/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the RISCV target                           *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 107;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(4),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s32,
  GILLT_p0s64,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_nxv1s1,
  GILLT_nxv1s8,
  GILLT_nxv1s16,
  GILLT_nxv1s32,
  GILLT_nxv1s64,
  GILLT_nxv2s1,
  GILLT_nxv2s8,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s8,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv4s64,
  GILLT_nxv8s1,
  GILLT_nxv8s8,
  GILLT_nxv8s16,
  GILLT_nxv8s32,
  GILLT_nxv8s64,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
  GILLT_nxv16s16,
  GILLT_nxv16s32,
  GILLT_nxv32s1,
  GILLT_nxv32s8,
  GILLT_nxv32s16,
  GILLT_nxv64s1,
  GILLT_nxv64s8,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 32),
  LLT::pointer(0, 64),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(1), 8),
  LLT::vector(ElementCount::getScalable(1), 16),
  LLT::vector(ElementCount::getScalable(1), 32),
  LLT::vector(ElementCount::getScalable(1), 64),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 8),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 8),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(4), 64),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 8),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(8), 32),
  LLT::vector(ElementCount::getScalable(8), 64),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
  LLT::vector(ElementCount::getScalable(16), 16),
  LLT::vector(ElementCount::getScalable(16), 32),
  LLT::vector(ElementCount::getScalable(32), 1),
  LLT::vector(ElementCount::getScalable(32), 8),
  LLT::vector(ElementCount::getScalable(32), 16),
  LLT::vector(ElementCount::getScalable(64), 1),
  LLT::vector(ElementCount::getScalable(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasStdExtZicbopBit = 34,
  Feature_HasStdExtZicondBit = 36,
  Feature_HasStdExtZihintpauseBit = 22,
  Feature_HasStdExtZimopBit = 33,
  Feature_HasStdExtZicfilpBit = 2,
  Feature_NoStdExtZicfilpBit = 1,
  Feature_HasStdExtZilsdBit = 37,
  Feature_HasStdExtZmmulBit = 23,
  Feature_HasStdExtMBit = 24,
  Feature_HasStdExtABit = 26,
  Feature_HasStdExtZtsoBit = 28,
  Feature_NotHasStdExtZtsoBit = 27,
  Feature_HasStdExtZabhaBit = 31,
  Feature_HasStdExtZacasBit = 30,
  Feature_NoStdExtZacasBit = 29,
  Feature_HasStdExtZalasrBit = 32,
  Feature_HasStdExtFBit = 5,
  Feature_HasStdExtDBit = 7,
  Feature_HasStdExtZfhminBit = 12,
  Feature_HasStdExtZfhBit = 10,
  Feature_HasStdExtZfaBit = 38,
  Feature_NoStdExtZfaBit = 8,
  Feature_HasStdExtZfinxBit = 6,
  Feature_HasStdExtZdinxBit = 9,
  Feature_HasStdExtZhinxminBit = 13,
  Feature_HasStdExtZhinxBit = 11,
  Feature_HasStdExtZcaBit = 20,
  Feature_HasStdExtCBit = 18,
  Feature_HasStdExtZbaBit = 44,
  Feature_NotHasStdExtZbaBit = 21,
  Feature_HasStdExtZbbBit = 41,
  Feature_NoStdExtZbbBit = 43,
  Feature_HasStdExtZbcBit = 46,
  Feature_HasStdExtZbsBit = 40,
  Feature_HasStdExtZbkbBit = 42,
  Feature_NoStdExtZbkbBit = 104,
  Feature_HasStdExtZbkxBit = 47,
  Feature_HasStdExtZbbOrZbkbBit = 39,
  Feature_HasStdExtZbcOrZbkcBit = 45,
  Feature_HasStdExtZkndBit = 48,
  Feature_HasStdExtZkneBit = 50,
  Feature_HasStdExtZkndOrZkneBit = 49,
  Feature_HasStdExtZknhBit = 51,
  Feature_HasStdExtZksedBit = 52,
  Feature_HasStdExtZkshBit = 53,
  Feature_HasStdExtZvkbBit = 61,
  Feature_HasStdExtZvbbBit = 60,
  Feature_HasStdExtZvbcBit = 65,
  Feature_HasStdExtZvkgBit = 62,
  Feature_HasStdExtZvknedBit = 63,
  Feature_HasStdExtZvknhaBit = 66,
  Feature_HasStdExtZvknhbBit = 67,
  Feature_HasStdExtZvksedBit = 68,
  Feature_HasStdExtZvkshBit = 64,
  Feature_HasVInstructionsBit = 14,
  Feature_HasVInstructionsI64Bit = 56,
  Feature_HasVInstructionsAnyFBit = 55,
  Feature_HasVInstructionsF16MinimalBit = 58,
  Feature_HasVInstructionsF16Bit = 54,
  Feature_HasVInstructionsF64Bit = 59,
  Feature_HasVInstructionsFullMultiplyBit = 57,
  Feature_HasVendorXVentanaCondOpsBit = 69,
  Feature_HasVendorXTHeadBaBit = 70,
  Feature_HasVendorXTHeadBbBit = 71,
  Feature_HasVendorXTHeadBsBit = 72,
  Feature_HasVendorXTHeadCondMovBit = 73,
  Feature_HasVendorXTHeadFMemIdxBit = 78,
  Feature_HasVendorXTHeadMacBit = 74,
  Feature_HasVendorXTHeadMemIdxBit = 77,
  Feature_HasVendorXTHeadMemPairBit = 76,
  Feature_HasVendorXTHeadVdotBit = 75,
  Feature_HasVendorXSfvcpBit = 79,
  Feature_HasVendorXSfvqmaccdodBit = 80,
  Feature_HasVendorXSfvqmaccqoqBit = 81,
  Feature_HasVendorXSfvfnrclipxfqfBit = 82,
  Feature_HasVendorXCVbitmanipBit = 84,
  Feature_HasVendorXCVmacBit = 87,
  Feature_HasVendorXCVmemBit = 83,
  Feature_HasVendorXCValuBit = 85,
  Feature_HasVendorXCVbiBit = 86,
  Feature_UseCCMovInsnBit = 102,
  Feature_HasVendorXMIPSCBOPBit = 101,
  Feature_NotHasVendorXMIPSCBOPBit = 35,
  Feature_HasVendorXqciaBit = 92,
  Feature_HasVendorXqciacBit = 88,
  Feature_HasVendorXqcibiBit = 93,
  Feature_HasVendorXqcibmBit = 94,
  Feature_HasVendorXqcicliBit = 98,
  Feature_HasVendorXqcicmBit = 96,
  Feature_HasVendorXqcicsBit = 100,
  Feature_NoVendorXqcicsBit = 97,
  Feature_HasVendorXqcicsOrXqcicmBit = 99,
  Feature_HasVendorXqciintBit = 95,
  Feature_HasVendorXqciliaBit = 89,
  Feature_HasVendorXqciloBit = 90,
  Feature_HasVendorXqcislsBit = 91,
  Feature_HasVendorXAndesPerfBit = 103,
  Feature_IsRV64Bit = 4,
  Feature_IsRV32Bit = 3,
  Feature_HasShortForwardBranchOptBit = 15,
  Feature_NoShortForwardBranchOptBit = 17,
  Feature_HasConditionalMoveFusionBit = 16,
  Feature_NoConditionalMoveFusionBit = 0,
  Feature_HasAtomicLdStBit = 25,
  Feature_OptForMinSizeBit = 19,
  Feature_HwMode1Bit = 106,
  Feature_HwMode0Bit = 105,
};

PredicateBitset RISCVInstructionSelector::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasStdExtZicbop())
    Features.set(Feature_HasStdExtZicbopBit);
  if (Subtarget->hasStdExtZicond())
    Features.set(Feature_HasStdExtZicondBit);
  if (Subtarget->hasStdExtZihintpause())
    Features.set(Feature_HasStdExtZihintpauseBit);
  if (Subtarget->hasStdExtZimop())
    Features.set(Feature_HasStdExtZimopBit);
  if (Subtarget->hasStdExtZicfilp())
    Features.set(Feature_HasStdExtZicfilpBit);
  if (!Subtarget->hasStdExtZicfilp())
    Features.set(Feature_NoStdExtZicfilpBit);
  if (Subtarget->hasStdExtZilsd())
    Features.set(Feature_HasStdExtZilsdBit);
  if (Subtarget->hasStdExtZmmul())
    Features.set(Feature_HasStdExtZmmulBit);
  if (Subtarget->hasStdExtM())
    Features.set(Feature_HasStdExtMBit);
  if (Subtarget->hasStdExtA())
    Features.set(Feature_HasStdExtABit);
  if (Subtarget->hasStdExtZtso())
    Features.set(Feature_HasStdExtZtsoBit);
  if (!Subtarget->hasStdExtZtso())
    Features.set(Feature_NotHasStdExtZtsoBit);
  if (Subtarget->hasStdExtZabha())
    Features.set(Feature_HasStdExtZabhaBit);
  if (Subtarget->hasStdExtZacas())
    Features.set(Feature_HasStdExtZacasBit);
  if (!Subtarget->hasStdExtZacas())
    Features.set(Feature_NoStdExtZacasBit);
  if (Subtarget->hasStdExtZalasr())
    Features.set(Feature_HasStdExtZalasrBit);
  if (Subtarget->hasStdExtF())
    Features.set(Feature_HasStdExtFBit);
  if (Subtarget->hasStdExtD())
    Features.set(Feature_HasStdExtDBit);
  if (Subtarget->hasStdExtZfhmin())
    Features.set(Feature_HasStdExtZfhminBit);
  if (Subtarget->hasStdExtZfh())
    Features.set(Feature_HasStdExtZfhBit);
  if (Subtarget->hasStdExtZfa())
    Features.set(Feature_HasStdExtZfaBit);
  if (!Subtarget->hasStdExtZfa())
    Features.set(Feature_NoStdExtZfaBit);
  if (Subtarget->hasStdExtZfinx())
    Features.set(Feature_HasStdExtZfinxBit);
  if (Subtarget->hasStdExtZdinx())
    Features.set(Feature_HasStdExtZdinxBit);
  if (Subtarget->hasStdExtZhinxmin())
    Features.set(Feature_HasStdExtZhinxminBit);
  if (Subtarget->hasStdExtZhinx())
    Features.set(Feature_HasStdExtZhinxBit);
  if (Subtarget->hasStdExtZca())
    Features.set(Feature_HasStdExtZcaBit);
  if (Subtarget->hasStdExtC())
    Features.set(Feature_HasStdExtCBit);
  if (Subtarget->hasStdExtZba())
    Features.set(Feature_HasStdExtZbaBit);
  if (!Subtarget->hasStdExtZba())
    Features.set(Feature_NotHasStdExtZbaBit);
  if (Subtarget->hasStdExtZbb())
    Features.set(Feature_HasStdExtZbbBit);
  if (!Subtarget->hasStdExtZbb())
    Features.set(Feature_NoStdExtZbbBit);
  if (Subtarget->hasStdExtZbc())
    Features.set(Feature_HasStdExtZbcBit);
  if (Subtarget->hasStdExtZbs())
    Features.set(Feature_HasStdExtZbsBit);
  if (Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbkbBit);
  if (!Subtarget->hasStdExtZbkb())
    Features.set(Feature_NoStdExtZbkbBit);
  if (Subtarget->hasStdExtZbkx())
    Features.set(Feature_HasStdExtZbkxBit);
  if (Subtarget->hasStdExtZbb() || Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbbOrZbkbBit);
  if (Subtarget->hasStdExtZbc() || Subtarget->hasStdExtZbkc())
    Features.set(Feature_HasStdExtZbcOrZbkcBit);
  if (Subtarget->hasStdExtZknd())
    Features.set(Feature_HasStdExtZkndBit);
  if (Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkneBit);
  if (Subtarget->hasStdExtZknd() || Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkndOrZkneBit);
  if (Subtarget->hasStdExtZknh())
    Features.set(Feature_HasStdExtZknhBit);
  if (Subtarget->hasStdExtZksed())
    Features.set(Feature_HasStdExtZksedBit);
  if (Subtarget->hasStdExtZksh())
    Features.set(Feature_HasStdExtZkshBit);
  if (Subtarget->hasStdExtZvkb())
    Features.set(Feature_HasStdExtZvkbBit);
  if (Subtarget->hasStdExtZvbb())
    Features.set(Feature_HasStdExtZvbbBit);
  if (Subtarget->hasStdExtZvbc())
    Features.set(Feature_HasStdExtZvbcBit);
  if (Subtarget->hasStdExtZvkg())
    Features.set(Feature_HasStdExtZvkgBit);
  if (Subtarget->hasStdExtZvkned())
    Features.set(Feature_HasStdExtZvknedBit);
  if (Subtarget->hasStdExtZvknha())
    Features.set(Feature_HasStdExtZvknhaBit);
  if (Subtarget->hasStdExtZvknhb())
    Features.set(Feature_HasStdExtZvknhbBit);
  if (Subtarget->hasStdExtZvksed())
    Features.set(Feature_HasStdExtZvksedBit);
  if (Subtarget->hasStdExtZvksh())
    Features.set(Feature_HasStdExtZvkshBit);
  if (Subtarget->hasVInstructions())
    Features.set(Feature_HasVInstructionsBit);
  if (Subtarget->hasVInstructionsI64())
    Features.set(Feature_HasVInstructionsI64Bit);
  if (Subtarget->hasVInstructionsAnyF())
    Features.set(Feature_HasVInstructionsAnyFBit);
  if (Subtarget->hasVInstructionsF16Minimal())
    Features.set(Feature_HasVInstructionsF16MinimalBit);
  if (Subtarget->hasVInstructionsF16())
    Features.set(Feature_HasVInstructionsF16Bit);
  if (Subtarget->hasVInstructionsF64())
    Features.set(Feature_HasVInstructionsF64Bit);
  if (Subtarget->hasVInstructionsFullMultiply())
    Features.set(Feature_HasVInstructionsFullMultiplyBit);
  if (Subtarget->hasVendorXVentanaCondOps())
    Features.set(Feature_HasVendorXVentanaCondOpsBit);
  if (Subtarget->hasVendorXTHeadBa())
    Features.set(Feature_HasVendorXTHeadBaBit);
  if (Subtarget->hasVendorXTHeadBb())
    Features.set(Feature_HasVendorXTHeadBbBit);
  if (Subtarget->hasVendorXTHeadBs())
    Features.set(Feature_HasVendorXTHeadBsBit);
  if (Subtarget->hasVendorXTHeadCondMov())
    Features.set(Feature_HasVendorXTHeadCondMovBit);
  if (Subtarget->hasVendorXTHeadFMemIdx())
    Features.set(Feature_HasVendorXTHeadFMemIdxBit);
  if (Subtarget->hasVendorXTHeadMac())
    Features.set(Feature_HasVendorXTHeadMacBit);
  if (Subtarget->hasVendorXTHeadMemIdx())
    Features.set(Feature_HasVendorXTHeadMemIdxBit);
  if (Subtarget->hasVendorXTHeadMemPair())
    Features.set(Feature_HasVendorXTHeadMemPairBit);
  if (Subtarget->hasVendorXTHeadVdot())
    Features.set(Feature_HasVendorXTHeadVdotBit);
  if (Subtarget->hasVendorXSfvcp())
    Features.set(Feature_HasVendorXSfvcpBit);
  if (Subtarget->hasVendorXSfvqmaccdod())
    Features.set(Feature_HasVendorXSfvqmaccdodBit);
  if (Subtarget->hasVendorXSfvqmaccqoq())
    Features.set(Feature_HasVendorXSfvqmaccqoqBit);
  if (Subtarget->hasVendorXSfvfnrclipxfqf())
    Features.set(Feature_HasVendorXSfvfnrclipxfqfBit);
  if (Subtarget->hasVendorXCVbitmanip())
    Features.set(Feature_HasVendorXCVbitmanipBit);
  if (Subtarget->hasVendorXCVmac())
    Features.set(Feature_HasVendorXCVmacBit);
  if (Subtarget->hasVendorXCVmem())
    Features.set(Feature_HasVendorXCVmemBit);
  if (Subtarget->hasVendorXCValu())
    Features.set(Feature_HasVendorXCValuBit);
  if (Subtarget->hasVendorXCVbi())
    Features.set(Feature_HasVendorXCVbiBit);
  if (Subtarget->useCCMovInsn())
    Features.set(Feature_UseCCMovInsnBit);
  if (Subtarget->hasVendorXMIPSCBOP())
    Features.set(Feature_HasVendorXMIPSCBOPBit);
  if (!Subtarget->hasVendorXMIPSCBOP())
    Features.set(Feature_NotHasVendorXMIPSCBOPBit);
  if (Subtarget->hasVendorXqcia())
    Features.set(Feature_HasVendorXqciaBit);
  if (Subtarget->hasVendorXqciac())
    Features.set(Feature_HasVendorXqciacBit);
  if (Subtarget->hasVendorXqcibi())
    Features.set(Feature_HasVendorXqcibiBit);
  if (Subtarget->hasVendorXqcibm())
    Features.set(Feature_HasVendorXqcibmBit);
  if (Subtarget->hasVendorXqcicli())
    Features.set(Feature_HasVendorXqcicliBit);
  if (Subtarget->hasVendorXqcicm())
    Features.set(Feature_HasVendorXqcicmBit);
  if (Subtarget->hasVendorXqcics())
    Features.set(Feature_HasVendorXqcicsBit);
  if (!Subtarget->hasVendorXqcics())
    Features.set(Feature_NoVendorXqcicsBit);
  if (Subtarget->hasVendorXqcics() || Subtarget->hasVendorXqcicm())
    Features.set(Feature_HasVendorXqcicsOrXqcicmBit);
  if (Subtarget->hasVendorXqciint())
    Features.set(Feature_HasVendorXqciintBit);
  if (Subtarget->hasVendorXqcilia())
    Features.set(Feature_HasVendorXqciliaBit);
  if (Subtarget->hasVendorXqcilo())
    Features.set(Feature_HasVendorXqciloBit);
  if (Subtarget->hasVendorXqcisls())
    Features.set(Feature_HasVendorXqcislsBit);
  if (Subtarget->hasVendorXAndesPerf())
    Features.set(Feature_HasVendorXAndesPerfBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_IsRV64Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_IsRV32Bit);
  if (Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_HasShortForwardBranchOptBit);
  if (!Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_NoShortForwardBranchOptBit);
  if (Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_HasConditionalMoveFusionBit);
  if (!Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_NoConditionalMoveFusionBit);
  if (Subtarget->hasStdExtA() || Subtarget->hasForcedAtomics())
    Features.set(Feature_HasAtomicLdStBit);
  if (MF ? MF->getFunction().hasMinSize() : false)
    Features.set(Feature_OptForMinSizeBit);
  if (!((Subtarget->is64Bit())))
    Features.set(Feature_HwMode1Bit);
  if ((Subtarget->is64Bit()))
    Features.set(Feature_HwMode0Bit);
  return Features;
}

void RISCVInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVInstructionSelector::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HwMode0,
  GIFBS_HwMode1,
  GIFBS_HasAtomicLdSt_HwMode0,
  GIFBS_HasAtomicLdSt_HwMode1,
  GIFBS_HasShortForwardBranchOpt_HwMode0,
  GIFBS_HasShortForwardBranchOpt_HwMode1,
  GIFBS_HasStdExtA_HwMode0,
  GIFBS_HasStdExtA_HwMode1,
  GIFBS_HasStdExtD,
  GIFBS_HasStdExtD_HwMode0,
  GIFBS_HasStdExtD_HwMode1,
  GIFBS_HasStdExtF,
  GIFBS_HasStdExtF_HwMode0,
  GIFBS_HasStdExtF_HwMode1,
  GIFBS_HasStdExtM_HwMode0,
  GIFBS_HasStdExtM_HwMode1,
  GIFBS_HasStdExtZalasr_HwMode0,
  GIFBS_HasStdExtZalasr_HwMode1,
  GIFBS_HasStdExtZba_HwMode0,
  GIFBS_HasStdExtZba_HwMode1,
  GIFBS_HasStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_HwMode1,
  GIFBS_HasStdExtZbkb_HwMode0,
  GIFBS_HasStdExtZbkb_HwMode1,
  GIFBS_HasStdExtZbkx_HwMode0,
  GIFBS_HasStdExtZbkx_HwMode1,
  GIFBS_HasStdExtZbs_HwMode0,
  GIFBS_HasStdExtZbs_HwMode1,
  GIFBS_HasStdExtZfa,
  GIFBS_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtZfh,
  GIFBS_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtZfinx,
  GIFBS_HasStdExtZfinx_HwMode0,
  GIFBS_HasStdExtZfinx_HwMode1,
  GIFBS_HasStdExtZhinx,
  GIFBS_HasStdExtZhinx_HwMode0,
  GIFBS_HasStdExtZhinx_HwMode1,
  GIFBS_HasStdExtZhinxmin_HwMode0,
  GIFBS_HasStdExtZhinxmin_HwMode1,
  GIFBS_HasStdExtZihintpause_HwMode0,
  GIFBS_HasStdExtZihintpause_HwMode1,
  GIFBS_HasStdExtZmmul_HwMode0,
  GIFBS_HasStdExtZmmul_HwMode1,
  GIFBS_HasStdExtZvbb_HwMode0,
  GIFBS_HasStdExtZvbb_HwMode1,
  GIFBS_HasStdExtZvbc_HwMode0,
  GIFBS_HasStdExtZvbc_HwMode1,
  GIFBS_HasStdExtZvkb_HwMode0,
  GIFBS_HasStdExtZvkb_HwMode1,
  GIFBS_HasStdExtZvkg_HwMode0,
  GIFBS_HasStdExtZvkg_HwMode1,
  GIFBS_HasStdExtZvkned_HwMode0,
  GIFBS_HasStdExtZvkned_HwMode1,
  GIFBS_HasStdExtZvknha_HwMode0,
  GIFBS_HasStdExtZvknha_HwMode1,
  GIFBS_HasStdExtZvknhb_HwMode0,
  GIFBS_HasStdExtZvknhb_HwMode1,
  GIFBS_HasStdExtZvksed_HwMode0,
  GIFBS_HasStdExtZvksed_HwMode1,
  GIFBS_HasStdExtZvksh_HwMode0,
  GIFBS_HasStdExtZvksh_HwMode1,
  GIFBS_HasVInstructions_HwMode0,
  GIFBS_HasVInstructions_HwMode1,
  GIFBS_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsFullMultiply_HwMode0,
  GIFBS_HasVInstructionsFullMultiply_HwMode1,
  GIFBS_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXAndesPerf_HwMode0,
  GIFBS_HasVendorXAndesPerf_HwMode1,
  GIFBS_HasVendorXCVmac_HwMode0,
  GIFBS_HasVendorXCVmac_HwMode1,
  GIFBS_HasVendorXSfvcp_HwMode0,
  GIFBS_HasVendorXSfvcp_HwMode1,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1,
  GIFBS_HasVendorXSfvqmaccdod_HwMode0,
  GIFBS_HasVendorXSfvqmaccdod_HwMode1,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode0,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode1,
  GIFBS_HasVendorXTHeadBa_HwMode0,
  GIFBS_HasVendorXTHeadBa_HwMode1,
  GIFBS_HasVendorXTHeadBb_HwMode0,
  GIFBS_HasVendorXTHeadBb_HwMode1,
  GIFBS_HasVendorXTHeadBs_HwMode0,
  GIFBS_HasVendorXTHeadBs_HwMode1,
  GIFBS_HasVendorXTHeadCondMov_HwMode0,
  GIFBS_HasVendorXTHeadCondMov_HwMode1,
  GIFBS_HasVendorXTHeadMac_HwMode0,
  GIFBS_HasVendorXTHeadMac_HwMode1,
  GIFBS_HasVendorXTHeadVdot_HwMode0,
  GIFBS_HasVendorXTHeadVdot_HwMode1,
  GIFBS_IsRV32_HwMode0,
  GIFBS_IsRV32_HwMode1,
  GIFBS_IsRV64_HwMode0,
  GIFBS_IsRV64_HwMode1,
  GIFBS_UseCCMovInsn_HwMode0,
  GIFBS_UseCCMovInsn_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_IsRV64_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode1,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfa,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtD_IsRV32_HwMode0,
  GIFBS_HasStdExtD_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV64_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode1,
  GIFBS_HasStdExtF_IsRV64_HwMode0,
  GIFBS_HasStdExtM_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode1,
  GIFBS_HasStdExtZba_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV64_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfh_IsRV32_HwMode0,
  GIFBS_HasStdExtZfh_IsRV32_HwMode1,
  GIFBS_HasStdExtZfh_IsRV64_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZfinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZhinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZknd_IsRV32_HwMode1,
  GIFBS_HasStdExtZknd_IsRV64_HwMode0,
  GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZkne_IsRV32_HwMode1,
  GIFBS_HasStdExtZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZknh_IsRV32_HwMode1,
  GIFBS_HasStdExtZknh_IsRV64_HwMode0,
  GIFBS_HasStdExtZmmul_IsRV64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode1,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1,
  GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0,
  GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode1,
  GIFBS_HasVendorXqciac_IsRV32_HwMode0,
  GIFBS_HasVendorXqciac_IsRV32_HwMode1,
  GIFBS_HasVendorXqcibm_IsRV32_HwMode0,
  GIFBS_HasVendorXqcibm_IsRV32_HwMode1,
  GIFBS_HasVendorXqcicm_IsRV32_HwMode0,
  GIFBS_HasVendorXqcicm_IsRV32_HwMode1,
  GIFBS_HasVendorXqcics_IsRV32_HwMode0,
  GIFBS_HasVendorXqcics_IsRV32_HwMode1,
  GIFBS_HasVendorXqcilia_IsRV32_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1,
  GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0,
  GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1,
  GIFBS_HasVendorXqcicm_IsRV32_NoVendorXqcics_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HwMode0Bit, },
  {Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode1Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode0Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, },
  {Feature_HasStdExtDBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, },
  {Feature_HasStdExtFBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZihintpauseBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZihintpauseBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode0Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndOrZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqciacBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciacBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcicmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcicmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcicsBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcicsBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqciliaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZilsdBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZilsdBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcicliBit, Feature_HasVendorXqcicsOrXqcicmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcicliBit, Feature_HasVendorXqcicsOrXqcicmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcicmBit, Feature_IsRV32Bit, Feature_NoVendorXqcicsBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_GIAddrRegImm,
  GICP_GIShiftMask32,
  GICP_GIShiftMaskXLen,
  GICP_GIVLOp,
  GICP_gi_sexti32,
  GICP_gi_sh1add_op,
  GICP_gi_sh1add_uw_op,
  GICP_gi_sh2add_op,
  GICP_gi_sh2add_uw_op,
  GICP_gi_sh3add_op,
  GICP_gi_sh3add_uw_op,
  GICP_gi_zexti16,
  GICP_gi_zexti32,
  GICP_gi_zexti8,
};
// See constructor for table contents

RISCVInstructionSelector::ComplexMatcherMemFn
RISCVInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &RISCVInstructionSelector::selectAddrRegImm, // GIAddrRegImm
  &RISCVInstructionSelector::selectShiftMask32, // GIShiftMask32
  &RISCVInstructionSelector::selectShiftMaskXLen, // GIShiftMaskXLen
  &RISCVInstructionSelector::renderVLOp, // GIVLOp
  &RISCVInstructionSelector::selectSExtBits<32>, // gi_sexti32
  &RISCVInstructionSelector::selectSHXADDOp<1>, // gi_sh1add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<1>, // gi_sh1add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<2>, // gi_sh2add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<2>, // gi_sh2add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<3>, // gi_sh3add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<3>, // gi_sh3add_uw_op
  &RISCVInstructionSelector::selectZExtBits<16>, // gi_zexti16
  &RISCVInstructionSelector::selectZExtBits<32>, // gi_zexti32
  &RISCVInstructionSelector::selectZExtBits<8>, // gi_zexti8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_like_non_imm12 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_add_non_imm12,
  GICXXPred_MI_Predicate_anonymous_9976,
  GICXXPred_MI_Predicate_anonymous_9978,
  GICXXPred_MI_Predicate_anonymous_10068,
  GICXXPred_MI_Predicate_anonymous_10082,
  GICXXPred_MI_Predicate_anonymous_10086,
  GICXXPred_MI_Predicate_anonymous_10088,
  GICXXPred_MI_Predicate_anonymous_10090,
  GICXXPred_MI_Predicate_anonymous_10092,
  GICXXPred_MI_Predicate_anonymous_10095,
  GICXXPred_MI_Predicate_anonymous_10097,
  GICXXPred_MI_Predicate_anonymous_10110,
  GICXXPred_MI_Predicate_anonymous_10123,
  GICXXPred_MI_Predicate_anonymous_11319,
  GICXXPred_MI_Predicate_or_disjoint,
};
bool RISCVInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_like_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_like_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_add_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_9976: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9978: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10068: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10082: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10086: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10088: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10090: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10092: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10095: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10097: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10110: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10123: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_11319: {
     return hasAllHUsers(MI); 
  }
  case GICXXPred_MI_Predicate_or_disjoint: {
    
        return MI.getFlag(MachineInstr::Disjoint);
      
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AddiPair = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BCLRMask,
  GICXXPred_I64_Predicate_LeadingOnesMask,
  GICXXPred_I64_Predicate_LeadingOnesWMask,
  GICXXPred_I64_Predicate_SingleBitSetMask,
  GICXXPred_I64_Predicate_allonessew8,
  GICXXPred_I64_Predicate_allonessew16,
  GICXXPred_I64_Predicate_allonessew32,
  GICXXPred_I64_Predicate_allonessew64,
  GICXXPred_I64_Predicate_bare_simm9_lsb0,
  GICXXPred_I64_Predicate_bare_simm12_lsb0,
  GICXXPred_I64_Predicate_bare_simm13_lsb0,
  GICXXPred_I64_Predicate_byteselect,
  GICXXPred_I64_Predicate_c_lui_imm,
  GICXXPred_I64_Predicate_csr_sysreg,
  GICXXPred_I64_Predicate_cv_tuimm2,
  GICXXPred_I64_Predicate_cv_tuimm5,
  GICXXPred_I64_Predicate_cv_uimm10,
  GICXXPred_I64_Predicate_immzero,
  GICXXPred_I64_Predicate_payload1,
  GICXXPred_I64_Predicate_payload2,
  GICXXPred_I64_Predicate_payload5,
  GICXXPred_I64_Predicate_powerOf2Minus1,
  GICXXPred_I64_Predicate_rnum,
  GICXXPred_I64_Predicate_simm5,
  GICXXPred_I64_Predicate_simm5_plus1,
  GICXXPred_I64_Predicate_simm5_plus1_nonzero,
  GICXXPred_I64_Predicate_simm5nonzero,
  GICXXPred_I64_Predicate_simm6,
  GICXXPred_I64_Predicate_simm6nonzero,
  GICXXPred_I64_Predicate_simm10,
  GICXXPred_I64_Predicate_simm10_lsb0000nonzero,
  GICXXPred_I64_Predicate_simm11,
  GICXXPred_I64_Predicate_simm12,
  GICXXPred_I64_Predicate_simm12Minus1Nonzero,
  GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1,
  GICXXPred_I64_Predicate_simm12Plus1,
  GICXXPred_I64_Predicate_simm12Plus1i32,
  GICXXPred_I64_Predicate_simm12_lsb00000,
  GICXXPred_I64_Predicate_simm12_no6,
  GICXXPred_I64_Predicate_simm12_plus1,
  GICXXPred_I64_Predicate_simm16nonzero,
  GICXXPred_I64_Predicate_simm20_li,
  GICXXPred_I64_Predicate_simm21_lsb0_jal,
  GICXXPred_I64_Predicate_simm26,
  GICXXPred_I64_Predicate_simm26_nosimm12,
  GICXXPred_I64_Predicate_simm32_nosimm26,
  GICXXPred_I64_Predicate_tsimm5,
  GICXXPred_I64_Predicate_tuimm5,
  GICXXPred_I64_Predicate_u32simm12,
  GICXXPred_I64_Predicate_uimm1,
  GICXXPred_I64_Predicate_uimm2,
  GICXXPred_I64_Predicate_uimm2_3,
  GICXXPred_I64_Predicate_uimm2_4,
  GICXXPred_I64_Predicate_uimm2_lsb0,
  GICXXPred_I64_Predicate_uimm3,
  GICXXPred_I64_Predicate_uimm4,
  GICXXPred_I64_Predicate_uimm5,
  GICXXPred_I64_Predicate_uimm5_lsb0,
  GICXXPred_I64_Predicate_uimm5_plus1,
  GICXXPred_I64_Predicate_uimm5ge6_plus1,
  GICXXPred_I64_Predicate_uimm5gt3,
  GICXXPred_I64_Predicate_uimm5i32,
  GICXXPred_I64_Predicate_uimm5nonzero,
  GICXXPred_I64_Predicate_uimm5slist,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_lsb0,
  GICXXPred_I64_Predicate_uimm6gt32,
  GICXXPred_I64_Predicate_uimm7,
  GICXXPred_I64_Predicate_uimm7_lsb00,
  GICXXPred_I64_Predicate_uimm7_lsb000,
  GICXXPred_I64_Predicate_uimm8_lsb00,
  GICXXPred_I64_Predicate_uimm8_lsb000,
  GICXXPred_I64_Predicate_uimm9_lsb000,
  GICXXPred_I64_Predicate_uimm10,
  GICXXPred_I64_Predicate_uimm10_lsb00nonzero,
  GICXXPred_I64_Predicate_uimm11,
  GICXXPred_I64_Predicate_uimm14lsb00,
  GICXXPred_I64_Predicate_uimm16nonzero,
  GICXXPred_I64_Predicate_uimmlog2xlen,
  GICXXPred_I64_Predicate_uimmlog2xlennonzero,
};
bool RISCVInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AddiPair: {
    
      // The immediate operand must be in range [-4096,-2049] or [2048,4094].
      return (-4096 <= Imm && Imm <= -2049) || (2048 <= Imm && Imm <= 4094);
    
    llvm_unreachable("AddiPair should have returned");
  }
  case GICXXPred_I64_Predicate_BCLRMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(~Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(~Imm);
    
    llvm_unreachable("BCLRMask should have returned");
  }
  case GICXXPred_I64_Predicate_LeadingOnesMask: {
    
      return !isInt<32>(Imm) && isMask_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_LeadingOnesWMask: {
    
      // If the value is a uint32 but not an int32, it must have bit 31 set and
      // bits 63:32 cleared. After that we're looking for a shifted mask but not
      // an all ones mask.
      return !isInt<32>(Imm) && isUInt<32>(Imm) && isShiftedMask_64(Imm) &&
             Imm != UINT64_C(0xffffffff);
    
    llvm_unreachable("LeadingOnesWMask should have returned");
  }
  case GICXXPred_I64_Predicate_SingleBitSetMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(Imm);
    
    llvm_unreachable("SingleBitSetMask should have returned");
  }
  case GICXXPred_I64_Predicate_allonessew8: {
    return SignExtend64<8>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew16: {
    return SignExtend64<16>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew32: {
    return SignExtend64<32>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew64: {
    return Imm == -1LL;
  }
  case GICXXPred_I64_Predicate_bare_simm9_lsb0: {
    return isShiftedInt<8, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_bare_simm12_lsb0: {
    return isShiftedInt<11, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_bare_simm13_lsb0: {
    return isShiftedInt<12, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_byteselect: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_c_lui_imm: {
    return (Imm != 0) &&
                                     (isUInt<5>(Imm) ||
                                      (Imm >= 0xfffe0 && Imm <= 0xfffff));
  }
  case GICXXPred_I64_Predicate_csr_sysreg: {
    return isUInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immzero: {
    return (Imm == 0);
  }
  case GICXXPred_I64_Predicate_payload1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_payload2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_payload5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_powerOf2Minus1: {
     return isPowerOf2_32(Imm+1); 
  }
  case GICXXPred_I64_Predicate_rnum: {
    return (Imm >= 0 && Imm <= 10);
  }
  case GICXXPred_I64_Predicate_simm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm5_plus1: {
    return (isInt<5>(Imm) && Imm != -16) || Imm == 16;
  }
  case GICXXPred_I64_Predicate_simm5_plus1_nonzero: {
    return Imm != 0 && ((isInt<5>(Imm) && Imm != -16) || Imm == 16);
  }
  case GICXXPred_I64_Predicate_simm5nonzero: {
    return (Imm != 0) && isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6nonzero: {
    return (Imm != 0) && isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm10: {
    return isInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_simm10_lsb0000nonzero: {
    return (Imm != 0) && isShiftedInt<6, 4>(Imm);
  }
  case GICXXPred_I64_Predicate_simm11: {
    return isInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12: {
    return isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12Minus1Nonzero: {
    
      return (Imm >= -2049 && Imm < 0) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1: {
    
      return (Imm >= -2049 && Imm < -1) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Plus1: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12Plus1i32: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12_lsb00000: {
    return isShiftedInt<7, 5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12_no6: {
    
      return isInt<12>(Imm) && !isInt<6>(Imm) && isInt<12>(-Imm);
  }
  case GICXXPred_I64_Predicate_simm12_plus1: {
    return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm16nonzero: {
    return (Imm != 0) && isInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_simm20_li: {
    return isInt<20>(Imm);
  }
  case GICXXPred_I64_Predicate_simm21_lsb0_jal: {
    return isShiftedInt<20, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26: {
    return isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26_nosimm12: {
    
      return isInt<26>(Imm) && !isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm32_nosimm26: {
    
      return isInt<32>(Imm) && !isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_tsimm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_u32simm12: {
    
      return isUInt<32>(Imm) && isInt<12>(SignExtend64<32>(Imm));
    
  }
  case GICXXPred_I64_Predicate_uimm1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2_3: {
    
      return isShiftedUInt<2, 3>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_4: {
    
      return isShiftedUInt<2, 4>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_lsb0: {
    return isShiftedUInt<1, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_lsb0: {
    return isShiftedUInt<4, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_plus1: {
    return (isUInt<5>(Imm) && (Imm != 0)) || (Imm == 32);
  }
  case GICXXPred_I64_Predicate_uimm5ge6_plus1: {
    return (Imm >= 6) && (isUInt<5>(Imm) || (Imm == 32));
  }
  case GICXXPred_I64_Predicate_uimm5gt3: {
    return (Imm > 3) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5i32: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5nonzero: {
    return (Imm != 0) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5slist: {
    return ((Imm == 0)  ||
                (Imm == 1)  ||
                (Imm == 2)  ||
                (Imm == 4)  ||
                (Imm == 8)  ||
                (Imm == 16) ||
                (Imm == 15) ||
                (Imm == 31));
  }
  case GICXXPred_I64_Predicate_uimm6: {
    return isUInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6_lsb0: {
    return isShiftedUInt<5, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6gt32: {
    
      return isUInt<6>(Imm) && Imm > 32;
    
  }
  case GICXXPred_I64_Predicate_uimm7: {
    return isUInt<7>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm7_lsb00: {
    return isShiftedUInt<5, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm7_lsb000: {
    return isShiftedUInt<4, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb00: {
    return isShiftedUInt<6, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb000: {
    return isShiftedUInt<5, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm9_lsb000: {
    return isShiftedUInt<6, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10_lsb00nonzero: {
    return isShiftedUInt<8, 2>(Imm) && (Imm != 0);
  }
  case GICXXPred_I64_Predicate_uimm11: {
    return isUInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm14lsb00: {
    return isShiftedUInt<12, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm16nonzero: {
    return (Imm != 0) && isUInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_uimmlog2xlen: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm);
      return isUInt<5>(Imm);
    
    llvm_unreachable("uimmlog2xlen should have returned");
  }
  case GICXXPred_I64_Predicate_uimmlog2xlennonzero: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm) && (Imm != 0);
      return isUInt<5>(Imm) && (Imm != 0);
    
    llvm_unreachable("uimmlog2xlennonzero should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_Shifted32OnesMask = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_TrailingOnesMask,
};
bool RISCVInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_Shifted32OnesMask: {
    
      if (!Imm.isShiftedMask())
        return false;
    
      unsigned TrailingZeros = Imm.countr_zero();
      return TrailingZeros > 0 && TrailingZeros < 32 &&
             Imm == UINT64_C(0xFFFFFFFF) << TrailingZeros;
    
    llvm_unreachable("Shifted32OnesMask should have returned");
  }
  case GICXXPred_APInt_Predicate_TrailingOnesMask: {
    
      return !isInt<12>(Imm.getSExtValue()) && isMask_64(Imm.getZExtValue());
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("RISCVInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderAddiPairImmLarge,
  GICR_renderAddiPairImmSmall,
  GICR_renderFrameIndex,
  GICR_renderImmPlus1,
  GICR_renderImmSubFrom32,
  GICR_renderImmSubFromXLen,
  GICR_renderNegImm,
  GICR_renderTrailingZeros,
  GICR_renderXLenSubTrailingOnes,
};
RISCVInstructionSelector::CustomRendererFn
RISCVInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &RISCVInstructionSelector::renderAddiPairImmLarge,
  &RISCVInstructionSelector::renderAddiPairImmSmall,
  &RISCVInstructionSelector::renderFrameIndex,
  &RISCVInstructionSelector::renderImmPlus1,
  &RISCVInstructionSelector::renderImmSubFrom32,
  &RISCVInstructionSelector::renderImmSubFromXLen,
  &RISCVInstructionSelector::renderNegImm,
  &RISCVInstructionSelector::renderTrailingZeros,
  &RISCVInstructionSelector::renderXLenSubTrailingOnes,
};

bool RISCVInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool RISCVInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("RISCVInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*       0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(339), /*)*//*default:*//*Label 125*/ GIMT_Encode4(2457152),
     /*      10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1154),
     /*      14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(61545),
     /*      18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(80778),
     /*      22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(107832),
     /*      26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(110566),
     /*      30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(113300),
     /*      34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(116079), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(118813),
     /*      50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(128771),
     /*      54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(141392), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      74 */ /*TargetOpcode::G_FRAME_INDEX*//*Label 10*/ GIMT_Encode4(156299), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      94 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ GIMT_Encode4(156360), GIMT_Encode4(0),
     /*     102 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ GIMT_Encode4(156421), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     126 */ /*TargetOpcode::G_BITCAST*//*Label 13*/ GIMT_Encode4(156512), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 14*/ GIMT_Encode4(156879),
     /*     146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 15*/ GIMT_Encode4(157077),
     /*     150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 16*/ GIMT_Encode4(157275),
     /*     154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 17*/ GIMT_Encode4(157855),
     /*     158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 18*/ GIMT_Encode4(158065),
     /*     162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 19*/ GIMT_Encode4(158263),
     /*     166 */ /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 20*/ GIMT_Encode4(158302),
     /*     170 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(158341),
     /*     174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(167319),
     /*     178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(168433), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     194 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(169067), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 25*/ GIMT_Encode4(175967),
     /*     210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 26*/ GIMT_Encode4(180853),
     /*     214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 27*/ GIMT_Encode4(183763), GIMT_Encode4(0),
     /*     222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 28*/ GIMT_Encode4(186673),
     /*     226 */ /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 29*/ GIMT_Encode4(189583),
     /*     230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 30*/ GIMT_Encode4(190495),
     /*     234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 31*/ GIMT_Encode4(193405),
     /*     238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 32*/ GIMT_Encode4(196315),
     /*     242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 33*/ GIMT_Encode4(199225),
     /*     246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 34*/ GIMT_Encode4(202135),
     /*     250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 35*/ GIMT_Encode4(205045), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(207955), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(208173),
     /*     318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(2206466), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(2208034), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     366 */ /*TargetOpcode::G_SEXT*//*Label 40*/ GIMT_Encode4(2211155),
     /*     370 */ /*TargetOpcode::G_SEXT_INREG*//*Label 41*/ GIMT_Encode4(2214630),
     /*     374 */ /*TargetOpcode::G_ZEXT*//*Label 42*/ GIMT_Encode4(2215673),
     /*     378 */ /*TargetOpcode::G_SHL*//*Label 43*/ GIMT_Encode4(2219360),
     /*     382 */ /*TargetOpcode::G_LSHR*//*Label 44*/ GIMT_Encode4(2227956),
     /*     386 */ /*TargetOpcode::G_ASHR*//*Label 45*/ GIMT_Encode4(2230987), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     398 */ /*TargetOpcode::G_ROTR*//*Label 46*/ GIMT_Encode4(2233926),
     /*     402 */ /*TargetOpcode::G_ROTL*//*Label 47*/ GIMT_Encode4(2236866),
     /*     406 */ /*TargetOpcode::G_ICMP*//*Label 48*/ GIMT_Encode4(2239776),
     /*     410 */ /*TargetOpcode::G_FCMP*//*Label 49*/ GIMT_Encode4(2266853), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     422 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(2274315), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     466 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(2285300),
     /*     470 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(2288034),
     /*     474 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(2290768),
     /*     478 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(2293621),
     /*     482 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(2296474),
     /*     486 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(2299327),
     /*     490 */ /*TargetOpcode::G_USHLSAT*//*Label 57*/ GIMT_Encode4(2302180),
     /*     494 */ /*TargetOpcode::G_SSHLSAT*//*Label 58*/ GIMT_Encode4(2302238), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     530 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(2302296),
     /*     534 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(2304724),
     /*     538 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(2307152),
     /*     542 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(2309580), GIMT_Encode4(0),
     /*     550 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(2326225), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     598 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(2328653),
     /*     602 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(2330624),
     /*     606 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(2331077),
     /*     610 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(2332613),
     /*     614 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(2337499),
     /*     618 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(2342385),
     /*     622 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(2347671), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     634 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(2352957),
     /*     638 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 72*/ GIMT_Encode4(2354928), GIMT_Encode4(0),
     /*     646 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 73*/ GIMT_Encode4(2360990),
     /*     650 */ /*TargetOpcode::G_FMINNUM*//*Label 74*/ GIMT_Encode4(2361180),
     /*     654 */ /*TargetOpcode::G_FMAXNUM*//*Label 75*/ GIMT_Encode4(2363265), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     666 */ /*TargetOpcode::G_FMINIMUM*//*Label 76*/ GIMT_Encode4(2365350),
     /*     670 */ /*TargetOpcode::G_FMAXIMUM*//*Label 77*/ GIMT_Encode4(2365476),
     /*     674 */ /*TargetOpcode::G_FMINIMUMNUM*//*Label 78*/ GIMT_Encode4(2365602),
     /*     678 */ /*TargetOpcode::G_FMAXIMUMNUM*//*Label 79*/ GIMT_Encode4(2367687), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     718 */ /*TargetOpcode::G_SMIN*//*Label 80*/ GIMT_Encode4(2369772),
     /*     722 */ /*TargetOpcode::G_SMAX*//*Label 81*/ GIMT_Encode4(2372548),
     /*     726 */ /*TargetOpcode::G_UMIN*//*Label 82*/ GIMT_Encode4(2375324),
     /*     730 */ /*TargetOpcode::G_UMAX*//*Label 83*/ GIMT_Encode4(2378100),
     /*     734 */ /*TargetOpcode::G_ABS*//*Label 84*/ GIMT_Encode4(2380876),
     /*     738 */ /*TargetOpcode::G_LROUND*//*Label 85*/ GIMT_Encode4(2381034),
     /*     742 */ /*TargetOpcode::G_LLROUND*//*Label 86*/ GIMT_Encode4(2381614),
     /*     746 */ /*TargetOpcode::G_BR*//*Label 87*/ GIMT_Encode4(2381824), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     790 */ /*TargetOpcode::G_CTTZ*//*Label 88*/ GIMT_Encode4(2381840), GIMT_Encode4(0),
     /*     798 */ /*TargetOpcode::G_CTLZ*//*Label 89*/ GIMT_Encode4(2384468), GIMT_Encode4(0),
     /*     806 */ /*TargetOpcode::G_CTPOP*//*Label 90*/ GIMT_Encode4(2387238),
     /*     810 */ /*TargetOpcode::G_BSWAP*//*Label 91*/ GIMT_Encode4(2389789),
     /*     814 */ /*TargetOpcode::G_BITREVERSE*//*Label 92*/ GIMT_Encode4(2392324),
     /*     818 */ /*TargetOpcode::G_FCEIL*//*Label 93*/ GIMT_Encode4(2394870), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     866 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(2395068),
     /*     870 */ /*TargetOpcode::G_FFLOOR*//*Label 95*/ GIMT_Encode4(2397244),
     /*     874 */ /*TargetOpcode::G_FRINT*//*Label 96*/ GIMT_Encode4(2397442),
     /*     878 */ /*TargetOpcode::G_FNEARBYINT*//*Label 97*/ GIMT_Encode4(2397640), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     906 */ /*TargetOpcode::G_STRICT_FADD*//*Label 98*/ GIMT_Encode4(2397838),
     /*     910 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 99*/ GIMT_Encode4(2400266),
     /*     914 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 100*/ GIMT_Encode4(2402694),
     /*     918 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 101*/ GIMT_Encode4(2405122), GIMT_Encode4(0),
     /*     926 */ /*TargetOpcode::G_STRICT_FMA*//*Label 102*/ GIMT_Encode4(2407550),
     /*     930 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 103*/ GIMT_Encode4(2424195), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     966 */ /*TargetOpcode::G_TRAP*//*Label 104*/ GIMT_Encode4(2426371),
     /*     970 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 105*/ GIMT_Encode4(2426384), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    1074 */ /*RISCV::G_CLZW*//*Label 106*/ GIMT_Encode4(2426397),
     /*    1078 */ /*RISCV::G_CTZW*//*Label 107*/ GIMT_Encode4(2426492),
     /*    1082 */ /*RISCV::G_DIVUW*//*Label 108*/ GIMT_Encode4(2426522),
     /*    1086 */ /*RISCV::G_DIVW*//*Label 109*/ GIMT_Encode4(2426559),
     /*    1090 */ /*RISCV::G_FCLASS*//*Label 110*/ GIMT_Encode4(2426596),
     /*    1094 */ /*RISCV::G_FCVT_WU_RV64*//*Label 111*/ GIMT_Encode4(2426956),
     /*    1098 */ /*RISCV::G_FCVT_W_RV64*//*Label 112*/ GIMT_Encode4(2427154),
     /*    1102 */ /*RISCV::G_READ_VLENB*//*Label 113*/ GIMT_Encode4(2427352),
     /*    1106 */ /*RISCV::G_REMUW*//*Label 114*/ GIMT_Encode4(2427412),
     /*    1110 */ /*RISCV::G_ROLW*//*Label 115*/ GIMT_Encode4(2427449),
     /*    1114 */ /*RISCV::G_RORW*//*Label 116*/ GIMT_Encode4(2427574),
     /*    1118 */ /*RISCV::G_SLLW*//*Label 117*/ GIMT_Encode4(2427695), GIMT_Encode4(0),
     /*    1126 */ /*RISCV::G_SRAW*//*Label 118*/ GIMT_Encode4(2427742),
     /*    1130 */ /*RISCV::G_SRLW*//*Label 119*/ GIMT_Encode4(2427789),
     /*    1134 */ /*RISCV::G_VMCLR_VL*//*Label 120*/ GIMT_Encode4(2427836),
     /*    1138 */ /*RISCV::G_VMSET_VL*//*Label 121*/ GIMT_Encode4(2428485),
     /*    1142 */ /*RISCV::G_VMV_V_V_VL*//*Label 122*/ GIMT_Encode4(2429134),
     /*    1146 */ /*RISCV::G_VSLIDEDOWN_VL*//*Label 123*/ GIMT_Encode4(2433392),
     /*    1150 */ /*RISCV::G_VSLIDEUP_VL*//*Label 124*/ GIMT_Encode4(2445272),
     /*    1154 */ // Label 0: @1154
     /*    1154 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 150*/ GIMT_Encode4(61544),
     /*    1165 */ /*GILLT_s32*//*Label 126*/ GIMT_Encode4(1289),
     /*    1169 */ /*GILLT_s64*//*Label 127*/ GIMT_Encode4(4004), GIMT_Encode4(0),
     /*    1177 */ /*GILLT_nxv1s8*//*Label 128*/ GIMT_Encode4(11904),
     /*    1181 */ /*GILLT_nxv1s16*//*Label 129*/ GIMT_Encode4(12299),
     /*    1185 */ /*GILLT_nxv1s32*//*Label 130*/ GIMT_Encode4(15424),
     /*    1189 */ /*GILLT_nxv1s64*//*Label 131*/ GIMT_Encode4(18549), GIMT_Encode4(0),
     /*    1197 */ /*GILLT_nxv2s8*//*Label 132*/ GIMT_Encode4(21674),
     /*    1201 */ /*GILLT_nxv2s16*//*Label 133*/ GIMT_Encode4(22069),
     /*    1205 */ /*GILLT_nxv2s32*//*Label 134*/ GIMT_Encode4(25194),
     /*    1209 */ /*GILLT_nxv2s64*//*Label 135*/ GIMT_Encode4(28319), GIMT_Encode4(0),
     /*    1217 */ /*GILLT_nxv4s8*//*Label 136*/ GIMT_Encode4(31444),
     /*    1221 */ /*GILLT_nxv4s16*//*Label 137*/ GIMT_Encode4(31839),
     /*    1225 */ /*GILLT_nxv4s32*//*Label 138*/ GIMT_Encode4(34964),
     /*    1229 */ /*GILLT_nxv4s64*//*Label 139*/ GIMT_Encode4(38089), GIMT_Encode4(0),
     /*    1237 */ /*GILLT_nxv8s8*//*Label 140*/ GIMT_Encode4(41214),
     /*    1241 */ /*GILLT_nxv8s16*//*Label 141*/ GIMT_Encode4(41609),
     /*    1245 */ /*GILLT_nxv8s32*//*Label 142*/ GIMT_Encode4(44734),
     /*    1249 */ /*GILLT_nxv8s64*//*Label 143*/ GIMT_Encode4(47859), GIMT_Encode4(0),
     /*    1257 */ /*GILLT_nxv16s8*//*Label 144*/ GIMT_Encode4(50984),
     /*    1261 */ /*GILLT_nxv16s16*//*Label 145*/ GIMT_Encode4(51379),
     /*    1265 */ /*GILLT_nxv16s32*//*Label 146*/ GIMT_Encode4(54504), GIMT_Encode4(0),
     /*    1273 */ /*GILLT_nxv32s8*//*Label 147*/ GIMT_Encode4(57629),
     /*    1277 */ /*GILLT_nxv32s16*//*Label 148*/ GIMT_Encode4(58024), GIMT_Encode4(0),
     /*    1285 */ /*GILLT_nxv64s8*//*Label 149*/ GIMT_Encode4(61149),
     /*    1289 */ // Label 126: @1289
     /*    1289 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(4003),
     /*    1294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*    1297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*    1300 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(1348), // Rule ID 2580 //
     /*    1305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1312 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    1316 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    1320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1335 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:2:x, GPR:{ *:[i32] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1340 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1346 */     GIR_RootConstrainSelectedInstOperands,
     /*    1347 */     // GIR_Coverage, 2580,
     /*    1347 */     GIR_EraseRootFromParent_Done,
     /*    1348 */   // Label 152: @1348
     /*    1348 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(1396), // Rule ID 2590 //
     /*    1353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1360 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    1364 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    1368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1372 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1383 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:4:x, GPR:{ *:[i32] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1388 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1394 */     GIR_RootConstrainSelectedInstOperands,
     /*    1395 */     // GIR_Coverage, 2590,
     /*    1395 */     GIR_EraseRootFromParent_Done,
     /*    1396 */   // Label 153: @1396
     /*    1396 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(1444), // Rule ID 2600 //
     /*    1401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1408 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    1412 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    1416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1431 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:6:x, GPR:{ *:[i32] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1436 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1442 */     GIR_RootConstrainSelectedInstOperands,
     /*    1443 */     // GIR_Coverage, 2600,
     /*    1443 */     GIR_EraseRootFromParent_Done,
     /*    1444 */   // Label 154: @1444
     /*    1444 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(1495), // Rule ID 62546 //
     /*    1449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1456 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    1460 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    1464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1468 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1479 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs2:$pred:24:x, GPR:{ *:[i32] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1486 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1493 */     GIR_RootConstrainSelectedInstOperands,
     /*    1494 */     // GIR_Coverage, 62546,
     /*    1494 */     GIR_EraseRootFromParent_Done,
     /*    1495 */   // Label 155: @1495
     /*    1495 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(1546), // Rule ID 62550 //
     /*    1500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1507 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    1511 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    1515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1530 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs2:$pred:25:x, GPR:{ *:[i32] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1537 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1544 */     GIR_RootConstrainSelectedInstOperands,
     /*    1545 */     // GIR_Coverage, 62550,
     /*    1545 */     GIR_EraseRootFromParent_Done,
     /*    1546 */   // Label 156: @1546
     /*    1546 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(1597), // Rule ID 62554 //
     /*    1551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1558 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    1562 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    1566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1570 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1581 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs2:$pred:26:x, GPR:{ *:[i32] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1588 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    1595 */     GIR_RootConstrainSelectedInstOperands,
     /*    1596 */     // GIR_Coverage, 62554,
     /*    1596 */     GIR_EraseRootFromParent_Done,
     /*    1597 */   // Label 157: @1597
     /*    1597 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(1645), // Rule ID 65125 //
     /*    1602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1609 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:29:x
     /*    1613 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:29:y
     /*    1617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1632 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:29:x, GPR:{ *:[i32] }:$rs2:$pred:29:y)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    1635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1637 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1643 */     GIR_RootConstrainSelectedInstOperands,
     /*    1644 */     // GIR_Coverage, 65125,
     /*    1644 */     GIR_EraseRootFromParent_Done,
     /*    1645 */   // Label 158: @1645
     /*    1645 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(1693), // Rule ID 65135 //
     /*    1650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1657 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:31:x
     /*    1661 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:31:y
     /*    1665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1680 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:31:x, GPR:{ *:[i32] }:$rs2:$pred:31:y)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    1683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1685 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1691 */     GIR_RootConstrainSelectedInstOperands,
     /*    1692 */     // GIR_Coverage, 65135,
     /*    1692 */     GIR_EraseRootFromParent_Done,
     /*    1693 */   // Label 159: @1693
     /*    1693 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(1741), // Rule ID 65145 //
     /*    1698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1705 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:33:x
     /*    1709 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:33:y
     /*    1713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1728 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:33:x, GPR:{ *:[i32] }:$rs2:$pred:33:y)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    1731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1739 */     GIR_RootConstrainSelectedInstOperands,
     /*    1740 */     // GIR_Coverage, 65145,
     /*    1740 */     GIR_EraseRootFromParent_Done,
     /*    1741 */   // Label 160: @1741
     /*    1741 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(1789), // Rule ID 65604 //
     /*    1746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1753 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    1757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1761 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    1765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1776 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:2:y, sh1add_op:{ *:[i32] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1781 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1787 */     GIR_RootConstrainSelectedInstOperands,
     /*    1788 */     // GIR_Coverage, 65604,
     /*    1788 */     GIR_EraseRootFromParent_Done,
     /*    1789 */   // Label 161: @1789
     /*    1789 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(1837), // Rule ID 65612 //
     /*    1794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1801 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    1805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1809 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    1813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1824 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:4:y, sh2add_op:{ *:[i32] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1835 */     GIR_RootConstrainSelectedInstOperands,
     /*    1836 */     // GIR_Coverage, 65612,
     /*    1836 */     GIR_EraseRootFromParent_Done,
     /*    1837 */   // Label 162: @1837
     /*    1837 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(1885), // Rule ID 65620 //
     /*    1842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1849 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    1853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1857 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    1861 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1872 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:6:y, sh3add_op:{ *:[i32] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1883 */     GIR_RootConstrainSelectedInstOperands,
     /*    1884 */     // GIR_Coverage, 65620,
     /*    1884 */     GIR_EraseRootFromParent_Done,
     /*    1885 */   // Label 163: @1885
     /*    1885 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(1936), // Rule ID 74438 //
     /*    1890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1897 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    1901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1905 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    1909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1920 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:24:y, sh1add_op:{ *:[i32] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1927 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1934 */     GIR_RootConstrainSelectedInstOperands,
     /*    1935 */     // GIR_Coverage, 74438,
     /*    1935 */     GIR_EraseRootFromParent_Done,
     /*    1936 */   // Label 164: @1936
     /*    1936 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(1987), // Rule ID 74442 //
     /*    1941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1948 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    1952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1956 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    1960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1971 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:25:y, sh2add_op:{ *:[i32] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1978 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1985 */     GIR_RootConstrainSelectedInstOperands,
     /*    1986 */     // GIR_Coverage, 74442,
     /*    1986 */     GIR_EraseRootFromParent_Done,
     /*    1987 */   // Label 165: @1987
     /*    1987 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2038), // Rule ID 74446 //
     /*    1992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1999 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    2003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2007 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    2011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    2022 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:26:y, sh3add_op:{ *:[i32] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    2022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    2025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    2029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    2033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    2036 */     GIR_RootConstrainSelectedInstOperands,
     /*    2037 */     // GIR_Coverage, 74446,
     /*    2037 */     GIR_EraseRootFromParent_Done,
     /*    2038 */   // Label 166: @2038
     /*    2038 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2086), // Rule ID 74464 //
     /*    2043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2050 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:29:y
     /*    2054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2058 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:29:x
     /*    2062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    2073 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:29:y, sh1add_op:{ *:[i32] }:$rs1:$pred:29:x)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2084 */     GIR_RootConstrainSelectedInstOperands,
     /*    2085 */     // GIR_Coverage, 74464,
     /*    2085 */     GIR_EraseRootFromParent_Done,
     /*    2086 */   // Label 167: @2086
     /*    2086 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2134), // Rule ID 74472 //
     /*    2091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2098 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:31:y
     /*    2102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2106 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:31:x
     /*    2110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    2121 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:31:y, sh2add_op:{ *:[i32] }:$rs1:$pred:31:x)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2132 */     GIR_RootConstrainSelectedInstOperands,
     /*    2133 */     // GIR_Coverage, 74472,
     /*    2133 */     GIR_EraseRootFromParent_Done,
     /*    2134 */   // Label 168: @2134
     /*    2134 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2182), // Rule ID 74480 //
     /*    2139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2146 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:33:y
     /*    2150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2154 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:33:x
     /*    2158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    2169 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:33:y, sh3add_op:{ *:[i32] }:$rs1:$pred:33:x)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2180 */     GIR_RootConstrainSelectedInstOperands,
     /*    2181 */     // GIR_Coverage, 74480,
     /*    2181 */     GIR_EraseRootFromParent_Done,
     /*    2182 */   // Label 169: @2182
     /*    2182 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2250), // Rule ID 2574 //
     /*    2187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2194 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    2198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2219 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2223 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    2227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2237 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x, GPR:{ *:[i32] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2248 */     GIR_RootConstrainSelectedInstOperands,
     /*    2249 */     // GIR_Coverage, 2574,
     /*    2249 */     GIR_EraseRootFromParent_Done,
     /*    2250 */   // Label 170: @2250
     /*    2250 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2318), // Rule ID 2584 //
     /*    2255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2262 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    2266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2287 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2291 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    2295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2305 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x, GPR:{ *:[i32] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2316 */     GIR_RootConstrainSelectedInstOperands,
     /*    2317 */     // GIR_Coverage, 2584,
     /*    2317 */     GIR_EraseRootFromParent_Done,
     /*    2318 */   // Label 171: @2318
     /*    2318 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2386), // Rule ID 2594 //
     /*    2323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2330 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    2334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2355 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2359 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    2363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2367 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2373 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x, GPR:{ *:[i32] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2384 */     GIR_RootConstrainSelectedInstOperands,
     /*    2385 */     // GIR_Coverage, 2594,
     /*    2385 */     GIR_EraseRootFromParent_Done,
     /*    2386 */   // Label 172: @2386
     /*    2386 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2454), // Rule ID 65119 //
     /*    2391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2398 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:28:x
     /*    2402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2423 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2427 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:28:y
     /*    2431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2441 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:28:x, GPR:{ *:[i32] }:$rs2:$pred:28:y)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2452 */     GIR_RootConstrainSelectedInstOperands,
     /*    2453 */     // GIR_Coverage, 65119,
     /*    2453 */     GIR_EraseRootFromParent_Done,
     /*    2454 */   // Label 173: @2454
     /*    2454 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2522), // Rule ID 65129 //
     /*    2459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2466 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:30:x
     /*    2470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2491 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2495 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:30:y
     /*    2499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2503 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2509 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:30:x, GPR:{ *:[i32] }:$rs2:$pred:30:y)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2520 */     GIR_RootConstrainSelectedInstOperands,
     /*    2521 */     // GIR_Coverage, 65129,
     /*    2521 */     GIR_EraseRootFromParent_Done,
     /*    2522 */   // Label 174: @2522
     /*    2522 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2590), // Rule ID 65139 //
     /*    2527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2534 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:32:x
     /*    2538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2559 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2563 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:32:y
     /*    2567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2577 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:32:x, GPR:{ *:[i32] }:$rs2:$pred:32:y)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2588 */     GIR_RootConstrainSelectedInstOperands,
     /*    2589 */     // GIR_Coverage, 65139,
     /*    2589 */     GIR_EraseRootFromParent_Done,
     /*    2590 */   // Label 175: @2590
     /*    2590 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2658), // Rule ID 65600 //
     /*    2595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2602 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*    2606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2610 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*    2614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2635 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2645 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:1:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2656 */     GIR_RootConstrainSelectedInstOperands,
     /*    2657 */     // GIR_Coverage, 65600,
     /*    2657 */     GIR_EraseRootFromParent_Done,
     /*    2658 */   // Label 176: @2658
     /*    2658 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2726), // Rule ID 65608 //
     /*    2663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2670 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*    2674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2678 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*    2682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2703 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2713 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:3:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2724 */     GIR_RootConstrainSelectedInstOperands,
     /*    2725 */     // GIR_Coverage, 65608,
     /*    2725 */     GIR_EraseRootFromParent_Done,
     /*    2726 */   // Label 177: @2726
     /*    2726 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2794), // Rule ID 65616 //
     /*    2731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2738 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*    2742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2746 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*    2750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2771 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2775 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2781 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:5:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2792 */     GIR_RootConstrainSelectedInstOperands,
     /*    2793 */     // GIR_Coverage, 65616,
     /*    2793 */     GIR_EraseRootFromParent_Done,
     /*    2794 */   // Label 178: @2794
     /*    2794 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2862), // Rule ID 74460 //
     /*    2799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2806 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:28:y
     /*    2810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2814 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:28:x
     /*    2818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2839 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2849 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:28:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:28:x)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2860 */     GIR_RootConstrainSelectedInstOperands,
     /*    2861 */     // GIR_Coverage, 74460,
     /*    2861 */     GIR_EraseRootFromParent_Done,
     /*    2862 */   // Label 179: @2862
     /*    2862 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2930), // Rule ID 74468 //
     /*    2867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2874 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:30:y
     /*    2878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2882 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:30:x
     /*    2886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2907 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2911 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2917 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:30:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:30:x)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2928 */     GIR_RootConstrainSelectedInstOperands,
     /*    2929 */     // GIR_Coverage, 74468,
     /*    2929 */     GIR_EraseRootFromParent_Done,
     /*    2930 */   // Label 180: @2930
     /*    2930 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2998), // Rule ID 74476 //
     /*    2935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2942 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:32:y
     /*    2946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2950 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:32:x
     /*    2954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2975 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2985 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:32:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:32:x)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2996 */     GIR_RootConstrainSelectedInstOperands,
     /*    2997 */     // GIR_Coverage, 74476,
     /*    2997 */     GIR_EraseRootFromParent_Done,
     /*    2998 */   // Label 181: @2998
     /*    2998 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3077), // Rule ID 62540 //
     /*    3003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    3006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3010 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*    3014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3043 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    3047 */     // MIs[2] Operand 1
     /*    3047 */     // No operand predicates
     /*    3047 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*    3051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3055 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3061 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i32] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    3061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    3064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    3068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    3072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    3075 */     GIR_RootConstrainSelectedInstOperands,
     /*    3076 */     // GIR_Coverage, 62540,
     /*    3076 */     GIR_EraseRootFromParent_Done,
     /*    3077 */   // Label 182: @3077
     /*    3077 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3156), // Rule ID 64541 //
     /*    3082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqciac_IsRV32_HwMode0),
     /*    3085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3089 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:27:x
     /*    3093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3122 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5gt3),
     /*    3126 */     // MIs[2] Operand 1
     /*    3126 */     // No operand predicates
     /*    3126 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:27:y
     /*    3130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3140 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5gt3>>:$imm):$pred:27:x, GPRNoX0:{ *:[i32] }:$rs2:$pred:27:y)<<P:27:Predicate_add_like_non_imm12>>  =>  (QC_SHLADD:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5gt3>>:$imm)
     /*    3140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLADD),
     /*    3143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*    3154 */     GIR_RootConstrainSelectedInstOperands,
     /*    3155 */     // GIR_Coverage, 64541,
     /*    3155 */     GIR_EraseRootFromParent_Done,
     /*    3156 */   // Label 183: @3156
     /*    3156 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3235), // Rule ID 64542 //
     /*    3161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqciac_IsRV32_HwMode1),
     /*    3164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3168 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:27:x
     /*    3172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3201 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5gt3),
     /*    3205 */     // MIs[2] Operand 1
     /*    3205 */     // No operand predicates
     /*    3205 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:27:y
     /*    3209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3219 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5gt3>>:$imm):$pred:27:x, GPRNoX0:{ *:[i32] }:$rs2:$pred:27:y)<<P:27:Predicate_add_like_non_imm12>>  =>  (QC_SHLADD:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5gt3>>:$imm)
     /*    3219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLADD),
     /*    3222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*    3233 */     GIR_RootConstrainSelectedInstOperands,
     /*    3234 */     // GIR_Coverage, 64542,
     /*    3234 */     GIR_EraseRootFromParent_Done,
     /*    3235 */   // Label 184: @3235
     /*    3235 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3314), // Rule ID 74434 //
     /*    3240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    3243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3247 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*    3251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3255 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*    3259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3288 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    3292 */     // MIs[2] Operand 1
     /*    3292 */     // No operand predicates
     /*    3292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3298 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:23:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    3298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    3301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    3309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    3312 */     GIR_RootConstrainSelectedInstOperands,
     /*    3313 */     // GIR_Coverage, 74434,
     /*    3313 */     GIR_EraseRootFromParent_Done,
     /*    3314 */   // Label 185: @3314
     /*    3314 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3393), // Rule ID 74455 //
     /*    3319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqciac_IsRV32_HwMode0),
     /*    3322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3326 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:27:y
     /*    3330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3334 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:27:x
     /*    3338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3367 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5gt3),
     /*    3371 */     // MIs[2] Operand 1
     /*    3371 */     // No operand predicates
     /*    3371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3377 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2:$pred:27:y, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5gt3>>:$imm):$pred:27:x)<<P:27:Predicate_add_like_non_imm12>>  =>  (QC_SHLADD:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5gt3>>:$imm)
     /*    3377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLADD),
     /*    3380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*    3391 */     GIR_RootConstrainSelectedInstOperands,
     /*    3392 */     // GIR_Coverage, 74455,
     /*    3392 */     GIR_EraseRootFromParent_Done,
     /*    3393 */   // Label 186: @3393
     /*    3393 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3472), // Rule ID 74456 //
     /*    3398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqciac_IsRV32_HwMode1),
     /*    3401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3405 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:27:y
     /*    3409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3413 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:27:x
     /*    3417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3446 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5gt3),
     /*    3450 */     // MIs[2] Operand 1
     /*    3450 */     // No operand predicates
     /*    3450 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3456 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2:$pred:27:y, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5gt3>>:$imm):$pred:27:x)<<P:27:Predicate_add_like_non_imm12>>  =>  (QC_SHLADD:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5gt3>>:$imm)
     /*    3456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLADD),
     /*    3459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*    3470 */     GIR_RootConstrainSelectedInstOperands,
     /*    3471 */     // GIR_Coverage, 74456,
     /*    3471 */     GIR_EraseRootFromParent_Done,
     /*    3472 */   // Label 187: @3472
     /*    3472 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3539), // Rule ID 74452 //
     /*    3477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqciac_IsRV32_HwMode1),
     /*    3480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3513 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3517 */     // MIs[2] Operand 1
     /*    3517 */     // No operand predicates
     /*    3517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3523 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12), GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MULIADD:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*    3523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MULIADD),
     /*    3526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    3530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm12
     /*    3537 */     GIR_RootConstrainSelectedInstOperands,
     /*    3538 */     // GIR_Coverage, 74452,
     /*    3538 */     GIR_EraseRootFromParent_Done,
     /*    3539 */   // Label 188: @3539
     /*    3539 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(3588), // Rule ID 129 //
     /*    3544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*    3559 */     // MIs[1] Operand 1
     /*    3559 */     // No operand predicates
     /*    3559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    3563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3567 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3571 */     // MIs[2] Operand 1
     /*    3571 */     // No operand predicates
     /*    3571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3573 */     // (add:{ *:[i32] } (frameindex:{ *:[i32] }):$fi, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i32] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i32] }:$fi), (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)
     /*    3573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3578 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*    3583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*    3586 */     GIR_RootConstrainSelectedInstOperands,
     /*    3587 */     // GIR_Coverage, 129,
     /*    3587 */     GIR_EraseRootFromParent_Done,
     /*    3588 */   // Label 189: @3588
     /*    3588 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(3655), // Rule ID 64538 //
     /*    3593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqciac_IsRV32_HwMode1),
     /*    3596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3633 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3637 */     // MIs[2] Operand 1
     /*    3637 */     // No operand predicates
     /*    3637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3639 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))  =>  (QC_MULIADD:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*    3639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MULIADD),
     /*    3642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    3646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm12
     /*    3653 */     GIR_RootConstrainSelectedInstOperands,
     /*    3654 */     // GIR_Coverage, 64538,
     /*    3654 */     GIR_EraseRootFromParent_Done,
     /*    3655 */   // Label 190: @3655
     /*    3655 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3697), // Rule ID 89 //
     /*    3660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3683 */     // MIs[1] Operand 1
     /*    3683 */     // No operand predicates
     /*    3683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3685 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*    3685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3695 */     GIR_RootConstrainSelectedInstOperands,
     /*    3696 */     // GIR_Coverage, 89,
     /*    3696 */     GIR_EraseRootFromParent_Done,
     /*    3697 */   // Label 191: @3697
     /*    3697 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(3769), // Rule ID 304 //
     /*    3702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*    3725 */     // MIs[1] Operand 1
     /*    3725 */     // No operand predicates
     /*    3725 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10110),
     /*    3729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3731 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10110>>:$rs2)  =>  (ADDI:{ *:[i32] } (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (AddiPairImmLarge:{ *:[i32] } (imm:{ *:[i32] }):$rs2)), (AddiPairImmSmall:{ *:[i32] } (imm:{ *:[i32] }):$rs2))
     /*    3731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*    3734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    3743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*    3747 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*    3752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    3754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    3762 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*    3767 */     GIR_RootConstrainSelectedInstOperands,
     /*    3768 */     // GIR_Coverage, 304,
     /*    3768 */     GIR_EraseRootFromParent_Done,
     /*    3769 */   // Label 192: @3769
     /*    3769 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3811), // Rule ID 64545 //
     /*    3774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    3777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*    3797 */     // MIs[1] Operand 1
     /*    3797 */     // No operand predicates
     /*    3797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3799 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ADDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*    3799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDAI),
     /*    3802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3809 */     GIR_RootConstrainSelectedInstOperands,
     /*    3810 */     // GIR_Coverage, 64545,
     /*    3810 */     GIR_EraseRootFromParent_Done,
     /*    3811 */   // Label 193: @3811
     /*    3811 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3853), // Rule ID 64549 //
     /*    3816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    3819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*    3839 */     // MIs[1] Operand 1
     /*    3839 */     // No operand predicates
     /*    3839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3841 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ADDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*    3841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDI),
     /*    3844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3851 */     GIR_RootConstrainSelectedInstOperands,
     /*    3852 */     // GIR_Coverage, 64549,
     /*    3852 */     GIR_EraseRootFromParent_Done,
     /*    3853 */   // Label 194: @3853
     /*    3853 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3914), // Rule ID 74448 //
     /*    3858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    3861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3897 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rd)  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    3900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    3904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    3912 */     GIR_RootConstrainSelectedInstOperands,
     /*    3913 */     // GIR_Coverage, 74448,
     /*    3913 */     GIR_EraseRootFromParent_Done,
     /*    3914 */   // Label 195: @3914
     /*    3914 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3975), // Rule ID 62607 //
     /*    3919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    3922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3958 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    3961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    3965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    3973 */     GIR_RootConstrainSelectedInstOperands,
     /*    3974 */     // GIR_Coverage, 62607,
     /*    3974 */     GIR_EraseRootFromParent_Done,
     /*    3975 */   // Label 196: @3975
     /*    3975 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(4002), // Rule ID 87 //
     /*    3980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3995 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*    4000 */     GIR_RootConstrainSelectedInstOperands,
     /*    4001 */     // GIR_Coverage, 87,
     /*    4001 */     GIR_Done,
     /*    4002 */   // Label 197: @4002
     /*    4002 */   GIM_Reject,
     /*    4003 */ // Label 151: @4003
     /*    4003 */ GIM_Reject,
     /*    4004 */ // Label 127: @4004
     /*    4004 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(11903),
     /*    4009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*    4012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*    4015 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(4110), // Rule ID 2620 //
     /*    4020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4027 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*    4031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4068 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    4072 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    4083 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*    4087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4097 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:10:x, GPR:{ *:[i64] }:$rs2:$pred:10:y)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4108 */     GIR_RootConstrainSelectedInstOperands,
     /*    4109 */     // GIR_Coverage, 2620,
     /*    4109 */     GIR_EraseRootFromParent_Done,
     /*    4110 */   // Label 199: @4110
     /*    4110 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(4205), // Rule ID 2624 //
     /*    4115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4122 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:12:x
     /*    4126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4163 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    4167 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    4178 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:12:y
     /*    4182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4186 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4192 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x, GPR:{ *:[i64] }:$rs2:$pred:12:y)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4203 */     GIR_RootConstrainSelectedInstOperands,
     /*    4204 */     // GIR_Coverage, 2624,
     /*    4204 */     GIR_EraseRootFromParent_Done,
     /*    4205 */   // Label 200: @4205
     /*    4205 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4300), // Rule ID 65175 //
     /*    4210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4217 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:41:x
     /*    4221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4258 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    4262 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    4273 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:41:y
     /*    4277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4287 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:41:x, GPR:{ *:[i64] }:$rs2:$pred:41:y)<<P:41:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    4290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4298 */     GIR_RootConstrainSelectedInstOperands,
     /*    4299 */     // GIR_Coverage, 65175,
     /*    4299 */     GIR_EraseRootFromParent_Done,
     /*    4300 */   // Label 201: @4300
     /*    4300 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(4395), // Rule ID 65179 //
     /*    4305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4312 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:43:x
     /*    4316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4353 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    4357 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    4368 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:43:y
     /*    4372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4376 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4382 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:43:x, GPR:{ *:[i64] }:$rs2:$pred:43:y)<<P:43:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    4385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4393 */     GIR_RootConstrainSelectedInstOperands,
     /*    4394 */     // GIR_Coverage, 65179,
     /*    4394 */     GIR_EraseRootFromParent_Done,
     /*    4395 */   // Label 202: @4395
     /*    4395 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(4490), // Rule ID 2615 //
     /*    4400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4407 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*    4411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4448 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4459 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4463 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*    4467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4471 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4477 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x, GPR:{ *:[i64] }:$rs2:$pred:8:y)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4488 */     GIR_RootConstrainSelectedInstOperands,
     /*    4489 */     // GIR_Coverage, 2615,
     /*    4489 */     GIR_EraseRootFromParent_Done,
     /*    4490 */   // Label 203: @4490
     /*    4490 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(4585), // Rule ID 2634 //
     /*    4495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4502 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*    4506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4543 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4554 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    4558 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*    4562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4572 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:16:x, GPR:{ *:[i64] }:$rs2:$pred:16:y)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4583 */     GIR_RootConstrainSelectedInstOperands,
     /*    4584 */     // GIR_Coverage, 2634,
     /*    4584 */     GIR_EraseRootFromParent_Done,
     /*    4585 */   // Label 204: @4585
     /*    4585 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4680), // Rule ID 2639 //
     /*    4590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4597 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:18:x
     /*    4601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4638 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4649 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    4653 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:18:y
     /*    4657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4667 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:18:x, GPR:{ *:[i64] }:$rs2:$pred:18:y)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    4670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4678 */     GIR_RootConstrainSelectedInstOperands,
     /*    4679 */     // GIR_Coverage, 2639,
     /*    4679 */     GIR_EraseRootFromParent_Done,
     /*    4680 */   // Label 205: @4680
     /*    4680 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(4775), // Rule ID 65160 //
     /*    4685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4692 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:35:x
     /*    4696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4728 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4733 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4744 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4748 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:35:y
     /*    4752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4762 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:35:x, GPR:{ *:[i64] }:$rs2:$pred:35:y)<<P:35:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    4765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4773 */     GIR_RootConstrainSelectedInstOperands,
     /*    4774 */     // GIR_Coverage, 65160,
     /*    4774 */     GIR_EraseRootFromParent_Done,
     /*    4775 */   // Label 206: @4775
     /*    4775 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(4870), // Rule ID 65165 //
     /*    4780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4787 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:37:x
     /*    4791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4823 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4828 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4839 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    4843 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:37:y
     /*    4847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4857 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:37:x, GPR:{ *:[i64] }:$rs2:$pred:37:y)<<P:37:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    4860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4868 */     GIR_RootConstrainSelectedInstOperands,
     /*    4869 */     // GIR_Coverage, 65165,
     /*    4869 */     GIR_EraseRootFromParent_Done,
     /*    4870 */   // Label 207: @4870
     /*    4870 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(4965), // Rule ID 65170 //
     /*    4875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4882 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:39:x
     /*    4886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4923 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4934 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    4938 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:39:y
     /*    4942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4952 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:39:x, GPR:{ *:[i64] }:$rs2:$pred:39:y)<<P:39:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    4955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4963 */     GIR_RootConstrainSelectedInstOperands,
     /*    4964 */     // GIR_Coverage, 65170,
     /*    4964 */     GIR_EraseRootFromParent_Done,
     /*    4965 */   // Label 208: @4965
     /*    4965 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(5060), // Rule ID 65630 //
     /*    4970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4977 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:10:y
     /*    4981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4985 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:10:x
     /*    4989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5026 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    5030 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    5041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5047 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:10:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:10:x)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    5050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5058 */     GIR_RootConstrainSelectedInstOperands,
     /*    5059 */     // GIR_Coverage, 65630,
     /*    5059 */     GIR_EraseRootFromParent_Done,
     /*    5060 */   // Label 209: @5060
     /*    5060 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(5155), // Rule ID 65634 //
     /*    5065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5072 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:12:y
     /*    5076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5080 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:12:x
     /*    5084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5121 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    5125 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    5136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5142 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:12:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5153 */     GIR_RootConstrainSelectedInstOperands,
     /*    5154 */     // GIR_Coverage, 65634,
     /*    5154 */     GIR_EraseRootFromParent_Done,
     /*    5155 */   // Label 210: @5155
     /*    5155 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(5250), // Rule ID 74498 //
     /*    5160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5167 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:41:y
     /*    5171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5175 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:41:x
     /*    5179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5216 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    5220 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    5231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5237 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:41:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:41:x)<<P:41:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    5240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5248 */     GIR_RootConstrainSelectedInstOperands,
     /*    5249 */     // GIR_Coverage, 74498,
     /*    5249 */     GIR_EraseRootFromParent_Done,
     /*    5250 */   // Label 211: @5250
     /*    5250 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(5345), // Rule ID 74502 //
     /*    5255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5262 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:43:y
     /*    5266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5270 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:43:x
     /*    5274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5311 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    5315 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    5326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5332 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:43:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:43:x)<<P:43:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    5335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5343 */     GIR_RootConstrainSelectedInstOperands,
     /*    5344 */     // GIR_Coverage, 74502,
     /*    5344 */     GIR_EraseRootFromParent_Done,
     /*    5345 */   // Label 212: @5345
     /*    5345 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5440), // Rule ID 65626 //
     /*    5350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5357 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:8:y
     /*    5361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5365 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:8:x
     /*    5369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5406 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5417 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    5421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5427 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:8:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    5430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5438 */     GIR_RootConstrainSelectedInstOperands,
     /*    5439 */     // GIR_Coverage, 65626,
     /*    5439 */     GIR_EraseRootFromParent_Done,
     /*    5440 */   // Label 213: @5440
     /*    5440 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(5535), // Rule ID 65642 //
     /*    5445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5452 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:16:y
     /*    5456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5460 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:16:x
     /*    5464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5501 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5522 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:16:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:16:x)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5533 */     GIR_RootConstrainSelectedInstOperands,
     /*    5534 */     // GIR_Coverage, 65642,
     /*    5534 */     GIR_EraseRootFromParent_Done,
     /*    5535 */   // Label 214: @5535
     /*    5535 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(5630), // Rule ID 65646 //
     /*    5540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5547 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:18:y
     /*    5551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5555 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:18:x
     /*    5559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5596 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5607 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5611 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5617 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:18:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:18:x)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    5620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5628 */     GIR_RootConstrainSelectedInstOperands,
     /*    5629 */     // GIR_Coverage, 65646,
     /*    5629 */     GIR_EraseRootFromParent_Done,
     /*    5630 */   // Label 215: @5630
     /*    5630 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(5725), // Rule ID 74486 //
     /*    5635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5642 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:35:y
     /*    5646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5650 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:35:x
     /*    5654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5691 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5702 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    5706 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5712 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:35:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:35:x)<<P:35:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    5715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5723 */     GIR_RootConstrainSelectedInstOperands,
     /*    5724 */     // GIR_Coverage, 74486,
     /*    5724 */     GIR_EraseRootFromParent_Done,
     /*    5725 */   // Label 216: @5725
     /*    5725 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(5820), // Rule ID 74490 //
     /*    5730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5737 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:37:y
     /*    5741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5745 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:37:x
     /*    5749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5786 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5797 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5807 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:37:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:37:x)<<P:37:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    5810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5818 */     GIR_RootConstrainSelectedInstOperands,
     /*    5819 */     // GIR_Coverage, 74490,
     /*    5819 */     GIR_EraseRootFromParent_Done,
     /*    5820 */   // Label 217: @5820
     /*    5820 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(5915), // Rule ID 74494 //
     /*    5825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5832 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:39:y
     /*    5836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5840 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:39:x
     /*    5844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5881 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5902 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:39:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:39:x)<<P:39:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    5905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5913 */     GIR_RootConstrainSelectedInstOperands,
     /*    5914 */     // GIR_Coverage, 74494,
     /*    5914 */     GIR_EraseRootFromParent_Done,
     /*    5915 */   // Label 218: @5915
     /*    5915 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(5963), // Rule ID 2579 //
     /*    5920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5927 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    5931 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    5935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5950 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:2:x, GPR:{ *:[i64] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    5953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5961 */     GIR_RootConstrainSelectedInstOperands,
     /*    5962 */     // GIR_Coverage, 2579,
     /*    5962 */     GIR_EraseRootFromParent_Done,
     /*    5963 */   // Label 219: @5963
     /*    5963 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(6011), // Rule ID 2589 //
     /*    5968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5975 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    5979 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    5983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5987 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5998 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:4:x, GPR:{ *:[i64] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    6001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6003 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6009 */     GIR_RootConstrainSelectedInstOperands,
     /*    6010 */     // GIR_Coverage, 2589,
     /*    6010 */     GIR_EraseRootFromParent_Done,
     /*    6011 */   // Label 220: @6011
     /*    6011 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(6059), // Rule ID 2599 //
     /*    6016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6023 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    6027 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    6031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6046 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:6:x, GPR:{ *:[i64] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    6049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6051 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6057 */     GIR_RootConstrainSelectedInstOperands,
     /*    6058 */     // GIR_Coverage, 2599,
     /*    6058 */     GIR_EraseRootFromParent_Done,
     /*    6059 */   // Label 221: @6059
     /*    6059 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(6107), // Rule ID 2618 //
     /*    6064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6071 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*    6075 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*    6079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6094 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:9:x, GPR:{ *:[i64] }:$rs2:$pred:9:y)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    6097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6099 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6105 */     GIR_RootConstrainSelectedInstOperands,
     /*    6106 */     // GIR_Coverage, 2618,
     /*    6106 */     GIR_EraseRootFromParent_Done,
     /*    6107 */   // Label 222: @6107
     /*    6107 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(6155), // Rule ID 2637 //
     /*    6112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6119 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:17:x
     /*    6123 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:17:y
     /*    6127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6142 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:17:x, GPR:{ *:[i64] }:$rs2:$pred:17:y)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    6145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6153 */     GIR_RootConstrainSelectedInstOperands,
     /*    6154 */     // GIR_Coverage, 2637,
     /*    6154 */     GIR_EraseRootFromParent_Done,
     /*    6155 */   // Label 223: @6155
     /*    6155 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6203), // Rule ID 2642 //
     /*    6160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6167 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:19:x
     /*    6171 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:19:y
     /*    6175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6179 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6190 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:19:x, GPR:{ *:[i64] }:$rs2:$pred:19:y)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    6193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6201 */     GIR_RootConstrainSelectedInstOperands,
     /*    6202 */     // GIR_Coverage, 2642,
     /*    6202 */     GIR_EraseRootFromParent_Done,
     /*    6203 */   // Label 224: @6203
     /*    6203 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6254), // Rule ID 62545 //
     /*    6208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6215 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    6219 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    6223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6227 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6238 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs2:$pred:24:x, GPR:{ *:[i64] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    6238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    6245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    6252 */     GIR_RootConstrainSelectedInstOperands,
     /*    6253 */     // GIR_Coverage, 62545,
     /*    6253 */     GIR_EraseRootFromParent_Done,
     /*    6254 */   // Label 225: @6254
     /*    6254 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6305), // Rule ID 62549 //
     /*    6259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6266 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    6270 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    6274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6278 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6289 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs2:$pred:25:x, GPR:{ *:[i64] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    6289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    6296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    6303 */     GIR_RootConstrainSelectedInstOperands,
     /*    6304 */     // GIR_Coverage, 62549,
     /*    6304 */     GIR_EraseRootFromParent_Done,
     /*    6305 */   // Label 226: @6305
     /*    6305 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6356), // Rule ID 62553 //
     /*    6310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6317 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    6321 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    6325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6340 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs2:$pred:26:x, GPR:{ *:[i64] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    6340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    6347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    6354 */     GIR_RootConstrainSelectedInstOperands,
     /*    6355 */     // GIR_Coverage, 62553,
     /*    6355 */     GIR_EraseRootFromParent_Done,
     /*    6356 */   // Label 227: @6356
     /*    6356 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6404), // Rule ID 65124 //
     /*    6361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6368 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:29:x
     /*    6372 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:29:y
     /*    6376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6391 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:29:x, GPR:{ *:[i64] }:$rs2:$pred:29:y)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    6394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6402 */     GIR_RootConstrainSelectedInstOperands,
     /*    6403 */     // GIR_Coverage, 65124,
     /*    6403 */     GIR_EraseRootFromParent_Done,
     /*    6404 */   // Label 228: @6404
     /*    6404 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6452), // Rule ID 65134 //
     /*    6409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6416 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:31:x
     /*    6420 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:31:y
     /*    6424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6439 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:31:x, GPR:{ *:[i64] }:$rs2:$pred:31:y)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    6442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6444 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6450 */     GIR_RootConstrainSelectedInstOperands,
     /*    6451 */     // GIR_Coverage, 65134,
     /*    6451 */     GIR_EraseRootFromParent_Done,
     /*    6452 */   // Label 229: @6452
     /*    6452 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6500), // Rule ID 65144 //
     /*    6457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6464 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:33:x
     /*    6468 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:33:y
     /*    6472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6487 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:33:x, GPR:{ *:[i64] }:$rs2:$pred:33:y)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    6490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6498 */     GIR_RootConstrainSelectedInstOperands,
     /*    6499 */     // GIR_Coverage, 65144,
     /*    6499 */     GIR_EraseRootFromParent_Done,
     /*    6500 */   // Label 230: @6500
     /*    6500 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(6548), // Rule ID 65163 //
     /*    6505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6512 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:36:x
     /*    6516 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:36:y
     /*    6520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6535 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:36:x, GPR:{ *:[i64] }:$rs2:$pred:36:y)<<P:36:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    6538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6540 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6546 */     GIR_RootConstrainSelectedInstOperands,
     /*    6547 */     // GIR_Coverage, 65163,
     /*    6547 */     GIR_EraseRootFromParent_Done,
     /*    6548 */   // Label 231: @6548
     /*    6548 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(6596), // Rule ID 65168 //
     /*    6553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6560 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:38:x
     /*    6564 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:38:y
     /*    6568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6572 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6583 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:38:x, GPR:{ *:[i64] }:$rs2:$pred:38:y)<<P:38:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    6586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6588 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6594 */     GIR_RootConstrainSelectedInstOperands,
     /*    6595 */     // GIR_Coverage, 65168,
     /*    6595 */     GIR_EraseRootFromParent_Done,
     /*    6596 */   // Label 232: @6596
     /*    6596 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(6644), // Rule ID 65173 //
     /*    6601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6608 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:40:x
     /*    6612 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:40:y
     /*    6616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6620 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6631 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:40:x, GPR:{ *:[i64] }:$rs2:$pred:40:y)<<P:40:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    6634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6636 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6642 */     GIR_RootConstrainSelectedInstOperands,
     /*    6643 */     // GIR_Coverage, 65173,
     /*    6643 */     GIR_EraseRootFromParent_Done,
     /*    6644 */   // Label 233: @6644
     /*    6644 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(6692), // Rule ID 65603 //
     /*    6649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6656 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    6660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6664 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    6668 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6679 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:2:y, sh1add_op:{ *:[i64] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    6682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6684 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6690 */     GIR_RootConstrainSelectedInstOperands,
     /*    6691 */     // GIR_Coverage, 65603,
     /*    6691 */     GIR_EraseRootFromParent_Done,
     /*    6692 */   // Label 234: @6692
     /*    6692 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(6740), // Rule ID 65611 //
     /*    6697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6704 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    6708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6712 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    6716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6727 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:4:y, sh2add_op:{ *:[i64] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    6730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6732 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6738 */     GIR_RootConstrainSelectedInstOperands,
     /*    6739 */     // GIR_Coverage, 65611,
     /*    6739 */     GIR_EraseRootFromParent_Done,
     /*    6740 */   // Label 235: @6740
     /*    6740 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(6788), // Rule ID 65619 //
     /*    6745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6752 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    6756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6760 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    6764 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6775 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:6:y, sh3add_op:{ *:[i64] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    6778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6780 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6786 */     GIR_RootConstrainSelectedInstOperands,
     /*    6787 */     // GIR_Coverage, 65619,
     /*    6787 */     GIR_EraseRootFromParent_Done,
     /*    6788 */   // Label 236: @6788
     /*    6788 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(6836), // Rule ID 65628 //
     /*    6793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6800 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:9:y
     /*    6804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6808 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:9:x
     /*    6812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6823 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:9:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:9:x)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    6826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6828 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6834 */     GIR_RootConstrainSelectedInstOperands,
     /*    6835 */     // GIR_Coverage, 65628,
     /*    6835 */     GIR_EraseRootFromParent_Done,
     /*    6836 */   // Label 237: @6836
     /*    6836 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(6884), // Rule ID 65644 //
     /*    6841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6848 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:17:y
     /*    6852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6856 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:17:x
     /*    6860 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6871 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:17:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:17:x)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    6874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6882 */     GIR_RootConstrainSelectedInstOperands,
     /*    6883 */     // GIR_Coverage, 65644,
     /*    6883 */     GIR_EraseRootFromParent_Done,
     /*    6884 */   // Label 238: @6884
     /*    6884 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(6932), // Rule ID 65648 //
     /*    6889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6896 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:19:y
     /*    6900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6904 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:19:x
     /*    6908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6919 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:19:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:19:x)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    6922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6924 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6930 */     GIR_RootConstrainSelectedInstOperands,
     /*    6931 */     // GIR_Coverage, 65648,
     /*    6931 */     GIR_EraseRootFromParent_Done,
     /*    6932 */   // Label 239: @6932
     /*    6932 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(6983), // Rule ID 74437 //
     /*    6937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6944 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    6948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6952 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    6956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6967 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:24:y, sh1add_op:{ *:[i64] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    6967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6974 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    6981 */     GIR_RootConstrainSelectedInstOperands,
     /*    6982 */     // GIR_Coverage, 74437,
     /*    6982 */     GIR_EraseRootFromParent_Done,
     /*    6983 */   // Label 240: @6983
     /*    6983 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(7034), // Rule ID 74441 //
     /*    6988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6995 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    6999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7003 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    7007 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    7018 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:25:y, sh2add_op:{ *:[i64] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    7018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    7021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    7029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    7032 */     GIR_RootConstrainSelectedInstOperands,
     /*    7033 */     // GIR_Coverage, 74441,
     /*    7033 */     GIR_EraseRootFromParent_Done,
     /*    7034 */   // Label 241: @7034
     /*    7034 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(7085), // Rule ID 74445 //
     /*    7039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    7042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7046 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    7050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7054 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    7058 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    7069 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:26:y, sh3add_op:{ *:[i64] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    7069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    7072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    7080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7083 */     GIR_RootConstrainSelectedInstOperands,
     /*    7084 */     // GIR_Coverage, 74445,
     /*    7084 */     GIR_EraseRootFromParent_Done,
     /*    7085 */   // Label 242: @7085
     /*    7085 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(7133), // Rule ID 74463 //
     /*    7090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    7093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7097 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:29:y
     /*    7101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7105 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:29:x
     /*    7109 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    7120 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:29:y, sh1add_op:{ *:[i64] }:$rs1:$pred:29:x)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    7123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7125 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    7129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7131 */     GIR_RootConstrainSelectedInstOperands,
     /*    7132 */     // GIR_Coverage, 74463,
     /*    7132 */     GIR_EraseRootFromParent_Done,
     /*    7133 */   // Label 243: @7133
     /*    7133 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(7181), // Rule ID 74471 //
     /*    7138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    7141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7145 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:31:y
     /*    7149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7153 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:31:x
     /*    7157 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    7168 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:31:y, sh2add_op:{ *:[i64] }:$rs1:$pred:31:x)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    7171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7173 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    7177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7179 */     GIR_RootConstrainSelectedInstOperands,
     /*    7180 */     // GIR_Coverage, 74471,
     /*    7180 */     GIR_EraseRootFromParent_Done,
     /*    7181 */   // Label 244: @7181
     /*    7181 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(7229), // Rule ID 74479 //
     /*    7186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    7189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7193 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:33:y
     /*    7197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7201 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:33:x
     /*    7205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    7216 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:33:y, sh3add_op:{ *:[i64] }:$rs1:$pred:33:x)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    7219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    7225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7227 */     GIR_RootConstrainSelectedInstOperands,
     /*    7228 */     // GIR_Coverage, 74479,
     /*    7228 */     GIR_EraseRootFromParent_Done,
     /*    7229 */   // Label 245: @7229
     /*    7229 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(7277), // Rule ID 74488 //
     /*    7234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7241 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:36:y
     /*    7245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7249 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:36:x
     /*    7253 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    7264 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:36:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:36:x)<<P:36:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    7267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7269 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    7273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7275 */     GIR_RootConstrainSelectedInstOperands,
     /*    7276 */     // GIR_Coverage, 74488,
     /*    7276 */     GIR_EraseRootFromParent_Done,
     /*    7277 */   // Label 246: @7277
     /*    7277 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(7325), // Rule ID 74492 //
     /*    7282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7289 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:38:y
     /*    7293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7297 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:38:x
     /*    7301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    7312 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:38:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:38:x)<<P:38:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    7315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7317 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    7321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7323 */     GIR_RootConstrainSelectedInstOperands,
     /*    7324 */     // GIR_Coverage, 74492,
     /*    7324 */     GIR_EraseRootFromParent_Done,
     /*    7325 */   // Label 247: @7325
     /*    7325 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(7373), // Rule ID 74496 //
     /*    7330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7337 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:40:y
     /*    7341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7345 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:40:x
     /*    7349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    7360 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:40:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:40:x)<<P:40:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    7363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    7369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7371 */     GIR_RootConstrainSelectedInstOperands,
     /*    7372 */     // GIR_Coverage, 74496,
     /*    7372 */     GIR_EraseRootFromParent_Done,
     /*    7373 */   // Label 248: @7373
     /*    7373 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(7448), // Rule ID 2610 //
     /*    7378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7385 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*    7389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7410 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    7421 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*    7425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7429 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7435 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x, GPR:{ *:[i64] }:$rs2:$pred:7:y)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    7438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7446 */     GIR_RootConstrainSelectedInstOperands,
     /*    7447 */     // GIR_Coverage, 2610,
     /*    7447 */     GIR_EraseRootFromParent_Done,
     /*    7448 */   // Label 249: @7448
     /*    7448 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(7543), // Rule ID 2622 //
     /*    7453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7460 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*    7464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7485 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    7496 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*    7500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7510 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:11:x, GPR:{ *:[i64] }:$rs2:$pred:11:y)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    7534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7541 */     GIR_RootConstrainSelectedInstOperands,
     /*    7542 */     // GIR_Coverage, 2622,
     /*    7542 */     GIR_EraseRootFromParent_Done,
     /*    7543 */   // Label 250: @7543
     /*    7543 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(7638), // Rule ID 2626 //
     /*    7548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7555 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*    7559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7580 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    7591 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*    7595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7599 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7605 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:13:x, GPR:{ *:[i64] }:$rs2:$pred:13:y)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    7629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7636 */     GIR_RootConstrainSelectedInstOperands,
     /*    7637 */     // GIR_Coverage, 2626,
     /*    7637 */     GIR_EraseRootFromParent_Done,
     /*    7638 */   // Label 251: @7638
     /*    7638 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(7733), // Rule ID 2628 //
     /*    7643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7650 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*    7654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7675 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7686 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*    7690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7700 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:14:x, GPR:{ *:[i64] }:$rs2:$pred:14:y)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7716 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    7724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7731 */     GIR_RootConstrainSelectedInstOperands,
     /*    7732 */     // GIR_Coverage, 2628,
     /*    7732 */     GIR_EraseRootFromParent_Done,
     /*    7733 */   // Label 252: @7733
     /*    7733 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(7828), // Rule ID 2630 //
     /*    7738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7745 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:15:x
     /*    7749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7770 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    7781 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:15:y
     /*    7785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7795 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:15:x, GPR:{ *:[i64] }:$rs2:$pred:15:y)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7807 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7811 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    7819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7826 */     GIR_RootConstrainSelectedInstOperands,
     /*    7827 */     // GIR_Coverage, 2630,
     /*    7827 */     GIR_EraseRootFromParent_Done,
     /*    7828 */   // Label 253: @7828
     /*    7828 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(7923), // Rule ID 2644 //
     /*    7833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7840 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:20:x
     /*    7844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7865 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    7876 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:20:y
     /*    7880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7890 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:20:x, GPR:{ *:[i64] }:$rs2:$pred:20:y)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7906 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    7914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7921 */     GIR_RootConstrainSelectedInstOperands,
     /*    7922 */     // GIR_Coverage, 2644,
     /*    7922 */     GIR_EraseRootFromParent_Done,
     /*    7923 */   // Label 254: @7923
     /*    7923 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(8018), // Rule ID 2646 //
     /*    7928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7935 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:21:x
     /*    7939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7960 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    7971 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:21:y
     /*    7975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7985 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:21:x, GPR:{ *:[i64] }:$rs2:$pred:21:y)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8001 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    8004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    8009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8016 */     GIR_RootConstrainSelectedInstOperands,
     /*    8017 */     // GIR_Coverage, 2646,
     /*    8017 */     GIR_EraseRootFromParent_Done,
     /*    8018 */   // Label 255: @8018
     /*    8018 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(8113), // Rule ID 2648 //
     /*    8023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8030 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:22:x
     /*    8034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8055 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    8066 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:22:y
     /*    8070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8080 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:22:x, GPR:{ *:[i64] }:$rs2:$pred:22:y)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8096 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    8104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8111 */     GIR_RootConstrainSelectedInstOperands,
     /*    8112 */     // GIR_Coverage, 2648,
     /*    8112 */     GIR_EraseRootFromParent_Done,
     /*    8113 */   // Label 256: @8113
     /*    8113 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(8188), // Rule ID 65155 //
     /*    8118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8125 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:34:x
     /*    8129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8150 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    8161 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:34:y
     /*    8165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8169 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8175 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:34:x, GPR:{ *:[i64] }:$rs2:$pred:34:y)<<P:34:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*    8178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8186 */     GIR_RootConstrainSelectedInstOperands,
     /*    8187 */     // GIR_Coverage, 65155,
     /*    8187 */     GIR_EraseRootFromParent_Done,
     /*    8188 */   // Label 257: @8188
     /*    8188 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(8283), // Rule ID 65177 //
     /*    8193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8200 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:42:x
     /*    8204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8225 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    8236 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:42:y
     /*    8240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8250 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:42:x, GPR:{ *:[i64] }:$rs2:$pred:42:y)<<P:42:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8266 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    8269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    8274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8281 */     GIR_RootConstrainSelectedInstOperands,
     /*    8282 */     // GIR_Coverage, 65177,
     /*    8282 */     GIR_EraseRootFromParent_Done,
     /*    8283 */   // Label 258: @8283
     /*    8283 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(8378), // Rule ID 65181 //
     /*    8288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8295 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:44:x
     /*    8299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8320 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    8331 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:44:y
     /*    8335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8345 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:44:x, GPR:{ *:[i64] }:$rs2:$pred:44:y)<<P:44:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8361 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    8364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    8369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8376 */     GIR_RootConstrainSelectedInstOperands,
     /*    8377 */     // GIR_Coverage, 65181,
     /*    8377 */     GIR_EraseRootFromParent_Done,
     /*    8378 */   // Label 259: @8378
     /*    8378 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(8473), // Rule ID 65183 //
     /*    8383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8390 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:45:x
     /*    8394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8415 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    8426 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:45:y
     /*    8430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8440 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:45:x, GPR:{ *:[i64] }:$rs2:$pred:45:y)<<P:45:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8456 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8471 */     GIR_RootConstrainSelectedInstOperands,
     /*    8472 */     // GIR_Coverage, 65183,
     /*    8472 */     GIR_EraseRootFromParent_Done,
     /*    8473 */   // Label 260: @8473
     /*    8473 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(8568), // Rule ID 65185 //
     /*    8478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8485 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:46:x
     /*    8489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8510 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    8521 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:46:y
     /*    8525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8535 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:46:x, GPR:{ *:[i64] }:$rs2:$pred:46:y)<<P:46:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8551 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8566 */     GIR_RootConstrainSelectedInstOperands,
     /*    8567 */     // GIR_Coverage, 65185,
     /*    8567 */     GIR_EraseRootFromParent_Done,
     /*    8568 */   // Label 261: @8568
     /*    8568 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(8663), // Rule ID 65187 //
     /*    8573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8580 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:47:x
     /*    8584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8605 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    8616 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:47:y
     /*    8620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8630 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:47:x, GPR:{ *:[i64] }:$rs2:$pred:47:y)<<P:47:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    8649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    8654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8661 */     GIR_RootConstrainSelectedInstOperands,
     /*    8662 */     // GIR_Coverage, 65187,
     /*    8662 */     GIR_EraseRootFromParent_Done,
     /*    8663 */   // Label 262: @8663
     /*    8663 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(8758), // Rule ID 65189 //
     /*    8668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8675 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:48:x
     /*    8679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8700 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    8711 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:48:y
     /*    8715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8725 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:48:x, GPR:{ *:[i64] }:$rs2:$pred:48:y)<<P:48:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8741 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    8744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    8749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8756 */     GIR_RootConstrainSelectedInstOperands,
     /*    8757 */     // GIR_Coverage, 65189,
     /*    8757 */     GIR_EraseRootFromParent_Done,
     /*    8758 */   // Label 263: @8758
     /*    8758 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(8853), // Rule ID 65191 //
     /*    8763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8770 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:49:x
     /*    8774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8795 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    8806 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:49:y
     /*    8810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8820 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:49:x, GPR:{ *:[i64] }:$rs2:$pred:49:y)<<P:49:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8832 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8836 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8851 */     GIR_RootConstrainSelectedInstOperands,
     /*    8852 */     // GIR_Coverage, 65191,
     /*    8852 */     GIR_EraseRootFromParent_Done,
     /*    8853 */   // Label 264: @8853
     /*    8853 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(8921), // Rule ID 2573 //
     /*    8858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8865 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    8869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8890 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    8894 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    8898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8908 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x, GPR:{ *:[i64] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    8911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8919 */     GIR_RootConstrainSelectedInstOperands,
     /*    8920 */     // GIR_Coverage, 2573,
     /*    8920 */     GIR_EraseRootFromParent_Done,
     /*    8921 */   // Label 265: @8921
     /*    8921 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(8989), // Rule ID 2583 //
     /*    8926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8933 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    8937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8958 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    8962 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    8966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8976 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x, GPR:{ *:[i64] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    8979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8987 */     GIR_RootConstrainSelectedInstOperands,
     /*    8988 */     // GIR_Coverage, 2583,
     /*    8988 */     GIR_EraseRootFromParent_Done,
     /*    8989 */   // Label 266: @8989
     /*    8989 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(9057), // Rule ID 2593 //
     /*    8994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9001 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    9005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    9013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9026 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    9030 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    9034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9044 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x, GPR:{ *:[i64] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    9047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9055 */     GIR_RootConstrainSelectedInstOperands,
     /*    9056 */     // GIR_Coverage, 2593,
     /*    9056 */     GIR_EraseRootFromParent_Done,
     /*    9057 */   // Label 267: @9057
     /*    9057 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(9125), // Rule ID 65118 //
     /*    9062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    9065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9069 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:28:x
     /*    9073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    9081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9094 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    9098 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:28:y
     /*    9102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9112 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:28:x, GPR:{ *:[i64] }:$rs2:$pred:28:y)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    9115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9123 */     GIR_RootConstrainSelectedInstOperands,
     /*    9124 */     // GIR_Coverage, 65118,
     /*    9124 */     GIR_EraseRootFromParent_Done,
     /*    9125 */   // Label 268: @9125
     /*    9125 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(9193), // Rule ID 65128 //
     /*    9130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    9133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9137 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:30:x
     /*    9141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    9149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9162 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    9166 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:30:y
     /*    9170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9180 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:30:x, GPR:{ *:[i64] }:$rs2:$pred:30:y)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    9183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9191 */     GIR_RootConstrainSelectedInstOperands,
     /*    9192 */     // GIR_Coverage, 65128,
     /*    9192 */     GIR_EraseRootFromParent_Done,
     /*    9193 */   // Label 269: @9193
     /*    9193 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(9261), // Rule ID 65138 //
     /*    9198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    9201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9205 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:32:x
     /*    9209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    9217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9230 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    9234 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:32:y
     /*    9238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9242 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9248 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:32:x, GPR:{ *:[i64] }:$rs2:$pred:32:y)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    9251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9259 */     GIR_RootConstrainSelectedInstOperands,
     /*    9260 */     // GIR_Coverage, 65138,
     /*    9260 */     GIR_EraseRootFromParent_Done,
     /*    9261 */   // Label 270: @9261
     /*    9261 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(9336), // Rule ID 65622 //
     /*    9266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9273 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:7:y
     /*    9277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9281 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:7:x
     /*    9285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9306 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    9317 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9323 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:7:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    9326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9334 */     GIR_RootConstrainSelectedInstOperands,
     /*    9335 */     // GIR_Coverage, 65622,
     /*    9335 */     GIR_EraseRootFromParent_Done,
     /*    9336 */   // Label 271: @9336
     /*    9336 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(9431), // Rule ID 65632 //
     /*    9341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9348 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:11:y
     /*    9352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9356 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:11:x
     /*    9360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9381 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    9392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9398 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:11:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:11:x)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9414 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    9417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    9422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9429 */     GIR_RootConstrainSelectedInstOperands,
     /*    9430 */     // GIR_Coverage, 65632,
     /*    9430 */     GIR_EraseRootFromParent_Done,
     /*    9431 */   // Label 272: @9431
     /*    9431 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(9526), // Rule ID 65636 //
     /*    9436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9443 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:13:y
     /*    9447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9451 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:13:x
     /*    9455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9476 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    9487 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9493 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:13:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:13:x)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9505 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9509 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    9517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9524 */     GIR_RootConstrainSelectedInstOperands,
     /*    9525 */     // GIR_Coverage, 65636,
     /*    9525 */     GIR_EraseRootFromParent_Done,
     /*    9526 */   // Label 273: @9526
     /*    9526 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(9621), // Rule ID 65638 //
     /*    9531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9538 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:14:y
     /*    9542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9546 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:14:x
     /*    9550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9571 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9588 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:14:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:14:x)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9600 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9604 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    9612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9619 */     GIR_RootConstrainSelectedInstOperands,
     /*    9620 */     // GIR_Coverage, 65638,
     /*    9620 */     GIR_EraseRootFromParent_Done,
     /*    9621 */   // Label 274: @9621
     /*    9621 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(9716), // Rule ID 65640 //
     /*    9626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9633 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:15:y
     /*    9637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9641 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:15:x
     /*    9645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9666 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    9677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9683 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:15:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:15:x)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9695 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9699 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    9707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9714 */     GIR_RootConstrainSelectedInstOperands,
     /*    9715 */     // GIR_Coverage, 65640,
     /*    9715 */     GIR_EraseRootFromParent_Done,
     /*    9716 */   // Label 275: @9716
     /*    9716 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(9811), // Rule ID 65650 //
     /*    9721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9728 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:20:y
     /*    9732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9736 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:20:x
     /*    9740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9761 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    9772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9778 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:20:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:20:x)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9794 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    9797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    9802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9809 */     GIR_RootConstrainSelectedInstOperands,
     /*    9810 */     // GIR_Coverage, 65650,
     /*    9810 */     GIR_EraseRootFromParent_Done,
     /*    9811 */   // Label 276: @9811
     /*    9811 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(9906), // Rule ID 65652 //
     /*    9816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9823 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:21:y
     /*    9827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9831 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:21:x
     /*    9835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9856 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    9867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9873 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:21:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:21:x)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9889 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    9897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9904 */     GIR_RootConstrainSelectedInstOperands,
     /*    9905 */     // GIR_Coverage, 65652,
     /*    9905 */     GIR_EraseRootFromParent_Done,
     /*    9906 */   // Label 277: @9906
     /*    9906 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(10001), // Rule ID 65654 //
     /*    9911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9918 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:22:y
     /*    9922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9926 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:22:x
     /*    9930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9951 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9962 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9968 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:22:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:22:x)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9984 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    9992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9999 */     GIR_RootConstrainSelectedInstOperands,
     /*   10000 */     // GIR_Coverage, 65654,
     /*   10000 */     GIR_EraseRootFromParent_Done,
     /*   10001 */   // Label 278: @10001
     /*   10001 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(10076), // Rule ID 74482 //
     /*   10006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10013 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:34:y
     /*   10017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10021 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:34:x
     /*   10025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10046 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*   10057 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10063 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:34:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:34:x)<<P:34:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*   10066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10074 */     GIR_RootConstrainSelectedInstOperands,
     /*   10075 */     // GIR_Coverage, 74482,
     /*   10075 */     GIR_EraseRootFromParent_Done,
     /*   10076 */   // Label 279: @10076
     /*   10076 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(10171), // Rule ID 74500 //
     /*   10081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10088 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:42:y
     /*   10092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10096 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:42:x
     /*   10100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10121 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*   10132 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10138 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:42:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:42:x)<<P:42:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*   10145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10154 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   10157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*   10162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10169 */     GIR_RootConstrainSelectedInstOperands,
     /*   10170 */     // GIR_Coverage, 74500,
     /*   10170 */     GIR_EraseRootFromParent_Done,
     /*   10171 */   // Label 280: @10171
     /*   10171 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(10266), // Rule ID 74504 //
     /*   10176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10183 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:44:y
     /*   10187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10191 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:44:x
     /*   10195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10216 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*   10227 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10233 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:44:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:44:x)<<P:44:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*   10240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10249 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*   10252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*   10257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10264 */     GIR_RootConstrainSelectedInstOperands,
     /*   10265 */     // GIR_Coverage, 74504,
     /*   10265 */     GIR_EraseRootFromParent_Done,
     /*   10266 */   // Label 281: @10266
     /*   10266 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(10361), // Rule ID 74506 //
     /*   10271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10278 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:45:y
     /*   10282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10286 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:45:x
     /*   10290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10311 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*   10322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10328 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:45:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:45:x)<<P:45:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10340 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*   10347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*   10352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10359 */     GIR_RootConstrainSelectedInstOperands,
     /*   10360 */     // GIR_Coverage, 74506,
     /*   10360 */     GIR_EraseRootFromParent_Done,
     /*   10361 */   // Label 282: @10361
     /*   10361 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(10456), // Rule ID 74508 //
     /*   10366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10373 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:46:y
     /*   10377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10381 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:46:x
     /*   10385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10406 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*   10417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10423 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:46:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:46:x)<<P:46:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*   10430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10435 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10439 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*   10442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*   10447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10454 */     GIR_RootConstrainSelectedInstOperands,
     /*   10455 */     // GIR_Coverage, 74508,
     /*   10455 */     GIR_EraseRootFromParent_Done,
     /*   10456 */   // Label 283: @10456
     /*   10456 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(10551), // Rule ID 74510 //
     /*   10461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10468 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:47:y
     /*   10472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10476 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:47:x
     /*   10480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10501 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*   10512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10518 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:47:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:47:x)<<P:47:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10534 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   10537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*   10542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10549 */     GIR_RootConstrainSelectedInstOperands,
     /*   10550 */     // GIR_Coverage, 74510,
     /*   10550 */     GIR_EraseRootFromParent_Done,
     /*   10551 */   // Label 284: @10551
     /*   10551 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(10646), // Rule ID 74512 //
     /*   10556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10563 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:48:y
     /*   10567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10571 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:48:x
     /*   10575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10596 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*   10607 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10613 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:48:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:48:x)<<P:48:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10629 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*   10632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*   10637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10644 */     GIR_RootConstrainSelectedInstOperands,
     /*   10645 */     // GIR_Coverage, 74512,
     /*   10645 */     GIR_EraseRootFromParent_Done,
     /*   10646 */   // Label 285: @10646
     /*   10646 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(10741), // Rule ID 74514 //
     /*   10651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10658 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:49:y
     /*   10662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10666 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:49:x
     /*   10670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10691 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*   10702 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10708 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:49:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:49:x)<<P:49:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10724 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*   10727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*   10732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10739 */     GIR_RootConstrainSelectedInstOperands,
     /*   10740 */     // GIR_Coverage, 74514,
     /*   10740 */     GIR_EraseRootFromParent_Done,
     /*   10741 */   // Label 286: @10741
     /*   10741 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(10809), // Rule ID 65599 //
     /*   10746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10753 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*   10757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10761 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*   10765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10786 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   10790 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10796 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:1:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*   10799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10807 */     GIR_RootConstrainSelectedInstOperands,
     /*   10808 */     // GIR_Coverage, 65599,
     /*   10808 */     GIR_EraseRootFromParent_Done,
     /*   10809 */   // Label 287: @10809
     /*   10809 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(10877), // Rule ID 65607 //
     /*   10814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10821 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*   10825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10829 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*   10833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10854 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*   10858 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10864 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:3:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*   10867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10875 */     GIR_RootConstrainSelectedInstOperands,
     /*   10876 */     // GIR_Coverage, 65607,
     /*   10876 */     GIR_EraseRootFromParent_Done,
     /*   10877 */   // Label 288: @10877
     /*   10877 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(10945), // Rule ID 65615 //
     /*   10882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10889 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*   10893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10897 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*   10901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10922 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*   10926 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10932 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:5:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*   10935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10943 */     GIR_RootConstrainSelectedInstOperands,
     /*   10944 */     // GIR_Coverage, 65615,
     /*   10944 */     GIR_EraseRootFromParent_Done,
     /*   10945 */   // Label 289: @10945
     /*   10945 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(11013), // Rule ID 74459 //
     /*   10950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10957 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:28:y
     /*   10961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10965 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:28:x
     /*   10969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10990 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   10994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11000 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:28:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:28:x)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*   11003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11011 */     GIR_RootConstrainSelectedInstOperands,
     /*   11012 */     // GIR_Coverage, 74459,
     /*   11012 */     GIR_EraseRootFromParent_Done,
     /*   11013 */   // Label 290: @11013
     /*   11013 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(11081), // Rule ID 74467 //
     /*   11018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   11021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11025 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:30:y
     /*   11029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11033 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:30:x
     /*   11037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   11045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11058 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*   11062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   11066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11068 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:30:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:30:x)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*   11071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11079 */     GIR_RootConstrainSelectedInstOperands,
     /*   11080 */     // GIR_Coverage, 74467,
     /*   11080 */     GIR_EraseRootFromParent_Done,
     /*   11081 */   // Label 291: @11081
     /*   11081 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(11149), // Rule ID 74475 //
     /*   11086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   11089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11093 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:32:y
     /*   11097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11101 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:32:x
     /*   11105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   11113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11126 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*   11130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   11134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11136 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:32:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:32:x)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*   11139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11147 */     GIR_RootConstrainSelectedInstOperands,
     /*   11148 */     // GIR_Coverage, 74475,
     /*   11148 */     GIR_EraseRootFromParent_Done,
     /*   11149 */   // Label 292: @11149
     /*   11149 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(11228), // Rule ID 62539 //
     /*   11154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*   11157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11161 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*   11165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   11173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   11190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11194 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*   11198 */     // MIs[2] Operand 1
     /*   11198 */     // No operand predicates
     /*   11198 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*   11202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   11210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   11212 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i64] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*   11212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*   11215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   11219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   11223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*   11226 */     GIR_RootConstrainSelectedInstOperands,
     /*   11227 */     // GIR_Coverage, 62539,
     /*   11227 */     GIR_EraseRootFromParent_Done,
     /*   11228 */   // Label 293: @11228
     /*   11228 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(11307), // Rule ID 74433 //
     /*   11233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*   11236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11240 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*   11244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11248 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*   11252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   11260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   11277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11281 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*   11285 */     // MIs[2] Operand 1
     /*   11285 */     // No operand predicates
     /*   11285 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   11289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   11291 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:23:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*   11291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*   11294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   11302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*   11305 */     GIR_RootConstrainSelectedInstOperands,
     /*   11306 */     // GIR_Coverage, 74433,
     /*   11306 */     GIR_EraseRootFromParent_Done,
     /*   11307 */   // Label 294: @11307
     /*   11307 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(11356), // Rule ID 128 //
     /*   11312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*   11327 */     // MIs[1] Operand 1
     /*   11327 */     // No operand predicates
     /*   11327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   11331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11335 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   11339 */     // MIs[2] Operand 1
     /*   11339 */     // No operand predicates
     /*   11339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   11341 */     // (add:{ *:[i64] } (frameindex:{ *:[i64] }):$fi, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i64] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i64] }:$fi), (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)
     /*   11341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11346 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*   11351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*   11354 */     GIR_RootConstrainSelectedInstOperands,
     /*   11355 */     // GIR_Coverage, 128,
     /*   11355 */     GIR_EraseRootFromParent_Done,
     /*   11356 */   // Label 295: @11356
     /*   11356 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(11402), // Rule ID 283 //
     /*   11361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   11364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   11384 */     // MIs[1] Operand 1
     /*   11384 */     // No operand predicates
     /*   11384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10082),
     /*   11388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11390 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)<<P:Predicate_anonymous_10082>>  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   11390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   11393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   11400 */     GIR_RootConstrainSelectedInstOperands,
     /*   11401 */     // GIR_Coverage, 283,
     /*   11401 */     GIR_EraseRootFromParent_Done,
     /*   11402 */   // Label 296: @11402
     /*   11402 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(11478), // Rule ID 305 //
     /*   11407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   11410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*   11430 */     // MIs[1] Operand 1
     /*   11430 */     // No operand predicates
     /*   11430 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10110),
     /*   11434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10082),
     /*   11438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11440 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10110>>:$rs2)<<P:Predicate_anonymous_10082>>  =>  (ADDIW:{ *:[i64] } (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*   11440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   11443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   11447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   11456 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*   11461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   11466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11471 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*   11476 */     GIR_RootConstrainSelectedInstOperands,
     /*   11477 */     // GIR_Coverage, 305,
     /*   11477 */     GIR_EraseRootFromParent_Done,
     /*   11478 */   // Label 297: @11478
     /*   11478 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(11543), // Rule ID 74449 //
     /*   11483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   11486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10082),
     /*   11524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11526 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)<<P:Predicate_anonymous_10082>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*   11529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11541 */     GIR_RootConstrainSelectedInstOperands,
     /*   11542 */     // GIR_Coverage, 74449,
     /*   11542 */     GIR_EraseRootFromParent_Done,
     /*   11543 */   // Label 298: @11543
     /*   11543 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(11608), // Rule ID 62610 //
     /*   11548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   11551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10082),
     /*   11589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11591 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10082>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*   11594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11606 */     GIR_RootConstrainSelectedInstOperands,
     /*   11607 */     // GIR_Coverage, 62610,
     /*   11607 */     GIR_EraseRootFromParent_Done,
     /*   11608 */   // Label 299: @11608
     /*   11608 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(11650), // Rule ID 88 //
     /*   11613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   11636 */     // MIs[1] Operand 1
     /*   11636 */     // No operand predicates
     /*   11636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11638 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   11638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   11648 */     GIR_RootConstrainSelectedInstOperands,
     /*   11649 */     // GIR_Coverage, 88,
     /*   11649 */     GIR_EraseRootFromParent_Done,
     /*   11650 */   // Label 300: @11650
     /*   11650 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(11722), // Rule ID 303 //
     /*   11655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*   11678 */     // MIs[1] Operand 1
     /*   11678 */     // No operand predicates
     /*   11678 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10110),
     /*   11682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11684 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10110>>:$rs2)  =>  (ADDI:{ *:[i64] } (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*   11684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   11687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11696 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   11700 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*   11705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11715 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*   11720 */     GIR_RootConstrainSelectedInstOperands,
     /*   11721 */     // GIR_Coverage, 303,
     /*   11721 */     GIR_EraseRootFromParent_Done,
     /*   11722 */   // Label 301: @11722
     /*   11722 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(11783), // Rule ID 74447 //
     /*   11727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   11730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11766 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*   11769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11781 */     GIR_RootConstrainSelectedInstOperands,
     /*   11782 */     // GIR_Coverage, 74447,
     /*   11782 */     GIR_EraseRootFromParent_Done,
     /*   11783 */   // Label 302: @11783
     /*   11783 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(11844), // Rule ID 62606 //
     /*   11788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   11791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11827 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*   11830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11842 */     GIR_RootConstrainSelectedInstOperands,
     /*   11843 */     // GIR_Coverage, 62606,
     /*   11843 */     GIR_EraseRootFromParent_Done,
     /*   11844 */   // Label 303: @11844
     /*   11844 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(11875), // Rule ID 282 //
     /*   11849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   11852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11864 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10082),
     /*   11868 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10082>>  =>  (ADDW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADDW),
     /*   11873 */     GIR_RootConstrainSelectedInstOperands,
     /*   11874 */     // GIR_Coverage, 282,
     /*   11874 */     GIR_Done,
     /*   11875 */   // Label 304: @11875
     /*   11875 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(11902), // Rule ID 86 //
     /*   11880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11895 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*   11900 */     GIR_RootConstrainSelectedInstOperands,
     /*   11901 */     // GIR_Coverage, 86,
     /*   11901 */     GIR_Done,
     /*   11902 */   // Label 305: @11902
     /*   11902 */   GIM_Reject,
     /*   11903 */ // Label 198: @11903
     /*   11903 */ GIM_Reject,
     /*   11904 */ // Label 128: @11904
     /*   11904 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(12298),
     /*   11909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11919 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(11987), // Rule ID 69397 //
     /*   11924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11943 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11961 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11985 */     GIR_RootConstrainSelectedInstOperands,
     /*   11986 */     // GIR_Coverage, 69397,
     /*   11986 */     GIR_EraseRootFromParent_Done,
     /*   11987 */   // Label 307: @11987
     /*   11987 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(12055), // Rule ID 69398 //
     /*   11992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   12011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   12029 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   12032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   12038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   12042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12053 */     GIR_RootConstrainSelectedInstOperands,
     /*   12054 */     // GIR_Coverage, 69398,
     /*   12054 */     GIR_EraseRootFromParent_Done,
     /*   12055 */   // Label 308: @12055
     /*   12055 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(12123), // Rule ID 45930 //
     /*   12060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   12083 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   12097 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   12100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   12106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   12110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   12112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12121 */     GIR_RootConstrainSelectedInstOperands,
     /*   12122 */     // GIR_Coverage, 45930,
     /*   12122 */     GIR_EraseRootFromParent_Done,
     /*   12123 */   // Label 309: @12123
     /*   12123 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(12191), // Rule ID 45931 //
     /*   12128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   12151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   12165 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   12168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   12174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   12178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   12180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12189 */     GIR_RootConstrainSelectedInstOperands,
     /*   12190 */     // GIR_Coverage, 45931,
     /*   12190 */     GIR_EraseRootFromParent_Done,
     /*   12191 */   // Label 310: @12191
     /*   12191 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(12244), // Rule ID 45758 //
     /*   12196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12207 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   12207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   12210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*   12224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12242 */     GIR_RootConstrainSelectedInstOperands,
     /*   12243 */     // GIR_Coverage, 45758,
     /*   12243 */     GIR_EraseRootFromParent_Done,
     /*   12244 */   // Label 311: @12244
     /*   12244 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(12297), // Rule ID 45759 //
     /*   12249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12260 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   12260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   12263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*   12277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12295 */     GIR_RootConstrainSelectedInstOperands,
     /*   12296 */     // GIR_Coverage, 45759,
     /*   12296 */     GIR_EraseRootFromParent_Done,
     /*   12297 */   // Label 312: @12297
     /*   12297 */   GIM_Reject,
     /*   12298 */ // Label 306: @12298
     /*   12298 */ GIM_Reject,
     /*   12299 */ // Label 129: @12299
     /*   12299 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(15423),
     /*   12304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12314 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(12410), // Rule ID 69311 //
     /*   12319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12338 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12352 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12367 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12371 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12373 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12384 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12408 */     GIR_RootConstrainSelectedInstOperands,
     /*   12409 */     // GIR_Coverage, 69311,
     /*   12409 */     GIR_EraseRootFromParent_Done,
     /*   12410 */   // Label 314: @12410
     /*   12410 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(12506), // Rule ID 69312 //
     /*   12415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12434 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12448 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12463 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12467 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12469 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12480 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12504 */     GIR_RootConstrainSelectedInstOperands,
     /*   12505 */     // GIR_Coverage, 69312,
     /*   12505 */     GIR_EraseRootFromParent_Done,
     /*   12506 */   // Label 315: @12506
     /*   12506 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(12602), // Rule ID 71137 //
     /*   12511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12530 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12544 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12559 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12563 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12565 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12576 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12600 */     GIR_RootConstrainSelectedInstOperands,
     /*   12601 */     // GIR_Coverage, 71137,
     /*   12601 */     GIR_EraseRootFromParent_Done,
     /*   12602 */   // Label 316: @12602
     /*   12602 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(12698), // Rule ID 71138 //
     /*   12607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12626 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12640 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12655 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12659 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12661 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12670 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12672 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12696 */     GIR_RootConstrainSelectedInstOperands,
     /*   12697 */     // GIR_Coverage, 71138,
     /*   12697 */     GIR_EraseRootFromParent_Done,
     /*   12698 */   // Label 317: @12698
     /*   12698 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(12794), // Rule ID 71139 //
     /*   12703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12736 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12751 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12755 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12757 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12768 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12792 */     GIR_RootConstrainSelectedInstOperands,
     /*   12793 */     // GIR_Coverage, 71139,
     /*   12793 */     GIR_EraseRootFromParent_Done,
     /*   12794 */   // Label 318: @12794
     /*   12794 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(12890), // Rule ID 71140 //
     /*   12799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12818 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12832 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12847 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12851 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12853 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12864 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12888 */     GIR_RootConstrainSelectedInstOperands,
     /*   12889 */     // GIR_Coverage, 71140,
     /*   12889 */     GIR_EraseRootFromParent_Done,
     /*   12890 */   // Label 319: @12890
     /*   12890 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(12986), // Rule ID 71015 //
     /*   12895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12914 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12928 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12943 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12947 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12949 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12960 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   12963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12984 */     GIR_RootConstrainSelectedInstOperands,
     /*   12985 */     // GIR_Coverage, 71015,
     /*   12985 */     GIR_EraseRootFromParent_Done,
     /*   12986 */   // Label 320: @12986
     /*   12986 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(13082), // Rule ID 71016 //
     /*   12991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13010 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13024 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13039 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13043 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13045 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13056 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   13063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13080 */     GIR_RootConstrainSelectedInstOperands,
     /*   13081 */     // GIR_Coverage, 71016,
     /*   13081 */     GIR_EraseRootFromParent_Done,
     /*   13082 */   // Label 321: @13082
     /*   13082 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(13178), // Rule ID 45842 //
     /*   13087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13110 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13124 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13139 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13143 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13145 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13152 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   13155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13176 */     GIR_RootConstrainSelectedInstOperands,
     /*   13177 */     // GIR_Coverage, 45842,
     /*   13177 */     GIR_EraseRootFromParent_Done,
     /*   13178 */   // Label 322: @13178
     /*   13178 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(13274), // Rule ID 45843 //
     /*   13183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13220 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13235 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13239 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13241 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13248 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   13251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13272 */     GIR_RootConstrainSelectedInstOperands,
     /*   13273 */     // GIR_Coverage, 45843,
     /*   13273 */     GIR_EraseRootFromParent_Done,
     /*   13274 */   // Label 323: @13274
     /*   13274 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(13370), // Rule ID 52162 //
     /*   13279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13302 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13316 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13331 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13335 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13337 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13344 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13368 */     GIR_RootConstrainSelectedInstOperands,
     /*   13369 */     // GIR_Coverage, 52162,
     /*   13369 */     GIR_EraseRootFromParent_Done,
     /*   13370 */   // Label 324: @13370
     /*   13370 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(13466), // Rule ID 52163 //
     /*   13375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13398 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13412 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13427 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13431 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13433 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13440 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13464 */     GIR_RootConstrainSelectedInstOperands,
     /*   13465 */     // GIR_Coverage, 52163,
     /*   13465 */     GIR_EraseRootFromParent_Done,
     /*   13466 */   // Label 325: @13466
     /*   13466 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(13562), // Rule ID 71135 //
     /*   13471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13494 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13508 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13527 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13529 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13534 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13536 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   13547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   13551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13560 */     GIR_RootConstrainSelectedInstOperands,
     /*   13561 */     // GIR_Coverage, 71135,
     /*   13561 */     GIR_EraseRootFromParent_Done,
     /*   13562 */   // Label 326: @13562
     /*   13562 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(13658), // Rule ID 71136 //
     /*   13567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13590 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13604 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13623 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13625 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13632 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   13643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   13647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13656 */     GIR_RootConstrainSelectedInstOperands,
     /*   13657 */     // GIR_Coverage, 71136,
     /*   13657 */     GIR_EraseRootFromParent_Done,
     /*   13658 */   // Label 327: @13658
     /*   13658 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(13754), // Rule ID 52102 //
     /*   13663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13686 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13700 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13715 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13719 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13721 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13728 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13752 */     GIR_RootConstrainSelectedInstOperands,
     /*   13753 */     // GIR_Coverage, 52102,
     /*   13753 */     GIR_EraseRootFromParent_Done,
     /*   13754 */   // Label 328: @13754
     /*   13754 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(13850), // Rule ID 52103 //
     /*   13759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13796 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13811 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13815 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13817 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13824 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13848 */     GIR_RootConstrainSelectedInstOperands,
     /*   13849 */     // GIR_Coverage, 52103,
     /*   13849 */     GIR_EraseRootFromParent_Done,
     /*   13850 */   // Label 329: @13850
     /*   13850 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(13939), // Rule ID 46688 //
     /*   13855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13870 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13889 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13898 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13937 */     GIR_RootConstrainSelectedInstOperands,
     /*   13938 */     // GIR_Coverage, 46688,
     /*   13938 */     GIR_EraseRootFromParent_Done,
     /*   13939 */   // Label 330: @13939
     /*   13939 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(14028), // Rule ID 46689 //
     /*   13944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13959 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13978 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13987 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   14004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   14013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14026 */     GIR_RootConstrainSelectedInstOperands,
     /*   14027 */     // GIR_Coverage, 46689,
     /*   14027 */     GIR_EraseRootFromParent_Done,
     /*   14028 */   // Label 331: @14028
     /*   14028 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(14117), // Rule ID 45834 //
     /*   14033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14048 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   14059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14067 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   14076 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   14076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*   14093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   14102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14115 */     GIR_RootConstrainSelectedInstOperands,
     /*   14116 */     // GIR_Coverage, 45834,
     /*   14116 */     GIR_EraseRootFromParent_Done,
     /*   14117 */   // Label 332: @14117
     /*   14117 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(14206), // Rule ID 45835 //
     /*   14122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14137 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   14148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14156 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   14165 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   14165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*   14182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   14191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14204 */     GIR_RootConstrainSelectedInstOperands,
     /*   14205 */     // GIR_Coverage, 45835,
     /*   14205 */     GIR_EraseRootFromParent_Done,
     /*   14206 */   // Label 333: @14206
     /*   14206 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(14295), // Rule ID 46568 //
     /*   14211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14226 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   14237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14245 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   14254 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   14254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   14271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   14280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14293 */     GIR_RootConstrainSelectedInstOperands,
     /*   14294 */     // GIR_Coverage, 46568,
     /*   14294 */     GIR_EraseRootFromParent_Done,
     /*   14295 */   // Label 334: @14295
     /*   14295 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(14384), // Rule ID 46569 //
     /*   14300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14315 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   14326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14334 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   14343 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   14343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   14360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   14369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14382 */     GIR_RootConstrainSelectedInstOperands,
     /*   14383 */     // GIR_Coverage, 46569,
     /*   14383 */     GIR_EraseRootFromParent_Done,
     /*   14384 */   // Label 335: @14384
     /*   14384 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(14452), // Rule ID 70707 //
     /*   14389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14408 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14426 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   14426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14450 */     GIR_RootConstrainSelectedInstOperands,
     /*   14451 */     // GIR_Coverage, 70707,
     /*   14451 */     GIR_EraseRootFromParent_Done,
     /*   14452 */   // Label 336: @14452
     /*   14452 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(14520), // Rule ID 70708 //
     /*   14457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14476 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14494 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   14494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14518 */     GIR_RootConstrainSelectedInstOperands,
     /*   14519 */     // GIR_Coverage, 70708,
     /*   14519 */     GIR_EraseRootFromParent_Done,
     /*   14520 */   // Label 337: @14520
     /*   14520 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(14575), // Rule ID 69699 //
     /*   14525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14540 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14553 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14573 */     GIR_RootConstrainSelectedInstOperands,
     /*   14574 */     // GIR_Coverage, 69699,
     /*   14574 */     GIR_EraseRootFromParent_Done,
     /*   14575 */   // Label 338: @14575
     /*   14575 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(14630), // Rule ID 69700 //
     /*   14580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14595 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14608 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14628 */     GIR_RootConstrainSelectedInstOperands,
     /*   14629 */     // GIR_Coverage, 69700,
     /*   14629 */     GIR_EraseRootFromParent_Done,
     /*   14630 */   // Label 339: @14630
     /*   14630 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(14685), // Rule ID 69307 //
     /*   14635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14650 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14663 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14683 */     GIR_RootConstrainSelectedInstOperands,
     /*   14684 */     // GIR_Coverage, 69307,
     /*   14684 */     GIR_EraseRootFromParent_Done,
     /*   14685 */   // Label 340: @14685
     /*   14685 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(14740), // Rule ID 69308 //
     /*   14690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14705 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14718 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14738 */     GIR_RootConstrainSelectedInstOperands,
     /*   14739 */     // GIR_Coverage, 69308,
     /*   14739 */     GIR_EraseRootFromParent_Done,
     /*   14740 */   // Label 341: @14740
     /*   14740 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(14795), // Rule ID 69609 //
     /*   14745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14760 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14773 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14793 */     GIR_RootConstrainSelectedInstOperands,
     /*   14794 */     // GIR_Coverage, 69609,
     /*   14794 */     GIR_EraseRootFromParent_Done,
     /*   14795 */   // Label 342: @14795
     /*   14795 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(14850), // Rule ID 69610 //
     /*   14800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14815 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14828 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14848 */     GIR_RootConstrainSelectedInstOperands,
     /*   14849 */     // GIR_Coverage, 69610,
     /*   14849 */     GIR_EraseRootFromParent_Done,
     /*   14850 */   // Label 343: @14850
     /*   14850 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(14918), // Rule ID 51882 //
     /*   14855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14878 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14892 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   14892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14916 */     GIR_RootConstrainSelectedInstOperands,
     /*   14917 */     // GIR_Coverage, 51882,
     /*   14917 */     GIR_EraseRootFromParent_Done,
     /*   14918 */   // Label 344: @14918
     /*   14918 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(14986), // Rule ID 51883 //
     /*   14923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14960 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   14960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14984 */     GIR_RootConstrainSelectedInstOperands,
     /*   14985 */     // GIR_Coverage, 51883,
     /*   14985 */     GIR_EraseRootFromParent_Done,
     /*   14986 */   // Label 345: @14986
     /*   14986 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(15041), // Rule ID 46748 //
     /*   14991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   15006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15010 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   15019 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   15019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   15022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   15026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   15030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15039 */     GIR_RootConstrainSelectedInstOperands,
     /*   15040 */     // GIR_Coverage, 46748,
     /*   15040 */     GIR_EraseRootFromParent_Done,
     /*   15041 */   // Label 346: @15041
     /*   15041 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(15096), // Rule ID 46749 //
     /*   15046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   15061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   15074 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   15074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   15077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   15081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   15085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15094 */     GIR_RootConstrainSelectedInstOperands,
     /*   15095 */     // GIR_Coverage, 46749,
     /*   15095 */     GIR_EraseRootFromParent_Done,
     /*   15096 */   // Label 347: @15096
     /*   15096 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(15151), // Rule ID 45838 //
     /*   15101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15120 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   15129 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   15129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   15132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   15136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   15140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15149 */     GIR_RootConstrainSelectedInstOperands,
     /*   15150 */     // GIR_Coverage, 45838,
     /*   15150 */     GIR_EraseRootFromParent_Done,
     /*   15151 */   // Label 348: @15151
     /*   15151 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15206), // Rule ID 45839 //
     /*   15156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   15184 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   15184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   15187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   15191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   15195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15204 */     GIR_RootConstrainSelectedInstOperands,
     /*   15205 */     // GIR_Coverage, 45839,
     /*   15205 */     GIR_EraseRootFromParent_Done,
     /*   15206 */   // Label 349: @15206
     /*   15206 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15261), // Rule ID 46628 //
     /*   15211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15230 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   15239 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   15239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   15242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   15246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   15250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15259 */     GIR_RootConstrainSelectedInstOperands,
     /*   15260 */     // GIR_Coverage, 46628,
     /*   15260 */     GIR_EraseRootFromParent_Done,
     /*   15261 */   // Label 350: @15261
     /*   15261 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15316), // Rule ID 46629 //
     /*   15266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15285 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   15294 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   15294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   15297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   15301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   15305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15314 */     GIR_RootConstrainSelectedInstOperands,
     /*   15315 */     // GIR_Coverage, 46629,
     /*   15315 */     GIR_EraseRootFromParent_Done,
     /*   15316 */   // Label 351: @15316
     /*   15316 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15369), // Rule ID 46114 //
     /*   15321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15332 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   15332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   15335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   15349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15367 */     GIR_RootConstrainSelectedInstOperands,
     /*   15368 */     // GIR_Coverage, 46114,
     /*   15368 */     GIR_EraseRootFromParent_Done,
     /*   15369 */   // Label 352: @15369
     /*   15369 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15422), // Rule ID 46115 //
     /*   15374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15385 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   15385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   15388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   15402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15420 */     GIR_RootConstrainSelectedInstOperands,
     /*   15421 */     // GIR_Coverage, 46115,
     /*   15421 */     GIR_EraseRootFromParent_Done,
     /*   15422 */   // Label 353: @15422
     /*   15422 */   GIM_Reject,
     /*   15423 */ // Label 313: @15423
     /*   15423 */ GIM_Reject,
     /*   15424 */ // Label 130: @15424
     /*   15424 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(18548),
     /*   15429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15439 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15535), // Rule ID 70913 //
     /*   15444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15463 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15477 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15492 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15496 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15498 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15507 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15509 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15533 */     GIR_RootConstrainSelectedInstOperands,
     /*   15534 */     // GIR_Coverage, 70913,
     /*   15534 */     GIR_EraseRootFromParent_Done,
     /*   15535 */   // Label 355: @15535
     /*   15535 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(15631), // Rule ID 70914 //
     /*   15540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15559 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15573 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15588 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15592 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15594 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15605 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15629 */     GIR_RootConstrainSelectedInstOperands,
     /*   15630 */     // GIR_Coverage, 70914,
     /*   15630 */     GIR_EraseRootFromParent_Done,
     /*   15631 */   // Label 356: @15631
     /*   15631 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(15727), // Rule ID 71173 //
     /*   15636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15655 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15669 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15671 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15684 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15688 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15690 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15701 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15725 */     GIR_RootConstrainSelectedInstOperands,
     /*   15726 */     // GIR_Coverage, 71173,
     /*   15726 */     GIR_EraseRootFromParent_Done,
     /*   15727 */   // Label 357: @15727
     /*   15727 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(15823), // Rule ID 71174 //
     /*   15732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15751 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15765 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15780 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15784 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15786 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15797 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15821 */     GIR_RootConstrainSelectedInstOperands,
     /*   15822 */     // GIR_Coverage, 71174,
     /*   15822 */     GIR_EraseRootFromParent_Done,
     /*   15823 */   // Label 358: @15823
     /*   15823 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(15919), // Rule ID 71175 //
     /*   15828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15847 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15861 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15876 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15880 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15882 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15891 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15893 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15917 */     GIR_RootConstrainSelectedInstOperands,
     /*   15918 */     // GIR_Coverage, 71175,
     /*   15918 */     GIR_EraseRootFromParent_Done,
     /*   15919 */   // Label 359: @15919
     /*   15919 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16015), // Rule ID 71176 //
     /*   15924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15943 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15957 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15959 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15976 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15978 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15989 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16013 */     GIR_RootConstrainSelectedInstOperands,
     /*   16014 */     // GIR_Coverage, 71176,
     /*   16014 */     GIR_EraseRootFromParent_Done,
     /*   16015 */   // Label 360: @16015
     /*   16015 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16111), // Rule ID 71027 //
     /*   16020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16039 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16053 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16068 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16072 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16074 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16085 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   16092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16109 */     GIR_RootConstrainSelectedInstOperands,
     /*   16110 */     // GIR_Coverage, 71027,
     /*   16110 */     GIR_EraseRootFromParent_Done,
     /*   16111 */   // Label 361: @16111
     /*   16111 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16207), // Rule ID 71028 //
     /*   16116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16135 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16149 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16168 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16170 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16179 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16181 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   16188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16205 */     GIR_RootConstrainSelectedInstOperands,
     /*   16206 */     // GIR_Coverage, 71028,
     /*   16206 */     GIR_EraseRootFromParent_Done,
     /*   16207 */   // Label 362: @16207
     /*   16207 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16303), // Rule ID 52056 //
     /*   16212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16235 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16249 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16264 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16268 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16270 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16277 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   16280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16301 */     GIR_RootConstrainSelectedInstOperands,
     /*   16302 */     // GIR_Coverage, 52056,
     /*   16302 */     GIR_EraseRootFromParent_Done,
     /*   16303 */   // Label 363: @16303
     /*   16303 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16399), // Rule ID 52057 //
     /*   16308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16331 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16345 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16360 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16364 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16366 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16373 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   16376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16397 */     GIR_RootConstrainSelectedInstOperands,
     /*   16398 */     // GIR_Coverage, 52057,
     /*   16398 */     GIR_EraseRootFromParent_Done,
     /*   16399 */   // Label 364: @16399
     /*   16399 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16495), // Rule ID 52174 //
     /*   16404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16427 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16441 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16456 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16460 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16462 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16469 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16493 */     GIR_RootConstrainSelectedInstOperands,
     /*   16494 */     // GIR_Coverage, 52174,
     /*   16494 */     GIR_EraseRootFromParent_Done,
     /*   16495 */   // Label 365: @16495
     /*   16495 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16591), // Rule ID 52175 //
     /*   16500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16523 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16537 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16552 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16556 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16558 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16565 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16589 */     GIR_RootConstrainSelectedInstOperands,
     /*   16590 */     // GIR_Coverage, 52175,
     /*   16590 */     GIR_EraseRootFromParent_Done,
     /*   16591 */   // Label 366: @16591
     /*   16591 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16687), // Rule ID 71171 //
     /*   16596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16619 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16633 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16644 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16648 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16652 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16654 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16661 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16685 */     GIR_RootConstrainSelectedInstOperands,
     /*   16686 */     // GIR_Coverage, 71171,
     /*   16686 */     GIR_EraseRootFromParent_Done,
     /*   16687 */   // Label 367: @16687
     /*   16687 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16783), // Rule ID 71172 //
     /*   16692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16715 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16729 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16731 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16744 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16748 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16750 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16757 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16781 */     GIR_RootConstrainSelectedInstOperands,
     /*   16782 */     // GIR_Coverage, 71172,
     /*   16782 */     GIR_EraseRootFromParent_Done,
     /*   16783 */   // Label 368: @16783
     /*   16783 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16879), // Rule ID 52114 //
     /*   16788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16825 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16840 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16844 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16846 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16853 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16877 */     GIR_RootConstrainSelectedInstOperands,
     /*   16878 */     // GIR_Coverage, 52114,
     /*   16878 */     GIR_EraseRootFromParent_Done,
     /*   16879 */   // Label 369: @16879
     /*   16879 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(16975), // Rule ID 52115 //
     /*   16884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16907 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16921 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16936 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16940 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16942 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16949 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16973 */     GIR_RootConstrainSelectedInstOperands,
     /*   16974 */     // GIR_Coverage, 52115,
     /*   16974 */     GIR_EraseRootFromParent_Done,
     /*   16975 */   // Label 370: @16975
     /*   16975 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17064), // Rule ID 46712 //
     /*   16980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16995 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   17006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17014 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17023 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   17023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   17040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17062 */     GIR_RootConstrainSelectedInstOperands,
     /*   17063 */     // GIR_Coverage, 46712,
     /*   17063 */     GIR_EraseRootFromParent_Done,
     /*   17064 */   // Label 371: @17064
     /*   17064 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17153), // Rule ID 46713 //
     /*   17069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17084 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   17095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17103 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17112 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   17112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   17129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17151 */     GIR_RootConstrainSelectedInstOperands,
     /*   17152 */     // GIR_Coverage, 46713,
     /*   17152 */     GIR_EraseRootFromParent_Done,
     /*   17153 */   // Label 372: @17153
     /*   17153 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17242), // Rule ID 46476 //
     /*   17158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17173 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   17184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17192 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17201 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   17201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   17218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17240 */     GIR_RootConstrainSelectedInstOperands,
     /*   17241 */     // GIR_Coverage, 46476,
     /*   17241 */     GIR_EraseRootFromParent_Done,
     /*   17242 */   // Label 373: @17242
     /*   17242 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17331), // Rule ID 46477 //
     /*   17247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17262 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   17273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17281 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17290 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   17290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   17307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17329 */     GIR_RootConstrainSelectedInstOperands,
     /*   17330 */     // GIR_Coverage, 46477,
     /*   17330 */     GIR_EraseRootFromParent_Done,
     /*   17331 */   // Label 374: @17331
     /*   17331 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17420), // Rule ID 46592 //
     /*   17336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17351 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   17362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17370 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17379 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   17379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   17396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17418 */     GIR_RootConstrainSelectedInstOperands,
     /*   17419 */     // GIR_Coverage, 46592,
     /*   17419 */     GIR_EraseRootFromParent_Done,
     /*   17420 */   // Label 375: @17420
     /*   17420 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17509), // Rule ID 46593 //
     /*   17425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17440 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   17451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17459 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17468 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   17468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   17485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17507 */     GIR_RootConstrainSelectedInstOperands,
     /*   17508 */     // GIR_Coverage, 46593,
     /*   17508 */     GIR_EraseRootFromParent_Done,
     /*   17509 */   // Label 376: @17509
     /*   17509 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17577), // Rule ID 70723 //
     /*   17514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17533 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17551 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   17551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17575 */     GIR_RootConstrainSelectedInstOperands,
     /*   17576 */     // GIR_Coverage, 70723,
     /*   17576 */     GIR_EraseRootFromParent_Done,
     /*   17577 */   // Label 377: @17577
     /*   17577 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17645), // Rule ID 70724 //
     /*   17582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17601 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17619 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   17619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17643 */     GIR_RootConstrainSelectedInstOperands,
     /*   17644 */     // GIR_Coverage, 70724,
     /*   17644 */     GIR_EraseRootFromParent_Done,
     /*   17645 */   // Label 378: @17645
     /*   17645 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17700), // Rule ID 69723 //
     /*   17650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17665 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17678 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17698 */     GIR_RootConstrainSelectedInstOperands,
     /*   17699 */     // GIR_Coverage, 69723,
     /*   17699 */     GIR_EraseRootFromParent_Done,
     /*   17700 */   // Label 379: @17700
     /*   17700 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17755), // Rule ID 69724 //
     /*   17705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17720 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17733 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17753 */     GIR_RootConstrainSelectedInstOperands,
     /*   17754 */     // GIR_Coverage, 69724,
     /*   17754 */     GIR_EraseRootFromParent_Done,
     /*   17755 */   // Label 380: @17755
     /*   17755 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17810), // Rule ID 69543 //
     /*   17760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17775 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17788 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17808 */     GIR_RootConstrainSelectedInstOperands,
     /*   17809 */     // GIR_Coverage, 69543,
     /*   17809 */     GIR_EraseRootFromParent_Done,
     /*   17810 */   // Label 381: @17810
     /*   17810 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17865), // Rule ID 69544 //
     /*   17815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17830 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17843 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17863 */     GIR_RootConstrainSelectedInstOperands,
     /*   17864 */     // GIR_Coverage, 69544,
     /*   17864 */     GIR_EraseRootFromParent_Done,
     /*   17865 */   // Label 382: @17865
     /*   17865 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17920), // Rule ID 69633 //
     /*   17870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17885 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17898 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17918 */     GIR_RootConstrainSelectedInstOperands,
     /*   17919 */     // GIR_Coverage, 69633,
     /*   17919 */     GIR_EraseRootFromParent_Done,
     /*   17920 */   // Label 383: @17920
     /*   17920 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17975), // Rule ID 69634 //
     /*   17925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17940 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17953 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17973 */     GIR_RootConstrainSelectedInstOperands,
     /*   17974 */     // GIR_Coverage, 69634,
     /*   17974 */     GIR_EraseRootFromParent_Done,
     /*   17975 */   // Label 384: @17975
     /*   17975 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(18043), // Rule ID 51890 //
     /*   17980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   18003 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18017 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   18020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   18026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18041 */     GIR_RootConstrainSelectedInstOperands,
     /*   18042 */     // GIR_Coverage, 51890,
     /*   18042 */     GIR_EraseRootFromParent_Done,
     /*   18043 */   // Label 385: @18043
     /*   18043 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(18111), // Rule ID 51891 //
     /*   18048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   18071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18085 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   18088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   18094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18109 */     GIR_RootConstrainSelectedInstOperands,
     /*   18110 */     // GIR_Coverage, 51891,
     /*   18110 */     GIR_EraseRootFromParent_Done,
     /*   18111 */   // Label 386: @18111
     /*   18111 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18166), // Rule ID 46772 //
     /*   18116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   18131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18135 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18144 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   18144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   18147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18164 */     GIR_RootConstrainSelectedInstOperands,
     /*   18165 */     // GIR_Coverage, 46772,
     /*   18165 */     GIR_EraseRootFromParent_Done,
     /*   18166 */   // Label 387: @18166
     /*   18166 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18221), // Rule ID 46773 //
     /*   18171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   18186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18190 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18199 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   18199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   18202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18219 */     GIR_RootConstrainSelectedInstOperands,
     /*   18220 */     // GIR_Coverage, 46773,
     /*   18220 */     GIR_EraseRootFromParent_Done,
     /*   18221 */   // Label 388: @18221
     /*   18221 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18276), // Rule ID 46532 //
     /*   18226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18245 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18254 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   18254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   18257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18274 */     GIR_RootConstrainSelectedInstOperands,
     /*   18275 */     // GIR_Coverage, 46532,
     /*   18275 */     GIR_EraseRootFromParent_Done,
     /*   18276 */   // Label 389: @18276
     /*   18276 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18331), // Rule ID 46533 //
     /*   18281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18300 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18309 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   18309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   18312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18329 */     GIR_RootConstrainSelectedInstOperands,
     /*   18330 */     // GIR_Coverage, 46533,
     /*   18330 */     GIR_EraseRootFromParent_Done,
     /*   18331 */   // Label 390: @18331
     /*   18331 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18386), // Rule ID 46652 //
     /*   18336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18355 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18364 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   18364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   18367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18384 */     GIR_RootConstrainSelectedInstOperands,
     /*   18385 */     // GIR_Coverage, 46652,
     /*   18385 */     GIR_EraseRootFromParent_Done,
     /*   18386 */   // Label 391: @18386
     /*   18386 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18441), // Rule ID 46653 //
     /*   18391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18410 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18419 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   18419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   18422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18439 */     GIR_RootConstrainSelectedInstOperands,
     /*   18440 */     // GIR_Coverage, 46653,
     /*   18440 */     GIR_EraseRootFromParent_Done,
     /*   18441 */   // Label 392: @18441
     /*   18441 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18494), // Rule ID 46122 //
     /*   18446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18457 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   18457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   18460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   18474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18492 */     GIR_RootConstrainSelectedInstOperands,
     /*   18493 */     // GIR_Coverage, 46122,
     /*   18493 */     GIR_EraseRootFromParent_Done,
     /*   18494 */   // Label 393: @18494
     /*   18494 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18547), // Rule ID 46123 //
     /*   18499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18510 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   18510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   18513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   18527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18545 */     GIR_RootConstrainSelectedInstOperands,
     /*   18546 */     // GIR_Coverage, 46123,
     /*   18546 */     GIR_EraseRootFromParent_Done,
     /*   18547 */   // Label 394: @18547
     /*   18547 */   GIM_Reject,
     /*   18548 */ // Label 354: @18548
     /*   18548 */ GIM_Reject,
     /*   18549 */ // Label 131: @18549
     /*   18549 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(21673),
     /*   18554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18564 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18660), // Rule ID 70923 //
     /*   18569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18588 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18602 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18617 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18621 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18623 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18634 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18658 */     GIR_RootConstrainSelectedInstOperands,
     /*   18659 */     // GIR_Coverage, 70923,
     /*   18659 */     GIR_EraseRootFromParent_Done,
     /*   18660 */   // Label 396: @18660
     /*   18660 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18756), // Rule ID 70924 //
     /*   18665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18684 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18698 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18709 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18713 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18717 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18719 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18730 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18754 */     GIR_RootConstrainSelectedInstOperands,
     /*   18755 */     // GIR_Coverage, 70924,
     /*   18755 */     GIR_EraseRootFromParent_Done,
     /*   18756 */   // Label 397: @18756
     /*   18756 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18852), // Rule ID 71203 //
     /*   18761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18780 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18794 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18809 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18813 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18815 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18826 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18850 */     GIR_RootConstrainSelectedInstOperands,
     /*   18851 */     // GIR_Coverage, 71203,
     /*   18851 */     GIR_EraseRootFromParent_Done,
     /*   18852 */   // Label 398: @18852
     /*   18852 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18948), // Rule ID 71204 //
     /*   18857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18876 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18890 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18905 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18909 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18911 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18922 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18946 */     GIR_RootConstrainSelectedInstOperands,
     /*   18947 */     // GIR_Coverage, 71204,
     /*   18947 */     GIR_EraseRootFromParent_Done,
     /*   18948 */   // Label 399: @18948
     /*   18948 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(19044), // Rule ID 71205 //
     /*   18953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18972 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18986 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18988 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19001 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19005 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19007 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19018 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   19025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19042 */     GIR_RootConstrainSelectedInstOperands,
     /*   19043 */     // GIR_Coverage, 71205,
     /*   19043 */     GIR_EraseRootFromParent_Done,
     /*   19044 */   // Label 400: @19044
     /*   19044 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(19140), // Rule ID 71206 //
     /*   19049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19068 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19082 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19097 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19101 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19103 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19114 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   19121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19138 */     GIR_RootConstrainSelectedInstOperands,
     /*   19139 */     // GIR_Coverage, 71206,
     /*   19139 */     GIR_EraseRootFromParent_Done,
     /*   19140 */   // Label 401: @19140
     /*   19140 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(19236), // Rule ID 71037 //
     /*   19145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19164 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19178 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19193 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19197 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19199 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19210 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   19217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19234 */     GIR_RootConstrainSelectedInstOperands,
     /*   19235 */     // GIR_Coverage, 71037,
     /*   19235 */     GIR_EraseRootFromParent_Done,
     /*   19236 */   // Label 402: @19236
     /*   19236 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(19332), // Rule ID 71038 //
     /*   19241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19260 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19274 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19289 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19293 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19295 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19306 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   19313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19330 */     GIR_RootConstrainSelectedInstOperands,
     /*   19331 */     // GIR_Coverage, 71038,
     /*   19331 */     GIR_EraseRootFromParent_Done,
     /*   19332 */   // Label 403: @19332
     /*   19332 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(19428), // Rule ID 52066 //
     /*   19337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19360 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19374 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19389 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19393 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19395 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19402 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   19405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19426 */     GIR_RootConstrainSelectedInstOperands,
     /*   19427 */     // GIR_Coverage, 52066,
     /*   19427 */     GIR_EraseRootFromParent_Done,
     /*   19428 */   // Label 404: @19428
     /*   19428 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(19524), // Rule ID 52067 //
     /*   19433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19456 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19470 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19485 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19489 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19491 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19498 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   19501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19522 */     GIR_RootConstrainSelectedInstOperands,
     /*   19523 */     // GIR_Coverage, 52067,
     /*   19523 */     GIR_EraseRootFromParent_Done,
     /*   19524 */   // Label 405: @19524
     /*   19524 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(19620), // Rule ID 52184 //
     /*   19529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19566 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19581 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19585 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19587 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19594 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19618 */     GIR_RootConstrainSelectedInstOperands,
     /*   19619 */     // GIR_Coverage, 52184,
     /*   19619 */     GIR_EraseRootFromParent_Done,
     /*   19620 */   // Label 406: @19620
     /*   19620 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(19716), // Rule ID 52185 //
     /*   19625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19648 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19662 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19677 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19681 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19683 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19690 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19714 */     GIR_RootConstrainSelectedInstOperands,
     /*   19715 */     // GIR_Coverage, 52185,
     /*   19715 */     GIR_EraseRootFromParent_Done,
     /*   19716 */   // Label 407: @19716
     /*   19716 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(19812), // Rule ID 71201 //
     /*   19721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19744 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19758 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19777 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19779 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19786 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19810 */     GIR_RootConstrainSelectedInstOperands,
     /*   19811 */     // GIR_Coverage, 71201,
     /*   19811 */     GIR_EraseRootFromParent_Done,
     /*   19812 */   // Label 408: @19812
     /*   19812 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(19908), // Rule ID 71202 //
     /*   19817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19840 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19854 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19856 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19869 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19873 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19875 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19882 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19906 */     GIR_RootConstrainSelectedInstOperands,
     /*   19907 */     // GIR_Coverage, 71202,
     /*   19907 */     GIR_EraseRootFromParent_Done,
     /*   19908 */   // Label 409: @19908
     /*   19908 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(20004), // Rule ID 52124 //
     /*   19913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19936 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19950 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19965 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19969 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19971 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19978 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20002 */     GIR_RootConstrainSelectedInstOperands,
     /*   20003 */     // GIR_Coverage, 52124,
     /*   20003 */     GIR_EraseRootFromParent_Done,
     /*   20004 */   // Label 410: @20004
     /*   20004 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(20100), // Rule ID 52125 //
     /*   20009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   20038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20046 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   20057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20065 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   20067 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   20074 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   20077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   20081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   20089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20098 */     GIR_RootConstrainSelectedInstOperands,
     /*   20099 */     // GIR_Coverage, 52125,
     /*   20099 */     GIR_EraseRootFromParent_Done,
     /*   20100 */   // Label 411: @20100
     /*   20100 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(20189), // Rule ID 46732 //
     /*   20105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20120 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20139 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20148 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   20148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20187 */     GIR_RootConstrainSelectedInstOperands,
     /*   20188 */     // GIR_Coverage, 46732,
     /*   20188 */     GIR_EraseRootFromParent_Done,
     /*   20189 */   // Label 412: @20189
     /*   20189 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(20278), // Rule ID 46733 //
     /*   20194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20209 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20228 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20237 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   20237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20276 */     GIR_RootConstrainSelectedInstOperands,
     /*   20277 */     // GIR_Coverage, 46733,
     /*   20277 */     GIR_EraseRootFromParent_Done,
     /*   20278 */   // Label 413: @20278
     /*   20278 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(20367), // Rule ID 46496 //
     /*   20283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20298 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20317 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20326 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   20326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   20343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20365 */     GIR_RootConstrainSelectedInstOperands,
     /*   20366 */     // GIR_Coverage, 46496,
     /*   20366 */     GIR_EraseRootFromParent_Done,
     /*   20367 */   // Label 414: @20367
     /*   20367 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(20456), // Rule ID 46497 //
     /*   20372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20387 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20406 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20408 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20415 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   20415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   20432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20454 */     GIR_RootConstrainSelectedInstOperands,
     /*   20455 */     // GIR_Coverage, 46497,
     /*   20455 */     GIR_EraseRootFromParent_Done,
     /*   20456 */   // Label 415: @20456
     /*   20456 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(20545), // Rule ID 46612 //
     /*   20461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20476 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20495 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20504 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   20504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20543 */     GIR_RootConstrainSelectedInstOperands,
     /*   20544 */     // GIR_Coverage, 46612,
     /*   20544 */     GIR_EraseRootFromParent_Done,
     /*   20545 */   // Label 416: @20545
     /*   20545 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(20634), // Rule ID 46613 //
     /*   20550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20565 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20584 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20593 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   20593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20632 */     GIR_RootConstrainSelectedInstOperands,
     /*   20633 */     // GIR_Coverage, 46613,
     /*   20633 */     GIR_EraseRootFromParent_Done,
     /*   20634 */   // Label 417: @20634
     /*   20634 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(20702), // Rule ID 70755 //
     /*   20639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   20642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20658 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20676 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   20676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20700 */     GIR_RootConstrainSelectedInstOperands,
     /*   20701 */     // GIR_Coverage, 70755,
     /*   20701 */     GIR_EraseRootFromParent_Done,
     /*   20702 */   // Label 418: @20702
     /*   20702 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(20770), // Rule ID 70756 //
     /*   20707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   20710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20744 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   20744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20768 */     GIR_RootConstrainSelectedInstOperands,
     /*   20769 */     // GIR_Coverage, 70756,
     /*   20769 */     GIR_EraseRootFromParent_Done,
     /*   20770 */   // Label 419: @20770
     /*   20770 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(20825), // Rule ID 69743 //
     /*   20775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20803 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20823 */     GIR_RootConstrainSelectedInstOperands,
     /*   20824 */     // GIR_Coverage, 69743,
     /*   20824 */     GIR_EraseRootFromParent_Done,
     /*   20825 */   // Label 420: @20825
     /*   20825 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(20880), // Rule ID 69744 //
     /*   20830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20845 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20858 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20878 */     GIR_RootConstrainSelectedInstOperands,
     /*   20879 */     // GIR_Coverage, 69744,
     /*   20879 */     GIR_EraseRootFromParent_Done,
     /*   20880 */   // Label 421: @20880
     /*   20880 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(20935), // Rule ID 69563 //
     /*   20885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20900 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20913 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20933 */     GIR_RootConstrainSelectedInstOperands,
     /*   20934 */     // GIR_Coverage, 69563,
     /*   20934 */     GIR_EraseRootFromParent_Done,
     /*   20935 */   // Label 422: @20935
     /*   20935 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(20990), // Rule ID 69564 //
     /*   20940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20955 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20968 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20988 */     GIR_RootConstrainSelectedInstOperands,
     /*   20989 */     // GIR_Coverage, 69564,
     /*   20989 */     GIR_EraseRootFromParent_Done,
     /*   20990 */   // Label 423: @20990
     /*   20990 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(21045), // Rule ID 69653 //
     /*   20995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21010 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21023 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   21023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21043 */     GIR_RootConstrainSelectedInstOperands,
     /*   21044 */     // GIR_Coverage, 69653,
     /*   21044 */     GIR_EraseRootFromParent_Done,
     /*   21045 */   // Label 424: @21045
     /*   21045 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(21100), // Rule ID 69654 //
     /*   21050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   21053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21078 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   21078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21098 */     GIR_RootConstrainSelectedInstOperands,
     /*   21099 */     // GIR_Coverage, 69654,
     /*   21099 */     GIR_EraseRootFromParent_Done,
     /*   21100 */   // Label 425: @21100
     /*   21100 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(21168), // Rule ID 51906 //
     /*   21105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   21108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   21124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   21128 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21142 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   21142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   21145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21166 */     GIR_RootConstrainSelectedInstOperands,
     /*   21167 */     // GIR_Coverage, 51906,
     /*   21167 */     GIR_EraseRootFromParent_Done,
     /*   21168 */   // Label 426: @21168
     /*   21168 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(21236), // Rule ID 51907 //
     /*   21173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   21176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   21192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   21196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21210 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   21210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   21213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21234 */     GIR_RootConstrainSelectedInstOperands,
     /*   21235 */     // GIR_Coverage, 51907,
     /*   21235 */     GIR_EraseRootFromParent_Done,
     /*   21236 */   // Label 427: @21236
     /*   21236 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(21291), // Rule ID 46792 //
     /*   21241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   21244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   21256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21260 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21269 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   21269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21289 */     GIR_RootConstrainSelectedInstOperands,
     /*   21290 */     // GIR_Coverage, 46792,
     /*   21290 */     GIR_EraseRootFromParent_Done,
     /*   21291 */   // Label 428: @21291
     /*   21291 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(21346), // Rule ID 46793 //
     /*   21296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   21299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   21311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21315 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21324 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   21324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21344 */     GIR_RootConstrainSelectedInstOperands,
     /*   21345 */     // GIR_Coverage, 46793,
     /*   21345 */     GIR_EraseRootFromParent_Done,
     /*   21346 */   // Label 429: @21346
     /*   21346 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(21401), // Rule ID 46552 //
     /*   21351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   21354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21370 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21379 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   21379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   21382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21399 */     GIR_RootConstrainSelectedInstOperands,
     /*   21400 */     // GIR_Coverage, 46552,
     /*   21400 */     GIR_EraseRootFromParent_Done,
     /*   21401 */   // Label 430: @21401
     /*   21401 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(21456), // Rule ID 46553 //
     /*   21406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   21409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21425 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21434 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   21434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   21437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21454 */     GIR_RootConstrainSelectedInstOperands,
     /*   21455 */     // GIR_Coverage, 46553,
     /*   21455 */     GIR_EraseRootFromParent_Done,
     /*   21456 */   // Label 431: @21456
     /*   21456 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(21511), // Rule ID 46672 //
     /*   21461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   21464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21480 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21489 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   21489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21509 */     GIR_RootConstrainSelectedInstOperands,
     /*   21510 */     // GIR_Coverage, 46672,
     /*   21510 */     GIR_EraseRootFromParent_Done,
     /*   21511 */   // Label 432: @21511
     /*   21511 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21566), // Rule ID 46673 //
     /*   21516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   21519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21535 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21544 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   21544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21564 */     GIR_RootConstrainSelectedInstOperands,
     /*   21565 */     // GIR_Coverage, 46673,
     /*   21565 */     GIR_EraseRootFromParent_Done,
     /*   21566 */   // Label 433: @21566
     /*   21566 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21619), // Rule ID 46138 //
     /*   21571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   21574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21582 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   21582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   21599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21617 */     GIR_RootConstrainSelectedInstOperands,
     /*   21618 */     // GIR_Coverage, 46138,
     /*   21618 */     GIR_EraseRootFromParent_Done,
     /*   21619 */   // Label 434: @21619
     /*   21619 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21672), // Rule ID 46139 //
     /*   21624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   21627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21635 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   21635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   21652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21670 */     GIR_RootConstrainSelectedInstOperands,
     /*   21671 */     // GIR_Coverage, 46139,
     /*   21671 */     GIR_EraseRootFromParent_Done,
     /*   21672 */   // Label 435: @21672
     /*   21672 */   GIM_Reject,
     /*   21673 */ // Label 395: @21673
     /*   21673 */ GIM_Reject,
     /*   21674 */ // Label 132: @21674
     /*   21674 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(22068),
     /*   21679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21689 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21757), // Rule ID 70691 //
     /*   21694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21713 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21731 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21755 */     GIR_RootConstrainSelectedInstOperands,
     /*   21756 */     // GIR_Coverage, 70691,
     /*   21756 */     GIR_EraseRootFromParent_Done,
     /*   21757 */   // Label 437: @21757
     /*   21757 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21825), // Rule ID 70692 //
     /*   21762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21799 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21823 */     GIR_RootConstrainSelectedInstOperands,
     /*   21824 */     // GIR_Coverage, 70692,
     /*   21824 */     GIR_EraseRootFromParent_Done,
     /*   21825 */   // Label 438: @21825
     /*   21825 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21893), // Rule ID 51874 //
     /*   21830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21853 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21867 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21891 */     GIR_RootConstrainSelectedInstOperands,
     /*   21892 */     // GIR_Coverage, 51874,
     /*   21892 */     GIR_EraseRootFromParent_Done,
     /*   21893 */   // Label 439: @21893
     /*   21893 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21961), // Rule ID 51875 //
     /*   21898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21921 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21935 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21959 */     GIR_RootConstrainSelectedInstOperands,
     /*   21960 */     // GIR_Coverage, 51875,
     /*   21960 */     GIR_EraseRootFromParent_Done,
     /*   21961 */   // Label 440: @21961
     /*   21961 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(22014), // Rule ID 46106 //
     /*   21966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21977 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   21977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   21980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   21994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22012 */     GIR_RootConstrainSelectedInstOperands,
     /*   22013 */     // GIR_Coverage, 46106,
     /*   22013 */     GIR_EraseRootFromParent_Done,
     /*   22014 */   // Label 441: @22014
     /*   22014 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22067), // Rule ID 46107 //
     /*   22019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22030 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   22030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   22033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   22047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22065 */     GIR_RootConstrainSelectedInstOperands,
     /*   22066 */     // GIR_Coverage, 46107,
     /*   22066 */     GIR_EraseRootFromParent_Done,
     /*   22067 */   // Label 442: @22067
     /*   22067 */   GIM_Reject,
     /*   22068 */ // Label 436: @22068
     /*   22068 */ GIM_Reject,
     /*   22069 */ // Label 133: @22069
     /*   22069 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(25193),
     /*   22074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22084 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22180), // Rule ID 70903 //
     /*   22089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22108 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22122 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22137 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22141 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22143 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22154 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22178 */     GIR_RootConstrainSelectedInstOperands,
     /*   22179 */     // GIR_Coverage, 70903,
     /*   22179 */     GIR_EraseRootFromParent_Done,
     /*   22180 */   // Label 444: @22180
     /*   22180 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22276), // Rule ID 70904 //
     /*   22185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22204 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22218 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22233 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22237 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22239 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22250 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22274 */     GIR_RootConstrainSelectedInstOperands,
     /*   22275 */     // GIR_Coverage, 70904,
     /*   22275 */     GIR_EraseRootFromParent_Done,
     /*   22276 */   // Label 445: @22276
     /*   22276 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22372), // Rule ID 71143 //
     /*   22281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22300 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22314 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22325 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22329 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22333 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22335 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22344 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22346 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22370 */     GIR_RootConstrainSelectedInstOperands,
     /*   22371 */     // GIR_Coverage, 71143,
     /*   22371 */     GIR_EraseRootFromParent_Done,
     /*   22372 */   // Label 446: @22372
     /*   22372 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22468), // Rule ID 71144 //
     /*   22377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22396 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22410 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22425 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22429 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22431 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22442 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22466 */     GIR_RootConstrainSelectedInstOperands,
     /*   22467 */     // GIR_Coverage, 71144,
     /*   22467 */     GIR_EraseRootFromParent_Done,
     /*   22468 */   // Label 447: @22468
     /*   22468 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22564), // Rule ID 71145 //
     /*   22473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22506 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22521 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22525 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22527 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22538 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22562 */     GIR_RootConstrainSelectedInstOperands,
     /*   22563 */     // GIR_Coverage, 71145,
     /*   22563 */     GIR_EraseRootFromParent_Done,
     /*   22564 */   // Label 448: @22564
     /*   22564 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22660), // Rule ID 71146 //
     /*   22569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22588 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22602 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22617 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22621 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22623 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22634 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22658 */     GIR_RootConstrainSelectedInstOperands,
     /*   22659 */     // GIR_Coverage, 71146,
     /*   22659 */     GIR_EraseRootFromParent_Done,
     /*   22660 */   // Label 449: @22660
     /*   22660 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22756), // Rule ID 71017 //
     /*   22665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22684 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22698 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22709 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22713 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22717 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22719 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22730 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   22733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22754 */     GIR_RootConstrainSelectedInstOperands,
     /*   22755 */     // GIR_Coverage, 71017,
     /*   22755 */     GIR_EraseRootFromParent_Done,
     /*   22756 */   // Label 450: @22756
     /*   22756 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22852), // Rule ID 71018 //
     /*   22761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22780 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22794 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22809 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22813 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22815 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22826 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   22829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22850 */     GIR_RootConstrainSelectedInstOperands,
     /*   22851 */     // GIR_Coverage, 71018,
     /*   22851 */     GIR_EraseRootFromParent_Done,
     /*   22852 */   // Label 451: @22852
     /*   22852 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(22948), // Rule ID 52046 //
     /*   22857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22880 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22894 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22909 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22913 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22915 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22922 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22946 */     GIR_RootConstrainSelectedInstOperands,
     /*   22947 */     // GIR_Coverage, 52046,
     /*   22947 */     GIR_EraseRootFromParent_Done,
     /*   22948 */   // Label 452: @22948
     /*   22948 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23044), // Rule ID 52047 //
     /*   22953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22990 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23005 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23009 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23011 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23018 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   23021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23042 */     GIR_RootConstrainSelectedInstOperands,
     /*   23043 */     // GIR_Coverage, 52047,
     /*   23043 */     GIR_EraseRootFromParent_Done,
     /*   23044 */   // Label 453: @23044
     /*   23044 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23140), // Rule ID 52164 //
     /*   23049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23072 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23086 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23101 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23105 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23107 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23114 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   23117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23138 */     GIR_RootConstrainSelectedInstOperands,
     /*   23139 */     // GIR_Coverage, 52164,
     /*   23139 */     GIR_EraseRootFromParent_Done,
     /*   23140 */   // Label 454: @23140
     /*   23140 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23236), // Rule ID 52165 //
     /*   23145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23168 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23182 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23197 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23201 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23203 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23210 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   23213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23234 */     GIR_RootConstrainSelectedInstOperands,
     /*   23235 */     // GIR_Coverage, 52165,
     /*   23235 */     GIR_EraseRootFromParent_Done,
     /*   23236 */   // Label 455: @23236
     /*   23236 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23332), // Rule ID 71141 //
     /*   23241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23264 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23278 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23293 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23297 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23299 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23306 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   23309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   23317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   23321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23330 */     GIR_RootConstrainSelectedInstOperands,
     /*   23331 */     // GIR_Coverage, 71141,
     /*   23331 */     GIR_EraseRootFromParent_Done,
     /*   23332 */   // Label 456: @23332
     /*   23332 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23428), // Rule ID 71142 //
     /*   23337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23360 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23374 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23389 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23393 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23395 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23402 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   23405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   23413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   23417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23426 */     GIR_RootConstrainSelectedInstOperands,
     /*   23427 */     // GIR_Coverage, 71142,
     /*   23427 */     GIR_EraseRootFromParent_Done,
     /*   23428 */   // Label 457: @23428
     /*   23428 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23524), // Rule ID 52104 //
     /*   23433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23456 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23470 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23485 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23489 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23491 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23498 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   23501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23522 */     GIR_RootConstrainSelectedInstOperands,
     /*   23523 */     // GIR_Coverage, 52104,
     /*   23523 */     GIR_EraseRootFromParent_Done,
     /*   23524 */   // Label 458: @23524
     /*   23524 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23620), // Rule ID 52105 //
     /*   23529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23566 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23581 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23585 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23587 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23594 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   23597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23618 */     GIR_RootConstrainSelectedInstOperands,
     /*   23619 */     // GIR_Coverage, 52105,
     /*   23619 */     GIR_EraseRootFromParent_Done,
     /*   23620 */   // Label 459: @23620
     /*   23620 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23709), // Rule ID 46692 //
     /*   23625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23640 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23659 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23668 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23707 */     GIR_RootConstrainSelectedInstOperands,
     /*   23708 */     // GIR_Coverage, 46692,
     /*   23708 */     GIR_EraseRootFromParent_Done,
     /*   23709 */   // Label 460: @23709
     /*   23709 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23798), // Rule ID 46693 //
     /*   23714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23729 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23748 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23757 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23796 */     GIR_RootConstrainSelectedInstOperands,
     /*   23797 */     // GIR_Coverage, 46693,
     /*   23797 */     GIR_EraseRootFromParent_Done,
     /*   23798 */   // Label 461: @23798
     /*   23798 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23887), // Rule ID 46456 //
     /*   23803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23818 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23837 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23846 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   23863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23885 */     GIR_RootConstrainSelectedInstOperands,
     /*   23886 */     // GIR_Coverage, 46456,
     /*   23886 */     GIR_EraseRootFromParent_Done,
     /*   23887 */   // Label 462: @23887
     /*   23887 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23976), // Rule ID 46457 //
     /*   23892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23907 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23926 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23935 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   23952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23974 */     GIR_RootConstrainSelectedInstOperands,
     /*   23975 */     // GIR_Coverage, 46457,
     /*   23975 */     GIR_EraseRootFromParent_Done,
     /*   23976 */   // Label 463: @23976
     /*   23976 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(24065), // Rule ID 46572 //
     /*   23981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23996 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   24007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24015 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   24024 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   24024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   24041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   24050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24063 */     GIR_RootConstrainSelectedInstOperands,
     /*   24064 */     // GIR_Coverage, 46572,
     /*   24064 */     GIR_EraseRootFromParent_Done,
     /*   24065 */   // Label 464: @24065
     /*   24065 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(24154), // Rule ID 46573 //
     /*   24070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24085 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   24096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24104 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   24113 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   24113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   24130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   24139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24152 */     GIR_RootConstrainSelectedInstOperands,
     /*   24153 */     // GIR_Coverage, 46573,
     /*   24153 */     GIR_EraseRootFromParent_Done,
     /*   24154 */   // Label 465: @24154
     /*   24154 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(24222), // Rule ID 70715 //
     /*   24159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24178 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24196 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24220 */     GIR_RootConstrainSelectedInstOperands,
     /*   24221 */     // GIR_Coverage, 70715,
     /*   24221 */     GIR_EraseRootFromParent_Done,
     /*   24222 */   // Label 466: @24222
     /*   24222 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(24290), // Rule ID 70716 //
     /*   24227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24264 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   24264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24288 */     GIR_RootConstrainSelectedInstOperands,
     /*   24289 */     // GIR_Coverage, 70716,
     /*   24289 */     GIR_EraseRootFromParent_Done,
     /*   24290 */   // Label 467: @24290
     /*   24290 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(24345), // Rule ID 69703 //
     /*   24295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24310 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24323 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24343 */     GIR_RootConstrainSelectedInstOperands,
     /*   24344 */     // GIR_Coverage, 69703,
     /*   24344 */     GIR_EraseRootFromParent_Done,
     /*   24345 */   // Label 468: @24345
     /*   24345 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(24400), // Rule ID 69704 //
     /*   24350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24365 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24378 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24398 */     GIR_RootConstrainSelectedInstOperands,
     /*   24399 */     // GIR_Coverage, 69704,
     /*   24399 */     GIR_EraseRootFromParent_Done,
     /*   24400 */   // Label 469: @24400
     /*   24400 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(24455), // Rule ID 69523 //
     /*   24405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24420 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24433 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24453 */     GIR_RootConstrainSelectedInstOperands,
     /*   24454 */     // GIR_Coverage, 69523,
     /*   24454 */     GIR_EraseRootFromParent_Done,
     /*   24455 */   // Label 470: @24455
     /*   24455 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(24510), // Rule ID 69524 //
     /*   24460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24475 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24488 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24508 */     GIR_RootConstrainSelectedInstOperands,
     /*   24509 */     // GIR_Coverage, 69524,
     /*   24509 */     GIR_EraseRootFromParent_Done,
     /*   24510 */   // Label 471: @24510
     /*   24510 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24565), // Rule ID 69613 //
     /*   24515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24530 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24543 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24563 */     GIR_RootConstrainSelectedInstOperands,
     /*   24564 */     // GIR_Coverage, 69613,
     /*   24564 */     GIR_EraseRootFromParent_Done,
     /*   24565 */   // Label 472: @24565
     /*   24565 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24620), // Rule ID 69614 //
     /*   24570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24585 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24598 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24618 */     GIR_RootConstrainSelectedInstOperands,
     /*   24619 */     // GIR_Coverage, 69614,
     /*   24619 */     GIR_EraseRootFromParent_Done,
     /*   24620 */   // Label 473: @24620
     /*   24620 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24688), // Rule ID 51886 //
     /*   24625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24648 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24662 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24686 */     GIR_RootConstrainSelectedInstOperands,
     /*   24687 */     // GIR_Coverage, 51886,
     /*   24687 */     GIR_EraseRootFromParent_Done,
     /*   24688 */   // Label 474: @24688
     /*   24688 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24756), // Rule ID 51887 //
     /*   24693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24730 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   24730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24754 */     GIR_RootConstrainSelectedInstOperands,
     /*   24755 */     // GIR_Coverage, 51887,
     /*   24755 */     GIR_EraseRootFromParent_Done,
     /*   24756 */   // Label 475: @24756
     /*   24756 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24811), // Rule ID 46752 //
     /*   24761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24780 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24789 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24809 */     GIR_RootConstrainSelectedInstOperands,
     /*   24810 */     // GIR_Coverage, 46752,
     /*   24810 */     GIR_EraseRootFromParent_Done,
     /*   24811 */   // Label 476: @24811
     /*   24811 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24866), // Rule ID 46753 //
     /*   24816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24835 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24844 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24864 */     GIR_RootConstrainSelectedInstOperands,
     /*   24865 */     // GIR_Coverage, 46753,
     /*   24865 */     GIR_EraseRootFromParent_Done,
     /*   24866 */   // Label 477: @24866
     /*   24866 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24921), // Rule ID 46512 //
     /*   24871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24899 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24919 */     GIR_RootConstrainSelectedInstOperands,
     /*   24920 */     // GIR_Coverage, 46512,
     /*   24920 */     GIR_EraseRootFromParent_Done,
     /*   24921 */   // Label 478: @24921
     /*   24921 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24976), // Rule ID 46513 //
     /*   24926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24945 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24954 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24974 */     GIR_RootConstrainSelectedInstOperands,
     /*   24975 */     // GIR_Coverage, 46513,
     /*   24975 */     GIR_EraseRootFromParent_Done,
     /*   24976 */   // Label 479: @24976
     /*   24976 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(25031), // Rule ID 46632 //
     /*   24981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   25000 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   25009 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   25009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   25012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   25016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   25020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25029 */     GIR_RootConstrainSelectedInstOperands,
     /*   25030 */     // GIR_Coverage, 46632,
     /*   25030 */     GIR_EraseRootFromParent_Done,
     /*   25031 */   // Label 480: @25031
     /*   25031 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(25086), // Rule ID 46633 //
     /*   25036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   25055 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   25064 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   25064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   25067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   25071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   25075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25084 */     GIR_RootConstrainSelectedInstOperands,
     /*   25085 */     // GIR_Coverage, 46633,
     /*   25085 */     GIR_EraseRootFromParent_Done,
     /*   25086 */   // Label 481: @25086
     /*   25086 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(25139), // Rule ID 46118 //
     /*   25091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25102 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   25102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   25105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   25119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25137 */     GIR_RootConstrainSelectedInstOperands,
     /*   25138 */     // GIR_Coverage, 46118,
     /*   25138 */     GIR_EraseRootFromParent_Done,
     /*   25139 */   // Label 482: @25139
     /*   25139 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(25192), // Rule ID 46119 //
     /*   25144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25155 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   25155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   25158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   25172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25190 */     GIR_RootConstrainSelectedInstOperands,
     /*   25191 */     // GIR_Coverage, 46119,
     /*   25191 */     GIR_EraseRootFromParent_Done,
     /*   25192 */   // Label 483: @25192
     /*   25192 */   GIM_Reject,
     /*   25193 */ // Label 443: @25193
     /*   25193 */ GIM_Reject,
     /*   25194 */ // Label 134: @25194
     /*   25194 */ GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(28318),
     /*   25199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25209 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(25305), // Rule ID 70915 //
     /*   25214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25233 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25247 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25249 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25262 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25266 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25268 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25277 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25279 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   25282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25303 */     GIR_RootConstrainSelectedInstOperands,
     /*   25304 */     // GIR_Coverage, 70915,
     /*   25304 */     GIR_EraseRootFromParent_Done,
     /*   25305 */   // Label 485: @25305
     /*   25305 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(25401), // Rule ID 70916 //
     /*   25310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25329 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25343 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25358 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25362 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25364 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25375 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   25378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25399 */     GIR_RootConstrainSelectedInstOperands,
     /*   25400 */     // GIR_Coverage, 70916,
     /*   25400 */     GIR_EraseRootFromParent_Done,
     /*   25401 */   // Label 486: @25401
     /*   25401 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(25497), // Rule ID 71179 //
     /*   25406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25425 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25439 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25454 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25458 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25460 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25471 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25495 */     GIR_RootConstrainSelectedInstOperands,
     /*   25496 */     // GIR_Coverage, 71179,
     /*   25496 */     GIR_EraseRootFromParent_Done,
     /*   25497 */   // Label 487: @25497
     /*   25497 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(25593), // Rule ID 71180 //
     /*   25502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25535 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25550 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25554 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25556 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25567 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25591 */     GIR_RootConstrainSelectedInstOperands,
     /*   25592 */     // GIR_Coverage, 71180,
     /*   25592 */     GIR_EraseRootFromParent_Done,
     /*   25593 */   // Label 488: @25593
     /*   25593 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(25689), // Rule ID 71181 //
     /*   25598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25617 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25631 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25646 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25650 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25652 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25663 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25687 */     GIR_RootConstrainSelectedInstOperands,
     /*   25688 */     // GIR_Coverage, 71181,
     /*   25688 */     GIR_EraseRootFromParent_Done,
     /*   25689 */   // Label 489: @25689
     /*   25689 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(25785), // Rule ID 71182 //
     /*   25694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25713 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25727 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25729 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25742 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25746 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25748 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25759 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25783 */     GIR_RootConstrainSelectedInstOperands,
     /*   25784 */     // GIR_Coverage, 71182,
     /*   25784 */     GIR_EraseRootFromParent_Done,
     /*   25785 */   // Label 490: @25785
     /*   25785 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(25881), // Rule ID 71029 //
     /*   25790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25809 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25823 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25842 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25844 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25855 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   25858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25879 */     GIR_RootConstrainSelectedInstOperands,
     /*   25880 */     // GIR_Coverage, 71029,
     /*   25880 */     GIR_EraseRootFromParent_Done,
     /*   25881 */   // Label 491: @25881
     /*   25881 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(25977), // Rule ID 71030 //
     /*   25886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25905 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25919 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25934 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25938 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25940 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25951 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   25954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25975 */     GIR_RootConstrainSelectedInstOperands,
     /*   25976 */     // GIR_Coverage, 71030,
     /*   25976 */     GIR_EraseRootFromParent_Done,
     /*   25977 */   // Label 492: @25977
     /*   25977 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(26073), // Rule ID 52058 //
     /*   25982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26005 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26019 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26034 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26038 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26040 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26047 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   26050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26071 */     GIR_RootConstrainSelectedInstOperands,
     /*   26072 */     // GIR_Coverage, 52058,
     /*   26072 */     GIR_EraseRootFromParent_Done,
     /*   26073 */   // Label 493: @26073
     /*   26073 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(26169), // Rule ID 52059 //
     /*   26078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26101 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26115 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26130 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26134 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26136 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26143 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   26146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26167 */     GIR_RootConstrainSelectedInstOperands,
     /*   26168 */     // GIR_Coverage, 52059,
     /*   26168 */     GIR_EraseRootFromParent_Done,
     /*   26169 */   // Label 494: @26169
     /*   26169 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(26265), // Rule ID 52176 //
     /*   26174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26197 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26211 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26226 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26230 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26232 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26239 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   26242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26263 */     GIR_RootConstrainSelectedInstOperands,
     /*   26264 */     // GIR_Coverage, 52176,
     /*   26264 */     GIR_EraseRootFromParent_Done,
     /*   26265 */   // Label 495: @26265
     /*   26265 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(26361), // Rule ID 52177 //
     /*   26270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26293 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26307 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26322 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26326 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26328 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26335 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   26338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26359 */     GIR_RootConstrainSelectedInstOperands,
     /*   26360 */     // GIR_Coverage, 52177,
     /*   26360 */     GIR_EraseRootFromParent_Done,
     /*   26361 */   // Label 496: @26361
     /*   26361 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(26457), // Rule ID 71177 //
     /*   26366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26389 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26403 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26418 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26422 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26424 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26431 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   26434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   26442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   26446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26455 */     GIR_RootConstrainSelectedInstOperands,
     /*   26456 */     // GIR_Coverage, 71177,
     /*   26456 */     GIR_EraseRootFromParent_Done,
     /*   26457 */   // Label 497: @26457
     /*   26457 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(26553), // Rule ID 71178 //
     /*   26462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26485 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26499 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26514 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26518 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26520 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26527 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   26530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   26538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   26542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26551 */     GIR_RootConstrainSelectedInstOperands,
     /*   26552 */     // GIR_Coverage, 71178,
     /*   26552 */     GIR_EraseRootFromParent_Done,
     /*   26553 */   // Label 498: @26553
     /*   26553 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(26649), // Rule ID 52116 //
     /*   26558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26581 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26595 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26610 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26614 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26616 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26623 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   26626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26647 */     GIR_RootConstrainSelectedInstOperands,
     /*   26648 */     // GIR_Coverage, 52116,
     /*   26648 */     GIR_EraseRootFromParent_Done,
     /*   26649 */   // Label 499: @26649
     /*   26649 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(26745), // Rule ID 52117 //
     /*   26654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26677 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26691 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26706 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26710 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26712 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26719 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   26722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26743 */     GIR_RootConstrainSelectedInstOperands,
     /*   26744 */     // GIR_Coverage, 52117,
     /*   26744 */     GIR_EraseRootFromParent_Done,
     /*   26745 */   // Label 500: @26745
     /*   26745 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(26834), // Rule ID 46716 //
     /*   26750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26765 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26784 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26793 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26832 */     GIR_RootConstrainSelectedInstOperands,
     /*   26833 */     // GIR_Coverage, 46716,
     /*   26833 */     GIR_EraseRootFromParent_Done,
     /*   26834 */   // Label 501: @26834
     /*   26834 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(26923), // Rule ID 46717 //
     /*   26839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26873 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26882 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26921 */     GIR_RootConstrainSelectedInstOperands,
     /*   26922 */     // GIR_Coverage, 46717,
     /*   26922 */     GIR_EraseRootFromParent_Done,
     /*   26923 */   // Label 502: @26923
     /*   26923 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(27012), // Rule ID 46480 //
     /*   26928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26943 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26962 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26971 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   26988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27010 */     GIR_RootConstrainSelectedInstOperands,
     /*   27011 */     // GIR_Coverage, 46480,
     /*   27011 */     GIR_EraseRootFromParent_Done,
     /*   27012 */   // Label 503: @27012
     /*   27012 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(27101), // Rule ID 46481 //
     /*   27017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   27043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27051 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   27060 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   27060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   27077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   27086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27099 */     GIR_RootConstrainSelectedInstOperands,
     /*   27100 */     // GIR_Coverage, 46481,
     /*   27100 */     GIR_EraseRootFromParent_Done,
     /*   27101 */   // Label 504: @27101
     /*   27101 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(27190), // Rule ID 46596 //
     /*   27106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   27132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27140 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   27149 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   27149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   27166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   27175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27188 */     GIR_RootConstrainSelectedInstOperands,
     /*   27189 */     // GIR_Coverage, 46596,
     /*   27189 */     GIR_EraseRootFromParent_Done,
     /*   27190 */   // Label 505: @27190
     /*   27190 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(27279), // Rule ID 46597 //
     /*   27195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   27221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27229 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   27238 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   27238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   27255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   27264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27277 */     GIR_RootConstrainSelectedInstOperands,
     /*   27278 */     // GIR_Coverage, 46597,
     /*   27278 */     GIR_EraseRootFromParent_Done,
     /*   27279 */   // Label 506: @27279
     /*   27279 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(27347), // Rule ID 70747 //
     /*   27284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27303 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27321 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   27321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27345 */     GIR_RootConstrainSelectedInstOperands,
     /*   27346 */     // GIR_Coverage, 70747,
     /*   27346 */     GIR_EraseRootFromParent_Done,
     /*   27347 */   // Label 507: @27347
     /*   27347 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(27415), // Rule ID 70748 //
     /*   27352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27389 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   27389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27413 */     GIR_RootConstrainSelectedInstOperands,
     /*   27414 */     // GIR_Coverage, 70748,
     /*   27414 */     GIR_EraseRootFromParent_Done,
     /*   27415 */   // Label 508: @27415
     /*   27415 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(27470), // Rule ID 69727 //
     /*   27420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27435 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27448 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27468 */     GIR_RootConstrainSelectedInstOperands,
     /*   27469 */     // GIR_Coverage, 69727,
     /*   27469 */     GIR_EraseRootFromParent_Done,
     /*   27470 */   // Label 509: @27470
     /*   27470 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(27525), // Rule ID 69728 //
     /*   27475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27490 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27503 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27523 */     GIR_RootConstrainSelectedInstOperands,
     /*   27524 */     // GIR_Coverage, 69728,
     /*   27524 */     GIR_EraseRootFromParent_Done,
     /*   27525 */   // Label 510: @27525
     /*   27525 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(27580), // Rule ID 69547 //
     /*   27530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27545 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27558 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27578 */     GIR_RootConstrainSelectedInstOperands,
     /*   27579 */     // GIR_Coverage, 69547,
     /*   27579 */     GIR_EraseRootFromParent_Done,
     /*   27580 */   // Label 511: @27580
     /*   27580 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(27635), // Rule ID 69548 //
     /*   27585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27613 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27633 */     GIR_RootConstrainSelectedInstOperands,
     /*   27634 */     // GIR_Coverage, 69548,
     /*   27634 */     GIR_EraseRootFromParent_Done,
     /*   27635 */   // Label 512: @27635
     /*   27635 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(27690), // Rule ID 69637 //
     /*   27640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27655 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27668 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27688 */     GIR_RootConstrainSelectedInstOperands,
     /*   27689 */     // GIR_Coverage, 69637,
     /*   27689 */     GIR_EraseRootFromParent_Done,
     /*   27690 */   // Label 513: @27690
     /*   27690 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(27745), // Rule ID 69638 //
     /*   27695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27710 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27723 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27743 */     GIR_RootConstrainSelectedInstOperands,
     /*   27744 */     // GIR_Coverage, 69638,
     /*   27744 */     GIR_EraseRootFromParent_Done,
     /*   27745 */   // Label 514: @27745
     /*   27745 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(27813), // Rule ID 51902 //
     /*   27750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27773 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27787 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   27787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27811 */     GIR_RootConstrainSelectedInstOperands,
     /*   27812 */     // GIR_Coverage, 51902,
     /*   27812 */     GIR_EraseRootFromParent_Done,
     /*   27813 */   // Label 515: @27813
     /*   27813 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(27881), // Rule ID 51903 //
     /*   27818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27855 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   27855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27879 */     GIR_RootConstrainSelectedInstOperands,
     /*   27880 */     // GIR_Coverage, 51903,
     /*   27880 */     GIR_EraseRootFromParent_Done,
     /*   27881 */   // Label 516: @27881
     /*   27881 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(27936), // Rule ID 46776 //
     /*   27886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27905 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27914 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27934 */     GIR_RootConstrainSelectedInstOperands,
     /*   27935 */     // GIR_Coverage, 46776,
     /*   27935 */     GIR_EraseRootFromParent_Done,
     /*   27936 */   // Label 517: @27936
     /*   27936 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(27991), // Rule ID 46777 //
     /*   27941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27960 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27969 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27989 */     GIR_RootConstrainSelectedInstOperands,
     /*   27990 */     // GIR_Coverage, 46777,
     /*   27990 */     GIR_EraseRootFromParent_Done,
     /*   27991 */   // Label 518: @27991
     /*   27991 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(28046), // Rule ID 46536 //
     /*   27996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   28015 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28024 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   28024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   28027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   28031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   28035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   28041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28044 */     GIR_RootConstrainSelectedInstOperands,
     /*   28045 */     // GIR_Coverage, 46536,
     /*   28045 */     GIR_EraseRootFromParent_Done,
     /*   28046 */   // Label 519: @28046
     /*   28046 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(28101), // Rule ID 46537 //
     /*   28051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   28054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   28070 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28079 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   28079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   28082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   28086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   28090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   28096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28099 */     GIR_RootConstrainSelectedInstOperands,
     /*   28100 */     // GIR_Coverage, 46537,
     /*   28100 */     GIR_EraseRootFromParent_Done,
     /*   28101 */   // Label 520: @28101
     /*   28101 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(28156), // Rule ID 46656 //
     /*   28106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   28109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   28125 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28134 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   28134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   28137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   28141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   28145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   28151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28154 */     GIR_RootConstrainSelectedInstOperands,
     /*   28155 */     // GIR_Coverage, 46656,
     /*   28155 */     GIR_EraseRootFromParent_Done,
     /*   28156 */   // Label 521: @28156
     /*   28156 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(28211), // Rule ID 46657 //
     /*   28161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   28164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   28180 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28189 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   28189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   28192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   28196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   28200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   28206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28209 */     GIR_RootConstrainSelectedInstOperands,
     /*   28210 */     // GIR_Coverage, 46657,
     /*   28210 */     GIR_EraseRootFromParent_Done,
     /*   28211 */   // Label 522: @28211
     /*   28211 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(28264), // Rule ID 46134 //
     /*   28216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   28219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28227 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   28227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   28230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   28234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   28239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   28241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   28244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   28249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   28251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   28253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28262 */     GIR_RootConstrainSelectedInstOperands,
     /*   28263 */     // GIR_Coverage, 46134,
     /*   28263 */     GIR_EraseRootFromParent_Done,
     /*   28264 */   // Label 523: @28264
     /*   28264 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(28317), // Rule ID 46135 //
     /*   28269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   28272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28280 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   28280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   28283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   28287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   28292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   28294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   28297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   28302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   28304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   28306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28315 */     GIR_RootConstrainSelectedInstOperands,
     /*   28316 */     // GIR_Coverage, 46135,
     /*   28316 */     GIR_EraseRootFromParent_Done,
     /*   28317 */   // Label 524: @28317
     /*   28317 */   GIM_Reject,
     /*   28318 */ // Label 484: @28318
     /*   28318 */ GIM_Reject,
     /*   28319 */ // Label 135: @28319
     /*   28319 */ GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(31443),
     /*   28324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28334 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(28430), // Rule ID 70925 //
     /*   28339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28358 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28372 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28387 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28391 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28393 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28404 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28428 */     GIR_RootConstrainSelectedInstOperands,
     /*   28429 */     // GIR_Coverage, 70925,
     /*   28429 */     GIR_EraseRootFromParent_Done,
     /*   28430 */   // Label 526: @28430
     /*   28430 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(28526), // Rule ID 70926 //
     /*   28435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28454 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28468 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28483 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28487 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28489 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28500 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28524 */     GIR_RootConstrainSelectedInstOperands,
     /*   28525 */     // GIR_Coverage, 70926,
     /*   28525 */     GIR_EraseRootFromParent_Done,
     /*   28526 */   // Label 527: @28526
     /*   28526 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(28622), // Rule ID 71209 //
     /*   28531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28550 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28564 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28579 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28583 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28585 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28596 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28620 */     GIR_RootConstrainSelectedInstOperands,
     /*   28621 */     // GIR_Coverage, 71209,
     /*   28621 */     GIR_EraseRootFromParent_Done,
     /*   28622 */   // Label 528: @28622
     /*   28622 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(28718), // Rule ID 71210 //
     /*   28627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28646 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28660 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28675 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28679 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28681 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28692 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28716 */     GIR_RootConstrainSelectedInstOperands,
     /*   28717 */     // GIR_Coverage, 71210,
     /*   28717 */     GIR_EraseRootFromParent_Done,
     /*   28718 */   // Label 529: @28718
     /*   28718 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(28814), // Rule ID 71211 //
     /*   28723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28742 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28756 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28771 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28775 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28777 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28788 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28812 */     GIR_RootConstrainSelectedInstOperands,
     /*   28813 */     // GIR_Coverage, 71211,
     /*   28813 */     GIR_EraseRootFromParent_Done,
     /*   28814 */   // Label 530: @28814
     /*   28814 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(28910), // Rule ID 71212 //
     /*   28819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28838 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28852 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28867 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28871 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28873 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28884 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28908 */     GIR_RootConstrainSelectedInstOperands,
     /*   28909 */     // GIR_Coverage, 71212,
     /*   28909 */     GIR_EraseRootFromParent_Done,
     /*   28910 */   // Label 531: @28910
     /*   28910 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(29006), // Rule ID 71039 //
     /*   28915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28934 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28948 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28963 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28967 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28969 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28980 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   28983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29004 */     GIR_RootConstrainSelectedInstOperands,
     /*   29005 */     // GIR_Coverage, 71039,
     /*   29005 */     GIR_EraseRootFromParent_Done,
     /*   29006 */   // Label 532: @29006
     /*   29006 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(29102), // Rule ID 71040 //
     /*   29011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29030 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29044 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29059 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29063 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29065 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29076 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   29083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29100 */     GIR_RootConstrainSelectedInstOperands,
     /*   29101 */     // GIR_Coverage, 71040,
     /*   29101 */     GIR_EraseRootFromParent_Done,
     /*   29102 */   // Label 533: @29102
     /*   29102 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(29198), // Rule ID 52068 //
     /*   29107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29130 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29144 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29159 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29163 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29165 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29172 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   29175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29196 */     GIR_RootConstrainSelectedInstOperands,
     /*   29197 */     // GIR_Coverage, 52068,
     /*   29197 */     GIR_EraseRootFromParent_Done,
     /*   29198 */   // Label 534: @29198
     /*   29198 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(29294), // Rule ID 52069 //
     /*   29203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29226 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29240 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29255 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29259 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29261 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29268 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   29271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29292 */     GIR_RootConstrainSelectedInstOperands,
     /*   29293 */     // GIR_Coverage, 52069,
     /*   29293 */     GIR_EraseRootFromParent_Done,
     /*   29294 */   // Label 535: @29294
     /*   29294 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(29390), // Rule ID 52186 //
     /*   29299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29322 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29336 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29351 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29355 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29357 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29364 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29388 */     GIR_RootConstrainSelectedInstOperands,
     /*   29389 */     // GIR_Coverage, 52186,
     /*   29389 */     GIR_EraseRootFromParent_Done,
     /*   29390 */   // Label 536: @29390
     /*   29390 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(29486), // Rule ID 52187 //
     /*   29395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29418 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29432 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29447 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29451 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29453 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29460 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29484 */     GIR_RootConstrainSelectedInstOperands,
     /*   29485 */     // GIR_Coverage, 52187,
     /*   29485 */     GIR_EraseRootFromParent_Done,
     /*   29486 */   // Label 537: @29486
     /*   29486 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(29582), // Rule ID 71207 //
     /*   29491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29514 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29528 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29543 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29547 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29549 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29556 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   29567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   29571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29580 */     GIR_RootConstrainSelectedInstOperands,
     /*   29581 */     // GIR_Coverage, 71207,
     /*   29581 */     GIR_EraseRootFromParent_Done,
     /*   29582 */   // Label 538: @29582
     /*   29582 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(29678), // Rule ID 71208 //
     /*   29587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29624 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29639 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29643 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29645 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29652 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   29663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   29667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29676 */     GIR_RootConstrainSelectedInstOperands,
     /*   29677 */     // GIR_Coverage, 71208,
     /*   29677 */     GIR_EraseRootFromParent_Done,
     /*   29678 */   // Label 539: @29678
     /*   29678 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(29774), // Rule ID 52126 //
     /*   29683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29706 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29720 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29735 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29739 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29741 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29748 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29772 */     GIR_RootConstrainSelectedInstOperands,
     /*   29773 */     // GIR_Coverage, 52126,
     /*   29773 */     GIR_EraseRootFromParent_Done,
     /*   29774 */   // Label 540: @29774
     /*   29774 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(29870), // Rule ID 52127 //
     /*   29779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29802 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29816 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29835 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29837 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29844 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29868 */     GIR_RootConstrainSelectedInstOperands,
     /*   29869 */     // GIR_Coverage, 52127,
     /*   29869 */     GIR_EraseRootFromParent_Done,
     /*   29870 */   // Label 541: @29870
     /*   29870 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(29959), // Rule ID 46736 //
     /*   29875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29909 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29918 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29957 */     GIR_RootConstrainSelectedInstOperands,
     /*   29958 */     // GIR_Coverage, 46736,
     /*   29958 */     GIR_EraseRootFromParent_Done,
     /*   29959 */   // Label 542: @29959
     /*   29959 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(30048), // Rule ID 46737 //
     /*   29964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29979 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29998 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30007 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   30007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   30024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30046 */     GIR_RootConstrainSelectedInstOperands,
     /*   30047 */     // GIR_Coverage, 46737,
     /*   30047 */     GIR_EraseRootFromParent_Done,
     /*   30048 */   // Label 543: @30048
     /*   30048 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(30137), // Rule ID 46500 //
     /*   30053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30068 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   30079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30087 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30096 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   30096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   30113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30135 */     GIR_RootConstrainSelectedInstOperands,
     /*   30136 */     // GIR_Coverage, 46500,
     /*   30136 */     GIR_EraseRootFromParent_Done,
     /*   30137 */   // Label 544: @30137
     /*   30137 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(30226), // Rule ID 46501 //
     /*   30142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30157 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   30168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30176 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30185 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   30185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   30202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30224 */     GIR_RootConstrainSelectedInstOperands,
     /*   30225 */     // GIR_Coverage, 46501,
     /*   30225 */     GIR_EraseRootFromParent_Done,
     /*   30226 */   // Label 545: @30226
     /*   30226 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(30315), // Rule ID 46616 //
     /*   30231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   30257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30265 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30274 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   30274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   30291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30313 */     GIR_RootConstrainSelectedInstOperands,
     /*   30314 */     // GIR_Coverage, 46616,
     /*   30314 */     GIR_EraseRootFromParent_Done,
     /*   30315 */   // Label 546: @30315
     /*   30315 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(30404), // Rule ID 46617 //
     /*   30320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30335 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   30346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30354 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30363 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   30363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   30380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30402 */     GIR_RootConstrainSelectedInstOperands,
     /*   30403 */     // GIR_Coverage, 46617,
     /*   30403 */     GIR_EraseRootFromParent_Done,
     /*   30404 */   // Label 547: @30404
     /*   30404 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(30472), // Rule ID 70835 //
     /*   30409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30428 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30446 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   30446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30470 */     GIR_RootConstrainSelectedInstOperands,
     /*   30471 */     // GIR_Coverage, 70835,
     /*   30471 */     GIR_EraseRootFromParent_Done,
     /*   30472 */   // Label 548: @30472
     /*   30472 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(30540), // Rule ID 70836 //
     /*   30477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30496 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30514 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   30514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30538 */     GIR_RootConstrainSelectedInstOperands,
     /*   30539 */     // GIR_Coverage, 70836,
     /*   30539 */     GIR_EraseRootFromParent_Done,
     /*   30540 */   // Label 549: @30540
     /*   30540 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(30595), // Rule ID 69747 //
     /*   30545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30560 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30573 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30593 */     GIR_RootConstrainSelectedInstOperands,
     /*   30594 */     // GIR_Coverage, 69747,
     /*   30594 */     GIR_EraseRootFromParent_Done,
     /*   30595 */   // Label 550: @30595
     /*   30595 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(30650), // Rule ID 69748 //
     /*   30600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30615 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30628 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30648 */     GIR_RootConstrainSelectedInstOperands,
     /*   30649 */     // GIR_Coverage, 69748,
     /*   30649 */     GIR_EraseRootFromParent_Done,
     /*   30650 */   // Label 551: @30650
     /*   30650 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(30705), // Rule ID 69567 //
     /*   30655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30670 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30683 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30703 */     GIR_RootConstrainSelectedInstOperands,
     /*   30704 */     // GIR_Coverage, 69567,
     /*   30704 */     GIR_EraseRootFromParent_Done,
     /*   30705 */   // Label 552: @30705
     /*   30705 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(30760), // Rule ID 69568 //
     /*   30710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30725 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30738 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30758 */     GIR_RootConstrainSelectedInstOperands,
     /*   30759 */     // GIR_Coverage, 69568,
     /*   30759 */     GIR_EraseRootFromParent_Done,
     /*   30760 */   // Label 553: @30760
     /*   30760 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(30815), // Rule ID 69657 //
     /*   30765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30780 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30793 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30813 */     GIR_RootConstrainSelectedInstOperands,
     /*   30814 */     // GIR_Coverage, 69657,
     /*   30814 */     GIR_EraseRootFromParent_Done,
     /*   30815 */   // Label 554: @30815
     /*   30815 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(30870), // Rule ID 69658 //
     /*   30820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30835 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30848 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30868 */     GIR_RootConstrainSelectedInstOperands,
     /*   30869 */     // GIR_Coverage, 69658,
     /*   30869 */     GIR_EraseRootFromParent_Done,
     /*   30870 */   // Label 555: @30870
     /*   30870 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(30938), // Rule ID 51946 //
     /*   30875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30898 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30912 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   30912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30936 */     GIR_RootConstrainSelectedInstOperands,
     /*   30937 */     // GIR_Coverage, 51946,
     /*   30937 */     GIR_EraseRootFromParent_Done,
     /*   30938 */   // Label 556: @30938
     /*   30938 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(31006), // Rule ID 51947 //
     /*   30943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30980 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   30980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   31001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31004 */     GIR_RootConstrainSelectedInstOperands,
     /*   31005 */     // GIR_Coverage, 51947,
     /*   31005 */     GIR_EraseRootFromParent_Done,
     /*   31006 */   // Label 557: @31006
     /*   31006 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(31061), // Rule ID 46796 //
     /*   31011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   31014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   31026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   31030 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31039 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   31039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   31042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31059 */     GIR_RootConstrainSelectedInstOperands,
     /*   31060 */     // GIR_Coverage, 46796,
     /*   31060 */     GIR_EraseRootFromParent_Done,
     /*   31061 */   // Label 558: @31061
     /*   31061 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(31116), // Rule ID 46797 //
     /*   31066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   31069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   31081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   31085 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31094 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   31094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   31097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31114 */     GIR_RootConstrainSelectedInstOperands,
     /*   31115 */     // GIR_Coverage, 46797,
     /*   31115 */     GIR_EraseRootFromParent_Done,
     /*   31116 */   // Label 559: @31116
     /*   31116 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(31171), // Rule ID 46556 //
     /*   31121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   31124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   31140 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31149 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   31149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   31152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31169 */     GIR_RootConstrainSelectedInstOperands,
     /*   31170 */     // GIR_Coverage, 46556,
     /*   31170 */     GIR_EraseRootFromParent_Done,
     /*   31171 */   // Label 560: @31171
     /*   31171 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(31226), // Rule ID 46557 //
     /*   31176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   31179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   31195 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31204 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   31204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   31207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31224 */     GIR_RootConstrainSelectedInstOperands,
     /*   31225 */     // GIR_Coverage, 46557,
     /*   31225 */     GIR_EraseRootFromParent_Done,
     /*   31226 */   // Label 561: @31226
     /*   31226 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(31281), // Rule ID 46676 //
     /*   31231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   31234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   31250 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31259 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   31259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   31262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31279 */     GIR_RootConstrainSelectedInstOperands,
     /*   31280 */     // GIR_Coverage, 46676,
     /*   31280 */     GIR_EraseRootFromParent_Done,
     /*   31281 */   // Label 562: @31281
     /*   31281 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(31336), // Rule ID 46677 //
     /*   31286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   31289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   31305 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31314 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   31314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   31317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31334 */     GIR_RootConstrainSelectedInstOperands,
     /*   31335 */     // GIR_Coverage, 46677,
     /*   31335 */     GIR_EraseRootFromParent_Done,
     /*   31336 */   // Label 563: @31336
     /*   31336 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(31389), // Rule ID 46178 //
     /*   31341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   31344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31352 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   31352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   31355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   31369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   31384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31387 */     GIR_RootConstrainSelectedInstOperands,
     /*   31388 */     // GIR_Coverage, 46178,
     /*   31388 */     GIR_EraseRootFromParent_Done,
     /*   31389 */   // Label 564: @31389
     /*   31389 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(31442), // Rule ID 46179 //
     /*   31394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   31397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31405 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   31405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   31408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   31422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   31437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31440 */     GIR_RootConstrainSelectedInstOperands,
     /*   31441 */     // GIR_Coverage, 46179,
     /*   31441 */     GIR_EraseRootFromParent_Done,
     /*   31442 */   // Label 565: @31442
     /*   31442 */   GIM_Reject,
     /*   31443 */ // Label 525: @31443
     /*   31443 */ GIM_Reject,
     /*   31444 */ // Label 136: @31444
     /*   31444 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(31838),
     /*   31449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31459 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(31527), // Rule ID 70699 //
     /*   31464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31483 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31501 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31525 */     GIR_RootConstrainSelectedInstOperands,
     /*   31526 */     // GIR_Coverage, 70699,
     /*   31526 */     GIR_EraseRootFromParent_Done,
     /*   31527 */   // Label 567: @31527
     /*   31527 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(31595), // Rule ID 70700 //
     /*   31532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31551 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31569 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31593 */     GIR_RootConstrainSelectedInstOperands,
     /*   31594 */     // GIR_Coverage, 70700,
     /*   31594 */     GIR_EraseRootFromParent_Done,
     /*   31595 */   // Label 568: @31595
     /*   31595 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(31663), // Rule ID 51878 //
     /*   31600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31623 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31637 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31661 */     GIR_RootConstrainSelectedInstOperands,
     /*   31662 */     // GIR_Coverage, 51878,
     /*   31662 */     GIR_EraseRootFromParent_Done,
     /*   31663 */   // Label 569: @31663
     /*   31663 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(31731), // Rule ID 51879 //
     /*   31668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31691 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31705 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31729 */     GIR_RootConstrainSelectedInstOperands,
     /*   31730 */     // GIR_Coverage, 51879,
     /*   31730 */     GIR_EraseRootFromParent_Done,
     /*   31731 */   // Label 570: @31731
     /*   31731 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(31784), // Rule ID 46110 //
     /*   31736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31747 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   31747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   31764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31782 */     GIR_RootConstrainSelectedInstOperands,
     /*   31783 */     // GIR_Coverage, 46110,
     /*   31783 */     GIR_EraseRootFromParent_Done,
     /*   31784 */   // Label 571: @31784
     /*   31784 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(31837), // Rule ID 46111 //
     /*   31789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31800 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   31800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   31817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31835 */     GIR_RootConstrainSelectedInstOperands,
     /*   31836 */     // GIR_Coverage, 46111,
     /*   31836 */     GIR_EraseRootFromParent_Done,
     /*   31837 */   // Label 572: @31837
     /*   31837 */   GIM_Reject,
     /*   31838 */ // Label 566: @31838
     /*   31838 */ GIM_Reject,
     /*   31839 */ // Label 137: @31839
     /*   31839 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(34963),
     /*   31844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31854 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(31950), // Rule ID 70905 //
     /*   31859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31878 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31892 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31903 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31907 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31911 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31913 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31922 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31924 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   31927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31948 */     GIR_RootConstrainSelectedInstOperands,
     /*   31949 */     // GIR_Coverage, 70905,
     /*   31949 */     GIR_EraseRootFromParent_Done,
     /*   31950 */   // Label 574: @31950
     /*   31950 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(32046), // Rule ID 70906 //
     /*   31955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31974 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31988 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32003 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32007 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32009 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32020 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32044 */     GIR_RootConstrainSelectedInstOperands,
     /*   32045 */     // GIR_Coverage, 70906,
     /*   32045 */     GIR_EraseRootFromParent_Done,
     /*   32046 */   // Label 575: @32046
     /*   32046 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(32142), // Rule ID 71149 //
     /*   32051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32070 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32084 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32099 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32103 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32105 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32116 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32140 */     GIR_RootConstrainSelectedInstOperands,
     /*   32141 */     // GIR_Coverage, 71149,
     /*   32141 */     GIR_EraseRootFromParent_Done,
     /*   32142 */   // Label 576: @32142
     /*   32142 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(32238), // Rule ID 71150 //
     /*   32147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32166 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32180 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32195 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32199 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32201 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32212 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32236 */     GIR_RootConstrainSelectedInstOperands,
     /*   32237 */     // GIR_Coverage, 71150,
     /*   32237 */     GIR_EraseRootFromParent_Done,
     /*   32238 */   // Label 577: @32238
     /*   32238 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(32334), // Rule ID 71151 //
     /*   32243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32262 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32276 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32291 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32295 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32297 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32308 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   32319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   32323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32332 */     GIR_RootConstrainSelectedInstOperands,
     /*   32333 */     // GIR_Coverage, 71151,
     /*   32333 */     GIR_EraseRootFromParent_Done,
     /*   32334 */   // Label 578: @32334
     /*   32334 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(32430), // Rule ID 71152 //
     /*   32339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32358 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32372 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32387 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32391 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32393 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32404 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   32415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   32419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32428 */     GIR_RootConstrainSelectedInstOperands,
     /*   32429 */     // GIR_Coverage, 71152,
     /*   32429 */     GIR_EraseRootFromParent_Done,
     /*   32430 */   // Label 579: @32430
     /*   32430 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(32526), // Rule ID 71019 //
     /*   32435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32454 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32468 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32483 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32487 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32489 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32500 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32524 */     GIR_RootConstrainSelectedInstOperands,
     /*   32525 */     // GIR_Coverage, 71019,
     /*   32525 */     GIR_EraseRootFromParent_Done,
     /*   32526 */   // Label 580: @32526
     /*   32526 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(32622), // Rule ID 71020 //
     /*   32531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32550 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32564 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32579 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32583 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32585 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32596 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32620 */     GIR_RootConstrainSelectedInstOperands,
     /*   32621 */     // GIR_Coverage, 71020,
     /*   32621 */     GIR_EraseRootFromParent_Done,
     /*   32622 */   // Label 581: @32622
     /*   32622 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(32718), // Rule ID 52048 //
     /*   32627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32650 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32664 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32679 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32683 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32685 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32692 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32716 */     GIR_RootConstrainSelectedInstOperands,
     /*   32717 */     // GIR_Coverage, 52048,
     /*   32717 */     GIR_EraseRootFromParent_Done,
     /*   32718 */   // Label 582: @32718
     /*   32718 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(32814), // Rule ID 52049 //
     /*   32723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32746 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32760 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32775 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32779 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32788 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32812 */     GIR_RootConstrainSelectedInstOperands,
     /*   32813 */     // GIR_Coverage, 52049,
     /*   32813 */     GIR_EraseRootFromParent_Done,
     /*   32814 */   // Label 583: @32814
     /*   32814 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(32910), // Rule ID 52166 //
     /*   32819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32842 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32856 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32871 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32875 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32877 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32884 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32908 */     GIR_RootConstrainSelectedInstOperands,
     /*   32909 */     // GIR_Coverage, 52166,
     /*   32909 */     GIR_EraseRootFromParent_Done,
     /*   32910 */   // Label 584: @32910
     /*   32910 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(33006), // Rule ID 52167 //
     /*   32915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32938 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32952 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32967 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32971 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32973 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32980 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33004 */     GIR_RootConstrainSelectedInstOperands,
     /*   33005 */     // GIR_Coverage, 52167,
     /*   33005 */     GIR_EraseRootFromParent_Done,
     /*   33006 */   // Label 585: @33006
     /*   33006 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(33102), // Rule ID 71147 //
     /*   33011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33034 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33048 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33063 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33067 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33069 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33076 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   33079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   33083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   33087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   33091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33100 */     GIR_RootConstrainSelectedInstOperands,
     /*   33101 */     // GIR_Coverage, 71147,
     /*   33101 */     GIR_EraseRootFromParent_Done,
     /*   33102 */   // Label 586: @33102
     /*   33102 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(33198), // Rule ID 71148 //
     /*   33107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33130 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33144 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33159 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33163 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33165 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33172 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   33175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   33179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   33183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   33187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33196 */     GIR_RootConstrainSelectedInstOperands,
     /*   33197 */     // GIR_Coverage, 71148,
     /*   33197 */     GIR_EraseRootFromParent_Done,
     /*   33198 */   // Label 587: @33198
     /*   33198 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(33294), // Rule ID 52106 //
     /*   33203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33226 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33240 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33255 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33259 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33261 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33268 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   33271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   33275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   33283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33292 */     GIR_RootConstrainSelectedInstOperands,
     /*   33293 */     // GIR_Coverage, 52106,
     /*   33293 */     GIR_EraseRootFromParent_Done,
     /*   33294 */   // Label 588: @33294
     /*   33294 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(33390), // Rule ID 52107 //
     /*   33299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33322 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33336 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33351 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33355 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33357 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33364 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   33367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   33371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   33379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33388 */     GIR_RootConstrainSelectedInstOperands,
     /*   33389 */     // GIR_Coverage, 52107,
     /*   33389 */     GIR_EraseRootFromParent_Done,
     /*   33390 */   // Label 589: @33390
     /*   33390 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(33479), // Rule ID 46696 //
     /*   33395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33410 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33429 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33438 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33477 */     GIR_RootConstrainSelectedInstOperands,
     /*   33478 */     // GIR_Coverage, 46696,
     /*   33478 */     GIR_EraseRootFromParent_Done,
     /*   33479 */   // Label 590: @33479
     /*   33479 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(33568), // Rule ID 46697 //
     /*   33484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33499 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33518 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33527 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33566 */     GIR_RootConstrainSelectedInstOperands,
     /*   33567 */     // GIR_Coverage, 46697,
     /*   33567 */     GIR_EraseRootFromParent_Done,
     /*   33568 */   // Label 591: @33568
     /*   33568 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(33657), // Rule ID 46460 //
     /*   33573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33588 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33607 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33616 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   33633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33655 */     GIR_RootConstrainSelectedInstOperands,
     /*   33656 */     // GIR_Coverage, 46460,
     /*   33656 */     GIR_EraseRootFromParent_Done,
     /*   33657 */   // Label 592: @33657
     /*   33657 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(33746), // Rule ID 46461 //
     /*   33662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33677 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33696 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33705 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   33722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33744 */     GIR_RootConstrainSelectedInstOperands,
     /*   33745 */     // GIR_Coverage, 46461,
     /*   33745 */     GIR_EraseRootFromParent_Done,
     /*   33746 */   // Label 593: @33746
     /*   33746 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(33835), // Rule ID 46576 //
     /*   33751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33766 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33785 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33787 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33794 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33833 */     GIR_RootConstrainSelectedInstOperands,
     /*   33834 */     // GIR_Coverage, 46576,
     /*   33834 */     GIR_EraseRootFromParent_Done,
     /*   33835 */   // Label 594: @33835
     /*   33835 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(33924), // Rule ID 46577 //
     /*   33840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33855 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33874 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33883 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33922 */     GIR_RootConstrainSelectedInstOperands,
     /*   33923 */     // GIR_Coverage, 46577,
     /*   33923 */     GIR_EraseRootFromParent_Done,
     /*   33924 */   // Label 595: @33924
     /*   33924 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(33992), // Rule ID 70739 //
     /*   33929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33966 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33990 */     GIR_RootConstrainSelectedInstOperands,
     /*   33991 */     // GIR_Coverage, 70739,
     /*   33991 */     GIR_EraseRootFromParent_Done,
     /*   33992 */   // Label 596: @33992
     /*   33992 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(34060), // Rule ID 70740 //
     /*   33997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   34016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34034 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   34037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   34043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34058 */     GIR_RootConstrainSelectedInstOperands,
     /*   34059 */     // GIR_Coverage, 70740,
     /*   34059 */     GIR_EraseRootFromParent_Done,
     /*   34060 */   // Label 597: @34060
     /*   34060 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(34115), // Rule ID 69707 //
     /*   34065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34080 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34093 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34113 */     GIR_RootConstrainSelectedInstOperands,
     /*   34114 */     // GIR_Coverage, 69707,
     /*   34114 */     GIR_EraseRootFromParent_Done,
     /*   34115 */   // Label 598: @34115
     /*   34115 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(34170), // Rule ID 69708 //
     /*   34120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34135 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34148 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34168 */     GIR_RootConstrainSelectedInstOperands,
     /*   34169 */     // GIR_Coverage, 69708,
     /*   34169 */     GIR_EraseRootFromParent_Done,
     /*   34170 */   // Label 599: @34170
     /*   34170 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(34225), // Rule ID 69527 //
     /*   34175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34190 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34203 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34223 */     GIR_RootConstrainSelectedInstOperands,
     /*   34224 */     // GIR_Coverage, 69527,
     /*   34224 */     GIR_EraseRootFromParent_Done,
     /*   34225 */   // Label 600: @34225
     /*   34225 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(34280), // Rule ID 69528 //
     /*   34230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34245 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34258 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34278 */     GIR_RootConstrainSelectedInstOperands,
     /*   34279 */     // GIR_Coverage, 69528,
     /*   34279 */     GIR_EraseRootFromParent_Done,
     /*   34280 */   // Label 601: @34280
     /*   34280 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(34335), // Rule ID 69617 //
     /*   34285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34300 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34313 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34333 */     GIR_RootConstrainSelectedInstOperands,
     /*   34334 */     // GIR_Coverage, 69617,
     /*   34334 */     GIR_EraseRootFromParent_Done,
     /*   34335 */   // Label 602: @34335
     /*   34335 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(34390), // Rule ID 69618 //
     /*   34340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34355 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34368 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34388 */     GIR_RootConstrainSelectedInstOperands,
     /*   34389 */     // GIR_Coverage, 69618,
     /*   34389 */     GIR_EraseRootFromParent_Done,
     /*   34390 */   // Label 603: @34390
     /*   34390 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(34458), // Rule ID 51898 //
     /*   34395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   34418 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34432 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   34435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   34441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34456 */     GIR_RootConstrainSelectedInstOperands,
     /*   34457 */     // GIR_Coverage, 51898,
     /*   34457 */     GIR_EraseRootFromParent_Done,
     /*   34458 */   // Label 604: @34458
     /*   34458 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(34526), // Rule ID 51899 //
     /*   34463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   34486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34500 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   34503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   34509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34524 */     GIR_RootConstrainSelectedInstOperands,
     /*   34525 */     // GIR_Coverage, 51899,
     /*   34525 */     GIR_EraseRootFromParent_Done,
     /*   34526 */   // Label 605: @34526
     /*   34526 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(34581), // Rule ID 46756 //
     /*   34531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34550 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34559 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34579 */     GIR_RootConstrainSelectedInstOperands,
     /*   34580 */     // GIR_Coverage, 46756,
     /*   34580 */     GIR_EraseRootFromParent_Done,
     /*   34581 */   // Label 606: @34581
     /*   34581 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(34636), // Rule ID 46757 //
     /*   34586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34605 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34614 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34634 */     GIR_RootConstrainSelectedInstOperands,
     /*   34635 */     // GIR_Coverage, 46757,
     /*   34635 */     GIR_EraseRootFromParent_Done,
     /*   34636 */   // Label 607: @34636
     /*   34636 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(34691), // Rule ID 46516 //
     /*   34641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34660 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34669 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34689 */     GIR_RootConstrainSelectedInstOperands,
     /*   34690 */     // GIR_Coverage, 46516,
     /*   34690 */     GIR_EraseRootFromParent_Done,
     /*   34691 */   // Label 608: @34691
     /*   34691 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(34746), // Rule ID 46517 //
     /*   34696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34715 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34724 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34744 */     GIR_RootConstrainSelectedInstOperands,
     /*   34745 */     // GIR_Coverage, 46517,
     /*   34745 */     GIR_EraseRootFromParent_Done,
     /*   34746 */   // Label 609: @34746
     /*   34746 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(34801), // Rule ID 46636 //
     /*   34751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34770 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34779 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34799 */     GIR_RootConstrainSelectedInstOperands,
     /*   34800 */     // GIR_Coverage, 46636,
     /*   34800 */     GIR_EraseRootFromParent_Done,
     /*   34801 */   // Label 610: @34801
     /*   34801 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(34856), // Rule ID 46637 //
     /*   34806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34825 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34834 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34854 */     GIR_RootConstrainSelectedInstOperands,
     /*   34855 */     // GIR_Coverage, 46637,
     /*   34855 */     GIR_EraseRootFromParent_Done,
     /*   34856 */   // Label 611: @34856
     /*   34856 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(34909), // Rule ID 46130 //
     /*   34861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34872 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   34872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   34875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   34889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34907 */     GIR_RootConstrainSelectedInstOperands,
     /*   34908 */     // GIR_Coverage, 46130,
     /*   34908 */     GIR_EraseRootFromParent_Done,
     /*   34909 */   // Label 612: @34909
     /*   34909 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(34962), // Rule ID 46131 //
     /*   34914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34925 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   34925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   34928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   34942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34960 */     GIR_RootConstrainSelectedInstOperands,
     /*   34961 */     // GIR_Coverage, 46131,
     /*   34961 */     GIR_EraseRootFromParent_Done,
     /*   34962 */   // Label 613: @34962
     /*   34962 */   GIM_Reject,
     /*   34963 */ // Label 573: @34963
     /*   34963 */ GIM_Reject,
     /*   34964 */ // Label 138: @34964
     /*   34964 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38088),
     /*   34969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34979 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(35075), // Rule ID 70917 //
     /*   34984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35003 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35017 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35032 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35036 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35038 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35049 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35073 */     GIR_RootConstrainSelectedInstOperands,
     /*   35074 */     // GIR_Coverage, 70917,
     /*   35074 */     GIR_EraseRootFromParent_Done,
     /*   35075 */   // Label 615: @35075
     /*   35075 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(35171), // Rule ID 70918 //
     /*   35080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35099 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35113 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35128 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35132 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35134 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35145 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35169 */     GIR_RootConstrainSelectedInstOperands,
     /*   35170 */     // GIR_Coverage, 70918,
     /*   35170 */     GIR_EraseRootFromParent_Done,
     /*   35171 */   // Label 616: @35171
     /*   35171 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(35267), // Rule ID 71185 //
     /*   35176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35195 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35209 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35224 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35228 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35230 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35241 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35265 */     GIR_RootConstrainSelectedInstOperands,
     /*   35266 */     // GIR_Coverage, 71185,
     /*   35266 */     GIR_EraseRootFromParent_Done,
     /*   35267 */   // Label 617: @35267
     /*   35267 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(35363), // Rule ID 71186 //
     /*   35272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35291 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35305 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35320 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35324 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35326 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35337 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35361 */     GIR_RootConstrainSelectedInstOperands,
     /*   35362 */     // GIR_Coverage, 71186,
     /*   35362 */     GIR_EraseRootFromParent_Done,
     /*   35363 */   // Label 618: @35363
     /*   35363 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(35459), // Rule ID 71187 //
     /*   35368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35387 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35401 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35416 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35420 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35422 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35433 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35457 */     GIR_RootConstrainSelectedInstOperands,
     /*   35458 */     // GIR_Coverage, 71187,
     /*   35458 */     GIR_EraseRootFromParent_Done,
     /*   35459 */   // Label 619: @35459
     /*   35459 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(35555), // Rule ID 71188 //
     /*   35464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35483 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35497 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35512 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35516 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35518 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35529 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35553 */     GIR_RootConstrainSelectedInstOperands,
     /*   35554 */     // GIR_Coverage, 71188,
     /*   35554 */     GIR_EraseRootFromParent_Done,
     /*   35555 */   // Label 620: @35555
     /*   35555 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(35651), // Rule ID 71031 //
     /*   35560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35579 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35593 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35612 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35614 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35625 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35649 */     GIR_RootConstrainSelectedInstOperands,
     /*   35650 */     // GIR_Coverage, 71031,
     /*   35650 */     GIR_EraseRootFromParent_Done,
     /*   35651 */   // Label 621: @35651
     /*   35651 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(35747), // Rule ID 71032 //
     /*   35656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35675 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35689 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35704 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35708 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35710 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35721 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35745 */     GIR_RootConstrainSelectedInstOperands,
     /*   35746 */     // GIR_Coverage, 71032,
     /*   35746 */     GIR_EraseRootFromParent_Done,
     /*   35747 */   // Label 622: @35747
     /*   35747 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(35843), // Rule ID 52060 //
     /*   35752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35775 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35789 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35804 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35808 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35810 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35817 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35841 */     GIR_RootConstrainSelectedInstOperands,
     /*   35842 */     // GIR_Coverage, 52060,
     /*   35842 */     GIR_EraseRootFromParent_Done,
     /*   35843 */   // Label 623: @35843
     /*   35843 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(35939), // Rule ID 52061 //
     /*   35848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35871 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35885 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35904 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35906 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35913 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35937 */     GIR_RootConstrainSelectedInstOperands,
     /*   35938 */     // GIR_Coverage, 52061,
     /*   35938 */     GIR_EraseRootFromParent_Done,
     /*   35939 */   // Label 624: @35939
     /*   35939 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(36035), // Rule ID 52178 //
     /*   35944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35967 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35981 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36000 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36002 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36009 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   36012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   36024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36033 */     GIR_RootConstrainSelectedInstOperands,
     /*   36034 */     // GIR_Coverage, 52178,
     /*   36034 */     GIR_EraseRootFromParent_Done,
     /*   36035 */   // Label 625: @36035
     /*   36035 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(36131), // Rule ID 52179 //
     /*   36040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36063 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36077 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   36088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36092 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36096 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36098 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36105 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   36108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   36120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36129 */     GIR_RootConstrainSelectedInstOperands,
     /*   36130 */     // GIR_Coverage, 52179,
     /*   36130 */     GIR_EraseRootFromParent_Done,
     /*   36131 */   // Label 626: @36131
     /*   36131 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(36227), // Rule ID 71183 //
     /*   36136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36159 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36173 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   36184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36188 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36192 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36194 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36201 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   36204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   36212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   36216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36225 */     GIR_RootConstrainSelectedInstOperands,
     /*   36226 */     // GIR_Coverage, 71183,
     /*   36226 */     GIR_EraseRootFromParent_Done,
     /*   36227 */   // Label 627: @36227
     /*   36227 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(36323), // Rule ID 71184 //
     /*   36232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36255 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36269 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   36280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36284 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36288 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36290 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36297 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   36300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   36308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   36312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36321 */     GIR_RootConstrainSelectedInstOperands,
     /*   36322 */     // GIR_Coverage, 71184,
     /*   36322 */     GIR_EraseRootFromParent_Done,
     /*   36323 */   // Label 628: @36323
     /*   36323 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(36419), // Rule ID 52118 //
     /*   36328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36351 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36365 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   36376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36380 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36384 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36386 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36393 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   36396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   36408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36417 */     GIR_RootConstrainSelectedInstOperands,
     /*   36418 */     // GIR_Coverage, 52118,
     /*   36418 */     GIR_EraseRootFromParent_Done,
     /*   36419 */   // Label 629: @36419
     /*   36419 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(36515), // Rule ID 52119 //
     /*   36424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36447 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   36472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36476 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36480 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36482 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36489 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   36492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   36504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36513 */     GIR_RootConstrainSelectedInstOperands,
     /*   36514 */     // GIR_Coverage, 52119,
     /*   36514 */     GIR_EraseRootFromParent_Done,
     /*   36515 */   // Label 630: @36515
     /*   36515 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(36604), // Rule ID 46720 //
     /*   36520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36535 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36554 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36563 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36602 */     GIR_RootConstrainSelectedInstOperands,
     /*   36603 */     // GIR_Coverage, 46720,
     /*   36603 */     GIR_EraseRootFromParent_Done,
     /*   36604 */   // Label 631: @36604
     /*   36604 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(36693), // Rule ID 46721 //
     /*   36609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36624 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36643 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36652 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36691 */     GIR_RootConstrainSelectedInstOperands,
     /*   36692 */     // GIR_Coverage, 46721,
     /*   36692 */     GIR_EraseRootFromParent_Done,
     /*   36693 */   // Label 632: @36693
     /*   36693 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(36782), // Rule ID 46484 //
     /*   36698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36713 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36732 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36741 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   36758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36780 */     GIR_RootConstrainSelectedInstOperands,
     /*   36781 */     // GIR_Coverage, 46484,
     /*   36781 */     GIR_EraseRootFromParent_Done,
     /*   36782 */   // Label 633: @36782
     /*   36782 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(36871), // Rule ID 46485 //
     /*   36787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36802 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36821 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36823 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36830 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   36847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36869 */     GIR_RootConstrainSelectedInstOperands,
     /*   36870 */     // GIR_Coverage, 46485,
     /*   36870 */     GIR_EraseRootFromParent_Done,
     /*   36871 */   // Label 634: @36871
     /*   36871 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(36960), // Rule ID 46600 //
     /*   36876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36891 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36910 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36919 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36958 */     GIR_RootConstrainSelectedInstOperands,
     /*   36959 */     // GIR_Coverage, 46600,
     /*   36959 */     GIR_EraseRootFromParent_Done,
     /*   36960 */   // Label 635: @36960
     /*   36960 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(37049), // Rule ID 46601 //
     /*   36965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36980 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36999 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   37008 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   37008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   37011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   37015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   37025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   37034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37047 */     GIR_RootConstrainSelectedInstOperands,
     /*   37048 */     // GIR_Coverage, 46601,
     /*   37048 */     GIR_EraseRootFromParent_Done,
     /*   37049 */   // Label 636: @37049
     /*   37049 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(37117), // Rule ID 70811 //
     /*   37054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37073 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37091 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37115 */     GIR_RootConstrainSelectedInstOperands,
     /*   37116 */     // GIR_Coverage, 70811,
     /*   37116 */     GIR_EraseRootFromParent_Done,
     /*   37117 */   // Label 637: @37117
     /*   37117 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(37185), // Rule ID 70812 //
     /*   37122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37141 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37159 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37183 */     GIR_RootConstrainSelectedInstOperands,
     /*   37184 */     // GIR_Coverage, 70812,
     /*   37184 */     GIR_EraseRootFromParent_Done,
     /*   37185 */   // Label 638: @37185
     /*   37185 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(37240), // Rule ID 69731 //
     /*   37190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37205 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37218 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37238 */     GIR_RootConstrainSelectedInstOperands,
     /*   37239 */     // GIR_Coverage, 69731,
     /*   37239 */     GIR_EraseRootFromParent_Done,
     /*   37240 */   // Label 639: @37240
     /*   37240 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(37295), // Rule ID 69732 //
     /*   37245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37260 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37273 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37293 */     GIR_RootConstrainSelectedInstOperands,
     /*   37294 */     // GIR_Coverage, 69732,
     /*   37294 */     GIR_EraseRootFromParent_Done,
     /*   37295 */   // Label 640: @37295
     /*   37295 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(37350), // Rule ID 69551 //
     /*   37300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37315 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37328 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37348 */     GIR_RootConstrainSelectedInstOperands,
     /*   37349 */     // GIR_Coverage, 69551,
     /*   37349 */     GIR_EraseRootFromParent_Done,
     /*   37350 */   // Label 641: @37350
     /*   37350 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(37405), // Rule ID 69552 //
     /*   37355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37370 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37383 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37403 */     GIR_RootConstrainSelectedInstOperands,
     /*   37404 */     // GIR_Coverage, 69552,
     /*   37404 */     GIR_EraseRootFromParent_Done,
     /*   37405 */   // Label 642: @37405
     /*   37405 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(37460), // Rule ID 69641 //
     /*   37410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37425 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37438 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37458 */     GIR_RootConstrainSelectedInstOperands,
     /*   37459 */     // GIR_Coverage, 69641,
     /*   37459 */     GIR_EraseRootFromParent_Done,
     /*   37460 */   // Label 643: @37460
     /*   37460 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(37515), // Rule ID 69642 //
     /*   37465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37480 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37493 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37513 */     GIR_RootConstrainSelectedInstOperands,
     /*   37514 */     // GIR_Coverage, 69642,
     /*   37514 */     GIR_EraseRootFromParent_Done,
     /*   37515 */   // Label 644: @37515
     /*   37515 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(37583), // Rule ID 51934 //
     /*   37520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37543 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37557 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37581 */     GIR_RootConstrainSelectedInstOperands,
     /*   37582 */     // GIR_Coverage, 51934,
     /*   37582 */     GIR_EraseRootFromParent_Done,
     /*   37583 */   // Label 645: @37583
     /*   37583 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(37651), // Rule ID 51935 //
     /*   37588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37625 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37649 */     GIR_RootConstrainSelectedInstOperands,
     /*   37650 */     // GIR_Coverage, 51935,
     /*   37650 */     GIR_EraseRootFromParent_Done,
     /*   37651 */   // Label 646: @37651
     /*   37651 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(37706), // Rule ID 46780 //
     /*   37656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37675 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37684 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37704 */     GIR_RootConstrainSelectedInstOperands,
     /*   37705 */     // GIR_Coverage, 46780,
     /*   37705 */     GIR_EraseRootFromParent_Done,
     /*   37706 */   // Label 647: @37706
     /*   37706 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(37761), // Rule ID 46781 //
     /*   37711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37739 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37759 */     GIR_RootConstrainSelectedInstOperands,
     /*   37760 */     // GIR_Coverage, 46781,
     /*   37760 */     GIR_EraseRootFromParent_Done,
     /*   37761 */   // Label 648: @37761
     /*   37761 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(37816), // Rule ID 46540 //
     /*   37766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37785 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37794 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37814 */     GIR_RootConstrainSelectedInstOperands,
     /*   37815 */     // GIR_Coverage, 46540,
     /*   37815 */     GIR_EraseRootFromParent_Done,
     /*   37816 */   // Label 649: @37816
     /*   37816 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(37871), // Rule ID 46541 //
     /*   37821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37840 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37849 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37869 */     GIR_RootConstrainSelectedInstOperands,
     /*   37870 */     // GIR_Coverage, 46541,
     /*   37870 */     GIR_EraseRootFromParent_Done,
     /*   37871 */   // Label 650: @37871
     /*   37871 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(37926), // Rule ID 46660 //
     /*   37876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37895 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37904 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37924 */     GIR_RootConstrainSelectedInstOperands,
     /*   37925 */     // GIR_Coverage, 46660,
     /*   37925 */     GIR_EraseRootFromParent_Done,
     /*   37926 */   // Label 651: @37926
     /*   37926 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(37981), // Rule ID 46661 //
     /*   37931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37950 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37959 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37979 */     GIR_RootConstrainSelectedInstOperands,
     /*   37980 */     // GIR_Coverage, 46661,
     /*   37980 */     GIR_EraseRootFromParent_Done,
     /*   37981 */   // Label 652: @37981
     /*   37981 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(38034), // Rule ID 46166 //
     /*   37986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37997 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   37997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   38000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   38004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   38009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   38011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   38014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   38019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   38021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   38023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38032 */     GIR_RootConstrainSelectedInstOperands,
     /*   38033 */     // GIR_Coverage, 46166,
     /*   38033 */     GIR_EraseRootFromParent_Done,
     /*   38034 */   // Label 653: @38034
     /*   38034 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(38087), // Rule ID 46167 //
     /*   38039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   38042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38050 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   38050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   38053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   38057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   38062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   38064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   38067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   38072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   38074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   38076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38085 */     GIR_RootConstrainSelectedInstOperands,
     /*   38086 */     // GIR_Coverage, 46167,
     /*   38086 */     GIR_EraseRootFromParent_Done,
     /*   38087 */   // Label 654: @38087
     /*   38087 */   GIM_Reject,
     /*   38088 */ // Label 614: @38088
     /*   38088 */ GIM_Reject,
     /*   38089 */ // Label 139: @38089
     /*   38089 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41213),
     /*   38094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38104 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(38200), // Rule ID 70927 //
     /*   38109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38128 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38142 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38157 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38161 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38163 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38174 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38198 */     GIR_RootConstrainSelectedInstOperands,
     /*   38199 */     // GIR_Coverage, 70927,
     /*   38199 */     GIR_EraseRootFromParent_Done,
     /*   38200 */   // Label 656: @38200
     /*   38200 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(38296), // Rule ID 70928 //
     /*   38205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38224 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38238 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38253 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38257 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38259 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38270 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38294 */     GIR_RootConstrainSelectedInstOperands,
     /*   38295 */     // GIR_Coverage, 70928,
     /*   38295 */     GIR_EraseRootFromParent_Done,
     /*   38296 */   // Label 657: @38296
     /*   38296 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(38392), // Rule ID 71215 //
     /*   38301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38320 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38334 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38349 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38353 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38355 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38366 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38390 */     GIR_RootConstrainSelectedInstOperands,
     /*   38391 */     // GIR_Coverage, 71215,
     /*   38391 */     GIR_EraseRootFromParent_Done,
     /*   38392 */   // Label 658: @38392
     /*   38392 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(38488), // Rule ID 71216 //
     /*   38397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38416 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38430 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38445 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38449 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38451 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38462 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38486 */     GIR_RootConstrainSelectedInstOperands,
     /*   38487 */     // GIR_Coverage, 71216,
     /*   38487 */     GIR_EraseRootFromParent_Done,
     /*   38488 */   // Label 659: @38488
     /*   38488 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(38584), // Rule ID 71217 //
     /*   38493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38512 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38526 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38541 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38545 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38547 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38558 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38582 */     GIR_RootConstrainSelectedInstOperands,
     /*   38583 */     // GIR_Coverage, 71217,
     /*   38583 */     GIR_EraseRootFromParent_Done,
     /*   38584 */   // Label 660: @38584
     /*   38584 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(38680), // Rule ID 71218 //
     /*   38589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38608 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38622 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38637 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38641 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38643 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38654 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38678 */     GIR_RootConstrainSelectedInstOperands,
     /*   38679 */     // GIR_Coverage, 71218,
     /*   38679 */     GIR_EraseRootFromParent_Done,
     /*   38680 */   // Label 661: @38680
     /*   38680 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(38776), // Rule ID 71041 //
     /*   38685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38704 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38718 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38733 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38737 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38739 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38750 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   38753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38774 */     GIR_RootConstrainSelectedInstOperands,
     /*   38775 */     // GIR_Coverage, 71041,
     /*   38775 */     GIR_EraseRootFromParent_Done,
     /*   38776 */   // Label 662: @38776
     /*   38776 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(38872), // Rule ID 71042 //
     /*   38781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38800 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38814 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38829 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38833 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38835 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38846 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   38849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38870 */     GIR_RootConstrainSelectedInstOperands,
     /*   38871 */     // GIR_Coverage, 71042,
     /*   38871 */     GIR_EraseRootFromParent_Done,
     /*   38872 */   // Label 663: @38872
     /*   38872 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(38968), // Rule ID 52070 //
     /*   38877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38900 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38914 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38929 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38933 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38935 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38942 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38966 */     GIR_RootConstrainSelectedInstOperands,
     /*   38967 */     // GIR_Coverage, 52070,
     /*   38967 */     GIR_EraseRootFromParent_Done,
     /*   38968 */   // Label 664: @38968
     /*   38968 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(39064), // Rule ID 52071 //
     /*   38973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38996 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39010 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39025 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39029 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39031 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39038 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   39041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39062 */     GIR_RootConstrainSelectedInstOperands,
     /*   39063 */     // GIR_Coverage, 52071,
     /*   39063 */     GIR_EraseRootFromParent_Done,
     /*   39064 */   // Label 665: @39064
     /*   39064 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(39160), // Rule ID 52188 //
     /*   39069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39092 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39106 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39121 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39125 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39127 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39134 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   39137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39158 */     GIR_RootConstrainSelectedInstOperands,
     /*   39159 */     // GIR_Coverage, 52188,
     /*   39159 */     GIR_EraseRootFromParent_Done,
     /*   39160 */   // Label 666: @39160
     /*   39160 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(39256), // Rule ID 52189 //
     /*   39165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39188 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39202 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39217 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39221 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39223 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39230 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   39233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39254 */     GIR_RootConstrainSelectedInstOperands,
     /*   39255 */     // GIR_Coverage, 52189,
     /*   39255 */     GIR_EraseRootFromParent_Done,
     /*   39256 */   // Label 667: @39256
     /*   39256 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(39352), // Rule ID 71213 //
     /*   39261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39284 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39298 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39313 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39317 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39319 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39326 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   39329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   39337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   39341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39350 */     GIR_RootConstrainSelectedInstOperands,
     /*   39351 */     // GIR_Coverage, 71213,
     /*   39351 */     GIR_EraseRootFromParent_Done,
     /*   39352 */   // Label 668: @39352
     /*   39352 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(39448), // Rule ID 71214 //
     /*   39357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39380 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39394 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39396 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39409 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39413 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39415 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39422 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   39425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   39433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   39437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39446 */     GIR_RootConstrainSelectedInstOperands,
     /*   39447 */     // GIR_Coverage, 71214,
     /*   39447 */     GIR_EraseRootFromParent_Done,
     /*   39448 */   // Label 669: @39448
     /*   39448 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(39544), // Rule ID 52128 //
     /*   39453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39476 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39490 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39505 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39509 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39511 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39518 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   39521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39542 */     GIR_RootConstrainSelectedInstOperands,
     /*   39543 */     // GIR_Coverage, 52128,
     /*   39543 */     GIR_EraseRootFromParent_Done,
     /*   39544 */   // Label 670: @39544
     /*   39544 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(39640), // Rule ID 52129 //
     /*   39549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39572 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39586 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39601 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39605 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39607 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39614 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   39617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39638 */     GIR_RootConstrainSelectedInstOperands,
     /*   39639 */     // GIR_Coverage, 52129,
     /*   39639 */     GIR_EraseRootFromParent_Done,
     /*   39640 */   // Label 671: @39640
     /*   39640 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(39729), // Rule ID 46740 //
     /*   39645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39660 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39679 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39688 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39727 */     GIR_RootConstrainSelectedInstOperands,
     /*   39728 */     // GIR_Coverage, 46740,
     /*   39728 */     GIR_EraseRootFromParent_Done,
     /*   39729 */   // Label 672: @39729
     /*   39729 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(39818), // Rule ID 46741 //
     /*   39734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39749 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39768 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39777 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39816 */     GIR_RootConstrainSelectedInstOperands,
     /*   39817 */     // GIR_Coverage, 46741,
     /*   39817 */     GIR_EraseRootFromParent_Done,
     /*   39818 */   // Label 673: @39818
     /*   39818 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(39907), // Rule ID 46504 //
     /*   39823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39838 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39857 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39866 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   39883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39905 */     GIR_RootConstrainSelectedInstOperands,
     /*   39906 */     // GIR_Coverage, 46504,
     /*   39906 */     GIR_EraseRootFromParent_Done,
     /*   39907 */   // Label 674: @39907
     /*   39907 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(39996), // Rule ID 46505 //
     /*   39912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39927 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39946 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39955 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   39972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39994 */     GIR_RootConstrainSelectedInstOperands,
     /*   39995 */     // GIR_Coverage, 46505,
     /*   39995 */     GIR_EraseRootFromParent_Done,
     /*   39996 */   // Label 675: @39996
     /*   39996 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(40085), // Rule ID 46620 //
     /*   40001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   40027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40035 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   40044 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   40044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   40047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   40061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   40070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   40074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40083 */     GIR_RootConstrainSelectedInstOperands,
     /*   40084 */     // GIR_Coverage, 46620,
     /*   40084 */     GIR_EraseRootFromParent_Done,
     /*   40085 */   // Label 676: @40085
     /*   40085 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(40174), // Rule ID 46621 //
     /*   40090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40105 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   40116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40124 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   40133 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   40133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   40136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   40150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   40159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   40163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40172 */     GIR_RootConstrainSelectedInstOperands,
     /*   40173 */     // GIR_Coverage, 46621,
     /*   40173 */     GIR_EraseRootFromParent_Done,
     /*   40174 */   // Label 677: @40174
     /*   40174 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(40242), // Rule ID 70843 //
     /*   40179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   40182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40198 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40216 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   40216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40240 */     GIR_RootConstrainSelectedInstOperands,
     /*   40241 */     // GIR_Coverage, 70843,
     /*   40241 */     GIR_EraseRootFromParent_Done,
     /*   40242 */   // Label 678: @40242
     /*   40242 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(40310), // Rule ID 70844 //
     /*   40247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   40250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40266 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40284 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   40284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40308 */     GIR_RootConstrainSelectedInstOperands,
     /*   40309 */     // GIR_Coverage, 70844,
     /*   40309 */     GIR_EraseRootFromParent_Done,
     /*   40310 */   // Label 679: @40310
     /*   40310 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(40365), // Rule ID 69751 //
     /*   40315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40330 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40343 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40363 */     GIR_RootConstrainSelectedInstOperands,
     /*   40364 */     // GIR_Coverage, 69751,
     /*   40364 */     GIR_EraseRootFromParent_Done,
     /*   40365 */   // Label 680: @40365
     /*   40365 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(40420), // Rule ID 69752 //
     /*   40370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40385 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40398 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40418 */     GIR_RootConstrainSelectedInstOperands,
     /*   40419 */     // GIR_Coverage, 69752,
     /*   40419 */     GIR_EraseRootFromParent_Done,
     /*   40420 */   // Label 681: @40420
     /*   40420 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(40475), // Rule ID 69571 //
     /*   40425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40440 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40453 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40473 */     GIR_RootConstrainSelectedInstOperands,
     /*   40474 */     // GIR_Coverage, 69571,
     /*   40474 */     GIR_EraseRootFromParent_Done,
     /*   40475 */   // Label 682: @40475
     /*   40475 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(40530), // Rule ID 69572 //
     /*   40480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40495 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40508 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40528 */     GIR_RootConstrainSelectedInstOperands,
     /*   40529 */     // GIR_Coverage, 69572,
     /*   40529 */     GIR_EraseRootFromParent_Done,
     /*   40530 */   // Label 683: @40530
     /*   40530 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(40585), // Rule ID 69661 //
     /*   40535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40550 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40563 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40583 */     GIR_RootConstrainSelectedInstOperands,
     /*   40584 */     // GIR_Coverage, 69661,
     /*   40584 */     GIR_EraseRootFromParent_Done,
     /*   40585 */   // Label 684: @40585
     /*   40585 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(40640), // Rule ID 69662 //
     /*   40590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40605 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40618 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40638 */     GIR_RootConstrainSelectedInstOperands,
     /*   40639 */     // GIR_Coverage, 69662,
     /*   40639 */     GIR_EraseRootFromParent_Done,
     /*   40640 */   // Label 685: @40640
     /*   40640 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(40708), // Rule ID 51950 //
     /*   40645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   40648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40668 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40682 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   40682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40706 */     GIR_RootConstrainSelectedInstOperands,
     /*   40707 */     // GIR_Coverage, 51950,
     /*   40707 */     GIR_EraseRootFromParent_Done,
     /*   40708 */   // Label 686: @40708
     /*   40708 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(40776), // Rule ID 51951 //
     /*   40713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   40716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40750 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   40750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40774 */     GIR_RootConstrainSelectedInstOperands,
     /*   40775 */     // GIR_Coverage, 51951,
     /*   40775 */     GIR_EraseRootFromParent_Done,
     /*   40776 */   // Label 687: @40776
     /*   40776 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(40831), // Rule ID 46800 //
     /*   40781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40800 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40809 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40829 */     GIR_RootConstrainSelectedInstOperands,
     /*   40830 */     // GIR_Coverage, 46800,
     /*   40830 */     GIR_EraseRootFromParent_Done,
     /*   40831 */   // Label 688: @40831
     /*   40831 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(40886), // Rule ID 46801 //
     /*   40836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40855 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40864 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40884 */     GIR_RootConstrainSelectedInstOperands,
     /*   40885 */     // GIR_Coverage, 46801,
     /*   40885 */     GIR_EraseRootFromParent_Done,
     /*   40886 */   // Label 689: @40886
     /*   40886 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(40941), // Rule ID 46560 //
     /*   40891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40910 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40919 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40939 */     GIR_RootConstrainSelectedInstOperands,
     /*   40940 */     // GIR_Coverage, 46560,
     /*   40940 */     GIR_EraseRootFromParent_Done,
     /*   40941 */   // Label 690: @40941
     /*   40941 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(40996), // Rule ID 46561 //
     /*   40946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40965 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40974 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40994 */     GIR_RootConstrainSelectedInstOperands,
     /*   40995 */     // GIR_Coverage, 46561,
     /*   40995 */     GIR_EraseRootFromParent_Done,
     /*   40996 */   // Label 691: @40996
     /*   40996 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(41051), // Rule ID 46680 //
     /*   41001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   41004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   41020 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41029 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   41029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   41032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   41036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   41046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41049 */     GIR_RootConstrainSelectedInstOperands,
     /*   41050 */     // GIR_Coverage, 46680,
     /*   41050 */     GIR_EraseRootFromParent_Done,
     /*   41051 */   // Label 692: @41051
     /*   41051 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(41106), // Rule ID 46681 //
     /*   41056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   41059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   41075 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41084 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   41084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   41087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   41091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   41101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41104 */     GIR_RootConstrainSelectedInstOperands,
     /*   41105 */     // GIR_Coverage, 46681,
     /*   41105 */     GIR_EraseRootFromParent_Done,
     /*   41106 */   // Label 693: @41106
     /*   41106 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(41159), // Rule ID 46182 //
     /*   41111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   41114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41122 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   41122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   41125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   41139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   41154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41157 */     GIR_RootConstrainSelectedInstOperands,
     /*   41158 */     // GIR_Coverage, 46182,
     /*   41158 */     GIR_EraseRootFromParent_Done,
     /*   41159 */   // Label 694: @41159
     /*   41159 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(41212), // Rule ID 46183 //
     /*   41164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   41167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41175 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   41175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   41178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   41192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   41207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41210 */     GIR_RootConstrainSelectedInstOperands,
     /*   41211 */     // GIR_Coverage, 46183,
     /*   41211 */     GIR_EraseRootFromParent_Done,
     /*   41212 */   // Label 695: @41212
     /*   41212 */   GIM_Reject,
     /*   41213 */ // Label 655: @41213
     /*   41213 */ GIM_Reject,
     /*   41214 */ // Label 140: @41214
     /*   41214 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(41608),
     /*   41219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   41225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41229 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(41297), // Rule ID 70731 //
     /*   41234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   41253 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41271 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   41274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   41280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41295 */     GIR_RootConstrainSelectedInstOperands,
     /*   41296 */     // GIR_Coverage, 70731,
     /*   41296 */     GIR_EraseRootFromParent_Done,
     /*   41297 */   // Label 697: @41297
     /*   41297 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(41365), // Rule ID 70732 //
     /*   41302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   41321 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41339 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   41342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   41348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41363 */     GIR_RootConstrainSelectedInstOperands,
     /*   41364 */     // GIR_Coverage, 70732,
     /*   41364 */     GIR_EraseRootFromParent_Done,
     /*   41365 */   // Label 698: @41365
     /*   41365 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(41433), // Rule ID 51894 //
     /*   41370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   41393 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41407 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   41410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   41416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   41422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41431 */     GIR_RootConstrainSelectedInstOperands,
     /*   41432 */     // GIR_Coverage, 51894,
     /*   41432 */     GIR_EraseRootFromParent_Done,
     /*   41433 */   // Label 699: @41433
     /*   41433 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(41501), // Rule ID 51895 //
     /*   41438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   41461 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41475 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   41478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   41484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   41490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41499 */     GIR_RootConstrainSelectedInstOperands,
     /*   41500 */     // GIR_Coverage, 51895,
     /*   41500 */     GIR_EraseRootFromParent_Done,
     /*   41501 */   // Label 700: @41501
     /*   41501 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(41554), // Rule ID 46126 //
     /*   41506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41517 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   41517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   41520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   41534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41552 */     GIR_RootConstrainSelectedInstOperands,
     /*   41553 */     // GIR_Coverage, 46126,
     /*   41553 */     GIR_EraseRootFromParent_Done,
     /*   41554 */   // Label 701: @41554
     /*   41554 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(41607), // Rule ID 46127 //
     /*   41559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41570 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   41570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   41573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   41587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41605 */     GIR_RootConstrainSelectedInstOperands,
     /*   41606 */     // GIR_Coverage, 46127,
     /*   41606 */     GIR_EraseRootFromParent_Done,
     /*   41607 */   // Label 702: @41607
     /*   41607 */   GIM_Reject,
     /*   41608 */ // Label 696: @41608
     /*   41608 */ GIM_Reject,
     /*   41609 */ // Label 141: @41609
     /*   41609 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(44733),
     /*   41614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41624 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(41720), // Rule ID 70907 //
     /*   41629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41648 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41662 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41677 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41681 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41683 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41694 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41718 */     GIR_RootConstrainSelectedInstOperands,
     /*   41719 */     // GIR_Coverage, 70907,
     /*   41719 */     GIR_EraseRootFromParent_Done,
     /*   41720 */   // Label 704: @41720
     /*   41720 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(41816), // Rule ID 70908 //
     /*   41725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41744 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41758 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41777 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41779 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41790 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41814 */     GIR_RootConstrainSelectedInstOperands,
     /*   41815 */     // GIR_Coverage, 70908,
     /*   41815 */     GIR_EraseRootFromParent_Done,
     /*   41816 */   // Label 705: @41816
     /*   41816 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(41912), // Rule ID 71155 //
     /*   41821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41840 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41854 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41856 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41869 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41873 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41875 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41886 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41910 */     GIR_RootConstrainSelectedInstOperands,
     /*   41911 */     // GIR_Coverage, 71155,
     /*   41911 */     GIR_EraseRootFromParent_Done,
     /*   41912 */   // Label 706: @41912
     /*   41912 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(42008), // Rule ID 71156 //
     /*   41917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41936 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41950 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41965 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41969 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41971 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41982 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42006 */     GIR_RootConstrainSelectedInstOperands,
     /*   42007 */     // GIR_Coverage, 71156,
     /*   42007 */     GIR_EraseRootFromParent_Done,
     /*   42008 */   // Label 707: @42008
     /*   42008 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(42104), // Rule ID 71157 //
     /*   42013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42046 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42065 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42067 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42076 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42078 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   42085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42102 */     GIR_RootConstrainSelectedInstOperands,
     /*   42103 */     // GIR_Coverage, 71157,
     /*   42103 */     GIR_EraseRootFromParent_Done,
     /*   42104 */   // Label 708: @42104
     /*   42104 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(42200), // Rule ID 71158 //
     /*   42109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42128 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42142 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42157 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42161 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42163 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42174 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   42181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42198 */     GIR_RootConstrainSelectedInstOperands,
     /*   42199 */     // GIR_Coverage, 71158,
     /*   42199 */     GIR_EraseRootFromParent_Done,
     /*   42200 */   // Label 709: @42200
     /*   42200 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(42296), // Rule ID 71021 //
     /*   42205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42224 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42238 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42253 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42257 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42259 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42270 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   42273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   42277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42294 */     GIR_RootConstrainSelectedInstOperands,
     /*   42295 */     // GIR_Coverage, 71021,
     /*   42295 */     GIR_EraseRootFromParent_Done,
     /*   42296 */   // Label 710: @42296
     /*   42296 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(42392), // Rule ID 71022 //
     /*   42301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42320 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42334 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42349 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42353 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42355 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42366 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   42369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   42373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42390 */     GIR_RootConstrainSelectedInstOperands,
     /*   42391 */     // GIR_Coverage, 71022,
     /*   42391 */     GIR_EraseRootFromParent_Done,
     /*   42392 */   // Label 711: @42392
     /*   42392 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(42488), // Rule ID 52050 //
     /*   42397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42420 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42434 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42449 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42453 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42455 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42462 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   42465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42486 */     GIR_RootConstrainSelectedInstOperands,
     /*   42487 */     // GIR_Coverage, 52050,
     /*   42487 */     GIR_EraseRootFromParent_Done,
     /*   42488 */   // Label 712: @42488
     /*   42488 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(42584), // Rule ID 52051 //
     /*   42493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42516 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42530 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42545 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42549 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42551 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42558 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   42561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42582 */     GIR_RootConstrainSelectedInstOperands,
     /*   42583 */     // GIR_Coverage, 52051,
     /*   42583 */     GIR_EraseRootFromParent_Done,
     /*   42584 */   // Label 713: @42584
     /*   42584 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(42680), // Rule ID 52168 //
     /*   42589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42612 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42626 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42641 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42645 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42647 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42654 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42678 */     GIR_RootConstrainSelectedInstOperands,
     /*   42679 */     // GIR_Coverage, 52168,
     /*   42679 */     GIR_EraseRootFromParent_Done,
     /*   42680 */   // Label 714: @42680
     /*   42680 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(42776), // Rule ID 52169 //
     /*   42685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42708 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42722 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42737 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42741 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42743 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42750 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42774 */     GIR_RootConstrainSelectedInstOperands,
     /*   42775 */     // GIR_Coverage, 52169,
     /*   42775 */     GIR_EraseRootFromParent_Done,
     /*   42776 */   // Label 715: @42776
     /*   42776 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(42872), // Rule ID 71153 //
     /*   42781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42804 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42818 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42833 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42837 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42839 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42846 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42870 */     GIR_RootConstrainSelectedInstOperands,
     /*   42871 */     // GIR_Coverage, 71153,
     /*   42871 */     GIR_EraseRootFromParent_Done,
     /*   42872 */   // Label 716: @42872
     /*   42872 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(42968), // Rule ID 71154 //
     /*   42877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42900 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42914 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42929 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42933 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42935 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42942 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42966 */     GIR_RootConstrainSelectedInstOperands,
     /*   42967 */     // GIR_Coverage, 71154,
     /*   42967 */     GIR_EraseRootFromParent_Done,
     /*   42968 */   // Label 717: @42968
     /*   42968 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(43064), // Rule ID 52108 //
     /*   42973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42996 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43010 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   43021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43025 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43029 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   43031 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   43038 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   43041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   43045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   43053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43062 */     GIR_RootConstrainSelectedInstOperands,
     /*   43063 */     // GIR_Coverage, 52108,
     /*   43063 */     GIR_EraseRootFromParent_Done,
     /*   43064 */   // Label 718: @43064
     /*   43064 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(43160), // Rule ID 52109 //
     /*   43069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43092 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43106 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   43117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43121 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43125 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   43127 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   43134 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   43137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   43141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   43149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43158 */     GIR_RootConstrainSelectedInstOperands,
     /*   43159 */     // GIR_Coverage, 52109,
     /*   43159 */     GIR_EraseRootFromParent_Done,
     /*   43160 */   // Label 719: @43160
     /*   43160 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(43249), // Rule ID 46700 //
     /*   43165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43180 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43199 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43208 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   43208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43247 */     GIR_RootConstrainSelectedInstOperands,
     /*   43248 */     // GIR_Coverage, 46700,
     /*   43248 */     GIR_EraseRootFromParent_Done,
     /*   43249 */   // Label 720: @43249
     /*   43249 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(43338), // Rule ID 46701 //
     /*   43254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43269 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43288 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43297 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43336 */     GIR_RootConstrainSelectedInstOperands,
     /*   43337 */     // GIR_Coverage, 46701,
     /*   43337 */     GIR_EraseRootFromParent_Done,
     /*   43338 */   // Label 721: @43338
     /*   43338 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(43427), // Rule ID 46464 //
     /*   43343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43358 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43377 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43379 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43386 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   43386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   43403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43425 */     GIR_RootConstrainSelectedInstOperands,
     /*   43426 */     // GIR_Coverage, 46464,
     /*   43426 */     GIR_EraseRootFromParent_Done,
     /*   43427 */   // Label 722: @43427
     /*   43427 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(43516), // Rule ID 46465 //
     /*   43432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43447 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43466 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43475 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   43492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43514 */     GIR_RootConstrainSelectedInstOperands,
     /*   43515 */     // GIR_Coverage, 46465,
     /*   43515 */     GIR_EraseRootFromParent_Done,
     /*   43516 */   // Label 723: @43516
     /*   43516 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(43605), // Rule ID 46580 //
     /*   43521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43555 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43564 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   43564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43603 */     GIR_RootConstrainSelectedInstOperands,
     /*   43604 */     // GIR_Coverage, 46580,
     /*   43604 */     GIR_EraseRootFromParent_Done,
     /*   43605 */   // Label 724: @43605
     /*   43605 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(43694), // Rule ID 46581 //
     /*   43610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43625 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43644 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43653 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43692 */     GIR_RootConstrainSelectedInstOperands,
     /*   43693 */     // GIR_Coverage, 46581,
     /*   43693 */     GIR_EraseRootFromParent_Done,
     /*   43694 */   // Label 725: @43694
     /*   43694 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(43762), // Rule ID 70787 //
     /*   43699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43718 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43736 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   43736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43760 */     GIR_RootConstrainSelectedInstOperands,
     /*   43761 */     // GIR_Coverage, 70787,
     /*   43761 */     GIR_EraseRootFromParent_Done,
     /*   43762 */   // Label 726: @43762
     /*   43762 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(43830), // Rule ID 70788 //
     /*   43767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43804 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   43804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43828 */     GIR_RootConstrainSelectedInstOperands,
     /*   43829 */     // GIR_Coverage, 70788,
     /*   43829 */     GIR_EraseRootFromParent_Done,
     /*   43830 */   // Label 727: @43830
     /*   43830 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(43885), // Rule ID 69711 //
     /*   43835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43850 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43863 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43883 */     GIR_RootConstrainSelectedInstOperands,
     /*   43884 */     // GIR_Coverage, 69711,
     /*   43884 */     GIR_EraseRootFromParent_Done,
     /*   43885 */   // Label 728: @43885
     /*   43885 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(43940), // Rule ID 69712 //
     /*   43890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43905 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43918 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43938 */     GIR_RootConstrainSelectedInstOperands,
     /*   43939 */     // GIR_Coverage, 69712,
     /*   43939 */     GIR_EraseRootFromParent_Done,
     /*   43940 */   // Label 729: @43940
     /*   43940 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(43995), // Rule ID 69531 //
     /*   43945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43960 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43973 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43993 */     GIR_RootConstrainSelectedInstOperands,
     /*   43994 */     // GIR_Coverage, 69531,
     /*   43994 */     GIR_EraseRootFromParent_Done,
     /*   43995 */   // Label 730: @43995
     /*   43995 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(44050), // Rule ID 69532 //
     /*   44000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44015 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44028 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   44031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44048 */     GIR_RootConstrainSelectedInstOperands,
     /*   44049 */     // GIR_Coverage, 69532,
     /*   44049 */     GIR_EraseRootFromParent_Done,
     /*   44050 */   // Label 731: @44050
     /*   44050 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(44105), // Rule ID 69621 //
     /*   44055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44070 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44083 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   44083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44103 */     GIR_RootConstrainSelectedInstOperands,
     /*   44104 */     // GIR_Coverage, 69621,
     /*   44104 */     GIR_EraseRootFromParent_Done,
     /*   44105 */   // Label 732: @44105
     /*   44105 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(44160), // Rule ID 69622 //
     /*   44110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44125 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44138 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44158 */     GIR_RootConstrainSelectedInstOperands,
     /*   44159 */     // GIR_Coverage, 69622,
     /*   44159 */     GIR_EraseRootFromParent_Done,
     /*   44160 */   // Label 733: @44160
     /*   44160 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(44228), // Rule ID 51922 //
     /*   44165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   44188 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44202 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   44205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   44211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44226 */     GIR_RootConstrainSelectedInstOperands,
     /*   44227 */     // GIR_Coverage, 51922,
     /*   44227 */     GIR_EraseRootFromParent_Done,
     /*   44228 */   // Label 734: @44228
     /*   44228 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(44296), // Rule ID 51923 //
     /*   44233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   44256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44270 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   44273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   44279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44294 */     GIR_RootConstrainSelectedInstOperands,
     /*   44295 */     // GIR_Coverage, 51923,
     /*   44295 */     GIR_EraseRootFromParent_Done,
     /*   44296 */   // Label 735: @44296
     /*   44296 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(44351), // Rule ID 46760 //
     /*   44301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   44316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44320 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44329 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   44329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44349 */     GIR_RootConstrainSelectedInstOperands,
     /*   44350 */     // GIR_Coverage, 46760,
     /*   44350 */     GIR_EraseRootFromParent_Done,
     /*   44351 */   // Label 736: @44351
     /*   44351 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(44406), // Rule ID 46761 //
     /*   44356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   44371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44375 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44384 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44404 */     GIR_RootConstrainSelectedInstOperands,
     /*   44405 */     // GIR_Coverage, 46761,
     /*   44405 */     GIR_EraseRootFromParent_Done,
     /*   44406 */   // Label 737: @44406
     /*   44406 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(44461), // Rule ID 46520 //
     /*   44411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44430 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44439 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   44439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   44442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44459 */     GIR_RootConstrainSelectedInstOperands,
     /*   44460 */     // GIR_Coverage, 46520,
     /*   44460 */     GIR_EraseRootFromParent_Done,
     /*   44461 */   // Label 738: @44461
     /*   44461 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(44516), // Rule ID 46521 //
     /*   44466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44485 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44494 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   44497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44514 */     GIR_RootConstrainSelectedInstOperands,
     /*   44515 */     // GIR_Coverage, 46521,
     /*   44515 */     GIR_EraseRootFromParent_Done,
     /*   44516 */   // Label 739: @44516
     /*   44516 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(44571), // Rule ID 46640 //
     /*   44521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44540 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44549 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   44549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44569 */     GIR_RootConstrainSelectedInstOperands,
     /*   44570 */     // GIR_Coverage, 46640,
     /*   44570 */     GIR_EraseRootFromParent_Done,
     /*   44571 */   // Label 740: @44571
     /*   44571 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(44626), // Rule ID 46641 //
     /*   44576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44595 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44604 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44624 */     GIR_RootConstrainSelectedInstOperands,
     /*   44625 */     // GIR_Coverage, 46641,
     /*   44625 */     GIR_EraseRootFromParent_Done,
     /*   44626 */   // Label 741: @44626
     /*   44626 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(44679), // Rule ID 46154 //
     /*   44631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44642 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   44642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   44645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   44659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44677 */     GIR_RootConstrainSelectedInstOperands,
     /*   44678 */     // GIR_Coverage, 46154,
     /*   44678 */     GIR_EraseRootFromParent_Done,
     /*   44679 */   // Label 742: @44679
     /*   44679 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(44732), // Rule ID 46155 //
     /*   44684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44695 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   44695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   44698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   44712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44730 */     GIR_RootConstrainSelectedInstOperands,
     /*   44731 */     // GIR_Coverage, 46155,
     /*   44731 */     GIR_EraseRootFromParent_Done,
     /*   44732 */   // Label 743: @44732
     /*   44732 */   GIM_Reject,
     /*   44733 */ // Label 703: @44733
     /*   44733 */ GIM_Reject,
     /*   44734 */ // Label 142: @44734
     /*   44734 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(47858),
     /*   44739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44749 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(44845), // Rule ID 70919 //
     /*   44754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44773 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44787 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44806 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44808 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44819 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   44822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44843 */     GIR_RootConstrainSelectedInstOperands,
     /*   44844 */     // GIR_Coverage, 70919,
     /*   44844 */     GIR_EraseRootFromParent_Done,
     /*   44845 */   // Label 745: @44845
     /*   44845 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(44941), // Rule ID 70920 //
     /*   44850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44869 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44883 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44898 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44902 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44904 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44915 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   44918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44939 */     GIR_RootConstrainSelectedInstOperands,
     /*   44940 */     // GIR_Coverage, 70920,
     /*   44940 */     GIR_EraseRootFromParent_Done,
     /*   44941 */   // Label 746: @44941
     /*   44941 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(45037), // Rule ID 71191 //
     /*   44946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44965 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44979 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44994 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44998 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45000 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45011 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45035 */     GIR_RootConstrainSelectedInstOperands,
     /*   45036 */     // GIR_Coverage, 71191,
     /*   45036 */     GIR_EraseRootFromParent_Done,
     /*   45037 */   // Label 747: @45037
     /*   45037 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(45133), // Rule ID 71192 //
     /*   45042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45061 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45075 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45077 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45090 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45094 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45096 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45107 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45131 */     GIR_RootConstrainSelectedInstOperands,
     /*   45132 */     // GIR_Coverage, 71192,
     /*   45132 */     GIR_EraseRootFromParent_Done,
     /*   45133 */   // Label 748: @45133
     /*   45133 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(45229), // Rule ID 71193 //
     /*   45138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45157 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45171 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45186 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45190 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45192 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45203 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45227 */     GIR_RootConstrainSelectedInstOperands,
     /*   45228 */     // GIR_Coverage, 71193,
     /*   45228 */     GIR_EraseRootFromParent_Done,
     /*   45229 */   // Label 749: @45229
     /*   45229 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(45325), // Rule ID 71194 //
     /*   45234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45253 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45267 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45282 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45286 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45288 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45299 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45323 */     GIR_RootConstrainSelectedInstOperands,
     /*   45324 */     // GIR_Coverage, 71194,
     /*   45324 */     GIR_EraseRootFromParent_Done,
     /*   45325 */   // Label 750: @45325
     /*   45325 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(45421), // Rule ID 71033 //
     /*   45330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45349 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45363 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45378 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45382 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45384 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45395 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45419 */     GIR_RootConstrainSelectedInstOperands,
     /*   45420 */     // GIR_Coverage, 71033,
     /*   45420 */     GIR_EraseRootFromParent_Done,
     /*   45421 */   // Label 751: @45421
     /*   45421 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(45517), // Rule ID 71034 //
     /*   45426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45445 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45459 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45474 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45478 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45480 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45491 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45515 */     GIR_RootConstrainSelectedInstOperands,
     /*   45516 */     // GIR_Coverage, 71034,
     /*   45516 */     GIR_EraseRootFromParent_Done,
     /*   45517 */   // Label 752: @45517
     /*   45517 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(45613), // Rule ID 52062 //
     /*   45522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45545 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45559 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45574 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45578 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45580 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45587 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   45590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45611 */     GIR_RootConstrainSelectedInstOperands,
     /*   45612 */     // GIR_Coverage, 52062,
     /*   45612 */     GIR_EraseRootFromParent_Done,
     /*   45613 */   // Label 753: @45613
     /*   45613 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(45709), // Rule ID 52063 //
     /*   45618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45641 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45655 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45674 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45676 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45683 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   45686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45707 */     GIR_RootConstrainSelectedInstOperands,
     /*   45708 */     // GIR_Coverage, 52063,
     /*   45708 */     GIR_EraseRootFromParent_Done,
     /*   45709 */   // Label 754: @45709
     /*   45709 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(45805), // Rule ID 52180 //
     /*   45714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45737 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45751 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45766 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45770 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45772 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45779 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45803 */     GIR_RootConstrainSelectedInstOperands,
     /*   45804 */     // GIR_Coverage, 52180,
     /*   45804 */     GIR_EraseRootFromParent_Done,
     /*   45805 */   // Label 755: @45805
     /*   45805 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(45901), // Rule ID 52181 //
     /*   45810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45833 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45847 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45862 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45866 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45868 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45875 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45899 */     GIR_RootConstrainSelectedInstOperands,
     /*   45900 */     // GIR_Coverage, 52181,
     /*   45900 */     GIR_EraseRootFromParent_Done,
     /*   45901 */   // Label 756: @45901
     /*   45901 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(45997), // Rule ID 71189 //
     /*   45906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45929 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45943 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45962 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45964 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45971 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45995 */     GIR_RootConstrainSelectedInstOperands,
     /*   45996 */     // GIR_Coverage, 71189,
     /*   45996 */     GIR_EraseRootFromParent_Done,
     /*   45997 */   // Label 757: @45997
     /*   45997 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(46093), // Rule ID 71190 //
     /*   46002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46025 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   46031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46039 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   46050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46054 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46058 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   46060 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   46067 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   46070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   46074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   46078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   46082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46091 */     GIR_RootConstrainSelectedInstOperands,
     /*   46092 */     // GIR_Coverage, 71190,
     /*   46092 */     GIR_EraseRootFromParent_Done,
     /*   46093 */   // Label 758: @46093
     /*   46093 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(46189), // Rule ID 52120 //
     /*   46098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   46127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46135 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   46146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46150 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46154 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   46156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   46163 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   46166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   46170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   46178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46187 */     GIR_RootConstrainSelectedInstOperands,
     /*   46188 */     // GIR_Coverage, 52120,
     /*   46188 */     GIR_EraseRootFromParent_Done,
     /*   46189 */   // Label 759: @46189
     /*   46189 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(46285), // Rule ID 52121 //
     /*   46194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46217 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   46223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46231 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46233 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   46242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46246 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46250 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   46252 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   46259 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   46262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   46266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   46274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46283 */     GIR_RootConstrainSelectedInstOperands,
     /*   46284 */     // GIR_Coverage, 52121,
     /*   46284 */     GIR_EraseRootFromParent_Done,
     /*   46285 */   // Label 760: @46285
     /*   46285 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(46374), // Rule ID 46724 //
     /*   46290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46305 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46324 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46333 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46372 */     GIR_RootConstrainSelectedInstOperands,
     /*   46373 */     // GIR_Coverage, 46724,
     /*   46373 */     GIR_EraseRootFromParent_Done,
     /*   46374 */   // Label 761: @46374
     /*   46374 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(46463), // Rule ID 46725 //
     /*   46379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46394 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46413 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46422 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46461 */     GIR_RootConstrainSelectedInstOperands,
     /*   46462 */     // GIR_Coverage, 46725,
     /*   46462 */     GIR_EraseRootFromParent_Done,
     /*   46463 */   // Label 762: @46463
     /*   46463 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(46552), // Rule ID 46488 //
     /*   46468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46483 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46502 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46511 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   46528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46550 */     GIR_RootConstrainSelectedInstOperands,
     /*   46551 */     // GIR_Coverage, 46488,
     /*   46551 */     GIR_EraseRootFromParent_Done,
     /*   46552 */   // Label 763: @46552
     /*   46552 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(46641), // Rule ID 46489 //
     /*   46557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46572 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46591 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46600 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   46617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46639 */     GIR_RootConstrainSelectedInstOperands,
     /*   46640 */     // GIR_Coverage, 46489,
     /*   46640 */     GIR_EraseRootFromParent_Done,
     /*   46641 */   // Label 764: @46641
     /*   46641 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(46730), // Rule ID 46604 //
     /*   46646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46680 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46689 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46728 */     GIR_RootConstrainSelectedInstOperands,
     /*   46729 */     // GIR_Coverage, 46604,
     /*   46729 */     GIR_EraseRootFromParent_Done,
     /*   46730 */   // Label 765: @46730
     /*   46730 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(46819), // Rule ID 46605 //
     /*   46735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46769 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46778 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46817 */     GIR_RootConstrainSelectedInstOperands,
     /*   46818 */     // GIR_Coverage, 46605,
     /*   46818 */     GIR_EraseRootFromParent_Done,
     /*   46819 */   // Label 766: @46819
     /*   46819 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(46887), // Rule ID 70819 //
     /*   46824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46843 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46861 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   46861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46885 */     GIR_RootConstrainSelectedInstOperands,
     /*   46886 */     // GIR_Coverage, 70819,
     /*   46886 */     GIR_EraseRootFromParent_Done,
     /*   46887 */   // Label 767: @46887
     /*   46887 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(46955), // Rule ID 70820 //
     /*   46892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46911 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46929 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46953 */     GIR_RootConstrainSelectedInstOperands,
     /*   46954 */     // GIR_Coverage, 70820,
     /*   46954 */     GIR_EraseRootFromParent_Done,
     /*   46955 */   // Label 768: @46955
     /*   46955 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(47010), // Rule ID 69735 //
     /*   46960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46975 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46988 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47008 */     GIR_RootConstrainSelectedInstOperands,
     /*   47009 */     // GIR_Coverage, 69735,
     /*   47009 */     GIR_EraseRootFromParent_Done,
     /*   47010 */   // Label 769: @47010
     /*   47010 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(47065), // Rule ID 69736 //
     /*   47015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   47026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47030 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47043 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47063 */     GIR_RootConstrainSelectedInstOperands,
     /*   47064 */     // GIR_Coverage, 69736,
     /*   47064 */     GIR_EraseRootFromParent_Done,
     /*   47065 */   // Label 770: @47065
     /*   47065 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(47120), // Rule ID 69555 //
     /*   47070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47085 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47098 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47118 */     GIR_RootConstrainSelectedInstOperands,
     /*   47119 */     // GIR_Coverage, 69555,
     /*   47119 */     GIR_EraseRootFromParent_Done,
     /*   47120 */   // Label 771: @47120
     /*   47120 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(47175), // Rule ID 69556 //
     /*   47125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47140 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47153 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47173 */     GIR_RootConstrainSelectedInstOperands,
     /*   47174 */     // GIR_Coverage, 69556,
     /*   47174 */     GIR_EraseRootFromParent_Done,
     /*   47175 */   // Label 772: @47175
     /*   47175 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(47230), // Rule ID 69645 //
     /*   47180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47195 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47208 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47228 */     GIR_RootConstrainSelectedInstOperands,
     /*   47229 */     // GIR_Coverage, 69645,
     /*   47229 */     GIR_EraseRootFromParent_Done,
     /*   47230 */   // Label 773: @47230
     /*   47230 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(47285), // Rule ID 69646 //
     /*   47235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47250 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47263 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47283 */     GIR_RootConstrainSelectedInstOperands,
     /*   47284 */     // GIR_Coverage, 69646,
     /*   47284 */     GIR_EraseRootFromParent_Done,
     /*   47285 */   // Label 774: @47285
     /*   47285 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(47353), // Rule ID 51938 //
     /*   47290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   47313 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47327 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   47330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   47336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47351 */     GIR_RootConstrainSelectedInstOperands,
     /*   47352 */     // GIR_Coverage, 51938,
     /*   47352 */     GIR_EraseRootFromParent_Done,
     /*   47353 */   // Label 775: @47353
     /*   47353 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(47421), // Rule ID 51939 //
     /*   47358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   47381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47395 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   47398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   47404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47419 */     GIR_RootConstrainSelectedInstOperands,
     /*   47420 */     // GIR_Coverage, 51939,
     /*   47420 */     GIR_EraseRootFromParent_Done,
     /*   47421 */   // Label 776: @47421
     /*   47421 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(47476), // Rule ID 46784 //
     /*   47426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   47441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47445 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47454 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47474 */     GIR_RootConstrainSelectedInstOperands,
     /*   47475 */     // GIR_Coverage, 46784,
     /*   47475 */     GIR_EraseRootFromParent_Done,
     /*   47476 */   // Label 777: @47476
     /*   47476 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(47531), // Rule ID 46785 //
     /*   47481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   47496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47509 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47529 */     GIR_RootConstrainSelectedInstOperands,
     /*   47530 */     // GIR_Coverage, 46785,
     /*   47530 */     GIR_EraseRootFromParent_Done,
     /*   47531 */   // Label 778: @47531
     /*   47531 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(47586), // Rule ID 46544 //
     /*   47536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47555 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47564 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47584 */     GIR_RootConstrainSelectedInstOperands,
     /*   47585 */     // GIR_Coverage, 46544,
     /*   47585 */     GIR_EraseRootFromParent_Done,
     /*   47586 */   // Label 779: @47586
     /*   47586 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(47641), // Rule ID 46545 //
     /*   47591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47619 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47639 */     GIR_RootConstrainSelectedInstOperands,
     /*   47640 */     // GIR_Coverage, 46545,
     /*   47640 */     GIR_EraseRootFromParent_Done,
     /*   47641 */   // Label 780: @47641
     /*   47641 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(47696), // Rule ID 46664 //
     /*   47646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47665 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47674 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47694 */     GIR_RootConstrainSelectedInstOperands,
     /*   47695 */     // GIR_Coverage, 46664,
     /*   47695 */     GIR_EraseRootFromParent_Done,
     /*   47696 */   // Label 781: @47696
     /*   47696 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(47751), // Rule ID 46665 //
     /*   47701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47720 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47729 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47749 */     GIR_RootConstrainSelectedInstOperands,
     /*   47750 */     // GIR_Coverage, 46665,
     /*   47750 */     GIR_EraseRootFromParent_Done,
     /*   47751 */   // Label 782: @47751
     /*   47751 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(47804), // Rule ID 46170 //
     /*   47756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47767 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   47767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   47770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   47784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47802 */     GIR_RootConstrainSelectedInstOperands,
     /*   47803 */     // GIR_Coverage, 46170,
     /*   47803 */     GIR_EraseRootFromParent_Done,
     /*   47804 */   // Label 783: @47804
     /*   47804 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(47857), // Rule ID 46171 //
     /*   47809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47820 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   47820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   47823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   47837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47855 */     GIR_RootConstrainSelectedInstOperands,
     /*   47856 */     // GIR_Coverage, 46171,
     /*   47856 */     GIR_EraseRootFromParent_Done,
     /*   47857 */   // Label 784: @47857
     /*   47857 */   GIM_Reject,
     /*   47858 */ // Label 744: @47858
     /*   47858 */ GIM_Reject,
     /*   47859 */ // Label 143: @47859
     /*   47859 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(50983),
     /*   47864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47874 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(47970), // Rule ID 70929 //
     /*   47879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47898 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47912 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47927 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47931 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47944 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   47947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47968 */     GIR_RootConstrainSelectedInstOperands,
     /*   47969 */     // GIR_Coverage, 70929,
     /*   47969 */     GIR_EraseRootFromParent_Done,
     /*   47970 */   // Label 786: @47970
     /*   47970 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(48066), // Rule ID 70930 //
     /*   47975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47994 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48008 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48023 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48027 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48029 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48040 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48064 */     GIR_RootConstrainSelectedInstOperands,
     /*   48065 */     // GIR_Coverage, 70930,
     /*   48065 */     GIR_EraseRootFromParent_Done,
     /*   48066 */   // Label 787: @48066
     /*   48066 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(48162), // Rule ID 71221 //
     /*   48071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48090 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48104 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48119 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48123 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48125 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48136 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48160 */     GIR_RootConstrainSelectedInstOperands,
     /*   48161 */     // GIR_Coverage, 71221,
     /*   48161 */     GIR_EraseRootFromParent_Done,
     /*   48162 */   // Label 788: @48162
     /*   48162 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(48258), // Rule ID 71222 //
     /*   48167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48200 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48215 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48219 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48221 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48232 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48256 */     GIR_RootConstrainSelectedInstOperands,
     /*   48257 */     // GIR_Coverage, 71222,
     /*   48257 */     GIR_EraseRootFromParent_Done,
     /*   48258 */   // Label 789: @48258
     /*   48258 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(48354), // Rule ID 71223 //
     /*   48263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48282 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48296 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48311 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48315 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48317 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48328 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48352 */     GIR_RootConstrainSelectedInstOperands,
     /*   48353 */     // GIR_Coverage, 71223,
     /*   48353 */     GIR_EraseRootFromParent_Done,
     /*   48354 */   // Label 790: @48354
     /*   48354 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(48450), // Rule ID 71224 //
     /*   48359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48378 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48392 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48407 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48411 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48413 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48424 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48448 */     GIR_RootConstrainSelectedInstOperands,
     /*   48449 */     // GIR_Coverage, 71224,
     /*   48449 */     GIR_EraseRootFromParent_Done,
     /*   48450 */   // Label 791: @48450
     /*   48450 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(48546), // Rule ID 71043 //
     /*   48455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48474 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48488 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48503 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48507 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48509 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48520 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48544 */     GIR_RootConstrainSelectedInstOperands,
     /*   48545 */     // GIR_Coverage, 71043,
     /*   48545 */     GIR_EraseRootFromParent_Done,
     /*   48546 */   // Label 792: @48546
     /*   48546 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(48642), // Rule ID 71044 //
     /*   48551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48570 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48584 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48599 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48603 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48605 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48616 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48640 */     GIR_RootConstrainSelectedInstOperands,
     /*   48641 */     // GIR_Coverage, 71044,
     /*   48641 */     GIR_EraseRootFromParent_Done,
     /*   48642 */   // Label 793: @48642
     /*   48642 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(48738), // Rule ID 52072 //
     /*   48647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48670 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48684 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48699 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48703 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48705 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48712 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48736 */     GIR_RootConstrainSelectedInstOperands,
     /*   48737 */     // GIR_Coverage, 52072,
     /*   48737 */     GIR_EraseRootFromParent_Done,
     /*   48738 */   // Label 794: @48738
     /*   48738 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(48834), // Rule ID 52073 //
     /*   48743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48766 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48780 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48795 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48799 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48801 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48808 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48832 */     GIR_RootConstrainSelectedInstOperands,
     /*   48833 */     // GIR_Coverage, 52073,
     /*   48833 */     GIR_EraseRootFromParent_Done,
     /*   48834 */   // Label 795: @48834
     /*   48834 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(48930), // Rule ID 52190 //
     /*   48839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48862 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48876 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48891 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48895 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48897 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48904 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48928 */     GIR_RootConstrainSelectedInstOperands,
     /*   48929 */     // GIR_Coverage, 52190,
     /*   48929 */     GIR_EraseRootFromParent_Done,
     /*   48930 */   // Label 796: @48930
     /*   48930 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(49026), // Rule ID 52191 //
     /*   48935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48958 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48972 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48987 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48991 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48993 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   49000 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   49003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   49007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   49015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49024 */     GIR_RootConstrainSelectedInstOperands,
     /*   49025 */     // GIR_Coverage, 52191,
     /*   49025 */     GIR_EraseRootFromParent_Done,
     /*   49026 */   // Label 797: @49026
     /*   49026 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(49122), // Rule ID 71219 //
     /*   49031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49054 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   49060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49068 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   49079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49083 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49087 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   49089 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   49096 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   49099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   49103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   49107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   49111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49120 */     GIR_RootConstrainSelectedInstOperands,
     /*   49121 */     // GIR_Coverage, 71219,
     /*   49121 */     GIR_EraseRootFromParent_Done,
     /*   49122 */   // Label 798: @49122
     /*   49122 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(49218), // Rule ID 71220 //
     /*   49127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   49156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49164 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   49175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49183 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   49185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   49192 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   49195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   49199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   49203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   49207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49216 */     GIR_RootConstrainSelectedInstOperands,
     /*   49217 */     // GIR_Coverage, 71220,
     /*   49217 */     GIR_EraseRootFromParent_Done,
     /*   49218 */   // Label 799: @49218
     /*   49218 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(49314), // Rule ID 52130 //
     /*   49223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   49252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49260 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   49271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49275 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49279 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   49281 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49286 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   49288 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   49291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   49295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   49303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49312 */     GIR_RootConstrainSelectedInstOperands,
     /*   49313 */     // GIR_Coverage, 52130,
     /*   49313 */     GIR_EraseRootFromParent_Done,
     /*   49314 */   // Label 800: @49314
     /*   49314 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(49410), // Rule ID 52131 //
     /*   49319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49342 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   49348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49356 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   49367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49371 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49375 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   49377 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   49384 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   49387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   49391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   49399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49408 */     GIR_RootConstrainSelectedInstOperands,
     /*   49409 */     // GIR_Coverage, 52131,
     /*   49409 */     GIR_EraseRootFromParent_Done,
     /*   49410 */   // Label 801: @49410
     /*   49410 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(49499), // Rule ID 46744 //
     /*   49415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49430 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49449 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49458 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49497 */     GIR_RootConstrainSelectedInstOperands,
     /*   49498 */     // GIR_Coverage, 46744,
     /*   49498 */     GIR_EraseRootFromParent_Done,
     /*   49499 */   // Label 802: @49499
     /*   49499 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(49588), // Rule ID 46745 //
     /*   49504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49519 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49538 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49547 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49586 */     GIR_RootConstrainSelectedInstOperands,
     /*   49587 */     // GIR_Coverage, 46745,
     /*   49587 */     GIR_EraseRootFromParent_Done,
     /*   49588 */   // Label 803: @49588
     /*   49588 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(49677), // Rule ID 46508 //
     /*   49593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49608 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49627 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49636 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   49653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49675 */     GIR_RootConstrainSelectedInstOperands,
     /*   49676 */     // GIR_Coverage, 46508,
     /*   49676 */     GIR_EraseRootFromParent_Done,
     /*   49677 */   // Label 804: @49677
     /*   49677 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(49766), // Rule ID 46509 //
     /*   49682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49716 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49725 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   49742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49764 */     GIR_RootConstrainSelectedInstOperands,
     /*   49765 */     // GIR_Coverage, 46509,
     /*   49765 */     GIR_EraseRootFromParent_Done,
     /*   49766 */   // Label 805: @49766
     /*   49766 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(49855), // Rule ID 46624 //
     /*   49771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49805 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49814 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49853 */     GIR_RootConstrainSelectedInstOperands,
     /*   49854 */     // GIR_Coverage, 46624,
     /*   49854 */     GIR_EraseRootFromParent_Done,
     /*   49855 */   // Label 806: @49855
     /*   49855 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(49944), // Rule ID 46625 //
     /*   49860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49875 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49894 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49903 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49942 */     GIR_RootConstrainSelectedInstOperands,
     /*   49943 */     // GIR_Coverage, 46625,
     /*   49943 */     GIR_EraseRootFromParent_Done,
     /*   49944 */   // Label 807: @49944
     /*   49944 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(50012), // Rule ID 70851 //
     /*   49949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   49952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49986 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   49986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50010 */     GIR_RootConstrainSelectedInstOperands,
     /*   50011 */     // GIR_Coverage, 70851,
     /*   50011 */     GIR_EraseRootFromParent_Done,
     /*   50012 */   // Label 808: @50012
     /*   50012 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(50080), // Rule ID 70852 //
     /*   50017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   50032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   50036 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50054 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   50054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   50057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50078 */     GIR_RootConstrainSelectedInstOperands,
     /*   50079 */     // GIR_Coverage, 70852,
     /*   50079 */     GIR_EraseRootFromParent_Done,
     /*   50080 */   // Label 809: @50080
     /*   50080 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(50135), // Rule ID 69755 //
     /*   50085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50113 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50133 */     GIR_RootConstrainSelectedInstOperands,
     /*   50134 */     // GIR_Coverage, 69755,
     /*   50134 */     GIR_EraseRootFromParent_Done,
     /*   50135 */   // Label 810: @50135
     /*   50135 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(50190), // Rule ID 69756 //
     /*   50140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50155 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50168 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50188 */     GIR_RootConstrainSelectedInstOperands,
     /*   50189 */     // GIR_Coverage, 69756,
     /*   50189 */     GIR_EraseRootFromParent_Done,
     /*   50190 */   // Label 811: @50190
     /*   50190 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(50245), // Rule ID 69575 //
     /*   50195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50223 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50243 */     GIR_RootConstrainSelectedInstOperands,
     /*   50244 */     // GIR_Coverage, 69575,
     /*   50244 */     GIR_EraseRootFromParent_Done,
     /*   50245 */   // Label 812: @50245
     /*   50245 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(50300), // Rule ID 69576 //
     /*   50250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50265 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50278 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50298 */     GIR_RootConstrainSelectedInstOperands,
     /*   50299 */     // GIR_Coverage, 69576,
     /*   50299 */     GIR_EraseRootFromParent_Done,
     /*   50300 */   // Label 813: @50300
     /*   50300 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(50355), // Rule ID 69665 //
     /*   50305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50320 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50333 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50353 */     GIR_RootConstrainSelectedInstOperands,
     /*   50354 */     // GIR_Coverage, 69665,
     /*   50354 */     GIR_EraseRootFromParent_Done,
     /*   50355 */   // Label 814: @50355
     /*   50355 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(50410), // Rule ID 69666 //
     /*   50360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50375 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50388 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50408 */     GIR_RootConstrainSelectedInstOperands,
     /*   50409 */     // GIR_Coverage, 69666,
     /*   50409 */     GIR_EraseRootFromParent_Done,
     /*   50410 */   // Label 815: @50410
     /*   50410 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(50478), // Rule ID 51954 //
     /*   50415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   50418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   50434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   50438 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50452 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   50452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   50455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50476 */     GIR_RootConstrainSelectedInstOperands,
     /*   50477 */     // GIR_Coverage, 51954,
     /*   50477 */     GIR_EraseRootFromParent_Done,
     /*   50478 */   // Label 816: @50478
     /*   50478 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(50546), // Rule ID 51955 //
     /*   50483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   50502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   50506 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50520 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   50520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   50523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50544 */     GIR_RootConstrainSelectedInstOperands,
     /*   50545 */     // GIR_Coverage, 51955,
     /*   50545 */     GIR_EraseRootFromParent_Done,
     /*   50546 */   // Label 817: @50546
     /*   50546 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(50601), // Rule ID 46804 //
     /*   50551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50570 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50579 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50599 */     GIR_RootConstrainSelectedInstOperands,
     /*   50600 */     // GIR_Coverage, 46804,
     /*   50600 */     GIR_EraseRootFromParent_Done,
     /*   50601 */   // Label 818: @50601
     /*   50601 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(50656), // Rule ID 46805 //
     /*   50606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50625 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50634 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50654 */     GIR_RootConstrainSelectedInstOperands,
     /*   50655 */     // GIR_Coverage, 46805,
     /*   50655 */     GIR_EraseRootFromParent_Done,
     /*   50656 */   // Label 819: @50656
     /*   50656 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(50711), // Rule ID 46564 //
     /*   50661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50680 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50689 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50709 */     GIR_RootConstrainSelectedInstOperands,
     /*   50710 */     // GIR_Coverage, 46564,
     /*   50710 */     GIR_EraseRootFromParent_Done,
     /*   50711 */   // Label 820: @50711
     /*   50711 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(50766), // Rule ID 46565 //
     /*   50716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50735 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50744 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50764 */     GIR_RootConstrainSelectedInstOperands,
     /*   50765 */     // GIR_Coverage, 46565,
     /*   50765 */     GIR_EraseRootFromParent_Done,
     /*   50766 */   // Label 821: @50766
     /*   50766 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(50821), // Rule ID 46684 //
     /*   50771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50799 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50819 */     GIR_RootConstrainSelectedInstOperands,
     /*   50820 */     // GIR_Coverage, 46684,
     /*   50820 */     GIR_EraseRootFromParent_Done,
     /*   50821 */   // Label 822: @50821
     /*   50821 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(50876), // Rule ID 46685 //
     /*   50826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50845 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50854 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50874 */     GIR_RootConstrainSelectedInstOperands,
     /*   50875 */     // GIR_Coverage, 46685,
     /*   50875 */     GIR_EraseRootFromParent_Done,
     /*   50876 */   // Label 823: @50876
     /*   50876 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(50929), // Rule ID 46186 //
     /*   50881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   50884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50892 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   50892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   50895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   50909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50927 */     GIR_RootConstrainSelectedInstOperands,
     /*   50928 */     // GIR_Coverage, 46186,
     /*   50928 */     GIR_EraseRootFromParent_Done,
     /*   50929 */   // Label 824: @50929
     /*   50929 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(50982), // Rule ID 46187 //
     /*   50934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50945 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   50945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   50948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   50962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50980 */     GIR_RootConstrainSelectedInstOperands,
     /*   50981 */     // GIR_Coverage, 46187,
     /*   50981 */     GIR_EraseRootFromParent_Done,
     /*   50982 */   // Label 825: @50982
     /*   50982 */   GIM_Reject,
     /*   50983 */ // Label 785: @50983
     /*   50983 */ GIM_Reject,
     /*   50984 */ // Label 144: @50984
     /*   50984 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(51378),
     /*   50989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50999 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(51067), // Rule ID 70763 //
     /*   51004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   51023 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   51041 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   51044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   51050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51065 */     GIR_RootConstrainSelectedInstOperands,
     /*   51066 */     // GIR_Coverage, 70763,
     /*   51066 */     GIR_EraseRootFromParent_Done,
     /*   51067 */   // Label 827: @51067
     /*   51067 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(51135), // Rule ID 70764 //
     /*   51072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   51091 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   51109 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   51112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   51118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51133 */     GIR_RootConstrainSelectedInstOperands,
     /*   51134 */     // GIR_Coverage, 70764,
     /*   51134 */     GIR_EraseRootFromParent_Done,
     /*   51135 */   // Label 828: @51135
     /*   51135 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(51203), // Rule ID 51910 //
     /*   51140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   51163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   51177 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   51180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   51186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   51192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51201 */     GIR_RootConstrainSelectedInstOperands,
     /*   51202 */     // GIR_Coverage, 51910,
     /*   51202 */     GIR_EraseRootFromParent_Done,
     /*   51203 */   // Label 829: @51203
     /*   51203 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(51271), // Rule ID 51911 //
     /*   51208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   51231 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   51245 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   51248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   51254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   51260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51269 */     GIR_RootConstrainSelectedInstOperands,
     /*   51270 */     // GIR_Coverage, 51911,
     /*   51270 */     GIR_EraseRootFromParent_Done,
     /*   51271 */   // Label 830: @51271
     /*   51271 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(51324), // Rule ID 46142 //
     /*   51276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51287 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   51287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   51290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   51304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   51311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51322 */     GIR_RootConstrainSelectedInstOperands,
     /*   51323 */     // GIR_Coverage, 46142,
     /*   51323 */     GIR_EraseRootFromParent_Done,
     /*   51324 */   // Label 831: @51324
     /*   51324 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(51377), // Rule ID 46143 //
     /*   51329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51340 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   51340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   51343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   51357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   51364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51375 */     GIR_RootConstrainSelectedInstOperands,
     /*   51376 */     // GIR_Coverage, 46143,
     /*   51376 */     GIR_EraseRootFromParent_Done,
     /*   51377 */   // Label 832: @51377
     /*   51377 */   GIM_Reject,
     /*   51378 */ // Label 826: @51378
     /*   51378 */ GIM_Reject,
     /*   51379 */ // Label 145: @51379
     /*   51379 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(54503),
     /*   51384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51394 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(51490), // Rule ID 70909 //
     /*   51399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51418 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51432 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51447 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51451 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51453 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51464 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51488 */     GIR_RootConstrainSelectedInstOperands,
     /*   51489 */     // GIR_Coverage, 70909,
     /*   51489 */     GIR_EraseRootFromParent_Done,
     /*   51490 */   // Label 834: @51490
     /*   51490 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(51586), // Rule ID 70910 //
     /*   51495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51514 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51528 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51543 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51547 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51549 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51560 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51584 */     GIR_RootConstrainSelectedInstOperands,
     /*   51585 */     // GIR_Coverage, 70910,
     /*   51585 */     GIR_EraseRootFromParent_Done,
     /*   51586 */   // Label 835: @51586
     /*   51586 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(51682), // Rule ID 71161 //
     /*   51591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51624 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51639 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51643 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51645 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51654 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51656 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51680 */     GIR_RootConstrainSelectedInstOperands,
     /*   51681 */     // GIR_Coverage, 71161,
     /*   51681 */     GIR_EraseRootFromParent_Done,
     /*   51682 */   // Label 836: @51682
     /*   51682 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(51778), // Rule ID 71162 //
     /*   51687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51706 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51720 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51735 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51739 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51741 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51752 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51776 */     GIR_RootConstrainSelectedInstOperands,
     /*   51777 */     // GIR_Coverage, 71162,
     /*   51777 */     GIR_EraseRootFromParent_Done,
     /*   51778 */   // Label 837: @51778
     /*   51778 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(51874), // Rule ID 71163 //
     /*   51783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51802 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51816 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51835 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51837 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51848 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51872 */     GIR_RootConstrainSelectedInstOperands,
     /*   51873 */     // GIR_Coverage, 71163,
     /*   51873 */     GIR_EraseRootFromParent_Done,
     /*   51874 */   // Label 838: @51874
     /*   51874 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(51970), // Rule ID 71164 //
     /*   51879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51898 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51912 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51927 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51931 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51944 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51968 */     GIR_RootConstrainSelectedInstOperands,
     /*   51969 */     // GIR_Coverage, 71164,
     /*   51969 */     GIR_EraseRootFromParent_Done,
     /*   51970 */   // Label 839: @51970
     /*   51970 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(52066), // Rule ID 71023 //
     /*   51975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51994 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52008 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52023 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52027 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52029 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52040 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   52047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52064 */     GIR_RootConstrainSelectedInstOperands,
     /*   52065 */     // GIR_Coverage, 71023,
     /*   52065 */     GIR_EraseRootFromParent_Done,
     /*   52066 */   // Label 840: @52066
     /*   52066 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(52162), // Rule ID 71024 //
     /*   52071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52090 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52104 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52119 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52123 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52125 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52136 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   52143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52160 */     GIR_RootConstrainSelectedInstOperands,
     /*   52161 */     // GIR_Coverage, 71024,
     /*   52161 */     GIR_EraseRootFromParent_Done,
     /*   52162 */   // Label 841: @52162
     /*   52162 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(52258), // Rule ID 52052 //
     /*   52167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52190 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52204 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52219 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52223 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52225 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52232 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   52235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52256 */     GIR_RootConstrainSelectedInstOperands,
     /*   52257 */     // GIR_Coverage, 52052,
     /*   52257 */     GIR_EraseRootFromParent_Done,
     /*   52258 */   // Label 842: @52258
     /*   52258 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(52354), // Rule ID 52053 //
     /*   52263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52286 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52300 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52315 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52319 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52321 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52328 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   52331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52352 */     GIR_RootConstrainSelectedInstOperands,
     /*   52353 */     // GIR_Coverage, 52053,
     /*   52353 */     GIR_EraseRootFromParent_Done,
     /*   52354 */   // Label 843: @52354
     /*   52354 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(52450), // Rule ID 52170 //
     /*   52359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52382 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52396 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52411 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52415 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52417 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52424 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52448 */     GIR_RootConstrainSelectedInstOperands,
     /*   52449 */     // GIR_Coverage, 52170,
     /*   52449 */     GIR_EraseRootFromParent_Done,
     /*   52450 */   // Label 844: @52450
     /*   52450 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(52546), // Rule ID 52171 //
     /*   52455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52478 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52492 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52507 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52511 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52513 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52520 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52544 */     GIR_RootConstrainSelectedInstOperands,
     /*   52545 */     // GIR_Coverage, 52171,
     /*   52545 */     GIR_EraseRootFromParent_Done,
     /*   52546 */   // Label 845: @52546
     /*   52546 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(52642), // Rule ID 71159 //
     /*   52551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52574 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52588 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52607 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52609 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52616 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   52627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   52631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52640 */     GIR_RootConstrainSelectedInstOperands,
     /*   52641 */     // GIR_Coverage, 71159,
     /*   52641 */     GIR_EraseRootFromParent_Done,
     /*   52642 */   // Label 846: @52642
     /*   52642 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(52738), // Rule ID 71160 //
     /*   52647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52670 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52684 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52699 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52703 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52705 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52712 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   52723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   52727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52736 */     GIR_RootConstrainSelectedInstOperands,
     /*   52737 */     // GIR_Coverage, 71160,
     /*   52737 */     GIR_EraseRootFromParent_Done,
     /*   52738 */   // Label 847: @52738
     /*   52738 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(52834), // Rule ID 52110 //
     /*   52743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52766 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52780 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52795 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52799 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52801 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52808 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52832 */     GIR_RootConstrainSelectedInstOperands,
     /*   52833 */     // GIR_Coverage, 52110,
     /*   52833 */     GIR_EraseRootFromParent_Done,
     /*   52834 */   // Label 848: @52834
     /*   52834 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(52930), // Rule ID 52111 //
     /*   52839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52862 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52876 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52891 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52895 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52897 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52904 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52928 */     GIR_RootConstrainSelectedInstOperands,
     /*   52929 */     // GIR_Coverage, 52111,
     /*   52929 */     GIR_EraseRootFromParent_Done,
     /*   52930 */   // Label 849: @52930
     /*   52930 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(53019), // Rule ID 46704 //
     /*   52935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52950 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52969 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52971 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52978 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   53004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53017 */     GIR_RootConstrainSelectedInstOperands,
     /*   53018 */     // GIR_Coverage, 46704,
     /*   53018 */     GIR_EraseRootFromParent_Done,
     /*   53019 */   // Label 850: @53019
     /*   53019 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(53108), // Rule ID 46705 //
     /*   53024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53039 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53058 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53067 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   53067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   53084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   53093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53106 */     GIR_RootConstrainSelectedInstOperands,
     /*   53107 */     // GIR_Coverage, 46705,
     /*   53107 */     GIR_EraseRootFromParent_Done,
     /*   53108 */   // Label 851: @53108
     /*   53108 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(53197), // Rule ID 46468 //
     /*   53113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53128 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53147 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53149 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53156 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   53156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   53173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   53182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53195 */     GIR_RootConstrainSelectedInstOperands,
     /*   53196 */     // GIR_Coverage, 46468,
     /*   53196 */     GIR_EraseRootFromParent_Done,
     /*   53197 */   // Label 852: @53197
     /*   53197 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(53286), // Rule ID 46469 //
     /*   53202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53217 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53236 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53245 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   53245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   53262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   53271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53284 */     GIR_RootConstrainSelectedInstOperands,
     /*   53285 */     // GIR_Coverage, 46469,
     /*   53285 */     GIR_EraseRootFromParent_Done,
     /*   53286 */   // Label 853: @53286
     /*   53286 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(53375), // Rule ID 46584 //
     /*   53291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53325 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53327 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53334 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   53334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   53351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   53360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53373 */     GIR_RootConstrainSelectedInstOperands,
     /*   53374 */     // GIR_Coverage, 46584,
     /*   53374 */     GIR_EraseRootFromParent_Done,
     /*   53375 */   // Label 854: @53375
     /*   53375 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(53464), // Rule ID 46585 //
     /*   53380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53395 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53414 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53423 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   53423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   53440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   53449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53462 */     GIR_RootConstrainSelectedInstOperands,
     /*   53463 */     // GIR_Coverage, 46585,
     /*   53463 */     GIR_EraseRootFromParent_Done,
     /*   53464 */   // Label 855: @53464
     /*   53464 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(53532), // Rule ID 70795 //
     /*   53469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53488 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53506 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   53506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53530 */     GIR_RootConstrainSelectedInstOperands,
     /*   53531 */     // GIR_Coverage, 70795,
     /*   53531 */     GIR_EraseRootFromParent_Done,
     /*   53532 */   // Label 856: @53532
     /*   53532 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(53600), // Rule ID 70796 //
     /*   53537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53574 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   53574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53598 */     GIR_RootConstrainSelectedInstOperands,
     /*   53599 */     // GIR_Coverage, 70796,
     /*   53599 */     GIR_EraseRootFromParent_Done,
     /*   53600 */   // Label 857: @53600
     /*   53600 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(53655), // Rule ID 69715 //
     /*   53605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53633 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53653 */     GIR_RootConstrainSelectedInstOperands,
     /*   53654 */     // GIR_Coverage, 69715,
     /*   53654 */     GIR_EraseRootFromParent_Done,
     /*   53655 */   // Label 858: @53655
     /*   53655 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53710), // Rule ID 69716 //
     /*   53660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53675 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53688 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53708 */     GIR_RootConstrainSelectedInstOperands,
     /*   53709 */     // GIR_Coverage, 69716,
     /*   53709 */     GIR_EraseRootFromParent_Done,
     /*   53710 */   // Label 859: @53710
     /*   53710 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53765), // Rule ID 69535 //
     /*   53715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53743 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53763 */     GIR_RootConstrainSelectedInstOperands,
     /*   53764 */     // GIR_Coverage, 69535,
     /*   53764 */     GIR_EraseRootFromParent_Done,
     /*   53765 */   // Label 860: @53765
     /*   53765 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53820), // Rule ID 69536 //
     /*   53770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53785 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53798 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53818 */     GIR_RootConstrainSelectedInstOperands,
     /*   53819 */     // GIR_Coverage, 69536,
     /*   53819 */     GIR_EraseRootFromParent_Done,
     /*   53820 */   // Label 861: @53820
     /*   53820 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53875), // Rule ID 69625 //
     /*   53825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53840 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53853 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53873 */     GIR_RootConstrainSelectedInstOperands,
     /*   53874 */     // GIR_Coverage, 69625,
     /*   53874 */     GIR_EraseRootFromParent_Done,
     /*   53875 */   // Label 862: @53875
     /*   53875 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53930), // Rule ID 69626 //
     /*   53880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53895 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53908 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53928 */     GIR_RootConstrainSelectedInstOperands,
     /*   53929 */     // GIR_Coverage, 69626,
     /*   53929 */     GIR_EraseRootFromParent_Done,
     /*   53930 */   // Label 863: @53930
     /*   53930 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53998), // Rule ID 51926 //
     /*   53935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53958 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53972 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   53972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53996 */     GIR_RootConstrainSelectedInstOperands,
     /*   53997 */     // GIR_Coverage, 51926,
     /*   53997 */     GIR_EraseRootFromParent_Done,
     /*   53998 */   // Label 864: @53998
     /*   53998 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(54066), // Rule ID 51927 //
     /*   54003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   54026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54040 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   54043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   54049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54064 */     GIR_RootConstrainSelectedInstOperands,
     /*   54065 */     // GIR_Coverage, 51927,
     /*   54065 */     GIR_EraseRootFromParent_Done,
     /*   54066 */   // Label 865: @54066
     /*   54066 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(54121), // Rule ID 46764 //
     /*   54071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   54086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   54090 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   54097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54099 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   54099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   54102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54119 */     GIR_RootConstrainSelectedInstOperands,
     /*   54120 */     // GIR_Coverage, 46764,
     /*   54120 */     GIR_EraseRootFromParent_Done,
     /*   54121 */   // Label 866: @54121
     /*   54121 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(54176), // Rule ID 46765 //
     /*   54126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   54141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   54145 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   54152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54154 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   54154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   54157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54174 */     GIR_RootConstrainSelectedInstOperands,
     /*   54175 */     // GIR_Coverage, 46765,
     /*   54175 */     GIR_EraseRootFromParent_Done,
     /*   54176 */   // Label 867: @54176
     /*   54176 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(54231), // Rule ID 46524 //
     /*   54181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   54200 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   54207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54209 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   54209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   54212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54229 */     GIR_RootConstrainSelectedInstOperands,
     /*   54230 */     // GIR_Coverage, 46524,
     /*   54230 */     GIR_EraseRootFromParent_Done,
     /*   54231 */   // Label 868: @54231
     /*   54231 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(54286), // Rule ID 46525 //
     /*   54236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   54255 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   54262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54264 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   54264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   54267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54284 */     GIR_RootConstrainSelectedInstOperands,
     /*   54285 */     // GIR_Coverage, 46525,
     /*   54285 */     GIR_EraseRootFromParent_Done,
     /*   54286 */   // Label 869: @54286
     /*   54286 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(54341), // Rule ID 46644 //
     /*   54291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   54310 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   54317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54319 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   54319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   54322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54339 */     GIR_RootConstrainSelectedInstOperands,
     /*   54340 */     // GIR_Coverage, 46644,
     /*   54340 */     GIR_EraseRootFromParent_Done,
     /*   54341 */   // Label 870: @54341
     /*   54341 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(54396), // Rule ID 46645 //
     /*   54346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   54365 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   54372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54374 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   54374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   54377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54394 */     GIR_RootConstrainSelectedInstOperands,
     /*   54395 */     // GIR_Coverage, 46645,
     /*   54395 */     GIR_EraseRootFromParent_Done,
     /*   54396 */   // Label 871: @54396
     /*   54396 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54449), // Rule ID 46158 //
     /*   54401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54412 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   54412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   54415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   54419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   54424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   54426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   54429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   54434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   54436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   54438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54447 */     GIR_RootConstrainSelectedInstOperands,
     /*   54448 */     // GIR_Coverage, 46158,
     /*   54448 */     GIR_EraseRootFromParent_Done,
     /*   54449 */   // Label 872: @54449
     /*   54449 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54502), // Rule ID 46159 //
     /*   54454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54465 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   54465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   54468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   54472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   54477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   54479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   54482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   54487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   54489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   54491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54500 */     GIR_RootConstrainSelectedInstOperands,
     /*   54501 */     // GIR_Coverage, 46159,
     /*   54501 */     GIR_EraseRootFromParent_Done,
     /*   54502 */   // Label 873: @54502
     /*   54502 */   GIM_Reject,
     /*   54503 */ // Label 833: @54503
     /*   54503 */ GIM_Reject,
     /*   54504 */ // Label 146: @54504
     /*   54504 */ GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(57628),
     /*   54509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54519 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54615), // Rule ID 70921 //
     /*   54524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54543 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54557 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54576 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54578 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54589 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54613 */     GIR_RootConstrainSelectedInstOperands,
     /*   54614 */     // GIR_Coverage, 70921,
     /*   54614 */     GIR_EraseRootFromParent_Done,
     /*   54615 */   // Label 875: @54615
     /*   54615 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54711), // Rule ID 70922 //
     /*   54620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54639 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54653 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54668 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54672 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54674 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54685 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54709 */     GIR_RootConstrainSelectedInstOperands,
     /*   54710 */     // GIR_Coverage, 70922,
     /*   54710 */     GIR_EraseRootFromParent_Done,
     /*   54711 */   // Label 876: @54711
     /*   54711 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54807), // Rule ID 71197 //
     /*   54716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54735 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54749 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54768 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54770 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54781 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54805 */     GIR_RootConstrainSelectedInstOperands,
     /*   54806 */     // GIR_Coverage, 71197,
     /*   54806 */     GIR_EraseRootFromParent_Done,
     /*   54807 */   // Label 877: @54807
     /*   54807 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54903), // Rule ID 71198 //
     /*   54812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54845 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54860 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54864 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54866 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54877 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54901 */     GIR_RootConstrainSelectedInstOperands,
     /*   54902 */     // GIR_Coverage, 71198,
     /*   54902 */     GIR_EraseRootFromParent_Done,
     /*   54903 */   // Label 878: @54903
     /*   54903 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54999), // Rule ID 71199 //
     /*   54908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54927 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54941 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54956 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54960 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54962 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54973 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54997 */     GIR_RootConstrainSelectedInstOperands,
     /*   54998 */     // GIR_Coverage, 71199,
     /*   54998 */     GIR_EraseRootFromParent_Done,
     /*   54999 */   // Label 879: @54999
     /*   54999 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(55095), // Rule ID 71200 //
     /*   55004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55023 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55037 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55052 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55056 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55058 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55069 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   55076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55093 */     GIR_RootConstrainSelectedInstOperands,
     /*   55094 */     // GIR_Coverage, 71200,
     /*   55094 */     GIR_EraseRootFromParent_Done,
     /*   55095 */   // Label 880: @55095
     /*   55095 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(55191), // Rule ID 71035 //
     /*   55100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55119 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55133 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55152 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55154 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55165 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   55172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55189 */     GIR_RootConstrainSelectedInstOperands,
     /*   55190 */     // GIR_Coverage, 71035,
     /*   55190 */     GIR_EraseRootFromParent_Done,
     /*   55191 */   // Label 881: @55191
     /*   55191 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(55287), // Rule ID 71036 //
     /*   55196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55215 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55229 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55244 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55248 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55250 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55261 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   55268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55285 */     GIR_RootConstrainSelectedInstOperands,
     /*   55286 */     // GIR_Coverage, 71036,
     /*   55286 */     GIR_EraseRootFromParent_Done,
     /*   55287 */   // Label 882: @55287
     /*   55287 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55383), // Rule ID 52064 //
     /*   55292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55315 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55329 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55344 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55348 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55350 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55357 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   55360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55381 */     GIR_RootConstrainSelectedInstOperands,
     /*   55382 */     // GIR_Coverage, 52064,
     /*   55382 */     GIR_EraseRootFromParent_Done,
     /*   55383 */   // Label 883: @55383
     /*   55383 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55479), // Rule ID 52065 //
     /*   55388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55425 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55427 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55440 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55444 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55446 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55453 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   55456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55477 */     GIR_RootConstrainSelectedInstOperands,
     /*   55478 */     // GIR_Coverage, 52065,
     /*   55478 */     GIR_EraseRootFromParent_Done,
     /*   55479 */   // Label 884: @55479
     /*   55479 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55575), // Rule ID 52182 //
     /*   55484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55507 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55521 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55523 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55536 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55540 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55542 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55549 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55573 */     GIR_RootConstrainSelectedInstOperands,
     /*   55574 */     // GIR_Coverage, 52182,
     /*   55574 */     GIR_EraseRootFromParent_Done,
     /*   55575 */   // Label 885: @55575
     /*   55575 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55671), // Rule ID 52183 //
     /*   55580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55603 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55617 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55632 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55636 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55638 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55645 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55669 */     GIR_RootConstrainSelectedInstOperands,
     /*   55670 */     // GIR_Coverage, 52183,
     /*   55670 */     GIR_EraseRootFromParent_Done,
     /*   55671 */   // Label 886: @55671
     /*   55671 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55767), // Rule ID 71195 //
     /*   55676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55713 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55732 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55734 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55741 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55765 */     GIR_RootConstrainSelectedInstOperands,
     /*   55766 */     // GIR_Coverage, 71195,
     /*   55766 */     GIR_EraseRootFromParent_Done,
     /*   55767 */   // Label 887: @55767
     /*   55767 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55863), // Rule ID 71196 //
     /*   55772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55795 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55809 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55824 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55828 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55830 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55837 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55861 */     GIR_RootConstrainSelectedInstOperands,
     /*   55862 */     // GIR_Coverage, 71196,
     /*   55862 */     GIR_EraseRootFromParent_Done,
     /*   55863 */   // Label 888: @55863
     /*   55863 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55959), // Rule ID 52122 //
     /*   55868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55891 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55905 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55924 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55926 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55933 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55957 */     GIR_RootConstrainSelectedInstOperands,
     /*   55958 */     // GIR_Coverage, 52122,
     /*   55958 */     GIR_EraseRootFromParent_Done,
     /*   55959 */   // Label 889: @55959
     /*   55959 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(56055), // Rule ID 52123 //
     /*   55964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55987 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56001 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   56012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56016 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56020 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   56022 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   56029 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   56032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   56036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   56044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56053 */     GIR_RootConstrainSelectedInstOperands,
     /*   56054 */     // GIR_Coverage, 52123,
     /*   56054 */     GIR_EraseRootFromParent_Done,
     /*   56055 */   // Label 890: @56055
     /*   56055 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(56144), // Rule ID 46728 //
     /*   56060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56075 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56094 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56103 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   56103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56142 */     GIR_RootConstrainSelectedInstOperands,
     /*   56143 */     // GIR_Coverage, 46728,
     /*   56143 */     GIR_EraseRootFromParent_Done,
     /*   56144 */   // Label 891: @56144
     /*   56144 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(56233), // Rule ID 46729 //
     /*   56149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56164 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56183 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56192 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   56192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56231 */     GIR_RootConstrainSelectedInstOperands,
     /*   56232 */     // GIR_Coverage, 46729,
     /*   56232 */     GIR_EraseRootFromParent_Done,
     /*   56233 */   // Label 892: @56233
     /*   56233 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(56322), // Rule ID 46492 //
     /*   56238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56253 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56272 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56281 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   56281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   56298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56320 */     GIR_RootConstrainSelectedInstOperands,
     /*   56321 */     // GIR_Coverage, 46492,
     /*   56321 */     GIR_EraseRootFromParent_Done,
     /*   56322 */   // Label 893: @56322
     /*   56322 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(56411), // Rule ID 46493 //
     /*   56327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56342 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56361 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56370 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   56370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   56387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56409 */     GIR_RootConstrainSelectedInstOperands,
     /*   56410 */     // GIR_Coverage, 46493,
     /*   56410 */     GIR_EraseRootFromParent_Done,
     /*   56411 */   // Label 894: @56411
     /*   56411 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(56500), // Rule ID 46608 //
     /*   56416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56450 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56459 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   56459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56498 */     GIR_RootConstrainSelectedInstOperands,
     /*   56499 */     // GIR_Coverage, 46608,
     /*   56499 */     GIR_EraseRootFromParent_Done,
     /*   56500 */   // Label 895: @56500
     /*   56500 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(56589), // Rule ID 46609 //
     /*   56505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56520 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56539 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56548 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   56548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56587 */     GIR_RootConstrainSelectedInstOperands,
     /*   56588 */     // GIR_Coverage, 46609,
     /*   56588 */     GIR_EraseRootFromParent_Done,
     /*   56589 */   // Label 896: @56589
     /*   56589 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(56657), // Rule ID 70827 //
     /*   56594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56613 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56631 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   56631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56655 */     GIR_RootConstrainSelectedInstOperands,
     /*   56656 */     // GIR_Coverage, 70827,
     /*   56656 */     GIR_EraseRootFromParent_Done,
     /*   56657 */   // Label 897: @56657
     /*   56657 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(56725), // Rule ID 70828 //
     /*   56662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56681 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56699 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   56699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56723 */     GIR_RootConstrainSelectedInstOperands,
     /*   56724 */     // GIR_Coverage, 70828,
     /*   56724 */     GIR_EraseRootFromParent_Done,
     /*   56725 */   // Label 898: @56725
     /*   56725 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(56780), // Rule ID 69739 //
     /*   56730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56745 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56758 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56778 */     GIR_RootConstrainSelectedInstOperands,
     /*   56779 */     // GIR_Coverage, 69739,
     /*   56779 */     GIR_EraseRootFromParent_Done,
     /*   56780 */   // Label 899: @56780
     /*   56780 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(56835), // Rule ID 69740 //
     /*   56785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56800 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56813 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56833 */     GIR_RootConstrainSelectedInstOperands,
     /*   56834 */     // GIR_Coverage, 69740,
     /*   56834 */     GIR_EraseRootFromParent_Done,
     /*   56835 */   // Label 900: @56835
     /*   56835 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(56890), // Rule ID 69559 //
     /*   56840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56855 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56868 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56888 */     GIR_RootConstrainSelectedInstOperands,
     /*   56889 */     // GIR_Coverage, 69559,
     /*   56889 */     GIR_EraseRootFromParent_Done,
     /*   56890 */   // Label 901: @56890
     /*   56890 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(56945), // Rule ID 69560 //
     /*   56895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56910 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56923 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56943 */     GIR_RootConstrainSelectedInstOperands,
     /*   56944 */     // GIR_Coverage, 69560,
     /*   56944 */     GIR_EraseRootFromParent_Done,
     /*   56945 */   // Label 902: @56945
     /*   56945 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(57000), // Rule ID 69649 //
     /*   56950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56965 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56978 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56998 */     GIR_RootConstrainSelectedInstOperands,
     /*   56999 */     // GIR_Coverage, 69649,
     /*   56999 */     GIR_EraseRootFromParent_Done,
     /*   57000 */   // Label 903: @57000
     /*   57000 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(57055), // Rule ID 69650 //
     /*   57005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57020 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57033 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   57033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57053 */     GIR_RootConstrainSelectedInstOperands,
     /*   57054 */     // GIR_Coverage, 69650,
     /*   57054 */     GIR_EraseRootFromParent_Done,
     /*   57055 */   // Label 904: @57055
     /*   57055 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(57123), // Rule ID 51942 //
     /*   57060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   57079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   57083 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57097 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   57097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   57100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57121 */     GIR_RootConstrainSelectedInstOperands,
     /*   57122 */     // GIR_Coverage, 51942,
     /*   57122 */     GIR_EraseRootFromParent_Done,
     /*   57123 */   // Label 905: @57123
     /*   57123 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(57191), // Rule ID 51943 //
     /*   57128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   57147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   57151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57165 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   57165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   57168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57189 */     GIR_RootConstrainSelectedInstOperands,
     /*   57190 */     // GIR_Coverage, 51943,
     /*   57190 */     GIR_EraseRootFromParent_Done,
     /*   57191 */   // Label 906: @57191
     /*   57191 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(57246), // Rule ID 46788 //
     /*   57196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   57211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57215 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57224 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   57224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57244 */     GIR_RootConstrainSelectedInstOperands,
     /*   57245 */     // GIR_Coverage, 46788,
     /*   57245 */     GIR_EraseRootFromParent_Done,
     /*   57246 */   // Label 907: @57246
     /*   57246 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(57301), // Rule ID 46789 //
     /*   57251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   57266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57270 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57279 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   57279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57299 */     GIR_RootConstrainSelectedInstOperands,
     /*   57300 */     // GIR_Coverage, 46789,
     /*   57300 */     GIR_EraseRootFromParent_Done,
     /*   57301 */   // Label 908: @57301
     /*   57301 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(57356), // Rule ID 46548 //
     /*   57306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57325 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57334 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   57334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   57337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57354 */     GIR_RootConstrainSelectedInstOperands,
     /*   57355 */     // GIR_Coverage, 46548,
     /*   57355 */     GIR_EraseRootFromParent_Done,
     /*   57356 */   // Label 909: @57356
     /*   57356 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(57411), // Rule ID 46549 //
     /*   57361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57380 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57389 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   57389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   57392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57409 */     GIR_RootConstrainSelectedInstOperands,
     /*   57410 */     // GIR_Coverage, 46549,
     /*   57410 */     GIR_EraseRootFromParent_Done,
     /*   57411 */   // Label 910: @57411
     /*   57411 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(57466), // Rule ID 46668 //
     /*   57416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57435 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57444 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   57444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57464 */     GIR_RootConstrainSelectedInstOperands,
     /*   57465 */     // GIR_Coverage, 46668,
     /*   57465 */     GIR_EraseRootFromParent_Done,
     /*   57466 */   // Label 911: @57466
     /*   57466 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(57521), // Rule ID 46669 //
     /*   57471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57490 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57499 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   57499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57519 */     GIR_RootConstrainSelectedInstOperands,
     /*   57520 */     // GIR_Coverage, 46669,
     /*   57520 */     GIR_EraseRootFromParent_Done,
     /*   57521 */   // Label 912: @57521
     /*   57521 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(57574), // Rule ID 46174 //
     /*   57526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57537 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   57537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   57540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   57554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57572 */     GIR_RootConstrainSelectedInstOperands,
     /*   57573 */     // GIR_Coverage, 46174,
     /*   57573 */     GIR_EraseRootFromParent_Done,
     /*   57574 */   // Label 913: @57574
     /*   57574 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(57627), // Rule ID 46175 //
     /*   57579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57590 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   57590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   57593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   57607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57625 */     GIR_RootConstrainSelectedInstOperands,
     /*   57626 */     // GIR_Coverage, 46175,
     /*   57626 */     GIR_EraseRootFromParent_Done,
     /*   57627 */   // Label 914: @57627
     /*   57627 */   GIM_Reject,
     /*   57628 */ // Label 874: @57628
     /*   57628 */ GIM_Reject,
     /*   57629 */ // Label 147: @57629
     /*   57629 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(58023),
     /*   57634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57644 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(57712), // Rule ID 70771 //
     /*   57649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57668 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57686 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57710 */     GIR_RootConstrainSelectedInstOperands,
     /*   57711 */     // GIR_Coverage, 70771,
     /*   57711 */     GIR_EraseRootFromParent_Done,
     /*   57712 */   // Label 916: @57712
     /*   57712 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(57780), // Rule ID 70772 //
     /*   57717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57754 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57778 */     GIR_RootConstrainSelectedInstOperands,
     /*   57779 */     // GIR_Coverage, 70772,
     /*   57779 */     GIR_EraseRootFromParent_Done,
     /*   57780 */   // Label 917: @57780
     /*   57780 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(57848), // Rule ID 51914 //
     /*   57785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57822 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57846 */     GIR_RootConstrainSelectedInstOperands,
     /*   57847 */     // GIR_Coverage, 51914,
     /*   57847 */     GIR_EraseRootFromParent_Done,
     /*   57848 */   // Label 918: @57848
     /*   57848 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57916), // Rule ID 51915 //
     /*   57853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57876 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57890 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57914 */     GIR_RootConstrainSelectedInstOperands,
     /*   57915 */     // GIR_Coverage, 51915,
     /*   57915 */     GIR_EraseRootFromParent_Done,
     /*   57916 */   // Label 919: @57916
     /*   57916 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(57969), // Rule ID 46146 //
     /*   57921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57932 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   57932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   57935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   57949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57967 */     GIR_RootConstrainSelectedInstOperands,
     /*   57968 */     // GIR_Coverage, 46146,
     /*   57968 */     GIR_EraseRootFromParent_Done,
     /*   57969 */   // Label 920: @57969
     /*   57969 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(58022), // Rule ID 46147 //
     /*   57974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57985 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   57985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   57988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   58002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   58007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   58009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   58011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58020 */     GIR_RootConstrainSelectedInstOperands,
     /*   58021 */     // GIR_Coverage, 46147,
     /*   58021 */     GIR_EraseRootFromParent_Done,
     /*   58022 */   // Label 921: @58022
     /*   58022 */   GIM_Reject,
     /*   58023 */ // Label 915: @58023
     /*   58023 */ GIM_Reject,
     /*   58024 */ // Label 148: @58024
     /*   58024 */ GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(61148),
     /*   58029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58039 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(58135), // Rule ID 70911 //
     /*   58044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58063 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58077 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58092 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58096 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58098 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58109 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58133 */     GIR_RootConstrainSelectedInstOperands,
     /*   58134 */     // GIR_Coverage, 70911,
     /*   58134 */     GIR_EraseRootFromParent_Done,
     /*   58135 */   // Label 923: @58135
     /*   58135 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(58231), // Rule ID 70912 //
     /*   58140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58159 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58173 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58188 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58192 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58194 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58205 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58229 */     GIR_RootConstrainSelectedInstOperands,
     /*   58230 */     // GIR_Coverage, 70912,
     /*   58230 */     GIR_EraseRootFromParent_Done,
     /*   58231 */   // Label 924: @58231
     /*   58231 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(58327), // Rule ID 71167 //
     /*   58236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58255 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58269 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58284 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58288 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58290 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58301 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58325 */     GIR_RootConstrainSelectedInstOperands,
     /*   58326 */     // GIR_Coverage, 71167,
     /*   58326 */     GIR_EraseRootFromParent_Done,
     /*   58327 */   // Label 925: @58327
     /*   58327 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(58423), // Rule ID 71168 //
     /*   58332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58351 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58365 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58380 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58384 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58386 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58397 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58421 */     GIR_RootConstrainSelectedInstOperands,
     /*   58422 */     // GIR_Coverage, 71168,
     /*   58422 */     GIR_EraseRootFromParent_Done,
     /*   58423 */   // Label 926: @58423
     /*   58423 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(58519), // Rule ID 71169 //
     /*   58428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58447 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58476 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58480 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58482 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58493 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58517 */     GIR_RootConstrainSelectedInstOperands,
     /*   58518 */     // GIR_Coverage, 71169,
     /*   58518 */     GIR_EraseRootFromParent_Done,
     /*   58519 */   // Label 927: @58519
     /*   58519 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(58615), // Rule ID 71170 //
     /*   58524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58543 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58557 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58576 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58578 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58589 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58613 */     GIR_RootConstrainSelectedInstOperands,
     /*   58614 */     // GIR_Coverage, 71170,
     /*   58614 */     GIR_EraseRootFromParent_Done,
     /*   58615 */   // Label 928: @58615
     /*   58615 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(58711), // Rule ID 71025 //
     /*   58620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58639 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58653 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58668 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58672 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58674 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58685 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58709 */     GIR_RootConstrainSelectedInstOperands,
     /*   58710 */     // GIR_Coverage, 71025,
     /*   58710 */     GIR_EraseRootFromParent_Done,
     /*   58711 */   // Label 929: @58711
     /*   58711 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(58807), // Rule ID 71026 //
     /*   58716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58735 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58749 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58768 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58770 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58781 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58805 */     GIR_RootConstrainSelectedInstOperands,
     /*   58806 */     // GIR_Coverage, 71026,
     /*   58806 */     GIR_EraseRootFromParent_Done,
     /*   58807 */   // Label 930: @58807
     /*   58807 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(58903), // Rule ID 52054 //
     /*   58812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58835 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58849 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58851 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58868 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58870 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58877 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58901 */     GIR_RootConstrainSelectedInstOperands,
     /*   58902 */     // GIR_Coverage, 52054,
     /*   58902 */     GIR_EraseRootFromParent_Done,
     /*   58903 */   // Label 931: @58903
     /*   58903 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(58999), // Rule ID 52055 //
     /*   58908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58945 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58960 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58964 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58966 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58973 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58997 */     GIR_RootConstrainSelectedInstOperands,
     /*   58998 */     // GIR_Coverage, 52055,
     /*   58998 */     GIR_EraseRootFromParent_Done,
     /*   58999 */   // Label 932: @58999
     /*   58999 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(59095), // Rule ID 52172 //
     /*   59004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59027 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59041 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59056 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59060 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59062 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59069 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   59072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59093 */     GIR_RootConstrainSelectedInstOperands,
     /*   59094 */     // GIR_Coverage, 52172,
     /*   59094 */     GIR_EraseRootFromParent_Done,
     /*   59095 */   // Label 933: @59095
     /*   59095 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(59191), // Rule ID 52173 //
     /*   59100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59123 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59137 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59152 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59156 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59158 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59165 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   59168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59189 */     GIR_RootConstrainSelectedInstOperands,
     /*   59190 */     // GIR_Coverage, 52173,
     /*   59190 */     GIR_EraseRootFromParent_Done,
     /*   59191 */   // Label 934: @59191
     /*   59191 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(59287), // Rule ID 71165 //
     /*   59196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59219 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59233 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59248 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59252 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59254 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59261 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   59264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   59272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   59276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59285 */     GIR_RootConstrainSelectedInstOperands,
     /*   59286 */     // GIR_Coverage, 71165,
     /*   59286 */     GIR_EraseRootFromParent_Done,
     /*   59287 */   // Label 935: @59287
     /*   59287 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(59383), // Rule ID 71166 //
     /*   59292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59315 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59329 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59344 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59348 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59350 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59357 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   59360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   59368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   59372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59381 */     GIR_RootConstrainSelectedInstOperands,
     /*   59382 */     // GIR_Coverage, 71166,
     /*   59382 */     GIR_EraseRootFromParent_Done,
     /*   59383 */   // Label 936: @59383
     /*   59383 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(59479), // Rule ID 52112 //
     /*   59388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59425 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59427 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59440 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59444 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59446 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59453 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   59456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59477 */     GIR_RootConstrainSelectedInstOperands,
     /*   59478 */     // GIR_Coverage, 52112,
     /*   59478 */     GIR_EraseRootFromParent_Done,
     /*   59479 */   // Label 937: @59479
     /*   59479 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(59575), // Rule ID 52113 //
     /*   59484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59507 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59521 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59523 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59536 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59540 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59542 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59549 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   59552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59573 */     GIR_RootConstrainSelectedInstOperands,
     /*   59574 */     // GIR_Coverage, 52113,
     /*   59574 */     GIR_EraseRootFromParent_Done,
     /*   59575 */   // Label 938: @59575
     /*   59575 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(59664), // Rule ID 46708 //
     /*   59580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59595 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59614 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59623 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59662 */     GIR_RootConstrainSelectedInstOperands,
     /*   59663 */     // GIR_Coverage, 46708,
     /*   59663 */     GIR_EraseRootFromParent_Done,
     /*   59664 */   // Label 939: @59664
     /*   59664 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(59753), // Rule ID 46709 //
     /*   59669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59684 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59703 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59712 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59751 */     GIR_RootConstrainSelectedInstOperands,
     /*   59752 */     // GIR_Coverage, 46709,
     /*   59752 */     GIR_EraseRootFromParent_Done,
     /*   59753 */   // Label 940: @59753
     /*   59753 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(59842), // Rule ID 46472 //
     /*   59758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59773 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59792 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59801 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   59818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59840 */     GIR_RootConstrainSelectedInstOperands,
     /*   59841 */     // GIR_Coverage, 46472,
     /*   59841 */     GIR_EraseRootFromParent_Done,
     /*   59842 */   // Label 941: @59842
     /*   59842 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(59931), // Rule ID 46473 //
     /*   59847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59862 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59881 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59890 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   59907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59929 */     GIR_RootConstrainSelectedInstOperands,
     /*   59930 */     // GIR_Coverage, 46473,
     /*   59930 */     GIR_EraseRootFromParent_Done,
     /*   59931 */   // Label 942: @59931
     /*   59931 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(60020), // Rule ID 46588 //
     /*   59936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59970 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59979 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   60005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60018 */     GIR_RootConstrainSelectedInstOperands,
     /*   60019 */     // GIR_Coverage, 46588,
     /*   60019 */     GIR_EraseRootFromParent_Done,
     /*   60020 */   // Label 943: @60020
     /*   60020 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(60109), // Rule ID 46589 //
     /*   60025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60059 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   60061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60068 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   60068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   60071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   60085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   60094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60107 */     GIR_RootConstrainSelectedInstOperands,
     /*   60108 */     // GIR_Coverage, 46589,
     /*   60108 */     GIR_EraseRootFromParent_Done,
     /*   60109 */   // Label 944: @60109
     /*   60109 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(60177), // Rule ID 70803 //
     /*   60114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60133 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60151 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   60151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60175 */     GIR_RootConstrainSelectedInstOperands,
     /*   60176 */     // GIR_Coverage, 70803,
     /*   60176 */     GIR_EraseRootFromParent_Done,
     /*   60177 */   // Label 945: @60177
     /*   60177 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(60245), // Rule ID 70804 //
     /*   60182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60219 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   60219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60243 */     GIR_RootConstrainSelectedInstOperands,
     /*   60244 */     // GIR_Coverage, 70804,
     /*   60244 */     GIR_EraseRootFromParent_Done,
     /*   60245 */   // Label 946: @60245
     /*   60245 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(60300), // Rule ID 69719 //
     /*   60250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60265 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60278 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60298 */     GIR_RootConstrainSelectedInstOperands,
     /*   60299 */     // GIR_Coverage, 69719,
     /*   60299 */     GIR_EraseRootFromParent_Done,
     /*   60300 */   // Label 947: @60300
     /*   60300 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(60355), // Rule ID 69720 //
     /*   60305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60320 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60333 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60353 */     GIR_RootConstrainSelectedInstOperands,
     /*   60354 */     // GIR_Coverage, 69720,
     /*   60354 */     GIR_EraseRootFromParent_Done,
     /*   60355 */   // Label 948: @60355
     /*   60355 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(60410), // Rule ID 69539 //
     /*   60360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60375 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60388 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60408 */     GIR_RootConstrainSelectedInstOperands,
     /*   60409 */     // GIR_Coverage, 69539,
     /*   60409 */     GIR_EraseRootFromParent_Done,
     /*   60410 */   // Label 949: @60410
     /*   60410 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(60465), // Rule ID 69540 //
     /*   60415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60430 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60443 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60463 */     GIR_RootConstrainSelectedInstOperands,
     /*   60464 */     // GIR_Coverage, 69540,
     /*   60464 */     GIR_EraseRootFromParent_Done,
     /*   60465 */   // Label 950: @60465
     /*   60465 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(60520), // Rule ID 69629 //
     /*   60470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60485 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60498 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60518 */     GIR_RootConstrainSelectedInstOperands,
     /*   60519 */     // GIR_Coverage, 69629,
     /*   60519 */     GIR_EraseRootFromParent_Done,
     /*   60520 */   // Label 951: @60520
     /*   60520 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(60575), // Rule ID 69630 //
     /*   60525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60540 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60553 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60573 */     GIR_RootConstrainSelectedInstOperands,
     /*   60574 */     // GIR_Coverage, 69630,
     /*   60574 */     GIR_EraseRootFromParent_Done,
     /*   60575 */   // Label 952: @60575
     /*   60575 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(60643), // Rule ID 51930 //
     /*   60580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60603 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60617 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   60617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60641 */     GIR_RootConstrainSelectedInstOperands,
     /*   60642 */     // GIR_Coverage, 51930,
     /*   60642 */     GIR_EraseRootFromParent_Done,
     /*   60643 */   // Label 953: @60643
     /*   60643 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(60711), // Rule ID 51931 //
     /*   60648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60671 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60685 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   60685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60709 */     GIR_RootConstrainSelectedInstOperands,
     /*   60710 */     // GIR_Coverage, 51931,
     /*   60710 */     GIR_EraseRootFromParent_Done,
     /*   60711 */   // Label 954: @60711
     /*   60711 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(60766), // Rule ID 46768 //
     /*   60716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60735 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60744 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60764 */     GIR_RootConstrainSelectedInstOperands,
     /*   60765 */     // GIR_Coverage, 46768,
     /*   60765 */     GIR_EraseRootFromParent_Done,
     /*   60766 */   // Label 955: @60766
     /*   60766 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(60821), // Rule ID 46769 //
     /*   60771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60799 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60819 */     GIR_RootConstrainSelectedInstOperands,
     /*   60820 */     // GIR_Coverage, 46769,
     /*   60820 */     GIR_EraseRootFromParent_Done,
     /*   60821 */   // Label 956: @60821
     /*   60821 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(60876), // Rule ID 46528 //
     /*   60826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60845 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60854 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60874 */     GIR_RootConstrainSelectedInstOperands,
     /*   60875 */     // GIR_Coverage, 46528,
     /*   60875 */     GIR_EraseRootFromParent_Done,
     /*   60876 */   // Label 957: @60876
     /*   60876 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(60931), // Rule ID 46529 //
     /*   60881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60900 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60909 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60929 */     GIR_RootConstrainSelectedInstOperands,
     /*   60930 */     // GIR_Coverage, 46529,
     /*   60930 */     GIR_EraseRootFromParent_Done,
     /*   60931 */   // Label 958: @60931
     /*   60931 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(60986), // Rule ID 46648 //
     /*   60936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60955 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60964 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60984 */     GIR_RootConstrainSelectedInstOperands,
     /*   60985 */     // GIR_Coverage, 46648,
     /*   60985 */     GIR_EraseRootFromParent_Done,
     /*   60986 */   // Label 959: @60986
     /*   60986 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(61041), // Rule ID 46649 //
     /*   60991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   61006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   61010 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   61017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61019 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   61019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   61022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61039 */     GIR_RootConstrainSelectedInstOperands,
     /*   61040 */     // GIR_Coverage, 46649,
     /*   61040 */     GIR_EraseRootFromParent_Done,
     /*   61041 */   // Label 960: @61041
     /*   61041 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(61094), // Rule ID 46162 //
     /*   61046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61057 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   61057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   61060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   61089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61092 */     GIR_RootConstrainSelectedInstOperands,
     /*   61093 */     // GIR_Coverage, 46162,
     /*   61093 */     GIR_EraseRootFromParent_Done,
     /*   61094 */   // Label 961: @61094
     /*   61094 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(61147), // Rule ID 46163 //
     /*   61099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61110 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   61110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   61113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   61142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61145 */     GIR_RootConstrainSelectedInstOperands,
     /*   61146 */     // GIR_Coverage, 46163,
     /*   61146 */     GIR_EraseRootFromParent_Done,
     /*   61147 */   // Label 962: @61147
     /*   61147 */   GIM_Reject,
     /*   61148 */ // Label 922: @61148
     /*   61148 */ GIM_Reject,
     /*   61149 */ // Label 149: @61149
     /*   61149 */ GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(61543),
     /*   61154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   61157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   61160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61164 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(61232), // Rule ID 70779 //
     /*   61169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   61184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   61188 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61206 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   61206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   61209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61230 */     GIR_RootConstrainSelectedInstOperands,
     /*   61231 */     // GIR_Coverage, 70779,
     /*   61231 */     GIR_EraseRootFromParent_Done,
     /*   61232 */   // Label 964: @61232
     /*   61232 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(61300), // Rule ID 70780 //
     /*   61237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   61252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   61256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61274 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   61274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   61277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61298 */     GIR_RootConstrainSelectedInstOperands,
     /*   61299 */     // GIR_Coverage, 70780,
     /*   61299 */     GIR_EraseRootFromParent_Done,
     /*   61300 */   // Label 965: @61300
     /*   61300 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(61368), // Rule ID 51918 //
     /*   61305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   61324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   61328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61342 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   61342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   61345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61366 */     GIR_RootConstrainSelectedInstOperands,
     /*   61367 */     // GIR_Coverage, 51918,
     /*   61367 */     GIR_EraseRootFromParent_Done,
     /*   61368 */   // Label 966: @61368
     /*   61368 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(61436), // Rule ID 51919 //
     /*   61373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   61392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   61396 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61410 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   61410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   61413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61434 */     GIR_RootConstrainSelectedInstOperands,
     /*   61435 */     // GIR_Coverage, 51919,
     /*   61435 */     GIR_EraseRootFromParent_Done,
     /*   61436 */   // Label 967: @61436
     /*   61436 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(61489), // Rule ID 46150 //
     /*   61441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61452 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   61452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   61455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61487 */     GIR_RootConstrainSelectedInstOperands,
     /*   61488 */     // GIR_Coverage, 46150,
     /*   61488 */     GIR_EraseRootFromParent_Done,
     /*   61489 */   // Label 968: @61489
     /*   61489 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(61542), // Rule ID 46151 //
     /*   61494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61505 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   61508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61540 */     GIR_RootConstrainSelectedInstOperands,
     /*   61541 */     // GIR_Coverage, 46151,
     /*   61541 */     GIR_EraseRootFromParent_Done,
     /*   61542 */   // Label 969: @61542
     /*   61542 */   GIM_Reject,
     /*   61543 */ // Label 963: @61543
     /*   61543 */ GIM_Reject,
     /*   61544 */ // Label 150: @61544
     /*   61544 */ GIM_Reject,
     /*   61545 */ // Label 1: @61545
     /*   61545 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 994*/ GIMT_Encode4(80777),
     /*   61556 */ /*GILLT_s32*//*Label 970*/ GIMT_Encode4(61680),
     /*   61560 */ /*GILLT_s64*//*Label 971*/ GIMT_Encode4(61927), GIMT_Encode4(0),
     /*   61568 */ /*GILLT_nxv1s8*//*Label 972*/ GIMT_Encode4(62203),
     /*   61572 */ /*GILLT_nxv1s16*//*Label 973*/ GIMT_Encode4(62450),
     /*   61576 */ /*GILLT_nxv1s32*//*Label 974*/ GIMT_Encode4(63573),
     /*   61580 */ /*GILLT_nxv1s64*//*Label 975*/ GIMT_Encode4(64696), GIMT_Encode4(0),
     /*   61588 */ /*GILLT_nxv2s8*//*Label 976*/ GIMT_Encode4(65819),
     /*   61592 */ /*GILLT_nxv2s16*//*Label 977*/ GIMT_Encode4(66066),
     /*   61596 */ /*GILLT_nxv2s32*//*Label 978*/ GIMT_Encode4(67189),
     /*   61600 */ /*GILLT_nxv2s64*//*Label 979*/ GIMT_Encode4(68312), GIMT_Encode4(0),
     /*   61608 */ /*GILLT_nxv4s8*//*Label 980*/ GIMT_Encode4(69435),
     /*   61612 */ /*GILLT_nxv4s16*//*Label 981*/ GIMT_Encode4(69682),
     /*   61616 */ /*GILLT_nxv4s32*//*Label 982*/ GIMT_Encode4(70805),
     /*   61620 */ /*GILLT_nxv4s64*//*Label 983*/ GIMT_Encode4(71928), GIMT_Encode4(0),
     /*   61628 */ /*GILLT_nxv8s8*//*Label 984*/ GIMT_Encode4(73051),
     /*   61632 */ /*GILLT_nxv8s16*//*Label 985*/ GIMT_Encode4(73298),
     /*   61636 */ /*GILLT_nxv8s32*//*Label 986*/ GIMT_Encode4(74421),
     /*   61640 */ /*GILLT_nxv8s64*//*Label 987*/ GIMT_Encode4(75544), GIMT_Encode4(0),
     /*   61648 */ /*GILLT_nxv16s8*//*Label 988*/ GIMT_Encode4(76667),
     /*   61652 */ /*GILLT_nxv16s16*//*Label 989*/ GIMT_Encode4(76914),
     /*   61656 */ /*GILLT_nxv16s32*//*Label 990*/ GIMT_Encode4(78037), GIMT_Encode4(0),
     /*   61664 */ /*GILLT_nxv32s8*//*Label 991*/ GIMT_Encode4(79160),
     /*   61668 */ /*GILLT_nxv32s16*//*Label 992*/ GIMT_Encode4(79407), GIMT_Encode4(0),
     /*   61676 */ /*GILLT_nxv64s8*//*Label 993*/ GIMT_Encode4(80530),
     /*   61680 */ // Label 970: @61680
     /*   61680 */ GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(61926),
     /*   61685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   61688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   61691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61695 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(61770), // Rule ID 112 //
     /*   61700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*   61703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61723 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61730 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61736 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i64] }), 31:{ *:[i64] })
     /*   61736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   61739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61752 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   61755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   61768 */     GIR_RootConstrainSelectedInstOperands,
     /*   61769 */     // GIR_Coverage, 112,
     /*   61769 */     GIR_EraseRootFromParent_Done,
     /*   61770 */   // Label 996: @61770
     /*   61770 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(61845), // Rule ID 113 //
     /*   61775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*   61778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61811 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i32] }), 31:{ *:[i32] })
     /*   61811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   61814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61823 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61827 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   61830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   61843 */     GIR_RootConstrainSelectedInstOperands,
     /*   61844 */     // GIR_Coverage, 113,
     /*   61844 */     GIR_EraseRootFromParent_Done,
     /*   61845 */   // Label 997: @61845
     /*   61845 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(61902), // Rule ID 62609 //
     /*   61850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*   61853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61885 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULS:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   61885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   61888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61900 */     GIR_RootConstrainSelectedInstOperands,
     /*   61901 */     // GIR_Coverage, 62609,
     /*   61901 */     GIR_EraseRootFromParent_Done,
     /*   61902 */   // Label 998: @61902
     /*   61902 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(61925), // Rule ID 91 //
     /*   61907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   61910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61918 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   61918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   61923 */     GIR_RootConstrainSelectedInstOperands,
     /*   61924 */     // GIR_Coverage, 91,
     /*   61924 */     GIR_Done,
     /*   61925 */   // Label 999: @61925
     /*   61925 */   GIM_Reject,
     /*   61926 */ // Label 995: @61926
     /*   61926 */ GIM_Reject,
     /*   61927 */ // Label 971: @61927
     /*   61927 */ GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(62202),
     /*   61932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   61935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   61938 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(62017), // Rule ID 114 //
     /*   61943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   61946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61970 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61977 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61983 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 1:{ *:[i64] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, 63:{ *:[i64] }), 63:{ *:[i64] })
     /*   61983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   61986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61995 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61999 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*   62002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   62007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /*   62015 */     GIR_RootConstrainSelectedInstOperands,
     /*   62016 */     // GIR_Coverage, 114,
     /*   62016 */     GIR_EraseRootFromParent_Done,
     /*   62017 */   // Label 1001: @62017
     /*   62017 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(62082), // Rule ID 62611 //
     /*   62022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   62025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   62045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   62049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62059 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10086),
     /*   62063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62065 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10086>>  =>  (TH_MULSW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   62065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULSW),
     /*   62068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   62070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   62072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   62080 */     GIR_RootConstrainSelectedInstOperands,
     /*   62081 */     // GIR_Coverage, 62611,
     /*   62081 */     GIR_EraseRootFromParent_Done,
     /*   62082 */   // Label 1002: @62082
     /*   62082 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(62143), // Rule ID 62608 //
     /*   62087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   62090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   62110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   62114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62126 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULS:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   62126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   62129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   62131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   62133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   62141 */     GIR_RootConstrainSelectedInstOperands,
     /*   62142 */     // GIR_Coverage, 62608,
     /*   62142 */     GIR_EraseRootFromParent_Done,
     /*   62143 */   // Label 1003: @62143
     /*   62143 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(62174), // Rule ID 285 //
     /*   62148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   62151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62163 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10086),
     /*   62167 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10086>>  =>  (SUBW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   62167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUBW),
     /*   62172 */     GIR_RootConstrainSelectedInstOperands,
     /*   62173 */     // GIR_Coverage, 285,
     /*   62173 */     GIR_Done,
     /*   62174 */   // Label 1004: @62174
     /*   62174 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(62201), // Rule ID 90 //
     /*   62179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   62182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62194 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (SUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   62194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   62199 */     GIR_RootConstrainSelectedInstOperands,
     /*   62200 */     // GIR_Coverage, 90,
     /*   62200 */     GIR_Done,
     /*   62201 */   // Label 1005: @62201
     /*   62201 */   GIM_Reject,
     /*   62202 */ // Label 1000: @62202
     /*   62202 */ GIM_Reject,
     /*   62203 */ // Label 972: @62203
     /*   62203 */ GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(62449),
     /*   62208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   62214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62222 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(62286), // Rule ID 51958 //
     /*   62227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   62246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62260 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   62263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62284 */     GIR_RootConstrainSelectedInstOperands,
     /*   62285 */     // GIR_Coverage, 51958,
     /*   62285 */     GIR_EraseRootFromParent_Done,
     /*   62286 */   // Label 1007: @62286
     /*   62286 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(62350), // Rule ID 51959 //
     /*   62291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   62310 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62324 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   62327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62348 */     GIR_RootConstrainSelectedInstOperands,
     /*   62349 */     // GIR_Coverage, 51959,
     /*   62349 */     GIR_EraseRootFromParent_Done,
     /*   62350 */   // Label 1008: @62350
     /*   62350 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(62399), // Rule ID 46232 //
     /*   62355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62362 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   62365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   62379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   62386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   62388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62397 */     GIR_RootConstrainSelectedInstOperands,
     /*   62398 */     // GIR_Coverage, 46232,
     /*   62398 */     GIR_EraseRootFromParent_Done,
     /*   62399 */   // Label 1009: @62399
     /*   62399 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(62448), // Rule ID 46233 //
     /*   62404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62411 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   62414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   62428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   62435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   62437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62446 */     GIR_RootConstrainSelectedInstOperands,
     /*   62447 */     // GIR_Coverage, 46233,
     /*   62447 */     GIR_EraseRootFromParent_Done,
     /*   62448 */   // Label 1010: @62448
     /*   62448 */   GIM_Reject,
     /*   62449 */ // Label 1006: @62449
     /*   62449 */ GIM_Reject,
     /*   62450 */ // Label 973: @62450
     /*   62450 */ GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(63572),
     /*   62455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   62458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   62461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62465 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(62554), // Rule ID 47228 //
     /*   62470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62485 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62504 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62513 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62552 */     GIR_RootConstrainSelectedInstOperands,
     /*   62553 */     // GIR_Coverage, 47228,
     /*   62553 */     GIR_EraseRootFromParent_Done,
     /*   62554 */   // Label 1012: @62554
     /*   62554 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(62643), // Rule ID 47229 //
     /*   62559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62574 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62593 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62602 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62641 */     GIR_RootConstrainSelectedInstOperands,
     /*   62642 */     // GIR_Coverage, 47229,
     /*   62642 */     GIR_EraseRootFromParent_Done,
     /*   62643 */   // Label 1013: @62643
     /*   62643 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(62732), // Rule ID 46988 //
     /*   62648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62682 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62691 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   62708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62730 */     GIR_RootConstrainSelectedInstOperands,
     /*   62731 */     // GIR_Coverage, 46988,
     /*   62731 */     GIR_EraseRootFromParent_Done,
     /*   62732 */   // Label 1014: @62732
     /*   62732 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(62821), // Rule ID 46989 //
     /*   62737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62771 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62780 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   62797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62819 */     GIR_RootConstrainSelectedInstOperands,
     /*   62820 */     // GIR_Coverage, 46989,
     /*   62820 */     GIR_EraseRootFromParent_Done,
     /*   62821 */   // Label 1015: @62821
     /*   62821 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(62910), // Rule ID 47108 //
     /*   62826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62860 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62869 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62908 */     GIR_RootConstrainSelectedInstOperands,
     /*   62909 */     // GIR_Coverage, 47108,
     /*   62909 */     GIR_EraseRootFromParent_Done,
     /*   62910 */   // Label 1016: @62910
     /*   62910 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(62999), // Rule ID 47109 //
     /*   62915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62930 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62949 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62958 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62997 */     GIR_RootConstrainSelectedInstOperands,
     /*   62998 */     // GIR_Coverage, 47109,
     /*   62998 */     GIR_EraseRootFromParent_Done,
     /*   62999 */   // Label 1017: @62999
     /*   62999 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(63067), // Rule ID 51970 //
     /*   63004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   63027 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63041 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   63044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63065 */     GIR_RootConstrainSelectedInstOperands,
     /*   63066 */     // GIR_Coverage, 51970,
     /*   63066 */     GIR_EraseRootFromParent_Done,
     /*   63067 */   // Label 1018: @63067
     /*   63067 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(63135), // Rule ID 51971 //
     /*   63072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   63095 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63109 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   63112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63133 */     GIR_RootConstrainSelectedInstOperands,
     /*   63134 */     // GIR_Coverage, 51971,
     /*   63134 */     GIR_EraseRootFromParent_Done,
     /*   63135 */   // Label 1019: @63135
     /*   63135 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(63190), // Rule ID 47288 //
     /*   63140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   63159 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63168 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   63168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   63171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63188 */     GIR_RootConstrainSelectedInstOperands,
     /*   63189 */     // GIR_Coverage, 47288,
     /*   63189 */     GIR_EraseRootFromParent_Done,
     /*   63190 */   // Label 1020: @63190
     /*   63190 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(63245), // Rule ID 47289 //
     /*   63195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   63214 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63223 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   63223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   63226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63243 */     GIR_RootConstrainSelectedInstOperands,
     /*   63244 */     // GIR_Coverage, 47289,
     /*   63244 */     GIR_EraseRootFromParent_Done,
     /*   63245 */   // Label 1021: @63245
     /*   63245 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(63300), // Rule ID 47048 //
     /*   63250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   63269 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63278 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   63278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   63281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63298 */     GIR_RootConstrainSelectedInstOperands,
     /*   63299 */     // GIR_Coverage, 47048,
     /*   63299 */     GIR_EraseRootFromParent_Done,
     /*   63300 */   // Label 1022: @63300
     /*   63300 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(63355), // Rule ID 47049 //
     /*   63305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   63324 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63333 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   63333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   63336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63353 */     GIR_RootConstrainSelectedInstOperands,
     /*   63354 */     // GIR_Coverage, 47049,
     /*   63354 */     GIR_EraseRootFromParent_Done,
     /*   63355 */   // Label 1023: @63355
     /*   63355 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(63410), // Rule ID 47168 //
     /*   63360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   63379 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63388 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   63388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   63391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63408 */     GIR_RootConstrainSelectedInstOperands,
     /*   63409 */     // GIR_Coverage, 47168,
     /*   63409 */     GIR_EraseRootFromParent_Done,
     /*   63410 */   // Label 1024: @63410
     /*   63410 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(63465), // Rule ID 47169 //
     /*   63415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   63434 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63443 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   63443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   63446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63463 */     GIR_RootConstrainSelectedInstOperands,
     /*   63464 */     // GIR_Coverage, 47169,
     /*   63464 */     GIR_EraseRootFromParent_Done,
     /*   63465 */   // Label 1025: @63465
     /*   63465 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(63518), // Rule ID 46244 //
     /*   63470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63481 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   63484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   63498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63516 */     GIR_RootConstrainSelectedInstOperands,
     /*   63517 */     // GIR_Coverage, 46244,
     /*   63517 */     GIR_EraseRootFromParent_Done,
     /*   63518 */   // Label 1026: @63518
     /*   63518 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(63571), // Rule ID 46245 //
     /*   63523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63534 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   63537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   63551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63569 */     GIR_RootConstrainSelectedInstOperands,
     /*   63570 */     // GIR_Coverage, 46245,
     /*   63570 */     GIR_EraseRootFromParent_Done,
     /*   63571 */   // Label 1027: @63571
     /*   63571 */   GIM_Reject,
     /*   63572 */ // Label 1011: @63572
     /*   63572 */ GIM_Reject,
     /*   63573 */ // Label 974: @63573
     /*   63573 */ GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(64695),
     /*   63578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63588 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(63677), // Rule ID 47252 //
     /*   63593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63608 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63627 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63636 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63675 */     GIR_RootConstrainSelectedInstOperands,
     /*   63676 */     // GIR_Coverage, 47252,
     /*   63676 */     GIR_EraseRootFromParent_Done,
     /*   63677 */   // Label 1029: @63677
     /*   63677 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(63766), // Rule ID 47253 //
     /*   63682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63716 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63725 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63764 */     GIR_RootConstrainSelectedInstOperands,
     /*   63765 */     // GIR_Coverage, 47253,
     /*   63765 */     GIR_EraseRootFromParent_Done,
     /*   63766 */   // Label 1030: @63766
     /*   63766 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(63855), // Rule ID 47012 //
     /*   63771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63805 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63814 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   63831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63853 */     GIR_RootConstrainSelectedInstOperands,
     /*   63854 */     // GIR_Coverage, 47012,
     /*   63854 */     GIR_EraseRootFromParent_Done,
     /*   63855 */   // Label 1031: @63855
     /*   63855 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(63944), // Rule ID 47013 //
     /*   63860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63875 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63894 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63903 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   63920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63942 */     GIR_RootConstrainSelectedInstOperands,
     /*   63943 */     // GIR_Coverage, 47013,
     /*   63943 */     GIR_EraseRootFromParent_Done,
     /*   63944 */   // Label 1032: @63944
     /*   63944 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(64033), // Rule ID 47132 //
     /*   63949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63964 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63983 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63992 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   64009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64031 */     GIR_RootConstrainSelectedInstOperands,
     /*   64032 */     // GIR_Coverage, 47132,
     /*   64032 */     GIR_EraseRootFromParent_Done,
     /*   64033 */   // Label 1033: @64033
     /*   64033 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(64122), // Rule ID 47133 //
     /*   64038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64053 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64072 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64081 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   64081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   64098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64120 */     GIR_RootConstrainSelectedInstOperands,
     /*   64121 */     // GIR_Coverage, 47133,
     /*   64121 */     GIR_EraseRootFromParent_Done,
     /*   64122 */   // Label 1034: @64122
     /*   64122 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(64190), // Rule ID 51978 //
     /*   64127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   64150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64164 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   64164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   64167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64188 */     GIR_RootConstrainSelectedInstOperands,
     /*   64189 */     // GIR_Coverage, 51978,
     /*   64189 */     GIR_EraseRootFromParent_Done,
     /*   64190 */   // Label 1035: @64190
     /*   64190 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(64258), // Rule ID 51979 //
     /*   64195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   64218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64232 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   64232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   64235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64256 */     GIR_RootConstrainSelectedInstOperands,
     /*   64257 */     // GIR_Coverage, 51979,
     /*   64257 */     GIR_EraseRootFromParent_Done,
     /*   64258 */   // Label 1036: @64258
     /*   64258 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(64313), // Rule ID 47312 //
     /*   64263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64282 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64291 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   64291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64311 */     GIR_RootConstrainSelectedInstOperands,
     /*   64312 */     // GIR_Coverage, 47312,
     /*   64312 */     GIR_EraseRootFromParent_Done,
     /*   64313 */   // Label 1037: @64313
     /*   64313 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(64368), // Rule ID 47313 //
     /*   64318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64337 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64346 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   64346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64366 */     GIR_RootConstrainSelectedInstOperands,
     /*   64367 */     // GIR_Coverage, 47313,
     /*   64367 */     GIR_EraseRootFromParent_Done,
     /*   64368 */   // Label 1038: @64368
     /*   64368 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(64423), // Rule ID 47072 //
     /*   64373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64392 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64401 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   64401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   64404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64421 */     GIR_RootConstrainSelectedInstOperands,
     /*   64422 */     // GIR_Coverage, 47072,
     /*   64422 */     GIR_EraseRootFromParent_Done,
     /*   64423 */   // Label 1039: @64423
     /*   64423 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(64478), // Rule ID 47073 //
     /*   64428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64447 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64456 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   64456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   64459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64476 */     GIR_RootConstrainSelectedInstOperands,
     /*   64477 */     // GIR_Coverage, 47073,
     /*   64477 */     GIR_EraseRootFromParent_Done,
     /*   64478 */   // Label 1040: @64478
     /*   64478 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(64533), // Rule ID 47192 //
     /*   64483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64502 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64511 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   64511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64531 */     GIR_RootConstrainSelectedInstOperands,
     /*   64532 */     // GIR_Coverage, 47192,
     /*   64532 */     GIR_EraseRootFromParent_Done,
     /*   64533 */   // Label 1041: @64533
     /*   64533 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(64588), // Rule ID 47193 //
     /*   64538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64557 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64566 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   64566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64586 */     GIR_RootConstrainSelectedInstOperands,
     /*   64587 */     // GIR_Coverage, 47193,
     /*   64587 */     GIR_EraseRootFromParent_Done,
     /*   64588 */   // Label 1042: @64588
     /*   64588 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(64641), // Rule ID 46252 //
     /*   64593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64604 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   64621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64639 */     GIR_RootConstrainSelectedInstOperands,
     /*   64640 */     // GIR_Coverage, 46252,
     /*   64640 */     GIR_EraseRootFromParent_Done,
     /*   64641 */   // Label 1043: @64641
     /*   64641 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(64694), // Rule ID 46253 //
     /*   64646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64657 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   64674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64692 */     GIR_RootConstrainSelectedInstOperands,
     /*   64693 */     // GIR_Coverage, 46253,
     /*   64693 */     GIR_EraseRootFromParent_Done,
     /*   64694 */   // Label 1044: @64694
     /*   64694 */   GIM_Reject,
     /*   64695 */ // Label 1028: @64695
     /*   64695 */ GIM_Reject,
     /*   64696 */ // Label 975: @64696
     /*   64696 */ GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(65818),
     /*   64701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64711 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(64800), // Rule ID 47272 //
     /*   64716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64731 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64750 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64759 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64798 */     GIR_RootConstrainSelectedInstOperands,
     /*   64799 */     // GIR_Coverage, 47272,
     /*   64799 */     GIR_EraseRootFromParent_Done,
     /*   64800 */   // Label 1046: @64800
     /*   64800 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(64889), // Rule ID 47273 //
     /*   64805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64820 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64839 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64848 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64887 */     GIR_RootConstrainSelectedInstOperands,
     /*   64888 */     // GIR_Coverage, 47273,
     /*   64888 */     GIR_EraseRootFromParent_Done,
     /*   64889 */   // Label 1047: @64889
     /*   64889 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(64978), // Rule ID 47032 //
     /*   64894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64909 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64928 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64937 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   64954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64976 */     GIR_RootConstrainSelectedInstOperands,
     /*   64977 */     // GIR_Coverage, 47032,
     /*   64977 */     GIR_EraseRootFromParent_Done,
     /*   64978 */   // Label 1048: @64978
     /*   64978 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(65067), // Rule ID 47033 //
     /*   64983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64998 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65017 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65026 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   65026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   65043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65065 */     GIR_RootConstrainSelectedInstOperands,
     /*   65066 */     // GIR_Coverage, 47033,
     /*   65066 */     GIR_EraseRootFromParent_Done,
     /*   65067 */   // Label 1049: @65067
     /*   65067 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(65156), // Rule ID 47152 //
     /*   65072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65087 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65106 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65115 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   65115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   65132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65154 */     GIR_RootConstrainSelectedInstOperands,
     /*   65155 */     // GIR_Coverage, 47152,
     /*   65155 */     GIR_EraseRootFromParent_Done,
     /*   65156 */   // Label 1050: @65156
     /*   65156 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(65245), // Rule ID 47153 //
     /*   65161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65176 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65195 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65204 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   65204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   65221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65243 */     GIR_RootConstrainSelectedInstOperands,
     /*   65244 */     // GIR_Coverage, 47153,
     /*   65244 */     GIR_EraseRootFromParent_Done,
     /*   65245 */   // Label 1051: @65245
     /*   65245 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(65313), // Rule ID 51994 //
     /*   65250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   65253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   65269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   65273 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65287 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   65287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   65290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65311 */     GIR_RootConstrainSelectedInstOperands,
     /*   65312 */     // GIR_Coverage, 51994,
     /*   65312 */     GIR_EraseRootFromParent_Done,
     /*   65313 */   // Label 1052: @65313
     /*   65313 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(65381), // Rule ID 51995 //
     /*   65318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   65321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   65337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   65341 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65355 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   65355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   65358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65379 */     GIR_RootConstrainSelectedInstOperands,
     /*   65380 */     // GIR_Coverage, 51995,
     /*   65380 */     GIR_EraseRootFromParent_Done,
     /*   65381 */   // Label 1053: @65381
     /*   65381 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(65436), // Rule ID 47332 //
     /*   65386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65405 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65414 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65434 */     GIR_RootConstrainSelectedInstOperands,
     /*   65435 */     // GIR_Coverage, 47332,
     /*   65435 */     GIR_EraseRootFromParent_Done,
     /*   65436 */   // Label 1054: @65436
     /*   65436 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(65491), // Rule ID 47333 //
     /*   65441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65460 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65469 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65489 */     GIR_RootConstrainSelectedInstOperands,
     /*   65490 */     // GIR_Coverage, 47333,
     /*   65490 */     GIR_EraseRootFromParent_Done,
     /*   65491 */   // Label 1055: @65491
     /*   65491 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(65546), // Rule ID 47092 //
     /*   65496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65515 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65524 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65544 */     GIR_RootConstrainSelectedInstOperands,
     /*   65545 */     // GIR_Coverage, 47092,
     /*   65545 */     GIR_EraseRootFromParent_Done,
     /*   65546 */   // Label 1056: @65546
     /*   65546 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(65601), // Rule ID 47093 //
     /*   65551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65570 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65579 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65599 */     GIR_RootConstrainSelectedInstOperands,
     /*   65600 */     // GIR_Coverage, 47093,
     /*   65600 */     GIR_EraseRootFromParent_Done,
     /*   65601 */   // Label 1057: @65601
     /*   65601 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(65656), // Rule ID 47212 //
     /*   65606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65625 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65634 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65654 */     GIR_RootConstrainSelectedInstOperands,
     /*   65655 */     // GIR_Coverage, 47212,
     /*   65655 */     GIR_EraseRootFromParent_Done,
     /*   65656 */   // Label 1058: @65656
     /*   65656 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(65711), // Rule ID 47213 //
     /*   65661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65680 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65689 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65709 */     GIR_RootConstrainSelectedInstOperands,
     /*   65710 */     // GIR_Coverage, 47213,
     /*   65710 */     GIR_EraseRootFromParent_Done,
     /*   65711 */   // Label 1059: @65711
     /*   65711 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(65764), // Rule ID 46268 //
     /*   65716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   65719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65727 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   65727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   65744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65762 */     GIR_RootConstrainSelectedInstOperands,
     /*   65763 */     // GIR_Coverage, 46268,
     /*   65763 */     GIR_EraseRootFromParent_Done,
     /*   65764 */   // Label 1060: @65764
     /*   65764 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(65817), // Rule ID 46269 //
     /*   65769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   65772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65780 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   65780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   65797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65815 */     GIR_RootConstrainSelectedInstOperands,
     /*   65816 */     // GIR_Coverage, 46269,
     /*   65816 */     GIR_EraseRootFromParent_Done,
     /*   65817 */   // Label 1061: @65817
     /*   65817 */   GIM_Reject,
     /*   65818 */ // Label 1045: @65818
     /*   65818 */ GIM_Reject,
     /*   65819 */ // Label 976: @65819
     /*   65819 */ GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(66065),
     /*   65824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65838 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(65902), // Rule ID 51962 //
     /*   65843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65862 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65876 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   65876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   65879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65900 */     GIR_RootConstrainSelectedInstOperands,
     /*   65901 */     // GIR_Coverage, 51962,
     /*   65901 */     GIR_EraseRootFromParent_Done,
     /*   65902 */   // Label 1063: @65902
     /*   65902 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(65966), // Rule ID 51963 //
     /*   65907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65926 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65940 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   65940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   65943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65964 */     GIR_RootConstrainSelectedInstOperands,
     /*   65965 */     // GIR_Coverage, 51963,
     /*   65965 */     GIR_EraseRootFromParent_Done,
     /*   65966 */   // Label 1064: @65966
     /*   65966 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(66015), // Rule ID 46236 //
     /*   65971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65978 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   65981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   65995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66013 */     GIR_RootConstrainSelectedInstOperands,
     /*   66014 */     // GIR_Coverage, 46236,
     /*   66014 */     GIR_EraseRootFromParent_Done,
     /*   66015 */   // Label 1065: @66015
     /*   66015 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(66064), // Rule ID 46237 //
     /*   66020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66027 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   66027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   66030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   66044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66062 */     GIR_RootConstrainSelectedInstOperands,
     /*   66063 */     // GIR_Coverage, 46237,
     /*   66063 */     GIR_EraseRootFromParent_Done,
     /*   66064 */   // Label 1066: @66064
     /*   66064 */   GIM_Reject,
     /*   66065 */ // Label 1062: @66065
     /*   66065 */ GIM_Reject,
     /*   66066 */ // Label 977: @66066
     /*   66066 */ GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(67188),
     /*   66071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66081 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(66170), // Rule ID 47232 //
     /*   66086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66101 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66120 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66129 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   66129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66168 */     GIR_RootConstrainSelectedInstOperands,
     /*   66169 */     // GIR_Coverage, 47232,
     /*   66169 */     GIR_EraseRootFromParent_Done,
     /*   66170 */   // Label 1068: @66170
     /*   66170 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(66259), // Rule ID 47233 //
     /*   66175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66190 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66209 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66218 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   66218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66257 */     GIR_RootConstrainSelectedInstOperands,
     /*   66258 */     // GIR_Coverage, 47233,
     /*   66258 */     GIR_EraseRootFromParent_Done,
     /*   66259 */   // Label 1069: @66259
     /*   66259 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(66348), // Rule ID 46992 //
     /*   66264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66279 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66298 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66307 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   66307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   66324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66346 */     GIR_RootConstrainSelectedInstOperands,
     /*   66347 */     // GIR_Coverage, 46992,
     /*   66347 */     GIR_EraseRootFromParent_Done,
     /*   66348 */   // Label 1070: @66348
     /*   66348 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(66437), // Rule ID 46993 //
     /*   66353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66368 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66387 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66396 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   66396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   66413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66435 */     GIR_RootConstrainSelectedInstOperands,
     /*   66436 */     // GIR_Coverage, 46993,
     /*   66436 */     GIR_EraseRootFromParent_Done,
     /*   66437 */   // Label 1071: @66437
     /*   66437 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(66526), // Rule ID 47112 //
     /*   66442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66457 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66476 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66485 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   66485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66524 */     GIR_RootConstrainSelectedInstOperands,
     /*   66525 */     // GIR_Coverage, 47112,
     /*   66525 */     GIR_EraseRootFromParent_Done,
     /*   66526 */   // Label 1072: @66526
     /*   66526 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(66615), // Rule ID 47113 //
     /*   66531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66565 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66574 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   66574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66613 */     GIR_RootConstrainSelectedInstOperands,
     /*   66614 */     // GIR_Coverage, 47113,
     /*   66614 */     GIR_EraseRootFromParent_Done,
     /*   66615 */   // Label 1073: @66615
     /*   66615 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(66683), // Rule ID 51974 //
     /*   66620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66643 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66657 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   66657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   66660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66681 */     GIR_RootConstrainSelectedInstOperands,
     /*   66682 */     // GIR_Coverage, 51974,
     /*   66682 */     GIR_EraseRootFromParent_Done,
     /*   66683 */   // Label 1074: @66683
     /*   66683 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(66751), // Rule ID 51975 //
     /*   66688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66711 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66725 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   66725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   66728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66749 */     GIR_RootConstrainSelectedInstOperands,
     /*   66750 */     // GIR_Coverage, 51975,
     /*   66750 */     GIR_EraseRootFromParent_Done,
     /*   66751 */   // Label 1075: @66751
     /*   66751 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(66806), // Rule ID 47292 //
     /*   66756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66775 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66784 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66804 */     GIR_RootConstrainSelectedInstOperands,
     /*   66805 */     // GIR_Coverage, 47292,
     /*   66805 */     GIR_EraseRootFromParent_Done,
     /*   66806 */   // Label 1076: @66806
     /*   66806 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(66861), // Rule ID 47293 //
     /*   66811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66830 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66839 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66859 */     GIR_RootConstrainSelectedInstOperands,
     /*   66860 */     // GIR_Coverage, 47293,
     /*   66860 */     GIR_EraseRootFromParent_Done,
     /*   66861 */   // Label 1077: @66861
     /*   66861 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(66916), // Rule ID 47052 //
     /*   66866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66885 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66894 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   66897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66914 */     GIR_RootConstrainSelectedInstOperands,
     /*   66915 */     // GIR_Coverage, 47052,
     /*   66915 */     GIR_EraseRootFromParent_Done,
     /*   66916 */   // Label 1078: @66916
     /*   66916 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(66971), // Rule ID 47053 //
     /*   66921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66940 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66949 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   66952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66969 */     GIR_RootConstrainSelectedInstOperands,
     /*   66970 */     // GIR_Coverage, 47053,
     /*   66970 */     GIR_EraseRootFromParent_Done,
     /*   66971 */   // Label 1079: @66971
     /*   66971 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(67026), // Rule ID 47172 //
     /*   66976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66995 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67004 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   67004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   67007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67024 */     GIR_RootConstrainSelectedInstOperands,
     /*   67025 */     // GIR_Coverage, 47172,
     /*   67025 */     GIR_EraseRootFromParent_Done,
     /*   67026 */   // Label 1080: @67026
     /*   67026 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(67081), // Rule ID 47173 //
     /*   67031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   67050 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67059 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   67059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   67062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67079 */     GIR_RootConstrainSelectedInstOperands,
     /*   67080 */     // GIR_Coverage, 47173,
     /*   67080 */     GIR_EraseRootFromParent_Done,
     /*   67081 */   // Label 1081: @67081
     /*   67081 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(67134), // Rule ID 46248 //
     /*   67086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67097 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   67097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   67100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   67114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67132 */     GIR_RootConstrainSelectedInstOperands,
     /*   67133 */     // GIR_Coverage, 46248,
     /*   67133 */     GIR_EraseRootFromParent_Done,
     /*   67134 */   // Label 1082: @67134
     /*   67134 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(67187), // Rule ID 46249 //
     /*   67139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67150 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   67153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   67167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67185 */     GIR_RootConstrainSelectedInstOperands,
     /*   67186 */     // GIR_Coverage, 46249,
     /*   67186 */     GIR_EraseRootFromParent_Done,
     /*   67187 */   // Label 1083: @67187
     /*   67187 */   GIM_Reject,
     /*   67188 */ // Label 1067: @67188
     /*   67188 */ GIM_Reject,
     /*   67189 */ // Label 978: @67189
     /*   67189 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(68311),
     /*   67194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67204 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(67293), // Rule ID 47256 //
     /*   67209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67224 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67243 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67252 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   67252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67291 */     GIR_RootConstrainSelectedInstOperands,
     /*   67292 */     // GIR_Coverage, 47256,
     /*   67292 */     GIR_EraseRootFromParent_Done,
     /*   67293 */   // Label 1085: @67293
     /*   67293 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(67382), // Rule ID 47257 //
     /*   67298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67313 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67332 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67341 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67380 */     GIR_RootConstrainSelectedInstOperands,
     /*   67381 */     // GIR_Coverage, 47257,
     /*   67381 */     GIR_EraseRootFromParent_Done,
     /*   67382 */   // Label 1086: @67382
     /*   67382 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(67471), // Rule ID 47016 //
     /*   67387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67402 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67421 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67430 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   67430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   67447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67469 */     GIR_RootConstrainSelectedInstOperands,
     /*   67470 */     // GIR_Coverage, 47016,
     /*   67470 */     GIR_EraseRootFromParent_Done,
     /*   67471 */   // Label 1087: @67471
     /*   67471 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(67560), // Rule ID 47017 //
     /*   67476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67510 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67519 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   67536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67558 */     GIR_RootConstrainSelectedInstOperands,
     /*   67559 */     // GIR_Coverage, 47017,
     /*   67559 */     GIR_EraseRootFromParent_Done,
     /*   67560 */   // Label 1088: @67560
     /*   67560 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(67649), // Rule ID 47136 //
     /*   67565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67580 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67599 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67608 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   67608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67647 */     GIR_RootConstrainSelectedInstOperands,
     /*   67648 */     // GIR_Coverage, 47136,
     /*   67648 */     GIR_EraseRootFromParent_Done,
     /*   67649 */   // Label 1089: @67649
     /*   67649 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(67738), // Rule ID 47137 //
     /*   67654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67669 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67688 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67697 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67736 */     GIR_RootConstrainSelectedInstOperands,
     /*   67737 */     // GIR_Coverage, 47137,
     /*   67737 */     GIR_EraseRootFromParent_Done,
     /*   67738 */   // Label 1090: @67738
     /*   67738 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(67806), // Rule ID 51990 //
     /*   67743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67766 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67780 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   67780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   67783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67804 */     GIR_RootConstrainSelectedInstOperands,
     /*   67805 */     // GIR_Coverage, 51990,
     /*   67805 */     GIR_EraseRootFromParent_Done,
     /*   67806 */   // Label 1091: @67806
     /*   67806 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(67874), // Rule ID 51991 //
     /*   67811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67848 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   67848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   67851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67872 */     GIR_RootConstrainSelectedInstOperands,
     /*   67873 */     // GIR_Coverage, 51991,
     /*   67873 */     GIR_EraseRootFromParent_Done,
     /*   67874 */   // Label 1092: @67874
     /*   67874 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(67929), // Rule ID 47316 //
     /*   67879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67898 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67907 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67927 */     GIR_RootConstrainSelectedInstOperands,
     /*   67928 */     // GIR_Coverage, 47316,
     /*   67928 */     GIR_EraseRootFromParent_Done,
     /*   67929 */   // Label 1093: @67929
     /*   67929 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(67984), // Rule ID 47317 //
     /*   67934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67953 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67962 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67982 */     GIR_RootConstrainSelectedInstOperands,
     /*   67983 */     // GIR_Coverage, 47317,
     /*   67983 */     GIR_EraseRootFromParent_Done,
     /*   67984 */   // Label 1094: @67984
     /*   67984 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(68039), // Rule ID 47076 //
     /*   67989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   68008 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68017 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   68017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   68020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   68034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68037 */     GIR_RootConstrainSelectedInstOperands,
     /*   68038 */     // GIR_Coverage, 47076,
     /*   68038 */     GIR_EraseRootFromParent_Done,
     /*   68039 */   // Label 1095: @68039
     /*   68039 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(68094), // Rule ID 47077 //
     /*   68044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   68063 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68072 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   68072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   68075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   68089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68092 */     GIR_RootConstrainSelectedInstOperands,
     /*   68093 */     // GIR_Coverage, 47077,
     /*   68093 */     GIR_EraseRootFromParent_Done,
     /*   68094 */   // Label 1096: @68094
     /*   68094 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(68149), // Rule ID 47196 //
     /*   68099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   68118 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68127 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   68127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   68130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   68144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68147 */     GIR_RootConstrainSelectedInstOperands,
     /*   68148 */     // GIR_Coverage, 47196,
     /*   68148 */     GIR_EraseRootFromParent_Done,
     /*   68149 */   // Label 1097: @68149
     /*   68149 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(68204), // Rule ID 47197 //
     /*   68154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   68173 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68182 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   68182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   68185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   68199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68202 */     GIR_RootConstrainSelectedInstOperands,
     /*   68203 */     // GIR_Coverage, 47197,
     /*   68203 */     GIR_EraseRootFromParent_Done,
     /*   68204 */   // Label 1098: @68204
     /*   68204 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(68257), // Rule ID 46264 //
     /*   68209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68220 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   68223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   68237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68255 */     GIR_RootConstrainSelectedInstOperands,
     /*   68256 */     // GIR_Coverage, 46264,
     /*   68256 */     GIR_EraseRootFromParent_Done,
     /*   68257 */   // Label 1099: @68257
     /*   68257 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(68310), // Rule ID 46265 //
     /*   68262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68273 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   68276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   68290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68308 */     GIR_RootConstrainSelectedInstOperands,
     /*   68309 */     // GIR_Coverage, 46265,
     /*   68309 */     GIR_EraseRootFromParent_Done,
     /*   68310 */   // Label 1100: @68310
     /*   68310 */   GIM_Reject,
     /*   68311 */ // Label 1084: @68311
     /*   68311 */ GIM_Reject,
     /*   68312 */ // Label 979: @68312
     /*   68312 */ GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(69434),
     /*   68317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68327 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(68416), // Rule ID 47276 //
     /*   68332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68347 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68366 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68375 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68414 */     GIR_RootConstrainSelectedInstOperands,
     /*   68415 */     // GIR_Coverage, 47276,
     /*   68415 */     GIR_EraseRootFromParent_Done,
     /*   68416 */   // Label 1102: @68416
     /*   68416 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(68505), // Rule ID 47277 //
     /*   68421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68455 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68464 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68503 */     GIR_RootConstrainSelectedInstOperands,
     /*   68504 */     // GIR_Coverage, 47277,
     /*   68504 */     GIR_EraseRootFromParent_Done,
     /*   68505 */   // Label 1103: @68505
     /*   68505 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(68594), // Rule ID 47036 //
     /*   68510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68525 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68544 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68553 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68592 */     GIR_RootConstrainSelectedInstOperands,
     /*   68593 */     // GIR_Coverage, 47036,
     /*   68593 */     GIR_EraseRootFromParent_Done,
     /*   68594 */   // Label 1104: @68594
     /*   68594 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(68683), // Rule ID 47037 //
     /*   68599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68614 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68633 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68642 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68681 */     GIR_RootConstrainSelectedInstOperands,
     /*   68682 */     // GIR_Coverage, 47037,
     /*   68682 */     GIR_EraseRootFromParent_Done,
     /*   68683 */   // Label 1105: @68683
     /*   68683 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(68772), // Rule ID 47156 //
     /*   68688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68703 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68722 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68731 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68770 */     GIR_RootConstrainSelectedInstOperands,
     /*   68771 */     // GIR_Coverage, 47156,
     /*   68771 */     GIR_EraseRootFromParent_Done,
     /*   68772 */   // Label 1106: @68772
     /*   68772 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(68861), // Rule ID 47157 //
     /*   68777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68792 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68811 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68813 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68820 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68859 */     GIR_RootConstrainSelectedInstOperands,
     /*   68860 */     // GIR_Coverage, 47157,
     /*   68860 */     GIR_EraseRootFromParent_Done,
     /*   68861 */   // Label 1107: @68861
     /*   68861 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(68929), // Rule ID 52034 //
     /*   68866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   68869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68889 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68903 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   68903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   68906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68927 */     GIR_RootConstrainSelectedInstOperands,
     /*   68928 */     // GIR_Coverage, 52034,
     /*   68928 */     GIR_EraseRootFromParent_Done,
     /*   68929 */   // Label 1108: @68929
     /*   68929 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(68997), // Rule ID 52035 //
     /*   68934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   68937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68957 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68971 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   68971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   68974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68995 */     GIR_RootConstrainSelectedInstOperands,
     /*   68996 */     // GIR_Coverage, 52035,
     /*   68996 */     GIR_EraseRootFromParent_Done,
     /*   68997 */   // Label 1109: @68997
     /*   68997 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(69052), // Rule ID 47336 //
     /*   69002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   69005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   69021 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69030 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   69030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   69033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69050 */     GIR_RootConstrainSelectedInstOperands,
     /*   69051 */     // GIR_Coverage, 47336,
     /*   69051 */     GIR_EraseRootFromParent_Done,
     /*   69052 */   // Label 1110: @69052
     /*   69052 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(69107), // Rule ID 47337 //
     /*   69057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   69060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   69076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69085 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   69085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   69088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69105 */     GIR_RootConstrainSelectedInstOperands,
     /*   69106 */     // GIR_Coverage, 47337,
     /*   69106 */     GIR_EraseRootFromParent_Done,
     /*   69107 */   // Label 1111: @69107
     /*   69107 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(69162), // Rule ID 47096 //
     /*   69112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   69115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   69131 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69140 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   69140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   69143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69160 */     GIR_RootConstrainSelectedInstOperands,
     /*   69161 */     // GIR_Coverage, 47096,
     /*   69161 */     GIR_EraseRootFromParent_Done,
     /*   69162 */   // Label 1112: @69162
     /*   69162 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(69217), // Rule ID 47097 //
     /*   69167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   69170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   69186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69195 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   69195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   69198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69215 */     GIR_RootConstrainSelectedInstOperands,
     /*   69216 */     // GIR_Coverage, 47097,
     /*   69216 */     GIR_EraseRootFromParent_Done,
     /*   69217 */   // Label 1113: @69217
     /*   69217 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(69272), // Rule ID 47216 //
     /*   69222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   69225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   69241 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69250 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   69250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   69253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69270 */     GIR_RootConstrainSelectedInstOperands,
     /*   69271 */     // GIR_Coverage, 47216,
     /*   69271 */     GIR_EraseRootFromParent_Done,
     /*   69272 */   // Label 1114: @69272
     /*   69272 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(69327), // Rule ID 47217 //
     /*   69277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   69280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   69296 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69305 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   69305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   69308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69325 */     GIR_RootConstrainSelectedInstOperands,
     /*   69326 */     // GIR_Coverage, 47217,
     /*   69326 */     GIR_EraseRootFromParent_Done,
     /*   69327 */   // Label 1115: @69327
     /*   69327 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(69380), // Rule ID 46308 //
     /*   69332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   69335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69343 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   69343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   69346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   69360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   69375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69378 */     GIR_RootConstrainSelectedInstOperands,
     /*   69379 */     // GIR_Coverage, 46308,
     /*   69379 */     GIR_EraseRootFromParent_Done,
     /*   69380 */   // Label 1116: @69380
     /*   69380 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(69433), // Rule ID 46309 //
     /*   69385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   69388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69396 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   69396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   69399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   69413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   69428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69431 */     GIR_RootConstrainSelectedInstOperands,
     /*   69432 */     // GIR_Coverage, 46309,
     /*   69432 */     GIR_EraseRootFromParent_Done,
     /*   69433 */   // Label 1117: @69433
     /*   69433 */   GIM_Reject,
     /*   69434 */ // Label 1101: @69434
     /*   69434 */ GIM_Reject,
     /*   69435 */ // Label 980: @69435
     /*   69435 */ GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(69681),
     /*   69440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69454 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(69518), // Rule ID 51966 //
     /*   69459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69478 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69492 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   69495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69516 */     GIR_RootConstrainSelectedInstOperands,
     /*   69517 */     // GIR_Coverage, 51966,
     /*   69517 */     GIR_EraseRootFromParent_Done,
     /*   69518 */   // Label 1119: @69518
     /*   69518 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(69582), // Rule ID 51967 //
     /*   69523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69556 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   69559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69580 */     GIR_RootConstrainSelectedInstOperands,
     /*   69581 */     // GIR_Coverage, 51967,
     /*   69581 */     GIR_EraseRootFromParent_Done,
     /*   69582 */   // Label 1120: @69582
     /*   69582 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(69631), // Rule ID 46240 //
     /*   69587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69594 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   69597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   69611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69629 */     GIR_RootConstrainSelectedInstOperands,
     /*   69630 */     // GIR_Coverage, 46240,
     /*   69630 */     GIR_EraseRootFromParent_Done,
     /*   69631 */   // Label 1121: @69631
     /*   69631 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(69680), // Rule ID 46241 //
     /*   69636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69643 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   69646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   69660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69678 */     GIR_RootConstrainSelectedInstOperands,
     /*   69679 */     // GIR_Coverage, 46241,
     /*   69679 */     GIR_EraseRootFromParent_Done,
     /*   69680 */   // Label 1122: @69680
     /*   69680 */   GIM_Reject,
     /*   69681 */ // Label 1118: @69681
     /*   69681 */ GIM_Reject,
     /*   69682 */ // Label 981: @69682
     /*   69682 */ GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(70804),
     /*   69687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69697 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(69786), // Rule ID 47236 //
     /*   69702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69717 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69736 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69745 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69784 */     GIR_RootConstrainSelectedInstOperands,
     /*   69785 */     // GIR_Coverage, 47236,
     /*   69785 */     GIR_EraseRootFromParent_Done,
     /*   69786 */   // Label 1124: @69786
     /*   69786 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(69875), // Rule ID 47237 //
     /*   69791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69806 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69825 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69834 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69873 */     GIR_RootConstrainSelectedInstOperands,
     /*   69874 */     // GIR_Coverage, 47237,
     /*   69874 */     GIR_EraseRootFromParent_Done,
     /*   69875 */   // Label 1125: @69875
     /*   69875 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(69964), // Rule ID 46996 //
     /*   69880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69895 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69914 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69923 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   69940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69962 */     GIR_RootConstrainSelectedInstOperands,
     /*   69963 */     // GIR_Coverage, 46996,
     /*   69963 */     GIR_EraseRootFromParent_Done,
     /*   69964 */   // Label 1126: @69964
     /*   69964 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(70053), // Rule ID 46997 //
     /*   69969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69984 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70012 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   70012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   70029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70051 */     GIR_RootConstrainSelectedInstOperands,
     /*   70052 */     // GIR_Coverage, 46997,
     /*   70052 */     GIR_EraseRootFromParent_Done,
     /*   70053 */   // Label 1127: @70053
     /*   70053 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(70142), // Rule ID 47116 //
     /*   70058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70073 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70092 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70101 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   70101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   70118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70140 */     GIR_RootConstrainSelectedInstOperands,
     /*   70141 */     // GIR_Coverage, 47116,
     /*   70141 */     GIR_EraseRootFromParent_Done,
     /*   70142 */   // Label 1128: @70142
     /*   70142 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(70231), // Rule ID 47117 //
     /*   70147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70162 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70181 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70190 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   70190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   70207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70229 */     GIR_RootConstrainSelectedInstOperands,
     /*   70230 */     // GIR_Coverage, 47117,
     /*   70230 */     GIR_EraseRootFromParent_Done,
     /*   70231 */   // Label 1129: @70231
     /*   70231 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(70299), // Rule ID 51986 //
     /*   70236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   70259 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70273 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   70273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   70276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70297 */     GIR_RootConstrainSelectedInstOperands,
     /*   70298 */     // GIR_Coverage, 51986,
     /*   70298 */     GIR_EraseRootFromParent_Done,
     /*   70299 */   // Label 1130: @70299
     /*   70299 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(70367), // Rule ID 51987 //
     /*   70304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   70327 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70341 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   70341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   70344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70365 */     GIR_RootConstrainSelectedInstOperands,
     /*   70366 */     // GIR_Coverage, 51987,
     /*   70366 */     GIR_EraseRootFromParent_Done,
     /*   70367 */   // Label 1131: @70367
     /*   70367 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(70422), // Rule ID 47296 //
     /*   70372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70391 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70400 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70420 */     GIR_RootConstrainSelectedInstOperands,
     /*   70421 */     // GIR_Coverage, 47296,
     /*   70421 */     GIR_EraseRootFromParent_Done,
     /*   70422 */   // Label 1132: @70422
     /*   70422 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(70477), // Rule ID 47297 //
     /*   70427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70446 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70455 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70475 */     GIR_RootConstrainSelectedInstOperands,
     /*   70476 */     // GIR_Coverage, 47297,
     /*   70476 */     GIR_EraseRootFromParent_Done,
     /*   70477 */   // Label 1133: @70477
     /*   70477 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(70532), // Rule ID 47056 //
     /*   70482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70501 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70510 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   70513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70530 */     GIR_RootConstrainSelectedInstOperands,
     /*   70531 */     // GIR_Coverage, 47056,
     /*   70531 */     GIR_EraseRootFromParent_Done,
     /*   70532 */   // Label 1134: @70532
     /*   70532 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(70587), // Rule ID 47057 //
     /*   70537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70565 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   70568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70585 */     GIR_RootConstrainSelectedInstOperands,
     /*   70586 */     // GIR_Coverage, 47057,
     /*   70586 */     GIR_EraseRootFromParent_Done,
     /*   70587 */   // Label 1135: @70587
     /*   70587 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(70642), // Rule ID 47176 //
     /*   70592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70620 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70640 */     GIR_RootConstrainSelectedInstOperands,
     /*   70641 */     // GIR_Coverage, 47176,
     /*   70641 */     GIR_EraseRootFromParent_Done,
     /*   70642 */   // Label 1136: @70642
     /*   70642 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(70697), // Rule ID 47177 //
     /*   70647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70675 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70695 */     GIR_RootConstrainSelectedInstOperands,
     /*   70696 */     // GIR_Coverage, 47177,
     /*   70696 */     GIR_EraseRootFromParent_Done,
     /*   70697 */   // Label 1137: @70697
     /*   70697 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(70750), // Rule ID 46260 //
     /*   70702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70713 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   70730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70748 */     GIR_RootConstrainSelectedInstOperands,
     /*   70749 */     // GIR_Coverage, 46260,
     /*   70749 */     GIR_EraseRootFromParent_Done,
     /*   70750 */   // Label 1138: @70750
     /*   70750 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(70803), // Rule ID 46261 //
     /*   70755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70766 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   70783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70801 */     GIR_RootConstrainSelectedInstOperands,
     /*   70802 */     // GIR_Coverage, 46261,
     /*   70802 */     GIR_EraseRootFromParent_Done,
     /*   70803 */   // Label 1139: @70803
     /*   70803 */   GIM_Reject,
     /*   70804 */ // Label 1123: @70804
     /*   70804 */ GIM_Reject,
     /*   70805 */ // Label 982: @70805
     /*   70805 */ GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(71927),
     /*   70810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70820 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(70909), // Rule ID 47260 //
     /*   70825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70840 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70859 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70868 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70907 */     GIR_RootConstrainSelectedInstOperands,
     /*   70908 */     // GIR_Coverage, 47260,
     /*   70908 */     GIR_EraseRootFromParent_Done,
     /*   70909 */   // Label 1141: @70909
     /*   70909 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(70998), // Rule ID 47261 //
     /*   70914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70929 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70948 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70957 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70996 */     GIR_RootConstrainSelectedInstOperands,
     /*   70997 */     // GIR_Coverage, 47261,
     /*   70997 */     GIR_EraseRootFromParent_Done,
     /*   70998 */   // Label 1142: @70998
     /*   70998 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(71087), // Rule ID 47020 //
     /*   71003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71018 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71037 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71046 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   71046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   71063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71085 */     GIR_RootConstrainSelectedInstOperands,
     /*   71086 */     // GIR_Coverage, 47020,
     /*   71086 */     GIR_EraseRootFromParent_Done,
     /*   71087 */   // Label 1143: @71087
     /*   71087 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(71176), // Rule ID 47021 //
     /*   71092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71126 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71135 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   71135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   71152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71174 */     GIR_RootConstrainSelectedInstOperands,
     /*   71175 */     // GIR_Coverage, 47021,
     /*   71175 */     GIR_EraseRootFromParent_Done,
     /*   71176 */   // Label 1144: @71176
     /*   71176 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(71265), // Rule ID 47140 //
     /*   71181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71215 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71224 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   71224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   71241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71263 */     GIR_RootConstrainSelectedInstOperands,
     /*   71264 */     // GIR_Coverage, 47140,
     /*   71264 */     GIR_EraseRootFromParent_Done,
     /*   71265 */   // Label 1145: @71265
     /*   71265 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(71354), // Rule ID 47141 //
     /*   71270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71285 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71304 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71313 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   71313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   71330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71352 */     GIR_RootConstrainSelectedInstOperands,
     /*   71353 */     // GIR_Coverage, 47141,
     /*   71353 */     GIR_EraseRootFromParent_Done,
     /*   71354 */   // Label 1146: @71354
     /*   71354 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71422), // Rule ID 52022 //
     /*   71359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   71374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   71382 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71396 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   71396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   71399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   71405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71420 */     GIR_RootConstrainSelectedInstOperands,
     /*   71421 */     // GIR_Coverage, 52022,
     /*   71421 */     GIR_EraseRootFromParent_Done,
     /*   71422 */   // Label 1147: @71422
     /*   71422 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71490), // Rule ID 52023 //
     /*   71427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   71442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   71450 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71464 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   71464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   71467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   71473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71488 */     GIR_RootConstrainSelectedInstOperands,
     /*   71489 */     // GIR_Coverage, 52023,
     /*   71489 */     GIR_EraseRootFromParent_Done,
     /*   71490 */   // Label 1148: @71490
     /*   71490 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(71545), // Rule ID 47320 //
     /*   71495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71514 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71523 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71543 */     GIR_RootConstrainSelectedInstOperands,
     /*   71544 */     // GIR_Coverage, 47320,
     /*   71544 */     GIR_EraseRootFromParent_Done,
     /*   71545 */   // Label 1149: @71545
     /*   71545 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(71600), // Rule ID 47321 //
     /*   71550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71569 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71578 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71598 */     GIR_RootConstrainSelectedInstOperands,
     /*   71599 */     // GIR_Coverage, 47321,
     /*   71599 */     GIR_EraseRootFromParent_Done,
     /*   71600 */   // Label 1150: @71600
     /*   71600 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(71655), // Rule ID 47080 //
     /*   71605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71624 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71633 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   71636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71653 */     GIR_RootConstrainSelectedInstOperands,
     /*   71654 */     // GIR_Coverage, 47080,
     /*   71654 */     GIR_EraseRootFromParent_Done,
     /*   71655 */   // Label 1151: @71655
     /*   71655 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(71710), // Rule ID 47081 //
     /*   71660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71679 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71688 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   71691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71708 */     GIR_RootConstrainSelectedInstOperands,
     /*   71709 */     // GIR_Coverage, 47081,
     /*   71709 */     GIR_EraseRootFromParent_Done,
     /*   71710 */   // Label 1152: @71710
     /*   71710 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71765), // Rule ID 47200 //
     /*   71715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71734 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71743 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71763 */     GIR_RootConstrainSelectedInstOperands,
     /*   71764 */     // GIR_Coverage, 47200,
     /*   71764 */     GIR_EraseRootFromParent_Done,
     /*   71765 */   // Label 1153: @71765
     /*   71765 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(71820), // Rule ID 47201 //
     /*   71770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71789 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71798 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71818 */     GIR_RootConstrainSelectedInstOperands,
     /*   71819 */     // GIR_Coverage, 47201,
     /*   71819 */     GIR_EraseRootFromParent_Done,
     /*   71820 */   // Label 1154: @71820
     /*   71820 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(71873), // Rule ID 46296 //
     /*   71825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71836 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   71853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   71862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71871 */     GIR_RootConstrainSelectedInstOperands,
     /*   71872 */     // GIR_Coverage, 46296,
     /*   71872 */     GIR_EraseRootFromParent_Done,
     /*   71873 */   // Label 1155: @71873
     /*   71873 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(71926), // Rule ID 46297 //
     /*   71878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71889 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   71906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   71915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71924 */     GIR_RootConstrainSelectedInstOperands,
     /*   71925 */     // GIR_Coverage, 46297,
     /*   71925 */     GIR_EraseRootFromParent_Done,
     /*   71926 */   // Label 1156: @71926
     /*   71926 */   GIM_Reject,
     /*   71927 */ // Label 1140: @71927
     /*   71927 */ GIM_Reject,
     /*   71928 */ // Label 983: @71928
     /*   71928 */ GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(73050),
     /*   71933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   71936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   71939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71943 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(72032), // Rule ID 47280 //
     /*   71948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71963 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71982 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71991 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   72008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72030 */     GIR_RootConstrainSelectedInstOperands,
     /*   72031 */     // GIR_Coverage, 47280,
     /*   72031 */     GIR_EraseRootFromParent_Done,
     /*   72032 */   // Label 1158: @72032
     /*   72032 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(72121), // Rule ID 47281 //
     /*   72037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72052 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72071 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72080 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   72080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   72097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72119 */     GIR_RootConstrainSelectedInstOperands,
     /*   72120 */     // GIR_Coverage, 47281,
     /*   72120 */     GIR_EraseRootFromParent_Done,
     /*   72121 */   // Label 1159: @72121
     /*   72121 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(72210), // Rule ID 47040 //
     /*   72126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72141 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72160 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72169 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   72169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   72186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72208 */     GIR_RootConstrainSelectedInstOperands,
     /*   72209 */     // GIR_Coverage, 47040,
     /*   72209 */     GIR_EraseRootFromParent_Done,
     /*   72210 */   // Label 1160: @72210
     /*   72210 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(72299), // Rule ID 47041 //
     /*   72215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72230 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72249 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72258 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   72258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   72275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72297 */     GIR_RootConstrainSelectedInstOperands,
     /*   72298 */     // GIR_Coverage, 47041,
     /*   72298 */     GIR_EraseRootFromParent_Done,
     /*   72299 */   // Label 1161: @72299
     /*   72299 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(72388), // Rule ID 47160 //
     /*   72304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72319 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72338 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72347 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   72347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   72364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72386 */     GIR_RootConstrainSelectedInstOperands,
     /*   72387 */     // GIR_Coverage, 47160,
     /*   72387 */     GIR_EraseRootFromParent_Done,
     /*   72388 */   // Label 1162: @72388
     /*   72388 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72477), // Rule ID 47161 //
     /*   72393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72408 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72427 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72436 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   72436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   72453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72475 */     GIR_RootConstrainSelectedInstOperands,
     /*   72476 */     // GIR_Coverage, 47161,
     /*   72476 */     GIR_EraseRootFromParent_Done,
     /*   72477 */   // Label 1163: @72477
     /*   72477 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72545), // Rule ID 52038 //
     /*   72482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   72501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   72505 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72519 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   72519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72543 */     GIR_RootConstrainSelectedInstOperands,
     /*   72544 */     // GIR_Coverage, 52038,
     /*   72544 */     GIR_EraseRootFromParent_Done,
     /*   72545 */   // Label 1164: @72545
     /*   72545 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(72613), // Rule ID 52039 //
     /*   72550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   72569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   72573 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72587 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   72587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72611 */     GIR_RootConstrainSelectedInstOperands,
     /*   72612 */     // GIR_Coverage, 52039,
     /*   72612 */     GIR_EraseRootFromParent_Done,
     /*   72613 */   // Label 1165: @72613
     /*   72613 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(72668), // Rule ID 47340 //
     /*   72618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72637 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72646 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72666 */     GIR_RootConstrainSelectedInstOperands,
     /*   72667 */     // GIR_Coverage, 47340,
     /*   72667 */     GIR_EraseRootFromParent_Done,
     /*   72668 */   // Label 1166: @72668
     /*   72668 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(72723), // Rule ID 47341 //
     /*   72673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72692 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72701 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72721 */     GIR_RootConstrainSelectedInstOperands,
     /*   72722 */     // GIR_Coverage, 47341,
     /*   72722 */     GIR_EraseRootFromParent_Done,
     /*   72723 */   // Label 1167: @72723
     /*   72723 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(72778), // Rule ID 47100 //
     /*   72728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72747 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72756 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   72759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72776 */     GIR_RootConstrainSelectedInstOperands,
     /*   72777 */     // GIR_Coverage, 47100,
     /*   72777 */     GIR_EraseRootFromParent_Done,
     /*   72778 */   // Label 1168: @72778
     /*   72778 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72833), // Rule ID 47101 //
     /*   72783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72802 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72811 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   72814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72831 */     GIR_RootConstrainSelectedInstOperands,
     /*   72832 */     // GIR_Coverage, 47101,
     /*   72832 */     GIR_EraseRootFromParent_Done,
     /*   72833 */   // Label 1169: @72833
     /*   72833 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72888), // Rule ID 47220 //
     /*   72838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72857 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72866 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72886 */     GIR_RootConstrainSelectedInstOperands,
     /*   72887 */     // GIR_Coverage, 47220,
     /*   72887 */     GIR_EraseRootFromParent_Done,
     /*   72888 */   // Label 1170: @72888
     /*   72888 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72943), // Rule ID 47221 //
     /*   72893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72912 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72921 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72941 */     GIR_RootConstrainSelectedInstOperands,
     /*   72942 */     // GIR_Coverage, 47221,
     /*   72942 */     GIR_EraseRootFromParent_Done,
     /*   72943 */   // Label 1171: @72943
     /*   72943 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72996), // Rule ID 46312 //
     /*   72948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72959 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   72959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   72976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72994 */     GIR_RootConstrainSelectedInstOperands,
     /*   72995 */     // GIR_Coverage, 46312,
     /*   72995 */     GIR_EraseRootFromParent_Done,
     /*   72996 */   // Label 1172: @72996
     /*   72996 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(73049), // Rule ID 46313 //
     /*   73001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   73004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73012 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   73012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   73015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   73029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   73044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73047 */     GIR_RootConstrainSelectedInstOperands,
     /*   73048 */     // GIR_Coverage, 46313,
     /*   73048 */     GIR_EraseRootFromParent_Done,
     /*   73049 */   // Label 1173: @73049
     /*   73049 */   GIM_Reject,
     /*   73050 */ // Label 1157: @73050
     /*   73050 */ GIM_Reject,
     /*   73051 */ // Label 984: @73051
     /*   73051 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(73297),
     /*   73056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   73062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73070 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(73134), // Rule ID 51982 //
     /*   73075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   73094 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73108 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   73111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73132 */     GIR_RootConstrainSelectedInstOperands,
     /*   73133 */     // GIR_Coverage, 51982,
     /*   73133 */     GIR_EraseRootFromParent_Done,
     /*   73134 */   // Label 1175: @73134
     /*   73134 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(73198), // Rule ID 51983 //
     /*   73139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   73158 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73172 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   73175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73196 */     GIR_RootConstrainSelectedInstOperands,
     /*   73197 */     // GIR_Coverage, 51983,
     /*   73197 */     GIR_EraseRootFromParent_Done,
     /*   73198 */   // Label 1176: @73198
     /*   73198 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(73247), // Rule ID 46256 //
     /*   73203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73210 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   73213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   73227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73245 */     GIR_RootConstrainSelectedInstOperands,
     /*   73246 */     // GIR_Coverage, 46256,
     /*   73246 */     GIR_EraseRootFromParent_Done,
     /*   73247 */   // Label 1177: @73247
     /*   73247 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(73296), // Rule ID 46257 //
     /*   73252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73259 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   73262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   73276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73294 */     GIR_RootConstrainSelectedInstOperands,
     /*   73295 */     // GIR_Coverage, 46257,
     /*   73295 */     GIR_EraseRootFromParent_Done,
     /*   73296 */   // Label 1178: @73296
     /*   73296 */   GIM_Reject,
     /*   73297 */ // Label 1174: @73297
     /*   73297 */ GIM_Reject,
     /*   73298 */ // Label 985: @73298
     /*   73298 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(74420),
     /*   73303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73313 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(73402), // Rule ID 47240 //
     /*   73318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73333 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73352 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73361 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73400 */     GIR_RootConstrainSelectedInstOperands,
     /*   73401 */     // GIR_Coverage, 47240,
     /*   73401 */     GIR_EraseRootFromParent_Done,
     /*   73402 */   // Label 1180: @73402
     /*   73402 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(73491), // Rule ID 47241 //
     /*   73407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73422 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73441 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73450 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73489 */     GIR_RootConstrainSelectedInstOperands,
     /*   73490 */     // GIR_Coverage, 47241,
     /*   73490 */     GIR_EraseRootFromParent_Done,
     /*   73491 */   // Label 1181: @73491
     /*   73491 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73580), // Rule ID 47000 //
     /*   73496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73511 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73530 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73539 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   73556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73578 */     GIR_RootConstrainSelectedInstOperands,
     /*   73579 */     // GIR_Coverage, 47000,
     /*   73579 */     GIR_EraseRootFromParent_Done,
     /*   73580 */   // Label 1182: @73580
     /*   73580 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73669), // Rule ID 47001 //
     /*   73585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73619 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73628 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   73645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73667 */     GIR_RootConstrainSelectedInstOperands,
     /*   73668 */     // GIR_Coverage, 47001,
     /*   73668 */     GIR_EraseRootFromParent_Done,
     /*   73669 */   // Label 1183: @73669
     /*   73669 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73758), // Rule ID 47120 //
     /*   73674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73708 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73717 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73756 */     GIR_RootConstrainSelectedInstOperands,
     /*   73757 */     // GIR_Coverage, 47120,
     /*   73757 */     GIR_EraseRootFromParent_Done,
     /*   73758 */   // Label 1184: @73758
     /*   73758 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73847), // Rule ID 47121 //
     /*   73763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73778 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73797 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73799 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73806 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73845 */     GIR_RootConstrainSelectedInstOperands,
     /*   73846 */     // GIR_Coverage, 47121,
     /*   73846 */     GIR_EraseRootFromParent_Done,
     /*   73847 */   // Label 1185: @73847
     /*   73847 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73915), // Rule ID 52010 //
     /*   73852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73875 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73889 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   73889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   73892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73913 */     GIR_RootConstrainSelectedInstOperands,
     /*   73914 */     // GIR_Coverage, 52010,
     /*   73914 */     GIR_EraseRootFromParent_Done,
     /*   73915 */   // Label 1186: @73915
     /*   73915 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73983), // Rule ID 52011 //
     /*   73920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73943 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73957 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   73957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   73960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73981 */     GIR_RootConstrainSelectedInstOperands,
     /*   73982 */     // GIR_Coverage, 52011,
     /*   73982 */     GIR_EraseRootFromParent_Done,
     /*   73983 */   // Label 1187: @73983
     /*   73983 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(74038), // Rule ID 47300 //
     /*   73988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   74007 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   74014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74016 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   74016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   74019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74036 */     GIR_RootConstrainSelectedInstOperands,
     /*   74037 */     // GIR_Coverage, 47300,
     /*   74037 */     GIR_EraseRootFromParent_Done,
     /*   74038 */   // Label 1188: @74038
     /*   74038 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(74093), // Rule ID 47301 //
     /*   74043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   74062 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   74069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74071 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   74071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   74074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74091 */     GIR_RootConstrainSelectedInstOperands,
     /*   74092 */     // GIR_Coverage, 47301,
     /*   74092 */     GIR_EraseRootFromParent_Done,
     /*   74093 */   // Label 1189: @74093
     /*   74093 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(74148), // Rule ID 47060 //
     /*   74098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   74117 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   74124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74126 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   74126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   74129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74146 */     GIR_RootConstrainSelectedInstOperands,
     /*   74147 */     // GIR_Coverage, 47060,
     /*   74147 */     GIR_EraseRootFromParent_Done,
     /*   74148 */   // Label 1190: @74148
     /*   74148 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(74203), // Rule ID 47061 //
     /*   74153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   74172 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   74179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74181 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   74181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   74184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74201 */     GIR_RootConstrainSelectedInstOperands,
     /*   74202 */     // GIR_Coverage, 47061,
     /*   74202 */     GIR_EraseRootFromParent_Done,
     /*   74203 */   // Label 1191: @74203
     /*   74203 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(74258), // Rule ID 47180 //
     /*   74208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   74227 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   74234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74236 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   74236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   74239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74256 */     GIR_RootConstrainSelectedInstOperands,
     /*   74257 */     // GIR_Coverage, 47180,
     /*   74257 */     GIR_EraseRootFromParent_Done,
     /*   74258 */   // Label 1192: @74258
     /*   74258 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(74313), // Rule ID 47181 //
     /*   74263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   74282 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   74289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74291 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   74291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   74294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74311 */     GIR_RootConstrainSelectedInstOperands,
     /*   74312 */     // GIR_Coverage, 47181,
     /*   74312 */     GIR_EraseRootFromParent_Done,
     /*   74313 */   // Label 1193: @74313
     /*   74313 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74366), // Rule ID 46284 //
     /*   74318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74329 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   74332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   74346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   74353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   74355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74364 */     GIR_RootConstrainSelectedInstOperands,
     /*   74365 */     // GIR_Coverage, 46284,
     /*   74365 */     GIR_EraseRootFromParent_Done,
     /*   74366 */   // Label 1194: @74366
     /*   74366 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74419), // Rule ID 46285 //
     /*   74371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74382 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   74385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   74399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   74406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   74408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74417 */     GIR_RootConstrainSelectedInstOperands,
     /*   74418 */     // GIR_Coverage, 46285,
     /*   74418 */     GIR_EraseRootFromParent_Done,
     /*   74419 */   // Label 1195: @74419
     /*   74419 */   GIM_Reject,
     /*   74420 */ // Label 1179: @74420
     /*   74420 */ GIM_Reject,
     /*   74421 */ // Label 986: @74421
     /*   74421 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(75543),
     /*   74426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   74429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   74432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74436 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74525), // Rule ID 47264 //
     /*   74441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74456 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74475 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74484 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74523 */     GIR_RootConstrainSelectedInstOperands,
     /*   74524 */     // GIR_Coverage, 47264,
     /*   74524 */     GIR_EraseRootFromParent_Done,
     /*   74525 */   // Label 1197: @74525
     /*   74525 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74614), // Rule ID 47265 //
     /*   74530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74545 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74564 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74573 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74612 */     GIR_RootConstrainSelectedInstOperands,
     /*   74613 */     // GIR_Coverage, 47265,
     /*   74613 */     GIR_EraseRootFromParent_Done,
     /*   74614 */   // Label 1198: @74614
     /*   74614 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74703), // Rule ID 47024 //
     /*   74619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74634 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74653 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74662 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   74679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74701 */     GIR_RootConstrainSelectedInstOperands,
     /*   74702 */     // GIR_Coverage, 47024,
     /*   74702 */     GIR_EraseRootFromParent_Done,
     /*   74703 */   // Label 1199: @74703
     /*   74703 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74792), // Rule ID 47025 //
     /*   74708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74723 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74742 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74751 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   74768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74790 */     GIR_RootConstrainSelectedInstOperands,
     /*   74791 */     // GIR_Coverage, 47025,
     /*   74791 */     GIR_EraseRootFromParent_Done,
     /*   74792 */   // Label 1200: @74792
     /*   74792 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74881), // Rule ID 47144 //
     /*   74797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74812 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74831 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74840 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74879 */     GIR_RootConstrainSelectedInstOperands,
     /*   74880 */     // GIR_Coverage, 47144,
     /*   74880 */     GIR_EraseRootFromParent_Done,
     /*   74881 */   // Label 1201: @74881
     /*   74881 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74970), // Rule ID 47145 //
     /*   74886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74920 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74929 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74968 */     GIR_RootConstrainSelectedInstOperands,
     /*   74969 */     // GIR_Coverage, 47145,
     /*   74969 */     GIR_EraseRootFromParent_Done,
     /*   74970 */   // Label 1202: @74970
     /*   74970 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(75038), // Rule ID 52026 //
     /*   74975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   74994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   74998 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75012 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   75012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   75015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75036 */     GIR_RootConstrainSelectedInstOperands,
     /*   75037 */     // GIR_Coverage, 52026,
     /*   75037 */     GIR_EraseRootFromParent_Done,
     /*   75038 */   // Label 1203: @75038
     /*   75038 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(75106), // Rule ID 52027 //
     /*   75043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   75066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75080 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   75080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   75083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75104 */     GIR_RootConstrainSelectedInstOperands,
     /*   75105 */     // GIR_Coverage, 52027,
     /*   75105 */     GIR_EraseRootFromParent_Done,
     /*   75106 */   // Label 1204: @75106
     /*   75106 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(75161), // Rule ID 47324 //
     /*   75111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   75130 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   75137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75139 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   75139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   75142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75159 */     GIR_RootConstrainSelectedInstOperands,
     /*   75160 */     // GIR_Coverage, 47324,
     /*   75160 */     GIR_EraseRootFromParent_Done,
     /*   75161 */   // Label 1205: @75161
     /*   75161 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75216), // Rule ID 47325 //
     /*   75166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   75185 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   75192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75194 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   75194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   75197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75214 */     GIR_RootConstrainSelectedInstOperands,
     /*   75215 */     // GIR_Coverage, 47325,
     /*   75215 */     GIR_EraseRootFromParent_Done,
     /*   75216 */   // Label 1206: @75216
     /*   75216 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(75271), // Rule ID 47084 //
     /*   75221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   75240 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   75247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75249 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   75249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   75252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75269 */     GIR_RootConstrainSelectedInstOperands,
     /*   75270 */     // GIR_Coverage, 47084,
     /*   75270 */     GIR_EraseRootFromParent_Done,
     /*   75271 */   // Label 1207: @75271
     /*   75271 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75326), // Rule ID 47085 //
     /*   75276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   75295 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   75302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75304 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   75304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   75307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75324 */     GIR_RootConstrainSelectedInstOperands,
     /*   75325 */     // GIR_Coverage, 47085,
     /*   75325 */     GIR_EraseRootFromParent_Done,
     /*   75326 */   // Label 1208: @75326
     /*   75326 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75381), // Rule ID 47204 //
     /*   75331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   75350 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   75357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75359 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   75359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   75362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75379 */     GIR_RootConstrainSelectedInstOperands,
     /*   75380 */     // GIR_Coverage, 47204,
     /*   75380 */     GIR_EraseRootFromParent_Done,
     /*   75381 */   // Label 1209: @75381
     /*   75381 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75436), // Rule ID 47205 //
     /*   75386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   75405 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   75412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75414 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   75414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   75417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75434 */     GIR_RootConstrainSelectedInstOperands,
     /*   75435 */     // GIR_Coverage, 47205,
     /*   75435 */     GIR_EraseRootFromParent_Done,
     /*   75436 */   // Label 1210: @75436
     /*   75436 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75489), // Rule ID 46300 //
     /*   75441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75452 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   75455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   75469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75487 */     GIR_RootConstrainSelectedInstOperands,
     /*   75488 */     // GIR_Coverage, 46300,
     /*   75488 */     GIR_EraseRootFromParent_Done,
     /*   75489 */   // Label 1211: @75489
     /*   75489 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75542), // Rule ID 46301 //
     /*   75494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75505 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   75508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   75522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75540 */     GIR_RootConstrainSelectedInstOperands,
     /*   75541 */     // GIR_Coverage, 46301,
     /*   75541 */     GIR_EraseRootFromParent_Done,
     /*   75542 */   // Label 1212: @75542
     /*   75542 */   GIM_Reject,
     /*   75543 */ // Label 1196: @75543
     /*   75543 */ GIM_Reject,
     /*   75544 */ // Label 987: @75544
     /*   75544 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(76666),
     /*   75549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75559 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75648), // Rule ID 47284 //
     /*   75564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75579 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75598 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75607 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75646 */     GIR_RootConstrainSelectedInstOperands,
     /*   75647 */     // GIR_Coverage, 47284,
     /*   75647 */     GIR_EraseRootFromParent_Done,
     /*   75648 */   // Label 1214: @75648
     /*   75648 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(75737), // Rule ID 47285 //
     /*   75653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75668 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75687 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75696 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75735 */     GIR_RootConstrainSelectedInstOperands,
     /*   75736 */     // GIR_Coverage, 47285,
     /*   75736 */     GIR_EraseRootFromParent_Done,
     /*   75737 */   // Label 1215: @75737
     /*   75737 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(75826), // Rule ID 47044 //
     /*   75742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75757 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75776 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75785 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75824 */     GIR_RootConstrainSelectedInstOperands,
     /*   75825 */     // GIR_Coverage, 47044,
     /*   75825 */     GIR_EraseRootFromParent_Done,
     /*   75826 */   // Label 1216: @75826
     /*   75826 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(75915), // Rule ID 47045 //
     /*   75831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75865 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75874 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75913 */     GIR_RootConstrainSelectedInstOperands,
     /*   75914 */     // GIR_Coverage, 47045,
     /*   75914 */     GIR_EraseRootFromParent_Done,
     /*   75915 */   // Label 1217: @75915
     /*   75915 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(76004), // Rule ID 47164 //
     /*   75920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75935 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75954 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75963 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76002 */     GIR_RootConstrainSelectedInstOperands,
     /*   76003 */     // GIR_Coverage, 47164,
     /*   76003 */     GIR_EraseRootFromParent_Done,
     /*   76004 */   // Label 1218: @76004
     /*   76004 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(76093), // Rule ID 47165 //
     /*   76009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   76012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76024 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76043 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76052 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   76052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   76069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76091 */     GIR_RootConstrainSelectedInstOperands,
     /*   76092 */     // GIR_Coverage, 47165,
     /*   76092 */     GIR_EraseRootFromParent_Done,
     /*   76093 */   // Label 1219: @76093
     /*   76093 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76161), // Rule ID 52042 //
     /*   76098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   76101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   76117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   76121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76135 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   76135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   76138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76159 */     GIR_RootConstrainSelectedInstOperands,
     /*   76160 */     // GIR_Coverage, 52042,
     /*   76160 */     GIR_EraseRootFromParent_Done,
     /*   76161 */   // Label 1220: @76161
     /*   76161 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76229), // Rule ID 52043 //
     /*   76166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   76169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   76185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   76189 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76203 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   76203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   76206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76227 */     GIR_RootConstrainSelectedInstOperands,
     /*   76228 */     // GIR_Coverage, 52043,
     /*   76228 */     GIR_EraseRootFromParent_Done,
     /*   76229 */   // Label 1221: @76229
     /*   76229 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76284), // Rule ID 47344 //
     /*   76234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   76237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76253 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76262 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   76262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76282 */     GIR_RootConstrainSelectedInstOperands,
     /*   76283 */     // GIR_Coverage, 47344,
     /*   76283 */     GIR_EraseRootFromParent_Done,
     /*   76284 */   // Label 1222: @76284
     /*   76284 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76339), // Rule ID 47345 //
     /*   76289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   76292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76308 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76317 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   76317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76337 */     GIR_RootConstrainSelectedInstOperands,
     /*   76338 */     // GIR_Coverage, 47345,
     /*   76338 */     GIR_EraseRootFromParent_Done,
     /*   76339 */   // Label 1223: @76339
     /*   76339 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(76394), // Rule ID 47104 //
     /*   76344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   76347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76363 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76372 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   76372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   76375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76392 */     GIR_RootConstrainSelectedInstOperands,
     /*   76393 */     // GIR_Coverage, 47104,
     /*   76393 */     GIR_EraseRootFromParent_Done,
     /*   76394 */   // Label 1224: @76394
     /*   76394 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(76449), // Rule ID 47105 //
     /*   76399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   76402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76418 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76427 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   76427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   76430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76447 */     GIR_RootConstrainSelectedInstOperands,
     /*   76448 */     // GIR_Coverage, 47105,
     /*   76448 */     GIR_EraseRootFromParent_Done,
     /*   76449 */   // Label 1225: @76449
     /*   76449 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(76504), // Rule ID 47224 //
     /*   76454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   76457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76473 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76482 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   76482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76502 */     GIR_RootConstrainSelectedInstOperands,
     /*   76503 */     // GIR_Coverage, 47224,
     /*   76503 */     GIR_EraseRootFromParent_Done,
     /*   76504 */   // Label 1226: @76504
     /*   76504 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(76559), // Rule ID 47225 //
     /*   76509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   76512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76528 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76537 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   76537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76557 */     GIR_RootConstrainSelectedInstOperands,
     /*   76558 */     // GIR_Coverage, 47225,
     /*   76558 */     GIR_EraseRootFromParent_Done,
     /*   76559 */   // Label 1227: @76559
     /*   76559 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(76612), // Rule ID 46316 //
     /*   76564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   76567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76575 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   76575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76610 */     GIR_RootConstrainSelectedInstOperands,
     /*   76611 */     // GIR_Coverage, 46316,
     /*   76611 */     GIR_EraseRootFromParent_Done,
     /*   76612 */   // Label 1228: @76612
     /*   76612 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(76665), // Rule ID 46317 //
     /*   76617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   76620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76628 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   76628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76663 */     GIR_RootConstrainSelectedInstOperands,
     /*   76664 */     // GIR_Coverage, 46317,
     /*   76664 */     GIR_EraseRootFromParent_Done,
     /*   76665 */   // Label 1229: @76665
     /*   76665 */   GIM_Reject,
     /*   76666 */ // Label 1213: @76666
     /*   76666 */ GIM_Reject,
     /*   76667 */ // Label 988: @76667
     /*   76667 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(76913),
     /*   76672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76686 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(76750), // Rule ID 51998 //
     /*   76691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76710 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76724 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   76724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   76727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76748 */     GIR_RootConstrainSelectedInstOperands,
     /*   76749 */     // GIR_Coverage, 51998,
     /*   76749 */     GIR_EraseRootFromParent_Done,
     /*   76750 */   // Label 1231: @76750
     /*   76750 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(76814), // Rule ID 51999 //
     /*   76755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76774 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76788 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   76788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   76791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76812 */     GIR_RootConstrainSelectedInstOperands,
     /*   76813 */     // GIR_Coverage, 51999,
     /*   76813 */     GIR_EraseRootFromParent_Done,
     /*   76814 */   // Label 1232: @76814
     /*   76814 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(76863), // Rule ID 46272 //
     /*   76819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76826 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   76829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   76843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76861 */     GIR_RootConstrainSelectedInstOperands,
     /*   76862 */     // GIR_Coverage, 46272,
     /*   76862 */     GIR_EraseRootFromParent_Done,
     /*   76863 */   // Label 1233: @76863
     /*   76863 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(76912), // Rule ID 46273 //
     /*   76868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76875 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   76878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   76892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76910 */     GIR_RootConstrainSelectedInstOperands,
     /*   76911 */     // GIR_Coverage, 46273,
     /*   76911 */     GIR_EraseRootFromParent_Done,
     /*   76912 */   // Label 1234: @76912
     /*   76912 */   GIM_Reject,
     /*   76913 */ // Label 1230: @76913
     /*   76913 */ GIM_Reject,
     /*   76914 */ // Label 989: @76914
     /*   76914 */ GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(78036),
     /*   76919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   76922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   76925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76929 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(77018), // Rule ID 47244 //
     /*   76934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76949 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76968 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76977 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77016 */     GIR_RootConstrainSelectedInstOperands,
     /*   77017 */     // GIR_Coverage, 47244,
     /*   77017 */     GIR_EraseRootFromParent_Done,
     /*   77018 */   // Label 1236: @77018
     /*   77018 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(77107), // Rule ID 47245 //
     /*   77023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77038 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77057 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77066 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   77066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   77083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77105 */     GIR_RootConstrainSelectedInstOperands,
     /*   77106 */     // GIR_Coverage, 47245,
     /*   77106 */     GIR_EraseRootFromParent_Done,
     /*   77107 */   // Label 1237: @77107
     /*   77107 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(77196), // Rule ID 47004 //
     /*   77112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77127 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77146 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77155 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   77155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   77172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77194 */     GIR_RootConstrainSelectedInstOperands,
     /*   77195 */     // GIR_Coverage, 47004,
     /*   77195 */     GIR_EraseRootFromParent_Done,
     /*   77196 */   // Label 1238: @77196
     /*   77196 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(77285), // Rule ID 47005 //
     /*   77201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77216 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77235 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77244 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   77244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   77261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77283 */     GIR_RootConstrainSelectedInstOperands,
     /*   77284 */     // GIR_Coverage, 47005,
     /*   77284 */     GIR_EraseRootFromParent_Done,
     /*   77285 */   // Label 1239: @77285
     /*   77285 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(77374), // Rule ID 47124 //
     /*   77290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77305 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77324 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77333 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   77333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   77350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77372 */     GIR_RootConstrainSelectedInstOperands,
     /*   77373 */     // GIR_Coverage, 47124,
     /*   77373 */     GIR_EraseRootFromParent_Done,
     /*   77374 */   // Label 1240: @77374
     /*   77374 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(77463), // Rule ID 47125 //
     /*   77379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77394 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77413 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77422 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   77422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   77439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77461 */     GIR_RootConstrainSelectedInstOperands,
     /*   77462 */     // GIR_Coverage, 47125,
     /*   77462 */     GIR_EraseRootFromParent_Done,
     /*   77463 */   // Label 1241: @77463
     /*   77463 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(77531), // Rule ID 52014 //
     /*   77468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   77483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   77491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77505 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   77505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   77508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   77514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77529 */     GIR_RootConstrainSelectedInstOperands,
     /*   77530 */     // GIR_Coverage, 52014,
     /*   77530 */     GIR_EraseRootFromParent_Done,
     /*   77531 */   // Label 1242: @77531
     /*   77531 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(77599), // Rule ID 52015 //
     /*   77536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   77551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   77559 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77573 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   77573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   77576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   77582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77597 */     GIR_RootConstrainSelectedInstOperands,
     /*   77598 */     // GIR_Coverage, 52015,
     /*   77598 */     GIR_EraseRootFromParent_Done,
     /*   77599 */   // Label 1243: @77599
     /*   77599 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(77654), // Rule ID 47304 //
     /*   77604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77623 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77632 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77652 */     GIR_RootConstrainSelectedInstOperands,
     /*   77653 */     // GIR_Coverage, 47304,
     /*   77653 */     GIR_EraseRootFromParent_Done,
     /*   77654 */   // Label 1244: @77654
     /*   77654 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(77709), // Rule ID 47305 //
     /*   77659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77678 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77687 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77707 */     GIR_RootConstrainSelectedInstOperands,
     /*   77708 */     // GIR_Coverage, 47305,
     /*   77708 */     GIR_EraseRootFromParent_Done,
     /*   77709 */   // Label 1245: @77709
     /*   77709 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(77764), // Rule ID 47064 //
     /*   77714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77733 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77742 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   77745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77762 */     GIR_RootConstrainSelectedInstOperands,
     /*   77763 */     // GIR_Coverage, 47064,
     /*   77763 */     GIR_EraseRootFromParent_Done,
     /*   77764 */   // Label 1246: @77764
     /*   77764 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(77819), // Rule ID 47065 //
     /*   77769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77797 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   77800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77817 */     GIR_RootConstrainSelectedInstOperands,
     /*   77818 */     // GIR_Coverage, 47065,
     /*   77818 */     GIR_EraseRootFromParent_Done,
     /*   77819 */   // Label 1247: @77819
     /*   77819 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(77874), // Rule ID 47184 //
     /*   77824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77843 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77852 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77872 */     GIR_RootConstrainSelectedInstOperands,
     /*   77873 */     // GIR_Coverage, 47184,
     /*   77873 */     GIR_EraseRootFromParent_Done,
     /*   77874 */   // Label 1248: @77874
     /*   77874 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(77929), // Rule ID 47185 //
     /*   77879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77898 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77907 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77927 */     GIR_RootConstrainSelectedInstOperands,
     /*   77928 */     // GIR_Coverage, 47185,
     /*   77928 */     GIR_EraseRootFromParent_Done,
     /*   77929 */   // Label 1249: @77929
     /*   77929 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(77982), // Rule ID 46288 //
     /*   77934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77945 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   77962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   77971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77980 */     GIR_RootConstrainSelectedInstOperands,
     /*   77981 */     // GIR_Coverage, 46288,
     /*   77981 */     GIR_EraseRootFromParent_Done,
     /*   77982 */   // Label 1250: @77982
     /*   77982 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(78035), // Rule ID 46289 //
     /*   77987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77998 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   78001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   78015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78033 */     GIR_RootConstrainSelectedInstOperands,
     /*   78034 */     // GIR_Coverage, 46289,
     /*   78034 */     GIR_EraseRootFromParent_Done,
     /*   78035 */   // Label 1251: @78035
     /*   78035 */   GIM_Reject,
     /*   78036 */ // Label 1235: @78036
     /*   78036 */ GIM_Reject,
     /*   78037 */ // Label 990: @78037
     /*   78037 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(79159),
     /*   78042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78052 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(78141), // Rule ID 47268 //
     /*   78057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78072 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78091 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78100 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   78100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78139 */     GIR_RootConstrainSelectedInstOperands,
     /*   78140 */     // GIR_Coverage, 47268,
     /*   78140 */     GIR_EraseRootFromParent_Done,
     /*   78141 */   // Label 1253: @78141
     /*   78141 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(78230), // Rule ID 47269 //
     /*   78146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78161 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78180 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78189 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78228 */     GIR_RootConstrainSelectedInstOperands,
     /*   78229 */     // GIR_Coverage, 47269,
     /*   78229 */     GIR_EraseRootFromParent_Done,
     /*   78230 */   // Label 1254: @78230
     /*   78230 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(78319), // Rule ID 47028 //
     /*   78235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78250 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78269 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78278 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   78278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   78295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78317 */     GIR_RootConstrainSelectedInstOperands,
     /*   78318 */     // GIR_Coverage, 47028,
     /*   78318 */     GIR_EraseRootFromParent_Done,
     /*   78319 */   // Label 1255: @78319
     /*   78319 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(78408), // Rule ID 47029 //
     /*   78324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78339 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78358 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78367 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   78384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78406 */     GIR_RootConstrainSelectedInstOperands,
     /*   78407 */     // GIR_Coverage, 47029,
     /*   78407 */     GIR_EraseRootFromParent_Done,
     /*   78408 */   // Label 1256: @78408
     /*   78408 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(78497), // Rule ID 47148 //
     /*   78413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78428 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78447 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78456 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   78456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78495 */     GIR_RootConstrainSelectedInstOperands,
     /*   78496 */     // GIR_Coverage, 47148,
     /*   78496 */     GIR_EraseRootFromParent_Done,
     /*   78497 */   // Label 1257: @78497
     /*   78497 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(78586), // Rule ID 47149 //
     /*   78502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78517 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78536 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78545 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78584 */     GIR_RootConstrainSelectedInstOperands,
     /*   78585 */     // GIR_Coverage, 47149,
     /*   78585 */     GIR_EraseRootFromParent_Done,
     /*   78586 */   // Label 1258: @78586
     /*   78586 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(78654), // Rule ID 52030 //
     /*   78591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78614 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78628 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   78628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   78631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78652 */     GIR_RootConstrainSelectedInstOperands,
     /*   78653 */     // GIR_Coverage, 52030,
     /*   78653 */     GIR_EraseRootFromParent_Done,
     /*   78654 */   // Label 1259: @78654
     /*   78654 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(78722), // Rule ID 52031 //
     /*   78659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78682 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78696 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   78696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   78699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78720 */     GIR_RootConstrainSelectedInstOperands,
     /*   78721 */     // GIR_Coverage, 52031,
     /*   78721 */     GIR_EraseRootFromParent_Done,
     /*   78722 */   // Label 1260: @78722
     /*   78722 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(78777), // Rule ID 47328 //
     /*   78727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78746 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78755 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78775 */     GIR_RootConstrainSelectedInstOperands,
     /*   78776 */     // GIR_Coverage, 47328,
     /*   78776 */     GIR_EraseRootFromParent_Done,
     /*   78777 */   // Label 1261: @78777
     /*   78777 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(78832), // Rule ID 47329 //
     /*   78782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78801 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78810 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78830 */     GIR_RootConstrainSelectedInstOperands,
     /*   78831 */     // GIR_Coverage, 47329,
     /*   78831 */     GIR_EraseRootFromParent_Done,
     /*   78832 */   // Label 1262: @78832
     /*   78832 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(78887), // Rule ID 47088 //
     /*   78837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78856 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78865 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   78868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78885 */     GIR_RootConstrainSelectedInstOperands,
     /*   78886 */     // GIR_Coverage, 47088,
     /*   78886 */     GIR_EraseRootFromParent_Done,
     /*   78887 */   // Label 1263: @78887
     /*   78887 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(78942), // Rule ID 47089 //
     /*   78892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78911 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78920 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   78923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78940 */     GIR_RootConstrainSelectedInstOperands,
     /*   78941 */     // GIR_Coverage, 47089,
     /*   78941 */     GIR_EraseRootFromParent_Done,
     /*   78942 */   // Label 1264: @78942
     /*   78942 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(78997), // Rule ID 47208 //
     /*   78947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78975 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78995 */     GIR_RootConstrainSelectedInstOperands,
     /*   78996 */     // GIR_Coverage, 47208,
     /*   78996 */     GIR_EraseRootFromParent_Done,
     /*   78997 */   // Label 1265: @78997
     /*   78997 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(79052), // Rule ID 47209 //
     /*   79002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   79021 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79030 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   79030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79050 */     GIR_RootConstrainSelectedInstOperands,
     /*   79051 */     // GIR_Coverage, 47209,
     /*   79051 */     GIR_EraseRootFromParent_Done,
     /*   79052 */   // Label 1266: @79052
     /*   79052 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(79105), // Rule ID 46304 //
     /*   79057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79068 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   79068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   79071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   79085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   79094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   79100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79103 */     GIR_RootConstrainSelectedInstOperands,
     /*   79104 */     // GIR_Coverage, 46304,
     /*   79104 */     GIR_EraseRootFromParent_Done,
     /*   79105 */   // Label 1267: @79105
     /*   79105 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(79158), // Rule ID 46305 //
     /*   79110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79121 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   79121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   79124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   79138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   79147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   79153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79156 */     GIR_RootConstrainSelectedInstOperands,
     /*   79157 */     // GIR_Coverage, 46305,
     /*   79157 */     GIR_EraseRootFromParent_Done,
     /*   79158 */   // Label 1268: @79158
     /*   79158 */   GIM_Reject,
     /*   79159 */ // Label 1252: @79159
     /*   79159 */ GIM_Reject,
     /*   79160 */ // Label 991: @79160
     /*   79160 */ GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(79406),
     /*   79165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   79171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79179 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(79243), // Rule ID 52002 //
     /*   79184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   79203 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79217 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   79220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79241 */     GIR_RootConstrainSelectedInstOperands,
     /*   79242 */     // GIR_Coverage, 52002,
     /*   79242 */     GIR_EraseRootFromParent_Done,
     /*   79243 */   // Label 1270: @79243
     /*   79243 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(79307), // Rule ID 52003 //
     /*   79248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   79267 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79281 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   79284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79305 */     GIR_RootConstrainSelectedInstOperands,
     /*   79306 */     // GIR_Coverage, 52003,
     /*   79306 */     GIR_EraseRootFromParent_Done,
     /*   79307 */   // Label 1271: @79307
     /*   79307 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(79356), // Rule ID 46276 //
     /*   79312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79319 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   79322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   79336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   79345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79354 */     GIR_RootConstrainSelectedInstOperands,
     /*   79355 */     // GIR_Coverage, 46276,
     /*   79355 */     GIR_EraseRootFromParent_Done,
     /*   79356 */   // Label 1272: @79356
     /*   79356 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(79405), // Rule ID 46277 //
     /*   79361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79368 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   79371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   79385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   79394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79403 */     GIR_RootConstrainSelectedInstOperands,
     /*   79404 */     // GIR_Coverage, 46277,
     /*   79404 */     GIR_EraseRootFromParent_Done,
     /*   79405 */   // Label 1273: @79405
     /*   79405 */   GIM_Reject,
     /*   79406 */ // Label 1269: @79406
     /*   79406 */ GIM_Reject,
     /*   79407 */ // Label 992: @79407
     /*   79407 */ GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(80529),
     /*   79412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   79415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   79418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79422 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(79511), // Rule ID 47248 //
     /*   79427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79470 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79509 */     GIR_RootConstrainSelectedInstOperands,
     /*   79510 */     // GIR_Coverage, 47248,
     /*   79510 */     GIR_EraseRootFromParent_Done,
     /*   79511 */   // Label 1275: @79511
     /*   79511 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(79600), // Rule ID 47249 //
     /*   79516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79559 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79598 */     GIR_RootConstrainSelectedInstOperands,
     /*   79599 */     // GIR_Coverage, 47249,
     /*   79599 */     GIR_EraseRootFromParent_Done,
     /*   79600 */   // Label 1276: @79600
     /*   79600 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(79689), // Rule ID 47008 //
     /*   79605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79639 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79648 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   79665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79687 */     GIR_RootConstrainSelectedInstOperands,
     /*   79688 */     // GIR_Coverage, 47008,
     /*   79688 */     GIR_EraseRootFromParent_Done,
     /*   79689 */   // Label 1277: @79689
     /*   79689 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(79778), // Rule ID 47009 //
     /*   79694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79737 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   79754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79776 */     GIR_RootConstrainSelectedInstOperands,
     /*   79777 */     // GIR_Coverage, 47009,
     /*   79777 */     GIR_EraseRootFromParent_Done,
     /*   79778 */   // Label 1278: @79778
     /*   79778 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(79867), // Rule ID 47128 //
     /*   79783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79826 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79865 */     GIR_RootConstrainSelectedInstOperands,
     /*   79866 */     // GIR_Coverage, 47128,
     /*   79866 */     GIR_EraseRootFromParent_Done,
     /*   79867 */   // Label 1279: @79867
     /*   79867 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(79956), // Rule ID 47129 //
     /*   79872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79915 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79954 */     GIR_RootConstrainSelectedInstOperands,
     /*   79955 */     // GIR_Coverage, 47129,
     /*   79955 */     GIR_EraseRootFromParent_Done,
     /*   79956 */   // Label 1280: @79956
     /*   79956 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(80024), // Rule ID 52018 //
     /*   79961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   79980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   79984 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79998 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   79998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80022 */     GIR_RootConstrainSelectedInstOperands,
     /*   80023 */     // GIR_Coverage, 52018,
     /*   80023 */     GIR_EraseRootFromParent_Done,
     /*   80024 */   // Label 1281: @80024
     /*   80024 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(80092), // Rule ID 52019 //
     /*   80029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   80048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   80052 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80066 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   80066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80090 */     GIR_RootConstrainSelectedInstOperands,
     /*   80091 */     // GIR_Coverage, 52019,
     /*   80091 */     GIR_EraseRootFromParent_Done,
     /*   80092 */   // Label 1282: @80092
     /*   80092 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(80147), // Rule ID 47308 //
     /*   80097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   80116 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80125 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   80125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   80128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80145 */     GIR_RootConstrainSelectedInstOperands,
     /*   80146 */     // GIR_Coverage, 47308,
     /*   80146 */     GIR_EraseRootFromParent_Done,
     /*   80147 */   // Label 1283: @80147
     /*   80147 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(80202), // Rule ID 47309 //
     /*   80152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   80171 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80180 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   80180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   80183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80200 */     GIR_RootConstrainSelectedInstOperands,
     /*   80201 */     // GIR_Coverage, 47309,
     /*   80201 */     GIR_EraseRootFromParent_Done,
     /*   80202 */   // Label 1284: @80202
     /*   80202 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(80257), // Rule ID 47068 //
     /*   80207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   80222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   80226 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80235 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   80235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   80238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80255 */     GIR_RootConstrainSelectedInstOperands,
     /*   80256 */     // GIR_Coverage, 47068,
     /*   80256 */     GIR_EraseRootFromParent_Done,
     /*   80257 */   // Label 1285: @80257
     /*   80257 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(80312), // Rule ID 47069 //
     /*   80262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   80277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   80281 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80290 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   80290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   80293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80310 */     GIR_RootConstrainSelectedInstOperands,
     /*   80311 */     // GIR_Coverage, 47069,
     /*   80311 */     GIR_EraseRootFromParent_Done,
     /*   80312 */   // Label 1286: @80312
     /*   80312 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(80367), // Rule ID 47188 //
     /*   80317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   80332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   80336 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80345 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   80345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   80348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80365 */     GIR_RootConstrainSelectedInstOperands,
     /*   80366 */     // GIR_Coverage, 47188,
     /*   80366 */     GIR_EraseRootFromParent_Done,
     /*   80367 */   // Label 1287: @80367
     /*   80367 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(80422), // Rule ID 47189 //
     /*   80372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   80387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   80391 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80400 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   80400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   80403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80420 */     GIR_RootConstrainSelectedInstOperands,
     /*   80421 */     // GIR_Coverage, 47189,
     /*   80421 */     GIR_EraseRootFromParent_Done,
     /*   80422 */   // Label 1288: @80422
     /*   80422 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(80475), // Rule ID 46292 //
     /*   80427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80438 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   80438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   80441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80473 */     GIR_RootConstrainSelectedInstOperands,
     /*   80474 */     // GIR_Coverage, 46292,
     /*   80474 */     GIR_EraseRootFromParent_Done,
     /*   80475 */   // Label 1289: @80475
     /*   80475 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(80528), // Rule ID 46293 //
     /*   80480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80491 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   80491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   80494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80526 */     GIR_RootConstrainSelectedInstOperands,
     /*   80527 */     // GIR_Coverage, 46293,
     /*   80527 */     GIR_EraseRootFromParent_Done,
     /*   80528 */   // Label 1290: @80528
     /*   80528 */   GIM_Reject,
     /*   80529 */ // Label 1274: @80529
     /*   80529 */ GIM_Reject,
     /*   80530 */ // Label 993: @80530
     /*   80530 */ GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(80776),
     /*   80535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80549 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(80613), // Rule ID 52006 //
     /*   80554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80573 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80587 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   80587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80611 */     GIR_RootConstrainSelectedInstOperands,
     /*   80612 */     // GIR_Coverage, 52006,
     /*   80612 */     GIR_EraseRootFromParent_Done,
     /*   80613 */   // Label 1292: @80613
     /*   80613 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(80677), // Rule ID 52007 //
     /*   80618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80637 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80651 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   80651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80675 */     GIR_RootConstrainSelectedInstOperands,
     /*   80676 */     // GIR_Coverage, 52007,
     /*   80676 */     GIR_EraseRootFromParent_Done,
     /*   80677 */   // Label 1293: @80677
     /*   80677 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(80726), // Rule ID 46280 //
     /*   80682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80689 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   80692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80724 */     GIR_RootConstrainSelectedInstOperands,
     /*   80725 */     // GIR_Coverage, 46280,
     /*   80725 */     GIR_EraseRootFromParent_Done,
     /*   80726 */   // Label 1294: @80726
     /*   80726 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(80775), // Rule ID 46281 //
     /*   80731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80738 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   80741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80773 */     GIR_RootConstrainSelectedInstOperands,
     /*   80774 */     // GIR_Coverage, 46281,
     /*   80774 */     GIR_EraseRootFromParent_Done,
     /*   80775 */   // Label 1295: @80775
     /*   80775 */   GIM_Reject,
     /*   80776 */ // Label 1291: @80776
     /*   80776 */ GIM_Reject,
     /*   80777 */ // Label 994: @80777
     /*   80777 */ GIM_Reject,
     /*   80778 */ // Label 2: @80778
     /*   80778 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1320*/ GIMT_Encode4(107831),
     /*   80789 */ /*GILLT_s32*//*Label 1296*/ GIMT_Encode4(80913),
     /*   80793 */ /*GILLT_s64*//*Label 1297*/ GIMT_Encode4(80947), GIMT_Encode4(0),
     /*   80801 */ /*GILLT_nxv1s8*//*Label 1298*/ GIMT_Encode4(81151),
     /*   80805 */ /*GILLT_nxv1s16*//*Label 1299*/ GIMT_Encode4(81266),
     /*   80809 */ /*GILLT_nxv1s32*//*Label 1300*/ GIMT_Encode4(82991),
     /*   80813 */ /*GILLT_nxv1s64*//*Label 1301*/ GIMT_Encode4(84716), GIMT_Encode4(0),
     /*   80821 */ /*GILLT_nxv2s8*//*Label 1302*/ GIMT_Encode4(86441),
     /*   80825 */ /*GILLT_nxv2s16*//*Label 1303*/ GIMT_Encode4(86556),
     /*   80829 */ /*GILLT_nxv2s32*//*Label 1304*/ GIMT_Encode4(88281),
     /*   80833 */ /*GILLT_nxv2s64*//*Label 1305*/ GIMT_Encode4(90006), GIMT_Encode4(0),
     /*   80841 */ /*GILLT_nxv4s8*//*Label 1306*/ GIMT_Encode4(91731),
     /*   80845 */ /*GILLT_nxv4s16*//*Label 1307*/ GIMT_Encode4(91846),
     /*   80849 */ /*GILLT_nxv4s32*//*Label 1308*/ GIMT_Encode4(93571),
     /*   80853 */ /*GILLT_nxv4s64*//*Label 1309*/ GIMT_Encode4(95296), GIMT_Encode4(0),
     /*   80861 */ /*GILLT_nxv8s8*//*Label 1310*/ GIMT_Encode4(97021),
     /*   80865 */ /*GILLT_nxv8s16*//*Label 1311*/ GIMT_Encode4(97136),
     /*   80869 */ /*GILLT_nxv8s32*//*Label 1312*/ GIMT_Encode4(98861),
     /*   80873 */ /*GILLT_nxv8s64*//*Label 1313*/ GIMT_Encode4(100586), GIMT_Encode4(0),
     /*   80881 */ /*GILLT_nxv16s8*//*Label 1314*/ GIMT_Encode4(102311),
     /*   80885 */ /*GILLT_nxv16s16*//*Label 1315*/ GIMT_Encode4(102426),
     /*   80889 */ /*GILLT_nxv16s32*//*Label 1316*/ GIMT_Encode4(104151), GIMT_Encode4(0),
     /*   80897 */ /*GILLT_nxv32s8*//*Label 1317*/ GIMT_Encode4(105876),
     /*   80901 */ /*GILLT_nxv32s16*//*Label 1318*/ GIMT_Encode4(105991), GIMT_Encode4(0),
     /*   80909 */ /*GILLT_nxv64s8*//*Label 1319*/ GIMT_Encode4(107716),
     /*   80913 */ // Label 1296: @80913
     /*   80913 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(80946), // Rule ID 310 //
     /*   80918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /*   80921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   80924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   80927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80939 */   // (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MUL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   80939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   80944 */   GIR_RootConstrainSelectedInstOperands,
     /*   80945 */   // GIR_Coverage, 310,
     /*   80945 */   GIR_Done,
     /*   80946 */ // Label 1321: @80946
     /*   80946 */ GIM_Reject,
     /*   80947 */ // Label 1297: @80947
     /*   80947 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(81150),
     /*   80952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   80955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   80958 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(81091), // Rule ID 332 //
     /*   80963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0),
     /*   80966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   80978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   80982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   80986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80991 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*   81002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   81010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   81014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   81018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81023 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*   81034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81036 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 4294967295:{ *:[i64] }))  =>  (MULHU:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))
     /*   81036 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   81039 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   81043 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81048 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81052 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*   81055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   81057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   81060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   81064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81073 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*   81076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /*   81081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   81089 */     GIR_RootConstrainSelectedInstOperands,
     /*   81090 */     // GIR_Coverage, 332,
     /*   81090 */     GIR_EraseRootFromParent_Done,
     /*   81091 */   // Label 1323: @81091
     /*   81091 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(81122), // Rule ID 325 //
     /*   81096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_HwMode0),
     /*   81099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10123),
     /*   81115 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10123>>  =>  (MULW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   81115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULW),
     /*   81120 */     GIR_RootConstrainSelectedInstOperands,
     /*   81121 */     // GIR_Coverage, 325,
     /*   81121 */     GIR_Done,
     /*   81122 */   // Label 1324: @81122
     /*   81122 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(81149), // Rule ID 309 //
     /*   81127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /*   81130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81142 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MUL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   81142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   81147 */     GIR_RootConstrainSelectedInstOperands,
     /*   81148 */     // GIR_Coverage, 309,
     /*   81148 */     GIR_Done,
     /*   81149 */   // Label 1325: @81149
     /*   81149 */   GIM_Reject,
     /*   81150 */ // Label 1322: @81150
     /*   81150 */ GIM_Reject,
     /*   81151 */ // Label 1298: @81151
     /*   81151 */ GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(81265),
     /*   81156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   81162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81174 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(81219), // Rule ID 50868 //
     /*   81179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81182 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   81185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   81199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   81206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   81208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81217 */     GIR_RootConstrainSelectedInstOperands,
     /*   81218 */     // GIR_Coverage, 50868,
     /*   81218 */     GIR_EraseRootFromParent_Done,
     /*   81219 */   // Label 1327: @81219
     /*   81219 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(81264), // Rule ID 50869 //
     /*   81224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81227 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   81230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   81244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   81251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   81253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81262 */     GIR_RootConstrainSelectedInstOperands,
     /*   81263 */     // GIR_Coverage, 50869,
     /*   81263 */     GIR_EraseRootFromParent_Done,
     /*   81264 */   // Label 1328: @81264
     /*   81264 */   GIM_Reject,
     /*   81265 */ // Label 1326: @81265
     /*   81265 */ GIM_Reject,
     /*   81266 */ // Label 1299: @81266
     /*   81266 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(82990),
     /*   81271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   81274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   81277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81281 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(81370), // Rule ID 51634 //
     /*   81286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81320 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81329 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81368 */     GIR_RootConstrainSelectedInstOperands,
     /*   81369 */     // GIR_Coverage, 51634,
     /*   81369 */     GIR_EraseRootFromParent_Done,
     /*   81370 */   // Label 1330: @81370
     /*   81370 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(81459), // Rule ID 51635 //
     /*   81375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81390 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81409 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81418 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81457 */     GIR_RootConstrainSelectedInstOperands,
     /*   81458 */     // GIR_Coverage, 51635,
     /*   81458 */     GIR_EraseRootFromParent_Done,
     /*   81459 */   // Label 1331: @81459
     /*   81459 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(81548), // Rule ID 70631 //
     /*   81464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81479 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81498 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81507 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81546 */     GIR_RootConstrainSelectedInstOperands,
     /*   81547 */     // GIR_Coverage, 70631,
     /*   81547 */     GIR_EraseRootFromParent_Done,
     /*   81548 */   // Label 1332: @81548
     /*   81548 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(81637), // Rule ID 70632 //
     /*   81553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81568 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81587 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81596 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81635 */     GIR_RootConstrainSelectedInstOperands,
     /*   81636 */     // GIR_Coverage, 70632,
     /*   81636 */     GIR_EraseRootFromParent_Done,
     /*   81637 */   // Label 1333: @81637
     /*   81637 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(81726), // Rule ID 70511 //
     /*   81642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81657 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81676 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81685 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81724 */     GIR_RootConstrainSelectedInstOperands,
     /*   81725 */     // GIR_Coverage, 70511,
     /*   81725 */     GIR_EraseRootFromParent_Done,
     /*   81726 */   // Label 1334: @81726
     /*   81726 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(81815), // Rule ID 70512 //
     /*   81731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81746 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81765 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81774 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81813 */     GIR_RootConstrainSelectedInstOperands,
     /*   81814 */     // GIR_Coverage, 70512,
     /*   81814 */     GIR_EraseRootFromParent_Done,
     /*   81815 */   // Label 1335: @81815
     /*   81815 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(81904), // Rule ID 51814 //
     /*   81820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81835 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81854 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81856 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81863 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81902 */     GIR_RootConstrainSelectedInstOperands,
     /*   81903 */     // GIR_Coverage, 51814,
     /*   81903 */     GIR_EraseRootFromParent_Done,
     /*   81904 */   // Label 1336: @81904
     /*   81904 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(81993), // Rule ID 51815 //
     /*   81909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81924 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81943 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81952 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81991 */     GIR_RootConstrainSelectedInstOperands,
     /*   81992 */     // GIR_Coverage, 51815,
     /*   81992 */     GIR_EraseRootFromParent_Done,
     /*   81993 */   // Label 1337: @81993
     /*   81993 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(82082), // Rule ID 51514 //
     /*   81998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82013 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82032 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82041 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   82058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82080 */     GIR_RootConstrainSelectedInstOperands,
     /*   82081 */     // GIR_Coverage, 51514,
     /*   82081 */     GIR_EraseRootFromParent_Done,
     /*   82082 */   // Label 1338: @82082
     /*   82082 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(82171), // Rule ID 51515 //
     /*   82087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82102 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82121 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82130 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   82147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82169 */     GIR_RootConstrainSelectedInstOperands,
     /*   82170 */     // GIR_Coverage, 51515,
     /*   82170 */     GIR_EraseRootFromParent_Done,
     /*   82171 */   // Label 1339: @82171
     /*   82171 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(82260), // Rule ID 51754 //
     /*   82176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82210 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82219 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82258 */     GIR_RootConstrainSelectedInstOperands,
     /*   82259 */     // GIR_Coverage, 51754,
     /*   82259 */     GIR_EraseRootFromParent_Done,
     /*   82260 */   // Label 1340: @82260
     /*   82260 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(82349), // Rule ID 51755 //
     /*   82265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82280 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82299 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82308 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82347 */     GIR_RootConstrainSelectedInstOperands,
     /*   82348 */     // GIR_Coverage, 51755,
     /*   82348 */     GIR_EraseRootFromParent_Done,
     /*   82349 */   // Label 1341: @82349
     /*   82349 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(82438), // Rule ID 51694 //
     /*   82354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82369 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82388 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82397 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82436 */     GIR_RootConstrainSelectedInstOperands,
     /*   82437 */     // GIR_Coverage, 51694,
     /*   82437 */     GIR_EraseRootFromParent_Done,
     /*   82438 */   // Label 1342: @82438
     /*   82438 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(82527), // Rule ID 51695 //
     /*   82443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82458 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82477 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82486 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82525 */     GIR_RootConstrainSelectedInstOperands,
     /*   82526 */     // GIR_Coverage, 51695,
     /*   82526 */     GIR_EraseRootFromParent_Done,
     /*   82527 */   // Label 1343: @82527
     /*   82527 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(82616), // Rule ID 70571 //
     /*   82532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82547 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82566 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82575 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82614 */     GIR_RootConstrainSelectedInstOperands,
     /*   82615 */     // GIR_Coverage, 70571,
     /*   82615 */     GIR_EraseRootFromParent_Done,
     /*   82616 */   // Label 1344: @82616
     /*   82616 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(82705), // Rule ID 70572 //
     /*   82621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82636 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82655 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82664 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82703 */     GIR_RootConstrainSelectedInstOperands,
     /*   82704 */     // GIR_Coverage, 70572,
     /*   82704 */     GIR_EraseRootFromParent_Done,
     /*   82705 */   // Label 1345: @82705
     /*   82705 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(82794), // Rule ID 51574 //
     /*   82710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82725 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82744 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82753 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82792 */     GIR_RootConstrainSelectedInstOperands,
     /*   82793 */     // GIR_Coverage, 51574,
     /*   82793 */     GIR_EraseRootFromParent_Done,
     /*   82794 */   // Label 1346: @82794
     /*   82794 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(82883), // Rule ID 51575 //
     /*   82799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82814 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82833 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82842 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82881 */     GIR_RootConstrainSelectedInstOperands,
     /*   82882 */     // GIR_Coverage, 51575,
     /*   82882 */     GIR_EraseRootFromParent_Done,
     /*   82883 */   // Label 1347: @82883
     /*   82883 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(82936), // Rule ID 50880 //
     /*   82888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82899 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   82916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   82923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   82925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82934 */     GIR_RootConstrainSelectedInstOperands,
     /*   82935 */     // GIR_Coverage, 50880,
     /*   82935 */     GIR_EraseRootFromParent_Done,
     /*   82936 */   // Label 1348: @82936
     /*   82936 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(82989), // Rule ID 50881 //
     /*   82941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82952 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   82969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   82976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   82978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82987 */     GIR_RootConstrainSelectedInstOperands,
     /*   82988 */     // GIR_Coverage, 50881,
     /*   82988 */     GIR_EraseRootFromParent_Done,
     /*   82989 */   // Label 1349: @82989
     /*   82989 */   GIM_Reject,
     /*   82990 */ // Label 1329: @82990
     /*   82990 */ GIM_Reject,
     /*   82991 */ // Label 1300: @82991
     /*   82991 */ GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(84715),
     /*   82996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   82999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   83002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83006 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(83095), // Rule ID 51658 //
     /*   83011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83045 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83054 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83093 */     GIR_RootConstrainSelectedInstOperands,
     /*   83094 */     // GIR_Coverage, 51658,
     /*   83094 */     GIR_EraseRootFromParent_Done,
     /*   83095 */   // Label 1351: @83095
     /*   83095 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(83184), // Rule ID 51659 //
     /*   83100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83115 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83134 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83143 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83182 */     GIR_RootConstrainSelectedInstOperands,
     /*   83183 */     // GIR_Coverage, 51659,
     /*   83183 */     GIR_EraseRootFromParent_Done,
     /*   83184 */   // Label 1352: @83184
     /*   83184 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(83273), // Rule ID 70655 //
     /*   83189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83204 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83223 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83232 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83271 */     GIR_RootConstrainSelectedInstOperands,
     /*   83272 */     // GIR_Coverage, 70655,
     /*   83272 */     GIR_EraseRootFromParent_Done,
     /*   83273 */   // Label 1353: @83273
     /*   83273 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(83362), // Rule ID 70656 //
     /*   83278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83293 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83312 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83321 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83360 */     GIR_RootConstrainSelectedInstOperands,
     /*   83361 */     // GIR_Coverage, 70656,
     /*   83361 */     GIR_EraseRootFromParent_Done,
     /*   83362 */   // Label 1354: @83362
     /*   83362 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(83451), // Rule ID 70535 //
     /*   83367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83382 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83401 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83410 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83449 */     GIR_RootConstrainSelectedInstOperands,
     /*   83450 */     // GIR_Coverage, 70535,
     /*   83450 */     GIR_EraseRootFromParent_Done,
     /*   83451 */   // Label 1355: @83451
     /*   83451 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(83540), // Rule ID 70536 //
     /*   83456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83471 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83490 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83499 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83538 */     GIR_RootConstrainSelectedInstOperands,
     /*   83539 */     // GIR_Coverage, 70536,
     /*   83539 */     GIR_EraseRootFromParent_Done,
     /*   83540 */   // Label 1356: @83540
     /*   83540 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(83629), // Rule ID 51838 //
     /*   83545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83560 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83579 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83588 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83627 */     GIR_RootConstrainSelectedInstOperands,
     /*   83628 */     // GIR_Coverage, 51838,
     /*   83628 */     GIR_EraseRootFromParent_Done,
     /*   83629 */   // Label 1357: @83629
     /*   83629 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(83718), // Rule ID 51839 //
     /*   83634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83649 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83668 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83677 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83716 */     GIR_RootConstrainSelectedInstOperands,
     /*   83717 */     // GIR_Coverage, 51839,
     /*   83717 */     GIR_EraseRootFromParent_Done,
     /*   83718 */   // Label 1358: @83718
     /*   83718 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(83807), // Rule ID 51538 //
     /*   83723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83738 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83757 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83766 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   83783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83805 */     GIR_RootConstrainSelectedInstOperands,
     /*   83806 */     // GIR_Coverage, 51538,
     /*   83806 */     GIR_EraseRootFromParent_Done,
     /*   83807 */   // Label 1359: @83807
     /*   83807 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(83896), // Rule ID 51539 //
     /*   83812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83827 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83855 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   83872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83894 */     GIR_RootConstrainSelectedInstOperands,
     /*   83895 */     // GIR_Coverage, 51539,
     /*   83895 */     GIR_EraseRootFromParent_Done,
     /*   83896 */   // Label 1360: @83896
     /*   83896 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(83985), // Rule ID 51778 //
     /*   83901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83916 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83935 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83944 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83983 */     GIR_RootConstrainSelectedInstOperands,
     /*   83984 */     // GIR_Coverage, 51778,
     /*   83984 */     GIR_EraseRootFromParent_Done,
     /*   83985 */   // Label 1361: @83985
     /*   83985 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(84074), // Rule ID 51779 //
     /*   83990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84005 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84024 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84033 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   84050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84072 */     GIR_RootConstrainSelectedInstOperands,
     /*   84073 */     // GIR_Coverage, 51779,
     /*   84073 */     GIR_EraseRootFromParent_Done,
     /*   84074 */   // Label 1362: @84074
     /*   84074 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(84163), // Rule ID 51718 //
     /*   84079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84094 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84113 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84122 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84161 */     GIR_RootConstrainSelectedInstOperands,
     /*   84162 */     // GIR_Coverage, 51718,
     /*   84162 */     GIR_EraseRootFromParent_Done,
     /*   84163 */   // Label 1363: @84163
     /*   84163 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(84252), // Rule ID 51719 //
     /*   84168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84183 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84202 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84211 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84250 */     GIR_RootConstrainSelectedInstOperands,
     /*   84251 */     // GIR_Coverage, 51719,
     /*   84251 */     GIR_EraseRootFromParent_Done,
     /*   84252 */   // Label 1364: @84252
     /*   84252 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(84341), // Rule ID 70595 //
     /*   84257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84291 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84300 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   84317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84339 */     GIR_RootConstrainSelectedInstOperands,
     /*   84340 */     // GIR_Coverage, 70595,
     /*   84340 */     GIR_EraseRootFromParent_Done,
     /*   84341 */   // Label 1365: @84341
     /*   84341 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(84430), // Rule ID 70596 //
     /*   84346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84380 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84389 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   84406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84428 */     GIR_RootConstrainSelectedInstOperands,
     /*   84429 */     // GIR_Coverage, 70596,
     /*   84429 */     GIR_EraseRootFromParent_Done,
     /*   84430 */   // Label 1366: @84430
     /*   84430 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(84519), // Rule ID 51598 //
     /*   84435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84450 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84469 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84478 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84517 */     GIR_RootConstrainSelectedInstOperands,
     /*   84518 */     // GIR_Coverage, 51598,
     /*   84518 */     GIR_EraseRootFromParent_Done,
     /*   84519 */   // Label 1367: @84519
     /*   84519 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(84608), // Rule ID 51599 //
     /*   84524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84539 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84558 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84567 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84606 */     GIR_RootConstrainSelectedInstOperands,
     /*   84607 */     // GIR_Coverage, 51599,
     /*   84607 */     GIR_EraseRootFromParent_Done,
     /*   84608 */   // Label 1368: @84608
     /*   84608 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(84661), // Rule ID 50888 //
     /*   84613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84624 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   84641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   84648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   84650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84659 */     GIR_RootConstrainSelectedInstOperands,
     /*   84660 */     // GIR_Coverage, 50888,
     /*   84660 */     GIR_EraseRootFromParent_Done,
     /*   84661 */   // Label 1369: @84661
     /*   84661 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(84714), // Rule ID 50889 //
     /*   84666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84677 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   84694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   84701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   84703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84712 */     GIR_RootConstrainSelectedInstOperands,
     /*   84713 */     // GIR_Coverage, 50889,
     /*   84713 */     GIR_EraseRootFromParent_Done,
     /*   84714 */   // Label 1370: @84714
     /*   84714 */   GIM_Reject,
     /*   84715 */ // Label 1350: @84715
     /*   84715 */ GIM_Reject,
     /*   84716 */ // Label 1301: @84716
     /*   84716 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(86440),
     /*   84721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   84724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   84727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84731 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(84820), // Rule ID 51678 //
     /*   84736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84751 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84770 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84772 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84779 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84818 */     GIR_RootConstrainSelectedInstOperands,
     /*   84819 */     // GIR_Coverage, 51678,
     /*   84819 */     GIR_EraseRootFromParent_Done,
     /*   84820 */   // Label 1372: @84820
     /*   84820 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(84909), // Rule ID 51679 //
     /*   84825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84840 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84859 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84868 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84907 */     GIR_RootConstrainSelectedInstOperands,
     /*   84908 */     // GIR_Coverage, 51679,
     /*   84908 */     GIR_EraseRootFromParent_Done,
     /*   84909 */   // Label 1373: @84909
     /*   84909 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(84998), // Rule ID 70675 //
     /*   84914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84929 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84948 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84957 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84996 */     GIR_RootConstrainSelectedInstOperands,
     /*   84997 */     // GIR_Coverage, 70675,
     /*   84997 */     GIR_EraseRootFromParent_Done,
     /*   84998 */   // Label 1374: @84998
     /*   84998 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(85087), // Rule ID 70676 //
     /*   85003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85018 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85037 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85046 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85085 */     GIR_RootConstrainSelectedInstOperands,
     /*   85086 */     // GIR_Coverage, 70676,
     /*   85086 */     GIR_EraseRootFromParent_Done,
     /*   85087 */   // Label 1375: @85087
     /*   85087 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(85176), // Rule ID 70555 //
     /*   85092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85126 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85135 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85174 */     GIR_RootConstrainSelectedInstOperands,
     /*   85175 */     // GIR_Coverage, 70555,
     /*   85175 */     GIR_EraseRootFromParent_Done,
     /*   85176 */   // Label 1376: @85176
     /*   85176 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(85265), // Rule ID 70556 //
     /*   85181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85215 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85224 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85263 */     GIR_RootConstrainSelectedInstOperands,
     /*   85264 */     // GIR_Coverage, 70556,
     /*   85264 */     GIR_EraseRootFromParent_Done,
     /*   85265 */   // Label 1377: @85265
     /*   85265 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(85354), // Rule ID 51858 //
     /*   85270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85285 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85304 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85313 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85352 */     GIR_RootConstrainSelectedInstOperands,
     /*   85353 */     // GIR_Coverage, 51858,
     /*   85353 */     GIR_EraseRootFromParent_Done,
     /*   85354 */   // Label 1378: @85354
     /*   85354 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(85443), // Rule ID 51859 //
     /*   85359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85374 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85393 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85402 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85441 */     GIR_RootConstrainSelectedInstOperands,
     /*   85442 */     // GIR_Coverage, 51859,
     /*   85442 */     GIR_EraseRootFromParent_Done,
     /*   85443 */   // Label 1379: @85443
     /*   85443 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(85532), // Rule ID 51558 //
     /*   85448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85463 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85482 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85491 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   85508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85530 */     GIR_RootConstrainSelectedInstOperands,
     /*   85531 */     // GIR_Coverage, 51558,
     /*   85531 */     GIR_EraseRootFromParent_Done,
     /*   85532 */   // Label 1380: @85532
     /*   85532 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(85621), // Rule ID 51559 //
     /*   85537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85571 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85580 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   85597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85619 */     GIR_RootConstrainSelectedInstOperands,
     /*   85620 */     // GIR_Coverage, 51559,
     /*   85620 */     GIR_EraseRootFromParent_Done,
     /*   85621 */   // Label 1381: @85621
     /*   85621 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(85710), // Rule ID 51798 //
     /*   85626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85641 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85660 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85669 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85708 */     GIR_RootConstrainSelectedInstOperands,
     /*   85709 */     // GIR_Coverage, 51798,
     /*   85709 */     GIR_EraseRootFromParent_Done,
     /*   85710 */   // Label 1382: @85710
     /*   85710 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(85799), // Rule ID 51799 //
     /*   85715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85749 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85758 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85797 */     GIR_RootConstrainSelectedInstOperands,
     /*   85798 */     // GIR_Coverage, 51799,
     /*   85798 */     GIR_EraseRootFromParent_Done,
     /*   85799 */   // Label 1383: @85799
     /*   85799 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(85888), // Rule ID 51738 //
     /*   85804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85838 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85847 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85886 */     GIR_RootConstrainSelectedInstOperands,
     /*   85887 */     // GIR_Coverage, 51738,
     /*   85887 */     GIR_EraseRootFromParent_Done,
     /*   85888 */   // Label 1384: @85888
     /*   85888 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(85977), // Rule ID 51739 //
     /*   85893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85927 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85936 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85975 */     GIR_RootConstrainSelectedInstOperands,
     /*   85976 */     // GIR_Coverage, 51739,
     /*   85976 */     GIR_EraseRootFromParent_Done,
     /*   85977 */   // Label 1385: @85977
     /*   85977 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(86066), // Rule ID 70615 //
     /*   85982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85997 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86025 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   86025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   86028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   86042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86064 */     GIR_RootConstrainSelectedInstOperands,
     /*   86065 */     // GIR_Coverage, 70615,
     /*   86065 */     GIR_EraseRootFromParent_Done,
     /*   86066 */   // Label 1386: @86066
     /*   86066 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(86155), // Rule ID 70616 //
     /*   86071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   86074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86105 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86114 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   86114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   86117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   86131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86153 */     GIR_RootConstrainSelectedInstOperands,
     /*   86154 */     // GIR_Coverage, 70616,
     /*   86154 */     GIR_EraseRootFromParent_Done,
     /*   86155 */   // Label 1387: @86155
     /*   86155 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(86244), // Rule ID 51618 //
     /*   86160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   86163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86194 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86203 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   86203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   86206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   86220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86242 */     GIR_RootConstrainSelectedInstOperands,
     /*   86243 */     // GIR_Coverage, 51618,
     /*   86243 */     GIR_EraseRootFromParent_Done,
     /*   86244 */   // Label 1388: @86244
     /*   86244 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(86333), // Rule ID 51619 //
     /*   86249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   86252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86264 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86283 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86292 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   86292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   86295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   86309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86331 */     GIR_RootConstrainSelectedInstOperands,
     /*   86332 */     // GIR_Coverage, 51619,
     /*   86332 */     GIR_EraseRootFromParent_Done,
     /*   86333 */   // Label 1389: @86333
     /*   86333 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(86386), // Rule ID 50904 //
     /*   86338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   86341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86349 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   86349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   86352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   86366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   86381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86384 */     GIR_RootConstrainSelectedInstOperands,
     /*   86385 */     // GIR_Coverage, 50904,
     /*   86385 */     GIR_EraseRootFromParent_Done,
     /*   86386 */   // Label 1390: @86386
     /*   86386 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(86439), // Rule ID 50905 //
     /*   86391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   86394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86402 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   86402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   86405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   86419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   86434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86437 */     GIR_RootConstrainSelectedInstOperands,
     /*   86438 */     // GIR_Coverage, 50905,
     /*   86438 */     GIR_EraseRootFromParent_Done,
     /*   86439 */   // Label 1391: @86439
     /*   86439 */   GIM_Reject,
     /*   86440 */ // Label 1371: @86440
     /*   86440 */ GIM_Reject,
     /*   86441 */ // Label 1302: @86441
     /*   86441 */ GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(86555),
     /*   86446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   86452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86464 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(86509), // Rule ID 50872 //
     /*   86469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86472 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   86475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   86489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86507 */     GIR_RootConstrainSelectedInstOperands,
     /*   86508 */     // GIR_Coverage, 50872,
     /*   86508 */     GIR_EraseRootFromParent_Done,
     /*   86509 */   // Label 1393: @86509
     /*   86509 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(86554), // Rule ID 50873 //
     /*   86514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86517 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   86520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   86534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86552 */     GIR_RootConstrainSelectedInstOperands,
     /*   86553 */     // GIR_Coverage, 50873,
     /*   86553 */     GIR_EraseRootFromParent_Done,
     /*   86554 */   // Label 1394: @86554
     /*   86554 */   GIM_Reject,
     /*   86555 */ // Label 1392: @86555
     /*   86555 */ GIM_Reject,
     /*   86556 */ // Label 1303: @86556
     /*   86556 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(88280),
     /*   86561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   86564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   86567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86571 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(86660), // Rule ID 51638 //
     /*   86576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86591 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86610 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86619 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86658 */     GIR_RootConstrainSelectedInstOperands,
     /*   86659 */     // GIR_Coverage, 51638,
     /*   86659 */     GIR_EraseRootFromParent_Done,
     /*   86660 */   // Label 1396: @86660
     /*   86660 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(86749), // Rule ID 51639 //
     /*   86665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86680 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86699 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86708 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86747 */     GIR_RootConstrainSelectedInstOperands,
     /*   86748 */     // GIR_Coverage, 51639,
     /*   86748 */     GIR_EraseRootFromParent_Done,
     /*   86749 */   // Label 1397: @86749
     /*   86749 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(86838), // Rule ID 70635 //
     /*   86754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86769 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86788 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86797 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86836 */     GIR_RootConstrainSelectedInstOperands,
     /*   86837 */     // GIR_Coverage, 70635,
     /*   86837 */     GIR_EraseRootFromParent_Done,
     /*   86838 */   // Label 1398: @86838
     /*   86838 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(86927), // Rule ID 70636 //
     /*   86843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86858 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86877 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86886 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86925 */     GIR_RootConstrainSelectedInstOperands,
     /*   86926 */     // GIR_Coverage, 70636,
     /*   86926 */     GIR_EraseRootFromParent_Done,
     /*   86927 */   // Label 1399: @86927
     /*   86927 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(87016), // Rule ID 70515 //
     /*   86932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86947 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86966 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86975 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87014 */     GIR_RootConstrainSelectedInstOperands,
     /*   87015 */     // GIR_Coverage, 70515,
     /*   87015 */     GIR_EraseRootFromParent_Done,
     /*   87016 */   // Label 1400: @87016
     /*   87016 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(87105), // Rule ID 70516 //
     /*   87021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87036 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87055 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87064 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87103 */     GIR_RootConstrainSelectedInstOperands,
     /*   87104 */     // GIR_Coverage, 70516,
     /*   87104 */     GIR_EraseRootFromParent_Done,
     /*   87105 */   // Label 1401: @87105
     /*   87105 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(87194), // Rule ID 51818 //
     /*   87110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87125 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87144 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87153 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87192 */     GIR_RootConstrainSelectedInstOperands,
     /*   87193 */     // GIR_Coverage, 51818,
     /*   87193 */     GIR_EraseRootFromParent_Done,
     /*   87194 */   // Label 1402: @87194
     /*   87194 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(87283), // Rule ID 51819 //
     /*   87199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87214 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87233 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87242 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87281 */     GIR_RootConstrainSelectedInstOperands,
     /*   87282 */     // GIR_Coverage, 51819,
     /*   87282 */     GIR_EraseRootFromParent_Done,
     /*   87283 */   // Label 1403: @87283
     /*   87283 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(87372), // Rule ID 51518 //
     /*   87288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87303 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87322 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87331 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   87348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87370 */     GIR_RootConstrainSelectedInstOperands,
     /*   87371 */     // GIR_Coverage, 51518,
     /*   87371 */     GIR_EraseRootFromParent_Done,
     /*   87372 */   // Label 1404: @87372
     /*   87372 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(87461), // Rule ID 51519 //
     /*   87377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87392 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87411 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87420 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   87437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87459 */     GIR_RootConstrainSelectedInstOperands,
     /*   87460 */     // GIR_Coverage, 51519,
     /*   87460 */     GIR_EraseRootFromParent_Done,
     /*   87461 */   // Label 1405: @87461
     /*   87461 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(87550), // Rule ID 51758 //
     /*   87466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87500 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87509 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87548 */     GIR_RootConstrainSelectedInstOperands,
     /*   87549 */     // GIR_Coverage, 51758,
     /*   87549 */     GIR_EraseRootFromParent_Done,
     /*   87550 */   // Label 1406: @87550
     /*   87550 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(87639), // Rule ID 51759 //
     /*   87555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87570 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87589 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87598 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87637 */     GIR_RootConstrainSelectedInstOperands,
     /*   87638 */     // GIR_Coverage, 51759,
     /*   87638 */     GIR_EraseRootFromParent_Done,
     /*   87639 */   // Label 1407: @87639
     /*   87639 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(87728), // Rule ID 51698 //
     /*   87644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87659 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87678 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87687 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87726 */     GIR_RootConstrainSelectedInstOperands,
     /*   87727 */     // GIR_Coverage, 51698,
     /*   87727 */     GIR_EraseRootFromParent_Done,
     /*   87728 */   // Label 1408: @87728
     /*   87728 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(87817), // Rule ID 51699 //
     /*   87733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87748 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87767 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87776 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87815 */     GIR_RootConstrainSelectedInstOperands,
     /*   87816 */     // GIR_Coverage, 51699,
     /*   87816 */     GIR_EraseRootFromParent_Done,
     /*   87817 */   // Label 1409: @87817
     /*   87817 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(87906), // Rule ID 70575 //
     /*   87822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87837 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87856 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87865 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87904 */     GIR_RootConstrainSelectedInstOperands,
     /*   87905 */     // GIR_Coverage, 70575,
     /*   87905 */     GIR_EraseRootFromParent_Done,
     /*   87906 */   // Label 1410: @87906
     /*   87906 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(87995), // Rule ID 70576 //
     /*   87911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87926 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87945 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87954 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87993 */     GIR_RootConstrainSelectedInstOperands,
     /*   87994 */     // GIR_Coverage, 70576,
     /*   87994 */     GIR_EraseRootFromParent_Done,
     /*   87995 */   // Label 1411: @87995
     /*   87995 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(88084), // Rule ID 51578 //
     /*   88000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   88015 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   88034 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88043 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   88043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   88046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   88060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88082 */     GIR_RootConstrainSelectedInstOperands,
     /*   88083 */     // GIR_Coverage, 51578,
     /*   88083 */     GIR_EraseRootFromParent_Done,
     /*   88084 */   // Label 1412: @88084
     /*   88084 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(88173), // Rule ID 51579 //
     /*   88089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   88104 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   88123 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88132 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   88132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   88135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   88149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88171 */     GIR_RootConstrainSelectedInstOperands,
     /*   88172 */     // GIR_Coverage, 51579,
     /*   88172 */     GIR_EraseRootFromParent_Done,
     /*   88173 */   // Label 1413: @88173
     /*   88173 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(88226), // Rule ID 50884 //
     /*   88178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88189 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   88192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   88206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   88213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   88215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88224 */     GIR_RootConstrainSelectedInstOperands,
     /*   88225 */     // GIR_Coverage, 50884,
     /*   88225 */     GIR_EraseRootFromParent_Done,
     /*   88226 */   // Label 1414: @88226
     /*   88226 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(88279), // Rule ID 50885 //
     /*   88231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88242 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   88245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   88259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   88266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   88268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88277 */     GIR_RootConstrainSelectedInstOperands,
     /*   88278 */     // GIR_Coverage, 50885,
     /*   88278 */     GIR_EraseRootFromParent_Done,
     /*   88279 */   // Label 1415: @88279
     /*   88279 */   GIM_Reject,
     /*   88280 */ // Label 1395: @88280
     /*   88280 */ GIM_Reject,
     /*   88281 */ // Label 1304: @88281
     /*   88281 */ GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(90005),
     /*   88286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   88289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   88292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88296 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(88385), // Rule ID 51662 //
     /*   88301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88335 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88344 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88383 */     GIR_RootConstrainSelectedInstOperands,
     /*   88384 */     // GIR_Coverage, 51662,
     /*   88384 */     GIR_EraseRootFromParent_Done,
     /*   88385 */   // Label 1417: @88385
     /*   88385 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(88474), // Rule ID 51663 //
     /*   88390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88405 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88424 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88433 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88472 */     GIR_RootConstrainSelectedInstOperands,
     /*   88473 */     // GIR_Coverage, 51663,
     /*   88473 */     GIR_EraseRootFromParent_Done,
     /*   88474 */   // Label 1418: @88474
     /*   88474 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(88563), // Rule ID 70659 //
     /*   88479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88494 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88513 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88522 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88561 */     GIR_RootConstrainSelectedInstOperands,
     /*   88562 */     // GIR_Coverage, 70659,
     /*   88562 */     GIR_EraseRootFromParent_Done,
     /*   88563 */   // Label 1419: @88563
     /*   88563 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(88652), // Rule ID 70660 //
     /*   88568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88583 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88602 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88611 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88650 */     GIR_RootConstrainSelectedInstOperands,
     /*   88651 */     // GIR_Coverage, 70660,
     /*   88651 */     GIR_EraseRootFromParent_Done,
     /*   88652 */   // Label 1420: @88652
     /*   88652 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(88741), // Rule ID 70539 //
     /*   88657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88672 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88691 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88700 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88739 */     GIR_RootConstrainSelectedInstOperands,
     /*   88740 */     // GIR_Coverage, 70539,
     /*   88740 */     GIR_EraseRootFromParent_Done,
     /*   88741 */   // Label 1421: @88741
     /*   88741 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(88830), // Rule ID 70540 //
     /*   88746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88761 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88780 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88789 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88828 */     GIR_RootConstrainSelectedInstOperands,
     /*   88829 */     // GIR_Coverage, 70540,
     /*   88829 */     GIR_EraseRootFromParent_Done,
     /*   88830 */   // Label 1422: @88830
     /*   88830 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(88919), // Rule ID 51842 //
     /*   88835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88850 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88869 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88878 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88917 */     GIR_RootConstrainSelectedInstOperands,
     /*   88918 */     // GIR_Coverage, 51842,
     /*   88918 */     GIR_EraseRootFromParent_Done,
     /*   88919 */   // Label 1423: @88919
     /*   88919 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(89008), // Rule ID 51843 //
     /*   88924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88939 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88958 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88967 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89006 */     GIR_RootConstrainSelectedInstOperands,
     /*   89007 */     // GIR_Coverage, 51843,
     /*   89007 */     GIR_EraseRootFromParent_Done,
     /*   89008 */   // Label 1424: @89008
     /*   89008 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(89097), // Rule ID 51542 //
     /*   89013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89028 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89047 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89056 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   89073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89095 */     GIR_RootConstrainSelectedInstOperands,
     /*   89096 */     // GIR_Coverage, 51542,
     /*   89096 */     GIR_EraseRootFromParent_Done,
     /*   89097 */   // Label 1425: @89097
     /*   89097 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(89186), // Rule ID 51543 //
     /*   89102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89117 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89136 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89145 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   89162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89184 */     GIR_RootConstrainSelectedInstOperands,
     /*   89185 */     // GIR_Coverage, 51543,
     /*   89185 */     GIR_EraseRootFromParent_Done,
     /*   89186 */   // Label 1426: @89186
     /*   89186 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(89275), // Rule ID 51782 //
     /*   89191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89225 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89234 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89273 */     GIR_RootConstrainSelectedInstOperands,
     /*   89274 */     // GIR_Coverage, 51782,
     /*   89274 */     GIR_EraseRootFromParent_Done,
     /*   89275 */   // Label 1427: @89275
     /*   89275 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(89364), // Rule ID 51783 //
     /*   89280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89295 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89314 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89323 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89362 */     GIR_RootConstrainSelectedInstOperands,
     /*   89363 */     // GIR_Coverage, 51783,
     /*   89363 */     GIR_EraseRootFromParent_Done,
     /*   89364 */   // Label 1428: @89364
     /*   89364 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(89453), // Rule ID 51722 //
     /*   89369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89384 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89403 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89412 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89451 */     GIR_RootConstrainSelectedInstOperands,
     /*   89452 */     // GIR_Coverage, 51722,
     /*   89452 */     GIR_EraseRootFromParent_Done,
     /*   89453 */   // Label 1429: @89453
     /*   89453 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(89542), // Rule ID 51723 //
     /*   89458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89473 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89492 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89501 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89540 */     GIR_RootConstrainSelectedInstOperands,
     /*   89541 */     // GIR_Coverage, 51723,
     /*   89541 */     GIR_EraseRootFromParent_Done,
     /*   89542 */   // Label 1430: @89542
     /*   89542 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(89631), // Rule ID 70599 //
     /*   89547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89562 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89581 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89590 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89629 */     GIR_RootConstrainSelectedInstOperands,
     /*   89630 */     // GIR_Coverage, 70599,
     /*   89630 */     GIR_EraseRootFromParent_Done,
     /*   89631 */   // Label 1431: @89631
     /*   89631 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(89720), // Rule ID 70600 //
     /*   89636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89651 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89670 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89679 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89718 */     GIR_RootConstrainSelectedInstOperands,
     /*   89719 */     // GIR_Coverage, 70600,
     /*   89719 */     GIR_EraseRootFromParent_Done,
     /*   89720 */   // Label 1432: @89720
     /*   89720 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(89809), // Rule ID 51602 //
     /*   89725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89740 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89759 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89768 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89807 */     GIR_RootConstrainSelectedInstOperands,
     /*   89808 */     // GIR_Coverage, 51602,
     /*   89808 */     GIR_EraseRootFromParent_Done,
     /*   89809 */   // Label 1433: @89809
     /*   89809 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(89898), // Rule ID 51603 //
     /*   89814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89829 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89848 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89857 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89896 */     GIR_RootConstrainSelectedInstOperands,
     /*   89897 */     // GIR_Coverage, 51603,
     /*   89897 */     GIR_EraseRootFromParent_Done,
     /*   89898 */   // Label 1434: @89898
     /*   89898 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(89951), // Rule ID 50900 //
     /*   89903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89914 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   89931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   89938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   89940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89949 */     GIR_RootConstrainSelectedInstOperands,
     /*   89950 */     // GIR_Coverage, 50900,
     /*   89950 */     GIR_EraseRootFromParent_Done,
     /*   89951 */   // Label 1435: @89951
     /*   89951 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(90004), // Rule ID 50901 //
     /*   89956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89967 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   89984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   89991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   89993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90002 */     GIR_RootConstrainSelectedInstOperands,
     /*   90003 */     // GIR_Coverage, 50901,
     /*   90003 */     GIR_EraseRootFromParent_Done,
     /*   90004 */   // Label 1436: @90004
     /*   90004 */   GIM_Reject,
     /*   90005 */ // Label 1416: @90005
     /*   90005 */ GIM_Reject,
     /*   90006 */ // Label 1305: @90006
     /*   90006 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(91730),
     /*   90011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   90014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   90017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   90021 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(90110), // Rule ID 51682 //
     /*   90026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90041 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90060 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90062 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90069 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90108 */     GIR_RootConstrainSelectedInstOperands,
     /*   90109 */     // GIR_Coverage, 51682,
     /*   90109 */     GIR_EraseRootFromParent_Done,
     /*   90110 */   // Label 1438: @90110
     /*   90110 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(90199), // Rule ID 51683 //
     /*   90115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90130 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90149 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90158 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90197 */     GIR_RootConstrainSelectedInstOperands,
     /*   90198 */     // GIR_Coverage, 51683,
     /*   90198 */     GIR_EraseRootFromParent_Done,
     /*   90199 */   // Label 1439: @90199
     /*   90199 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(90288), // Rule ID 70679 //
     /*   90204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90219 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90238 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90247 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90286 */     GIR_RootConstrainSelectedInstOperands,
     /*   90287 */     // GIR_Coverage, 70679,
     /*   90287 */     GIR_EraseRootFromParent_Done,
     /*   90288 */   // Label 1440: @90288
     /*   90288 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(90377), // Rule ID 70680 //
     /*   90293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90308 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90327 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90336 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90375 */     GIR_RootConstrainSelectedInstOperands,
     /*   90376 */     // GIR_Coverage, 70680,
     /*   90376 */     GIR_EraseRootFromParent_Done,
     /*   90377 */   // Label 1441: @90377
     /*   90377 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(90466), // Rule ID 70559 //
     /*   90382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90397 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90416 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90425 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90464 */     GIR_RootConstrainSelectedInstOperands,
     /*   90465 */     // GIR_Coverage, 70559,
     /*   90465 */     GIR_EraseRootFromParent_Done,
     /*   90466 */   // Label 1442: @90466
     /*   90466 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(90555), // Rule ID 70560 //
     /*   90471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90505 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90514 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90553 */     GIR_RootConstrainSelectedInstOperands,
     /*   90554 */     // GIR_Coverage, 70560,
     /*   90554 */     GIR_EraseRootFromParent_Done,
     /*   90555 */   // Label 1443: @90555
     /*   90555 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(90644), // Rule ID 51862 //
     /*   90560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90575 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90594 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90603 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90642 */     GIR_RootConstrainSelectedInstOperands,
     /*   90643 */     // GIR_Coverage, 51862,
     /*   90643 */     GIR_EraseRootFromParent_Done,
     /*   90644 */   // Label 1444: @90644
     /*   90644 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(90733), // Rule ID 51863 //
     /*   90649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90664 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90683 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90692 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90731 */     GIR_RootConstrainSelectedInstOperands,
     /*   90732 */     // GIR_Coverage, 51863,
     /*   90732 */     GIR_EraseRootFromParent_Done,
     /*   90733 */   // Label 1445: @90733
     /*   90733 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(90822), // Rule ID 51562 //
     /*   90738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90753 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90772 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90781 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   90798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90820 */     GIR_RootConstrainSelectedInstOperands,
     /*   90821 */     // GIR_Coverage, 51562,
     /*   90821 */     GIR_EraseRootFromParent_Done,
     /*   90822 */   // Label 1446: @90822
     /*   90822 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(90911), // Rule ID 51563 //
     /*   90827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90842 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90861 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90870 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   90887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90909 */     GIR_RootConstrainSelectedInstOperands,
     /*   90910 */     // GIR_Coverage, 51563,
     /*   90910 */     GIR_EraseRootFromParent_Done,
     /*   90911 */   // Label 1447: @90911
     /*   90911 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(91000), // Rule ID 51802 //
     /*   90916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90950 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90959 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90998 */     GIR_RootConstrainSelectedInstOperands,
     /*   90999 */     // GIR_Coverage, 51802,
     /*   90999 */     GIR_EraseRootFromParent_Done,
     /*   91000 */   // Label 1448: @91000
     /*   91000 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(91089), // Rule ID 51803 //
     /*   91005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91020 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91039 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91048 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   91065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91087 */     GIR_RootConstrainSelectedInstOperands,
     /*   91088 */     // GIR_Coverage, 51803,
     /*   91088 */     GIR_EraseRootFromParent_Done,
     /*   91089 */   // Label 1449: @91089
     /*   91089 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(91178), // Rule ID 51742 //
     /*   91094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   91097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91109 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91128 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91137 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91176 */     GIR_RootConstrainSelectedInstOperands,
     /*   91177 */     // GIR_Coverage, 51742,
     /*   91177 */     GIR_EraseRootFromParent_Done,
     /*   91178 */   // Label 1450: @91178
     /*   91178 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(91267), // Rule ID 51743 //
     /*   91183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91198 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91226 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91265 */     GIR_RootConstrainSelectedInstOperands,
     /*   91266 */     // GIR_Coverage, 51743,
     /*   91266 */     GIR_EraseRootFromParent_Done,
     /*   91267 */   // Label 1451: @91267
     /*   91267 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(91356), // Rule ID 70619 //
     /*   91272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   91275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91287 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91315 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   91332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91354 */     GIR_RootConstrainSelectedInstOperands,
     /*   91355 */     // GIR_Coverage, 70619,
     /*   91355 */     GIR_EraseRootFromParent_Done,
     /*   91356 */   // Label 1452: @91356
     /*   91356 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(91445), // Rule ID 70620 //
     /*   91361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91376 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91395 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91404 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   91421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91443 */     GIR_RootConstrainSelectedInstOperands,
     /*   91444 */     // GIR_Coverage, 70620,
     /*   91444 */     GIR_EraseRootFromParent_Done,
     /*   91445 */   // Label 1453: @91445
     /*   91445 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(91534), // Rule ID 51622 //
     /*   91450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   91453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91465 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91484 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91493 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91532 */     GIR_RootConstrainSelectedInstOperands,
     /*   91533 */     // GIR_Coverage, 51622,
     /*   91533 */     GIR_EraseRootFromParent_Done,
     /*   91534 */   // Label 1454: @91534
     /*   91534 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(91623), // Rule ID 51623 //
     /*   91539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91554 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91573 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91582 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91621 */     GIR_RootConstrainSelectedInstOperands,
     /*   91622 */     // GIR_Coverage, 51623,
     /*   91622 */     GIR_EraseRootFromParent_Done,
     /*   91623 */   // Label 1455: @91623
     /*   91623 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(91676), // Rule ID 50944 //
     /*   91628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   91631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91639 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   91639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   91656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   91671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91674 */     GIR_RootConstrainSelectedInstOperands,
     /*   91675 */     // GIR_Coverage, 50944,
     /*   91675 */     GIR_EraseRootFromParent_Done,
     /*   91676 */   // Label 1456: @91676
     /*   91676 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(91729), // Rule ID 50945 //
     /*   91681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   91684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91692 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   91692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   91709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   91724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91727 */     GIR_RootConstrainSelectedInstOperands,
     /*   91728 */     // GIR_Coverage, 50945,
     /*   91728 */     GIR_EraseRootFromParent_Done,
     /*   91729 */   // Label 1457: @91729
     /*   91729 */   GIM_Reject,
     /*   91730 */ // Label 1437: @91730
     /*   91730 */ GIM_Reject,
     /*   91731 */ // Label 1306: @91731
     /*   91731 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(91845),
     /*   91736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   91742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91754 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(91799), // Rule ID 50876 //
     /*   91759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91762 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   91765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   91779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91797 */     GIR_RootConstrainSelectedInstOperands,
     /*   91798 */     // GIR_Coverage, 50876,
     /*   91798 */     GIR_EraseRootFromParent_Done,
     /*   91799 */   // Label 1459: @91799
     /*   91799 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(91844), // Rule ID 50877 //
     /*   91804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91807 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   91810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   91824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91842 */     GIR_RootConstrainSelectedInstOperands,
     /*   91843 */     // GIR_Coverage, 50877,
     /*   91843 */     GIR_EraseRootFromParent_Done,
     /*   91844 */   // Label 1460: @91844
     /*   91844 */   GIM_Reject,
     /*   91845 */ // Label 1458: @91845
     /*   91845 */ GIM_Reject,
     /*   91846 */ // Label 1307: @91846
     /*   91846 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(93570),
     /*   91851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   91854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   91857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91861 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(91950), // Rule ID 51642 //
     /*   91866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91881 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91900 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91909 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91948 */     GIR_RootConstrainSelectedInstOperands,
     /*   91949 */     // GIR_Coverage, 51642,
     /*   91949 */     GIR_EraseRootFromParent_Done,
     /*   91950 */   // Label 1462: @91950
     /*   91950 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(92039), // Rule ID 51643 //
     /*   91955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91970 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91989 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91998 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92037 */     GIR_RootConstrainSelectedInstOperands,
     /*   92038 */     // GIR_Coverage, 51643,
     /*   92038 */     GIR_EraseRootFromParent_Done,
     /*   92039 */   // Label 1463: @92039
     /*   92039 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(92128), // Rule ID 70639 //
     /*   92044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92059 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92078 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92080 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92087 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92126 */     GIR_RootConstrainSelectedInstOperands,
     /*   92127 */     // GIR_Coverage, 70639,
     /*   92127 */     GIR_EraseRootFromParent_Done,
     /*   92128 */   // Label 1464: @92128
     /*   92128 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(92217), // Rule ID 70640 //
     /*   92133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92148 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92167 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92176 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92215 */     GIR_RootConstrainSelectedInstOperands,
     /*   92216 */     // GIR_Coverage, 70640,
     /*   92216 */     GIR_EraseRootFromParent_Done,
     /*   92217 */   // Label 1465: @92217
     /*   92217 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(92306), // Rule ID 70519 //
     /*   92222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92237 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92256 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92265 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92304 */     GIR_RootConstrainSelectedInstOperands,
     /*   92305 */     // GIR_Coverage, 70519,
     /*   92305 */     GIR_EraseRootFromParent_Done,
     /*   92306 */   // Label 1466: @92306
     /*   92306 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(92395), // Rule ID 70520 //
     /*   92311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92345 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92354 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92393 */     GIR_RootConstrainSelectedInstOperands,
     /*   92394 */     // GIR_Coverage, 70520,
     /*   92394 */     GIR_EraseRootFromParent_Done,
     /*   92395 */   // Label 1467: @92395
     /*   92395 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(92484), // Rule ID 51822 //
     /*   92400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92415 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92434 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92443 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92482 */     GIR_RootConstrainSelectedInstOperands,
     /*   92483 */     // GIR_Coverage, 51822,
     /*   92483 */     GIR_EraseRootFromParent_Done,
     /*   92484 */   // Label 1468: @92484
     /*   92484 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(92573), // Rule ID 51823 //
     /*   92489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92504 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92523 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92532 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92571 */     GIR_RootConstrainSelectedInstOperands,
     /*   92572 */     // GIR_Coverage, 51823,
     /*   92572 */     GIR_EraseRootFromParent_Done,
     /*   92573 */   // Label 1469: @92573
     /*   92573 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(92662), // Rule ID 51522 //
     /*   92578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92593 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92612 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92621 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   92638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92660 */     GIR_RootConstrainSelectedInstOperands,
     /*   92661 */     // GIR_Coverage, 51522,
     /*   92661 */     GIR_EraseRootFromParent_Done,
     /*   92662 */   // Label 1470: @92662
     /*   92662 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(92751), // Rule ID 51523 //
     /*   92667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92682 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92701 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92710 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   92727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92749 */     GIR_RootConstrainSelectedInstOperands,
     /*   92750 */     // GIR_Coverage, 51523,
     /*   92750 */     GIR_EraseRootFromParent_Done,
     /*   92751 */   // Label 1471: @92751
     /*   92751 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(92840), // Rule ID 51762 //
     /*   92756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92771 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92790 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92799 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92838 */     GIR_RootConstrainSelectedInstOperands,
     /*   92839 */     // GIR_Coverage, 51762,
     /*   92839 */     GIR_EraseRootFromParent_Done,
     /*   92840 */   // Label 1472: @92840
     /*   92840 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(92929), // Rule ID 51763 //
     /*   92845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92860 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92879 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92888 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92927 */     GIR_RootConstrainSelectedInstOperands,
     /*   92928 */     // GIR_Coverage, 51763,
     /*   92928 */     GIR_EraseRootFromParent_Done,
     /*   92929 */   // Label 1473: @92929
     /*   92929 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(93018), // Rule ID 51702 //
     /*   92934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92949 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92968 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92977 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93016 */     GIR_RootConstrainSelectedInstOperands,
     /*   93017 */     // GIR_Coverage, 51702,
     /*   93017 */     GIR_EraseRootFromParent_Done,
     /*   93018 */   // Label 1474: @93018
     /*   93018 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(93107), // Rule ID 51703 //
     /*   93023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93038 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93057 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93066 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   93066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   93083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93105 */     GIR_RootConstrainSelectedInstOperands,
     /*   93106 */     // GIR_Coverage, 51703,
     /*   93106 */     GIR_EraseRootFromParent_Done,
     /*   93107 */   // Label 1475: @93107
     /*   93107 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(93196), // Rule ID 70579 //
     /*   93112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93127 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93146 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93155 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   93155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   93172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93194 */     GIR_RootConstrainSelectedInstOperands,
     /*   93195 */     // GIR_Coverage, 70579,
     /*   93195 */     GIR_EraseRootFromParent_Done,
     /*   93196 */   // Label 1476: @93196
     /*   93196 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(93285), // Rule ID 70580 //
     /*   93201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93216 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93235 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93244 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   93244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   93261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93283 */     GIR_RootConstrainSelectedInstOperands,
     /*   93284 */     // GIR_Coverage, 70580,
     /*   93284 */     GIR_EraseRootFromParent_Done,
     /*   93285 */   // Label 1477: @93285
     /*   93285 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(93374), // Rule ID 51582 //
     /*   93290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93305 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93324 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93333 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   93333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   93350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93372 */     GIR_RootConstrainSelectedInstOperands,
     /*   93373 */     // GIR_Coverage, 51582,
     /*   93373 */     GIR_EraseRootFromParent_Done,
     /*   93374 */   // Label 1478: @93374
     /*   93374 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(93463), // Rule ID 51583 //
     /*   93379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93394 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93413 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93422 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   93422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   93439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93461 */     GIR_RootConstrainSelectedInstOperands,
     /*   93462 */     // GIR_Coverage, 51583,
     /*   93462 */     GIR_EraseRootFromParent_Done,
     /*   93463 */   // Label 1479: @93463
     /*   93463 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(93516), // Rule ID 50896 //
     /*   93468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93479 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   93496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   93503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   93505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93514 */     GIR_RootConstrainSelectedInstOperands,
     /*   93515 */     // GIR_Coverage, 50896,
     /*   93515 */     GIR_EraseRootFromParent_Done,
     /*   93516 */   // Label 1480: @93516
     /*   93516 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(93569), // Rule ID 50897 //
     /*   93521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93532 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   93549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   93556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   93558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93567 */     GIR_RootConstrainSelectedInstOperands,
     /*   93568 */     // GIR_Coverage, 50897,
     /*   93568 */     GIR_EraseRootFromParent_Done,
     /*   93569 */   // Label 1481: @93569
     /*   93569 */   GIM_Reject,
     /*   93570 */ // Label 1461: @93570
     /*   93570 */ GIM_Reject,
     /*   93571 */ // Label 1308: @93571
     /*   93571 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(95295),
     /*   93576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   93579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   93582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   93586 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(93675), // Rule ID 51666 //
     /*   93591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93625 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93634 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93673 */     GIR_RootConstrainSelectedInstOperands,
     /*   93674 */     // GIR_Coverage, 51666,
     /*   93674 */     GIR_EraseRootFromParent_Done,
     /*   93675 */   // Label 1483: @93675
     /*   93675 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(93764), // Rule ID 51667 //
     /*   93680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93695 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93714 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93723 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93762 */     GIR_RootConstrainSelectedInstOperands,
     /*   93763 */     // GIR_Coverage, 51667,
     /*   93763 */     GIR_EraseRootFromParent_Done,
     /*   93764 */   // Label 1484: @93764
     /*   93764 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(93853), // Rule ID 70663 //
     /*   93769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93784 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93803 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93812 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93851 */     GIR_RootConstrainSelectedInstOperands,
     /*   93852 */     // GIR_Coverage, 70663,
     /*   93852 */     GIR_EraseRootFromParent_Done,
     /*   93853 */   // Label 1485: @93853
     /*   93853 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(93942), // Rule ID 70664 //
     /*   93858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93873 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93892 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93901 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93940 */     GIR_RootConstrainSelectedInstOperands,
     /*   93941 */     // GIR_Coverage, 70664,
     /*   93941 */     GIR_EraseRootFromParent_Done,
     /*   93942 */   // Label 1486: @93942
     /*   93942 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(94031), // Rule ID 70543 //
     /*   93947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93962 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93981 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93990 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94029 */     GIR_RootConstrainSelectedInstOperands,
     /*   94030 */     // GIR_Coverage, 70543,
     /*   94030 */     GIR_EraseRootFromParent_Done,
     /*   94031 */   // Label 1487: @94031
     /*   94031 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(94120), // Rule ID 70544 //
     /*   94036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94051 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94070 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94079 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94118 */     GIR_RootConstrainSelectedInstOperands,
     /*   94119 */     // GIR_Coverage, 70544,
     /*   94119 */     GIR_EraseRootFromParent_Done,
     /*   94120 */   // Label 1488: @94120
     /*   94120 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(94209), // Rule ID 51846 //
     /*   94125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94140 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94159 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94168 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94207 */     GIR_RootConstrainSelectedInstOperands,
     /*   94208 */     // GIR_Coverage, 51846,
     /*   94208 */     GIR_EraseRootFromParent_Done,
     /*   94209 */   // Label 1489: @94209
     /*   94209 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(94298), // Rule ID 51847 //
     /*   94214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94229 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94248 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94257 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94296 */     GIR_RootConstrainSelectedInstOperands,
     /*   94297 */     // GIR_Coverage, 51847,
     /*   94297 */     GIR_EraseRootFromParent_Done,
     /*   94298 */   // Label 1490: @94298
     /*   94298 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(94387), // Rule ID 51546 //
     /*   94303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94318 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94337 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94346 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   94363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94385 */     GIR_RootConstrainSelectedInstOperands,
     /*   94386 */     // GIR_Coverage, 51546,
     /*   94386 */     GIR_EraseRootFromParent_Done,
     /*   94387 */   // Label 1491: @94387
     /*   94387 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(94476), // Rule ID 51547 //
     /*   94392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94407 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94426 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94435 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   94452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94474 */     GIR_RootConstrainSelectedInstOperands,
     /*   94475 */     // GIR_Coverage, 51547,
     /*   94475 */     GIR_EraseRootFromParent_Done,
     /*   94476 */   // Label 1492: @94476
     /*   94476 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(94565), // Rule ID 51786 //
     /*   94481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94496 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94515 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94524 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94563 */     GIR_RootConstrainSelectedInstOperands,
     /*   94564 */     // GIR_Coverage, 51786,
     /*   94564 */     GIR_EraseRootFromParent_Done,
     /*   94565 */   // Label 1493: @94565
     /*   94565 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(94654), // Rule ID 51787 //
     /*   94570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94585 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94604 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94613 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94652 */     GIR_RootConstrainSelectedInstOperands,
     /*   94653 */     // GIR_Coverage, 51787,
     /*   94653 */     GIR_EraseRootFromParent_Done,
     /*   94654 */   // Label 1494: @94654
     /*   94654 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(94743), // Rule ID 51726 //
     /*   94659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94674 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94693 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94702 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94741 */     GIR_RootConstrainSelectedInstOperands,
     /*   94742 */     // GIR_Coverage, 51726,
     /*   94742 */     GIR_EraseRootFromParent_Done,
     /*   94743 */   // Label 1495: @94743
     /*   94743 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(94832), // Rule ID 51727 //
     /*   94748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94763 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94782 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94791 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94830 */     GIR_RootConstrainSelectedInstOperands,
     /*   94831 */     // GIR_Coverage, 51727,
     /*   94831 */     GIR_EraseRootFromParent_Done,
     /*   94832 */   // Label 1496: @94832
     /*   94832 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(94921), // Rule ID 70603 //
     /*   94837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94852 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94871 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94880 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94919 */     GIR_RootConstrainSelectedInstOperands,
     /*   94920 */     // GIR_Coverage, 70603,
     /*   94920 */     GIR_EraseRootFromParent_Done,
     /*   94921 */   // Label 1497: @94921
     /*   94921 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(95010), // Rule ID 70604 //
     /*   94926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94941 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94960 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94969 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95008 */     GIR_RootConstrainSelectedInstOperands,
     /*   95009 */     // GIR_Coverage, 70604,
     /*   95009 */     GIR_EraseRootFromParent_Done,
     /*   95010 */   // Label 1498: @95010
     /*   95010 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(95099), // Rule ID 51606 //
     /*   95015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   95018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   95030 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   95037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   95049 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   95056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95058 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   95058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   95061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   95075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95097 */     GIR_RootConstrainSelectedInstOperands,
     /*   95098 */     // GIR_Coverage, 51606,
     /*   95098 */     GIR_EraseRootFromParent_Done,
     /*   95099 */   // Label 1499: @95099
     /*   95099 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(95188), // Rule ID 51607 //
     /*   95104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   95107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   95119 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   95126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   95138 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   95145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95147 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   95147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   95150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   95164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95186 */     GIR_RootConstrainSelectedInstOperands,
     /*   95187 */     // GIR_Coverage, 51607,
     /*   95187 */     GIR_EraseRootFromParent_Done,
     /*   95188 */   // Label 1500: @95188
     /*   95188 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(95241), // Rule ID 50932 //
     /*   95193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   95196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95204 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   95207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   95221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   95228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   95230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95239 */     GIR_RootConstrainSelectedInstOperands,
     /*   95240 */     // GIR_Coverage, 50932,
     /*   95240 */     GIR_EraseRootFromParent_Done,
     /*   95241 */   // Label 1501: @95241
     /*   95241 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(95294), // Rule ID 50933 //
     /*   95246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   95249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95257 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   95260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   95274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   95281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   95283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95292 */     GIR_RootConstrainSelectedInstOperands,
     /*   95293 */     // GIR_Coverage, 50933,
     /*   95293 */     GIR_EraseRootFromParent_Done,
     /*   95294 */   // Label 1502: @95294
     /*   95294 */   GIM_Reject,
     /*   95295 */ // Label 1482: @95295
     /*   95295 */ GIM_Reject,
     /*   95296 */ // Label 1309: @95296
     /*   95296 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(97020),
     /*   95301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   95304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   95307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   95311 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(95400), // Rule ID 51686 //
     /*   95316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95331 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95350 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95352 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95359 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95398 */     GIR_RootConstrainSelectedInstOperands,
     /*   95399 */     // GIR_Coverage, 51686,
     /*   95399 */     GIR_EraseRootFromParent_Done,
     /*   95400 */   // Label 1504: @95400
     /*   95400 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(95489), // Rule ID 51687 //
     /*   95405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95420 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95439 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95448 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95487 */     GIR_RootConstrainSelectedInstOperands,
     /*   95488 */     // GIR_Coverage, 51687,
     /*   95488 */     GIR_EraseRootFromParent_Done,
     /*   95489 */   // Label 1505: @95489
     /*   95489 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(95578), // Rule ID 70683 //
     /*   95494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95509 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95528 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95537 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95576 */     GIR_RootConstrainSelectedInstOperands,
     /*   95577 */     // GIR_Coverage, 70683,
     /*   95577 */     GIR_EraseRootFromParent_Done,
     /*   95578 */   // Label 1506: @95578
     /*   95578 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(95667), // Rule ID 70684 //
     /*   95583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95598 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95617 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95626 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95665 */     GIR_RootConstrainSelectedInstOperands,
     /*   95666 */     // GIR_Coverage, 70684,
     /*   95666 */     GIR_EraseRootFromParent_Done,
     /*   95667 */   // Label 1507: @95667
     /*   95667 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(95756), // Rule ID 70563 //
     /*   95672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95687 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95706 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95715 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95754 */     GIR_RootConstrainSelectedInstOperands,
     /*   95755 */     // GIR_Coverage, 70563,
     /*   95755 */     GIR_EraseRootFromParent_Done,
     /*   95756 */   // Label 1508: @95756
     /*   95756 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(95845), // Rule ID 70564 //
     /*   95761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95795 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95804 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95843 */     GIR_RootConstrainSelectedInstOperands,
     /*   95844 */     // GIR_Coverage, 70564,
     /*   95844 */     GIR_EraseRootFromParent_Done,
     /*   95845 */   // Label 1509: @95845
     /*   95845 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(95934), // Rule ID 51866 //
     /*   95850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95865 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95884 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95893 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95932 */     GIR_RootConstrainSelectedInstOperands,
     /*   95933 */     // GIR_Coverage, 51866,
     /*   95933 */     GIR_EraseRootFromParent_Done,
     /*   95934 */   // Label 1510: @95934
     /*   95934 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(96023), // Rule ID 51867 //
     /*   95939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95954 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95973 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95982 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96021 */     GIR_RootConstrainSelectedInstOperands,
     /*   96022 */     // GIR_Coverage, 51867,
     /*   96022 */     GIR_EraseRootFromParent_Done,
     /*   96023 */   // Label 1511: @96023
     /*   96023 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(96112), // Rule ID 51566 //
     /*   96028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96043 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96062 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96071 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   96088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96110 */     GIR_RootConstrainSelectedInstOperands,
     /*   96111 */     // GIR_Coverage, 51566,
     /*   96111 */     GIR_EraseRootFromParent_Done,
     /*   96112 */   // Label 1512: @96112
     /*   96112 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(96201), // Rule ID 51567 //
     /*   96117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96132 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96151 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96160 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   96177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96199 */     GIR_RootConstrainSelectedInstOperands,
     /*   96200 */     // GIR_Coverage, 51567,
     /*   96200 */     GIR_EraseRootFromParent_Done,
     /*   96201 */   // Label 1513: @96201
     /*   96201 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(96290), // Rule ID 51806 //
     /*   96206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96221 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96240 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96249 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96288 */     GIR_RootConstrainSelectedInstOperands,
     /*   96289 */     // GIR_Coverage, 51806,
     /*   96289 */     GIR_EraseRootFromParent_Done,
     /*   96290 */   // Label 1514: @96290
     /*   96290 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(96379), // Rule ID 51807 //
     /*   96295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96310 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96329 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96338 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96377 */     GIR_RootConstrainSelectedInstOperands,
     /*   96378 */     // GIR_Coverage, 51807,
     /*   96378 */     GIR_EraseRootFromParent_Done,
     /*   96379 */   // Label 1515: @96379
     /*   96379 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(96468), // Rule ID 51746 //
     /*   96384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96399 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96418 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96427 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96466 */     GIR_RootConstrainSelectedInstOperands,
     /*   96467 */     // GIR_Coverage, 51746,
     /*   96467 */     GIR_EraseRootFromParent_Done,
     /*   96468 */   // Label 1516: @96468
     /*   96468 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(96557), // Rule ID 51747 //
     /*   96473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96488 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96507 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96516 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96555 */     GIR_RootConstrainSelectedInstOperands,
     /*   96556 */     // GIR_Coverage, 51747,
     /*   96556 */     GIR_EraseRootFromParent_Done,
     /*   96557 */   // Label 1517: @96557
     /*   96557 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(96646), // Rule ID 70623 //
     /*   96562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96577 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96596 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96605 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96644 */     GIR_RootConstrainSelectedInstOperands,
     /*   96645 */     // GIR_Coverage, 70623,
     /*   96645 */     GIR_EraseRootFromParent_Done,
     /*   96646 */   // Label 1518: @96646
     /*   96646 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(96735), // Rule ID 70624 //
     /*   96651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96685 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96694 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96733 */     GIR_RootConstrainSelectedInstOperands,
     /*   96734 */     // GIR_Coverage, 70624,
     /*   96734 */     GIR_EraseRootFromParent_Done,
     /*   96735 */   // Label 1519: @96735
     /*   96735 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(96824), // Rule ID 51626 //
     /*   96740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96755 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96774 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96783 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96822 */     GIR_RootConstrainSelectedInstOperands,
     /*   96823 */     // GIR_Coverage, 51626,
     /*   96823 */     GIR_EraseRootFromParent_Done,
     /*   96824 */   // Label 1520: @96824
     /*   96824 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(96913), // Rule ID 51627 //
     /*   96829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96844 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96863 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96872 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96911 */     GIR_RootConstrainSelectedInstOperands,
     /*   96912 */     // GIR_Coverage, 51627,
     /*   96912 */     GIR_EraseRootFromParent_Done,
     /*   96913 */   // Label 1521: @96913
     /*   96913 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(96966), // Rule ID 50948 //
     /*   96918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   96921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96929 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   96929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   96946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   96961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96964 */     GIR_RootConstrainSelectedInstOperands,
     /*   96965 */     // GIR_Coverage, 50948,
     /*   96965 */     GIR_EraseRootFromParent_Done,
     /*   96966 */   // Label 1522: @96966
     /*   96966 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(97019), // Rule ID 50949 //
     /*   96971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   96974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96982 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   96982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   96999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   97006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   97008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   97014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97017 */     GIR_RootConstrainSelectedInstOperands,
     /*   97018 */     // GIR_Coverage, 50949,
     /*   97018 */     GIR_EraseRootFromParent_Done,
     /*   97019 */   // Label 1523: @97019
     /*   97019 */   GIM_Reject,
     /*   97020 */ // Label 1503: @97020
     /*   97020 */ GIM_Reject,
     /*   97021 */ // Label 1310: @97021
     /*   97021 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(97135),
     /*   97026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   97032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97044 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(97089), // Rule ID 50892 //
     /*   97049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97052 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   97055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   97069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   97076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   97078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97087 */     GIR_RootConstrainSelectedInstOperands,
     /*   97088 */     // GIR_Coverage, 50892,
     /*   97088 */     GIR_EraseRootFromParent_Done,
     /*   97089 */   // Label 1525: @97089
     /*   97089 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97134), // Rule ID 50893 //
     /*   97094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97097 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   97100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   97114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   97121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   97123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97132 */     GIR_RootConstrainSelectedInstOperands,
     /*   97133 */     // GIR_Coverage, 50893,
     /*   97133 */     GIR_EraseRootFromParent_Done,
     /*   97134 */   // Label 1526: @97134
     /*   97134 */   GIM_Reject,
     /*   97135 */ // Label 1524: @97135
     /*   97135 */ GIM_Reject,
     /*   97136 */ // Label 1311: @97136
     /*   97136 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(98860),
     /*   97141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   97144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   97147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   97151 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(97240), // Rule ID 51646 //
     /*   97156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97171 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97190 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97199 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97238 */     GIR_RootConstrainSelectedInstOperands,
     /*   97239 */     // GIR_Coverage, 51646,
     /*   97239 */     GIR_EraseRootFromParent_Done,
     /*   97240 */   // Label 1528: @97240
     /*   97240 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(97329), // Rule ID 51647 //
     /*   97245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97260 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97279 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97288 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97327 */     GIR_RootConstrainSelectedInstOperands,
     /*   97328 */     // GIR_Coverage, 51647,
     /*   97328 */     GIR_EraseRootFromParent_Done,
     /*   97329 */   // Label 1529: @97329
     /*   97329 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(97418), // Rule ID 70643 //
     /*   97334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97349 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97368 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97377 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97416 */     GIR_RootConstrainSelectedInstOperands,
     /*   97417 */     // GIR_Coverage, 70643,
     /*   97417 */     GIR_EraseRootFromParent_Done,
     /*   97418 */   // Label 1530: @97418
     /*   97418 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(97507), // Rule ID 70644 //
     /*   97423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97438 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97457 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97466 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97505 */     GIR_RootConstrainSelectedInstOperands,
     /*   97506 */     // GIR_Coverage, 70644,
     /*   97506 */     GIR_EraseRootFromParent_Done,
     /*   97507 */   // Label 1531: @97507
     /*   97507 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(97596), // Rule ID 70523 //
     /*   97512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97527 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97546 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97555 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97594 */     GIR_RootConstrainSelectedInstOperands,
     /*   97595 */     // GIR_Coverage, 70523,
     /*   97595 */     GIR_EraseRootFromParent_Done,
     /*   97596 */   // Label 1532: @97596
     /*   97596 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(97685), // Rule ID 70524 //
     /*   97601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97635 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97644 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97683 */     GIR_RootConstrainSelectedInstOperands,
     /*   97684 */     // GIR_Coverage, 70524,
     /*   97684 */     GIR_EraseRootFromParent_Done,
     /*   97685 */   // Label 1533: @97685
     /*   97685 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(97774), // Rule ID 51826 //
     /*   97690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97705 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97724 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97733 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97772 */     GIR_RootConstrainSelectedInstOperands,
     /*   97773 */     // GIR_Coverage, 51826,
     /*   97773 */     GIR_EraseRootFromParent_Done,
     /*   97774 */   // Label 1534: @97774
     /*   97774 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(97863), // Rule ID 51827 //
     /*   97779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97794 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97813 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97822 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97861 */     GIR_RootConstrainSelectedInstOperands,
     /*   97862 */     // GIR_Coverage, 51827,
     /*   97862 */     GIR_EraseRootFromParent_Done,
     /*   97863 */   // Label 1535: @97863
     /*   97863 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(97952), // Rule ID 51526 //
     /*   97868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97883 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97902 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97911 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   97928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97950 */     GIR_RootConstrainSelectedInstOperands,
     /*   97951 */     // GIR_Coverage, 51526,
     /*   97951 */     GIR_EraseRootFromParent_Done,
     /*   97952 */   // Label 1536: @97952
     /*   97952 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(98041), // Rule ID 51527 //
     /*   97957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97972 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97991 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98000 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   98017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98039 */     GIR_RootConstrainSelectedInstOperands,
     /*   98040 */     // GIR_Coverage, 51527,
     /*   98040 */     GIR_EraseRootFromParent_Done,
     /*   98041 */   // Label 1537: @98041
     /*   98041 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(98130), // Rule ID 51766 //
     /*   98046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98061 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98080 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98089 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98128 */     GIR_RootConstrainSelectedInstOperands,
     /*   98129 */     // GIR_Coverage, 51766,
     /*   98129 */     GIR_EraseRootFromParent_Done,
     /*   98130 */   // Label 1538: @98130
     /*   98130 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(98219), // Rule ID 51767 //
     /*   98135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98169 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98178 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98217 */     GIR_RootConstrainSelectedInstOperands,
     /*   98218 */     // GIR_Coverage, 51767,
     /*   98218 */     GIR_EraseRootFromParent_Done,
     /*   98219 */   // Label 1539: @98219
     /*   98219 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(98308), // Rule ID 51706 //
     /*   98224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98239 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98258 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98267 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98306 */     GIR_RootConstrainSelectedInstOperands,
     /*   98307 */     // GIR_Coverage, 51706,
     /*   98307 */     GIR_EraseRootFromParent_Done,
     /*   98308 */   // Label 1540: @98308
     /*   98308 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(98397), // Rule ID 51707 //
     /*   98313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98347 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98356 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98395 */     GIR_RootConstrainSelectedInstOperands,
     /*   98396 */     // GIR_Coverage, 51707,
     /*   98396 */     GIR_EraseRootFromParent_Done,
     /*   98397 */   // Label 1541: @98397
     /*   98397 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(98486), // Rule ID 70583 //
     /*   98402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98417 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98436 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98445 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98484 */     GIR_RootConstrainSelectedInstOperands,
     /*   98485 */     // GIR_Coverage, 70583,
     /*   98485 */     GIR_EraseRootFromParent_Done,
     /*   98486 */   // Label 1542: @98486
     /*   98486 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(98575), // Rule ID 70584 //
     /*   98491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98506 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98525 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98534 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98573 */     GIR_RootConstrainSelectedInstOperands,
     /*   98574 */     // GIR_Coverage, 70584,
     /*   98574 */     GIR_EraseRootFromParent_Done,
     /*   98575 */   // Label 1543: @98575
     /*   98575 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(98664), // Rule ID 51586 //
     /*   98580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98595 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98614 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98623 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98662 */     GIR_RootConstrainSelectedInstOperands,
     /*   98663 */     // GIR_Coverage, 51586,
     /*   98663 */     GIR_EraseRootFromParent_Done,
     /*   98664 */   // Label 1544: @98664
     /*   98664 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(98753), // Rule ID 51587 //
     /*   98669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98684 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98703 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98712 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98751 */     GIR_RootConstrainSelectedInstOperands,
     /*   98752 */     // GIR_Coverage, 51587,
     /*   98752 */     GIR_EraseRootFromParent_Done,
     /*   98753 */   // Label 1545: @98753
     /*   98753 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(98806), // Rule ID 50920 //
     /*   98758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98769 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   98786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   98793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   98795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98804 */     GIR_RootConstrainSelectedInstOperands,
     /*   98805 */     // GIR_Coverage, 50920,
     /*   98805 */     GIR_EraseRootFromParent_Done,
     /*   98806 */   // Label 1546: @98806
     /*   98806 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(98859), // Rule ID 50921 //
     /*   98811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98822 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   98839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   98846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   98848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98857 */     GIR_RootConstrainSelectedInstOperands,
     /*   98858 */     // GIR_Coverage, 50921,
     /*   98858 */     GIR_EraseRootFromParent_Done,
     /*   98859 */   // Label 1547: @98859
     /*   98859 */   GIM_Reject,
     /*   98860 */ // Label 1527: @98860
     /*   98860 */ GIM_Reject,
     /*   98861 */ // Label 1312: @98861
     /*   98861 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(100585),
     /*   98866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   98869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   98872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   98876 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(98965), // Rule ID 51670 //
     /*   98881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98915 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98924 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98963 */     GIR_RootConstrainSelectedInstOperands,
     /*   98964 */     // GIR_Coverage, 51670,
     /*   98964 */     GIR_EraseRootFromParent_Done,
     /*   98965 */   // Label 1549: @98965
     /*   98965 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(99054), // Rule ID 51671 //
     /*   98970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98985 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99004 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99013 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99052 */     GIR_RootConstrainSelectedInstOperands,
     /*   99053 */     // GIR_Coverage, 51671,
     /*   99053 */     GIR_EraseRootFromParent_Done,
     /*   99054 */   // Label 1550: @99054
     /*   99054 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(99143), // Rule ID 70667 //
     /*   99059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99074 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99093 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99102 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99141 */     GIR_RootConstrainSelectedInstOperands,
     /*   99142 */     // GIR_Coverage, 70667,
     /*   99142 */     GIR_EraseRootFromParent_Done,
     /*   99143 */   // Label 1551: @99143
     /*   99143 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(99232), // Rule ID 70668 //
     /*   99148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99182 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99191 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99230 */     GIR_RootConstrainSelectedInstOperands,
     /*   99231 */     // GIR_Coverage, 70668,
     /*   99231 */     GIR_EraseRootFromParent_Done,
     /*   99232 */   // Label 1552: @99232
     /*   99232 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(99321), // Rule ID 70547 //
     /*   99237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99252 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99271 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99280 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99319 */     GIR_RootConstrainSelectedInstOperands,
     /*   99320 */     // GIR_Coverage, 70547,
     /*   99320 */     GIR_EraseRootFromParent_Done,
     /*   99321 */   // Label 1553: @99321
     /*   99321 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(99410), // Rule ID 70548 //
     /*   99326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99341 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99360 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99369 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99408 */     GIR_RootConstrainSelectedInstOperands,
     /*   99409 */     // GIR_Coverage, 70548,
     /*   99409 */     GIR_EraseRootFromParent_Done,
     /*   99410 */   // Label 1554: @99410
     /*   99410 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(99499), // Rule ID 51850 //
     /*   99415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99430 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99449 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99458 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99497 */     GIR_RootConstrainSelectedInstOperands,
     /*   99498 */     // GIR_Coverage, 51850,
     /*   99498 */     GIR_EraseRootFromParent_Done,
     /*   99499 */   // Label 1555: @99499
     /*   99499 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(99588), // Rule ID 51851 //
     /*   99504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99519 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99538 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99547 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99586 */     GIR_RootConstrainSelectedInstOperands,
     /*   99587 */     // GIR_Coverage, 51851,
     /*   99587 */     GIR_EraseRootFromParent_Done,
     /*   99588 */   // Label 1556: @99588
     /*   99588 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(99677), // Rule ID 51550 //
     /*   99593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99608 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99627 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99636 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   99653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99675 */     GIR_RootConstrainSelectedInstOperands,
     /*   99676 */     // GIR_Coverage, 51550,
     /*   99676 */     GIR_EraseRootFromParent_Done,
     /*   99677 */   // Label 1557: @99677
     /*   99677 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(99766), // Rule ID 51551 //
     /*   99682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99716 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99725 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   99742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99764 */     GIR_RootConstrainSelectedInstOperands,
     /*   99765 */     // GIR_Coverage, 51551,
     /*   99765 */     GIR_EraseRootFromParent_Done,
     /*   99766 */   // Label 1558: @99766
     /*   99766 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(99855), // Rule ID 51790 //
     /*   99771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99805 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99814 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99853 */     GIR_RootConstrainSelectedInstOperands,
     /*   99854 */     // GIR_Coverage, 51790,
     /*   99854 */     GIR_EraseRootFromParent_Done,
     /*   99855 */   // Label 1559: @99855
     /*   99855 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(99944), // Rule ID 51791 //
     /*   99860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99875 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99894 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99903 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99942 */     GIR_RootConstrainSelectedInstOperands,
     /*   99943 */     // GIR_Coverage, 51791,
     /*   99943 */     GIR_EraseRootFromParent_Done,
     /*   99944 */   // Label 1560: @99944
     /*   99944 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(100033), // Rule ID 51730 //
     /*   99949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99964 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99983 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99992 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  100009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100031 */     GIR_RootConstrainSelectedInstOperands,
     /*  100032 */     // GIR_Coverage, 51730,
     /*  100032 */     GIR_EraseRootFromParent_Done,
     /*  100033 */   // Label 1561: @100033
     /*  100033 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(100122), // Rule ID 51731 //
     /*  100038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100053 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100072 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100081 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  100081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  100098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100120 */     GIR_RootConstrainSelectedInstOperands,
     /*  100121 */     // GIR_Coverage, 51731,
     /*  100121 */     GIR_EraseRootFromParent_Done,
     /*  100122 */   // Label 1562: @100122
     /*  100122 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(100211), // Rule ID 70607 //
     /*  100127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100142 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100161 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100170 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  100170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  100187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100209 */     GIR_RootConstrainSelectedInstOperands,
     /*  100210 */     // GIR_Coverage, 70607,
     /*  100210 */     GIR_EraseRootFromParent_Done,
     /*  100211 */   // Label 1563: @100211
     /*  100211 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(100300), // Rule ID 70608 //
     /*  100216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100231 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100250 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100259 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  100259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  100276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100298 */     GIR_RootConstrainSelectedInstOperands,
     /*  100299 */     // GIR_Coverage, 70608,
     /*  100299 */     GIR_EraseRootFromParent_Done,
     /*  100300 */   // Label 1564: @100300
     /*  100300 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(100389), // Rule ID 51610 //
     /*  100305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100320 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100339 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100348 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  100348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  100365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100387 */     GIR_RootConstrainSelectedInstOperands,
     /*  100388 */     // GIR_Coverage, 51610,
     /*  100388 */     GIR_EraseRootFromParent_Done,
     /*  100389 */   // Label 1565: @100389
     /*  100389 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(100478), // Rule ID 51611 //
     /*  100394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100409 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100428 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100437 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  100437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  100454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100476 */     GIR_RootConstrainSelectedInstOperands,
     /*  100477 */     // GIR_Coverage, 51611,
     /*  100477 */     GIR_EraseRootFromParent_Done,
     /*  100478 */   // Label 1566: @100478
     /*  100478 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(100531), // Rule ID 50936 //
     /*  100483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100494 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  100511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  100518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  100520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100529 */     GIR_RootConstrainSelectedInstOperands,
     /*  100530 */     // GIR_Coverage, 50936,
     /*  100530 */     GIR_EraseRootFromParent_Done,
     /*  100531 */   // Label 1567: @100531
     /*  100531 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(100584), // Rule ID 50937 //
     /*  100536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100547 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  100564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  100571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  100573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100582 */     GIR_RootConstrainSelectedInstOperands,
     /*  100583 */     // GIR_Coverage, 50937,
     /*  100583 */     GIR_EraseRootFromParent_Done,
     /*  100584 */   // Label 1568: @100584
     /*  100584 */   GIM_Reject,
     /*  100585 */ // Label 1548: @100585
     /*  100585 */ GIM_Reject,
     /*  100586 */ // Label 1313: @100586
     /*  100586 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(102310),
     /*  100591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  100594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  100597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  100601 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(100690), // Rule ID 51690 //
     /*  100606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100621 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100640 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100649 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100688 */     GIR_RootConstrainSelectedInstOperands,
     /*  100689 */     // GIR_Coverage, 51690,
     /*  100689 */     GIR_EraseRootFromParent_Done,
     /*  100690 */   // Label 1570: @100690
     /*  100690 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(100779), // Rule ID 51691 //
     /*  100695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100710 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100729 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100731 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100738 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100777 */     GIR_RootConstrainSelectedInstOperands,
     /*  100778 */     // GIR_Coverage, 51691,
     /*  100778 */     GIR_EraseRootFromParent_Done,
     /*  100779 */   // Label 1571: @100779
     /*  100779 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(100868), // Rule ID 70687 //
     /*  100784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100799 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100818 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100827 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100866 */     GIR_RootConstrainSelectedInstOperands,
     /*  100867 */     // GIR_Coverage, 70687,
     /*  100867 */     GIR_EraseRootFromParent_Done,
     /*  100868 */   // Label 1572: @100868
     /*  100868 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(100957), // Rule ID 70688 //
     /*  100873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100888 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100907 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100916 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100955 */     GIR_RootConstrainSelectedInstOperands,
     /*  100956 */     // GIR_Coverage, 70688,
     /*  100956 */     GIR_EraseRootFromParent_Done,
     /*  100957 */   // Label 1573: @100957
     /*  100957 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(101046), // Rule ID 70567 //
     /*  100962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100977 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100996 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101005 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101044 */     GIR_RootConstrainSelectedInstOperands,
     /*  101045 */     // GIR_Coverage, 70567,
     /*  101045 */     GIR_EraseRootFromParent_Done,
     /*  101046 */   // Label 1574: @101046
     /*  101046 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(101135), // Rule ID 70568 //
     /*  101051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101085 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101094 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101133 */     GIR_RootConstrainSelectedInstOperands,
     /*  101134 */     // GIR_Coverage, 70568,
     /*  101134 */     GIR_EraseRootFromParent_Done,
     /*  101135 */   // Label 1575: @101135
     /*  101135 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(101224), // Rule ID 51870 //
     /*  101140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101155 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101174 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101183 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101222 */     GIR_RootConstrainSelectedInstOperands,
     /*  101223 */     // GIR_Coverage, 51870,
     /*  101223 */     GIR_EraseRootFromParent_Done,
     /*  101224 */   // Label 1576: @101224
     /*  101224 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(101313), // Rule ID 51871 //
     /*  101229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101244 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101263 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101272 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101311 */     GIR_RootConstrainSelectedInstOperands,
     /*  101312 */     // GIR_Coverage, 51871,
     /*  101312 */     GIR_EraseRootFromParent_Done,
     /*  101313 */   // Label 1577: @101313
     /*  101313 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(101402), // Rule ID 51570 //
     /*  101318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101333 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101352 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101361 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  101378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101400 */     GIR_RootConstrainSelectedInstOperands,
     /*  101401 */     // GIR_Coverage, 51570,
     /*  101401 */     GIR_EraseRootFromParent_Done,
     /*  101402 */   // Label 1578: @101402
     /*  101402 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(101491), // Rule ID 51571 //
     /*  101407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101422 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101441 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101450 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  101467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101489 */     GIR_RootConstrainSelectedInstOperands,
     /*  101490 */     // GIR_Coverage, 51571,
     /*  101490 */     GIR_EraseRootFromParent_Done,
     /*  101491 */   // Label 1579: @101491
     /*  101491 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(101580), // Rule ID 51810 //
     /*  101496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101511 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101530 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101539 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101578 */     GIR_RootConstrainSelectedInstOperands,
     /*  101579 */     // GIR_Coverage, 51810,
     /*  101579 */     GIR_EraseRootFromParent_Done,
     /*  101580 */   // Label 1580: @101580
     /*  101580 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(101669), // Rule ID 51811 //
     /*  101585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101619 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101628 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101667 */     GIR_RootConstrainSelectedInstOperands,
     /*  101668 */     // GIR_Coverage, 51811,
     /*  101668 */     GIR_EraseRootFromParent_Done,
     /*  101669 */   // Label 1581: @101669
     /*  101669 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(101758), // Rule ID 51750 //
     /*  101674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101708 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101717 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101756 */     GIR_RootConstrainSelectedInstOperands,
     /*  101757 */     // GIR_Coverage, 51750,
     /*  101757 */     GIR_EraseRootFromParent_Done,
     /*  101758 */   // Label 1582: @101758
     /*  101758 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(101847), // Rule ID 51751 //
     /*  101763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101778 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101797 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101799 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101806 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101845 */     GIR_RootConstrainSelectedInstOperands,
     /*  101846 */     // GIR_Coverage, 51751,
     /*  101846 */     GIR_EraseRootFromParent_Done,
     /*  101847 */   // Label 1583: @101847
     /*  101847 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(101936), // Rule ID 70627 //
     /*  101852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101867 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101886 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101895 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101934 */     GIR_RootConstrainSelectedInstOperands,
     /*  101935 */     // GIR_Coverage, 70627,
     /*  101935 */     GIR_EraseRootFromParent_Done,
     /*  101936 */   // Label 1584: @101936
     /*  101936 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(102025), // Rule ID 70628 //
     /*  101941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101975 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101984 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  102001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  102020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102023 */     GIR_RootConstrainSelectedInstOperands,
     /*  102024 */     // GIR_Coverage, 70628,
     /*  102024 */     GIR_EraseRootFromParent_Done,
     /*  102025 */   // Label 1585: @102025
     /*  102025 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(102114), // Rule ID 51630 //
     /*  102030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  102033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  102045 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  102064 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102073 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  102073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  102076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  102090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  102109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102112 */     GIR_RootConstrainSelectedInstOperands,
     /*  102113 */     // GIR_Coverage, 51630,
     /*  102113 */     GIR_EraseRootFromParent_Done,
     /*  102114 */   // Label 1586: @102114
     /*  102114 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(102203), // Rule ID 51631 //
     /*  102119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  102122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  102134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  102153 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102162 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  102162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  102165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  102179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  102198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102201 */     GIR_RootConstrainSelectedInstOperands,
     /*  102202 */     // GIR_Coverage, 51631,
     /*  102202 */     GIR_EraseRootFromParent_Done,
     /*  102203 */   // Label 1587: @102203
     /*  102203 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(102256), // Rule ID 50952 //
     /*  102208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  102211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  102215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  102219 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  102219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  102222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  102236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  102243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  102245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  102251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102254 */     GIR_RootConstrainSelectedInstOperands,
     /*  102255 */     // GIR_Coverage, 50952,
     /*  102255 */     GIR_EraseRootFromParent_Done,
     /*  102256 */   // Label 1588: @102256
     /*  102256 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(102309), // Rule ID 50953 //
     /*  102261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  102264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  102268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  102272 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  102272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  102275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  102289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  102296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  102298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  102304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102307 */     GIR_RootConstrainSelectedInstOperands,
     /*  102308 */     // GIR_Coverage, 50953,
     /*  102308 */     GIR_EraseRootFromParent_Done,
     /*  102309 */   // Label 1589: @102309
     /*  102309 */   GIM_Reject,
     /*  102310 */ // Label 1569: @102310
     /*  102310 */ GIM_Reject,
     /*  102311 */ // Label 1314: @102311
     /*  102311 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(102425),
     /*  102316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  102322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102334 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(102379), // Rule ID 50908 //
     /*  102339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102342 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  102345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  102359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  102366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  102368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102377 */     GIR_RootConstrainSelectedInstOperands,
     /*  102378 */     // GIR_Coverage, 50908,
     /*  102378 */     GIR_EraseRootFromParent_Done,
     /*  102379 */   // Label 1591: @102379
     /*  102379 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(102424), // Rule ID 50909 //
     /*  102384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102387 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  102390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  102404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  102411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  102413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102422 */     GIR_RootConstrainSelectedInstOperands,
     /*  102423 */     // GIR_Coverage, 50909,
     /*  102423 */     GIR_EraseRootFromParent_Done,
     /*  102424 */   // Label 1592: @102424
     /*  102424 */   GIM_Reject,
     /*  102425 */ // Label 1590: @102425
     /*  102425 */ GIM_Reject,
     /*  102426 */ // Label 1315: @102426
     /*  102426 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(104150),
     /*  102431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  102434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  102437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102441 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(102530), // Rule ID 51650 //
     /*  102446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102461 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102480 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102489 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102528 */     GIR_RootConstrainSelectedInstOperands,
     /*  102529 */     // GIR_Coverage, 51650,
     /*  102529 */     GIR_EraseRootFromParent_Done,
     /*  102530 */   // Label 1594: @102530
     /*  102530 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(102619), // Rule ID 51651 //
     /*  102535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102550 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102569 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102578 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102617 */     GIR_RootConstrainSelectedInstOperands,
     /*  102618 */     // GIR_Coverage, 51651,
     /*  102618 */     GIR_EraseRootFromParent_Done,
     /*  102619 */   // Label 1595: @102619
     /*  102619 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(102708), // Rule ID 70647 //
     /*  102624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102639 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102658 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102667 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102706 */     GIR_RootConstrainSelectedInstOperands,
     /*  102707 */     // GIR_Coverage, 70647,
     /*  102707 */     GIR_EraseRootFromParent_Done,
     /*  102708 */   // Label 1596: @102708
     /*  102708 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(102797), // Rule ID 70648 //
     /*  102713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102728 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102747 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102756 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102795 */     GIR_RootConstrainSelectedInstOperands,
     /*  102796 */     // GIR_Coverage, 70648,
     /*  102796 */     GIR_EraseRootFromParent_Done,
     /*  102797 */   // Label 1597: @102797
     /*  102797 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(102886), // Rule ID 70527 //
     /*  102802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102817 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102836 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102845 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102884 */     GIR_RootConstrainSelectedInstOperands,
     /*  102885 */     // GIR_Coverage, 70527,
     /*  102885 */     GIR_EraseRootFromParent_Done,
     /*  102886 */   // Label 1598: @102886
     /*  102886 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(102975), // Rule ID 70528 //
     /*  102891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102906 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102925 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102934 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102973 */     GIR_RootConstrainSelectedInstOperands,
     /*  102974 */     // GIR_Coverage, 70528,
     /*  102974 */     GIR_EraseRootFromParent_Done,
     /*  102975 */   // Label 1599: @102975
     /*  102975 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(103064), // Rule ID 51830 //
     /*  102980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102995 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103014 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103023 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103062 */     GIR_RootConstrainSelectedInstOperands,
     /*  103063 */     // GIR_Coverage, 51830,
     /*  103063 */     GIR_EraseRootFromParent_Done,
     /*  103064 */   // Label 1600: @103064
     /*  103064 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(103153), // Rule ID 51831 //
     /*  103069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103084 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103103 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103112 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103151 */     GIR_RootConstrainSelectedInstOperands,
     /*  103152 */     // GIR_Coverage, 51831,
     /*  103152 */     GIR_EraseRootFromParent_Done,
     /*  103153 */   // Label 1601: @103153
     /*  103153 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(103242), // Rule ID 51530 //
     /*  103158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103173 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103192 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103201 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  103218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103240 */     GIR_RootConstrainSelectedInstOperands,
     /*  103241 */     // GIR_Coverage, 51530,
     /*  103241 */     GIR_EraseRootFromParent_Done,
     /*  103242 */   // Label 1602: @103242
     /*  103242 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(103331), // Rule ID 51531 //
     /*  103247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103262 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103281 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103290 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  103307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103329 */     GIR_RootConstrainSelectedInstOperands,
     /*  103330 */     // GIR_Coverage, 51531,
     /*  103330 */     GIR_EraseRootFromParent_Done,
     /*  103331 */   // Label 1603: @103331
     /*  103331 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(103420), // Rule ID 51770 //
     /*  103336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103351 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103370 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103379 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103418 */     GIR_RootConstrainSelectedInstOperands,
     /*  103419 */     // GIR_Coverage, 51770,
     /*  103419 */     GIR_EraseRootFromParent_Done,
     /*  103420 */   // Label 1604: @103420
     /*  103420 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(103509), // Rule ID 51771 //
     /*  103425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103440 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103459 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103468 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103507 */     GIR_RootConstrainSelectedInstOperands,
     /*  103508 */     // GIR_Coverage, 51771,
     /*  103508 */     GIR_EraseRootFromParent_Done,
     /*  103509 */   // Label 1605: @103509
     /*  103509 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(103598), // Rule ID 51710 //
     /*  103514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103529 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103548 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103557 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103596 */     GIR_RootConstrainSelectedInstOperands,
     /*  103597 */     // GIR_Coverage, 51710,
     /*  103597 */     GIR_EraseRootFromParent_Done,
     /*  103598 */   // Label 1606: @103598
     /*  103598 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(103687), // Rule ID 51711 //
     /*  103603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103618 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103637 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103646 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103685 */     GIR_RootConstrainSelectedInstOperands,
     /*  103686 */     // GIR_Coverage, 51711,
     /*  103686 */     GIR_EraseRootFromParent_Done,
     /*  103687 */   // Label 1607: @103687
     /*  103687 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(103776), // Rule ID 70587 //
     /*  103692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103707 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103726 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103728 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103735 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103774 */     GIR_RootConstrainSelectedInstOperands,
     /*  103775 */     // GIR_Coverage, 70587,
     /*  103775 */     GIR_EraseRootFromParent_Done,
     /*  103776 */   // Label 1608: @103776
     /*  103776 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(103865), // Rule ID 70588 //
     /*  103781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103796 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103815 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103824 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103863 */     GIR_RootConstrainSelectedInstOperands,
     /*  103864 */     // GIR_Coverage, 70588,
     /*  103864 */     GIR_EraseRootFromParent_Done,
     /*  103865 */   // Label 1609: @103865
     /*  103865 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(103954), // Rule ID 51590 //
     /*  103870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103885 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103904 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103913 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103952 */     GIR_RootConstrainSelectedInstOperands,
     /*  103953 */     // GIR_Coverage, 51590,
     /*  103953 */     GIR_EraseRootFromParent_Done,
     /*  103954 */   // Label 1610: @103954
     /*  103954 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(104043), // Rule ID 51591 //
     /*  103959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103974 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103993 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  104000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104002 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  104002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  104005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  104019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104041 */     GIR_RootConstrainSelectedInstOperands,
     /*  104042 */     // GIR_Coverage, 51591,
     /*  104042 */     GIR_EraseRootFromParent_Done,
     /*  104043 */   // Label 1611: @104043
     /*  104043 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(104096), // Rule ID 50924 //
     /*  104048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104059 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  104062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  104076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104094 */     GIR_RootConstrainSelectedInstOperands,
     /*  104095 */     // GIR_Coverage, 50924,
     /*  104095 */     GIR_EraseRootFromParent_Done,
     /*  104096 */   // Label 1612: @104096
     /*  104096 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(104149), // Rule ID 50925 //
     /*  104101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104112 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  104115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  104129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104147 */     GIR_RootConstrainSelectedInstOperands,
     /*  104148 */     // GIR_Coverage, 50925,
     /*  104148 */     GIR_EraseRootFromParent_Done,
     /*  104149 */   // Label 1613: @104149
     /*  104149 */   GIM_Reject,
     /*  104150 */ // Label 1593: @104150
     /*  104150 */ GIM_Reject,
     /*  104151 */ // Label 1316: @104151
     /*  104151 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(105875),
     /*  104156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  104159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  104162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  104166 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(104255), // Rule ID 51674 //
     /*  104171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104205 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104214 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104253 */     GIR_RootConstrainSelectedInstOperands,
     /*  104254 */     // GIR_Coverage, 51674,
     /*  104254 */     GIR_EraseRootFromParent_Done,
     /*  104255 */   // Label 1615: @104255
     /*  104255 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(104344), // Rule ID 51675 //
     /*  104260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104275 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104294 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104303 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104342 */     GIR_RootConstrainSelectedInstOperands,
     /*  104343 */     // GIR_Coverage, 51675,
     /*  104343 */     GIR_EraseRootFromParent_Done,
     /*  104344 */   // Label 1616: @104344
     /*  104344 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(104433), // Rule ID 70671 //
     /*  104349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104364 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104383 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104392 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104431 */     GIR_RootConstrainSelectedInstOperands,
     /*  104432 */     // GIR_Coverage, 70671,
     /*  104432 */     GIR_EraseRootFromParent_Done,
     /*  104433 */   // Label 1617: @104433
     /*  104433 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(104522), // Rule ID 70672 //
     /*  104438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104453 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104472 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104481 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104520 */     GIR_RootConstrainSelectedInstOperands,
     /*  104521 */     // GIR_Coverage, 70672,
     /*  104521 */     GIR_EraseRootFromParent_Done,
     /*  104522 */   // Label 1618: @104522
     /*  104522 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(104611), // Rule ID 70551 //
     /*  104527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104561 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104570 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104609 */     GIR_RootConstrainSelectedInstOperands,
     /*  104610 */     // GIR_Coverage, 70551,
     /*  104610 */     GIR_EraseRootFromParent_Done,
     /*  104611 */   // Label 1619: @104611
     /*  104611 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(104700), // Rule ID 70552 //
     /*  104616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104631 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104650 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104659 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104698 */     GIR_RootConstrainSelectedInstOperands,
     /*  104699 */     // GIR_Coverage, 70552,
     /*  104699 */     GIR_EraseRootFromParent_Done,
     /*  104700 */   // Label 1620: @104700
     /*  104700 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(104789), // Rule ID 51854 //
     /*  104705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104720 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104739 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104748 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104787 */     GIR_RootConstrainSelectedInstOperands,
     /*  104788 */     // GIR_Coverage, 51854,
     /*  104788 */     GIR_EraseRootFromParent_Done,
     /*  104789 */   // Label 1621: @104789
     /*  104789 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(104878), // Rule ID 51855 //
     /*  104794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104809 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104828 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104837 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104876 */     GIR_RootConstrainSelectedInstOperands,
     /*  104877 */     // GIR_Coverage, 51855,
     /*  104877 */     GIR_EraseRootFromParent_Done,
     /*  104878 */   // Label 1622: @104878
     /*  104878 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(104967), // Rule ID 51554 //
     /*  104883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104898 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104917 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104926 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  104943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104965 */     GIR_RootConstrainSelectedInstOperands,
     /*  104966 */     // GIR_Coverage, 51554,
     /*  104966 */     GIR_EraseRootFromParent_Done,
     /*  104967 */   // Label 1623: @104967
     /*  104967 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(105056), // Rule ID 51555 //
     /*  104972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104987 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105006 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105015 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  105032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105054 */     GIR_RootConstrainSelectedInstOperands,
     /*  105055 */     // GIR_Coverage, 51555,
     /*  105055 */     GIR_EraseRootFromParent_Done,
     /*  105056 */   // Label 1624: @105056
     /*  105056 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(105145), // Rule ID 51794 //
     /*  105061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105095 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105104 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105143 */     GIR_RootConstrainSelectedInstOperands,
     /*  105144 */     // GIR_Coverage, 51794,
     /*  105144 */     GIR_EraseRootFromParent_Done,
     /*  105145 */   // Label 1625: @105145
     /*  105145 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(105234), // Rule ID 51795 //
     /*  105150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105184 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105193 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105232 */     GIR_RootConstrainSelectedInstOperands,
     /*  105233 */     // GIR_Coverage, 51795,
     /*  105233 */     GIR_EraseRootFromParent_Done,
     /*  105234 */   // Label 1626: @105234
     /*  105234 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(105323), // Rule ID 51734 //
     /*  105239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105254 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105273 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105282 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105321 */     GIR_RootConstrainSelectedInstOperands,
     /*  105322 */     // GIR_Coverage, 51734,
     /*  105322 */     GIR_EraseRootFromParent_Done,
     /*  105323 */   // Label 1627: @105323
     /*  105323 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(105412), // Rule ID 51735 //
     /*  105328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105362 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105371 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105410 */     GIR_RootConstrainSelectedInstOperands,
     /*  105411 */     // GIR_Coverage, 51735,
     /*  105411 */     GIR_EraseRootFromParent_Done,
     /*  105412 */   // Label 1628: @105412
     /*  105412 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(105501), // Rule ID 70611 //
     /*  105417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105432 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105451 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105460 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105499 */     GIR_RootConstrainSelectedInstOperands,
     /*  105500 */     // GIR_Coverage, 70611,
     /*  105500 */     GIR_EraseRootFromParent_Done,
     /*  105501 */   // Label 1629: @105501
     /*  105501 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(105590), // Rule ID 70612 //
     /*  105506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105540 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105549 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105588 */     GIR_RootConstrainSelectedInstOperands,
     /*  105589 */     // GIR_Coverage, 70612,
     /*  105589 */     GIR_EraseRootFromParent_Done,
     /*  105590 */   // Label 1630: @105590
     /*  105590 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(105679), // Rule ID 51614 //
     /*  105595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105629 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105638 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105677 */     GIR_RootConstrainSelectedInstOperands,
     /*  105678 */     // GIR_Coverage, 51614,
     /*  105678 */     GIR_EraseRootFromParent_Done,
     /*  105679 */   // Label 1631: @105679
     /*  105679 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(105768), // Rule ID 51615 //
     /*  105684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105718 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105727 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105766 */     GIR_RootConstrainSelectedInstOperands,
     /*  105767 */     // GIR_Coverage, 51615,
     /*  105767 */     GIR_EraseRootFromParent_Done,
     /*  105768 */   // Label 1632: @105768
     /*  105768 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(105821), // Rule ID 50940 //
     /*  105773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105784 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  105784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  105801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105819 */     GIR_RootConstrainSelectedInstOperands,
     /*  105820 */     // GIR_Coverage, 50940,
     /*  105820 */     GIR_EraseRootFromParent_Done,
     /*  105821 */   // Label 1633: @105821
     /*  105821 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(105874), // Rule ID 50941 //
     /*  105826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105837 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  105837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  105854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105872 */     GIR_RootConstrainSelectedInstOperands,
     /*  105873 */     // GIR_Coverage, 50941,
     /*  105873 */     GIR_EraseRootFromParent_Done,
     /*  105874 */   // Label 1634: @105874
     /*  105874 */   GIM_Reject,
     /*  105875 */ // Label 1614: @105875
     /*  105875 */ GIM_Reject,
     /*  105876 */ // Label 1317: @105876
     /*  105876 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(105990),
     /*  105881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  105887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105899 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(105944), // Rule ID 50912 //
     /*  105904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105907 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  105924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105942 */     GIR_RootConstrainSelectedInstOperands,
     /*  105943 */     // GIR_Coverage, 50912,
     /*  105943 */     GIR_EraseRootFromParent_Done,
     /*  105944 */   // Label 1636: @105944
     /*  105944 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(105989), // Rule ID 50913 //
     /*  105949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105952 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  105969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105987 */     GIR_RootConstrainSelectedInstOperands,
     /*  105988 */     // GIR_Coverage, 50913,
     /*  105988 */     GIR_EraseRootFromParent_Done,
     /*  105989 */   // Label 1637: @105989
     /*  105989 */   GIM_Reject,
     /*  105990 */ // Label 1635: @105990
     /*  105990 */ GIM_Reject,
     /*  105991 */ // Label 1318: @105991
     /*  105991 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(107715),
     /*  105996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  105999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  106002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  106006 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(106095), // Rule ID 51654 //
     /*  106011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106045 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106054 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106093 */     GIR_RootConstrainSelectedInstOperands,
     /*  106094 */     // GIR_Coverage, 51654,
     /*  106094 */     GIR_EraseRootFromParent_Done,
     /*  106095 */   // Label 1639: @106095
     /*  106095 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106184), // Rule ID 51655 //
     /*  106100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106115 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106134 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106143 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106182 */     GIR_RootConstrainSelectedInstOperands,
     /*  106183 */     // GIR_Coverage, 51655,
     /*  106183 */     GIR_EraseRootFromParent_Done,
     /*  106184 */   // Label 1640: @106184
     /*  106184 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106273), // Rule ID 70651 //
     /*  106189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106204 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106223 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106232 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106271 */     GIR_RootConstrainSelectedInstOperands,
     /*  106272 */     // GIR_Coverage, 70651,
     /*  106272 */     GIR_EraseRootFromParent_Done,
     /*  106273 */   // Label 1641: @106273
     /*  106273 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106362), // Rule ID 70652 //
     /*  106278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106293 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106312 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106321 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106360 */     GIR_RootConstrainSelectedInstOperands,
     /*  106361 */     // GIR_Coverage, 70652,
     /*  106361 */     GIR_EraseRootFromParent_Done,
     /*  106362 */   // Label 1642: @106362
     /*  106362 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106451), // Rule ID 70531 //
     /*  106367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106382 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106401 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106410 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106449 */     GIR_RootConstrainSelectedInstOperands,
     /*  106450 */     // GIR_Coverage, 70531,
     /*  106450 */     GIR_EraseRootFromParent_Done,
     /*  106451 */   // Label 1643: @106451
     /*  106451 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(106540), // Rule ID 70532 //
     /*  106456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106471 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106490 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106499 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106538 */     GIR_RootConstrainSelectedInstOperands,
     /*  106539 */     // GIR_Coverage, 70532,
     /*  106539 */     GIR_EraseRootFromParent_Done,
     /*  106540 */   // Label 1644: @106540
     /*  106540 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(106629), // Rule ID 51834 //
     /*  106545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106560 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106579 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106588 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106627 */     GIR_RootConstrainSelectedInstOperands,
     /*  106628 */     // GIR_Coverage, 51834,
     /*  106628 */     GIR_EraseRootFromParent_Done,
     /*  106629 */   // Label 1645: @106629
     /*  106629 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(106718), // Rule ID 51835 //
     /*  106634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106649 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106668 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106677 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106716 */     GIR_RootConstrainSelectedInstOperands,
     /*  106717 */     // GIR_Coverage, 51835,
     /*  106717 */     GIR_EraseRootFromParent_Done,
     /*  106718 */   // Label 1646: @106718
     /*  106718 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(106807), // Rule ID 51534 //
     /*  106723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106738 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106757 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106766 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  106783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106805 */     GIR_RootConstrainSelectedInstOperands,
     /*  106806 */     // GIR_Coverage, 51534,
     /*  106806 */     GIR_EraseRootFromParent_Done,
     /*  106807 */   // Label 1647: @106807
     /*  106807 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(106896), // Rule ID 51535 //
     /*  106812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106827 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106855 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  106872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106894 */     GIR_RootConstrainSelectedInstOperands,
     /*  106895 */     // GIR_Coverage, 51535,
     /*  106895 */     GIR_EraseRootFromParent_Done,
     /*  106896 */   // Label 1648: @106896
     /*  106896 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(106985), // Rule ID 51774 //
     /*  106901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106916 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106935 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106944 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106983 */     GIR_RootConstrainSelectedInstOperands,
     /*  106984 */     // GIR_Coverage, 51774,
     /*  106984 */     GIR_EraseRootFromParent_Done,
     /*  106985 */   // Label 1649: @106985
     /*  106985 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(107074), // Rule ID 51775 //
     /*  106990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  107001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107005 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107024 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107033 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  107050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107072 */     GIR_RootConstrainSelectedInstOperands,
     /*  107073 */     // GIR_Coverage, 51775,
     /*  107073 */     GIR_EraseRootFromParent_Done,
     /*  107074 */   // Label 1650: @107074
     /*  107074 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(107163), // Rule ID 51714 //
     /*  107079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107094 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  107109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107113 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107122 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107161 */     GIR_RootConstrainSelectedInstOperands,
     /*  107162 */     // GIR_Coverage, 51714,
     /*  107162 */     GIR_EraseRootFromParent_Done,
     /*  107163 */   // Label 1651: @107163
     /*  107163 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(107252), // Rule ID 51715 //
     /*  107168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107183 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  107198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107202 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107211 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107250 */     GIR_RootConstrainSelectedInstOperands,
     /*  107251 */     // GIR_Coverage, 51715,
     /*  107251 */     GIR_EraseRootFromParent_Done,
     /*  107252 */   // Label 1652: @107252
     /*  107252 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(107341), // Rule ID 70591 //
     /*  107257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  107287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107291 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107300 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  107317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  107326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  107330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107339 */     GIR_RootConstrainSelectedInstOperands,
     /*  107340 */     // GIR_Coverage, 70591,
     /*  107340 */     GIR_EraseRootFromParent_Done,
     /*  107341 */   // Label 1653: @107341
     /*  107341 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(107430), // Rule ID 70592 //
     /*  107346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  107376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107380 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107389 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  107406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  107415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  107419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107428 */     GIR_RootConstrainSelectedInstOperands,
     /*  107429 */     // GIR_Coverage, 70592,
     /*  107429 */     GIR_EraseRootFromParent_Done,
     /*  107430 */   // Label 1654: @107430
     /*  107430 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(107519), // Rule ID 51594 //
     /*  107435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107450 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107469 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107478 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107517 */     GIR_RootConstrainSelectedInstOperands,
     /*  107518 */     // GIR_Coverage, 51594,
     /*  107518 */     GIR_EraseRootFromParent_Done,
     /*  107519 */   // Label 1655: @107519
     /*  107519 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(107608), // Rule ID 51595 //
     /*  107524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107539 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107558 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107567 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107606 */     GIR_RootConstrainSelectedInstOperands,
     /*  107607 */     // GIR_Coverage, 51595,
     /*  107607 */     GIR_EraseRootFromParent_Done,
     /*  107608 */   // Label 1656: @107608
     /*  107608 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(107661), // Rule ID 50928 //
     /*  107613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107624 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  107624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107659 */     GIR_RootConstrainSelectedInstOperands,
     /*  107660 */     // GIR_Coverage, 50928,
     /*  107660 */     GIR_EraseRootFromParent_Done,
     /*  107661 */   // Label 1657: @107661
     /*  107661 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(107714), // Rule ID 50929 //
     /*  107666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107677 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  107677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107712 */     GIR_RootConstrainSelectedInstOperands,
     /*  107713 */     // GIR_Coverage, 50929,
     /*  107713 */     GIR_EraseRootFromParent_Done,
     /*  107714 */   // Label 1658: @107714
     /*  107714 */   GIM_Reject,
     /*  107715 */ // Label 1638: @107715
     /*  107715 */ GIM_Reject,
     /*  107716 */ // Label 1319: @107716
     /*  107716 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(107830),
     /*  107721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  107724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  107727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107739 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(107784), // Rule ID 50916 //
     /*  107744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107747 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  107750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107782 */     GIR_RootConstrainSelectedInstOperands,
     /*  107783 */     // GIR_Coverage, 50916,
     /*  107783 */     GIR_EraseRootFromParent_Done,
     /*  107784 */   // Label 1660: @107784
     /*  107784 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(107829), // Rule ID 50917 //
     /*  107789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107792 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  107795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107827 */     GIR_RootConstrainSelectedInstOperands,
     /*  107828 */     // GIR_Coverage, 50917,
     /*  107828 */     GIR_EraseRootFromParent_Done,
     /*  107829 */   // Label 1661: @107829
     /*  107829 */   GIM_Reject,
     /*  107830 */ // Label 1659: @107830
     /*  107830 */ GIM_Reject,
     /*  107831 */ // Label 1320: @107831
     /*  107831 */ GIM_Reject,
     /*  107832 */ // Label 3: @107832
     /*  107832 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1686*/ GIMT_Encode4(110565),
     /*  107843 */ /*GILLT_s32*//*Label 1662*/ GIMT_Encode4(107967),
     /*  107847 */ /*GILLT_s64*//*Label 1663*/ GIMT_Encode4(108001), GIMT_Encode4(0),
     /*  107855 */ /*GILLT_nxv1s8*//*Label 1664*/ GIMT_Encode4(108035),
     /*  107859 */ /*GILLT_nxv1s16*//*Label 1665*/ GIMT_Encode4(108150),
     /*  107863 */ /*GILLT_nxv1s32*//*Label 1666*/ GIMT_Encode4(108265),
     /*  107867 */ /*GILLT_nxv1s64*//*Label 1667*/ GIMT_Encode4(108380), GIMT_Encode4(0),
     /*  107875 */ /*GILLT_nxv2s8*//*Label 1668*/ GIMT_Encode4(108495),
     /*  107879 */ /*GILLT_nxv2s16*//*Label 1669*/ GIMT_Encode4(108610),
     /*  107883 */ /*GILLT_nxv2s32*//*Label 1670*/ GIMT_Encode4(108725),
     /*  107887 */ /*GILLT_nxv2s64*//*Label 1671*/ GIMT_Encode4(108840), GIMT_Encode4(0),
     /*  107895 */ /*GILLT_nxv4s8*//*Label 1672*/ GIMT_Encode4(108955),
     /*  107899 */ /*GILLT_nxv4s16*//*Label 1673*/ GIMT_Encode4(109070),
     /*  107903 */ /*GILLT_nxv4s32*//*Label 1674*/ GIMT_Encode4(109185),
     /*  107907 */ /*GILLT_nxv4s64*//*Label 1675*/ GIMT_Encode4(109300), GIMT_Encode4(0),
     /*  107915 */ /*GILLT_nxv8s8*//*Label 1676*/ GIMT_Encode4(109415),
     /*  107919 */ /*GILLT_nxv8s16*//*Label 1677*/ GIMT_Encode4(109530),
     /*  107923 */ /*GILLT_nxv8s32*//*Label 1678*/ GIMT_Encode4(109645),
     /*  107927 */ /*GILLT_nxv8s64*//*Label 1679*/ GIMT_Encode4(109760), GIMT_Encode4(0),
     /*  107935 */ /*GILLT_nxv16s8*//*Label 1680*/ GIMT_Encode4(109875),
     /*  107939 */ /*GILLT_nxv16s16*//*Label 1681*/ GIMT_Encode4(109990),
     /*  107943 */ /*GILLT_nxv16s32*//*Label 1682*/ GIMT_Encode4(110105), GIMT_Encode4(0),
     /*  107951 */ /*GILLT_nxv32s8*//*Label 1683*/ GIMT_Encode4(110220),
     /*  107955 */ /*GILLT_nxv32s16*//*Label 1684*/ GIMT_Encode4(110335), GIMT_Encode4(0),
     /*  107963 */ /*GILLT_nxv64s8*//*Label 1685*/ GIMT_Encode4(110450),
     /*  107967 */ // Label 1662: @107967
     /*  107967 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(108000), // Rule ID 318 //
     /*  107972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  107975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  107978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  107981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107993 */   // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  107998 */   GIR_RootConstrainSelectedInstOperands,
     /*  107999 */   // GIR_Coverage, 318,
     /*  107999 */   GIR_Done,
     /*  108000 */ // Label 1687: @108000
     /*  108000 */ GIM_Reject,
     /*  108001 */ // Label 1663: @108001
     /*  108001 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(108034), // Rule ID 317 //
     /*  108006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  108009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  108012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  108015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108027 */   // (sdiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  108032 */   GIR_RootConstrainSelectedInstOperands,
     /*  108033 */   // GIR_Coverage, 317,
     /*  108033 */   GIR_Done,
     /*  108034 */ // Label 1688: @108034
     /*  108034 */ GIM_Reject,
     /*  108035 */ // Label 1664: @108035
     /*  108035 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(108149),
     /*  108040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  108043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  108046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108058 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(108103), // Rule ID 51220 //
     /*  108063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108066 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  108069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  108083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108101 */     GIR_RootConstrainSelectedInstOperands,
     /*  108102 */     // GIR_Coverage, 51220,
     /*  108102 */     GIR_EraseRootFromParent_Done,
     /*  108103 */   // Label 1690: @108103
     /*  108103 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(108148), // Rule ID 51221 //
     /*  108108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108111 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  108114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  108128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108146 */     GIR_RootConstrainSelectedInstOperands,
     /*  108147 */     // GIR_Coverage, 51221,
     /*  108147 */     GIR_EraseRootFromParent_Done,
     /*  108148 */   // Label 1691: @108148
     /*  108148 */   GIM_Reject,
     /*  108149 */ // Label 1689: @108149
     /*  108149 */ GIM_Reject,
     /*  108150 */ // Label 1665: @108150
     /*  108150 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(108264),
     /*  108155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  108158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  108161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108173 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(108218), // Rule ID 51232 //
     /*  108178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108181 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  108184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  108198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108216 */     GIR_RootConstrainSelectedInstOperands,
     /*  108217 */     // GIR_Coverage, 51232,
     /*  108217 */     GIR_EraseRootFromParent_Done,
     /*  108218 */   // Label 1693: @108218
     /*  108218 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(108263), // Rule ID 51233 //
     /*  108223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108226 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  108229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  108243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108261 */     GIR_RootConstrainSelectedInstOperands,
     /*  108262 */     // GIR_Coverage, 51233,
     /*  108262 */     GIR_EraseRootFromParent_Done,
     /*  108263 */   // Label 1694: @108263
     /*  108263 */   GIM_Reject,
     /*  108264 */ // Label 1692: @108264
     /*  108264 */ GIM_Reject,
     /*  108265 */ // Label 1666: @108265
     /*  108265 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(108379),
     /*  108270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  108273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  108276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108288 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(108333), // Rule ID 51240 //
     /*  108293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108296 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  108299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  108313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108331 */     GIR_RootConstrainSelectedInstOperands,
     /*  108332 */     // GIR_Coverage, 51240,
     /*  108332 */     GIR_EraseRootFromParent_Done,
     /*  108333 */   // Label 1696: @108333
     /*  108333 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(108378), // Rule ID 51241 //
     /*  108338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108341 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  108344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  108358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108376 */     GIR_RootConstrainSelectedInstOperands,
     /*  108377 */     // GIR_Coverage, 51241,
     /*  108377 */     GIR_EraseRootFromParent_Done,
     /*  108378 */   // Label 1697: @108378
     /*  108378 */   GIM_Reject,
     /*  108379 */ // Label 1695: @108379
     /*  108379 */ GIM_Reject,
     /*  108380 */ // Label 1667: @108380
     /*  108380 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(108494),
     /*  108385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  108388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  108391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108403 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(108448), // Rule ID 51256 //
     /*  108408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  108411 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  108411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  108414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  108428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108446 */     GIR_RootConstrainSelectedInstOperands,
     /*  108447 */     // GIR_Coverage, 51256,
     /*  108447 */     GIR_EraseRootFromParent_Done,
     /*  108448 */   // Label 1699: @108448
     /*  108448 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108493), // Rule ID 51257 //
     /*  108453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  108456 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  108456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  108459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  108473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108491 */     GIR_RootConstrainSelectedInstOperands,
     /*  108492 */     // GIR_Coverage, 51257,
     /*  108492 */     GIR_EraseRootFromParent_Done,
     /*  108493 */   // Label 1700: @108493
     /*  108493 */   GIM_Reject,
     /*  108494 */ // Label 1698: @108494
     /*  108494 */ GIM_Reject,
     /*  108495 */ // Label 1668: @108495
     /*  108495 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108609),
     /*  108500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  108503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  108506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108518 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108563), // Rule ID 51224 //
     /*  108523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108526 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  108529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  108543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108561 */     GIR_RootConstrainSelectedInstOperands,
     /*  108562 */     // GIR_Coverage, 51224,
     /*  108562 */     GIR_EraseRootFromParent_Done,
     /*  108563 */   // Label 1702: @108563
     /*  108563 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108608), // Rule ID 51225 //
     /*  108568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108571 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  108574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  108588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108606 */     GIR_RootConstrainSelectedInstOperands,
     /*  108607 */     // GIR_Coverage, 51225,
     /*  108607 */     GIR_EraseRootFromParent_Done,
     /*  108608 */   // Label 1703: @108608
     /*  108608 */   GIM_Reject,
     /*  108609 */ // Label 1701: @108609
     /*  108609 */ GIM_Reject,
     /*  108610 */ // Label 1669: @108610
     /*  108610 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108724),
     /*  108615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  108618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  108621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108633 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108678), // Rule ID 51236 //
     /*  108638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108641 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  108644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  108658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108676 */     GIR_RootConstrainSelectedInstOperands,
     /*  108677 */     // GIR_Coverage, 51236,
     /*  108677 */     GIR_EraseRootFromParent_Done,
     /*  108678 */   // Label 1705: @108678
     /*  108678 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(108723), // Rule ID 51237 //
     /*  108683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108686 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  108689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  108703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108721 */     GIR_RootConstrainSelectedInstOperands,
     /*  108722 */     // GIR_Coverage, 51237,
     /*  108722 */     GIR_EraseRootFromParent_Done,
     /*  108723 */   // Label 1706: @108723
     /*  108723 */   GIM_Reject,
     /*  108724 */ // Label 1704: @108724
     /*  108724 */ GIM_Reject,
     /*  108725 */ // Label 1670: @108725
     /*  108725 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(108839),
     /*  108730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  108733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  108736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108748 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(108793), // Rule ID 51252 //
     /*  108753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108756 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  108759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  108773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108791 */     GIR_RootConstrainSelectedInstOperands,
     /*  108792 */     // GIR_Coverage, 51252,
     /*  108792 */     GIR_EraseRootFromParent_Done,
     /*  108793 */   // Label 1708: @108793
     /*  108793 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(108838), // Rule ID 51253 //
     /*  108798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108801 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  108804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  108818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108836 */     GIR_RootConstrainSelectedInstOperands,
     /*  108837 */     // GIR_Coverage, 51253,
     /*  108837 */     GIR_EraseRootFromParent_Done,
     /*  108838 */   // Label 1709: @108838
     /*  108838 */   GIM_Reject,
     /*  108839 */ // Label 1707: @108839
     /*  108839 */ GIM_Reject,
     /*  108840 */ // Label 1671: @108840
     /*  108840 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(108954),
     /*  108845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  108848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  108851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108863 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(108908), // Rule ID 51296 //
     /*  108868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  108871 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  108871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  108874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  108888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108906 */     GIR_RootConstrainSelectedInstOperands,
     /*  108907 */     // GIR_Coverage, 51296,
     /*  108907 */     GIR_EraseRootFromParent_Done,
     /*  108908 */   // Label 1711: @108908
     /*  108908 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(108953), // Rule ID 51297 //
     /*  108913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  108916 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  108916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  108919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  108933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108951 */     GIR_RootConstrainSelectedInstOperands,
     /*  108952 */     // GIR_Coverage, 51297,
     /*  108952 */     GIR_EraseRootFromParent_Done,
     /*  108953 */   // Label 1712: @108953
     /*  108953 */   GIM_Reject,
     /*  108954 */ // Label 1710: @108954
     /*  108954 */ GIM_Reject,
     /*  108955 */ // Label 1672: @108955
     /*  108955 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(109069),
     /*  108960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  108963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  108966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108978 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(109023), // Rule ID 51228 //
     /*  108983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108986 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  108989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  109003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109021 */     GIR_RootConstrainSelectedInstOperands,
     /*  109022 */     // GIR_Coverage, 51228,
     /*  109022 */     GIR_EraseRootFromParent_Done,
     /*  109023 */   // Label 1714: @109023
     /*  109023 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(109068), // Rule ID 51229 //
     /*  109028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109031 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  109034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  109048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109066 */     GIR_RootConstrainSelectedInstOperands,
     /*  109067 */     // GIR_Coverage, 51229,
     /*  109067 */     GIR_EraseRootFromParent_Done,
     /*  109068 */   // Label 1715: @109068
     /*  109068 */   GIM_Reject,
     /*  109069 */ // Label 1713: @109069
     /*  109069 */ GIM_Reject,
     /*  109070 */ // Label 1673: @109070
     /*  109070 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(109184),
     /*  109075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  109078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  109081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109093 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(109138), // Rule ID 51248 //
     /*  109098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109101 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  109104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  109118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109136 */     GIR_RootConstrainSelectedInstOperands,
     /*  109137 */     // GIR_Coverage, 51248,
     /*  109137 */     GIR_EraseRootFromParent_Done,
     /*  109138 */   // Label 1717: @109138
     /*  109138 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(109183), // Rule ID 51249 //
     /*  109143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109146 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  109149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  109163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109181 */     GIR_RootConstrainSelectedInstOperands,
     /*  109182 */     // GIR_Coverage, 51249,
     /*  109182 */     GIR_EraseRootFromParent_Done,
     /*  109183 */   // Label 1718: @109183
     /*  109183 */   GIM_Reject,
     /*  109184 */ // Label 1716: @109184
     /*  109184 */ GIM_Reject,
     /*  109185 */ // Label 1674: @109185
     /*  109185 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(109299),
     /*  109190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  109193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  109196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109208 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(109253), // Rule ID 51284 //
     /*  109213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109216 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  109219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  109233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109251 */     GIR_RootConstrainSelectedInstOperands,
     /*  109252 */     // GIR_Coverage, 51284,
     /*  109252 */     GIR_EraseRootFromParent_Done,
     /*  109253 */   // Label 1720: @109253
     /*  109253 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(109298), // Rule ID 51285 //
     /*  109258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109261 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  109264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  109278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109296 */     GIR_RootConstrainSelectedInstOperands,
     /*  109297 */     // GIR_Coverage, 51285,
     /*  109297 */     GIR_EraseRootFromParent_Done,
     /*  109298 */   // Label 1721: @109298
     /*  109298 */   GIM_Reject,
     /*  109299 */ // Label 1719: @109299
     /*  109299 */ GIM_Reject,
     /*  109300 */ // Label 1675: @109300
     /*  109300 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(109414),
     /*  109305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  109308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  109311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109323 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(109368), // Rule ID 51300 //
     /*  109328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  109331 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  109331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  109334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  109348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109366 */     GIR_RootConstrainSelectedInstOperands,
     /*  109367 */     // GIR_Coverage, 51300,
     /*  109367 */     GIR_EraseRootFromParent_Done,
     /*  109368 */   // Label 1723: @109368
     /*  109368 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(109413), // Rule ID 51301 //
     /*  109373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  109376 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  109376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  109379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  109393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109411 */     GIR_RootConstrainSelectedInstOperands,
     /*  109412 */     // GIR_Coverage, 51301,
     /*  109412 */     GIR_EraseRootFromParent_Done,
     /*  109413 */   // Label 1724: @109413
     /*  109413 */   GIM_Reject,
     /*  109414 */ // Label 1722: @109414
     /*  109414 */ GIM_Reject,
     /*  109415 */ // Label 1676: @109415
     /*  109415 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(109529),
     /*  109420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  109423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  109426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109438 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(109483), // Rule ID 51244 //
     /*  109443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109446 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  109449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  109463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109481 */     GIR_RootConstrainSelectedInstOperands,
     /*  109482 */     // GIR_Coverage, 51244,
     /*  109482 */     GIR_EraseRootFromParent_Done,
     /*  109483 */   // Label 1726: @109483
     /*  109483 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(109528), // Rule ID 51245 //
     /*  109488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109491 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  109494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  109508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109526 */     GIR_RootConstrainSelectedInstOperands,
     /*  109527 */     // GIR_Coverage, 51245,
     /*  109527 */     GIR_EraseRootFromParent_Done,
     /*  109528 */   // Label 1727: @109528
     /*  109528 */   GIM_Reject,
     /*  109529 */ // Label 1725: @109529
     /*  109529 */ GIM_Reject,
     /*  109530 */ // Label 1677: @109530
     /*  109530 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(109644),
     /*  109535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  109538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  109541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109553 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(109598), // Rule ID 51272 //
     /*  109558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109561 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  109564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  109578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109596 */     GIR_RootConstrainSelectedInstOperands,
     /*  109597 */     // GIR_Coverage, 51272,
     /*  109597 */     GIR_EraseRootFromParent_Done,
     /*  109598 */   // Label 1729: @109598
     /*  109598 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(109643), // Rule ID 51273 //
     /*  109603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109606 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  109609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  109623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109641 */     GIR_RootConstrainSelectedInstOperands,
     /*  109642 */     // GIR_Coverage, 51273,
     /*  109642 */     GIR_EraseRootFromParent_Done,
     /*  109643 */   // Label 1730: @109643
     /*  109643 */   GIM_Reject,
     /*  109644 */ // Label 1728: @109644
     /*  109644 */ GIM_Reject,
     /*  109645 */ // Label 1678: @109645
     /*  109645 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(109759),
     /*  109650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  109653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  109656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109668 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(109713), // Rule ID 51288 //
     /*  109673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109676 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  109679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  109693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109711 */     GIR_RootConstrainSelectedInstOperands,
     /*  109712 */     // GIR_Coverage, 51288,
     /*  109712 */     GIR_EraseRootFromParent_Done,
     /*  109713 */   // Label 1732: @109713
     /*  109713 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(109758), // Rule ID 51289 //
     /*  109718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109721 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  109724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  109738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109756 */     GIR_RootConstrainSelectedInstOperands,
     /*  109757 */     // GIR_Coverage, 51289,
     /*  109757 */     GIR_EraseRootFromParent_Done,
     /*  109758 */   // Label 1733: @109758
     /*  109758 */   GIM_Reject,
     /*  109759 */ // Label 1731: @109759
     /*  109759 */ GIM_Reject,
     /*  109760 */ // Label 1679: @109760
     /*  109760 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(109874),
     /*  109765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  109768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  109771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109783 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(109828), // Rule ID 51304 //
     /*  109788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  109791 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  109791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  109794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  109808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109826 */     GIR_RootConstrainSelectedInstOperands,
     /*  109827 */     // GIR_Coverage, 51304,
     /*  109827 */     GIR_EraseRootFromParent_Done,
     /*  109828 */   // Label 1735: @109828
     /*  109828 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(109873), // Rule ID 51305 //
     /*  109833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  109836 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  109836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  109839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  109853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109871 */     GIR_RootConstrainSelectedInstOperands,
     /*  109872 */     // GIR_Coverage, 51305,
     /*  109872 */     GIR_EraseRootFromParent_Done,
     /*  109873 */   // Label 1736: @109873
     /*  109873 */   GIM_Reject,
     /*  109874 */ // Label 1734: @109874
     /*  109874 */ GIM_Reject,
     /*  109875 */ // Label 1680: @109875
     /*  109875 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(109989),
     /*  109880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  109883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  109886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109898 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(109943), // Rule ID 51260 //
     /*  109903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109906 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  109909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  109923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109941 */     GIR_RootConstrainSelectedInstOperands,
     /*  109942 */     // GIR_Coverage, 51260,
     /*  109942 */     GIR_EraseRootFromParent_Done,
     /*  109943 */   // Label 1738: @109943
     /*  109943 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(109988), // Rule ID 51261 //
     /*  109948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109951 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  109954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  109968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109986 */     GIR_RootConstrainSelectedInstOperands,
     /*  109987 */     // GIR_Coverage, 51261,
     /*  109987 */     GIR_EraseRootFromParent_Done,
     /*  109988 */   // Label 1739: @109988
     /*  109988 */   GIM_Reject,
     /*  109989 */ // Label 1737: @109989
     /*  109989 */ GIM_Reject,
     /*  109990 */ // Label 1681: @109990
     /*  109990 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(110104),
     /*  109995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  109998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  110001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110013 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(110058), // Rule ID 51276 //
     /*  110018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110021 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  110024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  110038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110056 */     GIR_RootConstrainSelectedInstOperands,
     /*  110057 */     // GIR_Coverage, 51276,
     /*  110057 */     GIR_EraseRootFromParent_Done,
     /*  110058 */   // Label 1741: @110058
     /*  110058 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(110103), // Rule ID 51277 //
     /*  110063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110066 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  110069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  110083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110101 */     GIR_RootConstrainSelectedInstOperands,
     /*  110102 */     // GIR_Coverage, 51277,
     /*  110102 */     GIR_EraseRootFromParent_Done,
     /*  110103 */   // Label 1742: @110103
     /*  110103 */   GIM_Reject,
     /*  110104 */ // Label 1740: @110104
     /*  110104 */ GIM_Reject,
     /*  110105 */ // Label 1682: @110105
     /*  110105 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(110219),
     /*  110110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  110113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  110116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110128 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(110173), // Rule ID 51292 //
     /*  110133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110136 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  110136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  110139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  110153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110171 */     GIR_RootConstrainSelectedInstOperands,
     /*  110172 */     // GIR_Coverage, 51292,
     /*  110172 */     GIR_EraseRootFromParent_Done,
     /*  110173 */   // Label 1744: @110173
     /*  110173 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(110218), // Rule ID 51293 //
     /*  110178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110181 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  110181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  110184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  110198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110216 */     GIR_RootConstrainSelectedInstOperands,
     /*  110217 */     // GIR_Coverage, 51293,
     /*  110217 */     GIR_EraseRootFromParent_Done,
     /*  110218 */   // Label 1745: @110218
     /*  110218 */   GIM_Reject,
     /*  110219 */ // Label 1743: @110219
     /*  110219 */ GIM_Reject,
     /*  110220 */ // Label 1683: @110220
     /*  110220 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(110334),
     /*  110225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  110228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  110231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110243 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(110288), // Rule ID 51264 //
     /*  110248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110251 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  110254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  110268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110286 */     GIR_RootConstrainSelectedInstOperands,
     /*  110287 */     // GIR_Coverage, 51264,
     /*  110287 */     GIR_EraseRootFromParent_Done,
     /*  110288 */   // Label 1747: @110288
     /*  110288 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(110333), // Rule ID 51265 //
     /*  110293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110296 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  110299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  110313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110331 */     GIR_RootConstrainSelectedInstOperands,
     /*  110332 */     // GIR_Coverage, 51265,
     /*  110332 */     GIR_EraseRootFromParent_Done,
     /*  110333 */   // Label 1748: @110333
     /*  110333 */   GIM_Reject,
     /*  110334 */ // Label 1746: @110334
     /*  110334 */ GIM_Reject,
     /*  110335 */ // Label 1684: @110335
     /*  110335 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(110449),
     /*  110340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  110343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  110346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110358 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(110403), // Rule ID 51280 //
     /*  110363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110366 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  110369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  110383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110401 */     GIR_RootConstrainSelectedInstOperands,
     /*  110402 */     // GIR_Coverage, 51280,
     /*  110402 */     GIR_EraseRootFromParent_Done,
     /*  110403 */   // Label 1750: @110403
     /*  110403 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(110448), // Rule ID 51281 //
     /*  110408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110411 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  110414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  110428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110446 */     GIR_RootConstrainSelectedInstOperands,
     /*  110447 */     // GIR_Coverage, 51281,
     /*  110447 */     GIR_EraseRootFromParent_Done,
     /*  110448 */   // Label 1751: @110448
     /*  110448 */   GIM_Reject,
     /*  110449 */ // Label 1749: @110449
     /*  110449 */ GIM_Reject,
     /*  110450 */ // Label 1685: @110450
     /*  110450 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(110564),
     /*  110455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  110458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  110461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110473 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(110518), // Rule ID 51268 //
     /*  110478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110481 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  110484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  110498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110516 */     GIR_RootConstrainSelectedInstOperands,
     /*  110517 */     // GIR_Coverage, 51268,
     /*  110517 */     GIR_EraseRootFromParent_Done,
     /*  110518 */   // Label 1753: @110518
     /*  110518 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(110563), // Rule ID 51269 //
     /*  110523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110526 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  110529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  110543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110561 */     GIR_RootConstrainSelectedInstOperands,
     /*  110562 */     // GIR_Coverage, 51269,
     /*  110562 */     GIR_EraseRootFromParent_Done,
     /*  110563 */   // Label 1754: @110563
     /*  110563 */   GIM_Reject,
     /*  110564 */ // Label 1752: @110564
     /*  110564 */ GIM_Reject,
     /*  110565 */ // Label 1686: @110565
     /*  110565 */ GIM_Reject,
     /*  110566 */ // Label 4: @110566
     /*  110566 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1779*/ GIMT_Encode4(113299),
     /*  110577 */ /*GILLT_s32*//*Label 1755*/ GIMT_Encode4(110701),
     /*  110581 */ /*GILLT_s64*//*Label 1756*/ GIMT_Encode4(110735), GIMT_Encode4(0),
     /*  110589 */ /*GILLT_nxv1s8*//*Label 1757*/ GIMT_Encode4(110769),
     /*  110593 */ /*GILLT_nxv1s16*//*Label 1758*/ GIMT_Encode4(110884),
     /*  110597 */ /*GILLT_nxv1s32*//*Label 1759*/ GIMT_Encode4(110999),
     /*  110601 */ /*GILLT_nxv1s64*//*Label 1760*/ GIMT_Encode4(111114), GIMT_Encode4(0),
     /*  110609 */ /*GILLT_nxv2s8*//*Label 1761*/ GIMT_Encode4(111229),
     /*  110613 */ /*GILLT_nxv2s16*//*Label 1762*/ GIMT_Encode4(111344),
     /*  110617 */ /*GILLT_nxv2s32*//*Label 1763*/ GIMT_Encode4(111459),
     /*  110621 */ /*GILLT_nxv2s64*//*Label 1764*/ GIMT_Encode4(111574), GIMT_Encode4(0),
     /*  110629 */ /*GILLT_nxv4s8*//*Label 1765*/ GIMT_Encode4(111689),
     /*  110633 */ /*GILLT_nxv4s16*//*Label 1766*/ GIMT_Encode4(111804),
     /*  110637 */ /*GILLT_nxv4s32*//*Label 1767*/ GIMT_Encode4(111919),
     /*  110641 */ /*GILLT_nxv4s64*//*Label 1768*/ GIMT_Encode4(112034), GIMT_Encode4(0),
     /*  110649 */ /*GILLT_nxv8s8*//*Label 1769*/ GIMT_Encode4(112149),
     /*  110653 */ /*GILLT_nxv8s16*//*Label 1770*/ GIMT_Encode4(112264),
     /*  110657 */ /*GILLT_nxv8s32*//*Label 1771*/ GIMT_Encode4(112379),
     /*  110661 */ /*GILLT_nxv8s64*//*Label 1772*/ GIMT_Encode4(112494), GIMT_Encode4(0),
     /*  110669 */ /*GILLT_nxv16s8*//*Label 1773*/ GIMT_Encode4(112609),
     /*  110673 */ /*GILLT_nxv16s16*//*Label 1774*/ GIMT_Encode4(112724),
     /*  110677 */ /*GILLT_nxv16s32*//*Label 1775*/ GIMT_Encode4(112839), GIMT_Encode4(0),
     /*  110685 */ /*GILLT_nxv32s8*//*Label 1776*/ GIMT_Encode4(112954),
     /*  110689 */ /*GILLT_nxv32s16*//*Label 1777*/ GIMT_Encode4(113069), GIMT_Encode4(0),
     /*  110697 */ /*GILLT_nxv64s8*//*Label 1778*/ GIMT_Encode4(113184),
     /*  110701 */ // Label 1755: @110701
     /*  110701 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(110734), // Rule ID 320 //
     /*  110706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  110709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  110712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  110715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110727 */   // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIVU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110727 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  110732 */   GIR_RootConstrainSelectedInstOperands,
     /*  110733 */   // GIR_Coverage, 320,
     /*  110733 */   GIR_Done,
     /*  110734 */ // Label 1780: @110734
     /*  110734 */ GIM_Reject,
     /*  110735 */ // Label 1756: @110735
     /*  110735 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(110768), // Rule ID 319 //
     /*  110740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  110743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  110746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  110749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110761 */   // (udiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  110761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  110766 */   GIR_RootConstrainSelectedInstOperands,
     /*  110767 */   // GIR_Coverage, 319,
     /*  110767 */   GIR_Done,
     /*  110768 */ // Label 1781: @110768
     /*  110768 */ GIM_Reject,
     /*  110769 */ // Label 1757: @110769
     /*  110769 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(110883),
     /*  110774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  110777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  110780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110792 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(110837), // Rule ID 51132 //
     /*  110797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110800 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  110803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  110817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110835 */     GIR_RootConstrainSelectedInstOperands,
     /*  110836 */     // GIR_Coverage, 51132,
     /*  110836 */     GIR_EraseRootFromParent_Done,
     /*  110837 */   // Label 1783: @110837
     /*  110837 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(110882), // Rule ID 51133 //
     /*  110842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110845 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  110848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  110862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110880 */     GIR_RootConstrainSelectedInstOperands,
     /*  110881 */     // GIR_Coverage, 51133,
     /*  110881 */     GIR_EraseRootFromParent_Done,
     /*  110882 */   // Label 1784: @110882
     /*  110882 */   GIM_Reject,
     /*  110883 */ // Label 1782: @110883
     /*  110883 */ GIM_Reject,
     /*  110884 */ // Label 1758: @110884
     /*  110884 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(110998),
     /*  110889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  110892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  110895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110907 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(110952), // Rule ID 51144 //
     /*  110912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110915 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  110918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  110932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110950 */     GIR_RootConstrainSelectedInstOperands,
     /*  110951 */     // GIR_Coverage, 51144,
     /*  110951 */     GIR_EraseRootFromParent_Done,
     /*  110952 */   // Label 1786: @110952
     /*  110952 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(110997), // Rule ID 51145 //
     /*  110957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110960 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  110963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  110977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110995 */     GIR_RootConstrainSelectedInstOperands,
     /*  110996 */     // GIR_Coverage, 51145,
     /*  110996 */     GIR_EraseRootFromParent_Done,
     /*  110997 */   // Label 1787: @110997
     /*  110997 */   GIM_Reject,
     /*  110998 */ // Label 1785: @110998
     /*  110998 */ GIM_Reject,
     /*  110999 */ // Label 1759: @110999
     /*  110999 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(111113),
     /*  111004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  111007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  111010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111022 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(111067), // Rule ID 51152 //
     /*  111027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111030 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  111033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  111047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111065 */     GIR_RootConstrainSelectedInstOperands,
     /*  111066 */     // GIR_Coverage, 51152,
     /*  111066 */     GIR_EraseRootFromParent_Done,
     /*  111067 */   // Label 1789: @111067
     /*  111067 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(111112), // Rule ID 51153 //
     /*  111072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111075 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  111078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  111092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111110 */     GIR_RootConstrainSelectedInstOperands,
     /*  111111 */     // GIR_Coverage, 51153,
     /*  111111 */     GIR_EraseRootFromParent_Done,
     /*  111112 */   // Label 1790: @111112
     /*  111112 */   GIM_Reject,
     /*  111113 */ // Label 1788: @111113
     /*  111113 */ GIM_Reject,
     /*  111114 */ // Label 1760: @111114
     /*  111114 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(111228),
     /*  111119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  111122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  111125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111137 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(111182), // Rule ID 51168 //
     /*  111142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  111145 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  111145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  111148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  111162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111180 */     GIR_RootConstrainSelectedInstOperands,
     /*  111181 */     // GIR_Coverage, 51168,
     /*  111181 */     GIR_EraseRootFromParent_Done,
     /*  111182 */   // Label 1792: @111182
     /*  111182 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(111227), // Rule ID 51169 //
     /*  111187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  111190 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  111190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  111193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  111207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111225 */     GIR_RootConstrainSelectedInstOperands,
     /*  111226 */     // GIR_Coverage, 51169,
     /*  111226 */     GIR_EraseRootFromParent_Done,
     /*  111227 */   // Label 1793: @111227
     /*  111227 */   GIM_Reject,
     /*  111228 */ // Label 1791: @111228
     /*  111228 */ GIM_Reject,
     /*  111229 */ // Label 1761: @111229
     /*  111229 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(111343),
     /*  111234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  111237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  111240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111252 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(111297), // Rule ID 51136 //
     /*  111257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111260 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  111263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  111277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111295 */     GIR_RootConstrainSelectedInstOperands,
     /*  111296 */     // GIR_Coverage, 51136,
     /*  111296 */     GIR_EraseRootFromParent_Done,
     /*  111297 */   // Label 1795: @111297
     /*  111297 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(111342), // Rule ID 51137 //
     /*  111302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111305 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  111308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  111322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111340 */     GIR_RootConstrainSelectedInstOperands,
     /*  111341 */     // GIR_Coverage, 51137,
     /*  111341 */     GIR_EraseRootFromParent_Done,
     /*  111342 */   // Label 1796: @111342
     /*  111342 */   GIM_Reject,
     /*  111343 */ // Label 1794: @111343
     /*  111343 */ GIM_Reject,
     /*  111344 */ // Label 1762: @111344
     /*  111344 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(111458),
     /*  111349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  111352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  111355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111367 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(111412), // Rule ID 51148 //
     /*  111372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111375 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  111378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  111392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111410 */     GIR_RootConstrainSelectedInstOperands,
     /*  111411 */     // GIR_Coverage, 51148,
     /*  111411 */     GIR_EraseRootFromParent_Done,
     /*  111412 */   // Label 1798: @111412
     /*  111412 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(111457), // Rule ID 51149 //
     /*  111417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111420 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  111423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  111437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111455 */     GIR_RootConstrainSelectedInstOperands,
     /*  111456 */     // GIR_Coverage, 51149,
     /*  111456 */     GIR_EraseRootFromParent_Done,
     /*  111457 */   // Label 1799: @111457
     /*  111457 */   GIM_Reject,
     /*  111458 */ // Label 1797: @111458
     /*  111458 */ GIM_Reject,
     /*  111459 */ // Label 1763: @111459
     /*  111459 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(111573),
     /*  111464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  111467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  111470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111482 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(111527), // Rule ID 51164 //
     /*  111487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111490 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  111493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  111507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111525 */     GIR_RootConstrainSelectedInstOperands,
     /*  111526 */     // GIR_Coverage, 51164,
     /*  111526 */     GIR_EraseRootFromParent_Done,
     /*  111527 */   // Label 1801: @111527
     /*  111527 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(111572), // Rule ID 51165 //
     /*  111532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111535 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  111538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  111552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111570 */     GIR_RootConstrainSelectedInstOperands,
     /*  111571 */     // GIR_Coverage, 51165,
     /*  111571 */     GIR_EraseRootFromParent_Done,
     /*  111572 */   // Label 1802: @111572
     /*  111572 */   GIM_Reject,
     /*  111573 */ // Label 1800: @111573
     /*  111573 */ GIM_Reject,
     /*  111574 */ // Label 1764: @111574
     /*  111574 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(111688),
     /*  111579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  111582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  111585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111597 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(111642), // Rule ID 51208 //
     /*  111602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  111605 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  111605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  111608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  111622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111640 */     GIR_RootConstrainSelectedInstOperands,
     /*  111641 */     // GIR_Coverage, 51208,
     /*  111641 */     GIR_EraseRootFromParent_Done,
     /*  111642 */   // Label 1804: @111642
     /*  111642 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(111687), // Rule ID 51209 //
     /*  111647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  111650 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  111650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  111653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  111667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111685 */     GIR_RootConstrainSelectedInstOperands,
     /*  111686 */     // GIR_Coverage, 51209,
     /*  111686 */     GIR_EraseRootFromParent_Done,
     /*  111687 */   // Label 1805: @111687
     /*  111687 */   GIM_Reject,
     /*  111688 */ // Label 1803: @111688
     /*  111688 */ GIM_Reject,
     /*  111689 */ // Label 1765: @111689
     /*  111689 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(111803),
     /*  111694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  111697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  111700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111712 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(111757), // Rule ID 51140 //
     /*  111717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111720 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  111723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  111737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111755 */     GIR_RootConstrainSelectedInstOperands,
     /*  111756 */     // GIR_Coverage, 51140,
     /*  111756 */     GIR_EraseRootFromParent_Done,
     /*  111757 */   // Label 1807: @111757
     /*  111757 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(111802), // Rule ID 51141 //
     /*  111762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111765 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  111768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  111782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111800 */     GIR_RootConstrainSelectedInstOperands,
     /*  111801 */     // GIR_Coverage, 51141,
     /*  111801 */     GIR_EraseRootFromParent_Done,
     /*  111802 */   // Label 1808: @111802
     /*  111802 */   GIM_Reject,
     /*  111803 */ // Label 1806: @111803
     /*  111803 */ GIM_Reject,
     /*  111804 */ // Label 1766: @111804
     /*  111804 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(111918),
     /*  111809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  111812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  111815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111827 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(111872), // Rule ID 51160 //
     /*  111832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111835 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  111838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  111852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111870 */     GIR_RootConstrainSelectedInstOperands,
     /*  111871 */     // GIR_Coverage, 51160,
     /*  111871 */     GIR_EraseRootFromParent_Done,
     /*  111872 */   // Label 1810: @111872
     /*  111872 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(111917), // Rule ID 51161 //
     /*  111877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111880 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  111883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  111897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111915 */     GIR_RootConstrainSelectedInstOperands,
     /*  111916 */     // GIR_Coverage, 51161,
     /*  111916 */     GIR_EraseRootFromParent_Done,
     /*  111917 */   // Label 1811: @111917
     /*  111917 */   GIM_Reject,
     /*  111918 */ // Label 1809: @111918
     /*  111918 */ GIM_Reject,
     /*  111919 */ // Label 1767: @111919
     /*  111919 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(112033),
     /*  111924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  111927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  111930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111942 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(111987), // Rule ID 51196 //
     /*  111947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111950 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  111953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  111967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111985 */     GIR_RootConstrainSelectedInstOperands,
     /*  111986 */     // GIR_Coverage, 51196,
     /*  111986 */     GIR_EraseRootFromParent_Done,
     /*  111987 */   // Label 1813: @111987
     /*  111987 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(112032), // Rule ID 51197 //
     /*  111992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111995 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  111998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  112012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112030 */     GIR_RootConstrainSelectedInstOperands,
     /*  112031 */     // GIR_Coverage, 51197,
     /*  112031 */     GIR_EraseRootFromParent_Done,
     /*  112032 */   // Label 1814: @112032
     /*  112032 */   GIM_Reject,
     /*  112033 */ // Label 1812: @112033
     /*  112033 */ GIM_Reject,
     /*  112034 */ // Label 1768: @112034
     /*  112034 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(112148),
     /*  112039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  112042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  112045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112057 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(112102), // Rule ID 51212 //
     /*  112062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  112065 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  112065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  112068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  112082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112100 */     GIR_RootConstrainSelectedInstOperands,
     /*  112101 */     // GIR_Coverage, 51212,
     /*  112101 */     GIR_EraseRootFromParent_Done,
     /*  112102 */   // Label 1816: @112102
     /*  112102 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(112147), // Rule ID 51213 //
     /*  112107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  112110 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  112110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  112113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  112127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112145 */     GIR_RootConstrainSelectedInstOperands,
     /*  112146 */     // GIR_Coverage, 51213,
     /*  112146 */     GIR_EraseRootFromParent_Done,
     /*  112147 */   // Label 1817: @112147
     /*  112147 */   GIM_Reject,
     /*  112148 */ // Label 1815: @112148
     /*  112148 */ GIM_Reject,
     /*  112149 */ // Label 1769: @112149
     /*  112149 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(112263),
     /*  112154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  112157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  112160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112172 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(112217), // Rule ID 51156 //
     /*  112177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112180 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  112183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  112197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112215 */     GIR_RootConstrainSelectedInstOperands,
     /*  112216 */     // GIR_Coverage, 51156,
     /*  112216 */     GIR_EraseRootFromParent_Done,
     /*  112217 */   // Label 1819: @112217
     /*  112217 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(112262), // Rule ID 51157 //
     /*  112222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112225 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  112228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  112242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112260 */     GIR_RootConstrainSelectedInstOperands,
     /*  112261 */     // GIR_Coverage, 51157,
     /*  112261 */     GIR_EraseRootFromParent_Done,
     /*  112262 */   // Label 1820: @112262
     /*  112262 */   GIM_Reject,
     /*  112263 */ // Label 1818: @112263
     /*  112263 */ GIM_Reject,
     /*  112264 */ // Label 1770: @112264
     /*  112264 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(112378),
     /*  112269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  112272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  112275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112287 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(112332), // Rule ID 51184 //
     /*  112292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112295 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  112298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  112312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112330 */     GIR_RootConstrainSelectedInstOperands,
     /*  112331 */     // GIR_Coverage, 51184,
     /*  112331 */     GIR_EraseRootFromParent_Done,
     /*  112332 */   // Label 1822: @112332
     /*  112332 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(112377), // Rule ID 51185 //
     /*  112337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112340 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  112343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  112357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112375 */     GIR_RootConstrainSelectedInstOperands,
     /*  112376 */     // GIR_Coverage, 51185,
     /*  112376 */     GIR_EraseRootFromParent_Done,
     /*  112377 */   // Label 1823: @112377
     /*  112377 */   GIM_Reject,
     /*  112378 */ // Label 1821: @112378
     /*  112378 */ GIM_Reject,
     /*  112379 */ // Label 1771: @112379
     /*  112379 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(112493),
     /*  112384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  112387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  112390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112402 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(112447), // Rule ID 51200 //
     /*  112407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112410 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  112410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  112413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  112427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112445 */     GIR_RootConstrainSelectedInstOperands,
     /*  112446 */     // GIR_Coverage, 51200,
     /*  112446 */     GIR_EraseRootFromParent_Done,
     /*  112447 */   // Label 1825: @112447
     /*  112447 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(112492), // Rule ID 51201 //
     /*  112452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112455 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  112455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  112458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  112472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112490 */     GIR_RootConstrainSelectedInstOperands,
     /*  112491 */     // GIR_Coverage, 51201,
     /*  112491 */     GIR_EraseRootFromParent_Done,
     /*  112492 */   // Label 1826: @112492
     /*  112492 */   GIM_Reject,
     /*  112493 */ // Label 1824: @112493
     /*  112493 */ GIM_Reject,
     /*  112494 */ // Label 1772: @112494
     /*  112494 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(112608),
     /*  112499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  112502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  112505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112517 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(112562), // Rule ID 51216 //
     /*  112522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  112525 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  112525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  112528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  112542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112560 */     GIR_RootConstrainSelectedInstOperands,
     /*  112561 */     // GIR_Coverage, 51216,
     /*  112561 */     GIR_EraseRootFromParent_Done,
     /*  112562 */   // Label 1828: @112562
     /*  112562 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(112607), // Rule ID 51217 //
     /*  112567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  112570 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  112570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  112573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  112587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112605 */     GIR_RootConstrainSelectedInstOperands,
     /*  112606 */     // GIR_Coverage, 51217,
     /*  112606 */     GIR_EraseRootFromParent_Done,
     /*  112607 */   // Label 1829: @112607
     /*  112607 */   GIM_Reject,
     /*  112608 */ // Label 1827: @112608
     /*  112608 */ GIM_Reject,
     /*  112609 */ // Label 1773: @112609
     /*  112609 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(112723),
     /*  112614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  112617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  112620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112632 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(112677), // Rule ID 51172 //
     /*  112637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112640 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  112643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  112657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112675 */     GIR_RootConstrainSelectedInstOperands,
     /*  112676 */     // GIR_Coverage, 51172,
     /*  112676 */     GIR_EraseRootFromParent_Done,
     /*  112677 */   // Label 1831: @112677
     /*  112677 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(112722), // Rule ID 51173 //
     /*  112682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112685 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  112688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  112702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112720 */     GIR_RootConstrainSelectedInstOperands,
     /*  112721 */     // GIR_Coverage, 51173,
     /*  112721 */     GIR_EraseRootFromParent_Done,
     /*  112722 */   // Label 1832: @112722
     /*  112722 */   GIM_Reject,
     /*  112723 */ // Label 1830: @112723
     /*  112723 */ GIM_Reject,
     /*  112724 */ // Label 1774: @112724
     /*  112724 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(112838),
     /*  112729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  112732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  112735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112747 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(112792), // Rule ID 51188 //
     /*  112752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112755 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  112758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  112772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112790 */     GIR_RootConstrainSelectedInstOperands,
     /*  112791 */     // GIR_Coverage, 51188,
     /*  112791 */     GIR_EraseRootFromParent_Done,
     /*  112792 */   // Label 1834: @112792
     /*  112792 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(112837), // Rule ID 51189 //
     /*  112797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112800 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  112803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  112817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112835 */     GIR_RootConstrainSelectedInstOperands,
     /*  112836 */     // GIR_Coverage, 51189,
     /*  112836 */     GIR_EraseRootFromParent_Done,
     /*  112837 */   // Label 1835: @112837
     /*  112837 */   GIM_Reject,
     /*  112838 */ // Label 1833: @112838
     /*  112838 */ GIM_Reject,
     /*  112839 */ // Label 1775: @112839
     /*  112839 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(112953),
     /*  112844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  112847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  112850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112862 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(112907), // Rule ID 51204 //
     /*  112867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112870 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  112870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  112873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  112887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112905 */     GIR_RootConstrainSelectedInstOperands,
     /*  112906 */     // GIR_Coverage, 51204,
     /*  112906 */     GIR_EraseRootFromParent_Done,
     /*  112907 */   // Label 1837: @112907
     /*  112907 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(112952), // Rule ID 51205 //
     /*  112912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112915 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  112915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  112918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  112932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112950 */     GIR_RootConstrainSelectedInstOperands,
     /*  112951 */     // GIR_Coverage, 51205,
     /*  112951 */     GIR_EraseRootFromParent_Done,
     /*  112952 */   // Label 1838: @112952
     /*  112952 */   GIM_Reject,
     /*  112953 */ // Label 1836: @112953
     /*  112953 */ GIM_Reject,
     /*  112954 */ // Label 1776: @112954
     /*  112954 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(113068),
     /*  112959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  112962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  112965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112977 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(113022), // Rule ID 51176 //
     /*  112982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112985 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  112988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  113002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113020 */     GIR_RootConstrainSelectedInstOperands,
     /*  113021 */     // GIR_Coverage, 51176,
     /*  113021 */     GIR_EraseRootFromParent_Done,
     /*  113022 */   // Label 1840: @113022
     /*  113022 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(113067), // Rule ID 51177 //
     /*  113027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113030 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  113033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  113047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113065 */     GIR_RootConstrainSelectedInstOperands,
     /*  113066 */     // GIR_Coverage, 51177,
     /*  113066 */     GIR_EraseRootFromParent_Done,
     /*  113067 */   // Label 1841: @113067
     /*  113067 */   GIM_Reject,
     /*  113068 */ // Label 1839: @113068
     /*  113068 */ GIM_Reject,
     /*  113069 */ // Label 1777: @113069
     /*  113069 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(113183),
     /*  113074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  113077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  113080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113092 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(113137), // Rule ID 51192 //
     /*  113097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113100 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  113103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  113117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113135 */     GIR_RootConstrainSelectedInstOperands,
     /*  113136 */     // GIR_Coverage, 51192,
     /*  113136 */     GIR_EraseRootFromParent_Done,
     /*  113137 */   // Label 1843: @113137
     /*  113137 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(113182), // Rule ID 51193 //
     /*  113142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113145 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  113148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  113162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113180 */     GIR_RootConstrainSelectedInstOperands,
     /*  113181 */     // GIR_Coverage, 51193,
     /*  113181 */     GIR_EraseRootFromParent_Done,
     /*  113182 */   // Label 1844: @113182
     /*  113182 */   GIM_Reject,
     /*  113183 */ // Label 1842: @113183
     /*  113183 */ GIM_Reject,
     /*  113184 */ // Label 1778: @113184
     /*  113184 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(113298),
     /*  113189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  113192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  113195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113207 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(113252), // Rule ID 51180 //
     /*  113212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113215 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  113218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  113232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113250 */     GIR_RootConstrainSelectedInstOperands,
     /*  113251 */     // GIR_Coverage, 51180,
     /*  113251 */     GIR_EraseRootFromParent_Done,
     /*  113252 */   // Label 1846: @113252
     /*  113252 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(113297), // Rule ID 51181 //
     /*  113257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113260 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  113263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  113277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113295 */     GIR_RootConstrainSelectedInstOperands,
     /*  113296 */     // GIR_Coverage, 51181,
     /*  113296 */     GIR_EraseRootFromParent_Done,
     /*  113297 */   // Label 1847: @113297
     /*  113297 */   GIM_Reject,
     /*  113298 */ // Label 1845: @113298
     /*  113298 */ GIM_Reject,
     /*  113299 */ // Label 1779: @113299
     /*  113299 */ GIM_Reject,
     /*  113300 */ // Label 5: @113300
     /*  113300 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1872*/ GIMT_Encode4(116078),
     /*  113311 */ /*GILLT_s32*//*Label 1848*/ GIMT_Encode4(113435),
     /*  113315 */ /*GILLT_s64*//*Label 1849*/ GIMT_Encode4(113469), GIMT_Encode4(0),
     /*  113323 */ /*GILLT_nxv1s8*//*Label 1850*/ GIMT_Encode4(113548),
     /*  113327 */ /*GILLT_nxv1s16*//*Label 1851*/ GIMT_Encode4(113663),
     /*  113331 */ /*GILLT_nxv1s32*//*Label 1852*/ GIMT_Encode4(113778),
     /*  113335 */ /*GILLT_nxv1s64*//*Label 1853*/ GIMT_Encode4(113893), GIMT_Encode4(0),
     /*  113343 */ /*GILLT_nxv2s8*//*Label 1854*/ GIMT_Encode4(114008),
     /*  113347 */ /*GILLT_nxv2s16*//*Label 1855*/ GIMT_Encode4(114123),
     /*  113351 */ /*GILLT_nxv2s32*//*Label 1856*/ GIMT_Encode4(114238),
     /*  113355 */ /*GILLT_nxv2s64*//*Label 1857*/ GIMT_Encode4(114353), GIMT_Encode4(0),
     /*  113363 */ /*GILLT_nxv4s8*//*Label 1858*/ GIMT_Encode4(114468),
     /*  113367 */ /*GILLT_nxv4s16*//*Label 1859*/ GIMT_Encode4(114583),
     /*  113371 */ /*GILLT_nxv4s32*//*Label 1860*/ GIMT_Encode4(114698),
     /*  113375 */ /*GILLT_nxv4s64*//*Label 1861*/ GIMT_Encode4(114813), GIMT_Encode4(0),
     /*  113383 */ /*GILLT_nxv8s8*//*Label 1862*/ GIMT_Encode4(114928),
     /*  113387 */ /*GILLT_nxv8s16*//*Label 1863*/ GIMT_Encode4(115043),
     /*  113391 */ /*GILLT_nxv8s32*//*Label 1864*/ GIMT_Encode4(115158),
     /*  113395 */ /*GILLT_nxv8s64*//*Label 1865*/ GIMT_Encode4(115273), GIMT_Encode4(0),
     /*  113403 */ /*GILLT_nxv16s8*//*Label 1866*/ GIMT_Encode4(115388),
     /*  113407 */ /*GILLT_nxv16s16*//*Label 1867*/ GIMT_Encode4(115503),
     /*  113411 */ /*GILLT_nxv16s32*//*Label 1868*/ GIMT_Encode4(115618), GIMT_Encode4(0),
     /*  113419 */ /*GILLT_nxv32s8*//*Label 1869*/ GIMT_Encode4(115733),
     /*  113423 */ /*GILLT_nxv32s16*//*Label 1870*/ GIMT_Encode4(115848), GIMT_Encode4(0),
     /*  113431 */ /*GILLT_nxv64s8*//*Label 1871*/ GIMT_Encode4(115963),
     /*  113435 */ // Label 1848: @113435
     /*  113435 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(113468), // Rule ID 322 //
     /*  113440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  113443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  113446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  113449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113461 */   // (srem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REM:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  113461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  113466 */   GIR_RootConstrainSelectedInstOperands,
     /*  113467 */   // GIR_Coverage, 322,
     /*  113467 */   GIR_Done,
     /*  113468 */ // Label 1873: @113468
     /*  113468 */ GIM_Reject,
     /*  113469 */ // Label 1849: @113469
     /*  113469 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(113547),
     /*  113474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  113477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113484 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(113523), // Rule ID 331 //
     /*  113489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /*  113492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /*  113499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_sexti32),
     /*  113506 */     // (srem:{ *:[i64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (REMW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::REMW),
     /*  113509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  113516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  113521 */     GIR_RootConstrainSelectedInstOperands,
     /*  113522 */     // GIR_Coverage, 331,
     /*  113522 */     GIR_EraseRootFromParent_Done,
     /*  113523 */   // Label 1875: @113523
     /*  113523 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(113546), // Rule ID 321 //
     /*  113528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  113531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113539 */     // (srem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  113544 */     GIR_RootConstrainSelectedInstOperands,
     /*  113545 */     // GIR_Coverage, 321,
     /*  113545 */     GIR_Done,
     /*  113546 */   // Label 1876: @113546
     /*  113546 */   GIM_Reject,
     /*  113547 */ // Label 1874: @113547
     /*  113547 */ GIM_Reject,
     /*  113548 */ // Label 1850: @113548
     /*  113548 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(113662),
     /*  113553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  113556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  113559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113571 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(113616), // Rule ID 51396 //
     /*  113576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113579 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  113582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  113596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113614 */     GIR_RootConstrainSelectedInstOperands,
     /*  113615 */     // GIR_Coverage, 51396,
     /*  113615 */     GIR_EraseRootFromParent_Done,
     /*  113616 */   // Label 1878: @113616
     /*  113616 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(113661), // Rule ID 51397 //
     /*  113621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113624 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  113627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  113641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113659 */     GIR_RootConstrainSelectedInstOperands,
     /*  113660 */     // GIR_Coverage, 51397,
     /*  113660 */     GIR_EraseRootFromParent_Done,
     /*  113661 */   // Label 1879: @113661
     /*  113661 */   GIM_Reject,
     /*  113662 */ // Label 1877: @113662
     /*  113662 */ GIM_Reject,
     /*  113663 */ // Label 1851: @113663
     /*  113663 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(113777),
     /*  113668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  113671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  113674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113686 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(113731), // Rule ID 51408 //
     /*  113691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113694 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  113697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  113711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113729 */     GIR_RootConstrainSelectedInstOperands,
     /*  113730 */     // GIR_Coverage, 51408,
     /*  113730 */     GIR_EraseRootFromParent_Done,
     /*  113731 */   // Label 1881: @113731
     /*  113731 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(113776), // Rule ID 51409 //
     /*  113736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113739 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  113742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  113756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113774 */     GIR_RootConstrainSelectedInstOperands,
     /*  113775 */     // GIR_Coverage, 51409,
     /*  113775 */     GIR_EraseRootFromParent_Done,
     /*  113776 */   // Label 1882: @113776
     /*  113776 */   GIM_Reject,
     /*  113777 */ // Label 1880: @113777
     /*  113777 */ GIM_Reject,
     /*  113778 */ // Label 1852: @113778
     /*  113778 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(113892),
     /*  113783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  113786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  113789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113801 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(113846), // Rule ID 51416 //
     /*  113806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113809 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  113809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  113812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  113826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113844 */     GIR_RootConstrainSelectedInstOperands,
     /*  113845 */     // GIR_Coverage, 51416,
     /*  113845 */     GIR_EraseRootFromParent_Done,
     /*  113846 */   // Label 1884: @113846
     /*  113846 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(113891), // Rule ID 51417 //
     /*  113851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113854 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  113854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  113857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  113871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113889 */     GIR_RootConstrainSelectedInstOperands,
     /*  113890 */     // GIR_Coverage, 51417,
     /*  113890 */     GIR_EraseRootFromParent_Done,
     /*  113891 */   // Label 1885: @113891
     /*  113891 */   GIM_Reject,
     /*  113892 */ // Label 1883: @113892
     /*  113892 */ GIM_Reject,
     /*  113893 */ // Label 1853: @113893
     /*  113893 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(114007),
     /*  113898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  113901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  113904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113916 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(113961), // Rule ID 51432 //
     /*  113921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  113924 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  113924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  113927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  113941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113959 */     GIR_RootConstrainSelectedInstOperands,
     /*  113960 */     // GIR_Coverage, 51432,
     /*  113960 */     GIR_EraseRootFromParent_Done,
     /*  113961 */   // Label 1887: @113961
     /*  113961 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(114006), // Rule ID 51433 //
     /*  113966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  113969 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  113969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  113972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  113986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114004 */     GIR_RootConstrainSelectedInstOperands,
     /*  114005 */     // GIR_Coverage, 51433,
     /*  114005 */     GIR_EraseRootFromParent_Done,
     /*  114006 */   // Label 1888: @114006
     /*  114006 */   GIM_Reject,
     /*  114007 */ // Label 1886: @114007
     /*  114007 */ GIM_Reject,
     /*  114008 */ // Label 1854: @114008
     /*  114008 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(114122),
     /*  114013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  114016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  114019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114031 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(114076), // Rule ID 51400 //
     /*  114036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114039 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  114042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  114056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114074 */     GIR_RootConstrainSelectedInstOperands,
     /*  114075 */     // GIR_Coverage, 51400,
     /*  114075 */     GIR_EraseRootFromParent_Done,
     /*  114076 */   // Label 1890: @114076
     /*  114076 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(114121), // Rule ID 51401 //
     /*  114081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114084 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  114087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  114101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114119 */     GIR_RootConstrainSelectedInstOperands,
     /*  114120 */     // GIR_Coverage, 51401,
     /*  114120 */     GIR_EraseRootFromParent_Done,
     /*  114121 */   // Label 1891: @114121
     /*  114121 */   GIM_Reject,
     /*  114122 */ // Label 1889: @114122
     /*  114122 */ GIM_Reject,
     /*  114123 */ // Label 1855: @114123
     /*  114123 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(114237),
     /*  114128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  114131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  114134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114146 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(114191), // Rule ID 51412 //
     /*  114151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114154 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  114157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  114171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114189 */     GIR_RootConstrainSelectedInstOperands,
     /*  114190 */     // GIR_Coverage, 51412,
     /*  114190 */     GIR_EraseRootFromParent_Done,
     /*  114191 */   // Label 1893: @114191
     /*  114191 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(114236), // Rule ID 51413 //
     /*  114196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114199 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  114202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  114216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114234 */     GIR_RootConstrainSelectedInstOperands,
     /*  114235 */     // GIR_Coverage, 51413,
     /*  114235 */     GIR_EraseRootFromParent_Done,
     /*  114236 */   // Label 1894: @114236
     /*  114236 */   GIM_Reject,
     /*  114237 */ // Label 1892: @114237
     /*  114237 */ GIM_Reject,
     /*  114238 */ // Label 1856: @114238
     /*  114238 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(114352),
     /*  114243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  114246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  114249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114261 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(114306), // Rule ID 51428 //
     /*  114266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114269 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  114269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  114272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  114286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114304 */     GIR_RootConstrainSelectedInstOperands,
     /*  114305 */     // GIR_Coverage, 51428,
     /*  114305 */     GIR_EraseRootFromParent_Done,
     /*  114306 */   // Label 1896: @114306
     /*  114306 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(114351), // Rule ID 51429 //
     /*  114311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114314 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  114314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  114317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  114331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114349 */     GIR_RootConstrainSelectedInstOperands,
     /*  114350 */     // GIR_Coverage, 51429,
     /*  114350 */     GIR_EraseRootFromParent_Done,
     /*  114351 */   // Label 1897: @114351
     /*  114351 */   GIM_Reject,
     /*  114352 */ // Label 1895: @114352
     /*  114352 */ GIM_Reject,
     /*  114353 */ // Label 1857: @114353
     /*  114353 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(114467),
     /*  114358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  114361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  114364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114376 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(114421), // Rule ID 51472 //
     /*  114381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  114384 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  114384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  114387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  114401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114419 */     GIR_RootConstrainSelectedInstOperands,
     /*  114420 */     // GIR_Coverage, 51472,
     /*  114420 */     GIR_EraseRootFromParent_Done,
     /*  114421 */   // Label 1899: @114421
     /*  114421 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(114466), // Rule ID 51473 //
     /*  114426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  114429 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  114429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  114432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  114446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114464 */     GIR_RootConstrainSelectedInstOperands,
     /*  114465 */     // GIR_Coverage, 51473,
     /*  114465 */     GIR_EraseRootFromParent_Done,
     /*  114466 */   // Label 1900: @114466
     /*  114466 */   GIM_Reject,
     /*  114467 */ // Label 1898: @114467
     /*  114467 */ GIM_Reject,
     /*  114468 */ // Label 1858: @114468
     /*  114468 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(114582),
     /*  114473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  114476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  114479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114491 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(114536), // Rule ID 51404 //
     /*  114496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114499 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  114502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  114516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114534 */     GIR_RootConstrainSelectedInstOperands,
     /*  114535 */     // GIR_Coverage, 51404,
     /*  114535 */     GIR_EraseRootFromParent_Done,
     /*  114536 */   // Label 1902: @114536
     /*  114536 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(114581), // Rule ID 51405 //
     /*  114541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114544 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  114547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  114561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114579 */     GIR_RootConstrainSelectedInstOperands,
     /*  114580 */     // GIR_Coverage, 51405,
     /*  114580 */     GIR_EraseRootFromParent_Done,
     /*  114581 */   // Label 1903: @114581
     /*  114581 */   GIM_Reject,
     /*  114582 */ // Label 1901: @114582
     /*  114582 */ GIM_Reject,
     /*  114583 */ // Label 1859: @114583
     /*  114583 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(114697),
     /*  114588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  114591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  114594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114602 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114606 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(114651), // Rule ID 51424 //
     /*  114611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114614 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  114617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  114631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114649 */     GIR_RootConstrainSelectedInstOperands,
     /*  114650 */     // GIR_Coverage, 51424,
     /*  114650 */     GIR_EraseRootFromParent_Done,
     /*  114651 */   // Label 1905: @114651
     /*  114651 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(114696), // Rule ID 51425 //
     /*  114656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114659 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  114662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  114676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114694 */     GIR_RootConstrainSelectedInstOperands,
     /*  114695 */     // GIR_Coverage, 51425,
     /*  114695 */     GIR_EraseRootFromParent_Done,
     /*  114696 */   // Label 1906: @114696
     /*  114696 */   GIM_Reject,
     /*  114697 */ // Label 1904: @114697
     /*  114697 */ GIM_Reject,
     /*  114698 */ // Label 1860: @114698
     /*  114698 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(114812),
     /*  114703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  114706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  114709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114721 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(114766), // Rule ID 51460 //
     /*  114726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114729 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  114729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  114732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  114746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114764 */     GIR_RootConstrainSelectedInstOperands,
     /*  114765 */     // GIR_Coverage, 51460,
     /*  114765 */     GIR_EraseRootFromParent_Done,
     /*  114766 */   // Label 1908: @114766
     /*  114766 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(114811), // Rule ID 51461 //
     /*  114771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114774 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  114774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  114777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  114791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114809 */     GIR_RootConstrainSelectedInstOperands,
     /*  114810 */     // GIR_Coverage, 51461,
     /*  114810 */     GIR_EraseRootFromParent_Done,
     /*  114811 */   // Label 1909: @114811
     /*  114811 */   GIM_Reject,
     /*  114812 */ // Label 1907: @114812
     /*  114812 */ GIM_Reject,
     /*  114813 */ // Label 1861: @114813
     /*  114813 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(114927),
     /*  114818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  114821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  114824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114836 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(114881), // Rule ID 51476 //
     /*  114841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  114844 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  114844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  114847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  114861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114879 */     GIR_RootConstrainSelectedInstOperands,
     /*  114880 */     // GIR_Coverage, 51476,
     /*  114880 */     GIR_EraseRootFromParent_Done,
     /*  114881 */   // Label 1911: @114881
     /*  114881 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(114926), // Rule ID 51477 //
     /*  114886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  114889 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  114889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  114892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  114906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114924 */     GIR_RootConstrainSelectedInstOperands,
     /*  114925 */     // GIR_Coverage, 51477,
     /*  114925 */     GIR_EraseRootFromParent_Done,
     /*  114926 */   // Label 1912: @114926
     /*  114926 */   GIM_Reject,
     /*  114927 */ // Label 1910: @114927
     /*  114927 */ GIM_Reject,
     /*  114928 */ // Label 1862: @114928
     /*  114928 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(115042),
     /*  114933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  114936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  114939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114947 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114951 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(114996), // Rule ID 51420 //
     /*  114956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114959 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  114962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  114976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114994 */     GIR_RootConstrainSelectedInstOperands,
     /*  114995 */     // GIR_Coverage, 51420,
     /*  114995 */     GIR_EraseRootFromParent_Done,
     /*  114996 */   // Label 1914: @114996
     /*  114996 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(115041), // Rule ID 51421 //
     /*  115001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115004 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  115007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  115021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115039 */     GIR_RootConstrainSelectedInstOperands,
     /*  115040 */     // GIR_Coverage, 51421,
     /*  115040 */     GIR_EraseRootFromParent_Done,
     /*  115041 */   // Label 1915: @115041
     /*  115041 */   GIM_Reject,
     /*  115042 */ // Label 1913: @115042
     /*  115042 */ GIM_Reject,
     /*  115043 */ // Label 1863: @115043
     /*  115043 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(115157),
     /*  115048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  115051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  115054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  115058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  115062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  115066 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(115111), // Rule ID 51448 //
     /*  115071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115074 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  115077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  115091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115109 */     GIR_RootConstrainSelectedInstOperands,
     /*  115110 */     // GIR_Coverage, 51448,
     /*  115110 */     GIR_EraseRootFromParent_Done,
     /*  115111 */   // Label 1917: @115111
     /*  115111 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(115156), // Rule ID 51449 //
     /*  115116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115119 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  115122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  115136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115154 */     GIR_RootConstrainSelectedInstOperands,
     /*  115155 */     // GIR_Coverage, 51449,
     /*  115155 */     GIR_EraseRootFromParent_Done,
     /*  115156 */   // Label 1918: @115156
     /*  115156 */   GIM_Reject,
     /*  115157 */ // Label 1916: @115157
     /*  115157 */ GIM_Reject,
     /*  115158 */ // Label 1864: @115158
     /*  115158 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(115272),
     /*  115163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  115166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  115169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115181 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(115226), // Rule ID 51464 //
     /*  115186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115189 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  115189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  115192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  115206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115224 */     GIR_RootConstrainSelectedInstOperands,
     /*  115225 */     // GIR_Coverage, 51464,
     /*  115225 */     GIR_EraseRootFromParent_Done,
     /*  115226 */   // Label 1920: @115226
     /*  115226 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(115271), // Rule ID 51465 //
     /*  115231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115234 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  115234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  115237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  115251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115269 */     GIR_RootConstrainSelectedInstOperands,
     /*  115270 */     // GIR_Coverage, 51465,
     /*  115270 */     GIR_EraseRootFromParent_Done,
     /*  115271 */   // Label 1921: @115271
     /*  115271 */   GIM_Reject,
     /*  115272 */ // Label 1919: @115272
     /*  115272 */ GIM_Reject,
     /*  115273 */ // Label 1865: @115273
     /*  115273 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(115387),
     /*  115278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  115281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  115284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115296 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(115341), // Rule ID 51480 //
     /*  115301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  115304 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  115304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  115307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  115321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  115336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115339 */     GIR_RootConstrainSelectedInstOperands,
     /*  115340 */     // GIR_Coverage, 51480,
     /*  115340 */     GIR_EraseRootFromParent_Done,
     /*  115341 */   // Label 1923: @115341
     /*  115341 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(115386), // Rule ID 51481 //
     /*  115346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  115349 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  115349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  115352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  115366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  115381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115384 */     GIR_RootConstrainSelectedInstOperands,
     /*  115385 */     // GIR_Coverage, 51481,
     /*  115385 */     GIR_EraseRootFromParent_Done,
     /*  115386 */   // Label 1924: @115386
     /*  115386 */   GIM_Reject,
     /*  115387 */ // Label 1922: @115387
     /*  115387 */ GIM_Reject,
     /*  115388 */ // Label 1866: @115388
     /*  115388 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(115502),
     /*  115393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  115396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  115399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  115403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  115407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  115411 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(115456), // Rule ID 51436 //
     /*  115416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115419 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  115422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  115436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115454 */     GIR_RootConstrainSelectedInstOperands,
     /*  115455 */     // GIR_Coverage, 51436,
     /*  115455 */     GIR_EraseRootFromParent_Done,
     /*  115456 */   // Label 1926: @115456
     /*  115456 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(115501), // Rule ID 51437 //
     /*  115461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115464 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  115467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  115481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115499 */     GIR_RootConstrainSelectedInstOperands,
     /*  115500 */     // GIR_Coverage, 51437,
     /*  115500 */     GIR_EraseRootFromParent_Done,
     /*  115501 */   // Label 1927: @115501
     /*  115501 */   GIM_Reject,
     /*  115502 */ // Label 1925: @115502
     /*  115502 */ GIM_Reject,
     /*  115503 */ // Label 1867: @115503
     /*  115503 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(115617),
     /*  115508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  115511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  115514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115526 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(115571), // Rule ID 51452 //
     /*  115531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115534 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  115537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  115551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115569 */     GIR_RootConstrainSelectedInstOperands,
     /*  115570 */     // GIR_Coverage, 51452,
     /*  115570 */     GIR_EraseRootFromParent_Done,
     /*  115571 */   // Label 1929: @115571
     /*  115571 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(115616), // Rule ID 51453 //
     /*  115576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115579 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  115582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  115596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115614 */     GIR_RootConstrainSelectedInstOperands,
     /*  115615 */     // GIR_Coverage, 51453,
     /*  115615 */     GIR_EraseRootFromParent_Done,
     /*  115616 */   // Label 1930: @115616
     /*  115616 */   GIM_Reject,
     /*  115617 */ // Label 1928: @115617
     /*  115617 */ GIM_Reject,
     /*  115618 */ // Label 1868: @115618
     /*  115618 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(115732),
     /*  115623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  115626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  115629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115641 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(115686), // Rule ID 51468 //
     /*  115646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115649 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  115649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  115652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  115666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115684 */     GIR_RootConstrainSelectedInstOperands,
     /*  115685 */     // GIR_Coverage, 51468,
     /*  115685 */     GIR_EraseRootFromParent_Done,
     /*  115686 */   // Label 1932: @115686
     /*  115686 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(115731), // Rule ID 51469 //
     /*  115691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115694 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  115694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  115697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  115711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115729 */     GIR_RootConstrainSelectedInstOperands,
     /*  115730 */     // GIR_Coverage, 51469,
     /*  115730 */     GIR_EraseRootFromParent_Done,
     /*  115731 */   // Label 1933: @115731
     /*  115731 */   GIM_Reject,
     /*  115732 */ // Label 1931: @115732
     /*  115732 */ GIM_Reject,
     /*  115733 */ // Label 1869: @115733
     /*  115733 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(115847),
     /*  115738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  115741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  115744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115756 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(115801), // Rule ID 51440 //
     /*  115761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115764 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  115767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  115781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115799 */     GIR_RootConstrainSelectedInstOperands,
     /*  115800 */     // GIR_Coverage, 51440,
     /*  115800 */     GIR_EraseRootFromParent_Done,
     /*  115801 */   // Label 1935: @115801
     /*  115801 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(115846), // Rule ID 51441 //
     /*  115806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115809 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  115812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  115826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115844 */     GIR_RootConstrainSelectedInstOperands,
     /*  115845 */     // GIR_Coverage, 51441,
     /*  115845 */     GIR_EraseRootFromParent_Done,
     /*  115846 */   // Label 1936: @115846
     /*  115846 */   GIM_Reject,
     /*  115847 */ // Label 1934: @115847
     /*  115847 */ GIM_Reject,
     /*  115848 */ // Label 1870: @115848
     /*  115848 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(115962),
     /*  115853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  115856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  115859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115871 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(115916), // Rule ID 51456 //
     /*  115876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115879 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  115882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  115896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115914 */     GIR_RootConstrainSelectedInstOperands,
     /*  115915 */     // GIR_Coverage, 51456,
     /*  115915 */     GIR_EraseRootFromParent_Done,
     /*  115916 */   // Label 1938: @115916
     /*  115916 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(115961), // Rule ID 51457 //
     /*  115921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115924 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  115927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  115941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115959 */     GIR_RootConstrainSelectedInstOperands,
     /*  115960 */     // GIR_Coverage, 51457,
     /*  115960 */     GIR_EraseRootFromParent_Done,
     /*  115961 */   // Label 1939: @115961
     /*  115961 */   GIM_Reject,
     /*  115962 */ // Label 1937: @115962
     /*  115962 */ GIM_Reject,
     /*  115963 */ // Label 1871: @115963
     /*  115963 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(116077),
     /*  115968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  115971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  115974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115986 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(116031), // Rule ID 51444 //
     /*  115991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115994 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  115997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  116011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116029 */     GIR_RootConstrainSelectedInstOperands,
     /*  116030 */     // GIR_Coverage, 51444,
     /*  116030 */     GIR_EraseRootFromParent_Done,
     /*  116031 */   // Label 1941: @116031
     /*  116031 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(116076), // Rule ID 51445 //
     /*  116036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116039 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  116042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  116056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116074 */     GIR_RootConstrainSelectedInstOperands,
     /*  116075 */     // GIR_Coverage, 51445,
     /*  116075 */     GIR_EraseRootFromParent_Done,
     /*  116076 */   // Label 1942: @116076
     /*  116076 */   GIM_Reject,
     /*  116077 */ // Label 1940: @116077
     /*  116077 */ GIM_Reject,
     /*  116078 */ // Label 1872: @116078
     /*  116078 */ GIM_Reject,
     /*  116079 */ // Label 6: @116079
     /*  116079 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1967*/ GIMT_Encode4(118812),
     /*  116090 */ /*GILLT_s32*//*Label 1943*/ GIMT_Encode4(116214),
     /*  116094 */ /*GILLT_s64*//*Label 1944*/ GIMT_Encode4(116248), GIMT_Encode4(0),
     /*  116102 */ /*GILLT_nxv1s8*//*Label 1945*/ GIMT_Encode4(116282),
     /*  116106 */ /*GILLT_nxv1s16*//*Label 1946*/ GIMT_Encode4(116397),
     /*  116110 */ /*GILLT_nxv1s32*//*Label 1947*/ GIMT_Encode4(116512),
     /*  116114 */ /*GILLT_nxv1s64*//*Label 1948*/ GIMT_Encode4(116627), GIMT_Encode4(0),
     /*  116122 */ /*GILLT_nxv2s8*//*Label 1949*/ GIMT_Encode4(116742),
     /*  116126 */ /*GILLT_nxv2s16*//*Label 1950*/ GIMT_Encode4(116857),
     /*  116130 */ /*GILLT_nxv2s32*//*Label 1951*/ GIMT_Encode4(116972),
     /*  116134 */ /*GILLT_nxv2s64*//*Label 1952*/ GIMT_Encode4(117087), GIMT_Encode4(0),
     /*  116142 */ /*GILLT_nxv4s8*//*Label 1953*/ GIMT_Encode4(117202),
     /*  116146 */ /*GILLT_nxv4s16*//*Label 1954*/ GIMT_Encode4(117317),
     /*  116150 */ /*GILLT_nxv4s32*//*Label 1955*/ GIMT_Encode4(117432),
     /*  116154 */ /*GILLT_nxv4s64*//*Label 1956*/ GIMT_Encode4(117547), GIMT_Encode4(0),
     /*  116162 */ /*GILLT_nxv8s8*//*Label 1957*/ GIMT_Encode4(117662),
     /*  116166 */ /*GILLT_nxv8s16*//*Label 1958*/ GIMT_Encode4(117777),
     /*  116170 */ /*GILLT_nxv8s32*//*Label 1959*/ GIMT_Encode4(117892),
     /*  116174 */ /*GILLT_nxv8s64*//*Label 1960*/ GIMT_Encode4(118007), GIMT_Encode4(0),
     /*  116182 */ /*GILLT_nxv16s8*//*Label 1961*/ GIMT_Encode4(118122),
     /*  116186 */ /*GILLT_nxv16s16*//*Label 1962*/ GIMT_Encode4(118237),
     /*  116190 */ /*GILLT_nxv16s32*//*Label 1963*/ GIMT_Encode4(118352), GIMT_Encode4(0),
     /*  116198 */ /*GILLT_nxv32s8*//*Label 1964*/ GIMT_Encode4(118467),
     /*  116202 */ /*GILLT_nxv32s16*//*Label 1965*/ GIMT_Encode4(118582), GIMT_Encode4(0),
     /*  116210 */ /*GILLT_nxv64s8*//*Label 1966*/ GIMT_Encode4(118697),
     /*  116214 */ // Label 1943: @116214
     /*  116214 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(116247), // Rule ID 324 //
     /*  116219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  116222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  116225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  116228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116240 */   // (urem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REMU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  116240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  116245 */   GIR_RootConstrainSelectedInstOperands,
     /*  116246 */   // GIR_Coverage, 324,
     /*  116246 */   GIR_Done,
     /*  116247 */ // Label 1968: @116247
     /*  116247 */ GIM_Reject,
     /*  116248 */ // Label 1944: @116248
     /*  116248 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(116281), // Rule ID 323 //
     /*  116253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  116256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  116259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  116262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116274 */   // (urem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  116274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  116279 */   GIR_RootConstrainSelectedInstOperands,
     /*  116280 */   // GIR_Coverage, 323,
     /*  116280 */   GIR_Done,
     /*  116281 */ // Label 1969: @116281
     /*  116281 */ GIM_Reject,
     /*  116282 */ // Label 1945: @116282
     /*  116282 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(116396),
     /*  116287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  116290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  116293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116305 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(116350), // Rule ID 51308 //
     /*  116310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116313 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  116313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  116316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  116330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116348 */     GIR_RootConstrainSelectedInstOperands,
     /*  116349 */     // GIR_Coverage, 51308,
     /*  116349 */     GIR_EraseRootFromParent_Done,
     /*  116350 */   // Label 1971: @116350
     /*  116350 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(116395), // Rule ID 51309 //
     /*  116355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116358 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  116361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  116375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116393 */     GIR_RootConstrainSelectedInstOperands,
     /*  116394 */     // GIR_Coverage, 51309,
     /*  116394 */     GIR_EraseRootFromParent_Done,
     /*  116395 */   // Label 1972: @116395
     /*  116395 */   GIM_Reject,
     /*  116396 */ // Label 1970: @116396
     /*  116396 */ GIM_Reject,
     /*  116397 */ // Label 1946: @116397
     /*  116397 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(116511),
     /*  116402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  116405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  116408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116420 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(116465), // Rule ID 51320 //
     /*  116425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116428 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  116428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  116431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  116445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116463 */     GIR_RootConstrainSelectedInstOperands,
     /*  116464 */     // GIR_Coverage, 51320,
     /*  116464 */     GIR_EraseRootFromParent_Done,
     /*  116465 */   // Label 1974: @116465
     /*  116465 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(116510), // Rule ID 51321 //
     /*  116470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116473 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  116476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  116490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116508 */     GIR_RootConstrainSelectedInstOperands,
     /*  116509 */     // GIR_Coverage, 51321,
     /*  116509 */     GIR_EraseRootFromParent_Done,
     /*  116510 */   // Label 1975: @116510
     /*  116510 */   GIM_Reject,
     /*  116511 */ // Label 1973: @116511
     /*  116511 */ GIM_Reject,
     /*  116512 */ // Label 1947: @116512
     /*  116512 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(116626),
     /*  116517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  116520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  116523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116535 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(116580), // Rule ID 51328 //
     /*  116540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116543 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  116546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  116560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116578 */     GIR_RootConstrainSelectedInstOperands,
     /*  116579 */     // GIR_Coverage, 51328,
     /*  116579 */     GIR_EraseRootFromParent_Done,
     /*  116580 */   // Label 1977: @116580
     /*  116580 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(116625), // Rule ID 51329 //
     /*  116585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116588 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  116588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  116591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  116605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116623 */     GIR_RootConstrainSelectedInstOperands,
     /*  116624 */     // GIR_Coverage, 51329,
     /*  116624 */     GIR_EraseRootFromParent_Done,
     /*  116625 */   // Label 1978: @116625
     /*  116625 */   GIM_Reject,
     /*  116626 */ // Label 1976: @116626
     /*  116626 */ GIM_Reject,
     /*  116627 */ // Label 1948: @116627
     /*  116627 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(116741),
     /*  116632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  116635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  116638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116650 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(116695), // Rule ID 51344 //
     /*  116655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  116658 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  116658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  116661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  116675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116693 */     GIR_RootConstrainSelectedInstOperands,
     /*  116694 */     // GIR_Coverage, 51344,
     /*  116694 */     GIR_EraseRootFromParent_Done,
     /*  116695 */   // Label 1980: @116695
     /*  116695 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(116740), // Rule ID 51345 //
     /*  116700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  116703 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  116703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  116706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  116720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116738 */     GIR_RootConstrainSelectedInstOperands,
     /*  116739 */     // GIR_Coverage, 51345,
     /*  116739 */     GIR_EraseRootFromParent_Done,
     /*  116740 */   // Label 1981: @116740
     /*  116740 */   GIM_Reject,
     /*  116741 */ // Label 1979: @116741
     /*  116741 */ GIM_Reject,
     /*  116742 */ // Label 1949: @116742
     /*  116742 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(116856),
     /*  116747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  116750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  116753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116765 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(116810), // Rule ID 51312 //
     /*  116770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116773 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  116773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  116776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  116790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116808 */     GIR_RootConstrainSelectedInstOperands,
     /*  116809 */     // GIR_Coverage, 51312,
     /*  116809 */     GIR_EraseRootFromParent_Done,
     /*  116810 */   // Label 1983: @116810
     /*  116810 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(116855), // Rule ID 51313 //
     /*  116815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116818 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  116821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  116835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116853 */     GIR_RootConstrainSelectedInstOperands,
     /*  116854 */     // GIR_Coverage, 51313,
     /*  116854 */     GIR_EraseRootFromParent_Done,
     /*  116855 */   // Label 1984: @116855
     /*  116855 */   GIM_Reject,
     /*  116856 */ // Label 1982: @116856
     /*  116856 */ GIM_Reject,
     /*  116857 */ // Label 1950: @116857
     /*  116857 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(116971),
     /*  116862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  116865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  116868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116880 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(116925), // Rule ID 51324 //
     /*  116885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116888 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  116888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  116891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  116905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116923 */     GIR_RootConstrainSelectedInstOperands,
     /*  116924 */     // GIR_Coverage, 51324,
     /*  116924 */     GIR_EraseRootFromParent_Done,
     /*  116925 */   // Label 1986: @116925
     /*  116925 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(116970), // Rule ID 51325 //
     /*  116930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116933 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  116936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  116950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116968 */     GIR_RootConstrainSelectedInstOperands,
     /*  116969 */     // GIR_Coverage, 51325,
     /*  116969 */     GIR_EraseRootFromParent_Done,
     /*  116970 */   // Label 1987: @116970
     /*  116970 */   GIM_Reject,
     /*  116971 */ // Label 1985: @116971
     /*  116971 */ GIM_Reject,
     /*  116972 */ // Label 1951: @116972
     /*  116972 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(117086),
     /*  116977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  116980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  116983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116995 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(117040), // Rule ID 51340 //
     /*  117000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117003 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  117006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  117020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117038 */     GIR_RootConstrainSelectedInstOperands,
     /*  117039 */     // GIR_Coverage, 51340,
     /*  117039 */     GIR_EraseRootFromParent_Done,
     /*  117040 */   // Label 1989: @117040
     /*  117040 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(117085), // Rule ID 51341 //
     /*  117045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117048 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  117051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  117065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117083 */     GIR_RootConstrainSelectedInstOperands,
     /*  117084 */     // GIR_Coverage, 51341,
     /*  117084 */     GIR_EraseRootFromParent_Done,
     /*  117085 */   // Label 1990: @117085
     /*  117085 */   GIM_Reject,
     /*  117086 */ // Label 1988: @117086
     /*  117086 */ GIM_Reject,
     /*  117087 */ // Label 1952: @117087
     /*  117087 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(117201),
     /*  117092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  117095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  117098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117106 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117110 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(117155), // Rule ID 51384 //
     /*  117115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117118 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  117121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  117135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117153 */     GIR_RootConstrainSelectedInstOperands,
     /*  117154 */     // GIR_Coverage, 51384,
     /*  117154 */     GIR_EraseRootFromParent_Done,
     /*  117155 */   // Label 1992: @117155
     /*  117155 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(117200), // Rule ID 51385 //
     /*  117160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117163 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  117166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  117180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117198 */     GIR_RootConstrainSelectedInstOperands,
     /*  117199 */     // GIR_Coverage, 51385,
     /*  117199 */     GIR_EraseRootFromParent_Done,
     /*  117200 */   // Label 1993: @117200
     /*  117200 */   GIM_Reject,
     /*  117201 */ // Label 1991: @117201
     /*  117201 */ GIM_Reject,
     /*  117202 */ // Label 1953: @117202
     /*  117202 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(117316),
     /*  117207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  117210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  117213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117225 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(117270), // Rule ID 51316 //
     /*  117230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117233 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  117236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  117250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117268 */     GIR_RootConstrainSelectedInstOperands,
     /*  117269 */     // GIR_Coverage, 51316,
     /*  117269 */     GIR_EraseRootFromParent_Done,
     /*  117270 */   // Label 1995: @117270
     /*  117270 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(117315), // Rule ID 51317 //
     /*  117275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117278 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  117281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  117295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117313 */     GIR_RootConstrainSelectedInstOperands,
     /*  117314 */     // GIR_Coverage, 51317,
     /*  117314 */     GIR_EraseRootFromParent_Done,
     /*  117315 */   // Label 1996: @117315
     /*  117315 */   GIM_Reject,
     /*  117316 */ // Label 1994: @117316
     /*  117316 */ GIM_Reject,
     /*  117317 */ // Label 1954: @117317
     /*  117317 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(117431),
     /*  117322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  117325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  117328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117336 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117340 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(117385), // Rule ID 51336 //
     /*  117345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117348 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  117351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  117365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117383 */     GIR_RootConstrainSelectedInstOperands,
     /*  117384 */     // GIR_Coverage, 51336,
     /*  117384 */     GIR_EraseRootFromParent_Done,
     /*  117385 */   // Label 1998: @117385
     /*  117385 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(117430), // Rule ID 51337 //
     /*  117390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117393 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  117396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  117410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117428 */     GIR_RootConstrainSelectedInstOperands,
     /*  117429 */     // GIR_Coverage, 51337,
     /*  117429 */     GIR_EraseRootFromParent_Done,
     /*  117430 */   // Label 1999: @117430
     /*  117430 */   GIM_Reject,
     /*  117431 */ // Label 1997: @117431
     /*  117431 */ GIM_Reject,
     /*  117432 */ // Label 1955: @117432
     /*  117432 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(117546),
     /*  117437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  117440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  117443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117451 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117455 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(117500), // Rule ID 51372 //
     /*  117460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117463 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  117466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  117480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117498 */     GIR_RootConstrainSelectedInstOperands,
     /*  117499 */     // GIR_Coverage, 51372,
     /*  117499 */     GIR_EraseRootFromParent_Done,
     /*  117500 */   // Label 2001: @117500
     /*  117500 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(117545), // Rule ID 51373 //
     /*  117505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117508 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  117511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  117525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117543 */     GIR_RootConstrainSelectedInstOperands,
     /*  117544 */     // GIR_Coverage, 51373,
     /*  117544 */     GIR_EraseRootFromParent_Done,
     /*  117545 */   // Label 2002: @117545
     /*  117545 */   GIM_Reject,
     /*  117546 */ // Label 2000: @117546
     /*  117546 */ GIM_Reject,
     /*  117547 */ // Label 1956: @117547
     /*  117547 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(117661),
     /*  117552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  117555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  117558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117570 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(117615), // Rule ID 51388 //
     /*  117575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117578 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  117581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  117595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117613 */     GIR_RootConstrainSelectedInstOperands,
     /*  117614 */     // GIR_Coverage, 51388,
     /*  117614 */     GIR_EraseRootFromParent_Done,
     /*  117615 */   // Label 2004: @117615
     /*  117615 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(117660), // Rule ID 51389 //
     /*  117620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117623 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  117626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  117640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117658 */     GIR_RootConstrainSelectedInstOperands,
     /*  117659 */     // GIR_Coverage, 51389,
     /*  117659 */     GIR_EraseRootFromParent_Done,
     /*  117660 */   // Label 2005: @117660
     /*  117660 */   GIM_Reject,
     /*  117661 */ // Label 2003: @117661
     /*  117661 */ GIM_Reject,
     /*  117662 */ // Label 1957: @117662
     /*  117662 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(117776),
     /*  117667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  117670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  117673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117685 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(117730), // Rule ID 51332 //
     /*  117690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117693 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  117696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  117710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117728 */     GIR_RootConstrainSelectedInstOperands,
     /*  117729 */     // GIR_Coverage, 51332,
     /*  117729 */     GIR_EraseRootFromParent_Done,
     /*  117730 */   // Label 2007: @117730
     /*  117730 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(117775), // Rule ID 51333 //
     /*  117735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117738 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  117741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  117755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117773 */     GIR_RootConstrainSelectedInstOperands,
     /*  117774 */     // GIR_Coverage, 51333,
     /*  117774 */     GIR_EraseRootFromParent_Done,
     /*  117775 */   // Label 2008: @117775
     /*  117775 */   GIM_Reject,
     /*  117776 */ // Label 2006: @117776
     /*  117776 */ GIM_Reject,
     /*  117777 */ // Label 1958: @117777
     /*  117777 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(117891),
     /*  117782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  117785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  117788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117800 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(117845), // Rule ID 51360 //
     /*  117805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117808 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  117811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  117825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117843 */     GIR_RootConstrainSelectedInstOperands,
     /*  117844 */     // GIR_Coverage, 51360,
     /*  117844 */     GIR_EraseRootFromParent_Done,
     /*  117845 */   // Label 2010: @117845
     /*  117845 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(117890), // Rule ID 51361 //
     /*  117850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117853 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  117856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  117870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117888 */     GIR_RootConstrainSelectedInstOperands,
     /*  117889 */     // GIR_Coverage, 51361,
     /*  117889 */     GIR_EraseRootFromParent_Done,
     /*  117890 */   // Label 2011: @117890
     /*  117890 */   GIM_Reject,
     /*  117891 */ // Label 2009: @117891
     /*  117891 */ GIM_Reject,
     /*  117892 */ // Label 1959: @117892
     /*  117892 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(118006),
     /*  117897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  117900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  117903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117915 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(117960), // Rule ID 51376 //
     /*  117920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117923 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  117926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  117940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117958 */     GIR_RootConstrainSelectedInstOperands,
     /*  117959 */     // GIR_Coverage, 51376,
     /*  117959 */     GIR_EraseRootFromParent_Done,
     /*  117960 */   // Label 2013: @117960
     /*  117960 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(118005), // Rule ID 51377 //
     /*  117965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117968 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  117971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  117985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  118000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118003 */     GIR_RootConstrainSelectedInstOperands,
     /*  118004 */     // GIR_Coverage, 51377,
     /*  118004 */     GIR_EraseRootFromParent_Done,
     /*  118005 */   // Label 2014: @118005
     /*  118005 */   GIM_Reject,
     /*  118006 */ // Label 2012: @118006
     /*  118006 */ GIM_Reject,
     /*  118007 */ // Label 1960: @118007
     /*  118007 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(118121),
     /*  118012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  118015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  118018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118030 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(118075), // Rule ID 51392 //
     /*  118035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  118038 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  118038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  118041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  118055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  118070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118073 */     GIR_RootConstrainSelectedInstOperands,
     /*  118074 */     // GIR_Coverage, 51392,
     /*  118074 */     GIR_EraseRootFromParent_Done,
     /*  118075 */   // Label 2016: @118075
     /*  118075 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(118120), // Rule ID 51393 //
     /*  118080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  118083 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  118083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  118086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  118100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  118115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118118 */     GIR_RootConstrainSelectedInstOperands,
     /*  118119 */     // GIR_Coverage, 51393,
     /*  118119 */     GIR_EraseRootFromParent_Done,
     /*  118120 */   // Label 2017: @118120
     /*  118120 */   GIM_Reject,
     /*  118121 */ // Label 2015: @118121
     /*  118121 */ GIM_Reject,
     /*  118122 */ // Label 1961: @118122
     /*  118122 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(118236),
     /*  118127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  118130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  118133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  118137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  118141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  118145 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(118190), // Rule ID 51348 //
     /*  118150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118153 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  118156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  118170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118188 */     GIR_RootConstrainSelectedInstOperands,
     /*  118189 */     // GIR_Coverage, 51348,
     /*  118189 */     GIR_EraseRootFromParent_Done,
     /*  118190 */   // Label 2019: @118190
     /*  118190 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(118235), // Rule ID 51349 //
     /*  118195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118198 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  118201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  118215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118233 */     GIR_RootConstrainSelectedInstOperands,
     /*  118234 */     // GIR_Coverage, 51349,
     /*  118234 */     GIR_EraseRootFromParent_Done,
     /*  118235 */   // Label 2020: @118235
     /*  118235 */   GIM_Reject,
     /*  118236 */ // Label 2018: @118236
     /*  118236 */ GIM_Reject,
     /*  118237 */ // Label 1962: @118237
     /*  118237 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(118351),
     /*  118242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  118245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  118248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118260 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(118305), // Rule ID 51364 //
     /*  118265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118268 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  118268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  118271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  118285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118303 */     GIR_RootConstrainSelectedInstOperands,
     /*  118304 */     // GIR_Coverage, 51364,
     /*  118304 */     GIR_EraseRootFromParent_Done,
     /*  118305 */   // Label 2022: @118305
     /*  118305 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(118350), // Rule ID 51365 //
     /*  118310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118313 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  118313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  118316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  118330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118348 */     GIR_RootConstrainSelectedInstOperands,
     /*  118349 */     // GIR_Coverage, 51365,
     /*  118349 */     GIR_EraseRootFromParent_Done,
     /*  118350 */   // Label 2023: @118350
     /*  118350 */   GIM_Reject,
     /*  118351 */ // Label 2021: @118351
     /*  118351 */ GIM_Reject,
     /*  118352 */ // Label 1963: @118352
     /*  118352 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(118466),
     /*  118357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  118360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  118363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118375 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(118420), // Rule ID 51380 //
     /*  118380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118383 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  118383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  118386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  118400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  118415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118418 */     GIR_RootConstrainSelectedInstOperands,
     /*  118419 */     // GIR_Coverage, 51380,
     /*  118419 */     GIR_EraseRootFromParent_Done,
     /*  118420 */   // Label 2025: @118420
     /*  118420 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(118465), // Rule ID 51381 //
     /*  118425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118428 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  118428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  118431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  118445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  118460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118463 */     GIR_RootConstrainSelectedInstOperands,
     /*  118464 */     // GIR_Coverage, 51381,
     /*  118464 */     GIR_EraseRootFromParent_Done,
     /*  118465 */   // Label 2026: @118465
     /*  118465 */   GIM_Reject,
     /*  118466 */ // Label 2024: @118466
     /*  118466 */ GIM_Reject,
     /*  118467 */ // Label 1964: @118467
     /*  118467 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(118581),
     /*  118472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  118475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  118478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118490 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(118535), // Rule ID 51352 //
     /*  118495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118498 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  118501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  118515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118533 */     GIR_RootConstrainSelectedInstOperands,
     /*  118534 */     // GIR_Coverage, 51352,
     /*  118534 */     GIR_EraseRootFromParent_Done,
     /*  118535 */   // Label 2028: @118535
     /*  118535 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(118580), // Rule ID 51353 //
     /*  118540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118543 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  118546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  118560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118578 */     GIR_RootConstrainSelectedInstOperands,
     /*  118579 */     // GIR_Coverage, 51353,
     /*  118579 */     GIR_EraseRootFromParent_Done,
     /*  118580 */   // Label 2029: @118580
     /*  118580 */   GIM_Reject,
     /*  118581 */ // Label 2027: @118581
     /*  118581 */ GIM_Reject,
     /*  118582 */ // Label 1965: @118582
     /*  118582 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(118696),
     /*  118587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  118590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  118593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118605 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(118650), // Rule ID 51368 //
     /*  118610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118613 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  118613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  118616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  118630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118648 */     GIR_RootConstrainSelectedInstOperands,
     /*  118649 */     // GIR_Coverage, 51368,
     /*  118649 */     GIR_EraseRootFromParent_Done,
     /*  118650 */   // Label 2031: @118650
     /*  118650 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(118695), // Rule ID 51369 //
     /*  118655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118658 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  118658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  118661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  118675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118693 */     GIR_RootConstrainSelectedInstOperands,
     /*  118694 */     // GIR_Coverage, 51369,
     /*  118694 */     GIR_EraseRootFromParent_Done,
     /*  118695 */   // Label 2032: @118695
     /*  118695 */   GIM_Reject,
     /*  118696 */ // Label 2030: @118696
     /*  118696 */ GIM_Reject,
     /*  118697 */ // Label 1966: @118697
     /*  118697 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(118811),
     /*  118702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  118705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  118708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118720 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(118765), // Rule ID 51356 //
     /*  118725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118728 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  118731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  118745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118763 */     GIR_RootConstrainSelectedInstOperands,
     /*  118764 */     // GIR_Coverage, 51356,
     /*  118764 */     GIR_EraseRootFromParent_Done,
     /*  118765 */   // Label 2034: @118765
     /*  118765 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(118810), // Rule ID 51357 //
     /*  118770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118773 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  118776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  118790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118808 */     GIR_RootConstrainSelectedInstOperands,
     /*  118809 */     // GIR_Coverage, 51357,
     /*  118809 */     GIR_EraseRootFromParent_Done,
     /*  118810 */   // Label 2035: @118810
     /*  118810 */   GIM_Reject,
     /*  118811 */ // Label 2033: @118811
     /*  118811 */ GIM_Reject,
     /*  118812 */ // Label 1967: @118812
     /*  118812 */ GIM_Reject,
     /*  118813 */ // Label 7: @118813
     /*  118813 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2067*/ GIMT_Encode4(128770),
     /*  118824 */ /*GILLT_s32*//*Label 2036*/ GIMT_Encode4(118948),
     /*  118828 */ /*GILLT_s64*//*Label 2037*/ GIMT_Encode4(120642),
     /*  118832 */ /*GILLT_nxv1s1*//*Label 2038*/ GIMT_Encode4(121963),
     /*  118836 */ /*GILLT_nxv1s8*//*Label 2039*/ GIMT_Encode4(122574),
     /*  118840 */ /*GILLT_nxv1s16*//*Label 2040*/ GIMT_Encode4(122689),
     /*  118844 */ /*GILLT_nxv1s32*//*Label 2041*/ GIMT_Encode4(122804),
     /*  118848 */ /*GILLT_nxv1s64*//*Label 2042*/ GIMT_Encode4(122919),
     /*  118852 */ /*GILLT_nxv2s1*//*Label 2043*/ GIMT_Encode4(123034),
     /*  118856 */ /*GILLT_nxv2s8*//*Label 2044*/ GIMT_Encode4(123645),
     /*  118860 */ /*GILLT_nxv2s16*//*Label 2045*/ GIMT_Encode4(123760),
     /*  118864 */ /*GILLT_nxv2s32*//*Label 2046*/ GIMT_Encode4(123875),
     /*  118868 */ /*GILLT_nxv2s64*//*Label 2047*/ GIMT_Encode4(123990),
     /*  118872 */ /*GILLT_nxv4s1*//*Label 2048*/ GIMT_Encode4(124105),
     /*  118876 */ /*GILLT_nxv4s8*//*Label 2049*/ GIMT_Encode4(124716),
     /*  118880 */ /*GILLT_nxv4s16*//*Label 2050*/ GIMT_Encode4(124831),
     /*  118884 */ /*GILLT_nxv4s32*//*Label 2051*/ GIMT_Encode4(124946),
     /*  118888 */ /*GILLT_nxv4s64*//*Label 2052*/ GIMT_Encode4(125061),
     /*  118892 */ /*GILLT_nxv8s1*//*Label 2053*/ GIMT_Encode4(125176),
     /*  118896 */ /*GILLT_nxv8s8*//*Label 2054*/ GIMT_Encode4(125787),
     /*  118900 */ /*GILLT_nxv8s16*//*Label 2055*/ GIMT_Encode4(125902),
     /*  118904 */ /*GILLT_nxv8s32*//*Label 2056*/ GIMT_Encode4(126017),
     /*  118908 */ /*GILLT_nxv8s64*//*Label 2057*/ GIMT_Encode4(126132),
     /*  118912 */ /*GILLT_nxv16s1*//*Label 2058*/ GIMT_Encode4(126247),
     /*  118916 */ /*GILLT_nxv16s8*//*Label 2059*/ GIMT_Encode4(126858),
     /*  118920 */ /*GILLT_nxv16s16*//*Label 2060*/ GIMT_Encode4(126973),
     /*  118924 */ /*GILLT_nxv16s32*//*Label 2061*/ GIMT_Encode4(127088),
     /*  118928 */ /*GILLT_nxv32s1*//*Label 2062*/ GIMT_Encode4(127203),
     /*  118932 */ /*GILLT_nxv32s8*//*Label 2063*/ GIMT_Encode4(127814),
     /*  118936 */ /*GILLT_nxv32s16*//*Label 2064*/ GIMT_Encode4(127929),
     /*  118940 */ /*GILLT_nxv64s1*//*Label 2065*/ GIMT_Encode4(128044),
     /*  118944 */ /*GILLT_nxv64s8*//*Label 2066*/ GIMT_Encode4(128655),
     /*  118948 */ // Label 2036: @118948
     /*  118948 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(120641),
     /*  118953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  118956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  118959 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(119048), // Rule ID 65574 //
     /*  118964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  118967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  118979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  119003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119008 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  119012 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  119032 */     // (and:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] })), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  119035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  119042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  119046 */     GIR_RootConstrainSelectedInstOperands,
     /*  119047 */     // GIR_Coverage, 65574,
     /*  119047 */     GIR_EraseRootFromParent_Done,
     /*  119048 */   // Label 2069: @119048
     /*  119048 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(119137), // Rule ID 2554 //
     /*  119053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  119056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  119068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  119088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  119092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119097 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  119101 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  119121 */     // (and:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1)), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  119124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  119131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  119135 */     GIR_RootConstrainSelectedInstOperands,
     /*  119136 */     // GIR_Coverage, 2554,
     /*  119136 */     GIR_EraseRootFromParent_Done,
     /*  119137 */   // Label 2070: @119137
     /*  119137 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(119216), // Rule ID 2481 //
     /*  119142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  119177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  119181 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  119185 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119195 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  119202 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  119214 */     GIR_RootConstrainSelectedInstOperands,
     /*  119215 */     // GIR_Coverage, 2481,
     /*  119215 */     GIR_EraseRootFromParent_Done,
     /*  119216 */   // Label 2071: @119216
     /*  119216 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(119295), // Rule ID 65562 //
     /*  119221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  119260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  119264 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  119268 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  119281 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  119293 */     GIR_RootConstrainSelectedInstOperands,
     /*  119294 */     // GIR_Coverage, 65562,
     /*  119294 */     GIR_EraseRootFromParent_Done,
     /*  119295 */   // Label 2072: @119295
     /*  119295 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(119360), // Rule ID 2501 //
     /*  119300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  119315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  119332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119336 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  119340 */     // MIs[2] Operand 1
     /*  119340 */     // No operand predicates
     /*  119340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  119344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119346 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (BEXTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  119346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  119349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  119355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  119358 */     GIR_RootConstrainSelectedInstOperands,
     /*  119359 */     // GIR_Coverage, 2501,
     /*  119359 */     GIR_EraseRootFromParent_Done,
     /*  119360 */   // Label 2073: @119360
     /*  119360 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(119425), // Rule ID 62585 //
     /*  119365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode1),
     /*  119368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  119380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  119397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119401 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  119405 */     // MIs[2] Operand 1
     /*  119405 */     // No operand predicates
     /*  119405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  119409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119411 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (TH_TST:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  119411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  119414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  119420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  119423 */     GIR_RootConstrainSelectedInstOperands,
     /*  119424 */     // GIR_Coverage, 62585,
     /*  119424 */     GIR_EraseRootFromParent_Done,
     /*  119425 */   // Label 2074: @119425
     /*  119425 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(119487), // Rule ID 2489 //
     /*  119430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  119445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  119462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  119471 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), 1:{ *:[i32] })  =>  (BEXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  119474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  119480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  119485 */     GIR_RootConstrainSelectedInstOperands,
     /*  119486 */     // GIR_Coverage, 2489,
     /*  119486 */     GIR_EraseRootFromParent_Done,
     /*  119487 */   // Label 2075: @119487
     /*  119487 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(119543), // Rule ID 2483 //
     /*  119492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  119507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119515 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  119519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119530 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119541 */     GIR_RootConstrainSelectedInstOperands,
     /*  119542 */     // GIR_Coverage, 2483,
     /*  119542 */     GIR_EraseRootFromParent_Done,
     /*  119543 */   // Label 2076: @119543
     /*  119543 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(119599), // Rule ID 65548 //
     /*  119548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  119551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119576 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119586 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  119589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119597 */     GIR_RootConstrainSelectedInstOperands,
     /*  119598 */     // GIR_Coverage, 65548,
     /*  119598 */     GIR_EraseRootFromParent_Done,
     /*  119599 */   // Label 2077: @119599
     /*  119599 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(119655), // Rule ID 65564 //
     /*  119604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  119623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119631 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  119635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119642 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119653 */     GIR_RootConstrainSelectedInstOperands,
     /*  119654 */     // GIR_Coverage, 65564,
     /*  119654 */     GIR_EraseRootFromParent_Done,
     /*  119655 */   // Label 2078: @119655
     /*  119655 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(119711), // Rule ID 2455 //
     /*  119660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  119663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119692 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119698 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  119701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119709 */     GIR_RootConstrainSelectedInstOperands,
     /*  119710 */     // GIR_Coverage, 2455,
     /*  119710 */     GIR_EraseRootFromParent_Done,
     /*  119711 */   // Label 2079: @119711
     /*  119711 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(119747), // Rule ID 64486 //
     /*  119716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  119719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119727 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119738 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 65535:{ *:[i32] })  =>  (CV_EXTHZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  119738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  119741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119745 */     GIR_RootConstrainSelectedInstOperands,
     /*  119746 */     // GIR_Coverage, 64486,
     /*  119746 */     GIR_EraseRootFromParent_Done,
     /*  119747 */   // Label 2080: @119747
     /*  119747 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(119783), // Rule ID 64488 //
     /*  119752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  119755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119763 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  119774 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 255:{ *:[i32] })  =>  (CV_EXTBZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  119774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  119777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119781 */     GIR_RootConstrainSelectedInstOperands,
     /*  119782 */     // GIR_Coverage, 64488,
     /*  119782 */     GIR_EraseRootFromParent_Done,
     /*  119783 */   // Label 2081: @119783
     /*  119783 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(119819), // Rule ID 2565 //
     /*  119788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /*  119791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119799 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119810 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  119810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  119813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119817 */     GIR_RootConstrainSelectedInstOperands,
     /*  119818 */     // GIR_Coverage, 2565,
     /*  119818 */     GIR_EraseRootFromParent_Done,
     /*  119819 */   // Label 2082: @119819
     /*  119819 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(119855), // Rule ID 2566 //
     /*  119824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /*  119827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119835 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119846 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  119846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  119849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119853 */     GIR_RootConstrainSelectedInstOperands,
     /*  119854 */     // GIR_Coverage, 2566,
     /*  119854 */     GIR_EraseRootFromParent_Done,
     /*  119855 */   // Label 2083: @119855
     /*  119855 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(119897), // Rule ID 2568 //
     /*  119860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /*  119863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119871 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119882 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i64] })
     /*  119882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  119885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  119895 */     GIR_RootConstrainSelectedInstOperands,
     /*  119896 */     // GIR_Coverage, 2568,
     /*  119896 */     GIR_EraseRootFromParent_Done,
     /*  119897 */   // Label 2084: @119897
     /*  119897 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(119939), // Rule ID 2569 //
     /*  119902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /*  119905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119913 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119924 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i32] })
     /*  119924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  119927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  119937 */     GIR_RootConstrainSelectedInstOperands,
     /*  119938 */     // GIR_Coverage, 2569,
     /*  119938 */     GIR_EraseRootFromParent_Done,
     /*  119939 */   // Label 2085: @119939
     /*  119939 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(119974), // Rule ID 64631 //
     /*  119944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /*  119959 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 63:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  119959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  119969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119972 */     GIR_RootConstrainSelectedInstOperands,
     /*  119973 */     // GIR_Coverage, 64631,
     /*  119973 */     GIR_EraseRootFromParent_Done,
     /*  119974 */   // Label 2086: @119974
     /*  119974 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(120009), // Rule ID 64632 //
     /*  119979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /*  119994 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 63:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  119994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  120004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120007 */     GIR_RootConstrainSelectedInstOperands,
     /*  120008 */     // GIR_Coverage, 64632,
     /*  120008 */     GIR_EraseRootFromParent_Done,
     /*  120009 */   // Label 2087: @120009
     /*  120009 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(120044), // Rule ID 64633 //
     /*  120014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  120017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 127,
     /*  120029 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 127:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 7:{ *:[i64] }, 0:{ *:[i64] })
     /*  120029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  120039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120042 */     GIR_RootConstrainSelectedInstOperands,
     /*  120043 */     // GIR_Coverage, 64633,
     /*  120043 */     GIR_EraseRootFromParent_Done,
     /*  120044 */   // Label 2088: @120044
     /*  120044 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(120079), // Rule ID 64634 //
     /*  120049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  120052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 127,
     /*  120064 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 127:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 7:{ *:[i32] }, 0:{ *:[i32] })
     /*  120064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  120074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120077 */     GIR_RootConstrainSelectedInstOperands,
     /*  120078 */     // GIR_Coverage, 64634,
     /*  120078 */     GIR_EraseRootFromParent_Done,
     /*  120079 */   // Label 2089: @120079
     /*  120079 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(120121), // Rule ID 64635 //
     /*  120084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  120087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120095 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  120106 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 255:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 8:{ *:[i64] }, 0:{ *:[i64] })
     /*  120106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  120116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120119 */     GIR_RootConstrainSelectedInstOperands,
     /*  120120 */     // GIR_Coverage, 64635,
     /*  120120 */     GIR_EraseRootFromParent_Done,
     /*  120121 */   // Label 2090: @120121
     /*  120121 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(120163), // Rule ID 64636 //
     /*  120126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  120129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120137 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  120148 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 255:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 8:{ *:[i32] }, 0:{ *:[i32] })
     /*  120148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  120158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120161 */     GIR_RootConstrainSelectedInstOperands,
     /*  120162 */     // GIR_Coverage, 64636,
     /*  120162 */     GIR_EraseRootFromParent_Done,
     /*  120163 */   // Label 2091: @120163
     /*  120163 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(120205), // Rule ID 64637 //
     /*  120168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  120171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120179 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(511),
     /*  120190 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 511:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 9:{ *:[i64] }, 0:{ *:[i64] })
     /*  120190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*  120200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120203 */     GIR_RootConstrainSelectedInstOperands,
     /*  120204 */     // GIR_Coverage, 64637,
     /*  120204 */     GIR_EraseRootFromParent_Done,
     /*  120205 */   // Label 2092: @120205
     /*  120205 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(120247), // Rule ID 64638 //
     /*  120210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  120213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120221 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(511),
     /*  120232 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 511:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 9:{ *:[i32] }, 0:{ *:[i32] })
     /*  120232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*  120242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120245 */     GIR_RootConstrainSelectedInstOperands,
     /*  120246 */     // GIR_Coverage, 64638,
     /*  120246 */     GIR_EraseRootFromParent_Done,
     /*  120247 */   // Label 2093: @120247
     /*  120247 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(120289), // Rule ID 64639 //
     /*  120252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  120255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120263 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1023),
     /*  120274 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 1023:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 10:{ *:[i64] }, 0:{ *:[i64] })
     /*  120274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/10,
     /*  120284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120287 */     GIR_RootConstrainSelectedInstOperands,
     /*  120288 */     // GIR_Coverage, 64639,
     /*  120288 */     GIR_EraseRootFromParent_Done,
     /*  120289 */   // Label 2094: @120289
     /*  120289 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(120331), // Rule ID 64640 //
     /*  120294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  120297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120305 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1023),
     /*  120316 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 1023:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 10:{ *:[i32] }, 0:{ *:[i32] })
     /*  120316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/10,
     /*  120326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120329 */     GIR_RootConstrainSelectedInstOperands,
     /*  120330 */     // GIR_Coverage, 64640,
     /*  120330 */     GIR_EraseRootFromParent_Done,
     /*  120331 */   // Label 2095: @120331
     /*  120331 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(120373), // Rule ID 64641 //
     /*  120336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  120339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120347 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2047),
     /*  120358 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 2047:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 11:{ *:[i64] }, 0:{ *:[i64] })
     /*  120358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /*  120368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120371 */     GIR_RootConstrainSelectedInstOperands,
     /*  120372 */     // GIR_Coverage, 64641,
     /*  120372 */     GIR_EraseRootFromParent_Done,
     /*  120373 */   // Label 2096: @120373
     /*  120373 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(120415), // Rule ID 64642 //
     /*  120378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  120381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120389 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2047),
     /*  120400 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 2047:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 11:{ *:[i32] }, 0:{ *:[i32] })
     /*  120400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /*  120410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120413 */     GIR_RootConstrainSelectedInstOperands,
     /*  120414 */     // GIR_Coverage, 64642,
     /*  120414 */     GIR_EraseRootFromParent_Done,
     /*  120415 */   // Label 2097: @120415
     /*  120415 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(120457), // Rule ID 99 //
     /*  120420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  120423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  120443 */     // MIs[1] Operand 1
     /*  120443 */     // No operand predicates
     /*  120443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120445 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  120445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  120448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  120455 */     GIR_RootConstrainSelectedInstOperands,
     /*  120456 */     // GIR_Coverage, 99,
     /*  120456 */     GIR_EraseRootFromParent_Done,
     /*  120457 */   // Label 2098: @120457
     /*  120457 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(120529), // Rule ID 117 //
     /*  120462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  120465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120481 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  120485 */     // MIs[1] Operand 1
     /*  120485 */     // No operand predicates
     /*  120485 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9978),
     /*  120489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120491 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9978>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)), (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask))
     /*  120491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  120494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120503 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  120507 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  120512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  120517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120522 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  120527 */     GIR_RootConstrainSelectedInstOperands,
     /*  120528 */     // GIR_Coverage, 117,
     /*  120528 */     GIR_EraseRootFromParent_Done,
     /*  120529 */   // Label 2099: @120529
     /*  120529 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(120571), // Rule ID 64546 //
     /*  120534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  120537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  120557 */     // MIs[1] Operand 1
     /*  120557 */     // No operand predicates
     /*  120557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120559 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ANDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  120559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDAI),
     /*  120562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  120564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  120569 */     GIR_RootConstrainSelectedInstOperands,
     /*  120570 */     // GIR_Coverage, 64546,
     /*  120570 */     GIR_EraseRootFromParent_Done,
     /*  120571 */   // Label 2100: @120571
     /*  120571 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(120613), // Rule ID 64550 //
     /*  120576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  120579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  120599 */     // MIs[1] Operand 1
     /*  120599 */     // No operand predicates
     /*  120599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120601 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ANDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  120601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDI),
     /*  120604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  120611 */     GIR_RootConstrainSelectedInstOperands,
     /*  120612 */     // GIR_Coverage, 64550,
     /*  120612 */     GIR_EraseRootFromParent_Done,
     /*  120613 */   // Label 2101: @120613
     /*  120613 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(120640), // Rule ID 97 //
     /*  120618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  120621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120633 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (AND:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  120633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  120638 */     GIR_RootConstrainSelectedInstOperands,
     /*  120639 */     // GIR_Coverage, 97,
     /*  120639 */     GIR_Done,
     /*  120640 */   // Label 2102: @120640
     /*  120640 */   GIM_Reject,
     /*  120641 */ // Label 2068: @120641
     /*  120641 */ GIM_Reject,
     /*  120642 */ // Label 2037: @120642
     /*  120642 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(121962),
     /*  120647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  120650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  120653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120657 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(120742), // Rule ID 65573 //
     /*  120662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  120665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  120673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120702 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  120706 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  120726 */     // (and:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] })), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  120729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  120736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  120740 */     GIR_RootConstrainSelectedInstOperands,
     /*  120741 */     // GIR_Coverage, 65573,
     /*  120741 */     GIR_EraseRootFromParent_Done,
     /*  120742 */   // Label 2104: @120742
     /*  120742 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(120827), // Rule ID 2553 //
     /*  120747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  120750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  120758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120787 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  120791 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  120811 */     // (and:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1)), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  120814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  120821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  120825 */     GIR_RootConstrainSelectedInstOperands,
     /*  120826 */     // GIR_Coverage, 2553,
     /*  120826 */     GIR_EraseRootFromParent_Done,
     /*  120827 */   // Label 2105: @120827
     /*  120827 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(120902), // Rule ID 2480 //
     /*  120832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120867 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  120871 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120888 */     // (and:{ *:[i64] } (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120900 */     GIR_RootConstrainSelectedInstOperands,
     /*  120901 */     // GIR_Coverage, 2480,
     /*  120901 */     GIR_EraseRootFromParent_Done,
     /*  120902 */   // Label 2106: @120902
     /*  120902 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(120977), // Rule ID 65561 //
     /*  120907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120946 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  120950 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120963 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120975 */     GIR_RootConstrainSelectedInstOperands,
     /*  120976 */     // GIR_Coverage, 65561,
     /*  120976 */     GIR_EraseRootFromParent_Done,
     /*  120977 */   // Label 2107: @120977
     /*  120977 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(121038), // Rule ID 2500 //
     /*  120982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121014 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  121018 */     // MIs[2] Operand 1
     /*  121018 */     // No operand predicates
     /*  121018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  121022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121024 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (BEXTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  121024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  121027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  121033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  121036 */     GIR_RootConstrainSelectedInstOperands,
     /*  121037 */     // GIR_Coverage, 2500,
     /*  121037 */     GIR_EraseRootFromParent_Done,
     /*  121038 */   // Label 2108: @121038
     /*  121038 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(121099), // Rule ID 62584 //
     /*  121043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode0),
     /*  121046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  121054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  121058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121075 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  121079 */     // MIs[2] Operand 1
     /*  121079 */     // No operand predicates
     /*  121079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  121083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121085 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (TH_TST:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  121085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  121088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  121094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  121097 */     GIR_RootConstrainSelectedInstOperands,
     /*  121098 */     // GIR_Coverage, 62584,
     /*  121098 */     GIR_EraseRootFromParent_Done,
     /*  121099 */   // Label 2109: @121099
     /*  121099 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(121157), // Rule ID 2488 //
     /*  121104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  121107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  121115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  121119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  121132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  121141 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), 1:{ *:[i64] })  =>  (BEXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  121144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  121150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  121155 */     GIR_RootConstrainSelectedInstOperands,
     /*  121156 */     // GIR_Coverage, 2488,
     /*  121156 */     GIR_EraseRootFromParent_Done,
     /*  121157 */   // Label 2110: @121157
     /*  121157 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(121209), // Rule ID 2482 //
     /*  121162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  121165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  121173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  121177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121181 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  121185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121196 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  121199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121207 */     GIR_RootConstrainSelectedInstOperands,
     /*  121208 */     // GIR_Coverage, 2482,
     /*  121208 */     GIR_EraseRootFromParent_Done,
     /*  121209 */   // Label 2111: @121209
     /*  121209 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(121261), // Rule ID 65547 //
     /*  121214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  121217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  121229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121238 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  121242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121248 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  121251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121259 */     GIR_RootConstrainSelectedInstOperands,
     /*  121260 */     // GIR_Coverage, 65547,
     /*  121260 */     GIR_EraseRootFromParent_Done,
     /*  121261 */   // Label 2112: @121261
     /*  121261 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(121313), // Rule ID 65563 //
     /*  121266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  121269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  121281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  121285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121289 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  121293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121300 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  121303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121311 */     GIR_RootConstrainSelectedInstOperands,
     /*  121312 */     // GIR_Coverage, 65563,
     /*  121312 */     GIR_EraseRootFromParent_Done,
     /*  121313 */   // Label 2113: @121313
     /*  121313 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(121365), // Rule ID 2454 //
     /*  121318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  121321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  121337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121346 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  121350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121352 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  121355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121363 */     GIR_RootConstrainSelectedInstOperands,
     /*  121364 */     // GIR_Coverage, 2454,
     /*  121364 */     GIR_EraseRootFromParent_Done,
     /*  121365 */   // Label 2114: @121365
     /*  121365 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(121397), // Rule ID 64485 //
     /*  121370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  121373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121377 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  121388 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 65535:{ *:[i64] })  =>  (CV_EXTHZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  121388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  121391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121395 */     GIR_RootConstrainSelectedInstOperands,
     /*  121396 */     // GIR_Coverage, 64485,
     /*  121396 */     GIR_EraseRootFromParent_Done,
     /*  121397 */   // Label 2115: @121397
     /*  121397 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(121429), // Rule ID 64487 //
     /*  121402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  121405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121409 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  121420 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 255:{ *:[i64] })  =>  (CV_EXTBZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  121420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  121423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121427 */     GIR_RootConstrainSelectedInstOperands,
     /*  121428 */     // GIR_Coverage, 64487,
     /*  121428 */     GIR_EraseRootFromParent_Done,
     /*  121429 */   // Label 2116: @121429
     /*  121429 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(121486), // Rule ID 270 //
     /*  121434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /*  121437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121441 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  121452 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] })  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), 32:{ *:[i64] })
     /*  121452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  121468 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  121471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /*  121484 */     GIR_RootConstrainSelectedInstOperands,
     /*  121485 */     // GIR_Coverage, 270,
     /*  121485 */     GIR_EraseRootFromParent_Done,
     /*  121486 */   // Label 2117: @121486
     /*  121486 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(121518), // Rule ID 2567 //
     /*  121491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /*  121494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121498 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  121509 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs)
     /*  121509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /*  121512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121516 */     GIR_RootConstrainSelectedInstOperands,
     /*  121517 */     // GIR_Coverage, 2567,
     /*  121517 */     GIR_EraseRootFromParent_Done,
     /*  121518 */   // Label 2118: @121518
     /*  121518 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(121556), // Rule ID 2570 //
     /*  121523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /*  121526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121530 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  121541 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  121541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  121544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  121554 */     GIR_RootConstrainSelectedInstOperands,
     /*  121555 */     // GIR_Coverage, 2570,
     /*  121555 */     GIR_EraseRootFromParent_Done,
     /*  121556 */   // Label 2119: @121556
     /*  121556 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(121594), // Rule ID 2613 //
     /*  121561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  121564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121568 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  121579 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  121579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*  121582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  121592 */     GIR_RootConstrainSelectedInstOperands,
     /*  121593 */     // GIR_Coverage, 2613,
     /*  121593 */     GIR_EraseRootFromParent_Done,
     /*  121594 */   // Label 2120: @121594
     /*  121594 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(121632), // Rule ID 65158 //
     /*  121599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*  121602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121606 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  121617 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  121617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*  121620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  121630 */     GIR_RootConstrainSelectedInstOperands,
     /*  121631 */     // GIR_Coverage, 65158,
     /*  121631 */     GIR_EraseRootFromParent_Done,
     /*  121632 */   // Label 2121: @121632
     /*  121632 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(121670), // Rule ID 98 //
     /*  121637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  121656 */     // MIs[1] Operand 1
     /*  121656 */     // No operand predicates
     /*  121656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121658 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  121658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  121661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  121668 */     GIR_RootConstrainSelectedInstOperands,
     /*  121669 */     // GIR_Coverage, 98,
     /*  121669 */     GIR_EraseRootFromParent_Done,
     /*  121670 */   // Label 2122: @121670
     /*  121670 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(121738), // Rule ID 115 //
     /*  121675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesMask),
     /*  121694 */     // MIs[1] Operand 1
     /*  121694 */     // No operand predicates
     /*  121694 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9976),
     /*  121698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121700 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesMask>><<P:Predicate_anonymous_9976>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  121700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  121716 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121731 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121736 */     GIR_RootConstrainSelectedInstOperands,
     /*  121737 */     // GIR_Coverage, 115,
     /*  121737 */     GIR_EraseRootFromParent_Done,
     /*  121738 */   // Label 2123: @121738
     /*  121738 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(121806), // Rule ID 116 //
     /*  121743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121758 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  121762 */     // MIs[1] Operand 1
     /*  121762 */     // No operand predicates
     /*  121762 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9978),
     /*  121766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121768 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9978>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  121768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121780 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  121784 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  121789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121799 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  121804 */     GIR_RootConstrainSelectedInstOperands,
     /*  121805 */     // GIR_Coverage, 116,
     /*  121805 */     GIR_EraseRootFromParent_Done,
     /*  121806 */   // Label 2124: @121806
     /*  121806 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(121874), // Rule ID 272 //
     /*  121811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  121814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesWMask),
     /*  121830 */     // MIs[1] Operand 1
     /*  121830 */     // No operand predicates
     /*  121830 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10068),
     /*  121834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121836 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesWMask>><<P:Predicate_anonymous_10068>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLIW:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  121836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*  121843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  121852 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121867 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121872 */     GIR_RootConstrainSelectedInstOperands,
     /*  121873 */     // GIR_Coverage, 272,
     /*  121873 */     GIR_EraseRootFromParent_Done,
     /*  121874 */   // Label 2125: @121874
     /*  121874 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(121938), // Rule ID 2632 //
     /*  121879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  121882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121894 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_Shifted32OnesMask),
     /*  121898 */     // MIs[1] Operand 1
     /*  121898 */     // No operand predicates
     /*  121898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121900 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>><<X:TrailingZeros>>:$mask)  =>  (SLLI_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask))
     /*  121900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  121916 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /*  121926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121931 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121936 */     GIR_RootConstrainSelectedInstOperands,
     /*  121937 */     // GIR_Coverage, 2632,
     /*  121937 */     GIR_EraseRootFromParent_Done,
     /*  121938 */   // Label 2126: @121938
     /*  121938 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(121961), // Rule ID 96 //
     /*  121943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121954 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AND:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  121959 */     GIR_RootConstrainSelectedInstOperands,
     /*  121960 */     // GIR_Coverage, 96,
     /*  121960 */     GIR_Done,
     /*  121961 */   // Label 2127: @121961
     /*  121961 */   GIM_Reject,
     /*  121962 */ // Label 2103: @121962
     /*  121962 */ GIM_Reject,
     /*  121963 */ // Label 2038: @121963
     /*  121963 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(122573),
     /*  121968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121978 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(122044), // Rule ID 71773 //
     /*  121983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122025 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122042 */     GIR_RootConstrainSelectedInstOperands,
     /*  122043 */     // GIR_Coverage, 71773,
     /*  122043 */     GIR_EraseRootFromParent_Done,
     /*  122044 */   // Label 2129: @122044
     /*  122044 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(122110), // Rule ID 71774 //
     /*  122049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122091 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122108 */     GIR_RootConstrainSelectedInstOperands,
     /*  122109 */     // GIR_Coverage, 71774,
     /*  122109 */     GIR_EraseRootFromParent_Done,
     /*  122110 */   // Label 2130: @122110
     /*  122110 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(122176), // Rule ID 71771 //
     /*  122115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122157 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122174 */     GIR_RootConstrainSelectedInstOperands,
     /*  122175 */     // GIR_Coverage, 71771,
     /*  122175 */     GIR_EraseRootFromParent_Done,
     /*  122176 */   // Label 2131: @122176
     /*  122176 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(122242), // Rule ID 71772 //
     /*  122181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122223 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122240 */     GIR_RootConstrainSelectedInstOperands,
     /*  122241 */     // GIR_Coverage, 71772,
     /*  122241 */     GIR_EraseRootFromParent_Done,
     /*  122242 */   // Label 2132: @122242
     /*  122242 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(122308), // Rule ID 71769 //
     /*  122247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122289 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122306 */     GIR_RootConstrainSelectedInstOperands,
     /*  122307 */     // GIR_Coverage, 71769,
     /*  122307 */     GIR_EraseRootFromParent_Done,
     /*  122308 */   // Label 2133: @122308
     /*  122308 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(122374), // Rule ID 71770 //
     /*  122313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122355 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122372 */     GIR_RootConstrainSelectedInstOperands,
     /*  122373 */     // GIR_Coverage, 71770,
     /*  122373 */     GIR_EraseRootFromParent_Done,
     /*  122374 */   // Label 2134: @122374
     /*  122374 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(122440), // Rule ID 53184 //
     /*  122379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122421 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122438 */     GIR_RootConstrainSelectedInstOperands,
     /*  122439 */     // GIR_Coverage, 53184,
     /*  122439 */     GIR_EraseRootFromParent_Done,
     /*  122440 */   // Label 2135: @122440
     /*  122440 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(122506), // Rule ID 53185 //
     /*  122445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122487 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122504 */     GIR_RootConstrainSelectedInstOperands,
     /*  122505 */     // GIR_Coverage, 53185,
     /*  122505 */     GIR_EraseRootFromParent_Done,
     /*  122506 */   // Label 2136: @122506
     /*  122506 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(122539), // Rule ID 53172 //
     /*  122511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122522 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  122525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122537 */     GIR_RootConstrainSelectedInstOperands,
     /*  122538 */     // GIR_Coverage, 53172,
     /*  122538 */     GIR_EraseRootFromParent_Done,
     /*  122539 */   // Label 2137: @122539
     /*  122539 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(122572), // Rule ID 53173 //
     /*  122544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122555 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  122558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122570 */     GIR_RootConstrainSelectedInstOperands,
     /*  122571 */     // GIR_Coverage, 53173,
     /*  122571 */     GIR_EraseRootFromParent_Done,
     /*  122572 */   // Label 2138: @122572
     /*  122572 */   GIM_Reject,
     /*  122573 */ // Label 2128: @122573
     /*  122573 */ GIM_Reject,
     /*  122574 */ // Label 2039: @122574
     /*  122574 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(122688),
     /*  122579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  122582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  122585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122597 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(122642), // Rule ID 47664 //
     /*  122602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122605 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  122605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  122608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  122622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122640 */     GIR_RootConstrainSelectedInstOperands,
     /*  122641 */     // GIR_Coverage, 47664,
     /*  122641 */     GIR_EraseRootFromParent_Done,
     /*  122642 */   // Label 2140: @122642
     /*  122642 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(122687), // Rule ID 47665 //
     /*  122647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122650 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  122650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  122653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  122667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122685 */     GIR_RootConstrainSelectedInstOperands,
     /*  122686 */     // GIR_Coverage, 47665,
     /*  122686 */     GIR_EraseRootFromParent_Done,
     /*  122687 */   // Label 2141: @122687
     /*  122687 */   GIM_Reject,
     /*  122688 */ // Label 2139: @122688
     /*  122688 */ GIM_Reject,
     /*  122689 */ // Label 2040: @122689
     /*  122689 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(122803),
     /*  122694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  122697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  122700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122712 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(122757), // Rule ID 47676 //
     /*  122717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122720 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  122720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  122723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  122737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122755 */     GIR_RootConstrainSelectedInstOperands,
     /*  122756 */     // GIR_Coverage, 47676,
     /*  122756 */     GIR_EraseRootFromParent_Done,
     /*  122757 */   // Label 2143: @122757
     /*  122757 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(122802), // Rule ID 47677 //
     /*  122762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122765 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  122765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  122768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  122782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122800 */     GIR_RootConstrainSelectedInstOperands,
     /*  122801 */     // GIR_Coverage, 47677,
     /*  122801 */     GIR_EraseRootFromParent_Done,
     /*  122802 */   // Label 2144: @122802
     /*  122802 */   GIM_Reject,
     /*  122803 */ // Label 2142: @122803
     /*  122803 */ GIM_Reject,
     /*  122804 */ // Label 2041: @122804
     /*  122804 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(122918),
     /*  122809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  122812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  122815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122827 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(122872), // Rule ID 47684 //
     /*  122832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122835 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  122835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  122838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  122852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122870 */     GIR_RootConstrainSelectedInstOperands,
     /*  122871 */     // GIR_Coverage, 47684,
     /*  122871 */     GIR_EraseRootFromParent_Done,
     /*  122872 */   // Label 2146: @122872
     /*  122872 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(122917), // Rule ID 47685 //
     /*  122877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122880 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  122880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  122883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  122897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122915 */     GIR_RootConstrainSelectedInstOperands,
     /*  122916 */     // GIR_Coverage, 47685,
     /*  122916 */     GIR_EraseRootFromParent_Done,
     /*  122917 */   // Label 2147: @122917
     /*  122917 */   GIM_Reject,
     /*  122918 */ // Label 2145: @122918
     /*  122918 */ GIM_Reject,
     /*  122919 */ // Label 2042: @122919
     /*  122919 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(123033),
     /*  122924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  122927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  122930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122942 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(122987), // Rule ID 47700 //
     /*  122947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  122950 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  122950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  122953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  122967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  122982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122985 */     GIR_RootConstrainSelectedInstOperands,
     /*  122986 */     // GIR_Coverage, 47700,
     /*  122986 */     GIR_EraseRootFromParent_Done,
     /*  122987 */   // Label 2149: @122987
     /*  122987 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(123032), // Rule ID 47701 //
     /*  122992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  122995 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  122995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  122998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  123027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123030 */     GIR_RootConstrainSelectedInstOperands,
     /*  123031 */     // GIR_Coverage, 47701,
     /*  123031 */     GIR_EraseRootFromParent_Done,
     /*  123032 */   // Label 2150: @123032
     /*  123032 */   GIM_Reject,
     /*  123033 */ // Label 2148: @123033
     /*  123033 */ GIM_Reject,
     /*  123034 */ // Label 2043: @123034
     /*  123034 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(123644),
     /*  123039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123049 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(123115), // Rule ID 71801 //
     /*  123054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123096 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123113 */     GIR_RootConstrainSelectedInstOperands,
     /*  123114 */     // GIR_Coverage, 71801,
     /*  123114 */     GIR_EraseRootFromParent_Done,
     /*  123115 */   // Label 2152: @123115
     /*  123115 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(123181), // Rule ID 71802 //
     /*  123120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123162 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123179 */     GIR_RootConstrainSelectedInstOperands,
     /*  123180 */     // GIR_Coverage, 71802,
     /*  123180 */     GIR_EraseRootFromParent_Done,
     /*  123181 */   // Label 2153: @123181
     /*  123181 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(123247), // Rule ID 71799 //
     /*  123186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123228 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123245 */     GIR_RootConstrainSelectedInstOperands,
     /*  123246 */     // GIR_Coverage, 71799,
     /*  123246 */     GIR_EraseRootFromParent_Done,
     /*  123247 */   // Label 2154: @123247
     /*  123247 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(123313), // Rule ID 71800 //
     /*  123252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123294 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123311 */     GIR_RootConstrainSelectedInstOperands,
     /*  123312 */     // GIR_Coverage, 71800,
     /*  123312 */     GIR_EraseRootFromParent_Done,
     /*  123313 */   // Label 2155: @123313
     /*  123313 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(123379), // Rule ID 71797 //
     /*  123318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123360 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123377 */     GIR_RootConstrainSelectedInstOperands,
     /*  123378 */     // GIR_Coverage, 71797,
     /*  123378 */     GIR_EraseRootFromParent_Done,
     /*  123379 */   // Label 2156: @123379
     /*  123379 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(123445), // Rule ID 71798 //
     /*  123384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123426 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123443 */     GIR_RootConstrainSelectedInstOperands,
     /*  123444 */     // GIR_Coverage, 71798,
     /*  123444 */     GIR_EraseRootFromParent_Done,
     /*  123445 */   // Label 2157: @123445
     /*  123445 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(123511), // Rule ID 53202 //
     /*  123450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123492 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123509 */     GIR_RootConstrainSelectedInstOperands,
     /*  123510 */     // GIR_Coverage, 53202,
     /*  123510 */     GIR_EraseRootFromParent_Done,
     /*  123511 */   // Label 2158: @123511
     /*  123511 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(123577), // Rule ID 53203 //
     /*  123516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123558 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123575 */     GIR_RootConstrainSelectedInstOperands,
     /*  123576 */     // GIR_Coverage, 53203,
     /*  123576 */     GIR_EraseRootFromParent_Done,
     /*  123577 */   // Label 2159: @123577
     /*  123577 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(123610), // Rule ID 53190 //
     /*  123582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123593 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  123596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123608 */     GIR_RootConstrainSelectedInstOperands,
     /*  123609 */     // GIR_Coverage, 53190,
     /*  123609 */     GIR_EraseRootFromParent_Done,
     /*  123610 */   // Label 2160: @123610
     /*  123610 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(123643), // Rule ID 53191 //
     /*  123615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123626 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  123629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123641 */     GIR_RootConstrainSelectedInstOperands,
     /*  123642 */     // GIR_Coverage, 53191,
     /*  123642 */     GIR_EraseRootFromParent_Done,
     /*  123643 */   // Label 2161: @123643
     /*  123643 */   GIM_Reject,
     /*  123644 */ // Label 2151: @123644
     /*  123644 */ GIM_Reject,
     /*  123645 */ // Label 2044: @123645
     /*  123645 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(123759),
     /*  123650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  123653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  123656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123668 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(123713), // Rule ID 47668 //
     /*  123673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123676 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  123676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  123679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  123693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123711 */     GIR_RootConstrainSelectedInstOperands,
     /*  123712 */     // GIR_Coverage, 47668,
     /*  123712 */     GIR_EraseRootFromParent_Done,
     /*  123713 */   // Label 2163: @123713
     /*  123713 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(123758), // Rule ID 47669 //
     /*  123718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123721 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  123721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  123724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  123738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123756 */     GIR_RootConstrainSelectedInstOperands,
     /*  123757 */     // GIR_Coverage, 47669,
     /*  123757 */     GIR_EraseRootFromParent_Done,
     /*  123758 */   // Label 2164: @123758
     /*  123758 */   GIM_Reject,
     /*  123759 */ // Label 2162: @123759
     /*  123759 */ GIM_Reject,
     /*  123760 */ // Label 2045: @123760
     /*  123760 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(123874),
     /*  123765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  123768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  123771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123783 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(123828), // Rule ID 47680 //
     /*  123788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123791 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  123791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  123794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  123808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123826 */     GIR_RootConstrainSelectedInstOperands,
     /*  123827 */     // GIR_Coverage, 47680,
     /*  123827 */     GIR_EraseRootFromParent_Done,
     /*  123828 */   // Label 2166: @123828
     /*  123828 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(123873), // Rule ID 47681 //
     /*  123833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123836 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  123836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  123839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  123853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123871 */     GIR_RootConstrainSelectedInstOperands,
     /*  123872 */     // GIR_Coverage, 47681,
     /*  123872 */     GIR_EraseRootFromParent_Done,
     /*  123873 */   // Label 2167: @123873
     /*  123873 */   GIM_Reject,
     /*  123874 */ // Label 2165: @123874
     /*  123874 */ GIM_Reject,
     /*  123875 */ // Label 2046: @123875
     /*  123875 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(123989),
     /*  123880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  123883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  123886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123898 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(123943), // Rule ID 47696 //
     /*  123903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123906 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  123906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  123909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  123938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123941 */     GIR_RootConstrainSelectedInstOperands,
     /*  123942 */     // GIR_Coverage, 47696,
     /*  123942 */     GIR_EraseRootFromParent_Done,
     /*  123943 */   // Label 2169: @123943
     /*  123943 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(123988), // Rule ID 47697 //
     /*  123948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123951 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  123951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  123954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  123983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123986 */     GIR_RootConstrainSelectedInstOperands,
     /*  123987 */     // GIR_Coverage, 47697,
     /*  123987 */     GIR_EraseRootFromParent_Done,
     /*  123988 */   // Label 2170: @123988
     /*  123988 */   GIM_Reject,
     /*  123989 */ // Label 2168: @123989
     /*  123989 */ GIM_Reject,
     /*  123990 */ // Label 2047: @123990
     /*  123990 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(124104),
     /*  123995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  123998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  124001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124013 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(124058), // Rule ID 47740 //
     /*  124018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  124021 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  124021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  124024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124056 */     GIR_RootConstrainSelectedInstOperands,
     /*  124057 */     // GIR_Coverage, 47740,
     /*  124057 */     GIR_EraseRootFromParent_Done,
     /*  124058 */   // Label 2172: @124058
     /*  124058 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(124103), // Rule ID 47741 //
     /*  124063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  124066 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  124066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  124069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124101 */     GIR_RootConstrainSelectedInstOperands,
     /*  124102 */     // GIR_Coverage, 47741,
     /*  124102 */     GIR_EraseRootFromParent_Done,
     /*  124103 */   // Label 2173: @124103
     /*  124103 */   GIM_Reject,
     /*  124104 */ // Label 2171: @124104
     /*  124104 */ GIM_Reject,
     /*  124105 */ // Label 2048: @124105
     /*  124105 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(124715),
     /*  124110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124120 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(124186), // Rule ID 71829 //
     /*  124125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124167 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124184 */     GIR_RootConstrainSelectedInstOperands,
     /*  124185 */     // GIR_Coverage, 71829,
     /*  124185 */     GIR_EraseRootFromParent_Done,
     /*  124186 */   // Label 2175: @124186
     /*  124186 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(124252), // Rule ID 71830 //
     /*  124191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124233 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124250 */     GIR_RootConstrainSelectedInstOperands,
     /*  124251 */     // GIR_Coverage, 71830,
     /*  124251 */     GIR_EraseRootFromParent_Done,
     /*  124252 */   // Label 2176: @124252
     /*  124252 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(124318), // Rule ID 71827 //
     /*  124257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124299 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124316 */     GIR_RootConstrainSelectedInstOperands,
     /*  124317 */     // GIR_Coverage, 71827,
     /*  124317 */     GIR_EraseRootFromParent_Done,
     /*  124318 */   // Label 2177: @124318
     /*  124318 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(124384), // Rule ID 71828 //
     /*  124323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124365 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124382 */     GIR_RootConstrainSelectedInstOperands,
     /*  124383 */     // GIR_Coverage, 71828,
     /*  124383 */     GIR_EraseRootFromParent_Done,
     /*  124384 */   // Label 2178: @124384
     /*  124384 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(124450), // Rule ID 71825 //
     /*  124389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124431 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124448 */     GIR_RootConstrainSelectedInstOperands,
     /*  124449 */     // GIR_Coverage, 71825,
     /*  124449 */     GIR_EraseRootFromParent_Done,
     /*  124450 */   // Label 2179: @124450
     /*  124450 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(124516), // Rule ID 71826 //
     /*  124455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124497 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124514 */     GIR_RootConstrainSelectedInstOperands,
     /*  124515 */     // GIR_Coverage, 71826,
     /*  124515 */     GIR_EraseRootFromParent_Done,
     /*  124516 */   // Label 2180: @124516
     /*  124516 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(124582), // Rule ID 53220 //
     /*  124521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124563 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124580 */     GIR_RootConstrainSelectedInstOperands,
     /*  124581 */     // GIR_Coverage, 53220,
     /*  124581 */     GIR_EraseRootFromParent_Done,
     /*  124582 */   // Label 2181: @124582
     /*  124582 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(124648), // Rule ID 53221 //
     /*  124587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124629 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124646 */     GIR_RootConstrainSelectedInstOperands,
     /*  124647 */     // GIR_Coverage, 53221,
     /*  124647 */     GIR_EraseRootFromParent_Done,
     /*  124648 */   // Label 2182: @124648
     /*  124648 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(124681), // Rule ID 53208 //
     /*  124653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124664 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  124667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124679 */     GIR_RootConstrainSelectedInstOperands,
     /*  124680 */     // GIR_Coverage, 53208,
     /*  124680 */     GIR_EraseRootFromParent_Done,
     /*  124681 */   // Label 2183: @124681
     /*  124681 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(124714), // Rule ID 53209 //
     /*  124686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124697 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  124700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124712 */     GIR_RootConstrainSelectedInstOperands,
     /*  124713 */     // GIR_Coverage, 53209,
     /*  124713 */     GIR_EraseRootFromParent_Done,
     /*  124714 */   // Label 2184: @124714
     /*  124714 */   GIM_Reject,
     /*  124715 */ // Label 2174: @124715
     /*  124715 */ GIM_Reject,
     /*  124716 */ // Label 2049: @124716
     /*  124716 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(124830),
     /*  124721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  124724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  124727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124739 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(124784), // Rule ID 47672 //
     /*  124744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124747 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  124747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  124750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  124764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124782 */     GIR_RootConstrainSelectedInstOperands,
     /*  124783 */     // GIR_Coverage, 47672,
     /*  124783 */     GIR_EraseRootFromParent_Done,
     /*  124784 */   // Label 2186: @124784
     /*  124784 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(124829), // Rule ID 47673 //
     /*  124789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124792 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  124792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  124795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  124809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124827 */     GIR_RootConstrainSelectedInstOperands,
     /*  124828 */     // GIR_Coverage, 47673,
     /*  124828 */     GIR_EraseRootFromParent_Done,
     /*  124829 */   // Label 2187: @124829
     /*  124829 */   GIM_Reject,
     /*  124830 */ // Label 2185: @124830
     /*  124830 */ GIM_Reject,
     /*  124831 */ // Label 2050: @124831
     /*  124831 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(124945),
     /*  124836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  124839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  124842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124854 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(124899), // Rule ID 47692 //
     /*  124859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124862 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  124862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  124865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  124879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124897 */     GIR_RootConstrainSelectedInstOperands,
     /*  124898 */     // GIR_Coverage, 47692,
     /*  124898 */     GIR_EraseRootFromParent_Done,
     /*  124899 */   // Label 2189: @124899
     /*  124899 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(124944), // Rule ID 47693 //
     /*  124904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124907 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  124907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  124910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  124924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124942 */     GIR_RootConstrainSelectedInstOperands,
     /*  124943 */     // GIR_Coverage, 47693,
     /*  124943 */     GIR_EraseRootFromParent_Done,
     /*  124944 */   // Label 2190: @124944
     /*  124944 */   GIM_Reject,
     /*  124945 */ // Label 2188: @124945
     /*  124945 */ GIM_Reject,
     /*  124946 */ // Label 2051: @124946
     /*  124946 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(125060),
     /*  124951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  124954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  124957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124969 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(125014), // Rule ID 47728 //
     /*  124974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124977 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  124977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  124980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  125009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125012 */     GIR_RootConstrainSelectedInstOperands,
     /*  125013 */     // GIR_Coverage, 47728,
     /*  125013 */     GIR_EraseRootFromParent_Done,
     /*  125014 */   // Label 2192: @125014
     /*  125014 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(125059), // Rule ID 47729 //
     /*  125019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125022 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  125022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  125025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  125054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125057 */     GIR_RootConstrainSelectedInstOperands,
     /*  125058 */     // GIR_Coverage, 47729,
     /*  125058 */     GIR_EraseRootFromParent_Done,
     /*  125059 */   // Label 2193: @125059
     /*  125059 */   GIM_Reject,
     /*  125060 */ // Label 2191: @125060
     /*  125060 */ GIM_Reject,
     /*  125061 */ // Label 2052: @125061
     /*  125061 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(125175),
     /*  125066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  125069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  125072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125084 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(125129), // Rule ID 47744 //
     /*  125089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  125092 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  125092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  125095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  125109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125127 */     GIR_RootConstrainSelectedInstOperands,
     /*  125128 */     // GIR_Coverage, 47744,
     /*  125128 */     GIR_EraseRootFromParent_Done,
     /*  125129 */   // Label 2195: @125129
     /*  125129 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(125174), // Rule ID 47745 //
     /*  125134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  125137 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  125137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  125140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  125154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125172 */     GIR_RootConstrainSelectedInstOperands,
     /*  125173 */     // GIR_Coverage, 47745,
     /*  125173 */     GIR_EraseRootFromParent_Done,
     /*  125174 */   // Label 2196: @125174
     /*  125174 */   GIM_Reject,
     /*  125175 */ // Label 2194: @125175
     /*  125175 */ GIM_Reject,
     /*  125176 */ // Label 2053: @125176
     /*  125176 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(125786),
     /*  125181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125191 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(125257), // Rule ID 71857 //
     /*  125196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125238 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125255 */     GIR_RootConstrainSelectedInstOperands,
     /*  125256 */     // GIR_Coverage, 71857,
     /*  125256 */     GIR_EraseRootFromParent_Done,
     /*  125257 */   // Label 2198: @125257
     /*  125257 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(125323), // Rule ID 71858 //
     /*  125262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125304 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125321 */     GIR_RootConstrainSelectedInstOperands,
     /*  125322 */     // GIR_Coverage, 71858,
     /*  125322 */     GIR_EraseRootFromParent_Done,
     /*  125323 */   // Label 2199: @125323
     /*  125323 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(125389), // Rule ID 71855 //
     /*  125328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125370 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125387 */     GIR_RootConstrainSelectedInstOperands,
     /*  125388 */     // GIR_Coverage, 71855,
     /*  125388 */     GIR_EraseRootFromParent_Done,
     /*  125389 */   // Label 2200: @125389
     /*  125389 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(125455), // Rule ID 71856 //
     /*  125394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125436 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125453 */     GIR_RootConstrainSelectedInstOperands,
     /*  125454 */     // GIR_Coverage, 71856,
     /*  125454 */     GIR_EraseRootFromParent_Done,
     /*  125455 */   // Label 2201: @125455
     /*  125455 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(125521), // Rule ID 71853 //
     /*  125460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125502 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125519 */     GIR_RootConstrainSelectedInstOperands,
     /*  125520 */     // GIR_Coverage, 71853,
     /*  125520 */     GIR_EraseRootFromParent_Done,
     /*  125521 */   // Label 2202: @125521
     /*  125521 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(125587), // Rule ID 71854 //
     /*  125526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125568 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125585 */     GIR_RootConstrainSelectedInstOperands,
     /*  125586 */     // GIR_Coverage, 71854,
     /*  125586 */     GIR_EraseRootFromParent_Done,
     /*  125587 */   // Label 2203: @125587
     /*  125587 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(125653), // Rule ID 53238 //
     /*  125592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125634 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125651 */     GIR_RootConstrainSelectedInstOperands,
     /*  125652 */     // GIR_Coverage, 53238,
     /*  125652 */     GIR_EraseRootFromParent_Done,
     /*  125653 */   // Label 2204: @125653
     /*  125653 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(125719), // Rule ID 53239 //
     /*  125658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125700 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125717 */     GIR_RootConstrainSelectedInstOperands,
     /*  125718 */     // GIR_Coverage, 53239,
     /*  125718 */     GIR_EraseRootFromParent_Done,
     /*  125719 */   // Label 2205: @125719
     /*  125719 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(125752), // Rule ID 53226 //
     /*  125724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125735 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  125738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125750 */     GIR_RootConstrainSelectedInstOperands,
     /*  125751 */     // GIR_Coverage, 53226,
     /*  125751 */     GIR_EraseRootFromParent_Done,
     /*  125752 */   // Label 2206: @125752
     /*  125752 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(125785), // Rule ID 53227 //
     /*  125757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125768 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  125771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125783 */     GIR_RootConstrainSelectedInstOperands,
     /*  125784 */     // GIR_Coverage, 53227,
     /*  125784 */     GIR_EraseRootFromParent_Done,
     /*  125785 */   // Label 2207: @125785
     /*  125785 */   GIM_Reject,
     /*  125786 */ // Label 2197: @125786
     /*  125786 */ GIM_Reject,
     /*  125787 */ // Label 2054: @125787
     /*  125787 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(125901),
     /*  125792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  125795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  125798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125810 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(125855), // Rule ID 47688 //
     /*  125815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125818 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  125818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  125821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  125835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125853 */     GIR_RootConstrainSelectedInstOperands,
     /*  125854 */     // GIR_Coverage, 47688,
     /*  125854 */     GIR_EraseRootFromParent_Done,
     /*  125855 */   // Label 2209: @125855
     /*  125855 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(125900), // Rule ID 47689 //
     /*  125860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125863 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  125863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  125866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  125880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125898 */     GIR_RootConstrainSelectedInstOperands,
     /*  125899 */     // GIR_Coverage, 47689,
     /*  125899 */     GIR_EraseRootFromParent_Done,
     /*  125900 */   // Label 2210: @125900
     /*  125900 */   GIM_Reject,
     /*  125901 */ // Label 2208: @125901
     /*  125901 */ GIM_Reject,
     /*  125902 */ // Label 2055: @125902
     /*  125902 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(126016),
     /*  125907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  125910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  125913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125925 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(125970), // Rule ID 47716 //
     /*  125930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125933 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  125933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  125936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  125965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125968 */     GIR_RootConstrainSelectedInstOperands,
     /*  125969 */     // GIR_Coverage, 47716,
     /*  125969 */     GIR_EraseRootFromParent_Done,
     /*  125970 */   // Label 2212: @125970
     /*  125970 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(126015), // Rule ID 47717 //
     /*  125975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125978 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  125978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  125981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126013 */     GIR_RootConstrainSelectedInstOperands,
     /*  126014 */     // GIR_Coverage, 47717,
     /*  126014 */     GIR_EraseRootFromParent_Done,
     /*  126015 */   // Label 2213: @126015
     /*  126015 */   GIM_Reject,
     /*  126016 */ // Label 2211: @126016
     /*  126016 */ GIM_Reject,
     /*  126017 */ // Label 2056: @126017
     /*  126017 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(126131),
     /*  126022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  126025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  126028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126040 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(126085), // Rule ID 47732 //
     /*  126045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126048 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  126048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  126051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126083 */     GIR_RootConstrainSelectedInstOperands,
     /*  126084 */     // GIR_Coverage, 47732,
     /*  126084 */     GIR_EraseRootFromParent_Done,
     /*  126085 */   // Label 2215: @126085
     /*  126085 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(126130), // Rule ID 47733 //
     /*  126090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126093 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  126093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  126096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126128 */     GIR_RootConstrainSelectedInstOperands,
     /*  126129 */     // GIR_Coverage, 47733,
     /*  126129 */     GIR_EraseRootFromParent_Done,
     /*  126130 */   // Label 2216: @126130
     /*  126130 */   GIM_Reject,
     /*  126131 */ // Label 2214: @126131
     /*  126131 */ GIM_Reject,
     /*  126132 */ // Label 2057: @126132
     /*  126132 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(126246),
     /*  126137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  126140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  126143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126155 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(126200), // Rule ID 47748 //
     /*  126160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  126163 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  126163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  126166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  126180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  126195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126198 */     GIR_RootConstrainSelectedInstOperands,
     /*  126199 */     // GIR_Coverage, 47748,
     /*  126199 */     GIR_EraseRootFromParent_Done,
     /*  126200 */   // Label 2218: @126200
     /*  126200 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(126245), // Rule ID 47749 //
     /*  126205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  126208 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  126208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  126211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  126225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  126240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126243 */     GIR_RootConstrainSelectedInstOperands,
     /*  126244 */     // GIR_Coverage, 47749,
     /*  126244 */     GIR_EraseRootFromParent_Done,
     /*  126245 */   // Label 2219: @126245
     /*  126245 */   GIM_Reject,
     /*  126246 */ // Label 2217: @126246
     /*  126246 */ GIM_Reject,
     /*  126247 */ // Label 2058: @126247
     /*  126247 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(126857),
     /*  126252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126262 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(126328), // Rule ID 71885 //
     /*  126267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126309 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126326 */     GIR_RootConstrainSelectedInstOperands,
     /*  126327 */     // GIR_Coverage, 71885,
     /*  126327 */     GIR_EraseRootFromParent_Done,
     /*  126328 */   // Label 2221: @126328
     /*  126328 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(126394), // Rule ID 71886 //
     /*  126333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126375 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126392 */     GIR_RootConstrainSelectedInstOperands,
     /*  126393 */     // GIR_Coverage, 71886,
     /*  126393 */     GIR_EraseRootFromParent_Done,
     /*  126394 */   // Label 2222: @126394
     /*  126394 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(126460), // Rule ID 71883 //
     /*  126399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126441 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126458 */     GIR_RootConstrainSelectedInstOperands,
     /*  126459 */     // GIR_Coverage, 71883,
     /*  126459 */     GIR_EraseRootFromParent_Done,
     /*  126460 */   // Label 2223: @126460
     /*  126460 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(126526), // Rule ID 71884 //
     /*  126465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126507 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126524 */     GIR_RootConstrainSelectedInstOperands,
     /*  126525 */     // GIR_Coverage, 71884,
     /*  126525 */     GIR_EraseRootFromParent_Done,
     /*  126526 */   // Label 2224: @126526
     /*  126526 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(126592), // Rule ID 71881 //
     /*  126531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126573 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126590 */     GIR_RootConstrainSelectedInstOperands,
     /*  126591 */     // GIR_Coverage, 71881,
     /*  126591 */     GIR_EraseRootFromParent_Done,
     /*  126592 */   // Label 2225: @126592
     /*  126592 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(126658), // Rule ID 71882 //
     /*  126597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126639 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126656 */     GIR_RootConstrainSelectedInstOperands,
     /*  126657 */     // GIR_Coverage, 71882,
     /*  126657 */     GIR_EraseRootFromParent_Done,
     /*  126658 */   // Label 2226: @126658
     /*  126658 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(126724), // Rule ID 53256 //
     /*  126663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126705 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126722 */     GIR_RootConstrainSelectedInstOperands,
     /*  126723 */     // GIR_Coverage, 53256,
     /*  126723 */     GIR_EraseRootFromParent_Done,
     /*  126724 */   // Label 2227: @126724
     /*  126724 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(126790), // Rule ID 53257 //
     /*  126729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126771 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126788 */     GIR_RootConstrainSelectedInstOperands,
     /*  126789 */     // GIR_Coverage, 53257,
     /*  126789 */     GIR_EraseRootFromParent_Done,
     /*  126790 */   // Label 2228: @126790
     /*  126790 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(126823), // Rule ID 53244 //
     /*  126795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126806 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  126809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126821 */     GIR_RootConstrainSelectedInstOperands,
     /*  126822 */     // GIR_Coverage, 53244,
     /*  126822 */     GIR_EraseRootFromParent_Done,
     /*  126823 */   // Label 2229: @126823
     /*  126823 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(126856), // Rule ID 53245 //
     /*  126828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126839 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  126842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126854 */     GIR_RootConstrainSelectedInstOperands,
     /*  126855 */     // GIR_Coverage, 53245,
     /*  126855 */     GIR_EraseRootFromParent_Done,
     /*  126856 */   // Label 2230: @126856
     /*  126856 */   GIM_Reject,
     /*  126857 */ // Label 2220: @126857
     /*  126857 */ GIM_Reject,
     /*  126858 */ // Label 2059: @126858
     /*  126858 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(126972),
     /*  126863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  126866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  126869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126881 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(126926), // Rule ID 47704 //
     /*  126886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126889 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  126889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  126892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  126906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126924 */     GIR_RootConstrainSelectedInstOperands,
     /*  126925 */     // GIR_Coverage, 47704,
     /*  126925 */     GIR_EraseRootFromParent_Done,
     /*  126926 */   // Label 2232: @126926
     /*  126926 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(126971), // Rule ID 47705 //
     /*  126931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126934 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  126934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  126937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  126951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126969 */     GIR_RootConstrainSelectedInstOperands,
     /*  126970 */     // GIR_Coverage, 47705,
     /*  126970 */     GIR_EraseRootFromParent_Done,
     /*  126971 */   // Label 2233: @126971
     /*  126971 */   GIM_Reject,
     /*  126972 */ // Label 2231: @126972
     /*  126972 */ GIM_Reject,
     /*  126973 */ // Label 2060: @126973
     /*  126973 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(127087),
     /*  126978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  126981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  126984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126996 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(127041), // Rule ID 47720 //
     /*  127001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127004 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  127004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  127007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  127021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127039 */     GIR_RootConstrainSelectedInstOperands,
     /*  127040 */     // GIR_Coverage, 47720,
     /*  127040 */     GIR_EraseRootFromParent_Done,
     /*  127041 */   // Label 2235: @127041
     /*  127041 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(127086), // Rule ID 47721 //
     /*  127046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127049 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  127049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  127052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  127066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127084 */     GIR_RootConstrainSelectedInstOperands,
     /*  127085 */     // GIR_Coverage, 47721,
     /*  127085 */     GIR_EraseRootFromParent_Done,
     /*  127086 */   // Label 2236: @127086
     /*  127086 */   GIM_Reject,
     /*  127087 */ // Label 2234: @127087
     /*  127087 */ GIM_Reject,
     /*  127088 */ // Label 2061: @127088
     /*  127088 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(127202),
     /*  127093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  127096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  127099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127111 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(127156), // Rule ID 47736 //
     /*  127116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127119 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  127119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  127122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  127151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127154 */     GIR_RootConstrainSelectedInstOperands,
     /*  127155 */     // GIR_Coverage, 47736,
     /*  127155 */     GIR_EraseRootFromParent_Done,
     /*  127156 */   // Label 2238: @127156
     /*  127156 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(127201), // Rule ID 47737 //
     /*  127161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127164 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  127164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  127167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  127196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127199 */     GIR_RootConstrainSelectedInstOperands,
     /*  127200 */     // GIR_Coverage, 47737,
     /*  127200 */     GIR_EraseRootFromParent_Done,
     /*  127201 */   // Label 2239: @127201
     /*  127201 */   GIM_Reject,
     /*  127202 */ // Label 2237: @127202
     /*  127202 */ GIM_Reject,
     /*  127203 */ // Label 2062: @127203
     /*  127203 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(127813),
     /*  127208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127218 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(127284), // Rule ID 71913 //
     /*  127223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127265 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127282 */     GIR_RootConstrainSelectedInstOperands,
     /*  127283 */     // GIR_Coverage, 71913,
     /*  127283 */     GIR_EraseRootFromParent_Done,
     /*  127284 */   // Label 2241: @127284
     /*  127284 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(127350), // Rule ID 71914 //
     /*  127289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127331 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127348 */     GIR_RootConstrainSelectedInstOperands,
     /*  127349 */     // GIR_Coverage, 71914,
     /*  127349 */     GIR_EraseRootFromParent_Done,
     /*  127350 */   // Label 2242: @127350
     /*  127350 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(127416), // Rule ID 71911 //
     /*  127355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127397 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127414 */     GIR_RootConstrainSelectedInstOperands,
     /*  127415 */     // GIR_Coverage, 71911,
     /*  127415 */     GIR_EraseRootFromParent_Done,
     /*  127416 */   // Label 2243: @127416
     /*  127416 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(127482), // Rule ID 71912 //
     /*  127421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127463 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127480 */     GIR_RootConstrainSelectedInstOperands,
     /*  127481 */     // GIR_Coverage, 71912,
     /*  127481 */     GIR_EraseRootFromParent_Done,
     /*  127482 */   // Label 2244: @127482
     /*  127482 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(127548), // Rule ID 71909 //
     /*  127487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127529 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127546 */     GIR_RootConstrainSelectedInstOperands,
     /*  127547 */     // GIR_Coverage, 71909,
     /*  127547 */     GIR_EraseRootFromParent_Done,
     /*  127548 */   // Label 2245: @127548
     /*  127548 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(127614), // Rule ID 71910 //
     /*  127553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127595 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127612 */     GIR_RootConstrainSelectedInstOperands,
     /*  127613 */     // GIR_Coverage, 71910,
     /*  127613 */     GIR_EraseRootFromParent_Done,
     /*  127614 */   // Label 2246: @127614
     /*  127614 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(127680), // Rule ID 53274 //
     /*  127619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127661 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127678 */     GIR_RootConstrainSelectedInstOperands,
     /*  127679 */     // GIR_Coverage, 53274,
     /*  127679 */     GIR_EraseRootFromParent_Done,
     /*  127680 */   // Label 2247: @127680
     /*  127680 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(127746), // Rule ID 53275 //
     /*  127685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127727 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127744 */     GIR_RootConstrainSelectedInstOperands,
     /*  127745 */     // GIR_Coverage, 53275,
     /*  127745 */     GIR_EraseRootFromParent_Done,
     /*  127746 */   // Label 2248: @127746
     /*  127746 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(127779), // Rule ID 53262 //
     /*  127751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127762 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  127765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127777 */     GIR_RootConstrainSelectedInstOperands,
     /*  127778 */     // GIR_Coverage, 53262,
     /*  127778 */     GIR_EraseRootFromParent_Done,
     /*  127779 */   // Label 2249: @127779
     /*  127779 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(127812), // Rule ID 53263 //
     /*  127784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127795 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  127798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127810 */     GIR_RootConstrainSelectedInstOperands,
     /*  127811 */     // GIR_Coverage, 53263,
     /*  127811 */     GIR_EraseRootFromParent_Done,
     /*  127812 */   // Label 2250: @127812
     /*  127812 */   GIM_Reject,
     /*  127813 */ // Label 2240: @127813
     /*  127813 */ GIM_Reject,
     /*  127814 */ // Label 2063: @127814
     /*  127814 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(127928),
     /*  127819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  127822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  127825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127837 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(127882), // Rule ID 47708 //
     /*  127842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127845 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  127845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  127848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  127862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127880 */     GIR_RootConstrainSelectedInstOperands,
     /*  127881 */     // GIR_Coverage, 47708,
     /*  127881 */     GIR_EraseRootFromParent_Done,
     /*  127882 */   // Label 2252: @127882
     /*  127882 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(127927), // Rule ID 47709 //
     /*  127887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127890 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  127890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  127893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  127907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127925 */     GIR_RootConstrainSelectedInstOperands,
     /*  127926 */     // GIR_Coverage, 47709,
     /*  127926 */     GIR_EraseRootFromParent_Done,
     /*  127927 */   // Label 2253: @127927
     /*  127927 */   GIM_Reject,
     /*  127928 */ // Label 2251: @127928
     /*  127928 */ GIM_Reject,
     /*  127929 */ // Label 2064: @127929
     /*  127929 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(128043),
     /*  127934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  127937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  127940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127952 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(127997), // Rule ID 47724 //
     /*  127957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127960 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  127960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  127963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127995 */     GIR_RootConstrainSelectedInstOperands,
     /*  127996 */     // GIR_Coverage, 47724,
     /*  127996 */     GIR_EraseRootFromParent_Done,
     /*  127997 */   // Label 2255: @127997
     /*  127997 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(128042), // Rule ID 47725 //
     /*  128002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128005 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  128005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  128008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  128012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  128022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  128037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128040 */     GIR_RootConstrainSelectedInstOperands,
     /*  128041 */     // GIR_Coverage, 47725,
     /*  128041 */     GIR_EraseRootFromParent_Done,
     /*  128042 */   // Label 2256: @128042
     /*  128042 */   GIM_Reject,
     /*  128043 */ // Label 2254: @128043
     /*  128043 */ GIM_Reject,
     /*  128044 */ // Label 2065: @128044
     /*  128044 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(128654),
     /*  128049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128059 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(128125), // Rule ID 71941 //
     /*  128064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128106 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  128117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128123 */     GIR_RootConstrainSelectedInstOperands,
     /*  128124 */     // GIR_Coverage, 71941,
     /*  128124 */     GIR_EraseRootFromParent_Done,
     /*  128125 */   // Label 2258: @128125
     /*  128125 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(128191), // Rule ID 71942 //
     /*  128130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128172 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  128183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128189 */     GIR_RootConstrainSelectedInstOperands,
     /*  128190 */     // GIR_Coverage, 71942,
     /*  128190 */     GIR_EraseRootFromParent_Done,
     /*  128191 */   // Label 2259: @128191
     /*  128191 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(128257), // Rule ID 71939 //
     /*  128196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128238 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128255 */     GIR_RootConstrainSelectedInstOperands,
     /*  128256 */     // GIR_Coverage, 71939,
     /*  128256 */     GIR_EraseRootFromParent_Done,
     /*  128257 */   // Label 2260: @128257
     /*  128257 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(128323), // Rule ID 71940 //
     /*  128262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128304 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128321 */     GIR_RootConstrainSelectedInstOperands,
     /*  128322 */     // GIR_Coverage, 71940,
     /*  128322 */     GIR_EraseRootFromParent_Done,
     /*  128323 */   // Label 2261: @128323
     /*  128323 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(128389), // Rule ID 71937 //
     /*  128328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128370 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  128381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128387 */     GIR_RootConstrainSelectedInstOperands,
     /*  128388 */     // GIR_Coverage, 71937,
     /*  128388 */     GIR_EraseRootFromParent_Done,
     /*  128389 */   // Label 2262: @128389
     /*  128389 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(128455), // Rule ID 71938 //
     /*  128394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128436 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  128447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128453 */     GIR_RootConstrainSelectedInstOperands,
     /*  128454 */     // GIR_Coverage, 71938,
     /*  128454 */     GIR_EraseRootFromParent_Done,
     /*  128455 */   // Label 2263: @128455
     /*  128455 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(128521), // Rule ID 53292 //
     /*  128460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128502 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128519 */     GIR_RootConstrainSelectedInstOperands,
     /*  128520 */     // GIR_Coverage, 53292,
     /*  128520 */     GIR_EraseRootFromParent_Done,
     /*  128521 */   // Label 2264: @128521
     /*  128521 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(128587), // Rule ID 53293 //
     /*  128526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128568 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128585 */     GIR_RootConstrainSelectedInstOperands,
     /*  128586 */     // GIR_Coverage, 53293,
     /*  128586 */     GIR_EraseRootFromParent_Done,
     /*  128587 */   // Label 2265: @128587
     /*  128587 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(128620), // Rule ID 53280 //
     /*  128592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128603 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  128606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128618 */     GIR_RootConstrainSelectedInstOperands,
     /*  128619 */     // GIR_Coverage, 53280,
     /*  128619 */     GIR_EraseRootFromParent_Done,
     /*  128620 */   // Label 2266: @128620
     /*  128620 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(128653), // Rule ID 53281 //
     /*  128625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128636 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  128639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128651 */     GIR_RootConstrainSelectedInstOperands,
     /*  128652 */     // GIR_Coverage, 53281,
     /*  128652 */     GIR_EraseRootFromParent_Done,
     /*  128653 */   // Label 2267: @128653
     /*  128653 */   GIM_Reject,
     /*  128654 */ // Label 2257: @128654
     /*  128654 */ GIM_Reject,
     /*  128655 */ // Label 2066: @128655
     /*  128655 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(128769),
     /*  128660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  128663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  128666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128674 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128678 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(128723), // Rule ID 47712 //
     /*  128683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128686 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  128686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  128689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  128693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  128703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128721 */     GIR_RootConstrainSelectedInstOperands,
     /*  128722 */     // GIR_Coverage, 47712,
     /*  128722 */     GIR_EraseRootFromParent_Done,
     /*  128723 */   // Label 2269: @128723
     /*  128723 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(128768), // Rule ID 47713 //
     /*  128728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128731 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  128731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  128734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  128738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  128748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128766 */     GIR_RootConstrainSelectedInstOperands,
     /*  128767 */     // GIR_Coverage, 47713,
     /*  128767 */     GIR_EraseRootFromParent_Done,
     /*  128768 */   // Label 2270: @128768
     /*  128768 */   GIM_Reject,
     /*  128769 */ // Label 2268: @128769
     /*  128769 */ GIM_Reject,
     /*  128770 */ // Label 2067: @128770
     /*  128770 */ GIM_Reject,
     /*  128771 */ // Label 8: @128771
     /*  128771 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2302*/ GIMT_Encode4(141391),
     /*  128782 */ /*GILLT_s32*//*Label 2271*/ GIMT_Encode4(128906),
     /*  128786 */ /*GILLT_s64*//*Label 2272*/ GIMT_Encode4(131636),
     /*  128790 */ /*GILLT_nxv1s1*//*Label 2273*/ GIMT_Encode4(134584),
     /*  128794 */ /*GILLT_nxv1s8*//*Label 2274*/ GIMT_Encode4(135195),
     /*  128798 */ /*GILLT_nxv1s16*//*Label 2275*/ GIMT_Encode4(135310),
     /*  128802 */ /*GILLT_nxv1s32*//*Label 2276*/ GIMT_Encode4(135425),
     /*  128806 */ /*GILLT_nxv1s64*//*Label 2277*/ GIMT_Encode4(135540),
     /*  128810 */ /*GILLT_nxv2s1*//*Label 2278*/ GIMT_Encode4(135655),
     /*  128814 */ /*GILLT_nxv2s8*//*Label 2279*/ GIMT_Encode4(136266),
     /*  128818 */ /*GILLT_nxv2s16*//*Label 2280*/ GIMT_Encode4(136381),
     /*  128822 */ /*GILLT_nxv2s32*//*Label 2281*/ GIMT_Encode4(136496),
     /*  128826 */ /*GILLT_nxv2s64*//*Label 2282*/ GIMT_Encode4(136611),
     /*  128830 */ /*GILLT_nxv4s1*//*Label 2283*/ GIMT_Encode4(136726),
     /*  128834 */ /*GILLT_nxv4s8*//*Label 2284*/ GIMT_Encode4(137337),
     /*  128838 */ /*GILLT_nxv4s16*//*Label 2285*/ GIMT_Encode4(137452),
     /*  128842 */ /*GILLT_nxv4s32*//*Label 2286*/ GIMT_Encode4(137567),
     /*  128846 */ /*GILLT_nxv4s64*//*Label 2287*/ GIMT_Encode4(137682),
     /*  128850 */ /*GILLT_nxv8s1*//*Label 2288*/ GIMT_Encode4(137797),
     /*  128854 */ /*GILLT_nxv8s8*//*Label 2289*/ GIMT_Encode4(138408),
     /*  128858 */ /*GILLT_nxv8s16*//*Label 2290*/ GIMT_Encode4(138523),
     /*  128862 */ /*GILLT_nxv8s32*//*Label 2291*/ GIMT_Encode4(138638),
     /*  128866 */ /*GILLT_nxv8s64*//*Label 2292*/ GIMT_Encode4(138753),
     /*  128870 */ /*GILLT_nxv16s1*//*Label 2293*/ GIMT_Encode4(138868),
     /*  128874 */ /*GILLT_nxv16s8*//*Label 2294*/ GIMT_Encode4(139479),
     /*  128878 */ /*GILLT_nxv16s16*//*Label 2295*/ GIMT_Encode4(139594),
     /*  128882 */ /*GILLT_nxv16s32*//*Label 2296*/ GIMT_Encode4(139709),
     /*  128886 */ /*GILLT_nxv32s1*//*Label 2297*/ GIMT_Encode4(139824),
     /*  128890 */ /*GILLT_nxv32s8*//*Label 2298*/ GIMT_Encode4(140435),
     /*  128894 */ /*GILLT_nxv32s16*//*Label 2299*/ GIMT_Encode4(140550),
     /*  128898 */ /*GILLT_nxv64s1*//*Label 2300*/ GIMT_Encode4(140665),
     /*  128902 */ /*GILLT_nxv64s8*//*Label 2301*/ GIMT_Encode4(141276),
     /*  128906 */ // Label 2271: @128906
     /*  128906 */ GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(131635),
     /*  128911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  128914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  128917 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(129112), // Rule ID 65591 //
     /*  128922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128961 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128977 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128981 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128985 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128989 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128993 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128997 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  129001 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  129005 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129009 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129013 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129017 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  129021 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129037 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129044 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129051 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129051 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129054 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129058 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  129068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  129073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  129092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  129097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129110 */     GIR_RootConstrainSelectedInstOperands,
     /*  129111 */     // GIR_Coverage, 65591,
     /*  129111 */     GIR_EraseRootFromParent_Done,
     /*  129112 */   // Label 2304: @129112
     /*  129112 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(129307), // Rule ID 65593 //
     /*  129117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  129144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129156 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  129160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  129164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129168 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129172 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129176 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  129180 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129184 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129188 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129192 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  129196 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  129200 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129204 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129208 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129212 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  129216 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129232 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129239 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129246 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129246 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129249 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129253 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  129263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  129268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  129287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  129292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129305 */     GIR_RootConstrainSelectedInstOperands,
     /*  129306 */     // GIR_Coverage, 65593,
     /*  129306 */     GIR_EraseRootFromParent_Done,
     /*  129307 */   // Label 2305: @129307
     /*  129307 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(129502), // Rule ID 65587 //
     /*  129312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129351 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  129355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  129359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129363 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129367 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129371 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  129375 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129379 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129383 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129387 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  129391 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  129395 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129399 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129403 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129407 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  129411 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129427 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129434 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129441 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129441 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129444 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129448 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  129458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  129463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  129482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  129487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129500 */     GIR_RootConstrainSelectedInstOperands,
     /*  129501 */     // GIR_Coverage, 65587,
     /*  129501 */     GIR_EraseRootFromParent_Done,
     /*  129502 */   // Label 2306: @129502
     /*  129502 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(129697), // Rule ID 65589 //
     /*  129507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129546 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  129550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  129554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129558 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129562 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129566 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  129570 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129574 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129578 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129582 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  129586 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  129590 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129594 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129598 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129602 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  129606 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129608 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129615 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129622 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129629 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129636 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129636 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129639 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129643 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  129653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  129658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  129677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  129682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129695 */     GIR_RootConstrainSelectedInstOperands,
     /*  129696 */     // GIR_Coverage, 65589,
     /*  129696 */     GIR_EraseRootFromParent_Done,
     /*  129697 */   // Label 2307: @129697
     /*  129697 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(129892), // Rule ID 65581 //
     /*  129702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  129745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129753 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129757 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129761 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  129765 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129769 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129773 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129777 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129781 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  129785 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129789 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129793 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129797 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129801 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129803 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129810 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129817 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129824 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129831 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  129848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  129853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  129872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  129877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129890 */     GIR_RootConstrainSelectedInstOperands,
     /*  129891 */     // GIR_Coverage, 65581,
     /*  129891 */     GIR_EraseRootFromParent_Done,
     /*  129892 */   // Label 2308: @129892
     /*  129892 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(130087), // Rule ID 65585 //
     /*  129897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129936 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  129940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129948 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129952 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129956 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  129960 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129964 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129968 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129972 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129976 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  129980 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129984 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129988 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129992 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129996 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130005 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130012 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  130019 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  130026 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  130026 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  130029 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130033 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  130043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  130048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  130050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  130067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  130072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  130085 */     GIR_RootConstrainSelectedInstOperands,
     /*  130086 */     // GIR_Coverage, 65585,
     /*  130086 */     GIR_EraseRootFromParent_Done,
     /*  130087 */   // Label 2309: @130087
     /*  130087 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(130282), // Rule ID 2561 //
     /*  130092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  130095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130131 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  130135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  130139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  130147 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  130151 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  130155 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  130159 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130163 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  130167 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  130171 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  130175 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130179 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  130183 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  130187 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  130191 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  130193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130200 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130207 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  130214 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  130221 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  130221 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  130224 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130228 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  130238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  130243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  130245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  130262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  130267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  130280 */     GIR_RootConstrainSelectedInstOperands,
     /*  130281 */     // GIR_Coverage, 2561,
     /*  130281 */     GIR_EraseRootFromParent_Done,
     /*  130282 */   // Label 2310: @130282
     /*  130282 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(130477), // Rule ID 65583 //
     /*  130287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  130290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130326 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  130330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  130334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130338 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  130342 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  130346 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  130350 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  130354 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130358 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  130362 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  130366 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  130370 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130374 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  130378 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  130382 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  130386 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  130388 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130395 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130402 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  130409 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  130416 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  130416 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  130419 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130423 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  130433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  130438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  130440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  130457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  130462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  130475 */     GIR_RootConstrainSelectedInstOperands,
     /*  130476 */     // GIR_Coverage, 65583,
     /*  130476 */     GIR_EraseRootFromParent_Done,
     /*  130477 */   // Label 2311: @130477
     /*  130477 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(130582), // Rule ID 2556 //
     /*  130482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130505 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  130509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  130513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130525 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  130529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130545 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  130545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  130562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  130572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  130580 */     GIR_RootConstrainSelectedInstOperands,
     /*  130581 */     // GIR_Coverage, 2556,
     /*  130581 */     GIR_EraseRootFromParent_Done,
     /*  130582 */   // Label 2312: @130582
     /*  130582 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(130687), // Rule ID 65576 //
     /*  130587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130610 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  130614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  130618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130630 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  130634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130650 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  130650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  130672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  130677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  130685 */     GIR_RootConstrainSelectedInstOperands,
     /*  130686 */     // GIR_Coverage, 65576,
     /*  130686 */     GIR_EraseRootFromParent_Done,
     /*  130687 */   // Label 2313: @130687
     /*  130687 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(130776), // Rule ID 65570 //
     /*  130692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  130707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130731 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130736 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  130740 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  130751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130760 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  130774 */     GIR_RootConstrainSelectedInstOperands,
     /*  130775 */     // GIR_Coverage, 65570,
     /*  130775 */     GIR_EraseRootFromParent_Done,
     /*  130776 */   // Label 2314: @130776
     /*  130776 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(130865), // Rule ID 2550 //
     /*  130781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  130796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130825 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  130829 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  130840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130849 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  130863 */     GIR_RootConstrainSelectedInstOperands,
     /*  130864 */     // GIR_Coverage, 2550,
     /*  130864 */     GIR_EraseRootFromParent_Done,
     /*  130865 */   // Label 2315: @130865
     /*  130865 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(130930), // Rule ID 65572 //
     /*  130870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130893 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130913 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  130928 */     GIR_RootConstrainSelectedInstOperands,
     /*  130929 */     // GIR_Coverage, 65572,
     /*  130929 */     GIR_EraseRootFromParent_Done,
     /*  130930 */   // Label 2316: @130930
     /*  130930 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(130995), // Rule ID 2552 //
     /*  130935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130958 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130978 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  130988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130993 */     GIR_RootConstrainSelectedInstOperands,
     /*  130994 */     // GIR_Coverage, 2552,
     /*  130994 */     GIR_EraseRootFromParent_Done,
     /*  130995 */   // Label 2317: @130995
     /*  130995 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131061), // Rule ID 65578 //
     /*  131000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  131003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131028 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  131032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11319),
     /*  131036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131045 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }))<<P:Predicate_anonymous_11319>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  131055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131059 */     GIR_RootConstrainSelectedInstOperands,
     /*  131060 */     // GIR_Coverage, 65578,
     /*  131060 */     GIR_EraseRootFromParent_Done,
     /*  131061 */   // Label 2318: @131061
     /*  131061 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131127), // Rule ID 2558 //
     /*  131066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  131069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131094 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  131098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11319),
     /*  131102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131111 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))<<P:Predicate_anonymous_11319>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  131121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131125 */     GIR_RootConstrainSelectedInstOperands,
     /*  131126 */     // GIR_Coverage, 2558,
     /*  131126 */     GIR_EraseRootFromParent_Done,
     /*  131127 */   // Label 2319: @131127
     /*  131127 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(131189), // Rule ID 2559 //
     /*  131132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  131135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131160 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  131164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  131173 */     // (or:{ *:[i32] } (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  131183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131187 */     GIR_RootConstrainSelectedInstOperands,
     /*  131188 */     // GIR_Coverage, 2559,
     /*  131188 */     GIR_EraseRootFromParent_Done,
     /*  131189 */   // Label 2320: @131189
     /*  131189 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(131251), // Rule ID 65579 //
     /*  131194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  131197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131222 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  131226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  131235 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }), (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  131245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131249 */     GIR_RootConstrainSelectedInstOperands,
     /*  131250 */     // GIR_Coverage, 65579,
     /*  131250 */     GIR_EraseRootFromParent_Done,
     /*  131251 */   // Label 2321: @131251
     /*  131251 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(131310), // Rule ID 2485 //
     /*  131256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  131259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131279 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  131283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  131296 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  131299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  131308 */     GIR_RootConstrainSelectedInstOperands,
     /*  131309 */     // GIR_Coverage, 2485,
     /*  131309 */     GIR_EraseRootFromParent_Done,
     /*  131310 */   // Label 2322: @131310
     /*  131310 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(131369), // Rule ID 65566 //
     /*  131315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  131318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131342 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  131346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  131355 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  131358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  131367 */     GIR_RootConstrainSelectedInstOperands,
     /*  131368 */     // GIR_Coverage, 65566,
     /*  131368 */     GIR_EraseRootFromParent_Done,
     /*  131369 */   // Label 2323: @131369
     /*  131369 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(131425), // Rule ID 65550 //
     /*  131374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  131377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  131389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131402 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  131406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131412 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  131415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131423 */     GIR_RootConstrainSelectedInstOperands,
     /*  131424 */     // GIR_Coverage, 65550,
     /*  131424 */     GIR_EraseRootFromParent_Done,
     /*  131425 */   // Label 2324: @131425
     /*  131425 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(131481), // Rule ID 2457 //
     /*  131430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  131433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  131449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131462 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  131466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131468 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  131471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131479 */     GIR_RootConstrainSelectedInstOperands,
     /*  131480 */     // GIR_Coverage, 2457,
     /*  131480 */     GIR_EraseRootFromParent_Done,
     /*  131481 */   // Label 2325: @131481
     /*  131481 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(131523), // Rule ID 95 //
     /*  131486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  131489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  131509 */     // MIs[1] Operand 1
     /*  131509 */     // No operand predicates
     /*  131509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131511 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  131511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  131514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  131521 */     GIR_RootConstrainSelectedInstOperands,
     /*  131522 */     // GIR_Coverage, 95,
     /*  131522 */     GIR_EraseRootFromParent_Done,
     /*  131523 */   // Label 2326: @131523
     /*  131523 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(131565), // Rule ID 64547 //
     /*  131528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  131531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  131551 */     // MIs[1] Operand 1
     /*  131551 */     // No operand predicates
     /*  131551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131553 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  131553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORAI),
     /*  131556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  131558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  131563 */     GIR_RootConstrainSelectedInstOperands,
     /*  131564 */     // GIR_Coverage, 64547,
     /*  131564 */     GIR_EraseRootFromParent_Done,
     /*  131565 */   // Label 2327: @131565
     /*  131565 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(131607), // Rule ID 64551 //
     /*  131570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  131573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  131593 */     // MIs[1] Operand 1
     /*  131593 */     // No operand predicates
     /*  131593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131595 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  131595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORI),
     /*  131598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  131605 */     GIR_RootConstrainSelectedInstOperands,
     /*  131606 */     // GIR_Coverage, 64551,
     /*  131606 */     GIR_EraseRootFromParent_Done,
     /*  131607 */   // Label 2328: @131607
     /*  131607 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(131634), // Rule ID 93 //
     /*  131612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  131615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131627 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (OR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  131632 */     GIR_RootConstrainSelectedInstOperands,
     /*  131633 */     // GIR_Coverage, 93,
     /*  131633 */     GIR_Done,
     /*  131634 */   // Label 2329: @131634
     /*  131634 */   GIM_Reject,
     /*  131635 */ // Label 2303: @131635
     /*  131635 */ GIM_Reject,
     /*  131636 */ // Label 2272: @131636
     /*  131636 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(134583),
     /*  131641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  131644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  131647 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(131842), // Rule ID 65590 //
     /*  131652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  131679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131691 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131703 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131707 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131711 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131715 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131719 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131723 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131727 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  131731 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131735 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131739 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131743 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131747 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  131751 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131767 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131774 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131781 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131781 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131784 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131788 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  131798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  131803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  131822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  131827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131840 */     GIR_RootConstrainSelectedInstOperands,
     /*  131841 */     // GIR_Coverage, 65590,
     /*  131841 */     GIR_EraseRootFromParent_Done,
     /*  131842 */   // Label 2331: @131842
     /*  131842 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(132037), // Rule ID 65592 //
     /*  131847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  131874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131886 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131898 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131902 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131906 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131910 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131914 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131918 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131922 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  131926 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131930 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131934 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131938 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131942 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  131946 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131962 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131969 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131976 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131976 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131979 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131983 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  131993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  131998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  132017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  132022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132035 */     GIR_RootConstrainSelectedInstOperands,
     /*  132036 */     // GIR_Coverage, 65592,
     /*  132036 */     GIR_EraseRootFromParent_Done,
     /*  132037 */   // Label 2332: @132037
     /*  132037 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(132232), // Rule ID 65586 //
     /*  132042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132081 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  132085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  132089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132093 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132097 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132101 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  132105 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132109 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132113 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132117 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  132121 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  132125 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132129 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132133 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132137 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  132141 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132157 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132164 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132171 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  132188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  132193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  132212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  132217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132230 */     GIR_RootConstrainSelectedInstOperands,
     /*  132231 */     // GIR_Coverage, 65586,
     /*  132231 */     GIR_EraseRootFromParent_Done,
     /*  132232 */   // Label 2333: @132232
     /*  132232 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(132427), // Rule ID 65588 //
     /*  132237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132276 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  132280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  132284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132288 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132292 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132296 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  132300 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132304 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132308 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132312 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  132316 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  132320 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132324 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132328 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132332 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  132336 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132352 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132359 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132366 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132366 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132369 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132373 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  132383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  132388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  132407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  132412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132425 */     GIR_RootConstrainSelectedInstOperands,
     /*  132426 */     // GIR_Coverage, 65588,
     /*  132426 */     GIR_EraseRootFromParent_Done,
     /*  132427 */   // Label 2334: @132427
     /*  132427 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(132622), // Rule ID 65580 //
     /*  132432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132471 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  132475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132483 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132487 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132491 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  132495 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132499 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132503 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132507 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132511 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  132515 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132519 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132523 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132527 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132531 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132540 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132547 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132554 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132561 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132561 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132564 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132568 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  132578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  132583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  132602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  132607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132620 */     GIR_RootConstrainSelectedInstOperands,
     /*  132621 */     // GIR_Coverage, 65580,
     /*  132621 */     GIR_EraseRootFromParent_Done,
     /*  132622 */   // Label 2335: @132622
     /*  132622 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(132817), // Rule ID 65584 //
     /*  132627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132666 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132682 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132686 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  132690 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132694 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132698 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132702 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132706 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  132710 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132714 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132718 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132722 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132726 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132728 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132735 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132742 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132749 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132756 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132756 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132759 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132763 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  132773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  132778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  132797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  132802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132815 */     GIR_RootConstrainSelectedInstOperands,
     /*  132816 */     // GIR_Coverage, 65584,
     /*  132816 */     GIR_EraseRootFromParent_Done,
     /*  132817 */   // Label 2336: @132817
     /*  132817 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133012), // Rule ID 2560 //
     /*  132822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132861 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  132865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132873 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132877 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132881 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  132885 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132889 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132893 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132897 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132901 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  132905 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132909 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132913 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132917 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132921 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132930 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132937 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132944 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132951 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132951 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132954 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132958 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  132968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  132973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  132992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  132997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  133002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  133010 */     GIR_RootConstrainSelectedInstOperands,
     /*  133011 */     // GIR_Coverage, 2560,
     /*  133011 */     GIR_EraseRootFromParent_Done,
     /*  133012 */   // Label 2337: @133012
     /*  133012 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133207), // Rule ID 65582 //
     /*  133017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  133020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  133032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133056 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  133060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  133064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133068 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  133072 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  133076 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  133080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  133084 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  133088 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  133092 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  133096 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  133100 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133104 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  133108 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  133112 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  133116 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  133118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133125 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133132 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  133139 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  133146 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  133146 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  133149 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133153 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  133163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  133168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  133170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  133173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  133187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  133192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  133197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  133205 */     GIR_RootConstrainSelectedInstOperands,
     /*  133206 */     // GIR_Coverage, 65582,
     /*  133206 */     GIR_EraseRootFromParent_Done,
     /*  133207 */   // Label 2338: @133207
     /*  133207 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133312), // Rule ID 2555 //
     /*  133212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133235 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  133239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  133243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133255 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  133259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133275 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  133275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  133278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  133292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  133302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  133310 */     GIR_RootConstrainSelectedInstOperands,
     /*  133311 */     // GIR_Coverage, 2555,
     /*  133311 */     GIR_EraseRootFromParent_Done,
     /*  133312 */   // Label 2339: @133312
     /*  133312 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133417), // Rule ID 65575 //
     /*  133317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133340 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  133344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  133348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133360 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  133364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133380 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  133380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  133383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  133402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  133407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  133415 */     GIR_RootConstrainSelectedInstOperands,
     /*  133416 */     // GIR_Coverage, 65575,
     /*  133416 */     GIR_EraseRootFromParent_Done,
     /*  133417 */   // Label 2340: @133417
     /*  133417 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(133506), // Rule ID 65569 //
     /*  133422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  133437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133466 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  133470 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  133481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133490 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133504 */     GIR_RootConstrainSelectedInstOperands,
     /*  133505 */     // GIR_Coverage, 65569,
     /*  133505 */     GIR_EraseRootFromParent_Done,
     /*  133506 */   // Label 2341: @133506
     /*  133506 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(133595), // Rule ID 2549 //
     /*  133511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  133526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133555 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  133559 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  133570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133579 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133593 */     GIR_RootConstrainSelectedInstOperands,
     /*  133594 */     // GIR_Coverage, 2549,
     /*  133594 */     GIR_EraseRootFromParent_Done,
     /*  133595 */   // Label 2342: @133595
     /*  133595 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(133660), // Rule ID 65571 //
     /*  133600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133623 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133643 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  133658 */     GIR_RootConstrainSelectedInstOperands,
     /*  133659 */     // GIR_Coverage, 65571,
     /*  133659 */     GIR_EraseRootFromParent_Done,
     /*  133660 */   // Label 2343: @133660
     /*  133660 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(133725), // Rule ID 2551 //
     /*  133665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133688 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133708 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  133718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133723 */     GIR_RootConstrainSelectedInstOperands,
     /*  133724 */     // GIR_Coverage, 2551,
     /*  133724 */     GIR_EraseRootFromParent_Done,
     /*  133725 */   // Label 2344: @133725
     /*  133725 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(133810), // Rule ID 65596 //
     /*  133730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  133745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133770 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  133774 */     // MIs[1] Operand 2
     /*  133774 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  133785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133794 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133808 */     GIR_RootConstrainSelectedInstOperands,
     /*  133809 */     // GIR_Coverage, 65596,
     /*  133809 */     GIR_EraseRootFromParent_Done,
     /*  133810 */   // Label 2345: @133810
     /*  133810 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(133895), // Rule ID 2564 //
     /*  133815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  133830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133855 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  133859 */     // MIs[1] Operand 2
     /*  133859 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  133870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133879 */     // (or:{ *:[i64] } (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133893 */     GIR_RootConstrainSelectedInstOperands,
     /*  133894 */     // GIR_Coverage, 2564,
     /*  133894 */     GIR_EraseRootFromParent_Done,
     /*  133895 */   // Label 2346: @133895
     /*  133895 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(133961), // Rule ID 65577 //
     /*  133900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133928 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11319),
     /*  133936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133945 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }))<<P:Predicate_anonymous_11319>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133959 */     GIR_RootConstrainSelectedInstOperands,
     /*  133960 */     // GIR_Coverage, 65577,
     /*  133960 */     GIR_EraseRootFromParent_Done,
     /*  133961 */   // Label 2347: @133961
     /*  133961 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(134027), // Rule ID 65595 //
     /*  133966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133994 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  133998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10095),
     /*  134002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  134011 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }))<<P:Predicate_anonymous_10095>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  134014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  134021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134025 */     GIR_RootConstrainSelectedInstOperands,
     /*  134026 */     // GIR_Coverage, 65595,
     /*  134026 */     GIR_EraseRootFromParent_Done,
     /*  134027 */   // Label 2348: @134027
     /*  134027 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(134093), // Rule ID 2557 //
     /*  134032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  134035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  134047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134060 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  134064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11319),
     /*  134068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  134077 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_11319>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  134080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  134087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134091 */     GIR_RootConstrainSelectedInstOperands,
     /*  134092 */     // GIR_Coverage, 2557,
     /*  134092 */     GIR_EraseRootFromParent_Done,
     /*  134093 */   // Label 2349: @134093
     /*  134093 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134159), // Rule ID 2563 //
     /*  134098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  134101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  134113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134126 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  134130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10095),
     /*  134134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  134143 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_10095>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  134146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  134153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134157 */     GIR_RootConstrainSelectedInstOperands,
     /*  134158 */     // GIR_Coverage, 2563,
     /*  134158 */     GIR_EraseRootFromParent_Done,
     /*  134159 */   // Label 2350: @134159
     /*  134159 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134221), // Rule ID 2562 //
     /*  134164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  134167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  134179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134192 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  134196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  134205 */     // (or:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  134208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  134215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134219 */     GIR_RootConstrainSelectedInstOperands,
     /*  134220 */     // GIR_Coverage, 2562,
     /*  134220 */     GIR_EraseRootFromParent_Done,
     /*  134221 */   // Label 2351: @134221
     /*  134221 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(134283), // Rule ID 65594 //
     /*  134226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  134229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  134241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134254 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  134258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  134267 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }), (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  134270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  134277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134281 */     GIR_RootConstrainSelectedInstOperands,
     /*  134282 */     // GIR_Coverage, 65594,
     /*  134282 */     GIR_EraseRootFromParent_Done,
     /*  134283 */   // Label 2352: @134283
     /*  134283 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(134342), // Rule ID 2484 //
     /*  134288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  134291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  134303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134311 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  134315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  134328 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  134331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  134340 */     GIR_RootConstrainSelectedInstOperands,
     /*  134341 */     // GIR_Coverage, 2484,
     /*  134341 */     GIR_EraseRootFromParent_Done,
     /*  134342 */   // Label 2353: @134342
     /*  134342 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(134401), // Rule ID 65565 //
     /*  134347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  134350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  134366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134374 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  134378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  134387 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  134390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  134399 */     GIR_RootConstrainSelectedInstOperands,
     /*  134400 */     // GIR_Coverage, 65565,
     /*  134400 */     GIR_EraseRootFromParent_Done,
     /*  134401 */   // Label 2354: @134401
     /*  134401 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(134457), // Rule ID 65549 //
     /*  134406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  134409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134434 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  134438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134444 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  134447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134455 */     GIR_RootConstrainSelectedInstOperands,
     /*  134456 */     // GIR_Coverage, 65549,
     /*  134456 */     GIR_EraseRootFromParent_Done,
     /*  134457 */   // Label 2355: @134457
     /*  134457 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(134513), // Rule ID 2456 //
     /*  134462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  134465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134494 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  134498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134500 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  134503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134511 */     GIR_RootConstrainSelectedInstOperands,
     /*  134512 */     // GIR_Coverage, 2456,
     /*  134512 */     GIR_EraseRootFromParent_Done,
     /*  134513 */   // Label 2356: @134513
     /*  134513 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(134555), // Rule ID 94 //
     /*  134518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  134521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  134541 */     // MIs[1] Operand 1
     /*  134541 */     // No operand predicates
     /*  134541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134543 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  134543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  134546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  134553 */     GIR_RootConstrainSelectedInstOperands,
     /*  134554 */     // GIR_Coverage, 94,
     /*  134554 */     GIR_EraseRootFromParent_Done,
     /*  134555 */   // Label 2357: @134555
     /*  134555 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(134582), // Rule ID 92 //
     /*  134560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  134563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134575 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (OR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  134580 */     GIR_RootConstrainSelectedInstOperands,
     /*  134581 */     // GIR_Coverage, 92,
     /*  134581 */     GIR_Done,
     /*  134582 */   // Label 2358: @134582
     /*  134582 */   GIM_Reject,
     /*  134583 */ // Label 2330: @134583
     /*  134583 */ GIM_Reject,
     /*  134584 */ // Label 2273: @134584
     /*  134584 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(135194),
     /*  134589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134599 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(134665), // Rule ID 71779 //
     /*  134604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134646 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134663 */     GIR_RootConstrainSelectedInstOperands,
     /*  134664 */     // GIR_Coverage, 71779,
     /*  134664 */     GIR_EraseRootFromParent_Done,
     /*  134665 */   // Label 2360: @134665
     /*  134665 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(134731), // Rule ID 71780 //
     /*  134670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134712 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134729 */     GIR_RootConstrainSelectedInstOperands,
     /*  134730 */     // GIR_Coverage, 71780,
     /*  134730 */     GIR_EraseRootFromParent_Done,
     /*  134731 */   // Label 2361: @134731
     /*  134731 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(134797), // Rule ID 71777 //
     /*  134736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134778 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134795 */     GIR_RootConstrainSelectedInstOperands,
     /*  134796 */     // GIR_Coverage, 71777,
     /*  134796 */     GIR_EraseRootFromParent_Done,
     /*  134797 */   // Label 2362: @134797
     /*  134797 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(134863), // Rule ID 71778 //
     /*  134802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134844 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134861 */     GIR_RootConstrainSelectedInstOperands,
     /*  134862 */     // GIR_Coverage, 71778,
     /*  134862 */     GIR_EraseRootFromParent_Done,
     /*  134863 */   // Label 2363: @134863
     /*  134863 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(134929), // Rule ID 71775 //
     /*  134868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134910 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134927 */     GIR_RootConstrainSelectedInstOperands,
     /*  134928 */     // GIR_Coverage, 71775,
     /*  134928 */     GIR_EraseRootFromParent_Done,
     /*  134929 */   // Label 2364: @134929
     /*  134929 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(134995), // Rule ID 71776 //
     /*  134934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134976 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134993 */     GIR_RootConstrainSelectedInstOperands,
     /*  134994 */     // GIR_Coverage, 71776,
     /*  134994 */     GIR_EraseRootFromParent_Done,
     /*  134995 */   // Label 2365: @134995
     /*  134995 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(135061), // Rule ID 53186 //
     /*  135000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  135019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  135023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135042 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  135045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135059 */     GIR_RootConstrainSelectedInstOperands,
     /*  135060 */     // GIR_Coverage, 53186,
     /*  135060 */     GIR_EraseRootFromParent_Done,
     /*  135061 */   // Label 2366: @135061
     /*  135061 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(135127), // Rule ID 53187 //
     /*  135066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  135085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  135089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135108 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  135111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135125 */     GIR_RootConstrainSelectedInstOperands,
     /*  135126 */     // GIR_Coverage, 53187,
     /*  135126 */     GIR_EraseRootFromParent_Done,
     /*  135127 */   // Label 2367: @135127
     /*  135127 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(135160), // Rule ID 53174 //
     /*  135132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135143 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  135146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135158 */     GIR_RootConstrainSelectedInstOperands,
     /*  135159 */     // GIR_Coverage, 53174,
     /*  135159 */     GIR_EraseRootFromParent_Done,
     /*  135160 */   // Label 2368: @135160
     /*  135160 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(135193), // Rule ID 53175 //
     /*  135165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135176 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  135179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135191 */     GIR_RootConstrainSelectedInstOperands,
     /*  135192 */     // GIR_Coverage, 53175,
     /*  135192 */     GIR_EraseRootFromParent_Done,
     /*  135193 */   // Label 2369: @135193
     /*  135193 */   GIM_Reject,
     /*  135194 */ // Label 2359: @135194
     /*  135194 */ GIM_Reject,
     /*  135195 */ // Label 2274: @135195
     /*  135195 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(135309),
     /*  135200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  135203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  135206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135218 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(135263), // Rule ID 47796 //
     /*  135223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135226 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  135226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  135229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  135243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135261 */     GIR_RootConstrainSelectedInstOperands,
     /*  135262 */     // GIR_Coverage, 47796,
     /*  135262 */     GIR_EraseRootFromParent_Done,
     /*  135263 */   // Label 2371: @135263
     /*  135263 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(135308), // Rule ID 47797 //
     /*  135268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135271 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  135271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  135274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  135288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135306 */     GIR_RootConstrainSelectedInstOperands,
     /*  135307 */     // GIR_Coverage, 47797,
     /*  135307 */     GIR_EraseRootFromParent_Done,
     /*  135308 */   // Label 2372: @135308
     /*  135308 */   GIM_Reject,
     /*  135309 */ // Label 2370: @135309
     /*  135309 */ GIM_Reject,
     /*  135310 */ // Label 2275: @135310
     /*  135310 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(135424),
     /*  135315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  135318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  135321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135333 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(135378), // Rule ID 47808 //
     /*  135338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135341 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  135341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  135344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  135358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135376 */     GIR_RootConstrainSelectedInstOperands,
     /*  135377 */     // GIR_Coverage, 47808,
     /*  135377 */     GIR_EraseRootFromParent_Done,
     /*  135378 */   // Label 2374: @135378
     /*  135378 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(135423), // Rule ID 47809 //
     /*  135383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135386 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  135386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  135389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  135403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135421 */     GIR_RootConstrainSelectedInstOperands,
     /*  135422 */     // GIR_Coverage, 47809,
     /*  135422 */     GIR_EraseRootFromParent_Done,
     /*  135423 */   // Label 2375: @135423
     /*  135423 */   GIM_Reject,
     /*  135424 */ // Label 2373: @135424
     /*  135424 */ GIM_Reject,
     /*  135425 */ // Label 2276: @135425
     /*  135425 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(135539),
     /*  135430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  135433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  135436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135448 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(135493), // Rule ID 47816 //
     /*  135453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135456 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  135456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  135459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135491 */     GIR_RootConstrainSelectedInstOperands,
     /*  135492 */     // GIR_Coverage, 47816,
     /*  135492 */     GIR_EraseRootFromParent_Done,
     /*  135493 */   // Label 2377: @135493
     /*  135493 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(135538), // Rule ID 47817 //
     /*  135498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135501 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  135501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  135504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135536 */     GIR_RootConstrainSelectedInstOperands,
     /*  135537 */     // GIR_Coverage, 47817,
     /*  135537 */     GIR_EraseRootFromParent_Done,
     /*  135538 */   // Label 2378: @135538
     /*  135538 */   GIM_Reject,
     /*  135539 */ // Label 2376: @135539
     /*  135539 */ GIM_Reject,
     /*  135540 */ // Label 2277: @135540
     /*  135540 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(135654),
     /*  135545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  135548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  135551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135563 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(135608), // Rule ID 47832 //
     /*  135568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  135571 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  135571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  135574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  135588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135606 */     GIR_RootConstrainSelectedInstOperands,
     /*  135607 */     // GIR_Coverage, 47832,
     /*  135607 */     GIR_EraseRootFromParent_Done,
     /*  135608 */   // Label 2380: @135608
     /*  135608 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(135653), // Rule ID 47833 //
     /*  135613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  135616 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  135616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  135619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  135633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135651 */     GIR_RootConstrainSelectedInstOperands,
     /*  135652 */     // GIR_Coverage, 47833,
     /*  135652 */     GIR_EraseRootFromParent_Done,
     /*  135653 */   // Label 2381: @135653
     /*  135653 */   GIM_Reject,
     /*  135654 */ // Label 2379: @135654
     /*  135654 */ GIM_Reject,
     /*  135655 */ // Label 2278: @135655
     /*  135655 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(136265),
     /*  135660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135670 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(135736), // Rule ID 71807 //
     /*  135675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135717 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135734 */     GIR_RootConstrainSelectedInstOperands,
     /*  135735 */     // GIR_Coverage, 71807,
     /*  135735 */     GIR_EraseRootFromParent_Done,
     /*  135736 */   // Label 2383: @135736
     /*  135736 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(135802), // Rule ID 71808 //
     /*  135741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135783 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135800 */     GIR_RootConstrainSelectedInstOperands,
     /*  135801 */     // GIR_Coverage, 71808,
     /*  135801 */     GIR_EraseRootFromParent_Done,
     /*  135802 */   // Label 2384: @135802
     /*  135802 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(135868), // Rule ID 71805 //
     /*  135807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135849 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135866 */     GIR_RootConstrainSelectedInstOperands,
     /*  135867 */     // GIR_Coverage, 71805,
     /*  135867 */     GIR_EraseRootFromParent_Done,
     /*  135868 */   // Label 2385: @135868
     /*  135868 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(135934), // Rule ID 71806 //
     /*  135873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135915 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135932 */     GIR_RootConstrainSelectedInstOperands,
     /*  135933 */     // GIR_Coverage, 71806,
     /*  135933 */     GIR_EraseRootFromParent_Done,
     /*  135934 */   // Label 2386: @135934
     /*  135934 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(136000), // Rule ID 71803 //
     /*  135939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135981 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135998 */     GIR_RootConstrainSelectedInstOperands,
     /*  135999 */     // GIR_Coverage, 71803,
     /*  135999 */     GIR_EraseRootFromParent_Done,
     /*  136000 */   // Label 2387: @136000
     /*  136000 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(136066), // Rule ID 71804 //
     /*  136005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  136024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  136028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136047 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  136050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136064 */     GIR_RootConstrainSelectedInstOperands,
     /*  136065 */     // GIR_Coverage, 71804,
     /*  136065 */     GIR_EraseRootFromParent_Done,
     /*  136066 */   // Label 2388: @136066
     /*  136066 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(136132), // Rule ID 53204 //
     /*  136071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  136090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  136094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136113 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  136116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136130 */     GIR_RootConstrainSelectedInstOperands,
     /*  136131 */     // GIR_Coverage, 53204,
     /*  136131 */     GIR_EraseRootFromParent_Done,
     /*  136132 */   // Label 2389: @136132
     /*  136132 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(136198), // Rule ID 53205 //
     /*  136137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  136156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  136160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136179 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  136182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136196 */     GIR_RootConstrainSelectedInstOperands,
     /*  136197 */     // GIR_Coverage, 53205,
     /*  136197 */     GIR_EraseRootFromParent_Done,
     /*  136198 */   // Label 2390: @136198
     /*  136198 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(136231), // Rule ID 53192 //
     /*  136203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136214 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  136217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136229 */     GIR_RootConstrainSelectedInstOperands,
     /*  136230 */     // GIR_Coverage, 53192,
     /*  136230 */     GIR_EraseRootFromParent_Done,
     /*  136231 */   // Label 2391: @136231
     /*  136231 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(136264), // Rule ID 53193 //
     /*  136236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136247 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  136250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136262 */     GIR_RootConstrainSelectedInstOperands,
     /*  136263 */     // GIR_Coverage, 53193,
     /*  136263 */     GIR_EraseRootFromParent_Done,
     /*  136264 */   // Label 2392: @136264
     /*  136264 */   GIM_Reject,
     /*  136265 */ // Label 2382: @136265
     /*  136265 */ GIM_Reject,
     /*  136266 */ // Label 2279: @136266
     /*  136266 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(136380),
     /*  136271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  136274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  136277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136289 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(136334), // Rule ID 47800 //
     /*  136294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136297 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  136297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  136300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  136314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136332 */     GIR_RootConstrainSelectedInstOperands,
     /*  136333 */     // GIR_Coverage, 47800,
     /*  136333 */     GIR_EraseRootFromParent_Done,
     /*  136334 */   // Label 2394: @136334
     /*  136334 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(136379), // Rule ID 47801 //
     /*  136339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136342 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  136342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  136345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  136359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136377 */     GIR_RootConstrainSelectedInstOperands,
     /*  136378 */     // GIR_Coverage, 47801,
     /*  136378 */     GIR_EraseRootFromParent_Done,
     /*  136379 */   // Label 2395: @136379
     /*  136379 */   GIM_Reject,
     /*  136380 */ // Label 2393: @136380
     /*  136380 */ GIM_Reject,
     /*  136381 */ // Label 2280: @136381
     /*  136381 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(136495),
     /*  136386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  136389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  136392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136404 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(136449), // Rule ID 47812 //
     /*  136409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136412 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  136412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  136415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  136444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136447 */     GIR_RootConstrainSelectedInstOperands,
     /*  136448 */     // GIR_Coverage, 47812,
     /*  136448 */     GIR_EraseRootFromParent_Done,
     /*  136449 */   // Label 2397: @136449
     /*  136449 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(136494), // Rule ID 47813 //
     /*  136454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136457 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  136457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  136460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  136489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136492 */     GIR_RootConstrainSelectedInstOperands,
     /*  136493 */     // GIR_Coverage, 47813,
     /*  136493 */     GIR_EraseRootFromParent_Done,
     /*  136494 */   // Label 2398: @136494
     /*  136494 */   GIM_Reject,
     /*  136495 */ // Label 2396: @136495
     /*  136495 */ GIM_Reject,
     /*  136496 */ // Label 2281: @136496
     /*  136496 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(136610),
     /*  136501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  136504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  136507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136519 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(136564), // Rule ID 47828 //
     /*  136524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136527 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  136527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  136530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  136544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136562 */     GIR_RootConstrainSelectedInstOperands,
     /*  136563 */     // GIR_Coverage, 47828,
     /*  136563 */     GIR_EraseRootFromParent_Done,
     /*  136564 */   // Label 2400: @136564
     /*  136564 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(136609), // Rule ID 47829 //
     /*  136569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136572 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  136572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  136575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  136589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136607 */     GIR_RootConstrainSelectedInstOperands,
     /*  136608 */     // GIR_Coverage, 47829,
     /*  136608 */     GIR_EraseRootFromParent_Done,
     /*  136609 */   // Label 2401: @136609
     /*  136609 */   GIM_Reject,
     /*  136610 */ // Label 2399: @136610
     /*  136610 */ GIM_Reject,
     /*  136611 */ // Label 2282: @136611
     /*  136611 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(136725),
     /*  136616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  136619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  136622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136634 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(136679), // Rule ID 47872 //
     /*  136639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  136642 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  136642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  136645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  136659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136677 */     GIR_RootConstrainSelectedInstOperands,
     /*  136678 */     // GIR_Coverage, 47872,
     /*  136678 */     GIR_EraseRootFromParent_Done,
     /*  136679 */   // Label 2403: @136679
     /*  136679 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(136724), // Rule ID 47873 //
     /*  136684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  136687 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  136687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  136690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  136704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136722 */     GIR_RootConstrainSelectedInstOperands,
     /*  136723 */     // GIR_Coverage, 47873,
     /*  136723 */     GIR_EraseRootFromParent_Done,
     /*  136724 */   // Label 2404: @136724
     /*  136724 */   GIM_Reject,
     /*  136725 */ // Label 2402: @136725
     /*  136725 */ GIM_Reject,
     /*  136726 */ // Label 2283: @136726
     /*  136726 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(137336),
     /*  136731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136741 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(136807), // Rule ID 71835 //
     /*  136746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136788 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136805 */     GIR_RootConstrainSelectedInstOperands,
     /*  136806 */     // GIR_Coverage, 71835,
     /*  136806 */     GIR_EraseRootFromParent_Done,
     /*  136807 */   // Label 2406: @136807
     /*  136807 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(136873), // Rule ID 71836 //
     /*  136812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136854 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136871 */     GIR_RootConstrainSelectedInstOperands,
     /*  136872 */     // GIR_Coverage, 71836,
     /*  136872 */     GIR_EraseRootFromParent_Done,
     /*  136873 */   // Label 2407: @136873
     /*  136873 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(136939), // Rule ID 71833 //
     /*  136878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136920 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136937 */     GIR_RootConstrainSelectedInstOperands,
     /*  136938 */     // GIR_Coverage, 71833,
     /*  136938 */     GIR_EraseRootFromParent_Done,
     /*  136939 */   // Label 2408: @136939
     /*  136939 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(137005), // Rule ID 71834 //
     /*  136944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136986 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137003 */     GIR_RootConstrainSelectedInstOperands,
     /*  137004 */     // GIR_Coverage, 71834,
     /*  137004 */     GIR_EraseRootFromParent_Done,
     /*  137005 */   // Label 2409: @137005
     /*  137005 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(137071), // Rule ID 71831 //
     /*  137010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  137029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  137033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137052 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  137055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137069 */     GIR_RootConstrainSelectedInstOperands,
     /*  137070 */     // GIR_Coverage, 71831,
     /*  137070 */     GIR_EraseRootFromParent_Done,
     /*  137071 */   // Label 2410: @137071
     /*  137071 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(137137), // Rule ID 71832 //
     /*  137076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  137095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  137099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137118 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  137121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137135 */     GIR_RootConstrainSelectedInstOperands,
     /*  137136 */     // GIR_Coverage, 71832,
     /*  137136 */     GIR_EraseRootFromParent_Done,
     /*  137137 */   // Label 2411: @137137
     /*  137137 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(137203), // Rule ID 53222 //
     /*  137142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  137161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  137165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137184 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  137187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137201 */     GIR_RootConstrainSelectedInstOperands,
     /*  137202 */     // GIR_Coverage, 53222,
     /*  137202 */     GIR_EraseRootFromParent_Done,
     /*  137203 */   // Label 2412: @137203
     /*  137203 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(137269), // Rule ID 53223 //
     /*  137208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  137227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  137231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137250 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  137253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137267 */     GIR_RootConstrainSelectedInstOperands,
     /*  137268 */     // GIR_Coverage, 53223,
     /*  137268 */     GIR_EraseRootFromParent_Done,
     /*  137269 */   // Label 2413: @137269
     /*  137269 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(137302), // Rule ID 53210 //
     /*  137274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137285 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  137288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137300 */     GIR_RootConstrainSelectedInstOperands,
     /*  137301 */     // GIR_Coverage, 53210,
     /*  137301 */     GIR_EraseRootFromParent_Done,
     /*  137302 */   // Label 2414: @137302
     /*  137302 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(137335), // Rule ID 53211 //
     /*  137307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137318 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  137321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137333 */     GIR_RootConstrainSelectedInstOperands,
     /*  137334 */     // GIR_Coverage, 53211,
     /*  137334 */     GIR_EraseRootFromParent_Done,
     /*  137335 */   // Label 2415: @137335
     /*  137335 */   GIM_Reject,
     /*  137336 */ // Label 2405: @137336
     /*  137336 */ GIM_Reject,
     /*  137337 */ // Label 2284: @137337
     /*  137337 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(137451),
     /*  137342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  137345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  137348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137360 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(137405), // Rule ID 47804 //
     /*  137365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137368 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  137368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  137371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  137385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137403 */     GIR_RootConstrainSelectedInstOperands,
     /*  137404 */     // GIR_Coverage, 47804,
     /*  137404 */     GIR_EraseRootFromParent_Done,
     /*  137405 */   // Label 2417: @137405
     /*  137405 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(137450), // Rule ID 47805 //
     /*  137410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137413 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  137413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  137416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  137430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137448 */     GIR_RootConstrainSelectedInstOperands,
     /*  137449 */     // GIR_Coverage, 47805,
     /*  137449 */     GIR_EraseRootFromParent_Done,
     /*  137450 */   // Label 2418: @137450
     /*  137450 */   GIM_Reject,
     /*  137451 */ // Label 2416: @137451
     /*  137451 */ GIM_Reject,
     /*  137452 */ // Label 2285: @137452
     /*  137452 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(137566),
     /*  137457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  137460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  137463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137475 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(137520), // Rule ID 47824 //
     /*  137480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137483 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  137483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  137486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137518 */     GIR_RootConstrainSelectedInstOperands,
     /*  137519 */     // GIR_Coverage, 47824,
     /*  137519 */     GIR_EraseRootFromParent_Done,
     /*  137520 */   // Label 2420: @137520
     /*  137520 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(137565), // Rule ID 47825 //
     /*  137525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137528 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  137528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  137531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137563 */     GIR_RootConstrainSelectedInstOperands,
     /*  137564 */     // GIR_Coverage, 47825,
     /*  137564 */     GIR_EraseRootFromParent_Done,
     /*  137565 */   // Label 2421: @137565
     /*  137565 */   GIM_Reject,
     /*  137566 */ // Label 2419: @137566
     /*  137566 */ GIM_Reject,
     /*  137567 */ // Label 2286: @137567
     /*  137567 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(137681),
     /*  137572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  137575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  137578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137590 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(137635), // Rule ID 47860 //
     /*  137595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137598 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  137598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  137601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  137615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137633 */     GIR_RootConstrainSelectedInstOperands,
     /*  137634 */     // GIR_Coverage, 47860,
     /*  137634 */     GIR_EraseRootFromParent_Done,
     /*  137635 */   // Label 2423: @137635
     /*  137635 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(137680), // Rule ID 47861 //
     /*  137640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137643 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  137643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  137646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  137660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137678 */     GIR_RootConstrainSelectedInstOperands,
     /*  137679 */     // GIR_Coverage, 47861,
     /*  137679 */     GIR_EraseRootFromParent_Done,
     /*  137680 */   // Label 2424: @137680
     /*  137680 */   GIM_Reject,
     /*  137681 */ // Label 2422: @137681
     /*  137681 */ GIM_Reject,
     /*  137682 */ // Label 2287: @137682
     /*  137682 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(137796),
     /*  137687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  137690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  137693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137705 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(137750), // Rule ID 47876 //
     /*  137710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  137713 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  137713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  137716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  137730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137748 */     GIR_RootConstrainSelectedInstOperands,
     /*  137749 */     // GIR_Coverage, 47876,
     /*  137749 */     GIR_EraseRootFromParent_Done,
     /*  137750 */   // Label 2426: @137750
     /*  137750 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(137795), // Rule ID 47877 //
     /*  137755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  137758 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  137758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  137761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  137775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137793 */     GIR_RootConstrainSelectedInstOperands,
     /*  137794 */     // GIR_Coverage, 47877,
     /*  137794 */     GIR_EraseRootFromParent_Done,
     /*  137795 */   // Label 2427: @137795
     /*  137795 */   GIM_Reject,
     /*  137796 */ // Label 2425: @137796
     /*  137796 */ GIM_Reject,
     /*  137797 */ // Label 2288: @137797
     /*  137797 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(138407),
     /*  137802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137812 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(137878), // Rule ID 71863 //
     /*  137817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137859 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137876 */     GIR_RootConstrainSelectedInstOperands,
     /*  137877 */     // GIR_Coverage, 71863,
     /*  137877 */     GIR_EraseRootFromParent_Done,
     /*  137878 */   // Label 2429: @137878
     /*  137878 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(137944), // Rule ID 71864 //
     /*  137883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137925 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137942 */     GIR_RootConstrainSelectedInstOperands,
     /*  137943 */     // GIR_Coverage, 71864,
     /*  137943 */     GIR_EraseRootFromParent_Done,
     /*  137944 */   // Label 2430: @137944
     /*  137944 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(138010), // Rule ID 71861 //
     /*  137949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137991 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138008 */     GIR_RootConstrainSelectedInstOperands,
     /*  138009 */     // GIR_Coverage, 71861,
     /*  138009 */     GIR_EraseRootFromParent_Done,
     /*  138010 */   // Label 2431: @138010
     /*  138010 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(138076), // Rule ID 71862 //
     /*  138015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  138030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  138034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138057 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  138060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138074 */     GIR_RootConstrainSelectedInstOperands,
     /*  138075 */     // GIR_Coverage, 71862,
     /*  138075 */     GIR_EraseRootFromParent_Done,
     /*  138076 */   // Label 2432: @138076
     /*  138076 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(138142), // Rule ID 71859 //
     /*  138081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  138100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  138104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138123 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  138126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138140 */     GIR_RootConstrainSelectedInstOperands,
     /*  138141 */     // GIR_Coverage, 71859,
     /*  138141 */     GIR_EraseRootFromParent_Done,
     /*  138142 */   // Label 2433: @138142
     /*  138142 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(138208), // Rule ID 71860 //
     /*  138147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  138166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  138170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138189 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  138192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138206 */     GIR_RootConstrainSelectedInstOperands,
     /*  138207 */     // GIR_Coverage, 71860,
     /*  138207 */     GIR_EraseRootFromParent_Done,
     /*  138208 */   // Label 2434: @138208
     /*  138208 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(138274), // Rule ID 53240 //
     /*  138213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  138232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  138236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138255 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  138258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138272 */     GIR_RootConstrainSelectedInstOperands,
     /*  138273 */     // GIR_Coverage, 53240,
     /*  138273 */     GIR_EraseRootFromParent_Done,
     /*  138274 */   // Label 2435: @138274
     /*  138274 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(138340), // Rule ID 53241 //
     /*  138279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  138298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  138302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138321 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  138324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138338 */     GIR_RootConstrainSelectedInstOperands,
     /*  138339 */     // GIR_Coverage, 53241,
     /*  138339 */     GIR_EraseRootFromParent_Done,
     /*  138340 */   // Label 2436: @138340
     /*  138340 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(138373), // Rule ID 53228 //
     /*  138345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138356 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  138359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138371 */     GIR_RootConstrainSelectedInstOperands,
     /*  138372 */     // GIR_Coverage, 53228,
     /*  138372 */     GIR_EraseRootFromParent_Done,
     /*  138373 */   // Label 2437: @138373
     /*  138373 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(138406), // Rule ID 53229 //
     /*  138378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138389 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  138392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138404 */     GIR_RootConstrainSelectedInstOperands,
     /*  138405 */     // GIR_Coverage, 53229,
     /*  138405 */     GIR_EraseRootFromParent_Done,
     /*  138406 */   // Label 2438: @138406
     /*  138406 */   GIM_Reject,
     /*  138407 */ // Label 2428: @138407
     /*  138407 */ GIM_Reject,
     /*  138408 */ // Label 2289: @138408
     /*  138408 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(138522),
     /*  138413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  138416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  138419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138431 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(138476), // Rule ID 47820 //
     /*  138436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138439 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  138439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  138442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  138456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138474 */     GIR_RootConstrainSelectedInstOperands,
     /*  138475 */     // GIR_Coverage, 47820,
     /*  138475 */     GIR_EraseRootFromParent_Done,
     /*  138476 */   // Label 2440: @138476
     /*  138476 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(138521), // Rule ID 47821 //
     /*  138481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138484 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  138484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  138487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  138501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138519 */     GIR_RootConstrainSelectedInstOperands,
     /*  138520 */     // GIR_Coverage, 47821,
     /*  138520 */     GIR_EraseRootFromParent_Done,
     /*  138521 */   // Label 2441: @138521
     /*  138521 */   GIM_Reject,
     /*  138522 */ // Label 2439: @138522
     /*  138522 */ GIM_Reject,
     /*  138523 */ // Label 2290: @138523
     /*  138523 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(138637),
     /*  138528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  138531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  138534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138546 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(138591), // Rule ID 47848 //
     /*  138551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138554 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  138554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  138557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  138571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138589 */     GIR_RootConstrainSelectedInstOperands,
     /*  138590 */     // GIR_Coverage, 47848,
     /*  138590 */     GIR_EraseRootFromParent_Done,
     /*  138591 */   // Label 2443: @138591
     /*  138591 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(138636), // Rule ID 47849 //
     /*  138596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138599 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  138599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  138602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  138616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138634 */     GIR_RootConstrainSelectedInstOperands,
     /*  138635 */     // GIR_Coverage, 47849,
     /*  138635 */     GIR_EraseRootFromParent_Done,
     /*  138636 */   // Label 2444: @138636
     /*  138636 */   GIM_Reject,
     /*  138637 */ // Label 2442: @138637
     /*  138637 */ GIM_Reject,
     /*  138638 */ // Label 2291: @138638
     /*  138638 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(138752),
     /*  138643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  138646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  138649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138661 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(138706), // Rule ID 47864 //
     /*  138666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138669 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  138669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  138672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  138686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  138701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138704 */     GIR_RootConstrainSelectedInstOperands,
     /*  138705 */     // GIR_Coverage, 47864,
     /*  138705 */     GIR_EraseRootFromParent_Done,
     /*  138706 */   // Label 2446: @138706
     /*  138706 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(138751), // Rule ID 47865 //
     /*  138711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138714 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  138714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  138717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  138731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  138746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138749 */     GIR_RootConstrainSelectedInstOperands,
     /*  138750 */     // GIR_Coverage, 47865,
     /*  138750 */     GIR_EraseRootFromParent_Done,
     /*  138751 */   // Label 2447: @138751
     /*  138751 */   GIM_Reject,
     /*  138752 */ // Label 2445: @138752
     /*  138752 */ GIM_Reject,
     /*  138753 */ // Label 2292: @138753
     /*  138753 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(138867),
     /*  138758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  138761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  138764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138776 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(138821), // Rule ID 47880 //
     /*  138781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  138784 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  138784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  138787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  138801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138819 */     GIR_RootConstrainSelectedInstOperands,
     /*  138820 */     // GIR_Coverage, 47880,
     /*  138820 */     GIR_EraseRootFromParent_Done,
     /*  138821 */   // Label 2449: @138821
     /*  138821 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(138866), // Rule ID 47881 //
     /*  138826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  138829 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  138829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  138832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  138846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138864 */     GIR_RootConstrainSelectedInstOperands,
     /*  138865 */     // GIR_Coverage, 47881,
     /*  138865 */     GIR_EraseRootFromParent_Done,
     /*  138866 */   // Label 2450: @138866
     /*  138866 */   GIM_Reject,
     /*  138867 */ // Label 2448: @138867
     /*  138867 */ GIM_Reject,
     /*  138868 */ // Label 2293: @138868
     /*  138868 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(139478),
     /*  138873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138883 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(138949), // Rule ID 71891 //
     /*  138888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138930 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138947 */     GIR_RootConstrainSelectedInstOperands,
     /*  138948 */     // GIR_Coverage, 71891,
     /*  138948 */     GIR_EraseRootFromParent_Done,
     /*  138949 */   // Label 2452: @138949
     /*  138949 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(139015), // Rule ID 71892 //
     /*  138954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138996 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139013 */     GIR_RootConstrainSelectedInstOperands,
     /*  139014 */     // GIR_Coverage, 71892,
     /*  139014 */     GIR_EraseRootFromParent_Done,
     /*  139015 */   // Label 2453: @139015
     /*  139015 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(139081), // Rule ID 71889 //
     /*  139020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  139035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  139039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139062 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  139065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139079 */     GIR_RootConstrainSelectedInstOperands,
     /*  139080 */     // GIR_Coverage, 71889,
     /*  139080 */     GIR_EraseRootFromParent_Done,
     /*  139081 */   // Label 2454: @139081
     /*  139081 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(139147), // Rule ID 71890 //
     /*  139086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  139101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  139105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139128 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  139131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139145 */     GIR_RootConstrainSelectedInstOperands,
     /*  139146 */     // GIR_Coverage, 71890,
     /*  139146 */     GIR_EraseRootFromParent_Done,
     /*  139147 */   // Label 2455: @139147
     /*  139147 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(139213), // Rule ID 71887 //
     /*  139152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  139171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  139175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139194 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  139197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139211 */     GIR_RootConstrainSelectedInstOperands,
     /*  139212 */     // GIR_Coverage, 71887,
     /*  139212 */     GIR_EraseRootFromParent_Done,
     /*  139213 */   // Label 2456: @139213
     /*  139213 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(139279), // Rule ID 71888 //
     /*  139218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  139237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  139241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139260 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  139263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139277 */     GIR_RootConstrainSelectedInstOperands,
     /*  139278 */     // GIR_Coverage, 71888,
     /*  139278 */     GIR_EraseRootFromParent_Done,
     /*  139279 */   // Label 2457: @139279
     /*  139279 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(139345), // Rule ID 53258 //
     /*  139284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  139303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  139307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139326 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  139329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139343 */     GIR_RootConstrainSelectedInstOperands,
     /*  139344 */     // GIR_Coverage, 53258,
     /*  139344 */     GIR_EraseRootFromParent_Done,
     /*  139345 */   // Label 2458: @139345
     /*  139345 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(139411), // Rule ID 53259 //
     /*  139350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  139369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  139373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139392 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  139395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139409 */     GIR_RootConstrainSelectedInstOperands,
     /*  139410 */     // GIR_Coverage, 53259,
     /*  139410 */     GIR_EraseRootFromParent_Done,
     /*  139411 */   // Label 2459: @139411
     /*  139411 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(139444), // Rule ID 53246 //
     /*  139416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139427 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  139430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139442 */     GIR_RootConstrainSelectedInstOperands,
     /*  139443 */     // GIR_Coverage, 53246,
     /*  139443 */     GIR_EraseRootFromParent_Done,
     /*  139444 */   // Label 2460: @139444
     /*  139444 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(139477), // Rule ID 53247 //
     /*  139449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139460 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  139463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139475 */     GIR_RootConstrainSelectedInstOperands,
     /*  139476 */     // GIR_Coverage, 53247,
     /*  139476 */     GIR_EraseRootFromParent_Done,
     /*  139477 */   // Label 2461: @139477
     /*  139477 */   GIM_Reject,
     /*  139478 */ // Label 2451: @139478
     /*  139478 */ GIM_Reject,
     /*  139479 */ // Label 2294: @139479
     /*  139479 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(139593),
     /*  139484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  139487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  139490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139502 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(139547), // Rule ID 47836 //
     /*  139507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139510 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  139510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  139513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  139527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139545 */     GIR_RootConstrainSelectedInstOperands,
     /*  139546 */     // GIR_Coverage, 47836,
     /*  139546 */     GIR_EraseRootFromParent_Done,
     /*  139547 */   // Label 2463: @139547
     /*  139547 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(139592), // Rule ID 47837 //
     /*  139552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139555 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  139555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  139558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  139572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139590 */     GIR_RootConstrainSelectedInstOperands,
     /*  139591 */     // GIR_Coverage, 47837,
     /*  139591 */     GIR_EraseRootFromParent_Done,
     /*  139592 */   // Label 2464: @139592
     /*  139592 */   GIM_Reject,
     /*  139593 */ // Label 2462: @139593
     /*  139593 */ GIM_Reject,
     /*  139594 */ // Label 2295: @139594
     /*  139594 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(139708),
     /*  139599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  139602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  139605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139617 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(139662), // Rule ID 47852 //
     /*  139622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139625 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  139625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  139628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  139642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139660 */     GIR_RootConstrainSelectedInstOperands,
     /*  139661 */     // GIR_Coverage, 47852,
     /*  139661 */     GIR_EraseRootFromParent_Done,
     /*  139662 */   // Label 2466: @139662
     /*  139662 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(139707), // Rule ID 47853 //
     /*  139667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139670 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  139670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  139673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  139687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139705 */     GIR_RootConstrainSelectedInstOperands,
     /*  139706 */     // GIR_Coverage, 47853,
     /*  139706 */     GIR_EraseRootFromParent_Done,
     /*  139707 */   // Label 2467: @139707
     /*  139707 */   GIM_Reject,
     /*  139708 */ // Label 2465: @139708
     /*  139708 */ GIM_Reject,
     /*  139709 */ // Label 2296: @139709
     /*  139709 */ GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(139823),
     /*  139714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  139717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  139720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139732 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(139777), // Rule ID 47868 //
     /*  139737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139740 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  139740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  139743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  139757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139775 */     GIR_RootConstrainSelectedInstOperands,
     /*  139776 */     // GIR_Coverage, 47868,
     /*  139776 */     GIR_EraseRootFromParent_Done,
     /*  139777 */   // Label 2469: @139777
     /*  139777 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(139822), // Rule ID 47869 //
     /*  139782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139785 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  139785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  139788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  139802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139820 */     GIR_RootConstrainSelectedInstOperands,
     /*  139821 */     // GIR_Coverage, 47869,
     /*  139821 */     GIR_EraseRootFromParent_Done,
     /*  139822 */   // Label 2470: @139822
     /*  139822 */   GIM_Reject,
     /*  139823 */ // Label 2468: @139823
     /*  139823 */ GIM_Reject,
     /*  139824 */ // Label 2297: @139824
     /*  139824 */ GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(140434),
     /*  139829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139839 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(139905), // Rule ID 71919 //
     /*  139844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139886 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139903 */     GIR_RootConstrainSelectedInstOperands,
     /*  139904 */     // GIR_Coverage, 71919,
     /*  139904 */     GIR_EraseRootFromParent_Done,
     /*  139905 */   // Label 2472: @139905
     /*  139905 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(139971), // Rule ID 71920 //
     /*  139910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139952 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139969 */     GIR_RootConstrainSelectedInstOperands,
     /*  139970 */     // GIR_Coverage, 71920,
     /*  139970 */     GIR_EraseRootFromParent_Done,
     /*  139971 */   // Label 2473: @139971
     /*  139971 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(140037), // Rule ID 71917 //
     /*  139976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140018 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  140021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140035 */     GIR_RootConstrainSelectedInstOperands,
     /*  140036 */     // GIR_Coverage, 71917,
     /*  140036 */     GIR_EraseRootFromParent_Done,
     /*  140037 */   // Label 2474: @140037
     /*  140037 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(140103), // Rule ID 71918 //
     /*  140042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  140057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  140061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140084 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  140087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140101 */     GIR_RootConstrainSelectedInstOperands,
     /*  140102 */     // GIR_Coverage, 71918,
     /*  140102 */     GIR_EraseRootFromParent_Done,
     /*  140103 */   // Label 2475: @140103
     /*  140103 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(140169), // Rule ID 71915 //
     /*  140108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  140127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  140131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140150 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  140153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140167 */     GIR_RootConstrainSelectedInstOperands,
     /*  140168 */     // GIR_Coverage, 71915,
     /*  140168 */     GIR_EraseRootFromParent_Done,
     /*  140169 */   // Label 2476: @140169
     /*  140169 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(140235), // Rule ID 71916 //
     /*  140174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  140193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  140197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140216 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  140219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140233 */     GIR_RootConstrainSelectedInstOperands,
     /*  140234 */     // GIR_Coverage, 71916,
     /*  140234 */     GIR_EraseRootFromParent_Done,
     /*  140235 */   // Label 2477: @140235
     /*  140235 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(140301), // Rule ID 53276 //
     /*  140240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  140259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  140263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140282 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  140285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140299 */     GIR_RootConstrainSelectedInstOperands,
     /*  140300 */     // GIR_Coverage, 53276,
     /*  140300 */     GIR_EraseRootFromParent_Done,
     /*  140301 */   // Label 2478: @140301
     /*  140301 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(140367), // Rule ID 53277 //
     /*  140306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  140325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  140329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140348 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  140351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140365 */     GIR_RootConstrainSelectedInstOperands,
     /*  140366 */     // GIR_Coverage, 53277,
     /*  140366 */     GIR_EraseRootFromParent_Done,
     /*  140367 */   // Label 2479: @140367
     /*  140367 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(140400), // Rule ID 53264 //
     /*  140372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140383 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  140386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140398 */     GIR_RootConstrainSelectedInstOperands,
     /*  140399 */     // GIR_Coverage, 53264,
     /*  140399 */     GIR_EraseRootFromParent_Done,
     /*  140400 */   // Label 2480: @140400
     /*  140400 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(140433), // Rule ID 53265 //
     /*  140405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140416 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  140419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140431 */     GIR_RootConstrainSelectedInstOperands,
     /*  140432 */     // GIR_Coverage, 53265,
     /*  140432 */     GIR_EraseRootFromParent_Done,
     /*  140433 */   // Label 2481: @140433
     /*  140433 */   GIM_Reject,
     /*  140434 */ // Label 2471: @140434
     /*  140434 */ GIM_Reject,
     /*  140435 */ // Label 2298: @140435
     /*  140435 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(140549),
     /*  140440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  140443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  140446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  140450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  140454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  140458 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(140503), // Rule ID 47840 //
     /*  140463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140466 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  140466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  140469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  140483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140501 */     GIR_RootConstrainSelectedInstOperands,
     /*  140502 */     // GIR_Coverage, 47840,
     /*  140502 */     GIR_EraseRootFromParent_Done,
     /*  140503 */   // Label 2483: @140503
     /*  140503 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(140548), // Rule ID 47841 //
     /*  140508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140511 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  140511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  140514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  140528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140546 */     GIR_RootConstrainSelectedInstOperands,
     /*  140547 */     // GIR_Coverage, 47841,
     /*  140547 */     GIR_EraseRootFromParent_Done,
     /*  140548 */   // Label 2484: @140548
     /*  140548 */   GIM_Reject,
     /*  140549 */ // Label 2482: @140549
     /*  140549 */ GIM_Reject,
     /*  140550 */ // Label 2299: @140550
     /*  140550 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(140664),
     /*  140555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  140558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  140561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140573 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(140618), // Rule ID 47856 //
     /*  140578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140581 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  140581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  140584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140616 */     GIR_RootConstrainSelectedInstOperands,
     /*  140617 */     // GIR_Coverage, 47856,
     /*  140617 */     GIR_EraseRootFromParent_Done,
     /*  140618 */   // Label 2486: @140618
     /*  140618 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(140663), // Rule ID 47857 //
     /*  140623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140626 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  140626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  140629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140661 */     GIR_RootConstrainSelectedInstOperands,
     /*  140662 */     // GIR_Coverage, 47857,
     /*  140662 */     GIR_EraseRootFromParent_Done,
     /*  140663 */   // Label 2487: @140663
     /*  140663 */   GIM_Reject,
     /*  140664 */ // Label 2485: @140664
     /*  140664 */ GIM_Reject,
     /*  140665 */ // Label 2300: @140665
     /*  140665 */ GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(141275),
     /*  140670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140680 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(140746), // Rule ID 71947 //
     /*  140685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140727 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140744 */     GIR_RootConstrainSelectedInstOperands,
     /*  140745 */     // GIR_Coverage, 71947,
     /*  140745 */     GIR_EraseRootFromParent_Done,
     /*  140746 */   // Label 2489: @140746
     /*  140746 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(140812), // Rule ID 71948 //
     /*  140751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140793 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140810 */     GIR_RootConstrainSelectedInstOperands,
     /*  140811 */     // GIR_Coverage, 71948,
     /*  140811 */     GIR_EraseRootFromParent_Done,
     /*  140812 */   // Label 2490: @140812
     /*  140812 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(140878), // Rule ID 71945 //
     /*  140817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140859 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140876 */     GIR_RootConstrainSelectedInstOperands,
     /*  140877 */     // GIR_Coverage, 71945,
     /*  140877 */     GIR_EraseRootFromParent_Done,
     /*  140878 */   // Label 2491: @140878
     /*  140878 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(140944), // Rule ID 71946 //
     /*  140883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140925 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140942 */     GIR_RootConstrainSelectedInstOperands,
     /*  140943 */     // GIR_Coverage, 71946,
     /*  140943 */     GIR_EraseRootFromParent_Done,
     /*  140944 */   // Label 2492: @140944
     /*  140944 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(141010), // Rule ID 71943 //
     /*  140949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140991 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141008 */     GIR_RootConstrainSelectedInstOperands,
     /*  141009 */     // GIR_Coverage, 71943,
     /*  141009 */     GIR_EraseRootFromParent_Done,
     /*  141010 */   // Label 2493: @141010
     /*  141010 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(141076), // Rule ID 71944 //
     /*  141015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  141034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  141038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  141042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141057 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  141060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141074 */     GIR_RootConstrainSelectedInstOperands,
     /*  141075 */     // GIR_Coverage, 71944,
     /*  141075 */     GIR_EraseRootFromParent_Done,
     /*  141076 */   // Label 2494: @141076
     /*  141076 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(141142), // Rule ID 53294 //
     /*  141081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  141100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  141104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  141113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  141121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141123 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  141126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  141134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141140 */     GIR_RootConstrainSelectedInstOperands,
     /*  141141 */     // GIR_Coverage, 53294,
     /*  141141 */     GIR_EraseRootFromParent_Done,
     /*  141142 */   // Label 2495: @141142
     /*  141142 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(141208), // Rule ID 53295 //
     /*  141147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  141166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  141170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  141179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141189 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  141192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  141200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141206 */     GIR_RootConstrainSelectedInstOperands,
     /*  141207 */     // GIR_Coverage, 53295,
     /*  141207 */     GIR_EraseRootFromParent_Done,
     /*  141208 */   // Label 2496: @141208
     /*  141208 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(141241), // Rule ID 53282 //
     /*  141213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141224 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  141227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141239 */     GIR_RootConstrainSelectedInstOperands,
     /*  141240 */     // GIR_Coverage, 53282,
     /*  141240 */     GIR_EraseRootFromParent_Done,
     /*  141241 */   // Label 2497: @141241
     /*  141241 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(141274), // Rule ID 53283 //
     /*  141246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141257 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  141260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141272 */     GIR_RootConstrainSelectedInstOperands,
     /*  141273 */     // GIR_Coverage, 53283,
     /*  141273 */     GIR_EraseRootFromParent_Done,
     /*  141274 */   // Label 2498: @141274
     /*  141274 */   GIM_Reject,
     /*  141275 */ // Label 2488: @141275
     /*  141275 */ GIM_Reject,
     /*  141276 */ // Label 2301: @141276
     /*  141276 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(141390),
     /*  141281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  141284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  141287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  141291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  141295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  141299 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(141344), // Rule ID 47844 //
     /*  141304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141307 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  141307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  141310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  141314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  141324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141342 */     GIR_RootConstrainSelectedInstOperands,
     /*  141343 */     // GIR_Coverage, 47844,
     /*  141343 */     GIR_EraseRootFromParent_Done,
     /*  141344 */   // Label 2500: @141344
     /*  141344 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(141389), // Rule ID 47845 //
     /*  141349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141352 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  141352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  141355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  141359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  141369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141387 */     GIR_RootConstrainSelectedInstOperands,
     /*  141388 */     // GIR_Coverage, 47845,
     /*  141388 */     GIR_EraseRootFromParent_Done,
     /*  141389 */   // Label 2501: @141389
     /*  141389 */   GIM_Reject,
     /*  141390 */ // Label 2499: @141390
     /*  141390 */ GIM_Reject,
     /*  141391 */ // Label 2302: @141391
     /*  141391 */ GIM_Reject,
     /*  141392 */ // Label 9: @141392
     /*  141392 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2533*/ GIMT_Encode4(156298),
     /*  141403 */ /*GILLT_s32*//*Label 2502*/ GIMT_Encode4(141527),
     /*  141407 */ /*GILLT_s64*//*Label 2503*/ GIMT_Encode4(142065),
     /*  141411 */ /*GILLT_nxv1s1*//*Label 2504*/ GIMT_Encode4(142491),
     /*  141415 */ /*GILLT_nxv1s8*//*Label 2505*/ GIMT_Encode4(144102),
     /*  141419 */ /*GILLT_nxv1s16*//*Label 2506*/ GIMT_Encode4(144217),
     /*  141423 */ /*GILLT_nxv1s32*//*Label 2507*/ GIMT_Encode4(144332),
     /*  141427 */ /*GILLT_nxv1s64*//*Label 2508*/ GIMT_Encode4(144447),
     /*  141431 */ /*GILLT_nxv2s1*//*Label 2509*/ GIMT_Encode4(144562),
     /*  141435 */ /*GILLT_nxv2s8*//*Label 2510*/ GIMT_Encode4(146173),
     /*  141439 */ /*GILLT_nxv2s16*//*Label 2511*/ GIMT_Encode4(146288),
     /*  141443 */ /*GILLT_nxv2s32*//*Label 2512*/ GIMT_Encode4(146403),
     /*  141447 */ /*GILLT_nxv2s64*//*Label 2513*/ GIMT_Encode4(146518),
     /*  141451 */ /*GILLT_nxv4s1*//*Label 2514*/ GIMT_Encode4(146633),
     /*  141455 */ /*GILLT_nxv4s8*//*Label 2515*/ GIMT_Encode4(148244),
     /*  141459 */ /*GILLT_nxv4s16*//*Label 2516*/ GIMT_Encode4(148359),
     /*  141463 */ /*GILLT_nxv4s32*//*Label 2517*/ GIMT_Encode4(148474),
     /*  141467 */ /*GILLT_nxv4s64*//*Label 2518*/ GIMT_Encode4(148589),
     /*  141471 */ /*GILLT_nxv8s1*//*Label 2519*/ GIMT_Encode4(148704),
     /*  141475 */ /*GILLT_nxv8s8*//*Label 2520*/ GIMT_Encode4(150315),
     /*  141479 */ /*GILLT_nxv8s16*//*Label 2521*/ GIMT_Encode4(150430),
     /*  141483 */ /*GILLT_nxv8s32*//*Label 2522*/ GIMT_Encode4(150545),
     /*  141487 */ /*GILLT_nxv8s64*//*Label 2523*/ GIMT_Encode4(150660),
     /*  141491 */ /*GILLT_nxv16s1*//*Label 2524*/ GIMT_Encode4(150775),
     /*  141495 */ /*GILLT_nxv16s8*//*Label 2525*/ GIMT_Encode4(152386),
     /*  141499 */ /*GILLT_nxv16s16*//*Label 2526*/ GIMT_Encode4(152501),
     /*  141503 */ /*GILLT_nxv16s32*//*Label 2527*/ GIMT_Encode4(152616),
     /*  141507 */ /*GILLT_nxv32s1*//*Label 2528*/ GIMT_Encode4(152731),
     /*  141511 */ /*GILLT_nxv32s8*//*Label 2529*/ GIMT_Encode4(154342),
     /*  141515 */ /*GILLT_nxv32s16*//*Label 2530*/ GIMT_Encode4(154457),
     /*  141519 */ /*GILLT_nxv64s1*//*Label 2531*/ GIMT_Encode4(154572),
     /*  141523 */ /*GILLT_nxv64s8*//*Label 2532*/ GIMT_Encode4(156183),
     /*  141527 */ // Label 2502: @141527
     /*  141527 */ GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(142064),
     /*  141532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  141535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  141538 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(141621), // Rule ID 2493 //
     /*  141543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  141546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141566 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  141570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141576 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141583 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] })  =>  (ADDI:{ *:[i32] } (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })
     /*  141583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  141586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  141590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141595 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  141601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  141611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141619 */     GIR_RootConstrainSelectedInstOperands,
     /*  141620 */     // GIR_Coverage, 2493,
     /*  141620 */     GIR_EraseRootFromParent_Done,
     /*  141621 */   // Label 2535: @141621
     /*  141621 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(141680), // Rule ID 2487 //
     /*  141626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  141629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141649 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141666 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141678 */     GIR_RootConstrainSelectedInstOperands,
     /*  141679 */     // GIR_Coverage, 2487,
     /*  141679 */     GIR_EraseRootFromParent_Done,
     /*  141680 */   // Label 2536: @141680
     /*  141680 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(141739), // Rule ID 65568 //
     /*  141685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  141688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141712 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141725 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141737 */     GIR_RootConstrainSelectedInstOperands,
     /*  141738 */     // GIR_Coverage, 65568,
     /*  141738 */     GIR_EraseRootFromParent_Done,
     /*  141739 */   // Label 2537: @141739
     /*  141739 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(141795), // Rule ID 65552 //
     /*  141744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  141747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141772 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141782 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs2)  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141793 */     GIR_RootConstrainSelectedInstOperands,
     /*  141794 */     // GIR_Coverage, 65552,
     /*  141794 */     GIR_EraseRootFromParent_Done,
     /*  141795 */   // Label 2538: @141795
     /*  141795 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(141854), // Rule ID 2461 //
     /*  141800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  141803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141839 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141852 */     GIR_RootConstrainSelectedInstOperands,
     /*  141853 */     // GIR_Coverage, 2461,
     /*  141853 */     GIR_EraseRootFromParent_Done,
     /*  141854 */   // Label 2539: @141854
     /*  141854 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(141910), // Rule ID 65554 //
     /*  141859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  141862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141891 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141897 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  141908 */     GIR_RootConstrainSelectedInstOperands,
     /*  141909 */     // GIR_Coverage, 65554,
     /*  141909 */     GIR_EraseRootFromParent_Done,
     /*  141910 */   // Label 2540: @141910
     /*  141910 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(141952), // Rule ID 103 //
     /*  141915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  141918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  141938 */     // MIs[1] Operand 1
     /*  141938 */     // No operand predicates
     /*  141938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141940 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  141940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  141943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141950 */     GIR_RootConstrainSelectedInstOperands,
     /*  141951 */     // GIR_Coverage, 103,
     /*  141951 */     GIR_EraseRootFromParent_Done,
     /*  141952 */   // Label 2541: @141952
     /*  141952 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(141994), // Rule ID 64548 //
     /*  141957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  141960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  141980 */     // MIs[1] Operand 1
     /*  141980 */     // No operand predicates
     /*  141980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141982 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_XORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  141982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORAI),
     /*  141985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  141987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141992 */     GIR_RootConstrainSelectedInstOperands,
     /*  141993 */     // GIR_Coverage, 64548,
     /*  141993 */     GIR_EraseRootFromParent_Done,
     /*  141994 */   // Label 2542: @141994
     /*  141994 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(142036), // Rule ID 64552 //
     /*  141999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  142002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  142006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  142010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  142022 */     // MIs[1] Operand 1
     /*  142022 */     // No operand predicates
     /*  142022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142024 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_XORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  142024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORI),
     /*  142027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  142031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  142034 */     GIR_RootConstrainSelectedInstOperands,
     /*  142035 */     // GIR_Coverage, 64552,
     /*  142035 */     GIR_EraseRootFromParent_Done,
     /*  142036 */   // Label 2543: @142036
     /*  142036 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(142063), // Rule ID 101 //
     /*  142041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  142044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142056 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  142056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  142061 */     GIR_RootConstrainSelectedInstOperands,
     /*  142062 */     // GIR_Coverage, 101,
     /*  142062 */     GIR_Done,
     /*  142063 */   // Label 2544: @142063
     /*  142063 */   GIM_Reject,
     /*  142064 */ // Label 2534: @142064
     /*  142064 */ GIM_Reject,
     /*  142065 */ // Label 2503: @142065
     /*  142065 */ GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(142490),
     /*  142070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  142073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  142076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142080 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(142159), // Rule ID 2492 //
     /*  142085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  142088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  142096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  142104 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  142108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  142112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  142121 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } -1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] })  =>  (ADDI:{ *:[i64] } (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })
     /*  142121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  142124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  142128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  142133 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  142139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  142144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  142146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  142149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  142154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142157 */     GIR_RootConstrainSelectedInstOperands,
     /*  142158 */     // GIR_Coverage, 2492,
     /*  142158 */     GIR_EraseRootFromParent_Done,
     /*  142159 */   // Label 2546: @142159
     /*  142159 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(142214), // Rule ID 2486 //
     /*  142164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  142167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  142175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  142183 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  142187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  142200 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  142203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  142212 */     GIR_RootConstrainSelectedInstOperands,
     /*  142213 */     // GIR_Coverage, 2486,
     /*  142213 */     GIR_EraseRootFromParent_Done,
     /*  142214 */   // Label 2547: @142214
     /*  142214 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(142269), // Rule ID 65567 //
     /*  142219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  142222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  142234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  142242 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  142246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  142255 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  142258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  142262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  142267 */     GIR_RootConstrainSelectedInstOperands,
     /*  142268 */     // GIR_Coverage, 65567,
     /*  142268 */     GIR_EraseRootFromParent_Done,
     /*  142269 */   // Label 2548: @142269
     /*  142269 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(142321), // Rule ID 65551 //
     /*  142274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  142277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  142293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142298 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  142302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142308 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  142311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142319 */     GIR_RootConstrainSelectedInstOperands,
     /*  142320 */     // GIR_Coverage, 65551,
     /*  142320 */     GIR_EraseRootFromParent_Done,
     /*  142321 */   // Label 2549: @142321
     /*  142321 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(142376), // Rule ID 2460 //
     /*  142326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  142329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  142345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142355 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  142359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142361 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  142364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142374 */     GIR_RootConstrainSelectedInstOperands,
     /*  142375 */     // GIR_Coverage, 2460,
     /*  142375 */     GIR_EraseRootFromParent_Done,
     /*  142376 */   // Label 2550: @142376
     /*  142376 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(142428), // Rule ID 65553 //
     /*  142381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  142384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  142404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142409 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  142413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142415 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }))  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  142418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142426 */     GIR_RootConstrainSelectedInstOperands,
     /*  142427 */     // GIR_Coverage, 65553,
     /*  142427 */     GIR_EraseRootFromParent_Done,
     /*  142428 */   // Label 2551: @142428
     /*  142428 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(142466), // Rule ID 102 //
     /*  142433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  142436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  142452 */     // MIs[1] Operand 1
     /*  142452 */     // No operand predicates
     /*  142452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142454 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  142454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  142457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  142461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  142464 */     GIR_RootConstrainSelectedInstOperands,
     /*  142465 */     // GIR_Coverage, 102,
     /*  142465 */     GIR_EraseRootFromParent_Done,
     /*  142466 */   // Label 2552: @142466
     /*  142466 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(142489), // Rule ID 100 //
     /*  142471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  142474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142482 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  142487 */     GIR_RootConstrainSelectedInstOperands,
     /*  142488 */     // GIR_Coverage, 100,
     /*  142488 */     GIR_Done,
     /*  142489 */   // Label 2553: @142489
     /*  142489 */   GIM_Reject,
     /*  142490 */ // Label 2545: @142490
     /*  142490 */ GIM_Reject,
     /*  142491 */ // Label 2504: @142491
     /*  142491 */ GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(144101),
     /*  142496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142506 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(142575), // Rule ID 53178 //
     /*  142511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142554 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142573 */     GIR_RootConstrainSelectedInstOperands,
     /*  142574 */     // GIR_Coverage, 53178,
     /*  142574 */     GIR_EraseRootFromParent_Done,
     /*  142575 */   // Label 2555: @142575
     /*  142575 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(142644), // Rule ID 53179 //
     /*  142580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142623 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142642 */     GIR_RootConstrainSelectedInstOperands,
     /*  142643 */     // GIR_Coverage, 53179,
     /*  142643 */     GIR_EraseRootFromParent_Done,
     /*  142644 */   // Label 2556: @142644
     /*  142644 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(142713), // Rule ID 53180 //
     /*  142649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142692 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142711 */     GIR_RootConstrainSelectedInstOperands,
     /*  142712 */     // GIR_Coverage, 53180,
     /*  142712 */     GIR_EraseRootFromParent_Done,
     /*  142713 */   // Label 2557: @142713
     /*  142713 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(142782), // Rule ID 53181 //
     /*  142718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142761 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142780 */     GIR_RootConstrainSelectedInstOperands,
     /*  142781 */     // GIR_Coverage, 53181,
     /*  142781 */     GIR_EraseRootFromParent_Done,
     /*  142782 */   // Label 2558: @142782
     /*  142782 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(142848), // Rule ID 71761 //
     /*  142787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142829 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142846 */     GIR_RootConstrainSelectedInstOperands,
     /*  142847 */     // GIR_Coverage, 71761,
     /*  142847 */     GIR_EraseRootFromParent_Done,
     /*  142848 */   // Label 2559: @142848
     /*  142848 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(142914), // Rule ID 71762 //
     /*  142853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142895 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142912 */     GIR_RootConstrainSelectedInstOperands,
     /*  142913 */     // GIR_Coverage, 71762,
     /*  142913 */     GIR_EraseRootFromParent_Done,
     /*  142914 */   // Label 2560: @142914
     /*  142914 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(142980), // Rule ID 71759 //
     /*  142919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142961 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142978 */     GIR_RootConstrainSelectedInstOperands,
     /*  142979 */     // GIR_Coverage, 71759,
     /*  142979 */     GIR_EraseRootFromParent_Done,
     /*  142980 */   // Label 2561: @142980
     /*  142980 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(143046), // Rule ID 71760 //
     /*  142985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  143013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143027 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143044 */     GIR_RootConstrainSelectedInstOperands,
     /*  143045 */     // GIR_Coverage, 71760,
     /*  143045 */     GIR_EraseRootFromParent_Done,
     /*  143046 */   // Label 2562: @143046
     /*  143046 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(143115), // Rule ID 53182 //
     /*  143051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143094 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143113 */     GIR_RootConstrainSelectedInstOperands,
     /*  143114 */     // GIR_Coverage, 53182,
     /*  143114 */     GIR_EraseRootFromParent_Done,
     /*  143115 */   // Label 2563: @143115
     /*  143115 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(143184), // Rule ID 53183 //
     /*  143120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143163 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143182 */     GIR_RootConstrainSelectedInstOperands,
     /*  143183 */     // GIR_Coverage, 53183,
     /*  143183 */     GIR_EraseRootFromParent_Done,
     /*  143184 */   // Label 2564: @143184
     /*  143184 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(143253), // Rule ID 71755 //
     /*  143189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  143212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143232 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143251 */     GIR_RootConstrainSelectedInstOperands,
     /*  143252 */     // GIR_Coverage, 71755,
     /*  143252 */     GIR_EraseRootFromParent_Done,
     /*  143253 */   // Label 2565: @143253
     /*  143253 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(143322), // Rule ID 71756 //
     /*  143258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  143281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143301 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143320 */     GIR_RootConstrainSelectedInstOperands,
     /*  143321 */     // GIR_Coverage, 71756,
     /*  143321 */     GIR_EraseRootFromParent_Done,
     /*  143322 */   // Label 2566: @143322
     /*  143322 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(143391), // Rule ID 71757 //
     /*  143327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  143350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143370 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  143373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143389 */     GIR_RootConstrainSelectedInstOperands,
     /*  143390 */     // GIR_Coverage, 71757,
     /*  143390 */     GIR_EraseRootFromParent_Done,
     /*  143391 */   // Label 2567: @143391
     /*  143391 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(143460), // Rule ID 71758 //
     /*  143396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  143419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143427 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143439 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  143442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143458 */     GIR_RootConstrainSelectedInstOperands,
     /*  143459 */     // GIR_Coverage, 71758,
     /*  143459 */     GIR_EraseRootFromParent_Done,
     /*  143460 */   // Label 2568: @143460
     /*  143460 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(143529), // Rule ID 71763 //
     /*  143465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143508 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143527 */     GIR_RootConstrainSelectedInstOperands,
     /*  143528 */     // GIR_Coverage, 71763,
     /*  143528 */     GIR_EraseRootFromParent_Done,
     /*  143529 */   // Label 2569: @143529
     /*  143529 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(143598), // Rule ID 71764 //
     /*  143534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143561 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143577 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143596 */     GIR_RootConstrainSelectedInstOperands,
     /*  143597 */     // GIR_Coverage, 71764,
     /*  143597 */     GIR_EraseRootFromParent_Done,
     /*  143598 */   // Label 2570: @143598
     /*  143598 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(143664), // Rule ID 71767 //
     /*  143603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143645 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  143654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143662 */     GIR_RootConstrainSelectedInstOperands,
     /*  143663 */     // GIR_Coverage, 71767,
     /*  143663 */     GIR_EraseRootFromParent_Done,
     /*  143664 */   // Label 2571: @143664
     /*  143664 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(143730), // Rule ID 71768 //
     /*  143669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143711 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  143720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143728 */     GIR_RootConstrainSelectedInstOperands,
     /*  143729 */     // GIR_Coverage, 71768,
     /*  143729 */     GIR_EraseRootFromParent_Done,
     /*  143730 */   // Label 2572: @143730
     /*  143730 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(143796), // Rule ID 71765 //
     /*  143735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  143767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143777 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143794 */     GIR_RootConstrainSelectedInstOperands,
     /*  143795 */     // GIR_Coverage, 71765,
     /*  143795 */     GIR_EraseRootFromParent_Done,
     /*  143796 */   // Label 2573: @143796
     /*  143796 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(143862), // Rule ID 71766 //
     /*  143801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  143833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143843 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143860 */     GIR_RootConstrainSelectedInstOperands,
     /*  143861 */     // GIR_Coverage, 71766,
     /*  143861 */     GIR_EraseRootFromParent_Done,
     /*  143862 */   // Label 2574: @143862
     /*  143862 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(143905), // Rule ID 71781 //
     /*  143867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143888 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143903 */     GIR_RootConstrainSelectedInstOperands,
     /*  143904 */     // GIR_Coverage, 71781,
     /*  143904 */     GIR_EraseRootFromParent_Done,
     /*  143905 */   // Label 2575: @143905
     /*  143905 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(143948), // Rule ID 71782 //
     /*  143910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143931 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143946 */     GIR_RootConstrainSelectedInstOperands,
     /*  143947 */     // GIR_Coverage, 71782,
     /*  143947 */     GIR_EraseRootFromParent_Done,
     /*  143948 */   // Label 2576: @143948
     /*  143948 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(143991), // Rule ID 53188 //
     /*  143953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143974 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143989 */     GIR_RootConstrainSelectedInstOperands,
     /*  143990 */     // GIR_Coverage, 53188,
     /*  143990 */     GIR_EraseRootFromParent_Done,
     /*  143991 */   // Label 2577: @143991
     /*  143991 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(144034), // Rule ID 53189 //
     /*  143996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144017 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  144020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  144024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  144026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144032 */     GIR_RootConstrainSelectedInstOperands,
     /*  144033 */     // GIR_Coverage, 53189,
     /*  144033 */     GIR_EraseRootFromParent_Done,
     /*  144034 */   // Label 2578: @144034
     /*  144034 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(144067), // Rule ID 53176 //
     /*  144039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144050 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  144053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144065 */     GIR_RootConstrainSelectedInstOperands,
     /*  144066 */     // GIR_Coverage, 53176,
     /*  144066 */     GIR_EraseRootFromParent_Done,
     /*  144067 */   // Label 2579: @144067
     /*  144067 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(144100), // Rule ID 53177 //
     /*  144072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144083 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  144086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144098 */     GIR_RootConstrainSelectedInstOperands,
     /*  144099 */     // GIR_Coverage, 53177,
     /*  144099 */     GIR_EraseRootFromParent_Done,
     /*  144100 */   // Label 2580: @144100
     /*  144100 */   GIM_Reject,
     /*  144101 */ // Label 2554: @144101
     /*  144101 */ GIM_Reject,
     /*  144102 */ // Label 2505: @144102
     /*  144102 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(144216),
     /*  144107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  144110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  144113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144125 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(144170), // Rule ID 47928 //
     /*  144130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144133 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  144133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  144136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  144150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144168 */     GIR_RootConstrainSelectedInstOperands,
     /*  144169 */     // GIR_Coverage, 47928,
     /*  144169 */     GIR_EraseRootFromParent_Done,
     /*  144170 */   // Label 2582: @144170
     /*  144170 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(144215), // Rule ID 47929 //
     /*  144175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144178 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  144178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  144181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  144195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144213 */     GIR_RootConstrainSelectedInstOperands,
     /*  144214 */     // GIR_Coverage, 47929,
     /*  144214 */     GIR_EraseRootFromParent_Done,
     /*  144215 */   // Label 2583: @144215
     /*  144215 */   GIM_Reject,
     /*  144216 */ // Label 2581: @144216
     /*  144216 */ GIM_Reject,
     /*  144217 */ // Label 2506: @144217
     /*  144217 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(144331),
     /*  144222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  144225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  144228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144240 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(144285), // Rule ID 47940 //
     /*  144245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144248 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  144248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  144251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  144265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  144280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144283 */     GIR_RootConstrainSelectedInstOperands,
     /*  144284 */     // GIR_Coverage, 47940,
     /*  144284 */     GIR_EraseRootFromParent_Done,
     /*  144285 */   // Label 2585: @144285
     /*  144285 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(144330), // Rule ID 47941 //
     /*  144290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144293 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  144293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  144296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  144310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  144325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144328 */     GIR_RootConstrainSelectedInstOperands,
     /*  144329 */     // GIR_Coverage, 47941,
     /*  144329 */     GIR_EraseRootFromParent_Done,
     /*  144330 */   // Label 2586: @144330
     /*  144330 */   GIM_Reject,
     /*  144331 */ // Label 2584: @144331
     /*  144331 */ GIM_Reject,
     /*  144332 */ // Label 2507: @144332
     /*  144332 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(144446),
     /*  144337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  144340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  144343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144355 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(144400), // Rule ID 47948 //
     /*  144360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144363 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  144363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  144366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  144380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  144395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144398 */     GIR_RootConstrainSelectedInstOperands,
     /*  144399 */     // GIR_Coverage, 47948,
     /*  144399 */     GIR_EraseRootFromParent_Done,
     /*  144400 */   // Label 2588: @144400
     /*  144400 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(144445), // Rule ID 47949 //
     /*  144405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144408 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  144408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  144411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  144425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  144440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144443 */     GIR_RootConstrainSelectedInstOperands,
     /*  144444 */     // GIR_Coverage, 47949,
     /*  144444 */     GIR_EraseRootFromParent_Done,
     /*  144445 */   // Label 2589: @144445
     /*  144445 */   GIM_Reject,
     /*  144446 */ // Label 2587: @144446
     /*  144446 */ GIM_Reject,
     /*  144447 */ // Label 2508: @144447
     /*  144447 */ GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(144561),
     /*  144452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  144455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  144458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144470 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(144515), // Rule ID 47964 //
     /*  144475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  144478 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  144478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  144481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  144495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144513 */     GIR_RootConstrainSelectedInstOperands,
     /*  144514 */     // GIR_Coverage, 47964,
     /*  144514 */     GIR_EraseRootFromParent_Done,
     /*  144515 */   // Label 2591: @144515
     /*  144515 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(144560), // Rule ID 47965 //
     /*  144520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  144523 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  144523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  144526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  144540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144558 */     GIR_RootConstrainSelectedInstOperands,
     /*  144559 */     // GIR_Coverage, 47965,
     /*  144559 */     GIR_EraseRootFromParent_Done,
     /*  144560 */   // Label 2592: @144560
     /*  144560 */   GIM_Reject,
     /*  144561 */ // Label 2590: @144561
     /*  144561 */ GIM_Reject,
     /*  144562 */ // Label 2509: @144562
     /*  144562 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(146172),
     /*  144567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144577 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(144646), // Rule ID 53196 //
     /*  144582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144625 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144644 */     GIR_RootConstrainSelectedInstOperands,
     /*  144645 */     // GIR_Coverage, 53196,
     /*  144645 */     GIR_EraseRootFromParent_Done,
     /*  144646 */   // Label 2594: @144646
     /*  144646 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(144715), // Rule ID 53197 //
     /*  144651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144694 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144713 */     GIR_RootConstrainSelectedInstOperands,
     /*  144714 */     // GIR_Coverage, 53197,
     /*  144714 */     GIR_EraseRootFromParent_Done,
     /*  144715 */   // Label 2595: @144715
     /*  144715 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(144784), // Rule ID 53198 //
     /*  144720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144763 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144782 */     GIR_RootConstrainSelectedInstOperands,
     /*  144783 */     // GIR_Coverage, 53198,
     /*  144783 */     GIR_EraseRootFromParent_Done,
     /*  144784 */   // Label 2596: @144784
     /*  144784 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(144853), // Rule ID 53199 //
     /*  144789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144832 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144851 */     GIR_RootConstrainSelectedInstOperands,
     /*  144852 */     // GIR_Coverage, 53199,
     /*  144852 */     GIR_EraseRootFromParent_Done,
     /*  144853 */   // Label 2597: @144853
     /*  144853 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(144919), // Rule ID 71789 //
     /*  144858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144900 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144917 */     GIR_RootConstrainSelectedInstOperands,
     /*  144918 */     // GIR_Coverage, 71789,
     /*  144918 */     GIR_EraseRootFromParent_Done,
     /*  144919 */   // Label 2598: @144919
     /*  144919 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(144985), // Rule ID 71790 //
     /*  144924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144966 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144983 */     GIR_RootConstrainSelectedInstOperands,
     /*  144984 */     // GIR_Coverage, 71790,
     /*  144984 */     GIR_EraseRootFromParent_Done,
     /*  144985 */   // Label 2599: @144985
     /*  144985 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(145051), // Rule ID 71787 //
     /*  144990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  145018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145032 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145049 */     GIR_RootConstrainSelectedInstOperands,
     /*  145050 */     // GIR_Coverage, 71787,
     /*  145050 */     GIR_EraseRootFromParent_Done,
     /*  145051 */   // Label 2600: @145051
     /*  145051 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(145117), // Rule ID 71788 //
     /*  145056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  145084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145098 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145115 */     GIR_RootConstrainSelectedInstOperands,
     /*  145116 */     // GIR_Coverage, 71788,
     /*  145116 */     GIR_EraseRootFromParent_Done,
     /*  145117 */   // Label 2601: @145117
     /*  145117 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(145186), // Rule ID 53200 //
     /*  145122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145165 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145184 */     GIR_RootConstrainSelectedInstOperands,
     /*  145185 */     // GIR_Coverage, 53200,
     /*  145185 */     GIR_EraseRootFromParent_Done,
     /*  145186 */   // Label 2602: @145186
     /*  145186 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(145255), // Rule ID 53201 //
     /*  145191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145234 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145253 */     GIR_RootConstrainSelectedInstOperands,
     /*  145254 */     // GIR_Coverage, 53201,
     /*  145254 */     GIR_EraseRootFromParent_Done,
     /*  145255 */   // Label 2603: @145255
     /*  145255 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(145324), // Rule ID 71783 //
     /*  145260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  145283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145303 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145322 */     GIR_RootConstrainSelectedInstOperands,
     /*  145323 */     // GIR_Coverage, 71783,
     /*  145323 */     GIR_EraseRootFromParent_Done,
     /*  145324 */   // Label 2604: @145324
     /*  145324 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(145393), // Rule ID 71784 //
     /*  145329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  145352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145372 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145391 */     GIR_RootConstrainSelectedInstOperands,
     /*  145392 */     // GIR_Coverage, 71784,
     /*  145392 */     GIR_EraseRootFromParent_Done,
     /*  145393 */   // Label 2605: @145393
     /*  145393 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(145462), // Rule ID 71785 //
     /*  145398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  145421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145441 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  145444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145460 */     GIR_RootConstrainSelectedInstOperands,
     /*  145461 */     // GIR_Coverage, 71785,
     /*  145461 */     GIR_EraseRootFromParent_Done,
     /*  145462 */   // Label 2606: @145462
     /*  145462 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(145531), // Rule ID 71786 //
     /*  145467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  145490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145510 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  145513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145529 */     GIR_RootConstrainSelectedInstOperands,
     /*  145530 */     // GIR_Coverage, 71786,
     /*  145530 */     GIR_EraseRootFromParent_Done,
     /*  145531 */   // Label 2607: @145531
     /*  145531 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(145600), // Rule ID 71791 //
     /*  145536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145579 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145598 */     GIR_RootConstrainSelectedInstOperands,
     /*  145599 */     // GIR_Coverage, 71791,
     /*  145599 */     GIR_EraseRootFromParent_Done,
     /*  145600 */   // Label 2608: @145600
     /*  145600 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(145669), // Rule ID 71792 //
     /*  145605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145648 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145667 */     GIR_RootConstrainSelectedInstOperands,
     /*  145668 */     // GIR_Coverage, 71792,
     /*  145668 */     GIR_EraseRootFromParent_Done,
     /*  145669 */   // Label 2609: @145669
     /*  145669 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(145735), // Rule ID 71795 //
     /*  145674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  145701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145716 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  145725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145733 */     GIR_RootConstrainSelectedInstOperands,
     /*  145734 */     // GIR_Coverage, 71795,
     /*  145734 */     GIR_EraseRootFromParent_Done,
     /*  145735 */   // Label 2610: @145735
     /*  145735 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(145801), // Rule ID 71796 //
     /*  145740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  145767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145782 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  145791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145799 */     GIR_RootConstrainSelectedInstOperands,
     /*  145800 */     // GIR_Coverage, 71796,
     /*  145800 */     GIR_EraseRootFromParent_Done,
     /*  145801 */   // Label 2611: @145801
     /*  145801 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(145867), // Rule ID 71793 //
     /*  145806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  145838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145848 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145865 */     GIR_RootConstrainSelectedInstOperands,
     /*  145866 */     // GIR_Coverage, 71793,
     /*  145866 */     GIR_EraseRootFromParent_Done,
     /*  145867 */   // Label 2612: @145867
     /*  145867 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(145933), // Rule ID 71794 //
     /*  145872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  145904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145914 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145931 */     GIR_RootConstrainSelectedInstOperands,
     /*  145932 */     // GIR_Coverage, 71794,
     /*  145932 */     GIR_EraseRootFromParent_Done,
     /*  145933 */   // Label 2613: @145933
     /*  145933 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(145976), // Rule ID 71809 //
     /*  145938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145959 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145974 */     GIR_RootConstrainSelectedInstOperands,
     /*  145975 */     // GIR_Coverage, 71809,
     /*  145975 */     GIR_EraseRootFromParent_Done,
     /*  145976 */   // Label 2614: @145976
     /*  145976 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(146019), // Rule ID 71810 //
     /*  145981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  146002 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  146005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  146009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  146011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146017 */     GIR_RootConstrainSelectedInstOperands,
     /*  146018 */     // GIR_Coverage, 71810,
     /*  146018 */     GIR_EraseRootFromParent_Done,
     /*  146019 */   // Label 2615: @146019
     /*  146019 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(146062), // Rule ID 53206 //
     /*  146024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  146045 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  146048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  146052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  146054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146060 */     GIR_RootConstrainSelectedInstOperands,
     /*  146061 */     // GIR_Coverage, 53206,
     /*  146061 */     GIR_EraseRootFromParent_Done,
     /*  146062 */   // Label 2616: @146062
     /*  146062 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(146105), // Rule ID 53207 //
     /*  146067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  146088 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  146091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  146095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  146097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146103 */     GIR_RootConstrainSelectedInstOperands,
     /*  146104 */     // GIR_Coverage, 53207,
     /*  146104 */     GIR_EraseRootFromParent_Done,
     /*  146105 */   // Label 2617: @146105
     /*  146105 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(146138), // Rule ID 53194 //
     /*  146110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146121 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  146124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146136 */     GIR_RootConstrainSelectedInstOperands,
     /*  146137 */     // GIR_Coverage, 53194,
     /*  146137 */     GIR_EraseRootFromParent_Done,
     /*  146138 */   // Label 2618: @146138
     /*  146138 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(146171), // Rule ID 53195 //
     /*  146143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146154 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  146157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146169 */     GIR_RootConstrainSelectedInstOperands,
     /*  146170 */     // GIR_Coverage, 53195,
     /*  146170 */     GIR_EraseRootFromParent_Done,
     /*  146171 */   // Label 2619: @146171
     /*  146171 */   GIM_Reject,
     /*  146172 */ // Label 2593: @146172
     /*  146172 */ GIM_Reject,
     /*  146173 */ // Label 2510: @146173
     /*  146173 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(146287),
     /*  146178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  146181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  146184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146196 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(146241), // Rule ID 47932 //
     /*  146201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146204 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  146204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  146207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  146221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146239 */     GIR_RootConstrainSelectedInstOperands,
     /*  146240 */     // GIR_Coverage, 47932,
     /*  146240 */     GIR_EraseRootFromParent_Done,
     /*  146241 */   // Label 2621: @146241
     /*  146241 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(146286), // Rule ID 47933 //
     /*  146246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146249 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  146249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  146252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  146266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146284 */     GIR_RootConstrainSelectedInstOperands,
     /*  146285 */     // GIR_Coverage, 47933,
     /*  146285 */     GIR_EraseRootFromParent_Done,
     /*  146286 */   // Label 2622: @146286
     /*  146286 */   GIM_Reject,
     /*  146287 */ // Label 2620: @146287
     /*  146287 */ GIM_Reject,
     /*  146288 */ // Label 2511: @146288
     /*  146288 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(146402),
     /*  146293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  146296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  146299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146311 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(146356), // Rule ID 47944 //
     /*  146316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146319 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  146319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  146322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  146336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146354 */     GIR_RootConstrainSelectedInstOperands,
     /*  146355 */     // GIR_Coverage, 47944,
     /*  146355 */     GIR_EraseRootFromParent_Done,
     /*  146356 */   // Label 2624: @146356
     /*  146356 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(146401), // Rule ID 47945 //
     /*  146361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146364 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  146364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  146367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  146381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146399 */     GIR_RootConstrainSelectedInstOperands,
     /*  146400 */     // GIR_Coverage, 47945,
     /*  146400 */     GIR_EraseRootFromParent_Done,
     /*  146401 */   // Label 2625: @146401
     /*  146401 */   GIM_Reject,
     /*  146402 */ // Label 2623: @146402
     /*  146402 */ GIM_Reject,
     /*  146403 */ // Label 2512: @146403
     /*  146403 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(146517),
     /*  146408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  146411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  146414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146426 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(146471), // Rule ID 47960 //
     /*  146431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146434 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  146434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  146437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  146451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  146466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146469 */     GIR_RootConstrainSelectedInstOperands,
     /*  146470 */     // GIR_Coverage, 47960,
     /*  146470 */     GIR_EraseRootFromParent_Done,
     /*  146471 */   // Label 2627: @146471
     /*  146471 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(146516), // Rule ID 47961 //
     /*  146476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146479 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  146479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  146482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  146496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  146511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146514 */     GIR_RootConstrainSelectedInstOperands,
     /*  146515 */     // GIR_Coverage, 47961,
     /*  146515 */     GIR_EraseRootFromParent_Done,
     /*  146516 */   // Label 2628: @146516
     /*  146516 */   GIM_Reject,
     /*  146517 */ // Label 2626: @146517
     /*  146517 */ GIM_Reject,
     /*  146518 */ // Label 2513: @146518
     /*  146518 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(146632),
     /*  146523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  146526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  146529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146541 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(146586), // Rule ID 48004 //
     /*  146546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  146549 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  146549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  146552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  146566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  146581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146584 */     GIR_RootConstrainSelectedInstOperands,
     /*  146585 */     // GIR_Coverage, 48004,
     /*  146585 */     GIR_EraseRootFromParent_Done,
     /*  146586 */   // Label 2630: @146586
     /*  146586 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(146631), // Rule ID 48005 //
     /*  146591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  146594 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  146594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  146597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  146611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  146626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146629 */     GIR_RootConstrainSelectedInstOperands,
     /*  146630 */     // GIR_Coverage, 48005,
     /*  146630 */     GIR_EraseRootFromParent_Done,
     /*  146631 */   // Label 2631: @146631
     /*  146631 */   GIM_Reject,
     /*  146632 */ // Label 2629: @146632
     /*  146632 */ GIM_Reject,
     /*  146633 */ // Label 2514: @146633
     /*  146633 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(148243),
     /*  146638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146648 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(146717), // Rule ID 53214 //
     /*  146653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146696 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146715 */     GIR_RootConstrainSelectedInstOperands,
     /*  146716 */     // GIR_Coverage, 53214,
     /*  146716 */     GIR_EraseRootFromParent_Done,
     /*  146717 */   // Label 2633: @146717
     /*  146717 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(146786), // Rule ID 53215 //
     /*  146722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146765 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146784 */     GIR_RootConstrainSelectedInstOperands,
     /*  146785 */     // GIR_Coverage, 53215,
     /*  146785 */     GIR_EraseRootFromParent_Done,
     /*  146786 */   // Label 2634: @146786
     /*  146786 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(146855), // Rule ID 53216 //
     /*  146791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146834 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  146837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146853 */     GIR_RootConstrainSelectedInstOperands,
     /*  146854 */     // GIR_Coverage, 53216,
     /*  146854 */     GIR_EraseRootFromParent_Done,
     /*  146855 */   // Label 2635: @146855
     /*  146855 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(146924), // Rule ID 53217 //
     /*  146860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146903 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  146906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146922 */     GIR_RootConstrainSelectedInstOperands,
     /*  146923 */     // GIR_Coverage, 53217,
     /*  146923 */     GIR_EraseRootFromParent_Done,
     /*  146924 */   // Label 2636: @146924
     /*  146924 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(146990), // Rule ID 71817 //
     /*  146929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146971 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146988 */     GIR_RootConstrainSelectedInstOperands,
     /*  146989 */     // GIR_Coverage, 71817,
     /*  146989 */     GIR_EraseRootFromParent_Done,
     /*  146990 */   // Label 2637: @146990
     /*  146990 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(147056), // Rule ID 71818 //
     /*  146995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  147018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147037 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  147046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147054 */     GIR_RootConstrainSelectedInstOperands,
     /*  147055 */     // GIR_Coverage, 71818,
     /*  147055 */     GIR_EraseRootFromParent_Done,
     /*  147056 */   // Label 2638: @147056
     /*  147056 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(147122), // Rule ID 71815 //
     /*  147061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147103 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147120 */     GIR_RootConstrainSelectedInstOperands,
     /*  147121 */     // GIR_Coverage, 71815,
     /*  147121 */     GIR_EraseRootFromParent_Done,
     /*  147122 */   // Label 2639: @147122
     /*  147122 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(147188), // Rule ID 71816 //
     /*  147127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147169 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147186 */     GIR_RootConstrainSelectedInstOperands,
     /*  147187 */     // GIR_Coverage, 71816,
     /*  147187 */     GIR_EraseRootFromParent_Done,
     /*  147188 */   // Label 2640: @147188
     /*  147188 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(147257), // Rule ID 53218 //
     /*  147193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147236 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147255 */     GIR_RootConstrainSelectedInstOperands,
     /*  147256 */     // GIR_Coverage, 53218,
     /*  147256 */     GIR_EraseRootFromParent_Done,
     /*  147257 */   // Label 2641: @147257
     /*  147257 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(147326), // Rule ID 53219 //
     /*  147262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147305 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147324 */     GIR_RootConstrainSelectedInstOperands,
     /*  147325 */     // GIR_Coverage, 53219,
     /*  147325 */     GIR_EraseRootFromParent_Done,
     /*  147326 */   // Label 2642: @147326
     /*  147326 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(147395), // Rule ID 71811 //
     /*  147331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  147354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147374 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147393 */     GIR_RootConstrainSelectedInstOperands,
     /*  147394 */     // GIR_Coverage, 71811,
     /*  147394 */     GIR_EraseRootFromParent_Done,
     /*  147395 */   // Label 2643: @147395
     /*  147395 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(147464), // Rule ID 71812 //
     /*  147400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  147423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147443 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147462 */     GIR_RootConstrainSelectedInstOperands,
     /*  147463 */     // GIR_Coverage, 71812,
     /*  147463 */     GIR_EraseRootFromParent_Done,
     /*  147464 */   // Label 2644: @147464
     /*  147464 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(147533), // Rule ID 71813 //
     /*  147469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147512 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  147515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147531 */     GIR_RootConstrainSelectedInstOperands,
     /*  147532 */     // GIR_Coverage, 71813,
     /*  147532 */     GIR_EraseRootFromParent_Done,
     /*  147533 */   // Label 2645: @147533
     /*  147533 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(147602), // Rule ID 71814 //
     /*  147538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147581 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  147584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147600 */     GIR_RootConstrainSelectedInstOperands,
     /*  147601 */     // GIR_Coverage, 71814,
     /*  147601 */     GIR_EraseRootFromParent_Done,
     /*  147602 */   // Label 2646: @147602
     /*  147602 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(147671), // Rule ID 71819 //
     /*  147607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147650 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147669 */     GIR_RootConstrainSelectedInstOperands,
     /*  147670 */     // GIR_Coverage, 71819,
     /*  147670 */     GIR_EraseRootFromParent_Done,
     /*  147671 */   // Label 2647: @147671
     /*  147671 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(147740), // Rule ID 71820 //
     /*  147676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147719 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147738 */     GIR_RootConstrainSelectedInstOperands,
     /*  147739 */     // GIR_Coverage, 71820,
     /*  147739 */     GIR_EraseRootFromParent_Done,
     /*  147740 */   // Label 2648: @147740
     /*  147740 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(147806), // Rule ID 71823 //
     /*  147745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  147772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147787 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  147796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147804 */     GIR_RootConstrainSelectedInstOperands,
     /*  147805 */     // GIR_Coverage, 71823,
     /*  147805 */     GIR_EraseRootFromParent_Done,
     /*  147806 */   // Label 2649: @147806
     /*  147806 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(147872), // Rule ID 71824 //
     /*  147811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  147838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147853 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  147862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147870 */     GIR_RootConstrainSelectedInstOperands,
     /*  147871 */     // GIR_Coverage, 71824,
     /*  147871 */     GIR_EraseRootFromParent_Done,
     /*  147872 */   // Label 2650: @147872
     /*  147872 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(147938), // Rule ID 71821 //
     /*  147877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147919 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147936 */     GIR_RootConstrainSelectedInstOperands,
     /*  147937 */     // GIR_Coverage, 71821,
     /*  147937 */     GIR_EraseRootFromParent_Done,
     /*  147938 */   // Label 2651: @147938
     /*  147938 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(148004), // Rule ID 71822 //
     /*  147943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147985 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148002 */     GIR_RootConstrainSelectedInstOperands,
     /*  148003 */     // GIR_Coverage, 71822,
     /*  148003 */     GIR_EraseRootFromParent_Done,
     /*  148004 */   // Label 2652: @148004
     /*  148004 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(148047), // Rule ID 71837 //
     /*  148009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  148030 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  148033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  148037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  148039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148045 */     GIR_RootConstrainSelectedInstOperands,
     /*  148046 */     // GIR_Coverage, 71837,
     /*  148046 */     GIR_EraseRootFromParent_Done,
     /*  148047 */   // Label 2653: @148047
     /*  148047 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(148090), // Rule ID 71838 //
     /*  148052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  148073 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  148076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  148080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  148082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148088 */     GIR_RootConstrainSelectedInstOperands,
     /*  148089 */     // GIR_Coverage, 71838,
     /*  148089 */     GIR_EraseRootFromParent_Done,
     /*  148090 */   // Label 2654: @148090
     /*  148090 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(148133), // Rule ID 53224 //
     /*  148095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  148106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  148116 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  148119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  148123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  148125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148131 */     GIR_RootConstrainSelectedInstOperands,
     /*  148132 */     // GIR_Coverage, 53224,
     /*  148132 */     GIR_EraseRootFromParent_Done,
     /*  148133 */   // Label 2655: @148133
     /*  148133 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(148176), // Rule ID 53225 //
     /*  148138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  148149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  148159 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  148162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  148166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  148168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148174 */     GIR_RootConstrainSelectedInstOperands,
     /*  148175 */     // GIR_Coverage, 53225,
     /*  148175 */     GIR_EraseRootFromParent_Done,
     /*  148176 */   // Label 2656: @148176
     /*  148176 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(148209), // Rule ID 53212 //
     /*  148181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148192 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  148195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148207 */     GIR_RootConstrainSelectedInstOperands,
     /*  148208 */     // GIR_Coverage, 53212,
     /*  148208 */     GIR_EraseRootFromParent_Done,
     /*  148209 */   // Label 2657: @148209
     /*  148209 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(148242), // Rule ID 53213 //
     /*  148214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148225 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  148228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148240 */     GIR_RootConstrainSelectedInstOperands,
     /*  148241 */     // GIR_Coverage, 53213,
     /*  148241 */     GIR_EraseRootFromParent_Done,
     /*  148242 */   // Label 2658: @148242
     /*  148242 */   GIM_Reject,
     /*  148243 */ // Label 2632: @148243
     /*  148243 */ GIM_Reject,
     /*  148244 */ // Label 2515: @148244
     /*  148244 */ GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(148358),
     /*  148249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  148252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  148255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148267 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(148312), // Rule ID 47936 //
     /*  148272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148275 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  148275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  148278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  148292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148310 */     GIR_RootConstrainSelectedInstOperands,
     /*  148311 */     // GIR_Coverage, 47936,
     /*  148311 */     GIR_EraseRootFromParent_Done,
     /*  148312 */   // Label 2660: @148312
     /*  148312 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(148357), // Rule ID 47937 //
     /*  148317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148320 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  148320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  148323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  148337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148355 */     GIR_RootConstrainSelectedInstOperands,
     /*  148356 */     // GIR_Coverage, 47937,
     /*  148356 */     GIR_EraseRootFromParent_Done,
     /*  148357 */   // Label 2661: @148357
     /*  148357 */   GIM_Reject,
     /*  148358 */ // Label 2659: @148358
     /*  148358 */ GIM_Reject,
     /*  148359 */ // Label 2516: @148359
     /*  148359 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(148473),
     /*  148364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  148367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  148370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148382 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(148427), // Rule ID 47956 //
     /*  148387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148390 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  148390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  148393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  148407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  148422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148425 */     GIR_RootConstrainSelectedInstOperands,
     /*  148426 */     // GIR_Coverage, 47956,
     /*  148426 */     GIR_EraseRootFromParent_Done,
     /*  148427 */   // Label 2663: @148427
     /*  148427 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(148472), // Rule ID 47957 //
     /*  148432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148435 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  148435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  148438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  148452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  148467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148470 */     GIR_RootConstrainSelectedInstOperands,
     /*  148471 */     // GIR_Coverage, 47957,
     /*  148471 */     GIR_EraseRootFromParent_Done,
     /*  148472 */   // Label 2664: @148472
     /*  148472 */   GIM_Reject,
     /*  148473 */ // Label 2662: @148473
     /*  148473 */ GIM_Reject,
     /*  148474 */ // Label 2517: @148474
     /*  148474 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(148588),
     /*  148479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  148482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  148485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148497 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(148542), // Rule ID 47992 //
     /*  148502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148505 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  148505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  148508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  148522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148540 */     GIR_RootConstrainSelectedInstOperands,
     /*  148541 */     // GIR_Coverage, 47992,
     /*  148541 */     GIR_EraseRootFromParent_Done,
     /*  148542 */   // Label 2666: @148542
     /*  148542 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(148587), // Rule ID 47993 //
     /*  148547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148550 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  148550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  148553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  148567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148585 */     GIR_RootConstrainSelectedInstOperands,
     /*  148586 */     // GIR_Coverage, 47993,
     /*  148586 */     GIR_EraseRootFromParent_Done,
     /*  148587 */   // Label 2667: @148587
     /*  148587 */   GIM_Reject,
     /*  148588 */ // Label 2665: @148588
     /*  148588 */ GIM_Reject,
     /*  148589 */ // Label 2518: @148589
     /*  148589 */ GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(148703),
     /*  148594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  148597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  148600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148612 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(148657), // Rule ID 48008 //
     /*  148617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  148620 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  148620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  148623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  148637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148655 */     GIR_RootConstrainSelectedInstOperands,
     /*  148656 */     // GIR_Coverage, 48008,
     /*  148656 */     GIR_EraseRootFromParent_Done,
     /*  148657 */   // Label 2669: @148657
     /*  148657 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(148702), // Rule ID 48009 //
     /*  148662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  148665 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  148665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  148668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  148682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148700 */     GIR_RootConstrainSelectedInstOperands,
     /*  148701 */     // GIR_Coverage, 48009,
     /*  148701 */     GIR_EraseRootFromParent_Done,
     /*  148702 */   // Label 2670: @148702
     /*  148702 */   GIM_Reject,
     /*  148703 */ // Label 2668: @148703
     /*  148703 */ GIM_Reject,
     /*  148704 */ // Label 2519: @148704
     /*  148704 */ GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(150314),
     /*  148709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148719 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(148788), // Rule ID 53232 //
     /*  148724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148767 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148786 */     GIR_RootConstrainSelectedInstOperands,
     /*  148787 */     // GIR_Coverage, 53232,
     /*  148787 */     GIR_EraseRootFromParent_Done,
     /*  148788 */   // Label 2672: @148788
     /*  148788 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(148857), // Rule ID 53233 //
     /*  148793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148836 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148855 */     GIR_RootConstrainSelectedInstOperands,
     /*  148856 */     // GIR_Coverage, 53233,
     /*  148856 */     GIR_EraseRootFromParent_Done,
     /*  148857 */   // Label 2673: @148857
     /*  148857 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(148926), // Rule ID 53234 //
     /*  148862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148905 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148924 */     GIR_RootConstrainSelectedInstOperands,
     /*  148925 */     // GIR_Coverage, 53234,
     /*  148925 */     GIR_EraseRootFromParent_Done,
     /*  148926 */   // Label 2674: @148926
     /*  148926 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(148995), // Rule ID 53235 //
     /*  148931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148974 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148993 */     GIR_RootConstrainSelectedInstOperands,
     /*  148994 */     // GIR_Coverage, 53235,
     /*  148994 */     GIR_EraseRootFromParent_Done,
     /*  148995 */   // Label 2675: @148995
     /*  148995 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(149061), // Rule ID 71845 //
     /*  149000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149042 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149059 */     GIR_RootConstrainSelectedInstOperands,
     /*  149060 */     // GIR_Coverage, 71845,
     /*  149060 */     GIR_EraseRootFromParent_Done,
     /*  149061 */   // Label 2676: @149061
     /*  149061 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(149127), // Rule ID 71846 //
     /*  149066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149108 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149125 */     GIR_RootConstrainSelectedInstOperands,
     /*  149126 */     // GIR_Coverage, 71846,
     /*  149126 */     GIR_EraseRootFromParent_Done,
     /*  149127 */   // Label 2677: @149127
     /*  149127 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(149193), // Rule ID 71843 //
     /*  149132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149174 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149191 */     GIR_RootConstrainSelectedInstOperands,
     /*  149192 */     // GIR_Coverage, 71843,
     /*  149192 */     GIR_EraseRootFromParent_Done,
     /*  149193 */   // Label 2678: @149193
     /*  149193 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(149259), // Rule ID 71844 //
     /*  149198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149240 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149257 */     GIR_RootConstrainSelectedInstOperands,
     /*  149258 */     // GIR_Coverage, 71844,
     /*  149258 */     GIR_EraseRootFromParent_Done,
     /*  149259 */   // Label 2679: @149259
     /*  149259 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(149328), // Rule ID 53236 //
     /*  149264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149307 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  149320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149326 */     GIR_RootConstrainSelectedInstOperands,
     /*  149327 */     // GIR_Coverage, 53236,
     /*  149327 */     GIR_EraseRootFromParent_Done,
     /*  149328 */   // Label 2680: @149328
     /*  149328 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(149397), // Rule ID 53237 //
     /*  149333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149376 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  149389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149395 */     GIR_RootConstrainSelectedInstOperands,
     /*  149396 */     // GIR_Coverage, 53237,
     /*  149396 */     GIR_EraseRootFromParent_Done,
     /*  149397 */   // Label 2681: @149397
     /*  149397 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(149466), // Rule ID 71839 //
     /*  149402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  149425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149445 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149464 */     GIR_RootConstrainSelectedInstOperands,
     /*  149465 */     // GIR_Coverage, 71839,
     /*  149465 */     GIR_EraseRootFromParent_Done,
     /*  149466 */   // Label 2682: @149466
     /*  149466 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(149535), // Rule ID 71840 //
     /*  149471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  149494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149514 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149533 */     GIR_RootConstrainSelectedInstOperands,
     /*  149534 */     // GIR_Coverage, 71840,
     /*  149534 */     GIR_EraseRootFromParent_Done,
     /*  149535 */   // Label 2683: @149535
     /*  149535 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(149604), // Rule ID 71841 //
     /*  149540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  149563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149583 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  149586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149602 */     GIR_RootConstrainSelectedInstOperands,
     /*  149603 */     // GIR_Coverage, 71841,
     /*  149603 */     GIR_EraseRootFromParent_Done,
     /*  149604 */   // Label 2684: @149604
     /*  149604 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(149673), // Rule ID 71842 //
     /*  149609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  149632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149652 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  149655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149671 */     GIR_RootConstrainSelectedInstOperands,
     /*  149672 */     // GIR_Coverage, 71842,
     /*  149672 */     GIR_EraseRootFromParent_Done,
     /*  149673 */   // Label 2685: @149673
     /*  149673 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(149742), // Rule ID 71847 //
     /*  149678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149721 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149740 */     GIR_RootConstrainSelectedInstOperands,
     /*  149741 */     // GIR_Coverage, 71847,
     /*  149741 */     GIR_EraseRootFromParent_Done,
     /*  149742 */   // Label 2686: @149742
     /*  149742 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(149811), // Rule ID 71848 //
     /*  149747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149790 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149809 */     GIR_RootConstrainSelectedInstOperands,
     /*  149810 */     // GIR_Coverage, 71848,
     /*  149810 */     GIR_EraseRootFromParent_Done,
     /*  149811 */   // Label 2687: @149811
     /*  149811 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(149877), // Rule ID 71851 //
     /*  149816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149858 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149875 */     GIR_RootConstrainSelectedInstOperands,
     /*  149876 */     // GIR_Coverage, 71851,
     /*  149876 */     GIR_EraseRootFromParent_Done,
     /*  149877 */   // Label 2688: @149877
     /*  149877 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(149943), // Rule ID 71852 //
     /*  149882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149924 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149941 */     GIR_RootConstrainSelectedInstOperands,
     /*  149942 */     // GIR_Coverage, 71852,
     /*  149942 */     GIR_EraseRootFromParent_Done,
     /*  149943 */   // Label 2689: @149943
     /*  149943 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(150009), // Rule ID 71849 //
     /*  149948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149990 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  150001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150007 */     GIR_RootConstrainSelectedInstOperands,
     /*  150008 */     // GIR_Coverage, 71849,
     /*  150008 */     GIR_EraseRootFromParent_Done,
     /*  150009 */   // Label 2690: @150009
     /*  150009 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(150075), // Rule ID 71850 //
     /*  150014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  150033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  150037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  150046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150056 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  150059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  150067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150073 */     GIR_RootConstrainSelectedInstOperands,
     /*  150074 */     // GIR_Coverage, 71850,
     /*  150074 */     GIR_EraseRootFromParent_Done,
     /*  150075 */   // Label 2691: @150075
     /*  150075 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(150118), // Rule ID 71865 //
     /*  150080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  150101 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  150104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  150108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  150110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150116 */     GIR_RootConstrainSelectedInstOperands,
     /*  150117 */     // GIR_Coverage, 71865,
     /*  150117 */     GIR_EraseRootFromParent_Done,
     /*  150118 */   // Label 2692: @150118
     /*  150118 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(150161), // Rule ID 71866 //
     /*  150123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  150144 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  150147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  150151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  150153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150159 */     GIR_RootConstrainSelectedInstOperands,
     /*  150160 */     // GIR_Coverage, 71866,
     /*  150160 */     GIR_EraseRootFromParent_Done,
     /*  150161 */   // Label 2693: @150161
     /*  150161 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(150204), // Rule ID 53242 //
     /*  150166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  150187 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  150190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  150194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  150196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150202 */     GIR_RootConstrainSelectedInstOperands,
     /*  150203 */     // GIR_Coverage, 53242,
     /*  150203 */     GIR_EraseRootFromParent_Done,
     /*  150204 */   // Label 2694: @150204
     /*  150204 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(150247), // Rule ID 53243 //
     /*  150209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  150230 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  150233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  150237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  150239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150245 */     GIR_RootConstrainSelectedInstOperands,
     /*  150246 */     // GIR_Coverage, 53243,
     /*  150246 */     GIR_EraseRootFromParent_Done,
     /*  150247 */   // Label 2695: @150247
     /*  150247 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(150280), // Rule ID 53230 //
     /*  150252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150263 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  150266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150278 */     GIR_RootConstrainSelectedInstOperands,
     /*  150279 */     // GIR_Coverage, 53230,
     /*  150279 */     GIR_EraseRootFromParent_Done,
     /*  150280 */   // Label 2696: @150280
     /*  150280 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(150313), // Rule ID 53231 //
     /*  150285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150296 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  150299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150311 */     GIR_RootConstrainSelectedInstOperands,
     /*  150312 */     // GIR_Coverage, 53231,
     /*  150312 */     GIR_EraseRootFromParent_Done,
     /*  150313 */   // Label 2697: @150313
     /*  150313 */   GIM_Reject,
     /*  150314 */ // Label 2671: @150314
     /*  150314 */ GIM_Reject,
     /*  150315 */ // Label 2520: @150315
     /*  150315 */ GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(150429),
     /*  150320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  150323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  150326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150338 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(150383), // Rule ID 47952 //
     /*  150343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150346 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  150346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  150349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  150363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150381 */     GIR_RootConstrainSelectedInstOperands,
     /*  150382 */     // GIR_Coverage, 47952,
     /*  150382 */     GIR_EraseRootFromParent_Done,
     /*  150383 */   // Label 2699: @150383
     /*  150383 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(150428), // Rule ID 47953 //
     /*  150388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150391 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  150391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  150394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  150408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150426 */     GIR_RootConstrainSelectedInstOperands,
     /*  150427 */     // GIR_Coverage, 47953,
     /*  150427 */     GIR_EraseRootFromParent_Done,
     /*  150428 */   // Label 2700: @150428
     /*  150428 */   GIM_Reject,
     /*  150429 */ // Label 2698: @150429
     /*  150429 */ GIM_Reject,
     /*  150430 */ // Label 2521: @150430
     /*  150430 */ GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(150544),
     /*  150435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  150438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  150441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150453 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(150498), // Rule ID 47980 //
     /*  150458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150461 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  150461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  150464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  150478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150496 */     GIR_RootConstrainSelectedInstOperands,
     /*  150497 */     // GIR_Coverage, 47980,
     /*  150497 */     GIR_EraseRootFromParent_Done,
     /*  150498 */   // Label 2702: @150498
     /*  150498 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(150543), // Rule ID 47981 //
     /*  150503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150506 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  150506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  150509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  150523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150541 */     GIR_RootConstrainSelectedInstOperands,
     /*  150542 */     // GIR_Coverage, 47981,
     /*  150542 */     GIR_EraseRootFromParent_Done,
     /*  150543 */   // Label 2703: @150543
     /*  150543 */   GIM_Reject,
     /*  150544 */ // Label 2701: @150544
     /*  150544 */ GIM_Reject,
     /*  150545 */ // Label 2522: @150545
     /*  150545 */ GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(150659),
     /*  150550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  150553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  150556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150568 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(150613), // Rule ID 47996 //
     /*  150573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150576 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  150576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  150579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  150593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150611 */     GIR_RootConstrainSelectedInstOperands,
     /*  150612 */     // GIR_Coverage, 47996,
     /*  150612 */     GIR_EraseRootFromParent_Done,
     /*  150613 */   // Label 2705: @150613
     /*  150613 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(150658), // Rule ID 47997 //
     /*  150618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150621 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  150621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  150624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  150638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150656 */     GIR_RootConstrainSelectedInstOperands,
     /*  150657 */     // GIR_Coverage, 47997,
     /*  150657 */     GIR_EraseRootFromParent_Done,
     /*  150658 */   // Label 2706: @150658
     /*  150658 */   GIM_Reject,
     /*  150659 */ // Label 2704: @150659
     /*  150659 */ GIM_Reject,
     /*  150660 */ // Label 2523: @150660
     /*  150660 */ GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(150774),
     /*  150665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  150668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  150671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150683 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(150728), // Rule ID 48012 //
     /*  150688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  150691 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  150691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  150694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  150708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  150723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150726 */     GIR_RootConstrainSelectedInstOperands,
     /*  150727 */     // GIR_Coverage, 48012,
     /*  150727 */     GIR_EraseRootFromParent_Done,
     /*  150728 */   // Label 2708: @150728
     /*  150728 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(150773), // Rule ID 48013 //
     /*  150733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  150736 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  150736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  150739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  150753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  150768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150771 */     GIR_RootConstrainSelectedInstOperands,
     /*  150772 */     // GIR_Coverage, 48013,
     /*  150772 */     GIR_EraseRootFromParent_Done,
     /*  150773 */   // Label 2709: @150773
     /*  150773 */   GIM_Reject,
     /*  150774 */ // Label 2707: @150774
     /*  150774 */ GIM_Reject,
     /*  150775 */ // Label 2524: @150775
     /*  150775 */ GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(152385),
     /*  150780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150790 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(150859), // Rule ID 53250 //
     /*  150795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150838 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  150841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150857 */     GIR_RootConstrainSelectedInstOperands,
     /*  150858 */     // GIR_Coverage, 53250,
     /*  150858 */     GIR_EraseRootFromParent_Done,
     /*  150859 */   // Label 2711: @150859
     /*  150859 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(150928), // Rule ID 53251 //
     /*  150864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150907 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  150910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150926 */     GIR_RootConstrainSelectedInstOperands,
     /*  150927 */     // GIR_Coverage, 53251,
     /*  150927 */     GIR_EraseRootFromParent_Done,
     /*  150928 */   // Label 2712: @150928
     /*  150928 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(150997), // Rule ID 53252 //
     /*  150933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150976 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150995 */     GIR_RootConstrainSelectedInstOperands,
     /*  150996 */     // GIR_Coverage, 53252,
     /*  150996 */     GIR_EraseRootFromParent_Done,
     /*  150997 */   // Label 2713: @150997
     /*  150997 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(151066), // Rule ID 53253 //
     /*  151002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  151013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151045 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  151048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  151058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151064 */     GIR_RootConstrainSelectedInstOperands,
     /*  151065 */     // GIR_Coverage, 53253,
     /*  151065 */     GIR_EraseRootFromParent_Done,
     /*  151066 */   // Label 2714: @151066
     /*  151066 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(151132), // Rule ID 71873 //
     /*  151071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151113 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151130 */     GIR_RootConstrainSelectedInstOperands,
     /*  151131 */     // GIR_Coverage, 71873,
     /*  151131 */     GIR_EraseRootFromParent_Done,
     /*  151132 */   // Label 2715: @151132
     /*  151132 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(151198), // Rule ID 71874 //
     /*  151137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151179 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151196 */     GIR_RootConstrainSelectedInstOperands,
     /*  151197 */     // GIR_Coverage, 71874,
     /*  151197 */     GIR_EraseRootFromParent_Done,
     /*  151198 */   // Label 2716: @151198
     /*  151198 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(151264), // Rule ID 71871 //
     /*  151203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  151231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151245 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151262 */     GIR_RootConstrainSelectedInstOperands,
     /*  151263 */     // GIR_Coverage, 71871,
     /*  151263 */     GIR_EraseRootFromParent_Done,
     /*  151264 */   // Label 2717: @151264
     /*  151264 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(151330), // Rule ID 71872 //
     /*  151269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  151297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151311 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151328 */     GIR_RootConstrainSelectedInstOperands,
     /*  151329 */     // GIR_Coverage, 71872,
     /*  151329 */     GIR_EraseRootFromParent_Done,
     /*  151330 */   // Label 2718: @151330
     /*  151330 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(151399), // Rule ID 53254 //
     /*  151335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151378 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  151391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151397 */     GIR_RootConstrainSelectedInstOperands,
     /*  151398 */     // GIR_Coverage, 53254,
     /*  151398 */     GIR_EraseRootFromParent_Done,
     /*  151399 */   // Label 2719: @151399
     /*  151399 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(151468), // Rule ID 53255 //
     /*  151404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151447 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  151460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151466 */     GIR_RootConstrainSelectedInstOperands,
     /*  151467 */     // GIR_Coverage, 53255,
     /*  151467 */     GIR_EraseRootFromParent_Done,
     /*  151468 */   // Label 2720: @151468
     /*  151468 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(151537), // Rule ID 71867 //
     /*  151473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  151496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151516 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151535 */     GIR_RootConstrainSelectedInstOperands,
     /*  151536 */     // GIR_Coverage, 71867,
     /*  151536 */     GIR_EraseRootFromParent_Done,
     /*  151537 */   // Label 2721: @151537
     /*  151537 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(151606), // Rule ID 71868 //
     /*  151542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  151565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151585 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151604 */     GIR_RootConstrainSelectedInstOperands,
     /*  151605 */     // GIR_Coverage, 71868,
     /*  151605 */     GIR_EraseRootFromParent_Done,
     /*  151606 */   // Label 2722: @151606
     /*  151606 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(151675), // Rule ID 71869 //
     /*  151611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  151634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151654 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  151657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151673 */     GIR_RootConstrainSelectedInstOperands,
     /*  151674 */     // GIR_Coverage, 71869,
     /*  151674 */     GIR_EraseRootFromParent_Done,
     /*  151675 */   // Label 2723: @151675
     /*  151675 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(151744), // Rule ID 71870 //
     /*  151680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  151703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151723 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  151726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151742 */     GIR_RootConstrainSelectedInstOperands,
     /*  151743 */     // GIR_Coverage, 71870,
     /*  151743 */     GIR_EraseRootFromParent_Done,
     /*  151744 */   // Label 2724: @151744
     /*  151744 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(151813), // Rule ID 71875 //
     /*  151749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151792 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151811 */     GIR_RootConstrainSelectedInstOperands,
     /*  151812 */     // GIR_Coverage, 71875,
     /*  151812 */     GIR_EraseRootFromParent_Done,
     /*  151813 */   // Label 2725: @151813
     /*  151813 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(151882), // Rule ID 71876 //
     /*  151818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151861 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151880 */     GIR_RootConstrainSelectedInstOperands,
     /*  151881 */     // GIR_Coverage, 71876,
     /*  151881 */     GIR_EraseRootFromParent_Done,
     /*  151882 */   // Label 2726: @151882
     /*  151882 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(151948), // Rule ID 71879 //
     /*  151887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151929 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151946 */     GIR_RootConstrainSelectedInstOperands,
     /*  151947 */     // GIR_Coverage, 71879,
     /*  151947 */     GIR_EraseRootFromParent_Done,
     /*  151948 */   // Label 2727: @151948
     /*  151948 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(152014), // Rule ID 71880 //
     /*  151953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151995 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  152004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  152006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152012 */     GIR_RootConstrainSelectedInstOperands,
     /*  152013 */     // GIR_Coverage, 71880,
     /*  152013 */     GIR_EraseRootFromParent_Done,
     /*  152014 */   // Label 2728: @152014
     /*  152014 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(152080), // Rule ID 71877 //
     /*  152019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  152030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  152038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  152042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  152051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152061 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  152064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  152072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152078 */     GIR_RootConstrainSelectedInstOperands,
     /*  152079 */     // GIR_Coverage, 71877,
     /*  152079 */     GIR_EraseRootFromParent_Done,
     /*  152080 */   // Label 2729: @152080
     /*  152080 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(152146), // Rule ID 71878 //
     /*  152085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  152096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  152104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  152108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  152117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152127 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  152130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  152138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152144 */     GIR_RootConstrainSelectedInstOperands,
     /*  152145 */     // GIR_Coverage, 71878,
     /*  152145 */     GIR_EraseRootFromParent_Done,
     /*  152146 */   // Label 2730: @152146
     /*  152146 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(152189), // Rule ID 71893 //
     /*  152151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  152166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  152172 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  152175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  152179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  152181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152187 */     GIR_RootConstrainSelectedInstOperands,
     /*  152188 */     // GIR_Coverage, 71893,
     /*  152188 */     GIR_EraseRootFromParent_Done,
     /*  152189 */   // Label 2731: @152189
     /*  152189 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(152232), // Rule ID 71894 //
     /*  152194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  152209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  152215 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  152218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  152222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  152224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152230 */     GIR_RootConstrainSelectedInstOperands,
     /*  152231 */     // GIR_Coverage, 71894,
     /*  152231 */     GIR_EraseRootFromParent_Done,
     /*  152232 */   // Label 2732: @152232
     /*  152232 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(152275), // Rule ID 53260 //
     /*  152237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  152248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  152256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  152258 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  152261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  152265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  152267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152273 */     GIR_RootConstrainSelectedInstOperands,
     /*  152274 */     // GIR_Coverage, 53260,
     /*  152274 */     GIR_EraseRootFromParent_Done,
     /*  152275 */   // Label 2733: @152275
     /*  152275 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(152318), // Rule ID 53261 //
     /*  152280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  152291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  152299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  152301 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  152304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  152308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  152310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152316 */     GIR_RootConstrainSelectedInstOperands,
     /*  152317 */     // GIR_Coverage, 53261,
     /*  152317 */     GIR_EraseRootFromParent_Done,
     /*  152318 */   // Label 2734: @152318
     /*  152318 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(152351), // Rule ID 53248 //
     /*  152323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152334 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  152337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152349 */     GIR_RootConstrainSelectedInstOperands,
     /*  152350 */     // GIR_Coverage, 53248,
     /*  152350 */     GIR_EraseRootFromParent_Done,
     /*  152351 */   // Label 2735: @152351
     /*  152351 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(152384), // Rule ID 53249 //
     /*  152356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152367 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  152370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152382 */     GIR_RootConstrainSelectedInstOperands,
     /*  152383 */     // GIR_Coverage, 53249,
     /*  152383 */     GIR_EraseRootFromParent_Done,
     /*  152384 */   // Label 2736: @152384
     /*  152384 */   GIM_Reject,
     /*  152385 */ // Label 2710: @152385
     /*  152385 */ GIM_Reject,
     /*  152386 */ // Label 2525: @152386
     /*  152386 */ GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(152500),
     /*  152391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  152394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  152397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152409 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(152454), // Rule ID 47968 //
     /*  152414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152417 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  152417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  152420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  152434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152452 */     GIR_RootConstrainSelectedInstOperands,
     /*  152453 */     // GIR_Coverage, 47968,
     /*  152453 */     GIR_EraseRootFromParent_Done,
     /*  152454 */   // Label 2738: @152454
     /*  152454 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(152499), // Rule ID 47969 //
     /*  152459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152462 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  152462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  152465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  152479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152497 */     GIR_RootConstrainSelectedInstOperands,
     /*  152498 */     // GIR_Coverage, 47969,
     /*  152498 */     GIR_EraseRootFromParent_Done,
     /*  152499 */   // Label 2739: @152499
     /*  152499 */   GIM_Reject,
     /*  152500 */ // Label 2737: @152500
     /*  152500 */ GIM_Reject,
     /*  152501 */ // Label 2526: @152501
     /*  152501 */ GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(152615),
     /*  152506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  152509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  152512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152524 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(152569), // Rule ID 47984 //
     /*  152529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152532 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  152532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  152535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  152549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152567 */     GIR_RootConstrainSelectedInstOperands,
     /*  152568 */     // GIR_Coverage, 47984,
     /*  152568 */     GIR_EraseRootFromParent_Done,
     /*  152569 */   // Label 2741: @152569
     /*  152569 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(152614), // Rule ID 47985 //
     /*  152574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152577 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  152577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  152580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  152594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152612 */     GIR_RootConstrainSelectedInstOperands,
     /*  152613 */     // GIR_Coverage, 47985,
     /*  152613 */     GIR_EraseRootFromParent_Done,
     /*  152614 */   // Label 2742: @152614
     /*  152614 */   GIM_Reject,
     /*  152615 */ // Label 2740: @152615
     /*  152615 */ GIM_Reject,
     /*  152616 */ // Label 2527: @152616
     /*  152616 */ GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(152730),
     /*  152621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  152624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  152627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152639 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(152684), // Rule ID 48000 //
     /*  152644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152647 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  152647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  152650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  152664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152682 */     GIR_RootConstrainSelectedInstOperands,
     /*  152683 */     // GIR_Coverage, 48000,
     /*  152683 */     GIR_EraseRootFromParent_Done,
     /*  152684 */   // Label 2744: @152684
     /*  152684 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(152729), // Rule ID 48001 //
     /*  152689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152692 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  152692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  152695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  152709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152727 */     GIR_RootConstrainSelectedInstOperands,
     /*  152728 */     // GIR_Coverage, 48001,
     /*  152728 */     GIR_EraseRootFromParent_Done,
     /*  152729 */   // Label 2745: @152729
     /*  152729 */   GIM_Reject,
     /*  152730 */ // Label 2743: @152730
     /*  152730 */ GIM_Reject,
     /*  152731 */ // Label 2528: @152731
     /*  152731 */ GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(154341),
     /*  152736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152746 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(152815), // Rule ID 53268 //
     /*  152751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152794 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  152797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152813 */     GIR_RootConstrainSelectedInstOperands,
     /*  152814 */     // GIR_Coverage, 53268,
     /*  152814 */     GIR_EraseRootFromParent_Done,
     /*  152815 */   // Label 2747: @152815
     /*  152815 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(152884), // Rule ID 53269 //
     /*  152820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152863 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  152866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152882 */     GIR_RootConstrainSelectedInstOperands,
     /*  152883 */     // GIR_Coverage, 53269,
     /*  152883 */     GIR_EraseRootFromParent_Done,
     /*  152884 */   // Label 2748: @152884
     /*  152884 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(152953), // Rule ID 53270 //
     /*  152889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152932 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152951 */     GIR_RootConstrainSelectedInstOperands,
     /*  152952 */     // GIR_Coverage, 53270,
     /*  152952 */     GIR_EraseRootFromParent_Done,
     /*  152953 */   // Label 2749: @152953
     /*  152953 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(153022), // Rule ID 53271 //
     /*  152958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153001 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  153004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153020 */     GIR_RootConstrainSelectedInstOperands,
     /*  153021 */     // GIR_Coverage, 53271,
     /*  153021 */     GIR_EraseRootFromParent_Done,
     /*  153022 */   // Label 2750: @153022
     /*  153022 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(153088), // Rule ID 71901 //
     /*  153027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153069 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153086 */     GIR_RootConstrainSelectedInstOperands,
     /*  153087 */     // GIR_Coverage, 71901,
     /*  153087 */     GIR_EraseRootFromParent_Done,
     /*  153088 */   // Label 2751: @153088
     /*  153088 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(153154), // Rule ID 71902 //
     /*  153093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153135 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153152 */     GIR_RootConstrainSelectedInstOperands,
     /*  153153 */     // GIR_Coverage, 71902,
     /*  153153 */     GIR_EraseRootFromParent_Done,
     /*  153154 */   // Label 2752: @153154
     /*  153154 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(153220), // Rule ID 71899 //
     /*  153159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153201 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153218 */     GIR_RootConstrainSelectedInstOperands,
     /*  153219 */     // GIR_Coverage, 71899,
     /*  153219 */     GIR_EraseRootFromParent_Done,
     /*  153220 */   // Label 2753: @153220
     /*  153220 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(153286), // Rule ID 71900 //
     /*  153225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153267 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153284 */     GIR_RootConstrainSelectedInstOperands,
     /*  153285 */     // GIR_Coverage, 71900,
     /*  153285 */     GIR_EraseRootFromParent_Done,
     /*  153286 */   // Label 2754: @153286
     /*  153286 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(153355), // Rule ID 53272 //
     /*  153291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153334 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153353 */     GIR_RootConstrainSelectedInstOperands,
     /*  153354 */     // GIR_Coverage, 53272,
     /*  153354 */     GIR_EraseRootFromParent_Done,
     /*  153355 */   // Label 2755: @153355
     /*  153355 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(153424), // Rule ID 53273 //
     /*  153360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153403 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153422 */     GIR_RootConstrainSelectedInstOperands,
     /*  153423 */     // GIR_Coverage, 53273,
     /*  153423 */     GIR_EraseRootFromParent_Done,
     /*  153424 */   // Label 2756: @153424
     /*  153424 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(153493), // Rule ID 71895 //
     /*  153429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  153452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153472 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153491 */     GIR_RootConstrainSelectedInstOperands,
     /*  153492 */     // GIR_Coverage, 71895,
     /*  153492 */     GIR_EraseRootFromParent_Done,
     /*  153493 */   // Label 2757: @153493
     /*  153493 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(153562), // Rule ID 71896 //
     /*  153498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  153521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153541 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153560 */     GIR_RootConstrainSelectedInstOperands,
     /*  153561 */     // GIR_Coverage, 71896,
     /*  153561 */     GIR_EraseRootFromParent_Done,
     /*  153562 */   // Label 2758: @153562
     /*  153562 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(153631), // Rule ID 71897 //
     /*  153567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  153590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153610 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  153613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153629 */     GIR_RootConstrainSelectedInstOperands,
     /*  153630 */     // GIR_Coverage, 71897,
     /*  153630 */     GIR_EraseRootFromParent_Done,
     /*  153631 */   // Label 2759: @153631
     /*  153631 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(153700), // Rule ID 71898 //
     /*  153636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  153659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153679 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  153682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153698 */     GIR_RootConstrainSelectedInstOperands,
     /*  153699 */     // GIR_Coverage, 71898,
     /*  153699 */     GIR_EraseRootFromParent_Done,
     /*  153700 */   // Label 2760: @153700
     /*  153700 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(153769), // Rule ID 71903 //
     /*  153705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153748 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153767 */     GIR_RootConstrainSelectedInstOperands,
     /*  153768 */     // GIR_Coverage, 71903,
     /*  153768 */     GIR_EraseRootFromParent_Done,
     /*  153769 */   // Label 2761: @153769
     /*  153769 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(153838), // Rule ID 71904 //
     /*  153774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153817 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153836 */     GIR_RootConstrainSelectedInstOperands,
     /*  153837 */     // GIR_Coverage, 71904,
     /*  153837 */     GIR_EraseRootFromParent_Done,
     /*  153838 */   // Label 2762: @153838
     /*  153838 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(153904), // Rule ID 71907 //
     /*  153843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153885 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153902 */     GIR_RootConstrainSelectedInstOperands,
     /*  153903 */     // GIR_Coverage, 71907,
     /*  153903 */     GIR_EraseRootFromParent_Done,
     /*  153904 */   // Label 2763: @153904
     /*  153904 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(153970), // Rule ID 71908 //
     /*  153909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153951 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153968 */     GIR_RootConstrainSelectedInstOperands,
     /*  153969 */     // GIR_Coverage, 71908,
     /*  153969 */     GIR_EraseRootFromParent_Done,
     /*  153970 */   // Label 2764: @153970
     /*  153970 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(154036), // Rule ID 71905 //
     /*  153975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154017 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  154020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  154028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154034 */     GIR_RootConstrainSelectedInstOperands,
     /*  154035 */     // GIR_Coverage, 71905,
     /*  154035 */     GIR_EraseRootFromParent_Done,
     /*  154036 */   // Label 2765: @154036
     /*  154036 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(154102), // Rule ID 71906 //
     /*  154041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  154060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  154064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154083 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  154086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  154094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154100 */     GIR_RootConstrainSelectedInstOperands,
     /*  154101 */     // GIR_Coverage, 71906,
     /*  154101 */     GIR_EraseRootFromParent_Done,
     /*  154102 */   // Label 2766: @154102
     /*  154102 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(154145), // Rule ID 71921 //
     /*  154107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  154128 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  154131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  154135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  154137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154143 */     GIR_RootConstrainSelectedInstOperands,
     /*  154144 */     // GIR_Coverage, 71921,
     /*  154144 */     GIR_EraseRootFromParent_Done,
     /*  154145 */   // Label 2767: @154145
     /*  154145 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(154188), // Rule ID 71922 //
     /*  154150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  154171 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  154174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  154178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  154180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154186 */     GIR_RootConstrainSelectedInstOperands,
     /*  154187 */     // GIR_Coverage, 71922,
     /*  154187 */     GIR_EraseRootFromParent_Done,
     /*  154188 */   // Label 2768: @154188
     /*  154188 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(154231), // Rule ID 53278 //
     /*  154193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  154214 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  154217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  154221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  154223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154229 */     GIR_RootConstrainSelectedInstOperands,
     /*  154230 */     // GIR_Coverage, 53278,
     /*  154230 */     GIR_EraseRootFromParent_Done,
     /*  154231 */   // Label 2769: @154231
     /*  154231 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(154274), // Rule ID 53279 //
     /*  154236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  154257 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  154260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  154264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  154266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154272 */     GIR_RootConstrainSelectedInstOperands,
     /*  154273 */     // GIR_Coverage, 53279,
     /*  154273 */     GIR_EraseRootFromParent_Done,
     /*  154274 */   // Label 2770: @154274
     /*  154274 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(154307), // Rule ID 53266 //
     /*  154279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154290 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  154293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154305 */     GIR_RootConstrainSelectedInstOperands,
     /*  154306 */     // GIR_Coverage, 53266,
     /*  154306 */     GIR_EraseRootFromParent_Done,
     /*  154307 */   // Label 2771: @154307
     /*  154307 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(154340), // Rule ID 53267 //
     /*  154312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154323 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  154326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154338 */     GIR_RootConstrainSelectedInstOperands,
     /*  154339 */     // GIR_Coverage, 53267,
     /*  154339 */     GIR_EraseRootFromParent_Done,
     /*  154340 */   // Label 2772: @154340
     /*  154340 */   GIM_Reject,
     /*  154341 */ // Label 2746: @154341
     /*  154341 */ GIM_Reject,
     /*  154342 */ // Label 2529: @154342
     /*  154342 */ GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(154456),
     /*  154347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  154350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  154353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  154357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  154361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  154365 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(154410), // Rule ID 47972 //
     /*  154370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154373 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  154373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  154376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  154380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  154385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  154387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  154390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  154395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154408 */     GIR_RootConstrainSelectedInstOperands,
     /*  154409 */     // GIR_Coverage, 47972,
     /*  154409 */     GIR_EraseRootFromParent_Done,
     /*  154410 */   // Label 2774: @154410
     /*  154410 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(154455), // Rule ID 47973 //
     /*  154415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154418 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  154418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  154421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  154425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  154430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  154432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  154435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  154440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154453 */     GIR_RootConstrainSelectedInstOperands,
     /*  154454 */     // GIR_Coverage, 47973,
     /*  154454 */     GIR_EraseRootFromParent_Done,
     /*  154455 */   // Label 2775: @154455
     /*  154455 */   GIM_Reject,
     /*  154456 */ // Label 2773: @154456
     /*  154456 */ GIM_Reject,
     /*  154457 */ // Label 2530: @154457
     /*  154457 */ GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(154571),
     /*  154462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  154465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  154468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154480 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(154525), // Rule ID 47988 //
     /*  154485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154488 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  154488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  154491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  154495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  154500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  154502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  154505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  154510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  154520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154523 */     GIR_RootConstrainSelectedInstOperands,
     /*  154524 */     // GIR_Coverage, 47988,
     /*  154524 */     GIR_EraseRootFromParent_Done,
     /*  154525 */   // Label 2777: @154525
     /*  154525 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(154570), // Rule ID 47989 //
     /*  154530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154533 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  154533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  154536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  154540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  154545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  154547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  154550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  154555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  154565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154568 */     GIR_RootConstrainSelectedInstOperands,
     /*  154569 */     // GIR_Coverage, 47989,
     /*  154569 */     GIR_EraseRootFromParent_Done,
     /*  154570 */   // Label 2778: @154570
     /*  154570 */   GIM_Reject,
     /*  154571 */ // Label 2776: @154571
     /*  154571 */ GIM_Reject,
     /*  154572 */ // Label 2531: @154572
     /*  154572 */ GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(156182),
     /*  154577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154587 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(154656), // Rule ID 53286 //
     /*  154592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154635 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154654 */     GIR_RootConstrainSelectedInstOperands,
     /*  154655 */     // GIR_Coverage, 53286,
     /*  154655 */     GIR_EraseRootFromParent_Done,
     /*  154656 */   // Label 2780: @154656
     /*  154656 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(154725), // Rule ID 53287 //
     /*  154661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154704 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154723 */     GIR_RootConstrainSelectedInstOperands,
     /*  154724 */     // GIR_Coverage, 53287,
     /*  154724 */     GIR_EraseRootFromParent_Done,
     /*  154725 */   // Label 2781: @154725
     /*  154725 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(154794), // Rule ID 53288 //
     /*  154730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154773 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154792 */     GIR_RootConstrainSelectedInstOperands,
     /*  154793 */     // GIR_Coverage, 53288,
     /*  154793 */     GIR_EraseRootFromParent_Done,
     /*  154794 */   // Label 2782: @154794
     /*  154794 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(154863), // Rule ID 53289 //
     /*  154799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154842 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154861 */     GIR_RootConstrainSelectedInstOperands,
     /*  154862 */     // GIR_Coverage, 53289,
     /*  154862 */     GIR_EraseRootFromParent_Done,
     /*  154863 */   // Label 2783: @154863
     /*  154863 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(154929), // Rule ID 71929 //
     /*  154868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154910 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154927 */     GIR_RootConstrainSelectedInstOperands,
     /*  154928 */     // GIR_Coverage, 71929,
     /*  154928 */     GIR_EraseRootFromParent_Done,
     /*  154929 */   // Label 2784: @154929
     /*  154929 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(154995), // Rule ID 71930 //
     /*  154934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154976 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154993 */     GIR_RootConstrainSelectedInstOperands,
     /*  154994 */     // GIR_Coverage, 71930,
     /*  154994 */     GIR_EraseRootFromParent_Done,
     /*  154995 */   // Label 2785: @154995
     /*  154995 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(155061), // Rule ID 71927 //
     /*  155000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  155036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155042 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155059 */     GIR_RootConstrainSelectedInstOperands,
     /*  155060 */     // GIR_Coverage, 71927,
     /*  155060 */     GIR_EraseRootFromParent_Done,
     /*  155061 */   // Label 2786: @155061
     /*  155061 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(155127), // Rule ID 71928 //
     /*  155066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155108 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155125 */     GIR_RootConstrainSelectedInstOperands,
     /*  155126 */     // GIR_Coverage, 71928,
     /*  155126 */     GIR_EraseRootFromParent_Done,
     /*  155127 */   // Label 2787: @155127
     /*  155127 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155196), // Rule ID 53290 //
     /*  155132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  155173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155175 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  155188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155194 */     GIR_RootConstrainSelectedInstOperands,
     /*  155195 */     // GIR_Coverage, 53290,
     /*  155195 */     GIR_EraseRootFromParent_Done,
     /*  155196 */   // Label 2788: @155196
     /*  155196 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155265), // Rule ID 53291 //
     /*  155201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155244 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  155257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155263 */     GIR_RootConstrainSelectedInstOperands,
     /*  155264 */     // GIR_Coverage, 53291,
     /*  155264 */     GIR_EraseRootFromParent_Done,
     /*  155265 */   // Label 2789: @155265
     /*  155265 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(155334), // Rule ID 71923 //
     /*  155270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  155293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155313 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155332 */     GIR_RootConstrainSelectedInstOperands,
     /*  155333 */     // GIR_Coverage, 71923,
     /*  155333 */     GIR_EraseRootFromParent_Done,
     /*  155334 */   // Label 2790: @155334
     /*  155334 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(155403), // Rule ID 71924 //
     /*  155339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  155362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155382 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155401 */     GIR_RootConstrainSelectedInstOperands,
     /*  155402 */     // GIR_Coverage, 71924,
     /*  155402 */     GIR_EraseRootFromParent_Done,
     /*  155403 */   // Label 2791: @155403
     /*  155403 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(155472), // Rule ID 71925 //
     /*  155408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  155431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155451 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  155454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155470 */     GIR_RootConstrainSelectedInstOperands,
     /*  155471 */     // GIR_Coverage, 71925,
     /*  155471 */     GIR_EraseRootFromParent_Done,
     /*  155472 */   // Label 2792: @155472
     /*  155472 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(155541), // Rule ID 71926 //
     /*  155477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  155500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155520 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  155523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155539 */     GIR_RootConstrainSelectedInstOperands,
     /*  155540 */     // GIR_Coverage, 71926,
     /*  155540 */     GIR_EraseRootFromParent_Done,
     /*  155541 */   // Label 2793: @155541
     /*  155541 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(155610), // Rule ID 71931 //
     /*  155546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155589 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155608 */     GIR_RootConstrainSelectedInstOperands,
     /*  155609 */     // GIR_Coverage, 71931,
     /*  155609 */     GIR_EraseRootFromParent_Done,
     /*  155610 */   // Label 2794: @155610
     /*  155610 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(155679), // Rule ID 71932 //
     /*  155615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155658 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155677 */     GIR_RootConstrainSelectedInstOperands,
     /*  155678 */     // GIR_Coverage, 71932,
     /*  155678 */     GIR_EraseRootFromParent_Done,
     /*  155679 */   // Label 2795: @155679
     /*  155679 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(155745), // Rule ID 71935 //
     /*  155684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  155711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  155719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155726 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  155735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155743 */     GIR_RootConstrainSelectedInstOperands,
     /*  155744 */     // GIR_Coverage, 71935,
     /*  155744 */     GIR_EraseRootFromParent_Done,
     /*  155745 */   // Label 2796: @155745
     /*  155745 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(155811), // Rule ID 71936 //
     /*  155750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  155777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155792 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  155801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155809 */     GIR_RootConstrainSelectedInstOperands,
     /*  155810 */     // GIR_Coverage, 71936,
     /*  155810 */     GIR_EraseRootFromParent_Done,
     /*  155811 */   // Label 2797: @155811
     /*  155811 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(155877), // Rule ID 71933 //
     /*  155816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  155856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155858 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155875 */     GIR_RootConstrainSelectedInstOperands,
     /*  155876 */     // GIR_Coverage, 71933,
     /*  155876 */     GIR_EraseRootFromParent_Done,
     /*  155877 */   // Label 2798: @155877
     /*  155877 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(155943), // Rule ID 71934 //
     /*  155882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155924 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155941 */     GIR_RootConstrainSelectedInstOperands,
     /*  155942 */     // GIR_Coverage, 71934,
     /*  155942 */     GIR_EraseRootFromParent_Done,
     /*  155943 */   // Label 2799: @155943
     /*  155943 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(155986), // Rule ID 71949 //
     /*  155948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155969 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155984 */     GIR_RootConstrainSelectedInstOperands,
     /*  155985 */     // GIR_Coverage, 71949,
     /*  155985 */     GIR_EraseRootFromParent_Done,
     /*  155986 */   // Label 2800: @155986
     /*  155986 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(156029), // Rule ID 71950 //
     /*  155991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  156002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  156006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  156012 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  156012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  156015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  156019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  156021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156027 */     GIR_RootConstrainSelectedInstOperands,
     /*  156028 */     // GIR_Coverage, 71950,
     /*  156028 */     GIR_EraseRootFromParent_Done,
     /*  156029 */   // Label 2801: @156029
     /*  156029 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(156072), // Rule ID 53296 //
     /*  156034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  156045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  156049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  156053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  156055 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  156055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  156058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  156062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  156064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156070 */     GIR_RootConstrainSelectedInstOperands,
     /*  156071 */     // GIR_Coverage, 53296,
     /*  156071 */     GIR_EraseRootFromParent_Done,
     /*  156072 */   // Label 2802: @156072
     /*  156072 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(156115), // Rule ID 53297 //
     /*  156077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  156088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  156092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  156096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  156098 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  156098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  156101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  156105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  156107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156113 */     GIR_RootConstrainSelectedInstOperands,
     /*  156114 */     // GIR_Coverage, 53297,
     /*  156114 */     GIR_EraseRootFromParent_Done,
     /*  156115 */   // Label 2803: @156115
     /*  156115 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(156148), // Rule ID 53284 //
     /*  156120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156131 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  156131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  156134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  156140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156146 */     GIR_RootConstrainSelectedInstOperands,
     /*  156147 */     // GIR_Coverage, 53284,
     /*  156147 */     GIR_EraseRootFromParent_Done,
     /*  156148 */   // Label 2804: @156148
     /*  156148 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(156181), // Rule ID 53285 //
     /*  156153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156164 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  156164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  156167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  156173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156179 */     GIR_RootConstrainSelectedInstOperands,
     /*  156180 */     // GIR_Coverage, 53285,
     /*  156180 */     GIR_EraseRootFromParent_Done,
     /*  156181 */   // Label 2805: @156181
     /*  156181 */   GIM_Reject,
     /*  156182 */ // Label 2779: @156182
     /*  156182 */ GIM_Reject,
     /*  156183 */ // Label 2532: @156183
     /*  156183 */ GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(156297),
     /*  156188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  156191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  156194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  156198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  156202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  156206 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(156251), // Rule ID 47976 //
     /*  156211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156214 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  156214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  156217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  156221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  156226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  156228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  156231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  156236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  156240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156249 */     GIR_RootConstrainSelectedInstOperands,
     /*  156250 */     // GIR_Coverage, 47976,
     /*  156250 */     GIR_EraseRootFromParent_Done,
     /*  156251 */   // Label 2807: @156251
     /*  156251 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(156296), // Rule ID 47977 //
     /*  156256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156259 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  156259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  156262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  156266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  156271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  156273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  156276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  156281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  156285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156294 */     GIR_RootConstrainSelectedInstOperands,
     /*  156295 */     // GIR_Coverage, 47977,
     /*  156295 */     GIR_EraseRootFromParent_Done,
     /*  156296 */   // Label 2808: @156296
     /*  156296 */   GIM_Reject,
     /*  156297 */ // Label 2806: @156297
     /*  156297 */ GIM_Reject,
     /*  156298 */ // Label 2533: @156298
     /*  156298 */ GIM_Reject,
     /*  156299 */ // Label 10: @156299
     /*  156299 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(156359),
     /*  156304 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  156308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156312 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(156335), // Rule ID 124 //
     /*  156317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  156320 */     // MIs[0] Operand 1
     /*  156320 */     // No operand predicates
     /*  156320 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i64] })
     /*  156320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  156323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156325 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  156330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156333 */     GIR_RootConstrainSelectedInstOperands,
     /*  156334 */     // GIR_Coverage, 124,
     /*  156334 */     GIR_EraseRootFromParent_Done,
     /*  156335 */   // Label 2810: @156335
     /*  156335 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(156358), // Rule ID 125 //
     /*  156340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  156343 */     // MIs[0] Operand 1
     /*  156343 */     // No operand predicates
     /*  156343 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i32] })
     /*  156343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  156346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156348 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  156353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156356 */     GIR_RootConstrainSelectedInstOperands,
     /*  156357 */     // GIR_Coverage, 125,
     /*  156357 */     GIR_EraseRootFromParent_Done,
     /*  156358 */   // Label 2811: @156358
     /*  156358 */   GIM_Reject,
     /*  156359 */ // Label 2809: @156359
     /*  156359 */ GIM_Reject,
     /*  156360 */ // Label 11: @156360
     /*  156360 */ GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(156420),
     /*  156365 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  156368 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  156371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  156377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156389 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(156404), // Rule ID 64 //
     /*  156394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  156397 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  156397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  156402 */     GIR_RootConstrainSelectedInstOperands,
     /*  156403 */     // GIR_Coverage, 64,
     /*  156403 */     GIR_Done,
     /*  156404 */   // Label 2813: @156404
     /*  156404 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(156419), // Rule ID 65 //
     /*  156409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  156412 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  156412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  156417 */     GIR_RootConstrainSelectedInstOperands,
     /*  156418 */     // GIR_Coverage, 65,
     /*  156418 */     GIR_Done,
     /*  156419 */   // Label 2814: @156419
     /*  156419 */   GIM_Reject,
     /*  156420 */ // Label 2812: @156420
     /*  156420 */ GIM_Reject,
     /*  156421 */ // Label 12: @156421
     /*  156421 */ GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(156511),
     /*  156426 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  156429 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  156432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  156438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156450 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(156465), // Rule ID 62 //
     /*  156455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  156458 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  156458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  156463 */     GIR_RootConstrainSelectedInstOperands,
     /*  156464 */     // GIR_Coverage, 62,
     /*  156464 */     GIR_Done,
     /*  156465 */   // Label 2816: @156465
     /*  156465 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(156480), // Rule ID 63 //
     /*  156470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  156473 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  156473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  156478 */     GIR_RootConstrainSelectedInstOperands,
     /*  156479 */     // GIR_Coverage, 63,
     /*  156479 */     GIR_Done,
     /*  156480 */   // Label 2817: @156480
     /*  156480 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(156495), // Rule ID 2412 //
     /*  156485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0),
     /*  156488 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  156488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  156493 */     GIR_RootConstrainSelectedInstOperands,
     /*  156494 */     // GIR_Coverage, 2412,
     /*  156494 */     GIR_Done,
     /*  156495 */   // Label 2818: @156495
     /*  156495 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(156510), // Rule ID 2413 //
     /*  156500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1),
     /*  156503 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  156503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  156508 */     GIR_RootConstrainSelectedInstOperands,
     /*  156509 */     // GIR_Coverage, 2413,
     /*  156509 */     GIR_Done,
     /*  156510 */   // Label 2819: @156510
     /*  156510 */   GIM_Reject,
     /*  156511 */ // Label 2815: @156511
     /*  156511 */ GIM_Reject,
     /*  156512 */ // Label 13: @156512
     /*  156512 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2822*/ GIMT_Encode4(156878),
     /*  156523 */ /*GILLT_s32*//*Label 2820*/ GIMT_Encode4(156531),
     /*  156527 */ /*GILLT_s64*//*Label 2821*/ GIMT_Encode4(156768),
     /*  156531 */ // Label 2820: @156531
     /*  156531 */ GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(156767),
     /*  156536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156539 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(156562), // Rule ID 1455 //
     /*  156544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  156547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156555 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  156555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  156560 */     GIR_RootConstrainSelectedInstOperands,
     /*  156561 */     // GIR_Coverage, 1455,
     /*  156561 */     GIR_Done,
     /*  156562 */   // Label 2824: @156562
     /*  156562 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(156585), // Rule ID 1456 //
     /*  156567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  156570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156578 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  156578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  156583 */     GIR_RootConstrainSelectedInstOperands,
     /*  156584 */     // GIR_Coverage, 1456,
     /*  156584 */     GIR_Done,
     /*  156585 */   // Label 2825: @156585
     /*  156585 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(156608), // Rule ID 1457 //
     /*  156590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  156593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156601 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  156601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  156606 */     GIR_RootConstrainSelectedInstOperands,
     /*  156607 */     // GIR_Coverage, 1457,
     /*  156607 */     GIR_Done,
     /*  156608 */   // Label 2826: @156608
     /*  156608 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(156631), // Rule ID 1458 //
     /*  156613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  156616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156624 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  156624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  156629 */     GIR_RootConstrainSelectedInstOperands,
     /*  156630 */     // GIR_Coverage, 1458,
     /*  156630 */     GIR_Done,
     /*  156631 */   // Label 2827: @156631
     /*  156631 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(156669), // Rule ID 1459 //
     /*  156636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  156639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156647 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  156647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  156652 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  156658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156668 */     // GIR_Coverage, 1459,
     /*  156668 */     GIR_EraseRootFromParent_Done,
     /*  156669 */   // Label 2828: @156669
     /*  156669 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(156707), // Rule ID 1460 //
     /*  156674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  156677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156685 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  156685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  156690 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  156696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156706 */     // GIR_Coverage, 1460,
     /*  156706 */     GIR_EraseRootFromParent_Done,
     /*  156707 */   // Label 2829: @156707
     /*  156707 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(156766), // Rule ID 1461 //
     /*  156712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  156715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156723 */     // (bitconvert:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), FPR32INX:{ *:[f32] }:$rs1, sub_32:{ *:[i32] })
     /*  156723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  156726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  156730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  156735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  156737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  156740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  156742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  156745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  156750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156765 */     // GIR_Coverage, 1461,
     /*  156765 */     GIR_EraseRootFromParent_Done,
     /*  156766 */   // Label 2830: @156766
     /*  156766 */   GIM_Reject,
     /*  156767 */ // Label 2823: @156767
     /*  156767 */ GIM_Reject,
     /*  156768 */ // Label 2821: @156768
     /*  156768 */ GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(156877),
     /*  156773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156776 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(156799), // Rule ID 1908 //
     /*  156781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  156784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156792 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FMV_D_X:{ *:[f64] } GPR:{ *:[i64] }:$rs1)
     /*  156792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_D_X),
     /*  156797 */     GIR_RootConstrainSelectedInstOperands,
     /*  156798 */     // GIR_Coverage, 1908,
     /*  156798 */     GIR_Done,
     /*  156799 */   // Label 2832: @156799
     /*  156799 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(156822), // Rule ID 1909 //
     /*  156804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  156807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156815 */     // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMV_X_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)
     /*  156815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_D),
     /*  156820 */     GIR_RootConstrainSelectedInstOperands,
     /*  156821 */     // GIR_Coverage, 1909,
     /*  156821 */     GIR_Done,
     /*  156822 */   // Label 2833: @156822
     /*  156822 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(156849), // Rule ID 1936 //
     /*  156827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  156830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156838 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i32] })
     /*  156838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156848 */     // GIR_Coverage, 1936,
     /*  156848 */     GIR_Done,
     /*  156849 */   // Label 2834: @156849
     /*  156849 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(156876), // Rule ID 1937 //
     /*  156854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  156857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156865 */     // (bitconvert:{ *:[i64] } GPR:{ *:[f64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[i64] } GPR:{ *:[f64] }:$rs1, GPR:{ *:[i32] })
     /*  156865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156875 */     // GIR_Coverage, 1937,
     /*  156875 */     GIR_Done,
     /*  156876 */   // Label 2835: @156876
     /*  156876 */   GIM_Reject,
     /*  156877 */ // Label 2831: @156877
     /*  156877 */ GIM_Reject,
     /*  156878 */ // Label 2822: @156878
     /*  156878 */ GIM_Reject,
     /*  156879 */ // Label 14: @156879
     /*  156879 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2839*/ GIMT_Encode4(157076),
     /*  156890 */ /*GILLT_s16*//*Label 2836*/ GIMT_Encode4(156902),
     /*  156894 */ /*GILLT_s32*//*Label 2837*/ GIMT_Encode4(156960),
     /*  156898 */ /*GILLT_s64*//*Label 2838*/ GIMT_Encode4(157018),
     /*  156902 */ // Label 2836: @156902
     /*  156902 */ GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(156959),
     /*  156907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156918 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(156938), // Rule ID 2444 //
     /*  156923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  156926 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /*  156926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156936 */     GIR_RootConstrainSelectedInstOperands,
     /*  156937 */     // GIR_Coverage, 2444,
     /*  156937 */     GIR_EraseRootFromParent_Done,
     /*  156938 */   // Label 2841: @156938
     /*  156938 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(156958), // Rule ID 2445 //
     /*  156943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  156946 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /*  156946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156956 */     GIR_RootConstrainSelectedInstOperands,
     /*  156957 */     // GIR_Coverage, 2445,
     /*  156957 */     GIR_EraseRootFromParent_Done,
     /*  156958 */   // Label 2842: @156958
     /*  156958 */   GIM_Reject,
     /*  156959 */ // Label 2840: @156959
     /*  156959 */ GIM_Reject,
     /*  156960 */ // Label 2837: @156960
     /*  156960 */ GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(157017),
     /*  156965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156976 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(156996), // Rule ID 2362 //
     /*  156981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  156984 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /*  156984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156994 */     GIR_RootConstrainSelectedInstOperands,
     /*  156995 */     // GIR_Coverage, 2362,
     /*  156995 */     GIR_EraseRootFromParent_Done,
     /*  156996 */   // Label 2844: @156996
     /*  156996 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(157016), // Rule ID 2363 //
     /*  157001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  157004 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /*  157004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  157014 */     GIR_RootConstrainSelectedInstOperands,
     /*  157015 */     // GIR_Coverage, 2363,
     /*  157015 */     GIR_EraseRootFromParent_Done,
     /*  157016 */   // Label 2845: @157016
     /*  157016 */   GIM_Reject,
     /*  157017 */ // Label 2843: @157017
     /*  157017 */ GIM_Reject,
     /*  157018 */ // Label 2838: @157018
     /*  157018 */ GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(157075),
     /*  157023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157034 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(157054), // Rule ID 2402 //
     /*  157039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  157042 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /*  157042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  157052 */     GIR_RootConstrainSelectedInstOperands,
     /*  157053 */     // GIR_Coverage, 2402,
     /*  157053 */     GIR_EraseRootFromParent_Done,
     /*  157054 */   // Label 2847: @157054
     /*  157054 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(157074), // Rule ID 2403 //
     /*  157059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  157062 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /*  157062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  157072 */     GIR_RootConstrainSelectedInstOperands,
     /*  157073 */     // GIR_Coverage, 2403,
     /*  157073 */     GIR_EraseRootFromParent_Done,
     /*  157074 */   // Label 2848: @157074
     /*  157074 */   GIM_Reject,
     /*  157075 */ // Label 2846: @157075
     /*  157075 */ GIM_Reject,
     /*  157076 */ // Label 2839: @157076
     /*  157076 */ GIM_Reject,
     /*  157077 */ // Label 15: @157077
     /*  157077 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2852*/ GIMT_Encode4(157274),
     /*  157088 */ /*GILLT_s16*//*Label 2849*/ GIMT_Encode4(157100),
     /*  157092 */ /*GILLT_s32*//*Label 2850*/ GIMT_Encode4(157158),
     /*  157096 */ /*GILLT_s64*//*Label 2851*/ GIMT_Encode4(157216),
     /*  157100 */ // Label 2849: @157100
     /*  157100 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(157157),
     /*  157105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157116 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(157136), // Rule ID 2428 //
     /*  157121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  157124 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /*  157124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  157127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157134 */     GIR_RootConstrainSelectedInstOperands,
     /*  157135 */     // GIR_Coverage, 2428,
     /*  157135 */     GIR_EraseRootFromParent_Done,
     /*  157136 */   // Label 2854: @157136
     /*  157136 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(157156), // Rule ID 2429 //
     /*  157141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  157144 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /*  157144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  157147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157154 */     GIR_RootConstrainSelectedInstOperands,
     /*  157155 */     // GIR_Coverage, 2429,
     /*  157155 */     GIR_EraseRootFromParent_Done,
     /*  157156 */   // Label 2855: @157156
     /*  157156 */   GIM_Reject,
     /*  157157 */ // Label 2853: @157157
     /*  157157 */ GIM_Reject,
     /*  157158 */ // Label 2850: @157158
     /*  157158 */ GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(157215),
     /*  157163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157174 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(157194), // Rule ID 2346 //
     /*  157179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  157182 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /*  157182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157192 */     GIR_RootConstrainSelectedInstOperands,
     /*  157193 */     // GIR_Coverage, 2346,
     /*  157193 */     GIR_EraseRootFromParent_Done,
     /*  157194 */   // Label 2857: @157194
     /*  157194 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(157214), // Rule ID 2347 //
     /*  157199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  157202 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /*  157202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157212 */     GIR_RootConstrainSelectedInstOperands,
     /*  157213 */     // GIR_Coverage, 2347,
     /*  157213 */     GIR_EraseRootFromParent_Done,
     /*  157214 */   // Label 2858: @157214
     /*  157214 */   GIM_Reject,
     /*  157215 */ // Label 2856: @157215
     /*  157215 */ GIM_Reject,
     /*  157216 */ // Label 2851: @157216
     /*  157216 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(157273),
     /*  157221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157232 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(157252), // Rule ID 2386 //
     /*  157237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  157240 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /*  157240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157250 */     GIR_RootConstrainSelectedInstOperands,
     /*  157251 */     // GIR_Coverage, 2386,
     /*  157251 */     GIR_EraseRootFromParent_Done,
     /*  157252 */   // Label 2860: @157252
     /*  157252 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(157272), // Rule ID 2387 //
     /*  157257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  157260 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /*  157260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157270 */     GIR_RootConstrainSelectedInstOperands,
     /*  157271 */     // GIR_Coverage, 2387,
     /*  157271 */     GIR_EraseRootFromParent_Done,
     /*  157272 */   // Label 2861: @157272
     /*  157272 */   GIM_Reject,
     /*  157273 */ // Label 2859: @157273
     /*  157273 */ GIM_Reject,
     /*  157274 */ // Label 2852: @157274
     /*  157274 */ GIM_Reject,
     /*  157275 */ // Label 16: @157275
     /*  157275 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2864*/ GIMT_Encode4(157854),
     /*  157286 */ /*GILLT_s32*//*Label 2862*/ GIMT_Encode4(157294),
     /*  157290 */ /*GILLT_s64*//*Label 2863*/ GIMT_Encode4(157667),
     /*  157294 */ // Label 2862: @157294
     /*  157294 */ GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(157325), // Rule ID 1474 //
     /*  157299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  157302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157313 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  157316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157318 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157323 */   GIR_RootConstrainSelectedInstOperands,
     /*  157324 */   // GIR_Coverage, 1474,
     /*  157324 */   GIR_EraseRootFromParent_Done,
     /*  157325 */ // Label 2865: @157325
     /*  157325 */ GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(157356), // Rule ID 1475 //
     /*  157330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  157333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157344 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  157344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  157347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157349 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157354 */   GIR_RootConstrainSelectedInstOperands,
     /*  157355 */   // GIR_Coverage, 1475,
     /*  157355 */   GIR_EraseRootFromParent_Done,
     /*  157356 */ // Label 2866: @157356
     /*  157356 */ GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(157387), // Rule ID 1500 //
     /*  157361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  157364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157375 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  157378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157380 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157385 */   GIR_RootConstrainSelectedInstOperands,
     /*  157386 */   // GIR_Coverage, 1500,
     /*  157386 */   GIR_EraseRootFromParent_Done,
     /*  157387 */ // Label 2867: @157387
     /*  157387 */ GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(157418), // Rule ID 1501 //
     /*  157392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  157395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157406 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  157406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  157409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157411 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157416 */   GIR_RootConstrainSelectedInstOperands,
     /*  157417 */   // GIR_Coverage, 1501,
     /*  157417 */   GIR_EraseRootFromParent_Done,
     /*  157418 */ // Label 2868: @157418
     /*  157418 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(157449), // Rule ID 1868 //
     /*  157423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /*  157426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157437 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  157440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157442 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157447 */   GIR_RootConstrainSelectedInstOperands,
     /*  157448 */   // GIR_Coverage, 1868,
     /*  157448 */   GIR_EraseRootFromParent_Done,
     /*  157449 */ // Label 2869: @157449
     /*  157449 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(157480), // Rule ID 1869 //
     /*  157454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /*  157457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157468 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  157468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  157471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157473 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157478 */   GIR_RootConstrainSelectedInstOperands,
     /*  157479 */   // GIR_Coverage, 1869,
     /*  157479 */   GIR_EraseRootFromParent_Done,
     /*  157480 */ // Label 2870: @157480
     /*  157480 */ GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(157511), // Rule ID 1894 //
     /*  157485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /*  157488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  157499 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  157502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157504 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157509 */   GIR_RootConstrainSelectedInstOperands,
     /*  157510 */   // GIR_Coverage, 1894,
     /*  157510 */   GIR_EraseRootFromParent_Done,
     /*  157511 */ // Label 2871: @157511
     /*  157511 */ GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(157542), // Rule ID 1895 //
     /*  157516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /*  157519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  157530 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  157530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  157533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157535 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157540 */   GIR_RootConstrainSelectedInstOperands,
     /*  157541 */   // GIR_Coverage, 1895,
     /*  157541 */   GIR_EraseRootFromParent_Done,
     /*  157542 */ // Label 2872: @157542
     /*  157542 */ GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(157573), // Rule ID 2210 //
     /*  157547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /*  157550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157561 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  157564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157566 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157571 */   GIR_RootConstrainSelectedInstOperands,
     /*  157572 */   // GIR_Coverage, 2210,
     /*  157572 */   GIR_EraseRootFromParent_Done,
     /*  157573 */ // Label 2873: @157573
     /*  157573 */ GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(157604), // Rule ID 2211 //
     /*  157578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /*  157581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157592 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  157592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  157595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157597 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157602 */   GIR_RootConstrainSelectedInstOperands,
     /*  157603 */   // GIR_Coverage, 2211,
     /*  157603 */   GIR_EraseRootFromParent_Done,
     /*  157604 */ // Label 2874: @157604
     /*  157604 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(157635), // Rule ID 2236 //
     /*  157609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /*  157612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157623 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  157626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157628 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157633 */   GIR_RootConstrainSelectedInstOperands,
     /*  157634 */   // GIR_Coverage, 2236,
     /*  157634 */   GIR_EraseRootFromParent_Done,
     /*  157635 */ // Label 2875: @157635
     /*  157635 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(157666), // Rule ID 2237 //
     /*  157640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /*  157643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157654 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  157654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  157657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157659 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157664 */   GIR_RootConstrainSelectedInstOperands,
     /*  157665 */   // GIR_Coverage, 2237,
     /*  157665 */   GIR_EraseRootFromParent_Done,
     /*  157666 */ // Label 2876: @157666
     /*  157666 */ GIM_Reject,
     /*  157667 */ // Label 2863: @157667
     /*  157667 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(157698), // Rule ID 1527 //
     /*  157672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  157675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157686 */   // (lrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  157689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157691 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157696 */   GIR_RootConstrainSelectedInstOperands,
     /*  157697 */   // GIR_Coverage, 1527,
     /*  157697 */   GIR_EraseRootFromParent_Done,
     /*  157698 */ // Label 2877: @157698
     /*  157698 */ GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(157729), // Rule ID 1555 //
     /*  157703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  157706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157717 */   // (lrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  157720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157722 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157727 */   GIR_RootConstrainSelectedInstOperands,
     /*  157728 */   // GIR_Coverage, 1555,
     /*  157728 */   GIR_EraseRootFromParent_Done,
     /*  157729 */ // Label 2878: @157729
     /*  157729 */ GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(157760), // Rule ID 1925 //
     /*  157734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  157737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157748 */   // (lrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  157751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157753 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157758 */   GIR_RootConstrainSelectedInstOperands,
     /*  157759 */   // GIR_Coverage, 1925,
     /*  157759 */   GIR_EraseRootFromParent_Done,
     /*  157760 */ // Label 2879: @157760
     /*  157760 */ GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(157791), // Rule ID 1953 //
     /*  157765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  157768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157779 */   // (lrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  157782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157784 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157789 */   GIR_RootConstrainSelectedInstOperands,
     /*  157790 */   // GIR_Coverage, 1953,
     /*  157790 */   GIR_EraseRootFromParent_Done,
     /*  157791 */ // Label 2880: @157791
     /*  157791 */ GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(157822), // Rule ID 2261 //
     /*  157796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  157799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157810 */   // (lrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  157813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157815 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157820 */   GIR_RootConstrainSelectedInstOperands,
     /*  157821 */   // GIR_Coverage, 2261,
     /*  157821 */   GIR_EraseRootFromParent_Done,
     /*  157822 */ // Label 2881: @157822
     /*  157822 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(157853), // Rule ID 2287 //
     /*  157827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  157830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157841 */   // (lrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  157844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157846 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157851 */   GIR_RootConstrainSelectedInstOperands,
     /*  157852 */   // GIR_Coverage, 2287,
     /*  157852 */   GIR_EraseRootFromParent_Done,
     /*  157853 */ // Label 2882: @157853
     /*  157853 */ GIM_Reject,
     /*  157854 */ // Label 2864: @157854
     /*  157854 */ GIM_Reject,
     /*  157855 */ // Label 17: @157855
     /*  157855 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(158064),
     /*  157860 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  157863 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2887*/ GIMT_Encode4(158063),
     /*  157874 */   /*GILLT_s16*//*Label 2884*/ GIMT_Encode4(157886),
     /*  157878 */   /*GILLT_s32*//*Label 2885*/ GIMT_Encode4(157945),
     /*  157882 */   /*GILLT_s64*//*Label 2886*/ GIMT_Encode4(158004),
     /*  157886 */   // Label 2884: @157886
     /*  157886 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(157944),
     /*  157891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157895 */     GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(157919), // Rule ID 2263 //
     /*  157900 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  157903 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157907 */       // (llrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157907 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  157910 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157912 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157914 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157917 */       GIR_RootConstrainSelectedInstOperands,
     /*  157918 */       // GIR_Coverage, 2263,
     /*  157918 */       GIR_EraseRootFromParent_Done,
     /*  157919 */     // Label 2889: @157919
     /*  157919 */     GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(157943), // Rule ID 2289 //
     /*  157924 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  157927 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157931 */       // (llrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157931 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  157934 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157936 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157938 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157941 */       GIR_RootConstrainSelectedInstOperands,
     /*  157942 */       // GIR_Coverage, 2289,
     /*  157942 */       GIR_EraseRootFromParent_Done,
     /*  157943 */     // Label 2890: @157943
     /*  157943 */     GIM_Reject,
     /*  157944 */   // Label 2888: @157944
     /*  157944 */   GIM_Reject,
     /*  157945 */   // Label 2885: @157945
     /*  157945 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(158003),
     /*  157950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157954 */     GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(157978), // Rule ID 1529 //
     /*  157959 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  157962 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157966 */       // (llrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157966 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  157969 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157971 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157973 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157976 */       GIR_RootConstrainSelectedInstOperands,
     /*  157977 */       // GIR_Coverage, 1529,
     /*  157977 */       GIR_EraseRootFromParent_Done,
     /*  157978 */     // Label 2892: @157978
     /*  157978 */     GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(158002), // Rule ID 1557 //
     /*  157983 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  157986 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157990 */       // (llrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157990 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  157993 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157995 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157997 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  158000 */       GIR_RootConstrainSelectedInstOperands,
     /*  158001 */       // GIR_Coverage, 1557,
     /*  158001 */       GIR_EraseRootFromParent_Done,
     /*  158002 */     // Label 2893: @158002
     /*  158002 */     GIM_Reject,
     /*  158003 */   // Label 2891: @158003
     /*  158003 */   GIM_Reject,
     /*  158004 */   // Label 2886: @158004
     /*  158004 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(158062),
     /*  158009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158013 */     GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(158037), // Rule ID 1927 //
     /*  158018 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  158021 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  158025 */       // (llrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  158025 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  158028 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158030 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158032 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  158035 */       GIR_RootConstrainSelectedInstOperands,
     /*  158036 */       // GIR_Coverage, 1927,
     /*  158036 */       GIR_EraseRootFromParent_Done,
     /*  158037 */     // Label 2895: @158037
     /*  158037 */     GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(158061), // Rule ID 1955 //
     /*  158042 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  158045 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158049 */       // (llrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  158049 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  158052 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158054 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158056 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  158059 */       GIR_RootConstrainSelectedInstOperands,
     /*  158060 */       // GIR_Coverage, 1955,
     /*  158060 */       GIR_EraseRootFromParent_Done,
     /*  158061 */     // Label 2896: @158061
     /*  158061 */     GIM_Reject,
     /*  158062 */   // Label 2894: @158062
     /*  158062 */   GIM_Reject,
     /*  158063 */   // Label 2887: @158063
     /*  158063 */   GIM_Reject,
     /*  158064 */ // Label 2883: @158064
     /*  158064 */ GIM_Reject,
     /*  158065 */ // Label 18: @158065
     /*  158065 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2900*/ GIMT_Encode4(158262),
     /*  158076 */ /*GILLT_s16*//*Label 2897*/ GIMT_Encode4(158088),
     /*  158080 */ /*GILLT_s32*//*Label 2898*/ GIMT_Encode4(158146),
     /*  158084 */ /*GILLT_s64*//*Label 2899*/ GIMT_Encode4(158204),
     /*  158088 */ // Label 2897: @158088
     /*  158088 */ GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(158145),
     /*  158093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  158096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  158100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  158104 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(158124), // Rule ID 2432 //
     /*  158109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  158112 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /*  158112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  158115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158122 */     GIR_RootConstrainSelectedInstOperands,
     /*  158123 */     // GIR_Coverage, 2432,
     /*  158123 */     GIR_EraseRootFromParent_Done,
     /*  158124 */   // Label 2902: @158124
     /*  158124 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(158144), // Rule ID 2433 //
     /*  158129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  158132 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /*  158132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  158135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158142 */     GIR_RootConstrainSelectedInstOperands,
     /*  158143 */     // GIR_Coverage, 2433,
     /*  158143 */     GIR_EraseRootFromParent_Done,
     /*  158144 */   // Label 2903: @158144
     /*  158144 */   GIM_Reject,
     /*  158145 */ // Label 2901: @158145
     /*  158145 */ GIM_Reject,
     /*  158146 */ // Label 2898: @158146
     /*  158146 */ GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(158203),
     /*  158151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  158154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  158158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  158162 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(158182), // Rule ID 2350 //
     /*  158167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  158170 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /*  158170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  158173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158180 */     GIR_RootConstrainSelectedInstOperands,
     /*  158181 */     // GIR_Coverage, 2350,
     /*  158181 */     GIR_EraseRootFromParent_Done,
     /*  158182 */   // Label 2905: @158182
     /*  158182 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(158202), // Rule ID 2351 //
     /*  158187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  158190 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /*  158190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  158193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158200 */     GIR_RootConstrainSelectedInstOperands,
     /*  158201 */     // GIR_Coverage, 2351,
     /*  158201 */     GIR_EraseRootFromParent_Done,
     /*  158202 */   // Label 2906: @158202
     /*  158202 */   GIM_Reject,
     /*  158203 */ // Label 2904: @158203
     /*  158203 */ GIM_Reject,
     /*  158204 */ // Label 2899: @158204
     /*  158204 */ GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(158261),
     /*  158209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  158212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  158216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  158220 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(158240), // Rule ID 2390 //
     /*  158225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  158228 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i64] })
     /*  158228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  158231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158238 */     GIR_RootConstrainSelectedInstOperands,
     /*  158239 */     // GIR_Coverage, 2390,
     /*  158239 */     GIR_EraseRootFromParent_Done,
     /*  158240 */   // Label 2908: @158240
     /*  158240 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(158260), // Rule ID 2391 //
     /*  158245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  158248 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i32] })
     /*  158248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  158251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158258 */     GIR_RootConstrainSelectedInstOperands,
     /*  158259 */     // GIR_Coverage, 2391,
     /*  158259 */     GIR_EraseRootFromParent_Done,
     /*  158260 */   // Label 2909: @158260
     /*  158260 */   GIM_Reject,
     /*  158261 */ // Label 2907: @158261
     /*  158261 */ GIM_Reject,
     /*  158262 */ // Label 2900: @158262
     /*  158262 */ GIM_Reject,
     /*  158263 */ // Label 19: @158263
     /*  158263 */ GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(158301), // Rule ID 299 //
     /*  158268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  158271 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  158274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158278 */   // (readcyclecounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3072:{ *:[i64] }, X0:{ *:[i64] })
     /*  158278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  158281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158283 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3072),
     /*  158293 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  158299 */   GIR_RootConstrainSelectedInstOperands,
     /*  158300 */   // GIR_Coverage, 299,
     /*  158300 */   GIR_EraseRootFromParent_Done,
     /*  158301 */ // Label 2910: @158301
     /*  158301 */ GIM_Reject,
     /*  158302 */ // Label 20: @158302
     /*  158302 */ GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(158340), // Rule ID 300 //
     /*  158307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  158310 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  158313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158317 */   // (readsteadycounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3073:{ *:[i64] }, X0:{ *:[i64] })
     /*  158317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  158320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158322 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3073),
     /*  158332 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  158338 */   GIR_RootConstrainSelectedInstOperands,
     /*  158339 */   // GIR_Coverage, 300,
     /*  158339 */   GIR_EraseRootFromParent_Done,
     /*  158340 */ // Label 2911: @158340
     /*  158340 */ GIM_Reject,
     /*  158341 */ // Label 21: @158341
     /*  158341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 2946*/ GIMT_Encode4(167318),
     /*  158352 */ /*GILLT_p0s32*//*Label 2912*/ GIMT_Encode4(158488),
     /*  158356 */ /*GILLT_p0s64*//*Label 2913*/ GIMT_Encode4(158582),
     /*  158360 */ /*GILLT_s16*//*Label 2914*/ GIMT_Encode4(158676),
     /*  158364 */ /*GILLT_s32*//*Label 2915*/ GIMT_Encode4(159331),
     /*  158368 */ /*GILLT_s64*//*Label 2916*/ GIMT_Encode4(160786),
     /*  158372 */ /*GILLT_nxv1s1*//*Label 2917*/ GIMT_Encode4(162012),
     /*  158376 */ /*GILLT_nxv1s8*//*Label 2918*/ GIMT_Encode4(162132),
     /*  158380 */ /*GILLT_nxv1s16*//*Label 2919*/ GIMT_Encode4(162260),
     /*  158384 */ /*GILLT_nxv1s32*//*Label 2920*/ GIMT_Encode4(162498),
     /*  158388 */ /*GILLT_nxv1s64*//*Label 2921*/ GIMT_Encode4(162736),
     /*  158392 */ /*GILLT_nxv2s1*//*Label 2922*/ GIMT_Encode4(162974),
     /*  158396 */ /*GILLT_nxv2s8*//*Label 2923*/ GIMT_Encode4(163094),
     /*  158400 */ /*GILLT_nxv2s16*//*Label 2924*/ GIMT_Encode4(163222),
     /*  158404 */ /*GILLT_nxv2s32*//*Label 2925*/ GIMT_Encode4(163460),
     /*  158408 */ /*GILLT_nxv2s64*//*Label 2926*/ GIMT_Encode4(163698),
     /*  158412 */ /*GILLT_nxv4s1*//*Label 2927*/ GIMT_Encode4(163936),
     /*  158416 */ /*GILLT_nxv4s8*//*Label 2928*/ GIMT_Encode4(164056),
     /*  158420 */ /*GILLT_nxv4s16*//*Label 2929*/ GIMT_Encode4(164184),
     /*  158424 */ /*GILLT_nxv4s32*//*Label 2930*/ GIMT_Encode4(164422),
     /*  158428 */ /*GILLT_nxv4s64*//*Label 2931*/ GIMT_Encode4(164660),
     /*  158432 */ /*GILLT_nxv8s1*//*Label 2932*/ GIMT_Encode4(164898),
     /*  158436 */ /*GILLT_nxv8s8*//*Label 2933*/ GIMT_Encode4(165018),
     /*  158440 */ /*GILLT_nxv8s16*//*Label 2934*/ GIMT_Encode4(165146),
     /*  158444 */ /*GILLT_nxv8s32*//*Label 2935*/ GIMT_Encode4(165384),
     /*  158448 */ /*GILLT_nxv8s64*//*Label 2936*/ GIMT_Encode4(165622),
     /*  158452 */ /*GILLT_nxv16s1*//*Label 2937*/ GIMT_Encode4(165860),
     /*  158456 */ /*GILLT_nxv16s8*//*Label 2938*/ GIMT_Encode4(165980),
     /*  158460 */ /*GILLT_nxv16s16*//*Label 2939*/ GIMT_Encode4(166108),
     /*  158464 */ /*GILLT_nxv16s32*//*Label 2940*/ GIMT_Encode4(166346),
     /*  158468 */ /*GILLT_nxv32s1*//*Label 2941*/ GIMT_Encode4(166584),
     /*  158472 */ /*GILLT_nxv32s8*//*Label 2942*/ GIMT_Encode4(166704),
     /*  158476 */ /*GILLT_nxv32s16*//*Label 2943*/ GIMT_Encode4(166832),
     /*  158480 */ /*GILLT_nxv64s1*//*Label 2944*/ GIMT_Encode4(167070),
     /*  158484 */ /*GILLT_nxv64s8*//*Label 2945*/ GIMT_Encode4(167190),
     /*  158488 */ // Label 2912: @158488
     /*  158488 */ GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(158581),
     /*  158493 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158496 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158504 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158508 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(158544), // Rule ID 65429 //
     /*  158513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  158516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158523 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  158526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158542 */     GIR_RootConstrainSelectedInstOperands,
     /*  158543 */     // GIR_Coverage, 65429,
     /*  158543 */     GIR_EraseRootFromParent_Done,
     /*  158544 */   // Label 2948: @158544
     /*  158544 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(158580), // Rule ID 65433 //
     /*  158549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  158552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158559 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  158562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158578 */     GIR_RootConstrainSelectedInstOperands,
     /*  158579 */     // GIR_Coverage, 65433,
     /*  158579 */     GIR_EraseRootFromParent_Done,
     /*  158580 */   // Label 2949: @158580
     /*  158580 */   GIM_Reject,
     /*  158581 */ // Label 2947: @158581
     /*  158581 */ GIM_Reject,
     /*  158582 */ // Label 2913: @158582
     /*  158582 */ GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(158675),
     /*  158587 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158590 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158598 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158602 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(158638), // Rule ID 65428 //
     /*  158607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  158610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158617 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  158620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158636 */     GIR_RootConstrainSelectedInstOperands,
     /*  158637 */     // GIR_Coverage, 65428,
     /*  158637 */     GIR_EraseRootFromParent_Done,
     /*  158638 */   // Label 2951: @158638
     /*  158638 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(158674), // Rule ID 65432 //
     /*  158643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  158646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158653 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  158656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158672 */     GIR_RootConstrainSelectedInstOperands,
     /*  158673 */     // GIR_Coverage, 65432,
     /*  158673 */     GIR_EraseRootFromParent_Done,
     /*  158674 */   // Label 2952: @158674
     /*  158674 */   GIM_Reject,
     /*  158675 */ // Label 2950: @158675
     /*  158675 */ GIM_Reject,
     /*  158676 */ // Label 2914: @158676
     /*  158676 */ GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(158727), // Rule ID 2158 //
     /*  158681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  158684 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158687 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  158695 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158706 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  158709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158725 */   GIR_RootConstrainSelectedInstOperands,
     /*  158726 */   // GIR_Coverage, 2158,
     /*  158726 */   GIR_EraseRootFromParent_Done,
     /*  158727 */ // Label 2953: @158727
     /*  158727 */ GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(158778), // Rule ID 2159 //
     /*  158732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  158735 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158738 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  158746 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158750 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158757 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  158760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158772 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158776 */   GIR_RootConstrainSelectedInstOperands,
     /*  158777 */   // GIR_Coverage, 2159,
     /*  158777 */   GIR_EraseRootFromParent_Done,
     /*  158778 */ // Label 2954: @158778
     /*  158778 */ GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(158829), // Rule ID 2164 //
     /*  158783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  158786 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158789 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  158797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158801 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158808 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  158811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158823 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158827 */   GIR_RootConstrainSelectedInstOperands,
     /*  158828 */   // GIR_Coverage, 2164,
     /*  158828 */   GIR_EraseRootFromParent_Done,
     /*  158829 */ // Label 2955: @158829
     /*  158829 */ GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(158880), // Rule ID 2165 //
     /*  158834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  158837 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158840 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  158848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158859 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  158862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158878 */   GIR_RootConstrainSelectedInstOperands,
     /*  158879 */   // GIR_Coverage, 2165,
     /*  158879 */   GIR_EraseRootFromParent_Done,
     /*  158880 */ // Label 2956: @158880
     /*  158880 */ GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(158931), // Rule ID 65436 //
     /*  158885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  158888 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158891 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158899 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158903 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158910 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158929 */   GIR_RootConstrainSelectedInstOperands,
     /*  158930 */   // GIR_Coverage, 65436,
     /*  158930 */   GIR_EraseRootFromParent_Done,
     /*  158931 */ // Label 2957: @158931
     /*  158931 */ GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(158982), // Rule ID 65437 //
     /*  158936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  158939 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158942 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158961 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158976 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158980 */   GIR_RootConstrainSelectedInstOperands,
     /*  158981 */   // GIR_Coverage, 65437,
     /*  158981 */   GIR_EraseRootFromParent_Done,
     /*  158982 */ // Label 2958: @158982
     /*  158982 */ GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(159040), // Rule ID 65440 //
     /*  158987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  158990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158993 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158997 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159012 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159019 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  159022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159038 */   GIR_RootConstrainSelectedInstOperands,
     /*  159039 */   // GIR_Coverage, 65440,
     /*  159039 */   GIR_EraseRootFromParent_Done,
     /*  159040 */ // Label 2959: @159040
     /*  159040 */ GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(159098), // Rule ID 65441 //
     /*  159045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159051 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159055 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159077 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  159080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159092 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159096 */   GIR_RootConstrainSelectedInstOperands,
     /*  159097 */   // GIR_Coverage, 65441,
     /*  159097 */   GIR_EraseRootFromParent_Done,
     /*  159098 */ // Label 2960: @159098
     /*  159098 */ GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(159156), // Rule ID 65444 //
     /*  159103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  159106 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159109 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159113 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159128 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159135 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  159138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159154 */   GIR_RootConstrainSelectedInstOperands,
     /*  159155 */   // GIR_Coverage, 65444,
     /*  159155 */   GIR_EraseRootFromParent_Done,
     /*  159156 */ // Label 2961: @159156
     /*  159156 */ GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(159214), // Rule ID 65445 //
     /*  159161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159164 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159167 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159171 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159193 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  159196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159208 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159212 */   GIR_RootConstrainSelectedInstOperands,
     /*  159213 */   // GIR_Coverage, 65445,
     /*  159213 */   GIR_EraseRootFromParent_Done,
     /*  159214 */ // Label 2962: @159214
     /*  159214 */ GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(159272), // Rule ID 65446 //
     /*  159219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  159222 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159225 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159229 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159240 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159251 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159266 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159270 */   GIR_RootConstrainSelectedInstOperands,
     /*  159271 */   // GIR_Coverage, 65446,
     /*  159271 */   GIR_EraseRootFromParent_Done,
     /*  159272 */ // Label 2963: @159272
     /*  159272 */ GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(159330), // Rule ID 65447 //
     /*  159277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159280 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159283 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159287 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159298 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159302 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159309 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159324 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159328 */   GIR_RootConstrainSelectedInstOperands,
     /*  159329 */   // GIR_Coverage, 65447,
     /*  159329 */   GIR_EraseRootFromParent_Done,
     /*  159330 */ // Label 2964: @159330
     /*  159330 */ GIM_Reject,
     /*  159331 */ // Label 2915: @159331
     /*  159331 */ GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(159389), // Rule ID 245 //
     /*  159336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159342 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159346 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159357 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159361 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159368 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  159371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159387 */   GIR_RootConstrainSelectedInstOperands,
     /*  159388 */   // GIR_Coverage, 245,
     /*  159388 */   GIR_EraseRootFromParent_Done,
     /*  159389 */ // Label 2965: @159389
     /*  159389 */ GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(159447), // Rule ID 249 //
     /*  159394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159397 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159400 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159404 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159426 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159445 */   GIR_RootConstrainSelectedInstOperands,
     /*  159446 */   // GIR_Coverage, 249,
     /*  159446 */   GIR_EraseRootFromParent_Done,
     /*  159447 */ // Label 2966: @159447
     /*  159447 */ GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(159498), // Rule ID 250 //
     /*  159452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  159455 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159458 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159470 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159477 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159496 */   GIR_RootConstrainSelectedInstOperands,
     /*  159497 */   // GIR_Coverage, 250,
     /*  159497 */   GIR_EraseRootFromParent_Done,
     /*  159498 */ // Label 2967: @159498
     /*  159498 */ GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(159549), // Rule ID 251 //
     /*  159503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159509 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159517 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159521 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159528 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159543 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159547 */   GIR_RootConstrainSelectedInstOperands,
     /*  159548 */   // GIR_Coverage, 251,
     /*  159548 */   GIR_EraseRootFromParent_Done,
     /*  159549 */ // Label 2968: @159549
     /*  159549 */ GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(159610), // Rule ID 334 //
     /*  159554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159557 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159560 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159564 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159571 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159578 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159582 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159589 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10132>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  159592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159604 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159608 */   GIR_RootConstrainSelectedInstOperands,
     /*  159609 */   // GIR_Coverage, 334,
     /*  159609 */   GIR_EraseRootFromParent_Done,
     /*  159610 */ // Label 2969: @159610
     /*  159610 */ GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(159671), // Rule ID 338 //
     /*  159615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159618 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159621 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159625 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159632 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159639 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159643 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159650 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10134>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159665 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159669 */   GIR_RootConstrainSelectedInstOperands,
     /*  159670 */   // GIR_Coverage, 338,
     /*  159670 */   GIR_EraseRootFromParent_Done,
     /*  159671 */ // Label 2970: @159671
     /*  159671 */ GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(159732), // Rule ID 352 //
     /*  159676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode1),
     /*  159679 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159682 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159686 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  159693 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159704 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159711 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10146>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159726 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159730 */   GIR_RootConstrainSelectedInstOperands,
     /*  159731 */   // GIR_Coverage, 352,
     /*  159731 */   GIR_EraseRootFromParent_Done,
     /*  159732 */ // Label 2971: @159732
     /*  159732 */ GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(159793), // Rule ID 354 //
     /*  159737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  159740 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159743 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159747 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  159754 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159761 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159765 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159772 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10148>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159787 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159791 */   GIR_RootConstrainSelectedInstOperands,
     /*  159792 */   // GIR_Coverage, 354,
     /*  159792 */   GIR_EraseRootFromParent_Done,
     /*  159793 */ // Label 2972: @159793
     /*  159793 */ GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(159844), // Rule ID 1445 //
     /*  159798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  159801 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159804 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  159812 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159816 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159823 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  159826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159838 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159842 */   GIR_RootConstrainSelectedInstOperands,
     /*  159843 */   // GIR_Coverage, 1445,
     /*  159843 */   GIR_EraseRootFromParent_Done,
     /*  159844 */ // Label 2973: @159844
     /*  159844 */ GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(159895), // Rule ID 1446 //
     /*  159849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  159852 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159855 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  159863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159867 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159874 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  159877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159889 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159893 */   GIR_RootConstrainSelectedInstOperands,
     /*  159894 */   // GIR_Coverage, 1446,
     /*  159894 */   GIR_EraseRootFromParent_Done,
     /*  159895 */ // Label 2974: @159895
     /*  159895 */ GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(159946), // Rule ID 1451 //
     /*  159900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  159903 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159906 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  159914 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159918 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159925 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  159928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159940 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159944 */   GIR_RootConstrainSelectedInstOperands,
     /*  159945 */   // GIR_Coverage, 1451,
     /*  159945 */   GIR_EraseRootFromParent_Done,
     /*  159946 */ // Label 2975: @159946
     /*  159946 */ GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(159997), // Rule ID 1452 //
     /*  159951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  159954 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159957 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  159965 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159969 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159976 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  159979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159991 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159995 */   GIR_RootConstrainSelectedInstOperands,
     /*  159996 */   // GIR_Coverage, 1452,
     /*  159996 */   GIR_EraseRootFromParent_Done,
     /*  159997 */ // Label 2976: @159997
     /*  159997 */ GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(160055), // Rule ID 65452 //
     /*  160002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  160005 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160008 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160012 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160023 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160027 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160034 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160053 */   GIR_RootConstrainSelectedInstOperands,
     /*  160054 */   // GIR_Coverage, 65452,
     /*  160054 */   GIR_EraseRootFromParent_Done,
     /*  160055 */ // Label 2977: @160055
     /*  160055 */ GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(160113), // Rule ID 65453 //
     /*  160060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  160063 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160066 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160070 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160081 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160085 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160092 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160107 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160111 */   GIR_RootConstrainSelectedInstOperands,
     /*  160112 */   // GIR_Coverage, 65453,
     /*  160112 */   GIR_EraseRootFromParent_Done,
     /*  160113 */ // Label 2978: @160113
     /*  160113 */ GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(160171), // Rule ID 65456 //
     /*  160118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160124 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160128 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160139 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160143 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160150 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  160153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160165 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160169 */   GIR_RootConstrainSelectedInstOperands,
     /*  160170 */   // GIR_Coverage, 65456,
     /*  160170 */   GIR_EraseRootFromParent_Done,
     /*  160171 */ // Label 2979: @160171
     /*  160171 */ GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(160229), // Rule ID 65457 //
     /*  160176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  160179 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160182 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160186 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160197 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160201 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160208 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  160211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160223 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160227 */   GIR_RootConstrainSelectedInstOperands,
     /*  160228 */   // GIR_Coverage, 65457,
     /*  160228 */   GIR_EraseRootFromParent_Done,
     /*  160229 */ // Label 2980: @160229
     /*  160229 */ GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(160287), // Rule ID 65458 //
     /*  160234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160237 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160240 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160255 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160259 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160266 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160281 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160285 */   GIR_RootConstrainSelectedInstOperands,
     /*  160286 */   // GIR_Coverage, 65458,
     /*  160286 */   GIR_EraseRootFromParent_Done,
     /*  160287 */ // Label 2981: @160287
     /*  160287 */ GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(160345), // Rule ID 65459 //
     /*  160292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  160295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160298 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160302 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160313 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160317 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160324 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160343 */   GIR_RootConstrainSelectedInstOperands,
     /*  160344 */   // GIR_Coverage, 65459,
     /*  160344 */   GIR_EraseRootFromParent_Done,
     /*  160345 */ // Label 2982: @160345
     /*  160345 */ GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(160389), // Rule ID 1110 //
     /*  160350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160353 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160356 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160360 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160367 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160374 */   // MIs[0] rs1
     /*  160374 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160382 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10636>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  160387 */   GIR_RootConstrainSelectedInstOperands,
     /*  160388 */   // GIR_Coverage, 1110,
     /*  160388 */   GIR_Done,
     /*  160389 */ // Label 2983: @160389
     /*  160389 */ GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(160433), // Rule ID 1114 //
     /*  160394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160397 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160400 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160404 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160411 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160418 */   // MIs[0] rs1
     /*  160418 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160426 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10638>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  160431 */   GIR_RootConstrainSelectedInstOperands,
     /*  160432 */   // GIR_Coverage, 1114,
     /*  160432 */   GIR_Done,
     /*  160433 */ // Label 2984: @160433
     /*  160433 */ GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(160477), // Rule ID 1118 //
     /*  160438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160441 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160444 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160448 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160455 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160462 */   // MIs[0] rs1
     /*  160462 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160470 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10640>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  160475 */   GIR_RootConstrainSelectedInstOperands,
     /*  160476 */   // GIR_Coverage, 1118,
     /*  160476 */   GIR_Done,
     /*  160477 */ // Label 2985: @160477
     /*  160477 */ GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(160521), // Rule ID 1122 //
     /*  160482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160485 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160488 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160492 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160499 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160506 */   // MIs[0] rs1
     /*  160506 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160514 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10642>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  160519 */   GIR_RootConstrainSelectedInstOperands,
     /*  160520 */   // GIR_Coverage, 1122,
     /*  160520 */   GIR_Done,
     /*  160521 */ // Label 2986: @160521
     /*  160521 */ GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(160565), // Rule ID 1138 //
     /*  160526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  160529 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160532 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160543 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160550 */   // MIs[0] rs1
     /*  160550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160558 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10656>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160563 */   GIR_RootConstrainSelectedInstOperands,
     /*  160564 */   // GIR_Coverage, 1138,
     /*  160564 */   GIR_Done,
     /*  160565 */ // Label 2987: @160565
     /*  160565 */ GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(160609), // Rule ID 1140 //
     /*  160570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  160573 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160576 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160580 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160587 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160594 */   // MIs[0] rs1
     /*  160594 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160602 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10658>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160607 */   GIR_RootConstrainSelectedInstOperands,
     /*  160608 */   // GIR_Coverage, 1140,
     /*  160608 */   GIR_Done,
     /*  160609 */ // Label 2988: @160609
     /*  160609 */ GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(160653), // Rule ID 1142 //
     /*  160614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160617 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160620 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160624 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160631 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160638 */   // MIs[0] rs1
     /*  160638 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160646 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10660>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160651 */   GIR_RootConstrainSelectedInstOperands,
     /*  160652 */   // GIR_Coverage, 1142,
     /*  160652 */   GIR_Done,
     /*  160653 */ // Label 2989: @160653
     /*  160653 */ GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(160697), // Rule ID 1146 //
     /*  160658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160661 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160664 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160668 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160675 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160682 */   // MIs[0] rs1
     /*  160682 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160690 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10662>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160695 */   GIR_RootConstrainSelectedInstOperands,
     /*  160696 */   // GIR_Coverage, 1146,
     /*  160696 */   GIR_Done,
     /*  160697 */ // Label 2990: @160697
     /*  160697 */ GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(160741), // Rule ID 1150 //
     /*  160702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160705 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160708 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160712 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  160719 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160726 */   // MIs[0] rs1
     /*  160726 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160734 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10664>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  160739 */   GIR_RootConstrainSelectedInstOperands,
     /*  160740 */   // GIR_Coverage, 1150,
     /*  160740 */   GIR_Done,
     /*  160741 */ // Label 2991: @160741
     /*  160741 */ GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(160785), // Rule ID 1152 //
     /*  160746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160749 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160752 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160756 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  160763 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160770 */   // MIs[0] rs1
     /*  160770 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160778 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10666>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  160783 */   GIR_RootConstrainSelectedInstOperands,
     /*  160784 */   // GIR_Coverage, 1152,
     /*  160784 */   GIR_Done,
     /*  160785 */ // Label 2992: @160785
     /*  160785 */ GIM_Reject,
     /*  160786 */ // Label 2916: @160786
     /*  160786 */ GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(160844), // Rule ID 244 //
     /*  160791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  160794 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160797 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160801 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160812 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160816 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160823 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  160826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160838 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160842 */   GIR_RootConstrainSelectedInstOperands,
     /*  160843 */   // GIR_Coverage, 244,
     /*  160843 */   GIR_EraseRootFromParent_Done,
     /*  160844 */ // Label 2993: @160844
     /*  160844 */ GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(160902), // Rule ID 248 //
     /*  160849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  160852 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160855 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160859 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160874 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160881 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160896 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160900 */   GIR_RootConstrainSelectedInstOperands,
     /*  160901 */   // GIR_Coverage, 248,
     /*  160901 */   GIR_EraseRootFromParent_Done,
     /*  160902 */ // Label 2994: @160902
     /*  160902 */ GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(160960), // Rule ID 294 //
     /*  160907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160910 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160913 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160917 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160932 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160939 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160958 */   GIR_RootConstrainSelectedInstOperands,
     /*  160959 */   // GIR_Coverage, 294,
     /*  160959 */   GIR_EraseRootFromParent_Done,
     /*  160960 */ // Label 2995: @160960
     /*  160960 */ GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(161011), // Rule ID 296 //
     /*  160965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160968 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160971 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160979 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160983 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160990 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  160993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161005 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161009 */   GIR_RootConstrainSelectedInstOperands,
     /*  161010 */   // GIR_Coverage, 296,
     /*  161010 */   GIR_EraseRootFromParent_Done,
     /*  161011 */ // Label 2996: @161011
     /*  161011 */ GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(161072), // Rule ID 333 //
     /*  161016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  161019 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161022 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161026 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161033 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161040 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161044 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161051 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10132>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  161054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161066 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161070 */   GIR_RootConstrainSelectedInstOperands,
     /*  161071 */   // GIR_Coverage, 333,
     /*  161071 */   GIR_EraseRootFromParent_Done,
     /*  161072 */ // Label 2997: @161072
     /*  161072 */ GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(161133), // Rule ID 337 //
     /*  161077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  161080 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161083 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161087 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161094 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161112 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10134>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  161115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161131 */   GIR_RootConstrainSelectedInstOperands,
     /*  161132 */   // GIR_Coverage, 337,
     /*  161132 */   GIR_EraseRootFromParent_Done,
     /*  161133 */ // Label 2998: @161133
     /*  161133 */ GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(161194), // Rule ID 351 //
     /*  161138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode0),
     /*  161141 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161144 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161148 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161155 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161162 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161166 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161173 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10146>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  161176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161192 */   GIR_RootConstrainSelectedInstOperands,
     /*  161193 */   // GIR_Coverage, 351,
     /*  161193 */   GIR_EraseRootFromParent_Done,
     /*  161194 */ // Label 2999: @161194
     /*  161194 */ GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(161255), // Rule ID 353 //
     /*  161199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  161202 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161205 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161209 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161216 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161223 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161227 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161234 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10148>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  161237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161249 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161253 */   GIR_RootConstrainSelectedInstOperands,
     /*  161254 */   // GIR_Coverage, 353,
     /*  161254 */   GIR_EraseRootFromParent_Done,
     /*  161255 */ // Label 3000: @161255
     /*  161255 */ GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(161316), // Rule ID 359 //
     /*  161260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  161263 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161266 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161270 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161277 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161284 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161288 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161295 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10152>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  161298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161310 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161314 */   GIR_RootConstrainSelectedInstOperands,
     /*  161315 */   // GIR_Coverage, 359,
     /*  161315 */   GIR_EraseRootFromParent_Done,
     /*  161316 */ // Label 3001: @161316
     /*  161316 */ GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(161367), // Rule ID 1843 //
     /*  161321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  161324 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161327 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  161335 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161339 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161346 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  161349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161361 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161365 */   GIR_RootConstrainSelectedInstOperands,
     /*  161366 */   // GIR_Coverage, 1843,
     /*  161366 */   GIR_EraseRootFromParent_Done,
     /*  161367 */ // Label 3002: @161367
     /*  161367 */ GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(161418), // Rule ID 1844 //
     /*  161372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  161375 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161378 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  161386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161390 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161397 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  161397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  161400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161412 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161416 */   GIR_RootConstrainSelectedInstOperands,
     /*  161417 */   // GIR_Coverage, 1844,
     /*  161417 */   GIR_EraseRootFromParent_Done,
     /*  161418 */ // Label 3003: @161418
     /*  161418 */ GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(161469), // Rule ID 1848 //
     /*  161423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  161426 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161429 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161448 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  161451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161463 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161467 */   GIR_RootConstrainSelectedInstOperands,
     /*  161468 */   // GIR_Coverage, 1848,
     /*  161468 */   GIR_EraseRootFromParent_Done,
     /*  161469 */ // Label 3004: @161469
     /*  161469 */ GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(161520), // Rule ID 1852 //
     /*  161474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0),
     /*  161477 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161480 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  161488 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161492 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161499 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_RV32:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD_RV32),
     /*  161502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161514 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161518 */   GIR_RootConstrainSelectedInstOperands,
     /*  161519 */   // GIR_Coverage, 1852,
     /*  161519 */   GIR_EraseRootFromParent_Done,
     /*  161520 */ // Label 3005: @161520
     /*  161520 */ GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(161571), // Rule ID 1853 //
     /*  161525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1),
     /*  161528 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161531 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  161539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161543 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161550 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_RV32:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  161550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD_RV32),
     /*  161553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161569 */   GIR_RootConstrainSelectedInstOperands,
     /*  161570 */   // GIR_Coverage, 1853,
     /*  161570 */   GIR_EraseRootFromParent_Done,
     /*  161571 */ // Label 3006: @161571
     /*  161571 */ GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(161615), // Rule ID 1109 //
     /*  161576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161579 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161582 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161593 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161600 */   // MIs[0] rs1
     /*  161600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161608 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10636>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  161613 */   GIR_RootConstrainSelectedInstOperands,
     /*  161614 */   // GIR_Coverage, 1109,
     /*  161614 */   GIR_Done,
     /*  161615 */ // Label 3007: @161615
     /*  161615 */ GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(161659), // Rule ID 1113 //
     /*  161620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161623 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161626 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161630 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161637 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161644 */   // MIs[0] rs1
     /*  161644 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161652 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10638>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  161657 */   GIR_RootConstrainSelectedInstOperands,
     /*  161658 */   // GIR_Coverage, 1113,
     /*  161658 */   GIR_Done,
     /*  161659 */ // Label 3008: @161659
     /*  161659 */ GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(161703), // Rule ID 1117 //
     /*  161664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161667 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161670 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161674 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161681 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161688 */   // MIs[0] rs1
     /*  161688 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161696 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10640>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  161701 */   GIR_RootConstrainSelectedInstOperands,
     /*  161702 */   // GIR_Coverage, 1117,
     /*  161702 */   GIR_Done,
     /*  161703 */ // Label 3009: @161703
     /*  161703 */ GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(161747), // Rule ID 1121 //
     /*  161708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161711 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161714 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161718 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161725 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161732 */   // MIs[0] rs1
     /*  161732 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161740 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10642>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  161745 */   GIR_RootConstrainSelectedInstOperands,
     /*  161746 */   // GIR_Coverage, 1121,
     /*  161746 */   GIR_Done,
     /*  161747 */ // Label 3010: @161747
     /*  161747 */ GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(161791), // Rule ID 1137 //
     /*  161752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  161755 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161758 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161762 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161776 */   // MIs[0] rs1
     /*  161776 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161784 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10656>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161789 */   GIR_RootConstrainSelectedInstOperands,
     /*  161790 */   // GIR_Coverage, 1137,
     /*  161790 */   GIR_Done,
     /*  161791 */ // Label 3011: @161791
     /*  161791 */ GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(161835), // Rule ID 1139 //
     /*  161796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  161799 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161802 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161806 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161813 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161820 */   // MIs[0] rs1
     /*  161820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161828 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10658>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161833 */   GIR_RootConstrainSelectedInstOperands,
     /*  161834 */   // GIR_Coverage, 1139,
     /*  161834 */   GIR_Done,
     /*  161835 */ // Label 3012: @161835
     /*  161835 */ GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(161879), // Rule ID 1141 //
     /*  161840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161843 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161846 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161850 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161864 */   // MIs[0] rs1
     /*  161864 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161872 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10660>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161872 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161877 */   GIR_RootConstrainSelectedInstOperands,
     /*  161878 */   // GIR_Coverage, 1141,
     /*  161878 */   GIR_Done,
     /*  161879 */ // Label 3013: @161879
     /*  161879 */ GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(161923), // Rule ID 1145 //
     /*  161884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161887 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161890 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161894 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161901 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161908 */   // MIs[0] rs1
     /*  161908 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161916 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10662>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161921 */   GIR_RootConstrainSelectedInstOperands,
     /*  161922 */   // GIR_Coverage, 1145,
     /*  161922 */   GIR_Done,
     /*  161923 */ // Label 3014: @161923
     /*  161923 */ GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(161967), // Rule ID 1149 //
     /*  161928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161931 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161934 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161938 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161952 */   // MIs[0] rs1
     /*  161952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161960 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10664>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  161965 */   GIR_RootConstrainSelectedInstOperands,
     /*  161966 */   // GIR_Coverage, 1149,
     /*  161966 */   GIR_Done,
     /*  161967 */ // Label 3015: @161967
     /*  161967 */ GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(162011), // Rule ID 1151 //
     /*  161972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161975 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161978 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161982 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161989 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161996 */   // MIs[0] rs1
     /*  161996 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162004 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10666>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  162009 */   GIR_RootConstrainSelectedInstOperands,
     /*  162010 */   // GIR_Coverage, 1151,
     /*  162010 */   GIR_Done,
     /*  162011 */ // Label 3016: @162011
     /*  162011 */ GIM_Reject,
     /*  162012 */ // Label 2917: @162012
     /*  162012 */ GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(162131),
     /*  162017 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162020 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162028 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  162032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162036 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(162083), // Rule ID 45754 //
     /*  162041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162044 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  162044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  162047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  162061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162081 */     GIR_RootConstrainSelectedInstOperands,
     /*  162082 */     // GIR_Coverage, 45754,
     /*  162082 */     GIR_EraseRootFromParent_Done,
     /*  162083 */   // Label 3018: @162083
     /*  162083 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(162130), // Rule ID 45755 //
     /*  162088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162091 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  162091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  162094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  162108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162128 */     GIR_RootConstrainSelectedInstOperands,
     /*  162129 */     // GIR_Coverage, 45755,
     /*  162129 */     GIR_EraseRootFromParent_Done,
     /*  162130 */   // Label 3019: @162130
     /*  162130 */   GIM_Reject,
     /*  162131 */ // Label 3017: @162131
     /*  162131 */ GIM_Reject,
     /*  162132 */ // Label 2918: @162132
     /*  162132 */ GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(162259),
     /*  162137 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162140 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162148 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(162203), // Rule ID 45750 //
     /*  162153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162156 */     // MIs[0] rs1
     /*  162156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162164 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  162164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  162167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  162181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162201 */     GIR_RootConstrainSelectedInstOperands,
     /*  162202 */     // GIR_Coverage, 45750,
     /*  162202 */     GIR_EraseRootFromParent_Done,
     /*  162203 */   // Label 3021: @162203
     /*  162203 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(162258), // Rule ID 45751 //
     /*  162208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162211 */     // MIs[0] rs1
     /*  162211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162219 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  162219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  162222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  162236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162256 */     GIR_RootConstrainSelectedInstOperands,
     /*  162257 */     // GIR_Coverage, 45751,
     /*  162257 */     GIR_EraseRootFromParent_Done,
     /*  162258 */   // Label 3022: @162258
     /*  162258 */   GIM_Reject,
     /*  162259 */ // Label 3020: @162259
     /*  162259 */ GIM_Reject,
     /*  162260 */ // Label 2919: @162260
     /*  162260 */ GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(162497),
     /*  162265 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162268 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162276 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(162331), // Rule ID 45946 //
     /*  162281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162284 */     // MIs[0] rs1
     /*  162284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162292 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162329 */     GIR_RootConstrainSelectedInstOperands,
     /*  162330 */     // GIR_Coverage, 45946,
     /*  162330 */     GIR_EraseRootFromParent_Done,
     /*  162331 */   // Label 3024: @162331
     /*  162331 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(162386), // Rule ID 45947 //
     /*  162336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162339 */     // MIs[0] rs1
     /*  162339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162347 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162384 */     GIR_RootConstrainSelectedInstOperands,
     /*  162385 */     // GIR_Coverage, 45947,
     /*  162385 */     GIR_EraseRootFromParent_Done,
     /*  162386 */   // Label 3025: @162386
     /*  162386 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(162441), // Rule ID 46022 //
     /*  162391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  162394 */     // MIs[0] rs1
     /*  162394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162402 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162439 */     GIR_RootConstrainSelectedInstOperands,
     /*  162440 */     // GIR_Coverage, 46022,
     /*  162440 */     GIR_EraseRootFromParent_Done,
     /*  162441 */   // Label 3026: @162441
     /*  162441 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(162496), // Rule ID 46023 //
     /*  162446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  162449 */     // MIs[0] rs1
     /*  162449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162457 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162494 */     GIR_RootConstrainSelectedInstOperands,
     /*  162495 */     // GIR_Coverage, 46023,
     /*  162495 */     GIR_EraseRootFromParent_Done,
     /*  162496 */   // Label 3027: @162496
     /*  162496 */   GIM_Reject,
     /*  162497 */ // Label 3023: @162497
     /*  162497 */ GIM_Reject,
     /*  162498 */ // Label 2920: @162498
     /*  162498 */ GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(162735),
     /*  162503 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162506 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162514 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(162569), // Rule ID 45954 //
     /*  162519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162522 */     // MIs[0] rs1
     /*  162522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162530 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162567 */     GIR_RootConstrainSelectedInstOperands,
     /*  162568 */     // GIR_Coverage, 45954,
     /*  162568 */     GIR_EraseRootFromParent_Done,
     /*  162569 */   // Label 3029: @162569
     /*  162569 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(162624), // Rule ID 45955 //
     /*  162574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162577 */     // MIs[0] rs1
     /*  162577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162585 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  162585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162622 */     GIR_RootConstrainSelectedInstOperands,
     /*  162623 */     // GIR_Coverage, 45955,
     /*  162623 */     GIR_EraseRootFromParent_Done,
     /*  162624 */   // Label 3030: @162624
     /*  162624 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(162679), // Rule ID 46030 //
     /*  162629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  162632 */     // MIs[0] rs1
     /*  162632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162640 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162677 */     GIR_RootConstrainSelectedInstOperands,
     /*  162678 */     // GIR_Coverage, 46030,
     /*  162678 */     GIR_EraseRootFromParent_Done,
     /*  162679 */   // Label 3031: @162679
     /*  162679 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(162734), // Rule ID 46031 //
     /*  162684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  162687 */     // MIs[0] rs1
     /*  162687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162695 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  162695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162732 */     GIR_RootConstrainSelectedInstOperands,
     /*  162733 */     // GIR_Coverage, 46031,
     /*  162733 */     GIR_EraseRootFromParent_Done,
     /*  162734 */   // Label 3032: @162734
     /*  162734 */   GIM_Reject,
     /*  162735 */ // Label 3028: @162735
     /*  162735 */ GIM_Reject,
     /*  162736 */ // Label 2921: @162736
     /*  162736 */ GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(162973),
     /*  162741 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162744 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162752 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(162807), // Rule ID 45970 //
     /*  162757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  162760 */     // MIs[0] rs1
     /*  162760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162768 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  162768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162805 */     GIR_RootConstrainSelectedInstOperands,
     /*  162806 */     // GIR_Coverage, 45970,
     /*  162806 */     GIR_EraseRootFromParent_Done,
     /*  162807 */   // Label 3034: @162807
     /*  162807 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(162862), // Rule ID 45971 //
     /*  162812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  162815 */     // MIs[0] rs1
     /*  162815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162823 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  162823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162860 */     GIR_RootConstrainSelectedInstOperands,
     /*  162861 */     // GIR_Coverage, 45971,
     /*  162861 */     GIR_EraseRootFromParent_Done,
     /*  162862 */   // Label 3035: @162862
     /*  162862 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(162917), // Rule ID 46042 //
     /*  162867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  162870 */     // MIs[0] rs1
     /*  162870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162878 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  162878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162915 */     GIR_RootConstrainSelectedInstOperands,
     /*  162916 */     // GIR_Coverage, 46042,
     /*  162916 */     GIR_EraseRootFromParent_Done,
     /*  162917 */   // Label 3036: @162917
     /*  162917 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(162972), // Rule ID 46043 //
     /*  162922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  162925 */     // MIs[0] rs1
     /*  162925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162933 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  162933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162970 */     GIR_RootConstrainSelectedInstOperands,
     /*  162971 */     // GIR_Coverage, 46043,
     /*  162971 */     GIR_EraseRootFromParent_Done,
     /*  162972 */   // Label 3037: @162972
     /*  162972 */   GIM_Reject,
     /*  162973 */ // Label 3033: @162973
     /*  162973 */ GIM_Reject,
     /*  162974 */ // Label 2922: @162974
     /*  162974 */ GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(163093),
     /*  162979 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162982 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162990 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  162994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162998 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(163045), // Rule ID 46082 //
     /*  163003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163006 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  163006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  163009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  163023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163043 */     GIR_RootConstrainSelectedInstOperands,
     /*  163044 */     // GIR_Coverage, 46082,
     /*  163044 */     GIR_EraseRootFromParent_Done,
     /*  163045 */   // Label 3039: @163045
     /*  163045 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(163092), // Rule ID 46083 //
     /*  163050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163053 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  163053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  163056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  163070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163090 */     GIR_RootConstrainSelectedInstOperands,
     /*  163091 */     // GIR_Coverage, 46083,
     /*  163091 */     GIR_EraseRootFromParent_Done,
     /*  163092 */   // Label 3040: @163092
     /*  163092 */   GIM_Reject,
     /*  163093 */ // Label 3038: @163093
     /*  163093 */ GIM_Reject,
     /*  163094 */ // Label 2923: @163094
     /*  163094 */ GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(163221),
     /*  163099 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163102 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163110 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(163165), // Rule ID 45938 //
     /*  163115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163118 */     // MIs[0] rs1
     /*  163118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163126 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  163126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  163129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  163143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163163 */     GIR_RootConstrainSelectedInstOperands,
     /*  163164 */     // GIR_Coverage, 45938,
     /*  163164 */     GIR_EraseRootFromParent_Done,
     /*  163165 */   // Label 3042: @163165
     /*  163165 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(163220), // Rule ID 45939 //
     /*  163170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163173 */     // MIs[0] rs1
     /*  163173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163181 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  163181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  163184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  163198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163218 */     GIR_RootConstrainSelectedInstOperands,
     /*  163219 */     // GIR_Coverage, 45939,
     /*  163219 */     GIR_EraseRootFromParent_Done,
     /*  163220 */   // Label 3043: @163220
     /*  163220 */   GIM_Reject,
     /*  163221 */ // Label 3041: @163221
     /*  163221 */ GIM_Reject,
     /*  163222 */ // Label 2924: @163222
     /*  163222 */ GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(163459),
     /*  163227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163230 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163238 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(163293), // Rule ID 45950 //
     /*  163243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163246 */     // MIs[0] rs1
     /*  163246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163254 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163291 */     GIR_RootConstrainSelectedInstOperands,
     /*  163292 */     // GIR_Coverage, 45950,
     /*  163292 */     GIR_EraseRootFromParent_Done,
     /*  163293 */   // Label 3045: @163293
     /*  163293 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(163348), // Rule ID 45951 //
     /*  163298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163301 */     // MIs[0] rs1
     /*  163301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163309 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163346 */     GIR_RootConstrainSelectedInstOperands,
     /*  163347 */     // GIR_Coverage, 45951,
     /*  163347 */     GIR_EraseRootFromParent_Done,
     /*  163348 */   // Label 3046: @163348
     /*  163348 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(163403), // Rule ID 46026 //
     /*  163353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  163356 */     // MIs[0] rs1
     /*  163356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163364 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163401 */     GIR_RootConstrainSelectedInstOperands,
     /*  163402 */     // GIR_Coverage, 46026,
     /*  163402 */     GIR_EraseRootFromParent_Done,
     /*  163403 */   // Label 3047: @163403
     /*  163403 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(163458), // Rule ID 46027 //
     /*  163408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  163411 */     // MIs[0] rs1
     /*  163411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163419 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163456 */     GIR_RootConstrainSelectedInstOperands,
     /*  163457 */     // GIR_Coverage, 46027,
     /*  163457 */     GIR_EraseRootFromParent_Done,
     /*  163458 */   // Label 3048: @163458
     /*  163458 */   GIM_Reject,
     /*  163459 */ // Label 3044: @163459
     /*  163459 */ GIM_Reject,
     /*  163460 */ // Label 2925: @163460
     /*  163460 */ GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(163697),
     /*  163465 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163468 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163476 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(163531), // Rule ID 45966 //
     /*  163481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163484 */     // MIs[0] rs1
     /*  163484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163492 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163529 */     GIR_RootConstrainSelectedInstOperands,
     /*  163530 */     // GIR_Coverage, 45966,
     /*  163530 */     GIR_EraseRootFromParent_Done,
     /*  163531 */   // Label 3050: @163531
     /*  163531 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(163586), // Rule ID 45967 //
     /*  163536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163539 */     // MIs[0] rs1
     /*  163539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163547 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  163547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163584 */     GIR_RootConstrainSelectedInstOperands,
     /*  163585 */     // GIR_Coverage, 45967,
     /*  163585 */     GIR_EraseRootFromParent_Done,
     /*  163586 */   // Label 3051: @163586
     /*  163586 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(163641), // Rule ID 46038 //
     /*  163591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  163594 */     // MIs[0] rs1
     /*  163594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163602 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163639 */     GIR_RootConstrainSelectedInstOperands,
     /*  163640 */     // GIR_Coverage, 46038,
     /*  163640 */     GIR_EraseRootFromParent_Done,
     /*  163641 */   // Label 3052: @163641
     /*  163641 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(163696), // Rule ID 46039 //
     /*  163646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  163649 */     // MIs[0] rs1
     /*  163649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163657 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  163657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163694 */     GIR_RootConstrainSelectedInstOperands,
     /*  163695 */     // GIR_Coverage, 46039,
     /*  163695 */     GIR_EraseRootFromParent_Done,
     /*  163696 */   // Label 3053: @163696
     /*  163696 */   GIM_Reject,
     /*  163697 */ // Label 3049: @163697
     /*  163697 */ GIM_Reject,
     /*  163698 */ // Label 2926: @163698
     /*  163698 */ GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(163935),
     /*  163703 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163706 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  163714 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(163769), // Rule ID 46010 //
     /*  163719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  163722 */     // MIs[0] rs1
     /*  163722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163730 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  163730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163767 */     GIR_RootConstrainSelectedInstOperands,
     /*  163768 */     // GIR_Coverage, 46010,
     /*  163768 */     GIR_EraseRootFromParent_Done,
     /*  163769 */   // Label 3055: @163769
     /*  163769 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(163824), // Rule ID 46011 //
     /*  163774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  163777 */     // MIs[0] rs1
     /*  163777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163785 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  163785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163822 */     GIR_RootConstrainSelectedInstOperands,
     /*  163823 */     // GIR_Coverage, 46011,
     /*  163823 */     GIR_EraseRootFromParent_Done,
     /*  163824 */   // Label 3056: @163824
     /*  163824 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(163879), // Rule ID 46070 //
     /*  163829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  163832 */     // MIs[0] rs1
     /*  163832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163840 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  163840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163877 */     GIR_RootConstrainSelectedInstOperands,
     /*  163878 */     // GIR_Coverage, 46070,
     /*  163878 */     GIR_EraseRootFromParent_Done,
     /*  163879 */   // Label 3057: @163879
     /*  163879 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(163934), // Rule ID 46071 //
     /*  163884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  163887 */     // MIs[0] rs1
     /*  163887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163895 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  163895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163932 */     GIR_RootConstrainSelectedInstOperands,
     /*  163933 */     // GIR_Coverage, 46071,
     /*  163933 */     GIR_EraseRootFromParent_Done,
     /*  163934 */   // Label 3058: @163934
     /*  163934 */   GIM_Reject,
     /*  163935 */ // Label 3054: @163935
     /*  163935 */ GIM_Reject,
     /*  163936 */ // Label 2927: @163936
     /*  163936 */ GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(164055),
     /*  163941 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163944 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  163956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163960 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(164007), // Rule ID 46086 //
     /*  163965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163968 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  163968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  163971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  163985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164005 */     GIR_RootConstrainSelectedInstOperands,
     /*  164006 */     // GIR_Coverage, 46086,
     /*  164006 */     GIR_EraseRootFromParent_Done,
     /*  164007 */   // Label 3060: @164007
     /*  164007 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(164054), // Rule ID 46087 //
     /*  164012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164015 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  164015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  164018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  164032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164052 */     GIR_RootConstrainSelectedInstOperands,
     /*  164053 */     // GIR_Coverage, 46087,
     /*  164053 */     GIR_EraseRootFromParent_Done,
     /*  164054 */   // Label 3061: @164054
     /*  164054 */   GIM_Reject,
     /*  164055 */ // Label 3059: @164055
     /*  164055 */ GIM_Reject,
     /*  164056 */ // Label 2928: @164056
     /*  164056 */ GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(164183),
     /*  164061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164064 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164072 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(164127), // Rule ID 45942 //
     /*  164077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164080 */     // MIs[0] rs1
     /*  164080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164088 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  164088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  164091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  164105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164125 */     GIR_RootConstrainSelectedInstOperands,
     /*  164126 */     // GIR_Coverage, 45942,
     /*  164126 */     GIR_EraseRootFromParent_Done,
     /*  164127 */   // Label 3063: @164127
     /*  164127 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(164182), // Rule ID 45943 //
     /*  164132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164135 */     // MIs[0] rs1
     /*  164135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164143 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  164143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  164146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  164160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164180 */     GIR_RootConstrainSelectedInstOperands,
     /*  164181 */     // GIR_Coverage, 45943,
     /*  164181 */     GIR_EraseRootFromParent_Done,
     /*  164182 */   // Label 3064: @164182
     /*  164182 */   GIM_Reject,
     /*  164183 */ // Label 3062: @164183
     /*  164183 */ GIM_Reject,
     /*  164184 */ // Label 2929: @164184
     /*  164184 */ GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(164421),
     /*  164189 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164192 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164200 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(164255), // Rule ID 45962 //
     /*  164205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164208 */     // MIs[0] rs1
     /*  164208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164216 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  164216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164253 */     GIR_RootConstrainSelectedInstOperands,
     /*  164254 */     // GIR_Coverage, 45962,
     /*  164254 */     GIR_EraseRootFromParent_Done,
     /*  164255 */   // Label 3066: @164255
     /*  164255 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(164310), // Rule ID 45963 //
     /*  164260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164263 */     // MIs[0] rs1
     /*  164263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164271 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  164271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164308 */     GIR_RootConstrainSelectedInstOperands,
     /*  164309 */     // GIR_Coverage, 45963,
     /*  164309 */     GIR_EraseRootFromParent_Done,
     /*  164310 */   // Label 3067: @164310
     /*  164310 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(164365), // Rule ID 46034 //
     /*  164315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  164318 */     // MIs[0] rs1
     /*  164318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164326 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  164326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164363 */     GIR_RootConstrainSelectedInstOperands,
     /*  164364 */     // GIR_Coverage, 46034,
     /*  164364 */     GIR_EraseRootFromParent_Done,
     /*  164365 */   // Label 3068: @164365
     /*  164365 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(164420), // Rule ID 46035 //
     /*  164370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  164373 */     // MIs[0] rs1
     /*  164373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164381 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  164381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164418 */     GIR_RootConstrainSelectedInstOperands,
     /*  164419 */     // GIR_Coverage, 46035,
     /*  164419 */     GIR_EraseRootFromParent_Done,
     /*  164420 */   // Label 3069: @164420
     /*  164420 */   GIM_Reject,
     /*  164421 */ // Label 3065: @164421
     /*  164421 */ GIM_Reject,
     /*  164422 */ // Label 2930: @164422
     /*  164422 */ GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(164659),
     /*  164427 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164430 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  164438 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(164493), // Rule ID 45998 //
     /*  164443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164446 */     // MIs[0] rs1
     /*  164446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164454 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  164454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164491 */     GIR_RootConstrainSelectedInstOperands,
     /*  164492 */     // GIR_Coverage, 45998,
     /*  164492 */     GIR_EraseRootFromParent_Done,
     /*  164493 */   // Label 3071: @164493
     /*  164493 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(164548), // Rule ID 45999 //
     /*  164498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164501 */     // MIs[0] rs1
     /*  164501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164509 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164546 */     GIR_RootConstrainSelectedInstOperands,
     /*  164547 */     // GIR_Coverage, 45999,
     /*  164547 */     GIR_EraseRootFromParent_Done,
     /*  164548 */   // Label 3072: @164548
     /*  164548 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(164603), // Rule ID 46058 //
     /*  164553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  164556 */     // MIs[0] rs1
     /*  164556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164564 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  164564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164601 */     GIR_RootConstrainSelectedInstOperands,
     /*  164602 */     // GIR_Coverage, 46058,
     /*  164602 */     GIR_EraseRootFromParent_Done,
     /*  164603 */   // Label 3073: @164603
     /*  164603 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(164658), // Rule ID 46059 //
     /*  164608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  164611 */     // MIs[0] rs1
     /*  164611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164619 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164656 */     GIR_RootConstrainSelectedInstOperands,
     /*  164657 */     // GIR_Coverage, 46059,
     /*  164657 */     GIR_EraseRootFromParent_Done,
     /*  164658 */   // Label 3074: @164658
     /*  164658 */   GIM_Reject,
     /*  164659 */ // Label 3070: @164659
     /*  164659 */ GIM_Reject,
     /*  164660 */ // Label 2931: @164660
     /*  164660 */ GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(164897),
     /*  164665 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164668 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  164676 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(164731), // Rule ID 46014 //
     /*  164681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  164684 */     // MIs[0] rs1
     /*  164684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164692 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  164692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164729 */     GIR_RootConstrainSelectedInstOperands,
     /*  164730 */     // GIR_Coverage, 46014,
     /*  164730 */     GIR_EraseRootFromParent_Done,
     /*  164731 */   // Label 3076: @164731
     /*  164731 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(164786), // Rule ID 46015 //
     /*  164736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  164739 */     // MIs[0] rs1
     /*  164739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164747 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  164747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164784 */     GIR_RootConstrainSelectedInstOperands,
     /*  164785 */     // GIR_Coverage, 46015,
     /*  164785 */     GIR_EraseRootFromParent_Done,
     /*  164786 */   // Label 3077: @164786
     /*  164786 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(164841), // Rule ID 46074 //
     /*  164791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  164794 */     // MIs[0] rs1
     /*  164794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164802 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  164802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164839 */     GIR_RootConstrainSelectedInstOperands,
     /*  164840 */     // GIR_Coverage, 46074,
     /*  164840 */     GIR_EraseRootFromParent_Done,
     /*  164841 */   // Label 3078: @164841
     /*  164841 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(164896), // Rule ID 46075 //
     /*  164846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  164849 */     // MIs[0] rs1
     /*  164849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164857 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  164857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164894 */     GIR_RootConstrainSelectedInstOperands,
     /*  164895 */     // GIR_Coverage, 46075,
     /*  164895 */     GIR_EraseRootFromParent_Done,
     /*  164896 */   // Label 3079: @164896
     /*  164896 */   GIM_Reject,
     /*  164897 */ // Label 3075: @164897
     /*  164897 */ GIM_Reject,
     /*  164898 */ // Label 2932: @164898
     /*  164898 */ GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(165017),
     /*  164903 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164906 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164914 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164922 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(164969), // Rule ID 46090 //
     /*  164927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164930 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  164930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  164933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  164947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164967 */     GIR_RootConstrainSelectedInstOperands,
     /*  164968 */     // GIR_Coverage, 46090,
     /*  164968 */     GIR_EraseRootFromParent_Done,
     /*  164969 */   // Label 3081: @164969
     /*  164969 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(165016), // Rule ID 46091 //
     /*  164974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164977 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  164977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  164980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  164994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165014 */     GIR_RootConstrainSelectedInstOperands,
     /*  165015 */     // GIR_Coverage, 46091,
     /*  165015 */     GIR_EraseRootFromParent_Done,
     /*  165016 */   // Label 3082: @165016
     /*  165016 */   GIM_Reject,
     /*  165017 */ // Label 3080: @165017
     /*  165017 */ GIM_Reject,
     /*  165018 */ // Label 2933: @165018
     /*  165018 */ GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(165145),
     /*  165023 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165026 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165034 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(165089), // Rule ID 45958 //
     /*  165039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165042 */     // MIs[0] rs1
     /*  165042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165050 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  165050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  165053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  165067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165087 */     GIR_RootConstrainSelectedInstOperands,
     /*  165088 */     // GIR_Coverage, 45958,
     /*  165088 */     GIR_EraseRootFromParent_Done,
     /*  165089 */   // Label 3084: @165089
     /*  165089 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(165144), // Rule ID 45959 //
     /*  165094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165097 */     // MIs[0] rs1
     /*  165097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165105 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  165105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  165108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  165122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165142 */     GIR_RootConstrainSelectedInstOperands,
     /*  165143 */     // GIR_Coverage, 45959,
     /*  165143 */     GIR_EraseRootFromParent_Done,
     /*  165144 */   // Label 3085: @165144
     /*  165144 */   GIM_Reject,
     /*  165145 */ // Label 3083: @165145
     /*  165145 */ GIM_Reject,
     /*  165146 */ // Label 2934: @165146
     /*  165146 */ GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(165383),
     /*  165151 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165154 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165162 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(165217), // Rule ID 45986 //
     /*  165167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165170 */     // MIs[0] rs1
     /*  165170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165178 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  165178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165215 */     GIR_RootConstrainSelectedInstOperands,
     /*  165216 */     // GIR_Coverage, 45986,
     /*  165216 */     GIR_EraseRootFromParent_Done,
     /*  165217 */   // Label 3087: @165217
     /*  165217 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(165272), // Rule ID 45987 //
     /*  165222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165225 */     // MIs[0] rs1
     /*  165225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165233 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  165233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165270 */     GIR_RootConstrainSelectedInstOperands,
     /*  165271 */     // GIR_Coverage, 45987,
     /*  165271 */     GIR_EraseRootFromParent_Done,
     /*  165272 */   // Label 3088: @165272
     /*  165272 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(165327), // Rule ID 46046 //
     /*  165277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  165280 */     // MIs[0] rs1
     /*  165280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165288 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  165288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165325 */     GIR_RootConstrainSelectedInstOperands,
     /*  165326 */     // GIR_Coverage, 46046,
     /*  165326 */     GIR_EraseRootFromParent_Done,
     /*  165327 */   // Label 3089: @165327
     /*  165327 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(165382), // Rule ID 46047 //
     /*  165332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  165335 */     // MIs[0] rs1
     /*  165335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165343 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  165343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165380 */     GIR_RootConstrainSelectedInstOperands,
     /*  165381 */     // GIR_Coverage, 46047,
     /*  165381 */     GIR_EraseRootFromParent_Done,
     /*  165382 */   // Label 3090: @165382
     /*  165382 */   GIM_Reject,
     /*  165383 */ // Label 3086: @165383
     /*  165383 */ GIM_Reject,
     /*  165384 */ // Label 2935: @165384
     /*  165384 */ GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(165621),
     /*  165389 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165392 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165400 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(165455), // Rule ID 46002 //
     /*  165405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165408 */     // MIs[0] rs1
     /*  165408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165416 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  165416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165453 */     GIR_RootConstrainSelectedInstOperands,
     /*  165454 */     // GIR_Coverage, 46002,
     /*  165454 */     GIR_EraseRootFromParent_Done,
     /*  165455 */   // Label 3092: @165455
     /*  165455 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(165510), // Rule ID 46003 //
     /*  165460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165463 */     // MIs[0] rs1
     /*  165463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165471 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165508 */     GIR_RootConstrainSelectedInstOperands,
     /*  165509 */     // GIR_Coverage, 46003,
     /*  165509 */     GIR_EraseRootFromParent_Done,
     /*  165510 */   // Label 3093: @165510
     /*  165510 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(165565), // Rule ID 46062 //
     /*  165515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  165518 */     // MIs[0] rs1
     /*  165518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165526 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  165526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165563 */     GIR_RootConstrainSelectedInstOperands,
     /*  165564 */     // GIR_Coverage, 46062,
     /*  165564 */     GIR_EraseRootFromParent_Done,
     /*  165565 */   // Label 3094: @165565
     /*  165565 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(165620), // Rule ID 46063 //
     /*  165570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  165573 */     // MIs[0] rs1
     /*  165573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165581 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165618 */     GIR_RootConstrainSelectedInstOperands,
     /*  165619 */     // GIR_Coverage, 46063,
     /*  165619 */     GIR_EraseRootFromParent_Done,
     /*  165620 */   // Label 3095: @165620
     /*  165620 */   GIM_Reject,
     /*  165621 */ // Label 3091: @165621
     /*  165621 */ GIM_Reject,
     /*  165622 */ // Label 2936: @165622
     /*  165622 */ GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(165859),
     /*  165627 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165630 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  165638 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(165693), // Rule ID 46018 //
     /*  165643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  165646 */     // MIs[0] rs1
     /*  165646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165654 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  165654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165691 */     GIR_RootConstrainSelectedInstOperands,
     /*  165692 */     // GIR_Coverage, 46018,
     /*  165692 */     GIR_EraseRootFromParent_Done,
     /*  165693 */   // Label 3097: @165693
     /*  165693 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(165748), // Rule ID 46019 //
     /*  165698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  165701 */     // MIs[0] rs1
     /*  165701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165709 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  165709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165746 */     GIR_RootConstrainSelectedInstOperands,
     /*  165747 */     // GIR_Coverage, 46019,
     /*  165747 */     GIR_EraseRootFromParent_Done,
     /*  165748 */   // Label 3098: @165748
     /*  165748 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(165803), // Rule ID 46078 //
     /*  165753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  165756 */     // MIs[0] rs1
     /*  165756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165764 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  165764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165801 */     GIR_RootConstrainSelectedInstOperands,
     /*  165802 */     // GIR_Coverage, 46078,
     /*  165802 */     GIR_EraseRootFromParent_Done,
     /*  165803 */   // Label 3099: @165803
     /*  165803 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(165858), // Rule ID 46079 //
     /*  165808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  165811 */     // MIs[0] rs1
     /*  165811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165819 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  165819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165856 */     GIR_RootConstrainSelectedInstOperands,
     /*  165857 */     // GIR_Coverage, 46079,
     /*  165857 */     GIR_EraseRootFromParent_Done,
     /*  165858 */   // Label 3100: @165858
     /*  165858 */   GIM_Reject,
     /*  165859 */ // Label 3096: @165859
     /*  165859 */ GIM_Reject,
     /*  165860 */ // Label 2937: @165860
     /*  165860 */ GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(165979),
     /*  165865 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165868 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  165880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165884 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(165931), // Rule ID 46094 //
     /*  165889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165892 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  165892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  165895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  165909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165929 */     GIR_RootConstrainSelectedInstOperands,
     /*  165930 */     // GIR_Coverage, 46094,
     /*  165930 */     GIR_EraseRootFromParent_Done,
     /*  165931 */   // Label 3102: @165931
     /*  165931 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(165978), // Rule ID 46095 //
     /*  165936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165939 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  165939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  165942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  165956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165976 */     GIR_RootConstrainSelectedInstOperands,
     /*  165977 */     // GIR_Coverage, 46095,
     /*  165977 */     GIR_EraseRootFromParent_Done,
     /*  165978 */   // Label 3103: @165978
     /*  165978 */   GIM_Reject,
     /*  165979 */ // Label 3101: @165979
     /*  165979 */ GIM_Reject,
     /*  165980 */ // Label 2938: @165980
     /*  165980 */ GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(166107),
     /*  165985 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165988 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165996 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(166051), // Rule ID 45974 //
     /*  166001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166004 */     // MIs[0] rs1
     /*  166004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166012 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  166012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  166015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  166029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166049 */     GIR_RootConstrainSelectedInstOperands,
     /*  166050 */     // GIR_Coverage, 45974,
     /*  166050 */     GIR_EraseRootFromParent_Done,
     /*  166051 */   // Label 3105: @166051
     /*  166051 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(166106), // Rule ID 45975 //
     /*  166056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166059 */     // MIs[0] rs1
     /*  166059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166067 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  166067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  166070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  166084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166104 */     GIR_RootConstrainSelectedInstOperands,
     /*  166105 */     // GIR_Coverage, 45975,
     /*  166105 */     GIR_EraseRootFromParent_Done,
     /*  166106 */   // Label 3106: @166106
     /*  166106 */   GIM_Reject,
     /*  166107 */ // Label 3104: @166107
     /*  166107 */ GIM_Reject,
     /*  166108 */ // Label 2939: @166108
     /*  166108 */ GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(166345),
     /*  166113 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166116 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166124 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(166179), // Rule ID 45990 //
     /*  166129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166132 */     // MIs[0] rs1
     /*  166132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166140 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166177 */     GIR_RootConstrainSelectedInstOperands,
     /*  166178 */     // GIR_Coverage, 45990,
     /*  166178 */     GIR_EraseRootFromParent_Done,
     /*  166179 */   // Label 3108: @166179
     /*  166179 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(166234), // Rule ID 45991 //
     /*  166184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166187 */     // MIs[0] rs1
     /*  166187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166195 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166232 */     GIR_RootConstrainSelectedInstOperands,
     /*  166233 */     // GIR_Coverage, 45991,
     /*  166233 */     GIR_EraseRootFromParent_Done,
     /*  166234 */   // Label 3109: @166234
     /*  166234 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(166289), // Rule ID 46050 //
     /*  166239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  166242 */     // MIs[0] rs1
     /*  166242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166250 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166287 */     GIR_RootConstrainSelectedInstOperands,
     /*  166288 */     // GIR_Coverage, 46050,
     /*  166288 */     GIR_EraseRootFromParent_Done,
     /*  166289 */   // Label 3110: @166289
     /*  166289 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(166344), // Rule ID 46051 //
     /*  166294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  166297 */     // MIs[0] rs1
     /*  166297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166305 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166342 */     GIR_RootConstrainSelectedInstOperands,
     /*  166343 */     // GIR_Coverage, 46051,
     /*  166343 */     GIR_EraseRootFromParent_Done,
     /*  166344 */   // Label 3111: @166344
     /*  166344 */   GIM_Reject,
     /*  166345 */ // Label 3107: @166345
     /*  166345 */ GIM_Reject,
     /*  166346 */ // Label 2940: @166346
     /*  166346 */ GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(166583),
     /*  166351 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166354 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166362 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(166417), // Rule ID 46006 //
     /*  166367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166370 */     // MIs[0] rs1
     /*  166370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166378 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  166378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166415 */     GIR_RootConstrainSelectedInstOperands,
     /*  166416 */     // GIR_Coverage, 46006,
     /*  166416 */     GIR_EraseRootFromParent_Done,
     /*  166417 */   // Label 3113: @166417
     /*  166417 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(166472), // Rule ID 46007 //
     /*  166422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166425 */     // MIs[0] rs1
     /*  166425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166433 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  166433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166470 */     GIR_RootConstrainSelectedInstOperands,
     /*  166471 */     // GIR_Coverage, 46007,
     /*  166471 */     GIR_EraseRootFromParent_Done,
     /*  166472 */   // Label 3114: @166472
     /*  166472 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(166527), // Rule ID 46066 //
     /*  166477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  166480 */     // MIs[0] rs1
     /*  166480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166488 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  166488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166525 */     GIR_RootConstrainSelectedInstOperands,
     /*  166526 */     // GIR_Coverage, 46066,
     /*  166526 */     GIR_EraseRootFromParent_Done,
     /*  166527 */   // Label 3115: @166527
     /*  166527 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(166582), // Rule ID 46067 //
     /*  166532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  166535 */     // MIs[0] rs1
     /*  166535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166543 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  166543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166580 */     GIR_RootConstrainSelectedInstOperands,
     /*  166581 */     // GIR_Coverage, 46067,
     /*  166581 */     GIR_EraseRootFromParent_Done,
     /*  166582 */   // Label 3116: @166582
     /*  166582 */   GIM_Reject,
     /*  166583 */ // Label 3112: @166583
     /*  166583 */ GIM_Reject,
     /*  166584 */ // Label 2941: @166584
     /*  166584 */ GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(166703),
     /*  166589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166592 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166608 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(166655), // Rule ID 46098 //
     /*  166613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166616 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  166616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  166619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  166633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166653 */     GIR_RootConstrainSelectedInstOperands,
     /*  166654 */     // GIR_Coverage, 46098,
     /*  166654 */     GIR_EraseRootFromParent_Done,
     /*  166655 */   // Label 3118: @166655
     /*  166655 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(166702), // Rule ID 46099 //
     /*  166660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166663 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  166663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  166666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  166680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166700 */     GIR_RootConstrainSelectedInstOperands,
     /*  166701 */     // GIR_Coverage, 46099,
     /*  166701 */     GIR_EraseRootFromParent_Done,
     /*  166702 */   // Label 3119: @166702
     /*  166702 */   GIM_Reject,
     /*  166703 */ // Label 3117: @166703
     /*  166703 */ GIM_Reject,
     /*  166704 */ // Label 2942: @166704
     /*  166704 */ GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(166831),
     /*  166709 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166712 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166720 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(166775), // Rule ID 45978 //
     /*  166725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166728 */     // MIs[0] rs1
     /*  166728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166736 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  166736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  166739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  166753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166773 */     GIR_RootConstrainSelectedInstOperands,
     /*  166774 */     // GIR_Coverage, 45978,
     /*  166774 */     GIR_EraseRootFromParent_Done,
     /*  166775 */   // Label 3121: @166775
     /*  166775 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(166830), // Rule ID 45979 //
     /*  166780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166783 */     // MIs[0] rs1
     /*  166783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166791 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  166791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  166794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  166808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166828 */     GIR_RootConstrainSelectedInstOperands,
     /*  166829 */     // GIR_Coverage, 45979,
     /*  166829 */     GIR_EraseRootFromParent_Done,
     /*  166830 */   // Label 3122: @166830
     /*  166830 */   GIM_Reject,
     /*  166831 */ // Label 3120: @166831
     /*  166831 */ GIM_Reject,
     /*  166832 */ // Label 2943: @166832
     /*  166832 */ GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(167069),
     /*  166837 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166840 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166848 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(166903), // Rule ID 45994 //
     /*  166853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166856 */     // MIs[0] rs1
     /*  166856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166864 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166901 */     GIR_RootConstrainSelectedInstOperands,
     /*  166902 */     // GIR_Coverage, 45994,
     /*  166902 */     GIR_EraseRootFromParent_Done,
     /*  166903 */   // Label 3124: @166903
     /*  166903 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(166958), // Rule ID 45995 //
     /*  166908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166911 */     // MIs[0] rs1
     /*  166911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166919 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166956 */     GIR_RootConstrainSelectedInstOperands,
     /*  166957 */     // GIR_Coverage, 45995,
     /*  166957 */     GIR_EraseRootFromParent_Done,
     /*  166958 */   // Label 3125: @166958
     /*  166958 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(167013), // Rule ID 46054 //
     /*  166963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  166966 */     // MIs[0] rs1
     /*  166966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166974 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167011 */     GIR_RootConstrainSelectedInstOperands,
     /*  167012 */     // GIR_Coverage, 46054,
     /*  167012 */     GIR_EraseRootFromParent_Done,
     /*  167013 */   // Label 3126: @167013
     /*  167013 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(167068), // Rule ID 46055 //
     /*  167018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  167021 */     // MIs[0] rs1
     /*  167021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167029 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  167029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  167032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  167046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167066 */     GIR_RootConstrainSelectedInstOperands,
     /*  167067 */     // GIR_Coverage, 46055,
     /*  167067 */     GIR_EraseRootFromParent_Done,
     /*  167068 */   // Label 3127: @167068
     /*  167068 */   GIM_Reject,
     /*  167069 */ // Label 3123: @167069
     /*  167069 */ GIM_Reject,
     /*  167070 */ // Label 2944: @167070
     /*  167070 */ GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(167189),
     /*  167075 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167078 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167086 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167094 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(167141), // Rule ID 46102 //
     /*  167099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167102 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  167102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  167105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  167119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  167132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167139 */     GIR_RootConstrainSelectedInstOperands,
     /*  167140 */     // GIR_Coverage, 46102,
     /*  167140 */     GIR_EraseRootFromParent_Done,
     /*  167141 */   // Label 3129: @167141
     /*  167141 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(167188), // Rule ID 46103 //
     /*  167146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167149 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  167149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  167152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  167166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  167179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167186 */     GIR_RootConstrainSelectedInstOperands,
     /*  167187 */     // GIR_Coverage, 46103,
     /*  167187 */     GIR_EraseRootFromParent_Done,
     /*  167188 */   // Label 3130: @167188
     /*  167188 */   GIM_Reject,
     /*  167189 */ // Label 3128: @167189
     /*  167189 */ GIM_Reject,
     /*  167190 */ // Label 2945: @167190
     /*  167190 */ GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(167317),
     /*  167195 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167198 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  167206 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(167261), // Rule ID 45982 //
     /*  167211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167214 */     // MIs[0] rs1
     /*  167214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167222 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  167222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  167225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  167239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167259 */     GIR_RootConstrainSelectedInstOperands,
     /*  167260 */     // GIR_Coverage, 45982,
     /*  167260 */     GIR_EraseRootFromParent_Done,
     /*  167261 */   // Label 3132: @167261
     /*  167261 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(167316), // Rule ID 45983 //
     /*  167266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167269 */     // MIs[0] rs1
     /*  167269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167277 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  167277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  167280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  167294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167314 */     GIR_RootConstrainSelectedInstOperands,
     /*  167315 */     // GIR_Coverage, 45983,
     /*  167315 */     GIR_EraseRootFromParent_Done,
     /*  167316 */   // Label 3133: @167316
     /*  167316 */   GIM_Reject,
     /*  167317 */ // Label 3131: @167317
     /*  167317 */ GIM_Reject,
     /*  167318 */ // Label 2946: @167318
     /*  167318 */ GIM_Reject,
     /*  167319 */ // Label 22: @167319
     /*  167319 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3136*/ GIMT_Encode4(168432),
     /*  167330 */ /*GILLT_s32*//*Label 3134*/ GIMT_Encode4(167338),
     /*  167334 */ /*GILLT_s64*//*Label 3135*/ GIMT_Encode4(167858),
     /*  167338 */ // Label 3134: @167338
     /*  167338 */ GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(167392), // Rule ID 243 //
     /*  167343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  167346 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167349 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167364 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167371 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  167374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167390 */   GIR_RootConstrainSelectedInstOperands,
     /*  167391 */   // GIR_Coverage, 243,
     /*  167391 */   GIR_EraseRootFromParent_Done,
     /*  167392 */ // Label 3137: @167392
     /*  167392 */ GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(167446), // Rule ID 247 //
     /*  167397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  167400 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167403 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167425 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  167428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167444 */   GIR_RootConstrainSelectedInstOperands,
     /*  167445 */   // GIR_Coverage, 247,
     /*  167445 */   GIR_EraseRootFromParent_Done,
     /*  167446 */ // Label 3138: @167446
     /*  167446 */ GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(167503), // Rule ID 336 //
     /*  167451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  167454 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167457 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167464 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167471 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167475 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167482 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10132>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  167485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167497 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167501 */   GIR_RootConstrainSelectedInstOperands,
     /*  167502 */   // GIR_Coverage, 336,
     /*  167502 */   GIR_EraseRootFromParent_Done,
     /*  167503 */ // Label 3139: @167503
     /*  167503 */ GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(167560), // Rule ID 340 //
     /*  167508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  167511 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167514 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167521 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167532 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167539 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10134>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  167542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167558 */   GIR_RootConstrainSelectedInstOperands,
     /*  167559 */   // GIR_Coverage, 340,
     /*  167559 */   GIR_EraseRootFromParent_Done,
     /*  167560 */ // Label 3140: @167560
     /*  167560 */ GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(167617), // Rule ID 356 //
     /*  167565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  167568 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167571 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167578 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167585 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167589 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167596 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10148>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  167599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167611 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167615 */   GIR_RootConstrainSelectedInstOperands,
     /*  167616 */   // GIR_Coverage, 356,
     /*  167616 */   GIR_EraseRootFromParent_Done,
     /*  167617 */ // Label 3141: @167617
     /*  167617 */ GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(167657), // Rule ID 1112 //
     /*  167622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167625 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167628 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167635 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167642 */   // MIs[0] rs1
     /*  167642 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167650 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10636>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  167655 */   GIR_RootConstrainSelectedInstOperands,
     /*  167656 */   // GIR_Coverage, 1112,
     /*  167656 */   GIR_Done,
     /*  167657 */ // Label 3142: @167657
     /*  167657 */ GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(167697), // Rule ID 1116 //
     /*  167662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167665 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167668 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167675 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167682 */   // MIs[0] rs1
     /*  167682 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167690 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10638>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  167695 */   GIR_RootConstrainSelectedInstOperands,
     /*  167696 */   // GIR_Coverage, 1116,
     /*  167696 */   GIR_Done,
     /*  167697 */ // Label 3143: @167697
     /*  167697 */ GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(167737), // Rule ID 1120 //
     /*  167702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167705 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167708 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167715 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167722 */   // MIs[0] rs1
     /*  167722 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167730 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10640>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  167735 */   GIR_RootConstrainSelectedInstOperands,
     /*  167736 */   // GIR_Coverage, 1120,
     /*  167736 */   GIR_Done,
     /*  167737 */ // Label 3144: @167737
     /*  167737 */ GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(167777), // Rule ID 1124 //
     /*  167742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167745 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167755 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167762 */   // MIs[0] rs1
     /*  167762 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167770 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10642>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  167775 */   GIR_RootConstrainSelectedInstOperands,
     /*  167776 */   // GIR_Coverage, 1124,
     /*  167776 */   GIR_Done,
     /*  167777 */ // Label 3145: @167777
     /*  167777 */ GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(167817), // Rule ID 1144 //
     /*  167782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  167785 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167788 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167795 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167802 */   // MIs[0] rs1
     /*  167802 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167810 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10660>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  167815 */   GIR_RootConstrainSelectedInstOperands,
     /*  167816 */   // GIR_Coverage, 1144,
     /*  167816 */   GIR_Done,
     /*  167817 */ // Label 3146: @167817
     /*  167817 */ GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(167857), // Rule ID 1148 //
     /*  167822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  167825 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167828 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167835 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167842 */   // MIs[0] rs1
     /*  167842 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167850 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10662>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  167855 */   GIR_RootConstrainSelectedInstOperands,
     /*  167856 */   // GIR_Coverage, 1148,
     /*  167856 */   GIR_Done,
     /*  167857 */ // Label 3147: @167857
     /*  167857 */ GIM_Reject,
     /*  167858 */ // Label 3135: @167858
     /*  167858 */ GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(167912), // Rule ID 242 //
     /*  167863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  167866 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167869 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167891 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  167894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167906 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167910 */   GIR_RootConstrainSelectedInstOperands,
     /*  167911 */   // GIR_Coverage, 242,
     /*  167911 */   GIR_EraseRootFromParent_Done,
     /*  167912 */ // Label 3148: @167912
     /*  167912 */ GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(167966), // Rule ID 246 //
     /*  167917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  167920 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167923 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167945 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  167948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167964 */   GIR_RootConstrainSelectedInstOperands,
     /*  167965 */   // GIR_Coverage, 246,
     /*  167965 */   GIR_EraseRootFromParent_Done,
     /*  167966 */ // Label 3149: @167966
     /*  167966 */ GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(168020), // Rule ID 293 //
     /*  167971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  167974 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167977 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167988 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167992 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167999 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  168002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168018 */   GIR_RootConstrainSelectedInstOperands,
     /*  168019 */   // GIR_Coverage, 293,
     /*  168019 */   GIR_EraseRootFromParent_Done,
     /*  168020 */ // Label 3150: @168020
     /*  168020 */ GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(168077), // Rule ID 335 //
     /*  168025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168028 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168031 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168038 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168045 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168049 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168056 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10132>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  168059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168071 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168075 */   GIR_RootConstrainSelectedInstOperands,
     /*  168076 */   // GIR_Coverage, 335,
     /*  168076 */   GIR_EraseRootFromParent_Done,
     /*  168077 */ // Label 3151: @168077
     /*  168077 */ GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(168134), // Rule ID 339 //
     /*  168082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168085 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168088 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168095 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168102 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168106 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168113 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10134>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  168116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168132 */   GIR_RootConstrainSelectedInstOperands,
     /*  168133 */   // GIR_Coverage, 339,
     /*  168133 */   GIR_EraseRootFromParent_Done,
     /*  168134 */ // Label 3152: @168134
     /*  168134 */ GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(168191), // Rule ID 355 //
     /*  168139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  168142 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168145 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168152 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168159 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168163 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168170 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10148>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  168173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168185 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168189 */   GIR_RootConstrainSelectedInstOperands,
     /*  168190 */   // GIR_Coverage, 355,
     /*  168190 */   GIR_EraseRootFromParent_Done,
     /*  168191 */ // Label 3153: @168191
     /*  168191 */ GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(168231), // Rule ID 1111 //
     /*  168196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  168199 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168202 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168209 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168216 */   // MIs[0] rs1
     /*  168216 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  168220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168224 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10636>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  168224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  168229 */   GIR_RootConstrainSelectedInstOperands,
     /*  168230 */   // GIR_Coverage, 1111,
     /*  168230 */   GIR_Done,
     /*  168231 */ // Label 3154: @168231
     /*  168231 */ GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(168271), // Rule ID 1115 //
     /*  168236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  168239 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168242 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168249 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  168252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168256 */   // MIs[0] rs1
     /*  168256 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  168260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168264 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10638>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  168264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  168269 */   GIR_RootConstrainSelectedInstOperands,
     /*  168270 */   // GIR_Coverage, 1115,
     /*  168270 */   GIR_Done,
     /*  168271 */ // Label 3155: @168271
     /*  168271 */ GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(168311), // Rule ID 1119 //
     /*  168276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  168279 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168282 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168296 */   // MIs[0] rs1
     /*  168296 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  168300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168304 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10640>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  168304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  168309 */   GIR_RootConstrainSelectedInstOperands,
     /*  168310 */   // GIR_Coverage, 1119,
     /*  168310 */   GIR_Done,
     /*  168311 */ // Label 3156: @168311
     /*  168311 */ GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(168351), // Rule ID 1123 //
     /*  168316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  168319 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168322 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  168332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168336 */   // MIs[0] rs1
     /*  168336 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  168340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168344 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10642>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  168344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  168349 */   GIR_RootConstrainSelectedInstOperands,
     /*  168350 */   // GIR_Coverage, 1123,
     /*  168350 */   GIR_Done,
     /*  168351 */ // Label 3157: @168351
     /*  168351 */ GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(168391), // Rule ID 1143 //
     /*  168356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  168359 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168362 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168369 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168376 */   // MIs[0] rs1
     /*  168376 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  168380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168384 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10660>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  168384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  168389 */   GIR_RootConstrainSelectedInstOperands,
     /*  168390 */   // GIR_Coverage, 1143,
     /*  168390 */   GIR_Done,
     /*  168391 */ // Label 3158: @168391
     /*  168391 */ GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(168431), // Rule ID 1147 //
     /*  168396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  168399 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168402 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168409 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  168412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168416 */   // MIs[0] rs1
     /*  168416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  168420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168424 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10662>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  168424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  168429 */   GIR_RootConstrainSelectedInstOperands,
     /*  168430 */   // GIR_Coverage, 1147,
     /*  168430 */   GIR_Done,
     /*  168431 */ // Label 3159: @168431
     /*  168431 */ GIM_Reject,
     /*  168432 */ // Label 3136: @168432
     /*  168432 */ GIM_Reject,
     /*  168433 */ // Label 23: @168433
     /*  168433 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3162*/ GIMT_Encode4(169066),
     /*  168444 */ /*GILLT_s32*//*Label 3160*/ GIMT_Encode4(168452),
     /*  168448 */ /*GILLT_s64*//*Label 3161*/ GIMT_Encode4(168732),
     /*  168452 */ // Label 3160: @168452
     /*  168452 */ GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(168506), // Rule ID 253 //
     /*  168457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  168460 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168463 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168474 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168478 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168485 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168500 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168504 */   GIR_RootConstrainSelectedInstOperands,
     /*  168505 */   // GIR_Coverage, 253,
     /*  168505 */   GIR_EraseRootFromParent_Done,
     /*  168506 */ // Label 3163: @168506
     /*  168506 */ GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(168560), // Rule ID 255 //
     /*  168511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  168514 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168517 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168532 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168539 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168558 */   GIR_RootConstrainSelectedInstOperands,
     /*  168559 */   // GIR_Coverage, 255,
     /*  168559 */   GIR_EraseRootFromParent_Done,
     /*  168560 */ // Label 3164: @168560
     /*  168560 */ GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(168617), // Rule ID 342 //
     /*  168565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168568 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168571 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168578 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168585 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168589 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168596 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10136>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168611 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168615 */   GIR_RootConstrainSelectedInstOperands,
     /*  168616 */   // GIR_Coverage, 342,
     /*  168616 */   GIR_EraseRootFromParent_Done,
     /*  168617 */ // Label 3165: @168617
     /*  168617 */ GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(168674), // Rule ID 344 //
     /*  168622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168625 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168628 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168635 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168642 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168646 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168653 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10138>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168668 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168672 */   GIR_RootConstrainSelectedInstOperands,
     /*  168673 */   // GIR_Coverage, 344,
     /*  168673 */   GIR_EraseRootFromParent_Done,
     /*  168674 */ // Label 3166: @168674
     /*  168674 */ GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(168731), // Rule ID 358 //
     /*  168679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  168682 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168685 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168692 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168699 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168703 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168710 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10150>>  =>  (LWU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  168713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168725 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168729 */   GIR_RootConstrainSelectedInstOperands,
     /*  168730 */   // GIR_Coverage, 358,
     /*  168730 */   GIR_EraseRootFromParent_Done,
     /*  168731 */ // Label 3167: @168731
     /*  168731 */ GIM_Reject,
     /*  168732 */ // Label 3161: @168732
     /*  168732 */ GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(168786), // Rule ID 252 //
     /*  168737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  168740 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168743 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168754 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168758 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168765 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168780 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168784 */   GIR_RootConstrainSelectedInstOperands,
     /*  168785 */   // GIR_Coverage, 252,
     /*  168785 */   GIR_EraseRootFromParent_Done,
     /*  168786 */ // Label 3168: @168786
     /*  168786 */ GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(168840), // Rule ID 254 //
     /*  168791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  168794 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168797 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168808 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168812 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168819 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168838 */   GIR_RootConstrainSelectedInstOperands,
     /*  168839 */   // GIR_Coverage, 254,
     /*  168839 */   GIR_EraseRootFromParent_Done,
     /*  168840 */ // Label 3169: @168840
     /*  168840 */ GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(168894), // Rule ID 295 //
     /*  168845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  168848 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168851 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168862 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168866 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168873 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  168876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168892 */   GIR_RootConstrainSelectedInstOperands,
     /*  168893 */   // GIR_Coverage, 295,
     /*  168893 */   GIR_EraseRootFromParent_Done,
     /*  168894 */ // Label 3170: @168894
     /*  168894 */ GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(168951), // Rule ID 341 //
     /*  168899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168902 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168905 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168912 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168919 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168923 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168930 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10136>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168945 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168949 */   GIR_RootConstrainSelectedInstOperands,
     /*  168950 */   // GIR_Coverage, 341,
     /*  168950 */   GIR_EraseRootFromParent_Done,
     /*  168951 */ // Label 3171: @168951
     /*  168951 */ GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(169008), // Rule ID 343 //
     /*  168956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168959 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168962 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168969 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168976 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168980 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168987 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10138>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169006 */   GIR_RootConstrainSelectedInstOperands,
     /*  169007 */   // GIR_Coverage, 343,
     /*  169007 */   GIR_EraseRootFromParent_Done,
     /*  169008 */ // Label 3172: @169008
     /*  169008 */ GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(169065), // Rule ID 357 //
     /*  169013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  169016 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169019 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169026 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169033 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169037 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169044 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10150>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  169047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169063 */   GIR_RootConstrainSelectedInstOperands,
     /*  169064 */   // GIR_Coverage, 357,
     /*  169064 */   GIR_EraseRootFromParent_Done,
     /*  169065 */ // Label 3173: @169065
     /*  169065 */ GIM_Reject,
     /*  169066 */ // Label 3162: @169066
     /*  169066 */ GIM_Reject,
     /*  169067 */ // Label 24: @169067
     /*  169067 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 3208*/ GIMT_Encode4(175966),
     /*  169078 */ /*GILLT_p0s32*//*Label 3174*/ GIMT_Encode4(169214),
     /*  169082 */ /*GILLT_p0s64*//*Label 3175*/ GIMT_Encode4(169308),
     /*  169086 */ /*GILLT_s16*//*Label 3176*/ GIMT_Encode4(169402),
     /*  169090 */ /*GILLT_s32*//*Label 3177*/ GIMT_Encode4(170041),
     /*  169094 */ /*GILLT_s64*//*Label 3178*/ GIMT_Encode4(171343),
     /*  169098 */ /*GILLT_nxv1s1*//*Label 3179*/ GIMT_Encode4(172420),
     /*  169102 */ /*GILLT_nxv1s8*//*Label 3180*/ GIMT_Encode4(172500),
     /*  169106 */ /*GILLT_nxv1s16*//*Label 3181*/ GIMT_Encode4(172588),
     /*  169110 */ /*GILLT_nxv1s32*//*Label 3182*/ GIMT_Encode4(172746),
     /*  169114 */ /*GILLT_nxv1s64*//*Label 3183*/ GIMT_Encode4(172904),
     /*  169118 */ /*GILLT_nxv2s1*//*Label 3184*/ GIMT_Encode4(173062),
     /*  169122 */ /*GILLT_nxv2s8*//*Label 3185*/ GIMT_Encode4(173142),
     /*  169126 */ /*GILLT_nxv2s16*//*Label 3186*/ GIMT_Encode4(173230),
     /*  169130 */ /*GILLT_nxv2s32*//*Label 3187*/ GIMT_Encode4(173388),
     /*  169134 */ /*GILLT_nxv2s64*//*Label 3188*/ GIMT_Encode4(173546),
     /*  169138 */ /*GILLT_nxv4s1*//*Label 3189*/ GIMT_Encode4(173704),
     /*  169142 */ /*GILLT_nxv4s8*//*Label 3190*/ GIMT_Encode4(173784),
     /*  169146 */ /*GILLT_nxv4s16*//*Label 3191*/ GIMT_Encode4(173872),
     /*  169150 */ /*GILLT_nxv4s32*//*Label 3192*/ GIMT_Encode4(174030),
     /*  169154 */ /*GILLT_nxv4s64*//*Label 3193*/ GIMT_Encode4(174188),
     /*  169158 */ /*GILLT_nxv8s1*//*Label 3194*/ GIMT_Encode4(174346),
     /*  169162 */ /*GILLT_nxv8s8*//*Label 3195*/ GIMT_Encode4(174426),
     /*  169166 */ /*GILLT_nxv8s16*//*Label 3196*/ GIMT_Encode4(174514),
     /*  169170 */ /*GILLT_nxv8s32*//*Label 3197*/ GIMT_Encode4(174672),
     /*  169174 */ /*GILLT_nxv8s64*//*Label 3198*/ GIMT_Encode4(174830),
     /*  169178 */ /*GILLT_nxv16s1*//*Label 3199*/ GIMT_Encode4(174988),
     /*  169182 */ /*GILLT_nxv16s8*//*Label 3200*/ GIMT_Encode4(175068),
     /*  169186 */ /*GILLT_nxv16s16*//*Label 3201*/ GIMT_Encode4(175156),
     /*  169190 */ /*GILLT_nxv16s32*//*Label 3202*/ GIMT_Encode4(175314),
     /*  169194 */ /*GILLT_nxv32s1*//*Label 3203*/ GIMT_Encode4(175472),
     /*  169198 */ /*GILLT_nxv32s8*//*Label 3204*/ GIMT_Encode4(175552),
     /*  169202 */ /*GILLT_nxv32s16*//*Label 3205*/ GIMT_Encode4(175640),
     /*  169206 */ /*GILLT_nxv64s1*//*Label 3206*/ GIMT_Encode4(175798),
     /*  169210 */ /*GILLT_nxv64s8*//*Label 3207*/ GIMT_Encode4(175878),
     /*  169214 */ // Label 3174: @169214
     /*  169214 */ GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(169307),
     /*  169219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169222 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169234 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(169270), // Rule ID 65431 //
     /*  169239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  169242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169249 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169252 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169268 */     GIR_RootConstrainSelectedInstOperands,
     /*  169269 */     // GIR_Coverage, 65431,
     /*  169269 */     GIR_EraseRootFromParent_Done,
     /*  169270 */   // Label 3210: @169270
     /*  169270 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(169306), // Rule ID 65435 //
     /*  169275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  169278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169285 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  169288 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169304 */     GIR_RootConstrainSelectedInstOperands,
     /*  169305 */     // GIR_Coverage, 65435,
     /*  169305 */     GIR_EraseRootFromParent_Done,
     /*  169306 */   // Label 3211: @169306
     /*  169306 */   GIM_Reject,
     /*  169307 */ // Label 3209: @169307
     /*  169307 */ GIM_Reject,
     /*  169308 */ // Label 3175: @169308
     /*  169308 */ GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(169401),
     /*  169313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169316 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169324 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169328 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(169364), // Rule ID 65430 //
     /*  169333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  169336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169343 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169346 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169362 */     GIR_RootConstrainSelectedInstOperands,
     /*  169363 */     // GIR_Coverage, 65430,
     /*  169363 */     GIR_EraseRootFromParent_Done,
     /*  169364 */   // Label 3213: @169364
     /*  169364 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(169400), // Rule ID 65434 //
     /*  169369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  169372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169379 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  169382 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169398 */     GIR_RootConstrainSelectedInstOperands,
     /*  169399 */     // GIR_Coverage, 65434,
     /*  169399 */     GIR_EraseRootFromParent_Done,
     /*  169400 */   // Label 3214: @169400
     /*  169400 */   GIM_Reject,
     /*  169401 */ // Label 3212: @169401
     /*  169401 */ GIM_Reject,
     /*  169402 */ // Label 3176: @169402
     /*  169402 */ GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(169456), // Rule ID 65448 //
     /*  169407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  169410 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169413 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169424 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169428 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169435 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169438 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169454 */   GIR_RootConstrainSelectedInstOperands,
     /*  169455 */   // GIR_Coverage, 65448,
     /*  169455 */   GIR_EraseRootFromParent_Done,
     /*  169456 */ // Label 3215: @169456
     /*  169456 */ GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(169510), // Rule ID 65449 //
     /*  169461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169464 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169467 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169482 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169489 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169492 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169504 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169508 */   GIR_RootConstrainSelectedInstOperands,
     /*  169509 */   // GIR_Coverage, 65449,
     /*  169509 */   GIR_EraseRootFromParent_Done,
     /*  169510 */ // Label 3216: @169510
     /*  169510 */ GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(169564), // Rule ID 65450 //
     /*  169515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  169518 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169521 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169532 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169536 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169543 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169546 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169558 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169562 */   GIR_RootConstrainSelectedInstOperands,
     /*  169563 */   // GIR_Coverage, 65450,
     /*  169563 */   GIR_EraseRootFromParent_Done,
     /*  169564 */ // Label 3217: @169564
     /*  169564 */ GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(169618), // Rule ID 65451 //
     /*  169569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169572 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169575 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169586 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169590 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169597 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169600 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169607 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169612 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169616 */   GIR_RootConstrainSelectedInstOperands,
     /*  169617 */   // GIR_Coverage, 65451,
     /*  169617 */   GIR_EraseRootFromParent_Done,
     /*  169618 */ // Label 3218: @169618
     /*  169618 */ GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(169669), // Rule ID 2160 //
     /*  169623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  169626 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169629 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  169637 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169641 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169648 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  169651 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169663 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169667 */   GIR_RootConstrainSelectedInstOperands,
     /*  169668 */   // GIR_Coverage, 2160,
     /*  169668 */   GIR_EraseRootFromParent_Done,
     /*  169669 */ // Label 3219: @169669
     /*  169669 */ GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(169720), // Rule ID 2161 //
     /*  169674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  169677 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169680 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  169688 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169692 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169699 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  169702 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169718 */   GIR_RootConstrainSelectedInstOperands,
     /*  169719 */   // GIR_Coverage, 2161,
     /*  169719 */   GIR_EraseRootFromParent_Done,
     /*  169720 */ // Label 3220: @169720
     /*  169720 */ GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(169771), // Rule ID 2166 //
     /*  169725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  169728 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169731 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  169739 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169743 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169750 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  169753 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169765 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169769 */   GIR_RootConstrainSelectedInstOperands,
     /*  169770 */   // GIR_Coverage, 2166,
     /*  169770 */   GIR_EraseRootFromParent_Done,
     /*  169771 */ // Label 3221: @169771
     /*  169771 */ GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(169822), // Rule ID 2167 //
     /*  169776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  169779 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169782 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  169790 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169794 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169801 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  169804 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169820 */   GIR_RootConstrainSelectedInstOperands,
     /*  169821 */   // GIR_Coverage, 2167,
     /*  169821 */   GIR_EraseRootFromParent_Done,
     /*  169822 */ // Label 3222: @169822
     /*  169822 */ GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(169873), // Rule ID 65438 //
     /*  169827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169833 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169845 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169852 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169855 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169867 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169871 */   GIR_RootConstrainSelectedInstOperands,
     /*  169872 */   // GIR_Coverage, 65438,
     /*  169872 */   GIR_EraseRootFromParent_Done,
     /*  169873 */ // Label 3223: @169873
     /*  169873 */ GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(169924), // Rule ID 65439 //
     /*  169878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169881 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169884 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169896 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169903 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169906 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169918 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169922 */   GIR_RootConstrainSelectedInstOperands,
     /*  169923 */   // GIR_Coverage, 65439,
     /*  169923 */   GIR_EraseRootFromParent_Done,
     /*  169924 */ // Label 3224: @169924
     /*  169924 */ GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(169982), // Rule ID 65442 //
     /*  169929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169935 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169961 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169964 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169976 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169980 */   GIR_RootConstrainSelectedInstOperands,
     /*  169981 */   // GIR_Coverage, 65442,
     /*  169981 */   GIR_EraseRootFromParent_Done,
     /*  169982 */ // Label 3225: @169982
     /*  169982 */ GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(170040), // Rule ID 65443 //
     /*  169987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169993 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169997 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170012 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170019 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170022 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170038 */   GIR_RootConstrainSelectedInstOperands,
     /*  170039 */   // GIR_Coverage, 65443,
     /*  170039 */   GIR_EraseRootFromParent_Done,
     /*  170040 */ // Label 3226: @170040
     /*  170040 */ GIM_Reject,
     /*  170041 */ // Label 3177: @170041
     /*  170041 */ GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(170098), // Rule ID 346 //
     /*  170046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  170049 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170052 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170059 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170077 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10140>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170080 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170092 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170096 */   GIR_RootConstrainSelectedInstOperands,
     /*  170097 */   // GIR_Coverage, 346,
     /*  170097 */   GIR_EraseRootFromParent_Done,
     /*  170098 */ // Label 3227: @170098
     /*  170098 */ GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(170155), // Rule ID 348 //
     /*  170103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  170106 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170109 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170116 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170123 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170127 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170134 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10142>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170137 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170149 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170153 */   GIR_RootConstrainSelectedInstOperands,
     /*  170154 */   // GIR_Coverage, 348,
     /*  170154 */   GIR_EraseRootFromParent_Done,
     /*  170155 */ // Label 3228: @170155
     /*  170155 */ GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(170212), // Rule ID 350 //
     /*  170160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  170163 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170173 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170184 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170191 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10144>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170194 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170206 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170210 */   GIR_RootConstrainSelectedInstOperands,
     /*  170211 */   // GIR_Coverage, 350,
     /*  170211 */   GIR_EraseRootFromParent_Done,
     /*  170212 */ // Label 3229: @170212
     /*  170212 */ GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(170266), // Rule ID 65454 //
     /*  170217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  170220 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170223 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170234 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170238 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170245 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170248 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170264 */   GIR_RootConstrainSelectedInstOperands,
     /*  170265 */   // GIR_Coverage, 65454,
     /*  170265 */   GIR_EraseRootFromParent_Done,
     /*  170266 */ // Label 3230: @170266
     /*  170266 */ GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(170320), // Rule ID 65455 //
     /*  170271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  170274 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170277 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170288 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170292 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170299 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170302 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170314 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170318 */   GIR_RootConstrainSelectedInstOperands,
     /*  170319 */   // GIR_Coverage, 65455,
     /*  170319 */   GIR_EraseRootFromParent_Done,
     /*  170320 */ // Label 3231: @170320
     /*  170320 */ GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(170378), // Rule ID 257 //
     /*  170325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  170328 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170331 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170335 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170346 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170350 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170357 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170360 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170362 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170372 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170376 */   GIR_RootConstrainSelectedInstOperands,
     /*  170377 */   // GIR_Coverage, 257,
     /*  170377 */   GIR_EraseRootFromParent_Done,
     /*  170378 */ // Label 3232: @170378
     /*  170378 */ GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(170436), // Rule ID 259 //
     /*  170383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  170386 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170389 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170393 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170404 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170408 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170415 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170418 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170434 */   GIR_RootConstrainSelectedInstOperands,
     /*  170435 */   // GIR_Coverage, 259,
     /*  170435 */   GIR_EraseRootFromParent_Done,
     /*  170436 */ // Label 3233: @170436
     /*  170436 */ GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(170487), // Rule ID 260 //
     /*  170441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  170444 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170447 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170455 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170459 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170466 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170469 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170485 */   GIR_RootConstrainSelectedInstOperands,
     /*  170486 */   // GIR_Coverage, 260,
     /*  170486 */   GIR_EraseRootFromParent_Done,
     /*  170487 */ // Label 3234: @170487
     /*  170487 */ GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(170538), // Rule ID 261 //
     /*  170492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  170495 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170498 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170506 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170510 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170517 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170520 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170536 */   GIR_RootConstrainSelectedInstOperands,
     /*  170537 */   // GIR_Coverage, 261,
     /*  170537 */   GIR_EraseRootFromParent_Done,
     /*  170538 */ // Label 3235: @170538
     /*  170538 */ GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(170589), // Rule ID 1447 //
     /*  170543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  170546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170549 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  170557 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170561 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170568 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  170571 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170583 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170587 */   GIR_RootConstrainSelectedInstOperands,
     /*  170588 */   // GIR_Coverage, 1447,
     /*  170588 */   GIR_EraseRootFromParent_Done,
     /*  170589 */ // Label 3236: @170589
     /*  170589 */ GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(170640), // Rule ID 1448 //
     /*  170594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  170597 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170600 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  170608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170619 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  170622 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170634 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170638 */   GIR_RootConstrainSelectedInstOperands,
     /*  170639 */   // GIR_Coverage, 1448,
     /*  170639 */   GIR_EraseRootFromParent_Done,
     /*  170640 */ // Label 3237: @170640
     /*  170640 */ GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(170691), // Rule ID 1453 //
     /*  170645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  170648 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170651 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  170659 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170663 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170670 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  170673 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170685 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170689 */   GIR_RootConstrainSelectedInstOperands,
     /*  170690 */   // GIR_Coverage, 1453,
     /*  170690 */   GIR_EraseRootFromParent_Done,
     /*  170691 */ // Label 3238: @170691
     /*  170691 */ GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(170742), // Rule ID 1454 //
     /*  170696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  170699 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170702 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  170710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170714 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170721 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  170724 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170736 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170740 */   GIR_RootConstrainSelectedInstOperands,
     /*  170741 */   // GIR_Coverage, 1454,
     /*  170741 */   GIR_EraseRootFromParent_Done,
     /*  170742 */ // Label 3239: @170742
     /*  170742 */ GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(170800), // Rule ID 65460 //
     /*  170747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  170750 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170753 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170757 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170768 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170772 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170779 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170782 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170794 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170798 */   GIR_RootConstrainSelectedInstOperands,
     /*  170799 */   // GIR_Coverage, 65460,
     /*  170799 */   GIR_EraseRootFromParent_Done,
     /*  170800 */ // Label 3240: @170800
     /*  170800 */ GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(170858), // Rule ID 65461 //
     /*  170805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  170808 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170811 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170815 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170826 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170830 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170837 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170840 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170856 */   GIR_RootConstrainSelectedInstOperands,
     /*  170857 */   // GIR_Coverage, 65461,
     /*  170857 */   GIR_EraseRootFromParent_Done,
     /*  170858 */ // Label 3241: @170858
     /*  170858 */ GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(170916), // Rule ID 65462 //
     /*  170863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  170866 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170869 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170873 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170888 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170895 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170898 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170914 */   GIR_RootConstrainSelectedInstOperands,
     /*  170915 */   // GIR_Coverage, 65462,
     /*  170915 */   GIR_EraseRootFromParent_Done,
     /*  170916 */ // Label 3242: @170916
     /*  170916 */ GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(170974), // Rule ID 65463 //
     /*  170921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  170924 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170927 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170931 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170946 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170953 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170956 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170968 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170972 */   GIR_RootConstrainSelectedInstOperands,
     /*  170973 */   // GIR_Coverage, 65463,
     /*  170973 */   GIR_EraseRootFromParent_Done,
     /*  170974 */ // Label 3243: @170974
     /*  170974 */ GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(171020), // Rule ID 1126 //
     /*  170979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170982 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170985 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170992 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170999 */   // MIs[0] rs1
     /*  170999 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171007 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10644>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  171010 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171012 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171018 */   GIR_RootConstrainSelectedInstOperands,
     /*  171019 */   // GIR_Coverage, 1126,
     /*  171019 */   GIR_EraseRootFromParent_Done,
     /*  171020 */ // Label 3244: @171020
     /*  171020 */ GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(171066), // Rule ID 1128 //
     /*  171025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  171028 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171031 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171038 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171045 */   // MIs[0] rs1
     /*  171045 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171053 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10646>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  171056 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171058 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171060 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171064 */   GIR_RootConstrainSelectedInstOperands,
     /*  171065 */   // GIR_Coverage, 1128,
     /*  171065 */   GIR_EraseRootFromParent_Done,
     /*  171066 */ // Label 3245: @171066
     /*  171066 */ GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(171112), // Rule ID 1130 //
     /*  171071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  171074 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171077 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171084 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171091 */   // MIs[0] rs1
     /*  171091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171099 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10648>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  171102 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171104 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171106 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171110 */   GIR_RootConstrainSelectedInstOperands,
     /*  171111 */   // GIR_Coverage, 1130,
     /*  171111 */   GIR_EraseRootFromParent_Done,
     /*  171112 */ // Label 3246: @171112
     /*  171112 */ GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(171158), // Rule ID 1132 //
     /*  171117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  171120 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171123 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171130 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171137 */   // MIs[0] rs1
     /*  171137 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171145 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10650>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  171148 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171150 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171156 */   GIR_RootConstrainSelectedInstOperands,
     /*  171157 */   // GIR_Coverage, 1132,
     /*  171157 */   GIR_EraseRootFromParent_Done,
     /*  171158 */ // Label 3247: @171158
     /*  171158 */ GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(171204), // Rule ID 1134 //
     /*  171163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  171166 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171169 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171176 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171183 */   // MIs[0] rs1
     /*  171183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171191 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10652>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  171194 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171196 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171198 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171202 */   GIR_RootConstrainSelectedInstOperands,
     /*  171203 */   // GIR_Coverage, 1134,
     /*  171203 */   GIR_EraseRootFromParent_Done,
     /*  171204 */ // Label 3248: @171204
     /*  171204 */ GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(171250), // Rule ID 1136 //
     /*  171209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  171212 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171215 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171222 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171229 */   // MIs[0] rs1
     /*  171229 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171237 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10654>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  171240 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171242 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171244 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171248 */   GIR_RootConstrainSelectedInstOperands,
     /*  171249 */   // GIR_Coverage, 1136,
     /*  171249 */   GIR_EraseRootFromParent_Done,
     /*  171250 */ // Label 3249: @171250
     /*  171250 */ GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(171296), // Rule ID 1154 //
     /*  171255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  171258 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171261 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171268 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171275 */   // MIs[0] rs1
     /*  171275 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171283 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10668>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  171286 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171288 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171294 */   GIR_RootConstrainSelectedInstOperands,
     /*  171295 */   // GIR_Coverage, 1154,
     /*  171295 */   GIR_EraseRootFromParent_Done,
     /*  171296 */ // Label 3250: @171296
     /*  171296 */ GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(171342), // Rule ID 1156 //
     /*  171301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  171304 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171307 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171314 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171321 */   // MIs[0] rs1
     /*  171321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171329 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10670>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  171332 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171334 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171336 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171340 */   GIR_RootConstrainSelectedInstOperands,
     /*  171341 */   // GIR_Coverage, 1156,
     /*  171341 */   GIR_EraseRootFromParent_Done,
     /*  171342 */ // Label 3251: @171342
     /*  171342 */ GIM_Reject,
     /*  171343 */ // Label 3178: @171343
     /*  171343 */ GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(171400), // Rule ID 345 //
     /*  171348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171351 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171354 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171361 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171379 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10140>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  171382 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171398 */   GIR_RootConstrainSelectedInstOperands,
     /*  171399 */   // GIR_Coverage, 345,
     /*  171399 */   GIR_EraseRootFromParent_Done,
     /*  171400 */ // Label 3252: @171400
     /*  171400 */ GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(171457), // Rule ID 347 //
     /*  171405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171408 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171411 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171418 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171425 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171429 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171436 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10142>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171439 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171451 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171455 */   GIR_RootConstrainSelectedInstOperands,
     /*  171456 */   // GIR_Coverage, 347,
     /*  171456 */   GIR_EraseRootFromParent_Done,
     /*  171457 */ // Label 3253: @171457
     /*  171457 */ GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(171514), // Rule ID 349 //
     /*  171462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171465 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171475 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171482 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171486 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171493 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10144>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  171496 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171508 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171512 */   GIR_RootConstrainSelectedInstOperands,
     /*  171513 */   // GIR_Coverage, 349,
     /*  171513 */   GIR_EraseRootFromParent_Done,
     /*  171514 */ // Label 3254: @171514
     /*  171514 */ GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(171571), // Rule ID 360 //
     /*  171519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  171522 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171525 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171532 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171543 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171550 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10154>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171553 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171569 */   GIR_RootConstrainSelectedInstOperands,
     /*  171570 */   // GIR_Coverage, 360,
     /*  171570 */   GIR_EraseRootFromParent_Done,
     /*  171571 */ // Label 3255: @171571
     /*  171571 */ GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(171629), // Rule ID 256 //
     /*  171576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  171579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171582 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171608 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  171611 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171627 */   GIR_RootConstrainSelectedInstOperands,
     /*  171628 */   // GIR_Coverage, 256,
     /*  171628 */   GIR_EraseRootFromParent_Done,
     /*  171629 */ // Label 3256: @171629
     /*  171629 */ GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(171687), // Rule ID 258 //
     /*  171634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  171637 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171640 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171644 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171655 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171666 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171669 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171681 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171685 */   GIR_RootConstrainSelectedInstOperands,
     /*  171686 */   // GIR_Coverage, 258,
     /*  171686 */   GIR_EraseRootFromParent_Done,
     /*  171687 */ // Label 3257: @171687
     /*  171687 */ GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(171745), // Rule ID 297 //
     /*  171692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  171695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171698 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171702 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171713 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171717 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171724 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  171727 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171739 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171743 */   GIR_RootConstrainSelectedInstOperands,
     /*  171744 */   // GIR_Coverage, 297,
     /*  171744 */   GIR_EraseRootFromParent_Done,
     /*  171745 */ // Label 3258: @171745
     /*  171745 */ GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(171796), // Rule ID 298 //
     /*  171750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  171753 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171756 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171764 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171768 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171775 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171778 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171790 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171794 */   GIR_RootConstrainSelectedInstOperands,
     /*  171795 */   // GIR_Coverage, 298,
     /*  171795 */   GIR_EraseRootFromParent_Done,
     /*  171796 */ // Label 3259: @171796
     /*  171796 */ GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(171847), // Rule ID 1845 //
     /*  171801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  171804 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171807 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  171815 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171819 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171826 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  171829 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171841 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171845 */   GIR_RootConstrainSelectedInstOperands,
     /*  171846 */   // GIR_Coverage, 1845,
     /*  171846 */   GIR_EraseRootFromParent_Done,
     /*  171847 */ // Label 3260: @171847
     /*  171847 */ GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(171898), // Rule ID 1846 //
     /*  171852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  171855 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171858 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  171866 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171870 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171877 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  171880 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171892 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171896 */   GIR_RootConstrainSelectedInstOperands,
     /*  171897 */   // GIR_Coverage, 1846,
     /*  171897 */   GIR_EraseRootFromParent_Done,
     /*  171898 */ // Label 3261: @171898
     /*  171898 */ GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(171949), // Rule ID 1849 //
     /*  171903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  171906 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171909 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171917 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171921 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171928 */   // (st GPR:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171931 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171943 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171947 */   GIR_RootConstrainSelectedInstOperands,
     /*  171948 */   // GIR_Coverage, 1849,
     /*  171948 */   GIR_EraseRootFromParent_Done,
     /*  171949 */ // Label 3262: @171949
     /*  171949 */ GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(172000), // Rule ID 1854 //
     /*  171954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0),
     /*  171957 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171960 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  171968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171972 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171979 */   // (st GPRPair:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD_RV32 GPRPair:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RV32),
     /*  171982 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171994 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171998 */   GIR_RootConstrainSelectedInstOperands,
     /*  171999 */   // GIR_Coverage, 1854,
     /*  171999 */   GIR_EraseRootFromParent_Done,
     /*  172000 */ // Label 3263: @172000
     /*  172000 */ GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(172051), // Rule ID 1855 //
     /*  172005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1),
     /*  172008 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172011 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  172019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  172023 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  172030 */   // (st GPRPair:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD_RV32 GPRPair:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  172030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RV32),
     /*  172033 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  172040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  172045 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172049 */   GIR_RootConstrainSelectedInstOperands,
     /*  172050 */   // GIR_Coverage, 1855,
     /*  172050 */   GIR_EraseRootFromParent_Done,
     /*  172051 */ // Label 3264: @172051
     /*  172051 */ GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(172097), // Rule ID 1125 //
     /*  172056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  172059 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172062 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172069 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  172072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172076 */   // MIs[0] rs1
     /*  172076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172084 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10644>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  172087 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172089 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172095 */   GIR_RootConstrainSelectedInstOperands,
     /*  172096 */   // GIR_Coverage, 1125,
     /*  172096 */   GIR_EraseRootFromParent_Done,
     /*  172097 */ // Label 3265: @172097
     /*  172097 */ GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(172143), // Rule ID 1127 //
     /*  172102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  172105 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172108 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  172118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172122 */   // MIs[0] rs1
     /*  172122 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172130 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10646>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  172133 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172135 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172137 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172141 */   GIR_RootConstrainSelectedInstOperands,
     /*  172142 */   // GIR_Coverage, 1127,
     /*  172142 */   GIR_EraseRootFromParent_Done,
     /*  172143 */ // Label 3266: @172143
     /*  172143 */ GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(172189), // Rule ID 1129 //
     /*  172148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  172151 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172154 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  172161 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  172164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172168 */   // MIs[0] rs1
     /*  172168 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172176 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10648>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  172179 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172181 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172183 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172187 */   GIR_RootConstrainSelectedInstOperands,
     /*  172188 */   // GIR_Coverage, 1129,
     /*  172188 */   GIR_EraseRootFromParent_Done,
     /*  172189 */ // Label 3267: @172189
     /*  172189 */ GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(172235), // Rule ID 1131 //
     /*  172194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  172197 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172200 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  172207 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  172210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172214 */   // MIs[0] rs1
     /*  172214 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172222 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10650>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  172225 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172227 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172229 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172233 */   GIR_RootConstrainSelectedInstOperands,
     /*  172234 */   // GIR_Coverage, 1131,
     /*  172234 */   GIR_EraseRootFromParent_Done,
     /*  172235 */ // Label 3268: @172235
     /*  172235 */ GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(172281), // Rule ID 1133 //
     /*  172240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  172243 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172246 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  172253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  172256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172260 */   // MIs[0] rs1
     /*  172260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172268 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10652>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  172271 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172273 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172275 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172279 */   GIR_RootConstrainSelectedInstOperands,
     /*  172280 */   // GIR_Coverage, 1133,
     /*  172280 */   GIR_EraseRootFromParent_Done,
     /*  172281 */ // Label 3269: @172281
     /*  172281 */ GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(172327), // Rule ID 1135 //
     /*  172286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  172289 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172292 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  172299 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  172302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172306 */   // MIs[0] rs1
     /*  172306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172314 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10654>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  172317 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172319 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172321 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172325 */   GIR_RootConstrainSelectedInstOperands,
     /*  172326 */   // GIR_Coverage, 1135,
     /*  172326 */   GIR_EraseRootFromParent_Done,
     /*  172327 */ // Label 3270: @172327
     /*  172327 */ GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(172373), // Rule ID 1153 //
     /*  172332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  172335 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172338 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  172345 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  172348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172352 */   // MIs[0] rs1
     /*  172352 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172360 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10668>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  172363 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172365 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172371 */   GIR_RootConstrainSelectedInstOperands,
     /*  172372 */   // GIR_Coverage, 1153,
     /*  172372 */   GIR_EraseRootFromParent_Done,
     /*  172373 */ // Label 3271: @172373
     /*  172373 */ GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(172419), // Rule ID 1155 //
     /*  172378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  172381 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172384 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  172391 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  172394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172398 */   // MIs[0] rs1
     /*  172398 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172406 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10670>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  172409 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172411 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172413 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172417 */   GIR_RootConstrainSelectedInstOperands,
     /*  172418 */   // GIR_Coverage, 1155,
     /*  172418 */   GIR_EraseRootFromParent_Done,
     /*  172419 */ // Label 3272: @172419
     /*  172419 */ GIM_Reject,
     /*  172420 */ // Label 3179: @172420
     /*  172420 */ GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(172499),
     /*  172425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172428 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172436 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  172440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172444 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(172471), // Rule ID 45756 //
     /*  172449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172452 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  172452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  172455 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172469 */     GIR_RootConstrainSelectedInstOperands,
     /*  172470 */     // GIR_Coverage, 45756,
     /*  172470 */     GIR_EraseRootFromParent_Done,
     /*  172471 */   // Label 3274: @172471
     /*  172471 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(172498), // Rule ID 45757 //
     /*  172476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172479 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  172479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  172482 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172496 */     GIR_RootConstrainSelectedInstOperands,
     /*  172497 */     // GIR_Coverage, 45757,
     /*  172497 */     GIR_EraseRootFromParent_Done,
     /*  172498 */   // Label 3275: @172498
     /*  172498 */   GIM_Reject,
     /*  172499 */ // Label 3273: @172499
     /*  172499 */ GIM_Reject,
     /*  172500 */ // Label 3180: @172500
     /*  172500 */ GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(172587),
     /*  172505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172516 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(172551), // Rule ID 45752 //
     /*  172521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172524 */     // MIs[0] rs1
     /*  172524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172532 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  172532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  172535 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172549 */     GIR_RootConstrainSelectedInstOperands,
     /*  172550 */     // GIR_Coverage, 45752,
     /*  172550 */     GIR_EraseRootFromParent_Done,
     /*  172551 */   // Label 3277: @172551
     /*  172551 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(172586), // Rule ID 45753 //
     /*  172556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172559 */     // MIs[0] rs1
     /*  172559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172567 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  172567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  172570 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172584 */     GIR_RootConstrainSelectedInstOperands,
     /*  172585 */     // GIR_Coverage, 45753,
     /*  172585 */     GIR_EraseRootFromParent_Done,
     /*  172586 */   // Label 3278: @172586
     /*  172586 */   GIM_Reject,
     /*  172587 */ // Label 3276: @172587
     /*  172587 */ GIM_Reject,
     /*  172588 */ // Label 3181: @172588
     /*  172588 */ GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(172745),
     /*  172593 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172596 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172604 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(172639), // Rule ID 45948 //
     /*  172609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172612 */     // MIs[0] rs1
     /*  172612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172620 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172623 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172637 */     GIR_RootConstrainSelectedInstOperands,
     /*  172638 */     // GIR_Coverage, 45948,
     /*  172638 */     GIR_EraseRootFromParent_Done,
     /*  172639 */   // Label 3280: @172639
     /*  172639 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(172674), // Rule ID 45949 //
     /*  172644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172647 */     // MIs[0] rs1
     /*  172647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172655 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172658 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172672 */     GIR_RootConstrainSelectedInstOperands,
     /*  172673 */     // GIR_Coverage, 45949,
     /*  172673 */     GIR_EraseRootFromParent_Done,
     /*  172674 */   // Label 3281: @172674
     /*  172674 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(172709), // Rule ID 46024 //
     /*  172679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  172682 */     // MIs[0] rs1
     /*  172682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172690 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172693 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172707 */     GIR_RootConstrainSelectedInstOperands,
     /*  172708 */     // GIR_Coverage, 46024,
     /*  172708 */     GIR_EraseRootFromParent_Done,
     /*  172709 */   // Label 3282: @172709
     /*  172709 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(172744), // Rule ID 46025 //
     /*  172714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  172717 */     // MIs[0] rs1
     /*  172717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172725 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172728 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172742 */     GIR_RootConstrainSelectedInstOperands,
     /*  172743 */     // GIR_Coverage, 46025,
     /*  172743 */     GIR_EraseRootFromParent_Done,
     /*  172744 */   // Label 3283: @172744
     /*  172744 */   GIM_Reject,
     /*  172745 */ // Label 3279: @172745
     /*  172745 */ GIM_Reject,
     /*  172746 */ // Label 3182: @172746
     /*  172746 */ GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(172903),
     /*  172751 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172754 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172762 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(172797), // Rule ID 45956 //
     /*  172767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172770 */     // MIs[0] rs1
     /*  172770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172778 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  172778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172781 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172795 */     GIR_RootConstrainSelectedInstOperands,
     /*  172796 */     // GIR_Coverage, 45956,
     /*  172796 */     GIR_EraseRootFromParent_Done,
     /*  172797 */   // Label 3285: @172797
     /*  172797 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(172832), // Rule ID 45957 //
     /*  172802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172805 */     // MIs[0] rs1
     /*  172805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172813 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  172813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172816 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172830 */     GIR_RootConstrainSelectedInstOperands,
     /*  172831 */     // GIR_Coverage, 45957,
     /*  172831 */     GIR_EraseRootFromParent_Done,
     /*  172832 */   // Label 3286: @172832
     /*  172832 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(172867), // Rule ID 46032 //
     /*  172837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  172840 */     // MIs[0] rs1
     /*  172840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172848 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  172848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172851 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172865 */     GIR_RootConstrainSelectedInstOperands,
     /*  172866 */     // GIR_Coverage, 46032,
     /*  172866 */     GIR_EraseRootFromParent_Done,
     /*  172867 */   // Label 3287: @172867
     /*  172867 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(172902), // Rule ID 46033 //
     /*  172872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  172875 */     // MIs[0] rs1
     /*  172875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172883 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  172883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172886 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172900 */     GIR_RootConstrainSelectedInstOperands,
     /*  172901 */     // GIR_Coverage, 46033,
     /*  172901 */     GIR_EraseRootFromParent_Done,
     /*  172902 */   // Label 3288: @172902
     /*  172902 */   GIM_Reject,
     /*  172903 */ // Label 3284: @172903
     /*  172903 */ GIM_Reject,
     /*  172904 */ // Label 3183: @172904
     /*  172904 */ GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(173061),
     /*  172909 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172912 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172920 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(172955), // Rule ID 45972 //
     /*  172925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  172928 */     // MIs[0] rs1
     /*  172928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172936 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  172936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172939 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172953 */     GIR_RootConstrainSelectedInstOperands,
     /*  172954 */     // GIR_Coverage, 45972,
     /*  172954 */     GIR_EraseRootFromParent_Done,
     /*  172955 */   // Label 3290: @172955
     /*  172955 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(172990), // Rule ID 45973 //
     /*  172960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  172963 */     // MIs[0] rs1
     /*  172963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172971 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  172971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172974 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172988 */     GIR_RootConstrainSelectedInstOperands,
     /*  172989 */     // GIR_Coverage, 45973,
     /*  172989 */     GIR_EraseRootFromParent_Done,
     /*  172990 */   // Label 3291: @172990
     /*  172990 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(173025), // Rule ID 46044 //
     /*  172995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  172998 */     // MIs[0] rs1
     /*  172998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173006 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  173009 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173023 */     GIR_RootConstrainSelectedInstOperands,
     /*  173024 */     // GIR_Coverage, 46044,
     /*  173024 */     GIR_EraseRootFromParent_Done,
     /*  173025 */   // Label 3292: @173025
     /*  173025 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(173060), // Rule ID 46045 //
     /*  173030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  173033 */     // MIs[0] rs1
     /*  173033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173041 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  173044 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173058 */     GIR_RootConstrainSelectedInstOperands,
     /*  173059 */     // GIR_Coverage, 46045,
     /*  173059 */     GIR_EraseRootFromParent_Done,
     /*  173060 */   // Label 3293: @173060
     /*  173060 */   GIM_Reject,
     /*  173061 */ // Label 3289: @173061
     /*  173061 */ GIM_Reject,
     /*  173062 */ // Label 3184: @173062
     /*  173062 */ GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(173141),
     /*  173067 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173070 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173078 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173086 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(173113), // Rule ID 46084 //
     /*  173091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173094 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  173094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  173097 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173111 */     GIR_RootConstrainSelectedInstOperands,
     /*  173112 */     // GIR_Coverage, 46084,
     /*  173112 */     GIR_EraseRootFromParent_Done,
     /*  173113 */   // Label 3295: @173113
     /*  173113 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(173140), // Rule ID 46085 //
     /*  173118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173121 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  173121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  173124 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173138 */     GIR_RootConstrainSelectedInstOperands,
     /*  173139 */     // GIR_Coverage, 46085,
     /*  173139 */     GIR_EraseRootFromParent_Done,
     /*  173140 */   // Label 3296: @173140
     /*  173140 */   GIM_Reject,
     /*  173141 */ // Label 3294: @173141
     /*  173141 */ GIM_Reject,
     /*  173142 */ // Label 3185: @173142
     /*  173142 */ GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(173229),
     /*  173147 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173150 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173158 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(173193), // Rule ID 45940 //
     /*  173163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173166 */     // MIs[0] rs1
     /*  173166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173174 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  173174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  173177 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173191 */     GIR_RootConstrainSelectedInstOperands,
     /*  173192 */     // GIR_Coverage, 45940,
     /*  173192 */     GIR_EraseRootFromParent_Done,
     /*  173193 */   // Label 3298: @173193
     /*  173193 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(173228), // Rule ID 45941 //
     /*  173198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173201 */     // MIs[0] rs1
     /*  173201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173209 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  173209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  173212 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173226 */     GIR_RootConstrainSelectedInstOperands,
     /*  173227 */     // GIR_Coverage, 45941,
     /*  173227 */     GIR_EraseRootFromParent_Done,
     /*  173228 */   // Label 3299: @173228
     /*  173228 */   GIM_Reject,
     /*  173229 */ // Label 3297: @173229
     /*  173229 */ GIM_Reject,
     /*  173230 */ // Label 3186: @173230
     /*  173230 */ GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(173387),
     /*  173235 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173246 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(173281), // Rule ID 45952 //
     /*  173251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173254 */     // MIs[0] rs1
     /*  173254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173262 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  173265 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173279 */     GIR_RootConstrainSelectedInstOperands,
     /*  173280 */     // GIR_Coverage, 45952,
     /*  173280 */     GIR_EraseRootFromParent_Done,
     /*  173281 */   // Label 3301: @173281
     /*  173281 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(173316), // Rule ID 45953 //
     /*  173286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173289 */     // MIs[0] rs1
     /*  173289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173297 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  173300 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173314 */     GIR_RootConstrainSelectedInstOperands,
     /*  173315 */     // GIR_Coverage, 45953,
     /*  173315 */     GIR_EraseRootFromParent_Done,
     /*  173316 */   // Label 3302: @173316
     /*  173316 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(173351), // Rule ID 46028 //
     /*  173321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  173324 */     // MIs[0] rs1
     /*  173324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173332 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  173335 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173349 */     GIR_RootConstrainSelectedInstOperands,
     /*  173350 */     // GIR_Coverage, 46028,
     /*  173350 */     GIR_EraseRootFromParent_Done,
     /*  173351 */   // Label 3303: @173351
     /*  173351 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(173386), // Rule ID 46029 //
     /*  173356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  173359 */     // MIs[0] rs1
     /*  173359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173367 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  173370 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173384 */     GIR_RootConstrainSelectedInstOperands,
     /*  173385 */     // GIR_Coverage, 46029,
     /*  173385 */     GIR_EraseRootFromParent_Done,
     /*  173386 */   // Label 3304: @173386
     /*  173386 */   GIM_Reject,
     /*  173387 */ // Label 3300: @173387
     /*  173387 */ GIM_Reject,
     /*  173388 */ // Label 3187: @173388
     /*  173388 */ GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(173545),
     /*  173393 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173396 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173404 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(173439), // Rule ID 45968 //
     /*  173409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173412 */     // MIs[0] rs1
     /*  173412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173420 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  173423 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173437 */     GIR_RootConstrainSelectedInstOperands,
     /*  173438 */     // GIR_Coverage, 45968,
     /*  173438 */     GIR_EraseRootFromParent_Done,
     /*  173439 */   // Label 3306: @173439
     /*  173439 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(173474), // Rule ID 45969 //
     /*  173444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173447 */     // MIs[0] rs1
     /*  173447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173455 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  173458 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173472 */     GIR_RootConstrainSelectedInstOperands,
     /*  173473 */     // GIR_Coverage, 45969,
     /*  173473 */     GIR_EraseRootFromParent_Done,
     /*  173474 */   // Label 3307: @173474
     /*  173474 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(173509), // Rule ID 46040 //
     /*  173479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  173482 */     // MIs[0] rs1
     /*  173482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173490 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  173493 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173507 */     GIR_RootConstrainSelectedInstOperands,
     /*  173508 */     // GIR_Coverage, 46040,
     /*  173508 */     GIR_EraseRootFromParent_Done,
     /*  173509 */   // Label 3308: @173509
     /*  173509 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(173544), // Rule ID 46041 //
     /*  173514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  173517 */     // MIs[0] rs1
     /*  173517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173525 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  173528 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173542 */     GIR_RootConstrainSelectedInstOperands,
     /*  173543 */     // GIR_Coverage, 46041,
     /*  173543 */     GIR_EraseRootFromParent_Done,
     /*  173544 */   // Label 3309: @173544
     /*  173544 */   GIM_Reject,
     /*  173545 */ // Label 3305: @173545
     /*  173545 */ GIM_Reject,
     /*  173546 */ // Label 3188: @173546
     /*  173546 */ GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(173703),
     /*  173551 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173554 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  173562 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(173597), // Rule ID 46012 //
     /*  173567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  173570 */     // MIs[0] rs1
     /*  173570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173578 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173581 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173595 */     GIR_RootConstrainSelectedInstOperands,
     /*  173596 */     // GIR_Coverage, 46012,
     /*  173596 */     GIR_EraseRootFromParent_Done,
     /*  173597 */   // Label 3311: @173597
     /*  173597 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(173632), // Rule ID 46013 //
     /*  173602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  173605 */     // MIs[0] rs1
     /*  173605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173613 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173616 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173630 */     GIR_RootConstrainSelectedInstOperands,
     /*  173631 */     // GIR_Coverage, 46013,
     /*  173631 */     GIR_EraseRootFromParent_Done,
     /*  173632 */   // Label 3312: @173632
     /*  173632 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(173667), // Rule ID 46072 //
     /*  173637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  173640 */     // MIs[0] rs1
     /*  173640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173648 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173651 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173665 */     GIR_RootConstrainSelectedInstOperands,
     /*  173666 */     // GIR_Coverage, 46072,
     /*  173666 */     GIR_EraseRootFromParent_Done,
     /*  173667 */   // Label 3313: @173667
     /*  173667 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(173702), // Rule ID 46073 //
     /*  173672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  173675 */     // MIs[0] rs1
     /*  173675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173683 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173686 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173700 */     GIR_RootConstrainSelectedInstOperands,
     /*  173701 */     // GIR_Coverage, 46073,
     /*  173701 */     GIR_EraseRootFromParent_Done,
     /*  173702 */   // Label 3314: @173702
     /*  173702 */   GIM_Reject,
     /*  173703 */ // Label 3310: @173703
     /*  173703 */ GIM_Reject,
     /*  173704 */ // Label 3189: @173704
     /*  173704 */ GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(173783),
     /*  173709 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173712 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173720 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173728 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(173755), // Rule ID 46088 //
     /*  173733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173736 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  173736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  173739 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173753 */     GIR_RootConstrainSelectedInstOperands,
     /*  173754 */     // GIR_Coverage, 46088,
     /*  173754 */     GIR_EraseRootFromParent_Done,
     /*  173755 */   // Label 3316: @173755
     /*  173755 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(173782), // Rule ID 46089 //
     /*  173760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173763 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  173763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  173766 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173780 */     GIR_RootConstrainSelectedInstOperands,
     /*  173781 */     // GIR_Coverage, 46089,
     /*  173781 */     GIR_EraseRootFromParent_Done,
     /*  173782 */   // Label 3317: @173782
     /*  173782 */   GIM_Reject,
     /*  173783 */ // Label 3315: @173783
     /*  173783 */ GIM_Reject,
     /*  173784 */ // Label 3190: @173784
     /*  173784 */ GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(173871),
     /*  173789 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173800 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(173835), // Rule ID 45944 //
     /*  173805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173808 */     // MIs[0] rs1
     /*  173808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173816 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  173816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  173819 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173833 */     GIR_RootConstrainSelectedInstOperands,
     /*  173834 */     // GIR_Coverage, 45944,
     /*  173834 */     GIR_EraseRootFromParent_Done,
     /*  173835 */   // Label 3319: @173835
     /*  173835 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(173870), // Rule ID 45945 //
     /*  173840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173843 */     // MIs[0] rs1
     /*  173843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173851 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  173851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  173854 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173868 */     GIR_RootConstrainSelectedInstOperands,
     /*  173869 */     // GIR_Coverage, 45945,
     /*  173869 */     GIR_EraseRootFromParent_Done,
     /*  173870 */   // Label 3320: @173870
     /*  173870 */   GIM_Reject,
     /*  173871 */ // Label 3318: @173871
     /*  173871 */ GIM_Reject,
     /*  173872 */ // Label 3191: @173872
     /*  173872 */ GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(174029),
     /*  173877 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173880 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173888 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(173923), // Rule ID 45964 //
     /*  173893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173896 */     // MIs[0] rs1
     /*  173896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173904 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173907 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173921 */     GIR_RootConstrainSelectedInstOperands,
     /*  173922 */     // GIR_Coverage, 45964,
     /*  173922 */     GIR_EraseRootFromParent_Done,
     /*  173923 */   // Label 3322: @173923
     /*  173923 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(173958), // Rule ID 45965 //
     /*  173928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173931 */     // MIs[0] rs1
     /*  173931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173939 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173942 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173956 */     GIR_RootConstrainSelectedInstOperands,
     /*  173957 */     // GIR_Coverage, 45965,
     /*  173957 */     GIR_EraseRootFromParent_Done,
     /*  173958 */   // Label 3323: @173958
     /*  173958 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(173993), // Rule ID 46036 //
     /*  173963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  173966 */     // MIs[0] rs1
     /*  173966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173974 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173977 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173991 */     GIR_RootConstrainSelectedInstOperands,
     /*  173992 */     // GIR_Coverage, 46036,
     /*  173992 */     GIR_EraseRootFromParent_Done,
     /*  173993 */   // Label 3324: @173993
     /*  173993 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(174028), // Rule ID 46037 //
     /*  173998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  174001 */     // MIs[0] rs1
     /*  174001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174009 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  174012 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174026 */     GIR_RootConstrainSelectedInstOperands,
     /*  174027 */     // GIR_Coverage, 46037,
     /*  174027 */     GIR_EraseRootFromParent_Done,
     /*  174028 */   // Label 3325: @174028
     /*  174028 */   GIM_Reject,
     /*  174029 */ // Label 3321: @174029
     /*  174029 */ GIM_Reject,
     /*  174030 */ // Label 3192: @174030
     /*  174030 */ GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(174187),
     /*  174035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174046 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(174081), // Rule ID 46000 //
     /*  174051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174054 */     // MIs[0] rs1
     /*  174054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174062 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  174065 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174079 */     GIR_RootConstrainSelectedInstOperands,
     /*  174080 */     // GIR_Coverage, 46000,
     /*  174080 */     GIR_EraseRootFromParent_Done,
     /*  174081 */   // Label 3327: @174081
     /*  174081 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(174116), // Rule ID 46001 //
     /*  174086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174089 */     // MIs[0] rs1
     /*  174089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174097 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  174100 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174114 */     GIR_RootConstrainSelectedInstOperands,
     /*  174115 */     // GIR_Coverage, 46001,
     /*  174115 */     GIR_EraseRootFromParent_Done,
     /*  174116 */   // Label 3328: @174116
     /*  174116 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(174151), // Rule ID 46060 //
     /*  174121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  174124 */     // MIs[0] rs1
     /*  174124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174132 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  174135 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174149 */     GIR_RootConstrainSelectedInstOperands,
     /*  174150 */     // GIR_Coverage, 46060,
     /*  174150 */     GIR_EraseRootFromParent_Done,
     /*  174151 */   // Label 3329: @174151
     /*  174151 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(174186), // Rule ID 46061 //
     /*  174156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  174159 */     // MIs[0] rs1
     /*  174159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174167 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  174170 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174184 */     GIR_RootConstrainSelectedInstOperands,
     /*  174185 */     // GIR_Coverage, 46061,
     /*  174185 */     GIR_EraseRootFromParent_Done,
     /*  174186 */   // Label 3330: @174186
     /*  174186 */   GIM_Reject,
     /*  174187 */ // Label 3326: @174187
     /*  174187 */ GIM_Reject,
     /*  174188 */ // Label 3193: @174188
     /*  174188 */ GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(174345),
     /*  174193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174196 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174204 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(174239), // Rule ID 46016 //
     /*  174209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  174212 */     // MIs[0] rs1
     /*  174212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174220 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  174220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  174223 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174237 */     GIR_RootConstrainSelectedInstOperands,
     /*  174238 */     // GIR_Coverage, 46016,
     /*  174238 */     GIR_EraseRootFromParent_Done,
     /*  174239 */   // Label 3332: @174239
     /*  174239 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(174274), // Rule ID 46017 //
     /*  174244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  174247 */     // MIs[0] rs1
     /*  174247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174255 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  174255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  174258 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174272 */     GIR_RootConstrainSelectedInstOperands,
     /*  174273 */     // GIR_Coverage, 46017,
     /*  174273 */     GIR_EraseRootFromParent_Done,
     /*  174274 */   // Label 3333: @174274
     /*  174274 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(174309), // Rule ID 46076 //
     /*  174279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  174282 */     // MIs[0] rs1
     /*  174282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174290 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  174290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  174293 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174307 */     GIR_RootConstrainSelectedInstOperands,
     /*  174308 */     // GIR_Coverage, 46076,
     /*  174308 */     GIR_EraseRootFromParent_Done,
     /*  174309 */   // Label 3334: @174309
     /*  174309 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(174344), // Rule ID 46077 //
     /*  174314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  174317 */     // MIs[0] rs1
     /*  174317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174325 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  174325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  174328 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174342 */     GIR_RootConstrainSelectedInstOperands,
     /*  174343 */     // GIR_Coverage, 46077,
     /*  174343 */     GIR_EraseRootFromParent_Done,
     /*  174344 */   // Label 3335: @174344
     /*  174344 */   GIM_Reject,
     /*  174345 */ // Label 3331: @174345
     /*  174345 */ GIM_Reject,
     /*  174346 */ // Label 3194: @174346
     /*  174346 */ GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(174425),
     /*  174351 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174354 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174362 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174370 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(174397), // Rule ID 46092 //
     /*  174375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174378 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  174378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  174381 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174395 */     GIR_RootConstrainSelectedInstOperands,
     /*  174396 */     // GIR_Coverage, 46092,
     /*  174396 */     GIR_EraseRootFromParent_Done,
     /*  174397 */   // Label 3337: @174397
     /*  174397 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(174424), // Rule ID 46093 //
     /*  174402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174405 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  174405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  174408 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174422 */     GIR_RootConstrainSelectedInstOperands,
     /*  174423 */     // GIR_Coverage, 46093,
     /*  174423 */     GIR_EraseRootFromParent_Done,
     /*  174424 */   // Label 3338: @174424
     /*  174424 */   GIM_Reject,
     /*  174425 */ // Label 3336: @174425
     /*  174425 */ GIM_Reject,
     /*  174426 */ // Label 3195: @174426
     /*  174426 */ GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(174513),
     /*  174431 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174434 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174442 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(174477), // Rule ID 45960 //
     /*  174447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174450 */     // MIs[0] rs1
     /*  174450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174458 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  174458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  174461 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174475 */     GIR_RootConstrainSelectedInstOperands,
     /*  174476 */     // GIR_Coverage, 45960,
     /*  174476 */     GIR_EraseRootFromParent_Done,
     /*  174477 */   // Label 3340: @174477
     /*  174477 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(174512), // Rule ID 45961 //
     /*  174482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174485 */     // MIs[0] rs1
     /*  174485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174493 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  174493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  174496 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174510 */     GIR_RootConstrainSelectedInstOperands,
     /*  174511 */     // GIR_Coverage, 45961,
     /*  174511 */     GIR_EraseRootFromParent_Done,
     /*  174512 */   // Label 3341: @174512
     /*  174512 */   GIM_Reject,
     /*  174513 */ // Label 3339: @174513
     /*  174513 */ GIM_Reject,
     /*  174514 */ // Label 3196: @174514
     /*  174514 */ GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(174671),
     /*  174519 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174522 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174530 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(174565), // Rule ID 45988 //
     /*  174535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174538 */     // MIs[0] rs1
     /*  174538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174546 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174549 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174563 */     GIR_RootConstrainSelectedInstOperands,
     /*  174564 */     // GIR_Coverage, 45988,
     /*  174564 */     GIR_EraseRootFromParent_Done,
     /*  174565 */   // Label 3343: @174565
     /*  174565 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(174600), // Rule ID 45989 //
     /*  174570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174573 */     // MIs[0] rs1
     /*  174573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174581 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174584 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174598 */     GIR_RootConstrainSelectedInstOperands,
     /*  174599 */     // GIR_Coverage, 45989,
     /*  174599 */     GIR_EraseRootFromParent_Done,
     /*  174600 */   // Label 3344: @174600
     /*  174600 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(174635), // Rule ID 46048 //
     /*  174605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  174608 */     // MIs[0] rs1
     /*  174608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174616 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174619 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174633 */     GIR_RootConstrainSelectedInstOperands,
     /*  174634 */     // GIR_Coverage, 46048,
     /*  174634 */     GIR_EraseRootFromParent_Done,
     /*  174635 */   // Label 3345: @174635
     /*  174635 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(174670), // Rule ID 46049 //
     /*  174640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  174643 */     // MIs[0] rs1
     /*  174643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174651 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174654 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174668 */     GIR_RootConstrainSelectedInstOperands,
     /*  174669 */     // GIR_Coverage, 46049,
     /*  174669 */     GIR_EraseRootFromParent_Done,
     /*  174670 */   // Label 3346: @174670
     /*  174670 */   GIM_Reject,
     /*  174671 */ // Label 3342: @174671
     /*  174671 */ GIM_Reject,
     /*  174672 */ // Label 3197: @174672
     /*  174672 */ GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(174829),
     /*  174677 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174680 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174688 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(174723), // Rule ID 46004 //
     /*  174693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174696 */     // MIs[0] rs1
     /*  174696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174704 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174707 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174721 */     GIR_RootConstrainSelectedInstOperands,
     /*  174722 */     // GIR_Coverage, 46004,
     /*  174722 */     GIR_EraseRootFromParent_Done,
     /*  174723 */   // Label 3348: @174723
     /*  174723 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(174758), // Rule ID 46005 //
     /*  174728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174731 */     // MIs[0] rs1
     /*  174731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174739 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174742 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174756 */     GIR_RootConstrainSelectedInstOperands,
     /*  174757 */     // GIR_Coverage, 46005,
     /*  174757 */     GIR_EraseRootFromParent_Done,
     /*  174758 */   // Label 3349: @174758
     /*  174758 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(174793), // Rule ID 46064 //
     /*  174763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  174766 */     // MIs[0] rs1
     /*  174766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174774 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174777 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174791 */     GIR_RootConstrainSelectedInstOperands,
     /*  174792 */     // GIR_Coverage, 46064,
     /*  174792 */     GIR_EraseRootFromParent_Done,
     /*  174793 */   // Label 3350: @174793
     /*  174793 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(174828), // Rule ID 46065 //
     /*  174798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  174801 */     // MIs[0] rs1
     /*  174801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174809 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174812 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174826 */     GIR_RootConstrainSelectedInstOperands,
     /*  174827 */     // GIR_Coverage, 46065,
     /*  174827 */     GIR_EraseRootFromParent_Done,
     /*  174828 */   // Label 3351: @174828
     /*  174828 */   GIM_Reject,
     /*  174829 */ // Label 3347: @174829
     /*  174829 */ GIM_Reject,
     /*  174830 */ // Label 3198: @174830
     /*  174830 */ GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(174987),
     /*  174835 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174838 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174846 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(174881), // Rule ID 46020 //
     /*  174851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  174854 */     // MIs[0] rs1
     /*  174854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174862 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  174862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174865 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174879 */     GIR_RootConstrainSelectedInstOperands,
     /*  174880 */     // GIR_Coverage, 46020,
     /*  174880 */     GIR_EraseRootFromParent_Done,
     /*  174881 */   // Label 3353: @174881
     /*  174881 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(174916), // Rule ID 46021 //
     /*  174886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  174889 */     // MIs[0] rs1
     /*  174889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174897 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  174897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174900 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174914 */     GIR_RootConstrainSelectedInstOperands,
     /*  174915 */     // GIR_Coverage, 46021,
     /*  174915 */     GIR_EraseRootFromParent_Done,
     /*  174916 */   // Label 3354: @174916
     /*  174916 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(174951), // Rule ID 46080 //
     /*  174921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  174924 */     // MIs[0] rs1
     /*  174924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174932 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  174932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174935 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174949 */     GIR_RootConstrainSelectedInstOperands,
     /*  174950 */     // GIR_Coverage, 46080,
     /*  174950 */     GIR_EraseRootFromParent_Done,
     /*  174951 */   // Label 3355: @174951
     /*  174951 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(174986), // Rule ID 46081 //
     /*  174956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  174959 */     // MIs[0] rs1
     /*  174959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174967 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  174967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174970 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174984 */     GIR_RootConstrainSelectedInstOperands,
     /*  174985 */     // GIR_Coverage, 46081,
     /*  174985 */     GIR_EraseRootFromParent_Done,
     /*  174986 */   // Label 3356: @174986
     /*  174986 */   GIM_Reject,
     /*  174987 */ // Label 3352: @174987
     /*  174987 */ GIM_Reject,
     /*  174988 */ // Label 3199: @174988
     /*  174988 */ GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(175067),
     /*  174993 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174996 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175012 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(175039), // Rule ID 46096 //
     /*  175017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175020 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  175020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  175023 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175037 */     GIR_RootConstrainSelectedInstOperands,
     /*  175038 */     // GIR_Coverage, 46096,
     /*  175038 */     GIR_EraseRootFromParent_Done,
     /*  175039 */   // Label 3358: @175039
     /*  175039 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(175066), // Rule ID 46097 //
     /*  175044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175047 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  175047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  175050 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175064 */     GIR_RootConstrainSelectedInstOperands,
     /*  175065 */     // GIR_Coverage, 46097,
     /*  175065 */     GIR_EraseRootFromParent_Done,
     /*  175066 */   // Label 3359: @175066
     /*  175066 */   GIM_Reject,
     /*  175067 */ // Label 3357: @175067
     /*  175067 */ GIM_Reject,
     /*  175068 */ // Label 3200: @175068
     /*  175068 */ GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(175155),
     /*  175073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175076 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  175084 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(175119), // Rule ID 45976 //
     /*  175089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175092 */     // MIs[0] rs1
     /*  175092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175100 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  175100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  175103 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175117 */     GIR_RootConstrainSelectedInstOperands,
     /*  175118 */     // GIR_Coverage, 45976,
     /*  175118 */     GIR_EraseRootFromParent_Done,
     /*  175119 */   // Label 3361: @175119
     /*  175119 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(175154), // Rule ID 45977 //
     /*  175124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175127 */     // MIs[0] rs1
     /*  175127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175135 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  175135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  175138 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175152 */     GIR_RootConstrainSelectedInstOperands,
     /*  175153 */     // GIR_Coverage, 45977,
     /*  175153 */     GIR_EraseRootFromParent_Done,
     /*  175154 */   // Label 3362: @175154
     /*  175154 */   GIM_Reject,
     /*  175155 */ // Label 3360: @175155
     /*  175155 */ GIM_Reject,
     /*  175156 */ // Label 3201: @175156
     /*  175156 */ GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(175313),
     /*  175161 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175164 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  175172 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(175207), // Rule ID 45992 //
     /*  175177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175180 */     // MIs[0] rs1
     /*  175180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175188 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  175191 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175205 */     GIR_RootConstrainSelectedInstOperands,
     /*  175206 */     // GIR_Coverage, 45992,
     /*  175206 */     GIR_EraseRootFromParent_Done,
     /*  175207 */   // Label 3364: @175207
     /*  175207 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(175242), // Rule ID 45993 //
     /*  175212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175215 */     // MIs[0] rs1
     /*  175215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175223 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  175223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  175226 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175240 */     GIR_RootConstrainSelectedInstOperands,
     /*  175241 */     // GIR_Coverage, 45993,
     /*  175241 */     GIR_EraseRootFromParent_Done,
     /*  175242 */   // Label 3365: @175242
     /*  175242 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(175277), // Rule ID 46052 //
     /*  175247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  175250 */     // MIs[0] rs1
     /*  175250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175258 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  175261 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175275 */     GIR_RootConstrainSelectedInstOperands,
     /*  175276 */     // GIR_Coverage, 46052,
     /*  175276 */     GIR_EraseRootFromParent_Done,
     /*  175277 */   // Label 3366: @175277
     /*  175277 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(175312), // Rule ID 46053 //
     /*  175282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  175285 */     // MIs[0] rs1
     /*  175285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175293 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  175293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  175296 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175310 */     GIR_RootConstrainSelectedInstOperands,
     /*  175311 */     // GIR_Coverage, 46053,
     /*  175311 */     GIR_EraseRootFromParent_Done,
     /*  175312 */   // Label 3367: @175312
     /*  175312 */   GIM_Reject,
     /*  175313 */ // Label 3363: @175313
     /*  175313 */ GIM_Reject,
     /*  175314 */ // Label 3202: @175314
     /*  175314 */ GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(175471),
     /*  175319 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175322 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  175330 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(175365), // Rule ID 46008 //
     /*  175335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175338 */     // MIs[0] rs1
     /*  175338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175346 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  175346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  175349 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175363 */     GIR_RootConstrainSelectedInstOperands,
     /*  175364 */     // GIR_Coverage, 46008,
     /*  175364 */     GIR_EraseRootFromParent_Done,
     /*  175365 */   // Label 3369: @175365
     /*  175365 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(175400), // Rule ID 46009 //
     /*  175370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175373 */     // MIs[0] rs1
     /*  175373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175381 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  175381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  175384 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175398 */     GIR_RootConstrainSelectedInstOperands,
     /*  175399 */     // GIR_Coverage, 46009,
     /*  175399 */     GIR_EraseRootFromParent_Done,
     /*  175400 */   // Label 3370: @175400
     /*  175400 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(175435), // Rule ID 46068 //
     /*  175405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  175408 */     // MIs[0] rs1
     /*  175408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175416 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  175416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  175419 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175433 */     GIR_RootConstrainSelectedInstOperands,
     /*  175434 */     // GIR_Coverage, 46068,
     /*  175434 */     GIR_EraseRootFromParent_Done,
     /*  175435 */   // Label 3371: @175435
     /*  175435 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(175470), // Rule ID 46069 //
     /*  175440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  175443 */     // MIs[0] rs1
     /*  175443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175451 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  175451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  175454 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175468 */     GIR_RootConstrainSelectedInstOperands,
     /*  175469 */     // GIR_Coverage, 46069,
     /*  175469 */     GIR_EraseRootFromParent_Done,
     /*  175470 */   // Label 3372: @175470
     /*  175470 */   GIM_Reject,
     /*  175471 */ // Label 3368: @175471
     /*  175471 */ GIM_Reject,
     /*  175472 */ // Label 3203: @175472
     /*  175472 */ GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(175551),
     /*  175477 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175480 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175488 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175496 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(175523), // Rule ID 46100 //
     /*  175501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175504 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  175504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  175507 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175521 */     GIR_RootConstrainSelectedInstOperands,
     /*  175522 */     // GIR_Coverage, 46100,
     /*  175522 */     GIR_EraseRootFromParent_Done,
     /*  175523 */   // Label 3374: @175523
     /*  175523 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(175550), // Rule ID 46101 //
     /*  175528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175531 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  175531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  175534 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175548 */     GIR_RootConstrainSelectedInstOperands,
     /*  175549 */     // GIR_Coverage, 46101,
     /*  175549 */     GIR_EraseRootFromParent_Done,
     /*  175550 */   // Label 3375: @175550
     /*  175550 */   GIM_Reject,
     /*  175551 */ // Label 3373: @175551
     /*  175551 */ GIM_Reject,
     /*  175552 */ // Label 3204: @175552
     /*  175552 */ GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(175639),
     /*  175557 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175560 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  175568 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(175603), // Rule ID 45980 //
     /*  175573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175576 */     // MIs[0] rs1
     /*  175576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175584 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  175584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  175587 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175601 */     GIR_RootConstrainSelectedInstOperands,
     /*  175602 */     // GIR_Coverage, 45980,
     /*  175602 */     GIR_EraseRootFromParent_Done,
     /*  175603 */   // Label 3377: @175603
     /*  175603 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(175638), // Rule ID 45981 //
     /*  175608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175611 */     // MIs[0] rs1
     /*  175611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175619 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  175619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  175622 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175636 */     GIR_RootConstrainSelectedInstOperands,
     /*  175637 */     // GIR_Coverage, 45981,
     /*  175637 */     GIR_EraseRootFromParent_Done,
     /*  175638 */   // Label 3378: @175638
     /*  175638 */   GIM_Reject,
     /*  175639 */ // Label 3376: @175639
     /*  175639 */ GIM_Reject,
     /*  175640 */ // Label 3205: @175640
     /*  175640 */ GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(175797),
     /*  175645 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175648 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  175656 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(175691), // Rule ID 45996 //
     /*  175661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175664 */     // MIs[0] rs1
     /*  175664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175672 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175675 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175689 */     GIR_RootConstrainSelectedInstOperands,
     /*  175690 */     // GIR_Coverage, 45996,
     /*  175690 */     GIR_EraseRootFromParent_Done,
     /*  175691 */   // Label 3380: @175691
     /*  175691 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(175726), // Rule ID 45997 //
     /*  175696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175699 */     // MIs[0] rs1
     /*  175699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175707 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  175707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175710 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175724 */     GIR_RootConstrainSelectedInstOperands,
     /*  175725 */     // GIR_Coverage, 45997,
     /*  175725 */     GIR_EraseRootFromParent_Done,
     /*  175726 */   // Label 3381: @175726
     /*  175726 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(175761), // Rule ID 46056 //
     /*  175731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  175734 */     // MIs[0] rs1
     /*  175734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175742 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175745 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175759 */     GIR_RootConstrainSelectedInstOperands,
     /*  175760 */     // GIR_Coverage, 46056,
     /*  175760 */     GIR_EraseRootFromParent_Done,
     /*  175761 */   // Label 3382: @175761
     /*  175761 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(175796), // Rule ID 46057 //
     /*  175766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  175769 */     // MIs[0] rs1
     /*  175769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175777 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  175777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175780 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175794 */     GIR_RootConstrainSelectedInstOperands,
     /*  175795 */     // GIR_Coverage, 46057,
     /*  175795 */     GIR_EraseRootFromParent_Done,
     /*  175796 */   // Label 3383: @175796
     /*  175796 */   GIM_Reject,
     /*  175797 */ // Label 3379: @175797
     /*  175797 */ GIM_Reject,
     /*  175798 */ // Label 3206: @175798
     /*  175798 */ GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(175877),
     /*  175803 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175806 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175822 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(175849), // Rule ID 46104 //
     /*  175827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175830 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  175830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  175833 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175847 */     GIR_RootConstrainSelectedInstOperands,
     /*  175848 */     // GIR_Coverage, 46104,
     /*  175848 */     GIR_EraseRootFromParent_Done,
     /*  175849 */   // Label 3385: @175849
     /*  175849 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(175876), // Rule ID 46105 //
     /*  175854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175857 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  175857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  175860 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175874 */     GIR_RootConstrainSelectedInstOperands,
     /*  175875 */     // GIR_Coverage, 46105,
     /*  175875 */     GIR_EraseRootFromParent_Done,
     /*  175876 */   // Label 3386: @175876
     /*  175876 */   GIM_Reject,
     /*  175877 */ // Label 3384: @175877
     /*  175877 */ GIM_Reject,
     /*  175878 */ // Label 3207: @175878
     /*  175878 */ GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(175965),
     /*  175883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  175894 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(175929), // Rule ID 45984 //
     /*  175899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175902 */     // MIs[0] rs1
     /*  175902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175910 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  175910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  175913 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175927 */     GIR_RootConstrainSelectedInstOperands,
     /*  175928 */     // GIR_Coverage, 45984,
     /*  175928 */     GIR_EraseRootFromParent_Done,
     /*  175929 */   // Label 3388: @175929
     /*  175929 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(175964), // Rule ID 45985 //
     /*  175934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175937 */     // MIs[0] rs1
     /*  175937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175945 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  175945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  175948 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175962 */     GIR_RootConstrainSelectedInstOperands,
     /*  175963 */     // GIR_Coverage, 45985,
     /*  175963 */     GIR_EraseRootFromParent_Done,
     /*  175964 */   // Label 3389: @175964
     /*  175964 */   GIM_Reject,
     /*  175965 */ // Label 3387: @175965
     /*  175965 */ GIM_Reject,
     /*  175966 */ // Label 3208: @175966
     /*  175966 */ GIM_Reject,
     /*  175967 */ // Label 25: @175967
     /*  175967 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3392*/ GIMT_Encode4(180852),
     /*  175978 */ /*GILLT_s32*//*Label 3390*/ GIMT_Encode4(175986),
     /*  175982 */ /*GILLT_s64*//*Label 3391*/ GIMT_Encode4(177979),
     /*  175986 */ // Label 3390: @175986
     /*  175986 */ GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(177978),
     /*  175991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  175994 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  175997 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(176063), // Rule ID 663 //
     /*  176002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  176005 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176012 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176019 */     // MIs[0] addr
     /*  176019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  176023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176035 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 2:{ *:[i32] })
     /*  176035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  176038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  176041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  176043 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  176048 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176050 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176052 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  176057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176061 */     GIR_RootConstrainSelectedInstOperands,
     /*  176062 */     // GIR_Coverage, 663,
     /*  176062 */     GIR_EraseRootFromParent_Done,
     /*  176063 */   // Label 3394: @176063
     /*  176063 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(176129), // Rule ID 665 //
     /*  176068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  176071 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176078 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176085 */     // MIs[0] addr
     /*  176085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  176089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176101 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 4:{ *:[i32] })
     /*  176101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  176104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  176107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  176109 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  176114 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176116 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176118 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176127 */     GIR_RootConstrainSelectedInstOperands,
     /*  176128 */     // GIR_Coverage, 665,
     /*  176128 */     GIR_EraseRootFromParent_Done,
     /*  176129 */   // Label 3395: @176129
     /*  176129 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(176195), // Rule ID 667 //
     /*  176134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  176137 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176144 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176151 */     // MIs[0] addr
     /*  176151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  176155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176167 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 5:{ *:[i32] })
     /*  176167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  176170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  176173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  176175 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  176180 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176182 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176184 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176193 */     GIR_RootConstrainSelectedInstOperands,
     /*  176194 */     // GIR_Coverage, 667,
     /*  176194 */     GIR_EraseRootFromParent_Done,
     /*  176195 */   // Label 3396: @176195
     /*  176195 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(176261), // Rule ID 669 //
     /*  176200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  176203 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176217 */     // MIs[0] addr
     /*  176217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  176221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176233 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 6:{ *:[i32] })
     /*  176233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  176236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  176239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  176241 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  176246 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176248 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176250 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176259 */     GIR_RootConstrainSelectedInstOperands,
     /*  176260 */     // GIR_Coverage, 669,
     /*  176260 */     GIR_EraseRootFromParent_Done,
     /*  176261 */   // Label 3397: @176261
     /*  176261 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(176327), // Rule ID 671 //
     /*  176266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  176269 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176276 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176283 */     // MIs[0] addr
     /*  176283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  176287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176299 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 7:{ *:[i32] })
     /*  176299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  176302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  176305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  176307 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  176312 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176314 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176316 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  176321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176325 */     GIR_RootConstrainSelectedInstOperands,
     /*  176326 */     // GIR_Coverage, 671,
     /*  176326 */     GIR_EraseRootFromParent_Done,
     /*  176327 */   // Label 3398: @176327
     /*  176327 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(176382), // Rule ID 680 //
     /*  176332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176335 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176342 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176349 */     // MIs[0] addr
     /*  176349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176365 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176370 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176372 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176374 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176380 */     GIR_RootConstrainSelectedInstOperands,
     /*  176381 */     // GIR_Coverage, 680,
     /*  176381 */     GIR_EraseRootFromParent_Done,
     /*  176382 */   // Label 3399: @176382
     /*  176382 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(176437), // Rule ID 682 //
     /*  176387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176390 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176397 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176404 */     // MIs[0] addr
     /*  176404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176420 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  176423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176425 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176427 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176429 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176435 */     GIR_RootConstrainSelectedInstOperands,
     /*  176436 */     // GIR_Coverage, 682,
     /*  176436 */     GIR_EraseRootFromParent_Done,
     /*  176437 */   // Label 3400: @176437
     /*  176437 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(176492), // Rule ID 684 //
     /*  176442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176445 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176452 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176459 */     // MIs[0] addr
     /*  176459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176475 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  176478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176480 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176482 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176484 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176490 */     GIR_RootConstrainSelectedInstOperands,
     /*  176491 */     // GIR_Coverage, 684,
     /*  176491 */     GIR_EraseRootFromParent_Done,
     /*  176492 */   // Label 3401: @176492
     /*  176492 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(176547), // Rule ID 686 //
     /*  176497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176514 */     // MIs[0] addr
     /*  176514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176530 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  176533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176535 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176537 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176539 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176545 */     GIR_RootConstrainSelectedInstOperands,
     /*  176546 */     // GIR_Coverage, 686,
     /*  176546 */     GIR_EraseRootFromParent_Done,
     /*  176547 */   // Label 3402: @176547
     /*  176547 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(176602), // Rule ID 688 //
     /*  176552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176562 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176569 */     // MIs[0] addr
     /*  176569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176585 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  176588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176590 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176592 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176594 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176600 */     GIR_RootConstrainSelectedInstOperands,
     /*  176601 */     // GIR_Coverage, 688,
     /*  176601 */     GIR_EraseRootFromParent_Done,
     /*  176602 */   // Label 3403: @176602
     /*  176602 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(176657), // Rule ID 690 //
     /*  176607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176610 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176624 */     // MIs[0] addr
     /*  176624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176640 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176645 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176647 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176649 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176655 */     GIR_RootConstrainSelectedInstOperands,
     /*  176656 */     // GIR_Coverage, 690,
     /*  176656 */     GIR_EraseRootFromParent_Done,
     /*  176657 */   // Label 3404: @176657
     /*  176657 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(176712), // Rule ID 692 //
     /*  176662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176679 */     // MIs[0] addr
     /*  176679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176695 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176700 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176702 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176704 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176710 */     GIR_RootConstrainSelectedInstOperands,
     /*  176711 */     // GIR_Coverage, 692,
     /*  176711 */     GIR_EraseRootFromParent_Done,
     /*  176712 */   // Label 3405: @176712
     /*  176712 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(176767), // Rule ID 694 //
     /*  176717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176734 */     // MIs[0] addr
     /*  176734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176750 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176755 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176757 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176759 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176765 */     GIR_RootConstrainSelectedInstOperands,
     /*  176766 */     // GIR_Coverage, 694,
     /*  176766 */     GIR_EraseRootFromParent_Done,
     /*  176767 */   // Label 3406: @176767
     /*  176767 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(176822), // Rule ID 696 //
     /*  176772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176775 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176782 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176789 */     // MIs[0] addr
     /*  176789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176805 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176810 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176812 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176814 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176820 */     GIR_RootConstrainSelectedInstOperands,
     /*  176821 */     // GIR_Coverage, 696,
     /*  176821 */     GIR_EraseRootFromParent_Done,
     /*  176822 */   // Label 3407: @176822
     /*  176822 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(176877), // Rule ID 698 //
     /*  176827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176844 */     // MIs[0] addr
     /*  176844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176860 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176865 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176867 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176869 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176875 */     GIR_RootConstrainSelectedInstOperands,
     /*  176876 */     // GIR_Coverage, 698,
     /*  176876 */     GIR_EraseRootFromParent_Done,
     /*  176877 */   // Label 3408: @176877
     /*  176877 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(176932), // Rule ID 1070 //
     /*  176882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176885 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176892 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176899 */     // MIs[0] addr
     /*  176899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176915 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176920 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176922 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176924 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176930 */     GIR_RootConstrainSelectedInstOperands,
     /*  176931 */     // GIR_Coverage, 1070,
     /*  176931 */     GIR_EraseRootFromParent_Done,
     /*  176932 */   // Label 3409: @176932
     /*  176932 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(176987), // Rule ID 1072 //
     /*  176937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176954 */     // MIs[0] addr
     /*  176954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176970 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  176973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176975 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176977 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176979 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176985 */     GIR_RootConstrainSelectedInstOperands,
     /*  176986 */     // GIR_Coverage, 1072,
     /*  176986 */     GIR_EraseRootFromParent_Done,
     /*  176987 */   // Label 3410: @176987
     /*  176987 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(177042), // Rule ID 1074 //
     /*  176992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176995 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177002 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177009 */     // MIs[0] addr
     /*  177009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177025 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  177028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177030 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177032 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177034 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177040 */     GIR_RootConstrainSelectedInstOperands,
     /*  177041 */     // GIR_Coverage, 1074,
     /*  177041 */     GIR_EraseRootFromParent_Done,
     /*  177042 */   // Label 3411: @177042
     /*  177042 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(177097), // Rule ID 1076 //
     /*  177047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177057 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177064 */     // MIs[0] addr
     /*  177064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177080 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  177083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177085 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177087 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177089 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177095 */     GIR_RootConstrainSelectedInstOperands,
     /*  177096 */     // GIR_Coverage, 1076,
     /*  177096 */     GIR_EraseRootFromParent_Done,
     /*  177097 */   // Label 3412: @177097
     /*  177097 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(177152), // Rule ID 1078 //
     /*  177102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177105 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177112 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177119 */     // MIs[0] addr
     /*  177119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177135 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  177138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177140 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177142 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177144 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177150 */     GIR_RootConstrainSelectedInstOperands,
     /*  177151 */     // GIR_Coverage, 1078,
     /*  177151 */     GIR_EraseRootFromParent_Done,
     /*  177152 */   // Label 3413: @177152
     /*  177152 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(177207), // Rule ID 1080 //
     /*  177157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177160 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177167 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177174 */     // MIs[0] addr
     /*  177174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177190 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  177193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177195 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177197 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177199 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177205 */     GIR_RootConstrainSelectedInstOperands,
     /*  177206 */     // GIR_Coverage, 1080,
     /*  177206 */     GIR_EraseRootFromParent_Done,
     /*  177207 */   // Label 3414: @177207
     /*  177207 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(177262), // Rule ID 1082 //
     /*  177212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177229 */     // MIs[0] addr
     /*  177229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177245 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  177248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177250 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177252 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177254 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177260 */     GIR_RootConstrainSelectedInstOperands,
     /*  177261 */     // GIR_Coverage, 1082,
     /*  177261 */     GIR_EraseRootFromParent_Done,
     /*  177262 */   // Label 3415: @177262
     /*  177262 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(177317), // Rule ID 1084 //
     /*  177267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177284 */     // MIs[0] addr
     /*  177284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177300 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  177303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177305 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177307 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177309 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177315 */     GIR_RootConstrainSelectedInstOperands,
     /*  177316 */     // GIR_Coverage, 1084,
     /*  177316 */     GIR_EraseRootFromParent_Done,
     /*  177317 */   // Label 3416: @177317
     /*  177317 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(177372), // Rule ID 1086 //
     /*  177322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177325 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177332 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177339 */     // MIs[0] addr
     /*  177339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177355 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  177358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177360 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177362 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177364 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177370 */     GIR_RootConstrainSelectedInstOperands,
     /*  177371 */     // GIR_Coverage, 1086,
     /*  177371 */     GIR_EraseRootFromParent_Done,
     /*  177372 */   // Label 3417: @177372
     /*  177372 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(177427), // Rule ID 1088 //
     /*  177377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177380 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177387 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177394 */     // MIs[0] addr
     /*  177394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177410 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  177413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177415 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177417 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177419 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177425 */     GIR_RootConstrainSelectedInstOperands,
     /*  177426 */     // GIR_Coverage, 1088,
     /*  177426 */     GIR_EraseRootFromParent_Done,
     /*  177427 */   // Label 3418: @177427
     /*  177427 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(177482), // Rule ID 1090 //
     /*  177432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177442 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177449 */     // MIs[0] addr
     /*  177449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177465 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177470 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177472 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177474 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177480 */     GIR_RootConstrainSelectedInstOperands,
     /*  177481 */     // GIR_Coverage, 1090,
     /*  177481 */     GIR_EraseRootFromParent_Done,
     /*  177482 */   // Label 3419: @177482
     /*  177482 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(177537), // Rule ID 1092 //
     /*  177487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177504 */     // MIs[0] addr
     /*  177504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177520 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  177523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177525 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177527 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177529 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177535 */     GIR_RootConstrainSelectedInstOperands,
     /*  177536 */     // GIR_Coverage, 1092,
     /*  177536 */     GIR_EraseRootFromParent_Done,
     /*  177537 */   // Label 3420: @177537
     /*  177537 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(177592), // Rule ID 1094 //
     /*  177542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177545 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177552 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177559 */     // MIs[0] addr
     /*  177559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177575 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  177578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177580 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177582 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177584 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177590 */     GIR_RootConstrainSelectedInstOperands,
     /*  177591 */     // GIR_Coverage, 1094,
     /*  177591 */     GIR_EraseRootFromParent_Done,
     /*  177592 */   // Label 3421: @177592
     /*  177592 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(177647), // Rule ID 1096 //
     /*  177597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177600 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177607 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177614 */     // MIs[0] addr
     /*  177614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177630 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  177633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177635 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177637 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177639 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177645 */     GIR_RootConstrainSelectedInstOperands,
     /*  177646 */     // GIR_Coverage, 1096,
     /*  177646 */     GIR_EraseRootFromParent_Done,
     /*  177647 */   // Label 3422: @177647
     /*  177647 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(177702), // Rule ID 1098 //
     /*  177652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177669 */     // MIs[0] addr
     /*  177669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177685 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  177688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177690 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177692 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177694 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177700 */     GIR_RootConstrainSelectedInstOperands,
     /*  177701 */     // GIR_Coverage, 1098,
     /*  177701 */     GIR_EraseRootFromParent_Done,
     /*  177702 */   // Label 3423: @177702
     /*  177702 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(177757), // Rule ID 1100 //
     /*  177707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177710 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177717 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177724 */     // MIs[0] addr
     /*  177724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177740 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177745 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177747 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177749 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177755 */     GIR_RootConstrainSelectedInstOperands,
     /*  177756 */     // GIR_Coverage, 1100,
     /*  177756 */     GIR_EraseRootFromParent_Done,
     /*  177757 */   // Label 3424: @177757
     /*  177757 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(177812), // Rule ID 1102 //
     /*  177762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177765 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177772 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177779 */     // MIs[0] addr
     /*  177779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177795 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177800 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177802 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177804 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177810 */     GIR_RootConstrainSelectedInstOperands,
     /*  177811 */     // GIR_Coverage, 1102,
     /*  177811 */     GIR_EraseRootFromParent_Done,
     /*  177812 */   // Label 3425: @177812
     /*  177812 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(177867), // Rule ID 1104 //
     /*  177817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177820 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177834 */     // MIs[0] addr
     /*  177834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177850 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177855 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177857 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177859 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177865 */     GIR_RootConstrainSelectedInstOperands,
     /*  177866 */     // GIR_Coverage, 1104,
     /*  177866 */     GIR_EraseRootFromParent_Done,
     /*  177867 */   // Label 3426: @177867
     /*  177867 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(177922), // Rule ID 1106 //
     /*  177872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177875 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177882 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177889 */     // MIs[0] addr
     /*  177889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177905 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177910 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177912 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177914 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177920 */     GIR_RootConstrainSelectedInstOperands,
     /*  177921 */     // GIR_Coverage, 1106,
     /*  177921 */     GIR_EraseRootFromParent_Done,
     /*  177922 */   // Label 3427: @177922
     /*  177922 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(177977), // Rule ID 1108 //
     /*  177927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177930 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177937 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177944 */     // MIs[0] addr
     /*  177944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177960 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177965 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177967 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177969 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177975 */     GIR_RootConstrainSelectedInstOperands,
     /*  177976 */     // GIR_Coverage, 1108,
     /*  177976 */     GIR_EraseRootFromParent_Done,
     /*  177977 */   // Label 3428: @177977
     /*  177977 */   GIM_Reject,
     /*  177978 */ // Label 3393: @177978
     /*  177978 */ GIM_Reject,
     /*  177979 */ // Label 3391: @177979
     /*  177979 */ GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(180851),
     /*  177984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  177987 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  177990 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(178056), // Rule ID 662 //
     /*  177995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177998 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178005 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178012 */     // MIs[0] addr
     /*  178012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178028 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  178028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  178034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178036 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178041 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178043 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178045 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  178050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178054 */     GIR_RootConstrainSelectedInstOperands,
     /*  178055 */     // GIR_Coverage, 662,
     /*  178055 */     GIR_EraseRootFromParent_Done,
     /*  178056 */   // Label 3430: @178056
     /*  178056 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(178122), // Rule ID 664 //
     /*  178061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  178064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178078 */     // MIs[0] addr
     /*  178078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178094 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  178094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  178100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178102 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178107 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178109 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178111 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178120 */     GIR_RootConstrainSelectedInstOperands,
     /*  178121 */     // GIR_Coverage, 664,
     /*  178121 */     GIR_EraseRootFromParent_Done,
     /*  178122 */   // Label 3431: @178122
     /*  178122 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(178188), // Rule ID 666 //
     /*  178127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  178130 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178144 */     // MIs[0] addr
     /*  178144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178160 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  178160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  178166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178168 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178173 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178175 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178177 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178186 */     GIR_RootConstrainSelectedInstOperands,
     /*  178187 */     // GIR_Coverage, 666,
     /*  178187 */     GIR_EraseRootFromParent_Done,
     /*  178188 */   // Label 3432: @178188
     /*  178188 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(178254), // Rule ID 668 //
     /*  178193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  178196 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178210 */     // MIs[0] addr
     /*  178210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178226 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  178226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  178232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178234 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178239 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178241 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178243 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178252 */     GIR_RootConstrainSelectedInstOperands,
     /*  178253 */     // GIR_Coverage, 668,
     /*  178253 */     GIR_EraseRootFromParent_Done,
     /*  178254 */   // Label 3433: @178254
     /*  178254 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(178320), // Rule ID 670 //
     /*  178259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  178262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178276 */     // MIs[0] addr
     /*  178276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178292 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  178292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  178298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178300 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178305 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178307 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178309 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  178314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178318 */     GIR_RootConstrainSelectedInstOperands,
     /*  178319 */     // GIR_Coverage, 670,
     /*  178319 */     GIR_EraseRootFromParent_Done,
     /*  178320 */   // Label 3434: @178320
     /*  178320 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(178386), // Rule ID 672 //
     /*  178325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178342 */     // MIs[0] addr
     /*  178342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178358 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  178358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178366 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178371 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178373 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178375 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  178380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178384 */     GIR_RootConstrainSelectedInstOperands,
     /*  178385 */     // GIR_Coverage, 672,
     /*  178385 */     GIR_EraseRootFromParent_Done,
     /*  178386 */   // Label 3435: @178386
     /*  178386 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(178452), // Rule ID 673 //
     /*  178391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178394 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178401 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178408 */     // MIs[0] addr
     /*  178408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178424 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  178424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178432 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178437 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178439 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178441 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178450 */     GIR_RootConstrainSelectedInstOperands,
     /*  178451 */     // GIR_Coverage, 673,
     /*  178451 */     GIR_EraseRootFromParent_Done,
     /*  178452 */   // Label 3436: @178452
     /*  178452 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(178518), // Rule ID 674 //
     /*  178457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178474 */     // MIs[0] addr
     /*  178474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178490 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  178490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178498 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178503 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178505 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178507 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178516 */     GIR_RootConstrainSelectedInstOperands,
     /*  178517 */     // GIR_Coverage, 674,
     /*  178517 */     GIR_EraseRootFromParent_Done,
     /*  178518 */   // Label 3437: @178518
     /*  178518 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(178584), // Rule ID 675 //
     /*  178523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178540 */     // MIs[0] addr
     /*  178540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178556 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  178556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178564 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178569 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178571 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178573 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178582 */     GIR_RootConstrainSelectedInstOperands,
     /*  178583 */     // GIR_Coverage, 675,
     /*  178583 */     GIR_EraseRootFromParent_Done,
     /*  178584 */   // Label 3438: @178584
     /*  178584 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(178650), // Rule ID 676 //
     /*  178589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178592 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178606 */     // MIs[0] addr
     /*  178606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178622 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  178622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178630 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178635 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178637 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178639 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  178644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178648 */     GIR_RootConstrainSelectedInstOperands,
     /*  178649 */     // GIR_Coverage, 676,
     /*  178649 */     GIR_EraseRootFromParent_Done,
     /*  178650 */   // Label 3439: @178650
     /*  178650 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(178705), // Rule ID 679 //
     /*  178655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178658 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178665 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178672 */     // MIs[0] addr
     /*  178672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178688 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178693 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178695 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178697 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178703 */     GIR_RootConstrainSelectedInstOperands,
     /*  178704 */     // GIR_Coverage, 679,
     /*  178704 */     GIR_EraseRootFromParent_Done,
     /*  178705 */   // Label 3440: @178705
     /*  178705 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(178760), // Rule ID 681 //
     /*  178710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178713 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178720 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178727 */     // MIs[0] addr
     /*  178727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178743 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  178746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178748 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178750 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178752 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178758 */     GIR_RootConstrainSelectedInstOperands,
     /*  178759 */     // GIR_Coverage, 681,
     /*  178759 */     GIR_EraseRootFromParent_Done,
     /*  178760 */   // Label 3441: @178760
     /*  178760 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(178815), // Rule ID 683 //
     /*  178765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178768 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178775 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178782 */     // MIs[0] addr
     /*  178782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178798 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  178801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178803 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178805 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178807 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178813 */     GIR_RootConstrainSelectedInstOperands,
     /*  178814 */     // GIR_Coverage, 683,
     /*  178814 */     GIR_EraseRootFromParent_Done,
     /*  178815 */   // Label 3442: @178815
     /*  178815 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(178870), // Rule ID 685 //
     /*  178820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178830 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178837 */     // MIs[0] addr
     /*  178837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178853 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  178856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178858 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178860 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178862 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178868 */     GIR_RootConstrainSelectedInstOperands,
     /*  178869 */     // GIR_Coverage, 685,
     /*  178869 */     GIR_EraseRootFromParent_Done,
     /*  178870 */   // Label 3443: @178870
     /*  178870 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(178925), // Rule ID 687 //
     /*  178875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178878 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178885 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178892 */     // MIs[0] addr
     /*  178892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178908 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  178911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178913 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178915 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178917 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178923 */     GIR_RootConstrainSelectedInstOperands,
     /*  178924 */     // GIR_Coverage, 687,
     /*  178924 */     GIR_EraseRootFromParent_Done,
     /*  178925 */   // Label 3444: @178925
     /*  178925 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(178980), // Rule ID 689 //
     /*  178930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178947 */     // MIs[0] addr
     /*  178947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178963 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178968 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178970 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178972 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178978 */     GIR_RootConstrainSelectedInstOperands,
     /*  178979 */     // GIR_Coverage, 689,
     /*  178979 */     GIR_EraseRootFromParent_Done,
     /*  178980 */   // Label 3445: @178980
     /*  178980 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(179035), // Rule ID 691 //
     /*  178985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178988 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178995 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179002 */     // MIs[0] addr
     /*  179002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179018 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  179021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179023 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179025 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179027 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179033 */     GIR_RootConstrainSelectedInstOperands,
     /*  179034 */     // GIR_Coverage, 691,
     /*  179034 */     GIR_EraseRootFromParent_Done,
     /*  179035 */   // Label 3446: @179035
     /*  179035 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(179090), // Rule ID 693 //
     /*  179040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179043 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179050 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179057 */     // MIs[0] addr
     /*  179057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179073 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  179076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179078 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179080 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179082 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179088 */     GIR_RootConstrainSelectedInstOperands,
     /*  179089 */     // GIR_Coverage, 693,
     /*  179089 */     GIR_EraseRootFromParent_Done,
     /*  179090 */   // Label 3447: @179090
     /*  179090 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(179145), // Rule ID 695 //
     /*  179095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179112 */     // MIs[0] addr
     /*  179112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179128 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  179131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179133 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179135 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179137 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179143 */     GIR_RootConstrainSelectedInstOperands,
     /*  179144 */     // GIR_Coverage, 695,
     /*  179144 */     GIR_EraseRootFromParent_Done,
     /*  179145 */   // Label 3448: @179145
     /*  179145 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(179200), // Rule ID 697 //
     /*  179150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179153 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179167 */     // MIs[0] addr
     /*  179167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179183 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  179186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179188 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179190 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179192 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179198 */     GIR_RootConstrainSelectedInstOperands,
     /*  179199 */     // GIR_Coverage, 697,
     /*  179199 */     GIR_EraseRootFromParent_Done,
     /*  179200 */   // Label 3449: @179200
     /*  179200 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(179255), // Rule ID 699 //
     /*  179205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  179208 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179215 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179222 */     // MIs[0] addr
     /*  179222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179238 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179243 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179245 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179247 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179253 */     GIR_RootConstrainSelectedInstOperands,
     /*  179254 */     // GIR_Coverage, 699,
     /*  179254 */     GIR_EraseRootFromParent_Done,
     /*  179255 */   // Label 3450: @179255
     /*  179255 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(179310), // Rule ID 700 //
     /*  179260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  179263 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179277 */     // MIs[0] addr
     /*  179277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179293 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ),
     /*  179296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179298 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179300 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179302 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179308 */     GIR_RootConstrainSelectedInstOperands,
     /*  179309 */     // GIR_Coverage, 700,
     /*  179309 */     GIR_EraseRootFromParent_Done,
     /*  179310 */   // Label 3451: @179310
     /*  179310 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(179365), // Rule ID 701 //
     /*  179315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  179318 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179325 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179332 */     // MIs[0] addr
     /*  179332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179348 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_RL),
     /*  179351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179353 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179355 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179357 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179363 */     GIR_RootConstrainSelectedInstOperands,
     /*  179364 */     // GIR_Coverage, 701,
     /*  179364 */     GIR_EraseRootFromParent_Done,
     /*  179365 */   // Label 3452: @179365
     /*  179365 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(179420), // Rule ID 702 //
     /*  179370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  179373 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179380 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179387 */     // MIs[0] addr
     /*  179387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179403 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  179406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179408 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179410 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179412 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179418 */     GIR_RootConstrainSelectedInstOperands,
     /*  179419 */     // GIR_Coverage, 702,
     /*  179419 */     GIR_EraseRootFromParent_Done,
     /*  179420 */   // Label 3453: @179420
     /*  179420 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(179475), // Rule ID 703 //
     /*  179425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  179428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179442 */     // MIs[0] addr
     /*  179442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179458 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  179461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179463 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179465 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179467 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179473 */     GIR_RootConstrainSelectedInstOperands,
     /*  179474 */     // GIR_Coverage, 703,
     /*  179474 */     GIR_EraseRootFromParent_Done,
     /*  179475 */   // Label 3454: @179475
     /*  179475 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(179530), // Rule ID 704 //
     /*  179480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179497 */     // MIs[0] addr
     /*  179497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179513 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179518 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179520 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179522 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179528 */     GIR_RootConstrainSelectedInstOperands,
     /*  179529 */     // GIR_Coverage, 704,
     /*  179529 */     GIR_EraseRootFromParent_Done,
     /*  179530 */   // Label 3455: @179530
     /*  179530 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(179585), // Rule ID 705 //
     /*  179535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179538 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179545 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179552 */     // MIs[0] addr
     /*  179552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179568 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179573 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179575 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179577 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179583 */     GIR_RootConstrainSelectedInstOperands,
     /*  179584 */     // GIR_Coverage, 705,
     /*  179584 */     GIR_EraseRootFromParent_Done,
     /*  179585 */   // Label 3456: @179585
     /*  179585 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(179640), // Rule ID 706 //
     /*  179590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179593 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179600 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179607 */     // MIs[0] addr
     /*  179607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179623 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179628 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179630 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179632 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179638 */     GIR_RootConstrainSelectedInstOperands,
     /*  179639 */     // GIR_Coverage, 706,
     /*  179639 */     GIR_EraseRootFromParent_Done,
     /*  179640 */   // Label 3457: @179640
     /*  179640 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(179695), // Rule ID 707 //
     /*  179645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179648 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179655 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179662 */     // MIs[0] addr
     /*  179662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179678 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179683 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179685 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179687 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179693 */     GIR_RootConstrainSelectedInstOperands,
     /*  179694 */     // GIR_Coverage, 707,
     /*  179694 */     GIR_EraseRootFromParent_Done,
     /*  179695 */   // Label 3458: @179695
     /*  179695 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(179750), // Rule ID 708 //
     /*  179700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179717 */     // MIs[0] addr
     /*  179717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179733 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179738 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179740 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179742 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179748 */     GIR_RootConstrainSelectedInstOperands,
     /*  179749 */     // GIR_Coverage, 708,
     /*  179749 */     GIR_EraseRootFromParent_Done,
     /*  179750 */   // Label 3459: @179750
     /*  179750 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(179805), // Rule ID 1069 //
     /*  179755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179772 */     // MIs[0] addr
     /*  179772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179788 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179793 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179795 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179797 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179803 */     GIR_RootConstrainSelectedInstOperands,
     /*  179804 */     // GIR_Coverage, 1069,
     /*  179804 */     GIR_EraseRootFromParent_Done,
     /*  179805 */   // Label 3460: @179805
     /*  179805 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(179860), // Rule ID 1071 //
     /*  179810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179827 */     // MIs[0] addr
     /*  179827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179843 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  179846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179848 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179850 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179852 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179858 */     GIR_RootConstrainSelectedInstOperands,
     /*  179859 */     // GIR_Coverage, 1071,
     /*  179859 */     GIR_EraseRootFromParent_Done,
     /*  179860 */   // Label 3461: @179860
     /*  179860 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(179915), // Rule ID 1073 //
     /*  179865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179882 */     // MIs[0] addr
     /*  179882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179898 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  179901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179903 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179905 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179907 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179913 */     GIR_RootConstrainSelectedInstOperands,
     /*  179914 */     // GIR_Coverage, 1073,
     /*  179914 */     GIR_EraseRootFromParent_Done,
     /*  179915 */   // Label 3462: @179915
     /*  179915 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(179970), // Rule ID 1075 //
     /*  179920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179923 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179930 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179937 */     // MIs[0] addr
     /*  179937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179953 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  179956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179958 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179960 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179962 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179968 */     GIR_RootConstrainSelectedInstOperands,
     /*  179969 */     // GIR_Coverage, 1075,
     /*  179969 */     GIR_EraseRootFromParent_Done,
     /*  179970 */   // Label 3463: @179970
     /*  179970 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(180025), // Rule ID 1077 //
     /*  179975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179992 */     // MIs[0] addr
     /*  179992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180008 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  180011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180013 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180015 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180017 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180023 */     GIR_RootConstrainSelectedInstOperands,
     /*  180024 */     // GIR_Coverage, 1077,
     /*  180024 */     GIR_EraseRootFromParent_Done,
     /*  180025 */   // Label 3464: @180025
     /*  180025 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(180080), // Rule ID 1079 //
     /*  180030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180047 */     // MIs[0] addr
     /*  180047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180063 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180068 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180070 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180072 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180078 */     GIR_RootConstrainSelectedInstOperands,
     /*  180079 */     // GIR_Coverage, 1079,
     /*  180079 */     GIR_EraseRootFromParent_Done,
     /*  180080 */   // Label 3465: @180080
     /*  180080 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(180135), // Rule ID 1081 //
     /*  180085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180088 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180102 */     // MIs[0] addr
     /*  180102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180118 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180123 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180125 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180127 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180133 */     GIR_RootConstrainSelectedInstOperands,
     /*  180134 */     // GIR_Coverage, 1081,
     /*  180134 */     GIR_EraseRootFromParent_Done,
     /*  180135 */   // Label 3466: @180135
     /*  180135 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(180190), // Rule ID 1083 //
     /*  180140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180143 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180150 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180157 */     // MIs[0] addr
     /*  180157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180173 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180178 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180180 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180182 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180188 */     GIR_RootConstrainSelectedInstOperands,
     /*  180189 */     // GIR_Coverage, 1083,
     /*  180189 */     GIR_EraseRootFromParent_Done,
     /*  180190 */   // Label 3467: @180190
     /*  180190 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(180245), // Rule ID 1085 //
     /*  180195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180212 */     // MIs[0] addr
     /*  180212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180228 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180233 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180235 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180237 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180243 */     GIR_RootConstrainSelectedInstOperands,
     /*  180244 */     // GIR_Coverage, 1085,
     /*  180244 */     GIR_EraseRootFromParent_Done,
     /*  180245 */   // Label 3468: @180245
     /*  180245 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(180300), // Rule ID 1087 //
     /*  180250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180267 */     // MIs[0] addr
     /*  180267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180283 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180288 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180290 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180292 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180298 */     GIR_RootConstrainSelectedInstOperands,
     /*  180299 */     // GIR_Coverage, 1087,
     /*  180299 */     GIR_EraseRootFromParent_Done,
     /*  180300 */   // Label 3469: @180300
     /*  180300 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(180355), // Rule ID 1089 //
     /*  180305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180308 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180322 */     // MIs[0] addr
     /*  180322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180338 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180343 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180345 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180347 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180353 */     GIR_RootConstrainSelectedInstOperands,
     /*  180354 */     // GIR_Coverage, 1089,
     /*  180354 */     GIR_EraseRootFromParent_Done,
     /*  180355 */   // Label 3470: @180355
     /*  180355 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(180410), // Rule ID 1091 //
     /*  180360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180363 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180377 */     // MIs[0] addr
     /*  180377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180393 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  180396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180398 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180400 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180402 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180408 */     GIR_RootConstrainSelectedInstOperands,
     /*  180409 */     // GIR_Coverage, 1091,
     /*  180409 */     GIR_EraseRootFromParent_Done,
     /*  180410 */   // Label 3471: @180410
     /*  180410 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(180465), // Rule ID 1093 //
     /*  180415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180418 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180432 */     // MIs[0] addr
     /*  180432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180448 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  180451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180453 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180455 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180457 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180463 */     GIR_RootConstrainSelectedInstOperands,
     /*  180464 */     // GIR_Coverage, 1093,
     /*  180464 */     GIR_EraseRootFromParent_Done,
     /*  180465 */   // Label 3472: @180465
     /*  180465 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(180520), // Rule ID 1095 //
     /*  180470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180480 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180487 */     // MIs[0] addr
     /*  180487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180503 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  180506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180508 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180510 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180512 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180518 */     GIR_RootConstrainSelectedInstOperands,
     /*  180519 */     // GIR_Coverage, 1095,
     /*  180519 */     GIR_EraseRootFromParent_Done,
     /*  180520 */   // Label 3473: @180520
     /*  180520 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(180575), // Rule ID 1097 //
     /*  180525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180528 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180535 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180542 */     // MIs[0] addr
     /*  180542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180558 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  180561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180563 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180565 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180567 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180573 */     GIR_RootConstrainSelectedInstOperands,
     /*  180574 */     // GIR_Coverage, 1097,
     /*  180574 */     GIR_EraseRootFromParent_Done,
     /*  180575 */   // Label 3474: @180575
     /*  180575 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(180630), // Rule ID 1099 //
     /*  180580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180583 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180590 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180597 */     // MIs[0] addr
     /*  180597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180613 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180618 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180620 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180622 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180628 */     GIR_RootConstrainSelectedInstOperands,
     /*  180629 */     // GIR_Coverage, 1099,
     /*  180629 */     GIR_EraseRootFromParent_Done,
     /*  180630 */   // Label 3475: @180630
     /*  180630 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(180685), // Rule ID 1101 //
     /*  180635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180652 */     // MIs[0] addr
     /*  180652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180668 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180673 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180675 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180677 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180683 */     GIR_RootConstrainSelectedInstOperands,
     /*  180684 */     // GIR_Coverage, 1101,
     /*  180684 */     GIR_EraseRootFromParent_Done,
     /*  180685 */   // Label 3476: @180685
     /*  180685 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(180740), // Rule ID 1103 //
     /*  180690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180693 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180700 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180707 */     // MIs[0] addr
     /*  180707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180723 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180728 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180730 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180732 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180738 */     GIR_RootConstrainSelectedInstOperands,
     /*  180739 */     // GIR_Coverage, 1103,
     /*  180739 */     GIR_EraseRootFromParent_Done,
     /*  180740 */   // Label 3477: @180740
     /*  180740 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(180795), // Rule ID 1105 //
     /*  180745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180748 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180755 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180762 */     // MIs[0] addr
     /*  180762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180778 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180783 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180785 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180787 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180793 */     GIR_RootConstrainSelectedInstOperands,
     /*  180794 */     // GIR_Coverage, 1105,
     /*  180794 */     GIR_EraseRootFromParent_Done,
     /*  180795 */   // Label 3478: @180795
     /*  180795 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(180850), // Rule ID 1107 //
     /*  180800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180803 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180810 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180817 */     // MIs[0] addr
     /*  180817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180833 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180838 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180840 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180842 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180848 */     GIR_RootConstrainSelectedInstOperands,
     /*  180849 */     // GIR_Coverage, 1107,
     /*  180849 */     GIR_EraseRootFromParent_Done,
     /*  180850 */   // Label 3479: @180850
     /*  180850 */   GIM_Reject,
     /*  180851 */ // Label 3429: @180851
     /*  180851 */ GIM_Reject,
     /*  180852 */ // Label 3392: @180852
     /*  180852 */ GIM_Reject,
     /*  180853 */ // Label 26: @180853
     /*  180853 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3482*/ GIMT_Encode4(183762),
     /*  180864 */ /*GILLT_s32*//*Label 3480*/ GIMT_Encode4(180872),
     /*  180868 */ /*GILLT_s64*//*Label 3481*/ GIMT_Encode4(182112),
     /*  180872 */ // Label 3480: @180872
     /*  180872 */ GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(182111),
     /*  180877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  180880 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(180921), // Rule ID 362 //
     /*  180885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180888 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180895 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180902 */     // MIs[0] rs1
     /*  180902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180914 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180919 */     GIR_RootConstrainSelectedInstOperands,
     /*  180920 */     // GIR_Coverage, 362,
     /*  180920 */     GIR_Done,
     /*  180921 */   // Label 3484: @180921
     /*  180921 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(180962), // Rule ID 364 //
     /*  180926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180943 */     // MIs[0] rs1
     /*  180943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180955 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  180960 */     GIR_RootConstrainSelectedInstOperands,
     /*  180961 */     // GIR_Coverage, 364,
     /*  180961 */     GIR_Done,
     /*  180962 */   // Label 3485: @180962
     /*  180962 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(181003), // Rule ID 366 //
     /*  180967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180984 */     // MIs[0] rs1
     /*  180984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180996 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  181001 */     GIR_RootConstrainSelectedInstOperands,
     /*  181002 */     // GIR_Coverage, 366,
     /*  181002 */     GIR_Done,
     /*  181003 */   // Label 3486: @181003
     /*  181003 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(181044), // Rule ID 368 //
     /*  181008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  181011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181025 */     // MIs[0] rs1
     /*  181025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181037 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  181042 */     GIR_RootConstrainSelectedInstOperands,
     /*  181043 */     // GIR_Coverage, 368,
     /*  181043 */     GIR_Done,
     /*  181044 */   // Label 3487: @181044
     /*  181044 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(181085), // Rule ID 370 //
     /*  181049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  181052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181066 */     // MIs[0] rs1
     /*  181066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181078 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  181083 */     GIR_RootConstrainSelectedInstOperands,
     /*  181084 */     // GIR_Coverage, 370,
     /*  181084 */     GIR_Done,
     /*  181085 */   // Label 3488: @181085
     /*  181085 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(181126), // Rule ID 372 //
     /*  181090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  181093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181107 */     // MIs[0] rs1
     /*  181107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181119 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181124 */     GIR_RootConstrainSelectedInstOperands,
     /*  181125 */     // GIR_Coverage, 372,
     /*  181125 */     GIR_Done,
     /*  181126 */   // Label 3489: @181126
     /*  181126 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(181167), // Rule ID 374 //
     /*  181131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  181134 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181141 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181148 */     // MIs[0] rs1
     /*  181148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181160 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181165 */     GIR_RootConstrainSelectedInstOperands,
     /*  181166 */     // GIR_Coverage, 374,
     /*  181166 */     GIR_Done,
     /*  181167 */   // Label 3490: @181167
     /*  181167 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(181208), // Rule ID 376 //
     /*  181172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  181175 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181182 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181189 */     // MIs[0] rs1
     /*  181189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181201 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181206 */     GIR_RootConstrainSelectedInstOperands,
     /*  181207 */     // GIR_Coverage, 376,
     /*  181207 */     GIR_Done,
     /*  181208 */   // Label 3491: @181208
     /*  181208 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(181249), // Rule ID 378 //
     /*  181213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  181216 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181223 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181230 */     // MIs[0] rs1
     /*  181230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181242 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181247 */     GIR_RootConstrainSelectedInstOperands,
     /*  181248 */     // GIR_Coverage, 378,
     /*  181248 */     GIR_Done,
     /*  181249 */   // Label 3492: @181249
     /*  181249 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(181290), // Rule ID 380 //
     /*  181254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  181257 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181271 */     // MIs[0] rs1
     /*  181271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181283 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181288 */     GIR_RootConstrainSelectedInstOperands,
     /*  181289 */     // GIR_Coverage, 380,
     /*  181289 */     GIR_Done,
     /*  181290 */   // Label 3493: @181290
     /*  181290 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(181331), // Rule ID 710 //
     /*  181295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181298 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181305 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181312 */     // MIs[0] rs1
     /*  181312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181324 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181324 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181329 */     GIR_RootConstrainSelectedInstOperands,
     /*  181330 */     // GIR_Coverage, 710,
     /*  181330 */     GIR_Done,
     /*  181331 */   // Label 3494: @181331
     /*  181331 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(181372), // Rule ID 712 //
     /*  181336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181339 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181346 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181353 */     // MIs[0] rs1
     /*  181353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181365 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  181370 */     GIR_RootConstrainSelectedInstOperands,
     /*  181371 */     // GIR_Coverage, 712,
     /*  181371 */     GIR_Done,
     /*  181372 */   // Label 3495: @181372
     /*  181372 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(181413), // Rule ID 714 //
     /*  181377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181380 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181387 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181394 */     // MIs[0] rs1
     /*  181394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181406 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  181411 */     GIR_RootConstrainSelectedInstOperands,
     /*  181412 */     // GIR_Coverage, 714,
     /*  181412 */     GIR_Done,
     /*  181413 */   // Label 3496: @181413
     /*  181413 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(181454), // Rule ID 716 //
     /*  181418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181421 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181428 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181435 */     // MIs[0] rs1
     /*  181435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181447 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  181452 */     GIR_RootConstrainSelectedInstOperands,
     /*  181453 */     // GIR_Coverage, 716,
     /*  181453 */     GIR_Done,
     /*  181454 */   // Label 3497: @181454
     /*  181454 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(181495), // Rule ID 718 //
     /*  181459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181462 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181469 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181476 */     // MIs[0] rs1
     /*  181476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181488 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  181493 */     GIR_RootConstrainSelectedInstOperands,
     /*  181494 */     // GIR_Coverage, 718,
     /*  181494 */     GIR_Done,
     /*  181495 */   // Label 3498: @181495
     /*  181495 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(181536), // Rule ID 720 //
     /*  181500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181503 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181510 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181517 */     // MIs[0] rs1
     /*  181517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181529 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181534 */     GIR_RootConstrainSelectedInstOperands,
     /*  181535 */     // GIR_Coverage, 720,
     /*  181535 */     GIR_Done,
     /*  181536 */   // Label 3499: @181536
     /*  181536 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(181577), // Rule ID 722 //
     /*  181541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181544 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181551 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181558 */     // MIs[0] rs1
     /*  181558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181570 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181575 */     GIR_RootConstrainSelectedInstOperands,
     /*  181576 */     // GIR_Coverage, 722,
     /*  181576 */     GIR_Done,
     /*  181577 */   // Label 3500: @181577
     /*  181577 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(181618), // Rule ID 724 //
     /*  181582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181585 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181592 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181599 */     // MIs[0] rs1
     /*  181599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181611 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181616 */     GIR_RootConstrainSelectedInstOperands,
     /*  181617 */     // GIR_Coverage, 724,
     /*  181617 */     GIR_Done,
     /*  181618 */   // Label 3501: @181618
     /*  181618 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(181659), // Rule ID 726 //
     /*  181623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181626 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181633 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181640 */     // MIs[0] rs1
     /*  181640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181652 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181657 */     GIR_RootConstrainSelectedInstOperands,
     /*  181658 */     // GIR_Coverage, 726,
     /*  181658 */     GIR_Done,
     /*  181659 */   // Label 3502: @181659
     /*  181659 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(181700), // Rule ID 728 //
     /*  181664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181667 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181674 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181681 */     // MIs[0] rs1
     /*  181681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181693 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181698 */     GIR_RootConstrainSelectedInstOperands,
     /*  181699 */     // GIR_Coverage, 728,
     /*  181699 */     GIR_Done,
     /*  181700 */   // Label 3503: @181700
     /*  181700 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(181741), // Rule ID 890 //
     /*  181705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181708 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181715 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181722 */     // MIs[0] rs1
     /*  181722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181734 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181739 */     GIR_RootConstrainSelectedInstOperands,
     /*  181740 */     // GIR_Coverage, 890,
     /*  181740 */     GIR_Done,
     /*  181741 */   // Label 3504: @181741
     /*  181741 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(181782), // Rule ID 892 //
     /*  181746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181749 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181756 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181763 */     // MIs[0] rs1
     /*  181763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181775 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  181780 */     GIR_RootConstrainSelectedInstOperands,
     /*  181781 */     // GIR_Coverage, 892,
     /*  181781 */     GIR_Done,
     /*  181782 */   // Label 3505: @181782
     /*  181782 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(181823), // Rule ID 894 //
     /*  181787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181790 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181797 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181804 */     // MIs[0] rs1
     /*  181804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181816 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  181821 */     GIR_RootConstrainSelectedInstOperands,
     /*  181822 */     // GIR_Coverage, 894,
     /*  181822 */     GIR_Done,
     /*  181823 */   // Label 3506: @181823
     /*  181823 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(181864), // Rule ID 896 //
     /*  181828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181838 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181845 */     // MIs[0] rs1
     /*  181845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181857 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  181862 */     GIR_RootConstrainSelectedInstOperands,
     /*  181863 */     // GIR_Coverage, 896,
     /*  181863 */     GIR_Done,
     /*  181864 */   // Label 3507: @181864
     /*  181864 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(181905), // Rule ID 898 //
     /*  181869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181872 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181886 */     // MIs[0] rs1
     /*  181886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181898 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  181903 */     GIR_RootConstrainSelectedInstOperands,
     /*  181904 */     // GIR_Coverage, 898,
     /*  181904 */     GIR_Done,
     /*  181905 */   // Label 3508: @181905
     /*  181905 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(181946), // Rule ID 900 //
     /*  181910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181913 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181927 */     // MIs[0] rs1
     /*  181927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181939 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181944 */     GIR_RootConstrainSelectedInstOperands,
     /*  181945 */     // GIR_Coverage, 900,
     /*  181945 */     GIR_Done,
     /*  181946 */   // Label 3509: @181946
     /*  181946 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(181987), // Rule ID 902 //
     /*  181951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181968 */     // MIs[0] rs1
     /*  181968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181980 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181985 */     GIR_RootConstrainSelectedInstOperands,
     /*  181986 */     // GIR_Coverage, 902,
     /*  181986 */     GIR_Done,
     /*  181987 */   // Label 3510: @181987
     /*  181987 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(182028), // Rule ID 904 //
     /*  181992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181995 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182002 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182009 */     // MIs[0] rs1
     /*  182009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  182013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182021 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  182021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182026 */     GIR_RootConstrainSelectedInstOperands,
     /*  182027 */     // GIR_Coverage, 904,
     /*  182027 */     GIR_Done,
     /*  182028 */   // Label 3511: @182028
     /*  182028 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(182069), // Rule ID 906 //
     /*  182033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  182036 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182043 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182050 */     // MIs[0] rs1
     /*  182050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  182054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182062 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  182062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182067 */     GIR_RootConstrainSelectedInstOperands,
     /*  182068 */     // GIR_Coverage, 906,
     /*  182068 */     GIR_Done,
     /*  182069 */   // Label 3512: @182069
     /*  182069 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(182110), // Rule ID 908 //
     /*  182074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  182077 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182091 */     // MIs[0] rs1
     /*  182091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  182095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182103 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  182103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182108 */     GIR_RootConstrainSelectedInstOperands,
     /*  182109 */     // GIR_Coverage, 908,
     /*  182109 */     GIR_Done,
     /*  182110 */   // Label 3513: @182110
     /*  182110 */   GIM_Reject,
     /*  182111 */ // Label 3483: @182111
     /*  182111 */ GIM_Reject,
     /*  182112 */ // Label 3481: @182112
     /*  182112 */ GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(183761),
     /*  182117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  182120 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(182161), // Rule ID 361 //
     /*  182125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  182128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182142 */     // MIs[0] rs1
     /*  182142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182154 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182159 */     GIR_RootConstrainSelectedInstOperands,
     /*  182160 */     // GIR_Coverage, 361,
     /*  182160 */     GIR_Done,
     /*  182161 */   // Label 3515: @182161
     /*  182161 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(182202), // Rule ID 363 //
     /*  182166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  182169 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182176 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182183 */     // MIs[0] rs1
     /*  182183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182195 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  182200 */     GIR_RootConstrainSelectedInstOperands,
     /*  182201 */     // GIR_Coverage, 363,
     /*  182201 */     GIR_Done,
     /*  182202 */   // Label 3516: @182202
     /*  182202 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(182243), // Rule ID 365 //
     /*  182207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  182210 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182217 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182224 */     // MIs[0] rs1
     /*  182224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182236 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  182241 */     GIR_RootConstrainSelectedInstOperands,
     /*  182242 */     // GIR_Coverage, 365,
     /*  182242 */     GIR_Done,
     /*  182243 */   // Label 3517: @182243
     /*  182243 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(182284), // Rule ID 367 //
     /*  182248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  182251 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182258 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182265 */     // MIs[0] rs1
     /*  182265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182277 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  182282 */     GIR_RootConstrainSelectedInstOperands,
     /*  182283 */     // GIR_Coverage, 367,
     /*  182283 */     GIR_Done,
     /*  182284 */   // Label 3518: @182284
     /*  182284 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(182325), // Rule ID 369 //
     /*  182289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  182292 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182299 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182306 */     // MIs[0] rs1
     /*  182306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182318 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  182323 */     GIR_RootConstrainSelectedInstOperands,
     /*  182324 */     // GIR_Coverage, 369,
     /*  182324 */     GIR_Done,
     /*  182325 */   // Label 3519: @182325
     /*  182325 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(182366), // Rule ID 371 //
     /*  182330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  182333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182347 */     // MIs[0] rs1
     /*  182347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182359 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182364 */     GIR_RootConstrainSelectedInstOperands,
     /*  182365 */     // GIR_Coverage, 371,
     /*  182365 */     GIR_Done,
     /*  182366 */   // Label 3520: @182366
     /*  182366 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(182407), // Rule ID 373 //
     /*  182371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  182374 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182381 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182388 */     // MIs[0] rs1
     /*  182388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182400 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182405 */     GIR_RootConstrainSelectedInstOperands,
     /*  182406 */     // GIR_Coverage, 373,
     /*  182406 */     GIR_Done,
     /*  182407 */   // Label 3521: @182407
     /*  182407 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(182448), // Rule ID 375 //
     /*  182412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  182415 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182422 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182429 */     // MIs[0] rs1
     /*  182429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182441 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182446 */     GIR_RootConstrainSelectedInstOperands,
     /*  182447 */     // GIR_Coverage, 375,
     /*  182447 */     GIR_Done,
     /*  182448 */   // Label 3522: @182448
     /*  182448 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(182489), // Rule ID 377 //
     /*  182453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  182456 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182470 */     // MIs[0] rs1
     /*  182470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182482 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182487 */     GIR_RootConstrainSelectedInstOperands,
     /*  182488 */     // GIR_Coverage, 377,
     /*  182488 */     GIR_Done,
     /*  182489 */   // Label 3523: @182489
     /*  182489 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(182530), // Rule ID 379 //
     /*  182494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  182497 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182504 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182511 */     // MIs[0] rs1
     /*  182511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182523 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182528 */     GIR_RootConstrainSelectedInstOperands,
     /*  182529 */     // GIR_Coverage, 379,
     /*  182529 */     GIR_Done,
     /*  182530 */   // Label 3524: @182530
     /*  182530 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(182571), // Rule ID 541 //
     /*  182535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182538 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182545 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182552 */     // MIs[0] rs1
     /*  182552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182564 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182569 */     GIR_RootConstrainSelectedInstOperands,
     /*  182570 */     // GIR_Coverage, 541,
     /*  182570 */     GIR_Done,
     /*  182571 */   // Label 3525: @182571
     /*  182571 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(182612), // Rule ID 542 //
     /*  182576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182579 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182586 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182593 */     // MIs[0] rs1
     /*  182593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182605 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ),
     /*  182610 */     GIR_RootConstrainSelectedInstOperands,
     /*  182611 */     // GIR_Coverage, 542,
     /*  182611 */     GIR_Done,
     /*  182612 */   // Label 3526: @182612
     /*  182612 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(182653), // Rule ID 543 //
     /*  182617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182620 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182627 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182634 */     // MIs[0] rs1
     /*  182634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182646 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_RL),
     /*  182651 */     GIR_RootConstrainSelectedInstOperands,
     /*  182652 */     // GIR_Coverage, 543,
     /*  182652 */     GIR_Done,
     /*  182653 */   // Label 3527: @182653
     /*  182653 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(182694), // Rule ID 544 //
     /*  182658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182661 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182668 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182675 */     // MIs[0] rs1
     /*  182675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182687 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  182692 */     GIR_RootConstrainSelectedInstOperands,
     /*  182693 */     // GIR_Coverage, 544,
     /*  182693 */     GIR_Done,
     /*  182694 */   // Label 3528: @182694
     /*  182694 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(182735), // Rule ID 545 //
     /*  182699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182702 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182709 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182716 */     // MIs[0] rs1
     /*  182716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182728 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  182733 */     GIR_RootConstrainSelectedInstOperands,
     /*  182734 */     // GIR_Coverage, 545,
     /*  182734 */     GIR_Done,
     /*  182735 */   // Label 3529: @182735
     /*  182735 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(182776), // Rule ID 546 //
     /*  182740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182757 */     // MIs[0] rs1
     /*  182757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182769 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182774 */     GIR_RootConstrainSelectedInstOperands,
     /*  182775 */     // GIR_Coverage, 546,
     /*  182775 */     GIR_Done,
     /*  182776 */   // Label 3530: @182776
     /*  182776 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(182817), // Rule ID 547 //
     /*  182781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182798 */     // MIs[0] rs1
     /*  182798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182810 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182815 */     GIR_RootConstrainSelectedInstOperands,
     /*  182816 */     // GIR_Coverage, 547,
     /*  182816 */     GIR_Done,
     /*  182817 */   // Label 3531: @182817
     /*  182817 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(182858), // Rule ID 548 //
     /*  182822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182825 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182832 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182839 */     // MIs[0] rs1
     /*  182839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182851 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182856 */     GIR_RootConstrainSelectedInstOperands,
     /*  182857 */     // GIR_Coverage, 548,
     /*  182857 */     GIR_Done,
     /*  182858 */   // Label 3532: @182858
     /*  182858 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(182899), // Rule ID 549 //
     /*  182863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182866 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182873 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182880 */     // MIs[0] rs1
     /*  182880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182892 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182897 */     GIR_RootConstrainSelectedInstOperands,
     /*  182898 */     // GIR_Coverage, 549,
     /*  182898 */     GIR_Done,
     /*  182899 */   // Label 3533: @182899
     /*  182899 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(182940), // Rule ID 550 //
     /*  182904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182907 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182914 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182921 */     // MIs[0] rs1
     /*  182921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182933 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182938 */     GIR_RootConstrainSelectedInstOperands,
     /*  182939 */     // GIR_Coverage, 550,
     /*  182939 */     GIR_Done,
     /*  182940 */   // Label 3534: @182940
     /*  182940 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(182981), // Rule ID 709 //
     /*  182945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182962 */     // MIs[0] rs1
     /*  182962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182974 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182979 */     GIR_RootConstrainSelectedInstOperands,
     /*  182980 */     // GIR_Coverage, 709,
     /*  182980 */     GIR_Done,
     /*  182981 */   // Label 3535: @182981
     /*  182981 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(183022), // Rule ID 711 //
     /*  182986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182989 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182996 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183003 */     // MIs[0] rs1
     /*  183003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183015 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  183020 */     GIR_RootConstrainSelectedInstOperands,
     /*  183021 */     // GIR_Coverage, 711,
     /*  183021 */     GIR_Done,
     /*  183022 */   // Label 3536: @183022
     /*  183022 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(183063), // Rule ID 713 //
     /*  183027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183030 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183037 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183044 */     // MIs[0] rs1
     /*  183044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183056 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  183061 */     GIR_RootConstrainSelectedInstOperands,
     /*  183062 */     // GIR_Coverage, 713,
     /*  183062 */     GIR_Done,
     /*  183063 */   // Label 3537: @183063
     /*  183063 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(183104), // Rule ID 715 //
     /*  183068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183071 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183078 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183085 */     // MIs[0] rs1
     /*  183085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183097 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  183102 */     GIR_RootConstrainSelectedInstOperands,
     /*  183103 */     // GIR_Coverage, 715,
     /*  183103 */     GIR_Done,
     /*  183104 */   // Label 3538: @183104
     /*  183104 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(183145), // Rule ID 717 //
     /*  183109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183112 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183119 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183126 */     // MIs[0] rs1
     /*  183126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183138 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  183143 */     GIR_RootConstrainSelectedInstOperands,
     /*  183144 */     // GIR_Coverage, 717,
     /*  183144 */     GIR_Done,
     /*  183145 */   // Label 3539: @183145
     /*  183145 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(183186), // Rule ID 719 //
     /*  183150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183153 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183167 */     // MIs[0] rs1
     /*  183167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183179 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  183184 */     GIR_RootConstrainSelectedInstOperands,
     /*  183185 */     // GIR_Coverage, 719,
     /*  183185 */     GIR_Done,
     /*  183186 */   // Label 3540: @183186
     /*  183186 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(183227), // Rule ID 721 //
     /*  183191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183194 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183201 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183208 */     // MIs[0] rs1
     /*  183208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183220 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  183225 */     GIR_RootConstrainSelectedInstOperands,
     /*  183226 */     // GIR_Coverage, 721,
     /*  183226 */     GIR_Done,
     /*  183227 */   // Label 3541: @183227
     /*  183227 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(183268), // Rule ID 723 //
     /*  183232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183235 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183249 */     // MIs[0] rs1
     /*  183249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183261 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  183266 */     GIR_RootConstrainSelectedInstOperands,
     /*  183267 */     // GIR_Coverage, 723,
     /*  183267 */     GIR_Done,
     /*  183268 */   // Label 3542: @183268
     /*  183268 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(183309), // Rule ID 725 //
     /*  183273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183276 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183290 */     // MIs[0] rs1
     /*  183290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183302 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  183307 */     GIR_RootConstrainSelectedInstOperands,
     /*  183308 */     // GIR_Coverage, 725,
     /*  183308 */     GIR_Done,
     /*  183309 */   // Label 3543: @183309
     /*  183309 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(183350), // Rule ID 727 //
     /*  183314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183317 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183324 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183331 */     // MIs[0] rs1
     /*  183331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183343 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  183348 */     GIR_RootConstrainSelectedInstOperands,
     /*  183349 */     // GIR_Coverage, 727,
     /*  183349 */     GIR_Done,
     /*  183350 */   // Label 3544: @183350
     /*  183350 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(183391), // Rule ID 889 //
     /*  183355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183358 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183365 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183372 */     // MIs[0] rs1
     /*  183372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183384 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183389 */     GIR_RootConstrainSelectedInstOperands,
     /*  183390 */     // GIR_Coverage, 889,
     /*  183390 */     GIR_Done,
     /*  183391 */   // Label 3545: @183391
     /*  183391 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(183432), // Rule ID 891 //
     /*  183396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183399 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183406 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183413 */     // MIs[0] rs1
     /*  183413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183425 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  183430 */     GIR_RootConstrainSelectedInstOperands,
     /*  183431 */     // GIR_Coverage, 891,
     /*  183431 */     GIR_Done,
     /*  183432 */   // Label 3546: @183432
     /*  183432 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(183473), // Rule ID 893 //
     /*  183437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183440 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183454 */     // MIs[0] rs1
     /*  183454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183466 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  183471 */     GIR_RootConstrainSelectedInstOperands,
     /*  183472 */     // GIR_Coverage, 893,
     /*  183472 */     GIR_Done,
     /*  183473 */   // Label 3547: @183473
     /*  183473 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(183514), // Rule ID 895 //
     /*  183478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183481 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183488 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183495 */     // MIs[0] rs1
     /*  183495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183507 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  183512 */     GIR_RootConstrainSelectedInstOperands,
     /*  183513 */     // GIR_Coverage, 895,
     /*  183513 */     GIR_Done,
     /*  183514 */   // Label 3548: @183514
     /*  183514 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(183555), // Rule ID 897 //
     /*  183519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183522 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183529 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183536 */     // MIs[0] rs1
     /*  183536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183548 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  183553 */     GIR_RootConstrainSelectedInstOperands,
     /*  183554 */     // GIR_Coverage, 897,
     /*  183554 */     GIR_Done,
     /*  183555 */   // Label 3549: @183555
     /*  183555 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(183596), // Rule ID 899 //
     /*  183560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183563 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183570 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183577 */     // MIs[0] rs1
     /*  183577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183589 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183594 */     GIR_RootConstrainSelectedInstOperands,
     /*  183595 */     // GIR_Coverage, 899,
     /*  183595 */     GIR_Done,
     /*  183596 */   // Label 3550: @183596
     /*  183596 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(183637), // Rule ID 901 //
     /*  183601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183604 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183611 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183618 */     // MIs[0] rs1
     /*  183618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183630 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183635 */     GIR_RootConstrainSelectedInstOperands,
     /*  183636 */     // GIR_Coverage, 901,
     /*  183636 */     GIR_Done,
     /*  183637 */   // Label 3551: @183637
     /*  183637 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(183678), // Rule ID 903 //
     /*  183642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183659 */     // MIs[0] rs1
     /*  183659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183671 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183676 */     GIR_RootConstrainSelectedInstOperands,
     /*  183677 */     // GIR_Coverage, 903,
     /*  183677 */     GIR_Done,
     /*  183678 */   // Label 3552: @183678
     /*  183678 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(183719), // Rule ID 905 //
     /*  183683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183700 */     // MIs[0] rs1
     /*  183700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183712 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183717 */     GIR_RootConstrainSelectedInstOperands,
     /*  183718 */     // GIR_Coverage, 905,
     /*  183718 */     GIR_Done,
     /*  183719 */   // Label 3553: @183719
     /*  183719 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(183760), // Rule ID 907 //
     /*  183724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183727 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183741 */     // MIs[0] rs1
     /*  183741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183753 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183758 */     GIR_RootConstrainSelectedInstOperands,
     /*  183759 */     // GIR_Coverage, 907,
     /*  183759 */     GIR_Done,
     /*  183760 */   // Label 3554: @183760
     /*  183760 */   GIM_Reject,
     /*  183761 */ // Label 3514: @183761
     /*  183761 */ GIM_Reject,
     /*  183762 */ // Label 3482: @183762
     /*  183762 */ GIM_Reject,
     /*  183763 */ // Label 27: @183763
     /*  183763 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3557*/ GIMT_Encode4(186672),
     /*  183774 */ /*GILLT_s32*//*Label 3555*/ GIMT_Encode4(183782),
     /*  183778 */ /*GILLT_s64*//*Label 3556*/ GIMT_Encode4(185022),
     /*  183782 */ // Label 3555: @183782
     /*  183782 */ GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(185021),
     /*  183787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  183790 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(183831), // Rule ID 382 //
     /*  183795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183798 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183812 */     // MIs[0] rs1
     /*  183812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183824 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183829 */     GIR_RootConstrainSelectedInstOperands,
     /*  183830 */     // GIR_Coverage, 382,
     /*  183830 */     GIR_Done,
     /*  183831 */   // Label 3559: @183831
     /*  183831 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(183872), // Rule ID 384 //
     /*  183836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183839 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183846 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183853 */     // MIs[0] rs1
     /*  183853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183865 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  183870 */     GIR_RootConstrainSelectedInstOperands,
     /*  183871 */     // GIR_Coverage, 384,
     /*  183871 */     GIR_Done,
     /*  183872 */   // Label 3560: @183872
     /*  183872 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(183913), // Rule ID 386 //
     /*  183877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183880 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183894 */     // MIs[0] rs1
     /*  183894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183906 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  183911 */     GIR_RootConstrainSelectedInstOperands,
     /*  183912 */     // GIR_Coverage, 386,
     /*  183912 */     GIR_Done,
     /*  183913 */   // Label 3561: @183913
     /*  183913 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(183954), // Rule ID 388 //
     /*  183918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183921 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183935 */     // MIs[0] rs1
     /*  183935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183947 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  183952 */     GIR_RootConstrainSelectedInstOperands,
     /*  183953 */     // GIR_Coverage, 388,
     /*  183953 */     GIR_Done,
     /*  183954 */   // Label 3562: @183954
     /*  183954 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(183995), // Rule ID 390 //
     /*  183959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183976 */     // MIs[0] rs1
     /*  183976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183988 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  183993 */     GIR_RootConstrainSelectedInstOperands,
     /*  183994 */     // GIR_Coverage, 390,
     /*  183994 */     GIR_Done,
     /*  183995 */   // Label 3563: @183995
     /*  183995 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(184036), // Rule ID 392 //
     /*  184000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184017 */     // MIs[0] rs1
     /*  184017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184029 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184034 */     GIR_RootConstrainSelectedInstOperands,
     /*  184035 */     // GIR_Coverage, 392,
     /*  184035 */     GIR_Done,
     /*  184036 */   // Label 3564: @184036
     /*  184036 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(184077), // Rule ID 394 //
     /*  184041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184044 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184058 */     // MIs[0] rs1
     /*  184058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184070 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184075 */     GIR_RootConstrainSelectedInstOperands,
     /*  184076 */     // GIR_Coverage, 394,
     /*  184076 */     GIR_Done,
     /*  184077 */   // Label 3565: @184077
     /*  184077 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(184118), // Rule ID 396 //
     /*  184082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184085 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184092 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184099 */     // MIs[0] rs1
     /*  184099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184111 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184116 */     GIR_RootConstrainSelectedInstOperands,
     /*  184117 */     // GIR_Coverage, 396,
     /*  184117 */     GIR_Done,
     /*  184118 */   // Label 3566: @184118
     /*  184118 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(184159), // Rule ID 398 //
     /*  184123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184126 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184133 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184140 */     // MIs[0] rs1
     /*  184140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184152 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184157 */     GIR_RootConstrainSelectedInstOperands,
     /*  184158 */     // GIR_Coverage, 398,
     /*  184158 */     GIR_Done,
     /*  184159 */   // Label 3567: @184159
     /*  184159 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(184200), // Rule ID 400 //
     /*  184164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184167 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184174 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184181 */     // MIs[0] rs1
     /*  184181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184193 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184198 */     GIR_RootConstrainSelectedInstOperands,
     /*  184199 */     // GIR_Coverage, 400,
     /*  184199 */     GIR_Done,
     /*  184200 */   // Label 3568: @184200
     /*  184200 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(184241), // Rule ID 730 //
     /*  184205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184208 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184215 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184222 */     // MIs[0] rs1
     /*  184222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184234 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184239 */     GIR_RootConstrainSelectedInstOperands,
     /*  184240 */     // GIR_Coverage, 730,
     /*  184240 */     GIR_Done,
     /*  184241 */   // Label 3569: @184241
     /*  184241 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(184282), // Rule ID 732 //
     /*  184246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184249 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184256 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184263 */     // MIs[0] rs1
     /*  184263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184275 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  184280 */     GIR_RootConstrainSelectedInstOperands,
     /*  184281 */     // GIR_Coverage, 732,
     /*  184281 */     GIR_Done,
     /*  184282 */   // Label 3570: @184282
     /*  184282 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(184323), // Rule ID 734 //
     /*  184287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184290 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184297 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184304 */     // MIs[0] rs1
     /*  184304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184316 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  184321 */     GIR_RootConstrainSelectedInstOperands,
     /*  184322 */     // GIR_Coverage, 734,
     /*  184322 */     GIR_Done,
     /*  184323 */   // Label 3571: @184323
     /*  184323 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(184364), // Rule ID 736 //
     /*  184328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184331 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184338 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184345 */     // MIs[0] rs1
     /*  184345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184357 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  184362 */     GIR_RootConstrainSelectedInstOperands,
     /*  184363 */     // GIR_Coverage, 736,
     /*  184363 */     GIR_Done,
     /*  184364 */   // Label 3572: @184364
     /*  184364 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(184405), // Rule ID 738 //
     /*  184369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184372 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184379 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184386 */     // MIs[0] rs1
     /*  184386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184398 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  184403 */     GIR_RootConstrainSelectedInstOperands,
     /*  184404 */     // GIR_Coverage, 738,
     /*  184404 */     GIR_Done,
     /*  184405 */   // Label 3573: @184405
     /*  184405 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(184446), // Rule ID 740 //
     /*  184410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184413 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184420 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184427 */     // MIs[0] rs1
     /*  184427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184439 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184444 */     GIR_RootConstrainSelectedInstOperands,
     /*  184445 */     // GIR_Coverage, 740,
     /*  184445 */     GIR_Done,
     /*  184446 */   // Label 3574: @184446
     /*  184446 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(184487), // Rule ID 742 //
     /*  184451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184454 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184461 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184468 */     // MIs[0] rs1
     /*  184468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184480 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184485 */     GIR_RootConstrainSelectedInstOperands,
     /*  184486 */     // GIR_Coverage, 742,
     /*  184486 */     GIR_Done,
     /*  184487 */   // Label 3575: @184487
     /*  184487 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(184528), // Rule ID 744 //
     /*  184492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184495 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184502 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184509 */     // MIs[0] rs1
     /*  184509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184521 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184526 */     GIR_RootConstrainSelectedInstOperands,
     /*  184527 */     // GIR_Coverage, 744,
     /*  184527 */     GIR_Done,
     /*  184528 */   // Label 3576: @184528
     /*  184528 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(184569), // Rule ID 746 //
     /*  184533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184536 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184543 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184550 */     // MIs[0] rs1
     /*  184550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184562 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184567 */     GIR_RootConstrainSelectedInstOperands,
     /*  184568 */     // GIR_Coverage, 746,
     /*  184568 */     GIR_Done,
     /*  184569 */   // Label 3577: @184569
     /*  184569 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(184610), // Rule ID 748 //
     /*  184574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184577 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184584 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184591 */     // MIs[0] rs1
     /*  184591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184603 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184608 */     GIR_RootConstrainSelectedInstOperands,
     /*  184609 */     // GIR_Coverage, 748,
     /*  184609 */     GIR_Done,
     /*  184610 */   // Label 3578: @184610
     /*  184610 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(184651), // Rule ID 910 //
     /*  184615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184632 */     // MIs[0] rs1
     /*  184632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184644 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184649 */     GIR_RootConstrainSelectedInstOperands,
     /*  184650 */     // GIR_Coverage, 910,
     /*  184650 */     GIR_Done,
     /*  184651 */   // Label 3579: @184651
     /*  184651 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(184692), // Rule ID 912 //
     /*  184656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184659 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184666 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184673 */     // MIs[0] rs1
     /*  184673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184685 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  184690 */     GIR_RootConstrainSelectedInstOperands,
     /*  184691 */     // GIR_Coverage, 912,
     /*  184691 */     GIR_Done,
     /*  184692 */   // Label 3580: @184692
     /*  184692 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(184733), // Rule ID 914 //
     /*  184697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184707 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184714 */     // MIs[0] rs1
     /*  184714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184726 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  184731 */     GIR_RootConstrainSelectedInstOperands,
     /*  184732 */     // GIR_Coverage, 914,
     /*  184732 */     GIR_Done,
     /*  184733 */   // Label 3581: @184733
     /*  184733 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(184774), // Rule ID 916 //
     /*  184738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184741 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184748 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184755 */     // MIs[0] rs1
     /*  184755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184767 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  184772 */     GIR_RootConstrainSelectedInstOperands,
     /*  184773 */     // GIR_Coverage, 916,
     /*  184773 */     GIR_Done,
     /*  184774 */   // Label 3582: @184774
     /*  184774 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(184815), // Rule ID 918 //
     /*  184779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184782 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184789 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184796 */     // MIs[0] rs1
     /*  184796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184808 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  184813 */     GIR_RootConstrainSelectedInstOperands,
     /*  184814 */     // GIR_Coverage, 918,
     /*  184814 */     GIR_Done,
     /*  184815 */   // Label 3583: @184815
     /*  184815 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(184856), // Rule ID 920 //
     /*  184820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184830 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184837 */     // MIs[0] rs1
     /*  184837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184849 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184854 */     GIR_RootConstrainSelectedInstOperands,
     /*  184855 */     // GIR_Coverage, 920,
     /*  184855 */     GIR_Done,
     /*  184856 */   // Label 3584: @184856
     /*  184856 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(184897), // Rule ID 922 //
     /*  184861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184864 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184878 */     // MIs[0] rs1
     /*  184878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184890 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184895 */     GIR_RootConstrainSelectedInstOperands,
     /*  184896 */     // GIR_Coverage, 922,
     /*  184896 */     GIR_Done,
     /*  184897 */   // Label 3585: @184897
     /*  184897 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(184938), // Rule ID 924 //
     /*  184902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184919 */     // MIs[0] rs1
     /*  184919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184931 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184936 */     GIR_RootConstrainSelectedInstOperands,
     /*  184937 */     // GIR_Coverage, 924,
     /*  184937 */     GIR_Done,
     /*  184938 */   // Label 3586: @184938
     /*  184938 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(184979), // Rule ID 926 //
     /*  184943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184960 */     // MIs[0] rs1
     /*  184960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184972 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184977 */     GIR_RootConstrainSelectedInstOperands,
     /*  184978 */     // GIR_Coverage, 926,
     /*  184978 */     GIR_Done,
     /*  184979 */   // Label 3587: @184979
     /*  184979 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(185020), // Rule ID 928 //
     /*  184984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184987 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184994 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185001 */     // MIs[0] rs1
     /*  185001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185013 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  185018 */     GIR_RootConstrainSelectedInstOperands,
     /*  185019 */     // GIR_Coverage, 928,
     /*  185019 */     GIR_Done,
     /*  185020 */   // Label 3588: @185020
     /*  185020 */   GIM_Reject,
     /*  185021 */ // Label 3558: @185021
     /*  185021 */ GIM_Reject,
     /*  185022 */ // Label 3556: @185022
     /*  185022 */ GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(186671),
     /*  185027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  185030 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(185071), // Rule ID 381 //
     /*  185035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185038 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185045 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185052 */     // MIs[0] rs1
     /*  185052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185064 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  185069 */     GIR_RootConstrainSelectedInstOperands,
     /*  185070 */     // GIR_Coverage, 381,
     /*  185070 */     GIR_Done,
     /*  185071 */   // Label 3590: @185071
     /*  185071 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(185112), // Rule ID 383 //
     /*  185076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185079 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185086 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185093 */     // MIs[0] rs1
     /*  185093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185105 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  185110 */     GIR_RootConstrainSelectedInstOperands,
     /*  185111 */     // GIR_Coverage, 383,
     /*  185111 */     GIR_Done,
     /*  185112 */   // Label 3591: @185112
     /*  185112 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(185153), // Rule ID 385 //
     /*  185117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185120 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185127 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185134 */     // MIs[0] rs1
     /*  185134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185146 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  185151 */     GIR_RootConstrainSelectedInstOperands,
     /*  185152 */     // GIR_Coverage, 385,
     /*  185152 */     GIR_Done,
     /*  185153 */   // Label 3592: @185153
     /*  185153 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(185194), // Rule ID 387 //
     /*  185158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185175 */     // MIs[0] rs1
     /*  185175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185187 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  185192 */     GIR_RootConstrainSelectedInstOperands,
     /*  185193 */     // GIR_Coverage, 387,
     /*  185193 */     GIR_Done,
     /*  185194 */   // Label 3593: @185194
     /*  185194 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(185235), // Rule ID 389 //
     /*  185199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185202 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185209 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185216 */     // MIs[0] rs1
     /*  185216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185228 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  185233 */     GIR_RootConstrainSelectedInstOperands,
     /*  185234 */     // GIR_Coverage, 389,
     /*  185234 */     GIR_Done,
     /*  185235 */   // Label 3594: @185235
     /*  185235 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(185276), // Rule ID 391 //
     /*  185240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185243 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185250 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185257 */     // MIs[0] rs1
     /*  185257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185269 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  185274 */     GIR_RootConstrainSelectedInstOperands,
     /*  185275 */     // GIR_Coverage, 391,
     /*  185275 */     GIR_Done,
     /*  185276 */   // Label 3595: @185276
     /*  185276 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(185317), // Rule ID 393 //
     /*  185281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185284 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185291 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185298 */     // MIs[0] rs1
     /*  185298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185310 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  185315 */     GIR_RootConstrainSelectedInstOperands,
     /*  185316 */     // GIR_Coverage, 393,
     /*  185316 */     GIR_Done,
     /*  185317 */   // Label 3596: @185317
     /*  185317 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(185358), // Rule ID 395 //
     /*  185322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185325 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185332 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185339 */     // MIs[0] rs1
     /*  185339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185351 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  185356 */     GIR_RootConstrainSelectedInstOperands,
     /*  185357 */     // GIR_Coverage, 395,
     /*  185357 */     GIR_Done,
     /*  185358 */   // Label 3597: @185358
     /*  185358 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(185399), // Rule ID 397 //
     /*  185363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185366 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185373 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185380 */     // MIs[0] rs1
     /*  185380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185392 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  185397 */     GIR_RootConstrainSelectedInstOperands,
     /*  185398 */     // GIR_Coverage, 397,
     /*  185398 */     GIR_Done,
     /*  185399 */   // Label 3598: @185399
     /*  185399 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(185440), // Rule ID 399 //
     /*  185404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185407 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185414 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185421 */     // MIs[0] rs1
     /*  185421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185433 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  185438 */     GIR_RootConstrainSelectedInstOperands,
     /*  185439 */     // GIR_Coverage, 399,
     /*  185439 */     GIR_Done,
     /*  185440 */   // Label 3599: @185440
     /*  185440 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(185481), // Rule ID 551 //
     /*  185445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185448 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185455 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185462 */     // MIs[0] rs1
     /*  185462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185474 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185479 */     GIR_RootConstrainSelectedInstOperands,
     /*  185480 */     // GIR_Coverage, 551,
     /*  185480 */     GIR_Done,
     /*  185481 */   // Label 3600: @185481
     /*  185481 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(185522), // Rule ID 552 //
     /*  185486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185489 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185496 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185503 */     // MIs[0] rs1
     /*  185503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185515 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ),
     /*  185520 */     GIR_RootConstrainSelectedInstOperands,
     /*  185521 */     // GIR_Coverage, 552,
     /*  185521 */     GIR_Done,
     /*  185522 */   // Label 3601: @185522
     /*  185522 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(185563), // Rule ID 553 //
     /*  185527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185530 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185537 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185544 */     // MIs[0] rs1
     /*  185544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185556 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_RL),
     /*  185561 */     GIR_RootConstrainSelectedInstOperands,
     /*  185562 */     // GIR_Coverage, 553,
     /*  185562 */     GIR_Done,
     /*  185563 */   // Label 3602: @185563
     /*  185563 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(185604), // Rule ID 554 //
     /*  185568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185571 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185578 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185585 */     // MIs[0] rs1
     /*  185585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185597 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  185602 */     GIR_RootConstrainSelectedInstOperands,
     /*  185603 */     // GIR_Coverage, 554,
     /*  185603 */     GIR_Done,
     /*  185604 */   // Label 3603: @185604
     /*  185604 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(185645), // Rule ID 555 //
     /*  185609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185612 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185619 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185626 */     // MIs[0] rs1
     /*  185626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185638 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  185643 */     GIR_RootConstrainSelectedInstOperands,
     /*  185644 */     // GIR_Coverage, 555,
     /*  185644 */     GIR_Done,
     /*  185645 */   // Label 3604: @185645
     /*  185645 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(185686), // Rule ID 556 //
     /*  185650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185653 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185660 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185667 */     // MIs[0] rs1
     /*  185667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185679 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185684 */     GIR_RootConstrainSelectedInstOperands,
     /*  185685 */     // GIR_Coverage, 556,
     /*  185685 */     GIR_Done,
     /*  185686 */   // Label 3605: @185686
     /*  185686 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(185727), // Rule ID 557 //
     /*  185691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185708 */     // MIs[0] rs1
     /*  185708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185720 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185725 */     GIR_RootConstrainSelectedInstOperands,
     /*  185726 */     // GIR_Coverage, 557,
     /*  185726 */     GIR_Done,
     /*  185727 */   // Label 3606: @185727
     /*  185727 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(185768), // Rule ID 558 //
     /*  185732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185735 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185749 */     // MIs[0] rs1
     /*  185749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185761 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185766 */     GIR_RootConstrainSelectedInstOperands,
     /*  185767 */     // GIR_Coverage, 558,
     /*  185767 */     GIR_Done,
     /*  185768 */   // Label 3607: @185768
     /*  185768 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(185809), // Rule ID 559 //
     /*  185773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185776 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185790 */     // MIs[0] rs1
     /*  185790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185802 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185807 */     GIR_RootConstrainSelectedInstOperands,
     /*  185808 */     // GIR_Coverage, 559,
     /*  185808 */     GIR_Done,
     /*  185809 */   // Label 3608: @185809
     /*  185809 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(185850), // Rule ID 560 //
     /*  185814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185817 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185824 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185831 */     // MIs[0] rs1
     /*  185831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185843 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185848 */     GIR_RootConstrainSelectedInstOperands,
     /*  185849 */     // GIR_Coverage, 560,
     /*  185849 */     GIR_Done,
     /*  185850 */   // Label 3609: @185850
     /*  185850 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(185891), // Rule ID 729 //
     /*  185855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185858 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185865 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185872 */     // MIs[0] rs1
     /*  185872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185884 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185889 */     GIR_RootConstrainSelectedInstOperands,
     /*  185890 */     // GIR_Coverage, 729,
     /*  185890 */     GIR_Done,
     /*  185891 */   // Label 3610: @185891
     /*  185891 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(185932), // Rule ID 731 //
     /*  185896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185899 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185906 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185913 */     // MIs[0] rs1
     /*  185913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185925 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  185930 */     GIR_RootConstrainSelectedInstOperands,
     /*  185931 */     // GIR_Coverage, 731,
     /*  185931 */     GIR_Done,
     /*  185932 */   // Label 3611: @185932
     /*  185932 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(185973), // Rule ID 733 //
     /*  185937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185954 */     // MIs[0] rs1
     /*  185954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185966 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  185971 */     GIR_RootConstrainSelectedInstOperands,
     /*  185972 */     // GIR_Coverage, 733,
     /*  185972 */     GIR_Done,
     /*  185973 */   // Label 3612: @185973
     /*  185973 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(186014), // Rule ID 735 //
     /*  185978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185981 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185988 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185995 */     // MIs[0] rs1
     /*  185995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186007 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  186012 */     GIR_RootConstrainSelectedInstOperands,
     /*  186013 */     // GIR_Coverage, 735,
     /*  186013 */     GIR_Done,
     /*  186014 */   // Label 3613: @186014
     /*  186014 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(186055), // Rule ID 737 //
     /*  186019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186022 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186036 */     // MIs[0] rs1
     /*  186036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186048 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  186053 */     GIR_RootConstrainSelectedInstOperands,
     /*  186054 */     // GIR_Coverage, 737,
     /*  186054 */     GIR_Done,
     /*  186055 */   // Label 3614: @186055
     /*  186055 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(186096), // Rule ID 739 //
     /*  186060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186077 */     // MIs[0] rs1
     /*  186077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186089 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  186094 */     GIR_RootConstrainSelectedInstOperands,
     /*  186095 */     // GIR_Coverage, 739,
     /*  186095 */     GIR_Done,
     /*  186096 */   // Label 3615: @186096
     /*  186096 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(186137), // Rule ID 741 //
     /*  186101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186104 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186111 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186118 */     // MIs[0] rs1
     /*  186118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186130 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  186135 */     GIR_RootConstrainSelectedInstOperands,
     /*  186136 */     // GIR_Coverage, 741,
     /*  186136 */     GIR_Done,
     /*  186137 */   // Label 3616: @186137
     /*  186137 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(186178), // Rule ID 743 //
     /*  186142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186159 */     // MIs[0] rs1
     /*  186159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186171 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  186176 */     GIR_RootConstrainSelectedInstOperands,
     /*  186177 */     // GIR_Coverage, 743,
     /*  186177 */     GIR_Done,
     /*  186178 */   // Label 3617: @186178
     /*  186178 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(186219), // Rule ID 745 //
     /*  186183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186186 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186193 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186200 */     // MIs[0] rs1
     /*  186200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186212 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  186217 */     GIR_RootConstrainSelectedInstOperands,
     /*  186218 */     // GIR_Coverage, 745,
     /*  186218 */     GIR_Done,
     /*  186219 */   // Label 3618: @186219
     /*  186219 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(186260), // Rule ID 747 //
     /*  186224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186227 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186234 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186241 */     // MIs[0] rs1
     /*  186241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186253 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  186258 */     GIR_RootConstrainSelectedInstOperands,
     /*  186259 */     // GIR_Coverage, 747,
     /*  186259 */     GIR_Done,
     /*  186260 */   // Label 3619: @186260
     /*  186260 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(186301), // Rule ID 909 //
     /*  186265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186268 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186275 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186282 */     // MIs[0] rs1
     /*  186282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186294 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186299 */     GIR_RootConstrainSelectedInstOperands,
     /*  186300 */     // GIR_Coverage, 909,
     /*  186300 */     GIR_Done,
     /*  186301 */   // Label 3620: @186301
     /*  186301 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(186342), // Rule ID 911 //
     /*  186306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186309 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186316 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186323 */     // MIs[0] rs1
     /*  186323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186335 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  186340 */     GIR_RootConstrainSelectedInstOperands,
     /*  186341 */     // GIR_Coverage, 911,
     /*  186341 */     GIR_Done,
     /*  186342 */   // Label 3621: @186342
     /*  186342 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(186383), // Rule ID 913 //
     /*  186347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186350 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186357 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186364 */     // MIs[0] rs1
     /*  186364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186376 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  186381 */     GIR_RootConstrainSelectedInstOperands,
     /*  186382 */     // GIR_Coverage, 913,
     /*  186382 */     GIR_Done,
     /*  186383 */   // Label 3622: @186383
     /*  186383 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(186424), // Rule ID 915 //
     /*  186388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186391 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186398 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186405 */     // MIs[0] rs1
     /*  186405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186417 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  186422 */     GIR_RootConstrainSelectedInstOperands,
     /*  186423 */     // GIR_Coverage, 915,
     /*  186423 */     GIR_Done,
     /*  186424 */   // Label 3623: @186424
     /*  186424 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(186465), // Rule ID 917 //
     /*  186429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186432 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186446 */     // MIs[0] rs1
     /*  186446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186458 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  186463 */     GIR_RootConstrainSelectedInstOperands,
     /*  186464 */     // GIR_Coverage, 917,
     /*  186464 */     GIR_Done,
     /*  186465 */   // Label 3624: @186465
     /*  186465 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(186506), // Rule ID 919 //
     /*  186470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186480 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186487 */     // MIs[0] rs1
     /*  186487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186499 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186504 */     GIR_RootConstrainSelectedInstOperands,
     /*  186505 */     // GIR_Coverage, 919,
     /*  186505 */     GIR_Done,
     /*  186506 */   // Label 3625: @186506
     /*  186506 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(186547), // Rule ID 921 //
     /*  186511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186514 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186521 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186528 */     // MIs[0] rs1
     /*  186528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186540 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186545 */     GIR_RootConstrainSelectedInstOperands,
     /*  186546 */     // GIR_Coverage, 921,
     /*  186546 */     GIR_Done,
     /*  186547 */   // Label 3626: @186547
     /*  186547 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(186588), // Rule ID 923 //
     /*  186552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186562 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186569 */     // MIs[0] rs1
     /*  186569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186581 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186586 */     GIR_RootConstrainSelectedInstOperands,
     /*  186587 */     // GIR_Coverage, 923,
     /*  186587 */     GIR_Done,
     /*  186588 */   // Label 3627: @186588
     /*  186588 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(186629), // Rule ID 925 //
     /*  186593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186610 */     // MIs[0] rs1
     /*  186610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186622 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186627 */     GIR_RootConstrainSelectedInstOperands,
     /*  186628 */     // GIR_Coverage, 925,
     /*  186628 */     GIR_Done,
     /*  186629 */   // Label 3628: @186629
     /*  186629 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(186670), // Rule ID 927 //
     /*  186634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186651 */     // MIs[0] rs1
     /*  186651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186663 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186668 */     GIR_RootConstrainSelectedInstOperands,
     /*  186669 */     // GIR_Coverage, 927,
     /*  186669 */     GIR_Done,
     /*  186670 */   // Label 3629: @186670
     /*  186670 */   GIM_Reject,
     /*  186671 */ // Label 3589: @186671
     /*  186671 */ GIM_Reject,
     /*  186672 */ // Label 3557: @186672
     /*  186672 */ GIM_Reject,
     /*  186673 */ // Label 28: @186673
     /*  186673 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3632*/ GIMT_Encode4(189582),
     /*  186684 */ /*GILLT_s32*//*Label 3630*/ GIMT_Encode4(186692),
     /*  186688 */ /*GILLT_s64*//*Label 3631*/ GIMT_Encode4(187932),
     /*  186692 */ // Label 3630: @186692
     /*  186692 */ GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(187931),
     /*  186697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  186700 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(186741), // Rule ID 402 //
     /*  186705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186708 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186715 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186722 */     // MIs[0] rs1
     /*  186722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186734 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186739 */     GIR_RootConstrainSelectedInstOperands,
     /*  186740 */     // GIR_Coverage, 402,
     /*  186740 */     GIR_Done,
     /*  186741 */   // Label 3634: @186741
     /*  186741 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(186782), // Rule ID 404 //
     /*  186746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186749 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186756 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186763 */     // MIs[0] rs1
     /*  186763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186775 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  186780 */     GIR_RootConstrainSelectedInstOperands,
     /*  186781 */     // GIR_Coverage, 404,
     /*  186781 */     GIR_Done,
     /*  186782 */   // Label 3635: @186782
     /*  186782 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(186823), // Rule ID 406 //
     /*  186787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186790 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186797 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186804 */     // MIs[0] rs1
     /*  186804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186816 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  186821 */     GIR_RootConstrainSelectedInstOperands,
     /*  186822 */     // GIR_Coverage, 406,
     /*  186822 */     GIR_Done,
     /*  186823 */   // Label 3636: @186823
     /*  186823 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(186864), // Rule ID 408 //
     /*  186828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186838 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186845 */     // MIs[0] rs1
     /*  186845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186857 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  186862 */     GIR_RootConstrainSelectedInstOperands,
     /*  186863 */     // GIR_Coverage, 408,
     /*  186863 */     GIR_Done,
     /*  186864 */   // Label 3637: @186864
     /*  186864 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(186905), // Rule ID 410 //
     /*  186869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186872 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186886 */     // MIs[0] rs1
     /*  186886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186898 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  186903 */     GIR_RootConstrainSelectedInstOperands,
     /*  186904 */     // GIR_Coverage, 410,
     /*  186904 */     GIR_Done,
     /*  186905 */   // Label 3638: @186905
     /*  186905 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(186946), // Rule ID 412 //
     /*  186910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186913 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186927 */     // MIs[0] rs1
     /*  186927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186939 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186944 */     GIR_RootConstrainSelectedInstOperands,
     /*  186945 */     // GIR_Coverage, 412,
     /*  186945 */     GIR_Done,
     /*  186946 */   // Label 3639: @186946
     /*  186946 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(186987), // Rule ID 414 //
     /*  186951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186968 */     // MIs[0] rs1
     /*  186968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186980 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186985 */     GIR_RootConstrainSelectedInstOperands,
     /*  186986 */     // GIR_Coverage, 414,
     /*  186986 */     GIR_Done,
     /*  186987 */   // Label 3640: @186987
     /*  186987 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(187028), // Rule ID 416 //
     /*  186992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186995 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187002 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187009 */     // MIs[0] rs1
     /*  187009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187021 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187026 */     GIR_RootConstrainSelectedInstOperands,
     /*  187027 */     // GIR_Coverage, 416,
     /*  187027 */     GIR_Done,
     /*  187028 */   // Label 3641: @187028
     /*  187028 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(187069), // Rule ID 418 //
     /*  187033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187036 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187043 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187050 */     // MIs[0] rs1
     /*  187050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187062 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187067 */     GIR_RootConstrainSelectedInstOperands,
     /*  187068 */     // GIR_Coverage, 418,
     /*  187068 */     GIR_Done,
     /*  187069 */   // Label 3642: @187069
     /*  187069 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(187110), // Rule ID 420 //
     /*  187074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187077 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187091 */     // MIs[0] rs1
     /*  187091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187103 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187108 */     GIR_RootConstrainSelectedInstOperands,
     /*  187109 */     // GIR_Coverage, 420,
     /*  187109 */     GIR_Done,
     /*  187110 */   // Label 3643: @187110
     /*  187110 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(187151), // Rule ID 750 //
     /*  187115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187118 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187125 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187132 */     // MIs[0] rs1
     /*  187132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187144 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187144 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187149 */     GIR_RootConstrainSelectedInstOperands,
     /*  187150 */     // GIR_Coverage, 750,
     /*  187150 */     GIR_Done,
     /*  187151 */   // Label 3644: @187151
     /*  187151 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(187192), // Rule ID 752 //
     /*  187156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187159 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187166 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187173 */     // MIs[0] rs1
     /*  187173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187185 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187185 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  187190 */     GIR_RootConstrainSelectedInstOperands,
     /*  187191 */     // GIR_Coverage, 752,
     /*  187191 */     GIR_Done,
     /*  187192 */   // Label 3645: @187192
     /*  187192 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(187233), // Rule ID 754 //
     /*  187197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187200 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187207 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187214 */     // MIs[0] rs1
     /*  187214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187226 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  187231 */     GIR_RootConstrainSelectedInstOperands,
     /*  187232 */     // GIR_Coverage, 754,
     /*  187232 */     GIR_Done,
     /*  187233 */   // Label 3646: @187233
     /*  187233 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(187274), // Rule ID 756 //
     /*  187238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187241 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187248 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187255 */     // MIs[0] rs1
     /*  187255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187267 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  187272 */     GIR_RootConstrainSelectedInstOperands,
     /*  187273 */     // GIR_Coverage, 756,
     /*  187273 */     GIR_Done,
     /*  187274 */   // Label 3647: @187274
     /*  187274 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(187315), // Rule ID 758 //
     /*  187279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187282 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187289 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187296 */     // MIs[0] rs1
     /*  187296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187308 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187308 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  187313 */     GIR_RootConstrainSelectedInstOperands,
     /*  187314 */     // GIR_Coverage, 758,
     /*  187314 */     GIR_Done,
     /*  187315 */   // Label 3648: @187315
     /*  187315 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(187356), // Rule ID 760 //
     /*  187320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187323 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187330 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187337 */     // MIs[0] rs1
     /*  187337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187349 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187354 */     GIR_RootConstrainSelectedInstOperands,
     /*  187355 */     // GIR_Coverage, 760,
     /*  187355 */     GIR_Done,
     /*  187356 */   // Label 3649: @187356
     /*  187356 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(187397), // Rule ID 762 //
     /*  187361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187364 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187371 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187378 */     // MIs[0] rs1
     /*  187378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187390 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187395 */     GIR_RootConstrainSelectedInstOperands,
     /*  187396 */     // GIR_Coverage, 762,
     /*  187396 */     GIR_Done,
     /*  187397 */   // Label 3650: @187397
     /*  187397 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(187438), // Rule ID 764 //
     /*  187402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187405 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187412 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187419 */     // MIs[0] rs1
     /*  187419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187431 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187436 */     GIR_RootConstrainSelectedInstOperands,
     /*  187437 */     // GIR_Coverage, 764,
     /*  187437 */     GIR_Done,
     /*  187438 */   // Label 3651: @187438
     /*  187438 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(187479), // Rule ID 766 //
     /*  187443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187446 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187453 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187460 */     // MIs[0] rs1
     /*  187460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187472 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187477 */     GIR_RootConstrainSelectedInstOperands,
     /*  187478 */     // GIR_Coverage, 766,
     /*  187478 */     GIR_Done,
     /*  187479 */   // Label 3652: @187479
     /*  187479 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(187520), // Rule ID 768 //
     /*  187484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187487 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187494 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187501 */     // MIs[0] rs1
     /*  187501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187513 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187518 */     GIR_RootConstrainSelectedInstOperands,
     /*  187519 */     // GIR_Coverage, 768,
     /*  187519 */     GIR_Done,
     /*  187520 */   // Label 3653: @187520
     /*  187520 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(187561), // Rule ID 930 //
     /*  187525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187528 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187535 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187542 */     // MIs[0] rs1
     /*  187542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187554 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187559 */     GIR_RootConstrainSelectedInstOperands,
     /*  187560 */     // GIR_Coverage, 930,
     /*  187560 */     GIR_Done,
     /*  187561 */   // Label 3654: @187561
     /*  187561 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(187602), // Rule ID 932 //
     /*  187566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187569 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187576 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187583 */     // MIs[0] rs1
     /*  187583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187595 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  187600 */     GIR_RootConstrainSelectedInstOperands,
     /*  187601 */     // GIR_Coverage, 932,
     /*  187601 */     GIR_Done,
     /*  187602 */   // Label 3655: @187602
     /*  187602 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(187643), // Rule ID 934 //
     /*  187607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187610 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187624 */     // MIs[0] rs1
     /*  187624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187636 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  187641 */     GIR_RootConstrainSelectedInstOperands,
     /*  187642 */     // GIR_Coverage, 934,
     /*  187642 */     GIR_Done,
     /*  187643 */   // Label 3656: @187643
     /*  187643 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(187684), // Rule ID 936 //
     /*  187648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187651 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187658 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187665 */     // MIs[0] rs1
     /*  187665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187677 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  187682 */     GIR_RootConstrainSelectedInstOperands,
     /*  187683 */     // GIR_Coverage, 936,
     /*  187683 */     GIR_Done,
     /*  187684 */   // Label 3657: @187684
     /*  187684 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(187725), // Rule ID 938 //
     /*  187689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187692 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187699 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187706 */     // MIs[0] rs1
     /*  187706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187718 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  187723 */     GIR_RootConstrainSelectedInstOperands,
     /*  187724 */     // GIR_Coverage, 938,
     /*  187724 */     GIR_Done,
     /*  187725 */   // Label 3658: @187725
     /*  187725 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(187766), // Rule ID 940 //
     /*  187730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187733 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187747 */     // MIs[0] rs1
     /*  187747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187759 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187764 */     GIR_RootConstrainSelectedInstOperands,
     /*  187765 */     // GIR_Coverage, 940,
     /*  187765 */     GIR_Done,
     /*  187766 */   // Label 3659: @187766
     /*  187766 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(187807), // Rule ID 942 //
     /*  187771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187774 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187781 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187788 */     // MIs[0] rs1
     /*  187788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187800 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187805 */     GIR_RootConstrainSelectedInstOperands,
     /*  187806 */     // GIR_Coverage, 942,
     /*  187806 */     GIR_Done,
     /*  187807 */   // Label 3660: @187807
     /*  187807 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(187848), // Rule ID 944 //
     /*  187812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187829 */     // MIs[0] rs1
     /*  187829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187841 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187846 */     GIR_RootConstrainSelectedInstOperands,
     /*  187847 */     // GIR_Coverage, 944,
     /*  187847 */     GIR_Done,
     /*  187848 */   // Label 3661: @187848
     /*  187848 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(187889), // Rule ID 946 //
     /*  187853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187856 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187863 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187870 */     // MIs[0] rs1
     /*  187870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187882 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187887 */     GIR_RootConstrainSelectedInstOperands,
     /*  187888 */     // GIR_Coverage, 946,
     /*  187888 */     GIR_Done,
     /*  187889 */   // Label 3662: @187889
     /*  187889 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(187930), // Rule ID 948 //
     /*  187894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187897 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187904 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187911 */     // MIs[0] rs1
     /*  187911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187923 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187928 */     GIR_RootConstrainSelectedInstOperands,
     /*  187929 */     // GIR_Coverage, 948,
     /*  187929 */     GIR_Done,
     /*  187930 */   // Label 3663: @187930
     /*  187930 */   GIM_Reject,
     /*  187931 */ // Label 3633: @187931
     /*  187931 */ GIM_Reject,
     /*  187932 */ // Label 3631: @187932
     /*  187932 */ GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(189581),
     /*  187937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  187940 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(187981), // Rule ID 401 //
     /*  187945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187962 */     // MIs[0] rs1
     /*  187962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187974 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187979 */     GIR_RootConstrainSelectedInstOperands,
     /*  187980 */     // GIR_Coverage, 401,
     /*  187980 */     GIR_Done,
     /*  187981 */   // Label 3665: @187981
     /*  187981 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(188022), // Rule ID 403 //
     /*  187986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187989 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187996 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188003 */     // MIs[0] rs1
     /*  188003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188015 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  188020 */     GIR_RootConstrainSelectedInstOperands,
     /*  188021 */     // GIR_Coverage, 403,
     /*  188021 */     GIR_Done,
     /*  188022 */   // Label 3666: @188022
     /*  188022 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(188063), // Rule ID 405 //
     /*  188027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188030 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188037 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188044 */     // MIs[0] rs1
     /*  188044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188056 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  188061 */     GIR_RootConstrainSelectedInstOperands,
     /*  188062 */     // GIR_Coverage, 405,
     /*  188062 */     GIR_Done,
     /*  188063 */   // Label 3667: @188063
     /*  188063 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(188104), // Rule ID 407 //
     /*  188068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188071 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188078 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188085 */     // MIs[0] rs1
     /*  188085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188097 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  188102 */     GIR_RootConstrainSelectedInstOperands,
     /*  188103 */     // GIR_Coverage, 407,
     /*  188103 */     GIR_Done,
     /*  188104 */   // Label 3668: @188104
     /*  188104 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(188145), // Rule ID 409 //
     /*  188109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188112 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188119 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188126 */     // MIs[0] rs1
     /*  188126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188138 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  188143 */     GIR_RootConstrainSelectedInstOperands,
     /*  188144 */     // GIR_Coverage, 409,
     /*  188144 */     GIR_Done,
     /*  188145 */   // Label 3669: @188145
     /*  188145 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(188186), // Rule ID 411 //
     /*  188150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188153 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188167 */     // MIs[0] rs1
     /*  188167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188179 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  188184 */     GIR_RootConstrainSelectedInstOperands,
     /*  188185 */     // GIR_Coverage, 411,
     /*  188185 */     GIR_Done,
     /*  188186 */   // Label 3670: @188186
     /*  188186 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(188227), // Rule ID 413 //
     /*  188191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188194 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188201 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188208 */     // MIs[0] rs1
     /*  188208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188220 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  188225 */     GIR_RootConstrainSelectedInstOperands,
     /*  188226 */     // GIR_Coverage, 413,
     /*  188226 */     GIR_Done,
     /*  188227 */   // Label 3671: @188227
     /*  188227 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(188268), // Rule ID 415 //
     /*  188232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188235 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188249 */     // MIs[0] rs1
     /*  188249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188261 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  188266 */     GIR_RootConstrainSelectedInstOperands,
     /*  188267 */     // GIR_Coverage, 415,
     /*  188267 */     GIR_Done,
     /*  188268 */   // Label 3672: @188268
     /*  188268 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(188309), // Rule ID 417 //
     /*  188273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188276 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188290 */     // MIs[0] rs1
     /*  188290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188302 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  188307 */     GIR_RootConstrainSelectedInstOperands,
     /*  188308 */     // GIR_Coverage, 417,
     /*  188308 */     GIR_Done,
     /*  188309 */   // Label 3673: @188309
     /*  188309 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(188350), // Rule ID 419 //
     /*  188314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188317 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188324 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188331 */     // MIs[0] rs1
     /*  188331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188343 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  188348 */     GIR_RootConstrainSelectedInstOperands,
     /*  188349 */     // GIR_Coverage, 419,
     /*  188349 */     GIR_Done,
     /*  188350 */   // Label 3674: @188350
     /*  188350 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(188391), // Rule ID 561 //
     /*  188355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188358 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188365 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188372 */     // MIs[0] rs1
     /*  188372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188384 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188389 */     GIR_RootConstrainSelectedInstOperands,
     /*  188390 */     // GIR_Coverage, 561,
     /*  188390 */     GIR_Done,
     /*  188391 */   // Label 3675: @188391
     /*  188391 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(188432), // Rule ID 562 //
     /*  188396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188399 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188406 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188413 */     // MIs[0] rs1
     /*  188413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188425 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ),
     /*  188430 */     GIR_RootConstrainSelectedInstOperands,
     /*  188431 */     // GIR_Coverage, 562,
     /*  188431 */     GIR_Done,
     /*  188432 */   // Label 3676: @188432
     /*  188432 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(188473), // Rule ID 563 //
     /*  188437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188440 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188454 */     // MIs[0] rs1
     /*  188454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188466 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_RL),
     /*  188471 */     GIR_RootConstrainSelectedInstOperands,
     /*  188472 */     // GIR_Coverage, 563,
     /*  188472 */     GIR_Done,
     /*  188473 */   // Label 3677: @188473
     /*  188473 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(188514), // Rule ID 564 //
     /*  188478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188481 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188488 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188495 */     // MIs[0] rs1
     /*  188495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188507 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  188512 */     GIR_RootConstrainSelectedInstOperands,
     /*  188513 */     // GIR_Coverage, 564,
     /*  188513 */     GIR_Done,
     /*  188514 */   // Label 3678: @188514
     /*  188514 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(188555), // Rule ID 565 //
     /*  188519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188522 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188529 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188536 */     // MIs[0] rs1
     /*  188536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188548 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  188553 */     GIR_RootConstrainSelectedInstOperands,
     /*  188554 */     // GIR_Coverage, 565,
     /*  188554 */     GIR_Done,
     /*  188555 */   // Label 3679: @188555
     /*  188555 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(188596), // Rule ID 566 //
     /*  188560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188563 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188570 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188577 */     // MIs[0] rs1
     /*  188577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188589 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188594 */     GIR_RootConstrainSelectedInstOperands,
     /*  188595 */     // GIR_Coverage, 566,
     /*  188595 */     GIR_Done,
     /*  188596 */   // Label 3680: @188596
     /*  188596 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(188637), // Rule ID 567 //
     /*  188601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188604 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188611 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188618 */     // MIs[0] rs1
     /*  188618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188630 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188635 */     GIR_RootConstrainSelectedInstOperands,
     /*  188636 */     // GIR_Coverage, 567,
     /*  188636 */     GIR_Done,
     /*  188637 */   // Label 3681: @188637
     /*  188637 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(188678), // Rule ID 568 //
     /*  188642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188659 */     // MIs[0] rs1
     /*  188659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188671 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188676 */     GIR_RootConstrainSelectedInstOperands,
     /*  188677 */     // GIR_Coverage, 568,
     /*  188677 */     GIR_Done,
     /*  188678 */   // Label 3682: @188678
     /*  188678 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(188719), // Rule ID 569 //
     /*  188683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188700 */     // MIs[0] rs1
     /*  188700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188712 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188717 */     GIR_RootConstrainSelectedInstOperands,
     /*  188718 */     // GIR_Coverage, 569,
     /*  188718 */     GIR_Done,
     /*  188719 */   // Label 3683: @188719
     /*  188719 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(188760), // Rule ID 570 //
     /*  188724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188727 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188741 */     // MIs[0] rs1
     /*  188741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188753 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188758 */     GIR_RootConstrainSelectedInstOperands,
     /*  188759 */     // GIR_Coverage, 570,
     /*  188759 */     GIR_Done,
     /*  188760 */   // Label 3684: @188760
     /*  188760 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(188801), // Rule ID 749 //
     /*  188765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188768 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188775 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188782 */     // MIs[0] rs1
     /*  188782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188794 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188799 */     GIR_RootConstrainSelectedInstOperands,
     /*  188800 */     // GIR_Coverage, 749,
     /*  188800 */     GIR_Done,
     /*  188801 */   // Label 3685: @188801
     /*  188801 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(188842), // Rule ID 751 //
     /*  188806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188809 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188816 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188823 */     // MIs[0] rs1
     /*  188823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188835 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  188840 */     GIR_RootConstrainSelectedInstOperands,
     /*  188841 */     // GIR_Coverage, 751,
     /*  188841 */     GIR_Done,
     /*  188842 */   // Label 3686: @188842
     /*  188842 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(188883), // Rule ID 753 //
     /*  188847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188850 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188864 */     // MIs[0] rs1
     /*  188864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188876 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  188881 */     GIR_RootConstrainSelectedInstOperands,
     /*  188882 */     // GIR_Coverage, 753,
     /*  188882 */     GIR_Done,
     /*  188883 */   // Label 3687: @188883
     /*  188883 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(188924), // Rule ID 755 //
     /*  188888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188898 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188905 */     // MIs[0] rs1
     /*  188905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188917 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  188922 */     GIR_RootConstrainSelectedInstOperands,
     /*  188923 */     // GIR_Coverage, 755,
     /*  188923 */     GIR_Done,
     /*  188924 */   // Label 3688: @188924
     /*  188924 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(188965), // Rule ID 757 //
     /*  188929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188932 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188939 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188946 */     // MIs[0] rs1
     /*  188946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188958 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  188963 */     GIR_RootConstrainSelectedInstOperands,
     /*  188964 */     // GIR_Coverage, 757,
     /*  188964 */     GIR_Done,
     /*  188965 */   // Label 3689: @188965
     /*  188965 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(189006), // Rule ID 759 //
     /*  188970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188973 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188980 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188987 */     // MIs[0] rs1
     /*  188987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188999 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  189004 */     GIR_RootConstrainSelectedInstOperands,
     /*  189005 */     // GIR_Coverage, 759,
     /*  189005 */     GIR_Done,
     /*  189006 */   // Label 3690: @189006
     /*  189006 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(189047), // Rule ID 761 //
     /*  189011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189014 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189021 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189028 */     // MIs[0] rs1
     /*  189028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189040 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  189045 */     GIR_RootConstrainSelectedInstOperands,
     /*  189046 */     // GIR_Coverage, 761,
     /*  189046 */     GIR_Done,
     /*  189047 */   // Label 3691: @189047
     /*  189047 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(189088), // Rule ID 763 //
     /*  189052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189055 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189062 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189069 */     // MIs[0] rs1
     /*  189069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189081 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  189086 */     GIR_RootConstrainSelectedInstOperands,
     /*  189087 */     // GIR_Coverage, 763,
     /*  189087 */     GIR_Done,
     /*  189088 */   // Label 3692: @189088
     /*  189088 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(189129), // Rule ID 765 //
     /*  189093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189096 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189103 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189110 */     // MIs[0] rs1
     /*  189110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189122 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  189127 */     GIR_RootConstrainSelectedInstOperands,
     /*  189128 */     // GIR_Coverage, 765,
     /*  189128 */     GIR_Done,
     /*  189129 */   // Label 3693: @189129
     /*  189129 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(189170), // Rule ID 767 //
     /*  189134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189137 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189144 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189151 */     // MIs[0] rs1
     /*  189151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189163 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  189168 */     GIR_RootConstrainSelectedInstOperands,
     /*  189169 */     // GIR_Coverage, 767,
     /*  189169 */     GIR_Done,
     /*  189170 */   // Label 3694: @189170
     /*  189170 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(189211), // Rule ID 929 //
     /*  189175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189178 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189185 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189192 */     // MIs[0] rs1
     /*  189192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189204 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189209 */     GIR_RootConstrainSelectedInstOperands,
     /*  189210 */     // GIR_Coverage, 929,
     /*  189210 */     GIR_Done,
     /*  189211 */   // Label 3695: @189211
     /*  189211 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(189252), // Rule ID 931 //
     /*  189216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189219 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189226 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189233 */     // MIs[0] rs1
     /*  189233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189245 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  189250 */     GIR_RootConstrainSelectedInstOperands,
     /*  189251 */     // GIR_Coverage, 931,
     /*  189251 */     GIR_Done,
     /*  189252 */   // Label 3696: @189252
     /*  189252 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(189293), // Rule ID 933 //
     /*  189257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189260 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189267 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189274 */     // MIs[0] rs1
     /*  189274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189286 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  189291 */     GIR_RootConstrainSelectedInstOperands,
     /*  189292 */     // GIR_Coverage, 933,
     /*  189292 */     GIR_Done,
     /*  189293 */   // Label 3697: @189293
     /*  189293 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(189334), // Rule ID 935 //
     /*  189298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189301 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189308 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189315 */     // MIs[0] rs1
     /*  189315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189327 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  189332 */     GIR_RootConstrainSelectedInstOperands,
     /*  189333 */     // GIR_Coverage, 935,
     /*  189333 */     GIR_Done,
     /*  189334 */   // Label 3698: @189334
     /*  189334 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(189375), // Rule ID 937 //
     /*  189339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189342 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189349 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189356 */     // MIs[0] rs1
     /*  189356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189368 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  189373 */     GIR_RootConstrainSelectedInstOperands,
     /*  189374 */     // GIR_Coverage, 937,
     /*  189374 */     GIR_Done,
     /*  189375 */   // Label 3699: @189375
     /*  189375 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(189416), // Rule ID 939 //
     /*  189380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189383 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189397 */     // MIs[0] rs1
     /*  189397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189409 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189414 */     GIR_RootConstrainSelectedInstOperands,
     /*  189415 */     // GIR_Coverage, 939,
     /*  189415 */     GIR_Done,
     /*  189416 */   // Label 3700: @189416
     /*  189416 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(189457), // Rule ID 941 //
     /*  189421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189424 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189431 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189438 */     // MIs[0] rs1
     /*  189438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189450 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189455 */     GIR_RootConstrainSelectedInstOperands,
     /*  189456 */     // GIR_Coverage, 941,
     /*  189456 */     GIR_Done,
     /*  189457 */   // Label 3701: @189457
     /*  189457 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(189498), // Rule ID 943 //
     /*  189462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189479 */     // MIs[0] rs1
     /*  189479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189491 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189496 */     GIR_RootConstrainSelectedInstOperands,
     /*  189497 */     // GIR_Coverage, 943,
     /*  189497 */     GIR_Done,
     /*  189498 */   // Label 3702: @189498
     /*  189498 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(189539), // Rule ID 945 //
     /*  189503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189513 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189520 */     // MIs[0] rs1
     /*  189520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189532 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189537 */     GIR_RootConstrainSelectedInstOperands,
     /*  189538 */     // GIR_Coverage, 945,
     /*  189538 */     GIR_Done,
     /*  189539 */   // Label 3703: @189539
     /*  189539 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(189580), // Rule ID 947 //
     /*  189544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189561 */     // MIs[0] rs1
     /*  189561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189573 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189578 */     GIR_RootConstrainSelectedInstOperands,
     /*  189579 */     // GIR_Coverage, 947,
     /*  189579 */     GIR_Done,
     /*  189580 */   // Label 3704: @189580
     /*  189580 */   GIM_Reject,
     /*  189581 */ // Label 3664: @189581
     /*  189581 */ GIM_Reject,
     /*  189582 */ // Label 3632: @189582
     /*  189582 */ GIM_Reject,
     /*  189583 */ // Label 29: @189583
     /*  189583 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3707*/ GIMT_Encode4(190494),
     /*  189594 */ /*GILLT_s32*//*Label 3705*/ GIMT_Encode4(189602),
     /*  189598 */ /*GILLT_s64*//*Label 3706*/ GIMT_Encode4(189884),
     /*  189602 */ // Label 3705: @189602
     /*  189602 */ GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(189883),
     /*  189607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  189610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189617 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(189670), // Rule ID 632 //
     /*  189622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189632 */     // MIs[0] addr
     /*  189632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189644 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 2:{ *:[i32] })
     /*  189644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189652 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189657 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189659 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  189664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189668 */     GIR_RootConstrainSelectedInstOperands,
     /*  189669 */     // GIR_Coverage, 632,
     /*  189669 */     GIR_EraseRootFromParent_Done,
     /*  189670 */   // Label 3709: @189670
     /*  189670 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(189723), // Rule ID 634 //
     /*  189675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189685 */     // MIs[0] addr
     /*  189685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189697 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 4:{ *:[i32] })
     /*  189697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189705 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189710 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189712 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189721 */     GIR_RootConstrainSelectedInstOperands,
     /*  189722 */     // GIR_Coverage, 634,
     /*  189722 */     GIR_EraseRootFromParent_Done,
     /*  189723 */   // Label 3710: @189723
     /*  189723 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(189776), // Rule ID 636 //
     /*  189728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189731 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189738 */     // MIs[0] addr
     /*  189738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189750 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 5:{ *:[i32] })
     /*  189750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189758 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189763 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189765 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  189770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189774 */     GIR_RootConstrainSelectedInstOperands,
     /*  189775 */     // GIR_Coverage, 636,
     /*  189775 */     GIR_EraseRootFromParent_Done,
     /*  189776 */   // Label 3711: @189776
     /*  189776 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(189829), // Rule ID 638 //
     /*  189781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189791 */     // MIs[0] addr
     /*  189791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189803 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 6:{ *:[i32] })
     /*  189803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189811 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189816 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189818 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189827 */     GIR_RootConstrainSelectedInstOperands,
     /*  189828 */     // GIR_Coverage, 638,
     /*  189828 */     GIR_EraseRootFromParent_Done,
     /*  189829 */   // Label 3712: @189829
     /*  189829 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(189882), // Rule ID 640 //
     /*  189834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189844 */     // MIs[0] addr
     /*  189844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189856 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 7:{ *:[i32] })
     /*  189856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189864 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189869 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189871 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  189876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189880 */     GIR_RootConstrainSelectedInstOperands,
     /*  189881 */     // GIR_Coverage, 640,
     /*  189881 */     GIR_EraseRootFromParent_Done,
     /*  189882 */   // Label 3713: @189882
     /*  189882 */   GIM_Reject,
     /*  189883 */ // Label 3708: @189883
     /*  189883 */ GIM_Reject,
     /*  189884 */ // Label 3706: @189884
     /*  189884 */ GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(190493),
     /*  189889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  189892 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(189952), // Rule ID 631 //
     /*  189897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189900 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189907 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189914 */     // MIs[0] addr
     /*  189914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189926 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  189926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189934 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189939 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189941 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  189946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189950 */     GIR_RootConstrainSelectedInstOperands,
     /*  189951 */     // GIR_Coverage, 631,
     /*  189951 */     GIR_EraseRootFromParent_Done,
     /*  189952 */   // Label 3715: @189952
     /*  189952 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(190012), // Rule ID 633 //
     /*  189957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189960 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189967 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189974 */     // MIs[0] addr
     /*  189974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189986 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  189986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189994 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189999 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190001 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  190006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190010 */     GIR_RootConstrainSelectedInstOperands,
     /*  190011 */     // GIR_Coverage, 633,
     /*  190011 */     GIR_EraseRootFromParent_Done,
     /*  190012 */   // Label 3716: @190012
     /*  190012 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(190072), // Rule ID 635 //
     /*  190017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  190020 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190027 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190034 */     // MIs[0] addr
     /*  190034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190046 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  190046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  190052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190054 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190059 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190061 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  190066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190070 */     GIR_RootConstrainSelectedInstOperands,
     /*  190071 */     // GIR_Coverage, 635,
     /*  190071 */     GIR_EraseRootFromParent_Done,
     /*  190072 */   // Label 3717: @190072
     /*  190072 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(190132), // Rule ID 637 //
     /*  190077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  190080 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190087 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190094 */     // MIs[0] addr
     /*  190094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190106 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  190106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  190112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190114 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190119 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190121 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  190126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190130 */     GIR_RootConstrainSelectedInstOperands,
     /*  190131 */     // GIR_Coverage, 637,
     /*  190131 */     GIR_EraseRootFromParent_Done,
     /*  190132 */   // Label 3718: @190132
     /*  190132 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(190192), // Rule ID 639 //
     /*  190137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  190140 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190147 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190154 */     // MIs[0] addr
     /*  190154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190166 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  190166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  190172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190174 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190179 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190181 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  190186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190190 */     GIR_RootConstrainSelectedInstOperands,
     /*  190191 */     // GIR_Coverage, 639,
     /*  190191 */     GIR_EraseRootFromParent_Done,
     /*  190192 */   // Label 3719: @190192
     /*  190192 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(190252), // Rule ID 649 //
     /*  190197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  190200 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  190207 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190214 */     // MIs[0] addr
     /*  190214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190226 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_monotonic>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  190226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  190232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190234 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190239 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190241 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  190246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190250 */     GIR_RootConstrainSelectedInstOperands,
     /*  190251 */     // GIR_Coverage, 649,
     /*  190251 */     GIR_EraseRootFromParent_Done,
     /*  190252 */   // Label 3720: @190252
     /*  190252 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(190312), // Rule ID 650 //
     /*  190257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  190260 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  190267 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190274 */     // MIs[0] addr
     /*  190274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190286 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acquire>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  190286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  190292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190294 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190299 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190301 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  190306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190310 */     GIR_RootConstrainSelectedInstOperands,
     /*  190311 */     // GIR_Coverage, 650,
     /*  190311 */     GIR_EraseRootFromParent_Done,
     /*  190312 */   // Label 3721: @190312
     /*  190312 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(190372), // Rule ID 651 //
     /*  190317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  190320 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  190327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190334 */     // MIs[0] addr
     /*  190334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190346 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_release>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  190346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  190352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190354 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190359 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190361 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  190366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190370 */     GIR_RootConstrainSelectedInstOperands,
     /*  190371 */     // GIR_Coverage, 651,
     /*  190371 */     GIR_EraseRootFromParent_Done,
     /*  190372 */   // Label 3722: @190372
     /*  190372 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(190432), // Rule ID 652 //
     /*  190377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  190380 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  190387 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190394 */     // MIs[0] addr
     /*  190394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190406 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acq_rel>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  190406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  190412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190414 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190419 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190421 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  190426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190430 */     GIR_RootConstrainSelectedInstOperands,
     /*  190431 */     // GIR_Coverage, 652,
     /*  190431 */     GIR_EraseRootFromParent_Done,
     /*  190432 */   // Label 3723: @190432
     /*  190432 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(190492), // Rule ID 653 //
     /*  190437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  190440 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  190447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190454 */     // MIs[0] addr
     /*  190454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190466 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_seq_cst>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  190466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  190472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190474 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190479 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190481 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  190486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190490 */     GIR_RootConstrainSelectedInstOperands,
     /*  190491 */     // GIR_Coverage, 653,
     /*  190491 */     GIR_EraseRootFromParent_Done,
     /*  190492 */   // Label 3724: @190492
     /*  190492 */   GIM_Reject,
     /*  190493 */ // Label 3714: @190493
     /*  190493 */ GIM_Reject,
     /*  190494 */ // Label 3707: @190494
     /*  190494 */ GIM_Reject,
     /*  190495 */ // Label 30: @190495
     /*  190495 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3727*/ GIMT_Encode4(193404),
     /*  190506 */ /*GILLT_s32*//*Label 3725*/ GIMT_Encode4(190514),
     /*  190510 */ /*GILLT_s64*//*Label 3726*/ GIMT_Encode4(191754),
     /*  190514 */ // Label 3725: @190514
     /*  190514 */ GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(191753),
     /*  190519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  190522 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(190563), // Rule ID 422 //
     /*  190527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190530 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190537 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190544 */     // MIs[0] rs1
     /*  190544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190556 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190561 */     GIR_RootConstrainSelectedInstOperands,
     /*  190562 */     // GIR_Coverage, 422,
     /*  190562 */     GIR_Done,
     /*  190563 */   // Label 3729: @190563
     /*  190563 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(190604), // Rule ID 424 //
     /*  190568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190571 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190578 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190585 */     // MIs[0] rs1
     /*  190585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190597 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  190602 */     GIR_RootConstrainSelectedInstOperands,
     /*  190603 */     // GIR_Coverage, 424,
     /*  190603 */     GIR_Done,
     /*  190604 */   // Label 3730: @190604
     /*  190604 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(190645), // Rule ID 426 //
     /*  190609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190612 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190619 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190626 */     // MIs[0] rs1
     /*  190626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190638 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  190643 */     GIR_RootConstrainSelectedInstOperands,
     /*  190644 */     // GIR_Coverage, 426,
     /*  190644 */     GIR_Done,
     /*  190645 */   // Label 3731: @190645
     /*  190645 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(190686), // Rule ID 428 //
     /*  190650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190653 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190660 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190667 */     // MIs[0] rs1
     /*  190667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190679 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  190684 */     GIR_RootConstrainSelectedInstOperands,
     /*  190685 */     // GIR_Coverage, 428,
     /*  190685 */     GIR_Done,
     /*  190686 */   // Label 3732: @190686
     /*  190686 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(190727), // Rule ID 430 //
     /*  190691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190708 */     // MIs[0] rs1
     /*  190708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190720 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  190725 */     GIR_RootConstrainSelectedInstOperands,
     /*  190726 */     // GIR_Coverage, 430,
     /*  190726 */     GIR_Done,
     /*  190727 */   // Label 3733: @190727
     /*  190727 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(190768), // Rule ID 432 //
     /*  190732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190735 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190749 */     // MIs[0] rs1
     /*  190749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190761 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190766 */     GIR_RootConstrainSelectedInstOperands,
     /*  190767 */     // GIR_Coverage, 432,
     /*  190767 */     GIR_Done,
     /*  190768 */   // Label 3734: @190768
     /*  190768 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(190809), // Rule ID 434 //
     /*  190773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190776 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190790 */     // MIs[0] rs1
     /*  190790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190802 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190807 */     GIR_RootConstrainSelectedInstOperands,
     /*  190808 */     // GIR_Coverage, 434,
     /*  190808 */     GIR_Done,
     /*  190809 */   // Label 3735: @190809
     /*  190809 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(190850), // Rule ID 436 //
     /*  190814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190817 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190824 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190831 */     // MIs[0] rs1
     /*  190831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190843 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190848 */     GIR_RootConstrainSelectedInstOperands,
     /*  190849 */     // GIR_Coverage, 436,
     /*  190849 */     GIR_Done,
     /*  190850 */   // Label 3736: @190850
     /*  190850 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(190891), // Rule ID 438 //
     /*  190855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190858 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190865 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190872 */     // MIs[0] rs1
     /*  190872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190884 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190889 */     GIR_RootConstrainSelectedInstOperands,
     /*  190890 */     // GIR_Coverage, 438,
     /*  190890 */     GIR_Done,
     /*  190891 */   // Label 3737: @190891
     /*  190891 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(190932), // Rule ID 440 //
     /*  190896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190899 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190906 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190913 */     // MIs[0] rs1
     /*  190913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190925 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190930 */     GIR_RootConstrainSelectedInstOperands,
     /*  190931 */     // GIR_Coverage, 440,
     /*  190931 */     GIR_Done,
     /*  190932 */   // Label 3738: @190932
     /*  190932 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(190973), // Rule ID 770 //
     /*  190937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190954 */     // MIs[0] rs1
     /*  190954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190966 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190971 */     GIR_RootConstrainSelectedInstOperands,
     /*  190972 */     // GIR_Coverage, 770,
     /*  190972 */     GIR_Done,
     /*  190973 */   // Label 3739: @190973
     /*  190973 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(191014), // Rule ID 772 //
     /*  190978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190981 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190988 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190995 */     // MIs[0] rs1
     /*  190995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191007 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  191012 */     GIR_RootConstrainSelectedInstOperands,
     /*  191013 */     // GIR_Coverage, 772,
     /*  191013 */     GIR_Done,
     /*  191014 */   // Label 3740: @191014
     /*  191014 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(191055), // Rule ID 774 //
     /*  191019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191022 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191036 */     // MIs[0] rs1
     /*  191036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191048 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  191053 */     GIR_RootConstrainSelectedInstOperands,
     /*  191054 */     // GIR_Coverage, 774,
     /*  191054 */     GIR_Done,
     /*  191055 */   // Label 3741: @191055
     /*  191055 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(191096), // Rule ID 776 //
     /*  191060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191077 */     // MIs[0] rs1
     /*  191077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191089 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  191094 */     GIR_RootConstrainSelectedInstOperands,
     /*  191095 */     // GIR_Coverage, 776,
     /*  191095 */     GIR_Done,
     /*  191096 */   // Label 3742: @191096
     /*  191096 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(191137), // Rule ID 778 //
     /*  191101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191104 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191111 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191118 */     // MIs[0] rs1
     /*  191118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191130 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  191135 */     GIR_RootConstrainSelectedInstOperands,
     /*  191136 */     // GIR_Coverage, 778,
     /*  191136 */     GIR_Done,
     /*  191137 */   // Label 3743: @191137
     /*  191137 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(191178), // Rule ID 780 //
     /*  191142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191159 */     // MIs[0] rs1
     /*  191159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191171 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191176 */     GIR_RootConstrainSelectedInstOperands,
     /*  191177 */     // GIR_Coverage, 780,
     /*  191177 */     GIR_Done,
     /*  191178 */   // Label 3744: @191178
     /*  191178 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(191219), // Rule ID 782 //
     /*  191183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191186 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191193 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191200 */     // MIs[0] rs1
     /*  191200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191212 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191217 */     GIR_RootConstrainSelectedInstOperands,
     /*  191218 */     // GIR_Coverage, 782,
     /*  191218 */     GIR_Done,
     /*  191219 */   // Label 3745: @191219
     /*  191219 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(191260), // Rule ID 784 //
     /*  191224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191227 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191234 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191241 */     // MIs[0] rs1
     /*  191241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191253 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191258 */     GIR_RootConstrainSelectedInstOperands,
     /*  191259 */     // GIR_Coverage, 784,
     /*  191259 */     GIR_Done,
     /*  191260 */   // Label 3746: @191260
     /*  191260 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(191301), // Rule ID 786 //
     /*  191265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191268 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191275 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191282 */     // MIs[0] rs1
     /*  191282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191294 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191299 */     GIR_RootConstrainSelectedInstOperands,
     /*  191300 */     // GIR_Coverage, 786,
     /*  191300 */     GIR_Done,
     /*  191301 */   // Label 3747: @191301
     /*  191301 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(191342), // Rule ID 788 //
     /*  191306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191309 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191316 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191323 */     // MIs[0] rs1
     /*  191323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191335 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191340 */     GIR_RootConstrainSelectedInstOperands,
     /*  191341 */     // GIR_Coverage, 788,
     /*  191341 */     GIR_Done,
     /*  191342 */   // Label 3748: @191342
     /*  191342 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(191383), // Rule ID 950 //
     /*  191347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191350 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191357 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191364 */     // MIs[0] rs1
     /*  191364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191376 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191381 */     GIR_RootConstrainSelectedInstOperands,
     /*  191382 */     // GIR_Coverage, 950,
     /*  191382 */     GIR_Done,
     /*  191383 */   // Label 3749: @191383
     /*  191383 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(191424), // Rule ID 952 //
     /*  191388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191391 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191398 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191405 */     // MIs[0] rs1
     /*  191405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191417 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  191422 */     GIR_RootConstrainSelectedInstOperands,
     /*  191423 */     // GIR_Coverage, 952,
     /*  191423 */     GIR_Done,
     /*  191424 */   // Label 3750: @191424
     /*  191424 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(191465), // Rule ID 954 //
     /*  191429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191432 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191446 */     // MIs[0] rs1
     /*  191446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191458 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  191463 */     GIR_RootConstrainSelectedInstOperands,
     /*  191464 */     // GIR_Coverage, 954,
     /*  191464 */     GIR_Done,
     /*  191465 */   // Label 3751: @191465
     /*  191465 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(191506), // Rule ID 956 //
     /*  191470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191480 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191487 */     // MIs[0] rs1
     /*  191487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191499 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  191504 */     GIR_RootConstrainSelectedInstOperands,
     /*  191505 */     // GIR_Coverage, 956,
     /*  191505 */     GIR_Done,
     /*  191506 */   // Label 3752: @191506
     /*  191506 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(191547), // Rule ID 958 //
     /*  191511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191514 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191521 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191528 */     // MIs[0] rs1
     /*  191528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191540 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  191545 */     GIR_RootConstrainSelectedInstOperands,
     /*  191546 */     // GIR_Coverage, 958,
     /*  191546 */     GIR_Done,
     /*  191547 */   // Label 3753: @191547
     /*  191547 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(191588), // Rule ID 960 //
     /*  191552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191562 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191569 */     // MIs[0] rs1
     /*  191569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191581 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191586 */     GIR_RootConstrainSelectedInstOperands,
     /*  191587 */     // GIR_Coverage, 960,
     /*  191587 */     GIR_Done,
     /*  191588 */   // Label 3754: @191588
     /*  191588 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(191629), // Rule ID 962 //
     /*  191593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191610 */     // MIs[0] rs1
     /*  191610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191622 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191627 */     GIR_RootConstrainSelectedInstOperands,
     /*  191628 */     // GIR_Coverage, 962,
     /*  191628 */     GIR_Done,
     /*  191629 */   // Label 3755: @191629
     /*  191629 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(191670), // Rule ID 964 //
     /*  191634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191651 */     // MIs[0] rs1
     /*  191651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191663 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191668 */     GIR_RootConstrainSelectedInstOperands,
     /*  191669 */     // GIR_Coverage, 964,
     /*  191669 */     GIR_Done,
     /*  191670 */   // Label 3756: @191670
     /*  191670 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(191711), // Rule ID 966 //
     /*  191675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191678 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191692 */     // MIs[0] rs1
     /*  191692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191704 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191709 */     GIR_RootConstrainSelectedInstOperands,
     /*  191710 */     // GIR_Coverage, 966,
     /*  191710 */     GIR_Done,
     /*  191711 */   // Label 3757: @191711
     /*  191711 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(191752), // Rule ID 968 //
     /*  191716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191719 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191726 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191733 */     // MIs[0] rs1
     /*  191733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191745 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191750 */     GIR_RootConstrainSelectedInstOperands,
     /*  191751 */     // GIR_Coverage, 968,
     /*  191751 */     GIR_Done,
     /*  191752 */   // Label 3758: @191752
     /*  191752 */   GIM_Reject,
     /*  191753 */ // Label 3728: @191753
     /*  191753 */ GIM_Reject,
     /*  191754 */ // Label 3726: @191754
     /*  191754 */ GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(193403),
     /*  191759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  191762 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(191803), // Rule ID 421 //
     /*  191767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191770 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191777 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191784 */     // MIs[0] rs1
     /*  191784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191796 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191801 */     GIR_RootConstrainSelectedInstOperands,
     /*  191802 */     // GIR_Coverage, 421,
     /*  191802 */     GIR_Done,
     /*  191803 */   // Label 3760: @191803
     /*  191803 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(191844), // Rule ID 423 //
     /*  191808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191811 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191818 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191825 */     // MIs[0] rs1
     /*  191825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191837 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  191842 */     GIR_RootConstrainSelectedInstOperands,
     /*  191843 */     // GIR_Coverage, 423,
     /*  191843 */     GIR_Done,
     /*  191844 */   // Label 3761: @191844
     /*  191844 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(191885), // Rule ID 425 //
     /*  191849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191852 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191859 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191866 */     // MIs[0] rs1
     /*  191866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191878 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  191883 */     GIR_RootConstrainSelectedInstOperands,
     /*  191884 */     // GIR_Coverage, 425,
     /*  191884 */     GIR_Done,
     /*  191885 */   // Label 3762: @191885
     /*  191885 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(191926), // Rule ID 427 //
     /*  191890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191893 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191907 */     // MIs[0] rs1
     /*  191907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191919 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  191924 */     GIR_RootConstrainSelectedInstOperands,
     /*  191925 */     // GIR_Coverage, 427,
     /*  191925 */     GIR_Done,
     /*  191926 */   // Label 3763: @191926
     /*  191926 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(191967), // Rule ID 429 //
     /*  191931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191934 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191948 */     // MIs[0] rs1
     /*  191948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191960 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  191965 */     GIR_RootConstrainSelectedInstOperands,
     /*  191966 */     // GIR_Coverage, 429,
     /*  191966 */     GIR_Done,
     /*  191967 */   // Label 3764: @191967
     /*  191967 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(192008), // Rule ID 431 //
     /*  191972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191975 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191982 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191989 */     // MIs[0] rs1
     /*  191989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192001 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  192006 */     GIR_RootConstrainSelectedInstOperands,
     /*  192007 */     // GIR_Coverage, 431,
     /*  192007 */     GIR_Done,
     /*  192008 */   // Label 3765: @192008
     /*  192008 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(192049), // Rule ID 433 //
     /*  192013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  192016 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192023 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192030 */     // MIs[0] rs1
     /*  192030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192042 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  192047 */     GIR_RootConstrainSelectedInstOperands,
     /*  192048 */     // GIR_Coverage, 433,
     /*  192048 */     GIR_Done,
     /*  192049 */   // Label 3766: @192049
     /*  192049 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(192090), // Rule ID 435 //
     /*  192054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  192057 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192064 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192071 */     // MIs[0] rs1
     /*  192071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192083 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  192088 */     GIR_RootConstrainSelectedInstOperands,
     /*  192089 */     // GIR_Coverage, 435,
     /*  192089 */     GIR_Done,
     /*  192090 */   // Label 3767: @192090
     /*  192090 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(192131), // Rule ID 437 //
     /*  192095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  192098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192112 */     // MIs[0] rs1
     /*  192112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192124 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  192129 */     GIR_RootConstrainSelectedInstOperands,
     /*  192130 */     // GIR_Coverage, 437,
     /*  192130 */     GIR_Done,
     /*  192131 */   // Label 3768: @192131
     /*  192131 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(192172), // Rule ID 439 //
     /*  192136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  192139 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192146 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192153 */     // MIs[0] rs1
     /*  192153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192165 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  192170 */     GIR_RootConstrainSelectedInstOperands,
     /*  192171 */     // GIR_Coverage, 439,
     /*  192171 */     GIR_Done,
     /*  192172 */   // Label 3769: @192172
     /*  192172 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(192213), // Rule ID 571 //
     /*  192177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  192180 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192187 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192194 */     // MIs[0] rs1
     /*  192194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192206 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192211 */     GIR_RootConstrainSelectedInstOperands,
     /*  192212 */     // GIR_Coverage, 571,
     /*  192212 */     GIR_Done,
     /*  192213 */   // Label 3770: @192213
     /*  192213 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(192254), // Rule ID 572 //
     /*  192218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  192221 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192235 */     // MIs[0] rs1
     /*  192235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192247 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ),
     /*  192252 */     GIR_RootConstrainSelectedInstOperands,
     /*  192253 */     // GIR_Coverage, 572,
     /*  192253 */     GIR_Done,
     /*  192254 */   // Label 3771: @192254
     /*  192254 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(192295), // Rule ID 573 //
     /*  192259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  192262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192276 */     // MIs[0] rs1
     /*  192276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192288 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_RL),
     /*  192293 */     GIR_RootConstrainSelectedInstOperands,
     /*  192294 */     // GIR_Coverage, 573,
     /*  192294 */     GIR_Done,
     /*  192295 */   // Label 3772: @192295
     /*  192295 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(192336), // Rule ID 574 //
     /*  192300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  192303 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192317 */     // MIs[0] rs1
     /*  192317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192329 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  192334 */     GIR_RootConstrainSelectedInstOperands,
     /*  192335 */     // GIR_Coverage, 574,
     /*  192335 */     GIR_Done,
     /*  192336 */   // Label 3773: @192336
     /*  192336 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(192377), // Rule ID 575 //
     /*  192341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  192344 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192358 */     // MIs[0] rs1
     /*  192358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192370 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  192375 */     GIR_RootConstrainSelectedInstOperands,
     /*  192376 */     // GIR_Coverage, 575,
     /*  192376 */     GIR_Done,
     /*  192377 */   // Label 3774: @192377
     /*  192377 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(192418), // Rule ID 576 //
     /*  192382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192385 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192392 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192399 */     // MIs[0] rs1
     /*  192399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192411 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192416 */     GIR_RootConstrainSelectedInstOperands,
     /*  192417 */     // GIR_Coverage, 576,
     /*  192417 */     GIR_Done,
     /*  192418 */   // Label 3775: @192418
     /*  192418 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(192459), // Rule ID 577 //
     /*  192423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192440 */     // MIs[0] rs1
     /*  192440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192452 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192457 */     GIR_RootConstrainSelectedInstOperands,
     /*  192458 */     // GIR_Coverage, 577,
     /*  192458 */     GIR_Done,
     /*  192459 */   // Label 3776: @192459
     /*  192459 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(192500), // Rule ID 578 //
     /*  192464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192467 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192481 */     // MIs[0] rs1
     /*  192481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192493 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192498 */     GIR_RootConstrainSelectedInstOperands,
     /*  192499 */     // GIR_Coverage, 578,
     /*  192499 */     GIR_Done,
     /*  192500 */   // Label 3777: @192500
     /*  192500 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(192541), // Rule ID 579 //
     /*  192505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192508 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192515 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192522 */     // MIs[0] rs1
     /*  192522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192534 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192539 */     GIR_RootConstrainSelectedInstOperands,
     /*  192540 */     // GIR_Coverage, 579,
     /*  192540 */     GIR_Done,
     /*  192541 */   // Label 3778: @192541
     /*  192541 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(192582), // Rule ID 580 //
     /*  192546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192549 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192556 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192563 */     // MIs[0] rs1
     /*  192563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192575 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192580 */     GIR_RootConstrainSelectedInstOperands,
     /*  192581 */     // GIR_Coverage, 580,
     /*  192581 */     GIR_Done,
     /*  192582 */   // Label 3779: @192582
     /*  192582 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(192623), // Rule ID 769 //
     /*  192587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192590 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192597 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192604 */     // MIs[0] rs1
     /*  192604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192616 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192621 */     GIR_RootConstrainSelectedInstOperands,
     /*  192622 */     // GIR_Coverage, 769,
     /*  192622 */     GIR_Done,
     /*  192623 */   // Label 3780: @192623
     /*  192623 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(192664), // Rule ID 771 //
     /*  192628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192631 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192638 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192645 */     // MIs[0] rs1
     /*  192645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192657 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  192662 */     GIR_RootConstrainSelectedInstOperands,
     /*  192663 */     // GIR_Coverage, 771,
     /*  192663 */     GIR_Done,
     /*  192664 */   // Label 3781: @192664
     /*  192664 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(192705), // Rule ID 773 //
     /*  192669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192672 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192679 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192686 */     // MIs[0] rs1
     /*  192686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192698 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  192703 */     GIR_RootConstrainSelectedInstOperands,
     /*  192704 */     // GIR_Coverage, 773,
     /*  192704 */     GIR_Done,
     /*  192705 */   // Label 3782: @192705
     /*  192705 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(192746), // Rule ID 775 //
     /*  192710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192713 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192720 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192727 */     // MIs[0] rs1
     /*  192727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192739 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  192744 */     GIR_RootConstrainSelectedInstOperands,
     /*  192745 */     // GIR_Coverage, 775,
     /*  192745 */     GIR_Done,
     /*  192746 */   // Label 3783: @192746
     /*  192746 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(192787), // Rule ID 777 //
     /*  192751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192754 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192768 */     // MIs[0] rs1
     /*  192768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192780 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  192785 */     GIR_RootConstrainSelectedInstOperands,
     /*  192786 */     // GIR_Coverage, 777,
     /*  192786 */     GIR_Done,
     /*  192787 */   // Label 3784: @192787
     /*  192787 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(192828), // Rule ID 779 //
     /*  192792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192809 */     // MIs[0] rs1
     /*  192809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192821 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192826 */     GIR_RootConstrainSelectedInstOperands,
     /*  192827 */     // GIR_Coverage, 779,
     /*  192827 */     GIR_Done,
     /*  192828 */   // Label 3785: @192828
     /*  192828 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(192869), // Rule ID 781 //
     /*  192833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192836 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192850 */     // MIs[0] rs1
     /*  192850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192862 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192867 */     GIR_RootConstrainSelectedInstOperands,
     /*  192868 */     // GIR_Coverage, 781,
     /*  192868 */     GIR_Done,
     /*  192869 */   // Label 3786: @192869
     /*  192869 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(192910), // Rule ID 783 //
     /*  192874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192891 */     // MIs[0] rs1
     /*  192891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192903 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192908 */     GIR_RootConstrainSelectedInstOperands,
     /*  192909 */     // GIR_Coverage, 783,
     /*  192909 */     GIR_Done,
     /*  192910 */   // Label 3787: @192910
     /*  192910 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(192951), // Rule ID 785 //
     /*  192915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192932 */     // MIs[0] rs1
     /*  192932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192944 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192949 */     GIR_RootConstrainSelectedInstOperands,
     /*  192950 */     // GIR_Coverage, 785,
     /*  192950 */     GIR_Done,
     /*  192951 */   // Label 3788: @192951
     /*  192951 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(192992), // Rule ID 787 //
     /*  192956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192959 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192966 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192973 */     // MIs[0] rs1
     /*  192973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192985 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192990 */     GIR_RootConstrainSelectedInstOperands,
     /*  192991 */     // GIR_Coverage, 787,
     /*  192991 */     GIR_Done,
     /*  192992 */   // Label 3789: @192992
     /*  192992 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(193033), // Rule ID 949 //
     /*  192997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  193000 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193007 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193014 */     // MIs[0] rs1
     /*  193014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193026 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  193031 */     GIR_RootConstrainSelectedInstOperands,
     /*  193032 */     // GIR_Coverage, 949,
     /*  193032 */     GIR_Done,
     /*  193033 */   // Label 3790: @193033
     /*  193033 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(193074), // Rule ID 951 //
     /*  193038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  193041 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193048 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193055 */     // MIs[0] rs1
     /*  193055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193067 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  193072 */     GIR_RootConstrainSelectedInstOperands,
     /*  193073 */     // GIR_Coverage, 951,
     /*  193073 */     GIR_Done,
     /*  193074 */   // Label 3791: @193074
     /*  193074 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(193115), // Rule ID 953 //
     /*  193079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  193082 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193089 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193096 */     // MIs[0] rs1
     /*  193096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193108 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  193113 */     GIR_RootConstrainSelectedInstOperands,
     /*  193114 */     // GIR_Coverage, 953,
     /*  193114 */     GIR_Done,
     /*  193115 */   // Label 3792: @193115
     /*  193115 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(193156), // Rule ID 955 //
     /*  193120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  193123 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193137 */     // MIs[0] rs1
     /*  193137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193149 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  193154 */     GIR_RootConstrainSelectedInstOperands,
     /*  193155 */     // GIR_Coverage, 955,
     /*  193155 */     GIR_Done,
     /*  193156 */   // Label 3793: @193156
     /*  193156 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(193197), // Rule ID 957 //
     /*  193161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  193164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193178 */     // MIs[0] rs1
     /*  193178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193190 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  193195 */     GIR_RootConstrainSelectedInstOperands,
     /*  193196 */     // GIR_Coverage, 957,
     /*  193196 */     GIR_Done,
     /*  193197 */   // Label 3794: @193197
     /*  193197 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(193238), // Rule ID 959 //
     /*  193202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  193205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193219 */     // MIs[0] rs1
     /*  193219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193231 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  193236 */     GIR_RootConstrainSelectedInstOperands,
     /*  193237 */     // GIR_Coverage, 959,
     /*  193237 */     GIR_Done,
     /*  193238 */   // Label 3795: @193238
     /*  193238 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(193279), // Rule ID 961 //
     /*  193243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  193246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193260 */     // MIs[0] rs1
     /*  193260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193272 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  193277 */     GIR_RootConstrainSelectedInstOperands,
     /*  193278 */     // GIR_Coverage, 961,
     /*  193278 */     GIR_Done,
     /*  193279 */   // Label 3796: @193279
     /*  193279 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(193320), // Rule ID 963 //
     /*  193284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  193287 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193301 */     // MIs[0] rs1
     /*  193301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193313 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  193318 */     GIR_RootConstrainSelectedInstOperands,
     /*  193319 */     // GIR_Coverage, 963,
     /*  193319 */     GIR_Done,
     /*  193320 */   // Label 3797: @193320
     /*  193320 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(193361), // Rule ID 965 //
     /*  193325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  193328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193342 */     // MIs[0] rs1
     /*  193342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193354 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  193359 */     GIR_RootConstrainSelectedInstOperands,
     /*  193360 */     // GIR_Coverage, 965,
     /*  193360 */     GIR_Done,
     /*  193361 */   // Label 3798: @193361
     /*  193361 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(193402), // Rule ID 967 //
     /*  193366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  193369 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193376 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193383 */     // MIs[0] rs1
     /*  193383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193395 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  193400 */     GIR_RootConstrainSelectedInstOperands,
     /*  193401 */     // GIR_Coverage, 967,
     /*  193401 */     GIR_Done,
     /*  193402 */   // Label 3799: @193402
     /*  193402 */   GIM_Reject,
     /*  193403 */ // Label 3759: @193403
     /*  193403 */ GIM_Reject,
     /*  193404 */ // Label 3727: @193404
     /*  193404 */ GIM_Reject,
     /*  193405 */ // Label 31: @193405
     /*  193405 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3802*/ GIMT_Encode4(196314),
     /*  193416 */ /*GILLT_s32*//*Label 3800*/ GIMT_Encode4(193424),
     /*  193420 */ /*GILLT_s64*//*Label 3801*/ GIMT_Encode4(194664),
     /*  193424 */ // Label 3800: @193424
     /*  193424 */ GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(194663),
     /*  193429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  193432 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(193473), // Rule ID 442 //
     /*  193437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193440 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193454 */     // MIs[0] rs1
     /*  193454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193466 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193471 */     GIR_RootConstrainSelectedInstOperands,
     /*  193472 */     // GIR_Coverage, 442,
     /*  193472 */     GIR_Done,
     /*  193473 */   // Label 3804: @193473
     /*  193473 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(193514), // Rule ID 444 //
     /*  193478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193481 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193488 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193495 */     // MIs[0] rs1
     /*  193495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193507 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  193512 */     GIR_RootConstrainSelectedInstOperands,
     /*  193513 */     // GIR_Coverage, 444,
     /*  193513 */     GIR_Done,
     /*  193514 */   // Label 3805: @193514
     /*  193514 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(193555), // Rule ID 446 //
     /*  193519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193522 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193529 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193536 */     // MIs[0] rs1
     /*  193536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193548 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  193553 */     GIR_RootConstrainSelectedInstOperands,
     /*  193554 */     // GIR_Coverage, 446,
     /*  193554 */     GIR_Done,
     /*  193555 */   // Label 3806: @193555
     /*  193555 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(193596), // Rule ID 448 //
     /*  193560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193563 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193570 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193577 */     // MIs[0] rs1
     /*  193577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193589 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  193594 */     GIR_RootConstrainSelectedInstOperands,
     /*  193595 */     // GIR_Coverage, 448,
     /*  193595 */     GIR_Done,
     /*  193596 */   // Label 3807: @193596
     /*  193596 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(193637), // Rule ID 450 //
     /*  193601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193604 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193611 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193618 */     // MIs[0] rs1
     /*  193618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193630 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  193635 */     GIR_RootConstrainSelectedInstOperands,
     /*  193636 */     // GIR_Coverage, 450,
     /*  193636 */     GIR_Done,
     /*  193637 */   // Label 3808: @193637
     /*  193637 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(193678), // Rule ID 452 //
     /*  193642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193659 */     // MIs[0] rs1
     /*  193659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193671 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193676 */     GIR_RootConstrainSelectedInstOperands,
     /*  193677 */     // GIR_Coverage, 452,
     /*  193677 */     GIR_Done,
     /*  193678 */   // Label 3809: @193678
     /*  193678 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(193719), // Rule ID 454 //
     /*  193683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193700 */     // MIs[0] rs1
     /*  193700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193712 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193717 */     GIR_RootConstrainSelectedInstOperands,
     /*  193718 */     // GIR_Coverage, 454,
     /*  193718 */     GIR_Done,
     /*  193719 */   // Label 3810: @193719
     /*  193719 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(193760), // Rule ID 456 //
     /*  193724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193727 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193741 */     // MIs[0] rs1
     /*  193741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193753 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193758 */     GIR_RootConstrainSelectedInstOperands,
     /*  193759 */     // GIR_Coverage, 456,
     /*  193759 */     GIR_Done,
     /*  193760 */   // Label 3811: @193760
     /*  193760 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(193801), // Rule ID 458 //
     /*  193765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193768 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193775 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193782 */     // MIs[0] rs1
     /*  193782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193794 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193799 */     GIR_RootConstrainSelectedInstOperands,
     /*  193800 */     // GIR_Coverage, 458,
     /*  193800 */     GIR_Done,
     /*  193801 */   // Label 3812: @193801
     /*  193801 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(193842), // Rule ID 460 //
     /*  193806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193809 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193816 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193823 */     // MIs[0] rs1
     /*  193823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193835 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193840 */     GIR_RootConstrainSelectedInstOperands,
     /*  193841 */     // GIR_Coverage, 460,
     /*  193841 */     GIR_Done,
     /*  193842 */   // Label 3813: @193842
     /*  193842 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(193883), // Rule ID 790 //
     /*  193847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193850 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193864 */     // MIs[0] rs1
     /*  193864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193876 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193881 */     GIR_RootConstrainSelectedInstOperands,
     /*  193882 */     // GIR_Coverage, 790,
     /*  193882 */     GIR_Done,
     /*  193883 */   // Label 3814: @193883
     /*  193883 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(193924), // Rule ID 792 //
     /*  193888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193898 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193905 */     // MIs[0] rs1
     /*  193905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193917 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  193922 */     GIR_RootConstrainSelectedInstOperands,
     /*  193923 */     // GIR_Coverage, 792,
     /*  193923 */     GIR_Done,
     /*  193924 */   // Label 3815: @193924
     /*  193924 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(193965), // Rule ID 794 //
     /*  193929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193932 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193939 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193946 */     // MIs[0] rs1
     /*  193946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193958 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  193963 */     GIR_RootConstrainSelectedInstOperands,
     /*  193964 */     // GIR_Coverage, 794,
     /*  193964 */     GIR_Done,
     /*  193965 */   // Label 3816: @193965
     /*  193965 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(194006), // Rule ID 796 //
     /*  193970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193973 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193980 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193987 */     // MIs[0] rs1
     /*  193987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193999 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  194004 */     GIR_RootConstrainSelectedInstOperands,
     /*  194005 */     // GIR_Coverage, 796,
     /*  194005 */     GIR_Done,
     /*  194006 */   // Label 3817: @194006
     /*  194006 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(194047), // Rule ID 798 //
     /*  194011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194014 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194021 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194028 */     // MIs[0] rs1
     /*  194028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194040 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  194045 */     GIR_RootConstrainSelectedInstOperands,
     /*  194046 */     // GIR_Coverage, 798,
     /*  194046 */     GIR_Done,
     /*  194047 */   // Label 3818: @194047
     /*  194047 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(194088), // Rule ID 800 //
     /*  194052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194055 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194062 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194069 */     // MIs[0] rs1
     /*  194069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194081 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194086 */     GIR_RootConstrainSelectedInstOperands,
     /*  194087 */     // GIR_Coverage, 800,
     /*  194087 */     GIR_Done,
     /*  194088 */   // Label 3819: @194088
     /*  194088 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(194129), // Rule ID 802 //
     /*  194093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194096 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194103 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194110 */     // MIs[0] rs1
     /*  194110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194122 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194127 */     GIR_RootConstrainSelectedInstOperands,
     /*  194128 */     // GIR_Coverage, 802,
     /*  194128 */     GIR_Done,
     /*  194129 */   // Label 3820: @194129
     /*  194129 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(194170), // Rule ID 804 //
     /*  194134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194137 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194144 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194151 */     // MIs[0] rs1
     /*  194151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194163 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194168 */     GIR_RootConstrainSelectedInstOperands,
     /*  194169 */     // GIR_Coverage, 804,
     /*  194169 */     GIR_Done,
     /*  194170 */   // Label 3821: @194170
     /*  194170 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(194211), // Rule ID 806 //
     /*  194175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194178 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194185 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194192 */     // MIs[0] rs1
     /*  194192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194204 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194209 */     GIR_RootConstrainSelectedInstOperands,
     /*  194210 */     // GIR_Coverage, 806,
     /*  194210 */     GIR_Done,
     /*  194211 */   // Label 3822: @194211
     /*  194211 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(194252), // Rule ID 808 //
     /*  194216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194219 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194226 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194233 */     // MIs[0] rs1
     /*  194233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194245 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194250 */     GIR_RootConstrainSelectedInstOperands,
     /*  194251 */     // GIR_Coverage, 808,
     /*  194251 */     GIR_Done,
     /*  194252 */   // Label 3823: @194252
     /*  194252 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(194293), // Rule ID 970 //
     /*  194257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194260 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194267 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194274 */     // MIs[0] rs1
     /*  194274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194286 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194291 */     GIR_RootConstrainSelectedInstOperands,
     /*  194292 */     // GIR_Coverage, 970,
     /*  194292 */     GIR_Done,
     /*  194293 */   // Label 3824: @194293
     /*  194293 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(194334), // Rule ID 972 //
     /*  194298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194301 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194308 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194315 */     // MIs[0] rs1
     /*  194315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194327 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  194332 */     GIR_RootConstrainSelectedInstOperands,
     /*  194333 */     // GIR_Coverage, 972,
     /*  194333 */     GIR_Done,
     /*  194334 */   // Label 3825: @194334
     /*  194334 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(194375), // Rule ID 974 //
     /*  194339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194342 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194349 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194356 */     // MIs[0] rs1
     /*  194356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194368 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  194373 */     GIR_RootConstrainSelectedInstOperands,
     /*  194374 */     // GIR_Coverage, 974,
     /*  194374 */     GIR_Done,
     /*  194375 */   // Label 3826: @194375
     /*  194375 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(194416), // Rule ID 976 //
     /*  194380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194383 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194397 */     // MIs[0] rs1
     /*  194397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194409 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  194414 */     GIR_RootConstrainSelectedInstOperands,
     /*  194415 */     // GIR_Coverage, 976,
     /*  194415 */     GIR_Done,
     /*  194416 */   // Label 3827: @194416
     /*  194416 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(194457), // Rule ID 978 //
     /*  194421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194424 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194431 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194438 */     // MIs[0] rs1
     /*  194438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194450 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  194455 */     GIR_RootConstrainSelectedInstOperands,
     /*  194456 */     // GIR_Coverage, 978,
     /*  194456 */     GIR_Done,
     /*  194457 */   // Label 3828: @194457
     /*  194457 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(194498), // Rule ID 980 //
     /*  194462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194479 */     // MIs[0] rs1
     /*  194479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194491 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194496 */     GIR_RootConstrainSelectedInstOperands,
     /*  194497 */     // GIR_Coverage, 980,
     /*  194497 */     GIR_Done,
     /*  194498 */   // Label 3829: @194498
     /*  194498 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(194539), // Rule ID 982 //
     /*  194503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194513 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194520 */     // MIs[0] rs1
     /*  194520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194532 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194537 */     GIR_RootConstrainSelectedInstOperands,
     /*  194538 */     // GIR_Coverage, 982,
     /*  194538 */     GIR_Done,
     /*  194539 */   // Label 3830: @194539
     /*  194539 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(194580), // Rule ID 984 //
     /*  194544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194561 */     // MIs[0] rs1
     /*  194561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194573 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194578 */     GIR_RootConstrainSelectedInstOperands,
     /*  194579 */     // GIR_Coverage, 984,
     /*  194579 */     GIR_Done,
     /*  194580 */   // Label 3831: @194580
     /*  194580 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(194621), // Rule ID 986 //
     /*  194585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194602 */     // MIs[0] rs1
     /*  194602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194614 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194619 */     GIR_RootConstrainSelectedInstOperands,
     /*  194620 */     // GIR_Coverage, 986,
     /*  194620 */     GIR_Done,
     /*  194621 */   // Label 3832: @194621
     /*  194621 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(194662), // Rule ID 988 //
     /*  194626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194629 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194636 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194643 */     // MIs[0] rs1
     /*  194643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194655 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194660 */     GIR_RootConstrainSelectedInstOperands,
     /*  194661 */     // GIR_Coverage, 988,
     /*  194661 */     GIR_Done,
     /*  194662 */   // Label 3833: @194662
     /*  194662 */   GIM_Reject,
     /*  194663 */ // Label 3803: @194663
     /*  194663 */ GIM_Reject,
     /*  194664 */ // Label 3801: @194664
     /*  194664 */ GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(196313),
     /*  194669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  194672 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(194713), // Rule ID 441 //
     /*  194677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194687 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194694 */     // MIs[0] rs1
     /*  194694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194706 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194711 */     GIR_RootConstrainSelectedInstOperands,
     /*  194712 */     // GIR_Coverage, 441,
     /*  194712 */     GIR_Done,
     /*  194713 */   // Label 3835: @194713
     /*  194713 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(194754), // Rule ID 443 //
     /*  194718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194721 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194728 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194735 */     // MIs[0] rs1
     /*  194735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194747 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  194752 */     GIR_RootConstrainSelectedInstOperands,
     /*  194753 */     // GIR_Coverage, 443,
     /*  194753 */     GIR_Done,
     /*  194754 */   // Label 3836: @194754
     /*  194754 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(194795), // Rule ID 445 //
     /*  194759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194762 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194769 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194776 */     // MIs[0] rs1
     /*  194776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194788 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  194793 */     GIR_RootConstrainSelectedInstOperands,
     /*  194794 */     // GIR_Coverage, 445,
     /*  194794 */     GIR_Done,
     /*  194795 */   // Label 3837: @194795
     /*  194795 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(194836), // Rule ID 447 //
     /*  194800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194803 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194810 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194817 */     // MIs[0] rs1
     /*  194817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194829 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  194834 */     GIR_RootConstrainSelectedInstOperands,
     /*  194835 */     // GIR_Coverage, 447,
     /*  194835 */     GIR_Done,
     /*  194836 */   // Label 3838: @194836
     /*  194836 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(194877), // Rule ID 449 //
     /*  194841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194844 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194851 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194858 */     // MIs[0] rs1
     /*  194858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194870 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  194875 */     GIR_RootConstrainSelectedInstOperands,
     /*  194876 */     // GIR_Coverage, 449,
     /*  194876 */     GIR_Done,
     /*  194877 */   // Label 3839: @194877
     /*  194877 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(194918), // Rule ID 451 //
     /*  194882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194885 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194892 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194899 */     // MIs[0] rs1
     /*  194899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194911 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194916 */     GIR_RootConstrainSelectedInstOperands,
     /*  194917 */     // GIR_Coverage, 451,
     /*  194917 */     GIR_Done,
     /*  194918 */   // Label 3840: @194918
     /*  194918 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(194959), // Rule ID 453 //
     /*  194923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194926 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194933 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194940 */     // MIs[0] rs1
     /*  194940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194952 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194957 */     GIR_RootConstrainSelectedInstOperands,
     /*  194958 */     // GIR_Coverage, 453,
     /*  194958 */     GIR_Done,
     /*  194959 */   // Label 3841: @194959
     /*  194959 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(195000), // Rule ID 455 //
     /*  194964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194967 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194974 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194981 */     // MIs[0] rs1
     /*  194981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194993 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194998 */     GIR_RootConstrainSelectedInstOperands,
     /*  194999 */     // GIR_Coverage, 455,
     /*  194999 */     GIR_Done,
     /*  195000 */   // Label 3842: @195000
     /*  195000 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(195041), // Rule ID 457 //
     /*  195005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195008 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195015 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195022 */     // MIs[0] rs1
     /*  195022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195034 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  195039 */     GIR_RootConstrainSelectedInstOperands,
     /*  195040 */     // GIR_Coverage, 457,
     /*  195040 */     GIR_Done,
     /*  195041 */   // Label 3843: @195041
     /*  195041 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(195082), // Rule ID 459 //
     /*  195046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195049 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195056 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195063 */     // MIs[0] rs1
     /*  195063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195075 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  195080 */     GIR_RootConstrainSelectedInstOperands,
     /*  195081 */     // GIR_Coverage, 459,
     /*  195081 */     GIR_Done,
     /*  195082 */   // Label 3844: @195082
     /*  195082 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(195123), // Rule ID 581 //
     /*  195087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195090 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195104 */     // MIs[0] rs1
     /*  195104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195116 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195121 */     GIR_RootConstrainSelectedInstOperands,
     /*  195122 */     // GIR_Coverage, 581,
     /*  195122 */     GIR_Done,
     /*  195123 */   // Label 3845: @195123
     /*  195123 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(195164), // Rule ID 582 //
     /*  195128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195131 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195138 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195145 */     // MIs[0] rs1
     /*  195145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195157 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ),
     /*  195162 */     GIR_RootConstrainSelectedInstOperands,
     /*  195163 */     // GIR_Coverage, 582,
     /*  195163 */     GIR_Done,
     /*  195164 */   // Label 3846: @195164
     /*  195164 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(195205), // Rule ID 583 //
     /*  195169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195172 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195186 */     // MIs[0] rs1
     /*  195186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195198 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_RL),
     /*  195203 */     GIR_RootConstrainSelectedInstOperands,
     /*  195204 */     // GIR_Coverage, 583,
     /*  195204 */     GIR_Done,
     /*  195205 */   // Label 3847: @195205
     /*  195205 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(195246), // Rule ID 584 //
     /*  195210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195213 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195220 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195227 */     // MIs[0] rs1
     /*  195227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195239 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  195244 */     GIR_RootConstrainSelectedInstOperands,
     /*  195245 */     // GIR_Coverage, 584,
     /*  195245 */     GIR_Done,
     /*  195246 */   // Label 3848: @195246
     /*  195246 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(195287), // Rule ID 585 //
     /*  195251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195254 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195261 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195268 */     // MIs[0] rs1
     /*  195268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195280 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  195285 */     GIR_RootConstrainSelectedInstOperands,
     /*  195286 */     // GIR_Coverage, 585,
     /*  195286 */     GIR_Done,
     /*  195287 */   // Label 3849: @195287
     /*  195287 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(195328), // Rule ID 586 //
     /*  195292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195295 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195302 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195309 */     // MIs[0] rs1
     /*  195309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195321 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195326 */     GIR_RootConstrainSelectedInstOperands,
     /*  195327 */     // GIR_Coverage, 586,
     /*  195327 */     GIR_Done,
     /*  195328 */   // Label 3850: @195328
     /*  195328 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(195369), // Rule ID 587 //
     /*  195333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195350 */     // MIs[0] rs1
     /*  195350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195362 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195367 */     GIR_RootConstrainSelectedInstOperands,
     /*  195368 */     // GIR_Coverage, 587,
     /*  195368 */     GIR_Done,
     /*  195369 */   // Label 3851: @195369
     /*  195369 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(195410), // Rule ID 588 //
     /*  195374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195377 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195384 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195391 */     // MIs[0] rs1
     /*  195391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195403 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195408 */     GIR_RootConstrainSelectedInstOperands,
     /*  195409 */     // GIR_Coverage, 588,
     /*  195409 */     GIR_Done,
     /*  195410 */   // Label 3852: @195410
     /*  195410 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(195451), // Rule ID 589 //
     /*  195415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195418 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195432 */     // MIs[0] rs1
     /*  195432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195444 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195449 */     GIR_RootConstrainSelectedInstOperands,
     /*  195450 */     // GIR_Coverage, 589,
     /*  195450 */     GIR_Done,
     /*  195451 */   // Label 3853: @195451
     /*  195451 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(195492), // Rule ID 590 //
     /*  195456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195459 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195466 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195473 */     // MIs[0] rs1
     /*  195473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195485 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195490 */     GIR_RootConstrainSelectedInstOperands,
     /*  195491 */     // GIR_Coverage, 590,
     /*  195491 */     GIR_Done,
     /*  195492 */   // Label 3854: @195492
     /*  195492 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(195533), // Rule ID 789 //
     /*  195497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195514 */     // MIs[0] rs1
     /*  195514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195526 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195531 */     GIR_RootConstrainSelectedInstOperands,
     /*  195532 */     // GIR_Coverage, 789,
     /*  195532 */     GIR_Done,
     /*  195533 */   // Label 3855: @195533
     /*  195533 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(195574), // Rule ID 791 //
     /*  195538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195541 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195548 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195555 */     // MIs[0] rs1
     /*  195555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195567 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  195572 */     GIR_RootConstrainSelectedInstOperands,
     /*  195573 */     // GIR_Coverage, 791,
     /*  195573 */     GIR_Done,
     /*  195574 */   // Label 3856: @195574
     /*  195574 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(195615), // Rule ID 793 //
     /*  195579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195596 */     // MIs[0] rs1
     /*  195596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195608 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  195613 */     GIR_RootConstrainSelectedInstOperands,
     /*  195614 */     // GIR_Coverage, 793,
     /*  195614 */     GIR_Done,
     /*  195615 */   // Label 3857: @195615
     /*  195615 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(195656), // Rule ID 795 //
     /*  195620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195623 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195630 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195637 */     // MIs[0] rs1
     /*  195637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195649 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  195654 */     GIR_RootConstrainSelectedInstOperands,
     /*  195655 */     // GIR_Coverage, 795,
     /*  195655 */     GIR_Done,
     /*  195656 */   // Label 3858: @195656
     /*  195656 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(195697), // Rule ID 797 //
     /*  195661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195664 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195671 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195678 */     // MIs[0] rs1
     /*  195678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195690 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  195695 */     GIR_RootConstrainSelectedInstOperands,
     /*  195696 */     // GIR_Coverage, 797,
     /*  195696 */     GIR_Done,
     /*  195697 */   // Label 3859: @195697
     /*  195697 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(195738), // Rule ID 799 //
     /*  195702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195719 */     // MIs[0] rs1
     /*  195719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195731 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195736 */     GIR_RootConstrainSelectedInstOperands,
     /*  195737 */     // GIR_Coverage, 799,
     /*  195737 */     GIR_Done,
     /*  195738 */   // Label 3860: @195738
     /*  195738 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(195779), // Rule ID 801 //
     /*  195743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195753 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195760 */     // MIs[0] rs1
     /*  195760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195772 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195777 */     GIR_RootConstrainSelectedInstOperands,
     /*  195778 */     // GIR_Coverage, 801,
     /*  195778 */     GIR_Done,
     /*  195779 */   // Label 3861: @195779
     /*  195779 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(195820), // Rule ID 803 //
     /*  195784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195787 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195801 */     // MIs[0] rs1
     /*  195801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195813 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195818 */     GIR_RootConstrainSelectedInstOperands,
     /*  195819 */     // GIR_Coverage, 803,
     /*  195819 */     GIR_Done,
     /*  195820 */   // Label 3862: @195820
     /*  195820 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(195861), // Rule ID 805 //
     /*  195825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195842 */     // MIs[0] rs1
     /*  195842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195854 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195859 */     GIR_RootConstrainSelectedInstOperands,
     /*  195860 */     // GIR_Coverage, 805,
     /*  195860 */     GIR_Done,
     /*  195861 */   // Label 3863: @195861
     /*  195861 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(195902), // Rule ID 807 //
     /*  195866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195869 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195876 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195883 */     // MIs[0] rs1
     /*  195883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195895 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195900 */     GIR_RootConstrainSelectedInstOperands,
     /*  195901 */     // GIR_Coverage, 807,
     /*  195901 */     GIR_Done,
     /*  195902 */   // Label 3864: @195902
     /*  195902 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(195943), // Rule ID 969 //
     /*  195907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195924 */     // MIs[0] rs1
     /*  195924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195936 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195941 */     GIR_RootConstrainSelectedInstOperands,
     /*  195942 */     // GIR_Coverage, 969,
     /*  195942 */     GIR_Done,
     /*  195943 */   // Label 3865: @195943
     /*  195943 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(195984), // Rule ID 971 //
     /*  195948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195951 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195958 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195965 */     // MIs[0] rs1
     /*  195965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195977 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  195982 */     GIR_RootConstrainSelectedInstOperands,
     /*  195983 */     // GIR_Coverage, 971,
     /*  195983 */     GIR_Done,
     /*  195984 */   // Label 3866: @195984
     /*  195984 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(196025), // Rule ID 973 //
     /*  195989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195992 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196006 */     // MIs[0] rs1
     /*  196006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196018 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  196023 */     GIR_RootConstrainSelectedInstOperands,
     /*  196024 */     // GIR_Coverage, 973,
     /*  196024 */     GIR_Done,
     /*  196025 */   // Label 3867: @196025
     /*  196025 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(196066), // Rule ID 975 //
     /*  196030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196047 */     // MIs[0] rs1
     /*  196047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196059 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  196064 */     GIR_RootConstrainSelectedInstOperands,
     /*  196065 */     // GIR_Coverage, 975,
     /*  196065 */     GIR_Done,
     /*  196066 */   // Label 3868: @196066
     /*  196066 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(196107), // Rule ID 977 //
     /*  196071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196074 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196081 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196088 */     // MIs[0] rs1
     /*  196088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196100 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  196105 */     GIR_RootConstrainSelectedInstOperands,
     /*  196106 */     // GIR_Coverage, 977,
     /*  196106 */     GIR_Done,
     /*  196107 */   // Label 3869: @196107
     /*  196107 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(196148), // Rule ID 979 //
     /*  196112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196115 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196122 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196129 */     // MIs[0] rs1
     /*  196129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196141 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  196146 */     GIR_RootConstrainSelectedInstOperands,
     /*  196147 */     // GIR_Coverage, 979,
     /*  196147 */     GIR_Done,
     /*  196148 */   // Label 3870: @196148
     /*  196148 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(196189), // Rule ID 981 //
     /*  196153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196170 */     // MIs[0] rs1
     /*  196170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196182 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  196187 */     GIR_RootConstrainSelectedInstOperands,
     /*  196188 */     // GIR_Coverage, 981,
     /*  196188 */     GIR_Done,
     /*  196189 */   // Label 3871: @196189
     /*  196189 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(196230), // Rule ID 983 //
     /*  196194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196211 */     // MIs[0] rs1
     /*  196211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196223 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  196228 */     GIR_RootConstrainSelectedInstOperands,
     /*  196229 */     // GIR_Coverage, 983,
     /*  196229 */     GIR_Done,
     /*  196230 */   // Label 3872: @196230
     /*  196230 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(196271), // Rule ID 985 //
     /*  196235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196252 */     // MIs[0] rs1
     /*  196252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196264 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  196269 */     GIR_RootConstrainSelectedInstOperands,
     /*  196270 */     // GIR_Coverage, 985,
     /*  196270 */     GIR_Done,
     /*  196271 */   // Label 3873: @196271
     /*  196271 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(196312), // Rule ID 987 //
     /*  196276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196279 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196293 */     // MIs[0] rs1
     /*  196293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196305 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  196310 */     GIR_RootConstrainSelectedInstOperands,
     /*  196311 */     // GIR_Coverage, 987,
     /*  196311 */     GIR_Done,
     /*  196312 */   // Label 3874: @196312
     /*  196312 */   GIM_Reject,
     /*  196313 */ // Label 3834: @196313
     /*  196313 */ GIM_Reject,
     /*  196314 */ // Label 3802: @196314
     /*  196314 */ GIM_Reject,
     /*  196315 */ // Label 32: @196315
     /*  196315 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3877*/ GIMT_Encode4(199224),
     /*  196326 */ /*GILLT_s32*//*Label 3875*/ GIMT_Encode4(196334),
     /*  196330 */ /*GILLT_s64*//*Label 3876*/ GIMT_Encode4(197574),
     /*  196334 */ // Label 3875: @196334
     /*  196334 */ GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(197573),
     /*  196339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  196342 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(196383), // Rule ID 462 //
     /*  196347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196350 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196357 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196364 */     // MIs[0] rs1
     /*  196364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196376 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196381 */     GIR_RootConstrainSelectedInstOperands,
     /*  196382 */     // GIR_Coverage, 462,
     /*  196382 */     GIR_Done,
     /*  196383 */   // Label 3879: @196383
     /*  196383 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(196424), // Rule ID 464 //
     /*  196388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196391 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196398 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196405 */     // MIs[0] rs1
     /*  196405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196417 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  196422 */     GIR_RootConstrainSelectedInstOperands,
     /*  196423 */     // GIR_Coverage, 464,
     /*  196423 */     GIR_Done,
     /*  196424 */   // Label 3880: @196424
     /*  196424 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(196465), // Rule ID 466 //
     /*  196429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196432 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196446 */     // MIs[0] rs1
     /*  196446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196458 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  196463 */     GIR_RootConstrainSelectedInstOperands,
     /*  196464 */     // GIR_Coverage, 466,
     /*  196464 */     GIR_Done,
     /*  196465 */   // Label 3881: @196465
     /*  196465 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(196506), // Rule ID 468 //
     /*  196470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196480 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196487 */     // MIs[0] rs1
     /*  196487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196499 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  196504 */     GIR_RootConstrainSelectedInstOperands,
     /*  196505 */     // GIR_Coverage, 468,
     /*  196505 */     GIR_Done,
     /*  196506 */   // Label 3882: @196506
     /*  196506 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(196547), // Rule ID 470 //
     /*  196511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196514 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196521 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196528 */     // MIs[0] rs1
     /*  196528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196540 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  196545 */     GIR_RootConstrainSelectedInstOperands,
     /*  196546 */     // GIR_Coverage, 470,
     /*  196546 */     GIR_Done,
     /*  196547 */   // Label 3883: @196547
     /*  196547 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(196588), // Rule ID 472 //
     /*  196552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196562 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196569 */     // MIs[0] rs1
     /*  196569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196581 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196586 */     GIR_RootConstrainSelectedInstOperands,
     /*  196587 */     // GIR_Coverage, 472,
     /*  196587 */     GIR_Done,
     /*  196588 */   // Label 3884: @196588
     /*  196588 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(196629), // Rule ID 474 //
     /*  196593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196610 */     // MIs[0] rs1
     /*  196610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196622 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196627 */     GIR_RootConstrainSelectedInstOperands,
     /*  196628 */     // GIR_Coverage, 474,
     /*  196628 */     GIR_Done,
     /*  196629 */   // Label 3885: @196629
     /*  196629 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(196670), // Rule ID 476 //
     /*  196634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196651 */     // MIs[0] rs1
     /*  196651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196663 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196668 */     GIR_RootConstrainSelectedInstOperands,
     /*  196669 */     // GIR_Coverage, 476,
     /*  196669 */     GIR_Done,
     /*  196670 */   // Label 3886: @196670
     /*  196670 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(196711), // Rule ID 478 //
     /*  196675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196678 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196692 */     // MIs[0] rs1
     /*  196692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196704 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196709 */     GIR_RootConstrainSelectedInstOperands,
     /*  196710 */     // GIR_Coverage, 478,
     /*  196710 */     GIR_Done,
     /*  196711 */   // Label 3887: @196711
     /*  196711 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(196752), // Rule ID 480 //
     /*  196716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196719 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196726 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196733 */     // MIs[0] rs1
     /*  196733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196745 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196750 */     GIR_RootConstrainSelectedInstOperands,
     /*  196751 */     // GIR_Coverage, 480,
     /*  196751 */     GIR_Done,
     /*  196752 */   // Label 3888: @196752
     /*  196752 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(196793), // Rule ID 810 //
     /*  196757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196774 */     // MIs[0] rs1
     /*  196774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196786 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196786 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196791 */     GIR_RootConstrainSelectedInstOperands,
     /*  196792 */     // GIR_Coverage, 810,
     /*  196792 */     GIR_Done,
     /*  196793 */   // Label 3889: @196793
     /*  196793 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(196834), // Rule ID 812 //
     /*  196798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196808 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196815 */     // MIs[0] rs1
     /*  196815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196827 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  196832 */     GIR_RootConstrainSelectedInstOperands,
     /*  196833 */     // GIR_Coverage, 812,
     /*  196833 */     GIR_Done,
     /*  196834 */   // Label 3890: @196834
     /*  196834 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(196875), // Rule ID 814 //
     /*  196839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196842 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196856 */     // MIs[0] rs1
     /*  196856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196868 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  196873 */     GIR_RootConstrainSelectedInstOperands,
     /*  196874 */     // GIR_Coverage, 814,
     /*  196874 */     GIR_Done,
     /*  196875 */   // Label 3891: @196875
     /*  196875 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(196916), // Rule ID 816 //
     /*  196880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196890 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196897 */     // MIs[0] rs1
     /*  196897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196909 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  196914 */     GIR_RootConstrainSelectedInstOperands,
     /*  196915 */     // GIR_Coverage, 816,
     /*  196915 */     GIR_Done,
     /*  196916 */   // Label 3892: @196916
     /*  196916 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(196957), // Rule ID 818 //
     /*  196921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196924 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196931 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196938 */     // MIs[0] rs1
     /*  196938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196950 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  196955 */     GIR_RootConstrainSelectedInstOperands,
     /*  196956 */     // GIR_Coverage, 818,
     /*  196956 */     GIR_Done,
     /*  196957 */   // Label 3893: @196957
     /*  196957 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(196998), // Rule ID 820 //
     /*  196962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196965 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196972 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196979 */     // MIs[0] rs1
     /*  196979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196991 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196996 */     GIR_RootConstrainSelectedInstOperands,
     /*  196997 */     // GIR_Coverage, 820,
     /*  196997 */     GIR_Done,
     /*  196998 */   // Label 3894: @196998
     /*  196998 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(197039), // Rule ID 822 //
     /*  197003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197006 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197013 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197020 */     // MIs[0] rs1
     /*  197020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197032 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197037 */     GIR_RootConstrainSelectedInstOperands,
     /*  197038 */     // GIR_Coverage, 822,
     /*  197038 */     GIR_Done,
     /*  197039 */   // Label 3895: @197039
     /*  197039 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(197080), // Rule ID 824 //
     /*  197044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197047 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197054 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197061 */     // MIs[0] rs1
     /*  197061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197073 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197078 */     GIR_RootConstrainSelectedInstOperands,
     /*  197079 */     // GIR_Coverage, 824,
     /*  197079 */     GIR_Done,
     /*  197080 */   // Label 3896: @197080
     /*  197080 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(197121), // Rule ID 826 //
     /*  197085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197088 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197102 */     // MIs[0] rs1
     /*  197102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197114 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197119 */     GIR_RootConstrainSelectedInstOperands,
     /*  197120 */     // GIR_Coverage, 826,
     /*  197120 */     GIR_Done,
     /*  197121 */   // Label 3897: @197121
     /*  197121 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(197162), // Rule ID 828 //
     /*  197126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197129 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197136 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197143 */     // MIs[0] rs1
     /*  197143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197155 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197160 */     GIR_RootConstrainSelectedInstOperands,
     /*  197161 */     // GIR_Coverage, 828,
     /*  197161 */     GIR_Done,
     /*  197162 */   // Label 3898: @197162
     /*  197162 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(197203), // Rule ID 990 //
     /*  197167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197170 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197177 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197184 */     // MIs[0] rs1
     /*  197184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197196 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197201 */     GIR_RootConstrainSelectedInstOperands,
     /*  197202 */     // GIR_Coverage, 990,
     /*  197202 */     GIR_Done,
     /*  197203 */   // Label 3899: @197203
     /*  197203 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(197244), // Rule ID 992 //
     /*  197208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197211 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197218 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197225 */     // MIs[0] rs1
     /*  197225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197237 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  197242 */     GIR_RootConstrainSelectedInstOperands,
     /*  197243 */     // GIR_Coverage, 992,
     /*  197243 */     GIR_Done,
     /*  197244 */   // Label 3900: @197244
     /*  197244 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(197285), // Rule ID 994 //
     /*  197249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197252 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197259 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197266 */     // MIs[0] rs1
     /*  197266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197278 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  197283 */     GIR_RootConstrainSelectedInstOperands,
     /*  197284 */     // GIR_Coverage, 994,
     /*  197284 */     GIR_Done,
     /*  197285 */   // Label 3901: @197285
     /*  197285 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(197326), // Rule ID 996 //
     /*  197290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197293 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197307 */     // MIs[0] rs1
     /*  197307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197319 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  197324 */     GIR_RootConstrainSelectedInstOperands,
     /*  197325 */     // GIR_Coverage, 996,
     /*  197325 */     GIR_Done,
     /*  197326 */   // Label 3902: @197326
     /*  197326 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(197367), // Rule ID 998 //
     /*  197331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197334 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197341 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197348 */     // MIs[0] rs1
     /*  197348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197360 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  197365 */     GIR_RootConstrainSelectedInstOperands,
     /*  197366 */     // GIR_Coverage, 998,
     /*  197366 */     GIR_Done,
     /*  197367 */   // Label 3903: @197367
     /*  197367 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(197408), // Rule ID 1000 //
     /*  197372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197375 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197382 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197389 */     // MIs[0] rs1
     /*  197389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197401 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197406 */     GIR_RootConstrainSelectedInstOperands,
     /*  197407 */     // GIR_Coverage, 1000,
     /*  197407 */     GIR_Done,
     /*  197408 */   // Label 3904: @197408
     /*  197408 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(197449), // Rule ID 1002 //
     /*  197413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197416 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197430 */     // MIs[0] rs1
     /*  197430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197442 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197447 */     GIR_RootConstrainSelectedInstOperands,
     /*  197448 */     // GIR_Coverage, 1002,
     /*  197448 */     GIR_Done,
     /*  197449 */   // Label 3905: @197449
     /*  197449 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(197490), // Rule ID 1004 //
     /*  197454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197457 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197464 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197471 */     // MIs[0] rs1
     /*  197471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197483 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197483 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197488 */     GIR_RootConstrainSelectedInstOperands,
     /*  197489 */     // GIR_Coverage, 1004,
     /*  197489 */     GIR_Done,
     /*  197490 */   // Label 3906: @197490
     /*  197490 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(197531), // Rule ID 1006 //
     /*  197495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197512 */     // MIs[0] rs1
     /*  197512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197524 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197529 */     GIR_RootConstrainSelectedInstOperands,
     /*  197530 */     // GIR_Coverage, 1006,
     /*  197530 */     GIR_Done,
     /*  197531 */   // Label 3907: @197531
     /*  197531 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(197572), // Rule ID 1008 //
     /*  197536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197553 */     // MIs[0] rs1
     /*  197553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197565 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197570 */     GIR_RootConstrainSelectedInstOperands,
     /*  197571 */     // GIR_Coverage, 1008,
     /*  197571 */     GIR_Done,
     /*  197572 */   // Label 3908: @197572
     /*  197572 */   GIM_Reject,
     /*  197573 */ // Label 3878: @197573
     /*  197573 */ GIM_Reject,
     /*  197574 */ // Label 3876: @197574
     /*  197574 */ GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(199223),
     /*  197579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  197582 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(197623), // Rule ID 461 //
     /*  197587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197590 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197597 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197604 */     // MIs[0] rs1
     /*  197604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197616 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197621 */     GIR_RootConstrainSelectedInstOperands,
     /*  197622 */     // GIR_Coverage, 461,
     /*  197622 */     GIR_Done,
     /*  197623 */   // Label 3910: @197623
     /*  197623 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(197664), // Rule ID 463 //
     /*  197628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197631 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197638 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197645 */     // MIs[0] rs1
     /*  197645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197657 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  197662 */     GIR_RootConstrainSelectedInstOperands,
     /*  197663 */     // GIR_Coverage, 463,
     /*  197663 */     GIR_Done,
     /*  197664 */   // Label 3911: @197664
     /*  197664 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(197705), // Rule ID 465 //
     /*  197669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197672 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197679 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197686 */     // MIs[0] rs1
     /*  197686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197698 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  197703 */     GIR_RootConstrainSelectedInstOperands,
     /*  197704 */     // GIR_Coverage, 465,
     /*  197704 */     GIR_Done,
     /*  197705 */   // Label 3912: @197705
     /*  197705 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(197746), // Rule ID 467 //
     /*  197710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197713 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197720 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197727 */     // MIs[0] rs1
     /*  197727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197739 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  197744 */     GIR_RootConstrainSelectedInstOperands,
     /*  197745 */     // GIR_Coverage, 467,
     /*  197745 */     GIR_Done,
     /*  197746 */   // Label 3913: @197746
     /*  197746 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(197787), // Rule ID 469 //
     /*  197751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197754 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197768 */     // MIs[0] rs1
     /*  197768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197780 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  197785 */     GIR_RootConstrainSelectedInstOperands,
     /*  197786 */     // GIR_Coverage, 469,
     /*  197786 */     GIR_Done,
     /*  197787 */   // Label 3914: @197787
     /*  197787 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(197828), // Rule ID 471 //
     /*  197792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197809 */     // MIs[0] rs1
     /*  197809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197821 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197826 */     GIR_RootConstrainSelectedInstOperands,
     /*  197827 */     // GIR_Coverage, 471,
     /*  197827 */     GIR_Done,
     /*  197828 */   // Label 3915: @197828
     /*  197828 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(197869), // Rule ID 473 //
     /*  197833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197836 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197850 */     // MIs[0] rs1
     /*  197850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197862 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197867 */     GIR_RootConstrainSelectedInstOperands,
     /*  197868 */     // GIR_Coverage, 473,
     /*  197868 */     GIR_Done,
     /*  197869 */   // Label 3916: @197869
     /*  197869 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(197910), // Rule ID 475 //
     /*  197874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197891 */     // MIs[0] rs1
     /*  197891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197903 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197908 */     GIR_RootConstrainSelectedInstOperands,
     /*  197909 */     // GIR_Coverage, 475,
     /*  197909 */     GIR_Done,
     /*  197910 */   // Label 3917: @197910
     /*  197910 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(197951), // Rule ID 477 //
     /*  197915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197932 */     // MIs[0] rs1
     /*  197932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197944 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197949 */     GIR_RootConstrainSelectedInstOperands,
     /*  197950 */     // GIR_Coverage, 477,
     /*  197950 */     GIR_Done,
     /*  197951 */   // Label 3918: @197951
     /*  197951 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(197992), // Rule ID 479 //
     /*  197956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197959 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197966 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197973 */     // MIs[0] rs1
     /*  197973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197985 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197990 */     GIR_RootConstrainSelectedInstOperands,
     /*  197991 */     // GIR_Coverage, 479,
     /*  197991 */     GIR_Done,
     /*  197992 */   // Label 3919: @197992
     /*  197992 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(198033), // Rule ID 591 //
     /*  197997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198000 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198007 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198014 */     // MIs[0] rs1
     /*  198014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198026 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  198031 */     GIR_RootConstrainSelectedInstOperands,
     /*  198032 */     // GIR_Coverage, 591,
     /*  198032 */     GIR_Done,
     /*  198033 */   // Label 3920: @198033
     /*  198033 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(198074), // Rule ID 592 //
     /*  198038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198041 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198048 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198055 */     // MIs[0] rs1
     /*  198055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198067 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ),
     /*  198072 */     GIR_RootConstrainSelectedInstOperands,
     /*  198073 */     // GIR_Coverage, 592,
     /*  198073 */     GIR_Done,
     /*  198074 */   // Label 3921: @198074
     /*  198074 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(198115), // Rule ID 593 //
     /*  198079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198082 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198089 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198096 */     // MIs[0] rs1
     /*  198096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198108 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_RL),
     /*  198113 */     GIR_RootConstrainSelectedInstOperands,
     /*  198114 */     // GIR_Coverage, 593,
     /*  198114 */     GIR_Done,
     /*  198115 */   // Label 3922: @198115
     /*  198115 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(198156), // Rule ID 594 //
     /*  198120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198123 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198137 */     // MIs[0] rs1
     /*  198137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198149 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  198154 */     GIR_RootConstrainSelectedInstOperands,
     /*  198155 */     // GIR_Coverage, 594,
     /*  198155 */     GIR_Done,
     /*  198156 */   // Label 3923: @198156
     /*  198156 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(198197), // Rule ID 595 //
     /*  198161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198178 */     // MIs[0] rs1
     /*  198178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198190 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  198195 */     GIR_RootConstrainSelectedInstOperands,
     /*  198196 */     // GIR_Coverage, 595,
     /*  198196 */     GIR_Done,
     /*  198197 */   // Label 3924: @198197
     /*  198197 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(198238), // Rule ID 596 //
     /*  198202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198219 */     // MIs[0] rs1
     /*  198219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198231 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  198236 */     GIR_RootConstrainSelectedInstOperands,
     /*  198237 */     // GIR_Coverage, 596,
     /*  198237 */     GIR_Done,
     /*  198238 */   // Label 3925: @198238
     /*  198238 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(198279), // Rule ID 597 //
     /*  198243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198260 */     // MIs[0] rs1
     /*  198260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198272 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  198277 */     GIR_RootConstrainSelectedInstOperands,
     /*  198278 */     // GIR_Coverage, 597,
     /*  198278 */     GIR_Done,
     /*  198279 */   // Label 3926: @198279
     /*  198279 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(198320), // Rule ID 598 //
     /*  198284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198287 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198301 */     // MIs[0] rs1
     /*  198301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198313 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  198318 */     GIR_RootConstrainSelectedInstOperands,
     /*  198319 */     // GIR_Coverage, 598,
     /*  198319 */     GIR_Done,
     /*  198320 */   // Label 3927: @198320
     /*  198320 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(198361), // Rule ID 599 //
     /*  198325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198342 */     // MIs[0] rs1
     /*  198342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198354 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  198359 */     GIR_RootConstrainSelectedInstOperands,
     /*  198360 */     // GIR_Coverage, 599,
     /*  198360 */     GIR_Done,
     /*  198361 */   // Label 3928: @198361
     /*  198361 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(198402), // Rule ID 600 //
     /*  198366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198369 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198376 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198383 */     // MIs[0] rs1
     /*  198383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198395 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  198400 */     GIR_RootConstrainSelectedInstOperands,
     /*  198401 */     // GIR_Coverage, 600,
     /*  198401 */     GIR_Done,
     /*  198402 */   // Label 3929: @198402
     /*  198402 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(198443), // Rule ID 809 //
     /*  198407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198417 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198424 */     // MIs[0] rs1
     /*  198424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198436 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198441 */     GIR_RootConstrainSelectedInstOperands,
     /*  198442 */     // GIR_Coverage, 809,
     /*  198442 */     GIR_Done,
     /*  198443 */   // Label 3930: @198443
     /*  198443 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(198484), // Rule ID 811 //
     /*  198448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198451 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198458 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198465 */     // MIs[0] rs1
     /*  198465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198477 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  198482 */     GIR_RootConstrainSelectedInstOperands,
     /*  198483 */     // GIR_Coverage, 811,
     /*  198483 */     GIR_Done,
     /*  198484 */   // Label 3931: @198484
     /*  198484 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(198525), // Rule ID 813 //
     /*  198489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198506 */     // MIs[0] rs1
     /*  198506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198518 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  198523 */     GIR_RootConstrainSelectedInstOperands,
     /*  198524 */     // GIR_Coverage, 813,
     /*  198524 */     GIR_Done,
     /*  198525 */   // Label 3932: @198525
     /*  198525 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(198566), // Rule ID 815 //
     /*  198530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198533 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198540 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198547 */     // MIs[0] rs1
     /*  198547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198559 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  198564 */     GIR_RootConstrainSelectedInstOperands,
     /*  198565 */     // GIR_Coverage, 815,
     /*  198565 */     GIR_Done,
     /*  198566 */   // Label 3933: @198566
     /*  198566 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(198607), // Rule ID 817 //
     /*  198571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198574 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198581 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198588 */     // MIs[0] rs1
     /*  198588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198600 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  198605 */     GIR_RootConstrainSelectedInstOperands,
     /*  198606 */     // GIR_Coverage, 817,
     /*  198606 */     GIR_Done,
     /*  198607 */   // Label 3934: @198607
     /*  198607 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(198648), // Rule ID 819 //
     /*  198612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198615 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198622 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198629 */     // MIs[0] rs1
     /*  198629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198641 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198646 */     GIR_RootConstrainSelectedInstOperands,
     /*  198647 */     // GIR_Coverage, 819,
     /*  198647 */     GIR_Done,
     /*  198648 */   // Label 3935: @198648
     /*  198648 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(198689), // Rule ID 821 //
     /*  198653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198670 */     // MIs[0] rs1
     /*  198670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198682 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198687 */     GIR_RootConstrainSelectedInstOperands,
     /*  198688 */     // GIR_Coverage, 821,
     /*  198688 */     GIR_Done,
     /*  198689 */   // Label 3936: @198689
     /*  198689 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(198730), // Rule ID 823 //
     /*  198694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198697 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198704 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198711 */     // MIs[0] rs1
     /*  198711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198723 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198728 */     GIR_RootConstrainSelectedInstOperands,
     /*  198729 */     // GIR_Coverage, 823,
     /*  198729 */     GIR_Done,
     /*  198730 */   // Label 3937: @198730
     /*  198730 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(198771), // Rule ID 825 //
     /*  198735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198745 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198752 */     // MIs[0] rs1
     /*  198752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198764 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198769 */     GIR_RootConstrainSelectedInstOperands,
     /*  198770 */     // GIR_Coverage, 825,
     /*  198770 */     GIR_Done,
     /*  198771 */   // Label 3938: @198771
     /*  198771 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(198812), // Rule ID 827 //
     /*  198776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198779 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198793 */     // MIs[0] rs1
     /*  198793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198805 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198810 */     GIR_RootConstrainSelectedInstOperands,
     /*  198811 */     // GIR_Coverage, 827,
     /*  198811 */     GIR_Done,
     /*  198812 */   // Label 3939: @198812
     /*  198812 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(198853), // Rule ID 989 //
     /*  198817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198820 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198834 */     // MIs[0] rs1
     /*  198834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198846 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198851 */     GIR_RootConstrainSelectedInstOperands,
     /*  198852 */     // GIR_Coverage, 989,
     /*  198852 */     GIR_Done,
     /*  198853 */   // Label 3940: @198853
     /*  198853 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(198894), // Rule ID 991 //
     /*  198858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198861 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198875 */     // MIs[0] rs1
     /*  198875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198887 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  198892 */     GIR_RootConstrainSelectedInstOperands,
     /*  198893 */     // GIR_Coverage, 991,
     /*  198893 */     GIR_Done,
     /*  198894 */   // Label 3941: @198894
     /*  198894 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(198935), // Rule ID 993 //
     /*  198899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198902 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198909 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198916 */     // MIs[0] rs1
     /*  198916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198928 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  198933 */     GIR_RootConstrainSelectedInstOperands,
     /*  198934 */     // GIR_Coverage, 993,
     /*  198934 */     GIR_Done,
     /*  198935 */   // Label 3942: @198935
     /*  198935 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(198976), // Rule ID 995 //
     /*  198940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198943 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198950 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198957 */     // MIs[0] rs1
     /*  198957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198969 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  198974 */     GIR_RootConstrainSelectedInstOperands,
     /*  198975 */     // GIR_Coverage, 995,
     /*  198975 */     GIR_Done,
     /*  198976 */   // Label 3943: @198976
     /*  198976 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(199017), // Rule ID 997 //
     /*  198981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198984 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198991 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198998 */     // MIs[0] rs1
     /*  198998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199010 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  199015 */     GIR_RootConstrainSelectedInstOperands,
     /*  199016 */     // GIR_Coverage, 997,
     /*  199016 */     GIR_Done,
     /*  199017 */   // Label 3944: @199017
     /*  199017 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(199058), // Rule ID 999 //
     /*  199022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199032 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199039 */     // MIs[0] rs1
     /*  199039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199051 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  199056 */     GIR_RootConstrainSelectedInstOperands,
     /*  199057 */     // GIR_Coverage, 999,
     /*  199057 */     GIR_Done,
     /*  199058 */   // Label 3945: @199058
     /*  199058 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(199099), // Rule ID 1001 //
     /*  199063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199080 */     // MIs[0] rs1
     /*  199080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199092 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  199097 */     GIR_RootConstrainSelectedInstOperands,
     /*  199098 */     // GIR_Coverage, 1001,
     /*  199098 */     GIR_Done,
     /*  199099 */   // Label 3946: @199099
     /*  199099 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(199140), // Rule ID 1003 //
     /*  199104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199107 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199114 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199121 */     // MIs[0] rs1
     /*  199121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199133 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  199138 */     GIR_RootConstrainSelectedInstOperands,
     /*  199139 */     // GIR_Coverage, 1003,
     /*  199139 */     GIR_Done,
     /*  199140 */   // Label 3947: @199140
     /*  199140 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(199181), // Rule ID 1005 //
     /*  199145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199148 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199155 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199162 */     // MIs[0] rs1
     /*  199162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199174 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  199179 */     GIR_RootConstrainSelectedInstOperands,
     /*  199180 */     // GIR_Coverage, 1005,
     /*  199180 */     GIR_Done,
     /*  199181 */   // Label 3948: @199181
     /*  199181 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(199222), // Rule ID 1007 //
     /*  199186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199189 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199203 */     // MIs[0] rs1
     /*  199203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199215 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  199220 */     GIR_RootConstrainSelectedInstOperands,
     /*  199221 */     // GIR_Coverage, 1007,
     /*  199221 */     GIR_Done,
     /*  199222 */   // Label 3949: @199222
     /*  199222 */   GIM_Reject,
     /*  199223 */ // Label 3909: @199223
     /*  199223 */ GIM_Reject,
     /*  199224 */ // Label 3877: @199224
     /*  199224 */ GIM_Reject,
     /*  199225 */ // Label 33: @199225
     /*  199225 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3952*/ GIMT_Encode4(202134),
     /*  199236 */ /*GILLT_s32*//*Label 3950*/ GIMT_Encode4(199244),
     /*  199240 */ /*GILLT_s64*//*Label 3951*/ GIMT_Encode4(200484),
     /*  199244 */ // Label 3950: @199244
     /*  199244 */ GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(200483),
     /*  199249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  199252 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(199293), // Rule ID 482 //
     /*  199257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199260 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199267 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199274 */     // MIs[0] rs1
     /*  199274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199286 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199291 */     GIR_RootConstrainSelectedInstOperands,
     /*  199292 */     // GIR_Coverage, 482,
     /*  199292 */     GIR_Done,
     /*  199293 */   // Label 3954: @199293
     /*  199293 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(199334), // Rule ID 484 //
     /*  199298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199301 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199308 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199315 */     // MIs[0] rs1
     /*  199315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199327 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  199332 */     GIR_RootConstrainSelectedInstOperands,
     /*  199333 */     // GIR_Coverage, 484,
     /*  199333 */     GIR_Done,
     /*  199334 */   // Label 3955: @199334
     /*  199334 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(199375), // Rule ID 486 //
     /*  199339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199342 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199349 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199356 */     // MIs[0] rs1
     /*  199356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199368 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  199373 */     GIR_RootConstrainSelectedInstOperands,
     /*  199374 */     // GIR_Coverage, 486,
     /*  199374 */     GIR_Done,
     /*  199375 */   // Label 3956: @199375
     /*  199375 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(199416), // Rule ID 488 //
     /*  199380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199383 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199397 */     // MIs[0] rs1
     /*  199397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199409 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  199414 */     GIR_RootConstrainSelectedInstOperands,
     /*  199415 */     // GIR_Coverage, 488,
     /*  199415 */     GIR_Done,
     /*  199416 */   // Label 3957: @199416
     /*  199416 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(199457), // Rule ID 490 //
     /*  199421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199424 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199431 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199438 */     // MIs[0] rs1
     /*  199438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199450 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  199455 */     GIR_RootConstrainSelectedInstOperands,
     /*  199456 */     // GIR_Coverage, 490,
     /*  199456 */     GIR_Done,
     /*  199457 */   // Label 3958: @199457
     /*  199457 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(199498), // Rule ID 492 //
     /*  199462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199479 */     // MIs[0] rs1
     /*  199479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199491 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199496 */     GIR_RootConstrainSelectedInstOperands,
     /*  199497 */     // GIR_Coverage, 492,
     /*  199497 */     GIR_Done,
     /*  199498 */   // Label 3959: @199498
     /*  199498 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(199539), // Rule ID 494 //
     /*  199503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199513 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199520 */     // MIs[0] rs1
     /*  199520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199532 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199537 */     GIR_RootConstrainSelectedInstOperands,
     /*  199538 */     // GIR_Coverage, 494,
     /*  199538 */     GIR_Done,
     /*  199539 */   // Label 3960: @199539
     /*  199539 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(199580), // Rule ID 496 //
     /*  199544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199561 */     // MIs[0] rs1
     /*  199561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199573 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199578 */     GIR_RootConstrainSelectedInstOperands,
     /*  199579 */     // GIR_Coverage, 496,
     /*  199579 */     GIR_Done,
     /*  199580 */   // Label 3961: @199580
     /*  199580 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(199621), // Rule ID 498 //
     /*  199585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199602 */     // MIs[0] rs1
     /*  199602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199614 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199619 */     GIR_RootConstrainSelectedInstOperands,
     /*  199620 */     // GIR_Coverage, 498,
     /*  199620 */     GIR_Done,
     /*  199621 */   // Label 3962: @199621
     /*  199621 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(199662), // Rule ID 500 //
     /*  199626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199629 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199636 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199643 */     // MIs[0] rs1
     /*  199643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199655 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199660 */     GIR_RootConstrainSelectedInstOperands,
     /*  199661 */     // GIR_Coverage, 500,
     /*  199661 */     GIR_Done,
     /*  199662 */   // Label 3963: @199662
     /*  199662 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(199703), // Rule ID 830 //
     /*  199667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199670 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199677 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199684 */     // MIs[0] rs1
     /*  199684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199696 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199701 */     GIR_RootConstrainSelectedInstOperands,
     /*  199702 */     // GIR_Coverage, 830,
     /*  199702 */     GIR_Done,
     /*  199703 */   // Label 3964: @199703
     /*  199703 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(199744), // Rule ID 832 //
     /*  199708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199711 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199725 */     // MIs[0] rs1
     /*  199725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199737 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  199742 */     GIR_RootConstrainSelectedInstOperands,
     /*  199743 */     // GIR_Coverage, 832,
     /*  199743 */     GIR_Done,
     /*  199744 */   // Label 3965: @199744
     /*  199744 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(199785), // Rule ID 834 //
     /*  199749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199752 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199759 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199766 */     // MIs[0] rs1
     /*  199766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199778 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  199783 */     GIR_RootConstrainSelectedInstOperands,
     /*  199784 */     // GIR_Coverage, 834,
     /*  199784 */     GIR_Done,
     /*  199785 */   // Label 3966: @199785
     /*  199785 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(199826), // Rule ID 836 //
     /*  199790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199793 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199807 */     // MIs[0] rs1
     /*  199807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199819 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  199824 */     GIR_RootConstrainSelectedInstOperands,
     /*  199825 */     // GIR_Coverage, 836,
     /*  199825 */     GIR_Done,
     /*  199826 */   // Label 3967: @199826
     /*  199826 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(199867), // Rule ID 838 //
     /*  199831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199834 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199841 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199848 */     // MIs[0] rs1
     /*  199848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199860 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  199865 */     GIR_RootConstrainSelectedInstOperands,
     /*  199866 */     // GIR_Coverage, 838,
     /*  199866 */     GIR_Done,
     /*  199867 */   // Label 3968: @199867
     /*  199867 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(199908), // Rule ID 840 //
     /*  199872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199875 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199882 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199889 */     // MIs[0] rs1
     /*  199889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199901 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199901 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199906 */     GIR_RootConstrainSelectedInstOperands,
     /*  199907 */     // GIR_Coverage, 840,
     /*  199907 */     GIR_Done,
     /*  199908 */   // Label 3969: @199908
     /*  199908 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(199949), // Rule ID 842 //
     /*  199913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199923 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199930 */     // MIs[0] rs1
     /*  199930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199942 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199947 */     GIR_RootConstrainSelectedInstOperands,
     /*  199948 */     // GIR_Coverage, 842,
     /*  199948 */     GIR_Done,
     /*  199949 */   // Label 3970: @199949
     /*  199949 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(199990), // Rule ID 844 //
     /*  199954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199957 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199964 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199971 */     // MIs[0] rs1
     /*  199971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199983 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199988 */     GIR_RootConstrainSelectedInstOperands,
     /*  199989 */     // GIR_Coverage, 844,
     /*  199989 */     GIR_Done,
     /*  199990 */   // Label 3971: @199990
     /*  199990 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(200031), // Rule ID 846 //
     /*  199995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199998 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200005 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200012 */     // MIs[0] rs1
     /*  200012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200024 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200024 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  200029 */     GIR_RootConstrainSelectedInstOperands,
     /*  200030 */     // GIR_Coverage, 846,
     /*  200030 */     GIR_Done,
     /*  200031 */   // Label 3972: @200031
     /*  200031 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(200072), // Rule ID 848 //
     /*  200036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200039 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200046 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200053 */     // MIs[0] rs1
     /*  200053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200065 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  200070 */     GIR_RootConstrainSelectedInstOperands,
     /*  200071 */     // GIR_Coverage, 848,
     /*  200071 */     GIR_Done,
     /*  200072 */   // Label 3973: @200072
     /*  200072 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(200113), // Rule ID 1010 //
     /*  200077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200080 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200087 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200094 */     // MIs[0] rs1
     /*  200094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200106 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200111 */     GIR_RootConstrainSelectedInstOperands,
     /*  200112 */     // GIR_Coverage, 1010,
     /*  200112 */     GIR_Done,
     /*  200113 */   // Label 3974: @200113
     /*  200113 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(200154), // Rule ID 1012 //
     /*  200118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200121 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200128 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200135 */     // MIs[0] rs1
     /*  200135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200147 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  200152 */     GIR_RootConstrainSelectedInstOperands,
     /*  200153 */     // GIR_Coverage, 1012,
     /*  200153 */     GIR_Done,
     /*  200154 */   // Label 3975: @200154
     /*  200154 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(200195), // Rule ID 1014 //
     /*  200159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200162 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200169 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200176 */     // MIs[0] rs1
     /*  200176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200188 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  200193 */     GIR_RootConstrainSelectedInstOperands,
     /*  200194 */     // GIR_Coverage, 1014,
     /*  200194 */     GIR_Done,
     /*  200195 */   // Label 3976: @200195
     /*  200195 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(200236), // Rule ID 1016 //
     /*  200200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200203 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200217 */     // MIs[0] rs1
     /*  200217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200229 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  200234 */     GIR_RootConstrainSelectedInstOperands,
     /*  200235 */     // GIR_Coverage, 1016,
     /*  200235 */     GIR_Done,
     /*  200236 */   // Label 3977: @200236
     /*  200236 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(200277), // Rule ID 1018 //
     /*  200241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200244 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200251 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200258 */     // MIs[0] rs1
     /*  200258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200270 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  200275 */     GIR_RootConstrainSelectedInstOperands,
     /*  200276 */     // GIR_Coverage, 1018,
     /*  200276 */     GIR_Done,
     /*  200277 */   // Label 3978: @200277
     /*  200277 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(200318), // Rule ID 1020 //
     /*  200282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200285 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200292 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200299 */     // MIs[0] rs1
     /*  200299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200311 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200316 */     GIR_RootConstrainSelectedInstOperands,
     /*  200317 */     // GIR_Coverage, 1020,
     /*  200317 */     GIR_Done,
     /*  200318 */   // Label 3979: @200318
     /*  200318 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(200359), // Rule ID 1022 //
     /*  200323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200326 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200333 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200340 */     // MIs[0] rs1
     /*  200340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200352 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200357 */     GIR_RootConstrainSelectedInstOperands,
     /*  200358 */     // GIR_Coverage, 1022,
     /*  200358 */     GIR_Done,
     /*  200359 */   // Label 3980: @200359
     /*  200359 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(200400), // Rule ID 1024 //
     /*  200364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200367 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200374 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200381 */     // MIs[0] rs1
     /*  200381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200393 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200398 */     GIR_RootConstrainSelectedInstOperands,
     /*  200399 */     // GIR_Coverage, 1024,
     /*  200399 */     GIR_Done,
     /*  200400 */   // Label 3981: @200400
     /*  200400 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(200441), // Rule ID 1026 //
     /*  200405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200408 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200415 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200422 */     // MIs[0] rs1
     /*  200422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200434 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200439 */     GIR_RootConstrainSelectedInstOperands,
     /*  200440 */     // GIR_Coverage, 1026,
     /*  200440 */     GIR_Done,
     /*  200441 */   // Label 3982: @200441
     /*  200441 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(200482), // Rule ID 1028 //
     /*  200446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200463 */     // MIs[0] rs1
     /*  200463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200475 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200480 */     GIR_RootConstrainSelectedInstOperands,
     /*  200481 */     // GIR_Coverage, 1028,
     /*  200481 */     GIR_Done,
     /*  200482 */   // Label 3983: @200482
     /*  200482 */   GIM_Reject,
     /*  200483 */ // Label 3953: @200483
     /*  200483 */ GIM_Reject,
     /*  200484 */ // Label 3951: @200484
     /*  200484 */ GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(202133),
     /*  200489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  200492 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(200533), // Rule ID 481 //
     /*  200497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200514 */     // MIs[0] rs1
     /*  200514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200526 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200531 */     GIR_RootConstrainSelectedInstOperands,
     /*  200532 */     // GIR_Coverage, 481,
     /*  200532 */     GIR_Done,
     /*  200533 */   // Label 3985: @200533
     /*  200533 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(200574), // Rule ID 483 //
     /*  200538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200541 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200548 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200555 */     // MIs[0] rs1
     /*  200555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200567 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  200572 */     GIR_RootConstrainSelectedInstOperands,
     /*  200573 */     // GIR_Coverage, 483,
     /*  200573 */     GIR_Done,
     /*  200574 */   // Label 3986: @200574
     /*  200574 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(200615), // Rule ID 485 //
     /*  200579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200596 */     // MIs[0] rs1
     /*  200596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200608 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  200613 */     GIR_RootConstrainSelectedInstOperands,
     /*  200614 */     // GIR_Coverage, 485,
     /*  200614 */     GIR_Done,
     /*  200615 */   // Label 3987: @200615
     /*  200615 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(200656), // Rule ID 487 //
     /*  200620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200623 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200630 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200637 */     // MIs[0] rs1
     /*  200637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200649 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  200654 */     GIR_RootConstrainSelectedInstOperands,
     /*  200655 */     // GIR_Coverage, 487,
     /*  200655 */     GIR_Done,
     /*  200656 */   // Label 3988: @200656
     /*  200656 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(200697), // Rule ID 489 //
     /*  200661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200664 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200671 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200678 */     // MIs[0] rs1
     /*  200678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200690 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  200695 */     GIR_RootConstrainSelectedInstOperands,
     /*  200696 */     // GIR_Coverage, 489,
     /*  200696 */     GIR_Done,
     /*  200697 */   // Label 3989: @200697
     /*  200697 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(200738), // Rule ID 491 //
     /*  200702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200719 */     // MIs[0] rs1
     /*  200719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200731 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200736 */     GIR_RootConstrainSelectedInstOperands,
     /*  200737 */     // GIR_Coverage, 491,
     /*  200737 */     GIR_Done,
     /*  200738 */   // Label 3990: @200738
     /*  200738 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(200779), // Rule ID 493 //
     /*  200743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200753 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200760 */     // MIs[0] rs1
     /*  200760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200772 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200777 */     GIR_RootConstrainSelectedInstOperands,
     /*  200778 */     // GIR_Coverage, 493,
     /*  200778 */     GIR_Done,
     /*  200779 */   // Label 3991: @200779
     /*  200779 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(200820), // Rule ID 495 //
     /*  200784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200787 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200801 */     // MIs[0] rs1
     /*  200801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200813 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200818 */     GIR_RootConstrainSelectedInstOperands,
     /*  200819 */     // GIR_Coverage, 495,
     /*  200819 */     GIR_Done,
     /*  200820 */   // Label 3992: @200820
     /*  200820 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(200861), // Rule ID 497 //
     /*  200825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200842 */     // MIs[0] rs1
     /*  200842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200854 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200859 */     GIR_RootConstrainSelectedInstOperands,
     /*  200860 */     // GIR_Coverage, 497,
     /*  200860 */     GIR_Done,
     /*  200861 */   // Label 3993: @200861
     /*  200861 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(200902), // Rule ID 499 //
     /*  200866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200869 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200876 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200883 */     // MIs[0] rs1
     /*  200883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200895 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200900 */     GIR_RootConstrainSelectedInstOperands,
     /*  200901 */     // GIR_Coverage, 499,
     /*  200901 */     GIR_Done,
     /*  200902 */   // Label 3994: @200902
     /*  200902 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(200943), // Rule ID 601 //
     /*  200907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200924 */     // MIs[0] rs1
     /*  200924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200936 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200941 */     GIR_RootConstrainSelectedInstOperands,
     /*  200942 */     // GIR_Coverage, 601,
     /*  200942 */     GIR_Done,
     /*  200943 */   // Label 3995: @200943
     /*  200943 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(200984), // Rule ID 602 //
     /*  200948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200951 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200958 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200965 */     // MIs[0] rs1
     /*  200965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200977 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ),
     /*  200982 */     GIR_RootConstrainSelectedInstOperands,
     /*  200983 */     // GIR_Coverage, 602,
     /*  200983 */     GIR_Done,
     /*  200984 */   // Label 3996: @200984
     /*  200984 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(201025), // Rule ID 603 //
     /*  200989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200992 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201006 */     // MIs[0] rs1
     /*  201006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201018 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_RL),
     /*  201023 */     GIR_RootConstrainSelectedInstOperands,
     /*  201024 */     // GIR_Coverage, 603,
     /*  201024 */     GIR_Done,
     /*  201025 */   // Label 3997: @201025
     /*  201025 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(201066), // Rule ID 604 //
     /*  201030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201047 */     // MIs[0] rs1
     /*  201047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201059 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  201064 */     GIR_RootConstrainSelectedInstOperands,
     /*  201065 */     // GIR_Coverage, 604,
     /*  201065 */     GIR_Done,
     /*  201066 */   // Label 3998: @201066
     /*  201066 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(201107), // Rule ID 605 //
     /*  201071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201074 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201081 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201088 */     // MIs[0] rs1
     /*  201088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201100 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  201105 */     GIR_RootConstrainSelectedInstOperands,
     /*  201106 */     // GIR_Coverage, 605,
     /*  201106 */     GIR_Done,
     /*  201107 */   // Label 3999: @201107
     /*  201107 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(201148), // Rule ID 606 //
     /*  201112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201115 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201122 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201129 */     // MIs[0] rs1
     /*  201129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201141 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  201146 */     GIR_RootConstrainSelectedInstOperands,
     /*  201147 */     // GIR_Coverage, 606,
     /*  201147 */     GIR_Done,
     /*  201148 */   // Label 4000: @201148
     /*  201148 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(201189), // Rule ID 607 //
     /*  201153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201170 */     // MIs[0] rs1
     /*  201170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201182 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  201187 */     GIR_RootConstrainSelectedInstOperands,
     /*  201188 */     // GIR_Coverage, 607,
     /*  201188 */     GIR_Done,
     /*  201189 */   // Label 4001: @201189
     /*  201189 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(201230), // Rule ID 608 //
     /*  201194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201211 */     // MIs[0] rs1
     /*  201211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201223 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  201228 */     GIR_RootConstrainSelectedInstOperands,
     /*  201229 */     // GIR_Coverage, 608,
     /*  201229 */     GIR_Done,
     /*  201230 */   // Label 4002: @201230
     /*  201230 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(201271), // Rule ID 609 //
     /*  201235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201252 */     // MIs[0] rs1
     /*  201252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201264 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  201269 */     GIR_RootConstrainSelectedInstOperands,
     /*  201270 */     // GIR_Coverage, 609,
     /*  201270 */     GIR_Done,
     /*  201271 */   // Label 4003: @201271
     /*  201271 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(201312), // Rule ID 610 //
     /*  201276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201279 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201293 */     // MIs[0] rs1
     /*  201293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201305 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  201310 */     GIR_RootConstrainSelectedInstOperands,
     /*  201311 */     // GIR_Coverage, 610,
     /*  201311 */     GIR_Done,
     /*  201312 */   // Label 4004: @201312
     /*  201312 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(201353), // Rule ID 829 //
     /*  201317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201320 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201334 */     // MIs[0] rs1
     /*  201334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201346 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201351 */     GIR_RootConstrainSelectedInstOperands,
     /*  201352 */     // GIR_Coverage, 829,
     /*  201352 */     GIR_Done,
     /*  201353 */   // Label 4005: @201353
     /*  201353 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(201394), // Rule ID 831 //
     /*  201358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201361 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201368 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201375 */     // MIs[0] rs1
     /*  201375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201387 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  201392 */     GIR_RootConstrainSelectedInstOperands,
     /*  201393 */     // GIR_Coverage, 831,
     /*  201393 */     GIR_Done,
     /*  201394 */   // Label 4006: @201394
     /*  201394 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(201435), // Rule ID 833 //
     /*  201399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201402 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201416 */     // MIs[0] rs1
     /*  201416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201428 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  201433 */     GIR_RootConstrainSelectedInstOperands,
     /*  201434 */     // GIR_Coverage, 833,
     /*  201434 */     GIR_Done,
     /*  201435 */   // Label 4007: @201435
     /*  201435 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(201476), // Rule ID 835 //
     /*  201440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201443 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201450 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201457 */     // MIs[0] rs1
     /*  201457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201469 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  201474 */     GIR_RootConstrainSelectedInstOperands,
     /*  201475 */     // GIR_Coverage, 835,
     /*  201475 */     GIR_Done,
     /*  201476 */   // Label 4008: @201476
     /*  201476 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(201517), // Rule ID 837 //
     /*  201481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201484 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201498 */     // MIs[0] rs1
     /*  201498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201510 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  201515 */     GIR_RootConstrainSelectedInstOperands,
     /*  201516 */     // GIR_Coverage, 837,
     /*  201516 */     GIR_Done,
     /*  201517 */   // Label 4009: @201517
     /*  201517 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(201558), // Rule ID 839 //
     /*  201522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201525 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201532 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201539 */     // MIs[0] rs1
     /*  201539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201551 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201556 */     GIR_RootConstrainSelectedInstOperands,
     /*  201557 */     // GIR_Coverage, 839,
     /*  201557 */     GIR_Done,
     /*  201558 */   // Label 4010: @201558
     /*  201558 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(201599), // Rule ID 841 //
     /*  201563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201566 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201580 */     // MIs[0] rs1
     /*  201580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201592 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201597 */     GIR_RootConstrainSelectedInstOperands,
     /*  201598 */     // GIR_Coverage, 841,
     /*  201598 */     GIR_Done,
     /*  201599 */   // Label 4011: @201599
     /*  201599 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(201640), // Rule ID 843 //
     /*  201604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201607 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201614 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201621 */     // MIs[0] rs1
     /*  201621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201633 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201638 */     GIR_RootConstrainSelectedInstOperands,
     /*  201639 */     // GIR_Coverage, 843,
     /*  201639 */     GIR_Done,
     /*  201640 */   // Label 4012: @201640
     /*  201640 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(201681), // Rule ID 845 //
     /*  201645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201648 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201655 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201662 */     // MIs[0] rs1
     /*  201662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201674 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201679 */     GIR_RootConstrainSelectedInstOperands,
     /*  201680 */     // GIR_Coverage, 845,
     /*  201680 */     GIR_Done,
     /*  201681 */   // Label 4013: @201681
     /*  201681 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(201722), // Rule ID 847 //
     /*  201686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201689 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201696 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201703 */     // MIs[0] rs1
     /*  201703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201715 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201720 */     GIR_RootConstrainSelectedInstOperands,
     /*  201721 */     // GIR_Coverage, 847,
     /*  201721 */     GIR_Done,
     /*  201722 */   // Label 4014: @201722
     /*  201722 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(201763), // Rule ID 1009 //
     /*  201727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201730 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201744 */     // MIs[0] rs1
     /*  201744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201756 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201761 */     GIR_RootConstrainSelectedInstOperands,
     /*  201762 */     // GIR_Coverage, 1009,
     /*  201762 */     GIR_Done,
     /*  201763 */   // Label 4015: @201763
     /*  201763 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(201804), // Rule ID 1011 //
     /*  201768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201771 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201778 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201785 */     // MIs[0] rs1
     /*  201785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201797 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  201802 */     GIR_RootConstrainSelectedInstOperands,
     /*  201803 */     // GIR_Coverage, 1011,
     /*  201803 */     GIR_Done,
     /*  201804 */   // Label 4016: @201804
     /*  201804 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(201845), // Rule ID 1013 //
     /*  201809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201812 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201819 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201826 */     // MIs[0] rs1
     /*  201826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201838 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  201843 */     GIR_RootConstrainSelectedInstOperands,
     /*  201844 */     // GIR_Coverage, 1013,
     /*  201844 */     GIR_Done,
     /*  201845 */   // Label 4017: @201845
     /*  201845 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(201886), // Rule ID 1015 //
     /*  201850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201853 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201867 */     // MIs[0] rs1
     /*  201867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201879 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  201884 */     GIR_RootConstrainSelectedInstOperands,
     /*  201885 */     // GIR_Coverage, 1015,
     /*  201885 */     GIR_Done,
     /*  201886 */   // Label 4018: @201886
     /*  201886 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(201927), // Rule ID 1017 //
     /*  201891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201894 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201901 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201908 */     // MIs[0] rs1
     /*  201908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201920 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  201925 */     GIR_RootConstrainSelectedInstOperands,
     /*  201926 */     // GIR_Coverage, 1017,
     /*  201926 */     GIR_Done,
     /*  201927 */   // Label 4019: @201927
     /*  201927 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(201968), // Rule ID 1019 //
     /*  201932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201935 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201942 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201949 */     // MIs[0] rs1
     /*  201949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201961 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201966 */     GIR_RootConstrainSelectedInstOperands,
     /*  201967 */     // GIR_Coverage, 1019,
     /*  201967 */     GIR_Done,
     /*  201968 */   // Label 4020: @201968
     /*  201968 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(202009), // Rule ID 1021 //
     /*  201973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201976 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201990 */     // MIs[0] rs1
     /*  201990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202002 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  202007 */     GIR_RootConstrainSelectedInstOperands,
     /*  202008 */     // GIR_Coverage, 1021,
     /*  202008 */     GIR_Done,
     /*  202009 */   // Label 4021: @202009
     /*  202009 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(202050), // Rule ID 1023 //
     /*  202014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202017 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202024 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202031 */     // MIs[0] rs1
     /*  202031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202043 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  202048 */     GIR_RootConstrainSelectedInstOperands,
     /*  202049 */     // GIR_Coverage, 1023,
     /*  202049 */     GIR_Done,
     /*  202050 */   // Label 4022: @202050
     /*  202050 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(202091), // Rule ID 1025 //
     /*  202055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202058 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202065 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202072 */     // MIs[0] rs1
     /*  202072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202084 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  202089 */     GIR_RootConstrainSelectedInstOperands,
     /*  202090 */     // GIR_Coverage, 1025,
     /*  202090 */     GIR_Done,
     /*  202091 */   // Label 4023: @202091
     /*  202091 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(202132), // Rule ID 1027 //
     /*  202096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202099 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202106 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202113 */     // MIs[0] rs1
     /*  202113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202125 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  202130 */     GIR_RootConstrainSelectedInstOperands,
     /*  202131 */     // GIR_Coverage, 1027,
     /*  202131 */     GIR_Done,
     /*  202132 */   // Label 4024: @202132
     /*  202132 */   GIM_Reject,
     /*  202133 */ // Label 3984: @202133
     /*  202133 */ GIM_Reject,
     /*  202134 */ // Label 3952: @202134
     /*  202134 */ GIM_Reject,
     /*  202135 */ // Label 34: @202135
     /*  202135 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4027*/ GIMT_Encode4(205044),
     /*  202146 */ /*GILLT_s32*//*Label 4025*/ GIMT_Encode4(202154),
     /*  202150 */ /*GILLT_s64*//*Label 4026*/ GIMT_Encode4(203394),
     /*  202154 */ // Label 4025: @202154
     /*  202154 */ GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(203393),
     /*  202159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  202162 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(202203), // Rule ID 502 //
     /*  202167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202170 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202177 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202184 */     // MIs[0] rs1
     /*  202184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202196 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202201 */     GIR_RootConstrainSelectedInstOperands,
     /*  202202 */     // GIR_Coverage, 502,
     /*  202202 */     GIR_Done,
     /*  202203 */   // Label 4029: @202203
     /*  202203 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(202244), // Rule ID 504 //
     /*  202208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202211 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202218 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202225 */     // MIs[0] rs1
     /*  202225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202237 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  202242 */     GIR_RootConstrainSelectedInstOperands,
     /*  202243 */     // GIR_Coverage, 504,
     /*  202243 */     GIR_Done,
     /*  202244 */   // Label 4030: @202244
     /*  202244 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(202285), // Rule ID 506 //
     /*  202249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202252 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202259 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202266 */     // MIs[0] rs1
     /*  202266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202278 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  202283 */     GIR_RootConstrainSelectedInstOperands,
     /*  202284 */     // GIR_Coverage, 506,
     /*  202284 */     GIR_Done,
     /*  202285 */   // Label 4031: @202285
     /*  202285 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202326), // Rule ID 508 //
     /*  202290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202293 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202307 */     // MIs[0] rs1
     /*  202307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202319 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  202324 */     GIR_RootConstrainSelectedInstOperands,
     /*  202325 */     // GIR_Coverage, 508,
     /*  202325 */     GIR_Done,
     /*  202326 */   // Label 4032: @202326
     /*  202326 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202367), // Rule ID 510 //
     /*  202331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202334 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202341 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202348 */     // MIs[0] rs1
     /*  202348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202360 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  202365 */     GIR_RootConstrainSelectedInstOperands,
     /*  202366 */     // GIR_Coverage, 510,
     /*  202366 */     GIR_Done,
     /*  202367 */   // Label 4033: @202367
     /*  202367 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202408), // Rule ID 512 //
     /*  202372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202375 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202382 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202389 */     // MIs[0] rs1
     /*  202389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202401 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202406 */     GIR_RootConstrainSelectedInstOperands,
     /*  202407 */     // GIR_Coverage, 512,
     /*  202407 */     GIR_Done,
     /*  202408 */   // Label 4034: @202408
     /*  202408 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(202449), // Rule ID 514 //
     /*  202413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202416 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202430 */     // MIs[0] rs1
     /*  202430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202442 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202447 */     GIR_RootConstrainSelectedInstOperands,
     /*  202448 */     // GIR_Coverage, 514,
     /*  202448 */     GIR_Done,
     /*  202449 */   // Label 4035: @202449
     /*  202449 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(202490), // Rule ID 516 //
     /*  202454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202457 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202464 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202471 */     // MIs[0] rs1
     /*  202471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202483 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202483 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202488 */     GIR_RootConstrainSelectedInstOperands,
     /*  202489 */     // GIR_Coverage, 516,
     /*  202489 */     GIR_Done,
     /*  202490 */   // Label 4036: @202490
     /*  202490 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(202531), // Rule ID 518 //
     /*  202495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202512 */     // MIs[0] rs1
     /*  202512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202524 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202529 */     GIR_RootConstrainSelectedInstOperands,
     /*  202530 */     // GIR_Coverage, 518,
     /*  202530 */     GIR_Done,
     /*  202531 */   // Label 4037: @202531
     /*  202531 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(202572), // Rule ID 520 //
     /*  202536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202553 */     // MIs[0] rs1
     /*  202553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202565 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202570 */     GIR_RootConstrainSelectedInstOperands,
     /*  202571 */     // GIR_Coverage, 520,
     /*  202571 */     GIR_Done,
     /*  202572 */   // Label 4038: @202572
     /*  202572 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(202613), // Rule ID 850 //
     /*  202577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202580 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202587 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202594 */     // MIs[0] rs1
     /*  202594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202606 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202611 */     GIR_RootConstrainSelectedInstOperands,
     /*  202612 */     // GIR_Coverage, 850,
     /*  202612 */     GIR_Done,
     /*  202613 */   // Label 4039: @202613
     /*  202613 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(202654), // Rule ID 852 //
     /*  202618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202621 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202628 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202635 */     // MIs[0] rs1
     /*  202635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202647 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  202652 */     GIR_RootConstrainSelectedInstOperands,
     /*  202653 */     // GIR_Coverage, 852,
     /*  202653 */     GIR_Done,
     /*  202654 */   // Label 4040: @202654
     /*  202654 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(202695), // Rule ID 854 //
     /*  202659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202662 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202669 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202676 */     // MIs[0] rs1
     /*  202676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202688 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  202693 */     GIR_RootConstrainSelectedInstOperands,
     /*  202694 */     // GIR_Coverage, 854,
     /*  202694 */     GIR_Done,
     /*  202695 */   // Label 4041: @202695
     /*  202695 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(202736), // Rule ID 856 //
     /*  202700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202717 */     // MIs[0] rs1
     /*  202717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202729 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  202734 */     GIR_RootConstrainSelectedInstOperands,
     /*  202735 */     // GIR_Coverage, 856,
     /*  202735 */     GIR_Done,
     /*  202736 */   // Label 4042: @202736
     /*  202736 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(202777), // Rule ID 858 //
     /*  202741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202744 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202758 */     // MIs[0] rs1
     /*  202758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202770 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  202775 */     GIR_RootConstrainSelectedInstOperands,
     /*  202776 */     // GIR_Coverage, 858,
     /*  202776 */     GIR_Done,
     /*  202777 */   // Label 4043: @202777
     /*  202777 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(202818), // Rule ID 860 //
     /*  202782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202785 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202792 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202799 */     // MIs[0] rs1
     /*  202799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202811 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202816 */     GIR_RootConstrainSelectedInstOperands,
     /*  202817 */     // GIR_Coverage, 860,
     /*  202817 */     GIR_Done,
     /*  202818 */   // Label 4044: @202818
     /*  202818 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(202859), // Rule ID 862 //
     /*  202823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202826 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202833 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202840 */     // MIs[0] rs1
     /*  202840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202852 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202857 */     GIR_RootConstrainSelectedInstOperands,
     /*  202858 */     // GIR_Coverage, 862,
     /*  202858 */     GIR_Done,
     /*  202859 */   // Label 4045: @202859
     /*  202859 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(202900), // Rule ID 864 //
     /*  202864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202867 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202874 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202881 */     // MIs[0] rs1
     /*  202881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202893 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202898 */     GIR_RootConstrainSelectedInstOperands,
     /*  202899 */     // GIR_Coverage, 864,
     /*  202899 */     GIR_Done,
     /*  202900 */   // Label 4046: @202900
     /*  202900 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(202941), // Rule ID 866 //
     /*  202905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202922 */     // MIs[0] rs1
     /*  202922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202934 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202939 */     GIR_RootConstrainSelectedInstOperands,
     /*  202940 */     // GIR_Coverage, 866,
     /*  202940 */     GIR_Done,
     /*  202941 */   // Label 4047: @202941
     /*  202941 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(202982), // Rule ID 868 //
     /*  202946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202949 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202956 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202963 */     // MIs[0] rs1
     /*  202963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202975 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202980 */     GIR_RootConstrainSelectedInstOperands,
     /*  202981 */     // GIR_Coverage, 868,
     /*  202981 */     GIR_Done,
     /*  202982 */   // Label 4048: @202982
     /*  202982 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(203023), // Rule ID 1030 //
     /*  202987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202990 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202997 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203004 */     // MIs[0] rs1
     /*  203004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203016 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203021 */     GIR_RootConstrainSelectedInstOperands,
     /*  203022 */     // GIR_Coverage, 1030,
     /*  203022 */     GIR_Done,
     /*  203023 */   // Label 4049: @203023
     /*  203023 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(203064), // Rule ID 1032 //
     /*  203028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203031 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203038 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203045 */     // MIs[0] rs1
     /*  203045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203057 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  203062 */     GIR_RootConstrainSelectedInstOperands,
     /*  203063 */     // GIR_Coverage, 1032,
     /*  203063 */     GIR_Done,
     /*  203064 */   // Label 4050: @203064
     /*  203064 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(203105), // Rule ID 1034 //
     /*  203069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203072 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203086 */     // MIs[0] rs1
     /*  203086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203098 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  203103 */     GIR_RootConstrainSelectedInstOperands,
     /*  203104 */     // GIR_Coverage, 1034,
     /*  203104 */     GIR_Done,
     /*  203105 */   // Label 4051: @203105
     /*  203105 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(203146), // Rule ID 1036 //
     /*  203110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203113 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203120 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203127 */     // MIs[0] rs1
     /*  203127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203139 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  203144 */     GIR_RootConstrainSelectedInstOperands,
     /*  203145 */     // GIR_Coverage, 1036,
     /*  203145 */     GIR_Done,
     /*  203146 */   // Label 4052: @203146
     /*  203146 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(203187), // Rule ID 1038 //
     /*  203151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203154 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203161 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203168 */     // MIs[0] rs1
     /*  203168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203180 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  203185 */     GIR_RootConstrainSelectedInstOperands,
     /*  203186 */     // GIR_Coverage, 1038,
     /*  203186 */     GIR_Done,
     /*  203187 */   // Label 4053: @203187
     /*  203187 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(203228), // Rule ID 1040 //
     /*  203192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203195 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203202 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203209 */     // MIs[0] rs1
     /*  203209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203221 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203226 */     GIR_RootConstrainSelectedInstOperands,
     /*  203227 */     // GIR_Coverage, 1040,
     /*  203227 */     GIR_Done,
     /*  203228 */   // Label 4054: @203228
     /*  203228 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(203269), // Rule ID 1042 //
     /*  203233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203243 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203250 */     // MIs[0] rs1
     /*  203250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203262 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203267 */     GIR_RootConstrainSelectedInstOperands,
     /*  203268 */     // GIR_Coverage, 1042,
     /*  203268 */     GIR_Done,
     /*  203269 */   // Label 4055: @203269
     /*  203269 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(203310), // Rule ID 1044 //
     /*  203274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203277 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203291 */     // MIs[0] rs1
     /*  203291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203303 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203308 */     GIR_RootConstrainSelectedInstOperands,
     /*  203309 */     // GIR_Coverage, 1044,
     /*  203309 */     GIR_Done,
     /*  203310 */   // Label 4056: @203310
     /*  203310 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(203351), // Rule ID 1046 //
     /*  203315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203318 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203325 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203332 */     // MIs[0] rs1
     /*  203332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203344 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203349 */     GIR_RootConstrainSelectedInstOperands,
     /*  203350 */     // GIR_Coverage, 1046,
     /*  203350 */     GIR_Done,
     /*  203351 */   // Label 4057: @203351
     /*  203351 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(203392), // Rule ID 1048 //
     /*  203356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203359 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203366 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203373 */     // MIs[0] rs1
     /*  203373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203385 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203390 */     GIR_RootConstrainSelectedInstOperands,
     /*  203391 */     // GIR_Coverage, 1048,
     /*  203391 */     GIR_Done,
     /*  203392 */   // Label 4058: @203392
     /*  203392 */   GIM_Reject,
     /*  203393 */ // Label 4028: @203393
     /*  203393 */ GIM_Reject,
     /*  203394 */ // Label 4026: @203394
     /*  203394 */ GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(205043),
     /*  203399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  203402 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(203443), // Rule ID 501 //
     /*  203407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203417 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203424 */     // MIs[0] rs1
     /*  203424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203436 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203441 */     GIR_RootConstrainSelectedInstOperands,
     /*  203442 */     // GIR_Coverage, 501,
     /*  203442 */     GIR_Done,
     /*  203443 */   // Label 4060: @203443
     /*  203443 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(203484), // Rule ID 503 //
     /*  203448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203451 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203458 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203465 */     // MIs[0] rs1
     /*  203465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203477 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  203482 */     GIR_RootConstrainSelectedInstOperands,
     /*  203483 */     // GIR_Coverage, 503,
     /*  203483 */     GIR_Done,
     /*  203484 */   // Label 4061: @203484
     /*  203484 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(203525), // Rule ID 505 //
     /*  203489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203506 */     // MIs[0] rs1
     /*  203506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203518 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  203523 */     GIR_RootConstrainSelectedInstOperands,
     /*  203524 */     // GIR_Coverage, 505,
     /*  203524 */     GIR_Done,
     /*  203525 */   // Label 4062: @203525
     /*  203525 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(203566), // Rule ID 507 //
     /*  203530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203533 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203540 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203547 */     // MIs[0] rs1
     /*  203547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203559 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  203564 */     GIR_RootConstrainSelectedInstOperands,
     /*  203565 */     // GIR_Coverage, 507,
     /*  203565 */     GIR_Done,
     /*  203566 */   // Label 4063: @203566
     /*  203566 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(203607), // Rule ID 509 //
     /*  203571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203574 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203581 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203588 */     // MIs[0] rs1
     /*  203588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203600 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  203605 */     GIR_RootConstrainSelectedInstOperands,
     /*  203606 */     // GIR_Coverage, 509,
     /*  203606 */     GIR_Done,
     /*  203607 */   // Label 4064: @203607
     /*  203607 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(203648), // Rule ID 511 //
     /*  203612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203615 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203622 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203629 */     // MIs[0] rs1
     /*  203629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203641 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203646 */     GIR_RootConstrainSelectedInstOperands,
     /*  203647 */     // GIR_Coverage, 511,
     /*  203647 */     GIR_Done,
     /*  203648 */   // Label 4065: @203648
     /*  203648 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(203689), // Rule ID 513 //
     /*  203653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203670 */     // MIs[0] rs1
     /*  203670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203682 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203687 */     GIR_RootConstrainSelectedInstOperands,
     /*  203688 */     // GIR_Coverage, 513,
     /*  203688 */     GIR_Done,
     /*  203689 */   // Label 4066: @203689
     /*  203689 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(203730), // Rule ID 515 //
     /*  203694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203697 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203704 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203711 */     // MIs[0] rs1
     /*  203711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203723 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203728 */     GIR_RootConstrainSelectedInstOperands,
     /*  203729 */     // GIR_Coverage, 515,
     /*  203729 */     GIR_Done,
     /*  203730 */   // Label 4067: @203730
     /*  203730 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(203771), // Rule ID 517 //
     /*  203735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203745 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203752 */     // MIs[0] rs1
     /*  203752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203764 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203769 */     GIR_RootConstrainSelectedInstOperands,
     /*  203770 */     // GIR_Coverage, 517,
     /*  203770 */     GIR_Done,
     /*  203771 */   // Label 4068: @203771
     /*  203771 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(203812), // Rule ID 519 //
     /*  203776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203779 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203793 */     // MIs[0] rs1
     /*  203793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203805 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203810 */     GIR_RootConstrainSelectedInstOperands,
     /*  203811 */     // GIR_Coverage, 519,
     /*  203811 */     GIR_Done,
     /*  203812 */   // Label 4069: @203812
     /*  203812 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(203853), // Rule ID 611 //
     /*  203817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203820 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203834 */     // MIs[0] rs1
     /*  203834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203846 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203851 */     GIR_RootConstrainSelectedInstOperands,
     /*  203852 */     // GIR_Coverage, 611,
     /*  203852 */     GIR_Done,
     /*  203853 */   // Label 4070: @203853
     /*  203853 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(203894), // Rule ID 612 //
     /*  203858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203861 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203875 */     // MIs[0] rs1
     /*  203875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203887 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ),
     /*  203892 */     GIR_RootConstrainSelectedInstOperands,
     /*  203893 */     // GIR_Coverage, 612,
     /*  203893 */     GIR_Done,
     /*  203894 */   // Label 4071: @203894
     /*  203894 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(203935), // Rule ID 613 //
     /*  203899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203902 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203909 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203916 */     // MIs[0] rs1
     /*  203916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203928 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_RL),
     /*  203933 */     GIR_RootConstrainSelectedInstOperands,
     /*  203934 */     // GIR_Coverage, 613,
     /*  203934 */     GIR_Done,
     /*  203935 */   // Label 4072: @203935
     /*  203935 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(203976), // Rule ID 614 //
     /*  203940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203943 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203950 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203957 */     // MIs[0] rs1
     /*  203957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203969 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  203974 */     GIR_RootConstrainSelectedInstOperands,
     /*  203975 */     // GIR_Coverage, 614,
     /*  203975 */     GIR_Done,
     /*  203976 */   // Label 4073: @203976
     /*  203976 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(204017), // Rule ID 615 //
     /*  203981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203984 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203991 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203998 */     // MIs[0] rs1
     /*  203998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204010 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  204015 */     GIR_RootConstrainSelectedInstOperands,
     /*  204016 */     // GIR_Coverage, 615,
     /*  204016 */     GIR_Done,
     /*  204017 */   // Label 4074: @204017
     /*  204017 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(204058), // Rule ID 616 //
     /*  204022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204032 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204039 */     // MIs[0] rs1
     /*  204039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204051 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  204056 */     GIR_RootConstrainSelectedInstOperands,
     /*  204057 */     // GIR_Coverage, 616,
     /*  204057 */     GIR_Done,
     /*  204058 */   // Label 4075: @204058
     /*  204058 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(204099), // Rule ID 617 //
     /*  204063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204080 */     // MIs[0] rs1
     /*  204080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204092 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  204097 */     GIR_RootConstrainSelectedInstOperands,
     /*  204098 */     // GIR_Coverage, 617,
     /*  204098 */     GIR_Done,
     /*  204099 */   // Label 4076: @204099
     /*  204099 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(204140), // Rule ID 618 //
     /*  204104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204107 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204114 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204121 */     // MIs[0] rs1
     /*  204121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204133 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  204138 */     GIR_RootConstrainSelectedInstOperands,
     /*  204139 */     // GIR_Coverage, 618,
     /*  204139 */     GIR_Done,
     /*  204140 */   // Label 4077: @204140
     /*  204140 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(204181), // Rule ID 619 //
     /*  204145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204148 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204155 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204162 */     // MIs[0] rs1
     /*  204162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204174 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  204179 */     GIR_RootConstrainSelectedInstOperands,
     /*  204180 */     // GIR_Coverage, 619,
     /*  204180 */     GIR_Done,
     /*  204181 */   // Label 4078: @204181
     /*  204181 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(204222), // Rule ID 620 //
     /*  204186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204189 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204203 */     // MIs[0] rs1
     /*  204203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204215 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  204220 */     GIR_RootConstrainSelectedInstOperands,
     /*  204221 */     // GIR_Coverage, 620,
     /*  204221 */     GIR_Done,
     /*  204222 */   // Label 4079: @204222
     /*  204222 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(204263), // Rule ID 849 //
     /*  204227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204230 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204237 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204244 */     // MIs[0] rs1
     /*  204244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204256 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204261 */     GIR_RootConstrainSelectedInstOperands,
     /*  204262 */     // GIR_Coverage, 849,
     /*  204262 */     GIR_Done,
     /*  204263 */   // Label 4080: @204263
     /*  204263 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(204304), // Rule ID 851 //
     /*  204268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204271 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204285 */     // MIs[0] rs1
     /*  204285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204297 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204297 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  204302 */     GIR_RootConstrainSelectedInstOperands,
     /*  204303 */     // GIR_Coverage, 851,
     /*  204303 */     GIR_Done,
     /*  204304 */   // Label 4081: @204304
     /*  204304 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(204345), // Rule ID 853 //
     /*  204309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204326 */     // MIs[0] rs1
     /*  204326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204338 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  204343 */     GIR_RootConstrainSelectedInstOperands,
     /*  204344 */     // GIR_Coverage, 853,
     /*  204344 */     GIR_Done,
     /*  204345 */   // Label 4082: @204345
     /*  204345 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(204386), // Rule ID 855 //
     /*  204350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204353 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204360 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204367 */     // MIs[0] rs1
     /*  204367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204379 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  204384 */     GIR_RootConstrainSelectedInstOperands,
     /*  204385 */     // GIR_Coverage, 855,
     /*  204385 */     GIR_Done,
     /*  204386 */   // Label 4083: @204386
     /*  204386 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(204427), // Rule ID 857 //
     /*  204391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204394 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204401 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204408 */     // MIs[0] rs1
     /*  204408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204420 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  204425 */     GIR_RootConstrainSelectedInstOperands,
     /*  204426 */     // GIR_Coverage, 857,
     /*  204426 */     GIR_Done,
     /*  204427 */   // Label 4084: @204427
     /*  204427 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(204468), // Rule ID 859 //
     /*  204432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204442 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204449 */     // MIs[0] rs1
     /*  204449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204461 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204466 */     GIR_RootConstrainSelectedInstOperands,
     /*  204467 */     // GIR_Coverage, 859,
     /*  204467 */     GIR_Done,
     /*  204468 */   // Label 4085: @204468
     /*  204468 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(204509), // Rule ID 861 //
     /*  204473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204483 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204490 */     // MIs[0] rs1
     /*  204490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204502 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204507 */     GIR_RootConstrainSelectedInstOperands,
     /*  204508 */     // GIR_Coverage, 861,
     /*  204508 */     GIR_Done,
     /*  204509 */   // Label 4086: @204509
     /*  204509 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(204550), // Rule ID 863 //
     /*  204514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204517 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204524 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204531 */     // MIs[0] rs1
     /*  204531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204543 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204548 */     GIR_RootConstrainSelectedInstOperands,
     /*  204549 */     // GIR_Coverage, 863,
     /*  204549 */     GIR_Done,
     /*  204550 */   // Label 4087: @204550
     /*  204550 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(204591), // Rule ID 865 //
     /*  204555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204558 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204565 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204572 */     // MIs[0] rs1
     /*  204572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204584 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204584 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204589 */     GIR_RootConstrainSelectedInstOperands,
     /*  204590 */     // GIR_Coverage, 865,
     /*  204590 */     GIR_Done,
     /*  204591 */   // Label 4088: @204591
     /*  204591 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(204632), // Rule ID 867 //
     /*  204596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204599 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204606 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204613 */     // MIs[0] rs1
     /*  204613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204625 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204630 */     GIR_RootConstrainSelectedInstOperands,
     /*  204631 */     // GIR_Coverage, 867,
     /*  204631 */     GIR_Done,
     /*  204632 */   // Label 4089: @204632
     /*  204632 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(204673), // Rule ID 1029 //
     /*  204637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204640 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204647 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204654 */     // MIs[0] rs1
     /*  204654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204666 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204671 */     GIR_RootConstrainSelectedInstOperands,
     /*  204672 */     // GIR_Coverage, 1029,
     /*  204672 */     GIR_Done,
     /*  204673 */   // Label 4090: @204673
     /*  204673 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(204714), // Rule ID 1031 //
     /*  204678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204681 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204688 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204695 */     // MIs[0] rs1
     /*  204695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204707 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  204712 */     GIR_RootConstrainSelectedInstOperands,
     /*  204713 */     // GIR_Coverage, 1031,
     /*  204713 */     GIR_Done,
     /*  204714 */   // Label 4091: @204714
     /*  204714 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(204755), // Rule ID 1033 //
     /*  204719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204722 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204729 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204736 */     // MIs[0] rs1
     /*  204736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204748 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  204753 */     GIR_RootConstrainSelectedInstOperands,
     /*  204754 */     // GIR_Coverage, 1033,
     /*  204754 */     GIR_Done,
     /*  204755 */   // Label 4092: @204755
     /*  204755 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(204796), // Rule ID 1035 //
     /*  204760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204763 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204770 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204777 */     // MIs[0] rs1
     /*  204777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204789 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  204794 */     GIR_RootConstrainSelectedInstOperands,
     /*  204795 */     // GIR_Coverage, 1035,
     /*  204795 */     GIR_Done,
     /*  204796 */   // Label 4093: @204796
     /*  204796 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(204837), // Rule ID 1037 //
     /*  204801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204804 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204811 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204818 */     // MIs[0] rs1
     /*  204818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204830 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  204835 */     GIR_RootConstrainSelectedInstOperands,
     /*  204836 */     // GIR_Coverage, 1037,
     /*  204836 */     GIR_Done,
     /*  204837 */   // Label 4094: @204837
     /*  204837 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(204878), // Rule ID 1039 //
     /*  204842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204845 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204852 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204859 */     // MIs[0] rs1
     /*  204859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204871 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204876 */     GIR_RootConstrainSelectedInstOperands,
     /*  204877 */     // GIR_Coverage, 1039,
     /*  204877 */     GIR_Done,
     /*  204878 */   // Label 4095: @204878
     /*  204878 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(204919), // Rule ID 1041 //
     /*  204883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204886 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204893 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204900 */     // MIs[0] rs1
     /*  204900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204912 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204917 */     GIR_RootConstrainSelectedInstOperands,
     /*  204918 */     // GIR_Coverage, 1041,
     /*  204918 */     GIR_Done,
     /*  204919 */   // Label 4096: @204919
     /*  204919 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(204960), // Rule ID 1043 //
     /*  204924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204927 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204934 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204941 */     // MIs[0] rs1
     /*  204941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204953 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204958 */     GIR_RootConstrainSelectedInstOperands,
     /*  204959 */     // GIR_Coverage, 1043,
     /*  204959 */     GIR_Done,
     /*  204960 */   // Label 4097: @204960
     /*  204960 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(205001), // Rule ID 1045 //
     /*  204965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204968 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204975 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204982 */     // MIs[0] rs1
     /*  204982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204994 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204999 */     GIR_RootConstrainSelectedInstOperands,
     /*  205000 */     // GIR_Coverage, 1045,
     /*  205000 */     GIR_Done,
     /*  205001 */   // Label 4098: @205001
     /*  205001 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(205042), // Rule ID 1047 //
     /*  205006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205009 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205016 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205023 */     // MIs[0] rs1
     /*  205023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205035 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  205040 */     GIR_RootConstrainSelectedInstOperands,
     /*  205041 */     // GIR_Coverage, 1047,
     /*  205041 */     GIR_Done,
     /*  205042 */   // Label 4099: @205042
     /*  205042 */   GIM_Reject,
     /*  205043 */ // Label 4059: @205043
     /*  205043 */ GIM_Reject,
     /*  205044 */ // Label 4027: @205044
     /*  205044 */ GIM_Reject,
     /*  205045 */ // Label 35: @205045
     /*  205045 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4102*/ GIMT_Encode4(207954),
     /*  205056 */ /*GILLT_s32*//*Label 4100*/ GIMT_Encode4(205064),
     /*  205060 */ /*GILLT_s64*//*Label 4101*/ GIMT_Encode4(206304),
     /*  205064 */ // Label 4100: @205064
     /*  205064 */ GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(206303),
     /*  205069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  205072 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(205113), // Rule ID 522 //
     /*  205077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205080 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205087 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205094 */     // MIs[0] rs1
     /*  205094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205106 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205111 */     GIR_RootConstrainSelectedInstOperands,
     /*  205112 */     // GIR_Coverage, 522,
     /*  205112 */     GIR_Done,
     /*  205113 */   // Label 4104: @205113
     /*  205113 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(205154), // Rule ID 524 //
     /*  205118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205121 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205128 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205135 */     // MIs[0] rs1
     /*  205135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205147 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  205152 */     GIR_RootConstrainSelectedInstOperands,
     /*  205153 */     // GIR_Coverage, 524,
     /*  205153 */     GIR_Done,
     /*  205154 */   // Label 4105: @205154
     /*  205154 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(205195), // Rule ID 526 //
     /*  205159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205162 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205169 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205176 */     // MIs[0] rs1
     /*  205176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205188 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  205193 */     GIR_RootConstrainSelectedInstOperands,
     /*  205194 */     // GIR_Coverage, 526,
     /*  205194 */     GIR_Done,
     /*  205195 */   // Label 4106: @205195
     /*  205195 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(205236), // Rule ID 528 //
     /*  205200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205203 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205217 */     // MIs[0] rs1
     /*  205217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205229 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  205234 */     GIR_RootConstrainSelectedInstOperands,
     /*  205235 */     // GIR_Coverage, 528,
     /*  205235 */     GIR_Done,
     /*  205236 */   // Label 4107: @205236
     /*  205236 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(205277), // Rule ID 530 //
     /*  205241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205244 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205251 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205258 */     // MIs[0] rs1
     /*  205258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205270 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  205275 */     GIR_RootConstrainSelectedInstOperands,
     /*  205276 */     // GIR_Coverage, 530,
     /*  205276 */     GIR_Done,
     /*  205277 */   // Label 4108: @205277
     /*  205277 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(205318), // Rule ID 532 //
     /*  205282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205285 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205292 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205299 */     // MIs[0] rs1
     /*  205299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205311 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205316 */     GIR_RootConstrainSelectedInstOperands,
     /*  205317 */     // GIR_Coverage, 532,
     /*  205317 */     GIR_Done,
     /*  205318 */   // Label 4109: @205318
     /*  205318 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(205359), // Rule ID 534 //
     /*  205323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205326 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205333 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205340 */     // MIs[0] rs1
     /*  205340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205352 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205357 */     GIR_RootConstrainSelectedInstOperands,
     /*  205358 */     // GIR_Coverage, 534,
     /*  205358 */     GIR_Done,
     /*  205359 */   // Label 4110: @205359
     /*  205359 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(205400), // Rule ID 536 //
     /*  205364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205367 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205374 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205381 */     // MIs[0] rs1
     /*  205381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205393 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205398 */     GIR_RootConstrainSelectedInstOperands,
     /*  205399 */     // GIR_Coverage, 536,
     /*  205399 */     GIR_Done,
     /*  205400 */   // Label 4111: @205400
     /*  205400 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(205441), // Rule ID 538 //
     /*  205405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205408 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205415 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205422 */     // MIs[0] rs1
     /*  205422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205434 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205439 */     GIR_RootConstrainSelectedInstOperands,
     /*  205440 */     // GIR_Coverage, 538,
     /*  205440 */     GIR_Done,
     /*  205441 */   // Label 4112: @205441
     /*  205441 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(205482), // Rule ID 540 //
     /*  205446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205463 */     // MIs[0] rs1
     /*  205463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205475 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205480 */     GIR_RootConstrainSelectedInstOperands,
     /*  205481 */     // GIR_Coverage, 540,
     /*  205481 */     GIR_Done,
     /*  205482 */   // Label 4113: @205482
     /*  205482 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(205523), // Rule ID 870 //
     /*  205487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205504 */     // MIs[0] rs1
     /*  205504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205516 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205521 */     GIR_RootConstrainSelectedInstOperands,
     /*  205522 */     // GIR_Coverage, 870,
     /*  205522 */     GIR_Done,
     /*  205523 */   // Label 4114: @205523
     /*  205523 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(205564), // Rule ID 872 //
     /*  205528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205531 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205545 */     // MIs[0] rs1
     /*  205545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205557 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  205562 */     GIR_RootConstrainSelectedInstOperands,
     /*  205563 */     // GIR_Coverage, 872,
     /*  205563 */     GIR_Done,
     /*  205564 */   // Label 4115: @205564
     /*  205564 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(205605), // Rule ID 874 //
     /*  205569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205572 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205579 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205586 */     // MIs[0] rs1
     /*  205586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205598 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  205603 */     GIR_RootConstrainSelectedInstOperands,
     /*  205604 */     // GIR_Coverage, 874,
     /*  205604 */     GIR_Done,
     /*  205605 */   // Label 4116: @205605
     /*  205605 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(205646), // Rule ID 876 //
     /*  205610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205613 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205620 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205627 */     // MIs[0] rs1
     /*  205627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205639 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205639 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  205644 */     GIR_RootConstrainSelectedInstOperands,
     /*  205645 */     // GIR_Coverage, 876,
     /*  205645 */     GIR_Done,
     /*  205646 */   // Label 4117: @205646
     /*  205646 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(205687), // Rule ID 878 //
     /*  205651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205668 */     // MIs[0] rs1
     /*  205668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205680 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  205685 */     GIR_RootConstrainSelectedInstOperands,
     /*  205686 */     // GIR_Coverage, 878,
     /*  205686 */     GIR_Done,
     /*  205687 */   // Label 4118: @205687
     /*  205687 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(205728), // Rule ID 880 //
     /*  205692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205709 */     // MIs[0] rs1
     /*  205709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205721 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205726 */     GIR_RootConstrainSelectedInstOperands,
     /*  205727 */     // GIR_Coverage, 880,
     /*  205727 */     GIR_Done,
     /*  205728 */   // Label 4119: @205728
     /*  205728 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(205769), // Rule ID 882 //
     /*  205733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205750 */     // MIs[0] rs1
     /*  205750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205762 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205767 */     GIR_RootConstrainSelectedInstOperands,
     /*  205768 */     // GIR_Coverage, 882,
     /*  205768 */     GIR_Done,
     /*  205769 */   // Label 4120: @205769
     /*  205769 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(205810), // Rule ID 884 //
     /*  205774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205777 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205791 */     // MIs[0] rs1
     /*  205791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205803 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205808 */     GIR_RootConstrainSelectedInstOperands,
     /*  205809 */     // GIR_Coverage, 884,
     /*  205809 */     GIR_Done,
     /*  205810 */   // Label 4121: @205810
     /*  205810 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(205851), // Rule ID 886 //
     /*  205815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205818 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205825 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205832 */     // MIs[0] rs1
     /*  205832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205844 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205849 */     GIR_RootConstrainSelectedInstOperands,
     /*  205850 */     // GIR_Coverage, 886,
     /*  205850 */     GIR_Done,
     /*  205851 */   // Label 4122: @205851
     /*  205851 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(205892), // Rule ID 888 //
     /*  205856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205866 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205873 */     // MIs[0] rs1
     /*  205873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205885 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205890 */     GIR_RootConstrainSelectedInstOperands,
     /*  205891 */     // GIR_Coverage, 888,
     /*  205891 */     GIR_Done,
     /*  205892 */   // Label 4123: @205892
     /*  205892 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(205933), // Rule ID 1050 //
     /*  205897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205900 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205907 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205914 */     // MIs[0] rs1
     /*  205914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205926 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205931 */     GIR_RootConstrainSelectedInstOperands,
     /*  205932 */     // GIR_Coverage, 1050,
     /*  205932 */     GIR_Done,
     /*  205933 */   // Label 4124: @205933
     /*  205933 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(205974), // Rule ID 1052 //
     /*  205938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205941 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205948 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205955 */     // MIs[0] rs1
     /*  205955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205967 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  205972 */     GIR_RootConstrainSelectedInstOperands,
     /*  205973 */     // GIR_Coverage, 1052,
     /*  205973 */     GIR_Done,
     /*  205974 */   // Label 4125: @205974
     /*  205974 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(206015), // Rule ID 1054 //
     /*  205979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205982 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205989 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205996 */     // MIs[0] rs1
     /*  205996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206008 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  206013 */     GIR_RootConstrainSelectedInstOperands,
     /*  206014 */     // GIR_Coverage, 1054,
     /*  206014 */     GIR_Done,
     /*  206015 */   // Label 4126: @206015
     /*  206015 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(206056), // Rule ID 1056 //
     /*  206020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206023 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206030 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206037 */     // MIs[0] rs1
     /*  206037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206049 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  206054 */     GIR_RootConstrainSelectedInstOperands,
     /*  206055 */     // GIR_Coverage, 1056,
     /*  206055 */     GIR_Done,
     /*  206056 */   // Label 4127: @206056
     /*  206056 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(206097), // Rule ID 1058 //
     /*  206061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206078 */     // MIs[0] rs1
     /*  206078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206090 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  206095 */     GIR_RootConstrainSelectedInstOperands,
     /*  206096 */     // GIR_Coverage, 1058,
     /*  206096 */     GIR_Done,
     /*  206097 */   // Label 4128: @206097
     /*  206097 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(206138), // Rule ID 1060 //
     /*  206102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206105 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206112 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206119 */     // MIs[0] rs1
     /*  206119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206131 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206136 */     GIR_RootConstrainSelectedInstOperands,
     /*  206137 */     // GIR_Coverage, 1060,
     /*  206137 */     GIR_Done,
     /*  206138 */   // Label 4129: @206138
     /*  206138 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(206179), // Rule ID 1062 //
     /*  206143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206146 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206153 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206160 */     // MIs[0] rs1
     /*  206160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206172 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206177 */     GIR_RootConstrainSelectedInstOperands,
     /*  206178 */     // GIR_Coverage, 1062,
     /*  206178 */     GIR_Done,
     /*  206179 */   // Label 4130: @206179
     /*  206179 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(206220), // Rule ID 1064 //
     /*  206184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206187 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206201 */     // MIs[0] rs1
     /*  206201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206213 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206218 */     GIR_RootConstrainSelectedInstOperands,
     /*  206219 */     // GIR_Coverage, 1064,
     /*  206219 */     GIR_Done,
     /*  206220 */   // Label 4131: @206220
     /*  206220 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(206261), // Rule ID 1066 //
     /*  206225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206228 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206235 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206242 */     // MIs[0] rs1
     /*  206242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206254 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206259 */     GIR_RootConstrainSelectedInstOperands,
     /*  206260 */     // GIR_Coverage, 1066,
     /*  206260 */     GIR_Done,
     /*  206261 */   // Label 4132: @206261
     /*  206261 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(206302), // Rule ID 1068 //
     /*  206266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206269 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206276 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206283 */     // MIs[0] rs1
     /*  206283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206295 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206300 */     GIR_RootConstrainSelectedInstOperands,
     /*  206301 */     // GIR_Coverage, 1068,
     /*  206301 */     GIR_Done,
     /*  206302 */   // Label 4133: @206302
     /*  206302 */   GIM_Reject,
     /*  206303 */ // Label 4103: @206303
     /*  206303 */ GIM_Reject,
     /*  206304 */ // Label 4101: @206304
     /*  206304 */ GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(207953),
     /*  206309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  206312 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(206353), // Rule ID 521 //
     /*  206317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206320 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206334 */     // MIs[0] rs1
     /*  206334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206346 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206351 */     GIR_RootConstrainSelectedInstOperands,
     /*  206352 */     // GIR_Coverage, 521,
     /*  206352 */     GIR_Done,
     /*  206353 */   // Label 4135: @206353
     /*  206353 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(206394), // Rule ID 523 //
     /*  206358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206361 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206368 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206375 */     // MIs[0] rs1
     /*  206375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206387 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  206392 */     GIR_RootConstrainSelectedInstOperands,
     /*  206393 */     // GIR_Coverage, 523,
     /*  206393 */     GIR_Done,
     /*  206394 */   // Label 4136: @206394
     /*  206394 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(206435), // Rule ID 525 //
     /*  206399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206402 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206416 */     // MIs[0] rs1
     /*  206416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206428 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  206433 */     GIR_RootConstrainSelectedInstOperands,
     /*  206434 */     // GIR_Coverage, 525,
     /*  206434 */     GIR_Done,
     /*  206435 */   // Label 4137: @206435
     /*  206435 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(206476), // Rule ID 527 //
     /*  206440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206443 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206450 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206457 */     // MIs[0] rs1
     /*  206457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206469 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  206474 */     GIR_RootConstrainSelectedInstOperands,
     /*  206475 */     // GIR_Coverage, 527,
     /*  206475 */     GIR_Done,
     /*  206476 */   // Label 4138: @206476
     /*  206476 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(206517), // Rule ID 529 //
     /*  206481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206484 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206498 */     // MIs[0] rs1
     /*  206498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206510 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  206515 */     GIR_RootConstrainSelectedInstOperands,
     /*  206516 */     // GIR_Coverage, 529,
     /*  206516 */     GIR_Done,
     /*  206517 */   // Label 4139: @206517
     /*  206517 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(206558), // Rule ID 531 //
     /*  206522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206525 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206532 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206539 */     // MIs[0] rs1
     /*  206539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206551 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206556 */     GIR_RootConstrainSelectedInstOperands,
     /*  206557 */     // GIR_Coverage, 531,
     /*  206557 */     GIR_Done,
     /*  206558 */   // Label 4140: @206558
     /*  206558 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(206599), // Rule ID 533 //
     /*  206563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206566 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206580 */     // MIs[0] rs1
     /*  206580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206592 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206597 */     GIR_RootConstrainSelectedInstOperands,
     /*  206598 */     // GIR_Coverage, 533,
     /*  206598 */     GIR_Done,
     /*  206599 */   // Label 4141: @206599
     /*  206599 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(206640), // Rule ID 535 //
     /*  206604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206607 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206614 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206621 */     // MIs[0] rs1
     /*  206621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206633 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206638 */     GIR_RootConstrainSelectedInstOperands,
     /*  206639 */     // GIR_Coverage, 535,
     /*  206639 */     GIR_Done,
     /*  206640 */   // Label 4142: @206640
     /*  206640 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(206681), // Rule ID 537 //
     /*  206645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206648 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206655 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206662 */     // MIs[0] rs1
     /*  206662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206674 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206679 */     GIR_RootConstrainSelectedInstOperands,
     /*  206680 */     // GIR_Coverage, 537,
     /*  206680 */     GIR_Done,
     /*  206681 */   // Label 4143: @206681
     /*  206681 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(206722), // Rule ID 539 //
     /*  206686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206689 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206696 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206703 */     // MIs[0] rs1
     /*  206703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206715 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206720 */     GIR_RootConstrainSelectedInstOperands,
     /*  206721 */     // GIR_Coverage, 539,
     /*  206721 */     GIR_Done,
     /*  206722 */   // Label 4144: @206722
     /*  206722 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(206763), // Rule ID 621 //
     /*  206727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206730 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206744 */     // MIs[0] rs1
     /*  206744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206756 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206761 */     GIR_RootConstrainSelectedInstOperands,
     /*  206762 */     // GIR_Coverage, 621,
     /*  206762 */     GIR_Done,
     /*  206763 */   // Label 4145: @206763
     /*  206763 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(206804), // Rule ID 622 //
     /*  206768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206771 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206778 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206785 */     // MIs[0] rs1
     /*  206785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206797 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ),
     /*  206802 */     GIR_RootConstrainSelectedInstOperands,
     /*  206803 */     // GIR_Coverage, 622,
     /*  206803 */     GIR_Done,
     /*  206804 */   // Label 4146: @206804
     /*  206804 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(206845), // Rule ID 623 //
     /*  206809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206812 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206819 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206826 */     // MIs[0] rs1
     /*  206826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206838 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_RL),
     /*  206843 */     GIR_RootConstrainSelectedInstOperands,
     /*  206844 */     // GIR_Coverage, 623,
     /*  206844 */     GIR_Done,
     /*  206845 */   // Label 4147: @206845
     /*  206845 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(206886), // Rule ID 624 //
     /*  206850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206853 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206867 */     // MIs[0] rs1
     /*  206867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206879 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  206884 */     GIR_RootConstrainSelectedInstOperands,
     /*  206885 */     // GIR_Coverage, 624,
     /*  206885 */     GIR_Done,
     /*  206886 */   // Label 4148: @206886
     /*  206886 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(206927), // Rule ID 625 //
     /*  206891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206894 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206901 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206908 */     // MIs[0] rs1
     /*  206908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206920 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  206925 */     GIR_RootConstrainSelectedInstOperands,
     /*  206926 */     // GIR_Coverage, 625,
     /*  206926 */     GIR_Done,
     /*  206927 */   // Label 4149: @206927
     /*  206927 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(206968), // Rule ID 626 //
     /*  206932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206935 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206942 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206949 */     // MIs[0] rs1
     /*  206949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206961 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206966 */     GIR_RootConstrainSelectedInstOperands,
     /*  206967 */     // GIR_Coverage, 626,
     /*  206967 */     GIR_Done,
     /*  206968 */   // Label 4150: @206968
     /*  206968 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(207009), // Rule ID 627 //
     /*  206973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206976 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206990 */     // MIs[0] rs1
     /*  206990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207002 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  207007 */     GIR_RootConstrainSelectedInstOperands,
     /*  207008 */     // GIR_Coverage, 627,
     /*  207008 */     GIR_Done,
     /*  207009 */   // Label 4151: @207009
     /*  207009 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(207050), // Rule ID 628 //
     /*  207014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207017 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207024 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207031 */     // MIs[0] rs1
     /*  207031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207043 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  207048 */     GIR_RootConstrainSelectedInstOperands,
     /*  207049 */     // GIR_Coverage, 628,
     /*  207049 */     GIR_Done,
     /*  207050 */   // Label 4152: @207050
     /*  207050 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(207091), // Rule ID 629 //
     /*  207055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207058 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207065 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207072 */     // MIs[0] rs1
     /*  207072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207084 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  207089 */     GIR_RootConstrainSelectedInstOperands,
     /*  207090 */     // GIR_Coverage, 629,
     /*  207090 */     GIR_Done,
     /*  207091 */   // Label 4153: @207091
     /*  207091 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(207132), // Rule ID 630 //
     /*  207096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207099 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207106 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207113 */     // MIs[0] rs1
     /*  207113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207125 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  207130 */     GIR_RootConstrainSelectedInstOperands,
     /*  207131 */     // GIR_Coverage, 630,
     /*  207131 */     GIR_Done,
     /*  207132 */   // Label 4154: @207132
     /*  207132 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(207173), // Rule ID 869 //
     /*  207137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207140 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207147 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207154 */     // MIs[0] rs1
     /*  207154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207166 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207171 */     GIR_RootConstrainSelectedInstOperands,
     /*  207172 */     // GIR_Coverage, 869,
     /*  207172 */     GIR_Done,
     /*  207173 */   // Label 4155: @207173
     /*  207173 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(207214), // Rule ID 871 //
     /*  207178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207181 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207188 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207195 */     // MIs[0] rs1
     /*  207195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207207 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  207212 */     GIR_RootConstrainSelectedInstOperands,
     /*  207213 */     // GIR_Coverage, 871,
     /*  207213 */     GIR_Done,
     /*  207214 */   // Label 4156: @207214
     /*  207214 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(207255), // Rule ID 873 //
     /*  207219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207222 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207229 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207236 */     // MIs[0] rs1
     /*  207236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207248 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  207253 */     GIR_RootConstrainSelectedInstOperands,
     /*  207254 */     // GIR_Coverage, 873,
     /*  207254 */     GIR_Done,
     /*  207255 */   // Label 4157: @207255
     /*  207255 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(207296), // Rule ID 875 //
     /*  207260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207263 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207277 */     // MIs[0] rs1
     /*  207277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207289 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207289 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  207294 */     GIR_RootConstrainSelectedInstOperands,
     /*  207295 */     // GIR_Coverage, 875,
     /*  207295 */     GIR_Done,
     /*  207296 */   // Label 4158: @207296
     /*  207296 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(207337), // Rule ID 877 //
     /*  207301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207304 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207318 */     // MIs[0] rs1
     /*  207318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207330 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  207335 */     GIR_RootConstrainSelectedInstOperands,
     /*  207336 */     // GIR_Coverage, 877,
     /*  207336 */     GIR_Done,
     /*  207337 */   // Label 4159: @207337
     /*  207337 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(207378), // Rule ID 879 //
     /*  207342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207345 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207352 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207359 */     // MIs[0] rs1
     /*  207359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207371 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207376 */     GIR_RootConstrainSelectedInstOperands,
     /*  207377 */     // GIR_Coverage, 879,
     /*  207377 */     GIR_Done,
     /*  207378 */   // Label 4160: @207378
     /*  207378 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(207419), // Rule ID 881 //
     /*  207383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207386 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207393 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207400 */     // MIs[0] rs1
     /*  207400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207412 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207417 */     GIR_RootConstrainSelectedInstOperands,
     /*  207418 */     // GIR_Coverage, 881,
     /*  207418 */     GIR_Done,
     /*  207419 */   // Label 4161: @207419
     /*  207419 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(207460), // Rule ID 883 //
     /*  207424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207434 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207441 */     // MIs[0] rs1
     /*  207441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207453 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207453 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207458 */     GIR_RootConstrainSelectedInstOperands,
     /*  207459 */     // GIR_Coverage, 883,
     /*  207459 */     GIR_Done,
     /*  207460 */   // Label 4162: @207460
     /*  207460 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(207501), // Rule ID 885 //
     /*  207465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207482 */     // MIs[0] rs1
     /*  207482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207494 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207499 */     GIR_RootConstrainSelectedInstOperands,
     /*  207500 */     // GIR_Coverage, 885,
     /*  207500 */     GIR_Done,
     /*  207501 */   // Label 4163: @207501
     /*  207501 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(207542), // Rule ID 887 //
     /*  207506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207509 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207516 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207523 */     // MIs[0] rs1
     /*  207523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207535 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207540 */     GIR_RootConstrainSelectedInstOperands,
     /*  207541 */     // GIR_Coverage, 887,
     /*  207541 */     GIR_Done,
     /*  207542 */   // Label 4164: @207542
     /*  207542 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(207583), // Rule ID 1049 //
     /*  207547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207550 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207557 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207564 */     // MIs[0] rs1
     /*  207564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207576 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207581 */     GIR_RootConstrainSelectedInstOperands,
     /*  207582 */     // GIR_Coverage, 1049,
     /*  207582 */     GIR_Done,
     /*  207583 */   // Label 4165: @207583
     /*  207583 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(207624), // Rule ID 1051 //
     /*  207588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207591 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207598 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207605 */     // MIs[0] rs1
     /*  207605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207617 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  207622 */     GIR_RootConstrainSelectedInstOperands,
     /*  207623 */     // GIR_Coverage, 1051,
     /*  207623 */     GIR_Done,
     /*  207624 */   // Label 4166: @207624
     /*  207624 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(207665), // Rule ID 1053 //
     /*  207629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207632 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207639 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207646 */     // MIs[0] rs1
     /*  207646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207658 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  207663 */     GIR_RootConstrainSelectedInstOperands,
     /*  207664 */     // GIR_Coverage, 1053,
     /*  207664 */     GIR_Done,
     /*  207665 */   // Label 4167: @207665
     /*  207665 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(207706), // Rule ID 1055 //
     /*  207670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207673 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207680 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207687 */     // MIs[0] rs1
     /*  207687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207699 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  207704 */     GIR_RootConstrainSelectedInstOperands,
     /*  207705 */     // GIR_Coverage, 1055,
     /*  207705 */     GIR_Done,
     /*  207706 */   // Label 4168: @207706
     /*  207706 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(207747), // Rule ID 1057 //
     /*  207711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207714 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207721 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207728 */     // MIs[0] rs1
     /*  207728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207740 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  207745 */     GIR_RootConstrainSelectedInstOperands,
     /*  207746 */     // GIR_Coverage, 1057,
     /*  207746 */     GIR_Done,
     /*  207747 */   // Label 4169: @207747
     /*  207747 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(207788), // Rule ID 1059 //
     /*  207752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207755 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207762 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207769 */     // MIs[0] rs1
     /*  207769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207781 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207786 */     GIR_RootConstrainSelectedInstOperands,
     /*  207787 */     // GIR_Coverage, 1059,
     /*  207787 */     GIR_Done,
     /*  207788 */   // Label 4170: @207788
     /*  207788 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(207829), // Rule ID 1061 //
     /*  207793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207796 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207803 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207810 */     // MIs[0] rs1
     /*  207810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207822 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207827 */     GIR_RootConstrainSelectedInstOperands,
     /*  207828 */     // GIR_Coverage, 1061,
     /*  207828 */     GIR_Done,
     /*  207829 */   // Label 4171: @207829
     /*  207829 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(207870), // Rule ID 1063 //
     /*  207834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207837 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207844 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207851 */     // MIs[0] rs1
     /*  207851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207863 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207868 */     GIR_RootConstrainSelectedInstOperands,
     /*  207869 */     // GIR_Coverage, 1063,
     /*  207869 */     GIR_Done,
     /*  207870 */   // Label 4172: @207870
     /*  207870 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(207911), // Rule ID 1065 //
     /*  207875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207878 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207885 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207892 */     // MIs[0] rs1
     /*  207892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207904 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207909 */     GIR_RootConstrainSelectedInstOperands,
     /*  207910 */     // GIR_Coverage, 1065,
     /*  207910 */     GIR_Done,
     /*  207911 */   // Label 4173: @207911
     /*  207911 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(207952), // Rule ID 1067 //
     /*  207916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207919 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207926 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207933 */     // MIs[0] rs1
     /*  207933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207945 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207950 */     GIR_RootConstrainSelectedInstOperands,
     /*  207951 */     // GIR_Coverage, 1067,
     /*  207951 */     GIR_Done,
     /*  207952 */   // Label 4174: @207952
     /*  207952 */   GIM_Reject,
     /*  207953 */ // Label 4134: @207953
     /*  207953 */ GIM_Reject,
     /*  207954 */ // Label 4102: @207954
     /*  207954 */ GIM_Reject,
     /*  207955 */ // Label 36: @207955
     /*  207955 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4177*/ GIMT_Encode4(208172),
     /*  207966 */ /*GILLT_s32*//*Label 4175*/ GIMT_Encode4(207974),
     /*  207970 */ /*GILLT_s64*//*Label 4176*/ GIMT_Encode4(208073),
     /*  207974 */ // Label 4175: @207974
     /*  207974 */ GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(208000), // Rule ID 263 //
     /*  207979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207982 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  207986 */   // MIs[0] Operand 1
     /*  207986 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207989 */   // (atomic_fence 4:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 2:{ *:[i32] }, 3:{ *:[i32] })
     /*  207989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  207995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207998 */   GIR_RootConstrainSelectedInstOperands,
     /*  207999 */   // GIR_Coverage, 263,
     /*  207999 */   GIR_EraseRootFromParent_Done,
     /*  208000 */ // Label 4178: @208000
     /*  208000 */ GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(208026), // Rule ID 265 //
     /*  208005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208008 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  208012 */   // MIs[0] Operand 1
     /*  208012 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208015 */   // (atomic_fence 5:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  208015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  208018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  208024 */   GIR_RootConstrainSelectedInstOperands,
     /*  208025 */   // GIR_Coverage, 265,
     /*  208025 */   GIR_EraseRootFromParent_Done,
     /*  208026 */ // Label 4179: @208026
     /*  208026 */ GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(208046), // Rule ID 267 //
     /*  208031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208034 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  208038 */   // MIs[0] Operand 1
     /*  208038 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208041 */   // (atomic_fence 6:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE_TSO)
     /*  208041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  208044 */   GIR_RootConstrainSelectedInstOperands,
     /*  208045 */   // GIR_Coverage, 267,
     /*  208045 */   GIR_EraseRootFromParent_Done,
     /*  208046 */ // Label 4180: @208046
     /*  208046 */ GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(208072), // Rule ID 269 //
     /*  208051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208054 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  208058 */   // MIs[0] Operand 1
     /*  208058 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208061 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  208061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  208064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208070 */   GIR_RootConstrainSelectedInstOperands,
     /*  208071 */   // GIR_Coverage, 269,
     /*  208071 */   GIR_EraseRootFromParent_Done,
     /*  208072 */ // Label 4181: @208072
     /*  208072 */ GIM_Reject,
     /*  208073 */ // Label 4176: @208073
     /*  208073 */ GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(208099), // Rule ID 262 //
     /*  208078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208081 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  208085 */   // MIs[0] Operand 1
     /*  208085 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208088 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 2:{ *:[i64] }, 3:{ *:[i64] })
     /*  208088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  208091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  208094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208097 */   GIR_RootConstrainSelectedInstOperands,
     /*  208098 */   // GIR_Coverage, 262,
     /*  208098 */   GIR_EraseRootFromParent_Done,
     /*  208099 */ // Label 4182: @208099
     /*  208099 */ GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(208125), // Rule ID 264 //
     /*  208104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208107 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  208111 */   // MIs[0] Operand 1
     /*  208111 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208114 */   // (atomic_fence 5:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  208114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  208117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  208123 */   GIR_RootConstrainSelectedInstOperands,
     /*  208124 */   // GIR_Coverage, 264,
     /*  208124 */   GIR_EraseRootFromParent_Done,
     /*  208125 */ // Label 4183: @208125
     /*  208125 */ GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(208145), // Rule ID 266 //
     /*  208130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208133 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  208137 */   // MIs[0] Operand 1
     /*  208137 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208140 */   // (atomic_fence 6:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE_TSO)
     /*  208140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  208143 */   GIR_RootConstrainSelectedInstOperands,
     /*  208144 */   // GIR_Coverage, 266,
     /*  208144 */   GIR_EraseRootFromParent_Done,
     /*  208145 */ // Label 4184: @208145
     /*  208145 */ GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(208171), // Rule ID 268 //
     /*  208150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208153 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  208157 */   // MIs[0] Operand 1
     /*  208157 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208160 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  208160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  208163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208169 */   GIR_RootConstrainSelectedInstOperands,
     /*  208170 */   // GIR_Coverage, 268,
     /*  208170 */   GIR_EraseRootFromParent_Done,
     /*  208171 */ // Label 4185: @208171
     /*  208171 */ GIM_Reject,
     /*  208172 */ // Label 4177: @208172
     /*  208172 */ GIM_Reject,
     /*  208173 */ // Label 37: @208173
     /*  208173 */ GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(209658),
     /*  208178 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  208181 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(208226), // Rule ID 2726 //
     /*  208186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208211 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  208214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208224 */     GIR_RootConstrainSelectedInstOperands,
     /*  208225 */     // GIR_Coverage, 2726,
     /*  208225 */     GIR_EraseRootFromParent_Done,
     /*  208226 */   // Label 4187: @208226
     /*  208226 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(208271), // Rule ID 2727 //
     /*  208231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208256 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  208259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208269 */     GIR_RootConstrainSelectedInstOperands,
     /*  208270 */     // GIR_Coverage, 2727,
     /*  208270 */     GIR_EraseRootFromParent_Done,
     /*  208271 */   // Label 4188: @208271
     /*  208271 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(208316), // Rule ID 23276 //
     /*  208276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208301 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  208304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208314 */     GIR_RootConstrainSelectedInstOperands,
     /*  208315 */     // GIR_Coverage, 23276,
     /*  208315 */     GIR_EraseRootFromParent_Done,
     /*  208316 */   // Label 4189: @208316
     /*  208316 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(208361), // Rule ID 23277 //
     /*  208321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208346 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  208349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208359 */     GIR_RootConstrainSelectedInstOperands,
     /*  208360 */     // GIR_Coverage, 23277,
     /*  208360 */     GIR_EraseRootFromParent_Done,
     /*  208361 */   // Label 4190: @208361
     /*  208361 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(208406), // Rule ID 23278 //
     /*  208366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208391 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  208394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208404 */     GIR_RootConstrainSelectedInstOperands,
     /*  208405 */     // GIR_Coverage, 23278,
     /*  208405 */     GIR_EraseRootFromParent_Done,
     /*  208406 */   // Label 4191: @208406
     /*  208406 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(208451), // Rule ID 23279 //
     /*  208411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208436 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  208439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208449 */     GIR_RootConstrainSelectedInstOperands,
     /*  208450 */     // GIR_Coverage, 23279,
     /*  208450 */     GIR_EraseRootFromParent_Done,
     /*  208451 */   // Label 4192: @208451
     /*  208451 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(208496), // Rule ID 23280 //
     /*  208456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208481 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  208484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208494 */     GIR_RootConstrainSelectedInstOperands,
     /*  208495 */     // GIR_Coverage, 23280,
     /*  208495 */     GIR_EraseRootFromParent_Done,
     /*  208496 */   // Label 4193: @208496
     /*  208496 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(208541), // Rule ID 23281 //
     /*  208501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208526 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  208529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208539 */     GIR_RootConstrainSelectedInstOperands,
     /*  208540 */     // GIR_Coverage, 23281,
     /*  208540 */     GIR_EraseRootFromParent_Done,
     /*  208541 */   // Label 4194: @208541
     /*  208541 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(208586), // Rule ID 23282 //
     /*  208546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208571 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  208574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208584 */     GIR_RootConstrainSelectedInstOperands,
     /*  208585 */     // GIR_Coverage, 23282,
     /*  208585 */     GIR_EraseRootFromParent_Done,
     /*  208586 */   // Label 4195: @208586
     /*  208586 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(208631), // Rule ID 23283 //
     /*  208591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208616 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  208619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208629 */     GIR_RootConstrainSelectedInstOperands,
     /*  208630 */     // GIR_Coverage, 23283,
     /*  208630 */     GIR_EraseRootFromParent_Done,
     /*  208631 */   // Label 4196: @208631
     /*  208631 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(208676), // Rule ID 23284 //
     /*  208636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208661 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  208664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208674 */     GIR_RootConstrainSelectedInstOperands,
     /*  208675 */     // GIR_Coverage, 23284,
     /*  208675 */     GIR_EraseRootFromParent_Done,
     /*  208676 */   // Label 4197: @208676
     /*  208676 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(208721), // Rule ID 23285 //
     /*  208681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208706 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  208709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208719 */     GIR_RootConstrainSelectedInstOperands,
     /*  208720 */     // GIR_Coverage, 23285,
     /*  208720 */     GIR_EraseRootFromParent_Done,
     /*  208721 */   // Label 4198: @208721
     /*  208721 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(208766), // Rule ID 23286 //
     /*  208726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208751 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  208754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208764 */     GIR_RootConstrainSelectedInstOperands,
     /*  208765 */     // GIR_Coverage, 23286,
     /*  208765 */     GIR_EraseRootFromParent_Done,
     /*  208766 */   // Label 4199: @208766
     /*  208766 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(208811), // Rule ID 23287 //
     /*  208771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208796 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11473:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  208799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208809 */     GIR_RootConstrainSelectedInstOperands,
     /*  208810 */     // GIR_Coverage, 23287,
     /*  208810 */     GIR_EraseRootFromParent_Done,
     /*  208811 */   // Label 4200: @208811
     /*  208811 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(208856), // Rule ID 23288 //
     /*  208816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208841 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  208844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208854 */     GIR_RootConstrainSelectedInstOperands,
     /*  208855 */     // GIR_Coverage, 23288,
     /*  208855 */     GIR_EraseRootFromParent_Done,
     /*  208856 */   // Label 4201: @208856
     /*  208856 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(208901), // Rule ID 23289 //
     /*  208861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208886 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  208889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208899 */     GIR_RootConstrainSelectedInstOperands,
     /*  208900 */     // GIR_Coverage, 23289,
     /*  208900 */     GIR_EraseRootFromParent_Done,
     /*  208901 */   // Label 4202: @208901
     /*  208901 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(208946), // Rule ID 23290 //
     /*  208906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208931 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  208934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208944 */     GIR_RootConstrainSelectedInstOperands,
     /*  208945 */     // GIR_Coverage, 23290,
     /*  208945 */     GIR_EraseRootFromParent_Done,
     /*  208946 */   // Label 4203: @208946
     /*  208946 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(208991), // Rule ID 23291 //
     /*  208951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208976 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  208979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208989 */     GIR_RootConstrainSelectedInstOperands,
     /*  208990 */     // GIR_Coverage, 23291,
     /*  208990 */     GIR_EraseRootFromParent_Done,
     /*  208991 */   // Label 4204: @208991
     /*  208991 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(209036), // Rule ID 23292 //
     /*  208996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  209007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209021 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  209024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209034 */     GIR_RootConstrainSelectedInstOperands,
     /*  209035 */     // GIR_Coverage, 23292,
     /*  209035 */     GIR_EraseRootFromParent_Done,
     /*  209036 */   // Label 4205: @209036
     /*  209036 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(209081), // Rule ID 23293 //
     /*  209041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  209052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209066 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  209069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209079 */     GIR_RootConstrainSelectedInstOperands,
     /*  209080 */     // GIR_Coverage, 23293,
     /*  209080 */     GIR_EraseRootFromParent_Done,
     /*  209081 */   // Label 4206: @209081
     /*  209081 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(209126), // Rule ID 23294 //
     /*  209086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  209097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209111 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  209114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209124 */     GIR_RootConstrainSelectedInstOperands,
     /*  209125 */     // GIR_Coverage, 23294,
     /*  209125 */     GIR_EraseRootFromParent_Done,
     /*  209126 */   // Label 4207: @209126
     /*  209126 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(209171), // Rule ID 23295 //
     /*  209131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  209142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  209159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209169 */     GIR_RootConstrainSelectedInstOperands,
     /*  209170 */     // GIR_Coverage, 23295,
     /*  209170 */     GIR_EraseRootFromParent_Done,
     /*  209171 */   // Label 4208: @209171
     /*  209171 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(209216), // Rule ID 23296 //
     /*  209176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  209187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209201 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  209204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209214 */     GIR_RootConstrainSelectedInstOperands,
     /*  209215 */     // GIR_Coverage, 23296,
     /*  209215 */     GIR_EraseRootFromParent_Done,
     /*  209216 */   // Label 4209: @209216
     /*  209216 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(209261), // Rule ID 23297 //
     /*  209221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  209232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209246 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  209249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209259 */     GIR_RootConstrainSelectedInstOperands,
     /*  209260 */     // GIR_Coverage, 23297,
     /*  209260 */     GIR_EraseRootFromParent_Done,
     /*  209261 */   // Label 4210: @209261
     /*  209261 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(209306), // Rule ID 23298 //
     /*  209266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  209277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209291 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  209294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209304 */     GIR_RootConstrainSelectedInstOperands,
     /*  209305 */     // GIR_Coverage, 23298,
     /*  209305 */     GIR_EraseRootFromParent_Done,
     /*  209306 */   // Label 4211: @209306
     /*  209306 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(209351), // Rule ID 23299 //
     /*  209311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  209322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209336 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  209339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209349 */     GIR_RootConstrainSelectedInstOperands,
     /*  209350 */     // GIR_Coverage, 23299,
     /*  209350 */     GIR_EraseRootFromParent_Done,
     /*  209351 */   // Label 4212: @209351
     /*  209351 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(209396), // Rule ID 23300 //
     /*  209356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  209367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209381 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  209384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209394 */     GIR_RootConstrainSelectedInstOperands,
     /*  209395 */     // GIR_Coverage, 23300,
     /*  209395 */     GIR_EraseRootFromParent_Done,
     /*  209396 */   // Label 4213: @209396
     /*  209396 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(209441), // Rule ID 23301 //
     /*  209401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  209412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209426 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11501:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  209429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209439 */     GIR_RootConstrainSelectedInstOperands,
     /*  209440 */     // GIR_Coverage, 23301,
     /*  209440 */     GIR_EraseRootFromParent_Done,
     /*  209441 */   // Label 4214: @209441
     /*  209441 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(209477), // Rule ID 2663 //
     /*  209446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  209449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64im),
     /*  209454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209468 */     // (intrinsic_wo_chain:{ *:[i64] } 11015:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (AES64IM:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64IM),
     /*  209471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209475 */     GIR_RootConstrainSelectedInstOperands,
     /*  209476 */     // GIR_Coverage, 2663,
     /*  209476 */     GIR_EraseRootFromParent_Done,
     /*  209477 */   // Label 4215: @209477
     /*  209477 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(209513), // Rule ID 2684 //
     /*  209482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0),
     /*  209490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209504 */     // (intrinsic_wo_chain:{ *:[i64] } 11168:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0),
     /*  209507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209511 */     GIR_RootConstrainSelectedInstOperands,
     /*  209512 */     // GIR_Coverage, 2684,
     /*  209512 */     GIR_EraseRootFromParent_Done,
     /*  209513 */   // Label 4216: @209513
     /*  209513 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(209549), // Rule ID 2685 //
     /*  209518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1),
     /*  209526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209540 */     // (intrinsic_wo_chain:{ *:[i64] } 11171:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1),
     /*  209543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209547 */     GIR_RootConstrainSelectedInstOperands,
     /*  209548 */     // GIR_Coverage, 2685,
     /*  209548 */     GIR_EraseRootFromParent_Done,
     /*  209549 */   // Label 4217: @209549
     /*  209549 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(209585), // Rule ID 2686 //
     /*  209554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0),
     /*  209562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209576 */     // (intrinsic_wo_chain:{ *:[i64] } 11174:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0),
     /*  209579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209583 */     GIR_RootConstrainSelectedInstOperands,
     /*  209584 */     // GIR_Coverage, 2686,
     /*  209584 */     GIR_EraseRootFromParent_Done,
     /*  209585 */   // Label 4218: @209585
     /*  209585 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(209621), // Rule ID 2687 //
     /*  209590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1),
     /*  209598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209612 */     // (intrinsic_wo_chain:{ *:[i64] } 11176:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1),
     /*  209615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209619 */     GIR_RootConstrainSelectedInstOperands,
     /*  209620 */     // GIR_Coverage, 2687,
     /*  209620 */     GIR_EraseRootFromParent_Done,
     /*  209621 */   // Label 4219: @209621
     /*  209621 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(209657), // Rule ID 64454 //
     /*  209626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  209629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_clb),
     /*  209634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209648 */     // (intrinsic_wo_chain:{ *:[i32] } 11035:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1)  =>  (CV_CLB:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  209648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLB),
     /*  209651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209655 */     GIR_RootConstrainSelectedInstOperands,
     /*  209656 */     // GIR_Coverage, 64454,
     /*  209656 */     GIR_EraseRootFromParent_Done,
     /*  209657 */   // Label 4220: @209657
     /*  209657 */   GIM_Reject,
     /*  209658 */ // Label 4186: @209658
     /*  209658 */ GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(216946),
     /*  209663 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  209666 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(209720), // Rule ID 2696 //
     /*  209671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209703 */     // (intrinsic_wo_chain:{ *:[i64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  209706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209718 */     GIR_RootConstrainSelectedInstOperands,
     /*  209719 */     // GIR_Coverage, 2696,
     /*  209719 */     GIR_EraseRootFromParent_Done,
     /*  209720 */   // Label 4222: @209720
     /*  209720 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(209774), // Rule ID 2697 //
     /*  209725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209757 */     // (intrinsic_wo_chain:{ *:[i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  209760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209772 */     GIR_RootConstrainSelectedInstOperands,
     /*  209773 */     // GIR_Coverage, 2697,
     /*  209773 */     GIR_EraseRootFromParent_Done,
     /*  209774 */   // Label 4223: @209774
     /*  209774 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(209828), // Rule ID 2702 //
     /*  209779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  209787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  209790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209811 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  209814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209826 */     GIR_RootConstrainSelectedInstOperands,
     /*  209827 */     // GIR_Coverage, 2702,
     /*  209827 */     GIR_EraseRootFromParent_Done,
     /*  209828 */   // Label 4224: @209828
     /*  209828 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(209882), // Rule ID 2703 //
     /*  209833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  209841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  209844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209865 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  209868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209880 */     GIR_RootConstrainSelectedInstOperands,
     /*  209881 */     // GIR_Coverage, 2703,
     /*  209881 */     GIR_EraseRootFromParent_Done,
     /*  209882 */   // Label 4225: @209882
     /*  209882 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(209939), // Rule ID 2722 //
     /*  209887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  209890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  209895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  209898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  209901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209919 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  209919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  209922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  209926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209937 */     GIR_RootConstrainSelectedInstOperands,
     /*  209938 */     // GIR_Coverage, 2722,
     /*  209938 */     GIR_EraseRootFromParent_Done,
     /*  209939 */   // Label 4226: @209939
     /*  209939 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(209996), // Rule ID 2723 //
     /*  209944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  209947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  209952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  209955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  209958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209976 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  209976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  209979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  209983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209994 */     GIR_RootConstrainSelectedInstOperands,
     /*  209995 */     // GIR_Coverage, 2723,
     /*  209995 */     GIR_EraseRootFromParent_Done,
     /*  209996 */   // Label 4227: @209996
     /*  209996 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(210050), // Rule ID 23302 //
     /*  210001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210033 */     // (intrinsic_wo_chain:{ *:[i64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  210036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210048 */     GIR_RootConstrainSelectedInstOperands,
     /*  210049 */     // GIR_Coverage, 23302,
     /*  210049 */     GIR_EraseRootFromParent_Done,
     /*  210050 */   // Label 4228: @210050
     /*  210050 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(210104), // Rule ID 23303 //
     /*  210055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210087 */     // (intrinsic_wo_chain:{ *:[i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  210090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210102 */     GIR_RootConstrainSelectedInstOperands,
     /*  210103 */     // GIR_Coverage, 23303,
     /*  210103 */     GIR_EraseRootFromParent_Done,
     /*  210104 */   // Label 4229: @210104
     /*  210104 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(210158), // Rule ID 23306 //
     /*  210109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210141 */     // (intrinsic_wo_chain:{ *:[i64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  210144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210156 */     GIR_RootConstrainSelectedInstOperands,
     /*  210157 */     // GIR_Coverage, 23306,
     /*  210157 */     GIR_EraseRootFromParent_Done,
     /*  210158 */   // Label 4230: @210158
     /*  210158 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(210212), // Rule ID 23307 //
     /*  210163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210195 */     // (intrinsic_wo_chain:{ *:[i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  210198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210210 */     GIR_RootConstrainSelectedInstOperands,
     /*  210211 */     // GIR_Coverage, 23307,
     /*  210211 */     GIR_EraseRootFromParent_Done,
     /*  210212 */   // Label 4231: @210212
     /*  210212 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(210266), // Rule ID 23310 //
     /*  210217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210249 */     // (intrinsic_wo_chain:{ *:[i64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  210252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210264 */     GIR_RootConstrainSelectedInstOperands,
     /*  210265 */     // GIR_Coverage, 23310,
     /*  210265 */     GIR_EraseRootFromParent_Done,
     /*  210266 */   // Label 4232: @210266
     /*  210266 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(210320), // Rule ID 23311 //
     /*  210271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210303 */     // (intrinsic_wo_chain:{ *:[i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  210306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210318 */     GIR_RootConstrainSelectedInstOperands,
     /*  210319 */     // GIR_Coverage, 23311,
     /*  210319 */     GIR_EraseRootFromParent_Done,
     /*  210320 */   // Label 4233: @210320
     /*  210320 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(210374), // Rule ID 23314 //
     /*  210325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  210339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210357 */     // (intrinsic_wo_chain:{ *:[i64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  210360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210372 */     GIR_RootConstrainSelectedInstOperands,
     /*  210373 */     // GIR_Coverage, 23314,
     /*  210373 */     GIR_EraseRootFromParent_Done,
     /*  210374 */   // Label 4234: @210374
     /*  210374 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(210428), // Rule ID 23315 //
     /*  210379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  210393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210411 */     // (intrinsic_wo_chain:{ *:[i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  210414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210426 */     GIR_RootConstrainSelectedInstOperands,
     /*  210427 */     // GIR_Coverage, 23315,
     /*  210427 */     GIR_EraseRootFromParent_Done,
     /*  210428 */   // Label 4235: @210428
     /*  210428 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(210482), // Rule ID 23318 //
     /*  210433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210465 */     // (intrinsic_wo_chain:{ *:[i64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  210468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210480 */     GIR_RootConstrainSelectedInstOperands,
     /*  210481 */     // GIR_Coverage, 23318,
     /*  210481 */     GIR_EraseRootFromParent_Done,
     /*  210482 */   // Label 4236: @210482
     /*  210482 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(210536), // Rule ID 23319 //
     /*  210487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210519 */     // (intrinsic_wo_chain:{ *:[i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  210522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210534 */     GIR_RootConstrainSelectedInstOperands,
     /*  210535 */     // GIR_Coverage, 23319,
     /*  210535 */     GIR_EraseRootFromParent_Done,
     /*  210536 */   // Label 4237: @210536
     /*  210536 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(210590), // Rule ID 23322 //
     /*  210541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210573 */     // (intrinsic_wo_chain:{ *:[i64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  210576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210588 */     GIR_RootConstrainSelectedInstOperands,
     /*  210589 */     // GIR_Coverage, 23322,
     /*  210589 */     GIR_EraseRootFromParent_Done,
     /*  210590 */   // Label 4238: @210590
     /*  210590 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(210644), // Rule ID 23323 //
     /*  210595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210627 */     // (intrinsic_wo_chain:{ *:[i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  210630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210642 */     GIR_RootConstrainSelectedInstOperands,
     /*  210643 */     // GIR_Coverage, 23323,
     /*  210643 */     GIR_EraseRootFromParent_Done,
     /*  210644 */   // Label 4239: @210644
     /*  210644 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(210698), // Rule ID 23326 //
     /*  210649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  210663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210681 */     // (intrinsic_wo_chain:{ *:[i64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  210684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210696 */     GIR_RootConstrainSelectedInstOperands,
     /*  210697 */     // GIR_Coverage, 23326,
     /*  210697 */     GIR_EraseRootFromParent_Done,
     /*  210698 */   // Label 4240: @210698
     /*  210698 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(210752), // Rule ID 23327 //
     /*  210703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  210717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210735 */     // (intrinsic_wo_chain:{ *:[i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  210738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210750 */     GIR_RootConstrainSelectedInstOperands,
     /*  210751 */     // GIR_Coverage, 23327,
     /*  210751 */     GIR_EraseRootFromParent_Done,
     /*  210752 */   // Label 4241: @210752
     /*  210752 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(210806), // Rule ID 23330 //
     /*  210757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210789 */     // (intrinsic_wo_chain:{ *:[i64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  210792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210804 */     GIR_RootConstrainSelectedInstOperands,
     /*  210805 */     // GIR_Coverage, 23330,
     /*  210805 */     GIR_EraseRootFromParent_Done,
     /*  210806 */   // Label 4242: @210806
     /*  210806 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(210860), // Rule ID 23331 //
     /*  210811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210843 */     // (intrinsic_wo_chain:{ *:[i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  210846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210858 */     GIR_RootConstrainSelectedInstOperands,
     /*  210859 */     // GIR_Coverage, 23331,
     /*  210859 */     GIR_EraseRootFromParent_Done,
     /*  210860 */   // Label 4243: @210860
     /*  210860 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(210914), // Rule ID 23334 //
     /*  210865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210897 */     // (intrinsic_wo_chain:{ *:[i64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  210900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210912 */     GIR_RootConstrainSelectedInstOperands,
     /*  210913 */     // GIR_Coverage, 23334,
     /*  210913 */     GIR_EraseRootFromParent_Done,
     /*  210914 */   // Label 4244: @210914
     /*  210914 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(210968), // Rule ID 23335 //
     /*  210919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210951 */     // (intrinsic_wo_chain:{ *:[i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  210954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210966 */     GIR_RootConstrainSelectedInstOperands,
     /*  210967 */     // GIR_Coverage, 23335,
     /*  210967 */     GIR_EraseRootFromParent_Done,
     /*  210968 */   // Label 4245: @210968
     /*  210968 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(211022), // Rule ID 23338 //
     /*  210973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211005 */     // (intrinsic_wo_chain:{ *:[i64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  211008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211020 */     GIR_RootConstrainSelectedInstOperands,
     /*  211021 */     // GIR_Coverage, 23338,
     /*  211021 */     GIR_EraseRootFromParent_Done,
     /*  211022 */   // Label 4246: @211022
     /*  211022 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(211076), // Rule ID 23339 //
     /*  211027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  211038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211059 */     // (intrinsic_wo_chain:{ *:[i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  211062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211074 */     GIR_RootConstrainSelectedInstOperands,
     /*  211075 */     // GIR_Coverage, 23339,
     /*  211075 */     GIR_EraseRootFromParent_Done,
     /*  211076 */   // Label 4247: @211076
     /*  211076 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(211130), // Rule ID 23342 //
     /*  211081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  211092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211113 */     // (intrinsic_wo_chain:{ *:[i64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  211116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211128 */     GIR_RootConstrainSelectedInstOperands,
     /*  211129 */     // GIR_Coverage, 23342,
     /*  211129 */     GIR_EraseRootFromParent_Done,
     /*  211130 */   // Label 4248: @211130
     /*  211130 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(211184), // Rule ID 23343 //
     /*  211135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  211146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211167 */     // (intrinsic_wo_chain:{ *:[i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  211170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211182 */     GIR_RootConstrainSelectedInstOperands,
     /*  211183 */     // GIR_Coverage, 23343,
     /*  211183 */     GIR_EraseRootFromParent_Done,
     /*  211184 */   // Label 4249: @211184
     /*  211184 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(211238), // Rule ID 23346 //
     /*  211189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  211200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211221 */     // (intrinsic_wo_chain:{ *:[i64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  211224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211236 */     GIR_RootConstrainSelectedInstOperands,
     /*  211237 */     // GIR_Coverage, 23346,
     /*  211237 */     GIR_EraseRootFromParent_Done,
     /*  211238 */   // Label 4250: @211238
     /*  211238 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(211292), // Rule ID 23347 //
     /*  211243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  211254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211275 */     // (intrinsic_wo_chain:{ *:[i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  211278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211290 */     GIR_RootConstrainSelectedInstOperands,
     /*  211291 */     // GIR_Coverage, 23347,
     /*  211291 */     GIR_EraseRootFromParent_Done,
     /*  211292 */   // Label 4251: @211292
     /*  211292 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(211346), // Rule ID 23350 //
     /*  211297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  211308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211329 */     // (intrinsic_wo_chain:{ *:[i64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  211332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211344 */     GIR_RootConstrainSelectedInstOperands,
     /*  211345 */     // GIR_Coverage, 23350,
     /*  211345 */     GIR_EraseRootFromParent_Done,
     /*  211346 */   // Label 4252: @211346
     /*  211346 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(211400), // Rule ID 23351 //
     /*  211351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  211362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211383 */     // (intrinsic_wo_chain:{ *:[i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  211386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211398 */     GIR_RootConstrainSelectedInstOperands,
     /*  211399 */     // GIR_Coverage, 23351,
     /*  211399 */     GIR_EraseRootFromParent_Done,
     /*  211400 */   // Label 4253: @211400
     /*  211400 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(211454), // Rule ID 23354 //
     /*  211405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  211419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211437 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  211440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211452 */     GIR_RootConstrainSelectedInstOperands,
     /*  211453 */     // GIR_Coverage, 23354,
     /*  211453 */     GIR_EraseRootFromParent_Done,
     /*  211454 */   // Label 4254: @211454
     /*  211454 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(211508), // Rule ID 23355 //
     /*  211459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  211473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211491 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  211494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211506 */     GIR_RootConstrainSelectedInstOperands,
     /*  211507 */     // GIR_Coverage, 23355,
     /*  211507 */     GIR_EraseRootFromParent_Done,
     /*  211508 */   // Label 4255: @211508
     /*  211508 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(211562), // Rule ID 23358 //
     /*  211513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211545 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  211548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211560 */     GIR_RootConstrainSelectedInstOperands,
     /*  211561 */     // GIR_Coverage, 23358,
     /*  211561 */     GIR_EraseRootFromParent_Done,
     /*  211562 */   // Label 4256: @211562
     /*  211562 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(211616), // Rule ID 23359 //
     /*  211567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211599 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  211602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211614 */     GIR_RootConstrainSelectedInstOperands,
     /*  211615 */     // GIR_Coverage, 23359,
     /*  211615 */     GIR_EraseRootFromParent_Done,
     /*  211616 */   // Label 4257: @211616
     /*  211616 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(211670), // Rule ID 23362 //
     /*  211621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211653 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  211656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211668 */     GIR_RootConstrainSelectedInstOperands,
     /*  211669 */     // GIR_Coverage, 23362,
     /*  211669 */     GIR_EraseRootFromParent_Done,
     /*  211670 */   // Label 4258: @211670
     /*  211670 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(211724), // Rule ID 23363 //
     /*  211675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211707 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  211710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211722 */     GIR_RootConstrainSelectedInstOperands,
     /*  211723 */     // GIR_Coverage, 23363,
     /*  211723 */     GIR_EraseRootFromParent_Done,
     /*  211724 */   // Label 4259: @211724
     /*  211724 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(211778), // Rule ID 23366 //
     /*  211729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211761 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  211764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211776 */     GIR_RootConstrainSelectedInstOperands,
     /*  211777 */     // GIR_Coverage, 23366,
     /*  211777 */     GIR_EraseRootFromParent_Done,
     /*  211778 */   // Label 4260: @211778
     /*  211778 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(211832), // Rule ID 23367 //
     /*  211783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211815 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  211818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211830 */     GIR_RootConstrainSelectedInstOperands,
     /*  211831 */     // GIR_Coverage, 23367,
     /*  211831 */     GIR_EraseRootFromParent_Done,
     /*  211832 */   // Label 4261: @211832
     /*  211832 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(211886), // Rule ID 23370 //
     /*  211837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  211848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211869 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  211872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211884 */     GIR_RootConstrainSelectedInstOperands,
     /*  211885 */     // GIR_Coverage, 23370,
     /*  211885 */     GIR_EraseRootFromParent_Done,
     /*  211886 */   // Label 4262: @211886
     /*  211886 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(211940), // Rule ID 23371 //
     /*  211891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  211902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211923 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  211926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211938 */     GIR_RootConstrainSelectedInstOperands,
     /*  211939 */     // GIR_Coverage, 23371,
     /*  211939 */     GIR_EraseRootFromParent_Done,
     /*  211940 */   // Label 4263: @211940
     /*  211940 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(211994), // Rule ID 23374 //
     /*  211945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  211956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211977 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  211980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211992 */     GIR_RootConstrainSelectedInstOperands,
     /*  211993 */     // GIR_Coverage, 23374,
     /*  211993 */     GIR_EraseRootFromParent_Done,
     /*  211994 */   // Label 4264: @211994
     /*  211994 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(212048), // Rule ID 23375 //
     /*  211999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  212007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212031 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  212034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212046 */     GIR_RootConstrainSelectedInstOperands,
     /*  212047 */     // GIR_Coverage, 23375,
     /*  212047 */     GIR_EraseRootFromParent_Done,
     /*  212048 */   // Label 4265: @212048
     /*  212048 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(212102), // Rule ID 23378 //
     /*  212053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  212067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212085 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  212088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212100 */     GIR_RootConstrainSelectedInstOperands,
     /*  212101 */     // GIR_Coverage, 23378,
     /*  212101 */     GIR_EraseRootFromParent_Done,
     /*  212102 */   // Label 4266: @212102
     /*  212102 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(212156), // Rule ID 23379 //
     /*  212107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  212121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212139 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  212142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212154 */     GIR_RootConstrainSelectedInstOperands,
     /*  212155 */     // GIR_Coverage, 23379,
     /*  212155 */     GIR_EraseRootFromParent_Done,
     /*  212156 */   // Label 4267: @212156
     /*  212156 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(212210), // Rule ID 23382 //
     /*  212161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212193 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  212196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212208 */     GIR_RootConstrainSelectedInstOperands,
     /*  212209 */     // GIR_Coverage, 23382,
     /*  212209 */     GIR_EraseRootFromParent_Done,
     /*  212210 */   // Label 4268: @212210
     /*  212210 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(212264), // Rule ID 23383 //
     /*  212215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212247 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  212250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212262 */     GIR_RootConstrainSelectedInstOperands,
     /*  212263 */     // GIR_Coverage, 23383,
     /*  212263 */     GIR_EraseRootFromParent_Done,
     /*  212264 */   // Label 4269: @212264
     /*  212264 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(212318), // Rule ID 23386 //
     /*  212269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  212283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212301 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  212304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212316 */     GIR_RootConstrainSelectedInstOperands,
     /*  212317 */     // GIR_Coverage, 23386,
     /*  212317 */     GIR_EraseRootFromParent_Done,
     /*  212318 */   // Label 4270: @212318
     /*  212318 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(212372), // Rule ID 23387 //
     /*  212323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  212337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212355 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  212358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212370 */     GIR_RootConstrainSelectedInstOperands,
     /*  212371 */     // GIR_Coverage, 23387,
     /*  212371 */     GIR_EraseRootFromParent_Done,
     /*  212372 */   // Label 4271: @212372
     /*  212372 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(212426), // Rule ID 23390 //
     /*  212377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  212391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212409 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  212412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212424 */     GIR_RootConstrainSelectedInstOperands,
     /*  212425 */     // GIR_Coverage, 23390,
     /*  212425 */     GIR_EraseRootFromParent_Done,
     /*  212426 */   // Label 4272: @212426
     /*  212426 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(212480), // Rule ID 23391 //
     /*  212431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  212445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212463 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  212466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212478 */     GIR_RootConstrainSelectedInstOperands,
     /*  212479 */     // GIR_Coverage, 23391,
     /*  212479 */     GIR_EraseRootFromParent_Done,
     /*  212480 */   // Label 4273: @212480
     /*  212480 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(212534), // Rule ID 23394 //
     /*  212485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212517 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  212520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212532 */     GIR_RootConstrainSelectedInstOperands,
     /*  212533 */     // GIR_Coverage, 23394,
     /*  212533 */     GIR_EraseRootFromParent_Done,
     /*  212534 */   // Label 4274: @212534
     /*  212534 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(212588), // Rule ID 23395 //
     /*  212539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212571 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  212574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212586 */     GIR_RootConstrainSelectedInstOperands,
     /*  212587 */     // GIR_Coverage, 23395,
     /*  212587 */     GIR_EraseRootFromParent_Done,
     /*  212588 */   // Label 4275: @212588
     /*  212588 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(212642), // Rule ID 23398 //
     /*  212593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212625 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  212628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212640 */     GIR_RootConstrainSelectedInstOperands,
     /*  212641 */     // GIR_Coverage, 23398,
     /*  212641 */     GIR_EraseRootFromParent_Done,
     /*  212642 */   // Label 4276: @212642
     /*  212642 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(212696), // Rule ID 23399 //
     /*  212647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212679 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  212682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212694 */     GIR_RootConstrainSelectedInstOperands,
     /*  212695 */     // GIR_Coverage, 23399,
     /*  212695 */     GIR_EraseRootFromParent_Done,
     /*  212696 */   // Label 4277: @212696
     /*  212696 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(212750), // Rule ID 23402 //
     /*  212701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212733 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  212736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212748 */     GIR_RootConstrainSelectedInstOperands,
     /*  212749 */     // GIR_Coverage, 23402,
     /*  212749 */     GIR_EraseRootFromParent_Done,
     /*  212750 */   // Label 4278: @212750
     /*  212750 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(212804), // Rule ID 23403 //
     /*  212755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212787 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  212790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212802 */     GIR_RootConstrainSelectedInstOperands,
     /*  212803 */     // GIR_Coverage, 23403,
     /*  212803 */     GIR_EraseRootFromParent_Done,
     /*  212804 */   // Label 4279: @212804
     /*  212804 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(212858), // Rule ID 23406 //
     /*  212809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  212823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212841 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  212844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212856 */     GIR_RootConstrainSelectedInstOperands,
     /*  212857 */     // GIR_Coverage, 23406,
     /*  212857 */     GIR_EraseRootFromParent_Done,
     /*  212858 */   // Label 4280: @212858
     /*  212858 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(212912), // Rule ID 23407 //
     /*  212863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  212877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212895 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  212898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212910 */     GIR_RootConstrainSelectedInstOperands,
     /*  212911 */     // GIR_Coverage, 23407,
     /*  212911 */     GIR_EraseRootFromParent_Done,
     /*  212912 */   // Label 4281: @212912
     /*  212912 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(212966), // Rule ID 23410 //
     /*  212917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212949 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  212952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212964 */     GIR_RootConstrainSelectedInstOperands,
     /*  212965 */     // GIR_Coverage, 23410,
     /*  212965 */     GIR_EraseRootFromParent_Done,
     /*  212966 */   // Label 4282: @212966
     /*  212966 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(213020), // Rule ID 23411 //
     /*  212971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213003 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  213006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213018 */     GIR_RootConstrainSelectedInstOperands,
     /*  213019 */     // GIR_Coverage, 23411,
     /*  213019 */     GIR_EraseRootFromParent_Done,
     /*  213020 */   // Label 4283: @213020
     /*  213020 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(213074), // Rule ID 23414 //
     /*  213025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  213036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  213039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213057 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  213060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213072 */     GIR_RootConstrainSelectedInstOperands,
     /*  213073 */     // GIR_Coverage, 23414,
     /*  213073 */     GIR_EraseRootFromParent_Done,
     /*  213074 */   // Label 4284: @213074
     /*  213074 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(213128), // Rule ID 23415 //
     /*  213079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  213090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  213093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213111 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  213114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213126 */     GIR_RootConstrainSelectedInstOperands,
     /*  213127 */     // GIR_Coverage, 23415,
     /*  213127 */     GIR_EraseRootFromParent_Done,
     /*  213128 */   // Label 4285: @213128
     /*  213128 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(213182), // Rule ID 23418 //
     /*  213133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  213144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  213147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213165 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  213168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213180 */     GIR_RootConstrainSelectedInstOperands,
     /*  213181 */     // GIR_Coverage, 23418,
     /*  213181 */     GIR_EraseRootFromParent_Done,
     /*  213182 */   // Label 4286: @213182
     /*  213182 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(213236), // Rule ID 23419 //
     /*  213187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  213198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  213201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213219 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  213222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213234 */     GIR_RootConstrainSelectedInstOperands,
     /*  213235 */     // GIR_Coverage, 23419,
     /*  213235 */     GIR_EraseRootFromParent_Done,
     /*  213236 */   // Label 4287: @213236
     /*  213236 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(213290), // Rule ID 23422 //
     /*  213241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  213252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  213255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213273 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  213276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213288 */     GIR_RootConstrainSelectedInstOperands,
     /*  213289 */     // GIR_Coverage, 23422,
     /*  213289 */     GIR_EraseRootFromParent_Done,
     /*  213290 */   // Label 4288: @213290
     /*  213290 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(213344), // Rule ID 23423 //
     /*  213295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  213306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  213309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213327 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  213330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213342 */     GIR_RootConstrainSelectedInstOperands,
     /*  213343 */     // GIR_Coverage, 23423,
     /*  213343 */     GIR_EraseRootFromParent_Done,
     /*  213344 */   // Label 4289: @213344
     /*  213344 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(213398), // Rule ID 23426 //
     /*  213349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  213360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  213363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213381 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  213384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213396 */     GIR_RootConstrainSelectedInstOperands,
     /*  213397 */     // GIR_Coverage, 23426,
     /*  213397 */     GIR_EraseRootFromParent_Done,
     /*  213398 */   // Label 4290: @213398
     /*  213398 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(213452), // Rule ID 23427 //
     /*  213403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  213414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  213417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213435 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  213438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213450 */     GIR_RootConstrainSelectedInstOperands,
     /*  213451 */     // GIR_Coverage, 23427,
     /*  213451 */     GIR_EraseRootFromParent_Done,
     /*  213452 */   // Label 4291: @213452
     /*  213452 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(213506), // Rule ID 23430 //
     /*  213457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  213468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  213471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213489 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  213492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213504 */     GIR_RootConstrainSelectedInstOperands,
     /*  213505 */     // GIR_Coverage, 23430,
     /*  213505 */     GIR_EraseRootFromParent_Done,
     /*  213506 */   // Label 4292: @213506
     /*  213506 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(213560), // Rule ID 23431 //
     /*  213511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  213522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  213525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213543 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  213546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213558 */     GIR_RootConstrainSelectedInstOperands,
     /*  213559 */     // GIR_Coverage, 23431,
     /*  213559 */     GIR_EraseRootFromParent_Done,
     /*  213560 */   // Label 4293: @213560
     /*  213560 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(213617), // Rule ID 23518 //
     /*  213565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  213576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  213579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213597 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213615 */     GIR_RootConstrainSelectedInstOperands,
     /*  213616 */     // GIR_Coverage, 23518,
     /*  213616 */     GIR_EraseRootFromParent_Done,
     /*  213617 */   // Label 4294: @213617
     /*  213617 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(213674), // Rule ID 23519 //
     /*  213622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  213633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  213636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213654 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213672 */     GIR_RootConstrainSelectedInstOperands,
     /*  213673 */     // GIR_Coverage, 23519,
     /*  213673 */     GIR_EraseRootFromParent_Done,
     /*  213674 */   // Label 4295: @213674
     /*  213674 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(213731), // Rule ID 23522 //
     /*  213679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  213690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  213693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213711 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213729 */     GIR_RootConstrainSelectedInstOperands,
     /*  213730 */     // GIR_Coverage, 23522,
     /*  213730 */     GIR_EraseRootFromParent_Done,
     /*  213731 */   // Label 4296: @213731
     /*  213731 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(213788), // Rule ID 23523 //
     /*  213736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  213747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  213750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213768 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213786 */     GIR_RootConstrainSelectedInstOperands,
     /*  213787 */     // GIR_Coverage, 23523,
     /*  213787 */     GIR_EraseRootFromParent_Done,
     /*  213788 */   // Label 4297: @213788
     /*  213788 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(213845), // Rule ID 23526 //
     /*  213793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  213804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  213807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213825 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  213825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213843 */     GIR_RootConstrainSelectedInstOperands,
     /*  213844 */     // GIR_Coverage, 23526,
     /*  213844 */     GIR_EraseRootFromParent_Done,
     /*  213845 */   // Label 4298: @213845
     /*  213845 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(213902), // Rule ID 23527 //
     /*  213850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  213861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  213864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213882 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  213882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213900 */     GIR_RootConstrainSelectedInstOperands,
     /*  213901 */     // GIR_Coverage, 23527,
     /*  213901 */     GIR_EraseRootFromParent_Done,
     /*  213902 */   // Label 4299: @213902
     /*  213902 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(213959), // Rule ID 23530 //
     /*  213907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  213918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  213921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213939 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  213939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213957 */     GIR_RootConstrainSelectedInstOperands,
     /*  213958 */     // GIR_Coverage, 23530,
     /*  213958 */     GIR_EraseRootFromParent_Done,
     /*  213959 */   // Label 4300: @213959
     /*  213959 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(214016), // Rule ID 23531 //
     /*  213964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  213975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  213978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213996 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  213996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214014 */     GIR_RootConstrainSelectedInstOperands,
     /*  214015 */     // GIR_Coverage, 23531,
     /*  214015 */     GIR_EraseRootFromParent_Done,
     /*  214016 */   // Label 4301: @214016
     /*  214016 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(214073), // Rule ID 23534 //
     /*  214021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  214032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  214035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214053 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  214053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  214056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214071 */     GIR_RootConstrainSelectedInstOperands,
     /*  214072 */     // GIR_Coverage, 23534,
     /*  214072 */     GIR_EraseRootFromParent_Done,
     /*  214073 */   // Label 4302: @214073
     /*  214073 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(214130), // Rule ID 23535 //
     /*  214078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  214089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  214092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214110 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  214110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  214113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214128 */     GIR_RootConstrainSelectedInstOperands,
     /*  214129 */     // GIR_Coverage, 23535,
     /*  214129 */     GIR_EraseRootFromParent_Done,
     /*  214130 */   // Label 4303: @214130
     /*  214130 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(214187), // Rule ID 23538 //
     /*  214135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  214146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  214149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214167 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214185 */     GIR_RootConstrainSelectedInstOperands,
     /*  214186 */     // GIR_Coverage, 23538,
     /*  214186 */     GIR_EraseRootFromParent_Done,
     /*  214187 */   // Label 4304: @214187
     /*  214187 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(214244), // Rule ID 23539 //
     /*  214192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  214203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  214206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214242 */     GIR_RootConstrainSelectedInstOperands,
     /*  214243 */     // GIR_Coverage, 23539,
     /*  214243 */     GIR_EraseRootFromParent_Done,
     /*  214244 */   // Label 4305: @214244
     /*  214244 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(214301), // Rule ID 23542 //
     /*  214249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  214260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  214263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214281 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214299 */     GIR_RootConstrainSelectedInstOperands,
     /*  214300 */     // GIR_Coverage, 23542,
     /*  214300 */     GIR_EraseRootFromParent_Done,
     /*  214301 */   // Label 4306: @214301
     /*  214301 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(214358), // Rule ID 23543 //
     /*  214306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  214317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  214320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214338 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214356 */     GIR_RootConstrainSelectedInstOperands,
     /*  214357 */     // GIR_Coverage, 23543,
     /*  214357 */     GIR_EraseRootFromParent_Done,
     /*  214358 */   // Label 4307: @214358
     /*  214358 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(214415), // Rule ID 23546 //
     /*  214363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  214374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  214377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214395 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  214395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214413 */     GIR_RootConstrainSelectedInstOperands,
     /*  214414 */     // GIR_Coverage, 23546,
     /*  214414 */     GIR_EraseRootFromParent_Done,
     /*  214415 */   // Label 4308: @214415
     /*  214415 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(214472), // Rule ID 23547 //
     /*  214420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  214431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  214434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  214452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214470 */     GIR_RootConstrainSelectedInstOperands,
     /*  214471 */     // GIR_Coverage, 23547,
     /*  214471 */     GIR_EraseRootFromParent_Done,
     /*  214472 */   // Label 4309: @214472
     /*  214472 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(214529), // Rule ID 23550 //
     /*  214477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  214480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  214488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  214491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214509 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  214509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214527 */     GIR_RootConstrainSelectedInstOperands,
     /*  214528 */     // GIR_Coverage, 23550,
     /*  214528 */     GIR_EraseRootFromParent_Done,
     /*  214529 */   // Label 4310: @214529
     /*  214529 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(214586), // Rule ID 23551 //
     /*  214534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  214537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  214545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  214548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  214566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214584 */     GIR_RootConstrainSelectedInstOperands,
     /*  214585 */     // GIR_Coverage, 23551,
     /*  214585 */     GIR_EraseRootFromParent_Done,
     /*  214586 */   // Label 4311: @214586
     /*  214586 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(214643), // Rule ID 23554 //
     /*  214591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  214602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  214605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214623 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11376:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214641 */     GIR_RootConstrainSelectedInstOperands,
     /*  214642 */     // GIR_Coverage, 23554,
     /*  214642 */     GIR_EraseRootFromParent_Done,
     /*  214643 */   // Label 4312: @214643
     /*  214643 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(214700), // Rule ID 23555 //
     /*  214648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  214659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  214662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11376:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214698 */     GIR_RootConstrainSelectedInstOperands,
     /*  214699 */     // GIR_Coverage, 23555,
     /*  214699 */     GIR_EraseRootFromParent_Done,
     /*  214700 */   // Label 4313: @214700
     /*  214700 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(214757), // Rule ID 23558 //
     /*  214705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  214716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  214719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214737 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11376:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214755 */     GIR_RootConstrainSelectedInstOperands,
     /*  214756 */     // GIR_Coverage, 23558,
     /*  214756 */     GIR_EraseRootFromParent_Done,
     /*  214757 */   // Label 4314: @214757
     /*  214757 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(214814), // Rule ID 23559 //
     /*  214762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  214773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  214776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214794 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11376:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214812 */     GIR_RootConstrainSelectedInstOperands,
     /*  214813 */     // GIR_Coverage, 23559,
     /*  214813 */     GIR_EraseRootFromParent_Done,
     /*  214814 */   // Label 4315: @214814
     /*  214814 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(214871), // Rule ID 23562 //
     /*  214819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  214830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  214833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214851 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11376:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214869 */     GIR_RootConstrainSelectedInstOperands,
     /*  214870 */     // GIR_Coverage, 23562,
     /*  214870 */     GIR_EraseRootFromParent_Done,
     /*  214871 */   // Label 4316: @214871
     /*  214871 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(214928), // Rule ID 23563 //
     /*  214876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  214887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  214890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214908 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11376:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214926 */     GIR_RootConstrainSelectedInstOperands,
     /*  214927 */     // GIR_Coverage, 23563,
     /*  214927 */     GIR_EraseRootFromParent_Done,
     /*  214928 */   // Label 4317: @214928
     /*  214928 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(214985), // Rule ID 23566 //
     /*  214933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  214944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  214947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214965 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11376:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214983 */     GIR_RootConstrainSelectedInstOperands,
     /*  214984 */     // GIR_Coverage, 23566,
     /*  214984 */     GIR_EraseRootFromParent_Done,
     /*  214985 */   // Label 4318: @214985
     /*  214985 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(215042), // Rule ID 23567 //
     /*  214990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  215001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  215004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11376:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  215022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215040 */     GIR_RootConstrainSelectedInstOperands,
     /*  215041 */     // GIR_Coverage, 23567,
     /*  215041 */     GIR_EraseRootFromParent_Done,
     /*  215042 */   // Label 4319: @215042
     /*  215042 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(215099), // Rule ID 23570 //
     /*  215047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  215058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  215061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215079 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11376:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  215079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215097 */     GIR_RootConstrainSelectedInstOperands,
     /*  215098 */     // GIR_Coverage, 23570,
     /*  215098 */     GIR_EraseRootFromParent_Done,
     /*  215099 */   // Label 4320: @215099
     /*  215099 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(215156), // Rule ID 23571 //
     /*  215104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  215115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  215118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11376:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  215136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215154 */     GIR_RootConstrainSelectedInstOperands,
     /*  215155 */     // GIR_Coverage, 23571,
     /*  215155 */     GIR_EraseRootFromParent_Done,
     /*  215156 */   // Label 4321: @215156
     /*  215156 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(215213), // Rule ID 23574 //
     /*  215161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  215172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  215175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215193 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11376:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  215193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215211 */     GIR_RootConstrainSelectedInstOperands,
     /*  215212 */     // GIR_Coverage, 23574,
     /*  215212 */     GIR_EraseRootFromParent_Done,
     /*  215213 */   // Label 4322: @215213
     /*  215213 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(215270), // Rule ID 23575 //
     /*  215218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  215229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  215232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215250 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11376:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  215250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215268 */     GIR_RootConstrainSelectedInstOperands,
     /*  215269 */     // GIR_Coverage, 23575,
     /*  215269 */     GIR_EraseRootFromParent_Done,
     /*  215270 */   // Label 4323: @215270
     /*  215270 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(215327), // Rule ID 23578 //
     /*  215275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  215286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  215289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11376:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  215307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215325 */     GIR_RootConstrainSelectedInstOperands,
     /*  215326 */     // GIR_Coverage, 23578,
     /*  215326 */     GIR_EraseRootFromParent_Done,
     /*  215327 */   // Label 4324: @215327
     /*  215327 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(215384), // Rule ID 23579 //
     /*  215332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  215343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  215346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11376:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  215364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215382 */     GIR_RootConstrainSelectedInstOperands,
     /*  215383 */     // GIR_Coverage, 23579,
     /*  215383 */     GIR_EraseRootFromParent_Done,
     /*  215384 */   // Label 4325: @215384
     /*  215384 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(215441), // Rule ID 23582 //
     /*  215389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  215400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  215403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11376:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  215421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215439 */     GIR_RootConstrainSelectedInstOperands,
     /*  215440 */     // GIR_Coverage, 23582,
     /*  215440 */     GIR_EraseRootFromParent_Done,
     /*  215441 */   // Label 4326: @215441
     /*  215441 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(215498), // Rule ID 23583 //
     /*  215446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  215457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  215460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11376:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  215478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215496 */     GIR_RootConstrainSelectedInstOperands,
     /*  215497 */     // GIR_Coverage, 23583,
     /*  215497 */     GIR_EraseRootFromParent_Done,
     /*  215498 */   // Label 4327: @215498
     /*  215498 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(215555), // Rule ID 23586 //
     /*  215503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  215514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  215517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215535 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11376:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  215535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215553 */     GIR_RootConstrainSelectedInstOperands,
     /*  215554 */     // GIR_Coverage, 23586,
     /*  215554 */     GIR_EraseRootFromParent_Done,
     /*  215555 */   // Label 4328: @215555
     /*  215555 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(215612), // Rule ID 23587 //
     /*  215560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  215571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  215574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215592 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11376:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  215592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215610 */     GIR_RootConstrainSelectedInstOperands,
     /*  215611 */     // GIR_Coverage, 23587,
     /*  215611 */     GIR_EraseRootFromParent_Done,
     /*  215612 */   // Label 4329: @215612
     /*  215612 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(215669), // Rule ID 23590 //
     /*  215617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  215628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  215631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11376:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215667 */     GIR_RootConstrainSelectedInstOperands,
     /*  215668 */     // GIR_Coverage, 23590,
     /*  215668 */     GIR_EraseRootFromParent_Done,
     /*  215669 */   // Label 4330: @215669
     /*  215669 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(215726), // Rule ID 23591 //
     /*  215674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  215685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  215688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215706 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11376:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215724 */     GIR_RootConstrainSelectedInstOperands,
     /*  215725 */     // GIR_Coverage, 23591,
     /*  215725 */     GIR_EraseRootFromParent_Done,
     /*  215726 */   // Label 4331: @215726
     /*  215726 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(215783), // Rule ID 23594 //
     /*  215731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  215742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  215745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215763 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11376:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215781 */     GIR_RootConstrainSelectedInstOperands,
     /*  215782 */     // GIR_Coverage, 23594,
     /*  215782 */     GIR_EraseRootFromParent_Done,
     /*  215783 */   // Label 4332: @215783
     /*  215783 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(215840), // Rule ID 23595 //
     /*  215788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  215799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  215802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215820 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11376:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215838 */     GIR_RootConstrainSelectedInstOperands,
     /*  215839 */     // GIR_Coverage, 23595,
     /*  215839 */     GIR_EraseRootFromParent_Done,
     /*  215840 */   // Label 4333: @215840
     /*  215840 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(215897), // Rule ID 23598 //
     /*  215845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  215856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  215859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215877 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11376:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215895 */     GIR_RootConstrainSelectedInstOperands,
     /*  215896 */     // GIR_Coverage, 23598,
     /*  215896 */     GIR_EraseRootFromParent_Done,
     /*  215897 */   // Label 4334: @215897
     /*  215897 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(215954), // Rule ID 23599 //
     /*  215902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  215913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  215916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215934 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11376:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215952 */     GIR_RootConstrainSelectedInstOperands,
     /*  215953 */     // GIR_Coverage, 23599,
     /*  215953 */     GIR_EraseRootFromParent_Done,
     /*  215954 */   // Label 4335: @215954
     /*  215954 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(216000), // Rule ID 2665 //
     /*  215959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  215962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks1i),
     /*  215967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215981 */     // MIs[0] rnum
     /*  215981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  215984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_rnum),
     /*  215989 */     // (intrinsic_wo_chain:{ *:[i64] } 11016:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)  =>  (AES64KS1I:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)
     /*  215989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS1I),
     /*  215992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rnum
     /*  215998 */     GIR_RootConstrainSelectedInstOperands,
     /*  215999 */     // GIR_Coverage, 2665,
     /*  215999 */     GIR_EraseRootFromParent_Done,
     /*  216000 */   // Label 4336: @216000
     /*  216000 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(216045), // Rule ID 64462 //
     /*  216005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  216008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clip),
     /*  216013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216034 */     // (intrinsic_wo_chain:{ *:[i32] } 11026:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPR),
     /*  216037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216043 */     GIR_RootConstrainSelectedInstOperands,
     /*  216044 */     // GIR_Coverage, 64462,
     /*  216044 */     GIR_EraseRootFromParent_Done,
     /*  216045 */   // Label 4337: @216045
     /*  216045 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(216090), // Rule ID 64489 //
     /*  216050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  216053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clipu),
     /*  216058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216079 */     // (intrinsic_wo_chain:{ *:[i32] } 11027:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPUR),
     /*  216082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216088 */     GIR_RootConstrainSelectedInstOperands,
     /*  216089 */     // GIR_Coverage, 64489,
     /*  216089 */     GIR_EraseRootFromParent_Done,
     /*  216090 */   // Label 4338: @216090
     /*  216090 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(216135), // Rule ID 2655 //
     /*  216095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  216098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  216103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216124 */     // (intrinsic_wo_chain:{ *:[i64] } 11734:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM4:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  216127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216133 */     GIR_RootConstrainSelectedInstOperands,
     /*  216134 */     // GIR_Coverage, 2655,
     /*  216134 */     GIR_EraseRootFromParent_Done,
     /*  216135 */   // Label 4339: @216135
     /*  216135 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(216180), // Rule ID 2656 //
     /*  216140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  216143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  216148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216169 */     // (intrinsic_wo_chain:{ *:[i32] } 11734:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM4:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  216172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216178 */     GIR_RootConstrainSelectedInstOperands,
     /*  216179 */     // GIR_Coverage, 2656,
     /*  216179 */     GIR_EraseRootFromParent_Done,
     /*  216180 */   // Label 4340: @216180
     /*  216180 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(216225), // Rule ID 2657 //
     /*  216185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  216188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  216193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216214 */     // (intrinsic_wo_chain:{ *:[i64] } 11735:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM8:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  216217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216223 */     GIR_RootConstrainSelectedInstOperands,
     /*  216224 */     // GIR_Coverage, 2657,
     /*  216224 */     GIR_EraseRootFromParent_Done,
     /*  216225 */   // Label 4341: @216225
     /*  216225 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(216270), // Rule ID 2658 //
     /*  216230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  216233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  216238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216259 */     // (intrinsic_wo_chain:{ *:[i32] } 11735:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM8:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  216262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216268 */     GIR_RootConstrainSelectedInstOperands,
     /*  216269 */     // GIR_Coverage, 2658,
     /*  216269 */     GIR_EraseRootFromParent_Done,
     /*  216270 */   // Label 4342: @216270
     /*  216270 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(216315), // Rule ID 2661 //
     /*  216275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  216278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ds),
     /*  216283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216304 */     // (intrinsic_wo_chain:{ *:[i64] } 11011:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DS),
     /*  216307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216313 */     GIR_RootConstrainSelectedInstOperands,
     /*  216314 */     // GIR_Coverage, 2661,
     /*  216314 */     GIR_EraseRootFromParent_Done,
     /*  216315 */   // Label 4343: @216315
     /*  216315 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(216360), // Rule ID 2662 //
     /*  216320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  216323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64dsm),
     /*  216328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216349 */     // (intrinsic_wo_chain:{ *:[i64] } 11012:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DSM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DSM),
     /*  216352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216358 */     GIR_RootConstrainSelectedInstOperands,
     /*  216359 */     // GIR_Coverage, 2662,
     /*  216359 */     GIR_EraseRootFromParent_Done,
     /*  216360 */   // Label 4344: @216360
     /*  216360 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(216405), // Rule ID 2664 //
     /*  216365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  216368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks2),
     /*  216373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216394 */     // (intrinsic_wo_chain:{ *:[i64] } 11017:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64KS2:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS2),
     /*  216397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216403 */     GIR_RootConstrainSelectedInstOperands,
     /*  216404 */     // GIR_Coverage, 2664,
     /*  216404 */     GIR_EraseRootFromParent_Done,
     /*  216405 */   // Label 4345: @216405
     /*  216405 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(216450), // Rule ID 2668 //
     /*  216410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  216413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64es),
     /*  216418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216439 */     // (intrinsic_wo_chain:{ *:[i64] } 11013:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ES:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ES),
     /*  216442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216448 */     GIR_RootConstrainSelectedInstOperands,
     /*  216449 */     // GIR_Coverage, 2668,
     /*  216449 */     GIR_EraseRootFromParent_Done,
     /*  216450 */   // Label 4346: @216450
     /*  216450 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(216495), // Rule ID 2669 //
     /*  216455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  216458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64esm),
     /*  216463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216484 */     // (intrinsic_wo_chain:{ *:[i64] } 11014:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ESM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ESM),
     /*  216487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216493 */     GIR_RootConstrainSelectedInstOperands,
     /*  216494 */     // GIR_Coverage, 2669,
     /*  216494 */     GIR_EraseRootFromParent_Done,
     /*  216495 */   // Label 4347: @216495
     /*  216495 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(216540), // Rule ID 2678 //
     /*  216500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0l),
     /*  216508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216529 */     // (intrinsic_wo_chain:{ *:[i32] } 11170:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0L),
     /*  216532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216538 */     GIR_RootConstrainSelectedInstOperands,
     /*  216539 */     // GIR_Coverage, 2678,
     /*  216539 */     GIR_EraseRootFromParent_Done,
     /*  216540 */   // Label 4348: @216540
     /*  216540 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(216585), // Rule ID 2679 //
     /*  216545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0h),
     /*  216553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216574 */     // (intrinsic_wo_chain:{ *:[i32] } 11169:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0H),
     /*  216577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216583 */     GIR_RootConstrainSelectedInstOperands,
     /*  216584 */     // GIR_Coverage, 2679,
     /*  216584 */     GIR_EraseRootFromParent_Done,
     /*  216585 */   // Label 4349: @216585
     /*  216585 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(216630), // Rule ID 2680 //
     /*  216590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1l),
     /*  216598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216619 */     // (intrinsic_wo_chain:{ *:[i32] } 11173:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1L),
     /*  216622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216628 */     GIR_RootConstrainSelectedInstOperands,
     /*  216629 */     // GIR_Coverage, 2680,
     /*  216629 */     GIR_EraseRootFromParent_Done,
     /*  216630 */   // Label 4350: @216630
     /*  216630 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(216675), // Rule ID 2681 //
     /*  216635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1h),
     /*  216643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216664 */     // (intrinsic_wo_chain:{ *:[i32] } 11172:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1H),
     /*  216667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216673 */     GIR_RootConstrainSelectedInstOperands,
     /*  216674 */     // GIR_Coverage, 2681,
     /*  216674 */     GIR_EraseRootFromParent_Done,
     /*  216675 */   // Label 4351: @216675
     /*  216675 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(216720), // Rule ID 2682 //
     /*  216680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0r),
     /*  216688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216709 */     // (intrinsic_wo_chain:{ *:[i32] } 11175:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM0R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0R),
     /*  216712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216718 */     GIR_RootConstrainSelectedInstOperands,
     /*  216719 */     // GIR_Coverage, 2682,
     /*  216719 */     GIR_EraseRootFromParent_Done,
     /*  216720 */   // Label 4352: @216720
     /*  216720 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(216765), // Rule ID 2683 //
     /*  216725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1r),
     /*  216733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216754 */     // (intrinsic_wo_chain:{ *:[i32] } 11177:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM1R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1R),
     /*  216757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216763 */     GIR_RootConstrainSelectedInstOperands,
     /*  216764 */     // GIR_Coverage, 2683,
     /*  216764 */     GIR_EraseRootFromParent_Done,
     /*  216765 */   // Label 4353: @216765
     /*  216765 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(216810), // Rule ID 64439 //
     /*  216770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extract),
     /*  216778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216799 */     // (intrinsic_wo_chain:{ *:[i32] } 11036:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTR),
     /*  216802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216808 */     GIR_RootConstrainSelectedInstOperands,
     /*  216809 */     // GIR_Coverage, 64439,
     /*  216809 */     GIR_EraseRootFromParent_Done,
     /*  216810 */   // Label 4354: @216810
     /*  216810 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(216855), // Rule ID 64441 //
     /*  216815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extractu),
     /*  216823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216844 */     // (intrinsic_wo_chain:{ *:[i32] } 11037:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTUR),
     /*  216847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216853 */     GIR_RootConstrainSelectedInstOperands,
     /*  216854 */     // GIR_Coverage, 64441,
     /*  216854 */     GIR_EraseRootFromParent_Done,
     /*  216855 */   // Label 4355: @216855
     /*  216855 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(216900), // Rule ID 64443 //
     /*  216860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bclr),
     /*  216868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216889 */     // (intrinsic_wo_chain:{ *:[i32] } 11032:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BCLRR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BCLRR),
     /*  216892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216898 */     GIR_RootConstrainSelectedInstOperands,
     /*  216899 */     // GIR_Coverage, 64443,
     /*  216899 */     GIR_EraseRootFromParent_Done,
     /*  216900 */   // Label 4356: @216900
     /*  216900 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(216945), // Rule ID 64445 //
     /*  216905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bset),
     /*  216913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216934 */     // (intrinsic_wo_chain:{ *:[i32] } 11034:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BSETR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BSETR),
     /*  216937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216943 */     GIR_RootConstrainSelectedInstOperands,
     /*  216944 */     // GIR_Coverage, 64445,
     /*  216944 */     GIR_EraseRootFromParent_Done,
     /*  216945 */   // Label 4357: @216945
     /*  216945 */   GIM_Reject,
     /*  216946 */ // Label 4221: @216946
     /*  216946 */ GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(387851),
     /*  216951 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  216954 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(217028), // Rule ID 5476 //
     /*  216959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  216973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216999 */     // MIs[1] Operand 1
     /*  216999 */     // No operand predicates
     /*  216999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217008 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  217011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217026 */     GIR_RootConstrainSelectedInstOperands,
     /*  217027 */     // GIR_Coverage, 5476,
     /*  217027 */     GIR_EraseRootFromParent_Done,
     /*  217028 */   // Label 4359: @217028
     /*  217028 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(217102), // Rule ID 5477 //
     /*  217033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  217047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217073 */     // MIs[1] Operand 1
     /*  217073 */     // No operand predicates
     /*  217073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217082 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  217085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217100 */     GIR_RootConstrainSelectedInstOperands,
     /*  217101 */     // GIR_Coverage, 5477,
     /*  217101 */     GIR_EraseRootFromParent_Done,
     /*  217102 */   // Label 4360: @217102
     /*  217102 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(217176), // Rule ID 5478 //
     /*  217107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  217121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217147 */     // MIs[1] Operand 1
     /*  217147 */     // No operand predicates
     /*  217147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217156 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  217159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217174 */     GIR_RootConstrainSelectedInstOperands,
     /*  217175 */     // GIR_Coverage, 5478,
     /*  217175 */     GIR_EraseRootFromParent_Done,
     /*  217176 */   // Label 4361: @217176
     /*  217176 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(217250), // Rule ID 5479 //
     /*  217181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  217195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217221 */     // MIs[1] Operand 1
     /*  217221 */     // No operand predicates
     /*  217221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217230 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  217233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217248 */     GIR_RootConstrainSelectedInstOperands,
     /*  217249 */     // GIR_Coverage, 5479,
     /*  217249 */     GIR_EraseRootFromParent_Done,
     /*  217250 */   // Label 4362: @217250
     /*  217250 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(217324), // Rule ID 5480 //
     /*  217255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  217266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  217269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217295 */     // MIs[1] Operand 1
     /*  217295 */     // No operand predicates
     /*  217295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217304 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217322 */     GIR_RootConstrainSelectedInstOperands,
     /*  217323 */     // GIR_Coverage, 5480,
     /*  217323 */     GIR_EraseRootFromParent_Done,
     /*  217324 */   // Label 4363: @217324
     /*  217324 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(217398), // Rule ID 5481 //
     /*  217329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  217340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  217343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217369 */     // MIs[1] Operand 1
     /*  217369 */     // No operand predicates
     /*  217369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217378 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217396 */     GIR_RootConstrainSelectedInstOperands,
     /*  217397 */     // GIR_Coverage, 5481,
     /*  217397 */     GIR_EraseRootFromParent_Done,
     /*  217398 */   // Label 4364: @217398
     /*  217398 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(217472), // Rule ID 5482 //
     /*  217403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  217417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217443 */     // MIs[1] Operand 1
     /*  217443 */     // No operand predicates
     /*  217443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217452 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  217452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  217455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217470 */     GIR_RootConstrainSelectedInstOperands,
     /*  217471 */     // GIR_Coverage, 5482,
     /*  217471 */     GIR_EraseRootFromParent_Done,
     /*  217472 */   // Label 4365: @217472
     /*  217472 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(217546), // Rule ID 5483 //
     /*  217477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  217491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217517 */     // MIs[1] Operand 1
     /*  217517 */     // No operand predicates
     /*  217517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217526 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  217526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  217529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217544 */     GIR_RootConstrainSelectedInstOperands,
     /*  217545 */     // GIR_Coverage, 5483,
     /*  217545 */     GIR_EraseRootFromParent_Done,
     /*  217546 */   // Label 4366: @217546
     /*  217546 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(217620), // Rule ID 5484 //
     /*  217551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217591 */     // MIs[1] Operand 1
     /*  217591 */     // No operand predicates
     /*  217591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217600 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  217600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217618 */     GIR_RootConstrainSelectedInstOperands,
     /*  217619 */     // GIR_Coverage, 5484,
     /*  217619 */     GIR_EraseRootFromParent_Done,
     /*  217620 */   // Label 4367: @217620
     /*  217620 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(217694), // Rule ID 5485 //
     /*  217625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217665 */     // MIs[1] Operand 1
     /*  217665 */     // No operand predicates
     /*  217665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217674 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  217674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217692 */     GIR_RootConstrainSelectedInstOperands,
     /*  217693 */     // GIR_Coverage, 5485,
     /*  217693 */     GIR_EraseRootFromParent_Done,
     /*  217694 */   // Label 4368: @217694
     /*  217694 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(217768), // Rule ID 5486 //
     /*  217699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217739 */     // MIs[1] Operand 1
     /*  217739 */     // No operand predicates
     /*  217739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217748 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  217748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217766 */     GIR_RootConstrainSelectedInstOperands,
     /*  217767 */     // GIR_Coverage, 5486,
     /*  217767 */     GIR_EraseRootFromParent_Done,
     /*  217768 */   // Label 4369: @217768
     /*  217768 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(217842), // Rule ID 5487 //
     /*  217773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217813 */     // MIs[1] Operand 1
     /*  217813 */     // No operand predicates
     /*  217813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217822 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  217822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217840 */     GIR_RootConstrainSelectedInstOperands,
     /*  217841 */     // GIR_Coverage, 5487,
     /*  217841 */     GIR_EraseRootFromParent_Done,
     /*  217842 */   // Label 4370: @217842
     /*  217842 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(217916), // Rule ID 5488 //
     /*  217847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  217858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  217861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217887 */     // MIs[1] Operand 1
     /*  217887 */     // No operand predicates
     /*  217887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217914 */     GIR_RootConstrainSelectedInstOperands,
     /*  217915 */     // GIR_Coverage, 5488,
     /*  217915 */     GIR_EraseRootFromParent_Done,
     /*  217916 */   // Label 4371: @217916
     /*  217916 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(217990), // Rule ID 5489 //
     /*  217921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  217932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  217935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217961 */     // MIs[1] Operand 1
     /*  217961 */     // No operand predicates
     /*  217961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217970 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217988 */     GIR_RootConstrainSelectedInstOperands,
     /*  217989 */     // GIR_Coverage, 5489,
     /*  217989 */     GIR_EraseRootFromParent_Done,
     /*  217990 */   // Label 4372: @217990
     /*  217990 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(218064), // Rule ID 5490 //
     /*  217995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  218006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  218009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218035 */     // MIs[1] Operand 1
     /*  218035 */     // No operand predicates
     /*  218035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218044 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  218044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  218047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218062 */     GIR_RootConstrainSelectedInstOperands,
     /*  218063 */     // GIR_Coverage, 5490,
     /*  218063 */     GIR_EraseRootFromParent_Done,
     /*  218064 */   // Label 4373: @218064
     /*  218064 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(218138), // Rule ID 5491 //
     /*  218069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  218080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  218083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218109 */     // MIs[1] Operand 1
     /*  218109 */     // No operand predicates
     /*  218109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218118 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  218118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  218121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218136 */     GIR_RootConstrainSelectedInstOperands,
     /*  218137 */     // GIR_Coverage, 5491,
     /*  218137 */     GIR_EraseRootFromParent_Done,
     /*  218138 */   // Label 4374: @218138
     /*  218138 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(218212), // Rule ID 5492 //
     /*  218143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  218154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  218157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218183 */     // MIs[1] Operand 1
     /*  218183 */     // No operand predicates
     /*  218183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218192 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  218192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  218195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218210 */     GIR_RootConstrainSelectedInstOperands,
     /*  218211 */     // GIR_Coverage, 5492,
     /*  218211 */     GIR_EraseRootFromParent_Done,
     /*  218212 */   // Label 4375: @218212
     /*  218212 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(218286), // Rule ID 5493 //
     /*  218217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  218228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  218231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218257 */     // MIs[1] Operand 1
     /*  218257 */     // No operand predicates
     /*  218257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218266 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  218266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  218269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218284 */     GIR_RootConstrainSelectedInstOperands,
     /*  218285 */     // GIR_Coverage, 5493,
     /*  218285 */     GIR_EraseRootFromParent_Done,
     /*  218286 */   // Label 4376: @218286
     /*  218286 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(218360), // Rule ID 5494 //
     /*  218291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  218294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  218302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  218305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218331 */     // MIs[1] Operand 1
     /*  218331 */     // No operand predicates
     /*  218331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218340 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  218340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  218343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  218358 */     GIR_RootConstrainSelectedInstOperands,
     /*  218359 */     // GIR_Coverage, 5494,
     /*  218359 */     GIR_EraseRootFromParent_Done,
     /*  218360 */   // Label 4377: @218360
     /*  218360 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(218434), // Rule ID 5495 //
     /*  218365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  218368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  218376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  218379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218405 */     // MIs[1] Operand 1
     /*  218405 */     // No operand predicates
     /*  218405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218414 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  218414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  218417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  218432 */     GIR_RootConstrainSelectedInstOperands,
     /*  218433 */     // GIR_Coverage, 5495,
     /*  218433 */     GIR_EraseRootFromParent_Done,
     /*  218434 */   // Label 4378: @218434
     /*  218434 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(218508), // Rule ID 5496 //
     /*  218439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  218453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218479 */     // MIs[1] Operand 1
     /*  218479 */     // No operand predicates
     /*  218479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218488 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  218488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218506 */     GIR_RootConstrainSelectedInstOperands,
     /*  218507 */     // GIR_Coverage, 5496,
     /*  218507 */     GIR_EraseRootFromParent_Done,
     /*  218508 */   // Label 4379: @218508
     /*  218508 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(218582), // Rule ID 5497 //
     /*  218513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  218527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218553 */     // MIs[1] Operand 1
     /*  218553 */     // No operand predicates
     /*  218553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218562 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  218562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218580 */     GIR_RootConstrainSelectedInstOperands,
     /*  218581 */     // GIR_Coverage, 5497,
     /*  218581 */     GIR_EraseRootFromParent_Done,
     /*  218582 */   // Label 4380: @218582
     /*  218582 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(218656), // Rule ID 5498 //
     /*  218587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  218601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218627 */     // MIs[1] Operand 1
     /*  218627 */     // No operand predicates
     /*  218627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218636 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  218636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218654 */     GIR_RootConstrainSelectedInstOperands,
     /*  218655 */     // GIR_Coverage, 5498,
     /*  218655 */     GIR_EraseRootFromParent_Done,
     /*  218656 */   // Label 4381: @218656
     /*  218656 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(218730), // Rule ID 5499 //
     /*  218661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  218675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218701 */     // MIs[1] Operand 1
     /*  218701 */     // No operand predicates
     /*  218701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218710 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  218710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218728 */     GIR_RootConstrainSelectedInstOperands,
     /*  218729 */     // GIR_Coverage, 5499,
     /*  218729 */     GIR_EraseRootFromParent_Done,
     /*  218730 */   // Label 4382: @218730
     /*  218730 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(218804), // Rule ID 5500 //
     /*  218735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  218746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  218749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218775 */     // MIs[1] Operand 1
     /*  218775 */     // No operand predicates
     /*  218775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218784 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  218784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218802 */     GIR_RootConstrainSelectedInstOperands,
     /*  218803 */     // GIR_Coverage, 5500,
     /*  218803 */     GIR_EraseRootFromParent_Done,
     /*  218804 */   // Label 4383: @218804
     /*  218804 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(218878), // Rule ID 5501 //
     /*  218809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  218820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  218823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218849 */     // MIs[1] Operand 1
     /*  218849 */     // No operand predicates
     /*  218849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218858 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  218858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218876 */     GIR_RootConstrainSelectedInstOperands,
     /*  218877 */     // GIR_Coverage, 5501,
     /*  218877 */     GIR_EraseRootFromParent_Done,
     /*  218878 */   // Label 4384: @218878
     /*  218878 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(218952), // Rule ID 5502 //
     /*  218883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  218894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  218897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218923 */     // MIs[1] Operand 1
     /*  218923 */     // No operand predicates
     /*  218923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218932 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  218932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218950 */     GIR_RootConstrainSelectedInstOperands,
     /*  218951 */     // GIR_Coverage, 5502,
     /*  218951 */     GIR_EraseRootFromParent_Done,
     /*  218952 */   // Label 4385: @218952
     /*  218952 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(219026), // Rule ID 5503 //
     /*  218957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  218968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  218971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218997 */     // MIs[1] Operand 1
     /*  218997 */     // No operand predicates
     /*  218997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219006 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  219006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219024 */     GIR_RootConstrainSelectedInstOperands,
     /*  219025 */     // GIR_Coverage, 5503,
     /*  219025 */     GIR_EraseRootFromParent_Done,
     /*  219026 */   // Label 4386: @219026
     /*  219026 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(219100), // Rule ID 5504 //
     /*  219031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  219042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  219045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219071 */     // MIs[1] Operand 1
     /*  219071 */     // No operand predicates
     /*  219071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219080 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  219080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219098 */     GIR_RootConstrainSelectedInstOperands,
     /*  219099 */     // GIR_Coverage, 5504,
     /*  219099 */     GIR_EraseRootFromParent_Done,
     /*  219100 */   // Label 4387: @219100
     /*  219100 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(219174), // Rule ID 5505 //
     /*  219105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  219116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  219119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219145 */     // MIs[1] Operand 1
     /*  219145 */     // No operand predicates
     /*  219145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219154 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  219154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219172 */     GIR_RootConstrainSelectedInstOperands,
     /*  219173 */     // GIR_Coverage, 5505,
     /*  219173 */     GIR_EraseRootFromParent_Done,
     /*  219174 */   // Label 4388: @219174
     /*  219174 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(219248), // Rule ID 5506 //
     /*  219179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  219190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  219193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219219 */     // MIs[1] Operand 1
     /*  219219 */     // No operand predicates
     /*  219219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219228 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  219228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219246 */     GIR_RootConstrainSelectedInstOperands,
     /*  219247 */     // GIR_Coverage, 5506,
     /*  219247 */     GIR_EraseRootFromParent_Done,
     /*  219248 */   // Label 4389: @219248
     /*  219248 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(219322), // Rule ID 5507 //
     /*  219253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  219264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  219267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219293 */     // MIs[1] Operand 1
     /*  219293 */     // No operand predicates
     /*  219293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219302 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  219302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219320 */     GIR_RootConstrainSelectedInstOperands,
     /*  219321 */     // GIR_Coverage, 5507,
     /*  219321 */     GIR_EraseRootFromParent_Done,
     /*  219322 */   // Label 4390: @219322
     /*  219322 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(219396), // Rule ID 5508 //
     /*  219327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  219341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219367 */     // MIs[1] Operand 1
     /*  219367 */     // No operand predicates
     /*  219367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219376 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  219376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219394 */     GIR_RootConstrainSelectedInstOperands,
     /*  219395 */     // GIR_Coverage, 5508,
     /*  219395 */     GIR_EraseRootFromParent_Done,
     /*  219396 */   // Label 4391: @219396
     /*  219396 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(219470), // Rule ID 5509 //
     /*  219401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  219415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219441 */     // MIs[1] Operand 1
     /*  219441 */     // No operand predicates
     /*  219441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219450 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  219450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219468 */     GIR_RootConstrainSelectedInstOperands,
     /*  219469 */     // GIR_Coverage, 5509,
     /*  219469 */     GIR_EraseRootFromParent_Done,
     /*  219470 */   // Label 4392: @219470
     /*  219470 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(219544), // Rule ID 5510 //
     /*  219475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  219489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219515 */     // MIs[1] Operand 1
     /*  219515 */     // No operand predicates
     /*  219515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219524 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  219524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219542 */     GIR_RootConstrainSelectedInstOperands,
     /*  219543 */     // GIR_Coverage, 5510,
     /*  219543 */     GIR_EraseRootFromParent_Done,
     /*  219544 */   // Label 4393: @219544
     /*  219544 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(219618), // Rule ID 5511 //
     /*  219549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  219563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219589 */     // MIs[1] Operand 1
     /*  219589 */     // No operand predicates
     /*  219589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219598 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  219598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219616 */     GIR_RootConstrainSelectedInstOperands,
     /*  219617 */     // GIR_Coverage, 5511,
     /*  219617 */     GIR_EraseRootFromParent_Done,
     /*  219618 */   // Label 4394: @219618
     /*  219618 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(219692), // Rule ID 5512 //
     /*  219623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  219634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  219637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219663 */     // MIs[1] Operand 1
     /*  219663 */     // No operand predicates
     /*  219663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219672 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  219672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219690 */     GIR_RootConstrainSelectedInstOperands,
     /*  219691 */     // GIR_Coverage, 5512,
     /*  219691 */     GIR_EraseRootFromParent_Done,
     /*  219692 */   // Label 4395: @219692
     /*  219692 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(219766), // Rule ID 5513 //
     /*  219697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  219708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  219711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219737 */     // MIs[1] Operand 1
     /*  219737 */     // No operand predicates
     /*  219737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219746 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  219746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219764 */     GIR_RootConstrainSelectedInstOperands,
     /*  219765 */     // GIR_Coverage, 5513,
     /*  219765 */     GIR_EraseRootFromParent_Done,
     /*  219766 */   // Label 4396: @219766
     /*  219766 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(219840), // Rule ID 5514 //
     /*  219771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  219785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219811 */     // MIs[1] Operand 1
     /*  219811 */     // No operand predicates
     /*  219811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219820 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  219820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219838 */     GIR_RootConstrainSelectedInstOperands,
     /*  219839 */     // GIR_Coverage, 5514,
     /*  219839 */     GIR_EraseRootFromParent_Done,
     /*  219840 */   // Label 4397: @219840
     /*  219840 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(219914), // Rule ID 5515 //
     /*  219845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  219859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219885 */     // MIs[1] Operand 1
     /*  219885 */     // No operand predicates
     /*  219885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219894 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  219894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219912 */     GIR_RootConstrainSelectedInstOperands,
     /*  219913 */     // GIR_Coverage, 5515,
     /*  219913 */     GIR_EraseRootFromParent_Done,
     /*  219914 */   // Label 4398: @219914
     /*  219914 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(219988), // Rule ID 5516 //
     /*  219919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  219933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219959 */     // MIs[1] Operand 1
     /*  219959 */     // No operand predicates
     /*  219959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219968 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  219968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219986 */     GIR_RootConstrainSelectedInstOperands,
     /*  219987 */     // GIR_Coverage, 5516,
     /*  219987 */     GIR_EraseRootFromParent_Done,
     /*  219988 */   // Label 4399: @219988
     /*  219988 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(220062), // Rule ID 5517 //
     /*  219993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  220007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220033 */     // MIs[1] Operand 1
     /*  220033 */     // No operand predicates
     /*  220033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220042 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  220042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  220045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220060 */     GIR_RootConstrainSelectedInstOperands,
     /*  220061 */     // GIR_Coverage, 5517,
     /*  220061 */     GIR_EraseRootFromParent_Done,
     /*  220062 */   // Label 4400: @220062
     /*  220062 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(220136), // Rule ID 5518 //
     /*  220067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  220070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  220078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  220081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220107 */     // MIs[1] Operand 1
     /*  220107 */     // No operand predicates
     /*  220107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220116 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  220116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  220119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220134 */     GIR_RootConstrainSelectedInstOperands,
     /*  220135 */     // GIR_Coverage, 5518,
     /*  220135 */     GIR_EraseRootFromParent_Done,
     /*  220136 */   // Label 4401: @220136
     /*  220136 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(220210), // Rule ID 5519 //
     /*  220141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  220144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  220152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  220155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220181 */     // MIs[1] Operand 1
     /*  220181 */     // No operand predicates
     /*  220181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220190 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  220190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  220193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220208 */     GIR_RootConstrainSelectedInstOperands,
     /*  220209 */     // GIR_Coverage, 5519,
     /*  220209 */     GIR_EraseRootFromParent_Done,
     /*  220210 */   // Label 4402: @220210
     /*  220210 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(220284), // Rule ID 7988 //
     /*  220215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  220229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220255 */     // MIs[1] Operand 1
     /*  220255 */     // No operand predicates
     /*  220255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220264 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  220267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220282 */     GIR_RootConstrainSelectedInstOperands,
     /*  220283 */     // GIR_Coverage, 7988,
     /*  220283 */     GIR_EraseRootFromParent_Done,
     /*  220284 */   // Label 4403: @220284
     /*  220284 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(220358), // Rule ID 7989 //
     /*  220289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  220303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220329 */     // MIs[1] Operand 1
     /*  220329 */     // No operand predicates
     /*  220329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220338 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  220341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220356 */     GIR_RootConstrainSelectedInstOperands,
     /*  220357 */     // GIR_Coverage, 7989,
     /*  220357 */     GIR_EraseRootFromParent_Done,
     /*  220358 */   // Label 4404: @220358
     /*  220358 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(220432), // Rule ID 7992 //
     /*  220363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  220377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220403 */     // MIs[1] Operand 1
     /*  220403 */     // No operand predicates
     /*  220403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220412 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220430 */     GIR_RootConstrainSelectedInstOperands,
     /*  220431 */     // GIR_Coverage, 7992,
     /*  220431 */     GIR_EraseRootFromParent_Done,
     /*  220432 */   // Label 4405: @220432
     /*  220432 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(220506), // Rule ID 7993 //
     /*  220437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  220451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220477 */     // MIs[1] Operand 1
     /*  220477 */     // No operand predicates
     /*  220477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220486 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220504 */     GIR_RootConstrainSelectedInstOperands,
     /*  220505 */     // GIR_Coverage, 7993,
     /*  220505 */     GIR_EraseRootFromParent_Done,
     /*  220506 */   // Label 4406: @220506
     /*  220506 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(220580), // Rule ID 7996 //
     /*  220511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  220525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220551 */     // MIs[1] Operand 1
     /*  220551 */     // No operand predicates
     /*  220551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220560 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220578 */     GIR_RootConstrainSelectedInstOperands,
     /*  220579 */     // GIR_Coverage, 7996,
     /*  220579 */     GIR_EraseRootFromParent_Done,
     /*  220580 */   // Label 4407: @220580
     /*  220580 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(220654), // Rule ID 7997 //
     /*  220585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  220599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220625 */     // MIs[1] Operand 1
     /*  220625 */     // No operand predicates
     /*  220625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220634 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220652 */     GIR_RootConstrainSelectedInstOperands,
     /*  220653 */     // GIR_Coverage, 7997,
     /*  220653 */     GIR_EraseRootFromParent_Done,
     /*  220654 */   // Label 4408: @220654
     /*  220654 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(220728), // Rule ID 8000 //
     /*  220659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220699 */     // MIs[1] Operand 1
     /*  220699 */     // No operand predicates
     /*  220699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220726 */     GIR_RootConstrainSelectedInstOperands,
     /*  220727 */     // GIR_Coverage, 8000,
     /*  220727 */     GIR_EraseRootFromParent_Done,
     /*  220728 */   // Label 4409: @220728
     /*  220728 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(220802), // Rule ID 8001 //
     /*  220733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220773 */     // MIs[1] Operand 1
     /*  220773 */     // No operand predicates
     /*  220773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220782 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220800 */     GIR_RootConstrainSelectedInstOperands,
     /*  220801 */     // GIR_Coverage, 8001,
     /*  220801 */     GIR_EraseRootFromParent_Done,
     /*  220802 */   // Label 4410: @220802
     /*  220802 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(220876), // Rule ID 8004 //
     /*  220807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  220821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220847 */     // MIs[1] Operand 1
     /*  220847 */     // No operand predicates
     /*  220847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220856 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220874 */     GIR_RootConstrainSelectedInstOperands,
     /*  220875 */     // GIR_Coverage, 8004,
     /*  220875 */     GIR_EraseRootFromParent_Done,
     /*  220876 */   // Label 4411: @220876
     /*  220876 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(220950), // Rule ID 8005 //
     /*  220881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  220895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220921 */     // MIs[1] Operand 1
     /*  220921 */     // No operand predicates
     /*  220921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220930 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220948 */     GIR_RootConstrainSelectedInstOperands,
     /*  220949 */     // GIR_Coverage, 8005,
     /*  220949 */     GIR_EraseRootFromParent_Done,
     /*  220950 */   // Label 4412: @220950
     /*  220950 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(221024), // Rule ID 8008 //
     /*  220955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  220969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220995 */     // MIs[1] Operand 1
     /*  220995 */     // No operand predicates
     /*  220995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221004 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  221007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221022 */     GIR_RootConstrainSelectedInstOperands,
     /*  221023 */     // GIR_Coverage, 8008,
     /*  221023 */     GIR_EraseRootFromParent_Done,
     /*  221024 */   // Label 4413: @221024
     /*  221024 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(221098), // Rule ID 8009 //
     /*  221029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  221043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221069 */     // MIs[1] Operand 1
     /*  221069 */     // No operand predicates
     /*  221069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221078 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  221081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221096 */     GIR_RootConstrainSelectedInstOperands,
     /*  221097 */     // GIR_Coverage, 8009,
     /*  221097 */     GIR_EraseRootFromParent_Done,
     /*  221098 */   // Label 4414: @221098
     /*  221098 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(221172), // Rule ID 8012 //
     /*  221103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  221117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221143 */     // MIs[1] Operand 1
     /*  221143 */     // No operand predicates
     /*  221143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221152 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221170 */     GIR_RootConstrainSelectedInstOperands,
     /*  221171 */     // GIR_Coverage, 8012,
     /*  221171 */     GIR_EraseRootFromParent_Done,
     /*  221172 */   // Label 4415: @221172
     /*  221172 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(221246), // Rule ID 8013 //
     /*  221177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  221191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221217 */     // MIs[1] Operand 1
     /*  221217 */     // No operand predicates
     /*  221217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221226 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221244 */     GIR_RootConstrainSelectedInstOperands,
     /*  221245 */     // GIR_Coverage, 8013,
     /*  221245 */     GIR_EraseRootFromParent_Done,
     /*  221246 */   // Label 4416: @221246
     /*  221246 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(221320), // Rule ID 8016 //
     /*  221251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  221265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221291 */     // MIs[1] Operand 1
     /*  221291 */     // No operand predicates
     /*  221291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221300 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221318 */     GIR_RootConstrainSelectedInstOperands,
     /*  221319 */     // GIR_Coverage, 8016,
     /*  221319 */     GIR_EraseRootFromParent_Done,
     /*  221320 */   // Label 4417: @221320
     /*  221320 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(221394), // Rule ID 8017 //
     /*  221325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  221339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221365 */     // MIs[1] Operand 1
     /*  221365 */     // No operand predicates
     /*  221365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221374 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221392 */     GIR_RootConstrainSelectedInstOperands,
     /*  221393 */     // GIR_Coverage, 8017,
     /*  221393 */     GIR_EraseRootFromParent_Done,
     /*  221394 */   // Label 4418: @221394
     /*  221394 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(221468), // Rule ID 8020 //
     /*  221399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  221413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221439 */     // MIs[1] Operand 1
     /*  221439 */     // No operand predicates
     /*  221439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221448 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221466 */     GIR_RootConstrainSelectedInstOperands,
     /*  221467 */     // GIR_Coverage, 8020,
     /*  221467 */     GIR_EraseRootFromParent_Done,
     /*  221468 */   // Label 4419: @221468
     /*  221468 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(221542), // Rule ID 8021 //
     /*  221473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  221487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221513 */     // MIs[1] Operand 1
     /*  221513 */     // No operand predicates
     /*  221513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221522 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221540 */     GIR_RootConstrainSelectedInstOperands,
     /*  221541 */     // GIR_Coverage, 8021,
     /*  221541 */     GIR_EraseRootFromParent_Done,
     /*  221542 */   // Label 4420: @221542
     /*  221542 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(221616), // Rule ID 8024 //
     /*  221547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  221550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221587 */     // MIs[1] Operand 1
     /*  221587 */     // No operand predicates
     /*  221587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221596 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  221596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221614 */     GIR_RootConstrainSelectedInstOperands,
     /*  221615 */     // GIR_Coverage, 8024,
     /*  221615 */     GIR_EraseRootFromParent_Done,
     /*  221616 */   // Label 4421: @221616
     /*  221616 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(221690), // Rule ID 8025 //
     /*  221621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  221624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221661 */     // MIs[1] Operand 1
     /*  221661 */     // No operand predicates
     /*  221661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221670 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  221670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221688 */     GIR_RootConstrainSelectedInstOperands,
     /*  221689 */     // GIR_Coverage, 8025,
     /*  221689 */     GIR_EraseRootFromParent_Done,
     /*  221690 */   // Label 4422: @221690
     /*  221690 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(221764), // Rule ID 8028 //
     /*  221695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  221709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221735 */     // MIs[1] Operand 1
     /*  221735 */     // No operand predicates
     /*  221735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221744 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221762 */     GIR_RootConstrainSelectedInstOperands,
     /*  221763 */     // GIR_Coverage, 8028,
     /*  221763 */     GIR_EraseRootFromParent_Done,
     /*  221764 */   // Label 4423: @221764
     /*  221764 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(221838), // Rule ID 8029 //
     /*  221769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  221783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221809 */     // MIs[1] Operand 1
     /*  221809 */     // No operand predicates
     /*  221809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221818 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221836 */     GIR_RootConstrainSelectedInstOperands,
     /*  221837 */     // GIR_Coverage, 8029,
     /*  221837 */     GIR_EraseRootFromParent_Done,
     /*  221838 */   // Label 4424: @221838
     /*  221838 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(221912), // Rule ID 8032 //
     /*  221843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  221857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221883 */     // MIs[1] Operand 1
     /*  221883 */     // No operand predicates
     /*  221883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221892 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221910 */     GIR_RootConstrainSelectedInstOperands,
     /*  221911 */     // GIR_Coverage, 8032,
     /*  221911 */     GIR_EraseRootFromParent_Done,
     /*  221912 */   // Label 4425: @221912
     /*  221912 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(221986), // Rule ID 8033 //
     /*  221917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  221931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221957 */     // MIs[1] Operand 1
     /*  221957 */     // No operand predicates
     /*  221957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221966 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221984 */     GIR_RootConstrainSelectedInstOperands,
     /*  221985 */     // GIR_Coverage, 8033,
     /*  221985 */     GIR_EraseRootFromParent_Done,
     /*  221986 */   // Label 4426: @221986
     /*  221986 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(222060), // Rule ID 8036 //
     /*  221991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  222002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  222005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222031 */     // MIs[1] Operand 1
     /*  222031 */     // No operand predicates
     /*  222031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222040 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  222040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222058 */     GIR_RootConstrainSelectedInstOperands,
     /*  222059 */     // GIR_Coverage, 8036,
     /*  222059 */     GIR_EraseRootFromParent_Done,
     /*  222060 */   // Label 4427: @222060
     /*  222060 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(222134), // Rule ID 8037 //
     /*  222065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  222076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  222079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222105 */     // MIs[1] Operand 1
     /*  222105 */     // No operand predicates
     /*  222105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222114 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  222114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222132 */     GIR_RootConstrainSelectedInstOperands,
     /*  222133 */     // GIR_Coverage, 8037,
     /*  222133 */     GIR_EraseRootFromParent_Done,
     /*  222134 */   // Label 4428: @222134
     /*  222134 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(222208), // Rule ID 8040 //
     /*  222139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  222153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222179 */     // MIs[1] Operand 1
     /*  222179 */     // No operand predicates
     /*  222179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222188 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222206 */     GIR_RootConstrainSelectedInstOperands,
     /*  222207 */     // GIR_Coverage, 8040,
     /*  222207 */     GIR_EraseRootFromParent_Done,
     /*  222208 */   // Label 4429: @222208
     /*  222208 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(222282), // Rule ID 8041 //
     /*  222213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  222227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222253 */     // MIs[1] Operand 1
     /*  222253 */     // No operand predicates
     /*  222253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222262 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222280 */     GIR_RootConstrainSelectedInstOperands,
     /*  222281 */     // GIR_Coverage, 8041,
     /*  222281 */     GIR_EraseRootFromParent_Done,
     /*  222282 */   // Label 4430: @222282
     /*  222282 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(222356), // Rule ID 8044 //
     /*  222287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  222301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222327 */     // MIs[1] Operand 1
     /*  222327 */     // No operand predicates
     /*  222327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222336 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222354 */     GIR_RootConstrainSelectedInstOperands,
     /*  222355 */     // GIR_Coverage, 8044,
     /*  222355 */     GIR_EraseRootFromParent_Done,
     /*  222356 */   // Label 4431: @222356
     /*  222356 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(222430), // Rule ID 8045 //
     /*  222361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  222375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222401 */     // MIs[1] Operand 1
     /*  222401 */     // No operand predicates
     /*  222401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222410 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222428 */     GIR_RootConstrainSelectedInstOperands,
     /*  222429 */     // GIR_Coverage, 8045,
     /*  222429 */     GIR_EraseRootFromParent_Done,
     /*  222430 */   // Label 4432: @222430
     /*  222430 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(222504), // Rule ID 8048 //
     /*  222435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  222446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  222449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222475 */     // MIs[1] Operand 1
     /*  222475 */     // No operand predicates
     /*  222475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222484 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222502 */     GIR_RootConstrainSelectedInstOperands,
     /*  222503 */     // GIR_Coverage, 8048,
     /*  222503 */     GIR_EraseRootFromParent_Done,
     /*  222504 */   // Label 4433: @222504
     /*  222504 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(222578), // Rule ID 8049 //
     /*  222509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  222520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  222523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222549 */     // MIs[1] Operand 1
     /*  222549 */     // No operand predicates
     /*  222549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222558 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222576 */     GIR_RootConstrainSelectedInstOperands,
     /*  222577 */     // GIR_Coverage, 8049,
     /*  222577 */     GIR_EraseRootFromParent_Done,
     /*  222578 */   // Label 4434: @222578
     /*  222578 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(222652), // Rule ID 8052 //
     /*  222583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  222597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222623 */     // MIs[1] Operand 1
     /*  222623 */     // No operand predicates
     /*  222623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222632 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222650 */     GIR_RootConstrainSelectedInstOperands,
     /*  222651 */     // GIR_Coverage, 8052,
     /*  222651 */     GIR_EraseRootFromParent_Done,
     /*  222652 */   // Label 4435: @222652
     /*  222652 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(222726), // Rule ID 8053 //
     /*  222657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  222671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222697 */     // MIs[1] Operand 1
     /*  222697 */     // No operand predicates
     /*  222697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222706 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222724 */     GIR_RootConstrainSelectedInstOperands,
     /*  222725 */     // GIR_Coverage, 8053,
     /*  222725 */     GIR_EraseRootFromParent_Done,
     /*  222726 */   // Label 4436: @222726
     /*  222726 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(222800), // Rule ID 8056 //
     /*  222731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222771 */     // MIs[1] Operand 1
     /*  222771 */     // No operand predicates
     /*  222771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222780 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222798 */     GIR_RootConstrainSelectedInstOperands,
     /*  222799 */     // GIR_Coverage, 8056,
     /*  222799 */     GIR_EraseRootFromParent_Done,
     /*  222800 */   // Label 4437: @222800
     /*  222800 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(222874), // Rule ID 8057 //
     /*  222805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222845 */     // MIs[1] Operand 1
     /*  222845 */     // No operand predicates
     /*  222845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222854 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222872 */     GIR_RootConstrainSelectedInstOperands,
     /*  222873 */     // GIR_Coverage, 8057,
     /*  222873 */     GIR_EraseRootFromParent_Done,
     /*  222874 */   // Label 4438: @222874
     /*  222874 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(222948), // Rule ID 8060 //
     /*  222879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  222893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222919 */     // MIs[1] Operand 1
     /*  222919 */     // No operand predicates
     /*  222919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222928 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222946 */     GIR_RootConstrainSelectedInstOperands,
     /*  222947 */     // GIR_Coverage, 8060,
     /*  222947 */     GIR_EraseRootFromParent_Done,
     /*  222948 */   // Label 4439: @222948
     /*  222948 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(223022), // Rule ID 8061 //
     /*  222953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  222967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222993 */     // MIs[1] Operand 1
     /*  222993 */     // No operand predicates
     /*  222993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223002 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  223002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  223005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223020 */     GIR_RootConstrainSelectedInstOperands,
     /*  223021 */     // GIR_Coverage, 8061,
     /*  223021 */     GIR_EraseRootFromParent_Done,
     /*  223022 */   // Label 4440: @223022
     /*  223022 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(223096), // Rule ID 8064 //
     /*  223027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  223041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223067 */     // MIs[1] Operand 1
     /*  223067 */     // No operand predicates
     /*  223067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223076 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  223079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223094 */     GIR_RootConstrainSelectedInstOperands,
     /*  223095 */     // GIR_Coverage, 8064,
     /*  223095 */     GIR_EraseRootFromParent_Done,
     /*  223096 */   // Label 4441: @223096
     /*  223096 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(223170), // Rule ID 8065 //
     /*  223101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  223115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223141 */     // MIs[1] Operand 1
     /*  223141 */     // No operand predicates
     /*  223141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223150 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  223153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223168 */     GIR_RootConstrainSelectedInstOperands,
     /*  223169 */     // GIR_Coverage, 8065,
     /*  223169 */     GIR_EraseRootFromParent_Done,
     /*  223170 */   // Label 4442: @223170
     /*  223170 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(223244), // Rule ID 8068 //
     /*  223175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  223189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  223203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223215 */     // MIs[1] Operand 1
     /*  223215 */     // No operand predicates
     /*  223215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223224 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  223227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223242 */     GIR_RootConstrainSelectedInstOperands,
     /*  223243 */     // GIR_Coverage, 8068,
     /*  223243 */     GIR_EraseRootFromParent_Done,
     /*  223244 */   // Label 4443: @223244
     /*  223244 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(223318), // Rule ID 8069 //
     /*  223249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  223263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  223277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223289 */     // MIs[1] Operand 1
     /*  223289 */     // No operand predicates
     /*  223289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223298 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  223301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223316 */     GIR_RootConstrainSelectedInstOperands,
     /*  223317 */     // GIR_Coverage, 8069,
     /*  223317 */     GIR_EraseRootFromParent_Done,
     /*  223318 */   // Label 4444: @223318
     /*  223318 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(223392), // Rule ID 8072 //
     /*  223323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  223337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223363 */     // MIs[1] Operand 1
     /*  223363 */     // No operand predicates
     /*  223363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223372 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  223375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223390 */     GIR_RootConstrainSelectedInstOperands,
     /*  223391 */     // GIR_Coverage, 8072,
     /*  223391 */     GIR_EraseRootFromParent_Done,
     /*  223392 */   // Label 4445: @223392
     /*  223392 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(223466), // Rule ID 8073 //
     /*  223397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  223411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223437 */     // MIs[1] Operand 1
     /*  223437 */     // No operand predicates
     /*  223437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223446 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  223449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223464 */     GIR_RootConstrainSelectedInstOperands,
     /*  223465 */     // GIR_Coverage, 8073,
     /*  223465 */     GIR_EraseRootFromParent_Done,
     /*  223466 */   // Label 4446: @223466
     /*  223466 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(223540), // Rule ID 8252 //
     /*  223471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  223485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223511 */     // MIs[1] Operand 1
     /*  223511 */     // No operand predicates
     /*  223511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  223523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223538 */     GIR_RootConstrainSelectedInstOperands,
     /*  223539 */     // GIR_Coverage, 8252,
     /*  223539 */     GIR_EraseRootFromParent_Done,
     /*  223540 */   // Label 4447: @223540
     /*  223540 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(223614), // Rule ID 8253 //
     /*  223545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  223559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223585 */     // MIs[1] Operand 1
     /*  223585 */     // No operand predicates
     /*  223585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223594 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  223597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223612 */     GIR_RootConstrainSelectedInstOperands,
     /*  223613 */     // GIR_Coverage, 8253,
     /*  223613 */     GIR_EraseRootFromParent_Done,
     /*  223614 */   // Label 4448: @223614
     /*  223614 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(223688), // Rule ID 8256 //
     /*  223619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  223633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223659 */     // MIs[1] Operand 1
     /*  223659 */     // No operand predicates
     /*  223659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223668 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223686 */     GIR_RootConstrainSelectedInstOperands,
     /*  223687 */     // GIR_Coverage, 8256,
     /*  223687 */     GIR_EraseRootFromParent_Done,
     /*  223688 */   // Label 4449: @223688
     /*  223688 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(223762), // Rule ID 8257 //
     /*  223693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  223707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223733 */     // MIs[1] Operand 1
     /*  223733 */     // No operand predicates
     /*  223733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223742 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223760 */     GIR_RootConstrainSelectedInstOperands,
     /*  223761 */     // GIR_Coverage, 8257,
     /*  223761 */     GIR_EraseRootFromParent_Done,
     /*  223762 */   // Label 4450: @223762
     /*  223762 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(223836), // Rule ID 8260 //
     /*  223767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  223781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223807 */     // MIs[1] Operand 1
     /*  223807 */     // No operand predicates
     /*  223807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223816 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223834 */     GIR_RootConstrainSelectedInstOperands,
     /*  223835 */     // GIR_Coverage, 8260,
     /*  223835 */     GIR_EraseRootFromParent_Done,
     /*  223836 */   // Label 4451: @223836
     /*  223836 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(223910), // Rule ID 8261 //
     /*  223841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  223855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223881 */     // MIs[1] Operand 1
     /*  223881 */     // No operand predicates
     /*  223881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223890 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223908 */     GIR_RootConstrainSelectedInstOperands,
     /*  223909 */     // GIR_Coverage, 8261,
     /*  223909 */     GIR_EraseRootFromParent_Done,
     /*  223910 */   // Label 4452: @223910
     /*  223910 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(223984), // Rule ID 8264 //
     /*  223915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  223929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223955 */     // MIs[1] Operand 1
     /*  223955 */     // No operand predicates
     /*  223955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223964 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  223964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223982 */     GIR_RootConstrainSelectedInstOperands,
     /*  223983 */     // GIR_Coverage, 8264,
     /*  223983 */     GIR_EraseRootFromParent_Done,
     /*  223984 */   // Label 4453: @223984
     /*  223984 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(224058), // Rule ID 8265 //
     /*  223989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  224003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224029 */     // MIs[1] Operand 1
     /*  224029 */     // No operand predicates
     /*  224029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224038 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  224041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224056 */     GIR_RootConstrainSelectedInstOperands,
     /*  224057 */     // GIR_Coverage, 8265,
     /*  224057 */     GIR_EraseRootFromParent_Done,
     /*  224058 */   // Label 4454: @224058
     /*  224058 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(224132), // Rule ID 8268 //
     /*  224063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  224077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224103 */     // MIs[1] Operand 1
     /*  224103 */     // No operand predicates
     /*  224103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224112 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  224115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224130 */     GIR_RootConstrainSelectedInstOperands,
     /*  224131 */     // GIR_Coverage, 8268,
     /*  224131 */     GIR_EraseRootFromParent_Done,
     /*  224132 */   // Label 4455: @224132
     /*  224132 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(224206), // Rule ID 8269 //
     /*  224137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  224151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224177 */     // MIs[1] Operand 1
     /*  224177 */     // No operand predicates
     /*  224177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224186 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  224189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224204 */     GIR_RootConstrainSelectedInstOperands,
     /*  224205 */     // GIR_Coverage, 8269,
     /*  224205 */     GIR_EraseRootFromParent_Done,
     /*  224206 */   // Label 4456: @224206
     /*  224206 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(224280), // Rule ID 8272 //
     /*  224211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  224225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224251 */     // MIs[1] Operand 1
     /*  224251 */     // No operand predicates
     /*  224251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224260 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  224263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224278 */     GIR_RootConstrainSelectedInstOperands,
     /*  224279 */     // GIR_Coverage, 8272,
     /*  224279 */     GIR_EraseRootFromParent_Done,
     /*  224280 */   // Label 4457: @224280
     /*  224280 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(224354), // Rule ID 8273 //
     /*  224285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  224299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224325 */     // MIs[1] Operand 1
     /*  224325 */     // No operand predicates
     /*  224325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224334 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  224337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224352 */     GIR_RootConstrainSelectedInstOperands,
     /*  224353 */     // GIR_Coverage, 8273,
     /*  224353 */     GIR_EraseRootFromParent_Done,
     /*  224354 */   // Label 4458: @224354
     /*  224354 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(224428), // Rule ID 8276 //
     /*  224359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  224373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224399 */     // MIs[1] Operand 1
     /*  224399 */     // No operand predicates
     /*  224399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224408 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224426 */     GIR_RootConstrainSelectedInstOperands,
     /*  224427 */     // GIR_Coverage, 8276,
     /*  224427 */     GIR_EraseRootFromParent_Done,
     /*  224428 */   // Label 4459: @224428
     /*  224428 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(224502), // Rule ID 8277 //
     /*  224433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  224447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224473 */     // MIs[1] Operand 1
     /*  224473 */     // No operand predicates
     /*  224473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224482 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224500 */     GIR_RootConstrainSelectedInstOperands,
     /*  224501 */     // GIR_Coverage, 8277,
     /*  224501 */     GIR_EraseRootFromParent_Done,
     /*  224502 */   // Label 4460: @224502
     /*  224502 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(224576), // Rule ID 8280 //
     /*  224507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224547 */     // MIs[1] Operand 1
     /*  224547 */     // No operand predicates
     /*  224547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224556 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224574 */     GIR_RootConstrainSelectedInstOperands,
     /*  224575 */     // GIR_Coverage, 8280,
     /*  224575 */     GIR_EraseRootFromParent_Done,
     /*  224576 */   // Label 4461: @224576
     /*  224576 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(224650), // Rule ID 8281 //
     /*  224581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224621 */     // MIs[1] Operand 1
     /*  224621 */     // No operand predicates
     /*  224621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224630 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224648 */     GIR_RootConstrainSelectedInstOperands,
     /*  224649 */     // GIR_Coverage, 8281,
     /*  224649 */     GIR_EraseRootFromParent_Done,
     /*  224650 */   // Label 4462: @224650
     /*  224650 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(224724), // Rule ID 8284 //
     /*  224655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224695 */     // MIs[1] Operand 1
     /*  224695 */     // No operand predicates
     /*  224695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224722 */     GIR_RootConstrainSelectedInstOperands,
     /*  224723 */     // GIR_Coverage, 8284,
     /*  224723 */     GIR_EraseRootFromParent_Done,
     /*  224724 */   // Label 4463: @224724
     /*  224724 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(224798), // Rule ID 8285 //
     /*  224729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224769 */     // MIs[1] Operand 1
     /*  224769 */     // No operand predicates
     /*  224769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224778 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224796 */     GIR_RootConstrainSelectedInstOperands,
     /*  224797 */     // GIR_Coverage, 8285,
     /*  224797 */     GIR_EraseRootFromParent_Done,
     /*  224798 */   // Label 4464: @224798
     /*  224798 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(224872), // Rule ID 8288 //
     /*  224803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  224806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  224817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224843 */     // MIs[1] Operand 1
     /*  224843 */     // No operand predicates
     /*  224843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224852 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  224852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224870 */     GIR_RootConstrainSelectedInstOperands,
     /*  224871 */     // GIR_Coverage, 8288,
     /*  224871 */     GIR_EraseRootFromParent_Done,
     /*  224872 */   // Label 4465: @224872
     /*  224872 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(224946), // Rule ID 8289 //
     /*  224877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  224880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  224891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224917 */     // MIs[1] Operand 1
     /*  224917 */     // No operand predicates
     /*  224917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224926 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  224926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224944 */     GIR_RootConstrainSelectedInstOperands,
     /*  224945 */     // GIR_Coverage, 8289,
     /*  224945 */     GIR_EraseRootFromParent_Done,
     /*  224946 */   // Label 4466: @224946
     /*  224946 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(225020), // Rule ID 8292 //
     /*  224951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  224962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  224965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224991 */     // MIs[1] Operand 1
     /*  224991 */     // No operand predicates
     /*  224991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225000 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225018 */     GIR_RootConstrainSelectedInstOperands,
     /*  225019 */     // GIR_Coverage, 8292,
     /*  225019 */     GIR_EraseRootFromParent_Done,
     /*  225020 */   // Label 4467: @225020
     /*  225020 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(225094), // Rule ID 8293 //
     /*  225025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  225039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225065 */     // MIs[1] Operand 1
     /*  225065 */     // No operand predicates
     /*  225065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225074 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225092 */     GIR_RootConstrainSelectedInstOperands,
     /*  225093 */     // GIR_Coverage, 8293,
     /*  225093 */     GIR_EraseRootFromParent_Done,
     /*  225094 */   // Label 4468: @225094
     /*  225094 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(225168), // Rule ID 8296 //
     /*  225099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  225113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225139 */     // MIs[1] Operand 1
     /*  225139 */     // No operand predicates
     /*  225139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225148 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225166 */     GIR_RootConstrainSelectedInstOperands,
     /*  225167 */     // GIR_Coverage, 8296,
     /*  225167 */     GIR_EraseRootFromParent_Done,
     /*  225168 */   // Label 4469: @225168
     /*  225168 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(225242), // Rule ID 8297 //
     /*  225173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  225187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225213 */     // MIs[1] Operand 1
     /*  225213 */     // No operand predicates
     /*  225213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225222 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225240 */     GIR_RootConstrainSelectedInstOperands,
     /*  225241 */     // GIR_Coverage, 8297,
     /*  225241 */     GIR_EraseRootFromParent_Done,
     /*  225242 */   // Label 4470: @225242
     /*  225242 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(225316), // Rule ID 8300 //
     /*  225247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  225258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  225261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225287 */     // MIs[1] Operand 1
     /*  225287 */     // No operand predicates
     /*  225287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225296 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225314 */     GIR_RootConstrainSelectedInstOperands,
     /*  225315 */     // GIR_Coverage, 8300,
     /*  225315 */     GIR_EraseRootFromParent_Done,
     /*  225316 */   // Label 4471: @225316
     /*  225316 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(225390), // Rule ID 8301 //
     /*  225321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  225332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  225335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225361 */     // MIs[1] Operand 1
     /*  225361 */     // No operand predicates
     /*  225361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225370 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225388 */     GIR_RootConstrainSelectedInstOperands,
     /*  225389 */     // GIR_Coverage, 8301,
     /*  225389 */     GIR_EraseRootFromParent_Done,
     /*  225390 */   // Label 4472: @225390
     /*  225390 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(225464), // Rule ID 8304 //
     /*  225395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  225409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225435 */     // MIs[1] Operand 1
     /*  225435 */     // No operand predicates
     /*  225435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225444 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225462 */     GIR_RootConstrainSelectedInstOperands,
     /*  225463 */     // GIR_Coverage, 8304,
     /*  225463 */     GIR_EraseRootFromParent_Done,
     /*  225464 */   // Label 4473: @225464
     /*  225464 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(225538), // Rule ID 8305 //
     /*  225469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  225483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225509 */     // MIs[1] Operand 1
     /*  225509 */     // No operand predicates
     /*  225509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225518 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225536 */     GIR_RootConstrainSelectedInstOperands,
     /*  225537 */     // GIR_Coverage, 8305,
     /*  225537 */     GIR_EraseRootFromParent_Done,
     /*  225538 */   // Label 4474: @225538
     /*  225538 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(225612), // Rule ID 8308 //
     /*  225543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225583 */     // MIs[1] Operand 1
     /*  225583 */     // No operand predicates
     /*  225583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225592 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225610 */     GIR_RootConstrainSelectedInstOperands,
     /*  225611 */     // GIR_Coverage, 8308,
     /*  225611 */     GIR_EraseRootFromParent_Done,
     /*  225612 */   // Label 4475: @225612
     /*  225612 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(225686), // Rule ID 8309 //
     /*  225617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225657 */     // MIs[1] Operand 1
     /*  225657 */     // No operand predicates
     /*  225657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225666 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225684 */     GIR_RootConstrainSelectedInstOperands,
     /*  225685 */     // GIR_Coverage, 8309,
     /*  225685 */     GIR_EraseRootFromParent_Done,
     /*  225686 */   // Label 4476: @225686
     /*  225686 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(225760), // Rule ID 8312 //
     /*  225691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225731 */     // MIs[1] Operand 1
     /*  225731 */     // No operand predicates
     /*  225731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225740 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225758 */     GIR_RootConstrainSelectedInstOperands,
     /*  225759 */     // GIR_Coverage, 8312,
     /*  225759 */     GIR_EraseRootFromParent_Done,
     /*  225760 */   // Label 4477: @225760
     /*  225760 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(225834), // Rule ID 8313 //
     /*  225765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225805 */     // MIs[1] Operand 1
     /*  225805 */     // No operand predicates
     /*  225805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225814 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225832 */     GIR_RootConstrainSelectedInstOperands,
     /*  225833 */     // GIR_Coverage, 8313,
     /*  225833 */     GIR_EraseRootFromParent_Done,
     /*  225834 */   // Label 4478: @225834
     /*  225834 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(225908), // Rule ID 8316 //
     /*  225839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  225853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225879 */     // MIs[1] Operand 1
     /*  225879 */     // No operand predicates
     /*  225879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225888 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225906 */     GIR_RootConstrainSelectedInstOperands,
     /*  225907 */     // GIR_Coverage, 8316,
     /*  225907 */     GIR_EraseRootFromParent_Done,
     /*  225908 */   // Label 4479: @225908
     /*  225908 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(225982), // Rule ID 8317 //
     /*  225913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  225927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225953 */     // MIs[1] Operand 1
     /*  225953 */     // No operand predicates
     /*  225953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225962 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225980 */     GIR_RootConstrainSelectedInstOperands,
     /*  225981 */     // GIR_Coverage, 8317,
     /*  225981 */     GIR_EraseRootFromParent_Done,
     /*  225982 */   // Label 4480: @225982
     /*  225982 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(226056), // Rule ID 8320 //
     /*  225987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  226001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226027 */     // MIs[1] Operand 1
     /*  226027 */     // No operand predicates
     /*  226027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226036 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  226039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226054 */     GIR_RootConstrainSelectedInstOperands,
     /*  226055 */     // GIR_Coverage, 8320,
     /*  226055 */     GIR_EraseRootFromParent_Done,
     /*  226056 */   // Label 4481: @226056
     /*  226056 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(226130), // Rule ID 8321 //
     /*  226061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  226075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226101 */     // MIs[1] Operand 1
     /*  226101 */     // No operand predicates
     /*  226101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226110 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  226113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226128 */     GIR_RootConstrainSelectedInstOperands,
     /*  226129 */     // GIR_Coverage, 8321,
     /*  226129 */     GIR_EraseRootFromParent_Done,
     /*  226130 */   // Label 4482: @226130
     /*  226130 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(226204), // Rule ID 8324 //
     /*  226135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  226146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  226149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226175 */     // MIs[1] Operand 1
     /*  226175 */     // No operand predicates
     /*  226175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226184 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  226187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226202 */     GIR_RootConstrainSelectedInstOperands,
     /*  226203 */     // GIR_Coverage, 8324,
     /*  226203 */     GIR_EraseRootFromParent_Done,
     /*  226204 */   // Label 4483: @226204
     /*  226204 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(226278), // Rule ID 8325 //
     /*  226209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  226220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  226223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226249 */     // MIs[1] Operand 1
     /*  226249 */     // No operand predicates
     /*  226249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226258 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  226261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226276 */     GIR_RootConstrainSelectedInstOperands,
     /*  226277 */     // GIR_Coverage, 8325,
     /*  226277 */     GIR_EraseRootFromParent_Done,
     /*  226278 */   // Label 4484: @226278
     /*  226278 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(226352), // Rule ID 8328 //
     /*  226283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  226297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226323 */     // MIs[1] Operand 1
     /*  226323 */     // No operand predicates
     /*  226323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226332 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  226335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226350 */     GIR_RootConstrainSelectedInstOperands,
     /*  226351 */     // GIR_Coverage, 8328,
     /*  226351 */     GIR_EraseRootFromParent_Done,
     /*  226352 */   // Label 4485: @226352
     /*  226352 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(226426), // Rule ID 8329 //
     /*  226357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  226371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226397 */     // MIs[1] Operand 1
     /*  226397 */     // No operand predicates
     /*  226397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226406 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  226409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226424 */     GIR_RootConstrainSelectedInstOperands,
     /*  226425 */     // GIR_Coverage, 8329,
     /*  226425 */     GIR_EraseRootFromParent_Done,
     /*  226426 */   // Label 4486: @226426
     /*  226426 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(226500), // Rule ID 8332 //
     /*  226431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  226445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226471 */     // MIs[1] Operand 1
     /*  226471 */     // No operand predicates
     /*  226471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226480 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  226483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226498 */     GIR_RootConstrainSelectedInstOperands,
     /*  226499 */     // GIR_Coverage, 8332,
     /*  226499 */     GIR_EraseRootFromParent_Done,
     /*  226500 */   // Label 4487: @226500
     /*  226500 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(226574), // Rule ID 8333 //
     /*  226505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  226519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226545 */     // MIs[1] Operand 1
     /*  226545 */     // No operand predicates
     /*  226545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226554 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  226557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226572 */     GIR_RootConstrainSelectedInstOperands,
     /*  226573 */     // GIR_Coverage, 8333,
     /*  226573 */     GIR_EraseRootFromParent_Done,
     /*  226574 */   // Label 4488: @226574
     /*  226574 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(226648), // Rule ID 8336 //
     /*  226579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226619 */     // MIs[1] Operand 1
     /*  226619 */     // No operand predicates
     /*  226619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226628 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  226631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226646 */     GIR_RootConstrainSelectedInstOperands,
     /*  226647 */     // GIR_Coverage, 8336,
     /*  226647 */     GIR_EraseRootFromParent_Done,
     /*  226648 */   // Label 4489: @226648
     /*  226648 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(226722), // Rule ID 8337 //
     /*  226653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226693 */     // MIs[1] Operand 1
     /*  226693 */     // No operand predicates
     /*  226693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226702 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  226705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226720 */     GIR_RootConstrainSelectedInstOperands,
     /*  226721 */     // GIR_Coverage, 8337,
     /*  226721 */     GIR_EraseRootFromParent_Done,
     /*  226722 */   // Label 4490: @226722
     /*  226722 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(226796), // Rule ID 8868 //
     /*  226727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  226741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226767 */     // MIs[1] Operand 1
     /*  226767 */     // No operand predicates
     /*  226767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226776 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  226779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226794 */     GIR_RootConstrainSelectedInstOperands,
     /*  226795 */     // GIR_Coverage, 8868,
     /*  226795 */     GIR_EraseRootFromParent_Done,
     /*  226796 */   // Label 4491: @226796
     /*  226796 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(226870), // Rule ID 8869 //
     /*  226801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  226815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226841 */     // MIs[1] Operand 1
     /*  226841 */     // No operand predicates
     /*  226841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226850 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  226853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226868 */     GIR_RootConstrainSelectedInstOperands,
     /*  226869 */     // GIR_Coverage, 8869,
     /*  226869 */     GIR_EraseRootFromParent_Done,
     /*  226870 */   // Label 4492: @226870
     /*  226870 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(226944), // Rule ID 8872 //
     /*  226875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  226889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226915 */     // MIs[1] Operand 1
     /*  226915 */     // No operand predicates
     /*  226915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226924 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226942 */     GIR_RootConstrainSelectedInstOperands,
     /*  226943 */     // GIR_Coverage, 8872,
     /*  226943 */     GIR_EraseRootFromParent_Done,
     /*  226944 */   // Label 4493: @226944
     /*  226944 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(227018), // Rule ID 8873 //
     /*  226949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  226963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226989 */     // MIs[1] Operand 1
     /*  226989 */     // No operand predicates
     /*  226989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  227001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227016 */     GIR_RootConstrainSelectedInstOperands,
     /*  227017 */     // GIR_Coverage, 8873,
     /*  227017 */     GIR_EraseRootFromParent_Done,
     /*  227018 */   // Label 4494: @227018
     /*  227018 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(227092), // Rule ID 8876 //
     /*  227023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  227037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227063 */     // MIs[1] Operand 1
     /*  227063 */     // No operand predicates
     /*  227063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227072 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227090 */     GIR_RootConstrainSelectedInstOperands,
     /*  227091 */     // GIR_Coverage, 8876,
     /*  227091 */     GIR_EraseRootFromParent_Done,
     /*  227092 */   // Label 4495: @227092
     /*  227092 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(227166), // Rule ID 8877 //
     /*  227097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  227111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227137 */     // MIs[1] Operand 1
     /*  227137 */     // No operand predicates
     /*  227137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227146 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227164 */     GIR_RootConstrainSelectedInstOperands,
     /*  227165 */     // GIR_Coverage, 8877,
     /*  227165 */     GIR_EraseRootFromParent_Done,
     /*  227166 */   // Label 4496: @227166
     /*  227166 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(227240), // Rule ID 8880 //
     /*  227171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  227185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227211 */     // MIs[1] Operand 1
     /*  227211 */     // No operand predicates
     /*  227211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227220 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  227223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227238 */     GIR_RootConstrainSelectedInstOperands,
     /*  227239 */     // GIR_Coverage, 8880,
     /*  227239 */     GIR_EraseRootFromParent_Done,
     /*  227240 */   // Label 4497: @227240
     /*  227240 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(227314), // Rule ID 8881 //
     /*  227245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  227259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227285 */     // MIs[1] Operand 1
     /*  227285 */     // No operand predicates
     /*  227285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227294 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  227297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227312 */     GIR_RootConstrainSelectedInstOperands,
     /*  227313 */     // GIR_Coverage, 8881,
     /*  227313 */     GIR_EraseRootFromParent_Done,
     /*  227314 */   // Label 4498: @227314
     /*  227314 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(227388), // Rule ID 8884 //
     /*  227319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  227333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227359 */     // MIs[1] Operand 1
     /*  227359 */     // No operand predicates
     /*  227359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227386 */     GIR_RootConstrainSelectedInstOperands,
     /*  227387 */     // GIR_Coverage, 8884,
     /*  227387 */     GIR_EraseRootFromParent_Done,
     /*  227388 */   // Label 4499: @227388
     /*  227388 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(227462), // Rule ID 8885 //
     /*  227393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  227407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227433 */     // MIs[1] Operand 1
     /*  227433 */     // No operand predicates
     /*  227433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227442 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227460 */     GIR_RootConstrainSelectedInstOperands,
     /*  227461 */     // GIR_Coverage, 8885,
     /*  227461 */     GIR_EraseRootFromParent_Done,
     /*  227462 */   // Label 4500: @227462
     /*  227462 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(227536), // Rule ID 8888 //
     /*  227467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  227481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227507 */     // MIs[1] Operand 1
     /*  227507 */     // No operand predicates
     /*  227507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227516 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227534 */     GIR_RootConstrainSelectedInstOperands,
     /*  227535 */     // GIR_Coverage, 8888,
     /*  227535 */     GIR_EraseRootFromParent_Done,
     /*  227536 */   // Label 4501: @227536
     /*  227536 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(227610), // Rule ID 8889 //
     /*  227541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  227555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227581 */     // MIs[1] Operand 1
     /*  227581 */     // No operand predicates
     /*  227581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227590 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  227590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227608 */     GIR_RootConstrainSelectedInstOperands,
     /*  227609 */     // GIR_Coverage, 8889,
     /*  227609 */     GIR_EraseRootFromParent_Done,
     /*  227610 */   // Label 4502: @227610
     /*  227610 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(227684), // Rule ID 8892 //
     /*  227615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  227629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227655 */     // MIs[1] Operand 1
     /*  227655 */     // No operand predicates
     /*  227655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227682 */     GIR_RootConstrainSelectedInstOperands,
     /*  227683 */     // GIR_Coverage, 8892,
     /*  227683 */     GIR_EraseRootFromParent_Done,
     /*  227684 */   // Label 4503: @227684
     /*  227684 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(227758), // Rule ID 8893 //
     /*  227689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  227703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227729 */     // MIs[1] Operand 1
     /*  227729 */     // No operand predicates
     /*  227729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227756 */     GIR_RootConstrainSelectedInstOperands,
     /*  227757 */     // GIR_Coverage, 8893,
     /*  227757 */     GIR_EraseRootFromParent_Done,
     /*  227758 */   // Label 4504: @227758
     /*  227758 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(227832), // Rule ID 8896 //
     /*  227763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  227777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227803 */     // MIs[1] Operand 1
     /*  227803 */     // No operand predicates
     /*  227803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227812 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227830 */     GIR_RootConstrainSelectedInstOperands,
     /*  227831 */     // GIR_Coverage, 8896,
     /*  227831 */     GIR_EraseRootFromParent_Done,
     /*  227832 */   // Label 4505: @227832
     /*  227832 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(227906), // Rule ID 8897 //
     /*  227837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  227851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227877 */     // MIs[1] Operand 1
     /*  227877 */     // No operand predicates
     /*  227877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227886 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227904 */     GIR_RootConstrainSelectedInstOperands,
     /*  227905 */     // GIR_Coverage, 8897,
     /*  227905 */     GIR_EraseRootFromParent_Done,
     /*  227906 */   // Label 4506: @227906
     /*  227906 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(227980), // Rule ID 8900 //
     /*  227911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  227925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227951 */     // MIs[1] Operand 1
     /*  227951 */     // No operand predicates
     /*  227951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227960 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227978 */     GIR_RootConstrainSelectedInstOperands,
     /*  227979 */     // GIR_Coverage, 8900,
     /*  227979 */     GIR_EraseRootFromParent_Done,
     /*  227980 */   // Label 4507: @227980
     /*  227980 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(228054), // Rule ID 8901 //
     /*  227985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  227999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228025 */     // MIs[1] Operand 1
     /*  228025 */     // No operand predicates
     /*  228025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228034 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  228037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228052 */     GIR_RootConstrainSelectedInstOperands,
     /*  228053 */     // GIR_Coverage, 8901,
     /*  228053 */     GIR_EraseRootFromParent_Done,
     /*  228054 */   // Label 4508: @228054
     /*  228054 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(228128), // Rule ID 8904 //
     /*  228059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  228062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  228073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228099 */     // MIs[1] Operand 1
     /*  228099 */     // No operand predicates
     /*  228099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228108 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  228108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  228111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228126 */     GIR_RootConstrainSelectedInstOperands,
     /*  228127 */     // GIR_Coverage, 8904,
     /*  228127 */     GIR_EraseRootFromParent_Done,
     /*  228128 */   // Label 4509: @228128
     /*  228128 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(228202), // Rule ID 8905 //
     /*  228133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  228136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  228147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228173 */     // MIs[1] Operand 1
     /*  228173 */     // No operand predicates
     /*  228173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228182 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  228182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  228185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228200 */     GIR_RootConstrainSelectedInstOperands,
     /*  228201 */     // GIR_Coverage, 8905,
     /*  228201 */     GIR_EraseRootFromParent_Done,
     /*  228202 */   // Label 4510: @228202
     /*  228202 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(228276), // Rule ID 8908 //
     /*  228207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  228221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228247 */     // MIs[1] Operand 1
     /*  228247 */     // No operand predicates
     /*  228247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228256 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228274 */     GIR_RootConstrainSelectedInstOperands,
     /*  228275 */     // GIR_Coverage, 8908,
     /*  228275 */     GIR_EraseRootFromParent_Done,
     /*  228276 */   // Label 4511: @228276
     /*  228276 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(228350), // Rule ID 8909 //
     /*  228281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  228295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228321 */     // MIs[1] Operand 1
     /*  228321 */     // No operand predicates
     /*  228321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228330 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228348 */     GIR_RootConstrainSelectedInstOperands,
     /*  228349 */     // GIR_Coverage, 8909,
     /*  228349 */     GIR_EraseRootFromParent_Done,
     /*  228350 */   // Label 4512: @228350
     /*  228350 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(228424), // Rule ID 8912 //
     /*  228355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  228369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228395 */     // MIs[1] Operand 1
     /*  228395 */     // No operand predicates
     /*  228395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228404 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228422 */     GIR_RootConstrainSelectedInstOperands,
     /*  228423 */     // GIR_Coverage, 8912,
     /*  228423 */     GIR_EraseRootFromParent_Done,
     /*  228424 */   // Label 4513: @228424
     /*  228424 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(228498), // Rule ID 8913 //
     /*  228429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  228443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228469 */     // MIs[1] Operand 1
     /*  228469 */     // No operand predicates
     /*  228469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228478 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228496 */     GIR_RootConstrainSelectedInstOperands,
     /*  228497 */     // GIR_Coverage, 8913,
     /*  228497 */     GIR_EraseRootFromParent_Done,
     /*  228498 */   // Label 4514: @228498
     /*  228498 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(228572), // Rule ID 8916 //
     /*  228503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  228514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  228517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228543 */     // MIs[1] Operand 1
     /*  228543 */     // No operand predicates
     /*  228543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228552 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228570 */     GIR_RootConstrainSelectedInstOperands,
     /*  228571 */     // GIR_Coverage, 8916,
     /*  228571 */     GIR_EraseRootFromParent_Done,
     /*  228572 */   // Label 4515: @228572
     /*  228572 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(228646), // Rule ID 8917 //
     /*  228577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  228588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  228591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228617 */     // MIs[1] Operand 1
     /*  228617 */     // No operand predicates
     /*  228617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228626 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228644 */     GIR_RootConstrainSelectedInstOperands,
     /*  228645 */     // GIR_Coverage, 8917,
     /*  228645 */     GIR_EraseRootFromParent_Done,
     /*  228646 */   // Label 4516: @228646
     /*  228646 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(228720), // Rule ID 8920 //
     /*  228651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  228665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228691 */     // MIs[1] Operand 1
     /*  228691 */     // No operand predicates
     /*  228691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228700 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228718 */     GIR_RootConstrainSelectedInstOperands,
     /*  228719 */     // GIR_Coverage, 8920,
     /*  228719 */     GIR_EraseRootFromParent_Done,
     /*  228720 */   // Label 4517: @228720
     /*  228720 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(228794), // Rule ID 8921 //
     /*  228725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  228739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228765 */     // MIs[1] Operand 1
     /*  228765 */     // No operand predicates
     /*  228765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228774 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228792 */     GIR_RootConstrainSelectedInstOperands,
     /*  228793 */     // GIR_Coverage, 8921,
     /*  228793 */     GIR_EraseRootFromParent_Done,
     /*  228794 */   // Label 4518: @228794
     /*  228794 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(228868), // Rule ID 8924 //
     /*  228799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  228813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228839 */     // MIs[1] Operand 1
     /*  228839 */     // No operand predicates
     /*  228839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228848 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228866 */     GIR_RootConstrainSelectedInstOperands,
     /*  228867 */     // GIR_Coverage, 8924,
     /*  228867 */     GIR_EraseRootFromParent_Done,
     /*  228868 */   // Label 4519: @228868
     /*  228868 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(228942), // Rule ID 8925 //
     /*  228873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  228887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228913 */     // MIs[1] Operand 1
     /*  228913 */     // No operand predicates
     /*  228913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228922 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228940 */     GIR_RootConstrainSelectedInstOperands,
     /*  228941 */     // GIR_Coverage, 8925,
     /*  228941 */     GIR_EraseRootFromParent_Done,
     /*  228942 */   // Label 4520: @228942
     /*  228942 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(229016), // Rule ID 8928 //
     /*  228947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  228961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228987 */     // MIs[1] Operand 1
     /*  228987 */     // No operand predicates
     /*  228987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228996 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229014 */     GIR_RootConstrainSelectedInstOperands,
     /*  229015 */     // GIR_Coverage, 8928,
     /*  229015 */     GIR_EraseRootFromParent_Done,
     /*  229016 */   // Label 4521: @229016
     /*  229016 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(229090), // Rule ID 8929 //
     /*  229021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  229032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  229035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229061 */     // MIs[1] Operand 1
     /*  229061 */     // No operand predicates
     /*  229061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229070 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  229070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229088 */     GIR_RootConstrainSelectedInstOperands,
     /*  229089 */     // GIR_Coverage, 8929,
     /*  229089 */     GIR_EraseRootFromParent_Done,
     /*  229090 */   // Label 4522: @229090
     /*  229090 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(229164), // Rule ID 8932 //
     /*  229095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  229109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229135 */     // MIs[1] Operand 1
     /*  229135 */     // No operand predicates
     /*  229135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229144 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  229147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229162 */     GIR_RootConstrainSelectedInstOperands,
     /*  229163 */     // GIR_Coverage, 8932,
     /*  229163 */     GIR_EraseRootFromParent_Done,
     /*  229164 */   // Label 4523: @229164
     /*  229164 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(229238), // Rule ID 8933 //
     /*  229169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  229183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229209 */     // MIs[1] Operand 1
     /*  229209 */     // No operand predicates
     /*  229209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229218 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  229221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229236 */     GIR_RootConstrainSelectedInstOperands,
     /*  229237 */     // GIR_Coverage, 8933,
     /*  229237 */     GIR_EraseRootFromParent_Done,
     /*  229238 */   // Label 4524: @229238
     /*  229238 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(229312), // Rule ID 8936 //
     /*  229243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  229257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229283 */     // MIs[1] Operand 1
     /*  229283 */     // No operand predicates
     /*  229283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229292 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  229295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229310 */     GIR_RootConstrainSelectedInstOperands,
     /*  229311 */     // GIR_Coverage, 8936,
     /*  229311 */     GIR_EraseRootFromParent_Done,
     /*  229312 */   // Label 4525: @229312
     /*  229312 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(229386), // Rule ID 8937 //
     /*  229317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  229331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229357 */     // MIs[1] Operand 1
     /*  229357 */     // No operand predicates
     /*  229357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229366 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  229369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229384 */     GIR_RootConstrainSelectedInstOperands,
     /*  229385 */     // GIR_Coverage, 8937,
     /*  229385 */     GIR_EraseRootFromParent_Done,
     /*  229386 */   // Label 4526: @229386
     /*  229386 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(229460), // Rule ID 8940 //
     /*  229391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  229405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229431 */     // MIs[1] Operand 1
     /*  229431 */     // No operand predicates
     /*  229431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229440 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229458 */     GIR_RootConstrainSelectedInstOperands,
     /*  229459 */     // GIR_Coverage, 8940,
     /*  229459 */     GIR_EraseRootFromParent_Done,
     /*  229460 */   // Label 4527: @229460
     /*  229460 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(229534), // Rule ID 8941 //
     /*  229465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  229479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229505 */     // MIs[1] Operand 1
     /*  229505 */     // No operand predicates
     /*  229505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229514 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229532 */     GIR_RootConstrainSelectedInstOperands,
     /*  229533 */     // GIR_Coverage, 8941,
     /*  229533 */     GIR_EraseRootFromParent_Done,
     /*  229534 */   // Label 4528: @229534
     /*  229534 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(229608), // Rule ID 8944 //
     /*  229539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229579 */     // MIs[1] Operand 1
     /*  229579 */     // No operand predicates
     /*  229579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229588 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  229591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229606 */     GIR_RootConstrainSelectedInstOperands,
     /*  229607 */     // GIR_Coverage, 8944,
     /*  229607 */     GIR_EraseRootFromParent_Done,
     /*  229608 */   // Label 4529: @229608
     /*  229608 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(229682), // Rule ID 8945 //
     /*  229613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229653 */     // MIs[1] Operand 1
     /*  229653 */     // No operand predicates
     /*  229653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229662 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  229665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229680 */     GIR_RootConstrainSelectedInstOperands,
     /*  229681 */     // GIR_Coverage, 8945,
     /*  229681 */     GIR_EraseRootFromParent_Done,
     /*  229682 */   // Label 4530: @229682
     /*  229682 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(229756), // Rule ID 8948 //
     /*  229687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229727 */     // MIs[1] Operand 1
     /*  229727 */     // No operand predicates
     /*  229727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229736 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  229739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229754 */     GIR_RootConstrainSelectedInstOperands,
     /*  229755 */     // GIR_Coverage, 8948,
     /*  229755 */     GIR_EraseRootFromParent_Done,
     /*  229756 */   // Label 4531: @229756
     /*  229756 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(229830), // Rule ID 8949 //
     /*  229761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229801 */     // MIs[1] Operand 1
     /*  229801 */     // No operand predicates
     /*  229801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229810 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  229813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229828 */     GIR_RootConstrainSelectedInstOperands,
     /*  229829 */     // GIR_Coverage, 8949,
     /*  229829 */     GIR_EraseRootFromParent_Done,
     /*  229830 */   // Label 4532: @229830
     /*  229830 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(229904), // Rule ID 8952 //
     /*  229835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  229849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229875 */     // MIs[1] Operand 1
     /*  229875 */     // No operand predicates
     /*  229875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229884 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229902 */     GIR_RootConstrainSelectedInstOperands,
     /*  229903 */     // GIR_Coverage, 8952,
     /*  229903 */     GIR_EraseRootFromParent_Done,
     /*  229904 */   // Label 4533: @229904
     /*  229904 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(229978), // Rule ID 8953 //
     /*  229909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  229923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229949 */     // MIs[1] Operand 1
     /*  229949 */     // No operand predicates
     /*  229949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229958 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229976 */     GIR_RootConstrainSelectedInstOperands,
     /*  229977 */     // GIR_Coverage, 8953,
     /*  229977 */     GIR_EraseRootFromParent_Done,
     /*  229978 */   // Label 4534: @229978
     /*  229978 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(230052), // Rule ID 9132 //
     /*  229983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  229997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230023 */     // MIs[1] Operand 1
     /*  230023 */     // No operand predicates
     /*  230023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230032 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  230035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230050 */     GIR_RootConstrainSelectedInstOperands,
     /*  230051 */     // GIR_Coverage, 9132,
     /*  230051 */     GIR_EraseRootFromParent_Done,
     /*  230052 */   // Label 4535: @230052
     /*  230052 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(230126), // Rule ID 9133 //
     /*  230057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  230071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230097 */     // MIs[1] Operand 1
     /*  230097 */     // No operand predicates
     /*  230097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230106 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  230109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230124 */     GIR_RootConstrainSelectedInstOperands,
     /*  230125 */     // GIR_Coverage, 9133,
     /*  230125 */     GIR_EraseRootFromParent_Done,
     /*  230126 */   // Label 4536: @230126
     /*  230126 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(230200), // Rule ID 9136 //
     /*  230131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  230145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230171 */     // MIs[1] Operand 1
     /*  230171 */     // No operand predicates
     /*  230171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230180 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  230183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230198 */     GIR_RootConstrainSelectedInstOperands,
     /*  230199 */     // GIR_Coverage, 9136,
     /*  230199 */     GIR_EraseRootFromParent_Done,
     /*  230200 */   // Label 4537: @230200
     /*  230200 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(230274), // Rule ID 9137 //
     /*  230205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  230219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230245 */     // MIs[1] Operand 1
     /*  230245 */     // No operand predicates
     /*  230245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230254 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  230257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230272 */     GIR_RootConstrainSelectedInstOperands,
     /*  230273 */     // GIR_Coverage, 9137,
     /*  230273 */     GIR_EraseRootFromParent_Done,
     /*  230274 */   // Label 4538: @230274
     /*  230274 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(230348), // Rule ID 9140 //
     /*  230279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  230293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230319 */     // MIs[1] Operand 1
     /*  230319 */     // No operand predicates
     /*  230319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230328 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230346 */     GIR_RootConstrainSelectedInstOperands,
     /*  230347 */     // GIR_Coverage, 9140,
     /*  230347 */     GIR_EraseRootFromParent_Done,
     /*  230348 */   // Label 4539: @230348
     /*  230348 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(230422), // Rule ID 9141 //
     /*  230353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  230367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230393 */     // MIs[1] Operand 1
     /*  230393 */     // No operand predicates
     /*  230393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230402 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230420 */     GIR_RootConstrainSelectedInstOperands,
     /*  230421 */     // GIR_Coverage, 9141,
     /*  230421 */     GIR_EraseRootFromParent_Done,
     /*  230422 */   // Label 4540: @230422
     /*  230422 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(230496), // Rule ID 9144 //
     /*  230427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  230441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230467 */     // MIs[1] Operand 1
     /*  230467 */     // No operand predicates
     /*  230467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230476 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  230479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230494 */     GIR_RootConstrainSelectedInstOperands,
     /*  230495 */     // GIR_Coverage, 9144,
     /*  230495 */     GIR_EraseRootFromParent_Done,
     /*  230496 */   // Label 4541: @230496
     /*  230496 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(230570), // Rule ID 9145 //
     /*  230501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  230515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230541 */     // MIs[1] Operand 1
     /*  230541 */     // No operand predicates
     /*  230541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230550 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  230553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230568 */     GIR_RootConstrainSelectedInstOperands,
     /*  230569 */     // GIR_Coverage, 9145,
     /*  230569 */     GIR_EraseRootFromParent_Done,
     /*  230570 */   // Label 4542: @230570
     /*  230570 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(230644), // Rule ID 9148 //
     /*  230575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230615 */     // MIs[1] Operand 1
     /*  230615 */     // No operand predicates
     /*  230615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230624 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230642 */     GIR_RootConstrainSelectedInstOperands,
     /*  230643 */     // GIR_Coverage, 9148,
     /*  230643 */     GIR_EraseRootFromParent_Done,
     /*  230644 */   // Label 4543: @230644
     /*  230644 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(230718), // Rule ID 9149 //
     /*  230649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230689 */     // MIs[1] Operand 1
     /*  230689 */     // No operand predicates
     /*  230689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230698 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230716 */     GIR_RootConstrainSelectedInstOperands,
     /*  230717 */     // GIR_Coverage, 9149,
     /*  230717 */     GIR_EraseRootFromParent_Done,
     /*  230718 */   // Label 4544: @230718
     /*  230718 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(230792), // Rule ID 9152 //
     /*  230723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230763 */     // MIs[1] Operand 1
     /*  230763 */     // No operand predicates
     /*  230763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230772 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  230772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230790 */     GIR_RootConstrainSelectedInstOperands,
     /*  230791 */     // GIR_Coverage, 9152,
     /*  230791 */     GIR_EraseRootFromParent_Done,
     /*  230792 */   // Label 4545: @230792
     /*  230792 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(230866), // Rule ID 9153 //
     /*  230797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230837 */     // MIs[1] Operand 1
     /*  230837 */     // No operand predicates
     /*  230837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230846 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  230846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230864 */     GIR_RootConstrainSelectedInstOperands,
     /*  230865 */     // GIR_Coverage, 9153,
     /*  230865 */     GIR_EraseRootFromParent_Done,
     /*  230866 */   // Label 4546: @230866
     /*  230866 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(230940), // Rule ID 9156 //
     /*  230871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  230885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230911 */     // MIs[1] Operand 1
     /*  230911 */     // No operand predicates
     /*  230911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230920 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230938 */     GIR_RootConstrainSelectedInstOperands,
     /*  230939 */     // GIR_Coverage, 9156,
     /*  230939 */     GIR_EraseRootFromParent_Done,
     /*  230940 */   // Label 4547: @230940
     /*  230940 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(231014), // Rule ID 9157 //
     /*  230945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  230959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230985 */     // MIs[1] Operand 1
     /*  230985 */     // No operand predicates
     /*  230985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230994 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231012 */     GIR_RootConstrainSelectedInstOperands,
     /*  231013 */     // GIR_Coverage, 9157,
     /*  231013 */     GIR_EraseRootFromParent_Done,
     /*  231014 */   // Label 4548: @231014
     /*  231014 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(231088), // Rule ID 9160 //
     /*  231019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  231033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231059 */     // MIs[1] Operand 1
     /*  231059 */     // No operand predicates
     /*  231059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231068 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  231071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231086 */     GIR_RootConstrainSelectedInstOperands,
     /*  231087 */     // GIR_Coverage, 9160,
     /*  231087 */     GIR_EraseRootFromParent_Done,
     /*  231088 */   // Label 4549: @231088
     /*  231088 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(231162), // Rule ID 9161 //
     /*  231093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  231107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231133 */     // MIs[1] Operand 1
     /*  231133 */     // No operand predicates
     /*  231133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231142 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  231145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231160 */     GIR_RootConstrainSelectedInstOperands,
     /*  231161 */     // GIR_Coverage, 9161,
     /*  231161 */     GIR_EraseRootFromParent_Done,
     /*  231162 */   // Label 4550: @231162
     /*  231162 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(231236), // Rule ID 9164 //
     /*  231167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  231178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  231181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231207 */     // MIs[1] Operand 1
     /*  231207 */     // No operand predicates
     /*  231207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231216 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  231216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  231219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231234 */     GIR_RootConstrainSelectedInstOperands,
     /*  231235 */     // GIR_Coverage, 9164,
     /*  231235 */     GIR_EraseRootFromParent_Done,
     /*  231236 */   // Label 4551: @231236
     /*  231236 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(231310), // Rule ID 9165 //
     /*  231241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  231252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  231255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231281 */     // MIs[1] Operand 1
     /*  231281 */     // No operand predicates
     /*  231281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231290 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  231290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  231293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231308 */     GIR_RootConstrainSelectedInstOperands,
     /*  231309 */     // GIR_Coverage, 9165,
     /*  231309 */     GIR_EraseRootFromParent_Done,
     /*  231310 */   // Label 4552: @231310
     /*  231310 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(231384), // Rule ID 9168 //
     /*  231315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  231318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  231326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  231329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231355 */     // MIs[1] Operand 1
     /*  231355 */     // No operand predicates
     /*  231355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231364 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  231364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  231367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231382 */     GIR_RootConstrainSelectedInstOperands,
     /*  231383 */     // GIR_Coverage, 9168,
     /*  231383 */     GIR_EraseRootFromParent_Done,
     /*  231384 */   // Label 4553: @231384
     /*  231384 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(231458), // Rule ID 9169 //
     /*  231389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  231392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  231400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  231403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231429 */     // MIs[1] Operand 1
     /*  231429 */     // No operand predicates
     /*  231429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231438 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  231438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  231441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231456 */     GIR_RootConstrainSelectedInstOperands,
     /*  231457 */     // GIR_Coverage, 9169,
     /*  231457 */     GIR_EraseRootFromParent_Done,
     /*  231458 */   // Label 4554: @231458
     /*  231458 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(231532), // Rule ID 9172 //
     /*  231463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  231477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231503 */     // MIs[1] Operand 1
     /*  231503 */     // No operand predicates
     /*  231503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231512 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231530 */     GIR_RootConstrainSelectedInstOperands,
     /*  231531 */     // GIR_Coverage, 9172,
     /*  231531 */     GIR_EraseRootFromParent_Done,
     /*  231532 */   // Label 4555: @231532
     /*  231532 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(231606), // Rule ID 9173 //
     /*  231537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  231551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231577 */     // MIs[1] Operand 1
     /*  231577 */     // No operand predicates
     /*  231577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231586 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231604 */     GIR_RootConstrainSelectedInstOperands,
     /*  231605 */     // GIR_Coverage, 9173,
     /*  231605 */     GIR_EraseRootFromParent_Done,
     /*  231606 */   // Label 4556: @231606
     /*  231606 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(231680), // Rule ID 9176 //
     /*  231611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  231625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231651 */     // MIs[1] Operand 1
     /*  231651 */     // No operand predicates
     /*  231651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231660 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231678 */     GIR_RootConstrainSelectedInstOperands,
     /*  231679 */     // GIR_Coverage, 9176,
     /*  231679 */     GIR_EraseRootFromParent_Done,
     /*  231680 */   // Label 4557: @231680
     /*  231680 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(231754), // Rule ID 9177 //
     /*  231685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  231699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231725 */     // MIs[1] Operand 1
     /*  231725 */     // No operand predicates
     /*  231725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231734 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231752 */     GIR_RootConstrainSelectedInstOperands,
     /*  231753 */     // GIR_Coverage, 9177,
     /*  231753 */     GIR_EraseRootFromParent_Done,
     /*  231754 */   // Label 4558: @231754
     /*  231754 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(231828), // Rule ID 9180 //
     /*  231759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  231770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  231773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231799 */     // MIs[1] Operand 1
     /*  231799 */     // No operand predicates
     /*  231799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231808 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231826 */     GIR_RootConstrainSelectedInstOperands,
     /*  231827 */     // GIR_Coverage, 9180,
     /*  231827 */     GIR_EraseRootFromParent_Done,
     /*  231828 */   // Label 4559: @231828
     /*  231828 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(231902), // Rule ID 9181 //
     /*  231833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  231844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  231847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231873 */     // MIs[1] Operand 1
     /*  231873 */     // No operand predicates
     /*  231873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231882 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231900 */     GIR_RootConstrainSelectedInstOperands,
     /*  231901 */     // GIR_Coverage, 9181,
     /*  231901 */     GIR_EraseRootFromParent_Done,
     /*  231902 */   // Label 4560: @231902
     /*  231902 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(231976), // Rule ID 9184 //
     /*  231907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  231921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231947 */     // MIs[1] Operand 1
     /*  231947 */     // No operand predicates
     /*  231947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231956 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231974 */     GIR_RootConstrainSelectedInstOperands,
     /*  231975 */     // GIR_Coverage, 9184,
     /*  231975 */     GIR_EraseRootFromParent_Done,
     /*  231976 */   // Label 4561: @231976
     /*  231976 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(232050), // Rule ID 9185 //
     /*  231981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  231995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232021 */     // MIs[1] Operand 1
     /*  232021 */     // No operand predicates
     /*  232021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232030 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232048 */     GIR_RootConstrainSelectedInstOperands,
     /*  232049 */     // GIR_Coverage, 9185,
     /*  232049 */     GIR_EraseRootFromParent_Done,
     /*  232050 */   // Label 4562: @232050
     /*  232050 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(232124), // Rule ID 9188 //
     /*  232055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  232069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232095 */     // MIs[1] Operand 1
     /*  232095 */     // No operand predicates
     /*  232095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232104 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232122 */     GIR_RootConstrainSelectedInstOperands,
     /*  232123 */     // GIR_Coverage, 9188,
     /*  232123 */     GIR_EraseRootFromParent_Done,
     /*  232124 */   // Label 4563: @232124
     /*  232124 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(232198), // Rule ID 9189 //
     /*  232129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  232143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232169 */     // MIs[1] Operand 1
     /*  232169 */     // No operand predicates
     /*  232169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232178 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232196 */     GIR_RootConstrainSelectedInstOperands,
     /*  232197 */     // GIR_Coverage, 9189,
     /*  232197 */     GIR_EraseRootFromParent_Done,
     /*  232198 */   // Label 4564: @232198
     /*  232198 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(232272), // Rule ID 9192 //
     /*  232203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  232214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  232217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232243 */     // MIs[1] Operand 1
     /*  232243 */     // No operand predicates
     /*  232243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232252 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232270 */     GIR_RootConstrainSelectedInstOperands,
     /*  232271 */     // GIR_Coverage, 9192,
     /*  232271 */     GIR_EraseRootFromParent_Done,
     /*  232272 */   // Label 4565: @232272
     /*  232272 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(232346), // Rule ID 9193 //
     /*  232277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  232288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  232291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232317 */     // MIs[1] Operand 1
     /*  232317 */     // No operand predicates
     /*  232317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232326 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232344 */     GIR_RootConstrainSelectedInstOperands,
     /*  232345 */     // GIR_Coverage, 9193,
     /*  232345 */     GIR_EraseRootFromParent_Done,
     /*  232346 */   // Label 4566: @232346
     /*  232346 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(232420), // Rule ID 9196 //
     /*  232351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  232365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232391 */     // MIs[1] Operand 1
     /*  232391 */     // No operand predicates
     /*  232391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232400 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232418 */     GIR_RootConstrainSelectedInstOperands,
     /*  232419 */     // GIR_Coverage, 9196,
     /*  232419 */     GIR_EraseRootFromParent_Done,
     /*  232420 */   // Label 4567: @232420
     /*  232420 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(232494), // Rule ID 9197 //
     /*  232425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  232439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232465 */     // MIs[1] Operand 1
     /*  232465 */     // No operand predicates
     /*  232465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232474 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232492 */     GIR_RootConstrainSelectedInstOperands,
     /*  232493 */     // GIR_Coverage, 9197,
     /*  232493 */     GIR_EraseRootFromParent_Done,
     /*  232494 */   // Label 4568: @232494
     /*  232494 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(232568), // Rule ID 9200 //
     /*  232499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  232513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232539 */     // MIs[1] Operand 1
     /*  232539 */     // No operand predicates
     /*  232539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232548 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232566 */     GIR_RootConstrainSelectedInstOperands,
     /*  232567 */     // GIR_Coverage, 9200,
     /*  232567 */     GIR_EraseRootFromParent_Done,
     /*  232568 */   // Label 4569: @232568
     /*  232568 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(232642), // Rule ID 9201 //
     /*  232573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  232587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232613 */     // MIs[1] Operand 1
     /*  232613 */     // No operand predicates
     /*  232613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232622 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232640 */     GIR_RootConstrainSelectedInstOperands,
     /*  232641 */     // GIR_Coverage, 9201,
     /*  232641 */     GIR_EraseRootFromParent_Done,
     /*  232642 */   // Label 4570: @232642
     /*  232642 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(232716), // Rule ID 9204 //
     /*  232647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  232661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232687 */     // MIs[1] Operand 1
     /*  232687 */     // No operand predicates
     /*  232687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232696 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232714 */     GIR_RootConstrainSelectedInstOperands,
     /*  232715 */     // GIR_Coverage, 9204,
     /*  232715 */     GIR_EraseRootFromParent_Done,
     /*  232716 */   // Label 4571: @232716
     /*  232716 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(232790), // Rule ID 9205 //
     /*  232721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  232735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232761 */     // MIs[1] Operand 1
     /*  232761 */     // No operand predicates
     /*  232761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232770 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232788 */     GIR_RootConstrainSelectedInstOperands,
     /*  232789 */     // GIR_Coverage, 9205,
     /*  232789 */     GIR_EraseRootFromParent_Done,
     /*  232790 */   // Label 4572: @232790
     /*  232790 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(232864), // Rule ID 9208 //
     /*  232795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  232809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232835 */     // MIs[1] Operand 1
     /*  232835 */     // No operand predicates
     /*  232835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232844 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232862 */     GIR_RootConstrainSelectedInstOperands,
     /*  232863 */     // GIR_Coverage, 9208,
     /*  232863 */     GIR_EraseRootFromParent_Done,
     /*  232864 */   // Label 4573: @232864
     /*  232864 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(232938), // Rule ID 9209 //
     /*  232869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  232872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  232883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232909 */     // MIs[1] Operand 1
     /*  232909 */     // No operand predicates
     /*  232909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232918 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  232918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232936 */     GIR_RootConstrainSelectedInstOperands,
     /*  232937 */     // GIR_Coverage, 9209,
     /*  232937 */     GIR_EraseRootFromParent_Done,
     /*  232938 */   // Label 4574: @232938
     /*  232938 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(233012), // Rule ID 9212 //
     /*  232943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  232957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232983 */     // MIs[1] Operand 1
     /*  232983 */     // No operand predicates
     /*  232983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232992 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233010 */     GIR_RootConstrainSelectedInstOperands,
     /*  233011 */     // GIR_Coverage, 9212,
     /*  233011 */     GIR_EraseRootFromParent_Done,
     /*  233012 */   // Label 4575: @233012
     /*  233012 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(233086), // Rule ID 9213 //
     /*  233017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  233020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  233031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233057 */     // MIs[1] Operand 1
     /*  233057 */     // No operand predicates
     /*  233057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233066 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  233069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233084 */     GIR_RootConstrainSelectedInstOperands,
     /*  233085 */     // GIR_Coverage, 9213,
     /*  233085 */     GIR_EraseRootFromParent_Done,
     /*  233086 */   // Label 4576: @233086
     /*  233086 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(233160), // Rule ID 9216 //
     /*  233091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  233094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  233105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233131 */     // MIs[1] Operand 1
     /*  233131 */     // No operand predicates
     /*  233131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233140 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  233140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  233143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233158 */     GIR_RootConstrainSelectedInstOperands,
     /*  233159 */     // GIR_Coverage, 9216,
     /*  233159 */     GIR_EraseRootFromParent_Done,
     /*  233160 */   // Label 4577: @233160
     /*  233160 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(233234), // Rule ID 9217 //
     /*  233165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  233168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  233179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233205 */     // MIs[1] Operand 1
     /*  233205 */     // No operand predicates
     /*  233205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233214 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  233217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233232 */     GIR_RootConstrainSelectedInstOperands,
     /*  233233 */     // GIR_Coverage, 9217,
     /*  233233 */     GIR_EraseRootFromParent_Done,
     /*  233234 */   // Label 4578: @233234
     /*  233234 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(233308), // Rule ID 9308 //
     /*  233239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  233253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233279 */     // MIs[1] Operand 1
     /*  233279 */     // No operand predicates
     /*  233279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233288 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  233291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233306 */     GIR_RootConstrainSelectedInstOperands,
     /*  233307 */     // GIR_Coverage, 9308,
     /*  233307 */     GIR_EraseRootFromParent_Done,
     /*  233308 */   // Label 4579: @233308
     /*  233308 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(233382), // Rule ID 9309 //
     /*  233313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  233327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233353 */     // MIs[1] Operand 1
     /*  233353 */     // No operand predicates
     /*  233353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233362 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  233365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233380 */     GIR_RootConstrainSelectedInstOperands,
     /*  233381 */     // GIR_Coverage, 9309,
     /*  233381 */     GIR_EraseRootFromParent_Done,
     /*  233382 */   // Label 4580: @233382
     /*  233382 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(233456), // Rule ID 9312 //
     /*  233387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  233401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233427 */     // MIs[1] Operand 1
     /*  233427 */     // No operand predicates
     /*  233427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233436 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233454 */     GIR_RootConstrainSelectedInstOperands,
     /*  233455 */     // GIR_Coverage, 9312,
     /*  233455 */     GIR_EraseRootFromParent_Done,
     /*  233456 */   // Label 4581: @233456
     /*  233456 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(233530), // Rule ID 9313 //
     /*  233461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  233475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233501 */     // MIs[1] Operand 1
     /*  233501 */     // No operand predicates
     /*  233501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233510 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233528 */     GIR_RootConstrainSelectedInstOperands,
     /*  233529 */     // GIR_Coverage, 9313,
     /*  233529 */     GIR_EraseRootFromParent_Done,
     /*  233530 */   // Label 4582: @233530
     /*  233530 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(233604), // Rule ID 9316 //
     /*  233535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  233549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233575 */     // MIs[1] Operand 1
     /*  233575 */     // No operand predicates
     /*  233575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233584 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233602 */     GIR_RootConstrainSelectedInstOperands,
     /*  233603 */     // GIR_Coverage, 9316,
     /*  233603 */     GIR_EraseRootFromParent_Done,
     /*  233604 */   // Label 4583: @233604
     /*  233604 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(233678), // Rule ID 9317 //
     /*  233609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  233623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233649 */     // MIs[1] Operand 1
     /*  233649 */     // No operand predicates
     /*  233649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233658 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233676 */     GIR_RootConstrainSelectedInstOperands,
     /*  233677 */     // GIR_Coverage, 9317,
     /*  233677 */     GIR_EraseRootFromParent_Done,
     /*  233678 */   // Label 4584: @233678
     /*  233678 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(233752), // Rule ID 9320 //
     /*  233683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233723 */     // MIs[1] Operand 1
     /*  233723 */     // No operand predicates
     /*  233723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233732 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233750 */     GIR_RootConstrainSelectedInstOperands,
     /*  233751 */     // GIR_Coverage, 9320,
     /*  233751 */     GIR_EraseRootFromParent_Done,
     /*  233752 */   // Label 4585: @233752
     /*  233752 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(233826), // Rule ID 9321 //
     /*  233757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233797 */     // MIs[1] Operand 1
     /*  233797 */     // No operand predicates
     /*  233797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233806 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233824 */     GIR_RootConstrainSelectedInstOperands,
     /*  233825 */     // GIR_Coverage, 9321,
     /*  233825 */     GIR_EraseRootFromParent_Done,
     /*  233826 */   // Label 4586: @233826
     /*  233826 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(233900), // Rule ID 9324 //
     /*  233831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  233845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233871 */     // MIs[1] Operand 1
     /*  233871 */     // No operand predicates
     /*  233871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233898 */     GIR_RootConstrainSelectedInstOperands,
     /*  233899 */     // GIR_Coverage, 9324,
     /*  233899 */     GIR_EraseRootFromParent_Done,
     /*  233900 */   // Label 4587: @233900
     /*  233900 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(233974), // Rule ID 9325 //
     /*  233905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  233919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233945 */     // MIs[1] Operand 1
     /*  233945 */     // No operand predicates
     /*  233945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233954 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233972 */     GIR_RootConstrainSelectedInstOperands,
     /*  233973 */     // GIR_Coverage, 9325,
     /*  233973 */     GIR_EraseRootFromParent_Done,
     /*  233974 */   // Label 4588: @233974
     /*  233974 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(234048), // Rule ID 9328 //
     /*  233979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  233993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234019 */     // MIs[1] Operand 1
     /*  234019 */     // No operand predicates
     /*  234019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  234031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234046 */     GIR_RootConstrainSelectedInstOperands,
     /*  234047 */     // GIR_Coverage, 9328,
     /*  234047 */     GIR_EraseRootFromParent_Done,
     /*  234048 */   // Label 4589: @234048
     /*  234048 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(234122), // Rule ID 9329 //
     /*  234053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  234067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234093 */     // MIs[1] Operand 1
     /*  234093 */     // No operand predicates
     /*  234093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  234105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234120 */     GIR_RootConstrainSelectedInstOperands,
     /*  234121 */     // GIR_Coverage, 9329,
     /*  234121 */     GIR_EraseRootFromParent_Done,
     /*  234122 */   // Label 4590: @234122
     /*  234122 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(234196), // Rule ID 9332 //
     /*  234127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  234141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234167 */     // MIs[1] Operand 1
     /*  234167 */     // No operand predicates
     /*  234167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234176 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234194 */     GIR_RootConstrainSelectedInstOperands,
     /*  234195 */     // GIR_Coverage, 9332,
     /*  234195 */     GIR_EraseRootFromParent_Done,
     /*  234196 */   // Label 4591: @234196
     /*  234196 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(234270), // Rule ID 9333 //
     /*  234201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  234215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234241 */     // MIs[1] Operand 1
     /*  234241 */     // No operand predicates
     /*  234241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234250 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234268 */     GIR_RootConstrainSelectedInstOperands,
     /*  234269 */     // GIR_Coverage, 9333,
     /*  234269 */     GIR_EraseRootFromParent_Done,
     /*  234270 */   // Label 4592: @234270
     /*  234270 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(234344), // Rule ID 9336 //
     /*  234275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  234286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  234289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234315 */     // MIs[1] Operand 1
     /*  234315 */     // No operand predicates
     /*  234315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234324 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234342 */     GIR_RootConstrainSelectedInstOperands,
     /*  234343 */     // GIR_Coverage, 9336,
     /*  234343 */     GIR_EraseRootFromParent_Done,
     /*  234344 */   // Label 4593: @234344
     /*  234344 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(234418), // Rule ID 9337 //
     /*  234349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  234360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  234363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234389 */     // MIs[1] Operand 1
     /*  234389 */     // No operand predicates
     /*  234389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234398 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234416 */     GIR_RootConstrainSelectedInstOperands,
     /*  234417 */     // GIR_Coverage, 9337,
     /*  234417 */     GIR_EraseRootFromParent_Done,
     /*  234418 */   // Label 4594: @234418
     /*  234418 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(234492), // Rule ID 9340 //
     /*  234423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  234437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234463 */     // MIs[1] Operand 1
     /*  234463 */     // No operand predicates
     /*  234463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234472 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234490 */     GIR_RootConstrainSelectedInstOperands,
     /*  234491 */     // GIR_Coverage, 9340,
     /*  234491 */     GIR_EraseRootFromParent_Done,
     /*  234492 */   // Label 4595: @234492
     /*  234492 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(234566), // Rule ID 9341 //
     /*  234497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  234511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234537 */     // MIs[1] Operand 1
     /*  234537 */     // No operand predicates
     /*  234537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234546 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234564 */     GIR_RootConstrainSelectedInstOperands,
     /*  234565 */     // GIR_Coverage, 9341,
     /*  234565 */     GIR_EraseRootFromParent_Done,
     /*  234566 */   // Label 4596: @234566
     /*  234566 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(234640), // Rule ID 9344 //
     /*  234571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  234574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234611 */     // MIs[1] Operand 1
     /*  234611 */     // No operand predicates
     /*  234611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  234620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234638 */     GIR_RootConstrainSelectedInstOperands,
     /*  234639 */     // GIR_Coverage, 9344,
     /*  234639 */     GIR_EraseRootFromParent_Done,
     /*  234640 */   // Label 4597: @234640
     /*  234640 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(234714), // Rule ID 9345 //
     /*  234645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  234648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234685 */     // MIs[1] Operand 1
     /*  234685 */     // No operand predicates
     /*  234685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234694 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  234694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234712 */     GIR_RootConstrainSelectedInstOperands,
     /*  234713 */     // GIR_Coverage, 9345,
     /*  234713 */     GIR_EraseRootFromParent_Done,
     /*  234714 */   // Label 4598: @234714
     /*  234714 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(234788), // Rule ID 9348 //
     /*  234719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  234733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234759 */     // MIs[1] Operand 1
     /*  234759 */     // No operand predicates
     /*  234759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234768 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234786 */     GIR_RootConstrainSelectedInstOperands,
     /*  234787 */     // GIR_Coverage, 9348,
     /*  234787 */     GIR_EraseRootFromParent_Done,
     /*  234788 */   // Label 4599: @234788
     /*  234788 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(234862), // Rule ID 9349 //
     /*  234793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  234807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234833 */     // MIs[1] Operand 1
     /*  234833 */     // No operand predicates
     /*  234833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234842 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234860 */     GIR_RootConstrainSelectedInstOperands,
     /*  234861 */     // GIR_Coverage, 9349,
     /*  234861 */     GIR_EraseRootFromParent_Done,
     /*  234862 */   // Label 4600: @234862
     /*  234862 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(234936), // Rule ID 9352 //
     /*  234867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  234881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234907 */     // MIs[1] Operand 1
     /*  234907 */     // No operand predicates
     /*  234907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234916 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234934 */     GIR_RootConstrainSelectedInstOperands,
     /*  234935 */     // GIR_Coverage, 9352,
     /*  234935 */     GIR_EraseRootFromParent_Done,
     /*  234936 */   // Label 4601: @234936
     /*  234936 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(235010), // Rule ID 9353 //
     /*  234941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  234955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234981 */     // MIs[1] Operand 1
     /*  234981 */     // No operand predicates
     /*  234981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234990 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235008 */     GIR_RootConstrainSelectedInstOperands,
     /*  235009 */     // GIR_Coverage, 9353,
     /*  235009 */     GIR_EraseRootFromParent_Done,
     /*  235010 */   // Label 4602: @235010
     /*  235010 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(235084), // Rule ID 9356 //
     /*  235015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  235026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  235029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235055 */     // MIs[1] Operand 1
     /*  235055 */     // No operand predicates
     /*  235055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235064 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  235064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235082 */     GIR_RootConstrainSelectedInstOperands,
     /*  235083 */     // GIR_Coverage, 9356,
     /*  235083 */     GIR_EraseRootFromParent_Done,
     /*  235084 */   // Label 4603: @235084
     /*  235084 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(235158), // Rule ID 9357 //
     /*  235089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  235100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  235103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235129 */     // MIs[1] Operand 1
     /*  235129 */     // No operand predicates
     /*  235129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235138 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  235138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235156 */     GIR_RootConstrainSelectedInstOperands,
     /*  235157 */     // GIR_Coverage, 9357,
     /*  235157 */     GIR_EraseRootFromParent_Done,
     /*  235158 */   // Label 4604: @235158
     /*  235158 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(235232), // Rule ID 9360 //
     /*  235163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  235177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235203 */     // MIs[1] Operand 1
     /*  235203 */     // No operand predicates
     /*  235203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235212 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235230 */     GIR_RootConstrainSelectedInstOperands,
     /*  235231 */     // GIR_Coverage, 9360,
     /*  235231 */     GIR_EraseRootFromParent_Done,
     /*  235232 */   // Label 4605: @235232
     /*  235232 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(235306), // Rule ID 9361 //
     /*  235237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  235251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235277 */     // MIs[1] Operand 1
     /*  235277 */     // No operand predicates
     /*  235277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235286 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235304 */     GIR_RootConstrainSelectedInstOperands,
     /*  235305 */     // GIR_Coverage, 9361,
     /*  235305 */     GIR_EraseRootFromParent_Done,
     /*  235306 */   // Label 4606: @235306
     /*  235306 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(235380), // Rule ID 9364 //
     /*  235311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  235325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235351 */     // MIs[1] Operand 1
     /*  235351 */     // No operand predicates
     /*  235351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235360 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235378 */     GIR_RootConstrainSelectedInstOperands,
     /*  235379 */     // GIR_Coverage, 9364,
     /*  235379 */     GIR_EraseRootFromParent_Done,
     /*  235380 */   // Label 4607: @235380
     /*  235380 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(235454), // Rule ID 9365 //
     /*  235385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  235399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235425 */     // MIs[1] Operand 1
     /*  235425 */     // No operand predicates
     /*  235425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235434 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235452 */     GIR_RootConstrainSelectedInstOperands,
     /*  235453 */     // GIR_Coverage, 9365,
     /*  235453 */     GIR_EraseRootFromParent_Done,
     /*  235454 */   // Label 4608: @235454
     /*  235454 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(235528), // Rule ID 9368 //
     /*  235459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  235473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235499 */     // MIs[1] Operand 1
     /*  235499 */     // No operand predicates
     /*  235499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235508 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235526 */     GIR_RootConstrainSelectedInstOperands,
     /*  235527 */     // GIR_Coverage, 9368,
     /*  235527 */     GIR_EraseRootFromParent_Done,
     /*  235528 */   // Label 4609: @235528
     /*  235528 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(235602), // Rule ID 9369 //
     /*  235533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  235547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235573 */     // MIs[1] Operand 1
     /*  235573 */     // No operand predicates
     /*  235573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235582 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235600 */     GIR_RootConstrainSelectedInstOperands,
     /*  235601 */     // GIR_Coverage, 9369,
     /*  235601 */     GIR_EraseRootFromParent_Done,
     /*  235602 */   // Label 4610: @235602
     /*  235602 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(235676), // Rule ID 9372 //
     /*  235607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235647 */     // MIs[1] Operand 1
     /*  235647 */     // No operand predicates
     /*  235647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235656 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235674 */     GIR_RootConstrainSelectedInstOperands,
     /*  235675 */     // GIR_Coverage, 9372,
     /*  235675 */     GIR_EraseRootFromParent_Done,
     /*  235676 */   // Label 4611: @235676
     /*  235676 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(235750), // Rule ID 9373 //
     /*  235681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235721 */     // MIs[1] Operand 1
     /*  235721 */     // No operand predicates
     /*  235721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235730 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235748 */     GIR_RootConstrainSelectedInstOperands,
     /*  235749 */     // GIR_Coverage, 9373,
     /*  235749 */     GIR_EraseRootFromParent_Done,
     /*  235750 */   // Label 4612: @235750
     /*  235750 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(235824), // Rule ID 9376 //
     /*  235755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235795 */     // MIs[1] Operand 1
     /*  235795 */     // No operand predicates
     /*  235795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235804 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235822 */     GIR_RootConstrainSelectedInstOperands,
     /*  235823 */     // GIR_Coverage, 9376,
     /*  235823 */     GIR_EraseRootFromParent_Done,
     /*  235824 */   // Label 4613: @235824
     /*  235824 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(235898), // Rule ID 9377 //
     /*  235829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235869 */     // MIs[1] Operand 1
     /*  235869 */     // No operand predicates
     /*  235869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235878 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235896 */     GIR_RootConstrainSelectedInstOperands,
     /*  235897 */     // GIR_Coverage, 9377,
     /*  235897 */     GIR_EraseRootFromParent_Done,
     /*  235898 */   // Label 4614: @235898
     /*  235898 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(235972), // Rule ID 9380 //
     /*  235903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  235917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235943 */     // MIs[1] Operand 1
     /*  235943 */     // No operand predicates
     /*  235943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235952 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235970 */     GIR_RootConstrainSelectedInstOperands,
     /*  235971 */     // GIR_Coverage, 9380,
     /*  235971 */     GIR_EraseRootFromParent_Done,
     /*  235972 */   // Label 4615: @235972
     /*  235972 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(236046), // Rule ID 9381 //
     /*  235977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  235991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236017 */     // MIs[1] Operand 1
     /*  236017 */     // No operand predicates
     /*  236017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236026 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  236026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  236029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236044 */     GIR_RootConstrainSelectedInstOperands,
     /*  236045 */     // GIR_Coverage, 9381,
     /*  236045 */     GIR_EraseRootFromParent_Done,
     /*  236046 */   // Label 4616: @236046
     /*  236046 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(236120), // Rule ID 9384 //
     /*  236051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  236065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  236079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236091 */     // MIs[1] Operand 1
     /*  236091 */     // No operand predicates
     /*  236091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236100 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  236103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236118 */     GIR_RootConstrainSelectedInstOperands,
     /*  236119 */     // GIR_Coverage, 9384,
     /*  236119 */     GIR_EraseRootFromParent_Done,
     /*  236120 */   // Label 4617: @236120
     /*  236120 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(236194), // Rule ID 9385 //
     /*  236125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  236139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  236153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236165 */     // MIs[1] Operand 1
     /*  236165 */     // No operand predicates
     /*  236165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236174 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  236177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236192 */     GIR_RootConstrainSelectedInstOperands,
     /*  236193 */     // GIR_Coverage, 9385,
     /*  236193 */     GIR_EraseRootFromParent_Done,
     /*  236194 */   // Label 4618: @236194
     /*  236194 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(236268), // Rule ID 9388 //
     /*  236199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  236213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  236227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236239 */     // MIs[1] Operand 1
     /*  236239 */     // No operand predicates
     /*  236239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236248 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  236251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236266 */     GIR_RootConstrainSelectedInstOperands,
     /*  236267 */     // GIR_Coverage, 9388,
     /*  236267 */     GIR_EraseRootFromParent_Done,
     /*  236268 */   // Label 4619: @236268
     /*  236268 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(236342), // Rule ID 9389 //
     /*  236273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  236287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  236301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236313 */     // MIs[1] Operand 1
     /*  236313 */     // No operand predicates
     /*  236313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236322 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  236325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236340 */     GIR_RootConstrainSelectedInstOperands,
     /*  236341 */     // GIR_Coverage, 9389,
     /*  236341 */     GIR_EraseRootFromParent_Done,
     /*  236342 */   // Label 4620: @236342
     /*  236342 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(236416), // Rule ID 9392 //
     /*  236347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  236361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236387 */     // MIs[1] Operand 1
     /*  236387 */     // No operand predicates
     /*  236387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236396 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  236399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236414 */     GIR_RootConstrainSelectedInstOperands,
     /*  236415 */     // GIR_Coverage, 9392,
     /*  236415 */     GIR_EraseRootFromParent_Done,
     /*  236416 */   // Label 4621: @236416
     /*  236416 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(236490), // Rule ID 9393 //
     /*  236421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  236435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236461 */     // MIs[1] Operand 1
     /*  236461 */     // No operand predicates
     /*  236461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236470 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  236473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236488 */     GIR_RootConstrainSelectedInstOperands,
     /*  236489 */     // GIR_Coverage, 9393,
     /*  236489 */     GIR_EraseRootFromParent_Done,
     /*  236490 */   // Label 4622: @236490
     /*  236490 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(236564), // Rule ID 9484 //
     /*  236495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  236509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236535 */     // MIs[1] Operand 1
     /*  236535 */     // No operand predicates
     /*  236535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236544 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  236547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236562 */     GIR_RootConstrainSelectedInstOperands,
     /*  236563 */     // GIR_Coverage, 9484,
     /*  236563 */     GIR_EraseRootFromParent_Done,
     /*  236564 */   // Label 4623: @236564
     /*  236564 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(236638), // Rule ID 9485 //
     /*  236569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  236583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236609 */     // MIs[1] Operand 1
     /*  236609 */     // No operand predicates
     /*  236609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236618 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  236621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236636 */     GIR_RootConstrainSelectedInstOperands,
     /*  236637 */     // GIR_Coverage, 9485,
     /*  236637 */     GIR_EraseRootFromParent_Done,
     /*  236638 */   // Label 4624: @236638
     /*  236638 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(236712), // Rule ID 9488 //
     /*  236643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  236657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236683 */     // MIs[1] Operand 1
     /*  236683 */     // No operand predicates
     /*  236683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236710 */     GIR_RootConstrainSelectedInstOperands,
     /*  236711 */     // GIR_Coverage, 9488,
     /*  236711 */     GIR_EraseRootFromParent_Done,
     /*  236712 */   // Label 4625: @236712
     /*  236712 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(236786), // Rule ID 9489 //
     /*  236717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  236731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236757 */     // MIs[1] Operand 1
     /*  236757 */     // No operand predicates
     /*  236757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236766 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236784 */     GIR_RootConstrainSelectedInstOperands,
     /*  236785 */     // GIR_Coverage, 9489,
     /*  236785 */     GIR_EraseRootFromParent_Done,
     /*  236786 */   // Label 4626: @236786
     /*  236786 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(236860), // Rule ID 9492 //
     /*  236791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  236805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236831 */     // MIs[1] Operand 1
     /*  236831 */     // No operand predicates
     /*  236831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236858 */     GIR_RootConstrainSelectedInstOperands,
     /*  236859 */     // GIR_Coverage, 9492,
     /*  236859 */     GIR_EraseRootFromParent_Done,
     /*  236860 */   // Label 4627: @236860
     /*  236860 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(236934), // Rule ID 9493 //
     /*  236865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  236879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236905 */     // MIs[1] Operand 1
     /*  236905 */     // No operand predicates
     /*  236905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236914 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236932 */     GIR_RootConstrainSelectedInstOperands,
     /*  236933 */     // GIR_Coverage, 9493,
     /*  236933 */     GIR_EraseRootFromParent_Done,
     /*  236934 */   // Label 4628: @236934
     /*  236934 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(237008), // Rule ID 9496 //
     /*  236939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  236953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236979 */     // MIs[1] Operand 1
     /*  236979 */     // No operand predicates
     /*  236979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236988 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237006 */     GIR_RootConstrainSelectedInstOperands,
     /*  237007 */     // GIR_Coverage, 9496,
     /*  237007 */     GIR_EraseRootFromParent_Done,
     /*  237008 */   // Label 4629: @237008
     /*  237008 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(237082), // Rule ID 9497 //
     /*  237013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  237027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237053 */     // MIs[1] Operand 1
     /*  237053 */     // No operand predicates
     /*  237053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237062 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  237065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237080 */     GIR_RootConstrainSelectedInstOperands,
     /*  237081 */     // GIR_Coverage, 9497,
     /*  237081 */     GIR_EraseRootFromParent_Done,
     /*  237082 */   // Label 4630: @237082
     /*  237082 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(237156), // Rule ID 9500 //
     /*  237087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  237101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237127 */     // MIs[1] Operand 1
     /*  237127 */     // No operand predicates
     /*  237127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237136 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  237139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237154 */     GIR_RootConstrainSelectedInstOperands,
     /*  237155 */     // GIR_Coverage, 9500,
     /*  237155 */     GIR_EraseRootFromParent_Done,
     /*  237156 */   // Label 4631: @237156
     /*  237156 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(237230), // Rule ID 9501 //
     /*  237161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  237175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237201 */     // MIs[1] Operand 1
     /*  237201 */     // No operand predicates
     /*  237201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237210 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  237213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237228 */     GIR_RootConstrainSelectedInstOperands,
     /*  237229 */     // GIR_Coverage, 9501,
     /*  237229 */     GIR_EraseRootFromParent_Done,
     /*  237230 */   // Label 4632: @237230
     /*  237230 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(237304), // Rule ID 9504 //
     /*  237235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  237249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237275 */     // MIs[1] Operand 1
     /*  237275 */     // No operand predicates
     /*  237275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237284 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  237287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237302 */     GIR_RootConstrainSelectedInstOperands,
     /*  237303 */     // GIR_Coverage, 9504,
     /*  237303 */     GIR_EraseRootFromParent_Done,
     /*  237304 */   // Label 4633: @237304
     /*  237304 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(237378), // Rule ID 9505 //
     /*  237309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  237323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237349 */     // MIs[1] Operand 1
     /*  237349 */     // No operand predicates
     /*  237349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  237361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237376 */     GIR_RootConstrainSelectedInstOperands,
     /*  237377 */     // GIR_Coverage, 9505,
     /*  237377 */     GIR_EraseRootFromParent_Done,
     /*  237378 */   // Label 4634: @237378
     /*  237378 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(237452), // Rule ID 9508 //
     /*  237383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  237397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237423 */     // MIs[1] Operand 1
     /*  237423 */     // No operand predicates
     /*  237423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237450 */     GIR_RootConstrainSelectedInstOperands,
     /*  237451 */     // GIR_Coverage, 9508,
     /*  237451 */     GIR_EraseRootFromParent_Done,
     /*  237452 */   // Label 4635: @237452
     /*  237452 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(237526), // Rule ID 9509 //
     /*  237457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  237471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237497 */     // MIs[1] Operand 1
     /*  237497 */     // No operand predicates
     /*  237497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237506 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237524 */     GIR_RootConstrainSelectedInstOperands,
     /*  237525 */     // GIR_Coverage, 9509,
     /*  237525 */     GIR_EraseRootFromParent_Done,
     /*  237526 */   // Label 4636: @237526
     /*  237526 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(237600), // Rule ID 9512 //
     /*  237531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  237545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237571 */     // MIs[1] Operand 1
     /*  237571 */     // No operand predicates
     /*  237571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237580 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237598 */     GIR_RootConstrainSelectedInstOperands,
     /*  237599 */     // GIR_Coverage, 9512,
     /*  237599 */     GIR_EraseRootFromParent_Done,
     /*  237600 */   // Label 4637: @237600
     /*  237600 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(237674), // Rule ID 9513 //
     /*  237605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  237619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237645 */     // MIs[1] Operand 1
     /*  237645 */     // No operand predicates
     /*  237645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237654 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237672 */     GIR_RootConstrainSelectedInstOperands,
     /*  237673 */     // GIR_Coverage, 9513,
     /*  237673 */     GIR_EraseRootFromParent_Done,
     /*  237674 */   // Label 4638: @237674
     /*  237674 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(237748), // Rule ID 9516 //
     /*  237679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  237693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237719 */     // MIs[1] Operand 1
     /*  237719 */     // No operand predicates
     /*  237719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237728 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237746 */     GIR_RootConstrainSelectedInstOperands,
     /*  237747 */     // GIR_Coverage, 9516,
     /*  237747 */     GIR_EraseRootFromParent_Done,
     /*  237748 */   // Label 4639: @237748
     /*  237748 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(237822), // Rule ID 9517 //
     /*  237753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  237767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237793 */     // MIs[1] Operand 1
     /*  237793 */     // No operand predicates
     /*  237793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237802 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237820 */     GIR_RootConstrainSelectedInstOperands,
     /*  237821 */     // GIR_Coverage, 9517,
     /*  237821 */     GIR_EraseRootFromParent_Done,
     /*  237822 */   // Label 4640: @237822
     /*  237822 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(237896), // Rule ID 9520 //
     /*  237827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  237830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  237841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237867 */     // MIs[1] Operand 1
     /*  237867 */     // No operand predicates
     /*  237867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237876 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  237876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237894 */     GIR_RootConstrainSelectedInstOperands,
     /*  237895 */     // GIR_Coverage, 9520,
     /*  237895 */     GIR_EraseRootFromParent_Done,
     /*  237896 */   // Label 4641: @237896
     /*  237896 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(237970), // Rule ID 9521 //
     /*  237901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  237904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  237915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237941 */     // MIs[1] Operand 1
     /*  237941 */     // No operand predicates
     /*  237941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237950 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  237950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237968 */     GIR_RootConstrainSelectedInstOperands,
     /*  237969 */     // GIR_Coverage, 9521,
     /*  237969 */     GIR_EraseRootFromParent_Done,
     /*  237970 */   // Label 4642: @237970
     /*  237970 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(238044), // Rule ID 9524 //
     /*  237975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  237986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  237989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238015 */     // MIs[1] Operand 1
     /*  238015 */     // No operand predicates
     /*  238015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238024 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  238024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238042 */     GIR_RootConstrainSelectedInstOperands,
     /*  238043 */     // GIR_Coverage, 9524,
     /*  238043 */     GIR_EraseRootFromParent_Done,
     /*  238044 */   // Label 4643: @238044
     /*  238044 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(238118), // Rule ID 9525 //
     /*  238049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  238063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238089 */     // MIs[1] Operand 1
     /*  238089 */     // No operand predicates
     /*  238089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238098 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  238098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238116 */     GIR_RootConstrainSelectedInstOperands,
     /*  238117 */     // GIR_Coverage, 9525,
     /*  238117 */     GIR_EraseRootFromParent_Done,
     /*  238118 */   // Label 4644: @238118
     /*  238118 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(238192), // Rule ID 9528 //
     /*  238123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  238137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238163 */     // MIs[1] Operand 1
     /*  238163 */     // No operand predicates
     /*  238163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238172 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  238172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238190 */     GIR_RootConstrainSelectedInstOperands,
     /*  238191 */     // GIR_Coverage, 9528,
     /*  238191 */     GIR_EraseRootFromParent_Done,
     /*  238192 */   // Label 4645: @238192
     /*  238192 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(238266), // Rule ID 9529 //
     /*  238197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  238211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238237 */     // MIs[1] Operand 1
     /*  238237 */     // No operand predicates
     /*  238237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238246 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  238246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238264 */     GIR_RootConstrainSelectedInstOperands,
     /*  238265 */     // GIR_Coverage, 9529,
     /*  238265 */     GIR_EraseRootFromParent_Done,
     /*  238266 */   // Label 4646: @238266
     /*  238266 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(238340), // Rule ID 9532 //
     /*  238271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  238282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  238285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238311 */     // MIs[1] Operand 1
     /*  238311 */     // No operand predicates
     /*  238311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238320 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  238320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238338 */     GIR_RootConstrainSelectedInstOperands,
     /*  238339 */     // GIR_Coverage, 9532,
     /*  238339 */     GIR_EraseRootFromParent_Done,
     /*  238340 */   // Label 4647: @238340
     /*  238340 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(238414), // Rule ID 9533 //
     /*  238345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  238356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  238359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238385 */     // MIs[1] Operand 1
     /*  238385 */     // No operand predicates
     /*  238385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238394 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  238394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238412 */     GIR_RootConstrainSelectedInstOperands,
     /*  238413 */     // GIR_Coverage, 9533,
     /*  238413 */     GIR_EraseRootFromParent_Done,
     /*  238414 */   // Label 4648: @238414
     /*  238414 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(238488), // Rule ID 9536 //
     /*  238419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  238433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238459 */     // MIs[1] Operand 1
     /*  238459 */     // No operand predicates
     /*  238459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238468 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238486 */     GIR_RootConstrainSelectedInstOperands,
     /*  238487 */     // GIR_Coverage, 9536,
     /*  238487 */     GIR_EraseRootFromParent_Done,
     /*  238488 */   // Label 4649: @238488
     /*  238488 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(238562), // Rule ID 9537 //
     /*  238493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  238507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238533 */     // MIs[1] Operand 1
     /*  238533 */     // No operand predicates
     /*  238533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238542 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238560 */     GIR_RootConstrainSelectedInstOperands,
     /*  238561 */     // GIR_Coverage, 9537,
     /*  238561 */     GIR_EraseRootFromParent_Done,
     /*  238562 */   // Label 4650: @238562
     /*  238562 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(238636), // Rule ID 9540 //
     /*  238567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238607 */     // MIs[1] Operand 1
     /*  238607 */     // No operand predicates
     /*  238607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238616 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238634 */     GIR_RootConstrainSelectedInstOperands,
     /*  238635 */     // GIR_Coverage, 9540,
     /*  238635 */     GIR_EraseRootFromParent_Done,
     /*  238636 */   // Label 4651: @238636
     /*  238636 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(238710), // Rule ID 9541 //
     /*  238641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238681 */     // MIs[1] Operand 1
     /*  238681 */     // No operand predicates
     /*  238681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238690 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238708 */     GIR_RootConstrainSelectedInstOperands,
     /*  238709 */     // GIR_Coverage, 9541,
     /*  238709 */     GIR_EraseRootFromParent_Done,
     /*  238710 */   // Label 4652: @238710
     /*  238710 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(238784), // Rule ID 9544 //
     /*  238715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238755 */     // MIs[1] Operand 1
     /*  238755 */     // No operand predicates
     /*  238755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238764 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238782 */     GIR_RootConstrainSelectedInstOperands,
     /*  238783 */     // GIR_Coverage, 9544,
     /*  238783 */     GIR_EraseRootFromParent_Done,
     /*  238784 */   // Label 4653: @238784
     /*  238784 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(238858), // Rule ID 9545 //
     /*  238789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238829 */     // MIs[1] Operand 1
     /*  238829 */     // No operand predicates
     /*  238829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238838 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238856 */     GIR_RootConstrainSelectedInstOperands,
     /*  238857 */     // GIR_Coverage, 9545,
     /*  238857 */     GIR_EraseRootFromParent_Done,
     /*  238858 */   // Label 4654: @238858
     /*  238858 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(238932), // Rule ID 9548 //
     /*  238863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  238877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238903 */     // MIs[1] Operand 1
     /*  238903 */     // No operand predicates
     /*  238903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238912 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  238912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238930 */     GIR_RootConstrainSelectedInstOperands,
     /*  238931 */     // GIR_Coverage, 9548,
     /*  238931 */     GIR_EraseRootFromParent_Done,
     /*  238932 */   // Label 4655: @238932
     /*  238932 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(239006), // Rule ID 9549 //
     /*  238937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  238951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238977 */     // MIs[1] Operand 1
     /*  238977 */     // No operand predicates
     /*  238977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238986 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239004 */     GIR_RootConstrainSelectedInstOperands,
     /*  239005 */     // GIR_Coverage, 9549,
     /*  239005 */     GIR_EraseRootFromParent_Done,
     /*  239006 */   // Label 4656: @239006
     /*  239006 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(239080), // Rule ID 9552 //
     /*  239011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  239025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239051 */     // MIs[1] Operand 1
     /*  239051 */     // No operand predicates
     /*  239051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239060 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  239063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239078 */     GIR_RootConstrainSelectedInstOperands,
     /*  239079 */     // GIR_Coverage, 9552,
     /*  239079 */     GIR_EraseRootFromParent_Done,
     /*  239080 */   // Label 4657: @239080
     /*  239080 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(239154), // Rule ID 9553 //
     /*  239085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  239099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239125 */     // MIs[1] Operand 1
     /*  239125 */     // No operand predicates
     /*  239125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239134 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  239137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239152 */     GIR_RootConstrainSelectedInstOperands,
     /*  239153 */     // GIR_Coverage, 9553,
     /*  239153 */     GIR_EraseRootFromParent_Done,
     /*  239154 */   // Label 4658: @239154
     /*  239154 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(239228), // Rule ID 9556 //
     /*  239159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  239170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  239173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239199 */     // MIs[1] Operand 1
     /*  239199 */     // No operand predicates
     /*  239199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239208 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  239211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239226 */     GIR_RootConstrainSelectedInstOperands,
     /*  239227 */     // GIR_Coverage, 9556,
     /*  239227 */     GIR_EraseRootFromParent_Done,
     /*  239228 */   // Label 4659: @239228
     /*  239228 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(239302), // Rule ID 9557 //
     /*  239233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  239244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  239247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239273 */     // MIs[1] Operand 1
     /*  239273 */     // No operand predicates
     /*  239273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239282 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  239285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239300 */     GIR_RootConstrainSelectedInstOperands,
     /*  239301 */     // GIR_Coverage, 9557,
     /*  239301 */     GIR_EraseRootFromParent_Done,
     /*  239302 */   // Label 4660: @239302
     /*  239302 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(239376), // Rule ID 9560 //
     /*  239307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  239318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  239321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239347 */     // MIs[1] Operand 1
     /*  239347 */     // No operand predicates
     /*  239347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239356 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  239359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239374 */     GIR_RootConstrainSelectedInstOperands,
     /*  239375 */     // GIR_Coverage, 9560,
     /*  239375 */     GIR_EraseRootFromParent_Done,
     /*  239376 */   // Label 4661: @239376
     /*  239376 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(239450), // Rule ID 9561 //
     /*  239381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  239392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  239395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239421 */     // MIs[1] Operand 1
     /*  239421 */     // No operand predicates
     /*  239421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239430 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  239433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239448 */     GIR_RootConstrainSelectedInstOperands,
     /*  239449 */     // GIR_Coverage, 9561,
     /*  239449 */     GIR_EraseRootFromParent_Done,
     /*  239450 */   // Label 4662: @239450
     /*  239450 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(239524), // Rule ID 9564 //
     /*  239455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239495 */     // MIs[1] Operand 1
     /*  239495 */     // No operand predicates
     /*  239495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239504 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  239507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239522 */     GIR_RootConstrainSelectedInstOperands,
     /*  239523 */     // GIR_Coverage, 9564,
     /*  239523 */     GIR_EraseRootFromParent_Done,
     /*  239524 */   // Label 4663: @239524
     /*  239524 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(239598), // Rule ID 9565 //
     /*  239529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239569 */     // MIs[1] Operand 1
     /*  239569 */     // No operand predicates
     /*  239569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239578 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  239581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239596 */     GIR_RootConstrainSelectedInstOperands,
     /*  239597 */     // GIR_Coverage, 9565,
     /*  239597 */     GIR_EraseRootFromParent_Done,
     /*  239598 */   // Label 4664: @239598
     /*  239598 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(239672), // Rule ID 9568 //
     /*  239603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239643 */     // MIs[1] Operand 1
     /*  239643 */     // No operand predicates
     /*  239643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239652 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  239655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239670 */     GIR_RootConstrainSelectedInstOperands,
     /*  239671 */     // GIR_Coverage, 9568,
     /*  239671 */     GIR_EraseRootFromParent_Done,
     /*  239672 */   // Label 4665: @239672
     /*  239672 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(239746), // Rule ID 9569 //
     /*  239677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239717 */     // MIs[1] Operand 1
     /*  239717 */     // No operand predicates
     /*  239717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239726 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  239729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239744 */     GIR_RootConstrainSelectedInstOperands,
     /*  239745 */     // GIR_Coverage, 9569,
     /*  239745 */     GIR_EraseRootFromParent_Done,
     /*  239746 */   // Label 4666: @239746
     /*  239746 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(239802), // Rule ID 64459 //
     /*  239751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  239754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bitrev),
     /*  239759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  239762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  239765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239773 */     // MIs[0] pts
     /*  239773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  239776 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  239781 */     // MIs[0] radix
     /*  239781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  239784 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm2),
     /*  239789 */     // (intrinsic_wo_chain:{ *:[i32] } 11033:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts)
     /*  239789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /*  239792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239796 */     GIR_RootToRootCopy, /*OpIdx*/4, // radix
     /*  239798 */     GIR_RootToRootCopy, /*OpIdx*/3, // pts
     /*  239800 */     GIR_RootConstrainSelectedInstOperands,
     /*  239801 */     // GIR_Coverage, 64459,
     /*  239801 */     GIR_EraseRootFromParent_Done,
     /*  239802 */   // Label 4667: @239802
     /*  239802 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(239865), // Rule ID 2698 //
     /*  239807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  239810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  239815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  239818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  239821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  239839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239846 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  239846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  239849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239853 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  239855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239863 */     GIR_RootConstrainSelectedInstOperands,
     /*  239864 */     // GIR_Coverage, 2698,
     /*  239864 */     GIR_EraseRootFromParent_Done,
     /*  239865 */   // Label 4668: @239865
     /*  239865 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(239928), // Rule ID 2699 //
     /*  239870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  239873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  239878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  239881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  239884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  239902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239909 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  239909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  239912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239916 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  239918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239926 */     GIR_RootConstrainSelectedInstOperands,
     /*  239927 */     // GIR_Coverage, 2699,
     /*  239927 */     GIR_EraseRootFromParent_Done,
     /*  239928 */   // Label 4669: @239928
     /*  239928 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(239994), // Rule ID 2706 //
     /*  239933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  239941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  239944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239972 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  239972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  239975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239992 */     GIR_RootConstrainSelectedInstOperands,
     /*  239993 */     // GIR_Coverage, 2706,
     /*  239993 */     GIR_EraseRootFromParent_Done,
     /*  239994 */   // Label 4670: @239994
     /*  239994 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(240060), // Rule ID 2707 //
     /*  239999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  240007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  240010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  240016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240038 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  240038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  240041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240058 */     GIR_RootConstrainSelectedInstOperands,
     /*  240059 */     // GIR_Coverage, 2707,
     /*  240059 */     GIR_EraseRootFromParent_Done,
     /*  240060 */   // Label 4671: @240060
     /*  240060 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(240126), // Rule ID 2710 //
     /*  240065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240104 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  240107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240124 */     GIR_RootConstrainSelectedInstOperands,
     /*  240125 */     // GIR_Coverage, 2710,
     /*  240125 */     GIR_EraseRootFromParent_Done,
     /*  240126 */   // Label 4672: @240126
     /*  240126 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(240192), // Rule ID 2711 //
     /*  240131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240170 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  240173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240190 */     GIR_RootConstrainSelectedInstOperands,
     /*  240191 */     // GIR_Coverage, 2711,
     /*  240191 */     GIR_EraseRootFromParent_Done,
     /*  240192 */   // Label 4673: @240192
     /*  240192 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(240258), // Rule ID 2714 //
     /*  240197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  240200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  240205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240236 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  240239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240256 */     GIR_RootConstrainSelectedInstOperands,
     /*  240257 */     // GIR_Coverage, 2714,
     /*  240257 */     GIR_EraseRootFromParent_Done,
     /*  240258 */   // Label 4674: @240258
     /*  240258 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(240324), // Rule ID 2715 //
     /*  240263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  240266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  240271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240302 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  240305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240322 */     GIR_RootConstrainSelectedInstOperands,
     /*  240323 */     // GIR_Coverage, 2715,
     /*  240323 */     GIR_EraseRootFromParent_Done,
     /*  240324 */   // Label 4675: @240324
     /*  240324 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(240387), // Rule ID 2728 //
     /*  240329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  240337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240368 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  240371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240385 */     GIR_RootConstrainSelectedInstOperands,
     /*  240386 */     // GIR_Coverage, 2728,
     /*  240386 */     GIR_EraseRootFromParent_Done,
     /*  240387 */   // Label 4676: @240387
     /*  240387 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(240450), // Rule ID 2729 //
     /*  240392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  240400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240431 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  240434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240448 */     GIR_RootConstrainSelectedInstOperands,
     /*  240449 */     // GIR_Coverage, 2729,
     /*  240449 */     GIR_EraseRootFromParent_Done,
     /*  240450 */   // Label 4677: @240450
     /*  240450 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(240513), // Rule ID 2740 //
     /*  240455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  240463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240494 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  240497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240511 */     GIR_RootConstrainSelectedInstOperands,
     /*  240512 */     // GIR_Coverage, 2740,
     /*  240512 */     GIR_EraseRootFromParent_Done,
     /*  240513 */   // Label 4678: @240513
     /*  240513 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(240576), // Rule ID 2741 //
     /*  240518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  240526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240557 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  240560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240574 */     GIR_RootConstrainSelectedInstOperands,
     /*  240575 */     // GIR_Coverage, 2741,
     /*  240575 */     GIR_EraseRootFromParent_Done,
     /*  240576 */   // Label 4679: @240576
     /*  240576 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(240639), // Rule ID 2748 //
     /*  240581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  240589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  240623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240637 */     GIR_RootConstrainSelectedInstOperands,
     /*  240638 */     // GIR_Coverage, 2748,
     /*  240638 */     GIR_EraseRootFromParent_Done,
     /*  240639 */   // Label 4680: @240639
     /*  240639 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(240702), // Rule ID 2749 //
     /*  240644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  240652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240683 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  240686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240700 */     GIR_RootConstrainSelectedInstOperands,
     /*  240701 */     // GIR_Coverage, 2749,
     /*  240701 */     GIR_EraseRootFromParent_Done,
     /*  240702 */   // Label 4681: @240702
     /*  240702 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(240768), // Rule ID 2750 //
     /*  240707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  240710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  240715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  240749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240766 */     GIR_RootConstrainSelectedInstOperands,
     /*  240767 */     // GIR_Coverage, 2750,
     /*  240767 */     GIR_EraseRootFromParent_Done,
     /*  240768 */   // Label 4682: @240768
     /*  240768 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(240834), // Rule ID 2751 //
     /*  240773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  240776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  240781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240812 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  240815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240832 */     GIR_RootConstrainSelectedInstOperands,
     /*  240833 */     // GIR_Coverage, 2751,
     /*  240833 */     GIR_EraseRootFromParent_Done,
     /*  240834 */   // Label 4683: @240834
     /*  240834 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(240897), // Rule ID 2762 //
     /*  240839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  240847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  240853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  240856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240878 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  240878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  240881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240895 */     GIR_RootConstrainSelectedInstOperands,
     /*  240896 */     // GIR_Coverage, 2762,
     /*  240896 */     GIR_EraseRootFromParent_Done,
     /*  240897 */   // Label 4684: @240897
     /*  240897 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(240960), // Rule ID 2763 //
     /*  240902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  240910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  240916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  240919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240941 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  240941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  240944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240958 */     GIR_RootConstrainSelectedInstOperands,
     /*  240959 */     // GIR_Coverage, 2763,
     /*  240959 */     GIR_EraseRootFromParent_Done,
     /*  240960 */   // Label 4685: @240960
     /*  240960 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(241026), // Rule ID 4910 //
     /*  240965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  240976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  240979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  240982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241004 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  241004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  241007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241024 */     GIR_RootConstrainSelectedInstOperands,
     /*  241025 */     // GIR_Coverage, 4910,
     /*  241025 */     GIR_EraseRootFromParent_Done,
     /*  241026 */   // Label 4686: @241026
     /*  241026 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(241092), // Rule ID 4911 //
     /*  241031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  241042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  241045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  241048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241070 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  241073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241090 */     GIR_RootConstrainSelectedInstOperands,
     /*  241091 */     // GIR_Coverage, 4911,
     /*  241091 */     GIR_EraseRootFromParent_Done,
     /*  241092 */   // Label 4687: @241092
     /*  241092 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(241158), // Rule ID 4914 //
     /*  241097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  241108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  241111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  241114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241136 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  241136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241156 */     GIR_RootConstrainSelectedInstOperands,
     /*  241157 */     // GIR_Coverage, 4914,
     /*  241157 */     GIR_EraseRootFromParent_Done,
     /*  241158 */   // Label 4688: @241158
     /*  241158 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(241224), // Rule ID 4915 //
     /*  241163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  241174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  241177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  241180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241222 */     GIR_RootConstrainSelectedInstOperands,
     /*  241223 */     // GIR_Coverage, 4915,
     /*  241223 */     GIR_EraseRootFromParent_Done,
     /*  241224 */   // Label 4689: @241224
     /*  241224 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(241290), // Rule ID 4918 //
     /*  241229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  241240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  241243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  241246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  241268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241288 */     GIR_RootConstrainSelectedInstOperands,
     /*  241289 */     // GIR_Coverage, 4918,
     /*  241289 */     GIR_EraseRootFromParent_Done,
     /*  241290 */   // Label 4690: @241290
     /*  241290 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(241356), // Rule ID 4919 //
     /*  241295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  241306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  241309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  241312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241354 */     GIR_RootConstrainSelectedInstOperands,
     /*  241355 */     // GIR_Coverage, 4919,
     /*  241355 */     GIR_EraseRootFromParent_Done,
     /*  241356 */   // Label 4691: @241356
     /*  241356 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(241422), // Rule ID 4922 //
     /*  241361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  241372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  241375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  241378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  241400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241420 */     GIR_RootConstrainSelectedInstOperands,
     /*  241421 */     // GIR_Coverage, 4922,
     /*  241421 */     GIR_EraseRootFromParent_Done,
     /*  241422 */   // Label 4692: @241422
     /*  241422 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(241488), // Rule ID 4923 //
     /*  241427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  241438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  241441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  241444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241466 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241486 */     GIR_RootConstrainSelectedInstOperands,
     /*  241487 */     // GIR_Coverage, 4923,
     /*  241487 */     GIR_EraseRootFromParent_Done,
     /*  241488 */   // Label 4693: @241488
     /*  241488 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(241554), // Rule ID 4926 //
     /*  241493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  241504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  241507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  241510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241532 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  241532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241552 */     GIR_RootConstrainSelectedInstOperands,
     /*  241553 */     // GIR_Coverage, 4926,
     /*  241553 */     GIR_EraseRootFromParent_Done,
     /*  241554 */   // Label 4694: @241554
     /*  241554 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(241620), // Rule ID 4927 //
     /*  241559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  241570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  241573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  241576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241598 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241618 */     GIR_RootConstrainSelectedInstOperands,
     /*  241619 */     // GIR_Coverage, 4927,
     /*  241619 */     GIR_EraseRootFromParent_Done,
     /*  241620 */   // Label 4695: @241620
     /*  241620 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(241686), // Rule ID 4930 //
     /*  241625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  241636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  241639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  241642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241664 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  241667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241684 */     GIR_RootConstrainSelectedInstOperands,
     /*  241685 */     // GIR_Coverage, 4930,
     /*  241685 */     GIR_EraseRootFromParent_Done,
     /*  241686 */   // Label 4696: @241686
     /*  241686 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(241752), // Rule ID 4931 //
     /*  241691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  241702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  241705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  241708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241730 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  241733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241750 */     GIR_RootConstrainSelectedInstOperands,
     /*  241751 */     // GIR_Coverage, 4931,
     /*  241751 */     GIR_EraseRootFromParent_Done,
     /*  241752 */   // Label 4697: @241752
     /*  241752 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(241818), // Rule ID 4934 //
     /*  241757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  241768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  241774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241816 */     GIR_RootConstrainSelectedInstOperands,
     /*  241817 */     // GIR_Coverage, 4934,
     /*  241817 */     GIR_EraseRootFromParent_Done,
     /*  241818 */   // Label 4698: @241818
     /*  241818 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(241884), // Rule ID 4935 //
     /*  241823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  241834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  241840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241862 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241882 */     GIR_RootConstrainSelectedInstOperands,
     /*  241883 */     // GIR_Coverage, 4935,
     /*  241883 */     GIR_EraseRootFromParent_Done,
     /*  241884 */   // Label 4699: @241884
     /*  241884 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(241950), // Rule ID 4938 //
     /*  241889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  241900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  241903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  241906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241948 */     GIR_RootConstrainSelectedInstOperands,
     /*  241949 */     // GIR_Coverage, 4938,
     /*  241949 */     GIR_EraseRootFromParent_Done,
     /*  241950 */   // Label 4700: @241950
     /*  241950 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(242016), // Rule ID 4939 //
     /*  241955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  241966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  241969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  241972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242014 */     GIR_RootConstrainSelectedInstOperands,
     /*  242015 */     // GIR_Coverage, 4939,
     /*  242015 */     GIR_EraseRootFromParent_Done,
     /*  242016 */   // Label 4701: @242016
     /*  242016 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(242082), // Rule ID 4942 //
     /*  242021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  242032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  242038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242060 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  242063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242080 */     GIR_RootConstrainSelectedInstOperands,
     /*  242081 */     // GIR_Coverage, 4942,
     /*  242081 */     GIR_EraseRootFromParent_Done,
     /*  242082 */   // Label 4702: @242082
     /*  242082 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(242148), // Rule ID 4943 //
     /*  242087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  242098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  242104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242126 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  242129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242146 */     GIR_RootConstrainSelectedInstOperands,
     /*  242147 */     // GIR_Coverage, 4943,
     /*  242147 */     GIR_EraseRootFromParent_Done,
     /*  242148 */   // Label 4703: @242148
     /*  242148 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(242214), // Rule ID 4946 //
     /*  242153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  242164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  242170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242192 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  242195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242212 */     GIR_RootConstrainSelectedInstOperands,
     /*  242213 */     // GIR_Coverage, 4946,
     /*  242213 */     GIR_EraseRootFromParent_Done,
     /*  242214 */   // Label 4704: @242214
     /*  242214 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(242280), // Rule ID 4947 //
     /*  242219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  242230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  242236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242258 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  242261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242278 */     GIR_RootConstrainSelectedInstOperands,
     /*  242279 */     // GIR_Coverage, 4947,
     /*  242279 */     GIR_EraseRootFromParent_Done,
     /*  242280 */   // Label 4705: @242280
     /*  242280 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(242346), // Rule ID 4950 //
     /*  242285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  242296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  242299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  242302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242324 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  242327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242344 */     GIR_RootConstrainSelectedInstOperands,
     /*  242345 */     // GIR_Coverage, 4950,
     /*  242345 */     GIR_EraseRootFromParent_Done,
     /*  242346 */   // Label 4706: @242346
     /*  242346 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(242412), // Rule ID 4951 //
     /*  242351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  242362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  242365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  242368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  242393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242410 */     GIR_RootConstrainSelectedInstOperands,
     /*  242411 */     // GIR_Coverage, 4951,
     /*  242411 */     GIR_EraseRootFromParent_Done,
     /*  242412 */   // Label 4707: @242412
     /*  242412 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(242478), // Rule ID 4954 //
     /*  242417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  242428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  242431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  242434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  242459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242476 */     GIR_RootConstrainSelectedInstOperands,
     /*  242477 */     // GIR_Coverage, 4954,
     /*  242477 */     GIR_EraseRootFromParent_Done,
     /*  242478 */   // Label 4708: @242478
     /*  242478 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(242544), // Rule ID 4955 //
     /*  242483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  242494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  242497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  242500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242522 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  242525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242542 */     GIR_RootConstrainSelectedInstOperands,
     /*  242543 */     // GIR_Coverage, 4955,
     /*  242543 */     GIR_EraseRootFromParent_Done,
     /*  242544 */   // Label 4709: @242544
     /*  242544 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(242610), // Rule ID 4958 //
     /*  242549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  242560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  242566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242588 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  242591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242608 */     GIR_RootConstrainSelectedInstOperands,
     /*  242609 */     // GIR_Coverage, 4958,
     /*  242609 */     GIR_EraseRootFromParent_Done,
     /*  242610 */   // Label 4710: @242610
     /*  242610 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(242676), // Rule ID 4959 //
     /*  242615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  242626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  242632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242654 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  242657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242674 */     GIR_RootConstrainSelectedInstOperands,
     /*  242675 */     // GIR_Coverage, 4959,
     /*  242675 */     GIR_EraseRootFromParent_Done,
     /*  242676 */   // Label 4711: @242676
     /*  242676 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(242742), // Rule ID 4962 //
     /*  242681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  242692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  242695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  242698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242720 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  242723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242740 */     GIR_RootConstrainSelectedInstOperands,
     /*  242741 */     // GIR_Coverage, 4962,
     /*  242741 */     GIR_EraseRootFromParent_Done,
     /*  242742 */   // Label 4712: @242742
     /*  242742 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(242808), // Rule ID 4963 //
     /*  242747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  242758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  242761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  242764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  242789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242806 */     GIR_RootConstrainSelectedInstOperands,
     /*  242807 */     // GIR_Coverage, 4963,
     /*  242807 */     GIR_EraseRootFromParent_Done,
     /*  242808 */   // Label 4713: @242808
     /*  242808 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(242874), // Rule ID 4966 //
     /*  242813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  242824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  242827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  242830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242852 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  242855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242872 */     GIR_RootConstrainSelectedInstOperands,
     /*  242873 */     // GIR_Coverage, 4966,
     /*  242873 */     GIR_EraseRootFromParent_Done,
     /*  242874 */   // Label 4714: @242874
     /*  242874 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(242940), // Rule ID 4967 //
     /*  242879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  242890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  242893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  242896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  242921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242938 */     GIR_RootConstrainSelectedInstOperands,
     /*  242939 */     // GIR_Coverage, 4967,
     /*  242939 */     GIR_EraseRootFromParent_Done,
     /*  242940 */   // Label 4715: @242940
     /*  242940 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(243006), // Rule ID 4970 //
     /*  242945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  242956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  242959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  242962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  242987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243004 */     GIR_RootConstrainSelectedInstOperands,
     /*  243005 */     // GIR_Coverage, 4970,
     /*  243005 */     GIR_EraseRootFromParent_Done,
     /*  243006 */   // Label 4716: @243006
     /*  243006 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(243072), // Rule ID 4971 //
     /*  243011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  243022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  243025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  243028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  243050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  243053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243070 */     GIR_RootConstrainSelectedInstOperands,
     /*  243071 */     // GIR_Coverage, 4971,
     /*  243071 */     GIR_EraseRootFromParent_Done,
     /*  243072 */   // Label 4717: @243072
     /*  243072 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(243138), // Rule ID 4974 //
     /*  243077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  243088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  243091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  243094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243116 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  243116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  243119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243136 */     GIR_RootConstrainSelectedInstOperands,
     /*  243137 */     // GIR_Coverage, 4974,
     /*  243137 */     GIR_EraseRootFromParent_Done,
     /*  243138 */   // Label 4718: @243138
     /*  243138 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(243204), // Rule ID 4975 //
     /*  243143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  243154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  243157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  243160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243182 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  243182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  243185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243202 */     GIR_RootConstrainSelectedInstOperands,
     /*  243203 */     // GIR_Coverage, 4975,
     /*  243203 */     GIR_EraseRootFromParent_Done,
     /*  243204 */   // Label 4719: @243204
     /*  243204 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(243270), // Rule ID 4978 //
     /*  243209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  243220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  243223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  243226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  243248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  243251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243268 */     GIR_RootConstrainSelectedInstOperands,
     /*  243269 */     // GIR_Coverage, 4978,
     /*  243269 */     GIR_EraseRootFromParent_Done,
     /*  243270 */   // Label 4720: @243270
     /*  243270 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(243336), // Rule ID 4979 //
     /*  243275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  243286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  243289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  243292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  243314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  243317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243334 */     GIR_RootConstrainSelectedInstOperands,
     /*  243335 */     // GIR_Coverage, 4979,
     /*  243335 */     GIR_EraseRootFromParent_Done,
     /*  243336 */   // Label 4721: @243336
     /*  243336 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(243402), // Rule ID 4982 //
     /*  243341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  243352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  243355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  243358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243380 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  243380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  243383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243400 */     GIR_RootConstrainSelectedInstOperands,
     /*  243401 */     // GIR_Coverage, 4982,
     /*  243401 */     GIR_EraseRootFromParent_Done,
     /*  243402 */   // Label 4722: @243402
     /*  243402 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(243468), // Rule ID 4983 //
     /*  243407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  243418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  243421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  243424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  243446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  243449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243466 */     GIR_RootConstrainSelectedInstOperands,
     /*  243467 */     // GIR_Coverage, 4983,
     /*  243467 */     GIR_EraseRootFromParent_Done,
     /*  243468 */   // Label 4723: @243468
     /*  243468 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(243534), // Rule ID 4986 //
     /*  243473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  243490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243512 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  243515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243532 */     GIR_RootConstrainSelectedInstOperands,
     /*  243533 */     // GIR_Coverage, 4986,
     /*  243533 */     GIR_EraseRootFromParent_Done,
     /*  243534 */   // Label 4724: @243534
     /*  243534 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(243600), // Rule ID 4987 //
     /*  243539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  243556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243578 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  243581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243598 */     GIR_RootConstrainSelectedInstOperands,
     /*  243599 */     // GIR_Coverage, 4987,
     /*  243599 */     GIR_EraseRootFromParent_Done,
     /*  243600 */   // Label 4725: @243600
     /*  243600 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(243666), // Rule ID 4990 //
     /*  243605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  243622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  243647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243664 */     GIR_RootConstrainSelectedInstOperands,
     /*  243665 */     // GIR_Coverage, 4990,
     /*  243665 */     GIR_EraseRootFromParent_Done,
     /*  243666 */   // Label 4726: @243666
     /*  243666 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(243732), // Rule ID 4991 //
     /*  243671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  243688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  243713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243730 */     GIR_RootConstrainSelectedInstOperands,
     /*  243731 */     // GIR_Coverage, 4991,
     /*  243731 */     GIR_EraseRootFromParent_Done,
     /*  243732 */   // Label 4727: @243732
     /*  243732 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(243798), // Rule ID 4994 //
     /*  243737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  243754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243776 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  243779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243796 */     GIR_RootConstrainSelectedInstOperands,
     /*  243797 */     // GIR_Coverage, 4994,
     /*  243797 */     GIR_EraseRootFromParent_Done,
     /*  243798 */   // Label 4728: @243798
     /*  243798 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(243864), // Rule ID 4995 //
     /*  243803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  243820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243842 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  243845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243862 */     GIR_RootConstrainSelectedInstOperands,
     /*  243863 */     // GIR_Coverage, 4995,
     /*  243863 */     GIR_EraseRootFromParent_Done,
     /*  243864 */   // Label 4729: @243864
     /*  243864 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(243930), // Rule ID 4998 //
     /*  243869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  243880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  243886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243908 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  243911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243928 */     GIR_RootConstrainSelectedInstOperands,
     /*  243929 */     // GIR_Coverage, 4998,
     /*  243929 */     GIR_EraseRootFromParent_Done,
     /*  243930 */   // Label 4730: @243930
     /*  243930 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(243996), // Rule ID 4999 //
     /*  243935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  243946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  243952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243974 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  243977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243994 */     GIR_RootConstrainSelectedInstOperands,
     /*  243995 */     // GIR_Coverage, 4999,
     /*  243995 */     GIR_EraseRootFromParent_Done,
     /*  243996 */   // Label 4731: @243996
     /*  243996 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(244062), // Rule ID 5002 //
     /*  244001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  244004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  244012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  244015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  244040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  244043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244060 */     GIR_RootConstrainSelectedInstOperands,
     /*  244061 */     // GIR_Coverage, 5002,
     /*  244061 */     GIR_EraseRootFromParent_Done,
     /*  244062 */   // Label 4732: @244062
     /*  244062 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(244128), // Rule ID 5003 //
     /*  244067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  244070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  244078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  244081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  244106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  244109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244126 */     GIR_RootConstrainSelectedInstOperands,
     /*  244127 */     // GIR_Coverage, 5003,
     /*  244127 */     GIR_EraseRootFromParent_Done,
     /*  244128 */   // Label 4733: @244128
     /*  244128 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(244194), // Rule ID 5006 //
     /*  244133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  244136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  244144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  244147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  244172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  244175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244192 */     GIR_RootConstrainSelectedInstOperands,
     /*  244193 */     // GIR_Coverage, 5006,
     /*  244193 */     GIR_EraseRootFromParent_Done,
     /*  244194 */   // Label 4734: @244194
     /*  244194 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(244260), // Rule ID 5007 //
     /*  244199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  244202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  244210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  244213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  244238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  244241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244258 */     GIR_RootConstrainSelectedInstOperands,
     /*  244259 */     // GIR_Coverage, 5007,
     /*  244259 */     GIR_EraseRootFromParent_Done,
     /*  244260 */   // Label 4735: @244260
     /*  244260 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(244326), // Rule ID 5010 //
     /*  244265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  244268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  244276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  244279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  244304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  244307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244324 */     GIR_RootConstrainSelectedInstOperands,
     /*  244325 */     // GIR_Coverage, 5010,
     /*  244325 */     GIR_EraseRootFromParent_Done,
     /*  244326 */   // Label 4736: @244326
     /*  244326 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(244392), // Rule ID 5011 //
     /*  244331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  244334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  244342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  244345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244370 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  244370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  244373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244390 */     GIR_RootConstrainSelectedInstOperands,
     /*  244391 */     // GIR_Coverage, 5011,
     /*  244391 */     GIR_EraseRootFromParent_Done,
     /*  244392 */   // Label 4737: @244392
     /*  244392 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(244458), // Rule ID 5014 //
     /*  244397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  244400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  244408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  244411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244436 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  244436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  244439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244456 */     GIR_RootConstrainSelectedInstOperands,
     /*  244457 */     // GIR_Coverage, 5014,
     /*  244457 */     GIR_EraseRootFromParent_Done,
     /*  244458 */   // Label 4738: @244458
     /*  244458 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(244524), // Rule ID 5015 //
     /*  244463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  244466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  244474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  244477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  244502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  244505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244522 */     GIR_RootConstrainSelectedInstOperands,
     /*  244523 */     // GIR_Coverage, 5015,
     /*  244523 */     GIR_EraseRootFromParent_Done,
     /*  244524 */   // Label 4739: @244524
     /*  244524 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(244590), // Rule ID 5018 //
     /*  244529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  244540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  244543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  244571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244588 */     GIR_RootConstrainSelectedInstOperands,
     /*  244589 */     // GIR_Coverage, 5018,
     /*  244589 */     GIR_EraseRootFromParent_Done,
     /*  244590 */   // Label 4740: @244590
     /*  244590 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(244656), // Rule ID 5019 //
     /*  244595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  244606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  244609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244634 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  244637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244654 */     GIR_RootConstrainSelectedInstOperands,
     /*  244655 */     // GIR_Coverage, 5019,
     /*  244655 */     GIR_EraseRootFromParent_Done,
     /*  244656 */   // Label 4741: @244656
     /*  244656 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(244722), // Rule ID 5022 //
     /*  244661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  244672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  244675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244700 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244720 */     GIR_RootConstrainSelectedInstOperands,
     /*  244721 */     // GIR_Coverage, 5022,
     /*  244721 */     GIR_EraseRootFromParent_Done,
     /*  244722 */   // Label 4742: @244722
     /*  244722 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(244788), // Rule ID 5023 //
     /*  244727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  244738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  244741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244766 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244786 */     GIR_RootConstrainSelectedInstOperands,
     /*  244787 */     // GIR_Coverage, 5023,
     /*  244787 */     GIR_EraseRootFromParent_Done,
     /*  244788 */   // Label 4743: @244788
     /*  244788 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(244854), // Rule ID 5026 //
     /*  244793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  244804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  244807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244832 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  244835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244852 */     GIR_RootConstrainSelectedInstOperands,
     /*  244853 */     // GIR_Coverage, 5026,
     /*  244853 */     GIR_EraseRootFromParent_Done,
     /*  244854 */   // Label 4744: @244854
     /*  244854 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(244920), // Rule ID 5027 //
     /*  244859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  244870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  244873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  244901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244918 */     GIR_RootConstrainSelectedInstOperands,
     /*  244919 */     // GIR_Coverage, 5027,
     /*  244919 */     GIR_EraseRootFromParent_Done,
     /*  244920 */   // Label 4745: @244920
     /*  244920 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(244986), // Rule ID 5030 //
     /*  244925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  244967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244984 */     GIR_RootConstrainSelectedInstOperands,
     /*  244985 */     // GIR_Coverage, 5030,
     /*  244985 */     GIR_EraseRootFromParent_Done,
     /*  244986 */   // Label 4746: @244986
     /*  244986 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(245052), // Rule ID 5031 //
     /*  244991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  245002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  245005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  245008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245030 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  245030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245050 */     GIR_RootConstrainSelectedInstOperands,
     /*  245051 */     // GIR_Coverage, 5031,
     /*  245051 */     GIR_EraseRootFromParent_Done,
     /*  245052 */   // Label 4747: @245052
     /*  245052 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(245118), // Rule ID 5034 //
     /*  245057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  245068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  245071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  245074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245096 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  245096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245116 */     GIR_RootConstrainSelectedInstOperands,
     /*  245117 */     // GIR_Coverage, 5034,
     /*  245117 */     GIR_EraseRootFromParent_Done,
     /*  245118 */   // Label 4748: @245118
     /*  245118 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(245184), // Rule ID 5035 //
     /*  245123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  245134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  245137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  245140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245162 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  245162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245182 */     GIR_RootConstrainSelectedInstOperands,
     /*  245183 */     // GIR_Coverage, 5035,
     /*  245183 */     GIR_EraseRootFromParent_Done,
     /*  245184 */   // Label 4749: @245184
     /*  245184 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(245250), // Rule ID 5038 //
     /*  245189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  245200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  245203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  245206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245228 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  245228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245248 */     GIR_RootConstrainSelectedInstOperands,
     /*  245249 */     // GIR_Coverage, 5038,
     /*  245249 */     GIR_EraseRootFromParent_Done,
     /*  245250 */   // Label 4750: @245250
     /*  245250 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(245316), // Rule ID 5039 //
     /*  245255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  245266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  245269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  245272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245294 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  245294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245314 */     GIR_RootConstrainSelectedInstOperands,
     /*  245315 */     // GIR_Coverage, 5039,
     /*  245315 */     GIR_EraseRootFromParent_Done,
     /*  245316 */   // Label 4751: @245316
     /*  245316 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(245382), // Rule ID 5042 //
     /*  245321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  245332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  245335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  245338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245360 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  245363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245380 */     GIR_RootConstrainSelectedInstOperands,
     /*  245381 */     // GIR_Coverage, 5042,
     /*  245381 */     GIR_EraseRootFromParent_Done,
     /*  245382 */   // Label 4752: @245382
     /*  245382 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(245448), // Rule ID 5043 //
     /*  245387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  245398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  245401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  245404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245426 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  245429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245446 */     GIR_RootConstrainSelectedInstOperands,
     /*  245447 */     // GIR_Coverage, 5043,
     /*  245447 */     GIR_EraseRootFromParent_Done,
     /*  245448 */   // Label 4753: @245448
     /*  245448 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(245514), // Rule ID 5046 //
     /*  245453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245512 */     GIR_RootConstrainSelectedInstOperands,
     /*  245513 */     // GIR_Coverage, 5046,
     /*  245513 */     GIR_EraseRootFromParent_Done,
     /*  245514 */   // Label 4754: @245514
     /*  245514 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(245580), // Rule ID 5047 //
     /*  245519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245578 */     GIR_RootConstrainSelectedInstOperands,
     /*  245579 */     // GIR_Coverage, 5047,
     /*  245579 */     GIR_EraseRootFromParent_Done,
     /*  245580 */   // Label 4755: @245580
     /*  245580 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(245646), // Rule ID 5050 //
     /*  245585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245644 */     GIR_RootConstrainSelectedInstOperands,
     /*  245645 */     // GIR_Coverage, 5050,
     /*  245645 */     GIR_EraseRootFromParent_Done,
     /*  245646 */   // Label 4756: @245646
     /*  245646 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(245712), // Rule ID 5051 //
     /*  245651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245710 */     GIR_RootConstrainSelectedInstOperands,
     /*  245711 */     // GIR_Coverage, 5051,
     /*  245711 */     GIR_EraseRootFromParent_Done,
     /*  245712 */   // Label 4757: @245712
     /*  245712 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(245778), // Rule ID 5054 //
     /*  245717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  245734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245756 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245776 */     GIR_RootConstrainSelectedInstOperands,
     /*  245777 */     // GIR_Coverage, 5054,
     /*  245777 */     GIR_EraseRootFromParent_Done,
     /*  245778 */   // Label 4758: @245778
     /*  245778 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(245844), // Rule ID 5055 //
     /*  245783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  245800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245842 */     GIR_RootConstrainSelectedInstOperands,
     /*  245843 */     // GIR_Coverage, 5055,
     /*  245843 */     GIR_EraseRootFromParent_Done,
     /*  245844 */   // Label 4759: @245844
     /*  245844 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(245910), // Rule ID 5058 //
     /*  245849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  245860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  245863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  245866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245888 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245908 */     GIR_RootConstrainSelectedInstOperands,
     /*  245909 */     // GIR_Coverage, 5058,
     /*  245909 */     GIR_EraseRootFromParent_Done,
     /*  245910 */   // Label 4760: @245910
     /*  245910 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(245976), // Rule ID 5059 //
     /*  245915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  245926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  245929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  245932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245954 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245974 */     GIR_RootConstrainSelectedInstOperands,
     /*  245975 */     // GIR_Coverage, 5059,
     /*  245975 */     GIR_EraseRootFromParent_Done,
     /*  245976 */   // Label 4761: @245976
     /*  245976 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(246042), // Rule ID 5062 //
     /*  245981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  246023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246040 */     GIR_RootConstrainSelectedInstOperands,
     /*  246041 */     // GIR_Coverage, 5062,
     /*  246041 */     GIR_EraseRootFromParent_Done,
     /*  246042 */   // Label 4762: @246042
     /*  246042 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(246108), // Rule ID 5063 //
     /*  246047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  246064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  246089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246106 */     GIR_RootConstrainSelectedInstOperands,
     /*  246107 */     // GIR_Coverage, 5063,
     /*  246107 */     GIR_EraseRootFromParent_Done,
     /*  246108 */   // Label 4763: @246108
     /*  246108 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(246174), // Rule ID 5066 //
     /*  246113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  246130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246152 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  246155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246172 */     GIR_RootConstrainSelectedInstOperands,
     /*  246173 */     // GIR_Coverage, 5066,
     /*  246173 */     GIR_EraseRootFromParent_Done,
     /*  246174 */   // Label 4764: @246174
     /*  246174 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(246240), // Rule ID 5067 //
     /*  246179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  246196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  246221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246238 */     GIR_RootConstrainSelectedInstOperands,
     /*  246239 */     // GIR_Coverage, 5067,
     /*  246239 */     GIR_EraseRootFromParent_Done,
     /*  246240 */   // Label 4765: @246240
     /*  246240 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(246306), // Rule ID 5070 //
     /*  246245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  246256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  246259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  246262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246284 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  246287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246304 */     GIR_RootConstrainSelectedInstOperands,
     /*  246305 */     // GIR_Coverage, 5070,
     /*  246305 */     GIR_EraseRootFromParent_Done,
     /*  246306 */   // Label 4766: @246306
     /*  246306 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(246372), // Rule ID 5071 //
     /*  246311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  246322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  246325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  246328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246350 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  246353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246370 */     GIR_RootConstrainSelectedInstOperands,
     /*  246371 */     // GIR_Coverage, 5071,
     /*  246371 */     GIR_EraseRootFromParent_Done,
     /*  246372 */   // Label 4767: @246372
     /*  246372 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(246438), // Rule ID 5074 //
     /*  246377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  246388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  246391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  246394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246416 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  246419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246436 */     GIR_RootConstrainSelectedInstOperands,
     /*  246437 */     // GIR_Coverage, 5074,
     /*  246437 */     GIR_EraseRootFromParent_Done,
     /*  246438 */   // Label 4768: @246438
     /*  246438 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(246504), // Rule ID 5075 //
     /*  246443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  246454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  246457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  246460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246482 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  246485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246502 */     GIR_RootConstrainSelectedInstOperands,
     /*  246503 */     // GIR_Coverage, 5075,
     /*  246503 */     GIR_EraseRootFromParent_Done,
     /*  246504 */   // Label 4769: @246504
     /*  246504 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(246570), // Rule ID 5078 //
     /*  246509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  246520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  246523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246548 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  246551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246568 */     GIR_RootConstrainSelectedInstOperands,
     /*  246569 */     // GIR_Coverage, 5078,
     /*  246569 */     GIR_EraseRootFromParent_Done,
     /*  246570 */   // Label 4770: @246570
     /*  246570 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(246636), // Rule ID 5079 //
     /*  246575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  246586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  246589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246614 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  246617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246634 */     GIR_RootConstrainSelectedInstOperands,
     /*  246635 */     // GIR_Coverage, 5079,
     /*  246635 */     GIR_EraseRootFromParent_Done,
     /*  246636 */   // Label 4771: @246636
     /*  246636 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(246702), // Rule ID 5082 //
     /*  246641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  246652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  246655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246680 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246700 */     GIR_RootConstrainSelectedInstOperands,
     /*  246701 */     // GIR_Coverage, 5082,
     /*  246701 */     GIR_EraseRootFromParent_Done,
     /*  246702 */   // Label 4772: @246702
     /*  246702 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(246768), // Rule ID 5083 //
     /*  246707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  246718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  246721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246746 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246766 */     GIR_RootConstrainSelectedInstOperands,
     /*  246767 */     // GIR_Coverage, 5083,
     /*  246767 */     GIR_EraseRootFromParent_Done,
     /*  246768 */   // Label 4773: @246768
     /*  246768 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(246834), // Rule ID 5086 //
     /*  246773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246812 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246832 */     GIR_RootConstrainSelectedInstOperands,
     /*  246833 */     // GIR_Coverage, 5086,
     /*  246833 */     GIR_EraseRootFromParent_Done,
     /*  246834 */   // Label 4774: @246834
     /*  246834 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(246900), // Rule ID 5087 //
     /*  246839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246898 */     GIR_RootConstrainSelectedInstOperands,
     /*  246899 */     // GIR_Coverage, 5087,
     /*  246899 */     GIR_EraseRootFromParent_Done,
     /*  246900 */   // Label 4775: @246900
     /*  246900 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(246966), // Rule ID 5090 //
     /*  246905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246944 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  246947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246964 */     GIR_RootConstrainSelectedInstOperands,
     /*  246965 */     // GIR_Coverage, 5090,
     /*  246965 */     GIR_EraseRootFromParent_Done,
     /*  246966 */   // Label 4776: @246966
     /*  246966 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(247032), // Rule ID 5091 //
     /*  246971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247010 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  247010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  247013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  247027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247030 */     GIR_RootConstrainSelectedInstOperands,
     /*  247031 */     // GIR_Coverage, 5091,
     /*  247031 */     GIR_EraseRootFromParent_Done,
     /*  247032 */   // Label 4777: @247032
     /*  247032 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(247098), // Rule ID 5094 //
     /*  247037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  247048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  247051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  247054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  247076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  247079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  247093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247096 */     GIR_RootConstrainSelectedInstOperands,
     /*  247097 */     // GIR_Coverage, 5094,
     /*  247097 */     GIR_EraseRootFromParent_Done,
     /*  247098 */   // Label 4778: @247098
     /*  247098 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(247164), // Rule ID 5095 //
     /*  247103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  247114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  247117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  247120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247142 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  247142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  247145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  247159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247162 */     GIR_RootConstrainSelectedInstOperands,
     /*  247163 */     // GIR_Coverage, 5095,
     /*  247163 */     GIR_EraseRootFromParent_Done,
     /*  247164 */   // Label 4779: @247164
     /*  247164 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(247230), // Rule ID 5098 //
     /*  247169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  247186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247208 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  247211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247228 */     GIR_RootConstrainSelectedInstOperands,
     /*  247229 */     // GIR_Coverage, 5098,
     /*  247229 */     GIR_EraseRootFromParent_Done,
     /*  247230 */   // Label 4780: @247230
     /*  247230 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(247296), // Rule ID 5099 //
     /*  247235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  247252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  247277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247294 */     GIR_RootConstrainSelectedInstOperands,
     /*  247295 */     // GIR_Coverage, 5099,
     /*  247295 */     GIR_EraseRootFromParent_Done,
     /*  247296 */   // Label 4781: @247296
     /*  247296 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(247362), // Rule ID 5102 //
     /*  247301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  247318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  247343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247360 */     GIR_RootConstrainSelectedInstOperands,
     /*  247361 */     // GIR_Coverage, 5102,
     /*  247361 */     GIR_EraseRootFromParent_Done,
     /*  247362 */   // Label 4782: @247362
     /*  247362 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(247428), // Rule ID 5103 //
     /*  247367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  247384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247406 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  247409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247426 */     GIR_RootConstrainSelectedInstOperands,
     /*  247427 */     // GIR_Coverage, 5103,
     /*  247427 */     GIR_EraseRootFromParent_Done,
     /*  247428 */   // Label 4783: @247428
     /*  247428 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(247494), // Rule ID 5106 //
     /*  247433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  247450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247472 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  247475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247492 */     GIR_RootConstrainSelectedInstOperands,
     /*  247493 */     // GIR_Coverage, 5106,
     /*  247493 */     GIR_EraseRootFromParent_Done,
     /*  247494 */   // Label 4784: @247494
     /*  247494 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(247560), // Rule ID 5107 //
     /*  247499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  247516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247538 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  247541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247558 */     GIR_RootConstrainSelectedInstOperands,
     /*  247559 */     // GIR_Coverage, 5107,
     /*  247559 */     GIR_EraseRootFromParent_Done,
     /*  247560 */   // Label 4785: @247560
     /*  247560 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(247626), // Rule ID 5110 //
     /*  247565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  247582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247604 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  247607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247624 */     GIR_RootConstrainSelectedInstOperands,
     /*  247625 */     // GIR_Coverage, 5110,
     /*  247625 */     GIR_EraseRootFromParent_Done,
     /*  247626 */   // Label 4786: @247626
     /*  247626 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(247692), // Rule ID 5111 //
     /*  247631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  247648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247670 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  247673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247690 */     GIR_RootConstrainSelectedInstOperands,
     /*  247691 */     // GIR_Coverage, 5111,
     /*  247691 */     GIR_EraseRootFromParent_Done,
     /*  247692 */   // Label 4787: @247692
     /*  247692 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(247758), // Rule ID 5114 //
     /*  247697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247736 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  247739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247756 */     GIR_RootConstrainSelectedInstOperands,
     /*  247757 */     // GIR_Coverage, 5114,
     /*  247757 */     GIR_EraseRootFromParent_Done,
     /*  247758 */   // Label 4788: @247758
     /*  247758 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(247824), // Rule ID 5115 //
     /*  247763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  247805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247822 */     GIR_RootConstrainSelectedInstOperands,
     /*  247823 */     // GIR_Coverage, 5115,
     /*  247823 */     GIR_EraseRootFromParent_Done,
     /*  247824 */   // Label 4789: @247824
     /*  247824 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(247890), // Rule ID 5118 //
     /*  247829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  247871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247888 */     GIR_RootConstrainSelectedInstOperands,
     /*  247889 */     // GIR_Coverage, 5118,
     /*  247889 */     GIR_EraseRootFromParent_Done,
     /*  247890 */   // Label 4790: @247890
     /*  247890 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(247956), // Rule ID 5119 //
     /*  247895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  247937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247954 */     GIR_RootConstrainSelectedInstOperands,
     /*  247955 */     // GIR_Coverage, 5119,
     /*  247955 */     GIR_EraseRootFromParent_Done,
     /*  247956 */   // Label 4791: @247956
     /*  247956 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(248022), // Rule ID 5122 //
     /*  247961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248000 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  248000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  248003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248020 */     GIR_RootConstrainSelectedInstOperands,
     /*  248021 */     // GIR_Coverage, 5122,
     /*  248021 */     GIR_EraseRootFromParent_Done,
     /*  248022 */   // Label 4792: @248022
     /*  248022 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(248088), // Rule ID 5123 //
     /*  248027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  248030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  248038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  248041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  248044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  248066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  248069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248086 */     GIR_RootConstrainSelectedInstOperands,
     /*  248087 */     // GIR_Coverage, 5123,
     /*  248087 */     GIR_EraseRootFromParent_Done,
     /*  248088 */   // Label 4793: @248088
     /*  248088 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(248154), // Rule ID 5126 //
     /*  248093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  248096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  248104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  248107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248132 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  248132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  248135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248152 */     GIR_RootConstrainSelectedInstOperands,
     /*  248153 */     // GIR_Coverage, 5126,
     /*  248153 */     GIR_EraseRootFromParent_Done,
     /*  248154 */   // Label 4794: @248154
     /*  248154 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(248220), // Rule ID 5127 //
     /*  248159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  248162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  248170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  248173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248198 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  248198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  248201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248218 */     GIR_RootConstrainSelectedInstOperands,
     /*  248219 */     // GIR_Coverage, 5127,
     /*  248219 */     GIR_EraseRootFromParent_Done,
     /*  248220 */   // Label 4795: @248220
     /*  248220 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(248283), // Rule ID 5390 //
     /*  248225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  248239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  248242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248264 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  248267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248281 */     GIR_RootConstrainSelectedInstOperands,
     /*  248282 */     // GIR_Coverage, 5390,
     /*  248282 */     GIR_EraseRootFromParent_Done,
     /*  248283 */   // Label 4796: @248283
     /*  248283 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(248346), // Rule ID 5391 //
     /*  248288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  248302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  248305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248327 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  248330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248344 */     GIR_RootConstrainSelectedInstOperands,
     /*  248345 */     // GIR_Coverage, 5391,
     /*  248345 */     GIR_EraseRootFromParent_Done,
     /*  248346 */   // Label 4797: @248346
     /*  248346 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(248409), // Rule ID 5392 //
     /*  248351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  248362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  248365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  248368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248390 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248407 */     GIR_RootConstrainSelectedInstOperands,
     /*  248408 */     // GIR_Coverage, 5392,
     /*  248408 */     GIR_EraseRootFromParent_Done,
     /*  248409 */   // Label 4798: @248409
     /*  248409 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(248472), // Rule ID 5393 //
     /*  248414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  248425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  248428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  248431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248453 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248470 */     GIR_RootConstrainSelectedInstOperands,
     /*  248471 */     // GIR_Coverage, 5393,
     /*  248471 */     GIR_EraseRootFromParent_Done,
     /*  248472 */   // Label 4799: @248472
     /*  248472 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(248535), // Rule ID 5394 //
     /*  248477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  248491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  248494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248516 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  248519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248533 */     GIR_RootConstrainSelectedInstOperands,
     /*  248534 */     // GIR_Coverage, 5394,
     /*  248534 */     GIR_EraseRootFromParent_Done,
     /*  248535 */   // Label 4800: @248535
     /*  248535 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(248598), // Rule ID 5395 //
     /*  248540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  248554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  248557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248579 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  248582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248596 */     GIR_RootConstrainSelectedInstOperands,
     /*  248597 */     // GIR_Coverage, 5395,
     /*  248597 */     GIR_EraseRootFromParent_Done,
     /*  248598 */   // Label 4801: @248598
     /*  248598 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(248661), // Rule ID 5396 //
     /*  248603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  248617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  248620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248642 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248659 */     GIR_RootConstrainSelectedInstOperands,
     /*  248660 */     // GIR_Coverage, 5396,
     /*  248660 */     GIR_EraseRootFromParent_Done,
     /*  248661 */   // Label 4802: @248661
     /*  248661 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(248724), // Rule ID 5397 //
     /*  248666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  248680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  248683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248705 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248722 */     GIR_RootConstrainSelectedInstOperands,
     /*  248723 */     // GIR_Coverage, 5397,
     /*  248723 */     GIR_EraseRootFromParent_Done,
     /*  248724 */   // Label 4803: @248724
     /*  248724 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(248787), // Rule ID 5398 //
     /*  248729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  248743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  248746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248768 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  248768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248785 */     GIR_RootConstrainSelectedInstOperands,
     /*  248786 */     // GIR_Coverage, 5398,
     /*  248786 */     GIR_EraseRootFromParent_Done,
     /*  248787 */   // Label 4804: @248787
     /*  248787 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(248850), // Rule ID 5399 //
     /*  248792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  248806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  248809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248831 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  248831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248848 */     GIR_RootConstrainSelectedInstOperands,
     /*  248849 */     // GIR_Coverage, 5399,
     /*  248849 */     GIR_EraseRootFromParent_Done,
     /*  248850 */   // Label 4805: @248850
     /*  248850 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(248913), // Rule ID 5400 //
     /*  248855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  248866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  248869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248894 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248911 */     GIR_RootConstrainSelectedInstOperands,
     /*  248912 */     // GIR_Coverage, 5400,
     /*  248912 */     GIR_EraseRootFromParent_Done,
     /*  248913 */   // Label 4806: @248913
     /*  248913 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(248976), // Rule ID 5401 //
     /*  248918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  248929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  248932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248957 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248974 */     GIR_RootConstrainSelectedInstOperands,
     /*  248975 */     // GIR_Coverage, 5401,
     /*  248975 */     GIR_EraseRootFromParent_Done,
     /*  248976 */   // Label 4807: @248976
     /*  248976 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(249039), // Rule ID 5402 //
     /*  248981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  248992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  248995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  248998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249020 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  249023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249037 */     GIR_RootConstrainSelectedInstOperands,
     /*  249038 */     // GIR_Coverage, 5402,
     /*  249038 */     GIR_EraseRootFromParent_Done,
     /*  249039 */   // Label 4808: @249039
     /*  249039 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(249102), // Rule ID 5403 //
     /*  249044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  249055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  249058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  249061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249083 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  249086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249100 */     GIR_RootConstrainSelectedInstOperands,
     /*  249101 */     // GIR_Coverage, 5403,
     /*  249101 */     GIR_EraseRootFromParent_Done,
     /*  249102 */   // Label 4809: @249102
     /*  249102 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(249165), // Rule ID 5404 //
     /*  249107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  249118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  249121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  249124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249146 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  249146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  249149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249163 */     GIR_RootConstrainSelectedInstOperands,
     /*  249164 */     // GIR_Coverage, 5404,
     /*  249164 */     GIR_EraseRootFromParent_Done,
     /*  249165 */   // Label 4810: @249165
     /*  249165 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(249228), // Rule ID 5405 //
     /*  249170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  249181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  249184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  249187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249209 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  249209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  249212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249226 */     GIR_RootConstrainSelectedInstOperands,
     /*  249227 */     // GIR_Coverage, 5405,
     /*  249227 */     GIR_EraseRootFromParent_Done,
     /*  249228 */   // Label 4811: @249228
     /*  249228 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(249291), // Rule ID 5406 //
     /*  249233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  249236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  249244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  249247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  249250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249272 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  249272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  249275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249289 */     GIR_RootConstrainSelectedInstOperands,
     /*  249290 */     // GIR_Coverage, 5406,
     /*  249290 */     GIR_EraseRootFromParent_Done,
     /*  249291 */   // Label 4812: @249291
     /*  249291 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(249354), // Rule ID 5407 //
     /*  249296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  249299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  249307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  249310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  249313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249335 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  249335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  249338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249352 */     GIR_RootConstrainSelectedInstOperands,
     /*  249353 */     // GIR_Coverage, 5407,
     /*  249353 */     GIR_EraseRootFromParent_Done,
     /*  249354 */   // Label 4813: @249354
     /*  249354 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(249417), // Rule ID 5408 //
     /*  249359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  249373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  249376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249398 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  249398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249415 */     GIR_RootConstrainSelectedInstOperands,
     /*  249416 */     // GIR_Coverage, 5408,
     /*  249416 */     GIR_EraseRootFromParent_Done,
     /*  249417 */   // Label 4814: @249417
     /*  249417 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(249480), // Rule ID 5409 //
     /*  249422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  249436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  249439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249461 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  249461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249478 */     GIR_RootConstrainSelectedInstOperands,
     /*  249479 */     // GIR_Coverage, 5409,
     /*  249479 */     GIR_EraseRootFromParent_Done,
     /*  249480 */   // Label 4815: @249480
     /*  249480 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(249543), // Rule ID 5410 //
     /*  249485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  249499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  249502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249524 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  249524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249541 */     GIR_RootConstrainSelectedInstOperands,
     /*  249542 */     // GIR_Coverage, 5410,
     /*  249542 */     GIR_EraseRootFromParent_Done,
     /*  249543 */   // Label 4816: @249543
     /*  249543 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(249606), // Rule ID 5411 //
     /*  249548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  249562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  249565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249587 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  249587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249604 */     GIR_RootConstrainSelectedInstOperands,
     /*  249605 */     // GIR_Coverage, 5411,
     /*  249605 */     GIR_EraseRootFromParent_Done,
     /*  249606 */   // Label 4817: @249606
     /*  249606 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(249669), // Rule ID 5412 //
     /*  249611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  249622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  249625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  249628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249650 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  249650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249667 */     GIR_RootConstrainSelectedInstOperands,
     /*  249668 */     // GIR_Coverage, 5412,
     /*  249668 */     GIR_EraseRootFromParent_Done,
     /*  249669 */   // Label 4818: @249669
     /*  249669 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(249732), // Rule ID 5413 //
     /*  249674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  249685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  249688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  249691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249713 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  249713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249730 */     GIR_RootConstrainSelectedInstOperands,
     /*  249731 */     // GIR_Coverage, 5413,
     /*  249731 */     GIR_EraseRootFromParent_Done,
     /*  249732 */   // Label 4819: @249732
     /*  249732 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(249795), // Rule ID 5414 //
     /*  249737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  249751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249776 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249793 */     GIR_RootConstrainSelectedInstOperands,
     /*  249794 */     // GIR_Coverage, 5414,
     /*  249794 */     GIR_EraseRootFromParent_Done,
     /*  249795 */   // Label 4820: @249795
     /*  249795 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(249858), // Rule ID 5415 //
     /*  249800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  249814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249839 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249856 */     GIR_RootConstrainSelectedInstOperands,
     /*  249857 */     // GIR_Coverage, 5415,
     /*  249857 */     GIR_EraseRootFromParent_Done,
     /*  249858 */   // Label 4821: @249858
     /*  249858 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(249921), // Rule ID 5416 //
     /*  249863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  249877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249902 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249919 */     GIR_RootConstrainSelectedInstOperands,
     /*  249920 */     // GIR_Coverage, 5416,
     /*  249920 */     GIR_EraseRootFromParent_Done,
     /*  249921 */   // Label 4822: @249921
     /*  249921 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(249984), // Rule ID 5417 //
     /*  249926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  249940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249965 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249982 */     GIR_RootConstrainSelectedInstOperands,
     /*  249983 */     // GIR_Coverage, 5417,
     /*  249983 */     GIR_EraseRootFromParent_Done,
     /*  249984 */   // Label 4823: @249984
     /*  249984 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(250047), // Rule ID 5418 //
     /*  249989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  250000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  250003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  250006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250028 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  250028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250045 */     GIR_RootConstrainSelectedInstOperands,
     /*  250046 */     // GIR_Coverage, 5418,
     /*  250046 */     GIR_EraseRootFromParent_Done,
     /*  250047 */   // Label 4824: @250047
     /*  250047 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(250110), // Rule ID 5419 //
     /*  250052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  250063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  250066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  250069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250091 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  250091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250108 */     GIR_RootConstrainSelectedInstOperands,
     /*  250109 */     // GIR_Coverage, 5419,
     /*  250109 */     GIR_EraseRootFromParent_Done,
     /*  250110 */   // Label 4825: @250110
     /*  250110 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(250173), // Rule ID 5420 //
     /*  250115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  250129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  250132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250154 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  250154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  250157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250171 */     GIR_RootConstrainSelectedInstOperands,
     /*  250172 */     // GIR_Coverage, 5420,
     /*  250172 */     GIR_EraseRootFromParent_Done,
     /*  250173 */   // Label 4826: @250173
     /*  250173 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(250236), // Rule ID 5421 //
     /*  250178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  250192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  250195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250217 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  250217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  250220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250234 */     GIR_RootConstrainSelectedInstOperands,
     /*  250235 */     // GIR_Coverage, 5421,
     /*  250235 */     GIR_EraseRootFromParent_Done,
     /*  250236 */   // Label 4827: @250236
     /*  250236 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(250299), // Rule ID 5422 //
     /*  250241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  250255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  250258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250280 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  250280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  250283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250297 */     GIR_RootConstrainSelectedInstOperands,
     /*  250298 */     // GIR_Coverage, 5422,
     /*  250298 */     GIR_EraseRootFromParent_Done,
     /*  250299 */   // Label 4828: @250299
     /*  250299 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(250362), // Rule ID 5423 //
     /*  250304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  250318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  250321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250343 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  250343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  250346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250360 */     GIR_RootConstrainSelectedInstOperands,
     /*  250361 */     // GIR_Coverage, 5423,
     /*  250361 */     GIR_EraseRootFromParent_Done,
     /*  250362 */   // Label 4829: @250362
     /*  250362 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(250425), // Rule ID 5424 //
     /*  250367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  250378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  250381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  250384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250406 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  250406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250423 */     GIR_RootConstrainSelectedInstOperands,
     /*  250424 */     // GIR_Coverage, 5424,
     /*  250424 */     GIR_EraseRootFromParent_Done,
     /*  250425 */   // Label 4830: @250425
     /*  250425 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(250488), // Rule ID 5425 //
     /*  250430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  250441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  250444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  250447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250469 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  250469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250486 */     GIR_RootConstrainSelectedInstOperands,
     /*  250487 */     // GIR_Coverage, 5425,
     /*  250487 */     GIR_EraseRootFromParent_Done,
     /*  250488 */   // Label 4831: @250488
     /*  250488 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(250551), // Rule ID 5426 //
     /*  250493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  250496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  250510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250532 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  250532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  250535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250549 */     GIR_RootConstrainSelectedInstOperands,
     /*  250550 */     // GIR_Coverage, 5426,
     /*  250550 */     GIR_EraseRootFromParent_Done,
     /*  250551 */   // Label 4832: @250551
     /*  250551 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(250614), // Rule ID 5427 //
     /*  250556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  250559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  250573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250595 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  250595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  250598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250612 */     GIR_RootConstrainSelectedInstOperands,
     /*  250613 */     // GIR_Coverage, 5427,
     /*  250613 */     GIR_EraseRootFromParent_Done,
     /*  250614 */   // Label 4833: @250614
     /*  250614 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(250677), // Rule ID 5428 //
     /*  250619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  250622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  250636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250658 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  250658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  250661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250675 */     GIR_RootConstrainSelectedInstOperands,
     /*  250676 */     // GIR_Coverage, 5428,
     /*  250676 */     GIR_EraseRootFromParent_Done,
     /*  250677 */   // Label 4834: @250677
     /*  250677 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(250740), // Rule ID 5429 //
     /*  250682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  250685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  250699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250721 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  250721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  250724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250738 */     GIR_RootConstrainSelectedInstOperands,
     /*  250739 */     // GIR_Coverage, 5429,
     /*  250739 */     GIR_EraseRootFromParent_Done,
     /*  250740 */   // Label 4835: @250740
     /*  250740 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(250803), // Rule ID 5430 //
     /*  250745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  250748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  250759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  250762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250784 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  250784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250801 */     GIR_RootConstrainSelectedInstOperands,
     /*  250802 */     // GIR_Coverage, 5430,
     /*  250802 */     GIR_EraseRootFromParent_Done,
     /*  250803 */   // Label 4836: @250803
     /*  250803 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(250866), // Rule ID 5431 //
     /*  250808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  250811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  250822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  250825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250847 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  250847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250864 */     GIR_RootConstrainSelectedInstOperands,
     /*  250865 */     // GIR_Coverage, 5431,
     /*  250865 */     GIR_EraseRootFromParent_Done,
     /*  250866 */   // Label 4837: @250866
     /*  250866 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(250929), // Rule ID 5432 //
     /*  250871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  250885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250910 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  250910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  250913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250927 */     GIR_RootConstrainSelectedInstOperands,
     /*  250928 */     // GIR_Coverage, 5432,
     /*  250928 */     GIR_EraseRootFromParent_Done,
     /*  250929 */   // Label 4838: @250929
     /*  250929 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(250992), // Rule ID 5433 //
     /*  250934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  250948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250973 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  250973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  250976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250990 */     GIR_RootConstrainSelectedInstOperands,
     /*  250991 */     // GIR_Coverage, 5433,
     /*  250991 */     GIR_EraseRootFromParent_Done,
     /*  250992 */   // Label 4839: @250992
     /*  250992 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(251055), // Rule ID 5434 //
     /*  250997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  251011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251036 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  251039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251053 */     GIR_RootConstrainSelectedInstOperands,
     /*  251054 */     // GIR_Coverage, 5434,
     /*  251054 */     GIR_EraseRootFromParent_Done,
     /*  251055 */   // Label 4840: @251055
     /*  251055 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(251118), // Rule ID 5435 //
     /*  251060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  251074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251099 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  251102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251116 */     GIR_RootConstrainSelectedInstOperands,
     /*  251117 */     // GIR_Coverage, 5435,
     /*  251117 */     GIR_EraseRootFromParent_Done,
     /*  251118 */   // Label 4841: @251118
     /*  251118 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(251181), // Rule ID 5436 //
     /*  251123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  251137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251162 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251179 */     GIR_RootConstrainSelectedInstOperands,
     /*  251180 */     // GIR_Coverage, 5436,
     /*  251180 */     GIR_EraseRootFromParent_Done,
     /*  251181 */   // Label 4842: @251181
     /*  251181 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(251244), // Rule ID 5437 //
     /*  251186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  251200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251225 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251242 */     GIR_RootConstrainSelectedInstOperands,
     /*  251243 */     // GIR_Coverage, 5437,
     /*  251243 */     GIR_EraseRootFromParent_Done,
     /*  251244 */   // Label 4843: @251244
     /*  251244 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(251307), // Rule ID 5438 //
     /*  251249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  251263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251288 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  251291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251305 */     GIR_RootConstrainSelectedInstOperands,
     /*  251306 */     // GIR_Coverage, 5438,
     /*  251306 */     GIR_EraseRootFromParent_Done,
     /*  251307 */   // Label 4844: @251307
     /*  251307 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(251370), // Rule ID 5439 //
     /*  251312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  251326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251351 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  251354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251368 */     GIR_RootConstrainSelectedInstOperands,
     /*  251369 */     // GIR_Coverage, 5439,
     /*  251369 */     GIR_EraseRootFromParent_Done,
     /*  251370 */   // Label 4845: @251370
     /*  251370 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(251433), // Rule ID 5440 //
     /*  251375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  251389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251414 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251431 */     GIR_RootConstrainSelectedInstOperands,
     /*  251432 */     // GIR_Coverage, 5440,
     /*  251432 */     GIR_EraseRootFromParent_Done,
     /*  251433 */   // Label 4846: @251433
     /*  251433 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(251496), // Rule ID 5441 //
     /*  251438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  251452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251477 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251494 */     GIR_RootConstrainSelectedInstOperands,
     /*  251495 */     // GIR_Coverage, 5441,
     /*  251495 */     GIR_EraseRootFromParent_Done,
     /*  251496 */   // Label 4847: @251496
     /*  251496 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(251559), // Rule ID 5442 //
     /*  251501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  251515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251540 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  251540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251557 */     GIR_RootConstrainSelectedInstOperands,
     /*  251558 */     // GIR_Coverage, 5442,
     /*  251558 */     GIR_EraseRootFromParent_Done,
     /*  251559 */   // Label 4848: @251559
     /*  251559 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(251622), // Rule ID 5443 //
     /*  251564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  251578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251603 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  251603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251620 */     GIR_RootConstrainSelectedInstOperands,
     /*  251621 */     // GIR_Coverage, 5443,
     /*  251621 */     GIR_EraseRootFromParent_Done,
     /*  251622 */   // Label 4849: @251622
     /*  251622 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(251685), // Rule ID 5444 //
     /*  251627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  251638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  251641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251666 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251683 */     GIR_RootConstrainSelectedInstOperands,
     /*  251684 */     // GIR_Coverage, 5444,
     /*  251684 */     GIR_EraseRootFromParent_Done,
     /*  251685 */   // Label 4850: @251685
     /*  251685 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(251748), // Rule ID 5445 //
     /*  251690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  251701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  251704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251729 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251746 */     GIR_RootConstrainSelectedInstOperands,
     /*  251747 */     // GIR_Coverage, 5445,
     /*  251747 */     GIR_EraseRootFromParent_Done,
     /*  251748 */   // Label 4851: @251748
     /*  251748 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(251811), // Rule ID 5446 //
     /*  251753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  251767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251792 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251809 */     GIR_RootConstrainSelectedInstOperands,
     /*  251810 */     // GIR_Coverage, 5446,
     /*  251810 */     GIR_EraseRootFromParent_Done,
     /*  251811 */   // Label 4852: @251811
     /*  251811 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(251874), // Rule ID 5447 //
     /*  251816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  251830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251855 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251872 */     GIR_RootConstrainSelectedInstOperands,
     /*  251873 */     // GIR_Coverage, 5447,
     /*  251873 */     GIR_EraseRootFromParent_Done,
     /*  251874 */   // Label 4853: @251874
     /*  251874 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(251937), // Rule ID 5448 //
     /*  251879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  251893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251918 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  251918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251935 */     GIR_RootConstrainSelectedInstOperands,
     /*  251936 */     // GIR_Coverage, 5448,
     /*  251936 */     GIR_EraseRootFromParent_Done,
     /*  251937 */   // Label 4854: @251937
     /*  251937 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(252000), // Rule ID 5449 //
     /*  251942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  251956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251981 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  251981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251998 */     GIR_RootConstrainSelectedInstOperands,
     /*  251999 */     // GIR_Coverage, 5449,
     /*  251999 */     GIR_EraseRootFromParent_Done,
     /*  252000 */   // Label 4855: @252000
     /*  252000 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(252063), // Rule ID 5450 //
     /*  252005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  252008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  252019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252044 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  252044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  252047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252061 */     GIR_RootConstrainSelectedInstOperands,
     /*  252062 */     // GIR_Coverage, 5450,
     /*  252062 */     GIR_EraseRootFromParent_Done,
     /*  252063 */   // Label 4856: @252063
     /*  252063 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(252126), // Rule ID 5451 //
     /*  252068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  252071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  252082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252107 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  252107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  252110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252124 */     GIR_RootConstrainSelectedInstOperands,
     /*  252125 */     // GIR_Coverage, 5451,
     /*  252125 */     GIR_EraseRootFromParent_Done,
     /*  252126 */   // Label 4857: @252126
     /*  252126 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(252189), // Rule ID 5452 //
     /*  252131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  252145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252170 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252187 */     GIR_RootConstrainSelectedInstOperands,
     /*  252188 */     // GIR_Coverage, 5452,
     /*  252188 */     GIR_EraseRootFromParent_Done,
     /*  252189 */   // Label 4858: @252189
     /*  252189 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(252252), // Rule ID 5453 //
     /*  252194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  252208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252233 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252250 */     GIR_RootConstrainSelectedInstOperands,
     /*  252251 */     // GIR_Coverage, 5453,
     /*  252251 */     GIR_EraseRootFromParent_Done,
     /*  252252 */   // Label 4859: @252252
     /*  252252 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(252315), // Rule ID 5454 //
     /*  252257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  252271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252296 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252313 */     GIR_RootConstrainSelectedInstOperands,
     /*  252314 */     // GIR_Coverage, 5454,
     /*  252314 */     GIR_EraseRootFromParent_Done,
     /*  252315 */   // Label 4860: @252315
     /*  252315 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(252378), // Rule ID 5455 //
     /*  252320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  252334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252359 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252376 */     GIR_RootConstrainSelectedInstOperands,
     /*  252377 */     // GIR_Coverage, 5455,
     /*  252377 */     GIR_EraseRootFromParent_Done,
     /*  252378 */   // Label 4861: @252378
     /*  252378 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(252441), // Rule ID 5456 //
     /*  252383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  252394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  252397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252422 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252439 */     GIR_RootConstrainSelectedInstOperands,
     /*  252440 */     // GIR_Coverage, 5456,
     /*  252440 */     GIR_EraseRootFromParent_Done,
     /*  252441 */   // Label 4862: @252441
     /*  252441 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(252504), // Rule ID 5457 //
     /*  252446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  252457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  252460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252485 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252502 */     GIR_RootConstrainSelectedInstOperands,
     /*  252503 */     // GIR_Coverage, 5457,
     /*  252503 */     GIR_EraseRootFromParent_Done,
     /*  252504 */   // Label 4863: @252504
     /*  252504 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(252567), // Rule ID 5458 //
     /*  252509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  252523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252548 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252565 */     GIR_RootConstrainSelectedInstOperands,
     /*  252566 */     // GIR_Coverage, 5458,
     /*  252566 */     GIR_EraseRootFromParent_Done,
     /*  252567 */   // Label 4864: @252567
     /*  252567 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(252630), // Rule ID 5459 //
     /*  252572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  252586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252611 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252628 */     GIR_RootConstrainSelectedInstOperands,
     /*  252629 */     // GIR_Coverage, 5459,
     /*  252629 */     GIR_EraseRootFromParent_Done,
     /*  252630 */   // Label 4865: @252630
     /*  252630 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(252693), // Rule ID 5460 //
     /*  252635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  252649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252674 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252691 */     GIR_RootConstrainSelectedInstOperands,
     /*  252692 */     // GIR_Coverage, 5460,
     /*  252692 */     GIR_EraseRootFromParent_Done,
     /*  252693 */   // Label 4866: @252693
     /*  252693 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(252756), // Rule ID 5461 //
     /*  252698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  252712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252737 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252754 */     GIR_RootConstrainSelectedInstOperands,
     /*  252755 */     // GIR_Coverage, 5461,
     /*  252755 */     GIR_EraseRootFromParent_Done,
     /*  252756 */   // Label 4867: @252756
     /*  252756 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(252819), // Rule ID 5462 //
     /*  252761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  252775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252800 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252817 */     GIR_RootConstrainSelectedInstOperands,
     /*  252818 */     // GIR_Coverage, 5462,
     /*  252818 */     GIR_EraseRootFromParent_Done,
     /*  252819 */   // Label 4868: @252819
     /*  252819 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(252882), // Rule ID 5463 //
     /*  252824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  252838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252863 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252880 */     GIR_RootConstrainSelectedInstOperands,
     /*  252881 */     // GIR_Coverage, 5463,
     /*  252881 */     GIR_EraseRootFromParent_Done,
     /*  252882 */   // Label 4869: @252882
     /*  252882 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(252945), // Rule ID 5464 //
     /*  252887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  252901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252926 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252943 */     GIR_RootConstrainSelectedInstOperands,
     /*  252944 */     // GIR_Coverage, 5464,
     /*  252944 */     GIR_EraseRootFromParent_Done,
     /*  252945 */   // Label 4870: @252945
     /*  252945 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(253008), // Rule ID 5465 //
     /*  252950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  252964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252989 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253006 */     GIR_RootConstrainSelectedInstOperands,
     /*  253007 */     // GIR_Coverage, 5465,
     /*  253007 */     GIR_EraseRootFromParent_Done,
     /*  253008 */   // Label 4871: @253008
     /*  253008 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(253071), // Rule ID 5466 //
     /*  253013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  253027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  253030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253052 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  253055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253069 */     GIR_RootConstrainSelectedInstOperands,
     /*  253070 */     // GIR_Coverage, 5466,
     /*  253070 */     GIR_EraseRootFromParent_Done,
     /*  253071 */   // Label 4872: @253071
     /*  253071 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(253134), // Rule ID 5467 //
     /*  253076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  253090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253115 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  253118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253132 */     GIR_RootConstrainSelectedInstOperands,
     /*  253133 */     // GIR_Coverage, 5467,
     /*  253133 */     GIR_EraseRootFromParent_Done,
     /*  253134 */   // Label 4873: @253134
     /*  253134 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(253197), // Rule ID 5468 //
     /*  253139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  253153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  253156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253178 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  253181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253195 */     GIR_RootConstrainSelectedInstOperands,
     /*  253196 */     // GIR_Coverage, 5468,
     /*  253196 */     GIR_EraseRootFromParent_Done,
     /*  253197 */   // Label 4874: @253197
     /*  253197 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(253260), // Rule ID 5469 //
     /*  253202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  253216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253241 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  253244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253258 */     GIR_RootConstrainSelectedInstOperands,
     /*  253259 */     // GIR_Coverage, 5469,
     /*  253259 */     GIR_EraseRootFromParent_Done,
     /*  253260 */   // Label 4875: @253260
     /*  253260 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(253323), // Rule ID 5470 //
     /*  253265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  253279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  253282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  253304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  253307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253321 */     GIR_RootConstrainSelectedInstOperands,
     /*  253322 */     // GIR_Coverage, 5470,
     /*  253322 */     GIR_EraseRootFromParent_Done,
     /*  253323 */   // Label 4876: @253323
     /*  253323 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(253386), // Rule ID 5471 //
     /*  253328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  253331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  253342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253367 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  253370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253384 */     GIR_RootConstrainSelectedInstOperands,
     /*  253385 */     // GIR_Coverage, 5471,
     /*  253385 */     GIR_EraseRootFromParent_Done,
     /*  253386 */   // Label 4877: @253386
     /*  253386 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(253449), // Rule ID 5472 //
     /*  253391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  253405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  253408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253430 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  253430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  253433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253447 */     GIR_RootConstrainSelectedInstOperands,
     /*  253448 */     // GIR_Coverage, 5472,
     /*  253448 */     GIR_EraseRootFromParent_Done,
     /*  253449 */   // Label 4878: @253449
     /*  253449 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(253512), // Rule ID 5473 //
     /*  253454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  253457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  253468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253493 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  253496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253510 */     GIR_RootConstrainSelectedInstOperands,
     /*  253511 */     // GIR_Coverage, 5473,
     /*  253511 */     GIR_EraseRootFromParent_Done,
     /*  253512 */   // Label 4879: @253512
     /*  253512 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(253575), // Rule ID 5474 //
     /*  253517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  253531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  253534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253556 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  253556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  253559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253573 */     GIR_RootConstrainSelectedInstOperands,
     /*  253574 */     // GIR_Coverage, 5474,
     /*  253574 */     GIR_EraseRootFromParent_Done,
     /*  253575 */   // Label 4880: @253575
     /*  253575 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(253638), // Rule ID 5475 //
     /*  253580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  253583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  253594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253619 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  253622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253636 */     GIR_RootConstrainSelectedInstOperands,
     /*  253637 */     // GIR_Coverage, 5475,
     /*  253637 */     GIR_EraseRootFromParent_Done,
     /*  253638 */   // Label 4881: @253638
     /*  253638 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(253701), // Rule ID 5696 //
     /*  253643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  253657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  253660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253682 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  253685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253699 */     GIR_RootConstrainSelectedInstOperands,
     /*  253700 */     // GIR_Coverage, 5696,
     /*  253700 */     GIR_EraseRootFromParent_Done,
     /*  253701 */   // Label 4882: @253701
     /*  253701 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(253764), // Rule ID 5697 //
     /*  253706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  253720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  253723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253745 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  253748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253762 */     GIR_RootConstrainSelectedInstOperands,
     /*  253763 */     // GIR_Coverage, 5697,
     /*  253763 */     GIR_EraseRootFromParent_Done,
     /*  253764 */   // Label 4883: @253764
     /*  253764 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(253827), // Rule ID 5698 //
     /*  253769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  253783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  253786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253808 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253825 */     GIR_RootConstrainSelectedInstOperands,
     /*  253826 */     // GIR_Coverage, 5698,
     /*  253826 */     GIR_EraseRootFromParent_Done,
     /*  253827 */   // Label 4884: @253827
     /*  253827 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(253890), // Rule ID 5699 //
     /*  253832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  253846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  253849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253871 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253888 */     GIR_RootConstrainSelectedInstOperands,
     /*  253889 */     // GIR_Coverage, 5699,
     /*  253889 */     GIR_EraseRootFromParent_Done,
     /*  253890 */   // Label 4885: @253890
     /*  253890 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(253953), // Rule ID 5700 //
     /*  253895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  253909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  253912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253934 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253951 */     GIR_RootConstrainSelectedInstOperands,
     /*  253952 */     // GIR_Coverage, 5700,
     /*  253952 */     GIR_EraseRootFromParent_Done,
     /*  253953 */   // Label 4886: @253953
     /*  253953 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(254016), // Rule ID 5701 //
     /*  253958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  253972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  253975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253997 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  254000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254014 */     GIR_RootConstrainSelectedInstOperands,
     /*  254015 */     // GIR_Coverage, 5701,
     /*  254015 */     GIR_EraseRootFromParent_Done,
     /*  254016 */   // Label 4887: @254016
     /*  254016 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(254079), // Rule ID 5702 //
     /*  254021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  254035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  254038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254060 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  254063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254077 */     GIR_RootConstrainSelectedInstOperands,
     /*  254078 */     // GIR_Coverage, 5702,
     /*  254078 */     GIR_EraseRootFromParent_Done,
     /*  254079 */   // Label 4888: @254079
     /*  254079 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(254142), // Rule ID 5703 //
     /*  254084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  254098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  254101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254123 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  254126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254140 */     GIR_RootConstrainSelectedInstOperands,
     /*  254141 */     // GIR_Coverage, 5703,
     /*  254141 */     GIR_EraseRootFromParent_Done,
     /*  254142 */   // Label 4889: @254142
     /*  254142 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(254205), // Rule ID 5704 //
     /*  254147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  254161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  254164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254186 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  254189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254203 */     GIR_RootConstrainSelectedInstOperands,
     /*  254204 */     // GIR_Coverage, 5704,
     /*  254204 */     GIR_EraseRootFromParent_Done,
     /*  254205 */   // Label 4890: @254205
     /*  254205 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(254268), // Rule ID 5705 //
     /*  254210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  254224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  254227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254249 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  254252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254266 */     GIR_RootConstrainSelectedInstOperands,
     /*  254267 */     // GIR_Coverage, 5705,
     /*  254267 */     GIR_EraseRootFromParent_Done,
     /*  254268 */   // Label 4891: @254268
     /*  254268 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(254331), // Rule ID 5706 //
     /*  254273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  254287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  254290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254312 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  254312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  254315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254329 */     GIR_RootConstrainSelectedInstOperands,
     /*  254330 */     // GIR_Coverage, 5706,
     /*  254330 */     GIR_EraseRootFromParent_Done,
     /*  254331 */   // Label 4892: @254331
     /*  254331 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(254394), // Rule ID 5707 //
     /*  254336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  254350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  254353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254375 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  254375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  254378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254392 */     GIR_RootConstrainSelectedInstOperands,
     /*  254393 */     // GIR_Coverage, 5707,
     /*  254393 */     GIR_EraseRootFromParent_Done,
     /*  254394 */   // Label 4893: @254394
     /*  254394 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(254457), // Rule ID 5708 //
     /*  254399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  254413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  254416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254438 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254455 */     GIR_RootConstrainSelectedInstOperands,
     /*  254456 */     // GIR_Coverage, 5708,
     /*  254456 */     GIR_EraseRootFromParent_Done,
     /*  254457 */   // Label 4894: @254457
     /*  254457 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(254520), // Rule ID 5709 //
     /*  254462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  254476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  254479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254501 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254518 */     GIR_RootConstrainSelectedInstOperands,
     /*  254519 */     // GIR_Coverage, 5709,
     /*  254519 */     GIR_EraseRootFromParent_Done,
     /*  254520 */   // Label 4895: @254520
     /*  254520 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(254583), // Rule ID 5710 //
     /*  254525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  254539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  254542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254564 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254581 */     GIR_RootConstrainSelectedInstOperands,
     /*  254582 */     // GIR_Coverage, 5710,
     /*  254582 */     GIR_EraseRootFromParent_Done,
     /*  254583 */   // Label 4896: @254583
     /*  254583 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(254646), // Rule ID 5711 //
     /*  254588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  254602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  254605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254627 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254644 */     GIR_RootConstrainSelectedInstOperands,
     /*  254645 */     // GIR_Coverage, 5711,
     /*  254645 */     GIR_EraseRootFromParent_Done,
     /*  254646 */   // Label 4897: @254646
     /*  254646 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(254709), // Rule ID 5712 //
     /*  254651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  254665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  254668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254690 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  254690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254707 */     GIR_RootConstrainSelectedInstOperands,
     /*  254708 */     // GIR_Coverage, 5712,
     /*  254708 */     GIR_EraseRootFromParent_Done,
     /*  254709 */   // Label 4898: @254709
     /*  254709 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(254772), // Rule ID 5713 //
     /*  254714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  254728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  254731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254753 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  254753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254770 */     GIR_RootConstrainSelectedInstOperands,
     /*  254771 */     // GIR_Coverage, 5713,
     /*  254771 */     GIR_EraseRootFromParent_Done,
     /*  254772 */   // Label 4899: @254772
     /*  254772 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(254835), // Rule ID 5714 //
     /*  254777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  254780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  254791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  254794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254816 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  254816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254833 */     GIR_RootConstrainSelectedInstOperands,
     /*  254834 */     // GIR_Coverage, 5714,
     /*  254834 */     GIR_EraseRootFromParent_Done,
     /*  254835 */   // Label 4900: @254835
     /*  254835 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(254898), // Rule ID 5715 //
     /*  254840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  254843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  254854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  254857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254879 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  254879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254896 */     GIR_RootConstrainSelectedInstOperands,
     /*  254897 */     // GIR_Coverage, 5715,
     /*  254897 */     GIR_EraseRootFromParent_Done,
     /*  254898 */   // Label 4901: @254898
     /*  254898 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(254961), // Rule ID 5716 //
     /*  254903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  254917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  254920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254942 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254959 */     GIR_RootConstrainSelectedInstOperands,
     /*  254960 */     // GIR_Coverage, 5716,
     /*  254960 */     GIR_EraseRootFromParent_Done,
     /*  254961 */   // Label 4902: @254961
     /*  254961 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(255024), // Rule ID 5717 //
     /*  254966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  254980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  254983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255005 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255022 */     GIR_RootConstrainSelectedInstOperands,
     /*  255023 */     // GIR_Coverage, 5717,
     /*  255023 */     GIR_EraseRootFromParent_Done,
     /*  255024 */   // Label 4903: @255024
     /*  255024 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(255087), // Rule ID 5718 //
     /*  255029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  255043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  255046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255068 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255085 */     GIR_RootConstrainSelectedInstOperands,
     /*  255086 */     // GIR_Coverage, 5718,
     /*  255086 */     GIR_EraseRootFromParent_Done,
     /*  255087 */   // Label 4904: @255087
     /*  255087 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(255150), // Rule ID 5719 //
     /*  255092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  255106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  255109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255131 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255148 */     GIR_RootConstrainSelectedInstOperands,
     /*  255149 */     // GIR_Coverage, 5719,
     /*  255149 */     GIR_EraseRootFromParent_Done,
     /*  255150 */   // Label 4905: @255150
     /*  255150 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(255213), // Rule ID 5720 //
     /*  255155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  255166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  255169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  255172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255194 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255211 */     GIR_RootConstrainSelectedInstOperands,
     /*  255212 */     // GIR_Coverage, 5720,
     /*  255212 */     GIR_EraseRootFromParent_Done,
     /*  255213 */   // Label 4906: @255213
     /*  255213 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(255276), // Rule ID 5721 //
     /*  255218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  255229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  255232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  255235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255257 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255274 */     GIR_RootConstrainSelectedInstOperands,
     /*  255275 */     // GIR_Coverage, 5721,
     /*  255275 */     GIR_EraseRootFromParent_Done,
     /*  255276 */   // Label 4907: @255276
     /*  255276 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(255339), // Rule ID 5722 //
     /*  255281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  255295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  255298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255320 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255337 */     GIR_RootConstrainSelectedInstOperands,
     /*  255338 */     // GIR_Coverage, 5722,
     /*  255338 */     GIR_EraseRootFromParent_Done,
     /*  255339 */   // Label 4908: @255339
     /*  255339 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(255402), // Rule ID 5723 //
     /*  255344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  255358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  255361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255383 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255400 */     GIR_RootConstrainSelectedInstOperands,
     /*  255401 */     // GIR_Coverage, 5723,
     /*  255401 */     GIR_EraseRootFromParent_Done,
     /*  255402 */   // Label 4909: @255402
     /*  255402 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(255465), // Rule ID 5724 //
     /*  255407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  255421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  255424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255446 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255463 */     GIR_RootConstrainSelectedInstOperands,
     /*  255464 */     // GIR_Coverage, 5724,
     /*  255464 */     GIR_EraseRootFromParent_Done,
     /*  255465 */   // Label 4910: @255465
     /*  255465 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(255528), // Rule ID 5725 //
     /*  255470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  255484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  255487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255509 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255526 */     GIR_RootConstrainSelectedInstOperands,
     /*  255527 */     // GIR_Coverage, 5725,
     /*  255527 */     GIR_EraseRootFromParent_Done,
     /*  255528 */   // Label 4911: @255528
     /*  255528 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(255591), // Rule ID 5726 //
     /*  255533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  255547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  255550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255572 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255589 */     GIR_RootConstrainSelectedInstOperands,
     /*  255590 */     // GIR_Coverage, 5726,
     /*  255590 */     GIR_EraseRootFromParent_Done,
     /*  255591 */   // Label 4912: @255591
     /*  255591 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(255654), // Rule ID 5727 //
     /*  255596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  255610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  255613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255635 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255652 */     GIR_RootConstrainSelectedInstOperands,
     /*  255653 */     // GIR_Coverage, 5727,
     /*  255653 */     GIR_EraseRootFromParent_Done,
     /*  255654 */   // Label 4913: @255654
     /*  255654 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(255717), // Rule ID 5728 //
     /*  255659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  255673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  255676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255698 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255715 */     GIR_RootConstrainSelectedInstOperands,
     /*  255716 */     // GIR_Coverage, 5728,
     /*  255716 */     GIR_EraseRootFromParent_Done,
     /*  255717 */   // Label 4914: @255717
     /*  255717 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(255780), // Rule ID 5729 //
     /*  255722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  255736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  255739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255761 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255778 */     GIR_RootConstrainSelectedInstOperands,
     /*  255779 */     // GIR_Coverage, 5729,
     /*  255779 */     GIR_EraseRootFromParent_Done,
     /*  255780 */   // Label 4915: @255780
     /*  255780 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(255843), // Rule ID 5730 //
     /*  255785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  255799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  255802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255841 */     GIR_RootConstrainSelectedInstOperands,
     /*  255842 */     // GIR_Coverage, 5730,
     /*  255842 */     GIR_EraseRootFromParent_Done,
     /*  255843 */   // Label 4916: @255843
     /*  255843 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(255906), // Rule ID 5731 //
     /*  255848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  255862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  255865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255887 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255904 */     GIR_RootConstrainSelectedInstOperands,
     /*  255905 */     // GIR_Coverage, 5731,
     /*  255905 */     GIR_EraseRootFromParent_Done,
     /*  255906 */   // Label 4917: @255906
     /*  255906 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(255969), // Rule ID 5732 //
     /*  255911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  255925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  255928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255950 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255967 */     GIR_RootConstrainSelectedInstOperands,
     /*  255968 */     // GIR_Coverage, 5732,
     /*  255968 */     GIR_EraseRootFromParent_Done,
     /*  255969 */   // Label 4918: @255969
     /*  255969 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(256032), // Rule ID 5733 //
     /*  255974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  255988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  255991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256013 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  256013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  256016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256030 */     GIR_RootConstrainSelectedInstOperands,
     /*  256031 */     // GIR_Coverage, 5733,
     /*  256031 */     GIR_EraseRootFromParent_Done,
     /*  256032 */   // Label 4919: @256032
     /*  256032 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(256095), // Rule ID 5734 //
     /*  256037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  256051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  256054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256076 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  256079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256093 */     GIR_RootConstrainSelectedInstOperands,
     /*  256094 */     // GIR_Coverage, 5734,
     /*  256094 */     GIR_EraseRootFromParent_Done,
     /*  256095 */   // Label 4920: @256095
     /*  256095 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(256158), // Rule ID 5735 //
     /*  256100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  256114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  256117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256139 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  256142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256156 */     GIR_RootConstrainSelectedInstOperands,
     /*  256157 */     // GIR_Coverage, 5735,
     /*  256157 */     GIR_EraseRootFromParent_Done,
     /*  256158 */   // Label 4921: @256158
     /*  256158 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(256221), // Rule ID 5736 //
     /*  256163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  256177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  256180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256202 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  256205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256219 */     GIR_RootConstrainSelectedInstOperands,
     /*  256220 */     // GIR_Coverage, 5736,
     /*  256220 */     GIR_EraseRootFromParent_Done,
     /*  256221 */   // Label 4922: @256221
     /*  256221 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(256284), // Rule ID 5737 //
     /*  256226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  256240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  256243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256265 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  256268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256282 */     GIR_RootConstrainSelectedInstOperands,
     /*  256283 */     // GIR_Coverage, 5737,
     /*  256283 */     GIR_EraseRootFromParent_Done,
     /*  256284 */   // Label 4923: @256284
     /*  256284 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(256347), // Rule ID 5738 //
     /*  256289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  256303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  256306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  256331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256345 */     GIR_RootConstrainSelectedInstOperands,
     /*  256346 */     // GIR_Coverage, 5738,
     /*  256346 */     GIR_EraseRootFromParent_Done,
     /*  256347 */   // Label 4924: @256347
     /*  256347 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(256410), // Rule ID 5739 //
     /*  256352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  256366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  256369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256391 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  256394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256408 */     GIR_RootConstrainSelectedInstOperands,
     /*  256409 */     // GIR_Coverage, 5739,
     /*  256409 */     GIR_EraseRootFromParent_Done,
     /*  256410 */   // Label 4925: @256410
     /*  256410 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(256473), // Rule ID 5740 //
     /*  256415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  256429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256454 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  256457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256471 */     GIR_RootConstrainSelectedInstOperands,
     /*  256472 */     // GIR_Coverage, 5740,
     /*  256472 */     GIR_EraseRootFromParent_Done,
     /*  256473 */   // Label 4926: @256473
     /*  256473 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(256536), // Rule ID 5741 //
     /*  256478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  256492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256517 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  256520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256534 */     GIR_RootConstrainSelectedInstOperands,
     /*  256535 */     // GIR_Coverage, 5741,
     /*  256535 */     GIR_EraseRootFromParent_Done,
     /*  256536 */   // Label 4927: @256536
     /*  256536 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(256599), // Rule ID 5742 //
     /*  256541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  256555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256597 */     GIR_RootConstrainSelectedInstOperands,
     /*  256598 */     // GIR_Coverage, 5742,
     /*  256598 */     GIR_EraseRootFromParent_Done,
     /*  256599 */   // Label 4928: @256599
     /*  256599 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(256662), // Rule ID 5743 //
     /*  256604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  256618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256643 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256660 */     GIR_RootConstrainSelectedInstOperands,
     /*  256661 */     // GIR_Coverage, 5743,
     /*  256661 */     GIR_EraseRootFromParent_Done,
     /*  256662 */   // Label 4929: @256662
     /*  256662 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(256725), // Rule ID 5744 //
     /*  256667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  256681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256706 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256723 */     GIR_RootConstrainSelectedInstOperands,
     /*  256724 */     // GIR_Coverage, 5744,
     /*  256724 */     GIR_EraseRootFromParent_Done,
     /*  256725 */   // Label 4930: @256725
     /*  256725 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(256788), // Rule ID 5745 //
     /*  256730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  256744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256769 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256786 */     GIR_RootConstrainSelectedInstOperands,
     /*  256787 */     // GIR_Coverage, 5745,
     /*  256787 */     GIR_EraseRootFromParent_Done,
     /*  256788 */   // Label 4931: @256788
     /*  256788 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(256851), // Rule ID 5746 //
     /*  256793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  256807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256832 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256849 */     GIR_RootConstrainSelectedInstOperands,
     /*  256850 */     // GIR_Coverage, 5746,
     /*  256850 */     GIR_EraseRootFromParent_Done,
     /*  256851 */   // Label 4932: @256851
     /*  256851 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(256914), // Rule ID 5747 //
     /*  256856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  256870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256895 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256912 */     GIR_RootConstrainSelectedInstOperands,
     /*  256913 */     // GIR_Coverage, 5747,
     /*  256913 */     GIR_EraseRootFromParent_Done,
     /*  256914 */   // Label 4933: @256914
     /*  256914 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(256977), // Rule ID 5748 //
     /*  256919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  256933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256958 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256975 */     GIR_RootConstrainSelectedInstOperands,
     /*  256976 */     // GIR_Coverage, 5748,
     /*  256976 */     GIR_EraseRootFromParent_Done,
     /*  256977 */   // Label 4934: @256977
     /*  256977 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(257040), // Rule ID 5749 //
     /*  256982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  256996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257021 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  257024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257038 */     GIR_RootConstrainSelectedInstOperands,
     /*  257039 */     // GIR_Coverage, 5749,
     /*  257039 */     GIR_EraseRootFromParent_Done,
     /*  257040 */   // Label 4935: @257040
     /*  257040 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(257103), // Rule ID 5750 //
     /*  257045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  257059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257084 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  257084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  257087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257101 */     GIR_RootConstrainSelectedInstOperands,
     /*  257102 */     // GIR_Coverage, 5750,
     /*  257102 */     GIR_EraseRootFromParent_Done,
     /*  257103 */   // Label 4936: @257103
     /*  257103 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(257166), // Rule ID 5751 //
     /*  257108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  257122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257147 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  257147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  257150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257164 */     GIR_RootConstrainSelectedInstOperands,
     /*  257165 */     // GIR_Coverage, 5751,
     /*  257165 */     GIR_EraseRootFromParent_Done,
     /*  257166 */   // Label 4937: @257166
     /*  257166 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(257229), // Rule ID 5752 //
     /*  257171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  257185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257210 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257227 */     GIR_RootConstrainSelectedInstOperands,
     /*  257228 */     // GIR_Coverage, 5752,
     /*  257228 */     GIR_EraseRootFromParent_Done,
     /*  257229 */   // Label 4938: @257229
     /*  257229 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(257292), // Rule ID 5753 //
     /*  257234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  257248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257273 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257290 */     GIR_RootConstrainSelectedInstOperands,
     /*  257291 */     // GIR_Coverage, 5753,
     /*  257291 */     GIR_EraseRootFromParent_Done,
     /*  257292 */   // Label 4939: @257292
     /*  257292 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(257355), // Rule ID 5754 //
     /*  257297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  257311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257336 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257353 */     GIR_RootConstrainSelectedInstOperands,
     /*  257354 */     // GIR_Coverage, 5754,
     /*  257354 */     GIR_EraseRootFromParent_Done,
     /*  257355 */   // Label 4940: @257355
     /*  257355 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(257418), // Rule ID 5755 //
     /*  257360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  257374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257399 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257416 */     GIR_RootConstrainSelectedInstOperands,
     /*  257417 */     // GIR_Coverage, 5755,
     /*  257417 */     GIR_EraseRootFromParent_Done,
     /*  257418 */   // Label 4941: @257418
     /*  257418 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(257481), // Rule ID 5756 //
     /*  257423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  257437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257462 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  257462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257479 */     GIR_RootConstrainSelectedInstOperands,
     /*  257480 */     // GIR_Coverage, 5756,
     /*  257480 */     GIR_EraseRootFromParent_Done,
     /*  257481 */   // Label 4942: @257481
     /*  257481 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(257544), // Rule ID 5757 //
     /*  257486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  257500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257525 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  257525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257542 */     GIR_RootConstrainSelectedInstOperands,
     /*  257543 */     // GIR_Coverage, 5757,
     /*  257543 */     GIR_EraseRootFromParent_Done,
     /*  257544 */   // Label 4943: @257544
     /*  257544 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(257607), // Rule ID 5758 //
     /*  257549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  257552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  257563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257588 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  257588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  257605 */     GIR_RootConstrainSelectedInstOperands,
     /*  257606 */     // GIR_Coverage, 5758,
     /*  257606 */     GIR_EraseRootFromParent_Done,
     /*  257607 */   // Label 4944: @257607
     /*  257607 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(257670), // Rule ID 5759 //
     /*  257612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  257615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  257626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257651 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  257651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  257668 */     GIR_RootConstrainSelectedInstOperands,
     /*  257669 */     // GIR_Coverage, 5759,
     /*  257669 */     GIR_EraseRootFromParent_Done,
     /*  257670 */   // Label 4945: @257670
     /*  257670 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(257733), // Rule ID 5760 //
     /*  257675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  257689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257714 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257731 */     GIR_RootConstrainSelectedInstOperands,
     /*  257732 */     // GIR_Coverage, 5760,
     /*  257732 */     GIR_EraseRootFromParent_Done,
     /*  257733 */   // Label 4946: @257733
     /*  257733 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(257796), // Rule ID 5761 //
     /*  257738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  257752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257777 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257794 */     GIR_RootConstrainSelectedInstOperands,
     /*  257795 */     // GIR_Coverage, 5761,
     /*  257795 */     GIR_EraseRootFromParent_Done,
     /*  257796 */   // Label 4947: @257796
     /*  257796 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(257859), // Rule ID 5762 //
     /*  257801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  257815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257840 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257857 */     GIR_RootConstrainSelectedInstOperands,
     /*  257858 */     // GIR_Coverage, 5762,
     /*  257858 */     GIR_EraseRootFromParent_Done,
     /*  257859 */   // Label 4948: @257859
     /*  257859 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(257922), // Rule ID 5763 //
     /*  257864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  257878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257903 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257920 */     GIR_RootConstrainSelectedInstOperands,
     /*  257921 */     // GIR_Coverage, 5763,
     /*  257921 */     GIR_EraseRootFromParent_Done,
     /*  257922 */   // Label 4949: @257922
     /*  257922 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(257985), // Rule ID 5764 //
     /*  257927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  257938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  257941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257966 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257983 */     GIR_RootConstrainSelectedInstOperands,
     /*  257984 */     // GIR_Coverage, 5764,
     /*  257984 */     GIR_EraseRootFromParent_Done,
     /*  257985 */   // Label 4950: @257985
     /*  257985 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(258048), // Rule ID 5765 //
     /*  257990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  258001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  258004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258029 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258046 */     GIR_RootConstrainSelectedInstOperands,
     /*  258047 */     // GIR_Coverage, 5765,
     /*  258047 */     GIR_EraseRootFromParent_Done,
     /*  258048 */   // Label 4951: @258048
     /*  258048 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(258111), // Rule ID 5766 //
     /*  258053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  258067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258092 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258109 */     GIR_RootConstrainSelectedInstOperands,
     /*  258110 */     // GIR_Coverage, 5766,
     /*  258110 */     GIR_EraseRootFromParent_Done,
     /*  258111 */   // Label 4952: @258111
     /*  258111 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(258174), // Rule ID 5767 //
     /*  258116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  258130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258155 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  258155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258172 */     GIR_RootConstrainSelectedInstOperands,
     /*  258173 */     // GIR_Coverage, 5767,
     /*  258173 */     GIR_EraseRootFromParent_Done,
     /*  258174 */   // Label 4953: @258174
     /*  258174 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(258237), // Rule ID 5768 //
     /*  258179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  258193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258218 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258235 */     GIR_RootConstrainSelectedInstOperands,
     /*  258236 */     // GIR_Coverage, 5768,
     /*  258236 */     GIR_EraseRootFromParent_Done,
     /*  258237 */   // Label 4954: @258237
     /*  258237 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(258300), // Rule ID 5769 //
     /*  258242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  258256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258281 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  258281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258298 */     GIR_RootConstrainSelectedInstOperands,
     /*  258299 */     // GIR_Coverage, 5769,
     /*  258299 */     GIR_EraseRootFromParent_Done,
     /*  258300 */   // Label 4955: @258300
     /*  258300 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(258363), // Rule ID 5770 //
     /*  258305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  258316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  258319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258344 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258361 */     GIR_RootConstrainSelectedInstOperands,
     /*  258362 */     // GIR_Coverage, 5770,
     /*  258362 */     GIR_EraseRootFromParent_Done,
     /*  258363 */   // Label 4956: @258363
     /*  258363 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(258426), // Rule ID 5771 //
     /*  258368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  258379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  258382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258407 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  258407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258424 */     GIR_RootConstrainSelectedInstOperands,
     /*  258425 */     // GIR_Coverage, 5771,
     /*  258425 */     GIR_EraseRootFromParent_Done,
     /*  258426 */   // Label 4957: @258426
     /*  258426 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(258489), // Rule ID 5772 //
     /*  258431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  258445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258470 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258487 */     GIR_RootConstrainSelectedInstOperands,
     /*  258488 */     // GIR_Coverage, 5772,
     /*  258488 */     GIR_EraseRootFromParent_Done,
     /*  258489 */   // Label 4958: @258489
     /*  258489 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(258552), // Rule ID 5773 //
     /*  258494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  258508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258533 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258550 */     GIR_RootConstrainSelectedInstOperands,
     /*  258551 */     // GIR_Coverage, 5773,
     /*  258551 */     GIR_EraseRootFromParent_Done,
     /*  258552 */   // Label 4959: @258552
     /*  258552 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(258615), // Rule ID 5774 //
     /*  258557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  258571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258596 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258613 */     GIR_RootConstrainSelectedInstOperands,
     /*  258614 */     // GIR_Coverage, 5774,
     /*  258614 */     GIR_EraseRootFromParent_Done,
     /*  258615 */   // Label 4960: @258615
     /*  258615 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(258678), // Rule ID 5775 //
     /*  258620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  258634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258659 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258676 */     GIR_RootConstrainSelectedInstOperands,
     /*  258677 */     // GIR_Coverage, 5775,
     /*  258677 */     GIR_EraseRootFromParent_Done,
     /*  258678 */   // Label 4961: @258678
     /*  258678 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(258741), // Rule ID 5776 //
     /*  258683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  258697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258722 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258739 */     GIR_RootConstrainSelectedInstOperands,
     /*  258740 */     // GIR_Coverage, 5776,
     /*  258740 */     GIR_EraseRootFromParent_Done,
     /*  258741 */   // Label 4962: @258741
     /*  258741 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(258804), // Rule ID 5777 //
     /*  258746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  258760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258785 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258802 */     GIR_RootConstrainSelectedInstOperands,
     /*  258803 */     // GIR_Coverage, 5777,
     /*  258803 */     GIR_EraseRootFromParent_Done,
     /*  258804 */   // Label 4963: @258804
     /*  258804 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(258867), // Rule ID 5778 //
     /*  258809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  258823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258848 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258865 */     GIR_RootConstrainSelectedInstOperands,
     /*  258866 */     // GIR_Coverage, 5778,
     /*  258866 */     GIR_EraseRootFromParent_Done,
     /*  258867 */   // Label 4964: @258867
     /*  258867 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(258930), // Rule ID 5779 //
     /*  258872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  258886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258911 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  258911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258928 */     GIR_RootConstrainSelectedInstOperands,
     /*  258929 */     // GIR_Coverage, 5779,
     /*  258929 */     GIR_EraseRootFromParent_Done,
     /*  258930 */   // Label 4965: @258930
     /*  258930 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(258993), // Rule ID 5780 //
     /*  258935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  258949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258974 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258991 */     GIR_RootConstrainSelectedInstOperands,
     /*  258992 */     // GIR_Coverage, 5780,
     /*  258992 */     GIR_EraseRootFromParent_Done,
     /*  258993 */   // Label 4966: @258993
     /*  258993 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(259056), // Rule ID 5781 //
     /*  258998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  259001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  259012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  259015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  259030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259037 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  259040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259054 */     GIR_RootConstrainSelectedInstOperands,
     /*  259055 */     // GIR_Coverage, 5781,
     /*  259055 */     GIR_EraseRootFromParent_Done,
     /*  259056 */   // Label 4967: @259056
     /*  259056 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(259119), // Rule ID 5782 //
     /*  259061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  259064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  259075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  259078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  259093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259100 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  259100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  259103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259117 */     GIR_RootConstrainSelectedInstOperands,
     /*  259118 */     // GIR_Coverage, 5782,
     /*  259118 */     GIR_EraseRootFromParent_Done,
     /*  259119 */   // Label 4968: @259119
     /*  259119 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(259182), // Rule ID 5783 //
     /*  259124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  259127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  259138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  259141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  259156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259163 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  259166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259180 */     GIR_RootConstrainSelectedInstOperands,
     /*  259181 */     // GIR_Coverage, 5783,
     /*  259181 */     GIR_EraseRootFromParent_Done,
     /*  259182 */   // Label 4969: @259182
     /*  259182 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(259245), // Rule ID 7816 //
     /*  259187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  259201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  259204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259226 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  259229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259243 */     GIR_RootConstrainSelectedInstOperands,
     /*  259244 */     // GIR_Coverage, 7816,
     /*  259244 */     GIR_EraseRootFromParent_Done,
     /*  259245 */   // Label 4970: @259245
     /*  259245 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(259308), // Rule ID 7817 //
     /*  259250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  259264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  259267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259289 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  259292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259306 */     GIR_RootConstrainSelectedInstOperands,
     /*  259307 */     // GIR_Coverage, 7817,
     /*  259307 */     GIR_EraseRootFromParent_Done,
     /*  259308 */   // Label 4971: @259308
     /*  259308 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(259371), // Rule ID 7820 //
     /*  259313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  259327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  259330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259352 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259369 */     GIR_RootConstrainSelectedInstOperands,
     /*  259370 */     // GIR_Coverage, 7820,
     /*  259370 */     GIR_EraseRootFromParent_Done,
     /*  259371 */   // Label 4972: @259371
     /*  259371 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(259434), // Rule ID 7821 //
     /*  259376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  259390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  259393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259415 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259432 */     GIR_RootConstrainSelectedInstOperands,
     /*  259433 */     // GIR_Coverage, 7821,
     /*  259433 */     GIR_EraseRootFromParent_Done,
     /*  259434 */   // Label 4973: @259434
     /*  259434 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(259497), // Rule ID 7824 //
     /*  259439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  259453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  259456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259478 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  259481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259495 */     GIR_RootConstrainSelectedInstOperands,
     /*  259496 */     // GIR_Coverage, 7824,
     /*  259496 */     GIR_EraseRootFromParent_Done,
     /*  259497 */   // Label 4974: @259497
     /*  259497 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(259560), // Rule ID 7825 //
     /*  259502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  259516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  259519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259541 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  259544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259558 */     GIR_RootConstrainSelectedInstOperands,
     /*  259559 */     // GIR_Coverage, 7825,
     /*  259559 */     GIR_EraseRootFromParent_Done,
     /*  259560 */   // Label 4975: @259560
     /*  259560 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(259623), // Rule ID 7828 //
     /*  259565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  259579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  259582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259604 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259621 */     GIR_RootConstrainSelectedInstOperands,
     /*  259622 */     // GIR_Coverage, 7828,
     /*  259622 */     GIR_EraseRootFromParent_Done,
     /*  259623 */   // Label 4976: @259623
     /*  259623 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(259686), // Rule ID 7829 //
     /*  259628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  259642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  259645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259667 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259684 */     GIR_RootConstrainSelectedInstOperands,
     /*  259685 */     // GIR_Coverage, 7829,
     /*  259685 */     GIR_EraseRootFromParent_Done,
     /*  259686 */   // Label 4977: @259686
     /*  259686 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(259749), // Rule ID 7832 //
     /*  259691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  259705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  259708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259730 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259747 */     GIR_RootConstrainSelectedInstOperands,
     /*  259748 */     // GIR_Coverage, 7832,
     /*  259748 */     GIR_EraseRootFromParent_Done,
     /*  259749 */   // Label 4978: @259749
     /*  259749 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(259812), // Rule ID 7833 //
     /*  259754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  259768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  259771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259793 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259810 */     GIR_RootConstrainSelectedInstOperands,
     /*  259811 */     // GIR_Coverage, 7833,
     /*  259811 */     GIR_EraseRootFromParent_Done,
     /*  259812 */   // Label 4979: @259812
     /*  259812 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(259875), // Rule ID 7836 //
     /*  259817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  259831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  259834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259856 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259873 */     GIR_RootConstrainSelectedInstOperands,
     /*  259874 */     // GIR_Coverage, 7836,
     /*  259874 */     GIR_EraseRootFromParent_Done,
     /*  259875 */   // Label 4980: @259875
     /*  259875 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(259938), // Rule ID 7837 //
     /*  259880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  259894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  259897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259919 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259936 */     GIR_RootConstrainSelectedInstOperands,
     /*  259937 */     // GIR_Coverage, 7837,
     /*  259937 */     GIR_EraseRootFromParent_Done,
     /*  259938 */   // Label 4981: @259938
     /*  259938 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(260001), // Rule ID 7840 //
     /*  259943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  259957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  259960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259982 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259999 */     GIR_RootConstrainSelectedInstOperands,
     /*  260000 */     // GIR_Coverage, 7840,
     /*  260000 */     GIR_EraseRootFromParent_Done,
     /*  260001 */   // Label 4982: @260001
     /*  260001 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(260064), // Rule ID 7841 //
     /*  260006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  260020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  260023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260045 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  260048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260062 */     GIR_RootConstrainSelectedInstOperands,
     /*  260063 */     // GIR_Coverage, 7841,
     /*  260063 */     GIR_EraseRootFromParent_Done,
     /*  260064 */   // Label 4983: @260064
     /*  260064 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(260127), // Rule ID 7844 //
     /*  260069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  260083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  260086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260108 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  260111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260125 */     GIR_RootConstrainSelectedInstOperands,
     /*  260126 */     // GIR_Coverage, 7844,
     /*  260126 */     GIR_EraseRootFromParent_Done,
     /*  260127 */   // Label 4984: @260127
     /*  260127 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(260190), // Rule ID 7845 //
     /*  260132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  260146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  260149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260171 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  260174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260188 */     GIR_RootConstrainSelectedInstOperands,
     /*  260189 */     // GIR_Coverage, 7845,
     /*  260189 */     GIR_EraseRootFromParent_Done,
     /*  260190 */   // Label 4985: @260190
     /*  260190 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(260253), // Rule ID 7848 //
     /*  260195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  260198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  260209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  260212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260234 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  260234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  260237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  260251 */     GIR_RootConstrainSelectedInstOperands,
     /*  260252 */     // GIR_Coverage, 7848,
     /*  260252 */     GIR_EraseRootFromParent_Done,
     /*  260253 */   // Label 4986: @260253
     /*  260253 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(260316), // Rule ID 7849 //
     /*  260258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  260261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  260272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  260275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260297 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  260297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  260300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  260314 */     GIR_RootConstrainSelectedInstOperands,
     /*  260315 */     // GIR_Coverage, 7849,
     /*  260315 */     GIR_EraseRootFromParent_Done,
     /*  260316 */   // Label 4987: @260316
     /*  260316 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(260379), // Rule ID 7852 //
     /*  260321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  260335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  260338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260360 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260377 */     GIR_RootConstrainSelectedInstOperands,
     /*  260378 */     // GIR_Coverage, 7852,
     /*  260378 */     GIR_EraseRootFromParent_Done,
     /*  260379 */   // Label 4988: @260379
     /*  260379 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(260442), // Rule ID 7853 //
     /*  260384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  260398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  260401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260423 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260440 */     GIR_RootConstrainSelectedInstOperands,
     /*  260441 */     // GIR_Coverage, 7853,
     /*  260441 */     GIR_EraseRootFromParent_Done,
     /*  260442 */   // Label 4989: @260442
     /*  260442 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(260505), // Rule ID 7856 //
     /*  260447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  260461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  260464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260486 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260503 */     GIR_RootConstrainSelectedInstOperands,
     /*  260504 */     // GIR_Coverage, 7856,
     /*  260504 */     GIR_EraseRootFromParent_Done,
     /*  260505 */   // Label 4990: @260505
     /*  260505 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(260568), // Rule ID 7857 //
     /*  260510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  260524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  260527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260549 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260566 */     GIR_RootConstrainSelectedInstOperands,
     /*  260567 */     // GIR_Coverage, 7857,
     /*  260567 */     GIR_EraseRootFromParent_Done,
     /*  260568 */   // Label 4991: @260568
     /*  260568 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(260631), // Rule ID 7860 //
     /*  260573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  260584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  260587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  260590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260612 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260629 */     GIR_RootConstrainSelectedInstOperands,
     /*  260630 */     // GIR_Coverage, 7860,
     /*  260630 */     GIR_EraseRootFromParent_Done,
     /*  260631 */   // Label 4992: @260631
     /*  260631 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(260694), // Rule ID 7861 //
     /*  260636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  260647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  260650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  260653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260675 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260692 */     GIR_RootConstrainSelectedInstOperands,
     /*  260693 */     // GIR_Coverage, 7861,
     /*  260693 */     GIR_EraseRootFromParent_Done,
     /*  260694 */   // Label 4993: @260694
     /*  260694 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(260757), // Rule ID 7864 //
     /*  260699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  260713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  260716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260755 */     GIR_RootConstrainSelectedInstOperands,
     /*  260756 */     // GIR_Coverage, 7864,
     /*  260756 */     GIR_EraseRootFromParent_Done,
     /*  260757 */   // Label 4994: @260757
     /*  260757 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(260820), // Rule ID 7865 //
     /*  260762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  260776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  260779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260801 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260818 */     GIR_RootConstrainSelectedInstOperands,
     /*  260819 */     // GIR_Coverage, 7865,
     /*  260819 */     GIR_EraseRootFromParent_Done,
     /*  260820 */   // Label 4995: @260820
     /*  260820 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(260883), // Rule ID 7868 //
     /*  260825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  260839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  260842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260864 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260881 */     GIR_RootConstrainSelectedInstOperands,
     /*  260882 */     // GIR_Coverage, 7868,
     /*  260882 */     GIR_EraseRootFromParent_Done,
     /*  260883 */   // Label 4996: @260883
     /*  260883 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(260946), // Rule ID 7869 //
     /*  260888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  260902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  260905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260927 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260944 */     GIR_RootConstrainSelectedInstOperands,
     /*  260945 */     // GIR_Coverage, 7869,
     /*  260945 */     GIR_EraseRootFromParent_Done,
     /*  260946 */   // Label 4997: @260946
     /*  260946 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(261009), // Rule ID 7872 //
     /*  260951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  260965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  260968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260990 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261007 */     GIR_RootConstrainSelectedInstOperands,
     /*  261008 */     // GIR_Coverage, 7872,
     /*  261008 */     GIR_EraseRootFromParent_Done,
     /*  261009 */   // Label 4998: @261009
     /*  261009 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(261072), // Rule ID 7873 //
     /*  261014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  261025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  261028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  261031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261053 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261070 */     GIR_RootConstrainSelectedInstOperands,
     /*  261071 */     // GIR_Coverage, 7873,
     /*  261071 */     GIR_EraseRootFromParent_Done,
     /*  261072 */   // Label 4999: @261072
     /*  261072 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(261135), // Rule ID 7876 //
     /*  261077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  261091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  261094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261116 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  261116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  261119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261133 */     GIR_RootConstrainSelectedInstOperands,
     /*  261134 */     // GIR_Coverage, 7876,
     /*  261134 */     GIR_EraseRootFromParent_Done,
     /*  261135 */   // Label 5000: @261135
     /*  261135 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(261198), // Rule ID 7877 //
     /*  261140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  261154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  261157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261179 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  261179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  261182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261196 */     GIR_RootConstrainSelectedInstOperands,
     /*  261197 */     // GIR_Coverage, 7877,
     /*  261197 */     GIR_EraseRootFromParent_Done,
     /*  261198 */   // Label 5001: @261198
     /*  261198 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(261261), // Rule ID 7880 //
     /*  261203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  261217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  261220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261242 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  261242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  261245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261259 */     GIR_RootConstrainSelectedInstOperands,
     /*  261260 */     // GIR_Coverage, 7880,
     /*  261260 */     GIR_EraseRootFromParent_Done,
     /*  261261 */   // Label 5002: @261261
     /*  261261 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(261324), // Rule ID 7881 //
     /*  261266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  261280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  261283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261305 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  261305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  261308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261322 */     GIR_RootConstrainSelectedInstOperands,
     /*  261323 */     // GIR_Coverage, 7881,
     /*  261323 */     GIR_EraseRootFromParent_Done,
     /*  261324 */   // Label 5003: @261324
     /*  261324 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(261387), // Rule ID 7884 //
     /*  261329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  261340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  261343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  261346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261368 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  261368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261385 */     GIR_RootConstrainSelectedInstOperands,
     /*  261386 */     // GIR_Coverage, 7884,
     /*  261386 */     GIR_EraseRootFromParent_Done,
     /*  261387 */   // Label 5004: @261387
     /*  261387 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(261450), // Rule ID 7885 //
     /*  261392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  261403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  261406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  261409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261431 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  261431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261448 */     GIR_RootConstrainSelectedInstOperands,
     /*  261449 */     // GIR_Coverage, 7885,
     /*  261449 */     GIR_EraseRootFromParent_Done,
     /*  261450 */   // Label 5005: @261450
     /*  261450 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(261513), // Rule ID 7888 //
     /*  261455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  261458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  261469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  261472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261494 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  261494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  261497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261511 */     GIR_RootConstrainSelectedInstOperands,
     /*  261512 */     // GIR_Coverage, 7888,
     /*  261512 */     GIR_EraseRootFromParent_Done,
     /*  261513 */   // Label 5006: @261513
     /*  261513 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(261576), // Rule ID 7889 //
     /*  261518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  261521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  261532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  261535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261557 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  261560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261574 */     GIR_RootConstrainSelectedInstOperands,
     /*  261575 */     // GIR_Coverage, 7889,
     /*  261575 */     GIR_EraseRootFromParent_Done,
     /*  261576 */   // Label 5007: @261576
     /*  261576 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(261639), // Rule ID 7892 //
     /*  261581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  261584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  261595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  261598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261620 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  261620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  261623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261637 */     GIR_RootConstrainSelectedInstOperands,
     /*  261638 */     // GIR_Coverage, 7892,
     /*  261638 */     GIR_EraseRootFromParent_Done,
     /*  261639 */   // Label 5008: @261639
     /*  261639 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(261702), // Rule ID 7893 //
     /*  261644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  261647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  261658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  261661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261683 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  261686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261700 */     GIR_RootConstrainSelectedInstOperands,
     /*  261701 */     // GIR_Coverage, 7893,
     /*  261701 */     GIR_EraseRootFromParent_Done,
     /*  261702 */   // Label 5009: @261702
     /*  261702 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(261765), // Rule ID 7896 //
     /*  261707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  261710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  261721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  261724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261746 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  261746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261763 */     GIR_RootConstrainSelectedInstOperands,
     /*  261764 */     // GIR_Coverage, 7896,
     /*  261764 */     GIR_EraseRootFromParent_Done,
     /*  261765 */   // Label 5010: @261765
     /*  261765 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(261828), // Rule ID 7897 //
     /*  261770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  261773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  261784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  261787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261809 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261826 */     GIR_RootConstrainSelectedInstOperands,
     /*  261827 */     // GIR_Coverage, 7897,
     /*  261827 */     GIR_EraseRootFromParent_Done,
     /*  261828 */   // Label 5011: @261828
     /*  261828 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(261891), // Rule ID 7900 //
     /*  261833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  261847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261872 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  261875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261889 */     GIR_RootConstrainSelectedInstOperands,
     /*  261890 */     // GIR_Coverage, 7900,
     /*  261890 */     GIR_EraseRootFromParent_Done,
     /*  261891 */   // Label 5012: @261891
     /*  261891 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(261954), // Rule ID 7901 //
     /*  261896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  261910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261935 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  261938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261952 */     GIR_RootConstrainSelectedInstOperands,
     /*  261953 */     // GIR_Coverage, 7901,
     /*  261953 */     GIR_EraseRootFromParent_Done,
     /*  261954 */   // Label 5013: @261954
     /*  261954 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(262017), // Rule ID 7904 //
     /*  261959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  261973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  262001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262015 */     GIR_RootConstrainSelectedInstOperands,
     /*  262016 */     // GIR_Coverage, 7904,
     /*  262016 */     GIR_EraseRootFromParent_Done,
     /*  262017 */   // Label 5014: @262017
     /*  262017 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(262080), // Rule ID 7905 //
     /*  262022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  262036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262061 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  262064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262078 */     GIR_RootConstrainSelectedInstOperands,
     /*  262079 */     // GIR_Coverage, 7905,
     /*  262079 */     GIR_EraseRootFromParent_Done,
     /*  262080 */   // Label 5015: @262080
     /*  262080 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(262143), // Rule ID 7908 //
     /*  262085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  262099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262124 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262141 */     GIR_RootConstrainSelectedInstOperands,
     /*  262142 */     // GIR_Coverage, 7908,
     /*  262142 */     GIR_EraseRootFromParent_Done,
     /*  262143 */   // Label 5016: @262143
     /*  262143 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(262206), // Rule ID 7909 //
     /*  262148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  262162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262187 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262204 */     GIR_RootConstrainSelectedInstOperands,
     /*  262205 */     // GIR_Coverage, 7909,
     /*  262205 */     GIR_EraseRootFromParent_Done,
     /*  262206 */   // Label 5017: @262206
     /*  262206 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(262269), // Rule ID 7912 //
     /*  262211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  262225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262250 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  262253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262267 */     GIR_RootConstrainSelectedInstOperands,
     /*  262268 */     // GIR_Coverage, 7912,
     /*  262268 */     GIR_EraseRootFromParent_Done,
     /*  262269 */   // Label 5018: @262269
     /*  262269 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(262332), // Rule ID 7913 //
     /*  262274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  262288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262313 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  262316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262330 */     GIR_RootConstrainSelectedInstOperands,
     /*  262331 */     // GIR_Coverage, 7913,
     /*  262331 */     GIR_EraseRootFromParent_Done,
     /*  262332 */   // Label 5019: @262332
     /*  262332 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(262395), // Rule ID 7916 //
     /*  262337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  262351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262393 */     GIR_RootConstrainSelectedInstOperands,
     /*  262394 */     // GIR_Coverage, 7916,
     /*  262394 */     GIR_EraseRootFromParent_Done,
     /*  262395 */   // Label 5020: @262395
     /*  262395 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(262458), // Rule ID 7917 //
     /*  262400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  262414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262439 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262456 */     GIR_RootConstrainSelectedInstOperands,
     /*  262457 */     // GIR_Coverage, 7917,
     /*  262457 */     GIR_EraseRootFromParent_Done,
     /*  262458 */   // Label 5021: @262458
     /*  262458 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(262521), // Rule ID 7920 //
     /*  262463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  262477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262502 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  262502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262519 */     GIR_RootConstrainSelectedInstOperands,
     /*  262520 */     // GIR_Coverage, 7920,
     /*  262520 */     GIR_EraseRootFromParent_Done,
     /*  262521 */   // Label 5022: @262521
     /*  262521 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(262584), // Rule ID 7921 //
     /*  262526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  262540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262565 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262582 */     GIR_RootConstrainSelectedInstOperands,
     /*  262583 */     // GIR_Coverage, 7921,
     /*  262583 */     GIR_EraseRootFromParent_Done,
     /*  262584 */   // Label 5023: @262584
     /*  262584 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(262647), // Rule ID 7924 //
     /*  262589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  262603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262628 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262645 */     GIR_RootConstrainSelectedInstOperands,
     /*  262646 */     // GIR_Coverage, 7924,
     /*  262646 */     GIR_EraseRootFromParent_Done,
     /*  262647 */   // Label 5024: @262647
     /*  262647 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(262710), // Rule ID 7925 //
     /*  262652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  262666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262691 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262708 */     GIR_RootConstrainSelectedInstOperands,
     /*  262709 */     // GIR_Coverage, 7925,
     /*  262709 */     GIR_EraseRootFromParent_Done,
     /*  262710 */   // Label 5025: @262710
     /*  262710 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(262773), // Rule ID 7928 //
     /*  262715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  262729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262754 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262771 */     GIR_RootConstrainSelectedInstOperands,
     /*  262772 */     // GIR_Coverage, 7928,
     /*  262772 */     GIR_EraseRootFromParent_Done,
     /*  262773 */   // Label 5026: @262773
     /*  262773 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(262836), // Rule ID 7929 //
     /*  262778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  262792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262817 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262834 */     GIR_RootConstrainSelectedInstOperands,
     /*  262835 */     // GIR_Coverage, 7929,
     /*  262835 */     GIR_EraseRootFromParent_Done,
     /*  262836 */   // Label 5027: @262836
     /*  262836 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(262899), // Rule ID 7932 //
     /*  262841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  262855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  262880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262897 */     GIR_RootConstrainSelectedInstOperands,
     /*  262898 */     // GIR_Coverage, 7932,
     /*  262898 */     GIR_EraseRootFromParent_Done,
     /*  262899 */   // Label 5028: @262899
     /*  262899 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(262962), // Rule ID 7933 //
     /*  262904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  262918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262943 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262960 */     GIR_RootConstrainSelectedInstOperands,
     /*  262961 */     // GIR_Coverage, 7933,
     /*  262961 */     GIR_EraseRootFromParent_Done,
     /*  262962 */   // Label 5029: @262962
     /*  262962 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(263025), // Rule ID 7936 //
     /*  262967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  262970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  262981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263006 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  263006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  263009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263023 */     GIR_RootConstrainSelectedInstOperands,
     /*  263024 */     // GIR_Coverage, 7936,
     /*  263024 */     GIR_EraseRootFromParent_Done,
     /*  263025 */   // Label 5030: @263025
     /*  263025 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(263088), // Rule ID 7937 //
     /*  263030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  263033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  263044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263069 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  263069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  263072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263086 */     GIR_RootConstrainSelectedInstOperands,
     /*  263087 */     // GIR_Coverage, 7937,
     /*  263087 */     GIR_EraseRootFromParent_Done,
     /*  263088 */   // Label 5031: @263088
     /*  263088 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(263151), // Rule ID 7940 //
     /*  263093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  263107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263132 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263149 */     GIR_RootConstrainSelectedInstOperands,
     /*  263150 */     // GIR_Coverage, 7940,
     /*  263150 */     GIR_EraseRootFromParent_Done,
     /*  263151 */   // Label 5032: @263151
     /*  263151 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(263214), // Rule ID 7941 //
     /*  263156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  263170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263195 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263212 */     GIR_RootConstrainSelectedInstOperands,
     /*  263213 */     // GIR_Coverage, 7941,
     /*  263213 */     GIR_EraseRootFromParent_Done,
     /*  263214 */   // Label 5033: @263214
     /*  263214 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(263277), // Rule ID 7944 //
     /*  263219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  263233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263258 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263275 */     GIR_RootConstrainSelectedInstOperands,
     /*  263276 */     // GIR_Coverage, 7944,
     /*  263276 */     GIR_EraseRootFromParent_Done,
     /*  263277 */   // Label 5034: @263277
     /*  263277 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(263340), // Rule ID 7945 //
     /*  263282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  263296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263321 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263338 */     GIR_RootConstrainSelectedInstOperands,
     /*  263339 */     // GIR_Coverage, 7945,
     /*  263339 */     GIR_EraseRootFromParent_Done,
     /*  263340 */   // Label 5035: @263340
     /*  263340 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(263403), // Rule ID 7948 //
     /*  263345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  263356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  263359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263384 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263401 */     GIR_RootConstrainSelectedInstOperands,
     /*  263402 */     // GIR_Coverage, 7948,
     /*  263402 */     GIR_EraseRootFromParent_Done,
     /*  263403 */   // Label 5036: @263403
     /*  263403 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(263466), // Rule ID 7949 //
     /*  263408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  263419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  263422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263447 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263464 */     GIR_RootConstrainSelectedInstOperands,
     /*  263465 */     // GIR_Coverage, 7949,
     /*  263465 */     GIR_EraseRootFromParent_Done,
     /*  263466 */   // Label 5037: @263466
     /*  263466 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(263529), // Rule ID 7952 //
     /*  263471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  263485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263510 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263527 */     GIR_RootConstrainSelectedInstOperands,
     /*  263528 */     // GIR_Coverage, 7952,
     /*  263528 */     GIR_EraseRootFromParent_Done,
     /*  263529 */   // Label 5038: @263529
     /*  263529 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(263592), // Rule ID 7953 //
     /*  263534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  263548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263573 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263590 */     GIR_RootConstrainSelectedInstOperands,
     /*  263591 */     // GIR_Coverage, 7953,
     /*  263591 */     GIR_EraseRootFromParent_Done,
     /*  263592 */   // Label 5039: @263592
     /*  263592 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(263655), // Rule ID 7956 //
     /*  263597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  263611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263636 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263653 */     GIR_RootConstrainSelectedInstOperands,
     /*  263654 */     // GIR_Coverage, 7956,
     /*  263654 */     GIR_EraseRootFromParent_Done,
     /*  263655 */   // Label 5040: @263655
     /*  263655 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(263718), // Rule ID 7957 //
     /*  263660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  263674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263699 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263716 */     GIR_RootConstrainSelectedInstOperands,
     /*  263717 */     // GIR_Coverage, 7957,
     /*  263717 */     GIR_EraseRootFromParent_Done,
     /*  263718 */   // Label 5041: @263718
     /*  263718 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(263781), // Rule ID 7960 //
     /*  263723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  263737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263762 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263779 */     GIR_RootConstrainSelectedInstOperands,
     /*  263780 */     // GIR_Coverage, 7960,
     /*  263780 */     GIR_EraseRootFromParent_Done,
     /*  263781 */   // Label 5042: @263781
     /*  263781 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(263844), // Rule ID 7961 //
     /*  263786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  263800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263825 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263842 */     GIR_RootConstrainSelectedInstOperands,
     /*  263843 */     // GIR_Coverage, 7961,
     /*  263843 */     GIR_EraseRootFromParent_Done,
     /*  263844 */   // Label 5043: @263844
     /*  263844 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(263907), // Rule ID 7964 //
     /*  263849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  263863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263888 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263905 */     GIR_RootConstrainSelectedInstOperands,
     /*  263906 */     // GIR_Coverage, 7964,
     /*  263906 */     GIR_EraseRootFromParent_Done,
     /*  263907 */   // Label 5044: @263907
     /*  263907 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(263970), // Rule ID 7965 //
     /*  263912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  263926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263951 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263968 */     GIR_RootConstrainSelectedInstOperands,
     /*  263969 */     // GIR_Coverage, 7965,
     /*  263969 */     GIR_EraseRootFromParent_Done,
     /*  263970 */   // Label 5045: @263970
     /*  263970 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(264033), // Rule ID 7968 //
     /*  263975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  263989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264014 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  264017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264031 */     GIR_RootConstrainSelectedInstOperands,
     /*  264032 */     // GIR_Coverage, 7968,
     /*  264032 */     GIR_EraseRootFromParent_Done,
     /*  264033 */   // Label 5046: @264033
     /*  264033 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(264096), // Rule ID 7969 //
     /*  264038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  264052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  264055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264077 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  264080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264094 */     GIR_RootConstrainSelectedInstOperands,
     /*  264095 */     // GIR_Coverage, 7969,
     /*  264095 */     GIR_EraseRootFromParent_Done,
     /*  264096 */   // Label 5047: @264096
     /*  264096 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(264159), // Rule ID 7972 //
     /*  264101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  264115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  264118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264140 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  264143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264157 */     GIR_RootConstrainSelectedInstOperands,
     /*  264158 */     // GIR_Coverage, 7972,
     /*  264158 */     GIR_EraseRootFromParent_Done,
     /*  264159 */   // Label 5048: @264159
     /*  264159 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(264222), // Rule ID 7973 //
     /*  264164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  264178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  264181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264203 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  264206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264220 */     GIR_RootConstrainSelectedInstOperands,
     /*  264221 */     // GIR_Coverage, 7973,
     /*  264221 */     GIR_EraseRootFromParent_Done,
     /*  264222 */   // Label 5049: @264222
     /*  264222 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(264285), // Rule ID 7976 //
     /*  264227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  264241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  264244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264266 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  264269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264283 */     GIR_RootConstrainSelectedInstOperands,
     /*  264284 */     // GIR_Coverage, 7976,
     /*  264284 */     GIR_EraseRootFromParent_Done,
     /*  264285 */   // Label 5050: @264285
     /*  264285 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(264348), // Rule ID 7977 //
     /*  264290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  264293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  264304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  264307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264329 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  264329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  264332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264346 */     GIR_RootConstrainSelectedInstOperands,
     /*  264347 */     // GIR_Coverage, 7977,
     /*  264347 */     GIR_EraseRootFromParent_Done,
     /*  264348 */   // Label 5051: @264348
     /*  264348 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(264411), // Rule ID 7980 //
     /*  264353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  264367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  264370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264392 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  264395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264409 */     GIR_RootConstrainSelectedInstOperands,
     /*  264410 */     // GIR_Coverage, 7980,
     /*  264410 */     GIR_EraseRootFromParent_Done,
     /*  264411 */   // Label 5052: @264411
     /*  264411 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(264474), // Rule ID 7981 //
     /*  264416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  264419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  264430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  264433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264455 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  264455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  264458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264472 */     GIR_RootConstrainSelectedInstOperands,
     /*  264473 */     // GIR_Coverage, 7981,
     /*  264473 */     GIR_EraseRootFromParent_Done,
     /*  264474 */   // Label 5053: @264474
     /*  264474 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(264537), // Rule ID 7984 //
     /*  264479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  264493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  264496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264518 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  264521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264535 */     GIR_RootConstrainSelectedInstOperands,
     /*  264536 */     // GIR_Coverage, 7984,
     /*  264536 */     GIR_EraseRootFromParent_Done,
     /*  264537 */   // Label 5054: @264537
     /*  264537 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(264600), // Rule ID 7985 //
     /*  264542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  264545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  264556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  264559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264581 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  264581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  264584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264598 */     GIR_RootConstrainSelectedInstOperands,
     /*  264599 */     // GIR_Coverage, 7985,
     /*  264599 */     GIR_EraseRootFromParent_Done,
     /*  264600 */   // Label 5055: @264600
     /*  264600 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(264663), // Rule ID 8076 //
     /*  264605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  264619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  264622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264644 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  264647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264661 */     GIR_RootConstrainSelectedInstOperands,
     /*  264662 */     // GIR_Coverage, 8076,
     /*  264662 */     GIR_EraseRootFromParent_Done,
     /*  264663 */   // Label 5056: @264663
     /*  264663 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(264726), // Rule ID 8077 //
     /*  264668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  264682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  264685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264707 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  264710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264724 */     GIR_RootConstrainSelectedInstOperands,
     /*  264725 */     // GIR_Coverage, 8077,
     /*  264725 */     GIR_EraseRootFromParent_Done,
     /*  264726 */   // Label 5057: @264726
     /*  264726 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(264789), // Rule ID 8080 //
     /*  264731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  264745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  264748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264770 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264787 */     GIR_RootConstrainSelectedInstOperands,
     /*  264788 */     // GIR_Coverage, 8080,
     /*  264788 */     GIR_EraseRootFromParent_Done,
     /*  264789 */   // Label 5058: @264789
     /*  264789 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(264852), // Rule ID 8081 //
     /*  264794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  264808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  264811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264833 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264850 */     GIR_RootConstrainSelectedInstOperands,
     /*  264851 */     // GIR_Coverage, 8081,
     /*  264851 */     GIR_EraseRootFromParent_Done,
     /*  264852 */   // Label 5059: @264852
     /*  264852 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(264915), // Rule ID 8084 //
     /*  264857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  264871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  264874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264896 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264913 */     GIR_RootConstrainSelectedInstOperands,
     /*  264914 */     // GIR_Coverage, 8084,
     /*  264914 */     GIR_EraseRootFromParent_Done,
     /*  264915 */   // Label 5060: @264915
     /*  264915 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(264978), // Rule ID 8085 //
     /*  264920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  264934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  264937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264959 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264976 */     GIR_RootConstrainSelectedInstOperands,
     /*  264977 */     // GIR_Coverage, 8085,
     /*  264977 */     GIR_EraseRootFromParent_Done,
     /*  264978 */   // Label 5061: @264978
     /*  264978 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(265041), // Rule ID 8088 //
     /*  264983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  264997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  265000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265022 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  265025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265039 */     GIR_RootConstrainSelectedInstOperands,
     /*  265040 */     // GIR_Coverage, 8088,
     /*  265040 */     GIR_EraseRootFromParent_Done,
     /*  265041 */   // Label 5062: @265041
     /*  265041 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(265104), // Rule ID 8089 //
     /*  265046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  265060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  265063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265085 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  265088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265102 */     GIR_RootConstrainSelectedInstOperands,
     /*  265103 */     // GIR_Coverage, 8089,
     /*  265103 */     GIR_EraseRootFromParent_Done,
     /*  265104 */   // Label 5063: @265104
     /*  265104 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(265167), // Rule ID 8092 //
     /*  265109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  265123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  265126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265148 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  265151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265165 */     GIR_RootConstrainSelectedInstOperands,
     /*  265166 */     // GIR_Coverage, 8092,
     /*  265166 */     GIR_EraseRootFromParent_Done,
     /*  265167 */   // Label 5064: @265167
     /*  265167 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(265230), // Rule ID 8093 //
     /*  265172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  265186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  265189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265211 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  265214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265228 */     GIR_RootConstrainSelectedInstOperands,
     /*  265229 */     // GIR_Coverage, 8093,
     /*  265229 */     GIR_EraseRootFromParent_Done,
     /*  265230 */   // Label 5065: @265230
     /*  265230 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(265293), // Rule ID 8096 //
     /*  265235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  265249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  265252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265274 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  265274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  265277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265291 */     GIR_RootConstrainSelectedInstOperands,
     /*  265292 */     // GIR_Coverage, 8096,
     /*  265292 */     GIR_EraseRootFromParent_Done,
     /*  265293 */   // Label 5066: @265293
     /*  265293 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(265356), // Rule ID 8097 //
     /*  265298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  265312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  265315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265337 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  265337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  265340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265354 */     GIR_RootConstrainSelectedInstOperands,
     /*  265355 */     // GIR_Coverage, 8097,
     /*  265355 */     GIR_EraseRootFromParent_Done,
     /*  265356 */   // Label 5067: @265356
     /*  265356 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(265419), // Rule ID 8100 //
     /*  265361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  265375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  265378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265400 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265417 */     GIR_RootConstrainSelectedInstOperands,
     /*  265418 */     // GIR_Coverage, 8100,
     /*  265418 */     GIR_EraseRootFromParent_Done,
     /*  265419 */   // Label 5068: @265419
     /*  265419 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(265482), // Rule ID 8101 //
     /*  265424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  265438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  265441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265463 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265480 */     GIR_RootConstrainSelectedInstOperands,
     /*  265481 */     // GIR_Coverage, 8101,
     /*  265481 */     GIR_EraseRootFromParent_Done,
     /*  265482 */   // Label 5069: @265482
     /*  265482 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(265545), // Rule ID 8104 //
     /*  265487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  265501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  265504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265526 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265543 */     GIR_RootConstrainSelectedInstOperands,
     /*  265544 */     // GIR_Coverage, 8104,
     /*  265544 */     GIR_EraseRootFromParent_Done,
     /*  265545 */   // Label 5070: @265545
     /*  265545 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(265608), // Rule ID 8105 //
     /*  265550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  265564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  265567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265589 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265606 */     GIR_RootConstrainSelectedInstOperands,
     /*  265607 */     // GIR_Coverage, 8105,
     /*  265607 */     GIR_EraseRootFromParent_Done,
     /*  265608 */   // Label 5071: @265608
     /*  265608 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(265671), // Rule ID 8108 //
     /*  265613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  265627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  265630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265652 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  265652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265669 */     GIR_RootConstrainSelectedInstOperands,
     /*  265670 */     // GIR_Coverage, 8108,
     /*  265670 */     GIR_EraseRootFromParent_Done,
     /*  265671 */   // Label 5072: @265671
     /*  265671 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(265734), // Rule ID 8109 //
     /*  265676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  265690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  265693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265715 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  265715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265732 */     GIR_RootConstrainSelectedInstOperands,
     /*  265733 */     // GIR_Coverage, 8109,
     /*  265733 */     GIR_EraseRootFromParent_Done,
     /*  265734 */   // Label 5073: @265734
     /*  265734 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(265797), // Rule ID 8112 //
     /*  265739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  265742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  265753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  265756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265778 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  265778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265795 */     GIR_RootConstrainSelectedInstOperands,
     /*  265796 */     // GIR_Coverage, 8112,
     /*  265796 */     GIR_EraseRootFromParent_Done,
     /*  265797 */   // Label 5074: @265797
     /*  265797 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(265860), // Rule ID 8113 //
     /*  265802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  265805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  265816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  265819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265841 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  265841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265858 */     GIR_RootConstrainSelectedInstOperands,
     /*  265859 */     // GIR_Coverage, 8113,
     /*  265859 */     GIR_EraseRootFromParent_Done,
     /*  265860 */   // Label 5075: @265860
     /*  265860 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(265923), // Rule ID 8116 //
     /*  265865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  265879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  265882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265904 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265921 */     GIR_RootConstrainSelectedInstOperands,
     /*  265922 */     // GIR_Coverage, 8116,
     /*  265922 */     GIR_EraseRootFromParent_Done,
     /*  265923 */   // Label 5076: @265923
     /*  265923 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(265986), // Rule ID 8117 //
     /*  265928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  265942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  265945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265967 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265984 */     GIR_RootConstrainSelectedInstOperands,
     /*  265985 */     // GIR_Coverage, 8117,
     /*  265985 */     GIR_EraseRootFromParent_Done,
     /*  265986 */   // Label 5077: @265986
     /*  265986 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(266049), // Rule ID 8120 //
     /*  265991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  266005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  266008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266030 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266047 */     GIR_RootConstrainSelectedInstOperands,
     /*  266048 */     // GIR_Coverage, 8120,
     /*  266048 */     GIR_EraseRootFromParent_Done,
     /*  266049 */   // Label 5078: @266049
     /*  266049 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(266112), // Rule ID 8121 //
     /*  266054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  266068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  266071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266093 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266110 */     GIR_RootConstrainSelectedInstOperands,
     /*  266111 */     // GIR_Coverage, 8121,
     /*  266111 */     GIR_EraseRootFromParent_Done,
     /*  266112 */   // Label 5079: @266112
     /*  266112 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(266175), // Rule ID 8124 //
     /*  266117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  266128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  266131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  266134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266156 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266173 */     GIR_RootConstrainSelectedInstOperands,
     /*  266174 */     // GIR_Coverage, 8124,
     /*  266174 */     GIR_EraseRootFromParent_Done,
     /*  266175 */   // Label 5080: @266175
     /*  266175 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(266238), // Rule ID 8125 //
     /*  266180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  266191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  266194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  266197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266219 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266236 */     GIR_RootConstrainSelectedInstOperands,
     /*  266237 */     // GIR_Coverage, 8125,
     /*  266237 */     GIR_EraseRootFromParent_Done,
     /*  266238 */   // Label 5081: @266238
     /*  266238 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(266301), // Rule ID 8128 //
     /*  266243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  266257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  266260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266282 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266299 */     GIR_RootConstrainSelectedInstOperands,
     /*  266300 */     // GIR_Coverage, 8128,
     /*  266300 */     GIR_EraseRootFromParent_Done,
     /*  266301 */   // Label 5082: @266301
     /*  266301 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(266364), // Rule ID 8129 //
     /*  266306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  266320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  266323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266345 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266362 */     GIR_RootConstrainSelectedInstOperands,
     /*  266363 */     // GIR_Coverage, 8129,
     /*  266363 */     GIR_EraseRootFromParent_Done,
     /*  266364 */   // Label 5083: @266364
     /*  266364 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(266427), // Rule ID 8132 //
     /*  266369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  266383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  266386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266408 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266425 */     GIR_RootConstrainSelectedInstOperands,
     /*  266426 */     // GIR_Coverage, 8132,
     /*  266426 */     GIR_EraseRootFromParent_Done,
     /*  266427 */   // Label 5084: @266427
     /*  266427 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(266490), // Rule ID 8133 //
     /*  266432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  266446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  266449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266471 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266488 */     GIR_RootConstrainSelectedInstOperands,
     /*  266489 */     // GIR_Coverage, 8133,
     /*  266489 */     GIR_EraseRootFromParent_Done,
     /*  266490 */   // Label 5085: @266490
     /*  266490 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(266553), // Rule ID 8136 //
     /*  266495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  266509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  266512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266534 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266551 */     GIR_RootConstrainSelectedInstOperands,
     /*  266552 */     // GIR_Coverage, 8136,
     /*  266552 */     GIR_EraseRootFromParent_Done,
     /*  266553 */   // Label 5086: @266553
     /*  266553 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(266616), // Rule ID 8137 //
     /*  266558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  266572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  266575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266597 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266614 */     GIR_RootConstrainSelectedInstOperands,
     /*  266615 */     // GIR_Coverage, 8137,
     /*  266615 */     GIR_EraseRootFromParent_Done,
     /*  266616 */   // Label 5087: @266616
     /*  266616 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(266679), // Rule ID 8140 //
     /*  266621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  266635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  266638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266660 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266677 */     GIR_RootConstrainSelectedInstOperands,
     /*  266678 */     // GIR_Coverage, 8140,
     /*  266678 */     GIR_EraseRootFromParent_Done,
     /*  266679 */   // Label 5088: @266679
     /*  266679 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(266742), // Rule ID 8141 //
     /*  266684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  266698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  266701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266723 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266740 */     GIR_RootConstrainSelectedInstOperands,
     /*  266741 */     // GIR_Coverage, 8141,
     /*  266741 */     GIR_EraseRootFromParent_Done,
     /*  266742 */   // Label 5089: @266742
     /*  266742 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(266805), // Rule ID 8144 //
     /*  266747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  266761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  266764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266786 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266803 */     GIR_RootConstrainSelectedInstOperands,
     /*  266804 */     // GIR_Coverage, 8144,
     /*  266804 */     GIR_EraseRootFromParent_Done,
     /*  266805 */   // Label 5090: @266805
     /*  266805 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(266868), // Rule ID 8145 //
     /*  266810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  266824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  266827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266849 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266866 */     GIR_RootConstrainSelectedInstOperands,
     /*  266867 */     // GIR_Coverage, 8145,
     /*  266867 */     GIR_EraseRootFromParent_Done,
     /*  266868 */   // Label 5091: @266868
     /*  266868 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(266931), // Rule ID 8148 //
     /*  266873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  266887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  266890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266912 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266929 */     GIR_RootConstrainSelectedInstOperands,
     /*  266930 */     // GIR_Coverage, 8148,
     /*  266930 */     GIR_EraseRootFromParent_Done,
     /*  266931 */   // Label 5092: @266931
     /*  266931 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(266994), // Rule ID 8149 //
     /*  266936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  266950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  266953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266975 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266992 */     GIR_RootConstrainSelectedInstOperands,
     /*  266993 */     // GIR_Coverage, 8149,
     /*  266993 */     GIR_EraseRootFromParent_Done,
     /*  266994 */   // Label 5093: @266994
     /*  266994 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(267057), // Rule ID 8152 //
     /*  266999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  267002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  267013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  267016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267038 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  267041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267055 */     GIR_RootConstrainSelectedInstOperands,
     /*  267056 */     // GIR_Coverage, 8152,
     /*  267056 */     GIR_EraseRootFromParent_Done,
     /*  267057 */   // Label 5094: @267057
     /*  267057 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(267120), // Rule ID 8153 //
     /*  267062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  267076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  267079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267101 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  267104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267118 */     GIR_RootConstrainSelectedInstOperands,
     /*  267119 */     // GIR_Coverage, 8153,
     /*  267119 */     GIR_EraseRootFromParent_Done,
     /*  267120 */   // Label 5095: @267120
     /*  267120 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(267183), // Rule ID 8156 //
     /*  267125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  267128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  267139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  267142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267164 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  267167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267181 */     GIR_RootConstrainSelectedInstOperands,
     /*  267182 */     // GIR_Coverage, 8156,
     /*  267182 */     GIR_EraseRootFromParent_Done,
     /*  267183 */   // Label 5096: @267183
     /*  267183 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(267246), // Rule ID 8157 //
     /*  267188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  267202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  267205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267227 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  267230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267244 */     GIR_RootConstrainSelectedInstOperands,
     /*  267245 */     // GIR_Coverage, 8157,
     /*  267245 */     GIR_EraseRootFromParent_Done,
     /*  267246 */   // Label 5097: @267246
     /*  267246 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(267309), // Rule ID 8160 //
     /*  267251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  267254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  267265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  267268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267290 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  267293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267307 */     GIR_RootConstrainSelectedInstOperands,
     /*  267308 */     // GIR_Coverage, 8160,
     /*  267308 */     GIR_EraseRootFromParent_Done,
     /*  267309 */   // Label 5098: @267309
     /*  267309 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(267372), // Rule ID 8161 //
     /*  267314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  267328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  267331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267353 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  267356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267370 */     GIR_RootConstrainSelectedInstOperands,
     /*  267371 */     // GIR_Coverage, 8161,
     /*  267371 */     GIR_EraseRootFromParent_Done,
     /*  267372 */   // Label 5099: @267372
     /*  267372 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(267435), // Rule ID 8164 //
     /*  267377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  267391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267416 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  267419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267433 */     GIR_RootConstrainSelectedInstOperands,
     /*  267434 */     // GIR_Coverage, 8164,
     /*  267434 */     GIR_EraseRootFromParent_Done,
     /*  267435 */   // Label 5100: @267435
     /*  267435 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(267498), // Rule ID 8165 //
     /*  267440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  267454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267479 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  267482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267496 */     GIR_RootConstrainSelectedInstOperands,
     /*  267497 */     // GIR_Coverage, 8165,
     /*  267497 */     GIR_EraseRootFromParent_Done,
     /*  267498 */   // Label 5101: @267498
     /*  267498 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(267561), // Rule ID 8168 //
     /*  267503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  267517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267542 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267559 */     GIR_RootConstrainSelectedInstOperands,
     /*  267560 */     // GIR_Coverage, 8168,
     /*  267560 */     GIR_EraseRootFromParent_Done,
     /*  267561 */   // Label 5102: @267561
     /*  267561 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(267624), // Rule ID 8169 //
     /*  267566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  267580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267605 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267622 */     GIR_RootConstrainSelectedInstOperands,
     /*  267623 */     // GIR_Coverage, 8169,
     /*  267623 */     GIR_EraseRootFromParent_Done,
     /*  267624 */   // Label 5103: @267624
     /*  267624 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(267687), // Rule ID 8172 //
     /*  267629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  267643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267685 */     GIR_RootConstrainSelectedInstOperands,
     /*  267686 */     // GIR_Coverage, 8172,
     /*  267686 */     GIR_EraseRootFromParent_Done,
     /*  267687 */   // Label 5104: @267687
     /*  267687 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(267750), // Rule ID 8173 //
     /*  267692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  267706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267731 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267748 */     GIR_RootConstrainSelectedInstOperands,
     /*  267749 */     // GIR_Coverage, 8173,
     /*  267749 */     GIR_EraseRootFromParent_Done,
     /*  267750 */   // Label 5105: @267750
     /*  267750 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(267813), // Rule ID 8176 //
     /*  267755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  267769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267794 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267811 */     GIR_RootConstrainSelectedInstOperands,
     /*  267812 */     // GIR_Coverage, 8176,
     /*  267812 */     GIR_EraseRootFromParent_Done,
     /*  267813 */   // Label 5106: @267813
     /*  267813 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(267876), // Rule ID 8177 //
     /*  267818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  267832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267857 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267874 */     GIR_RootConstrainSelectedInstOperands,
     /*  267875 */     // GIR_Coverage, 8177,
     /*  267875 */     GIR_EraseRootFromParent_Done,
     /*  267876 */   // Label 5107: @267876
     /*  267876 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(267939), // Rule ID 8180 //
     /*  267881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  267895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267920 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267937 */     GIR_RootConstrainSelectedInstOperands,
     /*  267938 */     // GIR_Coverage, 8180,
     /*  267938 */     GIR_EraseRootFromParent_Done,
     /*  267939 */   // Label 5108: @267939
     /*  267939 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(268002), // Rule ID 8181 //
     /*  267944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  267958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267983 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268000 */     GIR_RootConstrainSelectedInstOperands,
     /*  268001 */     // GIR_Coverage, 8181,
     /*  268001 */     GIR_EraseRootFromParent_Done,
     /*  268002 */   // Label 5109: @268002
     /*  268002 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(268065), // Rule ID 8184 //
     /*  268007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  268021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268046 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  268046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  268049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268063 */     GIR_RootConstrainSelectedInstOperands,
     /*  268064 */     // GIR_Coverage, 8184,
     /*  268064 */     GIR_EraseRootFromParent_Done,
     /*  268065 */   // Label 5110: @268065
     /*  268065 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(268128), // Rule ID 8185 //
     /*  268070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  268084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268109 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  268109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  268112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268126 */     GIR_RootConstrainSelectedInstOperands,
     /*  268127 */     // GIR_Coverage, 8185,
     /*  268127 */     GIR_EraseRootFromParent_Done,
     /*  268128 */   // Label 5111: @268128
     /*  268128 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(268191), // Rule ID 8188 //
     /*  268133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  268147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268172 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268189 */     GIR_RootConstrainSelectedInstOperands,
     /*  268190 */     // GIR_Coverage, 8188,
     /*  268190 */     GIR_EraseRootFromParent_Done,
     /*  268191 */   // Label 5112: @268191
     /*  268191 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(268254), // Rule ID 8189 //
     /*  268196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  268210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268235 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268252 */     GIR_RootConstrainSelectedInstOperands,
     /*  268253 */     // GIR_Coverage, 8189,
     /*  268253 */     GIR_EraseRootFromParent_Done,
     /*  268254 */   // Label 5113: @268254
     /*  268254 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(268317), // Rule ID 8192 //
     /*  268259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  268273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268298 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268315 */     GIR_RootConstrainSelectedInstOperands,
     /*  268316 */     // GIR_Coverage, 8192,
     /*  268316 */     GIR_EraseRootFromParent_Done,
     /*  268317 */   // Label 5114: @268317
     /*  268317 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(268380), // Rule ID 8193 //
     /*  268322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  268336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268361 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268378 */     GIR_RootConstrainSelectedInstOperands,
     /*  268379 */     // GIR_Coverage, 8193,
     /*  268379 */     GIR_EraseRootFromParent_Done,
     /*  268380 */   // Label 5115: @268380
     /*  268380 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(268443), // Rule ID 8196 //
     /*  268385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  268399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268424 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  268424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268441 */     GIR_RootConstrainSelectedInstOperands,
     /*  268442 */     // GIR_Coverage, 8196,
     /*  268442 */     GIR_EraseRootFromParent_Done,
     /*  268443 */   // Label 5116: @268443
     /*  268443 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(268506), // Rule ID 8197 //
     /*  268448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  268462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268487 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  268487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268504 */     GIR_RootConstrainSelectedInstOperands,
     /*  268505 */     // GIR_Coverage, 8197,
     /*  268505 */     GIR_EraseRootFromParent_Done,
     /*  268506 */   // Label 5117: @268506
     /*  268506 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(268569), // Rule ID 8200 //
     /*  268511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  268514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  268525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268550 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  268550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  268567 */     GIR_RootConstrainSelectedInstOperands,
     /*  268568 */     // GIR_Coverage, 8200,
     /*  268568 */     GIR_EraseRootFromParent_Done,
     /*  268569 */   // Label 5118: @268569
     /*  268569 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(268632), // Rule ID 8201 //
     /*  268574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  268577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  268588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268613 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  268613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  268630 */     GIR_RootConstrainSelectedInstOperands,
     /*  268631 */     // GIR_Coverage, 8201,
     /*  268631 */     GIR_EraseRootFromParent_Done,
     /*  268632 */   // Label 5119: @268632
     /*  268632 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(268695), // Rule ID 8204 //
     /*  268637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  268651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268676 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268693 */     GIR_RootConstrainSelectedInstOperands,
     /*  268694 */     // GIR_Coverage, 8204,
     /*  268694 */     GIR_EraseRootFromParent_Done,
     /*  268695 */   // Label 5120: @268695
     /*  268695 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(268758), // Rule ID 8205 //
     /*  268700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  268714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268739 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268756 */     GIR_RootConstrainSelectedInstOperands,
     /*  268757 */     // GIR_Coverage, 8205,
     /*  268757 */     GIR_EraseRootFromParent_Done,
     /*  268758 */   // Label 5121: @268758
     /*  268758 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(268821), // Rule ID 8208 //
     /*  268763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  268777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268802 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268819 */     GIR_RootConstrainSelectedInstOperands,
     /*  268820 */     // GIR_Coverage, 8208,
     /*  268820 */     GIR_EraseRootFromParent_Done,
     /*  268821 */   // Label 5122: @268821
     /*  268821 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(268884), // Rule ID 8209 //
     /*  268826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  268840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268865 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268882 */     GIR_RootConstrainSelectedInstOperands,
     /*  268883 */     // GIR_Coverage, 8209,
     /*  268883 */     GIR_EraseRootFromParent_Done,
     /*  268884 */   // Label 5123: @268884
     /*  268884 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(268947), // Rule ID 8212 //
     /*  268889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  268900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  268903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268928 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268945 */     GIR_RootConstrainSelectedInstOperands,
     /*  268946 */     // GIR_Coverage, 8212,
     /*  268946 */     GIR_EraseRootFromParent_Done,
     /*  268947 */   // Label 5124: @268947
     /*  268947 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(269010), // Rule ID 8213 //
     /*  268952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  268963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  268966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268991 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269008 */     GIR_RootConstrainSelectedInstOperands,
     /*  269009 */     // GIR_Coverage, 8213,
     /*  269009 */     GIR_EraseRootFromParent_Done,
     /*  269010 */   // Label 5125: @269010
     /*  269010 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(269073), // Rule ID 8216 //
     /*  269015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  269029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269054 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269071 */     GIR_RootConstrainSelectedInstOperands,
     /*  269072 */     // GIR_Coverage, 8216,
     /*  269072 */     GIR_EraseRootFromParent_Done,
     /*  269073 */   // Label 5126: @269073
     /*  269073 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(269136), // Rule ID 8217 //
     /*  269078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  269092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269117 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269134 */     GIR_RootConstrainSelectedInstOperands,
     /*  269135 */     // GIR_Coverage, 8217,
     /*  269135 */     GIR_EraseRootFromParent_Done,
     /*  269136 */   // Label 5127: @269136
     /*  269136 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(269199), // Rule ID 8220 //
     /*  269141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  269155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269180 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269197 */     GIR_RootConstrainSelectedInstOperands,
     /*  269198 */     // GIR_Coverage, 8220,
     /*  269198 */     GIR_EraseRootFromParent_Done,
     /*  269199 */   // Label 5128: @269199
     /*  269199 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(269262), // Rule ID 8221 //
     /*  269204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  269218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269243 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269260 */     GIR_RootConstrainSelectedInstOperands,
     /*  269261 */     // GIR_Coverage, 8221,
     /*  269261 */     GIR_EraseRootFromParent_Done,
     /*  269262 */   // Label 5129: @269262
     /*  269262 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(269325), // Rule ID 8224 //
     /*  269267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  269278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  269281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269306 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269323 */     GIR_RootConstrainSelectedInstOperands,
     /*  269324 */     // GIR_Coverage, 8224,
     /*  269324 */     GIR_EraseRootFromParent_Done,
     /*  269325 */   // Label 5130: @269325
     /*  269325 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(269388), // Rule ID 8225 //
     /*  269330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  269341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  269344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269369 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269386 */     GIR_RootConstrainSelectedInstOperands,
     /*  269387 */     // GIR_Coverage, 8225,
     /*  269387 */     GIR_EraseRootFromParent_Done,
     /*  269388 */   // Label 5131: @269388
     /*  269388 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(269451), // Rule ID 8228 //
     /*  269393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  269407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269432 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269449 */     GIR_RootConstrainSelectedInstOperands,
     /*  269450 */     // GIR_Coverage, 8228,
     /*  269450 */     GIR_EraseRootFromParent_Done,
     /*  269451 */   // Label 5132: @269451
     /*  269451 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(269514), // Rule ID 8229 //
     /*  269456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  269470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269495 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269512 */     GIR_RootConstrainSelectedInstOperands,
     /*  269513 */     // GIR_Coverage, 8229,
     /*  269513 */     GIR_EraseRootFromParent_Done,
     /*  269514 */   // Label 5133: @269514
     /*  269514 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(269577), // Rule ID 8232 //
     /*  269519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  269533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269558 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269575 */     GIR_RootConstrainSelectedInstOperands,
     /*  269576 */     // GIR_Coverage, 8232,
     /*  269576 */     GIR_EraseRootFromParent_Done,
     /*  269577 */   // Label 5134: @269577
     /*  269577 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(269640), // Rule ID 8233 //
     /*  269582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  269596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269621 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269638 */     GIR_RootConstrainSelectedInstOperands,
     /*  269639 */     // GIR_Coverage, 8233,
     /*  269639 */     GIR_EraseRootFromParent_Done,
     /*  269640 */   // Label 5135: @269640
     /*  269640 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(269703), // Rule ID 8236 //
     /*  269645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  269659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269684 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269701 */     GIR_RootConstrainSelectedInstOperands,
     /*  269702 */     // GIR_Coverage, 8236,
     /*  269702 */     GIR_EraseRootFromParent_Done,
     /*  269703 */   // Label 5136: @269703
     /*  269703 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(269766), // Rule ID 8237 //
     /*  269708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  269722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269747 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269764 */     GIR_RootConstrainSelectedInstOperands,
     /*  269765 */     // GIR_Coverage, 8237,
     /*  269765 */     GIR_EraseRootFromParent_Done,
     /*  269766 */   // Label 5137: @269766
     /*  269766 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(269829), // Rule ID 8240 //
     /*  269771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  269785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269810 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269827 */     GIR_RootConstrainSelectedInstOperands,
     /*  269828 */     // GIR_Coverage, 8240,
     /*  269828 */     GIR_EraseRootFromParent_Done,
     /*  269829 */   // Label 5138: @269829
     /*  269829 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(269892), // Rule ID 8241 //
     /*  269834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  269848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269873 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269890 */     GIR_RootConstrainSelectedInstOperands,
     /*  269891 */     // GIR_Coverage, 8241,
     /*  269891 */     GIR_EraseRootFromParent_Done,
     /*  269892 */   // Label 5139: @269892
     /*  269892 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(269955), // Rule ID 8244 //
     /*  269897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  269911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269936 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269953 */     GIR_RootConstrainSelectedInstOperands,
     /*  269954 */     // GIR_Coverage, 8244,
     /*  269954 */     GIR_EraseRootFromParent_Done,
     /*  269955 */   // Label 5140: @269955
     /*  269955 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(270018), // Rule ID 8245 //
     /*  269960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  269974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269999 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  270002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270016 */     GIR_RootConstrainSelectedInstOperands,
     /*  270017 */     // GIR_Coverage, 8245,
     /*  270017 */     GIR_EraseRootFromParent_Done,
     /*  270018 */   // Label 5141: @270018
     /*  270018 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(270081), // Rule ID 8248 //
     /*  270023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  270026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  270037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  270040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270062 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  270062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  270065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270079 */     GIR_RootConstrainSelectedInstOperands,
     /*  270080 */     // GIR_Coverage, 8248,
     /*  270080 */     GIR_EraseRootFromParent_Done,
     /*  270081 */   // Label 5142: @270081
     /*  270081 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(270144), // Rule ID 8249 //
     /*  270086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  270089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  270100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  270103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270125 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  270125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  270128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270142 */     GIR_RootConstrainSelectedInstOperands,
     /*  270143 */     // GIR_Coverage, 8249,
     /*  270143 */     GIR_EraseRootFromParent_Done,
     /*  270144 */   // Label 5143: @270144
     /*  270144 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(270207), // Rule ID 8340 //
     /*  270149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  270163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  270166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270188 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  270191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270205 */     GIR_RootConstrainSelectedInstOperands,
     /*  270206 */     // GIR_Coverage, 8340,
     /*  270206 */     GIR_EraseRootFromParent_Done,
     /*  270207 */   // Label 5144: @270207
     /*  270207 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(270270), // Rule ID 8341 //
     /*  270212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  270226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  270229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270251 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  270254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270268 */     GIR_RootConstrainSelectedInstOperands,
     /*  270269 */     // GIR_Coverage, 8341,
     /*  270269 */     GIR_EraseRootFromParent_Done,
     /*  270270 */   // Label 5145: @270270
     /*  270270 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(270333), // Rule ID 8344 //
     /*  270275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  270289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  270292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270314 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  270317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270331 */     GIR_RootConstrainSelectedInstOperands,
     /*  270332 */     // GIR_Coverage, 8344,
     /*  270332 */     GIR_EraseRootFromParent_Done,
     /*  270333 */   // Label 5146: @270333
     /*  270333 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(270396), // Rule ID 8345 //
     /*  270338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  270352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  270355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270377 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  270380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270394 */     GIR_RootConstrainSelectedInstOperands,
     /*  270395 */     // GIR_Coverage, 8345,
     /*  270395 */     GIR_EraseRootFromParent_Done,
     /*  270396 */   // Label 5147: @270396
     /*  270396 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(270459), // Rule ID 8348 //
     /*  270401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  270415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  270418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270440 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270457 */     GIR_RootConstrainSelectedInstOperands,
     /*  270458 */     // GIR_Coverage, 8348,
     /*  270458 */     GIR_EraseRootFromParent_Done,
     /*  270459 */   // Label 5148: @270459
     /*  270459 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(270522), // Rule ID 8349 //
     /*  270464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  270478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  270481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270503 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270520 */     GIR_RootConstrainSelectedInstOperands,
     /*  270521 */     // GIR_Coverage, 8349,
     /*  270521 */     GIR_EraseRootFromParent_Done,
     /*  270522 */   // Label 5149: @270522
     /*  270522 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(270585), // Rule ID 8352 //
     /*  270527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  270541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  270544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270566 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  270569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270583 */     GIR_RootConstrainSelectedInstOperands,
     /*  270584 */     // GIR_Coverage, 8352,
     /*  270584 */     GIR_EraseRootFromParent_Done,
     /*  270585 */   // Label 5150: @270585
     /*  270585 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(270648), // Rule ID 8353 //
     /*  270590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  270604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  270607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270629 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  270629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  270632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270646 */     GIR_RootConstrainSelectedInstOperands,
     /*  270647 */     // GIR_Coverage, 8353,
     /*  270647 */     GIR_EraseRootFromParent_Done,
     /*  270648 */   // Label 5151: @270648
     /*  270648 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(270711), // Rule ID 8356 //
     /*  270653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  270667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  270670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270709 */     GIR_RootConstrainSelectedInstOperands,
     /*  270710 */     // GIR_Coverage, 8356,
     /*  270710 */     GIR_EraseRootFromParent_Done,
     /*  270711 */   // Label 5152: @270711
     /*  270711 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(270774), // Rule ID 8357 //
     /*  270716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  270730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  270733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270755 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  270755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270772 */     GIR_RootConstrainSelectedInstOperands,
     /*  270773 */     // GIR_Coverage, 8357,
     /*  270773 */     GIR_EraseRootFromParent_Done,
     /*  270774 */   // Label 5153: @270774
     /*  270774 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(270837), // Rule ID 8360 //
     /*  270779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  270793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  270796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270818 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270835 */     GIR_RootConstrainSelectedInstOperands,
     /*  270836 */     // GIR_Coverage, 8360,
     /*  270836 */     GIR_EraseRootFromParent_Done,
     /*  270837 */   // Label 5154: @270837
     /*  270837 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(270900), // Rule ID 8361 //
     /*  270842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  270856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  270859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270881 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270898 */     GIR_RootConstrainSelectedInstOperands,
     /*  270899 */     // GIR_Coverage, 8361,
     /*  270899 */     GIR_EraseRootFromParent_Done,
     /*  270900 */   // Label 5155: @270900
     /*  270900 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(270963), // Rule ID 8364 //
     /*  270905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  270919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  270922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270944 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270961 */     GIR_RootConstrainSelectedInstOperands,
     /*  270962 */     // GIR_Coverage, 8364,
     /*  270962 */     GIR_EraseRootFromParent_Done,
     /*  270963 */   // Label 5156: @270963
     /*  270963 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(271026), // Rule ID 8365 //
     /*  270968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  270982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  270985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271007 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271024 */     GIR_RootConstrainSelectedInstOperands,
     /*  271025 */     // GIR_Coverage, 8365,
     /*  271025 */     GIR_EraseRootFromParent_Done,
     /*  271026 */   // Label 5157: @271026
     /*  271026 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(271089), // Rule ID 8368 //
     /*  271031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  271045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  271048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271070 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271087 */     GIR_RootConstrainSelectedInstOperands,
     /*  271088 */     // GIR_Coverage, 8368,
     /*  271088 */     GIR_EraseRootFromParent_Done,
     /*  271089 */   // Label 5158: @271089
     /*  271089 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(271152), // Rule ID 8369 //
     /*  271094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  271108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  271111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271133 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271150 */     GIR_RootConstrainSelectedInstOperands,
     /*  271151 */     // GIR_Coverage, 8369,
     /*  271151 */     GIR_EraseRootFromParent_Done,
     /*  271152 */   // Label 5159: @271152
     /*  271152 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(271215), // Rule ID 8372 //
     /*  271157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  271171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  271174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271196 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271213 */     GIR_RootConstrainSelectedInstOperands,
     /*  271214 */     // GIR_Coverage, 8372,
     /*  271214 */     GIR_EraseRootFromParent_Done,
     /*  271215 */   // Label 5160: @271215
     /*  271215 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(271278), // Rule ID 8373 //
     /*  271220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  271234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  271237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271259 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271276 */     GIR_RootConstrainSelectedInstOperands,
     /*  271277 */     // GIR_Coverage, 8373,
     /*  271277 */     GIR_EraseRootFromParent_Done,
     /*  271278 */   // Label 5161: @271278
     /*  271278 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(271341), // Rule ID 8376 //
     /*  271283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  271286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  271297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  271300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271322 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  271322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271339 */     GIR_RootConstrainSelectedInstOperands,
     /*  271340 */     // GIR_Coverage, 8376,
     /*  271340 */     GIR_EraseRootFromParent_Done,
     /*  271341 */   // Label 5162: @271341
     /*  271341 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(271404), // Rule ID 8377 //
     /*  271346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  271349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  271360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  271363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271385 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  271385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271402 */     GIR_RootConstrainSelectedInstOperands,
     /*  271403 */     // GIR_Coverage, 8377,
     /*  271403 */     GIR_EraseRootFromParent_Done,
     /*  271404 */   // Label 5163: @271404
     /*  271404 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(271467), // Rule ID 8380 //
     /*  271409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  271423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  271426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271448 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271465 */     GIR_RootConstrainSelectedInstOperands,
     /*  271466 */     // GIR_Coverage, 8380,
     /*  271466 */     GIR_EraseRootFromParent_Done,
     /*  271467 */   // Label 5164: @271467
     /*  271467 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(271530), // Rule ID 8381 //
     /*  271472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  271486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  271489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271511 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271528 */     GIR_RootConstrainSelectedInstOperands,
     /*  271529 */     // GIR_Coverage, 8381,
     /*  271529 */     GIR_EraseRootFromParent_Done,
     /*  271530 */   // Label 5165: @271530
     /*  271530 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(271593), // Rule ID 8384 //
     /*  271535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  271549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  271552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271574 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271591 */     GIR_RootConstrainSelectedInstOperands,
     /*  271592 */     // GIR_Coverage, 8384,
     /*  271592 */     GIR_EraseRootFromParent_Done,
     /*  271593 */   // Label 5166: @271593
     /*  271593 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(271656), // Rule ID 8385 //
     /*  271598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  271612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  271615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271637 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271654 */     GIR_RootConstrainSelectedInstOperands,
     /*  271655 */     // GIR_Coverage, 8385,
     /*  271655 */     GIR_EraseRootFromParent_Done,
     /*  271656 */   // Label 5167: @271656
     /*  271656 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(271719), // Rule ID 8388 //
     /*  271661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  271672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  271675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  271678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271700 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271717 */     GIR_RootConstrainSelectedInstOperands,
     /*  271718 */     // GIR_Coverage, 8388,
     /*  271718 */     GIR_EraseRootFromParent_Done,
     /*  271719 */   // Label 5168: @271719
     /*  271719 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(271782), // Rule ID 8389 //
     /*  271724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  271735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  271738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  271741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271763 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271780 */     GIR_RootConstrainSelectedInstOperands,
     /*  271781 */     // GIR_Coverage, 8389,
     /*  271781 */     GIR_EraseRootFromParent_Done,
     /*  271782 */   // Label 5169: @271782
     /*  271782 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(271845), // Rule ID 8392 //
     /*  271787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  271801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  271804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271826 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271843 */     GIR_RootConstrainSelectedInstOperands,
     /*  271844 */     // GIR_Coverage, 8392,
     /*  271844 */     GIR_EraseRootFromParent_Done,
     /*  271845 */   // Label 5170: @271845
     /*  271845 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(271908), // Rule ID 8393 //
     /*  271850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  271864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  271867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271889 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271906 */     GIR_RootConstrainSelectedInstOperands,
     /*  271907 */     // GIR_Coverage, 8393,
     /*  271907 */     GIR_EraseRootFromParent_Done,
     /*  271908 */   // Label 5171: @271908
     /*  271908 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(271971), // Rule ID 8396 //
     /*  271913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  271927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  271930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271952 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271969 */     GIR_RootConstrainSelectedInstOperands,
     /*  271970 */     // GIR_Coverage, 8396,
     /*  271970 */     GIR_EraseRootFromParent_Done,
     /*  271971 */   // Label 5172: @271971
     /*  271971 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(272034), // Rule ID 8397 //
     /*  271976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  271990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  271993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272015 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272032 */     GIR_RootConstrainSelectedInstOperands,
     /*  272033 */     // GIR_Coverage, 8397,
     /*  272033 */     GIR_EraseRootFromParent_Done,
     /*  272034 */   // Label 5173: @272034
     /*  272034 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(272097), // Rule ID 8400 //
     /*  272039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  272050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  272053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  272056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272078 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272095 */     GIR_RootConstrainSelectedInstOperands,
     /*  272096 */     // GIR_Coverage, 8400,
     /*  272096 */     GIR_EraseRootFromParent_Done,
     /*  272097 */   // Label 5174: @272097
     /*  272097 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(272160), // Rule ID 8401 //
     /*  272102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  272113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  272116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  272119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272141 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272158 */     GIR_RootConstrainSelectedInstOperands,
     /*  272159 */     // GIR_Coverage, 8401,
     /*  272159 */     GIR_EraseRootFromParent_Done,
     /*  272160 */   // Label 5175: @272160
     /*  272160 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(272223), // Rule ID 8404 //
     /*  272165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  272179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  272182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272204 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  272204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  272207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272221 */     GIR_RootConstrainSelectedInstOperands,
     /*  272222 */     // GIR_Coverage, 8404,
     /*  272222 */     GIR_EraseRootFromParent_Done,
     /*  272223 */   // Label 5176: @272223
     /*  272223 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(272286), // Rule ID 8405 //
     /*  272228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  272242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  272245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272267 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  272270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272284 */     GIR_RootConstrainSelectedInstOperands,
     /*  272285 */     // GIR_Coverage, 8405,
     /*  272285 */     GIR_EraseRootFromParent_Done,
     /*  272286 */   // Label 5177: @272286
     /*  272286 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(272349), // Rule ID 8408 //
     /*  272291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  272305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  272308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272330 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  272330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272347 */     GIR_RootConstrainSelectedInstOperands,
     /*  272348 */     // GIR_Coverage, 8408,
     /*  272348 */     GIR_EraseRootFromParent_Done,
     /*  272349 */   // Label 5178: @272349
     /*  272349 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(272412), // Rule ID 8409 //
     /*  272354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  272368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  272371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272393 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272410 */     GIR_RootConstrainSelectedInstOperands,
     /*  272411 */     // GIR_Coverage, 8409,
     /*  272411 */     GIR_EraseRootFromParent_Done,
     /*  272412 */   // Label 5179: @272412
     /*  272412 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(272475), // Rule ID 8412 //
     /*  272417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  272431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  272434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272456 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  272456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272473 */     GIR_RootConstrainSelectedInstOperands,
     /*  272474 */     // GIR_Coverage, 8412,
     /*  272474 */     GIR_EraseRootFromParent_Done,
     /*  272475 */   // Label 5180: @272475
     /*  272475 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(272538), // Rule ID 8413 //
     /*  272480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  272494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  272497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272519 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272536 */     GIR_RootConstrainSelectedInstOperands,
     /*  272537 */     // GIR_Coverage, 8413,
     /*  272537 */     GIR_EraseRootFromParent_Done,
     /*  272538 */   // Label 5181: @272538
     /*  272538 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(272601), // Rule ID 8416 //
     /*  272543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  272557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  272560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272582 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  272582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  272585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272599 */     GIR_RootConstrainSelectedInstOperands,
     /*  272600 */     // GIR_Coverage, 8416,
     /*  272600 */     GIR_EraseRootFromParent_Done,
     /*  272601 */   // Label 5182: @272601
     /*  272601 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(272664), // Rule ID 8417 //
     /*  272606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  272620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  272623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272645 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  272645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  272648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272662 */     GIR_RootConstrainSelectedInstOperands,
     /*  272663 */     // GIR_Coverage, 8417,
     /*  272663 */     GIR_EraseRootFromParent_Done,
     /*  272664 */   // Label 5183: @272664
     /*  272664 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(272727), // Rule ID 8420 //
     /*  272669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  272683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  272686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272708 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  272708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272725 */     GIR_RootConstrainSelectedInstOperands,
     /*  272726 */     // GIR_Coverage, 8420,
     /*  272726 */     GIR_EraseRootFromParent_Done,
     /*  272727 */   // Label 5184: @272727
     /*  272727 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(272790), // Rule ID 8421 //
     /*  272732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  272746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  272749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272771 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  272771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272788 */     GIR_RootConstrainSelectedInstOperands,
     /*  272789 */     // GIR_Coverage, 8421,
     /*  272789 */     GIR_EraseRootFromParent_Done,
     /*  272790 */   // Label 5185: @272790
     /*  272790 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(272853), // Rule ID 8424 //
     /*  272795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  272809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  272812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272834 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  272834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272851 */     GIR_RootConstrainSelectedInstOperands,
     /*  272852 */     // GIR_Coverage, 8424,
     /*  272852 */     GIR_EraseRootFromParent_Done,
     /*  272853 */   // Label 5186: @272853
     /*  272853 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(272916), // Rule ID 8425 //
     /*  272858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  272872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  272875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272897 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  272897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272914 */     GIR_RootConstrainSelectedInstOperands,
     /*  272915 */     // GIR_Coverage, 8425,
     /*  272915 */     GIR_EraseRootFromParent_Done,
     /*  272916 */   // Label 5187: @272916
     /*  272916 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(272979), // Rule ID 8428 //
     /*  272921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  272935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272960 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  272963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272977 */     GIR_RootConstrainSelectedInstOperands,
     /*  272978 */     // GIR_Coverage, 8428,
     /*  272978 */     GIR_EraseRootFromParent_Done,
     /*  272979 */   // Label 5188: @272979
     /*  272979 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(273042), // Rule ID 8429 //
     /*  272984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  272998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273023 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  273026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273040 */     GIR_RootConstrainSelectedInstOperands,
     /*  273041 */     // GIR_Coverage, 8429,
     /*  273041 */     GIR_EraseRootFromParent_Done,
     /*  273042 */   // Label 5189: @273042
     /*  273042 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(273105), // Rule ID 8432 //
     /*  273047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  273061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273086 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  273089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273103 */     GIR_RootConstrainSelectedInstOperands,
     /*  273104 */     // GIR_Coverage, 8432,
     /*  273104 */     GIR_EraseRootFromParent_Done,
     /*  273105 */   // Label 5190: @273105
     /*  273105 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(273168), // Rule ID 8433 //
     /*  273110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  273124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273149 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  273152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273166 */     GIR_RootConstrainSelectedInstOperands,
     /*  273167 */     // GIR_Coverage, 8433,
     /*  273167 */     GIR_EraseRootFromParent_Done,
     /*  273168 */   // Label 5191: @273168
     /*  273168 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(273231), // Rule ID 8436 //
     /*  273173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  273187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273212 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273229 */     GIR_RootConstrainSelectedInstOperands,
     /*  273230 */     // GIR_Coverage, 8436,
     /*  273230 */     GIR_EraseRootFromParent_Done,
     /*  273231 */   // Label 5192: @273231
     /*  273231 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(273294), // Rule ID 8437 //
     /*  273236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  273250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273275 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273292 */     GIR_RootConstrainSelectedInstOperands,
     /*  273293 */     // GIR_Coverage, 8437,
     /*  273293 */     GIR_EraseRootFromParent_Done,
     /*  273294 */   // Label 5193: @273294
     /*  273294 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(273357), // Rule ID 8440 //
     /*  273299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  273313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273338 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  273341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273355 */     GIR_RootConstrainSelectedInstOperands,
     /*  273356 */     // GIR_Coverage, 8440,
     /*  273356 */     GIR_EraseRootFromParent_Done,
     /*  273357 */   // Label 5194: @273357
     /*  273357 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(273420), // Rule ID 8441 //
     /*  273362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  273376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273401 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  273404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273418 */     GIR_RootConstrainSelectedInstOperands,
     /*  273419 */     // GIR_Coverage, 8441,
     /*  273419 */     GIR_EraseRootFromParent_Done,
     /*  273420 */   // Label 5195: @273420
     /*  273420 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(273483), // Rule ID 8444 //
     /*  273425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  273439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273464 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273481 */     GIR_RootConstrainSelectedInstOperands,
     /*  273482 */     // GIR_Coverage, 8444,
     /*  273482 */     GIR_EraseRootFromParent_Done,
     /*  273483 */   // Label 5196: @273483
     /*  273483 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(273546), // Rule ID 8445 //
     /*  273488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  273502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273527 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273544 */     GIR_RootConstrainSelectedInstOperands,
     /*  273545 */     // GIR_Coverage, 8445,
     /*  273545 */     GIR_EraseRootFromParent_Done,
     /*  273546 */   // Label 5197: @273546
     /*  273546 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(273609), // Rule ID 8448 //
     /*  273551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  273565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273590 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  273590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273607 */     GIR_RootConstrainSelectedInstOperands,
     /*  273608 */     // GIR_Coverage, 8448,
     /*  273608 */     GIR_EraseRootFromParent_Done,
     /*  273609 */   // Label 5198: @273609
     /*  273609 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(273672), // Rule ID 8449 //
     /*  273614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  273628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273653 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  273653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273670 */     GIR_RootConstrainSelectedInstOperands,
     /*  273671 */     // GIR_Coverage, 8449,
     /*  273671 */     GIR_EraseRootFromParent_Done,
     /*  273672 */   // Label 5199: @273672
     /*  273672 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(273735), // Rule ID 8452 //
     /*  273677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  273691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273716 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273733 */     GIR_RootConstrainSelectedInstOperands,
     /*  273734 */     // GIR_Coverage, 8452,
     /*  273734 */     GIR_EraseRootFromParent_Done,
     /*  273735 */   // Label 5200: @273735
     /*  273735 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(273798), // Rule ID 8453 //
     /*  273740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  273754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273779 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273796 */     GIR_RootConstrainSelectedInstOperands,
     /*  273797 */     // GIR_Coverage, 8453,
     /*  273797 */     GIR_EraseRootFromParent_Done,
     /*  273798 */   // Label 5201: @273798
     /*  273798 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(273861), // Rule ID 8456 //
     /*  273803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  273817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273842 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273859 */     GIR_RootConstrainSelectedInstOperands,
     /*  273860 */     // GIR_Coverage, 8456,
     /*  273860 */     GIR_EraseRootFromParent_Done,
     /*  273861 */   // Label 5202: @273861
     /*  273861 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(273924), // Rule ID 8457 //
     /*  273866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  273880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273905 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273922 */     GIR_RootConstrainSelectedInstOperands,
     /*  273923 */     // GIR_Coverage, 8457,
     /*  273923 */     GIR_EraseRootFromParent_Done,
     /*  273924 */   // Label 5203: @273924
     /*  273924 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(273987), // Rule ID 8460 //
     /*  273929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  273943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273968 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  273968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273985 */     GIR_RootConstrainSelectedInstOperands,
     /*  273986 */     // GIR_Coverage, 8460,
     /*  273986 */     GIR_EraseRootFromParent_Done,
     /*  273987 */   // Label 5204: @273987
     /*  273987 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(274050), // Rule ID 8461 //
     /*  273992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  274006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274031 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  274034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274048 */     GIR_RootConstrainSelectedInstOperands,
     /*  274049 */     // GIR_Coverage, 8461,
     /*  274049 */     GIR_EraseRootFromParent_Done,
     /*  274050 */   // Label 5205: @274050
     /*  274050 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(274113), // Rule ID 8464 //
     /*  274055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  274058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  274069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274094 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  274094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  274097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274111 */     GIR_RootConstrainSelectedInstOperands,
     /*  274112 */     // GIR_Coverage, 8464,
     /*  274112 */     GIR_EraseRootFromParent_Done,
     /*  274113 */   // Label 5206: @274113
     /*  274113 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(274176), // Rule ID 8465 //
     /*  274118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  274121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  274132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274157 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  274157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  274160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274174 */     GIR_RootConstrainSelectedInstOperands,
     /*  274175 */     // GIR_Coverage, 8465,
     /*  274175 */     GIR_EraseRootFromParent_Done,
     /*  274176 */   // Label 5207: @274176
     /*  274176 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(274239), // Rule ID 8468 //
     /*  274181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  274195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274220 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274237 */     GIR_RootConstrainSelectedInstOperands,
     /*  274238 */     // GIR_Coverage, 8468,
     /*  274238 */     GIR_EraseRootFromParent_Done,
     /*  274239 */   // Label 5208: @274239
     /*  274239 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(274302), // Rule ID 8469 //
     /*  274244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  274258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274283 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274300 */     GIR_RootConstrainSelectedInstOperands,
     /*  274301 */     // GIR_Coverage, 8469,
     /*  274301 */     GIR_EraseRootFromParent_Done,
     /*  274302 */   // Label 5209: @274302
     /*  274302 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(274365), // Rule ID 8472 //
     /*  274307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  274321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274346 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274363 */     GIR_RootConstrainSelectedInstOperands,
     /*  274364 */     // GIR_Coverage, 8472,
     /*  274364 */     GIR_EraseRootFromParent_Done,
     /*  274365 */   // Label 5210: @274365
     /*  274365 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(274428), // Rule ID 8473 //
     /*  274370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  274384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274409 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274426 */     GIR_RootConstrainSelectedInstOperands,
     /*  274427 */     // GIR_Coverage, 8473,
     /*  274427 */     GIR_EraseRootFromParent_Done,
     /*  274428 */   // Label 5211: @274428
     /*  274428 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(274491), // Rule ID 8476 //
     /*  274433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  274444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  274447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274472 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274489 */     GIR_RootConstrainSelectedInstOperands,
     /*  274490 */     // GIR_Coverage, 8476,
     /*  274490 */     GIR_EraseRootFromParent_Done,
     /*  274491 */   // Label 5212: @274491
     /*  274491 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(274554), // Rule ID 8477 //
     /*  274496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  274507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  274510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274535 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274552 */     GIR_RootConstrainSelectedInstOperands,
     /*  274553 */     // GIR_Coverage, 8477,
     /*  274553 */     GIR_EraseRootFromParent_Done,
     /*  274554 */   // Label 5213: @274554
     /*  274554 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(274617), // Rule ID 8480 //
     /*  274559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  274573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274598 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274615 */     GIR_RootConstrainSelectedInstOperands,
     /*  274616 */     // GIR_Coverage, 8480,
     /*  274616 */     GIR_EraseRootFromParent_Done,
     /*  274617 */   // Label 5214: @274617
     /*  274617 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(274680), // Rule ID 8481 //
     /*  274622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  274636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274661 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274678 */     GIR_RootConstrainSelectedInstOperands,
     /*  274679 */     // GIR_Coverage, 8481,
     /*  274679 */     GIR_EraseRootFromParent_Done,
     /*  274680 */   // Label 5215: @274680
     /*  274680 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(274743), // Rule ID 8484 //
     /*  274685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  274699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274724 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274741 */     GIR_RootConstrainSelectedInstOperands,
     /*  274742 */     // GIR_Coverage, 8484,
     /*  274742 */     GIR_EraseRootFromParent_Done,
     /*  274743 */   // Label 5216: @274743
     /*  274743 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(274806), // Rule ID 8485 //
     /*  274748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  274762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274787 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274804 */     GIR_RootConstrainSelectedInstOperands,
     /*  274805 */     // GIR_Coverage, 8485,
     /*  274805 */     GIR_EraseRootFromParent_Done,
     /*  274806 */   // Label 5217: @274806
     /*  274806 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(274869), // Rule ID 8488 //
     /*  274811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  274825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274850 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274867 */     GIR_RootConstrainSelectedInstOperands,
     /*  274868 */     // GIR_Coverage, 8488,
     /*  274868 */     GIR_EraseRootFromParent_Done,
     /*  274869 */   // Label 5218: @274869
     /*  274869 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(274932), // Rule ID 8489 //
     /*  274874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  274888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274913 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274930 */     GIR_RootConstrainSelectedInstOperands,
     /*  274931 */     // GIR_Coverage, 8489,
     /*  274931 */     GIR_EraseRootFromParent_Done,
     /*  274932 */   // Label 5219: @274932
     /*  274932 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(274995), // Rule ID 8492 //
     /*  274937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  274951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274976 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274993 */     GIR_RootConstrainSelectedInstOperands,
     /*  274994 */     // GIR_Coverage, 8492,
     /*  274994 */     GIR_EraseRootFromParent_Done,
     /*  274995 */   // Label 5220: @274995
     /*  274995 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(275058), // Rule ID 8493 //
     /*  275000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  275014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275039 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  275042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275056 */     GIR_RootConstrainSelectedInstOperands,
     /*  275057 */     // GIR_Coverage, 8493,
     /*  275057 */     GIR_EraseRootFromParent_Done,
     /*  275058 */   // Label 5221: @275058
     /*  275058 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(275121), // Rule ID 8496 //
     /*  275063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  275077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  275080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275102 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  275105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275119 */     GIR_RootConstrainSelectedInstOperands,
     /*  275120 */     // GIR_Coverage, 8496,
     /*  275120 */     GIR_EraseRootFromParent_Done,
     /*  275121 */   // Label 5222: @275121
     /*  275121 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(275184), // Rule ID 8497 //
     /*  275126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  275140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275165 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  275168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275182 */     GIR_RootConstrainSelectedInstOperands,
     /*  275183 */     // GIR_Coverage, 8497,
     /*  275183 */     GIR_EraseRootFromParent_Done,
     /*  275184 */   // Label 5223: @275184
     /*  275184 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(275247), // Rule ID 8500 //
     /*  275189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  275203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  275206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275228 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  275231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275245 */     GIR_RootConstrainSelectedInstOperands,
     /*  275246 */     // GIR_Coverage, 8500,
     /*  275246 */     GIR_EraseRootFromParent_Done,
     /*  275247 */   // Label 5224: @275247
     /*  275247 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(275310), // Rule ID 8501 //
     /*  275252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  275266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275291 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  275294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275308 */     GIR_RootConstrainSelectedInstOperands,
     /*  275309 */     // GIR_Coverage, 8501,
     /*  275309 */     GIR_EraseRootFromParent_Done,
     /*  275310 */   // Label 5225: @275310
     /*  275310 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(275373), // Rule ID 8504 //
     /*  275315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  275318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  275329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  275332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275354 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  275357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275371 */     GIR_RootConstrainSelectedInstOperands,
     /*  275372 */     // GIR_Coverage, 8504,
     /*  275372 */     GIR_EraseRootFromParent_Done,
     /*  275373 */   // Label 5226: @275373
     /*  275373 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(275436), // Rule ID 8505 //
     /*  275378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  275392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275417 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  275417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  275420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275434 */     GIR_RootConstrainSelectedInstOperands,
     /*  275435 */     // GIR_Coverage, 8505,
     /*  275435 */     GIR_EraseRootFromParent_Done,
     /*  275436 */   // Label 5227: @275436
     /*  275436 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(275499), // Rule ID 8508 //
     /*  275441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  275444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  275455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  275458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275480 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  275483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275497 */     GIR_RootConstrainSelectedInstOperands,
     /*  275498 */     // GIR_Coverage, 8508,
     /*  275498 */     GIR_EraseRootFromParent_Done,
     /*  275499 */   // Label 5228: @275499
     /*  275499 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(275562), // Rule ID 8509 //
     /*  275504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  275518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275543 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  275543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  275546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275560 */     GIR_RootConstrainSelectedInstOperands,
     /*  275561 */     // GIR_Coverage, 8509,
     /*  275561 */     GIR_EraseRootFromParent_Done,
     /*  275562 */   // Label 5229: @275562
     /*  275562 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(275625), // Rule ID 8512 //
     /*  275567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  275570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  275581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  275584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275606 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  275609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275623 */     GIR_RootConstrainSelectedInstOperands,
     /*  275624 */     // GIR_Coverage, 8512,
     /*  275624 */     GIR_EraseRootFromParent_Done,
     /*  275625 */   // Label 5230: @275625
     /*  275625 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(275688), // Rule ID 8513 //
     /*  275630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  275644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275669 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  275669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  275672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275686 */     GIR_RootConstrainSelectedInstOperands,
     /*  275687 */     // GIR_Coverage, 8513,
     /*  275687 */     GIR_EraseRootFromParent_Done,
     /*  275688 */   // Label 5231: @275688
     /*  275688 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(275751), // Rule ID 8516 //
     /*  275693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  275707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  275710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275732 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  275735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275749 */     GIR_RootConstrainSelectedInstOperands,
     /*  275750 */     // GIR_Coverage, 8516,
     /*  275750 */     GIR_EraseRootFromParent_Done,
     /*  275751 */   // Label 5232: @275751
     /*  275751 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(275814), // Rule ID 8517 //
     /*  275756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  275770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  275773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275795 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  275798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275812 */     GIR_RootConstrainSelectedInstOperands,
     /*  275813 */     // GIR_Coverage, 8517,
     /*  275813 */     GIR_EraseRootFromParent_Done,
     /*  275814 */   // Label 5233: @275814
     /*  275814 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(275877), // Rule ID 8520 //
     /*  275819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  275833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  275836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275858 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275875 */     GIR_RootConstrainSelectedInstOperands,
     /*  275876 */     // GIR_Coverage, 8520,
     /*  275876 */     GIR_EraseRootFromParent_Done,
     /*  275877 */   // Label 5234: @275877
     /*  275877 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(275940), // Rule ID 8521 //
     /*  275882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  275896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  275899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275921 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275938 */     GIR_RootConstrainSelectedInstOperands,
     /*  275939 */     // GIR_Coverage, 8521,
     /*  275939 */     GIR_EraseRootFromParent_Done,
     /*  275940 */   // Label 5235: @275940
     /*  275940 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(276003), // Rule ID 8524 //
     /*  275945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  275959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  275962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275984 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276001 */     GIR_RootConstrainSelectedInstOperands,
     /*  276002 */     // GIR_Coverage, 8524,
     /*  276002 */     GIR_EraseRootFromParent_Done,
     /*  276003 */   // Label 5236: @276003
     /*  276003 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(276066), // Rule ID 8525 //
     /*  276008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  276022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  276025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276047 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  276050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276064 */     GIR_RootConstrainSelectedInstOperands,
     /*  276065 */     // GIR_Coverage, 8525,
     /*  276065 */     GIR_EraseRootFromParent_Done,
     /*  276066 */   // Label 5237: @276066
     /*  276066 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(276129), // Rule ID 8528 //
     /*  276071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  276085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  276088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276110 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  276113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276127 */     GIR_RootConstrainSelectedInstOperands,
     /*  276128 */     // GIR_Coverage, 8528,
     /*  276128 */     GIR_EraseRootFromParent_Done,
     /*  276129 */   // Label 5238: @276129
     /*  276129 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(276192), // Rule ID 8529 //
     /*  276134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  276148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  276151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276173 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  276176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276190 */     GIR_RootConstrainSelectedInstOperands,
     /*  276191 */     // GIR_Coverage, 8529,
     /*  276191 */     GIR_EraseRootFromParent_Done,
     /*  276192 */   // Label 5239: @276192
     /*  276192 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(276255), // Rule ID 8532 //
     /*  276197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  276211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  276214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276236 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  276239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276253 */     GIR_RootConstrainSelectedInstOperands,
     /*  276254 */     // GIR_Coverage, 8532,
     /*  276254 */     GIR_EraseRootFromParent_Done,
     /*  276255 */   // Label 5240: @276255
     /*  276255 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(276318), // Rule ID 8533 //
     /*  276260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  276274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  276277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276299 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  276302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276316 */     GIR_RootConstrainSelectedInstOperands,
     /*  276317 */     // GIR_Coverage, 8533,
     /*  276317 */     GIR_EraseRootFromParent_Done,
     /*  276318 */   // Label 5241: @276318
     /*  276318 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(276381), // Rule ID 8536 //
     /*  276323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  276337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  276340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276362 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  276362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  276365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276379 */     GIR_RootConstrainSelectedInstOperands,
     /*  276380 */     // GIR_Coverage, 8536,
     /*  276380 */     GIR_EraseRootFromParent_Done,
     /*  276381 */   // Label 5242: @276381
     /*  276381 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(276444), // Rule ID 8537 //
     /*  276386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  276400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  276403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276425 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  276425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  276428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276442 */     GIR_RootConstrainSelectedInstOperands,
     /*  276443 */     // GIR_Coverage, 8537,
     /*  276443 */     GIR_EraseRootFromParent_Done,
     /*  276444 */   // Label 5243: @276444
     /*  276444 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(276507), // Rule ID 8540 //
     /*  276449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  276463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  276466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276488 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276505 */     GIR_RootConstrainSelectedInstOperands,
     /*  276506 */     // GIR_Coverage, 8540,
     /*  276506 */     GIR_EraseRootFromParent_Done,
     /*  276507 */   // Label 5244: @276507
     /*  276507 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(276570), // Rule ID 8541 //
     /*  276512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  276526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  276529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276551 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276568 */     GIR_RootConstrainSelectedInstOperands,
     /*  276569 */     // GIR_Coverage, 8541,
     /*  276569 */     GIR_EraseRootFromParent_Done,
     /*  276570 */   // Label 5245: @276570
     /*  276570 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(276633), // Rule ID 8544 //
     /*  276575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  276589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  276592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276614 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276631 */     GIR_RootConstrainSelectedInstOperands,
     /*  276632 */     // GIR_Coverage, 8544,
     /*  276632 */     GIR_EraseRootFromParent_Done,
     /*  276633 */   // Label 5246: @276633
     /*  276633 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(276696), // Rule ID 8545 //
     /*  276638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  276652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  276655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276677 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276694 */     GIR_RootConstrainSelectedInstOperands,
     /*  276695 */     // GIR_Coverage, 8545,
     /*  276695 */     GIR_EraseRootFromParent_Done,
     /*  276696 */   // Label 5247: @276696
     /*  276696 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(276759), // Rule ID 8548 //
     /*  276701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  276715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  276718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276740 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  276740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276757 */     GIR_RootConstrainSelectedInstOperands,
     /*  276758 */     // GIR_Coverage, 8548,
     /*  276758 */     GIR_EraseRootFromParent_Done,
     /*  276759 */   // Label 5248: @276759
     /*  276759 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(276822), // Rule ID 8549 //
     /*  276764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  276778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  276781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276803 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  276803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276820 */     GIR_RootConstrainSelectedInstOperands,
     /*  276821 */     // GIR_Coverage, 8549,
     /*  276821 */     GIR_EraseRootFromParent_Done,
     /*  276822 */   // Label 5249: @276822
     /*  276822 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(276885), // Rule ID 8552 //
     /*  276827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  276830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  276841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  276844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276866 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  276866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276883 */     GIR_RootConstrainSelectedInstOperands,
     /*  276884 */     // GIR_Coverage, 8552,
     /*  276884 */     GIR_EraseRootFromParent_Done,
     /*  276885 */   // Label 5250: @276885
     /*  276885 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(276948), // Rule ID 8553 //
     /*  276890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  276893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  276904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  276907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276929 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  276929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276946 */     GIR_RootConstrainSelectedInstOperands,
     /*  276947 */     // GIR_Coverage, 8553,
     /*  276947 */     GIR_EraseRootFromParent_Done,
     /*  276948 */   // Label 5251: @276948
     /*  276948 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(277011), // Rule ID 8556 //
     /*  276953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  276964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  276967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  276970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276992 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277009 */     GIR_RootConstrainSelectedInstOperands,
     /*  277010 */     // GIR_Coverage, 8556,
     /*  277010 */     GIR_EraseRootFromParent_Done,
     /*  277011 */   // Label 5252: @277011
     /*  277011 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(277074), // Rule ID 8557 //
     /*  277016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  277030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  277033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277055 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277072 */     GIR_RootConstrainSelectedInstOperands,
     /*  277073 */     // GIR_Coverage, 8557,
     /*  277073 */     GIR_EraseRootFromParent_Done,
     /*  277074 */   // Label 5253: @277074
     /*  277074 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(277137), // Rule ID 8560 //
     /*  277079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  277093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  277096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277118 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277135 */     GIR_RootConstrainSelectedInstOperands,
     /*  277136 */     // GIR_Coverage, 8560,
     /*  277136 */     GIR_EraseRootFromParent_Done,
     /*  277137 */   // Label 5254: @277137
     /*  277137 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(277200), // Rule ID 8561 //
     /*  277142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  277156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  277159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277181 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277198 */     GIR_RootConstrainSelectedInstOperands,
     /*  277199 */     // GIR_Coverage, 8561,
     /*  277199 */     GIR_EraseRootFromParent_Done,
     /*  277200 */   // Label 5255: @277200
     /*  277200 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(277263), // Rule ID 8564 //
     /*  277205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  277216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  277219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  277222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277244 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277261 */     GIR_RootConstrainSelectedInstOperands,
     /*  277262 */     // GIR_Coverage, 8564,
     /*  277262 */     GIR_EraseRootFromParent_Done,
     /*  277263 */   // Label 5256: @277263
     /*  277263 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(277326), // Rule ID 8565 //
     /*  277268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  277279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  277282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  277285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277307 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277324 */     GIR_RootConstrainSelectedInstOperands,
     /*  277325 */     // GIR_Coverage, 8565,
     /*  277325 */     GIR_EraseRootFromParent_Done,
     /*  277326 */   // Label 5257: @277326
     /*  277326 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(277389), // Rule ID 8568 //
     /*  277331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  277345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  277348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277370 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277387 */     GIR_RootConstrainSelectedInstOperands,
     /*  277388 */     // GIR_Coverage, 8568,
     /*  277388 */     GIR_EraseRootFromParent_Done,
     /*  277389 */   // Label 5258: @277389
     /*  277389 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(277452), // Rule ID 8569 //
     /*  277394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  277408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  277411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277433 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277450 */     GIR_RootConstrainSelectedInstOperands,
     /*  277451 */     // GIR_Coverage, 8569,
     /*  277451 */     GIR_EraseRootFromParent_Done,
     /*  277452 */   // Label 5259: @277452
     /*  277452 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(277515), // Rule ID 8572 //
     /*  277457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  277471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  277474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277496 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277513 */     GIR_RootConstrainSelectedInstOperands,
     /*  277514 */     // GIR_Coverage, 8572,
     /*  277514 */     GIR_EraseRootFromParent_Done,
     /*  277515 */   // Label 5260: @277515
     /*  277515 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(277578), // Rule ID 8573 //
     /*  277520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  277534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  277537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277559 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277576 */     GIR_RootConstrainSelectedInstOperands,
     /*  277577 */     // GIR_Coverage, 8573,
     /*  277577 */     GIR_EraseRootFromParent_Done,
     /*  277578 */   // Label 5261: @277578
     /*  277578 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(277641), // Rule ID 8576 //
     /*  277583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  277597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  277600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277622 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277639 */     GIR_RootConstrainSelectedInstOperands,
     /*  277640 */     // GIR_Coverage, 8576,
     /*  277640 */     GIR_EraseRootFromParent_Done,
     /*  277641 */   // Label 5262: @277641
     /*  277641 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(277704), // Rule ID 8577 //
     /*  277646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  277660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  277663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277685 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277702 */     GIR_RootConstrainSelectedInstOperands,
     /*  277703 */     // GIR_Coverage, 8577,
     /*  277703 */     GIR_EraseRootFromParent_Done,
     /*  277704 */   // Label 5263: @277704
     /*  277704 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(277767), // Rule ID 8580 //
     /*  277709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  277723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  277726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277748 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277765 */     GIR_RootConstrainSelectedInstOperands,
     /*  277766 */     // GIR_Coverage, 8580,
     /*  277766 */     GIR_EraseRootFromParent_Done,
     /*  277767 */   // Label 5264: @277767
     /*  277767 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(277830), // Rule ID 8581 //
     /*  277772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  277786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  277789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277811 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277828 */     GIR_RootConstrainSelectedInstOperands,
     /*  277829 */     // GIR_Coverage, 8581,
     /*  277829 */     GIR_EraseRootFromParent_Done,
     /*  277830 */   // Label 5265: @277830
     /*  277830 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(277893), // Rule ID 8584 //
     /*  277835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  277849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  277852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277874 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277891 */     GIR_RootConstrainSelectedInstOperands,
     /*  277892 */     // GIR_Coverage, 8584,
     /*  277892 */     GIR_EraseRootFromParent_Done,
     /*  277893 */   // Label 5266: @277893
     /*  277893 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(277956), // Rule ID 8585 //
     /*  277898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  277912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  277915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277937 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277954 */     GIR_RootConstrainSelectedInstOperands,
     /*  277955 */     // GIR_Coverage, 8585,
     /*  277955 */     GIR_EraseRootFromParent_Done,
     /*  277956 */   // Label 5267: @277956
     /*  277956 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(278019), // Rule ID 8588 //
     /*  277961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  277975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  277978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278000 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  278000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  278003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278017 */     GIR_RootConstrainSelectedInstOperands,
     /*  278018 */     // GIR_Coverage, 8588,
     /*  278018 */     GIR_EraseRootFromParent_Done,
     /*  278019 */   // Label 5268: @278019
     /*  278019 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(278082), // Rule ID 8589 //
     /*  278024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  278035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  278038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  278041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278063 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  278063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  278066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278080 */     GIR_RootConstrainSelectedInstOperands,
     /*  278081 */     // GIR_Coverage, 8589,
     /*  278081 */     GIR_EraseRootFromParent_Done,
     /*  278082 */   // Label 5269: @278082
     /*  278082 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(278145), // Rule ID 8592 //
     /*  278087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  278101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  278104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278126 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  278129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278143 */     GIR_RootConstrainSelectedInstOperands,
     /*  278144 */     // GIR_Coverage, 8592,
     /*  278144 */     GIR_EraseRootFromParent_Done,
     /*  278145 */   // Label 5270: @278145
     /*  278145 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(278208), // Rule ID 8593 //
     /*  278150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  278153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  278164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  278167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278189 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  278189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  278192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278206 */     GIR_RootConstrainSelectedInstOperands,
     /*  278207 */     // GIR_Coverage, 8593,
     /*  278207 */     GIR_EraseRootFromParent_Done,
     /*  278208 */   // Label 5271: @278208
     /*  278208 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(278271), // Rule ID 8596 //
     /*  278213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  278227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  278230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278252 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  278255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278269 */     GIR_RootConstrainSelectedInstOperands,
     /*  278270 */     // GIR_Coverage, 8596,
     /*  278270 */     GIR_EraseRootFromParent_Done,
     /*  278271 */   // Label 5272: @278271
     /*  278271 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(278334), // Rule ID 8597 //
     /*  278276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  278279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  278290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  278293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278315 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  278315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  278318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278332 */     GIR_RootConstrainSelectedInstOperands,
     /*  278333 */     // GIR_Coverage, 8597,
     /*  278333 */     GIR_EraseRootFromParent_Done,
     /*  278334 */   // Label 5273: @278334
     /*  278334 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(278397), // Rule ID 8600 //
     /*  278339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  278353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  278356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278378 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  278381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278395 */     GIR_RootConstrainSelectedInstOperands,
     /*  278396 */     // GIR_Coverage, 8600,
     /*  278396 */     GIR_EraseRootFromParent_Done,
     /*  278397 */   // Label 5274: @278397
     /*  278397 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(278460), // Rule ID 8601 //
     /*  278402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  278405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  278416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  278419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278441 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  278441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  278444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278458 */     GIR_RootConstrainSelectedInstOperands,
     /*  278459 */     // GIR_Coverage, 8601,
     /*  278459 */     GIR_EraseRootFromParent_Done,
     /*  278460 */   // Label 5275: @278460
     /*  278460 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(278523), // Rule ID 8604 //
     /*  278465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  278479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278504 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  278507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278521 */     GIR_RootConstrainSelectedInstOperands,
     /*  278522 */     // GIR_Coverage, 8604,
     /*  278522 */     GIR_EraseRootFromParent_Done,
     /*  278523 */   // Label 5276: @278523
     /*  278523 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(278586), // Rule ID 8605 //
     /*  278528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  278542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278567 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  278570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278584 */     GIR_RootConstrainSelectedInstOperands,
     /*  278585 */     // GIR_Coverage, 8605,
     /*  278585 */     GIR_EraseRootFromParent_Done,
     /*  278586 */   // Label 5277: @278586
     /*  278586 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(278649), // Rule ID 8608 //
     /*  278591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  278605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278630 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278647 */     GIR_RootConstrainSelectedInstOperands,
     /*  278648 */     // GIR_Coverage, 8608,
     /*  278648 */     GIR_EraseRootFromParent_Done,
     /*  278649 */   // Label 5278: @278649
     /*  278649 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(278712), // Rule ID 8609 //
     /*  278654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  278668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278693 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278710 */     GIR_RootConstrainSelectedInstOperands,
     /*  278711 */     // GIR_Coverage, 8609,
     /*  278711 */     GIR_EraseRootFromParent_Done,
     /*  278712 */   // Label 5279: @278712
     /*  278712 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(278775), // Rule ID 8612 //
     /*  278717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  278731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278756 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278773 */     GIR_RootConstrainSelectedInstOperands,
     /*  278774 */     // GIR_Coverage, 8612,
     /*  278774 */     GIR_EraseRootFromParent_Done,
     /*  278775 */   // Label 5280: @278775
     /*  278775 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(278838), // Rule ID 8613 //
     /*  278780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  278794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278819 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278836 */     GIR_RootConstrainSelectedInstOperands,
     /*  278837 */     // GIR_Coverage, 8613,
     /*  278837 */     GIR_EraseRootFromParent_Done,
     /*  278838 */   // Label 5281: @278838
     /*  278838 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(278901), // Rule ID 8616 //
     /*  278843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  278857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278882 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278899 */     GIR_RootConstrainSelectedInstOperands,
     /*  278900 */     // GIR_Coverage, 8616,
     /*  278900 */     GIR_EraseRootFromParent_Done,
     /*  278901 */   // Label 5282: @278901
     /*  278901 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(278964), // Rule ID 8617 //
     /*  278906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  278920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278945 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278962 */     GIR_RootConstrainSelectedInstOperands,
     /*  278963 */     // GIR_Coverage, 8617,
     /*  278963 */     GIR_EraseRootFromParent_Done,
     /*  278964 */   // Label 5283: @278964
     /*  278964 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(279027), // Rule ID 8620 //
     /*  278969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  278983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279008 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  279011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279025 */     GIR_RootConstrainSelectedInstOperands,
     /*  279026 */     // GIR_Coverage, 8620,
     /*  279026 */     GIR_EraseRootFromParent_Done,
     /*  279027 */   // Label 5284: @279027
     /*  279027 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(279090), // Rule ID 8621 //
     /*  279032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  279046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279071 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  279074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279088 */     GIR_RootConstrainSelectedInstOperands,
     /*  279089 */     // GIR_Coverage, 8621,
     /*  279089 */     GIR_EraseRootFromParent_Done,
     /*  279090 */   // Label 5285: @279090
     /*  279090 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(279153), // Rule ID 8624 //
     /*  279095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  279109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279134 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  279134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  279137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279151 */     GIR_RootConstrainSelectedInstOperands,
     /*  279152 */     // GIR_Coverage, 8624,
     /*  279152 */     GIR_EraseRootFromParent_Done,
     /*  279153 */   // Label 5286: @279153
     /*  279153 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(279216), // Rule ID 8625 //
     /*  279158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  279172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279197 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  279197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  279200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279214 */     GIR_RootConstrainSelectedInstOperands,
     /*  279215 */     // GIR_Coverage, 8625,
     /*  279215 */     GIR_EraseRootFromParent_Done,
     /*  279216 */   // Label 5287: @279216
     /*  279216 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(279279), // Rule ID 8628 //
     /*  279221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  279235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279260 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279277 */     GIR_RootConstrainSelectedInstOperands,
     /*  279278 */     // GIR_Coverage, 8628,
     /*  279278 */     GIR_EraseRootFromParent_Done,
     /*  279279 */   // Label 5288: @279279
     /*  279279 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(279342), // Rule ID 8629 //
     /*  279284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  279298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279323 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279340 */     GIR_RootConstrainSelectedInstOperands,
     /*  279341 */     // GIR_Coverage, 8629,
     /*  279341 */     GIR_EraseRootFromParent_Done,
     /*  279342 */   // Label 5289: @279342
     /*  279342 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(279405), // Rule ID 8632 //
     /*  279347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  279358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  279361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279386 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279403 */     GIR_RootConstrainSelectedInstOperands,
     /*  279404 */     // GIR_Coverage, 8632,
     /*  279404 */     GIR_EraseRootFromParent_Done,
     /*  279405 */   // Label 5290: @279405
     /*  279405 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(279468), // Rule ID 8633 //
     /*  279410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  279421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  279424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279449 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279466 */     GIR_RootConstrainSelectedInstOperands,
     /*  279467 */     // GIR_Coverage, 8633,
     /*  279467 */     GIR_EraseRootFromParent_Done,
     /*  279468 */   // Label 5291: @279468
     /*  279468 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(279531), // Rule ID 8636 //
     /*  279473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  279487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279512 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  279512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279529 */     GIR_RootConstrainSelectedInstOperands,
     /*  279530 */     // GIR_Coverage, 8636,
     /*  279530 */     GIR_EraseRootFromParent_Done,
     /*  279531 */   // Label 5292: @279531
     /*  279531 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(279594), // Rule ID 8637 //
     /*  279536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  279550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279575 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  279575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279592 */     GIR_RootConstrainSelectedInstOperands,
     /*  279593 */     // GIR_Coverage, 8637,
     /*  279593 */     GIR_EraseRootFromParent_Done,
     /*  279594 */   // Label 5293: @279594
     /*  279594 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(279657), // Rule ID 8640 //
     /*  279599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  279602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  279613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279638 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  279638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  279655 */     GIR_RootConstrainSelectedInstOperands,
     /*  279656 */     // GIR_Coverage, 8640,
     /*  279656 */     GIR_EraseRootFromParent_Done,
     /*  279657 */   // Label 5294: @279657
     /*  279657 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(279720), // Rule ID 8641 //
     /*  279662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  279665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  279676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279701 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  279701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  279718 */     GIR_RootConstrainSelectedInstOperands,
     /*  279719 */     // GIR_Coverage, 8641,
     /*  279719 */     GIR_EraseRootFromParent_Done,
     /*  279720 */   // Label 5295: @279720
     /*  279720 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(279783), // Rule ID 8644 //
     /*  279725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  279739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279764 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279781 */     GIR_RootConstrainSelectedInstOperands,
     /*  279782 */     // GIR_Coverage, 8644,
     /*  279782 */     GIR_EraseRootFromParent_Done,
     /*  279783 */   // Label 5296: @279783
     /*  279783 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(279846), // Rule ID 8645 //
     /*  279788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  279802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279827 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279844 */     GIR_RootConstrainSelectedInstOperands,
     /*  279845 */     // GIR_Coverage, 8645,
     /*  279845 */     GIR_EraseRootFromParent_Done,
     /*  279846 */   // Label 5297: @279846
     /*  279846 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(279909), // Rule ID 8648 //
     /*  279851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  279865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279890 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279907 */     GIR_RootConstrainSelectedInstOperands,
     /*  279908 */     // GIR_Coverage, 8648,
     /*  279908 */     GIR_EraseRootFromParent_Done,
     /*  279909 */   // Label 5298: @279909
     /*  279909 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(279972), // Rule ID 8649 //
     /*  279914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  279928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279953 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279970 */     GIR_RootConstrainSelectedInstOperands,
     /*  279971 */     // GIR_Coverage, 8649,
     /*  279971 */     GIR_EraseRootFromParent_Done,
     /*  279972 */   // Label 5299: @279972
     /*  279972 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(280035), // Rule ID 8652 //
     /*  279977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  279988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  279991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280016 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280033 */     GIR_RootConstrainSelectedInstOperands,
     /*  280034 */     // GIR_Coverage, 8652,
     /*  280034 */     GIR_EraseRootFromParent_Done,
     /*  280035 */   // Label 5300: @280035
     /*  280035 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(280098), // Rule ID 8653 //
     /*  280040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  280051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  280054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280079 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280096 */     GIR_RootConstrainSelectedInstOperands,
     /*  280097 */     // GIR_Coverage, 8653,
     /*  280097 */     GIR_EraseRootFromParent_Done,
     /*  280098 */   // Label 5301: @280098
     /*  280098 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(280161), // Rule ID 8656 //
     /*  280103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  280117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280142 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280159 */     GIR_RootConstrainSelectedInstOperands,
     /*  280160 */     // GIR_Coverage, 8656,
     /*  280160 */     GIR_EraseRootFromParent_Done,
     /*  280161 */   // Label 5302: @280161
     /*  280161 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(280224), // Rule ID 8657 //
     /*  280166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  280180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280205 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280222 */     GIR_RootConstrainSelectedInstOperands,
     /*  280223 */     // GIR_Coverage, 8657,
     /*  280223 */     GIR_EraseRootFromParent_Done,
     /*  280224 */   // Label 5303: @280224
     /*  280224 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(280287), // Rule ID 8660 //
     /*  280229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  280243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280268 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280285 */     GIR_RootConstrainSelectedInstOperands,
     /*  280286 */     // GIR_Coverage, 8660,
     /*  280286 */     GIR_EraseRootFromParent_Done,
     /*  280287 */   // Label 5304: @280287
     /*  280287 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(280350), // Rule ID 8661 //
     /*  280292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  280306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280331 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280348 */     GIR_RootConstrainSelectedInstOperands,
     /*  280349 */     // GIR_Coverage, 8661,
     /*  280349 */     GIR_EraseRootFromParent_Done,
     /*  280350 */   // Label 5305: @280350
     /*  280350 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(280413), // Rule ID 8664 //
     /*  280355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  280366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  280369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280394 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280411 */     GIR_RootConstrainSelectedInstOperands,
     /*  280412 */     // GIR_Coverage, 8664,
     /*  280412 */     GIR_EraseRootFromParent_Done,
     /*  280413 */   // Label 5306: @280413
     /*  280413 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(280476), // Rule ID 8665 //
     /*  280418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  280429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  280432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280457 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280474 */     GIR_RootConstrainSelectedInstOperands,
     /*  280475 */     // GIR_Coverage, 8665,
     /*  280475 */     GIR_EraseRootFromParent_Done,
     /*  280476 */   // Label 5307: @280476
     /*  280476 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(280539), // Rule ID 8668 //
     /*  280481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  280495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280520 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280537 */     GIR_RootConstrainSelectedInstOperands,
     /*  280538 */     // GIR_Coverage, 8668,
     /*  280538 */     GIR_EraseRootFromParent_Done,
     /*  280539 */   // Label 5308: @280539
     /*  280539 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(280602), // Rule ID 8669 //
     /*  280544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  280558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280583 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280600 */     GIR_RootConstrainSelectedInstOperands,
     /*  280601 */     // GIR_Coverage, 8669,
     /*  280601 */     GIR_EraseRootFromParent_Done,
     /*  280602 */   // Label 5309: @280602
     /*  280602 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(280665), // Rule ID 8672 //
     /*  280607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  280621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280646 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280663 */     GIR_RootConstrainSelectedInstOperands,
     /*  280664 */     // GIR_Coverage, 8672,
     /*  280664 */     GIR_EraseRootFromParent_Done,
     /*  280665 */   // Label 5310: @280665
     /*  280665 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(280728), // Rule ID 8673 //
     /*  280670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  280684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280709 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280726 */     GIR_RootConstrainSelectedInstOperands,
     /*  280727 */     // GIR_Coverage, 8673,
     /*  280727 */     GIR_EraseRootFromParent_Done,
     /*  280728 */   // Label 5311: @280728
     /*  280728 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(280791), // Rule ID 8676 //
     /*  280733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  280747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280772 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280789 */     GIR_RootConstrainSelectedInstOperands,
     /*  280790 */     // GIR_Coverage, 8676,
     /*  280790 */     GIR_EraseRootFromParent_Done,
     /*  280791 */   // Label 5312: @280791
     /*  280791 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(280854), // Rule ID 8677 //
     /*  280796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  280810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280835 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280852 */     GIR_RootConstrainSelectedInstOperands,
     /*  280853 */     // GIR_Coverage, 8677,
     /*  280853 */     GIR_EraseRootFromParent_Done,
     /*  280854 */   // Label 5313: @280854
     /*  280854 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(280917), // Rule ID 8680 //
     /*  280859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  280873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280898 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  280898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280915 */     GIR_RootConstrainSelectedInstOperands,
     /*  280916 */     // GIR_Coverage, 8680,
     /*  280916 */     GIR_EraseRootFromParent_Done,
     /*  280917 */   // Label 5314: @280917
     /*  280917 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(280980), // Rule ID 8681 //
     /*  280922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  280925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  280936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280961 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  280961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280978 */     GIR_RootConstrainSelectedInstOperands,
     /*  280979 */     // GIR_Coverage, 8681,
     /*  280979 */     GIR_EraseRootFromParent_Done,
     /*  280980 */   // Label 5315: @280980
     /*  280980 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(281043), // Rule ID 8684 //
     /*  280985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  280999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  281002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281024 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  281027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281041 */     GIR_RootConstrainSelectedInstOperands,
     /*  281042 */     // GIR_Coverage, 8684,
     /*  281042 */     GIR_EraseRootFromParent_Done,
     /*  281043 */   // Label 5316: @281043
     /*  281043 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(281106), // Rule ID 8685 //
     /*  281048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  281062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  281065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281087 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  281087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  281090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281104 */     GIR_RootConstrainSelectedInstOperands,
     /*  281105 */     // GIR_Coverage, 8685,
     /*  281105 */     GIR_EraseRootFromParent_Done,
     /*  281106 */   // Label 5317: @281106
     /*  281106 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(281169), // Rule ID 8688 //
     /*  281111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  281114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  281125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  281128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281150 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  281153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281167 */     GIR_RootConstrainSelectedInstOperands,
     /*  281168 */     // GIR_Coverage, 8688,
     /*  281168 */     GIR_EraseRootFromParent_Done,
     /*  281169 */   // Label 5318: @281169
     /*  281169 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(281232), // Rule ID 8689 //
     /*  281174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  281188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  281191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281213 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  281213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  281216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281230 */     GIR_RootConstrainSelectedInstOperands,
     /*  281231 */     // GIR_Coverage, 8689,
     /*  281231 */     GIR_EraseRootFromParent_Done,
     /*  281232 */   // Label 5319: @281232
     /*  281232 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(281295), // Rule ID 8692 //
     /*  281237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  281251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  281254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281276 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  281279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281293 */     GIR_RootConstrainSelectedInstOperands,
     /*  281294 */     // GIR_Coverage, 8692,
     /*  281294 */     GIR_EraseRootFromParent_Done,
     /*  281295 */   // Label 5320: @281295
     /*  281295 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(281358), // Rule ID 8693 //
     /*  281300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  281314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  281317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281339 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  281342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281356 */     GIR_RootConstrainSelectedInstOperands,
     /*  281357 */     // GIR_Coverage, 8693,
     /*  281357 */     GIR_EraseRootFromParent_Done,
     /*  281358 */   // Label 5321: @281358
     /*  281358 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(281421), // Rule ID 8696 //
     /*  281363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  281377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  281380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281402 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281419 */     GIR_RootConstrainSelectedInstOperands,
     /*  281420 */     // GIR_Coverage, 8696,
     /*  281420 */     GIR_EraseRootFromParent_Done,
     /*  281421 */   // Label 5322: @281421
     /*  281421 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(281484), // Rule ID 8697 //
     /*  281426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  281440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  281443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281465 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281482 */     GIR_RootConstrainSelectedInstOperands,
     /*  281483 */     // GIR_Coverage, 8697,
     /*  281483 */     GIR_EraseRootFromParent_Done,
     /*  281484 */   // Label 5323: @281484
     /*  281484 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(281547), // Rule ID 8700 //
     /*  281489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  281503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  281506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281528 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281545 */     GIR_RootConstrainSelectedInstOperands,
     /*  281546 */     // GIR_Coverage, 8700,
     /*  281546 */     GIR_EraseRootFromParent_Done,
     /*  281547 */   // Label 5324: @281547
     /*  281547 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(281610), // Rule ID 8701 //
     /*  281552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  281566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  281569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281591 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281608 */     GIR_RootConstrainSelectedInstOperands,
     /*  281609 */     // GIR_Coverage, 8701,
     /*  281609 */     GIR_EraseRootFromParent_Done,
     /*  281610 */   // Label 5325: @281610
     /*  281610 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(281673), // Rule ID 8704 //
     /*  281615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  281629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  281632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281654 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  281654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281671 */     GIR_RootConstrainSelectedInstOperands,
     /*  281672 */     // GIR_Coverage, 8704,
     /*  281672 */     GIR_EraseRootFromParent_Done,
     /*  281673 */   // Label 5326: @281673
     /*  281673 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(281736), // Rule ID 8705 //
     /*  281678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  281692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  281695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281717 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281734 */     GIR_RootConstrainSelectedInstOperands,
     /*  281735 */     // GIR_Coverage, 8705,
     /*  281735 */     GIR_EraseRootFromParent_Done,
     /*  281736 */   // Label 5327: @281736
     /*  281736 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(281799), // Rule ID 8708 //
     /*  281741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  281755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  281758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281780 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  281780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281797 */     GIR_RootConstrainSelectedInstOperands,
     /*  281798 */     // GIR_Coverage, 8708,
     /*  281798 */     GIR_EraseRootFromParent_Done,
     /*  281799 */   // Label 5328: @281799
     /*  281799 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(281862), // Rule ID 8709 //
     /*  281804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  281818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  281821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281843 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281860 */     GIR_RootConstrainSelectedInstOperands,
     /*  281861 */     // GIR_Coverage, 8709,
     /*  281861 */     GIR_EraseRootFromParent_Done,
     /*  281862 */   // Label 5329: @281862
     /*  281862 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(281925), // Rule ID 8712 //
     /*  281867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  281881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  281884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281906 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281923 */     GIR_RootConstrainSelectedInstOperands,
     /*  281924 */     // GIR_Coverage, 8712,
     /*  281924 */     GIR_EraseRootFromParent_Done,
     /*  281925 */   // Label 5330: @281925
     /*  281925 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(281988), // Rule ID 8713 //
     /*  281930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  281944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  281947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281969 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281986 */     GIR_RootConstrainSelectedInstOperands,
     /*  281987 */     // GIR_Coverage, 8713,
     /*  281987 */     GIR_EraseRootFromParent_Done,
     /*  281988 */   // Label 5331: @281988
     /*  281988 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(282051), // Rule ID 8716 //
     /*  281993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  282007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  282010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282049 */     GIR_RootConstrainSelectedInstOperands,
     /*  282050 */     // GIR_Coverage, 8716,
     /*  282050 */     GIR_EraseRootFromParent_Done,
     /*  282051 */   // Label 5332: @282051
     /*  282051 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(282114), // Rule ID 8717 //
     /*  282056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  282070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  282073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282095 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282112 */     GIR_RootConstrainSelectedInstOperands,
     /*  282113 */     // GIR_Coverage, 8717,
     /*  282113 */     GIR_EraseRootFromParent_Done,
     /*  282114 */   // Label 5333: @282114
     /*  282114 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(282177), // Rule ID 8720 //
     /*  282119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  282133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  282136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282158 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282175 */     GIR_RootConstrainSelectedInstOperands,
     /*  282176 */     // GIR_Coverage, 8720,
     /*  282176 */     GIR_EraseRootFromParent_Done,
     /*  282177 */   // Label 5334: @282177
     /*  282177 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(282240), // Rule ID 8721 //
     /*  282182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  282196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  282199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282221 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282238 */     GIR_RootConstrainSelectedInstOperands,
     /*  282239 */     // GIR_Coverage, 8721,
     /*  282239 */     GIR_EraseRootFromParent_Done,
     /*  282240 */   // Label 5335: @282240
     /*  282240 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(282303), // Rule ID 8724 //
     /*  282245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  282259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  282262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282284 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282301 */     GIR_RootConstrainSelectedInstOperands,
     /*  282302 */     // GIR_Coverage, 8724,
     /*  282302 */     GIR_EraseRootFromParent_Done,
     /*  282303 */   // Label 5336: @282303
     /*  282303 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(282366), // Rule ID 8725 //
     /*  282308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  282322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  282325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282347 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  282347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282364 */     GIR_RootConstrainSelectedInstOperands,
     /*  282365 */     // GIR_Coverage, 8725,
     /*  282365 */     GIR_EraseRootFromParent_Done,
     /*  282366 */   // Label 5337: @282366
     /*  282366 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(282429), // Rule ID 8728 //
     /*  282371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  282374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  282385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  282388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282410 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  282410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  282427 */     GIR_RootConstrainSelectedInstOperands,
     /*  282428 */     // GIR_Coverage, 8728,
     /*  282428 */     GIR_EraseRootFromParent_Done,
     /*  282429 */   // Label 5338: @282429
     /*  282429 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(282492), // Rule ID 8729 //
     /*  282434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  282437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  282448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  282451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282473 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  282473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  282490 */     GIR_RootConstrainSelectedInstOperands,
     /*  282491 */     // GIR_Coverage, 8729,
     /*  282491 */     GIR_EraseRootFromParent_Done,
     /*  282492 */   // Label 5339: @282492
     /*  282492 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(282555), // Rule ID 8732 //
     /*  282497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  282511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  282514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282536 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282553 */     GIR_RootConstrainSelectedInstOperands,
     /*  282554 */     // GIR_Coverage, 8732,
     /*  282554 */     GIR_EraseRootFromParent_Done,
     /*  282555 */   // Label 5340: @282555
     /*  282555 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(282618), // Rule ID 8733 //
     /*  282560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  282574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  282577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282599 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282616 */     GIR_RootConstrainSelectedInstOperands,
     /*  282617 */     // GIR_Coverage, 8733,
     /*  282617 */     GIR_EraseRootFromParent_Done,
     /*  282618 */   // Label 5341: @282618
     /*  282618 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(282681), // Rule ID 8736 //
     /*  282623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  282637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  282640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282662 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282679 */     GIR_RootConstrainSelectedInstOperands,
     /*  282680 */     // GIR_Coverage, 8736,
     /*  282680 */     GIR_EraseRootFromParent_Done,
     /*  282681 */   // Label 5342: @282681
     /*  282681 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(282744), // Rule ID 8737 //
     /*  282686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  282700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  282703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282725 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282742 */     GIR_RootConstrainSelectedInstOperands,
     /*  282743 */     // GIR_Coverage, 8737,
     /*  282743 */     GIR_EraseRootFromParent_Done,
     /*  282744 */   // Label 5343: @282744
     /*  282744 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(282807), // Rule ID 8740 //
     /*  282749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  282760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  282763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  282766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282788 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282805 */     GIR_RootConstrainSelectedInstOperands,
     /*  282806 */     // GIR_Coverage, 8740,
     /*  282806 */     GIR_EraseRootFromParent_Done,
     /*  282807 */   // Label 5344: @282807
     /*  282807 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(282870), // Rule ID 8741 //
     /*  282812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  282823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  282826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  282829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282851 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282868 */     GIR_RootConstrainSelectedInstOperands,
     /*  282869 */     // GIR_Coverage, 8741,
     /*  282869 */     GIR_EraseRootFromParent_Done,
     /*  282870 */   // Label 5345: @282870
     /*  282870 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(282933), // Rule ID 8744 //
     /*  282875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  282889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  282892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282914 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282931 */     GIR_RootConstrainSelectedInstOperands,
     /*  282932 */     // GIR_Coverage, 8744,
     /*  282932 */     GIR_EraseRootFromParent_Done,
     /*  282933 */   // Label 5346: @282933
     /*  282933 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(282996), // Rule ID 8745 //
     /*  282938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  282952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  282955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282977 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282994 */     GIR_RootConstrainSelectedInstOperands,
     /*  282995 */     // GIR_Coverage, 8745,
     /*  282995 */     GIR_EraseRootFromParent_Done,
     /*  282996 */   // Label 5347: @282996
     /*  282996 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(283059), // Rule ID 8748 //
     /*  283001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  283015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  283018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283040 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283057 */     GIR_RootConstrainSelectedInstOperands,
     /*  283058 */     // GIR_Coverage, 8748,
     /*  283058 */     GIR_EraseRootFromParent_Done,
     /*  283059 */   // Label 5348: @283059
     /*  283059 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(283122), // Rule ID 8749 //
     /*  283064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  283078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  283081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283103 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  283103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283120 */     GIR_RootConstrainSelectedInstOperands,
     /*  283121 */     // GIR_Coverage, 8749,
     /*  283121 */     GIR_EraseRootFromParent_Done,
     /*  283122 */   // Label 5349: @283122
     /*  283122 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(283185), // Rule ID 8752 //
     /*  283127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  283138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  283141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  283144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283166 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283183 */     GIR_RootConstrainSelectedInstOperands,
     /*  283184 */     // GIR_Coverage, 8752,
     /*  283184 */     GIR_EraseRootFromParent_Done,
     /*  283185 */   // Label 5350: @283185
     /*  283185 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(283248), // Rule ID 8753 //
     /*  283190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  283201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  283204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  283207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283229 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  283229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283246 */     GIR_RootConstrainSelectedInstOperands,
     /*  283247 */     // GIR_Coverage, 8753,
     /*  283247 */     GIR_EraseRootFromParent_Done,
     /*  283248 */   // Label 5351: @283248
     /*  283248 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(283311), // Rule ID 8756 //
     /*  283253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  283267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  283270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283292 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  283292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  283295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283309 */     GIR_RootConstrainSelectedInstOperands,
     /*  283310 */     // GIR_Coverage, 8756,
     /*  283310 */     GIR_EraseRootFromParent_Done,
     /*  283311 */   // Label 5352: @283311
     /*  283311 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(283374), // Rule ID 8757 //
     /*  283316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  283330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  283333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283355 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  283358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283372 */     GIR_RootConstrainSelectedInstOperands,
     /*  283373 */     // GIR_Coverage, 8757,
     /*  283373 */     GIR_EraseRootFromParent_Done,
     /*  283374 */   // Label 5353: @283374
     /*  283374 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(283437), // Rule ID 8760 //
     /*  283379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  283393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  283396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283418 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  283418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283435 */     GIR_RootConstrainSelectedInstOperands,
     /*  283436 */     // GIR_Coverage, 8760,
     /*  283436 */     GIR_EraseRootFromParent_Done,
     /*  283437 */   // Label 5354: @283437
     /*  283437 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(283500), // Rule ID 8761 //
     /*  283442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  283456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  283459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283481 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283498 */     GIR_RootConstrainSelectedInstOperands,
     /*  283499 */     // GIR_Coverage, 8761,
     /*  283499 */     GIR_EraseRootFromParent_Done,
     /*  283500 */   // Label 5355: @283500
     /*  283500 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(283563), // Rule ID 8764 //
     /*  283505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  283519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  283522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283544 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  283544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283561 */     GIR_RootConstrainSelectedInstOperands,
     /*  283562 */     // GIR_Coverage, 8764,
     /*  283562 */     GIR_EraseRootFromParent_Done,
     /*  283563 */   // Label 5356: @283563
     /*  283563 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(283626), // Rule ID 8765 //
     /*  283568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  283582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  283585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283607 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283624 */     GIR_RootConstrainSelectedInstOperands,
     /*  283625 */     // GIR_Coverage, 8765,
     /*  283625 */     GIR_EraseRootFromParent_Done,
     /*  283626 */   // Label 5357: @283626
     /*  283626 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(283689), // Rule ID 8768 //
     /*  283631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  283634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  283645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  283648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283670 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  283673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283687 */     GIR_RootConstrainSelectedInstOperands,
     /*  283688 */     // GIR_Coverage, 8768,
     /*  283688 */     GIR_EraseRootFromParent_Done,
     /*  283689 */   // Label 5358: @283689
     /*  283689 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(283752), // Rule ID 8769 //
     /*  283694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  283708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  283711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283733 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  283736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283750 */     GIR_RootConstrainSelectedInstOperands,
     /*  283751 */     // GIR_Coverage, 8769,
     /*  283751 */     GIR_EraseRootFromParent_Done,
     /*  283752 */   // Label 5359: @283752
     /*  283752 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(283815), // Rule ID 8772 //
     /*  283757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  283760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  283771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  283774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283796 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283813 */     GIR_RootConstrainSelectedInstOperands,
     /*  283814 */     // GIR_Coverage, 8772,
     /*  283814 */     GIR_EraseRootFromParent_Done,
     /*  283815 */   // Label 5360: @283815
     /*  283815 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(283878), // Rule ID 8773 //
     /*  283820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  283834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  283837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283859 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283876 */     GIR_RootConstrainSelectedInstOperands,
     /*  283877 */     // GIR_Coverage, 8773,
     /*  283877 */     GIR_EraseRootFromParent_Done,
     /*  283878 */   // Label 5361: @283878
     /*  283878 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(283941), // Rule ID 8776 //
     /*  283883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  283886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  283897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  283900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283922 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283939 */     GIR_RootConstrainSelectedInstOperands,
     /*  283940 */     // GIR_Coverage, 8776,
     /*  283940 */     GIR_EraseRootFromParent_Done,
     /*  283941 */   // Label 5362: @283941
     /*  283941 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(284004), // Rule ID 8777 //
     /*  283946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  283960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  283963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283985 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284002 */     GIR_RootConstrainSelectedInstOperands,
     /*  284003 */     // GIR_Coverage, 8777,
     /*  284003 */     GIR_EraseRootFromParent_Done,
     /*  284004 */   // Label 5363: @284004
     /*  284004 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(284067), // Rule ID 8780 //
     /*  284009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  284023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284048 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  284051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284065 */     GIR_RootConstrainSelectedInstOperands,
     /*  284066 */     // GIR_Coverage, 8780,
     /*  284066 */     GIR_EraseRootFromParent_Done,
     /*  284067 */   // Label 5364: @284067
     /*  284067 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(284130), // Rule ID 8781 //
     /*  284072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  284086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284111 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  284114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284128 */     GIR_RootConstrainSelectedInstOperands,
     /*  284129 */     // GIR_Coverage, 8781,
     /*  284129 */     GIR_EraseRootFromParent_Done,
     /*  284130 */   // Label 5365: @284130
     /*  284130 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(284193), // Rule ID 8784 //
     /*  284135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  284149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284174 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  284177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284191 */     GIR_RootConstrainSelectedInstOperands,
     /*  284192 */     // GIR_Coverage, 8784,
     /*  284192 */     GIR_EraseRootFromParent_Done,
     /*  284193 */   // Label 5366: @284193
     /*  284193 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(284256), // Rule ID 8785 //
     /*  284198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  284212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284237 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  284240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284254 */     GIR_RootConstrainSelectedInstOperands,
     /*  284255 */     // GIR_Coverage, 8785,
     /*  284255 */     GIR_EraseRootFromParent_Done,
     /*  284256 */   // Label 5367: @284256
     /*  284256 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(284319), // Rule ID 8788 //
     /*  284261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  284275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284300 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284317 */     GIR_RootConstrainSelectedInstOperands,
     /*  284318 */     // GIR_Coverage, 8788,
     /*  284318 */     GIR_EraseRootFromParent_Done,
     /*  284319 */   // Label 5368: @284319
     /*  284319 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(284382), // Rule ID 8789 //
     /*  284324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  284338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284363 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284380 */     GIR_RootConstrainSelectedInstOperands,
     /*  284381 */     // GIR_Coverage, 8789,
     /*  284381 */     GIR_EraseRootFromParent_Done,
     /*  284382 */   // Label 5369: @284382
     /*  284382 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(284445), // Rule ID 8792 //
     /*  284387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  284401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284426 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  284429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284443 */     GIR_RootConstrainSelectedInstOperands,
     /*  284444 */     // GIR_Coverage, 8792,
     /*  284444 */     GIR_EraseRootFromParent_Done,
     /*  284445 */   // Label 5370: @284445
     /*  284445 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(284508), // Rule ID 8793 //
     /*  284450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  284464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284489 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  284492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284506 */     GIR_RootConstrainSelectedInstOperands,
     /*  284507 */     // GIR_Coverage, 8793,
     /*  284507 */     GIR_EraseRootFromParent_Done,
     /*  284508 */   // Label 5371: @284508
     /*  284508 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(284571), // Rule ID 8796 //
     /*  284513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  284527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284552 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284569 */     GIR_RootConstrainSelectedInstOperands,
     /*  284570 */     // GIR_Coverage, 8796,
     /*  284570 */     GIR_EraseRootFromParent_Done,
     /*  284571 */   // Label 5372: @284571
     /*  284571 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(284634), // Rule ID 8797 //
     /*  284576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  284590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284615 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284632 */     GIR_RootConstrainSelectedInstOperands,
     /*  284633 */     // GIR_Coverage, 8797,
     /*  284633 */     GIR_EraseRootFromParent_Done,
     /*  284634 */   // Label 5373: @284634
     /*  284634 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(284697), // Rule ID 8800 //
     /*  284639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  284653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284678 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  284678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284695 */     GIR_RootConstrainSelectedInstOperands,
     /*  284696 */     // GIR_Coverage, 8800,
     /*  284696 */     GIR_EraseRootFromParent_Done,
     /*  284697 */   // Label 5374: @284697
     /*  284697 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(284760), // Rule ID 8801 //
     /*  284702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  284716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284741 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  284741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284758 */     GIR_RootConstrainSelectedInstOperands,
     /*  284759 */     // GIR_Coverage, 8801,
     /*  284759 */     GIR_EraseRootFromParent_Done,
     /*  284760 */   // Label 5375: @284760
     /*  284760 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(284823), // Rule ID 8804 //
     /*  284765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  284779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284804 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284821 */     GIR_RootConstrainSelectedInstOperands,
     /*  284822 */     // GIR_Coverage, 8804,
     /*  284822 */     GIR_EraseRootFromParent_Done,
     /*  284823 */   // Label 5376: @284823
     /*  284823 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(284886), // Rule ID 8805 //
     /*  284828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  284842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284867 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284884 */     GIR_RootConstrainSelectedInstOperands,
     /*  284885 */     // GIR_Coverage, 8805,
     /*  284885 */     GIR_EraseRootFromParent_Done,
     /*  284886 */   // Label 5377: @284886
     /*  284886 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(284949), // Rule ID 8808 //
     /*  284891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  284905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284930 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284947 */     GIR_RootConstrainSelectedInstOperands,
     /*  284948 */     // GIR_Coverage, 8808,
     /*  284948 */     GIR_EraseRootFromParent_Done,
     /*  284949 */   // Label 5378: @284949
     /*  284949 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(285012), // Rule ID 8809 //
     /*  284954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  284968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284993 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285010 */     GIR_RootConstrainSelectedInstOperands,
     /*  285011 */     // GIR_Coverage, 8809,
     /*  285011 */     GIR_EraseRootFromParent_Done,
     /*  285012 */   // Label 5379: @285012
     /*  285012 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(285075), // Rule ID 8812 //
     /*  285017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  285031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285056 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  285059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285073 */     GIR_RootConstrainSelectedInstOperands,
     /*  285074 */     // GIR_Coverage, 8812,
     /*  285074 */     GIR_EraseRootFromParent_Done,
     /*  285075 */   // Label 5380: @285075
     /*  285075 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(285138), // Rule ID 8813 //
     /*  285080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  285094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285119 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  285122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285136 */     GIR_RootConstrainSelectedInstOperands,
     /*  285137 */     // GIR_Coverage, 8813,
     /*  285137 */     GIR_EraseRootFromParent_Done,
     /*  285138 */   // Label 5381: @285138
     /*  285138 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(285201), // Rule ID 8816 //
     /*  285143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  285146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  285157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285182 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  285182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  285185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285199 */     GIR_RootConstrainSelectedInstOperands,
     /*  285200 */     // GIR_Coverage, 8816,
     /*  285200 */     GIR_EraseRootFromParent_Done,
     /*  285201 */   // Label 5382: @285201
     /*  285201 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(285264), // Rule ID 8817 //
     /*  285206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  285209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  285220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285245 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  285245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  285248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285262 */     GIR_RootConstrainSelectedInstOperands,
     /*  285263 */     // GIR_Coverage, 8817,
     /*  285263 */     GIR_EraseRootFromParent_Done,
     /*  285264 */   // Label 5383: @285264
     /*  285264 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(285327), // Rule ID 8820 //
     /*  285269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  285283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285308 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285325 */     GIR_RootConstrainSelectedInstOperands,
     /*  285326 */     // GIR_Coverage, 8820,
     /*  285326 */     GIR_EraseRootFromParent_Done,
     /*  285327 */   // Label 5384: @285327
     /*  285327 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(285390), // Rule ID 8821 //
     /*  285332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  285346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285371 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285388 */     GIR_RootConstrainSelectedInstOperands,
     /*  285389 */     // GIR_Coverage, 8821,
     /*  285389 */     GIR_EraseRootFromParent_Done,
     /*  285390 */   // Label 5385: @285390
     /*  285390 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(285453), // Rule ID 8824 //
     /*  285395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  285409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285434 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285451 */     GIR_RootConstrainSelectedInstOperands,
     /*  285452 */     // GIR_Coverage, 8824,
     /*  285452 */     GIR_EraseRootFromParent_Done,
     /*  285453 */   // Label 5386: @285453
     /*  285453 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(285516), // Rule ID 8825 //
     /*  285458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  285472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285497 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285514 */     GIR_RootConstrainSelectedInstOperands,
     /*  285515 */     // GIR_Coverage, 8825,
     /*  285515 */     GIR_EraseRootFromParent_Done,
     /*  285516 */   // Label 5387: @285516
     /*  285516 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(285579), // Rule ID 8828 //
     /*  285521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  285532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  285535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285560 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285577 */     GIR_RootConstrainSelectedInstOperands,
     /*  285578 */     // GIR_Coverage, 8828,
     /*  285578 */     GIR_EraseRootFromParent_Done,
     /*  285579 */   // Label 5388: @285579
     /*  285579 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(285642), // Rule ID 8829 //
     /*  285584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  285595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  285598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285623 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285640 */     GIR_RootConstrainSelectedInstOperands,
     /*  285641 */     // GIR_Coverage, 8829,
     /*  285641 */     GIR_EraseRootFromParent_Done,
     /*  285642 */   // Label 5389: @285642
     /*  285642 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(285705), // Rule ID 8832 //
     /*  285647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  285661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285686 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285703 */     GIR_RootConstrainSelectedInstOperands,
     /*  285704 */     // GIR_Coverage, 8832,
     /*  285704 */     GIR_EraseRootFromParent_Done,
     /*  285705 */   // Label 5390: @285705
     /*  285705 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(285768), // Rule ID 8833 //
     /*  285710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  285724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285749 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285766 */     GIR_RootConstrainSelectedInstOperands,
     /*  285767 */     // GIR_Coverage, 8833,
     /*  285767 */     GIR_EraseRootFromParent_Done,
     /*  285768 */   // Label 5391: @285768
     /*  285768 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(285831), // Rule ID 8836 //
     /*  285773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  285787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285812 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285829 */     GIR_RootConstrainSelectedInstOperands,
     /*  285830 */     // GIR_Coverage, 8836,
     /*  285830 */     GIR_EraseRootFromParent_Done,
     /*  285831 */   // Label 5392: @285831
     /*  285831 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(285894), // Rule ID 8837 //
     /*  285836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  285850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285875 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285892 */     GIR_RootConstrainSelectedInstOperands,
     /*  285893 */     // GIR_Coverage, 8837,
     /*  285893 */     GIR_EraseRootFromParent_Done,
     /*  285894 */   // Label 5393: @285894
     /*  285894 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(285957), // Rule ID 8840 //
     /*  285899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  285913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285938 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285955 */     GIR_RootConstrainSelectedInstOperands,
     /*  285956 */     // GIR_Coverage, 8840,
     /*  285956 */     GIR_EraseRootFromParent_Done,
     /*  285957 */   // Label 5394: @285957
     /*  285957 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(286020), // Rule ID 8841 //
     /*  285962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  285976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286001 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286018 */     GIR_RootConstrainSelectedInstOperands,
     /*  286019 */     // GIR_Coverage, 8841,
     /*  286019 */     GIR_EraseRootFromParent_Done,
     /*  286020 */   // Label 5395: @286020
     /*  286020 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(286083), // Rule ID 8844 //
     /*  286025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  286039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286064 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  286067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286081 */     GIR_RootConstrainSelectedInstOperands,
     /*  286082 */     // GIR_Coverage, 8844,
     /*  286082 */     GIR_EraseRootFromParent_Done,
     /*  286083 */   // Label 5396: @286083
     /*  286083 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(286146), // Rule ID 8845 //
     /*  286088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  286102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286127 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  286130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286144 */     GIR_RootConstrainSelectedInstOperands,
     /*  286145 */     // GIR_Coverage, 8845,
     /*  286145 */     GIR_EraseRootFromParent_Done,
     /*  286146 */   // Label 5397: @286146
     /*  286146 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(286209), // Rule ID 8848 //
     /*  286151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  286165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286190 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  286193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286207 */     GIR_RootConstrainSelectedInstOperands,
     /*  286208 */     // GIR_Coverage, 8848,
     /*  286208 */     GIR_EraseRootFromParent_Done,
     /*  286209 */   // Label 5398: @286209
     /*  286209 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(286272), // Rule ID 8849 //
     /*  286214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  286228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286253 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  286256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286270 */     GIR_RootConstrainSelectedInstOperands,
     /*  286271 */     // GIR_Coverage, 8849,
     /*  286271 */     GIR_EraseRootFromParent_Done,
     /*  286272 */   // Label 5399: @286272
     /*  286272 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(286335), // Rule ID 8852 //
     /*  286277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  286288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  286291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286316 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286333 */     GIR_RootConstrainSelectedInstOperands,
     /*  286334 */     // GIR_Coverage, 8852,
     /*  286334 */     GIR_EraseRootFromParent_Done,
     /*  286335 */   // Label 5400: @286335
     /*  286335 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(286398), // Rule ID 8853 //
     /*  286340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  286351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  286354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286379 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286396 */     GIR_RootConstrainSelectedInstOperands,
     /*  286397 */     // GIR_Coverage, 8853,
     /*  286397 */     GIR_EraseRootFromParent_Done,
     /*  286398 */   // Label 5401: @286398
     /*  286398 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(286461), // Rule ID 8856 //
     /*  286403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  286406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  286417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286442 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  286442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  286445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286459 */     GIR_RootConstrainSelectedInstOperands,
     /*  286460 */     // GIR_Coverage, 8856,
     /*  286460 */     GIR_EraseRootFromParent_Done,
     /*  286461 */   // Label 5402: @286461
     /*  286461 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(286524), // Rule ID 8857 //
     /*  286466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  286469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  286480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286505 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  286505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  286508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286522 */     GIR_RootConstrainSelectedInstOperands,
     /*  286523 */     // GIR_Coverage, 8857,
     /*  286523 */     GIR_EraseRootFromParent_Done,
     /*  286524 */   // Label 5403: @286524
     /*  286524 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(286587), // Rule ID 8860 //
     /*  286529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  286532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  286543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286568 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  286568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  286571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286585 */     GIR_RootConstrainSelectedInstOperands,
     /*  286586 */     // GIR_Coverage, 8860,
     /*  286586 */     GIR_EraseRootFromParent_Done,
     /*  286587 */   // Label 5404: @286587
     /*  286587 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(286650), // Rule ID 8861 //
     /*  286592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  286595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  286606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286631 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  286631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  286634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286648 */     GIR_RootConstrainSelectedInstOperands,
     /*  286649 */     // GIR_Coverage, 8861,
     /*  286649 */     GIR_EraseRootFromParent_Done,
     /*  286650 */   // Label 5405: @286650
     /*  286650 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(286713), // Rule ID 8864 //
     /*  286655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  286658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  286669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286694 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  286694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286711 */     GIR_RootConstrainSelectedInstOperands,
     /*  286712 */     // GIR_Coverage, 8864,
     /*  286712 */     GIR_EraseRootFromParent_Done,
     /*  286713 */   // Label 5406: @286713
     /*  286713 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(286776), // Rule ID 8865 //
     /*  286718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  286721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  286732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286757 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  286757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286774 */     GIR_RootConstrainSelectedInstOperands,
     /*  286775 */     // GIR_Coverage, 8865,
     /*  286775 */     GIR_EraseRootFromParent_Done,
     /*  286776 */   // Label 5407: @286776
     /*  286776 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(286839), // Rule ID 8956 //
     /*  286781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  286795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  286798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286820 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  286823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286837 */     GIR_RootConstrainSelectedInstOperands,
     /*  286838 */     // GIR_Coverage, 8956,
     /*  286838 */     GIR_EraseRootFromParent_Done,
     /*  286839 */   // Label 5408: @286839
     /*  286839 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(286902), // Rule ID 8957 //
     /*  286844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  286858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  286861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286883 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  286886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286900 */     GIR_RootConstrainSelectedInstOperands,
     /*  286901 */     // GIR_Coverage, 8957,
     /*  286901 */     GIR_EraseRootFromParent_Done,
     /*  286902 */   // Label 5409: @286902
     /*  286902 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(286965), // Rule ID 8960 //
     /*  286907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  286921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  286924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286946 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286963 */     GIR_RootConstrainSelectedInstOperands,
     /*  286964 */     // GIR_Coverage, 8960,
     /*  286964 */     GIR_EraseRootFromParent_Done,
     /*  286965 */   // Label 5410: @286965
     /*  286965 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(287028), // Rule ID 8961 //
     /*  286970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  286984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  286987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287009 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  287012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287026 */     GIR_RootConstrainSelectedInstOperands,
     /*  287027 */     // GIR_Coverage, 8961,
     /*  287027 */     GIR_EraseRootFromParent_Done,
     /*  287028 */   // Label 5411: @287028
     /*  287028 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(287091), // Rule ID 8964 //
     /*  287033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  287047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  287050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287072 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287089 */     GIR_RootConstrainSelectedInstOperands,
     /*  287090 */     // GIR_Coverage, 8964,
     /*  287090 */     GIR_EraseRootFromParent_Done,
     /*  287091 */   // Label 5412: @287091
     /*  287091 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(287154), // Rule ID 8965 //
     /*  287096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  287110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  287113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287135 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287152 */     GIR_RootConstrainSelectedInstOperands,
     /*  287153 */     // GIR_Coverage, 8965,
     /*  287153 */     GIR_EraseRootFromParent_Done,
     /*  287154 */   // Label 5413: @287154
     /*  287154 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(287217), // Rule ID 8968 //
     /*  287159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  287173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  287176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287198 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  287201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287215 */     GIR_RootConstrainSelectedInstOperands,
     /*  287216 */     // GIR_Coverage, 8968,
     /*  287216 */     GIR_EraseRootFromParent_Done,
     /*  287217 */   // Label 5414: @287217
     /*  287217 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(287280), // Rule ID 8969 //
     /*  287222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  287236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  287239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287261 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  287264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287278 */     GIR_RootConstrainSelectedInstOperands,
     /*  287279 */     // GIR_Coverage, 8969,
     /*  287279 */     GIR_EraseRootFromParent_Done,
     /*  287280 */   // Label 5415: @287280
     /*  287280 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(287343), // Rule ID 8972 //
     /*  287285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  287299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  287302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287324 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287341 */     GIR_RootConstrainSelectedInstOperands,
     /*  287342 */     // GIR_Coverage, 8972,
     /*  287342 */     GIR_EraseRootFromParent_Done,
     /*  287343 */   // Label 5416: @287343
     /*  287343 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(287406), // Rule ID 8973 //
     /*  287348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  287362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  287365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287387 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287404 */     GIR_RootConstrainSelectedInstOperands,
     /*  287405 */     // GIR_Coverage, 8973,
     /*  287405 */     GIR_EraseRootFromParent_Done,
     /*  287406 */   // Label 5417: @287406
     /*  287406 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(287469), // Rule ID 8976 //
     /*  287411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  287425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  287428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287450 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  287450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287467 */     GIR_RootConstrainSelectedInstOperands,
     /*  287468 */     // GIR_Coverage, 8976,
     /*  287468 */     GIR_EraseRootFromParent_Done,
     /*  287469 */   // Label 5418: @287469
     /*  287469 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(287532), // Rule ID 8977 //
     /*  287474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  287488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  287491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287513 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  287513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287530 */     GIR_RootConstrainSelectedInstOperands,
     /*  287531 */     // GIR_Coverage, 8977,
     /*  287531 */     GIR_EraseRootFromParent_Done,
     /*  287532 */   // Label 5419: @287532
     /*  287532 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(287595), // Rule ID 8980 //
     /*  287537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  287551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  287554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287576 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287593 */     GIR_RootConstrainSelectedInstOperands,
     /*  287594 */     // GIR_Coverage, 8980,
     /*  287594 */     GIR_EraseRootFromParent_Done,
     /*  287595 */   // Label 5420: @287595
     /*  287595 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(287658), // Rule ID 8981 //
     /*  287600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  287614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  287617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287639 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287656 */     GIR_RootConstrainSelectedInstOperands,
     /*  287657 */     // GIR_Coverage, 8981,
     /*  287657 */     GIR_EraseRootFromParent_Done,
     /*  287658 */   // Label 5421: @287658
     /*  287658 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(287721), // Rule ID 8984 //
     /*  287663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  287677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  287680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287702 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287719 */     GIR_RootConstrainSelectedInstOperands,
     /*  287720 */     // GIR_Coverage, 8984,
     /*  287720 */     GIR_EraseRootFromParent_Done,
     /*  287721 */   // Label 5422: @287721
     /*  287721 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(287784), // Rule ID 8985 //
     /*  287726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  287740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  287743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287765 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287782 */     GIR_RootConstrainSelectedInstOperands,
     /*  287783 */     // GIR_Coverage, 8985,
     /*  287783 */     GIR_EraseRootFromParent_Done,
     /*  287784 */   // Label 5423: @287784
     /*  287784 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(287847), // Rule ID 8988 //
     /*  287789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  287803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  287806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287828 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  287828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287845 */     GIR_RootConstrainSelectedInstOperands,
     /*  287846 */     // GIR_Coverage, 8988,
     /*  287846 */     GIR_EraseRootFromParent_Done,
     /*  287847 */   // Label 5424: @287847
     /*  287847 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(287910), // Rule ID 8989 //
     /*  287852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  287866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  287869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287891 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  287891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287908 */     GIR_RootConstrainSelectedInstOperands,
     /*  287909 */     // GIR_Coverage, 8989,
     /*  287909 */     GIR_EraseRootFromParent_Done,
     /*  287910 */   // Label 5425: @287910
     /*  287910 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(287973), // Rule ID 8992 //
     /*  287915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  287918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  287929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  287932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287954 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  287954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287971 */     GIR_RootConstrainSelectedInstOperands,
     /*  287972 */     // GIR_Coverage, 8992,
     /*  287972 */     GIR_EraseRootFromParent_Done,
     /*  287973 */   // Label 5426: @287973
     /*  287973 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(288036), // Rule ID 8993 //
     /*  287978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  287981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  287992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  287995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288017 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  288017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  288020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288034 */     GIR_RootConstrainSelectedInstOperands,
     /*  288035 */     // GIR_Coverage, 8993,
     /*  288035 */     GIR_EraseRootFromParent_Done,
     /*  288036 */   // Label 5427: @288036
     /*  288036 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(288099), // Rule ID 8996 //
     /*  288041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  288055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  288058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288080 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288097 */     GIR_RootConstrainSelectedInstOperands,
     /*  288098 */     // GIR_Coverage, 8996,
     /*  288098 */     GIR_EraseRootFromParent_Done,
     /*  288099 */   // Label 5428: @288099
     /*  288099 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(288162), // Rule ID 8997 //
     /*  288104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  288118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  288121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288143 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288160 */     GIR_RootConstrainSelectedInstOperands,
     /*  288161 */     // GIR_Coverage, 8997,
     /*  288161 */     GIR_EraseRootFromParent_Done,
     /*  288162 */   // Label 5429: @288162
     /*  288162 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(288225), // Rule ID 9000 //
     /*  288167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  288181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  288184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288206 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288223 */     GIR_RootConstrainSelectedInstOperands,
     /*  288224 */     // GIR_Coverage, 9000,
     /*  288224 */     GIR_EraseRootFromParent_Done,
     /*  288225 */   // Label 5430: @288225
     /*  288225 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(288288), // Rule ID 9001 //
     /*  288230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  288244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  288247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288269 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288286 */     GIR_RootConstrainSelectedInstOperands,
     /*  288287 */     // GIR_Coverage, 9001,
     /*  288287 */     GIR_EraseRootFromParent_Done,
     /*  288288 */   // Label 5431: @288288
     /*  288288 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(288351), // Rule ID 9004 //
     /*  288293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  288304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  288307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  288310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288332 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288349 */     GIR_RootConstrainSelectedInstOperands,
     /*  288350 */     // GIR_Coverage, 9004,
     /*  288350 */     GIR_EraseRootFromParent_Done,
     /*  288351 */   // Label 5432: @288351
     /*  288351 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(288414), // Rule ID 9005 //
     /*  288356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  288367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  288370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  288373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288395 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288412 */     GIR_RootConstrainSelectedInstOperands,
     /*  288413 */     // GIR_Coverage, 9005,
     /*  288413 */     GIR_EraseRootFromParent_Done,
     /*  288414 */   // Label 5433: @288414
     /*  288414 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(288477), // Rule ID 9008 //
     /*  288419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  288433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  288436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288458 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288475 */     GIR_RootConstrainSelectedInstOperands,
     /*  288476 */     // GIR_Coverage, 9008,
     /*  288476 */     GIR_EraseRootFromParent_Done,
     /*  288477 */   // Label 5434: @288477
     /*  288477 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(288540), // Rule ID 9009 //
     /*  288482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  288496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  288499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288521 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288538 */     GIR_RootConstrainSelectedInstOperands,
     /*  288539 */     // GIR_Coverage, 9009,
     /*  288539 */     GIR_EraseRootFromParent_Done,
     /*  288540 */   // Label 5435: @288540
     /*  288540 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(288603), // Rule ID 9012 //
     /*  288545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  288559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  288562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288584 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288601 */     GIR_RootConstrainSelectedInstOperands,
     /*  288602 */     // GIR_Coverage, 9012,
     /*  288602 */     GIR_EraseRootFromParent_Done,
     /*  288603 */   // Label 5436: @288603
     /*  288603 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(288666), // Rule ID 9013 //
     /*  288608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  288622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  288625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288647 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288664 */     GIR_RootConstrainSelectedInstOperands,
     /*  288665 */     // GIR_Coverage, 9013,
     /*  288665 */     GIR_EraseRootFromParent_Done,
     /*  288666 */   // Label 5437: @288666
     /*  288666 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(288729), // Rule ID 9016 //
     /*  288671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  288685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  288688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288710 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288727 */     GIR_RootConstrainSelectedInstOperands,
     /*  288728 */     // GIR_Coverage, 9016,
     /*  288728 */     GIR_EraseRootFromParent_Done,
     /*  288729 */   // Label 5438: @288729
     /*  288729 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(288792), // Rule ID 9017 //
     /*  288734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  288748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  288751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288773 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288790 */     GIR_RootConstrainSelectedInstOperands,
     /*  288791 */     // GIR_Coverage, 9017,
     /*  288791 */     GIR_EraseRootFromParent_Done,
     /*  288792 */   // Label 5439: @288792
     /*  288792 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(288855), // Rule ID 9020 //
     /*  288797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  288811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  288814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288853 */     GIR_RootConstrainSelectedInstOperands,
     /*  288854 */     // GIR_Coverage, 9020,
     /*  288854 */     GIR_EraseRootFromParent_Done,
     /*  288855 */   // Label 5440: @288855
     /*  288855 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(288918), // Rule ID 9021 //
     /*  288860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  288874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  288877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288899 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288916 */     GIR_RootConstrainSelectedInstOperands,
     /*  288917 */     // GIR_Coverage, 9021,
     /*  288917 */     GIR_EraseRootFromParent_Done,
     /*  288918 */   // Label 5441: @288918
     /*  288918 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(288981), // Rule ID 9024 //
     /*  288923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  288937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  288940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288962 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288979 */     GIR_RootConstrainSelectedInstOperands,
     /*  288980 */     // GIR_Coverage, 9024,
     /*  288980 */     GIR_EraseRootFromParent_Done,
     /*  288981 */   // Label 5442: @288981
     /*  288981 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(289044), // Rule ID 9025 //
     /*  288986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  289000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  289003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289025 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  289028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289042 */     GIR_RootConstrainSelectedInstOperands,
     /*  289043 */     // GIR_Coverage, 9025,
     /*  289043 */     GIR_EraseRootFromParent_Done,
     /*  289044 */   // Label 5443: @289044
     /*  289044 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(289107), // Rule ID 9028 //
     /*  289049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  289063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  289066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289088 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  289088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  289091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289105 */     GIR_RootConstrainSelectedInstOperands,
     /*  289106 */     // GIR_Coverage, 9028,
     /*  289106 */     GIR_EraseRootFromParent_Done,
     /*  289107 */   // Label 5444: @289107
     /*  289107 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(289170), // Rule ID 9029 //
     /*  289112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  289126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  289129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289151 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  289154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289168 */     GIR_RootConstrainSelectedInstOperands,
     /*  289169 */     // GIR_Coverage, 9029,
     /*  289169 */     GIR_EraseRootFromParent_Done,
     /*  289170 */   // Label 5445: @289170
     /*  289170 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(289233), // Rule ID 9032 //
     /*  289175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  289178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  289189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  289192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289214 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  289214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  289217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289231 */     GIR_RootConstrainSelectedInstOperands,
     /*  289232 */     // GIR_Coverage, 9032,
     /*  289232 */     GIR_EraseRootFromParent_Done,
     /*  289233 */   // Label 5446: @289233
     /*  289233 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(289296), // Rule ID 9033 //
     /*  289238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  289252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  289255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289277 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  289277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  289280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289294 */     GIR_RootConstrainSelectedInstOperands,
     /*  289295 */     // GIR_Coverage, 9033,
     /*  289295 */     GIR_EraseRootFromParent_Done,
     /*  289296 */   // Label 5447: @289296
     /*  289296 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(289359), // Rule ID 9036 //
     /*  289301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  289304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  289315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  289318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289340 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  289340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  289343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289357 */     GIR_RootConstrainSelectedInstOperands,
     /*  289358 */     // GIR_Coverage, 9036,
     /*  289358 */     GIR_EraseRootFromParent_Done,
     /*  289359 */   // Label 5448: @289359
     /*  289359 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(289422), // Rule ID 9037 //
     /*  289364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  289378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  289381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289403 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  289403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  289406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289420 */     GIR_RootConstrainSelectedInstOperands,
     /*  289421 */     // GIR_Coverage, 9037,
     /*  289421 */     GIR_EraseRootFromParent_Done,
     /*  289422 */   // Label 5449: @289422
     /*  289422 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(289485), // Rule ID 9040 //
     /*  289427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  289430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  289441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  289444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289466 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  289466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  289469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289483 */     GIR_RootConstrainSelectedInstOperands,
     /*  289484 */     // GIR_Coverage, 9040,
     /*  289484 */     GIR_EraseRootFromParent_Done,
     /*  289485 */   // Label 5450: @289485
     /*  289485 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(289548), // Rule ID 9041 //
     /*  289490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  289504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  289507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289529 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  289529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  289532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289546 */     GIR_RootConstrainSelectedInstOperands,
     /*  289547 */     // GIR_Coverage, 9041,
     /*  289547 */     GIR_EraseRootFromParent_Done,
     /*  289548 */   // Label 5451: @289548
     /*  289548 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(289611), // Rule ID 9044 //
     /*  289553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  289567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289592 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  289595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289609 */     GIR_RootConstrainSelectedInstOperands,
     /*  289610 */     // GIR_Coverage, 9044,
     /*  289610 */     GIR_EraseRootFromParent_Done,
     /*  289611 */   // Label 5452: @289611
     /*  289611 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(289674), // Rule ID 9045 //
     /*  289616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  289630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289655 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  289658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289672 */     GIR_RootConstrainSelectedInstOperands,
     /*  289673 */     // GIR_Coverage, 9045,
     /*  289673 */     GIR_EraseRootFromParent_Done,
     /*  289674 */   // Label 5453: @289674
     /*  289674 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(289737), // Rule ID 9048 //
     /*  289679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  289693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289718 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289735 */     GIR_RootConstrainSelectedInstOperands,
     /*  289736 */     // GIR_Coverage, 9048,
     /*  289736 */     GIR_EraseRootFromParent_Done,
     /*  289737 */   // Label 5454: @289737
     /*  289737 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(289800), // Rule ID 9049 //
     /*  289742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  289756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289781 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289798 */     GIR_RootConstrainSelectedInstOperands,
     /*  289799 */     // GIR_Coverage, 9049,
     /*  289799 */     GIR_EraseRootFromParent_Done,
     /*  289800 */   // Label 5455: @289800
     /*  289800 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(289863), // Rule ID 9052 //
     /*  289805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  289819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289861 */     GIR_RootConstrainSelectedInstOperands,
     /*  289862 */     // GIR_Coverage, 9052,
     /*  289862 */     GIR_EraseRootFromParent_Done,
     /*  289863 */   // Label 5456: @289863
     /*  289863 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(289926), // Rule ID 9053 //
     /*  289868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  289882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289907 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289924 */     GIR_RootConstrainSelectedInstOperands,
     /*  289925 */     // GIR_Coverage, 9053,
     /*  289925 */     GIR_EraseRootFromParent_Done,
     /*  289926 */   // Label 5457: @289926
     /*  289926 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(289989), // Rule ID 9056 //
     /*  289931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  289945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289970 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289987 */     GIR_RootConstrainSelectedInstOperands,
     /*  289988 */     // GIR_Coverage, 9056,
     /*  289988 */     GIR_EraseRootFromParent_Done,
     /*  289989 */   // Label 5458: @289989
     /*  289989 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(290052), // Rule ID 9057 //
     /*  289994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  290008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290033 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  290036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290050 */     GIR_RootConstrainSelectedInstOperands,
     /*  290051 */     // GIR_Coverage, 9057,
     /*  290051 */     GIR_EraseRootFromParent_Done,
     /*  290052 */   // Label 5459: @290052
     /*  290052 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(290115), // Rule ID 9060 //
     /*  290057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  290071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290096 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  290099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290113 */     GIR_RootConstrainSelectedInstOperands,
     /*  290114 */     // GIR_Coverage, 9060,
     /*  290114 */     GIR_EraseRootFromParent_Done,
     /*  290115 */   // Label 5460: @290115
     /*  290115 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(290178), // Rule ID 9061 //
     /*  290120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  290134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290159 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  290162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290176 */     GIR_RootConstrainSelectedInstOperands,
     /*  290177 */     // GIR_Coverage, 9061,
     /*  290177 */     GIR_EraseRootFromParent_Done,
     /*  290178 */   // Label 5461: @290178
     /*  290178 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(290241), // Rule ID 9064 //
     /*  290183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  290197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290222 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  290222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  290225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290239 */     GIR_RootConstrainSelectedInstOperands,
     /*  290240 */     // GIR_Coverage, 9064,
     /*  290240 */     GIR_EraseRootFromParent_Done,
     /*  290241 */   // Label 5462: @290241
     /*  290241 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(290304), // Rule ID 9065 //
     /*  290246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  290260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290285 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  290285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  290288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290302 */     GIR_RootConstrainSelectedInstOperands,
     /*  290303 */     // GIR_Coverage, 9065,
     /*  290303 */     GIR_EraseRootFromParent_Done,
     /*  290304 */   // Label 5463: @290304
     /*  290304 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(290367), // Rule ID 9068 //
     /*  290309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  290323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290348 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290365 */     GIR_RootConstrainSelectedInstOperands,
     /*  290366 */     // GIR_Coverage, 9068,
     /*  290366 */     GIR_EraseRootFromParent_Done,
     /*  290367 */   // Label 5464: @290367
     /*  290367 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(290430), // Rule ID 9069 //
     /*  290372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  290386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290411 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290428 */     GIR_RootConstrainSelectedInstOperands,
     /*  290429 */     // GIR_Coverage, 9069,
     /*  290429 */     GIR_EraseRootFromParent_Done,
     /*  290430 */   // Label 5465: @290430
     /*  290430 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(290493), // Rule ID 9072 //
     /*  290435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  290446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  290449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290474 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290491 */     GIR_RootConstrainSelectedInstOperands,
     /*  290492 */     // GIR_Coverage, 9072,
     /*  290492 */     GIR_EraseRootFromParent_Done,
     /*  290493 */   // Label 5466: @290493
     /*  290493 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(290556), // Rule ID 9073 //
     /*  290498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  290509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  290512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290537 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290554 */     GIR_RootConstrainSelectedInstOperands,
     /*  290555 */     // GIR_Coverage, 9073,
     /*  290555 */     GIR_EraseRootFromParent_Done,
     /*  290556 */   // Label 5467: @290556
     /*  290556 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(290619), // Rule ID 9076 //
     /*  290561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  290575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290600 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  290600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290617 */     GIR_RootConstrainSelectedInstOperands,
     /*  290618 */     // GIR_Coverage, 9076,
     /*  290618 */     GIR_EraseRootFromParent_Done,
     /*  290619 */   // Label 5468: @290619
     /*  290619 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(290682), // Rule ID 9077 //
     /*  290624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  290638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290663 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  290663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290680 */     GIR_RootConstrainSelectedInstOperands,
     /*  290681 */     // GIR_Coverage, 9077,
     /*  290681 */     GIR_EraseRootFromParent_Done,
     /*  290682 */   // Label 5469: @290682
     /*  290682 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(290745), // Rule ID 9080 //
     /*  290687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  290690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  290701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290726 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  290726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290743 */     GIR_RootConstrainSelectedInstOperands,
     /*  290744 */     // GIR_Coverage, 9080,
     /*  290744 */     GIR_EraseRootFromParent_Done,
     /*  290745 */   // Label 5470: @290745
     /*  290745 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(290808), // Rule ID 9081 //
     /*  290750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  290753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  290764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290789 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  290789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290806 */     GIR_RootConstrainSelectedInstOperands,
     /*  290807 */     // GIR_Coverage, 9081,
     /*  290807 */     GIR_EraseRootFromParent_Done,
     /*  290808 */   // Label 5471: @290808
     /*  290808 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(290871), // Rule ID 9084 //
     /*  290813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  290827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290852 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290869 */     GIR_RootConstrainSelectedInstOperands,
     /*  290870 */     // GIR_Coverage, 9084,
     /*  290870 */     GIR_EraseRootFromParent_Done,
     /*  290871 */   // Label 5472: @290871
     /*  290871 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(290934), // Rule ID 9085 //
     /*  290876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  290890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290915 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290932 */     GIR_RootConstrainSelectedInstOperands,
     /*  290933 */     // GIR_Coverage, 9085,
     /*  290933 */     GIR_EraseRootFromParent_Done,
     /*  290934 */   // Label 5473: @290934
     /*  290934 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(290997), // Rule ID 9088 //
     /*  290939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  290950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  290953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290978 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290995 */     GIR_RootConstrainSelectedInstOperands,
     /*  290996 */     // GIR_Coverage, 9088,
     /*  290996 */     GIR_EraseRootFromParent_Done,
     /*  290997 */   // Label 5474: @290997
     /*  290997 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(291060), // Rule ID 9089 //
     /*  291002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  291013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  291016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291041 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291058 */     GIR_RootConstrainSelectedInstOperands,
     /*  291059 */     // GIR_Coverage, 9089,
     /*  291059 */     GIR_EraseRootFromParent_Done,
     /*  291060 */   // Label 5475: @291060
     /*  291060 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(291123), // Rule ID 9092 //
     /*  291065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  291076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  291079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291104 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291121 */     GIR_RootConstrainSelectedInstOperands,
     /*  291122 */     // GIR_Coverage, 9092,
     /*  291122 */     GIR_EraseRootFromParent_Done,
     /*  291123 */   // Label 5476: @291123
     /*  291123 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(291186), // Rule ID 9093 //
     /*  291128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  291139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  291142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291167 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291184 */     GIR_RootConstrainSelectedInstOperands,
     /*  291185 */     // GIR_Coverage, 9093,
     /*  291185 */     GIR_EraseRootFromParent_Done,
     /*  291186 */   // Label 5477: @291186
     /*  291186 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(291249), // Rule ID 9096 //
     /*  291191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  291205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291230 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291247 */     GIR_RootConstrainSelectedInstOperands,
     /*  291248 */     // GIR_Coverage, 9096,
     /*  291248 */     GIR_EraseRootFromParent_Done,
     /*  291249 */   // Label 5478: @291249
     /*  291249 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(291312), // Rule ID 9097 //
     /*  291254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  291268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291293 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291310 */     GIR_RootConstrainSelectedInstOperands,
     /*  291311 */     // GIR_Coverage, 9097,
     /*  291311 */     GIR_EraseRootFromParent_Done,
     /*  291312 */   // Label 5479: @291312
     /*  291312 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(291375), // Rule ID 9100 //
     /*  291317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  291331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291356 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291373 */     GIR_RootConstrainSelectedInstOperands,
     /*  291374 */     // GIR_Coverage, 9100,
     /*  291374 */     GIR_EraseRootFromParent_Done,
     /*  291375 */   // Label 5480: @291375
     /*  291375 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(291438), // Rule ID 9101 //
     /*  291380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  291394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291419 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291436 */     GIR_RootConstrainSelectedInstOperands,
     /*  291437 */     // GIR_Coverage, 9101,
     /*  291437 */     GIR_EraseRootFromParent_Done,
     /*  291438 */   // Label 5481: @291438
     /*  291438 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(291501), // Rule ID 9104 //
     /*  291443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  291454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  291457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291482 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291499 */     GIR_RootConstrainSelectedInstOperands,
     /*  291500 */     // GIR_Coverage, 9104,
     /*  291500 */     GIR_EraseRootFromParent_Done,
     /*  291501 */   // Label 5482: @291501
     /*  291501 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(291564), // Rule ID 9105 //
     /*  291506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  291517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  291520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291545 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291562 */     GIR_RootConstrainSelectedInstOperands,
     /*  291563 */     // GIR_Coverage, 9105,
     /*  291563 */     GIR_EraseRootFromParent_Done,
     /*  291564 */   // Label 5483: @291564
     /*  291564 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(291627), // Rule ID 9108 //
     /*  291569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  291583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291625 */     GIR_RootConstrainSelectedInstOperands,
     /*  291626 */     // GIR_Coverage, 9108,
     /*  291626 */     GIR_EraseRootFromParent_Done,
     /*  291627 */   // Label 5484: @291627
     /*  291627 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(291690), // Rule ID 9109 //
     /*  291632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  291646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291671 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291688 */     GIR_RootConstrainSelectedInstOperands,
     /*  291689 */     // GIR_Coverage, 9109,
     /*  291689 */     GIR_EraseRootFromParent_Done,
     /*  291690 */   // Label 5485: @291690
     /*  291690 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(291753), // Rule ID 9112 //
     /*  291695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  291709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291734 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291751 */     GIR_RootConstrainSelectedInstOperands,
     /*  291752 */     // GIR_Coverage, 9112,
     /*  291752 */     GIR_EraseRootFromParent_Done,
     /*  291753 */   // Label 5486: @291753
     /*  291753 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(291816), // Rule ID 9113 //
     /*  291758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  291772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291797 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291814 */     GIR_RootConstrainSelectedInstOperands,
     /*  291815 */     // GIR_Coverage, 9113,
     /*  291815 */     GIR_EraseRootFromParent_Done,
     /*  291816 */   // Label 5487: @291816
     /*  291816 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(291879), // Rule ID 9116 //
     /*  291821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  291835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291860 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291877 */     GIR_RootConstrainSelectedInstOperands,
     /*  291878 */     // GIR_Coverage, 9116,
     /*  291878 */     GIR_EraseRootFromParent_Done,
     /*  291879 */   // Label 5488: @291879
     /*  291879 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(291942), // Rule ID 9117 //
     /*  291884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  291898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291923 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291940 */     GIR_RootConstrainSelectedInstOperands,
     /*  291941 */     // GIR_Coverage, 9117,
     /*  291941 */     GIR_EraseRootFromParent_Done,
     /*  291942 */   // Label 5489: @291942
     /*  291942 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(292005), // Rule ID 9120 //
     /*  291947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  291950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  291961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292003 */     GIR_RootConstrainSelectedInstOperands,
     /*  292004 */     // GIR_Coverage, 9120,
     /*  292004 */     GIR_EraseRootFromParent_Done,
     /*  292005 */   // Label 5490: @292005
     /*  292005 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(292068), // Rule ID 9121 //
     /*  292010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  292024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292049 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  292052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292066 */     GIR_RootConstrainSelectedInstOperands,
     /*  292067 */     // GIR_Coverage, 9121,
     /*  292067 */     GIR_EraseRootFromParent_Done,
     /*  292068 */   // Label 5491: @292068
     /*  292068 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(292131), // Rule ID 9124 //
     /*  292073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  292076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  292087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292112 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  292112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  292115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292129 */     GIR_RootConstrainSelectedInstOperands,
     /*  292130 */     // GIR_Coverage, 9124,
     /*  292130 */     GIR_EraseRootFromParent_Done,
     /*  292131 */   // Label 5492: @292131
     /*  292131 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(292194), // Rule ID 9125 //
     /*  292136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  292150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292175 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  292178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292192 */     GIR_RootConstrainSelectedInstOperands,
     /*  292193 */     // GIR_Coverage, 9125,
     /*  292193 */     GIR_EraseRootFromParent_Done,
     /*  292194 */   // Label 5493: @292194
     /*  292194 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(292257), // Rule ID 9128 //
     /*  292199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  292202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  292213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292238 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  292238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  292241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292255 */     GIR_RootConstrainSelectedInstOperands,
     /*  292256 */     // GIR_Coverage, 9128,
     /*  292256 */     GIR_EraseRootFromParent_Done,
     /*  292257 */   // Label 5494: @292257
     /*  292257 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(292320), // Rule ID 9129 //
     /*  292262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  292276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292301 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  292304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292318 */     GIR_RootConstrainSelectedInstOperands,
     /*  292319 */     // GIR_Coverage, 9129,
     /*  292319 */     GIR_EraseRootFromParent_Done,
     /*  292320 */   // Label 5495: @292320
     /*  292320 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(292383), // Rule ID 9220 //
     /*  292325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  292339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292364 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  292367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292381 */     GIR_RootConstrainSelectedInstOperands,
     /*  292382 */     // GIR_Coverage, 9220,
     /*  292382 */     GIR_EraseRootFromParent_Done,
     /*  292383 */   // Label 5496: @292383
     /*  292383 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(292446), // Rule ID 9221 //
     /*  292388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  292402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292427 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  292430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292444 */     GIR_RootConstrainSelectedInstOperands,
     /*  292445 */     // GIR_Coverage, 9221,
     /*  292445 */     GIR_EraseRootFromParent_Done,
     /*  292446 */   // Label 5497: @292446
     /*  292446 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(292509), // Rule ID 9224 //
     /*  292451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  292465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292490 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292507 */     GIR_RootConstrainSelectedInstOperands,
     /*  292508 */     // GIR_Coverage, 9224,
     /*  292508 */     GIR_EraseRootFromParent_Done,
     /*  292509 */   // Label 5498: @292509
     /*  292509 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(292572), // Rule ID 9225 //
     /*  292514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  292528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292553 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292570 */     GIR_RootConstrainSelectedInstOperands,
     /*  292571 */     // GIR_Coverage, 9225,
     /*  292571 */     GIR_EraseRootFromParent_Done,
     /*  292572 */   // Label 5499: @292572
     /*  292572 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(292635), // Rule ID 9228 //
     /*  292577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  292591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292616 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292633 */     GIR_RootConstrainSelectedInstOperands,
     /*  292634 */     // GIR_Coverage, 9228,
     /*  292634 */     GIR_EraseRootFromParent_Done,
     /*  292635 */   // Label 5500: @292635
     /*  292635 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(292698), // Rule ID 9229 //
     /*  292640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  292654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292679 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292696 */     GIR_RootConstrainSelectedInstOperands,
     /*  292697 */     // GIR_Coverage, 9229,
     /*  292697 */     GIR_EraseRootFromParent_Done,
     /*  292698 */   // Label 5501: @292698
     /*  292698 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(292761), // Rule ID 9232 //
     /*  292703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  292717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292742 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292759 */     GIR_RootConstrainSelectedInstOperands,
     /*  292760 */     // GIR_Coverage, 9232,
     /*  292760 */     GIR_EraseRootFromParent_Done,
     /*  292761 */   // Label 5502: @292761
     /*  292761 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(292824), // Rule ID 9233 //
     /*  292766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  292780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292805 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292822 */     GIR_RootConstrainSelectedInstOperands,
     /*  292823 */     // GIR_Coverage, 9233,
     /*  292823 */     GIR_EraseRootFromParent_Done,
     /*  292824 */   // Label 5503: @292824
     /*  292824 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(292887), // Rule ID 9236 //
     /*  292829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  292843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292868 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292885 */     GIR_RootConstrainSelectedInstOperands,
     /*  292886 */     // GIR_Coverage, 9236,
     /*  292886 */     GIR_EraseRootFromParent_Done,
     /*  292887 */   // Label 5504: @292887
     /*  292887 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(292950), // Rule ID 9237 //
     /*  292892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  292906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292931 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292948 */     GIR_RootConstrainSelectedInstOperands,
     /*  292949 */     // GIR_Coverage, 9237,
     /*  292949 */     GIR_EraseRootFromParent_Done,
     /*  292950 */   // Label 5505: @292950
     /*  292950 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(293013), // Rule ID 9240 //
     /*  292955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  292969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292994 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293011 */     GIR_RootConstrainSelectedInstOperands,
     /*  293012 */     // GIR_Coverage, 9240,
     /*  293012 */     GIR_EraseRootFromParent_Done,
     /*  293013 */   // Label 5506: @293013
     /*  293013 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(293076), // Rule ID 9241 //
     /*  293018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  293032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293057 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  293057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  293060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293074 */     GIR_RootConstrainSelectedInstOperands,
     /*  293075 */     // GIR_Coverage, 9241,
     /*  293075 */     GIR_EraseRootFromParent_Done,
     /*  293076 */   // Label 5507: @293076
     /*  293076 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(293139), // Rule ID 9244 //
     /*  293081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  293095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293120 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293137 */     GIR_RootConstrainSelectedInstOperands,
     /*  293138 */     // GIR_Coverage, 9244,
     /*  293138 */     GIR_EraseRootFromParent_Done,
     /*  293139 */   // Label 5508: @293139
     /*  293139 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(293202), // Rule ID 9245 //
     /*  293144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  293158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293183 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293200 */     GIR_RootConstrainSelectedInstOperands,
     /*  293201 */     // GIR_Coverage, 9245,
     /*  293201 */     GIR_EraseRootFromParent_Done,
     /*  293202 */   // Label 5509: @293202
     /*  293202 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(293265), // Rule ID 9248 //
     /*  293207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  293221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293246 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293263 */     GIR_RootConstrainSelectedInstOperands,
     /*  293264 */     // GIR_Coverage, 9248,
     /*  293264 */     GIR_EraseRootFromParent_Done,
     /*  293265 */   // Label 5510: @293265
     /*  293265 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(293328), // Rule ID 9249 //
     /*  293270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  293284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293309 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293326 */     GIR_RootConstrainSelectedInstOperands,
     /*  293327 */     // GIR_Coverage, 9249,
     /*  293327 */     GIR_EraseRootFromParent_Done,
     /*  293328 */   // Label 5511: @293328
     /*  293328 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(293391), // Rule ID 9252 //
     /*  293333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  293347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293372 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  293372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293389 */     GIR_RootConstrainSelectedInstOperands,
     /*  293390 */     // GIR_Coverage, 9252,
     /*  293390 */     GIR_EraseRootFromParent_Done,
     /*  293391 */   // Label 5512: @293391
     /*  293391 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(293454), // Rule ID 9253 //
     /*  293396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  293410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293435 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  293435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293452 */     GIR_RootConstrainSelectedInstOperands,
     /*  293453 */     // GIR_Coverage, 9253,
     /*  293453 */     GIR_EraseRootFromParent_Done,
     /*  293454 */   // Label 5513: @293454
     /*  293454 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(293517), // Rule ID 9256 //
     /*  293459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  293462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  293473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293498 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  293498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  293515 */     GIR_RootConstrainSelectedInstOperands,
     /*  293516 */     // GIR_Coverage, 9256,
     /*  293516 */     GIR_EraseRootFromParent_Done,
     /*  293517 */   // Label 5514: @293517
     /*  293517 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(293580), // Rule ID 9257 //
     /*  293522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  293525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  293536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293561 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  293561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  293578 */     GIR_RootConstrainSelectedInstOperands,
     /*  293579 */     // GIR_Coverage, 9257,
     /*  293579 */     GIR_EraseRootFromParent_Done,
     /*  293580 */   // Label 5515: @293580
     /*  293580 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(293643), // Rule ID 9260 //
     /*  293585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  293599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293624 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293641 */     GIR_RootConstrainSelectedInstOperands,
     /*  293642 */     // GIR_Coverage, 9260,
     /*  293642 */     GIR_EraseRootFromParent_Done,
     /*  293643 */   // Label 5516: @293643
     /*  293643 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(293706), // Rule ID 9261 //
     /*  293648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  293662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293687 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293704 */     GIR_RootConstrainSelectedInstOperands,
     /*  293705 */     // GIR_Coverage, 9261,
     /*  293705 */     GIR_EraseRootFromParent_Done,
     /*  293706 */   // Label 5517: @293706
     /*  293706 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(293769), // Rule ID 9264 //
     /*  293711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  293725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293750 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293767 */     GIR_RootConstrainSelectedInstOperands,
     /*  293768 */     // GIR_Coverage, 9264,
     /*  293768 */     GIR_EraseRootFromParent_Done,
     /*  293769 */   // Label 5518: @293769
     /*  293769 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(293832), // Rule ID 9265 //
     /*  293774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  293788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293813 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293830 */     GIR_RootConstrainSelectedInstOperands,
     /*  293831 */     // GIR_Coverage, 9265,
     /*  293831 */     GIR_EraseRootFromParent_Done,
     /*  293832 */   // Label 5519: @293832
     /*  293832 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(293895), // Rule ID 9268 //
     /*  293837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  293848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  293851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293876 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293893 */     GIR_RootConstrainSelectedInstOperands,
     /*  293894 */     // GIR_Coverage, 9268,
     /*  293894 */     GIR_EraseRootFromParent_Done,
     /*  293895 */   // Label 5520: @293895
     /*  293895 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(293958), // Rule ID 9269 //
     /*  293900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  293911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  293914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293939 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293956 */     GIR_RootConstrainSelectedInstOperands,
     /*  293957 */     // GIR_Coverage, 9269,
     /*  293957 */     GIR_EraseRootFromParent_Done,
     /*  293958 */   // Label 5521: @293958
     /*  293958 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(294021), // Rule ID 9272 //
     /*  293963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  293977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294002 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294019 */     GIR_RootConstrainSelectedInstOperands,
     /*  294020 */     // GIR_Coverage, 9272,
     /*  294020 */     GIR_EraseRootFromParent_Done,
     /*  294021 */   // Label 5522: @294021
     /*  294021 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(294084), // Rule ID 9273 //
     /*  294026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  294040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294065 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294082 */     GIR_RootConstrainSelectedInstOperands,
     /*  294083 */     // GIR_Coverage, 9273,
     /*  294083 */     GIR_EraseRootFromParent_Done,
     /*  294084 */   // Label 5523: @294084
     /*  294084 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(294147), // Rule ID 9276 //
     /*  294089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  294103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294128 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294145 */     GIR_RootConstrainSelectedInstOperands,
     /*  294146 */     // GIR_Coverage, 9276,
     /*  294146 */     GIR_EraseRootFromParent_Done,
     /*  294147 */   // Label 5524: @294147
     /*  294147 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(294210), // Rule ID 9277 //
     /*  294152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  294166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294191 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294208 */     GIR_RootConstrainSelectedInstOperands,
     /*  294209 */     // GIR_Coverage, 9277,
     /*  294209 */     GIR_EraseRootFromParent_Done,
     /*  294210 */   // Label 5525: @294210
     /*  294210 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(294273), // Rule ID 9280 //
     /*  294215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  294226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  294229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294254 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294271 */     GIR_RootConstrainSelectedInstOperands,
     /*  294272 */     // GIR_Coverage, 9280,
     /*  294272 */     GIR_EraseRootFromParent_Done,
     /*  294273 */   // Label 5526: @294273
     /*  294273 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(294336), // Rule ID 9281 //
     /*  294278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  294289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  294292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294317 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294334 */     GIR_RootConstrainSelectedInstOperands,
     /*  294335 */     // GIR_Coverage, 9281,
     /*  294335 */     GIR_EraseRootFromParent_Done,
     /*  294336 */   // Label 5527: @294336
     /*  294336 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(294399), // Rule ID 9284 //
     /*  294341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  294355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294380 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294397 */     GIR_RootConstrainSelectedInstOperands,
     /*  294398 */     // GIR_Coverage, 9284,
     /*  294398 */     GIR_EraseRootFromParent_Done,
     /*  294399 */   // Label 5528: @294399
     /*  294399 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(294462), // Rule ID 9285 //
     /*  294404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  294418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294443 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294460 */     GIR_RootConstrainSelectedInstOperands,
     /*  294461 */     // GIR_Coverage, 9285,
     /*  294461 */     GIR_EraseRootFromParent_Done,
     /*  294462 */   // Label 5529: @294462
     /*  294462 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(294525), // Rule ID 9288 //
     /*  294467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  294481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294506 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294523 */     GIR_RootConstrainSelectedInstOperands,
     /*  294524 */     // GIR_Coverage, 9288,
     /*  294524 */     GIR_EraseRootFromParent_Done,
     /*  294525 */   // Label 5530: @294525
     /*  294525 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(294588), // Rule ID 9289 //
     /*  294530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  294544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294569 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294586 */     GIR_RootConstrainSelectedInstOperands,
     /*  294587 */     // GIR_Coverage, 9289,
     /*  294587 */     GIR_EraseRootFromParent_Done,
     /*  294588 */   // Label 5531: @294588
     /*  294588 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(294651), // Rule ID 9292 //
     /*  294593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  294607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294632 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294649 */     GIR_RootConstrainSelectedInstOperands,
     /*  294650 */     // GIR_Coverage, 9292,
     /*  294650 */     GIR_EraseRootFromParent_Done,
     /*  294651 */   // Label 5532: @294651
     /*  294651 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(294714), // Rule ID 9293 //
     /*  294656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  294670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294695 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294712 */     GIR_RootConstrainSelectedInstOperands,
     /*  294713 */     // GIR_Coverage, 9293,
     /*  294713 */     GIR_EraseRootFromParent_Done,
     /*  294714 */   // Label 5533: @294714
     /*  294714 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(294777), // Rule ID 9296 //
     /*  294719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  294733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294758 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294775 */     GIR_RootConstrainSelectedInstOperands,
     /*  294776 */     // GIR_Coverage, 9296,
     /*  294776 */     GIR_EraseRootFromParent_Done,
     /*  294777 */   // Label 5534: @294777
     /*  294777 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(294840), // Rule ID 9297 //
     /*  294782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  294796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294821 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294838 */     GIR_RootConstrainSelectedInstOperands,
     /*  294839 */     // GIR_Coverage, 9297,
     /*  294839 */     GIR_EraseRootFromParent_Done,
     /*  294840 */   // Label 5535: @294840
     /*  294840 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(294903), // Rule ID 9300 //
     /*  294845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  294859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294884 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294901 */     GIR_RootConstrainSelectedInstOperands,
     /*  294902 */     // GIR_Coverage, 9300,
     /*  294902 */     GIR_EraseRootFromParent_Done,
     /*  294903 */   // Label 5536: @294903
     /*  294903 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(294966), // Rule ID 9301 //
     /*  294908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  294922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294947 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294964 */     GIR_RootConstrainSelectedInstOperands,
     /*  294965 */     // GIR_Coverage, 9301,
     /*  294965 */     GIR_EraseRootFromParent_Done,
     /*  294966 */   // Label 5537: @294966
     /*  294966 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(295029), // Rule ID 9304 //
     /*  294971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  294985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295010 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  295010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  295013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295027 */     GIR_RootConstrainSelectedInstOperands,
     /*  295028 */     // GIR_Coverage, 9304,
     /*  295028 */     GIR_EraseRootFromParent_Done,
     /*  295029 */   // Label 5538: @295029
     /*  295029 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(295092), // Rule ID 9305 //
     /*  295034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  295037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  295042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  295048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295073 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  295073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  295076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295090 */     GIR_RootConstrainSelectedInstOperands,
     /*  295091 */     // GIR_Coverage, 9305,
     /*  295091 */     GIR_EraseRootFromParent_Done,
     /*  295092 */   // Label 5539: @295092
     /*  295092 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(295155), // Rule ID 9396 //
     /*  295097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  295111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295136 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  295139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295153 */     GIR_RootConstrainSelectedInstOperands,
     /*  295154 */     // GIR_Coverage, 9396,
     /*  295154 */     GIR_EraseRootFromParent_Done,
     /*  295155 */   // Label 5540: @295155
     /*  295155 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(295218), // Rule ID 9397 //
     /*  295160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  295174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295199 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  295202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295216 */     GIR_RootConstrainSelectedInstOperands,
     /*  295217 */     // GIR_Coverage, 9397,
     /*  295217 */     GIR_EraseRootFromParent_Done,
     /*  295218 */   // Label 5541: @295218
     /*  295218 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(295281), // Rule ID 9400 //
     /*  295223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  295237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295262 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  295265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295279 */     GIR_RootConstrainSelectedInstOperands,
     /*  295280 */     // GIR_Coverage, 9400,
     /*  295280 */     GIR_EraseRootFromParent_Done,
     /*  295281 */   // Label 5542: @295281
     /*  295281 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(295344), // Rule ID 9401 //
     /*  295286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  295300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295325 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  295328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295342 */     GIR_RootConstrainSelectedInstOperands,
     /*  295343 */     // GIR_Coverage, 9401,
     /*  295343 */     GIR_EraseRootFromParent_Done,
     /*  295344 */   // Label 5543: @295344
     /*  295344 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(295407), // Rule ID 9404 //
     /*  295349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  295363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295388 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295405 */     GIR_RootConstrainSelectedInstOperands,
     /*  295406 */     // GIR_Coverage, 9404,
     /*  295406 */     GIR_EraseRootFromParent_Done,
     /*  295407 */   // Label 5544: @295407
     /*  295407 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(295470), // Rule ID 9405 //
     /*  295412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  295426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295451 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295468 */     GIR_RootConstrainSelectedInstOperands,
     /*  295469 */     // GIR_Coverage, 9405,
     /*  295469 */     GIR_EraseRootFromParent_Done,
     /*  295470 */   // Label 5545: @295470
     /*  295470 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(295533), // Rule ID 9408 //
     /*  295475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  295489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295514 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  295517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295531 */     GIR_RootConstrainSelectedInstOperands,
     /*  295532 */     // GIR_Coverage, 9408,
     /*  295532 */     GIR_EraseRootFromParent_Done,
     /*  295533 */   // Label 5546: @295533
     /*  295533 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(295596), // Rule ID 9409 //
     /*  295538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  295552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295577 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  295580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295594 */     GIR_RootConstrainSelectedInstOperands,
     /*  295595 */     // GIR_Coverage, 9409,
     /*  295595 */     GIR_EraseRootFromParent_Done,
     /*  295596 */   // Label 5547: @295596
     /*  295596 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(295659), // Rule ID 9412 //
     /*  295601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  295615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295640 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295657 */     GIR_RootConstrainSelectedInstOperands,
     /*  295658 */     // GIR_Coverage, 9412,
     /*  295658 */     GIR_EraseRootFromParent_Done,
     /*  295659 */   // Label 5548: @295659
     /*  295659 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(295722), // Rule ID 9413 //
     /*  295664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  295678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295703 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295720 */     GIR_RootConstrainSelectedInstOperands,
     /*  295721 */     // GIR_Coverage, 9413,
     /*  295721 */     GIR_EraseRootFromParent_Done,
     /*  295722 */   // Label 5549: @295722
     /*  295722 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(295785), // Rule ID 9416 //
     /*  295727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  295741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295766 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295783 */     GIR_RootConstrainSelectedInstOperands,
     /*  295784 */     // GIR_Coverage, 9416,
     /*  295784 */     GIR_EraseRootFromParent_Done,
     /*  295785 */   // Label 5550: @295785
     /*  295785 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(295848), // Rule ID 9417 //
     /*  295790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  295804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295829 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295846 */     GIR_RootConstrainSelectedInstOperands,
     /*  295847 */     // GIR_Coverage, 9417,
     /*  295847 */     GIR_EraseRootFromParent_Done,
     /*  295848 */   // Label 5551: @295848
     /*  295848 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(295911), // Rule ID 9420 //
     /*  295853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  295867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295892 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295909 */     GIR_RootConstrainSelectedInstOperands,
     /*  295910 */     // GIR_Coverage, 9420,
     /*  295910 */     GIR_EraseRootFromParent_Done,
     /*  295911 */   // Label 5552: @295911
     /*  295911 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(295974), // Rule ID 9421 //
     /*  295916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  295930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295955 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295972 */     GIR_RootConstrainSelectedInstOperands,
     /*  295973 */     // GIR_Coverage, 9421,
     /*  295973 */     GIR_EraseRootFromParent_Done,
     /*  295974 */   // Label 5553: @295974
     /*  295974 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(296037), // Rule ID 9424 //
     /*  295979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  295993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296018 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  296021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296035 */     GIR_RootConstrainSelectedInstOperands,
     /*  296036 */     // GIR_Coverage, 9424,
     /*  296036 */     GIR_EraseRootFromParent_Done,
     /*  296037 */   // Label 5554: @296037
     /*  296037 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(296100), // Rule ID 9425 //
     /*  296042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  296056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296081 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  296084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296098 */     GIR_RootConstrainSelectedInstOperands,
     /*  296099 */     // GIR_Coverage, 9425,
     /*  296099 */     GIR_EraseRootFromParent_Done,
     /*  296100 */   // Label 5555: @296100
     /*  296100 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(296163), // Rule ID 9428 //
     /*  296105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  296119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296144 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  296147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296161 */     GIR_RootConstrainSelectedInstOperands,
     /*  296162 */     // GIR_Coverage, 9428,
     /*  296162 */     GIR_EraseRootFromParent_Done,
     /*  296163 */   // Label 5556: @296163
     /*  296163 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(296226), // Rule ID 9429 //
     /*  296168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  296182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296207 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  296210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296224 */     GIR_RootConstrainSelectedInstOperands,
     /*  296225 */     // GIR_Coverage, 9429,
     /*  296225 */     GIR_EraseRootFromParent_Done,
     /*  296226 */   // Label 5557: @296226
     /*  296226 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(296289), // Rule ID 9432 //
     /*  296231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  296234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  296245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296270 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  296270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  296273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296287 */     GIR_RootConstrainSelectedInstOperands,
     /*  296288 */     // GIR_Coverage, 9432,
     /*  296288 */     GIR_EraseRootFromParent_Done,
     /*  296289 */   // Label 5558: @296289
     /*  296289 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(296352), // Rule ID 9433 //
     /*  296294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  296297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  296308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296333 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  296333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  296336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296350 */     GIR_RootConstrainSelectedInstOperands,
     /*  296351 */     // GIR_Coverage, 9433,
     /*  296351 */     GIR_EraseRootFromParent_Done,
     /*  296352 */   // Label 5559: @296352
     /*  296352 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(296415), // Rule ID 9436 //
     /*  296357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  296371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296396 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296413 */     GIR_RootConstrainSelectedInstOperands,
     /*  296414 */     // GIR_Coverage, 9436,
     /*  296414 */     GIR_EraseRootFromParent_Done,
     /*  296415 */   // Label 5560: @296415
     /*  296415 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(296478), // Rule ID 9437 //
     /*  296420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  296434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296459 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296476 */     GIR_RootConstrainSelectedInstOperands,
     /*  296477 */     // GIR_Coverage, 9437,
     /*  296477 */     GIR_EraseRootFromParent_Done,
     /*  296478 */   // Label 5561: @296478
     /*  296478 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(296541), // Rule ID 9440 //
     /*  296483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  296497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296522 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296539 */     GIR_RootConstrainSelectedInstOperands,
     /*  296540 */     // GIR_Coverage, 9440,
     /*  296540 */     GIR_EraseRootFromParent_Done,
     /*  296541 */   // Label 5562: @296541
     /*  296541 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(296604), // Rule ID 9441 //
     /*  296546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  296560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296585 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296602 */     GIR_RootConstrainSelectedInstOperands,
     /*  296603 */     // GIR_Coverage, 9441,
     /*  296603 */     GIR_EraseRootFromParent_Done,
     /*  296604 */   // Label 5563: @296604
     /*  296604 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(296667), // Rule ID 9444 //
     /*  296609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  296620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  296623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296648 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296665 */     GIR_RootConstrainSelectedInstOperands,
     /*  296666 */     // GIR_Coverage, 9444,
     /*  296666 */     GIR_EraseRootFromParent_Done,
     /*  296667 */   // Label 5564: @296667
     /*  296667 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(296730), // Rule ID 9445 //
     /*  296672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  296683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  296686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296711 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296728 */     GIR_RootConstrainSelectedInstOperands,
     /*  296729 */     // GIR_Coverage, 9445,
     /*  296729 */     GIR_EraseRootFromParent_Done,
     /*  296730 */   // Label 5565: @296730
     /*  296730 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(296793), // Rule ID 9448 //
     /*  296735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  296749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296774 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296791 */     GIR_RootConstrainSelectedInstOperands,
     /*  296792 */     // GIR_Coverage, 9448,
     /*  296792 */     GIR_EraseRootFromParent_Done,
     /*  296793 */   // Label 5566: @296793
     /*  296793 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(296856), // Rule ID 9449 //
     /*  296798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  296812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296837 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296854 */     GIR_RootConstrainSelectedInstOperands,
     /*  296855 */     // GIR_Coverage, 9449,
     /*  296855 */     GIR_EraseRootFromParent_Done,
     /*  296856 */   // Label 5567: @296856
     /*  296856 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(296919), // Rule ID 9452 //
     /*  296861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  296875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296900 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296917 */     GIR_RootConstrainSelectedInstOperands,
     /*  296918 */     // GIR_Coverage, 9452,
     /*  296918 */     GIR_EraseRootFromParent_Done,
     /*  296919 */   // Label 5568: @296919
     /*  296919 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(296982), // Rule ID 9453 //
     /*  296924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  296938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296963 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296980 */     GIR_RootConstrainSelectedInstOperands,
     /*  296981 */     // GIR_Coverage, 9453,
     /*  296981 */     GIR_EraseRootFromParent_Done,
     /*  296982 */   // Label 5569: @296982
     /*  296982 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(297045), // Rule ID 9456 //
     /*  296987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  297001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297026 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297043 */     GIR_RootConstrainSelectedInstOperands,
     /*  297044 */     // GIR_Coverage, 9456,
     /*  297044 */     GIR_EraseRootFromParent_Done,
     /*  297045 */   // Label 5570: @297045
     /*  297045 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(297108), // Rule ID 9457 //
     /*  297050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  297061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  297064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297089 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297106 */     GIR_RootConstrainSelectedInstOperands,
     /*  297107 */     // GIR_Coverage, 9457,
     /*  297107 */     GIR_EraseRootFromParent_Done,
     /*  297108 */   // Label 5571: @297108
     /*  297108 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(297171), // Rule ID 9460 //
     /*  297113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  297127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297152 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  297155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297169 */     GIR_RootConstrainSelectedInstOperands,
     /*  297170 */     // GIR_Coverage, 9460,
     /*  297170 */     GIR_EraseRootFromParent_Done,
     /*  297171 */   // Label 5572: @297171
     /*  297171 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(297234), // Rule ID 9461 //
     /*  297176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  297190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297215 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  297218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297232 */     GIR_RootConstrainSelectedInstOperands,
     /*  297233 */     // GIR_Coverage, 9461,
     /*  297233 */     GIR_EraseRootFromParent_Done,
     /*  297234 */   // Label 5573: @297234
     /*  297234 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(297297), // Rule ID 9464 //
     /*  297239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  297253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297278 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  297281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297295 */     GIR_RootConstrainSelectedInstOperands,
     /*  297296 */     // GIR_Coverage, 9464,
     /*  297296 */     GIR_EraseRootFromParent_Done,
     /*  297297 */   // Label 5574: @297297
     /*  297297 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(297360), // Rule ID 9465 //
     /*  297302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  297316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297341 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  297344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297358 */     GIR_RootConstrainSelectedInstOperands,
     /*  297359 */     // GIR_Coverage, 9465,
     /*  297359 */     GIR_EraseRootFromParent_Done,
     /*  297360 */   // Label 5575: @297360
     /*  297360 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(297423), // Rule ID 9468 //
     /*  297365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  297376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  297379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297404 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297421 */     GIR_RootConstrainSelectedInstOperands,
     /*  297422 */     // GIR_Coverage, 9468,
     /*  297422 */     GIR_EraseRootFromParent_Done,
     /*  297423 */   // Label 5576: @297423
     /*  297423 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(297486), // Rule ID 9469 //
     /*  297428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  297439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  297442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297467 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297484 */     GIR_RootConstrainSelectedInstOperands,
     /*  297485 */     // GIR_Coverage, 9469,
     /*  297485 */     GIR_EraseRootFromParent_Done,
     /*  297486 */   // Label 5577: @297486
     /*  297486 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(297549), // Rule ID 9472 //
     /*  297491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  297505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297530 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  297533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297547 */     GIR_RootConstrainSelectedInstOperands,
     /*  297548 */     // GIR_Coverage, 9472,
     /*  297548 */     GIR_EraseRootFromParent_Done,
     /*  297549 */   // Label 5578: @297549
     /*  297549 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(297612), // Rule ID 9473 //
     /*  297554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  297568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297593 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  297596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297610 */     GIR_RootConstrainSelectedInstOperands,
     /*  297611 */     // GIR_Coverage, 9473,
     /*  297611 */     GIR_EraseRootFromParent_Done,
     /*  297612 */   // Label 5579: @297612
     /*  297612 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(297675), // Rule ID 9476 //
     /*  297617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  297631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297656 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  297659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297673 */     GIR_RootConstrainSelectedInstOperands,
     /*  297674 */     // GIR_Coverage, 9476,
     /*  297674 */     GIR_EraseRootFromParent_Done,
     /*  297675 */   // Label 5580: @297675
     /*  297675 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(297738), // Rule ID 9477 //
     /*  297680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  297694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297719 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  297722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297736 */     GIR_RootConstrainSelectedInstOperands,
     /*  297737 */     // GIR_Coverage, 9477,
     /*  297737 */     GIR_EraseRootFromParent_Done,
     /*  297738 */   // Label 5581: @297738
     /*  297738 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(297801), // Rule ID 9480 //
     /*  297743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  297757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297799 */     GIR_RootConstrainSelectedInstOperands,
     /*  297800 */     // GIR_Coverage, 9480,
     /*  297800 */     GIR_EraseRootFromParent_Done,
     /*  297801 */   // Label 5582: @297801
     /*  297801 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(297864), // Rule ID 9481 //
     /*  297806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  297820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297845 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297862 */     GIR_RootConstrainSelectedInstOperands,
     /*  297863 */     // GIR_Coverage, 9481,
     /*  297863 */     GIR_EraseRootFromParent_Done,
     /*  297864 */   // Label 5583: @297864
     /*  297864 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(297927), // Rule ID 9572 //
     /*  297869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  297883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  297886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297908 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297925 */     GIR_RootConstrainSelectedInstOperands,
     /*  297926 */     // GIR_Coverage, 9572,
     /*  297926 */     GIR_EraseRootFromParent_Done,
     /*  297927 */   // Label 5584: @297927
     /*  297927 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(297990), // Rule ID 9573 //
     /*  297932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  297946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  297949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297971 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297988 */     GIR_RootConstrainSelectedInstOperands,
     /*  297989 */     // GIR_Coverage, 9573,
     /*  297989 */     GIR_EraseRootFromParent_Done,
     /*  297990 */   // Label 5585: @297990
     /*  297990 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(298053), // Rule ID 9576 //
     /*  297995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  298009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  298012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298034 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298051 */     GIR_RootConstrainSelectedInstOperands,
     /*  298052 */     // GIR_Coverage, 9576,
     /*  298052 */     GIR_EraseRootFromParent_Done,
     /*  298053 */   // Label 5586: @298053
     /*  298053 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(298116), // Rule ID 9577 //
     /*  298058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  298072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  298075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298097 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298114 */     GIR_RootConstrainSelectedInstOperands,
     /*  298115 */     // GIR_Coverage, 9577,
     /*  298115 */     GIR_EraseRootFromParent_Done,
     /*  298116 */   // Label 5587: @298116
     /*  298116 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(298179), // Rule ID 9580 //
     /*  298121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  298135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  298138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298160 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  298163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298177 */     GIR_RootConstrainSelectedInstOperands,
     /*  298178 */     // GIR_Coverage, 9580,
     /*  298178 */     GIR_EraseRootFromParent_Done,
     /*  298179 */   // Label 5588: @298179
     /*  298179 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(298242), // Rule ID 9581 //
     /*  298184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  298198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  298201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298223 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  298226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298240 */     GIR_RootConstrainSelectedInstOperands,
     /*  298241 */     // GIR_Coverage, 9581,
     /*  298241 */     GIR_EraseRootFromParent_Done,
     /*  298242 */   // Label 5589: @298242
     /*  298242 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(298305), // Rule ID 9584 //
     /*  298247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  298261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  298264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298286 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298303 */     GIR_RootConstrainSelectedInstOperands,
     /*  298304 */     // GIR_Coverage, 9584,
     /*  298304 */     GIR_EraseRootFromParent_Done,
     /*  298305 */   // Label 5590: @298305
     /*  298305 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(298368), // Rule ID 9585 //
     /*  298310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  298324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  298327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298349 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298366 */     GIR_RootConstrainSelectedInstOperands,
     /*  298367 */     // GIR_Coverage, 9585,
     /*  298367 */     GIR_EraseRootFromParent_Done,
     /*  298368 */   // Label 5591: @298368
     /*  298368 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(298431), // Rule ID 9588 //
     /*  298373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  298387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  298390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298412 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  298412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298429 */     GIR_RootConstrainSelectedInstOperands,
     /*  298430 */     // GIR_Coverage, 9588,
     /*  298430 */     GIR_EraseRootFromParent_Done,
     /*  298431 */   // Label 5592: @298431
     /*  298431 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(298494), // Rule ID 9589 //
     /*  298436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  298450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  298453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298475 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298492 */     GIR_RootConstrainSelectedInstOperands,
     /*  298493 */     // GIR_Coverage, 9589,
     /*  298493 */     GIR_EraseRootFromParent_Done,
     /*  298494 */   // Label 5593: @298494
     /*  298494 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(298557), // Rule ID 9592 //
     /*  298499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  298513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  298516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298538 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298555 */     GIR_RootConstrainSelectedInstOperands,
     /*  298556 */     // GIR_Coverage, 9592,
     /*  298556 */     GIR_EraseRootFromParent_Done,
     /*  298557 */   // Label 5594: @298557
     /*  298557 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(298620), // Rule ID 9593 //
     /*  298562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  298576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  298579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298601 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298618 */     GIR_RootConstrainSelectedInstOperands,
     /*  298619 */     // GIR_Coverage, 9593,
     /*  298619 */     GIR_EraseRootFromParent_Done,
     /*  298620 */   // Label 5595: @298620
     /*  298620 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(298683), // Rule ID 9596 //
     /*  298625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  298639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  298642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298664 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298681 */     GIR_RootConstrainSelectedInstOperands,
     /*  298682 */     // GIR_Coverage, 9596,
     /*  298682 */     GIR_EraseRootFromParent_Done,
     /*  298683 */   // Label 5596: @298683
     /*  298683 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(298746), // Rule ID 9597 //
     /*  298688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  298702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  298705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298727 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298744 */     GIR_RootConstrainSelectedInstOperands,
     /*  298745 */     // GIR_Coverage, 9597,
     /*  298745 */     GIR_EraseRootFromParent_Done,
     /*  298746 */   // Label 5597: @298746
     /*  298746 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(298809), // Rule ID 9600 //
     /*  298751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  298765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  298768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298790 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  298790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298807 */     GIR_RootConstrainSelectedInstOperands,
     /*  298808 */     // GIR_Coverage, 9600,
     /*  298808 */     GIR_EraseRootFromParent_Done,
     /*  298809 */   // Label 5598: @298809
     /*  298809 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(298872), // Rule ID 9601 //
     /*  298814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  298828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  298831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298853 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298870 */     GIR_RootConstrainSelectedInstOperands,
     /*  298871 */     // GIR_Coverage, 9601,
     /*  298871 */     GIR_EraseRootFromParent_Done,
     /*  298872 */   // Label 5599: @298872
     /*  298872 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(298935), // Rule ID 9604 //
     /*  298877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  298880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  298891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  298894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298916 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  298916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298933 */     GIR_RootConstrainSelectedInstOperands,
     /*  298934 */     // GIR_Coverage, 9604,
     /*  298934 */     GIR_EraseRootFromParent_Done,
     /*  298935 */   // Label 5600: @298935
     /*  298935 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(298998), // Rule ID 9605 //
     /*  298940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  298943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  298954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  298957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298979 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  298979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298996 */     GIR_RootConstrainSelectedInstOperands,
     /*  298997 */     // GIR_Coverage, 9605,
     /*  298997 */     GIR_EraseRootFromParent_Done,
     /*  298998 */   // Label 5601: @298998
     /*  298998 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(299061), // Rule ID 9608 //
     /*  299003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  299017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  299020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299042 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299059 */     GIR_RootConstrainSelectedInstOperands,
     /*  299060 */     // GIR_Coverage, 9608,
     /*  299060 */     GIR_EraseRootFromParent_Done,
     /*  299061 */   // Label 5602: @299061
     /*  299061 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(299124), // Rule ID 9609 //
     /*  299066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  299080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  299083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299105 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299122 */     GIR_RootConstrainSelectedInstOperands,
     /*  299123 */     // GIR_Coverage, 9609,
     /*  299123 */     GIR_EraseRootFromParent_Done,
     /*  299124 */   // Label 5603: @299124
     /*  299124 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(299187), // Rule ID 9612 //
     /*  299129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  299143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  299146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299168 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299185 */     GIR_RootConstrainSelectedInstOperands,
     /*  299186 */     // GIR_Coverage, 9612,
     /*  299186 */     GIR_EraseRootFromParent_Done,
     /*  299187 */   // Label 5604: @299187
     /*  299187 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(299250), // Rule ID 9613 //
     /*  299192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  299206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  299209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299231 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299248 */     GIR_RootConstrainSelectedInstOperands,
     /*  299249 */     // GIR_Coverage, 9613,
     /*  299249 */     GIR_EraseRootFromParent_Done,
     /*  299250 */   // Label 5605: @299250
     /*  299250 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(299313), // Rule ID 9616 //
     /*  299255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  299266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  299269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  299272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299294 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299311 */     GIR_RootConstrainSelectedInstOperands,
     /*  299312 */     // GIR_Coverage, 9616,
     /*  299312 */     GIR_EraseRootFromParent_Done,
     /*  299313 */   // Label 5606: @299313
     /*  299313 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(299376), // Rule ID 9617 //
     /*  299318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  299329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  299332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  299335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299357 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299374 */     GIR_RootConstrainSelectedInstOperands,
     /*  299375 */     // GIR_Coverage, 9617,
     /*  299375 */     GIR_EraseRootFromParent_Done,
     /*  299376 */   // Label 5607: @299376
     /*  299376 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(299439), // Rule ID 9620 //
     /*  299381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  299395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  299398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299420 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299437 */     GIR_RootConstrainSelectedInstOperands,
     /*  299438 */     // GIR_Coverage, 9620,
     /*  299438 */     GIR_EraseRootFromParent_Done,
     /*  299439 */   // Label 5608: @299439
     /*  299439 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(299502), // Rule ID 9621 //
     /*  299444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  299458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  299461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299483 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299500 */     GIR_RootConstrainSelectedInstOperands,
     /*  299501 */     // GIR_Coverage, 9621,
     /*  299501 */     GIR_EraseRootFromParent_Done,
     /*  299502 */   // Label 5609: @299502
     /*  299502 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(299565), // Rule ID 9624 //
     /*  299507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  299521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  299524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299546 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299563 */     GIR_RootConstrainSelectedInstOperands,
     /*  299564 */     // GIR_Coverage, 9624,
     /*  299564 */     GIR_EraseRootFromParent_Done,
     /*  299565 */   // Label 5610: @299565
     /*  299565 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(299628), // Rule ID 9625 //
     /*  299570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  299584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  299587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299609 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299626 */     GIR_RootConstrainSelectedInstOperands,
     /*  299627 */     // GIR_Coverage, 9625,
     /*  299627 */     GIR_EraseRootFromParent_Done,
     /*  299628 */   // Label 5611: @299628
     /*  299628 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(299691), // Rule ID 9628 //
     /*  299633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  299647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  299650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299672 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299689 */     GIR_RootConstrainSelectedInstOperands,
     /*  299690 */     // GIR_Coverage, 9628,
     /*  299690 */     GIR_EraseRootFromParent_Done,
     /*  299691 */   // Label 5612: @299691
     /*  299691 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(299754), // Rule ID 9629 //
     /*  299696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  299710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  299713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299735 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299752 */     GIR_RootConstrainSelectedInstOperands,
     /*  299753 */     // GIR_Coverage, 9629,
     /*  299753 */     GIR_EraseRootFromParent_Done,
     /*  299754 */   // Label 5613: @299754
     /*  299754 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(299817), // Rule ID 9632 //
     /*  299759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  299773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  299776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299798 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299815 */     GIR_RootConstrainSelectedInstOperands,
     /*  299816 */     // GIR_Coverage, 9632,
     /*  299816 */     GIR_EraseRootFromParent_Done,
     /*  299817 */   // Label 5614: @299817
     /*  299817 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(299880), // Rule ID 9633 //
     /*  299822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  299836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  299839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299861 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299878 */     GIR_RootConstrainSelectedInstOperands,
     /*  299879 */     // GIR_Coverage, 9633,
     /*  299879 */     GIR_EraseRootFromParent_Done,
     /*  299880 */   // Label 5615: @299880
     /*  299880 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(299943), // Rule ID 9636 //
     /*  299885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  299899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  299902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299924 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299941 */     GIR_RootConstrainSelectedInstOperands,
     /*  299942 */     // GIR_Coverage, 9636,
     /*  299942 */     GIR_EraseRootFromParent_Done,
     /*  299943 */   // Label 5616: @299943
     /*  299943 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(300006), // Rule ID 9637 //
     /*  299948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  299962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  299965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299987 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300004 */     GIR_RootConstrainSelectedInstOperands,
     /*  300005 */     // GIR_Coverage, 9637,
     /*  300005 */     GIR_EraseRootFromParent_Done,
     /*  300006 */   // Label 5617: @300006
     /*  300006 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(300069), // Rule ID 9640 //
     /*  300011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  300025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  300028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300050 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  300053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300067 */     GIR_RootConstrainSelectedInstOperands,
     /*  300068 */     // GIR_Coverage, 9640,
     /*  300068 */     GIR_EraseRootFromParent_Done,
     /*  300069 */   // Label 5618: @300069
     /*  300069 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(300132), // Rule ID 9641 //
     /*  300074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  300088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  300091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300113 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  300116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300130 */     GIR_RootConstrainSelectedInstOperands,
     /*  300131 */     // GIR_Coverage, 9641,
     /*  300131 */     GIR_EraseRootFromParent_Done,
     /*  300132 */   // Label 5619: @300132
     /*  300132 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(300195), // Rule ID 9644 //
     /*  300137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  300140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  300151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  300154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300176 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  300176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  300179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300193 */     GIR_RootConstrainSelectedInstOperands,
     /*  300194 */     // GIR_Coverage, 9644,
     /*  300194 */     GIR_EraseRootFromParent_Done,
     /*  300195 */   // Label 5620: @300195
     /*  300195 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(300258), // Rule ID 9645 //
     /*  300200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  300203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  300214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  300217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300239 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  300239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  300242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300256 */     GIR_RootConstrainSelectedInstOperands,
     /*  300257 */     // GIR_Coverage, 9645,
     /*  300257 */     GIR_EraseRootFromParent_Done,
     /*  300258 */   // Label 5621: @300258
     /*  300258 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(300321), // Rule ID 9648 //
     /*  300263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  300266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  300277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  300280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300302 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  300302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  300305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300319 */     GIR_RootConstrainSelectedInstOperands,
     /*  300320 */     // GIR_Coverage, 9648,
     /*  300320 */     GIR_EraseRootFromParent_Done,
     /*  300321 */   // Label 5622: @300321
     /*  300321 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(300384), // Rule ID 9649 //
     /*  300326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  300329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  300340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  300343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300365 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  300365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  300368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300382 */     GIR_RootConstrainSelectedInstOperands,
     /*  300383 */     // GIR_Coverage, 9649,
     /*  300383 */     GIR_EraseRootFromParent_Done,
     /*  300384 */   // Label 5623: @300384
     /*  300384 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(300447), // Rule ID 9652 //
     /*  300389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  300392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  300403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  300406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300428 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  300428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  300431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300445 */     GIR_RootConstrainSelectedInstOperands,
     /*  300446 */     // GIR_Coverage, 9652,
     /*  300446 */     GIR_EraseRootFromParent_Done,
     /*  300447 */   // Label 5624: @300447
     /*  300447 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(300510), // Rule ID 9653 //
     /*  300452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  300455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  300466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  300469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300491 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  300491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  300494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300508 */     GIR_RootConstrainSelectedInstOperands,
     /*  300509 */     // GIR_Coverage, 9653,
     /*  300509 */     GIR_EraseRootFromParent_Done,
     /*  300510 */   // Label 5625: @300510
     /*  300510 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(300573), // Rule ID 9656 //
     /*  300515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  300529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  300532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300554 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  300557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300571 */     GIR_RootConstrainSelectedInstOperands,
     /*  300572 */     // GIR_Coverage, 9656,
     /*  300572 */     GIR_EraseRootFromParent_Done,
     /*  300573 */   // Label 5626: @300573
     /*  300573 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(300636), // Rule ID 9657 //
     /*  300578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  300592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  300595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300617 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  300620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300634 */     GIR_RootConstrainSelectedInstOperands,
     /*  300635 */     // GIR_Coverage, 9657,
     /*  300635 */     GIR_EraseRootFromParent_Done,
     /*  300636 */   // Label 5627: @300636
     /*  300636 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(300699), // Rule ID 9660 //
     /*  300641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  300655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  300658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300680 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300697 */     GIR_RootConstrainSelectedInstOperands,
     /*  300698 */     // GIR_Coverage, 9660,
     /*  300698 */     GIR_EraseRootFromParent_Done,
     /*  300699 */   // Label 5628: @300699
     /*  300699 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(300762), // Rule ID 9661 //
     /*  300704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  300718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  300721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300743 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300760 */     GIR_RootConstrainSelectedInstOperands,
     /*  300761 */     // GIR_Coverage, 9661,
     /*  300761 */     GIR_EraseRootFromParent_Done,
     /*  300762 */   // Label 5629: @300762
     /*  300762 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(300825), // Rule ID 9664 //
     /*  300767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  300781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  300784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300806 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300823 */     GIR_RootConstrainSelectedInstOperands,
     /*  300824 */     // GIR_Coverage, 9664,
     /*  300824 */     GIR_EraseRootFromParent_Done,
     /*  300825 */   // Label 5630: @300825
     /*  300825 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(300888), // Rule ID 9665 //
     /*  300830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  300844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  300847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300869 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300886 */     GIR_RootConstrainSelectedInstOperands,
     /*  300887 */     // GIR_Coverage, 9665,
     /*  300887 */     GIR_EraseRootFromParent_Done,
     /*  300888 */   // Label 5631: @300888
     /*  300888 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(300951), // Rule ID 9668 //
     /*  300893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  300907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  300910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300932 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300949 */     GIR_RootConstrainSelectedInstOperands,
     /*  300950 */     // GIR_Coverage, 9668,
     /*  300950 */     GIR_EraseRootFromParent_Done,
     /*  300951 */   // Label 5632: @300951
     /*  300951 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(301014), // Rule ID 9669 //
     /*  300956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  300970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  300973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300995 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301012 */     GIR_RootConstrainSelectedInstOperands,
     /*  301013 */     // GIR_Coverage, 9669,
     /*  301013 */     GIR_EraseRootFromParent_Done,
     /*  301014 */   // Label 5633: @301014
     /*  301014 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(301077), // Rule ID 9672 //
     /*  301019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  301033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  301036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301058 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  301061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301075 */     GIR_RootConstrainSelectedInstOperands,
     /*  301076 */     // GIR_Coverage, 9672,
     /*  301076 */     GIR_EraseRootFromParent_Done,
     /*  301077 */   // Label 5634: @301077
     /*  301077 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(301140), // Rule ID 9673 //
     /*  301082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  301096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  301099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301121 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  301124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301138 */     GIR_RootConstrainSelectedInstOperands,
     /*  301139 */     // GIR_Coverage, 9673,
     /*  301139 */     GIR_EraseRootFromParent_Done,
     /*  301140 */   // Label 5635: @301140
     /*  301140 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(301203), // Rule ID 9676 //
     /*  301145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  301159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  301162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301184 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  301184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  301187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301201 */     GIR_RootConstrainSelectedInstOperands,
     /*  301202 */     // GIR_Coverage, 9676,
     /*  301202 */     GIR_EraseRootFromParent_Done,
     /*  301203 */   // Label 5636: @301203
     /*  301203 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(301266), // Rule ID 9677 //
     /*  301208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  301222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  301225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301247 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  301247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  301250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301264 */     GIR_RootConstrainSelectedInstOperands,
     /*  301265 */     // GIR_Coverage, 9677,
     /*  301265 */     GIR_EraseRootFromParent_Done,
     /*  301266 */   // Label 5637: @301266
     /*  301266 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(301329), // Rule ID 9680 //
     /*  301271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  301285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  301288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301310 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301327 */     GIR_RootConstrainSelectedInstOperands,
     /*  301328 */     // GIR_Coverage, 9680,
     /*  301328 */     GIR_EraseRootFromParent_Done,
     /*  301329 */   // Label 5638: @301329
     /*  301329 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(301392), // Rule ID 9681 //
     /*  301334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  301348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  301351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301373 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301390 */     GIR_RootConstrainSelectedInstOperands,
     /*  301391 */     // GIR_Coverage, 9681,
     /*  301391 */     GIR_EraseRootFromParent_Done,
     /*  301392 */   // Label 5639: @301392
     /*  301392 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(301455), // Rule ID 9684 //
     /*  301397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  301411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  301414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301436 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301453 */     GIR_RootConstrainSelectedInstOperands,
     /*  301454 */     // GIR_Coverage, 9684,
     /*  301454 */     GIR_EraseRootFromParent_Done,
     /*  301455 */   // Label 5640: @301455
     /*  301455 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(301518), // Rule ID 9685 //
     /*  301460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  301474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  301477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301499 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301516 */     GIR_RootConstrainSelectedInstOperands,
     /*  301517 */     // GIR_Coverage, 9685,
     /*  301517 */     GIR_EraseRootFromParent_Done,
     /*  301518 */   // Label 5641: @301518
     /*  301518 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(301581), // Rule ID 9688 //
     /*  301523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  301537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  301540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301562 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  301562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301579 */     GIR_RootConstrainSelectedInstOperands,
     /*  301580 */     // GIR_Coverage, 9688,
     /*  301580 */     GIR_EraseRootFromParent_Done,
     /*  301581 */   // Label 5642: @301581
     /*  301581 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(301644), // Rule ID 9689 //
     /*  301586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  301600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  301603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301625 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  301625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301642 */     GIR_RootConstrainSelectedInstOperands,
     /*  301643 */     // GIR_Coverage, 9689,
     /*  301643 */     GIR_EraseRootFromParent_Done,
     /*  301644 */   // Label 5643: @301644
     /*  301644 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(301707), // Rule ID 9692 //
     /*  301649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  301652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  301663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  301666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  301688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301705 */     GIR_RootConstrainSelectedInstOperands,
     /*  301706 */     // GIR_Coverage, 9692,
     /*  301706 */     GIR_EraseRootFromParent_Done,
     /*  301707 */   // Label 5644: @301707
     /*  301707 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(301770), // Rule ID 9693 //
     /*  301712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  301715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  301726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  301729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301751 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  301751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301768 */     GIR_RootConstrainSelectedInstOperands,
     /*  301769 */     // GIR_Coverage, 9693,
     /*  301769 */     GIR_EraseRootFromParent_Done,
     /*  301770 */   // Label 5645: @301770
     /*  301770 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(301833), // Rule ID 9696 //
     /*  301775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  301789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  301792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301814 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301831 */     GIR_RootConstrainSelectedInstOperands,
     /*  301832 */     // GIR_Coverage, 9696,
     /*  301832 */     GIR_EraseRootFromParent_Done,
     /*  301833 */   // Label 5646: @301833
     /*  301833 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(301896), // Rule ID 9697 //
     /*  301838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  301852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  301855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301877 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301894 */     GIR_RootConstrainSelectedInstOperands,
     /*  301895 */     // GIR_Coverage, 9697,
     /*  301895 */     GIR_EraseRootFromParent_Done,
     /*  301896 */   // Label 5647: @301896
     /*  301896 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(301959), // Rule ID 9700 //
     /*  301901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  301912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  301915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  301918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301940 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301957 */     GIR_RootConstrainSelectedInstOperands,
     /*  301958 */     // GIR_Coverage, 9700,
     /*  301958 */     GIR_EraseRootFromParent_Done,
     /*  301959 */   // Label 5648: @301959
     /*  301959 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(302022), // Rule ID 9701 //
     /*  301964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  301975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  301978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  301981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302003 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302020 */     GIR_RootConstrainSelectedInstOperands,
     /*  302021 */     // GIR_Coverage, 9701,
     /*  302021 */     GIR_EraseRootFromParent_Done,
     /*  302022 */   // Label 5649: @302022
     /*  302022 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(302085), // Rule ID 9704 //
     /*  302027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  302038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  302041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  302044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302066 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302083 */     GIR_RootConstrainSelectedInstOperands,
     /*  302084 */     // GIR_Coverage, 9704,
     /*  302084 */     GIR_EraseRootFromParent_Done,
     /*  302085 */   // Label 5650: @302085
     /*  302085 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(302148), // Rule ID 9705 //
     /*  302090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  302101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  302104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  302107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302129 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302146 */     GIR_RootConstrainSelectedInstOperands,
     /*  302147 */     // GIR_Coverage, 9705,
     /*  302147 */     GIR_EraseRootFromParent_Done,
     /*  302148 */   // Label 5651: @302148
     /*  302148 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(302211), // Rule ID 9708 //
     /*  302153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  302167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  302170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302192 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302209 */     GIR_RootConstrainSelectedInstOperands,
     /*  302210 */     // GIR_Coverage, 9708,
     /*  302210 */     GIR_EraseRootFromParent_Done,
     /*  302211 */   // Label 5652: @302211
     /*  302211 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(302274), // Rule ID 9709 //
     /*  302216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  302230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  302233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302255 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302272 */     GIR_RootConstrainSelectedInstOperands,
     /*  302273 */     // GIR_Coverage, 9709,
     /*  302273 */     GIR_EraseRootFromParent_Done,
     /*  302274 */   // Label 5653: @302274
     /*  302274 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(302337), // Rule ID 9712 //
     /*  302279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  302293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  302296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302318 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302335 */     GIR_RootConstrainSelectedInstOperands,
     /*  302336 */     // GIR_Coverage, 9712,
     /*  302336 */     GIR_EraseRootFromParent_Done,
     /*  302337 */   // Label 5654: @302337
     /*  302337 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(302400), // Rule ID 9713 //
     /*  302342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  302356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  302359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302381 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302398 */     GIR_RootConstrainSelectedInstOperands,
     /*  302399 */     // GIR_Coverage, 9713,
     /*  302399 */     GIR_EraseRootFromParent_Done,
     /*  302400 */   // Label 5655: @302400
     /*  302400 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(302463), // Rule ID 9716 //
     /*  302405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  302416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  302419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  302422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302444 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302461 */     GIR_RootConstrainSelectedInstOperands,
     /*  302462 */     // GIR_Coverage, 9716,
     /*  302462 */     GIR_EraseRootFromParent_Done,
     /*  302463 */   // Label 5656: @302463
     /*  302463 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(302526), // Rule ID 9717 //
     /*  302468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  302479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  302482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  302485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302507 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302524 */     GIR_RootConstrainSelectedInstOperands,
     /*  302525 */     // GIR_Coverage, 9717,
     /*  302525 */     GIR_EraseRootFromParent_Done,
     /*  302526 */   // Label 5657: @302526
     /*  302526 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(302589), // Rule ID 9720 //
     /*  302531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  302545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  302548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302570 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302587 */     GIR_RootConstrainSelectedInstOperands,
     /*  302588 */     // GIR_Coverage, 9720,
     /*  302588 */     GIR_EraseRootFromParent_Done,
     /*  302589 */   // Label 5658: @302589
     /*  302589 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(302652), // Rule ID 9721 //
     /*  302594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  302608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  302611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302633 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302650 */     GIR_RootConstrainSelectedInstOperands,
     /*  302651 */     // GIR_Coverage, 9721,
     /*  302651 */     GIR_EraseRootFromParent_Done,
     /*  302652 */   // Label 5659: @302652
     /*  302652 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(302715), // Rule ID 9724 //
     /*  302657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  302671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  302674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302696 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302713 */     GIR_RootConstrainSelectedInstOperands,
     /*  302714 */     // GIR_Coverage, 9724,
     /*  302714 */     GIR_EraseRootFromParent_Done,
     /*  302715 */   // Label 5660: @302715
     /*  302715 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(302778), // Rule ID 9725 //
     /*  302720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  302734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  302737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302759 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302776 */     GIR_RootConstrainSelectedInstOperands,
     /*  302777 */     // GIR_Coverage, 9725,
     /*  302777 */     GIR_EraseRootFromParent_Done,
     /*  302778 */   // Label 5661: @302778
     /*  302778 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(302841), // Rule ID 9728 //
     /*  302783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  302797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  302800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302822 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302839 */     GIR_RootConstrainSelectedInstOperands,
     /*  302840 */     // GIR_Coverage, 9728,
     /*  302840 */     GIR_EraseRootFromParent_Done,
     /*  302841 */   // Label 5662: @302841
     /*  302841 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(302904), // Rule ID 9729 //
     /*  302846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  302860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  302863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302885 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302902 */     GIR_RootConstrainSelectedInstOperands,
     /*  302903 */     // GIR_Coverage, 9729,
     /*  302903 */     GIR_EraseRootFromParent_Done,
     /*  302904 */   // Label 5663: @302904
     /*  302904 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(302967), // Rule ID 9732 //
     /*  302909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  302912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  302923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  302926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302948 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302965 */     GIR_RootConstrainSelectedInstOperands,
     /*  302966 */     // GIR_Coverage, 9732,
     /*  302966 */     GIR_EraseRootFromParent_Done,
     /*  302967 */   // Label 5664: @302967
     /*  302967 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(303030), // Rule ID 9733 //
     /*  302972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  302975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  302986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  302989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303011 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  303014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303028 */     GIR_RootConstrainSelectedInstOperands,
     /*  303029 */     // GIR_Coverage, 9733,
     /*  303029 */     GIR_EraseRootFromParent_Done,
     /*  303030 */   // Label 5665: @303030
     /*  303030 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(303093), // Rule ID 9736 //
     /*  303035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  303043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  303049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  303052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303074 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  303077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303091 */     GIR_RootConstrainSelectedInstOperands,
     /*  303092 */     // GIR_Coverage, 9736,
     /*  303092 */     GIR_EraseRootFromParent_Done,
     /*  303093 */   // Label 5666: @303093
     /*  303093 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(303156), // Rule ID 9737 //
     /*  303098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  303101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  303106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  303112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  303115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303137 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  303140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303154 */     GIR_RootConstrainSelectedInstOperands,
     /*  303155 */     // GIR_Coverage, 9737,
     /*  303155 */     GIR_EraseRootFromParent_Done,
     /*  303156 */   // Label 5667: @303156
     /*  303156 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(303219), // Rule ID 9740 //
     /*  303161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  303169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  303175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  303178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303200 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  303203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303217 */     GIR_RootConstrainSelectedInstOperands,
     /*  303218 */     // GIR_Coverage, 9740,
     /*  303218 */     GIR_EraseRootFromParent_Done,
     /*  303219 */   // Label 5668: @303219
     /*  303219 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(303282), // Rule ID 9741 //
     /*  303224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  303227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  303232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  303238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  303241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303263 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  303266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303280 */     GIR_RootConstrainSelectedInstOperands,
     /*  303281 */     // GIR_Coverage, 9741,
     /*  303281 */     GIR_EraseRootFromParent_Done,
     /*  303282 */   // Label 5669: @303282
     /*  303282 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(303345), // Rule ID 9744 //
     /*  303287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  303301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  303304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303326 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  303329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303343 */     GIR_RootConstrainSelectedInstOperands,
     /*  303344 */     // GIR_Coverage, 9744,
     /*  303344 */     GIR_EraseRootFromParent_Done,
     /*  303345 */   // Label 5670: @303345
     /*  303345 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(303408), // Rule ID 9745 //
     /*  303350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  303364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  303367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303389 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  303392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303406 */     GIR_RootConstrainSelectedInstOperands,
     /*  303407 */     // GIR_Coverage, 9745,
     /*  303407 */     GIR_EraseRootFromParent_Done,
     /*  303408 */   // Label 5671: @303408
     /*  303408 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(303471), // Rule ID 9748 //
     /*  303413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  303427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  303430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303452 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303469 */     GIR_RootConstrainSelectedInstOperands,
     /*  303470 */     // GIR_Coverage, 9748,
     /*  303470 */     GIR_EraseRootFromParent_Done,
     /*  303471 */   // Label 5672: @303471
     /*  303471 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(303534), // Rule ID 9749 //
     /*  303476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  303490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  303493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303515 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303532 */     GIR_RootConstrainSelectedInstOperands,
     /*  303533 */     // GIR_Coverage, 9749,
     /*  303533 */     GIR_EraseRootFromParent_Done,
     /*  303534 */   // Label 5673: @303534
     /*  303534 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(303597), // Rule ID 9752 //
     /*  303539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  303553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  303556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303578 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303595 */     GIR_RootConstrainSelectedInstOperands,
     /*  303596 */     // GIR_Coverage, 9752,
     /*  303596 */     GIR_EraseRootFromParent_Done,
     /*  303597 */   // Label 5674: @303597
     /*  303597 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(303660), // Rule ID 9753 //
     /*  303602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  303616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  303619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303641 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303658 */     GIR_RootConstrainSelectedInstOperands,
     /*  303659 */     // GIR_Coverage, 9753,
     /*  303659 */     GIR_EraseRootFromParent_Done,
     /*  303660 */   // Label 5675: @303660
     /*  303660 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(303723), // Rule ID 9756 //
     /*  303665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  303679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  303682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303704 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303721 */     GIR_RootConstrainSelectedInstOperands,
     /*  303722 */     // GIR_Coverage, 9756,
     /*  303722 */     GIR_EraseRootFromParent_Done,
     /*  303723 */   // Label 5676: @303723
     /*  303723 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(303786), // Rule ID 9757 //
     /*  303728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  303742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  303745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303767 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303784 */     GIR_RootConstrainSelectedInstOperands,
     /*  303785 */     // GIR_Coverage, 9757,
     /*  303785 */     GIR_EraseRootFromParent_Done,
     /*  303786 */   // Label 5677: @303786
     /*  303786 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(303849), // Rule ID 9760 //
     /*  303791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  303805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  303808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303830 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303847 */     GIR_RootConstrainSelectedInstOperands,
     /*  303848 */     // GIR_Coverage, 9760,
     /*  303848 */     GIR_EraseRootFromParent_Done,
     /*  303849 */   // Label 5678: @303849
     /*  303849 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(303912), // Rule ID 9761 //
     /*  303854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  303868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  303871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303893 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303910 */     GIR_RootConstrainSelectedInstOperands,
     /*  303911 */     // GIR_Coverage, 9761,
     /*  303911 */     GIR_EraseRootFromParent_Done,
     /*  303912 */   // Label 5679: @303912
     /*  303912 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(303975), // Rule ID 9764 //
     /*  303917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  303931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  303934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303956 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303973 */     GIR_RootConstrainSelectedInstOperands,
     /*  303974 */     // GIR_Coverage, 9764,
     /*  303974 */     GIR_EraseRootFromParent_Done,
     /*  303975 */   // Label 5680: @303975
     /*  303975 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(304038), // Rule ID 9765 //
     /*  303980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  303994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  303997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304019 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  304022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304036 */     GIR_RootConstrainSelectedInstOperands,
     /*  304037 */     // GIR_Coverage, 9765,
     /*  304037 */     GIR_EraseRootFromParent_Done,
     /*  304038 */   // Label 5681: @304038
     /*  304038 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(304101), // Rule ID 9768 //
     /*  304043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  304057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  304060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304082 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304099 */     GIR_RootConstrainSelectedInstOperands,
     /*  304100 */     // GIR_Coverage, 9768,
     /*  304100 */     GIR_EraseRootFromParent_Done,
     /*  304101 */   // Label 5682: @304101
     /*  304101 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(304164), // Rule ID 9769 //
     /*  304106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  304120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  304123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304145 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304162 */     GIR_RootConstrainSelectedInstOperands,
     /*  304163 */     // GIR_Coverage, 9769,
     /*  304163 */     GIR_EraseRootFromParent_Done,
     /*  304164 */   // Label 5683: @304164
     /*  304164 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(304227), // Rule ID 9772 //
     /*  304169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  304183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  304186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304208 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304225 */     GIR_RootConstrainSelectedInstOperands,
     /*  304226 */     // GIR_Coverage, 9772,
     /*  304226 */     GIR_EraseRootFromParent_Done,
     /*  304227 */   // Label 5684: @304227
     /*  304227 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(304290), // Rule ID 9773 //
     /*  304232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  304246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  304249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304271 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304288 */     GIR_RootConstrainSelectedInstOperands,
     /*  304289 */     // GIR_Coverage, 9773,
     /*  304289 */     GIR_EraseRootFromParent_Done,
     /*  304290 */   // Label 5685: @304290
     /*  304290 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(304353), // Rule ID 9776 //
     /*  304295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  304309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  304312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304334 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  304334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304351 */     GIR_RootConstrainSelectedInstOperands,
     /*  304352 */     // GIR_Coverage, 9776,
     /*  304352 */     GIR_EraseRootFromParent_Done,
     /*  304353 */   // Label 5686: @304353
     /*  304353 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(304416), // Rule ID 9777 //
     /*  304358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  304372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  304375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304397 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304414 */     GIR_RootConstrainSelectedInstOperands,
     /*  304415 */     // GIR_Coverage, 9777,
     /*  304415 */     GIR_EraseRootFromParent_Done,
     /*  304416 */   // Label 5687: @304416
     /*  304416 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(304479), // Rule ID 9780 //
     /*  304421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  304424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  304435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  304438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304460 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  304460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304477 */     GIR_RootConstrainSelectedInstOperands,
     /*  304478 */     // GIR_Coverage, 9780,
     /*  304478 */     GIR_EraseRootFromParent_Done,
     /*  304479 */   // Label 5688: @304479
     /*  304479 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(304542), // Rule ID 9781 //
     /*  304484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  304487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  304498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  304501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304523 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  304523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304540 */     GIR_RootConstrainSelectedInstOperands,
     /*  304541 */     // GIR_Coverage, 9781,
     /*  304541 */     GIR_EraseRootFromParent_Done,
     /*  304542 */   // Label 5689: @304542
     /*  304542 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(304605), // Rule ID 9784 //
     /*  304547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  304561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  304564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304586 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304603 */     GIR_RootConstrainSelectedInstOperands,
     /*  304604 */     // GIR_Coverage, 9784,
     /*  304604 */     GIR_EraseRootFromParent_Done,
     /*  304605 */   // Label 5690: @304605
     /*  304605 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(304668), // Rule ID 9785 //
     /*  304610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  304624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  304627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304649 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304666 */     GIR_RootConstrainSelectedInstOperands,
     /*  304667 */     // GIR_Coverage, 9785,
     /*  304667 */     GIR_EraseRootFromParent_Done,
     /*  304668 */   // Label 5691: @304668
     /*  304668 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(304731), // Rule ID 9788 //
     /*  304673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  304687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  304690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304712 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304729 */     GIR_RootConstrainSelectedInstOperands,
     /*  304730 */     // GIR_Coverage, 9788,
     /*  304730 */     GIR_EraseRootFromParent_Done,
     /*  304731 */   // Label 5692: @304731
     /*  304731 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(304794), // Rule ID 9789 //
     /*  304736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  304750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  304753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304775 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304792 */     GIR_RootConstrainSelectedInstOperands,
     /*  304793 */     // GIR_Coverage, 9789,
     /*  304793 */     GIR_EraseRootFromParent_Done,
     /*  304794 */   // Label 5693: @304794
     /*  304794 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(304857), // Rule ID 9792 //
     /*  304799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  304810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  304813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  304816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304838 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304855 */     GIR_RootConstrainSelectedInstOperands,
     /*  304856 */     // GIR_Coverage, 9792,
     /*  304856 */     GIR_EraseRootFromParent_Done,
     /*  304857 */   // Label 5694: @304857
     /*  304857 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(304920), // Rule ID 9793 //
     /*  304862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  304873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  304876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  304879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304901 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304918 */     GIR_RootConstrainSelectedInstOperands,
     /*  304919 */     // GIR_Coverage, 9793,
     /*  304919 */     GIR_EraseRootFromParent_Done,
     /*  304920 */   // Label 5695: @304920
     /*  304920 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(304983), // Rule ID 9796 //
     /*  304925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  304939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  304942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304964 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304981 */     GIR_RootConstrainSelectedInstOperands,
     /*  304982 */     // GIR_Coverage, 9796,
     /*  304982 */     GIR_EraseRootFromParent_Done,
     /*  304983 */   // Label 5696: @304983
     /*  304983 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(305046), // Rule ID 9797 //
     /*  304988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  305002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  305005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305027 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305044 */     GIR_RootConstrainSelectedInstOperands,
     /*  305045 */     // GIR_Coverage, 9797,
     /*  305045 */     GIR_EraseRootFromParent_Done,
     /*  305046 */   // Label 5697: @305046
     /*  305046 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(305109), // Rule ID 9800 //
     /*  305051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  305065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  305068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305090 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305107 */     GIR_RootConstrainSelectedInstOperands,
     /*  305108 */     // GIR_Coverage, 9800,
     /*  305108 */     GIR_EraseRootFromParent_Done,
     /*  305109 */   // Label 5698: @305109
     /*  305109 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(305172), // Rule ID 9801 //
     /*  305114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  305128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  305131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305153 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305170 */     GIR_RootConstrainSelectedInstOperands,
     /*  305171 */     // GIR_Coverage, 9801,
     /*  305171 */     GIR_EraseRootFromParent_Done,
     /*  305172 */   // Label 5699: @305172
     /*  305172 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(305235), // Rule ID 9804 //
     /*  305177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  305188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  305191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  305194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305216 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305233 */     GIR_RootConstrainSelectedInstOperands,
     /*  305234 */     // GIR_Coverage, 9804,
     /*  305234 */     GIR_EraseRootFromParent_Done,
     /*  305235 */   // Label 5700: @305235
     /*  305235 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(305298), // Rule ID 9805 //
     /*  305240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  305251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  305254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  305257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305279 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305296 */     GIR_RootConstrainSelectedInstOperands,
     /*  305297 */     // GIR_Coverage, 9805,
     /*  305297 */     GIR_EraseRootFromParent_Done,
     /*  305298 */   // Label 5701: @305298
     /*  305298 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(305361), // Rule ID 9808 //
     /*  305303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  305317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  305320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305342 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  305342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305359 */     GIR_RootConstrainSelectedInstOperands,
     /*  305360 */     // GIR_Coverage, 9808,
     /*  305360 */     GIR_EraseRootFromParent_Done,
     /*  305361 */   // Label 5702: @305361
     /*  305361 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(305424), // Rule ID 9809 //
     /*  305366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  305380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  305383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305405 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  305405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305422 */     GIR_RootConstrainSelectedInstOperands,
     /*  305423 */     // GIR_Coverage, 9809,
     /*  305423 */     GIR_EraseRootFromParent_Done,
     /*  305424 */   // Label 5703: @305424
     /*  305424 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(305487), // Rule ID 9812 //
     /*  305429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  305443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  305446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305468 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  305468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305485 */     GIR_RootConstrainSelectedInstOperands,
     /*  305486 */     // GIR_Coverage, 9812,
     /*  305486 */     GIR_EraseRootFromParent_Done,
     /*  305487 */   // Label 5704: @305487
     /*  305487 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(305550), // Rule ID 9813 //
     /*  305492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  305506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  305509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305531 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  305531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305548 */     GIR_RootConstrainSelectedInstOperands,
     /*  305549 */     // GIR_Coverage, 9813,
     /*  305549 */     GIR_EraseRootFromParent_Done,
     /*  305550 */   // Label 5705: @305550
     /*  305550 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(305613), // Rule ID 9816 //
     /*  305555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  305569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  305572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305594 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  305594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305611 */     GIR_RootConstrainSelectedInstOperands,
     /*  305612 */     // GIR_Coverage, 9816,
     /*  305612 */     GIR_EraseRootFromParent_Done,
     /*  305613 */   // Label 5706: @305613
     /*  305613 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(305676), // Rule ID 9817 //
     /*  305618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  305632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  305635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305657 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  305657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305674 */     GIR_RootConstrainSelectedInstOperands,
     /*  305675 */     // GIR_Coverage, 9817,
     /*  305675 */     GIR_EraseRootFromParent_Done,
     /*  305676 */   // Label 5707: @305676
     /*  305676 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(305739), // Rule ID 9820 //
     /*  305681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  305695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  305698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305720 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305737 */     GIR_RootConstrainSelectedInstOperands,
     /*  305738 */     // GIR_Coverage, 9820,
     /*  305738 */     GIR_EraseRootFromParent_Done,
     /*  305739 */   // Label 5708: @305739
     /*  305739 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(305802), // Rule ID 9821 //
     /*  305744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  305758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  305761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305783 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305800 */     GIR_RootConstrainSelectedInstOperands,
     /*  305801 */     // GIR_Coverage, 9821,
     /*  305801 */     GIR_EraseRootFromParent_Done,
     /*  305802 */   // Label 5709: @305802
     /*  305802 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(305865), // Rule ID 9824 //
     /*  305807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  305821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  305824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305846 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305863 */     GIR_RootConstrainSelectedInstOperands,
     /*  305864 */     // GIR_Coverage, 9824,
     /*  305864 */     GIR_EraseRootFromParent_Done,
     /*  305865 */   // Label 5710: @305865
     /*  305865 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(305928), // Rule ID 9825 //
     /*  305870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  305884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  305887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305909 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305926 */     GIR_RootConstrainSelectedInstOperands,
     /*  305927 */     // GIR_Coverage, 9825,
     /*  305927 */     GIR_EraseRootFromParent_Done,
     /*  305928 */   // Label 5711: @305928
     /*  305928 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(305991), // Rule ID 9828 //
     /*  305933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  305947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  305950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305972 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305989 */     GIR_RootConstrainSelectedInstOperands,
     /*  305990 */     // GIR_Coverage, 9828,
     /*  305990 */     GIR_EraseRootFromParent_Done,
     /*  305991 */   // Label 5712: @305991
     /*  305991 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(306054), // Rule ID 9829 //
     /*  305996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  306010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  306013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306035 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  306035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  306038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306052 */     GIR_RootConstrainSelectedInstOperands,
     /*  306053 */     // GIR_Coverage, 9829,
     /*  306053 */     GIR_EraseRootFromParent_Done,
     /*  306054 */   // Label 5713: @306054
     /*  306054 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(306117), // Rule ID 9832 //
     /*  306059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  306073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  306076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306098 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  306101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306115 */     GIR_RootConstrainSelectedInstOperands,
     /*  306116 */     // GIR_Coverage, 9832,
     /*  306116 */     GIR_EraseRootFromParent_Done,
     /*  306117 */   // Label 5714: @306117
     /*  306117 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(306180), // Rule ID 9833 //
     /*  306122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  306136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  306139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306161 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  306164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306178 */     GIR_RootConstrainSelectedInstOperands,
     /*  306179 */     // GIR_Coverage, 9833,
     /*  306179 */     GIR_EraseRootFromParent_Done,
     /*  306180 */   // Label 5715: @306180
     /*  306180 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(306243), // Rule ID 9836 //
     /*  306185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  306199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  306202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306224 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  306227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306241 */     GIR_RootConstrainSelectedInstOperands,
     /*  306242 */     // GIR_Coverage, 9836,
     /*  306242 */     GIR_EraseRootFromParent_Done,
     /*  306243 */   // Label 5716: @306243
     /*  306243 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(306306), // Rule ID 9837 //
     /*  306248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  306262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  306265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306287 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  306290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306304 */     GIR_RootConstrainSelectedInstOperands,
     /*  306305 */     // GIR_Coverage, 9837,
     /*  306305 */     GIR_EraseRootFromParent_Done,
     /*  306306 */   // Label 5717: @306306
     /*  306306 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(306369), // Rule ID 9840 //
     /*  306311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  306325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  306328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306350 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306367 */     GIR_RootConstrainSelectedInstOperands,
     /*  306368 */     // GIR_Coverage, 9840,
     /*  306368 */     GIR_EraseRootFromParent_Done,
     /*  306369 */   // Label 5718: @306369
     /*  306369 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(306432), // Rule ID 9841 //
     /*  306374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  306388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  306391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306413 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306430 */     GIR_RootConstrainSelectedInstOperands,
     /*  306431 */     // GIR_Coverage, 9841,
     /*  306431 */     GIR_EraseRootFromParent_Done,
     /*  306432 */   // Label 5719: @306432
     /*  306432 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(306495), // Rule ID 9844 //
     /*  306437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  306451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  306454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306476 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  306479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306493 */     GIR_RootConstrainSelectedInstOperands,
     /*  306494 */     // GIR_Coverage, 9844,
     /*  306494 */     GIR_EraseRootFromParent_Done,
     /*  306495 */   // Label 5720: @306495
     /*  306495 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(306558), // Rule ID 9845 //
     /*  306500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  306514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  306517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306539 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  306542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306556 */     GIR_RootConstrainSelectedInstOperands,
     /*  306557 */     // GIR_Coverage, 9845,
     /*  306557 */     GIR_EraseRootFromParent_Done,
     /*  306558 */   // Label 5721: @306558
     /*  306558 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(306621), // Rule ID 9848 //
     /*  306563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  306577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  306580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306602 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306619 */     GIR_RootConstrainSelectedInstOperands,
     /*  306620 */     // GIR_Coverage, 9848,
     /*  306620 */     GIR_EraseRootFromParent_Done,
     /*  306621 */   // Label 5722: @306621
     /*  306621 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(306684), // Rule ID 9849 //
     /*  306626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  306640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  306643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306665 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306682 */     GIR_RootConstrainSelectedInstOperands,
     /*  306683 */     // GIR_Coverage, 9849,
     /*  306683 */     GIR_EraseRootFromParent_Done,
     /*  306684 */   // Label 5723: @306684
     /*  306684 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(306747), // Rule ID 9852 //
     /*  306689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  306703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  306706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  306728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306745 */     GIR_RootConstrainSelectedInstOperands,
     /*  306746 */     // GIR_Coverage, 9852,
     /*  306746 */     GIR_EraseRootFromParent_Done,
     /*  306747 */   // Label 5724: @306747
     /*  306747 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(306810), // Rule ID 9853 //
     /*  306752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  306766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  306769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306791 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306808 */     GIR_RootConstrainSelectedInstOperands,
     /*  306809 */     // GIR_Coverage, 9853,
     /*  306809 */     GIR_EraseRootFromParent_Done,
     /*  306810 */   // Label 5725: @306810
     /*  306810 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(306873), // Rule ID 9856 //
     /*  306815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  306829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  306832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306854 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306871 */     GIR_RootConstrainSelectedInstOperands,
     /*  306872 */     // GIR_Coverage, 9856,
     /*  306872 */     GIR_EraseRootFromParent_Done,
     /*  306873 */   // Label 5726: @306873
     /*  306873 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(306936), // Rule ID 9857 //
     /*  306878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  306892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  306895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306917 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306934 */     GIR_RootConstrainSelectedInstOperands,
     /*  306935 */     // GIR_Coverage, 9857,
     /*  306935 */     GIR_EraseRootFromParent_Done,
     /*  306936 */   // Label 5727: @306936
     /*  306936 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(306999), // Rule ID 9860 //
     /*  306941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  306955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  306958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306980 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306997 */     GIR_RootConstrainSelectedInstOperands,
     /*  306998 */     // GIR_Coverage, 9860,
     /*  306998 */     GIR_EraseRootFromParent_Done,
     /*  306999 */   // Label 5728: @306999
     /*  306999 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(307062), // Rule ID 9861 //
     /*  307004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  307018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  307021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307043 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  307046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307060 */     GIR_RootConstrainSelectedInstOperands,
     /*  307061 */     // GIR_Coverage, 9861,
     /*  307061 */     GIR_EraseRootFromParent_Done,
     /*  307062 */   // Label 5729: @307062
     /*  307062 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(307125), // Rule ID 9864 //
     /*  307067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  307081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  307084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307106 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  307109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307123 */     GIR_RootConstrainSelectedInstOperands,
     /*  307124 */     // GIR_Coverage, 9864,
     /*  307124 */     GIR_EraseRootFromParent_Done,
     /*  307125 */   // Label 5730: @307125
     /*  307125 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(307188), // Rule ID 9865 //
     /*  307130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  307144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  307147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307169 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  307172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307186 */     GIR_RootConstrainSelectedInstOperands,
     /*  307187 */     // GIR_Coverage, 9865,
     /*  307187 */     GIR_EraseRootFromParent_Done,
     /*  307188 */   // Label 5731: @307188
     /*  307188 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(307251), // Rule ID 9868 //
     /*  307193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  307196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  307207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  307210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  307232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  307235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307249 */     GIR_RootConstrainSelectedInstOperands,
     /*  307250 */     // GIR_Coverage, 9868,
     /*  307250 */     GIR_EraseRootFromParent_Done,
     /*  307251 */   // Label 5732: @307251
     /*  307251 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(307314), // Rule ID 9869 //
     /*  307256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  307259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  307270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  307273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307295 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  307295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  307298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307312 */     GIR_RootConstrainSelectedInstOperands,
     /*  307313 */     // GIR_Coverage, 9869,
     /*  307313 */     GIR_EraseRootFromParent_Done,
     /*  307314 */   // Label 5733: @307314
     /*  307314 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(307377), // Rule ID 9872 //
     /*  307319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  307333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  307336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307358 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307375 */     GIR_RootConstrainSelectedInstOperands,
     /*  307376 */     // GIR_Coverage, 9872,
     /*  307376 */     GIR_EraseRootFromParent_Done,
     /*  307377 */   // Label 5734: @307377
     /*  307377 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(307440), // Rule ID 9873 //
     /*  307382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  307396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  307399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307421 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307438 */     GIR_RootConstrainSelectedInstOperands,
     /*  307439 */     // GIR_Coverage, 9873,
     /*  307439 */     GIR_EraseRootFromParent_Done,
     /*  307440 */   // Label 5735: @307440
     /*  307440 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(307503), // Rule ID 9876 //
     /*  307445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  307459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  307462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307484 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307501 */     GIR_RootConstrainSelectedInstOperands,
     /*  307502 */     // GIR_Coverage, 9876,
     /*  307502 */     GIR_EraseRootFromParent_Done,
     /*  307503 */   // Label 5736: @307503
     /*  307503 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(307566), // Rule ID 9877 //
     /*  307508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  307522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  307525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307547 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307564 */     GIR_RootConstrainSelectedInstOperands,
     /*  307565 */     // GIR_Coverage, 9877,
     /*  307565 */     GIR_EraseRootFromParent_Done,
     /*  307566 */   // Label 5737: @307566
     /*  307566 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(307629), // Rule ID 9880 //
     /*  307571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  307582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  307585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  307588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307610 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307627 */     GIR_RootConstrainSelectedInstOperands,
     /*  307628 */     // GIR_Coverage, 9880,
     /*  307628 */     GIR_EraseRootFromParent_Done,
     /*  307629 */   // Label 5738: @307629
     /*  307629 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(307692), // Rule ID 9881 //
     /*  307634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  307645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  307648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  307651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307673 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307690 */     GIR_RootConstrainSelectedInstOperands,
     /*  307691 */     // GIR_Coverage, 9881,
     /*  307691 */     GIR_EraseRootFromParent_Done,
     /*  307692 */   // Label 5739: @307692
     /*  307692 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(307755), // Rule ID 9884 //
     /*  307697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  307711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  307714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307753 */     GIR_RootConstrainSelectedInstOperands,
     /*  307754 */     // GIR_Coverage, 9884,
     /*  307754 */     GIR_EraseRootFromParent_Done,
     /*  307755 */   // Label 5740: @307755
     /*  307755 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(307818), // Rule ID 9885 //
     /*  307760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  307774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  307777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307799 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307816 */     GIR_RootConstrainSelectedInstOperands,
     /*  307817 */     // GIR_Coverage, 9885,
     /*  307817 */     GIR_EraseRootFromParent_Done,
     /*  307818 */   // Label 5741: @307818
     /*  307818 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(307881), // Rule ID 9888 //
     /*  307823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  307837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  307840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307862 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307879 */     GIR_RootConstrainSelectedInstOperands,
     /*  307880 */     // GIR_Coverage, 9888,
     /*  307880 */     GIR_EraseRootFromParent_Done,
     /*  307881 */   // Label 5742: @307881
     /*  307881 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(307944), // Rule ID 9889 //
     /*  307886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  307900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  307903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307925 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307942 */     GIR_RootConstrainSelectedInstOperands,
     /*  307943 */     // GIR_Coverage, 9889,
     /*  307943 */     GIR_EraseRootFromParent_Done,
     /*  307944 */   // Label 5743: @307944
     /*  307944 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(308007), // Rule ID 9892 //
     /*  307949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  307963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  307966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307988 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308005 */     GIR_RootConstrainSelectedInstOperands,
     /*  308006 */     // GIR_Coverage, 9892,
     /*  308006 */     GIR_EraseRootFromParent_Done,
     /*  308007 */   // Label 5744: @308007
     /*  308007 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(308070), // Rule ID 9893 //
     /*  308012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  308023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  308026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  308029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308051 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  308051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308068 */     GIR_RootConstrainSelectedInstOperands,
     /*  308069 */     // GIR_Coverage, 9893,
     /*  308069 */     GIR_EraseRootFromParent_Done,
     /*  308070 */   // Label 5745: @308070
     /*  308070 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(308133), // Rule ID 9896 //
     /*  308075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  308089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  308092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308114 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  308114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  308117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308131 */     GIR_RootConstrainSelectedInstOperands,
     /*  308132 */     // GIR_Coverage, 9896,
     /*  308132 */     GIR_EraseRootFromParent_Done,
     /*  308133 */   // Label 5746: @308133
     /*  308133 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(308196), // Rule ID 9897 //
     /*  308138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  308152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  308155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308177 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  308177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  308180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308194 */     GIR_RootConstrainSelectedInstOperands,
     /*  308195 */     // GIR_Coverage, 9897,
     /*  308195 */     GIR_EraseRootFromParent_Done,
     /*  308196 */   // Label 5747: @308196
     /*  308196 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(308259), // Rule ID 9900 //
     /*  308201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  308215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  308218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308240 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  308240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  308243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308257 */     GIR_RootConstrainSelectedInstOperands,
     /*  308258 */     // GIR_Coverage, 9900,
     /*  308258 */     GIR_EraseRootFromParent_Done,
     /*  308259 */   // Label 5748: @308259
     /*  308259 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(308322), // Rule ID 9901 //
     /*  308264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  308278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  308281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308303 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  308303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  308306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308320 */     GIR_RootConstrainSelectedInstOperands,
     /*  308321 */     // GIR_Coverage, 9901,
     /*  308321 */     GIR_EraseRootFromParent_Done,
     /*  308322 */   // Label 5749: @308322
     /*  308322 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(308385), // Rule ID 9904 //
     /*  308327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  308338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  308341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  308344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308366 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  308366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308383 */     GIR_RootConstrainSelectedInstOperands,
     /*  308384 */     // GIR_Coverage, 9904,
     /*  308384 */     GIR_EraseRootFromParent_Done,
     /*  308385 */   // Label 5750: @308385
     /*  308385 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(308448), // Rule ID 9905 //
     /*  308390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  308401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  308404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  308407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308429 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  308429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308446 */     GIR_RootConstrainSelectedInstOperands,
     /*  308447 */     // GIR_Coverage, 9905,
     /*  308447 */     GIR_EraseRootFromParent_Done,
     /*  308448 */   // Label 5751: @308448
     /*  308448 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(308511), // Rule ID 9908 //
     /*  308453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  308456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  308464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  308467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  308470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308492 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  308492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  308495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308509 */     GIR_RootConstrainSelectedInstOperands,
     /*  308510 */     // GIR_Coverage, 9908,
     /*  308510 */     GIR_EraseRootFromParent_Done,
     /*  308511 */   // Label 5752: @308511
     /*  308511 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(308574), // Rule ID 9909 //
     /*  308516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  308519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  308527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  308530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  308533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308555 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  308555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  308558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308572 */     GIR_RootConstrainSelectedInstOperands,
     /*  308573 */     // GIR_Coverage, 9909,
     /*  308573 */     GIR_EraseRootFromParent_Done,
     /*  308574 */   // Label 5753: @308574
     /*  308574 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(308637), // Rule ID 9912 //
     /*  308579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  308582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  308593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  308596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308618 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  308618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  308621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308635 */     GIR_RootConstrainSelectedInstOperands,
     /*  308636 */     // GIR_Coverage, 9912,
     /*  308636 */     GIR_EraseRootFromParent_Done,
     /*  308637 */   // Label 5754: @308637
     /*  308637 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(308700), // Rule ID 9913 //
     /*  308642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  308645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  308656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  308659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308681 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  308681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  308684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308698 */     GIR_RootConstrainSelectedInstOperands,
     /*  308699 */     // GIR_Coverage, 9913,
     /*  308699 */     GIR_EraseRootFromParent_Done,
     /*  308700 */   // Label 5755: @308700
     /*  308700 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(308763), // Rule ID 9916 //
     /*  308705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  308708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  308719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  308722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308744 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  308744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308761 */     GIR_RootConstrainSelectedInstOperands,
     /*  308762 */     // GIR_Coverage, 9916,
     /*  308762 */     GIR_EraseRootFromParent_Done,
     /*  308763 */   // Label 5756: @308763
     /*  308763 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(308826), // Rule ID 9917 //
     /*  308768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  308771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  308782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  308785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308807 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  308807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308824 */     GIR_RootConstrainSelectedInstOperands,
     /*  308825 */     // GIR_Coverage, 9917,
     /*  308825 */     GIR_EraseRootFromParent_Done,
     /*  308826 */   // Label 5757: @308826
     /*  308826 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(308892), // Rule ID 13992 //
     /*  308831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  308842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  308845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  308848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308870 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  308870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  308873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308890 */     GIR_RootConstrainSelectedInstOperands,
     /*  308891 */     // GIR_Coverage, 13992,
     /*  308891 */     GIR_EraseRootFromParent_Done,
     /*  308892 */   // Label 5758: @308892
     /*  308892 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(308958), // Rule ID 13993 //
     /*  308897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  308908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  308911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  308914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308936 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  308936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  308939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308956 */     GIR_RootConstrainSelectedInstOperands,
     /*  308957 */     // GIR_Coverage, 13993,
     /*  308957 */     GIR_EraseRootFromParent_Done,
     /*  308958 */   // Label 5759: @308958
     /*  308958 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(309024), // Rule ID 13994 //
     /*  308963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  308974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  308977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  308980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  309005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309022 */     GIR_RootConstrainSelectedInstOperands,
     /*  309023 */     // GIR_Coverage, 13994,
     /*  309023 */     GIR_EraseRootFromParent_Done,
     /*  309024 */   // Label 5760: @309024
     /*  309024 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(309090), // Rule ID 13995 //
     /*  309029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  309040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  309043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  309046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309068 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  309071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309088 */     GIR_RootConstrainSelectedInstOperands,
     /*  309089 */     // GIR_Coverage, 13995,
     /*  309089 */     GIR_EraseRootFromParent_Done,
     /*  309090 */   // Label 5761: @309090
     /*  309090 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(309156), // Rule ID 13996 //
     /*  309095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  309106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  309109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  309112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309134 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309154 */     GIR_RootConstrainSelectedInstOperands,
     /*  309155 */     // GIR_Coverage, 13996,
     /*  309155 */     GIR_EraseRootFromParent_Done,
     /*  309156 */   // Label 5762: @309156
     /*  309156 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(309222), // Rule ID 13997 //
     /*  309161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  309172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  309175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  309178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309200 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309220 */     GIR_RootConstrainSelectedInstOperands,
     /*  309221 */     // GIR_Coverage, 13997,
     /*  309221 */     GIR_EraseRootFromParent_Done,
     /*  309222 */   // Label 5763: @309222
     /*  309222 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(309288), // Rule ID 13998 //
     /*  309227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  309238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  309241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  309244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309266 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  309269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309286 */     GIR_RootConstrainSelectedInstOperands,
     /*  309287 */     // GIR_Coverage, 13998,
     /*  309287 */     GIR_EraseRootFromParent_Done,
     /*  309288 */   // Label 5764: @309288
     /*  309288 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(309354), // Rule ID 13999 //
     /*  309293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  309304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  309307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  309310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309332 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  309335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309352 */     GIR_RootConstrainSelectedInstOperands,
     /*  309353 */     // GIR_Coverage, 13999,
     /*  309353 */     GIR_EraseRootFromParent_Done,
     /*  309354 */   // Label 5765: @309354
     /*  309354 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(309420), // Rule ID 14000 //
     /*  309359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  309370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  309373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  309376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309398 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309418 */     GIR_RootConstrainSelectedInstOperands,
     /*  309419 */     // GIR_Coverage, 14000,
     /*  309419 */     GIR_EraseRootFromParent_Done,
     /*  309420 */   // Label 5766: @309420
     /*  309420 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(309486), // Rule ID 14001 //
     /*  309425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  309436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  309439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  309442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309464 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309484 */     GIR_RootConstrainSelectedInstOperands,
     /*  309485 */     // GIR_Coverage, 14001,
     /*  309485 */     GIR_EraseRootFromParent_Done,
     /*  309486 */   // Label 5767: @309486
     /*  309486 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(309552), // Rule ID 14002 //
     /*  309491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  309502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  309505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  309508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309530 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  309530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309550 */     GIR_RootConstrainSelectedInstOperands,
     /*  309551 */     // GIR_Coverage, 14002,
     /*  309551 */     GIR_EraseRootFromParent_Done,
     /*  309552 */   // Label 5768: @309552
     /*  309552 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(309618), // Rule ID 14003 //
     /*  309557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  309568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  309571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  309574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  309596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309616 */     GIR_RootConstrainSelectedInstOperands,
     /*  309617 */     // GIR_Coverage, 14003,
     /*  309617 */     GIR_EraseRootFromParent_Done,
     /*  309618 */   // Label 5769: @309618
     /*  309618 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(309684), // Rule ID 14004 //
     /*  309623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  309634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  309637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  309640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309662 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309682 */     GIR_RootConstrainSelectedInstOperands,
     /*  309683 */     // GIR_Coverage, 14004,
     /*  309683 */     GIR_EraseRootFromParent_Done,
     /*  309684 */   // Label 5770: @309684
     /*  309684 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(309750), // Rule ID 14005 //
     /*  309689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  309700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  309703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  309706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309728 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309748 */     GIR_RootConstrainSelectedInstOperands,
     /*  309749 */     // GIR_Coverage, 14005,
     /*  309749 */     GIR_EraseRootFromParent_Done,
     /*  309750 */   // Label 5771: @309750
     /*  309750 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(309816), // Rule ID 14006 //
     /*  309755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  309766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  309769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  309772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309794 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309814 */     GIR_RootConstrainSelectedInstOperands,
     /*  309815 */     // GIR_Coverage, 14006,
     /*  309815 */     GIR_EraseRootFromParent_Done,
     /*  309816 */   // Label 5772: @309816
     /*  309816 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(309882), // Rule ID 14007 //
     /*  309821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  309832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  309835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  309838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309880 */     GIR_RootConstrainSelectedInstOperands,
     /*  309881 */     // GIR_Coverage, 14007,
     /*  309881 */     GIR_EraseRootFromParent_Done,
     /*  309882 */   // Label 5773: @309882
     /*  309882 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(309948), // Rule ID 14008 //
     /*  309887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  309898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  309901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  309904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309926 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  309926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309946 */     GIR_RootConstrainSelectedInstOperands,
     /*  309947 */     // GIR_Coverage, 14008,
     /*  309947 */     GIR_EraseRootFromParent_Done,
     /*  309948 */   // Label 5774: @309948
     /*  309948 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(310014), // Rule ID 14009 //
     /*  309953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  309964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  309967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  309970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309992 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  309992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310012 */     GIR_RootConstrainSelectedInstOperands,
     /*  310013 */     // GIR_Coverage, 14009,
     /*  310013 */     GIR_EraseRootFromParent_Done,
     /*  310014 */   // Label 5775: @310014
     /*  310014 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(310080), // Rule ID 14010 //
     /*  310019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  310022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  310030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  310033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  310036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310058 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  310058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  310061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310078 */     GIR_RootConstrainSelectedInstOperands,
     /*  310079 */     // GIR_Coverage, 14010,
     /*  310079 */     GIR_EraseRootFromParent_Done,
     /*  310080 */   // Label 5776: @310080
     /*  310080 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(310146), // Rule ID 14011 //
     /*  310085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  310088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  310096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  310099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  310102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  310124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  310127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310144 */     GIR_RootConstrainSelectedInstOperands,
     /*  310145 */     // GIR_Coverage, 14011,
     /*  310145 */     GIR_EraseRootFromParent_Done,
     /*  310146 */   // Label 5777: @310146
     /*  310146 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(310212), // Rule ID 14012 //
     /*  310151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  310162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  310165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  310168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  310190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310210 */     GIR_RootConstrainSelectedInstOperands,
     /*  310211 */     // GIR_Coverage, 14012,
     /*  310211 */     GIR_EraseRootFromParent_Done,
     /*  310212 */   // Label 5778: @310212
     /*  310212 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(310278), // Rule ID 14013 //
     /*  310217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  310228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  310231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  310234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  310256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310276 */     GIR_RootConstrainSelectedInstOperands,
     /*  310277 */     // GIR_Coverage, 14013,
     /*  310277 */     GIR_EraseRootFromParent_Done,
     /*  310278 */   // Label 5779: @310278
     /*  310278 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(310344), // Rule ID 14014 //
     /*  310283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  310294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  310297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  310300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310322 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  310322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310342 */     GIR_RootConstrainSelectedInstOperands,
     /*  310343 */     // GIR_Coverage, 14014,
     /*  310343 */     GIR_EraseRootFromParent_Done,
     /*  310344 */   // Label 5780: @310344
     /*  310344 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(310410), // Rule ID 14015 //
     /*  310349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  310360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  310363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  310366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310388 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  310388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310408 */     GIR_RootConstrainSelectedInstOperands,
     /*  310409 */     // GIR_Coverage, 14015,
     /*  310409 */     GIR_EraseRootFromParent_Done,
     /*  310410 */   // Label 5781: @310410
     /*  310410 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(310476), // Rule ID 14016 //
     /*  310415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  310426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  310429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  310432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310454 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  310454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310474 */     GIR_RootConstrainSelectedInstOperands,
     /*  310475 */     // GIR_Coverage, 14016,
     /*  310475 */     GIR_EraseRootFromParent_Done,
     /*  310476 */   // Label 5782: @310476
     /*  310476 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(310542), // Rule ID 14017 //
     /*  310481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  310492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  310495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  310498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310520 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  310520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310540 */     GIR_RootConstrainSelectedInstOperands,
     /*  310541 */     // GIR_Coverage, 14017,
     /*  310541 */     GIR_EraseRootFromParent_Done,
     /*  310542 */   // Label 5783: @310542
     /*  310542 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(310608), // Rule ID 14018 //
     /*  310547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  310558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  310561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  310564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310586 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310606 */     GIR_RootConstrainSelectedInstOperands,
     /*  310607 */     // GIR_Coverage, 14018,
     /*  310607 */     GIR_EraseRootFromParent_Done,
     /*  310608 */   // Label 5784: @310608
     /*  310608 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(310674), // Rule ID 14019 //
     /*  310613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  310624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  310627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  310630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310672 */     GIR_RootConstrainSelectedInstOperands,
     /*  310673 */     // GIR_Coverage, 14019,
     /*  310673 */     GIR_EraseRootFromParent_Done,
     /*  310674 */   // Label 5785: @310674
     /*  310674 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(310740), // Rule ID 14020 //
     /*  310679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  310690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  310693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  310696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310718 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310738 */     GIR_RootConstrainSelectedInstOperands,
     /*  310739 */     // GIR_Coverage, 14020,
     /*  310739 */     GIR_EraseRootFromParent_Done,
     /*  310740 */   // Label 5786: @310740
     /*  310740 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(310806), // Rule ID 14021 //
     /*  310745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  310756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  310759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  310762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310784 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310804 */     GIR_RootConstrainSelectedInstOperands,
     /*  310805 */     // GIR_Coverage, 14021,
     /*  310805 */     GIR_EraseRootFromParent_Done,
     /*  310806 */   // Label 5787: @310806
     /*  310806 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(310872), // Rule ID 14022 //
     /*  310811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  310822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  310825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  310828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310850 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310870 */     GIR_RootConstrainSelectedInstOperands,
     /*  310871 */     // GIR_Coverage, 14022,
     /*  310871 */     GIR_EraseRootFromParent_Done,
     /*  310872 */   // Label 5788: @310872
     /*  310872 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(310938), // Rule ID 14023 //
     /*  310877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  310888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  310891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  310894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310916 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310936 */     GIR_RootConstrainSelectedInstOperands,
     /*  310937 */     // GIR_Coverage, 14023,
     /*  310937 */     GIR_EraseRootFromParent_Done,
     /*  310938 */   // Label 5789: @310938
     /*  310938 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(311004), // Rule ID 14024 //
     /*  310943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  310954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  310957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  310960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311002 */     GIR_RootConstrainSelectedInstOperands,
     /*  311003 */     // GIR_Coverage, 14024,
     /*  311003 */     GIR_EraseRootFromParent_Done,
     /*  311004 */   // Label 5790: @311004
     /*  311004 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(311070), // Rule ID 14025 //
     /*  311009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  311020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  311023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  311026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  311051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311068 */     GIR_RootConstrainSelectedInstOperands,
     /*  311069 */     // GIR_Coverage, 14025,
     /*  311069 */     GIR_EraseRootFromParent_Done,
     /*  311070 */   // Label 5791: @311070
     /*  311070 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(311136), // Rule ID 14026 //
     /*  311075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  311086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  311089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  311092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311114 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311134 */     GIR_RootConstrainSelectedInstOperands,
     /*  311135 */     // GIR_Coverage, 14026,
     /*  311135 */     GIR_EraseRootFromParent_Done,
     /*  311136 */   // Label 5792: @311136
     /*  311136 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(311202), // Rule ID 14027 //
     /*  311141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  311152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  311155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  311158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311180 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311200 */     GIR_RootConstrainSelectedInstOperands,
     /*  311201 */     // GIR_Coverage, 14027,
     /*  311201 */     GIR_EraseRootFromParent_Done,
     /*  311202 */   // Label 5793: @311202
     /*  311202 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(311268), // Rule ID 14028 //
     /*  311207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  311218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  311221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  311224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311246 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311266 */     GIR_RootConstrainSelectedInstOperands,
     /*  311267 */     // GIR_Coverage, 14028,
     /*  311267 */     GIR_EraseRootFromParent_Done,
     /*  311268 */   // Label 5794: @311268
     /*  311268 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(311334), // Rule ID 14029 //
     /*  311273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  311284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  311287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  311290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311312 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311332 */     GIR_RootConstrainSelectedInstOperands,
     /*  311333 */     // GIR_Coverage, 14029,
     /*  311333 */     GIR_EraseRootFromParent_Done,
     /*  311334 */   // Label 5795: @311334
     /*  311334 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(311400), // Rule ID 14030 //
     /*  311339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  311350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  311353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  311356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  311381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311398 */     GIR_RootConstrainSelectedInstOperands,
     /*  311399 */     // GIR_Coverage, 14030,
     /*  311399 */     GIR_EraseRootFromParent_Done,
     /*  311400 */   // Label 5796: @311400
     /*  311400 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(311466), // Rule ID 14031 //
     /*  311405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  311408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  311416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  311419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  311422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  311444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  311447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311464 */     GIR_RootConstrainSelectedInstOperands,
     /*  311465 */     // GIR_Coverage, 14031,
     /*  311465 */     GIR_EraseRootFromParent_Done,
     /*  311466 */   // Label 5797: @311466
     /*  311466 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(311532), // Rule ID 14032 //
     /*  311471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  311482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  311485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  311488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311510 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311530 */     GIR_RootConstrainSelectedInstOperands,
     /*  311531 */     // GIR_Coverage, 14032,
     /*  311531 */     GIR_EraseRootFromParent_Done,
     /*  311532 */   // Label 5798: @311532
     /*  311532 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(311598), // Rule ID 14033 //
     /*  311537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  311540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  311548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  311551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  311554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311576 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  311576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311596 */     GIR_RootConstrainSelectedInstOperands,
     /*  311597 */     // GIR_Coverage, 14033,
     /*  311597 */     GIR_EraseRootFromParent_Done,
     /*  311598 */   // Label 5799: @311598
     /*  311598 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(311664), // Rule ID 14034 //
     /*  311603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  311614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  311617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  311620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311662 */     GIR_RootConstrainSelectedInstOperands,
     /*  311663 */     // GIR_Coverage, 14034,
     /*  311663 */     GIR_EraseRootFromParent_Done,
     /*  311664 */   // Label 5800: @311664
     /*  311664 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(311730), // Rule ID 14035 //
     /*  311669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  311672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  311680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  311683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  311686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311708 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  311708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311728 */     GIR_RootConstrainSelectedInstOperands,
     /*  311729 */     // GIR_Coverage, 14035,
     /*  311729 */     GIR_EraseRootFromParent_Done,
     /*  311730 */   // Label 5801: @311730
     /*  311730 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(311796), // Rule ID 14036 //
     /*  311735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  311746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  311749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  311752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311774 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  311777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311794 */     GIR_RootConstrainSelectedInstOperands,
     /*  311795 */     // GIR_Coverage, 14036,
     /*  311795 */     GIR_EraseRootFromParent_Done,
     /*  311796 */   // Label 5802: @311796
     /*  311796 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(311862), // Rule ID 14037 //
     /*  311801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  311812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  311815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  311818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311840 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  311843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311860 */     GIR_RootConstrainSelectedInstOperands,
     /*  311861 */     // GIR_Coverage, 14037,
     /*  311861 */     GIR_EraseRootFromParent_Done,
     /*  311862 */   // Label 5803: @311862
     /*  311862 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(311928), // Rule ID 14038 //
     /*  311867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  311878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  311881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  311884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311906 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311926 */     GIR_RootConstrainSelectedInstOperands,
     /*  311927 */     // GIR_Coverage, 14038,
     /*  311927 */     GIR_EraseRootFromParent_Done,
     /*  311928 */   // Label 5804: @311928
     /*  311928 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(311994), // Rule ID 14039 //
     /*  311933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  311944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  311947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  311950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311972 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311992 */     GIR_RootConstrainSelectedInstOperands,
     /*  311993 */     // GIR_Coverage, 14039,
     /*  311993 */     GIR_EraseRootFromParent_Done,
     /*  311994 */   // Label 5805: @311994
     /*  311994 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(312060), // Rule ID 14040 //
     /*  311999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  312010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  312013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  312016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312038 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312058 */     GIR_RootConstrainSelectedInstOperands,
     /*  312059 */     // GIR_Coverage, 14040,
     /*  312059 */     GIR_EraseRootFromParent_Done,
     /*  312060 */   // Label 5806: @312060
     /*  312060 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(312126), // Rule ID 14041 //
     /*  312065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  312076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  312079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  312082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312104 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312124 */     GIR_RootConstrainSelectedInstOperands,
     /*  312125 */     // GIR_Coverage, 14041,
     /*  312125 */     GIR_EraseRootFromParent_Done,
     /*  312126 */   // Label 5807: @312126
     /*  312126 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(312192), // Rule ID 14042 //
     /*  312131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  312142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  312145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  312148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312170 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312190 */     GIR_RootConstrainSelectedInstOperands,
     /*  312191 */     // GIR_Coverage, 14042,
     /*  312191 */     GIR_EraseRootFromParent_Done,
     /*  312192 */   // Label 5808: @312192
     /*  312192 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(312258), // Rule ID 14043 //
     /*  312197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  312208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  312211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  312214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312236 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312256 */     GIR_RootConstrainSelectedInstOperands,
     /*  312257 */     // GIR_Coverage, 14043,
     /*  312257 */     GIR_EraseRootFromParent_Done,
     /*  312258 */   // Label 5809: @312258
     /*  312258 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(312324), // Rule ID 14044 //
     /*  312263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  312274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  312277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  312280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312302 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312322 */     GIR_RootConstrainSelectedInstOperands,
     /*  312323 */     // GIR_Coverage, 14044,
     /*  312323 */     GIR_EraseRootFromParent_Done,
     /*  312324 */   // Label 5810: @312324
     /*  312324 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(312390), // Rule ID 14045 //
     /*  312329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  312340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  312343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  312346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312368 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312388 */     GIR_RootConstrainSelectedInstOperands,
     /*  312389 */     // GIR_Coverage, 14045,
     /*  312389 */     GIR_EraseRootFromParent_Done,
     /*  312390 */   // Label 5811: @312390
     /*  312390 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(312456), // Rule ID 14046 //
     /*  312395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  312398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  312406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  312409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  312412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312434 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  312434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312454 */     GIR_RootConstrainSelectedInstOperands,
     /*  312455 */     // GIR_Coverage, 14046,
     /*  312455 */     GIR_EraseRootFromParent_Done,
     /*  312456 */   // Label 5812: @312456
     /*  312456 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(312522), // Rule ID 14047 //
     /*  312461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  312464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  312472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  312475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  312478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312500 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  312500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312520 */     GIR_RootConstrainSelectedInstOperands,
     /*  312521 */     // GIR_Coverage, 14047,
     /*  312521 */     GIR_EraseRootFromParent_Done,
     /*  312522 */   // Label 5813: @312522
     /*  312522 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(312588), // Rule ID 14048 //
     /*  312527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  312538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  312541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  312544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312566 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312586 */     GIR_RootConstrainSelectedInstOperands,
     /*  312587 */     // GIR_Coverage, 14048,
     /*  312587 */     GIR_EraseRootFromParent_Done,
     /*  312588 */   // Label 5814: @312588
     /*  312588 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(312654), // Rule ID 14049 //
     /*  312593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  312604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  312607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  312610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312632 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312652 */     GIR_RootConstrainSelectedInstOperands,
     /*  312653 */     // GIR_Coverage, 14049,
     /*  312653 */     GIR_EraseRootFromParent_Done,
     /*  312654 */   // Label 5815: @312654
     /*  312654 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(312720), // Rule ID 14050 //
     /*  312659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  312670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  312673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  312676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312698 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312718 */     GIR_RootConstrainSelectedInstOperands,
     /*  312719 */     // GIR_Coverage, 14050,
     /*  312719 */     GIR_EraseRootFromParent_Done,
     /*  312720 */   // Label 5816: @312720
     /*  312720 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(312786), // Rule ID 14051 //
     /*  312725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  312736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  312739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  312742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312764 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312784 */     GIR_RootConstrainSelectedInstOperands,
     /*  312785 */     // GIR_Coverage, 14051,
     /*  312785 */     GIR_EraseRootFromParent_Done,
     /*  312786 */   // Label 5817: @312786
     /*  312786 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(312852), // Rule ID 14052 //
     /*  312791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  312802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  312805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  312808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312830 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312850 */     GIR_RootConstrainSelectedInstOperands,
     /*  312851 */     // GIR_Coverage, 14052,
     /*  312851 */     GIR_EraseRootFromParent_Done,
     /*  312852 */   // Label 5818: @312852
     /*  312852 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(312918), // Rule ID 14053 //
     /*  312857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  312868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  312871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  312874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312896 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312916 */     GIR_RootConstrainSelectedInstOperands,
     /*  312917 */     // GIR_Coverage, 14053,
     /*  312917 */     GIR_EraseRootFromParent_Done,
     /*  312918 */   // Label 5819: @312918
     /*  312918 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(312984), // Rule ID 14054 //
     /*  312923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  312934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  312937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  312940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312962 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312982 */     GIR_RootConstrainSelectedInstOperands,
     /*  312983 */     // GIR_Coverage, 14054,
     /*  312983 */     GIR_EraseRootFromParent_Done,
     /*  312984 */   // Label 5820: @312984
     /*  312984 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(313050), // Rule ID 14055 //
     /*  312989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  313000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  313003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  313006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313028 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  313031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313048 */     GIR_RootConstrainSelectedInstOperands,
     /*  313049 */     // GIR_Coverage, 14055,
     /*  313049 */     GIR_EraseRootFromParent_Done,
     /*  313050 */   // Label 5821: @313050
     /*  313050 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(313116), // Rule ID 14056 //
     /*  313055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  313066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  313069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  313072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313094 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313114 */     GIR_RootConstrainSelectedInstOperands,
     /*  313115 */     // GIR_Coverage, 14056,
     /*  313115 */     GIR_EraseRootFromParent_Done,
     /*  313116 */   // Label 5822: @313116
     /*  313116 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(313182), // Rule ID 14057 //
     /*  313121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  313132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  313135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  313138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313160 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313180 */     GIR_RootConstrainSelectedInstOperands,
     /*  313181 */     // GIR_Coverage, 14057,
     /*  313181 */     GIR_EraseRootFromParent_Done,
     /*  313182 */   // Label 5823: @313182
     /*  313182 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(313248), // Rule ID 14058 //
     /*  313187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  313198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  313201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  313204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313226 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313246 */     GIR_RootConstrainSelectedInstOperands,
     /*  313247 */     // GIR_Coverage, 14058,
     /*  313247 */     GIR_EraseRootFromParent_Done,
     /*  313248 */   // Label 5824: @313248
     /*  313248 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(313314), // Rule ID 14059 //
     /*  313253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  313264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  313267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  313270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313292 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313312 */     GIR_RootConstrainSelectedInstOperands,
     /*  313313 */     // GIR_Coverage, 14059,
     /*  313313 */     GIR_EraseRootFromParent_Done,
     /*  313314 */   // Label 5825: @313314
     /*  313314 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(313380), // Rule ID 14060 //
     /*  313319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  313322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  313330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  313333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  313336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313358 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  313361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313378 */     GIR_RootConstrainSelectedInstOperands,
     /*  313379 */     // GIR_Coverage, 14060,
     /*  313379 */     GIR_EraseRootFromParent_Done,
     /*  313380 */   // Label 5826: @313380
     /*  313380 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(313446), // Rule ID 14061 //
     /*  313385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  313396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  313399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  313402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313424 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  313427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313444 */     GIR_RootConstrainSelectedInstOperands,
     /*  313445 */     // GIR_Coverage, 14061,
     /*  313445 */     GIR_EraseRootFromParent_Done,
     /*  313446 */   // Label 5827: @313446
     /*  313446 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(313512), // Rule ID 14062 //
     /*  313451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  313454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  313462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  313465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  313468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313490 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313510 */     GIR_RootConstrainSelectedInstOperands,
     /*  313511 */     // GIR_Coverage, 14062,
     /*  313511 */     GIR_EraseRootFromParent_Done,
     /*  313512 */   // Label 5828: @313512
     /*  313512 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(313578), // Rule ID 14063 //
     /*  313517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  313528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  313531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  313534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313556 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313576 */     GIR_RootConstrainSelectedInstOperands,
     /*  313577 */     // GIR_Coverage, 14063,
     /*  313577 */     GIR_EraseRootFromParent_Done,
     /*  313578 */   // Label 5829: @313578
     /*  313578 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(313644), // Rule ID 14064 //
     /*  313583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  313586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  313594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  313597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  313600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313622 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313642 */     GIR_RootConstrainSelectedInstOperands,
     /*  313643 */     // GIR_Coverage, 14064,
     /*  313643 */     GIR_EraseRootFromParent_Done,
     /*  313644 */   // Label 5830: @313644
     /*  313644 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(313710), // Rule ID 14065 //
     /*  313649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  313660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  313663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  313666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313688 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313708 */     GIR_RootConstrainSelectedInstOperands,
     /*  313709 */     // GIR_Coverage, 14065,
     /*  313709 */     GIR_EraseRootFromParent_Done,
     /*  313710 */   // Label 5831: @313710
     /*  313710 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(313776), // Rule ID 19068 //
     /*  313715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  313726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  313729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  313732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313754 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  313757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313774 */     GIR_RootConstrainSelectedInstOperands,
     /*  313775 */     // GIR_Coverage, 19068,
     /*  313775 */     GIR_EraseRootFromParent_Done,
     /*  313776 */   // Label 5832: @313776
     /*  313776 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(313842), // Rule ID 19069 //
     /*  313781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  313784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  313792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  313795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  313798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313820 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  313820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  313823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313840 */     GIR_RootConstrainSelectedInstOperands,
     /*  313841 */     // GIR_Coverage, 19069,
     /*  313841 */     GIR_EraseRootFromParent_Done,
     /*  313842 */   // Label 5833: @313842
     /*  313842 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(313908), // Rule ID 19072 //
     /*  313847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  313858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  313861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  313864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313886 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  313889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313906 */     GIR_RootConstrainSelectedInstOperands,
     /*  313907 */     // GIR_Coverage, 19072,
     /*  313907 */     GIR_EraseRootFromParent_Done,
     /*  313908 */   // Label 5834: @313908
     /*  313908 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(313974), // Rule ID 19073 //
     /*  313913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  313924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  313927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  313930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313952 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  313955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313972 */     GIR_RootConstrainSelectedInstOperands,
     /*  313973 */     // GIR_Coverage, 19073,
     /*  313973 */     GIR_EraseRootFromParent_Done,
     /*  313974 */   // Label 5835: @313974
     /*  313974 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(314040), // Rule ID 19076 //
     /*  313979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  313990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  313993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314018 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  314021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314038 */     GIR_RootConstrainSelectedInstOperands,
     /*  314039 */     // GIR_Coverage, 19076,
     /*  314039 */     GIR_EraseRootFromParent_Done,
     /*  314040 */   // Label 5836: @314040
     /*  314040 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(314106), // Rule ID 19077 //
     /*  314045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  314056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  314059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  314062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314084 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  314087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314104 */     GIR_RootConstrainSelectedInstOperands,
     /*  314105 */     // GIR_Coverage, 19077,
     /*  314105 */     GIR_EraseRootFromParent_Done,
     /*  314106 */   // Label 5837: @314106
     /*  314106 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(314172), // Rule ID 19080 //
     /*  314111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  314122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  314125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  314128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314150 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  314153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314170 */     GIR_RootConstrainSelectedInstOperands,
     /*  314171 */     // GIR_Coverage, 19080,
     /*  314171 */     GIR_EraseRootFromParent_Done,
     /*  314172 */   // Label 5838: @314172
     /*  314172 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(314238), // Rule ID 19081 //
     /*  314177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  314188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  314191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  314194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314216 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  314219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314236 */     GIR_RootConstrainSelectedInstOperands,
     /*  314237 */     // GIR_Coverage, 19081,
     /*  314237 */     GIR_EraseRootFromParent_Done,
     /*  314238 */   // Label 5839: @314238
     /*  314238 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(314304), // Rule ID 19084 //
     /*  314243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  314246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  314254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  314257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  314260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314282 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  314285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314302 */     GIR_RootConstrainSelectedInstOperands,
     /*  314303 */     // GIR_Coverage, 19084,
     /*  314303 */     GIR_EraseRootFromParent_Done,
     /*  314304 */   // Label 5840: @314304
     /*  314304 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(314370), // Rule ID 19085 //
     /*  314309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  314312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  314320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  314323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  314326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314348 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  314351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314368 */     GIR_RootConstrainSelectedInstOperands,
     /*  314369 */     // GIR_Coverage, 19085,
     /*  314369 */     GIR_EraseRootFromParent_Done,
     /*  314370 */   // Label 5841: @314370
     /*  314370 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(314436), // Rule ID 19088 //
     /*  314375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  314386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  314389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  314392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314414 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  314417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314434 */     GIR_RootConstrainSelectedInstOperands,
     /*  314435 */     // GIR_Coverage, 19088,
     /*  314435 */     GIR_EraseRootFromParent_Done,
     /*  314436 */   // Label 5842: @314436
     /*  314436 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(314502), // Rule ID 19089 //
     /*  314441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  314452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  314455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  314458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314480 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  314483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314500 */     GIR_RootConstrainSelectedInstOperands,
     /*  314501 */     // GIR_Coverage, 19089,
     /*  314501 */     GIR_EraseRootFromParent_Done,
     /*  314502 */   // Label 5843: @314502
     /*  314502 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(314568), // Rule ID 19092 //
     /*  314507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  314518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  314521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314546 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  314549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314566 */     GIR_RootConstrainSelectedInstOperands,
     /*  314567 */     // GIR_Coverage, 19092,
     /*  314567 */     GIR_EraseRootFromParent_Done,
     /*  314568 */   // Label 5844: @314568
     /*  314568 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(314634), // Rule ID 19093 //
     /*  314573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  314584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  314587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314612 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  314615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314632 */     GIR_RootConstrainSelectedInstOperands,
     /*  314633 */     // GIR_Coverage, 19093,
     /*  314633 */     GIR_EraseRootFromParent_Done,
     /*  314634 */   // Label 5845: @314634
     /*  314634 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(314700), // Rule ID 19096 //
     /*  314639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  314650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  314653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314678 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  314681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314698 */     GIR_RootConstrainSelectedInstOperands,
     /*  314699 */     // GIR_Coverage, 19096,
     /*  314699 */     GIR_EraseRootFromParent_Done,
     /*  314700 */   // Label 5846: @314700
     /*  314700 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(314766), // Rule ID 19097 //
     /*  314705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  314716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  314719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314744 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  314747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314764 */     GIR_RootConstrainSelectedInstOperands,
     /*  314765 */     // GIR_Coverage, 19097,
     /*  314765 */     GIR_EraseRootFromParent_Done,
     /*  314766 */   // Label 5847: @314766
     /*  314766 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(314832), // Rule ID 19100 //
     /*  314771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  314782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  314785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314810 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  314813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314830 */     GIR_RootConstrainSelectedInstOperands,
     /*  314831 */     // GIR_Coverage, 19100,
     /*  314831 */     GIR_EraseRootFromParent_Done,
     /*  314832 */   // Label 5848: @314832
     /*  314832 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(314898), // Rule ID 19101 //
     /*  314837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  314848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  314851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314876 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  314879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314896 */     GIR_RootConstrainSelectedInstOperands,
     /*  314897 */     // GIR_Coverage, 19101,
     /*  314897 */     GIR_EraseRootFromParent_Done,
     /*  314898 */   // Label 5849: @314898
     /*  314898 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(314964), // Rule ID 19104 //
     /*  314903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  314914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314942 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  314945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314962 */     GIR_RootConstrainSelectedInstOperands,
     /*  314963 */     // GIR_Coverage, 19104,
     /*  314963 */     GIR_EraseRootFromParent_Done,
     /*  314964 */   // Label 5850: @314964
     /*  314964 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(315030), // Rule ID 19105 //
     /*  314969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  314980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315008 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  315008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  315011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315028 */     GIR_RootConstrainSelectedInstOperands,
     /*  315029 */     // GIR_Coverage, 19105,
     /*  315029 */     GIR_EraseRootFromParent_Done,
     /*  315030 */   // Label 5851: @315030
     /*  315030 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(315096), // Rule ID 19108 //
     /*  315035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  315046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  315049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  315052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315074 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  315074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  315077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315094 */     GIR_RootConstrainSelectedInstOperands,
     /*  315095 */     // GIR_Coverage, 19108,
     /*  315095 */     GIR_EraseRootFromParent_Done,
     /*  315096 */   // Label 5852: @315096
     /*  315096 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(315162), // Rule ID 19109 //
     /*  315101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  315112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  315115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  315118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315140 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  315140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  315143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315160 */     GIR_RootConstrainSelectedInstOperands,
     /*  315161 */     // GIR_Coverage, 19109,
     /*  315161 */     GIR_EraseRootFromParent_Done,
     /*  315162 */   // Label 5853: @315162
     /*  315162 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(315228), // Rule ID 19112 //
     /*  315167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  315170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  315178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  315181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  315184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315206 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  315206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  315209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315226 */     GIR_RootConstrainSelectedInstOperands,
     /*  315227 */     // GIR_Coverage, 19112,
     /*  315227 */     GIR_EraseRootFromParent_Done,
     /*  315228 */   // Label 5854: @315228
     /*  315228 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(315294), // Rule ID 19113 //
     /*  315233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  315244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  315247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  315250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315272 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  315272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  315275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315292 */     GIR_RootConstrainSelectedInstOperands,
     /*  315293 */     // GIR_Coverage, 19113,
     /*  315293 */     GIR_EraseRootFromParent_Done,
     /*  315294 */   // Label 5855: @315294
     /*  315294 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(315360), // Rule ID 19116 //
     /*  315299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  315302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  315310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  315313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  315316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315338 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  315338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  315341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315358 */     GIR_RootConstrainSelectedInstOperands,
     /*  315359 */     // GIR_Coverage, 19116,
     /*  315359 */     GIR_EraseRootFromParent_Done,
     /*  315360 */   // Label 5856: @315360
     /*  315360 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(315426), // Rule ID 19117 //
     /*  315365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  315376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  315379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  315382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315404 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  315404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  315407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315424 */     GIR_RootConstrainSelectedInstOperands,
     /*  315425 */     // GIR_Coverage, 19117,
     /*  315425 */     GIR_EraseRootFromParent_Done,
     /*  315426 */   // Label 5857: @315426
     /*  315426 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(315492), // Rule ID 19120 //
     /*  315431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  315434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  315442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  315445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  315448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315470 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  315470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  315473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315490 */     GIR_RootConstrainSelectedInstOperands,
     /*  315491 */     // GIR_Coverage, 19120,
     /*  315491 */     GIR_EraseRootFromParent_Done,
     /*  315492 */   // Label 5858: @315492
     /*  315492 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(315558), // Rule ID 19121 //
     /*  315497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  315508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  315511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  315514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315536 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  315536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  315539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315556 */     GIR_RootConstrainSelectedInstOperands,
     /*  315557 */     // GIR_Coverage, 19121,
     /*  315557 */     GIR_EraseRootFromParent_Done,
     /*  315558 */   // Label 5859: @315558
     /*  315558 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(315621), // Rule ID 19784 //
     /*  315563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  315577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315602 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  315605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315619 */     GIR_RootConstrainSelectedInstOperands,
     /*  315620 */     // GIR_Coverage, 19784,
     /*  315620 */     GIR_EraseRootFromParent_Done,
     /*  315621 */   // Label 5860: @315621
     /*  315621 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(315684), // Rule ID 19785 //
     /*  315626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  315640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315665 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  315668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315682 */     GIR_RootConstrainSelectedInstOperands,
     /*  315683 */     // GIR_Coverage, 19785,
     /*  315683 */     GIR_EraseRootFromParent_Done,
     /*  315684 */   // Label 5861: @315684
     /*  315684 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(315747), // Rule ID 19788 //
     /*  315689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  315703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315728 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315745 */     GIR_RootConstrainSelectedInstOperands,
     /*  315746 */     // GIR_Coverage, 19788,
     /*  315746 */     GIR_EraseRootFromParent_Done,
     /*  315747 */   // Label 5862: @315747
     /*  315747 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(315810), // Rule ID 19789 //
     /*  315752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  315766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315791 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315808 */     GIR_RootConstrainSelectedInstOperands,
     /*  315809 */     // GIR_Coverage, 19789,
     /*  315809 */     GIR_EraseRootFromParent_Done,
     /*  315810 */   // Label 5863: @315810
     /*  315810 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(315873), // Rule ID 19792 //
     /*  315815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  315832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315854 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  315854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315871 */     GIR_RootConstrainSelectedInstOperands,
     /*  315872 */     // GIR_Coverage, 19792,
     /*  315872 */     GIR_EraseRootFromParent_Done,
     /*  315873 */   // Label 5864: @315873
     /*  315873 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(315936), // Rule ID 19793 //
     /*  315878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  315895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315917 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  315917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315934 */     GIR_RootConstrainSelectedInstOperands,
     /*  315935 */     // GIR_Coverage, 19793,
     /*  315935 */     GIR_EraseRootFromParent_Done,
     /*  315936 */   // Label 5865: @315936
     /*  315936 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(315999), // Rule ID 19796 //
     /*  315941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  315952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  315955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  315958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315980 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315997 */     GIR_RootConstrainSelectedInstOperands,
     /*  315998 */     // GIR_Coverage, 19796,
     /*  315998 */     GIR_EraseRootFromParent_Done,
     /*  315999 */   // Label 5866: @315999
     /*  315999 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(316062), // Rule ID 19797 //
     /*  316004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  316018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  316021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316043 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  316046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316060 */     GIR_RootConstrainSelectedInstOperands,
     /*  316061 */     // GIR_Coverage, 19797,
     /*  316061 */     GIR_EraseRootFromParent_Done,
     /*  316062 */   // Label 5867: @316062
     /*  316062 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(316125), // Rule ID 19800 //
     /*  316067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  316081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  316084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316106 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  316109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316123 */     GIR_RootConstrainSelectedInstOperands,
     /*  316124 */     // GIR_Coverage, 19800,
     /*  316124 */     GIR_EraseRootFromParent_Done,
     /*  316125 */   // Label 5868: @316125
     /*  316125 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(316188), // Rule ID 19801 //
     /*  316130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  316144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  316147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316169 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  316172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316186 */     GIR_RootConstrainSelectedInstOperands,
     /*  316187 */     // GIR_Coverage, 19801,
     /*  316187 */     GIR_EraseRootFromParent_Done,
     /*  316188 */   // Label 5869: @316188
     /*  316188 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(316251), // Rule ID 19804 //
     /*  316193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  316204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  316207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  316210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  316232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  316235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316249 */     GIR_RootConstrainSelectedInstOperands,
     /*  316250 */     // GIR_Coverage, 19804,
     /*  316250 */     GIR_EraseRootFromParent_Done,
     /*  316251 */   // Label 5870: @316251
     /*  316251 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(316314), // Rule ID 19805 //
     /*  316256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  316267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  316270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  316273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316295 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  316295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  316298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316312 */     GIR_RootConstrainSelectedInstOperands,
     /*  316313 */     // GIR_Coverage, 19805,
     /*  316313 */     GIR_EraseRootFromParent_Done,
     /*  316314 */   // Label 5871: @316314
     /*  316314 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(316377), // Rule ID 19808 //
     /*  316319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  316333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  316336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316358 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316375 */     GIR_RootConstrainSelectedInstOperands,
     /*  316376 */     // GIR_Coverage, 19808,
     /*  316376 */     GIR_EraseRootFromParent_Done,
     /*  316377 */   // Label 5872: @316377
     /*  316377 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(316440), // Rule ID 19809 //
     /*  316382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  316396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  316399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316421 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316438 */     GIR_RootConstrainSelectedInstOperands,
     /*  316439 */     // GIR_Coverage, 19809,
     /*  316439 */     GIR_EraseRootFromParent_Done,
     /*  316440 */   // Label 5873: @316440
     /*  316440 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(316503), // Rule ID 19812 //
     /*  316445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  316459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316484 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316501 */     GIR_RootConstrainSelectedInstOperands,
     /*  316502 */     // GIR_Coverage, 19812,
     /*  316502 */     GIR_EraseRootFromParent_Done,
     /*  316503 */   // Label 5874: @316503
     /*  316503 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(316566), // Rule ID 19813 //
     /*  316508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  316522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316547 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316564 */     GIR_RootConstrainSelectedInstOperands,
     /*  316565 */     // GIR_Coverage, 19813,
     /*  316565 */     GIR_EraseRootFromParent_Done,
     /*  316566 */   // Label 5875: @316566
     /*  316566 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(316629), // Rule ID 19816 //
     /*  316571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  316582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  316585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316610 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316627 */     GIR_RootConstrainSelectedInstOperands,
     /*  316628 */     // GIR_Coverage, 19816,
     /*  316628 */     GIR_EraseRootFromParent_Done,
     /*  316629 */   // Label 5876: @316629
     /*  316629 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(316692), // Rule ID 19817 //
     /*  316634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  316645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  316648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316673 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316690 */     GIR_RootConstrainSelectedInstOperands,
     /*  316691 */     // GIR_Coverage, 19817,
     /*  316691 */     GIR_EraseRootFromParent_Done,
     /*  316692 */   // Label 5877: @316692
     /*  316692 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(316755), // Rule ID 19820 //
     /*  316697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  316711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  316714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316736 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316753 */     GIR_RootConstrainSelectedInstOperands,
     /*  316754 */     // GIR_Coverage, 19820,
     /*  316754 */     GIR_EraseRootFromParent_Done,
     /*  316755 */   // Label 5878: @316755
     /*  316755 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(316818), // Rule ID 19821 //
     /*  316760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  316774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  316777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316799 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316816 */     GIR_RootConstrainSelectedInstOperands,
     /*  316817 */     // GIR_Coverage, 19821,
     /*  316817 */     GIR_EraseRootFromParent_Done,
     /*  316818 */   // Label 5879: @316818
     /*  316818 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(316881), // Rule ID 19824 //
     /*  316823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  316837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  316840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316862 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316879 */     GIR_RootConstrainSelectedInstOperands,
     /*  316880 */     // GIR_Coverage, 19824,
     /*  316880 */     GIR_EraseRootFromParent_Done,
     /*  316881 */   // Label 5880: @316881
     /*  316881 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(316944), // Rule ID 19825 //
     /*  316886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  316900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  316903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316925 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316942 */     GIR_RootConstrainSelectedInstOperands,
     /*  316943 */     // GIR_Coverage, 19825,
     /*  316943 */     GIR_EraseRootFromParent_Done,
     /*  316944 */   // Label 5881: @316944
     /*  316944 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(317007), // Rule ID 19828 //
     /*  316949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  316963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  316966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316988 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317005 */     GIR_RootConstrainSelectedInstOperands,
     /*  317006 */     // GIR_Coverage, 19828,
     /*  317006 */     GIR_EraseRootFromParent_Done,
     /*  317007 */   // Label 5882: @317007
     /*  317007 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(317070), // Rule ID 19829 //
     /*  317012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  317023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  317026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  317029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317051 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  317051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  317054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317068 */     GIR_RootConstrainSelectedInstOperands,
     /*  317069 */     // GIR_Coverage, 19829,
     /*  317069 */     GIR_EraseRootFromParent_Done,
     /*  317070 */   // Label 5883: @317070
     /*  317070 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(317133), // Rule ID 19832 //
     /*  317075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  317078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  317089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  317092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317114 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  317114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  317117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317131 */     GIR_RootConstrainSelectedInstOperands,
     /*  317132 */     // GIR_Coverage, 19832,
     /*  317132 */     GIR_EraseRootFromParent_Done,
     /*  317133 */   // Label 5884: @317133
     /*  317133 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(317196), // Rule ID 19833 //
     /*  317138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  317152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  317155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317177 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  317177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  317180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317194 */     GIR_RootConstrainSelectedInstOperands,
     /*  317195 */     // GIR_Coverage, 19833,
     /*  317195 */     GIR_EraseRootFromParent_Done,
     /*  317196 */   // Label 5885: @317196
     /*  317196 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(317259), // Rule ID 19836 //
     /*  317201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  317204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  317215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  317218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317240 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  317240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  317243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317257 */     GIR_RootConstrainSelectedInstOperands,
     /*  317258 */     // GIR_Coverage, 19836,
     /*  317258 */     GIR_EraseRootFromParent_Done,
     /*  317259 */   // Label 5886: @317259
     /*  317259 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(317322), // Rule ID 19837 //
     /*  317264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  317278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  317281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317303 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  317303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  317306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317320 */     GIR_RootConstrainSelectedInstOperands,
     /*  317321 */     // GIR_Coverage, 19837,
     /*  317321 */     GIR_EraseRootFromParent_Done,
     /*  317322 */   // Label 5887: @317322
     /*  317322 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(317385), // Rule ID 19840 //
     /*  317327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  317330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  317338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  317341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  317344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317366 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  317366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  317369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317383 */     GIR_RootConstrainSelectedInstOperands,
     /*  317384 */     // GIR_Coverage, 19840,
     /*  317384 */     GIR_EraseRootFromParent_Done,
     /*  317385 */   // Label 5888: @317385
     /*  317385 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(317448), // Rule ID 19841 //
     /*  317390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  317401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  317404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  317407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317429 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  317429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  317432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317446 */     GIR_RootConstrainSelectedInstOperands,
     /*  317447 */     // GIR_Coverage, 19841,
     /*  317447 */     GIR_EraseRootFromParent_Done,
     /*  317448 */   // Label 5889: @317448
     /*  317448 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(317511), // Rule ID 19844 //
     /*  317453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  317467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317492 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  317495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317509 */     GIR_RootConstrainSelectedInstOperands,
     /*  317510 */     // GIR_Coverage, 19844,
     /*  317510 */     GIR_EraseRootFromParent_Done,
     /*  317511 */   // Label 5890: @317511
     /*  317511 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(317574), // Rule ID 19845 //
     /*  317516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  317530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317555 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  317558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317572 */     GIR_RootConstrainSelectedInstOperands,
     /*  317573 */     // GIR_Coverage, 19845,
     /*  317573 */     GIR_EraseRootFromParent_Done,
     /*  317574 */   // Label 5891: @317574
     /*  317574 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(317637), // Rule ID 19848 //
     /*  317579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  317593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317618 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  317621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317635 */     GIR_RootConstrainSelectedInstOperands,
     /*  317636 */     // GIR_Coverage, 19848,
     /*  317636 */     GIR_EraseRootFromParent_Done,
     /*  317637 */   // Label 5892: @317637
     /*  317637 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(317700), // Rule ID 19849 //
     /*  317642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  317656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317681 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  317684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317698 */     GIR_RootConstrainSelectedInstOperands,
     /*  317699 */     // GIR_Coverage, 19849,
     /*  317699 */     GIR_EraseRootFromParent_Done,
     /*  317700 */   // Label 5893: @317700
     /*  317700 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(317763), // Rule ID 19852 //
     /*  317705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317744 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  317744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  317747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317761 */     GIR_RootConstrainSelectedInstOperands,
     /*  317762 */     // GIR_Coverage, 19852,
     /*  317762 */     GIR_EraseRootFromParent_Done,
     /*  317763 */   // Label 5894: @317763
     /*  317763 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(317826), // Rule ID 19853 //
     /*  317768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317807 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  317807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  317810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317824 */     GIR_RootConstrainSelectedInstOperands,
     /*  317825 */     // GIR_Coverage, 19853,
     /*  317825 */     GIR_EraseRootFromParent_Done,
     /*  317826 */   // Label 5895: @317826
     /*  317826 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(317889), // Rule ID 19856 //
     /*  317831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317870 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  317873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317887 */     GIR_RootConstrainSelectedInstOperands,
     /*  317888 */     // GIR_Coverage, 19856,
     /*  317888 */     GIR_EraseRootFromParent_Done,
     /*  317889 */   // Label 5896: @317889
     /*  317889 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(317952), // Rule ID 19857 //
     /*  317894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317933 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  317936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317950 */     GIR_RootConstrainSelectedInstOperands,
     /*  317951 */     // GIR_Coverage, 19857,
     /*  317951 */     GIR_EraseRootFromParent_Done,
     /*  317952 */   // Label 5897: @317952
     /*  317952 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(318015), // Rule ID 19860 //
     /*  317957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317996 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  317996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  317999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318013 */     GIR_RootConstrainSelectedInstOperands,
     /*  318014 */     // GIR_Coverage, 19860,
     /*  318014 */     GIR_EraseRootFromParent_Done,
     /*  318015 */   // Label 5898: @318015
     /*  318015 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(318078), // Rule ID 19861 //
     /*  318020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  318034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318059 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  318062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318076 */     GIR_RootConstrainSelectedInstOperands,
     /*  318077 */     // GIR_Coverage, 19861,
     /*  318077 */     GIR_EraseRootFromParent_Done,
     /*  318078 */   // Label 5899: @318078
     /*  318078 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(318141), // Rule ID 19864 //
     /*  318083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  318097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318122 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  318122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  318125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318139 */     GIR_RootConstrainSelectedInstOperands,
     /*  318140 */     // GIR_Coverage, 19864,
     /*  318140 */     GIR_EraseRootFromParent_Done,
     /*  318141 */   // Label 5900: @318141
     /*  318141 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(318204), // Rule ID 19865 //
     /*  318146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  318160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318185 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  318185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  318188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318202 */     GIR_RootConstrainSelectedInstOperands,
     /*  318203 */     // GIR_Coverage, 19865,
     /*  318203 */     GIR_EraseRootFromParent_Done,
     /*  318204 */   // Label 5901: @318204
     /*  318204 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(318267), // Rule ID 19868 //
     /*  318209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  318223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  318251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318265 */     GIR_RootConstrainSelectedInstOperands,
     /*  318266 */     // GIR_Coverage, 19868,
     /*  318266 */     GIR_EraseRootFromParent_Done,
     /*  318267 */   // Label 5902: @318267
     /*  318267 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(318330), // Rule ID 19869 //
     /*  318272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  318286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318311 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  318314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318328 */     GIR_RootConstrainSelectedInstOperands,
     /*  318329 */     // GIR_Coverage, 19869,
     /*  318329 */     GIR_EraseRootFromParent_Done,
     /*  318330 */   // Label 5903: @318330
     /*  318330 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(318393), // Rule ID 19872 //
     /*  318335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  318346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  318349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318374 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  318377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318391 */     GIR_RootConstrainSelectedInstOperands,
     /*  318392 */     // GIR_Coverage, 19872,
     /*  318392 */     GIR_EraseRootFromParent_Done,
     /*  318393 */   // Label 5904: @318393
     /*  318393 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(318456), // Rule ID 19873 //
     /*  318398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  318409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  318412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318437 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  318440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318454 */     GIR_RootConstrainSelectedInstOperands,
     /*  318455 */     // GIR_Coverage, 19873,
     /*  318455 */     GIR_EraseRootFromParent_Done,
     /*  318456 */   // Label 5905: @318456
     /*  318456 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(318519), // Rule ID 19876 //
     /*  318461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  318472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  318475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318500 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  318503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318517 */     GIR_RootConstrainSelectedInstOperands,
     /*  318518 */     // GIR_Coverage, 19876,
     /*  318518 */     GIR_EraseRootFromParent_Done,
     /*  318519 */   // Label 5906: @318519
     /*  318519 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(318582), // Rule ID 19877 //
     /*  318524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  318535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  318538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318563 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  318566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318580 */     GIR_RootConstrainSelectedInstOperands,
     /*  318581 */     // GIR_Coverage, 19877,
     /*  318581 */     GIR_EraseRootFromParent_Done,
     /*  318582 */   // Label 5907: @318582
     /*  318582 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(318645), // Rule ID 19880 //
     /*  318587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  318601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318626 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  318629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318643 */     GIR_RootConstrainSelectedInstOperands,
     /*  318644 */     // GIR_Coverage, 19880,
     /*  318644 */     GIR_EraseRootFromParent_Done,
     /*  318645 */   // Label 5908: @318645
     /*  318645 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(318708), // Rule ID 19881 //
     /*  318650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  318664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318689 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  318692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318706 */     GIR_RootConstrainSelectedInstOperands,
     /*  318707 */     // GIR_Coverage, 19881,
     /*  318707 */     GIR_EraseRootFromParent_Done,
     /*  318708 */   // Label 5909: @318708
     /*  318708 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(318771), // Rule ID 19884 //
     /*  318713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318752 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  318755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318769 */     GIR_RootConstrainSelectedInstOperands,
     /*  318770 */     // GIR_Coverage, 19884,
     /*  318770 */     GIR_EraseRootFromParent_Done,
     /*  318771 */   // Label 5910: @318771
     /*  318771 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(318834), // Rule ID 19885 //
     /*  318776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318815 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  318818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318832 */     GIR_RootConstrainSelectedInstOperands,
     /*  318833 */     // GIR_Coverage, 19885,
     /*  318833 */     GIR_EraseRootFromParent_Done,
     /*  318834 */   // Label 5911: @318834
     /*  318834 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(318897), // Rule ID 19888 //
     /*  318839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  318850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  318853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318878 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  318881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318895 */     GIR_RootConstrainSelectedInstOperands,
     /*  318896 */     // GIR_Coverage, 19888,
     /*  318896 */     GIR_EraseRootFromParent_Done,
     /*  318897 */   // Label 5912: @318897
     /*  318897 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(318960), // Rule ID 19889 //
     /*  318902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  318913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  318916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318941 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  318944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318958 */     GIR_RootConstrainSelectedInstOperands,
     /*  318959 */     // GIR_Coverage, 19889,
     /*  318959 */     GIR_EraseRootFromParent_Done,
     /*  318960 */   // Label 5913: @318960
     /*  318960 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(319023), // Rule ID 19892 //
     /*  318965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  318979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319004 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  319004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  319007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319021 */     GIR_RootConstrainSelectedInstOperands,
     /*  319022 */     // GIR_Coverage, 19892,
     /*  319022 */     GIR_EraseRootFromParent_Done,
     /*  319023 */   // Label 5914: @319023
     /*  319023 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(319086), // Rule ID 19893 //
     /*  319028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  319031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  319042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  319045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  319060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319067 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  319067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  319070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319084 */     GIR_RootConstrainSelectedInstOperands,
     /*  319085 */     // GIR_Coverage, 19893,
     /*  319085 */     GIR_EraseRootFromParent_Done,
     /*  319086 */   // Label 5915: @319086
     /*  319086 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(319149), // Rule ID 19896 //
     /*  319091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  319094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  319105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  319108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  319123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319130 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  319130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  319133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319147 */     GIR_RootConstrainSelectedInstOperands,
     /*  319148 */     // GIR_Coverage, 19896,
     /*  319148 */     GIR_EraseRootFromParent_Done,
     /*  319149 */   // Label 5916: @319149
     /*  319149 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(319212), // Rule ID 19897 //
     /*  319154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  319157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  319168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  319171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  319186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319193 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  319193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  319196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319210 */     GIR_RootConstrainSelectedInstOperands,
     /*  319211 */     // GIR_Coverage, 19897,
     /*  319211 */     GIR_EraseRootFromParent_Done,
     /*  319212 */   // Label 5917: @319212
     /*  319212 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(319275), // Rule ID 19900 //
     /*  319217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  319220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  319231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  319234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  319249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319256 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  319256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  319259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319273 */     GIR_RootConstrainSelectedInstOperands,
     /*  319274 */     // GIR_Coverage, 19900,
     /*  319274 */     GIR_EraseRootFromParent_Done,
     /*  319275 */   // Label 5918: @319275
     /*  319275 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(319338), // Rule ID 19901 //
     /*  319280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  319283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  319294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  319297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  319312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319319 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  319319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  319322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319336 */     GIR_RootConstrainSelectedInstOperands,
     /*  319337 */     // GIR_Coverage, 19901,
     /*  319337 */     GIR_EraseRootFromParent_Done,
     /*  319338 */   // Label 5919: @319338
     /*  319338 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(319401), // Rule ID 19904 //
     /*  319343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  319357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  319360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319382 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  319385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319399 */     GIR_RootConstrainSelectedInstOperands,
     /*  319400 */     // GIR_Coverage, 19904,
     /*  319400 */     GIR_EraseRootFromParent_Done,
     /*  319401 */   // Label 5920: @319401
     /*  319401 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(319464), // Rule ID 19905 //
     /*  319406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  319420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  319423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319445 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  319448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319462 */     GIR_RootConstrainSelectedInstOperands,
     /*  319463 */     // GIR_Coverage, 19905,
     /*  319463 */     GIR_EraseRootFromParent_Done,
     /*  319464 */   // Label 5921: @319464
     /*  319464 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(319527), // Rule ID 19908 //
     /*  319469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  319483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319508 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319525 */     GIR_RootConstrainSelectedInstOperands,
     /*  319526 */     // GIR_Coverage, 19908,
     /*  319526 */     GIR_EraseRootFromParent_Done,
     /*  319527 */   // Label 5922: @319527
     /*  319527 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(319590), // Rule ID 19909 //
     /*  319532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  319546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319571 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319588 */     GIR_RootConstrainSelectedInstOperands,
     /*  319589 */     // GIR_Coverage, 19909,
     /*  319589 */     GIR_EraseRootFromParent_Done,
     /*  319590 */   // Label 5923: @319590
     /*  319590 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(319653), // Rule ID 19912 //
     /*  319595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  319609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319634 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319651 */     GIR_RootConstrainSelectedInstOperands,
     /*  319652 */     // GIR_Coverage, 19912,
     /*  319652 */     GIR_EraseRootFromParent_Done,
     /*  319653 */   // Label 5924: @319653
     /*  319653 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(319716), // Rule ID 19913 //
     /*  319658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  319672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319697 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319714 */     GIR_RootConstrainSelectedInstOperands,
     /*  319715 */     // GIR_Coverage, 19913,
     /*  319715 */     GIR_EraseRootFromParent_Done,
     /*  319716 */   // Label 5925: @319716
     /*  319716 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(319779), // Rule ID 19916 //
     /*  319721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  319735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  319738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319760 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319777 */     GIR_RootConstrainSelectedInstOperands,
     /*  319778 */     // GIR_Coverage, 19916,
     /*  319778 */     GIR_EraseRootFromParent_Done,
     /*  319779 */   // Label 5926: @319779
     /*  319779 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(319842), // Rule ID 19917 //
     /*  319784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  319798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  319801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319823 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319840 */     GIR_RootConstrainSelectedInstOperands,
     /*  319841 */     // GIR_Coverage, 19917,
     /*  319841 */     GIR_EraseRootFromParent_Done,
     /*  319842 */   // Label 5927: @319842
     /*  319842 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(319905), // Rule ID 19920 //
     /*  319847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  319861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  319864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319886 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319903 */     GIR_RootConstrainSelectedInstOperands,
     /*  319904 */     // GIR_Coverage, 19920,
     /*  319904 */     GIR_EraseRootFromParent_Done,
     /*  319905 */   // Label 5928: @319905
     /*  319905 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(319968), // Rule ID 19921 //
     /*  319910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  319924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  319927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319949 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319966 */     GIR_RootConstrainSelectedInstOperands,
     /*  319967 */     // GIR_Coverage, 19921,
     /*  319967 */     GIR_EraseRootFromParent_Done,
     /*  319968 */   // Label 5929: @319968
     /*  319968 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(320031), // Rule ID 19924 //
     /*  319973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  319976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  319987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  319990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320012 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  320015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320029 */     GIR_RootConstrainSelectedInstOperands,
     /*  320030 */     // GIR_Coverage, 19924,
     /*  320030 */     GIR_EraseRootFromParent_Done,
     /*  320031 */   // Label 5930: @320031
     /*  320031 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(320094), // Rule ID 19925 //
     /*  320036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  320050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  320053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320075 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  320078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320092 */     GIR_RootConstrainSelectedInstOperands,
     /*  320093 */     // GIR_Coverage, 19925,
     /*  320093 */     GIR_EraseRootFromParent_Done,
     /*  320094 */   // Label 5931: @320094
     /*  320094 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(320157), // Rule ID 19928 //
     /*  320099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  320113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  320116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320138 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320155 */     GIR_RootConstrainSelectedInstOperands,
     /*  320156 */     // GIR_Coverage, 19928,
     /*  320156 */     GIR_EraseRootFromParent_Done,
     /*  320157 */   // Label 5932: @320157
     /*  320157 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(320220), // Rule ID 19929 //
     /*  320162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  320176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  320179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320201 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320218 */     GIR_RootConstrainSelectedInstOperands,
     /*  320219 */     // GIR_Coverage, 19929,
     /*  320219 */     GIR_EraseRootFromParent_Done,
     /*  320220 */   // Label 5933: @320220
     /*  320220 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(320283), // Rule ID 19932 //
     /*  320225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  320239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  320242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320264 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320281 */     GIR_RootConstrainSelectedInstOperands,
     /*  320282 */     // GIR_Coverage, 19932,
     /*  320282 */     GIR_EraseRootFromParent_Done,
     /*  320283 */   // Label 5934: @320283
     /*  320283 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(320346), // Rule ID 19933 //
     /*  320288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  320302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  320305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320327 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320344 */     GIR_RootConstrainSelectedInstOperands,
     /*  320345 */     // GIR_Coverage, 19933,
     /*  320345 */     GIR_EraseRootFromParent_Done,
     /*  320346 */   // Label 5935: @320346
     /*  320346 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(320409), // Rule ID 19936 //
     /*  320351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  320362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  320365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  320368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320390 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320407 */     GIR_RootConstrainSelectedInstOperands,
     /*  320408 */     // GIR_Coverage, 19936,
     /*  320408 */     GIR_EraseRootFromParent_Done,
     /*  320409 */   // Label 5936: @320409
     /*  320409 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(320472), // Rule ID 19937 //
     /*  320414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  320425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  320428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  320431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320453 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320470 */     GIR_RootConstrainSelectedInstOperands,
     /*  320471 */     // GIR_Coverage, 19937,
     /*  320471 */     GIR_EraseRootFromParent_Done,
     /*  320472 */   // Label 5937: @320472
     /*  320472 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(320535), // Rule ID 19940 //
     /*  320477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  320491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  320494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320516 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320533 */     GIR_RootConstrainSelectedInstOperands,
     /*  320534 */     // GIR_Coverage, 19940,
     /*  320534 */     GIR_EraseRootFromParent_Done,
     /*  320535 */   // Label 5938: @320535
     /*  320535 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(320598), // Rule ID 19941 //
     /*  320540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  320554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  320557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320579 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320596 */     GIR_RootConstrainSelectedInstOperands,
     /*  320597 */     // GIR_Coverage, 19941,
     /*  320597 */     GIR_EraseRootFromParent_Done,
     /*  320598 */   // Label 5939: @320598
     /*  320598 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(320661), // Rule ID 19944 //
     /*  320603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  320617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  320620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320642 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320659 */     GIR_RootConstrainSelectedInstOperands,
     /*  320660 */     // GIR_Coverage, 19944,
     /*  320660 */     GIR_EraseRootFromParent_Done,
     /*  320661 */   // Label 5940: @320661
     /*  320661 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(320724), // Rule ID 19945 //
     /*  320666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  320680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  320683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320705 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320722 */     GIR_RootConstrainSelectedInstOperands,
     /*  320723 */     // GIR_Coverage, 19945,
     /*  320723 */     GIR_EraseRootFromParent_Done,
     /*  320724 */   // Label 5941: @320724
     /*  320724 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(320787), // Rule ID 19948 //
     /*  320729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  320743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  320746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320768 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320785 */     GIR_RootConstrainSelectedInstOperands,
     /*  320786 */     // GIR_Coverage, 19948,
     /*  320786 */     GIR_EraseRootFromParent_Done,
     /*  320787 */   // Label 5942: @320787
     /*  320787 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(320850), // Rule ID 19949 //
     /*  320792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  320806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  320809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320831 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320848 */     GIR_RootConstrainSelectedInstOperands,
     /*  320849 */     // GIR_Coverage, 19949,
     /*  320849 */     GIR_EraseRootFromParent_Done,
     /*  320850 */   // Label 5943: @320850
     /*  320850 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(320913), // Rule ID 19952 //
     /*  320855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  320869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  320872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320894 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320911 */     GIR_RootConstrainSelectedInstOperands,
     /*  320912 */     // GIR_Coverage, 19952,
     /*  320912 */     GIR_EraseRootFromParent_Done,
     /*  320913 */   // Label 5944: @320913
     /*  320913 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(320976), // Rule ID 19953 //
     /*  320918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  320932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  320935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320957 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320974 */     GIR_RootConstrainSelectedInstOperands,
     /*  320975 */     // GIR_Coverage, 19953,
     /*  320975 */     GIR_EraseRootFromParent_Done,
     /*  320976 */   // Label 5945: @320976
     /*  320976 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(321039), // Rule ID 19956 //
     /*  320981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  320995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  320998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321020 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  321023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321037 */     GIR_RootConstrainSelectedInstOperands,
     /*  321038 */     // GIR_Coverage, 19956,
     /*  321038 */     GIR_EraseRootFromParent_Done,
     /*  321039 */   // Label 5946: @321039
     /*  321039 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(321102), // Rule ID 19957 //
     /*  321044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  321047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  321058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  321061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321083 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  321086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321100 */     GIR_RootConstrainSelectedInstOperands,
     /*  321101 */     // GIR_Coverage, 19957,
     /*  321101 */     GIR_EraseRootFromParent_Done,
     /*  321102 */   // Label 5947: @321102
     /*  321102 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(321165), // Rule ID 19960 //
     /*  321107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  321110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  321121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  321124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321146 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  321149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321163 */     GIR_RootConstrainSelectedInstOperands,
     /*  321164 */     // GIR_Coverage, 19960,
     /*  321164 */     GIR_EraseRootFromParent_Done,
     /*  321165 */   // Label 5948: @321165
     /*  321165 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(321228), // Rule ID 19961 //
     /*  321170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  321173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  321184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  321187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321209 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  321212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321226 */     GIR_RootConstrainSelectedInstOperands,
     /*  321227 */     // GIR_Coverage, 19961,
     /*  321227 */     GIR_EraseRootFromParent_Done,
     /*  321228 */   // Label 5949: @321228
     /*  321228 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(321291), // Rule ID 19964 //
     /*  321233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  321247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321272 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  321275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321289 */     GIR_RootConstrainSelectedInstOperands,
     /*  321290 */     // GIR_Coverage, 19964,
     /*  321290 */     GIR_EraseRootFromParent_Done,
     /*  321291 */   // Label 5950: @321291
     /*  321291 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(321354), // Rule ID 19965 //
     /*  321296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  321310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321335 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  321338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321352 */     GIR_RootConstrainSelectedInstOperands,
     /*  321353 */     // GIR_Coverage, 19965,
     /*  321353 */     GIR_EraseRootFromParent_Done,
     /*  321354 */   // Label 5951: @321354
     /*  321354 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(321417), // Rule ID 19968 //
     /*  321359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  321373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321398 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  321401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321415 */     GIR_RootConstrainSelectedInstOperands,
     /*  321416 */     // GIR_Coverage, 19968,
     /*  321416 */     GIR_EraseRootFromParent_Done,
     /*  321417 */   // Label 5952: @321417
     /*  321417 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(321480), // Rule ID 19969 //
     /*  321422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  321436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321461 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  321464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321478 */     GIR_RootConstrainSelectedInstOperands,
     /*  321479 */     // GIR_Coverage, 19969,
     /*  321479 */     GIR_EraseRootFromParent_Done,
     /*  321480 */   // Label 5953: @321480
     /*  321480 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(321543), // Rule ID 19972 //
     /*  321485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  321499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321524 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  321527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321541 */     GIR_RootConstrainSelectedInstOperands,
     /*  321542 */     // GIR_Coverage, 19972,
     /*  321542 */     GIR_EraseRootFromParent_Done,
     /*  321543 */   // Label 5954: @321543
     /*  321543 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(321606), // Rule ID 19973 //
     /*  321548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  321562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321587 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  321590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321604 */     GIR_RootConstrainSelectedInstOperands,
     /*  321605 */     // GIR_Coverage, 19973,
     /*  321605 */     GIR_EraseRootFromParent_Done,
     /*  321606 */   // Label 5955: @321606
     /*  321606 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(321669), // Rule ID 19976 //
     /*  321611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  321625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321650 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  321653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321667 */     GIR_RootConstrainSelectedInstOperands,
     /*  321668 */     // GIR_Coverage, 19976,
     /*  321668 */     GIR_EraseRootFromParent_Done,
     /*  321669 */   // Label 5956: @321669
     /*  321669 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(321732), // Rule ID 19977 //
     /*  321674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  321688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321713 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  321716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321730 */     GIR_RootConstrainSelectedInstOperands,
     /*  321731 */     // GIR_Coverage, 19977,
     /*  321731 */     GIR_EraseRootFromParent_Done,
     /*  321732 */   // Label 5957: @321732
     /*  321732 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(321795), // Rule ID 19980 //
     /*  321737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  321751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  321779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321793 */     GIR_RootConstrainSelectedInstOperands,
     /*  321794 */     // GIR_Coverage, 19980,
     /*  321794 */     GIR_EraseRootFromParent_Done,
     /*  321795 */   // Label 5958: @321795
     /*  321795 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(321858), // Rule ID 19981 //
     /*  321800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  321814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321839 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  321842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321856 */     GIR_RootConstrainSelectedInstOperands,
     /*  321857 */     // GIR_Coverage, 19981,
     /*  321857 */     GIR_EraseRootFromParent_Done,
     /*  321858 */   // Label 5959: @321858
     /*  321858 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(321921), // Rule ID 19984 //
     /*  321863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  321866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  321877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321902 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  321905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321919 */     GIR_RootConstrainSelectedInstOperands,
     /*  321920 */     // GIR_Coverage, 19984,
     /*  321920 */     GIR_EraseRootFromParent_Done,
     /*  321921 */   // Label 5960: @321921
     /*  321921 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(321984), // Rule ID 19985 //
     /*  321926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  321929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  321940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321965 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  321968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321982 */     GIR_RootConstrainSelectedInstOperands,
     /*  321983 */     // GIR_Coverage, 19985,
     /*  321983 */     GIR_EraseRootFromParent_Done,
     /*  321984 */   // Label 5961: @321984
     /*  321984 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(322047), // Rule ID 19988 //
     /*  321989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  322003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  322006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  322021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322028 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  322031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322045 */     GIR_RootConstrainSelectedInstOperands,
     /*  322046 */     // GIR_Coverage, 19988,
     /*  322046 */     GIR_EraseRootFromParent_Done,
     /*  322047 */   // Label 5962: @322047
     /*  322047 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(322110), // Rule ID 19989 //
     /*  322052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  322066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  322069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  322084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322091 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  322094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322108 */     GIR_RootConstrainSelectedInstOperands,
     /*  322109 */     // GIR_Coverage, 19989,
     /*  322109 */     GIR_EraseRootFromParent_Done,
     /*  322110 */   // Label 5963: @322110
     /*  322110 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(322173), // Rule ID 19992 //
     /*  322115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  322129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  322132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  322147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322154 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  322157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322171 */     GIR_RootConstrainSelectedInstOperands,
     /*  322172 */     // GIR_Coverage, 19992,
     /*  322172 */     GIR_EraseRootFromParent_Done,
     /*  322173 */   // Label 5964: @322173
     /*  322173 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(322236), // Rule ID 19993 //
     /*  322178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  322192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  322195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  322210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322217 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  322220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322234 */     GIR_RootConstrainSelectedInstOperands,
     /*  322235 */     // GIR_Coverage, 19993,
     /*  322235 */     GIR_EraseRootFromParent_Done,
     /*  322236 */   // Label 5965: @322236
     /*  322236 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(322299), // Rule ID 19996 //
     /*  322241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  322252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  322255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  322258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  322273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322280 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  322283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322297 */     GIR_RootConstrainSelectedInstOperands,
     /*  322298 */     // GIR_Coverage, 19996,
     /*  322298 */     GIR_EraseRootFromParent_Done,
     /*  322299 */   // Label 5966: @322299
     /*  322299 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(322362), // Rule ID 19997 //
     /*  322304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  322315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  322318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  322321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  322336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322343 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  322346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322360 */     GIR_RootConstrainSelectedInstOperands,
     /*  322361 */     // GIR_Coverage, 19997,
     /*  322361 */     GIR_EraseRootFromParent_Done,
     /*  322362 */   // Label 5967: @322362
     /*  322362 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(322425), // Rule ID 20000 //
     /*  322367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  322381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322406 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  322409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322423 */     GIR_RootConstrainSelectedInstOperands,
     /*  322424 */     // GIR_Coverage, 20000,
     /*  322424 */     GIR_EraseRootFromParent_Done,
     /*  322425 */   // Label 5968: @322425
     /*  322425 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(322488), // Rule ID 20001 //
     /*  322430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  322444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322469 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  322472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322486 */     GIR_RootConstrainSelectedInstOperands,
     /*  322487 */     // GIR_Coverage, 20001,
     /*  322487 */     GIR_EraseRootFromParent_Done,
     /*  322488 */   // Label 5969: @322488
     /*  322488 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(322551), // Rule ID 20004 //
     /*  322493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  322507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322532 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  322535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322549 */     GIR_RootConstrainSelectedInstOperands,
     /*  322550 */     // GIR_Coverage, 20004,
     /*  322550 */     GIR_EraseRootFromParent_Done,
     /*  322551 */   // Label 5970: @322551
     /*  322551 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(322614), // Rule ID 20005 //
     /*  322556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  322570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322595 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  322598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322612 */     GIR_RootConstrainSelectedInstOperands,
     /*  322613 */     // GIR_Coverage, 20005,
     /*  322613 */     GIR_EraseRootFromParent_Done,
     /*  322614 */   // Label 5971: @322614
     /*  322614 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(322677), // Rule ID 20008 //
     /*  322619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  322633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322658 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  322661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322675 */     GIR_RootConstrainSelectedInstOperands,
     /*  322676 */     // GIR_Coverage, 20008,
     /*  322676 */     GIR_EraseRootFromParent_Done,
     /*  322677 */   // Label 5972: @322677
     /*  322677 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(322740), // Rule ID 20009 //
     /*  322682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  322696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322721 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  322724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322738 */     GIR_RootConstrainSelectedInstOperands,
     /*  322739 */     // GIR_Coverage, 20009,
     /*  322739 */     GIR_EraseRootFromParent_Done,
     /*  322740 */   // Label 5973: @322740
     /*  322740 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(322803), // Rule ID 20012 //
     /*  322745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  322759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322784 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  322787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322801 */     GIR_RootConstrainSelectedInstOperands,
     /*  322802 */     // GIR_Coverage, 20012,
     /*  322802 */     GIR_EraseRootFromParent_Done,
     /*  322803 */   // Label 5974: @322803
     /*  322803 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(322866), // Rule ID 20013 //
     /*  322808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  322822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322847 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  322850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322864 */     GIR_RootConstrainSelectedInstOperands,
     /*  322865 */     // GIR_Coverage, 20013,
     /*  322865 */     GIR_EraseRootFromParent_Done,
     /*  322866 */   // Label 5975: @322866
     /*  322866 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(322929), // Rule ID 20016 //
     /*  322871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  322885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322910 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  322913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322927 */     GIR_RootConstrainSelectedInstOperands,
     /*  322928 */     // GIR_Coverage, 20016,
     /*  322928 */     GIR_EraseRootFromParent_Done,
     /*  322929 */   // Label 5976: @322929
     /*  322929 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(322992), // Rule ID 20017 //
     /*  322934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  322948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322973 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  322976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322990 */     GIR_RootConstrainSelectedInstOperands,
     /*  322991 */     // GIR_Coverage, 20017,
     /*  322991 */     GIR_EraseRootFromParent_Done,
     /*  322992 */   // Label 5977: @322992
     /*  322992 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(323055), // Rule ID 20020 //
     /*  322997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  323000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  323011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  323014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  323029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323036 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  323036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  323039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323053 */     GIR_RootConstrainSelectedInstOperands,
     /*  323054 */     // GIR_Coverage, 20020,
     /*  323054 */     GIR_EraseRootFromParent_Done,
     /*  323055 */   // Label 5978: @323055
     /*  323055 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(323118), // Rule ID 20021 //
     /*  323060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  323063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  323074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  323077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  323092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323099 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  323099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  323102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323116 */     GIR_RootConstrainSelectedInstOperands,
     /*  323117 */     // GIR_Coverage, 20021,
     /*  323117 */     GIR_EraseRootFromParent_Done,
     /*  323118 */   // Label 5979: @323118
     /*  323118 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(323181), // Rule ID 20024 //
     /*  323123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  323137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  323140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323162 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  323165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323179 */     GIR_RootConstrainSelectedInstOperands,
     /*  323180 */     // GIR_Coverage, 20024,
     /*  323180 */     GIR_EraseRootFromParent_Done,
     /*  323181 */   // Label 5980: @323181
     /*  323181 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(323244), // Rule ID 20025 //
     /*  323186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  323200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  323203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323225 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  323228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323242 */     GIR_RootConstrainSelectedInstOperands,
     /*  323243 */     // GIR_Coverage, 20025,
     /*  323243 */     GIR_EraseRootFromParent_Done,
     /*  323244 */   // Label 5981: @323244
     /*  323244 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(323307), // Rule ID 20028 //
     /*  323249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  323263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  323266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323288 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  323291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323305 */     GIR_RootConstrainSelectedInstOperands,
     /*  323306 */     // GIR_Coverage, 20028,
     /*  323306 */     GIR_EraseRootFromParent_Done,
     /*  323307 */   // Label 5982: @323307
     /*  323307 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(323370), // Rule ID 20029 //
     /*  323312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  323326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  323329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323351 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  323354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323368 */     GIR_RootConstrainSelectedInstOperands,
     /*  323369 */     // GIR_Coverage, 20029,
     /*  323369 */     GIR_EraseRootFromParent_Done,
     /*  323370 */   // Label 5983: @323370
     /*  323370 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(323433), // Rule ID 20032 //
     /*  323375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  323389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  323392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323414 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  323417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323431 */     GIR_RootConstrainSelectedInstOperands,
     /*  323432 */     // GIR_Coverage, 20032,
     /*  323432 */     GIR_EraseRootFromParent_Done,
     /*  323433 */   // Label 5984: @323433
     /*  323433 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(323496), // Rule ID 20033 //
     /*  323438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  323452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  323455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323477 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  323480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323494 */     GIR_RootConstrainSelectedInstOperands,
     /*  323495 */     // GIR_Coverage, 20033,
     /*  323495 */     GIR_EraseRootFromParent_Done,
     /*  323496 */   // Label 5985: @323496
     /*  323496 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(323559), // Rule ID 20036 //
     /*  323501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  323515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  323518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323540 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323557 */     GIR_RootConstrainSelectedInstOperands,
     /*  323558 */     // GIR_Coverage, 20036,
     /*  323558 */     GIR_EraseRootFromParent_Done,
     /*  323559 */   // Label 5986: @323559
     /*  323559 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(323622), // Rule ID 20037 //
     /*  323564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  323578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  323581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323603 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323620 */     GIR_RootConstrainSelectedInstOperands,
     /*  323621 */     // GIR_Coverage, 20037,
     /*  323621 */     GIR_EraseRootFromParent_Done,
     /*  323622 */   // Label 5987: @323622
     /*  323622 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(323685), // Rule ID 20040 //
     /*  323627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  323641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  323644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323666 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323683 */     GIR_RootConstrainSelectedInstOperands,
     /*  323684 */     // GIR_Coverage, 20040,
     /*  323684 */     GIR_EraseRootFromParent_Done,
     /*  323685 */   // Label 5988: @323685
     /*  323685 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(323748), // Rule ID 20041 //
     /*  323690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  323704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  323707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323729 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323746 */     GIR_RootConstrainSelectedInstOperands,
     /*  323747 */     // GIR_Coverage, 20041,
     /*  323747 */     GIR_EraseRootFromParent_Done,
     /*  323748 */   // Label 5989: @323748
     /*  323748 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(323811), // Rule ID 20044 //
     /*  323753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  323756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  323767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  323770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323792 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  323792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323809 */     GIR_RootConstrainSelectedInstOperands,
     /*  323810 */     // GIR_Coverage, 20044,
     /*  323810 */     GIR_EraseRootFromParent_Done,
     /*  323811 */   // Label 5990: @323811
     /*  323811 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(323874), // Rule ID 20045 //
     /*  323816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  323819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  323830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  323833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323855 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  323855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323872 */     GIR_RootConstrainSelectedInstOperands,
     /*  323873 */     // GIR_Coverage, 20045,
     /*  323873 */     GIR_EraseRootFromParent_Done,
     /*  323874 */   // Label 5991: @323874
     /*  323874 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(323937), // Rule ID 20048 //
     /*  323879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  323893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323918 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323935 */     GIR_RootConstrainSelectedInstOperands,
     /*  323936 */     // GIR_Coverage, 20048,
     /*  323936 */     GIR_EraseRootFromParent_Done,
     /*  323937 */   // Label 5992: @323937
     /*  323937 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(324000), // Rule ID 20049 //
     /*  323942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  323956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323981 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323998 */     GIR_RootConstrainSelectedInstOperands,
     /*  323999 */     // GIR_Coverage, 20049,
     /*  323999 */     GIR_EraseRootFromParent_Done,
     /*  324000 */   // Label 5993: @324000
     /*  324000 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(324063), // Rule ID 20052 //
     /*  324005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  324019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  324022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324044 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324061 */     GIR_RootConstrainSelectedInstOperands,
     /*  324062 */     // GIR_Coverage, 20052,
     /*  324062 */     GIR_EraseRootFromParent_Done,
     /*  324063 */   // Label 5994: @324063
     /*  324063 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(324126), // Rule ID 20053 //
     /*  324068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  324082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  324085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324107 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324124 */     GIR_RootConstrainSelectedInstOperands,
     /*  324125 */     // GIR_Coverage, 20053,
     /*  324125 */     GIR_EraseRootFromParent_Done,
     /*  324126 */   // Label 5995: @324126
     /*  324126 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(324189), // Rule ID 20056 //
     /*  324131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  324142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  324145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  324148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324170 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324187 */     GIR_RootConstrainSelectedInstOperands,
     /*  324188 */     // GIR_Coverage, 20056,
     /*  324188 */     GIR_EraseRootFromParent_Done,
     /*  324189 */   // Label 5996: @324189
     /*  324189 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(324252), // Rule ID 20057 //
     /*  324194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  324205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  324208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  324211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324233 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324250 */     GIR_RootConstrainSelectedInstOperands,
     /*  324251 */     // GIR_Coverage, 20057,
     /*  324251 */     GIR_EraseRootFromParent_Done,
     /*  324252 */   // Label 5997: @324252
     /*  324252 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(324315), // Rule ID 20060 //
     /*  324257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  324271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  324274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324296 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  324299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324313 */     GIR_RootConstrainSelectedInstOperands,
     /*  324314 */     // GIR_Coverage, 20060,
     /*  324314 */     GIR_EraseRootFromParent_Done,
     /*  324315 */   // Label 5998: @324315
     /*  324315 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(324378), // Rule ID 20061 //
     /*  324320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  324334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  324337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324359 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  324362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324376 */     GIR_RootConstrainSelectedInstOperands,
     /*  324377 */     // GIR_Coverage, 20061,
     /*  324377 */     GIR_EraseRootFromParent_Done,
     /*  324378 */   // Label 5999: @324378
     /*  324378 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(324441), // Rule ID 20064 //
     /*  324383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  324397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324422 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324439 */     GIR_RootConstrainSelectedInstOperands,
     /*  324440 */     // GIR_Coverage, 20064,
     /*  324440 */     GIR_EraseRootFromParent_Done,
     /*  324441 */   // Label 6000: @324441
     /*  324441 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(324504), // Rule ID 20065 //
     /*  324446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  324460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324485 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324502 */     GIR_RootConstrainSelectedInstOperands,
     /*  324503 */     // GIR_Coverage, 20065,
     /*  324503 */     GIR_EraseRootFromParent_Done,
     /*  324504 */   // Label 6001: @324504
     /*  324504 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(324567), // Rule ID 20068 //
     /*  324509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  324523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324548 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324565 */     GIR_RootConstrainSelectedInstOperands,
     /*  324566 */     // GIR_Coverage, 20068,
     /*  324566 */     GIR_EraseRootFromParent_Done,
     /*  324567 */   // Label 6002: @324567
     /*  324567 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(324630), // Rule ID 20069 //
     /*  324572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  324586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324611 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324628 */     GIR_RootConstrainSelectedInstOperands,
     /*  324629 */     // GIR_Coverage, 20069,
     /*  324629 */     GIR_EraseRootFromParent_Done,
     /*  324630 */   // Label 6003: @324630
     /*  324630 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(324693), // Rule ID 20072 //
     /*  324635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  324649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  324652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324674 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  324677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324691 */     GIR_RootConstrainSelectedInstOperands,
     /*  324692 */     // GIR_Coverage, 20072,
     /*  324692 */     GIR_EraseRootFromParent_Done,
     /*  324693 */   // Label 6004: @324693
     /*  324693 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(324756), // Rule ID 20073 //
     /*  324698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  324712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  324715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324737 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  324740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324754 */     GIR_RootConstrainSelectedInstOperands,
     /*  324755 */     // GIR_Coverage, 20073,
     /*  324755 */     GIR_EraseRootFromParent_Done,
     /*  324756 */   // Label 6005: @324756
     /*  324756 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(324819), // Rule ID 20076 //
     /*  324761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  324775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  324778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324800 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324817 */     GIR_RootConstrainSelectedInstOperands,
     /*  324818 */     // GIR_Coverage, 20076,
     /*  324818 */     GIR_EraseRootFromParent_Done,
     /*  324819 */   // Label 6006: @324819
     /*  324819 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(324882), // Rule ID 20077 //
     /*  324824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  324838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  324841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324863 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324880 */     GIR_RootConstrainSelectedInstOperands,
     /*  324881 */     // GIR_Coverage, 20077,
     /*  324881 */     GIR_EraseRootFromParent_Done,
     /*  324882 */   // Label 6007: @324882
     /*  324882 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(324945), // Rule ID 20080 //
     /*  324887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  324901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  324904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324926 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324943 */     GIR_RootConstrainSelectedInstOperands,
     /*  324944 */     // GIR_Coverage, 20080,
     /*  324944 */     GIR_EraseRootFromParent_Done,
     /*  324945 */   // Label 6008: @324945
     /*  324945 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(325008), // Rule ID 20081 //
     /*  324950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  324964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  324967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324989 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325006 */     GIR_RootConstrainSelectedInstOperands,
     /*  325007 */     // GIR_Coverage, 20081,
     /*  325007 */     GIR_EraseRootFromParent_Done,
     /*  325008 */   // Label 6009: @325008
     /*  325008 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(325071), // Rule ID 20084 //
     /*  325013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  325027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325052 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  325055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325069 */     GIR_RootConstrainSelectedInstOperands,
     /*  325070 */     // GIR_Coverage, 20084,
     /*  325070 */     GIR_EraseRootFromParent_Done,
     /*  325071 */   // Label 6010: @325071
     /*  325071 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(325134), // Rule ID 20085 //
     /*  325076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  325090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325115 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  325118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325132 */     GIR_RootConstrainSelectedInstOperands,
     /*  325133 */     // GIR_Coverage, 20085,
     /*  325133 */     GIR_EraseRootFromParent_Done,
     /*  325134 */   // Label 6011: @325134
     /*  325134 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(325197), // Rule ID 20088 //
     /*  325139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  325153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325178 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  325181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325195 */     GIR_RootConstrainSelectedInstOperands,
     /*  325196 */     // GIR_Coverage, 20088,
     /*  325196 */     GIR_EraseRootFromParent_Done,
     /*  325197 */   // Label 6012: @325197
     /*  325197 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(325260), // Rule ID 20089 //
     /*  325202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  325216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325241 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  325244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325258 */     GIR_RootConstrainSelectedInstOperands,
     /*  325259 */     // GIR_Coverage, 20089,
     /*  325259 */     GIR_EraseRootFromParent_Done,
     /*  325260 */   // Label 6013: @325260
     /*  325260 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(325323), // Rule ID 20092 //
     /*  325265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  325279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325304 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  325307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325321 */     GIR_RootConstrainSelectedInstOperands,
     /*  325322 */     // GIR_Coverage, 20092,
     /*  325322 */     GIR_EraseRootFromParent_Done,
     /*  325323 */   // Label 6014: @325323
     /*  325323 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(325386), // Rule ID 20093 //
     /*  325328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  325342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325367 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  325370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325384 */     GIR_RootConstrainSelectedInstOperands,
     /*  325385 */     // GIR_Coverage, 20093,
     /*  325385 */     GIR_EraseRootFromParent_Done,
     /*  325386 */   // Label 6015: @325386
     /*  325386 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(325449), // Rule ID 20096 //
     /*  325391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  325405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325430 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  325433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325447 */     GIR_RootConstrainSelectedInstOperands,
     /*  325448 */     // GIR_Coverage, 20096,
     /*  325448 */     GIR_EraseRootFromParent_Done,
     /*  325449 */   // Label 6016: @325449
     /*  325449 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(325512), // Rule ID 20097 //
     /*  325454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  325468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325493 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  325496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325510 */     GIR_RootConstrainSelectedInstOperands,
     /*  325511 */     // GIR_Coverage, 20097,
     /*  325511 */     GIR_EraseRootFromParent_Done,
     /*  325512 */   // Label 6017: @325512
     /*  325512 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(325575), // Rule ID 20100 //
     /*  325517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  325531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325556 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  325559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325573 */     GIR_RootConstrainSelectedInstOperands,
     /*  325574 */     // GIR_Coverage, 20100,
     /*  325574 */     GIR_EraseRootFromParent_Done,
     /*  325575 */   // Label 6018: @325575
     /*  325575 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(325638), // Rule ID 20101 //
     /*  325580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  325594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325619 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  325622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325636 */     GIR_RootConstrainSelectedInstOperands,
     /*  325637 */     // GIR_Coverage, 20101,
     /*  325637 */     GIR_EraseRootFromParent_Done,
     /*  325638 */   // Label 6019: @325638
     /*  325638 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(325701), // Rule ID 20104 //
     /*  325643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  325646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  325657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325682 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  325685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325699 */     GIR_RootConstrainSelectedInstOperands,
     /*  325700 */     // GIR_Coverage, 20104,
     /*  325700 */     GIR_EraseRootFromParent_Done,
     /*  325701 */   // Label 6020: @325701
     /*  325701 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(325764), // Rule ID 20105 //
     /*  325706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  325709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  325720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325745 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  325748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325762 */     GIR_RootConstrainSelectedInstOperands,
     /*  325763 */     // GIR_Coverage, 20105,
     /*  325763 */     GIR_EraseRootFromParent_Done,
     /*  325764 */   // Label 6021: @325764
     /*  325764 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(325827), // Rule ID 20108 //
     /*  325769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  325783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325808 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  325811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325825 */     GIR_RootConstrainSelectedInstOperands,
     /*  325826 */     // GIR_Coverage, 20108,
     /*  325826 */     GIR_EraseRootFromParent_Done,
     /*  325827 */   // Label 6022: @325827
     /*  325827 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(325890), // Rule ID 20109 //
     /*  325832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  325846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325871 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  325874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325888 */     GIR_RootConstrainSelectedInstOperands,
     /*  325889 */     // GIR_Coverage, 20109,
     /*  325889 */     GIR_EraseRootFromParent_Done,
     /*  325890 */   // Label 6023: @325890
     /*  325890 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(325953), // Rule ID 20112 //
     /*  325895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  325909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325934 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  325937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325951 */     GIR_RootConstrainSelectedInstOperands,
     /*  325952 */     // GIR_Coverage, 20112,
     /*  325952 */     GIR_EraseRootFromParent_Done,
     /*  325953 */   // Label 6024: @325953
     /*  325953 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(326016), // Rule ID 20113 //
     /*  325958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  325972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325997 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  326000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326014 */     GIR_RootConstrainSelectedInstOperands,
     /*  326015 */     // GIR_Coverage, 20113,
     /*  326015 */     GIR_EraseRootFromParent_Done,
     /*  326016 */   // Label 6025: @326016
     /*  326016 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(326079), // Rule ID 20116 //
     /*  326021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  326032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  326035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  326038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  326053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326060 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  326063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326077 */     GIR_RootConstrainSelectedInstOperands,
     /*  326078 */     // GIR_Coverage, 20116,
     /*  326078 */     GIR_EraseRootFromParent_Done,
     /*  326079 */   // Label 6026: @326079
     /*  326079 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(326142), // Rule ID 20117 //
     /*  326084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  326095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  326098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  326101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  326116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326123 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  326126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326140 */     GIR_RootConstrainSelectedInstOperands,
     /*  326141 */     // GIR_Coverage, 20117,
     /*  326141 */     GIR_EraseRootFromParent_Done,
     /*  326142 */   // Label 6027: @326142
     /*  326142 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(326205), // Rule ID 20120 //
     /*  326147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  326161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326186 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  326189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326203 */     GIR_RootConstrainSelectedInstOperands,
     /*  326204 */     // GIR_Coverage, 20120,
     /*  326204 */     GIR_EraseRootFromParent_Done,
     /*  326205 */   // Label 6028: @326205
     /*  326205 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(326268), // Rule ID 20121 //
     /*  326210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  326224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326249 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  326252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326266 */     GIR_RootConstrainSelectedInstOperands,
     /*  326267 */     // GIR_Coverage, 20121,
     /*  326267 */     GIR_EraseRootFromParent_Done,
     /*  326268 */   // Label 6029: @326268
     /*  326268 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(326331), // Rule ID 20124 //
     /*  326273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  326287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326312 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  326315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326329 */     GIR_RootConstrainSelectedInstOperands,
     /*  326330 */     // GIR_Coverage, 20124,
     /*  326330 */     GIR_EraseRootFromParent_Done,
     /*  326331 */   // Label 6030: @326331
     /*  326331 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(326394), // Rule ID 20125 //
     /*  326336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  326350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326375 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  326378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326392 */     GIR_RootConstrainSelectedInstOperands,
     /*  326393 */     // GIR_Coverage, 20125,
     /*  326393 */     GIR_EraseRootFromParent_Done,
     /*  326394 */   // Label 6031: @326394
     /*  326394 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(326457), // Rule ID 20128 //
     /*  326399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  326410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  326413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326438 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  326441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326455 */     GIR_RootConstrainSelectedInstOperands,
     /*  326456 */     // GIR_Coverage, 20128,
     /*  326456 */     GIR_EraseRootFromParent_Done,
     /*  326457 */   // Label 6032: @326457
     /*  326457 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(326520), // Rule ID 20129 //
     /*  326462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  326473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  326476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326501 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  326504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326518 */     GIR_RootConstrainSelectedInstOperands,
     /*  326519 */     // GIR_Coverage, 20129,
     /*  326519 */     GIR_EraseRootFromParent_Done,
     /*  326520 */   // Label 6033: @326520
     /*  326520 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(326583), // Rule ID 20132 //
     /*  326525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  326539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326564 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  326567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326581 */     GIR_RootConstrainSelectedInstOperands,
     /*  326582 */     // GIR_Coverage, 20132,
     /*  326582 */     GIR_EraseRootFromParent_Done,
     /*  326583 */   // Label 6034: @326583
     /*  326583 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(326646), // Rule ID 20133 //
     /*  326588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  326602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326627 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  326630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326644 */     GIR_RootConstrainSelectedInstOperands,
     /*  326645 */     // GIR_Coverage, 20133,
     /*  326645 */     GIR_EraseRootFromParent_Done,
     /*  326646 */   // Label 6035: @326646
     /*  326646 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(326709), // Rule ID 20136 //
     /*  326651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  326665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326690 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  326693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326707 */     GIR_RootConstrainSelectedInstOperands,
     /*  326708 */     // GIR_Coverage, 20136,
     /*  326708 */     GIR_EraseRootFromParent_Done,
     /*  326709 */   // Label 6036: @326709
     /*  326709 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(326772), // Rule ID 20137 //
     /*  326714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  326728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326753 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  326756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326770 */     GIR_RootConstrainSelectedInstOperands,
     /*  326771 */     // GIR_Coverage, 20137,
     /*  326771 */     GIR_EraseRootFromParent_Done,
     /*  326772 */   // Label 6037: @326772
     /*  326772 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(326835), // Rule ID 20140 //
     /*  326777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  326791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  326819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326833 */     GIR_RootConstrainSelectedInstOperands,
     /*  326834 */     // GIR_Coverage, 20140,
     /*  326834 */     GIR_EraseRootFromParent_Done,
     /*  326835 */   // Label 6038: @326835
     /*  326835 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(326898), // Rule ID 20141 //
     /*  326840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  326854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326879 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  326882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326896 */     GIR_RootConstrainSelectedInstOperands,
     /*  326897 */     // GIR_Coverage, 20141,
     /*  326897 */     GIR_EraseRootFromParent_Done,
     /*  326898 */   // Label 6039: @326898
     /*  326898 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(326961), // Rule ID 20144 //
     /*  326903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  326917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326942 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  326945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326959 */     GIR_RootConstrainSelectedInstOperands,
     /*  326960 */     // GIR_Coverage, 20144,
     /*  326960 */     GIR_EraseRootFromParent_Done,
     /*  326961 */   // Label 6040: @326961
     /*  326961 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(327024), // Rule ID 20145 //
     /*  326966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  326980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327005 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  327008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327022 */     GIR_RootConstrainSelectedInstOperands,
     /*  327023 */     // GIR_Coverage, 20145,
     /*  327023 */     GIR_EraseRootFromParent_Done,
     /*  327024 */   // Label 6041: @327024
     /*  327024 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(327087), // Rule ID 20148 //
     /*  327029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  327043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  327046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  327071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327085 */     GIR_RootConstrainSelectedInstOperands,
     /*  327086 */     // GIR_Coverage, 20148,
     /*  327086 */     GIR_EraseRootFromParent_Done,
     /*  327087 */   // Label 6042: @327087
     /*  327087 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(327150), // Rule ID 20149 //
     /*  327092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  327106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  327109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327131 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  327134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327148 */     GIR_RootConstrainSelectedInstOperands,
     /*  327149 */     // GIR_Coverage, 20149,
     /*  327149 */     GIR_EraseRootFromParent_Done,
     /*  327150 */   // Label 6043: @327150
     /*  327150 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(327213), // Rule ID 20152 //
     /*  327155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  327169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  327172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327194 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  327197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327211 */     GIR_RootConstrainSelectedInstOperands,
     /*  327212 */     // GIR_Coverage, 20152,
     /*  327212 */     GIR_EraseRootFromParent_Done,
     /*  327213 */   // Label 6044: @327213
     /*  327213 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(327276), // Rule ID 20153 //
     /*  327218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  327232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  327235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327257 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  327260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327274 */     GIR_RootConstrainSelectedInstOperands,
     /*  327275 */     // GIR_Coverage, 20153,
     /*  327275 */     GIR_EraseRootFromParent_Done,
     /*  327276 */   // Label 6045: @327276
     /*  327276 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(327339), // Rule ID 20156 //
     /*  327281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  327295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  327298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327320 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327337 */     GIR_RootConstrainSelectedInstOperands,
     /*  327338 */     // GIR_Coverage, 20156,
     /*  327338 */     GIR_EraseRootFromParent_Done,
     /*  327339 */   // Label 6046: @327339
     /*  327339 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(327402), // Rule ID 20157 //
     /*  327344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  327358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  327361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327383 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327400 */     GIR_RootConstrainSelectedInstOperands,
     /*  327401 */     // GIR_Coverage, 20157,
     /*  327401 */     GIR_EraseRootFromParent_Done,
     /*  327402 */   // Label 6047: @327402
     /*  327402 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(327465), // Rule ID 20160 //
     /*  327407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  327421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  327424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327463 */     GIR_RootConstrainSelectedInstOperands,
     /*  327464 */     // GIR_Coverage, 20160,
     /*  327464 */     GIR_EraseRootFromParent_Done,
     /*  327465 */   // Label 6048: @327465
     /*  327465 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(327528), // Rule ID 20161 //
     /*  327470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  327484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  327487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327509 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327526 */     GIR_RootConstrainSelectedInstOperands,
     /*  327527 */     // GIR_Coverage, 20161,
     /*  327527 */     GIR_EraseRootFromParent_Done,
     /*  327528 */   // Label 6049: @327528
     /*  327528 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(327591), // Rule ID 20164 //
     /*  327533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  327536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  327547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  327550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327572 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  327572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327589 */     GIR_RootConstrainSelectedInstOperands,
     /*  327590 */     // GIR_Coverage, 20164,
     /*  327590 */     GIR_EraseRootFromParent_Done,
     /*  327591 */   // Label 6050: @327591
     /*  327591 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(327654), // Rule ID 20165 //
     /*  327596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  327599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  327610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  327613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327635 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  327635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327652 */     GIR_RootConstrainSelectedInstOperands,
     /*  327653 */     // GIR_Coverage, 20165,
     /*  327653 */     GIR_EraseRootFromParent_Done,
     /*  327654 */   // Label 6051: @327654
     /*  327654 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(327717), // Rule ID 20168 //
     /*  327659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  327673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  327676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327698 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327715 */     GIR_RootConstrainSelectedInstOperands,
     /*  327716 */     // GIR_Coverage, 20168,
     /*  327716 */     GIR_EraseRootFromParent_Done,
     /*  327717 */   // Label 6052: @327717
     /*  327717 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(327780), // Rule ID 20169 //
     /*  327722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  327736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  327739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327761 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327778 */     GIR_RootConstrainSelectedInstOperands,
     /*  327779 */     // GIR_Coverage, 20169,
     /*  327779 */     GIR_EraseRootFromParent_Done,
     /*  327780 */   // Label 6053: @327780
     /*  327780 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(327843), // Rule ID 20172 //
     /*  327785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  327799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  327802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327824 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327841 */     GIR_RootConstrainSelectedInstOperands,
     /*  327842 */     // GIR_Coverage, 20172,
     /*  327842 */     GIR_EraseRootFromParent_Done,
     /*  327843 */   // Label 6054: @327843
     /*  327843 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(327906), // Rule ID 20173 //
     /*  327848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  327862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  327865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327887 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327904 */     GIR_RootConstrainSelectedInstOperands,
     /*  327905 */     // GIR_Coverage, 20173,
     /*  327905 */     GIR_EraseRootFromParent_Done,
     /*  327906 */   // Label 6055: @327906
     /*  327906 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(327969), // Rule ID 20176 //
     /*  327911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327950 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327967 */     GIR_RootConstrainSelectedInstOperands,
     /*  327968 */     // GIR_Coverage, 20176,
     /*  327968 */     GIR_EraseRootFromParent_Done,
     /*  327969 */   // Label 6056: @327969
     /*  327969 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(328032), // Rule ID 20177 //
     /*  327974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328013 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328030 */     GIR_RootConstrainSelectedInstOperands,
     /*  328031 */     // GIR_Coverage, 20177,
     /*  328031 */     GIR_EraseRootFromParent_Done,
     /*  328032 */   // Label 6057: @328032
     /*  328032 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(328095), // Rule ID 20180 //
     /*  328037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  328051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  328054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  328079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328093 */     GIR_RootConstrainSelectedInstOperands,
     /*  328094 */     // GIR_Coverage, 20180,
     /*  328094 */     GIR_EraseRootFromParent_Done,
     /*  328095 */   // Label 6058: @328095
     /*  328095 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(328158), // Rule ID 20181 //
     /*  328100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  328114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  328117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328139 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  328142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328156 */     GIR_RootConstrainSelectedInstOperands,
     /*  328157 */     // GIR_Coverage, 20181,
     /*  328157 */     GIR_EraseRootFromParent_Done,
     /*  328158 */   // Label 6059: @328158
     /*  328158 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(328221), // Rule ID 20184 //
     /*  328163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  328177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  328180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328202 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  328205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328219 */     GIR_RootConstrainSelectedInstOperands,
     /*  328220 */     // GIR_Coverage, 20184,
     /*  328220 */     GIR_EraseRootFromParent_Done,
     /*  328221 */   // Label 6060: @328221
     /*  328221 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(328284), // Rule ID 20185 //
     /*  328226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  328240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  328243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328265 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  328268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328282 */     GIR_RootConstrainSelectedInstOperands,
     /*  328283 */     // GIR_Coverage, 20185,
     /*  328283 */     GIR_EraseRootFromParent_Done,
     /*  328284 */   // Label 6061: @328284
     /*  328284 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(328347), // Rule ID 20188 //
     /*  328289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  328300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  328303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  328306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328328 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328345 */     GIR_RootConstrainSelectedInstOperands,
     /*  328346 */     // GIR_Coverage, 20188,
     /*  328346 */     GIR_EraseRootFromParent_Done,
     /*  328347 */   // Label 6062: @328347
     /*  328347 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(328410), // Rule ID 20189 //
     /*  328352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  328363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  328366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  328369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328391 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328408 */     GIR_RootConstrainSelectedInstOperands,
     /*  328409 */     // GIR_Coverage, 20189,
     /*  328409 */     GIR_EraseRootFromParent_Done,
     /*  328410 */   // Label 6063: @328410
     /*  328410 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(328473), // Rule ID 20192 //
     /*  328415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  328429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  328432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328454 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  328457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328471 */     GIR_RootConstrainSelectedInstOperands,
     /*  328472 */     // GIR_Coverage, 20192,
     /*  328472 */     GIR_EraseRootFromParent_Done,
     /*  328473 */   // Label 6064: @328473
     /*  328473 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(328536), // Rule ID 20193 //
     /*  328478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  328492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  328495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328517 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  328520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328534 */     GIR_RootConstrainSelectedInstOperands,
     /*  328535 */     // GIR_Coverage, 20193,
     /*  328535 */     GIR_EraseRootFromParent_Done,
     /*  328536 */   // Label 6065: @328536
     /*  328536 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(328599), // Rule ID 20196 //
     /*  328541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  328555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  328558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328580 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  328583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328597 */     GIR_RootConstrainSelectedInstOperands,
     /*  328598 */     // GIR_Coverage, 20196,
     /*  328598 */     GIR_EraseRootFromParent_Done,
     /*  328599 */   // Label 6066: @328599
     /*  328599 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(328662), // Rule ID 20197 //
     /*  328604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  328618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  328621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328643 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  328646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328660 */     GIR_RootConstrainSelectedInstOperands,
     /*  328661 */     // GIR_Coverage, 20197,
     /*  328661 */     GIR_EraseRootFromParent_Done,
     /*  328662 */   // Label 6067: @328662
     /*  328662 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(328725), // Rule ID 20200 //
     /*  328667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  328681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  328684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328706 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328723 */     GIR_RootConstrainSelectedInstOperands,
     /*  328724 */     // GIR_Coverage, 20200,
     /*  328724 */     GIR_EraseRootFromParent_Done,
     /*  328725 */   // Label 6068: @328725
     /*  328725 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(328788), // Rule ID 20201 //
     /*  328730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  328744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  328747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328769 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328786 */     GIR_RootConstrainSelectedInstOperands,
     /*  328787 */     // GIR_Coverage, 20201,
     /*  328787 */     GIR_EraseRootFromParent_Done,
     /*  328788 */   // Label 6069: @328788
     /*  328788 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(328851), // Rule ID 20204 //
     /*  328793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  328807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328832 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  328835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328849 */     GIR_RootConstrainSelectedInstOperands,
     /*  328850 */     // GIR_Coverage, 20204,
     /*  328850 */     GIR_EraseRootFromParent_Done,
     /*  328851 */   // Label 6070: @328851
     /*  328851 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(328914), // Rule ID 20205 //
     /*  328856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  328870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328895 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  328898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328912 */     GIR_RootConstrainSelectedInstOperands,
     /*  328913 */     // GIR_Coverage, 20205,
     /*  328913 */     GIR_EraseRootFromParent_Done,
     /*  328914 */   // Label 6071: @328914
     /*  328914 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(328977), // Rule ID 20208 //
     /*  328919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328958 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  328961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328975 */     GIR_RootConstrainSelectedInstOperands,
     /*  328976 */     // GIR_Coverage, 20208,
     /*  328976 */     GIR_EraseRootFromParent_Done,
     /*  328977 */   // Label 6072: @328977
     /*  328977 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(329040), // Rule ID 20209 //
     /*  328982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329021 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  329024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329038 */     GIR_RootConstrainSelectedInstOperands,
     /*  329039 */     // GIR_Coverage, 20209,
     /*  329039 */     GIR_EraseRootFromParent_Done,
     /*  329040 */   // Label 6073: @329040
     /*  329040 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(329103), // Rule ID 20212 //
     /*  329045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  329059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329084 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  329087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329101 */     GIR_RootConstrainSelectedInstOperands,
     /*  329102 */     // GIR_Coverage, 20212,
     /*  329102 */     GIR_EraseRootFromParent_Done,
     /*  329103 */   // Label 6074: @329103
     /*  329103 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(329166), // Rule ID 20213 //
     /*  329108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  329122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329147 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  329150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329164 */     GIR_RootConstrainSelectedInstOperands,
     /*  329165 */     // GIR_Coverage, 20213,
     /*  329165 */     GIR_EraseRootFromParent_Done,
     /*  329166 */   // Label 6075: @329166
     /*  329166 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(329229), // Rule ID 20216 //
     /*  329171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  329185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329210 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  329213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329227 */     GIR_RootConstrainSelectedInstOperands,
     /*  329228 */     // GIR_Coverage, 20216,
     /*  329228 */     GIR_EraseRootFromParent_Done,
     /*  329229 */   // Label 6076: @329229
     /*  329229 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(329292), // Rule ID 20217 //
     /*  329234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  329248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329273 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  329276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329290 */     GIR_RootConstrainSelectedInstOperands,
     /*  329291 */     // GIR_Coverage, 20217,
     /*  329291 */     GIR_EraseRootFromParent_Done,
     /*  329292 */   // Label 6077: @329292
     /*  329292 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(329355), // Rule ID 20220 //
     /*  329297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  329311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329336 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  329339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329353 */     GIR_RootConstrainSelectedInstOperands,
     /*  329354 */     // GIR_Coverage, 20220,
     /*  329354 */     GIR_EraseRootFromParent_Done,
     /*  329355 */   // Label 6078: @329355
     /*  329355 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(329418), // Rule ID 20221 //
     /*  329360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  329374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329399 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  329402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329416 */     GIR_RootConstrainSelectedInstOperands,
     /*  329417 */     // GIR_Coverage, 20221,
     /*  329417 */     GIR_EraseRootFromParent_Done,
     /*  329418 */   // Label 6079: @329418
     /*  329418 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(329481), // Rule ID 20224 //
     /*  329423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  329437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329462 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  329465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329479 */     GIR_RootConstrainSelectedInstOperands,
     /*  329480 */     // GIR_Coverage, 20224,
     /*  329480 */     GIR_EraseRootFromParent_Done,
     /*  329481 */   // Label 6080: @329481
     /*  329481 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(329544), // Rule ID 20225 //
     /*  329486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  329500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329525 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  329528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329542 */     GIR_RootConstrainSelectedInstOperands,
     /*  329543 */     // GIR_Coverage, 20225,
     /*  329543 */     GIR_EraseRootFromParent_Done,
     /*  329544 */   // Label 6081: @329544
     /*  329544 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(329607), // Rule ID 20228 //
     /*  329549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  329563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329588 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  329591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329605 */     GIR_RootConstrainSelectedInstOperands,
     /*  329606 */     // GIR_Coverage, 20228,
     /*  329606 */     GIR_EraseRootFromParent_Done,
     /*  329607 */   // Label 6082: @329607
     /*  329607 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(329670), // Rule ID 20229 //
     /*  329612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  329626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329651 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  329654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329668 */     GIR_RootConstrainSelectedInstOperands,
     /*  329669 */     // GIR_Coverage, 20229,
     /*  329669 */     GIR_EraseRootFromParent_Done,
     /*  329670 */   // Label 6083: @329670
     /*  329670 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(329733), // Rule ID 20232 //
     /*  329675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329714 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  329717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329731 */     GIR_RootConstrainSelectedInstOperands,
     /*  329732 */     // GIR_Coverage, 20232,
     /*  329732 */     GIR_EraseRootFromParent_Done,
     /*  329733 */   // Label 6084: @329733
     /*  329733 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(329796), // Rule ID 20233 //
     /*  329738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329777 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  329780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329794 */     GIR_RootConstrainSelectedInstOperands,
     /*  329795 */     // GIR_Coverage, 20233,
     /*  329795 */     GIR_EraseRootFromParent_Done,
     /*  329796 */   // Label 6085: @329796
     /*  329796 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(329859), // Rule ID 20236 //
     /*  329801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329840 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  329843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329857 */     GIR_RootConstrainSelectedInstOperands,
     /*  329858 */     // GIR_Coverage, 20236,
     /*  329858 */     GIR_EraseRootFromParent_Done,
     /*  329859 */   // Label 6086: @329859
     /*  329859 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(329922), // Rule ID 20237 //
     /*  329864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329903 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  329906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329920 */     GIR_RootConstrainSelectedInstOperands,
     /*  329921 */     // GIR_Coverage, 20237,
     /*  329921 */     GIR_EraseRootFromParent_Done,
     /*  329922 */   // Label 6087: @329922
     /*  329922 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(329985), // Rule ID 20240 //
     /*  329927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329966 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  329969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329983 */     GIR_RootConstrainSelectedInstOperands,
     /*  329984 */     // GIR_Coverage, 20240,
     /*  329984 */     GIR_EraseRootFromParent_Done,
     /*  329985 */   // Label 6088: @329985
     /*  329985 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(330048), // Rule ID 20241 //
     /*  329990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  330004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330029 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  330032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330046 */     GIR_RootConstrainSelectedInstOperands,
     /*  330047 */     // GIR_Coverage, 20241,
     /*  330047 */     GIR_EraseRootFromParent_Done,
     /*  330048 */   // Label 6089: @330048
     /*  330048 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(330111), // Rule ID 20244 //
     /*  330053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  330067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330092 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  330095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330109 */     GIR_RootConstrainSelectedInstOperands,
     /*  330110 */     // GIR_Coverage, 20244,
     /*  330110 */     GIR_EraseRootFromParent_Done,
     /*  330111 */   // Label 6090: @330111
     /*  330111 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(330174), // Rule ID 20245 //
     /*  330116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  330130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330155 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  330158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330172 */     GIR_RootConstrainSelectedInstOperands,
     /*  330173 */     // GIR_Coverage, 20245,
     /*  330173 */     GIR_EraseRootFromParent_Done,
     /*  330174 */   // Label 6091: @330174
     /*  330174 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(330237), // Rule ID 20248 //
     /*  330179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  330190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  330193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330218 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  330221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330235 */     GIR_RootConstrainSelectedInstOperands,
     /*  330236 */     // GIR_Coverage, 20248,
     /*  330236 */     GIR_EraseRootFromParent_Done,
     /*  330237 */   // Label 6092: @330237
     /*  330237 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(330300), // Rule ID 20249 //
     /*  330242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  330253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  330256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330281 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  330284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330298 */     GIR_RootConstrainSelectedInstOperands,
     /*  330299 */     // GIR_Coverage, 20249,
     /*  330299 */     GIR_EraseRootFromParent_Done,
     /*  330300 */   // Label 6093: @330300
     /*  330300 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(330363), // Rule ID 20252 //
     /*  330305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  330319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330344 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  330347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330361 */     GIR_RootConstrainSelectedInstOperands,
     /*  330362 */     // GIR_Coverage, 20252,
     /*  330362 */     GIR_EraseRootFromParent_Done,
     /*  330363 */   // Label 6094: @330363
     /*  330363 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(330426), // Rule ID 20253 //
     /*  330368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  330382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330407 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  330410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330424 */     GIR_RootConstrainSelectedInstOperands,
     /*  330425 */     // GIR_Coverage, 20253,
     /*  330425 */     GIR_EraseRootFromParent_Done,
     /*  330426 */   // Label 6095: @330426
     /*  330426 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(330489), // Rule ID 20256 //
     /*  330431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  330445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330470 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  330473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330487 */     GIR_RootConstrainSelectedInstOperands,
     /*  330488 */     // GIR_Coverage, 20256,
     /*  330488 */     GIR_EraseRootFromParent_Done,
     /*  330489 */   // Label 6096: @330489
     /*  330489 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(330552), // Rule ID 20257 //
     /*  330494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  330508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330533 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  330536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330550 */     GIR_RootConstrainSelectedInstOperands,
     /*  330551 */     // GIR_Coverage, 20257,
     /*  330551 */     GIR_EraseRootFromParent_Done,
     /*  330552 */   // Label 6097: @330552
     /*  330552 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(330615), // Rule ID 20260 //
     /*  330557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330596 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  330599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330613 */     GIR_RootConstrainSelectedInstOperands,
     /*  330614 */     // GIR_Coverage, 20260,
     /*  330614 */     GIR_EraseRootFromParent_Done,
     /*  330615 */   // Label 6098: @330615
     /*  330615 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(330678), // Rule ID 20261 //
     /*  330620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330659 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  330662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330676 */     GIR_RootConstrainSelectedInstOperands,
     /*  330677 */     // GIR_Coverage, 20261,
     /*  330677 */     GIR_EraseRootFromParent_Done,
     /*  330678 */   // Label 6099: @330678
     /*  330678 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(330741), // Rule ID 20264 //
     /*  330683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  330697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330722 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  330725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330739 */     GIR_RootConstrainSelectedInstOperands,
     /*  330740 */     // GIR_Coverage, 20264,
     /*  330740 */     GIR_EraseRootFromParent_Done,
     /*  330741 */   // Label 6100: @330741
     /*  330741 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(330804), // Rule ID 20265 //
     /*  330746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  330760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330785 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  330788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330802 */     GIR_RootConstrainSelectedInstOperands,
     /*  330803 */     // GIR_Coverage, 20265,
     /*  330803 */     GIR_EraseRootFromParent_Done,
     /*  330804 */   // Label 6101: @330804
     /*  330804 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(330867), // Rule ID 20268 //
     /*  330809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  330823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330848 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  330851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330865 */     GIR_RootConstrainSelectedInstOperands,
     /*  330866 */     // GIR_Coverage, 20268,
     /*  330866 */     GIR_EraseRootFromParent_Done,
     /*  330867 */   // Label 6102: @330867
     /*  330867 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(330930), // Rule ID 20269 //
     /*  330872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  330886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330911 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  330914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330928 */     GIR_RootConstrainSelectedInstOperands,
     /*  330929 */     // GIR_Coverage, 20269,
     /*  330929 */     GIR_EraseRootFromParent_Done,
     /*  330930 */   // Label 6103: @330930
     /*  330930 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(330993), // Rule ID 20272 //
     /*  330935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330974 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  330977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330991 */     GIR_RootConstrainSelectedInstOperands,
     /*  330992 */     // GIR_Coverage, 20272,
     /*  330992 */     GIR_EraseRootFromParent_Done,
     /*  330993 */   // Label 6104: @330993
     /*  330993 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(331056), // Rule ID 20273 //
     /*  330998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  331009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  331012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331037 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  331040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331054 */     GIR_RootConstrainSelectedInstOperands,
     /*  331055 */     // GIR_Coverage, 20273,
     /*  331055 */     GIR_EraseRootFromParent_Done,
     /*  331056 */   // Label 6105: @331056
     /*  331056 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(331119), // Rule ID 20276 //
     /*  331061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  331075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331100 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  331103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331117 */     GIR_RootConstrainSelectedInstOperands,
     /*  331118 */     // GIR_Coverage, 20276,
     /*  331118 */     GIR_EraseRootFromParent_Done,
     /*  331119 */   // Label 6106: @331119
     /*  331119 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(331182), // Rule ID 20277 //
     /*  331124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  331138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331163 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  331166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331180 */     GIR_RootConstrainSelectedInstOperands,
     /*  331181 */     // GIR_Coverage, 20277,
     /*  331181 */     GIR_EraseRootFromParent_Done,
     /*  331182 */   // Label 6107: @331182
     /*  331182 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(331245), // Rule ID 20280 //
     /*  331187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  331201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331226 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  331229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331243 */     GIR_RootConstrainSelectedInstOperands,
     /*  331244 */     // GIR_Coverage, 20280,
     /*  331244 */     GIR_EraseRootFromParent_Done,
     /*  331245 */   // Label 6108: @331245
     /*  331245 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(331308), // Rule ID 20281 //
     /*  331250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  331264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331289 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  331292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331306 */     GIR_RootConstrainSelectedInstOperands,
     /*  331307 */     // GIR_Coverage, 20281,
     /*  331307 */     GIR_EraseRootFromParent_Done,
     /*  331308 */   // Label 6109: @331308
     /*  331308 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(331371), // Rule ID 20284 //
     /*  331313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  331324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  331327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331352 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  331355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331369 */     GIR_RootConstrainSelectedInstOperands,
     /*  331370 */     // GIR_Coverage, 20284,
     /*  331370 */     GIR_EraseRootFromParent_Done,
     /*  331371 */   // Label 6110: @331371
     /*  331371 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(331434), // Rule ID 20285 //
     /*  331376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  331387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  331390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331415 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  331418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331432 */     GIR_RootConstrainSelectedInstOperands,
     /*  331433 */     // GIR_Coverage, 20285,
     /*  331433 */     GIR_EraseRootFromParent_Done,
     /*  331434 */   // Label 6111: @331434
     /*  331434 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(331497), // Rule ID 20288 //
     /*  331439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  331453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331478 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  331481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331495 */     GIR_RootConstrainSelectedInstOperands,
     /*  331496 */     // GIR_Coverage, 20288,
     /*  331496 */     GIR_EraseRootFromParent_Done,
     /*  331497 */   // Label 6112: @331497
     /*  331497 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(331560), // Rule ID 20289 //
     /*  331502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  331516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331541 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  331544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331558 */     GIR_RootConstrainSelectedInstOperands,
     /*  331559 */     // GIR_Coverage, 20289,
     /*  331559 */     GIR_EraseRootFromParent_Done,
     /*  331560 */   // Label 6113: @331560
     /*  331560 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(331623), // Rule ID 20292 //
     /*  331565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  331579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331604 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  331607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331621 */     GIR_RootConstrainSelectedInstOperands,
     /*  331622 */     // GIR_Coverage, 20292,
     /*  331622 */     GIR_EraseRootFromParent_Done,
     /*  331623 */   // Label 6114: @331623
     /*  331623 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(331686), // Rule ID 20293 //
     /*  331628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  331642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331667 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  331670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331684 */     GIR_RootConstrainSelectedInstOperands,
     /*  331685 */     // GIR_Coverage, 20293,
     /*  331685 */     GIR_EraseRootFromParent_Done,
     /*  331686 */   // Label 6115: @331686
     /*  331686 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(331749), // Rule ID 20296 //
     /*  331691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  331702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  331705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331730 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  331733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331747 */     GIR_RootConstrainSelectedInstOperands,
     /*  331748 */     // GIR_Coverage, 20296,
     /*  331748 */     GIR_EraseRootFromParent_Done,
     /*  331749 */   // Label 6116: @331749
     /*  331749 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(331812), // Rule ID 20297 //
     /*  331754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  331765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  331768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331793 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  331796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331810 */     GIR_RootConstrainSelectedInstOperands,
     /*  331811 */     // GIR_Coverage, 20297,
     /*  331811 */     GIR_EraseRootFromParent_Done,
     /*  331812 */   // Label 6117: @331812
     /*  331812 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(331875), // Rule ID 20300 //
     /*  331817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331856 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  331859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331873 */     GIR_RootConstrainSelectedInstOperands,
     /*  331874 */     // GIR_Coverage, 20300,
     /*  331874 */     GIR_EraseRootFromParent_Done,
     /*  331875 */   // Label 6118: @331875
     /*  331875 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(331938), // Rule ID 20301 //
     /*  331880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331919 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  331922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331936 */     GIR_RootConstrainSelectedInstOperands,
     /*  331937 */     // GIR_Coverage, 20301,
     /*  331937 */     GIR_EraseRootFromParent_Done,
     /*  331938 */   // Label 6119: @331938
     /*  331938 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(332001), // Rule ID 20304 //
     /*  331943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331982 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  331985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331999 */     GIR_RootConstrainSelectedInstOperands,
     /*  332000 */     // GIR_Coverage, 20304,
     /*  332000 */     GIR_EraseRootFromParent_Done,
     /*  332001 */   // Label 6120: @332001
     /*  332001 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(332064), // Rule ID 20305 //
     /*  332006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  332020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332045 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  332048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332062 */     GIR_RootConstrainSelectedInstOperands,
     /*  332063 */     // GIR_Coverage, 20305,
     /*  332063 */     GIR_EraseRootFromParent_Done,
     /*  332064 */   // Label 6121: @332064
     /*  332064 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(332127), // Rule ID 20308 //
     /*  332069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  332080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  332083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332108 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  332111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332125 */     GIR_RootConstrainSelectedInstOperands,
     /*  332126 */     // GIR_Coverage, 20308,
     /*  332126 */     GIR_EraseRootFromParent_Done,
     /*  332127 */   // Label 6122: @332127
     /*  332127 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(332190), // Rule ID 20309 //
     /*  332132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  332143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  332146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332171 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  332174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332188 */     GIR_RootConstrainSelectedInstOperands,
     /*  332189 */     // GIR_Coverage, 20309,
     /*  332189 */     GIR_EraseRootFromParent_Done,
     /*  332190 */   // Label 6123: @332190
     /*  332190 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(332253), // Rule ID 20312 //
     /*  332195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  332209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332234 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  332237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332251 */     GIR_RootConstrainSelectedInstOperands,
     /*  332252 */     // GIR_Coverage, 20312,
     /*  332252 */     GIR_EraseRootFromParent_Done,
     /*  332253 */   // Label 6124: @332253
     /*  332253 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(332316), // Rule ID 20313 //
     /*  332258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  332272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332297 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  332300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332314 */     GIR_RootConstrainSelectedInstOperands,
     /*  332315 */     // GIR_Coverage, 20313,
     /*  332315 */     GIR_EraseRootFromParent_Done,
     /*  332316 */   // Label 6125: @332316
     /*  332316 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(332379), // Rule ID 20316 //
     /*  332321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  332335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332360 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  332363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332377 */     GIR_RootConstrainSelectedInstOperands,
     /*  332378 */     // GIR_Coverage, 20316,
     /*  332378 */     GIR_EraseRootFromParent_Done,
     /*  332379 */   // Label 6126: @332379
     /*  332379 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(332442), // Rule ID 20317 //
     /*  332384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  332398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332423 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  332426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332440 */     GIR_RootConstrainSelectedInstOperands,
     /*  332441 */     // GIR_Coverage, 20317,
     /*  332441 */     GIR_EraseRootFromParent_Done,
     /*  332442 */   // Label 6127: @332442
     /*  332442 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(332505), // Rule ID 20320 //
     /*  332447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  332461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332486 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  332489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332503 */     GIR_RootConstrainSelectedInstOperands,
     /*  332504 */     // GIR_Coverage, 20320,
     /*  332504 */     GIR_EraseRootFromParent_Done,
     /*  332505 */   // Label 6128: @332505
     /*  332505 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(332568), // Rule ID 20321 //
     /*  332510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  332524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332549 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  332552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332566 */     GIR_RootConstrainSelectedInstOperands,
     /*  332567 */     // GIR_Coverage, 20321,
     /*  332567 */     GIR_EraseRootFromParent_Done,
     /*  332568 */   // Label 6129: @332568
     /*  332568 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(332631), // Rule ID 20324 //
     /*  332573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332612 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  332615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332629 */     GIR_RootConstrainSelectedInstOperands,
     /*  332630 */     // GIR_Coverage, 20324,
     /*  332630 */     GIR_EraseRootFromParent_Done,
     /*  332631 */   // Label 6130: @332631
     /*  332631 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(332694), // Rule ID 20325 //
     /*  332636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332675 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  332678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332692 */     GIR_RootConstrainSelectedInstOperands,
     /*  332693 */     // GIR_Coverage, 20325,
     /*  332693 */     GIR_EraseRootFromParent_Done,
     /*  332694 */   // Label 6131: @332694
     /*  332694 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(332757), // Rule ID 20328 //
     /*  332699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332738 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  332741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332755 */     GIR_RootConstrainSelectedInstOperands,
     /*  332756 */     // GIR_Coverage, 20328,
     /*  332756 */     GIR_EraseRootFromParent_Done,
     /*  332757 */   // Label 6132: @332757
     /*  332757 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(332820), // Rule ID 20329 //
     /*  332762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332801 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  332804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332818 */     GIR_RootConstrainSelectedInstOperands,
     /*  332819 */     // GIR_Coverage, 20329,
     /*  332819 */     GIR_EraseRootFromParent_Done,
     /*  332820 */   // Label 6133: @332820
     /*  332820 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(332883), // Rule ID 20332 //
     /*  332825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332864 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  332867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332881 */     GIR_RootConstrainSelectedInstOperands,
     /*  332882 */     // GIR_Coverage, 20332,
     /*  332882 */     GIR_EraseRootFromParent_Done,
     /*  332883 */   // Label 6134: @332883
     /*  332883 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(332946), // Rule ID 20333 //
     /*  332888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332927 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  332930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332944 */     GIR_RootConstrainSelectedInstOperands,
     /*  332945 */     // GIR_Coverage, 20333,
     /*  332945 */     GIR_EraseRootFromParent_Done,
     /*  332946 */   // Label 6135: @332946
     /*  332946 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(333009), // Rule ID 20336 //
     /*  332951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  332965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332990 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  332993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333007 */     GIR_RootConstrainSelectedInstOperands,
     /*  333008 */     // GIR_Coverage, 20336,
     /*  333008 */     GIR_EraseRootFromParent_Done,
     /*  333009 */   // Label 6136: @333009
     /*  333009 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(333072), // Rule ID 20337 //
     /*  333014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  333028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333053 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  333056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333070 */     GIR_RootConstrainSelectedInstOperands,
     /*  333071 */     // GIR_Coverage, 20337,
     /*  333071 */     GIR_EraseRootFromParent_Done,
     /*  333072 */   // Label 6137: @333072
     /*  333072 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(333135), // Rule ID 20340 //
     /*  333077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  333091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333116 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  333119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333133 */     GIR_RootConstrainSelectedInstOperands,
     /*  333134 */     // GIR_Coverage, 20340,
     /*  333134 */     GIR_EraseRootFromParent_Done,
     /*  333135 */   // Label 6138: @333135
     /*  333135 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(333198), // Rule ID 20341 //
     /*  333140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  333154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333179 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  333182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333196 */     GIR_RootConstrainSelectedInstOperands,
     /*  333197 */     // GIR_Coverage, 20341,
     /*  333197 */     GIR_EraseRootFromParent_Done,
     /*  333198 */   // Label 6139: @333198
     /*  333198 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(333261), // Rule ID 20344 //
     /*  333203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  333214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  333217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333242 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  333245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333259 */     GIR_RootConstrainSelectedInstOperands,
     /*  333260 */     // GIR_Coverage, 20344,
     /*  333260 */     GIR_EraseRootFromParent_Done,
     /*  333261 */   // Label 6140: @333261
     /*  333261 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(333324), // Rule ID 20345 //
     /*  333266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  333277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  333280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333305 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  333308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333322 */     GIR_RootConstrainSelectedInstOperands,
     /*  333323 */     // GIR_Coverage, 20345,
     /*  333323 */     GIR_EraseRootFromParent_Done,
     /*  333324 */   // Label 6141: @333324
     /*  333324 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(333387), // Rule ID 20348 //
     /*  333329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  333343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333368 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  333371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333385 */     GIR_RootConstrainSelectedInstOperands,
     /*  333386 */     // GIR_Coverage, 20348,
     /*  333386 */     GIR_EraseRootFromParent_Done,
     /*  333387 */   // Label 6142: @333387
     /*  333387 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(333450), // Rule ID 20349 //
     /*  333392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  333406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333431 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  333434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333448 */     GIR_RootConstrainSelectedInstOperands,
     /*  333449 */     // GIR_Coverage, 20349,
     /*  333449 */     GIR_EraseRootFromParent_Done,
     /*  333450 */   // Label 6143: @333450
     /*  333450 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(333513), // Rule ID 20352 //
     /*  333455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  333469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333494 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  333497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333511 */     GIR_RootConstrainSelectedInstOperands,
     /*  333512 */     // GIR_Coverage, 20352,
     /*  333512 */     GIR_EraseRootFromParent_Done,
     /*  333513 */   // Label 6144: @333513
     /*  333513 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(333576), // Rule ID 20353 //
     /*  333518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  333532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333557 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  333560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333574 */     GIR_RootConstrainSelectedInstOperands,
     /*  333575 */     // GIR_Coverage, 20353,
     /*  333575 */     GIR_EraseRootFromParent_Done,
     /*  333576 */   // Label 6145: @333576
     /*  333576 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(333639), // Rule ID 20356 //
     /*  333581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  333592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  333595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333620 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  333623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333637 */     GIR_RootConstrainSelectedInstOperands,
     /*  333638 */     // GIR_Coverage, 20356,
     /*  333638 */     GIR_EraseRootFromParent_Done,
     /*  333639 */   // Label 6146: @333639
     /*  333639 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(333702), // Rule ID 20357 //
     /*  333644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  333655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  333658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333683 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  333686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333700 */     GIR_RootConstrainSelectedInstOperands,
     /*  333701 */     // GIR_Coverage, 20357,
     /*  333701 */     GIR_EraseRootFromParent_Done,
     /*  333702 */   // Label 6147: @333702
     /*  333702 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(333765), // Rule ID 20360 //
     /*  333707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  333721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333746 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  333749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333763 */     GIR_RootConstrainSelectedInstOperands,
     /*  333764 */     // GIR_Coverage, 20360,
     /*  333764 */     GIR_EraseRootFromParent_Done,
     /*  333765 */   // Label 6148: @333765
     /*  333765 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(333828), // Rule ID 20361 //
     /*  333770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  333784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333809 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  333812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333826 */     GIR_RootConstrainSelectedInstOperands,
     /*  333827 */     // GIR_Coverage, 20361,
     /*  333827 */     GIR_EraseRootFromParent_Done,
     /*  333828 */   // Label 6149: @333828
     /*  333828 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(333891), // Rule ID 20364 //
     /*  333833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  333847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333872 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  333875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333889 */     GIR_RootConstrainSelectedInstOperands,
     /*  333890 */     // GIR_Coverage, 20364,
     /*  333890 */     GIR_EraseRootFromParent_Done,
     /*  333891 */   // Label 6150: @333891
     /*  333891 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(333954), // Rule ID 20365 //
     /*  333896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  333910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333935 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  333938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333952 */     GIR_RootConstrainSelectedInstOperands,
     /*  333953 */     // GIR_Coverage, 20365,
     /*  333953 */     GIR_EraseRootFromParent_Done,
     /*  333954 */   // Label 6151: @333954
     /*  333954 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(334017), // Rule ID 20368 //
     /*  333959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  333973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333998 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  334001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334015 */     GIR_RootConstrainSelectedInstOperands,
     /*  334016 */     // GIR_Coverage, 20368,
     /*  334016 */     GIR_EraseRootFromParent_Done,
     /*  334017 */   // Label 6152: @334017
     /*  334017 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(334080), // Rule ID 20369 //
     /*  334022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  334033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  334036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  334039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  334054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334061 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  334064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334078 */     GIR_RootConstrainSelectedInstOperands,
     /*  334079 */     // GIR_Coverage, 20369,
     /*  334079 */     GIR_EraseRootFromParent_Done,
     /*  334080 */   // Label 6153: @334080
     /*  334080 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(334143), // Rule ID 20372 //
     /*  334085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  334088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  334099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334124 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  334124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  334127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334141 */     GIR_RootConstrainSelectedInstOperands,
     /*  334142 */     // GIR_Coverage, 20372,
     /*  334142 */     GIR_EraseRootFromParent_Done,
     /*  334143 */   // Label 6154: @334143
     /*  334143 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(334206), // Rule ID 20373 //
     /*  334148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  334151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  334162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334187 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  334190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334204 */     GIR_RootConstrainSelectedInstOperands,
     /*  334205 */     // GIR_Coverage, 20373,
     /*  334205 */     GIR_EraseRootFromParent_Done,
     /*  334206 */   // Label 6155: @334206
     /*  334206 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(334269), // Rule ID 20376 //
     /*  334211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  334214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  334225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334250 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  334250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  334253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334267 */     GIR_RootConstrainSelectedInstOperands,
     /*  334268 */     // GIR_Coverage, 20376,
     /*  334268 */     GIR_EraseRootFromParent_Done,
     /*  334269 */   // Label 6156: @334269
     /*  334269 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(334332), // Rule ID 20377 //
     /*  334274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  334277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  334288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334313 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  334316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334330 */     GIR_RootConstrainSelectedInstOperands,
     /*  334331 */     // GIR_Coverage, 20377,
     /*  334331 */     GIR_EraseRootFromParent_Done,
     /*  334332 */   // Label 6157: @334332
     /*  334332 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(334395), // Rule ID 20380 //
     /*  334337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  334340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  334351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334376 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  334376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  334379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334393 */     GIR_RootConstrainSelectedInstOperands,
     /*  334394 */     // GIR_Coverage, 20380,
     /*  334394 */     GIR_EraseRootFromParent_Done,
     /*  334395 */   // Label 6158: @334395
     /*  334395 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(334458), // Rule ID 20381 //
     /*  334400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  334403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  334414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334439 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  334442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334456 */     GIR_RootConstrainSelectedInstOperands,
     /*  334457 */     // GIR_Coverage, 20381,
     /*  334457 */     GIR_EraseRootFromParent_Done,
     /*  334458 */   // Label 6159: @334458
     /*  334458 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(334521), // Rule ID 20384 //
     /*  334463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  334477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  334480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334502 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  334505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334519 */     GIR_RootConstrainSelectedInstOperands,
     /*  334520 */     // GIR_Coverage, 20384,
     /*  334520 */     GIR_EraseRootFromParent_Done,
     /*  334521 */   // Label 6160: @334521
     /*  334521 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(334584), // Rule ID 20385 //
     /*  334526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  334540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  334543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334565 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  334568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334582 */     GIR_RootConstrainSelectedInstOperands,
     /*  334583 */     // GIR_Coverage, 20385,
     /*  334583 */     GIR_EraseRootFromParent_Done,
     /*  334584 */   // Label 6161: @334584
     /*  334584 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(334647), // Rule ID 20388 //
     /*  334589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  334603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  334606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334628 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334645 */     GIR_RootConstrainSelectedInstOperands,
     /*  334646 */     // GIR_Coverage, 20388,
     /*  334646 */     GIR_EraseRootFromParent_Done,
     /*  334647 */   // Label 6162: @334647
     /*  334647 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(334710), // Rule ID 20389 //
     /*  334652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  334666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  334669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334691 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334708 */     GIR_RootConstrainSelectedInstOperands,
     /*  334709 */     // GIR_Coverage, 20389,
     /*  334709 */     GIR_EraseRootFromParent_Done,
     /*  334710 */   // Label 6163: @334710
     /*  334710 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(334773), // Rule ID 20392 //
     /*  334715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  334729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  334732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334754 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334771 */     GIR_RootConstrainSelectedInstOperands,
     /*  334772 */     // GIR_Coverage, 20392,
     /*  334772 */     GIR_EraseRootFromParent_Done,
     /*  334773 */   // Label 6164: @334773
     /*  334773 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(334836), // Rule ID 20393 //
     /*  334778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  334792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  334795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334817 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334834 */     GIR_RootConstrainSelectedInstOperands,
     /*  334835 */     // GIR_Coverage, 20393,
     /*  334835 */     GIR_EraseRootFromParent_Done,
     /*  334836 */   // Label 6165: @334836
     /*  334836 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(334899), // Rule ID 20396 //
     /*  334841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  334855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  334858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334880 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334897 */     GIR_RootConstrainSelectedInstOperands,
     /*  334898 */     // GIR_Coverage, 20396,
     /*  334898 */     GIR_EraseRootFromParent_Done,
     /*  334899 */   // Label 6166: @334899
     /*  334899 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(334962), // Rule ID 20397 //
     /*  334904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  334918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  334921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334943 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334960 */     GIR_RootConstrainSelectedInstOperands,
     /*  334961 */     // GIR_Coverage, 20397,
     /*  334961 */     GIR_EraseRootFromParent_Done,
     /*  334962 */   // Label 6167: @334962
     /*  334962 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(335025), // Rule ID 20400 //
     /*  334967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  334981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  334984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335006 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  335009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335023 */     GIR_RootConstrainSelectedInstOperands,
     /*  335024 */     // GIR_Coverage, 20400,
     /*  335024 */     GIR_EraseRootFromParent_Done,
     /*  335025 */   // Label 6168: @335025
     /*  335025 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(335088), // Rule ID 20401 //
     /*  335030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  335044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  335047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335069 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  335072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335086 */     GIR_RootConstrainSelectedInstOperands,
     /*  335087 */     // GIR_Coverage, 20401,
     /*  335087 */     GIR_EraseRootFromParent_Done,
     /*  335088 */   // Label 6169: @335088
     /*  335088 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(335151), // Rule ID 20404 //
     /*  335093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  335107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  335110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335132 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  335135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335149 */     GIR_RootConstrainSelectedInstOperands,
     /*  335150 */     // GIR_Coverage, 20404,
     /*  335150 */     GIR_EraseRootFromParent_Done,
     /*  335151 */   // Label 6170: @335151
     /*  335151 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(335214), // Rule ID 20405 //
     /*  335156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  335170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  335173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335195 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  335198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335212 */     GIR_RootConstrainSelectedInstOperands,
     /*  335213 */     // GIR_Coverage, 20405,
     /*  335213 */     GIR_EraseRootFromParent_Done,
     /*  335214 */   // Label 6171: @335214
     /*  335214 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(335277), // Rule ID 20408 //
     /*  335219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  335233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  335236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335275 */     GIR_RootConstrainSelectedInstOperands,
     /*  335276 */     // GIR_Coverage, 20408,
     /*  335276 */     GIR_EraseRootFromParent_Done,
     /*  335277 */   // Label 6172: @335277
     /*  335277 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(335340), // Rule ID 20409 //
     /*  335282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  335296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  335299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335321 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335338 */     GIR_RootConstrainSelectedInstOperands,
     /*  335339 */     // GIR_Coverage, 20409,
     /*  335339 */     GIR_EraseRootFromParent_Done,
     /*  335340 */   // Label 6173: @335340
     /*  335340 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(335403), // Rule ID 20412 //
     /*  335345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  335359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  335362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335384 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335401 */     GIR_RootConstrainSelectedInstOperands,
     /*  335402 */     // GIR_Coverage, 20412,
     /*  335402 */     GIR_EraseRootFromParent_Done,
     /*  335403 */   // Label 6174: @335403
     /*  335403 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(335466), // Rule ID 20413 //
     /*  335408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  335422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  335425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335447 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335464 */     GIR_RootConstrainSelectedInstOperands,
     /*  335465 */     // GIR_Coverage, 20413,
     /*  335465 */     GIR_EraseRootFromParent_Done,
     /*  335466 */   // Label 6175: @335466
     /*  335466 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(335529), // Rule ID 20416 //
     /*  335471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  335482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  335485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  335488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335510 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335527 */     GIR_RootConstrainSelectedInstOperands,
     /*  335528 */     // GIR_Coverage, 20416,
     /*  335528 */     GIR_EraseRootFromParent_Done,
     /*  335529 */   // Label 6176: @335529
     /*  335529 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(335592), // Rule ID 20417 //
     /*  335534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  335545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  335548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  335551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335573 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335590 */     GIR_RootConstrainSelectedInstOperands,
     /*  335591 */     // GIR_Coverage, 20417,
     /*  335591 */     GIR_EraseRootFromParent_Done,
     /*  335592 */   // Label 6177: @335592
     /*  335592 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(335655), // Rule ID 20420 //
     /*  335597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  335611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  335614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335636 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335653 */     GIR_RootConstrainSelectedInstOperands,
     /*  335654 */     // GIR_Coverage, 20420,
     /*  335654 */     GIR_EraseRootFromParent_Done,
     /*  335655 */   // Label 6178: @335655
     /*  335655 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(335718), // Rule ID 20421 //
     /*  335660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  335674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  335677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335699 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335716 */     GIR_RootConstrainSelectedInstOperands,
     /*  335717 */     // GIR_Coverage, 20421,
     /*  335717 */     GIR_EraseRootFromParent_Done,
     /*  335718 */   // Label 6179: @335718
     /*  335718 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(335781), // Rule ID 20424 //
     /*  335723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  335740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335762 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335779 */     GIR_RootConstrainSelectedInstOperands,
     /*  335780 */     // GIR_Coverage, 20424,
     /*  335780 */     GIR_EraseRootFromParent_Done,
     /*  335781 */   // Label 6180: @335781
     /*  335781 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(335844), // Rule ID 20425 //
     /*  335786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  335803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335825 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335842 */     GIR_RootConstrainSelectedInstOperands,
     /*  335843 */     // GIR_Coverage, 20425,
     /*  335843 */     GIR_EraseRootFromParent_Done,
     /*  335844 */   // Label 6181: @335844
     /*  335844 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(335907), // Rule ID 20428 //
     /*  335849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  335866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335888 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335905 */     GIR_RootConstrainSelectedInstOperands,
     /*  335906 */     // GIR_Coverage, 20428,
     /*  335906 */     GIR_EraseRootFromParent_Done,
     /*  335907 */   // Label 6182: @335907
     /*  335907 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(335970), // Rule ID 20429 //
     /*  335912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  335929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335951 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335968 */     GIR_RootConstrainSelectedInstOperands,
     /*  335969 */     // GIR_Coverage, 20429,
     /*  335969 */     GIR_EraseRootFromParent_Done,
     /*  335970 */   // Label 6183: @335970
     /*  335970 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(336033), // Rule ID 20432 //
     /*  335975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  335992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336014 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  336014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  336017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336031 */     GIR_RootConstrainSelectedInstOperands,
     /*  336032 */     // GIR_Coverage, 20432,
     /*  336032 */     GIR_EraseRootFromParent_Done,
     /*  336033 */   // Label 6184: @336033
     /*  336033 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(336096), // Rule ID 20433 //
     /*  336038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  336041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  336046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  336052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  336055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336077 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  336077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  336080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336094 */     GIR_RootConstrainSelectedInstOperands,
     /*  336095 */     // GIR_Coverage, 20433,
     /*  336095 */     GIR_EraseRootFromParent_Done,
     /*  336096 */   // Label 6185: @336096
     /*  336096 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(336159), // Rule ID 20436 //
     /*  336101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  336104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  336109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  336115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  336118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  336140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  336143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336157 */     GIR_RootConstrainSelectedInstOperands,
     /*  336158 */     // GIR_Coverage, 20436,
     /*  336158 */     GIR_EraseRootFromParent_Done,
     /*  336159 */   // Label 6186: @336159
     /*  336159 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(336222), // Rule ID 20437 //
     /*  336164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  336167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  336172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  336178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  336181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336203 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  336203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  336206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336220 */     GIR_RootConstrainSelectedInstOperands,
     /*  336221 */     // GIR_Coverage, 20437,
     /*  336221 */     GIR_EraseRootFromParent_Done,
     /*  336222 */   // Label 6187: @336222
     /*  336222 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(336285), // Rule ID 20440 //
     /*  336227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  336230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  336235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  336241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  336244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336266 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  336266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  336269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336283 */     GIR_RootConstrainSelectedInstOperands,
     /*  336284 */     // GIR_Coverage, 20440,
     /*  336284 */     GIR_EraseRootFromParent_Done,
     /*  336285 */   // Label 6188: @336285
     /*  336285 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(336348), // Rule ID 20441 //
     /*  336290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  336293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  336298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  336304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  336307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336329 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  336329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  336332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336346 */     GIR_RootConstrainSelectedInstOperands,
     /*  336347 */     // GIR_Coverage, 20441,
     /*  336347 */     GIR_EraseRootFromParent_Done,
     /*  336348 */   // Label 6189: @336348
     /*  336348 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(336411), // Rule ID 20444 //
     /*  336353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  336367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  336370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  336395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336409 */     GIR_RootConstrainSelectedInstOperands,
     /*  336410 */     // GIR_Coverage, 20444,
     /*  336410 */     GIR_EraseRootFromParent_Done,
     /*  336411 */   // Label 6190: @336411
     /*  336411 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(336474), // Rule ID 20445 //
     /*  336416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  336430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  336433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336455 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  336458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336472 */     GIR_RootConstrainSelectedInstOperands,
     /*  336473 */     // GIR_Coverage, 20445,
     /*  336473 */     GIR_EraseRootFromParent_Done,
     /*  336474 */   // Label 6191: @336474
     /*  336474 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(336537), // Rule ID 20448 //
     /*  336479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  336496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336518 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336535 */     GIR_RootConstrainSelectedInstOperands,
     /*  336536 */     // GIR_Coverage, 20448,
     /*  336536 */     GIR_EraseRootFromParent_Done,
     /*  336537 */   // Label 6192: @336537
     /*  336537 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(336600), // Rule ID 20449 //
     /*  336542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  336559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336581 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336598 */     GIR_RootConstrainSelectedInstOperands,
     /*  336599 */     // GIR_Coverage, 20449,
     /*  336599 */     GIR_EraseRootFromParent_Done,
     /*  336600 */   // Label 6193: @336600
     /*  336600 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(336663), // Rule ID 20452 //
     /*  336605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  336622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336644 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336661 */     GIR_RootConstrainSelectedInstOperands,
     /*  336662 */     // GIR_Coverage, 20452,
     /*  336662 */     GIR_EraseRootFromParent_Done,
     /*  336663 */   // Label 6194: @336663
     /*  336663 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(336726), // Rule ID 20453 //
     /*  336668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  336685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336707 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336724 */     GIR_RootConstrainSelectedInstOperands,
     /*  336725 */     // GIR_Coverage, 20453,
     /*  336725 */     GIR_EraseRootFromParent_Done,
     /*  336726 */   // Label 6195: @336726
     /*  336726 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(336789), // Rule ID 20456 //
     /*  336731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  336748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336770 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336787 */     GIR_RootConstrainSelectedInstOperands,
     /*  336788 */     // GIR_Coverage, 20456,
     /*  336788 */     GIR_EraseRootFromParent_Done,
     /*  336789 */   // Label 6196: @336789
     /*  336789 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(336852), // Rule ID 20457 //
     /*  336794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  336811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336833 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336850 */     GIR_RootConstrainSelectedInstOperands,
     /*  336851 */     // GIR_Coverage, 20457,
     /*  336851 */     GIR_EraseRootFromParent_Done,
     /*  336852 */   // Label 6197: @336852
     /*  336852 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(336915), // Rule ID 20460 //
     /*  336857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  336871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  336874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336896 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336913 */     GIR_RootConstrainSelectedInstOperands,
     /*  336914 */     // GIR_Coverage, 20460,
     /*  336914 */     GIR_EraseRootFromParent_Done,
     /*  336915 */   // Label 6198: @336915
     /*  336915 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(336978), // Rule ID 20461 //
     /*  336920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  336934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  336937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336959 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336976 */     GIR_RootConstrainSelectedInstOperands,
     /*  336977 */     // GIR_Coverage, 20461,
     /*  336977 */     GIR_EraseRootFromParent_Done,
     /*  336978 */   // Label 6199: @336978
     /*  336978 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(337041), // Rule ID 20464 //
     /*  336983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  336986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  336997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  337000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337022 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  337025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337039 */     GIR_RootConstrainSelectedInstOperands,
     /*  337040 */     // GIR_Coverage, 20464,
     /*  337040 */     GIR_EraseRootFromParent_Done,
     /*  337041 */   // Label 6200: @337041
     /*  337041 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(337104), // Rule ID 20465 //
     /*  337046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  337057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  337060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  337063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337085 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  337088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337102 */     GIR_RootConstrainSelectedInstOperands,
     /*  337103 */     // GIR_Coverage, 20465,
     /*  337103 */     GIR_EraseRootFromParent_Done,
     /*  337104 */   // Label 6201: @337104
     /*  337104 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(337167), // Rule ID 20468 //
     /*  337109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  337112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  337123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  337126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337148 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  337148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337165 */     GIR_RootConstrainSelectedInstOperands,
     /*  337166 */     // GIR_Coverage, 20468,
     /*  337166 */     GIR_EraseRootFromParent_Done,
     /*  337167 */   // Label 6202: @337167
     /*  337167 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(337230), // Rule ID 20469 //
     /*  337172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  337175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  337186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  337189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337211 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  337211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337228 */     GIR_RootConstrainSelectedInstOperands,
     /*  337229 */     // GIR_Coverage, 20469,
     /*  337229 */     GIR_EraseRootFromParent_Done,
     /*  337230 */   // Label 6203: @337230
     /*  337230 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(337293), // Rule ID 20472 //
     /*  337235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  337238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  337249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  337252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337274 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  337274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337291 */     GIR_RootConstrainSelectedInstOperands,
     /*  337292 */     // GIR_Coverage, 20472,
     /*  337292 */     GIR_EraseRootFromParent_Done,
     /*  337293 */   // Label 6204: @337293
     /*  337293 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(337356), // Rule ID 20473 //
     /*  337298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  337301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  337312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  337315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337337 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  337337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337354 */     GIR_RootConstrainSelectedInstOperands,
     /*  337355 */     // GIR_Coverage, 20473,
     /*  337355 */     GIR_EraseRootFromParent_Done,
     /*  337356 */   // Label 6205: @337356
     /*  337356 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(337419), // Rule ID 20476 //
     /*  337361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  337364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  337372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  337375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  337378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337400 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  337400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337417 */     GIR_RootConstrainSelectedInstOperands,
     /*  337418 */     // GIR_Coverage, 20476,
     /*  337418 */     GIR_EraseRootFromParent_Done,
     /*  337419 */   // Label 6206: @337419
     /*  337419 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(337482), // Rule ID 20477 //
     /*  337424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  337427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  337435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  337438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  337441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337463 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  337463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337480 */     GIR_RootConstrainSelectedInstOperands,
     /*  337481 */     // GIR_Coverage, 20477,
     /*  337481 */     GIR_EraseRootFromParent_Done,
     /*  337482 */   // Label 6207: @337482
     /*  337482 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(337545), // Rule ID 20480 //
     /*  337487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  337501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  337504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337526 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337543 */     GIR_RootConstrainSelectedInstOperands,
     /*  337544 */     // GIR_Coverage, 20480,
     /*  337544 */     GIR_EraseRootFromParent_Done,
     /*  337545 */   // Label 6208: @337545
     /*  337545 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(337608), // Rule ID 20481 //
     /*  337550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  337564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  337567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337589 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337606 */     GIR_RootConstrainSelectedInstOperands,
     /*  337607 */     // GIR_Coverage, 20481,
     /*  337607 */     GIR_EraseRootFromParent_Done,
     /*  337608 */   // Label 6209: @337608
     /*  337608 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(337671), // Rule ID 20484 //
     /*  337613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  337627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  337630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337652 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337669 */     GIR_RootConstrainSelectedInstOperands,
     /*  337670 */     // GIR_Coverage, 20484,
     /*  337670 */     GIR_EraseRootFromParent_Done,
     /*  337671 */   // Label 6210: @337671
     /*  337671 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(337734), // Rule ID 20485 //
     /*  337676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  337690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  337693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337715 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337732 */     GIR_RootConstrainSelectedInstOperands,
     /*  337733 */     // GIR_Coverage, 20485,
     /*  337733 */     GIR_EraseRootFromParent_Done,
     /*  337734 */   // Label 6211: @337734
     /*  337734 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(337797), // Rule ID 20488 //
     /*  337739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  337753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  337756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337778 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337795 */     GIR_RootConstrainSelectedInstOperands,
     /*  337796 */     // GIR_Coverage, 20488,
     /*  337796 */     GIR_EraseRootFromParent_Done,
     /*  337797 */   // Label 6212: @337797
     /*  337797 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(337860), // Rule ID 20489 //
     /*  337802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  337816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  337819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337841 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337858 */     GIR_RootConstrainSelectedInstOperands,
     /*  337859 */     // GIR_Coverage, 20489,
     /*  337859 */     GIR_EraseRootFromParent_Done,
     /*  337860 */   // Label 6213: @337860
     /*  337860 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(337923), // Rule ID 20492 //
     /*  337865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  337879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  337882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337904 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337921 */     GIR_RootConstrainSelectedInstOperands,
     /*  337922 */     // GIR_Coverage, 20492,
     /*  337922 */     GIR_EraseRootFromParent_Done,
     /*  337923 */   // Label 6214: @337923
     /*  337923 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(337986), // Rule ID 20493 //
     /*  337928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  337942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  337945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337967 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337984 */     GIR_RootConstrainSelectedInstOperands,
     /*  337985 */     // GIR_Coverage, 20493,
     /*  337985 */     GIR_EraseRootFromParent_Done,
     /*  337986 */   // Label 6215: @337986
     /*  337986 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(338049), // Rule ID 20496 //
     /*  337991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  338002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  338005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  338008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338030 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  338030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  338033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338047 */     GIR_RootConstrainSelectedInstOperands,
     /*  338048 */     // GIR_Coverage, 20496,
     /*  338048 */     GIR_EraseRootFromParent_Done,
     /*  338049 */   // Label 6216: @338049
     /*  338049 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(338112), // Rule ID 20497 //
     /*  338054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  338057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  338062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  338065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  338068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  338071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338093 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  338093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  338096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338110 */     GIR_RootConstrainSelectedInstOperands,
     /*  338111 */     // GIR_Coverage, 20497,
     /*  338111 */     GIR_EraseRootFromParent_Done,
     /*  338112 */   // Label 6217: @338112
     /*  338112 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(338175), // Rule ID 20500 //
     /*  338117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  338120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  338125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  338128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  338131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  338134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  338156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  338159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338173 */     GIR_RootConstrainSelectedInstOperands,
     /*  338174 */     // GIR_Coverage, 20500,
     /*  338174 */     GIR_EraseRootFromParent_Done,
     /*  338175 */   // Label 6218: @338175
     /*  338175 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(338238), // Rule ID 20501 //
     /*  338180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  338183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  338188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  338191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  338194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  338197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338219 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  338219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  338222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338236 */     GIR_RootConstrainSelectedInstOperands,
     /*  338237 */     // GIR_Coverage, 20501,
     /*  338237 */     GIR_EraseRootFromParent_Done,
     /*  338238 */   // Label 6219: @338238
     /*  338238 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(338304), // Rule ID 20504 //
     /*  338243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  338254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  338257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  338260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338282 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  338285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338302 */     GIR_RootConstrainSelectedInstOperands,
     /*  338303 */     // GIR_Coverage, 20504,
     /*  338303 */     GIR_EraseRootFromParent_Done,
     /*  338304 */   // Label 6220: @338304
     /*  338304 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(338370), // Rule ID 20505 //
     /*  338309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  338320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  338323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  338326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338348 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  338351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338368 */     GIR_RootConstrainSelectedInstOperands,
     /*  338369 */     // GIR_Coverage, 20505,
     /*  338369 */     GIR_EraseRootFromParent_Done,
     /*  338370 */   // Label 6221: @338370
     /*  338370 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(338436), // Rule ID 20508 //
     /*  338375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  338386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  338389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  338392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338414 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  338417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338434 */     GIR_RootConstrainSelectedInstOperands,
     /*  338435 */     // GIR_Coverage, 20508,
     /*  338435 */     GIR_EraseRootFromParent_Done,
     /*  338436 */   // Label 6222: @338436
     /*  338436 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(338502), // Rule ID 20509 //
     /*  338441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  338444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  338452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  338455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  338458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338480 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  338483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338500 */     GIR_RootConstrainSelectedInstOperands,
     /*  338501 */     // GIR_Coverage, 20509,
     /*  338501 */     GIR_EraseRootFromParent_Done,
     /*  338502 */   // Label 6223: @338502
     /*  338502 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(338568), // Rule ID 20512 //
     /*  338507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  338518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  338521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  338524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338566 */     GIR_RootConstrainSelectedInstOperands,
     /*  338567 */     // GIR_Coverage, 20512,
     /*  338567 */     GIR_EraseRootFromParent_Done,
     /*  338568 */   // Label 6224: @338568
     /*  338568 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(338634), // Rule ID 20513 //
     /*  338573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  338584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  338587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  338590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338612 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338632 */     GIR_RootConstrainSelectedInstOperands,
     /*  338633 */     // GIR_Coverage, 20513,
     /*  338633 */     GIR_EraseRootFromParent_Done,
     /*  338634 */   // Label 6225: @338634
     /*  338634 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(338700), // Rule ID 20516 //
     /*  338639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  338650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  338653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  338656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338698 */     GIR_RootConstrainSelectedInstOperands,
     /*  338699 */     // GIR_Coverage, 20516,
     /*  338699 */     GIR_EraseRootFromParent_Done,
     /*  338700 */   // Label 6226: @338700
     /*  338700 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(338766), // Rule ID 20517 //
     /*  338705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  338708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  338716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  338719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  338722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338764 */     GIR_RootConstrainSelectedInstOperands,
     /*  338765 */     // GIR_Coverage, 20517,
     /*  338765 */     GIR_EraseRootFromParent_Done,
     /*  338766 */   // Label 6227: @338766
     /*  338766 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(338832), // Rule ID 20520 //
     /*  338771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  338774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  338782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  338785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  338788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338810 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  338810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338830 */     GIR_RootConstrainSelectedInstOperands,
     /*  338831 */     // GIR_Coverage, 20520,
     /*  338831 */     GIR_EraseRootFromParent_Done,
     /*  338832 */   // Label 6228: @338832
     /*  338832 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(338898), // Rule ID 20521 //
     /*  338837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  338840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  338848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  338851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  338854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  338876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338896 */     GIR_RootConstrainSelectedInstOperands,
     /*  338897 */     // GIR_Coverage, 20521,
     /*  338897 */     GIR_EraseRootFromParent_Done,
     /*  338898 */   // Label 6229: @338898
     /*  338898 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(338964), // Rule ID 20524 //
     /*  338903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  338914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338942 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338962 */     GIR_RootConstrainSelectedInstOperands,
     /*  338963 */     // GIR_Coverage, 20524,
     /*  338963 */     GIR_EraseRootFromParent_Done,
     /*  338964 */   // Label 6230: @338964
     /*  338964 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(339030), // Rule ID 20525 //
     /*  338969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  338980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339008 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339028 */     GIR_RootConstrainSelectedInstOperands,
     /*  339029 */     // GIR_Coverage, 20525,
     /*  339029 */     GIR_EraseRootFromParent_Done,
     /*  339030 */   // Label 6231: @339030
     /*  339030 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(339096), // Rule ID 20528 //
     /*  339035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  339038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  339046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  339049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  339052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339074 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  339074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339094 */     GIR_RootConstrainSelectedInstOperands,
     /*  339095 */     // GIR_Coverage, 20528,
     /*  339095 */     GIR_EraseRootFromParent_Done,
     /*  339096 */   // Label 6232: @339096
     /*  339096 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(339162), // Rule ID 20529 //
     /*  339101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  339104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  339112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  339115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  339118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339140 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339160 */     GIR_RootConstrainSelectedInstOperands,
     /*  339161 */     // GIR_Coverage, 20529,
     /*  339161 */     GIR_EraseRootFromParent_Done,
     /*  339162 */   // Label 6233: @339162
     /*  339162 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(339228), // Rule ID 20532 //
     /*  339167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  339170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  339178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  339181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  339184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  339206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339226 */     GIR_RootConstrainSelectedInstOperands,
     /*  339227 */     // GIR_Coverage, 20532,
     /*  339227 */     GIR_EraseRootFromParent_Done,
     /*  339228 */   // Label 6234: @339228
     /*  339228 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(339294), // Rule ID 20533 //
     /*  339233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  339236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  339244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  339247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  339250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339272 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339292 */     GIR_RootConstrainSelectedInstOperands,
     /*  339293 */     // GIR_Coverage, 20533,
     /*  339293 */     GIR_EraseRootFromParent_Done,
     /*  339294 */   // Label 6235: @339294
     /*  339294 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(339360), // Rule ID 20536 //
     /*  339299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  339302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  339310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  339313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  339316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339358 */     GIR_RootConstrainSelectedInstOperands,
     /*  339359 */     // GIR_Coverage, 20536,
     /*  339359 */     GIR_EraseRootFromParent_Done,
     /*  339360 */   // Label 6236: @339360
     /*  339360 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(339426), // Rule ID 20537 //
     /*  339365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  339376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  339379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  339382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339424 */     GIR_RootConstrainSelectedInstOperands,
     /*  339425 */     // GIR_Coverage, 20537,
     /*  339425 */     GIR_EraseRootFromParent_Done,
     /*  339426 */   // Label 6237: @339426
     /*  339426 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(339492), // Rule ID 20540 //
     /*  339431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  339434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  339442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  339445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  339448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339490 */     GIR_RootConstrainSelectedInstOperands,
     /*  339491 */     // GIR_Coverage, 20540,
     /*  339491 */     GIR_EraseRootFromParent_Done,
     /*  339492 */   // Label 6238: @339492
     /*  339492 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(339558), // Rule ID 20541 //
     /*  339497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  339508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  339511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  339514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339536 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339556 */     GIR_RootConstrainSelectedInstOperands,
     /*  339557 */     // GIR_Coverage, 20541,
     /*  339557 */     GIR_EraseRootFromParent_Done,
     /*  339558 */   // Label 6239: @339558
     /*  339558 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(339624), // Rule ID 20544 //
     /*  339563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  339566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  339574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  339577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  339580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339602 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339622 */     GIR_RootConstrainSelectedInstOperands,
     /*  339623 */     // GIR_Coverage, 20544,
     /*  339623 */     GIR_EraseRootFromParent_Done,
     /*  339624 */   // Label 6240: @339624
     /*  339624 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(339690), // Rule ID 20545 //
     /*  339629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  339640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  339643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  339646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339668 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339688 */     GIR_RootConstrainSelectedInstOperands,
     /*  339689 */     // GIR_Coverage, 20545,
     /*  339689 */     GIR_EraseRootFromParent_Done,
     /*  339690 */   // Label 6241: @339690
     /*  339690 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(339756), // Rule ID 20548 //
     /*  339695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  339706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339734 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339754 */     GIR_RootConstrainSelectedInstOperands,
     /*  339755 */     // GIR_Coverage, 20548,
     /*  339755 */     GIR_EraseRootFromParent_Done,
     /*  339756 */   // Label 6242: @339756
     /*  339756 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(339822), // Rule ID 20549 //
     /*  339761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  339764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  339772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339800 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339820 */     GIR_RootConstrainSelectedInstOperands,
     /*  339821 */     // GIR_Coverage, 20549,
     /*  339821 */     GIR_EraseRootFromParent_Done,
     /*  339822 */   // Label 6243: @339822
     /*  339822 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(339888), // Rule ID 20552 //
     /*  339827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  339838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339866 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339886 */     GIR_RootConstrainSelectedInstOperands,
     /*  339887 */     // GIR_Coverage, 20552,
     /*  339887 */     GIR_EraseRootFromParent_Done,
     /*  339888 */   // Label 6244: @339888
     /*  339888 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(339954), // Rule ID 20553 //
     /*  339893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  339896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  339904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339932 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339952 */     GIR_RootConstrainSelectedInstOperands,
     /*  339953 */     // GIR_Coverage, 20553,
     /*  339953 */     GIR_EraseRootFromParent_Done,
     /*  339954 */   // Label 6245: @339954
     /*  339954 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(340020), // Rule ID 20556 //
     /*  339959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  339970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339998 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  340001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340018 */     GIR_RootConstrainSelectedInstOperands,
     /*  340019 */     // GIR_Coverage, 20556,
     /*  340019 */     GIR_EraseRootFromParent_Done,
     /*  340020 */   // Label 6246: @340020
     /*  340020 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(340086), // Rule ID 20557 //
     /*  340025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  340028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  340033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  340036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  340039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  340042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340064 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  340064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  340067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340084 */     GIR_RootConstrainSelectedInstOperands,
     /*  340085 */     // GIR_Coverage, 20557,
     /*  340085 */     GIR_EraseRootFromParent_Done,
     /*  340086 */   // Label 6247: @340086
     /*  340086 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(340152), // Rule ID 20882 //
     /*  340091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  340102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  340105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  340108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340130 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  340133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340150 */     GIR_RootConstrainSelectedInstOperands,
     /*  340151 */     // GIR_Coverage, 20882,
     /*  340151 */     GIR_EraseRootFromParent_Done,
     /*  340152 */   // Label 6248: @340152
     /*  340152 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(340218), // Rule ID 20883 //
     /*  340157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  340168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  340171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  340174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340196 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  340199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340216 */     GIR_RootConstrainSelectedInstOperands,
     /*  340217 */     // GIR_Coverage, 20883,
     /*  340217 */     GIR_EraseRootFromParent_Done,
     /*  340218 */   // Label 6249: @340218
     /*  340218 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(340284), // Rule ID 20886 //
     /*  340223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  340234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  340237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  340240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340262 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  340265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340282 */     GIR_RootConstrainSelectedInstOperands,
     /*  340283 */     // GIR_Coverage, 20886,
     /*  340283 */     GIR_EraseRootFromParent_Done,
     /*  340284 */   // Label 6250: @340284
     /*  340284 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(340350), // Rule ID 20887 //
     /*  340289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  340300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  340303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  340306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340328 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  340331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340348 */     GIR_RootConstrainSelectedInstOperands,
     /*  340349 */     // GIR_Coverage, 20887,
     /*  340349 */     GIR_EraseRootFromParent_Done,
     /*  340350 */   // Label 6251: @340350
     /*  340350 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(340416), // Rule ID 20890 //
     /*  340355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  340366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  340369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  340372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  340397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340414 */     GIR_RootConstrainSelectedInstOperands,
     /*  340415 */     // GIR_Coverage, 20890,
     /*  340415 */     GIR_EraseRootFromParent_Done,
     /*  340416 */   // Label 6252: @340416
     /*  340416 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(340482), // Rule ID 20891 //
     /*  340421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  340424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  340432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  340435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  340438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340460 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  340460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  340463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340480 */     GIR_RootConstrainSelectedInstOperands,
     /*  340481 */     // GIR_Coverage, 20891,
     /*  340481 */     GIR_EraseRootFromParent_Done,
     /*  340482 */   // Label 6253: @340482
     /*  340482 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(340548), // Rule ID 20894 //
     /*  340487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  340498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340526 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340546 */     GIR_RootConstrainSelectedInstOperands,
     /*  340547 */     // GIR_Coverage, 20894,
     /*  340547 */     GIR_EraseRootFromParent_Done,
     /*  340548 */   // Label 6254: @340548
     /*  340548 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(340614), // Rule ID 20895 //
     /*  340553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  340564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340592 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340612 */     GIR_RootConstrainSelectedInstOperands,
     /*  340613 */     // GIR_Coverage, 20895,
     /*  340613 */     GIR_EraseRootFromParent_Done,
     /*  340614 */   // Label 6255: @340614
     /*  340614 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(340680), // Rule ID 20898 //
     /*  340619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  340630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340678 */     GIR_RootConstrainSelectedInstOperands,
     /*  340679 */     // GIR_Coverage, 20898,
     /*  340679 */     GIR_EraseRootFromParent_Done,
     /*  340680 */   // Label 6256: @340680
     /*  340680 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(340746), // Rule ID 20899 //
     /*  340685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  340688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  340696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  340724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340744 */     GIR_RootConstrainSelectedInstOperands,
     /*  340745 */     // GIR_Coverage, 20899,
     /*  340745 */     GIR_EraseRootFromParent_Done,
     /*  340746 */   // Label 6257: @340746
     /*  340746 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(340812), // Rule ID 20902 //
     /*  340751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  340754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  340762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  340765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  340768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  340790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340810 */     GIR_RootConstrainSelectedInstOperands,
     /*  340811 */     // GIR_Coverage, 20902,
     /*  340811 */     GIR_EraseRootFromParent_Done,
     /*  340812 */   // Label 6258: @340812
     /*  340812 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(340878), // Rule ID 20903 //
     /*  340817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  340820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  340828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  340831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  340834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340856 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  340856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340876 */     GIR_RootConstrainSelectedInstOperands,
     /*  340877 */     // GIR_Coverage, 20903,
     /*  340877 */     GIR_EraseRootFromParent_Done,
     /*  340878 */   // Label 6259: @340878
     /*  340878 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(340944), // Rule ID 20906 //
     /*  340883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  340894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  340897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  340900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340942 */     GIR_RootConstrainSelectedInstOperands,
     /*  340943 */     // GIR_Coverage, 20906,
     /*  340943 */     GIR_EraseRootFromParent_Done,
     /*  340944 */   // Label 6260: @340944
     /*  340944 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(341010), // Rule ID 20907 //
     /*  340949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  340960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  340963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  340966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340988 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341008 */     GIR_RootConstrainSelectedInstOperands,
     /*  341009 */     // GIR_Coverage, 20907,
     /*  341009 */     GIR_EraseRootFromParent_Done,
     /*  341010 */   // Label 6261: @341010
     /*  341010 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(341076), // Rule ID 20910 //
     /*  341015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  341026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  341029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  341032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341054 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341074 */     GIR_RootConstrainSelectedInstOperands,
     /*  341075 */     // GIR_Coverage, 20910,
     /*  341075 */     GIR_EraseRootFromParent_Done,
     /*  341076 */   // Label 6262: @341076
     /*  341076 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(341142), // Rule ID 20911 //
     /*  341081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  341092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  341095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  341098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341120 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341140 */     GIR_RootConstrainSelectedInstOperands,
     /*  341141 */     // GIR_Coverage, 20911,
     /*  341141 */     GIR_EraseRootFromParent_Done,
     /*  341142 */   // Label 6263: @341142
     /*  341142 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(341208), // Rule ID 20914 //
     /*  341147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  341158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  341161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  341164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341186 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341206 */     GIR_RootConstrainSelectedInstOperands,
     /*  341207 */     // GIR_Coverage, 20914,
     /*  341207 */     GIR_EraseRootFromParent_Done,
     /*  341208 */   // Label 6264: @341208
     /*  341208 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(341274), // Rule ID 20915 //
     /*  341213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  341224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  341227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  341230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341252 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341272 */     GIR_RootConstrainSelectedInstOperands,
     /*  341273 */     // GIR_Coverage, 20915,
     /*  341273 */     GIR_EraseRootFromParent_Done,
     /*  341274 */   // Label 6265: @341274
     /*  341274 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(341340), // Rule ID 20918 //
     /*  341279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  341290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  341293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  341296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  341321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341338 */     GIR_RootConstrainSelectedInstOperands,
     /*  341339 */     // GIR_Coverage, 20918,
     /*  341339 */     GIR_EraseRootFromParent_Done,
     /*  341340 */   // Label 6266: @341340
     /*  341340 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(341406), // Rule ID 20919 //
     /*  341345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  341356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  341359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  341362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  341387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341404 */     GIR_RootConstrainSelectedInstOperands,
     /*  341405 */     // GIR_Coverage, 20919,
     /*  341405 */     GIR_EraseRootFromParent_Done,
     /*  341406 */   // Label 6267: @341406
     /*  341406 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(341472), // Rule ID 20922 //
     /*  341411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  341422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  341425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  341428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341450 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341470 */     GIR_RootConstrainSelectedInstOperands,
     /*  341471 */     // GIR_Coverage, 20922,
     /*  341471 */     GIR_EraseRootFromParent_Done,
     /*  341472 */   // Label 6268: @341472
     /*  341472 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(341538), // Rule ID 20923 //
     /*  341477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  341488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  341491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  341494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341536 */     GIR_RootConstrainSelectedInstOperands,
     /*  341537 */     // GIR_Coverage, 20923,
     /*  341537 */     GIR_EraseRootFromParent_Done,
     /*  341538 */   // Label 6269: @341538
     /*  341538 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(341604), // Rule ID 20926 //
     /*  341543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  341554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  341557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  341560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341582 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341602 */     GIR_RootConstrainSelectedInstOperands,
     /*  341603 */     // GIR_Coverage, 20926,
     /*  341603 */     GIR_EraseRootFromParent_Done,
     /*  341604 */   // Label 6270: @341604
     /*  341604 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(341670), // Rule ID 20927 //
     /*  341609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  341620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  341623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  341626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341648 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341668 */     GIR_RootConstrainSelectedInstOperands,
     /*  341669 */     // GIR_Coverage, 20927,
     /*  341669 */     GIR_EraseRootFromParent_Done,
     /*  341670 */   // Label 6271: @341670
     /*  341670 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(341736), // Rule ID 20930 //
     /*  341675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  341686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  341689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  341692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341714 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  341717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341734 */     GIR_RootConstrainSelectedInstOperands,
     /*  341735 */     // GIR_Coverage, 20930,
     /*  341735 */     GIR_EraseRootFromParent_Done,
     /*  341736 */   // Label 6272: @341736
     /*  341736 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(341802), // Rule ID 20931 //
     /*  341741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  341744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  341752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  341755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  341758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  341783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341800 */     GIR_RootConstrainSelectedInstOperands,
     /*  341801 */     // GIR_Coverage, 20931,
     /*  341801 */     GIR_EraseRootFromParent_Done,
     /*  341802 */   // Label 6273: @341802
     /*  341802 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(341868), // Rule ID 20934 //
     /*  341807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  341818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  341821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  341824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341866 */     GIR_RootConstrainSelectedInstOperands,
     /*  341867 */     // GIR_Coverage, 20934,
     /*  341867 */     GIR_EraseRootFromParent_Done,
     /*  341868 */   // Label 6274: @341868
     /*  341868 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(341934), // Rule ID 20935 //
     /*  341873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  341876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  341884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  341887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  341890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341912 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341932 */     GIR_RootConstrainSelectedInstOperands,
     /*  341933 */     // GIR_Coverage, 20935,
     /*  341933 */     GIR_EraseRootFromParent_Done,
     /*  341934 */   // Label 6275: @341934
     /*  341934 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(342000), // Rule ID 20938 //
     /*  341939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  341950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  341953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  341956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341978 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341998 */     GIR_RootConstrainSelectedInstOperands,
     /*  341999 */     // GIR_Coverage, 20938,
     /*  341999 */     GIR_EraseRootFromParent_Done,
     /*  342000 */   // Label 6276: @342000
     /*  342000 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(342066), // Rule ID 20939 //
     /*  342005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  342008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  342013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  342016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  342019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  342022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342044 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  342044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  342047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342064 */     GIR_RootConstrainSelectedInstOperands,
     /*  342065 */     // GIR_Coverage, 20939,
     /*  342065 */     GIR_EraseRootFromParent_Done,
     /*  342066 */   // Label 6277: @342066
     /*  342066 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(342132), // Rule ID 20942 //
     /*  342071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  342082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  342085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  342088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342110 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  342113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342130 */     GIR_RootConstrainSelectedInstOperands,
     /*  342131 */     // GIR_Coverage, 20942,
     /*  342131 */     GIR_EraseRootFromParent_Done,
     /*  342132 */   // Label 6278: @342132
     /*  342132 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(342198), // Rule ID 20943 //
     /*  342137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  342148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  342151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  342154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342176 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  342179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342196 */     GIR_RootConstrainSelectedInstOperands,
     /*  342197 */     // GIR_Coverage, 20943,
     /*  342197 */     GIR_EraseRootFromParent_Done,
     /*  342198 */   // Label 6279: @342198
     /*  342198 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(342264), // Rule ID 20946 //
     /*  342203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  342214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  342217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  342220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342242 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  342245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342262 */     GIR_RootConstrainSelectedInstOperands,
     /*  342263 */     // GIR_Coverage, 20946,
     /*  342263 */     GIR_EraseRootFromParent_Done,
     /*  342264 */   // Label 6280: @342264
     /*  342264 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(342330), // Rule ID 20947 //
     /*  342269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  342280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  342283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  342286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342308 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  342311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342328 */     GIR_RootConstrainSelectedInstOperands,
     /*  342329 */     // GIR_Coverage, 20947,
     /*  342329 */     GIR_EraseRootFromParent_Done,
     /*  342330 */   // Label 6281: @342330
     /*  342330 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(342396), // Rule ID 20950 //
     /*  342335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  342346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  342349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  342352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342374 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  342377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342394 */     GIR_RootConstrainSelectedInstOperands,
     /*  342395 */     // GIR_Coverage, 20950,
     /*  342395 */     GIR_EraseRootFromParent_Done,
     /*  342396 */   // Label 6282: @342396
     /*  342396 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(342462), // Rule ID 20951 //
     /*  342401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  342412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  342415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  342418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342440 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  342443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342460 */     GIR_RootConstrainSelectedInstOperands,
     /*  342461 */     // GIR_Coverage, 20951,
     /*  342461 */     GIR_EraseRootFromParent_Done,
     /*  342462 */   // Label 6283: @342462
     /*  342462 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(342528), // Rule ID 20954 //
     /*  342467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  342478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  342481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  342484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342526 */     GIR_RootConstrainSelectedInstOperands,
     /*  342527 */     // GIR_Coverage, 20954,
     /*  342527 */     GIR_EraseRootFromParent_Done,
     /*  342528 */   // Label 6284: @342528
     /*  342528 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(342594), // Rule ID 20955 //
     /*  342533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  342544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  342547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  342550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342572 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342592 */     GIR_RootConstrainSelectedInstOperands,
     /*  342593 */     // GIR_Coverage, 20955,
     /*  342593 */     GIR_EraseRootFromParent_Done,
     /*  342594 */   // Label 6285: @342594
     /*  342594 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(342660), // Rule ID 20958 //
     /*  342599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  342610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  342613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  342616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342658 */     GIR_RootConstrainSelectedInstOperands,
     /*  342659 */     // GIR_Coverage, 20958,
     /*  342659 */     GIR_EraseRootFromParent_Done,
     /*  342660 */   // Label 6286: @342660
     /*  342660 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(342726), // Rule ID 20959 //
     /*  342665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  342676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  342679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  342682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342724 */     GIR_RootConstrainSelectedInstOperands,
     /*  342725 */     // GIR_Coverage, 20959,
     /*  342725 */     GIR_EraseRootFromParent_Done,
     /*  342726 */   // Label 6287: @342726
     /*  342726 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(342792), // Rule ID 20962 //
     /*  342731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  342734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  342742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  342745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  342748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342770 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  342770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342790 */     GIR_RootConstrainSelectedInstOperands,
     /*  342791 */     // GIR_Coverage, 20962,
     /*  342791 */     GIR_EraseRootFromParent_Done,
     /*  342792 */   // Label 6288: @342792
     /*  342792 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(342858), // Rule ID 20963 //
     /*  342797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  342800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  342808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  342811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  342814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342836 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  342836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342856 */     GIR_RootConstrainSelectedInstOperands,
     /*  342857 */     // GIR_Coverage, 20963,
     /*  342857 */     GIR_EraseRootFromParent_Done,
     /*  342858 */   // Label 6289: @342858
     /*  342858 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(342924), // Rule ID 20966 //
     /*  342863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  342874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  342877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  342880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342922 */     GIR_RootConstrainSelectedInstOperands,
     /*  342923 */     // GIR_Coverage, 20966,
     /*  342923 */     GIR_EraseRootFromParent_Done,
     /*  342924 */   // Label 6290: @342924
     /*  342924 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(342990), // Rule ID 20967 //
     /*  342929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  342940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  342943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  342946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342988 */     GIR_RootConstrainSelectedInstOperands,
     /*  342989 */     // GIR_Coverage, 20967,
     /*  342989 */     GIR_EraseRootFromParent_Done,
     /*  342990 */   // Label 6291: @342990
     /*  342990 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(343056), // Rule ID 20970 //
     /*  342995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  343006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  343009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  343012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343054 */     GIR_RootConstrainSelectedInstOperands,
     /*  343055 */     // GIR_Coverage, 20970,
     /*  343055 */     GIR_EraseRootFromParent_Done,
     /*  343056 */   // Label 6292: @343056
     /*  343056 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(343122), // Rule ID 20971 //
     /*  343061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  343072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  343075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  343078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343100 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343120 */     GIR_RootConstrainSelectedInstOperands,
     /*  343121 */     // GIR_Coverage, 20971,
     /*  343121 */     GIR_EraseRootFromParent_Done,
     /*  343122 */   // Label 6293: @343122
     /*  343122 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(343188), // Rule ID 20974 //
     /*  343127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  343138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  343141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  343144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343166 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343186 */     GIR_RootConstrainSelectedInstOperands,
     /*  343187 */     // GIR_Coverage, 20974,
     /*  343187 */     GIR_EraseRootFromParent_Done,
     /*  343188 */   // Label 6294: @343188
     /*  343188 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(343254), // Rule ID 20975 //
     /*  343193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  343204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  343207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  343210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343232 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343252 */     GIR_RootConstrainSelectedInstOperands,
     /*  343253 */     // GIR_Coverage, 20975,
     /*  343253 */     GIR_EraseRootFromParent_Done,
     /*  343254 */   // Label 6295: @343254
     /*  343254 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(343320), // Rule ID 20978 //
     /*  343259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  343262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  343270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  343273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  343276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  343298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  343301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343318 */     GIR_RootConstrainSelectedInstOperands,
     /*  343319 */     // GIR_Coverage, 20978,
     /*  343319 */     GIR_EraseRootFromParent_Done,
     /*  343320 */   // Label 6296: @343320
     /*  343320 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(343386), // Rule ID 20979 //
     /*  343325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  343328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  343336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  343339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  343342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  343367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343384 */     GIR_RootConstrainSelectedInstOperands,
     /*  343385 */     // GIR_Coverage, 20979,
     /*  343385 */     GIR_EraseRootFromParent_Done,
     /*  343386 */   // Label 6297: @343386
     /*  343386 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(343452), // Rule ID 20982 //
     /*  343391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  343394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  343402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  343405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  343408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  343430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343450 */     GIR_RootConstrainSelectedInstOperands,
     /*  343451 */     // GIR_Coverage, 20982,
     /*  343451 */     GIR_EraseRootFromParent_Done,
     /*  343452 */   // Label 6298: @343452
     /*  343452 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(343518), // Rule ID 20983 //
     /*  343457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  343460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  343468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  343471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  343474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343516 */     GIR_RootConstrainSelectedInstOperands,
     /*  343517 */     // GIR_Coverage, 20983,
     /*  343517 */     GIR_EraseRootFromParent_Done,
     /*  343518 */   // Label 6299: @343518
     /*  343518 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(343584), // Rule ID 20986 //
     /*  343523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  343526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  343534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  343537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  343540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  343562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343582 */     GIR_RootConstrainSelectedInstOperands,
     /*  343583 */     // GIR_Coverage, 20986,
     /*  343583 */     GIR_EraseRootFromParent_Done,
     /*  343584 */   // Label 6300: @343584
     /*  343584 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(343650), // Rule ID 20987 //
     /*  343589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  343592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  343600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  343603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  343606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343628 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343648 */     GIR_RootConstrainSelectedInstOperands,
     /*  343649 */     // GIR_Coverage, 20987,
     /*  343649 */     GIR_EraseRootFromParent_Done,
     /*  343650 */   // Label 6301: @343650
     /*  343650 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(343716), // Rule ID 20990 //
     /*  343655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  343672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  343697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343714 */     GIR_RootConstrainSelectedInstOperands,
     /*  343715 */     // GIR_Coverage, 20990,
     /*  343715 */     GIR_EraseRootFromParent_Done,
     /*  343716 */   // Label 6302: @343716
     /*  343716 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(343782), // Rule ID 20991 //
     /*  343721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  343738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  343763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343780 */     GIR_RootConstrainSelectedInstOperands,
     /*  343781 */     // GIR_Coverage, 20991,
     /*  343781 */     GIR_EraseRootFromParent_Done,
     /*  343782 */   // Label 6303: @343782
     /*  343782 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(343848), // Rule ID 20994 //
     /*  343787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343826 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343846 */     GIR_RootConstrainSelectedInstOperands,
     /*  343847 */     // GIR_Coverage, 20994,
     /*  343847 */     GIR_EraseRootFromParent_Done,
     /*  343848 */   // Label 6304: @343848
     /*  343848 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(343914), // Rule ID 20995 //
     /*  343853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343892 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343912 */     GIR_RootConstrainSelectedInstOperands,
     /*  343913 */     // GIR_Coverage, 20995,
     /*  343913 */     GIR_EraseRootFromParent_Done,
     /*  343914 */   // Label 6305: @343914
     /*  343914 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(343980), // Rule ID 20998 //
     /*  343919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343958 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343978 */     GIR_RootConstrainSelectedInstOperands,
     /*  343979 */     // GIR_Coverage, 20998,
     /*  343979 */     GIR_EraseRootFromParent_Done,
     /*  343980 */   // Label 6306: @343980
     /*  343980 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(344046), // Rule ID 20999 //
     /*  343985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  344002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344024 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  344024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  344027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  344041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344044 */     GIR_RootConstrainSelectedInstOperands,
     /*  344045 */     // GIR_Coverage, 20999,
     /*  344045 */     GIR_EraseRootFromParent_Done,
     /*  344046 */   // Label 6307: @344046
     /*  344046 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(344112), // Rule ID 21266 //
     /*  344051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  344062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  344065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  344068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344090 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  344093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344110 */     GIR_RootConstrainSelectedInstOperands,
     /*  344111 */     // GIR_Coverage, 21266,
     /*  344111 */     GIR_EraseRootFromParent_Done,
     /*  344112 */   // Label 6308: @344112
     /*  344112 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(344178), // Rule ID 21267 //
     /*  344117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  344128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  344131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  344134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344156 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  344159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344176 */     GIR_RootConstrainSelectedInstOperands,
     /*  344177 */     // GIR_Coverage, 21267,
     /*  344177 */     GIR_EraseRootFromParent_Done,
     /*  344178 */   // Label 6309: @344178
     /*  344178 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(344244), // Rule ID 21270 //
     /*  344183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  344200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344222 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  344225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344242 */     GIR_RootConstrainSelectedInstOperands,
     /*  344243 */     // GIR_Coverage, 21270,
     /*  344243 */     GIR_EraseRootFromParent_Done,
     /*  344244 */   // Label 6310: @344244
     /*  344244 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(344310), // Rule ID 21271 //
     /*  344249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  344266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  344291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344308 */     GIR_RootConstrainSelectedInstOperands,
     /*  344309 */     // GIR_Coverage, 21271,
     /*  344309 */     GIR_EraseRootFromParent_Done,
     /*  344310 */   // Label 6311: @344310
     /*  344310 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(344376), // Rule ID 21274 //
     /*  344315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  344326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  344329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  344332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344354 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  344357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344374 */     GIR_RootConstrainSelectedInstOperands,
     /*  344375 */     // GIR_Coverage, 21274,
     /*  344375 */     GIR_EraseRootFromParent_Done,
     /*  344376 */   // Label 6312: @344376
     /*  344376 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(344442), // Rule ID 21275 //
     /*  344381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  344392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  344395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  344398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  344423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344440 */     GIR_RootConstrainSelectedInstOperands,
     /*  344441 */     // GIR_Coverage, 21275,
     /*  344441 */     GIR_EraseRootFromParent_Done,
     /*  344442 */   // Label 6313: @344442
     /*  344442 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(344508), // Rule ID 21278 //
     /*  344447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  344458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  344461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344486 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344506 */     GIR_RootConstrainSelectedInstOperands,
     /*  344507 */     // GIR_Coverage, 21278,
     /*  344507 */     GIR_EraseRootFromParent_Done,
     /*  344508 */   // Label 6314: @344508
     /*  344508 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(344574), // Rule ID 21279 //
     /*  344513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  344524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  344527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344552 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344572 */     GIR_RootConstrainSelectedInstOperands,
     /*  344573 */     // GIR_Coverage, 21279,
     /*  344573 */     GIR_EraseRootFromParent_Done,
     /*  344574 */   // Label 6315: @344574
     /*  344574 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(344640), // Rule ID 21282 //
     /*  344579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344638 */     GIR_RootConstrainSelectedInstOperands,
     /*  344639 */     // GIR_Coverage, 21282,
     /*  344639 */     GIR_EraseRootFromParent_Done,
     /*  344640 */   // Label 6316: @344640
     /*  344640 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(344706), // Rule ID 21283 //
     /*  344645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344684 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344704 */     GIR_RootConstrainSelectedInstOperands,
     /*  344705 */     // GIR_Coverage, 21283,
     /*  344705 */     GIR_EraseRootFromParent_Done,
     /*  344706 */   // Label 6317: @344706
     /*  344706 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(344772), // Rule ID 21286 //
     /*  344711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  344728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344750 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  344753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344770 */     GIR_RootConstrainSelectedInstOperands,
     /*  344771 */     // GIR_Coverage, 21286,
     /*  344771 */     GIR_EraseRootFromParent_Done,
     /*  344772 */   // Label 6318: @344772
     /*  344772 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(344838), // Rule ID 21287 //
     /*  344777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  344794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  344819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344836 */     GIR_RootConstrainSelectedInstOperands,
     /*  344837 */     // GIR_Coverage, 21287,
     /*  344837 */     GIR_EraseRootFromParent_Done,
     /*  344838 */   // Label 6319: @344838
     /*  344838 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(344904), // Rule ID 21290 //
     /*  344843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  344854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  344857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  344885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344902 */     GIR_RootConstrainSelectedInstOperands,
     /*  344903 */     // GIR_Coverage, 21290,
     /*  344903 */     GIR_EraseRootFromParent_Done,
     /*  344904 */   // Label 6320: @344904
     /*  344904 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(344970), // Rule ID 21291 //
     /*  344909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  344920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  344923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  344951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344968 */     GIR_RootConstrainSelectedInstOperands,
     /*  344969 */     // GIR_Coverage, 21291,
     /*  344969 */     GIR_EraseRootFromParent_Done,
     /*  344970 */   // Label 6321: @344970
     /*  344970 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(345036), // Rule ID 21294 //
     /*  344975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  344986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  344989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  344992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345014 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  345017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345034 */     GIR_RootConstrainSelectedInstOperands,
     /*  345035 */     // GIR_Coverage, 21294,
     /*  345035 */     GIR_EraseRootFromParent_Done,
     /*  345036 */   // Label 6322: @345036
     /*  345036 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(345102), // Rule ID 21295 //
     /*  345041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  345049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  345052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  345055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  345058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345080 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  345083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345100 */     GIR_RootConstrainSelectedInstOperands,
     /*  345101 */     // GIR_Coverage, 21295,
     /*  345101 */     GIR_EraseRootFromParent_Done,
     /*  345102 */   // Label 6323: @345102
     /*  345102 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(345168), // Rule ID 21298 //
     /*  345107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  345115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  345124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  345149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345166 */     GIR_RootConstrainSelectedInstOperands,
     /*  345167 */     // GIR_Coverage, 21298,
     /*  345167 */     GIR_EraseRootFromParent_Done,
     /*  345168 */   // Label 6324: @345168
     /*  345168 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(345234), // Rule ID 21299 //
     /*  345173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  345181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  345190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345212 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  345215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345232 */     GIR_RootConstrainSelectedInstOperands,
     /*  345233 */     // GIR_Coverage, 21299,
     /*  345233 */     GIR_EraseRootFromParent_Done,
     /*  345234 */   // Label 6325: @345234
     /*  345234 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(345300), // Rule ID 21302 //
     /*  345239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  345250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  345253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  345256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345278 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  345281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345298 */     GIR_RootConstrainSelectedInstOperands,
     /*  345299 */     // GIR_Coverage, 21302,
     /*  345299 */     GIR_EraseRootFromParent_Done,
     /*  345300 */   // Label 6326: @345300
     /*  345300 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(345366), // Rule ID 21303 //
     /*  345305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  345316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  345319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  345322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  345347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345364 */     GIR_RootConstrainSelectedInstOperands,
     /*  345365 */     // GIR_Coverage, 21303,
     /*  345365 */     GIR_EraseRootFromParent_Done,
     /*  345366 */   // Label 6327: @345366
     /*  345366 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(345432), // Rule ID 21306 //
     /*  345371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  345382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  345385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  345388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345410 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11344:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345430 */     GIR_RootConstrainSelectedInstOperands,
     /*  345431 */     // GIR_Coverage, 21306,
     /*  345431 */     GIR_EraseRootFromParent_Done,
     /*  345432 */   // Label 6328: @345432
     /*  345432 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(345498), // Rule ID 21307 //
     /*  345437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  345448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  345451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  345454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345476 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11344:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345496 */     GIR_RootConstrainSelectedInstOperands,
     /*  345497 */     // GIR_Coverage, 21307,
     /*  345497 */     GIR_EraseRootFromParent_Done,
     /*  345498 */   // Label 6329: @345498
     /*  345498 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(345564), // Rule ID 21310 //
     /*  345503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  345514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  345517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  345520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345542 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345562 */     GIR_RootConstrainSelectedInstOperands,
     /*  345563 */     // GIR_Coverage, 21310,
     /*  345563 */     GIR_EraseRootFromParent_Done,
     /*  345564 */   // Label 6330: @345564
     /*  345564 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(345630), // Rule ID 21311 //
     /*  345569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  345580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  345583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  345586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345628 */     GIR_RootConstrainSelectedInstOperands,
     /*  345629 */     // GIR_Coverage, 21311,
     /*  345629 */     GIR_EraseRootFromParent_Done,
     /*  345630 */   // Label 6331: @345630
     /*  345630 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(345696), // Rule ID 21314 //
     /*  345635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  345646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  345649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  345652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345694 */     GIR_RootConstrainSelectedInstOperands,
     /*  345695 */     // GIR_Coverage, 21314,
     /*  345695 */     GIR_EraseRootFromParent_Done,
     /*  345696 */   // Label 6332: @345696
     /*  345696 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(345762), // Rule ID 21315 //
     /*  345701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  345712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  345715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  345718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345740 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345760 */     GIR_RootConstrainSelectedInstOperands,
     /*  345761 */     // GIR_Coverage, 21315,
     /*  345761 */     GIR_EraseRootFromParent_Done,
     /*  345762 */   // Label 6333: @345762
     /*  345762 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(345828), // Rule ID 21318 //
     /*  345767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  345778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  345781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  345784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345806 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345826 */     GIR_RootConstrainSelectedInstOperands,
     /*  345827 */     // GIR_Coverage, 21318,
     /*  345827 */     GIR_EraseRootFromParent_Done,
     /*  345828 */   // Label 6334: @345828
     /*  345828 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(345894), // Rule ID 21319 //
     /*  345833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  345844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  345847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  345850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345872 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345892 */     GIR_RootConstrainSelectedInstOperands,
     /*  345893 */     // GIR_Coverage, 21319,
     /*  345893 */     GIR_EraseRootFromParent_Done,
     /*  345894 */   // Label 6335: @345894
     /*  345894 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(345960), // Rule ID 21322 //
     /*  345899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  345910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  345913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345938 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345958 */     GIR_RootConstrainSelectedInstOperands,
     /*  345959 */     // GIR_Coverage, 21322,
     /*  345959 */     GIR_EraseRootFromParent_Done,
     /*  345960 */   // Label 6336: @345960
     /*  345960 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(346026), // Rule ID 21323 //
     /*  345965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  345976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  345979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  346007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346024 */     GIR_RootConstrainSelectedInstOperands,
     /*  346025 */     // GIR_Coverage, 21323,
     /*  346025 */     GIR_EraseRootFromParent_Done,
     /*  346026 */   // Label 6337: @346026
     /*  346026 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(346092), // Rule ID 21326 //
     /*  346031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  346034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  346039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  346042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  346045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  346048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  346073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346090 */     GIR_RootConstrainSelectedInstOperands,
     /*  346091 */     // GIR_Coverage, 21326,
     /*  346091 */     GIR_EraseRootFromParent_Done,
     /*  346092 */   // Label 6338: @346092
     /*  346092 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(346158), // Rule ID 21327 //
     /*  346097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  346100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  346105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  346108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  346111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  346114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  346139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346156 */     GIR_RootConstrainSelectedInstOperands,
     /*  346157 */     // GIR_Coverage, 21327,
     /*  346157 */     GIR_EraseRootFromParent_Done,
     /*  346158 */   // Label 6339: @346158
     /*  346158 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(346224), // Rule ID 21330 //
     /*  346163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  346166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  346171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  346174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  346177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  346180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346202 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  346205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346222 */     GIR_RootConstrainSelectedInstOperands,
     /*  346223 */     // GIR_Coverage, 21330,
     /*  346223 */     GIR_EraseRootFromParent_Done,
     /*  346224 */   // Label 6340: @346224
     /*  346224 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(346290), // Rule ID 21331 //
     /*  346229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  346232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  346237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  346240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  346243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  346246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346268 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  346271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346288 */     GIR_RootConstrainSelectedInstOperands,
     /*  346289 */     // GIR_Coverage, 21331,
     /*  346289 */     GIR_EraseRootFromParent_Done,
     /*  346290 */   // Label 6341: @346290
     /*  346290 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(346356), // Rule ID 21334 //
     /*  346295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  346298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  346303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  346306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  346309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  346312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346334 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  346337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346354 */     GIR_RootConstrainSelectedInstOperands,
     /*  346355 */     // GIR_Coverage, 21334,
     /*  346355 */     GIR_EraseRootFromParent_Done,
     /*  346356 */   // Label 6342: @346356
     /*  346356 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(346422), // Rule ID 21335 //
     /*  346361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  346364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  346369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  346372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  346375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  346378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346400 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  346403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346420 */     GIR_RootConstrainSelectedInstOperands,
     /*  346421 */     // GIR_Coverage, 21335,
     /*  346421 */     GIR_EraseRootFromParent_Done,
     /*  346422 */   // Label 6343: @346422
     /*  346422 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(346488), // Rule ID 21338 //
     /*  346427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  346438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  346441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  346444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346466 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  346469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346486 */     GIR_RootConstrainSelectedInstOperands,
     /*  346487 */     // GIR_Coverage, 21338,
     /*  346487 */     GIR_EraseRootFromParent_Done,
     /*  346488 */   // Label 6344: @346488
     /*  346488 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(346554), // Rule ID 21339 //
     /*  346493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  346504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  346507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  346510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346532 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  346535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346552 */     GIR_RootConstrainSelectedInstOperands,
     /*  346553 */     // GIR_Coverage, 21339,
     /*  346553 */     GIR_EraseRootFromParent_Done,
     /*  346554 */   // Label 6345: @346554
     /*  346554 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(346620), // Rule ID 21342 //
     /*  346559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  346570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  346573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  346576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346598 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  346601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346618 */     GIR_RootConstrainSelectedInstOperands,
     /*  346619 */     // GIR_Coverage, 21342,
     /*  346619 */     GIR_EraseRootFromParent_Done,
     /*  346620 */   // Label 6346: @346620
     /*  346620 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(346686), // Rule ID 21343 //
     /*  346625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  346636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  346639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  346642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346664 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  346667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346684 */     GIR_RootConstrainSelectedInstOperands,
     /*  346685 */     // GIR_Coverage, 21343,
     /*  346685 */     GIR_EraseRootFromParent_Done,
     /*  346686 */   // Label 6347: @346686
     /*  346686 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(346752), // Rule ID 21346 //
     /*  346691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  346702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  346705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  346708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346730 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  346733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346750 */     GIR_RootConstrainSelectedInstOperands,
     /*  346751 */     // GIR_Coverage, 21346,
     /*  346751 */     GIR_EraseRootFromParent_Done,
     /*  346752 */   // Label 6348: @346752
     /*  346752 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(346818), // Rule ID 21347 //
     /*  346757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  346768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  346771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  346774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346796 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  346799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346816 */     GIR_RootConstrainSelectedInstOperands,
     /*  346817 */     // GIR_Coverage, 21347,
     /*  346817 */     GIR_EraseRootFromParent_Done,
     /*  346818 */   // Label 6349: @346818
     /*  346818 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(346884), // Rule ID 21350 //
     /*  346823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  346834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  346837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  346840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346862 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  346865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346882 */     GIR_RootConstrainSelectedInstOperands,
     /*  346883 */     // GIR_Coverage, 21350,
     /*  346883 */     GIR_EraseRootFromParent_Done,
     /*  346884 */   // Label 6350: @346884
     /*  346884 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(346950), // Rule ID 21351 //
     /*  346889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  346900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  346903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  346906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346928 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  346931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346948 */     GIR_RootConstrainSelectedInstOperands,
     /*  346949 */     // GIR_Coverage, 21351,
     /*  346949 */     GIR_EraseRootFromParent_Done,
     /*  346950 */   // Label 6351: @346950
     /*  346950 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(347016), // Rule ID 21354 //
     /*  346955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  346966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  346969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  346972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346994 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  346997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347014 */     GIR_RootConstrainSelectedInstOperands,
     /*  347015 */     // GIR_Coverage, 21354,
     /*  347015 */     GIR_EraseRootFromParent_Done,
     /*  347016 */   // Label 6352: @347016
     /*  347016 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(347082), // Rule ID 21355 //
     /*  347021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  347032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  347035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  347038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347060 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  347060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  347063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347080 */     GIR_RootConstrainSelectedInstOperands,
     /*  347081 */     // GIR_Coverage, 21355,
     /*  347081 */     GIR_EraseRootFromParent_Done,
     /*  347082 */   // Label 6353: @347082
     /*  347082 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(347148), // Rule ID 21358 //
     /*  347087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  347098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  347101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  347104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347126 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  347126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  347129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347146 */     GIR_RootConstrainSelectedInstOperands,
     /*  347147 */     // GIR_Coverage, 21358,
     /*  347147 */     GIR_EraseRootFromParent_Done,
     /*  347148 */   // Label 6354: @347148
     /*  347148 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(347214), // Rule ID 21359 //
     /*  347153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  347164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  347167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  347170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347192 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  347192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  347195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347212 */     GIR_RootConstrainSelectedInstOperands,
     /*  347213 */     // GIR_Coverage, 21359,
     /*  347213 */     GIR_EraseRootFromParent_Done,
     /*  347214 */   // Label 6355: @347214
     /*  347214 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(347280), // Rule ID 21362 //
     /*  347219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  347230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  347233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  347236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347258 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  347261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347278 */     GIR_RootConstrainSelectedInstOperands,
     /*  347279 */     // GIR_Coverage, 21362,
     /*  347279 */     GIR_EraseRootFromParent_Done,
     /*  347280 */   // Label 6356: @347280
     /*  347280 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(347346), // Rule ID 21363 //
     /*  347285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  347296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  347299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  347302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347324 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  347327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347344 */     GIR_RootConstrainSelectedInstOperands,
     /*  347345 */     // GIR_Coverage, 21363,
     /*  347345 */     GIR_EraseRootFromParent_Done,
     /*  347346 */   // Label 6357: @347346
     /*  347346 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(347412), // Rule ID 21366 //
     /*  347351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  347362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  347365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  347368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347390 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  347393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347410 */     GIR_RootConstrainSelectedInstOperands,
     /*  347411 */     // GIR_Coverage, 21366,
     /*  347411 */     GIR_EraseRootFromParent_Done,
     /*  347412 */   // Label 6358: @347412
     /*  347412 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(347478), // Rule ID 21367 //
     /*  347417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  347428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  347431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  347434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347456 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  347459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347476 */     GIR_RootConstrainSelectedInstOperands,
     /*  347477 */     // GIR_Coverage, 21367,
     /*  347477 */     GIR_EraseRootFromParent_Done,
     /*  347478 */   // Label 6359: @347478
     /*  347478 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(347544), // Rule ID 21370 //
     /*  347483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  347494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  347497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  347500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347522 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  347525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347542 */     GIR_RootConstrainSelectedInstOperands,
     /*  347543 */     // GIR_Coverage, 21370,
     /*  347543 */     GIR_EraseRootFromParent_Done,
     /*  347544 */   // Label 6360: @347544
     /*  347544 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(347610), // Rule ID 21371 //
     /*  347549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  347560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  347563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  347566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347588 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  347591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347608 */     GIR_RootConstrainSelectedInstOperands,
     /*  347609 */     // GIR_Coverage, 21371,
     /*  347609 */     GIR_EraseRootFromParent_Done,
     /*  347610 */   // Label 6361: @347610
     /*  347610 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(347676), // Rule ID 21374 //
     /*  347615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  347626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  347629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  347632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347654 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  347657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347674 */     GIR_RootConstrainSelectedInstOperands,
     /*  347675 */     // GIR_Coverage, 21374,
     /*  347675 */     GIR_EraseRootFromParent_Done,
     /*  347676 */   // Label 6362: @347676
     /*  347676 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(347742), // Rule ID 21375 //
     /*  347681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  347692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  347695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  347698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347720 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  347723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347740 */     GIR_RootConstrainSelectedInstOperands,
     /*  347741 */     // GIR_Coverage, 21375,
     /*  347741 */     GIR_EraseRootFromParent_Done,
     /*  347742 */   // Label 6363: @347742
     /*  347742 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(347808), // Rule ID 21378 //
     /*  347747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  347758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  347761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  347764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347786 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  347789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347806 */     GIR_RootConstrainSelectedInstOperands,
     /*  347807 */     // GIR_Coverage, 21378,
     /*  347807 */     GIR_EraseRootFromParent_Done,
     /*  347808 */   // Label 6364: @347808
     /*  347808 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(347874), // Rule ID 21379 //
     /*  347813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  347824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  347827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  347830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347852 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  347855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347872 */     GIR_RootConstrainSelectedInstOperands,
     /*  347873 */     // GIR_Coverage, 21379,
     /*  347873 */     GIR_EraseRootFromParent_Done,
     /*  347874 */   // Label 6365: @347874
     /*  347874 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(347940), // Rule ID 21382 //
     /*  347879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  347890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  347893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  347896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347918 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  347921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347938 */     GIR_RootConstrainSelectedInstOperands,
     /*  347939 */     // GIR_Coverage, 21382,
     /*  347939 */     GIR_EraseRootFromParent_Done,
     /*  347940 */   // Label 6366: @347940
     /*  347940 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(348006), // Rule ID 21383 //
     /*  347945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  347956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  347959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  347962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347984 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  347987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348004 */     GIR_RootConstrainSelectedInstOperands,
     /*  348005 */     // GIR_Coverage, 21383,
     /*  348005 */     GIR_EraseRootFromParent_Done,
     /*  348006 */   // Label 6367: @348006
     /*  348006 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(348072), // Rule ID 21386 //
     /*  348011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  348014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  348019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  348022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  348025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  348028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348050 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  348053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348070 */     GIR_RootConstrainSelectedInstOperands,
     /*  348071 */     // GIR_Coverage, 21386,
     /*  348071 */     GIR_EraseRootFromParent_Done,
     /*  348072 */   // Label 6368: @348072
     /*  348072 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(348138), // Rule ID 21387 //
     /*  348077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  348080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  348085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  348088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  348091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  348094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348116 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  348119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348136 */     GIR_RootConstrainSelectedInstOperands,
     /*  348137 */     // GIR_Coverage, 21387,
     /*  348137 */     GIR_EraseRootFromParent_Done,
     /*  348138 */   // Label 6369: @348138
     /*  348138 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(348204), // Rule ID 21390 //
     /*  348143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  348146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  348151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  348154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  348157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  348160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348182 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  348185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348202 */     GIR_RootConstrainSelectedInstOperands,
     /*  348203 */     // GIR_Coverage, 21390,
     /*  348203 */     GIR_EraseRootFromParent_Done,
     /*  348204 */   // Label 6370: @348204
     /*  348204 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(348270), // Rule ID 21391 //
     /*  348209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  348212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  348217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  348220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  348223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  348226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348248 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  348251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348268 */     GIR_RootConstrainSelectedInstOperands,
     /*  348269 */     // GIR_Coverage, 21391,
     /*  348269 */     GIR_EraseRootFromParent_Done,
     /*  348270 */   // Label 6371: @348270
     /*  348270 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(348336), // Rule ID 21394 //
     /*  348275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  348278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  348283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  348286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  348289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  348292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348314 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  348317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348334 */     GIR_RootConstrainSelectedInstOperands,
     /*  348335 */     // GIR_Coverage, 21394,
     /*  348335 */     GIR_EraseRootFromParent_Done,
     /*  348336 */   // Label 6372: @348336
     /*  348336 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(348402), // Rule ID 21395 //
     /*  348341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  348344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  348349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  348352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  348355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  348358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348380 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  348383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348400 */     GIR_RootConstrainSelectedInstOperands,
     /*  348401 */     // GIR_Coverage, 21395,
     /*  348401 */     GIR_EraseRootFromParent_Done,
     /*  348402 */   // Label 6373: @348402
     /*  348402 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(348468), // Rule ID 21398 //
     /*  348407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  348418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  348421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  348424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348446 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  348449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348466 */     GIR_RootConstrainSelectedInstOperands,
     /*  348467 */     // GIR_Coverage, 21398,
     /*  348467 */     GIR_EraseRootFromParent_Done,
     /*  348468 */   // Label 6374: @348468
     /*  348468 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(348534), // Rule ID 21399 //
     /*  348473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  348484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  348487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  348490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348512 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  348515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348532 */     GIR_RootConstrainSelectedInstOperands,
     /*  348533 */     // GIR_Coverage, 21399,
     /*  348533 */     GIR_EraseRootFromParent_Done,
     /*  348534 */   // Label 6375: @348534
     /*  348534 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(348600), // Rule ID 21402 //
     /*  348539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  348550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  348553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  348556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348578 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  348581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348598 */     GIR_RootConstrainSelectedInstOperands,
     /*  348599 */     // GIR_Coverage, 21402,
     /*  348599 */     GIR_EraseRootFromParent_Done,
     /*  348600 */   // Label 6376: @348600
     /*  348600 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(348666), // Rule ID 21403 //
     /*  348605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  348616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  348619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  348622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348644 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  348647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348664 */     GIR_RootConstrainSelectedInstOperands,
     /*  348665 */     // GIR_Coverage, 21403,
     /*  348665 */     GIR_EraseRootFromParent_Done,
     /*  348666 */   // Label 6377: @348666
     /*  348666 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(348732), // Rule ID 21406 //
     /*  348671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  348682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  348685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  348688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348710 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  348713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348730 */     GIR_RootConstrainSelectedInstOperands,
     /*  348731 */     // GIR_Coverage, 21406,
     /*  348731 */     GIR_EraseRootFromParent_Done,
     /*  348732 */   // Label 6378: @348732
     /*  348732 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(348798), // Rule ID 21407 //
     /*  348737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  348748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  348751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  348754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348776 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  348779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348796 */     GIR_RootConstrainSelectedInstOperands,
     /*  348797 */     // GIR_Coverage, 21407,
     /*  348797 */     GIR_EraseRootFromParent_Done,
     /*  348798 */   // Label 6379: @348798
     /*  348798 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(348864), // Rule ID 21410 //
     /*  348803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  348814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  348817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  348820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348842 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  348845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348862 */     GIR_RootConstrainSelectedInstOperands,
     /*  348863 */     // GIR_Coverage, 21410,
     /*  348863 */     GIR_EraseRootFromParent_Done,
     /*  348864 */   // Label 6380: @348864
     /*  348864 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(348930), // Rule ID 21411 //
     /*  348869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  348880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  348883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  348886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348908 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  348911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348928 */     GIR_RootConstrainSelectedInstOperands,
     /*  348929 */     // GIR_Coverage, 21411,
     /*  348929 */     GIR_EraseRootFromParent_Done,
     /*  348930 */   // Label 6381: @348930
     /*  348930 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(348996), // Rule ID 21414 //
     /*  348935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  348946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  348949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  348952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348974 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  348977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348994 */     GIR_RootConstrainSelectedInstOperands,
     /*  348995 */     // GIR_Coverage, 21414,
     /*  348995 */     GIR_EraseRootFromParent_Done,
     /*  348996 */   // Label 6382: @348996
     /*  348996 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(349062), // Rule ID 21415 //
     /*  349001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  349004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  349012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  349015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  349018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349040 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  349040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  349043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349060 */     GIR_RootConstrainSelectedInstOperands,
     /*  349061 */     // GIR_Coverage, 21415,
     /*  349061 */     GIR_EraseRootFromParent_Done,
     /*  349062 */   // Label 6383: @349062
     /*  349062 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(349128), // Rule ID 21418 //
     /*  349067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  349070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  349078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  349081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  349084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349106 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  349106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  349109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349126 */     GIR_RootConstrainSelectedInstOperands,
     /*  349127 */     // GIR_Coverage, 21418,
     /*  349127 */     GIR_EraseRootFromParent_Done,
     /*  349128 */   // Label 6384: @349128
     /*  349128 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(349194), // Rule ID 21419 //
     /*  349133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  349136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  349144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  349147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  349150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349172 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  349172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  349175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349192 */     GIR_RootConstrainSelectedInstOperands,
     /*  349193 */     // GIR_Coverage, 21419,
     /*  349193 */     GIR_EraseRootFromParent_Done,
     /*  349194 */   // Label 6385: @349194
     /*  349194 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(349260), // Rule ID 21422 //
     /*  349199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  349210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  349213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  349216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349238 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  349241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349258 */     GIR_RootConstrainSelectedInstOperands,
     /*  349259 */     // GIR_Coverage, 21422,
     /*  349259 */     GIR_EraseRootFromParent_Done,
     /*  349260 */   // Label 6386: @349260
     /*  349260 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(349326), // Rule ID 21423 //
     /*  349265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  349276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  349279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  349282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349304 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  349307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349324 */     GIR_RootConstrainSelectedInstOperands,
     /*  349325 */     // GIR_Coverage, 21423,
     /*  349325 */     GIR_EraseRootFromParent_Done,
     /*  349326 */   // Label 6387: @349326
     /*  349326 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(349392), // Rule ID 21426 //
     /*  349331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  349342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  349345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  349348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349370 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  349373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349390 */     GIR_RootConstrainSelectedInstOperands,
     /*  349391 */     // GIR_Coverage, 21426,
     /*  349391 */     GIR_EraseRootFromParent_Done,
     /*  349392 */   // Label 6388: @349392
     /*  349392 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(349458), // Rule ID 21427 //
     /*  349397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  349408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  349411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  349414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349436 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  349439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349456 */     GIR_RootConstrainSelectedInstOperands,
     /*  349457 */     // GIR_Coverage, 21427,
     /*  349457 */     GIR_EraseRootFromParent_Done,
     /*  349458 */   // Label 6389: @349458
     /*  349458 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(349524), // Rule ID 21430 //
     /*  349463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  349474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  349477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  349480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349502 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  349505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349522 */     GIR_RootConstrainSelectedInstOperands,
     /*  349523 */     // GIR_Coverage, 21430,
     /*  349523 */     GIR_EraseRootFromParent_Done,
     /*  349524 */   // Label 6390: @349524
     /*  349524 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(349590), // Rule ID 21431 //
     /*  349529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  349540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  349543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  349546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349568 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  349571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349588 */     GIR_RootConstrainSelectedInstOperands,
     /*  349589 */     // GIR_Coverage, 21431,
     /*  349589 */     GIR_EraseRootFromParent_Done,
     /*  349590 */   // Label 6391: @349590
     /*  349590 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(349656), // Rule ID 21434 //
     /*  349595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349634 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  349637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349654 */     GIR_RootConstrainSelectedInstOperands,
     /*  349655 */     // GIR_Coverage, 21434,
     /*  349655 */     GIR_EraseRootFromParent_Done,
     /*  349656 */   // Label 6392: @349656
     /*  349656 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(349722), // Rule ID 21435 //
     /*  349661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349700 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  349703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349720 */     GIR_RootConstrainSelectedInstOperands,
     /*  349721 */     // GIR_Coverage, 21435,
     /*  349721 */     GIR_EraseRootFromParent_Done,
     /*  349722 */   // Label 6393: @349722
     /*  349722 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(349788), // Rule ID 21438 //
     /*  349727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349766 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  349769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349786 */     GIR_RootConstrainSelectedInstOperands,
     /*  349787 */     // GIR_Coverage, 21438,
     /*  349787 */     GIR_EraseRootFromParent_Done,
     /*  349788 */   // Label 6394: @349788
     /*  349788 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(349854), // Rule ID 21439 //
     /*  349793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349832 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  349835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349852 */     GIR_RootConstrainSelectedInstOperands,
     /*  349853 */     // GIR_Coverage, 21439,
     /*  349853 */     GIR_EraseRootFromParent_Done,
     /*  349854 */   // Label 6395: @349854
     /*  349854 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(349920), // Rule ID 21442 //
     /*  349859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  349870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  349873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  349876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349898 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  349901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349918 */     GIR_RootConstrainSelectedInstOperands,
     /*  349919 */     // GIR_Coverage, 21442,
     /*  349919 */     GIR_EraseRootFromParent_Done,
     /*  349920 */   // Label 6396: @349920
     /*  349920 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(349986), // Rule ID 21443 //
     /*  349925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  349936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  349939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  349942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349964 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  349967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349984 */     GIR_RootConstrainSelectedInstOperands,
     /*  349985 */     // GIR_Coverage, 21443,
     /*  349985 */     GIR_EraseRootFromParent_Done,
     /*  349986 */   // Label 6397: @349986
     /*  349986 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(350052), // Rule ID 21446 //
     /*  349991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  350002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  350005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  350008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350030 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  350033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350050 */     GIR_RootConstrainSelectedInstOperands,
     /*  350051 */     // GIR_Coverage, 21446,
     /*  350051 */     GIR_EraseRootFromParent_Done,
     /*  350052 */   // Label 6398: @350052
     /*  350052 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(350118), // Rule ID 21447 //
     /*  350057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  350060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  350065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  350068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  350071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  350074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350096 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  350099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350116 */     GIR_RootConstrainSelectedInstOperands,
     /*  350117 */     // GIR_Coverage, 21447,
     /*  350117 */     GIR_EraseRootFromParent_Done,
     /*  350118 */   // Label 6399: @350118
     /*  350118 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(350184), // Rule ID 21450 //
     /*  350123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  350126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  350131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  350134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  350137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  350140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350162 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  350165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350182 */     GIR_RootConstrainSelectedInstOperands,
     /*  350183 */     // GIR_Coverage, 21450,
     /*  350183 */     GIR_EraseRootFromParent_Done,
     /*  350184 */   // Label 6400: @350184
     /*  350184 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(350250), // Rule ID 21451 //
     /*  350189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  350192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  350197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  350200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  350203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  350206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350228 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  350231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350248 */     GIR_RootConstrainSelectedInstOperands,
     /*  350249 */     // GIR_Coverage, 21451,
     /*  350249 */     GIR_EraseRootFromParent_Done,
     /*  350250 */   // Label 6401: @350250
     /*  350250 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(350316), // Rule ID 21454 //
     /*  350255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  350258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  350263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  350266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  350269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  350272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350294 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  350297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350314 */     GIR_RootConstrainSelectedInstOperands,
     /*  350315 */     // GIR_Coverage, 21454,
     /*  350315 */     GIR_EraseRootFromParent_Done,
     /*  350316 */   // Label 6402: @350316
     /*  350316 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(350382), // Rule ID 21455 //
     /*  350321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  350324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  350329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  350332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  350335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  350338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350360 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  350363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350380 */     GIR_RootConstrainSelectedInstOperands,
     /*  350381 */     // GIR_Coverage, 21455,
     /*  350381 */     GIR_EraseRootFromParent_Done,
     /*  350382 */   // Label 6403: @350382
     /*  350382 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(350448), // Rule ID 21458 //
     /*  350387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  350398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  350401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  350404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350426 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  350429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350446 */     GIR_RootConstrainSelectedInstOperands,
     /*  350447 */     // GIR_Coverage, 21458,
     /*  350447 */     GIR_EraseRootFromParent_Done,
     /*  350448 */   // Label 6404: @350448
     /*  350448 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(350514), // Rule ID 21459 //
     /*  350453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  350464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  350467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  350470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350492 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  350495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350512 */     GIR_RootConstrainSelectedInstOperands,
     /*  350513 */     // GIR_Coverage, 21459,
     /*  350513 */     GIR_EraseRootFromParent_Done,
     /*  350514 */   // Label 6405: @350514
     /*  350514 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(350580), // Rule ID 21462 //
     /*  350519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  350530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  350533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350558 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  350561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350578 */     GIR_RootConstrainSelectedInstOperands,
     /*  350579 */     // GIR_Coverage, 21462,
     /*  350579 */     GIR_EraseRootFromParent_Done,
     /*  350580 */   // Label 6406: @350580
     /*  350580 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(350646), // Rule ID 21463 //
     /*  350585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  350596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  350599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  350627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350644 */     GIR_RootConstrainSelectedInstOperands,
     /*  350645 */     // GIR_Coverage, 21463,
     /*  350645 */     GIR_EraseRootFromParent_Done,
     /*  350646 */   // Label 6407: @350646
     /*  350646 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(350712), // Rule ID 21466 //
     /*  350651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  350662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  350665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350690 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  350693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350710 */     GIR_RootConstrainSelectedInstOperands,
     /*  350711 */     // GIR_Coverage, 21466,
     /*  350711 */     GIR_EraseRootFromParent_Done,
     /*  350712 */   // Label 6408: @350712
     /*  350712 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(350778), // Rule ID 21467 //
     /*  350717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  350728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  350731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350756 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  350759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350776 */     GIR_RootConstrainSelectedInstOperands,
     /*  350777 */     // GIR_Coverage, 21467,
     /*  350777 */     GIR_EraseRootFromParent_Done,
     /*  350778 */   // Label 6409: @350778
     /*  350778 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(350844), // Rule ID 21470 //
     /*  350783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  350794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  350797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  350800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350822 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  350825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350842 */     GIR_RootConstrainSelectedInstOperands,
     /*  350843 */     // GIR_Coverage, 21470,
     /*  350843 */     GIR_EraseRootFromParent_Done,
     /*  350844 */   // Label 6410: @350844
     /*  350844 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(350910), // Rule ID 21471 //
     /*  350849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  350860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  350863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  350866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350888 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  350891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350908 */     GIR_RootConstrainSelectedInstOperands,
     /*  350909 */     // GIR_Coverage, 21471,
     /*  350909 */     GIR_EraseRootFromParent_Done,
     /*  350910 */   // Label 6411: @350910
     /*  350910 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(350976), // Rule ID 21474 //
     /*  350915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  350926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  350929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  350932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350954 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  350957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350974 */     GIR_RootConstrainSelectedInstOperands,
     /*  350975 */     // GIR_Coverage, 21474,
     /*  350975 */     GIR_EraseRootFromParent_Done,
     /*  350976 */   // Label 6412: @350976
     /*  350976 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(351042), // Rule ID 21475 //
     /*  350981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  350992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  350995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  350998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351020 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  351023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351040 */     GIR_RootConstrainSelectedInstOperands,
     /*  351041 */     // GIR_Coverage, 21475,
     /*  351041 */     GIR_EraseRootFromParent_Done,
     /*  351042 */   // Label 6413: @351042
     /*  351042 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(351108), // Rule ID 21478 //
     /*  351047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  351050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  351058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  351061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351086 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  351089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351106 */     GIR_RootConstrainSelectedInstOperands,
     /*  351107 */     // GIR_Coverage, 21478,
     /*  351107 */     GIR_EraseRootFromParent_Done,
     /*  351108 */   // Label 6414: @351108
     /*  351108 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(351174), // Rule ID 21479 //
     /*  351113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  351116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  351124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  351127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351152 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  351155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351172 */     GIR_RootConstrainSelectedInstOperands,
     /*  351173 */     // GIR_Coverage, 21479,
     /*  351173 */     GIR_EraseRootFromParent_Done,
     /*  351174 */   // Label 6415: @351174
     /*  351174 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(351240), // Rule ID 21482 //
     /*  351179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  351182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  351190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  351193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  351196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351218 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  351221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351238 */     GIR_RootConstrainSelectedInstOperands,
     /*  351239 */     // GIR_Coverage, 21482,
     /*  351239 */     GIR_EraseRootFromParent_Done,
     /*  351240 */   // Label 6416: @351240
     /*  351240 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(351306), // Rule ID 21483 //
     /*  351245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  351248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  351256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  351259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  351262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351284 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  351287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351304 */     GIR_RootConstrainSelectedInstOperands,
     /*  351305 */     // GIR_Coverage, 21483,
     /*  351305 */     GIR_EraseRootFromParent_Done,
     /*  351306 */   // Label 6417: @351306
     /*  351306 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(351372), // Rule ID 21486 //
     /*  351311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  351314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  351322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  351325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  351328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351350 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  351353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351370 */     GIR_RootConstrainSelectedInstOperands,
     /*  351371 */     // GIR_Coverage, 21486,
     /*  351371 */     GIR_EraseRootFromParent_Done,
     /*  351372 */   // Label 6418: @351372
     /*  351372 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(351438), // Rule ID 21487 //
     /*  351377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  351380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  351388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  351391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  351394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351416 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  351419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351436 */     GIR_RootConstrainSelectedInstOperands,
     /*  351437 */     // GIR_Coverage, 21487,
     /*  351437 */     GIR_EraseRootFromParent_Done,
     /*  351438 */   // Label 6419: @351438
     /*  351438 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(351504), // Rule ID 21490 //
     /*  351443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  351446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  351454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  351457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  351460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351482 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  351485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351502 */     GIR_RootConstrainSelectedInstOperands,
     /*  351503 */     // GIR_Coverage, 21490,
     /*  351503 */     GIR_EraseRootFromParent_Done,
     /*  351504 */   // Label 6420: @351504
     /*  351504 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(351570), // Rule ID 21491 //
     /*  351509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  351512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  351520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  351523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  351526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351548 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  351551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351568 */     GIR_RootConstrainSelectedInstOperands,
     /*  351569 */     // GIR_Coverage, 21491,
     /*  351569 */     GIR_EraseRootFromParent_Done,
     /*  351570 */   // Label 6421: @351570
     /*  351570 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(351636), // Rule ID 21734 //
     /*  351575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  351586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  351589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  351592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351614 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  351617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351634 */     GIR_RootConstrainSelectedInstOperands,
     /*  351635 */     // GIR_Coverage, 21734,
     /*  351635 */     GIR_EraseRootFromParent_Done,
     /*  351636 */   // Label 6422: @351636
     /*  351636 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(351702), // Rule ID 21735 //
     /*  351641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  351652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  351655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  351658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351680 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  351683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351700 */     GIR_RootConstrainSelectedInstOperands,
     /*  351701 */     // GIR_Coverage, 21735,
     /*  351701 */     GIR_EraseRootFromParent_Done,
     /*  351702 */   // Label 6423: @351702
     /*  351702 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(351768), // Rule ID 21738 //
     /*  351707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  351718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  351721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  351724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  351749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351766 */     GIR_RootConstrainSelectedInstOperands,
     /*  351767 */     // GIR_Coverage, 21738,
     /*  351767 */     GIR_EraseRootFromParent_Done,
     /*  351768 */   // Label 6424: @351768
     /*  351768 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(351834), // Rule ID 21739 //
     /*  351773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  351784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  351787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  351790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351812 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  351815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351832 */     GIR_RootConstrainSelectedInstOperands,
     /*  351833 */     // GIR_Coverage, 21739,
     /*  351833 */     GIR_EraseRootFromParent_Done,
     /*  351834 */   // Label 6425: @351834
     /*  351834 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(351900), // Rule ID 21742 //
     /*  351839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  351850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  351853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  351856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351878 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  351881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351898 */     GIR_RootConstrainSelectedInstOperands,
     /*  351899 */     // GIR_Coverage, 21742,
     /*  351899 */     GIR_EraseRootFromParent_Done,
     /*  351900 */   // Label 6426: @351900
     /*  351900 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(351966), // Rule ID 21743 //
     /*  351905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  351916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  351919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  351922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351944 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  351947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351964 */     GIR_RootConstrainSelectedInstOperands,
     /*  351965 */     // GIR_Coverage, 21743,
     /*  351965 */     GIR_EraseRootFromParent_Done,
     /*  351966 */   // Label 6427: @351966
     /*  351966 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(352032), // Rule ID 21746 //
     /*  351971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  351982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  351985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  351988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352010 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352030 */     GIR_RootConstrainSelectedInstOperands,
     /*  352031 */     // GIR_Coverage, 21746,
     /*  352031 */     GIR_EraseRootFromParent_Done,
     /*  352032 */   // Label 6428: @352032
     /*  352032 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(352098), // Rule ID 21747 //
     /*  352037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  352048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  352051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  352054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352076 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352096 */     GIR_RootConstrainSelectedInstOperands,
     /*  352097 */     // GIR_Coverage, 21747,
     /*  352097 */     GIR_EraseRootFromParent_Done,
     /*  352098 */   // Label 6429: @352098
     /*  352098 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(352164), // Rule ID 21750 //
     /*  352103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  352114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  352117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  352120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352142 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352162 */     GIR_RootConstrainSelectedInstOperands,
     /*  352163 */     // GIR_Coverage, 21750,
     /*  352163 */     GIR_EraseRootFromParent_Done,
     /*  352164 */   // Label 6430: @352164
     /*  352164 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(352230), // Rule ID 21751 //
     /*  352169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  352180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  352183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  352186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352208 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352228 */     GIR_RootConstrainSelectedInstOperands,
     /*  352229 */     // GIR_Coverage, 21751,
     /*  352229 */     GIR_EraseRootFromParent_Done,
     /*  352230 */   // Label 6431: @352230
     /*  352230 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(352296), // Rule ID 21754 //
     /*  352235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  352246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  352249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  352252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352274 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352294 */     GIR_RootConstrainSelectedInstOperands,
     /*  352295 */     // GIR_Coverage, 21754,
     /*  352295 */     GIR_EraseRootFromParent_Done,
     /*  352296 */   // Label 6432: @352296
     /*  352296 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(352362), // Rule ID 21755 //
     /*  352301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  352312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  352315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  352318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352340 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352360 */     GIR_RootConstrainSelectedInstOperands,
     /*  352361 */     // GIR_Coverage, 21755,
     /*  352361 */     GIR_EraseRootFromParent_Done,
     /*  352362 */   // Label 6433: @352362
     /*  352362 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(352428), // Rule ID 21758 //
     /*  352367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  352378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  352381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  352384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352406 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  352409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352426 */     GIR_RootConstrainSelectedInstOperands,
     /*  352427 */     // GIR_Coverage, 21758,
     /*  352427 */     GIR_EraseRootFromParent_Done,
     /*  352428 */   // Label 6434: @352428
     /*  352428 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(352494), // Rule ID 21759 //
     /*  352433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  352444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  352447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  352450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352472 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  352475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352492 */     GIR_RootConstrainSelectedInstOperands,
     /*  352493 */     // GIR_Coverage, 21759,
     /*  352493 */     GIR_EraseRootFromParent_Done,
     /*  352494 */   // Label 6435: @352494
     /*  352494 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(352560), // Rule ID 21762 //
     /*  352499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  352510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  352513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  352516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352538 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352558 */     GIR_RootConstrainSelectedInstOperands,
     /*  352559 */     // GIR_Coverage, 21762,
     /*  352559 */     GIR_EraseRootFromParent_Done,
     /*  352560 */   // Label 6436: @352560
     /*  352560 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(352626), // Rule ID 21763 //
     /*  352565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  352576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  352579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  352582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352604 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352624 */     GIR_RootConstrainSelectedInstOperands,
     /*  352625 */     // GIR_Coverage, 21763,
     /*  352625 */     GIR_EraseRootFromParent_Done,
     /*  352626 */   // Label 6437: @352626
     /*  352626 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(352692), // Rule ID 21766 //
     /*  352631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  352648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352670 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352690 */     GIR_RootConstrainSelectedInstOperands,
     /*  352691 */     // GIR_Coverage, 21766,
     /*  352691 */     GIR_EraseRootFromParent_Done,
     /*  352692 */   // Label 6438: @352692
     /*  352692 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(352758), // Rule ID 21767 //
     /*  352697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  352714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352736 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352756 */     GIR_RootConstrainSelectedInstOperands,
     /*  352757 */     // GIR_Coverage, 21767,
     /*  352757 */     GIR_EraseRootFromParent_Done,
     /*  352758 */   // Label 6439: @352758
     /*  352758 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(352824), // Rule ID 21770 //
     /*  352763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  352774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  352777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  352780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352822 */     GIR_RootConstrainSelectedInstOperands,
     /*  352823 */     // GIR_Coverage, 21770,
     /*  352823 */     GIR_EraseRootFromParent_Done,
     /*  352824 */   // Label 6440: @352824
     /*  352824 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(352890), // Rule ID 21771 //
     /*  352829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  352840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  352843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  352846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352888 */     GIR_RootConstrainSelectedInstOperands,
     /*  352889 */     // GIR_Coverage, 21771,
     /*  352889 */     GIR_EraseRootFromParent_Done,
     /*  352890 */   // Label 6441: @352890
     /*  352890 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(352956), // Rule ID 21774 //
     /*  352895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  352906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  352909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  352912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352954 */     GIR_RootConstrainSelectedInstOperands,
     /*  352955 */     // GIR_Coverage, 21774,
     /*  352955 */     GIR_EraseRootFromParent_Done,
     /*  352956 */   // Label 6442: @352956
     /*  352956 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(353022), // Rule ID 21775 //
     /*  352961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  352972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  352975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  352978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353000 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  353003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353020 */     GIR_RootConstrainSelectedInstOperands,
     /*  353021 */     // GIR_Coverage, 21775,
     /*  353021 */     GIR_EraseRootFromParent_Done,
     /*  353022 */   // Label 6443: @353022
     /*  353022 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(353088), // Rule ID 21778 //
     /*  353027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  353038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  353041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  353044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  353069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353086 */     GIR_RootConstrainSelectedInstOperands,
     /*  353087 */     // GIR_Coverage, 21778,
     /*  353087 */     GIR_EraseRootFromParent_Done,
     /*  353088 */   // Label 6444: @353088
     /*  353088 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(353154), // Rule ID 21779 //
     /*  353093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  353104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  353107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  353110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  353135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353152 */     GIR_RootConstrainSelectedInstOperands,
     /*  353153 */     // GIR_Coverage, 21779,
     /*  353153 */     GIR_EraseRootFromParent_Done,
     /*  353154 */   // Label 6445: @353154
     /*  353154 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(353220), // Rule ID 21782 //
     /*  353159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  353170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  353173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  353176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353198 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  353201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353218 */     GIR_RootConstrainSelectedInstOperands,
     /*  353219 */     // GIR_Coverage, 21782,
     /*  353219 */     GIR_EraseRootFromParent_Done,
     /*  353220 */   // Label 6446: @353220
     /*  353220 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(353286), // Rule ID 21783 //
     /*  353225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  353236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  353239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  353242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  353267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353284 */     GIR_RootConstrainSelectedInstOperands,
     /*  353285 */     // GIR_Coverage, 21783,
     /*  353285 */     GIR_EraseRootFromParent_Done,
     /*  353286 */   // Label 6447: @353286
     /*  353286 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(353352), // Rule ID 21786 //
     /*  353291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  353302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  353305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  353308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  353333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353350 */     GIR_RootConstrainSelectedInstOperands,
     /*  353351 */     // GIR_Coverage, 21786,
     /*  353351 */     GIR_EraseRootFromParent_Done,
     /*  353352 */   // Label 6448: @353352
     /*  353352 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(353418), // Rule ID 21787 //
     /*  353357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  353368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  353371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  353374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  353399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353416 */     GIR_RootConstrainSelectedInstOperands,
     /*  353417 */     // GIR_Coverage, 21787,
     /*  353417 */     GIR_EraseRootFromParent_Done,
     /*  353418 */   // Label 6449: @353418
     /*  353418 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(353484), // Rule ID 21790 //
     /*  353423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  353434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  353437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  353440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353462 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  353465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353482 */     GIR_RootConstrainSelectedInstOperands,
     /*  353483 */     // GIR_Coverage, 21790,
     /*  353483 */     GIR_EraseRootFromParent_Done,
     /*  353484 */   // Label 6450: @353484
     /*  353484 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(353550), // Rule ID 21791 //
     /*  353489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  353500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  353503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  353506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353528 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  353531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353548 */     GIR_RootConstrainSelectedInstOperands,
     /*  353549 */     // GIR_Coverage, 21791,
     /*  353549 */     GIR_EraseRootFromParent_Done,
     /*  353550 */   // Label 6451: @353550
     /*  353550 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(353616), // Rule ID 21794 //
     /*  353555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  353566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  353569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  353572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353594 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  353597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353614 */     GIR_RootConstrainSelectedInstOperands,
     /*  353615 */     // GIR_Coverage, 21794,
     /*  353615 */     GIR_EraseRootFromParent_Done,
     /*  353616 */   // Label 6452: @353616
     /*  353616 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(353682), // Rule ID 21795 //
     /*  353621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  353632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  353635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  353638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353660 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  353663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353680 */     GIR_RootConstrainSelectedInstOperands,
     /*  353681 */     // GIR_Coverage, 21795,
     /*  353681 */     GIR_EraseRootFromParent_Done,
     /*  353682 */   // Label 6453: @353682
     /*  353682 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(353748), // Rule ID 21798 //
     /*  353687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  353698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  353701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  353704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353726 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353746 */     GIR_RootConstrainSelectedInstOperands,
     /*  353747 */     // GIR_Coverage, 21798,
     /*  353747 */     GIR_EraseRootFromParent_Done,
     /*  353748 */   // Label 6454: @353748
     /*  353748 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(353814), // Rule ID 21799 //
     /*  353753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  353764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  353767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  353770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353792 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353812 */     GIR_RootConstrainSelectedInstOperands,
     /*  353813 */     // GIR_Coverage, 21799,
     /*  353813 */     GIR_EraseRootFromParent_Done,
     /*  353814 */   // Label 6455: @353814
     /*  353814 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(353880), // Rule ID 21802 //
     /*  353819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  353830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  353833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  353836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353858 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11286:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  353861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353878 */     GIR_RootConstrainSelectedInstOperands,
     /*  353879 */     // GIR_Coverage, 21802,
     /*  353879 */     GIR_EraseRootFromParent_Done,
     /*  353880 */   // Label 6456: @353880
     /*  353880 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(353946), // Rule ID 21803 //
     /*  353885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  353896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  353899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  353902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353924 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11286:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  353927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353944 */     GIR_RootConstrainSelectedInstOperands,
     /*  353945 */     // GIR_Coverage, 21803,
     /*  353945 */     GIR_EraseRootFromParent_Done,
     /*  353946 */   // Label 6457: @353946
     /*  353946 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(354012), // Rule ID 21806 //
     /*  353951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  353962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  353965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  353968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11286:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  353993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354010 */     GIR_RootConstrainSelectedInstOperands,
     /*  354011 */     // GIR_Coverage, 21806,
     /*  354011 */     GIR_EraseRootFromParent_Done,
     /*  354012 */   // Label 6458: @354012
     /*  354012 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(354078), // Rule ID 21807 //
     /*  354017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  354020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  354028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  354031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  354034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354056 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11286:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  354056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354076 */     GIR_RootConstrainSelectedInstOperands,
     /*  354077 */     // GIR_Coverage, 21807,
     /*  354077 */     GIR_EraseRootFromParent_Done,
     /*  354078 */   // Label 6459: @354078
     /*  354078 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(354144), // Rule ID 21810 //
     /*  354083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  354086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  354094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  354097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  354100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354122 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  354122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354142 */     GIR_RootConstrainSelectedInstOperands,
     /*  354143 */     // GIR_Coverage, 21810,
     /*  354143 */     GIR_EraseRootFromParent_Done,
     /*  354144 */   // Label 6460: @354144
     /*  354144 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(354210), // Rule ID 21811 //
     /*  354149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  354152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  354160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  354163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  354166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354188 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  354188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354208 */     GIR_RootConstrainSelectedInstOperands,
     /*  354209 */     // GIR_Coverage, 21811,
     /*  354209 */     GIR_EraseRootFromParent_Done,
     /*  354210 */   // Label 6461: @354210
     /*  354210 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(354276), // Rule ID 21814 //
     /*  354215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  354218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  354226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  354229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  354232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354254 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  354254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354274 */     GIR_RootConstrainSelectedInstOperands,
     /*  354275 */     // GIR_Coverage, 21814,
     /*  354275 */     GIR_EraseRootFromParent_Done,
     /*  354276 */   // Label 6462: @354276
     /*  354276 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(354342), // Rule ID 21815 //
     /*  354281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  354284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  354292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  354295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  354298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354320 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  354320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354340 */     GIR_RootConstrainSelectedInstOperands,
     /*  354341 */     // GIR_Coverage, 21815,
     /*  354341 */     GIR_EraseRootFromParent_Done,
     /*  354342 */   // Label 6463: @354342
     /*  354342 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(354408), // Rule ID 21818 //
     /*  354347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  354358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  354361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  354364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354386 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  354389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354406 */     GIR_RootConstrainSelectedInstOperands,
     /*  354407 */     // GIR_Coverage, 21818,
     /*  354407 */     GIR_EraseRootFromParent_Done,
     /*  354408 */   // Label 6464: @354408
     /*  354408 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(354474), // Rule ID 21819 //
     /*  354413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  354424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  354427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  354430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354452 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  354455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354472 */     GIR_RootConstrainSelectedInstOperands,
     /*  354473 */     // GIR_Coverage, 21819,
     /*  354473 */     GIR_EraseRootFromParent_Done,
     /*  354474 */   // Label 6465: @354474
     /*  354474 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(354540), // Rule ID 21822 //
     /*  354479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  354490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  354493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354538 */     GIR_RootConstrainSelectedInstOperands,
     /*  354539 */     // GIR_Coverage, 21822,
     /*  354539 */     GIR_EraseRootFromParent_Done,
     /*  354540 */   // Label 6466: @354540
     /*  354540 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(354606), // Rule ID 21823 //
     /*  354545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  354556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  354559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354584 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354604 */     GIR_RootConstrainSelectedInstOperands,
     /*  354605 */     // GIR_Coverage, 21823,
     /*  354605 */     GIR_EraseRootFromParent_Done,
     /*  354606 */   // Label 6467: @354606
     /*  354606 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(354672), // Rule ID 21826 //
     /*  354611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  354622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  354625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354670 */     GIR_RootConstrainSelectedInstOperands,
     /*  354671 */     // GIR_Coverage, 21826,
     /*  354671 */     GIR_EraseRootFromParent_Done,
     /*  354672 */   // Label 6468: @354672
     /*  354672 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(354738), // Rule ID 21827 //
     /*  354677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  354688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  354691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354736 */     GIR_RootConstrainSelectedInstOperands,
     /*  354737 */     // GIR_Coverage, 21827,
     /*  354737 */     GIR_EraseRootFromParent_Done,
     /*  354738 */   // Label 6469: @354738
     /*  354738 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(354804), // Rule ID 21830 //
     /*  354743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  354754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  354757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354802 */     GIR_RootConstrainSelectedInstOperands,
     /*  354803 */     // GIR_Coverage, 21830,
     /*  354803 */     GIR_EraseRootFromParent_Done,
     /*  354804 */   // Label 6470: @354804
     /*  354804 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(354870), // Rule ID 21831 //
     /*  354809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  354820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  354823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354868 */     GIR_RootConstrainSelectedInstOperands,
     /*  354869 */     // GIR_Coverage, 21831,
     /*  354869 */     GIR_EraseRootFromParent_Done,
     /*  354870 */   // Label 6471: @354870
     /*  354870 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(354936), // Rule ID 21834 //
     /*  354875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  354886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  354889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  354892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354914 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354934 */     GIR_RootConstrainSelectedInstOperands,
     /*  354935 */     // GIR_Coverage, 21834,
     /*  354935 */     GIR_EraseRootFromParent_Done,
     /*  354936 */   // Label 6472: @354936
     /*  354936 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(355002), // Rule ID 21835 //
     /*  354941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  354952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  354955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  354958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354980 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355000 */     GIR_RootConstrainSelectedInstOperands,
     /*  355001 */     // GIR_Coverage, 21835,
     /*  355001 */     GIR_EraseRootFromParent_Done,
     /*  355002 */   // Label 6473: @355002
     /*  355002 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(355068), // Rule ID 21838 //
     /*  355007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  355010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  355018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  355021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  355024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  355049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355066 */     GIR_RootConstrainSelectedInstOperands,
     /*  355067 */     // GIR_Coverage, 21838,
     /*  355067 */     GIR_EraseRootFromParent_Done,
     /*  355068 */   // Label 6474: @355068
     /*  355068 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(355134), // Rule ID 21839 //
     /*  355073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  355076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  355084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  355087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  355090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355112 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  355115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355132 */     GIR_RootConstrainSelectedInstOperands,
     /*  355133 */     // GIR_Coverage, 21839,
     /*  355133 */     GIR_EraseRootFromParent_Done,
     /*  355134 */   // Label 6475: @355134
     /*  355134 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(355200), // Rule ID 21842 //
     /*  355139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  355142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  355150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  355153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  355156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355178 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  355181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355198 */     GIR_RootConstrainSelectedInstOperands,
     /*  355199 */     // GIR_Coverage, 21842,
     /*  355199 */     GIR_EraseRootFromParent_Done,
     /*  355200 */   // Label 6476: @355200
     /*  355200 */   GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(355266), // Rule ID 21843 //
     /*  355205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  355208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  355216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  355219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  355222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  355247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355264 */     GIR_RootConstrainSelectedInstOperands,
     /*  355265 */     // GIR_Coverage, 21843,
     /*  355265 */     GIR_EraseRootFromParent_Done,
     /*  355266 */   // Label 6477: @355266
     /*  355266 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(355332), // Rule ID 21846 //
     /*  355271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  355274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  355282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  355285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  355288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355310 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  355313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355330 */     GIR_RootConstrainSelectedInstOperands,
     /*  355331 */     // GIR_Coverage, 21846,
     /*  355331 */     GIR_EraseRootFromParent_Done,
     /*  355332 */   // Label 6478: @355332
     /*  355332 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(355398), // Rule ID 21847 //
     /*  355337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  355340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  355348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  355351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  355354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  355379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355396 */     GIR_RootConstrainSelectedInstOperands,
     /*  355397 */     // GIR_Coverage, 21847,
     /*  355397 */     GIR_EraseRootFromParent_Done,
     /*  355398 */   // Label 6479: @355398
     /*  355398 */   GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(355464), // Rule ID 21850 //
     /*  355403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  355406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  355414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  355417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  355420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355442 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  355445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355462 */     GIR_RootConstrainSelectedInstOperands,
     /*  355463 */     // GIR_Coverage, 21850,
     /*  355463 */     GIR_EraseRootFromParent_Done,
     /*  355464 */   // Label 6480: @355464
     /*  355464 */   GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(355530), // Rule ID 21851 //
     /*  355469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  355472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  355480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  355483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  355486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  355511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355528 */     GIR_RootConstrainSelectedInstOperands,
     /*  355529 */     // GIR_Coverage, 21851,
     /*  355529 */     GIR_EraseRootFromParent_Done,
     /*  355530 */   // Label 6481: @355530
     /*  355530 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(355596), // Rule ID 21962 //
     /*  355535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355574 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  355577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355594 */     GIR_RootConstrainSelectedInstOperands,
     /*  355595 */     // GIR_Coverage, 21962,
     /*  355595 */     GIR_EraseRootFromParent_Done,
     /*  355596 */   // Label 6482: @355596
     /*  355596 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(355662), // Rule ID 21963 //
     /*  355601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355640 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  355643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355660 */     GIR_RootConstrainSelectedInstOperands,
     /*  355661 */     // GIR_Coverage, 21963,
     /*  355661 */     GIR_EraseRootFromParent_Done,
     /*  355662 */   // Label 6483: @355662
     /*  355662 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(355728), // Rule ID 21966 //
     /*  355667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  355684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355706 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  355709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355726 */     GIR_RootConstrainSelectedInstOperands,
     /*  355727 */     // GIR_Coverage, 21966,
     /*  355727 */     GIR_EraseRootFromParent_Done,
     /*  355728 */   // Label 6484: @355728
     /*  355728 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(355794), // Rule ID 21967 //
     /*  355733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  355750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355772 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  355775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355792 */     GIR_RootConstrainSelectedInstOperands,
     /*  355793 */     // GIR_Coverage, 21967,
     /*  355793 */     GIR_EraseRootFromParent_Done,
     /*  355794 */   // Label 6485: @355794
     /*  355794 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(355860), // Rule ID 21970 //
     /*  355799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  355810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  355813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  355816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355838 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  355841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355858 */     GIR_RootConstrainSelectedInstOperands,
     /*  355859 */     // GIR_Coverage, 21970,
     /*  355859 */     GIR_EraseRootFromParent_Done,
     /*  355860 */   // Label 6486: @355860
     /*  355860 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(355926), // Rule ID 21971 //
     /*  355865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  355876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  355879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  355882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355904 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  355907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355924 */     GIR_RootConstrainSelectedInstOperands,
     /*  355925 */     // GIR_Coverage, 21971,
     /*  355925 */     GIR_EraseRootFromParent_Done,
     /*  355926 */   // Label 6487: @355926
     /*  355926 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(355992), // Rule ID 21974 //
     /*  355931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  355942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  355945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  355948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355970 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  355973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355990 */     GIR_RootConstrainSelectedInstOperands,
     /*  355991 */     // GIR_Coverage, 21974,
     /*  355991 */     GIR_EraseRootFromParent_Done,
     /*  355992 */   // Label 6488: @355992
     /*  355992 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(356058), // Rule ID 21975 //
     /*  355997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  356000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  356008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  356011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  356014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356036 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  356036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  356039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356056 */     GIR_RootConstrainSelectedInstOperands,
     /*  356057 */     // GIR_Coverage, 21975,
     /*  356057 */     GIR_EraseRootFromParent_Done,
     /*  356058 */   // Label 6489: @356058
     /*  356058 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(356124), // Rule ID 21978 //
     /*  356063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  356066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  356074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  356077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  356080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356102 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  356102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  356105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356122 */     GIR_RootConstrainSelectedInstOperands,
     /*  356123 */     // GIR_Coverage, 21978,
     /*  356123 */     GIR_EraseRootFromParent_Done,
     /*  356124 */   // Label 6490: @356124
     /*  356124 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(356190), // Rule ID 21979 //
     /*  356129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  356132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  356140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  356143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  356146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356168 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  356168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  356171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356188 */     GIR_RootConstrainSelectedInstOperands,
     /*  356189 */     // GIR_Coverage, 21979,
     /*  356189 */     GIR_EraseRootFromParent_Done,
     /*  356190 */   // Label 6491: @356190
     /*  356190 */   GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(356256), // Rule ID 21982 //
     /*  356195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  356198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  356206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  356209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  356212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356234 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  356237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356254 */     GIR_RootConstrainSelectedInstOperands,
     /*  356255 */     // GIR_Coverage, 21982,
     /*  356255 */     GIR_EraseRootFromParent_Done,
     /*  356256 */   // Label 6492: @356256
     /*  356256 */   GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(356322), // Rule ID 21983 //
     /*  356261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  356264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  356272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  356275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  356278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356300 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  356303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356320 */     GIR_RootConstrainSelectedInstOperands,
     /*  356321 */     // GIR_Coverage, 21983,
     /*  356321 */     GIR_EraseRootFromParent_Done,
     /*  356322 */   // Label 6493: @356322
     /*  356322 */   GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(356388), // Rule ID 21986 //
     /*  356327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  356330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  356338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  356341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  356344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356366 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  356369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356386 */     GIR_RootConstrainSelectedInstOperands,
     /*  356387 */     // GIR_Coverage, 21986,
     /*  356387 */     GIR_EraseRootFromParent_Done,
     /*  356388 */   // Label 6494: @356388
     /*  356388 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(356454), // Rule ID 21987 //
     /*  356393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  356396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  356404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  356407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  356410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356432 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  356435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356452 */     GIR_RootConstrainSelectedInstOperands,
     /*  356453 */     // GIR_Coverage, 21987,
     /*  356453 */     GIR_EraseRootFromParent_Done,
     /*  356454 */   // Label 6495: @356454
     /*  356454 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(356520), // Rule ID 21990 //
     /*  356459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  356462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  356470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  356473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  356476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356498 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  356501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356518 */     GIR_RootConstrainSelectedInstOperands,
     /*  356519 */     // GIR_Coverage, 21990,
     /*  356519 */     GIR_EraseRootFromParent_Done,
     /*  356520 */   // Label 6496: @356520
     /*  356520 */   GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(356586), // Rule ID 21991 //
     /*  356525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  356528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  356536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  356539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  356542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356564 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  356567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356584 */     GIR_RootConstrainSelectedInstOperands,
     /*  356585 */     // GIR_Coverage, 21991,
     /*  356585 */     GIR_EraseRootFromParent_Done,
     /*  356586 */   // Label 6497: @356586
     /*  356586 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(356652), // Rule ID 21994 //
     /*  356591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  356594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  356602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  356605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  356608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356630 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  356633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356650 */     GIR_RootConstrainSelectedInstOperands,
     /*  356651 */     // GIR_Coverage, 21994,
     /*  356651 */     GIR_EraseRootFromParent_Done,
     /*  356652 */   // Label 6498: @356652
     /*  356652 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(356718), // Rule ID 21995 //
     /*  356657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  356660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  356668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  356671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  356674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356696 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  356699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356716 */     GIR_RootConstrainSelectedInstOperands,
     /*  356717 */     // GIR_Coverage, 21995,
     /*  356717 */     GIR_EraseRootFromParent_Done,
     /*  356718 */   // Label 6499: @356718
     /*  356718 */   GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(356781), // Rule ID 23166 //
     /*  356723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  356734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  356737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  356740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356762 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  356765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356779 */     GIR_RootConstrainSelectedInstOperands,
     /*  356780 */     // GIR_Coverage, 23166,
     /*  356780 */     GIR_EraseRootFromParent_Done,
     /*  356781 */   // Label 6500: @356781
     /*  356781 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(356844), // Rule ID 23167 //
     /*  356786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  356797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  356800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  356803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356825 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  356828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356842 */     GIR_RootConstrainSelectedInstOperands,
     /*  356843 */     // GIR_Coverage, 23167,
     /*  356843 */     GIR_EraseRootFromParent_Done,
     /*  356844 */   // Label 6501: @356844
     /*  356844 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(356907), // Rule ID 23168 //
     /*  356849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  356860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  356863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  356866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356888 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  356891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356905 */     GIR_RootConstrainSelectedInstOperands,
     /*  356906 */     // GIR_Coverage, 23168,
     /*  356906 */     GIR_EraseRootFromParent_Done,
     /*  356907 */   // Label 6502: @356907
     /*  356907 */   GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(356970), // Rule ID 23169 //
     /*  356912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  356923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  356926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  356929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356951 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  356954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356968 */     GIR_RootConstrainSelectedInstOperands,
     /*  356969 */     // GIR_Coverage, 23169,
     /*  356969 */     GIR_EraseRootFromParent_Done,
     /*  356970 */   // Label 6503: @356970
     /*  356970 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(357033), // Rule ID 23170 //
     /*  356975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  356986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  356989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  356992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357014 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  357017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357031 */     GIR_RootConstrainSelectedInstOperands,
     /*  357032 */     // GIR_Coverage, 23170,
     /*  357032 */     GIR_EraseRootFromParent_Done,
     /*  357033 */   // Label 6504: @357033
     /*  357033 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(357096), // Rule ID 23171 //
     /*  357038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  357049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  357052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  357055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357077 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  357080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357094 */     GIR_RootConstrainSelectedInstOperands,
     /*  357095 */     // GIR_Coverage, 23171,
     /*  357095 */     GIR_EraseRootFromParent_Done,
     /*  357096 */   // Label 6505: @357096
     /*  357096 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(357159), // Rule ID 23172 //
     /*  357101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357140 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  357143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357157 */     GIR_RootConstrainSelectedInstOperands,
     /*  357158 */     // GIR_Coverage, 23172,
     /*  357158 */     GIR_EraseRootFromParent_Done,
     /*  357159 */   // Label 6506: @357159
     /*  357159 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(357222), // Rule ID 23173 //
     /*  357164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357203 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  357206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357220 */     GIR_RootConstrainSelectedInstOperands,
     /*  357221 */     // GIR_Coverage, 23173,
     /*  357221 */     GIR_EraseRootFromParent_Done,
     /*  357222 */   // Label 6507: @357222
     /*  357222 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(357285), // Rule ID 23174 //
     /*  357227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  357238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  357241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  357244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357266 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  357269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357283 */     GIR_RootConstrainSelectedInstOperands,
     /*  357284 */     // GIR_Coverage, 23174,
     /*  357284 */     GIR_EraseRootFromParent_Done,
     /*  357285 */   // Label 6508: @357285
     /*  357285 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(357348), // Rule ID 23175 //
     /*  357290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  357301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  357304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  357307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357329 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  357332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357346 */     GIR_RootConstrainSelectedInstOperands,
     /*  357347 */     // GIR_Coverage, 23175,
     /*  357347 */     GIR_EraseRootFromParent_Done,
     /*  357348 */   // Label 6509: @357348
     /*  357348 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(357411), // Rule ID 23176 //
     /*  357353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  357364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  357367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  357370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357392 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  357395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357409 */     GIR_RootConstrainSelectedInstOperands,
     /*  357410 */     // GIR_Coverage, 23176,
     /*  357410 */     GIR_EraseRootFromParent_Done,
     /*  357411 */   // Label 6510: @357411
     /*  357411 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(357474), // Rule ID 23177 //
     /*  357416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  357427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  357430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  357433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357455 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  357458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357472 */     GIR_RootConstrainSelectedInstOperands,
     /*  357473 */     // GIR_Coverage, 23177,
     /*  357473 */     GIR_EraseRootFromParent_Done,
     /*  357474 */   // Label 6511: @357474
     /*  357474 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(357537), // Rule ID 23178 //
     /*  357479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357518 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  357521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357535 */     GIR_RootConstrainSelectedInstOperands,
     /*  357536 */     // GIR_Coverage, 23178,
     /*  357536 */     GIR_EraseRootFromParent_Done,
     /*  357537 */   // Label 6512: @357537
     /*  357537 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(357600), // Rule ID 23179 //
     /*  357542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357581 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  357584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357598 */     GIR_RootConstrainSelectedInstOperands,
     /*  357599 */     // GIR_Coverage, 23179,
     /*  357599 */     GIR_EraseRootFromParent_Done,
     /*  357600 */   // Label 6513: @357600
     /*  357600 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(357663), // Rule ID 23180 //
     /*  357605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  357616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  357619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  357622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357644 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  357647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357661 */     GIR_RootConstrainSelectedInstOperands,
     /*  357662 */     // GIR_Coverage, 23180,
     /*  357662 */     GIR_EraseRootFromParent_Done,
     /*  357663 */   // Label 6514: @357663
     /*  357663 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(357726), // Rule ID 23181 //
     /*  357668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  357679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  357682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  357685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357707 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  357710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357724 */     GIR_RootConstrainSelectedInstOperands,
     /*  357725 */     // GIR_Coverage, 23181,
     /*  357725 */     GIR_EraseRootFromParent_Done,
     /*  357726 */   // Label 6515: @357726
     /*  357726 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(357789), // Rule ID 23182 //
     /*  357731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  357742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  357745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  357748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357770 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  357773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357787 */     GIR_RootConstrainSelectedInstOperands,
     /*  357788 */     // GIR_Coverage, 23182,
     /*  357788 */     GIR_EraseRootFromParent_Done,
     /*  357789 */   // Label 6516: @357789
     /*  357789 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(357852), // Rule ID 23183 //
     /*  357794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  357805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  357808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  357811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357833 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  357836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357850 */     GIR_RootConstrainSelectedInstOperands,
     /*  357851 */     // GIR_Coverage, 23183,
     /*  357851 */     GIR_EraseRootFromParent_Done,
     /*  357852 */   // Label 6517: @357852
     /*  357852 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(357915), // Rule ID 23184 //
     /*  357857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  357868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  357871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  357874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  357899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357913 */     GIR_RootConstrainSelectedInstOperands,
     /*  357914 */     // GIR_Coverage, 23184,
     /*  357914 */     GIR_EraseRootFromParent_Done,
     /*  357915 */   // Label 6518: @357915
     /*  357915 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(357978), // Rule ID 23185 //
     /*  357920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  357931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  357934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  357937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357959 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  357962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357976 */     GIR_RootConstrainSelectedInstOperands,
     /*  357977 */     // GIR_Coverage, 23185,
     /*  357977 */     GIR_EraseRootFromParent_Done,
     /*  357978 */   // Label 6519: @357978
     /*  357978 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(358041), // Rule ID 23186 //
     /*  357983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358022 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  358025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358039 */     GIR_RootConstrainSelectedInstOperands,
     /*  358040 */     // GIR_Coverage, 23186,
     /*  358040 */     GIR_EraseRootFromParent_Done,
     /*  358041 */   // Label 6520: @358041
     /*  358041 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(358104), // Rule ID 23187 //
     /*  358046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  358054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  358057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  358060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358085 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  358088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358102 */     GIR_RootConstrainSelectedInstOperands,
     /*  358103 */     // GIR_Coverage, 23187,
     /*  358103 */     GIR_EraseRootFromParent_Done,
     /*  358104 */   // Label 6521: @358104
     /*  358104 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(358167), // Rule ID 23188 //
     /*  358109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  358117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  358126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358148 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  358151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358165 */     GIR_RootConstrainSelectedInstOperands,
     /*  358166 */     // GIR_Coverage, 23188,
     /*  358166 */     GIR_EraseRootFromParent_Done,
     /*  358167 */   // Label 6522: @358167
     /*  358167 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(358230), // Rule ID 23189 //
     /*  358172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  358180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  358189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358211 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  358214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358228 */     GIR_RootConstrainSelectedInstOperands,
     /*  358229 */     // GIR_Coverage, 23189,
     /*  358229 */     GIR_EraseRootFromParent_Done,
     /*  358230 */   // Label 6523: @358230
     /*  358230 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(358293), // Rule ID 23190 //
     /*  358235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  358243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  358246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  358249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  358252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358274 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  358277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358291 */     GIR_RootConstrainSelectedInstOperands,
     /*  358292 */     // GIR_Coverage, 23190,
     /*  358292 */     GIR_EraseRootFromParent_Done,
     /*  358293 */   // Label 6524: @358293
     /*  358293 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(358356), // Rule ID 23191 //
     /*  358298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  358306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  358309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  358312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  358315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358337 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11491:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  358340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358354 */     GIR_RootConstrainSelectedInstOperands,
     /*  358355 */     // GIR_Coverage, 23191,
     /*  358355 */     GIR_EraseRootFromParent_Done,
     /*  358356 */   // Label 6525: @358356
     /*  358356 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(358419), // Rule ID 23192 //
     /*  358361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  358372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  358375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  358378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358400 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  358403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358417 */     GIR_RootConstrainSelectedInstOperands,
     /*  358418 */     // GIR_Coverage, 23192,
     /*  358418 */     GIR_EraseRootFromParent_Done,
     /*  358419 */   // Label 6526: @358419
     /*  358419 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(358482), // Rule ID 23193 //
     /*  358424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  358435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  358438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  358441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358463 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  358466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358480 */     GIR_RootConstrainSelectedInstOperands,
     /*  358481 */     // GIR_Coverage, 23193,
     /*  358481 */     GIR_EraseRootFromParent_Done,
     /*  358482 */   // Label 6527: @358482
     /*  358482 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(358545), // Rule ID 23194 //
     /*  358487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358526 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  358529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358543 */     GIR_RootConstrainSelectedInstOperands,
     /*  358544 */     // GIR_Coverage, 23194,
     /*  358544 */     GIR_EraseRootFromParent_Done,
     /*  358545 */   // Label 6528: @358545
     /*  358545 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(358608), // Rule ID 23195 //
     /*  358550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358589 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  358592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358606 */     GIR_RootConstrainSelectedInstOperands,
     /*  358607 */     // GIR_Coverage, 23195,
     /*  358607 */     GIR_EraseRootFromParent_Done,
     /*  358608 */   // Label 6529: @358608
     /*  358608 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(358671), // Rule ID 23196 //
     /*  358613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  358624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  358627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  358630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358652 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  358655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358669 */     GIR_RootConstrainSelectedInstOperands,
     /*  358670 */     // GIR_Coverage, 23196,
     /*  358670 */     GIR_EraseRootFromParent_Done,
     /*  358671 */   // Label 6530: @358671
     /*  358671 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(358734), // Rule ID 23197 //
     /*  358676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  358687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  358690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  358693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358715 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  358718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358732 */     GIR_RootConstrainSelectedInstOperands,
     /*  358733 */     // GIR_Coverage, 23197,
     /*  358733 */     GIR_EraseRootFromParent_Done,
     /*  358734 */   // Label 6531: @358734
     /*  358734 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(358797), // Rule ID 23198 //
     /*  358739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  358750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  358753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  358756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358778 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  358781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358795 */     GIR_RootConstrainSelectedInstOperands,
     /*  358796 */     // GIR_Coverage, 23198,
     /*  358796 */     GIR_EraseRootFromParent_Done,
     /*  358797 */   // Label 6532: @358797
     /*  358797 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(358860), // Rule ID 23199 //
     /*  358802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  358813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  358816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  358819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358841 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  358844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358858 */     GIR_RootConstrainSelectedInstOperands,
     /*  358859 */     // GIR_Coverage, 23199,
     /*  358859 */     GIR_EraseRootFromParent_Done,
     /*  358860 */   // Label 6533: @358860
     /*  358860 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(358923), // Rule ID 23200 //
     /*  358865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  358876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  358879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358904 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  358907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358921 */     GIR_RootConstrainSelectedInstOperands,
     /*  358922 */     // GIR_Coverage, 23200,
     /*  358922 */     GIR_EraseRootFromParent_Done,
     /*  358923 */   // Label 6534: @358923
     /*  358923 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(358986), // Rule ID 23201 //
     /*  358928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  358939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  358942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358967 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  358970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358984 */     GIR_RootConstrainSelectedInstOperands,
     /*  358985 */     // GIR_Coverage, 23201,
     /*  358985 */     GIR_EraseRootFromParent_Done,
     /*  358986 */   // Label 6535: @358986
     /*  358986 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(359049), // Rule ID 23202 //
     /*  358991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359030 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  359033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359047 */     GIR_RootConstrainSelectedInstOperands,
     /*  359048 */     // GIR_Coverage, 23202,
     /*  359048 */     GIR_EraseRootFromParent_Done,
     /*  359049 */   // Label 6536: @359049
     /*  359049 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(359112), // Rule ID 23203 //
     /*  359054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  359062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359093 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  359096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359110 */     GIR_RootConstrainSelectedInstOperands,
     /*  359111 */     // GIR_Coverage, 23203,
     /*  359111 */     GIR_EraseRootFromParent_Done,
     /*  359112 */   // Label 6537: @359112
     /*  359112 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(359175), // Rule ID 23204 //
     /*  359117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  359125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  359128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  359131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  359134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359156 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  359159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359173 */     GIR_RootConstrainSelectedInstOperands,
     /*  359174 */     // GIR_Coverage, 23204,
     /*  359174 */     GIR_EraseRootFromParent_Done,
     /*  359175 */   // Label 6538: @359175
     /*  359175 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(359238), // Rule ID 23205 //
     /*  359180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  359188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  359191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  359194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  359197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359219 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  359222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359236 */     GIR_RootConstrainSelectedInstOperands,
     /*  359237 */     // GIR_Coverage, 23205,
     /*  359237 */     GIR_EraseRootFromParent_Done,
     /*  359238 */   // Label 6539: @359238
     /*  359238 */   GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(359301), // Rule ID 23206 //
     /*  359243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  359254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  359257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  359260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359282 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  359285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359299 */     GIR_RootConstrainSelectedInstOperands,
     /*  359300 */     // GIR_Coverage, 23206,
     /*  359300 */     GIR_EraseRootFromParent_Done,
     /*  359301 */   // Label 6540: @359301
     /*  359301 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(359364), // Rule ID 23207 //
     /*  359306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  359317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  359320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  359323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359345 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  359348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359362 */     GIR_RootConstrainSelectedInstOperands,
     /*  359363 */     // GIR_Coverage, 23207,
     /*  359363 */     GIR_EraseRootFromParent_Done,
     /*  359364 */   // Label 6541: @359364
     /*  359364 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(359427), // Rule ID 23208 //
     /*  359369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  359380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  359383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  359386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359408 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  359411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359425 */     GIR_RootConstrainSelectedInstOperands,
     /*  359426 */     // GIR_Coverage, 23208,
     /*  359426 */     GIR_EraseRootFromParent_Done,
     /*  359427 */   // Label 6542: @359427
     /*  359427 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(359490), // Rule ID 23209 //
     /*  359432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  359443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  359446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  359449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359471 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  359474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359488 */     GIR_RootConstrainSelectedInstOperands,
     /*  359489 */     // GIR_Coverage, 23209,
     /*  359489 */     GIR_EraseRootFromParent_Done,
     /*  359490 */   // Label 6543: @359490
     /*  359490 */   GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(359553), // Rule ID 23210 //
     /*  359495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359534 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  359537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359551 */     GIR_RootConstrainSelectedInstOperands,
     /*  359552 */     // GIR_Coverage, 23210,
     /*  359552 */     GIR_EraseRootFromParent_Done,
     /*  359553 */   // Label 6544: @359553
     /*  359553 */   GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(359616), // Rule ID 23211 //
     /*  359558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359597 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  359600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359614 */     GIR_RootConstrainSelectedInstOperands,
     /*  359615 */     // GIR_Coverage, 23211,
     /*  359615 */     GIR_EraseRootFromParent_Done,
     /*  359616 */   // Label 6545: @359616
     /*  359616 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(359679), // Rule ID 23212 //
     /*  359621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  359632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  359635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  359638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359660 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  359663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359677 */     GIR_RootConstrainSelectedInstOperands,
     /*  359678 */     // GIR_Coverage, 23212,
     /*  359678 */     GIR_EraseRootFromParent_Done,
     /*  359679 */   // Label 6546: @359679
     /*  359679 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(359742), // Rule ID 23213 //
     /*  359684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  359695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  359698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  359701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359723 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  359726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359740 */     GIR_RootConstrainSelectedInstOperands,
     /*  359741 */     // GIR_Coverage, 23213,
     /*  359741 */     GIR_EraseRootFromParent_Done,
     /*  359742 */   // Label 6547: @359742
     /*  359742 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(359805), // Rule ID 23214 //
     /*  359747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  359758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  359761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  359764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359786 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  359789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359803 */     GIR_RootConstrainSelectedInstOperands,
     /*  359804 */     // GIR_Coverage, 23214,
     /*  359804 */     GIR_EraseRootFromParent_Done,
     /*  359805 */   // Label 6548: @359805
     /*  359805 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(359868), // Rule ID 23215 //
     /*  359810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  359821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  359824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  359827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359849 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  359852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359866 */     GIR_RootConstrainSelectedInstOperands,
     /*  359867 */     // GIR_Coverage, 23215,
     /*  359867 */     GIR_EraseRootFromParent_Done,
     /*  359868 */   // Label 6549: @359868
     /*  359868 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(359931), // Rule ID 23216 //
     /*  359873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359912 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  359915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359929 */     GIR_RootConstrainSelectedInstOperands,
     /*  359930 */     // GIR_Coverage, 23216,
     /*  359930 */     GIR_EraseRootFromParent_Done,
     /*  359931 */   // Label 6550: @359931
     /*  359931 */   GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(359994), // Rule ID 23217 //
     /*  359936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359975 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  359978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359992 */     GIR_RootConstrainSelectedInstOperands,
     /*  359993 */     // GIR_Coverage, 23217,
     /*  359993 */     GIR_EraseRootFromParent_Done,
     /*  359994 */   // Label 6551: @359994
     /*  359994 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(360057), // Rule ID 23218 //
     /*  359999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  360007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360038 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  360041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360055 */     GIR_RootConstrainSelectedInstOperands,
     /*  360056 */     // GIR_Coverage, 23218,
     /*  360056 */     GIR_EraseRootFromParent_Done,
     /*  360057 */   // Label 6552: @360057
     /*  360057 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(360120), // Rule ID 23219 //
     /*  360062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  360070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360101 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  360104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360118 */     GIR_RootConstrainSelectedInstOperands,
     /*  360119 */     // GIR_Coverage, 23219,
     /*  360119 */     GIR_EraseRootFromParent_Done,
     /*  360120 */   // Label 6553: @360120
     /*  360120 */   GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(360183), // Rule ID 23220 //
     /*  360125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360164 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  360167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360181 */     GIR_RootConstrainSelectedInstOperands,
     /*  360182 */     // GIR_Coverage, 23220,
     /*  360182 */     GIR_EraseRootFromParent_Done,
     /*  360183 */   // Label 6554: @360183
     /*  360183 */   GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(360246), // Rule ID 23221 //
     /*  360188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360227 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  360230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360244 */     GIR_RootConstrainSelectedInstOperands,
     /*  360245 */     // GIR_Coverage, 23221,
     /*  360245 */     GIR_EraseRootFromParent_Done,
     /*  360246 */   // Label 6555: @360246
     /*  360246 */   GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(360309), // Rule ID 23222 //
     /*  360251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360290 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  360293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360307 */     GIR_RootConstrainSelectedInstOperands,
     /*  360308 */     // GIR_Coverage, 23222,
     /*  360308 */     GIR_EraseRootFromParent_Done,
     /*  360309 */   // Label 6556: @360309
     /*  360309 */   GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(360372), // Rule ID 23223 //
     /*  360314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360353 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  360356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360370 */     GIR_RootConstrainSelectedInstOperands,
     /*  360371 */     // GIR_Coverage, 23223,
     /*  360371 */     GIR_EraseRootFromParent_Done,
     /*  360372 */   // Label 6557: @360372
     /*  360372 */   GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(360435), // Rule ID 23224 //
     /*  360377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360416 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  360419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360433 */     GIR_RootConstrainSelectedInstOperands,
     /*  360434 */     // GIR_Coverage, 23224,
     /*  360434 */     GIR_EraseRootFromParent_Done,
     /*  360435 */   // Label 6558: @360435
     /*  360435 */   GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(360498), // Rule ID 23225 //
     /*  360440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360479 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  360482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360496 */     GIR_RootConstrainSelectedInstOperands,
     /*  360497 */     // GIR_Coverage, 23225,
     /*  360497 */     GIR_EraseRootFromParent_Done,
     /*  360498 */   // Label 6559: @360498
     /*  360498 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(360561), // Rule ID 23226 //
     /*  360503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360542 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  360545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360559 */     GIR_RootConstrainSelectedInstOperands,
     /*  360560 */     // GIR_Coverage, 23226,
     /*  360560 */     GIR_EraseRootFromParent_Done,
     /*  360561 */   // Label 6560: @360561
     /*  360561 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(360624), // Rule ID 23227 //
     /*  360566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360605 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  360608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360622 */     GIR_RootConstrainSelectedInstOperands,
     /*  360623 */     // GIR_Coverage, 23227,
     /*  360623 */     GIR_EraseRootFromParent_Done,
     /*  360624 */   // Label 6561: @360624
     /*  360624 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(360687), // Rule ID 23228 //
     /*  360629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360668 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  360671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360685 */     GIR_RootConstrainSelectedInstOperands,
     /*  360686 */     // GIR_Coverage, 23228,
     /*  360686 */     GIR_EraseRootFromParent_Done,
     /*  360687 */   // Label 6562: @360687
     /*  360687 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(360750), // Rule ID 23229 //
     /*  360692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360731 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  360734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360748 */     GIR_RootConstrainSelectedInstOperands,
     /*  360749 */     // GIR_Coverage, 23229,
     /*  360749 */     GIR_EraseRootFromParent_Done,
     /*  360750 */   // Label 6563: @360750
     /*  360750 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(360813), // Rule ID 23230 //
     /*  360755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360794 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  360797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360811 */     GIR_RootConstrainSelectedInstOperands,
     /*  360812 */     // GIR_Coverage, 23230,
     /*  360812 */     GIR_EraseRootFromParent_Done,
     /*  360813 */   // Label 6564: @360813
     /*  360813 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(360876), // Rule ID 23231 //
     /*  360818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360857 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  360860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360874 */     GIR_RootConstrainSelectedInstOperands,
     /*  360875 */     // GIR_Coverage, 23231,
     /*  360875 */     GIR_EraseRootFromParent_Done,
     /*  360876 */   // Label 6565: @360876
     /*  360876 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(360939), // Rule ID 23232 //
     /*  360881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360920 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  360923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360937 */     GIR_RootConstrainSelectedInstOperands,
     /*  360938 */     // GIR_Coverage, 23232,
     /*  360938 */     GIR_EraseRootFromParent_Done,
     /*  360939 */   // Label 6566: @360939
     /*  360939 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(361002), // Rule ID 23233 //
     /*  360944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360983 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  360986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361000 */     GIR_RootConstrainSelectedInstOperands,
     /*  361001 */     // GIR_Coverage, 23233,
     /*  361001 */     GIR_EraseRootFromParent_Done,
     /*  361002 */   // Label 6567: @361002
     /*  361002 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(361065), // Rule ID 23234 //
     /*  361007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361046 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  361049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361063 */     GIR_RootConstrainSelectedInstOperands,
     /*  361064 */     // GIR_Coverage, 23234,
     /*  361064 */     GIR_EraseRootFromParent_Done,
     /*  361065 */   // Label 6568: @361065
     /*  361065 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(361128), // Rule ID 23235 //
     /*  361070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361109 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  361112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361126 */     GIR_RootConstrainSelectedInstOperands,
     /*  361127 */     // GIR_Coverage, 23235,
     /*  361127 */     GIR_EraseRootFromParent_Done,
     /*  361128 */   // Label 6569: @361128
     /*  361128 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(361191), // Rule ID 23236 //
     /*  361133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361172 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  361175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361189 */     GIR_RootConstrainSelectedInstOperands,
     /*  361190 */     // GIR_Coverage, 23236,
     /*  361190 */     GIR_EraseRootFromParent_Done,
     /*  361191 */   // Label 6570: @361191
     /*  361191 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(361254), // Rule ID 23237 //
     /*  361196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361235 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  361238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361252 */     GIR_RootConstrainSelectedInstOperands,
     /*  361253 */     // GIR_Coverage, 23237,
     /*  361253 */     GIR_EraseRootFromParent_Done,
     /*  361254 */   // Label 6571: @361254
     /*  361254 */   GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(361317), // Rule ID 23238 //
     /*  361259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361298 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  361301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361315 */     GIR_RootConstrainSelectedInstOperands,
     /*  361316 */     // GIR_Coverage, 23238,
     /*  361316 */     GIR_EraseRootFromParent_Done,
     /*  361317 */   // Label 6572: @361317
     /*  361317 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(361380), // Rule ID 23239 //
     /*  361322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361361 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  361364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361378 */     GIR_RootConstrainSelectedInstOperands,
     /*  361379 */     // GIR_Coverage, 23239,
     /*  361379 */     GIR_EraseRootFromParent_Done,
     /*  361380 */   // Label 6573: @361380
     /*  361380 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(361443), // Rule ID 23240 //
     /*  361385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361424 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  361427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361441 */     GIR_RootConstrainSelectedInstOperands,
     /*  361442 */     // GIR_Coverage, 23240,
     /*  361442 */     GIR_EraseRootFromParent_Done,
     /*  361443 */   // Label 6574: @361443
     /*  361443 */   GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(361506), // Rule ID 23241 //
     /*  361448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361487 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  361490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361504 */     GIR_RootConstrainSelectedInstOperands,
     /*  361505 */     // GIR_Coverage, 23241,
     /*  361505 */     GIR_EraseRootFromParent_Done,
     /*  361506 */   // Label 6575: @361506
     /*  361506 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(361569), // Rule ID 23242 //
     /*  361511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361550 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  361553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361567 */     GIR_RootConstrainSelectedInstOperands,
     /*  361568 */     // GIR_Coverage, 23242,
     /*  361568 */     GIR_EraseRootFromParent_Done,
     /*  361569 */   // Label 6576: @361569
     /*  361569 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(361632), // Rule ID 23243 //
     /*  361574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361613 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  361616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361630 */     GIR_RootConstrainSelectedInstOperands,
     /*  361631 */     // GIR_Coverage, 23243,
     /*  361631 */     GIR_EraseRootFromParent_Done,
     /*  361632 */   // Label 6577: @361632
     /*  361632 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(361695), // Rule ID 23244 //
     /*  361637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361676 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  361679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361693 */     GIR_RootConstrainSelectedInstOperands,
     /*  361694 */     // GIR_Coverage, 23244,
     /*  361694 */     GIR_EraseRootFromParent_Done,
     /*  361695 */   // Label 6578: @361695
     /*  361695 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(361758), // Rule ID 23245 //
     /*  361700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361739 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  361742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361756 */     GIR_RootConstrainSelectedInstOperands,
     /*  361757 */     // GIR_Coverage, 23245,
     /*  361757 */     GIR_EraseRootFromParent_Done,
     /*  361758 */   // Label 6579: @361758
     /*  361758 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(361821), // Rule ID 23246 //
     /*  361763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361802 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  361805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361819 */     GIR_RootConstrainSelectedInstOperands,
     /*  361820 */     // GIR_Coverage, 23246,
     /*  361820 */     GIR_EraseRootFromParent_Done,
     /*  361821 */   // Label 6580: @361821
     /*  361821 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(361884), // Rule ID 23247 //
     /*  361826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361865 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  361868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361882 */     GIR_RootConstrainSelectedInstOperands,
     /*  361883 */     // GIR_Coverage, 23247,
     /*  361883 */     GIR_EraseRootFromParent_Done,
     /*  361884 */   // Label 6581: @361884
     /*  361884 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(361947), // Rule ID 23248 //
     /*  361889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361928 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  361931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361945 */     GIR_RootConstrainSelectedInstOperands,
     /*  361946 */     // GIR_Coverage, 23248,
     /*  361946 */     GIR_EraseRootFromParent_Done,
     /*  361947 */   // Label 6582: @361947
     /*  361947 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(362010), // Rule ID 23249 //
     /*  361952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361991 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  361994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362008 */     GIR_RootConstrainSelectedInstOperands,
     /*  362009 */     // GIR_Coverage, 23249,
     /*  362009 */     GIR_EraseRootFromParent_Done,
     /*  362010 */   // Label 6583: @362010
     /*  362010 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(362073), // Rule ID 23250 //
     /*  362015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362054 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  362057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362071 */     GIR_RootConstrainSelectedInstOperands,
     /*  362072 */     // GIR_Coverage, 23250,
     /*  362072 */     GIR_EraseRootFromParent_Done,
     /*  362073 */   // Label 6584: @362073
     /*  362073 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(362136), // Rule ID 23251 //
     /*  362078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362117 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  362120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362134 */     GIR_RootConstrainSelectedInstOperands,
     /*  362135 */     // GIR_Coverage, 23251,
     /*  362135 */     GIR_EraseRootFromParent_Done,
     /*  362136 */   // Label 6585: @362136
     /*  362136 */   GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(362199), // Rule ID 23252 //
     /*  362141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  362183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362197 */     GIR_RootConstrainSelectedInstOperands,
     /*  362198 */     // GIR_Coverage, 23252,
     /*  362198 */     GIR_EraseRootFromParent_Done,
     /*  362199 */   // Label 6586: @362199
     /*  362199 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(362262), // Rule ID 23253 //
     /*  362204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362243 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  362246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362260 */     GIR_RootConstrainSelectedInstOperands,
     /*  362261 */     // GIR_Coverage, 23253,
     /*  362261 */     GIR_EraseRootFromParent_Done,
     /*  362262 */   // Label 6587: @362262
     /*  362262 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(362325), // Rule ID 23254 //
     /*  362267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362306 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  362309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362323 */     GIR_RootConstrainSelectedInstOperands,
     /*  362324 */     // GIR_Coverage, 23254,
     /*  362324 */     GIR_EraseRootFromParent_Done,
     /*  362325 */   // Label 6588: @362325
     /*  362325 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(362388), // Rule ID 23255 //
     /*  362330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362369 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  362372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362386 */     GIR_RootConstrainSelectedInstOperands,
     /*  362387 */     // GIR_Coverage, 23255,
     /*  362387 */     GIR_EraseRootFromParent_Done,
     /*  362388 */   // Label 6589: @362388
     /*  362388 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(362451), // Rule ID 23256 //
     /*  362393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362432 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  362435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362449 */     GIR_RootConstrainSelectedInstOperands,
     /*  362450 */     // GIR_Coverage, 23256,
     /*  362450 */     GIR_EraseRootFromParent_Done,
     /*  362451 */   // Label 6590: @362451
     /*  362451 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(362514), // Rule ID 23257 //
     /*  362456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362495 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  362498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362512 */     GIR_RootConstrainSelectedInstOperands,
     /*  362513 */     // GIR_Coverage, 23257,
     /*  362513 */     GIR_EraseRootFromParent_Done,
     /*  362514 */   // Label 6591: @362514
     /*  362514 */   GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(362577), // Rule ID 23258 //
     /*  362519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362558 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  362561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362575 */     GIR_RootConstrainSelectedInstOperands,
     /*  362576 */     // GIR_Coverage, 23258,
     /*  362576 */     GIR_EraseRootFromParent_Done,
     /*  362577 */   // Label 6592: @362577
     /*  362577 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(362640), // Rule ID 23259 //
     /*  362582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362621 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  362624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362638 */     GIR_RootConstrainSelectedInstOperands,
     /*  362639 */     // GIR_Coverage, 23259,
     /*  362639 */     GIR_EraseRootFromParent_Done,
     /*  362640 */   // Label 6593: @362640
     /*  362640 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(362703), // Rule ID 23260 //
     /*  362645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362684 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  362687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362701 */     GIR_RootConstrainSelectedInstOperands,
     /*  362702 */     // GIR_Coverage, 23260,
     /*  362702 */     GIR_EraseRootFromParent_Done,
     /*  362703 */   // Label 6594: @362703
     /*  362703 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(362766), // Rule ID 23261 //
     /*  362708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362747 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  362750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362764 */     GIR_RootConstrainSelectedInstOperands,
     /*  362765 */     // GIR_Coverage, 23261,
     /*  362765 */     GIR_EraseRootFromParent_Done,
     /*  362766 */   // Label 6595: @362766
     /*  362766 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(362829), // Rule ID 23262 //
     /*  362771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  362782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  362785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  362788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362810 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  362813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362827 */     GIR_RootConstrainSelectedInstOperands,
     /*  362828 */     // GIR_Coverage, 23262,
     /*  362828 */     GIR_EraseRootFromParent_Done,
     /*  362829 */   // Label 6596: @362829
     /*  362829 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(362892), // Rule ID 23263 //
     /*  362834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  362845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  362848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  362851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362873 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  362876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362890 */     GIR_RootConstrainSelectedInstOperands,
     /*  362891 */     // GIR_Coverage, 23263,
     /*  362891 */     GIR_EraseRootFromParent_Done,
     /*  362892 */   // Label 6597: @362892
     /*  362892 */   GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(362955), // Rule ID 23264 //
     /*  362897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362936 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  362939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362953 */     GIR_RootConstrainSelectedInstOperands,
     /*  362954 */     // GIR_Coverage, 23264,
     /*  362954 */     GIR_EraseRootFromParent_Done,
     /*  362955 */   // Label 6598: @362955
     /*  362955 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(363018), // Rule ID 23265 //
     /*  362960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362999 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  363002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363016 */     GIR_RootConstrainSelectedInstOperands,
     /*  363017 */     // GIR_Coverage, 23265,
     /*  363017 */     GIR_EraseRootFromParent_Done,
     /*  363018 */   // Label 6599: @363018
     /*  363018 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(363081), // Rule ID 23266 //
     /*  363023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  363034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363062 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  363065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363079 */     GIR_RootConstrainSelectedInstOperands,
     /*  363080 */     // GIR_Coverage, 23266,
     /*  363080 */     GIR_EraseRootFromParent_Done,
     /*  363081 */   // Label 6600: @363081
     /*  363081 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(363144), // Rule ID 23267 //
     /*  363086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  363097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363125 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  363128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363142 */     GIR_RootConstrainSelectedInstOperands,
     /*  363143 */     // GIR_Coverage, 23267,
     /*  363143 */     GIR_EraseRootFromParent_Done,
     /*  363144 */   // Label 6601: @363144
     /*  363144 */   GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(363207), // Rule ID 23268 //
     /*  363149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  363160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363188 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  363191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363205 */     GIR_RootConstrainSelectedInstOperands,
     /*  363206 */     // GIR_Coverage, 23268,
     /*  363206 */     GIR_EraseRootFromParent_Done,
     /*  363207 */   // Label 6602: @363207
     /*  363207 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(363270), // Rule ID 23269 //
     /*  363212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  363223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363251 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  363254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363268 */     GIR_RootConstrainSelectedInstOperands,
     /*  363269 */     // GIR_Coverage, 23269,
     /*  363269 */     GIR_EraseRootFromParent_Done,
     /*  363270 */   // Label 6603: @363270
     /*  363270 */   GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(363333), // Rule ID 23270 //
     /*  363275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  363286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363314 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  363317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363331 */     GIR_RootConstrainSelectedInstOperands,
     /*  363332 */     // GIR_Coverage, 23270,
     /*  363332 */     GIR_EraseRootFromParent_Done,
     /*  363333 */   // Label 6604: @363333
     /*  363333 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(363396), // Rule ID 23271 //
     /*  363338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  363349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363377 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  363380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363394 */     GIR_RootConstrainSelectedInstOperands,
     /*  363395 */     // GIR_Coverage, 23271,
     /*  363395 */     GIR_EraseRootFromParent_Done,
     /*  363396 */   // Label 6605: @363396
     /*  363396 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(363459), // Rule ID 23272 //
     /*  363401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  363412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363440 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  363443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363457 */     GIR_RootConstrainSelectedInstOperands,
     /*  363458 */     // GIR_Coverage, 23272,
     /*  363458 */     GIR_EraseRootFromParent_Done,
     /*  363459 */   // Label 6606: @363459
     /*  363459 */   GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(363522), // Rule ID 23273 //
     /*  363464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  363475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363503 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  363506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363520 */     GIR_RootConstrainSelectedInstOperands,
     /*  363521 */     // GIR_Coverage, 23273,
     /*  363521 */     GIR_EraseRootFromParent_Done,
     /*  363522 */   // Label 6607: @363522
     /*  363522 */   GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(363585), // Rule ID 23274 //
     /*  363527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  363538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363566 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  363569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363583 */     GIR_RootConstrainSelectedInstOperands,
     /*  363584 */     // GIR_Coverage, 23274,
     /*  363584 */     GIR_EraseRootFromParent_Done,
     /*  363585 */   // Label 6608: @363585
     /*  363585 */   GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(363648), // Rule ID 23275 //
     /*  363590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  363601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363629 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11536:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  363632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363646 */     GIR_RootConstrainSelectedInstOperands,
     /*  363647 */     // GIR_Coverage, 23275,
     /*  363647 */     GIR_EraseRootFromParent_Done,
     /*  363648 */   // Label 6609: @363648
     /*  363648 */   GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(363711), // Rule ID 23304 //
     /*  363653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363692 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  363695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363699 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363709 */     GIR_RootConstrainSelectedInstOperands,
     /*  363710 */     // GIR_Coverage, 23304,
     /*  363710 */     GIR_EraseRootFromParent_Done,
     /*  363711 */   // Label 6610: @363711
     /*  363711 */   GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(363774), // Rule ID 23305 //
     /*  363716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363755 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  363758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363762 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363772 */     GIR_RootConstrainSelectedInstOperands,
     /*  363773 */     // GIR_Coverage, 23305,
     /*  363773 */     GIR_EraseRootFromParent_Done,
     /*  363774 */   // Label 6611: @363774
     /*  363774 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(363837), // Rule ID 23308 //
     /*  363779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363818 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  363821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363825 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363835 */     GIR_RootConstrainSelectedInstOperands,
     /*  363836 */     // GIR_Coverage, 23308,
     /*  363836 */     GIR_EraseRootFromParent_Done,
     /*  363837 */   // Label 6612: @363837
     /*  363837 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(363900), // Rule ID 23309 //
     /*  363842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363881 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  363884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363888 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363898 */     GIR_RootConstrainSelectedInstOperands,
     /*  363899 */     // GIR_Coverage, 23309,
     /*  363899 */     GIR_EraseRootFromParent_Done,
     /*  363900 */   // Label 6613: @363900
     /*  363900 */   GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(363963), // Rule ID 23312 //
     /*  363905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363944 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  363947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363951 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363961 */     GIR_RootConstrainSelectedInstOperands,
     /*  363962 */     // GIR_Coverage, 23312,
     /*  363962 */     GIR_EraseRootFromParent_Done,
     /*  363963 */   // Label 6614: @363963
     /*  363963 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(364026), // Rule ID 23313 //
     /*  363968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364007 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  364010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364014 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364024 */     GIR_RootConstrainSelectedInstOperands,
     /*  364025 */     // GIR_Coverage, 23313,
     /*  364025 */     GIR_EraseRootFromParent_Done,
     /*  364026 */   // Label 6615: @364026
     /*  364026 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(364089), // Rule ID 23316 //
     /*  364031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  364039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364070 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  364073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364077 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364087 */     GIR_RootConstrainSelectedInstOperands,
     /*  364088 */     // GIR_Coverage, 23316,
     /*  364088 */     GIR_EraseRootFromParent_Done,
     /*  364089 */   // Label 6616: @364089
     /*  364089 */   GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(364152), // Rule ID 23317 //
     /*  364094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  364102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364133 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  364136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364140 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364150 */     GIR_RootConstrainSelectedInstOperands,
     /*  364151 */     // GIR_Coverage, 23317,
     /*  364151 */     GIR_EraseRootFromParent_Done,
     /*  364152 */   // Label 6617: @364152
     /*  364152 */   GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(364215), // Rule ID 23320 //
     /*  364157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  364165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364196 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  364199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364203 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364213 */     GIR_RootConstrainSelectedInstOperands,
     /*  364214 */     // GIR_Coverage, 23320,
     /*  364214 */     GIR_EraseRootFromParent_Done,
     /*  364215 */   // Label 6618: @364215
     /*  364215 */   GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(364278), // Rule ID 23321 //
     /*  364220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  364228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364259 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  364262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364266 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364276 */     GIR_RootConstrainSelectedInstOperands,
     /*  364277 */     // GIR_Coverage, 23321,
     /*  364277 */     GIR_EraseRootFromParent_Done,
     /*  364278 */   // Label 6619: @364278
     /*  364278 */   GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(364341), // Rule ID 23324 //
     /*  364283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  364291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364322 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  364325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364329 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364339 */     GIR_RootConstrainSelectedInstOperands,
     /*  364340 */     // GIR_Coverage, 23324,
     /*  364340 */     GIR_EraseRootFromParent_Done,
     /*  364341 */   // Label 6620: @364341
     /*  364341 */   GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(364404), // Rule ID 23325 //
     /*  364346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  364354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364385 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  364388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364392 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364402 */     GIR_RootConstrainSelectedInstOperands,
     /*  364403 */     // GIR_Coverage, 23325,
     /*  364403 */     GIR_EraseRootFromParent_Done,
     /*  364404 */   // Label 6621: @364404
     /*  364404 */   GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(364467), // Rule ID 23328 //
     /*  364409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  364423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364448 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  364451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364455 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364465 */     GIR_RootConstrainSelectedInstOperands,
     /*  364466 */     // GIR_Coverage, 23328,
     /*  364466 */     GIR_EraseRootFromParent_Done,
     /*  364467 */   // Label 6622: @364467
     /*  364467 */   GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(364530), // Rule ID 23329 //
     /*  364472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  364486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364511 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  364514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364518 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364528 */     GIR_RootConstrainSelectedInstOperands,
     /*  364529 */     // GIR_Coverage, 23329,
     /*  364529 */     GIR_EraseRootFromParent_Done,
     /*  364530 */   // Label 6623: @364530
     /*  364530 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(364593), // Rule ID 23332 //
     /*  364535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  364549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364574 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  364577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364581 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364591 */     GIR_RootConstrainSelectedInstOperands,
     /*  364592 */     // GIR_Coverage, 23332,
     /*  364592 */     GIR_EraseRootFromParent_Done,
     /*  364593 */   // Label 6624: @364593
     /*  364593 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(364656), // Rule ID 23333 //
     /*  364598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  364612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364637 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  364640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364644 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364654 */     GIR_RootConstrainSelectedInstOperands,
     /*  364655 */     // GIR_Coverage, 23333,
     /*  364655 */     GIR_EraseRootFromParent_Done,
     /*  364656 */   // Label 6625: @364656
     /*  364656 */   GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(364719), // Rule ID 23336 //
     /*  364661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  364675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364700 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  364703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364707 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364717 */     GIR_RootConstrainSelectedInstOperands,
     /*  364718 */     // GIR_Coverage, 23336,
     /*  364718 */     GIR_EraseRootFromParent_Done,
     /*  364719 */   // Label 6626: @364719
     /*  364719 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(364782), // Rule ID 23337 //
     /*  364724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  364738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364763 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  364766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364770 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364780 */     GIR_RootConstrainSelectedInstOperands,
     /*  364781 */     // GIR_Coverage, 23337,
     /*  364781 */     GIR_EraseRootFromParent_Done,
     /*  364782 */   // Label 6627: @364782
     /*  364782 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(364845), // Rule ID 23340 //
     /*  364787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  364801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364826 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  364829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364833 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364843 */     GIR_RootConstrainSelectedInstOperands,
     /*  364844 */     // GIR_Coverage, 23340,
     /*  364844 */     GIR_EraseRootFromParent_Done,
     /*  364845 */   // Label 6628: @364845
     /*  364845 */   GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(364908), // Rule ID 23341 //
     /*  364850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  364864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364889 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  364892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364896 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364906 */     GIR_RootConstrainSelectedInstOperands,
     /*  364907 */     // GIR_Coverage, 23341,
     /*  364907 */     GIR_EraseRootFromParent_Done,
     /*  364908 */   // Label 6629: @364908
     /*  364908 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(364971), // Rule ID 23344 //
     /*  364913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364952 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  364955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364959 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364969 */     GIR_RootConstrainSelectedInstOperands,
     /*  364970 */     // GIR_Coverage, 23344,
     /*  364970 */     GIR_EraseRootFromParent_Done,
     /*  364971 */   // Label 6630: @364971
     /*  364971 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(365034), // Rule ID 23345 //
     /*  364976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  365000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  365008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365015 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  365018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365022 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  365024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365032 */     GIR_RootConstrainSelectedInstOperands,
     /*  365033 */     // GIR_Coverage, 23345,
     /*  365033 */     GIR_EraseRootFromParent_Done,
     /*  365034 */   // Label 6631: @365034
     /*  365034 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(365097), // Rule ID 23348 //
     /*  365039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  365042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  365047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  365050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  365053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  365063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  365071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365078 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  365081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365085 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  365087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365095 */     GIR_RootConstrainSelectedInstOperands,
     /*  365096 */     // GIR_Coverage, 23348,
     /*  365096 */     GIR_EraseRootFromParent_Done,
     /*  365097 */   // Label 6632: @365097
     /*  365097 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(365160), // Rule ID 23349 //
     /*  365102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  365105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  365110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  365113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  365116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  365126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  365134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365141 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  365144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365148 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  365150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365158 */     GIR_RootConstrainSelectedInstOperands,
     /*  365159 */     // GIR_Coverage, 23349,
     /*  365159 */     GIR_EraseRootFromParent_Done,
     /*  365160 */   // Label 6633: @365160
     /*  365160 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(365223), // Rule ID 23352 //
     /*  365165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  365168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  365173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  365176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  365179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  365182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  365189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  365197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365204 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  365207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365211 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  365213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365221 */     GIR_RootConstrainSelectedInstOperands,
     /*  365222 */     // GIR_Coverage, 23352,
     /*  365222 */     GIR_EraseRootFromParent_Done,
     /*  365223 */   // Label 6634: @365223
     /*  365223 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(365286), // Rule ID 23353 //
     /*  365228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  365231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  365236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  365239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  365242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  365245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  365252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  365260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365267 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  365270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365274 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  365276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365284 */     GIR_RootConstrainSelectedInstOperands,
     /*  365285 */     // GIR_Coverage, 23353,
     /*  365285 */     GIR_EraseRootFromParent_Done,
     /*  365286 */   // Label 6635: @365286
     /*  365286 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(365352), // Rule ID 23434 //
     /*  365291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  365302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  365305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365330 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  365333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365350 */     GIR_RootConstrainSelectedInstOperands,
     /*  365351 */     // GIR_Coverage, 23434,
     /*  365351 */     GIR_EraseRootFromParent_Done,
     /*  365352 */   // Label 6636: @365352
     /*  365352 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(365418), // Rule ID 23435 //
     /*  365357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  365368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  365371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  365396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  365399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365416 */     GIR_RootConstrainSelectedInstOperands,
     /*  365417 */     // GIR_Coverage, 23435,
     /*  365417 */     GIR_EraseRootFromParent_Done,
     /*  365418 */   // Label 6637: @365418
     /*  365418 */   GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(365484), // Rule ID 23438 //
     /*  365423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  365434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  365437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365462 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365482 */     GIR_RootConstrainSelectedInstOperands,
     /*  365483 */     // GIR_Coverage, 23438,
     /*  365483 */     GIR_EraseRootFromParent_Done,
     /*  365484 */   // Label 6638: @365484
     /*  365484 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(365550), // Rule ID 23439 //
     /*  365489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  365500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  365503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365528 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  365528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365548 */     GIR_RootConstrainSelectedInstOperands,
     /*  365549 */     // GIR_Coverage, 23439,
     /*  365549 */     GIR_EraseRootFromParent_Done,
     /*  365550 */   // Label 6639: @365550
     /*  365550 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(365616), // Rule ID 23442 //
     /*  365555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  365566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  365569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365594 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  365594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  365597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365614 */     GIR_RootConstrainSelectedInstOperands,
     /*  365615 */     // GIR_Coverage, 23442,
     /*  365615 */     GIR_EraseRootFromParent_Done,
     /*  365616 */   // Label 6640: @365616
     /*  365616 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(365682), // Rule ID 23443 //
     /*  365621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  365632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  365635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365660 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  365660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  365663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365680 */     GIR_RootConstrainSelectedInstOperands,
     /*  365681 */     // GIR_Coverage, 23443,
     /*  365681 */     GIR_EraseRootFromParent_Done,
     /*  365682 */   // Label 6641: @365682
     /*  365682 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(365748), // Rule ID 23446 //
     /*  365687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  365698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  365701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  365726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365746 */     GIR_RootConstrainSelectedInstOperands,
     /*  365747 */     // GIR_Coverage, 23446,
     /*  365747 */     GIR_EraseRootFromParent_Done,
     /*  365748 */   // Label 6642: @365748
     /*  365748 */   GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(365814), // Rule ID 23447 //
     /*  365753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  365764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  365767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  365792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365812 */     GIR_RootConstrainSelectedInstOperands,
     /*  365813 */     // GIR_Coverage, 23447,
     /*  365813 */     GIR_EraseRootFromParent_Done,
     /*  365814 */   // Label 6643: @365814
     /*  365814 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(365880), // Rule ID 23450 //
     /*  365819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  365830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  365833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365858 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  365858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365878 */     GIR_RootConstrainSelectedInstOperands,
     /*  365879 */     // GIR_Coverage, 23450,
     /*  365879 */     GIR_EraseRootFromParent_Done,
     /*  365880 */   // Label 6644: @365880
     /*  365880 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(365946), // Rule ID 23451 //
     /*  365885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  365896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  365899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  365924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365944 */     GIR_RootConstrainSelectedInstOperands,
     /*  365945 */     // GIR_Coverage, 23451,
     /*  365945 */     GIR_EraseRootFromParent_Done,
     /*  365946 */   // Label 6645: @365946
     /*  365946 */   GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(366012), // Rule ID 23454 //
     /*  365951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  365962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  365965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366010 */     GIR_RootConstrainSelectedInstOperands,
     /*  366011 */     // GIR_Coverage, 23454,
     /*  366011 */     GIR_EraseRootFromParent_Done,
     /*  366012 */   // Label 6646: @366012
     /*  366012 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(366078), // Rule ID 23455 //
     /*  366017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  366028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  366031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366056 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366076 */     GIR_RootConstrainSelectedInstOperands,
     /*  366077 */     // GIR_Coverage, 23455,
     /*  366077 */     GIR_EraseRootFromParent_Done,
     /*  366078 */   // Label 6647: @366078
     /*  366078 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(366144), // Rule ID 23458 //
     /*  366083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  366094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  366097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366122 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  366122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366142 */     GIR_RootConstrainSelectedInstOperands,
     /*  366143 */     // GIR_Coverage, 23458,
     /*  366143 */     GIR_EraseRootFromParent_Done,
     /*  366144 */   // Label 6648: @366144
     /*  366144 */   GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(366210), // Rule ID 23459 //
     /*  366149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  366160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  366163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366188 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  366188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366208 */     GIR_RootConstrainSelectedInstOperands,
     /*  366209 */     // GIR_Coverage, 23459,
     /*  366209 */     GIR_EraseRootFromParent_Done,
     /*  366210 */   // Label 6649: @366210
     /*  366210 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(366276), // Rule ID 23462 //
     /*  366215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  366226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  366229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  366232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366254 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  366254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366274 */     GIR_RootConstrainSelectedInstOperands,
     /*  366275 */     // GIR_Coverage, 23462,
     /*  366275 */     GIR_EraseRootFromParent_Done,
     /*  366276 */   // Label 6650: @366276
     /*  366276 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(366342), // Rule ID 23463 //
     /*  366281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  366292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  366295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  366298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  366320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366340 */     GIR_RootConstrainSelectedInstOperands,
     /*  366341 */     // GIR_Coverage, 23463,
     /*  366341 */     GIR_EraseRootFromParent_Done,
     /*  366342 */   // Label 6651: @366342
     /*  366342 */   GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(366408), // Rule ID 23466 //
     /*  366347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  366350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  366358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  366361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  366364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366386 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  366386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  366403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366406 */     GIR_RootConstrainSelectedInstOperands,
     /*  366407 */     // GIR_Coverage, 23466,
     /*  366407 */     GIR_EraseRootFromParent_Done,
     /*  366408 */   // Label 6652: @366408
     /*  366408 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(366474), // Rule ID 23467 //
     /*  366413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  366416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  366424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  366427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  366430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366452 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  366452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  366469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366472 */     GIR_RootConstrainSelectedInstOperands,
     /*  366473 */     // GIR_Coverage, 23467,
     /*  366473 */     GIR_EraseRootFromParent_Done,
     /*  366474 */   // Label 6653: @366474
     /*  366474 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(366540), // Rule ID 23470 //
     /*  366479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  366490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  366493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366518 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366538 */     GIR_RootConstrainSelectedInstOperands,
     /*  366539 */     // GIR_Coverage, 23470,
     /*  366539 */     GIR_EraseRootFromParent_Done,
     /*  366540 */   // Label 6654: @366540
     /*  366540 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(366606), // Rule ID 23471 //
     /*  366545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  366556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  366559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366604 */     GIR_RootConstrainSelectedInstOperands,
     /*  366605 */     // GIR_Coverage, 23471,
     /*  366605 */     GIR_EraseRootFromParent_Done,
     /*  366606 */   // Label 6655: @366606
     /*  366606 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(366672), // Rule ID 23474 //
     /*  366611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  366622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  366625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366650 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366670 */     GIR_RootConstrainSelectedInstOperands,
     /*  366671 */     // GIR_Coverage, 23474,
     /*  366671 */     GIR_EraseRootFromParent_Done,
     /*  366672 */   // Label 6656: @366672
     /*  366672 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(366738), // Rule ID 23475 //
     /*  366677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  366688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  366691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366716 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366736 */     GIR_RootConstrainSelectedInstOperands,
     /*  366737 */     // GIR_Coverage, 23475,
     /*  366737 */     GIR_EraseRootFromParent_Done,
     /*  366738 */   // Label 6657: @366738
     /*  366738 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(366804), // Rule ID 23478 //
     /*  366743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  366754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  366757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366782 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366802 */     GIR_RootConstrainSelectedInstOperands,
     /*  366803 */     // GIR_Coverage, 23478,
     /*  366803 */     GIR_EraseRootFromParent_Done,
     /*  366804 */   // Label 6658: @366804
     /*  366804 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(366870), // Rule ID 23479 //
     /*  366809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  366820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  366823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366848 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366868 */     GIR_RootConstrainSelectedInstOperands,
     /*  366869 */     // GIR_Coverage, 23479,
     /*  366869 */     GIR_EraseRootFromParent_Done,
     /*  366870 */   // Label 6659: @366870
     /*  366870 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(366936), // Rule ID 23482 //
     /*  366875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  366886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  366889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  366914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366934 */     GIR_RootConstrainSelectedInstOperands,
     /*  366935 */     // GIR_Coverage, 23482,
     /*  366935 */     GIR_EraseRootFromParent_Done,
     /*  366936 */   // Label 6660: @366936
     /*  366936 */   GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(367002), // Rule ID 23483 //
     /*  366941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  366952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  366955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366980 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  366980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367000 */     GIR_RootConstrainSelectedInstOperands,
     /*  367001 */     // GIR_Coverage, 23483,
     /*  367001 */     GIR_EraseRootFromParent_Done,
     /*  367002 */   // Label 6661: @367002
     /*  367002 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(367068), // Rule ID 23486 //
     /*  367007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  367018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  367021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367046 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  367046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367066 */     GIR_RootConstrainSelectedInstOperands,
     /*  367067 */     // GIR_Coverage, 23486,
     /*  367067 */     GIR_EraseRootFromParent_Done,
     /*  367068 */   // Label 6662: @367068
     /*  367068 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(367134), // Rule ID 23487 //
     /*  367073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  367084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  367087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367112 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  367112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367132 */     GIR_RootConstrainSelectedInstOperands,
     /*  367133 */     // GIR_Coverage, 23487,
     /*  367133 */     GIR_EraseRootFromParent_Done,
     /*  367134 */   // Label 6663: @367134
     /*  367134 */   GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(367200), // Rule ID 23490 //
     /*  367139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  367150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  367153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  367156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367178 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  367178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367198 */     GIR_RootConstrainSelectedInstOperands,
     /*  367199 */     // GIR_Coverage, 23490,
     /*  367199 */     GIR_EraseRootFromParent_Done,
     /*  367200 */   // Label 6664: @367200
     /*  367200 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(367266), // Rule ID 23491 //
     /*  367205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  367216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  367219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  367222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367244 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  367244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367264 */     GIR_RootConstrainSelectedInstOperands,
     /*  367265 */     // GIR_Coverage, 23491,
     /*  367265 */     GIR_EraseRootFromParent_Done,
     /*  367266 */   // Label 6665: @367266
     /*  367266 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(367332), // Rule ID 23494 //
     /*  367271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  367282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  367285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367310 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  367310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  367313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367330 */     GIR_RootConstrainSelectedInstOperands,
     /*  367331 */     // GIR_Coverage, 23494,
     /*  367331 */     GIR_EraseRootFromParent_Done,
     /*  367332 */   // Label 6666: @367332
     /*  367332 */   GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(367398), // Rule ID 23495 //
     /*  367337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  367348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  367351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  367376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  367379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367396 */     GIR_RootConstrainSelectedInstOperands,
     /*  367397 */     // GIR_Coverage, 23495,
     /*  367397 */     GIR_EraseRootFromParent_Done,
     /*  367398 */   // Label 6667: @367398
     /*  367398 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(367464), // Rule ID 23498 //
     /*  367403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  367414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  367417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367442 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  367442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367462 */     GIR_RootConstrainSelectedInstOperands,
     /*  367463 */     // GIR_Coverage, 23498,
     /*  367463 */     GIR_EraseRootFromParent_Done,
     /*  367464 */   // Label 6668: @367464
     /*  367464 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(367530), // Rule ID 23499 //
     /*  367469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  367480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  367483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  367508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367528 */     GIR_RootConstrainSelectedInstOperands,
     /*  367529 */     // GIR_Coverage, 23499,
     /*  367529 */     GIR_EraseRootFromParent_Done,
     /*  367530 */   // Label 6669: @367530
     /*  367530 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(367596), // Rule ID 23502 //
     /*  367535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  367546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  367549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367574 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  367574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367594 */     GIR_RootConstrainSelectedInstOperands,
     /*  367595 */     // GIR_Coverage, 23502,
     /*  367595 */     GIR_EraseRootFromParent_Done,
     /*  367596 */   // Label 6670: @367596
     /*  367596 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(367662), // Rule ID 23503 //
     /*  367601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  367612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  367615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  367640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367660 */     GIR_RootConstrainSelectedInstOperands,
     /*  367661 */     // GIR_Coverage, 23503,
     /*  367661 */     GIR_EraseRootFromParent_Done,
     /*  367662 */   // Label 6671: @367662
     /*  367662 */   GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(367728), // Rule ID 23506 //
     /*  367667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  367670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  367678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  367681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367706 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  367706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  367709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367726 */     GIR_RootConstrainSelectedInstOperands,
     /*  367727 */     // GIR_Coverage, 23506,
     /*  367727 */     GIR_EraseRootFromParent_Done,
     /*  367728 */   // Label 6672: @367728
     /*  367728 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(367794), // Rule ID 23507 //
     /*  367733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  367736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  367744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  367747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367772 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  367772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  367775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367792 */     GIR_RootConstrainSelectedInstOperands,
     /*  367793 */     // GIR_Coverage, 23507,
     /*  367793 */     GIR_EraseRootFromParent_Done,
     /*  367794 */   // Label 6673: @367794
     /*  367794 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(367860), // Rule ID 23510 //
     /*  367799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  367802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  367810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  367813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  367838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367858 */     GIR_RootConstrainSelectedInstOperands,
     /*  367859 */     // GIR_Coverage, 23510,
     /*  367859 */     GIR_EraseRootFromParent_Done,
     /*  367860 */   // Label 6674: @367860
     /*  367860 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(367926), // Rule ID 23511 //
     /*  367865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  367868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  367876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  367879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367904 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  367904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367924 */     GIR_RootConstrainSelectedInstOperands,
     /*  367925 */     // GIR_Coverage, 23511,
     /*  367925 */     GIR_EraseRootFromParent_Done,
     /*  367926 */   // Label 6675: @367926
     /*  367926 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(367992), // Rule ID 23514 //
     /*  367931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  367934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  367942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  367945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367970 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  367970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367990 */     GIR_RootConstrainSelectedInstOperands,
     /*  367991 */     // GIR_Coverage, 23514,
     /*  367991 */     GIR_EraseRootFromParent_Done,
     /*  367992 */   // Label 6676: @367992
     /*  367992 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(368058), // Rule ID 23515 //
     /*  367997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  368000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  368008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  368011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  368014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  368021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  368025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368036 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  368036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  368039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  368053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368056 */     GIR_RootConstrainSelectedInstOperands,
     /*  368057 */     // GIR_Coverage, 23515,
     /*  368057 */     GIR_EraseRootFromParent_Done,
     /*  368058 */   // Label 6677: @368058
     /*  368058 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(368124), // Rule ID 60630 //
     /*  368063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  368074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  368077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  368080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368102 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  368105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368122 */     GIR_RootConstrainSelectedInstOperands,
     /*  368123 */     // GIR_Coverage, 60630,
     /*  368123 */     GIR_EraseRootFromParent_Done,
     /*  368124 */   // Label 6678: @368124
     /*  368124 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(368190), // Rule ID 60631 //
     /*  368129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  368140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  368143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  368146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368168 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  368171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368188 */     GIR_RootConstrainSelectedInstOperands,
     /*  368189 */     // GIR_Coverage, 60631,
     /*  368189 */     GIR_EraseRootFromParent_Done,
     /*  368190 */   // Label 6679: @368190
     /*  368190 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(368256), // Rule ID 60634 //
     /*  368195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  368206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  368209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  368212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368234 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  368237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368254 */     GIR_RootConstrainSelectedInstOperands,
     /*  368255 */     // GIR_Coverage, 60634,
     /*  368255 */     GIR_EraseRootFromParent_Done,
     /*  368256 */   // Label 6680: @368256
     /*  368256 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(368322), // Rule ID 60635 //
     /*  368261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  368272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  368275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  368278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368300 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  368303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368320 */     GIR_RootConstrainSelectedInstOperands,
     /*  368321 */     // GIR_Coverage, 60635,
     /*  368321 */     GIR_EraseRootFromParent_Done,
     /*  368322 */   // Label 6681: @368322
     /*  368322 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(368388), // Rule ID 60638 //
     /*  368327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  368338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  368341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  368344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368366 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368386 */     GIR_RootConstrainSelectedInstOperands,
     /*  368387 */     // GIR_Coverage, 60638,
     /*  368387 */     GIR_EraseRootFromParent_Done,
     /*  368388 */   // Label 6682: @368388
     /*  368388 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(368454), // Rule ID 60639 //
     /*  368393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  368404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  368407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  368410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368432 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368452 */     GIR_RootConstrainSelectedInstOperands,
     /*  368453 */     // GIR_Coverage, 60639,
     /*  368453 */     GIR_EraseRootFromParent_Done,
     /*  368454 */   // Label 6683: @368454
     /*  368454 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(368520), // Rule ID 60642 //
     /*  368459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  368470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  368473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  368476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368498 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  368501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368518 */     GIR_RootConstrainSelectedInstOperands,
     /*  368519 */     // GIR_Coverage, 60642,
     /*  368519 */     GIR_EraseRootFromParent_Done,
     /*  368520 */   // Label 6684: @368520
     /*  368520 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(368586), // Rule ID 60643 //
     /*  368525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  368536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  368539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  368542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368564 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  368564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  368567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368584 */     GIR_RootConstrainSelectedInstOperands,
     /*  368585 */     // GIR_Coverage, 60643,
     /*  368585 */     GIR_EraseRootFromParent_Done,
     /*  368586 */   // Label 6685: @368586
     /*  368586 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(368652), // Rule ID 60646 //
     /*  368591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  368602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  368605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  368608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368630 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368650 */     GIR_RootConstrainSelectedInstOperands,
     /*  368651 */     // GIR_Coverage, 60646,
     /*  368651 */     GIR_EraseRootFromParent_Done,
     /*  368652 */   // Label 6686: @368652
     /*  368652 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(368718), // Rule ID 60647 //
     /*  368657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  368668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  368671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  368674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  368696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368716 */     GIR_RootConstrainSelectedInstOperands,
     /*  368717 */     // GIR_Coverage, 60647,
     /*  368717 */     GIR_EraseRootFromParent_Done,
     /*  368718 */   // Label 6687: @368718
     /*  368718 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(368784), // Rule ID 60650 //
     /*  368723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  368734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  368737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  368740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368762 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  368762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368782 */     GIR_RootConstrainSelectedInstOperands,
     /*  368783 */     // GIR_Coverage, 60650,
     /*  368783 */     GIR_EraseRootFromParent_Done,
     /*  368784 */   // Label 6688: @368784
     /*  368784 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(368850), // Rule ID 60651 //
     /*  368789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  368800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  368803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  368806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368828 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  368828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368848 */     GIR_RootConstrainSelectedInstOperands,
     /*  368849 */     // GIR_Coverage, 60651,
     /*  368849 */     GIR_EraseRootFromParent_Done,
     /*  368850 */   // Label 6689: @368850
     /*  368850 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(368916), // Rule ID 60654 //
     /*  368855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  368866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  368869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  368872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368894 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368914 */     GIR_RootConstrainSelectedInstOperands,
     /*  368915 */     // GIR_Coverage, 60654,
     /*  368915 */     GIR_EraseRootFromParent_Done,
     /*  368916 */   // Label 6690: @368916
     /*  368916 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(368982), // Rule ID 60655 //
     /*  368921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  368932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  368935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  368938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368960 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368980 */     GIR_RootConstrainSelectedInstOperands,
     /*  368981 */     // GIR_Coverage, 60655,
     /*  368981 */     GIR_EraseRootFromParent_Done,
     /*  368982 */   // Label 6691: @368982
     /*  368982 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(369048), // Rule ID 60658 //
     /*  368987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  368998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  369001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  369004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369026 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  369029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369046 */     GIR_RootConstrainSelectedInstOperands,
     /*  369047 */     // GIR_Coverage, 60658,
     /*  369047 */     GIR_EraseRootFromParent_Done,
     /*  369048 */   // Label 6692: @369048
     /*  369048 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(369114), // Rule ID 60659 //
     /*  369053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  369064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  369067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  369070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369092 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  369095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369112 */     GIR_RootConstrainSelectedInstOperands,
     /*  369113 */     // GIR_Coverage, 60659,
     /*  369113 */     GIR_EraseRootFromParent_Done,
     /*  369114 */   // Label 6693: @369114
     /*  369114 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(369180), // Rule ID 60662 //
     /*  369119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  369130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  369133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  369136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  369161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369178 */     GIR_RootConstrainSelectedInstOperands,
     /*  369179 */     // GIR_Coverage, 60662,
     /*  369179 */     GIR_EraseRootFromParent_Done,
     /*  369180 */   // Label 6694: @369180
     /*  369180 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(369246), // Rule ID 60663 //
     /*  369185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  369196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  369199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  369202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  369227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369244 */     GIR_RootConstrainSelectedInstOperands,
     /*  369245 */     // GIR_Coverage, 60663,
     /*  369245 */     GIR_EraseRootFromParent_Done,
     /*  369246 */   // Label 6695: @369246
     /*  369246 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(369312), // Rule ID 60666 //
     /*  369251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  369262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  369265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  369268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  369290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  369293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369310 */     GIR_RootConstrainSelectedInstOperands,
     /*  369311 */     // GIR_Coverage, 60666,
     /*  369311 */     GIR_EraseRootFromParent_Done,
     /*  369312 */   // Label 6696: @369312
     /*  369312 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(369378), // Rule ID 60667 //
     /*  369317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  369328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  369331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  369334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  369356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  369359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369376 */     GIR_RootConstrainSelectedInstOperands,
     /*  369377 */     // GIR_Coverage, 60667,
     /*  369377 */     GIR_EraseRootFromParent_Done,
     /*  369378 */   // Label 6697: @369378
     /*  369378 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(369444), // Rule ID 60670 //
     /*  369383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  369394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  369397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  369400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369422 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369442 */     GIR_RootConstrainSelectedInstOperands,
     /*  369443 */     // GIR_Coverage, 60670,
     /*  369443 */     GIR_EraseRootFromParent_Done,
     /*  369444 */   // Label 6698: @369444
     /*  369444 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(369510), // Rule ID 60671 //
     /*  369449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  369460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  369463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  369466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369488 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369508 */     GIR_RootConstrainSelectedInstOperands,
     /*  369509 */     // GIR_Coverage, 60671,
     /*  369509 */     GIR_EraseRootFromParent_Done,
     /*  369510 */   // Label 6699: @369510
     /*  369510 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(369576), // Rule ID 60674 //
     /*  369515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  369526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  369529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  369532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369554 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369574 */     GIR_RootConstrainSelectedInstOperands,
     /*  369575 */     // GIR_Coverage, 60674,
     /*  369575 */     GIR_EraseRootFromParent_Done,
     /*  369576 */   // Label 6700: @369576
     /*  369576 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(369642), // Rule ID 60675 //
     /*  369581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  369592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  369595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  369598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369620 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369640 */     GIR_RootConstrainSelectedInstOperands,
     /*  369641 */     // GIR_Coverage, 60675,
     /*  369641 */     GIR_EraseRootFromParent_Done,
     /*  369642 */   // Label 6701: @369642
     /*  369642 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(369708), // Rule ID 60678 //
     /*  369647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  369658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  369661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  369664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369686 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369706 */     GIR_RootConstrainSelectedInstOperands,
     /*  369707 */     // GIR_Coverage, 60678,
     /*  369707 */     GIR_EraseRootFromParent_Done,
     /*  369708 */   // Label 6702: @369708
     /*  369708 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(369774), // Rule ID 60679 //
     /*  369713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  369724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  369727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  369730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369752 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369772 */     GIR_RootConstrainSelectedInstOperands,
     /*  369773 */     // GIR_Coverage, 60679,
     /*  369773 */     GIR_EraseRootFromParent_Done,
     /*  369774 */   // Label 6703: @369774
     /*  369774 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(369840), // Rule ID 60682 //
     /*  369779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  369790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  369793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  369796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369838 */     GIR_RootConstrainSelectedInstOperands,
     /*  369839 */     // GIR_Coverage, 60682,
     /*  369839 */     GIR_EraseRootFromParent_Done,
     /*  369840 */   // Label 6704: @369840
     /*  369840 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(369906), // Rule ID 60683 //
     /*  369845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  369856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  369859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  369862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369904 */     GIR_RootConstrainSelectedInstOperands,
     /*  369905 */     // GIR_Coverage, 60683,
     /*  369905 */     GIR_EraseRootFromParent_Done,
     /*  369906 */   // Label 6705: @369906
     /*  369906 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(369972), // Rule ID 60686 //
     /*  369911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  369922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  369925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  369928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369950 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369970 */     GIR_RootConstrainSelectedInstOperands,
     /*  369971 */     // GIR_Coverage, 60686,
     /*  369971 */     GIR_EraseRootFromParent_Done,
     /*  369972 */   // Label 6706: @369972
     /*  369972 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(370038), // Rule ID 60687 //
     /*  369977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  369988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  369991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  369994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370016 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370036 */     GIR_RootConstrainSelectedInstOperands,
     /*  370037 */     // GIR_Coverage, 60687,
     /*  370037 */     GIR_EraseRootFromParent_Done,
     /*  370038 */   // Label 6707: @370038
     /*  370038 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(370104), // Rule ID 60690 //
     /*  370043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  370054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  370057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  370060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370082 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370102 */     GIR_RootConstrainSelectedInstOperands,
     /*  370103 */     // GIR_Coverage, 60690,
     /*  370103 */     GIR_EraseRootFromParent_Done,
     /*  370104 */   // Label 6708: @370104
     /*  370104 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(370170), // Rule ID 60691 //
     /*  370109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  370120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  370123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  370126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370148 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370168 */     GIR_RootConstrainSelectedInstOperands,
     /*  370169 */     // GIR_Coverage, 60691,
     /*  370169 */     GIR_EraseRootFromParent_Done,
     /*  370170 */   // Label 6709: @370170
     /*  370170 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(370236), // Rule ID 60694 //
     /*  370175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  370186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  370189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  370192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  370217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370234 */     GIR_RootConstrainSelectedInstOperands,
     /*  370235 */     // GIR_Coverage, 60694,
     /*  370235 */     GIR_EraseRootFromParent_Done,
     /*  370236 */   // Label 6710: @370236
     /*  370236 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(370302), // Rule ID 60695 //
     /*  370241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  370252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  370255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  370258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  370283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370300 */     GIR_RootConstrainSelectedInstOperands,
     /*  370301 */     // GIR_Coverage, 60695,
     /*  370301 */     GIR_EraseRootFromParent_Done,
     /*  370302 */   // Label 6711: @370302
     /*  370302 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(370368), // Rule ID 60698 //
     /*  370307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  370318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  370321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  370324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370366 */     GIR_RootConstrainSelectedInstOperands,
     /*  370367 */     // GIR_Coverage, 60698,
     /*  370367 */     GIR_EraseRootFromParent_Done,
     /*  370368 */   // Label 6712: @370368
     /*  370368 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(370434), // Rule ID 60699 //
     /*  370373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  370384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  370387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  370390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370412 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370432 */     GIR_RootConstrainSelectedInstOperands,
     /*  370433 */     // GIR_Coverage, 60699,
     /*  370433 */     GIR_EraseRootFromParent_Done,
     /*  370434 */   // Label 6713: @370434
     /*  370434 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(370500), // Rule ID 60702 //
     /*  370439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  370450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  370453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  370456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370498 */     GIR_RootConstrainSelectedInstOperands,
     /*  370499 */     // GIR_Coverage, 60702,
     /*  370499 */     GIR_EraseRootFromParent_Done,
     /*  370500 */   // Label 6714: @370500
     /*  370500 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(370566), // Rule ID 60703 //
     /*  370505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  370516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  370519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  370522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370544 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370564 */     GIR_RootConstrainSelectedInstOperands,
     /*  370565 */     // GIR_Coverage, 60703,
     /*  370565 */     GIR_EraseRootFromParent_Done,
     /*  370566 */   // Label 6715: @370566
     /*  370566 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(370632), // Rule ID 60706 //
     /*  370571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  370582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  370585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  370588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  370610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  370613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370630 */     GIR_RootConstrainSelectedInstOperands,
     /*  370631 */     // GIR_Coverage, 60706,
     /*  370631 */     GIR_EraseRootFromParent_Done,
     /*  370632 */   // Label 6716: @370632
     /*  370632 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(370698), // Rule ID 60707 //
     /*  370637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  370648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  370651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  370654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  370676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  370679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370696 */     GIR_RootConstrainSelectedInstOperands,
     /*  370697 */     // GIR_Coverage, 60707,
     /*  370697 */     GIR_EraseRootFromParent_Done,
     /*  370698 */   // Label 6717: @370698
     /*  370698 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(370764), // Rule ID 60710 //
     /*  370703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  370714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  370717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  370720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370742 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  370742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370762 */     GIR_RootConstrainSelectedInstOperands,
     /*  370763 */     // GIR_Coverage, 60710,
     /*  370763 */     GIR_EraseRootFromParent_Done,
     /*  370764 */   // Label 6718: @370764
     /*  370764 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(370830), // Rule ID 60711 //
     /*  370769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  370780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  370783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  370786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370808 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  370808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370828 */     GIR_RootConstrainSelectedInstOperands,
     /*  370829 */     // GIR_Coverage, 60711,
     /*  370829 */     GIR_EraseRootFromParent_Done,
     /*  370830 */   // Label 6719: @370830
     /*  370830 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(370896), // Rule ID 60714 //
     /*  370835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  370846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  370849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  370852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370874 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  370874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370894 */     GIR_RootConstrainSelectedInstOperands,
     /*  370895 */     // GIR_Coverage, 60714,
     /*  370895 */     GIR_EraseRootFromParent_Done,
     /*  370896 */   // Label 6720: @370896
     /*  370896 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(370962), // Rule ID 60715 //
     /*  370901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  370912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  370915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  370918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370940 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  370940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370960 */     GIR_RootConstrainSelectedInstOperands,
     /*  370961 */     // GIR_Coverage, 60715,
     /*  370961 */     GIR_EraseRootFromParent_Done,
     /*  370962 */   // Label 6721: @370962
     /*  370962 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(371028), // Rule ID 60718 //
     /*  370967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  370978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  370981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  370984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371006 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  371009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371026 */     GIR_RootConstrainSelectedInstOperands,
     /*  371027 */     // GIR_Coverage, 60718,
     /*  371027 */     GIR_EraseRootFromParent_Done,
     /*  371028 */   // Label 6722: @371028
     /*  371028 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(371094), // Rule ID 60719 //
     /*  371033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  371044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  371047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  371050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371072 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  371075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371092 */     GIR_RootConstrainSelectedInstOperands,
     /*  371093 */     // GIR_Coverage, 60719,
     /*  371093 */     GIR_EraseRootFromParent_Done,
     /*  371094 */   // Label 6723: @371094
     /*  371094 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(371160), // Rule ID 60722 //
     /*  371099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  371110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  371113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  371116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371138 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  371141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371158 */     GIR_RootConstrainSelectedInstOperands,
     /*  371159 */     // GIR_Coverage, 60722,
     /*  371159 */     GIR_EraseRootFromParent_Done,
     /*  371160 */   // Label 6724: @371160
     /*  371160 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(371226), // Rule ID 60723 //
     /*  371165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  371176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  371179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  371182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371204 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  371207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371224 */     GIR_RootConstrainSelectedInstOperands,
     /*  371225 */     // GIR_Coverage, 60723,
     /*  371225 */     GIR_EraseRootFromParent_Done,
     /*  371226 */   // Label 6725: @371226
     /*  371226 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(371292), // Rule ID 60726 //
     /*  371231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  371242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  371245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  371248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371270 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371290 */     GIR_RootConstrainSelectedInstOperands,
     /*  371291 */     // GIR_Coverage, 60726,
     /*  371291 */     GIR_EraseRootFromParent_Done,
     /*  371292 */   // Label 6726: @371292
     /*  371292 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(371358), // Rule ID 60727 //
     /*  371297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  371308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  371311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  371314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371336 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371356 */     GIR_RootConstrainSelectedInstOperands,
     /*  371357 */     // GIR_Coverage, 60727,
     /*  371357 */     GIR_EraseRootFromParent_Done,
     /*  371358 */   // Label 6727: @371358
     /*  371358 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(371424), // Rule ID 60730 //
     /*  371363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  371374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  371377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  371380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371402 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  371405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371422 */     GIR_RootConstrainSelectedInstOperands,
     /*  371423 */     // GIR_Coverage, 60730,
     /*  371423 */     GIR_EraseRootFromParent_Done,
     /*  371424 */   // Label 6728: @371424
     /*  371424 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(371490), // Rule ID 60731 //
     /*  371429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  371440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  371443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  371446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371468 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  371471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371488 */     GIR_RootConstrainSelectedInstOperands,
     /*  371489 */     // GIR_Coverage, 60731,
     /*  371489 */     GIR_EraseRootFromParent_Done,
     /*  371490 */   // Label 6729: @371490
     /*  371490 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(371556), // Rule ID 60734 //
     /*  371495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  371506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  371509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  371512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371534 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371554 */     GIR_RootConstrainSelectedInstOperands,
     /*  371555 */     // GIR_Coverage, 60734,
     /*  371555 */     GIR_EraseRootFromParent_Done,
     /*  371556 */   // Label 6730: @371556
     /*  371556 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(371622), // Rule ID 60735 //
     /*  371561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  371572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  371575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  371578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371600 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371620 */     GIR_RootConstrainSelectedInstOperands,
     /*  371621 */     // GIR_Coverage, 60735,
     /*  371621 */     GIR_EraseRootFromParent_Done,
     /*  371622 */   // Label 6731: @371622
     /*  371622 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(371688), // Rule ID 60738 //
     /*  371627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  371638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  371641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  371644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371666 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  371666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371686 */     GIR_RootConstrainSelectedInstOperands,
     /*  371687 */     // GIR_Coverage, 60738,
     /*  371687 */     GIR_EraseRootFromParent_Done,
     /*  371688 */   // Label 6732: @371688
     /*  371688 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(371754), // Rule ID 60739 //
     /*  371693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  371704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  371707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  371710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  371732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371752 */     GIR_RootConstrainSelectedInstOperands,
     /*  371753 */     // GIR_Coverage, 60739,
     /*  371753 */     GIR_EraseRootFromParent_Done,
     /*  371754 */   // Label 6733: @371754
     /*  371754 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(371820), // Rule ID 60742 //
     /*  371759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  371770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  371773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  371776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371798 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371818 */     GIR_RootConstrainSelectedInstOperands,
     /*  371819 */     // GIR_Coverage, 60742,
     /*  371819 */     GIR_EraseRootFromParent_Done,
     /*  371820 */   // Label 6734: @371820
     /*  371820 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(371886), // Rule ID 60743 //
     /*  371825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  371836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  371839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  371842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371864 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371884 */     GIR_RootConstrainSelectedInstOperands,
     /*  371885 */     // GIR_Coverage, 60743,
     /*  371885 */     GIR_EraseRootFromParent_Done,
     /*  371886 */   // Label 6735: @371886
     /*  371886 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(371952), // Rule ID 60746 //
     /*  371891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  371902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  371905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  371908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371930 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371950 */     GIR_RootConstrainSelectedInstOperands,
     /*  371951 */     // GIR_Coverage, 60746,
     /*  371951 */     GIR_EraseRootFromParent_Done,
     /*  371952 */   // Label 6736: @371952
     /*  371952 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(372018), // Rule ID 60747 //
     /*  371957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  371968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  371971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  371974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372016 */     GIR_RootConstrainSelectedInstOperands,
     /*  372017 */     // GIR_Coverage, 60747,
     /*  372017 */     GIR_EraseRootFromParent_Done,
     /*  372018 */   // Label 6737: @372018
     /*  372018 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(372084), // Rule ID 60750 //
     /*  372023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  372034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  372037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  372040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372062 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  372065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372082 */     GIR_RootConstrainSelectedInstOperands,
     /*  372083 */     // GIR_Coverage, 60750,
     /*  372083 */     GIR_EraseRootFromParent_Done,
     /*  372084 */   // Label 6738: @372084
     /*  372084 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(372150), // Rule ID 60751 //
     /*  372089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  372100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  372103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  372106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372128 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  372131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372148 */     GIR_RootConstrainSelectedInstOperands,
     /*  372149 */     // GIR_Coverage, 60751,
     /*  372149 */     GIR_EraseRootFromParent_Done,
     /*  372150 */   // Label 6739: @372150
     /*  372150 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(372216), // Rule ID 60754 //
     /*  372155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  372166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  372169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  372172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372194 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  372194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  372197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372214 */     GIR_RootConstrainSelectedInstOperands,
     /*  372215 */     // GIR_Coverage, 60754,
     /*  372215 */     GIR_EraseRootFromParent_Done,
     /*  372216 */   // Label 6740: @372216
     /*  372216 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(372282), // Rule ID 60755 //
     /*  372221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  372232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  372235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  372238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372260 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  372260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  372263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372280 */     GIR_RootConstrainSelectedInstOperands,
     /*  372281 */     // GIR_Coverage, 60755,
     /*  372281 */     GIR_EraseRootFromParent_Done,
     /*  372282 */   // Label 6741: @372282
     /*  372282 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(372348), // Rule ID 60758 //
     /*  372287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  372298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  372301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  372304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372346 */     GIR_RootConstrainSelectedInstOperands,
     /*  372347 */     // GIR_Coverage, 60758,
     /*  372347 */     GIR_EraseRootFromParent_Done,
     /*  372348 */   // Label 6742: @372348
     /*  372348 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(372414), // Rule ID 60759 //
     /*  372353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  372364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  372367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  372370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372392 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372412 */     GIR_RootConstrainSelectedInstOperands,
     /*  372413 */     // GIR_Coverage, 60759,
     /*  372413 */     GIR_EraseRootFromParent_Done,
     /*  372414 */   // Label 6743: @372414
     /*  372414 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(372480), // Rule ID 60762 //
     /*  372419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  372430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  372433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  372436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372458 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372478 */     GIR_RootConstrainSelectedInstOperands,
     /*  372479 */     // GIR_Coverage, 60762,
     /*  372479 */     GIR_EraseRootFromParent_Done,
     /*  372480 */   // Label 6744: @372480
     /*  372480 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(372546), // Rule ID 60763 //
     /*  372485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  372496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  372499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  372502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372524 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372544 */     GIR_RootConstrainSelectedInstOperands,
     /*  372545 */     // GIR_Coverage, 60763,
     /*  372545 */     GIR_EraseRootFromParent_Done,
     /*  372546 */   // Label 6745: @372546
     /*  372546 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(372612), // Rule ID 60766 //
     /*  372551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  372562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  372565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  372568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372590 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372610 */     GIR_RootConstrainSelectedInstOperands,
     /*  372611 */     // GIR_Coverage, 60766,
     /*  372611 */     GIR_EraseRootFromParent_Done,
     /*  372612 */   // Label 6746: @372612
     /*  372612 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(372678), // Rule ID 60767 //
     /*  372617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  372628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  372631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  372634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372656 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372676 */     GIR_RootConstrainSelectedInstOperands,
     /*  372677 */     // GIR_Coverage, 60767,
     /*  372677 */     GIR_EraseRootFromParent_Done,
     /*  372678 */   // Label 6747: @372678
     /*  372678 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(372744), // Rule ID 60770 //
     /*  372683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  372694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  372697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  372700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372722 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372742 */     GIR_RootConstrainSelectedInstOperands,
     /*  372743 */     // GIR_Coverage, 60770,
     /*  372743 */     GIR_EraseRootFromParent_Done,
     /*  372744 */   // Label 6748: @372744
     /*  372744 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(372810), // Rule ID 60771 //
     /*  372749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  372760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  372763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  372766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372788 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372808 */     GIR_RootConstrainSelectedInstOperands,
     /*  372809 */     // GIR_Coverage, 60771,
     /*  372809 */     GIR_EraseRootFromParent_Done,
     /*  372810 */   // Label 6749: @372810
     /*  372810 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(372876), // Rule ID 60774 //
     /*  372815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  372826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  372829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  372832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372854 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372874 */     GIR_RootConstrainSelectedInstOperands,
     /*  372875 */     // GIR_Coverage, 60774,
     /*  372875 */     GIR_EraseRootFromParent_Done,
     /*  372876 */   // Label 6750: @372876
     /*  372876 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(372942), // Rule ID 60775 //
     /*  372881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  372892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  372895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  372898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372920 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372940 */     GIR_RootConstrainSelectedInstOperands,
     /*  372941 */     // GIR_Coverage, 60775,
     /*  372941 */     GIR_EraseRootFromParent_Done,
     /*  372942 */   // Label 6751: @372942
     /*  372942 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(373008), // Rule ID 60778 //
     /*  372947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  372958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  372961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  372964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372986 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373006 */     GIR_RootConstrainSelectedInstOperands,
     /*  373007 */     // GIR_Coverage, 60778,
     /*  373007 */     GIR_EraseRootFromParent_Done,
     /*  373008 */   // Label 6752: @373008
     /*  373008 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(373074), // Rule ID 60779 //
     /*  373013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  373024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  373027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  373030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373052 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373072 */     GIR_RootConstrainSelectedInstOperands,
     /*  373073 */     // GIR_Coverage, 60779,
     /*  373073 */     GIR_EraseRootFromParent_Done,
     /*  373074 */   // Label 6753: @373074
     /*  373074 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(373140), // Rule ID 60782 //
     /*  373079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  373090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  373093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  373096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  373121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373138 */     GIR_RootConstrainSelectedInstOperands,
     /*  373139 */     // GIR_Coverage, 60782,
     /*  373139 */     GIR_EraseRootFromParent_Done,
     /*  373140 */   // Label 6754: @373140
     /*  373140 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(373206), // Rule ID 60783 //
     /*  373145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  373156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  373159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  373162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  373187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373204 */     GIR_RootConstrainSelectedInstOperands,
     /*  373205 */     // GIR_Coverage, 60783,
     /*  373205 */     GIR_EraseRootFromParent_Done,
     /*  373206 */   // Label 6755: @373206
     /*  373206 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(373272), // Rule ID 60786 //
     /*  373211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  373222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  373225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  373228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373250 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  373253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373270 */     GIR_RootConstrainSelectedInstOperands,
     /*  373271 */     // GIR_Coverage, 60786,
     /*  373271 */     GIR_EraseRootFromParent_Done,
     /*  373272 */   // Label 6756: @373272
     /*  373272 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(373338), // Rule ID 60787 //
     /*  373277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  373288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  373291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  373294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373316 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  373319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373336 */     GIR_RootConstrainSelectedInstOperands,
     /*  373337 */     // GIR_Coverage, 60787,
     /*  373337 */     GIR_EraseRootFromParent_Done,
     /*  373338 */   // Label 6757: @373338
     /*  373338 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(373404), // Rule ID 60790 //
     /*  373343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  373354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  373357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  373360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373382 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373402 */     GIR_RootConstrainSelectedInstOperands,
     /*  373403 */     // GIR_Coverage, 60790,
     /*  373403 */     GIR_EraseRootFromParent_Done,
     /*  373404 */   // Label 6758: @373404
     /*  373404 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(373470), // Rule ID 60791 //
     /*  373409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  373420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  373423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  373426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373448 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373468 */     GIR_RootConstrainSelectedInstOperands,
     /*  373469 */     // GIR_Coverage, 60791,
     /*  373469 */     GIR_EraseRootFromParent_Done,
     /*  373470 */   // Label 6759: @373470
     /*  373470 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(373536), // Rule ID 60794 //
     /*  373475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  373486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  373489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  373492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373514 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  373517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373534 */     GIR_RootConstrainSelectedInstOperands,
     /*  373535 */     // GIR_Coverage, 60794,
     /*  373535 */     GIR_EraseRootFromParent_Done,
     /*  373536 */   // Label 6760: @373536
     /*  373536 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(373602), // Rule ID 60795 //
     /*  373541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  373552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  373555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  373558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373580 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  373580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  373583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373600 */     GIR_RootConstrainSelectedInstOperands,
     /*  373601 */     // GIR_Coverage, 60795,
     /*  373601 */     GIR_EraseRootFromParent_Done,
     /*  373602 */   // Label 6761: @373602
     /*  373602 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(373668), // Rule ID 60798 //
     /*  373607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  373618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  373621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  373624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373646 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  373649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373666 */     GIR_RootConstrainSelectedInstOperands,
     /*  373667 */     // GIR_Coverage, 60798,
     /*  373667 */     GIR_EraseRootFromParent_Done,
     /*  373668 */   // Label 6762: @373668
     /*  373668 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(373734), // Rule ID 60799 //
     /*  373673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  373684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  373687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  373690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373712 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  373712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  373715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373732 */     GIR_RootConstrainSelectedInstOperands,
     /*  373733 */     // GIR_Coverage, 60799,
     /*  373733 */     GIR_EraseRootFromParent_Done,
     /*  373734 */   // Label 6763: @373734
     /*  373734 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(373800), // Rule ID 60802 //
     /*  373739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  373750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  373753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  373756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373778 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373798 */     GIR_RootConstrainSelectedInstOperands,
     /*  373799 */     // GIR_Coverage, 60802,
     /*  373799 */     GIR_EraseRootFromParent_Done,
     /*  373800 */   // Label 6764: @373800
     /*  373800 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(373866), // Rule ID 60803 //
     /*  373805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  373816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  373819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  373822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373844 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  373844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373864 */     GIR_RootConstrainSelectedInstOperands,
     /*  373865 */     // GIR_Coverage, 60803,
     /*  373865 */     GIR_EraseRootFromParent_Done,
     /*  373866 */   // Label 6765: @373866
     /*  373866 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(373932), // Rule ID 60806 //
     /*  373871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  373882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  373885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  373888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373910 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  373913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373930 */     GIR_RootConstrainSelectedInstOperands,
     /*  373931 */     // GIR_Coverage, 60806,
     /*  373931 */     GIR_EraseRootFromParent_Done,
     /*  373932 */   // Label 6766: @373932
     /*  373932 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(373998), // Rule ID 60807 //
     /*  373937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  373948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  373951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  373954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373976 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  373979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373996 */     GIR_RootConstrainSelectedInstOperands,
     /*  373997 */     // GIR_Coverage, 60807,
     /*  373997 */     GIR_EraseRootFromParent_Done,
     /*  373998 */   // Label 6767: @373998
     /*  373998 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(374064), // Rule ID 60810 //
     /*  374003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  374014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  374017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  374020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374042 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  374045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374062 */     GIR_RootConstrainSelectedInstOperands,
     /*  374063 */     // GIR_Coverage, 60810,
     /*  374063 */     GIR_EraseRootFromParent_Done,
     /*  374064 */   // Label 6768: @374064
     /*  374064 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(374130), // Rule ID 60811 //
     /*  374069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  374080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  374083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  374086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374108 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  374111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374128 */     GIR_RootConstrainSelectedInstOperands,
     /*  374129 */     // GIR_Coverage, 60811,
     /*  374129 */     GIR_EraseRootFromParent_Done,
     /*  374130 */   // Label 6769: @374130
     /*  374130 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(374196), // Rule ID 60814 //
     /*  374135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  374146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  374149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  374152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374174 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374194 */     GIR_RootConstrainSelectedInstOperands,
     /*  374195 */     // GIR_Coverage, 60814,
     /*  374195 */     GIR_EraseRootFromParent_Done,
     /*  374196 */   // Label 6770: @374196
     /*  374196 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(374262), // Rule ID 60815 //
     /*  374201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  374212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  374215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  374218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374240 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374260 */     GIR_RootConstrainSelectedInstOperands,
     /*  374261 */     // GIR_Coverage, 60815,
     /*  374261 */     GIR_EraseRootFromParent_Done,
     /*  374262 */   // Label 6771: @374262
     /*  374262 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(374328), // Rule ID 60818 //
     /*  374267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  374278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  374281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  374284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374306 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  374309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374326 */     GIR_RootConstrainSelectedInstOperands,
     /*  374327 */     // GIR_Coverage, 60818,
     /*  374327 */     GIR_EraseRootFromParent_Done,
     /*  374328 */   // Label 6772: @374328
     /*  374328 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(374394), // Rule ID 60819 //
     /*  374333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  374344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  374347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  374350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374372 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  374375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374392 */     GIR_RootConstrainSelectedInstOperands,
     /*  374393 */     // GIR_Coverage, 60819,
     /*  374393 */     GIR_EraseRootFromParent_Done,
     /*  374394 */   // Label 6773: @374394
     /*  374394 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(374460), // Rule ID 60822 //
     /*  374399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  374410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  374413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  374416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374438 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374458 */     GIR_RootConstrainSelectedInstOperands,
     /*  374459 */     // GIR_Coverage, 60822,
     /*  374459 */     GIR_EraseRootFromParent_Done,
     /*  374460 */   // Label 6774: @374460
     /*  374460 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(374526), // Rule ID 60823 //
     /*  374465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  374476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  374479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  374482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374504 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374524 */     GIR_RootConstrainSelectedInstOperands,
     /*  374525 */     // GIR_Coverage, 60823,
     /*  374525 */     GIR_EraseRootFromParent_Done,
     /*  374526 */   // Label 6775: @374526
     /*  374526 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(374592), // Rule ID 60826 //
     /*  374531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  374542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  374545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  374548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374570 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  374570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374590 */     GIR_RootConstrainSelectedInstOperands,
     /*  374591 */     // GIR_Coverage, 60826,
     /*  374591 */     GIR_EraseRootFromParent_Done,
     /*  374592 */   // Label 6776: @374592
     /*  374592 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(374658), // Rule ID 60827 //
     /*  374597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  374608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  374611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  374614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374636 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  374636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374656 */     GIR_RootConstrainSelectedInstOperands,
     /*  374657 */     // GIR_Coverage, 60827,
     /*  374657 */     GIR_EraseRootFromParent_Done,
     /*  374658 */   // Label 6777: @374658
     /*  374658 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(374724), // Rule ID 60830 //
     /*  374663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  374674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  374677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  374680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374702 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374722 */     GIR_RootConstrainSelectedInstOperands,
     /*  374723 */     // GIR_Coverage, 60830,
     /*  374723 */     GIR_EraseRootFromParent_Done,
     /*  374724 */   // Label 6778: @374724
     /*  374724 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(374790), // Rule ID 60831 //
     /*  374729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  374740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  374743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  374746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374768 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374788 */     GIR_RootConstrainSelectedInstOperands,
     /*  374789 */     // GIR_Coverage, 60831,
     /*  374789 */     GIR_EraseRootFromParent_Done,
     /*  374790 */   // Label 6779: @374790
     /*  374790 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(374856), // Rule ID 60834 //
     /*  374795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  374806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  374809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  374812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374834 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374854 */     GIR_RootConstrainSelectedInstOperands,
     /*  374855 */     // GIR_Coverage, 60834,
     /*  374855 */     GIR_EraseRootFromParent_Done,
     /*  374856 */   // Label 6780: @374856
     /*  374856 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(374922), // Rule ID 60835 //
     /*  374861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  374872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  374875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  374878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374920 */     GIR_RootConstrainSelectedInstOperands,
     /*  374921 */     // GIR_Coverage, 60835,
     /*  374921 */     GIR_EraseRootFromParent_Done,
     /*  374922 */   // Label 6781: @374922
     /*  374922 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(374988), // Rule ID 60838 //
     /*  374927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  374938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  374941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  374944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  374966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374986 */     GIR_RootConstrainSelectedInstOperands,
     /*  374987 */     // GIR_Coverage, 60838,
     /*  374987 */     GIR_EraseRootFromParent_Done,
     /*  374988 */   // Label 6782: @374988
     /*  374988 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(375054), // Rule ID 60839 //
     /*  374993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  375004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  375007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  375010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375032 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  375035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375052 */     GIR_RootConstrainSelectedInstOperands,
     /*  375053 */     // GIR_Coverage, 60839,
     /*  375053 */     GIR_EraseRootFromParent_Done,
     /*  375054 */   // Label 6783: @375054
     /*  375054 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(375120), // Rule ID 60842 //
     /*  375059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  375070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  375073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  375076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375098 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  375098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  375101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375118 */     GIR_RootConstrainSelectedInstOperands,
     /*  375119 */     // GIR_Coverage, 60842,
     /*  375119 */     GIR_EraseRootFromParent_Done,
     /*  375120 */   // Label 6784: @375120
     /*  375120 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(375186), // Rule ID 60843 //
     /*  375125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  375136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  375139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  375142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375164 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  375164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  375167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375184 */     GIR_RootConstrainSelectedInstOperands,
     /*  375185 */     // GIR_Coverage, 60843,
     /*  375185 */     GIR_EraseRootFromParent_Done,
     /*  375186 */   // Label 6785: @375186
     /*  375186 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(375252), // Rule ID 60846 //
     /*  375191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  375202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  375205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  375208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375250 */     GIR_RootConstrainSelectedInstOperands,
     /*  375251 */     // GIR_Coverage, 60846,
     /*  375251 */     GIR_EraseRootFromParent_Done,
     /*  375252 */   // Label 6786: @375252
     /*  375252 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(375318), // Rule ID 60847 //
     /*  375257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  375268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  375271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  375274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375316 */     GIR_RootConstrainSelectedInstOperands,
     /*  375317 */     // GIR_Coverage, 60847,
     /*  375317 */     GIR_EraseRootFromParent_Done,
     /*  375318 */   // Label 6787: @375318
     /*  375318 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(375384), // Rule ID 60850 //
     /*  375323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  375334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  375337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  375340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375362 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375382 */     GIR_RootConstrainSelectedInstOperands,
     /*  375383 */     // GIR_Coverage, 60850,
     /*  375383 */     GIR_EraseRootFromParent_Done,
     /*  375384 */   // Label 6788: @375384
     /*  375384 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(375450), // Rule ID 60851 //
     /*  375389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  375400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  375403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  375406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375428 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375448 */     GIR_RootConstrainSelectedInstOperands,
     /*  375449 */     // GIR_Coverage, 60851,
     /*  375449 */     GIR_EraseRootFromParent_Done,
     /*  375450 */   // Label 6789: @375450
     /*  375450 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(375516), // Rule ID 60854 //
     /*  375455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  375466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  375469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  375472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375494 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375514 */     GIR_RootConstrainSelectedInstOperands,
     /*  375515 */     // GIR_Coverage, 60854,
     /*  375515 */     GIR_EraseRootFromParent_Done,
     /*  375516 */   // Label 6790: @375516
     /*  375516 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(375582), // Rule ID 60855 //
     /*  375521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  375532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  375535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  375538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375560 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375580 */     GIR_RootConstrainSelectedInstOperands,
     /*  375581 */     // GIR_Coverage, 60855,
     /*  375581 */     GIR_EraseRootFromParent_Done,
     /*  375582 */   // Label 6791: @375582
     /*  375582 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(375648), // Rule ID 60858 //
     /*  375587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  375598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  375601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  375604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375646 */     GIR_RootConstrainSelectedInstOperands,
     /*  375647 */     // GIR_Coverage, 60858,
     /*  375647 */     GIR_EraseRootFromParent_Done,
     /*  375648 */   // Label 6792: @375648
     /*  375648 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(375714), // Rule ID 60859 //
     /*  375653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  375664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  375667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  375670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375712 */     GIR_RootConstrainSelectedInstOperands,
     /*  375713 */     // GIR_Coverage, 60859,
     /*  375713 */     GIR_EraseRootFromParent_Done,
     /*  375714 */   // Label 6793: @375714
     /*  375714 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(375780), // Rule ID 60862 //
     /*  375719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  375730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  375733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  375736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375758 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375778 */     GIR_RootConstrainSelectedInstOperands,
     /*  375779 */     // GIR_Coverage, 60862,
     /*  375779 */     GIR_EraseRootFromParent_Done,
     /*  375780 */   // Label 6794: @375780
     /*  375780 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(375846), // Rule ID 60863 //
     /*  375785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  375796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  375799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  375802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375824 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375844 */     GIR_RootConstrainSelectedInstOperands,
     /*  375845 */     // GIR_Coverage, 60863,
     /*  375845 */     GIR_EraseRootFromParent_Done,
     /*  375846 */   // Label 6795: @375846
     /*  375846 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(375912), // Rule ID 60866 //
     /*  375851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  375862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  375865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  375868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375890 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375910 */     GIR_RootConstrainSelectedInstOperands,
     /*  375911 */     // GIR_Coverage, 60866,
     /*  375911 */     GIR_EraseRootFromParent_Done,
     /*  375912 */   // Label 6796: @375912
     /*  375912 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(375978), // Rule ID 60867 //
     /*  375917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  375928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  375931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  375934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375956 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375976 */     GIR_RootConstrainSelectedInstOperands,
     /*  375977 */     // GIR_Coverage, 60867,
     /*  375977 */     GIR_EraseRootFromParent_Done,
     /*  375978 */   // Label 6797: @375978
     /*  375978 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(376044), // Rule ID 60870 //
     /*  375983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  375994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  375997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  376000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376022 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  376025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376042 */     GIR_RootConstrainSelectedInstOperands,
     /*  376043 */     // GIR_Coverage, 60870,
     /*  376043 */     GIR_EraseRootFromParent_Done,
     /*  376044 */   // Label 6798: @376044
     /*  376044 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(376110), // Rule ID 60871 //
     /*  376049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  376060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  376063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  376066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  376091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376108 */     GIR_RootConstrainSelectedInstOperands,
     /*  376109 */     // GIR_Coverage, 60871,
     /*  376109 */     GIR_EraseRootFromParent_Done,
     /*  376110 */   // Label 6799: @376110
     /*  376110 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(376176), // Rule ID 60874 //
     /*  376115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  376126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  376129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  376132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376154 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  376157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376174 */     GIR_RootConstrainSelectedInstOperands,
     /*  376175 */     // GIR_Coverage, 60874,
     /*  376175 */     GIR_EraseRootFromParent_Done,
     /*  376176 */   // Label 6800: @376176
     /*  376176 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(376242), // Rule ID 60875 //
     /*  376181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  376192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  376195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  376198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376220 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  376223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376240 */     GIR_RootConstrainSelectedInstOperands,
     /*  376241 */     // GIR_Coverage, 60875,
     /*  376241 */     GIR_EraseRootFromParent_Done,
     /*  376242 */   // Label 6801: @376242
     /*  376242 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(376308), // Rule ID 60878 //
     /*  376247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  376258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  376261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  376264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376286 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  376289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376306 */     GIR_RootConstrainSelectedInstOperands,
     /*  376307 */     // GIR_Coverage, 60878,
     /*  376307 */     GIR_EraseRootFromParent_Done,
     /*  376308 */   // Label 6802: @376308
     /*  376308 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(376374), // Rule ID 60879 //
     /*  376313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  376324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  376327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  376330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376352 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  376355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376372 */     GIR_RootConstrainSelectedInstOperands,
     /*  376373 */     // GIR_Coverage, 60879,
     /*  376373 */     GIR_EraseRootFromParent_Done,
     /*  376374 */   // Label 6803: @376374
     /*  376374 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(376440), // Rule ID 60882 //
     /*  376379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  376390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  376393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  376396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376418 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  376421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376438 */     GIR_RootConstrainSelectedInstOperands,
     /*  376439 */     // GIR_Coverage, 60882,
     /*  376439 */     GIR_EraseRootFromParent_Done,
     /*  376440 */   // Label 6804: @376440
     /*  376440 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(376506), // Rule ID 60883 //
     /*  376445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  376456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  376459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  376462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  376487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376504 */     GIR_RootConstrainSelectedInstOperands,
     /*  376505 */     // GIR_Coverage, 60883,
     /*  376505 */     GIR_EraseRootFromParent_Done,
     /*  376506 */   // Label 6805: @376506
     /*  376506 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(376572), // Rule ID 60886 //
     /*  376511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  376522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  376525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  376528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376550 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  376553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376570 */     GIR_RootConstrainSelectedInstOperands,
     /*  376571 */     // GIR_Coverage, 60886,
     /*  376571 */     GIR_EraseRootFromParent_Done,
     /*  376572 */   // Label 6806: @376572
     /*  376572 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(376638), // Rule ID 60887 //
     /*  376577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  376588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  376591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  376594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  376619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376636 */     GIR_RootConstrainSelectedInstOperands,
     /*  376637 */     // GIR_Coverage, 60887,
     /*  376637 */     GIR_EraseRootFromParent_Done,
     /*  376638 */   // Label 6807: @376638
     /*  376638 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(376704), // Rule ID 60890 //
     /*  376643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  376654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  376657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  376660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376682 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  376685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376702 */     GIR_RootConstrainSelectedInstOperands,
     /*  376703 */     // GIR_Coverage, 60890,
     /*  376703 */     GIR_EraseRootFromParent_Done,
     /*  376704 */   // Label 6808: @376704
     /*  376704 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(376770), // Rule ID 60891 //
     /*  376709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  376720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  376723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  376726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376748 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  376751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376768 */     GIR_RootConstrainSelectedInstOperands,
     /*  376769 */     // GIR_Coverage, 60891,
     /*  376769 */     GIR_EraseRootFromParent_Done,
     /*  376770 */   // Label 6809: @376770
     /*  376770 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(376836), // Rule ID 60894 //
     /*  376775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  376786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  376789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  376792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376814 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  376817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376834 */     GIR_RootConstrainSelectedInstOperands,
     /*  376835 */     // GIR_Coverage, 60894,
     /*  376835 */     GIR_EraseRootFromParent_Done,
     /*  376836 */   // Label 6810: @376836
     /*  376836 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(376902), // Rule ID 60895 //
     /*  376841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  376852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  376855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  376858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376880 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  376883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376900 */     GIR_RootConstrainSelectedInstOperands,
     /*  376901 */     // GIR_Coverage, 60895,
     /*  376901 */     GIR_EraseRootFromParent_Done,
     /*  376902 */   // Label 6811: @376902
     /*  376902 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(376968), // Rule ID 60898 //
     /*  376907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  376918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  376921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  376924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376966 */     GIR_RootConstrainSelectedInstOperands,
     /*  376967 */     // GIR_Coverage, 60898,
     /*  376967 */     GIR_EraseRootFromParent_Done,
     /*  376968 */   // Label 6812: @376968
     /*  376968 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(377034), // Rule ID 60899 //
     /*  376973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  376984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  376987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  376990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377012 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  377015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377032 */     GIR_RootConstrainSelectedInstOperands,
     /*  377033 */     // GIR_Coverage, 60899,
     /*  377033 */     GIR_EraseRootFromParent_Done,
     /*  377034 */   // Label 6813: @377034
     /*  377034 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(377100), // Rule ID 60902 //
     /*  377039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  377050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  377053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  377056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377078 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377098 */     GIR_RootConstrainSelectedInstOperands,
     /*  377099 */     // GIR_Coverage, 60902,
     /*  377099 */     GIR_EraseRootFromParent_Done,
     /*  377100 */   // Label 6814: @377100
     /*  377100 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(377166), // Rule ID 60903 //
     /*  377105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  377116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  377119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  377122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377144 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377164 */     GIR_RootConstrainSelectedInstOperands,
     /*  377165 */     // GIR_Coverage, 60903,
     /*  377165 */     GIR_EraseRootFromParent_Done,
     /*  377166 */   // Label 6815: @377166
     /*  377166 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(377232), // Rule ID 60906 //
     /*  377171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  377182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  377185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  377188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  377213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377230 */     GIR_RootConstrainSelectedInstOperands,
     /*  377231 */     // GIR_Coverage, 60906,
     /*  377231 */     GIR_EraseRootFromParent_Done,
     /*  377232 */   // Label 6816: @377232
     /*  377232 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(377298), // Rule ID 60907 //
     /*  377237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  377248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  377251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  377254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  377279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377296 */     GIR_RootConstrainSelectedInstOperands,
     /*  377297 */     // GIR_Coverage, 60907,
     /*  377297 */     GIR_EraseRootFromParent_Done,
     /*  377298 */   // Label 6817: @377298
     /*  377298 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(377364), // Rule ID 60910 //
     /*  377303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  377314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  377317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  377320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377342 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377362 */     GIR_RootConstrainSelectedInstOperands,
     /*  377363 */     // GIR_Coverage, 60910,
     /*  377363 */     GIR_EraseRootFromParent_Done,
     /*  377364 */   // Label 6818: @377364
     /*  377364 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(377430), // Rule ID 60911 //
     /*  377369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  377380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  377383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  377386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377408 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377428 */     GIR_RootConstrainSelectedInstOperands,
     /*  377429 */     // GIR_Coverage, 60911,
     /*  377429 */     GIR_EraseRootFromParent_Done,
     /*  377430 */   // Label 6819: @377430
     /*  377430 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(377496), // Rule ID 60914 //
     /*  377435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  377446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  377449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  377452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377474 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  377474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377494 */     GIR_RootConstrainSelectedInstOperands,
     /*  377495 */     // GIR_Coverage, 60914,
     /*  377495 */     GIR_EraseRootFromParent_Done,
     /*  377496 */   // Label 6820: @377496
     /*  377496 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(377562), // Rule ID 60915 //
     /*  377501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  377512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  377515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  377518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377540 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  377540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377560 */     GIR_RootConstrainSelectedInstOperands,
     /*  377561 */     // GIR_Coverage, 60915,
     /*  377561 */     GIR_EraseRootFromParent_Done,
     /*  377562 */   // Label 6821: @377562
     /*  377562 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(377628), // Rule ID 60918 //
     /*  377567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  377578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  377581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  377584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377606 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377626 */     GIR_RootConstrainSelectedInstOperands,
     /*  377627 */     // GIR_Coverage, 60918,
     /*  377627 */     GIR_EraseRootFromParent_Done,
     /*  377628 */   // Label 6822: @377628
     /*  377628 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(377694), // Rule ID 60919 //
     /*  377633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  377644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  377647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  377650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377672 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377692 */     GIR_RootConstrainSelectedInstOperands,
     /*  377693 */     // GIR_Coverage, 60919,
     /*  377693 */     GIR_EraseRootFromParent_Done,
     /*  377694 */   // Label 6823: @377694
     /*  377694 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(377760), // Rule ID 60922 //
     /*  377699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  377710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  377713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  377716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377738 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377758 */     GIR_RootConstrainSelectedInstOperands,
     /*  377759 */     // GIR_Coverage, 60922,
     /*  377759 */     GIR_EraseRootFromParent_Done,
     /*  377760 */   // Label 6824: @377760
     /*  377760 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(377826), // Rule ID 60923 //
     /*  377765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  377776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  377779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  377782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377824 */     GIR_RootConstrainSelectedInstOperands,
     /*  377825 */     // GIR_Coverage, 60923,
     /*  377825 */     GIR_EraseRootFromParent_Done,
     /*  377826 */   // Label 6825: @377826
     /*  377826 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(377892), // Rule ID 60926 //
     /*  377831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  377842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  377845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  377848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  377870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377890 */     GIR_RootConstrainSelectedInstOperands,
     /*  377891 */     // GIR_Coverage, 60926,
     /*  377891 */     GIR_EraseRootFromParent_Done,
     /*  377892 */   // Label 6826: @377892
     /*  377892 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(377958), // Rule ID 60927 //
     /*  377897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  377908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  377911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  377914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377936 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  377936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377956 */     GIR_RootConstrainSelectedInstOperands,
     /*  377957 */     // GIR_Coverage, 60927,
     /*  377957 */     GIR_EraseRootFromParent_Done,
     /*  377958 */   // Label 6827: @377958
     /*  377958 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(378024), // Rule ID 60930 //
     /*  377963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  377974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  377977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  377980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378002 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  378005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378022 */     GIR_RootConstrainSelectedInstOperands,
     /*  378023 */     // GIR_Coverage, 60930,
     /*  378023 */     GIR_EraseRootFromParent_Done,
     /*  378024 */   // Label 6828: @378024
     /*  378024 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(378090), // Rule ID 60931 //
     /*  378029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  378040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  378043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  378046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  378068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  378071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378088 */     GIR_RootConstrainSelectedInstOperands,
     /*  378089 */     // GIR_Coverage, 60931,
     /*  378089 */     GIR_EraseRootFromParent_Done,
     /*  378090 */   // Label 6829: @378090
     /*  378090 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(378156), // Rule ID 60934 //
     /*  378095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  378106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  378109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  378112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378134 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378154 */     GIR_RootConstrainSelectedInstOperands,
     /*  378155 */     // GIR_Coverage, 60934,
     /*  378155 */     GIR_EraseRootFromParent_Done,
     /*  378156 */   // Label 6830: @378156
     /*  378156 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(378222), // Rule ID 60935 //
     /*  378161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  378172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  378175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  378178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378220 */     GIR_RootConstrainSelectedInstOperands,
     /*  378221 */     // GIR_Coverage, 60935,
     /*  378221 */     GIR_EraseRootFromParent_Done,
     /*  378222 */   // Label 6831: @378222
     /*  378222 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(378288), // Rule ID 60938 //
     /*  378227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  378238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  378241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  378244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378266 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378286 */     GIR_RootConstrainSelectedInstOperands,
     /*  378287 */     // GIR_Coverage, 60938,
     /*  378287 */     GIR_EraseRootFromParent_Done,
     /*  378288 */   // Label 6832: @378288
     /*  378288 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(378354), // Rule ID 60939 //
     /*  378293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  378304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  378307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  378310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378332 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378352 */     GIR_RootConstrainSelectedInstOperands,
     /*  378353 */     // GIR_Coverage, 60939,
     /*  378353 */     GIR_EraseRootFromParent_Done,
     /*  378354 */   // Label 6833: @378354
     /*  378354 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(378420), // Rule ID 60942 //
     /*  378359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  378370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  378373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  378376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378398 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378418 */     GIR_RootConstrainSelectedInstOperands,
     /*  378419 */     // GIR_Coverage, 60942,
     /*  378419 */     GIR_EraseRootFromParent_Done,
     /*  378420 */   // Label 6834: @378420
     /*  378420 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(378486), // Rule ID 60943 //
     /*  378425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  378436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  378439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  378442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378464 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378484 */     GIR_RootConstrainSelectedInstOperands,
     /*  378485 */     // GIR_Coverage, 60943,
     /*  378485 */     GIR_EraseRootFromParent_Done,
     /*  378486 */   // Label 6835: @378486
     /*  378486 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(378552), // Rule ID 60946 //
     /*  378491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  378502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  378505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  378508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378550 */     GIR_RootConstrainSelectedInstOperands,
     /*  378551 */     // GIR_Coverage, 60946,
     /*  378551 */     GIR_EraseRootFromParent_Done,
     /*  378552 */   // Label 6836: @378552
     /*  378552 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(378618), // Rule ID 60947 //
     /*  378557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  378568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  378571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  378574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378596 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378616 */     GIR_RootConstrainSelectedInstOperands,
     /*  378617 */     // GIR_Coverage, 60947,
     /*  378617 */     GIR_EraseRootFromParent_Done,
     /*  378618 */   // Label 6837: @378618
     /*  378618 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(378684), // Rule ID 60950 //
     /*  378623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  378634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  378637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  378640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378662 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378682 */     GIR_RootConstrainSelectedInstOperands,
     /*  378683 */     // GIR_Coverage, 60950,
     /*  378683 */     GIR_EraseRootFromParent_Done,
     /*  378684 */   // Label 6838: @378684
     /*  378684 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(378750), // Rule ID 60951 //
     /*  378689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  378700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  378703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  378706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378728 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378748 */     GIR_RootConstrainSelectedInstOperands,
     /*  378749 */     // GIR_Coverage, 60951,
     /*  378749 */     GIR_EraseRootFromParent_Done,
     /*  378750 */   // Label 6839: @378750
     /*  378750 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(378816), // Rule ID 60954 //
     /*  378755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  378766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  378769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  378772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378794 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378814 */     GIR_RootConstrainSelectedInstOperands,
     /*  378815 */     // GIR_Coverage, 60954,
     /*  378815 */     GIR_EraseRootFromParent_Done,
     /*  378816 */   // Label 6840: @378816
     /*  378816 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(378882), // Rule ID 60955 //
     /*  378821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  378832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  378835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  378838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378860 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378880 */     GIR_RootConstrainSelectedInstOperands,
     /*  378881 */     // GIR_Coverage, 60955,
     /*  378881 */     GIR_EraseRootFromParent_Done,
     /*  378882 */   // Label 6841: @378882
     /*  378882 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(378948), // Rule ID 60958 //
     /*  378887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  378898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  378901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  378904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378946 */     GIR_RootConstrainSelectedInstOperands,
     /*  378947 */     // GIR_Coverage, 60958,
     /*  378947 */     GIR_EraseRootFromParent_Done,
     /*  378948 */   // Label 6842: @378948
     /*  378948 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(379014), // Rule ID 60959 //
     /*  378953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  378964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  378967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  378970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379012 */     GIR_RootConstrainSelectedInstOperands,
     /*  379013 */     // GIR_Coverage, 60959,
     /*  379013 */     GIR_EraseRootFromParent_Done,
     /*  379014 */   // Label 6843: @379014
     /*  379014 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(379080), // Rule ID 60962 //
     /*  379019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  379030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  379033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  379036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379058 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  379061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379078 */     GIR_RootConstrainSelectedInstOperands,
     /*  379079 */     // GIR_Coverage, 60962,
     /*  379079 */     GIR_EraseRootFromParent_Done,
     /*  379080 */   // Label 6844: @379080
     /*  379080 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(379146), // Rule ID 60963 //
     /*  379085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  379096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  379099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  379102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379124 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  379127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379144 */     GIR_RootConstrainSelectedInstOperands,
     /*  379145 */     // GIR_Coverage, 60963,
     /*  379145 */     GIR_EraseRootFromParent_Done,
     /*  379146 */   // Label 6845: @379146
     /*  379146 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(379212), // Rule ID 60966 //
     /*  379151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  379162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  379165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  379168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379190 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  379193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379210 */     GIR_RootConstrainSelectedInstOperands,
     /*  379211 */     // GIR_Coverage, 60966,
     /*  379211 */     GIR_EraseRootFromParent_Done,
     /*  379212 */   // Label 6846: @379212
     /*  379212 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(379278), // Rule ID 60967 //
     /*  379217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  379228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  379231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  379234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379256 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  379259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379276 */     GIR_RootConstrainSelectedInstOperands,
     /*  379277 */     // GIR_Coverage, 60967,
     /*  379277 */     GIR_EraseRootFromParent_Done,
     /*  379278 */   // Label 6847: @379278
     /*  379278 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(379344), // Rule ID 60970 //
     /*  379283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  379294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  379297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  379300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379322 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  379325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379342 */     GIR_RootConstrainSelectedInstOperands,
     /*  379343 */     // GIR_Coverage, 60970,
     /*  379343 */     GIR_EraseRootFromParent_Done,
     /*  379344 */   // Label 6848: @379344
     /*  379344 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(379410), // Rule ID 60971 //
     /*  379349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  379360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  379363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  379366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379388 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  379391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379408 */     GIR_RootConstrainSelectedInstOperands,
     /*  379409 */     // GIR_Coverage, 60971,
     /*  379409 */     GIR_EraseRootFromParent_Done,
     /*  379410 */   // Label 6849: @379410
     /*  379410 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(379476), // Rule ID 60974 //
     /*  379415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  379426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  379429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  379432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379454 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  379457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379474 */     GIR_RootConstrainSelectedInstOperands,
     /*  379475 */     // GIR_Coverage, 60974,
     /*  379475 */     GIR_EraseRootFromParent_Done,
     /*  379476 */   // Label 6850: @379476
     /*  379476 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(379542), // Rule ID 60975 //
     /*  379481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  379492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  379495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  379498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379520 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  379523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379540 */     GIR_RootConstrainSelectedInstOperands,
     /*  379541 */     // GIR_Coverage, 60975,
     /*  379541 */     GIR_EraseRootFromParent_Done,
     /*  379542 */   // Label 6851: @379542
     /*  379542 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(379608), // Rule ID 60978 //
     /*  379547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  379558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  379561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  379564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379586 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  379589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379606 */     GIR_RootConstrainSelectedInstOperands,
     /*  379607 */     // GIR_Coverage, 60978,
     /*  379607 */     GIR_EraseRootFromParent_Done,
     /*  379608 */   // Label 6852: @379608
     /*  379608 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(379674), // Rule ID 60979 //
     /*  379613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  379624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  379627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  379630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379652 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  379655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379672 */     GIR_RootConstrainSelectedInstOperands,
     /*  379673 */     // GIR_Coverage, 60979,
     /*  379673 */     GIR_EraseRootFromParent_Done,
     /*  379674 */   // Label 6853: @379674
     /*  379674 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(379740), // Rule ID 61402 //
     /*  379679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  379690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  379693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  379696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379718 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  379721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379738 */     GIR_RootConstrainSelectedInstOperands,
     /*  379739 */     // GIR_Coverage, 61402,
     /*  379739 */     GIR_EraseRootFromParent_Done,
     /*  379740 */   // Label 6854: @379740
     /*  379740 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(379806), // Rule ID 61403 //
     /*  379745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  379756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  379759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  379762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379784 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  379787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379804 */     GIR_RootConstrainSelectedInstOperands,
     /*  379805 */     // GIR_Coverage, 61403,
     /*  379805 */     GIR_EraseRootFromParent_Done,
     /*  379806 */   // Label 6855: @379806
     /*  379806 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(379872), // Rule ID 61406 //
     /*  379811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  379822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  379825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  379828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379850 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379870 */     GIR_RootConstrainSelectedInstOperands,
     /*  379871 */     // GIR_Coverage, 61406,
     /*  379871 */     GIR_EraseRootFromParent_Done,
     /*  379872 */   // Label 6856: @379872
     /*  379872 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(379938), // Rule ID 61407 //
     /*  379877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  379888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  379891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  379894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379916 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379936 */     GIR_RootConstrainSelectedInstOperands,
     /*  379937 */     // GIR_Coverage, 61407,
     /*  379937 */     GIR_EraseRootFromParent_Done,
     /*  379938 */   // Label 6857: @379938
     /*  379938 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(380004), // Rule ID 61410 //
     /*  379943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  379954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  379957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  379960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379982 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380002 */     GIR_RootConstrainSelectedInstOperands,
     /*  380003 */     // GIR_Coverage, 61410,
     /*  380003 */     GIR_EraseRootFromParent_Done,
     /*  380004 */   // Label 6858: @380004
     /*  380004 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(380070), // Rule ID 61411 //
     /*  380009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  380020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  380023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  380026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380048 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  380051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380068 */     GIR_RootConstrainSelectedInstOperands,
     /*  380069 */     // GIR_Coverage, 61411,
     /*  380069 */     GIR_EraseRootFromParent_Done,
     /*  380070 */   // Label 6859: @380070
     /*  380070 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(380136), // Rule ID 61414 //
     /*  380075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  380086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  380089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  380092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  380117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380134 */     GIR_RootConstrainSelectedInstOperands,
     /*  380135 */     // GIR_Coverage, 61414,
     /*  380135 */     GIR_EraseRootFromParent_Done,
     /*  380136 */   // Label 6860: @380136
     /*  380136 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(380202), // Rule ID 61415 //
     /*  380141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  380152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  380155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  380158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380180 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  380183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380200 */     GIR_RootConstrainSelectedInstOperands,
     /*  380201 */     // GIR_Coverage, 61415,
     /*  380201 */     GIR_EraseRootFromParent_Done,
     /*  380202 */   // Label 6861: @380202
     /*  380202 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(380268), // Rule ID 61418 //
     /*  380207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  380218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  380221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  380224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380246 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  380249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380266 */     GIR_RootConstrainSelectedInstOperands,
     /*  380267 */     // GIR_Coverage, 61418,
     /*  380267 */     GIR_EraseRootFromParent_Done,
     /*  380268 */   // Label 6862: @380268
     /*  380268 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(380334), // Rule ID 61419 //
     /*  380273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  380284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  380287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  380290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380312 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  380315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380332 */     GIR_RootConstrainSelectedInstOperands,
     /*  380333 */     // GIR_Coverage, 61419,
     /*  380333 */     GIR_EraseRootFromParent_Done,
     /*  380334 */   // Label 6863: @380334
     /*  380334 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(380400), // Rule ID 61422 //
     /*  380339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  380350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  380353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  380356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  380378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  380381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380398 */     GIR_RootConstrainSelectedInstOperands,
     /*  380399 */     // GIR_Coverage, 61422,
     /*  380399 */     GIR_EraseRootFromParent_Done,
     /*  380400 */   // Label 6864: @380400
     /*  380400 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(380466), // Rule ID 61423 //
     /*  380405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  380416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  380419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  380422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380444 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  380444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  380447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380464 */     GIR_RootConstrainSelectedInstOperands,
     /*  380465 */     // GIR_Coverage, 61423,
     /*  380465 */     GIR_EraseRootFromParent_Done,
     /*  380466 */   // Label 6865: @380466
     /*  380466 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(380532), // Rule ID 61426 //
     /*  380471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  380482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  380485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  380488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380510 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380530 */     GIR_RootConstrainSelectedInstOperands,
     /*  380531 */     // GIR_Coverage, 61426,
     /*  380531 */     GIR_EraseRootFromParent_Done,
     /*  380532 */   // Label 6866: @380532
     /*  380532 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(380598), // Rule ID 61427 //
     /*  380537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  380548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  380551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  380554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380576 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380596 */     GIR_RootConstrainSelectedInstOperands,
     /*  380597 */     // GIR_Coverage, 61427,
     /*  380597 */     GIR_EraseRootFromParent_Done,
     /*  380598 */   // Label 6867: @380598
     /*  380598 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(380664), // Rule ID 61430 //
     /*  380603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  380614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  380617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  380620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380642 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380662 */     GIR_RootConstrainSelectedInstOperands,
     /*  380663 */     // GIR_Coverage, 61430,
     /*  380663 */     GIR_EraseRootFromParent_Done,
     /*  380664 */   // Label 6868: @380664
     /*  380664 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(380730), // Rule ID 61431 //
     /*  380669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  380680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  380683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  380686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380728 */     GIR_RootConstrainSelectedInstOperands,
     /*  380729 */     // GIR_Coverage, 61431,
     /*  380729 */     GIR_EraseRootFromParent_Done,
     /*  380730 */   // Label 6869: @380730
     /*  380730 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(380796), // Rule ID 61434 //
     /*  380735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  380746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  380749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  380752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  380774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380794 */     GIR_RootConstrainSelectedInstOperands,
     /*  380795 */     // GIR_Coverage, 61434,
     /*  380795 */     GIR_EraseRootFromParent_Done,
     /*  380796 */   // Label 6870: @380796
     /*  380796 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(380862), // Rule ID 61435 //
     /*  380801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  380812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  380815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  380818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  380840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380860 */     GIR_RootConstrainSelectedInstOperands,
     /*  380861 */     // GIR_Coverage, 61435,
     /*  380861 */     GIR_EraseRootFromParent_Done,
     /*  380862 */   // Label 6871: @380862
     /*  380862 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(380928), // Rule ID 61438 //
     /*  380867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  380878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  380881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  380884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380906 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  380906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380926 */     GIR_RootConstrainSelectedInstOperands,
     /*  380927 */     // GIR_Coverage, 61438,
     /*  380927 */     GIR_EraseRootFromParent_Done,
     /*  380928 */   // Label 6872: @380928
     /*  380928 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(380994), // Rule ID 61439 //
     /*  380933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  380944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  380947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  380950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380972 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  380972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380992 */     GIR_RootConstrainSelectedInstOperands,
     /*  380993 */     // GIR_Coverage, 61439,
     /*  380993 */     GIR_EraseRootFromParent_Done,
     /*  380994 */   // Label 6873: @380994
     /*  380994 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(381060), // Rule ID 61442 //
     /*  380999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  381010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  381013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  381016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381038 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381058 */     GIR_RootConstrainSelectedInstOperands,
     /*  381059 */     // GIR_Coverage, 61442,
     /*  381059 */     GIR_EraseRootFromParent_Done,
     /*  381060 */   // Label 6874: @381060
     /*  381060 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(381126), // Rule ID 61443 //
     /*  381065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  381076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  381079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  381082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381104 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381124 */     GIR_RootConstrainSelectedInstOperands,
     /*  381125 */     // GIR_Coverage, 61443,
     /*  381125 */     GIR_EraseRootFromParent_Done,
     /*  381126 */   // Label 6875: @381126
     /*  381126 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(381192), // Rule ID 61446 //
     /*  381131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  381142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  381145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  381148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381170 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381190 */     GIR_RootConstrainSelectedInstOperands,
     /*  381191 */     // GIR_Coverage, 61446,
     /*  381191 */     GIR_EraseRootFromParent_Done,
     /*  381192 */   // Label 6876: @381192
     /*  381192 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(381258), // Rule ID 61447 //
     /*  381197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  381208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  381211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  381214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381236 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381256 */     GIR_RootConstrainSelectedInstOperands,
     /*  381257 */     // GIR_Coverage, 61447,
     /*  381257 */     GIR_EraseRootFromParent_Done,
     /*  381258 */   // Label 6877: @381258
     /*  381258 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(381324), // Rule ID 61450 //
     /*  381263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  381274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  381277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  381280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381302 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381322 */     GIR_RootConstrainSelectedInstOperands,
     /*  381323 */     // GIR_Coverage, 61450,
     /*  381323 */     GIR_EraseRootFromParent_Done,
     /*  381324 */   // Label 6878: @381324
     /*  381324 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(381390), // Rule ID 61451 //
     /*  381329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  381340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  381343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  381346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381368 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381388 */     GIR_RootConstrainSelectedInstOperands,
     /*  381389 */     // GIR_Coverage, 61451,
     /*  381389 */     GIR_EraseRootFromParent_Done,
     /*  381390 */   // Label 6879: @381390
     /*  381390 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(381456), // Rule ID 61454 //
     /*  381395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  381406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  381409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  381412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381434 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381454 */     GIR_RootConstrainSelectedInstOperands,
     /*  381455 */     // GIR_Coverage, 61454,
     /*  381455 */     GIR_EraseRootFromParent_Done,
     /*  381456 */   // Label 6880: @381456
     /*  381456 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(381522), // Rule ID 61455 //
     /*  381461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  381472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  381475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  381478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381500 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381520 */     GIR_RootConstrainSelectedInstOperands,
     /*  381521 */     // GIR_Coverage, 61455,
     /*  381521 */     GIR_EraseRootFromParent_Done,
     /*  381522 */   // Label 6881: @381522
     /*  381522 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(381588), // Rule ID 61458 //
     /*  381527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  381538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  381541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  381544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381566 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381586 */     GIR_RootConstrainSelectedInstOperands,
     /*  381587 */     // GIR_Coverage, 61458,
     /*  381587 */     GIR_EraseRootFromParent_Done,
     /*  381588 */   // Label 6882: @381588
     /*  381588 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(381654), // Rule ID 61459 //
     /*  381593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  381604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  381607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  381610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381632 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381652 */     GIR_RootConstrainSelectedInstOperands,
     /*  381653 */     // GIR_Coverage, 61459,
     /*  381653 */     GIR_EraseRootFromParent_Done,
     /*  381654 */   // Label 6883: @381654
     /*  381654 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(381720), // Rule ID 61462 //
     /*  381659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  381670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  381673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  381676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381698 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381718 */     GIR_RootConstrainSelectedInstOperands,
     /*  381719 */     // GIR_Coverage, 61462,
     /*  381719 */     GIR_EraseRootFromParent_Done,
     /*  381720 */   // Label 6884: @381720
     /*  381720 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(381786), // Rule ID 61463 //
     /*  381725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  381736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  381739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  381742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381764 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381784 */     GIR_RootConstrainSelectedInstOperands,
     /*  381785 */     // GIR_Coverage, 61463,
     /*  381785 */     GIR_EraseRootFromParent_Done,
     /*  381786 */   // Label 6885: @381786
     /*  381786 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(381852), // Rule ID 61466 //
     /*  381791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  381802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  381805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  381808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381850 */     GIR_RootConstrainSelectedInstOperands,
     /*  381851 */     // GIR_Coverage, 61466,
     /*  381851 */     GIR_EraseRootFromParent_Done,
     /*  381852 */   // Label 6886: @381852
     /*  381852 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(381918), // Rule ID 61467 //
     /*  381857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  381868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  381871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  381874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381916 */     GIR_RootConstrainSelectedInstOperands,
     /*  381917 */     // GIR_Coverage, 61467,
     /*  381917 */     GIR_EraseRootFromParent_Done,
     /*  381918 */   // Label 6887: @381918
     /*  381918 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(381984), // Rule ID 61470 //
     /*  381923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  381934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  381937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  381940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381962 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381982 */     GIR_RootConstrainSelectedInstOperands,
     /*  381983 */     // GIR_Coverage, 61470,
     /*  381983 */     GIR_EraseRootFromParent_Done,
     /*  381984 */   // Label 6888: @381984
     /*  381984 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(382050), // Rule ID 61471 //
     /*  381989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  382000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  382003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  382006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382028 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  382031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382048 */     GIR_RootConstrainSelectedInstOperands,
     /*  382049 */     // GIR_Coverage, 61471,
     /*  382049 */     GIR_EraseRootFromParent_Done,
     /*  382050 */   // Label 6889: @382050
     /*  382050 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(382116), // Rule ID 61474 //
     /*  382055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  382066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  382069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  382072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382094 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  382097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382114 */     GIR_RootConstrainSelectedInstOperands,
     /*  382115 */     // GIR_Coverage, 61474,
     /*  382115 */     GIR_EraseRootFromParent_Done,
     /*  382116 */   // Label 6890: @382116
     /*  382116 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(382182), // Rule ID 61475 //
     /*  382121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  382132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  382135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  382138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382160 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  382163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382180 */     GIR_RootConstrainSelectedInstOperands,
     /*  382181 */     // GIR_Coverage, 61475,
     /*  382181 */     GIR_EraseRootFromParent_Done,
     /*  382182 */   // Label 6891: @382182
     /*  382182 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(382248), // Rule ID 61478 //
     /*  382187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  382198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  382201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  382204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  382229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382246 */     GIR_RootConstrainSelectedInstOperands,
     /*  382247 */     // GIR_Coverage, 61478,
     /*  382247 */     GIR_EraseRootFromParent_Done,
     /*  382248 */   // Label 6892: @382248
     /*  382248 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(382314), // Rule ID 61479 //
     /*  382253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  382264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  382267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  382270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  382295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382312 */     GIR_RootConstrainSelectedInstOperands,
     /*  382313 */     // GIR_Coverage, 61479,
     /*  382313 */     GIR_EraseRootFromParent_Done,
     /*  382314 */   // Label 6893: @382314
     /*  382314 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(382380), // Rule ID 61482 //
     /*  382319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  382330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  382333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  382336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382358 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  382361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382378 */     GIR_RootConstrainSelectedInstOperands,
     /*  382379 */     // GIR_Coverage, 61482,
     /*  382379 */     GIR_EraseRootFromParent_Done,
     /*  382380 */   // Label 6894: @382380
     /*  382380 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(382446), // Rule ID 61483 //
     /*  382385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  382396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  382399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  382402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382424 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  382427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382444 */     GIR_RootConstrainSelectedInstOperands,
     /*  382445 */     // GIR_Coverage, 61483,
     /*  382445 */     GIR_EraseRootFromParent_Done,
     /*  382446 */   // Label 6895: @382446
     /*  382446 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(382512), // Rule ID 61486 //
     /*  382451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  382468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382490 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  382493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382510 */     GIR_RootConstrainSelectedInstOperands,
     /*  382511 */     // GIR_Coverage, 61486,
     /*  382511 */     GIR_EraseRootFromParent_Done,
     /*  382512 */   // Label 6896: @382512
     /*  382512 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(382578), // Rule ID 61487 //
     /*  382517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  382534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382556 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  382559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382576 */     GIR_RootConstrainSelectedInstOperands,
     /*  382577 */     // GIR_Coverage, 61487,
     /*  382577 */     GIR_EraseRootFromParent_Done,
     /*  382578 */   // Label 6897: @382578
     /*  382578 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(382644), // Rule ID 61490 //
     /*  382583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  382594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  382597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  382600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382622 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  382625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382642 */     GIR_RootConstrainSelectedInstOperands,
     /*  382643 */     // GIR_Coverage, 61490,
     /*  382643 */     GIR_EraseRootFromParent_Done,
     /*  382644 */   // Label 6898: @382644
     /*  382644 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(382710), // Rule ID 61491 //
     /*  382649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  382660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  382663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  382666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382688 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  382691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382708 */     GIR_RootConstrainSelectedInstOperands,
     /*  382709 */     // GIR_Coverage, 61491,
     /*  382709 */     GIR_EraseRootFromParent_Done,
     /*  382710 */   // Label 6899: @382710
     /*  382710 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(382776), // Rule ID 61494 //
     /*  382715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  382726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  382729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  382732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382754 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382774 */     GIR_RootConstrainSelectedInstOperands,
     /*  382775 */     // GIR_Coverage, 61494,
     /*  382775 */     GIR_EraseRootFromParent_Done,
     /*  382776 */   // Label 6900: @382776
     /*  382776 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(382842), // Rule ID 61495 //
     /*  382781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  382792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  382795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  382798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382820 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382840 */     GIR_RootConstrainSelectedInstOperands,
     /*  382841 */     // GIR_Coverage, 61495,
     /*  382841 */     GIR_EraseRootFromParent_Done,
     /*  382842 */   // Label 6901: @382842
     /*  382842 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(382908), // Rule ID 61498 //
     /*  382847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  382858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  382861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  382864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382886 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382906 */     GIR_RootConstrainSelectedInstOperands,
     /*  382907 */     // GIR_Coverage, 61498,
     /*  382907 */     GIR_EraseRootFromParent_Done,
     /*  382908 */   // Label 6902: @382908
     /*  382908 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(382974), // Rule ID 61499 //
     /*  382913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  382924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  382927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  382930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382952 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382972 */     GIR_RootConstrainSelectedInstOperands,
     /*  382973 */     // GIR_Coverage, 61499,
     /*  382973 */     GIR_EraseRootFromParent_Done,
     /*  382974 */   // Label 6903: @382974
     /*  382974 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(383040), // Rule ID 61502 //
     /*  382979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  382990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  382993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  382996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  383021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383038 */     GIR_RootConstrainSelectedInstOperands,
     /*  383039 */     // GIR_Coverage, 61502,
     /*  383039 */     GIR_EraseRootFromParent_Done,
     /*  383040 */   // Label 6904: @383040
     /*  383040 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(383106), // Rule ID 61503 //
     /*  383045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  383056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  383059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  383062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  383087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383104 */     GIR_RootConstrainSelectedInstOperands,
     /*  383105 */     // GIR_Coverage, 61503,
     /*  383105 */     GIR_EraseRootFromParent_Done,
     /*  383106 */   // Label 6905: @383106
     /*  383106 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(383172), // Rule ID 61506 //
     /*  383111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  383122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  383125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  383128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383150 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  383153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383170 */     GIR_RootConstrainSelectedInstOperands,
     /*  383171 */     // GIR_Coverage, 61506,
     /*  383171 */     GIR_EraseRootFromParent_Done,
     /*  383172 */   // Label 6906: @383172
     /*  383172 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(383238), // Rule ID 61507 //
     /*  383177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  383188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  383191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  383194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383216 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  383219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383236 */     GIR_RootConstrainSelectedInstOperands,
     /*  383237 */     // GIR_Coverage, 61507,
     /*  383237 */     GIR_EraseRootFromParent_Done,
     /*  383238 */   // Label 6907: @383238
     /*  383238 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(383304), // Rule ID 61510 //
     /*  383243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  383254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  383257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  383260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383282 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  383285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383302 */     GIR_RootConstrainSelectedInstOperands,
     /*  383303 */     // GIR_Coverage, 61510,
     /*  383303 */     GIR_EraseRootFromParent_Done,
     /*  383304 */   // Label 6908: @383304
     /*  383304 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(383370), // Rule ID 61511 //
     /*  383309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  383320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  383323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  383326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383348 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  383351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383368 */     GIR_RootConstrainSelectedInstOperands,
     /*  383369 */     // GIR_Coverage, 61511,
     /*  383369 */     GIR_EraseRootFromParent_Done,
     /*  383370 */   // Label 6909: @383370
     /*  383370 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(383436), // Rule ID 61514 //
     /*  383375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  383386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  383389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  383392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383414 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383434 */     GIR_RootConstrainSelectedInstOperands,
     /*  383435 */     // GIR_Coverage, 61514,
     /*  383435 */     GIR_EraseRootFromParent_Done,
     /*  383436 */   // Label 6910: @383436
     /*  383436 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(383502), // Rule ID 61515 //
     /*  383441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  383452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  383455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  383458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383480 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383500 */     GIR_RootConstrainSelectedInstOperands,
     /*  383501 */     // GIR_Coverage, 61515,
     /*  383501 */     GIR_EraseRootFromParent_Done,
     /*  383502 */   // Label 6911: @383502
     /*  383502 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(383568), // Rule ID 61518 //
     /*  383507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  383518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  383521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  383524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383566 */     GIR_RootConstrainSelectedInstOperands,
     /*  383567 */     // GIR_Coverage, 61518,
     /*  383567 */     GIR_EraseRootFromParent_Done,
     /*  383568 */   // Label 6912: @383568
     /*  383568 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(383634), // Rule ID 61519 //
     /*  383573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  383584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  383587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  383590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383612 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383632 */     GIR_RootConstrainSelectedInstOperands,
     /*  383633 */     // GIR_Coverage, 61519,
     /*  383633 */     GIR_EraseRootFromParent_Done,
     /*  383634 */   // Label 6913: @383634
     /*  383634 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(383700), // Rule ID 61522 //
     /*  383639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  383650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  383653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  383656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383698 */     GIR_RootConstrainSelectedInstOperands,
     /*  383699 */     // GIR_Coverage, 61522,
     /*  383699 */     GIR_EraseRootFromParent_Done,
     /*  383700 */   // Label 6914: @383700
     /*  383700 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(383766), // Rule ID 61523 //
     /*  383705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  383716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  383719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  383722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383764 */     GIR_RootConstrainSelectedInstOperands,
     /*  383765 */     // GIR_Coverage, 61523,
     /*  383765 */     GIR_EraseRootFromParent_Done,
     /*  383766 */   // Label 6915: @383766
     /*  383766 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(383832), // Rule ID 61526 //
     /*  383771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  383782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  383785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  383788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383810 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  383810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383830 */     GIR_RootConstrainSelectedInstOperands,
     /*  383831 */     // GIR_Coverage, 61526,
     /*  383831 */     GIR_EraseRootFromParent_Done,
     /*  383832 */   // Label 6916: @383832
     /*  383832 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(383898), // Rule ID 61527 //
     /*  383837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  383848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  383851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  383854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  383876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383896 */     GIR_RootConstrainSelectedInstOperands,
     /*  383897 */     // GIR_Coverage, 61527,
     /*  383897 */     GIR_EraseRootFromParent_Done,
     /*  383898 */   // Label 6917: @383898
     /*  383898 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(383964), // Rule ID 61530 //
     /*  383903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  383914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  383917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  383920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383942 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383962 */     GIR_RootConstrainSelectedInstOperands,
     /*  383963 */     // GIR_Coverage, 61530,
     /*  383963 */     GIR_EraseRootFromParent_Done,
     /*  383964 */   // Label 6918: @383964
     /*  383964 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(384030), // Rule ID 61531 //
     /*  383969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  383980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  383983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  383986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384008 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  384008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384028 */     GIR_RootConstrainSelectedInstOperands,
     /*  384029 */     // GIR_Coverage, 61531,
     /*  384029 */     GIR_EraseRootFromParent_Done,
     /*  384030 */   // Label 6919: @384030
     /*  384030 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(384096), // Rule ID 61534 //
     /*  384035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  384046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  384049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  384052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384074 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  384074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384094 */     GIR_RootConstrainSelectedInstOperands,
     /*  384095 */     // GIR_Coverage, 61534,
     /*  384095 */     GIR_EraseRootFromParent_Done,
     /*  384096 */   // Label 6920: @384096
     /*  384096 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(384162), // Rule ID 61535 //
     /*  384101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  384112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  384115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  384118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384140 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  384140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384160 */     GIR_RootConstrainSelectedInstOperands,
     /*  384161 */     // GIR_Coverage, 61535,
     /*  384161 */     GIR_EraseRootFromParent_Done,
     /*  384162 */   // Label 6921: @384162
     /*  384162 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(384228), // Rule ID 61538 //
     /*  384167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  384178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  384181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  384184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384206 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  384206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384226 */     GIR_RootConstrainSelectedInstOperands,
     /*  384227 */     // GIR_Coverage, 61538,
     /*  384227 */     GIR_EraseRootFromParent_Done,
     /*  384228 */   // Label 6922: @384228
     /*  384228 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(384294), // Rule ID 61539 //
     /*  384233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  384244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  384247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  384250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384272 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  384272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384292 */     GIR_RootConstrainSelectedInstOperands,
     /*  384293 */     // GIR_Coverage, 61539,
     /*  384293 */     GIR_EraseRootFromParent_Done,
     /*  384294 */   // Label 6923: @384294
     /*  384294 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(384360), // Rule ID 61542 //
     /*  384299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  384310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  384313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  384316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384338 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384358 */     GIR_RootConstrainSelectedInstOperands,
     /*  384359 */     // GIR_Coverage, 61542,
     /*  384359 */     GIR_EraseRootFromParent_Done,
     /*  384360 */   // Label 6924: @384360
     /*  384360 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(384426), // Rule ID 61543 //
     /*  384365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  384376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  384379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  384382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384424 */     GIR_RootConstrainSelectedInstOperands,
     /*  384425 */     // GIR_Coverage, 61543,
     /*  384425 */     GIR_EraseRootFromParent_Done,
     /*  384426 */   // Label 6925: @384426
     /*  384426 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(384492), // Rule ID 61546 //
     /*  384431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  384442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  384445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  384448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384470 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384490 */     GIR_RootConstrainSelectedInstOperands,
     /*  384491 */     // GIR_Coverage, 61546,
     /*  384491 */     GIR_EraseRootFromParent_Done,
     /*  384492 */   // Label 6926: @384492
     /*  384492 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(384558), // Rule ID 61547 //
     /*  384497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  384508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  384511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  384514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384536 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384556 */     GIR_RootConstrainSelectedInstOperands,
     /*  384557 */     // GIR_Coverage, 61547,
     /*  384557 */     GIR_EraseRootFromParent_Done,
     /*  384558 */   // Label 6927: @384558
     /*  384558 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(384624), // Rule ID 61550 //
     /*  384563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  384574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  384577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  384580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384602 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384622 */     GIR_RootConstrainSelectedInstOperands,
     /*  384623 */     // GIR_Coverage, 61550,
     /*  384623 */     GIR_EraseRootFromParent_Done,
     /*  384624 */   // Label 6928: @384624
     /*  384624 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(384690), // Rule ID 61551 //
     /*  384629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  384640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  384643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  384646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384668 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384688 */     GIR_RootConstrainSelectedInstOperands,
     /*  384689 */     // GIR_Coverage, 61551,
     /*  384689 */     GIR_EraseRootFromParent_Done,
     /*  384690 */   // Label 6929: @384690
     /*  384690 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(384756), // Rule ID 61554 //
     /*  384695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  384706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  384709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  384712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384754 */     GIR_RootConstrainSelectedInstOperands,
     /*  384755 */     // GIR_Coverage, 61554,
     /*  384755 */     GIR_EraseRootFromParent_Done,
     /*  384756 */   // Label 6930: @384756
     /*  384756 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(384822), // Rule ID 61555 //
     /*  384761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  384772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  384775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  384778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384800 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384820 */     GIR_RootConstrainSelectedInstOperands,
     /*  384821 */     // GIR_Coverage, 61555,
     /*  384821 */     GIR_EraseRootFromParent_Done,
     /*  384822 */   // Label 6931: @384822
     /*  384822 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(384888), // Rule ID 61558 //
     /*  384827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  384838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  384841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  384844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384886 */     GIR_RootConstrainSelectedInstOperands,
     /*  384887 */     // GIR_Coverage, 61558,
     /*  384887 */     GIR_EraseRootFromParent_Done,
     /*  384888 */   // Label 6932: @384888
     /*  384888 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(384954), // Rule ID 61559 //
     /*  384893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  384904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  384907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  384910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384932 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384952 */     GIR_RootConstrainSelectedInstOperands,
     /*  384953 */     // GIR_Coverage, 61559,
     /*  384953 */     GIR_EraseRootFromParent_Done,
     /*  384954 */   // Label 6933: @384954
     /*  384954 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(385020), // Rule ID 61562 //
     /*  384959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  384970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  384973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  384976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384998 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  385001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385018 */     GIR_RootConstrainSelectedInstOperands,
     /*  385019 */     // GIR_Coverage, 61562,
     /*  385019 */     GIR_EraseRootFromParent_Done,
     /*  385020 */   // Label 6934: @385020
     /*  385020 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(385086), // Rule ID 61563 //
     /*  385025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  385036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  385039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  385042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385064 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  385064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  385067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385084 */     GIR_RootConstrainSelectedInstOperands,
     /*  385085 */     // GIR_Coverage, 61563,
     /*  385085 */     GIR_EraseRootFromParent_Done,
     /*  385086 */   // Label 6935: @385086
     /*  385086 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(385152), // Rule ID 61566 //
     /*  385091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  385102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  385105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  385108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  385130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  385133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385150 */     GIR_RootConstrainSelectedInstOperands,
     /*  385151 */     // GIR_Coverage, 61566,
     /*  385151 */     GIR_EraseRootFromParent_Done,
     /*  385152 */   // Label 6936: @385152
     /*  385152 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(385218), // Rule ID 61567 //
     /*  385157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  385168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  385171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  385174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  385196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  385199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385216 */     GIR_RootConstrainSelectedInstOperands,
     /*  385217 */     // GIR_Coverage, 61567,
     /*  385217 */     GIR_EraseRootFromParent_Done,
     /*  385218 */   // Label 6937: @385218
     /*  385218 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(385284), // Rule ID 61570 //
     /*  385223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  385234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  385237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  385240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385262 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  385262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  385265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385282 */     GIR_RootConstrainSelectedInstOperands,
     /*  385283 */     // GIR_Coverage, 61570,
     /*  385283 */     GIR_EraseRootFromParent_Done,
     /*  385284 */   // Label 6938: @385284
     /*  385284 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(385350), // Rule ID 61571 //
     /*  385289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  385300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  385303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  385306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385328 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  385328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  385331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385348 */     GIR_RootConstrainSelectedInstOperands,
     /*  385349 */     // GIR_Coverage, 61571,
     /*  385349 */     GIR_EraseRootFromParent_Done,
     /*  385350 */   // Label 6939: @385350
     /*  385350 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(385416), // Rule ID 61574 //
     /*  385355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  385366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  385369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  385372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  385394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  385397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385414 */     GIR_RootConstrainSelectedInstOperands,
     /*  385415 */     // GIR_Coverage, 61574,
     /*  385415 */     GIR_EraseRootFromParent_Done,
     /*  385416 */   // Label 6940: @385416
     /*  385416 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(385482), // Rule ID 61575 //
     /*  385421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  385432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  385435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  385438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385460 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  385460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  385463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385480 */     GIR_RootConstrainSelectedInstOperands,
     /*  385481 */     // GIR_Coverage, 61575,
     /*  385481 */     GIR_EraseRootFromParent_Done,
     /*  385482 */   // Label 6941: @385482
     /*  385482 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(385547), // Rule ID 64466 //
     /*  385487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  385495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385531 */     // MIs[1] Operand 1
     /*  385531 */     // No operand predicates
     /*  385531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385533 */     // (intrinsic_wo_chain:{ *:[i32] } 11022:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDN),
     /*  385536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385545 */     GIR_RootConstrainSelectedInstOperands,
     /*  385546 */     // GIR_Coverage, 64466,
     /*  385546 */     GIR_EraseRootFromParent_Done,
     /*  385547 */   // Label 6942: @385547
     /*  385547 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(385612), // Rule ID 64493 //
     /*  385552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  385560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385596 */     // MIs[1] Operand 1
     /*  385596 */     // No operand predicates
     /*  385596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385598 */     // (intrinsic_wo_chain:{ *:[i32] } 11024:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUN),
     /*  385601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385610 */     GIR_RootConstrainSelectedInstOperands,
     /*  385611 */     // GIR_Coverage, 64493,
     /*  385611 */     GIR_EraseRootFromParent_Done,
     /*  385612 */   // Label 6943: @385612
     /*  385612 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(385677), // Rule ID 64496 //
     /*  385617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  385625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385661 */     // MIs[1] Operand 1
     /*  385661 */     // No operand predicates
     /*  385661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385663 */     // (intrinsic_wo_chain:{ *:[i32] } 11023:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRN),
     /*  385666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385675 */     GIR_RootConstrainSelectedInstOperands,
     /*  385676 */     // GIR_Coverage, 64496,
     /*  385676 */     GIR_EraseRootFromParent_Done,
     /*  385677 */   // Label 6944: @385677
     /*  385677 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(385742), // Rule ID 64499 //
     /*  385682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  385690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385722 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385726 */     // MIs[1] Operand 1
     /*  385726 */     // No operand predicates
     /*  385726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385728 */     // (intrinsic_wo_chain:{ *:[i32] } 11025:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURN),
     /*  385731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385740 */     GIR_RootConstrainSelectedInstOperands,
     /*  385741 */     // GIR_Coverage, 64499,
     /*  385741 */     GIR_EraseRootFromParent_Done,
     /*  385742 */   // Label 6945: @385742
     /*  385742 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(385807), // Rule ID 64502 //
     /*  385747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  385755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385791 */     // MIs[1] Operand 1
     /*  385791 */     // No operand predicates
     /*  385791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385793 */     // (intrinsic_wo_chain:{ *:[i32] } 11028:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBN),
     /*  385796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385805 */     GIR_RootConstrainSelectedInstOperands,
     /*  385806 */     // GIR_Coverage, 64502,
     /*  385806 */     GIR_EraseRootFromParent_Done,
     /*  385807 */   // Label 6946: @385807
     /*  385807 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(385872), // Rule ID 64505 //
     /*  385812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  385820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385856 */     // MIs[1] Operand 1
     /*  385856 */     // No operand predicates
     /*  385856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385858 */     // (intrinsic_wo_chain:{ *:[i32] } 11030:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUN),
     /*  385861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385870 */     GIR_RootConstrainSelectedInstOperands,
     /*  385871 */     // GIR_Coverage, 64505,
     /*  385871 */     GIR_EraseRootFromParent_Done,
     /*  385872 */   // Label 6947: @385872
     /*  385872 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(385937), // Rule ID 64508 //
     /*  385877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  385885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385921 */     // MIs[1] Operand 1
     /*  385921 */     // No operand predicates
     /*  385921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385923 */     // (intrinsic_wo_chain:{ *:[i32] } 11029:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRN),
     /*  385926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385935 */     GIR_RootConstrainSelectedInstOperands,
     /*  385936 */     // GIR_Coverage, 64508,
     /*  385936 */     GIR_EraseRootFromParent_Done,
     /*  385937 */   // Label 6948: @385937
     /*  385937 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(386002), // Rule ID 64511 //
     /*  385942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  385950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385986 */     // MIs[1] Operand 1
     /*  385986 */     // No operand predicates
     /*  385986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385988 */     // (intrinsic_wo_chain:{ *:[i32] } 11031:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURN),
     /*  385991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  386000 */     GIR_RootConstrainSelectedInstOperands,
     /*  386001 */     // GIR_Coverage, 64511,
     /*  386001 */     GIR_EraseRootFromParent_Done,
     /*  386002 */   // Label 6949: @386002
     /*  386002 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(386057), // Rule ID 2659 //
     /*  386007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  386010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsi),
     /*  386015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386036 */     // MIs[0] imm
     /*  386036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  386044 */     // (intrinsic_wo_chain:{ *:[i32] } 11007:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  386044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSI),
     /*  386047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386053 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  386055 */     GIR_RootConstrainSelectedInstOperands,
     /*  386056 */     // GIR_Coverage, 2659,
     /*  386056 */     GIR_EraseRootFromParent_Done,
     /*  386057 */   // Label 6950: @386057
     /*  386057 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(386112), // Rule ID 2660 //
     /*  386062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  386065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsmi),
     /*  386070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386091 */     // MIs[0] imm
     /*  386091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  386099 */     // (intrinsic_wo_chain:{ *:[i32] } 11008:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  386099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSMI),
     /*  386102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386108 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  386110 */     GIR_RootConstrainSelectedInstOperands,
     /*  386111 */     // GIR_Coverage, 2660,
     /*  386111 */     GIR_EraseRootFromParent_Done,
     /*  386112 */   // Label 6951: @386112
     /*  386112 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(386167), // Rule ID 2666 //
     /*  386117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  386120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esi),
     /*  386125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386146 */     // MIs[0] imm
     /*  386146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  386154 */     // (intrinsic_wo_chain:{ *:[i32] } 11009:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  386154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESI),
     /*  386157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386163 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  386165 */     GIR_RootConstrainSelectedInstOperands,
     /*  386166 */     // GIR_Coverage, 2666,
     /*  386166 */     GIR_EraseRootFromParent_Done,
     /*  386167 */   // Label 6952: @386167
     /*  386167 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(386222), // Rule ID 2667 //
     /*  386172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  386175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esmi),
     /*  386180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386201 */     // MIs[0] imm
     /*  386201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  386209 */     // (intrinsic_wo_chain:{ *:[i32] } 11010:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  386209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESMI),
     /*  386212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386218 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  386220 */     GIR_RootConstrainSelectedInstOperands,
     /*  386221 */     // GIR_Coverage, 2667,
     /*  386221 */     GIR_EraseRootFromParent_Done,
     /*  386222 */   // Label 6953: @386222
     /*  386222 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(386277), // Rule ID 64522 //
     /*  386227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluN),
     /*  386235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386256 */     // MIs[0] imm5
     /*  386256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386264 */     // (intrinsic_wo_chain:{ *:[i32] } 11055:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULUN),
     /*  386267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386273 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386275 */     GIR_RootConstrainSelectedInstOperands,
     /*  386276 */     // GIR_Coverage, 64522,
     /*  386276 */     GIR_EraseRootFromParent_Done,
     /*  386277 */   // Label 6954: @386277
     /*  386277 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(386332), // Rule ID 64523 //
     /*  386282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuN),
     /*  386290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386311 */     // MIs[0] imm5
     /*  386311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386319 */     // (intrinsic_wo_chain:{ *:[i32] } 11051:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHUN),
     /*  386322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386328 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386330 */     GIR_RootConstrainSelectedInstOperands,
     /*  386331 */     // GIR_Coverage, 64523,
     /*  386331 */     GIR_EraseRootFromParent_Done,
     /*  386332 */   // Label 6955: @386332
     /*  386332 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(386387), // Rule ID 64524 //
     /*  386337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsN),
     /*  386345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386366 */     // MIs[0] imm5
     /*  386366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386374 */     // (intrinsic_wo_chain:{ *:[i32] } 11053:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSN),
     /*  386377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386383 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386385 */     GIR_RootConstrainSelectedInstOperands,
     /*  386386 */     // GIR_Coverage, 64524,
     /*  386386 */     GIR_EraseRootFromParent_Done,
     /*  386387 */   // Label 6956: @386387
     /*  386387 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(386442), // Rule ID 64525 //
     /*  386392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsN),
     /*  386400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386421 */     // MIs[0] imm5
     /*  386421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386429 */     // (intrinsic_wo_chain:{ *:[i32] } 11049:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSN),
     /*  386432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386438 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386440 */     GIR_RootConstrainSelectedInstOperands,
     /*  386441 */     // GIR_Coverage, 64525,
     /*  386441 */     GIR_EraseRootFromParent_Done,
     /*  386442 */   // Label 6957: @386442
     /*  386442 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(386497), // Rule ID 64526 //
     /*  386447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluRN),
     /*  386455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386476 */     // MIs[0] imm5
     /*  386476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386479 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386484 */     // (intrinsic_wo_chain:{ *:[i32] } 11056:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULURN),
     /*  386487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386493 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386495 */     GIR_RootConstrainSelectedInstOperands,
     /*  386496 */     // GIR_Coverage, 64526,
     /*  386496 */     GIR_EraseRootFromParent_Done,
     /*  386497 */   // Label 6958: @386497
     /*  386497 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(386552), // Rule ID 64527 //
     /*  386502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuRN),
     /*  386510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386531 */     // MIs[0] imm5
     /*  386531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386539 */     // (intrinsic_wo_chain:{ *:[i32] } 11052:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHURN),
     /*  386542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386548 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386550 */     GIR_RootConstrainSelectedInstOperands,
     /*  386551 */     // GIR_Coverage, 64527,
     /*  386551 */     GIR_EraseRootFromParent_Done,
     /*  386552 */   // Label 6959: @386552
     /*  386552 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(386607), // Rule ID 64528 //
     /*  386557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsRN),
     /*  386565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386586 */     // MIs[0] imm5
     /*  386586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386594 */     // (intrinsic_wo_chain:{ *:[i32] } 11054:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSRN),
     /*  386597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386603 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386605 */     GIR_RootConstrainSelectedInstOperands,
     /*  386606 */     // GIR_Coverage, 64528,
     /*  386606 */     GIR_EraseRootFromParent_Done,
     /*  386607 */   // Label 6960: @386607
     /*  386607 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(386662), // Rule ID 64529 //
     /*  386612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsRN),
     /*  386620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386641 */     // MIs[0] imm5
     /*  386641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386649 */     // (intrinsic_wo_chain:{ *:[i32] } 11050:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSRN),
     /*  386652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386658 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386660 */     GIR_RootConstrainSelectedInstOperands,
     /*  386661 */     // GIR_Coverage, 64529,
     /*  386661 */     GIR_EraseRootFromParent_Done,
     /*  386662 */   // Label 6961: @386662
     /*  386662 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(386716), // Rule ID 64464 //
     /*  386667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  386675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386703 */     // (intrinsic_wo_chain:{ *:[i32] } 11022:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  386706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386714 */     GIR_RootConstrainSelectedInstOperands,
     /*  386715 */     // GIR_Coverage, 64464,
     /*  386715 */     GIR_EraseRootFromParent_Done,
     /*  386716 */   // Label 6962: @386716
     /*  386716 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(386770), // Rule ID 64465 //
     /*  386721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  386729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386757 */     // (intrinsic_wo_chain:{ *:[i32] } 11022:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  386760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386768 */     GIR_RootConstrainSelectedInstOperands,
     /*  386769 */     // GIR_Coverage, 64465,
     /*  386769 */     GIR_EraseRootFromParent_Done,
     /*  386770 */   // Label 6963: @386770
     /*  386770 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(386824), // Rule ID 64491 //
     /*  386775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  386783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386811 */     // (intrinsic_wo_chain:{ *:[i32] } 11024:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  386814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386822 */     GIR_RootConstrainSelectedInstOperands,
     /*  386823 */     // GIR_Coverage, 64491,
     /*  386823 */     GIR_EraseRootFromParent_Done,
     /*  386824 */   // Label 6964: @386824
     /*  386824 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(386878), // Rule ID 64492 //
     /*  386829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  386837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386865 */     // (intrinsic_wo_chain:{ *:[i32] } 11024:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  386868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386876 */     GIR_RootConstrainSelectedInstOperands,
     /*  386877 */     // GIR_Coverage, 64492,
     /*  386877 */     GIR_EraseRootFromParent_Done,
     /*  386878 */   // Label 6965: @386878
     /*  386878 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(386932), // Rule ID 64494 //
     /*  386883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  386891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386919 */     // (intrinsic_wo_chain:{ *:[i32] } 11023:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  386922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386930 */     GIR_RootConstrainSelectedInstOperands,
     /*  386931 */     // GIR_Coverage, 64494,
     /*  386931 */     GIR_EraseRootFromParent_Done,
     /*  386932 */   // Label 6966: @386932
     /*  386932 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(386986), // Rule ID 64495 //
     /*  386937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  386945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386973 */     // (intrinsic_wo_chain:{ *:[i32] } 11023:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  386976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386984 */     GIR_RootConstrainSelectedInstOperands,
     /*  386985 */     // GIR_Coverage, 64495,
     /*  386985 */     GIR_EraseRootFromParent_Done,
     /*  386986 */   // Label 6967: @386986
     /*  386986 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(387040), // Rule ID 64497 //
     /*  386991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  386999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387027 */     // (intrinsic_wo_chain:{ *:[i32] } 11025:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  387030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387038 */     GIR_RootConstrainSelectedInstOperands,
     /*  387039 */     // GIR_Coverage, 64497,
     /*  387039 */     GIR_EraseRootFromParent_Done,
     /*  387040 */   // Label 6968: @387040
     /*  387040 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(387094), // Rule ID 64498 //
     /*  387045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  387048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  387053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387081 */     // (intrinsic_wo_chain:{ *:[i32] } 11025:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  387084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387092 */     GIR_RootConstrainSelectedInstOperands,
     /*  387093 */     // GIR_Coverage, 64498,
     /*  387093 */     GIR_EraseRootFromParent_Done,
     /*  387094 */   // Label 6969: @387094
     /*  387094 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(387148), // Rule ID 64500 //
     /*  387099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  387102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  387107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387135 */     // (intrinsic_wo_chain:{ *:[i32] } 11028:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  387138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387146 */     GIR_RootConstrainSelectedInstOperands,
     /*  387147 */     // GIR_Coverage, 64500,
     /*  387147 */     GIR_EraseRootFromParent_Done,
     /*  387148 */   // Label 6970: @387148
     /*  387148 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(387202), // Rule ID 64501 //
     /*  387153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  387156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  387161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387189 */     // (intrinsic_wo_chain:{ *:[i32] } 11028:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  387192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387200 */     GIR_RootConstrainSelectedInstOperands,
     /*  387201 */     // GIR_Coverage, 64501,
     /*  387201 */     GIR_EraseRootFromParent_Done,
     /*  387202 */   // Label 6971: @387202
     /*  387202 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(387256), // Rule ID 64503 //
     /*  387207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  387210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  387215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387243 */     // (intrinsic_wo_chain:{ *:[i32] } 11030:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  387246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387254 */     GIR_RootConstrainSelectedInstOperands,
     /*  387255 */     // GIR_Coverage, 64503,
     /*  387255 */     GIR_EraseRootFromParent_Done,
     /*  387256 */   // Label 6972: @387256
     /*  387256 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(387310), // Rule ID 64504 //
     /*  387261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  387264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  387269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387297 */     // (intrinsic_wo_chain:{ *:[i32] } 11030:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  387300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387308 */     GIR_RootConstrainSelectedInstOperands,
     /*  387309 */     // GIR_Coverage, 64504,
     /*  387309 */     GIR_EraseRootFromParent_Done,
     /*  387310 */   // Label 6973: @387310
     /*  387310 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(387364), // Rule ID 64506 //
     /*  387315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  387318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  387323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387351 */     // (intrinsic_wo_chain:{ *:[i32] } 11029:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  387354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387362 */     GIR_RootConstrainSelectedInstOperands,
     /*  387363 */     // GIR_Coverage, 64506,
     /*  387363 */     GIR_EraseRootFromParent_Done,
     /*  387364 */   // Label 6974: @387364
     /*  387364 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(387418), // Rule ID 64507 //
     /*  387369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  387372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  387377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387405 */     // (intrinsic_wo_chain:{ *:[i32] } 11029:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  387408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387416 */     GIR_RootConstrainSelectedInstOperands,
     /*  387417 */     // GIR_Coverage, 64507,
     /*  387417 */     GIR_EraseRootFromParent_Done,
     /*  387418 */   // Label 6975: @387418
     /*  387418 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(387472), // Rule ID 64509 //
     /*  387423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  387426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  387431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387459 */     // (intrinsic_wo_chain:{ *:[i32] } 11031:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  387462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387470 */     GIR_RootConstrainSelectedInstOperands,
     /*  387471 */     // GIR_Coverage, 64509,
     /*  387471 */     GIR_EraseRootFromParent_Done,
     /*  387472 */   // Label 6976: @387472
     /*  387472 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(387526), // Rule ID 64510 //
     /*  387477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  387480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  387485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387513 */     // (intrinsic_wo_chain:{ *:[i32] } 11031:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  387516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387524 */     GIR_RootConstrainSelectedInstOperands,
     /*  387525 */     // GIR_Coverage, 64510,
     /*  387525 */     GIR_EraseRootFromParent_Done,
     /*  387526 */   // Label 6977: @387526
     /*  387526 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(387580), // Rule ID 64447 //
     /*  387531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /*  387534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  387539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387567 */     // (intrinsic_wo_chain:{ *:[i32] } 11038:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  387570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387578 */     GIR_RootConstrainSelectedInstOperands,
     /*  387579 */     // GIR_Coverage, 64447,
     /*  387579 */     GIR_EraseRootFromParent_Done,
     /*  387580 */   // Label 6978: @387580
     /*  387580 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(387634), // Rule ID 64448 //
     /*  387585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  387588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  387593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387621 */     // (intrinsic_wo_chain:{ *:[i32] } 11038:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  387624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387632 */     GIR_RootConstrainSelectedInstOperands,
     /*  387633 */     // GIR_Coverage, 64448,
     /*  387633 */     GIR_EraseRootFromParent_Done,
     /*  387634 */   // Label 6979: @387634
     /*  387634 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(387688), // Rule ID 64518 //
     /*  387639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  387642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  387647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387675 */     // (intrinsic_wo_chain:{ *:[i32] } 11039:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  387678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387686 */     GIR_RootConstrainSelectedInstOperands,
     /*  387687 */     // GIR_Coverage, 64518,
     /*  387687 */     GIR_EraseRootFromParent_Done,
     /*  387688 */   // Label 6980: @387688
     /*  387688 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(387742), // Rule ID 64519 //
     /*  387693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  387696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  387701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387729 */     // (intrinsic_wo_chain:{ *:[i32] } 11039:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  387732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387740 */     GIR_RootConstrainSelectedInstOperands,
     /*  387741 */     // GIR_Coverage, 64519,
     /*  387741 */     GIR_EraseRootFromParent_Done,
     /*  387742 */   // Label 6981: @387742
     /*  387742 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(387796), // Rule ID 64520 //
     /*  387747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  387750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  387755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387783 */     // (intrinsic_wo_chain:{ *:[i32] } 11048:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  387786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387794 */     GIR_RootConstrainSelectedInstOperands,
     /*  387795 */     // GIR_Coverage, 64520,
     /*  387795 */     GIR_EraseRootFromParent_Done,
     /*  387796 */   // Label 6982: @387796
     /*  387796 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(387850), // Rule ID 64521 //
     /*  387801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  387804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  387809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387837 */     // (intrinsic_wo_chain:{ *:[i32] } 11048:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  387840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387848 */     GIR_RootConstrainSelectedInstOperands,
     /*  387849 */     // GIR_Coverage, 64521,
     /*  387849 */     GIR_EraseRootFromParent_Done,
     /*  387850 */   // Label 6983: @387850
     /*  387850 */   GIM_Reject,
     /*  387851 */ // Label 4358: @387851
     /*  387851 */ GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(906628),
     /*  387856 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  387859 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(387934), // Rule ID 62851 //
     /*  387864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  387875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387882 */     // MIs[0] op1
     /*  387882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387890 */     // MIs[0] op2
     /*  387890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387898 */     // MIs[0] op3
     /*  387898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387913 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  387913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF8),
     /*  387916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387918 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387920 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387922 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387932 */     GIR_RootConstrainSelectedInstOperands,
     /*  387933 */     // GIR_Coverage, 62851,
     /*  387933 */     GIR_EraseRootFromParent_Done,
     /*  387934 */   // Label 6985: @387934
     /*  387934 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(388009), // Rule ID 62852 //
     /*  387939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  387950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387957 */     // MIs[0] op1
     /*  387957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387960 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387965 */     // MIs[0] op2
     /*  387965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387973 */     // MIs[0] op3
     /*  387973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387976 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387988 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  387988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF8),
     /*  387991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387993 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387995 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387997 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388007 */     GIR_RootConstrainSelectedInstOperands,
     /*  388008 */     // GIR_Coverage, 62852,
     /*  388008 */     GIR_EraseRootFromParent_Done,
     /*  388009 */   // Label 6986: @388009
     /*  388009 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(388084), // Rule ID 62883 //
     /*  388014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  388025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388032 */     // MIs[0] op1
     /*  388032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388040 */     // MIs[0] op2
     /*  388040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388048 */     // MIs[0] op3
     /*  388048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388063 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF4),
     /*  388066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388068 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388070 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388072 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388082 */     GIR_RootConstrainSelectedInstOperands,
     /*  388083 */     // GIR_Coverage, 62883,
     /*  388083 */     GIR_EraseRootFromParent_Done,
     /*  388084 */   // Label 6987: @388084
     /*  388084 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(388159), // Rule ID 62884 //
     /*  388089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  388100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388107 */     // MIs[0] op1
     /*  388107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388115 */     // MIs[0] op2
     /*  388115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388123 */     // MIs[0] op3
     /*  388123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388138 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  388138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF4),
     /*  388141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388143 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388145 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388147 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388157 */     GIR_RootConstrainSelectedInstOperands,
     /*  388158 */     // GIR_Coverage, 62884,
     /*  388158 */     GIR_EraseRootFromParent_Done,
     /*  388159 */   // Label 6988: @388159
     /*  388159 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(388234), // Rule ID 62927 //
     /*  388164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  388175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388182 */     // MIs[0] op1
     /*  388182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388190 */     // MIs[0] op2
     /*  388190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388193 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388198 */     // MIs[0] op3
     /*  388198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388213 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388218 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388220 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388222 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388232 */     GIR_RootConstrainSelectedInstOperands,
     /*  388233 */     // GIR_Coverage, 62927,
     /*  388233 */     GIR_EraseRootFromParent_Done,
     /*  388234 */   // Label 6989: @388234
     /*  388234 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(388309), // Rule ID 62928 //
     /*  388239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  388250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388257 */     // MIs[0] op1
     /*  388257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388260 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388265 */     // MIs[0] op2
     /*  388265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388273 */     // MIs[0] op3
     /*  388273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388288 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  388288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388293 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388295 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388297 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388307 */     GIR_RootConstrainSelectedInstOperands,
     /*  388308 */     // GIR_Coverage, 62928,
     /*  388308 */     GIR_EraseRootFromParent_Done,
     /*  388309 */   // Label 6990: @388309
     /*  388309 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(388384), // Rule ID 62971 //
     /*  388314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  388325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388332 */     // MIs[0] op1
     /*  388332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388340 */     // MIs[0] op2
     /*  388340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388348 */     // MIs[0] op3
     /*  388348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388363 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  388363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF4),
     /*  388366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388368 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388370 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388372 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388382 */     GIR_RootConstrainSelectedInstOperands,
     /*  388383 */     // GIR_Coverage, 62971,
     /*  388383 */     GIR_EraseRootFromParent_Done,
     /*  388384 */   // Label 6991: @388384
     /*  388384 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(388459), // Rule ID 62972 //
     /*  388389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  388400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388407 */     // MIs[0] op1
     /*  388407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388415 */     // MIs[0] op2
     /*  388415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388423 */     // MIs[0] op3
     /*  388423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388438 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  388438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF4),
     /*  388441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388443 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388445 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388447 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388457 */     GIR_RootConstrainSelectedInstOperands,
     /*  388458 */     // GIR_Coverage, 62972,
     /*  388458 */     GIR_EraseRootFromParent_Done,
     /*  388459 */   // Label 6992: @388459
     /*  388459 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(388534), // Rule ID 63027 //
     /*  388464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  388475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388482 */     // MIs[0] op1
     /*  388482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388485 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388490 */     // MIs[0] op2
     /*  388490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388493 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388498 */     // MIs[0] op3
     /*  388498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388513 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  388513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388518 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388520 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388522 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388532 */     GIR_RootConstrainSelectedInstOperands,
     /*  388533 */     // GIR_Coverage, 63027,
     /*  388533 */     GIR_EraseRootFromParent_Done,
     /*  388534 */   // Label 6993: @388534
     /*  388534 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(388609), // Rule ID 63028 //
     /*  388539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  388550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388557 */     // MIs[0] op1
     /*  388557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388560 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388565 */     // MIs[0] op2
     /*  388565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388568 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388573 */     // MIs[0] op3
     /*  388573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388588 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  388588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388593 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388595 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388597 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388607 */     GIR_RootConstrainSelectedInstOperands,
     /*  388608 */     // GIR_Coverage, 63028,
     /*  388608 */     GIR_EraseRootFromParent_Done,
     /*  388609 */   // Label 6994: @388609
     /*  388609 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(388684), // Rule ID 63083 //
     /*  388614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  388625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388632 */     // MIs[0] op1
     /*  388632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388640 */     // MIs[0] op2
     /*  388640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388648 */     // MIs[0] op3
     /*  388648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388651 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388663 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  388663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388668 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388670 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388672 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388682 */     GIR_RootConstrainSelectedInstOperands,
     /*  388683 */     // GIR_Coverage, 63083,
     /*  388683 */     GIR_EraseRootFromParent_Done,
     /*  388684 */   // Label 6995: @388684
     /*  388684 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(388759), // Rule ID 63084 //
     /*  388689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  388700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388707 */     // MIs[0] op1
     /*  388707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388715 */     // MIs[0] op2
     /*  388715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388723 */     // MIs[0] op3
     /*  388723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388738 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  388738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388743 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388745 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388747 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388757 */     GIR_RootConstrainSelectedInstOperands,
     /*  388758 */     // GIR_Coverage, 63084,
     /*  388758 */     GIR_EraseRootFromParent_Done,
     /*  388759 */   // Label 6996: @388759
     /*  388759 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(388834), // Rule ID 63139 //
     /*  388764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  388775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388782 */     // MIs[0] op1
     /*  388782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388790 */     // MIs[0] op2
     /*  388790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388798 */     // MIs[0] op3
     /*  388798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388813 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388818 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388820 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388822 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388832 */     GIR_RootConstrainSelectedInstOperands,
     /*  388833 */     // GIR_Coverage, 63139,
     /*  388833 */     GIR_EraseRootFromParent_Done,
     /*  388834 */   // Label 6997: @388834
     /*  388834 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(388909), // Rule ID 63140 //
     /*  388839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  388850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388857 */     // MIs[0] op1
     /*  388857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388865 */     // MIs[0] op2
     /*  388865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388873 */     // MIs[0] op3
     /*  388873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388888 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  388888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388893 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388895 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388897 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388907 */     GIR_RootConstrainSelectedInstOperands,
     /*  388908 */     // GIR_Coverage, 63140,
     /*  388908 */     GIR_EraseRootFromParent_Done,
     /*  388909 */   // Label 6998: @388909
     /*  388909 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(388984), // Rule ID 63183 //
     /*  388914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  388925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388932 */     // MIs[0] op1
     /*  388932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388940 */     // MIs[0] op2
     /*  388940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388948 */     // MIs[0] op3
     /*  388948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388963 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  388963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388968 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388970 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388972 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388982 */     GIR_RootConstrainSelectedInstOperands,
     /*  388983 */     // GIR_Coverage, 63183,
     /*  388983 */     GIR_EraseRootFromParent_Done,
     /*  388984 */   // Label 6999: @388984
     /*  388984 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(389059), // Rule ID 63184 //
     /*  388989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  389000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389007 */     // MIs[0] op1
     /*  389007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389015 */     // MIs[0] op2
     /*  389015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389023 */     // MIs[0] op3
     /*  389023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389038 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  389038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  389041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389043 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389045 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389047 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389057 */     GIR_RootConstrainSelectedInstOperands,
     /*  389058 */     // GIR_Coverage, 63184,
     /*  389058 */     GIR_EraseRootFromParent_Done,
     /*  389059 */   // Label 7000: @389059
     /*  389059 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(389134), // Rule ID 63239 //
     /*  389064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  389075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389082 */     // MIs[0] op1
     /*  389082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389085 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389090 */     // MIs[0] op2
     /*  389090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389093 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389098 */     // MIs[0] op3
     /*  389098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389113 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  389113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  389116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389118 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389120 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389122 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389132 */     GIR_RootConstrainSelectedInstOperands,
     /*  389133 */     // GIR_Coverage, 63239,
     /*  389133 */     GIR_EraseRootFromParent_Done,
     /*  389134 */   // Label 7001: @389134
     /*  389134 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(389209), // Rule ID 63240 //
     /*  389139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  389150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389157 */     // MIs[0] op1
     /*  389157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389160 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389165 */     // MIs[0] op2
     /*  389165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389168 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389173 */     // MIs[0] op3
     /*  389173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  389188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  389191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389193 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389195 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389197 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389207 */     GIR_RootConstrainSelectedInstOperands,
     /*  389208 */     // GIR_Coverage, 63240,
     /*  389208 */     GIR_EraseRootFromParent_Done,
     /*  389209 */   // Label 7002: @389209
     /*  389209 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(389284), // Rule ID 63295 //
     /*  389214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  389225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389232 */     // MIs[0] op1
     /*  389232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389240 */     // MIs[0] op2
     /*  389240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389248 */     // MIs[0] op3
     /*  389248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389263 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  389263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  389266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389268 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389270 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389272 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  389282 */     GIR_RootConstrainSelectedInstOperands,
     /*  389283 */     // GIR_Coverage, 63295,
     /*  389283 */     GIR_EraseRootFromParent_Done,
     /*  389284 */   // Label 7003: @389284
     /*  389284 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(389359), // Rule ID 63296 //
     /*  389289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  389300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389307 */     // MIs[0] op1
     /*  389307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389310 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389315 */     // MIs[0] op2
     /*  389315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389323 */     // MIs[0] op3
     /*  389323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389338 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  389338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  389341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389343 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389345 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389347 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  389357 */     GIR_RootConstrainSelectedInstOperands,
     /*  389358 */     // GIR_Coverage, 63296,
     /*  389358 */     GIR_EraseRootFromParent_Done,
     /*  389359 */   // Label 7004: @389359
     /*  389359 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(389434), // Rule ID 63351 //
     /*  389364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  389375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389382 */     // MIs[0] op1
     /*  389382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389390 */     // MIs[0] op2
     /*  389390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389398 */     // MIs[0] op3
     /*  389398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389413 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  389413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389418 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389420 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389422 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389432 */     GIR_RootConstrainSelectedInstOperands,
     /*  389433 */     // GIR_Coverage, 63351,
     /*  389433 */     GIR_EraseRootFromParent_Done,
     /*  389434 */   // Label 7005: @389434
     /*  389434 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(389509), // Rule ID 63352 //
     /*  389439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  389450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389457 */     // MIs[0] op1
     /*  389457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389465 */     // MIs[0] op2
     /*  389465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389468 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389473 */     // MIs[0] op3
     /*  389473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389476 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389488 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  389488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389493 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389495 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389497 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389507 */     GIR_RootConstrainSelectedInstOperands,
     /*  389508 */     // GIR_Coverage, 63352,
     /*  389508 */     GIR_EraseRootFromParent_Done,
     /*  389509 */   // Label 7006: @389509
     /*  389509 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(389584), // Rule ID 63395 //
     /*  389514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  389525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389532 */     // MIs[0] op1
     /*  389532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389540 */     // MIs[0] op2
     /*  389540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389548 */     // MIs[0] op3
     /*  389548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389551 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389563 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  389563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  389566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389568 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389570 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389572 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389582 */     GIR_RootConstrainSelectedInstOperands,
     /*  389583 */     // GIR_Coverage, 63395,
     /*  389583 */     GIR_EraseRootFromParent_Done,
     /*  389584 */   // Label 7007: @389584
     /*  389584 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(389659), // Rule ID 63396 //
     /*  389589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  389600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389607 */     // MIs[0] op1
     /*  389607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389615 */     // MIs[0] op2
     /*  389615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389623 */     // MIs[0] op3
     /*  389623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389638 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  389638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  389641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389643 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389645 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389647 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389657 */     GIR_RootConstrainSelectedInstOperands,
     /*  389658 */     // GIR_Coverage, 63396,
     /*  389658 */     GIR_EraseRootFromParent_Done,
     /*  389659 */   // Label 7008: @389659
     /*  389659 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(389734), // Rule ID 63439 //
     /*  389664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  389675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389682 */     // MIs[0] op1
     /*  389682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389690 */     // MIs[0] op2
     /*  389690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389698 */     // MIs[0] op3
     /*  389698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389701 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389713 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  389713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  389716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389718 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389720 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389722 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389732 */     GIR_RootConstrainSelectedInstOperands,
     /*  389733 */     // GIR_Coverage, 63439,
     /*  389733 */     GIR_EraseRootFromParent_Done,
     /*  389734 */   // Label 7009: @389734
     /*  389734 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(389809), // Rule ID 63440 //
     /*  389739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  389750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389757 */     // MIs[0] op1
     /*  389757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389765 */     // MIs[0] op2
     /*  389765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389773 */     // MIs[0] op3
     /*  389773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389776 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389788 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  389788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  389791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389793 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389795 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389797 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389807 */     GIR_RootConstrainSelectedInstOperands,
     /*  389808 */     // GIR_Coverage, 63440,
     /*  389808 */     GIR_EraseRootFromParent_Done,
     /*  389809 */   // Label 7010: @389809
     /*  389809 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(389884), // Rule ID 63483 //
     /*  389814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  389825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389832 */     // MIs[0] op1
     /*  389832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389840 */     // MIs[0] op2
     /*  389840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389848 */     // MIs[0] op3
     /*  389848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389863 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  389863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389868 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389870 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389872 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389882 */     GIR_RootConstrainSelectedInstOperands,
     /*  389883 */     // GIR_Coverage, 63483,
     /*  389883 */     GIR_EraseRootFromParent_Done,
     /*  389884 */   // Label 7011: @389884
     /*  389884 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(389959), // Rule ID 63484 //
     /*  389889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  389900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389907 */     // MIs[0] op1
     /*  389907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389915 */     // MIs[0] op2
     /*  389915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389923 */     // MIs[0] op3
     /*  389923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389938 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  389938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389943 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389945 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389947 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389957 */     GIR_RootConstrainSelectedInstOperands,
     /*  389958 */     // GIR_Coverage, 63484,
     /*  389958 */     GIR_EraseRootFromParent_Done,
     /*  389959 */   // Label 7012: @389959
     /*  389959 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(390034), // Rule ID 63539 //
     /*  389964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  389975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389982 */     // MIs[0] op1
     /*  389982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389985 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389990 */     // MIs[0] op2
     /*  389990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389998 */     // MIs[0] op3
     /*  389998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390013 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  390013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390018 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390020 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390022 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390032 */     GIR_RootConstrainSelectedInstOperands,
     /*  390033 */     // GIR_Coverage, 63539,
     /*  390033 */     GIR_EraseRootFromParent_Done,
     /*  390034 */   // Label 7013: @390034
     /*  390034 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(390109), // Rule ID 63540 //
     /*  390039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  390050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390057 */     // MIs[0] op1
     /*  390057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390065 */     // MIs[0] op2
     /*  390065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390073 */     // MIs[0] op3
     /*  390073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390088 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  390088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390093 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390095 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390097 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390107 */     GIR_RootConstrainSelectedInstOperands,
     /*  390108 */     // GIR_Coverage, 63540,
     /*  390108 */     GIR_EraseRootFromParent_Done,
     /*  390109 */   // Label 7014: @390109
     /*  390109 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(390184), // Rule ID 63595 //
     /*  390114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  390125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390132 */     // MIs[0] op1
     /*  390132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390140 */     // MIs[0] op2
     /*  390140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390148 */     // MIs[0] op3
     /*  390148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390151 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390163 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  390163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  390166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390168 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390170 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390172 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390182 */     GIR_RootConstrainSelectedInstOperands,
     /*  390183 */     // GIR_Coverage, 63595,
     /*  390183 */     GIR_EraseRootFromParent_Done,
     /*  390184 */   // Label 7015: @390184
     /*  390184 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(390259), // Rule ID 63596 //
     /*  390189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  390200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390207 */     // MIs[0] op1
     /*  390207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390215 */     // MIs[0] op2
     /*  390215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390218 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390223 */     // MIs[0] op3
     /*  390223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390226 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390238 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  390238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  390241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390243 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390245 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390247 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390257 */     GIR_RootConstrainSelectedInstOperands,
     /*  390258 */     // GIR_Coverage, 63596,
     /*  390258 */     GIR_EraseRootFromParent_Done,
     /*  390259 */   // Label 7016: @390259
     /*  390259 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(390334), // Rule ID 63651 //
     /*  390264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  390275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390282 */     // MIs[0] op1
     /*  390282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390290 */     // MIs[0] op2
     /*  390290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390298 */     // MIs[0] op3
     /*  390298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390301 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390313 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  390313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  390316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390318 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390320 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390322 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390332 */     GIR_RootConstrainSelectedInstOperands,
     /*  390333 */     // GIR_Coverage, 63651,
     /*  390333 */     GIR_EraseRootFromParent_Done,
     /*  390334 */   // Label 7017: @390334
     /*  390334 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(390409), // Rule ID 63652 //
     /*  390339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  390350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390357 */     // MIs[0] op1
     /*  390357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390365 */     // MIs[0] op2
     /*  390365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390373 */     // MIs[0] op3
     /*  390373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  390388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  390391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390393 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390395 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390397 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390407 */     GIR_RootConstrainSelectedInstOperands,
     /*  390408 */     // GIR_Coverage, 63652,
     /*  390408 */     GIR_EraseRootFromParent_Done,
     /*  390409 */   // Label 7018: @390409
     /*  390409 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(390484), // Rule ID 63707 //
     /*  390414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  390425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390432 */     // MIs[0] op1
     /*  390432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390440 */     // MIs[0] op2
     /*  390440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390448 */     // MIs[0] op3
     /*  390448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390463 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  390463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390468 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390470 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390472 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390482 */     GIR_RootConstrainSelectedInstOperands,
     /*  390483 */     // GIR_Coverage, 63707,
     /*  390483 */     GIR_EraseRootFromParent_Done,
     /*  390484 */   // Label 7019: @390484
     /*  390484 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(390559), // Rule ID 63708 //
     /*  390489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  390500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390507 */     // MIs[0] op1
     /*  390507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390515 */     // MIs[0] op2
     /*  390515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390523 */     // MIs[0] op3
     /*  390523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390538 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  390538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390543 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390545 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390547 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390557 */     GIR_RootConstrainSelectedInstOperands,
     /*  390558 */     // GIR_Coverage, 63708,
     /*  390558 */     GIR_EraseRootFromParent_Done,
     /*  390559 */   // Label 7020: @390559
     /*  390559 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(390634), // Rule ID 63763 //
     /*  390564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  390575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390582 */     // MIs[0] op1
     /*  390582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390590 */     // MIs[0] op2
     /*  390590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390598 */     // MIs[0] op3
     /*  390598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390613 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  390613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  390616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390618 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390620 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390622 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390632 */     GIR_RootConstrainSelectedInstOperands,
     /*  390633 */     // GIR_Coverage, 63763,
     /*  390633 */     GIR_EraseRootFromParent_Done,
     /*  390634 */   // Label 7021: @390634
     /*  390634 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(390709), // Rule ID 63764 //
     /*  390639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  390650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390657 */     // MIs[0] op1
     /*  390657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390665 */     // MIs[0] op2
     /*  390665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390673 */     // MIs[0] op3
     /*  390673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390688 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  390688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  390691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390693 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390695 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390697 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390707 */     GIR_RootConstrainSelectedInstOperands,
     /*  390708 */     // GIR_Coverage, 63764,
     /*  390708 */     GIR_EraseRootFromParent_Done,
     /*  390709 */   // Label 7022: @390709
     /*  390709 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(390784), // Rule ID 63819 //
     /*  390714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  390725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390732 */     // MIs[0] op1
     /*  390732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390740 */     // MIs[0] op2
     /*  390740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390748 */     // MIs[0] op3
     /*  390748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390763 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  390763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  390766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390768 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390770 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390772 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390782 */     GIR_RootConstrainSelectedInstOperands,
     /*  390783 */     // GIR_Coverage, 63819,
     /*  390783 */     GIR_EraseRootFromParent_Done,
     /*  390784 */   // Label 7023: @390784
     /*  390784 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(390859), // Rule ID 63820 //
     /*  390789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  390800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390807 */     // MIs[0] op1
     /*  390807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390815 */     // MIs[0] op2
     /*  390815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390823 */     // MIs[0] op3
     /*  390823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390838 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  390838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  390841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390843 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390845 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390847 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390857 */     GIR_RootConstrainSelectedInstOperands,
     /*  390858 */     // GIR_Coverage, 63820,
     /*  390858 */     GIR_EraseRootFromParent_Done,
     /*  390859 */   // Label 7024: @390859
     /*  390859 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(390934), // Rule ID 63875 //
     /*  390864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  390875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390882 */     // MIs[0] op1
     /*  390882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390890 */     // MIs[0] op2
     /*  390890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390898 */     // MIs[0] op3
     /*  390898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390913 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  390913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390918 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390920 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390922 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390932 */     GIR_RootConstrainSelectedInstOperands,
     /*  390933 */     // GIR_Coverage, 63875,
     /*  390933 */     GIR_EraseRootFromParent_Done,
     /*  390934 */   // Label 7025: @390934
     /*  390934 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(391009), // Rule ID 63876 //
     /*  390939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  390950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390957 */     // MIs[0] op1
     /*  390957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390960 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390965 */     // MIs[0] op2
     /*  390965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390973 */     // MIs[0] op3
     /*  390973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390976 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390988 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  390988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390993 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390995 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390997 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391007 */     GIR_RootConstrainSelectedInstOperands,
     /*  391008 */     // GIR_Coverage, 63876,
     /*  391008 */     GIR_EraseRootFromParent_Done,
     /*  391009 */   // Label 7026: @391009
     /*  391009 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(391084), // Rule ID 63931 //
     /*  391014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  391025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391032 */     // MIs[0] op1
     /*  391032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391040 */     // MIs[0] op2
     /*  391040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391048 */     // MIs[0] op3
     /*  391048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391063 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11122:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  391063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  391066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391068 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391070 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391072 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391082 */     GIR_RootConstrainSelectedInstOperands,
     /*  391083 */     // GIR_Coverage, 63931,
     /*  391083 */     GIR_EraseRootFromParent_Done,
     /*  391084 */   // Label 7027: @391084
     /*  391084 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(391159), // Rule ID 63932 //
     /*  391089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  391100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391107 */     // MIs[0] op1
     /*  391107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391115 */     // MIs[0] op2
     /*  391115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391123 */     // MIs[0] op3
     /*  391123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391138 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11122:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  391138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  391141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391143 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391145 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391147 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391157 */     GIR_RootConstrainSelectedInstOperands,
     /*  391158 */     // GIR_Coverage, 63932,
     /*  391158 */     GIR_EraseRootFromParent_Done,
     /*  391159 */   // Label 7028: @391159
     /*  391159 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(391233), // Rule ID 62833 //
     /*  391164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  391175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391185 */     // MIs[0] op1
     /*  391185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391193 */     // MIs[0] op2
     /*  391193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391212 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF8),
     /*  391215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391217 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391219 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391221 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391231 */     GIR_RootConstrainSelectedInstOperands,
     /*  391232 */     // GIR_Coverage, 62833,
     /*  391232 */     GIR_EraseRootFromParent_Done,
     /*  391233 */   // Label 7029: @391233
     /*  391233 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(391307), // Rule ID 62834 //
     /*  391238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  391249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391259 */     // MIs[0] op1
     /*  391259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391262 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391267 */     // MIs[0] op2
     /*  391267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391286 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF8),
     /*  391289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391291 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391293 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391295 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391305 */     GIR_RootConstrainSelectedInstOperands,
     /*  391306 */     // GIR_Coverage, 62834,
     /*  391306 */     GIR_EraseRootFromParent_Done,
     /*  391307 */   // Label 7030: @391307
     /*  391307 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(391381), // Rule ID 62879 //
     /*  391312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  391323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391333 */     // MIs[0] op1
     /*  391333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391341 */     // MIs[0] op2
     /*  391341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391360 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF4),
     /*  391363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391365 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391367 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391369 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391379 */     GIR_RootConstrainSelectedInstOperands,
     /*  391380 */     // GIR_Coverage, 62879,
     /*  391380 */     GIR_EraseRootFromParent_Done,
     /*  391381 */   // Label 7031: @391381
     /*  391381 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(391455), // Rule ID 62880 //
     /*  391386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  391397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391407 */     // MIs[0] op1
     /*  391407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391415 */     // MIs[0] op2
     /*  391415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391434 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF4),
     /*  391437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391439 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391441 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391443 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391453 */     GIR_RootConstrainSelectedInstOperands,
     /*  391454 */     // GIR_Coverage, 62880,
     /*  391454 */     GIR_EraseRootFromParent_Done,
     /*  391455 */   // Label 7032: @391455
     /*  391455 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(391529), // Rule ID 62923 //
     /*  391460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  391471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391481 */     // MIs[0] op1
     /*  391481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391489 */     // MIs[0] op2
     /*  391489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391508 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391513 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391515 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391517 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391527 */     GIR_RootConstrainSelectedInstOperands,
     /*  391528 */     // GIR_Coverage, 62923,
     /*  391528 */     GIR_EraseRootFromParent_Done,
     /*  391529 */   // Label 7033: @391529
     /*  391529 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(391603), // Rule ID 62924 //
     /*  391534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  391545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391555 */     // MIs[0] op1
     /*  391555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391563 */     // MIs[0] op2
     /*  391563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391582 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391587 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391589 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391591 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391601 */     GIR_RootConstrainSelectedInstOperands,
     /*  391602 */     // GIR_Coverage, 62924,
     /*  391602 */     GIR_EraseRootFromParent_Done,
     /*  391603 */   // Label 7034: @391603
     /*  391603 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(391677), // Rule ID 62967 //
     /*  391608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391629 */     // MIs[0] op1
     /*  391629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391637 */     // MIs[0] op2
     /*  391637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391656 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF4),
     /*  391659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391661 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391663 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391665 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391675 */     GIR_RootConstrainSelectedInstOperands,
     /*  391676 */     // GIR_Coverage, 62967,
     /*  391676 */     GIR_EraseRootFromParent_Done,
     /*  391677 */   // Label 7035: @391677
     /*  391677 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(391751), // Rule ID 62968 //
     /*  391682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391703 */     // MIs[0] op1
     /*  391703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391711 */     // MIs[0] op2
     /*  391711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391730 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF4),
     /*  391733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391735 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391737 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391739 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391749 */     GIR_RootConstrainSelectedInstOperands,
     /*  391750 */     // GIR_Coverage, 62968,
     /*  391750 */     GIR_EraseRootFromParent_Done,
     /*  391751 */   // Label 7036: @391751
     /*  391751 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(391825), // Rule ID 63023 //
     /*  391756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391777 */     // MIs[0] op1
     /*  391777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391785 */     // MIs[0] op2
     /*  391785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391804 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391809 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391811 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391813 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391823 */     GIR_RootConstrainSelectedInstOperands,
     /*  391824 */     // GIR_Coverage, 63023,
     /*  391824 */     GIR_EraseRootFromParent_Done,
     /*  391825 */   // Label 7037: @391825
     /*  391825 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(391899), // Rule ID 63024 //
     /*  391830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391851 */     // MIs[0] op1
     /*  391851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391859 */     // MIs[0] op2
     /*  391859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391878 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391883 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391885 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391887 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391897 */     GIR_RootConstrainSelectedInstOperands,
     /*  391898 */     // GIR_Coverage, 63024,
     /*  391898 */     GIR_EraseRootFromParent_Done,
     /*  391899 */   // Label 7038: @391899
     /*  391899 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(391973), // Rule ID 63079 //
     /*  391904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  391915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391925 */     // MIs[0] op1
     /*  391925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391933 */     // MIs[0] op2
     /*  391933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391952 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  391952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391957 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391959 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391961 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391971 */     GIR_RootConstrainSelectedInstOperands,
     /*  391972 */     // GIR_Coverage, 63079,
     /*  391972 */     GIR_EraseRootFromParent_Done,
     /*  391973 */   // Label 7039: @391973
     /*  391973 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(392047), // Rule ID 63080 //
     /*  391978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  391989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391999 */     // MIs[0] op1
     /*  391999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392007 */     // MIs[0] op2
     /*  392007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392026 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  392026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  392029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392031 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392033 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392035 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392045 */     GIR_RootConstrainSelectedInstOperands,
     /*  392046 */     // GIR_Coverage, 63080,
     /*  392046 */     GIR_EraseRootFromParent_Done,
     /*  392047 */   // Label 7040: @392047
     /*  392047 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(392121), // Rule ID 63135 //
     /*  392052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  392063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392073 */     // MIs[0] op1
     /*  392073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392081 */     // MIs[0] op2
     /*  392081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392100 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392105 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392107 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392109 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392119 */     GIR_RootConstrainSelectedInstOperands,
     /*  392120 */     // GIR_Coverage, 63135,
     /*  392120 */     GIR_EraseRootFromParent_Done,
     /*  392121 */   // Label 7041: @392121
     /*  392121 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(392195), // Rule ID 63136 //
     /*  392126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  392137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392147 */     // MIs[0] op1
     /*  392147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392155 */     // MIs[0] op2
     /*  392155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392174 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392179 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392181 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392183 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392193 */     GIR_RootConstrainSelectedInstOperands,
     /*  392194 */     // GIR_Coverage, 63136,
     /*  392194 */     GIR_EraseRootFromParent_Done,
     /*  392195 */   // Label 7042: @392195
     /*  392195 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(392269), // Rule ID 63179 //
     /*  392200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  392211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392221 */     // MIs[0] op1
     /*  392221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392229 */     // MIs[0] op2
     /*  392229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392248 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392253 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392255 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392257 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392267 */     GIR_RootConstrainSelectedInstOperands,
     /*  392268 */     // GIR_Coverage, 63179,
     /*  392268 */     GIR_EraseRootFromParent_Done,
     /*  392269 */   // Label 7043: @392269
     /*  392269 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(392343), // Rule ID 63180 //
     /*  392274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  392285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392295 */     // MIs[0] op1
     /*  392295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392303 */     // MIs[0] op2
     /*  392303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392322 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  392322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392327 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392329 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392331 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392341 */     GIR_RootConstrainSelectedInstOperands,
     /*  392342 */     // GIR_Coverage, 63180,
     /*  392342 */     GIR_EraseRootFromParent_Done,
     /*  392343 */   // Label 7044: @392343
     /*  392343 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(392417), // Rule ID 63235 //
     /*  392348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  392359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392369 */     // MIs[0] op1
     /*  392369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392377 */     // MIs[0] op2
     /*  392377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  392396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392401 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392403 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392405 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392415 */     GIR_RootConstrainSelectedInstOperands,
     /*  392416 */     // GIR_Coverage, 63235,
     /*  392416 */     GIR_EraseRootFromParent_Done,
     /*  392417 */   // Label 7045: @392417
     /*  392417 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(392491), // Rule ID 63236 //
     /*  392422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  392433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392443 */     // MIs[0] op1
     /*  392443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392451 */     // MIs[0] op2
     /*  392451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392470 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  392470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392475 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392477 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392479 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392489 */     GIR_RootConstrainSelectedInstOperands,
     /*  392490 */     // GIR_Coverage, 63236,
     /*  392490 */     GIR_EraseRootFromParent_Done,
     /*  392491 */   // Label 7046: @392491
     /*  392491 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(392565), // Rule ID 63291 //
     /*  392496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  392507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392517 */     // MIs[0] op1
     /*  392517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392525 */     // MIs[0] op2
     /*  392525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  392544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392549 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392551 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392553 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  392563 */     GIR_RootConstrainSelectedInstOperands,
     /*  392564 */     // GIR_Coverage, 63291,
     /*  392564 */     GIR_EraseRootFromParent_Done,
     /*  392565 */   // Label 7047: @392565
     /*  392565 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(392639), // Rule ID 63292 //
     /*  392570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  392581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392591 */     // MIs[0] op1
     /*  392591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392599 */     // MIs[0] op2
     /*  392599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392618 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  392618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392623 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392625 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392627 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  392637 */     GIR_RootConstrainSelectedInstOperands,
     /*  392638 */     // GIR_Coverage, 63292,
     /*  392638 */     GIR_EraseRootFromParent_Done,
     /*  392639 */   // Label 7048: @392639
     /*  392639 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(392713), // Rule ID 63347 //
     /*  392644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  392655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392665 */     // MIs[0] op1
     /*  392665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392673 */     // MIs[0] op2
     /*  392673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392692 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  392695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392697 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392699 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392701 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392711 */     GIR_RootConstrainSelectedInstOperands,
     /*  392712 */     // GIR_Coverage, 63347,
     /*  392712 */     GIR_EraseRootFromParent_Done,
     /*  392713 */   // Label 7049: @392713
     /*  392713 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(392787), // Rule ID 63348 //
     /*  392718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  392729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392739 */     // MIs[0] op1
     /*  392739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392747 */     // MIs[0] op2
     /*  392747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392766 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  392769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392771 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392773 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392775 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392785 */     GIR_RootConstrainSelectedInstOperands,
     /*  392786 */     // GIR_Coverage, 63348,
     /*  392786 */     GIR_EraseRootFromParent_Done,
     /*  392787 */   // Label 7050: @392787
     /*  392787 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(392861), // Rule ID 63391 //
     /*  392792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  392803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392813 */     // MIs[0] op1
     /*  392813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392821 */     // MIs[0] op2
     /*  392821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392824 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392840 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  392843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392845 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392847 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392849 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392859 */     GIR_RootConstrainSelectedInstOperands,
     /*  392860 */     // GIR_Coverage, 63391,
     /*  392860 */     GIR_EraseRootFromParent_Done,
     /*  392861 */   // Label 7051: @392861
     /*  392861 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(392935), // Rule ID 63392 //
     /*  392866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  392877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392887 */     // MIs[0] op1
     /*  392887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392895 */     // MIs[0] op2
     /*  392895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392914 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  392917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392919 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392921 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392923 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392933 */     GIR_RootConstrainSelectedInstOperands,
     /*  392934 */     // GIR_Coverage, 63392,
     /*  392934 */     GIR_EraseRootFromParent_Done,
     /*  392935 */   // Label 7052: @392935
     /*  392935 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(393009), // Rule ID 63435 //
     /*  392940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  392951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392961 */     // MIs[0] op1
     /*  392961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392969 */     // MIs[0] op2
     /*  392969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392988 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  392991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392993 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392995 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392997 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393007 */     GIR_RootConstrainSelectedInstOperands,
     /*  393008 */     // GIR_Coverage, 63435,
     /*  393008 */     GIR_EraseRootFromParent_Done,
     /*  393009 */   // Label 7053: @393009
     /*  393009 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(393083), // Rule ID 63436 //
     /*  393014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  393025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393035 */     // MIs[0] op1
     /*  393035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393043 */     // MIs[0] op2
     /*  393043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393062 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  393062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393067 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393069 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393071 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393081 */     GIR_RootConstrainSelectedInstOperands,
     /*  393082 */     // GIR_Coverage, 63436,
     /*  393082 */     GIR_EraseRootFromParent_Done,
     /*  393083 */   // Label 7054: @393083
     /*  393083 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(393157), // Rule ID 63479 //
     /*  393088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  393099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393109 */     // MIs[0] op1
     /*  393109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393117 */     // MIs[0] op2
     /*  393117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393136 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  393139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393141 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393143 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393145 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393155 */     GIR_RootConstrainSelectedInstOperands,
     /*  393156 */     // GIR_Coverage, 63479,
     /*  393156 */     GIR_EraseRootFromParent_Done,
     /*  393157 */   // Label 7055: @393157
     /*  393157 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(393231), // Rule ID 63480 //
     /*  393162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  393173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393183 */     // MIs[0] op1
     /*  393183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393191 */     // MIs[0] op2
     /*  393191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  393213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393215 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393217 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393219 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393229 */     GIR_RootConstrainSelectedInstOperands,
     /*  393230 */     // GIR_Coverage, 63480,
     /*  393230 */     GIR_EraseRootFromParent_Done,
     /*  393231 */   // Label 7056: @393231
     /*  393231 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(393305), // Rule ID 63535 //
     /*  393236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  393247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393257 */     // MIs[0] op1
     /*  393257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393260 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393265 */     // MIs[0] op2
     /*  393265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393284 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  393287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393289 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393291 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393293 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393303 */     GIR_RootConstrainSelectedInstOperands,
     /*  393304 */     // GIR_Coverage, 63535,
     /*  393304 */     GIR_EraseRootFromParent_Done,
     /*  393305 */   // Label 7057: @393305
     /*  393305 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(393379), // Rule ID 63536 //
     /*  393310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  393321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393331 */     // MIs[0] op1
     /*  393331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393339 */     // MIs[0] op2
     /*  393339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393358 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  393361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393363 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393365 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393367 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393377 */     GIR_RootConstrainSelectedInstOperands,
     /*  393378 */     // GIR_Coverage, 63536,
     /*  393378 */     GIR_EraseRootFromParent_Done,
     /*  393379 */   // Label 7058: @393379
     /*  393379 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(393453), // Rule ID 63591 //
     /*  393384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  393395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393405 */     // MIs[0] op1
     /*  393405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393408 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393413 */     // MIs[0] op2
     /*  393413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393432 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393437 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393439 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393441 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393451 */     GIR_RootConstrainSelectedInstOperands,
     /*  393452 */     // GIR_Coverage, 63591,
     /*  393452 */     GIR_EraseRootFromParent_Done,
     /*  393453 */   // Label 7059: @393453
     /*  393453 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(393527), // Rule ID 63592 //
     /*  393458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  393469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393479 */     // MIs[0] op1
     /*  393479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393487 */     // MIs[0] op2
     /*  393487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393506 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393511 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393513 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393515 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393525 */     GIR_RootConstrainSelectedInstOperands,
     /*  393526 */     // GIR_Coverage, 63592,
     /*  393526 */     GIR_EraseRootFromParent_Done,
     /*  393527 */   // Label 7060: @393527
     /*  393527 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(393601), // Rule ID 63647 //
     /*  393532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393553 */     // MIs[0] op1
     /*  393553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393561 */     // MIs[0] op2
     /*  393561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  393583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393585 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393587 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393589 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393599 */     GIR_RootConstrainSelectedInstOperands,
     /*  393600 */     // GIR_Coverage, 63647,
     /*  393600 */     GIR_EraseRootFromParent_Done,
     /*  393601 */   // Label 7061: @393601
     /*  393601 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(393675), // Rule ID 63648 //
     /*  393606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393627 */     // MIs[0] op1
     /*  393627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393635 */     // MIs[0] op2
     /*  393635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  393657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393659 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393661 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393663 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393673 */     GIR_RootConstrainSelectedInstOperands,
     /*  393674 */     // GIR_Coverage, 63648,
     /*  393674 */     GIR_EraseRootFromParent_Done,
     /*  393675 */   // Label 7062: @393675
     /*  393675 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(393749), // Rule ID 63703 //
     /*  393680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393701 */     // MIs[0] op1
     /*  393701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393709 */     // MIs[0] op2
     /*  393709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393728 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  393731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393733 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393735 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393737 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393747 */     GIR_RootConstrainSelectedInstOperands,
     /*  393748 */     // GIR_Coverage, 63703,
     /*  393748 */     GIR_EraseRootFromParent_Done,
     /*  393749 */   // Label 7063: @393749
     /*  393749 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(393823), // Rule ID 63704 //
     /*  393754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393775 */     // MIs[0] op1
     /*  393775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393783 */     // MIs[0] op2
     /*  393783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393802 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  393805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393807 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393809 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393811 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393821 */     GIR_RootConstrainSelectedInstOperands,
     /*  393822 */     // GIR_Coverage, 63704,
     /*  393822 */     GIR_EraseRootFromParent_Done,
     /*  393823 */   // Label 7064: @393823
     /*  393823 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(393897), // Rule ID 63759 //
     /*  393828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  393839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393849 */     // MIs[0] op1
     /*  393849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393857 */     // MIs[0] op2
     /*  393857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393876 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393881 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393883 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393885 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393895 */     GIR_RootConstrainSelectedInstOperands,
     /*  393896 */     // GIR_Coverage, 63759,
     /*  393896 */     GIR_EraseRootFromParent_Done,
     /*  393897 */   // Label 7065: @393897
     /*  393897 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(393971), // Rule ID 63760 //
     /*  393902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  393913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393923 */     // MIs[0] op1
     /*  393923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393931 */     // MIs[0] op2
     /*  393931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393950 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393955 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393957 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393959 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393969 */     GIR_RootConstrainSelectedInstOperands,
     /*  393970 */     // GIR_Coverage, 63760,
     /*  393970 */     GIR_EraseRootFromParent_Done,
     /*  393971 */   // Label 7066: @393971
     /*  393971 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(394045), // Rule ID 63815 //
     /*  393976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  393987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393997 */     // MIs[0] op1
     /*  393997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394005 */     // MIs[0] op2
     /*  394005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  394027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394029 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394031 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394033 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394043 */     GIR_RootConstrainSelectedInstOperands,
     /*  394044 */     // GIR_Coverage, 63815,
     /*  394044 */     GIR_EraseRootFromParent_Done,
     /*  394045 */   // Label 7067: @394045
     /*  394045 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(394119), // Rule ID 63816 //
     /*  394050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  394061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  394064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394071 */     // MIs[0] op1
     /*  394071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394074 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394079 */     // MIs[0] op2
     /*  394079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394098 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  394101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394103 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394105 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394107 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394117 */     GIR_RootConstrainSelectedInstOperands,
     /*  394118 */     // GIR_Coverage, 63816,
     /*  394118 */     GIR_EraseRootFromParent_Done,
     /*  394119 */   // Label 7068: @394119
     /*  394119 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(394193), // Rule ID 63871 //
     /*  394124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  394135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  394138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394145 */     // MIs[0] op1
     /*  394145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394153 */     // MIs[0] op2
     /*  394153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394172 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  394175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394177 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394179 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394181 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394191 */     GIR_RootConstrainSelectedInstOperands,
     /*  394192 */     // GIR_Coverage, 63871,
     /*  394192 */     GIR_EraseRootFromParent_Done,
     /*  394193 */   // Label 7069: @394193
     /*  394193 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(394267), // Rule ID 63872 //
     /*  394198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  394209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  394212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394219 */     // MIs[0] op1
     /*  394219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394227 */     // MIs[0] op2
     /*  394227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394246 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  394249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394251 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394253 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394255 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394265 */     GIR_RootConstrainSelectedInstOperands,
     /*  394266 */     // GIR_Coverage, 63872,
     /*  394266 */     GIR_EraseRootFromParent_Done,
     /*  394267 */   // Label 7070: @394267
     /*  394267 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(394341), // Rule ID 63927 //
     /*  394272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  394283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  394286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394293 */     // MIs[0] op1
     /*  394293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394301 */     // MIs[0] op2
     /*  394301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394320 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  394323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394325 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394327 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394329 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394339 */     GIR_RootConstrainSelectedInstOperands,
     /*  394340 */     // GIR_Coverage, 63927,
     /*  394340 */     GIR_EraseRootFromParent_Done,
     /*  394341 */   // Label 7071: @394341
     /*  394341 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(394415), // Rule ID 63928 //
     /*  394346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  394357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  394360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394367 */     // MIs[0] op1
     /*  394367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394375 */     // MIs[0] op2
     /*  394375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  394397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394399 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394401 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394403 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394413 */     GIR_RootConstrainSelectedInstOperands,
     /*  394414 */     // GIR_Coverage, 63928,
     /*  394414 */     GIR_EraseRootFromParent_Done,
     /*  394415 */   // Label 7072: @394415
     /*  394415 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(394489), // Rule ID 62857 //
     /*  394420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  394431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  394434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394441 */     // MIs[0] op1
     /*  394441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394453 */     // MIs[0] op3
     /*  394453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394456 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394468 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF8),
     /*  394471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394473 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394475 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394477 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394487 */     GIR_RootConstrainSelectedInstOperands,
     /*  394488 */     // GIR_Coverage, 62857,
     /*  394488 */     GIR_EraseRootFromParent_Done,
     /*  394489 */   // Label 7073: @394489
     /*  394489 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(394563), // Rule ID 62858 //
     /*  394494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  394505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  394508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394515 */     // MIs[0] op1
     /*  394515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394527 */     // MIs[0] op3
     /*  394527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394530 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394542 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF8),
     /*  394545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394547 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394549 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394551 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394561 */     GIR_RootConstrainSelectedInstOperands,
     /*  394562 */     // GIR_Coverage, 62858,
     /*  394562 */     GIR_EraseRootFromParent_Done,
     /*  394563 */   // Label 7074: @394563
     /*  394563 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(394637), // Rule ID 62895 //
     /*  394568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  394579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  394582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394589 */     // MIs[0] op1
     /*  394589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394601 */     // MIs[0] op3
     /*  394601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394604 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394616 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF4),
     /*  394619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394621 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394623 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394625 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394635 */     GIR_RootConstrainSelectedInstOperands,
     /*  394636 */     // GIR_Coverage, 62895,
     /*  394636 */     GIR_EraseRootFromParent_Done,
     /*  394637 */   // Label 7075: @394637
     /*  394637 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(394711), // Rule ID 62896 //
     /*  394642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  394653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  394656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394663 */     // MIs[0] op1
     /*  394663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394675 */     // MIs[0] op3
     /*  394675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394690 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF4),
     /*  394693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394695 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394697 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394699 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394709 */     GIR_RootConstrainSelectedInstOperands,
     /*  394710 */     // GIR_Coverage, 62896,
     /*  394710 */     GIR_EraseRootFromParent_Done,
     /*  394711 */   // Label 7076: @394711
     /*  394711 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(394785), // Rule ID 62939 //
     /*  394716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  394727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  394730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394737 */     // MIs[0] op1
     /*  394737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394749 */     // MIs[0] op3
     /*  394749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394764 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  394767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394769 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394771 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394773 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394783 */     GIR_RootConstrainSelectedInstOperands,
     /*  394784 */     // GIR_Coverage, 62939,
     /*  394784 */     GIR_EraseRootFromParent_Done,
     /*  394785 */   // Label 7077: @394785
     /*  394785 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(394859), // Rule ID 62940 //
     /*  394790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  394801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  394804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394811 */     // MIs[0] op1
     /*  394811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394814 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394823 */     // MIs[0] op3
     /*  394823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394838 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  394841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394843 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394845 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394847 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394857 */     GIR_RootConstrainSelectedInstOperands,
     /*  394858 */     // GIR_Coverage, 62940,
     /*  394858 */     GIR_EraseRootFromParent_Done,
     /*  394859 */   // Label 7078: @394859
     /*  394859 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(394933), // Rule ID 62983 //
     /*  394864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  394875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  394878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394885 */     // MIs[0] op1
     /*  394885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394888 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394897 */     // MIs[0] op3
     /*  394897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394912 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  394912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF4),
     /*  394915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394917 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394919 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394921 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394931 */     GIR_RootConstrainSelectedInstOperands,
     /*  394932 */     // GIR_Coverage, 62983,
     /*  394932 */     GIR_EraseRootFromParent_Done,
     /*  394933 */   // Label 7079: @394933
     /*  394933 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(395007), // Rule ID 62984 //
     /*  394938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  394949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  394952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394959 */     // MIs[0] op1
     /*  394959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394971 */     // MIs[0] op3
     /*  394971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394986 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  394986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF4),
     /*  394989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394991 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394993 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394995 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395005 */     GIR_RootConstrainSelectedInstOperands,
     /*  395006 */     // GIR_Coverage, 62984,
     /*  395006 */     GIR_EraseRootFromParent_Done,
     /*  395007 */   // Label 7080: @395007
     /*  395007 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(395081), // Rule ID 63039 //
     /*  395012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  395023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  395026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395033 */     // MIs[0] op1
     /*  395033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395045 */     // MIs[0] op3
     /*  395045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395048 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395060 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  395063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395065 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395067 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395069 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395079 */     GIR_RootConstrainSelectedInstOperands,
     /*  395080 */     // GIR_Coverage, 63039,
     /*  395080 */     GIR_EraseRootFromParent_Done,
     /*  395081 */   // Label 7081: @395081
     /*  395081 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(395155), // Rule ID 63040 //
     /*  395086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  395097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  395100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395107 */     // MIs[0] op1
     /*  395107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395119 */     // MIs[0] op3
     /*  395119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395134 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  395137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395139 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395141 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395143 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395153 */     GIR_RootConstrainSelectedInstOperands,
     /*  395154 */     // GIR_Coverage, 63040,
     /*  395154 */     GIR_EraseRootFromParent_Done,
     /*  395155 */   // Label 7082: @395155
     /*  395155 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(395229), // Rule ID 63095 //
     /*  395160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  395171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  395174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395181 */     // MIs[0] op1
     /*  395181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395193 */     // MIs[0] op3
     /*  395193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395208 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  395208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  395211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395213 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395215 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395217 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395227 */     GIR_RootConstrainSelectedInstOperands,
     /*  395228 */     // GIR_Coverage, 63095,
     /*  395228 */     GIR_EraseRootFromParent_Done,
     /*  395229 */   // Label 7083: @395229
     /*  395229 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(395303), // Rule ID 63096 //
     /*  395234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  395245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  395248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395255 */     // MIs[0] op1
     /*  395255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395267 */     // MIs[0] op3
     /*  395267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395282 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  395282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  395285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395287 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395289 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395291 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395301 */     GIR_RootConstrainSelectedInstOperands,
     /*  395302 */     // GIR_Coverage, 63096,
     /*  395302 */     GIR_EraseRootFromParent_Done,
     /*  395303 */   // Label 7084: @395303
     /*  395303 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(395377), // Rule ID 63151 //
     /*  395308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  395319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  395322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395329 */     // MIs[0] op1
     /*  395329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395341 */     // MIs[0] op3
     /*  395341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395356 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395361 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395363 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395365 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395375 */     GIR_RootConstrainSelectedInstOperands,
     /*  395376 */     // GIR_Coverage, 63151,
     /*  395376 */     GIR_EraseRootFromParent_Done,
     /*  395377 */   // Label 7085: @395377
     /*  395377 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(395451), // Rule ID 63152 //
     /*  395382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  395393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  395396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395403 */     // MIs[0] op1
     /*  395403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395415 */     // MIs[0] op3
     /*  395415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395430 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395435 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395437 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395439 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395449 */     GIR_RootConstrainSelectedInstOperands,
     /*  395450 */     // GIR_Coverage, 63152,
     /*  395450 */     GIR_EraseRootFromParent_Done,
     /*  395451 */   // Label 7086: @395451
     /*  395451 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(395525), // Rule ID 63195 //
     /*  395456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  395467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  395470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395477 */     // MIs[0] op1
     /*  395477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395489 */     // MIs[0] op3
     /*  395489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395504 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395509 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395511 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395513 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395523 */     GIR_RootConstrainSelectedInstOperands,
     /*  395524 */     // GIR_Coverage, 63195,
     /*  395524 */     GIR_EraseRootFromParent_Done,
     /*  395525 */   // Label 7087: @395525
     /*  395525 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(395599), // Rule ID 63196 //
     /*  395530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  395541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  395544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395551 */     // MIs[0] op1
     /*  395551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395554 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395563 */     // MIs[0] op3
     /*  395563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395578 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395583 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395585 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395587 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395597 */     GIR_RootConstrainSelectedInstOperands,
     /*  395598 */     // GIR_Coverage, 63196,
     /*  395598 */     GIR_EraseRootFromParent_Done,
     /*  395599 */   // Label 7088: @395599
     /*  395599 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(395673), // Rule ID 63251 //
     /*  395604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  395618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395625 */     // MIs[0] op1
     /*  395625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395637 */     // MIs[0] op3
     /*  395637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  395652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395657 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395659 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395661 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395671 */     GIR_RootConstrainSelectedInstOperands,
     /*  395672 */     // GIR_Coverage, 63251,
     /*  395672 */     GIR_EraseRootFromParent_Done,
     /*  395673 */   // Label 7089: @395673
     /*  395673 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(395747), // Rule ID 63252 //
     /*  395678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  395692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395699 */     // MIs[0] op1
     /*  395699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395711 */     // MIs[0] op3
     /*  395711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  395726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395731 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395733 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395735 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395745 */     GIR_RootConstrainSelectedInstOperands,
     /*  395746 */     // GIR_Coverage, 63252,
     /*  395746 */     GIR_EraseRootFromParent_Done,
     /*  395747 */   // Label 7090: @395747
     /*  395747 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(395821), // Rule ID 63307 //
     /*  395752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  395766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395773 */     // MIs[0] op1
     /*  395773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395776 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395785 */     // MIs[0] op3
     /*  395785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395800 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  395800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395805 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395807 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395809 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  395819 */     GIR_RootConstrainSelectedInstOperands,
     /*  395820 */     // GIR_Coverage, 63307,
     /*  395820 */     GIR_EraseRootFromParent_Done,
     /*  395821 */   // Label 7091: @395821
     /*  395821 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(395895), // Rule ID 63308 //
     /*  395826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  395840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395847 */     // MIs[0] op1
     /*  395847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395850 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395859 */     // MIs[0] op3
     /*  395859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  395874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395879 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395881 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395883 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  395893 */     GIR_RootConstrainSelectedInstOperands,
     /*  395894 */     // GIR_Coverage, 63308,
     /*  395894 */     GIR_EraseRootFromParent_Done,
     /*  395895 */   // Label 7092: @395895
     /*  395895 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(395969), // Rule ID 63363 //
     /*  395900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  395911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  395914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395921 */     // MIs[0] op1
     /*  395921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395933 */     // MIs[0] op3
     /*  395933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  395951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395953 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395955 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395957 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395967 */     GIR_RootConstrainSelectedInstOperands,
     /*  395968 */     // GIR_Coverage, 63363,
     /*  395968 */     GIR_EraseRootFromParent_Done,
     /*  395969 */   // Label 7093: @395969
     /*  395969 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(396043), // Rule ID 63364 //
     /*  395974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  395985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  395988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395995 */     // MIs[0] op1
     /*  395995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396007 */     // MIs[0] op3
     /*  396007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396022 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  396022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396027 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396029 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396031 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396041 */     GIR_RootConstrainSelectedInstOperands,
     /*  396042 */     // GIR_Coverage, 63364,
     /*  396042 */     GIR_EraseRootFromParent_Done,
     /*  396043 */   // Label 7094: @396043
     /*  396043 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(396117), // Rule ID 63407 //
     /*  396048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  396059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  396062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396069 */     // MIs[0] op1
     /*  396069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396081 */     // MIs[0] op3
     /*  396081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396096 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  396096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396101 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396103 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396105 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396115 */     GIR_RootConstrainSelectedInstOperands,
     /*  396116 */     // GIR_Coverage, 63407,
     /*  396116 */     GIR_EraseRootFromParent_Done,
     /*  396117 */   // Label 7095: @396117
     /*  396117 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(396191), // Rule ID 63408 //
     /*  396122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  396133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  396136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396143 */     // MIs[0] op1
     /*  396143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396155 */     // MIs[0] op3
     /*  396155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396170 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  396170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396175 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396177 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396179 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396189 */     GIR_RootConstrainSelectedInstOperands,
     /*  396190 */     // GIR_Coverage, 63408,
     /*  396190 */     GIR_EraseRootFromParent_Done,
     /*  396191 */   // Label 7096: @396191
     /*  396191 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(396265), // Rule ID 63451 //
     /*  396196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  396207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  396210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396217 */     // MIs[0] op1
     /*  396217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396229 */     // MIs[0] op3
     /*  396229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396244 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  396244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  396247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396249 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396251 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396253 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396263 */     GIR_RootConstrainSelectedInstOperands,
     /*  396264 */     // GIR_Coverage, 63451,
     /*  396264 */     GIR_EraseRootFromParent_Done,
     /*  396265 */   // Label 7097: @396265
     /*  396265 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(396339), // Rule ID 63452 //
     /*  396270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  396281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  396284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396291 */     // MIs[0] op1
     /*  396291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396303 */     // MIs[0] op3
     /*  396303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396318 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  396318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  396321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396323 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396325 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396327 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396337 */     GIR_RootConstrainSelectedInstOperands,
     /*  396338 */     // GIR_Coverage, 63452,
     /*  396338 */     GIR_EraseRootFromParent_Done,
     /*  396339 */   // Label 7098: @396339
     /*  396339 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(396413), // Rule ID 63495 //
     /*  396344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  396355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  396358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396365 */     // MIs[0] op1
     /*  396365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396377 */     // MIs[0] op3
     /*  396377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396397 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396399 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396401 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396411 */     GIR_RootConstrainSelectedInstOperands,
     /*  396412 */     // GIR_Coverage, 63495,
     /*  396412 */     GIR_EraseRootFromParent_Done,
     /*  396413 */   // Label 7099: @396413
     /*  396413 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(396487), // Rule ID 63496 //
     /*  396418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  396429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  396432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396439 */     // MIs[0] op1
     /*  396439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396451 */     // MIs[0] op3
     /*  396451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396471 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396473 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396475 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396485 */     GIR_RootConstrainSelectedInstOperands,
     /*  396486 */     // GIR_Coverage, 63496,
     /*  396486 */     GIR_EraseRootFromParent_Done,
     /*  396487 */   // Label 7100: @396487
     /*  396487 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(396561), // Rule ID 63551 //
     /*  396492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  396503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  396506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396513 */     // MIs[0] op1
     /*  396513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396525 */     // MIs[0] op3
     /*  396525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396540 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396545 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396547 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396549 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396559 */     GIR_RootConstrainSelectedInstOperands,
     /*  396560 */     // GIR_Coverage, 63551,
     /*  396560 */     GIR_EraseRootFromParent_Done,
     /*  396561 */   // Label 7101: @396561
     /*  396561 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(396635), // Rule ID 63552 //
     /*  396566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  396577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  396580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396587 */     // MIs[0] op1
     /*  396587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396599 */     // MIs[0] op3
     /*  396599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396614 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396619 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396621 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396623 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396633 */     GIR_RootConstrainSelectedInstOperands,
     /*  396634 */     // GIR_Coverage, 63552,
     /*  396634 */     GIR_EraseRootFromParent_Done,
     /*  396635 */   // Label 7102: @396635
     /*  396635 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(396709), // Rule ID 63607 //
     /*  396640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  396651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  396654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396661 */     // MIs[0] op1
     /*  396661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396673 */     // MIs[0] op3
     /*  396673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396688 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  396691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396693 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396695 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396697 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396707 */     GIR_RootConstrainSelectedInstOperands,
     /*  396708 */     // GIR_Coverage, 63607,
     /*  396708 */     GIR_EraseRootFromParent_Done,
     /*  396709 */   // Label 7103: @396709
     /*  396709 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(396783), // Rule ID 63608 //
     /*  396714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  396725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  396728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396735 */     // MIs[0] op1
     /*  396735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396747 */     // MIs[0] op3
     /*  396747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396762 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  396765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396767 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396769 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396771 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396781 */     GIR_RootConstrainSelectedInstOperands,
     /*  396782 */     // GIR_Coverage, 63608,
     /*  396782 */     GIR_EraseRootFromParent_Done,
     /*  396783 */   // Label 7104: @396783
     /*  396783 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(396857), // Rule ID 63663 //
     /*  396788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  396799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  396802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396809 */     // MIs[0] op1
     /*  396809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396821 */     // MIs[0] op3
     /*  396821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396824 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396841 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396843 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396845 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396855 */     GIR_RootConstrainSelectedInstOperands,
     /*  396856 */     // GIR_Coverage, 63663,
     /*  396856 */     GIR_EraseRootFromParent_Done,
     /*  396857 */   // Label 7105: @396857
     /*  396857 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(396931), // Rule ID 63664 //
     /*  396862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  396873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  396876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396883 */     // MIs[0] op1
     /*  396883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396895 */     // MIs[0] op3
     /*  396895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396910 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  396910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396915 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396917 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396919 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396929 */     GIR_RootConstrainSelectedInstOperands,
     /*  396930 */     // GIR_Coverage, 63664,
     /*  396930 */     GIR_EraseRootFromParent_Done,
     /*  396931 */   // Label 7106: @396931
     /*  396931 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(397005), // Rule ID 63719 //
     /*  396936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  396947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  396950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396957 */     // MIs[0] op1
     /*  396957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396960 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396969 */     // MIs[0] op3
     /*  396969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396984 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396989 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396991 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396993 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397003 */     GIR_RootConstrainSelectedInstOperands,
     /*  397004 */     // GIR_Coverage, 63719,
     /*  397004 */     GIR_EraseRootFromParent_Done,
     /*  397005 */   // Label 7107: @397005
     /*  397005 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(397079), // Rule ID 63720 //
     /*  397010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  397021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  397024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397031 */     // MIs[0] op1
     /*  397031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397043 */     // MIs[0] op3
     /*  397043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397058 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  397058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  397061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397063 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397065 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397067 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397077 */     GIR_RootConstrainSelectedInstOperands,
     /*  397078 */     // GIR_Coverage, 63720,
     /*  397078 */     GIR_EraseRootFromParent_Done,
     /*  397079 */   // Label 7108: @397079
     /*  397079 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(397153), // Rule ID 63775 //
     /*  397084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  397095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  397098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397105 */     // MIs[0] op1
     /*  397105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397117 */     // MIs[0] op3
     /*  397117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397132 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  397132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  397135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397137 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397139 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397141 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397151 */     GIR_RootConstrainSelectedInstOperands,
     /*  397152 */     // GIR_Coverage, 63775,
     /*  397152 */     GIR_EraseRootFromParent_Done,
     /*  397153 */   // Label 7109: @397153
     /*  397153 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(397227), // Rule ID 63776 //
     /*  397158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  397169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  397172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397179 */     // MIs[0] op1
     /*  397179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397191 */     // MIs[0] op3
     /*  397191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397206 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  397206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  397209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397211 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397213 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397215 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397225 */     GIR_RootConstrainSelectedInstOperands,
     /*  397226 */     // GIR_Coverage, 63776,
     /*  397226 */     GIR_EraseRootFromParent_Done,
     /*  397227 */   // Label 7110: @397227
     /*  397227 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(397301), // Rule ID 63831 //
     /*  397232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  397243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  397246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397253 */     // MIs[0] op1
     /*  397253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397265 */     // MIs[0] op3
     /*  397265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397280 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  397283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397285 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397287 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397289 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397299 */     GIR_RootConstrainSelectedInstOperands,
     /*  397300 */     // GIR_Coverage, 63831,
     /*  397300 */     GIR_EraseRootFromParent_Done,
     /*  397301 */   // Label 7111: @397301
     /*  397301 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(397375), // Rule ID 63832 //
     /*  397306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  397317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  397320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397327 */     // MIs[0] op1
     /*  397327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397339 */     // MIs[0] op3
     /*  397339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397354 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  397357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397359 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397361 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397363 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397373 */     GIR_RootConstrainSelectedInstOperands,
     /*  397374 */     // GIR_Coverage, 63832,
     /*  397374 */     GIR_EraseRootFromParent_Done,
     /*  397375 */   // Label 7112: @397375
     /*  397375 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(397449), // Rule ID 63887 //
     /*  397380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  397391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  397394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397401 */     // MIs[0] op1
     /*  397401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397413 */     // MIs[0] op3
     /*  397413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397428 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  397431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397433 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397435 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397437 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397447 */     GIR_RootConstrainSelectedInstOperands,
     /*  397448 */     // GIR_Coverage, 63887,
     /*  397448 */     GIR_EraseRootFromParent_Done,
     /*  397449 */   // Label 7113: @397449
     /*  397449 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(397523), // Rule ID 63888 //
     /*  397454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  397465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  397468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397475 */     // MIs[0] op1
     /*  397475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397487 */     // MIs[0] op3
     /*  397487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397502 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  397505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397507 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397509 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397511 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397521 */     GIR_RootConstrainSelectedInstOperands,
     /*  397522 */     // GIR_Coverage, 63888,
     /*  397522 */     GIR_EraseRootFromParent_Done,
     /*  397523 */   // Label 7114: @397523
     /*  397523 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(397597), // Rule ID 63943 //
     /*  397528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  397539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  397542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397549 */     // MIs[0] op1
     /*  397549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397561 */     // MIs[0] op3
     /*  397561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11124:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  397579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397581 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397583 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397585 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397595 */     GIR_RootConstrainSelectedInstOperands,
     /*  397596 */     // GIR_Coverage, 63943,
     /*  397596 */     GIR_EraseRootFromParent_Done,
     /*  397597 */   // Label 7115: @397597
     /*  397597 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(397671), // Rule ID 63944 //
     /*  397602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  397613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  397616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397623 */     // MIs[0] op1
     /*  397623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397635 */     // MIs[0] op3
     /*  397635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397650 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11124:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  397653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397655 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397657 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397659 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397669 */     GIR_RootConstrainSelectedInstOperands,
     /*  397670 */     // GIR_Coverage, 63944,
     /*  397670 */     GIR_EraseRootFromParent_Done,
     /*  397671 */   // Label 7116: @397671
     /*  397671 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(397746), // Rule ID 7368 //
     /*  397676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  397687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  397690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  397693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397722 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  397722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  397725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397744 */     GIR_RootConstrainSelectedInstOperands,
     /*  397745 */     // GIR_Coverage, 7368,
     /*  397745 */     GIR_EraseRootFromParent_Done,
     /*  397746 */   // Label 7117: @397746
     /*  397746 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(397821), // Rule ID 7369 //
     /*  397751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  397762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  397765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  397768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397786 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397797 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  397797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  397800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397819 */     GIR_RootConstrainSelectedInstOperands,
     /*  397820 */     // GIR_Coverage, 7369,
     /*  397820 */     GIR_EraseRootFromParent_Done,
     /*  397821 */   // Label 7118: @397821
     /*  397821 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(397896), // Rule ID 7372 //
     /*  397826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  397837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  397840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  397843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397872 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  397872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397894 */     GIR_RootConstrainSelectedInstOperands,
     /*  397895 */     // GIR_Coverage, 7372,
     /*  397895 */     GIR_EraseRootFromParent_Done,
     /*  397896 */   // Label 7119: @397896
     /*  397896 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(397971), // Rule ID 7373 //
     /*  397901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  397912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  397915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  397918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397947 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  397947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397969 */     GIR_RootConstrainSelectedInstOperands,
     /*  397970 */     // GIR_Coverage, 7373,
     /*  397970 */     GIR_EraseRootFromParent_Done,
     /*  397971 */   // Label 7120: @397971
     /*  397971 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(398046), // Rule ID 7376 //
     /*  397976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  397987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  397990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  397993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398022 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398044 */     GIR_RootConstrainSelectedInstOperands,
     /*  398045 */     // GIR_Coverage, 7376,
     /*  398045 */     GIR_EraseRootFromParent_Done,
     /*  398046 */   // Label 7121: @398046
     /*  398046 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(398121), // Rule ID 7377 //
     /*  398051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  398062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  398065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  398068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398097 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398119 */     GIR_RootConstrainSelectedInstOperands,
     /*  398120 */     // GIR_Coverage, 7377,
     /*  398120 */     GIR_EraseRootFromParent_Done,
     /*  398121 */   // Label 7122: @398121
     /*  398121 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(398196), // Rule ID 7380 //
     /*  398126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  398137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  398140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  398143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398172 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  398172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  398175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398194 */     GIR_RootConstrainSelectedInstOperands,
     /*  398195 */     // GIR_Coverage, 7380,
     /*  398195 */     GIR_EraseRootFromParent_Done,
     /*  398196 */   // Label 7123: @398196
     /*  398196 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(398271), // Rule ID 7381 //
     /*  398201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  398212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  398215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  398218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398247 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  398247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  398250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398269 */     GIR_RootConstrainSelectedInstOperands,
     /*  398270 */     // GIR_Coverage, 7381,
     /*  398270 */     GIR_EraseRootFromParent_Done,
     /*  398271 */   // Label 7124: @398271
     /*  398271 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(398346), // Rule ID 7384 //
     /*  398276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  398287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  398290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  398293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398322 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  398322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398344 */     GIR_RootConstrainSelectedInstOperands,
     /*  398345 */     // GIR_Coverage, 7384,
     /*  398345 */     GIR_EraseRootFromParent_Done,
     /*  398346 */   // Label 7125: @398346
     /*  398346 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(398421), // Rule ID 7385 //
     /*  398351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  398362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  398365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  398368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398397 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  398397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398419 */     GIR_RootConstrainSelectedInstOperands,
     /*  398420 */     // GIR_Coverage, 7385,
     /*  398420 */     GIR_EraseRootFromParent_Done,
     /*  398421 */   // Label 7126: @398421
     /*  398421 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(398496), // Rule ID 7388 //
     /*  398426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  398437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  398440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  398443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398472 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  398472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398494 */     GIR_RootConstrainSelectedInstOperands,
     /*  398495 */     // GIR_Coverage, 7388,
     /*  398495 */     GIR_EraseRootFromParent_Done,
     /*  398496 */   // Label 7127: @398496
     /*  398496 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(398571), // Rule ID 7389 //
     /*  398501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  398512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  398515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  398518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398547 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  398547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398569 */     GIR_RootConstrainSelectedInstOperands,
     /*  398570 */     // GIR_Coverage, 7389,
     /*  398570 */     GIR_EraseRootFromParent_Done,
     /*  398571 */   // Label 7128: @398571
     /*  398571 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(398646), // Rule ID 7392 //
     /*  398576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  398587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  398590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  398593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398622 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398644 */     GIR_RootConstrainSelectedInstOperands,
     /*  398645 */     // GIR_Coverage, 7392,
     /*  398645 */     GIR_EraseRootFromParent_Done,
     /*  398646 */   // Label 7129: @398646
     /*  398646 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(398721), // Rule ID 7393 //
     /*  398651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  398662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  398665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  398668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398697 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398719 */     GIR_RootConstrainSelectedInstOperands,
     /*  398720 */     // GIR_Coverage, 7393,
     /*  398720 */     GIR_EraseRootFromParent_Done,
     /*  398721 */   // Label 7130: @398721
     /*  398721 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(398796), // Rule ID 7396 //
     /*  398726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  398737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  398740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  398743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398772 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  398772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398794 */     GIR_RootConstrainSelectedInstOperands,
     /*  398795 */     // GIR_Coverage, 7396,
     /*  398795 */     GIR_EraseRootFromParent_Done,
     /*  398796 */   // Label 7131: @398796
     /*  398796 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(398871), // Rule ID 7397 //
     /*  398801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  398812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  398815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  398818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398847 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  398847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398869 */     GIR_RootConstrainSelectedInstOperands,
     /*  398870 */     // GIR_Coverage, 7397,
     /*  398870 */     GIR_EraseRootFromParent_Done,
     /*  398871 */   // Label 7132: @398871
     /*  398871 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(398946), // Rule ID 7400 //
     /*  398876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  398887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  398890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  398893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  398922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398944 */     GIR_RootConstrainSelectedInstOperands,
     /*  398945 */     // GIR_Coverage, 7400,
     /*  398945 */     GIR_EraseRootFromParent_Done,
     /*  398946 */   // Label 7133: @398946
     /*  398946 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(399021), // Rule ID 7401 //
     /*  398951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  398962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  398965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  398968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398997 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  398997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  399000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399019 */     GIR_RootConstrainSelectedInstOperands,
     /*  399020 */     // GIR_Coverage, 7401,
     /*  399020 */     GIR_EraseRootFromParent_Done,
     /*  399021 */   // Label 7134: @399021
     /*  399021 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(399096), // Rule ID 7404 //
     /*  399026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  399029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  399037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  399040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  399043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399072 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  399072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  399075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399094 */     GIR_RootConstrainSelectedInstOperands,
     /*  399095 */     // GIR_Coverage, 7404,
     /*  399095 */     GIR_EraseRootFromParent_Done,
     /*  399096 */   // Label 7135: @399096
     /*  399096 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(399171), // Rule ID 7405 //
     /*  399101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  399104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  399112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  399115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  399118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399147 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  399147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  399150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399169 */     GIR_RootConstrainSelectedInstOperands,
     /*  399170 */     // GIR_Coverage, 7405,
     /*  399170 */     GIR_EraseRootFromParent_Done,
     /*  399171 */   // Label 7136: @399171
     /*  399171 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(399246), // Rule ID 7408 //
     /*  399176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  399187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  399190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  399193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399222 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  399222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399244 */     GIR_RootConstrainSelectedInstOperands,
     /*  399245 */     // GIR_Coverage, 7408,
     /*  399245 */     GIR_EraseRootFromParent_Done,
     /*  399246 */   // Label 7137: @399246
     /*  399246 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(399321), // Rule ID 7409 //
     /*  399251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  399262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  399265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  399268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399297 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  399297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399319 */     GIR_RootConstrainSelectedInstOperands,
     /*  399320 */     // GIR_Coverage, 7409,
     /*  399320 */     GIR_EraseRootFromParent_Done,
     /*  399321 */   // Label 7138: @399321
     /*  399321 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(399396), // Rule ID 7412 //
     /*  399326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  399337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  399340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  399343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399372 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  399372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399394 */     GIR_RootConstrainSelectedInstOperands,
     /*  399395 */     // GIR_Coverage, 7412,
     /*  399395 */     GIR_EraseRootFromParent_Done,
     /*  399396 */   // Label 7139: @399396
     /*  399396 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(399471), // Rule ID 7413 //
     /*  399401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  399412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  399415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  399418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399447 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  399447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399469 */     GIR_RootConstrainSelectedInstOperands,
     /*  399470 */     // GIR_Coverage, 7413,
     /*  399470 */     GIR_EraseRootFromParent_Done,
     /*  399471 */   // Label 7140: @399471
     /*  399471 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(399546), // Rule ID 7416 //
     /*  399476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  399487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  399490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  399493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399522 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  399522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399544 */     GIR_RootConstrainSelectedInstOperands,
     /*  399545 */     // GIR_Coverage, 7416,
     /*  399545 */     GIR_EraseRootFromParent_Done,
     /*  399546 */   // Label 7141: @399546
     /*  399546 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(399621), // Rule ID 7417 //
     /*  399551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  399562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  399565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  399568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399597 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  399597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399619 */     GIR_RootConstrainSelectedInstOperands,
     /*  399620 */     // GIR_Coverage, 7417,
     /*  399620 */     GIR_EraseRootFromParent_Done,
     /*  399621 */   // Label 7142: @399621
     /*  399621 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(399696), // Rule ID 7420 //
     /*  399626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  399640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399672 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  399672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399694 */     GIR_RootConstrainSelectedInstOperands,
     /*  399695 */     // GIR_Coverage, 7420,
     /*  399695 */     GIR_EraseRootFromParent_Done,
     /*  399696 */   // Label 7143: @399696
     /*  399696 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(399771), // Rule ID 7421 //
     /*  399701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  399715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399747 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  399747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399769 */     GIR_RootConstrainSelectedInstOperands,
     /*  399770 */     // GIR_Coverage, 7421,
     /*  399770 */     GIR_EraseRootFromParent_Done,
     /*  399771 */   // Label 7144: @399771
     /*  399771 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(399846), // Rule ID 7424 //
     /*  399776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  399790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399822 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  399822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399844 */     GIR_RootConstrainSelectedInstOperands,
     /*  399845 */     // GIR_Coverage, 7424,
     /*  399845 */     GIR_EraseRootFromParent_Done,
     /*  399846 */   // Label 7145: @399846
     /*  399846 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(399921), // Rule ID 7425 //
     /*  399851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  399865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399897 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  399897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399919 */     GIR_RootConstrainSelectedInstOperands,
     /*  399920 */     // GIR_Coverage, 7425,
     /*  399920 */     GIR_EraseRootFromParent_Done,
     /*  399921 */   // Label 7146: @399921
     /*  399921 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(399996), // Rule ID 7428 //
     /*  399926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  399937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  399940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  399943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399972 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  399972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399994 */     GIR_RootConstrainSelectedInstOperands,
     /*  399995 */     // GIR_Coverage, 7428,
     /*  399995 */     GIR_EraseRootFromParent_Done,
     /*  399996 */   // Label 7147: @399996
     /*  399996 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(400071), // Rule ID 7429 //
     /*  400001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  400004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  400012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  400015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  400018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400047 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  400047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400069 */     GIR_RootConstrainSelectedInstOperands,
     /*  400070 */     // GIR_Coverage, 7429,
     /*  400070 */     GIR_EraseRootFromParent_Done,
     /*  400071 */   // Label 7148: @400071
     /*  400071 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(400146), // Rule ID 7432 //
     /*  400076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  400079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  400087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  400090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  400093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  400122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  400125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400144 */     GIR_RootConstrainSelectedInstOperands,
     /*  400145 */     // GIR_Coverage, 7432,
     /*  400145 */     GIR_EraseRootFromParent_Done,
     /*  400146 */   // Label 7149: @400146
     /*  400146 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(400221), // Rule ID 7433 //
     /*  400151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  400154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  400162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  400165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  400168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  400197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  400200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400219 */     GIR_RootConstrainSelectedInstOperands,
     /*  400220 */     // GIR_Coverage, 7433,
     /*  400220 */     GIR_EraseRootFromParent_Done,
     /*  400221 */   // Label 7150: @400221
     /*  400221 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(400296), // Rule ID 7436 //
     /*  400226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  400229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  400237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  400240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  400243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400272 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  400272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  400275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400294 */     GIR_RootConstrainSelectedInstOperands,
     /*  400295 */     // GIR_Coverage, 7436,
     /*  400295 */     GIR_EraseRootFromParent_Done,
     /*  400296 */   // Label 7151: @400296
     /*  400296 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(400371), // Rule ID 7437 //
     /*  400301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  400304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  400312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  400315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  400318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400347 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  400347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  400350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400369 */     GIR_RootConstrainSelectedInstOperands,
     /*  400370 */     // GIR_Coverage, 7437,
     /*  400370 */     GIR_EraseRootFromParent_Done,
     /*  400371 */   // Label 7152: @400371
     /*  400371 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(400446), // Rule ID 7440 //
     /*  400376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  400379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  400387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  400390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  400393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400422 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  400422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400444 */     GIR_RootConstrainSelectedInstOperands,
     /*  400445 */     // GIR_Coverage, 7440,
     /*  400445 */     GIR_EraseRootFromParent_Done,
     /*  400446 */   // Label 7153: @400446
     /*  400446 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(400521), // Rule ID 7441 //
     /*  400451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  400454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  400462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  400465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  400468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400497 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  400497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400519 */     GIR_RootConstrainSelectedInstOperands,
     /*  400520 */     // GIR_Coverage, 7441,
     /*  400520 */     GIR_EraseRootFromParent_Done,
     /*  400521 */   // Label 7154: @400521
     /*  400521 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(400596), // Rule ID 7444 //
     /*  400526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  400529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  400540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400572 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  400575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400594 */     GIR_RootConstrainSelectedInstOperands,
     /*  400595 */     // GIR_Coverage, 7444,
     /*  400595 */     GIR_EraseRootFromParent_Done,
     /*  400596 */   // Label 7155: @400596
     /*  400596 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(400671), // Rule ID 7445 //
     /*  400601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  400604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  400615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400647 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  400650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400669 */     GIR_RootConstrainSelectedInstOperands,
     /*  400670 */     // GIR_Coverage, 7445,
     /*  400670 */     GIR_EraseRootFromParent_Done,
     /*  400671 */   // Label 7156: @400671
     /*  400671 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(400746), // Rule ID 7448 //
     /*  400676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  400679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  400690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400722 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  400725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400744 */     GIR_RootConstrainSelectedInstOperands,
     /*  400745 */     // GIR_Coverage, 7448,
     /*  400745 */     GIR_EraseRootFromParent_Done,
     /*  400746 */   // Label 7157: @400746
     /*  400746 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(400821), // Rule ID 7449 //
     /*  400751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  400754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  400765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400786 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400797 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  400800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400819 */     GIR_RootConstrainSelectedInstOperands,
     /*  400820 */     // GIR_Coverage, 7449,
     /*  400820 */     GIR_EraseRootFromParent_Done,
     /*  400821 */   // Label 7158: @400821
     /*  400821 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(400896), // Rule ID 7452 //
     /*  400826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  400829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  400837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  400840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  400843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400872 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400894 */     GIR_RootConstrainSelectedInstOperands,
     /*  400895 */     // GIR_Coverage, 7452,
     /*  400895 */     GIR_EraseRootFromParent_Done,
     /*  400896 */   // Label 7159: @400896
     /*  400896 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(400971), // Rule ID 7453 //
     /*  400901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  400904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  400912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  400915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  400918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400947 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400969 */     GIR_RootConstrainSelectedInstOperands,
     /*  400970 */     // GIR_Coverage, 7453,
     /*  400970 */     GIR_EraseRootFromParent_Done,
     /*  400971 */   // Label 7160: @400971
     /*  400971 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(401048), // Rule ID 2758 //
     /*  400976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  400979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  400987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  400990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  400993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401008 */     // MIs[0] Operand 4
     /*  401008 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  401029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401046 */     GIR_RootConstrainSelectedInstOperands,
     /*  401047 */     // GIR_Coverage, 2758,
     /*  401047 */     GIR_EraseRootFromParent_Done,
     /*  401048 */   // Label 7161: @401048
     /*  401048 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(401125), // Rule ID 2759 //
     /*  401053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  401064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  401067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  401070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401085 */     // MIs[0] Operand 4
     /*  401085 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401103 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  401106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401123 */     GIR_RootConstrainSelectedInstOperands,
     /*  401124 */     // GIR_Coverage, 2759,
     /*  401124 */     GIR_EraseRootFromParent_Done,
     /*  401125 */   // Label 7162: @401125
     /*  401125 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(401202), // Rule ID 20650 //
     /*  401130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  401141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  401144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  401147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401162 */     // MIs[0] Operand 4
     /*  401162 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401180 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  401183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401200 */     GIR_RootConstrainSelectedInstOperands,
     /*  401201 */     // GIR_Coverage, 20650,
     /*  401201 */     GIR_EraseRootFromParent_Done,
     /*  401202 */   // Label 7163: @401202
     /*  401202 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(401279), // Rule ID 20651 //
     /*  401207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  401218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  401221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  401224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401239 */     // MIs[0] Operand 4
     /*  401239 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401257 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  401260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401277 */     GIR_RootConstrainSelectedInstOperands,
     /*  401278 */     // GIR_Coverage, 20651,
     /*  401278 */     GIR_EraseRootFromParent_Done,
     /*  401279 */   // Label 7164: @401279
     /*  401279 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(401356), // Rule ID 20654 //
     /*  401284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  401287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  401295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  401298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  401301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401316 */     // MIs[0] Operand 4
     /*  401316 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401334 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  401337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401354 */     GIR_RootConstrainSelectedInstOperands,
     /*  401355 */     // GIR_Coverage, 20654,
     /*  401355 */     GIR_EraseRootFromParent_Done,
     /*  401356 */   // Label 7165: @401356
     /*  401356 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(401433), // Rule ID 20655 //
     /*  401361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  401364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  401372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  401375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  401378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401393 */     // MIs[0] Operand 4
     /*  401393 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401411 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  401411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  401414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401431 */     GIR_RootConstrainSelectedInstOperands,
     /*  401432 */     // GIR_Coverage, 20655,
     /*  401432 */     GIR_EraseRootFromParent_Done,
     /*  401433 */   // Label 7166: @401433
     /*  401433 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(401510), // Rule ID 20658 //
     /*  401438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  401449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  401452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  401455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401470 */     // MIs[0] Operand 4
     /*  401470 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401488 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401508 */     GIR_RootConstrainSelectedInstOperands,
     /*  401509 */     // GIR_Coverage, 20658,
     /*  401509 */     GIR_EraseRootFromParent_Done,
     /*  401510 */   // Label 7167: @401510
     /*  401510 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(401587), // Rule ID 20659 //
     /*  401515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  401526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  401529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  401532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401547 */     // MIs[0] Operand 4
     /*  401547 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401565 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401585 */     GIR_RootConstrainSelectedInstOperands,
     /*  401586 */     // GIR_Coverage, 20659,
     /*  401586 */     GIR_EraseRootFromParent_Done,
     /*  401587 */   // Label 7168: @401587
     /*  401587 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(401664), // Rule ID 20662 //
     /*  401592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  401595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  401603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  401606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  401609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401624 */     // MIs[0] Operand 4
     /*  401624 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401642 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401662 */     GIR_RootConstrainSelectedInstOperands,
     /*  401663 */     // GIR_Coverage, 20662,
     /*  401663 */     GIR_EraseRootFromParent_Done,
     /*  401664 */   // Label 7169: @401664
     /*  401664 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(401741), // Rule ID 20663 //
     /*  401669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  401672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  401680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  401683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  401686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401701 */     // MIs[0] Operand 4
     /*  401701 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401719 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  401719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401739 */     GIR_RootConstrainSelectedInstOperands,
     /*  401740 */     // GIR_Coverage, 20663,
     /*  401740 */     GIR_EraseRootFromParent_Done,
     /*  401741 */   // Label 7170: @401741
     /*  401741 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(401818), // Rule ID 20666 //
     /*  401746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  401749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  401757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  401760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  401763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401778 */     // MIs[0] Operand 4
     /*  401778 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401796 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  401796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  401813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401816 */     GIR_RootConstrainSelectedInstOperands,
     /*  401817 */     // GIR_Coverage, 20666,
     /*  401817 */     GIR_EraseRootFromParent_Done,
     /*  401818 */   // Label 7171: @401818
     /*  401818 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(401895), // Rule ID 20667 //
     /*  401823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  401826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  401834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  401837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  401840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401855 */     // MIs[0] Operand 4
     /*  401855 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401873 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  401873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  401890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401893 */     GIR_RootConstrainSelectedInstOperands,
     /*  401894 */     // GIR_Coverage, 20667,
     /*  401894 */     GIR_EraseRootFromParent_Done,
     /*  401895 */   // Label 7172: @401895
     /*  401895 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(401972), // Rule ID 20670 //
     /*  401900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  401911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  401914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  401917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401932 */     // MIs[0] Operand 4
     /*  401932 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401950 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401970 */     GIR_RootConstrainSelectedInstOperands,
     /*  401971 */     // GIR_Coverage, 20670,
     /*  401971 */     GIR_EraseRootFromParent_Done,
     /*  401972 */   // Label 7173: @401972
     /*  401972 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(402049), // Rule ID 20671 //
     /*  401977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  401988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  401991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  401994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402009 */     // MIs[0] Operand 4
     /*  402009 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402027 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402047 */     GIR_RootConstrainSelectedInstOperands,
     /*  402048 */     // GIR_Coverage, 20671,
     /*  402048 */     GIR_EraseRootFromParent_Done,
     /*  402049 */   // Label 7174: @402049
     /*  402049 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(402126), // Rule ID 20674 //
     /*  402054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  402057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  402065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  402068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  402071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402086 */     // MIs[0] Operand 4
     /*  402086 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402104 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  402104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402124 */     GIR_RootConstrainSelectedInstOperands,
     /*  402125 */     // GIR_Coverage, 20674,
     /*  402125 */     GIR_EraseRootFromParent_Done,
     /*  402126 */   // Label 7175: @402126
     /*  402126 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(402203), // Rule ID 20675 //
     /*  402131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  402134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  402142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  402145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  402148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402163 */     // MIs[0] Operand 4
     /*  402163 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402181 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402201 */     GIR_RootConstrainSelectedInstOperands,
     /*  402202 */     // GIR_Coverage, 20675,
     /*  402202 */     GIR_EraseRootFromParent_Done,
     /*  402203 */   // Label 7176: @402203
     /*  402203 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(402280), // Rule ID 20678 //
     /*  402208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  402211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  402219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  402222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  402225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402240 */     // MIs[0] Operand 4
     /*  402240 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402258 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  402258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402278 */     GIR_RootConstrainSelectedInstOperands,
     /*  402279 */     // GIR_Coverage, 20678,
     /*  402279 */     GIR_EraseRootFromParent_Done,
     /*  402280 */   // Label 7177: @402280
     /*  402280 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(402357), // Rule ID 20679 //
     /*  402285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  402288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  402296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  402299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  402302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402317 */     // MIs[0] Operand 4
     /*  402317 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402335 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402355 */     GIR_RootConstrainSelectedInstOperands,
     /*  402356 */     // GIR_Coverage, 20679,
     /*  402356 */     GIR_EraseRootFromParent_Done,
     /*  402357 */   // Label 7178: @402357
     /*  402357 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(402434), // Rule ID 20682 //
     /*  402362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  402365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  402373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  402376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  402379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402394 */     // MIs[0] Operand 4
     /*  402394 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402432 */     GIR_RootConstrainSelectedInstOperands,
     /*  402433 */     // GIR_Coverage, 20682,
     /*  402433 */     GIR_EraseRootFromParent_Done,
     /*  402434 */   // Label 7179: @402434
     /*  402434 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(402511), // Rule ID 20683 //
     /*  402439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  402442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  402450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  402453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  402456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402471 */     // MIs[0] Operand 4
     /*  402471 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402509 */     GIR_RootConstrainSelectedInstOperands,
     /*  402510 */     // GIR_Coverage, 20683,
     /*  402510 */     GIR_EraseRootFromParent_Done,
     /*  402511 */   // Label 7180: @402511
     /*  402511 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(402588), // Rule ID 20686 //
     /*  402516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  402519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  402527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  402530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  402533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402548 */     // MIs[0] Operand 4
     /*  402548 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402566 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402586 */     GIR_RootConstrainSelectedInstOperands,
     /*  402587 */     // GIR_Coverage, 20686,
     /*  402587 */     GIR_EraseRootFromParent_Done,
     /*  402588 */   // Label 7181: @402588
     /*  402588 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(402665), // Rule ID 20687 //
     /*  402593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  402596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  402604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  402607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  402610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402625 */     // MIs[0] Operand 4
     /*  402625 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402643 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402663 */     GIR_RootConstrainSelectedInstOperands,
     /*  402664 */     // GIR_Coverage, 20687,
     /*  402664 */     GIR_EraseRootFromParent_Done,
     /*  402665 */   // Label 7182: @402665
     /*  402665 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(402742), // Rule ID 20690 //
     /*  402670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  402673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  402681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  402684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  402687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402702 */     // MIs[0] Operand 4
     /*  402702 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402720 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402740 */     GIR_RootConstrainSelectedInstOperands,
     /*  402741 */     // GIR_Coverage, 20690,
     /*  402741 */     GIR_EraseRootFromParent_Done,
     /*  402742 */   // Label 7183: @402742
     /*  402742 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(402819), // Rule ID 20691 //
     /*  402747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  402750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  402758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  402761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  402764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402779 */     // MIs[0] Operand 4
     /*  402779 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402797 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402817 */     GIR_RootConstrainSelectedInstOperands,
     /*  402818 */     // GIR_Coverage, 20691,
     /*  402818 */     GIR_EraseRootFromParent_Done,
     /*  402819 */   // Label 7184: @402819
     /*  402819 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(402896), // Rule ID 20694 //
     /*  402824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  402827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  402835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  402838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  402841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402856 */     // MIs[0] Operand 4
     /*  402856 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  402874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402894 */     GIR_RootConstrainSelectedInstOperands,
     /*  402895 */     // GIR_Coverage, 20694,
     /*  402895 */     GIR_EraseRootFromParent_Done,
     /*  402896 */   // Label 7185: @402896
     /*  402896 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(402973), // Rule ID 20695 //
     /*  402901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  402904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  402912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  402915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  402918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402933 */     // MIs[0] Operand 4
     /*  402933 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  402951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402971 */     GIR_RootConstrainSelectedInstOperands,
     /*  402972 */     // GIR_Coverage, 20695,
     /*  402972 */     GIR_EraseRootFromParent_Done,
     /*  402973 */   // Label 7186: @402973
     /*  402973 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(403050), // Rule ID 20698 //
     /*  402978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  402981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  402989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  402992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  402995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403010 */     // MIs[0] Operand 4
     /*  403010 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403028 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  403028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  403031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403048 */     GIR_RootConstrainSelectedInstOperands,
     /*  403049 */     // GIR_Coverage, 20698,
     /*  403049 */     GIR_EraseRootFromParent_Done,
     /*  403050 */   // Label 7187: @403050
     /*  403050 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(403127), // Rule ID 20699 //
     /*  403055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  403058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  403063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  403066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  403069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  403072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403087 */     // MIs[0] Operand 4
     /*  403087 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403105 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  403105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  403108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403125 */     GIR_RootConstrainSelectedInstOperands,
     /*  403126 */     // GIR_Coverage, 20699,
     /*  403126 */     GIR_EraseRootFromParent_Done,
     /*  403127 */   // Label 7188: @403127
     /*  403127 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(403204), // Rule ID 20702 //
     /*  403132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  403135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  403140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  403143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  403146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  403149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403164 */     // MIs[0] Operand 4
     /*  403164 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403182 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  403182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  403185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403202 */     GIR_RootConstrainSelectedInstOperands,
     /*  403203 */     // GIR_Coverage, 20702,
     /*  403203 */     GIR_EraseRootFromParent_Done,
     /*  403204 */   // Label 7189: @403204
     /*  403204 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(403281), // Rule ID 20703 //
     /*  403209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  403212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  403217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  403220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  403223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  403226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403241 */     // MIs[0] Operand 4
     /*  403241 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403259 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  403259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  403262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403279 */     GIR_RootConstrainSelectedInstOperands,
     /*  403280 */     // GIR_Coverage, 20703,
     /*  403280 */     GIR_EraseRootFromParent_Done,
     /*  403281 */   // Label 7190: @403281
     /*  403281 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(403358), // Rule ID 20706 //
     /*  403286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  403297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  403300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  403303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403318 */     // MIs[0] Operand 4
     /*  403318 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403336 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  403339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403356 */     GIR_RootConstrainSelectedInstOperands,
     /*  403357 */     // GIR_Coverage, 20706,
     /*  403357 */     GIR_EraseRootFromParent_Done,
     /*  403358 */   // Label 7191: @403358
     /*  403358 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(403435), // Rule ID 20707 //
     /*  403363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  403374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  403377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  403380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403395 */     // MIs[0] Operand 4
     /*  403395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403413 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  403416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403433 */     GIR_RootConstrainSelectedInstOperands,
     /*  403434 */     // GIR_Coverage, 20707,
     /*  403434 */     GIR_EraseRootFromParent_Done,
     /*  403435 */   // Label 7192: @403435
     /*  403435 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(403512), // Rule ID 20710 //
     /*  403440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  403451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  403454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  403457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403472 */     // MIs[0] Operand 4
     /*  403472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403490 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403510 */     GIR_RootConstrainSelectedInstOperands,
     /*  403511 */     // GIR_Coverage, 20710,
     /*  403511 */     GIR_EraseRootFromParent_Done,
     /*  403512 */   // Label 7193: @403512
     /*  403512 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(403589), // Rule ID 20711 //
     /*  403517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  403528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  403531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  403534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403549 */     // MIs[0] Operand 4
     /*  403549 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403567 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403587 */     GIR_RootConstrainSelectedInstOperands,
     /*  403588 */     // GIR_Coverage, 20711,
     /*  403588 */     GIR_EraseRootFromParent_Done,
     /*  403589 */   // Label 7194: @403589
     /*  403589 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(403666), // Rule ID 20714 //
     /*  403594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  403597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  403605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  403608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  403611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403626 */     // MIs[0] Operand 4
     /*  403626 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403644 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403664 */     GIR_RootConstrainSelectedInstOperands,
     /*  403665 */     // GIR_Coverage, 20714,
     /*  403665 */     GIR_EraseRootFromParent_Done,
     /*  403666 */   // Label 7195: @403666
     /*  403666 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(403743), // Rule ID 20715 //
     /*  403671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  403674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  403682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  403685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  403688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403703 */     // MIs[0] Operand 4
     /*  403703 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403741 */     GIR_RootConstrainSelectedInstOperands,
     /*  403742 */     // GIR_Coverage, 20715,
     /*  403742 */     GIR_EraseRootFromParent_Done,
     /*  403743 */   // Label 7196: @403743
     /*  403743 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(403820), // Rule ID 20718 //
     /*  403748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  403759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  403762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  403765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403780 */     // MIs[0] Operand 4
     /*  403780 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403818 */     GIR_RootConstrainSelectedInstOperands,
     /*  403819 */     // GIR_Coverage, 20718,
     /*  403819 */     GIR_EraseRootFromParent_Done,
     /*  403820 */   // Label 7197: @403820
     /*  403820 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(403897), // Rule ID 20719 //
     /*  403825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  403836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  403839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  403842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403857 */     // MIs[0] Operand 4
     /*  403857 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403875 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403895 */     GIR_RootConstrainSelectedInstOperands,
     /*  403896 */     // GIR_Coverage, 20719,
     /*  403896 */     GIR_EraseRootFromParent_Done,
     /*  403897 */   // Label 7198: @403897
     /*  403897 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(403974), // Rule ID 20722 //
     /*  403902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  403905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  403913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  403916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  403919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403934 */     // MIs[0] Operand 4
     /*  403934 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403972 */     GIR_RootConstrainSelectedInstOperands,
     /*  403973 */     // GIR_Coverage, 20722,
     /*  403973 */     GIR_EraseRootFromParent_Done,
     /*  403974 */   // Label 7199: @403974
     /*  403974 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(404051), // Rule ID 20723 //
     /*  403979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  403982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  403990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  403993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  403996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404011 */     // MIs[0] Operand 4
     /*  404011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404029 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  404032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404049 */     GIR_RootConstrainSelectedInstOperands,
     /*  404050 */     // GIR_Coverage, 20723,
     /*  404050 */     GIR_EraseRootFromParent_Done,
     /*  404051 */   // Label 7200: @404051
     /*  404051 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(404128), // Rule ID 20726 //
     /*  404056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  404059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  404067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  404070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  404073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404088 */     // MIs[0] Operand 4
     /*  404088 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  404109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404126 */     GIR_RootConstrainSelectedInstOperands,
     /*  404127 */     // GIR_Coverage, 20726,
     /*  404127 */     GIR_EraseRootFromParent_Done,
     /*  404128 */   // Label 7201: @404128
     /*  404128 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(404205), // Rule ID 20727 //
     /*  404133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  404136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  404144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  404147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  404150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404165 */     // MIs[0] Operand 4
     /*  404165 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404183 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  404186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404203 */     GIR_RootConstrainSelectedInstOperands,
     /*  404204 */     // GIR_Coverage, 20727,
     /*  404204 */     GIR_EraseRootFromParent_Done,
     /*  404205 */   // Label 7202: @404205
     /*  404205 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(404282), // Rule ID 20730 //
     /*  404210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  404221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  404224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  404227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404242 */     // MIs[0] Operand 4
     /*  404242 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404260 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404280 */     GIR_RootConstrainSelectedInstOperands,
     /*  404281 */     // GIR_Coverage, 20730,
     /*  404281 */     GIR_EraseRootFromParent_Done,
     /*  404282 */   // Label 7203: @404282
     /*  404282 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(404359), // Rule ID 20731 //
     /*  404287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  404298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  404301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  404304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404319 */     // MIs[0] Operand 4
     /*  404319 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404357 */     GIR_RootConstrainSelectedInstOperands,
     /*  404358 */     // GIR_Coverage, 20731,
     /*  404358 */     GIR_EraseRootFromParent_Done,
     /*  404359 */   // Label 7204: @404359
     /*  404359 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(404436), // Rule ID 20734 //
     /*  404364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  404375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  404378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  404381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404396 */     // MIs[0] Operand 4
     /*  404396 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404414 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404434 */     GIR_RootConstrainSelectedInstOperands,
     /*  404435 */     // GIR_Coverage, 20734,
     /*  404435 */     GIR_EraseRootFromParent_Done,
     /*  404436 */   // Label 7205: @404436
     /*  404436 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(404513), // Rule ID 20735 //
     /*  404441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  404452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  404455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  404458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404473 */     // MIs[0] Operand 4
     /*  404473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404491 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404511 */     GIR_RootConstrainSelectedInstOperands,
     /*  404512 */     // GIR_Coverage, 20735,
     /*  404512 */     GIR_EraseRootFromParent_Done,
     /*  404513 */   // Label 7206: @404513
     /*  404513 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(404590), // Rule ID 20738 //
     /*  404518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  404529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  404532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  404535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404550 */     // MIs[0] Operand 4
     /*  404550 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404588 */     GIR_RootConstrainSelectedInstOperands,
     /*  404589 */     // GIR_Coverage, 20738,
     /*  404589 */     GIR_EraseRootFromParent_Done,
     /*  404590 */   // Label 7207: @404590
     /*  404590 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(404667), // Rule ID 20739 //
     /*  404595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  404606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  404609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  404612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404627 */     // MIs[0] Operand 4
     /*  404627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404645 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404665 */     GIR_RootConstrainSelectedInstOperands,
     /*  404666 */     // GIR_Coverage, 20739,
     /*  404666 */     GIR_EraseRootFromParent_Done,
     /*  404667 */   // Label 7208: @404667
     /*  404667 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(404744), // Rule ID 20742 //
     /*  404672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  404683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  404686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  404689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404704 */     // MIs[0] Operand 4
     /*  404704 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404742 */     GIR_RootConstrainSelectedInstOperands,
     /*  404743 */     // GIR_Coverage, 20742,
     /*  404743 */     GIR_EraseRootFromParent_Done,
     /*  404744 */   // Label 7209: @404744
     /*  404744 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(404821), // Rule ID 20743 //
     /*  404749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  404760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  404763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  404766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404781 */     // MIs[0] Operand 4
     /*  404781 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404819 */     GIR_RootConstrainSelectedInstOperands,
     /*  404820 */     // GIR_Coverage, 20743,
     /*  404820 */     GIR_EraseRootFromParent_Done,
     /*  404821 */   // Label 7210: @404821
     /*  404821 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(404898), // Rule ID 20746 //
     /*  404826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  404837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  404840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  404843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404858 */     // MIs[0] Operand 4
     /*  404858 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404896 */     GIR_RootConstrainSelectedInstOperands,
     /*  404897 */     // GIR_Coverage, 20746,
     /*  404897 */     GIR_EraseRootFromParent_Done,
     /*  404898 */   // Label 7211: @404898
     /*  404898 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(404975), // Rule ID 20747 //
     /*  404903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  404914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  404917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  404920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404935 */     // MIs[0] Operand 4
     /*  404935 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404953 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404973 */     GIR_RootConstrainSelectedInstOperands,
     /*  404974 */     // GIR_Coverage, 20747,
     /*  404974 */     GIR_EraseRootFromParent_Done,
     /*  404975 */   // Label 7212: @404975
     /*  404975 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(405052), // Rule ID 20750 //
     /*  404980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  404991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  404994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  404997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405012 */     // MIs[0] Operand 4
     /*  405012 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  405033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405050 */     GIR_RootConstrainSelectedInstOperands,
     /*  405051 */     // GIR_Coverage, 20750,
     /*  405051 */     GIR_EraseRootFromParent_Done,
     /*  405052 */   // Label 7213: @405052
     /*  405052 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(405129), // Rule ID 20751 //
     /*  405057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  405060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  405068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  405071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  405074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405089 */     // MIs[0] Operand 4
     /*  405089 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405107 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  405107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  405110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405127 */     GIR_RootConstrainSelectedInstOperands,
     /*  405128 */     // GIR_Coverage, 20751,
     /*  405128 */     GIR_EraseRootFromParent_Done,
     /*  405129 */   // Label 7214: @405129
     /*  405129 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(405206), // Rule ID 20754 //
     /*  405134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  405137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  405145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  405148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  405151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405166 */     // MIs[0] Operand 4
     /*  405166 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  405184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  405187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405204 */     GIR_RootConstrainSelectedInstOperands,
     /*  405205 */     // GIR_Coverage, 20754,
     /*  405205 */     GIR_EraseRootFromParent_Done,
     /*  405206 */   // Label 7215: @405206
     /*  405206 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(405283), // Rule ID 20755 //
     /*  405211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  405214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  405222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  405225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  405228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405243 */     // MIs[0] Operand 4
     /*  405243 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405261 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  405261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  405264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405281 */     GIR_RootConstrainSelectedInstOperands,
     /*  405282 */     // GIR_Coverage, 20755,
     /*  405282 */     GIR_EraseRootFromParent_Done,
     /*  405283 */   // Label 7216: @405283
     /*  405283 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(405360), // Rule ID 20758 //
     /*  405288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  405291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  405299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  405302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  405305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405320 */     // MIs[0] Operand 4
     /*  405320 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405338 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  405338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  405341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405358 */     GIR_RootConstrainSelectedInstOperands,
     /*  405359 */     // GIR_Coverage, 20758,
     /*  405359 */     GIR_EraseRootFromParent_Done,
     /*  405360 */   // Label 7217: @405360
     /*  405360 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(405437), // Rule ID 20759 //
     /*  405365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  405368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  405376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  405379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  405382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405397 */     // MIs[0] Operand 4
     /*  405397 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405415 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  405415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  405418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405435 */     GIR_RootConstrainSelectedInstOperands,
     /*  405436 */     // GIR_Coverage, 20759,
     /*  405436 */     GIR_EraseRootFromParent_Done,
     /*  405437 */   // Label 7218: @405437
     /*  405437 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(405514), // Rule ID 20762 //
     /*  405442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  405445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  405453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  405456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  405459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405474 */     // MIs[0] Operand 4
     /*  405474 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405492 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  405492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  405495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405512 */     GIR_RootConstrainSelectedInstOperands,
     /*  405513 */     // GIR_Coverage, 20762,
     /*  405513 */     GIR_EraseRootFromParent_Done,
     /*  405514 */   // Label 7219: @405514
     /*  405514 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(405591), // Rule ID 20763 //
     /*  405519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  405522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  405530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  405533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  405536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405551 */     // MIs[0] Operand 4
     /*  405551 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405569 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  405569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  405572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405589 */     GIR_RootConstrainSelectedInstOperands,
     /*  405590 */     // GIR_Coverage, 20763,
     /*  405590 */     GIR_EraseRootFromParent_Done,
     /*  405591 */   // Label 7220: @405591
     /*  405591 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(405668), // Rule ID 21122 //
     /*  405596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  405607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  405610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  405613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405628 */     // MIs[0] Operand 4
     /*  405628 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  405649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405666 */     GIR_RootConstrainSelectedInstOperands,
     /*  405667 */     // GIR_Coverage, 21122,
     /*  405667 */     GIR_EraseRootFromParent_Done,
     /*  405668 */   // Label 7221: @405668
     /*  405668 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(405745), // Rule ID 21123 //
     /*  405673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  405684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  405687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  405690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405705 */     // MIs[0] Operand 4
     /*  405705 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405723 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  405726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405743 */     GIR_RootConstrainSelectedInstOperands,
     /*  405744 */     // GIR_Coverage, 21123,
     /*  405744 */     GIR_EraseRootFromParent_Done,
     /*  405745 */   // Label 7222: @405745
     /*  405745 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(405822), // Rule ID 21126 //
     /*  405750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  405767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405782 */     // MIs[0] Operand 4
     /*  405782 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  405803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405820 */     GIR_RootConstrainSelectedInstOperands,
     /*  405821 */     // GIR_Coverage, 21126,
     /*  405821 */     GIR_EraseRootFromParent_Done,
     /*  405822 */   // Label 7223: @405822
     /*  405822 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(405899), // Rule ID 21127 //
     /*  405827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  405844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405859 */     // MIs[0] Operand 4
     /*  405859 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  405880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405897 */     GIR_RootConstrainSelectedInstOperands,
     /*  405898 */     // GIR_Coverage, 21127,
     /*  405898 */     GIR_EraseRootFromParent_Done,
     /*  405899 */   // Label 7224: @405899
     /*  405899 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(405976), // Rule ID 21130 //
     /*  405904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  405921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405936 */     // MIs[0] Operand 4
     /*  405936 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405954 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  405957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405974 */     GIR_RootConstrainSelectedInstOperands,
     /*  405975 */     // GIR_Coverage, 21130,
     /*  405975 */     GIR_EraseRootFromParent_Done,
     /*  405976 */   // Label 7225: @405976
     /*  405976 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(406053), // Rule ID 21131 //
     /*  405981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  405998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406013 */     // MIs[0] Operand 4
     /*  406013 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  406034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406051 */     GIR_RootConstrainSelectedInstOperands,
     /*  406052 */     // GIR_Coverage, 21131,
     /*  406052 */     GIR_EraseRootFromParent_Done,
     /*  406053 */   // Label 7226: @406053
     /*  406053 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(406130), // Rule ID 21134 //
     /*  406058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  406075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406090 */     // MIs[0] Operand 4
     /*  406090 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406108 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  406111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406128 */     GIR_RootConstrainSelectedInstOperands,
     /*  406129 */     // GIR_Coverage, 21134,
     /*  406129 */     GIR_EraseRootFromParent_Done,
     /*  406130 */   // Label 7227: @406130
     /*  406130 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(406207), // Rule ID 21135 //
     /*  406135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  406152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406167 */     // MIs[0] Operand 4
     /*  406167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406185 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  406188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406205 */     GIR_RootConstrainSelectedInstOperands,
     /*  406206 */     // GIR_Coverage, 21135,
     /*  406206 */     GIR_EraseRootFromParent_Done,
     /*  406207 */   // Label 7228: @406207
     /*  406207 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(406284), // Rule ID 21138 //
     /*  406212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  406223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  406226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  406229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406244 */     // MIs[0] Operand 4
     /*  406244 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  406265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406282 */     GIR_RootConstrainSelectedInstOperands,
     /*  406283 */     // GIR_Coverage, 21138,
     /*  406283 */     GIR_EraseRootFromParent_Done,
     /*  406284 */   // Label 7229: @406284
     /*  406284 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(406361), // Rule ID 21139 //
     /*  406289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  406300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  406303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  406306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406321 */     // MIs[0] Operand 4
     /*  406321 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406339 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  406342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406359 */     GIR_RootConstrainSelectedInstOperands,
     /*  406360 */     // GIR_Coverage, 21139,
     /*  406360 */     GIR_EraseRootFromParent_Done,
     /*  406361 */   // Label 7230: @406361
     /*  406361 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(406438), // Rule ID 21142 //
     /*  406366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  406377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  406380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406398 */     // MIs[0] Operand 4
     /*  406398 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406416 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  406419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406436 */     GIR_RootConstrainSelectedInstOperands,
     /*  406437 */     // GIR_Coverage, 21142,
     /*  406437 */     GIR_EraseRootFromParent_Done,
     /*  406438 */   // Label 7231: @406438
     /*  406438 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(406515), // Rule ID 21143 //
     /*  406443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  406454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  406457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406475 */     // MIs[0] Operand 4
     /*  406475 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406493 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  406496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406513 */     GIR_RootConstrainSelectedInstOperands,
     /*  406514 */     // GIR_Coverage, 21143,
     /*  406514 */     GIR_EraseRootFromParent_Done,
     /*  406515 */   // Label 7232: @406515
     /*  406515 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(406592), // Rule ID 21146 //
     /*  406520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406552 */     // MIs[0] Operand 4
     /*  406552 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406570 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  406573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406590 */     GIR_RootConstrainSelectedInstOperands,
     /*  406591 */     // GIR_Coverage, 21146,
     /*  406591 */     GIR_EraseRootFromParent_Done,
     /*  406592 */   // Label 7233: @406592
     /*  406592 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(406669), // Rule ID 21147 //
     /*  406597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406629 */     // MIs[0] Operand 4
     /*  406629 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406647 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  406650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406667 */     GIR_RootConstrainSelectedInstOperands,
     /*  406668 */     // GIR_Coverage, 21147,
     /*  406668 */     GIR_EraseRootFromParent_Done,
     /*  406669 */   // Label 7234: @406669
     /*  406669 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(406746), // Rule ID 21150 //
     /*  406674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  406685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  406688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  406691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406706 */     // MIs[0] Operand 4
     /*  406706 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406724 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  406727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406744 */     GIR_RootConstrainSelectedInstOperands,
     /*  406745 */     // GIR_Coverage, 21150,
     /*  406745 */     GIR_EraseRootFromParent_Done,
     /*  406746 */   // Label 7235: @406746
     /*  406746 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(406823), // Rule ID 21151 //
     /*  406751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  406762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  406765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  406768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406783 */     // MIs[0] Operand 4
     /*  406783 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406801 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  406804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406821 */     GIR_RootConstrainSelectedInstOperands,
     /*  406822 */     // GIR_Coverage, 21151,
     /*  406822 */     GIR_EraseRootFromParent_Done,
     /*  406823 */   // Label 7236: @406823
     /*  406823 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(406900), // Rule ID 21154 //
     /*  406828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  406839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  406842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  406845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406860 */     // MIs[0] Operand 4
     /*  406860 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406878 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  406881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406898 */     GIR_RootConstrainSelectedInstOperands,
     /*  406899 */     // GIR_Coverage, 21154,
     /*  406899 */     GIR_EraseRootFromParent_Done,
     /*  406900 */   // Label 7237: @406900
     /*  406900 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(406977), // Rule ID 21155 //
     /*  406905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  406916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  406919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  406922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406937 */     // MIs[0] Operand 4
     /*  406937 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406955 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  406958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406975 */     GIR_RootConstrainSelectedInstOperands,
     /*  406976 */     // GIR_Coverage, 21155,
     /*  406976 */     GIR_EraseRootFromParent_Done,
     /*  406977 */   // Label 7238: @406977
     /*  406977 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(407054), // Rule ID 21158 //
     /*  406982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  406993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  406996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  406999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407014 */     // MIs[0] Operand 4
     /*  407014 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407032 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  407035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407052 */     GIR_RootConstrainSelectedInstOperands,
     /*  407053 */     // GIR_Coverage, 21158,
     /*  407053 */     GIR_EraseRootFromParent_Done,
     /*  407054 */   // Label 7239: @407054
     /*  407054 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(407131), // Rule ID 21159 //
     /*  407059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  407070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  407073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  407076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407091 */     // MIs[0] Operand 4
     /*  407091 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407109 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  407112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407129 */     GIR_RootConstrainSelectedInstOperands,
     /*  407130 */     // GIR_Coverage, 21159,
     /*  407130 */     GIR_EraseRootFromParent_Done,
     /*  407131 */   // Label 7240: @407131
     /*  407131 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(407208), // Rule ID 21162 //
     /*  407136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  407147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  407150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  407153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407168 */     // MIs[0] Operand 4
     /*  407168 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407186 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  407189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407206 */     GIR_RootConstrainSelectedInstOperands,
     /*  407207 */     // GIR_Coverage, 21162,
     /*  407207 */     GIR_EraseRootFromParent_Done,
     /*  407208 */   // Label 7241: @407208
     /*  407208 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(407285), // Rule ID 21163 //
     /*  407213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  407224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  407227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  407230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407245 */     // MIs[0] Operand 4
     /*  407245 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407263 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  407266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407283 */     GIR_RootConstrainSelectedInstOperands,
     /*  407284 */     // GIR_Coverage, 21163,
     /*  407284 */     GIR_EraseRootFromParent_Done,
     /*  407285 */   // Label 7242: @407285
     /*  407285 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(407362), // Rule ID 21166 //
     /*  407290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  407301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  407304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  407307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407322 */     // MIs[0] Operand 4
     /*  407322 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  407343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407360 */     GIR_RootConstrainSelectedInstOperands,
     /*  407361 */     // GIR_Coverage, 21166,
     /*  407361 */     GIR_EraseRootFromParent_Done,
     /*  407362 */   // Label 7243: @407362
     /*  407362 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(407439), // Rule ID 21167 //
     /*  407367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  407378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  407381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  407384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407399 */     // MIs[0] Operand 4
     /*  407399 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407417 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  407420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407437 */     GIR_RootConstrainSelectedInstOperands,
     /*  407438 */     // GIR_Coverage, 21167,
     /*  407438 */     GIR_EraseRootFromParent_Done,
     /*  407439 */   // Label 7244: @407439
     /*  407439 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(407516), // Rule ID 21170 //
     /*  407444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  407455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  407458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  407461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407476 */     // MIs[0] Operand 4
     /*  407476 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407514 */     GIR_RootConstrainSelectedInstOperands,
     /*  407515 */     // GIR_Coverage, 21170,
     /*  407515 */     GIR_EraseRootFromParent_Done,
     /*  407516 */   // Label 7245: @407516
     /*  407516 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(407593), // Rule ID 21171 //
     /*  407521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  407532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  407535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  407538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407553 */     // MIs[0] Operand 4
     /*  407553 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407571 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407591 */     GIR_RootConstrainSelectedInstOperands,
     /*  407592 */     // GIR_Coverage, 21171,
     /*  407592 */     GIR_EraseRootFromParent_Done,
     /*  407593 */   // Label 7246: @407593
     /*  407593 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(407670), // Rule ID 21174 //
     /*  407598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  407615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407630 */     // MIs[0] Operand 4
     /*  407630 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407648 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407668 */     GIR_RootConstrainSelectedInstOperands,
     /*  407669 */     // GIR_Coverage, 21174,
     /*  407669 */     GIR_EraseRootFromParent_Done,
     /*  407670 */   // Label 7247: @407670
     /*  407670 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(407747), // Rule ID 21175 //
     /*  407675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  407692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407707 */     // MIs[0] Operand 4
     /*  407707 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407725 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407745 */     GIR_RootConstrainSelectedInstOperands,
     /*  407746 */     // GIR_Coverage, 21175,
     /*  407746 */     GIR_EraseRootFromParent_Done,
     /*  407747 */   // Label 7248: @407747
     /*  407747 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(407824), // Rule ID 21178 //
     /*  407752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  407763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  407766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407784 */     // MIs[0] Operand 4
     /*  407784 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  407805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407822 */     GIR_RootConstrainSelectedInstOperands,
     /*  407823 */     // GIR_Coverage, 21178,
     /*  407823 */     GIR_EraseRootFromParent_Done,
     /*  407824 */   // Label 7249: @407824
     /*  407824 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(407901), // Rule ID 21179 //
     /*  407829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  407840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  407843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407861 */     // MIs[0] Operand 4
     /*  407861 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407879 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  407882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407899 */     GIR_RootConstrainSelectedInstOperands,
     /*  407900 */     // GIR_Coverage, 21179,
     /*  407900 */     GIR_EraseRootFromParent_Done,
     /*  407901 */   // Label 7250: @407901
     /*  407901 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(407978), // Rule ID 21182 //
     /*  407906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  407917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  407920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407938 */     // MIs[0] Operand 4
     /*  407938 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407956 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  407959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407976 */     GIR_RootConstrainSelectedInstOperands,
     /*  407977 */     // GIR_Coverage, 21182,
     /*  407977 */     GIR_EraseRootFromParent_Done,
     /*  407978 */   // Label 7251: @407978
     /*  407978 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(408055), // Rule ID 21183 //
     /*  407983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  407994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  407997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  408000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408015 */     // MIs[0] Operand 4
     /*  408015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408033 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  408033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  408036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408053 */     GIR_RootConstrainSelectedInstOperands,
     /*  408054 */     // GIR_Coverage, 21183,
     /*  408054 */     GIR_EraseRootFromParent_Done,
     /*  408055 */   // Label 7252: @408055
     /*  408055 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(408132), // Rule ID 21186 //
     /*  408060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  408063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  408068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  408071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  408074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  408077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408092 */     // MIs[0] Operand 4
     /*  408092 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408110 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  408110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  408113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408130 */     GIR_RootConstrainSelectedInstOperands,
     /*  408131 */     // GIR_Coverage, 21186,
     /*  408131 */     GIR_EraseRootFromParent_Done,
     /*  408132 */   // Label 7253: @408132
     /*  408132 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(408209), // Rule ID 21187 //
     /*  408137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  408140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  408145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  408148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  408151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  408154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408169 */     // MIs[0] Operand 4
     /*  408169 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408187 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  408187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  408190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408207 */     GIR_RootConstrainSelectedInstOperands,
     /*  408208 */     // GIR_Coverage, 21187,
     /*  408208 */     GIR_EraseRootFromParent_Done,
     /*  408209 */   // Label 7254: @408209
     /*  408209 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(408286), // Rule ID 21190 //
     /*  408214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  408217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  408222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  408225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  408228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  408231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408246 */     // MIs[0] Operand 4
     /*  408246 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408264 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  408264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  408267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408284 */     GIR_RootConstrainSelectedInstOperands,
     /*  408285 */     // GIR_Coverage, 21190,
     /*  408285 */     GIR_EraseRootFromParent_Done,
     /*  408286 */   // Label 7255: @408286
     /*  408286 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(408363), // Rule ID 21191 //
     /*  408291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  408294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  408299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  408302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  408305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  408308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408323 */     // MIs[0] Operand 4
     /*  408323 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408341 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  408341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  408344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408361 */     GIR_RootConstrainSelectedInstOperands,
     /*  408362 */     // GIR_Coverage, 21191,
     /*  408362 */     GIR_EraseRootFromParent_Done,
     /*  408363 */   // Label 7256: @408363
     /*  408363 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(408440), // Rule ID 21494 //
     /*  408368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  408379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  408382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  408385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408400 */     // MIs[0] Operand 4
     /*  408400 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408418 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  408421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408438 */     GIR_RootConstrainSelectedInstOperands,
     /*  408439 */     // GIR_Coverage, 21494,
     /*  408439 */     GIR_EraseRootFromParent_Done,
     /*  408440 */   // Label 7257: @408440
     /*  408440 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(408517), // Rule ID 21495 //
     /*  408445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  408456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  408459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  408462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408477 */     // MIs[0] Operand 4
     /*  408477 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408495 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  408498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408515 */     GIR_RootConstrainSelectedInstOperands,
     /*  408516 */     // GIR_Coverage, 21495,
     /*  408516 */     GIR_EraseRootFromParent_Done,
     /*  408517 */   // Label 7258: @408517
     /*  408517 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(408594), // Rule ID 21498 //
     /*  408522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  408533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  408536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  408539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408554 */     // MIs[0] Operand 4
     /*  408554 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408572 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408592 */     GIR_RootConstrainSelectedInstOperands,
     /*  408593 */     // GIR_Coverage, 21498,
     /*  408593 */     GIR_EraseRootFromParent_Done,
     /*  408594 */   // Label 7259: @408594
     /*  408594 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(408671), // Rule ID 21499 //
     /*  408599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  408610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  408613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  408616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408631 */     // MIs[0] Operand 4
     /*  408631 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408649 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408669 */     GIR_RootConstrainSelectedInstOperands,
     /*  408670 */     // GIR_Coverage, 21499,
     /*  408670 */     GIR_EraseRootFromParent_Done,
     /*  408671 */   // Label 7260: @408671
     /*  408671 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(408748), // Rule ID 21502 //
     /*  408676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  408687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  408690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  408693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408708 */     // MIs[0] Operand 4
     /*  408708 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408726 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  408729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408746 */     GIR_RootConstrainSelectedInstOperands,
     /*  408747 */     // GIR_Coverage, 21502,
     /*  408747 */     GIR_EraseRootFromParent_Done,
     /*  408748 */   // Label 7261: @408748
     /*  408748 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(408825), // Rule ID 21503 //
     /*  408753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  408764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  408767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  408770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408785 */     // MIs[0] Operand 4
     /*  408785 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408803 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  408806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408823 */     GIR_RootConstrainSelectedInstOperands,
     /*  408824 */     // GIR_Coverage, 21503,
     /*  408824 */     GIR_EraseRootFromParent_Done,
     /*  408825 */   // Label 7262: @408825
     /*  408825 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(408902), // Rule ID 21506 //
     /*  408830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  408841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  408844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  408847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408862 */     // MIs[0] Operand 4
     /*  408862 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408880 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  408883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408900 */     GIR_RootConstrainSelectedInstOperands,
     /*  408901 */     // GIR_Coverage, 21506,
     /*  408901 */     GIR_EraseRootFromParent_Done,
     /*  408902 */   // Label 7263: @408902
     /*  408902 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(408979), // Rule ID 21507 //
     /*  408907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  408918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  408921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  408924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408939 */     // MIs[0] Operand 4
     /*  408939 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408957 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  408960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408977 */     GIR_RootConstrainSelectedInstOperands,
     /*  408978 */     // GIR_Coverage, 21507,
     /*  408978 */     GIR_EraseRootFromParent_Done,
     /*  408979 */   // Label 7264: @408979
     /*  408979 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(409056), // Rule ID 21510 //
     /*  408984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  408995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  408998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  409001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409016 */     // MIs[0] Operand 4
     /*  409016 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409034 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  409034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  409051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409054 */     GIR_RootConstrainSelectedInstOperands,
     /*  409055 */     // GIR_Coverage, 21510,
     /*  409055 */     GIR_EraseRootFromParent_Done,
     /*  409056 */   // Label 7265: @409056
     /*  409056 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(409133), // Rule ID 21511 //
     /*  409061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  409072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  409075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  409078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409093 */     // MIs[0] Operand 4
     /*  409093 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409111 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  409111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  409128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409131 */     GIR_RootConstrainSelectedInstOperands,
     /*  409132 */     // GIR_Coverage, 21511,
     /*  409132 */     GIR_EraseRootFromParent_Done,
     /*  409133 */   // Label 7266: @409133
     /*  409133 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(409210), // Rule ID 21514 //
     /*  409138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  409141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  409149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  409152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  409155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409170 */     // MIs[0] Operand 4
     /*  409170 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409188 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  409188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  409205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409208 */     GIR_RootConstrainSelectedInstOperands,
     /*  409209 */     // GIR_Coverage, 21514,
     /*  409209 */     GIR_EraseRootFromParent_Done,
     /*  409210 */   // Label 7267: @409210
     /*  409210 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(409287), // Rule ID 21515 //
     /*  409215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  409226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  409229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  409232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409247 */     // MIs[0] Operand 4
     /*  409247 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409265 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  409265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  409282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409285 */     GIR_RootConstrainSelectedInstOperands,
     /*  409286 */     // GIR_Coverage, 21515,
     /*  409286 */     GIR_EraseRootFromParent_Done,
     /*  409287 */   // Label 7268: @409287
     /*  409287 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(409364), // Rule ID 21518 //
     /*  409292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  409303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  409306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  409309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409324 */     // MIs[0] Operand 4
     /*  409324 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409342 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  409345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409362 */     GIR_RootConstrainSelectedInstOperands,
     /*  409363 */     // GIR_Coverage, 21518,
     /*  409363 */     GIR_EraseRootFromParent_Done,
     /*  409364 */   // Label 7269: @409364
     /*  409364 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(409441), // Rule ID 21519 //
     /*  409369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  409380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  409383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  409386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409401 */     // MIs[0] Operand 4
     /*  409401 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409419 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  409422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409439 */     GIR_RootConstrainSelectedInstOperands,
     /*  409440 */     // GIR_Coverage, 21519,
     /*  409440 */     GIR_EraseRootFromParent_Done,
     /*  409441 */   // Label 7270: @409441
     /*  409441 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(409518), // Rule ID 21522 //
     /*  409446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  409457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  409460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409478 */     // MIs[0] Operand 4
     /*  409478 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409516 */     GIR_RootConstrainSelectedInstOperands,
     /*  409517 */     // GIR_Coverage, 21522,
     /*  409517 */     GIR_EraseRootFromParent_Done,
     /*  409518 */   // Label 7271: @409518
     /*  409518 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(409595), // Rule ID 21523 //
     /*  409523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  409534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  409537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409555 */     // MIs[0] Operand 4
     /*  409555 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409573 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409593 */     GIR_RootConstrainSelectedInstOperands,
     /*  409594 */     // GIR_Coverage, 21523,
     /*  409594 */     GIR_EraseRootFromParent_Done,
     /*  409595 */   // Label 7272: @409595
     /*  409595 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(409672), // Rule ID 21526 //
     /*  409600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  409611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  409614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  409617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409632 */     // MIs[0] Operand 4
     /*  409632 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409670 */     GIR_RootConstrainSelectedInstOperands,
     /*  409671 */     // GIR_Coverage, 21526,
     /*  409671 */     GIR_EraseRootFromParent_Done,
     /*  409672 */   // Label 7273: @409672
     /*  409672 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(409749), // Rule ID 21527 //
     /*  409677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  409688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  409691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  409694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409709 */     // MIs[0] Operand 4
     /*  409709 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409747 */     GIR_RootConstrainSelectedInstOperands,
     /*  409748 */     // GIR_Coverage, 21527,
     /*  409748 */     GIR_EraseRootFromParent_Done,
     /*  409749 */   // Label 7274: @409749
     /*  409749 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(409826), // Rule ID 21530 //
     /*  409754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  409765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  409768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  409771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409786 */     // MIs[0] Operand 4
     /*  409786 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409804 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409824 */     GIR_RootConstrainSelectedInstOperands,
     /*  409825 */     // GIR_Coverage, 21530,
     /*  409825 */     GIR_EraseRootFromParent_Done,
     /*  409826 */   // Label 7275: @409826
     /*  409826 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(409903), // Rule ID 21531 //
     /*  409831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  409842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  409845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  409848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409863 */     // MIs[0] Operand 4
     /*  409863 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409881 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409901 */     GIR_RootConstrainSelectedInstOperands,
     /*  409902 */     // GIR_Coverage, 21531,
     /*  409902 */     GIR_EraseRootFromParent_Done,
     /*  409903 */   // Label 7276: @409903
     /*  409903 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(409980), // Rule ID 21534 //
     /*  409908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  409919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  409922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  409925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409940 */     // MIs[0] Operand 4
     /*  409940 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409958 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409978 */     GIR_RootConstrainSelectedInstOperands,
     /*  409979 */     // GIR_Coverage, 21534,
     /*  409979 */     GIR_EraseRootFromParent_Done,
     /*  409980 */   // Label 7277: @409980
     /*  409980 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(410057), // Rule ID 21535 //
     /*  409985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  409996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  409999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  410002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410017 */     // MIs[0] Operand 4
     /*  410017 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410035 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  410035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  410038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410055 */     GIR_RootConstrainSelectedInstOperands,
     /*  410056 */     // GIR_Coverage, 21535,
     /*  410056 */     GIR_EraseRootFromParent_Done,
     /*  410057 */   // Label 7278: @410057
     /*  410057 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(410134), // Rule ID 21538 //
     /*  410062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  410065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  410073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  410076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  410079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410094 */     // MIs[0] Operand 4
     /*  410094 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410112 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  410115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410132 */     GIR_RootConstrainSelectedInstOperands,
     /*  410133 */     // GIR_Coverage, 21538,
     /*  410133 */     GIR_EraseRootFromParent_Done,
     /*  410134 */   // Label 7279: @410134
     /*  410134 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(410211), // Rule ID 21539 //
     /*  410139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  410142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  410150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  410153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  410156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410171 */     // MIs[0] Operand 4
     /*  410171 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410189 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  410192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410209 */     GIR_RootConstrainSelectedInstOperands,
     /*  410210 */     // GIR_Coverage, 21539,
     /*  410210 */     GIR_EraseRootFromParent_Done,
     /*  410211 */   // Label 7280: @410211
     /*  410211 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(410288), // Rule ID 21542 //
     /*  410216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  410219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  410227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  410230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  410233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410248 */     // MIs[0] Operand 4
     /*  410248 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410266 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  410269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410286 */     GIR_RootConstrainSelectedInstOperands,
     /*  410287 */     // GIR_Coverage, 21542,
     /*  410287 */     GIR_EraseRootFromParent_Done,
     /*  410288 */   // Label 7281: @410288
     /*  410288 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(410365), // Rule ID 21543 //
     /*  410293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  410296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  410304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  410307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  410310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410325 */     // MIs[0] Operand 4
     /*  410325 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410343 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  410346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410363 */     GIR_RootConstrainSelectedInstOperands,
     /*  410364 */     // GIR_Coverage, 21543,
     /*  410364 */     GIR_EraseRootFromParent_Done,
     /*  410365 */   // Label 7282: @410365
     /*  410365 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(410442), // Rule ID 21546 //
     /*  410370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  410373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  410381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  410384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  410387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410402 */     // MIs[0] Operand 4
     /*  410402 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  410423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410440 */     GIR_RootConstrainSelectedInstOperands,
     /*  410441 */     // GIR_Coverage, 21546,
     /*  410441 */     GIR_EraseRootFromParent_Done,
     /*  410442 */   // Label 7283: @410442
     /*  410442 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(410519), // Rule ID 21547 //
     /*  410447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  410450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  410458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  410461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  410464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410479 */     // MIs[0] Operand 4
     /*  410479 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410497 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  410500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410517 */     GIR_RootConstrainSelectedInstOperands,
     /*  410518 */     // GIR_Coverage, 21547,
     /*  410518 */     GIR_EraseRootFromParent_Done,
     /*  410519 */   // Label 7284: @410519
     /*  410519 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(410596), // Rule ID 21550 //
     /*  410524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  410527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  410541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410556 */     // MIs[0] Operand 4
     /*  410556 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  410577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410594 */     GIR_RootConstrainSelectedInstOperands,
     /*  410595 */     // GIR_Coverage, 21550,
     /*  410595 */     GIR_EraseRootFromParent_Done,
     /*  410596 */   // Label 7285: @410596
     /*  410596 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(410673), // Rule ID 21551 //
     /*  410601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  410604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  410618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410633 */     // MIs[0] Operand 4
     /*  410633 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410651 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  410654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410671 */     GIR_RootConstrainSelectedInstOperands,
     /*  410672 */     // GIR_Coverage, 21551,
     /*  410672 */     GIR_EraseRootFromParent_Done,
     /*  410673 */   // Label 7286: @410673
     /*  410673 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(410750), // Rule ID 21554 //
     /*  410678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  410689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  410692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  410695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410710 */     // MIs[0] Operand 4
     /*  410710 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410728 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  410731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410748 */     GIR_RootConstrainSelectedInstOperands,
     /*  410749 */     // GIR_Coverage, 21554,
     /*  410749 */     GIR_EraseRootFromParent_Done,
     /*  410750 */   // Label 7287: @410750
     /*  410750 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(410827), // Rule ID 21555 //
     /*  410755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  410766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  410769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  410772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410787 */     // MIs[0] Operand 4
     /*  410787 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410805 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  410808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410825 */     GIR_RootConstrainSelectedInstOperands,
     /*  410826 */     // GIR_Coverage, 21555,
     /*  410826 */     GIR_EraseRootFromParent_Done,
     /*  410827 */   // Label 7288: @410827
     /*  410827 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(410904), // Rule ID 21558 //
     /*  410832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  410843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  410846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  410849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410864 */     // MIs[0] Operand 4
     /*  410864 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410882 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  410885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410902 */     GIR_RootConstrainSelectedInstOperands,
     /*  410903 */     // GIR_Coverage, 21558,
     /*  410903 */     GIR_EraseRootFromParent_Done,
     /*  410904 */   // Label 7289: @410904
     /*  410904 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(410981), // Rule ID 21559 //
     /*  410909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  410920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  410923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  410926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410941 */     // MIs[0] Operand 4
     /*  410941 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410959 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  410962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410979 */     GIR_RootConstrainSelectedInstOperands,
     /*  410980 */     // GIR_Coverage, 21559,
     /*  410980 */     GIR_EraseRootFromParent_Done,
     /*  410981 */   // Label 7290: @410981
     /*  410981 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(411058), // Rule ID 21562 //
     /*  410986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  410997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  411000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  411003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411018 */     // MIs[0] Operand 4
     /*  411018 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411036 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411056 */     GIR_RootConstrainSelectedInstOperands,
     /*  411057 */     // GIR_Coverage, 21562,
     /*  411057 */     GIR_EraseRootFromParent_Done,
     /*  411058 */   // Label 7291: @411058
     /*  411058 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(411135), // Rule ID 21563 //
     /*  411063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  411074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  411077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  411080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411095 */     // MIs[0] Operand 4
     /*  411095 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411113 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  411113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411133 */     GIR_RootConstrainSelectedInstOperands,
     /*  411134 */     // GIR_Coverage, 21563,
     /*  411134 */     GIR_EraseRootFromParent_Done,
     /*  411135 */   // Label 7292: @411135
     /*  411135 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(411212), // Rule ID 21566 //
     /*  411140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  411143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  411151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  411154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  411157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411172 */     // MIs[0] Operand 4
     /*  411172 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411190 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411210 */     GIR_RootConstrainSelectedInstOperands,
     /*  411211 */     // GIR_Coverage, 21566,
     /*  411211 */     GIR_EraseRootFromParent_Done,
     /*  411212 */   // Label 7293: @411212
     /*  411212 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(411289), // Rule ID 21567 //
     /*  411217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  411228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  411231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  411234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411249 */     // MIs[0] Operand 4
     /*  411249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411267 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  411267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411287 */     GIR_RootConstrainSelectedInstOperands,
     /*  411288 */     // GIR_Coverage, 21567,
     /*  411288 */     GIR_EraseRootFromParent_Done,
     /*  411289 */   // Label 7294: @411289
     /*  411289 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(411366), // Rule ID 21570 //
     /*  411294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  411297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  411305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  411308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  411311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411326 */     // MIs[0] Operand 4
     /*  411326 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411344 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  411347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411364 */     GIR_RootConstrainSelectedInstOperands,
     /*  411365 */     // GIR_Coverage, 21570,
     /*  411365 */     GIR_EraseRootFromParent_Done,
     /*  411366 */   // Label 7295: @411366
     /*  411366 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(411443), // Rule ID 21571 //
     /*  411371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  411382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  411385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  411388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411403 */     // MIs[0] Operand 4
     /*  411403 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411421 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  411421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  411424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411441 */     GIR_RootConstrainSelectedInstOperands,
     /*  411442 */     // GIR_Coverage, 21571,
     /*  411442 */     GIR_EraseRootFromParent_Done,
     /*  411443 */   // Label 7296: @411443
     /*  411443 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(411520), // Rule ID 21574 //
     /*  411448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  411451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  411459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  411462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  411465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411480 */     // MIs[0] Operand 4
     /*  411480 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411498 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411518 */     GIR_RootConstrainSelectedInstOperands,
     /*  411519 */     // GIR_Coverage, 21574,
     /*  411519 */     GIR_EraseRootFromParent_Done,
     /*  411520 */   // Label 7297: @411520
     /*  411520 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(411597), // Rule ID 21575 //
     /*  411525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  411536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  411539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  411542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411557 */     // MIs[0] Operand 4
     /*  411557 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411575 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  411575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411595 */     GIR_RootConstrainSelectedInstOperands,
     /*  411596 */     // GIR_Coverage, 21575,
     /*  411596 */     GIR_EraseRootFromParent_Done,
     /*  411597 */   // Label 7298: @411597
     /*  411597 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(411674), // Rule ID 21578 //
     /*  411602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  411613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  411616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411634 */     // MIs[0] Operand 4
     /*  411634 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411652 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  411655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411672 */     GIR_RootConstrainSelectedInstOperands,
     /*  411673 */     // GIR_Coverage, 21578,
     /*  411673 */     GIR_EraseRootFromParent_Done,
     /*  411674 */   // Label 7299: @411674
     /*  411674 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(411751), // Rule ID 21579 //
     /*  411679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  411690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  411693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411711 */     // MIs[0] Operand 4
     /*  411711 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411729 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  411732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411749 */     GIR_RootConstrainSelectedInstOperands,
     /*  411750 */     // GIR_Coverage, 21579,
     /*  411750 */     GIR_EraseRootFromParent_Done,
     /*  411751 */   // Label 7300: @411751
     /*  411751 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(411828), // Rule ID 21582 //
     /*  411756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  411767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  411770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411788 */     // MIs[0] Operand 4
     /*  411788 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411806 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411826 */     GIR_RootConstrainSelectedInstOperands,
     /*  411827 */     // GIR_Coverage, 21582,
     /*  411827 */     GIR_EraseRootFromParent_Done,
     /*  411828 */   // Label 7301: @411828
     /*  411828 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(411905), // Rule ID 21583 //
     /*  411833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  411844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  411847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411865 */     // MIs[0] Operand 4
     /*  411865 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411883 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411903 */     GIR_RootConstrainSelectedInstOperands,
     /*  411904 */     // GIR_Coverage, 21583,
     /*  411904 */     GIR_EraseRootFromParent_Done,
     /*  411905 */   // Label 7302: @411905
     /*  411905 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(411982), // Rule ID 21586 //
     /*  411910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  411921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  411924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411942 */     // MIs[0] Operand 4
     /*  411942 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411980 */     GIR_RootConstrainSelectedInstOperands,
     /*  411981 */     // GIR_Coverage, 21586,
     /*  411981 */     GIR_EraseRootFromParent_Done,
     /*  411982 */   // Label 7303: @411982
     /*  411982 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(412059), // Rule ID 21587 //
     /*  411987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  411998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  412001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  412004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412019 */     // MIs[0] Operand 4
     /*  412019 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412037 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  412037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  412040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412057 */     GIR_RootConstrainSelectedInstOperands,
     /*  412058 */     // GIR_Coverage, 21587,
     /*  412058 */     GIR_EraseRootFromParent_Done,
     /*  412059 */   // Label 7304: @412059
     /*  412059 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(412136), // Rule ID 21590 //
     /*  412064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  412067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  412075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  412078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  412081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412096 */     // MIs[0] Operand 4
     /*  412096 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  412114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  412117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412134 */     GIR_RootConstrainSelectedInstOperands,
     /*  412135 */     // GIR_Coverage, 21590,
     /*  412135 */     GIR_EraseRootFromParent_Done,
     /*  412136 */   // Label 7305: @412136
     /*  412136 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(412213), // Rule ID 21591 //
     /*  412141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  412144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  412152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  412155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  412158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412173 */     // MIs[0] Operand 4
     /*  412173 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412191 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  412191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  412194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412211 */     GIR_RootConstrainSelectedInstOperands,
     /*  412212 */     // GIR_Coverage, 21591,
     /*  412212 */     GIR_EraseRootFromParent_Done,
     /*  412213 */   // Label 7306: @412213
     /*  412213 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(412290), // Rule ID 21594 //
     /*  412218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  412221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  412229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  412232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  412235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412250 */     // MIs[0] Operand 4
     /*  412250 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412268 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  412268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  412271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412288 */     GIR_RootConstrainSelectedInstOperands,
     /*  412289 */     // GIR_Coverage, 21594,
     /*  412289 */     GIR_EraseRootFromParent_Done,
     /*  412290 */   // Label 7307: @412290
     /*  412290 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(412367), // Rule ID 21595 //
     /*  412295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  412298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  412306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  412309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  412312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412327 */     // MIs[0] Operand 4
     /*  412327 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412345 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  412345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  412348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412365 */     GIR_RootConstrainSelectedInstOperands,
     /*  412366 */     // GIR_Coverage, 21595,
     /*  412366 */     GIR_EraseRootFromParent_Done,
     /*  412367 */   // Label 7308: @412367
     /*  412367 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(412444), // Rule ID 21598 //
     /*  412372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  412383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  412386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  412389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412404 */     // MIs[0] Operand 4
     /*  412404 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412422 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  412425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412442 */     GIR_RootConstrainSelectedInstOperands,
     /*  412443 */     // GIR_Coverage, 21598,
     /*  412443 */     GIR_EraseRootFromParent_Done,
     /*  412444 */   // Label 7309: @412444
     /*  412444 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(412521), // Rule ID 21599 //
     /*  412449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  412460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  412463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  412466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412481 */     // MIs[0] Operand 4
     /*  412481 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412499 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  412502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412519 */     GIR_RootConstrainSelectedInstOperands,
     /*  412520 */     // GIR_Coverage, 21599,
     /*  412520 */     GIR_EraseRootFromParent_Done,
     /*  412521 */   // Label 7310: @412521
     /*  412521 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(412598), // Rule ID 21602 //
     /*  412526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  412537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  412540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  412543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412558 */     // MIs[0] Operand 4
     /*  412558 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  412579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412596 */     GIR_RootConstrainSelectedInstOperands,
     /*  412597 */     // GIR_Coverage, 21602,
     /*  412597 */     GIR_EraseRootFromParent_Done,
     /*  412598 */   // Label 7311: @412598
     /*  412598 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(412675), // Rule ID 21603 //
     /*  412603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  412614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  412617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  412620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412635 */     // MIs[0] Operand 4
     /*  412635 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412653 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  412656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412673 */     GIR_RootConstrainSelectedInstOperands,
     /*  412674 */     // GIR_Coverage, 21603,
     /*  412674 */     GIR_EraseRootFromParent_Done,
     /*  412675 */   // Label 7312: @412675
     /*  412675 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(412752), // Rule ID 21606 //
     /*  412680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  412691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  412694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  412697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412712 */     // MIs[0] Operand 4
     /*  412712 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  412733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412750 */     GIR_RootConstrainSelectedInstOperands,
     /*  412751 */     // GIR_Coverage, 21606,
     /*  412751 */     GIR_EraseRootFromParent_Done,
     /*  412752 */   // Label 7313: @412752
     /*  412752 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(412829), // Rule ID 21607 //
     /*  412757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  412768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  412771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  412774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412789 */     // MIs[0] Operand 4
     /*  412789 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412807 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  412810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412827 */     GIR_RootConstrainSelectedInstOperands,
     /*  412828 */     // GIR_Coverage, 21607,
     /*  412828 */     GIR_EraseRootFromParent_Done,
     /*  412829 */   // Label 7314: @412829
     /*  412829 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(412906), // Rule ID 21610 //
     /*  412834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  412845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  412848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  412851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412866 */     // MIs[0] Operand 4
     /*  412866 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  412887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412904 */     GIR_RootConstrainSelectedInstOperands,
     /*  412905 */     // GIR_Coverage, 21610,
     /*  412905 */     GIR_EraseRootFromParent_Done,
     /*  412906 */   // Label 7315: @412906
     /*  412906 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(412983), // Rule ID 21611 //
     /*  412911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  412922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  412925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  412928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412943 */     // MIs[0] Operand 4
     /*  412943 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412961 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  412964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412981 */     GIR_RootConstrainSelectedInstOperands,
     /*  412982 */     // GIR_Coverage, 21611,
     /*  412982 */     GIR_EraseRootFromParent_Done,
     /*  412983 */   // Label 7316: @412983
     /*  412983 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(413056), // Rule ID 62839 //
     /*  412988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  413002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413012 */     // MIs[0] op1
     /*  413012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413035 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF8),
     /*  413038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413040 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413042 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413044 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413054 */     GIR_RootConstrainSelectedInstOperands,
     /*  413055 */     // GIR_Coverage, 62839,
     /*  413055 */     GIR_EraseRootFromParent_Done,
     /*  413056 */   // Label 7317: @413056
     /*  413056 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(413129), // Rule ID 62840 //
     /*  413061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  413072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  413075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413085 */     // MIs[0] op1
     /*  413085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413108 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF8),
     /*  413111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413113 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413115 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413117 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413127 */     GIR_RootConstrainSelectedInstOperands,
     /*  413128 */     // GIR_Coverage, 62840,
     /*  413128 */     GIR_EraseRootFromParent_Done,
     /*  413129 */   // Label 7318: @413129
     /*  413129 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(413202), // Rule ID 62863 //
     /*  413134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  413145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  413148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  413151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413158 */     // MIs[0] op1
     /*  413158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413181 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF8),
     /*  413184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413186 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413188 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413190 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413200 */     GIR_RootConstrainSelectedInstOperands,
     /*  413201 */     // GIR_Coverage, 62863,
     /*  413201 */     GIR_EraseRootFromParent_Done,
     /*  413202 */   // Label 7319: @413202
     /*  413202 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(413275), // Rule ID 62864 //
     /*  413207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  413218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  413221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  413224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413231 */     // MIs[0] op1
     /*  413231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413234 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413254 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF8),
     /*  413257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413259 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413261 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413263 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413273 */     GIR_RootConstrainSelectedInstOperands,
     /*  413274 */     // GIR_Coverage, 62864,
     /*  413274 */     GIR_EraseRootFromParent_Done,
     /*  413275 */   // Label 7320: @413275
     /*  413275 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(413348), // Rule ID 62889 //
     /*  413280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  413291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  413294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413304 */     // MIs[0] op1
     /*  413304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413307 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413327 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF4),
     /*  413330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413332 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413334 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413336 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413346 */     GIR_RootConstrainSelectedInstOperands,
     /*  413347 */     // GIR_Coverage, 62889,
     /*  413347 */     GIR_EraseRootFromParent_Done,
     /*  413348 */   // Label 7321: @413348
     /*  413348 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(413421), // Rule ID 62890 //
     /*  413353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  413364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  413367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413377 */     // MIs[0] op1
     /*  413377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413400 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF4),
     /*  413403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413405 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413407 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413409 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413419 */     GIR_RootConstrainSelectedInstOperands,
     /*  413420 */     // GIR_Coverage, 62890,
     /*  413420 */     GIR_EraseRootFromParent_Done,
     /*  413421 */   // Label 7322: @413421
     /*  413421 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(413494), // Rule ID 62901 //
     /*  413426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  413437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  413440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  413443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413450 */     // MIs[0] op1
     /*  413450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413473 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF4),
     /*  413476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413478 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413480 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413482 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413492 */     GIR_RootConstrainSelectedInstOperands,
     /*  413493 */     // GIR_Coverage, 62901,
     /*  413493 */     GIR_EraseRootFromParent_Done,
     /*  413494 */   // Label 7323: @413494
     /*  413494 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(413567), // Rule ID 62902 //
     /*  413499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  413510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  413513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  413516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413523 */     // MIs[0] op1
     /*  413523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413546 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF4),
     /*  413549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413551 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413553 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413555 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413565 */     GIR_RootConstrainSelectedInstOperands,
     /*  413566 */     // GIR_Coverage, 62902,
     /*  413566 */     GIR_EraseRootFromParent_Done,
     /*  413567 */   // Label 7324: @413567
     /*  413567 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(413640), // Rule ID 62933 //
     /*  413572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413596 */     // MIs[0] op1
     /*  413596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413619 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  413622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413624 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413626 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413628 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413638 */     GIR_RootConstrainSelectedInstOperands,
     /*  413639 */     // GIR_Coverage, 62933,
     /*  413639 */     GIR_EraseRootFromParent_Done,
     /*  413640 */   // Label 7325: @413640
     /*  413640 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(413713), // Rule ID 62934 //
     /*  413645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413669 */     // MIs[0] op1
     /*  413669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413692 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  413695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413697 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413699 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413701 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413711 */     GIR_RootConstrainSelectedInstOperands,
     /*  413712 */     // GIR_Coverage, 62934,
     /*  413712 */     GIR_EraseRootFromParent_Done,
     /*  413713 */   // Label 7326: @413713
     /*  413713 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(413786), // Rule ID 62945 //
     /*  413718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  413735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413742 */     // MIs[0] op1
     /*  413742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413765 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  413768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413770 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413772 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413774 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413784 */     GIR_RootConstrainSelectedInstOperands,
     /*  413785 */     // GIR_Coverage, 62945,
     /*  413785 */     GIR_EraseRootFromParent_Done,
     /*  413786 */   // Label 7327: @413786
     /*  413786 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(413859), // Rule ID 62946 //
     /*  413791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  413808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413815 */     // MIs[0] op1
     /*  413815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413838 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  413841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413843 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413845 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413847 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413857 */     GIR_RootConstrainSelectedInstOperands,
     /*  413858 */     // GIR_Coverage, 62946,
     /*  413858 */     GIR_EraseRootFromParent_Done,
     /*  413859 */   // Label 7328: @413859
     /*  413859 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(413932), // Rule ID 62977 //
     /*  413864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413888 */     // MIs[0] op1
     /*  413888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413911 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF4),
     /*  413914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413916 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413918 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413920 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413930 */     GIR_RootConstrainSelectedInstOperands,
     /*  413931 */     // GIR_Coverage, 62977,
     /*  413931 */     GIR_EraseRootFromParent_Done,
     /*  413932 */   // Label 7329: @413932
     /*  413932 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(414005), // Rule ID 62978 //
     /*  413937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413961 */     // MIs[0] op1
     /*  413961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413984 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF4),
     /*  413987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413989 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413991 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413993 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414003 */     GIR_RootConstrainSelectedInstOperands,
     /*  414004 */     // GIR_Coverage, 62978,
     /*  414004 */     GIR_EraseRootFromParent_Done,
     /*  414005 */   // Label 7330: @414005
     /*  414005 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(414078), // Rule ID 62989 //
     /*  414010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  414021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  414024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  414027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414034 */     // MIs[0] op1
     /*  414034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414037 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414057 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF4),
     /*  414060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414062 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414064 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414066 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414076 */     GIR_RootConstrainSelectedInstOperands,
     /*  414077 */     // GIR_Coverage, 62989,
     /*  414077 */     GIR_EraseRootFromParent_Done,
     /*  414078 */   // Label 7331: @414078
     /*  414078 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(414151), // Rule ID 62990 //
     /*  414083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  414094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  414097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  414100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414107 */     // MIs[0] op1
     /*  414107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414130 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF4),
     /*  414133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414135 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414137 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414139 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414149 */     GIR_RootConstrainSelectedInstOperands,
     /*  414150 */     // GIR_Coverage, 62990,
     /*  414150 */     GIR_EraseRootFromParent_Done,
     /*  414151 */   // Label 7332: @414151
     /*  414151 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(414224), // Rule ID 63013 //
     /*  414156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  414167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  414170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414180 */     // MIs[0] op1
     /*  414180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414203 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_MF4),
     /*  414206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414208 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414210 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414212 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414222 */     GIR_RootConstrainSelectedInstOperands,
     /*  414223 */     // GIR_Coverage, 63013,
     /*  414223 */     GIR_EraseRootFromParent_Done,
     /*  414224 */   // Label 7333: @414224
     /*  414224 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(414297), // Rule ID 63014 //
     /*  414229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  414240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  414243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414253 */     // MIs[0] op1
     /*  414253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_MF4),
     /*  414279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414281 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414283 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414285 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414295 */     GIR_RootConstrainSelectedInstOperands,
     /*  414296 */     // GIR_Coverage, 63014,
     /*  414296 */     GIR_EraseRootFromParent_Done,
     /*  414297 */   // Label 7334: @414297
     /*  414297 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(414370), // Rule ID 63033 //
     /*  414302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414326 */     // MIs[0] op1
     /*  414326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414349 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  414352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414354 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414356 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414358 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414368 */     GIR_RootConstrainSelectedInstOperands,
     /*  414369 */     // GIR_Coverage, 63033,
     /*  414369 */     GIR_EraseRootFromParent_Done,
     /*  414370 */   // Label 7335: @414370
     /*  414370 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(414443), // Rule ID 63034 //
     /*  414375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414399 */     // MIs[0] op1
     /*  414399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414422 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  414425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414427 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414429 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414431 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414441 */     GIR_RootConstrainSelectedInstOperands,
     /*  414442 */     // GIR_Coverage, 63034,
     /*  414442 */     GIR_EraseRootFromParent_Done,
     /*  414443 */   // Label 7336: @414443
     /*  414443 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(414516), // Rule ID 63045 //
     /*  414448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  414465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414472 */     // MIs[0] op1
     /*  414472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414495 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  414498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414500 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414502 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414504 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414514 */     GIR_RootConstrainSelectedInstOperands,
     /*  414515 */     // GIR_Coverage, 63045,
     /*  414515 */     GIR_EraseRootFromParent_Done,
     /*  414516 */   // Label 7337: @414516
     /*  414516 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(414589), // Rule ID 63046 //
     /*  414521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  414538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414545 */     // MIs[0] op1
     /*  414545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414568 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  414571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414573 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414575 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414577 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414587 */     GIR_RootConstrainSelectedInstOperands,
     /*  414588 */     // GIR_Coverage, 63046,
     /*  414588 */     GIR_EraseRootFromParent_Done,
     /*  414589 */   // Label 7338: @414589
     /*  414589 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(414662), // Rule ID 63069 //
     /*  414594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414618 */     // MIs[0] op1
     /*  414618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414641 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_MF2),
     /*  414644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414646 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414648 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414650 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414660 */     GIR_RootConstrainSelectedInstOperands,
     /*  414661 */     // GIR_Coverage, 63069,
     /*  414661 */     GIR_EraseRootFromParent_Done,
     /*  414662 */   // Label 7339: @414662
     /*  414662 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(414735), // Rule ID 63070 //
     /*  414667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414691 */     // MIs[0] op1
     /*  414691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414714 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_MF2),
     /*  414717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414719 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414721 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414723 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414733 */     GIR_RootConstrainSelectedInstOperands,
     /*  414734 */     // GIR_Coverage, 63070,
     /*  414734 */     GIR_EraseRootFromParent_Done,
     /*  414735 */   // Label 7340: @414735
     /*  414735 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(414808), // Rule ID 63089 //
     /*  414740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414764 */     // MIs[0] op1
     /*  414764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414767 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414787 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  414787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  414790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414792 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414794 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414796 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414806 */     GIR_RootConstrainSelectedInstOperands,
     /*  414807 */     // GIR_Coverage, 63089,
     /*  414807 */     GIR_EraseRootFromParent_Done,
     /*  414808 */   // Label 7341: @414808
     /*  414808 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(414881), // Rule ID 63090 //
     /*  414813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414837 */     // MIs[0] op1
     /*  414837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414840 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  414860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  414863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414865 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414867 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414869 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414879 */     GIR_RootConstrainSelectedInstOperands,
     /*  414880 */     // GIR_Coverage, 63090,
     /*  414880 */     GIR_EraseRootFromParent_Done,
     /*  414881 */   // Label 7342: @414881
     /*  414881 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(414954), // Rule ID 63101 //
     /*  414886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  414903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414910 */     // MIs[0] op1
     /*  414910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414913 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414933 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  414933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  414936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414938 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414940 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414942 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414952 */     GIR_RootConstrainSelectedInstOperands,
     /*  414953 */     // GIR_Coverage, 63101,
     /*  414953 */     GIR_EraseRootFromParent_Done,
     /*  414954 */   // Label 7343: @414954
     /*  414954 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(415027), // Rule ID 63102 //
     /*  414959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  414976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414983 */     // MIs[0] op1
     /*  414983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415006 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  415006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  415009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415011 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415013 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415015 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415025 */     GIR_RootConstrainSelectedInstOperands,
     /*  415026 */     // GIR_Coverage, 63102,
     /*  415026 */     GIR_EraseRootFromParent_Done,
     /*  415027 */   // Label 7344: @415027
     /*  415027 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(415100), // Rule ID 63125 //
     /*  415032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  415043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  415046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415056 */     // MIs[0] op1
     /*  415056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415059 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  415072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415079 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  415079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_MF2),
     /*  415082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415084 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415086 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415088 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415098 */     GIR_RootConstrainSelectedInstOperands,
     /*  415099 */     // GIR_Coverage, 63125,
     /*  415099 */     GIR_EraseRootFromParent_Done,
     /*  415100 */   // Label 7345: @415100
     /*  415100 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(415173), // Rule ID 63126 //
     /*  415105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  415116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  415119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415129 */     // MIs[0] op1
     /*  415129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  415145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415152 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  415152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_MF2),
     /*  415155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415157 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415159 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415161 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415171 */     GIR_RootConstrainSelectedInstOperands,
     /*  415172 */     // GIR_Coverage, 63126,
     /*  415172 */     GIR_EraseRootFromParent_Done,
     /*  415173 */   // Label 7346: @415173
     /*  415173 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(415246), // Rule ID 63145 //
     /*  415178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  415189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  415192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415202 */     // MIs[0] op1
     /*  415202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415205 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415225 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  415225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415230 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415232 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415234 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  415244 */     GIR_RootConstrainSelectedInstOperands,
     /*  415245 */     // GIR_Coverage, 63145,
     /*  415245 */     GIR_EraseRootFromParent_Done,
     /*  415246 */   // Label 7347: @415246
     /*  415246 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(415319), // Rule ID 63146 //
     /*  415251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  415262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  415265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415275 */     // MIs[0] op1
     /*  415275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415278 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415298 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  415298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415303 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415305 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415307 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  415317 */     GIR_RootConstrainSelectedInstOperands,
     /*  415318 */     // GIR_Coverage, 63146,
     /*  415318 */     GIR_EraseRootFromParent_Done,
     /*  415319 */   // Label 7348: @415319
     /*  415319 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(415392), // Rule ID 63157 //
     /*  415324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  415335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  415338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  415341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415348 */     // MIs[0] op1
     /*  415348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415371 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  415371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  415374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415376 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415378 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415380 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  415390 */     GIR_RootConstrainSelectedInstOperands,
     /*  415391 */     // GIR_Coverage, 63157,
     /*  415391 */     GIR_EraseRootFromParent_Done,
     /*  415392 */   // Label 7349: @415392
     /*  415392 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(415465), // Rule ID 63158 //
     /*  415397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  415408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  415411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  415414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415421 */     // MIs[0] op1
     /*  415421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415444 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  415444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  415447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415449 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415451 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415453 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  415463 */     GIR_RootConstrainSelectedInstOperands,
     /*  415464 */     // GIR_Coverage, 63158,
     /*  415464 */     GIR_EraseRootFromParent_Done,
     /*  415465 */   // Label 7350: @415465
     /*  415465 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(415538), // Rule ID 63189 //
     /*  415470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415494 */     // MIs[0] op1
     /*  415494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415517 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  415517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415522 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415524 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415526 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415536 */     GIR_RootConstrainSelectedInstOperands,
     /*  415537 */     // GIR_Coverage, 63189,
     /*  415537 */     GIR_EraseRootFromParent_Done,
     /*  415538 */   // Label 7351: @415538
     /*  415538 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(415611), // Rule ID 63190 //
     /*  415543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415567 */     // MIs[0] op1
     /*  415567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415570 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  415590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415595 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415597 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415599 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415609 */     GIR_RootConstrainSelectedInstOperands,
     /*  415610 */     // GIR_Coverage, 63190,
     /*  415610 */     GIR_EraseRootFromParent_Done,
     /*  415611 */   // Label 7352: @415611
     /*  415611 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(415684), // Rule ID 63201 //
     /*  415616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  415633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415640 */     // MIs[0] op1
     /*  415640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415663 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  415663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  415666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415668 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415670 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415672 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415682 */     GIR_RootConstrainSelectedInstOperands,
     /*  415683 */     // GIR_Coverage, 63201,
     /*  415683 */     GIR_EraseRootFromParent_Done,
     /*  415684 */   // Label 7353: @415684
     /*  415684 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(415757), // Rule ID 63202 //
     /*  415689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  415706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415713 */     // MIs[0] op1
     /*  415713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415716 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415736 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  415736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  415739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415741 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415743 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415745 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415755 */     GIR_RootConstrainSelectedInstOperands,
     /*  415756 */     // GIR_Coverage, 63202,
     /*  415756 */     GIR_EraseRootFromParent_Done,
     /*  415757 */   // Label 7354: @415757
     /*  415757 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(415830), // Rule ID 63225 //
     /*  415762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  415779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415786 */     // MIs[0] op1
     /*  415786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  415802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415809 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  415809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M1),
     /*  415812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415814 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415816 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415818 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415828 */     GIR_RootConstrainSelectedInstOperands,
     /*  415829 */     // GIR_Coverage, 63225,
     /*  415829 */     GIR_EraseRootFromParent_Done,
     /*  415830 */   // Label 7355: @415830
     /*  415830 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(415903), // Rule ID 63226 //
     /*  415835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  415852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415859 */     // MIs[0] op1
     /*  415859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  415875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  415882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M1),
     /*  415885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415887 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415889 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415891 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415901 */     GIR_RootConstrainSelectedInstOperands,
     /*  415902 */     // GIR_Coverage, 63226,
     /*  415902 */     GIR_EraseRootFromParent_Done,
     /*  415903 */   // Label 7356: @415903
     /*  415903 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(415976), // Rule ID 63245 //
     /*  415908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415932 */     // MIs[0] op1
     /*  415932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415955 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  415955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415960 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415962 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415964 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415974 */     GIR_RootConstrainSelectedInstOperands,
     /*  415975 */     // GIR_Coverage, 63245,
     /*  415975 */     GIR_EraseRootFromParent_Done,
     /*  415976 */   // Label 7357: @415976
     /*  415976 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(416049), // Rule ID 63246 //
     /*  415981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416005 */     // MIs[0] op1
     /*  416005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416028 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  416028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  416031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416033 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416035 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416037 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416047 */     GIR_RootConstrainSelectedInstOperands,
     /*  416048 */     // GIR_Coverage, 63246,
     /*  416048 */     GIR_EraseRootFromParent_Done,
     /*  416049 */   // Label 7358: @416049
     /*  416049 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(416122), // Rule ID 63257 //
     /*  416054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  416065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  416068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  416071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416078 */     // MIs[0] op1
     /*  416078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416081 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416101 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  416101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  416104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416106 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416108 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416110 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416120 */     GIR_RootConstrainSelectedInstOperands,
     /*  416121 */     // GIR_Coverage, 63257,
     /*  416121 */     GIR_EraseRootFromParent_Done,
     /*  416122 */   // Label 7359: @416122
     /*  416122 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(416195), // Rule ID 63258 //
     /*  416127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  416138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  416141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  416144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416151 */     // MIs[0] op1
     /*  416151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416174 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  416174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  416177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416179 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416181 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416183 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416193 */     GIR_RootConstrainSelectedInstOperands,
     /*  416194 */     // GIR_Coverage, 63258,
     /*  416194 */     GIR_EraseRootFromParent_Done,
     /*  416195 */   // Label 7360: @416195
     /*  416195 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(416268), // Rule ID 63281 //
     /*  416200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  416211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  416214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416224 */     // MIs[0] op1
     /*  416224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  416232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  416240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416247 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  416247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M1),
     /*  416250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416252 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416254 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416256 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416266 */     GIR_RootConstrainSelectedInstOperands,
     /*  416267 */     // GIR_Coverage, 63281,
     /*  416267 */     GIR_EraseRootFromParent_Done,
     /*  416268 */   // Label 7361: @416268
     /*  416268 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(416341), // Rule ID 63282 //
     /*  416273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  416284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  416287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416297 */     // MIs[0] op1
     /*  416297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  416305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  416313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  416320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M1),
     /*  416323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416325 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416327 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416329 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416339 */     GIR_RootConstrainSelectedInstOperands,
     /*  416340 */     // GIR_Coverage, 63282,
     /*  416340 */     GIR_EraseRootFromParent_Done,
     /*  416341 */   // Label 7362: @416341
     /*  416341 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(416414), // Rule ID 63301 //
     /*  416346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416370 */     // MIs[0] op1
     /*  416370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416373 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416393 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  416393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  416396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416398 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416400 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416402 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416412 */     GIR_RootConstrainSelectedInstOperands,
     /*  416413 */     // GIR_Coverage, 63301,
     /*  416413 */     GIR_EraseRootFromParent_Done,
     /*  416414 */   // Label 7363: @416414
     /*  416414 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(416487), // Rule ID 63302 //
     /*  416419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416443 */     // MIs[0] op1
     /*  416443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416466 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  416466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  416469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416471 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416473 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416475 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416485 */     GIR_RootConstrainSelectedInstOperands,
     /*  416486 */     // GIR_Coverage, 63302,
     /*  416486 */     GIR_EraseRootFromParent_Done,
     /*  416487 */   // Label 7364: @416487
     /*  416487 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(416560), // Rule ID 63313 //
     /*  416492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  416509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416516 */     // MIs[0] op1
     /*  416516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416539 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  416539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  416542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416544 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416546 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416548 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416558 */     GIR_RootConstrainSelectedInstOperands,
     /*  416559 */     // GIR_Coverage, 63313,
     /*  416559 */     GIR_EraseRootFromParent_Done,
     /*  416560 */   // Label 7365: @416560
     /*  416560 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(416633), // Rule ID 63314 //
     /*  416565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  416582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416589 */     // MIs[0] op1
     /*  416589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416612 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  416612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  416615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416617 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416619 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416621 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416631 */     GIR_RootConstrainSelectedInstOperands,
     /*  416632 */     // GIR_Coverage, 63314,
     /*  416632 */     GIR_EraseRootFromParent_Done,
     /*  416633 */   // Label 7366: @416633
     /*  416633 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(416706), // Rule ID 63337 //
     /*  416638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416662 */     // MIs[0] op1
     /*  416662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416665 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  416670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  416678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416685 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  416685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M1),
     /*  416688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416690 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416692 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416694 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416704 */     GIR_RootConstrainSelectedInstOperands,
     /*  416705 */     // GIR_Coverage, 63337,
     /*  416705 */     GIR_EraseRootFromParent_Done,
     /*  416706 */   // Label 7367: @416706
     /*  416706 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(416779), // Rule ID 63338 //
     /*  416711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416735 */     // MIs[0] op1
     /*  416735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  416743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  416751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416758 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  416758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M1),
     /*  416761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416763 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416765 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416767 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416777 */     GIR_RootConstrainSelectedInstOperands,
     /*  416778 */     // GIR_Coverage, 63338,
     /*  416778 */     GIR_EraseRootFromParent_Done,
     /*  416779 */   // Label 7368: @416779
     /*  416779 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(416852), // Rule ID 63357 //
     /*  416784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416808 */     // MIs[0] op1
     /*  416808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416831 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  416834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416836 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416838 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416840 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416850 */     GIR_RootConstrainSelectedInstOperands,
     /*  416851 */     // GIR_Coverage, 63357,
     /*  416851 */     GIR_EraseRootFromParent_Done,
     /*  416852 */   // Label 7369: @416852
     /*  416852 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(416925), // Rule ID 63358 //
     /*  416857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416881 */     // MIs[0] op1
     /*  416881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416884 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416904 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  416907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416909 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416911 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416913 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416923 */     GIR_RootConstrainSelectedInstOperands,
     /*  416924 */     // GIR_Coverage, 63358,
     /*  416924 */     GIR_EraseRootFromParent_Done,
     /*  416925 */   // Label 7370: @416925
     /*  416925 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(416998), // Rule ID 63369 //
     /*  416930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  416947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416954 */     // MIs[0] op1
     /*  416954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416957 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416977 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  416980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416982 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416984 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416986 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416996 */     GIR_RootConstrainSelectedInstOperands,
     /*  416997 */     // GIR_Coverage, 63369,
     /*  416997 */     GIR_EraseRootFromParent_Done,
     /*  416998 */   // Label 7371: @416998
     /*  416998 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(417071), // Rule ID 63370 //
     /*  417003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  417014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  417017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  417020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417027 */     // MIs[0] op1
     /*  417027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417050 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  417053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417055 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417057 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417059 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417069 */     GIR_RootConstrainSelectedInstOperands,
     /*  417070 */     // GIR_Coverage, 63370,
     /*  417070 */     GIR_EraseRootFromParent_Done,
     /*  417071 */   // Label 7372: @417071
     /*  417071 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(417144), // Rule ID 63401 //
     /*  417076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  417087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  417090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417100 */     // MIs[0] op1
     /*  417100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417123 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  417123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  417126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417128 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417130 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417132 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417142 */     GIR_RootConstrainSelectedInstOperands,
     /*  417143 */     // GIR_Coverage, 63401,
     /*  417143 */     GIR_EraseRootFromParent_Done,
     /*  417144 */   // Label 7373: @417144
     /*  417144 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(417217), // Rule ID 63402 //
     /*  417149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  417160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  417163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417173 */     // MIs[0] op1
     /*  417173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417196 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  417199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417201 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417203 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417205 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417215 */     GIR_RootConstrainSelectedInstOperands,
     /*  417216 */     // GIR_Coverage, 63402,
     /*  417216 */     GIR_EraseRootFromParent_Done,
     /*  417217 */   // Label 7374: @417217
     /*  417217 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(417290), // Rule ID 63413 //
     /*  417222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  417233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  417236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  417239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417246 */     // MIs[0] op1
     /*  417246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417249 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417269 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  417269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  417272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417274 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417276 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417278 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417288 */     GIR_RootConstrainSelectedInstOperands,
     /*  417289 */     // GIR_Coverage, 63413,
     /*  417289 */     GIR_EraseRootFromParent_Done,
     /*  417290 */   // Label 7375: @417290
     /*  417290 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(417363), // Rule ID 63414 //
     /*  417295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  417306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  417309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  417312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417319 */     // MIs[0] op1
     /*  417319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417342 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  417345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417347 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417349 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417351 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417361 */     GIR_RootConstrainSelectedInstOperands,
     /*  417362 */     // GIR_Coverage, 63414,
     /*  417362 */     GIR_EraseRootFromParent_Done,
     /*  417363 */   // Label 7376: @417363
     /*  417363 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(417436), // Rule ID 63445 //
     /*  417368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  417379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  417382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417392 */     // MIs[0] op1
     /*  417392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417415 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  417415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  417418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417420 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417422 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417424 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417434 */     GIR_RootConstrainSelectedInstOperands,
     /*  417435 */     // GIR_Coverage, 63445,
     /*  417435 */     GIR_EraseRootFromParent_Done,
     /*  417436 */   // Label 7377: @417436
     /*  417436 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(417509), // Rule ID 63446 //
     /*  417441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  417452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  417455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417465 */     // MIs[0] op1
     /*  417465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417468 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417488 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  417491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417493 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417495 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417497 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417507 */     GIR_RootConstrainSelectedInstOperands,
     /*  417508 */     // GIR_Coverage, 63446,
     /*  417508 */     GIR_EraseRootFromParent_Done,
     /*  417509 */   // Label 7378: @417509
     /*  417509 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(417582), // Rule ID 63457 //
     /*  417514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  417525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  417528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  417531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417538 */     // MIs[0] op1
     /*  417538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417541 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417561 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  417561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  417564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417566 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417568 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417570 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417580 */     GIR_RootConstrainSelectedInstOperands,
     /*  417581 */     // GIR_Coverage, 63457,
     /*  417581 */     GIR_EraseRootFromParent_Done,
     /*  417582 */   // Label 7379: @417582
     /*  417582 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(417655), // Rule ID 63458 //
     /*  417587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  417598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  417601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  417604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417611 */     // MIs[0] op1
     /*  417611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417614 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417634 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  417637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417639 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417641 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417643 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417653 */     GIR_RootConstrainSelectedInstOperands,
     /*  417654 */     // GIR_Coverage, 63458,
     /*  417654 */     GIR_EraseRootFromParent_Done,
     /*  417655 */   // Label 7380: @417655
     /*  417655 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(417728), // Rule ID 63489 //
     /*  417660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417684 */     // MIs[0] op1
     /*  417684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  417710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417712 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417714 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417716 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417726 */     GIR_RootConstrainSelectedInstOperands,
     /*  417727 */     // GIR_Coverage, 63489,
     /*  417727 */     GIR_EraseRootFromParent_Done,
     /*  417728 */   // Label 7381: @417728
     /*  417728 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(417801), // Rule ID 63490 //
     /*  417733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417757 */     // MIs[0] op1
     /*  417757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417780 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  417783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417785 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417787 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417789 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417799 */     GIR_RootConstrainSelectedInstOperands,
     /*  417800 */     // GIR_Coverage, 63490,
     /*  417800 */     GIR_EraseRootFromParent_Done,
     /*  417801 */   // Label 7382: @417801
     /*  417801 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(417874), // Rule ID 63501 //
     /*  417806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  417823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417830 */     // MIs[0] op1
     /*  417830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417833 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417853 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  417856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417858 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417860 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417862 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417872 */     GIR_RootConstrainSelectedInstOperands,
     /*  417873 */     // GIR_Coverage, 63501,
     /*  417873 */     GIR_EraseRootFromParent_Done,
     /*  417874 */   // Label 7383: @417874
     /*  417874 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(417947), // Rule ID 63502 //
     /*  417879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  417896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417903 */     // MIs[0] op1
     /*  417903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417926 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  417929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417931 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417933 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417935 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417945 */     GIR_RootConstrainSelectedInstOperands,
     /*  417946 */     // GIR_Coverage, 63502,
     /*  417946 */     GIR_EraseRootFromParent_Done,
     /*  417947 */   // Label 7384: @417947
     /*  417947 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(418020), // Rule ID 63525 //
     /*  417952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417976 */     // MIs[0] op1
     /*  417976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417999 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M2),
     /*  418002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418004 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418006 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418008 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418018 */     GIR_RootConstrainSelectedInstOperands,
     /*  418019 */     // GIR_Coverage, 63525,
     /*  418019 */     GIR_EraseRootFromParent_Done,
     /*  418020 */   // Label 7385: @418020
     /*  418020 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(418093), // Rule ID 63526 //
     /*  418025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  418036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  418039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418049 */     // MIs[0] op1
     /*  418049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418072 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M2),
     /*  418075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418077 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418079 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418081 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418091 */     GIR_RootConstrainSelectedInstOperands,
     /*  418092 */     // GIR_Coverage, 63526,
     /*  418092 */     GIR_EraseRootFromParent_Done,
     /*  418093 */   // Label 7386: @418093
     /*  418093 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(418166), // Rule ID 63545 //
     /*  418098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418122 */     // MIs[0] op1
     /*  418122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418145 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  418148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418150 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418152 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418154 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418164 */     GIR_RootConstrainSelectedInstOperands,
     /*  418165 */     // GIR_Coverage, 63545,
     /*  418165 */     GIR_EraseRootFromParent_Done,
     /*  418166 */   // Label 7387: @418166
     /*  418166 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(418239), // Rule ID 63546 //
     /*  418171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418195 */     // MIs[0] op1
     /*  418195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  418221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418223 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418225 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418227 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418237 */     GIR_RootConstrainSelectedInstOperands,
     /*  418238 */     // GIR_Coverage, 63546,
     /*  418238 */     GIR_EraseRootFromParent_Done,
     /*  418239 */   // Label 7388: @418239
     /*  418239 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(418312), // Rule ID 63557 //
     /*  418244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  418261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418268 */     // MIs[0] op1
     /*  418268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418291 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  418294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418296 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418298 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418300 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418310 */     GIR_RootConstrainSelectedInstOperands,
     /*  418311 */     // GIR_Coverage, 63557,
     /*  418311 */     GIR_EraseRootFromParent_Done,
     /*  418312 */   // Label 7389: @418312
     /*  418312 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(418385), // Rule ID 63558 //
     /*  418317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  418334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418341 */     // MIs[0] op1
     /*  418341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418364 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  418367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418369 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418371 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418373 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418383 */     GIR_RootConstrainSelectedInstOperands,
     /*  418384 */     // GIR_Coverage, 63558,
     /*  418384 */     GIR_EraseRootFromParent_Done,
     /*  418385 */   // Label 7390: @418385
     /*  418385 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(418458), // Rule ID 63581 //
     /*  418390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418414 */     // MIs[0] op1
     /*  418414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418417 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418437 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M4),
     /*  418440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418442 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418444 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418446 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418456 */     GIR_RootConstrainSelectedInstOperands,
     /*  418457 */     // GIR_Coverage, 63581,
     /*  418457 */     GIR_EraseRootFromParent_Done,
     /*  418458 */   // Label 7391: @418458
     /*  418458 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(418531), // Rule ID 63582 //
     /*  418463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418487 */     // MIs[0] op1
     /*  418487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418510 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M4),
     /*  418513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418515 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418517 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418519 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418529 */     GIR_RootConstrainSelectedInstOperands,
     /*  418530 */     // GIR_Coverage, 63582,
     /*  418530 */     GIR_EraseRootFromParent_Done,
     /*  418531 */   // Label 7392: @418531
     /*  418531 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(418604), // Rule ID 63601 //
     /*  418536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418560 */     // MIs[0] op1
     /*  418560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418583 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  418586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418588 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418590 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418592 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418602 */     GIR_RootConstrainSelectedInstOperands,
     /*  418603 */     // GIR_Coverage, 63601,
     /*  418603 */     GIR_EraseRootFromParent_Done,
     /*  418604 */   // Label 7393: @418604
     /*  418604 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(418677), // Rule ID 63602 //
     /*  418609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418633 */     // MIs[0] op1
     /*  418633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418656 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  418659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418661 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418663 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418665 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418675 */     GIR_RootConstrainSelectedInstOperands,
     /*  418676 */     // GIR_Coverage, 63602,
     /*  418676 */     GIR_EraseRootFromParent_Done,
     /*  418677 */   // Label 7394: @418677
     /*  418677 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(418750), // Rule ID 63613 //
     /*  418682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  418699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418706 */     // MIs[0] op1
     /*  418706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418709 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418729 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  418732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418734 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418736 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418738 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418748 */     GIR_RootConstrainSelectedInstOperands,
     /*  418749 */     // GIR_Coverage, 63613,
     /*  418749 */     GIR_EraseRootFromParent_Done,
     /*  418750 */   // Label 7395: @418750
     /*  418750 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(418823), // Rule ID 63614 //
     /*  418755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  418772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418779 */     // MIs[0] op1
     /*  418779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418782 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418802 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  418805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418807 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418809 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418811 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418821 */     GIR_RootConstrainSelectedInstOperands,
     /*  418822 */     // GIR_Coverage, 63614,
     /*  418822 */     GIR_EraseRootFromParent_Done,
     /*  418823 */   // Label 7396: @418823
     /*  418823 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(418896), // Rule ID 63637 //
     /*  418828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418852 */     // MIs[0] op1
     /*  418852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418875 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M8),
     /*  418878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418880 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418882 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418884 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418894 */     GIR_RootConstrainSelectedInstOperands,
     /*  418895 */     // GIR_Coverage, 63637,
     /*  418895 */     GIR_EraseRootFromParent_Done,
     /*  418896 */   // Label 7397: @418896
     /*  418896 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(418969), // Rule ID 63638 //
     /*  418901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418925 */     // MIs[0] op1
     /*  418925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418948 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M8),
     /*  418951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418953 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418955 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418957 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418967 */     GIR_RootConstrainSelectedInstOperands,
     /*  418968 */     // GIR_Coverage, 63638,
     /*  418968 */     GIR_EraseRootFromParent_Done,
     /*  418969 */   // Label 7398: @418969
     /*  418969 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(419042), // Rule ID 63657 //
     /*  418974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418998 */     // MIs[0] op1
     /*  418998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419021 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  419024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419026 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419028 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419030 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419040 */     GIR_RootConstrainSelectedInstOperands,
     /*  419041 */     // GIR_Coverage, 63657,
     /*  419041 */     GIR_EraseRootFromParent_Done,
     /*  419042 */   // Label 7399: @419042
     /*  419042 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(419115), // Rule ID 63658 //
     /*  419047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  419058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419071 */     // MIs[0] op1
     /*  419071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419074 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  419097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419099 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419101 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419103 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419113 */     GIR_RootConstrainSelectedInstOperands,
     /*  419114 */     // GIR_Coverage, 63658,
     /*  419114 */     GIR_EraseRootFromParent_Done,
     /*  419115 */   // Label 7400: @419115
     /*  419115 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(419188), // Rule ID 63669 //
     /*  419120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  419131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  419137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419144 */     // MIs[0] op1
     /*  419144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419167 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  419170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419172 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419174 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419176 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419186 */     GIR_RootConstrainSelectedInstOperands,
     /*  419187 */     // GIR_Coverage, 63669,
     /*  419187 */     GIR_EraseRootFromParent_Done,
     /*  419188 */   // Label 7401: @419188
     /*  419188 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(419261), // Rule ID 63670 //
     /*  419193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  419204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  419210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419217 */     // MIs[0] op1
     /*  419217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419240 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  419243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419245 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419247 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419249 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419259 */     GIR_RootConstrainSelectedInstOperands,
     /*  419260 */     // GIR_Coverage, 63670,
     /*  419260 */     GIR_EraseRootFromParent_Done,
     /*  419261 */   // Label 7402: @419261
     /*  419261 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(419334), // Rule ID 63693 //
     /*  419266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  419277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419290 */     // MIs[0] op1
     /*  419290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419313 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M2),
     /*  419316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419318 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419320 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419322 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419332 */     GIR_RootConstrainSelectedInstOperands,
     /*  419333 */     // GIR_Coverage, 63693,
     /*  419333 */     GIR_EraseRootFromParent_Done,
     /*  419334 */   // Label 7403: @419334
     /*  419334 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(419407), // Rule ID 63694 //
     /*  419339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  419350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419363 */     // MIs[0] op1
     /*  419363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419386 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M2),
     /*  419389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419391 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419393 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419395 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419405 */     GIR_RootConstrainSelectedInstOperands,
     /*  419406 */     // GIR_Coverage, 63694,
     /*  419406 */     GIR_EraseRootFromParent_Done,
     /*  419407 */   // Label 7404: @419407
     /*  419407 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(419480), // Rule ID 63713 //
     /*  419412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419436 */     // MIs[0] op1
     /*  419436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419459 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  419462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419464 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419466 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419468 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419478 */     GIR_RootConstrainSelectedInstOperands,
     /*  419479 */     // GIR_Coverage, 63713,
     /*  419479 */     GIR_EraseRootFromParent_Done,
     /*  419480 */   // Label 7405: @419480
     /*  419480 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(419553), // Rule ID 63714 //
     /*  419485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419509 */     // MIs[0] op1
     /*  419509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419532 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  419535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419537 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419539 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419541 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419551 */     GIR_RootConstrainSelectedInstOperands,
     /*  419552 */     // GIR_Coverage, 63714,
     /*  419552 */     GIR_EraseRootFromParent_Done,
     /*  419553 */   // Label 7406: @419553
     /*  419553 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(419626), // Rule ID 63725 //
     /*  419558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  419575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419582 */     // MIs[0] op1
     /*  419582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419605 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  419608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419610 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419612 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419614 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419624 */     GIR_RootConstrainSelectedInstOperands,
     /*  419625 */     // GIR_Coverage, 63725,
     /*  419625 */     GIR_EraseRootFromParent_Done,
     /*  419626 */   // Label 7407: @419626
     /*  419626 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(419699), // Rule ID 63726 //
     /*  419631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  419648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419655 */     // MIs[0] op1
     /*  419655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419678 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  419681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419683 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419685 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419687 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419697 */     GIR_RootConstrainSelectedInstOperands,
     /*  419698 */     // GIR_Coverage, 63726,
     /*  419698 */     GIR_EraseRootFromParent_Done,
     /*  419699 */   // Label 7408: @419699
     /*  419699 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(419772), // Rule ID 63749 //
     /*  419704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419728 */     // MIs[0] op1
     /*  419728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419751 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M4),
     /*  419754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419756 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419758 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419760 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419770 */     GIR_RootConstrainSelectedInstOperands,
     /*  419771 */     // GIR_Coverage, 63749,
     /*  419771 */     GIR_EraseRootFromParent_Done,
     /*  419772 */   // Label 7409: @419772
     /*  419772 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(419845), // Rule ID 63750 //
     /*  419777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419801 */     // MIs[0] op1
     /*  419801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419824 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M4),
     /*  419827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419829 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419831 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419833 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419843 */     GIR_RootConstrainSelectedInstOperands,
     /*  419844 */     // GIR_Coverage, 63750,
     /*  419844 */     GIR_EraseRootFromParent_Done,
     /*  419845 */   // Label 7410: @419845
     /*  419845 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(419918), // Rule ID 63769 //
     /*  419850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419874 */     // MIs[0] op1
     /*  419874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419897 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  419900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419902 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419904 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419906 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419916 */     GIR_RootConstrainSelectedInstOperands,
     /*  419917 */     // GIR_Coverage, 63769,
     /*  419917 */     GIR_EraseRootFromParent_Done,
     /*  419918 */   // Label 7411: @419918
     /*  419918 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(419991), // Rule ID 63770 //
     /*  419923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419947 */     // MIs[0] op1
     /*  419947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419970 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  419973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419975 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419977 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419979 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419989 */     GIR_RootConstrainSelectedInstOperands,
     /*  419990 */     // GIR_Coverage, 63770,
     /*  419990 */     GIR_EraseRootFromParent_Done,
     /*  419991 */   // Label 7412: @419991
     /*  419991 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(420064), // Rule ID 63781 //
     /*  419996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  420007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  420010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  420013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420020 */     // MIs[0] op1
     /*  420020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420043 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  420043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  420046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420048 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420050 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420052 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  420062 */     GIR_RootConstrainSelectedInstOperands,
     /*  420063 */     // GIR_Coverage, 63781,
     /*  420063 */     GIR_EraseRootFromParent_Done,
     /*  420064 */   // Label 7413: @420064
     /*  420064 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(420137), // Rule ID 63782 //
     /*  420069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  420080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  420083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  420086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420093 */     // MIs[0] op1
     /*  420093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420116 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  420116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  420119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420121 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420123 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420125 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  420135 */     GIR_RootConstrainSelectedInstOperands,
     /*  420136 */     // GIR_Coverage, 63782,
     /*  420136 */     GIR_EraseRootFromParent_Done,
     /*  420137 */   // Label 7414: @420137
     /*  420137 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(420210), // Rule ID 63805 //
     /*  420142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  420153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  420156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420166 */     // MIs[0] op1
     /*  420166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  420182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420189 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  420189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M8),
     /*  420192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420194 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420196 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420198 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  420208 */     GIR_RootConstrainSelectedInstOperands,
     /*  420209 */     // GIR_Coverage, 63805,
     /*  420209 */     GIR_EraseRootFromParent_Done,
     /*  420210 */   // Label 7415: @420210
     /*  420210 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(420283), // Rule ID 63806 //
     /*  420215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  420226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  420229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420239 */     // MIs[0] op1
     /*  420239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420242 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  420255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  420262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M8),
     /*  420265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420267 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420269 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420271 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  420281 */     GIR_RootConstrainSelectedInstOperands,
     /*  420282 */     // GIR_Coverage, 63806,
     /*  420282 */     GIR_EraseRootFromParent_Done,
     /*  420283 */   // Label 7416: @420283
     /*  420283 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(420356), // Rule ID 63825 //
     /*  420288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420312 */     // MIs[0] op1
     /*  420312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420335 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  420338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420340 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420342 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420344 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420354 */     GIR_RootConstrainSelectedInstOperands,
     /*  420355 */     // GIR_Coverage, 63825,
     /*  420355 */     GIR_EraseRootFromParent_Done,
     /*  420356 */   // Label 7417: @420356
     /*  420356 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(420429), // Rule ID 63826 //
     /*  420361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420385 */     // MIs[0] op1
     /*  420385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  420411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420413 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420415 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420417 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420427 */     GIR_RootConstrainSelectedInstOperands,
     /*  420428 */     // GIR_Coverage, 63826,
     /*  420428 */     GIR_EraseRootFromParent_Done,
     /*  420429 */   // Label 7418: @420429
     /*  420429 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(420502), // Rule ID 63837 //
     /*  420434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  420451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420458 */     // MIs[0] op1
     /*  420458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420481 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  420484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420486 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420488 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420490 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420500 */     GIR_RootConstrainSelectedInstOperands,
     /*  420501 */     // GIR_Coverage, 63837,
     /*  420501 */     GIR_EraseRootFromParent_Done,
     /*  420502 */   // Label 7419: @420502
     /*  420502 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(420575), // Rule ID 63838 //
     /*  420507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  420524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420531 */     // MIs[0] op1
     /*  420531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  420557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420559 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420561 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420563 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420573 */     GIR_RootConstrainSelectedInstOperands,
     /*  420574 */     // GIR_Coverage, 63838,
     /*  420574 */     GIR_EraseRootFromParent_Done,
     /*  420575 */   // Label 7420: @420575
     /*  420575 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(420648), // Rule ID 63861 //
     /*  420580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420604 */     // MIs[0] op1
     /*  420604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420607 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420627 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M2),
     /*  420630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420632 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420634 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420636 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420646 */     GIR_RootConstrainSelectedInstOperands,
     /*  420647 */     // GIR_Coverage, 63861,
     /*  420647 */     GIR_EraseRootFromParent_Done,
     /*  420648 */   // Label 7421: @420648
     /*  420648 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(420721), // Rule ID 63862 //
     /*  420653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420677 */     // MIs[0] op1
     /*  420677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420700 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M2),
     /*  420703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420705 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420707 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420709 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420719 */     GIR_RootConstrainSelectedInstOperands,
     /*  420720 */     // GIR_Coverage, 63862,
     /*  420720 */     GIR_EraseRootFromParent_Done,
     /*  420721 */   // Label 7422: @420721
     /*  420721 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(420794), // Rule ID 63881 //
     /*  420726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420750 */     // MIs[0] op1
     /*  420750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420773 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  420776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420778 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420780 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420782 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420792 */     GIR_RootConstrainSelectedInstOperands,
     /*  420793 */     // GIR_Coverage, 63881,
     /*  420793 */     GIR_EraseRootFromParent_Done,
     /*  420794 */   // Label 7423: @420794
     /*  420794 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(420867), // Rule ID 63882 //
     /*  420799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420823 */     // MIs[0] op1
     /*  420823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  420849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420851 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420853 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420855 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420865 */     GIR_RootConstrainSelectedInstOperands,
     /*  420866 */     // GIR_Coverage, 63882,
     /*  420866 */     GIR_EraseRootFromParent_Done,
     /*  420867 */   // Label 7424: @420867
     /*  420867 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(420940), // Rule ID 63893 //
     /*  420872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  420889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420896 */     // MIs[0] op1
     /*  420896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420899 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420919 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  420922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420924 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420926 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420928 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420938 */     GIR_RootConstrainSelectedInstOperands,
     /*  420939 */     // GIR_Coverage, 63893,
     /*  420939 */     GIR_EraseRootFromParent_Done,
     /*  420940 */   // Label 7425: @420940
     /*  420940 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(421013), // Rule ID 63894 //
     /*  420945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  420962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420969 */     // MIs[0] op1
     /*  420969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420992 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  420995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420997 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420999 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421001 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421011 */     GIR_RootConstrainSelectedInstOperands,
     /*  421012 */     // GIR_Coverage, 63894,
     /*  421012 */     GIR_EraseRootFromParent_Done,
     /*  421013 */   // Label 7426: @421013
     /*  421013 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(421086), // Rule ID 63917 //
     /*  421018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  421029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  421032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421042 */     // MIs[0] op1
     /*  421042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421045 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  421058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421065 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  421065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M4),
     /*  421068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421070 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421072 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421074 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421084 */     GIR_RootConstrainSelectedInstOperands,
     /*  421085 */     // GIR_Coverage, 63917,
     /*  421085 */     GIR_EraseRootFromParent_Done,
     /*  421086 */   // Label 7427: @421086
     /*  421086 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(421159), // Rule ID 63918 //
     /*  421091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  421102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  421105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421115 */     // MIs[0] op1
     /*  421115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  421131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421138 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  421138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M4),
     /*  421141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421143 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421145 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421147 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421157 */     GIR_RootConstrainSelectedInstOperands,
     /*  421158 */     // GIR_Coverage, 63918,
     /*  421158 */     GIR_EraseRootFromParent_Done,
     /*  421159 */   // Label 7428: @421159
     /*  421159 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(421232), // Rule ID 63937 //
     /*  421164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421188 */     // MIs[0] op1
     /*  421188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421211 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  421211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  421214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421216 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421218 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421220 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421230 */     GIR_RootConstrainSelectedInstOperands,
     /*  421231 */     // GIR_Coverage, 63937,
     /*  421231 */     GIR_EraseRootFromParent_Done,
     /*  421232 */   // Label 7429: @421232
     /*  421232 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(421305), // Rule ID 63938 //
     /*  421237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  421254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421261 */     // MIs[0] op1
     /*  421261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421284 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  421284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  421287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421289 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421291 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421293 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421303 */     GIR_RootConstrainSelectedInstOperands,
     /*  421304 */     // GIR_Coverage, 63938,
     /*  421304 */     GIR_EraseRootFromParent_Done,
     /*  421305 */   // Label 7430: @421305
     /*  421305 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(421378), // Rule ID 63949 //
     /*  421310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  421318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  421327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421334 */     // MIs[0] op1
     /*  421334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421357 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11130:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  421357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  421360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421362 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421364 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421366 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421376 */     GIR_RootConstrainSelectedInstOperands,
     /*  421377 */     // GIR_Coverage, 63949,
     /*  421377 */     GIR_EraseRootFromParent_Done,
     /*  421378 */   // Label 7431: @421378
     /*  421378 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(421451), // Rule ID 63950 //
     /*  421383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  421391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  421400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421407 */     // MIs[0] op1
     /*  421407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421430 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11130:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  421430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  421433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421435 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421437 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421439 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421449 */     GIR_RootConstrainSelectedInstOperands,
     /*  421450 */     // GIR_Coverage, 63950,
     /*  421450 */     GIR_EraseRootFromParent_Done,
     /*  421451 */   // Label 7432: @421451
     /*  421451 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(421524), // Rule ID 63973 //
     /*  421456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421480 */     // MIs[0] op1
     /*  421480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  421496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421503 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11116:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  421503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M8),
     /*  421506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421508 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421510 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421512 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421522 */     GIR_RootConstrainSelectedInstOperands,
     /*  421523 */     // GIR_Coverage, 63973,
     /*  421523 */     GIR_EraseRootFromParent_Done,
     /*  421524 */   // Label 7433: @421524
     /*  421524 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(421597), // Rule ID 63974 //
     /*  421529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421553 */     // MIs[0] op1
     /*  421553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  421569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11116:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  421576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M8),
     /*  421579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421581 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421583 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421585 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421595 */     GIR_RootConstrainSelectedInstOperands,
     /*  421596 */     // GIR_Coverage, 63974,
     /*  421596 */     GIR_EraseRootFromParent_Done,
     /*  421597 */   // Label 7434: @421597
     /*  421597 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(421680), // Rule ID 5346 //
     /*  421602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  421616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421645 */     // MIs[1] Operand 1
     /*  421645 */     // No operand predicates
     /*  421645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421658 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  421661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421678 */     GIR_RootConstrainSelectedInstOperands,
     /*  421679 */     // GIR_Coverage, 5346,
     /*  421679 */     GIR_EraseRootFromParent_Done,
     /*  421680 */   // Label 7435: @421680
     /*  421680 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(421763), // Rule ID 5347 //
     /*  421685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  421699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421728 */     // MIs[1] Operand 1
     /*  421728 */     // No operand predicates
     /*  421728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421741 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  421744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421761 */     GIR_RootConstrainSelectedInstOperands,
     /*  421762 */     // GIR_Coverage, 5347,
     /*  421762 */     GIR_EraseRootFromParent_Done,
     /*  421763 */   // Label 7436: @421763
     /*  421763 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(421846), // Rule ID 5348 //
     /*  421768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  421782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421811 */     // MIs[1] Operand 1
     /*  421811 */     // No operand predicates
     /*  421811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421824 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421834 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421844 */     GIR_RootConstrainSelectedInstOperands,
     /*  421845 */     // GIR_Coverage, 5348,
     /*  421845 */     GIR_EraseRootFromParent_Done,
     /*  421846 */   // Label 7437: @421846
     /*  421846 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(421929), // Rule ID 5349 //
     /*  421851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  421865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421894 */     // MIs[1] Operand 1
     /*  421894 */     // No operand predicates
     /*  421894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421907 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421927 */     GIR_RootConstrainSelectedInstOperands,
     /*  421928 */     // GIR_Coverage, 5349,
     /*  421928 */     GIR_EraseRootFromParent_Done,
     /*  421929 */   // Label 7438: @421929
     /*  421929 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(422012), // Rule ID 5350 //
     /*  421934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  421945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  421948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  421954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421977 */     // MIs[1] Operand 1
     /*  421977 */     // No operand predicates
     /*  421977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421990 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422000 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422010 */     GIR_RootConstrainSelectedInstOperands,
     /*  422011 */     // GIR_Coverage, 5350,
     /*  422011 */     GIR_EraseRootFromParent_Done,
     /*  422012 */   // Label 7439: @422012
     /*  422012 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(422095), // Rule ID 5351 //
     /*  422017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  422028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  422031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  422037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422060 */     // MIs[1] Operand 1
     /*  422060 */     // No operand predicates
     /*  422060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422073 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  422073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422093 */     GIR_RootConstrainSelectedInstOperands,
     /*  422094 */     // GIR_Coverage, 5351,
     /*  422094 */     GIR_EraseRootFromParent_Done,
     /*  422095 */   // Label 7440: @422095
     /*  422095 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(422178), // Rule ID 5352 //
     /*  422100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  422114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422143 */     // MIs[1] Operand 1
     /*  422143 */     // No operand predicates
     /*  422143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422156 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  422159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422176 */     GIR_RootConstrainSelectedInstOperands,
     /*  422177 */     // GIR_Coverage, 5352,
     /*  422177 */     GIR_EraseRootFromParent_Done,
     /*  422178 */   // Label 7441: @422178
     /*  422178 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(422261), // Rule ID 5353 //
     /*  422183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  422197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422226 */     // MIs[1] Operand 1
     /*  422226 */     // No operand predicates
     /*  422226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422239 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  422242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422259 */     GIR_RootConstrainSelectedInstOperands,
     /*  422260 */     // GIR_Coverage, 5353,
     /*  422260 */     GIR_EraseRootFromParent_Done,
     /*  422261 */   // Label 7442: @422261
     /*  422261 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(422344), // Rule ID 5354 //
     /*  422266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  422277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  422280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  422286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422309 */     // MIs[1] Operand 1
     /*  422309 */     // No operand predicates
     /*  422309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422322 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422342 */     GIR_RootConstrainSelectedInstOperands,
     /*  422343 */     // GIR_Coverage, 5354,
     /*  422343 */     GIR_EraseRootFromParent_Done,
     /*  422344 */   // Label 7443: @422344
     /*  422344 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(422427), // Rule ID 5355 //
     /*  422349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  422360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  422363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  422369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422392 */     // MIs[1] Operand 1
     /*  422392 */     // No operand predicates
     /*  422392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422405 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422425 */     GIR_RootConstrainSelectedInstOperands,
     /*  422426 */     // GIR_Coverage, 5355,
     /*  422426 */     GIR_EraseRootFromParent_Done,
     /*  422427 */   // Label 7444: @422427
     /*  422427 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(422510), // Rule ID 5356 //
     /*  422432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  422446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422475 */     // MIs[1] Operand 1
     /*  422475 */     // No operand predicates
     /*  422475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422488 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422498 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422508 */     GIR_RootConstrainSelectedInstOperands,
     /*  422509 */     // GIR_Coverage, 5356,
     /*  422509 */     GIR_EraseRootFromParent_Done,
     /*  422510 */   // Label 7445: @422510
     /*  422510 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(422593), // Rule ID 5357 //
     /*  422515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  422529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422558 */     // MIs[1] Operand 1
     /*  422558 */     // No operand predicates
     /*  422558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422571 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422591 */     GIR_RootConstrainSelectedInstOperands,
     /*  422592 */     // GIR_Coverage, 5357,
     /*  422592 */     GIR_EraseRootFromParent_Done,
     /*  422593 */   // Label 7446: @422593
     /*  422593 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(422676), // Rule ID 5358 //
     /*  422598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  422609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  422612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  422618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422641 */     // MIs[1] Operand 1
     /*  422641 */     // No operand predicates
     /*  422641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422654 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  422654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422664 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422674 */     GIR_RootConstrainSelectedInstOperands,
     /*  422675 */     // GIR_Coverage, 5358,
     /*  422675 */     GIR_EraseRootFromParent_Done,
     /*  422676 */   // Label 7447: @422676
     /*  422676 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(422759), // Rule ID 5359 //
     /*  422681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  422692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  422695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  422701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422724 */     // MIs[1] Operand 1
     /*  422724 */     // No operand predicates
     /*  422724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422737 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  422737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422757 */     GIR_RootConstrainSelectedInstOperands,
     /*  422758 */     // GIR_Coverage, 5359,
     /*  422758 */     GIR_EraseRootFromParent_Done,
     /*  422759 */   // Label 7448: @422759
     /*  422759 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(422842), // Rule ID 5360 //
     /*  422764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  422775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  422778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  422784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422807 */     // MIs[1] Operand 1
     /*  422807 */     // No operand predicates
     /*  422807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422820 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422830 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422840 */     GIR_RootConstrainSelectedInstOperands,
     /*  422841 */     // GIR_Coverage, 5360,
     /*  422841 */     GIR_EraseRootFromParent_Done,
     /*  422842 */   // Label 7449: @422842
     /*  422842 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(422925), // Rule ID 5361 //
     /*  422847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  422858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  422861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  422867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422890 */     // MIs[1] Operand 1
     /*  422890 */     // No operand predicates
     /*  422890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422903 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422923 */     GIR_RootConstrainSelectedInstOperands,
     /*  422924 */     // GIR_Coverage, 5361,
     /*  422924 */     GIR_EraseRootFromParent_Done,
     /*  422925 */   // Label 7450: @422925
     /*  422925 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(423008), // Rule ID 5362 //
     /*  422930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  422941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  422944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  422950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422973 */     // MIs[1] Operand 1
     /*  422973 */     // No operand predicates
     /*  422973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422996 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423006 */     GIR_RootConstrainSelectedInstOperands,
     /*  423007 */     // GIR_Coverage, 5362,
     /*  423007 */     GIR_EraseRootFromParent_Done,
     /*  423008 */   // Label 7451: @423008
     /*  423008 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(423091), // Rule ID 5363 //
     /*  423013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  423024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  423027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  423033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423056 */     // MIs[1] Operand 1
     /*  423056 */     // No operand predicates
     /*  423056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423069 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  423072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423089 */     GIR_RootConstrainSelectedInstOperands,
     /*  423090 */     // GIR_Coverage, 5363,
     /*  423090 */     GIR_EraseRootFromParent_Done,
     /*  423091 */   // Label 7452: @423091
     /*  423091 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(423174), // Rule ID 5364 //
     /*  423096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  423099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  423107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  423110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  423116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423139 */     // MIs[1] Operand 1
     /*  423139 */     // No operand predicates
     /*  423139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423152 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  423152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  423155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423162 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423172 */     GIR_RootConstrainSelectedInstOperands,
     /*  423173 */     // GIR_Coverage, 5364,
     /*  423173 */     GIR_EraseRootFromParent_Done,
     /*  423174 */   // Label 7453: @423174
     /*  423174 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(423257), // Rule ID 5365 //
     /*  423179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  423182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  423190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  423193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  423199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423222 */     // MIs[1] Operand 1
     /*  423222 */     // No operand predicates
     /*  423222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423235 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  423235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  423238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423255 */     GIR_RootConstrainSelectedInstOperands,
     /*  423256 */     // GIR_Coverage, 5365,
     /*  423256 */     GIR_EraseRootFromParent_Done,
     /*  423257 */   // Label 7454: @423257
     /*  423257 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(423340), // Rule ID 5366 //
     /*  423262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  423276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423305 */     // MIs[1] Operand 1
     /*  423305 */     // No operand predicates
     /*  423305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423318 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  423318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423328 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423338 */     GIR_RootConstrainSelectedInstOperands,
     /*  423339 */     // GIR_Coverage, 5366,
     /*  423339 */     GIR_EraseRootFromParent_Done,
     /*  423340 */   // Label 7455: @423340
     /*  423340 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(423423), // Rule ID 5367 //
     /*  423345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  423359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423388 */     // MIs[1] Operand 1
     /*  423388 */     // No operand predicates
     /*  423388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423401 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  423401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423421 */     GIR_RootConstrainSelectedInstOperands,
     /*  423422 */     // GIR_Coverage, 5367,
     /*  423422 */     GIR_EraseRootFromParent_Done,
     /*  423423 */   // Label 7456: @423423
     /*  423423 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(423506), // Rule ID 5368 //
     /*  423428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  423439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  423442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  423448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423471 */     // MIs[1] Operand 1
     /*  423471 */     // No operand predicates
     /*  423471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423484 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  423484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423494 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423504 */     GIR_RootConstrainSelectedInstOperands,
     /*  423505 */     // GIR_Coverage, 5368,
     /*  423505 */     GIR_EraseRootFromParent_Done,
     /*  423506 */   // Label 7457: @423506
     /*  423506 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(423589), // Rule ID 5369 //
     /*  423511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  423522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  423525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  423531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423554 */     // MIs[1] Operand 1
     /*  423554 */     // No operand predicates
     /*  423554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423567 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  423567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423587 */     GIR_RootConstrainSelectedInstOperands,
     /*  423588 */     // GIR_Coverage, 5369,
     /*  423588 */     GIR_EraseRootFromParent_Done,
     /*  423589 */   // Label 7458: @423589
     /*  423589 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(423672), // Rule ID 5370 //
     /*  423594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  423605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  423608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  423614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423637 */     // MIs[1] Operand 1
     /*  423637 */     // No operand predicates
     /*  423637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423650 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  423650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423670 */     GIR_RootConstrainSelectedInstOperands,
     /*  423671 */     // GIR_Coverage, 5370,
     /*  423671 */     GIR_EraseRootFromParent_Done,
     /*  423672 */   // Label 7459: @423672
     /*  423672 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(423755), // Rule ID 5371 //
     /*  423677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  423688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  423691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  423697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423720 */     // MIs[1] Operand 1
     /*  423720 */     // No operand predicates
     /*  423720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423733 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  423733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423753 */     GIR_RootConstrainSelectedInstOperands,
     /*  423754 */     // GIR_Coverage, 5371,
     /*  423754 */     GIR_EraseRootFromParent_Done,
     /*  423755 */   // Label 7460: @423755
     /*  423755 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(423838), // Rule ID 5372 //
     /*  423760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  423771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  423774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  423780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423803 */     // MIs[1] Operand 1
     /*  423803 */     // No operand predicates
     /*  423803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  423816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423826 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423836 */     GIR_RootConstrainSelectedInstOperands,
     /*  423837 */     // GIR_Coverage, 5372,
     /*  423837 */     GIR_EraseRootFromParent_Done,
     /*  423838 */   // Label 7461: @423838
     /*  423838 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(423921), // Rule ID 5373 //
     /*  423843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  423854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  423857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  423863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423886 */     // MIs[1] Operand 1
     /*  423886 */     // No operand predicates
     /*  423886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423899 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  423899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423919 */     GIR_RootConstrainSelectedInstOperands,
     /*  423920 */     // GIR_Coverage, 5373,
     /*  423920 */     GIR_EraseRootFromParent_Done,
     /*  423921 */   // Label 7462: @423921
     /*  423921 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(424004), // Rule ID 5374 //
     /*  423926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  423940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423969 */     // MIs[1] Operand 1
     /*  423969 */     // No operand predicates
     /*  423969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423982 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  423982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424002 */     GIR_RootConstrainSelectedInstOperands,
     /*  424003 */     // GIR_Coverage, 5374,
     /*  424003 */     GIR_EraseRootFromParent_Done,
     /*  424004 */   // Label 7463: @424004
     /*  424004 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(424087), // Rule ID 5375 //
     /*  424009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  424020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  424023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  424029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424052 */     // MIs[1] Operand 1
     /*  424052 */     // No operand predicates
     /*  424052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424065 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  424065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424085 */     GIR_RootConstrainSelectedInstOperands,
     /*  424086 */     // GIR_Coverage, 5375,
     /*  424086 */     GIR_EraseRootFromParent_Done,
     /*  424087 */   // Label 7464: @424087
     /*  424087 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(424170), // Rule ID 5376 //
     /*  424092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  424095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  424103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  424106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  424112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424135 */     // MIs[1] Operand 1
     /*  424135 */     // No operand predicates
     /*  424135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424148 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  424148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424168 */     GIR_RootConstrainSelectedInstOperands,
     /*  424169 */     // GIR_Coverage, 5376,
     /*  424169 */     GIR_EraseRootFromParent_Done,
     /*  424170 */   // Label 7465: @424170
     /*  424170 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(424253), // Rule ID 5377 //
     /*  424175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  424186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  424189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  424195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424218 */     // MIs[1] Operand 1
     /*  424218 */     // No operand predicates
     /*  424218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424231 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  424231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424251 */     GIR_RootConstrainSelectedInstOperands,
     /*  424252 */     // GIR_Coverage, 5377,
     /*  424252 */     GIR_EraseRootFromParent_Done,
     /*  424253 */   // Label 7466: @424253
     /*  424253 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(424336), // Rule ID 5378 //
     /*  424258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  424261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  424269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  424272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  424278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424301 */     // MIs[1] Operand 1
     /*  424301 */     // No operand predicates
     /*  424301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424314 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  424314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  424317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424324 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424334 */     GIR_RootConstrainSelectedInstOperands,
     /*  424335 */     // GIR_Coverage, 5378,
     /*  424335 */     GIR_EraseRootFromParent_Done,
     /*  424336 */   // Label 7467: @424336
     /*  424336 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(424419), // Rule ID 5379 //
     /*  424341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  424352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  424355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  424361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424384 */     // MIs[1] Operand 1
     /*  424384 */     // No operand predicates
     /*  424384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424397 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  424397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  424400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424417 */     GIR_RootConstrainSelectedInstOperands,
     /*  424418 */     // GIR_Coverage, 5379,
     /*  424418 */     GIR_EraseRootFromParent_Done,
     /*  424419 */   // Label 7468: @424419
     /*  424419 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(424502), // Rule ID 5380 //
     /*  424424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  424427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  424435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  424438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  424444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424467 */     // MIs[1] Operand 1
     /*  424467 */     // No operand predicates
     /*  424467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424480 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  424480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424490 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424500 */     GIR_RootConstrainSelectedInstOperands,
     /*  424501 */     // GIR_Coverage, 5380,
     /*  424501 */     GIR_EraseRootFromParent_Done,
     /*  424502 */   // Label 7469: @424502
     /*  424502 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(424585), // Rule ID 5381 //
     /*  424507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  424518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  424521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  424527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424550 */     // MIs[1] Operand 1
     /*  424550 */     // No operand predicates
     /*  424550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424563 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  424563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424583 */     GIR_RootConstrainSelectedInstOperands,
     /*  424584 */     // GIR_Coverage, 5381,
     /*  424584 */     GIR_EraseRootFromParent_Done,
     /*  424585 */   // Label 7470: @424585
     /*  424585 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(424668), // Rule ID 5382 //
     /*  424590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  424593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  424601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  424604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  424610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424633 */     // MIs[1] Operand 1
     /*  424633 */     // No operand predicates
     /*  424633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424646 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  424646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424656 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424666 */     GIR_RootConstrainSelectedInstOperands,
     /*  424667 */     // GIR_Coverage, 5382,
     /*  424667 */     GIR_EraseRootFromParent_Done,
     /*  424668 */   // Label 7471: @424668
     /*  424668 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(424751), // Rule ID 5383 //
     /*  424673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  424684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  424687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  424693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424716 */     // MIs[1] Operand 1
     /*  424716 */     // No operand predicates
     /*  424716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424729 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  424729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424749 */     GIR_RootConstrainSelectedInstOperands,
     /*  424750 */     // GIR_Coverage, 5383,
     /*  424750 */     GIR_EraseRootFromParent_Done,
     /*  424751 */   // Label 7472: @424751
     /*  424751 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(424834), // Rule ID 5384 //
     /*  424756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  424759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  424767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  424770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  424776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424799 */     // MIs[1] Operand 1
     /*  424799 */     // No operand predicates
     /*  424799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424812 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  424815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424822 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424832 */     GIR_RootConstrainSelectedInstOperands,
     /*  424833 */     // GIR_Coverage, 5384,
     /*  424833 */     GIR_EraseRootFromParent_Done,
     /*  424834 */   // Label 7473: @424834
     /*  424834 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(424917), // Rule ID 5385 //
     /*  424839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  424842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  424850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  424853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  424859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424882 */     // MIs[1] Operand 1
     /*  424882 */     // No operand predicates
     /*  424882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424895 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  424898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424915 */     GIR_RootConstrainSelectedInstOperands,
     /*  424916 */     // GIR_Coverage, 5385,
     /*  424916 */     GIR_EraseRootFromParent_Done,
     /*  424917 */   // Label 7474: @424917
     /*  424917 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(425000), // Rule ID 5386 //
     /*  424922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  424925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  424933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  424936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  424942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424965 */     // MIs[1] Operand 1
     /*  424965 */     // No operand predicates
     /*  424965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424978 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424998 */     GIR_RootConstrainSelectedInstOperands,
     /*  424999 */     // GIR_Coverage, 5386,
     /*  424999 */     GIR_EraseRootFromParent_Done,
     /*  425000 */   // Label 7475: @425000
     /*  425000 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(425083), // Rule ID 5387 //
     /*  425005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  425008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  425016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  425019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  425025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425048 */     // MIs[1] Operand 1
     /*  425048 */     // No operand predicates
     /*  425048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425061 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  425061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  425064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  425081 */     GIR_RootConstrainSelectedInstOperands,
     /*  425082 */     // GIR_Coverage, 5387,
     /*  425082 */     GIR_EraseRootFromParent_Done,
     /*  425083 */   // Label 7476: @425083
     /*  425083 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(425166), // Rule ID 5388 //
     /*  425088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  425091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  425099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  425102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  425108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425131 */     // MIs[1] Operand 1
     /*  425131 */     // No operand predicates
     /*  425131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425144 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  425144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  425147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425154 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  425164 */     GIR_RootConstrainSelectedInstOperands,
     /*  425165 */     // GIR_Coverage, 5388,
     /*  425165 */     GIR_EraseRootFromParent_Done,
     /*  425166 */   // Label 7477: @425166
     /*  425166 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(425249), // Rule ID 5389 //
     /*  425171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  425174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  425182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  425185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  425191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425214 */     // MIs[1] Operand 1
     /*  425214 */     // No operand predicates
     /*  425214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425227 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  425227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  425230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  425247 */     GIR_RootConstrainSelectedInstOperands,
     /*  425248 */     // GIR_Coverage, 5389,
     /*  425248 */     GIR_EraseRootFromParent_Done,
     /*  425249 */   // Label 7478: @425249
     /*  425249 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(425325), // Rule ID 60622 //
     /*  425254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  425265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  425271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425286 */     // MIs[0] rs2
     /*  425286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425301 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  425304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425323 */     GIR_RootConstrainSelectedInstOperands,
     /*  425324 */     // GIR_Coverage, 60622,
     /*  425324 */     GIR_EraseRootFromParent_Done,
     /*  425325 */   // Label 7479: @425325
     /*  425325 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(425401), // Rule ID 60623 //
     /*  425330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  425341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  425347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425362 */     // MIs[0] rs2
     /*  425362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425365 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425377 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  425380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425399 */     GIR_RootConstrainSelectedInstOperands,
     /*  425400 */     // GIR_Coverage, 60623,
     /*  425400 */     GIR_EraseRootFromParent_Done,
     /*  425401 */   // Label 7480: @425401
     /*  425401 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(425477), // Rule ID 62268 //
     /*  425406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  425417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  425420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  425423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425438 */     // MIs[0] rs2
     /*  425438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425453 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  425456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425475 */     GIR_RootConstrainSelectedInstOperands,
     /*  425476 */     // GIR_Coverage, 62268,
     /*  425476 */     GIR_EraseRootFromParent_Done,
     /*  425477 */   // Label 7481: @425477
     /*  425477 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(425553), // Rule ID 62269 //
     /*  425482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  425493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  425496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  425499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425514 */     // MIs[0] rs2
     /*  425514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425529 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  425532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425551 */     GIR_RootConstrainSelectedInstOperands,
     /*  425552 */     // GIR_Coverage, 62269,
     /*  425552 */     GIR_EraseRootFromParent_Done,
     /*  425553 */   // Label 7482: @425553
     /*  425553 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(425629), // Rule ID 62270 //
     /*  425558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425590 */     // MIs[0] rs2
     /*  425590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425605 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  425608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425627 */     GIR_RootConstrainSelectedInstOperands,
     /*  425628 */     // GIR_Coverage, 62270,
     /*  425628 */     GIR_EraseRootFromParent_Done,
     /*  425629 */   // Label 7483: @425629
     /*  425629 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(425705), // Rule ID 62271 //
     /*  425634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425666 */     // MIs[0] rs2
     /*  425666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  425684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425703 */     GIR_RootConstrainSelectedInstOperands,
     /*  425704 */     // GIR_Coverage, 62271,
     /*  425704 */     GIR_EraseRootFromParent_Done,
     /*  425705 */   // Label 7484: @425705
     /*  425705 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(425781), // Rule ID 62272 //
     /*  425710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  425721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  425724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  425727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425742 */     // MIs[0] rs2
     /*  425742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425757 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  425760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425779 */     GIR_RootConstrainSelectedInstOperands,
     /*  425780 */     // GIR_Coverage, 62272,
     /*  425780 */     GIR_EraseRootFromParent_Done,
     /*  425781 */   // Label 7485: @425781
     /*  425781 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(425857), // Rule ID 62273 //
     /*  425786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  425797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  425800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  425803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425818 */     // MIs[0] rs2
     /*  425818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425833 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  425836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425855 */     GIR_RootConstrainSelectedInstOperands,
     /*  425856 */     // GIR_Coverage, 62273,
     /*  425856 */     GIR_EraseRootFromParent_Done,
     /*  425857 */   // Label 7486: @425857
     /*  425857 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(425933), // Rule ID 62274 //
     /*  425862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  425873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  425876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  425879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425894 */     // MIs[0] rs2
     /*  425894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425897 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425909 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  425912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425931 */     GIR_RootConstrainSelectedInstOperands,
     /*  425932 */     // GIR_Coverage, 62274,
     /*  425932 */     GIR_EraseRootFromParent_Done,
     /*  425933 */   // Label 7487: @425933
     /*  425933 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(426009), // Rule ID 62275 //
     /*  425938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  425949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  425952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  425955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425970 */     // MIs[0] rs2
     /*  425970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425973 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425985 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  425988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426007 */     GIR_RootConstrainSelectedInstOperands,
     /*  426008 */     // GIR_Coverage, 62275,
     /*  426008 */     GIR_EraseRootFromParent_Done,
     /*  426009 */   // Label 7488: @426009
     /*  426009 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(426085), // Rule ID 62396 //
     /*  426014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  426025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  426028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  426031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426046 */     // MIs[0] rs2
     /*  426046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426049 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426061 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  426064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426083 */     GIR_RootConstrainSelectedInstOperands,
     /*  426084 */     // GIR_Coverage, 62396,
     /*  426084 */     GIR_EraseRootFromParent_Done,
     /*  426085 */   // Label 7489: @426085
     /*  426085 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(426161), // Rule ID 62397 //
     /*  426090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  426101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  426104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  426107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426122 */     // MIs[0] rs2
     /*  426122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426137 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  426140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426159 */     GIR_RootConstrainSelectedInstOperands,
     /*  426160 */     // GIR_Coverage, 62397,
     /*  426160 */     GIR_EraseRootFromParent_Done,
     /*  426161 */   // Label 7490: @426161
     /*  426161 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(426237), // Rule ID 62398 //
     /*  426166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  426177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  426180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  426183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426198 */     // MIs[0] rs2
     /*  426198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426213 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  426216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426235 */     GIR_RootConstrainSelectedInstOperands,
     /*  426236 */     // GIR_Coverage, 62398,
     /*  426236 */     GIR_EraseRootFromParent_Done,
     /*  426237 */   // Label 7491: @426237
     /*  426237 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(426313), // Rule ID 62399 //
     /*  426242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  426253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  426256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  426259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426274 */     // MIs[0] rs2
     /*  426274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426289 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  426292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426311 */     GIR_RootConstrainSelectedInstOperands,
     /*  426312 */     // GIR_Coverage, 62399,
     /*  426312 */     GIR_EraseRootFromParent_Done,
     /*  426313 */   // Label 7492: @426313
     /*  426313 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(426389), // Rule ID 62400 //
     /*  426318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  426329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  426332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  426335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426350 */     // MIs[0] rs2
     /*  426350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  426368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426387 */     GIR_RootConstrainSelectedInstOperands,
     /*  426388 */     // GIR_Coverage, 62400,
     /*  426388 */     GIR_EraseRootFromParent_Done,
     /*  426389 */   // Label 7493: @426389
     /*  426389 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(426465), // Rule ID 62401 //
     /*  426394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  426405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  426408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  426411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426426 */     // MIs[0] rs2
     /*  426426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  426444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426463 */     GIR_RootConstrainSelectedInstOperands,
     /*  426464 */     // GIR_Coverage, 62401,
     /*  426464 */     GIR_EraseRootFromParent_Done,
     /*  426465 */   // Label 7494: @426465
     /*  426465 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(426541), // Rule ID 62402 //
     /*  426470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  426481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  426484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  426487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426502 */     // MIs[0] rs2
     /*  426502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426517 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  426520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426539 */     GIR_RootConstrainSelectedInstOperands,
     /*  426540 */     // GIR_Coverage, 62402,
     /*  426540 */     GIR_EraseRootFromParent_Done,
     /*  426541 */   // Label 7495: @426541
     /*  426541 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(426617), // Rule ID 62403 //
     /*  426546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  426557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  426560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  426563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426578 */     // MIs[0] rs2
     /*  426578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426593 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  426596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426615 */     GIR_RootConstrainSelectedInstOperands,
     /*  426616 */     // GIR_Coverage, 62403,
     /*  426616 */     GIR_EraseRootFromParent_Done,
     /*  426617 */   // Label 7496: @426617
     /*  426617 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(426693), // Rule ID 62404 //
     /*  426622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  426633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  426636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  426639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426654 */     // MIs[0] rs2
     /*  426654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426657 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426669 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  426672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426691 */     GIR_RootConstrainSelectedInstOperands,
     /*  426692 */     // GIR_Coverage, 62404,
     /*  426692 */     GIR_EraseRootFromParent_Done,
     /*  426693 */   // Label 7497: @426693
     /*  426693 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(426769), // Rule ID 62405 //
     /*  426698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  426709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  426712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  426715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426730 */     // MIs[0] rs2
     /*  426730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426733 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426745 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  426748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426767 */     GIR_RootConstrainSelectedInstOperands,
     /*  426768 */     // GIR_Coverage, 62405,
     /*  426768 */     GIR_EraseRootFromParent_Done,
     /*  426769 */   // Label 7498: @426769
     /*  426769 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(426857), // Rule ID 2808 //
     /*  426774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  426785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  426788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  426791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426821 */     // MIs[1] Operand 1
     /*  426821 */     // No operand predicates
     /*  426821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426830 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  426830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  426833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426839 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426855 */     GIR_RootConstrainSelectedInstOperands,
     /*  426856 */     // GIR_Coverage, 2808,
     /*  426856 */     GIR_EraseRootFromParent_Done,
     /*  426857 */   // Label 7499: @426857
     /*  426857 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(426945), // Rule ID 2809 //
     /*  426862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  426873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  426876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  426879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426909 */     // MIs[1] Operand 1
     /*  426909 */     // No operand predicates
     /*  426909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426918 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  426918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  426921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426927 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426943 */     GIR_RootConstrainSelectedInstOperands,
     /*  426944 */     // GIR_Coverage, 2809,
     /*  426944 */     GIR_EraseRootFromParent_Done,
     /*  426945 */   // Label 7500: @426945
     /*  426945 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(427033), // Rule ID 2816 //
     /*  426950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  426961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  426964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  426967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426997 */     // MIs[1] Operand 1
     /*  426997 */     // No operand predicates
     /*  426997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427006 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  427006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  427009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427015 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427031 */     GIR_RootConstrainSelectedInstOperands,
     /*  427032 */     // GIR_Coverage, 2816,
     /*  427032 */     GIR_EraseRootFromParent_Done,
     /*  427033 */   // Label 7501: @427033
     /*  427033 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(427121), // Rule ID 2817 //
     /*  427038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  427049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  427052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  427055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427085 */     // MIs[1] Operand 1
     /*  427085 */     // No operand predicates
     /*  427085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427094 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  427094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  427097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427103 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427119 */     GIR_RootConstrainSelectedInstOperands,
     /*  427120 */     // GIR_Coverage, 2817,
     /*  427120 */     GIR_EraseRootFromParent_Done,
     /*  427121 */   // Label 7502: @427121
     /*  427121 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(427209), // Rule ID 2824 //
     /*  427126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  427137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  427140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  427143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427173 */     // MIs[1] Operand 1
     /*  427173 */     // No operand predicates
     /*  427173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427182 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  427182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427191 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427207 */     GIR_RootConstrainSelectedInstOperands,
     /*  427208 */     // GIR_Coverage, 2824,
     /*  427208 */     GIR_EraseRootFromParent_Done,
     /*  427209 */   // Label 7503: @427209
     /*  427209 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(427297), // Rule ID 2825 //
     /*  427214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  427225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  427228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  427231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427261 */     // MIs[1] Operand 1
     /*  427261 */     // No operand predicates
     /*  427261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427270 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  427270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427279 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427295 */     GIR_RootConstrainSelectedInstOperands,
     /*  427296 */     // GIR_Coverage, 2825,
     /*  427296 */     GIR_EraseRootFromParent_Done,
     /*  427297 */   // Label 7504: @427297
     /*  427297 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(427385), // Rule ID 2832 //
     /*  427302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  427313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  427316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  427319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427349 */     // MIs[1] Operand 1
     /*  427349 */     // No operand predicates
     /*  427349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427358 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  427358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  427361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427367 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427383 */     GIR_RootConstrainSelectedInstOperands,
     /*  427384 */     // GIR_Coverage, 2832,
     /*  427384 */     GIR_EraseRootFromParent_Done,
     /*  427385 */   // Label 7505: @427385
     /*  427385 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(427473), // Rule ID 2833 //
     /*  427390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  427401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  427404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  427407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427437 */     // MIs[1] Operand 1
     /*  427437 */     // No operand predicates
     /*  427437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  427446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  427449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427455 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427471 */     GIR_RootConstrainSelectedInstOperands,
     /*  427472 */     // GIR_Coverage, 2833,
     /*  427472 */     GIR_EraseRootFromParent_Done,
     /*  427473 */   // Label 7506: @427473
     /*  427473 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(427561), // Rule ID 2840 //
     /*  427478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  427489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  427492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  427495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427525 */     // MIs[1] Operand 1
     /*  427525 */     // No operand predicates
     /*  427525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427534 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  427534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427543 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427559 */     GIR_RootConstrainSelectedInstOperands,
     /*  427560 */     // GIR_Coverage, 2840,
     /*  427560 */     GIR_EraseRootFromParent_Done,
     /*  427561 */   // Label 7507: @427561
     /*  427561 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(427649), // Rule ID 2841 //
     /*  427566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  427577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  427580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  427583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427613 */     // MIs[1] Operand 1
     /*  427613 */     // No operand predicates
     /*  427613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427622 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  427622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427631 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427647 */     GIR_RootConstrainSelectedInstOperands,
     /*  427648 */     // GIR_Coverage, 2841,
     /*  427648 */     GIR_EraseRootFromParent_Done,
     /*  427649 */   // Label 7508: @427649
     /*  427649 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(427737), // Rule ID 2848 //
     /*  427654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  427665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  427668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  427671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427701 */     // MIs[1] Operand 1
     /*  427701 */     // No operand predicates
     /*  427701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427710 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  427710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427719 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427735 */     GIR_RootConstrainSelectedInstOperands,
     /*  427736 */     // GIR_Coverage, 2848,
     /*  427736 */     GIR_EraseRootFromParent_Done,
     /*  427737 */   // Label 7509: @427737
     /*  427737 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(427825), // Rule ID 2849 //
     /*  427742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  427753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  427756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  427759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427789 */     // MIs[1] Operand 1
     /*  427789 */     // No operand predicates
     /*  427789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427798 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  427798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427807 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427823 */     GIR_RootConstrainSelectedInstOperands,
     /*  427824 */     // GIR_Coverage, 2849,
     /*  427824 */     GIR_EraseRootFromParent_Done,
     /*  427825 */   // Label 7510: @427825
     /*  427825 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(427913), // Rule ID 2856 //
     /*  427830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  427841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  427844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  427847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427877 */     // MIs[1] Operand 1
     /*  427877 */     // No operand predicates
     /*  427877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427886 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  427886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427895 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427911 */     GIR_RootConstrainSelectedInstOperands,
     /*  427912 */     // GIR_Coverage, 2856,
     /*  427912 */     GIR_EraseRootFromParent_Done,
     /*  427913 */   // Label 7511: @427913
     /*  427913 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(428001), // Rule ID 2857 //
     /*  427918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  427929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  427932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  427935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427965 */     // MIs[1] Operand 1
     /*  427965 */     // No operand predicates
     /*  427965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  427974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427983 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427999 */     GIR_RootConstrainSelectedInstOperands,
     /*  428000 */     // GIR_Coverage, 2857,
     /*  428000 */     GIR_EraseRootFromParent_Done,
     /*  428001 */   // Label 7512: @428001
     /*  428001 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(428089), // Rule ID 2864 //
     /*  428006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  428017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  428020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  428023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428053 */     // MIs[1] Operand 1
     /*  428053 */     // No operand predicates
     /*  428053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428062 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428071 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428087 */     GIR_RootConstrainSelectedInstOperands,
     /*  428088 */     // GIR_Coverage, 2864,
     /*  428088 */     GIR_EraseRootFromParent_Done,
     /*  428089 */   // Label 7513: @428089
     /*  428089 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(428177), // Rule ID 2865 //
     /*  428094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  428105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  428108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  428111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428141 */     // MIs[1] Operand 1
     /*  428141 */     // No operand predicates
     /*  428141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428150 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  428150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428159 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428175 */     GIR_RootConstrainSelectedInstOperands,
     /*  428176 */     // GIR_Coverage, 2865,
     /*  428176 */     GIR_EraseRootFromParent_Done,
     /*  428177 */   // Label 7514: @428177
     /*  428177 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(428265), // Rule ID 2872 //
     /*  428182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  428193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  428196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  428199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428229 */     // MIs[1] Operand 1
     /*  428229 */     // No operand predicates
     /*  428229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428238 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  428238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428247 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428263 */     GIR_RootConstrainSelectedInstOperands,
     /*  428264 */     // GIR_Coverage, 2872,
     /*  428264 */     GIR_EraseRootFromParent_Done,
     /*  428265 */   // Label 7515: @428265
     /*  428265 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(428353), // Rule ID 2873 //
     /*  428270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  428281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  428284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  428287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428317 */     // MIs[1] Operand 1
     /*  428317 */     // No operand predicates
     /*  428317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  428326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428335 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428351 */     GIR_RootConstrainSelectedInstOperands,
     /*  428352 */     // GIR_Coverage, 2873,
     /*  428352 */     GIR_EraseRootFromParent_Done,
     /*  428353 */   // Label 7516: @428353
     /*  428353 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(428441), // Rule ID 2880 //
     /*  428358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  428361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  428369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  428372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  428375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428405 */     // MIs[1] Operand 1
     /*  428405 */     // No operand predicates
     /*  428405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  428414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428423 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428439 */     GIR_RootConstrainSelectedInstOperands,
     /*  428440 */     // GIR_Coverage, 2880,
     /*  428440 */     GIR_EraseRootFromParent_Done,
     /*  428441 */   // Label 7517: @428441
     /*  428441 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(428529), // Rule ID 2881 //
     /*  428446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  428449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  428457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  428460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  428463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428493 */     // MIs[1] Operand 1
     /*  428493 */     // No operand predicates
     /*  428493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  428502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428511 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428527 */     GIR_RootConstrainSelectedInstOperands,
     /*  428528 */     // GIR_Coverage, 2881,
     /*  428528 */     GIR_EraseRootFromParent_Done,
     /*  428529 */   // Label 7518: @428529
     /*  428529 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(428617), // Rule ID 2888 //
     /*  428534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  428545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  428548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  428551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428581 */     // MIs[1] Operand 1
     /*  428581 */     // No operand predicates
     /*  428581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428590 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  428590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428599 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428615 */     GIR_RootConstrainSelectedInstOperands,
     /*  428616 */     // GIR_Coverage, 2888,
     /*  428616 */     GIR_EraseRootFromParent_Done,
     /*  428617 */   // Label 7519: @428617
     /*  428617 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(428705), // Rule ID 2889 //
     /*  428622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  428633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  428636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  428639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428669 */     // MIs[1] Operand 1
     /*  428669 */     // No operand predicates
     /*  428669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428678 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  428678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428687 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428703 */     GIR_RootConstrainSelectedInstOperands,
     /*  428704 */     // GIR_Coverage, 2889,
     /*  428704 */     GIR_EraseRootFromParent_Done,
     /*  428705 */   // Label 7520: @428705
     /*  428705 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(428793), // Rule ID 2896 //
     /*  428710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  428721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  428724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  428727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428757 */     // MIs[1] Operand 1
     /*  428757 */     // No operand predicates
     /*  428757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428766 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  428766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428775 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428791 */     GIR_RootConstrainSelectedInstOperands,
     /*  428792 */     // GIR_Coverage, 2896,
     /*  428792 */     GIR_EraseRootFromParent_Done,
     /*  428793 */   // Label 7521: @428793
     /*  428793 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(428881), // Rule ID 2897 //
     /*  428798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  428809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  428812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  428815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428845 */     // MIs[1] Operand 1
     /*  428845 */     // No operand predicates
     /*  428845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428854 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  428854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428863 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428879 */     GIR_RootConstrainSelectedInstOperands,
     /*  428880 */     // GIR_Coverage, 2897,
     /*  428880 */     GIR_EraseRootFromParent_Done,
     /*  428881 */   // Label 7522: @428881
     /*  428881 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(428969), // Rule ID 2904 //
     /*  428886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  428897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  428900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  428903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428933 */     // MIs[1] Operand 1
     /*  428933 */     // No operand predicates
     /*  428933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428942 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  428942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  428945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428951 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428967 */     GIR_RootConstrainSelectedInstOperands,
     /*  428968 */     // GIR_Coverage, 2904,
     /*  428968 */     GIR_EraseRootFromParent_Done,
     /*  428969 */   // Label 7523: @428969
     /*  428969 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(429057), // Rule ID 2905 //
     /*  428974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  428985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  428988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  428991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429021 */     // MIs[1] Operand 1
     /*  429021 */     // No operand predicates
     /*  429021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429030 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  429030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429039 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  429052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429055 */     GIR_RootConstrainSelectedInstOperands,
     /*  429056 */     // GIR_Coverage, 2905,
     /*  429056 */     GIR_EraseRootFromParent_Done,
     /*  429057 */   // Label 7524: @429057
     /*  429057 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(429145), // Rule ID 2912 //
     /*  429062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  429073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  429076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  429079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429109 */     // MIs[1] Operand 1
     /*  429109 */     // No operand predicates
     /*  429109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429118 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  429118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429127 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429143 */     GIR_RootConstrainSelectedInstOperands,
     /*  429144 */     // GIR_Coverage, 2912,
     /*  429144 */     GIR_EraseRootFromParent_Done,
     /*  429145 */   // Label 7525: @429145
     /*  429145 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(429233), // Rule ID 2913 //
     /*  429150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  429161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  429164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  429167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429197 */     // MIs[1] Operand 1
     /*  429197 */     // No operand predicates
     /*  429197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  429206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429215 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429231 */     GIR_RootConstrainSelectedInstOperands,
     /*  429232 */     // GIR_Coverage, 2913,
     /*  429232 */     GIR_EraseRootFromParent_Done,
     /*  429233 */   // Label 7526: @429233
     /*  429233 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(429321), // Rule ID 2920 //
     /*  429238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  429249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  429252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  429255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429285 */     // MIs[1] Operand 1
     /*  429285 */     // No operand predicates
     /*  429285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429294 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  429294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429303 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429319 */     GIR_RootConstrainSelectedInstOperands,
     /*  429320 */     // GIR_Coverage, 2920,
     /*  429320 */     GIR_EraseRootFromParent_Done,
     /*  429321 */   // Label 7527: @429321
     /*  429321 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(429409), // Rule ID 2921 //
     /*  429326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  429337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  429340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  429343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429373 */     // MIs[1] Operand 1
     /*  429373 */     // No operand predicates
     /*  429373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429382 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  429382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429391 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429407 */     GIR_RootConstrainSelectedInstOperands,
     /*  429408 */     // GIR_Coverage, 2921,
     /*  429408 */     GIR_EraseRootFromParent_Done,
     /*  429409 */   // Label 7528: @429409
     /*  429409 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(429497), // Rule ID 2928 //
     /*  429414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  429425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  429428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  429431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429461 */     // MIs[1] Operand 1
     /*  429461 */     // No operand predicates
     /*  429461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429470 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  429470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429479 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429495 */     GIR_RootConstrainSelectedInstOperands,
     /*  429496 */     // GIR_Coverage, 2928,
     /*  429496 */     GIR_EraseRootFromParent_Done,
     /*  429497 */   // Label 7529: @429497
     /*  429497 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(429585), // Rule ID 2929 //
     /*  429502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  429513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  429516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  429519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429549 */     // MIs[1] Operand 1
     /*  429549 */     // No operand predicates
     /*  429549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  429558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429567 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429583 */     GIR_RootConstrainSelectedInstOperands,
     /*  429584 */     // GIR_Coverage, 2929,
     /*  429584 */     GIR_EraseRootFromParent_Done,
     /*  429585 */   // Label 7530: @429585
     /*  429585 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(429673), // Rule ID 2936 //
     /*  429590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429637 */     // MIs[1] Operand 1
     /*  429637 */     // No operand predicates
     /*  429637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429655 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429671 */     GIR_RootConstrainSelectedInstOperands,
     /*  429672 */     // GIR_Coverage, 2936,
     /*  429672 */     GIR_EraseRootFromParent_Done,
     /*  429673 */   // Label 7531: @429673
     /*  429673 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(429761), // Rule ID 2937 //
     /*  429678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429725 */     // MIs[1] Operand 1
     /*  429725 */     // No operand predicates
     /*  429725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429743 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429759 */     GIR_RootConstrainSelectedInstOperands,
     /*  429760 */     // GIR_Coverage, 2937,
     /*  429760 */     GIR_EraseRootFromParent_Done,
     /*  429761 */   // Label 7532: @429761
     /*  429761 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(429849), // Rule ID 2944 //
     /*  429766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429813 */     // MIs[1] Operand 1
     /*  429813 */     // No operand predicates
     /*  429813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429831 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429847 */     GIR_RootConstrainSelectedInstOperands,
     /*  429848 */     // GIR_Coverage, 2944,
     /*  429848 */     GIR_EraseRootFromParent_Done,
     /*  429849 */   // Label 7533: @429849
     /*  429849 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(429937), // Rule ID 2945 //
     /*  429854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429901 */     // MIs[1] Operand 1
     /*  429901 */     // No operand predicates
     /*  429901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429910 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429919 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429935 */     GIR_RootConstrainSelectedInstOperands,
     /*  429936 */     // GIR_Coverage, 2945,
     /*  429936 */     GIR_EraseRootFromParent_Done,
     /*  429937 */   // Label 7534: @429937
     /*  429937 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(430025), // Rule ID 2952 //
     /*  429942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429989 */     // MIs[1] Operand 1
     /*  429989 */     // No operand predicates
     /*  429989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429998 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  430001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430007 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  430020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430023 */     GIR_RootConstrainSelectedInstOperands,
     /*  430024 */     // GIR_Coverage, 2952,
     /*  430024 */     GIR_EraseRootFromParent_Done,
     /*  430025 */   // Label 7535: @430025
     /*  430025 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(430113), // Rule ID 2953 //
     /*  430030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  430041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  430044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  430047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430077 */     // MIs[1] Operand 1
     /*  430077 */     // No operand predicates
     /*  430077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430086 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  430086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  430089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430095 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  430108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430111 */     GIR_RootConstrainSelectedInstOperands,
     /*  430112 */     // GIR_Coverage, 2953,
     /*  430112 */     GIR_EraseRootFromParent_Done,
     /*  430113 */   // Label 7536: @430113
     /*  430113 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(430201), // Rule ID 2960 //
     /*  430118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  430121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  430129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  430132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  430135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430165 */     // MIs[1] Operand 1
     /*  430165 */     // No operand predicates
     /*  430165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430174 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  430174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  430177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430183 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430199 */     GIR_RootConstrainSelectedInstOperands,
     /*  430200 */     // GIR_Coverage, 2960,
     /*  430200 */     GIR_EraseRootFromParent_Done,
     /*  430201 */   // Label 7537: @430201
     /*  430201 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(430289), // Rule ID 2961 //
     /*  430206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  430209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  430217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  430220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  430223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430253 */     // MIs[1] Operand 1
     /*  430253 */     // No operand predicates
     /*  430253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430262 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  430262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  430265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430271 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430287 */     GIR_RootConstrainSelectedInstOperands,
     /*  430288 */     // GIR_Coverage, 2961,
     /*  430288 */     GIR_EraseRootFromParent_Done,
     /*  430289 */   // Label 7538: @430289
     /*  430289 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(430377), // Rule ID 2968 //
     /*  430294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  430297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  430305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  430308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  430311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430341 */     // MIs[1] Operand 1
     /*  430341 */     // No operand predicates
     /*  430341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430350 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  430350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  430353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430359 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430375 */     GIR_RootConstrainSelectedInstOperands,
     /*  430376 */     // GIR_Coverage, 2968,
     /*  430376 */     GIR_EraseRootFromParent_Done,
     /*  430377 */   // Label 7539: @430377
     /*  430377 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(430465), // Rule ID 2969 //
     /*  430382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  430385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  430393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  430396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  430399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430429 */     // MIs[1] Operand 1
     /*  430429 */     // No operand predicates
     /*  430429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430438 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  430438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  430441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430447 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430463 */     GIR_RootConstrainSelectedInstOperands,
     /*  430464 */     // GIR_Coverage, 2969,
     /*  430464 */     GIR_EraseRootFromParent_Done,
     /*  430465 */   // Label 7540: @430465
     /*  430465 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(430553), // Rule ID 2976 //
     /*  430470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  430473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  430481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  430484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  430487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430517 */     // MIs[1] Operand 1
     /*  430517 */     // No operand predicates
     /*  430517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430526 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  430526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  430529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430535 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430551 */     GIR_RootConstrainSelectedInstOperands,
     /*  430552 */     // GIR_Coverage, 2976,
     /*  430552 */     GIR_EraseRootFromParent_Done,
     /*  430553 */   // Label 7541: @430553
     /*  430553 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(430641), // Rule ID 2977 //
     /*  430558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  430561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  430569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  430572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  430575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430605 */     // MIs[1] Operand 1
     /*  430605 */     // No operand predicates
     /*  430605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430614 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  430614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  430617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430623 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430639 */     GIR_RootConstrainSelectedInstOperands,
     /*  430640 */     // GIR_Coverage, 2977,
     /*  430640 */     GIR_EraseRootFromParent_Done,
     /*  430641 */   // Label 7542: @430641
     /*  430641 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(430727), // Rule ID 3160 //
     /*  430646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  430657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  430660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  430663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430693 */     // MIs[1] Operand 1
     /*  430693 */     // No operand predicates
     /*  430693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430702 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  430705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430725 */     GIR_RootConstrainSelectedInstOperands,
     /*  430726 */     // GIR_Coverage, 3160,
     /*  430726 */     GIR_EraseRootFromParent_Done,
     /*  430727 */   // Label 7543: @430727
     /*  430727 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(430813), // Rule ID 3161 //
     /*  430732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  430743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  430746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  430749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430779 */     // MIs[1] Operand 1
     /*  430779 */     // No operand predicates
     /*  430779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430788 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  430791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430811 */     GIR_RootConstrainSelectedInstOperands,
     /*  430812 */     // GIR_Coverage, 3161,
     /*  430812 */     GIR_EraseRootFromParent_Done,
     /*  430813 */   // Label 7544: @430813
     /*  430813 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(430899), // Rule ID 3164 //
     /*  430818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  430829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  430832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  430835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430865 */     // MIs[1] Operand 1
     /*  430865 */     // No operand predicates
     /*  430865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430874 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430897 */     GIR_RootConstrainSelectedInstOperands,
     /*  430898 */     // GIR_Coverage, 3164,
     /*  430898 */     GIR_EraseRootFromParent_Done,
     /*  430899 */   // Label 7545: @430899
     /*  430899 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(430985), // Rule ID 3165 //
     /*  430904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  430915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  430918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  430921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430951 */     // MIs[1] Operand 1
     /*  430951 */     // No operand predicates
     /*  430951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430960 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430983 */     GIR_RootConstrainSelectedInstOperands,
     /*  430984 */     // GIR_Coverage, 3165,
     /*  430984 */     GIR_EraseRootFromParent_Done,
     /*  430985 */   // Label 7546: @430985
     /*  430985 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(431071), // Rule ID 3168 //
     /*  430990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  431001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  431004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  431007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431037 */     // MIs[1] Operand 1
     /*  431037 */     // No operand predicates
     /*  431037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431046 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431069 */     GIR_RootConstrainSelectedInstOperands,
     /*  431070 */     // GIR_Coverage, 3168,
     /*  431070 */     GIR_EraseRootFromParent_Done,
     /*  431071 */   // Label 7547: @431071
     /*  431071 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(431157), // Rule ID 3169 //
     /*  431076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  431087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  431090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  431093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431123 */     // MIs[1] Operand 1
     /*  431123 */     // No operand predicates
     /*  431123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431132 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  431132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431155 */     GIR_RootConstrainSelectedInstOperands,
     /*  431156 */     // GIR_Coverage, 3169,
     /*  431156 */     GIR_EraseRootFromParent_Done,
     /*  431157 */   // Label 7548: @431157
     /*  431157 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(431243), // Rule ID 3172 //
     /*  431162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  431173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  431176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  431179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431209 */     // MIs[1] Operand 1
     /*  431209 */     // No operand predicates
     /*  431209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431218 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  431221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431241 */     GIR_RootConstrainSelectedInstOperands,
     /*  431242 */     // GIR_Coverage, 3172,
     /*  431242 */     GIR_EraseRootFromParent_Done,
     /*  431243 */   // Label 7549: @431243
     /*  431243 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(431329), // Rule ID 3173 //
     /*  431248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  431259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  431262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  431265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431295 */     // MIs[1] Operand 1
     /*  431295 */     // No operand predicates
     /*  431295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431304 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  431307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431327 */     GIR_RootConstrainSelectedInstOperands,
     /*  431328 */     // GIR_Coverage, 3173,
     /*  431328 */     GIR_EraseRootFromParent_Done,
     /*  431329 */   // Label 7550: @431329
     /*  431329 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(431415), // Rule ID 3176 //
     /*  431334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  431345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  431348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  431351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431381 */     // MIs[1] Operand 1
     /*  431381 */     // No operand predicates
     /*  431381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431390 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431413 */     GIR_RootConstrainSelectedInstOperands,
     /*  431414 */     // GIR_Coverage, 3176,
     /*  431414 */     GIR_EraseRootFromParent_Done,
     /*  431415 */   // Label 7551: @431415
     /*  431415 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(431501), // Rule ID 3177 //
     /*  431420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  431431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  431434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  431437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431467 */     // MIs[1] Operand 1
     /*  431467 */     // No operand predicates
     /*  431467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431476 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431499 */     GIR_RootConstrainSelectedInstOperands,
     /*  431500 */     // GIR_Coverage, 3177,
     /*  431500 */     GIR_EraseRootFromParent_Done,
     /*  431501 */   // Label 7552: @431501
     /*  431501 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(431587), // Rule ID 3180 //
     /*  431506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  431517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  431520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  431523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431553 */     // MIs[1] Operand 1
     /*  431553 */     // No operand predicates
     /*  431553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431562 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431585 */     GIR_RootConstrainSelectedInstOperands,
     /*  431586 */     // GIR_Coverage, 3180,
     /*  431586 */     GIR_EraseRootFromParent_Done,
     /*  431587 */   // Label 7553: @431587
     /*  431587 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(431673), // Rule ID 3181 //
     /*  431592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  431603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  431606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  431609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431639 */     // MIs[1] Operand 1
     /*  431639 */     // No operand predicates
     /*  431639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431648 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431671 */     GIR_RootConstrainSelectedInstOperands,
     /*  431672 */     // GIR_Coverage, 3181,
     /*  431672 */     GIR_EraseRootFromParent_Done,
     /*  431673 */   // Label 7554: @431673
     /*  431673 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(431759), // Rule ID 3184 //
     /*  431678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  431689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  431692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  431695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431725 */     // MIs[1] Operand 1
     /*  431725 */     // No operand predicates
     /*  431725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431734 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431757 */     GIR_RootConstrainSelectedInstOperands,
     /*  431758 */     // GIR_Coverage, 3184,
     /*  431758 */     GIR_EraseRootFromParent_Done,
     /*  431759 */   // Label 7555: @431759
     /*  431759 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(431845), // Rule ID 3185 //
     /*  431764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  431775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  431778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  431781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431811 */     // MIs[1] Operand 1
     /*  431811 */     // No operand predicates
     /*  431811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431820 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  431820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431843 */     GIR_RootConstrainSelectedInstOperands,
     /*  431844 */     // GIR_Coverage, 3185,
     /*  431844 */     GIR_EraseRootFromParent_Done,
     /*  431845 */   // Label 7556: @431845
     /*  431845 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(431931), // Rule ID 3188 //
     /*  431850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  431861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  431864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  431867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431897 */     // MIs[1] Operand 1
     /*  431897 */     // No operand predicates
     /*  431897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431906 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431929 */     GIR_RootConstrainSelectedInstOperands,
     /*  431930 */     // GIR_Coverage, 3188,
     /*  431930 */     GIR_EraseRootFromParent_Done,
     /*  431931 */   // Label 7557: @431931
     /*  431931 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(432017), // Rule ID 3189 //
     /*  431936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  431947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  431950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  431953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431983 */     // MIs[1] Operand 1
     /*  431983 */     // No operand predicates
     /*  431983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431992 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432015 */     GIR_RootConstrainSelectedInstOperands,
     /*  432016 */     // GIR_Coverage, 3189,
     /*  432016 */     GIR_EraseRootFromParent_Done,
     /*  432017 */   // Label 7558: @432017
     /*  432017 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(432103), // Rule ID 3192 //
     /*  432022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  432033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  432036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  432039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432069 */     // MIs[1] Operand 1
     /*  432069 */     // No operand predicates
     /*  432069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  432078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  432081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  432098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432101 */     GIR_RootConstrainSelectedInstOperands,
     /*  432102 */     // GIR_Coverage, 3192,
     /*  432102 */     GIR_EraseRootFromParent_Done,
     /*  432103 */   // Label 7559: @432103
     /*  432103 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(432189), // Rule ID 3193 //
     /*  432108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  432119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  432122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  432125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432155 */     // MIs[1] Operand 1
     /*  432155 */     // No operand predicates
     /*  432155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  432164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  432167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  432184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432187 */     GIR_RootConstrainSelectedInstOperands,
     /*  432188 */     // GIR_Coverage, 3193,
     /*  432188 */     GIR_EraseRootFromParent_Done,
     /*  432189 */   // Label 7560: @432189
     /*  432189 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(432275), // Rule ID 3196 //
     /*  432194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  432197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  432205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  432208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  432211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432241 */     // MIs[1] Operand 1
     /*  432241 */     // No operand predicates
     /*  432241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432250 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  432250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  432253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  432270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432273 */     GIR_RootConstrainSelectedInstOperands,
     /*  432274 */     // GIR_Coverage, 3196,
     /*  432274 */     GIR_EraseRootFromParent_Done,
     /*  432275 */   // Label 7561: @432275
     /*  432275 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(432361), // Rule ID 3197 //
     /*  432280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  432283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  432291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  432294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  432297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432327 */     // MIs[1] Operand 1
     /*  432327 */     // No operand predicates
     /*  432327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  432336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  432339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  432356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432359 */     GIR_RootConstrainSelectedInstOperands,
     /*  432360 */     // GIR_Coverage, 3197,
     /*  432360 */     GIR_EraseRootFromParent_Done,
     /*  432361 */   // Label 7562: @432361
     /*  432361 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(432447), // Rule ID 3200 //
     /*  432366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  432377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  432380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  432383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432413 */     // MIs[1] Operand 1
     /*  432413 */     // No operand predicates
     /*  432413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432422 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432445 */     GIR_RootConstrainSelectedInstOperands,
     /*  432446 */     // GIR_Coverage, 3200,
     /*  432446 */     GIR_EraseRootFromParent_Done,
     /*  432447 */   // Label 7563: @432447
     /*  432447 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(432533), // Rule ID 3201 //
     /*  432452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  432463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  432466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  432469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432499 */     // MIs[1] Operand 1
     /*  432499 */     // No operand predicates
     /*  432499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432508 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432531 */     GIR_RootConstrainSelectedInstOperands,
     /*  432532 */     // GIR_Coverage, 3201,
     /*  432532 */     GIR_EraseRootFromParent_Done,
     /*  432533 */   // Label 7564: @432533
     /*  432533 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(432619), // Rule ID 3204 //
     /*  432538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  432549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  432552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  432555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432585 */     // MIs[1] Operand 1
     /*  432585 */     // No operand predicates
     /*  432585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432594 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432617 */     GIR_RootConstrainSelectedInstOperands,
     /*  432618 */     // GIR_Coverage, 3204,
     /*  432618 */     GIR_EraseRootFromParent_Done,
     /*  432619 */   // Label 7565: @432619
     /*  432619 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(432705), // Rule ID 3205 //
     /*  432624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  432635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  432638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  432641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432671 */     // MIs[1] Operand 1
     /*  432671 */     // No operand predicates
     /*  432671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432680 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432703 */     GIR_RootConstrainSelectedInstOperands,
     /*  432704 */     // GIR_Coverage, 3205,
     /*  432704 */     GIR_EraseRootFromParent_Done,
     /*  432705 */   // Label 7566: @432705
     /*  432705 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(432791), // Rule ID 3208 //
     /*  432710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  432721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  432724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  432727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432757 */     // MIs[1] Operand 1
     /*  432757 */     // No operand predicates
     /*  432757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432766 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432789 */     GIR_RootConstrainSelectedInstOperands,
     /*  432790 */     // GIR_Coverage, 3208,
     /*  432790 */     GIR_EraseRootFromParent_Done,
     /*  432791 */   // Label 7567: @432791
     /*  432791 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(432877), // Rule ID 3209 //
     /*  432796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  432807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  432810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  432813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432843 */     // MIs[1] Operand 1
     /*  432843 */     // No operand predicates
     /*  432843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432852 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432875 */     GIR_RootConstrainSelectedInstOperands,
     /*  432876 */     // GIR_Coverage, 3209,
     /*  432876 */     GIR_EraseRootFromParent_Done,
     /*  432877 */   // Label 7568: @432877
     /*  432877 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(432963), // Rule ID 3212 //
     /*  432882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  432893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432929 */     // MIs[1] Operand 1
     /*  432929 */     // No operand predicates
     /*  432929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432938 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432961 */     GIR_RootConstrainSelectedInstOperands,
     /*  432962 */     // GIR_Coverage, 3212,
     /*  432962 */     GIR_EraseRootFromParent_Done,
     /*  432963 */   // Label 7569: @432963
     /*  432963 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(433049), // Rule ID 3213 //
     /*  432968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  432979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433015 */     // MIs[1] Operand 1
     /*  433015 */     // No operand predicates
     /*  433015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  433024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433047 */     GIR_RootConstrainSelectedInstOperands,
     /*  433048 */     // GIR_Coverage, 3213,
     /*  433048 */     GIR_EraseRootFromParent_Done,
     /*  433049 */   // Label 7570: @433049
     /*  433049 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(433135), // Rule ID 3216 //
     /*  433054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  433065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  433068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  433071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433101 */     // MIs[1] Operand 1
     /*  433101 */     // No operand predicates
     /*  433101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433110 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  433110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433133 */     GIR_RootConstrainSelectedInstOperands,
     /*  433134 */     // GIR_Coverage, 3216,
     /*  433134 */     GIR_EraseRootFromParent_Done,
     /*  433135 */   // Label 7571: @433135
     /*  433135 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(433221), // Rule ID 3217 //
     /*  433140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  433151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  433154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  433157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433187 */     // MIs[1] Operand 1
     /*  433187 */     // No operand predicates
     /*  433187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  433196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433219 */     GIR_RootConstrainSelectedInstOperands,
     /*  433220 */     // GIR_Coverage, 3217,
     /*  433220 */     GIR_EraseRootFromParent_Done,
     /*  433221 */   // Label 7572: @433221
     /*  433221 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(433307), // Rule ID 3220 //
     /*  433226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  433237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  433240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  433243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433273 */     // MIs[1] Operand 1
     /*  433273 */     // No operand predicates
     /*  433273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433282 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  433282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433305 */     GIR_RootConstrainSelectedInstOperands,
     /*  433306 */     // GIR_Coverage, 3220,
     /*  433306 */     GIR_EraseRootFromParent_Done,
     /*  433307 */   // Label 7573: @433307
     /*  433307 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(433393), // Rule ID 3221 //
     /*  433312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  433323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  433326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  433329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433359 */     // MIs[1] Operand 1
     /*  433359 */     // No operand predicates
     /*  433359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433368 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  433368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433391 */     GIR_RootConstrainSelectedInstOperands,
     /*  433392 */     // GIR_Coverage, 3221,
     /*  433392 */     GIR_EraseRootFromParent_Done,
     /*  433393 */   // Label 7574: @433393
     /*  433393 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(433479), // Rule ID 3224 //
     /*  433398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  433409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  433412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  433415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433445 */     // MIs[1] Operand 1
     /*  433445 */     // No operand predicates
     /*  433445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433454 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433477 */     GIR_RootConstrainSelectedInstOperands,
     /*  433478 */     // GIR_Coverage, 3224,
     /*  433478 */     GIR_EraseRootFromParent_Done,
     /*  433479 */   // Label 7575: @433479
     /*  433479 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(433565), // Rule ID 3225 //
     /*  433484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  433495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  433498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  433501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433531 */     // MIs[1] Operand 1
     /*  433531 */     // No operand predicates
     /*  433531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433540 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433563 */     GIR_RootConstrainSelectedInstOperands,
     /*  433564 */     // GIR_Coverage, 3225,
     /*  433564 */     GIR_EraseRootFromParent_Done,
     /*  433565 */   // Label 7576: @433565
     /*  433565 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(433651), // Rule ID 3228 //
     /*  433570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433617 */     // MIs[1] Operand 1
     /*  433617 */     // No operand predicates
     /*  433617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433626 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433649 */     GIR_RootConstrainSelectedInstOperands,
     /*  433650 */     // GIR_Coverage, 3228,
     /*  433650 */     GIR_EraseRootFromParent_Done,
     /*  433651 */   // Label 7577: @433651
     /*  433651 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(433737), // Rule ID 3229 //
     /*  433656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433703 */     // MIs[1] Operand 1
     /*  433703 */     // No operand predicates
     /*  433703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433712 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433735 */     GIR_RootConstrainSelectedInstOperands,
     /*  433736 */     // GIR_Coverage, 3229,
     /*  433736 */     GIR_EraseRootFromParent_Done,
     /*  433737 */   // Label 7578: @433737
     /*  433737 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(433823), // Rule ID 3232 //
     /*  433742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  433759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433789 */     // MIs[1] Operand 1
     /*  433789 */     // No operand predicates
     /*  433789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433798 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433821 */     GIR_RootConstrainSelectedInstOperands,
     /*  433822 */     // GIR_Coverage, 3232,
     /*  433822 */     GIR_EraseRootFromParent_Done,
     /*  433823 */   // Label 7579: @433823
     /*  433823 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(433909), // Rule ID 3233 //
     /*  433828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  433845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433875 */     // MIs[1] Operand 1
     /*  433875 */     // No operand predicates
     /*  433875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433884 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433907 */     GIR_RootConstrainSelectedInstOperands,
     /*  433908 */     // GIR_Coverage, 3233,
     /*  433908 */     GIR_EraseRootFromParent_Done,
     /*  433909 */   // Label 7580: @433909
     /*  433909 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(433995), // Rule ID 3236 //
     /*  433914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  433931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433961 */     // MIs[1] Operand 1
     /*  433961 */     // No operand predicates
     /*  433961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433970 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433993 */     GIR_RootConstrainSelectedInstOperands,
     /*  433994 */     // GIR_Coverage, 3236,
     /*  433994 */     GIR_EraseRootFromParent_Done,
     /*  433995 */   // Label 7581: @433995
     /*  433995 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(434081), // Rule ID 3237 //
     /*  434000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  434003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  434011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  434014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  434017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434047 */     // MIs[1] Operand 1
     /*  434047 */     // No operand predicates
     /*  434047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434056 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  434056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  434059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  434076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434079 */     GIR_RootConstrainSelectedInstOperands,
     /*  434080 */     // GIR_Coverage, 3237,
     /*  434080 */     GIR_EraseRootFromParent_Done,
     /*  434081 */   // Label 7582: @434081
     /*  434081 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(434167), // Rule ID 3240 //
     /*  434086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  434089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  434097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  434100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  434103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434133 */     // MIs[1] Operand 1
     /*  434133 */     // No operand predicates
     /*  434133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434142 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  434142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  434145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  434162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434165 */     GIR_RootConstrainSelectedInstOperands,
     /*  434166 */     // GIR_Coverage, 3240,
     /*  434166 */     GIR_EraseRootFromParent_Done,
     /*  434167 */   // Label 7583: @434167
     /*  434167 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(434253), // Rule ID 3241 //
     /*  434172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  434175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  434183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  434186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  434189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434219 */     // MIs[1] Operand 1
     /*  434219 */     // No operand predicates
     /*  434219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434228 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  434228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  434231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  434248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434251 */     GIR_RootConstrainSelectedInstOperands,
     /*  434252 */     // GIR_Coverage, 3241,
     /*  434252 */     GIR_EraseRootFromParent_Done,
     /*  434253 */   // Label 7584: @434253
     /*  434253 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(434339), // Rule ID 3244 //
     /*  434258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  434261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  434269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  434272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  434275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434305 */     // MIs[1] Operand 1
     /*  434305 */     // No operand predicates
     /*  434305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434314 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  434314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  434317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  434334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434337 */     GIR_RootConstrainSelectedInstOperands,
     /*  434338 */     // GIR_Coverage, 3244,
     /*  434338 */     GIR_EraseRootFromParent_Done,
     /*  434339 */   // Label 7585: @434339
     /*  434339 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(434425), // Rule ID 3245 //
     /*  434344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  434347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  434355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  434358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  434361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434391 */     // MIs[1] Operand 1
     /*  434391 */     // No operand predicates
     /*  434391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434400 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  434400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  434403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  434420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434423 */     GIR_RootConstrainSelectedInstOperands,
     /*  434424 */     // GIR_Coverage, 3245,
     /*  434424 */     GIR_EraseRootFromParent_Done,
     /*  434425 */   // Label 7586: @434425
     /*  434425 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(434511), // Rule ID 3512 //
     /*  434430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  434441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  434444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  434447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434477 */     // MIs[1] Operand 1
     /*  434477 */     // No operand predicates
     /*  434477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434486 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  434489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434509 */     GIR_RootConstrainSelectedInstOperands,
     /*  434510 */     // GIR_Coverage, 3512,
     /*  434510 */     GIR_EraseRootFromParent_Done,
     /*  434511 */   // Label 7587: @434511
     /*  434511 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(434597), // Rule ID 3513 //
     /*  434516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  434527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  434530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  434533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434563 */     // MIs[1] Operand 1
     /*  434563 */     // No operand predicates
     /*  434563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434572 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  434575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434595 */     GIR_RootConstrainSelectedInstOperands,
     /*  434596 */     // GIR_Coverage, 3513,
     /*  434596 */     GIR_EraseRootFromParent_Done,
     /*  434597 */   // Label 7588: @434597
     /*  434597 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(434683), // Rule ID 3516 //
     /*  434602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  434613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  434616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  434619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434649 */     // MIs[1] Operand 1
     /*  434649 */     // No operand predicates
     /*  434649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434658 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434681 */     GIR_RootConstrainSelectedInstOperands,
     /*  434682 */     // GIR_Coverage, 3516,
     /*  434682 */     GIR_EraseRootFromParent_Done,
     /*  434683 */   // Label 7589: @434683
     /*  434683 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(434769), // Rule ID 3517 //
     /*  434688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  434699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  434702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  434705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434735 */     // MIs[1] Operand 1
     /*  434735 */     // No operand predicates
     /*  434735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434744 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434767 */     GIR_RootConstrainSelectedInstOperands,
     /*  434768 */     // GIR_Coverage, 3517,
     /*  434768 */     GIR_EraseRootFromParent_Done,
     /*  434769 */   // Label 7590: @434769
     /*  434769 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(434855), // Rule ID 3520 //
     /*  434774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  434785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  434788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  434791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434821 */     // MIs[1] Operand 1
     /*  434821 */     // No operand predicates
     /*  434821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434830 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434853 */     GIR_RootConstrainSelectedInstOperands,
     /*  434854 */     // GIR_Coverage, 3520,
     /*  434854 */     GIR_EraseRootFromParent_Done,
     /*  434855 */   // Label 7591: @434855
     /*  434855 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(434941), // Rule ID 3521 //
     /*  434860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  434871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  434874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  434877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434907 */     // MIs[1] Operand 1
     /*  434907 */     // No operand predicates
     /*  434907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434916 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434939 */     GIR_RootConstrainSelectedInstOperands,
     /*  434940 */     // GIR_Coverage, 3521,
     /*  434940 */     GIR_EraseRootFromParent_Done,
     /*  434941 */   // Label 7592: @434941
     /*  434941 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(435027), // Rule ID 3524 //
     /*  434946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  434957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  434960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  434963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434993 */     // MIs[1] Operand 1
     /*  434993 */     // No operand predicates
     /*  434993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435002 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  435002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  435005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435025 */     GIR_RootConstrainSelectedInstOperands,
     /*  435026 */     // GIR_Coverage, 3524,
     /*  435026 */     GIR_EraseRootFromParent_Done,
     /*  435027 */   // Label 7593: @435027
     /*  435027 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(435113), // Rule ID 3525 //
     /*  435032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  435043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  435046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  435049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435079 */     // MIs[1] Operand 1
     /*  435079 */     // No operand predicates
     /*  435079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435088 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  435088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  435091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435111 */     GIR_RootConstrainSelectedInstOperands,
     /*  435112 */     // GIR_Coverage, 3525,
     /*  435112 */     GIR_EraseRootFromParent_Done,
     /*  435113 */   // Label 7594: @435113
     /*  435113 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(435199), // Rule ID 3528 //
     /*  435118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  435129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  435132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  435135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435165 */     // MIs[1] Operand 1
     /*  435165 */     // No operand predicates
     /*  435165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435174 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  435174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  435177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435197 */     GIR_RootConstrainSelectedInstOperands,
     /*  435198 */     // GIR_Coverage, 3528,
     /*  435198 */     GIR_EraseRootFromParent_Done,
     /*  435199 */   // Label 7595: @435199
     /*  435199 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(435285), // Rule ID 3529 //
     /*  435204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  435215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  435218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  435221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435251 */     // MIs[1] Operand 1
     /*  435251 */     // No operand predicates
     /*  435251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435260 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  435260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  435263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435283 */     GIR_RootConstrainSelectedInstOperands,
     /*  435284 */     // GIR_Coverage, 3529,
     /*  435284 */     GIR_EraseRootFromParent_Done,
     /*  435285 */   // Label 7596: @435285
     /*  435285 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(435371), // Rule ID 3532 //
     /*  435290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  435301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  435304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  435307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435337 */     // MIs[1] Operand 1
     /*  435337 */     // No operand predicates
     /*  435337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  435346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  435349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435369 */     GIR_RootConstrainSelectedInstOperands,
     /*  435370 */     // GIR_Coverage, 3532,
     /*  435370 */     GIR_EraseRootFromParent_Done,
     /*  435371 */   // Label 7597: @435371
     /*  435371 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(435457), // Rule ID 3533 //
     /*  435376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  435387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  435390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  435393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435423 */     // MIs[1] Operand 1
     /*  435423 */     // No operand predicates
     /*  435423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435432 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  435432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  435435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435455 */     GIR_RootConstrainSelectedInstOperands,
     /*  435456 */     // GIR_Coverage, 3533,
     /*  435456 */     GIR_EraseRootFromParent_Done,
     /*  435457 */   // Label 7598: @435457
     /*  435457 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(435543), // Rule ID 3536 //
     /*  435462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  435479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435509 */     // MIs[1] Operand 1
     /*  435509 */     // No operand predicates
     /*  435509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435518 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435541 */     GIR_RootConstrainSelectedInstOperands,
     /*  435542 */     // GIR_Coverage, 3536,
     /*  435542 */     GIR_EraseRootFromParent_Done,
     /*  435543 */   // Label 7599: @435543
     /*  435543 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(435629), // Rule ID 3537 //
     /*  435548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  435565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435595 */     // MIs[1] Operand 1
     /*  435595 */     // No operand predicates
     /*  435595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435604 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435627 */     GIR_RootConstrainSelectedInstOperands,
     /*  435628 */     // GIR_Coverage, 3537,
     /*  435628 */     GIR_EraseRootFromParent_Done,
     /*  435629 */   // Label 7600: @435629
     /*  435629 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(435715), // Rule ID 3540 //
     /*  435634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  435645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  435648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435681 */     // MIs[1] Operand 1
     /*  435681 */     // No operand predicates
     /*  435681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435690 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  435690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435713 */     GIR_RootConstrainSelectedInstOperands,
     /*  435714 */     // GIR_Coverage, 3540,
     /*  435714 */     GIR_EraseRootFromParent_Done,
     /*  435715 */   // Label 7601: @435715
     /*  435715 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(435801), // Rule ID 3541 //
     /*  435720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  435731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  435734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435767 */     // MIs[1] Operand 1
     /*  435767 */     // No operand predicates
     /*  435767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435776 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  435776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435799 */     GIR_RootConstrainSelectedInstOperands,
     /*  435800 */     // GIR_Coverage, 3541,
     /*  435800 */     GIR_EraseRootFromParent_Done,
     /*  435801 */   // Label 7602: @435801
     /*  435801 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(435887), // Rule ID 3544 //
     /*  435806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  435817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  435820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  435823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435853 */     // MIs[1] Operand 1
     /*  435853 */     // No operand predicates
     /*  435853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435862 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  435862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435885 */     GIR_RootConstrainSelectedInstOperands,
     /*  435886 */     // GIR_Coverage, 3544,
     /*  435886 */     GIR_EraseRootFromParent_Done,
     /*  435887 */   // Label 7603: @435887
     /*  435887 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(435973), // Rule ID 3545 //
     /*  435892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  435903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  435906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  435909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435939 */     // MIs[1] Operand 1
     /*  435939 */     // No operand predicates
     /*  435939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  435948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435971 */     GIR_RootConstrainSelectedInstOperands,
     /*  435972 */     // GIR_Coverage, 3545,
     /*  435972 */     GIR_EraseRootFromParent_Done,
     /*  435973 */   // Label 7604: @435973
     /*  435973 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(436059), // Rule ID 3548 //
     /*  435978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  435981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  435989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  435992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  435995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436025 */     // MIs[1] Operand 1
     /*  436025 */     // No operand predicates
     /*  436025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436034 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  436034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  436037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  436054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436057 */     GIR_RootConstrainSelectedInstOperands,
     /*  436058 */     // GIR_Coverage, 3548,
     /*  436058 */     GIR_EraseRootFromParent_Done,
     /*  436059 */   // Label 7605: @436059
     /*  436059 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(436145), // Rule ID 3549 //
     /*  436064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  436067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  436075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  436078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  436081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436111 */     // MIs[1] Operand 1
     /*  436111 */     // No operand predicates
     /*  436111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  436120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  436123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  436140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436143 */     GIR_RootConstrainSelectedInstOperands,
     /*  436144 */     // GIR_Coverage, 3549,
     /*  436144 */     GIR_EraseRootFromParent_Done,
     /*  436145 */   // Label 7606: @436145
     /*  436145 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(436231), // Rule ID 3552 //
     /*  436150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  436161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  436164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  436167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436197 */     // MIs[1] Operand 1
     /*  436197 */     // No operand predicates
     /*  436197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436206 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  436206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436229 */     GIR_RootConstrainSelectedInstOperands,
     /*  436230 */     // GIR_Coverage, 3552,
     /*  436230 */     GIR_EraseRootFromParent_Done,
     /*  436231 */   // Label 7607: @436231
     /*  436231 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(436317), // Rule ID 3553 //
     /*  436236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  436247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  436250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  436253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436283 */     // MIs[1] Operand 1
     /*  436283 */     // No operand predicates
     /*  436283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436292 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436315 */     GIR_RootConstrainSelectedInstOperands,
     /*  436316 */     // GIR_Coverage, 3553,
     /*  436316 */     GIR_EraseRootFromParent_Done,
     /*  436317 */   // Label 7608: @436317
     /*  436317 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(436403), // Rule ID 3556 //
     /*  436322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  436333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  436336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  436339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436369 */     // MIs[1] Operand 1
     /*  436369 */     // No operand predicates
     /*  436369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436378 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  436378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436401 */     GIR_RootConstrainSelectedInstOperands,
     /*  436402 */     // GIR_Coverage, 3556,
     /*  436402 */     GIR_EraseRootFromParent_Done,
     /*  436403 */   // Label 7609: @436403
     /*  436403 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(436489), // Rule ID 3557 //
     /*  436408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  436419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  436422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  436425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436455 */     // MIs[1] Operand 1
     /*  436455 */     // No operand predicates
     /*  436455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436464 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436487 */     GIR_RootConstrainSelectedInstOperands,
     /*  436488 */     // GIR_Coverage, 3557,
     /*  436488 */     GIR_EraseRootFromParent_Done,
     /*  436489 */   // Label 7610: @436489
     /*  436489 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(436575), // Rule ID 3560 //
     /*  436494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  436505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  436508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  436511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436541 */     // MIs[1] Operand 1
     /*  436541 */     // No operand predicates
     /*  436541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436550 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  436550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436573 */     GIR_RootConstrainSelectedInstOperands,
     /*  436574 */     // GIR_Coverage, 3560,
     /*  436574 */     GIR_EraseRootFromParent_Done,
     /*  436575 */   // Label 7611: @436575
     /*  436575 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(436661), // Rule ID 3561 //
     /*  436580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  436591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  436594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  436597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436627 */     // MIs[1] Operand 1
     /*  436627 */     // No operand predicates
     /*  436627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436636 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436659 */     GIR_RootConstrainSelectedInstOperands,
     /*  436660 */     // GIR_Coverage, 3561,
     /*  436660 */     GIR_EraseRootFromParent_Done,
     /*  436661 */   // Label 7612: @436661
     /*  436661 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(436747), // Rule ID 3564 //
     /*  436666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  436683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436713 */     // MIs[1] Operand 1
     /*  436713 */     // No operand predicates
     /*  436713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436722 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436745 */     GIR_RootConstrainSelectedInstOperands,
     /*  436746 */     // GIR_Coverage, 3564,
     /*  436746 */     GIR_EraseRootFromParent_Done,
     /*  436747 */   // Label 7613: @436747
     /*  436747 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(436833), // Rule ID 3565 //
     /*  436752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  436769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436799 */     // MIs[1] Operand 1
     /*  436799 */     // No operand predicates
     /*  436799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436808 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436831 */     GIR_RootConstrainSelectedInstOperands,
     /*  436832 */     // GIR_Coverage, 3565,
     /*  436832 */     GIR_EraseRootFromParent_Done,
     /*  436833 */   // Label 7614: @436833
     /*  436833 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(436919), // Rule ID 3568 //
     /*  436838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  436855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436885 */     // MIs[1] Operand 1
     /*  436885 */     // No operand predicates
     /*  436885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436894 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436917 */     GIR_RootConstrainSelectedInstOperands,
     /*  436918 */     // GIR_Coverage, 3568,
     /*  436918 */     GIR_EraseRootFromParent_Done,
     /*  436919 */   // Label 7615: @436919
     /*  436919 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(437005), // Rule ID 3569 //
     /*  436924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  436941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436971 */     // MIs[1] Operand 1
     /*  436971 */     // No operand predicates
     /*  436971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436980 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  437000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437003 */     GIR_RootConstrainSelectedInstOperands,
     /*  437004 */     // GIR_Coverage, 3569,
     /*  437004 */     GIR_EraseRootFromParent_Done,
     /*  437005 */   // Label 7616: @437005
     /*  437005 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(437091), // Rule ID 3572 //
     /*  437010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  437021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  437024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  437027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437057 */     // MIs[1] Operand 1
     /*  437057 */     // No operand predicates
     /*  437057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437066 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  437066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  437086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437089 */     GIR_RootConstrainSelectedInstOperands,
     /*  437090 */     // GIR_Coverage, 3572,
     /*  437090 */     GIR_EraseRootFromParent_Done,
     /*  437091 */   // Label 7617: @437091
     /*  437091 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(437177), // Rule ID 3573 //
     /*  437096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  437107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  437110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  437113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437143 */     // MIs[1] Operand 1
     /*  437143 */     // No operand predicates
     /*  437143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437152 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  437152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  437172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437175 */     GIR_RootConstrainSelectedInstOperands,
     /*  437176 */     // GIR_Coverage, 3573,
     /*  437176 */     GIR_EraseRootFromParent_Done,
     /*  437177 */   // Label 7618: @437177
     /*  437177 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(437263), // Rule ID 3576 //
     /*  437182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  437193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  437196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  437199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437229 */     // MIs[1] Operand 1
     /*  437229 */     // No operand predicates
     /*  437229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437238 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  437238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  437241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437261 */     GIR_RootConstrainSelectedInstOperands,
     /*  437262 */     // GIR_Coverage, 3576,
     /*  437262 */     GIR_EraseRootFromParent_Done,
     /*  437263 */   // Label 7619: @437263
     /*  437263 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(437349), // Rule ID 3577 //
     /*  437268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  437279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  437282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  437285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437315 */     // MIs[1] Operand 1
     /*  437315 */     // No operand predicates
     /*  437315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  437327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437347 */     GIR_RootConstrainSelectedInstOperands,
     /*  437348 */     // GIR_Coverage, 3577,
     /*  437348 */     GIR_EraseRootFromParent_Done,
     /*  437349 */   // Label 7620: @437349
     /*  437349 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(437435), // Rule ID 3580 //
     /*  437354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  437365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  437368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  437371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437401 */     // MIs[1] Operand 1
     /*  437401 */     // No operand predicates
     /*  437401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437410 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  437410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437433 */     GIR_RootConstrainSelectedInstOperands,
     /*  437434 */     // GIR_Coverage, 3580,
     /*  437434 */     GIR_EraseRootFromParent_Done,
     /*  437435 */   // Label 7621: @437435
     /*  437435 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(437521), // Rule ID 3581 //
     /*  437440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  437451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  437454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  437457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437487 */     // MIs[1] Operand 1
     /*  437487 */     // No operand predicates
     /*  437487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437519 */     GIR_RootConstrainSelectedInstOperands,
     /*  437520 */     // GIR_Coverage, 3581,
     /*  437520 */     GIR_EraseRootFromParent_Done,
     /*  437521 */   // Label 7622: @437521
     /*  437521 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(437607), // Rule ID 3584 //
     /*  437526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  437537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  437540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  437543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437573 */     // MIs[1] Operand 1
     /*  437573 */     // No operand predicates
     /*  437573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437582 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  437582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437605 */     GIR_RootConstrainSelectedInstOperands,
     /*  437606 */     // GIR_Coverage, 3584,
     /*  437606 */     GIR_EraseRootFromParent_Done,
     /*  437607 */   // Label 7623: @437607
     /*  437607 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(437693), // Rule ID 3585 //
     /*  437612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  437623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  437626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  437629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437659 */     // MIs[1] Operand 1
     /*  437659 */     // No operand predicates
     /*  437659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437668 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437691 */     GIR_RootConstrainSelectedInstOperands,
     /*  437692 */     // GIR_Coverage, 3585,
     /*  437692 */     GIR_EraseRootFromParent_Done,
     /*  437693 */   // Label 7624: @437693
     /*  437693 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(437779), // Rule ID 3588 //
     /*  437698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  437709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  437712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  437715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437745 */     // MIs[1] Operand 1
     /*  437745 */     // No operand predicates
     /*  437745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437754 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  437757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437777 */     GIR_RootConstrainSelectedInstOperands,
     /*  437778 */     // GIR_Coverage, 3588,
     /*  437778 */     GIR_EraseRootFromParent_Done,
     /*  437779 */   // Label 7625: @437779
     /*  437779 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(437865), // Rule ID 3589 //
     /*  437784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  437795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  437798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  437801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437831 */     // MIs[1] Operand 1
     /*  437831 */     // No operand predicates
     /*  437831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437840 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  437843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437863 */     GIR_RootConstrainSelectedInstOperands,
     /*  437864 */     // GIR_Coverage, 3589,
     /*  437864 */     GIR_EraseRootFromParent_Done,
     /*  437865 */   // Label 7626: @437865
     /*  437865 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(437951), // Rule ID 3592 //
     /*  437870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  437881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  437884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437917 */     // MIs[1] Operand 1
     /*  437917 */     // No operand predicates
     /*  437917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437926 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437949 */     GIR_RootConstrainSelectedInstOperands,
     /*  437950 */     // GIR_Coverage, 3592,
     /*  437950 */     GIR_EraseRootFromParent_Done,
     /*  437951 */   // Label 7627: @437951
     /*  437951 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(438037), // Rule ID 3593 //
     /*  437956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  437967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  437970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438003 */     // MIs[1] Operand 1
     /*  438003 */     // No operand predicates
     /*  438003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438012 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  438012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  438015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  438032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438035 */     GIR_RootConstrainSelectedInstOperands,
     /*  438036 */     // GIR_Coverage, 3593,
     /*  438036 */     GIR_EraseRootFromParent_Done,
     /*  438037 */   // Label 7628: @438037
     /*  438037 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(438123), // Rule ID 3596 //
     /*  438042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  438045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  438053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  438056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  438059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438089 */     // MIs[1] Operand 1
     /*  438089 */     // No operand predicates
     /*  438089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438098 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  438098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  438101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  438118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438121 */     GIR_RootConstrainSelectedInstOperands,
     /*  438122 */     // GIR_Coverage, 3596,
     /*  438122 */     GIR_EraseRootFromParent_Done,
     /*  438123 */   // Label 7629: @438123
     /*  438123 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(438209), // Rule ID 3597 //
     /*  438128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  438131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  438139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  438142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  438145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438175 */     // MIs[1] Operand 1
     /*  438175 */     // No operand predicates
     /*  438175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  438184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  438187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  438204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438207 */     GIR_RootConstrainSelectedInstOperands,
     /*  438208 */     // GIR_Coverage, 3597,
     /*  438208 */     GIR_EraseRootFromParent_Done,
     /*  438209 */   // Label 7630: @438209
     /*  438209 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(438295), // Rule ID 5960 //
     /*  438214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  438225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  438228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  438231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438261 */     // MIs[1] Operand 1
     /*  438261 */     // No operand predicates
     /*  438261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438270 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  438273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438293 */     GIR_RootConstrainSelectedInstOperands,
     /*  438294 */     // GIR_Coverage, 5960,
     /*  438294 */     GIR_EraseRootFromParent_Done,
     /*  438295 */   // Label 7631: @438295
     /*  438295 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(438381), // Rule ID 5961 //
     /*  438300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  438311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  438314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  438317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438347 */     // MIs[1] Operand 1
     /*  438347 */     // No operand predicates
     /*  438347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438356 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  438359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438379 */     GIR_RootConstrainSelectedInstOperands,
     /*  438380 */     // GIR_Coverage, 5961,
     /*  438380 */     GIR_EraseRootFromParent_Done,
     /*  438381 */   // Label 7632: @438381
     /*  438381 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(438467), // Rule ID 5964 //
     /*  438386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  438397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  438400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  438403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438433 */     // MIs[1] Operand 1
     /*  438433 */     // No operand predicates
     /*  438433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438442 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438465 */     GIR_RootConstrainSelectedInstOperands,
     /*  438466 */     // GIR_Coverage, 5964,
     /*  438466 */     GIR_EraseRootFromParent_Done,
     /*  438467 */   // Label 7633: @438467
     /*  438467 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(438553), // Rule ID 5965 //
     /*  438472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  438483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  438486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  438489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438519 */     // MIs[1] Operand 1
     /*  438519 */     // No operand predicates
     /*  438519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438528 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438551 */     GIR_RootConstrainSelectedInstOperands,
     /*  438552 */     // GIR_Coverage, 5965,
     /*  438552 */     GIR_EraseRootFromParent_Done,
     /*  438553 */   // Label 7634: @438553
     /*  438553 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(438639), // Rule ID 5968 //
     /*  438558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  438569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  438572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  438575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438605 */     // MIs[1] Operand 1
     /*  438605 */     // No operand predicates
     /*  438605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438614 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438637 */     GIR_RootConstrainSelectedInstOperands,
     /*  438638 */     // GIR_Coverage, 5968,
     /*  438638 */     GIR_EraseRootFromParent_Done,
     /*  438639 */   // Label 7635: @438639
     /*  438639 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(438725), // Rule ID 5969 //
     /*  438644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  438655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  438658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  438661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438691 */     // MIs[1] Operand 1
     /*  438691 */     // No operand predicates
     /*  438691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438700 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438723 */     GIR_RootConstrainSelectedInstOperands,
     /*  438724 */     // GIR_Coverage, 5969,
     /*  438724 */     GIR_EraseRootFromParent_Done,
     /*  438725 */   // Label 7636: @438725
     /*  438725 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(438811), // Rule ID 5972 //
     /*  438730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  438747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438777 */     // MIs[1] Operand 1
     /*  438777 */     // No operand predicates
     /*  438777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438809 */     GIR_RootConstrainSelectedInstOperands,
     /*  438810 */     // GIR_Coverage, 5972,
     /*  438810 */     GIR_EraseRootFromParent_Done,
     /*  438811 */   // Label 7637: @438811
     /*  438811 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(438897), // Rule ID 5973 //
     /*  438816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  438833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438863 */     // MIs[1] Operand 1
     /*  438863 */     // No operand predicates
     /*  438863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438895 */     GIR_RootConstrainSelectedInstOperands,
     /*  438896 */     // GIR_Coverage, 5973,
     /*  438896 */     GIR_EraseRootFromParent_Done,
     /*  438897 */   // Label 7638: @438897
     /*  438897 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(438983), // Rule ID 5976 //
     /*  438902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  438919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438949 */     // MIs[1] Operand 1
     /*  438949 */     // No operand predicates
     /*  438949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438981 */     GIR_RootConstrainSelectedInstOperands,
     /*  438982 */     // GIR_Coverage, 5976,
     /*  438982 */     GIR_EraseRootFromParent_Done,
     /*  438983 */   // Label 7639: @438983
     /*  438983 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(439069), // Rule ID 5977 //
     /*  438988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  439002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  439005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439035 */     // MIs[1] Operand 1
     /*  439035 */     // No operand predicates
     /*  439035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439044 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  439047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439067 */     GIR_RootConstrainSelectedInstOperands,
     /*  439068 */     // GIR_Coverage, 5977,
     /*  439068 */     GIR_EraseRootFromParent_Done,
     /*  439069 */   // Label 7640: @439069
     /*  439069 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(439155), // Rule ID 5980 //
     /*  439074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  439085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  439088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  439091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439121 */     // MIs[1] Operand 1
     /*  439121 */     // No operand predicates
     /*  439121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439130 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  439130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  439133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439153 */     GIR_RootConstrainSelectedInstOperands,
     /*  439154 */     // GIR_Coverage, 5980,
     /*  439154 */     GIR_EraseRootFromParent_Done,
     /*  439155 */   // Label 7641: @439155
     /*  439155 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(439241), // Rule ID 5981 //
     /*  439160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  439171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  439174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  439177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439207 */     // MIs[1] Operand 1
     /*  439207 */     // No operand predicates
     /*  439207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439216 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  439216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  439219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439239 */     GIR_RootConstrainSelectedInstOperands,
     /*  439240 */     // GIR_Coverage, 5981,
     /*  439240 */     GIR_EraseRootFromParent_Done,
     /*  439241 */   // Label 7642: @439241
     /*  439241 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(439327), // Rule ID 5984 //
     /*  439246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  439257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  439260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  439263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439293 */     // MIs[1] Operand 1
     /*  439293 */     // No operand predicates
     /*  439293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439325 */     GIR_RootConstrainSelectedInstOperands,
     /*  439326 */     // GIR_Coverage, 5984,
     /*  439326 */     GIR_EraseRootFromParent_Done,
     /*  439327 */   // Label 7643: @439327
     /*  439327 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(439413), // Rule ID 5985 //
     /*  439332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  439343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  439346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  439349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439379 */     // MIs[1] Operand 1
     /*  439379 */     // No operand predicates
     /*  439379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439388 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439411 */     GIR_RootConstrainSelectedInstOperands,
     /*  439412 */     // GIR_Coverage, 5985,
     /*  439412 */     GIR_EraseRootFromParent_Done,
     /*  439413 */   // Label 7644: @439413
     /*  439413 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(439499), // Rule ID 5988 //
     /*  439418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  439429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  439432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  439435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439465 */     // MIs[1] Operand 1
     /*  439465 */     // No operand predicates
     /*  439465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439474 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439497 */     GIR_RootConstrainSelectedInstOperands,
     /*  439498 */     // GIR_Coverage, 5988,
     /*  439498 */     GIR_EraseRootFromParent_Done,
     /*  439499 */   // Label 7645: @439499
     /*  439499 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(439585), // Rule ID 5989 //
     /*  439504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  439515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  439518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  439521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439551 */     // MIs[1] Operand 1
     /*  439551 */     // No operand predicates
     /*  439551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439560 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439583 */     GIR_RootConstrainSelectedInstOperands,
     /*  439584 */     // GIR_Coverage, 5989,
     /*  439584 */     GIR_EraseRootFromParent_Done,
     /*  439585 */   // Label 7646: @439585
     /*  439585 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(439671), // Rule ID 5992 //
     /*  439590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  439601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439637 */     // MIs[1] Operand 1
     /*  439637 */     // No operand predicates
     /*  439637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439646 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  439646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439669 */     GIR_RootConstrainSelectedInstOperands,
     /*  439670 */     // GIR_Coverage, 5992,
     /*  439670 */     GIR_EraseRootFromParent_Done,
     /*  439671 */   // Label 7647: @439671
     /*  439671 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(439757), // Rule ID 5993 //
     /*  439676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  439687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439723 */     // MIs[1] Operand 1
     /*  439723 */     // No operand predicates
     /*  439723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439732 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  439732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439755 */     GIR_RootConstrainSelectedInstOperands,
     /*  439756 */     // GIR_Coverage, 5993,
     /*  439756 */     GIR_EraseRootFromParent_Done,
     /*  439757 */   // Label 7648: @439757
     /*  439757 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(439843), // Rule ID 5996 //
     /*  439762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  439765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  439773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  439776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  439779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439809 */     // MIs[1] Operand 1
     /*  439809 */     // No operand predicates
     /*  439809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439818 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  439818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  439838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439841 */     GIR_RootConstrainSelectedInstOperands,
     /*  439842 */     // GIR_Coverage, 5996,
     /*  439842 */     GIR_EraseRootFromParent_Done,
     /*  439843 */   // Label 7649: @439843
     /*  439843 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(439929), // Rule ID 5997 //
     /*  439848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  439851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  439859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  439862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  439865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439895 */     // MIs[1] Operand 1
     /*  439895 */     // No operand predicates
     /*  439895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439904 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  439904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  439924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439927 */     GIR_RootConstrainSelectedInstOperands,
     /*  439928 */     // GIR_Coverage, 5997,
     /*  439928 */     GIR_EraseRootFromParent_Done,
     /*  439929 */   // Label 7650: @439929
     /*  439929 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(440015), // Rule ID 6000 //
     /*  439934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  439945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  439948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  439951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439981 */     // MIs[1] Operand 1
     /*  439981 */     // No operand predicates
     /*  439981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439990 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  439993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440013 */     GIR_RootConstrainSelectedInstOperands,
     /*  440014 */     // GIR_Coverage, 6000,
     /*  440014 */     GIR_EraseRootFromParent_Done,
     /*  440015 */   // Label 7651: @440015
     /*  440015 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(440101), // Rule ID 6001 //
     /*  440020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  440031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  440034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  440037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440067 */     // MIs[1] Operand 1
     /*  440067 */     // No operand predicates
     /*  440067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440076 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  440076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440099 */     GIR_RootConstrainSelectedInstOperands,
     /*  440100 */     // GIR_Coverage, 6001,
     /*  440100 */     GIR_EraseRootFromParent_Done,
     /*  440101 */   // Label 7652: @440101
     /*  440101 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(440187), // Rule ID 6004 //
     /*  440106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  440117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  440120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  440123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440153 */     // MIs[1] Operand 1
     /*  440153 */     // No operand predicates
     /*  440153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440162 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  440162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440185 */     GIR_RootConstrainSelectedInstOperands,
     /*  440186 */     // GIR_Coverage, 6004,
     /*  440186 */     GIR_EraseRootFromParent_Done,
     /*  440187 */   // Label 7653: @440187
     /*  440187 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(440273), // Rule ID 6005 //
     /*  440192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  440203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  440206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  440209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440239 */     // MIs[1] Operand 1
     /*  440239 */     // No operand predicates
     /*  440239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440248 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  440248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440271 */     GIR_RootConstrainSelectedInstOperands,
     /*  440272 */     // GIR_Coverage, 6005,
     /*  440272 */     GIR_EraseRootFromParent_Done,
     /*  440273 */   // Label 7654: @440273
     /*  440273 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(440359), // Rule ID 6008 //
     /*  440278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  440289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  440292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  440295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440325 */     // MIs[1] Operand 1
     /*  440325 */     // No operand predicates
     /*  440325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440334 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  440334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440357 */     GIR_RootConstrainSelectedInstOperands,
     /*  440358 */     // GIR_Coverage, 6008,
     /*  440358 */     GIR_EraseRootFromParent_Done,
     /*  440359 */   // Label 7655: @440359
     /*  440359 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(440445), // Rule ID 6009 //
     /*  440364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  440375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  440378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  440381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440411 */     // MIs[1] Operand 1
     /*  440411 */     // No operand predicates
     /*  440411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440420 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  440420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440443 */     GIR_RootConstrainSelectedInstOperands,
     /*  440444 */     // GIR_Coverage, 6009,
     /*  440444 */     GIR_EraseRootFromParent_Done,
     /*  440445 */   // Label 7656: @440445
     /*  440445 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(440531), // Rule ID 6012 //
     /*  440450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  440461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  440464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  440467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440497 */     // MIs[1] Operand 1
     /*  440497 */     // No operand predicates
     /*  440497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440529 */     GIR_RootConstrainSelectedInstOperands,
     /*  440530 */     // GIR_Coverage, 6012,
     /*  440530 */     GIR_EraseRootFromParent_Done,
     /*  440531 */   // Label 7657: @440531
     /*  440531 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(440617), // Rule ID 6013 //
     /*  440536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  440547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  440550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  440553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440583 */     // MIs[1] Operand 1
     /*  440583 */     // No operand predicates
     /*  440583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440592 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440615 */     GIR_RootConstrainSelectedInstOperands,
     /*  440616 */     // GIR_Coverage, 6013,
     /*  440616 */     GIR_EraseRootFromParent_Done,
     /*  440617 */   // Label 7658: @440617
     /*  440617 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(440703), // Rule ID 6016 //
     /*  440622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  440633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  440636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  440639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440669 */     // MIs[1] Operand 1
     /*  440669 */     // No operand predicates
     /*  440669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440678 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440701 */     GIR_RootConstrainSelectedInstOperands,
     /*  440702 */     // GIR_Coverage, 6016,
     /*  440702 */     GIR_EraseRootFromParent_Done,
     /*  440703 */   // Label 7659: @440703
     /*  440703 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(440789), // Rule ID 6017 //
     /*  440708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  440719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  440722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  440725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440755 */     // MIs[1] Operand 1
     /*  440755 */     // No operand predicates
     /*  440755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440764 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440787 */     GIR_RootConstrainSelectedInstOperands,
     /*  440788 */     // GIR_Coverage, 6017,
     /*  440788 */     GIR_EraseRootFromParent_Done,
     /*  440789 */   // Label 7660: @440789
     /*  440789 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(440875), // Rule ID 6020 //
     /*  440794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  440805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  440808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  440811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440841 */     // MIs[1] Operand 1
     /*  440841 */     // No operand predicates
     /*  440841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440850 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440873 */     GIR_RootConstrainSelectedInstOperands,
     /*  440874 */     // GIR_Coverage, 6020,
     /*  440874 */     GIR_EraseRootFromParent_Done,
     /*  440875 */   // Label 7661: @440875
     /*  440875 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(440961), // Rule ID 6021 //
     /*  440880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  440891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  440894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  440897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440927 */     // MIs[1] Operand 1
     /*  440927 */     // No operand predicates
     /*  440927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440936 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440959 */     GIR_RootConstrainSelectedInstOperands,
     /*  440960 */     // GIR_Coverage, 6021,
     /*  440960 */     GIR_EraseRootFromParent_Done,
     /*  440961 */   // Label 7662: @440961
     /*  440961 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(441047), // Rule ID 6024 //
     /*  440966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441013 */     // MIs[1] Operand 1
     /*  441013 */     // No operand predicates
     /*  441013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441022 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  441022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  441025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441045 */     GIR_RootConstrainSelectedInstOperands,
     /*  441046 */     // GIR_Coverage, 6024,
     /*  441046 */     GIR_EraseRootFromParent_Done,
     /*  441047 */   // Label 7663: @441047
     /*  441047 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(441133), // Rule ID 6025 //
     /*  441052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  441063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  441066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  441069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441099 */     // MIs[1] Operand 1
     /*  441099 */     // No operand predicates
     /*  441099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441108 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  441108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  441111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441131 */     GIR_RootConstrainSelectedInstOperands,
     /*  441132 */     // GIR_Coverage, 6025,
     /*  441132 */     GIR_EraseRootFromParent_Done,
     /*  441133 */   // Label 7664: @441133
     /*  441133 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(441219), // Rule ID 6028 //
     /*  441138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  441149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  441152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  441155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441185 */     // MIs[1] Operand 1
     /*  441185 */     // No operand predicates
     /*  441185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441194 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  441194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  441197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441217 */     GIR_RootConstrainSelectedInstOperands,
     /*  441218 */     // GIR_Coverage, 6028,
     /*  441218 */     GIR_EraseRootFromParent_Done,
     /*  441219 */   // Label 7665: @441219
     /*  441219 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(441305), // Rule ID 6029 //
     /*  441224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  441235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  441238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  441241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441271 */     // MIs[1] Operand 1
     /*  441271 */     // No operand predicates
     /*  441271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441280 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  441280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  441283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441303 */     GIR_RootConstrainSelectedInstOperands,
     /*  441304 */     // GIR_Coverage, 6029,
     /*  441304 */     GIR_EraseRootFromParent_Done,
     /*  441305 */   // Label 7666: @441305
     /*  441305 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(441391), // Rule ID 6032 //
     /*  441310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  441321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  441324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  441327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441357 */     // MIs[1] Operand 1
     /*  441357 */     // No operand predicates
     /*  441357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441366 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  441366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  441369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441389 */     GIR_RootConstrainSelectedInstOperands,
     /*  441390 */     // GIR_Coverage, 6032,
     /*  441390 */     GIR_EraseRootFromParent_Done,
     /*  441391 */   // Label 7667: @441391
     /*  441391 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(441477), // Rule ID 6033 //
     /*  441396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  441407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  441410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  441413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441443 */     // MIs[1] Operand 1
     /*  441443 */     // No operand predicates
     /*  441443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441452 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  441452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  441455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441475 */     GIR_RootConstrainSelectedInstOperands,
     /*  441476 */     // GIR_Coverage, 6033,
     /*  441476 */     GIR_EraseRootFromParent_Done,
     /*  441477 */   // Label 7668: @441477
     /*  441477 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(441563), // Rule ID 6036 //
     /*  441482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  441493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  441496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441529 */     // MIs[1] Operand 1
     /*  441529 */     // No operand predicates
     /*  441529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441538 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  441541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441561 */     GIR_RootConstrainSelectedInstOperands,
     /*  441562 */     // GIR_Coverage, 6036,
     /*  441562 */     GIR_EraseRootFromParent_Done,
     /*  441563 */   // Label 7669: @441563
     /*  441563 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(441649), // Rule ID 6037 //
     /*  441568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  441579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  441582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441615 */     // MIs[1] Operand 1
     /*  441615 */     // No operand predicates
     /*  441615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441624 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  441627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441647 */     GIR_RootConstrainSelectedInstOperands,
     /*  441648 */     // GIR_Coverage, 6037,
     /*  441648 */     GIR_EraseRootFromParent_Done,
     /*  441649 */   // Label 7670: @441649
     /*  441649 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(441735), // Rule ID 6040 //
     /*  441654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  441665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  441668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441701 */     // MIs[1] Operand 1
     /*  441701 */     // No operand predicates
     /*  441701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441710 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  441713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441733 */     GIR_RootConstrainSelectedInstOperands,
     /*  441734 */     // GIR_Coverage, 6040,
     /*  441734 */     GIR_EraseRootFromParent_Done,
     /*  441735 */   // Label 7671: @441735
     /*  441735 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(441821), // Rule ID 6041 //
     /*  441740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  441751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  441754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441787 */     // MIs[1] Operand 1
     /*  441787 */     // No operand predicates
     /*  441787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441796 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  441799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441819 */     GIR_RootConstrainSelectedInstOperands,
     /*  441820 */     // GIR_Coverage, 6041,
     /*  441820 */     GIR_EraseRootFromParent_Done,
     /*  441821 */   // Label 7672: @441821
     /*  441821 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(441907), // Rule ID 6044 //
     /*  441826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  441837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  441840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441873 */     // MIs[1] Operand 1
     /*  441873 */     // No operand predicates
     /*  441873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441882 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  441885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441905 */     GIR_RootConstrainSelectedInstOperands,
     /*  441906 */     // GIR_Coverage, 6044,
     /*  441906 */     GIR_EraseRootFromParent_Done,
     /*  441907 */   // Label 7673: @441907
     /*  441907 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(441993), // Rule ID 6045 //
     /*  441912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  441923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  441926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441959 */     // MIs[1] Operand 1
     /*  441959 */     // No operand predicates
     /*  441959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  441971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441991 */     GIR_RootConstrainSelectedInstOperands,
     /*  441992 */     // GIR_Coverage, 6045,
     /*  441992 */     GIR_EraseRootFromParent_Done,
     /*  441993 */   // Label 7674: @441993
     /*  441993 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(442079), // Rule ID 6224 //
     /*  441998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  442009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  442012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  442015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442045 */     // MIs[1] Operand 1
     /*  442045 */     // No operand predicates
     /*  442045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442054 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  442057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442077 */     GIR_RootConstrainSelectedInstOperands,
     /*  442078 */     // GIR_Coverage, 6224,
     /*  442078 */     GIR_EraseRootFromParent_Done,
     /*  442079 */   // Label 7675: @442079
     /*  442079 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(442165), // Rule ID 6225 //
     /*  442084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  442095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  442098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  442101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442131 */     // MIs[1] Operand 1
     /*  442131 */     // No operand predicates
     /*  442131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  442143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442163 */     GIR_RootConstrainSelectedInstOperands,
     /*  442164 */     // GIR_Coverage, 6225,
     /*  442164 */     GIR_EraseRootFromParent_Done,
     /*  442165 */   // Label 7676: @442165
     /*  442165 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(442251), // Rule ID 6228 //
     /*  442170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  442181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  442184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  442187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442217 */     // MIs[1] Operand 1
     /*  442217 */     // No operand predicates
     /*  442217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442226 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  442229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442249 */     GIR_RootConstrainSelectedInstOperands,
     /*  442250 */     // GIR_Coverage, 6228,
     /*  442250 */     GIR_EraseRootFromParent_Done,
     /*  442251 */   // Label 7677: @442251
     /*  442251 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(442337), // Rule ID 6229 //
     /*  442256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  442267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  442270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  442273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442303 */     // MIs[1] Operand 1
     /*  442303 */     // No operand predicates
     /*  442303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442312 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  442315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442335 */     GIR_RootConstrainSelectedInstOperands,
     /*  442336 */     // GIR_Coverage, 6229,
     /*  442336 */     GIR_EraseRootFromParent_Done,
     /*  442337 */   // Label 7678: @442337
     /*  442337 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(442423), // Rule ID 6232 //
     /*  442342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  442353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  442356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  442359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442389 */     // MIs[1] Operand 1
     /*  442389 */     // No operand predicates
     /*  442389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442398 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442421 */     GIR_RootConstrainSelectedInstOperands,
     /*  442422 */     // GIR_Coverage, 6232,
     /*  442422 */     GIR_EraseRootFromParent_Done,
     /*  442423 */   // Label 7679: @442423
     /*  442423 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(442509), // Rule ID 6233 //
     /*  442428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  442439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  442442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  442445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442475 */     // MIs[1] Operand 1
     /*  442475 */     // No operand predicates
     /*  442475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442484 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442507 */     GIR_RootConstrainSelectedInstOperands,
     /*  442508 */     // GIR_Coverage, 6233,
     /*  442508 */     GIR_EraseRootFromParent_Done,
     /*  442509 */   // Label 7680: @442509
     /*  442509 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(442595), // Rule ID 6236 //
     /*  442514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  442531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442561 */     // MIs[1] Operand 1
     /*  442561 */     // No operand predicates
     /*  442561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442570 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  442573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442593 */     GIR_RootConstrainSelectedInstOperands,
     /*  442594 */     // GIR_Coverage, 6236,
     /*  442594 */     GIR_EraseRootFromParent_Done,
     /*  442595 */   // Label 7681: @442595
     /*  442595 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(442681), // Rule ID 6237 //
     /*  442600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  442617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442647 */     // MIs[1] Operand 1
     /*  442647 */     // No operand predicates
     /*  442647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442656 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  442659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442679 */     GIR_RootConstrainSelectedInstOperands,
     /*  442680 */     // GIR_Coverage, 6237,
     /*  442680 */     GIR_EraseRootFromParent_Done,
     /*  442681 */   // Label 7682: @442681
     /*  442681 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(442767), // Rule ID 6240 //
     /*  442686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  442703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442733 */     // MIs[1] Operand 1
     /*  442733 */     // No operand predicates
     /*  442733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442742 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442765 */     GIR_RootConstrainSelectedInstOperands,
     /*  442766 */     // GIR_Coverage, 6240,
     /*  442766 */     GIR_EraseRootFromParent_Done,
     /*  442767 */   // Label 7683: @442767
     /*  442767 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(442853), // Rule ID 6241 //
     /*  442772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  442789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442819 */     // MIs[1] Operand 1
     /*  442819 */     // No operand predicates
     /*  442819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442828 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442851 */     GIR_RootConstrainSelectedInstOperands,
     /*  442852 */     // GIR_Coverage, 6241,
     /*  442852 */     GIR_EraseRootFromParent_Done,
     /*  442853 */   // Label 7684: @442853
     /*  442853 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(442939), // Rule ID 6244 //
     /*  442858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  442869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  442872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442905 */     // MIs[1] Operand 1
     /*  442905 */     // No operand predicates
     /*  442905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442914 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  442914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442937 */     GIR_RootConstrainSelectedInstOperands,
     /*  442938 */     // GIR_Coverage, 6244,
     /*  442938 */     GIR_EraseRootFromParent_Done,
     /*  442939 */   // Label 7685: @442939
     /*  442939 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(443025), // Rule ID 6245 //
     /*  442944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  442955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  442958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442991 */     // MIs[1] Operand 1
     /*  442991 */     // No operand predicates
     /*  442991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  443000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  443003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443023 */     GIR_RootConstrainSelectedInstOperands,
     /*  443024 */     // GIR_Coverage, 6245,
     /*  443024 */     GIR_EraseRootFromParent_Done,
     /*  443025 */   // Label 7686: @443025
     /*  443025 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(443111), // Rule ID 6248 //
     /*  443030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  443041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  443044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  443047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443077 */     // MIs[1] Operand 1
     /*  443077 */     // No operand predicates
     /*  443077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443086 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443109 */     GIR_RootConstrainSelectedInstOperands,
     /*  443110 */     // GIR_Coverage, 6248,
     /*  443110 */     GIR_EraseRootFromParent_Done,
     /*  443111 */   // Label 7687: @443111
     /*  443111 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(443197), // Rule ID 6249 //
     /*  443116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  443127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  443130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  443133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443163 */     // MIs[1] Operand 1
     /*  443163 */     // No operand predicates
     /*  443163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443172 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443195 */     GIR_RootConstrainSelectedInstOperands,
     /*  443196 */     // GIR_Coverage, 6249,
     /*  443196 */     GIR_EraseRootFromParent_Done,
     /*  443197 */   // Label 7688: @443197
     /*  443197 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(443283), // Rule ID 6252 //
     /*  443202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  443213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  443216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  443219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443249 */     // MIs[1] Operand 1
     /*  443249 */     // No operand predicates
     /*  443249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443258 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  443258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443281 */     GIR_RootConstrainSelectedInstOperands,
     /*  443282 */     // GIR_Coverage, 6252,
     /*  443282 */     GIR_EraseRootFromParent_Done,
     /*  443283 */   // Label 7689: @443283
     /*  443283 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(443369), // Rule ID 6253 //
     /*  443288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  443299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  443302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  443305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443335 */     // MIs[1] Operand 1
     /*  443335 */     // No operand predicates
     /*  443335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443344 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  443344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443367 */     GIR_RootConstrainSelectedInstOperands,
     /*  443368 */     // GIR_Coverage, 6253,
     /*  443368 */     GIR_EraseRootFromParent_Done,
     /*  443369 */   // Label 7690: @443369
     /*  443369 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(443455), // Rule ID 6256 //
     /*  443374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  443385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  443388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  443391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443421 */     // MIs[1] Operand 1
     /*  443421 */     // No operand predicates
     /*  443421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443430 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  443430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443453 */     GIR_RootConstrainSelectedInstOperands,
     /*  443454 */     // GIR_Coverage, 6256,
     /*  443454 */     GIR_EraseRootFromParent_Done,
     /*  443455 */   // Label 7691: @443455
     /*  443455 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(443541), // Rule ID 6257 //
     /*  443460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  443471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  443474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  443477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443507 */     // MIs[1] Operand 1
     /*  443507 */     // No operand predicates
     /*  443507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  443516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443539 */     GIR_RootConstrainSelectedInstOperands,
     /*  443540 */     // GIR_Coverage, 6257,
     /*  443540 */     GIR_EraseRootFromParent_Done,
     /*  443541 */   // Label 7692: @443541
     /*  443541 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(443627), // Rule ID 6260 //
     /*  443546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  443549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  443557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  443560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  443563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443593 */     // MIs[1] Operand 1
     /*  443593 */     // No operand predicates
     /*  443593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443602 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  443602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  443622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443625 */     GIR_RootConstrainSelectedInstOperands,
     /*  443626 */     // GIR_Coverage, 6260,
     /*  443626 */     GIR_EraseRootFromParent_Done,
     /*  443627 */   // Label 7693: @443627
     /*  443627 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(443713), // Rule ID 6261 //
     /*  443632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  443635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  443643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  443646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  443649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443679 */     // MIs[1] Operand 1
     /*  443679 */     // No operand predicates
     /*  443679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443688 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  443688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  443708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443711 */     GIR_RootConstrainSelectedInstOperands,
     /*  443712 */     // GIR_Coverage, 6261,
     /*  443712 */     GIR_EraseRootFromParent_Done,
     /*  443713 */   // Label 7694: @443713
     /*  443713 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(443799), // Rule ID 6264 //
     /*  443718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  443729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  443732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  443735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443765 */     // MIs[1] Operand 1
     /*  443765 */     // No operand predicates
     /*  443765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443774 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443797 */     GIR_RootConstrainSelectedInstOperands,
     /*  443798 */     // GIR_Coverage, 6264,
     /*  443798 */     GIR_EraseRootFromParent_Done,
     /*  443799 */   // Label 7695: @443799
     /*  443799 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(443885), // Rule ID 6265 //
     /*  443804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  443815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  443818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  443821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443851 */     // MIs[1] Operand 1
     /*  443851 */     // No operand predicates
     /*  443851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443860 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443883 */     GIR_RootConstrainSelectedInstOperands,
     /*  443884 */     // GIR_Coverage, 6265,
     /*  443884 */     GIR_EraseRootFromParent_Done,
     /*  443885 */   // Label 7696: @443885
     /*  443885 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(443971), // Rule ID 6268 //
     /*  443890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443937 */     // MIs[1] Operand 1
     /*  443937 */     // No operand predicates
     /*  443937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443946 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  443949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443969 */     GIR_RootConstrainSelectedInstOperands,
     /*  443970 */     // GIR_Coverage, 6268,
     /*  443970 */     GIR_EraseRootFromParent_Done,
     /*  443971 */   // Label 7697: @443971
     /*  443971 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(444057), // Rule ID 6269 //
     /*  443976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444023 */     // MIs[1] Operand 1
     /*  444023 */     // No operand predicates
     /*  444023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444032 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  444032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  444052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444055 */     GIR_RootConstrainSelectedInstOperands,
     /*  444056 */     // GIR_Coverage, 6269,
     /*  444056 */     GIR_EraseRootFromParent_Done,
     /*  444057 */   // Label 7698: @444057
     /*  444057 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(444143), // Rule ID 6272 //
     /*  444062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  444073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  444076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  444079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444109 */     // MIs[1] Operand 1
     /*  444109 */     // No operand predicates
     /*  444109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444118 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  444118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  444138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444141 */     GIR_RootConstrainSelectedInstOperands,
     /*  444142 */     // GIR_Coverage, 6272,
     /*  444142 */     GIR_EraseRootFromParent_Done,
     /*  444143 */   // Label 7699: @444143
     /*  444143 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(444229), // Rule ID 6273 //
     /*  444148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  444159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  444162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  444165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444195 */     // MIs[1] Operand 1
     /*  444195 */     // No operand predicates
     /*  444195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444204 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  444204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  444224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444227 */     GIR_RootConstrainSelectedInstOperands,
     /*  444228 */     // GIR_Coverage, 6273,
     /*  444228 */     GIR_EraseRootFromParent_Done,
     /*  444229 */   // Label 7700: @444229
     /*  444229 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(444315), // Rule ID 6276 //
     /*  444234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  444245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  444248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  444251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444281 */     // MIs[1] Operand 1
     /*  444281 */     // No operand predicates
     /*  444281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444290 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444313 */     GIR_RootConstrainSelectedInstOperands,
     /*  444314 */     // GIR_Coverage, 6276,
     /*  444314 */     GIR_EraseRootFromParent_Done,
     /*  444315 */   // Label 7701: @444315
     /*  444315 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(444401), // Rule ID 6277 //
     /*  444320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  444331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  444334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  444337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444367 */     // MIs[1] Operand 1
     /*  444367 */     // No operand predicates
     /*  444367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444399 */     GIR_RootConstrainSelectedInstOperands,
     /*  444400 */     // GIR_Coverage, 6277,
     /*  444400 */     GIR_EraseRootFromParent_Done,
     /*  444401 */   // Label 7702: @444401
     /*  444401 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(444487), // Rule ID 6280 //
     /*  444406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  444417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  444420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  444423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444453 */     // MIs[1] Operand 1
     /*  444453 */     // No operand predicates
     /*  444453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444462 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444485 */     GIR_RootConstrainSelectedInstOperands,
     /*  444486 */     // GIR_Coverage, 6280,
     /*  444486 */     GIR_EraseRootFromParent_Done,
     /*  444487 */   // Label 7703: @444487
     /*  444487 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(444573), // Rule ID 6281 //
     /*  444492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  444503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  444506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  444509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444539 */     // MIs[1] Operand 1
     /*  444539 */     // No operand predicates
     /*  444539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444548 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444571 */     GIR_RootConstrainSelectedInstOperands,
     /*  444572 */     // GIR_Coverage, 6281,
     /*  444572 */     GIR_EraseRootFromParent_Done,
     /*  444573 */   // Label 7704: @444573
     /*  444573 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(444659), // Rule ID 6284 //
     /*  444578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  444589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  444592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  444595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444625 */     // MIs[1] Operand 1
     /*  444625 */     // No operand predicates
     /*  444625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444634 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444657 */     GIR_RootConstrainSelectedInstOperands,
     /*  444658 */     // GIR_Coverage, 6284,
     /*  444658 */     GIR_EraseRootFromParent_Done,
     /*  444659 */   // Label 7705: @444659
     /*  444659 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(444745), // Rule ID 6285 //
     /*  444664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  444675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  444678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  444681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444711 */     // MIs[1] Operand 1
     /*  444711 */     // No operand predicates
     /*  444711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444720 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444743 */     GIR_RootConstrainSelectedInstOperands,
     /*  444744 */     // GIR_Coverage, 6285,
     /*  444744 */     GIR_EraseRootFromParent_Done,
     /*  444745 */   // Label 7706: @444745
     /*  444745 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(444831), // Rule ID 6288 //
     /*  444750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  444767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444797 */     // MIs[1] Operand 1
     /*  444797 */     // No operand predicates
     /*  444797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444806 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444829 */     GIR_RootConstrainSelectedInstOperands,
     /*  444830 */     // GIR_Coverage, 6288,
     /*  444830 */     GIR_EraseRootFromParent_Done,
     /*  444831 */   // Label 7707: @444831
     /*  444831 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(444917), // Rule ID 6289 //
     /*  444836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  444853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444883 */     // MIs[1] Operand 1
     /*  444883 */     // No operand predicates
     /*  444883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444915 */     GIR_RootConstrainSelectedInstOperands,
     /*  444916 */     // GIR_Coverage, 6289,
     /*  444916 */     GIR_EraseRootFromParent_Done,
     /*  444917 */   // Label 7708: @444917
     /*  444917 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(445003), // Rule ID 6292 //
     /*  444922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  444939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444969 */     // MIs[1] Operand 1
     /*  444969 */     // No operand predicates
     /*  444969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444978 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445001 */     GIR_RootConstrainSelectedInstOperands,
     /*  445002 */     // GIR_Coverage, 6292,
     /*  445002 */     GIR_EraseRootFromParent_Done,
     /*  445003 */   // Label 7709: @445003
     /*  445003 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(445089), // Rule ID 6293 //
     /*  445008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  445019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  445022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  445025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445055 */     // MIs[1] Operand 1
     /*  445055 */     // No operand predicates
     /*  445055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445064 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  445064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  445067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445087 */     GIR_RootConstrainSelectedInstOperands,
     /*  445088 */     // GIR_Coverage, 6293,
     /*  445088 */     GIR_EraseRootFromParent_Done,
     /*  445089 */   // Label 7710: @445089
     /*  445089 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(445175), // Rule ID 6296 //
     /*  445094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  445105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  445108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  445111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445141 */     // MIs[1] Operand 1
     /*  445141 */     // No operand predicates
     /*  445141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445150 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  445150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  445153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445173 */     GIR_RootConstrainSelectedInstOperands,
     /*  445174 */     // GIR_Coverage, 6296,
     /*  445174 */     GIR_EraseRootFromParent_Done,
     /*  445175 */   // Label 7711: @445175
     /*  445175 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(445261), // Rule ID 6297 //
     /*  445180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  445191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  445194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  445197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445227 */     // MIs[1] Operand 1
     /*  445227 */     // No operand predicates
     /*  445227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445236 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  445236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  445239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445259 */     GIR_RootConstrainSelectedInstOperands,
     /*  445260 */     // GIR_Coverage, 6297,
     /*  445260 */     GIR_EraseRootFromParent_Done,
     /*  445261 */   // Label 7712: @445261
     /*  445261 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(445347), // Rule ID 6300 //
     /*  445266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  445269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  445277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  445280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  445283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445313 */     // MIs[1] Operand 1
     /*  445313 */     // No operand predicates
     /*  445313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445322 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  445325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445345 */     GIR_RootConstrainSelectedInstOperands,
     /*  445346 */     // GIR_Coverage, 6300,
     /*  445346 */     GIR_EraseRootFromParent_Done,
     /*  445347 */   // Label 7713: @445347
     /*  445347 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(445433), // Rule ID 6301 //
     /*  445352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  445363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  445366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  445369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445399 */     // MIs[1] Operand 1
     /*  445399 */     // No operand predicates
     /*  445399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  445411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445431 */     GIR_RootConstrainSelectedInstOperands,
     /*  445432 */     // GIR_Coverage, 6301,
     /*  445432 */     GIR_EraseRootFromParent_Done,
     /*  445433 */   // Label 7714: @445433
     /*  445433 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(445519), // Rule ID 6304 //
     /*  445438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  445441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  445449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  445452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  445455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445485 */     // MIs[1] Operand 1
     /*  445485 */     // No operand predicates
     /*  445485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445494 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  445497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445517 */     GIR_RootConstrainSelectedInstOperands,
     /*  445518 */     // GIR_Coverage, 6304,
     /*  445518 */     GIR_EraseRootFromParent_Done,
     /*  445519 */   // Label 7715: @445519
     /*  445519 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(445605), // Rule ID 6305 //
     /*  445524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  445535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  445538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  445541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445571 */     // MIs[1] Operand 1
     /*  445571 */     // No operand predicates
     /*  445571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445580 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  445583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445603 */     GIR_RootConstrainSelectedInstOperands,
     /*  445604 */     // GIR_Coverage, 6305,
     /*  445604 */     GIR_EraseRootFromParent_Done,
     /*  445605 */   // Label 7716: @445605
     /*  445605 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(445691), // Rule ID 6308 //
     /*  445610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  445613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  445627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445657 */     // MIs[1] Operand 1
     /*  445657 */     // No operand predicates
     /*  445657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445666 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  445669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445689 */     GIR_RootConstrainSelectedInstOperands,
     /*  445690 */     // GIR_Coverage, 6308,
     /*  445690 */     GIR_EraseRootFromParent_Done,
     /*  445691 */   // Label 7717: @445691
     /*  445691 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(445777), // Rule ID 6309 //
     /*  445696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  445713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445743 */     // MIs[1] Operand 1
     /*  445743 */     // No operand predicates
     /*  445743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445752 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  445755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445775 */     GIR_RootConstrainSelectedInstOperands,
     /*  445776 */     // GIR_Coverage, 6309,
     /*  445776 */     GIR_EraseRootFromParent_Done,
     /*  445777 */   // Label 7718: @445777
     /*  445777 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(445863), // Rule ID 6488 //
     /*  445782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  445793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  445796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  445799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445829 */     // MIs[1] Operand 1
     /*  445829 */     // No operand predicates
     /*  445829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445838 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  445841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445861 */     GIR_RootConstrainSelectedInstOperands,
     /*  445862 */     // GIR_Coverage, 6488,
     /*  445862 */     GIR_EraseRootFromParent_Done,
     /*  445863 */   // Label 7719: @445863
     /*  445863 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(445949), // Rule ID 6489 //
     /*  445868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  445879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  445882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  445885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445915 */     // MIs[1] Operand 1
     /*  445915 */     // No operand predicates
     /*  445915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445924 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  445927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445947 */     GIR_RootConstrainSelectedInstOperands,
     /*  445948 */     // GIR_Coverage, 6489,
     /*  445948 */     GIR_EraseRootFromParent_Done,
     /*  445949 */   // Label 7720: @445949
     /*  445949 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(446035), // Rule ID 6492 //
     /*  445954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  445965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  445968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  445971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446001 */     // MIs[1] Operand 1
     /*  446001 */     // No operand predicates
     /*  446001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446010 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  446013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446033 */     GIR_RootConstrainSelectedInstOperands,
     /*  446034 */     // GIR_Coverage, 6492,
     /*  446034 */     GIR_EraseRootFromParent_Done,
     /*  446035 */   // Label 7721: @446035
     /*  446035 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(446121), // Rule ID 6493 //
     /*  446040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  446051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  446054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  446057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446087 */     // MIs[1] Operand 1
     /*  446087 */     // No operand predicates
     /*  446087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446096 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  446099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446119 */     GIR_RootConstrainSelectedInstOperands,
     /*  446120 */     // GIR_Coverage, 6493,
     /*  446120 */     GIR_EraseRootFromParent_Done,
     /*  446121 */   // Label 7722: @446121
     /*  446121 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(446207), // Rule ID 6496 //
     /*  446126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  446137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  446140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  446143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446173 */     // MIs[1] Operand 1
     /*  446173 */     // No operand predicates
     /*  446173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446182 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446205 */     GIR_RootConstrainSelectedInstOperands,
     /*  446206 */     // GIR_Coverage, 6496,
     /*  446206 */     GIR_EraseRootFromParent_Done,
     /*  446207 */   // Label 7723: @446207
     /*  446207 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(446293), // Rule ID 6497 //
     /*  446212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  446223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  446226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  446229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446259 */     // MIs[1] Operand 1
     /*  446259 */     // No operand predicates
     /*  446259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446268 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446291 */     GIR_RootConstrainSelectedInstOperands,
     /*  446292 */     // GIR_Coverage, 6497,
     /*  446292 */     GIR_EraseRootFromParent_Done,
     /*  446293 */   // Label 7724: @446293
     /*  446293 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(446379), // Rule ID 6500 //
     /*  446298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  446309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  446312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  446315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446345 */     // MIs[1] Operand 1
     /*  446345 */     // No operand predicates
     /*  446345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446354 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  446357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446377 */     GIR_RootConstrainSelectedInstOperands,
     /*  446378 */     // GIR_Coverage, 6500,
     /*  446378 */     GIR_EraseRootFromParent_Done,
     /*  446379 */   // Label 7725: @446379
     /*  446379 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(446465), // Rule ID 6501 //
     /*  446384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  446395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  446398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  446401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446431 */     // MIs[1] Operand 1
     /*  446431 */     // No operand predicates
     /*  446431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446440 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  446443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446463 */     GIR_RootConstrainSelectedInstOperands,
     /*  446464 */     // GIR_Coverage, 6501,
     /*  446464 */     GIR_EraseRootFromParent_Done,
     /*  446465 */   // Label 7726: @446465
     /*  446465 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(446551), // Rule ID 6504 //
     /*  446470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  446481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  446484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  446487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446517 */     // MIs[1] Operand 1
     /*  446517 */     // No operand predicates
     /*  446517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446526 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446549 */     GIR_RootConstrainSelectedInstOperands,
     /*  446550 */     // GIR_Coverage, 6504,
     /*  446550 */     GIR_EraseRootFromParent_Done,
     /*  446551 */   // Label 7727: @446551
     /*  446551 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(446637), // Rule ID 6505 //
     /*  446556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  446567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  446570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  446573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446603 */     // MIs[1] Operand 1
     /*  446603 */     // No operand predicates
     /*  446603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446612 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446635 */     GIR_RootConstrainSelectedInstOperands,
     /*  446636 */     // GIR_Coverage, 6505,
     /*  446636 */     GIR_EraseRootFromParent_Done,
     /*  446637 */   // Label 7728: @446637
     /*  446637 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(446723), // Rule ID 6508 //
     /*  446642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  446659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446689 */     // MIs[1] Operand 1
     /*  446689 */     // No operand predicates
     /*  446689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446698 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  446698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446721 */     GIR_RootConstrainSelectedInstOperands,
     /*  446722 */     // GIR_Coverage, 6508,
     /*  446722 */     GIR_EraseRootFromParent_Done,
     /*  446723 */   // Label 7729: @446723
     /*  446723 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(446809), // Rule ID 6509 //
     /*  446728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  446745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446775 */     // MIs[1] Operand 1
     /*  446775 */     // No operand predicates
     /*  446775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  446784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446807 */     GIR_RootConstrainSelectedInstOperands,
     /*  446808 */     // GIR_Coverage, 6509,
     /*  446808 */     GIR_EraseRootFromParent_Done,
     /*  446809 */   // Label 7730: @446809
     /*  446809 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(446895), // Rule ID 6512 //
     /*  446814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  446825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  446828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  446831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446861 */     // MIs[1] Operand 1
     /*  446861 */     // No operand predicates
     /*  446861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446870 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446893 */     GIR_RootConstrainSelectedInstOperands,
     /*  446894 */     // GIR_Coverage, 6512,
     /*  446894 */     GIR_EraseRootFromParent_Done,
     /*  446895 */   // Label 7731: @446895
     /*  446895 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(446981), // Rule ID 6513 //
     /*  446900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  446911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  446914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  446917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446947 */     // MIs[1] Operand 1
     /*  446947 */     // No operand predicates
     /*  446947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446956 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446979 */     GIR_RootConstrainSelectedInstOperands,
     /*  446980 */     // GIR_Coverage, 6513,
     /*  446980 */     GIR_EraseRootFromParent_Done,
     /*  446981 */   // Label 7732: @446981
     /*  446981 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(447067), // Rule ID 6516 //
     /*  446986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  446997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  447000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  447003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447033 */     // MIs[1] Operand 1
     /*  447033 */     // No operand predicates
     /*  447033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447042 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447065 */     GIR_RootConstrainSelectedInstOperands,
     /*  447066 */     // GIR_Coverage, 6516,
     /*  447066 */     GIR_EraseRootFromParent_Done,
     /*  447067 */   // Label 7733: @447067
     /*  447067 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(447153), // Rule ID 6517 //
     /*  447072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  447083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  447086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  447089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447119 */     // MIs[1] Operand 1
     /*  447119 */     // No operand predicates
     /*  447119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447128 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447151 */     GIR_RootConstrainSelectedInstOperands,
     /*  447152 */     // GIR_Coverage, 6517,
     /*  447152 */     GIR_EraseRootFromParent_Done,
     /*  447153 */   // Label 7734: @447153
     /*  447153 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(447239), // Rule ID 6520 //
     /*  447158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  447169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  447172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  447175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447205 */     // MIs[1] Operand 1
     /*  447205 */     // No operand predicates
     /*  447205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447214 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  447214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447237 */     GIR_RootConstrainSelectedInstOperands,
     /*  447238 */     // GIR_Coverage, 6520,
     /*  447238 */     GIR_EraseRootFromParent_Done,
     /*  447239 */   // Label 7735: @447239
     /*  447239 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(447325), // Rule ID 6521 //
     /*  447244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  447255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  447258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  447261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447291 */     // MIs[1] Operand 1
     /*  447291 */     // No operand predicates
     /*  447291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  447300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447323 */     GIR_RootConstrainSelectedInstOperands,
     /*  447324 */     // GIR_Coverage, 6521,
     /*  447324 */     GIR_EraseRootFromParent_Done,
     /*  447325 */   // Label 7736: @447325
     /*  447325 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(447411), // Rule ID 6524 //
     /*  447330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  447333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  447341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  447344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  447347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447377 */     // MIs[1] Operand 1
     /*  447377 */     // No operand predicates
     /*  447377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447386 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  447386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  447406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447409 */     GIR_RootConstrainSelectedInstOperands,
     /*  447410 */     // GIR_Coverage, 6524,
     /*  447410 */     GIR_EraseRootFromParent_Done,
     /*  447411 */   // Label 7737: @447411
     /*  447411 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(447497), // Rule ID 6525 //
     /*  447416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  447419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  447427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  447430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  447433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447463 */     // MIs[1] Operand 1
     /*  447463 */     // No operand predicates
     /*  447463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447472 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  447472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  447492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447495 */     GIR_RootConstrainSelectedInstOperands,
     /*  447496 */     // GIR_Coverage, 6525,
     /*  447496 */     GIR_EraseRootFromParent_Done,
     /*  447497 */   // Label 7738: @447497
     /*  447497 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(447583), // Rule ID 6528 //
     /*  447502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  447513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  447516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  447519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447549 */     // MIs[1] Operand 1
     /*  447549 */     // No operand predicates
     /*  447549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447558 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447581 */     GIR_RootConstrainSelectedInstOperands,
     /*  447582 */     // GIR_Coverage, 6528,
     /*  447582 */     GIR_EraseRootFromParent_Done,
     /*  447583 */   // Label 7739: @447583
     /*  447583 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(447669), // Rule ID 6529 //
     /*  447588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  447599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  447602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  447605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447635 */     // MIs[1] Operand 1
     /*  447635 */     // No operand predicates
     /*  447635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447667 */     GIR_RootConstrainSelectedInstOperands,
     /*  447668 */     // GIR_Coverage, 6529,
     /*  447668 */     GIR_EraseRootFromParent_Done,
     /*  447669 */   // Label 7740: @447669
     /*  447669 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(447755), // Rule ID 6532 //
     /*  447674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  447685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  447688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  447691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447721 */     // MIs[1] Operand 1
     /*  447721 */     // No operand predicates
     /*  447721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447730 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447753 */     GIR_RootConstrainSelectedInstOperands,
     /*  447754 */     // GIR_Coverage, 6532,
     /*  447754 */     GIR_EraseRootFromParent_Done,
     /*  447755 */   // Label 7741: @447755
     /*  447755 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(447841), // Rule ID 6533 //
     /*  447760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  447771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  447774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  447777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447807 */     // MIs[1] Operand 1
     /*  447807 */     // No operand predicates
     /*  447807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447816 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447839 */     GIR_RootConstrainSelectedInstOperands,
     /*  447840 */     // GIR_Coverage, 6533,
     /*  447840 */     GIR_EraseRootFromParent_Done,
     /*  447841 */   // Label 7742: @447841
     /*  447841 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(447927), // Rule ID 6536 //
     /*  447846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  447857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  447860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  447863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447893 */     // MIs[1] Operand 1
     /*  447893 */     // No operand predicates
     /*  447893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447902 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447925 */     GIR_RootConstrainSelectedInstOperands,
     /*  447926 */     // GIR_Coverage, 6536,
     /*  447926 */     GIR_EraseRootFromParent_Done,
     /*  447927 */   // Label 7743: @447927
     /*  447927 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(448013), // Rule ID 6537 //
     /*  447932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  447943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  447946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  447949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447979 */     // MIs[1] Operand 1
     /*  447979 */     // No operand predicates
     /*  447979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447988 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  448008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448011 */     GIR_RootConstrainSelectedInstOperands,
     /*  448012 */     // GIR_Coverage, 6537,
     /*  448012 */     GIR_EraseRootFromParent_Done,
     /*  448013 */   // Label 7744: @448013
     /*  448013 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(448099), // Rule ID 6540 //
     /*  448018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  448029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  448032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  448035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448065 */     // MIs[1] Operand 1
     /*  448065 */     // No operand predicates
     /*  448065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448074 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448097 */     GIR_RootConstrainSelectedInstOperands,
     /*  448098 */     // GIR_Coverage, 6540,
     /*  448098 */     GIR_EraseRootFromParent_Done,
     /*  448099 */   // Label 7745: @448099
     /*  448099 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(448185), // Rule ID 6541 //
     /*  448104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  448115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  448118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  448121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448151 */     // MIs[1] Operand 1
     /*  448151 */     // No operand predicates
     /*  448151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448183 */     GIR_RootConstrainSelectedInstOperands,
     /*  448184 */     // GIR_Coverage, 6541,
     /*  448184 */     GIR_EraseRootFromParent_Done,
     /*  448185 */   // Label 7746: @448185
     /*  448185 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(448271), // Rule ID 6544 //
     /*  448190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  448201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  448204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  448207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448237 */     // MIs[1] Operand 1
     /*  448237 */     // No operand predicates
     /*  448237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448246 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448269 */     GIR_RootConstrainSelectedInstOperands,
     /*  448270 */     // GIR_Coverage, 6544,
     /*  448270 */     GIR_EraseRootFromParent_Done,
     /*  448271 */   // Label 7747: @448271
     /*  448271 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(448357), // Rule ID 6545 //
     /*  448276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  448287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  448290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  448293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448323 */     // MIs[1] Operand 1
     /*  448323 */     // No operand predicates
     /*  448323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448332 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448355 */     GIR_RootConstrainSelectedInstOperands,
     /*  448356 */     // GIR_Coverage, 6545,
     /*  448356 */     GIR_EraseRootFromParent_Done,
     /*  448357 */   // Label 7748: @448357
     /*  448357 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(448443), // Rule ID 6548 //
     /*  448362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  448373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  448376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  448379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448409 */     // MIs[1] Operand 1
     /*  448409 */     // No operand predicates
     /*  448409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448418 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448441 */     GIR_RootConstrainSelectedInstOperands,
     /*  448442 */     // GIR_Coverage, 6548,
     /*  448442 */     GIR_EraseRootFromParent_Done,
     /*  448443 */   // Label 7749: @448443
     /*  448443 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(448529), // Rule ID 6549 //
     /*  448448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  448459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  448462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  448465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448495 */     // MIs[1] Operand 1
     /*  448495 */     // No operand predicates
     /*  448495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448504 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448527 */     GIR_RootConstrainSelectedInstOperands,
     /*  448528 */     // GIR_Coverage, 6549,
     /*  448528 */     GIR_EraseRootFromParent_Done,
     /*  448529 */   // Label 7750: @448529
     /*  448529 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(448615), // Rule ID 6552 //
     /*  448534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  448551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448581 */     // MIs[1] Operand 1
     /*  448581 */     // No operand predicates
     /*  448581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448613 */     GIR_RootConstrainSelectedInstOperands,
     /*  448614 */     // GIR_Coverage, 6552,
     /*  448614 */     GIR_EraseRootFromParent_Done,
     /*  448615 */   // Label 7751: @448615
     /*  448615 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(448701), // Rule ID 6553 //
     /*  448620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  448637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448667 */     // MIs[1] Operand 1
     /*  448667 */     // No operand predicates
     /*  448667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448699 */     GIR_RootConstrainSelectedInstOperands,
     /*  448700 */     // GIR_Coverage, 6553,
     /*  448700 */     GIR_EraseRootFromParent_Done,
     /*  448701 */   // Label 7752: @448701
     /*  448701 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(448787), // Rule ID 6556 //
     /*  448706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  448723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448753 */     // MIs[1] Operand 1
     /*  448753 */     // No operand predicates
     /*  448753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448762 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448785 */     GIR_RootConstrainSelectedInstOperands,
     /*  448786 */     // GIR_Coverage, 6556,
     /*  448786 */     GIR_EraseRootFromParent_Done,
     /*  448787 */   // Label 7753: @448787
     /*  448787 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(448873), // Rule ID 6557 //
     /*  448792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  448809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448839 */     // MIs[1] Operand 1
     /*  448839 */     // No operand predicates
     /*  448839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448848 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448871 */     GIR_RootConstrainSelectedInstOperands,
     /*  448872 */     // GIR_Coverage, 6557,
     /*  448872 */     GIR_EraseRootFromParent_Done,
     /*  448873 */   // Label 7754: @448873
     /*  448873 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(448959), // Rule ID 6560 //
     /*  448878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  448895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448925 */     // MIs[1] Operand 1
     /*  448925 */     // No operand predicates
     /*  448925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448934 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448957 */     GIR_RootConstrainSelectedInstOperands,
     /*  448958 */     // GIR_Coverage, 6560,
     /*  448958 */     GIR_EraseRootFromParent_Done,
     /*  448959 */   // Label 7755: @448959
     /*  448959 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(449045), // Rule ID 6561 //
     /*  448964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  448981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449011 */     // MIs[1] Operand 1
     /*  449011 */     // No operand predicates
     /*  449011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449020 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  449020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  449023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  449040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449043 */     GIR_RootConstrainSelectedInstOperands,
     /*  449044 */     // GIR_Coverage, 6561,
     /*  449044 */     GIR_EraseRootFromParent_Done,
     /*  449045 */   // Label 7756: @449045
     /*  449045 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(449131), // Rule ID 6564 //
     /*  449050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  449053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  449061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  449064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  449067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449097 */     // MIs[1] Operand 1
     /*  449097 */     // No operand predicates
     /*  449097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449106 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  449106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  449109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449129 */     GIR_RootConstrainSelectedInstOperands,
     /*  449130 */     // GIR_Coverage, 6564,
     /*  449130 */     GIR_EraseRootFromParent_Done,
     /*  449131 */   // Label 7757: @449131
     /*  449131 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(449217), // Rule ID 6565 //
     /*  449136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  449139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  449147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  449150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  449153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449183 */     // MIs[1] Operand 1
     /*  449183 */     // No operand predicates
     /*  449183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  449192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  449195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449215 */     GIR_RootConstrainSelectedInstOperands,
     /*  449216 */     // GIR_Coverage, 6565,
     /*  449216 */     GIR_EraseRootFromParent_Done,
     /*  449217 */   // Label 7758: @449217
     /*  449217 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(449303), // Rule ID 6568 //
     /*  449222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  449225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  449233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  449236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  449239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449269 */     // MIs[1] Operand 1
     /*  449269 */     // No operand predicates
     /*  449269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449278 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  449278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  449281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449301 */     GIR_RootConstrainSelectedInstOperands,
     /*  449302 */     // GIR_Coverage, 6568,
     /*  449302 */     GIR_EraseRootFromParent_Done,
     /*  449303 */   // Label 7759: @449303
     /*  449303 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(449389), // Rule ID 6569 //
     /*  449308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  449311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  449319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  449322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  449325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449355 */     // MIs[1] Operand 1
     /*  449355 */     // No operand predicates
     /*  449355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  449364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  449367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449387 */     GIR_RootConstrainSelectedInstOperands,
     /*  449388 */     // GIR_Coverage, 6569,
     /*  449388 */     GIR_EraseRootFromParent_Done,
     /*  449389 */   // Label 7760: @449389
     /*  449389 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(449475), // Rule ID 6572 //
     /*  449394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  449397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  449405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  449408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  449411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449441 */     // MIs[1] Operand 1
     /*  449441 */     // No operand predicates
     /*  449441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449450 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  449450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  449453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449473 */     GIR_RootConstrainSelectedInstOperands,
     /*  449474 */     // GIR_Coverage, 6572,
     /*  449474 */     GIR_EraseRootFromParent_Done,
     /*  449475 */   // Label 7761: @449475
     /*  449475 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(449561), // Rule ID 6573 //
     /*  449480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  449483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  449491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  449494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  449497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449527 */     // MIs[1] Operand 1
     /*  449527 */     // No operand predicates
     /*  449527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  449536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  449539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449559 */     GIR_RootConstrainSelectedInstOperands,
     /*  449560 */     // GIR_Coverage, 6573,
     /*  449560 */     GIR_EraseRootFromParent_Done,
     /*  449561 */   // Label 7762: @449561
     /*  449561 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(449647), // Rule ID 6752 //
     /*  449566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  449577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  449580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  449583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449613 */     // MIs[1] Operand 1
     /*  449613 */     // No operand predicates
     /*  449613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449622 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  449625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449645 */     GIR_RootConstrainSelectedInstOperands,
     /*  449646 */     // GIR_Coverage, 6752,
     /*  449646 */     GIR_EraseRootFromParent_Done,
     /*  449647 */   // Label 7763: @449647
     /*  449647 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(449733), // Rule ID 6753 //
     /*  449652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  449663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  449666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  449669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449699 */     // MIs[1] Operand 1
     /*  449699 */     // No operand predicates
     /*  449699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449708 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  449711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449731 */     GIR_RootConstrainSelectedInstOperands,
     /*  449732 */     // GIR_Coverage, 6753,
     /*  449732 */     GIR_EraseRootFromParent_Done,
     /*  449733 */   // Label 7764: @449733
     /*  449733 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(449819), // Rule ID 6756 //
     /*  449738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  449749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  449752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  449755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449785 */     // MIs[1] Operand 1
     /*  449785 */     // No operand predicates
     /*  449785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449794 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449817 */     GIR_RootConstrainSelectedInstOperands,
     /*  449818 */     // GIR_Coverage, 6756,
     /*  449818 */     GIR_EraseRootFromParent_Done,
     /*  449819 */   // Label 7765: @449819
     /*  449819 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(449905), // Rule ID 6757 //
     /*  449824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  449835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  449838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  449841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449871 */     // MIs[1] Operand 1
     /*  449871 */     // No operand predicates
     /*  449871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449880 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449903 */     GIR_RootConstrainSelectedInstOperands,
     /*  449904 */     // GIR_Coverage, 6757,
     /*  449904 */     GIR_EraseRootFromParent_Done,
     /*  449905 */   // Label 7766: @449905
     /*  449905 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(449991), // Rule ID 6760 //
     /*  449910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  449921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  449924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  449927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449957 */     // MIs[1] Operand 1
     /*  449957 */     // No operand predicates
     /*  449957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449966 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449989 */     GIR_RootConstrainSelectedInstOperands,
     /*  449990 */     // GIR_Coverage, 6760,
     /*  449990 */     GIR_EraseRootFromParent_Done,
     /*  449991 */   // Label 7767: @449991
     /*  449991 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(450077), // Rule ID 6761 //
     /*  449996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  450007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  450010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  450013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450043 */     // MIs[1] Operand 1
     /*  450043 */     // No operand predicates
     /*  450043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450052 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450075 */     GIR_RootConstrainSelectedInstOperands,
     /*  450076 */     // GIR_Coverage, 6761,
     /*  450076 */     GIR_EraseRootFromParent_Done,
     /*  450077 */   // Label 7768: @450077
     /*  450077 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(450163), // Rule ID 6764 //
     /*  450082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  450093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  450096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  450099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450129 */     // MIs[1] Operand 1
     /*  450129 */     // No operand predicates
     /*  450129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450138 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  450141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450161 */     GIR_RootConstrainSelectedInstOperands,
     /*  450162 */     // GIR_Coverage, 6764,
     /*  450162 */     GIR_EraseRootFromParent_Done,
     /*  450163 */   // Label 7769: @450163
     /*  450163 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(450249), // Rule ID 6765 //
     /*  450168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  450179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  450182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  450185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450215 */     // MIs[1] Operand 1
     /*  450215 */     // No operand predicates
     /*  450215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450224 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  450227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450247 */     GIR_RootConstrainSelectedInstOperands,
     /*  450248 */     // GIR_Coverage, 6765,
     /*  450248 */     GIR_EraseRootFromParent_Done,
     /*  450249 */   // Label 7770: @450249
     /*  450249 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(450335), // Rule ID 6768 //
     /*  450254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  450265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  450268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  450271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450301 */     // MIs[1] Operand 1
     /*  450301 */     // No operand predicates
     /*  450301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450310 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450333 */     GIR_RootConstrainSelectedInstOperands,
     /*  450334 */     // GIR_Coverage, 6768,
     /*  450334 */     GIR_EraseRootFromParent_Done,
     /*  450335 */   // Label 7771: @450335
     /*  450335 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(450421), // Rule ID 6769 //
     /*  450340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  450351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  450354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  450357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450387 */     // MIs[1] Operand 1
     /*  450387 */     // No operand predicates
     /*  450387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450396 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450419 */     GIR_RootConstrainSelectedInstOperands,
     /*  450420 */     // GIR_Coverage, 6769,
     /*  450420 */     GIR_EraseRootFromParent_Done,
     /*  450421 */   // Label 7772: @450421
     /*  450421 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(450507), // Rule ID 6772 //
     /*  450426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  450437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  450440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  450443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450473 */     // MIs[1] Operand 1
     /*  450473 */     // No operand predicates
     /*  450473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450482 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450505 */     GIR_RootConstrainSelectedInstOperands,
     /*  450506 */     // GIR_Coverage, 6772,
     /*  450506 */     GIR_EraseRootFromParent_Done,
     /*  450507 */   // Label 7773: @450507
     /*  450507 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(450593), // Rule ID 6773 //
     /*  450512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  450523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  450526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  450529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450559 */     // MIs[1] Operand 1
     /*  450559 */     // No operand predicates
     /*  450559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  450568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450591 */     GIR_RootConstrainSelectedInstOperands,
     /*  450592 */     // GIR_Coverage, 6773,
     /*  450592 */     GIR_EraseRootFromParent_Done,
     /*  450593 */   // Label 7774: @450593
     /*  450593 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(450679), // Rule ID 6776 //
     /*  450598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  450609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  450612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  450615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450645 */     // MIs[1] Operand 1
     /*  450645 */     // No operand predicates
     /*  450645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450654 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450677 */     GIR_RootConstrainSelectedInstOperands,
     /*  450678 */     // GIR_Coverage, 6776,
     /*  450678 */     GIR_EraseRootFromParent_Done,
     /*  450679 */   // Label 7775: @450679
     /*  450679 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(450765), // Rule ID 6777 //
     /*  450684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  450695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  450698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  450701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450731 */     // MIs[1] Operand 1
     /*  450731 */     // No operand predicates
     /*  450731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450763 */     GIR_RootConstrainSelectedInstOperands,
     /*  450764 */     // GIR_Coverage, 6777,
     /*  450764 */     GIR_EraseRootFromParent_Done,
     /*  450765 */   // Label 7776: @450765
     /*  450765 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(450851), // Rule ID 6780 //
     /*  450770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  450781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  450784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  450787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450817 */     // MIs[1] Operand 1
     /*  450817 */     // No operand predicates
     /*  450817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450826 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450849 */     GIR_RootConstrainSelectedInstOperands,
     /*  450850 */     // GIR_Coverage, 6780,
     /*  450850 */     GIR_EraseRootFromParent_Done,
     /*  450851 */   // Label 7777: @450851
     /*  450851 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(450937), // Rule ID 6781 //
     /*  450856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  450867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  450870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  450873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450903 */     // MIs[1] Operand 1
     /*  450903 */     // No operand predicates
     /*  450903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450912 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450935 */     GIR_RootConstrainSelectedInstOperands,
     /*  450936 */     // GIR_Coverage, 6781,
     /*  450936 */     GIR_EraseRootFromParent_Done,
     /*  450937 */   // Label 7778: @450937
     /*  450937 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(451023), // Rule ID 6784 //
     /*  450942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  450959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450989 */     // MIs[1] Operand 1
     /*  450989 */     // No operand predicates
     /*  450989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450998 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  451001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451021 */     GIR_RootConstrainSelectedInstOperands,
     /*  451022 */     // GIR_Coverage, 6784,
     /*  451022 */     GIR_EraseRootFromParent_Done,
     /*  451023 */   // Label 7779: @451023
     /*  451023 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(451109), // Rule ID 6785 //
     /*  451028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  451039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  451042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  451045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451075 */     // MIs[1] Operand 1
     /*  451075 */     // No operand predicates
     /*  451075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  451084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  451087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451107 */     GIR_RootConstrainSelectedInstOperands,
     /*  451108 */     // GIR_Coverage, 6785,
     /*  451108 */     GIR_EraseRootFromParent_Done,
     /*  451109 */   // Label 7780: @451109
     /*  451109 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(451195), // Rule ID 6788 //
     /*  451114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  451117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  451125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  451128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  451131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451161 */     // MIs[1] Operand 1
     /*  451161 */     // No operand predicates
     /*  451161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451170 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  451170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  451173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  451190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451193 */     GIR_RootConstrainSelectedInstOperands,
     /*  451194 */     // GIR_Coverage, 6788,
     /*  451194 */     GIR_EraseRootFromParent_Done,
     /*  451195 */   // Label 7781: @451195
     /*  451195 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(451281), // Rule ID 6789 //
     /*  451200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  451203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  451211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  451214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  451217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451247 */     // MIs[1] Operand 1
     /*  451247 */     // No operand predicates
     /*  451247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451256 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  451256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  451259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  451276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451279 */     GIR_RootConstrainSelectedInstOperands,
     /*  451280 */     // GIR_Coverage, 6789,
     /*  451280 */     GIR_EraseRootFromParent_Done,
     /*  451281 */   // Label 7782: @451281
     /*  451281 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(451367), // Rule ID 6792 //
     /*  451286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  451297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  451300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  451303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451333 */     // MIs[1] Operand 1
     /*  451333 */     // No operand predicates
     /*  451333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451342 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451365 */     GIR_RootConstrainSelectedInstOperands,
     /*  451366 */     // GIR_Coverage, 6792,
     /*  451366 */     GIR_EraseRootFromParent_Done,
     /*  451367 */   // Label 7783: @451367
     /*  451367 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(451453), // Rule ID 6793 //
     /*  451372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  451383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  451386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  451389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451419 */     // MIs[1] Operand 1
     /*  451419 */     // No operand predicates
     /*  451419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451428 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451451 */     GIR_RootConstrainSelectedInstOperands,
     /*  451452 */     // GIR_Coverage, 6793,
     /*  451452 */     GIR_EraseRootFromParent_Done,
     /*  451453 */   // Label 7784: @451453
     /*  451453 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(451539), // Rule ID 6796 //
     /*  451458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  451469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  451472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  451475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451505 */     // MIs[1] Operand 1
     /*  451505 */     // No operand predicates
     /*  451505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451514 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451537 */     GIR_RootConstrainSelectedInstOperands,
     /*  451538 */     // GIR_Coverage, 6796,
     /*  451538 */     GIR_EraseRootFromParent_Done,
     /*  451539 */   // Label 7785: @451539
     /*  451539 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(451625), // Rule ID 6797 //
     /*  451544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  451555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  451558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  451561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451591 */     // MIs[1] Operand 1
     /*  451591 */     // No operand predicates
     /*  451591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451600 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451623 */     GIR_RootConstrainSelectedInstOperands,
     /*  451624 */     // GIR_Coverage, 6797,
     /*  451624 */     GIR_EraseRootFromParent_Done,
     /*  451625 */   // Label 7786: @451625
     /*  451625 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(451711), // Rule ID 6800 //
     /*  451630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  451641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  451644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  451647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451677 */     // MIs[1] Operand 1
     /*  451677 */     // No operand predicates
     /*  451677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451686 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451709 */     GIR_RootConstrainSelectedInstOperands,
     /*  451710 */     // GIR_Coverage, 6800,
     /*  451710 */     GIR_EraseRootFromParent_Done,
     /*  451711 */   // Label 7787: @451711
     /*  451711 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(451797), // Rule ID 6801 //
     /*  451716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  451727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  451730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  451733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451763 */     // MIs[1] Operand 1
     /*  451763 */     // No operand predicates
     /*  451763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451772 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451795 */     GIR_RootConstrainSelectedInstOperands,
     /*  451796 */     // GIR_Coverage, 6801,
     /*  451796 */     GIR_EraseRootFromParent_Done,
     /*  451797 */   // Label 7788: @451797
     /*  451797 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(451883), // Rule ID 6804 //
     /*  451802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  451813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  451816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  451819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451849 */     // MIs[1] Operand 1
     /*  451849 */     // No operand predicates
     /*  451849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451881 */     GIR_RootConstrainSelectedInstOperands,
     /*  451882 */     // GIR_Coverage, 6804,
     /*  451882 */     GIR_EraseRootFromParent_Done,
     /*  451883 */   // Label 7789: @451883
     /*  451883 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(451969), // Rule ID 6805 //
     /*  451888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  451899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  451902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  451905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451935 */     // MIs[1] Operand 1
     /*  451935 */     // No operand predicates
     /*  451935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451944 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451967 */     GIR_RootConstrainSelectedInstOperands,
     /*  451968 */     // GIR_Coverage, 6805,
     /*  451968 */     GIR_EraseRootFromParent_Done,
     /*  451969 */   // Label 7790: @451969
     /*  451969 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(452055), // Rule ID 6808 //
     /*  451974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  451985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  451988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  451991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452021 */     // MIs[1] Operand 1
     /*  452021 */     // No operand predicates
     /*  452021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452030 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  452030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  452050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452053 */     GIR_RootConstrainSelectedInstOperands,
     /*  452054 */     // GIR_Coverage, 6808,
     /*  452054 */     GIR_EraseRootFromParent_Done,
     /*  452055 */   // Label 7791: @452055
     /*  452055 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(452141), // Rule ID 6809 //
     /*  452060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  452071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  452074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  452077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452107 */     // MIs[1] Operand 1
     /*  452107 */     // No operand predicates
     /*  452107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452116 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  452116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  452136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452139 */     GIR_RootConstrainSelectedInstOperands,
     /*  452140 */     // GIR_Coverage, 6809,
     /*  452140 */     GIR_EraseRootFromParent_Done,
     /*  452141 */   // Label 7792: @452141
     /*  452141 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(452227), // Rule ID 6812 //
     /*  452146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  452157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  452160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  452163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452193 */     // MIs[1] Operand 1
     /*  452193 */     // No operand predicates
     /*  452193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452202 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  452202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  452222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452225 */     GIR_RootConstrainSelectedInstOperands,
     /*  452226 */     // GIR_Coverage, 6812,
     /*  452226 */     GIR_EraseRootFromParent_Done,
     /*  452227 */   // Label 7793: @452227
     /*  452227 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(452313), // Rule ID 6813 //
     /*  452232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  452243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  452246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  452249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452279 */     // MIs[1] Operand 1
     /*  452279 */     // No operand predicates
     /*  452279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452288 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  452288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  452308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452311 */     GIR_RootConstrainSelectedInstOperands,
     /*  452312 */     // GIR_Coverage, 6813,
     /*  452312 */     GIR_EraseRootFromParent_Done,
     /*  452313 */   // Label 7794: @452313
     /*  452313 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(452399), // Rule ID 6816 //
     /*  452318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  452329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  452332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  452335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452365 */     // MIs[1] Operand 1
     /*  452365 */     // No operand predicates
     /*  452365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452397 */     GIR_RootConstrainSelectedInstOperands,
     /*  452398 */     // GIR_Coverage, 6816,
     /*  452398 */     GIR_EraseRootFromParent_Done,
     /*  452399 */   // Label 7795: @452399
     /*  452399 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(452485), // Rule ID 6817 //
     /*  452404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  452415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  452418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  452421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452451 */     // MIs[1] Operand 1
     /*  452451 */     // No operand predicates
     /*  452451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452483 */     GIR_RootConstrainSelectedInstOperands,
     /*  452484 */     // GIR_Coverage, 6817,
     /*  452484 */     GIR_EraseRootFromParent_Done,
     /*  452485 */   // Label 7796: @452485
     /*  452485 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(452571), // Rule ID 6820 //
     /*  452490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  452501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  452504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  452507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452537 */     // MIs[1] Operand 1
     /*  452537 */     // No operand predicates
     /*  452537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452569 */     GIR_RootConstrainSelectedInstOperands,
     /*  452570 */     // GIR_Coverage, 6820,
     /*  452570 */     GIR_EraseRootFromParent_Done,
     /*  452571 */   // Label 7797: @452571
     /*  452571 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(452657), // Rule ID 6821 //
     /*  452576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  452587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  452590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  452593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452623 */     // MIs[1] Operand 1
     /*  452623 */     // No operand predicates
     /*  452623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452632 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452655 */     GIR_RootConstrainSelectedInstOperands,
     /*  452656 */     // GIR_Coverage, 6821,
     /*  452656 */     GIR_EraseRootFromParent_Done,
     /*  452657 */   // Label 7798: @452657
     /*  452657 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(452743), // Rule ID 6824 //
     /*  452662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  452673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  452676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  452679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452709 */     // MIs[1] Operand 1
     /*  452709 */     // No operand predicates
     /*  452709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452741 */     GIR_RootConstrainSelectedInstOperands,
     /*  452742 */     // GIR_Coverage, 6824,
     /*  452742 */     GIR_EraseRootFromParent_Done,
     /*  452743 */   // Label 7799: @452743
     /*  452743 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(452829), // Rule ID 6825 //
     /*  452748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  452759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  452762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  452765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452795 */     // MIs[1] Operand 1
     /*  452795 */     // No operand predicates
     /*  452795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452804 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452827 */     GIR_RootConstrainSelectedInstOperands,
     /*  452828 */     // GIR_Coverage, 6825,
     /*  452828 */     GIR_EraseRootFromParent_Done,
     /*  452829 */   // Label 7800: @452829
     /*  452829 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(452915), // Rule ID 6828 //
     /*  452834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  452845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  452848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  452851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452881 */     // MIs[1] Operand 1
     /*  452881 */     // No operand predicates
     /*  452881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452890 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452913 */     GIR_RootConstrainSelectedInstOperands,
     /*  452914 */     // GIR_Coverage, 6828,
     /*  452914 */     GIR_EraseRootFromParent_Done,
     /*  452915 */   // Label 7801: @452915
     /*  452915 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(453001), // Rule ID 6829 //
     /*  452920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  452931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  452934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  452937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452967 */     // MIs[1] Operand 1
     /*  452967 */     // No operand predicates
     /*  452967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452999 */     GIR_RootConstrainSelectedInstOperands,
     /*  453000 */     // GIR_Coverage, 6829,
     /*  453000 */     GIR_EraseRootFromParent_Done,
     /*  453001 */   // Label 7802: @453001
     /*  453001 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(453087), // Rule ID 6832 //
     /*  453006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  453009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  453017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  453020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  453023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  453033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  453037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  453041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453053 */     // MIs[1] Operand 1
     /*  453053 */     // No operand predicates
     /*  453053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453062 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  453062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  453065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  453082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453085 */     GIR_RootConstrainSelectedInstOperands,
     /*  453086 */     // GIR_Coverage, 6832,
     /*  453086 */     GIR_EraseRootFromParent_Done,
     /*  453087 */   // Label 7803: @453087
     /*  453087 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(453173), // Rule ID 6833 //
     /*  453092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  453095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  453103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  453106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  453109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  453119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  453123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  453127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453139 */     // MIs[1] Operand 1
     /*  453139 */     // No operand predicates
     /*  453139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453148 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  453148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  453151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  453168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453171 */     GIR_RootConstrainSelectedInstOperands,
     /*  453172 */     // GIR_Coverage, 6833,
     /*  453172 */     GIR_EraseRootFromParent_Done,
     /*  453173 */   // Label 7804: @453173
     /*  453173 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(453259), // Rule ID 6836 //
     /*  453178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  453181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  453189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  453192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  453195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  453205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  453209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  453213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453225 */     // MIs[1] Operand 1
     /*  453225 */     // No operand predicates
     /*  453225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453234 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  453234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  453237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  453254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453257 */     GIR_RootConstrainSelectedInstOperands,
     /*  453258 */     // GIR_Coverage, 6836,
     /*  453258 */     GIR_EraseRootFromParent_Done,
     /*  453259 */   // Label 7805: @453259
     /*  453259 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(453345), // Rule ID 6837 //
     /*  453264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  453267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  453275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  453278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  453281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  453291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  453295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  453299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453311 */     // MIs[1] Operand 1
     /*  453311 */     // No operand predicates
     /*  453311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453320 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  453320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  453323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  453340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453343 */     GIR_RootConstrainSelectedInstOperands,
     /*  453344 */     // GIR_Coverage, 6837,
     /*  453344 */     GIR_EraseRootFromParent_Done,
     /*  453345 */   // Label 7806: @453345
     /*  453345 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(453431), // Rule ID 7016 //
     /*  453350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  453361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  453364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  453367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453397 */     // MIs[1] Operand 1
     /*  453397 */     // No operand predicates
     /*  453397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453406 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  453409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453429 */     GIR_RootConstrainSelectedInstOperands,
     /*  453430 */     // GIR_Coverage, 7016,
     /*  453430 */     GIR_EraseRootFromParent_Done,
     /*  453431 */   // Label 7807: @453431
     /*  453431 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(453517), // Rule ID 7017 //
     /*  453436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  453447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  453450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  453453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453483 */     // MIs[1] Operand 1
     /*  453483 */     // No operand predicates
     /*  453483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453492 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  453495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453515 */     GIR_RootConstrainSelectedInstOperands,
     /*  453516 */     // GIR_Coverage, 7017,
     /*  453516 */     GIR_EraseRootFromParent_Done,
     /*  453517 */   // Label 7808: @453517
     /*  453517 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(453603), // Rule ID 7020 //
     /*  453522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  453533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  453536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  453539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453569 */     // MIs[1] Operand 1
     /*  453569 */     // No operand predicates
     /*  453569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453578 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453601 */     GIR_RootConstrainSelectedInstOperands,
     /*  453602 */     // GIR_Coverage, 7020,
     /*  453602 */     GIR_EraseRootFromParent_Done,
     /*  453603 */   // Label 7809: @453603
     /*  453603 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(453689), // Rule ID 7021 //
     /*  453608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  453619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  453622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  453625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453655 */     // MIs[1] Operand 1
     /*  453655 */     // No operand predicates
     /*  453655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453664 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453687 */     GIR_RootConstrainSelectedInstOperands,
     /*  453688 */     // GIR_Coverage, 7021,
     /*  453688 */     GIR_EraseRootFromParent_Done,
     /*  453689 */   // Label 7810: @453689
     /*  453689 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(453775), // Rule ID 7024 //
     /*  453694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  453705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  453708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  453711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453741 */     // MIs[1] Operand 1
     /*  453741 */     // No operand predicates
     /*  453741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453750 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453773 */     GIR_RootConstrainSelectedInstOperands,
     /*  453774 */     // GIR_Coverage, 7024,
     /*  453774 */     GIR_EraseRootFromParent_Done,
     /*  453775 */   // Label 7811: @453775
     /*  453775 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(453861), // Rule ID 7025 //
     /*  453780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  453791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  453794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  453797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453827 */     // MIs[1] Operand 1
     /*  453827 */     // No operand predicates
     /*  453827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453836 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453859 */     GIR_RootConstrainSelectedInstOperands,
     /*  453860 */     // GIR_Coverage, 7025,
     /*  453860 */     GIR_EraseRootFromParent_Done,
     /*  453861 */   // Label 7812: @453861
     /*  453861 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(453947), // Rule ID 7028 //
     /*  453866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453913 */     // MIs[1] Operand 1
     /*  453913 */     // No operand predicates
     /*  453913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453922 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453945 */     GIR_RootConstrainSelectedInstOperands,
     /*  453946 */     // GIR_Coverage, 7028,
     /*  453946 */     GIR_EraseRootFromParent_Done,
     /*  453947 */   // Label 7813: @453947
     /*  453947 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(454033), // Rule ID 7029 //
     /*  453952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453999 */     // MIs[1] Operand 1
     /*  453999 */     // No operand predicates
     /*  453999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454008 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  454011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454031 */     GIR_RootConstrainSelectedInstOperands,
     /*  454032 */     // GIR_Coverage, 7029,
     /*  454032 */     GIR_EraseRootFromParent_Done,
     /*  454033 */   // Label 7814: @454033
     /*  454033 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(454119), // Rule ID 7032 //
     /*  454038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  454049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  454052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  454055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454085 */     // MIs[1] Operand 1
     /*  454085 */     // No operand predicates
     /*  454085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454094 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  454097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454117 */     GIR_RootConstrainSelectedInstOperands,
     /*  454118 */     // GIR_Coverage, 7032,
     /*  454118 */     GIR_EraseRootFromParent_Done,
     /*  454119 */   // Label 7815: @454119
     /*  454119 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(454205), // Rule ID 7033 //
     /*  454124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  454135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  454138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  454141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454171 */     // MIs[1] Operand 1
     /*  454171 */     // No operand predicates
     /*  454171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454180 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  454183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454203 */     GIR_RootConstrainSelectedInstOperands,
     /*  454204 */     // GIR_Coverage, 7033,
     /*  454204 */     GIR_EraseRootFromParent_Done,
     /*  454205 */   // Label 7816: @454205
     /*  454205 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(454291), // Rule ID 7036 //
     /*  454210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  454221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  454224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  454227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454257 */     // MIs[1] Operand 1
     /*  454257 */     // No operand predicates
     /*  454257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454266 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  454266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  454269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454289 */     GIR_RootConstrainSelectedInstOperands,
     /*  454290 */     // GIR_Coverage, 7036,
     /*  454290 */     GIR_EraseRootFromParent_Done,
     /*  454291 */   // Label 7817: @454291
     /*  454291 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(454377), // Rule ID 7037 //
     /*  454296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  454307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  454310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  454313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454343 */     // MIs[1] Operand 1
     /*  454343 */     // No operand predicates
     /*  454343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  454352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  454355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454375 */     GIR_RootConstrainSelectedInstOperands,
     /*  454376 */     // GIR_Coverage, 7037,
     /*  454376 */     GIR_EraseRootFromParent_Done,
     /*  454377 */   // Label 7818: @454377
     /*  454377 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(454463), // Rule ID 7040 //
     /*  454382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  454393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  454396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  454399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454429 */     // MIs[1] Operand 1
     /*  454429 */     // No operand predicates
     /*  454429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454438 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454461 */     GIR_RootConstrainSelectedInstOperands,
     /*  454462 */     // GIR_Coverage, 7040,
     /*  454462 */     GIR_EraseRootFromParent_Done,
     /*  454463 */   // Label 7819: @454463
     /*  454463 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(454549), // Rule ID 7041 //
     /*  454468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  454479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  454482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  454485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454515 */     // MIs[1] Operand 1
     /*  454515 */     // No operand predicates
     /*  454515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454547 */     GIR_RootConstrainSelectedInstOperands,
     /*  454548 */     // GIR_Coverage, 7041,
     /*  454548 */     GIR_EraseRootFromParent_Done,
     /*  454549 */   // Label 7820: @454549
     /*  454549 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(454635), // Rule ID 7044 //
     /*  454554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  454565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  454568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  454571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454601 */     // MIs[1] Operand 1
     /*  454601 */     // No operand predicates
     /*  454601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454610 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454633 */     GIR_RootConstrainSelectedInstOperands,
     /*  454634 */     // GIR_Coverage, 7044,
     /*  454634 */     GIR_EraseRootFromParent_Done,
     /*  454635 */   // Label 7821: @454635
     /*  454635 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(454721), // Rule ID 7045 //
     /*  454640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  454651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  454654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  454657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454687 */     // MIs[1] Operand 1
     /*  454687 */     // No operand predicates
     /*  454687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454696 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454719 */     GIR_RootConstrainSelectedInstOperands,
     /*  454720 */     // GIR_Coverage, 7045,
     /*  454720 */     GIR_EraseRootFromParent_Done,
     /*  454721 */   // Label 7822: @454721
     /*  454721 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(454807), // Rule ID 7048 //
     /*  454726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  454737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  454740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  454743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454773 */     // MIs[1] Operand 1
     /*  454773 */     // No operand predicates
     /*  454773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454782 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  454782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454805 */     GIR_RootConstrainSelectedInstOperands,
     /*  454806 */     // GIR_Coverage, 7048,
     /*  454806 */     GIR_EraseRootFromParent_Done,
     /*  454807 */   // Label 7823: @454807
     /*  454807 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(454893), // Rule ID 7049 //
     /*  454812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  454823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  454826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  454829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454859 */     // MIs[1] Operand 1
     /*  454859 */     // No operand predicates
     /*  454859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  454868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454891 */     GIR_RootConstrainSelectedInstOperands,
     /*  454892 */     // GIR_Coverage, 7049,
     /*  454892 */     GIR_EraseRootFromParent_Done,
     /*  454893 */   // Label 7824: @454893
     /*  454893 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(454979), // Rule ID 7052 //
     /*  454898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  454901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454945 */     // MIs[1] Operand 1
     /*  454945 */     // No operand predicates
     /*  454945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454954 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  454954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454977 */     GIR_RootConstrainSelectedInstOperands,
     /*  454978 */     // GIR_Coverage, 7052,
     /*  454978 */     GIR_EraseRootFromParent_Done,
     /*  454979 */   // Label 7825: @454979
     /*  454979 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(455065), // Rule ID 7053 //
     /*  454984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  454987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  455001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455031 */     // MIs[1] Operand 1
     /*  455031 */     // No operand predicates
     /*  455031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  455040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  455043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  455060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455063 */     GIR_RootConstrainSelectedInstOperands,
     /*  455064 */     // GIR_Coverage, 7053,
     /*  455064 */     GIR_EraseRootFromParent_Done,
     /*  455065 */   // Label 7826: @455065
     /*  455065 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(455151), // Rule ID 7056 //
     /*  455070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  455081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  455084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  455087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455117 */     // MIs[1] Operand 1
     /*  455117 */     // No operand predicates
     /*  455117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455126 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  455126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455149 */     GIR_RootConstrainSelectedInstOperands,
     /*  455150 */     // GIR_Coverage, 7056,
     /*  455150 */     GIR_EraseRootFromParent_Done,
     /*  455151 */   // Label 7827: @455151
     /*  455151 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(455237), // Rule ID 7057 //
     /*  455156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  455167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  455170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  455173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455203 */     // MIs[1] Operand 1
     /*  455203 */     // No operand predicates
     /*  455203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455212 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  455212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455235 */     GIR_RootConstrainSelectedInstOperands,
     /*  455236 */     // GIR_Coverage, 7057,
     /*  455236 */     GIR_EraseRootFromParent_Done,
     /*  455237 */   // Label 7828: @455237
     /*  455237 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(455323), // Rule ID 7060 //
     /*  455242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  455253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  455256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  455259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455289 */     // MIs[1] Operand 1
     /*  455289 */     // No operand predicates
     /*  455289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455298 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  455298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455321 */     GIR_RootConstrainSelectedInstOperands,
     /*  455322 */     // GIR_Coverage, 7060,
     /*  455322 */     GIR_EraseRootFromParent_Done,
     /*  455323 */   // Label 7829: @455323
     /*  455323 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(455409), // Rule ID 7061 //
     /*  455328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  455339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  455342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  455345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455375 */     // MIs[1] Operand 1
     /*  455375 */     // No operand predicates
     /*  455375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  455384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455407 */     GIR_RootConstrainSelectedInstOperands,
     /*  455408 */     // GIR_Coverage, 7061,
     /*  455408 */     GIR_EraseRootFromParent_Done,
     /*  455409 */   // Label 7830: @455409
     /*  455409 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(455495), // Rule ID 7064 //
     /*  455414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  455425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  455428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  455431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455461 */     // MIs[1] Operand 1
     /*  455461 */     // No operand predicates
     /*  455461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455470 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  455470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455493 */     GIR_RootConstrainSelectedInstOperands,
     /*  455494 */     // GIR_Coverage, 7064,
     /*  455494 */     GIR_EraseRootFromParent_Done,
     /*  455495 */   // Label 7831: @455495
     /*  455495 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(455581), // Rule ID 7065 //
     /*  455500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  455511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  455514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  455517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455547 */     // MIs[1] Operand 1
     /*  455547 */     // No operand predicates
     /*  455547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455556 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  455556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455579 */     GIR_RootConstrainSelectedInstOperands,
     /*  455580 */     // GIR_Coverage, 7065,
     /*  455580 */     GIR_EraseRootFromParent_Done,
     /*  455581 */   // Label 7832: @455581
     /*  455581 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(455667), // Rule ID 7068 //
     /*  455586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  455597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  455600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  455603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455633 */     // MIs[1] Operand 1
     /*  455633 */     // No operand predicates
     /*  455633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455642 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455665 */     GIR_RootConstrainSelectedInstOperands,
     /*  455666 */     // GIR_Coverage, 7068,
     /*  455666 */     GIR_EraseRootFromParent_Done,
     /*  455667 */   // Label 7833: @455667
     /*  455667 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(455753), // Rule ID 7069 //
     /*  455672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  455683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  455686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  455689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455719 */     // MIs[1] Operand 1
     /*  455719 */     // No operand predicates
     /*  455719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455751 */     GIR_RootConstrainSelectedInstOperands,
     /*  455752 */     // GIR_Coverage, 7069,
     /*  455752 */     GIR_EraseRootFromParent_Done,
     /*  455753 */   // Label 7834: @455753
     /*  455753 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(455839), // Rule ID 7072 //
     /*  455758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  455769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  455772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  455775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455805 */     // MIs[1] Operand 1
     /*  455805 */     // No operand predicates
     /*  455805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455814 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455837 */     GIR_RootConstrainSelectedInstOperands,
     /*  455838 */     // GIR_Coverage, 7072,
     /*  455838 */     GIR_EraseRootFromParent_Done,
     /*  455839 */   // Label 7835: @455839
     /*  455839 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(455925), // Rule ID 7073 //
     /*  455844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  455855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  455858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  455861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455891 */     // MIs[1] Operand 1
     /*  455891 */     // No operand predicates
     /*  455891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455900 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455923 */     GIR_RootConstrainSelectedInstOperands,
     /*  455924 */     // GIR_Coverage, 7073,
     /*  455924 */     GIR_EraseRootFromParent_Done,
     /*  455925 */   // Label 7836: @455925
     /*  455925 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(456011), // Rule ID 7076 //
     /*  455930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  455941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  455944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  455947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455977 */     // MIs[1] Operand 1
     /*  455977 */     // No operand predicates
     /*  455977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455986 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  456006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456009 */     GIR_RootConstrainSelectedInstOperands,
     /*  456010 */     // GIR_Coverage, 7076,
     /*  456010 */     GIR_EraseRootFromParent_Done,
     /*  456011 */   // Label 7837: @456011
     /*  456011 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(456097), // Rule ID 7077 //
     /*  456016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  456027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  456030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  456033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456063 */     // MIs[1] Operand 1
     /*  456063 */     // No operand predicates
     /*  456063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456072 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  456072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  456092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456095 */     GIR_RootConstrainSelectedInstOperands,
     /*  456096 */     // GIR_Coverage, 7077,
     /*  456096 */     GIR_EraseRootFromParent_Done,
     /*  456097 */   // Label 7838: @456097
     /*  456097 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(456183), // Rule ID 7080 //
     /*  456102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  456113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  456116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  456119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456149 */     // MIs[1] Operand 1
     /*  456149 */     // No operand predicates
     /*  456149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456158 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  456158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  456161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456181 */     GIR_RootConstrainSelectedInstOperands,
     /*  456182 */     // GIR_Coverage, 7080,
     /*  456182 */     GIR_EraseRootFromParent_Done,
     /*  456183 */   // Label 7839: @456183
     /*  456183 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(456269), // Rule ID 7081 //
     /*  456188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  456199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  456202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  456205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456235 */     // MIs[1] Operand 1
     /*  456235 */     // No operand predicates
     /*  456235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  456247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456267 */     GIR_RootConstrainSelectedInstOperands,
     /*  456268 */     // GIR_Coverage, 7081,
     /*  456268 */     GIR_EraseRootFromParent_Done,
     /*  456269 */   // Label 7840: @456269
     /*  456269 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(456355), // Rule ID 7084 //
     /*  456274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  456285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  456288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  456291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456321 */     // MIs[1] Operand 1
     /*  456321 */     // No operand predicates
     /*  456321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456330 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  456330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  456333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456353 */     GIR_RootConstrainSelectedInstOperands,
     /*  456354 */     // GIR_Coverage, 7084,
     /*  456354 */     GIR_EraseRootFromParent_Done,
     /*  456355 */   // Label 7841: @456355
     /*  456355 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(456441), // Rule ID 7085 //
     /*  456360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  456371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  456374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  456377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456407 */     // MIs[1] Operand 1
     /*  456407 */     // No operand predicates
     /*  456407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  456419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456439 */     GIR_RootConstrainSelectedInstOperands,
     /*  456440 */     // GIR_Coverage, 7085,
     /*  456440 */     GIR_EraseRootFromParent_Done,
     /*  456441 */   // Label 7842: @456441
     /*  456441 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(456527), // Rule ID 7088 //
     /*  456446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  456457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  456460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  456463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456493 */     // MIs[1] Operand 1
     /*  456493 */     // No operand predicates
     /*  456493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456502 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  456502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456525 */     GIR_RootConstrainSelectedInstOperands,
     /*  456526 */     // GIR_Coverage, 7088,
     /*  456526 */     GIR_EraseRootFromParent_Done,
     /*  456527 */   // Label 7843: @456527
     /*  456527 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(456613), // Rule ID 7089 //
     /*  456532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  456543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  456546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  456549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456579 */     // MIs[1] Operand 1
     /*  456579 */     // No operand predicates
     /*  456579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456588 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456611 */     GIR_RootConstrainSelectedInstOperands,
     /*  456612 */     // GIR_Coverage, 7089,
     /*  456612 */     GIR_EraseRootFromParent_Done,
     /*  456613 */   // Label 7844: @456613
     /*  456613 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(456699), // Rule ID 7092 //
     /*  456618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  456629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  456632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  456635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456665 */     // MIs[1] Operand 1
     /*  456665 */     // No operand predicates
     /*  456665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456674 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  456677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456697 */     GIR_RootConstrainSelectedInstOperands,
     /*  456698 */     // GIR_Coverage, 7092,
     /*  456698 */     GIR_EraseRootFromParent_Done,
     /*  456699 */   // Label 7845: @456699
     /*  456699 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(456785), // Rule ID 7093 //
     /*  456704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  456715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  456718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  456721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456751 */     // MIs[1] Operand 1
     /*  456751 */     // No operand predicates
     /*  456751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  456763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456783 */     GIR_RootConstrainSelectedInstOperands,
     /*  456784 */     // GIR_Coverage, 7093,
     /*  456784 */     GIR_EraseRootFromParent_Done,
     /*  456785 */   // Label 7846: @456785
     /*  456785 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(456871), // Rule ID 7096 //
     /*  456790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  456801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  456804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  456807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456837 */     // MIs[1] Operand 1
     /*  456837 */     // No operand predicates
     /*  456837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  456849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456869 */     GIR_RootConstrainSelectedInstOperands,
     /*  456870 */     // GIR_Coverage, 7096,
     /*  456870 */     GIR_EraseRootFromParent_Done,
     /*  456871 */   // Label 7847: @456871
     /*  456871 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(456957), // Rule ID 7097 //
     /*  456876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  456887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  456890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  456893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456923 */     // MIs[1] Operand 1
     /*  456923 */     // No operand predicates
     /*  456923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456932 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  456935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456955 */     GIR_RootConstrainSelectedInstOperands,
     /*  456956 */     // GIR_Coverage, 7097,
     /*  456956 */     GIR_EraseRootFromParent_Done,
     /*  456957 */   // Label 7848: @456957
     /*  456957 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(457043), // Rule ID 7100 //
     /*  456962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  456973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  456976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  456979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457009 */     // MIs[1] Operand 1
     /*  457009 */     // No operand predicates
     /*  457009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457018 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  457018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  457021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  457038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457041 */     GIR_RootConstrainSelectedInstOperands,
     /*  457042 */     // GIR_Coverage, 7100,
     /*  457042 */     GIR_EraseRootFromParent_Done,
     /*  457043 */   // Label 7849: @457043
     /*  457043 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(457129), // Rule ID 7101 //
     /*  457048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  457051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  457059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  457062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  457065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457095 */     // MIs[1] Operand 1
     /*  457095 */     // No operand predicates
     /*  457095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457104 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  457104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  457107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  457124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457127 */     GIR_RootConstrainSelectedInstOperands,
     /*  457128 */     // GIR_Coverage, 7101,
     /*  457128 */     GIR_EraseRootFromParent_Done,
     /*  457129 */   // Label 7850: @457129
     /*  457129 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(457215), // Rule ID 7280 //
     /*  457134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  457145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  457148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  457151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457181 */     // MIs[1] Operand 1
     /*  457181 */     // No operand predicates
     /*  457181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457190 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  457193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457213 */     GIR_RootConstrainSelectedInstOperands,
     /*  457214 */     // GIR_Coverage, 7280,
     /*  457214 */     GIR_EraseRootFromParent_Done,
     /*  457215 */   // Label 7851: @457215
     /*  457215 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(457301), // Rule ID 7281 //
     /*  457220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  457231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  457234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  457237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457267 */     // MIs[1] Operand 1
     /*  457267 */     // No operand predicates
     /*  457267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457276 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  457279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457299 */     GIR_RootConstrainSelectedInstOperands,
     /*  457300 */     // GIR_Coverage, 7281,
     /*  457300 */     GIR_EraseRootFromParent_Done,
     /*  457301 */   // Label 7852: @457301
     /*  457301 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(457387), // Rule ID 7284 //
     /*  457306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  457317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  457320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  457323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457353 */     // MIs[1] Operand 1
     /*  457353 */     // No operand predicates
     /*  457353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457362 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  457365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457385 */     GIR_RootConstrainSelectedInstOperands,
     /*  457386 */     // GIR_Coverage, 7284,
     /*  457386 */     GIR_EraseRootFromParent_Done,
     /*  457387 */   // Label 7853: @457387
     /*  457387 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(457473), // Rule ID 7285 //
     /*  457392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  457403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  457406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  457409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457439 */     // MIs[1] Operand 1
     /*  457439 */     // No operand predicates
     /*  457439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457448 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  457451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457471 */     GIR_RootConstrainSelectedInstOperands,
     /*  457472 */     // GIR_Coverage, 7285,
     /*  457472 */     GIR_EraseRootFromParent_Done,
     /*  457473 */   // Label 7854: @457473
     /*  457473 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(457559), // Rule ID 7288 //
     /*  457478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  457489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  457492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  457495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457525 */     // MIs[1] Operand 1
     /*  457525 */     // No operand predicates
     /*  457525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457534 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457557 */     GIR_RootConstrainSelectedInstOperands,
     /*  457558 */     // GIR_Coverage, 7288,
     /*  457558 */     GIR_EraseRootFromParent_Done,
     /*  457559 */   // Label 7855: @457559
     /*  457559 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(457645), // Rule ID 7289 //
     /*  457564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  457575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  457578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  457581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457611 */     // MIs[1] Operand 1
     /*  457611 */     // No operand predicates
     /*  457611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457620 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457643 */     GIR_RootConstrainSelectedInstOperands,
     /*  457644 */     // GIR_Coverage, 7289,
     /*  457644 */     GIR_EraseRootFromParent_Done,
     /*  457645 */   // Label 7856: @457645
     /*  457645 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(457731), // Rule ID 7292 //
     /*  457650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  457661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  457664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  457667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457697 */     // MIs[1] Operand 1
     /*  457697 */     // No operand predicates
     /*  457697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  457709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457729 */     GIR_RootConstrainSelectedInstOperands,
     /*  457730 */     // GIR_Coverage, 7292,
     /*  457730 */     GIR_EraseRootFromParent_Done,
     /*  457731 */   // Label 7857: @457731
     /*  457731 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(457817), // Rule ID 7293 //
     /*  457736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  457747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  457750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  457753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457783 */     // MIs[1] Operand 1
     /*  457783 */     // No operand predicates
     /*  457783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457792 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  457795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457815 */     GIR_RootConstrainSelectedInstOperands,
     /*  457816 */     // GIR_Coverage, 7293,
     /*  457816 */     GIR_EraseRootFromParent_Done,
     /*  457817 */   // Label 7858: @457817
     /*  457817 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(457903), // Rule ID 7296 //
     /*  457822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  457833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  457836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  457839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457869 */     // MIs[1] Operand 1
     /*  457869 */     // No operand predicates
     /*  457869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457878 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457901 */     GIR_RootConstrainSelectedInstOperands,
     /*  457902 */     // GIR_Coverage, 7296,
     /*  457902 */     GIR_EraseRootFromParent_Done,
     /*  457903 */   // Label 7859: @457903
     /*  457903 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(457989), // Rule ID 7297 //
     /*  457908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  457919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  457922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  457925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457955 */     // MIs[1] Operand 1
     /*  457955 */     // No operand predicates
     /*  457955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457987 */     GIR_RootConstrainSelectedInstOperands,
     /*  457988 */     // GIR_Coverage, 7297,
     /*  457988 */     GIR_EraseRootFromParent_Done,
     /*  457989 */   // Label 7860: @457989
     /*  457989 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(458075), // Rule ID 7300 //
     /*  457994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  458005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  458008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  458011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458041 */     // MIs[1] Operand 1
     /*  458041 */     // No operand predicates
     /*  458041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458050 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  458050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  458053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458073 */     GIR_RootConstrainSelectedInstOperands,
     /*  458074 */     // GIR_Coverage, 7300,
     /*  458074 */     GIR_EraseRootFromParent_Done,
     /*  458075 */   // Label 7861: @458075
     /*  458075 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(458161), // Rule ID 7301 //
     /*  458080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  458091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  458094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  458097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458127 */     // MIs[1] Operand 1
     /*  458127 */     // No operand predicates
     /*  458127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458136 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  458136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  458139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458159 */     GIR_RootConstrainSelectedInstOperands,
     /*  458160 */     // GIR_Coverage, 7301,
     /*  458160 */     GIR_EraseRootFromParent_Done,
     /*  458161 */   // Label 7862: @458161
     /*  458161 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(458247), // Rule ID 7304 //
     /*  458166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  458177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  458180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  458183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458213 */     // MIs[1] Operand 1
     /*  458213 */     // No operand predicates
     /*  458213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458222 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458245 */     GIR_RootConstrainSelectedInstOperands,
     /*  458246 */     // GIR_Coverage, 7304,
     /*  458246 */     GIR_EraseRootFromParent_Done,
     /*  458247 */   // Label 7863: @458247
     /*  458247 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(458333), // Rule ID 7305 //
     /*  458252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  458263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  458266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  458269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458299 */     // MIs[1] Operand 1
     /*  458299 */     // No operand predicates
     /*  458299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458308 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458331 */     GIR_RootConstrainSelectedInstOperands,
     /*  458332 */     // GIR_Coverage, 7305,
     /*  458332 */     GIR_EraseRootFromParent_Done,
     /*  458333 */   // Label 7864: @458333
     /*  458333 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(458419), // Rule ID 7308 //
     /*  458338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  458349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  458352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  458355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458385 */     // MIs[1] Operand 1
     /*  458385 */     // No operand predicates
     /*  458385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  458394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458417 */     GIR_RootConstrainSelectedInstOperands,
     /*  458418 */     // GIR_Coverage, 7308,
     /*  458418 */     GIR_EraseRootFromParent_Done,
     /*  458419 */   // Label 7865: @458419
     /*  458419 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(458505), // Rule ID 7309 //
     /*  458424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  458435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  458438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  458441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458471 */     // MIs[1] Operand 1
     /*  458471 */     // No operand predicates
     /*  458471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458480 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  458480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458503 */     GIR_RootConstrainSelectedInstOperands,
     /*  458504 */     // GIR_Coverage, 7309,
     /*  458504 */     GIR_EraseRootFromParent_Done,
     /*  458505 */   // Label 7866: @458505
     /*  458505 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(458591), // Rule ID 7312 //
     /*  458510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  458521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  458524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  458527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458557 */     // MIs[1] Operand 1
     /*  458557 */     // No operand predicates
     /*  458557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458566 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  458566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458589 */     GIR_RootConstrainSelectedInstOperands,
     /*  458590 */     // GIR_Coverage, 7312,
     /*  458590 */     GIR_EraseRootFromParent_Done,
     /*  458591 */   // Label 7867: @458591
     /*  458591 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(458677), // Rule ID 7313 //
     /*  458596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  458607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  458610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  458613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458643 */     // MIs[1] Operand 1
     /*  458643 */     // No operand predicates
     /*  458643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  458652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458675 */     GIR_RootConstrainSelectedInstOperands,
     /*  458676 */     // GIR_Coverage, 7313,
     /*  458676 */     GIR_EraseRootFromParent_Done,
     /*  458677 */   // Label 7868: @458677
     /*  458677 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(458763), // Rule ID 7316 //
     /*  458682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  458685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  458693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  458696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  458699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458729 */     // MIs[1] Operand 1
     /*  458729 */     // No operand predicates
     /*  458729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458738 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  458738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458761 */     GIR_RootConstrainSelectedInstOperands,
     /*  458762 */     // GIR_Coverage, 7316,
     /*  458762 */     GIR_EraseRootFromParent_Done,
     /*  458763 */   // Label 7869: @458763
     /*  458763 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(458849), // Rule ID 7317 //
     /*  458768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  458771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  458779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  458782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  458785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458815 */     // MIs[1] Operand 1
     /*  458815 */     // No operand predicates
     /*  458815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458824 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  458824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458847 */     GIR_RootConstrainSelectedInstOperands,
     /*  458848 */     // GIR_Coverage, 7317,
     /*  458848 */     GIR_EraseRootFromParent_Done,
     /*  458849 */   // Label 7870: @458849
     /*  458849 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(458935), // Rule ID 7320 //
     /*  458854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  458865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  458868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  458871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458901 */     // MIs[1] Operand 1
     /*  458901 */     // No operand predicates
     /*  458901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458910 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458933 */     GIR_RootConstrainSelectedInstOperands,
     /*  458934 */     // GIR_Coverage, 7320,
     /*  458934 */     GIR_EraseRootFromParent_Done,
     /*  458935 */   // Label 7871: @458935
     /*  458935 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(459021), // Rule ID 7321 //
     /*  458940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  458951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  458954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  458957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458987 */     // MIs[1] Operand 1
     /*  458987 */     // No operand predicates
     /*  458987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459019 */     GIR_RootConstrainSelectedInstOperands,
     /*  459020 */     // GIR_Coverage, 7321,
     /*  459020 */     GIR_EraseRootFromParent_Done,
     /*  459021 */   // Label 7872: @459021
     /*  459021 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(459107), // Rule ID 7324 //
     /*  459026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  459037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  459040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  459043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459073 */     // MIs[1] Operand 1
     /*  459073 */     // No operand predicates
     /*  459073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459082 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  459082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459105 */     GIR_RootConstrainSelectedInstOperands,
     /*  459106 */     // GIR_Coverage, 7324,
     /*  459106 */     GIR_EraseRootFromParent_Done,
     /*  459107 */   // Label 7873: @459107
     /*  459107 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(459193), // Rule ID 7325 //
     /*  459112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  459123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  459126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  459129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459159 */     // MIs[1] Operand 1
     /*  459159 */     // No operand predicates
     /*  459159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459168 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  459168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459191 */     GIR_RootConstrainSelectedInstOperands,
     /*  459192 */     // GIR_Coverage, 7325,
     /*  459192 */     GIR_EraseRootFromParent_Done,
     /*  459193 */   // Label 7874: @459193
     /*  459193 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(459279), // Rule ID 7328 //
     /*  459198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  459209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  459212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  459215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459245 */     // MIs[1] Operand 1
     /*  459245 */     // No operand predicates
     /*  459245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459254 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  459254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459277 */     GIR_RootConstrainSelectedInstOperands,
     /*  459278 */     // GIR_Coverage, 7328,
     /*  459278 */     GIR_EraseRootFromParent_Done,
     /*  459279 */   // Label 7875: @459279
     /*  459279 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(459365), // Rule ID 7329 //
     /*  459284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  459295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  459298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  459301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459331 */     // MIs[1] Operand 1
     /*  459331 */     // No operand predicates
     /*  459331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459340 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  459340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459363 */     GIR_RootConstrainSelectedInstOperands,
     /*  459364 */     // GIR_Coverage, 7329,
     /*  459364 */     GIR_EraseRootFromParent_Done,
     /*  459365 */   // Label 7876: @459365
     /*  459365 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(459451), // Rule ID 7332 //
     /*  459370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  459381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  459384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  459387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459417 */     // MIs[1] Operand 1
     /*  459417 */     // No operand predicates
     /*  459417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459426 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459449 */     GIR_RootConstrainSelectedInstOperands,
     /*  459450 */     // GIR_Coverage, 7332,
     /*  459450 */     GIR_EraseRootFromParent_Done,
     /*  459451 */   // Label 7877: @459451
     /*  459451 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(459537), // Rule ID 7333 //
     /*  459456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  459467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  459470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  459473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459503 */     // MIs[1] Operand 1
     /*  459503 */     // No operand predicates
     /*  459503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459512 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459535 */     GIR_RootConstrainSelectedInstOperands,
     /*  459536 */     // GIR_Coverage, 7333,
     /*  459536 */     GIR_EraseRootFromParent_Done,
     /*  459537 */   // Label 7878: @459537
     /*  459537 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(459623), // Rule ID 7336 //
     /*  459542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  459553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  459556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  459559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459589 */     // MIs[1] Operand 1
     /*  459589 */     // No operand predicates
     /*  459589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459598 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459621 */     GIR_RootConstrainSelectedInstOperands,
     /*  459622 */     // GIR_Coverage, 7336,
     /*  459622 */     GIR_EraseRootFromParent_Done,
     /*  459623 */   // Label 7879: @459623
     /*  459623 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(459709), // Rule ID 7337 //
     /*  459628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  459639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  459642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  459645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459675 */     // MIs[1] Operand 1
     /*  459675 */     // No operand predicates
     /*  459675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459707 */     GIR_RootConstrainSelectedInstOperands,
     /*  459708 */     // GIR_Coverage, 7337,
     /*  459708 */     GIR_EraseRootFromParent_Done,
     /*  459709 */   // Label 7880: @459709
     /*  459709 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(459795), // Rule ID 7340 //
     /*  459714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  459725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  459728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  459731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459761 */     // MIs[1] Operand 1
     /*  459761 */     // No operand predicates
     /*  459761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459770 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459793 */     GIR_RootConstrainSelectedInstOperands,
     /*  459794 */     // GIR_Coverage, 7340,
     /*  459794 */     GIR_EraseRootFromParent_Done,
     /*  459795 */   // Label 7881: @459795
     /*  459795 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(459881), // Rule ID 7341 //
     /*  459800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  459811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  459814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  459817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459847 */     // MIs[1] Operand 1
     /*  459847 */     // No operand predicates
     /*  459847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459856 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459879 */     GIR_RootConstrainSelectedInstOperands,
     /*  459880 */     // GIR_Coverage, 7341,
     /*  459880 */     GIR_EraseRootFromParent_Done,
     /*  459881 */   // Label 7882: @459881
     /*  459881 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(459967), // Rule ID 7344 //
     /*  459886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459933 */     // MIs[1] Operand 1
     /*  459933 */     // No operand predicates
     /*  459933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459965 */     GIR_RootConstrainSelectedInstOperands,
     /*  459966 */     // GIR_Coverage, 7344,
     /*  459966 */     GIR_EraseRootFromParent_Done,
     /*  459967 */   // Label 7883: @459967
     /*  459967 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(460053), // Rule ID 7345 //
     /*  459972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460019 */     // MIs[1] Operand 1
     /*  460019 */     // No operand predicates
     /*  460019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460028 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  460028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  460031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  460048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460051 */     GIR_RootConstrainSelectedInstOperands,
     /*  460052 */     // GIR_Coverage, 7345,
     /*  460052 */     GIR_EraseRootFromParent_Done,
     /*  460053 */   // Label 7884: @460053
     /*  460053 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(460139), // Rule ID 7348 //
     /*  460058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  460069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  460072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  460075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460105 */     // MIs[1] Operand 1
     /*  460105 */     // No operand predicates
     /*  460105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460114 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  460114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  460117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  460134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460137 */     GIR_RootConstrainSelectedInstOperands,
     /*  460138 */     // GIR_Coverage, 7348,
     /*  460138 */     GIR_EraseRootFromParent_Done,
     /*  460139 */   // Label 7885: @460139
     /*  460139 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(460225), // Rule ID 7349 //
     /*  460144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  460155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  460158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  460161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460191 */     // MIs[1] Operand 1
     /*  460191 */     // No operand predicates
     /*  460191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460200 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  460200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  460203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  460220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460223 */     GIR_RootConstrainSelectedInstOperands,
     /*  460224 */     // GIR_Coverage, 7349,
     /*  460224 */     GIR_EraseRootFromParent_Done,
     /*  460225 */   // Label 7886: @460225
     /*  460225 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(460311), // Rule ID 7352 //
     /*  460230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  460241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  460244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  460247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460277 */     // MIs[1] Operand 1
     /*  460277 */     // No operand predicates
     /*  460277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460286 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  460286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  460289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  460306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460309 */     GIR_RootConstrainSelectedInstOperands,
     /*  460310 */     // GIR_Coverage, 7352,
     /*  460310 */     GIR_EraseRootFromParent_Done,
     /*  460311 */   // Label 7887: @460311
     /*  460311 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(460397), // Rule ID 7353 //
     /*  460316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  460327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  460330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  460333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460363 */     // MIs[1] Operand 1
     /*  460363 */     // No operand predicates
     /*  460363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460372 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  460372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  460375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  460392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460395 */     GIR_RootConstrainSelectedInstOperands,
     /*  460396 */     // GIR_Coverage, 7353,
     /*  460396 */     GIR_EraseRootFromParent_Done,
     /*  460397 */   // Label 7888: @460397
     /*  460397 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(460483), // Rule ID 7356 //
     /*  460402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  460413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  460416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  460419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460449 */     // MIs[1] Operand 1
     /*  460449 */     // No operand predicates
     /*  460449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460458 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  460461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460481 */     GIR_RootConstrainSelectedInstOperands,
     /*  460482 */     // GIR_Coverage, 7356,
     /*  460482 */     GIR_EraseRootFromParent_Done,
     /*  460483 */   // Label 7889: @460483
     /*  460483 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(460569), // Rule ID 7357 //
     /*  460488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  460499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  460502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  460505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460535 */     // MIs[1] Operand 1
     /*  460535 */     // No operand predicates
     /*  460535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460544 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  460547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460567 */     GIR_RootConstrainSelectedInstOperands,
     /*  460568 */     // GIR_Coverage, 7357,
     /*  460568 */     GIR_EraseRootFromParent_Done,
     /*  460569 */   // Label 7890: @460569
     /*  460569 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(460655), // Rule ID 7360 //
     /*  460574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  460585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  460588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  460591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460621 */     // MIs[1] Operand 1
     /*  460621 */     // No operand predicates
     /*  460621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460630 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  460633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460653 */     GIR_RootConstrainSelectedInstOperands,
     /*  460654 */     // GIR_Coverage, 7360,
     /*  460654 */     GIR_EraseRootFromParent_Done,
     /*  460655 */   // Label 7891: @460655
     /*  460655 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(460741), // Rule ID 7361 //
     /*  460660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  460671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  460674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  460677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460707 */     // MIs[1] Operand 1
     /*  460707 */     // No operand predicates
     /*  460707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460716 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  460719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460739 */     GIR_RootConstrainSelectedInstOperands,
     /*  460740 */     // GIR_Coverage, 7361,
     /*  460740 */     GIR_EraseRootFromParent_Done,
     /*  460741 */   // Label 7892: @460741
     /*  460741 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(460827), // Rule ID 7364 //
     /*  460746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  460757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  460760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  460763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460793 */     // MIs[1] Operand 1
     /*  460793 */     // No operand predicates
     /*  460793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460802 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  460805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460825 */     GIR_RootConstrainSelectedInstOperands,
     /*  460826 */     // GIR_Coverage, 7364,
     /*  460826 */     GIR_EraseRootFromParent_Done,
     /*  460827 */   // Label 7893: @460827
     /*  460827 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(460913), // Rule ID 7365 //
     /*  460832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  460843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  460846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  460849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460879 */     // MIs[1] Operand 1
     /*  460879 */     // No operand predicates
     /*  460879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460888 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  460891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460911 */     GIR_RootConstrainSelectedInstOperands,
     /*  460912 */     // GIR_Coverage, 7365,
     /*  460912 */     GIR_EraseRootFromParent_Done,
     /*  460913 */   // Label 7894: @460913
     /*  460913 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(460999), // Rule ID 7576 //
     /*  460918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  460929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  460932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  460935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460965 */     // MIs[1] Operand 1
     /*  460965 */     // No operand predicates
     /*  460965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460974 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  460977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460997 */     GIR_RootConstrainSelectedInstOperands,
     /*  460998 */     // GIR_Coverage, 7576,
     /*  460998 */     GIR_EraseRootFromParent_Done,
     /*  460999 */   // Label 7895: @460999
     /*  460999 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(461085), // Rule ID 7577 //
     /*  461004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  461015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  461018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  461021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461051 */     // MIs[1] Operand 1
     /*  461051 */     // No operand predicates
     /*  461051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461060 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  461063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461083 */     GIR_RootConstrainSelectedInstOperands,
     /*  461084 */     // GIR_Coverage, 7577,
     /*  461084 */     GIR_EraseRootFromParent_Done,
     /*  461085 */   // Label 7896: @461085
     /*  461085 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(461171), // Rule ID 7580 //
     /*  461090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  461101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  461104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  461107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461137 */     // MIs[1] Operand 1
     /*  461137 */     // No operand predicates
     /*  461137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461146 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  461149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461169 */     GIR_RootConstrainSelectedInstOperands,
     /*  461170 */     // GIR_Coverage, 7580,
     /*  461170 */     GIR_EraseRootFromParent_Done,
     /*  461171 */   // Label 7897: @461171
     /*  461171 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(461257), // Rule ID 7581 //
     /*  461176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  461187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  461190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  461193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461223 */     // MIs[1] Operand 1
     /*  461223 */     // No operand predicates
     /*  461223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461232 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  461235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461255 */     GIR_RootConstrainSelectedInstOperands,
     /*  461256 */     // GIR_Coverage, 7581,
     /*  461256 */     GIR_EraseRootFromParent_Done,
     /*  461257 */   // Label 7898: @461257
     /*  461257 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(461343), // Rule ID 7584 //
     /*  461262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  461273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  461276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  461279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461309 */     // MIs[1] Operand 1
     /*  461309 */     // No operand predicates
     /*  461309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461318 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  461321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461341 */     GIR_RootConstrainSelectedInstOperands,
     /*  461342 */     // GIR_Coverage, 7584,
     /*  461342 */     GIR_EraseRootFromParent_Done,
     /*  461343 */   // Label 7899: @461343
     /*  461343 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(461429), // Rule ID 7585 //
     /*  461348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  461359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  461362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  461365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461395 */     // MIs[1] Operand 1
     /*  461395 */     // No operand predicates
     /*  461395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461404 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  461407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461427 */     GIR_RootConstrainSelectedInstOperands,
     /*  461428 */     // GIR_Coverage, 7585,
     /*  461428 */     GIR_EraseRootFromParent_Done,
     /*  461429 */   // Label 7900: @461429
     /*  461429 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(461515), // Rule ID 7588 //
     /*  461434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  461445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  461448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  461451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461481 */     // MIs[1] Operand 1
     /*  461481 */     // No operand predicates
     /*  461481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461490 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461513 */     GIR_RootConstrainSelectedInstOperands,
     /*  461514 */     // GIR_Coverage, 7588,
     /*  461514 */     GIR_EraseRootFromParent_Done,
     /*  461515 */   // Label 7901: @461515
     /*  461515 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(461601), // Rule ID 7589 //
     /*  461520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  461531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  461534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  461537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461567 */     // MIs[1] Operand 1
     /*  461567 */     // No operand predicates
     /*  461567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461576 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461599 */     GIR_RootConstrainSelectedInstOperands,
     /*  461600 */     // GIR_Coverage, 7589,
     /*  461600 */     GIR_EraseRootFromParent_Done,
     /*  461601 */   // Label 7902: @461601
     /*  461601 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(461687), // Rule ID 7592 //
     /*  461606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  461617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  461620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  461623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461653 */     // MIs[1] Operand 1
     /*  461653 */     // No operand predicates
     /*  461653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461662 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  461665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461685 */     GIR_RootConstrainSelectedInstOperands,
     /*  461686 */     // GIR_Coverage, 7592,
     /*  461686 */     GIR_EraseRootFromParent_Done,
     /*  461687 */   // Label 7903: @461687
     /*  461687 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(461773), // Rule ID 7593 //
     /*  461692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  461703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  461706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  461709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461739 */     // MIs[1] Operand 1
     /*  461739 */     // No operand predicates
     /*  461739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461748 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  461751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461771 */     GIR_RootConstrainSelectedInstOperands,
     /*  461772 */     // GIR_Coverage, 7593,
     /*  461772 */     GIR_EraseRootFromParent_Done,
     /*  461773 */   // Label 7904: @461773
     /*  461773 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(461859), // Rule ID 7596 //
     /*  461778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  461789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  461792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  461795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461825 */     // MIs[1] Operand 1
     /*  461825 */     // No operand predicates
     /*  461825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  461837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461857 */     GIR_RootConstrainSelectedInstOperands,
     /*  461858 */     // GIR_Coverage, 7596,
     /*  461858 */     GIR_EraseRootFromParent_Done,
     /*  461859 */   // Label 7905: @461859
     /*  461859 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(461945), // Rule ID 7597 //
     /*  461864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  461875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  461878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  461881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461911 */     // MIs[1] Operand 1
     /*  461911 */     // No operand predicates
     /*  461911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461920 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  461923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461943 */     GIR_RootConstrainSelectedInstOperands,
     /*  461944 */     // GIR_Coverage, 7597,
     /*  461944 */     GIR_EraseRootFromParent_Done,
     /*  461945 */   // Label 7906: @461945
     /*  461945 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(462031), // Rule ID 7600 //
     /*  461950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  461961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  461964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  461967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461997 */     // MIs[1] Operand 1
     /*  461997 */     // No operand predicates
     /*  461997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462006 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  462009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462029 */     GIR_RootConstrainSelectedInstOperands,
     /*  462030 */     // GIR_Coverage, 7600,
     /*  462030 */     GIR_EraseRootFromParent_Done,
     /*  462031 */   // Label 7907: @462031
     /*  462031 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(462117), // Rule ID 7601 //
     /*  462036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  462047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  462050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  462053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462083 */     // MIs[1] Operand 1
     /*  462083 */     // No operand predicates
     /*  462083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462092 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  462095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462115 */     GIR_RootConstrainSelectedInstOperands,
     /*  462116 */     // GIR_Coverage, 7601,
     /*  462116 */     GIR_EraseRootFromParent_Done,
     /*  462117 */   // Label 7908: @462117
     /*  462117 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(462203), // Rule ID 7604 //
     /*  462122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  462133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  462136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  462139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462169 */     // MIs[1] Operand 1
     /*  462169 */     // No operand predicates
     /*  462169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462178 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  462181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462201 */     GIR_RootConstrainSelectedInstOperands,
     /*  462202 */     // GIR_Coverage, 7604,
     /*  462202 */     GIR_EraseRootFromParent_Done,
     /*  462203 */   // Label 7909: @462203
     /*  462203 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(462289), // Rule ID 7605 //
     /*  462208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  462219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  462222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  462225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462255 */     // MIs[1] Operand 1
     /*  462255 */     // No operand predicates
     /*  462255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  462267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462287 */     GIR_RootConstrainSelectedInstOperands,
     /*  462288 */     // GIR_Coverage, 7605,
     /*  462288 */     GIR_EraseRootFromParent_Done,
     /*  462289 */   // Label 7910: @462289
     /*  462289 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(462375), // Rule ID 7608 //
     /*  462294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  462305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  462308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  462311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462341 */     // MIs[1] Operand 1
     /*  462341 */     // No operand predicates
     /*  462341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462350 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  462353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462373 */     GIR_RootConstrainSelectedInstOperands,
     /*  462374 */     // GIR_Coverage, 7608,
     /*  462374 */     GIR_EraseRootFromParent_Done,
     /*  462375 */   // Label 7911: @462375
     /*  462375 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(462461), // Rule ID 7609 //
     /*  462380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  462391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  462394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  462397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462427 */     // MIs[1] Operand 1
     /*  462427 */     // No operand predicates
     /*  462427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462436 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  462439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462459 */     GIR_RootConstrainSelectedInstOperands,
     /*  462460 */     // GIR_Coverage, 7609,
     /*  462460 */     GIR_EraseRootFromParent_Done,
     /*  462461 */   // Label 7912: @462461
     /*  462461 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(462547), // Rule ID 7612 //
     /*  462466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  462477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  462480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  462483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462513 */     // MIs[1] Operand 1
     /*  462513 */     // No operand predicates
     /*  462513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462522 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462545 */     GIR_RootConstrainSelectedInstOperands,
     /*  462546 */     // GIR_Coverage, 7612,
     /*  462546 */     GIR_EraseRootFromParent_Done,
     /*  462547 */   // Label 7913: @462547
     /*  462547 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(462633), // Rule ID 7613 //
     /*  462552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  462563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  462566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  462569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462599 */     // MIs[1] Operand 1
     /*  462599 */     // No operand predicates
     /*  462599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462608 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462631 */     GIR_RootConstrainSelectedInstOperands,
     /*  462632 */     // GIR_Coverage, 7613,
     /*  462632 */     GIR_EraseRootFromParent_Done,
     /*  462633 */   // Label 7914: @462633
     /*  462633 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(462719), // Rule ID 7616 //
     /*  462638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  462649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  462652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  462655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462685 */     // MIs[1] Operand 1
     /*  462685 */     // No operand predicates
     /*  462685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462694 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462717 */     GIR_RootConstrainSelectedInstOperands,
     /*  462718 */     // GIR_Coverage, 7616,
     /*  462718 */     GIR_EraseRootFromParent_Done,
     /*  462719 */   // Label 7915: @462719
     /*  462719 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(462805), // Rule ID 7617 //
     /*  462724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  462735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  462738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  462741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462771 */     // MIs[1] Operand 1
     /*  462771 */     // No operand predicates
     /*  462771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462780 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462803 */     GIR_RootConstrainSelectedInstOperands,
     /*  462804 */     // GIR_Coverage, 7617,
     /*  462804 */     GIR_EraseRootFromParent_Done,
     /*  462805 */   // Label 7916: @462805
     /*  462805 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(462891), // Rule ID 7620 //
     /*  462810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  462821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  462824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  462827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462857 */     // MIs[1] Operand 1
     /*  462857 */     // No operand predicates
     /*  462857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462866 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  462869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462889 */     GIR_RootConstrainSelectedInstOperands,
     /*  462890 */     // GIR_Coverage, 7620,
     /*  462890 */     GIR_EraseRootFromParent_Done,
     /*  462891 */   // Label 7917: @462891
     /*  462891 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(462977), // Rule ID 7621 //
     /*  462896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  462907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  462910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  462913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462943 */     // MIs[1] Operand 1
     /*  462943 */     // No operand predicates
     /*  462943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462952 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  462955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462975 */     GIR_RootConstrainSelectedInstOperands,
     /*  462976 */     // GIR_Coverage, 7621,
     /*  462976 */     GIR_EraseRootFromParent_Done,
     /*  462977 */   // Label 7918: @462977
     /*  462977 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(463063), // Rule ID 7624 //
     /*  462982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  462993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  462996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  462999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463029 */     // MIs[1] Operand 1
     /*  463029 */     // No operand predicates
     /*  463029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  463041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463061 */     GIR_RootConstrainSelectedInstOperands,
     /*  463062 */     // GIR_Coverage, 7624,
     /*  463062 */     GIR_EraseRootFromParent_Done,
     /*  463063 */   // Label 7919: @463063
     /*  463063 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(463149), // Rule ID 7625 //
     /*  463068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  463071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  463076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  463079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  463082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  463085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463115 */     // MIs[1] Operand 1
     /*  463115 */     // No operand predicates
     /*  463115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463124 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  463127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463147 */     GIR_RootConstrainSelectedInstOperands,
     /*  463148 */     // GIR_Coverage, 7625,
     /*  463148 */     GIR_EraseRootFromParent_Done,
     /*  463149 */   // Label 7920: @463149
     /*  463149 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(463235), // Rule ID 7628 //
     /*  463154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  463157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  463162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  463165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  463168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  463171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463201 */     // MIs[1] Operand 1
     /*  463201 */     // No operand predicates
     /*  463201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  463213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463233 */     GIR_RootConstrainSelectedInstOperands,
     /*  463234 */     // GIR_Coverage, 7628,
     /*  463234 */     GIR_EraseRootFromParent_Done,
     /*  463235 */   // Label 7921: @463235
     /*  463235 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(463321), // Rule ID 7629 //
     /*  463240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  463243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  463248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  463251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  463254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  463257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463287 */     // MIs[1] Operand 1
     /*  463287 */     // No operand predicates
     /*  463287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  463299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463319 */     GIR_RootConstrainSelectedInstOperands,
     /*  463320 */     // GIR_Coverage, 7629,
     /*  463320 */     GIR_EraseRootFromParent_Done,
     /*  463321 */   // Label 7922: @463321
     /*  463321 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(463407), // Rule ID 7632 //
     /*  463326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  463329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  463334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  463337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  463340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  463343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463373 */     // MIs[1] Operand 1
     /*  463373 */     // No operand predicates
     /*  463373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463382 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  463385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463405 */     GIR_RootConstrainSelectedInstOperands,
     /*  463406 */     // GIR_Coverage, 7632,
     /*  463406 */     GIR_EraseRootFromParent_Done,
     /*  463407 */   // Label 7923: @463407
     /*  463407 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(463493), // Rule ID 7633 //
     /*  463412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  463415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  463420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  463423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  463426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  463429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463459 */     // MIs[1] Operand 1
     /*  463459 */     // No operand predicates
     /*  463459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  463471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463491 */     GIR_RootConstrainSelectedInstOperands,
     /*  463492 */     // GIR_Coverage, 7633,
     /*  463492 */     GIR_EraseRootFromParent_Done,
     /*  463493 */   // Label 7924: @463493
     /*  463493 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(463579), // Rule ID 7756 //
     /*  463498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  463509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  463512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  463515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463545 */     // MIs[1] Operand 1
     /*  463545 */     // No operand predicates
     /*  463545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463554 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  463557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463577 */     GIR_RootConstrainSelectedInstOperands,
     /*  463578 */     // GIR_Coverage, 7756,
     /*  463578 */     GIR_EraseRootFromParent_Done,
     /*  463579 */   // Label 7925: @463579
     /*  463579 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(463665), // Rule ID 7757 //
     /*  463584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  463595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  463598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  463601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463631 */     // MIs[1] Operand 1
     /*  463631 */     // No operand predicates
     /*  463631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463640 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  463643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463663 */     GIR_RootConstrainSelectedInstOperands,
     /*  463664 */     // GIR_Coverage, 7757,
     /*  463664 */     GIR_EraseRootFromParent_Done,
     /*  463665 */   // Label 7926: @463665
     /*  463665 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(463751), // Rule ID 7760 //
     /*  463670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  463681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  463684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  463687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463717 */     // MIs[1] Operand 1
     /*  463717 */     // No operand predicates
     /*  463717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463726 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  463729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463749 */     GIR_RootConstrainSelectedInstOperands,
     /*  463750 */     // GIR_Coverage, 7760,
     /*  463750 */     GIR_EraseRootFromParent_Done,
     /*  463751 */   // Label 7927: @463751
     /*  463751 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(463837), // Rule ID 7761 //
     /*  463756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  463767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  463770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  463773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463803 */     // MIs[1] Operand 1
     /*  463803 */     // No operand predicates
     /*  463803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463812 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  463815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463835 */     GIR_RootConstrainSelectedInstOperands,
     /*  463836 */     // GIR_Coverage, 7761,
     /*  463836 */     GIR_EraseRootFromParent_Done,
     /*  463837 */   // Label 7928: @463837
     /*  463837 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(463923), // Rule ID 7764 //
     /*  463842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  463853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  463856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  463859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463889 */     // MIs[1] Operand 1
     /*  463889 */     // No operand predicates
     /*  463889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463898 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  463901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463921 */     GIR_RootConstrainSelectedInstOperands,
     /*  463922 */     // GIR_Coverage, 7764,
     /*  463922 */     GIR_EraseRootFromParent_Done,
     /*  463923 */   // Label 7929: @463923
     /*  463923 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(464009), // Rule ID 7765 //
     /*  463928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  463939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  463942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  463945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463975 */     // MIs[1] Operand 1
     /*  463975 */     // No operand predicates
     /*  463975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463984 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  463987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464007 */     GIR_RootConstrainSelectedInstOperands,
     /*  464008 */     // GIR_Coverage, 7765,
     /*  464008 */     GIR_EraseRootFromParent_Done,
     /*  464009 */   // Label 7930: @464009
     /*  464009 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(464095), // Rule ID 7768 //
     /*  464014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  464025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  464028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  464031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464061 */     // MIs[1] Operand 1
     /*  464061 */     // No operand predicates
     /*  464061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464093 */     GIR_RootConstrainSelectedInstOperands,
     /*  464094 */     // GIR_Coverage, 7768,
     /*  464094 */     GIR_EraseRootFromParent_Done,
     /*  464095 */   // Label 7931: @464095
     /*  464095 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(464181), // Rule ID 7769 //
     /*  464100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  464111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  464114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  464117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464147 */     // MIs[1] Operand 1
     /*  464147 */     // No operand predicates
     /*  464147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464156 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464179 */     GIR_RootConstrainSelectedInstOperands,
     /*  464180 */     // GIR_Coverage, 7769,
     /*  464180 */     GIR_EraseRootFromParent_Done,
     /*  464181 */   // Label 7932: @464181
     /*  464181 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(464267), // Rule ID 7772 //
     /*  464186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  464197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  464200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  464203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464233 */     // MIs[1] Operand 1
     /*  464233 */     // No operand predicates
     /*  464233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464242 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  464245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464265 */     GIR_RootConstrainSelectedInstOperands,
     /*  464266 */     // GIR_Coverage, 7772,
     /*  464266 */     GIR_EraseRootFromParent_Done,
     /*  464267 */   // Label 7933: @464267
     /*  464267 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(464353), // Rule ID 7773 //
     /*  464272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  464283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  464286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  464289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464319 */     // MIs[1] Operand 1
     /*  464319 */     // No operand predicates
     /*  464319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464328 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  464331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464351 */     GIR_RootConstrainSelectedInstOperands,
     /*  464352 */     // GIR_Coverage, 7773,
     /*  464352 */     GIR_EraseRootFromParent_Done,
     /*  464353 */   // Label 7934: @464353
     /*  464353 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(464439), // Rule ID 7776 //
     /*  464358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  464369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  464372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  464375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464405 */     // MIs[1] Operand 1
     /*  464405 */     // No operand predicates
     /*  464405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464414 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464437 */     GIR_RootConstrainSelectedInstOperands,
     /*  464438 */     // GIR_Coverage, 7776,
     /*  464438 */     GIR_EraseRootFromParent_Done,
     /*  464439 */   // Label 7935: @464439
     /*  464439 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(464525), // Rule ID 7777 //
     /*  464444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  464455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  464458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  464461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464491 */     // MIs[1] Operand 1
     /*  464491 */     // No operand predicates
     /*  464491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464500 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464523 */     GIR_RootConstrainSelectedInstOperands,
     /*  464524 */     // GIR_Coverage, 7777,
     /*  464524 */     GIR_EraseRootFromParent_Done,
     /*  464525 */   // Label 7936: @464525
     /*  464525 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(464611), // Rule ID 7780 //
     /*  464530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  464541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  464544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  464547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464577 */     // MIs[1] Operand 1
     /*  464577 */     // No operand predicates
     /*  464577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  464589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464609 */     GIR_RootConstrainSelectedInstOperands,
     /*  464610 */     // GIR_Coverage, 7780,
     /*  464610 */     GIR_EraseRootFromParent_Done,
     /*  464611 */   // Label 7937: @464611
     /*  464611 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(464697), // Rule ID 7781 //
     /*  464616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  464627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  464630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  464633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464663 */     // MIs[1] Operand 1
     /*  464663 */     // No operand predicates
     /*  464663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464672 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  464675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464695 */     GIR_RootConstrainSelectedInstOperands,
     /*  464696 */     // GIR_Coverage, 7781,
     /*  464696 */     GIR_EraseRootFromParent_Done,
     /*  464697 */   // Label 7938: @464697
     /*  464697 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(464783), // Rule ID 7784 //
     /*  464702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  464713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  464716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  464719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464749 */     // MIs[1] Operand 1
     /*  464749 */     // No operand predicates
     /*  464749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464758 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  464761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464781 */     GIR_RootConstrainSelectedInstOperands,
     /*  464782 */     // GIR_Coverage, 7784,
     /*  464782 */     GIR_EraseRootFromParent_Done,
     /*  464783 */   // Label 7939: @464783
     /*  464783 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(464869), // Rule ID 7785 //
     /*  464788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  464799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  464802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  464805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464835 */     // MIs[1] Operand 1
     /*  464835 */     // No operand predicates
     /*  464835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  464847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464867 */     GIR_RootConstrainSelectedInstOperands,
     /*  464868 */     // GIR_Coverage, 7785,
     /*  464868 */     GIR_EraseRootFromParent_Done,
     /*  464869 */   // Label 7940: @464869
     /*  464869 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(464955), // Rule ID 7788 //
     /*  464874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  464885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  464888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  464891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464921 */     // MIs[1] Operand 1
     /*  464921 */     // No operand predicates
     /*  464921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464930 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464953 */     GIR_RootConstrainSelectedInstOperands,
     /*  464954 */     // GIR_Coverage, 7788,
     /*  464954 */     GIR_EraseRootFromParent_Done,
     /*  464955 */   // Label 7941: @464955
     /*  464955 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(465041), // Rule ID 7789 //
     /*  464960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  464971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  464974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  464977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465007 */     // MIs[1] Operand 1
     /*  465007 */     // No operand predicates
     /*  465007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  465019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465039 */     GIR_RootConstrainSelectedInstOperands,
     /*  465040 */     // GIR_Coverage, 7789,
     /*  465040 */     GIR_EraseRootFromParent_Done,
     /*  465041 */   // Label 7942: @465041
     /*  465041 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(465127), // Rule ID 7792 //
     /*  465046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  465057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  465060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  465063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465093 */     // MIs[1] Operand 1
     /*  465093 */     // No operand predicates
     /*  465093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465102 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  465105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465125 */     GIR_RootConstrainSelectedInstOperands,
     /*  465126 */     // GIR_Coverage, 7792,
     /*  465126 */     GIR_EraseRootFromParent_Done,
     /*  465127 */   // Label 7943: @465127
     /*  465127 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(465213), // Rule ID 7793 //
     /*  465132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  465143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  465146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  465149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465179 */     // MIs[1] Operand 1
     /*  465179 */     // No operand predicates
     /*  465179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  465191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465211 */     GIR_RootConstrainSelectedInstOperands,
     /*  465212 */     // GIR_Coverage, 7793,
     /*  465212 */     GIR_EraseRootFromParent_Done,
     /*  465213 */   // Label 7944: @465213
     /*  465213 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(465299), // Rule ID 7796 //
     /*  465218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  465229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  465232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  465235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465265 */     // MIs[1] Operand 1
     /*  465265 */     // No operand predicates
     /*  465265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465274 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  465277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465297 */     GIR_RootConstrainSelectedInstOperands,
     /*  465298 */     // GIR_Coverage, 7796,
     /*  465298 */     GIR_EraseRootFromParent_Done,
     /*  465299 */   // Label 7945: @465299
     /*  465299 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(465385), // Rule ID 7797 //
     /*  465304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  465315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  465318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  465321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465351 */     // MIs[1] Operand 1
     /*  465351 */     // No operand predicates
     /*  465351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465360 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  465363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465383 */     GIR_RootConstrainSelectedInstOperands,
     /*  465384 */     // GIR_Coverage, 7797,
     /*  465384 */     GIR_EraseRootFromParent_Done,
     /*  465385 */   // Label 7946: @465385
     /*  465385 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(465471), // Rule ID 7800 //
     /*  465390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  465401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  465404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  465407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465437 */     // MIs[1] Operand 1
     /*  465437 */     // No operand predicates
     /*  465437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465446 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  465449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465469 */     GIR_RootConstrainSelectedInstOperands,
     /*  465470 */     // GIR_Coverage, 7800,
     /*  465470 */     GIR_EraseRootFromParent_Done,
     /*  465471 */   // Label 7947: @465471
     /*  465471 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(465557), // Rule ID 7801 //
     /*  465476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  465487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  465490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  465493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465523 */     // MIs[1] Operand 1
     /*  465523 */     // No operand predicates
     /*  465523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465532 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  465535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465555 */     GIR_RootConstrainSelectedInstOperands,
     /*  465556 */     // GIR_Coverage, 7801,
     /*  465556 */     GIR_EraseRootFromParent_Done,
     /*  465557 */   // Label 7948: @465557
     /*  465557 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(465643), // Rule ID 7804 //
     /*  465562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  465573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  465576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  465579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465609 */     // MIs[1] Operand 1
     /*  465609 */     // No operand predicates
     /*  465609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  465621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465641 */     GIR_RootConstrainSelectedInstOperands,
     /*  465642 */     // GIR_Coverage, 7804,
     /*  465642 */     GIR_EraseRootFromParent_Done,
     /*  465643 */   // Label 7949: @465643
     /*  465643 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(465729), // Rule ID 7805 //
     /*  465648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  465659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  465662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  465665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465695 */     // MIs[1] Operand 1
     /*  465695 */     // No operand predicates
     /*  465695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  465707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465727 */     GIR_RootConstrainSelectedInstOperands,
     /*  465728 */     // GIR_Coverage, 7805,
     /*  465728 */     GIR_EraseRootFromParent_Done,
     /*  465729 */   // Label 7950: @465729
     /*  465729 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(465815), // Rule ID 7808 //
     /*  465734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  465745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  465748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  465751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465781 */     // MIs[1] Operand 1
     /*  465781 */     // No operand predicates
     /*  465781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  465793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465813 */     GIR_RootConstrainSelectedInstOperands,
     /*  465814 */     // GIR_Coverage, 7808,
     /*  465814 */     GIR_EraseRootFromParent_Done,
     /*  465815 */   // Label 7951: @465815
     /*  465815 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(465901), // Rule ID 7809 //
     /*  465820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  465831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  465834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  465837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465867 */     // MIs[1] Operand 1
     /*  465867 */     // No operand predicates
     /*  465867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  465879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465899 */     GIR_RootConstrainSelectedInstOperands,
     /*  465900 */     // GIR_Coverage, 7809,
     /*  465900 */     GIR_EraseRootFromParent_Done,
     /*  465901 */   // Label 7952: @465901
     /*  465901 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(465987), // Rule ID 7812 //
     /*  465906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  465917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  465920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  465923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465953 */     // MIs[1] Operand 1
     /*  465953 */     // No operand predicates
     /*  465953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465962 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  465965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465985 */     GIR_RootConstrainSelectedInstOperands,
     /*  465986 */     // GIR_Coverage, 7812,
     /*  465986 */     GIR_EraseRootFromParent_Done,
     /*  465987 */   // Label 7953: @465987
     /*  465987 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(466073), // Rule ID 7813 //
     /*  465992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  466000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  466003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  466006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  466009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  466027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466039 */     // MIs[1] Operand 1
     /*  466039 */     // No operand predicates
     /*  466039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  466051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466071 */     GIR_RootConstrainSelectedInstOperands,
     /*  466072 */     // GIR_Coverage, 7813,
     /*  466072 */     GIR_EraseRootFromParent_Done,
     /*  466073 */   // Label 7954: @466073
     /*  466073 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(466162), // Rule ID 14242 //
     /*  466078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  466089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  466092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  466095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466125 */     // MIs[1] Operand 1
     /*  466125 */     // No operand predicates
     /*  466125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466134 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  466137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466160 */     GIR_RootConstrainSelectedInstOperands,
     /*  466161 */     // GIR_Coverage, 14242,
     /*  466161 */     GIR_EraseRootFromParent_Done,
     /*  466162 */   // Label 7955: @466162
     /*  466162 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(466251), // Rule ID 14243 //
     /*  466167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  466178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  466181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  466184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466214 */     // MIs[1] Operand 1
     /*  466214 */     // No operand predicates
     /*  466214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466223 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  466226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466249 */     GIR_RootConstrainSelectedInstOperands,
     /*  466250 */     // GIR_Coverage, 14243,
     /*  466250 */     GIR_EraseRootFromParent_Done,
     /*  466251 */   // Label 7956: @466251
     /*  466251 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(466340), // Rule ID 14246 //
     /*  466256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  466267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  466270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  466273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466303 */     // MIs[1] Operand 1
     /*  466303 */     // No operand predicates
     /*  466303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466312 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  466315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466338 */     GIR_RootConstrainSelectedInstOperands,
     /*  466339 */     // GIR_Coverage, 14246,
     /*  466339 */     GIR_EraseRootFromParent_Done,
     /*  466340 */   // Label 7957: @466340
     /*  466340 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(466429), // Rule ID 14247 //
     /*  466345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  466356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  466359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  466362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466392 */     // MIs[1] Operand 1
     /*  466392 */     // No operand predicates
     /*  466392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466401 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  466404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466427 */     GIR_RootConstrainSelectedInstOperands,
     /*  466428 */     // GIR_Coverage, 14247,
     /*  466428 */     GIR_EraseRootFromParent_Done,
     /*  466429 */   // Label 7958: @466429
     /*  466429 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(466518), // Rule ID 14250 //
     /*  466434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  466445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  466448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  466451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466481 */     // MIs[1] Operand 1
     /*  466481 */     // No operand predicates
     /*  466481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466490 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466516 */     GIR_RootConstrainSelectedInstOperands,
     /*  466517 */     // GIR_Coverage, 14250,
     /*  466517 */     GIR_EraseRootFromParent_Done,
     /*  466518 */   // Label 7959: @466518
     /*  466518 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(466607), // Rule ID 14251 //
     /*  466523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  466534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  466537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  466540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466570 */     // MIs[1] Operand 1
     /*  466570 */     // No operand predicates
     /*  466570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466579 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466605 */     GIR_RootConstrainSelectedInstOperands,
     /*  466606 */     // GIR_Coverage, 14251,
     /*  466606 */     GIR_EraseRootFromParent_Done,
     /*  466607 */   // Label 7960: @466607
     /*  466607 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(466696), // Rule ID 14254 //
     /*  466612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  466623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  466626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466659 */     // MIs[1] Operand 1
     /*  466659 */     // No operand predicates
     /*  466659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  466671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466694 */     GIR_RootConstrainSelectedInstOperands,
     /*  466695 */     // GIR_Coverage, 14254,
     /*  466695 */     GIR_EraseRootFromParent_Done,
     /*  466696 */   // Label 7961: @466696
     /*  466696 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(466785), // Rule ID 14255 //
     /*  466701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  466712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  466715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466748 */     // MIs[1] Operand 1
     /*  466748 */     // No operand predicates
     /*  466748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466757 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  466760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466783 */     GIR_RootConstrainSelectedInstOperands,
     /*  466784 */     // GIR_Coverage, 14255,
     /*  466784 */     GIR_EraseRootFromParent_Done,
     /*  466785 */   // Label 7962: @466785
     /*  466785 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(466874), // Rule ID 14258 //
     /*  466790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  466801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  466804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  466807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466837 */     // MIs[1] Operand 1
     /*  466837 */     // No operand predicates
     /*  466837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466846 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466872 */     GIR_RootConstrainSelectedInstOperands,
     /*  466873 */     // GIR_Coverage, 14258,
     /*  466873 */     GIR_EraseRootFromParent_Done,
     /*  466874 */   // Label 7963: @466874
     /*  466874 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(466963), // Rule ID 14259 //
     /*  466879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  466890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  466893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  466896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466926 */     // MIs[1] Operand 1
     /*  466926 */     // No operand predicates
     /*  466926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466935 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466961 */     GIR_RootConstrainSelectedInstOperands,
     /*  466962 */     // GIR_Coverage, 14259,
     /*  466962 */     GIR_EraseRootFromParent_Done,
     /*  466963 */   // Label 7964: @466963
     /*  466963 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(467052), // Rule ID 14262 //
     /*  466968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  466985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467015 */     // MIs[1] Operand 1
     /*  467015 */     // No operand predicates
     /*  467015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  467024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  467027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  467044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467050 */     GIR_RootConstrainSelectedInstOperands,
     /*  467051 */     // GIR_Coverage, 14262,
     /*  467051 */     GIR_EraseRootFromParent_Done,
     /*  467052 */   // Label 7965: @467052
     /*  467052 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(467141), // Rule ID 14263 //
     /*  467057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  467068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  467071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  467074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467104 */     // MIs[1] Operand 1
     /*  467104 */     // No operand predicates
     /*  467104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467113 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  467113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  467116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  467133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467139 */     GIR_RootConstrainSelectedInstOperands,
     /*  467140 */     // GIR_Coverage, 14263,
     /*  467140 */     GIR_EraseRootFromParent_Done,
     /*  467141 */   // Label 7966: @467141
     /*  467141 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(467230), // Rule ID 14266 //
     /*  467146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  467157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  467160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  467163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467193 */     // MIs[1] Operand 1
     /*  467193 */     // No operand predicates
     /*  467193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467202 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467228 */     GIR_RootConstrainSelectedInstOperands,
     /*  467229 */     // GIR_Coverage, 14266,
     /*  467229 */     GIR_EraseRootFromParent_Done,
     /*  467230 */   // Label 7967: @467230
     /*  467230 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(467319), // Rule ID 14267 //
     /*  467235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  467246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  467249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  467252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467282 */     // MIs[1] Operand 1
     /*  467282 */     // No operand predicates
     /*  467282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467291 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467317 */     GIR_RootConstrainSelectedInstOperands,
     /*  467318 */     // GIR_Coverage, 14267,
     /*  467318 */     GIR_EraseRootFromParent_Done,
     /*  467319 */   // Label 7968: @467319
     /*  467319 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(467408), // Rule ID 14270 //
     /*  467324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  467335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  467338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  467341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467371 */     // MIs[1] Operand 1
     /*  467371 */     // No operand predicates
     /*  467371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467380 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  467380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467406 */     GIR_RootConstrainSelectedInstOperands,
     /*  467407 */     // GIR_Coverage, 14270,
     /*  467407 */     GIR_EraseRootFromParent_Done,
     /*  467408 */   // Label 7969: @467408
     /*  467408 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(467497), // Rule ID 14271 //
     /*  467413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  467424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  467427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  467430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467460 */     // MIs[1] Operand 1
     /*  467460 */     // No operand predicates
     /*  467460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467469 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  467469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467495 */     GIR_RootConstrainSelectedInstOperands,
     /*  467496 */     // GIR_Coverage, 14271,
     /*  467496 */     GIR_EraseRootFromParent_Done,
     /*  467497 */   // Label 7970: @467497
     /*  467497 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(467586), // Rule ID 14274 //
     /*  467502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  467513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  467516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  467519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467549 */     // MIs[1] Operand 1
     /*  467549 */     // No operand predicates
     /*  467549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  467558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  467578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467584 */     GIR_RootConstrainSelectedInstOperands,
     /*  467585 */     // GIR_Coverage, 14274,
     /*  467585 */     GIR_EraseRootFromParent_Done,
     /*  467586 */   // Label 7971: @467586
     /*  467586 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(467675), // Rule ID 14275 //
     /*  467591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  467602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  467605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  467608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467638 */     // MIs[1] Operand 1
     /*  467638 */     // No operand predicates
     /*  467638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467647 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  467647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  467667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467673 */     GIR_RootConstrainSelectedInstOperands,
     /*  467674 */     // GIR_Coverage, 14275,
     /*  467674 */     GIR_EraseRootFromParent_Done,
     /*  467675 */   // Label 7972: @467675
     /*  467675 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(467764), // Rule ID 14278 //
     /*  467680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  467683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  467691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  467694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  467697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467727 */     // MIs[1] Operand 1
     /*  467727 */     // No operand predicates
     /*  467727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467736 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  467736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  467756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467762 */     GIR_RootConstrainSelectedInstOperands,
     /*  467763 */     // GIR_Coverage, 14278,
     /*  467763 */     GIR_EraseRootFromParent_Done,
     /*  467764 */   // Label 7973: @467764
     /*  467764 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(467853), // Rule ID 14279 //
     /*  467769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  467772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  467780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  467783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  467786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467816 */     // MIs[1] Operand 1
     /*  467816 */     // No operand predicates
     /*  467816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467825 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  467825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  467845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467851 */     GIR_RootConstrainSelectedInstOperands,
     /*  467852 */     // GIR_Coverage, 14279,
     /*  467852 */     GIR_EraseRootFromParent_Done,
     /*  467853 */   // Label 7974: @467853
     /*  467853 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(467942), // Rule ID 14282 //
     /*  467858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  467875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467905 */     // MIs[1] Operand 1
     /*  467905 */     // No operand predicates
     /*  467905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  467917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467940 */     GIR_RootConstrainSelectedInstOperands,
     /*  467941 */     // GIR_Coverage, 14282,
     /*  467941 */     GIR_EraseRootFromParent_Done,
     /*  467942 */   // Label 7975: @467942
     /*  467942 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(468031), // Rule ID 14283 //
     /*  467947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  467964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467994 */     // MIs[1] Operand 1
     /*  467994 */     // No operand predicates
     /*  467994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468003 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  468003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  468023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468029 */     GIR_RootConstrainSelectedInstOperands,
     /*  468030 */     // GIR_Coverage, 14283,
     /*  468030 */     GIR_EraseRootFromParent_Done,
     /*  468031 */   // Label 7976: @468031
     /*  468031 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(468120), // Rule ID 14286 //
     /*  468036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  468047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  468050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  468053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468083 */     // MIs[1] Operand 1
     /*  468083 */     // No operand predicates
     /*  468083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468092 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  468092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  468112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468118 */     GIR_RootConstrainSelectedInstOperands,
     /*  468119 */     // GIR_Coverage, 14286,
     /*  468119 */     GIR_EraseRootFromParent_Done,
     /*  468120 */   // Label 7977: @468120
     /*  468120 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(468209), // Rule ID 14287 //
     /*  468125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  468136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  468139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  468142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468172 */     // MIs[1] Operand 1
     /*  468172 */     // No operand predicates
     /*  468172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468181 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  468181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  468201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468207 */     GIR_RootConstrainSelectedInstOperands,
     /*  468208 */     // GIR_Coverage, 14287,
     /*  468208 */     GIR_EraseRootFromParent_Done,
     /*  468209 */   // Label 7978: @468209
     /*  468209 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(468298), // Rule ID 14290 //
     /*  468214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  468225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  468228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  468231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468261 */     // MIs[1] Operand 1
     /*  468261 */     // No operand predicates
     /*  468261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468270 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  468270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  468290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468296 */     GIR_RootConstrainSelectedInstOperands,
     /*  468297 */     // GIR_Coverage, 14290,
     /*  468297 */     GIR_EraseRootFromParent_Done,
     /*  468298 */   // Label 7979: @468298
     /*  468298 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(468387), // Rule ID 14291 //
     /*  468303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  468314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  468317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  468320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468350 */     // MIs[1] Operand 1
     /*  468350 */     // No operand predicates
     /*  468350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468359 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  468359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  468379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468385 */     GIR_RootConstrainSelectedInstOperands,
     /*  468386 */     // GIR_Coverage, 14291,
     /*  468386 */     GIR_EraseRootFromParent_Done,
     /*  468387 */   // Label 7980: @468387
     /*  468387 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(468476), // Rule ID 14294 //
     /*  468392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  468403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  468406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  468409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468439 */     // MIs[1] Operand 1
     /*  468439 */     // No operand predicates
     /*  468439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468474 */     GIR_RootConstrainSelectedInstOperands,
     /*  468475 */     // GIR_Coverage, 14294,
     /*  468475 */     GIR_EraseRootFromParent_Done,
     /*  468476 */   // Label 7981: @468476
     /*  468476 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(468565), // Rule ID 14295 //
     /*  468481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  468492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  468495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  468498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468528 */     // MIs[1] Operand 1
     /*  468528 */     // No operand predicates
     /*  468528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468537 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468563 */     GIR_RootConstrainSelectedInstOperands,
     /*  468564 */     // GIR_Coverage, 14295,
     /*  468564 */     GIR_EraseRootFromParent_Done,
     /*  468565 */   // Label 7982: @468565
     /*  468565 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(468654), // Rule ID 14298 //
     /*  468570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  468581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  468584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  468587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468617 */     // MIs[1] Operand 1
     /*  468617 */     // No operand predicates
     /*  468617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468652 */     GIR_RootConstrainSelectedInstOperands,
     /*  468653 */     // GIR_Coverage, 14298,
     /*  468653 */     GIR_EraseRootFromParent_Done,
     /*  468654 */   // Label 7983: @468654
     /*  468654 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(468743), // Rule ID 14299 //
     /*  468659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  468670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  468673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  468676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468706 */     // MIs[1] Operand 1
     /*  468706 */     // No operand predicates
     /*  468706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468715 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468741 */     GIR_RootConstrainSelectedInstOperands,
     /*  468742 */     // GIR_Coverage, 14299,
     /*  468742 */     GIR_EraseRootFromParent_Done,
     /*  468743 */   // Label 7984: @468743
     /*  468743 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(468832), // Rule ID 14302 //
     /*  468748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  468759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  468762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  468765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468795 */     // MIs[1] Operand 1
     /*  468795 */     // No operand predicates
     /*  468795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468804 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468830 */     GIR_RootConstrainSelectedInstOperands,
     /*  468831 */     // GIR_Coverage, 14302,
     /*  468831 */     GIR_EraseRootFromParent_Done,
     /*  468832 */   // Label 7985: @468832
     /*  468832 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(468921), // Rule ID 14303 //
     /*  468837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  468848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  468851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  468854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468884 */     // MIs[1] Operand 1
     /*  468884 */     // No operand predicates
     /*  468884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468893 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468919 */     GIR_RootConstrainSelectedInstOperands,
     /*  468920 */     // GIR_Coverage, 14303,
     /*  468920 */     GIR_EraseRootFromParent_Done,
     /*  468921 */   // Label 7986: @468921
     /*  468921 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(469010), // Rule ID 14306 //
     /*  468926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  468937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  468940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468973 */     // MIs[1] Operand 1
     /*  468973 */     // No operand predicates
     /*  468973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469008 */     GIR_RootConstrainSelectedInstOperands,
     /*  469009 */     // GIR_Coverage, 14306,
     /*  469009 */     GIR_EraseRootFromParent_Done,
     /*  469010 */   // Label 7987: @469010
     /*  469010 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(469099), // Rule ID 14307 //
     /*  469015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  469026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  469029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  469032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469062 */     // MIs[1] Operand 1
     /*  469062 */     // No operand predicates
     /*  469062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469071 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  469074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469097 */     GIR_RootConstrainSelectedInstOperands,
     /*  469098 */     // GIR_Coverage, 14307,
     /*  469098 */     GIR_EraseRootFromParent_Done,
     /*  469099 */   // Label 7988: @469099
     /*  469099 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(469188), // Rule ID 14310 //
     /*  469104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  469115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  469118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  469121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469151 */     // MIs[1] Operand 1
     /*  469151 */     // No operand predicates
     /*  469151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469160 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  469160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  469163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469186 */     GIR_RootConstrainSelectedInstOperands,
     /*  469187 */     // GIR_Coverage, 14310,
     /*  469187 */     GIR_EraseRootFromParent_Done,
     /*  469188 */   // Label 7989: @469188
     /*  469188 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(469277), // Rule ID 14311 //
     /*  469193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  469204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  469207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  469210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469240 */     // MIs[1] Operand 1
     /*  469240 */     // No operand predicates
     /*  469240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469249 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  469252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469275 */     GIR_RootConstrainSelectedInstOperands,
     /*  469276 */     // GIR_Coverage, 14311,
     /*  469276 */     GIR_EraseRootFromParent_Done,
     /*  469277 */   // Label 7990: @469277
     /*  469277 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(469366), // Rule ID 14314 //
     /*  469282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  469293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  469296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  469299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469329 */     // MIs[1] Operand 1
     /*  469329 */     // No operand predicates
     /*  469329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469338 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  469338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  469341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469364 */     GIR_RootConstrainSelectedInstOperands,
     /*  469365 */     // GIR_Coverage, 14314,
     /*  469365 */     GIR_EraseRootFromParent_Done,
     /*  469366 */   // Label 7991: @469366
     /*  469366 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(469455), // Rule ID 14315 //
     /*  469371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  469382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  469385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  469388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469418 */     // MIs[1] Operand 1
     /*  469418 */     // No operand predicates
     /*  469418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469427 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  469430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469453 */     GIR_RootConstrainSelectedInstOperands,
     /*  469454 */     // GIR_Coverage, 14315,
     /*  469454 */     GIR_EraseRootFromParent_Done,
     /*  469455 */   // Label 7992: @469455
     /*  469455 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(469544), // Rule ID 14318 //
     /*  469460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  469463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  469471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  469474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  469477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469507 */     // MIs[1] Operand 1
     /*  469507 */     // No operand predicates
     /*  469507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  469516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  469519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469542 */     GIR_RootConstrainSelectedInstOperands,
     /*  469543 */     // GIR_Coverage, 14318,
     /*  469543 */     GIR_EraseRootFromParent_Done,
     /*  469544 */   // Label 7993: @469544
     /*  469544 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(469633), // Rule ID 14319 //
     /*  469549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  469552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  469560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  469563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  469566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469596 */     // MIs[1] Operand 1
     /*  469596 */     // No operand predicates
     /*  469596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469605 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  469605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  469608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469631 */     GIR_RootConstrainSelectedInstOperands,
     /*  469632 */     // GIR_Coverage, 14319,
     /*  469632 */     GIR_EraseRootFromParent_Done,
     /*  469633 */   // Label 7994: @469633
     /*  469633 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(469722), // Rule ID 14322 //
     /*  469638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  469641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  469649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  469652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  469655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469685 */     // MIs[1] Operand 1
     /*  469685 */     // No operand predicates
     /*  469685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469694 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  469694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  469697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469720 */     GIR_RootConstrainSelectedInstOperands,
     /*  469721 */     // GIR_Coverage, 14322,
     /*  469721 */     GIR_EraseRootFromParent_Done,
     /*  469722 */   // Label 7995: @469722
     /*  469722 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(469811), // Rule ID 14323 //
     /*  469727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  469730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  469738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  469741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  469744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469774 */     // MIs[1] Operand 1
     /*  469774 */     // No operand predicates
     /*  469774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469783 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  469783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  469786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469809 */     GIR_RootConstrainSelectedInstOperands,
     /*  469810 */     // GIR_Coverage, 14323,
     /*  469810 */     GIR_EraseRootFromParent_Done,
     /*  469811 */   // Label 7996: @469811
     /*  469811 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(469900), // Rule ID 14326 //
     /*  469816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  469819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  469827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  469830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  469833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469863 */     // MIs[1] Operand 1
     /*  469863 */     // No operand predicates
     /*  469863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469872 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  469872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  469875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469898 */     GIR_RootConstrainSelectedInstOperands,
     /*  469899 */     // GIR_Coverage, 14326,
     /*  469899 */     GIR_EraseRootFromParent_Done,
     /*  469900 */   // Label 7997: @469900
     /*  469900 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(469989), // Rule ID 14327 //
     /*  469905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  469908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  469916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  469919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  469922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469952 */     // MIs[1] Operand 1
     /*  469952 */     // No operand predicates
     /*  469952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469961 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  469961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  469964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469987 */     GIR_RootConstrainSelectedInstOperands,
     /*  469988 */     // GIR_Coverage, 14327,
     /*  469988 */     GIR_EraseRootFromParent_Done,
     /*  469989 */   // Label 7998: @469989
     /*  469989 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(470078), // Rule ID 14506 //
     /*  469994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  470005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  470008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  470011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470041 */     // MIs[1] Operand 1
     /*  470041 */     // No operand predicates
     /*  470041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470050 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  470053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470076 */     GIR_RootConstrainSelectedInstOperands,
     /*  470077 */     // GIR_Coverage, 14506,
     /*  470077 */     GIR_EraseRootFromParent_Done,
     /*  470078 */   // Label 7999: @470078
     /*  470078 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(470167), // Rule ID 14507 //
     /*  470083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  470094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  470097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  470100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470130 */     // MIs[1] Operand 1
     /*  470130 */     // No operand predicates
     /*  470130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470139 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  470142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470165 */     GIR_RootConstrainSelectedInstOperands,
     /*  470166 */     // GIR_Coverage, 14507,
     /*  470166 */     GIR_EraseRootFromParent_Done,
     /*  470167 */   // Label 8000: @470167
     /*  470167 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(470256), // Rule ID 14510 //
     /*  470172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  470183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  470186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  470189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470219 */     // MIs[1] Operand 1
     /*  470219 */     // No operand predicates
     /*  470219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470228 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  470231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470254 */     GIR_RootConstrainSelectedInstOperands,
     /*  470255 */     // GIR_Coverage, 14510,
     /*  470255 */     GIR_EraseRootFromParent_Done,
     /*  470256 */   // Label 8001: @470256
     /*  470256 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(470345), // Rule ID 14511 //
     /*  470261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  470272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  470275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  470278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470308 */     // MIs[1] Operand 1
     /*  470308 */     // No operand predicates
     /*  470308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470317 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  470320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470343 */     GIR_RootConstrainSelectedInstOperands,
     /*  470344 */     // GIR_Coverage, 14511,
     /*  470344 */     GIR_EraseRootFromParent_Done,
     /*  470345 */   // Label 8002: @470345
     /*  470345 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(470434), // Rule ID 14514 //
     /*  470350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  470361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  470364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  470367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470397 */     // MIs[1] Operand 1
     /*  470397 */     // No operand predicates
     /*  470397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470406 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470432 */     GIR_RootConstrainSelectedInstOperands,
     /*  470433 */     // GIR_Coverage, 14514,
     /*  470433 */     GIR_EraseRootFromParent_Done,
     /*  470434 */   // Label 8003: @470434
     /*  470434 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(470523), // Rule ID 14515 //
     /*  470439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  470450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  470453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  470456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470486 */     // MIs[1] Operand 1
     /*  470486 */     // No operand predicates
     /*  470486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470495 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470521 */     GIR_RootConstrainSelectedInstOperands,
     /*  470522 */     // GIR_Coverage, 14515,
     /*  470522 */     GIR_EraseRootFromParent_Done,
     /*  470523 */   // Label 8004: @470523
     /*  470523 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(470612), // Rule ID 14518 //
     /*  470528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  470539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  470542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  470545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470575 */     // MIs[1] Operand 1
     /*  470575 */     // No operand predicates
     /*  470575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470584 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  470587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470610 */     GIR_RootConstrainSelectedInstOperands,
     /*  470611 */     // GIR_Coverage, 14518,
     /*  470611 */     GIR_EraseRootFromParent_Done,
     /*  470612 */   // Label 8005: @470612
     /*  470612 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(470701), // Rule ID 14519 //
     /*  470617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  470628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  470631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  470634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470664 */     // MIs[1] Operand 1
     /*  470664 */     // No operand predicates
     /*  470664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470673 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  470676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470699 */     GIR_RootConstrainSelectedInstOperands,
     /*  470700 */     // GIR_Coverage, 14519,
     /*  470700 */     GIR_EraseRootFromParent_Done,
     /*  470701 */   // Label 8006: @470701
     /*  470701 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(470790), // Rule ID 14522 //
     /*  470706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  470717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  470720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  470723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470753 */     // MIs[1] Operand 1
     /*  470753 */     // No operand predicates
     /*  470753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470762 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470788 */     GIR_RootConstrainSelectedInstOperands,
     /*  470789 */     // GIR_Coverage, 14522,
     /*  470789 */     GIR_EraseRootFromParent_Done,
     /*  470790 */   // Label 8007: @470790
     /*  470790 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(470879), // Rule ID 14523 //
     /*  470795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  470806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  470809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  470812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470842 */     // MIs[1] Operand 1
     /*  470842 */     // No operand predicates
     /*  470842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470851 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470877 */     GIR_RootConstrainSelectedInstOperands,
     /*  470878 */     // GIR_Coverage, 14523,
     /*  470878 */     GIR_EraseRootFromParent_Done,
     /*  470879 */   // Label 8008: @470879
     /*  470879 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(470968), // Rule ID 14526 //
     /*  470884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470931 */     // MIs[1] Operand 1
     /*  470931 */     // No operand predicates
     /*  470931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470940 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  470940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470966 */     GIR_RootConstrainSelectedInstOperands,
     /*  470967 */     // GIR_Coverage, 14526,
     /*  470967 */     GIR_EraseRootFromParent_Done,
     /*  470968 */   // Label 8009: @470968
     /*  470968 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(471057), // Rule ID 14527 //
     /*  470973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471020 */     // MIs[1] Operand 1
     /*  471020 */     // No operand predicates
     /*  471020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471029 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  471029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  471032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471055 */     GIR_RootConstrainSelectedInstOperands,
     /*  471056 */     // GIR_Coverage, 14527,
     /*  471056 */     GIR_EraseRootFromParent_Done,
     /*  471057 */   // Label 8010: @471057
     /*  471057 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(471146), // Rule ID 14530 //
     /*  471062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  471073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  471076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  471079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471109 */     // MIs[1] Operand 1
     /*  471109 */     // No operand predicates
     /*  471109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471118 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471144 */     GIR_RootConstrainSelectedInstOperands,
     /*  471145 */     // GIR_Coverage, 14530,
     /*  471145 */     GIR_EraseRootFromParent_Done,
     /*  471146 */   // Label 8011: @471146
     /*  471146 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(471235), // Rule ID 14531 //
     /*  471151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  471162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  471165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  471168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471198 */     // MIs[1] Operand 1
     /*  471198 */     // No operand predicates
     /*  471198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471207 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471233 */     GIR_RootConstrainSelectedInstOperands,
     /*  471234 */     // GIR_Coverage, 14531,
     /*  471234 */     GIR_EraseRootFromParent_Done,
     /*  471235 */   // Label 8012: @471235
     /*  471235 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(471324), // Rule ID 14534 //
     /*  471240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  471251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  471254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  471257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471287 */     // MIs[1] Operand 1
     /*  471287 */     // No operand predicates
     /*  471287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471296 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471322 */     GIR_RootConstrainSelectedInstOperands,
     /*  471323 */     // GIR_Coverage, 14534,
     /*  471323 */     GIR_EraseRootFromParent_Done,
     /*  471324 */   // Label 8013: @471324
     /*  471324 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(471413), // Rule ID 14535 //
     /*  471329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  471340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  471343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  471346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471376 */     // MIs[1] Operand 1
     /*  471376 */     // No operand predicates
     /*  471376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471385 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  471385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471411 */     GIR_RootConstrainSelectedInstOperands,
     /*  471412 */     // GIR_Coverage, 14535,
     /*  471412 */     GIR_EraseRootFromParent_Done,
     /*  471413 */   // Label 8014: @471413
     /*  471413 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(471502), // Rule ID 14538 //
     /*  471418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  471429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  471432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  471435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471465 */     // MIs[1] Operand 1
     /*  471465 */     // No operand predicates
     /*  471465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  471474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471500 */     GIR_RootConstrainSelectedInstOperands,
     /*  471501 */     // GIR_Coverage, 14538,
     /*  471501 */     GIR_EraseRootFromParent_Done,
     /*  471502 */   // Label 8015: @471502
     /*  471502 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(471591), // Rule ID 14539 //
     /*  471507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  471518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  471521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  471524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471554 */     // MIs[1] Operand 1
     /*  471554 */     // No operand predicates
     /*  471554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471563 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  471563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471589 */     GIR_RootConstrainSelectedInstOperands,
     /*  471590 */     // GIR_Coverage, 14539,
     /*  471590 */     GIR_EraseRootFromParent_Done,
     /*  471591 */   // Label 8016: @471591
     /*  471591 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(471680), // Rule ID 14542 //
     /*  471596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  471599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  471607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  471610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  471613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471643 */     // MIs[1] Operand 1
     /*  471643 */     // No operand predicates
     /*  471643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  471652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471678 */     GIR_RootConstrainSelectedInstOperands,
     /*  471679 */     // GIR_Coverage, 14542,
     /*  471679 */     GIR_EraseRootFromParent_Done,
     /*  471680 */   // Label 8017: @471680
     /*  471680 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(471769), // Rule ID 14543 //
     /*  471685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  471688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  471696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  471699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  471702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471732 */     // MIs[1] Operand 1
     /*  471732 */     // No operand predicates
     /*  471732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471741 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  471741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471767 */     GIR_RootConstrainSelectedInstOperands,
     /*  471768 */     // GIR_Coverage, 14543,
     /*  471768 */     GIR_EraseRootFromParent_Done,
     /*  471769 */   // Label 8018: @471769
     /*  471769 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(471858), // Rule ID 14546 //
     /*  471774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  471785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  471788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  471791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471821 */     // MIs[1] Operand 1
     /*  471821 */     // No operand predicates
     /*  471821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471830 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471856 */     GIR_RootConstrainSelectedInstOperands,
     /*  471857 */     // GIR_Coverage, 14546,
     /*  471857 */     GIR_EraseRootFromParent_Done,
     /*  471858 */   // Label 8019: @471858
     /*  471858 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(471947), // Rule ID 14547 //
     /*  471863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  471874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  471877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  471880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471910 */     // MIs[1] Operand 1
     /*  471910 */     // No operand predicates
     /*  471910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471919 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471945 */     GIR_RootConstrainSelectedInstOperands,
     /*  471946 */     // GIR_Coverage, 14547,
     /*  471946 */     GIR_EraseRootFromParent_Done,
     /*  471947 */   // Label 8020: @471947
     /*  471947 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(472036), // Rule ID 14550 //
     /*  471952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  471963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  471966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  471969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471999 */     // MIs[1] Operand 1
     /*  471999 */     // No operand predicates
     /*  471999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472008 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  472008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472034 */     GIR_RootConstrainSelectedInstOperands,
     /*  472035 */     // GIR_Coverage, 14550,
     /*  472035 */     GIR_EraseRootFromParent_Done,
     /*  472036 */   // Label 8021: @472036
     /*  472036 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(472125), // Rule ID 14551 //
     /*  472041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  472052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  472055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  472058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472088 */     // MIs[1] Operand 1
     /*  472088 */     // No operand predicates
     /*  472088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472097 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  472097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472123 */     GIR_RootConstrainSelectedInstOperands,
     /*  472124 */     // GIR_Coverage, 14551,
     /*  472124 */     GIR_EraseRootFromParent_Done,
     /*  472125 */   // Label 8022: @472125
     /*  472125 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(472214), // Rule ID 14554 //
     /*  472130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  472141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  472144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  472147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472177 */     // MIs[1] Operand 1
     /*  472177 */     // No operand predicates
     /*  472177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472186 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  472186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472212 */     GIR_RootConstrainSelectedInstOperands,
     /*  472213 */     // GIR_Coverage, 14554,
     /*  472213 */     GIR_EraseRootFromParent_Done,
     /*  472214 */   // Label 8023: @472214
     /*  472214 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(472303), // Rule ID 14555 //
     /*  472219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  472230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  472233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  472236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472266 */     // MIs[1] Operand 1
     /*  472266 */     // No operand predicates
     /*  472266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472275 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  472275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472301 */     GIR_RootConstrainSelectedInstOperands,
     /*  472302 */     // GIR_Coverage, 14555,
     /*  472302 */     GIR_EraseRootFromParent_Done,
     /*  472303 */   // Label 8024: @472303
     /*  472303 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(472392), // Rule ID 14558 //
     /*  472308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  472319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  472322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  472325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472355 */     // MIs[1] Operand 1
     /*  472355 */     // No operand predicates
     /*  472355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472364 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  472364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472390 */     GIR_RootConstrainSelectedInstOperands,
     /*  472391 */     // GIR_Coverage, 14558,
     /*  472391 */     GIR_EraseRootFromParent_Done,
     /*  472392 */   // Label 8025: @472392
     /*  472392 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(472481), // Rule ID 14559 //
     /*  472397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  472408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  472411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  472414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472444 */     // MIs[1] Operand 1
     /*  472444 */     // No operand predicates
     /*  472444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472453 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472479 */     GIR_RootConstrainSelectedInstOperands,
     /*  472480 */     // GIR_Coverage, 14559,
     /*  472480 */     GIR_EraseRootFromParent_Done,
     /*  472481 */   // Label 8026: @472481
     /*  472481 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(472570), // Rule ID 14562 //
     /*  472486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  472497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  472500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  472503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472533 */     // MIs[1] Operand 1
     /*  472533 */     // No operand predicates
     /*  472533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472542 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  472542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472568 */     GIR_RootConstrainSelectedInstOperands,
     /*  472569 */     // GIR_Coverage, 14562,
     /*  472569 */     GIR_EraseRootFromParent_Done,
     /*  472570 */   // Label 8027: @472570
     /*  472570 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(472659), // Rule ID 14563 //
     /*  472575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  472586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  472589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  472592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472622 */     // MIs[1] Operand 1
     /*  472622 */     // No operand predicates
     /*  472622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472631 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472657 */     GIR_RootConstrainSelectedInstOperands,
     /*  472658 */     // GIR_Coverage, 14563,
     /*  472658 */     GIR_EraseRootFromParent_Done,
     /*  472659 */   // Label 8028: @472659
     /*  472659 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(472748), // Rule ID 14566 //
     /*  472664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  472681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472711 */     // MIs[1] Operand 1
     /*  472711 */     // No operand predicates
     /*  472711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472720 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  472720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472746 */     GIR_RootConstrainSelectedInstOperands,
     /*  472747 */     // GIR_Coverage, 14566,
     /*  472747 */     GIR_EraseRootFromParent_Done,
     /*  472748 */   // Label 8029: @472748
     /*  472748 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(472837), // Rule ID 14567 //
     /*  472753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  472770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472800 */     // MIs[1] Operand 1
     /*  472800 */     // No operand predicates
     /*  472800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472809 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472835 */     GIR_RootConstrainSelectedInstOperands,
     /*  472836 */     // GIR_Coverage, 14567,
     /*  472836 */     GIR_EraseRootFromParent_Done,
     /*  472837 */   // Label 8030: @472837
     /*  472837 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(472926), // Rule ID 14570 //
     /*  472842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  472853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  472856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  472859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472889 */     // MIs[1] Operand 1
     /*  472889 */     // No operand predicates
     /*  472889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472898 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472924 */     GIR_RootConstrainSelectedInstOperands,
     /*  472925 */     // GIR_Coverage, 14570,
     /*  472925 */     GIR_EraseRootFromParent_Done,
     /*  472926 */   // Label 8031: @472926
     /*  472926 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(473015), // Rule ID 14571 //
     /*  472931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  472942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  472945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  472948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472978 */     // MIs[1] Operand 1
     /*  472978 */     // No operand predicates
     /*  472978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472987 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  473007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473013 */     GIR_RootConstrainSelectedInstOperands,
     /*  473014 */     // GIR_Coverage, 14571,
     /*  473014 */     GIR_EraseRootFromParent_Done,
     /*  473015 */   // Label 8032: @473015
     /*  473015 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(473104), // Rule ID 14574 //
     /*  473020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  473031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  473034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  473037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473067 */     // MIs[1] Operand 1
     /*  473067 */     // No operand predicates
     /*  473067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  473076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  473079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  473096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473102 */     GIR_RootConstrainSelectedInstOperands,
     /*  473103 */     // GIR_Coverage, 14574,
     /*  473103 */     GIR_EraseRootFromParent_Done,
     /*  473104 */   // Label 8033: @473104
     /*  473104 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(473193), // Rule ID 14575 //
     /*  473109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  473120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  473123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  473126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473156 */     // MIs[1] Operand 1
     /*  473156 */     // No operand predicates
     /*  473156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473165 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  473165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  473168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  473185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473191 */     GIR_RootConstrainSelectedInstOperands,
     /*  473192 */     // GIR_Coverage, 14575,
     /*  473192 */     GIR_EraseRootFromParent_Done,
     /*  473193 */   // Label 8034: @473193
     /*  473193 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(473282), // Rule ID 14578 //
     /*  473198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  473209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  473212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  473215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473245 */     // MIs[1] Operand 1
     /*  473245 */     // No operand predicates
     /*  473245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  473254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  473257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  473274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473280 */     GIR_RootConstrainSelectedInstOperands,
     /*  473281 */     // GIR_Coverage, 14578,
     /*  473281 */     GIR_EraseRootFromParent_Done,
     /*  473282 */   // Label 8035: @473282
     /*  473282 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(473371), // Rule ID 14579 //
     /*  473287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  473298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  473301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  473304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473334 */     // MIs[1] Operand 1
     /*  473334 */     // No operand predicates
     /*  473334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473343 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  473343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  473346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  473363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473369 */     GIR_RootConstrainSelectedInstOperands,
     /*  473370 */     // GIR_Coverage, 14579,
     /*  473370 */     GIR_EraseRootFromParent_Done,
     /*  473371 */   // Label 8036: @473371
     /*  473371 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(473460), // Rule ID 14582 //
     /*  473376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  473387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  473390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  473393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473423 */     // MIs[1] Operand 1
     /*  473423 */     // No operand predicates
     /*  473423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  473435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473458 */     GIR_RootConstrainSelectedInstOperands,
     /*  473459 */     // GIR_Coverage, 14582,
     /*  473459 */     GIR_EraseRootFromParent_Done,
     /*  473460 */   // Label 8037: @473460
     /*  473460 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(473549), // Rule ID 14583 //
     /*  473465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  473476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  473479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  473482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473512 */     // MIs[1] Operand 1
     /*  473512 */     // No operand predicates
     /*  473512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  473524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473547 */     GIR_RootConstrainSelectedInstOperands,
     /*  473548 */     // GIR_Coverage, 14583,
     /*  473548 */     GIR_EraseRootFromParent_Done,
     /*  473549 */   // Label 8038: @473549
     /*  473549 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(473638), // Rule ID 14586 //
     /*  473554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  473565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  473568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  473571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473601 */     // MIs[1] Operand 1
     /*  473601 */     // No operand predicates
     /*  473601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473610 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  473613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473636 */     GIR_RootConstrainSelectedInstOperands,
     /*  473637 */     // GIR_Coverage, 14586,
     /*  473637 */     GIR_EraseRootFromParent_Done,
     /*  473638 */   // Label 8039: @473638
     /*  473638 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(473727), // Rule ID 14587 //
     /*  473643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  473654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  473657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  473660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473690 */     // MIs[1] Operand 1
     /*  473690 */     // No operand predicates
     /*  473690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473699 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  473702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473725 */     GIR_RootConstrainSelectedInstOperands,
     /*  473726 */     // GIR_Coverage, 14587,
     /*  473726 */     GIR_EraseRootFromParent_Done,
     /*  473727 */   // Label 8040: @473727
     /*  473727 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(473816), // Rule ID 14590 //
     /*  473732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  473743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  473746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  473749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473779 */     // MIs[1] Operand 1
     /*  473779 */     // No operand predicates
     /*  473779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473788 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  473791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473814 */     GIR_RootConstrainSelectedInstOperands,
     /*  473815 */     // GIR_Coverage, 14590,
     /*  473815 */     GIR_EraseRootFromParent_Done,
     /*  473816 */   // Label 8041: @473816
     /*  473816 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(473905), // Rule ID 14591 //
     /*  473821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  473832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  473835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  473838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473868 */     // MIs[1] Operand 1
     /*  473868 */     // No operand predicates
     /*  473868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473877 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  473880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473903 */     GIR_RootConstrainSelectedInstOperands,
     /*  473904 */     // GIR_Coverage, 14591,
     /*  473904 */     GIR_EraseRootFromParent_Done,
     /*  473905 */   // Label 8042: @473905
     /*  473905 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(473991), // Rule ID 24686 //
     /*  473910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  473921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  473924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  473927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473957 */     // MIs[1] Operand 1
     /*  473957 */     // No operand predicates
     /*  473957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473966 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  473969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473989 */     GIR_RootConstrainSelectedInstOperands,
     /*  473990 */     // GIR_Coverage, 24686,
     /*  473990 */     GIR_EraseRootFromParent_Done,
     /*  473991 */   // Label 8043: @473991
     /*  473991 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(474077), // Rule ID 24687 //
     /*  473996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  474007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  474010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  474013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474043 */     // MIs[1] Operand 1
     /*  474043 */     // No operand predicates
     /*  474043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  474055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474075 */     GIR_RootConstrainSelectedInstOperands,
     /*  474076 */     // GIR_Coverage, 24687,
     /*  474076 */     GIR_EraseRootFromParent_Done,
     /*  474077 */   // Label 8044: @474077
     /*  474077 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(474163), // Rule ID 24690 //
     /*  474082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  474093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  474096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  474099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474129 */     // MIs[1] Operand 1
     /*  474129 */     // No operand predicates
     /*  474129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474138 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  474141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474161 */     GIR_RootConstrainSelectedInstOperands,
     /*  474162 */     // GIR_Coverage, 24690,
     /*  474162 */     GIR_EraseRootFromParent_Done,
     /*  474163 */   // Label 8045: @474163
     /*  474163 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(474249), // Rule ID 24691 //
     /*  474168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  474179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  474182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  474185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474215 */     // MIs[1] Operand 1
     /*  474215 */     // No operand predicates
     /*  474215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474224 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  474227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474247 */     GIR_RootConstrainSelectedInstOperands,
     /*  474248 */     // GIR_Coverage, 24691,
     /*  474248 */     GIR_EraseRootFromParent_Done,
     /*  474249 */   // Label 8046: @474249
     /*  474249 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(474335), // Rule ID 24694 //
     /*  474254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  474265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  474268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  474271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474301 */     // MIs[1] Operand 1
     /*  474301 */     // No operand predicates
     /*  474301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474310 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474333 */     GIR_RootConstrainSelectedInstOperands,
     /*  474334 */     // GIR_Coverage, 24694,
     /*  474334 */     GIR_EraseRootFromParent_Done,
     /*  474335 */   // Label 8047: @474335
     /*  474335 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(474421), // Rule ID 24695 //
     /*  474340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  474351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  474354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  474357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474387 */     // MIs[1] Operand 1
     /*  474387 */     // No operand predicates
     /*  474387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474419 */     GIR_RootConstrainSelectedInstOperands,
     /*  474420 */     // GIR_Coverage, 24695,
     /*  474420 */     GIR_EraseRootFromParent_Done,
     /*  474421 */   // Label 8048: @474421
     /*  474421 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(474507), // Rule ID 24698 //
     /*  474426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  474437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  474440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  474443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474473 */     // MIs[1] Operand 1
     /*  474473 */     // No operand predicates
     /*  474473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474482 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  474485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474505 */     GIR_RootConstrainSelectedInstOperands,
     /*  474506 */     // GIR_Coverage, 24698,
     /*  474506 */     GIR_EraseRootFromParent_Done,
     /*  474507 */   // Label 8049: @474507
     /*  474507 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(474593), // Rule ID 24699 //
     /*  474512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  474523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  474526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  474529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474559 */     // MIs[1] Operand 1
     /*  474559 */     // No operand predicates
     /*  474559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  474571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474591 */     GIR_RootConstrainSelectedInstOperands,
     /*  474592 */     // GIR_Coverage, 24699,
     /*  474592 */     GIR_EraseRootFromParent_Done,
     /*  474593 */   // Label 8050: @474593
     /*  474593 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(474679), // Rule ID 24702 //
     /*  474598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  474615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474645 */     // MIs[1] Operand 1
     /*  474645 */     // No operand predicates
     /*  474645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474654 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474677 */     GIR_RootConstrainSelectedInstOperands,
     /*  474678 */     // GIR_Coverage, 24702,
     /*  474678 */     GIR_EraseRootFromParent_Done,
     /*  474679 */   // Label 8051: @474679
     /*  474679 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(474765), // Rule ID 24703 //
     /*  474684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  474701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474731 */     // MIs[1] Operand 1
     /*  474731 */     // No operand predicates
     /*  474731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474740 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474763 */     GIR_RootConstrainSelectedInstOperands,
     /*  474764 */     // GIR_Coverage, 24703,
     /*  474764 */     GIR_EraseRootFromParent_Done,
     /*  474765 */   // Label 8052: @474765
     /*  474765 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(474851), // Rule ID 24706 //
     /*  474770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  474781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  474784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  474787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474817 */     // MIs[1] Operand 1
     /*  474817 */     // No operand predicates
     /*  474817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474826 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474849 */     GIR_RootConstrainSelectedInstOperands,
     /*  474850 */     // GIR_Coverage, 24706,
     /*  474850 */     GIR_EraseRootFromParent_Done,
     /*  474851 */   // Label 8053: @474851
     /*  474851 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(474937), // Rule ID 24707 //
     /*  474856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  474867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  474870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  474873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474903 */     // MIs[1] Operand 1
     /*  474903 */     // No operand predicates
     /*  474903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474912 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474935 */     GIR_RootConstrainSelectedInstOperands,
     /*  474936 */     // GIR_Coverage, 24707,
     /*  474936 */     GIR_EraseRootFromParent_Done,
     /*  474937 */   // Label 8054: @474937
     /*  474937 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(475023), // Rule ID 24710 //
     /*  474942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  474953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  474956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  474959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474989 */     // MIs[1] Operand 1
     /*  474989 */     // No operand predicates
     /*  474989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474998 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475021 */     GIR_RootConstrainSelectedInstOperands,
     /*  475022 */     // GIR_Coverage, 24710,
     /*  475022 */     GIR_EraseRootFromParent_Done,
     /*  475023 */   // Label 8055: @475023
     /*  475023 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(475109), // Rule ID 24711 //
     /*  475028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  475039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  475042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  475045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475075 */     // MIs[1] Operand 1
     /*  475075 */     // No operand predicates
     /*  475075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475084 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475107 */     GIR_RootConstrainSelectedInstOperands,
     /*  475108 */     // GIR_Coverage, 24711,
     /*  475108 */     GIR_EraseRootFromParent_Done,
     /*  475109 */   // Label 8056: @475109
     /*  475109 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(475195), // Rule ID 24714 //
     /*  475114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  475125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  475128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  475131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475161 */     // MIs[1] Operand 1
     /*  475161 */     // No operand predicates
     /*  475161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475193 */     GIR_RootConstrainSelectedInstOperands,
     /*  475194 */     // GIR_Coverage, 24714,
     /*  475194 */     GIR_EraseRootFromParent_Done,
     /*  475195 */   // Label 8057: @475195
     /*  475195 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(475281), // Rule ID 24715 //
     /*  475200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  475211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  475214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  475217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475247 */     // MIs[1] Operand 1
     /*  475247 */     // No operand predicates
     /*  475247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475256 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475279 */     GIR_RootConstrainSelectedInstOperands,
     /*  475280 */     // GIR_Coverage, 24715,
     /*  475280 */     GIR_EraseRootFromParent_Done,
     /*  475281 */   // Label 8058: @475281
     /*  475281 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(475367), // Rule ID 24718 //
     /*  475286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  475297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  475300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  475303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475333 */     // MIs[1] Operand 1
     /*  475333 */     // No operand predicates
     /*  475333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475342 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  475342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  475362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475365 */     GIR_RootConstrainSelectedInstOperands,
     /*  475366 */     // GIR_Coverage, 24718,
     /*  475366 */     GIR_EraseRootFromParent_Done,
     /*  475367 */   // Label 8059: @475367
     /*  475367 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(475453), // Rule ID 24719 //
     /*  475372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  475383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  475386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  475389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475419 */     // MIs[1] Operand 1
     /*  475419 */     // No operand predicates
     /*  475419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  475428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  475448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475451 */     GIR_RootConstrainSelectedInstOperands,
     /*  475452 */     // GIR_Coverage, 24719,
     /*  475452 */     GIR_EraseRootFromParent_Done,
     /*  475453 */   // Label 8060: @475453
     /*  475453 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(475539), // Rule ID 24722 //
     /*  475458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  475461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  475469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  475472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  475475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475505 */     // MIs[1] Operand 1
     /*  475505 */     // No operand predicates
     /*  475505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  475514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  475534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475537 */     GIR_RootConstrainSelectedInstOperands,
     /*  475538 */     // GIR_Coverage, 24722,
     /*  475538 */     GIR_EraseRootFromParent_Done,
     /*  475539 */   // Label 8061: @475539
     /*  475539 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(475625), // Rule ID 24723 //
     /*  475544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  475547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  475555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  475558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  475561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475591 */     // MIs[1] Operand 1
     /*  475591 */     // No operand predicates
     /*  475591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  475600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  475620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475623 */     GIR_RootConstrainSelectedInstOperands,
     /*  475624 */     // GIR_Coverage, 24723,
     /*  475624 */     GIR_EraseRootFromParent_Done,
     /*  475625 */   // Label 8062: @475625
     /*  475625 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(475711), // Rule ID 24726 //
     /*  475630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  475641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  475644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475677 */     // MIs[1] Operand 1
     /*  475677 */     // No operand predicates
     /*  475677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475686 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475709 */     GIR_RootConstrainSelectedInstOperands,
     /*  475710 */     // GIR_Coverage, 24726,
     /*  475710 */     GIR_EraseRootFromParent_Done,
     /*  475711 */   // Label 8063: @475711
     /*  475711 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(475797), // Rule ID 24727 //
     /*  475716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  475727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  475730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475763 */     // MIs[1] Operand 1
     /*  475763 */     // No operand predicates
     /*  475763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475772 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475795 */     GIR_RootConstrainSelectedInstOperands,
     /*  475796 */     // GIR_Coverage, 24727,
     /*  475796 */     GIR_EraseRootFromParent_Done,
     /*  475797 */   // Label 8064: @475797
     /*  475797 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(475883), // Rule ID 24730 //
     /*  475802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  475813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  475816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475849 */     // MIs[1] Operand 1
     /*  475849 */     // No operand predicates
     /*  475849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475858 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475881 */     GIR_RootConstrainSelectedInstOperands,
     /*  475882 */     // GIR_Coverage, 24730,
     /*  475882 */     GIR_EraseRootFromParent_Done,
     /*  475883 */   // Label 8065: @475883
     /*  475883 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(475969), // Rule ID 24731 //
     /*  475888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  475899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  475902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475935 */     // MIs[1] Operand 1
     /*  475935 */     // No operand predicates
     /*  475935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475944 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475967 */     GIR_RootConstrainSelectedInstOperands,
     /*  475968 */     // GIR_Coverage, 24731,
     /*  475968 */     GIR_EraseRootFromParent_Done,
     /*  475969 */   // Label 8066: @475969
     /*  475969 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(476055), // Rule ID 24734 //
     /*  475974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  475985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  475988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  475991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476021 */     // MIs[1] Operand 1
     /*  476021 */     // No operand predicates
     /*  476021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476030 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  476030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  476050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476053 */     GIR_RootConstrainSelectedInstOperands,
     /*  476054 */     // GIR_Coverage, 24734,
     /*  476054 */     GIR_EraseRootFromParent_Done,
     /*  476055 */   // Label 8067: @476055
     /*  476055 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(476141), // Rule ID 24735 //
     /*  476060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  476071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  476074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  476077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476107 */     // MIs[1] Operand 1
     /*  476107 */     // No operand predicates
     /*  476107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476116 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  476116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  476136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476139 */     GIR_RootConstrainSelectedInstOperands,
     /*  476140 */     // GIR_Coverage, 24735,
     /*  476140 */     GIR_EraseRootFromParent_Done,
     /*  476141 */   // Label 8068: @476141
     /*  476141 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(476227), // Rule ID 24738 //
     /*  476146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  476157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  476160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  476163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476193 */     // MIs[1] Operand 1
     /*  476193 */     // No operand predicates
     /*  476193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  476202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476225 */     GIR_RootConstrainSelectedInstOperands,
     /*  476226 */     // GIR_Coverage, 24738,
     /*  476226 */     GIR_EraseRootFromParent_Done,
     /*  476227 */   // Label 8069: @476227
     /*  476227 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(476313), // Rule ID 24739 //
     /*  476232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  476243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  476246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  476249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476279 */     // MIs[1] Operand 1
     /*  476279 */     // No operand predicates
     /*  476279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476288 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476311 */     GIR_RootConstrainSelectedInstOperands,
     /*  476312 */     // GIR_Coverage, 24739,
     /*  476312 */     GIR_EraseRootFromParent_Done,
     /*  476313 */   // Label 8070: @476313
     /*  476313 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(476399), // Rule ID 24742 //
     /*  476318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  476329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  476332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  476335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476365 */     // MIs[1] Operand 1
     /*  476365 */     // No operand predicates
     /*  476365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476374 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  476374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476397 */     GIR_RootConstrainSelectedInstOperands,
     /*  476398 */     // GIR_Coverage, 24742,
     /*  476398 */     GIR_EraseRootFromParent_Done,
     /*  476399 */   // Label 8071: @476399
     /*  476399 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(476485), // Rule ID 24743 //
     /*  476404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  476415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  476418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  476421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476451 */     // MIs[1] Operand 1
     /*  476451 */     // No operand predicates
     /*  476451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476483 */     GIR_RootConstrainSelectedInstOperands,
     /*  476484 */     // GIR_Coverage, 24743,
     /*  476484 */     GIR_EraseRootFromParent_Done,
     /*  476485 */   // Label 8072: @476485
     /*  476485 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(476571), // Rule ID 24746 //
     /*  476490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  476501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  476504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  476507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476537 */     // MIs[1] Operand 1
     /*  476537 */     // No operand predicates
     /*  476537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  476546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476569 */     GIR_RootConstrainSelectedInstOperands,
     /*  476570 */     // GIR_Coverage, 24746,
     /*  476570 */     GIR_EraseRootFromParent_Done,
     /*  476571 */   // Label 8073: @476571
     /*  476571 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(476657), // Rule ID 24747 //
     /*  476576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  476587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  476590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  476593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476623 */     // MIs[1] Operand 1
     /*  476623 */     // No operand predicates
     /*  476623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476632 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476655 */     GIR_RootConstrainSelectedInstOperands,
     /*  476656 */     // GIR_Coverage, 24747,
     /*  476656 */     GIR_EraseRootFromParent_Done,
     /*  476657 */   // Label 8074: @476657
     /*  476657 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(476743), // Rule ID 24750 //
     /*  476662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  476673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  476676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476709 */     // MIs[1] Operand 1
     /*  476709 */     // No operand predicates
     /*  476709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476741 */     GIR_RootConstrainSelectedInstOperands,
     /*  476742 */     // GIR_Coverage, 24750,
     /*  476742 */     GIR_EraseRootFromParent_Done,
     /*  476743 */   // Label 8075: @476743
     /*  476743 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(476829), // Rule ID 24751 //
     /*  476748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  476759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  476762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476795 */     // MIs[1] Operand 1
     /*  476795 */     // No operand predicates
     /*  476795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476827 */     GIR_RootConstrainSelectedInstOperands,
     /*  476828 */     // GIR_Coverage, 24751,
     /*  476828 */     GIR_EraseRootFromParent_Done,
     /*  476829 */   // Label 8076: @476829
     /*  476829 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(476915), // Rule ID 24754 //
     /*  476834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  476845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  476848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476881 */     // MIs[1] Operand 1
     /*  476881 */     // No operand predicates
     /*  476881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476890 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476913 */     GIR_RootConstrainSelectedInstOperands,
     /*  476914 */     // GIR_Coverage, 24754,
     /*  476914 */     GIR_EraseRootFromParent_Done,
     /*  476915 */   // Label 8077: @476915
     /*  476915 */   GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(477001), // Rule ID 24755 //
     /*  476920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  476931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  476934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476967 */     // MIs[1] Operand 1
     /*  476967 */     // No operand predicates
     /*  476967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476999 */     GIR_RootConstrainSelectedInstOperands,
     /*  477000 */     // GIR_Coverage, 24755,
     /*  477000 */     GIR_EraseRootFromParent_Done,
     /*  477001 */   // Label 8078: @477001
     /*  477001 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(477087), // Rule ID 24758 //
     /*  477006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  477017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  477020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  477023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477053 */     // MIs[1] Operand 1
     /*  477053 */     // No operand predicates
     /*  477053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477062 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  477062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477085 */     GIR_RootConstrainSelectedInstOperands,
     /*  477086 */     // GIR_Coverage, 24758,
     /*  477086 */     GIR_EraseRootFromParent_Done,
     /*  477087 */   // Label 8079: @477087
     /*  477087 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(477173), // Rule ID 24759 //
     /*  477092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  477103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  477106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  477109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477139 */     // MIs[1] Operand 1
     /*  477139 */     // No operand predicates
     /*  477139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477148 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  477148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477171 */     GIR_RootConstrainSelectedInstOperands,
     /*  477172 */     // GIR_Coverage, 24759,
     /*  477172 */     GIR_EraseRootFromParent_Done,
     /*  477173 */   // Label 8080: @477173
     /*  477173 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(477259), // Rule ID 24762 //
     /*  477178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  477181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  477189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  477192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  477195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477225 */     // MIs[1] Operand 1
     /*  477225 */     // No operand predicates
     /*  477225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  477237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477257 */     GIR_RootConstrainSelectedInstOperands,
     /*  477258 */     // GIR_Coverage, 24762,
     /*  477258 */     GIR_EraseRootFromParent_Done,
     /*  477259 */   // Label 8081: @477259
     /*  477259 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(477345), // Rule ID 24763 //
     /*  477264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  477267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  477275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  477278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  477281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477311 */     // MIs[1] Operand 1
     /*  477311 */     // No operand predicates
     /*  477311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  477323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477343 */     GIR_RootConstrainSelectedInstOperands,
     /*  477344 */     // GIR_Coverage, 24763,
     /*  477344 */     GIR_EraseRootFromParent_Done,
     /*  477345 */   // Label 8082: @477345
     /*  477345 */   GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(477431), // Rule ID 24766 //
     /*  477350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  477353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  477361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  477364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  477367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477397 */     // MIs[1] Operand 1
     /*  477397 */     // No operand predicates
     /*  477397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477406 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  477409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477429 */     GIR_RootConstrainSelectedInstOperands,
     /*  477430 */     // GIR_Coverage, 24766,
     /*  477430 */     GIR_EraseRootFromParent_Done,
     /*  477431 */   // Label 8083: @477431
     /*  477431 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(477517), // Rule ID 24767 //
     /*  477436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  477439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  477447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  477450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  477453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477483 */     // MIs[1] Operand 1
     /*  477483 */     // No operand predicates
     /*  477483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477492 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  477495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477515 */     GIR_RootConstrainSelectedInstOperands,
     /*  477516 */     // GIR_Coverage, 24767,
     /*  477516 */     GIR_EraseRootFromParent_Done,
     /*  477517 */   // Label 8084: @477517
     /*  477517 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(477603), // Rule ID 24770 //
     /*  477522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  477525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  477533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  477536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  477539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477569 */     // MIs[1] Operand 1
     /*  477569 */     // No operand predicates
     /*  477569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477578 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477601 */     GIR_RootConstrainSelectedInstOperands,
     /*  477602 */     // GIR_Coverage, 24770,
     /*  477602 */     GIR_EraseRootFromParent_Done,
     /*  477603 */   // Label 8085: @477603
     /*  477603 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(477689), // Rule ID 24771 //
     /*  477608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  477611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  477619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  477622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  477625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477655 */     // MIs[1] Operand 1
     /*  477655 */     // No operand predicates
     /*  477655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477664 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477687 */     GIR_RootConstrainSelectedInstOperands,
     /*  477688 */     // GIR_Coverage, 24771,
     /*  477688 */     GIR_EraseRootFromParent_Done,
     /*  477689 */   // Label 8086: @477689
     /*  477689 */   GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(477775), // Rule ID 24978 //
     /*  477694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  477705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  477708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477741 */     // MIs[1] Operand 1
     /*  477741 */     // No operand predicates
     /*  477741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477750 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477773 */     GIR_RootConstrainSelectedInstOperands,
     /*  477774 */     // GIR_Coverage, 24978,
     /*  477774 */     GIR_EraseRootFromParent_Done,
     /*  477775 */   // Label 8087: @477775
     /*  477775 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(477861), // Rule ID 24979 //
     /*  477780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  477791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  477794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477827 */     // MIs[1] Operand 1
     /*  477827 */     // No operand predicates
     /*  477827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477836 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  477836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477859 */     GIR_RootConstrainSelectedInstOperands,
     /*  477860 */     // GIR_Coverage, 24979,
     /*  477860 */     GIR_EraseRootFromParent_Done,
     /*  477861 */   // Label 8088: @477861
     /*  477861 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(477947), // Rule ID 24982 //
     /*  477866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  477877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  477880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  477883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477913 */     // MIs[1] Operand 1
     /*  477913 */     // No operand predicates
     /*  477913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477922 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477945 */     GIR_RootConstrainSelectedInstOperands,
     /*  477946 */     // GIR_Coverage, 24982,
     /*  477946 */     GIR_EraseRootFromParent_Done,
     /*  477947 */   // Label 8089: @477947
     /*  477947 */   GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(478033), // Rule ID 24983 //
     /*  477952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  477963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  477966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  477969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477999 */     // MIs[1] Operand 1
     /*  477999 */     // No operand predicates
     /*  477999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478008 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478031 */     GIR_RootConstrainSelectedInstOperands,
     /*  478032 */     // GIR_Coverage, 24983,
     /*  478032 */     GIR_EraseRootFromParent_Done,
     /*  478033 */   // Label 8090: @478033
     /*  478033 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(478119), // Rule ID 24986 //
     /*  478038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  478049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  478052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  478055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478085 */     // MIs[1] Operand 1
     /*  478085 */     // No operand predicates
     /*  478085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478094 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478117 */     GIR_RootConstrainSelectedInstOperands,
     /*  478118 */     // GIR_Coverage, 24986,
     /*  478118 */     GIR_EraseRootFromParent_Done,
     /*  478119 */   // Label 8091: @478119
     /*  478119 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(478205), // Rule ID 24987 //
     /*  478124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  478135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  478138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  478141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478171 */     // MIs[1] Operand 1
     /*  478171 */     // No operand predicates
     /*  478171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478180 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478203 */     GIR_RootConstrainSelectedInstOperands,
     /*  478204 */     // GIR_Coverage, 24987,
     /*  478204 */     GIR_EraseRootFromParent_Done,
     /*  478205 */   // Label 8092: @478205
     /*  478205 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(478291), // Rule ID 24990 //
     /*  478210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  478221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  478224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  478227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478257 */     // MIs[1] Operand 1
     /*  478257 */     // No operand predicates
     /*  478257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478266 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478289 */     GIR_RootConstrainSelectedInstOperands,
     /*  478290 */     // GIR_Coverage, 24990,
     /*  478290 */     GIR_EraseRootFromParent_Done,
     /*  478291 */   // Label 8093: @478291
     /*  478291 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(478377), // Rule ID 24991 //
     /*  478296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  478307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  478310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  478313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478343 */     // MIs[1] Operand 1
     /*  478343 */     // No operand predicates
     /*  478343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478375 */     GIR_RootConstrainSelectedInstOperands,
     /*  478376 */     // GIR_Coverage, 24991,
     /*  478376 */     GIR_EraseRootFromParent_Done,
     /*  478377 */   // Label 8094: @478377
     /*  478377 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(478463), // Rule ID 24994 //
     /*  478382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  478393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  478396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  478399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478429 */     // MIs[1] Operand 1
     /*  478429 */     // No operand predicates
     /*  478429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478438 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478461 */     GIR_RootConstrainSelectedInstOperands,
     /*  478462 */     // GIR_Coverage, 24994,
     /*  478462 */     GIR_EraseRootFromParent_Done,
     /*  478463 */   // Label 8095: @478463
     /*  478463 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(478549), // Rule ID 24995 //
     /*  478468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  478479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  478482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  478485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478515 */     // MIs[1] Operand 1
     /*  478515 */     // No operand predicates
     /*  478515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478547 */     GIR_RootConstrainSelectedInstOperands,
     /*  478548 */     // GIR_Coverage, 24995,
     /*  478548 */     GIR_EraseRootFromParent_Done,
     /*  478549 */   // Label 8096: @478549
     /*  478549 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(478635), // Rule ID 24998 //
     /*  478554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  478557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  478571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478601 */     // MIs[1] Operand 1
     /*  478601 */     // No operand predicates
     /*  478601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478610 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  478610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478633 */     GIR_RootConstrainSelectedInstOperands,
     /*  478634 */     // GIR_Coverage, 24998,
     /*  478634 */     GIR_EraseRootFromParent_Done,
     /*  478635 */   // Label 8097: @478635
     /*  478635 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(478721), // Rule ID 24999 //
     /*  478640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  478643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  478657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478687 */     // MIs[1] Operand 1
     /*  478687 */     // No operand predicates
     /*  478687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478696 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  478696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478719 */     GIR_RootConstrainSelectedInstOperands,
     /*  478720 */     // GIR_Coverage, 24999,
     /*  478720 */     GIR_EraseRootFromParent_Done,
     /*  478721 */   // Label 8098: @478721
     /*  478721 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(478807), // Rule ID 25002 //
     /*  478726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  478737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  478740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  478743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478773 */     // MIs[1] Operand 1
     /*  478773 */     // No operand predicates
     /*  478773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478782 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478805 */     GIR_RootConstrainSelectedInstOperands,
     /*  478806 */     // GIR_Coverage, 25002,
     /*  478806 */     GIR_EraseRootFromParent_Done,
     /*  478807 */   // Label 8099: @478807
     /*  478807 */   GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(478893), // Rule ID 25003 //
     /*  478812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  478823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  478826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  478829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478859 */     // MIs[1] Operand 1
     /*  478859 */     // No operand predicates
     /*  478859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478868 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478891 */     GIR_RootConstrainSelectedInstOperands,
     /*  478892 */     // GIR_Coverage, 25003,
     /*  478892 */     GIR_EraseRootFromParent_Done,
     /*  478893 */   // Label 8100: @478893
     /*  478893 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(478979), // Rule ID 25006 //
     /*  478898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  478909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  478912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  478915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478945 */     // MIs[1] Operand 1
     /*  478945 */     // No operand predicates
     /*  478945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478954 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  478957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478977 */     GIR_RootConstrainSelectedInstOperands,
     /*  478978 */     // GIR_Coverage, 25006,
     /*  478978 */     GIR_EraseRootFromParent_Done,
     /*  478979 */   // Label 8101: @478979
     /*  478979 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(479065), // Rule ID 25007 //
     /*  478984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  478995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  478998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  479001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479031 */     // MIs[1] Operand 1
     /*  479031 */     // No operand predicates
     /*  479031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479040 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  479040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479063 */     GIR_RootConstrainSelectedInstOperands,
     /*  479064 */     // GIR_Coverage, 25007,
     /*  479064 */     GIR_EraseRootFromParent_Done,
     /*  479065 */   // Label 8102: @479065
     /*  479065 */   GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(479151), // Rule ID 25010 //
     /*  479070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  479081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  479084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  479087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479117 */     // MIs[1] Operand 1
     /*  479117 */     // No operand predicates
     /*  479117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479126 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  479126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479149 */     GIR_RootConstrainSelectedInstOperands,
     /*  479150 */     // GIR_Coverage, 25010,
     /*  479150 */     GIR_EraseRootFromParent_Done,
     /*  479151 */   // Label 8103: @479151
     /*  479151 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(479237), // Rule ID 25011 //
     /*  479156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  479167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  479170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  479173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479203 */     // MIs[1] Operand 1
     /*  479203 */     // No operand predicates
     /*  479203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479212 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  479212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479235 */     GIR_RootConstrainSelectedInstOperands,
     /*  479236 */     // GIR_Coverage, 25011,
     /*  479236 */     GIR_EraseRootFromParent_Done,
     /*  479237 */   // Label 8104: @479237
     /*  479237 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(479323), // Rule ID 25014 //
     /*  479242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  479253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  479256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  479259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479289 */     // MIs[1] Operand 1
     /*  479289 */     // No operand predicates
     /*  479289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479298 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  479298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479321 */     GIR_RootConstrainSelectedInstOperands,
     /*  479322 */     // GIR_Coverage, 25014,
     /*  479322 */     GIR_EraseRootFromParent_Done,
     /*  479323 */   // Label 8105: @479323
     /*  479323 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(479409), // Rule ID 25015 //
     /*  479328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  479339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  479342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  479345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479375 */     // MIs[1] Operand 1
     /*  479375 */     // No operand predicates
     /*  479375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479384 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  479384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479407 */     GIR_RootConstrainSelectedInstOperands,
     /*  479408 */     // GIR_Coverage, 25015,
     /*  479408 */     GIR_EraseRootFromParent_Done,
     /*  479409 */   // Label 8106: @479409
     /*  479409 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(479495), // Rule ID 25018 //
     /*  479414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  479425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  479428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  479431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479461 */     // MIs[1] Operand 1
     /*  479461 */     // No operand predicates
     /*  479461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479470 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  479470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479493 */     GIR_RootConstrainSelectedInstOperands,
     /*  479494 */     // GIR_Coverage, 25018,
     /*  479494 */     GIR_EraseRootFromParent_Done,
     /*  479495 */   // Label 8107: @479495
     /*  479495 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(479581), // Rule ID 25019 //
     /*  479500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  479511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  479514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  479517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479547 */     // MIs[1] Operand 1
     /*  479547 */     // No operand predicates
     /*  479547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479556 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  479556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479579 */     GIR_RootConstrainSelectedInstOperands,
     /*  479580 */     // GIR_Coverage, 25019,
     /*  479580 */     GIR_EraseRootFromParent_Done,
     /*  479581 */   // Label 8108: @479581
     /*  479581 */   GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(479667), // Rule ID 25022 //
     /*  479586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  479597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  479600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  479603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479633 */     // MIs[1] Operand 1
     /*  479633 */     // No operand predicates
     /*  479633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479642 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  479642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479665 */     GIR_RootConstrainSelectedInstOperands,
     /*  479666 */     // GIR_Coverage, 25022,
     /*  479666 */     GIR_EraseRootFromParent_Done,
     /*  479667 */   // Label 8109: @479667
     /*  479667 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(479753), // Rule ID 25023 //
     /*  479672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  479683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  479686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  479689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479719 */     // MIs[1] Operand 1
     /*  479719 */     // No operand predicates
     /*  479719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479728 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  479728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479751 */     GIR_RootConstrainSelectedInstOperands,
     /*  479752 */     // GIR_Coverage, 25023,
     /*  479752 */     GIR_EraseRootFromParent_Done,
     /*  479753 */   // Label 8110: @479753
     /*  479753 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(479839), // Rule ID 25026 //
     /*  479758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  479761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  479769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  479772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  479775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479805 */     // MIs[1] Operand 1
     /*  479805 */     // No operand predicates
     /*  479805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479814 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  479814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479837 */     GIR_RootConstrainSelectedInstOperands,
     /*  479838 */     // GIR_Coverage, 25026,
     /*  479838 */     GIR_EraseRootFromParent_Done,
     /*  479839 */   // Label 8111: @479839
     /*  479839 */   GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(479925), // Rule ID 25027 //
     /*  479844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  479847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  479855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  479858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  479861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479891 */     // MIs[1] Operand 1
     /*  479891 */     // No operand predicates
     /*  479891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479900 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  479900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479923 */     GIR_RootConstrainSelectedInstOperands,
     /*  479924 */     // GIR_Coverage, 25027,
     /*  479924 */     GIR_EraseRootFromParent_Done,
     /*  479925 */   // Label 8112: @479925
     /*  479925 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(480011), // Rule ID 25030 //
     /*  479930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  479933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  479941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  479944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  479947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479977 */     // MIs[1] Operand 1
     /*  479977 */     // No operand predicates
     /*  479977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479986 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  479986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480009 */     GIR_RootConstrainSelectedInstOperands,
     /*  480010 */     // GIR_Coverage, 25030,
     /*  480010 */     GIR_EraseRootFromParent_Done,
     /*  480011 */   // Label 8113: @480011
     /*  480011 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(480097), // Rule ID 25031 //
     /*  480016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  480019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  480027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  480030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  480033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480063 */     // MIs[1] Operand 1
     /*  480063 */     // No operand predicates
     /*  480063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480072 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  480072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  480075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480095 */     GIR_RootConstrainSelectedInstOperands,
     /*  480096 */     // GIR_Coverage, 25031,
     /*  480096 */     GIR_EraseRootFromParent_Done,
     /*  480097 */   // Label 8114: @480097
     /*  480097 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(480183), // Rule ID 25034 //
     /*  480102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  480105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  480113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  480116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  480119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480149 */     // MIs[1] Operand 1
     /*  480149 */     // No operand predicates
     /*  480149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480158 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  480158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  480161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480181 */     GIR_RootConstrainSelectedInstOperands,
     /*  480182 */     // GIR_Coverage, 25034,
     /*  480182 */     GIR_EraseRootFromParent_Done,
     /*  480183 */   // Label 8115: @480183
     /*  480183 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(480269), // Rule ID 25035 //
     /*  480188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  480191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  480199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  480202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  480205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480235 */     // MIs[1] Operand 1
     /*  480235 */     // No operand predicates
     /*  480235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480244 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  480244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  480247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480267 */     GIR_RootConstrainSelectedInstOperands,
     /*  480268 */     // GIR_Coverage, 25035,
     /*  480268 */     GIR_EraseRootFromParent_Done,
     /*  480269 */   // Label 8116: @480269
     /*  480269 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(480355), // Rule ID 61046 //
     /*  480274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  480285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  480288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  480291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480321 */     // MIs[1] Operand 1
     /*  480321 */     // No operand predicates
     /*  480321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480330 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  480333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480353 */     GIR_RootConstrainSelectedInstOperands,
     /*  480354 */     // GIR_Coverage, 61046,
     /*  480354 */     GIR_EraseRootFromParent_Done,
     /*  480355 */   // Label 8117: @480355
     /*  480355 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(480441), // Rule ID 61047 //
     /*  480360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  480371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  480374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  480377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480407 */     // MIs[1] Operand 1
     /*  480407 */     // No operand predicates
     /*  480407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480416 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  480419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480439 */     GIR_RootConstrainSelectedInstOperands,
     /*  480440 */     // GIR_Coverage, 61047,
     /*  480440 */     GIR_EraseRootFromParent_Done,
     /*  480441 */   // Label 8118: @480441
     /*  480441 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(480527), // Rule ID 61054 //
     /*  480446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  480457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  480460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  480463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480493 */     // MIs[1] Operand 1
     /*  480493 */     // No operand predicates
     /*  480493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480502 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480525 */     GIR_RootConstrainSelectedInstOperands,
     /*  480526 */     // GIR_Coverage, 61054,
     /*  480526 */     GIR_EraseRootFromParent_Done,
     /*  480527 */   // Label 8119: @480527
     /*  480527 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(480613), // Rule ID 61055 //
     /*  480532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  480543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  480546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  480549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480579 */     // MIs[1] Operand 1
     /*  480579 */     // No operand predicates
     /*  480579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480588 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480611 */     GIR_RootConstrainSelectedInstOperands,
     /*  480612 */     // GIR_Coverage, 61055,
     /*  480612 */     GIR_EraseRootFromParent_Done,
     /*  480613 */   // Label 8120: @480613
     /*  480613 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(480699), // Rule ID 61062 //
     /*  480618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  480629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  480632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  480635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480665 */     // MIs[1] Operand 1
     /*  480665 */     // No operand predicates
     /*  480665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  480677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480697 */     GIR_RootConstrainSelectedInstOperands,
     /*  480698 */     // GIR_Coverage, 61062,
     /*  480698 */     GIR_EraseRootFromParent_Done,
     /*  480699 */   // Label 8121: @480699
     /*  480699 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(480785), // Rule ID 61063 //
     /*  480704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  480715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  480718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  480721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480751 */     // MIs[1] Operand 1
     /*  480751 */     // No operand predicates
     /*  480751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480760 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  480763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480783 */     GIR_RootConstrainSelectedInstOperands,
     /*  480784 */     // GIR_Coverage, 61063,
     /*  480784 */     GIR_EraseRootFromParent_Done,
     /*  480785 */   // Label 8122: @480785
     /*  480785 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(480871), // Rule ID 61070 //
     /*  480790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  480801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  480804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  480807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480837 */     // MIs[1] Operand 1
     /*  480837 */     // No operand predicates
     /*  480837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  480849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480869 */     GIR_RootConstrainSelectedInstOperands,
     /*  480870 */     // GIR_Coverage, 61070,
     /*  480870 */     GIR_EraseRootFromParent_Done,
     /*  480871 */   // Label 8123: @480871
     /*  480871 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(480957), // Rule ID 61071 //
     /*  480876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  480887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  480890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  480893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480923 */     // MIs[1] Operand 1
     /*  480923 */     // No operand predicates
     /*  480923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480932 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  480935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480955 */     GIR_RootConstrainSelectedInstOperands,
     /*  480956 */     // GIR_Coverage, 61071,
     /*  480956 */     GIR_EraseRootFromParent_Done,
     /*  480957 */   // Label 8124: @480957
     /*  480957 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(481043), // Rule ID 61078 //
     /*  480962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  480973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  480976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  480979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481009 */     // MIs[1] Operand 1
     /*  481009 */     // No operand predicates
     /*  481009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481018 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  481018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481041 */     GIR_RootConstrainSelectedInstOperands,
     /*  481042 */     // GIR_Coverage, 61078,
     /*  481042 */     GIR_EraseRootFromParent_Done,
     /*  481043 */   // Label 8125: @481043
     /*  481043 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(481129), // Rule ID 61079 //
     /*  481048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  481059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  481062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  481065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481095 */     // MIs[1] Operand 1
     /*  481095 */     // No operand predicates
     /*  481095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481104 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  481104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481127 */     GIR_RootConstrainSelectedInstOperands,
     /*  481128 */     // GIR_Coverage, 61079,
     /*  481128 */     GIR_EraseRootFromParent_Done,
     /*  481129 */   // Label 8126: @481129
     /*  481129 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(481215), // Rule ID 61086 //
     /*  481134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  481145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  481148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  481151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481181 */     // MIs[1] Operand 1
     /*  481181 */     // No operand predicates
     /*  481181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481190 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  481190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  481193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481213 */     GIR_RootConstrainSelectedInstOperands,
     /*  481214 */     // GIR_Coverage, 61086,
     /*  481214 */     GIR_EraseRootFromParent_Done,
     /*  481215 */   // Label 8127: @481215
     /*  481215 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(481301), // Rule ID 61087 //
     /*  481220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  481231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  481234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  481237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481267 */     // MIs[1] Operand 1
     /*  481267 */     // No operand predicates
     /*  481267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481276 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  481276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  481279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481299 */     GIR_RootConstrainSelectedInstOperands,
     /*  481300 */     // GIR_Coverage, 61087,
     /*  481300 */     GIR_EraseRootFromParent_Done,
     /*  481301 */   // Label 8128: @481301
     /*  481301 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(481387), // Rule ID 61094 //
     /*  481306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  481317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  481320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  481323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481353 */     // MIs[1] Operand 1
     /*  481353 */     // No operand predicates
     /*  481353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481362 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  481365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481385 */     GIR_RootConstrainSelectedInstOperands,
     /*  481386 */     // GIR_Coverage, 61094,
     /*  481386 */     GIR_EraseRootFromParent_Done,
     /*  481387 */   // Label 8129: @481387
     /*  481387 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(481473), // Rule ID 61095 //
     /*  481392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  481403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  481406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  481409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481439 */     // MIs[1] Operand 1
     /*  481439 */     // No operand predicates
     /*  481439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481448 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  481451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481471 */     GIR_RootConstrainSelectedInstOperands,
     /*  481472 */     // GIR_Coverage, 61095,
     /*  481472 */     GIR_EraseRootFromParent_Done,
     /*  481473 */   // Label 8130: @481473
     /*  481473 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(481559), // Rule ID 61102 //
     /*  481478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  481489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  481492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  481495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481525 */     // MIs[1] Operand 1
     /*  481525 */     // No operand predicates
     /*  481525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481557 */     GIR_RootConstrainSelectedInstOperands,
     /*  481558 */     // GIR_Coverage, 61102,
     /*  481558 */     GIR_EraseRootFromParent_Done,
     /*  481559 */   // Label 8131: @481559
     /*  481559 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(481645), // Rule ID 61103 //
     /*  481564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  481575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  481578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  481581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481611 */     // MIs[1] Operand 1
     /*  481611 */     // No operand predicates
     /*  481611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481643 */     GIR_RootConstrainSelectedInstOperands,
     /*  481644 */     // GIR_Coverage, 61103,
     /*  481644 */     GIR_EraseRootFromParent_Done,
     /*  481645 */   // Label 8132: @481645
     /*  481645 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(481731), // Rule ID 61110 //
     /*  481650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  481661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  481664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  481667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481697 */     // MIs[1] Operand 1
     /*  481697 */     // No operand predicates
     /*  481697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  481709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481729 */     GIR_RootConstrainSelectedInstOperands,
     /*  481730 */     // GIR_Coverage, 61110,
     /*  481730 */     GIR_EraseRootFromParent_Done,
     /*  481731 */   // Label 8133: @481731
     /*  481731 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(481817), // Rule ID 61111 //
     /*  481736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  481747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  481750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  481753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481783 */     // MIs[1] Operand 1
     /*  481783 */     // No operand predicates
     /*  481783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481792 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  481795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481815 */     GIR_RootConstrainSelectedInstOperands,
     /*  481816 */     // GIR_Coverage, 61111,
     /*  481816 */     GIR_EraseRootFromParent_Done,
     /*  481817 */   // Label 8134: @481817
     /*  481817 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(481903), // Rule ID 61118 //
     /*  481822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  481833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  481836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  481839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481869 */     // MIs[1] Operand 1
     /*  481869 */     // No operand predicates
     /*  481869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481901 */     GIR_RootConstrainSelectedInstOperands,
     /*  481902 */     // GIR_Coverage, 61118,
     /*  481902 */     GIR_EraseRootFromParent_Done,
     /*  481903 */   // Label 8135: @481903
     /*  481903 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(481989), // Rule ID 61119 //
     /*  481908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  481919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  481922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  481925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481955 */     // MIs[1] Operand 1
     /*  481955 */     // No operand predicates
     /*  481955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481964 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481987 */     GIR_RootConstrainSelectedInstOperands,
     /*  481988 */     // GIR_Coverage, 61119,
     /*  481988 */     GIR_EraseRootFromParent_Done,
     /*  481989 */   // Label 8136: @481989
     /*  481989 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(482075), // Rule ID 61126 //
     /*  481994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  482005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  482008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  482011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482041 */     // MIs[1] Operand 1
     /*  482041 */     // No operand predicates
     /*  482041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482050 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  482053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482073 */     GIR_RootConstrainSelectedInstOperands,
     /*  482074 */     // GIR_Coverage, 61126,
     /*  482074 */     GIR_EraseRootFromParent_Done,
     /*  482075 */   // Label 8137: @482075
     /*  482075 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(482161), // Rule ID 61127 //
     /*  482080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  482091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  482094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  482097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482127 */     // MIs[1] Operand 1
     /*  482127 */     // No operand predicates
     /*  482127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482136 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  482139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482159 */     GIR_RootConstrainSelectedInstOperands,
     /*  482160 */     // GIR_Coverage, 61127,
     /*  482160 */     GIR_EraseRootFromParent_Done,
     /*  482161 */   // Label 8138: @482161
     /*  482161 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(482247), // Rule ID 61134 //
     /*  482166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  482169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  482177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  482180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  482183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482213 */     // MIs[1] Operand 1
     /*  482213 */     // No operand predicates
     /*  482213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482222 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  482225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482245 */     GIR_RootConstrainSelectedInstOperands,
     /*  482246 */     // GIR_Coverage, 61134,
     /*  482246 */     GIR_EraseRootFromParent_Done,
     /*  482247 */   // Label 8139: @482247
     /*  482247 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(482333), // Rule ID 61135 //
     /*  482252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  482263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  482266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  482269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482299 */     // MIs[1] Operand 1
     /*  482299 */     // No operand predicates
     /*  482299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  482311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482331 */     GIR_RootConstrainSelectedInstOperands,
     /*  482332 */     // GIR_Coverage, 61135,
     /*  482332 */     GIR_EraseRootFromParent_Done,
     /*  482333 */   // Label 8140: @482333
     /*  482333 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(482419), // Rule ID 61142 //
     /*  482338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  482341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  482349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  482352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  482355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482385 */     // MIs[1] Operand 1
     /*  482385 */     // No operand predicates
     /*  482385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  482397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482417 */     GIR_RootConstrainSelectedInstOperands,
     /*  482418 */     // GIR_Coverage, 61142,
     /*  482418 */     GIR_EraseRootFromParent_Done,
     /*  482419 */   // Label 8141: @482419
     /*  482419 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(482505), // Rule ID 61143 //
     /*  482424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  482435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  482438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  482441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482471 */     // MIs[1] Operand 1
     /*  482471 */     // No operand predicates
     /*  482471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482480 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  482483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482503 */     GIR_RootConstrainSelectedInstOperands,
     /*  482504 */     // GIR_Coverage, 61143,
     /*  482504 */     GIR_EraseRootFromParent_Done,
     /*  482505 */   // Label 8142: @482505
     /*  482505 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(482591), // Rule ID 61150 //
     /*  482510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  482513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  482521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  482524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  482527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482557 */     // MIs[1] Operand 1
     /*  482557 */     // No operand predicates
     /*  482557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482566 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  482569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482589 */     GIR_RootConstrainSelectedInstOperands,
     /*  482590 */     // GIR_Coverage, 61150,
     /*  482590 */     GIR_EraseRootFromParent_Done,
     /*  482591 */   // Label 8143: @482591
     /*  482591 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(482677), // Rule ID 61151 //
     /*  482596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  482607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  482610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  482613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482643 */     // MIs[1] Operand 1
     /*  482643 */     // No operand predicates
     /*  482643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482652 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  482655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482675 */     GIR_RootConstrainSelectedInstOperands,
     /*  482676 */     // GIR_Coverage, 61151,
     /*  482676 */     GIR_EraseRootFromParent_Done,
     /*  482677 */   // Label 8144: @482677
     /*  482677 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(482763), // Rule ID 61158 //
     /*  482682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  482685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  482693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  482696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  482699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482729 */     // MIs[1] Operand 1
     /*  482729 */     // No operand predicates
     /*  482729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482738 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  482741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482761 */     GIR_RootConstrainSelectedInstOperands,
     /*  482762 */     // GIR_Coverage, 61158,
     /*  482762 */     GIR_EraseRootFromParent_Done,
     /*  482763 */   // Label 8145: @482763
     /*  482763 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(482849), // Rule ID 61159 //
     /*  482768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  482779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  482782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  482785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482815 */     // MIs[1] Operand 1
     /*  482815 */     // No operand predicates
     /*  482815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482824 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  482827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482847 */     GIR_RootConstrainSelectedInstOperands,
     /*  482848 */     // GIR_Coverage, 61159,
     /*  482848 */     GIR_EraseRootFromParent_Done,
     /*  482849 */   // Label 8146: @482849
     /*  482849 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(482935), // Rule ID 62014 //
     /*  482854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  482865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  482868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  482871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482901 */     // MIs[1] Operand 1
     /*  482901 */     // No operand predicates
     /*  482901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482910 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  482910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  482913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482933 */     GIR_RootConstrainSelectedInstOperands,
     /*  482934 */     // GIR_Coverage, 62014,
     /*  482934 */     GIR_EraseRootFromParent_Done,
     /*  482935 */   // Label 8147: @482935
     /*  482935 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(483021), // Rule ID 62015 //
     /*  482940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  482951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  482954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  482957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482987 */     // MIs[1] Operand 1
     /*  482987 */     // No operand predicates
     /*  482987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  482996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  482999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483019 */     GIR_RootConstrainSelectedInstOperands,
     /*  483020 */     // GIR_Coverage, 62015,
     /*  483020 */     GIR_EraseRootFromParent_Done,
     /*  483021 */   // Label 8148: @483021
     /*  483021 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(483107), // Rule ID 62018 //
     /*  483026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  483037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  483040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  483043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483073 */     // MIs[1] Operand 1
     /*  483073 */     // No operand predicates
     /*  483073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483082 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  483085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483105 */     GIR_RootConstrainSelectedInstOperands,
     /*  483106 */     // GIR_Coverage, 62018,
     /*  483106 */     GIR_EraseRootFromParent_Done,
     /*  483107 */   // Label 8149: @483107
     /*  483107 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(483193), // Rule ID 62019 //
     /*  483112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  483123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  483126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  483129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483159 */     // MIs[1] Operand 1
     /*  483159 */     // No operand predicates
     /*  483159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483168 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  483171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483191 */     GIR_RootConstrainSelectedInstOperands,
     /*  483192 */     // GIR_Coverage, 62019,
     /*  483192 */     GIR_EraseRootFromParent_Done,
     /*  483193 */   // Label 8150: @483193
     /*  483193 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(483279), // Rule ID 62022 //
     /*  483198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  483209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  483212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  483215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483245 */     // MIs[1] Operand 1
     /*  483245 */     // No operand predicates
     /*  483245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483254 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483277 */     GIR_RootConstrainSelectedInstOperands,
     /*  483278 */     // GIR_Coverage, 62022,
     /*  483278 */     GIR_EraseRootFromParent_Done,
     /*  483279 */   // Label 8151: @483279
     /*  483279 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(483365), // Rule ID 62023 //
     /*  483284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  483295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  483298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  483301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483331 */     // MIs[1] Operand 1
     /*  483331 */     // No operand predicates
     /*  483331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483340 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483363 */     GIR_RootConstrainSelectedInstOperands,
     /*  483364 */     // GIR_Coverage, 62023,
     /*  483364 */     GIR_EraseRootFromParent_Done,
     /*  483365 */   // Label 8152: @483365
     /*  483365 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(483451), // Rule ID 62026 //
     /*  483370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  483381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  483384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  483387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483417 */     // MIs[1] Operand 1
     /*  483417 */     // No operand predicates
     /*  483417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483426 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  483429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483449 */     GIR_RootConstrainSelectedInstOperands,
     /*  483450 */     // GIR_Coverage, 62026,
     /*  483450 */     GIR_EraseRootFromParent_Done,
     /*  483451 */   // Label 8153: @483451
     /*  483451 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(483537), // Rule ID 62027 //
     /*  483456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  483467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  483470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  483473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483503 */     // MIs[1] Operand 1
     /*  483503 */     // No operand predicates
     /*  483503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483512 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  483515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483535 */     GIR_RootConstrainSelectedInstOperands,
     /*  483536 */     // GIR_Coverage, 62027,
     /*  483536 */     GIR_EraseRootFromParent_Done,
     /*  483537 */   // Label 8154: @483537
     /*  483537 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(483623), // Rule ID 62030 //
     /*  483542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  483559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483589 */     // MIs[1] Operand 1
     /*  483589 */     // No operand predicates
     /*  483589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483598 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483621 */     GIR_RootConstrainSelectedInstOperands,
     /*  483622 */     // GIR_Coverage, 62030,
     /*  483622 */     GIR_EraseRootFromParent_Done,
     /*  483623 */   // Label 8155: @483623
     /*  483623 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(483709), // Rule ID 62031 //
     /*  483628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  483645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483675 */     // MIs[1] Operand 1
     /*  483675 */     // No operand predicates
     /*  483675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483707 */     GIR_RootConstrainSelectedInstOperands,
     /*  483708 */     // GIR_Coverage, 62031,
     /*  483708 */     GIR_EraseRootFromParent_Done,
     /*  483709 */   // Label 8156: @483709
     /*  483709 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(483795), // Rule ID 62034 //
     /*  483714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  483725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  483728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  483731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483761 */     // MIs[1] Operand 1
     /*  483761 */     // No operand predicates
     /*  483761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483770 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  483770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483793 */     GIR_RootConstrainSelectedInstOperands,
     /*  483794 */     // GIR_Coverage, 62034,
     /*  483794 */     GIR_EraseRootFromParent_Done,
     /*  483795 */   // Label 8157: @483795
     /*  483795 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(483881), // Rule ID 62035 //
     /*  483800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  483811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  483814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  483817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483847 */     // MIs[1] Operand 1
     /*  483847 */     // No operand predicates
     /*  483847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  483856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483879 */     GIR_RootConstrainSelectedInstOperands,
     /*  483880 */     // GIR_Coverage, 62035,
     /*  483880 */     GIR_EraseRootFromParent_Done,
     /*  483881 */   // Label 8158: @483881
     /*  483881 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(483967), // Rule ID 62038 //
     /*  483886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  483897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  483900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  483903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483933 */     // MIs[1] Operand 1
     /*  483933 */     // No operand predicates
     /*  483933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483942 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483965 */     GIR_RootConstrainSelectedInstOperands,
     /*  483966 */     // GIR_Coverage, 62038,
     /*  483966 */     GIR_EraseRootFromParent_Done,
     /*  483967 */   // Label 8159: @483967
     /*  483967 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(484053), // Rule ID 62039 //
     /*  483972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  483983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  483986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  483989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484019 */     // MIs[1] Operand 1
     /*  484019 */     // No operand predicates
     /*  484019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484028 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484051 */     GIR_RootConstrainSelectedInstOperands,
     /*  484052 */     // GIR_Coverage, 62039,
     /*  484052 */     GIR_EraseRootFromParent_Done,
     /*  484053 */   // Label 8160: @484053
     /*  484053 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(484139), // Rule ID 62042 //
     /*  484058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  484069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  484072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  484075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484105 */     // MIs[1] Operand 1
     /*  484105 */     // No operand predicates
     /*  484105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484137 */     GIR_RootConstrainSelectedInstOperands,
     /*  484138 */     // GIR_Coverage, 62042,
     /*  484138 */     GIR_EraseRootFromParent_Done,
     /*  484139 */   // Label 8161: @484139
     /*  484139 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(484225), // Rule ID 62043 //
     /*  484144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  484155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  484158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  484161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484191 */     // MIs[1] Operand 1
     /*  484191 */     // No operand predicates
     /*  484191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484223 */     GIR_RootConstrainSelectedInstOperands,
     /*  484224 */     // GIR_Coverage, 62043,
     /*  484224 */     GIR_EraseRootFromParent_Done,
     /*  484225 */   // Label 8162: @484225
     /*  484225 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(484311), // Rule ID 62046 //
     /*  484230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  484241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  484244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  484247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484277 */     // MIs[1] Operand 1
     /*  484277 */     // No operand predicates
     /*  484277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  484286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  484306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484309 */     GIR_RootConstrainSelectedInstOperands,
     /*  484310 */     // GIR_Coverage, 62046,
     /*  484310 */     GIR_EraseRootFromParent_Done,
     /*  484311 */   // Label 8163: @484311
     /*  484311 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(484397), // Rule ID 62047 //
     /*  484316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  484327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  484330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  484333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484363 */     // MIs[1] Operand 1
     /*  484363 */     // No operand predicates
     /*  484363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484372 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  484372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  484392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484395 */     GIR_RootConstrainSelectedInstOperands,
     /*  484396 */     // GIR_Coverage, 62047,
     /*  484396 */     GIR_EraseRootFromParent_Done,
     /*  484397 */   // Label 8164: @484397
     /*  484397 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(484483), // Rule ID 62050 //
     /*  484402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  484413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  484416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  484419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484449 */     // MIs[1] Operand 1
     /*  484449 */     // No operand predicates
     /*  484449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  484458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  484478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484481 */     GIR_RootConstrainSelectedInstOperands,
     /*  484482 */     // GIR_Coverage, 62050,
     /*  484482 */     GIR_EraseRootFromParent_Done,
     /*  484483 */   // Label 8165: @484483
     /*  484483 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(484569), // Rule ID 62051 //
     /*  484488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  484499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  484502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  484505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484535 */     // MIs[1] Operand 1
     /*  484535 */     // No operand predicates
     /*  484535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  484544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  484564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484567 */     GIR_RootConstrainSelectedInstOperands,
     /*  484568 */     // GIR_Coverage, 62051,
     /*  484568 */     GIR_EraseRootFromParent_Done,
     /*  484569 */   // Label 8166: @484569
     /*  484569 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(484655), // Rule ID 62054 //
     /*  484574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  484585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  484588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484621 */     // MIs[1] Operand 1
     /*  484621 */     // No operand predicates
     /*  484621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484630 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484653 */     GIR_RootConstrainSelectedInstOperands,
     /*  484654 */     // GIR_Coverage, 62054,
     /*  484654 */     GIR_EraseRootFromParent_Done,
     /*  484655 */   // Label 8167: @484655
     /*  484655 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(484741), // Rule ID 62055 //
     /*  484660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  484671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  484674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484707 */     // MIs[1] Operand 1
     /*  484707 */     // No operand predicates
     /*  484707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484716 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484739 */     GIR_RootConstrainSelectedInstOperands,
     /*  484740 */     // GIR_Coverage, 62055,
     /*  484740 */     GIR_EraseRootFromParent_Done,
     /*  484741 */   // Label 8168: @484741
     /*  484741 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(484827), // Rule ID 62058 //
     /*  484746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  484757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  484760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484793 */     // MIs[1] Operand 1
     /*  484793 */     // No operand predicates
     /*  484793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484802 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484825 */     GIR_RootConstrainSelectedInstOperands,
     /*  484826 */     // GIR_Coverage, 62058,
     /*  484826 */     GIR_EraseRootFromParent_Done,
     /*  484827 */   // Label 8169: @484827
     /*  484827 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(484913), // Rule ID 62059 //
     /*  484832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  484843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  484846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484879 */     // MIs[1] Operand 1
     /*  484879 */     // No operand predicates
     /*  484879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484888 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484911 */     GIR_RootConstrainSelectedInstOperands,
     /*  484912 */     // GIR_Coverage, 62059,
     /*  484912 */     GIR_EraseRootFromParent_Done,
     /*  484913 */   // Label 8170: @484913
     /*  484913 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(484999), // Rule ID 62062 //
     /*  484918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  484929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  484932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  484935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484965 */     // MIs[1] Operand 1
     /*  484965 */     // No operand predicates
     /*  484965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484974 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  484977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484997 */     GIR_RootConstrainSelectedInstOperands,
     /*  484998 */     // GIR_Coverage, 62062,
     /*  484998 */     GIR_EraseRootFromParent_Done,
     /*  484999 */   // Label 8171: @484999
     /*  484999 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(485085), // Rule ID 62063 //
     /*  485004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  485015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  485018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  485021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485051 */     // MIs[1] Operand 1
     /*  485051 */     // No operand predicates
     /*  485051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485060 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  485060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  485080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485083 */     GIR_RootConstrainSelectedInstOperands,
     /*  485084 */     // GIR_Coverage, 62063,
     /*  485084 */     GIR_EraseRootFromParent_Done,
     /*  485085 */   // Label 8172: @485085
     /*  485085 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(485171), // Rule ID 62066 //
     /*  485090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  485101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  485104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  485107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485137 */     // MIs[1] Operand 1
     /*  485137 */     // No operand predicates
     /*  485137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485169 */     GIR_RootConstrainSelectedInstOperands,
     /*  485170 */     // GIR_Coverage, 62066,
     /*  485170 */     GIR_EraseRootFromParent_Done,
     /*  485171 */   // Label 8173: @485171
     /*  485171 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(485257), // Rule ID 62067 //
     /*  485176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  485187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  485190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  485193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485223 */     // MIs[1] Operand 1
     /*  485223 */     // No operand predicates
     /*  485223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485232 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485255 */     GIR_RootConstrainSelectedInstOperands,
     /*  485256 */     // GIR_Coverage, 62067,
     /*  485256 */     GIR_EraseRootFromParent_Done,
     /*  485257 */   // Label 8174: @485257
     /*  485257 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(485343), // Rule ID 62070 //
     /*  485262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  485273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  485276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  485279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485309 */     // MIs[1] Operand 1
     /*  485309 */     // No operand predicates
     /*  485309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485341 */     GIR_RootConstrainSelectedInstOperands,
     /*  485342 */     // GIR_Coverage, 62070,
     /*  485342 */     GIR_EraseRootFromParent_Done,
     /*  485343 */   // Label 8175: @485343
     /*  485343 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(485429), // Rule ID 62071 //
     /*  485348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  485359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  485362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  485365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485395 */     // MIs[1] Operand 1
     /*  485395 */     // No operand predicates
     /*  485395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485427 */     GIR_RootConstrainSelectedInstOperands,
     /*  485428 */     // GIR_Coverage, 62071,
     /*  485428 */     GIR_EraseRootFromParent_Done,
     /*  485429 */   // Label 8176: @485429
     /*  485429 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(485515), // Rule ID 62074 //
     /*  485434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  485445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  485448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  485451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485481 */     // MIs[1] Operand 1
     /*  485481 */     // No operand predicates
     /*  485481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485490 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485513 */     GIR_RootConstrainSelectedInstOperands,
     /*  485514 */     // GIR_Coverage, 62074,
     /*  485514 */     GIR_EraseRootFromParent_Done,
     /*  485515 */   // Label 8177: @485515
     /*  485515 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(485601), // Rule ID 62075 //
     /*  485520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  485531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  485534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  485537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485567 */     // MIs[1] Operand 1
     /*  485567 */     // No operand predicates
     /*  485567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485576 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485599 */     GIR_RootConstrainSelectedInstOperands,
     /*  485600 */     // GIR_Coverage, 62075,
     /*  485600 */     GIR_EraseRootFromParent_Done,
     /*  485601 */   // Label 8178: @485601
     /*  485601 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(485687), // Rule ID 62078 //
     /*  485606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  485617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  485620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485653 */     // MIs[1] Operand 1
     /*  485653 */     // No operand predicates
     /*  485653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485685 */     GIR_RootConstrainSelectedInstOperands,
     /*  485686 */     // GIR_Coverage, 62078,
     /*  485686 */     GIR_EraseRootFromParent_Done,
     /*  485687 */   // Label 8179: @485687
     /*  485687 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(485773), // Rule ID 62079 //
     /*  485692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  485703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  485706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485739 */     // MIs[1] Operand 1
     /*  485739 */     // No operand predicates
     /*  485739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485771 */     GIR_RootConstrainSelectedInstOperands,
     /*  485772 */     // GIR_Coverage, 62079,
     /*  485772 */     GIR_EraseRootFromParent_Done,
     /*  485773 */   // Label 8180: @485773
     /*  485773 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(485859), // Rule ID 62082 //
     /*  485778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  485789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  485792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  485795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485825 */     // MIs[1] Operand 1
     /*  485825 */     // No operand predicates
     /*  485825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485857 */     GIR_RootConstrainSelectedInstOperands,
     /*  485858 */     // GIR_Coverage, 62082,
     /*  485858 */     GIR_EraseRootFromParent_Done,
     /*  485859 */   // Label 8181: @485859
     /*  485859 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(485945), // Rule ID 62083 //
     /*  485864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  485875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  485878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  485881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485911 */     // MIs[1] Operand 1
     /*  485911 */     // No operand predicates
     /*  485911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485920 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485943 */     GIR_RootConstrainSelectedInstOperands,
     /*  485944 */     // GIR_Coverage, 62083,
     /*  485944 */     GIR_EraseRootFromParent_Done,
     /*  485945 */   // Label 8182: @485945
     /*  485945 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(486031), // Rule ID 62086 //
     /*  485950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  485961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  485964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  485967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485997 */     // MIs[1] Operand 1
     /*  485997 */     // No operand predicates
     /*  485997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486006 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  486006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  486009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  486026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486029 */     GIR_RootConstrainSelectedInstOperands,
     /*  486030 */     // GIR_Coverage, 62086,
     /*  486030 */     GIR_EraseRootFromParent_Done,
     /*  486031 */   // Label 8183: @486031
     /*  486031 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(486117), // Rule ID 62087 //
     /*  486036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  486047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  486050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  486053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486083 */     // MIs[1] Operand 1
     /*  486083 */     // No operand predicates
     /*  486083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486092 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  486092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  486095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  486112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486115 */     GIR_RootConstrainSelectedInstOperands,
     /*  486116 */     // GIR_Coverage, 62087,
     /*  486116 */     GIR_EraseRootFromParent_Done,
     /*  486117 */   // Label 8184: @486117
     /*  486117 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(486203), // Rule ID 62090 //
     /*  486122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  486133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  486136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  486139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486169 */     // MIs[1] Operand 1
     /*  486169 */     // No operand predicates
     /*  486169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486178 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  486178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  486181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486201 */     GIR_RootConstrainSelectedInstOperands,
     /*  486202 */     // GIR_Coverage, 62090,
     /*  486202 */     GIR_EraseRootFromParent_Done,
     /*  486203 */   // Label 8185: @486203
     /*  486203 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(486289), // Rule ID 62091 //
     /*  486208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  486219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  486222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  486225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486255 */     // MIs[1] Operand 1
     /*  486255 */     // No operand predicates
     /*  486255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486264 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  486264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  486267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486287 */     GIR_RootConstrainSelectedInstOperands,
     /*  486288 */     // GIR_Coverage, 62091,
     /*  486288 */     GIR_EraseRootFromParent_Done,
     /*  486289 */   // Label 8186: @486289
     /*  486289 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(486375), // Rule ID 62094 //
     /*  486294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  486305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  486308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  486311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486341 */     // MIs[1] Operand 1
     /*  486341 */     // No operand predicates
     /*  486341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486350 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  486350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  486353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486373 */     GIR_RootConstrainSelectedInstOperands,
     /*  486374 */     // GIR_Coverage, 62094,
     /*  486374 */     GIR_EraseRootFromParent_Done,
     /*  486375 */   // Label 8187: @486375
     /*  486375 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(486461), // Rule ID 62095 //
     /*  486380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  486391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  486394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  486397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486427 */     // MIs[1] Operand 1
     /*  486427 */     // No operand predicates
     /*  486427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  486436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  486439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486459 */     GIR_RootConstrainSelectedInstOperands,
     /*  486460 */     // GIR_Coverage, 62095,
     /*  486460 */     GIR_EraseRootFromParent_Done,
     /*  486461 */   // Label 8188: @486461
     /*  486461 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(486547), // Rule ID 62098 //
     /*  486466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  486477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  486480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  486483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486513 */     // MIs[1] Operand 1
     /*  486513 */     // No operand predicates
     /*  486513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486522 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  486522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  486525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486545 */     GIR_RootConstrainSelectedInstOperands,
     /*  486546 */     // GIR_Coverage, 62098,
     /*  486546 */     GIR_EraseRootFromParent_Done,
     /*  486547 */   // Label 8189: @486547
     /*  486547 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(486633), // Rule ID 62099 //
     /*  486552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  486563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  486566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  486569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486599 */     // MIs[1] Operand 1
     /*  486599 */     // No operand predicates
     /*  486599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486608 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  486608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  486611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486631 */     GIR_RootConstrainSelectedInstOperands,
     /*  486632 */     // GIR_Coverage, 62099,
     /*  486632 */     GIR_EraseRootFromParent_Done,
     /*  486633 */   // Label 8190: @486633
     /*  486633 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(486712), // Rule ID 2764 //
     /*  486638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  486649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  486652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  486658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486690 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  486693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486710 */     GIR_RootConstrainSelectedInstOperands,
     /*  486711 */     // GIR_Coverage, 2764,
     /*  486711 */     GIR_EraseRootFromParent_Done,
     /*  486712 */   // Label 8191: @486712
     /*  486712 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(486791), // Rule ID 2765 //
     /*  486717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  486728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  486731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  486737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486769 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  486772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486789 */     GIR_RootConstrainSelectedInstOperands,
     /*  486790 */     // GIR_Coverage, 2765,
     /*  486790 */     GIR_EraseRootFromParent_Done,
     /*  486791 */   // Label 8192: @486791
     /*  486791 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(486870), // Rule ID 4080 //
     /*  486796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  486807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  486810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  486813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  486816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486848 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  486851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486868 */     GIR_RootConstrainSelectedInstOperands,
     /*  486869 */     // GIR_Coverage, 4080,
     /*  486869 */     GIR_EraseRootFromParent_Done,
     /*  486870 */   // Label 8193: @486870
     /*  486870 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(486949), // Rule ID 4081 //
     /*  486875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  486886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  486889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  486892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  486895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486927 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  486930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486947 */     GIR_RootConstrainSelectedInstOperands,
     /*  486948 */     // GIR_Coverage, 4081,
     /*  486948 */     GIR_EraseRootFromParent_Done,
     /*  486949 */   // Label 8194: @486949
     /*  486949 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(487028), // Rule ID 4090 //
     /*  486954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  486965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  486968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  486971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  486974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487006 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  487006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487026 */     GIR_RootConstrainSelectedInstOperands,
     /*  487027 */     // GIR_Coverage, 4090,
     /*  487027 */     GIR_EraseRootFromParent_Done,
     /*  487028 */   // Label 8195: @487028
     /*  487028 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(487107), // Rule ID 4091 //
     /*  487033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  487044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  487047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  487050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  487053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487085 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  487085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487105 */     GIR_RootConstrainSelectedInstOperands,
     /*  487106 */     // GIR_Coverage, 4091,
     /*  487106 */     GIR_EraseRootFromParent_Done,
     /*  487107 */   // Label 8196: @487107
     /*  487107 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(487186), // Rule ID 4100 //
     /*  487112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  487123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  487126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  487129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  487132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487164 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  487164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487184 */     GIR_RootConstrainSelectedInstOperands,
     /*  487185 */     // GIR_Coverage, 4100,
     /*  487185 */     GIR_EraseRootFromParent_Done,
     /*  487186 */   // Label 8197: @487186
     /*  487186 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(487265), // Rule ID 4101 //
     /*  487191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  487202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  487205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  487208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  487211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  487243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487263 */     GIR_RootConstrainSelectedInstOperands,
     /*  487264 */     // GIR_Coverage, 4101,
     /*  487264 */     GIR_EraseRootFromParent_Done,
     /*  487265 */   // Label 8198: @487265
     /*  487265 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(487344), // Rule ID 4110 //
     /*  487270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  487281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  487284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  487287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  487290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487322 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  487322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  487325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487342 */     GIR_RootConstrainSelectedInstOperands,
     /*  487343 */     // GIR_Coverage, 4110,
     /*  487343 */     GIR_EraseRootFromParent_Done,
     /*  487344 */   // Label 8199: @487344
     /*  487344 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(487423), // Rule ID 4111 //
     /*  487349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  487360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  487363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  487366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  487369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487401 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  487401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  487404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487421 */     GIR_RootConstrainSelectedInstOperands,
     /*  487422 */     // GIR_Coverage, 4111,
     /*  487422 */     GIR_EraseRootFromParent_Done,
     /*  487423 */   // Label 8200: @487423
     /*  487423 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(487502), // Rule ID 4120 //
     /*  487428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  487439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  487442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  487445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  487448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487480 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  487480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487500 */     GIR_RootConstrainSelectedInstOperands,
     /*  487501 */     // GIR_Coverage, 4120,
     /*  487501 */     GIR_EraseRootFromParent_Done,
     /*  487502 */   // Label 8201: @487502
     /*  487502 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(487581), // Rule ID 4121 //
     /*  487507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  487518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  487521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  487524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  487527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487559 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  487559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487579 */     GIR_RootConstrainSelectedInstOperands,
     /*  487580 */     // GIR_Coverage, 4121,
     /*  487580 */     GIR_EraseRootFromParent_Done,
     /*  487581 */   // Label 8202: @487581
     /*  487581 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(487660), // Rule ID 4130 //
     /*  487586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  487597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  487600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  487606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487638 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  487641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487658 */     GIR_RootConstrainSelectedInstOperands,
     /*  487659 */     // GIR_Coverage, 4130,
     /*  487659 */     GIR_EraseRootFromParent_Done,
     /*  487660 */   // Label 8203: @487660
     /*  487660 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(487739), // Rule ID 4131 //
     /*  487665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  487676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  487679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  487685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487717 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  487720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487737 */     GIR_RootConstrainSelectedInstOperands,
     /*  487738 */     // GIR_Coverage, 4131,
     /*  487738 */     GIR_EraseRootFromParent_Done,
     /*  487739 */   // Label 8204: @487739
     /*  487739 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(487818), // Rule ID 4140 //
     /*  487744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  487755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  487758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  487764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487816 */     GIR_RootConstrainSelectedInstOperands,
     /*  487817 */     // GIR_Coverage, 4140,
     /*  487817 */     GIR_EraseRootFromParent_Done,
     /*  487818 */   // Label 8205: @487818
     /*  487818 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(487897), // Rule ID 4141 //
     /*  487823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  487834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  487837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  487843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487875 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487895 */     GIR_RootConstrainSelectedInstOperands,
     /*  487896 */     // GIR_Coverage, 4141,
     /*  487896 */     GIR_EraseRootFromParent_Done,
     /*  487897 */   // Label 8206: @487897
     /*  487897 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(487976), // Rule ID 4150 //
     /*  487902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  487913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  487916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  487919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  487922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487954 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487974 */     GIR_RootConstrainSelectedInstOperands,
     /*  487975 */     // GIR_Coverage, 4150,
     /*  487975 */     GIR_EraseRootFromParent_Done,
     /*  487976 */   // Label 8207: @487976
     /*  487976 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(488055), // Rule ID 4151 //
     /*  487981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  487992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  487995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  487998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  488001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488033 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  488033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  488036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488053 */     GIR_RootConstrainSelectedInstOperands,
     /*  488054 */     // GIR_Coverage, 4151,
     /*  488054 */     GIR_EraseRootFromParent_Done,
     /*  488055 */   // Label 8208: @488055
     /*  488055 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(488134), // Rule ID 4160 //
     /*  488060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  488071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  488074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  488077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  488080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  488112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  488115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488132 */     GIR_RootConstrainSelectedInstOperands,
     /*  488133 */     // GIR_Coverage, 4160,
     /*  488133 */     GIR_EraseRootFromParent_Done,
     /*  488134 */   // Label 8209: @488134
     /*  488134 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(488213), // Rule ID 4161 //
     /*  488139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  488150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  488153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  488156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  488159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488191 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  488191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  488194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488211 */     GIR_RootConstrainSelectedInstOperands,
     /*  488212 */     // GIR_Coverage, 4161,
     /*  488212 */     GIR_EraseRootFromParent_Done,
     /*  488213 */   // Label 8210: @488213
     /*  488213 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(488292), // Rule ID 4170 //
     /*  488218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  488229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  488232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  488235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  488238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488270 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  488270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488290 */     GIR_RootConstrainSelectedInstOperands,
     /*  488291 */     // GIR_Coverage, 4170,
     /*  488291 */     GIR_EraseRootFromParent_Done,
     /*  488292 */   // Label 8211: @488292
     /*  488292 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(488371), // Rule ID 4171 //
     /*  488297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  488308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  488311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  488314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  488317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488349 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  488349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488369 */     GIR_RootConstrainSelectedInstOperands,
     /*  488370 */     // GIR_Coverage, 4171,
     /*  488370 */     GIR_EraseRootFromParent_Done,
     /*  488371 */   // Label 8212: @488371
     /*  488371 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(488450), // Rule ID 4180 //
     /*  488376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  488387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  488390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  488393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  488396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488428 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  488431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488448 */     GIR_RootConstrainSelectedInstOperands,
     /*  488449 */     // GIR_Coverage, 4180,
     /*  488449 */     GIR_EraseRootFromParent_Done,
     /*  488450 */   // Label 8213: @488450
     /*  488450 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(488529), // Rule ID 4181 //
     /*  488455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  488466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  488469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  488472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  488475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488507 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  488510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488527 */     GIR_RootConstrainSelectedInstOperands,
     /*  488528 */     // GIR_Coverage, 4181,
     /*  488528 */     GIR_EraseRootFromParent_Done,
     /*  488529 */   // Label 8214: @488529
     /*  488529 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(488608), // Rule ID 4190 //
     /*  488534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  488545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  488548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  488551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  488554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  488589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488606 */     GIR_RootConstrainSelectedInstOperands,
     /*  488607 */     // GIR_Coverage, 4190,
     /*  488607 */     GIR_EraseRootFromParent_Done,
     /*  488608 */   // Label 8215: @488608
     /*  488608 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(488687), // Rule ID 4191 //
     /*  488613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  488624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  488627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  488630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  488633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488665 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  488668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488685 */     GIR_RootConstrainSelectedInstOperands,
     /*  488686 */     // GIR_Coverage, 4191,
     /*  488686 */     GIR_EraseRootFromParent_Done,
     /*  488687 */   // Label 8216: @488687
     /*  488687 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(488766), // Rule ID 4200 //
     /*  488692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  488703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  488706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  488709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  488712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488744 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  488747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488764 */     GIR_RootConstrainSelectedInstOperands,
     /*  488765 */     // GIR_Coverage, 4200,
     /*  488765 */     GIR_EraseRootFromParent_Done,
     /*  488766 */   // Label 8217: @488766
     /*  488766 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(488845), // Rule ID 4201 //
     /*  488771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  488782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  488785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  488788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  488791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488823 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  488826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488843 */     GIR_RootConstrainSelectedInstOperands,
     /*  488844 */     // GIR_Coverage, 4201,
     /*  488844 */     GIR_EraseRootFromParent_Done,
     /*  488845 */   // Label 8218: @488845
     /*  488845 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(488924), // Rule ID 4210 //
     /*  488850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  488861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  488864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  488867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  488870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488902 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488922 */     GIR_RootConstrainSelectedInstOperands,
     /*  488923 */     // GIR_Coverage, 4210,
     /*  488923 */     GIR_EraseRootFromParent_Done,
     /*  488924 */   // Label 8219: @488924
     /*  488924 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(489003), // Rule ID 4211 //
     /*  488929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  488940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  488943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  488946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  488949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488981 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11700:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489001 */     GIR_RootConstrainSelectedInstOperands,
     /*  489002 */     // GIR_Coverage, 4211,
     /*  489002 */     GIR_EraseRootFromParent_Done,
     /*  489003 */   // Label 8220: @489003
     /*  489003 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(489082), // Rule ID 4280 //
     /*  489008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  489019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  489022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  489025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  489028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  489063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489080 */     GIR_RootConstrainSelectedInstOperands,
     /*  489081 */     // GIR_Coverage, 4280,
     /*  489081 */     GIR_EraseRootFromParent_Done,
     /*  489082 */   // Label 8221: @489082
     /*  489082 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(489161), // Rule ID 4281 //
     /*  489087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  489098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  489101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  489104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  489107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489139 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  489142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489159 */     GIR_RootConstrainSelectedInstOperands,
     /*  489160 */     // GIR_Coverage, 4281,
     /*  489160 */     GIR_EraseRootFromParent_Done,
     /*  489161 */   // Label 8222: @489161
     /*  489161 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(489240), // Rule ID 4290 //
     /*  489166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  489177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  489180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  489183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  489186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  489221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489238 */     GIR_RootConstrainSelectedInstOperands,
     /*  489239 */     // GIR_Coverage, 4290,
     /*  489239 */     GIR_EraseRootFromParent_Done,
     /*  489240 */   // Label 8223: @489240
     /*  489240 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(489319), // Rule ID 4291 //
     /*  489245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  489256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  489259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  489262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  489265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489297 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  489300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489317 */     GIR_RootConstrainSelectedInstOperands,
     /*  489318 */     // GIR_Coverage, 4291,
     /*  489318 */     GIR_EraseRootFromParent_Done,
     /*  489319 */   // Label 8224: @489319
     /*  489319 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(489398), // Rule ID 4300 //
     /*  489324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  489335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  489338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  489341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  489344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489376 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  489379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489396 */     GIR_RootConstrainSelectedInstOperands,
     /*  489397 */     // GIR_Coverage, 4300,
     /*  489397 */     GIR_EraseRootFromParent_Done,
     /*  489398 */   // Label 8225: @489398
     /*  489398 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(489477), // Rule ID 4301 //
     /*  489403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  489414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  489417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  489420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  489423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489455 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  489458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489475 */     GIR_RootConstrainSelectedInstOperands,
     /*  489476 */     // GIR_Coverage, 4301,
     /*  489476 */     GIR_EraseRootFromParent_Done,
     /*  489477 */   // Label 8226: @489477
     /*  489477 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(489556), // Rule ID 4310 //
     /*  489482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  489493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  489496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  489499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  489502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489534 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489554 */     GIR_RootConstrainSelectedInstOperands,
     /*  489555 */     // GIR_Coverage, 4310,
     /*  489555 */     GIR_EraseRootFromParent_Done,
     /*  489556 */   // Label 8227: @489556
     /*  489556 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(489635), // Rule ID 4311 //
     /*  489561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  489572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  489575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  489578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  489581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489613 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489633 */     GIR_RootConstrainSelectedInstOperands,
     /*  489634 */     // GIR_Coverage, 4311,
     /*  489634 */     GIR_EraseRootFromParent_Done,
     /*  489635 */   // Label 8228: @489635
     /*  489635 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(489714), // Rule ID 4320 //
     /*  489640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  489651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  489654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  489657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  489660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489692 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  489695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489712 */     GIR_RootConstrainSelectedInstOperands,
     /*  489713 */     // GIR_Coverage, 4320,
     /*  489713 */     GIR_EraseRootFromParent_Done,
     /*  489714 */   // Label 8229: @489714
     /*  489714 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(489793), // Rule ID 4321 //
     /*  489719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  489730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  489733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  489736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  489739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  489774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489791 */     GIR_RootConstrainSelectedInstOperands,
     /*  489792 */     // GIR_Coverage, 4321,
     /*  489792 */     GIR_EraseRootFromParent_Done,
     /*  489793 */   // Label 8230: @489793
     /*  489793 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(489872), // Rule ID 4330 //
     /*  489798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  489809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  489812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  489815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  489818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489850 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  489853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489870 */     GIR_RootConstrainSelectedInstOperands,
     /*  489871 */     // GIR_Coverage, 4330,
     /*  489871 */     GIR_EraseRootFromParent_Done,
     /*  489872 */   // Label 8231: @489872
     /*  489872 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(489951), // Rule ID 4331 //
     /*  489877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  489888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  489891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  489894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  489897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489929 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  489932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489949 */     GIR_RootConstrainSelectedInstOperands,
     /*  489950 */     // GIR_Coverage, 4331,
     /*  489950 */     GIR_EraseRootFromParent_Done,
     /*  489951 */   // Label 8232: @489951
     /*  489951 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(490030), // Rule ID 4340 //
     /*  489956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  489967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  489970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  489973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  489976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490008 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  490011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490028 */     GIR_RootConstrainSelectedInstOperands,
     /*  490029 */     // GIR_Coverage, 4340,
     /*  490029 */     GIR_EraseRootFromParent_Done,
     /*  490030 */   // Label 8233: @490030
     /*  490030 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(490109), // Rule ID 4341 //
     /*  490035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  490046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  490049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  490052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  490055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490087 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  490090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490107 */     GIR_RootConstrainSelectedInstOperands,
     /*  490108 */     // GIR_Coverage, 4341,
     /*  490108 */     GIR_EraseRootFromParent_Done,
     /*  490109 */   // Label 8234: @490109
     /*  490109 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(490188), // Rule ID 4350 //
     /*  490114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  490125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  490128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  490131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  490134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  490169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490186 */     GIR_RootConstrainSelectedInstOperands,
     /*  490187 */     // GIR_Coverage, 4350,
     /*  490187 */     GIR_EraseRootFromParent_Done,
     /*  490188 */   // Label 8235: @490188
     /*  490188 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(490267), // Rule ID 4351 //
     /*  490193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  490204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  490207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  490210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  490213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490245 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  490248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490265 */     GIR_RootConstrainSelectedInstOperands,
     /*  490266 */     // GIR_Coverage, 4351,
     /*  490266 */     GIR_EraseRootFromParent_Done,
     /*  490267 */   // Label 8236: @490267
     /*  490267 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(490346), // Rule ID 4360 //
     /*  490272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  490283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  490286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  490289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  490292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  490327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490344 */     GIR_RootConstrainSelectedInstOperands,
     /*  490345 */     // GIR_Coverage, 4360,
     /*  490345 */     GIR_EraseRootFromParent_Done,
     /*  490346 */   // Label 8237: @490346
     /*  490346 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(490425), // Rule ID 4361 //
     /*  490351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  490362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  490365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  490368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  490371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490403 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  490406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490423 */     GIR_RootConstrainSelectedInstOperands,
     /*  490424 */     // GIR_Coverage, 4361,
     /*  490424 */     GIR_EraseRootFromParent_Done,
     /*  490425 */   // Label 8238: @490425
     /*  490425 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(490504), // Rule ID 4370 //
     /*  490430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  490441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  490444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  490447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  490450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490502 */     GIR_RootConstrainSelectedInstOperands,
     /*  490503 */     // GIR_Coverage, 4370,
     /*  490503 */     GIR_EraseRootFromParent_Done,
     /*  490504 */   // Label 8239: @490504
     /*  490504 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(490583), // Rule ID 4371 //
     /*  490509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  490520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  490523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  490526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  490529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490561 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490581 */     GIR_RootConstrainSelectedInstOperands,
     /*  490582 */     // GIR_Coverage, 4371,
     /*  490582 */     GIR_EraseRootFromParent_Done,
     /*  490583 */   // Label 8240: @490583
     /*  490583 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(490662), // Rule ID 4380 //
     /*  490588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  490599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  490602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  490605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  490608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490660 */     GIR_RootConstrainSelectedInstOperands,
     /*  490661 */     // GIR_Coverage, 4380,
     /*  490661 */     GIR_EraseRootFromParent_Done,
     /*  490662 */   // Label 8241: @490662
     /*  490662 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(490741), // Rule ID 4381 //
     /*  490667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  490678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  490681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  490684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  490687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490719 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490739 */     GIR_RootConstrainSelectedInstOperands,
     /*  490740 */     // GIR_Coverage, 4381,
     /*  490740 */     GIR_EraseRootFromParent_Done,
     /*  490741 */   // Label 8242: @490741
     /*  490741 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(490820), // Rule ID 4390 //
     /*  490746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  490757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  490760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  490763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  490766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  490801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490818 */     GIR_RootConstrainSelectedInstOperands,
     /*  490819 */     // GIR_Coverage, 4390,
     /*  490819 */     GIR_EraseRootFromParent_Done,
     /*  490820 */   // Label 8243: @490820
     /*  490820 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(490899), // Rule ID 4391 //
     /*  490825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  490836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  490839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  490842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  490845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490877 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  490880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490897 */     GIR_RootConstrainSelectedInstOperands,
     /*  490898 */     // GIR_Coverage, 4391,
     /*  490898 */     GIR_EraseRootFromParent_Done,
     /*  490899 */   // Label 8244: @490899
     /*  490899 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(490978), // Rule ID 4400 //
     /*  490904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  490915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  490918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  490921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  490924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490956 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  490959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490976 */     GIR_RootConstrainSelectedInstOperands,
     /*  490977 */     // GIR_Coverage, 4400,
     /*  490977 */     GIR_EraseRootFromParent_Done,
     /*  490978 */   // Label 8245: @490978
     /*  490978 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(491057), // Rule ID 4401 //
     /*  490983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  490994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  490997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  491000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  491003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491035 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  491035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  491038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491055 */     GIR_RootConstrainSelectedInstOperands,
     /*  491056 */     // GIR_Coverage, 4401,
     /*  491056 */     GIR_EraseRootFromParent_Done,
     /*  491057 */   // Label 8246: @491057
     /*  491057 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(491136), // Rule ID 4410 //
     /*  491062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  491065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  491070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  491073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  491076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  491079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  491082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491114 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  491114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  491117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491134 */     GIR_RootConstrainSelectedInstOperands,
     /*  491135 */     // GIR_Coverage, 4410,
     /*  491135 */     GIR_EraseRootFromParent_Done,
     /*  491136 */   // Label 8247: @491136
     /*  491136 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(491215), // Rule ID 4411 //
     /*  491141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  491144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  491149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  491152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  491155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  491158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  491161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491193 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  491193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  491196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491213 */     GIR_RootConstrainSelectedInstOperands,
     /*  491214 */     // GIR_Coverage, 4411,
     /*  491214 */     GIR_EraseRootFromParent_Done,
     /*  491215 */   // Label 8248: @491215
     /*  491215 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(491294), // Rule ID 4420 //
     /*  491220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  491223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  491228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  491231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  491234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  491237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  491240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491272 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  491272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  491275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491292 */     GIR_RootConstrainSelectedInstOperands,
     /*  491293 */     // GIR_Coverage, 4420,
     /*  491293 */     GIR_EraseRootFromParent_Done,
     /*  491294 */   // Label 8249: @491294
     /*  491294 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(491373), // Rule ID 4421 //
     /*  491299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  491302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  491307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  491310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  491313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  491316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  491319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491351 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11728:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  491351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  491354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491371 */     GIR_RootConstrainSelectedInstOperands,
     /*  491372 */     // GIR_Coverage, 4421,
     /*  491372 */     GIR_EraseRootFromParent_Done,
     /*  491373 */   // Label 8250: @491373
     /*  491373 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(491452), // Rule ID 4490 //
     /*  491378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  491389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  491392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  491395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  491398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491430 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  491433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491450 */     GIR_RootConstrainSelectedInstOperands,
     /*  491451 */     // GIR_Coverage, 4490,
     /*  491451 */     GIR_EraseRootFromParent_Done,
     /*  491452 */   // Label 8251: @491452
     /*  491452 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(491531), // Rule ID 4491 //
     /*  491457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  491468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  491471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  491474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  491477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491509 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  491512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491529 */     GIR_RootConstrainSelectedInstOperands,
     /*  491530 */     // GIR_Coverage, 4491,
     /*  491530 */     GIR_EraseRootFromParent_Done,
     /*  491531 */   // Label 8252: @491531
     /*  491531 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(491610), // Rule ID 4500 //
     /*  491536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  491547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  491550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  491553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  491556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491588 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491608 */     GIR_RootConstrainSelectedInstOperands,
     /*  491609 */     // GIR_Coverage, 4500,
     /*  491609 */     GIR_EraseRootFromParent_Done,
     /*  491610 */   // Label 8253: @491610
     /*  491610 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(491689), // Rule ID 4501 //
     /*  491615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  491626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  491629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  491632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  491635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491667 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491687 */     GIR_RootConstrainSelectedInstOperands,
     /*  491688 */     // GIR_Coverage, 4501,
     /*  491688 */     GIR_EraseRootFromParent_Done,
     /*  491689 */   // Label 8254: @491689
     /*  491689 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(491768), // Rule ID 4510 //
     /*  491694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  491705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  491708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  491711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  491714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491746 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  491749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491766 */     GIR_RootConstrainSelectedInstOperands,
     /*  491767 */     // GIR_Coverage, 4510,
     /*  491767 */     GIR_EraseRootFromParent_Done,
     /*  491768 */   // Label 8255: @491768
     /*  491768 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(491847), // Rule ID 4511 //
     /*  491773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  491784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  491787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  491790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  491793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  491828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491845 */     GIR_RootConstrainSelectedInstOperands,
     /*  491846 */     // GIR_Coverage, 4511,
     /*  491846 */     GIR_EraseRootFromParent_Done,
     /*  491847 */   // Label 8256: @491847
     /*  491847 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(491926), // Rule ID 4520 //
     /*  491852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  491863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  491866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  491869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  491872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491904 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  491907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491924 */     GIR_RootConstrainSelectedInstOperands,
     /*  491925 */     // GIR_Coverage, 4520,
     /*  491925 */     GIR_EraseRootFromParent_Done,
     /*  491926 */   // Label 8257: @491926
     /*  491926 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(492005), // Rule ID 4521 //
     /*  491931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  491942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  491945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  491948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  491951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491983 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  491986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492003 */     GIR_RootConstrainSelectedInstOperands,
     /*  492004 */     // GIR_Coverage, 4521,
     /*  492004 */     GIR_EraseRootFromParent_Done,
     /*  492005 */   // Label 8258: @492005
     /*  492005 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(492084), // Rule ID 4530 //
     /*  492010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  492021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  492024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  492027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  492030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492062 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492082 */     GIR_RootConstrainSelectedInstOperands,
     /*  492083 */     // GIR_Coverage, 4530,
     /*  492083 */     GIR_EraseRootFromParent_Done,
     /*  492084 */   // Label 8259: @492084
     /*  492084 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(492163), // Rule ID 4531 //
     /*  492089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  492100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  492103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  492106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  492109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492141 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492161 */     GIR_RootConstrainSelectedInstOperands,
     /*  492162 */     // GIR_Coverage, 4531,
     /*  492162 */     GIR_EraseRootFromParent_Done,
     /*  492163 */   // Label 8260: @492163
     /*  492163 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(492242), // Rule ID 4540 //
     /*  492168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  492179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  492182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  492185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  492188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  492223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492240 */     GIR_RootConstrainSelectedInstOperands,
     /*  492241 */     // GIR_Coverage, 4540,
     /*  492241 */     GIR_EraseRootFromParent_Done,
     /*  492242 */   // Label 8261: @492242
     /*  492242 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(492321), // Rule ID 4541 //
     /*  492247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  492258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  492261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  492264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  492267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492299 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  492302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492319 */     GIR_RootConstrainSelectedInstOperands,
     /*  492320 */     // GIR_Coverage, 4541,
     /*  492320 */     GIR_EraseRootFromParent_Done,
     /*  492321 */   // Label 8262: @492321
     /*  492321 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(492400), // Rule ID 4550 //
     /*  492326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  492337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  492340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  492343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  492346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  492381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492398 */     GIR_RootConstrainSelectedInstOperands,
     /*  492399 */     // GIR_Coverage, 4550,
     /*  492399 */     GIR_EraseRootFromParent_Done,
     /*  492400 */   // Label 8263: @492400
     /*  492400 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(492479), // Rule ID 4551 //
     /*  492405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  492416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  492419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  492422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  492425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492457 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  492460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492477 */     GIR_RootConstrainSelectedInstOperands,
     /*  492478 */     // GIR_Coverage, 4551,
     /*  492478 */     GIR_EraseRootFromParent_Done,
     /*  492479 */   // Label 8264: @492479
     /*  492479 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(492558), // Rule ID 4560 //
     /*  492484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  492495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  492498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  492501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  492504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492556 */     GIR_RootConstrainSelectedInstOperands,
     /*  492557 */     // GIR_Coverage, 4560,
     /*  492557 */     GIR_EraseRootFromParent_Done,
     /*  492558 */   // Label 8265: @492558
     /*  492558 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(492637), // Rule ID 4561 //
     /*  492563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  492574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  492577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  492580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  492583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492615 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492635 */     GIR_RootConstrainSelectedInstOperands,
     /*  492636 */     // GIR_Coverage, 4561,
     /*  492636 */     GIR_EraseRootFromParent_Done,
     /*  492637 */   // Label 8266: @492637
     /*  492637 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(492716), // Rule ID 4570 //
     /*  492642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  492653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  492656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  492659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  492662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492714 */     GIR_RootConstrainSelectedInstOperands,
     /*  492715 */     // GIR_Coverage, 4570,
     /*  492715 */     GIR_EraseRootFromParent_Done,
     /*  492716 */   // Label 8267: @492716
     /*  492716 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(492795), // Rule ID 4571 //
     /*  492721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  492732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  492735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  492738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  492741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492793 */     GIR_RootConstrainSelectedInstOperands,
     /*  492794 */     // GIR_Coverage, 4571,
     /*  492794 */     GIR_EraseRootFromParent_Done,
     /*  492795 */   // Label 8268: @492795
     /*  492795 */   GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(492874), // Rule ID 4580 //
     /*  492800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  492811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  492814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  492817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  492820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492872 */     GIR_RootConstrainSelectedInstOperands,
     /*  492873 */     // GIR_Coverage, 4580,
     /*  492873 */     GIR_EraseRootFromParent_Done,
     /*  492874 */   // Label 8269: @492874
     /*  492874 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(492953), // Rule ID 4581 //
     /*  492879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  492890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  492893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  492896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  492899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492931 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492951 */     GIR_RootConstrainSelectedInstOperands,
     /*  492952 */     // GIR_Coverage, 4581,
     /*  492952 */     GIR_EraseRootFromParent_Done,
     /*  492953 */   // Label 8270: @492953
     /*  492953 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(493032), // Rule ID 4590 //
     /*  492958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  492969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  492972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  492975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  492978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493010 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  493010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  493013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493030 */     GIR_RootConstrainSelectedInstOperands,
     /*  493031 */     // GIR_Coverage, 4590,
     /*  493031 */     GIR_EraseRootFromParent_Done,
     /*  493032 */   // Label 8271: @493032
     /*  493032 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(493111), // Rule ID 4591 //
     /*  493037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  493048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  493051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  493054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  493057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493089 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  493089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  493092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493109 */     GIR_RootConstrainSelectedInstOperands,
     /*  493110 */     // GIR_Coverage, 4591,
     /*  493110 */     GIR_EraseRootFromParent_Done,
     /*  493111 */   // Label 8272: @493111
     /*  493111 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(493190), // Rule ID 4600 //
     /*  493116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  493119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  493127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  493130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  493133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  493136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  493168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  493171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493188 */     GIR_RootConstrainSelectedInstOperands,
     /*  493189 */     // GIR_Coverage, 4600,
     /*  493189 */     GIR_EraseRootFromParent_Done,
     /*  493190 */   // Label 8273: @493190
     /*  493190 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(493269), // Rule ID 4601 //
     /*  493195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  493198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  493206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  493209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  493212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  493215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493247 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  493247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  493250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493267 */     GIR_RootConstrainSelectedInstOperands,
     /*  493268 */     // GIR_Coverage, 4601,
     /*  493268 */     GIR_EraseRootFromParent_Done,
     /*  493269 */   // Label 8274: @493269
     /*  493269 */   GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(493348), // Rule ID 4610 //
     /*  493274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  493277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  493285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  493288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  493291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  493294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  493326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  493329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493346 */     GIR_RootConstrainSelectedInstOperands,
     /*  493347 */     // GIR_Coverage, 4610,
     /*  493347 */     GIR_EraseRootFromParent_Done,
     /*  493348 */   // Label 8275: @493348
     /*  493348 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(493427), // Rule ID 4611 //
     /*  493353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  493356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  493364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  493367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  493370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  493373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493405 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  493405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  493408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493425 */     GIR_RootConstrainSelectedInstOperands,
     /*  493426 */     // GIR_Coverage, 4611,
     /*  493426 */     GIR_EraseRootFromParent_Done,
     /*  493427 */   // Label 8276: @493427
     /*  493427 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(493506), // Rule ID 4620 //
     /*  493432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  493435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  493443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  493446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  493449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  493452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  493484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  493487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493504 */     GIR_RootConstrainSelectedInstOperands,
     /*  493505 */     // GIR_Coverage, 4620,
     /*  493505 */     GIR_EraseRootFromParent_Done,
     /*  493506 */   // Label 8277: @493506
     /*  493506 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(493585), // Rule ID 4621 //
     /*  493511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  493514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  493522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  493525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  493528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  493531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493563 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  493563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  493566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493583 */     GIR_RootConstrainSelectedInstOperands,
     /*  493584 */     // GIR_Coverage, 4621,
     /*  493584 */     GIR_EraseRootFromParent_Done,
     /*  493585 */   // Label 8278: @493585
     /*  493585 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(493664), // Rule ID 4630 //
     /*  493590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  493593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  493601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  493604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  493607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  493610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  493642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  493645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493662 */     GIR_RootConstrainSelectedInstOperands,
     /*  493663 */     // GIR_Coverage, 4630,
     /*  493663 */     GIR_EraseRootFromParent_Done,
     /*  493664 */   // Label 8279: @493664
     /*  493664 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(493743), // Rule ID 4631 //
     /*  493669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  493672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  493680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  493683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  493686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  493689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493721 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11696:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  493721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  493724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493741 */     GIR_RootConstrainSelectedInstOperands,
     /*  493742 */     // GIR_Coverage, 4631,
     /*  493742 */     GIR_EraseRootFromParent_Done,
     /*  493743 */   // Label 8280: @493743
     /*  493743 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(493822), // Rule ID 4700 //
     /*  493748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  493759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  493762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  493765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  493768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493800 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  493803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493820 */     GIR_RootConstrainSelectedInstOperands,
     /*  493821 */     // GIR_Coverage, 4700,
     /*  493821 */     GIR_EraseRootFromParent_Done,
     /*  493822 */   // Label 8281: @493822
     /*  493822 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(493901), // Rule ID 4701 //
     /*  493827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  493838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  493841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  493844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  493847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493879 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  493882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493899 */     GIR_RootConstrainSelectedInstOperands,
     /*  493900 */     // GIR_Coverage, 4701,
     /*  493900 */     GIR_EraseRootFromParent_Done,
     /*  493901 */   // Label 8282: @493901
     /*  493901 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(493980), // Rule ID 4710 //
     /*  493906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  493917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  493920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  493923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  493926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  493961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493978 */     GIR_RootConstrainSelectedInstOperands,
     /*  493979 */     // GIR_Coverage, 4710,
     /*  493979 */     GIR_EraseRootFromParent_Done,
     /*  493980 */   // Label 8283: @493980
     /*  493980 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(494059), // Rule ID 4711 //
     /*  493985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  493996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  493999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  494002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  494005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494037 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  494040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494057 */     GIR_RootConstrainSelectedInstOperands,
     /*  494058 */     // GIR_Coverage, 4711,
     /*  494058 */     GIR_EraseRootFromParent_Done,
     /*  494059 */   // Label 8284: @494059
     /*  494059 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(494138), // Rule ID 4720 //
     /*  494064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  494075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  494078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  494081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  494084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494116 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494136 */     GIR_RootConstrainSelectedInstOperands,
     /*  494137 */     // GIR_Coverage, 4720,
     /*  494137 */     GIR_EraseRootFromParent_Done,
     /*  494138 */   // Label 8285: @494138
     /*  494138 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(494217), // Rule ID 4721 //
     /*  494143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  494154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  494157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  494160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  494163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494195 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494215 */     GIR_RootConstrainSelectedInstOperands,
     /*  494216 */     // GIR_Coverage, 4721,
     /*  494216 */     GIR_EraseRootFromParent_Done,
     /*  494217 */   // Label 8286: @494217
     /*  494217 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(494296), // Rule ID 4730 //
     /*  494222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  494233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  494236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  494239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  494242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  494277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494294 */     GIR_RootConstrainSelectedInstOperands,
     /*  494295 */     // GIR_Coverage, 4730,
     /*  494295 */     GIR_EraseRootFromParent_Done,
     /*  494296 */   // Label 8287: @494296
     /*  494296 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(494375), // Rule ID 4731 //
     /*  494301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  494312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  494315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  494318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  494321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  494356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494373 */     GIR_RootConstrainSelectedInstOperands,
     /*  494374 */     // GIR_Coverage, 4731,
     /*  494374 */     GIR_EraseRootFromParent_Done,
     /*  494375 */   // Label 8288: @494375
     /*  494375 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(494454), // Rule ID 4740 //
     /*  494380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  494391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  494394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  494397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  494400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494432 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494452 */     GIR_RootConstrainSelectedInstOperands,
     /*  494453 */     // GIR_Coverage, 4740,
     /*  494453 */     GIR_EraseRootFromParent_Done,
     /*  494454 */   // Label 8289: @494454
     /*  494454 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(494533), // Rule ID 4741 //
     /*  494459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  494470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  494473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  494476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  494479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494511 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494531 */     GIR_RootConstrainSelectedInstOperands,
     /*  494532 */     // GIR_Coverage, 4741,
     /*  494532 */     GIR_EraseRootFromParent_Done,
     /*  494533 */   // Label 8290: @494533
     /*  494533 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(494612), // Rule ID 4750 //
     /*  494538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  494549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  494552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  494555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  494558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494590 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494610 */     GIR_RootConstrainSelectedInstOperands,
     /*  494611 */     // GIR_Coverage, 4750,
     /*  494611 */     GIR_EraseRootFromParent_Done,
     /*  494612 */   // Label 8291: @494612
     /*  494612 */   GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(494691), // Rule ID 4751 //
     /*  494617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  494628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  494631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  494634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  494637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494669 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494689 */     GIR_RootConstrainSelectedInstOperands,
     /*  494690 */     // GIR_Coverage, 4751,
     /*  494690 */     GIR_EraseRootFromParent_Done,
     /*  494691 */   // Label 8292: @494691
     /*  494691 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(494770), // Rule ID 4760 //
     /*  494696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  494707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  494710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  494713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  494716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494748 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  494751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494768 */     GIR_RootConstrainSelectedInstOperands,
     /*  494769 */     // GIR_Coverage, 4760,
     /*  494769 */     GIR_EraseRootFromParent_Done,
     /*  494770 */   // Label 8293: @494770
     /*  494770 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(494849), // Rule ID 4761 //
     /*  494775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  494786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  494789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  494792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  494795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494827 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  494830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494847 */     GIR_RootConstrainSelectedInstOperands,
     /*  494848 */     // GIR_Coverage, 4761,
     /*  494848 */     GIR_EraseRootFromParent_Done,
     /*  494849 */   // Label 8294: @494849
     /*  494849 */   GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(494928), // Rule ID 4770 //
     /*  494854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  494865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  494868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  494871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  494874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494926 */     GIR_RootConstrainSelectedInstOperands,
     /*  494927 */     // GIR_Coverage, 4770,
     /*  494927 */     GIR_EraseRootFromParent_Done,
     /*  494928 */   // Label 8295: @494928
     /*  494928 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(495007), // Rule ID 4771 //
     /*  494933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  494944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  494947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  494950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  494953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494985 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495005 */     GIR_RootConstrainSelectedInstOperands,
     /*  495006 */     // GIR_Coverage, 4771,
     /*  495006 */     GIR_EraseRootFromParent_Done,
     /*  495007 */   // Label 8296: @495007
     /*  495007 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(495086), // Rule ID 4780 //
     /*  495012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  495023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  495026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  495029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  495032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  495064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  495067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495084 */     GIR_RootConstrainSelectedInstOperands,
     /*  495085 */     // GIR_Coverage, 4780,
     /*  495085 */     GIR_EraseRootFromParent_Done,
     /*  495086 */   // Label 8297: @495086
     /*  495086 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(495165), // Rule ID 4781 //
     /*  495091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  495102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  495105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  495108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  495111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  495143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  495146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495163 */     GIR_RootConstrainSelectedInstOperands,
     /*  495164 */     // GIR_Coverage, 4781,
     /*  495164 */     GIR_EraseRootFromParent_Done,
     /*  495165 */   // Label 8298: @495165
     /*  495165 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(495244), // Rule ID 4790 //
     /*  495170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  495181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  495184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  495187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  495190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495222 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  495222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  495225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495242 */     GIR_RootConstrainSelectedInstOperands,
     /*  495243 */     // GIR_Coverage, 4790,
     /*  495243 */     GIR_EraseRootFromParent_Done,
     /*  495244 */   // Label 8299: @495244
     /*  495244 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(495323), // Rule ID 4791 //
     /*  495249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  495260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  495263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  495266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  495269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495301 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  495301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  495304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495321 */     GIR_RootConstrainSelectedInstOperands,
     /*  495322 */     // GIR_Coverage, 4791,
     /*  495322 */     GIR_EraseRootFromParent_Done,
     /*  495323 */   // Label 8300: @495323
     /*  495323 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(495402), // Rule ID 4800 //
     /*  495328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  495339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  495342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  495345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  495348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495380 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  495380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  495383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495400 */     GIR_RootConstrainSelectedInstOperands,
     /*  495401 */     // GIR_Coverage, 4800,
     /*  495401 */     GIR_EraseRootFromParent_Done,
     /*  495402 */   // Label 8301: @495402
     /*  495402 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(495481), // Rule ID 4801 //
     /*  495407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  495418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  495421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  495424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  495427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495459 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  495459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  495462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495479 */     GIR_RootConstrainSelectedInstOperands,
     /*  495480 */     // GIR_Coverage, 4801,
     /*  495480 */     GIR_EraseRootFromParent_Done,
     /*  495481 */   // Label 8302: @495481
     /*  495481 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(495560), // Rule ID 4810 //
     /*  495486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  495497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  495500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  495503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  495506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495538 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  495541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495558 */     GIR_RootConstrainSelectedInstOperands,
     /*  495559 */     // GIR_Coverage, 4810,
     /*  495559 */     GIR_EraseRootFromParent_Done,
     /*  495560 */   // Label 8303: @495560
     /*  495560 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(495639), // Rule ID 4811 //
     /*  495565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  495576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  495579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  495582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  495585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495617 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  495620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495637 */     GIR_RootConstrainSelectedInstOperands,
     /*  495638 */     // GIR_Coverage, 4811,
     /*  495638 */     GIR_EraseRootFromParent_Done,
     /*  495639 */   // Label 8304: @495639
     /*  495639 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(495718), // Rule ID 4820 //
     /*  495644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  495655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  495658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  495661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  495664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  495699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495716 */     GIR_RootConstrainSelectedInstOperands,
     /*  495717 */     // GIR_Coverage, 4820,
     /*  495717 */     GIR_EraseRootFromParent_Done,
     /*  495718 */   // Label 8305: @495718
     /*  495718 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(495797), // Rule ID 4821 //
     /*  495723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  495734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  495737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  495740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  495743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495775 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  495778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495795 */     GIR_RootConstrainSelectedInstOperands,
     /*  495796 */     // GIR_Coverage, 4821,
     /*  495796 */     GIR_EraseRootFromParent_Done,
     /*  495797 */   // Label 8306: @495797
     /*  495797 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(495876), // Rule ID 4830 //
     /*  495802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  495813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  495816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  495819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  495822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495854 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  495857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495874 */     GIR_RootConstrainSelectedInstOperands,
     /*  495875 */     // GIR_Coverage, 4830,
     /*  495875 */     GIR_EraseRootFromParent_Done,
     /*  495876 */   // Label 8307: @495876
     /*  495876 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(495955), // Rule ID 4831 //
     /*  495881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  495892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  495895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  495898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  495901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495933 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  495936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495953 */     GIR_RootConstrainSelectedInstOperands,
     /*  495954 */     // GIR_Coverage, 4831,
     /*  495954 */     GIR_EraseRootFromParent_Done,
     /*  495955 */   // Label 8308: @495955
     /*  495955 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(496034), // Rule ID 4840 //
     /*  495960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  495971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  495974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  495977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  495980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496012 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  496012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  496015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496032 */     GIR_RootConstrainSelectedInstOperands,
     /*  496033 */     // GIR_Coverage, 4840,
     /*  496033 */     GIR_EraseRootFromParent_Done,
     /*  496034 */   // Label 8309: @496034
     /*  496034 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(496113), // Rule ID 4841 //
     /*  496039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  496042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  496047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  496050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  496053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  496056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  496059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496091 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11724:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  496091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  496094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496111 */     GIR_RootConstrainSelectedInstOperands,
     /*  496112 */     // GIR_Coverage, 4841,
     /*  496112 */     GIR_EraseRootFromParent_Done,
     /*  496113 */   // Label 8310: @496113
     /*  496113 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(496181), // Rule ID 2724 //
     /*  496118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  496129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  496132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496150 */     // MIs[0] policy
     /*  496150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496160 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  496163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496167 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496177 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496179 */     GIR_RootConstrainSelectedInstOperands,
     /*  496180 */     // GIR_Coverage, 2724,
     /*  496180 */     GIR_EraseRootFromParent_Done,
     /*  496181 */   // Label 8311: @496181
     /*  496181 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(496249), // Rule ID 2725 //
     /*  496186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  496197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  496200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496218 */     // MIs[0] policy
     /*  496218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496228 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  496231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496235 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496245 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496247 */     GIR_RootConstrainSelectedInstOperands,
     /*  496248 */     // GIR_Coverage, 2725,
     /*  496248 */     GIR_EraseRootFromParent_Done,
     /*  496249 */   // Label 8312: @496249
     /*  496249 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(496317), // Rule ID 23520 //
     /*  496254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  496265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  496268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496286 */     // MIs[0] policy
     /*  496286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496296 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  496299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496303 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496313 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496315 */     GIR_RootConstrainSelectedInstOperands,
     /*  496316 */     // GIR_Coverage, 23520,
     /*  496316 */     GIR_EraseRootFromParent_Done,
     /*  496317 */   // Label 8313: @496317
     /*  496317 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(496385), // Rule ID 23521 //
     /*  496322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  496333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  496336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496354 */     // MIs[0] policy
     /*  496354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496364 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  496367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496371 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496381 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496383 */     GIR_RootConstrainSelectedInstOperands,
     /*  496384 */     // GIR_Coverage, 23521,
     /*  496384 */     GIR_EraseRootFromParent_Done,
     /*  496385 */   // Label 8314: @496385
     /*  496385 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(496453), // Rule ID 23524 //
     /*  496390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  496401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  496404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  496407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496422 */     // MIs[0] policy
     /*  496422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496432 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496439 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496449 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496451 */     GIR_RootConstrainSelectedInstOperands,
     /*  496452 */     // GIR_Coverage, 23524,
     /*  496452 */     GIR_EraseRootFromParent_Done,
     /*  496453 */   // Label 8315: @496453
     /*  496453 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(496521), // Rule ID 23525 //
     /*  496458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  496469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  496472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  496475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496490 */     // MIs[0] policy
     /*  496490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496500 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496507 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496517 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496519 */     GIR_RootConstrainSelectedInstOperands,
     /*  496520 */     // GIR_Coverage, 23525,
     /*  496520 */     GIR_EraseRootFromParent_Done,
     /*  496521 */   // Label 8316: @496521
     /*  496521 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(496589), // Rule ID 23528 //
     /*  496526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  496537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  496540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496558 */     // MIs[0] policy
     /*  496558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  496571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496575 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496585 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496587 */     GIR_RootConstrainSelectedInstOperands,
     /*  496588 */     // GIR_Coverage, 23528,
     /*  496588 */     GIR_EraseRootFromParent_Done,
     /*  496589 */   // Label 8317: @496589
     /*  496589 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(496657), // Rule ID 23529 //
     /*  496594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  496605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  496608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496626 */     // MIs[0] policy
     /*  496626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496636 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  496639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496643 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496653 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496655 */     GIR_RootConstrainSelectedInstOperands,
     /*  496656 */     // GIR_Coverage, 23529,
     /*  496656 */     GIR_EraseRootFromParent_Done,
     /*  496657 */   // Label 8318: @496657
     /*  496657 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(496725), // Rule ID 23532 //
     /*  496662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  496673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  496676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496694 */     // MIs[0] policy
     /*  496694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496704 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496711 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496721 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496723 */     GIR_RootConstrainSelectedInstOperands,
     /*  496724 */     // GIR_Coverage, 23532,
     /*  496724 */     GIR_EraseRootFromParent_Done,
     /*  496725 */   // Label 8319: @496725
     /*  496725 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(496793), // Rule ID 23533 //
     /*  496730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  496741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  496744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496762 */     // MIs[0] policy
     /*  496762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496772 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496779 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496789 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496791 */     GIR_RootConstrainSelectedInstOperands,
     /*  496792 */     // GIR_Coverage, 23533,
     /*  496792 */     GIR_EraseRootFromParent_Done,
     /*  496793 */   // Label 8320: @496793
     /*  496793 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(496861), // Rule ID 23536 //
     /*  496798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  496809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  496812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496830 */     // MIs[0] policy
     /*  496830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496847 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496857 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496859 */     GIR_RootConstrainSelectedInstOperands,
     /*  496860 */     // GIR_Coverage, 23536,
     /*  496860 */     GIR_EraseRootFromParent_Done,
     /*  496861 */   // Label 8321: @496861
     /*  496861 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(496929), // Rule ID 23537 //
     /*  496866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  496877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  496880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496898 */     // MIs[0] policy
     /*  496898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496908 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496915 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496925 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496927 */     GIR_RootConstrainSelectedInstOperands,
     /*  496928 */     // GIR_Coverage, 23537,
     /*  496928 */     GIR_EraseRootFromParent_Done,
     /*  496929 */   // Label 8322: @496929
     /*  496929 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(496997), // Rule ID 23540 //
     /*  496934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  496945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  496948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  496951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496966 */     // MIs[0] policy
     /*  496966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496976 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496983 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496993 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496995 */     GIR_RootConstrainSelectedInstOperands,
     /*  496996 */     // GIR_Coverage, 23540,
     /*  496996 */     GIR_EraseRootFromParent_Done,
     /*  496997 */   // Label 8323: @496997
     /*  496997 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(497065), // Rule ID 23541 //
     /*  497002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  497013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  497016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497034 */     // MIs[0] policy
     /*  497034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497044 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497051 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497061 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497063 */     GIR_RootConstrainSelectedInstOperands,
     /*  497064 */     // GIR_Coverage, 23541,
     /*  497064 */     GIR_EraseRootFromParent_Done,
     /*  497065 */   // Label 8324: @497065
     /*  497065 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(497133), // Rule ID 23544 //
     /*  497070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  497081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  497084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  497087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497102 */     // MIs[0] policy
     /*  497102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497112 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11377:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497119 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497129 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497131 */     GIR_RootConstrainSelectedInstOperands,
     /*  497132 */     // GIR_Coverage, 23544,
     /*  497132 */     GIR_EraseRootFromParent_Done,
     /*  497133 */   // Label 8325: @497133
     /*  497133 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(497201), // Rule ID 23545 //
     /*  497138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  497149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  497152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  497155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497170 */     // MIs[0] policy
     /*  497170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11377:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497187 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497197 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497199 */     GIR_RootConstrainSelectedInstOperands,
     /*  497200 */     // GIR_Coverage, 23545,
     /*  497200 */     GIR_EraseRootFromParent_Done,
     /*  497201 */   // Label 8326: @497201
     /*  497201 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(497269), // Rule ID 23548 //
     /*  497206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  497217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  497220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  497223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497238 */     // MIs[0] policy
     /*  497238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497248 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497255 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497265 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497267 */     GIR_RootConstrainSelectedInstOperands,
     /*  497268 */     // GIR_Coverage, 23548,
     /*  497268 */     GIR_EraseRootFromParent_Done,
     /*  497269 */   // Label 8327: @497269
     /*  497269 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(497337), // Rule ID 23549 //
     /*  497274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  497285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  497288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  497291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497306 */     // MIs[0] policy
     /*  497306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497323 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497333 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497335 */     GIR_RootConstrainSelectedInstOperands,
     /*  497336 */     // GIR_Coverage, 23549,
     /*  497336 */     GIR_EraseRootFromParent_Done,
     /*  497337 */   // Label 8328: @497337
     /*  497337 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(497405), // Rule ID 23552 //
     /*  497342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  497345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  497353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  497356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  497359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497374 */     // MIs[0] policy
     /*  497374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497391 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  497401 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497403 */     GIR_RootConstrainSelectedInstOperands,
     /*  497404 */     // GIR_Coverage, 23552,
     /*  497404 */     GIR_EraseRootFromParent_Done,
     /*  497405 */   // Label 8329: @497405
     /*  497405 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(497473), // Rule ID 23553 //
     /*  497410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  497413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  497421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  497424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  497427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497442 */     // MIs[0] policy
     /*  497442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497452 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497459 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  497469 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497471 */     GIR_RootConstrainSelectedInstOperands,
     /*  497472 */     // GIR_Coverage, 23553,
     /*  497472 */     GIR_EraseRootFromParent_Done,
     /*  497473 */   // Label 8330: @497473
     /*  497473 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(497541), // Rule ID 23556 //
     /*  497478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  497489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  497492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497510 */     // MIs[0] policy
     /*  497510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497520 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497527 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497537 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497539 */     GIR_RootConstrainSelectedInstOperands,
     /*  497540 */     // GIR_Coverage, 23556,
     /*  497540 */     GIR_EraseRootFromParent_Done,
     /*  497541 */   // Label 8331: @497541
     /*  497541 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(497609), // Rule ID 23557 //
     /*  497546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  497557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  497560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497578 */     // MIs[0] policy
     /*  497578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497588 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497595 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497605 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497607 */     GIR_RootConstrainSelectedInstOperands,
     /*  497608 */     // GIR_Coverage, 23557,
     /*  497608 */     GIR_EraseRootFromParent_Done,
     /*  497609 */   // Label 8332: @497609
     /*  497609 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(497677), // Rule ID 23560 //
     /*  497614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  497625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  497628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497646 */     // MIs[0] policy
     /*  497646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497656 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497663 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497673 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497675 */     GIR_RootConstrainSelectedInstOperands,
     /*  497676 */     // GIR_Coverage, 23560,
     /*  497676 */     GIR_EraseRootFromParent_Done,
     /*  497677 */   // Label 8333: @497677
     /*  497677 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(497745), // Rule ID 23561 //
     /*  497682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  497693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  497696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497714 */     // MIs[0] policy
     /*  497714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497724 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497731 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497741 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497743 */     GIR_RootConstrainSelectedInstOperands,
     /*  497744 */     // GIR_Coverage, 23561,
     /*  497744 */     GIR_EraseRootFromParent_Done,
     /*  497745 */   // Label 8334: @497745
     /*  497745 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(497813), // Rule ID 23564 //
     /*  497750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  497761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  497764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  497767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497782 */     // MIs[0] policy
     /*  497782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497792 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497799 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497809 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497811 */     GIR_RootConstrainSelectedInstOperands,
     /*  497812 */     // GIR_Coverage, 23564,
     /*  497812 */     GIR_EraseRootFromParent_Done,
     /*  497813 */   // Label 8335: @497813
     /*  497813 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(497881), // Rule ID 23565 //
     /*  497818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  497829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  497832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  497835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497850 */     // MIs[0] policy
     /*  497850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497860 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497867 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497877 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497879 */     GIR_RootConstrainSelectedInstOperands,
     /*  497880 */     // GIR_Coverage, 23565,
     /*  497880 */     GIR_EraseRootFromParent_Done,
     /*  497881 */   // Label 8336: @497881
     /*  497881 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(497949), // Rule ID 23568 //
     /*  497886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497918 */     // MIs[0] policy
     /*  497918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497928 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497935 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497945 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497947 */     GIR_RootConstrainSelectedInstOperands,
     /*  497948 */     // GIR_Coverage, 23568,
     /*  497948 */     GIR_EraseRootFromParent_Done,
     /*  497949 */   // Label 8337: @497949
     /*  497949 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(498017), // Rule ID 23569 //
     /*  497954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497986 */     // MIs[0] policy
     /*  497986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498003 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498013 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498015 */     GIR_RootConstrainSelectedInstOperands,
     /*  498016 */     // GIR_Coverage, 23569,
     /*  498016 */     GIR_EraseRootFromParent_Done,
     /*  498017 */   // Label 8338: @498017
     /*  498017 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(498085), // Rule ID 23572 //
     /*  498022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  498033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  498036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  498039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498054 */     // MIs[0] policy
     /*  498054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498071 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498081 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498083 */     GIR_RootConstrainSelectedInstOperands,
     /*  498084 */     // GIR_Coverage, 23572,
     /*  498084 */     GIR_EraseRootFromParent_Done,
     /*  498085 */   // Label 8339: @498085
     /*  498085 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(498153), // Rule ID 23573 //
     /*  498090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  498101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  498104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  498107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498122 */     // MIs[0] policy
     /*  498122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498132 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498139 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498149 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498151 */     GIR_RootConstrainSelectedInstOperands,
     /*  498152 */     // GIR_Coverage, 23573,
     /*  498152 */     GIR_EraseRootFromParent_Done,
     /*  498153 */   // Label 8340: @498153
     /*  498153 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(498221), // Rule ID 23576 //
     /*  498158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  498169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  498172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  498175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498190 */     // MIs[0] policy
     /*  498190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498200 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498207 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498217 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498219 */     GIR_RootConstrainSelectedInstOperands,
     /*  498220 */     // GIR_Coverage, 23576,
     /*  498220 */     GIR_EraseRootFromParent_Done,
     /*  498221 */   // Label 8341: @498221
     /*  498221 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(498289), // Rule ID 23577 //
     /*  498226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  498237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  498240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  498243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498258 */     // MIs[0] policy
     /*  498258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498275 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498285 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498287 */     GIR_RootConstrainSelectedInstOperands,
     /*  498288 */     // GIR_Coverage, 23577,
     /*  498288 */     GIR_EraseRootFromParent_Done,
     /*  498289 */   // Label 8342: @498289
     /*  498289 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(498357), // Rule ID 23580 //
     /*  498294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  498305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  498308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  498311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  498318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498326 */     // MIs[0] policy
     /*  498326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  498339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498343 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498353 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498355 */     GIR_RootConstrainSelectedInstOperands,
     /*  498356 */     // GIR_Coverage, 23580,
     /*  498356 */     GIR_EraseRootFromParent_Done,
     /*  498357 */   // Label 8343: @498357
     /*  498357 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(498425), // Rule ID 23581 //
     /*  498362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  498373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  498376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  498379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  498386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498394 */     // MIs[0] policy
     /*  498394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  498407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498411 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498421 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498423 */     GIR_RootConstrainSelectedInstOperands,
     /*  498424 */     // GIR_Coverage, 23581,
     /*  498424 */     GIR_EraseRootFromParent_Done,
     /*  498425 */   // Label 8344: @498425
     /*  498425 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(498493), // Rule ID 23584 //
     /*  498430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498462 */     // MIs[0] policy
     /*  498462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498472 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498479 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498489 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498491 */     GIR_RootConstrainSelectedInstOperands,
     /*  498492 */     // GIR_Coverage, 23584,
     /*  498492 */     GIR_EraseRootFromParent_Done,
     /*  498493 */   // Label 8345: @498493
     /*  498493 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(498561), // Rule ID 23585 //
     /*  498498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498530 */     // MIs[0] policy
     /*  498530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498540 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498547 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498557 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498559 */     GIR_RootConstrainSelectedInstOperands,
     /*  498560 */     // GIR_Coverage, 23585,
     /*  498560 */     GIR_EraseRootFromParent_Done,
     /*  498561 */   // Label 8346: @498561
     /*  498561 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(498629), // Rule ID 23588 //
     /*  498566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  498583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498598 */     // MIs[0] policy
     /*  498598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498608 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498615 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498625 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498627 */     GIR_RootConstrainSelectedInstOperands,
     /*  498628 */     // GIR_Coverage, 23588,
     /*  498628 */     GIR_EraseRootFromParent_Done,
     /*  498629 */   // Label 8347: @498629
     /*  498629 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(498697), // Rule ID 23589 //
     /*  498634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  498651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498666 */     // MIs[0] policy
     /*  498666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498676 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498683 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498693 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498695 */     GIR_RootConstrainSelectedInstOperands,
     /*  498696 */     // GIR_Coverage, 23589,
     /*  498696 */     GIR_EraseRootFromParent_Done,
     /*  498697 */   // Label 8348: @498697
     /*  498697 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(498765), // Rule ID 23592 //
     /*  498702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  498705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  498713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  498716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  498719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  498726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498734 */     // MIs[0] policy
     /*  498734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  498747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498751 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498761 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498763 */     GIR_RootConstrainSelectedInstOperands,
     /*  498764 */     // GIR_Coverage, 23592,
     /*  498764 */     GIR_EraseRootFromParent_Done,
     /*  498765 */   // Label 8349: @498765
     /*  498765 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(498833), // Rule ID 23593 //
     /*  498770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  498773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  498781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  498784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  498787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  498794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498802 */     // MIs[0] policy
     /*  498802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  498815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498819 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498829 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498831 */     GIR_RootConstrainSelectedInstOperands,
     /*  498832 */     // GIR_Coverage, 23593,
     /*  498832 */     GIR_EraseRootFromParent_Done,
     /*  498833 */   // Label 8350: @498833
     /*  498833 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(498901), // Rule ID 23596 //
     /*  498838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  498841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  498849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  498852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  498855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498870 */     // MIs[0] policy
     /*  498870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498880 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498887 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498897 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498899 */     GIR_RootConstrainSelectedInstOperands,
     /*  498900 */     // GIR_Coverage, 23596,
     /*  498900 */     GIR_EraseRootFromParent_Done,
     /*  498901 */   // Label 8351: @498901
     /*  498901 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(498969), // Rule ID 23597 //
     /*  498906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  498909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  498917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  498920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  498923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498938 */     // MIs[0] policy
     /*  498938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498948 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498955 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498965 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498967 */     GIR_RootConstrainSelectedInstOperands,
     /*  498968 */     // GIR_Coverage, 23597,
     /*  498968 */     GIR_EraseRootFromParent_Done,
     /*  498969 */   // Label 8352: @498969
     /*  498969 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(499037), // Rule ID 23600 //
     /*  498974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  498977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  498985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  498988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499006 */     // MIs[0] policy
     /*  499006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  499019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499023 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  499033 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499035 */     GIR_RootConstrainSelectedInstOperands,
     /*  499036 */     // GIR_Coverage, 23600,
     /*  499036 */     GIR_EraseRootFromParent_Done,
     /*  499037 */   // Label 8353: @499037
     /*  499037 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(499105), // Rule ID 23601 //
     /*  499042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  499045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  499053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  499056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  499059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  499066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499074 */     // MIs[0] policy
     /*  499074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499084 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  499087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499091 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  499101 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499103 */     GIR_RootConstrainSelectedInstOperands,
     /*  499104 */     // GIR_Coverage, 23601,
     /*  499104 */     GIR_EraseRootFromParent_Done,
     /*  499105 */   // Label 8354: @499105
     /*  499105 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(499173), // Rule ID 60614 //
     /*  499110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499142 */     // MIs[0] policy
     /*  499142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499152 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  499155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499169 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499171 */     GIR_RootConstrainSelectedInstOperands,
     /*  499172 */     // GIR_Coverage, 60614,
     /*  499172 */     GIR_EraseRootFromParent_Done,
     /*  499173 */   // Label 8355: @499173
     /*  499173 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(499241), // Rule ID 60615 //
     /*  499178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499210 */     // MIs[0] policy
     /*  499210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499220 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  499223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499237 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499239 */     GIR_RootConstrainSelectedInstOperands,
     /*  499240 */     // GIR_Coverage, 60615,
     /*  499240 */     GIR_EraseRootFromParent_Done,
     /*  499241 */   // Label 8356: @499241
     /*  499241 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(499309), // Rule ID 60616 //
     /*  499246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  499254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499278 */     // MIs[0] policy
     /*  499278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499288 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  499291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499305 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499307 */     GIR_RootConstrainSelectedInstOperands,
     /*  499308 */     // GIR_Coverage, 60616,
     /*  499308 */     GIR_EraseRootFromParent_Done,
     /*  499309 */   // Label 8357: @499309
     /*  499309 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(499377), // Rule ID 60617 //
     /*  499314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  499322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499346 */     // MIs[0] policy
     /*  499346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499356 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  499359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499373 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499375 */     GIR_RootConstrainSelectedInstOperands,
     /*  499376 */     // GIR_Coverage, 60617,
     /*  499376 */     GIR_EraseRootFromParent_Done,
     /*  499377 */   // Label 8358: @499377
     /*  499377 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(499445), // Rule ID 62110 //
     /*  499382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499414 */     // MIs[0] policy
     /*  499414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499424 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  499427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499441 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499443 */     GIR_RootConstrainSelectedInstOperands,
     /*  499444 */     // GIR_Coverage, 62110,
     /*  499444 */     GIR_EraseRootFromParent_Done,
     /*  499445 */   // Label 8359: @499445
     /*  499445 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(499513), // Rule ID 62111 //
     /*  499450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499482 */     // MIs[0] policy
     /*  499482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  499495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499509 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499511 */     GIR_RootConstrainSelectedInstOperands,
     /*  499512 */     // GIR_Coverage, 62111,
     /*  499512 */     GIR_EraseRootFromParent_Done,
     /*  499513 */   // Label 8360: @499513
     /*  499513 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(499581), // Rule ID 62112 //
     /*  499518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499550 */     // MIs[0] policy
     /*  499550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  499563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499577 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499579 */     GIR_RootConstrainSelectedInstOperands,
     /*  499580 */     // GIR_Coverage, 62112,
     /*  499580 */     GIR_EraseRootFromParent_Done,
     /*  499581 */   // Label 8361: @499581
     /*  499581 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(499649), // Rule ID 62113 //
     /*  499586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499618 */     // MIs[0] policy
     /*  499618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499628 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  499631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499645 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499647 */     GIR_RootConstrainSelectedInstOperands,
     /*  499648 */     // GIR_Coverage, 62113,
     /*  499648 */     GIR_EraseRootFromParent_Done,
     /*  499649 */   // Label 8362: @499649
     /*  499649 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(499717), // Rule ID 62114 //
     /*  499654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499686 */     // MIs[0] policy
     /*  499686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499696 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  499699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499713 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499715 */     GIR_RootConstrainSelectedInstOperands,
     /*  499716 */     // GIR_Coverage, 62114,
     /*  499716 */     GIR_EraseRootFromParent_Done,
     /*  499717 */   // Label 8363: @499717
     /*  499717 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(499785), // Rule ID 62115 //
     /*  499722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499754 */     // MIs[0] policy
     /*  499754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  499767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499781 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499783 */     GIR_RootConstrainSelectedInstOperands,
     /*  499784 */     // GIR_Coverage, 62115,
     /*  499784 */     GIR_EraseRootFromParent_Done,
     /*  499785 */   // Label 8364: @499785
     /*  499785 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(499853), // Rule ID 62116 //
     /*  499790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  499801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  499804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  499807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499822 */     // MIs[0] policy
     /*  499822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499832 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  499835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499849 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499851 */     GIR_RootConstrainSelectedInstOperands,
     /*  499852 */     // GIR_Coverage, 62116,
     /*  499852 */     GIR_EraseRootFromParent_Done,
     /*  499853 */   // Label 8365: @499853
     /*  499853 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(499921), // Rule ID 62117 //
     /*  499858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  499869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  499872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  499875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499890 */     // MIs[0] policy
     /*  499890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499900 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  499903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499917 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499919 */     GIR_RootConstrainSelectedInstOperands,
     /*  499920 */     // GIR_Coverage, 62117,
     /*  499920 */     GIR_EraseRootFromParent_Done,
     /*  499921 */   // Label 8366: @499921
     /*  499921 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(499989), // Rule ID 62118 //
     /*  499926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499958 */     // MIs[0] policy
     /*  499958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  499971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499985 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499987 */     GIR_RootConstrainSelectedInstOperands,
     /*  499988 */     // GIR_Coverage, 62118,
     /*  499988 */     GIR_EraseRootFromParent_Done,
     /*  499989 */   // Label 8367: @499989
     /*  499989 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(500057), // Rule ID 62119 //
     /*  499994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  500005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  500008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500026 */     // MIs[0] policy
     /*  500026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500036 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  500039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500053 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500055 */     GIR_RootConstrainSelectedInstOperands,
     /*  500056 */     // GIR_Coverage, 62119,
     /*  500056 */     GIR_EraseRootFromParent_Done,
     /*  500057 */   // Label 8368: @500057
     /*  500057 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(500125), // Rule ID 62120 //
     /*  500062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500094 */     // MIs[0] policy
     /*  500094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  500107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500121 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500123 */     GIR_RootConstrainSelectedInstOperands,
     /*  500124 */     // GIR_Coverage, 62120,
     /*  500124 */     GIR_EraseRootFromParent_Done,
     /*  500125 */   // Label 8369: @500125
     /*  500125 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(500193), // Rule ID 62121 //
     /*  500130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500162 */     // MIs[0] policy
     /*  500162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500172 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  500175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500189 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500191 */     GIR_RootConstrainSelectedInstOperands,
     /*  500192 */     // GIR_Coverage, 62121,
     /*  500192 */     GIR_EraseRootFromParent_Done,
     /*  500193 */   // Label 8370: @500193
     /*  500193 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(500261), // Rule ID 62122 //
     /*  500198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500230 */     // MIs[0] policy
     /*  500230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500240 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  500243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500257 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500259 */     GIR_RootConstrainSelectedInstOperands,
     /*  500260 */     // GIR_Coverage, 62122,
     /*  500260 */     GIR_EraseRootFromParent_Done,
     /*  500261 */   // Label 8371: @500261
     /*  500261 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(500329), // Rule ID 62123 //
     /*  500266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500298 */     // MIs[0] policy
     /*  500298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500308 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  500311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500325 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500327 */     GIR_RootConstrainSelectedInstOperands,
     /*  500328 */     // GIR_Coverage, 62123,
     /*  500328 */     GIR_EraseRootFromParent_Done,
     /*  500329 */   // Label 8372: @500329
     /*  500329 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(500397), // Rule ID 62124 //
     /*  500334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  500351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500366 */     // MIs[0] policy
     /*  500366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500376 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  500379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500393 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500395 */     GIR_RootConstrainSelectedInstOperands,
     /*  500396 */     // GIR_Coverage, 62124,
     /*  500396 */     GIR_EraseRootFromParent_Done,
     /*  500397 */   // Label 8373: @500397
     /*  500397 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(500465), // Rule ID 62125 //
     /*  500402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  500419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500434 */     // MIs[0] policy
     /*  500434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500444 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  500447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500461 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500463 */     GIR_RootConstrainSelectedInstOperands,
     /*  500464 */     // GIR_Coverage, 62125,
     /*  500464 */     GIR_EraseRootFromParent_Done,
     /*  500465 */   // Label 8374: @500465
     /*  500465 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(500533), // Rule ID 62126 //
     /*  500470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  500487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500502 */     // MIs[0] policy
     /*  500502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500512 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  500515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500529 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500531 */     GIR_RootConstrainSelectedInstOperands,
     /*  500532 */     // GIR_Coverage, 62126,
     /*  500532 */     GIR_EraseRootFromParent_Done,
     /*  500533 */   // Label 8375: @500533
     /*  500533 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(500601), // Rule ID 62127 //
     /*  500538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  500555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500570 */     // MIs[0] policy
     /*  500570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  500583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500597 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500599 */     GIR_RootConstrainSelectedInstOperands,
     /*  500600 */     // GIR_Coverage, 62127,
     /*  500600 */     GIR_EraseRootFromParent_Done,
     /*  500601 */   // Label 8376: @500601
     /*  500601 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(500669), // Rule ID 62128 //
     /*  500606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500638 */     // MIs[0] policy
     /*  500638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500648 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  500651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500665 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500667 */     GIR_RootConstrainSelectedInstOperands,
     /*  500668 */     // GIR_Coverage, 62128,
     /*  500668 */     GIR_EraseRootFromParent_Done,
     /*  500669 */   // Label 8377: @500669
     /*  500669 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(500737), // Rule ID 62129 //
     /*  500674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500706 */     // MIs[0] policy
     /*  500706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  500719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500733 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500735 */     GIR_RootConstrainSelectedInstOperands,
     /*  500736 */     // GIR_Coverage, 62129,
     /*  500736 */     GIR_EraseRootFromParent_Done,
     /*  500737 */   // Label 8378: @500737
     /*  500737 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(500805), // Rule ID 62130 //
     /*  500742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500774 */     // MIs[0] policy
     /*  500774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500784 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  500787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500801 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500803 */     GIR_RootConstrainSelectedInstOperands,
     /*  500804 */     // GIR_Coverage, 62130,
     /*  500804 */     GIR_EraseRootFromParent_Done,
     /*  500805 */   // Label 8379: @500805
     /*  500805 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(500873), // Rule ID 62131 //
     /*  500810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500842 */     // MIs[0] policy
     /*  500842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  500855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500869 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500871 */     GIR_RootConstrainSelectedInstOperands,
     /*  500872 */     // GIR_Coverage, 62131,
     /*  500872 */     GIR_EraseRootFromParent_Done,
     /*  500873 */   // Label 8380: @500873
     /*  500873 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(500941), // Rule ID 62132 //
     /*  500878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500910 */     // MIs[0] policy
     /*  500910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  500923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500937 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500939 */     GIR_RootConstrainSelectedInstOperands,
     /*  500940 */     // GIR_Coverage, 62132,
     /*  500940 */     GIR_EraseRootFromParent_Done,
     /*  500941 */   // Label 8381: @500941
     /*  500941 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(501009), // Rule ID 62133 //
     /*  500946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500978 */     // MIs[0] policy
     /*  500978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500988 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  500991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501005 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501007 */     GIR_RootConstrainSelectedInstOperands,
     /*  501008 */     // GIR_Coverage, 62133,
     /*  501008 */     GIR_EraseRootFromParent_Done,
     /*  501009 */   // Label 8382: @501009
     /*  501009 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(501077), // Rule ID 62134 //
     /*  501014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501046 */     // MIs[0] policy
     /*  501046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  501059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501073 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501075 */     GIR_RootConstrainSelectedInstOperands,
     /*  501076 */     // GIR_Coverage, 62134,
     /*  501076 */     GIR_EraseRootFromParent_Done,
     /*  501077 */   // Label 8383: @501077
     /*  501077 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(501145), // Rule ID 62135 //
     /*  501082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501114 */     // MIs[0] policy
     /*  501114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501124 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  501127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501141 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501143 */     GIR_RootConstrainSelectedInstOperands,
     /*  501144 */     // GIR_Coverage, 62135,
     /*  501144 */     GIR_EraseRootFromParent_Done,
     /*  501145 */   // Label 8384: @501145
     /*  501145 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(501213), // Rule ID 62136 //
     /*  501150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501182 */     // MIs[0] policy
     /*  501182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  501195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501209 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501211 */     GIR_RootConstrainSelectedInstOperands,
     /*  501212 */     // GIR_Coverage, 62136,
     /*  501212 */     GIR_EraseRootFromParent_Done,
     /*  501213 */   // Label 8385: @501213
     /*  501213 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(501281), // Rule ID 62137 //
     /*  501218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501250 */     // MIs[0] policy
     /*  501250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  501263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501277 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501279 */     GIR_RootConstrainSelectedInstOperands,
     /*  501280 */     // GIR_Coverage, 62137,
     /*  501280 */     GIR_EraseRootFromParent_Done,
     /*  501281 */   // Label 8386: @501281
     /*  501281 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(501349), // Rule ID 62138 //
     /*  501286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501318 */     // MIs[0] policy
     /*  501318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  501331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501345 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501347 */     GIR_RootConstrainSelectedInstOperands,
     /*  501348 */     // GIR_Coverage, 62138,
     /*  501348 */     GIR_EraseRootFromParent_Done,
     /*  501349 */   // Label 8387: @501349
     /*  501349 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(501417), // Rule ID 62139 //
     /*  501354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501386 */     // MIs[0] policy
     /*  501386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501396 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  501399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501413 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501415 */     GIR_RootConstrainSelectedInstOperands,
     /*  501416 */     // GIR_Coverage, 62139,
     /*  501416 */     GIR_EraseRootFromParent_Done,
     /*  501417 */   // Label 8388: @501417
     /*  501417 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(501485), // Rule ID 62140 //
     /*  501422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501454 */     // MIs[0] policy
     /*  501454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  501467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501481 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501483 */     GIR_RootConstrainSelectedInstOperands,
     /*  501484 */     // GIR_Coverage, 62140,
     /*  501484 */     GIR_EraseRootFromParent_Done,
     /*  501485 */   // Label 8389: @501485
     /*  501485 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(501553), // Rule ID 62141 //
     /*  501490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501522 */     // MIs[0] policy
     /*  501522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501532 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  501535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501549 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501551 */     GIR_RootConstrainSelectedInstOperands,
     /*  501552 */     // GIR_Coverage, 62141,
     /*  501552 */     GIR_EraseRootFromParent_Done,
     /*  501553 */   // Label 8390: @501553
     /*  501553 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(501621), // Rule ID 62142 //
     /*  501558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501590 */     // MIs[0] policy
     /*  501590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501600 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  501603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501617 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501619 */     GIR_RootConstrainSelectedInstOperands,
     /*  501620 */     // GIR_Coverage, 62142,
     /*  501620 */     GIR_EraseRootFromParent_Done,
     /*  501621 */   // Label 8391: @501621
     /*  501621 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(501689), // Rule ID 62143 //
     /*  501626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501658 */     // MIs[0] policy
     /*  501658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  501671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501685 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501687 */     GIR_RootConstrainSelectedInstOperands,
     /*  501688 */     // GIR_Coverage, 62143,
     /*  501688 */     GIR_EraseRootFromParent_Done,
     /*  501689 */   // Label 8392: @501689
     /*  501689 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(501757), // Rule ID 62144 //
     /*  501694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501726 */     // MIs[0] policy
     /*  501726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  501739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501753 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501755 */     GIR_RootConstrainSelectedInstOperands,
     /*  501756 */     // GIR_Coverage, 62144,
     /*  501756 */     GIR_EraseRootFromParent_Done,
     /*  501757 */   // Label 8393: @501757
     /*  501757 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(501825), // Rule ID 62145 //
     /*  501762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501794 */     // MIs[0] policy
     /*  501794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501804 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  501807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501821 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501823 */     GIR_RootConstrainSelectedInstOperands,
     /*  501824 */     // GIR_Coverage, 62145,
     /*  501824 */     GIR_EraseRootFromParent_Done,
     /*  501825 */   // Label 8394: @501825
     /*  501825 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(501893), // Rule ID 62146 //
     /*  501830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501862 */     // MIs[0] policy
     /*  501862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501872 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  501875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501889 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501891 */     GIR_RootConstrainSelectedInstOperands,
     /*  501892 */     // GIR_Coverage, 62146,
     /*  501892 */     GIR_EraseRootFromParent_Done,
     /*  501893 */   // Label 8395: @501893
     /*  501893 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(501961), // Rule ID 62147 //
     /*  501898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501930 */     // MIs[0] policy
     /*  501930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501940 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  501943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501957 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501959 */     GIR_RootConstrainSelectedInstOperands,
     /*  501960 */     // GIR_Coverage, 62147,
     /*  501960 */     GIR_EraseRootFromParent_Done,
     /*  501961 */   // Label 8396: @501961
     /*  501961 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(502029), // Rule ID 62148 //
     /*  501966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501998 */     // MIs[0] policy
     /*  501998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502008 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  502011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502025 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502027 */     GIR_RootConstrainSelectedInstOperands,
     /*  502028 */     // GIR_Coverage, 62148,
     /*  502028 */     GIR_EraseRootFromParent_Done,
     /*  502029 */   // Label 8397: @502029
     /*  502029 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(502097), // Rule ID 62149 //
     /*  502034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502066 */     // MIs[0] policy
     /*  502066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  502079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502093 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502095 */     GIR_RootConstrainSelectedInstOperands,
     /*  502096 */     // GIR_Coverage, 62149,
     /*  502096 */     GIR_EraseRootFromParent_Done,
     /*  502097 */   // Label 8398: @502097
     /*  502097 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(502165), // Rule ID 62150 //
     /*  502102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502134 */     // MIs[0] policy
     /*  502134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502144 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  502147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502161 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502163 */     GIR_RootConstrainSelectedInstOperands,
     /*  502164 */     // GIR_Coverage, 62150,
     /*  502164 */     GIR_EraseRootFromParent_Done,
     /*  502165 */   // Label 8399: @502165
     /*  502165 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(502233), // Rule ID 62151 //
     /*  502170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502202 */     // MIs[0] policy
     /*  502202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502212 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  502215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502229 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502231 */     GIR_RootConstrainSelectedInstOperands,
     /*  502232 */     // GIR_Coverage, 62151,
     /*  502232 */     GIR_EraseRootFromParent_Done,
     /*  502233 */   // Label 8400: @502233
     /*  502233 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(502301), // Rule ID 62152 //
     /*  502238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502270 */     // MIs[0] policy
     /*  502270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502280 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  502283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502297 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502299 */     GIR_RootConstrainSelectedInstOperands,
     /*  502300 */     // GIR_Coverage, 62152,
     /*  502300 */     GIR_EraseRootFromParent_Done,
     /*  502301 */   // Label 8401: @502301
     /*  502301 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(502369), // Rule ID 62153 //
     /*  502306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502338 */     // MIs[0] policy
     /*  502338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502348 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  502351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502365 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502367 */     GIR_RootConstrainSelectedInstOperands,
     /*  502368 */     // GIR_Coverage, 62153,
     /*  502368 */     GIR_EraseRootFromParent_Done,
     /*  502369 */   // Label 8402: @502369
     /*  502369 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(502437), // Rule ID 62154 //
     /*  502374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502406 */     // MIs[0] policy
     /*  502406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  502419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502433 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502435 */     GIR_RootConstrainSelectedInstOperands,
     /*  502436 */     // GIR_Coverage, 62154,
     /*  502436 */     GIR_EraseRootFromParent_Done,
     /*  502437 */   // Label 8403: @502437
     /*  502437 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(502505), // Rule ID 62155 //
     /*  502442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502474 */     // MIs[0] policy
     /*  502474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  502487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502501 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502503 */     GIR_RootConstrainSelectedInstOperands,
     /*  502504 */     // GIR_Coverage, 62155,
     /*  502504 */     GIR_EraseRootFromParent_Done,
     /*  502505 */   // Label 8404: @502505
     /*  502505 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(502573), // Rule ID 62156 //
     /*  502510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502542 */     // MIs[0] policy
     /*  502542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  502555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502569 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502571 */     GIR_RootConstrainSelectedInstOperands,
     /*  502572 */     // GIR_Coverage, 62156,
     /*  502572 */     GIR_EraseRootFromParent_Done,
     /*  502573 */   // Label 8405: @502573
     /*  502573 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(502641), // Rule ID 62157 //
     /*  502578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502610 */     // MIs[0] policy
     /*  502610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  502623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502637 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502639 */     GIR_RootConstrainSelectedInstOperands,
     /*  502640 */     // GIR_Coverage, 62157,
     /*  502640 */     GIR_EraseRootFromParent_Done,
     /*  502641 */   // Label 8406: @502641
     /*  502641 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(502709), // Rule ID 62158 //
     /*  502646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502678 */     // MIs[0] policy
     /*  502678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  502691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502705 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502707 */     GIR_RootConstrainSelectedInstOperands,
     /*  502708 */     // GIR_Coverage, 62158,
     /*  502708 */     GIR_EraseRootFromParent_Done,
     /*  502709 */   // Label 8407: @502709
     /*  502709 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(502777), // Rule ID 62159 //
     /*  502714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502746 */     // MIs[0] policy
     /*  502746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  502759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502773 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502775 */     GIR_RootConstrainSelectedInstOperands,
     /*  502776 */     // GIR_Coverage, 62159,
     /*  502776 */     GIR_EraseRootFromParent_Done,
     /*  502777 */   // Label 8408: @502777
     /*  502777 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(502845), // Rule ID 62160 //
     /*  502782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  502793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  502796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502814 */     // MIs[0] policy
     /*  502814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502824 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  502827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502841 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502843 */     GIR_RootConstrainSelectedInstOperands,
     /*  502844 */     // GIR_Coverage, 62160,
     /*  502844 */     GIR_EraseRootFromParent_Done,
     /*  502845 */   // Label 8409: @502845
     /*  502845 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(502913), // Rule ID 62161 //
     /*  502850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  502861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  502864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502882 */     // MIs[0] policy
     /*  502882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502892 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  502895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502909 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502911 */     GIR_RootConstrainSelectedInstOperands,
     /*  502912 */     // GIR_Coverage, 62161,
     /*  502912 */     GIR_EraseRootFromParent_Done,
     /*  502913 */   // Label 8410: @502913
     /*  502913 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(502981), // Rule ID 62162 //
     /*  502918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  502935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502950 */     // MIs[0] policy
     /*  502950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  502963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502977 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502979 */     GIR_RootConstrainSelectedInstOperands,
     /*  502980 */     // GIR_Coverage, 62162,
     /*  502980 */     GIR_EraseRootFromParent_Done,
     /*  502981 */   // Label 8411: @502981
     /*  502981 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(503049), // Rule ID 62163 //
     /*  502986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  503003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503018 */     // MIs[0] policy
     /*  503018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503028 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  503031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503045 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503047 */     GIR_RootConstrainSelectedInstOperands,
     /*  503048 */     // GIR_Coverage, 62163,
     /*  503048 */     GIR_EraseRootFromParent_Done,
     /*  503049 */   // Label 8412: @503049
     /*  503049 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(503117), // Rule ID 62164 //
     /*  503054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  503065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  503068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503086 */     // MIs[0] policy
     /*  503086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503096 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  503099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503113 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503115 */     GIR_RootConstrainSelectedInstOperands,
     /*  503116 */     // GIR_Coverage, 62164,
     /*  503116 */     GIR_EraseRootFromParent_Done,
     /*  503117 */   // Label 8413: @503117
     /*  503117 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(503185), // Rule ID 62165 //
     /*  503122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  503133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  503136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503154 */     // MIs[0] policy
     /*  503154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503164 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  503167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503181 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503183 */     GIR_RootConstrainSelectedInstOperands,
     /*  503184 */     // GIR_Coverage, 62165,
     /*  503184 */     GIR_EraseRootFromParent_Done,
     /*  503185 */   // Label 8414: @503185
     /*  503185 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(503253), // Rule ID 62166 //
     /*  503190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503222 */     // MIs[0] policy
     /*  503222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  503235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503249 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503251 */     GIR_RootConstrainSelectedInstOperands,
     /*  503252 */     // GIR_Coverage, 62166,
     /*  503252 */     GIR_EraseRootFromParent_Done,
     /*  503253 */   // Label 8415: @503253
     /*  503253 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(503321), // Rule ID 62167 //
     /*  503258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503290 */     // MIs[0] policy
     /*  503290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  503303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503317 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503319 */     GIR_RootConstrainSelectedInstOperands,
     /*  503320 */     // GIR_Coverage, 62167,
     /*  503320 */     GIR_EraseRootFromParent_Done,
     /*  503321 */   // Label 8416: @503321
     /*  503321 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(503389), // Rule ID 62168 //
     /*  503326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503358 */     // MIs[0] policy
     /*  503358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503368 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  503371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503385 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503387 */     GIR_RootConstrainSelectedInstOperands,
     /*  503388 */     // GIR_Coverage, 62168,
     /*  503388 */     GIR_EraseRootFromParent_Done,
     /*  503389 */   // Label 8417: @503389
     /*  503389 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(503457), // Rule ID 62169 //
     /*  503394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503426 */     // MIs[0] policy
     /*  503426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  503439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503453 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503455 */     GIR_RootConstrainSelectedInstOperands,
     /*  503456 */     // GIR_Coverage, 62169,
     /*  503456 */     GIR_EraseRootFromParent_Done,
     /*  503457 */   // Label 8418: @503457
     /*  503457 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(503525), // Rule ID 62170 //
     /*  503462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503494 */     // MIs[0] policy
     /*  503494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  503507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503521 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503523 */     GIR_RootConstrainSelectedInstOperands,
     /*  503524 */     // GIR_Coverage, 62170,
     /*  503524 */     GIR_EraseRootFromParent_Done,
     /*  503525 */   // Label 8419: @503525
     /*  503525 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(503593), // Rule ID 62171 //
     /*  503530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503562 */     // MIs[0] policy
     /*  503562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  503575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503589 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503591 */     GIR_RootConstrainSelectedInstOperands,
     /*  503592 */     // GIR_Coverage, 62171,
     /*  503592 */     GIR_EraseRootFromParent_Done,
     /*  503593 */   // Label 8420: @503593
     /*  503593 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(503661), // Rule ID 62172 //
     /*  503598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503630 */     // MIs[0] policy
     /*  503630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  503643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503657 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503659 */     GIR_RootConstrainSelectedInstOperands,
     /*  503660 */     // GIR_Coverage, 62172,
     /*  503660 */     GIR_EraseRootFromParent_Done,
     /*  503661 */   // Label 8421: @503661
     /*  503661 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(503729), // Rule ID 62173 //
     /*  503666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503698 */     // MIs[0] policy
     /*  503698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  503711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503725 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503727 */     GIR_RootConstrainSelectedInstOperands,
     /*  503728 */     // GIR_Coverage, 62173,
     /*  503728 */     GIR_EraseRootFromParent_Done,
     /*  503729 */   // Label 8422: @503729
     /*  503729 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(503797), // Rule ID 62174 //
     /*  503734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503766 */     // MIs[0] policy
     /*  503766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  503779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503793 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503795 */     GIR_RootConstrainSelectedInstOperands,
     /*  503796 */     // GIR_Coverage, 62174,
     /*  503796 */     GIR_EraseRootFromParent_Done,
     /*  503797 */   // Label 8423: @503797
     /*  503797 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(503865), // Rule ID 62175 //
     /*  503802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503834 */     // MIs[0] policy
     /*  503834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  503847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503861 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503863 */     GIR_RootConstrainSelectedInstOperands,
     /*  503864 */     // GIR_Coverage, 62175,
     /*  503864 */     GIR_EraseRootFromParent_Done,
     /*  503865 */   // Label 8424: @503865
     /*  503865 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(503933), // Rule ID 62176 //
     /*  503870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503902 */     // MIs[0] policy
     /*  503902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503912 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  503915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503929 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503931 */     GIR_RootConstrainSelectedInstOperands,
     /*  503932 */     // GIR_Coverage, 62176,
     /*  503932 */     GIR_EraseRootFromParent_Done,
     /*  503933 */   // Label 8425: @503933
     /*  503933 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(504001), // Rule ID 62177 //
     /*  503938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503970 */     // MIs[0] policy
     /*  503970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  503983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503997 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503999 */     GIR_RootConstrainSelectedInstOperands,
     /*  504000 */     // GIR_Coverage, 62177,
     /*  504000 */     GIR_EraseRootFromParent_Done,
     /*  504001 */   // Label 8426: @504001
     /*  504001 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(504069), // Rule ID 62178 //
     /*  504006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504038 */     // MIs[0] policy
     /*  504038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  504051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504065 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504067 */     GIR_RootConstrainSelectedInstOperands,
     /*  504068 */     // GIR_Coverage, 62178,
     /*  504068 */     GIR_EraseRootFromParent_Done,
     /*  504069 */   // Label 8427: @504069
     /*  504069 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(504137), // Rule ID 62179 //
     /*  504074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504106 */     // MIs[0] policy
     /*  504106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504116 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  504119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504133 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504135 */     GIR_RootConstrainSelectedInstOperands,
     /*  504136 */     // GIR_Coverage, 62179,
     /*  504136 */     GIR_EraseRootFromParent_Done,
     /*  504137 */   // Label 8428: @504137
     /*  504137 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(504205), // Rule ID 62180 //
     /*  504142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504174 */     // MIs[0] policy
     /*  504174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504184 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  504187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504201 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504203 */     GIR_RootConstrainSelectedInstOperands,
     /*  504204 */     // GIR_Coverage, 62180,
     /*  504204 */     GIR_EraseRootFromParent_Done,
     /*  504205 */   // Label 8429: @504205
     /*  504205 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(504273), // Rule ID 62181 //
     /*  504210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504242 */     // MIs[0] policy
     /*  504242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504252 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  504255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504269 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504271 */     GIR_RootConstrainSelectedInstOperands,
     /*  504272 */     // GIR_Coverage, 62181,
     /*  504272 */     GIR_EraseRootFromParent_Done,
     /*  504273 */   // Label 8430: @504273
     /*  504273 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(504341), // Rule ID 62182 //
     /*  504278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504310 */     // MIs[0] policy
     /*  504310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504320 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  504323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504337 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504339 */     GIR_RootConstrainSelectedInstOperands,
     /*  504340 */     // GIR_Coverage, 62182,
     /*  504340 */     GIR_EraseRootFromParent_Done,
     /*  504341 */   // Label 8431: @504341
     /*  504341 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(504409), // Rule ID 62183 //
     /*  504346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504378 */     // MIs[0] policy
     /*  504378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504388 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  504391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504405 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504407 */     GIR_RootConstrainSelectedInstOperands,
     /*  504408 */     // GIR_Coverage, 62183,
     /*  504408 */     GIR_EraseRootFromParent_Done,
     /*  504409 */   // Label 8432: @504409
     /*  504409 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(504477), // Rule ID 62184 //
     /*  504414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504446 */     // MIs[0] policy
     /*  504446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504456 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  504459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504473 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504475 */     GIR_RootConstrainSelectedInstOperands,
     /*  504476 */     // GIR_Coverage, 62184,
     /*  504476 */     GIR_EraseRootFromParent_Done,
     /*  504477 */   // Label 8433: @504477
     /*  504477 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(504545), // Rule ID 62185 //
     /*  504482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504514 */     // MIs[0] policy
     /*  504514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504524 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  504527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504541 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504543 */     GIR_RootConstrainSelectedInstOperands,
     /*  504544 */     // GIR_Coverage, 62185,
     /*  504544 */     GIR_EraseRootFromParent_Done,
     /*  504545 */   // Label 8434: @504545
     /*  504545 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(504613), // Rule ID 62186 //
     /*  504550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504582 */     // MIs[0] policy
     /*  504582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504592 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  504595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504609 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504611 */     GIR_RootConstrainSelectedInstOperands,
     /*  504612 */     // GIR_Coverage, 62186,
     /*  504612 */     GIR_EraseRootFromParent_Done,
     /*  504613 */   // Label 8435: @504613
     /*  504613 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(504681), // Rule ID 62187 //
     /*  504618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504650 */     // MIs[0] policy
     /*  504650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504660 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  504663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504677 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504679 */     GIR_RootConstrainSelectedInstOperands,
     /*  504680 */     // GIR_Coverage, 62187,
     /*  504680 */     GIR_EraseRootFromParent_Done,
     /*  504681 */   // Label 8436: @504681
     /*  504681 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(504749), // Rule ID 62188 //
     /*  504686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504718 */     // MIs[0] policy
     /*  504718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504728 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  504731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504745 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504747 */     GIR_RootConstrainSelectedInstOperands,
     /*  504748 */     // GIR_Coverage, 62188,
     /*  504748 */     GIR_EraseRootFromParent_Done,
     /*  504749 */   // Label 8437: @504749
     /*  504749 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(504817), // Rule ID 62189 //
     /*  504754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504786 */     // MIs[0] policy
     /*  504786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  504799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504813 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504815 */     GIR_RootConstrainSelectedInstOperands,
     /*  504816 */     // GIR_Coverage, 62189,
     /*  504816 */     GIR_EraseRootFromParent_Done,
     /*  504817 */   // Label 8438: @504817
     /*  504817 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(504885), // Rule ID 62190 //
     /*  504822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504854 */     // MIs[0] policy
     /*  504854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  504867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504881 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504883 */     GIR_RootConstrainSelectedInstOperands,
     /*  504884 */     // GIR_Coverage, 62190,
     /*  504884 */     GIR_EraseRootFromParent_Done,
     /*  504885 */   // Label 8439: @504885
     /*  504885 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(504953), // Rule ID 62191 //
     /*  504890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504922 */     // MIs[0] policy
     /*  504922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  504935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504949 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504951 */     GIR_RootConstrainSelectedInstOperands,
     /*  504952 */     // GIR_Coverage, 62191,
     /*  504952 */     GIR_EraseRootFromParent_Done,
     /*  504953 */   // Label 8440: @504953
     /*  504953 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(505021), // Rule ID 62192 //
     /*  504958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  504969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  504972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504990 */     // MIs[0] policy
     /*  504990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  505003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505017 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505019 */     GIR_RootConstrainSelectedInstOperands,
     /*  505020 */     // GIR_Coverage, 62192,
     /*  505020 */     GIR_EraseRootFromParent_Done,
     /*  505021 */   // Label 8441: @505021
     /*  505021 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(505089), // Rule ID 62193 //
     /*  505026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505058 */     // MIs[0] policy
     /*  505058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505068 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  505071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505085 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505087 */     GIR_RootConstrainSelectedInstOperands,
     /*  505088 */     // GIR_Coverage, 62193,
     /*  505088 */     GIR_EraseRootFromParent_Done,
     /*  505089 */   // Label 8442: @505089
     /*  505089 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(505157), // Rule ID 62194 //
     /*  505094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505126 */     // MIs[0] policy
     /*  505126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  505139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505153 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505155 */     GIR_RootConstrainSelectedInstOperands,
     /*  505156 */     // GIR_Coverage, 62194,
     /*  505156 */     GIR_EraseRootFromParent_Done,
     /*  505157 */   // Label 8443: @505157
     /*  505157 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(505225), // Rule ID 62195 //
     /*  505162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505194 */     // MIs[0] policy
     /*  505194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  505207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505221 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505223 */     GIR_RootConstrainSelectedInstOperands,
     /*  505224 */     // GIR_Coverage, 62195,
     /*  505224 */     GIR_EraseRootFromParent_Done,
     /*  505225 */   // Label 8444: @505225
     /*  505225 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(505293), // Rule ID 62196 //
     /*  505230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505262 */     // MIs[0] policy
     /*  505262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505272 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  505275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505289 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505291 */     GIR_RootConstrainSelectedInstOperands,
     /*  505292 */     // GIR_Coverage, 62196,
     /*  505292 */     GIR_EraseRootFromParent_Done,
     /*  505293 */   // Label 8445: @505293
     /*  505293 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(505361), // Rule ID 62197 //
     /*  505298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505330 */     // MIs[0] policy
     /*  505330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  505343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505357 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505359 */     GIR_RootConstrainSelectedInstOperands,
     /*  505360 */     // GIR_Coverage, 62197,
     /*  505360 */     GIR_EraseRootFromParent_Done,
     /*  505361 */   // Label 8446: @505361
     /*  505361 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(505429), // Rule ID 62198 //
     /*  505366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505398 */     // MIs[0] policy
     /*  505398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505408 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  505411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505425 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505427 */     GIR_RootConstrainSelectedInstOperands,
     /*  505428 */     // GIR_Coverage, 62198,
     /*  505428 */     GIR_EraseRootFromParent_Done,
     /*  505429 */   // Label 8447: @505429
     /*  505429 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(505497), // Rule ID 62199 //
     /*  505434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505466 */     // MIs[0] policy
     /*  505466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505476 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  505479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505493 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505495 */     GIR_RootConstrainSelectedInstOperands,
     /*  505496 */     // GIR_Coverage, 62199,
     /*  505496 */     GIR_EraseRootFromParent_Done,
     /*  505497 */   // Label 8448: @505497
     /*  505497 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(505565), // Rule ID 62200 //
     /*  505502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  505519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505534 */     // MIs[0] policy
     /*  505534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505544 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  505547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505561 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505563 */     GIR_RootConstrainSelectedInstOperands,
     /*  505564 */     // GIR_Coverage, 62200,
     /*  505564 */     GIR_EraseRootFromParent_Done,
     /*  505565 */   // Label 8449: @505565
     /*  505565 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(505633), // Rule ID 62201 //
     /*  505570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  505587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505602 */     // MIs[0] policy
     /*  505602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505612 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  505615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505629 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505631 */     GIR_RootConstrainSelectedInstOperands,
     /*  505632 */     // GIR_Coverage, 62201,
     /*  505632 */     GIR_EraseRootFromParent_Done,
     /*  505633 */   // Label 8450: @505633
     /*  505633 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(505701), // Rule ID 62202 //
     /*  505638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505670 */     // MIs[0] policy
     /*  505670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505680 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  505683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505697 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505699 */     GIR_RootConstrainSelectedInstOperands,
     /*  505700 */     // GIR_Coverage, 62202,
     /*  505700 */     GIR_EraseRootFromParent_Done,
     /*  505701 */   // Label 8451: @505701
     /*  505701 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(505769), // Rule ID 62203 //
     /*  505706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505738 */     // MIs[0] policy
     /*  505738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505748 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  505751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505765 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505767 */     GIR_RootConstrainSelectedInstOperands,
     /*  505768 */     // GIR_Coverage, 62203,
     /*  505768 */     GIR_EraseRootFromParent_Done,
     /*  505769 */   // Label 8452: @505769
     /*  505769 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(505837), // Rule ID 62204 //
     /*  505774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505806 */     // MIs[0] policy
     /*  505806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505816 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  505819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505833 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505835 */     GIR_RootConstrainSelectedInstOperands,
     /*  505836 */     // GIR_Coverage, 62204,
     /*  505836 */     GIR_EraseRootFromParent_Done,
     /*  505837 */   // Label 8453: @505837
     /*  505837 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(505905), // Rule ID 62205 //
     /*  505842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505874 */     // MIs[0] policy
     /*  505874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505884 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  505887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505901 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505903 */     GIR_RootConstrainSelectedInstOperands,
     /*  505904 */     // GIR_Coverage, 62205,
     /*  505904 */     GIR_EraseRootFromParent_Done,
     /*  505905 */   // Label 8454: @505905
     /*  505905 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(505973), // Rule ID 62206 //
     /*  505910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505942 */     // MIs[0] policy
     /*  505942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  505955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505969 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505971 */     GIR_RootConstrainSelectedInstOperands,
     /*  505972 */     // GIR_Coverage, 62206,
     /*  505972 */     GIR_EraseRootFromParent_Done,
     /*  505973 */   // Label 8455: @505973
     /*  505973 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(506041), // Rule ID 62207 //
     /*  505978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506010 */     // MIs[0] policy
     /*  506010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  506023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506037 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506039 */     GIR_RootConstrainSelectedInstOperands,
     /*  506040 */     // GIR_Coverage, 62207,
     /*  506040 */     GIR_EraseRootFromParent_Done,
     /*  506041 */   // Label 8456: @506041
     /*  506041 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(506109), // Rule ID 62208 //
     /*  506046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506078 */     // MIs[0] policy
     /*  506078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  506091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506105 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506107 */     GIR_RootConstrainSelectedInstOperands,
     /*  506108 */     // GIR_Coverage, 62208,
     /*  506108 */     GIR_EraseRootFromParent_Done,
     /*  506109 */   // Label 8457: @506109
     /*  506109 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(506177), // Rule ID 62209 //
     /*  506114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506146 */     // MIs[0] policy
     /*  506146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  506159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506173 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506175 */     GIR_RootConstrainSelectedInstOperands,
     /*  506176 */     // GIR_Coverage, 62209,
     /*  506176 */     GIR_EraseRootFromParent_Done,
     /*  506177 */   // Label 8458: @506177
     /*  506177 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(506245), // Rule ID 62210 //
     /*  506182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506214 */     // MIs[0] policy
     /*  506214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506224 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  506227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506241 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506243 */     GIR_RootConstrainSelectedInstOperands,
     /*  506244 */     // GIR_Coverage, 62210,
     /*  506244 */     GIR_EraseRootFromParent_Done,
     /*  506245 */   // Label 8459: @506245
     /*  506245 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(506313), // Rule ID 62211 //
     /*  506250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506282 */     // MIs[0] policy
     /*  506282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  506295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506309 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506311 */     GIR_RootConstrainSelectedInstOperands,
     /*  506312 */     // GIR_Coverage, 62211,
     /*  506312 */     GIR_EraseRootFromParent_Done,
     /*  506313 */   // Label 8460: @506313
     /*  506313 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(506381), // Rule ID 62212 //
     /*  506318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506350 */     // MIs[0] policy
     /*  506350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  506363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506377 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506379 */     GIR_RootConstrainSelectedInstOperands,
     /*  506380 */     // GIR_Coverage, 62212,
     /*  506380 */     GIR_EraseRootFromParent_Done,
     /*  506381 */   // Label 8461: @506381
     /*  506381 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(506449), // Rule ID 62213 //
     /*  506386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506418 */     // MIs[0] policy
     /*  506418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506428 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  506431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506445 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506447 */     GIR_RootConstrainSelectedInstOperands,
     /*  506448 */     // GIR_Coverage, 62213,
     /*  506448 */     GIR_EraseRootFromParent_Done,
     /*  506449 */   // Label 8462: @506449
     /*  506449 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(506517), // Rule ID 62214 //
     /*  506454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506486 */     // MIs[0] policy
     /*  506486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  506499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506513 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506515 */     GIR_RootConstrainSelectedInstOperands,
     /*  506516 */     // GIR_Coverage, 62214,
     /*  506516 */     GIR_EraseRootFromParent_Done,
     /*  506517 */   // Label 8463: @506517
     /*  506517 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(506585), // Rule ID 62215 //
     /*  506522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506554 */     // MIs[0] policy
     /*  506554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506564 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  506567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506581 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506583 */     GIR_RootConstrainSelectedInstOperands,
     /*  506584 */     // GIR_Coverage, 62215,
     /*  506584 */     GIR_EraseRootFromParent_Done,
     /*  506585 */   // Label 8464: @506585
     /*  506585 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(506653), // Rule ID 62216 //
     /*  506590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506622 */     // MIs[0] policy
     /*  506622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506632 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  506635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506649 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506651 */     GIR_RootConstrainSelectedInstOperands,
     /*  506652 */     // GIR_Coverage, 62216,
     /*  506652 */     GIR_EraseRootFromParent_Done,
     /*  506653 */   // Label 8465: @506653
     /*  506653 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(506721), // Rule ID 62217 //
     /*  506658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506690 */     // MIs[0] policy
     /*  506690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506700 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  506703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506717 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506719 */     GIR_RootConstrainSelectedInstOperands,
     /*  506720 */     // GIR_Coverage, 62217,
     /*  506720 */     GIR_EraseRootFromParent_Done,
     /*  506721 */   // Label 8466: @506721
     /*  506721 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(506789), // Rule ID 62218 //
     /*  506726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506758 */     // MIs[0] policy
     /*  506758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  506771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506785 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506787 */     GIR_RootConstrainSelectedInstOperands,
     /*  506788 */     // GIR_Coverage, 62218,
     /*  506788 */     GIR_EraseRootFromParent_Done,
     /*  506789 */   // Label 8467: @506789
     /*  506789 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(506857), // Rule ID 62219 //
     /*  506794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506826 */     // MIs[0] policy
     /*  506826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  506839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506853 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506855 */     GIR_RootConstrainSelectedInstOperands,
     /*  506856 */     // GIR_Coverage, 62219,
     /*  506856 */     GIR_EraseRootFromParent_Done,
     /*  506857 */   // Label 8468: @506857
     /*  506857 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(506925), // Rule ID 62220 //
     /*  506862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506894 */     // MIs[0] policy
     /*  506894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506904 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  506907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506921 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506923 */     GIR_RootConstrainSelectedInstOperands,
     /*  506924 */     // GIR_Coverage, 62220,
     /*  506924 */     GIR_EraseRootFromParent_Done,
     /*  506925 */   // Label 8469: @506925
     /*  506925 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(506993), // Rule ID 62221 //
     /*  506930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506962 */     // MIs[0] policy
     /*  506962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506972 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  506975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506989 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506991 */     GIR_RootConstrainSelectedInstOperands,
     /*  506992 */     // GIR_Coverage, 62221,
     /*  506992 */     GIR_EraseRootFromParent_Done,
     /*  506993 */   // Label 8470: @506993
     /*  506993 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(507061), // Rule ID 62222 //
     /*  506998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507030 */     // MIs[0] policy
     /*  507030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507040 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  507043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507057 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507059 */     GIR_RootConstrainSelectedInstOperands,
     /*  507060 */     // GIR_Coverage, 62222,
     /*  507060 */     GIR_EraseRootFromParent_Done,
     /*  507061 */   // Label 8471: @507061
     /*  507061 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(507129), // Rule ID 62223 //
     /*  507066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507098 */     // MIs[0] policy
     /*  507098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  507111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507125 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507127 */     GIR_RootConstrainSelectedInstOperands,
     /*  507128 */     // GIR_Coverage, 62223,
     /*  507128 */     GIR_EraseRootFromParent_Done,
     /*  507129 */   // Label 8472: @507129
     /*  507129 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(507197), // Rule ID 62224 //
     /*  507134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507166 */     // MIs[0] policy
     /*  507166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507176 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  507179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507193 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507195 */     GIR_RootConstrainSelectedInstOperands,
     /*  507196 */     // GIR_Coverage, 62224,
     /*  507196 */     GIR_EraseRootFromParent_Done,
     /*  507197 */   // Label 8473: @507197
     /*  507197 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(507265), // Rule ID 62225 //
     /*  507202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507234 */     // MIs[0] policy
     /*  507234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  507247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507261 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507263 */     GIR_RootConstrainSelectedInstOperands,
     /*  507264 */     // GIR_Coverage, 62225,
     /*  507264 */     GIR_EraseRootFromParent_Done,
     /*  507265 */   // Label 8474: @507265
     /*  507265 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(507333), // Rule ID 62226 //
     /*  507270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507302 */     // MIs[0] policy
     /*  507302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507312 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  507315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507329 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507331 */     GIR_RootConstrainSelectedInstOperands,
     /*  507332 */     // GIR_Coverage, 62226,
     /*  507332 */     GIR_EraseRootFromParent_Done,
     /*  507333 */   // Label 8475: @507333
     /*  507333 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(507401), // Rule ID 62227 //
     /*  507338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507370 */     // MIs[0] policy
     /*  507370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507380 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  507383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507397 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507399 */     GIR_RootConstrainSelectedInstOperands,
     /*  507400 */     // GIR_Coverage, 62227,
     /*  507400 */     GIR_EraseRootFromParent_Done,
     /*  507401 */   // Label 8476: @507401
     /*  507401 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(507469), // Rule ID 62228 //
     /*  507406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507438 */     // MIs[0] policy
     /*  507438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507448 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  507451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507465 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507467 */     GIR_RootConstrainSelectedInstOperands,
     /*  507468 */     // GIR_Coverage, 62228,
     /*  507468 */     GIR_EraseRootFromParent_Done,
     /*  507469 */   // Label 8477: @507469
     /*  507469 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(507537), // Rule ID 62229 //
     /*  507474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507506 */     // MIs[0] policy
     /*  507506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507516 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  507519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507533 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507535 */     GIR_RootConstrainSelectedInstOperands,
     /*  507536 */     // GIR_Coverage, 62229,
     /*  507536 */     GIR_EraseRootFromParent_Done,
     /*  507537 */   // Label 8478: @507537
     /*  507537 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(507605), // Rule ID 62230 //
     /*  507542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507574 */     // MIs[0] policy
     /*  507574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507584 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  507587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507601 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507603 */     GIR_RootConstrainSelectedInstOperands,
     /*  507604 */     // GIR_Coverage, 62230,
     /*  507604 */     GIR_EraseRootFromParent_Done,
     /*  507605 */   // Label 8479: @507605
     /*  507605 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(507673), // Rule ID 62231 //
     /*  507610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507642 */     // MIs[0] policy
     /*  507642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  507655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507669 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507671 */     GIR_RootConstrainSelectedInstOperands,
     /*  507672 */     // GIR_Coverage, 62231,
     /*  507672 */     GIR_EraseRootFromParent_Done,
     /*  507673 */   // Label 8480: @507673
     /*  507673 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(507741), // Rule ID 62232 //
     /*  507678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507710 */     // MIs[0] policy
     /*  507710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507720 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  507723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507737 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507739 */     GIR_RootConstrainSelectedInstOperands,
     /*  507740 */     // GIR_Coverage, 62232,
     /*  507740 */     GIR_EraseRootFromParent_Done,
     /*  507741 */   // Label 8481: @507741
     /*  507741 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(507809), // Rule ID 62233 //
     /*  507746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507778 */     // MIs[0] policy
     /*  507778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507788 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  507791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507805 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507807 */     GIR_RootConstrainSelectedInstOperands,
     /*  507808 */     // GIR_Coverage, 62233,
     /*  507808 */     GIR_EraseRootFromParent_Done,
     /*  507809 */   // Label 8482: @507809
     /*  507809 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(507877), // Rule ID 62234 //
     /*  507814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507846 */     // MIs[0] policy
     /*  507846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  507859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507873 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507875 */     GIR_RootConstrainSelectedInstOperands,
     /*  507876 */     // GIR_Coverage, 62234,
     /*  507876 */     GIR_EraseRootFromParent_Done,
     /*  507877 */   // Label 8483: @507877
     /*  507877 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(507945), // Rule ID 62235 //
     /*  507882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507914 */     // MIs[0] policy
     /*  507914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507924 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  507927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507941 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507943 */     GIR_RootConstrainSelectedInstOperands,
     /*  507944 */     // GIR_Coverage, 62235,
     /*  507944 */     GIR_EraseRootFromParent_Done,
     /*  507945 */   // Label 8484: @507945
     /*  507945 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(508013), // Rule ID 62236 //
     /*  507950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507982 */     // MIs[0] policy
     /*  507982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507992 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  507995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508009 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508011 */     GIR_RootConstrainSelectedInstOperands,
     /*  508012 */     // GIR_Coverage, 62236,
     /*  508012 */     GIR_EraseRootFromParent_Done,
     /*  508013 */   // Label 8485: @508013
     /*  508013 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(508081), // Rule ID 62237 //
     /*  508018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  508026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508050 */     // MIs[0] policy
     /*  508050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508060 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  508063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508077 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508079 */     GIR_RootConstrainSelectedInstOperands,
     /*  508080 */     // GIR_Coverage, 62237,
     /*  508080 */     GIR_EraseRootFromParent_Done,
     /*  508081 */   // Label 8486: @508081
     /*  508081 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(508149), // Rule ID 62238 //
     /*  508086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  508094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  508103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508118 */     // MIs[0] policy
     /*  508118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508128 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  508131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508145 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508147 */     GIR_RootConstrainSelectedInstOperands,
     /*  508148 */     // GIR_Coverage, 62238,
     /*  508148 */     GIR_EraseRootFromParent_Done,
     /*  508149 */   // Label 8487: @508149
     /*  508149 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(508217), // Rule ID 62239 //
     /*  508154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  508162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  508171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508186 */     // MIs[0] policy
     /*  508186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  508199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508213 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508215 */     GIR_RootConstrainSelectedInstOperands,
     /*  508216 */     // GIR_Coverage, 62239,
     /*  508216 */     GIR_EraseRootFromParent_Done,
     /*  508217 */   // Label 8488: @508217
     /*  508217 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(508285), // Rule ID 62240 //
     /*  508222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  508233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  508236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508254 */     // MIs[0] policy
     /*  508254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  508267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508281 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508283 */     GIR_RootConstrainSelectedInstOperands,
     /*  508284 */     // GIR_Coverage, 62240,
     /*  508284 */     GIR_EraseRootFromParent_Done,
     /*  508285 */   // Label 8489: @508285
     /*  508285 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(508353), // Rule ID 62241 //
     /*  508290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  508301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  508304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508322 */     // MIs[0] policy
     /*  508322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508332 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  508335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508349 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508351 */     GIR_RootConstrainSelectedInstOperands,
     /*  508352 */     // GIR_Coverage, 62241,
     /*  508352 */     GIR_EraseRootFromParent_Done,
     /*  508353 */   // Label 8490: @508353
     /*  508353 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(508421), // Rule ID 62242 //
     /*  508358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508390 */     // MIs[0] policy
     /*  508390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  508403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508417 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508419 */     GIR_RootConstrainSelectedInstOperands,
     /*  508420 */     // GIR_Coverage, 62242,
     /*  508420 */     GIR_EraseRootFromParent_Done,
     /*  508421 */   // Label 8491: @508421
     /*  508421 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(508489), // Rule ID 62243 //
     /*  508426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508458 */     // MIs[0] policy
     /*  508458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508468 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  508471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508485 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508487 */     GIR_RootConstrainSelectedInstOperands,
     /*  508488 */     // GIR_Coverage, 62243,
     /*  508488 */     GIR_EraseRootFromParent_Done,
     /*  508489 */   // Label 8492: @508489
     /*  508489 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(508557), // Rule ID 62244 //
     /*  508494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508526 */     // MIs[0] policy
     /*  508526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  508539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508553 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508555 */     GIR_RootConstrainSelectedInstOperands,
     /*  508556 */     // GIR_Coverage, 62244,
     /*  508556 */     GIR_EraseRootFromParent_Done,
     /*  508557 */   // Label 8493: @508557
     /*  508557 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(508625), // Rule ID 62245 //
     /*  508562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508594 */     // MIs[0] policy
     /*  508594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508604 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  508607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508621 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508623 */     GIR_RootConstrainSelectedInstOperands,
     /*  508624 */     // GIR_Coverage, 62245,
     /*  508624 */     GIR_EraseRootFromParent_Done,
     /*  508625 */   // Label 8494: @508625
     /*  508625 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(508693), // Rule ID 62246 //
     /*  508630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508662 */     // MIs[0] policy
     /*  508662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  508675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508689 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508691 */     GIR_RootConstrainSelectedInstOperands,
     /*  508692 */     // GIR_Coverage, 62246,
     /*  508692 */     GIR_EraseRootFromParent_Done,
     /*  508693 */   // Label 8495: @508693
     /*  508693 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(508761), // Rule ID 62247 //
     /*  508698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508730 */     // MIs[0] policy
     /*  508730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  508743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508757 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508759 */     GIR_RootConstrainSelectedInstOperands,
     /*  508760 */     // GIR_Coverage, 62247,
     /*  508760 */     GIR_EraseRootFromParent_Done,
     /*  508761 */   // Label 8496: @508761
     /*  508761 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(508829), // Rule ID 62248 //
     /*  508766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508798 */     // MIs[0] policy
     /*  508798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508808 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  508811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508825 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508827 */     GIR_RootConstrainSelectedInstOperands,
     /*  508828 */     // GIR_Coverage, 62248,
     /*  508828 */     GIR_EraseRootFromParent_Done,
     /*  508829 */   // Label 8497: @508829
     /*  508829 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(508897), // Rule ID 62249 //
     /*  508834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508866 */     // MIs[0] policy
     /*  508866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  508879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508893 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508895 */     GIR_RootConstrainSelectedInstOperands,
     /*  508896 */     // GIR_Coverage, 62249,
     /*  508896 */     GIR_EraseRootFromParent_Done,
     /*  508897 */   // Label 8498: @508897
     /*  508897 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(508965), // Rule ID 62250 //
     /*  508902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508934 */     // MIs[0] policy
     /*  508934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  508947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508961 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508963 */     GIR_RootConstrainSelectedInstOperands,
     /*  508964 */     // GIR_Coverage, 62250,
     /*  508964 */     GIR_EraseRootFromParent_Done,
     /*  508965 */   // Label 8499: @508965
     /*  508965 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(509033), // Rule ID 62251 //
     /*  508970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509002 */     // MIs[0] policy
     /*  509002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509012 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  509015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509029 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509031 */     GIR_RootConstrainSelectedInstOperands,
     /*  509032 */     // GIR_Coverage, 62251,
     /*  509032 */     GIR_EraseRootFromParent_Done,
     /*  509033 */   // Label 8500: @509033
     /*  509033 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(509101), // Rule ID 62252 //
     /*  509038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509070 */     // MIs[0] policy
     /*  509070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509080 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  509083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509097 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509099 */     GIR_RootConstrainSelectedInstOperands,
     /*  509100 */     // GIR_Coverage, 62252,
     /*  509100 */     GIR_EraseRootFromParent_Done,
     /*  509101 */   // Label 8501: @509101
     /*  509101 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(509169), // Rule ID 62253 //
     /*  509106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509138 */     // MIs[0] policy
     /*  509138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509148 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  509151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509165 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509167 */     GIR_RootConstrainSelectedInstOperands,
     /*  509168 */     // GIR_Coverage, 62253,
     /*  509168 */     GIR_EraseRootFromParent_Done,
     /*  509169 */   // Label 8502: @509169
     /*  509169 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(509237), // Rule ID 62254 //
     /*  509174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509206 */     // MIs[0] policy
     /*  509206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  509219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509233 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509235 */     GIR_RootConstrainSelectedInstOperands,
     /*  509236 */     // GIR_Coverage, 62254,
     /*  509236 */     GIR_EraseRootFromParent_Done,
     /*  509237 */   // Label 8503: @509237
     /*  509237 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(509305), // Rule ID 62255 //
     /*  509242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509274 */     // MIs[0] policy
     /*  509274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509284 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  509287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509301 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509303 */     GIR_RootConstrainSelectedInstOperands,
     /*  509304 */     // GIR_Coverage, 62255,
     /*  509304 */     GIR_EraseRootFromParent_Done,
     /*  509305 */   // Label 8504: @509305
     /*  509305 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(509373), // Rule ID 62256 //
     /*  509310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509342 */     // MIs[0] policy
     /*  509342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509352 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  509355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509369 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509371 */     GIR_RootConstrainSelectedInstOperands,
     /*  509372 */     // GIR_Coverage, 62256,
     /*  509372 */     GIR_EraseRootFromParent_Done,
     /*  509373 */   // Label 8505: @509373
     /*  509373 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(509441), // Rule ID 62257 //
     /*  509378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509410 */     // MIs[0] policy
     /*  509410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509420 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  509423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509437 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509439 */     GIR_RootConstrainSelectedInstOperands,
     /*  509440 */     // GIR_Coverage, 62257,
     /*  509440 */     GIR_EraseRootFromParent_Done,
     /*  509441 */   // Label 8506: @509441
     /*  509441 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(509509), // Rule ID 62258 //
     /*  509446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509478 */     // MIs[0] policy
     /*  509478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  509491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509505 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509507 */     GIR_RootConstrainSelectedInstOperands,
     /*  509508 */     // GIR_Coverage, 62258,
     /*  509508 */     GIR_EraseRootFromParent_Done,
     /*  509509 */   // Label 8507: @509509
     /*  509509 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(509577), // Rule ID 62259 //
     /*  509514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509546 */     // MIs[0] policy
     /*  509546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  509559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509573 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509575 */     GIR_RootConstrainSelectedInstOperands,
     /*  509576 */     // GIR_Coverage, 62259,
     /*  509576 */     GIR_EraseRootFromParent_Done,
     /*  509577 */   // Label 8508: @509577
     /*  509577 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(509645), // Rule ID 62260 //
     /*  509582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509614 */     // MIs[0] policy
     /*  509614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509624 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  509627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509641 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509643 */     GIR_RootConstrainSelectedInstOperands,
     /*  509644 */     // GIR_Coverage, 62260,
     /*  509644 */     GIR_EraseRootFromParent_Done,
     /*  509645 */   // Label 8509: @509645
     /*  509645 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(509713), // Rule ID 62261 //
     /*  509650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509682 */     // MIs[0] policy
     /*  509682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  509695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509709 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509711 */     GIR_RootConstrainSelectedInstOperands,
     /*  509712 */     // GIR_Coverage, 62261,
     /*  509712 */     GIR_EraseRootFromParent_Done,
     /*  509713 */   // Label 8510: @509713
     /*  509713 */   GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(509781), // Rule ID 62262 //
     /*  509718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509750 */     // MIs[0] policy
     /*  509750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509760 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  509763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509777 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509779 */     GIR_RootConstrainSelectedInstOperands,
     /*  509780 */     // GIR_Coverage, 62262,
     /*  509780 */     GIR_EraseRootFromParent_Done,
     /*  509781 */   // Label 8511: @509781
     /*  509781 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(509849), // Rule ID 62263 //
     /*  509786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509818 */     // MIs[0] policy
     /*  509818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509828 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  509831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509845 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509847 */     GIR_RootConstrainSelectedInstOperands,
     /*  509848 */     // GIR_Coverage, 62263,
     /*  509848 */     GIR_EraseRootFromParent_Done,
     /*  509849 */   // Label 8512: @509849
     /*  509849 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(509917), // Rule ID 62264 //
     /*  509854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509886 */     // MIs[0] policy
     /*  509886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  509899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509913 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509915 */     GIR_RootConstrainSelectedInstOperands,
     /*  509916 */     // GIR_Coverage, 62264,
     /*  509916 */     GIR_EraseRootFromParent_Done,
     /*  509917 */   // Label 8513: @509917
     /*  509917 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(509985), // Rule ID 62265 //
     /*  509922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509954 */     // MIs[0] policy
     /*  509954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509964 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  509967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509981 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509983 */     GIR_RootConstrainSelectedInstOperands,
     /*  509984 */     // GIR_Coverage, 62265,
     /*  509984 */     GIR_EraseRootFromParent_Done,
     /*  509985 */   // Label 8514: @509985
     /*  509985 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(510053), // Rule ID 62266 //
     /*  509990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510022 */     // MIs[0] policy
     /*  510022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510032 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  510035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510049 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510051 */     GIR_RootConstrainSelectedInstOperands,
     /*  510052 */     // GIR_Coverage, 62266,
     /*  510052 */     GIR_EraseRootFromParent_Done,
     /*  510053 */   // Label 8515: @510053
     /*  510053 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(510121), // Rule ID 62267 //
     /*  510058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  510066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510090 */     // MIs[0] policy
     /*  510090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  510103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510117 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510119 */     GIR_RootConstrainSelectedInstOperands,
     /*  510120 */     // GIR_Coverage, 62267,
     /*  510120 */     GIR_EraseRootFromParent_Done,
     /*  510121 */   // Label 8516: @510121
     /*  510121 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(510189), // Rule ID 62284 //
     /*  510126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  510137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  510140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510158 */     // MIs[0] policy
     /*  510158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  510171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510185 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510187 */     GIR_RootConstrainSelectedInstOperands,
     /*  510188 */     // GIR_Coverage, 62284,
     /*  510188 */     GIR_EraseRootFromParent_Done,
     /*  510189 */   // Label 8517: @510189
     /*  510189 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(510257), // Rule ID 62285 //
     /*  510194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  510205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  510208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510226 */     // MIs[0] policy
     /*  510226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510236 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  510239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510253 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510255 */     GIR_RootConstrainSelectedInstOperands,
     /*  510256 */     // GIR_Coverage, 62285,
     /*  510256 */     GIR_EraseRootFromParent_Done,
     /*  510257 */   // Label 8518: @510257
     /*  510257 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(510325), // Rule ID 62286 //
     /*  510262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  510273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  510276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510294 */     // MIs[0] policy
     /*  510294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  510307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510321 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510323 */     GIR_RootConstrainSelectedInstOperands,
     /*  510324 */     // GIR_Coverage, 62286,
     /*  510324 */     GIR_EraseRootFromParent_Done,
     /*  510325 */   // Label 8519: @510325
     /*  510325 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(510393), // Rule ID 62287 //
     /*  510330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  510341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  510344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510362 */     // MIs[0] policy
     /*  510362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510372 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  510375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510389 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510391 */     GIR_RootConstrainSelectedInstOperands,
     /*  510392 */     // GIR_Coverage, 62287,
     /*  510392 */     GIR_EraseRootFromParent_Done,
     /*  510393 */   // Label 8520: @510393
     /*  510393 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(510461), // Rule ID 62288 //
     /*  510398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  510409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  510412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510430 */     // MIs[0] policy
     /*  510430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  510443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510457 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510459 */     GIR_RootConstrainSelectedInstOperands,
     /*  510460 */     // GIR_Coverage, 62288,
     /*  510460 */     GIR_EraseRootFromParent_Done,
     /*  510461 */   // Label 8521: @510461
     /*  510461 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(510529), // Rule ID 62289 //
     /*  510466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  510477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  510480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510498 */     // MIs[0] policy
     /*  510498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  510511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510525 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510527 */     GIR_RootConstrainSelectedInstOperands,
     /*  510528 */     // GIR_Coverage, 62289,
     /*  510528 */     GIR_EraseRootFromParent_Done,
     /*  510529 */   // Label 8522: @510529
     /*  510529 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(510597), // Rule ID 62290 //
     /*  510534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510566 */     // MIs[0] policy
     /*  510566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  510579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510593 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510595 */     GIR_RootConstrainSelectedInstOperands,
     /*  510596 */     // GIR_Coverage, 62290,
     /*  510596 */     GIR_EraseRootFromParent_Done,
     /*  510597 */   // Label 8523: @510597
     /*  510597 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(510665), // Rule ID 62291 //
     /*  510602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510634 */     // MIs[0] policy
     /*  510634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  510647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510661 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510663 */     GIR_RootConstrainSelectedInstOperands,
     /*  510664 */     // GIR_Coverage, 62291,
     /*  510664 */     GIR_EraseRootFromParent_Done,
     /*  510665 */   // Label 8524: @510665
     /*  510665 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(510733), // Rule ID 62292 //
     /*  510670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510702 */     // MIs[0] policy
     /*  510702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  510715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510729 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510731 */     GIR_RootConstrainSelectedInstOperands,
     /*  510732 */     // GIR_Coverage, 62292,
     /*  510732 */     GIR_EraseRootFromParent_Done,
     /*  510733 */   // Label 8525: @510733
     /*  510733 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(510801), // Rule ID 62293 //
     /*  510738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510770 */     // MIs[0] policy
     /*  510770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  510783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510797 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510799 */     GIR_RootConstrainSelectedInstOperands,
     /*  510800 */     // GIR_Coverage, 62293,
     /*  510800 */     GIR_EraseRootFromParent_Done,
     /*  510801 */   // Label 8526: @510801
     /*  510801 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(510869), // Rule ID 62294 //
     /*  510806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510838 */     // MIs[0] policy
     /*  510838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  510851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510865 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510867 */     GIR_RootConstrainSelectedInstOperands,
     /*  510868 */     // GIR_Coverage, 62294,
     /*  510868 */     GIR_EraseRootFromParent_Done,
     /*  510869 */   // Label 8527: @510869
     /*  510869 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(510937), // Rule ID 62295 //
     /*  510874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510906 */     // MIs[0] policy
     /*  510906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  510919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510933 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510935 */     GIR_RootConstrainSelectedInstOperands,
     /*  510936 */     // GIR_Coverage, 62295,
     /*  510936 */     GIR_EraseRootFromParent_Done,
     /*  510937 */   // Label 8528: @510937
     /*  510937 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(511005), // Rule ID 62296 //
     /*  510942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510974 */     // MIs[0] policy
     /*  510974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510984 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  510987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511001 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511003 */     GIR_RootConstrainSelectedInstOperands,
     /*  511004 */     // GIR_Coverage, 62296,
     /*  511004 */     GIR_EraseRootFromParent_Done,
     /*  511005 */   // Label 8529: @511005
     /*  511005 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(511073), // Rule ID 62297 //
     /*  511010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511042 */     // MIs[0] policy
     /*  511042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511052 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  511055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511069 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511071 */     GIR_RootConstrainSelectedInstOperands,
     /*  511072 */     // GIR_Coverage, 62297,
     /*  511072 */     GIR_EraseRootFromParent_Done,
     /*  511073 */   // Label 8530: @511073
     /*  511073 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(511141), // Rule ID 62298 //
     /*  511078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511110 */     // MIs[0] policy
     /*  511110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511120 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  511123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511137 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511139 */     GIR_RootConstrainSelectedInstOperands,
     /*  511140 */     // GIR_Coverage, 62298,
     /*  511140 */     GIR_EraseRootFromParent_Done,
     /*  511141 */   // Label 8531: @511141
     /*  511141 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(511209), // Rule ID 62299 //
     /*  511146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511178 */     // MIs[0] policy
     /*  511178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511188 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  511191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511205 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511207 */     GIR_RootConstrainSelectedInstOperands,
     /*  511208 */     // GIR_Coverage, 62299,
     /*  511208 */     GIR_EraseRootFromParent_Done,
     /*  511209 */   // Label 8532: @511209
     /*  511209 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(511277), // Rule ID 62300 //
     /*  511214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511246 */     // MIs[0] policy
     /*  511246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511256 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  511259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511273 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511275 */     GIR_RootConstrainSelectedInstOperands,
     /*  511276 */     // GIR_Coverage, 62300,
     /*  511276 */     GIR_EraseRootFromParent_Done,
     /*  511277 */   // Label 8533: @511277
     /*  511277 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(511345), // Rule ID 62301 //
     /*  511282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511314 */     // MIs[0] policy
     /*  511314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511324 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  511327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511341 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511343 */     GIR_RootConstrainSelectedInstOperands,
     /*  511344 */     // GIR_Coverage, 62301,
     /*  511344 */     GIR_EraseRootFromParent_Done,
     /*  511345 */   // Label 8534: @511345
     /*  511345 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(511413), // Rule ID 62302 //
     /*  511350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511382 */     // MIs[0] policy
     /*  511382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511392 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  511395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511409 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511411 */     GIR_RootConstrainSelectedInstOperands,
     /*  511412 */     // GIR_Coverage, 62302,
     /*  511412 */     GIR_EraseRootFromParent_Done,
     /*  511413 */   // Label 8535: @511413
     /*  511413 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(511481), // Rule ID 62303 //
     /*  511418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511450 */     // MIs[0] policy
     /*  511450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  511463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511477 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511479 */     GIR_RootConstrainSelectedInstOperands,
     /*  511480 */     // GIR_Coverage, 62303,
     /*  511480 */     GIR_EraseRootFromParent_Done,
     /*  511481 */   // Label 8536: @511481
     /*  511481 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(511549), // Rule ID 62304 //
     /*  511486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511518 */     // MIs[0] policy
     /*  511518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511528 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  511531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511545 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511547 */     GIR_RootConstrainSelectedInstOperands,
     /*  511548 */     // GIR_Coverage, 62304,
     /*  511548 */     GIR_EraseRootFromParent_Done,
     /*  511549 */   // Label 8537: @511549
     /*  511549 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(511617), // Rule ID 62305 //
     /*  511554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511586 */     // MIs[0] policy
     /*  511586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  511599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511613 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511615 */     GIR_RootConstrainSelectedInstOperands,
     /*  511616 */     // GIR_Coverage, 62305,
     /*  511616 */     GIR_EraseRootFromParent_Done,
     /*  511617 */   // Label 8538: @511617
     /*  511617 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(511685), // Rule ID 62306 //
     /*  511622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511654 */     // MIs[0] policy
     /*  511654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511664 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  511667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511681 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511683 */     GIR_RootConstrainSelectedInstOperands,
     /*  511684 */     // GIR_Coverage, 62306,
     /*  511684 */     GIR_EraseRootFromParent_Done,
     /*  511685 */   // Label 8539: @511685
     /*  511685 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(511753), // Rule ID 62307 //
     /*  511690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511722 */     // MIs[0] policy
     /*  511722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511732 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  511735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511749 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511751 */     GIR_RootConstrainSelectedInstOperands,
     /*  511752 */     // GIR_Coverage, 62307,
     /*  511752 */     GIR_EraseRootFromParent_Done,
     /*  511753 */   // Label 8540: @511753
     /*  511753 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(511821), // Rule ID 62308 //
     /*  511758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511790 */     // MIs[0] policy
     /*  511790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511800 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  511803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511817 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511819 */     GIR_RootConstrainSelectedInstOperands,
     /*  511820 */     // GIR_Coverage, 62308,
     /*  511820 */     GIR_EraseRootFromParent_Done,
     /*  511821 */   // Label 8541: @511821
     /*  511821 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(511889), // Rule ID 62309 //
     /*  511826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511858 */     // MIs[0] policy
     /*  511858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511868 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  511871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511885 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511887 */     GIR_RootConstrainSelectedInstOperands,
     /*  511888 */     // GIR_Coverage, 62309,
     /*  511888 */     GIR_EraseRootFromParent_Done,
     /*  511889 */   // Label 8542: @511889
     /*  511889 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(511957), // Rule ID 62310 //
     /*  511894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511926 */     // MIs[0] policy
     /*  511926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511936 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  511939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511953 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511955 */     GIR_RootConstrainSelectedInstOperands,
     /*  511956 */     // GIR_Coverage, 62310,
     /*  511956 */     GIR_EraseRootFromParent_Done,
     /*  511957 */   // Label 8543: @511957
     /*  511957 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(512025), // Rule ID 62311 //
     /*  511962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511994 */     // MIs[0] policy
     /*  511994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512004 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  512007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512021 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512023 */     GIR_RootConstrainSelectedInstOperands,
     /*  512024 */     // GIR_Coverage, 62311,
     /*  512024 */     GIR_EraseRootFromParent_Done,
     /*  512025 */   // Label 8544: @512025
     /*  512025 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(512093), // Rule ID 62406 //
     /*  512030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  512041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  512044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512062 */     // MIs[0] policy
     /*  512062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512072 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  512075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512089 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512091 */     GIR_RootConstrainSelectedInstOperands,
     /*  512092 */     // GIR_Coverage, 62406,
     /*  512092 */     GIR_EraseRootFromParent_Done,
     /*  512093 */   // Label 8545: @512093
     /*  512093 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(512161), // Rule ID 62407 //
     /*  512098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  512109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  512112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512130 */     // MIs[0] policy
     /*  512130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  512143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512157 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512159 */     GIR_RootConstrainSelectedInstOperands,
     /*  512160 */     // GIR_Coverage, 62407,
     /*  512160 */     GIR_EraseRootFromParent_Done,
     /*  512161 */   // Label 8546: @512161
     /*  512161 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(512229), // Rule ID 62408 //
     /*  512166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512198 */     // MIs[0] policy
     /*  512198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512208 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  512211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512225 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512227 */     GIR_RootConstrainSelectedInstOperands,
     /*  512228 */     // GIR_Coverage, 62408,
     /*  512228 */     GIR_EraseRootFromParent_Done,
     /*  512229 */   // Label 8547: @512229
     /*  512229 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(512297), // Rule ID 62409 //
     /*  512234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512266 */     // MIs[0] policy
     /*  512266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512276 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  512279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512293 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512295 */     GIR_RootConstrainSelectedInstOperands,
     /*  512296 */     // GIR_Coverage, 62409,
     /*  512296 */     GIR_EraseRootFromParent_Done,
     /*  512297 */   // Label 8548: @512297
     /*  512297 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(512365), // Rule ID 62410 //
     /*  512302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512334 */     // MIs[0] policy
     /*  512334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  512347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512361 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512363 */     GIR_RootConstrainSelectedInstOperands,
     /*  512364 */     // GIR_Coverage, 62410,
     /*  512364 */     GIR_EraseRootFromParent_Done,
     /*  512365 */   // Label 8549: @512365
     /*  512365 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(512433), // Rule ID 62411 //
     /*  512370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512402 */     // MIs[0] policy
     /*  512402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  512415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512429 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512431 */     GIR_RootConstrainSelectedInstOperands,
     /*  512432 */     // GIR_Coverage, 62411,
     /*  512432 */     GIR_EraseRootFromParent_Done,
     /*  512433 */   // Label 8550: @512433
     /*  512433 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(512501), // Rule ID 62412 //
     /*  512438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  512455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512470 */     // MIs[0] policy
     /*  512470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512480 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  512483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512497 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512499 */     GIR_RootConstrainSelectedInstOperands,
     /*  512500 */     // GIR_Coverage, 62412,
     /*  512500 */     GIR_EraseRootFromParent_Done,
     /*  512501 */   // Label 8551: @512501
     /*  512501 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(512569), // Rule ID 62413 //
     /*  512506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  512523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512538 */     // MIs[0] policy
     /*  512538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512548 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  512551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512565 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512567 */     GIR_RootConstrainSelectedInstOperands,
     /*  512568 */     // GIR_Coverage, 62413,
     /*  512568 */     GIR_EraseRootFromParent_Done,
     /*  512569 */   // Label 8552: @512569
     /*  512569 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(512637), // Rule ID 62414 //
     /*  512574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  512585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  512588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  512591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512606 */     // MIs[0] policy
     /*  512606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512616 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  512619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512633 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512635 */     GIR_RootConstrainSelectedInstOperands,
     /*  512636 */     // GIR_Coverage, 62414,
     /*  512636 */     GIR_EraseRootFromParent_Done,
     /*  512637 */   // Label 8553: @512637
     /*  512637 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(512705), // Rule ID 62415 //
     /*  512642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  512653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  512656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  512659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512674 */     // MIs[0] policy
     /*  512674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512684 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  512687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512701 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512703 */     GIR_RootConstrainSelectedInstOperands,
     /*  512704 */     // GIR_Coverage, 62415,
     /*  512704 */     GIR_EraseRootFromParent_Done,
     /*  512705 */   // Label 8554: @512705
     /*  512705 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(512773), // Rule ID 62416 //
     /*  512710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  512721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  512724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512742 */     // MIs[0] policy
     /*  512742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512752 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  512755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512769 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512771 */     GIR_RootConstrainSelectedInstOperands,
     /*  512772 */     // GIR_Coverage, 62416,
     /*  512772 */     GIR_EraseRootFromParent_Done,
     /*  512773 */   // Label 8555: @512773
     /*  512773 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(512841), // Rule ID 62417 //
     /*  512778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  512789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  512792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512810 */     // MIs[0] policy
     /*  512810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512820 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  512823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512837 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512839 */     GIR_RootConstrainSelectedInstOperands,
     /*  512840 */     // GIR_Coverage, 62417,
     /*  512840 */     GIR_EraseRootFromParent_Done,
     /*  512841 */   // Label 8556: @512841
     /*  512841 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(512909), // Rule ID 62418 //
     /*  512846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512878 */     // MIs[0] policy
     /*  512878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  512891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512905 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512907 */     GIR_RootConstrainSelectedInstOperands,
     /*  512908 */     // GIR_Coverage, 62418,
     /*  512908 */     GIR_EraseRootFromParent_Done,
     /*  512909 */   // Label 8557: @512909
     /*  512909 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(512977), // Rule ID 62419 //
     /*  512914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512946 */     // MIs[0] policy
     /*  512946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512956 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  512959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512973 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512975 */     GIR_RootConstrainSelectedInstOperands,
     /*  512976 */     // GIR_Coverage, 62419,
     /*  512976 */     GIR_EraseRootFromParent_Done,
     /*  512977 */   // Label 8558: @512977
     /*  512977 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(513045), // Rule ID 62420 //
     /*  512982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513014 */     // MIs[0] policy
     /*  513014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513024 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  513027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513041 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513043 */     GIR_RootConstrainSelectedInstOperands,
     /*  513044 */     // GIR_Coverage, 62420,
     /*  513044 */     GIR_EraseRootFromParent_Done,
     /*  513045 */   // Label 8559: @513045
     /*  513045 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(513113), // Rule ID 62421 //
     /*  513050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  513061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  513064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513082 */     // MIs[0] policy
     /*  513082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513092 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  513095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513109 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513111 */     GIR_RootConstrainSelectedInstOperands,
     /*  513112 */     // GIR_Coverage, 62421,
     /*  513112 */     GIR_EraseRootFromParent_Done,
     /*  513113 */   // Label 8560: @513113
     /*  513113 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(513181), // Rule ID 62422 //
     /*  513118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513150 */     // MIs[0] policy
     /*  513150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  513163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513177 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513179 */     GIR_RootConstrainSelectedInstOperands,
     /*  513180 */     // GIR_Coverage, 62422,
     /*  513180 */     GIR_EraseRootFromParent_Done,
     /*  513181 */   // Label 8561: @513181
     /*  513181 */   GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(513249), // Rule ID 62423 //
     /*  513186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513218 */     // MIs[0] policy
     /*  513218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  513231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513245 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513247 */     GIR_RootConstrainSelectedInstOperands,
     /*  513248 */     // GIR_Coverage, 62423,
     /*  513248 */     GIR_EraseRootFromParent_Done,
     /*  513249 */   // Label 8562: @513249
     /*  513249 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(513317), // Rule ID 62424 //
     /*  513254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513286 */     // MIs[0] policy
     /*  513286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  513299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513313 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513315 */     GIR_RootConstrainSelectedInstOperands,
     /*  513316 */     // GIR_Coverage, 62424,
     /*  513316 */     GIR_EraseRootFromParent_Done,
     /*  513317 */   // Label 8563: @513317
     /*  513317 */   GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(513385), // Rule ID 62425 //
     /*  513322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513354 */     // MIs[0] policy
     /*  513354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  513367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513381 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513383 */     GIR_RootConstrainSelectedInstOperands,
     /*  513384 */     // GIR_Coverage, 62425,
     /*  513384 */     GIR_EraseRootFromParent_Done,
     /*  513385 */   // Label 8564: @513385
     /*  513385 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(513453), // Rule ID 62426 //
     /*  513390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513422 */     // MIs[0] policy
     /*  513422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  513435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513449 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513451 */     GIR_RootConstrainSelectedInstOperands,
     /*  513452 */     // GIR_Coverage, 62426,
     /*  513452 */     GIR_EraseRootFromParent_Done,
     /*  513453 */   // Label 8565: @513453
     /*  513453 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(513521), // Rule ID 62427 //
     /*  513458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513490 */     // MIs[0] policy
     /*  513490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  513503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513517 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513519 */     GIR_RootConstrainSelectedInstOperands,
     /*  513520 */     // GIR_Coverage, 62427,
     /*  513520 */     GIR_EraseRootFromParent_Done,
     /*  513521 */   // Label 8566: @513521
     /*  513521 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(513589), // Rule ID 62428 //
     /*  513526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513558 */     // MIs[0] policy
     /*  513558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  513571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513585 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513587 */     GIR_RootConstrainSelectedInstOperands,
     /*  513588 */     // GIR_Coverage, 62428,
     /*  513588 */     GIR_EraseRootFromParent_Done,
     /*  513589 */   // Label 8567: @513589
     /*  513589 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(513657), // Rule ID 62429 //
     /*  513594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513626 */     // MIs[0] policy
     /*  513626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513636 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  513639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513653 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513655 */     GIR_RootConstrainSelectedInstOperands,
     /*  513656 */     // GIR_Coverage, 62429,
     /*  513656 */     GIR_EraseRootFromParent_Done,
     /*  513657 */   // Label 8568: @513657
     /*  513657 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(513725), // Rule ID 62430 //
     /*  513662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513694 */     // MIs[0] policy
     /*  513694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513704 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  513707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513721 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513723 */     GIR_RootConstrainSelectedInstOperands,
     /*  513724 */     // GIR_Coverage, 62430,
     /*  513724 */     GIR_EraseRootFromParent_Done,
     /*  513725 */   // Label 8569: @513725
     /*  513725 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(513793), // Rule ID 62431 //
     /*  513730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513762 */     // MIs[0] policy
     /*  513762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513772 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  513775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513789 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513791 */     GIR_RootConstrainSelectedInstOperands,
     /*  513792 */     // GIR_Coverage, 62431,
     /*  513792 */     GIR_EraseRootFromParent_Done,
     /*  513793 */   // Label 8570: @513793
     /*  513793 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(513861), // Rule ID 62432 //
     /*  513798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513830 */     // MIs[0] policy
     /*  513830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  513843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513857 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513859 */     GIR_RootConstrainSelectedInstOperands,
     /*  513860 */     // GIR_Coverage, 62432,
     /*  513860 */     GIR_EraseRootFromParent_Done,
     /*  513861 */   // Label 8571: @513861
     /*  513861 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(513929), // Rule ID 62433 //
     /*  513866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513898 */     // MIs[0] policy
     /*  513898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  513911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513925 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513927 */     GIR_RootConstrainSelectedInstOperands,
     /*  513928 */     // GIR_Coverage, 62433,
     /*  513928 */     GIR_EraseRootFromParent_Done,
     /*  513929 */   // Label 8572: @513929
     /*  513929 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(513997), // Rule ID 62434 //
     /*  513934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513966 */     // MIs[0] policy
     /*  513966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  513979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513993 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513995 */     GIR_RootConstrainSelectedInstOperands,
     /*  513996 */     // GIR_Coverage, 62434,
     /*  513996 */     GIR_EraseRootFromParent_Done,
     /*  513997 */   // Label 8573: @513997
     /*  513997 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(514065), // Rule ID 62435 //
     /*  514002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  514005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514034 */     // MIs[0] policy
     /*  514034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514044 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  514047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514061 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514063 */     GIR_RootConstrainSelectedInstOperands,
     /*  514064 */     // GIR_Coverage, 62435,
     /*  514064 */     GIR_EraseRootFromParent_Done,
     /*  514065 */   // Label 8574: @514065
     /*  514065 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(514133), // Rule ID 62436 //
     /*  514070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  514073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514102 */     // MIs[0] policy
     /*  514102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  514115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514129 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514131 */     GIR_RootConstrainSelectedInstOperands,
     /*  514132 */     // GIR_Coverage, 62436,
     /*  514132 */     GIR_EraseRootFromParent_Done,
     /*  514133 */   // Label 8575: @514133
     /*  514133 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(514201), // Rule ID 62437 //
     /*  514138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  514141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514170 */     // MIs[0] policy
     /*  514170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514180 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  514183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514197 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514199 */     GIR_RootConstrainSelectedInstOperands,
     /*  514200 */     // GIR_Coverage, 62437,
     /*  514200 */     GIR_EraseRootFromParent_Done,
     /*  514201 */   // Label 8576: @514201
     /*  514201 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(514269), // Rule ID 62438 //
     /*  514206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  514209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514238 */     // MIs[0] policy
     /*  514238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  514251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514265 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514267 */     GIR_RootConstrainSelectedInstOperands,
     /*  514268 */     // GIR_Coverage, 62438,
     /*  514268 */     GIR_EraseRootFromParent_Done,
     /*  514269 */   // Label 8577: @514269
     /*  514269 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(514337), // Rule ID 62439 //
     /*  514274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  514277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514306 */     // MIs[0] policy
     /*  514306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514316 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  514319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514333 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514335 */     GIR_RootConstrainSelectedInstOperands,
     /*  514336 */     // GIR_Coverage, 62439,
     /*  514336 */     GIR_EraseRootFromParent_Done,
     /*  514337 */   // Label 8578: @514337
     /*  514337 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(514405), // Rule ID 62440 //
     /*  514342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  514345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  514359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514374 */     // MIs[0] policy
     /*  514374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514384 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  514387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514401 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514403 */     GIR_RootConstrainSelectedInstOperands,
     /*  514404 */     // GIR_Coverage, 62440,
     /*  514404 */     GIR_EraseRootFromParent_Done,
     /*  514405 */   // Label 8579: @514405
     /*  514405 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(514473), // Rule ID 62441 //
     /*  514410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  514413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  514427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514442 */     // MIs[0] policy
     /*  514442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514452 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  514455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514469 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514471 */     GIR_RootConstrainSelectedInstOperands,
     /*  514472 */     // GIR_Coverage, 62441,
     /*  514472 */     GIR_EraseRootFromParent_Done,
     /*  514473 */   // Label 8580: @514473
     /*  514473 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(514541), // Rule ID 62442 //
     /*  514478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  514481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514510 */     // MIs[0] policy
     /*  514510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514520 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  514523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514537 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514539 */     GIR_RootConstrainSelectedInstOperands,
     /*  514540 */     // GIR_Coverage, 62442,
     /*  514540 */     GIR_EraseRootFromParent_Done,
     /*  514541 */   // Label 8581: @514541
     /*  514541 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(514609), // Rule ID 62443 //
     /*  514546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  514549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514578 */     // MIs[0] policy
     /*  514578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514588 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  514591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514605 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514607 */     GIR_RootConstrainSelectedInstOperands,
     /*  514608 */     // GIR_Coverage, 62443,
     /*  514608 */     GIR_EraseRootFromParent_Done,
     /*  514609 */   // Label 8582: @514609
     /*  514609 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(514680), // Rule ID 2718 //
     /*  514614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514646 */     // MIs[0] round
     /*  514646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514656 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  514659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514665 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514678 */     GIR_RootConstrainSelectedInstOperands,
     /*  514679 */     // GIR_Coverage, 2718,
     /*  514679 */     GIR_EraseRootFromParent_Done,
     /*  514680 */   // Label 8583: @514680
     /*  514680 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(514751), // Rule ID 2719 //
     /*  514685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514717 */     // MIs[0] round
     /*  514717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514727 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  514730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514736 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514749 */     GIR_RootConstrainSelectedInstOperands,
     /*  514750 */     // GIR_Coverage, 2719,
     /*  514750 */     GIR_EraseRootFromParent_Done,
     /*  514751 */   // Label 8584: @514751
     /*  514751 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(514822), // Rule ID 2754 //
     /*  514756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  514759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  514764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514788 */     // MIs[0] round
     /*  514788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514798 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  514801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514807 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514820 */     GIR_RootConstrainSelectedInstOperands,
     /*  514821 */     // GIR_Coverage, 2754,
     /*  514821 */     GIR_EraseRootFromParent_Done,
     /*  514822 */   // Label 8585: @514822
     /*  514822 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(514893), // Rule ID 2755 //
     /*  514827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  514830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  514835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514859 */     // MIs[0] round
     /*  514859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514869 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  514872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514878 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514891 */     GIR_RootConstrainSelectedInstOperands,
     /*  514892 */     // GIR_Coverage, 2755,
     /*  514892 */     GIR_EraseRootFromParent_Done,
     /*  514893 */   // Label 8586: @514893
     /*  514893 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(514964), // Rule ID 19012 //
     /*  514898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  514909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  514912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  514915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514930 */     // MIs[0] round
     /*  514930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514940 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  514943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514949 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514962 */     GIR_RootConstrainSelectedInstOperands,
     /*  514963 */     // GIR_Coverage, 19012,
     /*  514963 */     GIR_EraseRootFromParent_Done,
     /*  514964 */   // Label 8587: @514964
     /*  514964 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(515035), // Rule ID 19013 //
     /*  514969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  514980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  514983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  514986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515001 */     // MIs[0] round
     /*  515001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515011 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  515014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515020 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515033 */     GIR_RootConstrainSelectedInstOperands,
     /*  515034 */     // GIR_Coverage, 19013,
     /*  515034 */     GIR_EraseRootFromParent_Done,
     /*  515035 */   // Label 8588: @515035
     /*  515035 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(515106), // Rule ID 19016 //
     /*  515040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  515051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  515054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  515057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515072 */     // MIs[0] round
     /*  515072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515082 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  515085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515091 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515104 */     GIR_RootConstrainSelectedInstOperands,
     /*  515105 */     // GIR_Coverage, 19016,
     /*  515105 */     GIR_EraseRootFromParent_Done,
     /*  515106 */   // Label 8589: @515106
     /*  515106 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(515177), // Rule ID 19017 //
     /*  515111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  515122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  515125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  515128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515143 */     // MIs[0] round
     /*  515143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515153 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  515156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515162 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515175 */     GIR_RootConstrainSelectedInstOperands,
     /*  515176 */     // GIR_Coverage, 19017,
     /*  515176 */     GIR_EraseRootFromParent_Done,
     /*  515177 */   // Label 8590: @515177
     /*  515177 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(515248), // Rule ID 19020 //
     /*  515182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  515193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  515196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  515199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515214 */     // MIs[0] round
     /*  515214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515224 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  515227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515233 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515246 */     GIR_RootConstrainSelectedInstOperands,
     /*  515247 */     // GIR_Coverage, 19020,
     /*  515247 */     GIR_EraseRootFromParent_Done,
     /*  515248 */   // Label 8591: @515248
     /*  515248 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(515319), // Rule ID 19021 //
     /*  515253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  515264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  515267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  515270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515285 */     // MIs[0] round
     /*  515285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515295 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  515298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515304 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515317 */     GIR_RootConstrainSelectedInstOperands,
     /*  515318 */     // GIR_Coverage, 19021,
     /*  515318 */     GIR_EraseRootFromParent_Done,
     /*  515319 */   // Label 8592: @515319
     /*  515319 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(515390), // Rule ID 19024 //
     /*  515324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  515335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  515338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515356 */     // MIs[0] round
     /*  515356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515366 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  515369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515375 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515388 */     GIR_RootConstrainSelectedInstOperands,
     /*  515389 */     // GIR_Coverage, 19024,
     /*  515389 */     GIR_EraseRootFromParent_Done,
     /*  515390 */   // Label 8593: @515390
     /*  515390 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(515461), // Rule ID 19025 //
     /*  515395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  515406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  515409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515427 */     // MIs[0] round
     /*  515427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515437 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  515440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515446 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515459 */     GIR_RootConstrainSelectedInstOperands,
     /*  515460 */     // GIR_Coverage, 19025,
     /*  515460 */     GIR_EraseRootFromParent_Done,
     /*  515461 */   // Label 8594: @515461
     /*  515461 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(515532), // Rule ID 19028 //
     /*  515466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  515469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  515477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  515480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  515483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515498 */     // MIs[0] round
     /*  515498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515508 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  515508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  515511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515517 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515530 */     GIR_RootConstrainSelectedInstOperands,
     /*  515531 */     // GIR_Coverage, 19028,
     /*  515531 */     GIR_EraseRootFromParent_Done,
     /*  515532 */   // Label 8595: @515532
     /*  515532 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(515603), // Rule ID 19029 //
     /*  515537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  515540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  515548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  515551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  515554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515569 */     // MIs[0] round
     /*  515569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515579 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  515579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  515582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515588 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515601 */     GIR_RootConstrainSelectedInstOperands,
     /*  515602 */     // GIR_Coverage, 19029,
     /*  515602 */     GIR_EraseRootFromParent_Done,
     /*  515603 */   // Label 8596: @515603
     /*  515603 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(515674), // Rule ID 19032 //
     /*  515608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  515619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  515622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  515625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515640 */     // MIs[0] round
     /*  515640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515650 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  515653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515659 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515672 */     GIR_RootConstrainSelectedInstOperands,
     /*  515673 */     // GIR_Coverage, 19032,
     /*  515673 */     GIR_EraseRootFromParent_Done,
     /*  515674 */   // Label 8597: @515674
     /*  515674 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(515745), // Rule ID 19033 //
     /*  515679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  515690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  515693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  515696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515711 */     // MIs[0] round
     /*  515711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515721 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  515724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515730 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515743 */     GIR_RootConstrainSelectedInstOperands,
     /*  515744 */     // GIR_Coverage, 19033,
     /*  515744 */     GIR_EraseRootFromParent_Done,
     /*  515745 */   // Label 8598: @515745
     /*  515745 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(515816), // Rule ID 19036 //
     /*  515750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  515761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  515764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  515767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515782 */     // MIs[0] round
     /*  515782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515792 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  515795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515801 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515814 */     GIR_RootConstrainSelectedInstOperands,
     /*  515815 */     // GIR_Coverage, 19036,
     /*  515815 */     GIR_EraseRootFromParent_Done,
     /*  515816 */   // Label 8599: @515816
     /*  515816 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(515887), // Rule ID 19037 //
     /*  515821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  515832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  515835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  515838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515853 */     // MIs[0] round
     /*  515853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515863 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  515866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515872 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515885 */     GIR_RootConstrainSelectedInstOperands,
     /*  515886 */     // GIR_Coverage, 19037,
     /*  515886 */     GIR_EraseRootFromParent_Done,
     /*  515887 */   // Label 8600: @515887
     /*  515887 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(515958), // Rule ID 19040 //
     /*  515892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  515903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  515906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  515909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515924 */     // MIs[0] round
     /*  515924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515934 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  515937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515943 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515956 */     GIR_RootConstrainSelectedInstOperands,
     /*  515957 */     // GIR_Coverage, 19040,
     /*  515957 */     GIR_EraseRootFromParent_Done,
     /*  515958 */   // Label 8601: @515958
     /*  515958 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(516029), // Rule ID 19041 //
     /*  515963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  515974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  515977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  515980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515995 */     // MIs[0] round
     /*  515995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516005 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  516008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516014 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516027 */     GIR_RootConstrainSelectedInstOperands,
     /*  516028 */     // GIR_Coverage, 19041,
     /*  516028 */     GIR_EraseRootFromParent_Done,
     /*  516029 */   // Label 8602: @516029
     /*  516029 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(516100), // Rule ID 19044 //
     /*  516034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  516037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  516051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516066 */     // MIs[0] round
     /*  516066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516076 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  516076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  516079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516085 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516098 */     GIR_RootConstrainSelectedInstOperands,
     /*  516099 */     // GIR_Coverage, 19044,
     /*  516099 */     GIR_EraseRootFromParent_Done,
     /*  516100 */   // Label 8603: @516100
     /*  516100 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(516171), // Rule ID 19045 //
     /*  516105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  516108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  516122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516137 */     // MIs[0] round
     /*  516137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516147 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  516147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  516150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516156 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516169 */     GIR_RootConstrainSelectedInstOperands,
     /*  516170 */     // GIR_Coverage, 19045,
     /*  516170 */     GIR_EraseRootFromParent_Done,
     /*  516171 */   // Label 8604: @516171
     /*  516171 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(516242), // Rule ID 19048 //
     /*  516176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  516179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  516187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  516190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  516193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516208 */     // MIs[0] round
     /*  516208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516218 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  516218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  516221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516227 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516240 */     GIR_RootConstrainSelectedInstOperands,
     /*  516241 */     // GIR_Coverage, 19048,
     /*  516241 */     GIR_EraseRootFromParent_Done,
     /*  516242 */   // Label 8605: @516242
     /*  516242 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(516313), // Rule ID 19049 //
     /*  516247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  516250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  516258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  516261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  516264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516279 */     // MIs[0] round
     /*  516279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516289 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  516289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  516292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516298 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516311 */     GIR_RootConstrainSelectedInstOperands,
     /*  516312 */     // GIR_Coverage, 19049,
     /*  516312 */     GIR_EraseRootFromParent_Done,
     /*  516313 */   // Label 8606: @516313
     /*  516313 */   GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(516384), // Rule ID 19052 //
     /*  516318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  516321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  516329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  516332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  516335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516350 */     // MIs[0] round
     /*  516350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516360 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  516360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  516363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516369 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516382 */     GIR_RootConstrainSelectedInstOperands,
     /*  516383 */     // GIR_Coverage, 19052,
     /*  516383 */     GIR_EraseRootFromParent_Done,
     /*  516384 */   // Label 8607: @516384
     /*  516384 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(516455), // Rule ID 19053 //
     /*  516389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  516392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  516400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  516403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  516406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516421 */     // MIs[0] round
     /*  516421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516431 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  516431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  516434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516440 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516453 */     GIR_RootConstrainSelectedInstOperands,
     /*  516454 */     // GIR_Coverage, 19053,
     /*  516454 */     GIR_EraseRootFromParent_Done,
     /*  516455 */   // Label 8608: @516455
     /*  516455 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(516526), // Rule ID 19056 //
     /*  516460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  516463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  516471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  516474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  516477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516492 */     // MIs[0] round
     /*  516492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516502 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  516505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516511 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516524 */     GIR_RootConstrainSelectedInstOperands,
     /*  516525 */     // GIR_Coverage, 19056,
     /*  516525 */     GIR_EraseRootFromParent_Done,
     /*  516526 */   // Label 8609: @516526
     /*  516526 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(516597), // Rule ID 19057 //
     /*  516531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  516542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  516545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  516548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516563 */     // MIs[0] round
     /*  516563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516573 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  516576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516582 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516595 */     GIR_RootConstrainSelectedInstOperands,
     /*  516596 */     // GIR_Coverage, 19057,
     /*  516596 */     GIR_EraseRootFromParent_Done,
     /*  516597 */   // Label 8610: @516597
     /*  516597 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(516668), // Rule ID 19060 //
     /*  516602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  516605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  516613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  516616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  516619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516634 */     // MIs[0] round
     /*  516634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516644 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  516647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516653 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516666 */     GIR_RootConstrainSelectedInstOperands,
     /*  516667 */     // GIR_Coverage, 19060,
     /*  516667 */     GIR_EraseRootFromParent_Done,
     /*  516668 */   // Label 8611: @516668
     /*  516668 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(516739), // Rule ID 19061 //
     /*  516673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  516684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  516687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  516690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516705 */     // MIs[0] round
     /*  516705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516715 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  516718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516724 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516737 */     GIR_RootConstrainSelectedInstOperands,
     /*  516738 */     // GIR_Coverage, 19061,
     /*  516738 */     GIR_EraseRootFromParent_Done,
     /*  516739 */   // Label 8612: @516739
     /*  516739 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(516810), // Rule ID 19064 //
     /*  516744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  516747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  516755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  516758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  516761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516776 */     // MIs[0] round
     /*  516776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516786 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  516789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516795 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516808 */     GIR_RootConstrainSelectedInstOperands,
     /*  516809 */     // GIR_Coverage, 19064,
     /*  516809 */     GIR_EraseRootFromParent_Done,
     /*  516810 */   // Label 8613: @516810
     /*  516810 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(516881), // Rule ID 19065 //
     /*  516815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  516826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  516829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  516832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516847 */     // MIs[0] round
     /*  516847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516857 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  516860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516866 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516879 */     GIR_RootConstrainSelectedInstOperands,
     /*  516880 */     // GIR_Coverage, 19065,
     /*  516880 */     GIR_EraseRootFromParent_Done,
     /*  516881 */   // Label 8614: @516881
     /*  516881 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(516952), // Rule ID 19124 //
     /*  516886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  516889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  516897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  516900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  516903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516918 */     // MIs[0] round
     /*  516918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516928 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  516928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  516931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516937 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516950 */     GIR_RootConstrainSelectedInstOperands,
     /*  516951 */     // GIR_Coverage, 19124,
     /*  516951 */     GIR_EraseRootFromParent_Done,
     /*  516952 */   // Label 8615: @516952
     /*  516952 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(517023), // Rule ID 19125 //
     /*  516957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  516960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  516968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  516971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  516974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516989 */     // MIs[0] round
     /*  516989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516999 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  517002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517008 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517021 */     GIR_RootConstrainSelectedInstOperands,
     /*  517022 */     // GIR_Coverage, 19125,
     /*  517022 */     GIR_EraseRootFromParent_Done,
     /*  517023 */   // Label 8616: @517023
     /*  517023 */   GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(517094), // Rule ID 19128 //
     /*  517028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  517039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  517042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  517045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517060 */     // MIs[0] round
     /*  517060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517070 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  517073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517079 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517092 */     GIR_RootConstrainSelectedInstOperands,
     /*  517093 */     // GIR_Coverage, 19128,
     /*  517093 */     GIR_EraseRootFromParent_Done,
     /*  517094 */   // Label 8617: @517094
     /*  517094 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(517165), // Rule ID 19129 //
     /*  517099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  517110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  517113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  517116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517131 */     // MIs[0] round
     /*  517131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517141 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  517144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517150 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517163 */     GIR_RootConstrainSelectedInstOperands,
     /*  517164 */     // GIR_Coverage, 19129,
     /*  517164 */     GIR_EraseRootFromParent_Done,
     /*  517165 */   // Label 8618: @517165
     /*  517165 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(517236), // Rule ID 19132 //
     /*  517170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  517181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  517184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  517187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517202 */     // MIs[0] round
     /*  517202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517212 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  517215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517221 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517234 */     GIR_RootConstrainSelectedInstOperands,
     /*  517235 */     // GIR_Coverage, 19132,
     /*  517235 */     GIR_EraseRootFromParent_Done,
     /*  517236 */   // Label 8619: @517236
     /*  517236 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(517307), // Rule ID 19133 //
     /*  517241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  517252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  517255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  517258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517273 */     // MIs[0] round
     /*  517273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517283 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  517286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517292 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517305 */     GIR_RootConstrainSelectedInstOperands,
     /*  517306 */     // GIR_Coverage, 19133,
     /*  517306 */     GIR_EraseRootFromParent_Done,
     /*  517307 */   // Label 8620: @517307
     /*  517307 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(517378), // Rule ID 19136 //
     /*  517312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  517323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  517326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  517329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517344 */     // MIs[0] round
     /*  517344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517354 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11306:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  517357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517363 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517376 */     GIR_RootConstrainSelectedInstOperands,
     /*  517377 */     // GIR_Coverage, 19136,
     /*  517377 */     GIR_EraseRootFromParent_Done,
     /*  517378 */   // Label 8621: @517378
     /*  517378 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(517449), // Rule ID 19137 //
     /*  517383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  517394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  517397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  517400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517415 */     // MIs[0] round
     /*  517415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517425 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11306:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  517428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517434 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517447 */     GIR_RootConstrainSelectedInstOperands,
     /*  517448 */     // GIR_Coverage, 19137,
     /*  517448 */     GIR_EraseRootFromParent_Done,
     /*  517449 */   // Label 8622: @517449
     /*  517449 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(517520), // Rule ID 19140 //
     /*  517454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  517465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  517468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517486 */     // MIs[0] round
     /*  517486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517496 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  517499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517505 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517518 */     GIR_RootConstrainSelectedInstOperands,
     /*  517519 */     // GIR_Coverage, 19140,
     /*  517519 */     GIR_EraseRootFromParent_Done,
     /*  517520 */   // Label 8623: @517520
     /*  517520 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(517591), // Rule ID 19141 //
     /*  517525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  517536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  517539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517557 */     // MIs[0] round
     /*  517557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517567 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  517570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517576 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517589 */     GIR_RootConstrainSelectedInstOperands,
     /*  517590 */     // GIR_Coverage, 19141,
     /*  517590 */     GIR_EraseRootFromParent_Done,
     /*  517591 */   // Label 8624: @517591
     /*  517591 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(517662), // Rule ID 19144 //
     /*  517596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  517599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  517607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  517610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  517613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517628 */     // MIs[0] round
     /*  517628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517638 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  517638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  517641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517647 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517660 */     GIR_RootConstrainSelectedInstOperands,
     /*  517661 */     // GIR_Coverage, 19144,
     /*  517661 */     GIR_EraseRootFromParent_Done,
     /*  517662 */   // Label 8625: @517662
     /*  517662 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(517733), // Rule ID 19145 //
     /*  517667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  517670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  517678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  517681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  517684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517699 */     // MIs[0] round
     /*  517699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517709 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  517709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  517712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517718 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517731 */     GIR_RootConstrainSelectedInstOperands,
     /*  517732 */     // GIR_Coverage, 19145,
     /*  517732 */     GIR_EraseRootFromParent_Done,
     /*  517733 */   // Label 8626: @517733
     /*  517733 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(517804), // Rule ID 19148 //
     /*  517738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  517749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  517752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  517755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517770 */     // MIs[0] round
     /*  517770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517780 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  517783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517789 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517802 */     GIR_RootConstrainSelectedInstOperands,
     /*  517803 */     // GIR_Coverage, 19148,
     /*  517803 */     GIR_EraseRootFromParent_Done,
     /*  517804 */   // Label 8627: @517804
     /*  517804 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(517875), // Rule ID 19149 //
     /*  517809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  517820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  517823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  517826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517841 */     // MIs[0] round
     /*  517841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517851 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  517854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517860 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517873 */     GIR_RootConstrainSelectedInstOperands,
     /*  517874 */     // GIR_Coverage, 19149,
     /*  517874 */     GIR_EraseRootFromParent_Done,
     /*  517875 */   // Label 8628: @517875
     /*  517875 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(517946), // Rule ID 19152 //
     /*  517880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  517891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  517894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  517897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517912 */     // MIs[0] round
     /*  517912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517922 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  517925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517931 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517944 */     GIR_RootConstrainSelectedInstOperands,
     /*  517945 */     // GIR_Coverage, 19152,
     /*  517945 */     GIR_EraseRootFromParent_Done,
     /*  517946 */   // Label 8629: @517946
     /*  517946 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(518017), // Rule ID 19153 //
     /*  517951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  517962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  517965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  517968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517983 */     // MIs[0] round
     /*  517983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517993 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  517996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518002 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518015 */     GIR_RootConstrainSelectedInstOperands,
     /*  518016 */     // GIR_Coverage, 19153,
     /*  518016 */     GIR_EraseRootFromParent_Done,
     /*  518017 */   // Label 8630: @518017
     /*  518017 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(518088), // Rule ID 19156 //
     /*  518022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  518025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  518033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  518036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  518039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518054 */     // MIs[0] round
     /*  518054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518064 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  518067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518073 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518086 */     GIR_RootConstrainSelectedInstOperands,
     /*  518087 */     // GIR_Coverage, 19156,
     /*  518087 */     GIR_EraseRootFromParent_Done,
     /*  518088 */   // Label 8631: @518088
     /*  518088 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(518159), // Rule ID 19157 //
     /*  518093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  518096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  518104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  518107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  518110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518125 */     // MIs[0] round
     /*  518125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518135 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  518138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518144 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518157 */     GIR_RootConstrainSelectedInstOperands,
     /*  518158 */     // GIR_Coverage, 19157,
     /*  518158 */     GIR_EraseRootFromParent_Done,
     /*  518159 */   // Label 8632: @518159
     /*  518159 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(518230), // Rule ID 19160 //
     /*  518164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  518167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  518175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  518178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  518181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518196 */     // MIs[0] round
     /*  518196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518206 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  518209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518215 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518228 */     GIR_RootConstrainSelectedInstOperands,
     /*  518229 */     // GIR_Coverage, 19160,
     /*  518229 */     GIR_EraseRootFromParent_Done,
     /*  518230 */   // Label 8633: @518230
     /*  518230 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(518301), // Rule ID 19161 //
     /*  518235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  518238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  518246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  518249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  518252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518267 */     // MIs[0] round
     /*  518267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518277 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  518280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518286 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518299 */     GIR_RootConstrainSelectedInstOperands,
     /*  518300 */     // GIR_Coverage, 19161,
     /*  518300 */     GIR_EraseRootFromParent_Done,
     /*  518301 */   // Label 8634: @518301
     /*  518301 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(518372), // Rule ID 19164 //
     /*  518306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  518309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  518317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  518320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  518323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518338 */     // MIs[0] round
     /*  518338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518348 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  518351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518357 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518370 */     GIR_RootConstrainSelectedInstOperands,
     /*  518371 */     // GIR_Coverage, 19164,
     /*  518371 */     GIR_EraseRootFromParent_Done,
     /*  518372 */   // Label 8635: @518372
     /*  518372 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(518443), // Rule ID 19165 //
     /*  518377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  518380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  518388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  518391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  518394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518409 */     // MIs[0] round
     /*  518409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518419 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  518422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518428 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518441 */     GIR_RootConstrainSelectedInstOperands,
     /*  518442 */     // GIR_Coverage, 19165,
     /*  518442 */     GIR_EraseRootFromParent_Done,
     /*  518443 */   // Label 8636: @518443
     /*  518443 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(518514), // Rule ID 19168 //
     /*  518448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  518451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  518459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  518462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  518465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518480 */     // MIs[0] round
     /*  518480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518490 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  518493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518499 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518512 */     GIR_RootConstrainSelectedInstOperands,
     /*  518513 */     // GIR_Coverage, 19168,
     /*  518513 */     GIR_EraseRootFromParent_Done,
     /*  518514 */   // Label 8637: @518514
     /*  518514 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(518585), // Rule ID 19169 //
     /*  518519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  518522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  518530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  518533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  518536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518551 */     // MIs[0] round
     /*  518551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518561 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  518564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518570 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518583 */     GIR_RootConstrainSelectedInstOperands,
     /*  518584 */     // GIR_Coverage, 19169,
     /*  518584 */     GIR_EraseRootFromParent_Done,
     /*  518585 */   // Label 8638: @518585
     /*  518585 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(518656), // Rule ID 19172 //
     /*  518590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  518601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  518604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  518607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518622 */     // MIs[0] round
     /*  518622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518632 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  518635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518641 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518654 */     GIR_RootConstrainSelectedInstOperands,
     /*  518655 */     // GIR_Coverage, 19172,
     /*  518655 */     GIR_EraseRootFromParent_Done,
     /*  518656 */   // Label 8639: @518656
     /*  518656 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(518727), // Rule ID 19173 //
     /*  518661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  518672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  518675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  518678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518693 */     // MIs[0] round
     /*  518693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518703 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  518706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518712 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518725 */     GIR_RootConstrainSelectedInstOperands,
     /*  518726 */     // GIR_Coverage, 19173,
     /*  518726 */     GIR_EraseRootFromParent_Done,
     /*  518727 */   // Label 8640: @518727
     /*  518727 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(518798), // Rule ID 19176 //
     /*  518732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  518743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  518746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  518749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518764 */     // MIs[0] round
     /*  518764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518774 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  518777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518783 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518796 */     GIR_RootConstrainSelectedInstOperands,
     /*  518797 */     // GIR_Coverage, 19176,
     /*  518797 */     GIR_EraseRootFromParent_Done,
     /*  518798 */   // Label 8641: @518798
     /*  518798 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(518869), // Rule ID 19177 //
     /*  518803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  518814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  518817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  518820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518835 */     // MIs[0] round
     /*  518835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518845 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  518848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518854 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518867 */     GIR_RootConstrainSelectedInstOperands,
     /*  518868 */     // GIR_Coverage, 19177,
     /*  518868 */     GIR_EraseRootFromParent_Done,
     /*  518869 */   // Label 8642: @518869
     /*  518869 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(518940), // Rule ID 19180 //
     /*  518874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  518885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  518888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  518891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518906 */     // MIs[0] round
     /*  518906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518916 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  518919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518925 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518938 */     GIR_RootConstrainSelectedInstOperands,
     /*  518939 */     // GIR_Coverage, 19180,
     /*  518939 */     GIR_EraseRootFromParent_Done,
     /*  518940 */   // Label 8643: @518940
     /*  518940 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(519011), // Rule ID 19181 //
     /*  518945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  518956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  518959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  518962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518977 */     // MIs[0] round
     /*  518977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518987 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  518990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518996 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519009 */     GIR_RootConstrainSelectedInstOperands,
     /*  519010 */     // GIR_Coverage, 19181,
     /*  519010 */     GIR_EraseRootFromParent_Done,
     /*  519011 */   // Label 8644: @519011
     /*  519011 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(519082), // Rule ID 20766 //
     /*  519016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  519027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  519030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  519033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519048 */     // MIs[0] round
     /*  519048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519058 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  519061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519067 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519080 */     GIR_RootConstrainSelectedInstOperands,
     /*  519081 */     // GIR_Coverage, 20766,
     /*  519081 */     GIR_EraseRootFromParent_Done,
     /*  519082 */   // Label 8645: @519082
     /*  519082 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(519153), // Rule ID 20767 //
     /*  519087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  519098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  519101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  519104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519119 */     // MIs[0] round
     /*  519119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519129 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  519132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519138 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519151 */     GIR_RootConstrainSelectedInstOperands,
     /*  519152 */     // GIR_Coverage, 20767,
     /*  519152 */     GIR_EraseRootFromParent_Done,
     /*  519153 */   // Label 8646: @519153
     /*  519153 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(519224), // Rule ID 20770 //
     /*  519158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  519169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  519172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  519175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519190 */     // MIs[0] round
     /*  519190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519200 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  519203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519209 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519222 */     GIR_RootConstrainSelectedInstOperands,
     /*  519223 */     // GIR_Coverage, 20770,
     /*  519223 */     GIR_EraseRootFromParent_Done,
     /*  519224 */   // Label 8647: @519224
     /*  519224 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(519295), // Rule ID 20771 //
     /*  519229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  519240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  519243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  519246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519261 */     // MIs[0] round
     /*  519261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519271 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  519274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519280 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519293 */     GIR_RootConstrainSelectedInstOperands,
     /*  519294 */     // GIR_Coverage, 20771,
     /*  519294 */     GIR_EraseRootFromParent_Done,
     /*  519295 */   // Label 8648: @519295
     /*  519295 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(519366), // Rule ID 20774 //
     /*  519300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  519311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  519314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  519317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519332 */     // MIs[0] round
     /*  519332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519351 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519364 */     GIR_RootConstrainSelectedInstOperands,
     /*  519365 */     // GIR_Coverage, 20774,
     /*  519365 */     GIR_EraseRootFromParent_Done,
     /*  519366 */   // Label 8649: @519366
     /*  519366 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(519437), // Rule ID 20775 //
     /*  519371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  519382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  519385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  519388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519403 */     // MIs[0] round
     /*  519403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519413 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519422 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519435 */     GIR_RootConstrainSelectedInstOperands,
     /*  519436 */     // GIR_Coverage, 20775,
     /*  519436 */     GIR_EraseRootFromParent_Done,
     /*  519437 */   // Label 8650: @519437
     /*  519437 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(519508), // Rule ID 20778 //
     /*  519442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  519453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  519456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  519459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519474 */     // MIs[0] round
     /*  519474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519493 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519506 */     GIR_RootConstrainSelectedInstOperands,
     /*  519507 */     // GIR_Coverage, 20778,
     /*  519507 */     GIR_EraseRootFromParent_Done,
     /*  519508 */   // Label 8651: @519508
     /*  519508 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(519579), // Rule ID 20779 //
     /*  519513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  519524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  519527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  519530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519545 */     // MIs[0] round
     /*  519545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519555 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519564 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519577 */     GIR_RootConstrainSelectedInstOperands,
     /*  519578 */     // GIR_Coverage, 20779,
     /*  519578 */     GIR_EraseRootFromParent_Done,
     /*  519579 */   // Label 8652: @519579
     /*  519579 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(519650), // Rule ID 20782 //
     /*  519584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  519587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  519595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  519598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  519601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519616 */     // MIs[0] round
     /*  519616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519626 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  519626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519635 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519648 */     GIR_RootConstrainSelectedInstOperands,
     /*  519649 */     // GIR_Coverage, 20782,
     /*  519649 */     GIR_EraseRootFromParent_Done,
     /*  519650 */   // Label 8653: @519650
     /*  519650 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(519721), // Rule ID 20783 //
     /*  519655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  519658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  519666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  519669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  519672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519687 */     // MIs[0] round
     /*  519687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519697 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  519697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519706 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519719 */     GIR_RootConstrainSelectedInstOperands,
     /*  519720 */     // GIR_Coverage, 20783,
     /*  519720 */     GIR_EraseRootFromParent_Done,
     /*  519721 */   // Label 8654: @519721
     /*  519721 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(519792), // Rule ID 20786 //
     /*  519726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  519737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  519740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  519743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519758 */     // MIs[0] round
     /*  519758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519777 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519790 */     GIR_RootConstrainSelectedInstOperands,
     /*  519791 */     // GIR_Coverage, 20786,
     /*  519791 */     GIR_EraseRootFromParent_Done,
     /*  519792 */   // Label 8655: @519792
     /*  519792 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(519863), // Rule ID 20787 //
     /*  519797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  519808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  519811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  519814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519829 */     // MIs[0] round
     /*  519829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519839 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519848 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519861 */     GIR_RootConstrainSelectedInstOperands,
     /*  519862 */     // GIR_Coverage, 20787,
     /*  519862 */     GIR_EraseRootFromParent_Done,
     /*  519863 */   // Label 8656: @519863
     /*  519863 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(519934), // Rule ID 20790 //
     /*  519868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  519879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  519885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519900 */     // MIs[0] round
     /*  519900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519910 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519919 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519932 */     GIR_RootConstrainSelectedInstOperands,
     /*  519933 */     // GIR_Coverage, 20790,
     /*  519933 */     GIR_EraseRootFromParent_Done,
     /*  519934 */   // Label 8657: @519934
     /*  519934 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(520005), // Rule ID 20791 //
     /*  519939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  519950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  519956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519971 */     // MIs[0] round
     /*  519971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519981 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519990 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520003 */     GIR_RootConstrainSelectedInstOperands,
     /*  520004 */     // GIR_Coverage, 20791,
     /*  520004 */     GIR_EraseRootFromParent_Done,
     /*  520005 */   // Label 8658: @520005
     /*  520005 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(520076), // Rule ID 20794 //
     /*  520010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  520021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  520024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  520027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520042 */     // MIs[0] round
     /*  520042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520052 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520061 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520074 */     GIR_RootConstrainSelectedInstOperands,
     /*  520075 */     // GIR_Coverage, 20794,
     /*  520075 */     GIR_EraseRootFromParent_Done,
     /*  520076 */   // Label 8659: @520076
     /*  520076 */   GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(520147), // Rule ID 20795 //
     /*  520081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  520084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  520092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  520095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  520098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520113 */     // MIs[0] round
     /*  520113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520123 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520132 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520145 */     GIR_RootConstrainSelectedInstOperands,
     /*  520146 */     // GIR_Coverage, 20795,
     /*  520146 */     GIR_EraseRootFromParent_Done,
     /*  520147 */   // Label 8660: @520147
     /*  520147 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(520218), // Rule ID 20798 //
     /*  520152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  520155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  520163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  520166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  520169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520184 */     // MIs[0] round
     /*  520184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520194 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  520197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520203 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520216 */     GIR_RootConstrainSelectedInstOperands,
     /*  520217 */     // GIR_Coverage, 20798,
     /*  520217 */     GIR_EraseRootFromParent_Done,
     /*  520218 */   // Label 8661: @520218
     /*  520218 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(520289), // Rule ID 20799 //
     /*  520223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  520226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  520234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  520237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  520240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520255 */     // MIs[0] round
     /*  520255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520265 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  520268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520274 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520287 */     GIR_RootConstrainSelectedInstOperands,
     /*  520288 */     // GIR_Coverage, 20799,
     /*  520288 */     GIR_EraseRootFromParent_Done,
     /*  520289 */   // Label 8662: @520289
     /*  520289 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(520360), // Rule ID 20802 //
     /*  520294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  520297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  520305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  520308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  520311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520326 */     // MIs[0] round
     /*  520326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520336 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  520339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520345 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520358 */     GIR_RootConstrainSelectedInstOperands,
     /*  520359 */     // GIR_Coverage, 20802,
     /*  520359 */     GIR_EraseRootFromParent_Done,
     /*  520360 */   // Label 8663: @520360
     /*  520360 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(520431), // Rule ID 20803 //
     /*  520365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  520368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  520376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  520379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  520382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520397 */     // MIs[0] round
     /*  520397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520407 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  520410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520416 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520429 */     GIR_RootConstrainSelectedInstOperands,
     /*  520430 */     // GIR_Coverage, 20803,
     /*  520430 */     GIR_EraseRootFromParent_Done,
     /*  520431 */   // Label 8664: @520431
     /*  520431 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(520502), // Rule ID 20806 //
     /*  520436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  520439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  520447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  520450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  520453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520468 */     // MIs[0] round
     /*  520468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520487 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520500 */     GIR_RootConstrainSelectedInstOperands,
     /*  520501 */     // GIR_Coverage, 20806,
     /*  520501 */     GIR_EraseRootFromParent_Done,
     /*  520502 */   // Label 8665: @520502
     /*  520502 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(520573), // Rule ID 20807 //
     /*  520507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  520510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  520518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  520521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  520524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520539 */     // MIs[0] round
     /*  520539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520549 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520558 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520571 */     GIR_RootConstrainSelectedInstOperands,
     /*  520572 */     // GIR_Coverage, 20807,
     /*  520572 */     GIR_EraseRootFromParent_Done,
     /*  520573 */   // Label 8666: @520573
     /*  520573 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(520644), // Rule ID 20810 //
     /*  520578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  520589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  520592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  520595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520610 */     // MIs[0] round
     /*  520610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520620 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  520623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520629 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520642 */     GIR_RootConstrainSelectedInstOperands,
     /*  520643 */     // GIR_Coverage, 20810,
     /*  520643 */     GIR_EraseRootFromParent_Done,
     /*  520644 */   // Label 8667: @520644
     /*  520644 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(520715), // Rule ID 20811 //
     /*  520649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  520660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  520663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  520666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520681 */     // MIs[0] round
     /*  520681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520691 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  520694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520700 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520713 */     GIR_RootConstrainSelectedInstOperands,
     /*  520714 */     // GIR_Coverage, 20811,
     /*  520714 */     GIR_EraseRootFromParent_Done,
     /*  520715 */   // Label 8668: @520715
     /*  520715 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(520786), // Rule ID 20814 //
     /*  520720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  520731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  520734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  520737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520752 */     // MIs[0] round
     /*  520752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520762 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  520765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520771 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520784 */     GIR_RootConstrainSelectedInstOperands,
     /*  520785 */     // GIR_Coverage, 20814,
     /*  520785 */     GIR_EraseRootFromParent_Done,
     /*  520786 */   // Label 8669: @520786
     /*  520786 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(520857), // Rule ID 20815 //
     /*  520791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  520802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  520805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  520808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520823 */     // MIs[0] round
     /*  520823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520833 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  520836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520842 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520855 */     GIR_RootConstrainSelectedInstOperands,
     /*  520856 */     // GIR_Coverage, 20815,
     /*  520856 */     GIR_EraseRootFromParent_Done,
     /*  520857 */   // Label 8670: @520857
     /*  520857 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(520928), // Rule ID 20818 //
     /*  520862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  520873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  520879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520894 */     // MIs[0] round
     /*  520894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520904 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520913 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520926 */     GIR_RootConstrainSelectedInstOperands,
     /*  520927 */     // GIR_Coverage, 20818,
     /*  520927 */     GIR_EraseRootFromParent_Done,
     /*  520928 */   // Label 8671: @520928
     /*  520928 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(520999), // Rule ID 20819 //
     /*  520933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  520944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  520950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520965 */     // MIs[0] round
     /*  520965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520975 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520984 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520997 */     GIR_RootConstrainSelectedInstOperands,
     /*  520998 */     // GIR_Coverage, 20819,
     /*  520998 */     GIR_EraseRootFromParent_Done,
     /*  520999 */   // Label 8672: @520999
     /*  520999 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(521070), // Rule ID 20822 //
     /*  521004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  521015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  521018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  521021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521036 */     // MIs[0] round
     /*  521036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  521049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521055 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521068 */     GIR_RootConstrainSelectedInstOperands,
     /*  521069 */     // GIR_Coverage, 20822,
     /*  521069 */     GIR_EraseRootFromParent_Done,
     /*  521070 */   // Label 8673: @521070
     /*  521070 */   GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(521141), // Rule ID 20823 //
     /*  521075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  521086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  521089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  521092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521107 */     // MIs[0] round
     /*  521107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521117 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  521120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521126 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521139 */     GIR_RootConstrainSelectedInstOperands,
     /*  521140 */     // GIR_Coverage, 20823,
     /*  521140 */     GIR_EraseRootFromParent_Done,
     /*  521141 */   // Label 8674: @521141
     /*  521141 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(521212), // Rule ID 20826 //
     /*  521146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  521157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  521160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  521163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521178 */     // MIs[0] round
     /*  521178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521188 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  521191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521197 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521210 */     GIR_RootConstrainSelectedInstOperands,
     /*  521211 */     // GIR_Coverage, 20826,
     /*  521211 */     GIR_EraseRootFromParent_Done,
     /*  521212 */   // Label 8675: @521212
     /*  521212 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(521283), // Rule ID 20827 //
     /*  521217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  521228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  521231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  521234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521249 */     // MIs[0] round
     /*  521249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521259 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  521262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521268 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521281 */     GIR_RootConstrainSelectedInstOperands,
     /*  521282 */     // GIR_Coverage, 20827,
     /*  521282 */     GIR_EraseRootFromParent_Done,
     /*  521283 */   // Label 8676: @521283
     /*  521283 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(521354), // Rule ID 20830 //
     /*  521288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  521299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  521302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  521305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521320 */     // MIs[0] round
     /*  521320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521330 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  521333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521339 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521352 */     GIR_RootConstrainSelectedInstOperands,
     /*  521353 */     // GIR_Coverage, 20830,
     /*  521353 */     GIR_EraseRootFromParent_Done,
     /*  521354 */   // Label 8677: @521354
     /*  521354 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(521425), // Rule ID 20831 //
     /*  521359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  521362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  521370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  521373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  521376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521391 */     // MIs[0] round
     /*  521391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521401 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  521404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521410 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521423 */     GIR_RootConstrainSelectedInstOperands,
     /*  521424 */     // GIR_Coverage, 20831,
     /*  521424 */     GIR_EraseRootFromParent_Done,
     /*  521425 */   // Label 8678: @521425
     /*  521425 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(521496), // Rule ID 20834 //
     /*  521430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  521441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  521444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  521447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521462 */     // MIs[0] round
     /*  521462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521472 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521481 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521494 */     GIR_RootConstrainSelectedInstOperands,
     /*  521495 */     // GIR_Coverage, 20834,
     /*  521495 */     GIR_EraseRootFromParent_Done,
     /*  521496 */   // Label 8679: @521496
     /*  521496 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(521567), // Rule ID 20835 //
     /*  521501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  521512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  521515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  521518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521533 */     // MIs[0] round
     /*  521533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521543 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521552 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521565 */     GIR_RootConstrainSelectedInstOperands,
     /*  521566 */     // GIR_Coverage, 20835,
     /*  521566 */     GIR_EraseRootFromParent_Done,
     /*  521567 */   // Label 8680: @521567
     /*  521567 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(521638), // Rule ID 20838 //
     /*  521572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  521583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  521586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  521589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521604 */     // MIs[0] round
     /*  521604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521614 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521623 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521636 */     GIR_RootConstrainSelectedInstOperands,
     /*  521637 */     // GIR_Coverage, 20838,
     /*  521637 */     GIR_EraseRootFromParent_Done,
     /*  521638 */   // Label 8681: @521638
     /*  521638 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(521709), // Rule ID 20839 //
     /*  521643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  521646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  521654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  521657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  521660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521675 */     // MIs[0] round
     /*  521675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521685 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521694 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521707 */     GIR_RootConstrainSelectedInstOperands,
     /*  521708 */     // GIR_Coverage, 20839,
     /*  521708 */     GIR_EraseRootFromParent_Done,
     /*  521709 */   // Label 8682: @521709
     /*  521709 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(521780), // Rule ID 20842 //
     /*  521714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  521717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  521725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  521728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  521731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521746 */     // MIs[0] round
     /*  521746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521756 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  521756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521765 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521778 */     GIR_RootConstrainSelectedInstOperands,
     /*  521779 */     // GIR_Coverage, 20842,
     /*  521779 */     GIR_EraseRootFromParent_Done,
     /*  521780 */   // Label 8683: @521780
     /*  521780 */   GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(521851), // Rule ID 20843 //
     /*  521785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  521788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  521796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  521799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  521802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521817 */     // MIs[0] round
     /*  521817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  521827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521836 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521849 */     GIR_RootConstrainSelectedInstOperands,
     /*  521850 */     // GIR_Coverage, 20843,
     /*  521850 */     GIR_EraseRootFromParent_Done,
     /*  521851 */   // Label 8684: @521851
     /*  521851 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(521922), // Rule ID 20846 //
     /*  521856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  521867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  521870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  521873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521888 */     // MIs[0] round
     /*  521888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521898 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521907 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521920 */     GIR_RootConstrainSelectedInstOperands,
     /*  521921 */     // GIR_Coverage, 20846,
     /*  521921 */     GIR_EraseRootFromParent_Done,
     /*  521922 */   // Label 8685: @521922
     /*  521922 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(521993), // Rule ID 20847 //
     /*  521927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  521938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  521941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  521944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521959 */     // MIs[0] round
     /*  521959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521969 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521978 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521991 */     GIR_RootConstrainSelectedInstOperands,
     /*  521992 */     // GIR_Coverage, 20847,
     /*  521992 */     GIR_EraseRootFromParent_Done,
     /*  521993 */   // Label 8686: @521993
     /*  521993 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(522064), // Rule ID 20850 //
     /*  521998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  522009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  522012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  522015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522030 */     // MIs[0] round
     /*  522030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522040 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522049 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522062 */     GIR_RootConstrainSelectedInstOperands,
     /*  522063 */     // GIR_Coverage, 20850,
     /*  522063 */     GIR_EraseRootFromParent_Done,
     /*  522064 */   // Label 8687: @522064
     /*  522064 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(522135), // Rule ID 20851 //
     /*  522069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  522080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  522083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  522086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522101 */     // MIs[0] round
     /*  522101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522111 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522120 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522133 */     GIR_RootConstrainSelectedInstOperands,
     /*  522134 */     // GIR_Coverage, 20851,
     /*  522134 */     GIR_EraseRootFromParent_Done,
     /*  522135 */   // Label 8688: @522135
     /*  522135 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(522206), // Rule ID 20854 //
     /*  522140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  522151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  522154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  522157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522172 */     // MIs[0] round
     /*  522172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522182 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522191 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522204 */     GIR_RootConstrainSelectedInstOperands,
     /*  522205 */     // GIR_Coverage, 20854,
     /*  522205 */     GIR_EraseRootFromParent_Done,
     /*  522206 */   // Label 8689: @522206
     /*  522206 */   GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(522277), // Rule ID 20855 //
     /*  522211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  522222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  522225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  522228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522243 */     // MIs[0] round
     /*  522243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522253 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522262 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522275 */     GIR_RootConstrainSelectedInstOperands,
     /*  522276 */     // GIR_Coverage, 20855,
     /*  522276 */     GIR_EraseRootFromParent_Done,
     /*  522277 */   // Label 8690: @522277
     /*  522277 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(522348), // Rule ID 20858 //
     /*  522282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  522293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  522296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  522299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522314 */     // MIs[0] round
     /*  522314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  522327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522333 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522346 */     GIR_RootConstrainSelectedInstOperands,
     /*  522347 */     // GIR_Coverage, 20858,
     /*  522347 */     GIR_EraseRootFromParent_Done,
     /*  522348 */   // Label 8691: @522348
     /*  522348 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(522419), // Rule ID 20859 //
     /*  522353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  522364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  522367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  522370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522385 */     // MIs[0] round
     /*  522385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  522398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522404 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522417 */     GIR_RootConstrainSelectedInstOperands,
     /*  522418 */     // GIR_Coverage, 20859,
     /*  522418 */     GIR_EraseRootFromParent_Done,
     /*  522419 */   // Label 8692: @522419
     /*  522419 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(522490), // Rule ID 20862 //
     /*  522424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  522435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  522438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  522441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522456 */     // MIs[0] round
     /*  522456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522466 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522475 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522488 */     GIR_RootConstrainSelectedInstOperands,
     /*  522489 */     // GIR_Coverage, 20862,
     /*  522489 */     GIR_EraseRootFromParent_Done,
     /*  522490 */   // Label 8693: @522490
     /*  522490 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(522561), // Rule ID 20863 //
     /*  522495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  522506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  522509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  522512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522527 */     // MIs[0] round
     /*  522527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522537 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522546 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522559 */     GIR_RootConstrainSelectedInstOperands,
     /*  522560 */     // GIR_Coverage, 20863,
     /*  522560 */     GIR_EraseRootFromParent_Done,
     /*  522561 */   // Label 8694: @522561
     /*  522561 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(522632), // Rule ID 20866 //
     /*  522566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  522577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  522580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  522583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522598 */     // MIs[0] round
     /*  522598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522608 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522617 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522630 */     GIR_RootConstrainSelectedInstOperands,
     /*  522631 */     // GIR_Coverage, 20866,
     /*  522631 */     GIR_EraseRootFromParent_Done,
     /*  522632 */   // Label 8695: @522632
     /*  522632 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(522703), // Rule ID 20867 //
     /*  522637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  522648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  522651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  522654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522669 */     // MIs[0] round
     /*  522669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522679 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522688 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522701 */     GIR_RootConstrainSelectedInstOperands,
     /*  522702 */     // GIR_Coverage, 20867,
     /*  522702 */     GIR_EraseRootFromParent_Done,
     /*  522703 */   // Label 8696: @522703
     /*  522703 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(522774), // Rule ID 20870 //
     /*  522708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  522719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  522722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  522725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522740 */     // MIs[0] round
     /*  522740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522750 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  522753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522759 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522772 */     GIR_RootConstrainSelectedInstOperands,
     /*  522773 */     // GIR_Coverage, 20870,
     /*  522773 */     GIR_EraseRootFromParent_Done,
     /*  522774 */   // Label 8697: @522774
     /*  522774 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(522845), // Rule ID 20871 //
     /*  522779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  522782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  522790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  522793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  522796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522811 */     // MIs[0] round
     /*  522811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  522824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522830 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522843 */     GIR_RootConstrainSelectedInstOperands,
     /*  522844 */     // GIR_Coverage, 20871,
     /*  522844 */     GIR_EraseRootFromParent_Done,
     /*  522845 */   // Label 8698: @522845
     /*  522845 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(522916), // Rule ID 20874 //
     /*  522850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  522861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  522864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  522867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522882 */     // MIs[0] round
     /*  522882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522892 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522901 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522914 */     GIR_RootConstrainSelectedInstOperands,
     /*  522915 */     // GIR_Coverage, 20874,
     /*  522915 */     GIR_EraseRootFromParent_Done,
     /*  522916 */   // Label 8699: @522916
     /*  522916 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(522987), // Rule ID 20875 //
     /*  522921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  522924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  522932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  522935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  522938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522953 */     // MIs[0] round
     /*  522953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522963 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522972 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522985 */     GIR_RootConstrainSelectedInstOperands,
     /*  522986 */     // GIR_Coverage, 20875,
     /*  522986 */     GIR_EraseRootFromParent_Done,
     /*  522987 */   // Label 8700: @522987
     /*  522987 */   GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(523058), // Rule ID 20878 //
     /*  522992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  523000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  523003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  523006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  523009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523024 */     // MIs[0] round
     /*  523024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523034 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  523034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  523037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523043 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523056 */     GIR_RootConstrainSelectedInstOperands,
     /*  523057 */     // GIR_Coverage, 20878,
     /*  523057 */     GIR_EraseRootFromParent_Done,
     /*  523058 */   // Label 8701: @523058
     /*  523058 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(523129), // Rule ID 20879 //
     /*  523063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  523066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  523071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  523074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  523077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  523080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523095 */     // MIs[0] round
     /*  523095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523105 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  523105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  523108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523114 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523127 */     GIR_RootConstrainSelectedInstOperands,
     /*  523128 */     // GIR_Coverage, 20879,
     /*  523128 */     GIR_EraseRootFromParent_Done,
     /*  523129 */   // Label 8702: @523129
     /*  523129 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(523200), // Rule ID 21002 //
     /*  523134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  523145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  523148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  523151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523166 */     // MIs[0] round
     /*  523166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523176 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  523179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523185 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523198 */     GIR_RootConstrainSelectedInstOperands,
     /*  523199 */     // GIR_Coverage, 21002,
     /*  523199 */     GIR_EraseRootFromParent_Done,
     /*  523200 */   // Label 8703: @523200
     /*  523200 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(523271), // Rule ID 21003 //
     /*  523205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  523216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  523219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  523222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523237 */     // MIs[0] round
     /*  523237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523247 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  523250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523256 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523269 */     GIR_RootConstrainSelectedInstOperands,
     /*  523270 */     // GIR_Coverage, 21003,
     /*  523270 */     GIR_EraseRootFromParent_Done,
     /*  523271 */   // Label 8704: @523271
     /*  523271 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(523342), // Rule ID 21006 //
     /*  523276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  523287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  523290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  523293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523308 */     // MIs[0] round
     /*  523308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523318 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  523321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523327 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523340 */     GIR_RootConstrainSelectedInstOperands,
     /*  523341 */     // GIR_Coverage, 21006,
     /*  523341 */     GIR_EraseRootFromParent_Done,
     /*  523342 */   // Label 8705: @523342
     /*  523342 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(523413), // Rule ID 21007 //
     /*  523347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  523358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  523361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  523364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523379 */     // MIs[0] round
     /*  523379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523389 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  523392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523398 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523411 */     GIR_RootConstrainSelectedInstOperands,
     /*  523412 */     // GIR_Coverage, 21007,
     /*  523412 */     GIR_EraseRootFromParent_Done,
     /*  523413 */   // Label 8706: @523413
     /*  523413 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(523484), // Rule ID 21010 //
     /*  523418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  523429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  523432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  523435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523450 */     // MIs[0] round
     /*  523450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523460 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  523463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523469 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523482 */     GIR_RootConstrainSelectedInstOperands,
     /*  523483 */     // GIR_Coverage, 21010,
     /*  523483 */     GIR_EraseRootFromParent_Done,
     /*  523484 */   // Label 8707: @523484
     /*  523484 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(523555), // Rule ID 21011 //
     /*  523489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  523500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  523503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  523506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523521 */     // MIs[0] round
     /*  523521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523531 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  523534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523540 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523553 */     GIR_RootConstrainSelectedInstOperands,
     /*  523554 */     // GIR_Coverage, 21011,
     /*  523554 */     GIR_EraseRootFromParent_Done,
     /*  523555 */   // Label 8708: @523555
     /*  523555 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(523626), // Rule ID 21014 //
     /*  523560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  523571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  523574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  523577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523592 */     // MIs[0] round
     /*  523592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523602 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  523605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523611 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523624 */     GIR_RootConstrainSelectedInstOperands,
     /*  523625 */     // GIR_Coverage, 21014,
     /*  523625 */     GIR_EraseRootFromParent_Done,
     /*  523626 */   // Label 8709: @523626
     /*  523626 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(523697), // Rule ID 21015 //
     /*  523631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  523642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  523645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  523648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523663 */     // MIs[0] round
     /*  523663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523673 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  523676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523682 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523695 */     GIR_RootConstrainSelectedInstOperands,
     /*  523696 */     // GIR_Coverage, 21015,
     /*  523696 */     GIR_EraseRootFromParent_Done,
     /*  523697 */   // Label 8710: @523697
     /*  523697 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(523768), // Rule ID 21018 //
     /*  523702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  523713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  523716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  523719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523734 */     // MIs[0] round
     /*  523734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523744 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  523747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523753 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523766 */     GIR_RootConstrainSelectedInstOperands,
     /*  523767 */     // GIR_Coverage, 21018,
     /*  523767 */     GIR_EraseRootFromParent_Done,
     /*  523768 */   // Label 8711: @523768
     /*  523768 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(523839), // Rule ID 21019 //
     /*  523773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  523784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  523787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  523790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523805 */     // MIs[0] round
     /*  523805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523815 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  523818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523824 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523837 */     GIR_RootConstrainSelectedInstOperands,
     /*  523838 */     // GIR_Coverage, 21019,
     /*  523838 */     GIR_EraseRootFromParent_Done,
     /*  523839 */   // Label 8712: @523839
     /*  523839 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(523910), // Rule ID 21022 //
     /*  523844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  523847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  523855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  523858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  523861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523876 */     // MIs[0] round
     /*  523876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523886 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  523886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  523889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523895 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523908 */     GIR_RootConstrainSelectedInstOperands,
     /*  523909 */     // GIR_Coverage, 21022,
     /*  523909 */     GIR_EraseRootFromParent_Done,
     /*  523910 */   // Label 8713: @523910
     /*  523910 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(523981), // Rule ID 21023 //
     /*  523915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  523918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  523926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  523929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  523932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523947 */     // MIs[0] round
     /*  523947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523957 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  523957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  523960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523966 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523979 */     GIR_RootConstrainSelectedInstOperands,
     /*  523980 */     // GIR_Coverage, 21023,
     /*  523980 */     GIR_EraseRootFromParent_Done,
     /*  523981 */   // Label 8714: @523981
     /*  523981 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(524052), // Rule ID 21026 //
     /*  523986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  523997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  524000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  524003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524018 */     // MIs[0] round
     /*  524018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524028 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  524031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524037 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524050 */     GIR_RootConstrainSelectedInstOperands,
     /*  524051 */     // GIR_Coverage, 21026,
     /*  524051 */     GIR_EraseRootFromParent_Done,
     /*  524052 */   // Label 8715: @524052
     /*  524052 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(524123), // Rule ID 21027 //
     /*  524057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  524068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  524071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  524074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524089 */     // MIs[0] round
     /*  524089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524099 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  524102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524108 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524121 */     GIR_RootConstrainSelectedInstOperands,
     /*  524122 */     // GIR_Coverage, 21027,
     /*  524122 */     GIR_EraseRootFromParent_Done,
     /*  524123 */   // Label 8716: @524123
     /*  524123 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(524194), // Rule ID 21030 //
     /*  524128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  524139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  524142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  524145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524160 */     // MIs[0] round
     /*  524160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524170 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  524173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524179 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524192 */     GIR_RootConstrainSelectedInstOperands,
     /*  524193 */     // GIR_Coverage, 21030,
     /*  524193 */     GIR_EraseRootFromParent_Done,
     /*  524194 */   // Label 8717: @524194
     /*  524194 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(524265), // Rule ID 21031 //
     /*  524199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  524210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  524213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  524216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524231 */     // MIs[0] round
     /*  524231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524241 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  524244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524250 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524263 */     GIR_RootConstrainSelectedInstOperands,
     /*  524264 */     // GIR_Coverage, 21031,
     /*  524264 */     GIR_EraseRootFromParent_Done,
     /*  524265 */   // Label 8718: @524265
     /*  524265 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(524336), // Rule ID 21034 //
     /*  524270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  524281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  524284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  524287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524302 */     // MIs[0] round
     /*  524302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524312 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  524315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524321 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524334 */     GIR_RootConstrainSelectedInstOperands,
     /*  524335 */     // GIR_Coverage, 21034,
     /*  524335 */     GIR_EraseRootFromParent_Done,
     /*  524336 */   // Label 8719: @524336
     /*  524336 */   GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(524407), // Rule ID 21035 //
     /*  524341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  524352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  524355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  524358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524373 */     // MIs[0] round
     /*  524373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524383 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  524386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524392 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524405 */     GIR_RootConstrainSelectedInstOperands,
     /*  524406 */     // GIR_Coverage, 21035,
     /*  524406 */     GIR_EraseRootFromParent_Done,
     /*  524407 */   // Label 8720: @524407
     /*  524407 */   GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(524478), // Rule ID 21038 //
     /*  524412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  524423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  524426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  524429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524444 */     // MIs[0] round
     /*  524444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524454 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  524457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524463 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524476 */     GIR_RootConstrainSelectedInstOperands,
     /*  524477 */     // GIR_Coverage, 21038,
     /*  524477 */     GIR_EraseRootFromParent_Done,
     /*  524478 */   // Label 8721: @524478
     /*  524478 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(524549), // Rule ID 21039 //
     /*  524483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  524494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  524497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  524500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524515 */     // MIs[0] round
     /*  524515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524525 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  524528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524534 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524547 */     GIR_RootConstrainSelectedInstOperands,
     /*  524548 */     // GIR_Coverage, 21039,
     /*  524548 */     GIR_EraseRootFromParent_Done,
     /*  524549 */   // Label 8722: @524549
     /*  524549 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(524620), // Rule ID 21042 //
     /*  524554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  524565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  524568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  524571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524586 */     // MIs[0] round
     /*  524586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524596 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  524599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524605 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524618 */     GIR_RootConstrainSelectedInstOperands,
     /*  524619 */     // GIR_Coverage, 21042,
     /*  524619 */     GIR_EraseRootFromParent_Done,
     /*  524620 */   // Label 8723: @524620
     /*  524620 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(524691), // Rule ID 21043 //
     /*  524625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  524636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  524639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  524642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524657 */     // MIs[0] round
     /*  524657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524667 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  524670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524676 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524689 */     GIR_RootConstrainSelectedInstOperands,
     /*  524690 */     // GIR_Coverage, 21043,
     /*  524690 */     GIR_EraseRootFromParent_Done,
     /*  524691 */   // Label 8724: @524691
     /*  524691 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(524762), // Rule ID 21046 //
     /*  524696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  524707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  524710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  524713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524728 */     // MIs[0] round
     /*  524728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524738 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  524741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524747 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524760 */     GIR_RootConstrainSelectedInstOperands,
     /*  524761 */     // GIR_Coverage, 21046,
     /*  524761 */     GIR_EraseRootFromParent_Done,
     /*  524762 */   // Label 8725: @524762
     /*  524762 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(524833), // Rule ID 21047 //
     /*  524767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  524778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  524781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  524784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524799 */     // MIs[0] round
     /*  524799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524809 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  524812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524818 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524831 */     GIR_RootConstrainSelectedInstOperands,
     /*  524832 */     // GIR_Coverage, 21047,
     /*  524832 */     GIR_EraseRootFromParent_Done,
     /*  524833 */   // Label 8726: @524833
     /*  524833 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(524904), // Rule ID 21050 //
     /*  524838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  524849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  524852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  524855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524870 */     // MIs[0] round
     /*  524870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524880 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  524883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524889 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524902 */     GIR_RootConstrainSelectedInstOperands,
     /*  524903 */     // GIR_Coverage, 21050,
     /*  524903 */     GIR_EraseRootFromParent_Done,
     /*  524904 */   // Label 8727: @524904
     /*  524904 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(524975), // Rule ID 21051 //
     /*  524909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  524920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  524923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  524926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524941 */     // MIs[0] round
     /*  524941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524951 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  524954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524960 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524973 */     GIR_RootConstrainSelectedInstOperands,
     /*  524974 */     // GIR_Coverage, 21051,
     /*  524974 */     GIR_EraseRootFromParent_Done,
     /*  524975 */   // Label 8728: @524975
     /*  524975 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(525046), // Rule ID 21054 //
     /*  524980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  524991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  524994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  524997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525012 */     // MIs[0] round
     /*  525012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525022 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  525022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  525025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525031 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525044 */     GIR_RootConstrainSelectedInstOperands,
     /*  525045 */     // GIR_Coverage, 21054,
     /*  525045 */     GIR_EraseRootFromParent_Done,
     /*  525046 */   // Label 8729: @525046
     /*  525046 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(525117), // Rule ID 21055 //
     /*  525051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  525054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  525059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  525062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  525065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  525068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525083 */     // MIs[0] round
     /*  525083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525093 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  525093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  525096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525102 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525115 */     GIR_RootConstrainSelectedInstOperands,
     /*  525116 */     // GIR_Coverage, 21055,
     /*  525116 */     GIR_EraseRootFromParent_Done,
     /*  525117 */   // Label 8730: @525117
     /*  525117 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(525188), // Rule ID 21058 //
     /*  525122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  525125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  525130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  525133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  525136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  525139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525154 */     // MIs[0] round
     /*  525154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525164 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  525164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  525167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525173 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525186 */     GIR_RootConstrainSelectedInstOperands,
     /*  525187 */     // GIR_Coverage, 21058,
     /*  525187 */     GIR_EraseRootFromParent_Done,
     /*  525188 */   // Label 8731: @525188
     /*  525188 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(525259), // Rule ID 21059 //
     /*  525193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  525196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  525201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  525204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  525207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  525210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525225 */     // MIs[0] round
     /*  525225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525235 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  525235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  525238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525244 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525257 */     GIR_RootConstrainSelectedInstOperands,
     /*  525258 */     // GIR_Coverage, 21059,
     /*  525258 */     GIR_EraseRootFromParent_Done,
     /*  525259 */   // Label 8732: @525259
     /*  525259 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(525330), // Rule ID 21062 //
     /*  525264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  525275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  525278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  525281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525296 */     // MIs[0] round
     /*  525296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525306 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  525309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525315 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525328 */     GIR_RootConstrainSelectedInstOperands,
     /*  525329 */     // GIR_Coverage, 21062,
     /*  525329 */     GIR_EraseRootFromParent_Done,
     /*  525330 */   // Label 8733: @525330
     /*  525330 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(525401), // Rule ID 21063 //
     /*  525335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  525346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  525349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  525352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525367 */     // MIs[0] round
     /*  525367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525377 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  525380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525386 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525399 */     GIR_RootConstrainSelectedInstOperands,
     /*  525400 */     // GIR_Coverage, 21063,
     /*  525400 */     GIR_EraseRootFromParent_Done,
     /*  525401 */   // Label 8734: @525401
     /*  525401 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(525472), // Rule ID 21066 //
     /*  525406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  525417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  525420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  525423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525438 */     // MIs[0] round
     /*  525438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525448 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  525451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525457 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525470 */     GIR_RootConstrainSelectedInstOperands,
     /*  525471 */     // GIR_Coverage, 21066,
     /*  525471 */     GIR_EraseRootFromParent_Done,
     /*  525472 */   // Label 8735: @525472
     /*  525472 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(525543), // Rule ID 21067 //
     /*  525477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  525488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  525491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  525494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525509 */     // MIs[0] round
     /*  525509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525519 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  525522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525528 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525541 */     GIR_RootConstrainSelectedInstOperands,
     /*  525542 */     // GIR_Coverage, 21067,
     /*  525542 */     GIR_EraseRootFromParent_Done,
     /*  525543 */   // Label 8736: @525543
     /*  525543 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(525614), // Rule ID 21070 //
     /*  525548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  525559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  525562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  525565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525580 */     // MIs[0] round
     /*  525580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525590 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  525593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525599 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525612 */     GIR_RootConstrainSelectedInstOperands,
     /*  525613 */     // GIR_Coverage, 21070,
     /*  525613 */     GIR_EraseRootFromParent_Done,
     /*  525614 */   // Label 8737: @525614
     /*  525614 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(525685), // Rule ID 21071 //
     /*  525619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  525630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  525633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  525636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525651 */     // MIs[0] round
     /*  525651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525661 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  525664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525670 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525683 */     GIR_RootConstrainSelectedInstOperands,
     /*  525684 */     // GIR_Coverage, 21071,
     /*  525684 */     GIR_EraseRootFromParent_Done,
     /*  525685 */   // Label 8738: @525685
     /*  525685 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(525756), // Rule ID 21074 //
     /*  525690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  525701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  525704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  525707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525722 */     // MIs[0] round
     /*  525722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525732 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  525735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525741 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525754 */     GIR_RootConstrainSelectedInstOperands,
     /*  525755 */     // GIR_Coverage, 21074,
     /*  525755 */     GIR_EraseRootFromParent_Done,
     /*  525756 */   // Label 8739: @525756
     /*  525756 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(525827), // Rule ID 21075 //
     /*  525761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  525772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  525775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  525778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525793 */     // MIs[0] round
     /*  525793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525803 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  525806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525812 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525825 */     GIR_RootConstrainSelectedInstOperands,
     /*  525826 */     // GIR_Coverage, 21075,
     /*  525826 */     GIR_EraseRootFromParent_Done,
     /*  525827 */   // Label 8740: @525827
     /*  525827 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(525898), // Rule ID 21078 //
     /*  525832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  525843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  525846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  525849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525864 */     // MIs[0] round
     /*  525864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525874 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  525877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525883 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525896 */     GIR_RootConstrainSelectedInstOperands,
     /*  525897 */     // GIR_Coverage, 21078,
     /*  525897 */     GIR_EraseRootFromParent_Done,
     /*  525898 */   // Label 8741: @525898
     /*  525898 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(525969), // Rule ID 21079 //
     /*  525903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  525914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  525917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  525920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525935 */     // MIs[0] round
     /*  525935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525945 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  525948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525954 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525967 */     GIR_RootConstrainSelectedInstOperands,
     /*  525968 */     // GIR_Coverage, 21079,
     /*  525968 */     GIR_EraseRootFromParent_Done,
     /*  525969 */   // Label 8742: @525969
     /*  525969 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(526040), // Rule ID 21082 //
     /*  525974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  525977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526006 */     // MIs[0] round
     /*  526006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526016 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  526019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526025 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526038 */     GIR_RootConstrainSelectedInstOperands,
     /*  526039 */     // GIR_Coverage, 21082,
     /*  526039 */     GIR_EraseRootFromParent_Done,
     /*  526040 */   // Label 8743: @526040
     /*  526040 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(526111), // Rule ID 21083 //
     /*  526045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  526056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  526059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  526062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526077 */     // MIs[0] round
     /*  526077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526087 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  526090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526096 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526109 */     GIR_RootConstrainSelectedInstOperands,
     /*  526110 */     // GIR_Coverage, 21083,
     /*  526110 */     GIR_EraseRootFromParent_Done,
     /*  526111 */   // Label 8744: @526111
     /*  526111 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(526182), // Rule ID 21086 //
     /*  526116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  526127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  526130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  526133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526148 */     // MIs[0] round
     /*  526148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526158 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  526161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526167 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526180 */     GIR_RootConstrainSelectedInstOperands,
     /*  526181 */     // GIR_Coverage, 21086,
     /*  526181 */     GIR_EraseRootFromParent_Done,
     /*  526182 */   // Label 8745: @526182
     /*  526182 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(526253), // Rule ID 21087 //
     /*  526187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  526198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  526201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  526204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526219 */     // MIs[0] round
     /*  526219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526229 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  526232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526238 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526251 */     GIR_RootConstrainSelectedInstOperands,
     /*  526252 */     // GIR_Coverage, 21087,
     /*  526252 */     GIR_EraseRootFromParent_Done,
     /*  526253 */   // Label 8746: @526253
     /*  526253 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(526324), // Rule ID 21090 //
     /*  526258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  526269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  526272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  526275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526290 */     // MIs[0] round
     /*  526290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526300 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  526303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526309 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526322 */     GIR_RootConstrainSelectedInstOperands,
     /*  526323 */     // GIR_Coverage, 21090,
     /*  526323 */     GIR_EraseRootFromParent_Done,
     /*  526324 */   // Label 8747: @526324
     /*  526324 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(526395), // Rule ID 21091 //
     /*  526329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  526340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  526343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  526346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526361 */     // MIs[0] round
     /*  526361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526371 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  526374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526380 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526393 */     GIR_RootConstrainSelectedInstOperands,
     /*  526394 */     // GIR_Coverage, 21091,
     /*  526394 */     GIR_EraseRootFromParent_Done,
     /*  526395 */   // Label 8748: @526395
     /*  526395 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(526466), // Rule ID 21094 //
     /*  526400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  526411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  526414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  526417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526432 */     // MIs[0] round
     /*  526432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526442 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  526445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526451 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526464 */     GIR_RootConstrainSelectedInstOperands,
     /*  526465 */     // GIR_Coverage, 21094,
     /*  526465 */     GIR_EraseRootFromParent_Done,
     /*  526466 */   // Label 8749: @526466
     /*  526466 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(526537), // Rule ID 21095 //
     /*  526471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  526482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  526485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  526488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526503 */     // MIs[0] round
     /*  526503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526513 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  526516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526522 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526535 */     GIR_RootConstrainSelectedInstOperands,
     /*  526536 */     // GIR_Coverage, 21095,
     /*  526536 */     GIR_EraseRootFromParent_Done,
     /*  526537 */   // Label 8750: @526537
     /*  526537 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(526608), // Rule ID 21098 //
     /*  526542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  526553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  526556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  526559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526574 */     // MIs[0] round
     /*  526574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526584 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  526587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526593 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526606 */     GIR_RootConstrainSelectedInstOperands,
     /*  526607 */     // GIR_Coverage, 21098,
     /*  526607 */     GIR_EraseRootFromParent_Done,
     /*  526608 */   // Label 8751: @526608
     /*  526608 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(526679), // Rule ID 21099 //
     /*  526613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  526624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  526627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  526630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526645 */     // MIs[0] round
     /*  526645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526655 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  526658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526664 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526677 */     GIR_RootConstrainSelectedInstOperands,
     /*  526678 */     // GIR_Coverage, 21099,
     /*  526678 */     GIR_EraseRootFromParent_Done,
     /*  526679 */   // Label 8752: @526679
     /*  526679 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(526750), // Rule ID 21102 //
     /*  526684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  526695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  526698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  526701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526716 */     // MIs[0] round
     /*  526716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526726 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  526729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526735 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526748 */     GIR_RootConstrainSelectedInstOperands,
     /*  526749 */     // GIR_Coverage, 21102,
     /*  526749 */     GIR_EraseRootFromParent_Done,
     /*  526750 */   // Label 8753: @526750
     /*  526750 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(526821), // Rule ID 21103 //
     /*  526755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  526766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  526769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  526772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526787 */     // MIs[0] round
     /*  526787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526797 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  526800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526806 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526819 */     GIR_RootConstrainSelectedInstOperands,
     /*  526820 */     // GIR_Coverage, 21103,
     /*  526820 */     GIR_EraseRootFromParent_Done,
     /*  526821 */   // Label 8754: @526821
     /*  526821 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(526892), // Rule ID 21106 //
     /*  526826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  526843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526858 */     // MIs[0] round
     /*  526858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526868 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  526871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526877 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526890 */     GIR_RootConstrainSelectedInstOperands,
     /*  526891 */     // GIR_Coverage, 21106,
     /*  526891 */     GIR_EraseRootFromParent_Done,
     /*  526892 */   // Label 8755: @526892
     /*  526892 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(526963), // Rule ID 21107 //
     /*  526897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  526914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526929 */     // MIs[0] round
     /*  526929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526939 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  526942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526948 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526961 */     GIR_RootConstrainSelectedInstOperands,
     /*  526962 */     // GIR_Coverage, 21107,
     /*  526962 */     GIR_EraseRootFromParent_Done,
     /*  526963 */   // Label 8756: @526963
     /*  526963 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(527034), // Rule ID 21110 //
     /*  526968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527000 */     // MIs[0] round
     /*  527000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527010 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  527010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  527013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527019 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527032 */     GIR_RootConstrainSelectedInstOperands,
     /*  527033 */     // GIR_Coverage, 21110,
     /*  527033 */     GIR_EraseRootFromParent_Done,
     /*  527034 */   // Label 8757: @527034
     /*  527034 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(527105), // Rule ID 21111 //
     /*  527039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  527042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  527047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  527050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  527053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  527056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527071 */     // MIs[0] round
     /*  527071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527081 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  527081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  527084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527090 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527103 */     GIR_RootConstrainSelectedInstOperands,
     /*  527104 */     // GIR_Coverage, 21111,
     /*  527104 */     GIR_EraseRootFromParent_Done,
     /*  527105 */   // Label 8758: @527105
     /*  527105 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(527176), // Rule ID 21114 //
     /*  527110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  527113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  527118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  527121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  527124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  527127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527142 */     // MIs[0] round
     /*  527142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527152 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  527152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  527155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527161 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527174 */     GIR_RootConstrainSelectedInstOperands,
     /*  527175 */     // GIR_Coverage, 21114,
     /*  527175 */     GIR_EraseRootFromParent_Done,
     /*  527176 */   // Label 8759: @527176
     /*  527176 */   GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(527247), // Rule ID 21115 //
     /*  527181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  527184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  527189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  527192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  527195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  527198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527213 */     // MIs[0] round
     /*  527213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527223 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  527223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  527226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527232 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527245 */     GIR_RootConstrainSelectedInstOperands,
     /*  527246 */     // GIR_Coverage, 21115,
     /*  527246 */     GIR_EraseRootFromParent_Done,
     /*  527247 */   // Label 8760: @527247
     /*  527247 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(527318), // Rule ID 21118 //
     /*  527252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  527255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  527260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  527263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  527266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  527269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527284 */     // MIs[0] round
     /*  527284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527294 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  527294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  527297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527303 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527316 */     GIR_RootConstrainSelectedInstOperands,
     /*  527317 */     // GIR_Coverage, 21118,
     /*  527317 */     GIR_EraseRootFromParent_Done,
     /*  527318 */   // Label 8761: @527318
     /*  527318 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(527389), // Rule ID 21119 //
     /*  527323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  527326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  527331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  527334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  527337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  527340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527355 */     // MIs[0] round
     /*  527355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527365 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  527365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  527368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527374 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527387 */     GIR_RootConstrainSelectedInstOperands,
     /*  527388 */     // GIR_Coverage, 21119,
     /*  527388 */     GIR_EraseRootFromParent_Done,
     /*  527389 */   // Label 8762: @527389
     /*  527389 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(527460), // Rule ID 21194 //
     /*  527394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  527405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  527408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  527411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527426 */     // MIs[0] round
     /*  527426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  527439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527445 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527458 */     GIR_RootConstrainSelectedInstOperands,
     /*  527459 */     // GIR_Coverage, 21194,
     /*  527459 */     GIR_EraseRootFromParent_Done,
     /*  527460 */   // Label 8763: @527460
     /*  527460 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(527531), // Rule ID 21195 //
     /*  527465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  527476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  527479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  527482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527497 */     // MIs[0] round
     /*  527497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527507 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  527510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527516 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527529 */     GIR_RootConstrainSelectedInstOperands,
     /*  527530 */     // GIR_Coverage, 21195,
     /*  527530 */     GIR_EraseRootFromParent_Done,
     /*  527531 */   // Label 8764: @527531
     /*  527531 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(527602), // Rule ID 21198 //
     /*  527536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  527553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527568 */     // MIs[0] round
     /*  527568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527578 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527587 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527600 */     GIR_RootConstrainSelectedInstOperands,
     /*  527601 */     // GIR_Coverage, 21198,
     /*  527601 */     GIR_EraseRootFromParent_Done,
     /*  527602 */   // Label 8765: @527602
     /*  527602 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(527673), // Rule ID 21199 //
     /*  527607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  527624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527639 */     // MIs[0] round
     /*  527639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527649 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527658 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527671 */     GIR_RootConstrainSelectedInstOperands,
     /*  527672 */     // GIR_Coverage, 21199,
     /*  527672 */     GIR_EraseRootFromParent_Done,
     /*  527673 */   // Label 8766: @527673
     /*  527673 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(527744), // Rule ID 21202 //
     /*  527678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  527695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527710 */     // MIs[0] round
     /*  527710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527720 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527729 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527742 */     GIR_RootConstrainSelectedInstOperands,
     /*  527743 */     // GIR_Coverage, 21202,
     /*  527743 */     GIR_EraseRootFromParent_Done,
     /*  527744 */   // Label 8767: @527744
     /*  527744 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(527815), // Rule ID 21203 //
     /*  527749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  527766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527781 */     // MIs[0] round
     /*  527781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527800 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527813 */     GIR_RootConstrainSelectedInstOperands,
     /*  527814 */     // GIR_Coverage, 21203,
     /*  527814 */     GIR_EraseRootFromParent_Done,
     /*  527815 */   // Label 8768: @527815
     /*  527815 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(527886), // Rule ID 21206 //
     /*  527820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  527831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  527834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  527837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527852 */     // MIs[0] round
     /*  527852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527862 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  527865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527871 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527884 */     GIR_RootConstrainSelectedInstOperands,
     /*  527885 */     // GIR_Coverage, 21206,
     /*  527885 */     GIR_EraseRootFromParent_Done,
     /*  527886 */   // Label 8769: @527886
     /*  527886 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(527957), // Rule ID 21207 //
     /*  527891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  527902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  527905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  527908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527923 */     // MIs[0] round
     /*  527923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527933 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  527936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527942 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527955 */     GIR_RootConstrainSelectedInstOperands,
     /*  527956 */     // GIR_Coverage, 21207,
     /*  527956 */     GIR_EraseRootFromParent_Done,
     /*  527957 */   // Label 8770: @527957
     /*  527957 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(528028), // Rule ID 21210 //
     /*  527962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  527973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  527976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  527979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527994 */     // MIs[0] round
     /*  527994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528004 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  528007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528013 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528026 */     GIR_RootConstrainSelectedInstOperands,
     /*  528027 */     // GIR_Coverage, 21210,
     /*  528027 */     GIR_EraseRootFromParent_Done,
     /*  528028 */   // Label 8771: @528028
     /*  528028 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(528099), // Rule ID 21211 //
     /*  528033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  528044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  528047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  528050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528065 */     // MIs[0] round
     /*  528065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528075 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  528078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528084 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528097 */     GIR_RootConstrainSelectedInstOperands,
     /*  528098 */     // GIR_Coverage, 21211,
     /*  528098 */     GIR_EraseRootFromParent_Done,
     /*  528099 */   // Label 8772: @528099
     /*  528099 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(528170), // Rule ID 21214 //
     /*  528104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  528115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  528118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  528121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528136 */     // MIs[0] round
     /*  528136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528146 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  528149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528155 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528168 */     GIR_RootConstrainSelectedInstOperands,
     /*  528169 */     // GIR_Coverage, 21214,
     /*  528169 */     GIR_EraseRootFromParent_Done,
     /*  528170 */   // Label 8773: @528170
     /*  528170 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(528241), // Rule ID 21215 //
     /*  528175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  528186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  528189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  528192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528207 */     // MIs[0] round
     /*  528207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528217 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  528220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528226 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528239 */     GIR_RootConstrainSelectedInstOperands,
     /*  528240 */     // GIR_Coverage, 21215,
     /*  528240 */     GIR_EraseRootFromParent_Done,
     /*  528241 */   // Label 8774: @528241
     /*  528241 */   GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(528312), // Rule ID 21218 //
     /*  528246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  528257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  528260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  528263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528278 */     // MIs[0] round
     /*  528278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528288 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  528291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528297 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528310 */     GIR_RootConstrainSelectedInstOperands,
     /*  528311 */     // GIR_Coverage, 21218,
     /*  528311 */     GIR_EraseRootFromParent_Done,
     /*  528312 */   // Label 8775: @528312
     /*  528312 */   GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(528383), // Rule ID 21219 //
     /*  528317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  528328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  528331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  528334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528349 */     // MIs[0] round
     /*  528349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528359 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  528362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528368 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528381 */     GIR_RootConstrainSelectedInstOperands,
     /*  528382 */     // GIR_Coverage, 21219,
     /*  528382 */     GIR_EraseRootFromParent_Done,
     /*  528383 */   // Label 8776: @528383
     /*  528383 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(528454), // Rule ID 21222 //
     /*  528388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  528399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  528402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  528405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528420 */     // MIs[0] round
     /*  528420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  528433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528439 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528452 */     GIR_RootConstrainSelectedInstOperands,
     /*  528453 */     // GIR_Coverage, 21222,
     /*  528453 */     GIR_EraseRootFromParent_Done,
     /*  528454 */   // Label 8777: @528454
     /*  528454 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(528525), // Rule ID 21223 //
     /*  528459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  528470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  528473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  528476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528491 */     // MIs[0] round
     /*  528491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528501 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  528504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528510 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528523 */     GIR_RootConstrainSelectedInstOperands,
     /*  528524 */     // GIR_Coverage, 21223,
     /*  528524 */     GIR_EraseRootFromParent_Done,
     /*  528525 */   // Label 8778: @528525
     /*  528525 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(528596), // Rule ID 21226 //
     /*  528530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  528547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528562 */     // MIs[0] round
     /*  528562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528572 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  528575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528581 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528594 */     GIR_RootConstrainSelectedInstOperands,
     /*  528595 */     // GIR_Coverage, 21226,
     /*  528595 */     GIR_EraseRootFromParent_Done,
     /*  528596 */   // Label 8779: @528596
     /*  528596 */   GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(528667), // Rule ID 21227 //
     /*  528601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  528618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528633 */     // MIs[0] round
     /*  528633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528643 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  528646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528652 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528665 */     GIR_RootConstrainSelectedInstOperands,
     /*  528666 */     // GIR_Coverage, 21227,
     /*  528666 */     GIR_EraseRootFromParent_Done,
     /*  528667 */   // Label 8780: @528667
     /*  528667 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(528738), // Rule ID 21230 //
     /*  528672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  528683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  528686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528704 */     // MIs[0] round
     /*  528704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  528717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528723 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528736 */     GIR_RootConstrainSelectedInstOperands,
     /*  528737 */     // GIR_Coverage, 21230,
     /*  528737 */     GIR_EraseRootFromParent_Done,
     /*  528738 */   // Label 8781: @528738
     /*  528738 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(528809), // Rule ID 21231 //
     /*  528743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  528754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  528757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528775 */     // MIs[0] round
     /*  528775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528785 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  528788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528794 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528807 */     GIR_RootConstrainSelectedInstOperands,
     /*  528808 */     // GIR_Coverage, 21231,
     /*  528808 */     GIR_EraseRootFromParent_Done,
     /*  528809 */   // Label 8782: @528809
     /*  528809 */   GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(528880), // Rule ID 21234 //
     /*  528814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  528825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  528828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  528831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528846 */     // MIs[0] round
     /*  528846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528856 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  528859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528865 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528878 */     GIR_RootConstrainSelectedInstOperands,
     /*  528879 */     // GIR_Coverage, 21234,
     /*  528879 */     GIR_EraseRootFromParent_Done,
     /*  528880 */   // Label 8783: @528880
     /*  528880 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(528951), // Rule ID 21235 //
     /*  528885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  528896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  528899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  528902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528917 */     // MIs[0] round
     /*  528917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  528930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528936 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528949 */     GIR_RootConstrainSelectedInstOperands,
     /*  528950 */     // GIR_Coverage, 21235,
     /*  528950 */     GIR_EraseRootFromParent_Done,
     /*  528951 */   // Label 8784: @528951
     /*  528951 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(529022), // Rule ID 21238 //
     /*  528956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  528967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  528970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  528973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528988 */     // MIs[0] round
     /*  528988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  529001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529007 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529020 */     GIR_RootConstrainSelectedInstOperands,
     /*  529021 */     // GIR_Coverage, 21238,
     /*  529021 */     GIR_EraseRootFromParent_Done,
     /*  529022 */   // Label 8785: @529022
     /*  529022 */   GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(529093), // Rule ID 21239 //
     /*  529027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  529038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  529041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  529044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529059 */     // MIs[0] round
     /*  529059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529069 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  529072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529078 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529091 */     GIR_RootConstrainSelectedInstOperands,
     /*  529092 */     // GIR_Coverage, 21239,
     /*  529092 */     GIR_EraseRootFromParent_Done,
     /*  529093 */   // Label 8786: @529093
     /*  529093 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(529164), // Rule ID 21242 //
     /*  529098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  529109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  529112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529130 */     // MIs[0] round
     /*  529130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529140 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  529143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529149 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529162 */     GIR_RootConstrainSelectedInstOperands,
     /*  529163 */     // GIR_Coverage, 21242,
     /*  529163 */     GIR_EraseRootFromParent_Done,
     /*  529164 */   // Label 8787: @529164
     /*  529164 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(529235), // Rule ID 21243 //
     /*  529169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  529180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  529183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529201 */     // MIs[0] round
     /*  529201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529211 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  529214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529220 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529233 */     GIR_RootConstrainSelectedInstOperands,
     /*  529234 */     // GIR_Coverage, 21243,
     /*  529234 */     GIR_EraseRootFromParent_Done,
     /*  529235 */   // Label 8788: @529235
     /*  529235 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(529306), // Rule ID 21246 //
     /*  529240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  529251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  529254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  529257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529272 */     // MIs[0] round
     /*  529272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529282 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  529285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529291 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529304 */     GIR_RootConstrainSelectedInstOperands,
     /*  529305 */     // GIR_Coverage, 21246,
     /*  529305 */     GIR_EraseRootFromParent_Done,
     /*  529306 */   // Label 8789: @529306
     /*  529306 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(529377), // Rule ID 21247 //
     /*  529311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  529322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  529325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  529328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529343 */     // MIs[0] round
     /*  529343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529353 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  529356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529362 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529375 */     GIR_RootConstrainSelectedInstOperands,
     /*  529376 */     // GIR_Coverage, 21247,
     /*  529376 */     GIR_EraseRootFromParent_Done,
     /*  529377 */   // Label 8790: @529377
     /*  529377 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(529448), // Rule ID 21250 //
     /*  529382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  529393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  529396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  529399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529414 */     // MIs[0] round
     /*  529414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  529427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529433 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529446 */     GIR_RootConstrainSelectedInstOperands,
     /*  529447 */     // GIR_Coverage, 21250,
     /*  529447 */     GIR_EraseRootFromParent_Done,
     /*  529448 */   // Label 8791: @529448
     /*  529448 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(529519), // Rule ID 21251 //
     /*  529453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  529464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  529467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  529470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529485 */     // MIs[0] round
     /*  529485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529495 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  529498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529504 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529517 */     GIR_RootConstrainSelectedInstOperands,
     /*  529518 */     // GIR_Coverage, 21251,
     /*  529518 */     GIR_EraseRootFromParent_Done,
     /*  529519 */   // Label 8792: @529519
     /*  529519 */   GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(529590), // Rule ID 21254 //
     /*  529524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  529535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  529538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529556 */     // MIs[0] round
     /*  529556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  529569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529575 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529588 */     GIR_RootConstrainSelectedInstOperands,
     /*  529589 */     // GIR_Coverage, 21254,
     /*  529589 */     GIR_EraseRootFromParent_Done,
     /*  529590 */   // Label 8793: @529590
     /*  529590 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(529661), // Rule ID 21255 //
     /*  529595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  529606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  529609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529627 */     // MIs[0] round
     /*  529627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529637 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  529640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529646 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529659 */     GIR_RootConstrainSelectedInstOperands,
     /*  529660 */     // GIR_Coverage, 21255,
     /*  529660 */     GIR_EraseRootFromParent_Done,
     /*  529661 */   // Label 8794: @529661
     /*  529661 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(529732), // Rule ID 21258 //
     /*  529666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  529677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  529680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  529683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529698 */     // MIs[0] round
     /*  529698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529708 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  529711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529717 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529730 */     GIR_RootConstrainSelectedInstOperands,
     /*  529731 */     // GIR_Coverage, 21258,
     /*  529731 */     GIR_EraseRootFromParent_Done,
     /*  529732 */   // Label 8795: @529732
     /*  529732 */   GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(529803), // Rule ID 21259 //
     /*  529737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  529748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  529751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  529754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529769 */     // MIs[0] round
     /*  529769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529779 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  529782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529788 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529801 */     GIR_RootConstrainSelectedInstOperands,
     /*  529802 */     // GIR_Coverage, 21259,
     /*  529802 */     GIR_EraseRootFromParent_Done,
     /*  529803 */   // Label 8796: @529803
     /*  529803 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(529874), // Rule ID 21262 //
     /*  529808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  529819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  529822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  529825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529840 */     // MIs[0] round
     /*  529840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529850 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  529853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529859 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529872 */     GIR_RootConstrainSelectedInstOperands,
     /*  529873 */     // GIR_Coverage, 21262,
     /*  529873 */     GIR_EraseRootFromParent_Done,
     /*  529874 */   // Label 8797: @529874
     /*  529874 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(529945), // Rule ID 21263 //
     /*  529879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  529890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  529893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  529896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529911 */     // MIs[0] round
     /*  529911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529921 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  529924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529930 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529943 */     GIR_RootConstrainSelectedInstOperands,
     /*  529944 */     // GIR_Coverage, 21263,
     /*  529944 */     GIR_EraseRootFromParent_Done,
     /*  529945 */   // Label 8798: @529945
     /*  529945 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(530016), // Rule ID 21614 //
     /*  529950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  529961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  529964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  529967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529982 */     // MIs[0] round
     /*  529982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529992 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  529995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530001 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530014 */     GIR_RootConstrainSelectedInstOperands,
     /*  530015 */     // GIR_Coverage, 21614,
     /*  530015 */     GIR_EraseRootFromParent_Done,
     /*  530016 */   // Label 8799: @530016
     /*  530016 */   GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(530087), // Rule ID 21615 //
     /*  530021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  530032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  530035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  530038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530053 */     // MIs[0] round
     /*  530053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530063 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  530066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530072 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530085 */     GIR_RootConstrainSelectedInstOperands,
     /*  530086 */     // GIR_Coverage, 21615,
     /*  530086 */     GIR_EraseRootFromParent_Done,
     /*  530087 */   // Label 8800: @530087
     /*  530087 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(530158), // Rule ID 21618 //
     /*  530092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  530103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  530106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  530109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530124 */     // MIs[0] round
     /*  530124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530134 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  530137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530143 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530156 */     GIR_RootConstrainSelectedInstOperands,
     /*  530157 */     // GIR_Coverage, 21618,
     /*  530157 */     GIR_EraseRootFromParent_Done,
     /*  530158 */   // Label 8801: @530158
     /*  530158 */   GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(530229), // Rule ID 21619 //
     /*  530163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  530174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  530177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  530180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530195 */     // MIs[0] round
     /*  530195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530205 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  530208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530214 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530227 */     GIR_RootConstrainSelectedInstOperands,
     /*  530228 */     // GIR_Coverage, 21619,
     /*  530228 */     GIR_EraseRootFromParent_Done,
     /*  530229 */   // Label 8802: @530229
     /*  530229 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(530300), // Rule ID 21622 //
     /*  530234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  530245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  530248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  530251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530266 */     // MIs[0] round
     /*  530266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530276 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530285 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530298 */     GIR_RootConstrainSelectedInstOperands,
     /*  530299 */     // GIR_Coverage, 21622,
     /*  530299 */     GIR_EraseRootFromParent_Done,
     /*  530300 */   // Label 8803: @530300
     /*  530300 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(530371), // Rule ID 21623 //
     /*  530305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  530316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  530319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  530322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530337 */     // MIs[0] round
     /*  530337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530347 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530356 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530369 */     GIR_RootConstrainSelectedInstOperands,
     /*  530370 */     // GIR_Coverage, 21623,
     /*  530370 */     GIR_EraseRootFromParent_Done,
     /*  530371 */   // Label 8804: @530371
     /*  530371 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(530442), // Rule ID 21626 //
     /*  530376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  530387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  530390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  530393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530408 */     // MIs[0] round
     /*  530408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530418 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530427 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530440 */     GIR_RootConstrainSelectedInstOperands,
     /*  530441 */     // GIR_Coverage, 21626,
     /*  530441 */     GIR_EraseRootFromParent_Done,
     /*  530442 */   // Label 8805: @530442
     /*  530442 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(530513), // Rule ID 21627 //
     /*  530447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  530458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  530461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  530464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530479 */     // MIs[0] round
     /*  530479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530489 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530498 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530511 */     GIR_RootConstrainSelectedInstOperands,
     /*  530512 */     // GIR_Coverage, 21627,
     /*  530512 */     GIR_EraseRootFromParent_Done,
     /*  530513 */   // Label 8806: @530513
     /*  530513 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(530584), // Rule ID 21630 //
     /*  530518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  530529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  530532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  530535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530550 */     // MIs[0] round
     /*  530550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530560 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530569 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530582 */     GIR_RootConstrainSelectedInstOperands,
     /*  530583 */     // GIR_Coverage, 21630,
     /*  530583 */     GIR_EraseRootFromParent_Done,
     /*  530584 */   // Label 8807: @530584
     /*  530584 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(530655), // Rule ID 21631 //
     /*  530589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  530600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  530603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  530606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530621 */     // MIs[0] round
     /*  530621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530631 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530640 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530653 */     GIR_RootConstrainSelectedInstOperands,
     /*  530654 */     // GIR_Coverage, 21631,
     /*  530654 */     GIR_EraseRootFromParent_Done,
     /*  530655 */   // Label 8808: @530655
     /*  530655 */   GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(530726), // Rule ID 21634 //
     /*  530660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  530671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  530674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  530677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530692 */     // MIs[0] round
     /*  530692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530702 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  530705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530711 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530724 */     GIR_RootConstrainSelectedInstOperands,
     /*  530725 */     // GIR_Coverage, 21634,
     /*  530725 */     GIR_EraseRootFromParent_Done,
     /*  530726 */   // Label 8809: @530726
     /*  530726 */   GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(530797), // Rule ID 21635 //
     /*  530731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  530742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  530745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  530748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530763 */     // MIs[0] round
     /*  530763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530773 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  530776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530782 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530795 */     GIR_RootConstrainSelectedInstOperands,
     /*  530796 */     // GIR_Coverage, 21635,
     /*  530796 */     GIR_EraseRootFromParent_Done,
     /*  530797 */   // Label 8810: @530797
     /*  530797 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(530868), // Rule ID 21638 //
     /*  530802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  530813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  530816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  530819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530834 */     // MIs[0] round
     /*  530834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530844 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  530847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530853 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530866 */     GIR_RootConstrainSelectedInstOperands,
     /*  530867 */     // GIR_Coverage, 21638,
     /*  530867 */     GIR_EraseRootFromParent_Done,
     /*  530868 */   // Label 8811: @530868
     /*  530868 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(530939), // Rule ID 21639 //
     /*  530873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  530884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  530887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  530890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530905 */     // MIs[0] round
     /*  530905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530915 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  530918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530924 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530937 */     GIR_RootConstrainSelectedInstOperands,
     /*  530938 */     // GIR_Coverage, 21639,
     /*  530938 */     GIR_EraseRootFromParent_Done,
     /*  530939 */   // Label 8812: @530939
     /*  530939 */   GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(531010), // Rule ID 21642 //
     /*  530944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  530955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  530958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  530961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530976 */     // MIs[0] round
     /*  530976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530986 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530995 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531008 */     GIR_RootConstrainSelectedInstOperands,
     /*  531009 */     // GIR_Coverage, 21642,
     /*  531009 */     GIR_EraseRootFromParent_Done,
     /*  531010 */   // Label 8813: @531010
     /*  531010 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(531081), // Rule ID 21643 //
     /*  531015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  531018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  531026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  531029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  531032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531047 */     // MIs[0] round
     /*  531047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531057 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  531060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531066 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531079 */     GIR_RootConstrainSelectedInstOperands,
     /*  531080 */     // GIR_Coverage, 21643,
     /*  531080 */     GIR_EraseRootFromParent_Done,
     /*  531081 */   // Label 8814: @531081
     /*  531081 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(531152), // Rule ID 21646 //
     /*  531086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  531089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  531097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  531100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  531103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531118 */     // MIs[0] round
     /*  531118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531128 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  531131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531137 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531150 */     GIR_RootConstrainSelectedInstOperands,
     /*  531151 */     // GIR_Coverage, 21646,
     /*  531151 */     GIR_EraseRootFromParent_Done,
     /*  531152 */   // Label 8815: @531152
     /*  531152 */   GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(531223), // Rule ID 21647 //
     /*  531157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  531160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  531168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  531171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  531174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531189 */     // MIs[0] round
     /*  531189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531199 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  531202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531208 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531221 */     GIR_RootConstrainSelectedInstOperands,
     /*  531222 */     // GIR_Coverage, 21647,
     /*  531222 */     GIR_EraseRootFromParent_Done,
     /*  531223 */   // Label 8816: @531223
     /*  531223 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(531294), // Rule ID 21650 //
     /*  531228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  531231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  531239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  531242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  531245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531260 */     // MIs[0] round
     /*  531260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531270 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  531273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531279 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531292 */     GIR_RootConstrainSelectedInstOperands,
     /*  531293 */     // GIR_Coverage, 21650,
     /*  531293 */     GIR_EraseRootFromParent_Done,
     /*  531294 */   // Label 8817: @531294
     /*  531294 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(531365), // Rule ID 21651 //
     /*  531299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  531302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  531310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  531313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  531316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531331 */     // MIs[0] round
     /*  531331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531341 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  531344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531350 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531363 */     GIR_RootConstrainSelectedInstOperands,
     /*  531364 */     // GIR_Coverage, 21651,
     /*  531364 */     GIR_EraseRootFromParent_Done,
     /*  531365 */   // Label 8818: @531365
     /*  531365 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(531436), // Rule ID 21654 //
     /*  531370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  531373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  531381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  531384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  531387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531402 */     // MIs[0] round
     /*  531402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531412 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531421 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531434 */     GIR_RootConstrainSelectedInstOperands,
     /*  531435 */     // GIR_Coverage, 21654,
     /*  531435 */     GIR_EraseRootFromParent_Done,
     /*  531436 */   // Label 8819: @531436
     /*  531436 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(531507), // Rule ID 21655 //
     /*  531441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  531444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  531452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  531455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  531458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531473 */     // MIs[0] round
     /*  531473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531483 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531492 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531505 */     GIR_RootConstrainSelectedInstOperands,
     /*  531506 */     // GIR_Coverage, 21655,
     /*  531506 */     GIR_EraseRootFromParent_Done,
     /*  531507 */   // Label 8820: @531507
     /*  531507 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(531578), // Rule ID 21658 //
     /*  531512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  531523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  531526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  531529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531544 */     // MIs[0] round
     /*  531544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  531557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531563 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531576 */     GIR_RootConstrainSelectedInstOperands,
     /*  531577 */     // GIR_Coverage, 21658,
     /*  531577 */     GIR_EraseRootFromParent_Done,
     /*  531578 */   // Label 8821: @531578
     /*  531578 */   GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(531649), // Rule ID 21659 //
     /*  531583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  531594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  531597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  531600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531615 */     // MIs[0] round
     /*  531615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531625 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  531628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531634 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531647 */     GIR_RootConstrainSelectedInstOperands,
     /*  531648 */     // GIR_Coverage, 21659,
     /*  531648 */     GIR_EraseRootFromParent_Done,
     /*  531649 */   // Label 8822: @531649
     /*  531649 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(531720), // Rule ID 21662 //
     /*  531654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  531665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  531668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  531671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531686 */     // MIs[0] round
     /*  531686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  531699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531705 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531718 */     GIR_RootConstrainSelectedInstOperands,
     /*  531719 */     // GIR_Coverage, 21662,
     /*  531719 */     GIR_EraseRootFromParent_Done,
     /*  531720 */   // Label 8823: @531720
     /*  531720 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(531791), // Rule ID 21663 //
     /*  531725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  531736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  531739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  531742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531757 */     // MIs[0] round
     /*  531757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531767 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  531770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531776 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531789 */     GIR_RootConstrainSelectedInstOperands,
     /*  531790 */     // GIR_Coverage, 21663,
     /*  531790 */     GIR_EraseRootFromParent_Done,
     /*  531791 */   // Label 8824: @531791
     /*  531791 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(531862), // Rule ID 21666 //
     /*  531796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  531807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  531810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  531813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531828 */     // MIs[0] round
     /*  531828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  531841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531847 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531860 */     GIR_RootConstrainSelectedInstOperands,
     /*  531861 */     // GIR_Coverage, 21666,
     /*  531861 */     GIR_EraseRootFromParent_Done,
     /*  531862 */   // Label 8825: @531862
     /*  531862 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(531933), // Rule ID 21667 //
     /*  531867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  531878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  531881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  531884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531899 */     // MIs[0] round
     /*  531899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531909 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  531912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531918 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531931 */     GIR_RootConstrainSelectedInstOperands,
     /*  531932 */     // GIR_Coverage, 21667,
     /*  531932 */     GIR_EraseRootFromParent_Done,
     /*  531933 */   // Label 8826: @531933
     /*  531933 */   GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(532004), // Rule ID 21670 //
     /*  531938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  531949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  531952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  531955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531970 */     // MIs[0] round
     /*  531970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531989 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532002 */     GIR_RootConstrainSelectedInstOperands,
     /*  532003 */     // GIR_Coverage, 21670,
     /*  532003 */     GIR_EraseRootFromParent_Done,
     /*  532004 */   // Label 8827: @532004
     /*  532004 */   GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(532075), // Rule ID 21671 //
     /*  532009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  532012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  532017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  532020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  532023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  532026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532041 */     // MIs[0] round
     /*  532041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532051 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  532051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  532054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532060 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532073 */     GIR_RootConstrainSelectedInstOperands,
     /*  532074 */     // GIR_Coverage, 21671,
     /*  532074 */     GIR_EraseRootFromParent_Done,
     /*  532075 */   // Label 8828: @532075
     /*  532075 */   GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(532146), // Rule ID 21674 //
     /*  532080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  532091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  532094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  532097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532112 */     // MIs[0] round
     /*  532112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532122 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  532125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532131 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532144 */     GIR_RootConstrainSelectedInstOperands,
     /*  532145 */     // GIR_Coverage, 21674,
     /*  532145 */     GIR_EraseRootFromParent_Done,
     /*  532146 */   // Label 8829: @532146
     /*  532146 */   GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(532217), // Rule ID 21675 //
     /*  532151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  532162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  532165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  532168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532183 */     // MIs[0] round
     /*  532183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532193 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  532196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532202 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532215 */     GIR_RootConstrainSelectedInstOperands,
     /*  532216 */     // GIR_Coverage, 21675,
     /*  532216 */     GIR_EraseRootFromParent_Done,
     /*  532217 */   // Label 8830: @532217
     /*  532217 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(532288), // Rule ID 21678 //
     /*  532222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  532233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  532236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  532239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532254 */     // MIs[0] round
     /*  532254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532264 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  532267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532273 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532286 */     GIR_RootConstrainSelectedInstOperands,
     /*  532287 */     // GIR_Coverage, 21678,
     /*  532287 */     GIR_EraseRootFromParent_Done,
     /*  532288 */   // Label 8831: @532288
     /*  532288 */   GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(532359), // Rule ID 21679 //
     /*  532293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  532304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  532307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  532310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532325 */     // MIs[0] round
     /*  532325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532335 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  532338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532344 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532357 */     GIR_RootConstrainSelectedInstOperands,
     /*  532358 */     // GIR_Coverage, 21679,
     /*  532358 */     GIR_EraseRootFromParent_Done,
     /*  532359 */   // Label 8832: @532359
     /*  532359 */   GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(532430), // Rule ID 21682 //
     /*  532364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  532375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  532378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  532381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532396 */     // MIs[0] round
     /*  532396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532406 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532415 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532428 */     GIR_RootConstrainSelectedInstOperands,
     /*  532429 */     // GIR_Coverage, 21682,
     /*  532429 */     GIR_EraseRootFromParent_Done,
     /*  532430 */   // Label 8833: @532430
     /*  532430 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(532501), // Rule ID 21683 //
     /*  532435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  532446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  532449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  532452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532467 */     // MIs[0] round
     /*  532467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532477 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532486 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532499 */     GIR_RootConstrainSelectedInstOperands,
     /*  532500 */     // GIR_Coverage, 21683,
     /*  532500 */     GIR_EraseRootFromParent_Done,
     /*  532501 */   // Label 8834: @532501
     /*  532501 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(532572), // Rule ID 21686 //
     /*  532506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  532517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  532520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532538 */     // MIs[0] round
     /*  532538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532548 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532557 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532570 */     GIR_RootConstrainSelectedInstOperands,
     /*  532571 */     // GIR_Coverage, 21686,
     /*  532571 */     GIR_EraseRootFromParent_Done,
     /*  532572 */   // Label 8835: @532572
     /*  532572 */   GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(532643), // Rule ID 21687 //
     /*  532577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  532588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  532591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532609 */     // MIs[0] round
     /*  532609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532619 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532628 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532641 */     GIR_RootConstrainSelectedInstOperands,
     /*  532642 */     // GIR_Coverage, 21687,
     /*  532642 */     GIR_EraseRootFromParent_Done,
     /*  532643 */   // Label 8836: @532643
     /*  532643 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(532714), // Rule ID 21690 //
     /*  532648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  532659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  532662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532680 */     // MIs[0] round
     /*  532680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532690 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532699 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532712 */     GIR_RootConstrainSelectedInstOperands,
     /*  532713 */     // GIR_Coverage, 21690,
     /*  532713 */     GIR_EraseRootFromParent_Done,
     /*  532714 */   // Label 8837: @532714
     /*  532714 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(532785), // Rule ID 21691 //
     /*  532719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  532730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  532733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532751 */     // MIs[0] round
     /*  532751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532761 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532770 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532783 */     GIR_RootConstrainSelectedInstOperands,
     /*  532784 */     // GIR_Coverage, 21691,
     /*  532784 */     GIR_EraseRootFromParent_Done,
     /*  532785 */   // Label 8838: @532785
     /*  532785 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(532856), // Rule ID 21694 //
     /*  532790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  532801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  532804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  532807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532822 */     // MIs[0] round
     /*  532822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532832 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  532835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532841 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532854 */     GIR_RootConstrainSelectedInstOperands,
     /*  532855 */     // GIR_Coverage, 21694,
     /*  532855 */     GIR_EraseRootFromParent_Done,
     /*  532856 */   // Label 8839: @532856
     /*  532856 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(532927), // Rule ID 21695 //
     /*  532861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  532872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  532875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  532878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532893 */     // MIs[0] round
     /*  532893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532903 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  532906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532912 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532925 */     GIR_RootConstrainSelectedInstOperands,
     /*  532926 */     // GIR_Coverage, 21695,
     /*  532926 */     GIR_EraseRootFromParent_Done,
     /*  532927 */   // Label 8840: @532927
     /*  532927 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(532998), // Rule ID 21698 //
     /*  532932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  532943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  532946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  532949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532964 */     // MIs[0] round
     /*  532964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532974 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  532977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532983 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532996 */     GIR_RootConstrainSelectedInstOperands,
     /*  532997 */     // GIR_Coverage, 21698,
     /*  532997 */     GIR_EraseRootFromParent_Done,
     /*  532998 */   // Label 8841: @532998
     /*  532998 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(533069), // Rule ID 21699 //
     /*  533003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  533006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  533014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  533017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  533020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533035 */     // MIs[0] round
     /*  533035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533045 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  533048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533054 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533067 */     GIR_RootConstrainSelectedInstOperands,
     /*  533068 */     // GIR_Coverage, 21699,
     /*  533068 */     GIR_EraseRootFromParent_Done,
     /*  533069 */   // Label 8842: @533069
     /*  533069 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(533140), // Rule ID 21702 //
     /*  533074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  533077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  533085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  533088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  533091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533106 */     // MIs[0] round
     /*  533106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533116 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  533119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533125 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533138 */     GIR_RootConstrainSelectedInstOperands,
     /*  533139 */     // GIR_Coverage, 21702,
     /*  533139 */     GIR_EraseRootFromParent_Done,
     /*  533140 */   // Label 8843: @533140
     /*  533140 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(533211), // Rule ID 21703 //
     /*  533145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  533148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  533156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  533159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  533162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533177 */     // MIs[0] round
     /*  533177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533187 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  533190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533196 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533209 */     GIR_RootConstrainSelectedInstOperands,
     /*  533210 */     // GIR_Coverage, 21703,
     /*  533210 */     GIR_EraseRootFromParent_Done,
     /*  533211 */   // Label 8844: @533211
     /*  533211 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(533282), // Rule ID 21706 //
     /*  533216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  533219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  533227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  533230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  533233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533248 */     // MIs[0] round
     /*  533248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533258 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  533261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533267 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533280 */     GIR_RootConstrainSelectedInstOperands,
     /*  533281 */     // GIR_Coverage, 21706,
     /*  533281 */     GIR_EraseRootFromParent_Done,
     /*  533282 */   // Label 8845: @533282
     /*  533282 */   GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(533353), // Rule ID 21707 //
     /*  533287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  533290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  533298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  533301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  533304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533319 */     // MIs[0] round
     /*  533319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533329 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  533332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533338 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533351 */     GIR_RootConstrainSelectedInstOperands,
     /*  533352 */     // GIR_Coverage, 21707,
     /*  533352 */     GIR_EraseRootFromParent_Done,
     /*  533353 */   // Label 8846: @533353
     /*  533353 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(533424), // Rule ID 21710 //
     /*  533358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  533361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  533369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  533372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  533375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533390 */     // MIs[0] round
     /*  533390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533409 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533422 */     GIR_RootConstrainSelectedInstOperands,
     /*  533423 */     // GIR_Coverage, 21710,
     /*  533423 */     GIR_EraseRootFromParent_Done,
     /*  533424 */   // Label 8847: @533424
     /*  533424 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(533495), // Rule ID 21711 //
     /*  533429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  533432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  533440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  533443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  533446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533461 */     // MIs[0] round
     /*  533461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533480 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533493 */     GIR_RootConstrainSelectedInstOperands,
     /*  533494 */     // GIR_Coverage, 21711,
     /*  533494 */     GIR_EraseRootFromParent_Done,
     /*  533495 */   // Label 8848: @533495
     /*  533495 */   GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(533566), // Rule ID 21714 //
     /*  533500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  533503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  533511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  533514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  533517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533532 */     // MIs[0] round
     /*  533532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533542 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533551 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533564 */     GIR_RootConstrainSelectedInstOperands,
     /*  533565 */     // GIR_Coverage, 21714,
     /*  533565 */     GIR_EraseRootFromParent_Done,
     /*  533566 */   // Label 8849: @533566
     /*  533566 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(533637), // Rule ID 21715 //
     /*  533571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  533574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  533582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  533585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  533588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533603 */     // MIs[0] round
     /*  533603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533613 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533622 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533635 */     GIR_RootConstrainSelectedInstOperands,
     /*  533636 */     // GIR_Coverage, 21715,
     /*  533636 */     GIR_EraseRootFromParent_Done,
     /*  533637 */   // Label 8850: @533637
     /*  533637 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(533708), // Rule ID 21718 //
     /*  533642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  533653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  533656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  533659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533674 */     // MIs[0] round
     /*  533674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  533687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533693 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533706 */     GIR_RootConstrainSelectedInstOperands,
     /*  533707 */     // GIR_Coverage, 21718,
     /*  533707 */     GIR_EraseRootFromParent_Done,
     /*  533708 */   // Label 8851: @533708
     /*  533708 */   GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(533779), // Rule ID 21719 //
     /*  533713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  533724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  533727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  533730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533745 */     // MIs[0] round
     /*  533745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533755 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  533758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533764 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533777 */     GIR_RootConstrainSelectedInstOperands,
     /*  533778 */     // GIR_Coverage, 21719,
     /*  533778 */     GIR_EraseRootFromParent_Done,
     /*  533779 */   // Label 8852: @533779
     /*  533779 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(533850), // Rule ID 21722 //
     /*  533784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  533795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  533798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  533801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533816 */     // MIs[0] round
     /*  533816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  533829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533835 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533848 */     GIR_RootConstrainSelectedInstOperands,
     /*  533849 */     // GIR_Coverage, 21722,
     /*  533849 */     GIR_EraseRootFromParent_Done,
     /*  533850 */   // Label 8853: @533850
     /*  533850 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(533921), // Rule ID 21723 //
     /*  533855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  533866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  533869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  533872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533887 */     // MIs[0] round
     /*  533887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533897 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  533900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533906 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533919 */     GIR_RootConstrainSelectedInstOperands,
     /*  533920 */     // GIR_Coverage, 21723,
     /*  533920 */     GIR_EraseRootFromParent_Done,
     /*  533921 */   // Label 8854: @533921
     /*  533921 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(533992), // Rule ID 21726 //
     /*  533926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  533937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  533940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  533943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533958 */     // MIs[0] round
     /*  533958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533977 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533990 */     GIR_RootConstrainSelectedInstOperands,
     /*  533991 */     // GIR_Coverage, 21726,
     /*  533991 */     GIR_EraseRootFromParent_Done,
     /*  533992 */   // Label 8855: @533992
     /*  533992 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(534063), // Rule ID 21727 //
     /*  533997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  534000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  534005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  534008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  534011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  534014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534029 */     // MIs[0] round
     /*  534029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  534042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534048 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534061 */     GIR_RootConstrainSelectedInstOperands,
     /*  534062 */     // GIR_Coverage, 21727,
     /*  534062 */     GIR_EraseRootFromParent_Done,
     /*  534063 */   // Label 8856: @534063
     /*  534063 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(534134), // Rule ID 21730 //
     /*  534068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  534071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  534076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  534079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  534082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  534085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534100 */     // MIs[0] round
     /*  534100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534110 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  534113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534119 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534132 */     GIR_RootConstrainSelectedInstOperands,
     /*  534133 */     // GIR_Coverage, 21730,
     /*  534133 */     GIR_EraseRootFromParent_Done,
     /*  534134 */   // Label 8857: @534134
     /*  534134 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(534205), // Rule ID 21731 //
     /*  534139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  534142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  534147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  534150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  534153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  534156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534171 */     // MIs[0] round
     /*  534171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534181 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  534184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534190 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534203 */     GIR_RootConstrainSelectedInstOperands,
     /*  534204 */     // GIR_Coverage, 21731,
     /*  534204 */     GIR_EraseRootFromParent_Done,
     /*  534205 */   // Label 8858: @534205
     /*  534205 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(534276), // Rule ID 21854 //
     /*  534210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  534221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  534224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  534227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534242 */     // MIs[0] round
     /*  534242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534252 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  534255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534261 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534274 */     GIR_RootConstrainSelectedInstOperands,
     /*  534275 */     // GIR_Coverage, 21854,
     /*  534275 */     GIR_EraseRootFromParent_Done,
     /*  534276 */   // Label 8859: @534276
     /*  534276 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(534347), // Rule ID 21855 //
     /*  534281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  534292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  534295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  534298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534313 */     // MIs[0] round
     /*  534313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534323 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  534326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534332 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534345 */     GIR_RootConstrainSelectedInstOperands,
     /*  534346 */     // GIR_Coverage, 21855,
     /*  534346 */     GIR_EraseRootFromParent_Done,
     /*  534347 */   // Label 8860: @534347
     /*  534347 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(534418), // Rule ID 21858 //
     /*  534352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  534363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  534366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  534369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534384 */     // MIs[0] round
     /*  534384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534394 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  534397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534403 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534416 */     GIR_RootConstrainSelectedInstOperands,
     /*  534417 */     // GIR_Coverage, 21858,
     /*  534417 */     GIR_EraseRootFromParent_Done,
     /*  534418 */   // Label 8861: @534418
     /*  534418 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(534489), // Rule ID 21859 //
     /*  534423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  534434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  534437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  534440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534455 */     // MIs[0] round
     /*  534455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534465 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  534468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534474 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534487 */     GIR_RootConstrainSelectedInstOperands,
     /*  534488 */     // GIR_Coverage, 21859,
     /*  534488 */     GIR_EraseRootFromParent_Done,
     /*  534489 */   // Label 8862: @534489
     /*  534489 */   GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(534560), // Rule ID 21862 //
     /*  534494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534526 */     // MIs[0] round
     /*  534526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534536 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  534539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534545 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534558 */     GIR_RootConstrainSelectedInstOperands,
     /*  534559 */     // GIR_Coverage, 21862,
     /*  534559 */     GIR_EraseRootFromParent_Done,
     /*  534560 */   // Label 8863: @534560
     /*  534560 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(534631), // Rule ID 21863 //
     /*  534565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534597 */     // MIs[0] round
     /*  534597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534607 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  534610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534616 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534629 */     GIR_RootConstrainSelectedInstOperands,
     /*  534630 */     // GIR_Coverage, 21863,
     /*  534630 */     GIR_EraseRootFromParent_Done,
     /*  534631 */   // Label 8864: @534631
     /*  534631 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(534702), // Rule ID 21866 //
     /*  534636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534668 */     // MIs[0] round
     /*  534668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534678 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  534681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534687 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534700 */     GIR_RootConstrainSelectedInstOperands,
     /*  534701 */     // GIR_Coverage, 21866,
     /*  534701 */     GIR_EraseRootFromParent_Done,
     /*  534702 */   // Label 8865: @534702
     /*  534702 */   GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(534773), // Rule ID 21867 //
     /*  534707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534739 */     // MIs[0] round
     /*  534739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534749 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  534752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534758 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534771 */     GIR_RootConstrainSelectedInstOperands,
     /*  534772 */     // GIR_Coverage, 21867,
     /*  534772 */     GIR_EraseRootFromParent_Done,
     /*  534773 */   // Label 8866: @534773
     /*  534773 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(534844), // Rule ID 21870 //
     /*  534778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  534789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  534792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  534795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534810 */     // MIs[0] round
     /*  534810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534820 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  534823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534829 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534842 */     GIR_RootConstrainSelectedInstOperands,
     /*  534843 */     // GIR_Coverage, 21870,
     /*  534843 */     GIR_EraseRootFromParent_Done,
     /*  534844 */   // Label 8867: @534844
     /*  534844 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(534915), // Rule ID 21871 //
     /*  534849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  534860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  534863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  534866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534881 */     // MIs[0] round
     /*  534881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534891 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  534894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534900 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534913 */     GIR_RootConstrainSelectedInstOperands,
     /*  534914 */     // GIR_Coverage, 21871,
     /*  534914 */     GIR_EraseRootFromParent_Done,
     /*  534915 */   // Label 8868: @534915
     /*  534915 */   GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(534986), // Rule ID 21874 //
     /*  534920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  534937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534952 */     // MIs[0] round
     /*  534952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534962 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  534965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534971 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534984 */     GIR_RootConstrainSelectedInstOperands,
     /*  534985 */     // GIR_Coverage, 21874,
     /*  534985 */     GIR_EraseRootFromParent_Done,
     /*  534986 */   // Label 8869: @534986
     /*  534986 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(535057), // Rule ID 21875 //
     /*  534991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  535002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  535005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  535008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535023 */     // MIs[0] round
     /*  535023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535033 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  535036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535042 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535055 */     GIR_RootConstrainSelectedInstOperands,
     /*  535056 */     // GIR_Coverage, 21875,
     /*  535056 */     GIR_EraseRootFromParent_Done,
     /*  535057 */   // Label 8870: @535057
     /*  535057 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(535128), // Rule ID 21878 //
     /*  535062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  535070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535094 */     // MIs[0] round
     /*  535094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535104 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  535107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535113 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535126 */     GIR_RootConstrainSelectedInstOperands,
     /*  535127 */     // GIR_Coverage, 21878,
     /*  535127 */     GIR_EraseRootFromParent_Done,
     /*  535128 */   // Label 8871: @535128
     /*  535128 */   GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(535199), // Rule ID 21879 //
     /*  535133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  535141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535165 */     // MIs[0] round
     /*  535165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535175 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  535178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535184 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535197 */     GIR_RootConstrainSelectedInstOperands,
     /*  535198 */     // GIR_Coverage, 21879,
     /*  535198 */     GIR_EraseRootFromParent_Done,
     /*  535199 */   // Label 8872: @535199
     /*  535199 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(535270), // Rule ID 21882 //
     /*  535204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  535212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  535215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  535218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  535221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535236 */     // MIs[0] round
     /*  535236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535246 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  535249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535255 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535268 */     GIR_RootConstrainSelectedInstOperands,
     /*  535269 */     // GIR_Coverage, 21882,
     /*  535269 */     GIR_EraseRootFromParent_Done,
     /*  535270 */   // Label 8873: @535270
     /*  535270 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(535341), // Rule ID 21883 //
     /*  535275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  535283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  535286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  535289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  535292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535307 */     // MIs[0] round
     /*  535307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535317 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  535320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535326 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535339 */     GIR_RootConstrainSelectedInstOperands,
     /*  535340 */     // GIR_Coverage, 21883,
     /*  535340 */     GIR_EraseRootFromParent_Done,
     /*  535341 */   // Label 8874: @535341
     /*  535341 */   GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(535412), // Rule ID 21886 //
     /*  535346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  535354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  535357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  535360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  535363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535378 */     // MIs[0] round
     /*  535378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535388 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  535391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535397 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535410 */     GIR_RootConstrainSelectedInstOperands,
     /*  535411 */     // GIR_Coverage, 21886,
     /*  535411 */     GIR_EraseRootFromParent_Done,
     /*  535412 */   // Label 8875: @535412
     /*  535412 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(535483), // Rule ID 21887 //
     /*  535417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  535425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  535428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  535431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  535434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535449 */     // MIs[0] round
     /*  535449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535459 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  535462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535468 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535481 */     GIR_RootConstrainSelectedInstOperands,
     /*  535482 */     // GIR_Coverage, 21887,
     /*  535482 */     GIR_EraseRootFromParent_Done,
     /*  535483 */   // Label 8876: @535483
     /*  535483 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(535554), // Rule ID 21890 //
     /*  535488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  535499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  535502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  535505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535520 */     // MIs[0] round
     /*  535520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535530 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  535533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535539 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535552 */     GIR_RootConstrainSelectedInstOperands,
     /*  535553 */     // GIR_Coverage, 21890,
     /*  535553 */     GIR_EraseRootFromParent_Done,
     /*  535554 */   // Label 8877: @535554
     /*  535554 */   GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(535625), // Rule ID 21891 //
     /*  535559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  535570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  535573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  535576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535591 */     // MIs[0] round
     /*  535591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535601 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  535604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535610 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535623 */     GIR_RootConstrainSelectedInstOperands,
     /*  535624 */     // GIR_Coverage, 21891,
     /*  535624 */     GIR_EraseRootFromParent_Done,
     /*  535625 */   // Label 8878: @535625
     /*  535625 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(535696), // Rule ID 21894 //
     /*  535630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  535641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  535644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  535647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535662 */     // MIs[0] round
     /*  535662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535672 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  535675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535681 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535694 */     GIR_RootConstrainSelectedInstOperands,
     /*  535695 */     // GIR_Coverage, 21894,
     /*  535695 */     GIR_EraseRootFromParent_Done,
     /*  535696 */   // Label 8879: @535696
     /*  535696 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(535767), // Rule ID 21895 //
     /*  535701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  535712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  535715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  535718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535733 */     // MIs[0] round
     /*  535733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535743 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  535746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535752 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535765 */     GIR_RootConstrainSelectedInstOperands,
     /*  535766 */     // GIR_Coverage, 21895,
     /*  535766 */     GIR_EraseRootFromParent_Done,
     /*  535767 */   // Label 8880: @535767
     /*  535767 */   GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(535838), // Rule ID 21898 //
     /*  535772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  535783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  535786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  535789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535804 */     // MIs[0] round
     /*  535804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535814 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  535817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535823 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535836 */     GIR_RootConstrainSelectedInstOperands,
     /*  535837 */     // GIR_Coverage, 21898,
     /*  535837 */     GIR_EraseRootFromParent_Done,
     /*  535838 */   // Label 8881: @535838
     /*  535838 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(535909), // Rule ID 21899 //
     /*  535843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  535854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  535857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  535860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535875 */     // MIs[0] round
     /*  535875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535885 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  535888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535894 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535907 */     GIR_RootConstrainSelectedInstOperands,
     /*  535908 */     // GIR_Coverage, 21899,
     /*  535908 */     GIR_EraseRootFromParent_Done,
     /*  535909 */   // Label 8882: @535909
     /*  535909 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(535980), // Rule ID 21902 //
     /*  535914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  535925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  535928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  535931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535946 */     // MIs[0] round
     /*  535946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535956 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  535959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535965 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535978 */     GIR_RootConstrainSelectedInstOperands,
     /*  535979 */     // GIR_Coverage, 21902,
     /*  535979 */     GIR_EraseRootFromParent_Done,
     /*  535980 */   // Label 8883: @535980
     /*  535980 */   GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(536051), // Rule ID 21903 //
     /*  535985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  535996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  535999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536017 */     // MIs[0] round
     /*  536017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536027 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  536030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536036 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536049 */     GIR_RootConstrainSelectedInstOperands,
     /*  536050 */     // GIR_Coverage, 21903,
     /*  536050 */     GIR_EraseRootFromParent_Done,
     /*  536051 */   // Label 8884: @536051
     /*  536051 */   GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(536122), // Rule ID 21906 //
     /*  536056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  536059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536088 */     // MIs[0] round
     /*  536088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536098 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  536101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536107 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536120 */     GIR_RootConstrainSelectedInstOperands,
     /*  536121 */     // GIR_Coverage, 21906,
     /*  536121 */     GIR_EraseRootFromParent_Done,
     /*  536122 */   // Label 8885: @536122
     /*  536122 */   GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(536193), // Rule ID 21907 //
     /*  536127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  536130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536159 */     // MIs[0] round
     /*  536159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536169 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  536172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536178 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536191 */     GIR_RootConstrainSelectedInstOperands,
     /*  536192 */     // GIR_Coverage, 21907,
     /*  536192 */     GIR_EraseRootFromParent_Done,
     /*  536193 */   // Label 8886: @536193
     /*  536193 */   GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(536264), // Rule ID 21910 //
     /*  536198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  536201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  536209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  536212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  536215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536230 */     // MIs[0] round
     /*  536230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536240 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  536243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536249 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536262 */     GIR_RootConstrainSelectedInstOperands,
     /*  536263 */     // GIR_Coverage, 21910,
     /*  536263 */     GIR_EraseRootFromParent_Done,
     /*  536264 */   // Label 8887: @536264
     /*  536264 */   GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(536335), // Rule ID 21911 //
     /*  536269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  536272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  536280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  536283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  536286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536301 */     // MIs[0] round
     /*  536301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536311 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  536314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536320 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536333 */     GIR_RootConstrainSelectedInstOperands,
     /*  536334 */     // GIR_Coverage, 21911,
     /*  536334 */     GIR_EraseRootFromParent_Done,
     /*  536335 */   // Label 8888: @536335
     /*  536335 */   GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(536406), // Rule ID 21914 //
     /*  536340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  536343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  536351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  536354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  536357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536372 */     // MIs[0] round
     /*  536372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536382 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  536385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536391 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536404 */     GIR_RootConstrainSelectedInstOperands,
     /*  536405 */     // GIR_Coverage, 21914,
     /*  536405 */     GIR_EraseRootFromParent_Done,
     /*  536406 */   // Label 8889: @536406
     /*  536406 */   GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(536477), // Rule ID 21915 //
     /*  536411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  536414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  536422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  536425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  536428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536443 */     // MIs[0] round
     /*  536443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536453 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  536456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536462 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536475 */     GIR_RootConstrainSelectedInstOperands,
     /*  536476 */     // GIR_Coverage, 21915,
     /*  536476 */     GIR_EraseRootFromParent_Done,
     /*  536477 */   // Label 8890: @536477
     /*  536477 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(536548), // Rule ID 21918 //
     /*  536482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  536485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  536493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  536496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  536499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536514 */     // MIs[0] round
     /*  536514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536524 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  536527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536533 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536546 */     GIR_RootConstrainSelectedInstOperands,
     /*  536547 */     // GIR_Coverage, 21918,
     /*  536547 */     GIR_EraseRootFromParent_Done,
     /*  536548 */   // Label 8891: @536548
     /*  536548 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(536619), // Rule ID 21919 //
     /*  536553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  536556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  536564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  536567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  536570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536585 */     // MIs[0] round
     /*  536585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536595 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  536598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536604 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536617 */     GIR_RootConstrainSelectedInstOperands,
     /*  536618 */     // GIR_Coverage, 21919,
     /*  536618 */     GIR_EraseRootFromParent_Done,
     /*  536619 */   // Label 8892: @536619
     /*  536619 */   GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(536690), // Rule ID 21922 //
     /*  536624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  536627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  536635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  536638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  536641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536656 */     // MIs[0] round
     /*  536656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536666 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  536669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536675 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536688 */     GIR_RootConstrainSelectedInstOperands,
     /*  536689 */     // GIR_Coverage, 21922,
     /*  536689 */     GIR_EraseRootFromParent_Done,
     /*  536690 */   // Label 8893: @536690
     /*  536690 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(536761), // Rule ID 21923 //
     /*  536695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  536698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  536706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  536709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  536712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536727 */     // MIs[0] round
     /*  536727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536737 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  536740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536746 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536759 */     GIR_RootConstrainSelectedInstOperands,
     /*  536760 */     // GIR_Coverage, 21923,
     /*  536760 */     GIR_EraseRootFromParent_Done,
     /*  536761 */   // Label 8894: @536761
     /*  536761 */   GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(536832), // Rule ID 21926 //
     /*  536766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536798 */     // MIs[0] round
     /*  536798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536808 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  536811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536817 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536830 */     GIR_RootConstrainSelectedInstOperands,
     /*  536831 */     // GIR_Coverage, 21926,
     /*  536831 */     GIR_EraseRootFromParent_Done,
     /*  536832 */   // Label 8895: @536832
     /*  536832 */   GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(536903), // Rule ID 21927 //
     /*  536837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536869 */     // MIs[0] round
     /*  536869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536879 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  536882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536888 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536901 */     GIR_RootConstrainSelectedInstOperands,
     /*  536902 */     // GIR_Coverage, 21927,
     /*  536902 */     GIR_EraseRootFromParent_Done,
     /*  536903 */   // Label 8896: @536903
     /*  536903 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(536974), // Rule ID 21930 //
     /*  536908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536940 */     // MIs[0] round
     /*  536940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536950 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  536953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536959 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536972 */     GIR_RootConstrainSelectedInstOperands,
     /*  536973 */     // GIR_Coverage, 21930,
     /*  536973 */     GIR_EraseRootFromParent_Done,
     /*  536974 */   // Label 8897: @536974
     /*  536974 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(537045), // Rule ID 21931 //
     /*  536979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537011 */     // MIs[0] round
     /*  537011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537021 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  537024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537030 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537043 */     GIR_RootConstrainSelectedInstOperands,
     /*  537044 */     // GIR_Coverage, 21931,
     /*  537044 */     GIR_EraseRootFromParent_Done,
     /*  537045 */   // Label 8898: @537045
     /*  537045 */   GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(537116), // Rule ID 21934 //
     /*  537050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  537053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  537067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537082 */     // MIs[0] round
     /*  537082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537092 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  537095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537101 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537114 */     GIR_RootConstrainSelectedInstOperands,
     /*  537115 */     // GIR_Coverage, 21934,
     /*  537115 */     GIR_EraseRootFromParent_Done,
     /*  537116 */   // Label 8899: @537116
     /*  537116 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(537187), // Rule ID 21935 //
     /*  537121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  537124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  537138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537153 */     // MIs[0] round
     /*  537153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537163 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  537166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537172 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537185 */     GIR_RootConstrainSelectedInstOperands,
     /*  537186 */     // GIR_Coverage, 21935,
     /*  537186 */     GIR_EraseRootFromParent_Done,
     /*  537187 */   // Label 8900: @537187
     /*  537187 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(537258), // Rule ID 21938 //
     /*  537192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  537195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  537203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  537206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  537209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537224 */     // MIs[0] round
     /*  537224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537234 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  537237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537243 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537256 */     GIR_RootConstrainSelectedInstOperands,
     /*  537257 */     // GIR_Coverage, 21938,
     /*  537257 */     GIR_EraseRootFromParent_Done,
     /*  537258 */   // Label 8901: @537258
     /*  537258 */   GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(537329), // Rule ID 21939 //
     /*  537263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  537266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  537274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  537277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  537280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537295 */     // MIs[0] round
     /*  537295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537305 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  537308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537314 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537327 */     GIR_RootConstrainSelectedInstOperands,
     /*  537328 */     // GIR_Coverage, 21939,
     /*  537328 */     GIR_EraseRootFromParent_Done,
     /*  537329 */   // Label 8902: @537329
     /*  537329 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(537400), // Rule ID 21942 //
     /*  537334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  537337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  537345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  537348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  537351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537366 */     // MIs[0] round
     /*  537366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537376 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  537379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537385 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537398 */     GIR_RootConstrainSelectedInstOperands,
     /*  537399 */     // GIR_Coverage, 21942,
     /*  537399 */     GIR_EraseRootFromParent_Done,
     /*  537400 */   // Label 8903: @537400
     /*  537400 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(537471), // Rule ID 21943 //
     /*  537405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  537408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  537416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  537419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  537422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537437 */     // MIs[0] round
     /*  537437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537447 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  537450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537456 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537469 */     GIR_RootConstrainSelectedInstOperands,
     /*  537470 */     // GIR_Coverage, 21943,
     /*  537470 */     GIR_EraseRootFromParent_Done,
     /*  537471 */   // Label 8904: @537471
     /*  537471 */   GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(537542), // Rule ID 21946 //
     /*  537476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  537493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537508 */     // MIs[0] round
     /*  537508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537518 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  537521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537527 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537540 */     GIR_RootConstrainSelectedInstOperands,
     /*  537541 */     // GIR_Coverage, 21946,
     /*  537541 */     GIR_EraseRootFromParent_Done,
     /*  537542 */   // Label 8905: @537542
     /*  537542 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(537613), // Rule ID 21947 //
     /*  537547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  537564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537579 */     // MIs[0] round
     /*  537579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537589 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  537592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537598 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537611 */     GIR_RootConstrainSelectedInstOperands,
     /*  537612 */     // GIR_Coverage, 21947,
     /*  537612 */     GIR_EraseRootFromParent_Done,
     /*  537613 */   // Label 8906: @537613
     /*  537613 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(537684), // Rule ID 21950 //
     /*  537618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  537629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  537632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  537635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537650 */     // MIs[0] round
     /*  537650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537660 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  537663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537669 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537682 */     GIR_RootConstrainSelectedInstOperands,
     /*  537683 */     // GIR_Coverage, 21950,
     /*  537683 */     GIR_EraseRootFromParent_Done,
     /*  537684 */   // Label 8907: @537684
     /*  537684 */   GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(537755), // Rule ID 21951 //
     /*  537689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  537700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  537703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  537706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537721 */     // MIs[0] round
     /*  537721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537731 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  537734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537740 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537753 */     GIR_RootConstrainSelectedInstOperands,
     /*  537754 */     // GIR_Coverage, 21951,
     /*  537754 */     GIR_EraseRootFromParent_Done,
     /*  537755 */   // Label 8908: @537755
     /*  537755 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(537826), // Rule ID 21954 //
     /*  537760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  537771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  537774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  537777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537792 */     // MIs[0] round
     /*  537792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537802 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  537805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537811 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537824 */     GIR_RootConstrainSelectedInstOperands,
     /*  537825 */     // GIR_Coverage, 21954,
     /*  537825 */     GIR_EraseRootFromParent_Done,
     /*  537826 */   // Label 8909: @537826
     /*  537826 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(537897), // Rule ID 21955 //
     /*  537831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  537842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  537845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  537848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537863 */     // MIs[0] round
     /*  537863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537873 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  537876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537882 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537895 */     GIR_RootConstrainSelectedInstOperands,
     /*  537896 */     // GIR_Coverage, 21955,
     /*  537896 */     GIR_EraseRootFromParent_Done,
     /*  537897 */   // Label 8910: @537897
     /*  537897 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(537968), // Rule ID 21958 //
     /*  537902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  537913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  537916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537934 */     // MIs[0] round
     /*  537934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537944 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  537947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537953 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537966 */     GIR_RootConstrainSelectedInstOperands,
     /*  537967 */     // GIR_Coverage, 21958,
     /*  537967 */     GIR_EraseRootFromParent_Done,
     /*  537968 */   // Label 8911: @537968
     /*  537968 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(538039), // Rule ID 21959 //
     /*  537973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  537984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  537987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538005 */     // MIs[0] round
     /*  538005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538015 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  538018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538024 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538037 */     GIR_RootConstrainSelectedInstOperands,
     /*  538038 */     // GIR_Coverage, 21959,
     /*  538038 */     GIR_EraseRootFromParent_Done,
     /*  538039 */   // Label 8912: @538039
     /*  538039 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(538110), // Rule ID 2768 //
     /*  538044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  538055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  538058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  538061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538072 */     // MIs[0] passthru
     /*  538072 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538088 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  538091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538108 */     GIR_RootConstrainSelectedInstOperands,
     /*  538109 */     // GIR_Coverage, 2768,
     /*  538109 */     GIR_EraseRootFromParent_Done,
     /*  538110 */   // Label 8913: @538110
     /*  538110 */   GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(538181), // Rule ID 2769 //
     /*  538115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  538126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  538129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  538132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538143 */     // MIs[0] passthru
     /*  538143 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538159 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  538162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538179 */     GIR_RootConstrainSelectedInstOperands,
     /*  538180 */     // GIR_Coverage, 2769,
     /*  538180 */     GIR_EraseRootFromParent_Done,
     /*  538181 */   // Label 8914: @538181
     /*  538181 */   GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(538252), // Rule ID 4084 //
     /*  538186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  538197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  538200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  538203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538214 */     // MIs[0] passthru
     /*  538214 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538230 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  538233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538250 */     GIR_RootConstrainSelectedInstOperands,
     /*  538251 */     // GIR_Coverage, 4084,
     /*  538251 */     GIR_EraseRootFromParent_Done,
     /*  538252 */   // Label 8915: @538252
     /*  538252 */   GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(538323), // Rule ID 4085 //
     /*  538257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  538268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  538271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  538274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538285 */     // MIs[0] passthru
     /*  538285 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538301 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  538304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538321 */     GIR_RootConstrainSelectedInstOperands,
     /*  538322 */     // GIR_Coverage, 4085,
     /*  538322 */     GIR_EraseRootFromParent_Done,
     /*  538323 */   // Label 8916: @538323
     /*  538323 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(538394), // Rule ID 4094 //
     /*  538328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  538339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  538342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  538345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538356 */     // MIs[0] passthru
     /*  538356 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538372 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  538375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538392 */     GIR_RootConstrainSelectedInstOperands,
     /*  538393 */     // GIR_Coverage, 4094,
     /*  538393 */     GIR_EraseRootFromParent_Done,
     /*  538394 */   // Label 8917: @538394
     /*  538394 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(538465), // Rule ID 4095 //
     /*  538399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  538410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  538413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  538416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538427 */     // MIs[0] passthru
     /*  538427 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538443 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  538446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538463 */     GIR_RootConstrainSelectedInstOperands,
     /*  538464 */     // GIR_Coverage, 4095,
     /*  538464 */     GIR_EraseRootFromParent_Done,
     /*  538465 */   // Label 8918: @538465
     /*  538465 */   GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(538536), // Rule ID 4104 //
     /*  538470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  538481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  538484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  538487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538498 */     // MIs[0] passthru
     /*  538498 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538534 */     GIR_RootConstrainSelectedInstOperands,
     /*  538535 */     // GIR_Coverage, 4104,
     /*  538535 */     GIR_EraseRootFromParent_Done,
     /*  538536 */   // Label 8919: @538536
     /*  538536 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(538607), // Rule ID 4105 //
     /*  538541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  538552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  538555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  538558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538569 */     // MIs[0] passthru
     /*  538569 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538585 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538605 */     GIR_RootConstrainSelectedInstOperands,
     /*  538606 */     // GIR_Coverage, 4105,
     /*  538606 */     GIR_EraseRootFromParent_Done,
     /*  538607 */   // Label 8920: @538607
     /*  538607 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(538678), // Rule ID 4114 //
     /*  538612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  538623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  538626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  538629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538640 */     // MIs[0] passthru
     /*  538640 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538656 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538676 */     GIR_RootConstrainSelectedInstOperands,
     /*  538677 */     // GIR_Coverage, 4114,
     /*  538677 */     GIR_EraseRootFromParent_Done,
     /*  538678 */   // Label 8921: @538678
     /*  538678 */   GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(538749), // Rule ID 4115 //
     /*  538683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  538694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  538697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  538700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538711 */     // MIs[0] passthru
     /*  538711 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538727 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538747 */     GIR_RootConstrainSelectedInstOperands,
     /*  538748 */     // GIR_Coverage, 4115,
     /*  538748 */     GIR_EraseRootFromParent_Done,
     /*  538749 */   // Label 8922: @538749
     /*  538749 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(538820), // Rule ID 4124 //
     /*  538754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  538765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  538768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  538771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538782 */     // MIs[0] passthru
     /*  538782 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538798 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  538801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538818 */     GIR_RootConstrainSelectedInstOperands,
     /*  538819 */     // GIR_Coverage, 4124,
     /*  538819 */     GIR_EraseRootFromParent_Done,
     /*  538820 */   // Label 8923: @538820
     /*  538820 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(538891), // Rule ID 4125 //
     /*  538825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  538836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  538839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  538842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538853 */     // MIs[0] passthru
     /*  538853 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538869 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  538872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538889 */     GIR_RootConstrainSelectedInstOperands,
     /*  538890 */     // GIR_Coverage, 4125,
     /*  538890 */     GIR_EraseRootFromParent_Done,
     /*  538891 */   // Label 8924: @538891
     /*  538891 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(538962), // Rule ID 4134 //
     /*  538896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  538907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  538910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  538913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538924 */     // MIs[0] passthru
     /*  538924 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538940 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  538943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538960 */     GIR_RootConstrainSelectedInstOperands,
     /*  538961 */     // GIR_Coverage, 4134,
     /*  538961 */     GIR_EraseRootFromParent_Done,
     /*  538962 */   // Label 8925: @538962
     /*  538962 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(539033), // Rule ID 4135 //
     /*  538967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  538978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  538981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  538984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538995 */     // MIs[0] passthru
     /*  538995 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539011 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  539014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539031 */     GIR_RootConstrainSelectedInstOperands,
     /*  539032 */     // GIR_Coverage, 4135,
     /*  539032 */     GIR_EraseRootFromParent_Done,
     /*  539033 */   // Label 8926: @539033
     /*  539033 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(539104), // Rule ID 4144 //
     /*  539038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  539049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  539052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  539055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539066 */     // MIs[0] passthru
     /*  539066 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539082 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  539085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539102 */     GIR_RootConstrainSelectedInstOperands,
     /*  539103 */     // GIR_Coverage, 4144,
     /*  539103 */     GIR_EraseRootFromParent_Done,
     /*  539104 */   // Label 8927: @539104
     /*  539104 */   GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(539175), // Rule ID 4145 //
     /*  539109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  539120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  539123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  539126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539137 */     // MIs[0] passthru
     /*  539137 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539153 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  539156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539173 */     GIR_RootConstrainSelectedInstOperands,
     /*  539174 */     // GIR_Coverage, 4145,
     /*  539174 */     GIR_EraseRootFromParent_Done,
     /*  539175 */   // Label 8928: @539175
     /*  539175 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(539246), // Rule ID 4154 //
     /*  539180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  539191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  539194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  539197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539208 */     // MIs[0] passthru
     /*  539208 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539224 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  539227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539244 */     GIR_RootConstrainSelectedInstOperands,
     /*  539245 */     // GIR_Coverage, 4154,
     /*  539245 */     GIR_EraseRootFromParent_Done,
     /*  539246 */   // Label 8929: @539246
     /*  539246 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(539317), // Rule ID 4155 //
     /*  539251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  539262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  539265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  539268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539279 */     // MIs[0] passthru
     /*  539279 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  539298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539315 */     GIR_RootConstrainSelectedInstOperands,
     /*  539316 */     // GIR_Coverage, 4155,
     /*  539316 */     GIR_EraseRootFromParent_Done,
     /*  539317 */   // Label 8930: @539317
     /*  539317 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(539388), // Rule ID 4164 //
     /*  539322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  539333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  539336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  539339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539350 */     // MIs[0] passthru
     /*  539350 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539366 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  539369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539386 */     GIR_RootConstrainSelectedInstOperands,
     /*  539387 */     // GIR_Coverage, 4164,
     /*  539387 */     GIR_EraseRootFromParent_Done,
     /*  539388 */   // Label 8931: @539388
     /*  539388 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(539459), // Rule ID 4165 //
     /*  539393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  539404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  539407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  539410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539421 */     // MIs[0] passthru
     /*  539421 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539437 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  539440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539457 */     GIR_RootConstrainSelectedInstOperands,
     /*  539458 */     // GIR_Coverage, 4165,
     /*  539458 */     GIR_EraseRootFromParent_Done,
     /*  539459 */   // Label 8932: @539459
     /*  539459 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(539530), // Rule ID 4174 //
     /*  539464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  539475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  539478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  539481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539492 */     // MIs[0] passthru
     /*  539492 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539508 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539528 */     GIR_RootConstrainSelectedInstOperands,
     /*  539529 */     // GIR_Coverage, 4174,
     /*  539529 */     GIR_EraseRootFromParent_Done,
     /*  539530 */   // Label 8933: @539530
     /*  539530 */   GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(539601), // Rule ID 4175 //
     /*  539535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  539546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  539549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  539552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539563 */     // MIs[0] passthru
     /*  539563 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539579 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539599 */     GIR_RootConstrainSelectedInstOperands,
     /*  539600 */     // GIR_Coverage, 4175,
     /*  539600 */     GIR_EraseRootFromParent_Done,
     /*  539601 */   // Label 8934: @539601
     /*  539601 */   GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(539672), // Rule ID 4184 //
     /*  539606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  539617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  539620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  539623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539634 */     // MIs[0] passthru
     /*  539634 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539650 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  539653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539670 */     GIR_RootConstrainSelectedInstOperands,
     /*  539671 */     // GIR_Coverage, 4184,
     /*  539671 */     GIR_EraseRootFromParent_Done,
     /*  539672 */   // Label 8935: @539672
     /*  539672 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(539743), // Rule ID 4185 //
     /*  539677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  539688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  539691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  539694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539705 */     // MIs[0] passthru
     /*  539705 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539721 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  539724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539741 */     GIR_RootConstrainSelectedInstOperands,
     /*  539742 */     // GIR_Coverage, 4185,
     /*  539742 */     GIR_EraseRootFromParent_Done,
     /*  539743 */   // Label 8936: @539743
     /*  539743 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(539814), // Rule ID 4194 //
     /*  539748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  539759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  539762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  539765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539776 */     // MIs[0] passthru
     /*  539776 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539792 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  539795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539812 */     GIR_RootConstrainSelectedInstOperands,
     /*  539813 */     // GIR_Coverage, 4194,
     /*  539813 */     GIR_EraseRootFromParent_Done,
     /*  539814 */   // Label 8937: @539814
     /*  539814 */   GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(539885), // Rule ID 4195 //
     /*  539819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  539830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  539833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  539836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539847 */     // MIs[0] passthru
     /*  539847 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539863 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  539866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539883 */     GIR_RootConstrainSelectedInstOperands,
     /*  539884 */     // GIR_Coverage, 4195,
     /*  539884 */     GIR_EraseRootFromParent_Done,
     /*  539885 */   // Label 8938: @539885
     /*  539885 */   GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(539956), // Rule ID 4204 //
     /*  539890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  539901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  539904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  539907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539918 */     // MIs[0] passthru
     /*  539918 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539934 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  539937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539954 */     GIR_RootConstrainSelectedInstOperands,
     /*  539955 */     // GIR_Coverage, 4204,
     /*  539955 */     GIR_EraseRootFromParent_Done,
     /*  539956 */   // Label 8939: @539956
     /*  539956 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(540027), // Rule ID 4205 //
     /*  539961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  539972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  539975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  539978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539989 */     // MIs[0] passthru
     /*  539989 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540005 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  540008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540025 */     GIR_RootConstrainSelectedInstOperands,
     /*  540026 */     // GIR_Coverage, 4205,
     /*  540026 */     GIR_EraseRootFromParent_Done,
     /*  540027 */   // Label 8940: @540027
     /*  540027 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(540098), // Rule ID 4214 //
     /*  540032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  540035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  540040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  540043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  540046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  540049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540060 */     // MIs[0] passthru
     /*  540060 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540076 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  540079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540096 */     GIR_RootConstrainSelectedInstOperands,
     /*  540097 */     // GIR_Coverage, 4214,
     /*  540097 */     GIR_EraseRootFromParent_Done,
     /*  540098 */   // Label 8941: @540098
     /*  540098 */   GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(540169), // Rule ID 4215 //
     /*  540103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  540106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  540111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  540114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  540117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  540120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540131 */     // MIs[0] passthru
     /*  540131 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540147 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  540150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540167 */     GIR_RootConstrainSelectedInstOperands,
     /*  540168 */     // GIR_Coverage, 4215,
     /*  540168 */     GIR_EraseRootFromParent_Done,
     /*  540169 */   // Label 8942: @540169
     /*  540169 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(540240), // Rule ID 4284 //
     /*  540174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  540185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  540188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  540191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540202 */     // MIs[0] passthru
     /*  540202 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540218 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  540221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540238 */     GIR_RootConstrainSelectedInstOperands,
     /*  540239 */     // GIR_Coverage, 4284,
     /*  540239 */     GIR_EraseRootFromParent_Done,
     /*  540240 */   // Label 8943: @540240
     /*  540240 */   GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(540311), // Rule ID 4285 //
     /*  540245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  540256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  540259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  540262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540273 */     // MIs[0] passthru
     /*  540273 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540289 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  540292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540309 */     GIR_RootConstrainSelectedInstOperands,
     /*  540310 */     // GIR_Coverage, 4285,
     /*  540310 */     GIR_EraseRootFromParent_Done,
     /*  540311 */   // Label 8944: @540311
     /*  540311 */   GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(540382), // Rule ID 4294 //
     /*  540316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  540327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  540330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  540333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540344 */     // MIs[0] passthru
     /*  540344 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540360 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  540363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540380 */     GIR_RootConstrainSelectedInstOperands,
     /*  540381 */     // GIR_Coverage, 4294,
     /*  540381 */     GIR_EraseRootFromParent_Done,
     /*  540382 */   // Label 8945: @540382
     /*  540382 */   GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(540453), // Rule ID 4295 //
     /*  540387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  540398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  540401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  540404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540415 */     // MIs[0] passthru
     /*  540415 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540431 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  540434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540451 */     GIR_RootConstrainSelectedInstOperands,
     /*  540452 */     // GIR_Coverage, 4295,
     /*  540452 */     GIR_EraseRootFromParent_Done,
     /*  540453 */   // Label 8946: @540453
     /*  540453 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(540524), // Rule ID 4304 //
     /*  540458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  540469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  540472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  540475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540486 */     // MIs[0] passthru
     /*  540486 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540502 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540522 */     GIR_RootConstrainSelectedInstOperands,
     /*  540523 */     // GIR_Coverage, 4304,
     /*  540523 */     GIR_EraseRootFromParent_Done,
     /*  540524 */   // Label 8947: @540524
     /*  540524 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(540595), // Rule ID 4305 //
     /*  540529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  540540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  540543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  540546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540557 */     // MIs[0] passthru
     /*  540557 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540573 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540593 */     GIR_RootConstrainSelectedInstOperands,
     /*  540594 */     // GIR_Coverage, 4305,
     /*  540594 */     GIR_EraseRootFromParent_Done,
     /*  540595 */   // Label 8948: @540595
     /*  540595 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(540666), // Rule ID 4314 //
     /*  540600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  540611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  540614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  540617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540628 */     // MIs[0] passthru
     /*  540628 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540664 */     GIR_RootConstrainSelectedInstOperands,
     /*  540665 */     // GIR_Coverage, 4314,
     /*  540665 */     GIR_EraseRootFromParent_Done,
     /*  540666 */   // Label 8949: @540666
     /*  540666 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(540737), // Rule ID 4315 //
     /*  540671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  540682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  540685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  540688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540699 */     // MIs[0] passthru
     /*  540699 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540715 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540735 */     GIR_RootConstrainSelectedInstOperands,
     /*  540736 */     // GIR_Coverage, 4315,
     /*  540736 */     GIR_EraseRootFromParent_Done,
     /*  540737 */   // Label 8950: @540737
     /*  540737 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(540808), // Rule ID 4324 //
     /*  540742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  540753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  540756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  540759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540770 */     // MIs[0] passthru
     /*  540770 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540786 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  540789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540806 */     GIR_RootConstrainSelectedInstOperands,
     /*  540807 */     // GIR_Coverage, 4324,
     /*  540807 */     GIR_EraseRootFromParent_Done,
     /*  540808 */   // Label 8951: @540808
     /*  540808 */   GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(540879), // Rule ID 4325 //
     /*  540813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  540824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  540827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  540830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540841 */     // MIs[0] passthru
     /*  540841 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540857 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  540860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540877 */     GIR_RootConstrainSelectedInstOperands,
     /*  540878 */     // GIR_Coverage, 4325,
     /*  540878 */     GIR_EraseRootFromParent_Done,
     /*  540879 */   // Label 8952: @540879
     /*  540879 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(540950), // Rule ID 4334 //
     /*  540884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  540895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  540898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  540901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540912 */     // MIs[0] passthru
     /*  540912 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540928 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  540931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540948 */     GIR_RootConstrainSelectedInstOperands,
     /*  540949 */     // GIR_Coverage, 4334,
     /*  540949 */     GIR_EraseRootFromParent_Done,
     /*  540950 */   // Label 8953: @540950
     /*  540950 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(541021), // Rule ID 4335 //
     /*  540955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  540966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  540969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  540972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540983 */     // MIs[0] passthru
     /*  540983 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540999 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541019 */     GIR_RootConstrainSelectedInstOperands,
     /*  541020 */     // GIR_Coverage, 4335,
     /*  541020 */     GIR_EraseRootFromParent_Done,
     /*  541021 */   // Label 8954: @541021
     /*  541021 */   GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(541092), // Rule ID 4344 //
     /*  541026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  541037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  541040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  541043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541054 */     // MIs[0] passthru
     /*  541054 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541070 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  541073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541090 */     GIR_RootConstrainSelectedInstOperands,
     /*  541091 */     // GIR_Coverage, 4344,
     /*  541091 */     GIR_EraseRootFromParent_Done,
     /*  541092 */   // Label 8955: @541092
     /*  541092 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(541163), // Rule ID 4345 //
     /*  541097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  541108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  541111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  541114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541125 */     // MIs[0] passthru
     /*  541125 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541141 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  541144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541161 */     GIR_RootConstrainSelectedInstOperands,
     /*  541162 */     // GIR_Coverage, 4345,
     /*  541162 */     GIR_EraseRootFromParent_Done,
     /*  541163 */   // Label 8956: @541163
     /*  541163 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(541234), // Rule ID 4354 //
     /*  541168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  541179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  541182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  541185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541196 */     // MIs[0] passthru
     /*  541196 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541212 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  541215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541232 */     GIR_RootConstrainSelectedInstOperands,
     /*  541233 */     // GIR_Coverage, 4354,
     /*  541233 */     GIR_EraseRootFromParent_Done,
     /*  541234 */   // Label 8957: @541234
     /*  541234 */   GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(541305), // Rule ID 4355 //
     /*  541239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  541250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  541253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  541256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541267 */     // MIs[0] passthru
     /*  541267 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541283 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  541286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541303 */     GIR_RootConstrainSelectedInstOperands,
     /*  541304 */     // GIR_Coverage, 4355,
     /*  541304 */     GIR_EraseRootFromParent_Done,
     /*  541305 */   // Label 8958: @541305
     /*  541305 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(541376), // Rule ID 4364 //
     /*  541310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  541321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  541324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  541327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541338 */     // MIs[0] passthru
     /*  541338 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541354 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541374 */     GIR_RootConstrainSelectedInstOperands,
     /*  541375 */     // GIR_Coverage, 4364,
     /*  541375 */     GIR_EraseRootFromParent_Done,
     /*  541376 */   // Label 8959: @541376
     /*  541376 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(541447), // Rule ID 4365 //
     /*  541381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  541392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  541395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  541398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541409 */     // MIs[0] passthru
     /*  541409 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541445 */     GIR_RootConstrainSelectedInstOperands,
     /*  541446 */     // GIR_Coverage, 4365,
     /*  541446 */     GIR_EraseRootFromParent_Done,
     /*  541447 */   // Label 8960: @541447
     /*  541447 */   GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(541518), // Rule ID 4374 //
     /*  541452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  541463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  541466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  541469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541480 */     // MIs[0] passthru
     /*  541480 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541516 */     GIR_RootConstrainSelectedInstOperands,
     /*  541517 */     // GIR_Coverage, 4374,
     /*  541517 */     GIR_EraseRootFromParent_Done,
     /*  541518 */   // Label 8961: @541518
     /*  541518 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(541589), // Rule ID 4375 //
     /*  541523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  541534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  541537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  541540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541551 */     // MIs[0] passthru
     /*  541551 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541567 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541587 */     GIR_RootConstrainSelectedInstOperands,
     /*  541588 */     // GIR_Coverage, 4375,
     /*  541588 */     GIR_EraseRootFromParent_Done,
     /*  541589 */   // Label 8962: @541589
     /*  541589 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(541660), // Rule ID 4384 //
     /*  541594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  541605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  541608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  541611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541622 */     // MIs[0] passthru
     /*  541622 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541638 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541658 */     GIR_RootConstrainSelectedInstOperands,
     /*  541659 */     // GIR_Coverage, 4384,
     /*  541659 */     GIR_EraseRootFromParent_Done,
     /*  541660 */   // Label 8963: @541660
     /*  541660 */   GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(541731), // Rule ID 4385 //
     /*  541665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  541676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  541679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  541682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541693 */     // MIs[0] passthru
     /*  541693 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541709 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541729 */     GIR_RootConstrainSelectedInstOperands,
     /*  541730 */     // GIR_Coverage, 4385,
     /*  541730 */     GIR_EraseRootFromParent_Done,
     /*  541731 */   // Label 8964: @541731
     /*  541731 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(541802), // Rule ID 4394 //
     /*  541736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  541747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  541750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  541753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541764 */     // MIs[0] passthru
     /*  541764 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541780 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  541783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541800 */     GIR_RootConstrainSelectedInstOperands,
     /*  541801 */     // GIR_Coverage, 4394,
     /*  541801 */     GIR_EraseRootFromParent_Done,
     /*  541802 */   // Label 8965: @541802
     /*  541802 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(541873), // Rule ID 4395 //
     /*  541807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  541818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  541821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  541824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541835 */     // MIs[0] passthru
     /*  541835 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541851 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  541854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541871 */     GIR_RootConstrainSelectedInstOperands,
     /*  541872 */     // GIR_Coverage, 4395,
     /*  541872 */     GIR_EraseRootFromParent_Done,
     /*  541873 */   // Label 8966: @541873
     /*  541873 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(541944), // Rule ID 4404 //
     /*  541878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  541889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  541892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  541895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541906 */     // MIs[0] passthru
     /*  541906 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541922 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541942 */     GIR_RootConstrainSelectedInstOperands,
     /*  541943 */     // GIR_Coverage, 4404,
     /*  541943 */     GIR_EraseRootFromParent_Done,
     /*  541944 */   // Label 8967: @541944
     /*  541944 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(542015), // Rule ID 4405 //
     /*  541949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  541960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  541963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  541966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541977 */     // MIs[0] passthru
     /*  541977 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542013 */     GIR_RootConstrainSelectedInstOperands,
     /*  542014 */     // GIR_Coverage, 4405,
     /*  542014 */     GIR_EraseRootFromParent_Done,
     /*  542015 */   // Label 8968: @542015
     /*  542015 */   GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(542086), // Rule ID 4414 //
     /*  542020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  542023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  542028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  542031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  542034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  542037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542048 */     // MIs[0] passthru
     /*  542048 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  542064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  542067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542084 */     GIR_RootConstrainSelectedInstOperands,
     /*  542085 */     // GIR_Coverage, 4414,
     /*  542085 */     GIR_EraseRootFromParent_Done,
     /*  542086 */   // Label 8969: @542086
     /*  542086 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(542157), // Rule ID 4415 //
     /*  542091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  542094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  542099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  542102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  542105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  542108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542119 */     // MIs[0] passthru
     /*  542119 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542135 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  542135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  542138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542155 */     GIR_RootConstrainSelectedInstOperands,
     /*  542156 */     // GIR_Coverage, 4415,
     /*  542156 */     GIR_EraseRootFromParent_Done,
     /*  542157 */   // Label 8970: @542157
     /*  542157 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(542228), // Rule ID 4424 //
     /*  542162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  542165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  542170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  542173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  542176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  542179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542190 */     // MIs[0] passthru
     /*  542190 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542206 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  542206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  542209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542226 */     GIR_RootConstrainSelectedInstOperands,
     /*  542227 */     // GIR_Coverage, 4424,
     /*  542227 */     GIR_EraseRootFromParent_Done,
     /*  542228 */   // Label 8971: @542228
     /*  542228 */   GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(542299), // Rule ID 4425 //
     /*  542233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  542236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  542241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  542244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  542247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  542250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542261 */     // MIs[0] passthru
     /*  542261 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542277 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  542277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  542280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542297 */     GIR_RootConstrainSelectedInstOperands,
     /*  542298 */     // GIR_Coverage, 4425,
     /*  542298 */     GIR_EraseRootFromParent_Done,
     /*  542299 */   // Label 8972: @542299
     /*  542299 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(542370), // Rule ID 4494 //
     /*  542304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  542315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  542318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  542321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542332 */     // MIs[0] passthru
     /*  542332 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542348 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  542351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542368 */     GIR_RootConstrainSelectedInstOperands,
     /*  542369 */     // GIR_Coverage, 4494,
     /*  542369 */     GIR_EraseRootFromParent_Done,
     /*  542370 */   // Label 8973: @542370
     /*  542370 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(542441), // Rule ID 4495 //
     /*  542375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  542386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  542389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  542392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542403 */     // MIs[0] passthru
     /*  542403 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542419 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  542422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542439 */     GIR_RootConstrainSelectedInstOperands,
     /*  542440 */     // GIR_Coverage, 4495,
     /*  542440 */     GIR_EraseRootFromParent_Done,
     /*  542441 */   // Label 8974: @542441
     /*  542441 */   GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(542512), // Rule ID 4504 //
     /*  542446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  542457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  542460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  542463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542474 */     // MIs[0] passthru
     /*  542474 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542490 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542510 */     GIR_RootConstrainSelectedInstOperands,
     /*  542511 */     // GIR_Coverage, 4504,
     /*  542511 */     GIR_EraseRootFromParent_Done,
     /*  542512 */   // Label 8975: @542512
     /*  542512 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(542583), // Rule ID 4505 //
     /*  542517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  542528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  542531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  542534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542545 */     // MIs[0] passthru
     /*  542545 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542561 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542581 */     GIR_RootConstrainSelectedInstOperands,
     /*  542582 */     // GIR_Coverage, 4505,
     /*  542582 */     GIR_EraseRootFromParent_Done,
     /*  542583 */   // Label 8976: @542583
     /*  542583 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(542654), // Rule ID 4514 //
     /*  542588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  542599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  542602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  542605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542616 */     // MIs[0] passthru
     /*  542616 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542652 */     GIR_RootConstrainSelectedInstOperands,
     /*  542653 */     // GIR_Coverage, 4514,
     /*  542653 */     GIR_EraseRootFromParent_Done,
     /*  542654 */   // Label 8977: @542654
     /*  542654 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(542725), // Rule ID 4515 //
     /*  542659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  542670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  542673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  542676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542687 */     // MIs[0] passthru
     /*  542687 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542703 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542723 */     GIR_RootConstrainSelectedInstOperands,
     /*  542724 */     // GIR_Coverage, 4515,
     /*  542724 */     GIR_EraseRootFromParent_Done,
     /*  542725 */   // Label 8978: @542725
     /*  542725 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(542796), // Rule ID 4524 //
     /*  542730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  542741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  542744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  542747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542758 */     // MIs[0] passthru
     /*  542758 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542774 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  542777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542794 */     GIR_RootConstrainSelectedInstOperands,
     /*  542795 */     // GIR_Coverage, 4524,
     /*  542795 */     GIR_EraseRootFromParent_Done,
     /*  542796 */   // Label 8979: @542796
     /*  542796 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(542867), // Rule ID 4525 //
     /*  542801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  542812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  542815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  542818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542829 */     // MIs[0] passthru
     /*  542829 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542845 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  542848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542865 */     GIR_RootConstrainSelectedInstOperands,
     /*  542866 */     // GIR_Coverage, 4525,
     /*  542866 */     GIR_EraseRootFromParent_Done,
     /*  542867 */   // Label 8980: @542867
     /*  542867 */   GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(542938), // Rule ID 4534 //
     /*  542872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  542883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  542886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  542889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542900 */     // MIs[0] passthru
     /*  542900 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542916 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  542919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542936 */     GIR_RootConstrainSelectedInstOperands,
     /*  542937 */     // GIR_Coverage, 4534,
     /*  542937 */     GIR_EraseRootFromParent_Done,
     /*  542938 */   // Label 8981: @542938
     /*  542938 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(543009), // Rule ID 4535 //
     /*  542943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  542954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  542957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  542960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542971 */     // MIs[0] passthru
     /*  542971 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542987 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  542990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543007 */     GIR_RootConstrainSelectedInstOperands,
     /*  543008 */     // GIR_Coverage, 4535,
     /*  543008 */     GIR_EraseRootFromParent_Done,
     /*  543009 */   // Label 8982: @543009
     /*  543009 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(543080), // Rule ID 4544 //
     /*  543014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  543025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  543028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  543031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543042 */     // MIs[0] passthru
     /*  543042 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543058 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543078 */     GIR_RootConstrainSelectedInstOperands,
     /*  543079 */     // GIR_Coverage, 4544,
     /*  543079 */     GIR_EraseRootFromParent_Done,
     /*  543080 */   // Label 8983: @543080
     /*  543080 */   GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(543151), // Rule ID 4545 //
     /*  543085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  543096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  543099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  543102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543113 */     // MIs[0] passthru
     /*  543113 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543129 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543149 */     GIR_RootConstrainSelectedInstOperands,
     /*  543150 */     // GIR_Coverage, 4545,
     /*  543150 */     GIR_EraseRootFromParent_Done,
     /*  543151 */   // Label 8984: @543151
     /*  543151 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(543222), // Rule ID 4554 //
     /*  543156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  543167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  543170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  543173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543184 */     // MIs[0] passthru
     /*  543184 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543200 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  543203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543220 */     GIR_RootConstrainSelectedInstOperands,
     /*  543221 */     // GIR_Coverage, 4554,
     /*  543221 */     GIR_EraseRootFromParent_Done,
     /*  543222 */   // Label 8985: @543222
     /*  543222 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(543293), // Rule ID 4555 //
     /*  543227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  543238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  543241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  543244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543255 */     // MIs[0] passthru
     /*  543255 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543271 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  543274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543291 */     GIR_RootConstrainSelectedInstOperands,
     /*  543292 */     // GIR_Coverage, 4555,
     /*  543292 */     GIR_EraseRootFromParent_Done,
     /*  543293 */   // Label 8986: @543293
     /*  543293 */   GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(543364), // Rule ID 4564 //
     /*  543298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  543309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  543312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  543315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543326 */     // MIs[0] passthru
     /*  543326 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543342 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543362 */     GIR_RootConstrainSelectedInstOperands,
     /*  543363 */     // GIR_Coverage, 4564,
     /*  543363 */     GIR_EraseRootFromParent_Done,
     /*  543364 */   // Label 8987: @543364
     /*  543364 */   GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(543435), // Rule ID 4565 //
     /*  543369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  543380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  543383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  543386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543397 */     // MIs[0] passthru
     /*  543397 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543413 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543433 */     GIR_RootConstrainSelectedInstOperands,
     /*  543434 */     // GIR_Coverage, 4565,
     /*  543434 */     GIR_EraseRootFromParent_Done,
     /*  543435 */   // Label 8988: @543435
     /*  543435 */   GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(543506), // Rule ID 4574 //
     /*  543440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  543451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  543454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  543457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543468 */     // MIs[0] passthru
     /*  543468 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543504 */     GIR_RootConstrainSelectedInstOperands,
     /*  543505 */     // GIR_Coverage, 4574,
     /*  543505 */     GIR_EraseRootFromParent_Done,
     /*  543506 */   // Label 8989: @543506
     /*  543506 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(543577), // Rule ID 4575 //
     /*  543511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  543522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  543525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  543528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543539 */     // MIs[0] passthru
     /*  543539 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543555 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543575 */     GIR_RootConstrainSelectedInstOperands,
     /*  543576 */     // GIR_Coverage, 4575,
     /*  543576 */     GIR_EraseRootFromParent_Done,
     /*  543577 */   // Label 8990: @543577
     /*  543577 */   GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(543648), // Rule ID 4584 //
     /*  543582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  543593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  543596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  543599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543610 */     // MIs[0] passthru
     /*  543610 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543626 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543646 */     GIR_RootConstrainSelectedInstOperands,
     /*  543647 */     // GIR_Coverage, 4584,
     /*  543647 */     GIR_EraseRootFromParent_Done,
     /*  543648 */   // Label 8991: @543648
     /*  543648 */   GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(543719), // Rule ID 4585 //
     /*  543653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  543664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  543667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  543670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543681 */     // MIs[0] passthru
     /*  543681 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543697 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543717 */     GIR_RootConstrainSelectedInstOperands,
     /*  543718 */     // GIR_Coverage, 4585,
     /*  543718 */     GIR_EraseRootFromParent_Done,
     /*  543719 */   // Label 8992: @543719
     /*  543719 */   GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(543790), // Rule ID 4594 //
     /*  543724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  543735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  543738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  543741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543752 */     // MIs[0] passthru
     /*  543752 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543768 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543788 */     GIR_RootConstrainSelectedInstOperands,
     /*  543789 */     // GIR_Coverage, 4594,
     /*  543789 */     GIR_EraseRootFromParent_Done,
     /*  543790 */   // Label 8993: @543790
     /*  543790 */   GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(543861), // Rule ID 4595 //
     /*  543795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  543806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  543809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  543812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543823 */     // MIs[0] passthru
     /*  543823 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543839 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543859 */     GIR_RootConstrainSelectedInstOperands,
     /*  543860 */     // GIR_Coverage, 4595,
     /*  543860 */     GIR_EraseRootFromParent_Done,
     /*  543861 */   // Label 8994: @543861
     /*  543861 */   GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(543932), // Rule ID 4604 //
     /*  543866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  543877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  543880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  543883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543894 */     // MIs[0] passthru
     /*  543894 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543910 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543930 */     GIR_RootConstrainSelectedInstOperands,
     /*  543931 */     // GIR_Coverage, 4604,
     /*  543931 */     GIR_EraseRootFromParent_Done,
     /*  543932 */   // Label 8995: @543932
     /*  543932 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(544003), // Rule ID 4605 //
     /*  543937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  543948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  543951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  543954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543965 */     // MIs[0] passthru
     /*  543965 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543981 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544001 */     GIR_RootConstrainSelectedInstOperands,
     /*  544002 */     // GIR_Coverage, 4605,
     /*  544002 */     GIR_EraseRootFromParent_Done,
     /*  544003 */   // Label 8996: @544003
     /*  544003 */   GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(544074), // Rule ID 4614 //
     /*  544008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  544011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  544016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  544019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  544022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  544025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544036 */     // MIs[0] passthru
     /*  544036 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544052 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  544052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  544055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544072 */     GIR_RootConstrainSelectedInstOperands,
     /*  544073 */     // GIR_Coverage, 4614,
     /*  544073 */     GIR_EraseRootFromParent_Done,
     /*  544074 */   // Label 8997: @544074
     /*  544074 */   GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(544145), // Rule ID 4615 //
     /*  544079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  544082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  544087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  544090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  544093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  544096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544107 */     // MIs[0] passthru
     /*  544107 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544123 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  544123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  544126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544143 */     GIR_RootConstrainSelectedInstOperands,
     /*  544144 */     // GIR_Coverage, 4615,
     /*  544144 */     GIR_EraseRootFromParent_Done,
     /*  544145 */   // Label 8998: @544145
     /*  544145 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(544216), // Rule ID 4624 //
     /*  544150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  544153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  544158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  544161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  544164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  544167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544178 */     // MIs[0] passthru
     /*  544178 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544194 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  544194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  544197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544214 */     GIR_RootConstrainSelectedInstOperands,
     /*  544215 */     // GIR_Coverage, 4624,
     /*  544215 */     GIR_EraseRootFromParent_Done,
     /*  544216 */   // Label 8999: @544216
     /*  544216 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(544287), // Rule ID 4625 //
     /*  544221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  544224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  544229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  544232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  544235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  544238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544249 */     // MIs[0] passthru
     /*  544249 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544265 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  544265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  544268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544285 */     GIR_RootConstrainSelectedInstOperands,
     /*  544286 */     // GIR_Coverage, 4625,
     /*  544286 */     GIR_EraseRootFromParent_Done,
     /*  544287 */   // Label 9000: @544287
     /*  544287 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(544358), // Rule ID 4634 //
     /*  544292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  544295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  544300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  544303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  544306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  544309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544320 */     // MIs[0] passthru
     /*  544320 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544336 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  544336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  544339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544356 */     GIR_RootConstrainSelectedInstOperands,
     /*  544357 */     // GIR_Coverage, 4634,
     /*  544357 */     GIR_EraseRootFromParent_Done,
     /*  544358 */   // Label 9001: @544358
     /*  544358 */   GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(544429), // Rule ID 4635 //
     /*  544363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  544366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  544371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  544374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  544377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  544380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544391 */     // MIs[0] passthru
     /*  544391 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544407 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  544407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  544410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544427 */     GIR_RootConstrainSelectedInstOperands,
     /*  544428 */     // GIR_Coverage, 4635,
     /*  544428 */     GIR_EraseRootFromParent_Done,
     /*  544429 */   // Label 9002: @544429
     /*  544429 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(544500), // Rule ID 4704 //
     /*  544434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  544445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  544448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  544451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544462 */     // MIs[0] passthru
     /*  544462 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544478 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  544481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544498 */     GIR_RootConstrainSelectedInstOperands,
     /*  544499 */     // GIR_Coverage, 4704,
     /*  544499 */     GIR_EraseRootFromParent_Done,
     /*  544500 */   // Label 9003: @544500
     /*  544500 */   GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(544571), // Rule ID 4705 //
     /*  544505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  544516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  544519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  544522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544533 */     // MIs[0] passthru
     /*  544533 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544549 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  544552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544569 */     GIR_RootConstrainSelectedInstOperands,
     /*  544570 */     // GIR_Coverage, 4705,
     /*  544570 */     GIR_EraseRootFromParent_Done,
     /*  544571 */   // Label 9004: @544571
     /*  544571 */   GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(544642), // Rule ID 4714 //
     /*  544576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  544587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  544590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  544593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544604 */     // MIs[0] passthru
     /*  544604 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544620 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544640 */     GIR_RootConstrainSelectedInstOperands,
     /*  544641 */     // GIR_Coverage, 4714,
     /*  544641 */     GIR_EraseRootFromParent_Done,
     /*  544642 */   // Label 9005: @544642
     /*  544642 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(544713), // Rule ID 4715 //
     /*  544647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  544658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  544661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  544664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544675 */     // MIs[0] passthru
     /*  544675 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544691 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544711 */     GIR_RootConstrainSelectedInstOperands,
     /*  544712 */     // GIR_Coverage, 4715,
     /*  544712 */     GIR_EraseRootFromParent_Done,
     /*  544713 */   // Label 9006: @544713
     /*  544713 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(544784), // Rule ID 4724 //
     /*  544718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  544729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  544732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  544735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544746 */     // MIs[0] passthru
     /*  544746 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544762 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  544765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544782 */     GIR_RootConstrainSelectedInstOperands,
     /*  544783 */     // GIR_Coverage, 4724,
     /*  544783 */     GIR_EraseRootFromParent_Done,
     /*  544784 */   // Label 9007: @544784
     /*  544784 */   GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(544855), // Rule ID 4725 //
     /*  544789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  544800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  544803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  544806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544817 */     // MIs[0] passthru
     /*  544817 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544833 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  544836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544853 */     GIR_RootConstrainSelectedInstOperands,
     /*  544854 */     // GIR_Coverage, 4725,
     /*  544854 */     GIR_EraseRootFromParent_Done,
     /*  544855 */   // Label 9008: @544855
     /*  544855 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(544926), // Rule ID 4734 //
     /*  544860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  544871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  544874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  544877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544888 */     // MIs[0] passthru
     /*  544888 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544904 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  544907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544924 */     GIR_RootConstrainSelectedInstOperands,
     /*  544925 */     // GIR_Coverage, 4734,
     /*  544925 */     GIR_EraseRootFromParent_Done,
     /*  544926 */   // Label 9009: @544926
     /*  544926 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(544997), // Rule ID 4735 //
     /*  544931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  544942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  544945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  544948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544959 */     // MIs[0] passthru
     /*  544959 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  544978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544995 */     GIR_RootConstrainSelectedInstOperands,
     /*  544996 */     // GIR_Coverage, 4735,
     /*  544996 */     GIR_EraseRootFromParent_Done,
     /*  544997 */   // Label 9010: @544997
     /*  544997 */   GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(545068), // Rule ID 4744 //
     /*  545002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  545013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  545016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  545019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545030 */     // MIs[0] passthru
     /*  545030 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545046 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  545046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545066 */     GIR_RootConstrainSelectedInstOperands,
     /*  545067 */     // GIR_Coverage, 4744,
     /*  545067 */     GIR_EraseRootFromParent_Done,
     /*  545068 */   // Label 9011: @545068
     /*  545068 */   GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(545139), // Rule ID 4745 //
     /*  545073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  545084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  545087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  545090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545101 */     // MIs[0] passthru
     /*  545101 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545117 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  545117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545137 */     GIR_RootConstrainSelectedInstOperands,
     /*  545138 */     // GIR_Coverage, 4745,
     /*  545138 */     GIR_EraseRootFromParent_Done,
     /*  545139 */   // Label 9012: @545139
     /*  545139 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(545210), // Rule ID 4754 //
     /*  545144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  545155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  545158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  545161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545172 */     // MIs[0] passthru
     /*  545172 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545188 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  545188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545208 */     GIR_RootConstrainSelectedInstOperands,
     /*  545209 */     // GIR_Coverage, 4754,
     /*  545209 */     GIR_EraseRootFromParent_Done,
     /*  545210 */   // Label 9013: @545210
     /*  545210 */   GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(545281), // Rule ID 4755 //
     /*  545215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  545226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  545229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  545232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545243 */     // MIs[0] passthru
     /*  545243 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545259 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  545259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545279 */     GIR_RootConstrainSelectedInstOperands,
     /*  545280 */     // GIR_Coverage, 4755,
     /*  545280 */     GIR_EraseRootFromParent_Done,
     /*  545281 */   // Label 9014: @545281
     /*  545281 */   GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(545352), // Rule ID 4764 //
     /*  545286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  545297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  545300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  545303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545314 */     // MIs[0] passthru
     /*  545314 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545330 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  545333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545350 */     GIR_RootConstrainSelectedInstOperands,
     /*  545351 */     // GIR_Coverage, 4764,
     /*  545351 */     GIR_EraseRootFromParent_Done,
     /*  545352 */   // Label 9015: @545352
     /*  545352 */   GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(545423), // Rule ID 4765 //
     /*  545357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  545368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  545371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  545374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545385 */     // MIs[0] passthru
     /*  545385 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545401 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  545404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545421 */     GIR_RootConstrainSelectedInstOperands,
     /*  545422 */     // GIR_Coverage, 4765,
     /*  545422 */     GIR_EraseRootFromParent_Done,
     /*  545423 */   // Label 9016: @545423
     /*  545423 */   GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(545494), // Rule ID 4774 //
     /*  545428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  545439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  545442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  545445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545456 */     // MIs[0] passthru
     /*  545456 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545472 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545492 */     GIR_RootConstrainSelectedInstOperands,
     /*  545493 */     // GIR_Coverage, 4774,
     /*  545493 */     GIR_EraseRootFromParent_Done,
     /*  545494 */   // Label 9017: @545494
     /*  545494 */   GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(545565), // Rule ID 4775 //
     /*  545499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  545510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  545513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  545516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545527 */     // MIs[0] passthru
     /*  545527 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545543 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545563 */     GIR_RootConstrainSelectedInstOperands,
     /*  545564 */     // GIR_Coverage, 4775,
     /*  545564 */     GIR_EraseRootFromParent_Done,
     /*  545565 */   // Label 9018: @545565
     /*  545565 */   GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(545636), // Rule ID 4784 //
     /*  545570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  545581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  545584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  545587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545598 */     // MIs[0] passthru
     /*  545598 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545634 */     GIR_RootConstrainSelectedInstOperands,
     /*  545635 */     // GIR_Coverage, 4784,
     /*  545635 */     GIR_EraseRootFromParent_Done,
     /*  545636 */   // Label 9019: @545636
     /*  545636 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(545707), // Rule ID 4785 //
     /*  545641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  545652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  545655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  545658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545669 */     // MIs[0] passthru
     /*  545669 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545685 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545705 */     GIR_RootConstrainSelectedInstOperands,
     /*  545706 */     // GIR_Coverage, 4785,
     /*  545706 */     GIR_EraseRootFromParent_Done,
     /*  545707 */   // Label 9020: @545707
     /*  545707 */   GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(545778), // Rule ID 4794 //
     /*  545712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  545723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  545726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  545729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545740 */     // MIs[0] passthru
     /*  545740 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545756 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545776 */     GIR_RootConstrainSelectedInstOperands,
     /*  545777 */     // GIR_Coverage, 4794,
     /*  545777 */     GIR_EraseRootFromParent_Done,
     /*  545778 */   // Label 9021: @545778
     /*  545778 */   GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(545849), // Rule ID 4795 //
     /*  545783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  545794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  545797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  545800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545811 */     // MIs[0] passthru
     /*  545811 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545827 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545847 */     GIR_RootConstrainSelectedInstOperands,
     /*  545848 */     // GIR_Coverage, 4795,
     /*  545848 */     GIR_EraseRootFromParent_Done,
     /*  545849 */   // Label 9022: @545849
     /*  545849 */   GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(545920), // Rule ID 4804 //
     /*  545854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  545865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  545868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  545871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545882 */     // MIs[0] passthru
     /*  545882 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545898 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545918 */     GIR_RootConstrainSelectedInstOperands,
     /*  545919 */     // GIR_Coverage, 4804,
     /*  545919 */     GIR_EraseRootFromParent_Done,
     /*  545920 */   // Label 9023: @545920
     /*  545920 */   GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(545991), // Rule ID 4805 //
     /*  545925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  545936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  545939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  545942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545953 */     // MIs[0] passthru
     /*  545953 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545969 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545989 */     GIR_RootConstrainSelectedInstOperands,
     /*  545990 */     // GIR_Coverage, 4805,
     /*  545990 */     GIR_EraseRootFromParent_Done,
     /*  545991 */   // Label 9024: @545991
     /*  545991 */   GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(546062), // Rule ID 4814 //
     /*  545996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  546007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  546010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  546013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546024 */     // MIs[0] passthru
     /*  546024 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  546040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  546043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546060 */     GIR_RootConstrainSelectedInstOperands,
     /*  546061 */     // GIR_Coverage, 4814,
     /*  546061 */     GIR_EraseRootFromParent_Done,
     /*  546062 */   // Label 9025: @546062
     /*  546062 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(546133), // Rule ID 4815 //
     /*  546067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  546070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  546078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  546081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  546084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546095 */     // MIs[0] passthru
     /*  546095 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546111 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  546114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546131 */     GIR_RootConstrainSelectedInstOperands,
     /*  546132 */     // GIR_Coverage, 4815,
     /*  546132 */     GIR_EraseRootFromParent_Done,
     /*  546133 */   // Label 9026: @546133
     /*  546133 */   GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(546204), // Rule ID 4824 //
     /*  546138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  546141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  546149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  546152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  546155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546166 */     // MIs[0] passthru
     /*  546166 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  546182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  546185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546202 */     GIR_RootConstrainSelectedInstOperands,
     /*  546203 */     // GIR_Coverage, 4824,
     /*  546203 */     GIR_EraseRootFromParent_Done,
     /*  546204 */   // Label 9027: @546204
     /*  546204 */   GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(546275), // Rule ID 4825 //
     /*  546209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  546212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  546220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  546223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  546226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546237 */     // MIs[0] passthru
     /*  546237 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546253 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  546256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546273 */     GIR_RootConstrainSelectedInstOperands,
     /*  546274 */     // GIR_Coverage, 4825,
     /*  546274 */     GIR_EraseRootFromParent_Done,
     /*  546275 */   // Label 9028: @546275
     /*  546275 */   GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(546346), // Rule ID 4834 //
     /*  546280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  546283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  546291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  546294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  546297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546308 */     // MIs[0] passthru
     /*  546308 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546324 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  546324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  546327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546344 */     GIR_RootConstrainSelectedInstOperands,
     /*  546345 */     // GIR_Coverage, 4834,
     /*  546345 */     GIR_EraseRootFromParent_Done,
     /*  546346 */   // Label 9029: @546346
     /*  546346 */   GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(546417), // Rule ID 4835 //
     /*  546351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  546354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  546362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  546365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  546368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546379 */     // MIs[0] passthru
     /*  546379 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546395 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  546398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546415 */     GIR_RootConstrainSelectedInstOperands,
     /*  546416 */     // GIR_Coverage, 4835,
     /*  546416 */     GIR_EraseRootFromParent_Done,
     /*  546417 */   // Label 9030: @546417
     /*  546417 */   GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(546488), // Rule ID 4844 //
     /*  546422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  546425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  546433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  546436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  546439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546450 */     // MIs[0] passthru
     /*  546450 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546466 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  546466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  546469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546486 */     GIR_RootConstrainSelectedInstOperands,
     /*  546487 */     // GIR_Coverage, 4844,
     /*  546487 */     GIR_EraseRootFromParent_Done,
     /*  546488 */   // Label 9031: @546488
     /*  546488 */   GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(546559), // Rule ID 4845 //
     /*  546493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  546496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  546504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  546507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  546510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546521 */     // MIs[0] passthru
     /*  546521 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546537 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  546540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546557 */     GIR_RootConstrainSelectedInstOperands,
     /*  546558 */     // GIR_Coverage, 4845,
     /*  546558 */     GIR_EraseRootFromParent_Done,
     /*  546559 */   // Label 9032: @546559
     /*  546559 */   GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(546631), // Rule ID 2700 //
     /*  546564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  546572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546610 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  546610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  546613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546629 */     GIR_RootConstrainSelectedInstOperands,
     /*  546630 */     // GIR_Coverage, 2700,
     /*  546630 */     GIR_EraseRootFromParent_Done,
     /*  546631 */   // Label 9033: @546631
     /*  546631 */   GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(546703), // Rule ID 2701 //
     /*  546636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  546644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546682 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  546682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  546685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546701 */     GIR_RootConstrainSelectedInstOperands,
     /*  546702 */     // GIR_Coverage, 2701,
     /*  546702 */     GIR_EraseRootFromParent_Done,
     /*  546703 */   // Label 9034: @546703
     /*  546703 */   GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(546778), // Rule ID 2704 //
     /*  546708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  546711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  546716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  546722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  546725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  546735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546754 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  546754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  546757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  546776 */     GIR_RootConstrainSelectedInstOperands,
     /*  546777 */     // GIR_Coverage, 2704,
     /*  546777 */     GIR_EraseRootFromParent_Done,
     /*  546778 */   // Label 9035: @546778
     /*  546778 */   GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(546853), // Rule ID 2705 //
     /*  546783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  546786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  546791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  546797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  546800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  546810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546829 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  546829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  546832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546838 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  546851 */     GIR_RootConstrainSelectedInstOperands,
     /*  546852 */     // GIR_Coverage, 2705,
     /*  546852 */     GIR_EraseRootFromParent_Done,
     /*  546853 */   // Label 9036: @546853
     /*  546853 */   GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(546928), // Rule ID 2732 //
     /*  546858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  546866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546904 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  546907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546926 */     GIR_RootConstrainSelectedInstOperands,
     /*  546927 */     // GIR_Coverage, 2732,
     /*  546927 */     GIR_EraseRootFromParent_Done,
     /*  546928 */   // Label 9037: @546928
     /*  546928 */   GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(547003), // Rule ID 2733 //
     /*  546933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  546941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546979 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  546982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547001 */     GIR_RootConstrainSelectedInstOperands,
     /*  547002 */     // GIR_Coverage, 2733,
     /*  547002 */     GIR_EraseRootFromParent_Done,
     /*  547003 */   // Label 9038: @547003
     /*  547003 */   GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(547075), // Rule ID 2746 //
     /*  547008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  547016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  547019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  547028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  547047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547054 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  547054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  547057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  547061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  547065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547073 */     GIR_RootConstrainSelectedInstOperands,
     /*  547074 */     // GIR_Coverage, 2746,
     /*  547074 */     GIR_EraseRootFromParent_Done,
     /*  547075 */   // Label 9039: @547075
     /*  547075 */   GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(547147), // Rule ID 2747 //
     /*  547080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  547088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  547091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  547100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  547119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547126 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  547126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  547129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  547133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  547137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547145 */     GIR_RootConstrainSelectedInstOperands,
     /*  547146 */     // GIR_Coverage, 2747,
     /*  547146 */     GIR_EraseRootFromParent_Done,
     /*  547147 */   // Label 9040: @547147
     /*  547147 */   GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(547222), // Rule ID 2766 //
     /*  547152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  547160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  547201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547220 */     GIR_RootConstrainSelectedInstOperands,
     /*  547221 */     // GIR_Coverage, 2766,
     /*  547221 */     GIR_EraseRootFromParent_Done,
     /*  547222 */   // Label 9041: @547222
     /*  547222 */   GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(547297), // Rule ID 2767 //
     /*  547227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  547235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547273 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  547276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547295 */     GIR_RootConstrainSelectedInstOperands,
     /*  547296 */     // GIR_Coverage, 2767,
     /*  547296 */     GIR_EraseRootFromParent_Done,
     /*  547297 */   // Label 9042: @547297
     /*  547297 */   GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(547372), // Rule ID 2792 //
     /*  547302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  547310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  547313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  547316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  547322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547348 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  547351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  547355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547370 */     GIR_RootConstrainSelectedInstOperands,
     /*  547371 */     // GIR_Coverage, 2792,
     /*  547371 */     GIR_EraseRootFromParent_Done,
     /*  547372 */   // Label 9043: @547372
     /*  547372 */   GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(547447), // Rule ID 2793 //
     /*  547377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  547385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  547388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  547391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  547397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547423 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  547426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  547430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547445 */     GIR_RootConstrainSelectedInstOperands,
     /*  547446 */     // GIR_Coverage, 2793,
     /*  547446 */     GIR_EraseRootFromParent_Done,
     /*  547447 */   // Label 9044: @547447
     /*  547447 */   GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(547522), // Rule ID 2804 //
     /*  547452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  547463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547498 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  547501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547520 */     GIR_RootConstrainSelectedInstOperands,
     /*  547521 */     // GIR_Coverage, 2804,
     /*  547521 */     GIR_EraseRootFromParent_Done,
     /*  547522 */   // Label 9045: @547522
     /*  547522 */   GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(547597), // Rule ID 2805 //
     /*  547527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  547538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547573 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  547576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547595 */     GIR_RootConstrainSelectedInstOperands,
     /*  547596 */     // GIR_Coverage, 2805,
     /*  547596 */     GIR_EraseRootFromParent_Done,
     /*  547597 */   // Label 9046: @547597
     /*  547597 */   GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(547672), // Rule ID 2812 //
     /*  547602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  547613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  547616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  547619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  547622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547648 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547670 */     GIR_RootConstrainSelectedInstOperands,
     /*  547671 */     // GIR_Coverage, 2812,
     /*  547671 */     GIR_EraseRootFromParent_Done,
     /*  547672 */   // Label 9047: @547672
     /*  547672 */   GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(547747), // Rule ID 2813 //
     /*  547677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  547688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  547691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  547694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  547697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547723 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547745 */     GIR_RootConstrainSelectedInstOperands,
     /*  547746 */     // GIR_Coverage, 2813,
     /*  547746 */     GIR_EraseRootFromParent_Done,
     /*  547747 */   // Label 9048: @547747
     /*  547747 */   GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(547822), // Rule ID 2820 //
     /*  547752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  547763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  547766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  547769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  547772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547798 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547820 */     GIR_RootConstrainSelectedInstOperands,
     /*  547821 */     // GIR_Coverage, 2820,
     /*  547821 */     GIR_EraseRootFromParent_Done,
     /*  547822 */   // Label 9049: @547822
     /*  547822 */   GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(547897), // Rule ID 2821 //
     /*  547827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  547838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  547841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  547844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  547847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547873 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547895 */     GIR_RootConstrainSelectedInstOperands,
     /*  547896 */     // GIR_Coverage, 2821,
     /*  547896 */     GIR_EraseRootFromParent_Done,
     /*  547897 */   // Label 9050: @547897
     /*  547897 */   GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(547972), // Rule ID 2828 //
     /*  547902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  547922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547948 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  547948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547970 */     GIR_RootConstrainSelectedInstOperands,
     /*  547971 */     // GIR_Coverage, 2828,
     /*  547971 */     GIR_EraseRootFromParent_Done,
     /*  547972 */   // Label 9051: @547972
     /*  547972 */   GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(548047), // Rule ID 2829 //
     /*  547977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  547997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548023 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  548026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548045 */     GIR_RootConstrainSelectedInstOperands,
     /*  548046 */     // GIR_Coverage, 2829,
     /*  548046 */     GIR_EraseRootFromParent_Done,
     /*  548047 */   // Label 9052: @548047
     /*  548047 */   GIM_Try, /*On fail goto*//*Label 9053*/ GIMT_Encode4(548122), // Rule ID 2836 //
     /*  548052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  548063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  548066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  548069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  548072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548098 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  548101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548120 */     GIR_RootConstrainSelectedInstOperands,
     /*  548121 */     // GIR_Coverage, 2836,
     /*  548121 */     GIR_EraseRootFromParent_Done,
     /*  548122 */   // Label 9053: @548122
     /*  548122 */   GIM_Try, /*On fail goto*//*Label 9054*/ GIMT_Encode4(548197), // Rule ID 2837 //
     /*  548127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  548138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  548141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  548144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  548147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548173 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  548176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548195 */     GIR_RootConstrainSelectedInstOperands,
     /*  548196 */     // GIR_Coverage, 2837,
     /*  548196 */     GIR_EraseRootFromParent_Done,
     /*  548197 */   // Label 9054: @548197
     /*  548197 */   GIM_Try, /*On fail goto*//*Label 9055*/ GIMT_Encode4(548272), // Rule ID 2844 //
     /*  548202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  548213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  548216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  548219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  548222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548248 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  548248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  548251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548270 */     GIR_RootConstrainSelectedInstOperands,
     /*  548271 */     // GIR_Coverage, 2844,
     /*  548271 */     GIR_EraseRootFromParent_Done,
     /*  548272 */   // Label 9055: @548272
     /*  548272 */   GIM_Try, /*On fail goto*//*Label 9056*/ GIMT_Encode4(548347), // Rule ID 2845 //
     /*  548277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  548288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  548291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  548294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  548297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548323 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  548323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  548326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548345 */     GIR_RootConstrainSelectedInstOperands,
     /*  548346 */     // GIR_Coverage, 2845,
     /*  548346 */     GIR_EraseRootFromParent_Done,
     /*  548347 */   // Label 9056: @548347
     /*  548347 */   GIM_Try, /*On fail goto*//*Label 9057*/ GIMT_Encode4(548422), // Rule ID 2852 //
     /*  548352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  548363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  548366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  548369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  548372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548398 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548420 */     GIR_RootConstrainSelectedInstOperands,
     /*  548421 */     // GIR_Coverage, 2852,
     /*  548421 */     GIR_EraseRootFromParent_Done,
     /*  548422 */   // Label 9057: @548422
     /*  548422 */   GIM_Try, /*On fail goto*//*Label 9058*/ GIMT_Encode4(548497), // Rule ID 2853 //
     /*  548427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  548438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  548441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  548444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  548447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548473 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548495 */     GIR_RootConstrainSelectedInstOperands,
     /*  548496 */     // GIR_Coverage, 2853,
     /*  548496 */     GIR_EraseRootFromParent_Done,
     /*  548497 */   // Label 9058: @548497
     /*  548497 */   GIM_Try, /*On fail goto*//*Label 9059*/ GIMT_Encode4(548572), // Rule ID 2860 //
     /*  548502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  548519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  548522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548548 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548570 */     GIR_RootConstrainSelectedInstOperands,
     /*  548571 */     // GIR_Coverage, 2860,
     /*  548571 */     GIR_EraseRootFromParent_Done,
     /*  548572 */   // Label 9059: @548572
     /*  548572 */   GIM_Try, /*On fail goto*//*Label 9060*/ GIMT_Encode4(548647), // Rule ID 2861 //
     /*  548577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  548594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  548597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548623 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548645 */     GIR_RootConstrainSelectedInstOperands,
     /*  548646 */     // GIR_Coverage, 2861,
     /*  548646 */     GIR_EraseRootFromParent_Done,
     /*  548647 */   // Label 9060: @548647
     /*  548647 */   GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(548722), // Rule ID 2868 //
     /*  548652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  548669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  548672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548698 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  548698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548720 */     GIR_RootConstrainSelectedInstOperands,
     /*  548721 */     // GIR_Coverage, 2868,
     /*  548721 */     GIR_EraseRootFromParent_Done,
     /*  548722 */   // Label 9061: @548722
     /*  548722 */   GIM_Try, /*On fail goto*//*Label 9062*/ GIMT_Encode4(548797), // Rule ID 2869 //
     /*  548727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  548744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  548747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548773 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  548773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548795 */     GIR_RootConstrainSelectedInstOperands,
     /*  548796 */     // GIR_Coverage, 2869,
     /*  548796 */     GIR_EraseRootFromParent_Done,
     /*  548797 */   // Label 9062: @548797
     /*  548797 */   GIM_Try, /*On fail goto*//*Label 9063*/ GIMT_Encode4(548872), // Rule ID 2876 //
     /*  548802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  548805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  548813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  548816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  548819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  548822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548848 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  548848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  548867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548870 */     GIR_RootConstrainSelectedInstOperands,
     /*  548871 */     // GIR_Coverage, 2876,
     /*  548871 */     GIR_EraseRootFromParent_Done,
     /*  548872 */   // Label 9063: @548872
     /*  548872 */   GIM_Try, /*On fail goto*//*Label 9064*/ GIMT_Encode4(548947), // Rule ID 2877 //
     /*  548877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  548880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  548888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  548891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  548894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  548897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548923 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  548923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  548942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548945 */     GIR_RootConstrainSelectedInstOperands,
     /*  548946 */     // GIR_Coverage, 2877,
     /*  548946 */     GIR_EraseRootFromParent_Done,
     /*  548947 */   // Label 9064: @548947
     /*  548947 */   GIM_Try, /*On fail goto*//*Label 9065*/ GIMT_Encode4(549022), // Rule ID 2884 //
     /*  548952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  548963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  548966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  548969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548998 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549020 */     GIR_RootConstrainSelectedInstOperands,
     /*  549021 */     // GIR_Coverage, 2884,
     /*  549021 */     GIR_EraseRootFromParent_Done,
     /*  549022 */   // Label 9065: @549022
     /*  549022 */   GIM_Try, /*On fail goto*//*Label 9066*/ GIMT_Encode4(549097), // Rule ID 2885 //
     /*  549027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  549038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  549041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  549044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  549047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549073 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  549073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549095 */     GIR_RootConstrainSelectedInstOperands,
     /*  549096 */     // GIR_Coverage, 2885,
     /*  549096 */     GIR_EraseRootFromParent_Done,
     /*  549097 */   // Label 9066: @549097
     /*  549097 */   GIM_Try, /*On fail goto*//*Label 9067*/ GIMT_Encode4(549172), // Rule ID 2892 //
     /*  549102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  549113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  549116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  549119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  549122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549148 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  549148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549170 */     GIR_RootConstrainSelectedInstOperands,
     /*  549171 */     // GIR_Coverage, 2892,
     /*  549171 */     GIR_EraseRootFromParent_Done,
     /*  549172 */   // Label 9067: @549172
     /*  549172 */   GIM_Try, /*On fail goto*//*Label 9068*/ GIMT_Encode4(549247), // Rule ID 2893 //
     /*  549177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  549188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  549191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  549194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  549197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549223 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  549223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549245 */     GIR_RootConstrainSelectedInstOperands,
     /*  549246 */     // GIR_Coverage, 2893,
     /*  549246 */     GIR_EraseRootFromParent_Done,
     /*  549247 */   // Label 9068: @549247
     /*  549247 */   GIM_Try, /*On fail goto*//*Label 9069*/ GIMT_Encode4(549322), // Rule ID 2900 //
     /*  549252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  549263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  549266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  549269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  549272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549298 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  549298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549320 */     GIR_RootConstrainSelectedInstOperands,
     /*  549321 */     // GIR_Coverage, 2900,
     /*  549321 */     GIR_EraseRootFromParent_Done,
     /*  549322 */   // Label 9069: @549322
     /*  549322 */   GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(549397), // Rule ID 2901 //
     /*  549327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  549338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  549341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  549344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  549347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549373 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  549373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549395 */     GIR_RootConstrainSelectedInstOperands,
     /*  549396 */     // GIR_Coverage, 2901,
     /*  549396 */     GIR_EraseRootFromParent_Done,
     /*  549397 */   // Label 9070: @549397
     /*  549397 */   GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(549472), // Rule ID 2908 //
     /*  549402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  549413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  549416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  549419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  549422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549470 */     GIR_RootConstrainSelectedInstOperands,
     /*  549471 */     // GIR_Coverage, 2908,
     /*  549471 */     GIR_EraseRootFromParent_Done,
     /*  549472 */   // Label 9071: @549472
     /*  549472 */   GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(549547), // Rule ID 2909 //
     /*  549477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  549488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  549491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  549494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  549497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549523 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549545 */     GIR_RootConstrainSelectedInstOperands,
     /*  549546 */     // GIR_Coverage, 2909,
     /*  549546 */     GIR_EraseRootFromParent_Done,
     /*  549547 */   // Label 9072: @549547
     /*  549547 */   GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(549622), // Rule ID 2916 //
     /*  549552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  549563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  549566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  549569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549598 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549620 */     GIR_RootConstrainSelectedInstOperands,
     /*  549621 */     // GIR_Coverage, 2916,
     /*  549621 */     GIR_EraseRootFromParent_Done,
     /*  549622 */   // Label 9073: @549622
     /*  549622 */   GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(549697), // Rule ID 2917 //
     /*  549627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  549638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  549641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  549644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549673 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549695 */     GIR_RootConstrainSelectedInstOperands,
     /*  549696 */     // GIR_Coverage, 2917,
     /*  549696 */     GIR_EraseRootFromParent_Done,
     /*  549697 */   // Label 9074: @549697
     /*  549697 */   GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(549772), // Rule ID 2924 //
     /*  549702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  549713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  549716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  549719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  549722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549748 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549770 */     GIR_RootConstrainSelectedInstOperands,
     /*  549771 */     // GIR_Coverage, 2924,
     /*  549771 */     GIR_EraseRootFromParent_Done,
     /*  549772 */   // Label 9075: @549772
     /*  549772 */   GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(549847), // Rule ID 2925 //
     /*  549777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  549788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  549791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  549794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  549797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549823 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549845 */     GIR_RootConstrainSelectedInstOperands,
     /*  549846 */     // GIR_Coverage, 2925,
     /*  549846 */     GIR_EraseRootFromParent_Done,
     /*  549847 */   // Label 9076: @549847
     /*  549847 */   GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(549922), // Rule ID 2932 //
     /*  549852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  549863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  549866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  549869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549898 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549920 */     GIR_RootConstrainSelectedInstOperands,
     /*  549921 */     // GIR_Coverage, 2932,
     /*  549921 */     GIR_EraseRootFromParent_Done,
     /*  549922 */   // Label 9077: @549922
     /*  549922 */   GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(549997), // Rule ID 2933 //
     /*  549927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  549938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  549941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  549944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549995 */     GIR_RootConstrainSelectedInstOperands,
     /*  549996 */     // GIR_Coverage, 2933,
     /*  549996 */     GIR_EraseRootFromParent_Done,
     /*  549997 */   // Label 9078: @549997
     /*  549997 */   GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(550072), // Rule ID 2940 //
     /*  550002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  550013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  550016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  550019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  550022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  550048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  550051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550070 */     GIR_RootConstrainSelectedInstOperands,
     /*  550071 */     // GIR_Coverage, 2940,
     /*  550071 */     GIR_EraseRootFromParent_Done,
     /*  550072 */   // Label 9079: @550072
     /*  550072 */   GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(550147), // Rule ID 2941 //
     /*  550077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  550088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  550091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  550094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  550097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550123 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  550123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  550126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550145 */     GIR_RootConstrainSelectedInstOperands,
     /*  550146 */     // GIR_Coverage, 2941,
     /*  550146 */     GIR_EraseRootFromParent_Done,
     /*  550147 */   // Label 9080: @550147
     /*  550147 */   GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(550222), // Rule ID 2948 //
     /*  550152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  550163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  550166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  550169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  550172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  550198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  550201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550220 */     GIR_RootConstrainSelectedInstOperands,
     /*  550221 */     // GIR_Coverage, 2948,
     /*  550221 */     GIR_EraseRootFromParent_Done,
     /*  550222 */   // Label 9081: @550222
     /*  550222 */   GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(550297), // Rule ID 2949 //
     /*  550227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  550238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  550241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  550244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  550247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550273 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  550273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  550276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550295 */     GIR_RootConstrainSelectedInstOperands,
     /*  550296 */     // GIR_Coverage, 2949,
     /*  550296 */     GIR_EraseRootFromParent_Done,
     /*  550297 */   // Label 9082: @550297
     /*  550297 */   GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(550372), // Rule ID 2956 //
     /*  550302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  550305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  550313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  550316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  550319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  550322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550348 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  550348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  550351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550370 */     GIR_RootConstrainSelectedInstOperands,
     /*  550371 */     // GIR_Coverage, 2956,
     /*  550371 */     GIR_EraseRootFromParent_Done,
     /*  550372 */   // Label 9083: @550372
     /*  550372 */   GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(550447), // Rule ID 2957 //
     /*  550377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  550380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  550388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  550391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  550394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  550397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550423 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  550423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  550426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550445 */     GIR_RootConstrainSelectedInstOperands,
     /*  550446 */     // GIR_Coverage, 2957,
     /*  550446 */     GIR_EraseRootFromParent_Done,
     /*  550447 */   // Label 9084: @550447
     /*  550447 */   GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(550522), // Rule ID 2964 //
     /*  550452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  550455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  550463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  550466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  550469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  550472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550498 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  550498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  550501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550520 */     GIR_RootConstrainSelectedInstOperands,
     /*  550521 */     // GIR_Coverage, 2964,
     /*  550521 */     GIR_EraseRootFromParent_Done,
     /*  550522 */   // Label 9085: @550522
     /*  550522 */   GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(550597), // Rule ID 2965 //
     /*  550527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  550530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  550538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  550541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  550544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  550547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550573 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  550573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  550576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550595 */     GIR_RootConstrainSelectedInstOperands,
     /*  550596 */     // GIR_Coverage, 2965,
     /*  550596 */     GIR_EraseRootFromParent_Done,
     /*  550597 */   // Label 9086: @550597
     /*  550597 */   GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(550672), // Rule ID 2972 //
     /*  550602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  550605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  550613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  550616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  550619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  550622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550648 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  550648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  550651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550670 */     GIR_RootConstrainSelectedInstOperands,
     /*  550671 */     // GIR_Coverage, 2972,
     /*  550671 */     GIR_EraseRootFromParent_Done,
     /*  550672 */   // Label 9087: @550672
     /*  550672 */   GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(550747), // Rule ID 2973 //
     /*  550677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  550680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  550688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  550691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  550694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  550697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550723 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  550723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  550726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550745 */     GIR_RootConstrainSelectedInstOperands,
     /*  550746 */     // GIR_Coverage, 2973,
     /*  550746 */     GIR_EraseRootFromParent_Done,
     /*  550747 */   // Label 9088: @550747
     /*  550747 */   GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(550822), // Rule ID 2988 //
     /*  550752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  550763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  550766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  550769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  550772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550798 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550820 */     GIR_RootConstrainSelectedInstOperands,
     /*  550821 */     // GIR_Coverage, 2988,
     /*  550821 */     GIR_EraseRootFromParent_Done,
     /*  550822 */   // Label 9089: @550822
     /*  550822 */   GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(550897), // Rule ID 2989 //
     /*  550827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  550838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  550841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  550844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  550847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550873 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550895 */     GIR_RootConstrainSelectedInstOperands,
     /*  550896 */     // GIR_Coverage, 2989,
     /*  550896 */     GIR_EraseRootFromParent_Done,
     /*  550897 */   // Label 9090: @550897
     /*  550897 */   GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(550972), // Rule ID 2992 //
     /*  550902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  550913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  550916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  550919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  550922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550948 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550970 */     GIR_RootConstrainSelectedInstOperands,
     /*  550971 */     // GIR_Coverage, 2992,
     /*  550971 */     GIR_EraseRootFromParent_Done,
     /*  550972 */   // Label 9091: @550972
     /*  550972 */   GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(551047), // Rule ID 2993 //
     /*  550977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  550988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  550991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  550994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  550997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551023 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  551026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551045 */     GIR_RootConstrainSelectedInstOperands,
     /*  551046 */     // GIR_Coverage, 2993,
     /*  551046 */     GIR_EraseRootFromParent_Done,
     /*  551047 */   // Label 9092: @551047
     /*  551047 */   GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(551122), // Rule ID 2996 //
     /*  551052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  551063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  551066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  551069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  551072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551098 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  551101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551120 */     GIR_RootConstrainSelectedInstOperands,
     /*  551121 */     // GIR_Coverage, 2996,
     /*  551121 */     GIR_EraseRootFromParent_Done,
     /*  551122 */   // Label 9093: @551122
     /*  551122 */   GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(551197), // Rule ID 2997 //
     /*  551127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  551138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  551141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  551144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  551147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551173 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  551176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551195 */     GIR_RootConstrainSelectedInstOperands,
     /*  551196 */     // GIR_Coverage, 2997,
     /*  551196 */     GIR_EraseRootFromParent_Done,
     /*  551197 */   // Label 9094: @551197
     /*  551197 */   GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(551272), // Rule ID 3000 //
     /*  551202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  551213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  551216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  551219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  551222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551248 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  551251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551270 */     GIR_RootConstrainSelectedInstOperands,
     /*  551271 */     // GIR_Coverage, 3000,
     /*  551271 */     GIR_EraseRootFromParent_Done,
     /*  551272 */   // Label 9095: @551272
     /*  551272 */   GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(551347), // Rule ID 3001 //
     /*  551277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  551288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  551291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  551294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  551297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551323 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  551326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551345 */     GIR_RootConstrainSelectedInstOperands,
     /*  551346 */     // GIR_Coverage, 3001,
     /*  551346 */     GIR_EraseRootFromParent_Done,
     /*  551347 */   // Label 9096: @551347
     /*  551347 */   GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(551422), // Rule ID 3004 //
     /*  551352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  551363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  551366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  551369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  551372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551398 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  551398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  551401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551420 */     GIR_RootConstrainSelectedInstOperands,
     /*  551421 */     // GIR_Coverage, 3004,
     /*  551421 */     GIR_EraseRootFromParent_Done,
     /*  551422 */   // Label 9097: @551422
     /*  551422 */   GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(551497), // Rule ID 3005 //
     /*  551427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  551438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  551441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  551444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  551447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551473 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  551473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  551476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551495 */     GIR_RootConstrainSelectedInstOperands,
     /*  551496 */     // GIR_Coverage, 3005,
     /*  551496 */     GIR_EraseRootFromParent_Done,
     /*  551497 */   // Label 9098: @551497
     /*  551497 */   GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(551572), // Rule ID 3008 //
     /*  551502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  551522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551548 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551570 */     GIR_RootConstrainSelectedInstOperands,
     /*  551571 */     // GIR_Coverage, 3008,
     /*  551571 */     GIR_EraseRootFromParent_Done,
     /*  551572 */   // Label 9099: @551572
     /*  551572 */   GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(551647), // Rule ID 3009 //
     /*  551577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  551597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551623 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551645 */     GIR_RootConstrainSelectedInstOperands,
     /*  551646 */     // GIR_Coverage, 3009,
     /*  551646 */     GIR_EraseRootFromParent_Done,
     /*  551647 */   // Label 9100: @551647
     /*  551647 */   GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(551722), // Rule ID 3012 //
     /*  551652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  551672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551698 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551720 */     GIR_RootConstrainSelectedInstOperands,
     /*  551721 */     // GIR_Coverage, 3012,
     /*  551721 */     GIR_EraseRootFromParent_Done,
     /*  551722 */   // Label 9101: @551722
     /*  551722 */   GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(551797), // Rule ID 3013 //
     /*  551727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  551747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551773 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551795 */     GIR_RootConstrainSelectedInstOperands,
     /*  551796 */     // GIR_Coverage, 3013,
     /*  551796 */     GIR_EraseRootFromParent_Done,
     /*  551797 */   // Label 9102: @551797
     /*  551797 */   GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(551872), // Rule ID 3016 //
     /*  551802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  551813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  551816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  551819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  551822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551848 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  551848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551870 */     GIR_RootConstrainSelectedInstOperands,
     /*  551871 */     // GIR_Coverage, 3016,
     /*  551871 */     GIR_EraseRootFromParent_Done,
     /*  551872 */   // Label 9103: @551872
     /*  551872 */   GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(551947), // Rule ID 3017 //
     /*  551877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  551888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  551891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  551894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  551897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551923 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  551923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551945 */     GIR_RootConstrainSelectedInstOperands,
     /*  551946 */     // GIR_Coverage, 3017,
     /*  551946 */     GIR_EraseRootFromParent_Done,
     /*  551947 */   // Label 9104: @551947
     /*  551947 */   GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(552022), // Rule ID 3020 //
     /*  551952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  551955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  551963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  551966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  551969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  551972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551998 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  551998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  552001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552020 */     GIR_RootConstrainSelectedInstOperands,
     /*  552021 */     // GIR_Coverage, 3020,
     /*  552021 */     GIR_EraseRootFromParent_Done,
     /*  552022 */   // Label 9105: @552022
     /*  552022 */   GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(552097), // Rule ID 3021 //
     /*  552027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  552030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  552038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  552041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  552044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  552047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552073 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  552073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  552076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552095 */     GIR_RootConstrainSelectedInstOperands,
     /*  552096 */     // GIR_Coverage, 3021,
     /*  552096 */     GIR_EraseRootFromParent_Done,
     /*  552097 */   // Label 9106: @552097
     /*  552097 */   GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(552172), // Rule ID 3024 //
     /*  552102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  552113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  552116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  552119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  552122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552148 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552170 */     GIR_RootConstrainSelectedInstOperands,
     /*  552171 */     // GIR_Coverage, 3024,
     /*  552171 */     GIR_EraseRootFromParent_Done,
     /*  552172 */   // Label 9107: @552172
     /*  552172 */   GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(552247), // Rule ID 3025 //
     /*  552177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  552188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  552191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  552194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  552197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552223 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552245 */     GIR_RootConstrainSelectedInstOperands,
     /*  552246 */     // GIR_Coverage, 3025,
     /*  552246 */     GIR_EraseRootFromParent_Done,
     /*  552247 */   // Label 9108: @552247
     /*  552247 */   GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(552322), // Rule ID 3028 //
     /*  552252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  552263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  552266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  552269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  552272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552298 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552320 */     GIR_RootConstrainSelectedInstOperands,
     /*  552321 */     // GIR_Coverage, 3028,
     /*  552321 */     GIR_EraseRootFromParent_Done,
     /*  552322 */   // Label 9109: @552322
     /*  552322 */   GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(552397), // Rule ID 3029 //
     /*  552327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  552338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  552341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  552344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  552347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552373 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552395 */     GIR_RootConstrainSelectedInstOperands,
     /*  552396 */     // GIR_Coverage, 3029,
     /*  552396 */     GIR_EraseRootFromParent_Done,
     /*  552397 */   // Label 9110: @552397
     /*  552397 */   GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(552472), // Rule ID 3032 //
     /*  552402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  552413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  552416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  552419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  552422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552448 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552470 */     GIR_RootConstrainSelectedInstOperands,
     /*  552471 */     // GIR_Coverage, 3032,
     /*  552471 */     GIR_EraseRootFromParent_Done,
     /*  552472 */   // Label 9111: @552472
     /*  552472 */   GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(552547), // Rule ID 3033 //
     /*  552477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  552488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  552491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  552494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  552497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552523 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552545 */     GIR_RootConstrainSelectedInstOperands,
     /*  552546 */     // GIR_Coverage, 3033,
     /*  552546 */     GIR_EraseRootFromParent_Done,
     /*  552547 */   // Label 9112: @552547
     /*  552547 */   GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(552622), // Rule ID 3036 //
     /*  552552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  552572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552598 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552620 */     GIR_RootConstrainSelectedInstOperands,
     /*  552621 */     // GIR_Coverage, 3036,
     /*  552621 */     GIR_EraseRootFromParent_Done,
     /*  552622 */   // Label 9113: @552622
     /*  552622 */   GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(552697), // Rule ID 3037 //
     /*  552627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  552647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552695 */     GIR_RootConstrainSelectedInstOperands,
     /*  552696 */     // GIR_Coverage, 3037,
     /*  552696 */     GIR_EraseRootFromParent_Done,
     /*  552697 */   // Label 9114: @552697
     /*  552697 */   GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(552772), // Rule ID 3040 //
     /*  552702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  552713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  552716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  552719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  552722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552748 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552770 */     GIR_RootConstrainSelectedInstOperands,
     /*  552771 */     // GIR_Coverage, 3040,
     /*  552771 */     GIR_EraseRootFromParent_Done,
     /*  552772 */   // Label 9115: @552772
     /*  552772 */   GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(552847), // Rule ID 3041 //
     /*  552777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  552788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  552791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  552794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  552797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552823 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552845 */     GIR_RootConstrainSelectedInstOperands,
     /*  552846 */     // GIR_Coverage, 3041,
     /*  552846 */     GIR_EraseRootFromParent_Done,
     /*  552847 */   // Label 9116: @552847
     /*  552847 */   GIM_Try, /*On fail goto*//*Label 9117*/ GIMT_Encode4(552922), // Rule ID 3044 //
     /*  552852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  552863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  552866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  552869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  552872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552898 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552920 */     GIR_RootConstrainSelectedInstOperands,
     /*  552921 */     // GIR_Coverage, 3044,
     /*  552921 */     GIR_EraseRootFromParent_Done,
     /*  552922 */   // Label 9117: @552922
     /*  552922 */   GIM_Try, /*On fail goto*//*Label 9118*/ GIMT_Encode4(552997), // Rule ID 3045 //
     /*  552927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  552938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  552941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  552944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  552947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552973 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552995 */     GIR_RootConstrainSelectedInstOperands,
     /*  552996 */     // GIR_Coverage, 3045,
     /*  552996 */     GIR_EraseRootFromParent_Done,
     /*  552997 */   // Label 9118: @552997
     /*  552997 */   GIM_Try, /*On fail goto*//*Label 9119*/ GIMT_Encode4(553072), // Rule ID 3048 //
     /*  553002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  553013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  553016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  553019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  553022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  553051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553070 */     GIR_RootConstrainSelectedInstOperands,
     /*  553071 */     // GIR_Coverage, 3048,
     /*  553071 */     GIR_EraseRootFromParent_Done,
     /*  553072 */   // Label 9119: @553072
     /*  553072 */   GIM_Try, /*On fail goto*//*Label 9120*/ GIMT_Encode4(553147), // Rule ID 3049 //
     /*  553077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  553088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  553091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  553094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  553097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553123 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  553126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553145 */     GIR_RootConstrainSelectedInstOperands,
     /*  553146 */     // GIR_Coverage, 3049,
     /*  553146 */     GIR_EraseRootFromParent_Done,
     /*  553147 */   // Label 9120: @553147
     /*  553147 */   GIM_Try, /*On fail goto*//*Label 9121*/ GIMT_Encode4(553222), // Rule ID 3052 //
     /*  553152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  553163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  553166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  553169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  553172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553198 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  553201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553220 */     GIR_RootConstrainSelectedInstOperands,
     /*  553221 */     // GIR_Coverage, 3052,
     /*  553221 */     GIR_EraseRootFromParent_Done,
     /*  553222 */   // Label 9121: @553222
     /*  553222 */   GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(553297), // Rule ID 3053 //
     /*  553227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  553238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  553241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  553244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  553247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553273 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  553276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553295 */     GIR_RootConstrainSelectedInstOperands,
     /*  553296 */     // GIR_Coverage, 3053,
     /*  553296 */     GIR_EraseRootFromParent_Done,
     /*  553297 */   // Label 9122: @553297
     /*  553297 */   GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(553372), // Rule ID 3056 //
     /*  553302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  553313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  553316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  553319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  553322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553348 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  553351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553370 */     GIR_RootConstrainSelectedInstOperands,
     /*  553371 */     // GIR_Coverage, 3056,
     /*  553371 */     GIR_EraseRootFromParent_Done,
     /*  553372 */   // Label 9123: @553372
     /*  553372 */   GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(553447), // Rule ID 3057 //
     /*  553377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  553388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  553391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  553394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  553397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553423 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  553426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553445 */     GIR_RootConstrainSelectedInstOperands,
     /*  553446 */     // GIR_Coverage, 3057,
     /*  553446 */     GIR_EraseRootFromParent_Done,
     /*  553447 */   // Label 9124: @553447
     /*  553447 */   GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(553522), // Rule ID 3060 //
     /*  553452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  553472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553498 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  553501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553520 */     GIR_RootConstrainSelectedInstOperands,
     /*  553521 */     // GIR_Coverage, 3060,
     /*  553521 */     GIR_EraseRootFromParent_Done,
     /*  553522 */   // Label 9125: @553522
     /*  553522 */   GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(553597), // Rule ID 3061 //
     /*  553527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  553547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553573 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  553576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553595 */     GIR_RootConstrainSelectedInstOperands,
     /*  553596 */     // GIR_Coverage, 3061,
     /*  553596 */     GIR_EraseRootFromParent_Done,
     /*  553597 */   // Label 9126: @553597
     /*  553597 */   GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(553672), // Rule ID 3064 //
     /*  553602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  553622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553648 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  553651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553670 */     GIR_RootConstrainSelectedInstOperands,
     /*  553671 */     // GIR_Coverage, 3064,
     /*  553671 */     GIR_EraseRootFromParent_Done,
     /*  553672 */   // Label 9127: @553672
     /*  553672 */   GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(553747), // Rule ID 3065 //
     /*  553677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  553697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553723 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  553726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553745 */     GIR_RootConstrainSelectedInstOperands,
     /*  553746 */     // GIR_Coverage, 3065,
     /*  553746 */     GIR_EraseRootFromParent_Done,
     /*  553747 */   // Label 9128: @553747
     /*  553747 */   GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(553822), // Rule ID 3068 //
     /*  553752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  553763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  553766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  553769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  553772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553798 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  553801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553820 */     GIR_RootConstrainSelectedInstOperands,
     /*  553821 */     // GIR_Coverage, 3068,
     /*  553821 */     GIR_EraseRootFromParent_Done,
     /*  553822 */   // Label 9129: @553822
     /*  553822 */   GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(553897), // Rule ID 3069 //
     /*  553827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  553838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  553841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  553844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  553847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553873 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  553876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553895 */     GIR_RootConstrainSelectedInstOperands,
     /*  553896 */     // GIR_Coverage, 3069,
     /*  553896 */     GIR_EraseRootFromParent_Done,
     /*  553897 */   // Label 9130: @553897
     /*  553897 */   GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(553972), // Rule ID 3072 //
     /*  553902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  553913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  553916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  553919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553948 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  553951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553970 */     GIR_RootConstrainSelectedInstOperands,
     /*  553971 */     // GIR_Coverage, 3072,
     /*  553971 */     GIR_EraseRootFromParent_Done,
     /*  553972 */   // Label 9131: @553972
     /*  553972 */   GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(554047), // Rule ID 3073 //
     /*  553977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  553988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  553991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  553994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554023 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  554026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554045 */     GIR_RootConstrainSelectedInstOperands,
     /*  554046 */     // GIR_Coverage, 3073,
     /*  554046 */     GIR_EraseRootFromParent_Done,
     /*  554047 */   // Label 9132: @554047
     /*  554047 */   GIM_Try, /*On fail goto*//*Label 9133*/ GIMT_Encode4(554122), // Rule ID 3076 //
     /*  554052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  554063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  554066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  554069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554098 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  554101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554120 */     GIR_RootConstrainSelectedInstOperands,
     /*  554121 */     // GIR_Coverage, 3076,
     /*  554121 */     GIR_EraseRootFromParent_Done,
     /*  554122 */   // Label 9133: @554122
     /*  554122 */   GIM_Try, /*On fail goto*//*Label 9134*/ GIMT_Encode4(554197), // Rule ID 3077 //
     /*  554127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  554138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  554141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  554144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554173 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  554176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554195 */     GIR_RootConstrainSelectedInstOperands,
     /*  554196 */     // GIR_Coverage, 3077,
     /*  554196 */     GIR_EraseRootFromParent_Done,
     /*  554197 */   // Label 9134: @554197
     /*  554197 */   GIM_Try, /*On fail goto*//*Label 9135*/ GIMT_Encode4(554272), // Rule ID 3080 //
     /*  554202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  554213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  554216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  554219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554248 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554270 */     GIR_RootConstrainSelectedInstOperands,
     /*  554271 */     // GIR_Coverage, 3080,
     /*  554271 */     GIR_EraseRootFromParent_Done,
     /*  554272 */   // Label 9135: @554272
     /*  554272 */   GIM_Try, /*On fail goto*//*Label 9136*/ GIMT_Encode4(554347), // Rule ID 3081 //
     /*  554277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  554288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  554291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  554294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554323 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554345 */     GIR_RootConstrainSelectedInstOperands,
     /*  554346 */     // GIR_Coverage, 3081,
     /*  554346 */     GIR_EraseRootFromParent_Done,
     /*  554347 */   // Label 9136: @554347
     /*  554347 */   GIM_Try, /*On fail goto*//*Label 9137*/ GIMT_Encode4(554422), // Rule ID 3084 //
     /*  554352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  554363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  554366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  554369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554398 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  554401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554420 */     GIR_RootConstrainSelectedInstOperands,
     /*  554421 */     // GIR_Coverage, 3084,
     /*  554421 */     GIR_EraseRootFromParent_Done,
     /*  554422 */   // Label 9137: @554422
     /*  554422 */   GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(554497), // Rule ID 3085 //
     /*  554427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  554438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  554441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  554444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554473 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  554476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554495 */     GIR_RootConstrainSelectedInstOperands,
     /*  554496 */     // GIR_Coverage, 3085,
     /*  554496 */     GIR_EraseRootFromParent_Done,
     /*  554497 */   // Label 9138: @554497
     /*  554497 */   GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(554572), // Rule ID 3088 //
     /*  554502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554570 */     GIR_RootConstrainSelectedInstOperands,
     /*  554571 */     // GIR_Coverage, 3088,
     /*  554571 */     GIR_EraseRootFromParent_Done,
     /*  554572 */   // Label 9139: @554572
     /*  554572 */   GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(554647), // Rule ID 3089 //
     /*  554577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554623 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554645 */     GIR_RootConstrainSelectedInstOperands,
     /*  554646 */     // GIR_Coverage, 3089,
     /*  554646 */     GIR_EraseRootFromParent_Done,
     /*  554647 */   // Label 9140: @554647
     /*  554647 */   GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(554722), // Rule ID 3092 //
     /*  554652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554698 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  554698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554720 */     GIR_RootConstrainSelectedInstOperands,
     /*  554721 */     // GIR_Coverage, 3092,
     /*  554721 */     GIR_EraseRootFromParent_Done,
     /*  554722 */   // Label 9141: @554722
     /*  554722 */   GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(554797), // Rule ID 3093 //
     /*  554727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554773 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  554773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554795 */     GIR_RootConstrainSelectedInstOperands,
     /*  554796 */     // GIR_Coverage, 3093,
     /*  554796 */     GIR_EraseRootFromParent_Done,
     /*  554797 */   // Label 9142: @554797
     /*  554797 */   GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(554872), // Rule ID 3096 //
     /*  554802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554848 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554870 */     GIR_RootConstrainSelectedInstOperands,
     /*  554871 */     // GIR_Coverage, 3096,
     /*  554871 */     GIR_EraseRootFromParent_Done,
     /*  554872 */   // Label 9143: @554872
     /*  554872 */   GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(554947), // Rule ID 3097 //
     /*  554877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554923 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554945 */     GIR_RootConstrainSelectedInstOperands,
     /*  554946 */     // GIR_Coverage, 3097,
     /*  554946 */     GIR_EraseRootFromParent_Done,
     /*  554947 */   // Label 9144: @554947
     /*  554947 */   GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(555022), // Rule ID 3100 //
     /*  554952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  554963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  554966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  554969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  555001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555020 */     GIR_RootConstrainSelectedInstOperands,
     /*  555021 */     // GIR_Coverage, 3100,
     /*  555021 */     GIR_EraseRootFromParent_Done,
     /*  555022 */   // Label 9145: @555022
     /*  555022 */   GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(555097), // Rule ID 3101 //
     /*  555027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  555038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  555041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  555044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555073 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  555076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555095 */     GIR_RootConstrainSelectedInstOperands,
     /*  555096 */     // GIR_Coverage, 3101,
     /*  555096 */     GIR_EraseRootFromParent_Done,
     /*  555097 */   // Label 9146: @555097
     /*  555097 */   GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(555172), // Rule ID 3104 //
     /*  555102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  555113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  555116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  555119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555148 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  555148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  555151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555170 */     GIR_RootConstrainSelectedInstOperands,
     /*  555171 */     // GIR_Coverage, 3104,
     /*  555171 */     GIR_EraseRootFromParent_Done,
     /*  555172 */   // Label 9147: @555172
     /*  555172 */   GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(555247), // Rule ID 3105 //
     /*  555177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  555188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  555191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  555194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555223 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  555223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  555226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555245 */     GIR_RootConstrainSelectedInstOperands,
     /*  555246 */     // GIR_Coverage, 3105,
     /*  555246 */     GIR_EraseRootFromParent_Done,
     /*  555247 */   // Label 9148: @555247
     /*  555247 */   GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(555322), // Rule ID 3108 //
     /*  555252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  555255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  555263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  555266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  555269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555298 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  555298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  555301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555320 */     GIR_RootConstrainSelectedInstOperands,
     /*  555321 */     // GIR_Coverage, 3108,
     /*  555321 */     GIR_EraseRootFromParent_Done,
     /*  555322 */   // Label 9149: @555322
     /*  555322 */   GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(555397), // Rule ID 3109 //
     /*  555327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  555330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  555338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  555341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  555344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555373 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  555373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  555376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555395 */     GIR_RootConstrainSelectedInstOperands,
     /*  555396 */     // GIR_Coverage, 3109,
     /*  555396 */     GIR_EraseRootFromParent_Done,
     /*  555397 */   // Label 9150: @555397
     /*  555397 */   GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(555472), // Rule ID 3112 //
     /*  555402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  555413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  555416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  555419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555448 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555470 */     GIR_RootConstrainSelectedInstOperands,
     /*  555471 */     // GIR_Coverage, 3112,
     /*  555471 */     GIR_EraseRootFromParent_Done,
     /*  555472 */   // Label 9151: @555472
     /*  555472 */   GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(555547), // Rule ID 3113 //
     /*  555477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  555488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  555491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  555494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555523 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555545 */     GIR_RootConstrainSelectedInstOperands,
     /*  555546 */     // GIR_Coverage, 3113,
     /*  555546 */     GIR_EraseRootFromParent_Done,
     /*  555547 */   // Label 9152: @555547
     /*  555547 */   GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(555622), // Rule ID 3116 //
     /*  555552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555598 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555620 */     GIR_RootConstrainSelectedInstOperands,
     /*  555621 */     // GIR_Coverage, 3116,
     /*  555621 */     GIR_EraseRootFromParent_Done,
     /*  555622 */   // Label 9153: @555622
     /*  555622 */   GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(555697), // Rule ID 3117 //
     /*  555627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555673 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555695 */     GIR_RootConstrainSelectedInstOperands,
     /*  555696 */     // GIR_Coverage, 3117,
     /*  555696 */     GIR_EraseRootFromParent_Done,
     /*  555697 */   // Label 9154: @555697
     /*  555697 */   GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(555772), // Rule ID 3120 //
     /*  555702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555748 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555770 */     GIR_RootConstrainSelectedInstOperands,
     /*  555771 */     // GIR_Coverage, 3120,
     /*  555771 */     GIR_EraseRootFromParent_Done,
     /*  555772 */   // Label 9155: @555772
     /*  555772 */   GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(555847), // Rule ID 3121 //
     /*  555777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555823 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555845 */     GIR_RootConstrainSelectedInstOperands,
     /*  555846 */     // GIR_Coverage, 3121,
     /*  555846 */     GIR_EraseRootFromParent_Done,
     /*  555847 */   // Label 9156: @555847
     /*  555847 */   GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(555922), // Rule ID 3124 //
     /*  555852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  555863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  555866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  555869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555898 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555920 */     GIR_RootConstrainSelectedInstOperands,
     /*  555921 */     // GIR_Coverage, 3124,
     /*  555921 */     GIR_EraseRootFromParent_Done,
     /*  555922 */   // Label 9157: @555922
     /*  555922 */   GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(555997), // Rule ID 3125 //
     /*  555927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  555938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  555941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  555944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555973 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555995 */     GIR_RootConstrainSelectedInstOperands,
     /*  555996 */     // GIR_Coverage, 3125,
     /*  555996 */     GIR_EraseRootFromParent_Done,
     /*  555997 */   // Label 9158: @555997
     /*  555997 */   GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(556072), // Rule ID 3128 //
     /*  556002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  556013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  556016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  556019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556048 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  556048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556070 */     GIR_RootConstrainSelectedInstOperands,
     /*  556071 */     // GIR_Coverage, 3128,
     /*  556071 */     GIR_EraseRootFromParent_Done,
     /*  556072 */   // Label 9159: @556072
     /*  556072 */   GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(556147), // Rule ID 3129 //
     /*  556077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  556088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  556091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  556094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556123 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  556123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556145 */     GIR_RootConstrainSelectedInstOperands,
     /*  556146 */     // GIR_Coverage, 3129,
     /*  556146 */     GIR_EraseRootFromParent_Done,
     /*  556147 */   // Label 9160: @556147
     /*  556147 */   GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(556222), // Rule ID 3132 //
     /*  556152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  556163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  556166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  556169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556198 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  556198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556220 */     GIR_RootConstrainSelectedInstOperands,
     /*  556221 */     // GIR_Coverage, 3132,
     /*  556221 */     GIR_EraseRootFromParent_Done,
     /*  556222 */   // Label 9161: @556222
     /*  556222 */   GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(556297), // Rule ID 3133 //
     /*  556227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  556238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  556241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  556244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556273 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  556273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556295 */     GIR_RootConstrainSelectedInstOperands,
     /*  556296 */     // GIR_Coverage, 3133,
     /*  556296 */     GIR_EraseRootFromParent_Done,
     /*  556297 */   // Label 9162: @556297
     /*  556297 */   GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(556372), // Rule ID 3136 //
     /*  556302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  556313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  556316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  556319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  556351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556370 */     GIR_RootConstrainSelectedInstOperands,
     /*  556371 */     // GIR_Coverage, 3136,
     /*  556371 */     GIR_EraseRootFromParent_Done,
     /*  556372 */   // Label 9163: @556372
     /*  556372 */   GIM_Try, /*On fail goto*//*Label 9164*/ GIMT_Encode4(556447), // Rule ID 3137 //
     /*  556377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  556388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  556391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  556394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556423 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  556426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556445 */     GIR_RootConstrainSelectedInstOperands,
     /*  556446 */     // GIR_Coverage, 3137,
     /*  556446 */     GIR_EraseRootFromParent_Done,
     /*  556447 */   // Label 9164: @556447
     /*  556447 */   GIM_Try, /*On fail goto*//*Label 9165*/ GIMT_Encode4(556522), // Rule ID 3140 //
     /*  556452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556498 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556520 */     GIR_RootConstrainSelectedInstOperands,
     /*  556521 */     // GIR_Coverage, 3140,
     /*  556521 */     GIR_EraseRootFromParent_Done,
     /*  556522 */   // Label 9165: @556522
     /*  556522 */   GIM_Try, /*On fail goto*//*Label 9166*/ GIMT_Encode4(556597), // Rule ID 3141 //
     /*  556527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556573 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556595 */     GIR_RootConstrainSelectedInstOperands,
     /*  556596 */     // GIR_Coverage, 3141,
     /*  556596 */     GIR_EraseRootFromParent_Done,
     /*  556597 */   // Label 9166: @556597
     /*  556597 */   GIM_Try, /*On fail goto*//*Label 9167*/ GIMT_Encode4(556672), // Rule ID 3144 //
     /*  556602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556648 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556670 */     GIR_RootConstrainSelectedInstOperands,
     /*  556671 */     // GIR_Coverage, 3144,
     /*  556671 */     GIR_EraseRootFromParent_Done,
     /*  556672 */   // Label 9167: @556672
     /*  556672 */   GIM_Try, /*On fail goto*//*Label 9168*/ GIMT_Encode4(556747), // Rule ID 3145 //
     /*  556677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556723 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556745 */     GIR_RootConstrainSelectedInstOperands,
     /*  556746 */     // GIR_Coverage, 3145,
     /*  556746 */     GIR_EraseRootFromParent_Done,
     /*  556747 */   // Label 9168: @556747
     /*  556747 */   GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(556822), // Rule ID 3148 //
     /*  556752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  556801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556820 */     GIR_RootConstrainSelectedInstOperands,
     /*  556821 */     // GIR_Coverage, 3148,
     /*  556821 */     GIR_EraseRootFromParent_Done,
     /*  556822 */   // Label 9169: @556822
     /*  556822 */   GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(556897), // Rule ID 3149 //
     /*  556827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556873 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  556876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556895 */     GIR_RootConstrainSelectedInstOperands,
     /*  556896 */     // GIR_Coverage, 3149,
     /*  556896 */     GIR_EraseRootFromParent_Done,
     /*  556897 */   // Label 9170: @556897
     /*  556897 */   GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(556972), // Rule ID 3152 //
     /*  556902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556948 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556970 */     GIR_RootConstrainSelectedInstOperands,
     /*  556971 */     // GIR_Coverage, 3152,
     /*  556971 */     GIR_EraseRootFromParent_Done,
     /*  556972 */   // Label 9171: @556972
     /*  556972 */   GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(557047), // Rule ID 3153 //
     /*  556977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557023 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  557023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  557026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557045 */     GIR_RootConstrainSelectedInstOperands,
     /*  557046 */     // GIR_Coverage, 3153,
     /*  557046 */     GIR_EraseRootFromParent_Done,
     /*  557047 */   // Label 9172: @557047
     /*  557047 */   GIM_Try, /*On fail goto*//*Label 9173*/ GIMT_Encode4(557122), // Rule ID 3156 //
     /*  557052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  557055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  557063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  557066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  557069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557098 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  557098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  557101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557120 */     GIR_RootConstrainSelectedInstOperands,
     /*  557121 */     // GIR_Coverage, 3156,
     /*  557121 */     GIR_EraseRootFromParent_Done,
     /*  557122 */   // Label 9173: @557122
     /*  557122 */   GIM_Try, /*On fail goto*//*Label 9174*/ GIMT_Encode4(557197), // Rule ID 3157 //
     /*  557127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  557130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  557138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  557141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  557144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557173 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  557173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  557176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557195 */     GIR_RootConstrainSelectedInstOperands,
     /*  557196 */     // GIR_Coverage, 3157,
     /*  557196 */     GIR_EraseRootFromParent_Done,
     /*  557197 */   // Label 9174: @557197
     /*  557197 */   GIM_Try, /*On fail goto*//*Label 9175*/ GIMT_Encode4(557272), // Rule ID 3248 //
     /*  557202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  557213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  557216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  557219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  557222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557248 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  557251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557270 */     GIR_RootConstrainSelectedInstOperands,
     /*  557271 */     // GIR_Coverage, 3248,
     /*  557271 */     GIR_EraseRootFromParent_Done,
     /*  557272 */   // Label 9175: @557272
     /*  557272 */   GIM_Try, /*On fail goto*//*Label 9176*/ GIMT_Encode4(557347), // Rule ID 3249 //
     /*  557277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  557288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  557291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  557294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  557297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557323 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  557326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557345 */     GIR_RootConstrainSelectedInstOperands,
     /*  557346 */     // GIR_Coverage, 3249,
     /*  557346 */     GIR_EraseRootFromParent_Done,
     /*  557347 */   // Label 9176: @557347
     /*  557347 */   GIM_Try, /*On fail goto*//*Label 9177*/ GIMT_Encode4(557422), // Rule ID 3252 //
     /*  557352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  557363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  557366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  557369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  557372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557398 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557420 */     GIR_RootConstrainSelectedInstOperands,
     /*  557421 */     // GIR_Coverage, 3252,
     /*  557421 */     GIR_EraseRootFromParent_Done,
     /*  557422 */   // Label 9177: @557422
     /*  557422 */   GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(557497), // Rule ID 3253 //
     /*  557427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  557438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  557441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  557444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  557447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557473 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557495 */     GIR_RootConstrainSelectedInstOperands,
     /*  557496 */     // GIR_Coverage, 3253,
     /*  557496 */     GIR_EraseRootFromParent_Done,
     /*  557497 */   // Label 9178: @557497
     /*  557497 */   GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(557572), // Rule ID 3256 //
     /*  557502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  557522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557548 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557570 */     GIR_RootConstrainSelectedInstOperands,
     /*  557571 */     // GIR_Coverage, 3256,
     /*  557571 */     GIR_EraseRootFromParent_Done,
     /*  557572 */   // Label 9179: @557572
     /*  557572 */   GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(557647), // Rule ID 3257 //
     /*  557577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  557597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557623 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557645 */     GIR_RootConstrainSelectedInstOperands,
     /*  557646 */     // GIR_Coverage, 3257,
     /*  557646 */     GIR_EraseRootFromParent_Done,
     /*  557647 */   // Label 9180: @557647
     /*  557647 */   GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(557722), // Rule ID 3260 //
     /*  557652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  557672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557698 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557720 */     GIR_RootConstrainSelectedInstOperands,
     /*  557721 */     // GIR_Coverage, 3260,
     /*  557721 */     GIR_EraseRootFromParent_Done,
     /*  557722 */   // Label 9181: @557722
     /*  557722 */   GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(557797), // Rule ID 3261 //
     /*  557727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  557747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557773 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557795 */     GIR_RootConstrainSelectedInstOperands,
     /*  557796 */     // GIR_Coverage, 3261,
     /*  557796 */     GIR_EraseRootFromParent_Done,
     /*  557797 */   // Label 9182: @557797
     /*  557797 */   GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(557872), // Rule ID 3264 //
     /*  557802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  557822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557848 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557870 */     GIR_RootConstrainSelectedInstOperands,
     /*  557871 */     // GIR_Coverage, 3264,
     /*  557871 */     GIR_EraseRootFromParent_Done,
     /*  557872 */   // Label 9183: @557872
     /*  557872 */   GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(557947), // Rule ID 3265 //
     /*  557877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  557897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557923 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557945 */     GIR_RootConstrainSelectedInstOperands,
     /*  557946 */     // GIR_Coverage, 3265,
     /*  557946 */     GIR_EraseRootFromParent_Done,
     /*  557947 */   // Label 9184: @557947
     /*  557947 */   GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(558022), // Rule ID 3268 //
     /*  557952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  557963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  557966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  557969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  557972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  557998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  558001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558020 */     GIR_RootConstrainSelectedInstOperands,
     /*  558021 */     // GIR_Coverage, 3268,
     /*  558021 */     GIR_EraseRootFromParent_Done,
     /*  558022 */   // Label 9185: @558022
     /*  558022 */   GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(558097), // Rule ID 3269 //
     /*  558027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  558038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  558041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  558044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  558047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558073 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  558076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558095 */     GIR_RootConstrainSelectedInstOperands,
     /*  558096 */     // GIR_Coverage, 3269,
     /*  558096 */     GIR_EraseRootFromParent_Done,
     /*  558097 */   // Label 9186: @558097
     /*  558097 */   GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(558172), // Rule ID 3272 //
     /*  558102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  558113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  558116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  558119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  558122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558148 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558170 */     GIR_RootConstrainSelectedInstOperands,
     /*  558171 */     // GIR_Coverage, 3272,
     /*  558171 */     GIR_EraseRootFromParent_Done,
     /*  558172 */   // Label 9187: @558172
     /*  558172 */   GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(558247), // Rule ID 3273 //
     /*  558177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  558188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  558191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  558194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  558197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558223 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558245 */     GIR_RootConstrainSelectedInstOperands,
     /*  558246 */     // GIR_Coverage, 3273,
     /*  558246 */     GIR_EraseRootFromParent_Done,
     /*  558247 */   // Label 9188: @558247
     /*  558247 */   GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(558322), // Rule ID 3276 //
     /*  558252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  558263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  558266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  558269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  558272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558298 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558320 */     GIR_RootConstrainSelectedInstOperands,
     /*  558321 */     // GIR_Coverage, 3276,
     /*  558321 */     GIR_EraseRootFromParent_Done,
     /*  558322 */   // Label 9189: @558322
     /*  558322 */   GIM_Try, /*On fail goto*//*Label 9190*/ GIMT_Encode4(558397), // Rule ID 3277 //
     /*  558327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  558338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  558341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  558344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  558347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558373 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558395 */     GIR_RootConstrainSelectedInstOperands,
     /*  558396 */     // GIR_Coverage, 3277,
     /*  558396 */     GIR_EraseRootFromParent_Done,
     /*  558397 */   // Label 9190: @558397
     /*  558397 */   GIM_Try, /*On fail goto*//*Label 9191*/ GIMT_Encode4(558472), // Rule ID 3280 //
     /*  558402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  558413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  558416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  558419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  558422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  558448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558470 */     GIR_RootConstrainSelectedInstOperands,
     /*  558471 */     // GIR_Coverage, 3280,
     /*  558471 */     GIR_EraseRootFromParent_Done,
     /*  558472 */   // Label 9191: @558472
     /*  558472 */   GIM_Try, /*On fail goto*//*Label 9192*/ GIMT_Encode4(558547), // Rule ID 3281 //
     /*  558477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  558488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  558491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  558494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  558497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558523 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558545 */     GIR_RootConstrainSelectedInstOperands,
     /*  558546 */     // GIR_Coverage, 3281,
     /*  558546 */     GIR_EraseRootFromParent_Done,
     /*  558547 */   // Label 9192: @558547
     /*  558547 */   GIM_Try, /*On fail goto*//*Label 9193*/ GIMT_Encode4(558622), // Rule ID 3284 //
     /*  558552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  558555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  558572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558598 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  558598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558620 */     GIR_RootConstrainSelectedInstOperands,
     /*  558621 */     // GIR_Coverage, 3284,
     /*  558621 */     GIR_EraseRootFromParent_Done,
     /*  558622 */   // Label 9193: @558622
     /*  558622 */   GIM_Try, /*On fail goto*//*Label 9194*/ GIMT_Encode4(558697), // Rule ID 3285 //
     /*  558627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  558630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  558647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558673 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  558673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558695 */     GIR_RootConstrainSelectedInstOperands,
     /*  558696 */     // GIR_Coverage, 3285,
     /*  558696 */     GIR_EraseRootFromParent_Done,
     /*  558697 */   // Label 9194: @558697
     /*  558697 */   GIM_Try, /*On fail goto*//*Label 9195*/ GIMT_Encode4(558772), // Rule ID 3288 //
     /*  558702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  558722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558748 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558770 */     GIR_RootConstrainSelectedInstOperands,
     /*  558771 */     // GIR_Coverage, 3288,
     /*  558771 */     GIR_EraseRootFromParent_Done,
     /*  558772 */   // Label 9195: @558772
     /*  558772 */   GIM_Try, /*On fail goto*//*Label 9196*/ GIMT_Encode4(558847), // Rule ID 3289 //
     /*  558777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  558797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558823 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558845 */     GIR_RootConstrainSelectedInstOperands,
     /*  558846 */     // GIR_Coverage, 3289,
     /*  558846 */     GIR_EraseRootFromParent_Done,
     /*  558847 */   // Label 9196: @558847
     /*  558847 */   GIM_Try, /*On fail goto*//*Label 9197*/ GIMT_Encode4(558922), // Rule ID 3292 //
     /*  558852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  558863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  558866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  558869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  558872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558898 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558920 */     GIR_RootConstrainSelectedInstOperands,
     /*  558921 */     // GIR_Coverage, 3292,
     /*  558921 */     GIR_EraseRootFromParent_Done,
     /*  558922 */   // Label 9197: @558922
     /*  558922 */   GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(558997), // Rule ID 3293 //
     /*  558927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  558938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  558941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  558944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  558947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558973 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558995 */     GIR_RootConstrainSelectedInstOperands,
     /*  558996 */     // GIR_Coverage, 3293,
     /*  558996 */     GIR_EraseRootFromParent_Done,
     /*  558997 */   // Label 9198: @558997
     /*  558997 */   GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(559072), // Rule ID 3296 //
     /*  559002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  559013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  559016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  559019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  559022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559048 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  559048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559070 */     GIR_RootConstrainSelectedInstOperands,
     /*  559071 */     // GIR_Coverage, 3296,
     /*  559071 */     GIR_EraseRootFromParent_Done,
     /*  559072 */   // Label 9199: @559072
     /*  559072 */   GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(559147), // Rule ID 3297 //
     /*  559077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  559088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  559091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  559094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  559097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559123 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  559123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559145 */     GIR_RootConstrainSelectedInstOperands,
     /*  559146 */     // GIR_Coverage, 3297,
     /*  559146 */     GIR_EraseRootFromParent_Done,
     /*  559147 */   // Label 9200: @559147
     /*  559147 */   GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(559222), // Rule ID 3300 //
     /*  559152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  559163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  559166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  559169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  559172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559220 */     GIR_RootConstrainSelectedInstOperands,
     /*  559221 */     // GIR_Coverage, 3300,
     /*  559221 */     GIR_EraseRootFromParent_Done,
     /*  559222 */   // Label 9201: @559222
     /*  559222 */   GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(559297), // Rule ID 3301 //
     /*  559227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  559238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  559241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  559244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  559247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559273 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559295 */     GIR_RootConstrainSelectedInstOperands,
     /*  559296 */     // GIR_Coverage, 3301,
     /*  559296 */     GIR_EraseRootFromParent_Done,
     /*  559297 */   // Label 9202: @559297
     /*  559297 */   GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(559372), // Rule ID 3304 //
     /*  559302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  559313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  559316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  559319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  559322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559348 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559370 */     GIR_RootConstrainSelectedInstOperands,
     /*  559371 */     // GIR_Coverage, 3304,
     /*  559371 */     GIR_EraseRootFromParent_Done,
     /*  559372 */   // Label 9203: @559372
     /*  559372 */   GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(559447), // Rule ID 3305 //
     /*  559377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  559388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  559391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  559394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  559397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559423 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559445 */     GIR_RootConstrainSelectedInstOperands,
     /*  559446 */     // GIR_Coverage, 3305,
     /*  559446 */     GIR_EraseRootFromParent_Done,
     /*  559447 */   // Label 9204: @559447
     /*  559447 */   GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(559522), // Rule ID 3308 //
     /*  559452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  559472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559498 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559520 */     GIR_RootConstrainSelectedInstOperands,
     /*  559521 */     // GIR_Coverage, 3308,
     /*  559521 */     GIR_EraseRootFromParent_Done,
     /*  559522 */   // Label 9205: @559522
     /*  559522 */   GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(559597), // Rule ID 3309 //
     /*  559527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  559547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559573 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559595 */     GIR_RootConstrainSelectedInstOperands,
     /*  559596 */     // GIR_Coverage, 3309,
     /*  559596 */     GIR_EraseRootFromParent_Done,
     /*  559597 */   // Label 9206: @559597
     /*  559597 */   GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(559672), // Rule ID 3312 //
     /*  559602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  559622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559670 */     GIR_RootConstrainSelectedInstOperands,
     /*  559671 */     // GIR_Coverage, 3312,
     /*  559671 */     GIR_EraseRootFromParent_Done,
     /*  559672 */   // Label 9207: @559672
     /*  559672 */   GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(559747), // Rule ID 3313 //
     /*  559677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  559697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559723 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559745 */     GIR_RootConstrainSelectedInstOperands,
     /*  559746 */     // GIR_Coverage, 3313,
     /*  559746 */     GIR_EraseRootFromParent_Done,
     /*  559747 */   // Label 9208: @559747
     /*  559747 */   GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(559822), // Rule ID 3316 //
     /*  559752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  559772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559798 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559820 */     GIR_RootConstrainSelectedInstOperands,
     /*  559821 */     // GIR_Coverage, 3316,
     /*  559821 */     GIR_EraseRootFromParent_Done,
     /*  559822 */   // Label 9209: @559822
     /*  559822 */   GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(559897), // Rule ID 3317 //
     /*  559827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  559847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559873 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559895 */     GIR_RootConstrainSelectedInstOperands,
     /*  559896 */     // GIR_Coverage, 3317,
     /*  559896 */     GIR_EraseRootFromParent_Done,
     /*  559897 */   // Label 9210: @559897
     /*  559897 */   GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(559972), // Rule ID 3320 //
     /*  559902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  559922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559948 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559970 */     GIR_RootConstrainSelectedInstOperands,
     /*  559971 */     // GIR_Coverage, 3320,
     /*  559971 */     GIR_EraseRootFromParent_Done,
     /*  559972 */   // Label 9211: @559972
     /*  559972 */   GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(560047), // Rule ID 3321 //
     /*  559977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  559997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560023 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  560023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  560026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560045 */     GIR_RootConstrainSelectedInstOperands,
     /*  560046 */     // GIR_Coverage, 3321,
     /*  560046 */     GIR_EraseRootFromParent_Done,
     /*  560047 */   // Label 9212: @560047
     /*  560047 */   GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(560122), // Rule ID 3324 //
     /*  560052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  560063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  560066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  560069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  560072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560098 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  560101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560120 */     GIR_RootConstrainSelectedInstOperands,
     /*  560121 */     // GIR_Coverage, 3324,
     /*  560121 */     GIR_EraseRootFromParent_Done,
     /*  560122 */   // Label 9213: @560122
     /*  560122 */   GIM_Try, /*On fail goto*//*Label 9214*/ GIMT_Encode4(560197), // Rule ID 3325 //
     /*  560127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  560138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  560141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  560144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  560147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560173 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  560176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560195 */     GIR_RootConstrainSelectedInstOperands,
     /*  560196 */     // GIR_Coverage, 3325,
     /*  560196 */     GIR_EraseRootFromParent_Done,
     /*  560197 */   // Label 9214: @560197
     /*  560197 */   GIM_Try, /*On fail goto*//*Label 9215*/ GIMT_Encode4(560272), // Rule ID 3328 //
     /*  560202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  560213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  560216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  560219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  560222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560248 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  560251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560270 */     GIR_RootConstrainSelectedInstOperands,
     /*  560271 */     // GIR_Coverage, 3328,
     /*  560271 */     GIR_EraseRootFromParent_Done,
     /*  560272 */   // Label 9215: @560272
     /*  560272 */   GIM_Try, /*On fail goto*//*Label 9216*/ GIMT_Encode4(560347), // Rule ID 3329 //
     /*  560277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  560288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  560291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  560294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  560297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560323 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  560326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560345 */     GIR_RootConstrainSelectedInstOperands,
     /*  560346 */     // GIR_Coverage, 3329,
     /*  560346 */     GIR_EraseRootFromParent_Done,
     /*  560347 */   // Label 9216: @560347
     /*  560347 */   GIM_Try, /*On fail goto*//*Label 9217*/ GIMT_Encode4(560422), // Rule ID 3332 //
     /*  560352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  560363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  560366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  560369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  560372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560398 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  560401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560420 */     GIR_RootConstrainSelectedInstOperands,
     /*  560421 */     // GIR_Coverage, 3332,
     /*  560421 */     GIR_EraseRootFromParent_Done,
     /*  560422 */   // Label 9217: @560422
     /*  560422 */   GIM_Try, /*On fail goto*//*Label 9218*/ GIMT_Encode4(560497), // Rule ID 3333 //
     /*  560427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  560438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  560441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  560444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  560447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560473 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  560476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560495 */     GIR_RootConstrainSelectedInstOperands,
     /*  560496 */     // GIR_Coverage, 3333,
     /*  560496 */     GIR_EraseRootFromParent_Done,
     /*  560497 */   // Label 9218: @560497
     /*  560497 */   GIM_Try, /*On fail goto*//*Label 9219*/ GIMT_Encode4(560572), // Rule ID 3336 //
     /*  560502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  560519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560548 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  560551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560570 */     GIR_RootConstrainSelectedInstOperands,
     /*  560571 */     // GIR_Coverage, 3336,
     /*  560571 */     GIR_EraseRootFromParent_Done,
     /*  560572 */   // Label 9219: @560572
     /*  560572 */   GIM_Try, /*On fail goto*//*Label 9220*/ GIMT_Encode4(560647), // Rule ID 3337 //
     /*  560577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  560594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560623 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  560626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560645 */     GIR_RootConstrainSelectedInstOperands,
     /*  560646 */     // GIR_Coverage, 3337,
     /*  560646 */     GIR_EraseRootFromParent_Done,
     /*  560647 */   // Label 9220: @560647
     /*  560647 */   GIM_Try, /*On fail goto*//*Label 9221*/ GIMT_Encode4(560722), // Rule ID 3340 //
     /*  560652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  560669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560698 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560720 */     GIR_RootConstrainSelectedInstOperands,
     /*  560721 */     // GIR_Coverage, 3340,
     /*  560721 */     GIR_EraseRootFromParent_Done,
     /*  560722 */   // Label 9221: @560722
     /*  560722 */   GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(560797), // Rule ID 3341 //
     /*  560727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  560744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560773 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560795 */     GIR_RootConstrainSelectedInstOperands,
     /*  560796 */     // GIR_Coverage, 3341,
     /*  560796 */     GIR_EraseRootFromParent_Done,
     /*  560797 */   // Label 9222: @560797
     /*  560797 */   GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(560872), // Rule ID 3344 //
     /*  560802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  560819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560848 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560870 */     GIR_RootConstrainSelectedInstOperands,
     /*  560871 */     // GIR_Coverage, 3344,
     /*  560871 */     GIR_EraseRootFromParent_Done,
     /*  560872 */   // Label 9223: @560872
     /*  560872 */   GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(560947), // Rule ID 3345 //
     /*  560877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  560894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560923 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560945 */     GIR_RootConstrainSelectedInstOperands,
     /*  560946 */     // GIR_Coverage, 3345,
     /*  560946 */     GIR_EraseRootFromParent_Done,
     /*  560947 */   // Label 9224: @560947
     /*  560947 */   GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(561022), // Rule ID 3348 //
     /*  560952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  560963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  560966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  560969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560998 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  560998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  561001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561020 */     GIR_RootConstrainSelectedInstOperands,
     /*  561021 */     // GIR_Coverage, 3348,
     /*  561021 */     GIR_EraseRootFromParent_Done,
     /*  561022 */   // Label 9225: @561022
     /*  561022 */   GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(561097), // Rule ID 3349 //
     /*  561027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  561038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  561041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  561044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561073 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  561076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561095 */     GIR_RootConstrainSelectedInstOperands,
     /*  561096 */     // GIR_Coverage, 3349,
     /*  561096 */     GIR_EraseRootFromParent_Done,
     /*  561097 */   // Label 9226: @561097
     /*  561097 */   GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(561172), // Rule ID 3352 //
     /*  561102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  561113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  561116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  561119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  561151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561170 */     GIR_RootConstrainSelectedInstOperands,
     /*  561171 */     // GIR_Coverage, 3352,
     /*  561171 */     GIR_EraseRootFromParent_Done,
     /*  561172 */   // Label 9227: @561172
     /*  561172 */   GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(561247), // Rule ID 3353 //
     /*  561177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  561188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  561191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  561194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561223 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  561226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561245 */     GIR_RootConstrainSelectedInstOperands,
     /*  561246 */     // GIR_Coverage, 3353,
     /*  561246 */     GIR_EraseRootFromParent_Done,
     /*  561247 */   // Label 9228: @561247
     /*  561247 */   GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(561322), // Rule ID 3356 //
     /*  561252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  561263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  561266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  561269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561298 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  561298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  561301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561320 */     GIR_RootConstrainSelectedInstOperands,
     /*  561321 */     // GIR_Coverage, 3356,
     /*  561321 */     GIR_EraseRootFromParent_Done,
     /*  561322 */   // Label 9229: @561322
     /*  561322 */   GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(561397), // Rule ID 3357 //
     /*  561327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  561338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  561341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  561344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561373 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  561373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  561376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561395 */     GIR_RootConstrainSelectedInstOperands,
     /*  561396 */     // GIR_Coverage, 3357,
     /*  561396 */     GIR_EraseRootFromParent_Done,
     /*  561397 */   // Label 9230: @561397
     /*  561397 */   GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(561472), // Rule ID 3360 //
     /*  561402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  561413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  561416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  561419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561448 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561470 */     GIR_RootConstrainSelectedInstOperands,
     /*  561471 */     // GIR_Coverage, 3360,
     /*  561471 */     GIR_EraseRootFromParent_Done,
     /*  561472 */   // Label 9231: @561472
     /*  561472 */   GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(561547), // Rule ID 3361 //
     /*  561477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  561488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  561491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  561494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561523 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561545 */     GIR_RootConstrainSelectedInstOperands,
     /*  561546 */     // GIR_Coverage, 3361,
     /*  561546 */     GIR_EraseRootFromParent_Done,
     /*  561547 */   // Label 9232: @561547
     /*  561547 */   GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(561622), // Rule ID 3364 //
     /*  561552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  561569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561598 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561620 */     GIR_RootConstrainSelectedInstOperands,
     /*  561621 */     // GIR_Coverage, 3364,
     /*  561621 */     GIR_EraseRootFromParent_Done,
     /*  561622 */   // Label 9233: @561622
     /*  561622 */   GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(561697), // Rule ID 3365 //
     /*  561627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  561644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561673 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561695 */     GIR_RootConstrainSelectedInstOperands,
     /*  561696 */     // GIR_Coverage, 3365,
     /*  561696 */     GIR_EraseRootFromParent_Done,
     /*  561697 */   // Label 9234: @561697
     /*  561697 */   GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(561772), // Rule ID 3368 //
     /*  561702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  561713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  561716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561748 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  561748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561770 */     GIR_RootConstrainSelectedInstOperands,
     /*  561771 */     // GIR_Coverage, 3368,
     /*  561771 */     GIR_EraseRootFromParent_Done,
     /*  561772 */   // Label 9235: @561772
     /*  561772 */   GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(561847), // Rule ID 3369 //
     /*  561777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  561788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  561791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561823 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  561823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561845 */     GIR_RootConstrainSelectedInstOperands,
     /*  561846 */     // GIR_Coverage, 3369,
     /*  561846 */     GIR_EraseRootFromParent_Done,
     /*  561847 */   // Label 9236: @561847
     /*  561847 */   GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(561922), // Rule ID 3372 //
     /*  561852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  561855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  561863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  561866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  561869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561898 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  561898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  561917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561920 */     GIR_RootConstrainSelectedInstOperands,
     /*  561921 */     // GIR_Coverage, 3372,
     /*  561921 */     GIR_EraseRootFromParent_Done,
     /*  561922 */   // Label 9237: @561922
     /*  561922 */   GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(561997), // Rule ID 3373 //
     /*  561927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  561930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  561938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  561941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  561944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561973 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  561973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  561992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561995 */     GIR_RootConstrainSelectedInstOperands,
     /*  561996 */     // GIR_Coverage, 3373,
     /*  561996 */     GIR_EraseRootFromParent_Done,
     /*  561997 */   // Label 9238: @561997
     /*  561997 */   GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(562072), // Rule ID 3376 //
     /*  562002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  562013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  562016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  562019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562048 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562070 */     GIR_RootConstrainSelectedInstOperands,
     /*  562071 */     // GIR_Coverage, 3376,
     /*  562071 */     GIR_EraseRootFromParent_Done,
     /*  562072 */   // Label 9239: @562072
     /*  562072 */   GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(562147), // Rule ID 3377 //
     /*  562077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  562088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  562091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  562094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562123 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562145 */     GIR_RootConstrainSelectedInstOperands,
     /*  562146 */     // GIR_Coverage, 3377,
     /*  562146 */     GIR_EraseRootFromParent_Done,
     /*  562147 */   // Label 9240: @562147
     /*  562147 */   GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(562222), // Rule ID 3380 //
     /*  562152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  562163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  562166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  562169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562198 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562220 */     GIR_RootConstrainSelectedInstOperands,
     /*  562221 */     // GIR_Coverage, 3380,
     /*  562221 */     GIR_EraseRootFromParent_Done,
     /*  562222 */   // Label 9241: @562222
     /*  562222 */   GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(562297), // Rule ID 3381 //
     /*  562227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  562238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  562241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  562244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562273 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562295 */     GIR_RootConstrainSelectedInstOperands,
     /*  562296 */     // GIR_Coverage, 3381,
     /*  562296 */     GIR_EraseRootFromParent_Done,
     /*  562297 */   // Label 9242: @562297
     /*  562297 */   GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(562372), // Rule ID 3384 //
     /*  562302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  562313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  562316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  562319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562348 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562370 */     GIR_RootConstrainSelectedInstOperands,
     /*  562371 */     // GIR_Coverage, 3384,
     /*  562371 */     GIR_EraseRootFromParent_Done,
     /*  562372 */   // Label 9243: @562372
     /*  562372 */   GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(562447), // Rule ID 3385 //
     /*  562377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  562388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  562391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  562394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562423 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562445 */     GIR_RootConstrainSelectedInstOperands,
     /*  562446 */     // GIR_Coverage, 3385,
     /*  562446 */     GIR_EraseRootFromParent_Done,
     /*  562447 */   // Label 9244: @562447
     /*  562447 */   GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(562522), // Rule ID 3388 //
     /*  562452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  562463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  562466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  562469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562498 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562520 */     GIR_RootConstrainSelectedInstOperands,
     /*  562521 */     // GIR_Coverage, 3388,
     /*  562521 */     GIR_EraseRootFromParent_Done,
     /*  562522 */   // Label 9245: @562522
     /*  562522 */   GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(562597), // Rule ID 3389 //
     /*  562527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  562538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  562541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  562544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562573 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562595 */     GIR_RootConstrainSelectedInstOperands,
     /*  562596 */     // GIR_Coverage, 3389,
     /*  562596 */     GIR_EraseRootFromParent_Done,
     /*  562597 */   // Label 9246: @562597
     /*  562597 */   GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(562672), // Rule ID 3392 //
     /*  562602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  562613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  562616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  562619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562648 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562670 */     GIR_RootConstrainSelectedInstOperands,
     /*  562671 */     // GIR_Coverage, 3392,
     /*  562671 */     GIR_EraseRootFromParent_Done,
     /*  562672 */   // Label 9247: @562672
     /*  562672 */   GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(562747), // Rule ID 3393 //
     /*  562677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  562688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  562691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  562694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562723 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562745 */     GIR_RootConstrainSelectedInstOperands,
     /*  562746 */     // GIR_Coverage, 3393,
     /*  562746 */     GIR_EraseRootFromParent_Done,
     /*  562747 */   // Label 9248: @562747
     /*  562747 */   GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(562822), // Rule ID 3396 //
     /*  562752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  562763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  562766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  562769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562798 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562820 */     GIR_RootConstrainSelectedInstOperands,
     /*  562821 */     // GIR_Coverage, 3396,
     /*  562821 */     GIR_EraseRootFromParent_Done,
     /*  562822 */   // Label 9249: @562822
     /*  562822 */   GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(562897), // Rule ID 3397 //
     /*  562827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  562838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  562841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  562844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562873 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562895 */     GIR_RootConstrainSelectedInstOperands,
     /*  562896 */     // GIR_Coverage, 3397,
     /*  562896 */     GIR_EraseRootFromParent_Done,
     /*  562897 */   // Label 9250: @562897
     /*  562897 */   GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(562972), // Rule ID 3400 //
     /*  562902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  562919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562970 */     GIR_RootConstrainSelectedInstOperands,
     /*  562971 */     // GIR_Coverage, 3400,
     /*  562971 */     GIR_EraseRootFromParent_Done,
     /*  562972 */   // Label 9251: @562972
     /*  562972 */   GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(563047), // Rule ID 3401 //
     /*  562977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  562994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  563026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563045 */     GIR_RootConstrainSelectedInstOperands,
     /*  563046 */     // GIR_Coverage, 3401,
     /*  563046 */     GIR_EraseRootFromParent_Done,
     /*  563047 */   // Label 9252: @563047
     /*  563047 */   GIM_Try, /*On fail goto*//*Label 9253*/ GIMT_Encode4(563122), // Rule ID 3404 //
     /*  563052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  563063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  563066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  563069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563098 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  563098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  563101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563120 */     GIR_RootConstrainSelectedInstOperands,
     /*  563121 */     // GIR_Coverage, 3404,
     /*  563121 */     GIR_EraseRootFromParent_Done,
     /*  563122 */   // Label 9253: @563122
     /*  563122 */   GIM_Try, /*On fail goto*//*Label 9254*/ GIMT_Encode4(563197), // Rule ID 3405 //
     /*  563127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  563138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  563141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  563144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563173 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  563176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563195 */     GIR_RootConstrainSelectedInstOperands,
     /*  563196 */     // GIR_Coverage, 3405,
     /*  563196 */     GIR_EraseRootFromParent_Done,
     /*  563197 */   // Label 9254: @563197
     /*  563197 */   GIM_Try, /*On fail goto*//*Label 9255*/ GIMT_Encode4(563272), // Rule ID 3408 //
     /*  563202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  563213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  563216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  563219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  563248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  563251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563270 */     GIR_RootConstrainSelectedInstOperands,
     /*  563271 */     // GIR_Coverage, 3408,
     /*  563271 */     GIR_EraseRootFromParent_Done,
     /*  563272 */   // Label 9255: @563272
     /*  563272 */   GIM_Try, /*On fail goto*//*Label 9256*/ GIMT_Encode4(563347), // Rule ID 3409 //
     /*  563277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  563288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  563291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  563294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563323 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  563326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563345 */     GIR_RootConstrainSelectedInstOperands,
     /*  563346 */     // GIR_Coverage, 3409,
     /*  563346 */     GIR_EraseRootFromParent_Done,
     /*  563347 */   // Label 9256: @563347
     /*  563347 */   GIM_Try, /*On fail goto*//*Label 9257*/ GIMT_Encode4(563422), // Rule ID 3412 //
     /*  563352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  563363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  563366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  563369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  563401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563420 */     GIR_RootConstrainSelectedInstOperands,
     /*  563421 */     // GIR_Coverage, 3412,
     /*  563421 */     GIR_EraseRootFromParent_Done,
     /*  563422 */   // Label 9257: @563422
     /*  563422 */   GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(563497), // Rule ID 3413 //
     /*  563427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  563438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  563441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  563444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  563476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563495 */     GIR_RootConstrainSelectedInstOperands,
     /*  563496 */     // GIR_Coverage, 3413,
     /*  563496 */     GIR_EraseRootFromParent_Done,
     /*  563497 */   // Label 9258: @563497
     /*  563497 */   GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(563572), // Rule ID 3416 //
     /*  563502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  563513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  563516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  563519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563548 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  563551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563570 */     GIR_RootConstrainSelectedInstOperands,
     /*  563571 */     // GIR_Coverage, 3416,
     /*  563571 */     GIR_EraseRootFromParent_Done,
     /*  563572 */   // Label 9259: @563572
     /*  563572 */   GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(563647), // Rule ID 3417 //
     /*  563577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  563588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  563591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  563594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563623 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  563626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563645 */     GIR_RootConstrainSelectedInstOperands,
     /*  563646 */     // GIR_Coverage, 3417,
     /*  563646 */     GIR_EraseRootFromParent_Done,
     /*  563647 */   // Label 9260: @563647
     /*  563647 */   GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(563722), // Rule ID 3420 //
     /*  563652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  563663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  563666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  563669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563698 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  563701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563720 */     GIR_RootConstrainSelectedInstOperands,
     /*  563721 */     // GIR_Coverage, 3420,
     /*  563721 */     GIR_EraseRootFromParent_Done,
     /*  563722 */   // Label 9261: @563722
     /*  563722 */   GIM_Try, /*On fail goto*//*Label 9262*/ GIMT_Encode4(563797), // Rule ID 3421 //
     /*  563727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  563738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  563741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  563744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563773 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  563776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563795 */     GIR_RootConstrainSelectedInstOperands,
     /*  563796 */     // GIR_Coverage, 3421,
     /*  563796 */     GIR_EraseRootFromParent_Done,
     /*  563797 */   // Label 9262: @563797
     /*  563797 */   GIM_Try, /*On fail goto*//*Label 9263*/ GIMT_Encode4(563872), // Rule ID 3424 //
     /*  563802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  563813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  563816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  563819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563848 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  563851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563870 */     GIR_RootConstrainSelectedInstOperands,
     /*  563871 */     // GIR_Coverage, 3424,
     /*  563871 */     GIR_EraseRootFromParent_Done,
     /*  563872 */   // Label 9263: @563872
     /*  563872 */   GIM_Try, /*On fail goto*//*Label 9264*/ GIMT_Encode4(563947), // Rule ID 3425 //
     /*  563877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  563888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  563891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  563894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563923 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  563926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563945 */     GIR_RootConstrainSelectedInstOperands,
     /*  563946 */     // GIR_Coverage, 3425,
     /*  563946 */     GIR_EraseRootFromParent_Done,
     /*  563947 */   // Label 9264: @563947
     /*  563947 */   GIM_Try, /*On fail goto*//*Label 9265*/ GIMT_Encode4(564022), // Rule ID 3428 //
     /*  563952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  563963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  563966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  563969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563998 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  564001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564020 */     GIR_RootConstrainSelectedInstOperands,
     /*  564021 */     // GIR_Coverage, 3428,
     /*  564021 */     GIR_EraseRootFromParent_Done,
     /*  564022 */   // Label 9265: @564022
     /*  564022 */   GIM_Try, /*On fail goto*//*Label 9266*/ GIMT_Encode4(564097), // Rule ID 3429 //
     /*  564027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  564038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  564041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  564044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564073 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  564076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564095 */     GIR_RootConstrainSelectedInstOperands,
     /*  564096 */     // GIR_Coverage, 3429,
     /*  564096 */     GIR_EraseRootFromParent_Done,
     /*  564097 */   // Label 9266: @564097
     /*  564097 */   GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(564172), // Rule ID 3432 //
     /*  564102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  564113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  564116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  564119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564148 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564170 */     GIR_RootConstrainSelectedInstOperands,
     /*  564171 */     // GIR_Coverage, 3432,
     /*  564171 */     GIR_EraseRootFromParent_Done,
     /*  564172 */   // Label 9267: @564172
     /*  564172 */   GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(564247), // Rule ID 3433 //
     /*  564177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  564188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  564191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  564194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564223 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564245 */     GIR_RootConstrainSelectedInstOperands,
     /*  564246 */     // GIR_Coverage, 3433,
     /*  564246 */     GIR_EraseRootFromParent_Done,
     /*  564247 */   // Label 9268: @564247
     /*  564247 */   GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(564322), // Rule ID 3436 //
     /*  564252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  564263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  564266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  564269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564298 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  564301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564320 */     GIR_RootConstrainSelectedInstOperands,
     /*  564321 */     // GIR_Coverage, 3436,
     /*  564321 */     GIR_EraseRootFromParent_Done,
     /*  564322 */   // Label 9269: @564322
     /*  564322 */   GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(564397), // Rule ID 3437 //
     /*  564327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  564338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  564341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  564344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564373 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  564376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564395 */     GIR_RootConstrainSelectedInstOperands,
     /*  564396 */     // GIR_Coverage, 3437,
     /*  564396 */     GIR_EraseRootFromParent_Done,
     /*  564397 */   // Label 9270: @564397
     /*  564397 */   GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(564472), // Rule ID 3440 //
     /*  564402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  564413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  564416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  564419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564448 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564470 */     GIR_RootConstrainSelectedInstOperands,
     /*  564471 */     // GIR_Coverage, 3440,
     /*  564471 */     GIR_EraseRootFromParent_Done,
     /*  564472 */   // Label 9271: @564472
     /*  564472 */   GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(564547), // Rule ID 3441 //
     /*  564477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  564488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  564491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  564494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564523 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564545 */     GIR_RootConstrainSelectedInstOperands,
     /*  564546 */     // GIR_Coverage, 3441,
     /*  564546 */     GIR_EraseRootFromParent_Done,
     /*  564547 */   // Label 9272: @564547
     /*  564547 */   GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(564622), // Rule ID 3444 //
     /*  564552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  564569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564598 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564620 */     GIR_RootConstrainSelectedInstOperands,
     /*  564621 */     // GIR_Coverage, 3444,
     /*  564621 */     GIR_EraseRootFromParent_Done,
     /*  564622 */   // Label 9273: @564622
     /*  564622 */   GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(564697), // Rule ID 3445 //
     /*  564627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  564644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564673 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564695 */     GIR_RootConstrainSelectedInstOperands,
     /*  564696 */     // GIR_Coverage, 3445,
     /*  564696 */     GIR_EraseRootFromParent_Done,
     /*  564697 */   // Label 9274: @564697
     /*  564697 */   GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(564772), // Rule ID 3448 //
     /*  564702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  564713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  564716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  564719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564748 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564770 */     GIR_RootConstrainSelectedInstOperands,
     /*  564771 */     // GIR_Coverage, 3448,
     /*  564771 */     GIR_EraseRootFromParent_Done,
     /*  564772 */   // Label 9275: @564772
     /*  564772 */   GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(564847), // Rule ID 3449 //
     /*  564777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  564788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  564791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  564794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564823 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564845 */     GIR_RootConstrainSelectedInstOperands,
     /*  564846 */     // GIR_Coverage, 3449,
     /*  564846 */     GIR_EraseRootFromParent_Done,
     /*  564847 */   // Label 9276: @564847
     /*  564847 */   GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(564922), // Rule ID 3452 //
     /*  564852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  564863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  564866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  564869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564920 */     GIR_RootConstrainSelectedInstOperands,
     /*  564921 */     // GIR_Coverage, 3452,
     /*  564921 */     GIR_EraseRootFromParent_Done,
     /*  564922 */   // Label 9277: @564922
     /*  564922 */   GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(564997), // Rule ID 3453 //
     /*  564927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  564938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  564941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  564944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564973 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564995 */     GIR_RootConstrainSelectedInstOperands,
     /*  564996 */     // GIR_Coverage, 3453,
     /*  564996 */     GIR_EraseRootFromParent_Done,
     /*  564997 */   // Label 9278: @564997
     /*  564997 */   GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(565072), // Rule ID 3456 //
     /*  565002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  565013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  565016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  565019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  565048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  565051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565070 */     GIR_RootConstrainSelectedInstOperands,
     /*  565071 */     // GIR_Coverage, 3456,
     /*  565071 */     GIR_EraseRootFromParent_Done,
     /*  565072 */   // Label 9279: @565072
     /*  565072 */   GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(565147), // Rule ID 3457 //
     /*  565077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  565088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  565091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  565094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565123 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  565123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  565126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565145 */     GIR_RootConstrainSelectedInstOperands,
     /*  565146 */     // GIR_Coverage, 3457,
     /*  565146 */     GIR_EraseRootFromParent_Done,
     /*  565147 */   // Label 9280: @565147
     /*  565147 */   GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(565222), // Rule ID 3460 //
     /*  565152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  565155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  565163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  565166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  565169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565198 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  565198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  565201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  565217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565220 */     GIR_RootConstrainSelectedInstOperands,
     /*  565221 */     // GIR_Coverage, 3460,
     /*  565221 */     GIR_EraseRootFromParent_Done,
     /*  565222 */   // Label 9281: @565222
     /*  565222 */   GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(565297), // Rule ID 3461 //
     /*  565227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  565230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  565238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  565241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  565244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565273 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  565273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  565276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  565292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565295 */     GIR_RootConstrainSelectedInstOperands,
     /*  565296 */     // GIR_Coverage, 3461,
     /*  565296 */     GIR_EraseRootFromParent_Done,
     /*  565297 */   // Label 9282: @565297
     /*  565297 */   GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(565372), // Rule ID 3464 //
     /*  565302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  565313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  565316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  565319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565348 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565370 */     GIR_RootConstrainSelectedInstOperands,
     /*  565371 */     // GIR_Coverage, 3464,
     /*  565371 */     GIR_EraseRootFromParent_Done,
     /*  565372 */   // Label 9283: @565372
     /*  565372 */   GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(565447), // Rule ID 3465 //
     /*  565377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  565388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  565391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  565394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565423 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565445 */     GIR_RootConstrainSelectedInstOperands,
     /*  565446 */     // GIR_Coverage, 3465,
     /*  565446 */     GIR_EraseRootFromParent_Done,
     /*  565447 */   // Label 9284: @565447
     /*  565447 */   GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(565522), // Rule ID 3468 //
     /*  565452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  565469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565498 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565520 */     GIR_RootConstrainSelectedInstOperands,
     /*  565521 */     // GIR_Coverage, 3468,
     /*  565521 */     GIR_EraseRootFromParent_Done,
     /*  565522 */   // Label 9285: @565522
     /*  565522 */   GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(565597), // Rule ID 3469 //
     /*  565527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  565544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565573 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565595 */     GIR_RootConstrainSelectedInstOperands,
     /*  565596 */     // GIR_Coverage, 3469,
     /*  565596 */     GIR_EraseRootFromParent_Done,
     /*  565597 */   // Label 9286: @565597
     /*  565597 */   GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(565672), // Rule ID 3472 //
     /*  565602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  565613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  565616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  565619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565648 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565670 */     GIR_RootConstrainSelectedInstOperands,
     /*  565671 */     // GIR_Coverage, 3472,
     /*  565671 */     GIR_EraseRootFromParent_Done,
     /*  565672 */   // Label 9287: @565672
     /*  565672 */   GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(565747), // Rule ID 3473 //
     /*  565677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  565688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  565691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  565694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565723 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565745 */     GIR_RootConstrainSelectedInstOperands,
     /*  565746 */     // GIR_Coverage, 3473,
     /*  565746 */     GIR_EraseRootFromParent_Done,
     /*  565747 */   // Label 9288: @565747
     /*  565747 */   GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(565822), // Rule ID 3476 //
     /*  565752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  565763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  565766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565820 */     GIR_RootConstrainSelectedInstOperands,
     /*  565821 */     // GIR_Coverage, 3476,
     /*  565821 */     GIR_EraseRootFromParent_Done,
     /*  565822 */   // Label 9289: @565822
     /*  565822 */   GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(565897), // Rule ID 3477 //
     /*  565827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  565838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  565841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565873 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565895 */     GIR_RootConstrainSelectedInstOperands,
     /*  565896 */     // GIR_Coverage, 3477,
     /*  565896 */     GIR_EraseRootFromParent_Done,
     /*  565897 */   // Label 9290: @565897
     /*  565897 */   GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(565972), // Rule ID 3480 //
     /*  565902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  565913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  565916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565948 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565970 */     GIR_RootConstrainSelectedInstOperands,
     /*  565971 */     // GIR_Coverage, 3480,
     /*  565971 */     GIR_EraseRootFromParent_Done,
     /*  565972 */   // Label 9291: @565972
     /*  565972 */   GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(566047), // Rule ID 3481 //
     /*  565977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  565988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  565991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566023 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  566023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566045 */     GIR_RootConstrainSelectedInstOperands,
     /*  566046 */     // GIR_Coverage, 3481,
     /*  566046 */     GIR_EraseRootFromParent_Done,
     /*  566047 */   // Label 9292: @566047
     /*  566047 */   GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(566122), // Rule ID 3484 //
     /*  566052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  566063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  566066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  566069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566098 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  566098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566120 */     GIR_RootConstrainSelectedInstOperands,
     /*  566121 */     // GIR_Coverage, 3484,
     /*  566121 */     GIR_EraseRootFromParent_Done,
     /*  566122 */   // Label 9293: @566122
     /*  566122 */   GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(566197), // Rule ID 3485 //
     /*  566127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  566138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  566141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  566144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566173 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  566173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566195 */     GIR_RootConstrainSelectedInstOperands,
     /*  566196 */     // GIR_Coverage, 3485,
     /*  566196 */     GIR_EraseRootFromParent_Done,
     /*  566197 */   // Label 9294: @566197
     /*  566197 */   GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(566272), // Rule ID 3488 //
     /*  566202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  566213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  566216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  566219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  566251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566270 */     GIR_RootConstrainSelectedInstOperands,
     /*  566271 */     // GIR_Coverage, 3488,
     /*  566271 */     GIR_EraseRootFromParent_Done,
     /*  566272 */   // Label 9295: @566272
     /*  566272 */   GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(566347), // Rule ID 3489 //
     /*  566277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  566288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  566291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  566294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566323 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  566326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566345 */     GIR_RootConstrainSelectedInstOperands,
     /*  566346 */     // GIR_Coverage, 3489,
     /*  566346 */     GIR_EraseRootFromParent_Done,
     /*  566347 */   // Label 9296: @566347
     /*  566347 */   GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(566422), // Rule ID 3492 //
     /*  566352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  566363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  566366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  566369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566398 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566420 */     GIR_RootConstrainSelectedInstOperands,
     /*  566421 */     // GIR_Coverage, 3492,
     /*  566421 */     GIR_EraseRootFromParent_Done,
     /*  566422 */   // Label 9297: @566422
     /*  566422 */   GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(566497), // Rule ID 3493 //
     /*  566427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  566438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  566441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  566444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566473 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566495 */     GIR_RootConstrainSelectedInstOperands,
     /*  566496 */     // GIR_Coverage, 3493,
     /*  566496 */     GIR_EraseRootFromParent_Done,
     /*  566497 */   // Label 9298: @566497
     /*  566497 */   GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(566572), // Rule ID 3496 //
     /*  566502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  566513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  566516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566548 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566570 */     GIR_RootConstrainSelectedInstOperands,
     /*  566571 */     // GIR_Coverage, 3496,
     /*  566571 */     GIR_EraseRootFromParent_Done,
     /*  566572 */   // Label 9299: @566572
     /*  566572 */   GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(566647), // Rule ID 3497 //
     /*  566577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  566588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  566591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566623 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566645 */     GIR_RootConstrainSelectedInstOperands,
     /*  566646 */     // GIR_Coverage, 3497,
     /*  566646 */     GIR_EraseRootFromParent_Done,
     /*  566647 */   // Label 9300: @566647
     /*  566647 */   GIM_Try, /*On fail goto*//*Label 9301*/ GIMT_Encode4(566722), // Rule ID 3500 //
     /*  566652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  566663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  566666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  566701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566720 */     GIR_RootConstrainSelectedInstOperands,
     /*  566721 */     // GIR_Coverage, 3500,
     /*  566721 */     GIR_EraseRootFromParent_Done,
     /*  566722 */   // Label 9301: @566722
     /*  566722 */   GIM_Try, /*On fail goto*//*Label 9302*/ GIMT_Encode4(566797), // Rule ID 3501 //
     /*  566727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  566738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  566741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566773 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  566776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566795 */     GIR_RootConstrainSelectedInstOperands,
     /*  566796 */     // GIR_Coverage, 3501,
     /*  566796 */     GIR_EraseRootFromParent_Done,
     /*  566797 */   // Label 9302: @566797
     /*  566797 */   GIM_Try, /*On fail goto*//*Label 9303*/ GIMT_Encode4(566872), // Rule ID 3504 //
     /*  566802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  566813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  566816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566848 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566870 */     GIR_RootConstrainSelectedInstOperands,
     /*  566871 */     // GIR_Coverage, 3504,
     /*  566871 */     GIR_EraseRootFromParent_Done,
     /*  566872 */   // Label 9303: @566872
     /*  566872 */   GIM_Try, /*On fail goto*//*Label 9304*/ GIMT_Encode4(566947), // Rule ID 3505 //
     /*  566877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  566888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  566891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566923 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566945 */     GIR_RootConstrainSelectedInstOperands,
     /*  566946 */     // GIR_Coverage, 3505,
     /*  566946 */     GIR_EraseRootFromParent_Done,
     /*  566947 */   // Label 9304: @566947
     /*  566947 */   GIM_Try, /*On fail goto*//*Label 9305*/ GIMT_Encode4(567022), // Rule ID 3508 //
     /*  566952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  566963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  566966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  566969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566998 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  567001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  567017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567020 */     GIR_RootConstrainSelectedInstOperands,
     /*  567021 */     // GIR_Coverage, 3508,
     /*  567021 */     GIR_EraseRootFromParent_Done,
     /*  567022 */   // Label 9305: @567022
     /*  567022 */   GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(567097), // Rule ID 3509 //
     /*  567027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  567030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  567038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  567041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  567044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567073 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  567073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  567076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  567092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567095 */     GIR_RootConstrainSelectedInstOperands,
     /*  567096 */     // GIR_Coverage, 3509,
     /*  567096 */     GIR_EraseRootFromParent_Done,
     /*  567097 */   // Label 9306: @567097
     /*  567097 */   GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(567172), // Rule ID 3600 //
     /*  567102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  567113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  567116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  567119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  567122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567148 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  567151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567170 */     GIR_RootConstrainSelectedInstOperands,
     /*  567171 */     // GIR_Coverage, 3600,
     /*  567171 */     GIR_EraseRootFromParent_Done,
     /*  567172 */   // Label 9307: @567172
     /*  567172 */   GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(567247), // Rule ID 3601 //
     /*  567177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  567188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  567191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  567194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  567197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567223 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  567226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567245 */     GIR_RootConstrainSelectedInstOperands,
     /*  567246 */     // GIR_Coverage, 3601,
     /*  567246 */     GIR_EraseRootFromParent_Done,
     /*  567247 */   // Label 9308: @567247
     /*  567247 */   GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(567322), // Rule ID 3604 //
     /*  567252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  567263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  567266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  567269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  567272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567298 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  567301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567320 */     GIR_RootConstrainSelectedInstOperands,
     /*  567321 */     // GIR_Coverage, 3604,
     /*  567321 */     GIR_EraseRootFromParent_Done,
     /*  567322 */   // Label 9309: @567322
     /*  567322 */   GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(567397), // Rule ID 3605 //
     /*  567327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  567338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  567341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  567344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  567347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567373 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  567376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567395 */     GIR_RootConstrainSelectedInstOperands,
     /*  567396 */     // GIR_Coverage, 3605,
     /*  567396 */     GIR_EraseRootFromParent_Done,
     /*  567397 */   // Label 9310: @567397
     /*  567397 */   GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(567472), // Rule ID 3608 //
     /*  567402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  567413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  567416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  567419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  567422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567470 */     GIR_RootConstrainSelectedInstOperands,
     /*  567471 */     // GIR_Coverage, 3608,
     /*  567471 */     GIR_EraseRootFromParent_Done,
     /*  567472 */   // Label 9311: @567472
     /*  567472 */   GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(567547), // Rule ID 3609 //
     /*  567477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  567488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  567491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  567494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  567497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567523 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567545 */     GIR_RootConstrainSelectedInstOperands,
     /*  567546 */     // GIR_Coverage, 3609,
     /*  567546 */     GIR_EraseRootFromParent_Done,
     /*  567547 */   // Label 9312: @567547
     /*  567547 */   GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(567622), // Rule ID 3612 //
     /*  567552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  567563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  567566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  567569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  567572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567598 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567620 */     GIR_RootConstrainSelectedInstOperands,
     /*  567621 */     // GIR_Coverage, 3612,
     /*  567621 */     GIR_EraseRootFromParent_Done,
     /*  567622 */   // Label 9313: @567622
     /*  567622 */   GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(567697), // Rule ID 3613 //
     /*  567627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  567638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  567641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  567644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  567647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567695 */     GIR_RootConstrainSelectedInstOperands,
     /*  567696 */     // GIR_Coverage, 3613,
     /*  567696 */     GIR_EraseRootFromParent_Done,
     /*  567697 */   // Label 9314: @567697
     /*  567697 */   GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(567772), // Rule ID 3616 //
     /*  567702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  567713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  567716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  567719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  567722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567748 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  567751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567770 */     GIR_RootConstrainSelectedInstOperands,
     /*  567771 */     // GIR_Coverage, 3616,
     /*  567771 */     GIR_EraseRootFromParent_Done,
     /*  567772 */   // Label 9315: @567772
     /*  567772 */   GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(567847), // Rule ID 3617 //
     /*  567777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  567788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  567791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  567794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  567797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567823 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  567826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567845 */     GIR_RootConstrainSelectedInstOperands,
     /*  567846 */     // GIR_Coverage, 3617,
     /*  567846 */     GIR_EraseRootFromParent_Done,
     /*  567847 */   // Label 9316: @567847
     /*  567847 */   GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(567922), // Rule ID 3620 //
     /*  567852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  567863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  567866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  567869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  567872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567898 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  567901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567920 */     GIR_RootConstrainSelectedInstOperands,
     /*  567921 */     // GIR_Coverage, 3620,
     /*  567921 */     GIR_EraseRootFromParent_Done,
     /*  567922 */   // Label 9317: @567922
     /*  567922 */   GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(567997), // Rule ID 3621 //
     /*  567927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  567938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  567941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  567944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  567947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567973 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  567976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567995 */     GIR_RootConstrainSelectedInstOperands,
     /*  567996 */     // GIR_Coverage, 3621,
     /*  567996 */     GIR_EraseRootFromParent_Done,
     /*  567997 */   // Label 9318: @567997
     /*  567997 */   GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(568072), // Rule ID 3624 //
     /*  568002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  568013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  568016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  568019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  568022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568048 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  568051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568070 */     GIR_RootConstrainSelectedInstOperands,
     /*  568071 */     // GIR_Coverage, 3624,
     /*  568071 */     GIR_EraseRootFromParent_Done,
     /*  568072 */   // Label 9319: @568072
     /*  568072 */   GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(568147), // Rule ID 3625 //
     /*  568077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  568088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  568091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  568094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  568097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568123 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  568126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568145 */     GIR_RootConstrainSelectedInstOperands,
     /*  568146 */     // GIR_Coverage, 3625,
     /*  568146 */     GIR_EraseRootFromParent_Done,
     /*  568147 */   // Label 9320: @568147
     /*  568147 */   GIM_Try, /*On fail goto*//*Label 9321*/ GIMT_Encode4(568222), // Rule ID 3628 //
     /*  568152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  568163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  568166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  568169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  568172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568198 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  568201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568220 */     GIR_RootConstrainSelectedInstOperands,
     /*  568221 */     // GIR_Coverage, 3628,
     /*  568221 */     GIR_EraseRootFromParent_Done,
     /*  568222 */   // Label 9321: @568222
     /*  568222 */   GIM_Try, /*On fail goto*//*Label 9322*/ GIMT_Encode4(568297), // Rule ID 3629 //
     /*  568227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  568238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  568241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  568244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  568247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568273 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  568276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568295 */     GIR_RootConstrainSelectedInstOperands,
     /*  568296 */     // GIR_Coverage, 3629,
     /*  568296 */     GIR_EraseRootFromParent_Done,
     /*  568297 */   // Label 9322: @568297
     /*  568297 */   GIM_Try, /*On fail goto*//*Label 9323*/ GIMT_Encode4(568372), // Rule ID 3632 //
     /*  568302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  568313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  568316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  568319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  568322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  568351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568370 */     GIR_RootConstrainSelectedInstOperands,
     /*  568371 */     // GIR_Coverage, 3632,
     /*  568371 */     GIR_EraseRootFromParent_Done,
     /*  568372 */   // Label 9323: @568372
     /*  568372 */   GIM_Try, /*On fail goto*//*Label 9324*/ GIMT_Encode4(568447), // Rule ID 3633 //
     /*  568377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  568388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  568391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  568394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  568397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568423 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  568426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568445 */     GIR_RootConstrainSelectedInstOperands,
     /*  568446 */     // GIR_Coverage, 3633,
     /*  568446 */     GIR_EraseRootFromParent_Done,
     /*  568447 */   // Label 9324: @568447
     /*  568447 */   GIM_Try, /*On fail goto*//*Label 9325*/ GIMT_Encode4(568522), // Rule ID 3636 //
     /*  568452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  568463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  568466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  568469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  568472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568498 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568520 */     GIR_RootConstrainSelectedInstOperands,
     /*  568521 */     // GIR_Coverage, 3636,
     /*  568521 */     GIR_EraseRootFromParent_Done,
     /*  568522 */   // Label 9325: @568522
     /*  568522 */   GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(568597), // Rule ID 3637 //
     /*  568527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  568538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  568541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  568544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  568547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568573 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568595 */     GIR_RootConstrainSelectedInstOperands,
     /*  568596 */     // GIR_Coverage, 3637,
     /*  568596 */     GIR_EraseRootFromParent_Done,
     /*  568597 */   // Label 9326: @568597
     /*  568597 */   GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(568672), // Rule ID 3640 //
     /*  568602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  568613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  568616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  568619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  568622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568648 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568670 */     GIR_RootConstrainSelectedInstOperands,
     /*  568671 */     // GIR_Coverage, 3640,
     /*  568671 */     GIR_EraseRootFromParent_Done,
     /*  568672 */   // Label 9327: @568672
     /*  568672 */   GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(568747), // Rule ID 3641 //
     /*  568677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  568688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  568691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  568694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  568697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568723 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568745 */     GIR_RootConstrainSelectedInstOperands,
     /*  568746 */     // GIR_Coverage, 3641,
     /*  568746 */     GIR_EraseRootFromParent_Done,
     /*  568747 */   // Label 9328: @568747
     /*  568747 */   GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(568822), // Rule ID 3644 //
     /*  568752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  568763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  568766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  568769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  568772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  568801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568820 */     GIR_RootConstrainSelectedInstOperands,
     /*  568821 */     // GIR_Coverage, 3644,
     /*  568821 */     GIR_EraseRootFromParent_Done,
     /*  568822 */   // Label 9329: @568822
     /*  568822 */   GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(568897), // Rule ID 3645 //
     /*  568827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  568838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  568841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  568844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  568847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568873 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  568876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568895 */     GIR_RootConstrainSelectedInstOperands,
     /*  568896 */     // GIR_Coverage, 3645,
     /*  568896 */     GIR_EraseRootFromParent_Done,
     /*  568897 */   // Label 9330: @568897
     /*  568897 */   GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(568972), // Rule ID 3648 //
     /*  568902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  568913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  568916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  568922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  568951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568970 */     GIR_RootConstrainSelectedInstOperands,
     /*  568971 */     // GIR_Coverage, 3648,
     /*  568971 */     GIR_EraseRootFromParent_Done,
     /*  568972 */   // Label 9331: @568972
     /*  568972 */   GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(569047), // Rule ID 3649 //
     /*  568977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  568988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  568991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  568997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569023 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  569026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569045 */     GIR_RootConstrainSelectedInstOperands,
     /*  569046 */     // GIR_Coverage, 3649,
     /*  569046 */     GIR_EraseRootFromParent_Done,
     /*  569047 */   // Label 9332: @569047
     /*  569047 */   GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(569122), // Rule ID 3652 //
     /*  569052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  569055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  569063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  569066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  569069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  569072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569098 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  569098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  569101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569120 */     GIR_RootConstrainSelectedInstOperands,
     /*  569121 */     // GIR_Coverage, 3652,
     /*  569121 */     GIR_EraseRootFromParent_Done,
     /*  569122 */   // Label 9333: @569122
     /*  569122 */   GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(569197), // Rule ID 3653 //
     /*  569127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  569130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  569138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  569141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  569144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  569147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569173 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  569176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569195 */     GIR_RootConstrainSelectedInstOperands,
     /*  569196 */     // GIR_Coverage, 3653,
     /*  569196 */     GIR_EraseRootFromParent_Done,
     /*  569197 */   // Label 9334: @569197
     /*  569197 */   GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(569272), // Rule ID 3656 //
     /*  569202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  569205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  569213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  569216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  569219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  569222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569248 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  569248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  569251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569270 */     GIR_RootConstrainSelectedInstOperands,
     /*  569271 */     // GIR_Coverage, 3656,
     /*  569271 */     GIR_EraseRootFromParent_Done,
     /*  569272 */   // Label 9335: @569272
     /*  569272 */   GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(569347), // Rule ID 3657 //
     /*  569277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  569280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  569288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  569291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  569294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  569297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569323 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  569326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569345 */     GIR_RootConstrainSelectedInstOperands,
     /*  569346 */     // GIR_Coverage, 3657,
     /*  569346 */     GIR_EraseRootFromParent_Done,
     /*  569347 */   // Label 9336: @569347
     /*  569347 */   GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(569422), // Rule ID 3660 //
     /*  569352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  569363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  569366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  569369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569398 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  569401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569420 */     GIR_RootConstrainSelectedInstOperands,
     /*  569421 */     // GIR_Coverage, 3660,
     /*  569421 */     GIR_EraseRootFromParent_Done,
     /*  569422 */   // Label 9337: @569422
     /*  569422 */   GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(569497), // Rule ID 3661 //
     /*  569427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  569438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  569441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  569444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569473 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  569476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569495 */     GIR_RootConstrainSelectedInstOperands,
     /*  569496 */     // GIR_Coverage, 3661,
     /*  569496 */     GIR_EraseRootFromParent_Done,
     /*  569497 */   // Label 9338: @569497
     /*  569497 */   GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(569572), // Rule ID 3664 //
     /*  569502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  569513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  569516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  569519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569570 */     GIR_RootConstrainSelectedInstOperands,
     /*  569571 */     // GIR_Coverage, 3664,
     /*  569571 */     GIR_EraseRootFromParent_Done,
     /*  569572 */   // Label 9339: @569572
     /*  569572 */   GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(569647), // Rule ID 3665 //
     /*  569577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  569588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  569591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  569594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569623 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569645 */     GIR_RootConstrainSelectedInstOperands,
     /*  569646 */     // GIR_Coverage, 3665,
     /*  569646 */     GIR_EraseRootFromParent_Done,
     /*  569647 */   // Label 9340: @569647
     /*  569647 */   GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(569722), // Rule ID 3668 //
     /*  569652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  569663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  569666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  569669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569698 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  569701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569720 */     GIR_RootConstrainSelectedInstOperands,
     /*  569721 */     // GIR_Coverage, 3668,
     /*  569721 */     GIR_EraseRootFromParent_Done,
     /*  569722 */   // Label 9341: @569722
     /*  569722 */   GIM_Try, /*On fail goto*//*Label 9342*/ GIMT_Encode4(569797), // Rule ID 3669 //
     /*  569727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  569738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  569741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  569744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569773 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  569776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569795 */     GIR_RootConstrainSelectedInstOperands,
     /*  569796 */     // GIR_Coverage, 3669,
     /*  569796 */     GIR_EraseRootFromParent_Done,
     /*  569797 */   // Label 9342: @569797
     /*  569797 */   GIM_Try, /*On fail goto*//*Label 9343*/ GIMT_Encode4(569872), // Rule ID 3672 //
     /*  569802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  569813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  569816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  569819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  569851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569870 */     GIR_RootConstrainSelectedInstOperands,
     /*  569871 */     // GIR_Coverage, 3672,
     /*  569871 */     GIR_EraseRootFromParent_Done,
     /*  569872 */   // Label 9343: @569872
     /*  569872 */   GIM_Try, /*On fail goto*//*Label 9344*/ GIMT_Encode4(569947), // Rule ID 3673 //
     /*  569877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  569888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  569891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  569894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569923 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  569926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569945 */     GIR_RootConstrainSelectedInstOperands,
     /*  569946 */     // GIR_Coverage, 3673,
     /*  569946 */     GIR_EraseRootFromParent_Done,
     /*  569947 */   // Label 9344: @569947
     /*  569947 */   GIM_Try, /*On fail goto*//*Label 9345*/ GIMT_Encode4(570022), // Rule ID 3676 //
     /*  569952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  569963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  569966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  569969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569998 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570020 */     GIR_RootConstrainSelectedInstOperands,
     /*  570021 */     // GIR_Coverage, 3676,
     /*  570021 */     GIR_EraseRootFromParent_Done,
     /*  570022 */   // Label 9345: @570022
     /*  570022 */   GIM_Try, /*On fail goto*//*Label 9346*/ GIMT_Encode4(570097), // Rule ID 3677 //
     /*  570027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  570038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  570041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  570044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570073 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570095 */     GIR_RootConstrainSelectedInstOperands,
     /*  570096 */     // GIR_Coverage, 3677,
     /*  570096 */     GIR_EraseRootFromParent_Done,
     /*  570097 */   // Label 9346: @570097
     /*  570097 */   GIM_Try, /*On fail goto*//*Label 9347*/ GIMT_Encode4(570172), // Rule ID 3680 //
     /*  570102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  570113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  570116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  570119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570148 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570170 */     GIR_RootConstrainSelectedInstOperands,
     /*  570171 */     // GIR_Coverage, 3680,
     /*  570171 */     GIR_EraseRootFromParent_Done,
     /*  570172 */   // Label 9347: @570172
     /*  570172 */   GIM_Try, /*On fail goto*//*Label 9348*/ GIMT_Encode4(570247), // Rule ID 3681 //
     /*  570177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  570188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  570191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  570194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570223 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570245 */     GIR_RootConstrainSelectedInstOperands,
     /*  570246 */     // GIR_Coverage, 3681,
     /*  570246 */     GIR_EraseRootFromParent_Done,
     /*  570247 */   // Label 9348: @570247
     /*  570247 */   GIM_Try, /*On fail goto*//*Label 9349*/ GIMT_Encode4(570322), // Rule ID 3684 //
     /*  570252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  570263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  570266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  570269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570298 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  570301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570320 */     GIR_RootConstrainSelectedInstOperands,
     /*  570321 */     // GIR_Coverage, 3684,
     /*  570321 */     GIR_EraseRootFromParent_Done,
     /*  570322 */   // Label 9349: @570322
     /*  570322 */   GIM_Try, /*On fail goto*//*Label 9350*/ GIMT_Encode4(570397), // Rule ID 3685 //
     /*  570327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  570338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  570341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  570344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570373 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  570376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570395 */     GIR_RootConstrainSelectedInstOperands,
     /*  570396 */     // GIR_Coverage, 3685,
     /*  570396 */     GIR_EraseRootFromParent_Done,
     /*  570397 */   // Label 9350: @570397
     /*  570397 */   GIM_Try, /*On fail goto*//*Label 9351*/ GIMT_Encode4(570472), // Rule ID 3688 //
     /*  570402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  570413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  570416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  570419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  570451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570470 */     GIR_RootConstrainSelectedInstOperands,
     /*  570471 */     // GIR_Coverage, 3688,
     /*  570471 */     GIR_EraseRootFromParent_Done,
     /*  570472 */   // Label 9351: @570472
     /*  570472 */   GIM_Try, /*On fail goto*//*Label 9352*/ GIMT_Encode4(570547), // Rule ID 3689 //
     /*  570477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  570488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  570491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  570494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570523 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  570526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570545 */     GIR_RootConstrainSelectedInstOperands,
     /*  570546 */     // GIR_Coverage, 3689,
     /*  570546 */     GIR_EraseRootFromParent_Done,
     /*  570547 */   // Label 9352: @570547
     /*  570547 */   GIM_Try, /*On fail goto*//*Label 9353*/ GIMT_Encode4(570622), // Rule ID 3692 //
     /*  570552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  570563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  570566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  570569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570620 */     GIR_RootConstrainSelectedInstOperands,
     /*  570621 */     // GIR_Coverage, 3692,
     /*  570621 */     GIR_EraseRootFromParent_Done,
     /*  570622 */   // Label 9353: @570622
     /*  570622 */   GIM_Try, /*On fail goto*//*Label 9354*/ GIMT_Encode4(570697), // Rule ID 3693 //
     /*  570627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  570638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  570641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  570644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570695 */     GIR_RootConstrainSelectedInstOperands,
     /*  570696 */     // GIR_Coverage, 3693,
     /*  570696 */     GIR_EraseRootFromParent_Done,
     /*  570697 */   // Label 9354: @570697
     /*  570697 */   GIM_Try, /*On fail goto*//*Label 9355*/ GIMT_Encode4(570772), // Rule ID 3696 //
     /*  570702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  570713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  570716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  570719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570770 */     GIR_RootConstrainSelectedInstOperands,
     /*  570771 */     // GIR_Coverage, 3696,
     /*  570771 */     GIR_EraseRootFromParent_Done,
     /*  570772 */   // Label 9355: @570772
     /*  570772 */   GIM_Try, /*On fail goto*//*Label 9356*/ GIMT_Encode4(570847), // Rule ID 3697 //
     /*  570777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  570788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  570791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  570794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570823 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570845 */     GIR_RootConstrainSelectedInstOperands,
     /*  570846 */     // GIR_Coverage, 3697,
     /*  570846 */     GIR_EraseRootFromParent_Done,
     /*  570847 */   // Label 9356: @570847
     /*  570847 */   GIM_Try, /*On fail goto*//*Label 9357*/ GIMT_Encode4(570922), // Rule ID 3700 //
     /*  570852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  570863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  570866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  570869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570898 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570920 */     GIR_RootConstrainSelectedInstOperands,
     /*  570921 */     // GIR_Coverage, 3700,
     /*  570921 */     GIR_EraseRootFromParent_Done,
     /*  570922 */   // Label 9357: @570922
     /*  570922 */   GIM_Try, /*On fail goto*//*Label 9358*/ GIMT_Encode4(570997), // Rule ID 3701 //
     /*  570927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  570938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  570941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  570944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570973 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570995 */     GIR_RootConstrainSelectedInstOperands,
     /*  570996 */     // GIR_Coverage, 3701,
     /*  570996 */     GIR_EraseRootFromParent_Done,
     /*  570997 */   // Label 9358: @570997
     /*  570997 */   GIM_Try, /*On fail goto*//*Label 9359*/ GIMT_Encode4(571072), // Rule ID 3704 //
     /*  571002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  571005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  571013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  571016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  571019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  571022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571048 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  571051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571070 */     GIR_RootConstrainSelectedInstOperands,
     /*  571071 */     // GIR_Coverage, 3704,
     /*  571071 */     GIR_EraseRootFromParent_Done,
     /*  571072 */   // Label 9359: @571072
     /*  571072 */   GIM_Try, /*On fail goto*//*Label 9360*/ GIMT_Encode4(571147), // Rule ID 3705 //
     /*  571077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  571080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  571088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  571091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  571094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  571097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571123 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  571123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  571126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571145 */     GIR_RootConstrainSelectedInstOperands,
     /*  571146 */     // GIR_Coverage, 3705,
     /*  571146 */     GIR_EraseRootFromParent_Done,
     /*  571147 */   // Label 9360: @571147
     /*  571147 */   GIM_Try, /*On fail goto*//*Label 9361*/ GIMT_Encode4(571222), // Rule ID 3708 //
     /*  571152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  571155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  571163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  571166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  571169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  571172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  571201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571220 */     GIR_RootConstrainSelectedInstOperands,
     /*  571221 */     // GIR_Coverage, 3708,
     /*  571221 */     GIR_EraseRootFromParent_Done,
     /*  571222 */   // Label 9361: @571222
     /*  571222 */   GIM_Try, /*On fail goto*//*Label 9362*/ GIMT_Encode4(571297), // Rule ID 3709 //
     /*  571227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  571230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  571238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  571241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  571244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  571247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571273 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  571273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  571276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571295 */     GIR_RootConstrainSelectedInstOperands,
     /*  571296 */     // GIR_Coverage, 3709,
     /*  571296 */     GIR_EraseRootFromParent_Done,
     /*  571297 */   // Label 9362: @571297
     /*  571297 */   GIM_Try, /*On fail goto*//*Label 9363*/ GIMT_Encode4(571372), // Rule ID 3712 //
     /*  571302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  571305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  571313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  571316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  571319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  571322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571348 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  571351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571370 */     GIR_RootConstrainSelectedInstOperands,
     /*  571371 */     // GIR_Coverage, 3712,
     /*  571371 */     GIR_EraseRootFromParent_Done,
     /*  571372 */   // Label 9363: @571372
     /*  571372 */   GIM_Try, /*On fail goto*//*Label 9364*/ GIMT_Encode4(571447), // Rule ID 3713 //
     /*  571377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  571380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  571388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  571391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  571394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  571397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571423 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  571423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  571426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571445 */     GIR_RootConstrainSelectedInstOperands,
     /*  571446 */     // GIR_Coverage, 3713,
     /*  571446 */     GIR_EraseRootFromParent_Done,
     /*  571447 */   // Label 9364: @571447
     /*  571447 */   GIM_Try, /*On fail goto*//*Label 9365*/ GIMT_Encode4(571522), // Rule ID 3716 //
     /*  571452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  571455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  571463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  571466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  571469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  571472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571498 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  571501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571520 */     GIR_RootConstrainSelectedInstOperands,
     /*  571521 */     // GIR_Coverage, 3716,
     /*  571521 */     GIR_EraseRootFromParent_Done,
     /*  571522 */   // Label 9365: @571522
     /*  571522 */   GIM_Try, /*On fail goto*//*Label 9366*/ GIMT_Encode4(571597), // Rule ID 3717 //
     /*  571527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  571530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  571538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  571541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  571544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  571547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571573 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  571573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  571576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571595 */     GIR_RootConstrainSelectedInstOperands,
     /*  571596 */     // GIR_Coverage, 3717,
     /*  571596 */     GIR_EraseRootFromParent_Done,
     /*  571597 */   // Label 9366: @571597
     /*  571597 */   GIM_Try, /*On fail goto*//*Label 9367*/ GIMT_Encode4(571672), // Rule ID 3720 //
     /*  571602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  571613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  571616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  571619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  571622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  571651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571670 */     GIR_RootConstrainSelectedInstOperands,
     /*  571671 */     // GIR_Coverage, 3720,
     /*  571671 */     GIR_EraseRootFromParent_Done,
     /*  571672 */   // Label 9367: @571672
     /*  571672 */   GIM_Try, /*On fail goto*//*Label 9368*/ GIMT_Encode4(571747), // Rule ID 3721 //
     /*  571677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  571688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  571691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  571694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  571697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571723 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  571726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571745 */     GIR_RootConstrainSelectedInstOperands,
     /*  571746 */     // GIR_Coverage, 3721,
     /*  571746 */     GIR_EraseRootFromParent_Done,
     /*  571747 */   // Label 9368: @571747
     /*  571747 */   GIM_Try, /*On fail goto*//*Label 9369*/ GIMT_Encode4(571822), // Rule ID 3724 //
     /*  571752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  571763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  571766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  571769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  571772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571798 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  571801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571820 */     GIR_RootConstrainSelectedInstOperands,
     /*  571821 */     // GIR_Coverage, 3724,
     /*  571821 */     GIR_EraseRootFromParent_Done,
     /*  571822 */   // Label 9369: @571822
     /*  571822 */   GIM_Try, /*On fail goto*//*Label 9370*/ GIMT_Encode4(571897), // Rule ID 3725 //
     /*  571827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  571838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  571841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  571844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  571847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571873 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  571876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571895 */     GIR_RootConstrainSelectedInstOperands,
     /*  571896 */     // GIR_Coverage, 3725,
     /*  571896 */     GIR_EraseRootFromParent_Done,
     /*  571897 */   // Label 9370: @571897
     /*  571897 */   GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(571972), // Rule ID 3728 //
     /*  571902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  571913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  571916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  571919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  571922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571948 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  571951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571970 */     GIR_RootConstrainSelectedInstOperands,
     /*  571971 */     // GIR_Coverage, 3728,
     /*  571971 */     GIR_EraseRootFromParent_Done,
     /*  571972 */   // Label 9371: @571972
     /*  571972 */   GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(572047), // Rule ID 3729 //
     /*  571977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  571988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  571991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  571994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  571997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572023 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572045 */     GIR_RootConstrainSelectedInstOperands,
     /*  572046 */     // GIR_Coverage, 3729,
     /*  572046 */     GIR_EraseRootFromParent_Done,
     /*  572047 */   // Label 9372: @572047
     /*  572047 */   GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(572122), // Rule ID 3732 //
     /*  572052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  572063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  572066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  572069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  572072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572120 */     GIR_RootConstrainSelectedInstOperands,
     /*  572121 */     // GIR_Coverage, 3732,
     /*  572121 */     GIR_EraseRootFromParent_Done,
     /*  572122 */   // Label 9373: @572122
     /*  572122 */   GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(572197), // Rule ID 3733 //
     /*  572127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  572138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  572141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  572144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  572147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572173 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572195 */     GIR_RootConstrainSelectedInstOperands,
     /*  572196 */     // GIR_Coverage, 3733,
     /*  572196 */     GIR_EraseRootFromParent_Done,
     /*  572197 */   // Label 9374: @572197
     /*  572197 */   GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(572272), // Rule ID 3736 //
     /*  572202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  572213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  572216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  572219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  572222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572248 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572270 */     GIR_RootConstrainSelectedInstOperands,
     /*  572271 */     // GIR_Coverage, 3736,
     /*  572271 */     GIR_EraseRootFromParent_Done,
     /*  572272 */   // Label 9375: @572272
     /*  572272 */   GIM_Try, /*On fail goto*//*Label 9376*/ GIMT_Encode4(572347), // Rule ID 3737 //
     /*  572277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  572288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  572291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  572294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  572297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572323 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572345 */     GIR_RootConstrainSelectedInstOperands,
     /*  572346 */     // GIR_Coverage, 3737,
     /*  572346 */     GIR_EraseRootFromParent_Done,
     /*  572347 */   // Label 9376: @572347
     /*  572347 */   GIM_Try, /*On fail goto*//*Label 9377*/ GIMT_Encode4(572422), // Rule ID 3740 //
     /*  572352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  572363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  572366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  572369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  572372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572398 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572420 */     GIR_RootConstrainSelectedInstOperands,
     /*  572421 */     // GIR_Coverage, 3740,
     /*  572421 */     GIR_EraseRootFromParent_Done,
     /*  572422 */   // Label 9377: @572422
     /*  572422 */   GIM_Try, /*On fail goto*//*Label 9378*/ GIMT_Encode4(572497), // Rule ID 3741 //
     /*  572427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  572438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  572441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  572444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  572447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572473 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572495 */     GIR_RootConstrainSelectedInstOperands,
     /*  572496 */     // GIR_Coverage, 3741,
     /*  572496 */     GIR_EraseRootFromParent_Done,
     /*  572497 */   // Label 9378: @572497
     /*  572497 */   GIM_Try, /*On fail goto*//*Label 9379*/ GIMT_Encode4(572572), // Rule ID 3744 //
     /*  572502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  572513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  572516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  572519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  572522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572548 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  572551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572570 */     GIR_RootConstrainSelectedInstOperands,
     /*  572571 */     // GIR_Coverage, 3744,
     /*  572571 */     GIR_EraseRootFromParent_Done,
     /*  572572 */   // Label 9379: @572572
     /*  572572 */   GIM_Try, /*On fail goto*//*Label 9380*/ GIMT_Encode4(572647), // Rule ID 3745 //
     /*  572577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  572588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  572591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  572594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  572597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572623 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  572626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572645 */     GIR_RootConstrainSelectedInstOperands,
     /*  572646 */     // GIR_Coverage, 3745,
     /*  572646 */     GIR_EraseRootFromParent_Done,
     /*  572647 */   // Label 9380: @572647
     /*  572647 */   GIM_Try, /*On fail goto*//*Label 9381*/ GIMT_Encode4(572722), // Rule ID 3748 //
     /*  572652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  572663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  572666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  572669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  572672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572698 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572720 */     GIR_RootConstrainSelectedInstOperands,
     /*  572721 */     // GIR_Coverage, 3748,
     /*  572721 */     GIR_EraseRootFromParent_Done,
     /*  572722 */   // Label 9381: @572722
     /*  572722 */   GIM_Try, /*On fail goto*//*Label 9382*/ GIMT_Encode4(572797), // Rule ID 3749 //
     /*  572727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  572738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  572741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  572744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  572747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572773 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572795 */     GIR_RootConstrainSelectedInstOperands,
     /*  572796 */     // GIR_Coverage, 3749,
     /*  572796 */     GIR_EraseRootFromParent_Done,
     /*  572797 */   // Label 9382: @572797
     /*  572797 */   GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(572872), // Rule ID 3752 //
     /*  572802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  572813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  572816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  572819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  572822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572870 */     GIR_RootConstrainSelectedInstOperands,
     /*  572871 */     // GIR_Coverage, 3752,
     /*  572871 */     GIR_EraseRootFromParent_Done,
     /*  572872 */   // Label 9383: @572872
     /*  572872 */   GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(572947), // Rule ID 3753 //
     /*  572877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  572888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  572891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  572894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  572897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572923 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572945 */     GIR_RootConstrainSelectedInstOperands,
     /*  572946 */     // GIR_Coverage, 3753,
     /*  572946 */     GIR_EraseRootFromParent_Done,
     /*  572947 */   // Label 9384: @572947
     /*  572947 */   GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(573022), // Rule ID 3756 //
     /*  572952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  572963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  572966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  572969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  572972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572998 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  573001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573020 */     GIR_RootConstrainSelectedInstOperands,
     /*  573021 */     // GIR_Coverage, 3756,
     /*  573021 */     GIR_EraseRootFromParent_Done,
     /*  573022 */   // Label 9385: @573022
     /*  573022 */   GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(573097), // Rule ID 3757 //
     /*  573027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  573038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  573041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  573044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  573047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573073 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  573073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  573076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573095 */     GIR_RootConstrainSelectedInstOperands,
     /*  573096 */     // GIR_Coverage, 3757,
     /*  573096 */     GIR_EraseRootFromParent_Done,
     /*  573097 */   // Label 9386: @573097
     /*  573097 */   GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(573172), // Rule ID 3760 //
     /*  573102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  573113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  573116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  573119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  573122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573148 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  573151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573170 */     GIR_RootConstrainSelectedInstOperands,
     /*  573171 */     // GIR_Coverage, 3760,
     /*  573171 */     GIR_EraseRootFromParent_Done,
     /*  573172 */   // Label 9387: @573172
     /*  573172 */   GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(573247), // Rule ID 3761 //
     /*  573177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  573188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  573191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  573194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  573197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573223 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  573223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  573226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573245 */     GIR_RootConstrainSelectedInstOperands,
     /*  573246 */     // GIR_Coverage, 3761,
     /*  573246 */     GIR_EraseRootFromParent_Done,
     /*  573247 */   // Label 9388: @573247
     /*  573247 */   GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(573322), // Rule ID 3764 //
     /*  573252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  573255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  573263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  573266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  573269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  573272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573298 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  573301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573320 */     GIR_RootConstrainSelectedInstOperands,
     /*  573321 */     // GIR_Coverage, 3764,
     /*  573321 */     GIR_EraseRootFromParent_Done,
     /*  573322 */   // Label 9389: @573322
     /*  573322 */   GIM_Try, /*On fail goto*//*Label 9390*/ GIMT_Encode4(573397), // Rule ID 3765 //
     /*  573327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  573338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  573341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  573344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  573347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573373 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  573376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573395 */     GIR_RootConstrainSelectedInstOperands,
     /*  573396 */     // GIR_Coverage, 3765,
     /*  573396 */     GIR_EraseRootFromParent_Done,
     /*  573397 */   // Label 9390: @573397
     /*  573397 */   GIM_Try, /*On fail goto*//*Label 9391*/ GIMT_Encode4(573472), // Rule ID 3768 //
     /*  573402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  573405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  573413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  573416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  573419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  573422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573448 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  573451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573470 */     GIR_RootConstrainSelectedInstOperands,
     /*  573471 */     // GIR_Coverage, 3768,
     /*  573471 */     GIR_EraseRootFromParent_Done,
     /*  573472 */   // Label 9391: @573472
     /*  573472 */   GIM_Try, /*On fail goto*//*Label 9392*/ GIMT_Encode4(573547), // Rule ID 3769 //
     /*  573477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  573488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  573491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  573494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  573497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573523 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  573526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573545 */     GIR_RootConstrainSelectedInstOperands,
     /*  573546 */     // GIR_Coverage, 3769,
     /*  573546 */     GIR_EraseRootFromParent_Done,
     /*  573547 */   // Label 9392: @573547
     /*  573547 */   GIM_Try, /*On fail goto*//*Label 9393*/ GIMT_Encode4(573622), // Rule ID 3772 //
     /*  573552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  573555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  573563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  573566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  573569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  573572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573598 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  573601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573620 */     GIR_RootConstrainSelectedInstOperands,
     /*  573621 */     // GIR_Coverage, 3772,
     /*  573621 */     GIR_EraseRootFromParent_Done,
     /*  573622 */   // Label 9393: @573622
     /*  573622 */   GIM_Try, /*On fail goto*//*Label 9394*/ GIMT_Encode4(573697), // Rule ID 3773 //
     /*  573627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  573638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  573641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  573644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  573647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573673 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  573676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573695 */     GIR_RootConstrainSelectedInstOperands,
     /*  573696 */     // GIR_Coverage, 3773,
     /*  573696 */     GIR_EraseRootFromParent_Done,
     /*  573697 */   // Label 9394: @573697
     /*  573697 */   GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(573772), // Rule ID 3776 //
     /*  573702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  573705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  573713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  573716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  573719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  573722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573748 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  573751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573770 */     GIR_RootConstrainSelectedInstOperands,
     /*  573771 */     // GIR_Coverage, 3776,
     /*  573771 */     GIR_EraseRootFromParent_Done,
     /*  573772 */   // Label 9395: @573772
     /*  573772 */   GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(573847), // Rule ID 3777 //
     /*  573777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  573788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  573791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  573794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  573797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573823 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  573826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573845 */     GIR_RootConstrainSelectedInstOperands,
     /*  573846 */     // GIR_Coverage, 3777,
     /*  573846 */     GIR_EraseRootFromParent_Done,
     /*  573847 */   // Label 9396: @573847
     /*  573847 */   GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(573922), // Rule ID 3780 //
     /*  573852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  573863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  573866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  573869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573898 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  573901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573920 */     GIR_RootConstrainSelectedInstOperands,
     /*  573921 */     // GIR_Coverage, 3780,
     /*  573921 */     GIR_EraseRootFromParent_Done,
     /*  573922 */   // Label 9397: @573922
     /*  573922 */   GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(573997), // Rule ID 3781 //
     /*  573927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  573938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  573941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  573944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573973 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  573976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573995 */     GIR_RootConstrainSelectedInstOperands,
     /*  573996 */     // GIR_Coverage, 3781,
     /*  573996 */     GIR_EraseRootFromParent_Done,
     /*  573997 */   // Label 9398: @573997
     /*  573997 */   GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(574072), // Rule ID 3784 //
     /*  574002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  574013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  574016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  574019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574048 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  574051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574070 */     GIR_RootConstrainSelectedInstOperands,
     /*  574071 */     // GIR_Coverage, 3784,
     /*  574071 */     GIR_EraseRootFromParent_Done,
     /*  574072 */   // Label 9399: @574072
     /*  574072 */   GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(574147), // Rule ID 3785 //
     /*  574077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  574088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  574091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  574094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574123 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  574126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574145 */     GIR_RootConstrainSelectedInstOperands,
     /*  574146 */     // GIR_Coverage, 3785,
     /*  574146 */     GIR_EraseRootFromParent_Done,
     /*  574147 */   // Label 9400: @574147
     /*  574147 */   GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(574222), // Rule ID 3788 //
     /*  574152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  574163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  574166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  574169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574198 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574220 */     GIR_RootConstrainSelectedInstOperands,
     /*  574221 */     // GIR_Coverage, 3788,
     /*  574221 */     GIR_EraseRootFromParent_Done,
     /*  574222 */   // Label 9401: @574222
     /*  574222 */   GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(574297), // Rule ID 3789 //
     /*  574227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  574238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  574241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  574244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574273 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574295 */     GIR_RootConstrainSelectedInstOperands,
     /*  574296 */     // GIR_Coverage, 3789,
     /*  574296 */     GIR_EraseRootFromParent_Done,
     /*  574297 */   // Label 9402: @574297
     /*  574297 */   GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(574372), // Rule ID 3792 //
     /*  574302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  574313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  574316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  574319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  574351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574370 */     GIR_RootConstrainSelectedInstOperands,
     /*  574371 */     // GIR_Coverage, 3792,
     /*  574371 */     GIR_EraseRootFromParent_Done,
     /*  574372 */   // Label 9403: @574372
     /*  574372 */   GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(574447), // Rule ID 3793 //
     /*  574377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  574388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  574391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  574394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574423 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  574426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574445 */     GIR_RootConstrainSelectedInstOperands,
     /*  574446 */     // GIR_Coverage, 3793,
     /*  574446 */     GIR_EraseRootFromParent_Done,
     /*  574447 */   // Label 9404: @574447
     /*  574447 */   GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(574522), // Rule ID 3796 //
     /*  574452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  574463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  574466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  574469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574498 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574520 */     GIR_RootConstrainSelectedInstOperands,
     /*  574521 */     // GIR_Coverage, 3796,
     /*  574521 */     GIR_EraseRootFromParent_Done,
     /*  574522 */   // Label 9405: @574522
     /*  574522 */   GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(574597), // Rule ID 3797 //
     /*  574527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  574538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  574541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  574544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574573 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574595 */     GIR_RootConstrainSelectedInstOperands,
     /*  574596 */     // GIR_Coverage, 3797,
     /*  574596 */     GIR_EraseRootFromParent_Done,
     /*  574597 */   // Label 9406: @574597
     /*  574597 */   GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(574672), // Rule ID 3800 //
     /*  574602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  574613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  574616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  574619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574648 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  574651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574670 */     GIR_RootConstrainSelectedInstOperands,
     /*  574671 */     // GIR_Coverage, 3800,
     /*  574671 */     GIR_EraseRootFromParent_Done,
     /*  574672 */   // Label 9407: @574672
     /*  574672 */   GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(574747), // Rule ID 3801 //
     /*  574677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  574688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  574691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  574694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574723 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  574726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574745 */     GIR_RootConstrainSelectedInstOperands,
     /*  574746 */     // GIR_Coverage, 3801,
     /*  574746 */     GIR_EraseRootFromParent_Done,
     /*  574747 */   // Label 9408: @574747
     /*  574747 */   GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(574822), // Rule ID 3804 //
     /*  574752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  574763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  574766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  574769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574798 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  574801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574820 */     GIR_RootConstrainSelectedInstOperands,
     /*  574821 */     // GIR_Coverage, 3804,
     /*  574821 */     GIR_EraseRootFromParent_Done,
     /*  574822 */   // Label 9409: @574822
     /*  574822 */   GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(574897), // Rule ID 3805 //
     /*  574827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  574838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  574841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  574844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574873 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  574876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574895 */     GIR_RootConstrainSelectedInstOperands,
     /*  574896 */     // GIR_Coverage, 3805,
     /*  574896 */     GIR_EraseRootFromParent_Done,
     /*  574897 */   // Label 9410: @574897
     /*  574897 */   GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(574972), // Rule ID 3808 //
     /*  574902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  574913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  574916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  574919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574970 */     GIR_RootConstrainSelectedInstOperands,
     /*  574971 */     // GIR_Coverage, 3808,
     /*  574971 */     GIR_EraseRootFromParent_Done,
     /*  574972 */   // Label 9411: @574972
     /*  574972 */   GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(575047), // Rule ID 3809 //
     /*  574977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  574988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  574991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  574994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575023 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  575023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  575026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575045 */     GIR_RootConstrainSelectedInstOperands,
     /*  575046 */     // GIR_Coverage, 3809,
     /*  575046 */     GIR_EraseRootFromParent_Done,
     /*  575047 */   // Label 9412: @575047
     /*  575047 */   GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(575122), // Rule ID 3812 //
     /*  575052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  575063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  575066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  575069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575098 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  575098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  575101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575120 */     GIR_RootConstrainSelectedInstOperands,
     /*  575121 */     // GIR_Coverage, 3812,
     /*  575121 */     GIR_EraseRootFromParent_Done,
     /*  575122 */   // Label 9413: @575122
     /*  575122 */   GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(575197), // Rule ID 3813 //
     /*  575127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  575138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  575141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  575144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575173 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  575173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  575176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575195 */     GIR_RootConstrainSelectedInstOperands,
     /*  575196 */     // GIR_Coverage, 3813,
     /*  575196 */     GIR_EraseRootFromParent_Done,
     /*  575197 */   // Label 9414: @575197
     /*  575197 */   GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(575272), // Rule ID 3816 //
     /*  575202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  575213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  575216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  575219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  575248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  575251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575270 */     GIR_RootConstrainSelectedInstOperands,
     /*  575271 */     // GIR_Coverage, 3816,
     /*  575271 */     GIR_EraseRootFromParent_Done,
     /*  575272 */   // Label 9415: @575272
     /*  575272 */   GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(575347), // Rule ID 3817 //
     /*  575277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  575288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  575291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  575294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575323 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  575323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  575326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575345 */     GIR_RootConstrainSelectedInstOperands,
     /*  575346 */     // GIR_Coverage, 3817,
     /*  575346 */     GIR_EraseRootFromParent_Done,
     /*  575347 */   // Label 9416: @575347
     /*  575347 */   GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(575422), // Rule ID 3820 //
     /*  575352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  575363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  575366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  575369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  575398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575420 */     GIR_RootConstrainSelectedInstOperands,
     /*  575421 */     // GIR_Coverage, 3820,
     /*  575421 */     GIR_EraseRootFromParent_Done,
     /*  575422 */   // Label 9417: @575422
     /*  575422 */   GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(575497), // Rule ID 3821 //
     /*  575427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  575438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  575441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  575444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575473 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  575473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575495 */     GIR_RootConstrainSelectedInstOperands,
     /*  575496 */     // GIR_Coverage, 3821,
     /*  575496 */     GIR_EraseRootFromParent_Done,
     /*  575497 */   // Label 9418: @575497
     /*  575497 */   GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(575572), // Rule ID 3824 //
     /*  575502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  575513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  575516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  575519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575548 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  575551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575570 */     GIR_RootConstrainSelectedInstOperands,
     /*  575571 */     // GIR_Coverage, 3824,
     /*  575571 */     GIR_EraseRootFromParent_Done,
     /*  575572 */   // Label 9419: @575572
     /*  575572 */   GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(575647), // Rule ID 3825 //
     /*  575577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  575588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  575591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  575594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575623 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  575626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575645 */     GIR_RootConstrainSelectedInstOperands,
     /*  575646 */     // GIR_Coverage, 3825,
     /*  575646 */     GIR_EraseRootFromParent_Done,
     /*  575647 */   // Label 9420: @575647
     /*  575647 */   GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(575722), // Rule ID 3828 //
     /*  575652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  575663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  575666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  575669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  575701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575720 */     GIR_RootConstrainSelectedInstOperands,
     /*  575721 */     // GIR_Coverage, 3828,
     /*  575721 */     GIR_EraseRootFromParent_Done,
     /*  575722 */   // Label 9421: @575722
     /*  575722 */   GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(575797), // Rule ID 3829 //
     /*  575727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  575738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  575741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  575744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575773 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  575776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575795 */     GIR_RootConstrainSelectedInstOperands,
     /*  575796 */     // GIR_Coverage, 3829,
     /*  575796 */     GIR_EraseRootFromParent_Done,
     /*  575797 */   // Label 9422: @575797
     /*  575797 */   GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(575872), // Rule ID 3832 //
     /*  575802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  575813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  575816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  575819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575848 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  575851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575870 */     GIR_RootConstrainSelectedInstOperands,
     /*  575871 */     // GIR_Coverage, 3832,
     /*  575871 */     GIR_EraseRootFromParent_Done,
     /*  575872 */   // Label 9423: @575872
     /*  575872 */   GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(575947), // Rule ID 3833 //
     /*  575877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  575888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  575891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  575894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575923 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  575926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575945 */     GIR_RootConstrainSelectedInstOperands,
     /*  575946 */     // GIR_Coverage, 3833,
     /*  575946 */     GIR_EraseRootFromParent_Done,
     /*  575947 */   // Label 9424: @575947
     /*  575947 */   GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(576022), // Rule ID 3836 //
     /*  575952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  575963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  575966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  575969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575998 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  576001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576020 */     GIR_RootConstrainSelectedInstOperands,
     /*  576021 */     // GIR_Coverage, 3836,
     /*  576021 */     GIR_EraseRootFromParent_Done,
     /*  576022 */   // Label 9425: @576022
     /*  576022 */   GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(576097), // Rule ID 3837 //
     /*  576027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  576030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  576038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  576041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  576044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  576047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  576066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576073 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  576073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  576076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576095 */     GIR_RootConstrainSelectedInstOperands,
     /*  576096 */     // GIR_Coverage, 3837,
     /*  576096 */     GIR_EraseRootFromParent_Done,
     /*  576097 */   // Label 9426: @576097
     /*  576097 */   GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(576172), // Rule ID 3840 //
     /*  576102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  576113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  576116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  576119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  576122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576148 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11694:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  576151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576170 */     GIR_RootConstrainSelectedInstOperands,
     /*  576171 */     // GIR_Coverage, 3840,
     /*  576171 */     GIR_EraseRootFromParent_Done,
     /*  576172 */   // Label 9427: @576172
     /*  576172 */   GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(576247), // Rule ID 3841 //
     /*  576177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  576188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  576191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  576194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  576197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576223 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11694:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  576226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576245 */     GIR_RootConstrainSelectedInstOperands,
     /*  576246 */     // GIR_Coverage, 3841,
     /*  576246 */     GIR_EraseRootFromParent_Done,
     /*  576247 */   // Label 9428: @576247
     /*  576247 */   GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(576322), // Rule ID 3844 //
     /*  576252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  576263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  576266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  576269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  576272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576298 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11694:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  576301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576320 */     GIR_RootConstrainSelectedInstOperands,
     /*  576321 */     // GIR_Coverage, 3844,
     /*  576321 */     GIR_EraseRootFromParent_Done,
     /*  576322 */   // Label 9429: @576322
     /*  576322 */   GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(576397), // Rule ID 3845 //
     /*  576327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  576338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  576341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  576344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  576347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576373 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11694:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  576376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576395 */     GIR_RootConstrainSelectedInstOperands,
     /*  576396 */     // GIR_Coverage, 3845,
     /*  576396 */     GIR_EraseRootFromParent_Done,
     /*  576397 */   // Label 9430: @576397
     /*  576397 */   GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(576472), // Rule ID 3848 //
     /*  576402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  576413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  576416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  576419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  576422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11694:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576470 */     GIR_RootConstrainSelectedInstOperands,
     /*  576471 */     // GIR_Coverage, 3848,
     /*  576471 */     GIR_EraseRootFromParent_Done,
     /*  576472 */   // Label 9431: @576472
     /*  576472 */   GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(576547), // Rule ID 3849 //
     /*  576477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  576488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  576491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  576494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  576497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576523 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11694:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576545 */     GIR_RootConstrainSelectedInstOperands,
     /*  576546 */     // GIR_Coverage, 3849,
     /*  576546 */     GIR_EraseRootFromParent_Done,
     /*  576547 */   // Label 9432: @576547
     /*  576547 */   GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(576622), // Rule ID 3852 //
     /*  576552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  576563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  576566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  576569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  576572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576598 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11694:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576620 */     GIR_RootConstrainSelectedInstOperands,
     /*  576621 */     // GIR_Coverage, 3852,
     /*  576621 */     GIR_EraseRootFromParent_Done,
     /*  576622 */   // Label 9433: @576622
     /*  576622 */   GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(576697), // Rule ID 3853 //
     /*  576627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  576638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  576641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  576644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  576647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11694:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576695 */     GIR_RootConstrainSelectedInstOperands,
     /*  576696 */     // GIR_Coverage, 3853,
     /*  576696 */     GIR_EraseRootFromParent_Done,
     /*  576697 */   // Label 9434: @576697
     /*  576697 */   GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(576772), // Rule ID 3856 //
     /*  576702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  576713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  576716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  576719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  576722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576748 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11694:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  576751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576770 */     GIR_RootConstrainSelectedInstOperands,
     /*  576771 */     // GIR_Coverage, 3856,
     /*  576771 */     GIR_EraseRootFromParent_Done,
     /*  576772 */   // Label 9435: @576772
     /*  576772 */   GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(576847), // Rule ID 3857 //
     /*  576777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  576788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  576791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  576794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  576797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576823 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11694:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  576826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576845 */     GIR_RootConstrainSelectedInstOperands,
     /*  576846 */     // GIR_Coverage, 3857,
     /*  576846 */     GIR_EraseRootFromParent_Done,
     /*  576847 */   // Label 9436: @576847
     /*  576847 */   GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(576922), // Rule ID 3860 //
     /*  576852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  576863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  576866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  576869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  576872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576898 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11694:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  576901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576920 */     GIR_RootConstrainSelectedInstOperands,
     /*  576921 */     // GIR_Coverage, 3860,
     /*  576921 */     GIR_EraseRootFromParent_Done,
     /*  576922 */   // Label 9437: @576922
     /*  576922 */   GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(576997), // Rule ID 3861 //
     /*  576927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  576938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  576941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  576944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  576947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576973 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11694:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  576976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576995 */     GIR_RootConstrainSelectedInstOperands,
     /*  576996 */     // GIR_Coverage, 3861,
     /*  576996 */     GIR_EraseRootFromParent_Done,
     /*  576997 */   // Label 9438: @576997
     /*  576997 */   GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(577072), // Rule ID 3864 //
     /*  577002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  577013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  577016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  577019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  577022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577048 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11694:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  577051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577070 */     GIR_RootConstrainSelectedInstOperands,
     /*  577071 */     // GIR_Coverage, 3864,
     /*  577071 */     GIR_EraseRootFromParent_Done,
     /*  577072 */   // Label 9439: @577072
     /*  577072 */   GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(577147), // Rule ID 3865 //
     /*  577077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  577088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  577091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  577094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  577097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577123 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11694:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  577126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577145 */     GIR_RootConstrainSelectedInstOperands,
     /*  577146 */     // GIR_Coverage, 3865,
     /*  577146 */     GIR_EraseRootFromParent_Done,
     /*  577147 */   // Label 9440: @577147
     /*  577147 */   GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(577222), // Rule ID 3868 //
     /*  577152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  577163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  577166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  577169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  577172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577198 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11694:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  577201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577220 */     GIR_RootConstrainSelectedInstOperands,
     /*  577221 */     // GIR_Coverage, 3868,
     /*  577221 */     GIR_EraseRootFromParent_Done,
     /*  577222 */   // Label 9441: @577222
     /*  577222 */   GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(577297), // Rule ID 3869 //
     /*  577227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  577238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  577241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  577244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  577247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577273 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11694:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  577276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577295 */     GIR_RootConstrainSelectedInstOperands,
     /*  577296 */     // GIR_Coverage, 3869,
     /*  577296 */     GIR_EraseRootFromParent_Done,
     /*  577297 */   // Label 9442: @577297
     /*  577297 */   GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(577372), // Rule ID 3872 //
     /*  577302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  577313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  577316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  577319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  577322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11694:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  577351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577370 */     GIR_RootConstrainSelectedInstOperands,
     /*  577371 */     // GIR_Coverage, 3872,
     /*  577371 */     GIR_EraseRootFromParent_Done,
     /*  577372 */   // Label 9443: @577372
     /*  577372 */   GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(577447), // Rule ID 3873 //
     /*  577377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  577388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  577391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  577394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  577397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577423 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11694:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  577426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577445 */     GIR_RootConstrainSelectedInstOperands,
     /*  577446 */     // GIR_Coverage, 3873,
     /*  577446 */     GIR_EraseRootFromParent_Done,
     /*  577447 */   // Label 9444: @577447
     /*  577447 */   GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(577522), // Rule ID 3876 //
     /*  577452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  577463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  577466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  577469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  577472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577498 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11694:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577520 */     GIR_RootConstrainSelectedInstOperands,
     /*  577521 */     // GIR_Coverage, 3876,
     /*  577521 */     GIR_EraseRootFromParent_Done,
     /*  577522 */   // Label 9445: @577522
     /*  577522 */   GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(577597), // Rule ID 3877 //
     /*  577527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  577538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  577541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  577544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  577547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577573 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11694:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577595 */     GIR_RootConstrainSelectedInstOperands,
     /*  577596 */     // GIR_Coverage, 3877,
     /*  577596 */     GIR_EraseRootFromParent_Done,
     /*  577597 */   // Label 9446: @577597
     /*  577597 */   GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(577672), // Rule ID 3880 //
     /*  577602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  577613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  577616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  577619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  577622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577648 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11694:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577670 */     GIR_RootConstrainSelectedInstOperands,
     /*  577671 */     // GIR_Coverage, 3880,
     /*  577671 */     GIR_EraseRootFromParent_Done,
     /*  577672 */   // Label 9447: @577672
     /*  577672 */   GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(577747), // Rule ID 3881 //
     /*  577677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  577688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  577691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  577694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  577697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577723 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11694:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577745 */     GIR_RootConstrainSelectedInstOperands,
     /*  577746 */     // GIR_Coverage, 3881,
     /*  577746 */     GIR_EraseRootFromParent_Done,
     /*  577747 */   // Label 9448: @577747
     /*  577747 */   GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(577822), // Rule ID 3884 //
     /*  577752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  577763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  577766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  577769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  577772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11694:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  577801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577820 */     GIR_RootConstrainSelectedInstOperands,
     /*  577821 */     // GIR_Coverage, 3884,
     /*  577821 */     GIR_EraseRootFromParent_Done,
     /*  577822 */   // Label 9449: @577822
     /*  577822 */   GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(577897), // Rule ID 3885 //
     /*  577827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  577838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  577841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  577844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  577847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577873 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11694:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  577876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577895 */     GIR_RootConstrainSelectedInstOperands,
     /*  577896 */     // GIR_Coverage, 3885,
     /*  577896 */     GIR_EraseRootFromParent_Done,
     /*  577897 */   // Label 9450: @577897
     /*  577897 */   GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(577972), // Rule ID 3888 //
     /*  577902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  577913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  577916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  577919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  577922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11694:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  577951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577970 */     GIR_RootConstrainSelectedInstOperands,
     /*  577971 */     // GIR_Coverage, 3888,
     /*  577971 */     GIR_EraseRootFromParent_Done,
     /*  577972 */   // Label 9451: @577972
     /*  577972 */   GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(578047), // Rule ID 3889 //
     /*  577977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  577988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  577991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  577994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  577997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578023 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11694:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  578023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  578026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578045 */     GIR_RootConstrainSelectedInstOperands,
     /*  578046 */     // GIR_Coverage, 3889,
     /*  578046 */     GIR_EraseRootFromParent_Done,
     /*  578047 */   // Label 9452: @578047
     /*  578047 */   GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(578122), // Rule ID 3892 //
     /*  578052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  578055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  578063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  578066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  578069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  578072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578098 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11694:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  578098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  578101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578120 */     GIR_RootConstrainSelectedInstOperands,
     /*  578121 */     // GIR_Coverage, 3892,
     /*  578121 */     GIR_EraseRootFromParent_Done,
     /*  578122 */   // Label 9453: @578122
     /*  578122 */   GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(578197), // Rule ID 3893 //
     /*  578127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  578130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  578138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  578141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  578144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  578147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578173 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11694:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  578173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  578176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578195 */     GIR_RootConstrainSelectedInstOperands,
     /*  578196 */     // GIR_Coverage, 3893,
     /*  578196 */     GIR_EraseRootFromParent_Done,
     /*  578197 */   // Label 9454: @578197
     /*  578197 */   GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(578272), // Rule ID 3896 //
     /*  578202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  578205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  578213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  578216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  578219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  578222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578248 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11694:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  578248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  578251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578270 */     GIR_RootConstrainSelectedInstOperands,
     /*  578271 */     // GIR_Coverage, 3896,
     /*  578271 */     GIR_EraseRootFromParent_Done,
     /*  578272 */   // Label 9455: @578272
     /*  578272 */   GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(578347), // Rule ID 3897 //
     /*  578277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  578280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  578288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  578291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  578294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  578297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578323 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11694:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  578323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  578326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578345 */     GIR_RootConstrainSelectedInstOperands,
     /*  578346 */     // GIR_Coverage, 3897,
     /*  578346 */     GIR_EraseRootFromParent_Done,
     /*  578347 */   // Label 9456: @578347
     /*  578347 */   GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(578422), // Rule ID 3900 //
     /*  578352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  578363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  578366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  578369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578398 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11694:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  578401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578420 */     GIR_RootConstrainSelectedInstOperands,
     /*  578421 */     // GIR_Coverage, 3900,
     /*  578421 */     GIR_EraseRootFromParent_Done,
     /*  578422 */   // Label 9457: @578422
     /*  578422 */   GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(578497), // Rule ID 3901 //
     /*  578427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  578438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  578441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  578444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578473 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11694:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  578476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578495 */     GIR_RootConstrainSelectedInstOperands,
     /*  578496 */     // GIR_Coverage, 3901,
     /*  578496 */     GIR_EraseRootFromParent_Done,
     /*  578497 */   // Label 9458: @578497
     /*  578497 */   GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(578572), // Rule ID 3904 //
     /*  578502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  578513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  578516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  578519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11694:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578570 */     GIR_RootConstrainSelectedInstOperands,
     /*  578571 */     // GIR_Coverage, 3904,
     /*  578571 */     GIR_EraseRootFromParent_Done,
     /*  578572 */   // Label 9459: @578572
     /*  578572 */   GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(578647), // Rule ID 3905 //
     /*  578577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  578588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  578591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  578594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578623 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11694:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578645 */     GIR_RootConstrainSelectedInstOperands,
     /*  578646 */     // GIR_Coverage, 3905,
     /*  578646 */     GIR_EraseRootFromParent_Done,
     /*  578647 */   // Label 9460: @578647
     /*  578647 */   GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(578722), // Rule ID 3908 //
     /*  578652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  578663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  578666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  578669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578698 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11694:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  578701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578720 */     GIR_RootConstrainSelectedInstOperands,
     /*  578721 */     // GIR_Coverage, 3908,
     /*  578721 */     GIR_EraseRootFromParent_Done,
     /*  578722 */   // Label 9461: @578722
     /*  578722 */   GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(578797), // Rule ID 3909 //
     /*  578727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  578738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  578741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  578744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578773 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11694:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  578776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578795 */     GIR_RootConstrainSelectedInstOperands,
     /*  578796 */     // GIR_Coverage, 3909,
     /*  578796 */     GIR_EraseRootFromParent_Done,
     /*  578797 */   // Label 9462: @578797
     /*  578797 */   GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(578872), // Rule ID 3912 //
     /*  578802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  578813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  578816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  578819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11694:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  578851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578870 */     GIR_RootConstrainSelectedInstOperands,
     /*  578871 */     // GIR_Coverage, 3912,
     /*  578871 */     GIR_EraseRootFromParent_Done,
     /*  578872 */   // Label 9463: @578872
     /*  578872 */   GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(578947), // Rule ID 3913 //
     /*  578877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  578888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  578891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  578894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578923 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11694:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  578926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578945 */     GIR_RootConstrainSelectedInstOperands,
     /*  578946 */     // GIR_Coverage, 3913,
     /*  578946 */     GIR_EraseRootFromParent_Done,
     /*  578947 */   // Label 9464: @578947
     /*  578947 */   GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(579022), // Rule ID 3916 //
     /*  578952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  578963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  578966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  578969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578998 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11694:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579020 */     GIR_RootConstrainSelectedInstOperands,
     /*  579021 */     // GIR_Coverage, 3916,
     /*  579021 */     GIR_EraseRootFromParent_Done,
     /*  579022 */   // Label 9465: @579022
     /*  579022 */   GIM_Try, /*On fail goto*//*Label 9466*/ GIMT_Encode4(579097), // Rule ID 3917 //
     /*  579027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  579038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  579041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  579044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579073 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11694:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579095 */     GIR_RootConstrainSelectedInstOperands,
     /*  579096 */     // GIR_Coverage, 3917,
     /*  579096 */     GIR_EraseRootFromParent_Done,
     /*  579097 */   // Label 9466: @579097
     /*  579097 */   GIM_Try, /*On fail goto*//*Label 9467*/ GIMT_Encode4(579172), // Rule ID 3920 //
     /*  579102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  579113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  579116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  579119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579148 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11694:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579170 */     GIR_RootConstrainSelectedInstOperands,
     /*  579171 */     // GIR_Coverage, 3920,
     /*  579171 */     GIR_EraseRootFromParent_Done,
     /*  579172 */   // Label 9467: @579172
     /*  579172 */   GIM_Try, /*On fail goto*//*Label 9468*/ GIMT_Encode4(579247), // Rule ID 3921 //
     /*  579177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  579188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  579191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  579194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579223 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11694:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579245 */     GIR_RootConstrainSelectedInstOperands,
     /*  579246 */     // GIR_Coverage, 3921,
     /*  579246 */     GIR_EraseRootFromParent_Done,
     /*  579247 */   // Label 9468: @579247
     /*  579247 */   GIM_Try, /*On fail goto*//*Label 9469*/ GIMT_Encode4(579322), // Rule ID 3924 //
     /*  579252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  579263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  579266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  579269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579298 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11694:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  579301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579320 */     GIR_RootConstrainSelectedInstOperands,
     /*  579321 */     // GIR_Coverage, 3924,
     /*  579321 */     GIR_EraseRootFromParent_Done,
     /*  579322 */   // Label 9469: @579322
     /*  579322 */   GIM_Try, /*On fail goto*//*Label 9470*/ GIMT_Encode4(579397), // Rule ID 3925 //
     /*  579327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  579338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  579341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  579344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579373 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11694:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  579376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579395 */     GIR_RootConstrainSelectedInstOperands,
     /*  579396 */     // GIR_Coverage, 3925,
     /*  579396 */     GIR_EraseRootFromParent_Done,
     /*  579397 */   // Label 9470: @579397
     /*  579397 */   GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(579472), // Rule ID 3928 //
     /*  579402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  579413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  579416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  579419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11694:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  579451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579470 */     GIR_RootConstrainSelectedInstOperands,
     /*  579471 */     // GIR_Coverage, 3928,
     /*  579471 */     GIR_EraseRootFromParent_Done,
     /*  579472 */   // Label 9471: @579472
     /*  579472 */   GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(579547), // Rule ID 3929 //
     /*  579477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  579488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  579491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  579494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579523 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11694:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  579526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579545 */     GIR_RootConstrainSelectedInstOperands,
     /*  579546 */     // GIR_Coverage, 3929,
     /*  579546 */     GIR_EraseRootFromParent_Done,
     /*  579547 */   // Label 9472: @579547
     /*  579547 */   GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(579622), // Rule ID 3932 //
     /*  579552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  579563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  579566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  579569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11694:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579620 */     GIR_RootConstrainSelectedInstOperands,
     /*  579621 */     // GIR_Coverage, 3932,
     /*  579621 */     GIR_EraseRootFromParent_Done,
     /*  579622 */   // Label 9473: @579622
     /*  579622 */   GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(579697), // Rule ID 3933 //
     /*  579627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  579638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  579641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  579644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11694:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579695 */     GIR_RootConstrainSelectedInstOperands,
     /*  579696 */     // GIR_Coverage, 3933,
     /*  579696 */     GIR_EraseRootFromParent_Done,
     /*  579697 */   // Label 9474: @579697
     /*  579697 */   GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(579772), // Rule ID 3936 //
     /*  579702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  579713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  579716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  579719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11694:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579770 */     GIR_RootConstrainSelectedInstOperands,
     /*  579771 */     // GIR_Coverage, 3936,
     /*  579771 */     GIR_EraseRootFromParent_Done,
     /*  579772 */   // Label 9475: @579772
     /*  579772 */   GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(579847), // Rule ID 3937 //
     /*  579777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  579788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  579791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  579794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579823 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11694:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579845 */     GIR_RootConstrainSelectedInstOperands,
     /*  579846 */     // GIR_Coverage, 3937,
     /*  579846 */     GIR_EraseRootFromParent_Done,
     /*  579847 */   // Label 9476: @579847
     /*  579847 */   GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(579922), // Rule ID 3940 //
     /*  579852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  579863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  579866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  579869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579898 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11694:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579920 */     GIR_RootConstrainSelectedInstOperands,
     /*  579921 */     // GIR_Coverage, 3940,
     /*  579921 */     GIR_EraseRootFromParent_Done,
     /*  579922 */   // Label 9477: @579922
     /*  579922 */   GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(579997), // Rule ID 3941 //
     /*  579927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  579938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  579941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  579944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579973 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11694:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579995 */     GIR_RootConstrainSelectedInstOperands,
     /*  579996 */     // GIR_Coverage, 3941,
     /*  579996 */     GIR_EraseRootFromParent_Done,
     /*  579997 */   // Label 9478: @579997
     /*  579997 */   GIM_Try, /*On fail goto*//*Label 9479*/ GIMT_Encode4(580072), // Rule ID 3944 //
     /*  580002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  580005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  580013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  580016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  580019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580048 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11694:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  580048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  580051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580070 */     GIR_RootConstrainSelectedInstOperands,
     /*  580071 */     // GIR_Coverage, 3944,
     /*  580071 */     GIR_EraseRootFromParent_Done,
     /*  580072 */   // Label 9479: @580072
     /*  580072 */   GIM_Try, /*On fail goto*//*Label 9480*/ GIMT_Encode4(580147), // Rule ID 3945 //
     /*  580077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  580080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  580088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  580091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  580094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580123 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11694:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  580123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  580126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580145 */     GIR_RootConstrainSelectedInstOperands,
     /*  580146 */     // GIR_Coverage, 3945,
     /*  580146 */     GIR_EraseRootFromParent_Done,
     /*  580147 */   // Label 9480: @580147
     /*  580147 */   GIM_Try, /*On fail goto*//*Label 9481*/ GIMT_Encode4(580222), // Rule ID 3948 //
     /*  580152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  580155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  580163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  580166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  580169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11694:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  580198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  580201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580220 */     GIR_RootConstrainSelectedInstOperands,
     /*  580221 */     // GIR_Coverage, 3948,
     /*  580221 */     GIR_EraseRootFromParent_Done,
     /*  580222 */   // Label 9481: @580222
     /*  580222 */   GIM_Try, /*On fail goto*//*Label 9482*/ GIMT_Encode4(580297), // Rule ID 3949 //
     /*  580227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  580230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  580238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  580241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  580244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580273 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11694:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  580273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  580276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580295 */     GIR_RootConstrainSelectedInstOperands,
     /*  580296 */     // GIR_Coverage, 3949,
     /*  580296 */     GIR_EraseRootFromParent_Done,
     /*  580297 */   // Label 9482: @580297
     /*  580297 */   GIM_Try, /*On fail goto*//*Label 9483*/ GIMT_Encode4(580372), // Rule ID 3952 //
     /*  580302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  580305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  580313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  580316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  580319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580348 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11694:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  580348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  580351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580370 */     GIR_RootConstrainSelectedInstOperands,
     /*  580371 */     // GIR_Coverage, 3952,
     /*  580371 */     GIR_EraseRootFromParent_Done,
     /*  580372 */   // Label 9483: @580372
     /*  580372 */   GIM_Try, /*On fail goto*//*Label 9484*/ GIMT_Encode4(580447), // Rule ID 3953 //
     /*  580377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  580380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  580388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  580391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  580394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580423 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11694:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  580423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  580426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580445 */     GIR_RootConstrainSelectedInstOperands,
     /*  580446 */     // GIR_Coverage, 3953,
     /*  580446 */     GIR_EraseRootFromParent_Done,
     /*  580447 */   // Label 9484: @580447
     /*  580447 */   GIM_Try, /*On fail goto*//*Label 9485*/ GIMT_Encode4(580522), // Rule ID 3956 //
     /*  580452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  580455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  580463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  580466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  580469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580498 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11694:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  580498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  580501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580520 */     GIR_RootConstrainSelectedInstOperands,
     /*  580521 */     // GIR_Coverage, 3956,
     /*  580521 */     GIR_EraseRootFromParent_Done,
     /*  580522 */   // Label 9485: @580522
     /*  580522 */   GIM_Try, /*On fail goto*//*Label 9486*/ GIMT_Encode4(580597), // Rule ID 3957 //
     /*  580527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  580530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  580538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  580541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  580544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580573 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11694:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  580573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  580576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580595 */     GIR_RootConstrainSelectedInstOperands,
     /*  580596 */     // GIR_Coverage, 3957,
     /*  580596 */     GIR_EraseRootFromParent_Done,
     /*  580597 */   // Label 9486: @580597
     /*  580597 */   GIM_Try, /*On fail goto*//*Label 9487*/ GIMT_Encode4(580672), // Rule ID 3960 //
     /*  580602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  580613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  580616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  580619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  580622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  580651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580670 */     GIR_RootConstrainSelectedInstOperands,
     /*  580671 */     // GIR_Coverage, 3960,
     /*  580671 */     GIR_EraseRootFromParent_Done,
     /*  580672 */   // Label 9487: @580672
     /*  580672 */   GIM_Try, /*On fail goto*//*Label 9488*/ GIMT_Encode4(580747), // Rule ID 3961 //
     /*  580677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  580688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  580691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  580694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  580697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580723 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  580726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580745 */     GIR_RootConstrainSelectedInstOperands,
     /*  580746 */     // GIR_Coverage, 3961,
     /*  580746 */     GIR_EraseRootFromParent_Done,
     /*  580747 */   // Label 9488: @580747
     /*  580747 */   GIM_Try, /*On fail goto*//*Label 9489*/ GIMT_Encode4(580822), // Rule ID 3964 //
     /*  580752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  580763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  580766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  580769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  580772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580798 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  580801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580820 */     GIR_RootConstrainSelectedInstOperands,
     /*  580821 */     // GIR_Coverage, 3964,
     /*  580821 */     GIR_EraseRootFromParent_Done,
     /*  580822 */   // Label 9489: @580822
     /*  580822 */   GIM_Try, /*On fail goto*//*Label 9490*/ GIMT_Encode4(580897), // Rule ID 3965 //
     /*  580827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  580838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  580841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  580844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  580847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580873 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  580876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580895 */     GIR_RootConstrainSelectedInstOperands,
     /*  580896 */     // GIR_Coverage, 3965,
     /*  580896 */     GIR_EraseRootFromParent_Done,
     /*  580897 */   // Label 9490: @580897
     /*  580897 */   GIM_Try, /*On fail goto*//*Label 9491*/ GIMT_Encode4(580972), // Rule ID 3968 //
     /*  580902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  580913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  580916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  580919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  580922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580948 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  580951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580970 */     GIR_RootConstrainSelectedInstOperands,
     /*  580971 */     // GIR_Coverage, 3968,
     /*  580971 */     GIR_EraseRootFromParent_Done,
     /*  580972 */   // Label 9491: @580972
     /*  580972 */   GIM_Try, /*On fail goto*//*Label 9492*/ GIMT_Encode4(581047), // Rule ID 3969 //
     /*  580977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  580988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  580991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  580994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  580997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581023 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581045 */     GIR_RootConstrainSelectedInstOperands,
     /*  581046 */     // GIR_Coverage, 3969,
     /*  581046 */     GIR_EraseRootFromParent_Done,
     /*  581047 */   // Label 9492: @581047
     /*  581047 */   GIM_Try, /*On fail goto*//*Label 9493*/ GIMT_Encode4(581122), // Rule ID 3972 //
     /*  581052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  581063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  581066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  581069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  581072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  581098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581120 */     GIR_RootConstrainSelectedInstOperands,
     /*  581121 */     // GIR_Coverage, 3972,
     /*  581121 */     GIR_EraseRootFromParent_Done,
     /*  581122 */   // Label 9493: @581122
     /*  581122 */   GIM_Try, /*On fail goto*//*Label 9494*/ GIMT_Encode4(581197), // Rule ID 3973 //
     /*  581127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  581138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  581141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  581144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  581147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581173 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581195 */     GIR_RootConstrainSelectedInstOperands,
     /*  581196 */     // GIR_Coverage, 3973,
     /*  581196 */     GIR_EraseRootFromParent_Done,
     /*  581197 */   // Label 9494: @581197
     /*  581197 */   GIM_Try, /*On fail goto*//*Label 9495*/ GIMT_Encode4(581272), // Rule ID 3976 //
     /*  581202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  581213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  581216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  581219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  581222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581248 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  581248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581270 */     GIR_RootConstrainSelectedInstOperands,
     /*  581271 */     // GIR_Coverage, 3976,
     /*  581271 */     GIR_EraseRootFromParent_Done,
     /*  581272 */   // Label 9495: @581272
     /*  581272 */   GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(581347), // Rule ID 3977 //
     /*  581277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  581288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  581291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  581294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  581297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581323 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581345 */     GIR_RootConstrainSelectedInstOperands,
     /*  581346 */     // GIR_Coverage, 3977,
     /*  581346 */     GIR_EraseRootFromParent_Done,
     /*  581347 */   // Label 9496: @581347
     /*  581347 */   GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(581422), // Rule ID 3980 //
     /*  581352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  581363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  581366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  581369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  581372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581398 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  581398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581420 */     GIR_RootConstrainSelectedInstOperands,
     /*  581421 */     // GIR_Coverage, 3980,
     /*  581421 */     GIR_EraseRootFromParent_Done,
     /*  581422 */   // Label 9497: @581422
     /*  581422 */   GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(581497), // Rule ID 3981 //
     /*  581427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  581438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  581441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  581444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  581447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581473 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581495 */     GIR_RootConstrainSelectedInstOperands,
     /*  581496 */     // GIR_Coverage, 3981,
     /*  581496 */     GIR_EraseRootFromParent_Done,
     /*  581497 */   // Label 9498: @581497
     /*  581497 */   GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(581572), // Rule ID 3984 //
     /*  581502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  581513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  581516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  581519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  581522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581548 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  581551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581570 */     GIR_RootConstrainSelectedInstOperands,
     /*  581571 */     // GIR_Coverage, 3984,
     /*  581571 */     GIR_EraseRootFromParent_Done,
     /*  581572 */   // Label 9499: @581572
     /*  581572 */   GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(581647), // Rule ID 3985 //
     /*  581577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  581588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  581591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  581594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  581597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581623 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  581626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581645 */     GIR_RootConstrainSelectedInstOperands,
     /*  581646 */     // GIR_Coverage, 3985,
     /*  581646 */     GIR_EraseRootFromParent_Done,
     /*  581647 */   // Label 9500: @581647
     /*  581647 */   GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(581722), // Rule ID 3988 //
     /*  581652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  581663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  581666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  581669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  581672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581698 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581720 */     GIR_RootConstrainSelectedInstOperands,
     /*  581721 */     // GIR_Coverage, 3988,
     /*  581721 */     GIR_EraseRootFromParent_Done,
     /*  581722 */   // Label 9501: @581722
     /*  581722 */   GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(581797), // Rule ID 3989 //
     /*  581727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  581738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  581741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  581744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  581747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581773 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581795 */     GIR_RootConstrainSelectedInstOperands,
     /*  581796 */     // GIR_Coverage, 3989,
     /*  581796 */     GIR_EraseRootFromParent_Done,
     /*  581797 */   // Label 9502: @581797
     /*  581797 */   GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(581872), // Rule ID 3992 //
     /*  581802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  581813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  581816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  581819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  581822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581870 */     GIR_RootConstrainSelectedInstOperands,
     /*  581871 */     // GIR_Coverage, 3992,
     /*  581871 */     GIR_EraseRootFromParent_Done,
     /*  581872 */   // Label 9503: @581872
     /*  581872 */   GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(581947), // Rule ID 3993 //
     /*  581877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  581888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  581891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  581894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  581897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581923 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581945 */     GIR_RootConstrainSelectedInstOperands,
     /*  581946 */     // GIR_Coverage, 3993,
     /*  581946 */     GIR_EraseRootFromParent_Done,
     /*  581947 */   // Label 9504: @581947
     /*  581947 */   GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(582022), // Rule ID 3996 //
     /*  581952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  581963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  581966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  581969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  581972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581998 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  582001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582020 */     GIR_RootConstrainSelectedInstOperands,
     /*  582021 */     // GIR_Coverage, 3996,
     /*  582021 */     GIR_EraseRootFromParent_Done,
     /*  582022 */   // Label 9505: @582022
     /*  582022 */   GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(582097), // Rule ID 3997 //
     /*  582027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  582038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  582041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  582044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  582047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582073 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  582073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  582076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582095 */     GIR_RootConstrainSelectedInstOperands,
     /*  582096 */     // GIR_Coverage, 3997,
     /*  582096 */     GIR_EraseRootFromParent_Done,
     /*  582097 */   // Label 9506: @582097
     /*  582097 */   GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(582172), // Rule ID 4000 //
     /*  582102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  582113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  582116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  582119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  582122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582148 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  582148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  582151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582170 */     GIR_RootConstrainSelectedInstOperands,
     /*  582171 */     // GIR_Coverage, 4000,
     /*  582171 */     GIR_EraseRootFromParent_Done,
     /*  582172 */   // Label 9507: @582172
     /*  582172 */   GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(582247), // Rule ID 4001 //
     /*  582177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  582188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  582191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  582194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  582197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582223 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  582223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  582226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582245 */     GIR_RootConstrainSelectedInstOperands,
     /*  582246 */     // GIR_Coverage, 4001,
     /*  582246 */     GIR_EraseRootFromParent_Done,
     /*  582247 */   // Label 9508: @582247
     /*  582247 */   GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(582322), // Rule ID 4004 //
     /*  582252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  582255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  582263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  582266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  582269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  582272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582298 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  582298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  582301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582320 */     GIR_RootConstrainSelectedInstOperands,
     /*  582321 */     // GIR_Coverage, 4004,
     /*  582321 */     GIR_EraseRootFromParent_Done,
     /*  582322 */   // Label 9509: @582322
     /*  582322 */   GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(582397), // Rule ID 4005 //
     /*  582327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  582338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  582341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  582344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  582347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582373 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  582376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582395 */     GIR_RootConstrainSelectedInstOperands,
     /*  582396 */     // GIR_Coverage, 4005,
     /*  582396 */     GIR_EraseRootFromParent_Done,
     /*  582397 */   // Label 9510: @582397
     /*  582397 */   GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(582472), // Rule ID 4008 //
     /*  582402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  582405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  582413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  582416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  582419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  582422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582448 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  582448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  582451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582470 */     GIR_RootConstrainSelectedInstOperands,
     /*  582471 */     // GIR_Coverage, 4008,
     /*  582471 */     GIR_EraseRootFromParent_Done,
     /*  582472 */   // Label 9511: @582472
     /*  582472 */   GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(582547), // Rule ID 4009 //
     /*  582477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  582488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  582491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  582494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  582497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582523 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  582526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582545 */     GIR_RootConstrainSelectedInstOperands,
     /*  582546 */     // GIR_Coverage, 4009,
     /*  582546 */     GIR_EraseRootFromParent_Done,
     /*  582547 */   // Label 9512: @582547
     /*  582547 */   GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(582622), // Rule ID 4012 //
     /*  582552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  582555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  582563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  582566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  582569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  582572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582598 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  582598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  582601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582620 */     GIR_RootConstrainSelectedInstOperands,
     /*  582621 */     // GIR_Coverage, 4012,
     /*  582621 */     GIR_EraseRootFromParent_Done,
     /*  582622 */   // Label 9513: @582622
     /*  582622 */   GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(582697), // Rule ID 4013 //
     /*  582627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  582638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  582641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  582644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  582647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582673 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  582676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582695 */     GIR_RootConstrainSelectedInstOperands,
     /*  582696 */     // GIR_Coverage, 4013,
     /*  582696 */     GIR_EraseRootFromParent_Done,
     /*  582697 */   // Label 9514: @582697
     /*  582697 */   GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(582772), // Rule ID 4016 //
     /*  582702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  582705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  582713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  582716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  582719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  582722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582748 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  582748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  582751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582770 */     GIR_RootConstrainSelectedInstOperands,
     /*  582771 */     // GIR_Coverage, 4016,
     /*  582771 */     GIR_EraseRootFromParent_Done,
     /*  582772 */   // Label 9515: @582772
     /*  582772 */   GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(582847), // Rule ID 4017 //
     /*  582777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  582788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  582791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  582794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  582797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582823 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  582826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582845 */     GIR_RootConstrainSelectedInstOperands,
     /*  582846 */     // GIR_Coverage, 4017,
     /*  582846 */     GIR_EraseRootFromParent_Done,
     /*  582847 */   // Label 9516: @582847
     /*  582847 */   GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(582922), // Rule ID 4020 //
     /*  582852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  582863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  582866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  582869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582898 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  582901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582920 */     GIR_RootConstrainSelectedInstOperands,
     /*  582921 */     // GIR_Coverage, 4020,
     /*  582921 */     GIR_EraseRootFromParent_Done,
     /*  582922 */   // Label 9517: @582922
     /*  582922 */   GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(582997), // Rule ID 4021 //
     /*  582927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  582938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  582941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  582944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582973 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  582976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582995 */     GIR_RootConstrainSelectedInstOperands,
     /*  582996 */     // GIR_Coverage, 4021,
     /*  582996 */     GIR_EraseRootFromParent_Done,
     /*  582997 */   // Label 9518: @582997
     /*  582997 */   GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(583072), // Rule ID 4024 //
     /*  583002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  583013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  583016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  583019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583048 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  583051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583070 */     GIR_RootConstrainSelectedInstOperands,
     /*  583071 */     // GIR_Coverage, 4024,
     /*  583071 */     GIR_EraseRootFromParent_Done,
     /*  583072 */   // Label 9519: @583072
     /*  583072 */   GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(583147), // Rule ID 4025 //
     /*  583077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  583088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  583091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  583094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583123 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  583126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583145 */     GIR_RootConstrainSelectedInstOperands,
     /*  583146 */     // GIR_Coverage, 4025,
     /*  583146 */     GIR_EraseRootFromParent_Done,
     /*  583147 */   // Label 9520: @583147
     /*  583147 */   GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(583222), // Rule ID 4028 //
     /*  583152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  583163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  583166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  583169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583198 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583220 */     GIR_RootConstrainSelectedInstOperands,
     /*  583221 */     // GIR_Coverage, 4028,
     /*  583221 */     GIR_EraseRootFromParent_Done,
     /*  583222 */   // Label 9521: @583222
     /*  583222 */   GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(583297), // Rule ID 4029 //
     /*  583227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  583238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  583241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  583244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583273 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583295 */     GIR_RootConstrainSelectedInstOperands,
     /*  583296 */     // GIR_Coverage, 4029,
     /*  583296 */     GIR_EraseRootFromParent_Done,
     /*  583297 */   // Label 9522: @583297
     /*  583297 */   GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(583372), // Rule ID 4032 //
     /*  583302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  583313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  583316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  583319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  583351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583370 */     GIR_RootConstrainSelectedInstOperands,
     /*  583371 */     // GIR_Coverage, 4032,
     /*  583371 */     GIR_EraseRootFromParent_Done,
     /*  583372 */   // Label 9523: @583372
     /*  583372 */   GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(583447), // Rule ID 4033 //
     /*  583377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  583388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  583391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  583394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583423 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  583426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583445 */     GIR_RootConstrainSelectedInstOperands,
     /*  583446 */     // GIR_Coverage, 4033,
     /*  583446 */     GIR_EraseRootFromParent_Done,
     /*  583447 */   // Label 9524: @583447
     /*  583447 */   GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(583522), // Rule ID 4036 //
     /*  583452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  583463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  583466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  583469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583498 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583520 */     GIR_RootConstrainSelectedInstOperands,
     /*  583521 */     // GIR_Coverage, 4036,
     /*  583521 */     GIR_EraseRootFromParent_Done,
     /*  583522 */   // Label 9525: @583522
     /*  583522 */   GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(583597), // Rule ID 4037 //
     /*  583527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  583538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  583541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  583544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583573 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583595 */     GIR_RootConstrainSelectedInstOperands,
     /*  583596 */     // GIR_Coverage, 4037,
     /*  583596 */     GIR_EraseRootFromParent_Done,
     /*  583597 */   // Label 9526: @583597
     /*  583597 */   GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(583672), // Rule ID 4040 //
     /*  583602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  583613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  583616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  583619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583648 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  583651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583670 */     GIR_RootConstrainSelectedInstOperands,
     /*  583671 */     // GIR_Coverage, 4040,
     /*  583671 */     GIR_EraseRootFromParent_Done,
     /*  583672 */   // Label 9527: @583672
     /*  583672 */   GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(583747), // Rule ID 4041 //
     /*  583677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  583688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  583691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  583694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583723 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  583726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583745 */     GIR_RootConstrainSelectedInstOperands,
     /*  583746 */     // GIR_Coverage, 4041,
     /*  583746 */     GIR_EraseRootFromParent_Done,
     /*  583747 */   // Label 9528: @583747
     /*  583747 */   GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(583822), // Rule ID 4044 //
     /*  583752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  583763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  583766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  583769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583798 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  583801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583820 */     GIR_RootConstrainSelectedInstOperands,
     /*  583821 */     // GIR_Coverage, 4044,
     /*  583821 */     GIR_EraseRootFromParent_Done,
     /*  583822 */   // Label 9529: @583822
     /*  583822 */   GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(583897), // Rule ID 4045 //
     /*  583827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  583838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  583841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  583844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583873 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  583876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583895 */     GIR_RootConstrainSelectedInstOperands,
     /*  583896 */     // GIR_Coverage, 4045,
     /*  583896 */     GIR_EraseRootFromParent_Done,
     /*  583897 */   // Label 9530: @583897
     /*  583897 */   GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(583972), // Rule ID 4048 //
     /*  583902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  583913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  583916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  583919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583970 */     GIR_RootConstrainSelectedInstOperands,
     /*  583971 */     // GIR_Coverage, 4048,
     /*  583971 */     GIR_EraseRootFromParent_Done,
     /*  583972 */   // Label 9531: @583972
     /*  583972 */   GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(584047), // Rule ID 4049 //
     /*  583977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  583988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  583991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  583994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584023 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  584026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584045 */     GIR_RootConstrainSelectedInstOperands,
     /*  584046 */     // GIR_Coverage, 4049,
     /*  584046 */     GIR_EraseRootFromParent_Done,
     /*  584047 */   // Label 9532: @584047
     /*  584047 */   GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(584122), // Rule ID 4052 //
     /*  584052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  584063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  584066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  584069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584098 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  584098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  584101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584120 */     GIR_RootConstrainSelectedInstOperands,
     /*  584121 */     // GIR_Coverage, 4052,
     /*  584121 */     GIR_EraseRootFromParent_Done,
     /*  584122 */   // Label 9533: @584122
     /*  584122 */   GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(584197), // Rule ID 4053 //
     /*  584127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  584138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  584141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  584144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584173 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  584176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584195 */     GIR_RootConstrainSelectedInstOperands,
     /*  584196 */     // GIR_Coverage, 4053,
     /*  584196 */     GIR_EraseRootFromParent_Done,
     /*  584197 */   // Label 9534: @584197
     /*  584197 */   GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(584272), // Rule ID 4056 //
     /*  584202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  584213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  584216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  584219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  584248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  584251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584270 */     GIR_RootConstrainSelectedInstOperands,
     /*  584271 */     // GIR_Coverage, 4056,
     /*  584271 */     GIR_EraseRootFromParent_Done,
     /*  584272 */   // Label 9535: @584272
     /*  584272 */   GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(584347), // Rule ID 4057 //
     /*  584277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  584288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  584291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  584294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584323 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  584326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584345 */     GIR_RootConstrainSelectedInstOperands,
     /*  584346 */     // GIR_Coverage, 4057,
     /*  584346 */     GIR_EraseRootFromParent_Done,
     /*  584347 */   // Label 9536: @584347
     /*  584347 */   GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(584422), // Rule ID 4060 //
     /*  584352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  584363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  584366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  584369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  584398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584420 */     GIR_RootConstrainSelectedInstOperands,
     /*  584421 */     // GIR_Coverage, 4060,
     /*  584421 */     GIR_EraseRootFromParent_Done,
     /*  584422 */   // Label 9537: @584422
     /*  584422 */   GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(584497), // Rule ID 4061 //
     /*  584427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  584438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  584441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  584444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584473 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584495 */     GIR_RootConstrainSelectedInstOperands,
     /*  584496 */     // GIR_Coverage, 4061,
     /*  584496 */     GIR_EraseRootFromParent_Done,
     /*  584497 */   // Label 9538: @584497
     /*  584497 */   GIM_Try, /*On fail goto*//*Label 9539*/ GIMT_Encode4(584572), // Rule ID 4064 //
     /*  584502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  584513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  584516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  584519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584548 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  584551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584570 */     GIR_RootConstrainSelectedInstOperands,
     /*  584571 */     // GIR_Coverage, 4064,
     /*  584571 */     GIR_EraseRootFromParent_Done,
     /*  584572 */   // Label 9539: @584572
     /*  584572 */   GIM_Try, /*On fail goto*//*Label 9540*/ GIMT_Encode4(584647), // Rule ID 4065 //
     /*  584577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  584588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  584591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  584594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584623 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  584626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584645 */     GIR_RootConstrainSelectedInstOperands,
     /*  584646 */     // GIR_Coverage, 4065,
     /*  584646 */     GIR_EraseRootFromParent_Done,
     /*  584647 */   // Label 9540: @584647
     /*  584647 */   GIM_Try, /*On fail goto*//*Label 9541*/ GIMT_Encode4(584722), // Rule ID 4068 //
     /*  584652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  584663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  584666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  584669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  584701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584720 */     GIR_RootConstrainSelectedInstOperands,
     /*  584721 */     // GIR_Coverage, 4068,
     /*  584721 */     GIR_EraseRootFromParent_Done,
     /*  584722 */   // Label 9541: @584722
     /*  584722 */   GIM_Try, /*On fail goto*//*Label 9542*/ GIMT_Encode4(584797), // Rule ID 4069 //
     /*  584727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  584738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  584741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  584744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584773 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  584776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584795 */     GIR_RootConstrainSelectedInstOperands,
     /*  584796 */     // GIR_Coverage, 4069,
     /*  584796 */     GIR_EraseRootFromParent_Done,
     /*  584797 */   // Label 9542: @584797
     /*  584797 */   GIM_Try, /*On fail goto*//*Label 9543*/ GIMT_Encode4(584872), // Rule ID 4072 //
     /*  584802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  584813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  584816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  584819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584848 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  584851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584870 */     GIR_RootConstrainSelectedInstOperands,
     /*  584871 */     // GIR_Coverage, 4072,
     /*  584871 */     GIR_EraseRootFromParent_Done,
     /*  584872 */   // Label 9543: @584872
     /*  584872 */   GIM_Try, /*On fail goto*//*Label 9544*/ GIMT_Encode4(584947), // Rule ID 4073 //
     /*  584877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  584888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  584891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  584894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584923 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  584926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584945 */     GIR_RootConstrainSelectedInstOperands,
     /*  584946 */     // GIR_Coverage, 4073,
     /*  584946 */     GIR_EraseRootFromParent_Done,
     /*  584947 */   // Label 9544: @584947
     /*  584947 */   GIM_Try, /*On fail goto*//*Label 9545*/ GIMT_Encode4(585022), // Rule ID 4076 //
     /*  584952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  584963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  584966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  584969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584998 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  585001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585020 */     GIR_RootConstrainSelectedInstOperands,
     /*  585021 */     // GIR_Coverage, 4076,
     /*  585021 */     GIR_EraseRootFromParent_Done,
     /*  585022 */   // Label 9545: @585022
     /*  585022 */   GIM_Try, /*On fail goto*//*Label 9546*/ GIMT_Encode4(585097), // Rule ID 4077 //
     /*  585027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  585030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  585038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  585041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  585044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  585047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  585066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585073 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  585073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  585076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585095 */     GIR_RootConstrainSelectedInstOperands,
     /*  585096 */     // GIR_Coverage, 4077,
     /*  585096 */     GIR_EraseRootFromParent_Done,
     /*  585097 */   // Label 9546: @585097
     /*  585097 */   GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(585172), // Rule ID 4082 //
     /*  585102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  585113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  585116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  585119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  585122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  585151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585170 */     GIR_RootConstrainSelectedInstOperands,
     /*  585171 */     // GIR_Coverage, 4082,
     /*  585171 */     GIR_EraseRootFromParent_Done,
     /*  585172 */   // Label 9547: @585172
     /*  585172 */   GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(585247), // Rule ID 4083 //
     /*  585177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  585188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  585191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  585194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  585197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585223 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  585226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585245 */     GIR_RootConstrainSelectedInstOperands,
     /*  585246 */     // GIR_Coverage, 4083,
     /*  585246 */     GIR_EraseRootFromParent_Done,
     /*  585247 */   // Label 9548: @585247
     /*  585247 */   GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(585322), // Rule ID 4092 //
     /*  585252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  585263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  585266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  585269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  585272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585298 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  585301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585320 */     GIR_RootConstrainSelectedInstOperands,
     /*  585321 */     // GIR_Coverage, 4092,
     /*  585321 */     GIR_EraseRootFromParent_Done,
     /*  585322 */   // Label 9549: @585322
     /*  585322 */   GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(585397), // Rule ID 4093 //
     /*  585327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  585338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  585341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  585344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  585347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585373 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  585376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585395 */     GIR_RootConstrainSelectedInstOperands,
     /*  585396 */     // GIR_Coverage, 4093,
     /*  585396 */     GIR_EraseRootFromParent_Done,
     /*  585397 */   // Label 9550: @585397
     /*  585397 */   GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(585472), // Rule ID 4102 //
     /*  585402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  585413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  585416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  585419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  585422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585470 */     GIR_RootConstrainSelectedInstOperands,
     /*  585471 */     // GIR_Coverage, 4102,
     /*  585471 */     GIR_EraseRootFromParent_Done,
     /*  585472 */   // Label 9551: @585472
     /*  585472 */   GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(585547), // Rule ID 4103 //
     /*  585477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  585488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  585491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  585494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  585497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585523 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585545 */     GIR_RootConstrainSelectedInstOperands,
     /*  585546 */     // GIR_Coverage, 4103,
     /*  585546 */     GIR_EraseRootFromParent_Done,
     /*  585547 */   // Label 9552: @585547
     /*  585547 */   GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(585622), // Rule ID 4112 //
     /*  585552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  585563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  585566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  585569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  585572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585598 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585620 */     GIR_RootConstrainSelectedInstOperands,
     /*  585621 */     // GIR_Coverage, 4112,
     /*  585621 */     GIR_EraseRootFromParent_Done,
     /*  585622 */   // Label 9553: @585622
     /*  585622 */   GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(585697), // Rule ID 4113 //
     /*  585627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  585638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  585641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  585644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  585647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585673 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585695 */     GIR_RootConstrainSelectedInstOperands,
     /*  585696 */     // GIR_Coverage, 4113,
     /*  585696 */     GIR_EraseRootFromParent_Done,
     /*  585697 */   // Label 9554: @585697
     /*  585697 */   GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(585772), // Rule ID 4122 //
     /*  585702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  585713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  585716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  585719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  585722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585748 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  585751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585770 */     GIR_RootConstrainSelectedInstOperands,
     /*  585771 */     // GIR_Coverage, 4122,
     /*  585771 */     GIR_EraseRootFromParent_Done,
     /*  585772 */   // Label 9555: @585772
     /*  585772 */   GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(585847), // Rule ID 4123 //
     /*  585777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  585788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  585791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  585794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  585797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585823 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  585826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585845 */     GIR_RootConstrainSelectedInstOperands,
     /*  585846 */     // GIR_Coverage, 4123,
     /*  585846 */     GIR_EraseRootFromParent_Done,
     /*  585847 */   // Label 9556: @585847
     /*  585847 */   GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(585922), // Rule ID 4132 //
     /*  585852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  585863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  585866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  585869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  585872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585898 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  585901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585920 */     GIR_RootConstrainSelectedInstOperands,
     /*  585921 */     // GIR_Coverage, 4132,
     /*  585921 */     GIR_EraseRootFromParent_Done,
     /*  585922 */   // Label 9557: @585922
     /*  585922 */   GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(585997), // Rule ID 4133 //
     /*  585927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  585938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  585941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  585944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  585947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585973 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  585976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585995 */     GIR_RootConstrainSelectedInstOperands,
     /*  585996 */     // GIR_Coverage, 4133,
     /*  585996 */     GIR_EraseRootFromParent_Done,
     /*  585997 */   // Label 9558: @585997
     /*  585997 */   GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(586072), // Rule ID 4142 //
     /*  586002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  586013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  586016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  586019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  586022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  586051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586070 */     GIR_RootConstrainSelectedInstOperands,
     /*  586071 */     // GIR_Coverage, 4142,
     /*  586071 */     GIR_EraseRootFromParent_Done,
     /*  586072 */   // Label 9559: @586072
     /*  586072 */   GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(586147), // Rule ID 4143 //
     /*  586077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  586088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  586091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  586094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  586097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586123 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  586126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586145 */     GIR_RootConstrainSelectedInstOperands,
     /*  586146 */     // GIR_Coverage, 4143,
     /*  586146 */     GIR_EraseRootFromParent_Done,
     /*  586147 */   // Label 9560: @586147
     /*  586147 */   GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(586222), // Rule ID 4152 //
     /*  586152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  586163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  586166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  586169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  586172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586198 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  586201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586220 */     GIR_RootConstrainSelectedInstOperands,
     /*  586221 */     // GIR_Coverage, 4152,
     /*  586221 */     GIR_EraseRootFromParent_Done,
     /*  586222 */   // Label 9561: @586222
     /*  586222 */   GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(586297), // Rule ID 4153 //
     /*  586227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  586238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  586241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  586244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  586247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586273 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  586276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586295 */     GIR_RootConstrainSelectedInstOperands,
     /*  586296 */     // GIR_Coverage, 4153,
     /*  586296 */     GIR_EraseRootFromParent_Done,
     /*  586297 */   // Label 9562: @586297
     /*  586297 */   GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(586372), // Rule ID 4162 //
     /*  586302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  586313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  586316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  586319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  586322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586348 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  586351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586370 */     GIR_RootConstrainSelectedInstOperands,
     /*  586371 */     // GIR_Coverage, 4162,
     /*  586371 */     GIR_EraseRootFromParent_Done,
     /*  586372 */   // Label 9563: @586372
     /*  586372 */   GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(586447), // Rule ID 4163 //
     /*  586377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  586388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  586391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  586394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  586397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586423 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  586426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586445 */     GIR_RootConstrainSelectedInstOperands,
     /*  586446 */     // GIR_Coverage, 4163,
     /*  586446 */     GIR_EraseRootFromParent_Done,
     /*  586447 */   // Label 9564: @586447
     /*  586447 */   GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(586522), // Rule ID 4172 //
     /*  586452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  586463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  586466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  586469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  586472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586520 */     GIR_RootConstrainSelectedInstOperands,
     /*  586521 */     // GIR_Coverage, 4172,
     /*  586521 */     GIR_EraseRootFromParent_Done,
     /*  586522 */   // Label 9565: @586522
     /*  586522 */   GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(586597), // Rule ID 4173 //
     /*  586527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  586538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  586541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  586544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  586547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586573 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586595 */     GIR_RootConstrainSelectedInstOperands,
     /*  586596 */     // GIR_Coverage, 4173,
     /*  586596 */     GIR_EraseRootFromParent_Done,
     /*  586597 */   // Label 9566: @586597
     /*  586597 */   GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(586672), // Rule ID 4182 //
     /*  586602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  586613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  586616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  586619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  586622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586648 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  586651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586670 */     GIR_RootConstrainSelectedInstOperands,
     /*  586671 */     // GIR_Coverage, 4182,
     /*  586671 */     GIR_EraseRootFromParent_Done,
     /*  586672 */   // Label 9567: @586672
     /*  586672 */   GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(586747), // Rule ID 4183 //
     /*  586677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  586688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  586691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  586694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  586697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586723 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  586726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586745 */     GIR_RootConstrainSelectedInstOperands,
     /*  586746 */     // GIR_Coverage, 4183,
     /*  586746 */     GIR_EraseRootFromParent_Done,
     /*  586747 */   // Label 9568: @586747
     /*  586747 */   GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(586822), // Rule ID 4192 //
     /*  586752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  586763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  586766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  586769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  586772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  586801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586820 */     GIR_RootConstrainSelectedInstOperands,
     /*  586821 */     // GIR_Coverage, 4192,
     /*  586821 */     GIR_EraseRootFromParent_Done,
     /*  586822 */   // Label 9569: @586822
     /*  586822 */   GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(586897), // Rule ID 4193 //
     /*  586827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  586838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  586841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  586844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  586847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586873 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  586876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586895 */     GIR_RootConstrainSelectedInstOperands,
     /*  586896 */     // GIR_Coverage, 4193,
     /*  586896 */     GIR_EraseRootFromParent_Done,
     /*  586897 */   // Label 9570: @586897
     /*  586897 */   GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(586972), // Rule ID 4202 //
     /*  586902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  586913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  586916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  586919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  586922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586948 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  586951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586970 */     GIR_RootConstrainSelectedInstOperands,
     /*  586971 */     // GIR_Coverage, 4202,
     /*  586971 */     GIR_EraseRootFromParent_Done,
     /*  586972 */   // Label 9571: @586972
     /*  586972 */   GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(587047), // Rule ID 4203 //
     /*  586977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  586988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  586991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  586994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  586997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587023 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  587023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  587026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  587042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587045 */     GIR_RootConstrainSelectedInstOperands,
     /*  587046 */     // GIR_Coverage, 4203,
     /*  587046 */     GIR_EraseRootFromParent_Done,
     /*  587047 */   // Label 9572: @587047
     /*  587047 */   GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(587122), // Rule ID 4212 //
     /*  587052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  587055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  587063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  587066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  587069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  587072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587098 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  587098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  587101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  587117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587120 */     GIR_RootConstrainSelectedInstOperands,
     /*  587121 */     // GIR_Coverage, 4212,
     /*  587121 */     GIR_EraseRootFromParent_Done,
     /*  587122 */   // Label 9573: @587122
     /*  587122 */   GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(587197), // Rule ID 4213 //
     /*  587127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  587130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  587138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  587141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  587144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  587147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587173 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  587173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  587176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  587192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587195 */     GIR_RootConstrainSelectedInstOperands,
     /*  587196 */     // GIR_Coverage, 4213,
     /*  587196 */     GIR_EraseRootFromParent_Done,
     /*  587197 */   // Label 9574: @587197
     /*  587197 */   GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(587272), // Rule ID 4220 //
     /*  587202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  587213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  587216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  587219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587248 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  587251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587270 */     GIR_RootConstrainSelectedInstOperands,
     /*  587271 */     // GIR_Coverage, 4220,
     /*  587271 */     GIR_EraseRootFromParent_Done,
     /*  587272 */   // Label 9575: @587272
     /*  587272 */   GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(587347), // Rule ID 4221 //
     /*  587277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  587288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  587291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  587294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587323 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  587326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587345 */     GIR_RootConstrainSelectedInstOperands,
     /*  587346 */     // GIR_Coverage, 4221,
     /*  587346 */     GIR_EraseRootFromParent_Done,
     /*  587347 */   // Label 9576: @587347
     /*  587347 */   GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(587422), // Rule ID 4224 //
     /*  587352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  587363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  587366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  587369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587398 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  587401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587420 */     GIR_RootConstrainSelectedInstOperands,
     /*  587421 */     // GIR_Coverage, 4224,
     /*  587421 */     GIR_EraseRootFromParent_Done,
     /*  587422 */   // Label 9577: @587422
     /*  587422 */   GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(587497), // Rule ID 4225 //
     /*  587427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  587438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  587441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  587444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587473 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  587476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587495 */     GIR_RootConstrainSelectedInstOperands,
     /*  587496 */     // GIR_Coverage, 4225,
     /*  587496 */     GIR_EraseRootFromParent_Done,
     /*  587497 */   // Label 9578: @587497
     /*  587497 */   GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(587572), // Rule ID 4228 //
     /*  587502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  587513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  587516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  587519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587548 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587570 */     GIR_RootConstrainSelectedInstOperands,
     /*  587571 */     // GIR_Coverage, 4228,
     /*  587571 */     GIR_EraseRootFromParent_Done,
     /*  587572 */   // Label 9579: @587572
     /*  587572 */   GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(587647), // Rule ID 4229 //
     /*  587577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  587588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  587591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  587594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587623 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587645 */     GIR_RootConstrainSelectedInstOperands,
     /*  587646 */     // GIR_Coverage, 4229,
     /*  587646 */     GIR_EraseRootFromParent_Done,
     /*  587647 */   // Label 9580: @587647
     /*  587647 */   GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(587722), // Rule ID 4232 //
     /*  587652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  587663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  587666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587698 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  587701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587720 */     GIR_RootConstrainSelectedInstOperands,
     /*  587721 */     // GIR_Coverage, 4232,
     /*  587721 */     GIR_EraseRootFromParent_Done,
     /*  587722 */   // Label 9581: @587722
     /*  587722 */   GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(587797), // Rule ID 4233 //
     /*  587727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  587738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  587741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587773 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  587776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587795 */     GIR_RootConstrainSelectedInstOperands,
     /*  587796 */     // GIR_Coverage, 4233,
     /*  587796 */     GIR_EraseRootFromParent_Done,
     /*  587797 */   // Label 9582: @587797
     /*  587797 */   GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(587872), // Rule ID 4236 //
     /*  587802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  587813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  587816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  587851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587870 */     GIR_RootConstrainSelectedInstOperands,
     /*  587871 */     // GIR_Coverage, 4236,
     /*  587871 */     GIR_EraseRootFromParent_Done,
     /*  587872 */   // Label 9583: @587872
     /*  587872 */   GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(587947), // Rule ID 4237 //
     /*  587877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  587888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  587891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587923 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  587926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587945 */     GIR_RootConstrainSelectedInstOperands,
     /*  587946 */     // GIR_Coverage, 4237,
     /*  587946 */     GIR_EraseRootFromParent_Done,
     /*  587947 */   // Label 9584: @587947
     /*  587947 */   GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(588022), // Rule ID 4240 //
     /*  587952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  587963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  587966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  587969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587998 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588020 */     GIR_RootConstrainSelectedInstOperands,
     /*  588021 */     // GIR_Coverage, 4240,
     /*  588021 */     GIR_EraseRootFromParent_Done,
     /*  588022 */   // Label 9585: @588022
     /*  588022 */   GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(588097), // Rule ID 4241 //
     /*  588027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  588038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  588041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  588044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588073 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  588073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588095 */     GIR_RootConstrainSelectedInstOperands,
     /*  588096 */     // GIR_Coverage, 4241,
     /*  588096 */     GIR_EraseRootFromParent_Done,
     /*  588097 */   // Label 9586: @588097
     /*  588097 */   GIM_Try, /*On fail goto*//*Label 9587*/ GIMT_Encode4(588172), // Rule ID 4244 //
     /*  588102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  588113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  588116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  588119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588148 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  588151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588170 */     GIR_RootConstrainSelectedInstOperands,
     /*  588171 */     // GIR_Coverage, 4244,
     /*  588171 */     GIR_EraseRootFromParent_Done,
     /*  588172 */   // Label 9587: @588172
     /*  588172 */   GIM_Try, /*On fail goto*//*Label 9588*/ GIMT_Encode4(588247), // Rule ID 4245 //
     /*  588177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  588188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  588191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  588194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588223 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  588226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588245 */     GIR_RootConstrainSelectedInstOperands,
     /*  588246 */     // GIR_Coverage, 4245,
     /*  588246 */     GIR_EraseRootFromParent_Done,
     /*  588247 */   // Label 9588: @588247
     /*  588247 */   GIM_Try, /*On fail goto*//*Label 9589*/ GIMT_Encode4(588322), // Rule ID 4248 //
     /*  588252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  588263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  588266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  588269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588298 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  588301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588320 */     GIR_RootConstrainSelectedInstOperands,
     /*  588321 */     // GIR_Coverage, 4248,
     /*  588321 */     GIR_EraseRootFromParent_Done,
     /*  588322 */   // Label 9589: @588322
     /*  588322 */   GIM_Try, /*On fail goto*//*Label 9590*/ GIMT_Encode4(588397), // Rule ID 4249 //
     /*  588327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  588338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  588341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  588344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588373 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  588376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588395 */     GIR_RootConstrainSelectedInstOperands,
     /*  588396 */     // GIR_Coverage, 4249,
     /*  588396 */     GIR_EraseRootFromParent_Done,
     /*  588397 */   // Label 9590: @588397
     /*  588397 */   GIM_Try, /*On fail goto*//*Label 9591*/ GIMT_Encode4(588472), // Rule ID 4252 //
     /*  588402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  588413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  588416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  588419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588448 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  588451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588470 */     GIR_RootConstrainSelectedInstOperands,
     /*  588471 */     // GIR_Coverage, 4252,
     /*  588471 */     GIR_EraseRootFromParent_Done,
     /*  588472 */   // Label 9591: @588472
     /*  588472 */   GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(588547), // Rule ID 4253 //
     /*  588477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  588488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  588491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  588494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588523 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  588526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588545 */     GIR_RootConstrainSelectedInstOperands,
     /*  588546 */     // GIR_Coverage, 4253,
     /*  588546 */     GIR_EraseRootFromParent_Done,
     /*  588547 */   // Label 9592: @588547
     /*  588547 */   GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(588622), // Rule ID 4256 //
     /*  588552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  588563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  588566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588620 */     GIR_RootConstrainSelectedInstOperands,
     /*  588621 */     // GIR_Coverage, 4256,
     /*  588621 */     GIR_EraseRootFromParent_Done,
     /*  588622 */   // Label 9593: @588622
     /*  588622 */   GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(588697), // Rule ID 4257 //
     /*  588627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  588638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  588641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588673 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588695 */     GIR_RootConstrainSelectedInstOperands,
     /*  588696 */     // GIR_Coverage, 4257,
     /*  588696 */     GIR_EraseRootFromParent_Done,
     /*  588697 */   // Label 9594: @588697
     /*  588697 */   GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(588772), // Rule ID 4260 //
     /*  588702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  588713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  588716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  588719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588748 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588770 */     GIR_RootConstrainSelectedInstOperands,
     /*  588771 */     // GIR_Coverage, 4260,
     /*  588771 */     GIR_EraseRootFromParent_Done,
     /*  588772 */   // Label 9595: @588772
     /*  588772 */   GIM_Try, /*On fail goto*//*Label 9596*/ GIMT_Encode4(588847), // Rule ID 4261 //
     /*  588777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  588788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  588791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  588794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588823 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588845 */     GIR_RootConstrainSelectedInstOperands,
     /*  588846 */     // GIR_Coverage, 4261,
     /*  588846 */     GIR_EraseRootFromParent_Done,
     /*  588847 */   // Label 9596: @588847
     /*  588847 */   GIM_Try, /*On fail goto*//*Label 9597*/ GIMT_Encode4(588922), // Rule ID 4264 //
     /*  588852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  588863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  588866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  588869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588898 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  588901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588920 */     GIR_RootConstrainSelectedInstOperands,
     /*  588921 */     // GIR_Coverage, 4264,
     /*  588921 */     GIR_EraseRootFromParent_Done,
     /*  588922 */   // Label 9597: @588922
     /*  588922 */   GIM_Try, /*On fail goto*//*Label 9598*/ GIMT_Encode4(588997), // Rule ID 4265 //
     /*  588927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  588938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  588941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  588944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588973 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  588976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588995 */     GIR_RootConstrainSelectedInstOperands,
     /*  588996 */     // GIR_Coverage, 4265,
     /*  588996 */     GIR_EraseRootFromParent_Done,
     /*  588997 */   // Label 9598: @588997
     /*  588997 */   GIM_Try, /*On fail goto*//*Label 9599*/ GIMT_Encode4(589072), // Rule ID 4268 //
     /*  589002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  589005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  589013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  589016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  589019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  589022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  589041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589048 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  589048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  589051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589070 */     GIR_RootConstrainSelectedInstOperands,
     /*  589071 */     // GIR_Coverage, 4268,
     /*  589071 */     GIR_EraseRootFromParent_Done,
     /*  589072 */   // Label 9599: @589072
     /*  589072 */   GIM_Try, /*On fail goto*//*Label 9600*/ GIMT_Encode4(589147), // Rule ID 4269 //
     /*  589077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  589080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  589088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  589091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  589094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  589097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  589116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589123 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  589123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  589126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589145 */     GIR_RootConstrainSelectedInstOperands,
     /*  589146 */     // GIR_Coverage, 4269,
     /*  589146 */     GIR_EraseRootFromParent_Done,
     /*  589147 */   // Label 9600: @589147
     /*  589147 */   GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(589222), // Rule ID 4272 //
     /*  589152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  589155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  589163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  589166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  589169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  589172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  589191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589198 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  589198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  589201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589220 */     GIR_RootConstrainSelectedInstOperands,
     /*  589221 */     // GIR_Coverage, 4272,
     /*  589221 */     GIR_EraseRootFromParent_Done,
     /*  589222 */   // Label 9601: @589222
     /*  589222 */   GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(589297), // Rule ID 4273 //
     /*  589227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  589230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  589238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  589241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  589244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  589247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  589266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589273 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  589273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  589276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589295 */     GIR_RootConstrainSelectedInstOperands,
     /*  589296 */     // GIR_Coverage, 4273,
     /*  589296 */     GIR_EraseRootFromParent_Done,
     /*  589297 */   // Label 9602: @589297
     /*  589297 */   GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(589372), // Rule ID 4276 //
     /*  589302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  589305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  589313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  589316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  589319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  589322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  589341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589348 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  589348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  589351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589370 */     GIR_RootConstrainSelectedInstOperands,
     /*  589371 */     // GIR_Coverage, 4276,
     /*  589371 */     GIR_EraseRootFromParent_Done,
     /*  589372 */   // Label 9603: @589372
     /*  589372 */   GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(589447), // Rule ID 4277 //
     /*  589377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  589380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  589388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  589391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  589394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  589397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  589416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589423 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  589423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  589426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589445 */     GIR_RootConstrainSelectedInstOperands,
     /*  589446 */     // GIR_Coverage, 4277,
     /*  589446 */     GIR_EraseRootFromParent_Done,
     /*  589447 */   // Label 9604: @589447
     /*  589447 */   GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(589522), // Rule ID 4282 //
     /*  589452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  589463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  589466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  589469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  589472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589498 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  589501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589520 */     GIR_RootConstrainSelectedInstOperands,
     /*  589521 */     // GIR_Coverage, 4282,
     /*  589521 */     GIR_EraseRootFromParent_Done,
     /*  589522 */   // Label 9605: @589522
     /*  589522 */   GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(589597), // Rule ID 4283 //
     /*  589527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  589538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  589541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  589544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  589547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589573 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  589576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589595 */     GIR_RootConstrainSelectedInstOperands,
     /*  589596 */     // GIR_Coverage, 4283,
     /*  589596 */     GIR_EraseRootFromParent_Done,
     /*  589597 */   // Label 9606: @589597
     /*  589597 */   GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(589672), // Rule ID 4292 //
     /*  589602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  589613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  589616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  589619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  589622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589648 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  589651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589670 */     GIR_RootConstrainSelectedInstOperands,
     /*  589671 */     // GIR_Coverage, 4292,
     /*  589671 */     GIR_EraseRootFromParent_Done,
     /*  589672 */   // Label 9607: @589672
     /*  589672 */   GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(589747), // Rule ID 4293 //
     /*  589677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  589688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  589691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  589694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  589697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589723 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  589726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589745 */     GIR_RootConstrainSelectedInstOperands,
     /*  589746 */     // GIR_Coverage, 4293,
     /*  589746 */     GIR_EraseRootFromParent_Done,
     /*  589747 */   // Label 9608: @589747
     /*  589747 */   GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(589822), // Rule ID 4302 //
     /*  589752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  589763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  589766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  589769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  589772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  589801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589820 */     GIR_RootConstrainSelectedInstOperands,
     /*  589821 */     // GIR_Coverage, 4302,
     /*  589821 */     GIR_EraseRootFromParent_Done,
     /*  589822 */   // Label 9609: @589822
     /*  589822 */   GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(589897), // Rule ID 4303 //
     /*  589827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  589838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  589841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  589844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  589847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589873 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  589876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589895 */     GIR_RootConstrainSelectedInstOperands,
     /*  589896 */     // GIR_Coverage, 4303,
     /*  589896 */     GIR_EraseRootFromParent_Done,
     /*  589897 */   // Label 9610: @589897
     /*  589897 */   GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(589972), // Rule ID 4312 //
     /*  589902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  589913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  589916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  589919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  589922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589948 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  589951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589970 */     GIR_RootConstrainSelectedInstOperands,
     /*  589971 */     // GIR_Coverage, 4312,
     /*  589971 */     GIR_EraseRootFromParent_Done,
     /*  589972 */   // Label 9611: @589972
     /*  589972 */   GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(590047), // Rule ID 4313 //
     /*  589977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  589988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  589991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  589994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  589997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590023 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590045 */     GIR_RootConstrainSelectedInstOperands,
     /*  590046 */     // GIR_Coverage, 4313,
     /*  590046 */     GIR_EraseRootFromParent_Done,
     /*  590047 */   // Label 9612: @590047
     /*  590047 */   GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(590122), // Rule ID 4322 //
     /*  590052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  590063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  590066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  590069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  590072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590098 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590120 */     GIR_RootConstrainSelectedInstOperands,
     /*  590121 */     // GIR_Coverage, 4322,
     /*  590121 */     GIR_EraseRootFromParent_Done,
     /*  590122 */   // Label 9613: @590122
     /*  590122 */   GIM_Try, /*On fail goto*//*Label 9614*/ GIMT_Encode4(590197), // Rule ID 4323 //
     /*  590127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  590138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  590141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  590144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  590147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590173 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590195 */     GIR_RootConstrainSelectedInstOperands,
     /*  590196 */     // GIR_Coverage, 4323,
     /*  590196 */     GIR_EraseRootFromParent_Done,
     /*  590197 */   // Label 9614: @590197
     /*  590197 */   GIM_Try, /*On fail goto*//*Label 9615*/ GIMT_Encode4(590272), // Rule ID 4332 //
     /*  590202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  590213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  590216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  590219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  590222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590248 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590270 */     GIR_RootConstrainSelectedInstOperands,
     /*  590271 */     // GIR_Coverage, 4332,
     /*  590271 */     GIR_EraseRootFromParent_Done,
     /*  590272 */   // Label 9615: @590272
     /*  590272 */   GIM_Try, /*On fail goto*//*Label 9616*/ GIMT_Encode4(590347), // Rule ID 4333 //
     /*  590277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  590288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  590291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  590294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  590297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590323 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590345 */     GIR_RootConstrainSelectedInstOperands,
     /*  590346 */     // GIR_Coverage, 4333,
     /*  590346 */     GIR_EraseRootFromParent_Done,
     /*  590347 */   // Label 9616: @590347
     /*  590347 */   GIM_Try, /*On fail goto*//*Label 9617*/ GIMT_Encode4(590422), // Rule ID 4342 //
     /*  590352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  590363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  590366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  590369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  590372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590398 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  590401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590420 */     GIR_RootConstrainSelectedInstOperands,
     /*  590421 */     // GIR_Coverage, 4342,
     /*  590421 */     GIR_EraseRootFromParent_Done,
     /*  590422 */   // Label 9617: @590422
     /*  590422 */   GIM_Try, /*On fail goto*//*Label 9618*/ GIMT_Encode4(590497), // Rule ID 4343 //
     /*  590427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  590438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  590441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  590444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  590447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590473 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  590476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590495 */     GIR_RootConstrainSelectedInstOperands,
     /*  590496 */     // GIR_Coverage, 4343,
     /*  590496 */     GIR_EraseRootFromParent_Done,
     /*  590497 */   // Label 9618: @590497
     /*  590497 */   GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(590572), // Rule ID 4352 //
     /*  590502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  590513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  590516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  590519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  590522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590548 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590570 */     GIR_RootConstrainSelectedInstOperands,
     /*  590571 */     // GIR_Coverage, 4352,
     /*  590571 */     GIR_EraseRootFromParent_Done,
     /*  590572 */   // Label 9619: @590572
     /*  590572 */   GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(590647), // Rule ID 4353 //
     /*  590577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  590588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  590591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  590594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  590597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590623 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590645 */     GIR_RootConstrainSelectedInstOperands,
     /*  590646 */     // GIR_Coverage, 4353,
     /*  590646 */     GIR_EraseRootFromParent_Done,
     /*  590647 */   // Label 9620: @590647
     /*  590647 */   GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(590722), // Rule ID 4362 //
     /*  590652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  590663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  590666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  590669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  590672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590720 */     GIR_RootConstrainSelectedInstOperands,
     /*  590721 */     // GIR_Coverage, 4362,
     /*  590721 */     GIR_EraseRootFromParent_Done,
     /*  590722 */   // Label 9621: @590722
     /*  590722 */   GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(590797), // Rule ID 4363 //
     /*  590727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  590738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  590741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  590744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  590747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590795 */     GIR_RootConstrainSelectedInstOperands,
     /*  590796 */     // GIR_Coverage, 4363,
     /*  590796 */     GIR_EraseRootFromParent_Done,
     /*  590797 */   // Label 9622: @590797
     /*  590797 */   GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(590872), // Rule ID 4372 //
     /*  590802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  590813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  590816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  590819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  590822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590848 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590870 */     GIR_RootConstrainSelectedInstOperands,
     /*  590871 */     // GIR_Coverage, 4372,
     /*  590871 */     GIR_EraseRootFromParent_Done,
     /*  590872 */   // Label 9623: @590872
     /*  590872 */   GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(590947), // Rule ID 4373 //
     /*  590877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  590888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  590891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  590894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  590897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590923 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590945 */     GIR_RootConstrainSelectedInstOperands,
     /*  590946 */     // GIR_Coverage, 4373,
     /*  590946 */     GIR_EraseRootFromParent_Done,
     /*  590947 */   // Label 9624: @590947
     /*  590947 */   GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(591022), // Rule ID 4382 //
     /*  590952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  590963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  590966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  590969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  590972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590998 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  591001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591020 */     GIR_RootConstrainSelectedInstOperands,
     /*  591021 */     // GIR_Coverage, 4382,
     /*  591021 */     GIR_EraseRootFromParent_Done,
     /*  591022 */   // Label 9625: @591022
     /*  591022 */   GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(591097), // Rule ID 4383 //
     /*  591027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  591038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  591041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  591044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  591047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591073 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  591076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591095 */     GIR_RootConstrainSelectedInstOperands,
     /*  591096 */     // GIR_Coverage, 4383,
     /*  591096 */     GIR_EraseRootFromParent_Done,
     /*  591097 */   // Label 9626: @591097
     /*  591097 */   GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(591172), // Rule ID 4392 //
     /*  591102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  591105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  591113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  591116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  591119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  591122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591148 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  591151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591170 */     GIR_RootConstrainSelectedInstOperands,
     /*  591171 */     // GIR_Coverage, 4392,
     /*  591171 */     GIR_EraseRootFromParent_Done,
     /*  591172 */   // Label 9627: @591172
     /*  591172 */   GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(591247), // Rule ID 4393 //
     /*  591177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  591180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  591188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  591191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  591194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  591197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591223 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  591226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591245 */     GIR_RootConstrainSelectedInstOperands,
     /*  591246 */     // GIR_Coverage, 4393,
     /*  591246 */     GIR_EraseRootFromParent_Done,
     /*  591247 */   // Label 9628: @591247
     /*  591247 */   GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(591322), // Rule ID 4402 //
     /*  591252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  591255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  591263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  591266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  591269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  591272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  591301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591320 */     GIR_RootConstrainSelectedInstOperands,
     /*  591321 */     // GIR_Coverage, 4402,
     /*  591321 */     GIR_EraseRootFromParent_Done,
     /*  591322 */   // Label 9629: @591322
     /*  591322 */   GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(591397), // Rule ID 4403 //
     /*  591327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  591330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  591338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  591341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  591344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  591347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591373 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  591376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591395 */     GIR_RootConstrainSelectedInstOperands,
     /*  591396 */     // GIR_Coverage, 4403,
     /*  591396 */     GIR_EraseRootFromParent_Done,
     /*  591397 */   // Label 9630: @591397
     /*  591397 */   GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(591472), // Rule ID 4412 //
     /*  591402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  591405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  591413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  591416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  591419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  591422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  591451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591470 */     GIR_RootConstrainSelectedInstOperands,
     /*  591471 */     // GIR_Coverage, 4412,
     /*  591471 */     GIR_EraseRootFromParent_Done,
     /*  591472 */   // Label 9631: @591472
     /*  591472 */   GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(591547), // Rule ID 4413 //
     /*  591477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  591480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  591488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  591491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  591494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  591497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591523 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  591526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591545 */     GIR_RootConstrainSelectedInstOperands,
     /*  591546 */     // GIR_Coverage, 4413,
     /*  591546 */     GIR_EraseRootFromParent_Done,
     /*  591547 */   // Label 9632: @591547
     /*  591547 */   GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(591622), // Rule ID 4422 //
     /*  591552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  591555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  591563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  591566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  591569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  591572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591598 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  591601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591620 */     GIR_RootConstrainSelectedInstOperands,
     /*  591621 */     // GIR_Coverage, 4422,
     /*  591621 */     GIR_EraseRootFromParent_Done,
     /*  591622 */   // Label 9633: @591622
     /*  591622 */   GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(591697), // Rule ID 4423 //
     /*  591627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  591630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  591638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  591641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  591644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  591647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591673 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  591676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591695 */     GIR_RootConstrainSelectedInstOperands,
     /*  591696 */     // GIR_Coverage, 4423,
     /*  591696 */     GIR_EraseRootFromParent_Done,
     /*  591697 */   // Label 9634: @591697
     /*  591697 */   GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(591772), // Rule ID 4430 //
     /*  591702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  591713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  591716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  591719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591748 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  591751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591770 */     GIR_RootConstrainSelectedInstOperands,
     /*  591771 */     // GIR_Coverage, 4430,
     /*  591771 */     GIR_EraseRootFromParent_Done,
     /*  591772 */   // Label 9635: @591772
     /*  591772 */   GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(591847), // Rule ID 4431 //
     /*  591777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  591788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  591791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  591794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591823 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  591826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591845 */     GIR_RootConstrainSelectedInstOperands,
     /*  591846 */     // GIR_Coverage, 4431,
     /*  591846 */     GIR_EraseRootFromParent_Done,
     /*  591847 */   // Label 9636: @591847
     /*  591847 */   GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(591922), // Rule ID 4434 //
     /*  591852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  591863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  591866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  591869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591898 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  591901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591920 */     GIR_RootConstrainSelectedInstOperands,
     /*  591921 */     // GIR_Coverage, 4434,
     /*  591921 */     GIR_EraseRootFromParent_Done,
     /*  591922 */   // Label 9637: @591922
     /*  591922 */   GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(591997), // Rule ID 4435 //
     /*  591927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  591938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  591941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  591944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591973 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  591976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591995 */     GIR_RootConstrainSelectedInstOperands,
     /*  591996 */     // GIR_Coverage, 4435,
     /*  591996 */     GIR_EraseRootFromParent_Done,
     /*  591997 */   // Label 9638: @591997
     /*  591997 */   GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(592072), // Rule ID 4438 //
     /*  592002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  592013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  592016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  592019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592048 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592070 */     GIR_RootConstrainSelectedInstOperands,
     /*  592071 */     // GIR_Coverage, 4438,
     /*  592071 */     GIR_EraseRootFromParent_Done,
     /*  592072 */   // Label 9639: @592072
     /*  592072 */   GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(592147), // Rule ID 4439 //
     /*  592077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  592088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  592091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  592094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592123 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592145 */     GIR_RootConstrainSelectedInstOperands,
     /*  592146 */     // GIR_Coverage, 4439,
     /*  592146 */     GIR_EraseRootFromParent_Done,
     /*  592147 */   // Label 9640: @592147
     /*  592147 */   GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(592222), // Rule ID 4442 //
     /*  592152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  592163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  592166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  592169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592220 */     GIR_RootConstrainSelectedInstOperands,
     /*  592221 */     // GIR_Coverage, 4442,
     /*  592221 */     GIR_EraseRootFromParent_Done,
     /*  592222 */   // Label 9641: @592222
     /*  592222 */   GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(592297), // Rule ID 4443 //
     /*  592227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  592238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  592241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  592244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592273 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592295 */     GIR_RootConstrainSelectedInstOperands,
     /*  592296 */     // GIR_Coverage, 4443,
     /*  592296 */     GIR_EraseRootFromParent_Done,
     /*  592297 */   // Label 9642: @592297
     /*  592297 */   GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(592372), // Rule ID 4446 //
     /*  592302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  592313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  592316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  592319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592348 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  592351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592370 */     GIR_RootConstrainSelectedInstOperands,
     /*  592371 */     // GIR_Coverage, 4446,
     /*  592371 */     GIR_EraseRootFromParent_Done,
     /*  592372 */   // Label 9643: @592372
     /*  592372 */   GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(592447), // Rule ID 4447 //
     /*  592377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  592388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  592391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  592394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592423 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  592426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592445 */     GIR_RootConstrainSelectedInstOperands,
     /*  592446 */     // GIR_Coverage, 4447,
     /*  592446 */     GIR_EraseRootFromParent_Done,
     /*  592447 */   // Label 9644: @592447
     /*  592447 */   GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(592522), // Rule ID 4450 //
     /*  592452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  592463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  592466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  592469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592498 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592520 */     GIR_RootConstrainSelectedInstOperands,
     /*  592521 */     // GIR_Coverage, 4450,
     /*  592521 */     GIR_EraseRootFromParent_Done,
     /*  592522 */   // Label 9645: @592522
     /*  592522 */   GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(592597), // Rule ID 4451 //
     /*  592527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  592538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  592541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  592544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592573 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592595 */     GIR_RootConstrainSelectedInstOperands,
     /*  592596 */     // GIR_Coverage, 4451,
     /*  592596 */     GIR_EraseRootFromParent_Done,
     /*  592597 */   // Label 9646: @592597
     /*  592597 */   GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(592672), // Rule ID 4454 //
     /*  592602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  592613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  592616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  592619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592648 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  592651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592670 */     GIR_RootConstrainSelectedInstOperands,
     /*  592671 */     // GIR_Coverage, 4454,
     /*  592671 */     GIR_EraseRootFromParent_Done,
     /*  592672 */   // Label 9647: @592672
     /*  592672 */   GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(592747), // Rule ID 4455 //
     /*  592677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  592688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  592691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  592694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592723 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  592726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592745 */     GIR_RootConstrainSelectedInstOperands,
     /*  592746 */     // GIR_Coverage, 4455,
     /*  592746 */     GIR_EraseRootFromParent_Done,
     /*  592747 */   // Label 9648: @592747
     /*  592747 */   GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(592822), // Rule ID 4458 //
     /*  592752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  592763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  592766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  592769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592798 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592820 */     GIR_RootConstrainSelectedInstOperands,
     /*  592821 */     // GIR_Coverage, 4458,
     /*  592821 */     GIR_EraseRootFromParent_Done,
     /*  592822 */   // Label 9649: @592822
     /*  592822 */   GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(592897), // Rule ID 4459 //
     /*  592827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  592838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  592841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  592844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592873 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592895 */     GIR_RootConstrainSelectedInstOperands,
     /*  592896 */     // GIR_Coverage, 4459,
     /*  592896 */     GIR_EraseRootFromParent_Done,
     /*  592897 */   // Label 9650: @592897
     /*  592897 */   GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(592972), // Rule ID 4462 //
     /*  592902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  592913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  592916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  592919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592970 */     GIR_RootConstrainSelectedInstOperands,
     /*  592971 */     // GIR_Coverage, 4462,
     /*  592971 */     GIR_EraseRootFromParent_Done,
     /*  592972 */   // Label 9651: @592972
     /*  592972 */   GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(593047), // Rule ID 4463 //
     /*  592977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  592988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  592991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  592994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  593026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593045 */     GIR_RootConstrainSelectedInstOperands,
     /*  593046 */     // GIR_Coverage, 4463,
     /*  593046 */     GIR_EraseRootFromParent_Done,
     /*  593047 */   // Label 9652: @593047
     /*  593047 */   GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(593122), // Rule ID 4466 //
     /*  593052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  593063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  593066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  593069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593098 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  593098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  593101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593120 */     GIR_RootConstrainSelectedInstOperands,
     /*  593121 */     // GIR_Coverage, 4466,
     /*  593121 */     GIR_EraseRootFromParent_Done,
     /*  593122 */   // Label 9653: @593122
     /*  593122 */   GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(593197), // Rule ID 4467 //
     /*  593127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  593138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  593141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  593144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593173 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  593176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593195 */     GIR_RootConstrainSelectedInstOperands,
     /*  593196 */     // GIR_Coverage, 4467,
     /*  593196 */     GIR_EraseRootFromParent_Done,
     /*  593197 */   // Label 9654: @593197
     /*  593197 */   GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(593272), // Rule ID 4470 //
     /*  593202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  593213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  593216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  593219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  593248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  593251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593270 */     GIR_RootConstrainSelectedInstOperands,
     /*  593271 */     // GIR_Coverage, 4470,
     /*  593271 */     GIR_EraseRootFromParent_Done,
     /*  593272 */   // Label 9655: @593272
     /*  593272 */   GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(593347), // Rule ID 4471 //
     /*  593277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  593288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  593291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  593294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593323 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  593326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593345 */     GIR_RootConstrainSelectedInstOperands,
     /*  593346 */     // GIR_Coverage, 4471,
     /*  593346 */     GIR_EraseRootFromParent_Done,
     /*  593347 */   // Label 9656: @593347
     /*  593347 */   GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(593422), // Rule ID 4474 //
     /*  593352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  593363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  593366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  593369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593398 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  593401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593420 */     GIR_RootConstrainSelectedInstOperands,
     /*  593421 */     // GIR_Coverage, 4474,
     /*  593421 */     GIR_EraseRootFromParent_Done,
     /*  593422 */   // Label 9657: @593422
     /*  593422 */   GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(593497), // Rule ID 4475 //
     /*  593427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  593438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  593441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  593444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593473 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  593476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593495 */     GIR_RootConstrainSelectedInstOperands,
     /*  593496 */     // GIR_Coverage, 4475,
     /*  593496 */     GIR_EraseRootFromParent_Done,
     /*  593497 */   // Label 9658: @593497
     /*  593497 */   GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(593572), // Rule ID 4478 //
     /*  593502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  593513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  593516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  593519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593548 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  593551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593570 */     GIR_RootConstrainSelectedInstOperands,
     /*  593571 */     // GIR_Coverage, 4478,
     /*  593571 */     GIR_EraseRootFromParent_Done,
     /*  593572 */   // Label 9659: @593572
     /*  593572 */   GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(593647), // Rule ID 4479 //
     /*  593577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  593588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  593591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  593594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  593626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593645 */     GIR_RootConstrainSelectedInstOperands,
     /*  593646 */     // GIR_Coverage, 4479,
     /*  593646 */     GIR_EraseRootFromParent_Done,
     /*  593647 */   // Label 9660: @593647
     /*  593647 */   GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(593722), // Rule ID 4482 //
     /*  593652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  593663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  593666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  593669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593698 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  593701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593720 */     GIR_RootConstrainSelectedInstOperands,
     /*  593721 */     // GIR_Coverage, 4482,
     /*  593721 */     GIR_EraseRootFromParent_Done,
     /*  593722 */   // Label 9661: @593722
     /*  593722 */   GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(593797), // Rule ID 4483 //
     /*  593727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  593738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  593741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  593744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593773 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  593776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593795 */     GIR_RootConstrainSelectedInstOperands,
     /*  593796 */     // GIR_Coverage, 4483,
     /*  593796 */     GIR_EraseRootFromParent_Done,
     /*  593797 */   // Label 9662: @593797
     /*  593797 */   GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(593872), // Rule ID 4486 //
     /*  593802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  593813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  593816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  593819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593848 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  593851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593870 */     GIR_RootConstrainSelectedInstOperands,
     /*  593871 */     // GIR_Coverage, 4486,
     /*  593871 */     GIR_EraseRootFromParent_Done,
     /*  593872 */   // Label 9663: @593872
     /*  593872 */   GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(593947), // Rule ID 4487 //
     /*  593877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  593888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  593891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  593894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593923 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  593926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593945 */     GIR_RootConstrainSelectedInstOperands,
     /*  593946 */     // GIR_Coverage, 4487,
     /*  593946 */     GIR_EraseRootFromParent_Done,
     /*  593947 */   // Label 9664: @593947
     /*  593947 */   GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(594022), // Rule ID 4492 //
     /*  593952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  593963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  593966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  593969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  593972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593998 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  594001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594020 */     GIR_RootConstrainSelectedInstOperands,
     /*  594021 */     // GIR_Coverage, 4492,
     /*  594021 */     GIR_EraseRootFromParent_Done,
     /*  594022 */   // Label 9665: @594022
     /*  594022 */   GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(594097), // Rule ID 4493 //
     /*  594027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  594038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  594041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  594044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  594047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594073 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  594076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594095 */     GIR_RootConstrainSelectedInstOperands,
     /*  594096 */     // GIR_Coverage, 4493,
     /*  594096 */     GIR_EraseRootFromParent_Done,
     /*  594097 */   // Label 9666: @594097
     /*  594097 */   GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(594172), // Rule ID 4502 //
     /*  594102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  594113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  594116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  594119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  594122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  594151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594170 */     GIR_RootConstrainSelectedInstOperands,
     /*  594171 */     // GIR_Coverage, 4502,
     /*  594171 */     GIR_EraseRootFromParent_Done,
     /*  594172 */   // Label 9667: @594172
     /*  594172 */   GIM_Try, /*On fail goto*//*Label 9668*/ GIMT_Encode4(594247), // Rule ID 4503 //
     /*  594177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  594188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  594191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  594194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  594197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594223 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  594226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594245 */     GIR_RootConstrainSelectedInstOperands,
     /*  594246 */     // GIR_Coverage, 4503,
     /*  594246 */     GIR_EraseRootFromParent_Done,
     /*  594247 */   // Label 9668: @594247
     /*  594247 */   GIM_Try, /*On fail goto*//*Label 9669*/ GIMT_Encode4(594322), // Rule ID 4512 //
     /*  594252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  594263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  594266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  594269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  594272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594298 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  594301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594320 */     GIR_RootConstrainSelectedInstOperands,
     /*  594321 */     // GIR_Coverage, 4512,
     /*  594321 */     GIR_EraseRootFromParent_Done,
     /*  594322 */   // Label 9669: @594322
     /*  594322 */   GIM_Try, /*On fail goto*//*Label 9670*/ GIMT_Encode4(594397), // Rule ID 4513 //
     /*  594327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  594338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  594341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  594344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  594347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594373 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  594376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594395 */     GIR_RootConstrainSelectedInstOperands,
     /*  594396 */     // GIR_Coverage, 4513,
     /*  594396 */     GIR_EraseRootFromParent_Done,
     /*  594397 */   // Label 9670: @594397
     /*  594397 */   GIM_Try, /*On fail goto*//*Label 9671*/ GIMT_Encode4(594472), // Rule ID 4522 //
     /*  594402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  594413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  594416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  594419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  594422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594470 */     GIR_RootConstrainSelectedInstOperands,
     /*  594471 */     // GIR_Coverage, 4522,
     /*  594471 */     GIR_EraseRootFromParent_Done,
     /*  594472 */   // Label 9671: @594472
     /*  594472 */   GIM_Try, /*On fail goto*//*Label 9672*/ GIMT_Encode4(594547), // Rule ID 4523 //
     /*  594477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  594488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  594491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  594494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  594497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594523 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594545 */     GIR_RootConstrainSelectedInstOperands,
     /*  594546 */     // GIR_Coverage, 4523,
     /*  594546 */     GIR_EraseRootFromParent_Done,
     /*  594547 */   // Label 9672: @594547
     /*  594547 */   GIM_Try, /*On fail goto*//*Label 9673*/ GIMT_Encode4(594622), // Rule ID 4532 //
     /*  594552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  594563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  594566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  594569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  594572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594598 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594620 */     GIR_RootConstrainSelectedInstOperands,
     /*  594621 */     // GIR_Coverage, 4532,
     /*  594621 */     GIR_EraseRootFromParent_Done,
     /*  594622 */   // Label 9673: @594622
     /*  594622 */   GIM_Try, /*On fail goto*//*Label 9674*/ GIMT_Encode4(594697), // Rule ID 4533 //
     /*  594627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  594638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  594641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  594644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  594647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594673 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594695 */     GIR_RootConstrainSelectedInstOperands,
     /*  594696 */     // GIR_Coverage, 4533,
     /*  594696 */     GIR_EraseRootFromParent_Done,
     /*  594697 */   // Label 9674: @594697
     /*  594697 */   GIM_Try, /*On fail goto*//*Label 9675*/ GIMT_Encode4(594772), // Rule ID 4542 //
     /*  594702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  594713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  594716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  594719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  594722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594748 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  594751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594770 */     GIR_RootConstrainSelectedInstOperands,
     /*  594771 */     // GIR_Coverage, 4542,
     /*  594771 */     GIR_EraseRootFromParent_Done,
     /*  594772 */   // Label 9675: @594772
     /*  594772 */   GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(594847), // Rule ID 4543 //
     /*  594777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  594788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  594791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  594794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  594797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594823 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  594826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594845 */     GIR_RootConstrainSelectedInstOperands,
     /*  594846 */     // GIR_Coverage, 4543,
     /*  594846 */     GIR_EraseRootFromParent_Done,
     /*  594847 */   // Label 9676: @594847
     /*  594847 */   GIM_Try, /*On fail goto*//*Label 9677*/ GIMT_Encode4(594922), // Rule ID 4552 //
     /*  594852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  594863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  594866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  594869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  594872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594898 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  594901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594920 */     GIR_RootConstrainSelectedInstOperands,
     /*  594921 */     // GIR_Coverage, 4552,
     /*  594921 */     GIR_EraseRootFromParent_Done,
     /*  594922 */   // Label 9677: @594922
     /*  594922 */   GIM_Try, /*On fail goto*//*Label 9678*/ GIMT_Encode4(594997), // Rule ID 4553 //
     /*  594927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  594938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  594941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  594944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  594947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594973 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  594976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594995 */     GIR_RootConstrainSelectedInstOperands,
     /*  594996 */     // GIR_Coverage, 4553,
     /*  594996 */     GIR_EraseRootFromParent_Done,
     /*  594997 */   // Label 9678: @594997
     /*  594997 */   GIM_Try, /*On fail goto*//*Label 9679*/ GIMT_Encode4(595072), // Rule ID 4562 //
     /*  595002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  595013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  595016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  595019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  595022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  595048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  595051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595070 */     GIR_RootConstrainSelectedInstOperands,
     /*  595071 */     // GIR_Coverage, 4562,
     /*  595071 */     GIR_EraseRootFromParent_Done,
     /*  595072 */   // Label 9679: @595072
     /*  595072 */   GIM_Try, /*On fail goto*//*Label 9680*/ GIMT_Encode4(595147), // Rule ID 4563 //
     /*  595077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  595088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  595091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  595094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  595097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595123 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  595123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  595126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595145 */     GIR_RootConstrainSelectedInstOperands,
     /*  595146 */     // GIR_Coverage, 4563,
     /*  595146 */     GIR_EraseRootFromParent_Done,
     /*  595147 */   // Label 9680: @595147
     /*  595147 */   GIM_Try, /*On fail goto*//*Label 9681*/ GIMT_Encode4(595222), // Rule ID 4572 //
     /*  595152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  595163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  595166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  595169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  595172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595198 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  595198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  595201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595220 */     GIR_RootConstrainSelectedInstOperands,
     /*  595221 */     // GIR_Coverage, 4572,
     /*  595221 */     GIR_EraseRootFromParent_Done,
     /*  595222 */   // Label 9681: @595222
     /*  595222 */   GIM_Try, /*On fail goto*//*Label 9682*/ GIMT_Encode4(595297), // Rule ID 4573 //
     /*  595227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  595238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  595241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  595244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  595247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595273 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  595273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  595276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595295 */     GIR_RootConstrainSelectedInstOperands,
     /*  595296 */     // GIR_Coverage, 4573,
     /*  595296 */     GIR_EraseRootFromParent_Done,
     /*  595297 */   // Label 9682: @595297
     /*  595297 */   GIM_Try, /*On fail goto*//*Label 9683*/ GIMT_Encode4(595372), // Rule ID 4582 //
     /*  595302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  595313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  595316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  595319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  595322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595348 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  595348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  595351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595370 */     GIR_RootConstrainSelectedInstOperands,
     /*  595371 */     // GIR_Coverage, 4582,
     /*  595371 */     GIR_EraseRootFromParent_Done,
     /*  595372 */   // Label 9683: @595372
     /*  595372 */   GIM_Try, /*On fail goto*//*Label 9684*/ GIMT_Encode4(595447), // Rule ID 4583 //
     /*  595377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  595388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  595391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  595394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  595397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595423 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  595423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  595426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595445 */     GIR_RootConstrainSelectedInstOperands,
     /*  595446 */     // GIR_Coverage, 4583,
     /*  595446 */     GIR_EraseRootFromParent_Done,
     /*  595447 */   // Label 9684: @595447
     /*  595447 */   GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(595522), // Rule ID 4592 //
     /*  595452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  595463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  595466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  595469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  595472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  595498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595520 */     GIR_RootConstrainSelectedInstOperands,
     /*  595521 */     // GIR_Coverage, 4592,
     /*  595521 */     GIR_EraseRootFromParent_Done,
     /*  595522 */   // Label 9685: @595522
     /*  595522 */   GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(595597), // Rule ID 4593 //
     /*  595527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  595538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  595541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  595544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  595547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595573 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  595573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595595 */     GIR_RootConstrainSelectedInstOperands,
     /*  595596 */     // GIR_Coverage, 4593,
     /*  595596 */     GIR_EraseRootFromParent_Done,
     /*  595597 */   // Label 9686: @595597
     /*  595597 */   GIM_Try, /*On fail goto*//*Label 9687*/ GIMT_Encode4(595672), // Rule ID 4602 //
     /*  595602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  595613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  595616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  595619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  595622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595648 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  595651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595670 */     GIR_RootConstrainSelectedInstOperands,
     /*  595671 */     // GIR_Coverage, 4602,
     /*  595671 */     GIR_EraseRootFromParent_Done,
     /*  595672 */   // Label 9687: @595672
     /*  595672 */   GIM_Try, /*On fail goto*//*Label 9688*/ GIMT_Encode4(595747), // Rule ID 4603 //
     /*  595677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  595688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  595691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  595694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  595697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595723 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  595726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595745 */     GIR_RootConstrainSelectedInstOperands,
     /*  595746 */     // GIR_Coverage, 4603,
     /*  595746 */     GIR_EraseRootFromParent_Done,
     /*  595747 */   // Label 9688: @595747
     /*  595747 */   GIM_Try, /*On fail goto*//*Label 9689*/ GIMT_Encode4(595822), // Rule ID 4612 //
     /*  595752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  595763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  595766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  595769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  595772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  595801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595820 */     GIR_RootConstrainSelectedInstOperands,
     /*  595821 */     // GIR_Coverage, 4612,
     /*  595821 */     GIR_EraseRootFromParent_Done,
     /*  595822 */   // Label 9689: @595822
     /*  595822 */   GIM_Try, /*On fail goto*//*Label 9690*/ GIMT_Encode4(595897), // Rule ID 4613 //
     /*  595827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  595838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  595841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  595844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  595847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595873 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  595876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595895 */     GIR_RootConstrainSelectedInstOperands,
     /*  595896 */     // GIR_Coverage, 4613,
     /*  595896 */     GIR_EraseRootFromParent_Done,
     /*  595897 */   // Label 9690: @595897
     /*  595897 */   GIM_Try, /*On fail goto*//*Label 9691*/ GIMT_Encode4(595972), // Rule ID 4622 //
     /*  595902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  595913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  595916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  595919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  595922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595948 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  595951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595970 */     GIR_RootConstrainSelectedInstOperands,
     /*  595971 */     // GIR_Coverage, 4622,
     /*  595971 */     GIR_EraseRootFromParent_Done,
     /*  595972 */   // Label 9691: @595972
     /*  595972 */   GIM_Try, /*On fail goto*//*Label 9692*/ GIMT_Encode4(596047), // Rule ID 4623 //
     /*  595977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  595988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  595991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  595994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  595997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596023 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  596023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  596026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596045 */     GIR_RootConstrainSelectedInstOperands,
     /*  596046 */     // GIR_Coverage, 4623,
     /*  596046 */     GIR_EraseRootFromParent_Done,
     /*  596047 */   // Label 9692: @596047
     /*  596047 */   GIM_Try, /*On fail goto*//*Label 9693*/ GIMT_Encode4(596122), // Rule ID 4632 //
     /*  596052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  596055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  596063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  596066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  596069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  596072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596098 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  596098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  596101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596120 */     GIR_RootConstrainSelectedInstOperands,
     /*  596121 */     // GIR_Coverage, 4632,
     /*  596121 */     GIR_EraseRootFromParent_Done,
     /*  596122 */   // Label 9693: @596122
     /*  596122 */   GIM_Try, /*On fail goto*//*Label 9694*/ GIMT_Encode4(596197), // Rule ID 4633 //
     /*  596127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  596130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  596138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  596141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  596144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  596147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596173 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  596173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  596176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596195 */     GIR_RootConstrainSelectedInstOperands,
     /*  596196 */     // GIR_Coverage, 4633,
     /*  596196 */     GIR_EraseRootFromParent_Done,
     /*  596197 */   // Label 9694: @596197
     /*  596197 */   GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(596272), // Rule ID 4640 //
     /*  596202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  596213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  596216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  596219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596248 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  596251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596270 */     GIR_RootConstrainSelectedInstOperands,
     /*  596271 */     // GIR_Coverage, 4640,
     /*  596271 */     GIR_EraseRootFromParent_Done,
     /*  596272 */   // Label 9695: @596272
     /*  596272 */   GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(596347), // Rule ID 4641 //
     /*  596277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  596288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  596291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  596294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596323 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  596326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596345 */     GIR_RootConstrainSelectedInstOperands,
     /*  596346 */     // GIR_Coverage, 4641,
     /*  596346 */     GIR_EraseRootFromParent_Done,
     /*  596347 */   // Label 9696: @596347
     /*  596347 */   GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(596422), // Rule ID 4644 //
     /*  596352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  596363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  596366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  596369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596398 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  596401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596420 */     GIR_RootConstrainSelectedInstOperands,
     /*  596421 */     // GIR_Coverage, 4644,
     /*  596421 */     GIR_EraseRootFromParent_Done,
     /*  596422 */   // Label 9697: @596422
     /*  596422 */   GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(596497), // Rule ID 4645 //
     /*  596427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  596438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  596441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  596444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596473 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  596476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596495 */     GIR_RootConstrainSelectedInstOperands,
     /*  596496 */     // GIR_Coverage, 4645,
     /*  596496 */     GIR_EraseRootFromParent_Done,
     /*  596497 */   // Label 9698: @596497
     /*  596497 */   GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(596572), // Rule ID 4648 //
     /*  596502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  596513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  596516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  596519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596548 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596570 */     GIR_RootConstrainSelectedInstOperands,
     /*  596571 */     // GIR_Coverage, 4648,
     /*  596571 */     GIR_EraseRootFromParent_Done,
     /*  596572 */   // Label 9699: @596572
     /*  596572 */   GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(596647), // Rule ID 4649 //
     /*  596577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  596588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  596591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  596594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596623 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596645 */     GIR_RootConstrainSelectedInstOperands,
     /*  596646 */     // GIR_Coverage, 4649,
     /*  596646 */     GIR_EraseRootFromParent_Done,
     /*  596647 */   // Label 9700: @596647
     /*  596647 */   GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(596722), // Rule ID 4652 //
     /*  596652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  596663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  596666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  596669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596698 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  596701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596720 */     GIR_RootConstrainSelectedInstOperands,
     /*  596721 */     // GIR_Coverage, 4652,
     /*  596721 */     GIR_EraseRootFromParent_Done,
     /*  596722 */   // Label 9701: @596722
     /*  596722 */   GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(596797), // Rule ID 4653 //
     /*  596727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  596738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  596741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  596744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596773 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  596776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596795 */     GIR_RootConstrainSelectedInstOperands,
     /*  596796 */     // GIR_Coverage, 4653,
     /*  596796 */     GIR_EraseRootFromParent_Done,
     /*  596797 */   // Label 9702: @596797
     /*  596797 */   GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(596872), // Rule ID 4656 //
     /*  596802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  596813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  596816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  596819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  596851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596870 */     GIR_RootConstrainSelectedInstOperands,
     /*  596871 */     // GIR_Coverage, 4656,
     /*  596871 */     GIR_EraseRootFromParent_Done,
     /*  596872 */   // Label 9703: @596872
     /*  596872 */   GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(596947), // Rule ID 4657 //
     /*  596877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  596888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  596891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  596894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596923 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  596926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596945 */     GIR_RootConstrainSelectedInstOperands,
     /*  596946 */     // GIR_Coverage, 4657,
     /*  596946 */     GIR_EraseRootFromParent_Done,
     /*  596947 */   // Label 9704: @596947
     /*  596947 */   GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(597022), // Rule ID 4660 //
     /*  596952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  596963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  596966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  596969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596998 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597020 */     GIR_RootConstrainSelectedInstOperands,
     /*  597021 */     // GIR_Coverage, 4660,
     /*  597021 */     GIR_EraseRootFromParent_Done,
     /*  597022 */   // Label 9705: @597022
     /*  597022 */   GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(597097), // Rule ID 4661 //
     /*  597027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  597038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  597041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  597044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597073 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597095 */     GIR_RootConstrainSelectedInstOperands,
     /*  597096 */     // GIR_Coverage, 4661,
     /*  597096 */     GIR_EraseRootFromParent_Done,
     /*  597097 */   // Label 9706: @597097
     /*  597097 */   GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(597172), // Rule ID 4664 //
     /*  597102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  597113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  597116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  597119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597148 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  597151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597170 */     GIR_RootConstrainSelectedInstOperands,
     /*  597171 */     // GIR_Coverage, 4664,
     /*  597171 */     GIR_EraseRootFromParent_Done,
     /*  597172 */   // Label 9707: @597172
     /*  597172 */   GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(597247), // Rule ID 4665 //
     /*  597177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  597188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  597191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  597194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597223 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  597226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597245 */     GIR_RootConstrainSelectedInstOperands,
     /*  597246 */     // GIR_Coverage, 4665,
     /*  597246 */     GIR_EraseRootFromParent_Done,
     /*  597247 */   // Label 9708: @597247
     /*  597247 */   GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(597322), // Rule ID 4668 //
     /*  597252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  597263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  597266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  597269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597298 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  597301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597320 */     GIR_RootConstrainSelectedInstOperands,
     /*  597321 */     // GIR_Coverage, 4668,
     /*  597321 */     GIR_EraseRootFromParent_Done,
     /*  597322 */   // Label 9709: @597322
     /*  597322 */   GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(597397), // Rule ID 4669 //
     /*  597327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  597338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  597341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  597344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597373 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  597376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597395 */     GIR_RootConstrainSelectedInstOperands,
     /*  597396 */     // GIR_Coverage, 4669,
     /*  597396 */     GIR_EraseRootFromParent_Done,
     /*  597397 */   // Label 9710: @597397
     /*  597397 */   GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(597472), // Rule ID 4672 //
     /*  597402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  597413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  597416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  597419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597448 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  597451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597470 */     GIR_RootConstrainSelectedInstOperands,
     /*  597471 */     // GIR_Coverage, 4672,
     /*  597471 */     GIR_EraseRootFromParent_Done,
     /*  597472 */   // Label 9711: @597472
     /*  597472 */   GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(597547), // Rule ID 4673 //
     /*  597477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  597488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  597491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  597494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597523 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  597526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597545 */     GIR_RootConstrainSelectedInstOperands,
     /*  597546 */     // GIR_Coverage, 4673,
     /*  597546 */     GIR_EraseRootFromParent_Done,
     /*  597547 */   // Label 9712: @597547
     /*  597547 */   GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(597622), // Rule ID 4676 //
     /*  597552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  597563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  597566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  597569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597620 */     GIR_RootConstrainSelectedInstOperands,
     /*  597621 */     // GIR_Coverage, 4676,
     /*  597621 */     GIR_EraseRootFromParent_Done,
     /*  597622 */   // Label 9713: @597622
     /*  597622 */   GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(597697), // Rule ID 4677 //
     /*  597627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  597638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  597641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  597644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597673 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597695 */     GIR_RootConstrainSelectedInstOperands,
     /*  597696 */     // GIR_Coverage, 4677,
     /*  597696 */     GIR_EraseRootFromParent_Done,
     /*  597697 */   // Label 9714: @597697
     /*  597697 */   GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(597772), // Rule ID 4680 //
     /*  597702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  597713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  597716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  597719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597748 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597770 */     GIR_RootConstrainSelectedInstOperands,
     /*  597771 */     // GIR_Coverage, 4680,
     /*  597771 */     GIR_EraseRootFromParent_Done,
     /*  597772 */   // Label 9715: @597772
     /*  597772 */   GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(597847), // Rule ID 4681 //
     /*  597777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  597788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  597791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  597794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597823 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597845 */     GIR_RootConstrainSelectedInstOperands,
     /*  597846 */     // GIR_Coverage, 4681,
     /*  597846 */     GIR_EraseRootFromParent_Done,
     /*  597847 */   // Label 9716: @597847
     /*  597847 */   GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(597922), // Rule ID 4684 //
     /*  597852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  597863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  597866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  597869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597898 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  597901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597920 */     GIR_RootConstrainSelectedInstOperands,
     /*  597921 */     // GIR_Coverage, 4684,
     /*  597921 */     GIR_EraseRootFromParent_Done,
     /*  597922 */   // Label 9717: @597922
     /*  597922 */   GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(597997), // Rule ID 4685 //
     /*  597927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  597938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  597941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  597944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597973 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  597976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597995 */     GIR_RootConstrainSelectedInstOperands,
     /*  597996 */     // GIR_Coverage, 4685,
     /*  597996 */     GIR_EraseRootFromParent_Done,
     /*  597997 */   // Label 9718: @597997
     /*  597997 */   GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(598072), // Rule ID 4688 //
     /*  598002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  598005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  598013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  598016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  598019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  598022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598048 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  598048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  598051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598070 */     GIR_RootConstrainSelectedInstOperands,
     /*  598071 */     // GIR_Coverage, 4688,
     /*  598071 */     GIR_EraseRootFromParent_Done,
     /*  598072 */   // Label 9719: @598072
     /*  598072 */   GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(598147), // Rule ID 4689 //
     /*  598077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  598080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  598088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  598091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  598094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  598097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598123 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  598123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  598126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598145 */     GIR_RootConstrainSelectedInstOperands,
     /*  598146 */     // GIR_Coverage, 4689,
     /*  598146 */     GIR_EraseRootFromParent_Done,
     /*  598147 */   // Label 9720: @598147
     /*  598147 */   GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(598222), // Rule ID 4692 //
     /*  598152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  598155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  598163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  598166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  598169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  598172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598198 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  598198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  598201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598220 */     GIR_RootConstrainSelectedInstOperands,
     /*  598221 */     // GIR_Coverage, 4692,
     /*  598221 */     GIR_EraseRootFromParent_Done,
     /*  598222 */   // Label 9721: @598222
     /*  598222 */   GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(598297), // Rule ID 4693 //
     /*  598227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  598230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  598238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  598241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  598244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  598247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598273 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  598273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  598276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598295 */     GIR_RootConstrainSelectedInstOperands,
     /*  598296 */     // GIR_Coverage, 4693,
     /*  598296 */     GIR_EraseRootFromParent_Done,
     /*  598297 */   // Label 9722: @598297
     /*  598297 */   GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(598372), // Rule ID 4696 //
     /*  598302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  598305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  598313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  598316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  598319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  598322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598348 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  598348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  598351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598370 */     GIR_RootConstrainSelectedInstOperands,
     /*  598371 */     // GIR_Coverage, 4696,
     /*  598371 */     GIR_EraseRootFromParent_Done,
     /*  598372 */   // Label 9723: @598372
     /*  598372 */   GIM_Try, /*On fail goto*//*Label 9724*/ GIMT_Encode4(598447), // Rule ID 4697 //
     /*  598377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  598380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  598388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  598391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  598394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  598397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598423 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  598423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  598426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598445 */     GIR_RootConstrainSelectedInstOperands,
     /*  598446 */     // GIR_Coverage, 4697,
     /*  598446 */     GIR_EraseRootFromParent_Done,
     /*  598447 */   // Label 9724: @598447
     /*  598447 */   GIM_Try, /*On fail goto*//*Label 9725*/ GIMT_Encode4(598522), // Rule ID 4702 //
     /*  598452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  598463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  598466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  598469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  598472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598498 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  598501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598520 */     GIR_RootConstrainSelectedInstOperands,
     /*  598521 */     // GIR_Coverage, 4702,
     /*  598521 */     GIR_EraseRootFromParent_Done,
     /*  598522 */   // Label 9725: @598522
     /*  598522 */   GIM_Try, /*On fail goto*//*Label 9726*/ GIMT_Encode4(598597), // Rule ID 4703 //
     /*  598527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  598538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  598541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  598544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  598547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598573 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  598576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598595 */     GIR_RootConstrainSelectedInstOperands,
     /*  598596 */     // GIR_Coverage, 4703,
     /*  598596 */     GIR_EraseRootFromParent_Done,
     /*  598597 */   // Label 9726: @598597
     /*  598597 */   GIM_Try, /*On fail goto*//*Label 9727*/ GIMT_Encode4(598672), // Rule ID 4712 //
     /*  598602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  598613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  598616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  598619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  598622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598648 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  598651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598670 */     GIR_RootConstrainSelectedInstOperands,
     /*  598671 */     // GIR_Coverage, 4712,
     /*  598671 */     GIR_EraseRootFromParent_Done,
     /*  598672 */   // Label 9727: @598672
     /*  598672 */   GIM_Try, /*On fail goto*//*Label 9728*/ GIMT_Encode4(598747), // Rule ID 4713 //
     /*  598677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  598688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  598691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  598694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  598697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598723 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  598726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598745 */     GIR_RootConstrainSelectedInstOperands,
     /*  598746 */     // GIR_Coverage, 4713,
     /*  598746 */     GIR_EraseRootFromParent_Done,
     /*  598747 */   // Label 9728: @598747
     /*  598747 */   GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(598822), // Rule ID 4722 //
     /*  598752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  598763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  598766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  598769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  598772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  598801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598820 */     GIR_RootConstrainSelectedInstOperands,
     /*  598821 */     // GIR_Coverage, 4722,
     /*  598821 */     GIR_EraseRootFromParent_Done,
     /*  598822 */   // Label 9729: @598822
     /*  598822 */   GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(598897), // Rule ID 4723 //
     /*  598827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  598838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  598841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  598844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  598847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598873 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  598876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598895 */     GIR_RootConstrainSelectedInstOperands,
     /*  598896 */     // GIR_Coverage, 4723,
     /*  598896 */     GIR_EraseRootFromParent_Done,
     /*  598897 */   // Label 9730: @598897
     /*  598897 */   GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(598972), // Rule ID 4732 //
     /*  598902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  598913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  598916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  598919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  598922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598948 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  598951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598970 */     GIR_RootConstrainSelectedInstOperands,
     /*  598971 */     // GIR_Coverage, 4732,
     /*  598971 */     GIR_EraseRootFromParent_Done,
     /*  598972 */   // Label 9731: @598972
     /*  598972 */   GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(599047), // Rule ID 4733 //
     /*  598977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  598988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  598991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  598994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  598997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599023 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599045 */     GIR_RootConstrainSelectedInstOperands,
     /*  599046 */     // GIR_Coverage, 4733,
     /*  599046 */     GIR_EraseRootFromParent_Done,
     /*  599047 */   // Label 9732: @599047
     /*  599047 */   GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(599122), // Rule ID 4742 //
     /*  599052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  599063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  599066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  599069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  599072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599098 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599120 */     GIR_RootConstrainSelectedInstOperands,
     /*  599121 */     // GIR_Coverage, 4742,
     /*  599121 */     GIR_EraseRootFromParent_Done,
     /*  599122 */   // Label 9733: @599122
     /*  599122 */   GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(599197), // Rule ID 4743 //
     /*  599127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  599138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  599141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  599144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  599147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599173 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599195 */     GIR_RootConstrainSelectedInstOperands,
     /*  599196 */     // GIR_Coverage, 4743,
     /*  599196 */     GIR_EraseRootFromParent_Done,
     /*  599197 */   // Label 9734: @599197
     /*  599197 */   GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(599272), // Rule ID 4752 //
     /*  599202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  599213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  599216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  599219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  599222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599248 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599270 */     GIR_RootConstrainSelectedInstOperands,
     /*  599271 */     // GIR_Coverage, 4752,
     /*  599271 */     GIR_EraseRootFromParent_Done,
     /*  599272 */   // Label 9735: @599272
     /*  599272 */   GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(599347), // Rule ID 4753 //
     /*  599277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  599288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  599291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  599294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  599297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599323 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599345 */     GIR_RootConstrainSelectedInstOperands,
     /*  599346 */     // GIR_Coverage, 4753,
     /*  599346 */     GIR_EraseRootFromParent_Done,
     /*  599347 */   // Label 9736: @599347
     /*  599347 */   GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(599422), // Rule ID 4762 //
     /*  599352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  599363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  599366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  599369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  599372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599398 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  599401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599420 */     GIR_RootConstrainSelectedInstOperands,
     /*  599421 */     // GIR_Coverage, 4762,
     /*  599421 */     GIR_EraseRootFromParent_Done,
     /*  599422 */   // Label 9737: @599422
     /*  599422 */   GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(599497), // Rule ID 4763 //
     /*  599427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  599438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  599441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  599444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  599447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599473 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  599476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599495 */     GIR_RootConstrainSelectedInstOperands,
     /*  599496 */     // GIR_Coverage, 4763,
     /*  599496 */     GIR_EraseRootFromParent_Done,
     /*  599497 */   // Label 9738: @599497
     /*  599497 */   GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(599572), // Rule ID 4772 //
     /*  599502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  599513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  599516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  599519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  599522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599548 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599570 */     GIR_RootConstrainSelectedInstOperands,
     /*  599571 */     // GIR_Coverage, 4772,
     /*  599571 */     GIR_EraseRootFromParent_Done,
     /*  599572 */   // Label 9739: @599572
     /*  599572 */   GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(599647), // Rule ID 4773 //
     /*  599577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  599588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  599591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  599594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  599597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599623 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599645 */     GIR_RootConstrainSelectedInstOperands,
     /*  599646 */     // GIR_Coverage, 4773,
     /*  599646 */     GIR_EraseRootFromParent_Done,
     /*  599647 */   // Label 9740: @599647
     /*  599647 */   GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(599722), // Rule ID 4782 //
     /*  599652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  599663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  599666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  599669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  599672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599720 */     GIR_RootConstrainSelectedInstOperands,
     /*  599721 */     // GIR_Coverage, 4782,
     /*  599721 */     GIR_EraseRootFromParent_Done,
     /*  599722 */   // Label 9741: @599722
     /*  599722 */   GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(599797), // Rule ID 4783 //
     /*  599727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  599738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  599741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  599744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  599747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599795 */     GIR_RootConstrainSelectedInstOperands,
     /*  599796 */     // GIR_Coverage, 4783,
     /*  599796 */     GIR_EraseRootFromParent_Done,
     /*  599797 */   // Label 9742: @599797
     /*  599797 */   GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(599872), // Rule ID 4792 //
     /*  599802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  599813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  599816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  599819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  599822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599848 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599870 */     GIR_RootConstrainSelectedInstOperands,
     /*  599871 */     // GIR_Coverage, 4792,
     /*  599871 */     GIR_EraseRootFromParent_Done,
     /*  599872 */   // Label 9743: @599872
     /*  599872 */   GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(599947), // Rule ID 4793 //
     /*  599877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  599888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  599891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  599894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  599897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599923 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599945 */     GIR_RootConstrainSelectedInstOperands,
     /*  599946 */     // GIR_Coverage, 4793,
     /*  599946 */     GIR_EraseRootFromParent_Done,
     /*  599947 */   // Label 9744: @599947
     /*  599947 */   GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(600022), // Rule ID 4802 //
     /*  599952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  599963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  599966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  599969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  599972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599998 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  600001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600020 */     GIR_RootConstrainSelectedInstOperands,
     /*  600021 */     // GIR_Coverage, 4802,
     /*  600021 */     GIR_EraseRootFromParent_Done,
     /*  600022 */   // Label 9745: @600022
     /*  600022 */   GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(600097), // Rule ID 4803 //
     /*  600027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  600038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  600041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  600044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  600047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600073 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  600073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  600076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600095 */     GIR_RootConstrainSelectedInstOperands,
     /*  600096 */     // GIR_Coverage, 4803,
     /*  600096 */     GIR_EraseRootFromParent_Done,
     /*  600097 */   // Label 9746: @600097
     /*  600097 */   GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(600172), // Rule ID 4812 //
     /*  600102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  600105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  600113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  600116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  600119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  600122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600148 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  600148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  600151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600170 */     GIR_RootConstrainSelectedInstOperands,
     /*  600171 */     // GIR_Coverage, 4812,
     /*  600171 */     GIR_EraseRootFromParent_Done,
     /*  600172 */   // Label 9747: @600172
     /*  600172 */   GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(600247), // Rule ID 4813 //
     /*  600177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  600180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  600188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  600191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  600194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  600197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600223 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  600226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600245 */     GIR_RootConstrainSelectedInstOperands,
     /*  600246 */     // GIR_Coverage, 4813,
     /*  600246 */     GIR_EraseRootFromParent_Done,
     /*  600247 */   // Label 9748: @600247
     /*  600247 */   GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(600322), // Rule ID 4822 //
     /*  600252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  600255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  600263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  600266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  600269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  600272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  600298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  600301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600320 */     GIR_RootConstrainSelectedInstOperands,
     /*  600321 */     // GIR_Coverage, 4822,
     /*  600321 */     GIR_EraseRootFromParent_Done,
     /*  600322 */   // Label 9749: @600322
     /*  600322 */   GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(600397), // Rule ID 4823 //
     /*  600327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  600330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  600338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  600341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  600344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  600347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600373 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  600376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600395 */     GIR_RootConstrainSelectedInstOperands,
     /*  600396 */     // GIR_Coverage, 4823,
     /*  600396 */     GIR_EraseRootFromParent_Done,
     /*  600397 */   // Label 9750: @600397
     /*  600397 */   GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(600472), // Rule ID 4832 //
     /*  600402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  600405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  600413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  600416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  600419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  600422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  600448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  600451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600470 */     GIR_RootConstrainSelectedInstOperands,
     /*  600471 */     // GIR_Coverage, 4832,
     /*  600471 */     GIR_EraseRootFromParent_Done,
     /*  600472 */   // Label 9751: @600472
     /*  600472 */   GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(600547), // Rule ID 4833 //
     /*  600477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  600480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  600488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  600491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  600494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  600497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600523 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  600526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600545 */     GIR_RootConstrainSelectedInstOperands,
     /*  600546 */     // GIR_Coverage, 4833,
     /*  600546 */     GIR_EraseRootFromParent_Done,
     /*  600547 */   // Label 9752: @600547
     /*  600547 */   GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(600622), // Rule ID 4842 //
     /*  600552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  600555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  600563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  600566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  600569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  600572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600598 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  600598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  600601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600620 */     GIR_RootConstrainSelectedInstOperands,
     /*  600621 */     // GIR_Coverage, 4842,
     /*  600621 */     GIR_EraseRootFromParent_Done,
     /*  600622 */   // Label 9753: @600622
     /*  600622 */   GIM_Try, /*On fail goto*//*Label 9754*/ GIMT_Encode4(600697), // Rule ID 4843 //
     /*  600627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  600630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  600638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  600641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  600644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  600647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600673 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  600676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600695 */     GIR_RootConstrainSelectedInstOperands,
     /*  600696 */     // GIR_Coverage, 4843,
     /*  600696 */     GIR_EraseRootFromParent_Done,
     /*  600697 */   // Label 9754: @600697
     /*  600697 */   GIM_Try, /*On fail goto*//*Label 9755*/ GIMT_Encode4(600772), // Rule ID 4850 //
     /*  600702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  600713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  600716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  600719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600748 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  600751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600770 */     GIR_RootConstrainSelectedInstOperands,
     /*  600771 */     // GIR_Coverage, 4850,
     /*  600771 */     GIR_EraseRootFromParent_Done,
     /*  600772 */   // Label 9755: @600772
     /*  600772 */   GIM_Try, /*On fail goto*//*Label 9756*/ GIMT_Encode4(600847), // Rule ID 4851 //
     /*  600777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  600788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  600791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  600794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600823 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  600826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600845 */     GIR_RootConstrainSelectedInstOperands,
     /*  600846 */     // GIR_Coverage, 4851,
     /*  600846 */     GIR_EraseRootFromParent_Done,
     /*  600847 */   // Label 9756: @600847
     /*  600847 */   GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(600922), // Rule ID 4854 //
     /*  600852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  600863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  600866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  600869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600898 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  600901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600920 */     GIR_RootConstrainSelectedInstOperands,
     /*  600921 */     // GIR_Coverage, 4854,
     /*  600921 */     GIR_EraseRootFromParent_Done,
     /*  600922 */   // Label 9757: @600922
     /*  600922 */   GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(600997), // Rule ID 4855 //
     /*  600927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  600938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  600941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  600944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600973 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  600976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600995 */     GIR_RootConstrainSelectedInstOperands,
     /*  600996 */     // GIR_Coverage, 4855,
     /*  600996 */     GIR_EraseRootFromParent_Done,
     /*  600997 */   // Label 9758: @600997
     /*  600997 */   GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(601072), // Rule ID 4858 //
     /*  601002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  601013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  601016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  601019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601048 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  601048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601070 */     GIR_RootConstrainSelectedInstOperands,
     /*  601071 */     // GIR_Coverage, 4858,
     /*  601071 */     GIR_EraseRootFromParent_Done,
     /*  601072 */   // Label 9759: @601072
     /*  601072 */   GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(601147), // Rule ID 4859 //
     /*  601077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  601088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  601091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  601094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601123 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  601123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601145 */     GIR_RootConstrainSelectedInstOperands,
     /*  601146 */     // GIR_Coverage, 4859,
     /*  601146 */     GIR_EraseRootFromParent_Done,
     /*  601147 */   // Label 9760: @601147
     /*  601147 */   GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(601222), // Rule ID 4862 //
     /*  601152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  601163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  601166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  601169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  601198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601220 */     GIR_RootConstrainSelectedInstOperands,
     /*  601221 */     // GIR_Coverage, 4862,
     /*  601221 */     GIR_EraseRootFromParent_Done,
     /*  601222 */   // Label 9761: @601222
     /*  601222 */   GIM_Try, /*On fail goto*//*Label 9762*/ GIMT_Encode4(601297), // Rule ID 4863 //
     /*  601227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  601238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  601241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  601244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601273 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  601273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601295 */     GIR_RootConstrainSelectedInstOperands,
     /*  601296 */     // GIR_Coverage, 4863,
     /*  601296 */     GIR_EraseRootFromParent_Done,
     /*  601297 */   // Label 9762: @601297
     /*  601297 */   GIM_Try, /*On fail goto*//*Label 9763*/ GIMT_Encode4(601372), // Rule ID 4866 //
     /*  601302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  601313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  601316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  601319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601348 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  601348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  601351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601370 */     GIR_RootConstrainSelectedInstOperands,
     /*  601371 */     // GIR_Coverage, 4866,
     /*  601371 */     GIR_EraseRootFromParent_Done,
     /*  601372 */   // Label 9763: @601372
     /*  601372 */   GIM_Try, /*On fail goto*//*Label 9764*/ GIMT_Encode4(601447), // Rule ID 4867 //
     /*  601377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  601388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  601391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  601394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601423 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  601423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  601426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601445 */     GIR_RootConstrainSelectedInstOperands,
     /*  601446 */     // GIR_Coverage, 4867,
     /*  601446 */     GIR_EraseRootFromParent_Done,
     /*  601447 */   // Label 9764: @601447
     /*  601447 */   GIM_Try, /*On fail goto*//*Label 9765*/ GIMT_Encode4(601522), // Rule ID 4870 //
     /*  601452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  601463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  601466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  601469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601498 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  601498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601520 */     GIR_RootConstrainSelectedInstOperands,
     /*  601521 */     // GIR_Coverage, 4870,
     /*  601521 */     GIR_EraseRootFromParent_Done,
     /*  601522 */   // Label 9765: @601522
     /*  601522 */   GIM_Try, /*On fail goto*//*Label 9766*/ GIMT_Encode4(601597), // Rule ID 4871 //
     /*  601527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  601538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  601541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  601544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601573 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  601573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601595 */     GIR_RootConstrainSelectedInstOperands,
     /*  601596 */     // GIR_Coverage, 4871,
     /*  601596 */     GIR_EraseRootFromParent_Done,
     /*  601597 */   // Label 9766: @601597
     /*  601597 */   GIM_Try, /*On fail goto*//*Label 9767*/ GIMT_Encode4(601672), // Rule ID 4874 //
     /*  601602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  601613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  601616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  601619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601648 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  601651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601670 */     GIR_RootConstrainSelectedInstOperands,
     /*  601671 */     // GIR_Coverage, 4874,
     /*  601671 */     GIR_EraseRootFromParent_Done,
     /*  601672 */   // Label 9767: @601672
     /*  601672 */   GIM_Try, /*On fail goto*//*Label 9768*/ GIMT_Encode4(601747), // Rule ID 4875 //
     /*  601677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  601688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  601691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  601694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601723 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  601726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601745 */     GIR_RootConstrainSelectedInstOperands,
     /*  601746 */     // GIR_Coverage, 4875,
     /*  601746 */     GIR_EraseRootFromParent_Done,
     /*  601747 */   // Label 9768: @601747
     /*  601747 */   GIM_Try, /*On fail goto*//*Label 9769*/ GIMT_Encode4(601822), // Rule ID 4878 //
     /*  601752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  601763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  601766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  601769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601798 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601820 */     GIR_RootConstrainSelectedInstOperands,
     /*  601821 */     // GIR_Coverage, 4878,
     /*  601821 */     GIR_EraseRootFromParent_Done,
     /*  601822 */   // Label 9769: @601822
     /*  601822 */   GIM_Try, /*On fail goto*//*Label 9770*/ GIMT_Encode4(601897), // Rule ID 4879 //
     /*  601827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  601838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  601841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  601844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601873 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601895 */     GIR_RootConstrainSelectedInstOperands,
     /*  601896 */     // GIR_Coverage, 4879,
     /*  601896 */     GIR_EraseRootFromParent_Done,
     /*  601897 */   // Label 9770: @601897
     /*  601897 */   GIM_Try, /*On fail goto*//*Label 9771*/ GIMT_Encode4(601972), // Rule ID 4882 //
     /*  601902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  601913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  601916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  601919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601970 */     GIR_RootConstrainSelectedInstOperands,
     /*  601971 */     // GIR_Coverage, 4882,
     /*  601971 */     GIR_EraseRootFromParent_Done,
     /*  601972 */   // Label 9771: @601972
     /*  601972 */   GIM_Try, /*On fail goto*//*Label 9772*/ GIMT_Encode4(602047), // Rule ID 4883 //
     /*  601977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  601988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  601991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  601994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  602023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  602026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602045 */     GIR_RootConstrainSelectedInstOperands,
     /*  602046 */     // GIR_Coverage, 4883,
     /*  602046 */     GIR_EraseRootFromParent_Done,
     /*  602047 */   // Label 9772: @602047
     /*  602047 */   GIM_Try, /*On fail goto*//*Label 9773*/ GIMT_Encode4(602122), // Rule ID 4886 //
     /*  602052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  602063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  602066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  602069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602098 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  602098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  602101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602120 */     GIR_RootConstrainSelectedInstOperands,
     /*  602121 */     // GIR_Coverage, 4886,
     /*  602121 */     GIR_EraseRootFromParent_Done,
     /*  602122 */   // Label 9773: @602122
     /*  602122 */   GIM_Try, /*On fail goto*//*Label 9774*/ GIMT_Encode4(602197), // Rule ID 4887 //
     /*  602127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  602138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  602141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  602144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602173 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  602173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  602176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602195 */     GIR_RootConstrainSelectedInstOperands,
     /*  602196 */     // GIR_Coverage, 4887,
     /*  602196 */     GIR_EraseRootFromParent_Done,
     /*  602197 */   // Label 9774: @602197
     /*  602197 */   GIM_Try, /*On fail goto*//*Label 9775*/ GIMT_Encode4(602272), // Rule ID 4890 //
     /*  602202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  602213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  602216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  602219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  602248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  602251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602270 */     GIR_RootConstrainSelectedInstOperands,
     /*  602271 */     // GIR_Coverage, 4890,
     /*  602271 */     GIR_EraseRootFromParent_Done,
     /*  602272 */   // Label 9775: @602272
     /*  602272 */   GIM_Try, /*On fail goto*//*Label 9776*/ GIMT_Encode4(602347), // Rule ID 4891 //
     /*  602277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  602288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  602291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  602294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602323 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  602323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  602326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602345 */     GIR_RootConstrainSelectedInstOperands,
     /*  602346 */     // GIR_Coverage, 4891,
     /*  602346 */     GIR_EraseRootFromParent_Done,
     /*  602347 */   // Label 9776: @602347
     /*  602347 */   GIM_Try, /*On fail goto*//*Label 9777*/ GIMT_Encode4(602422), // Rule ID 4894 //
     /*  602352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  602363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  602366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  602369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602398 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  602401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602420 */     GIR_RootConstrainSelectedInstOperands,
     /*  602421 */     // GIR_Coverage, 4894,
     /*  602421 */     GIR_EraseRootFromParent_Done,
     /*  602422 */   // Label 9777: @602422
     /*  602422 */   GIM_Try, /*On fail goto*//*Label 9778*/ GIMT_Encode4(602497), // Rule ID 4895 //
     /*  602427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  602438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  602441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  602444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602473 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  602476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602495 */     GIR_RootConstrainSelectedInstOperands,
     /*  602496 */     // GIR_Coverage, 4895,
     /*  602496 */     GIR_EraseRootFromParent_Done,
     /*  602497 */   // Label 9778: @602497
     /*  602497 */   GIM_Try, /*On fail goto*//*Label 9779*/ GIMT_Encode4(602572), // Rule ID 4898 //
     /*  602502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  602513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  602516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  602519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602548 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  602551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602570 */     GIR_RootConstrainSelectedInstOperands,
     /*  602571 */     // GIR_Coverage, 4898,
     /*  602571 */     GIR_EraseRootFromParent_Done,
     /*  602572 */   // Label 9779: @602572
     /*  602572 */   GIM_Try, /*On fail goto*//*Label 9780*/ GIMT_Encode4(602647), // Rule ID 4899 //
     /*  602577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  602588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  602591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  602594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  602626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602645 */     GIR_RootConstrainSelectedInstOperands,
     /*  602646 */     // GIR_Coverage, 4899,
     /*  602646 */     GIR_EraseRootFromParent_Done,
     /*  602647 */   // Label 9780: @602647
     /*  602647 */   GIM_Try, /*On fail goto*//*Label 9781*/ GIMT_Encode4(602722), // Rule ID 4902 //
     /*  602652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  602663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  602666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  602669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602698 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  602701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602720 */     GIR_RootConstrainSelectedInstOperands,
     /*  602721 */     // GIR_Coverage, 4902,
     /*  602721 */     GIR_EraseRootFromParent_Done,
     /*  602722 */   // Label 9781: @602722
     /*  602722 */   GIM_Try, /*On fail goto*//*Label 9782*/ GIMT_Encode4(602797), // Rule ID 4903 //
     /*  602727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  602738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  602741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  602744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602773 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  602776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602795 */     GIR_RootConstrainSelectedInstOperands,
     /*  602796 */     // GIR_Coverage, 4903,
     /*  602796 */     GIR_EraseRootFromParent_Done,
     /*  602797 */   // Label 9782: @602797
     /*  602797 */   GIM_Try, /*On fail goto*//*Label 9783*/ GIMT_Encode4(602872), // Rule ID 4906 //
     /*  602802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  602813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  602816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  602819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602848 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  602851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602870 */     GIR_RootConstrainSelectedInstOperands,
     /*  602871 */     // GIR_Coverage, 4906,
     /*  602871 */     GIR_EraseRootFromParent_Done,
     /*  602872 */   // Label 9783: @602872
     /*  602872 */   GIM_Try, /*On fail goto*//*Label 9784*/ GIMT_Encode4(602947), // Rule ID 4907 //
     /*  602877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  602888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  602891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  602894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602923 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  602926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602945 */     GIR_RootConstrainSelectedInstOperands,
     /*  602946 */     // GIR_Coverage, 4907,
     /*  602946 */     GIR_EraseRootFromParent_Done,
     /*  602947 */   // Label 9784: @602947
     /*  602947 */   GIM_Try, /*On fail goto*//*Label 9785*/ GIMT_Encode4(603019), // Rule ID 5260 //
     /*  602952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  602966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  602969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  602972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  602998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  603001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603017 */     GIR_RootConstrainSelectedInstOperands,
     /*  603018 */     // GIR_Coverage, 5260,
     /*  603018 */     GIR_EraseRootFromParent_Done,
     /*  603019 */   // Label 9785: @603019
     /*  603019 */   GIM_Try, /*On fail goto*//*Label 9786*/ GIMT_Encode4(603091), // Rule ID 5261 //
     /*  603024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  603038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  603041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603070 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  603073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603089 */     GIR_RootConstrainSelectedInstOperands,
     /*  603090 */     // GIR_Coverage, 5261,
     /*  603090 */     GIR_EraseRootFromParent_Done,
     /*  603091 */   // Label 9786: @603091
     /*  603091 */   GIM_Try, /*On fail goto*//*Label 9787*/ GIMT_Encode4(603163), // Rule ID 5262 //
     /*  603096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  603107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  603110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  603113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  603116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603142 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603161 */     GIR_RootConstrainSelectedInstOperands,
     /*  603162 */     // GIR_Coverage, 5262,
     /*  603162 */     GIR_EraseRootFromParent_Done,
     /*  603163 */   // Label 9787: @603163
     /*  603163 */   GIM_Try, /*On fail goto*//*Label 9788*/ GIMT_Encode4(603235), // Rule ID 5263 //
     /*  603168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  603179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  603182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  603185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  603188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603214 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603233 */     GIR_RootConstrainSelectedInstOperands,
     /*  603234 */     // GIR_Coverage, 5263,
     /*  603234 */     GIR_EraseRootFromParent_Done,
     /*  603235 */   // Label 9788: @603235
     /*  603235 */   GIM_Try, /*On fail goto*//*Label 9789*/ GIMT_Encode4(603307), // Rule ID 5264 //
     /*  603240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  603254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  603257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603286 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  603286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  603289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603305 */     GIR_RootConstrainSelectedInstOperands,
     /*  603306 */     // GIR_Coverage, 5264,
     /*  603306 */     GIR_EraseRootFromParent_Done,
     /*  603307 */   // Label 9789: @603307
     /*  603307 */   GIM_Try, /*On fail goto*//*Label 9790*/ GIMT_Encode4(603379), // Rule ID 5265 //
     /*  603312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  603326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  603329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  603358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  603361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603377 */     GIR_RootConstrainSelectedInstOperands,
     /*  603378 */     // GIR_Coverage, 5265,
     /*  603378 */     GIR_EraseRootFromParent_Done,
     /*  603379 */   // Label 9790: @603379
     /*  603379 */   GIM_Try, /*On fail goto*//*Label 9791*/ GIMT_Encode4(603451), // Rule ID 5266 //
     /*  603384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  603398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  603401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603430 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  603430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603449 */     GIR_RootConstrainSelectedInstOperands,
     /*  603450 */     // GIR_Coverage, 5266,
     /*  603450 */     GIR_EraseRootFromParent_Done,
     /*  603451 */   // Label 9791: @603451
     /*  603451 */   GIM_Try, /*On fail goto*//*Label 9792*/ GIMT_Encode4(603523), // Rule ID 5267 //
     /*  603456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  603470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  603473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  603502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603521 */     GIR_RootConstrainSelectedInstOperands,
     /*  603522 */     // GIR_Coverage, 5267,
     /*  603522 */     GIR_EraseRootFromParent_Done,
     /*  603523 */   // Label 9792: @603523
     /*  603523 */   GIM_Try, /*On fail goto*//*Label 9793*/ GIMT_Encode4(603595), // Rule ID 5268 //
     /*  603528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  603542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  603545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603574 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  603574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603593 */     GIR_RootConstrainSelectedInstOperands,
     /*  603594 */     // GIR_Coverage, 5268,
     /*  603594 */     GIR_EraseRootFromParent_Done,
     /*  603595 */   // Label 9793: @603595
     /*  603595 */   GIM_Try, /*On fail goto*//*Label 9794*/ GIMT_Encode4(603667), // Rule ID 5269 //
     /*  603600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  603614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  603617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603646 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  603646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603665 */     GIR_RootConstrainSelectedInstOperands,
     /*  603666 */     // GIR_Coverage, 5269,
     /*  603666 */     GIR_EraseRootFromParent_Done,
     /*  603667 */   // Label 9794: @603667
     /*  603667 */   GIM_Try, /*On fail goto*//*Label 9795*/ GIMT_Encode4(603739), // Rule ID 5270 //
     /*  603672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  603683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  603686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  603689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  603692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603718 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603737 */     GIR_RootConstrainSelectedInstOperands,
     /*  603738 */     // GIR_Coverage, 5270,
     /*  603738 */     GIR_EraseRootFromParent_Done,
     /*  603739 */   // Label 9795: @603739
     /*  603739 */   GIM_Try, /*On fail goto*//*Label 9796*/ GIMT_Encode4(603811), // Rule ID 5271 //
     /*  603744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  603755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  603758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  603761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  603764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603790 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603809 */     GIR_RootConstrainSelectedInstOperands,
     /*  603810 */     // GIR_Coverage, 5271,
     /*  603810 */     GIR_EraseRootFromParent_Done,
     /*  603811 */   // Label 9796: @603811
     /*  603811 */   GIM_Try, /*On fail goto*//*Label 9797*/ GIMT_Encode4(603883), // Rule ID 5272 //
     /*  603816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  603827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  603830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  603833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  603836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603862 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  603862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603881 */     GIR_RootConstrainSelectedInstOperands,
     /*  603882 */     // GIR_Coverage, 5272,
     /*  603882 */     GIR_EraseRootFromParent_Done,
     /*  603883 */   // Label 9797: @603883
     /*  603883 */   GIM_Try, /*On fail goto*//*Label 9798*/ GIMT_Encode4(603955), // Rule ID 5273 //
     /*  603888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  603899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  603902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  603905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  603908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603934 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  603934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603953 */     GIR_RootConstrainSelectedInstOperands,
     /*  603954 */     // GIR_Coverage, 5273,
     /*  603954 */     GIR_EraseRootFromParent_Done,
     /*  603955 */   // Label 9798: @603955
     /*  603955 */   GIM_Try, /*On fail goto*//*Label 9799*/ GIMT_Encode4(604027), // Rule ID 5274 //
     /*  603960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  603974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  603977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604006 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  604006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  604009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604025 */     GIR_RootConstrainSelectedInstOperands,
     /*  604026 */     // GIR_Coverage, 5274,
     /*  604026 */     GIR_EraseRootFromParent_Done,
     /*  604027 */   // Label 9799: @604027
     /*  604027 */   GIM_Try, /*On fail goto*//*Label 9800*/ GIMT_Encode4(604099), // Rule ID 5275 //
     /*  604032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  604043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  604046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  604049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  604052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604078 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  604078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  604081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604097 */     GIR_RootConstrainSelectedInstOperands,
     /*  604098 */     // GIR_Coverage, 5275,
     /*  604098 */     GIR_EraseRootFromParent_Done,
     /*  604099 */   // Label 9800: @604099
     /*  604099 */   GIM_Try, /*On fail goto*//*Label 9801*/ GIMT_Encode4(604171), // Rule ID 5276 //
     /*  604104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  604107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  604115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  604118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  604121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  604124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604150 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  604150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  604153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  604169 */     GIR_RootConstrainSelectedInstOperands,
     /*  604170 */     // GIR_Coverage, 5276,
     /*  604170 */     GIR_EraseRootFromParent_Done,
     /*  604171 */   // Label 9801: @604171
     /*  604171 */   GIM_Try, /*On fail goto*//*Label 9802*/ GIMT_Encode4(604243), // Rule ID 5277 //
     /*  604176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  604179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  604187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  604190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  604193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  604196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604222 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  604222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  604225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  604241 */     GIR_RootConstrainSelectedInstOperands,
     /*  604242 */     // GIR_Coverage, 5277,
     /*  604242 */     GIR_EraseRootFromParent_Done,
     /*  604243 */   // Label 9802: @604243
     /*  604243 */   GIM_Try, /*On fail goto*//*Label 9803*/ GIMT_Encode4(604315), // Rule ID 5278 //
     /*  604248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  604262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  604265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604294 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  604294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604313 */     GIR_RootConstrainSelectedInstOperands,
     /*  604314 */     // GIR_Coverage, 5278,
     /*  604314 */     GIR_EraseRootFromParent_Done,
     /*  604315 */   // Label 9803: @604315
     /*  604315 */   GIM_Try, /*On fail goto*//*Label 9804*/ GIMT_Encode4(604387), // Rule ID 5279 //
     /*  604320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  604334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  604337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604366 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  604366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604385 */     GIR_RootConstrainSelectedInstOperands,
     /*  604386 */     // GIR_Coverage, 5279,
     /*  604386 */     GIR_EraseRootFromParent_Done,
     /*  604387 */   // Label 9804: @604387
     /*  604387 */   GIM_Try, /*On fail goto*//*Label 9805*/ GIMT_Encode4(604459), // Rule ID 5280 //
     /*  604392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  604406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  604409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604438 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  604438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604457 */     GIR_RootConstrainSelectedInstOperands,
     /*  604458 */     // GIR_Coverage, 5280,
     /*  604458 */     GIR_EraseRootFromParent_Done,
     /*  604459 */   // Label 9805: @604459
     /*  604459 */   GIM_Try, /*On fail goto*//*Label 9806*/ GIMT_Encode4(604531), // Rule ID 5281 //
     /*  604464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  604478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  604481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604510 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  604510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604529 */     GIR_RootConstrainSelectedInstOperands,
     /*  604530 */     // GIR_Coverage, 5281,
     /*  604530 */     GIR_EraseRootFromParent_Done,
     /*  604531 */   // Label 9806: @604531
     /*  604531 */   GIM_Try, /*On fail goto*//*Label 9807*/ GIMT_Encode4(604603), // Rule ID 5282 //
     /*  604536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  604547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  604550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  604553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  604556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604582 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  604582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604601 */     GIR_RootConstrainSelectedInstOperands,
     /*  604602 */     // GIR_Coverage, 5282,
     /*  604602 */     GIR_EraseRootFromParent_Done,
     /*  604603 */   // Label 9807: @604603
     /*  604603 */   GIM_Try, /*On fail goto*//*Label 9808*/ GIMT_Encode4(604675), // Rule ID 5283 //
     /*  604608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  604619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  604622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  604625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  604628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604654 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  604654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604673 */     GIR_RootConstrainSelectedInstOperands,
     /*  604674 */     // GIR_Coverage, 5283,
     /*  604674 */     GIR_EraseRootFromParent_Done,
     /*  604675 */   // Label 9808: @604675
     /*  604675 */   GIM_Try, /*On fail goto*//*Label 9809*/ GIMT_Encode4(604747), // Rule ID 5284 //
     /*  604680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604726 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  604726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604745 */     GIR_RootConstrainSelectedInstOperands,
     /*  604746 */     // GIR_Coverage, 5284,
     /*  604746 */     GIR_EraseRootFromParent_Done,
     /*  604747 */   // Label 9809: @604747
     /*  604747 */   GIM_Try, /*On fail goto*//*Label 9810*/ GIMT_Encode4(604819), // Rule ID 5285 //
     /*  604752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604798 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  604798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604817 */     GIR_RootConstrainSelectedInstOperands,
     /*  604818 */     // GIR_Coverage, 5285,
     /*  604818 */     GIR_EraseRootFromParent_Done,
     /*  604819 */   // Label 9810: @604819
     /*  604819 */   GIM_Try, /*On fail goto*//*Label 9811*/ GIMT_Encode4(604891), // Rule ID 5286 //
     /*  604824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604870 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  604870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604889 */     GIR_RootConstrainSelectedInstOperands,
     /*  604890 */     // GIR_Coverage, 5286,
     /*  604890 */     GIR_EraseRootFromParent_Done,
     /*  604891 */   // Label 9811: @604891
     /*  604891 */   GIM_Try, /*On fail goto*//*Label 9812*/ GIMT_Encode4(604963), // Rule ID 5287 //
     /*  604896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604942 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  604942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604961 */     GIR_RootConstrainSelectedInstOperands,
     /*  604962 */     // GIR_Coverage, 5287,
     /*  604962 */     GIR_EraseRootFromParent_Done,
     /*  604963 */   // Label 9812: @604963
     /*  604963 */   GIM_Try, /*On fail goto*//*Label 9813*/ GIMT_Encode4(605035), // Rule ID 5288 //
     /*  604968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605014 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  605014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605033 */     GIR_RootConstrainSelectedInstOperands,
     /*  605034 */     // GIR_Coverage, 5288,
     /*  605034 */     GIR_EraseRootFromParent_Done,
     /*  605035 */   // Label 9813: @605035
     /*  605035 */   GIM_Try, /*On fail goto*//*Label 9814*/ GIMT_Encode4(605107), // Rule ID 5289 //
     /*  605040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  605051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  605054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  605057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  605060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605086 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  605086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605105 */     GIR_RootConstrainSelectedInstOperands,
     /*  605106 */     // GIR_Coverage, 5289,
     /*  605106 */     GIR_EraseRootFromParent_Done,
     /*  605107 */   // Label 9814: @605107
     /*  605107 */   GIM_Try, /*On fail goto*//*Label 9815*/ GIMT_Encode4(605179), // Rule ID 5290 //
     /*  605112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  605126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  605129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605158 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  605158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  605161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605177 */     GIR_RootConstrainSelectedInstOperands,
     /*  605178 */     // GIR_Coverage, 5290,
     /*  605178 */     GIR_EraseRootFromParent_Done,
     /*  605179 */   // Label 9815: @605179
     /*  605179 */   GIM_Try, /*On fail goto*//*Label 9816*/ GIMT_Encode4(605251), // Rule ID 5291 //
     /*  605184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  605198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  605201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605230 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  605230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  605233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605249 */     GIR_RootConstrainSelectedInstOperands,
     /*  605250 */     // GIR_Coverage, 5291,
     /*  605250 */     GIR_EraseRootFromParent_Done,
     /*  605251 */   // Label 9816: @605251
     /*  605251 */   GIM_Try, /*On fail goto*//*Label 9817*/ GIMT_Encode4(605323), // Rule ID 5292 //
     /*  605256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  605270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  605273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  605302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  605305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605321 */     GIR_RootConstrainSelectedInstOperands,
     /*  605322 */     // GIR_Coverage, 5292,
     /*  605322 */     GIR_EraseRootFromParent_Done,
     /*  605323 */   // Label 9817: @605323
     /*  605323 */   GIM_Try, /*On fail goto*//*Label 9818*/ GIMT_Encode4(605395), // Rule ID 5293 //
     /*  605328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  605342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  605345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605374 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  605374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  605377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605393 */     GIR_RootConstrainSelectedInstOperands,
     /*  605394 */     // GIR_Coverage, 5293,
     /*  605394 */     GIR_EraseRootFromParent_Done,
     /*  605395 */   // Label 9818: @605395
     /*  605395 */   GIM_Try, /*On fail goto*//*Label 9819*/ GIMT_Encode4(605467), // Rule ID 5294 //
     /*  605400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  605411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  605414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  605417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  605420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605446 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  605446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605465 */     GIR_RootConstrainSelectedInstOperands,
     /*  605466 */     // GIR_Coverage, 5294,
     /*  605466 */     GIR_EraseRootFromParent_Done,
     /*  605467 */   // Label 9819: @605467
     /*  605467 */   GIM_Try, /*On fail goto*//*Label 9820*/ GIMT_Encode4(605539), // Rule ID 5295 //
     /*  605472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  605483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  605486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  605489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  605492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605518 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  605518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605537 */     GIR_RootConstrainSelectedInstOperands,
     /*  605538 */     // GIR_Coverage, 5295,
     /*  605538 */     GIR_EraseRootFromParent_Done,
     /*  605539 */   // Label 9820: @605539
     /*  605539 */   GIM_Try, /*On fail goto*//*Label 9821*/ GIMT_Encode4(605611), // Rule ID 5296 //
     /*  605544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  605547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  605558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  605561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605590 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  605590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  605593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605609 */     GIR_RootConstrainSelectedInstOperands,
     /*  605610 */     // GIR_Coverage, 5296,
     /*  605610 */     GIR_EraseRootFromParent_Done,
     /*  605611 */   // Label 9821: @605611
     /*  605611 */   GIM_Try, /*On fail goto*//*Label 9822*/ GIMT_Encode4(605683), // Rule ID 5297 //
     /*  605616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  605619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  605630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  605633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605662 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  605662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  605665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605681 */     GIR_RootConstrainSelectedInstOperands,
     /*  605682 */     // GIR_Coverage, 5297,
     /*  605682 */     GIR_EraseRootFromParent_Done,
     /*  605683 */   // Label 9822: @605683
     /*  605683 */   GIM_Try, /*On fail goto*//*Label 9823*/ GIMT_Encode4(605755), // Rule ID 5298 //
     /*  605688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  605691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  605702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  605705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605734 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  605734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  605737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605753 */     GIR_RootConstrainSelectedInstOperands,
     /*  605754 */     // GIR_Coverage, 5298,
     /*  605754 */     GIR_EraseRootFromParent_Done,
     /*  605755 */   // Label 9823: @605755
     /*  605755 */   GIM_Try, /*On fail goto*//*Label 9824*/ GIMT_Encode4(605827), // Rule ID 5299 //
     /*  605760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  605763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  605774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  605777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605806 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  605806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  605809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605825 */     GIR_RootConstrainSelectedInstOperands,
     /*  605826 */     // GIR_Coverage, 5299,
     /*  605826 */     GIR_EraseRootFromParent_Done,
     /*  605827 */   // Label 9824: @605827
     /*  605827 */   GIM_Try, /*On fail goto*//*Label 9825*/ GIMT_Encode4(605899), // Rule ID 5300 //
     /*  605832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  605835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  605846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  605849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605878 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  605878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605887 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605897 */     GIR_RootConstrainSelectedInstOperands,
     /*  605898 */     // GIR_Coverage, 5300,
     /*  605898 */     GIR_EraseRootFromParent_Done,
     /*  605899 */   // Label 9825: @605899
     /*  605899 */   GIM_Try, /*On fail goto*//*Label 9826*/ GIMT_Encode4(605971), // Rule ID 5301 //
     /*  605904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  605907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  605918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  605921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605950 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  605950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605969 */     GIR_RootConstrainSelectedInstOperands,
     /*  605970 */     // GIR_Coverage, 5301,
     /*  605970 */     GIR_EraseRootFromParent_Done,
     /*  605971 */   // Label 9826: @605971
     /*  605971 */   GIM_Try, /*On fail goto*//*Label 9827*/ GIMT_Encode4(606043), // Rule ID 5302 //
     /*  605976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  605990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606022 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  606025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606041 */     GIR_RootConstrainSelectedInstOperands,
     /*  606042 */     // GIR_Coverage, 5302,
     /*  606042 */     GIR_EraseRootFromParent_Done,
     /*  606043 */   // Label 9827: @606043
     /*  606043 */   GIM_Try, /*On fail goto*//*Label 9828*/ GIMT_Encode4(606115), // Rule ID 5303 //
     /*  606048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  606062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606094 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  606097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606113 */     GIR_RootConstrainSelectedInstOperands,
     /*  606114 */     // GIR_Coverage, 5303,
     /*  606114 */     GIR_EraseRootFromParent_Done,
     /*  606115 */   // Label 9828: @606115
     /*  606115 */   GIM_Try, /*On fail goto*//*Label 9829*/ GIMT_Encode4(606187), // Rule ID 5304 //
     /*  606120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  606134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606166 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  606169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606185 */     GIR_RootConstrainSelectedInstOperands,
     /*  606186 */     // GIR_Coverage, 5304,
     /*  606186 */     GIR_EraseRootFromParent_Done,
     /*  606187 */   // Label 9829: @606187
     /*  606187 */   GIM_Try, /*On fail goto*//*Label 9830*/ GIMT_Encode4(606259), // Rule ID 5305 //
     /*  606192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  606206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606238 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  606241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606257 */     GIR_RootConstrainSelectedInstOperands,
     /*  606258 */     // GIR_Coverage, 5305,
     /*  606258 */     GIR_EraseRootFromParent_Done,
     /*  606259 */   // Label 9830: @606259
     /*  606259 */   GIM_Try, /*On fail goto*//*Label 9831*/ GIMT_Encode4(606331), // Rule ID 5306 //
     /*  606264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  606278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606310 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606329 */     GIR_RootConstrainSelectedInstOperands,
     /*  606330 */     // GIR_Coverage, 5306,
     /*  606330 */     GIR_EraseRootFromParent_Done,
     /*  606331 */   // Label 9831: @606331
     /*  606331 */   GIM_Try, /*On fail goto*//*Label 9832*/ GIMT_Encode4(606403), // Rule ID 5307 //
     /*  606336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  606350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606382 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606401 */     GIR_RootConstrainSelectedInstOperands,
     /*  606402 */     // GIR_Coverage, 5307,
     /*  606402 */     GIR_EraseRootFromParent_Done,
     /*  606403 */   // Label 9832: @606403
     /*  606403 */   GIM_Try, /*On fail goto*//*Label 9833*/ GIMT_Encode4(606475), // Rule ID 5308 //
     /*  606408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  606422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606454 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  606457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606473 */     GIR_RootConstrainSelectedInstOperands,
     /*  606474 */     // GIR_Coverage, 5308,
     /*  606474 */     GIR_EraseRootFromParent_Done,
     /*  606475 */   // Label 9833: @606475
     /*  606475 */   GIM_Try, /*On fail goto*//*Label 9834*/ GIMT_Encode4(606547), // Rule ID 5309 //
     /*  606480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  606494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606526 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  606529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606545 */     GIR_RootConstrainSelectedInstOperands,
     /*  606546 */     // GIR_Coverage, 5309,
     /*  606546 */     GIR_EraseRootFromParent_Done,
     /*  606547 */   // Label 9834: @606547
     /*  606547 */   GIM_Try, /*On fail goto*//*Label 9835*/ GIMT_Encode4(606619), // Rule ID 5310 //
     /*  606552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  606566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606598 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606617 */     GIR_RootConstrainSelectedInstOperands,
     /*  606618 */     // GIR_Coverage, 5310,
     /*  606618 */     GIR_EraseRootFromParent_Done,
     /*  606619 */   // Label 9835: @606619
     /*  606619 */   GIM_Try, /*On fail goto*//*Label 9836*/ GIMT_Encode4(606691), // Rule ID 5311 //
     /*  606624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  606638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606670 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606689 */     GIR_RootConstrainSelectedInstOperands,
     /*  606690 */     // GIR_Coverage, 5311,
     /*  606690 */     GIR_EraseRootFromParent_Done,
     /*  606691 */   // Label 9836: @606691
     /*  606691 */   GIM_Try, /*On fail goto*//*Label 9837*/ GIMT_Encode4(606763), // Rule ID 5312 //
     /*  606696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  606710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606742 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  606742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606761 */     GIR_RootConstrainSelectedInstOperands,
     /*  606762 */     // GIR_Coverage, 5312,
     /*  606762 */     GIR_EraseRootFromParent_Done,
     /*  606763 */   // Label 9837: @606763
     /*  606763 */   GIM_Try, /*On fail goto*//*Label 9838*/ GIMT_Encode4(606835), // Rule ID 5313 //
     /*  606768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  606782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606814 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  606814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606833 */     GIR_RootConstrainSelectedInstOperands,
     /*  606834 */     // GIR_Coverage, 5313,
     /*  606834 */     GIR_EraseRootFromParent_Done,
     /*  606835 */   // Label 9838: @606835
     /*  606835 */   GIM_Try, /*On fail goto*//*Label 9839*/ GIMT_Encode4(606907), // Rule ID 5314 //
     /*  606840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  606851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  606854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  606860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606886 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606905 */     GIR_RootConstrainSelectedInstOperands,
     /*  606906 */     // GIR_Coverage, 5314,
     /*  606906 */     GIR_EraseRootFromParent_Done,
     /*  606907 */   // Label 9839: @606907
     /*  606907 */   GIM_Try, /*On fail goto*//*Label 9840*/ GIMT_Encode4(606979), // Rule ID 5315 //
     /*  606912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  606923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  606926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  606932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606958 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606977 */     GIR_RootConstrainSelectedInstOperands,
     /*  606978 */     // GIR_Coverage, 5315,
     /*  606978 */     GIR_EraseRootFromParent_Done,
     /*  606979 */   // Label 9840: @606979
     /*  606979 */   GIM_Try, /*On fail goto*//*Label 9841*/ GIMT_Encode4(607051), // Rule ID 5316 //
     /*  606984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  606998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607030 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  607033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607049 */     GIR_RootConstrainSelectedInstOperands,
     /*  607050 */     // GIR_Coverage, 5316,
     /*  607050 */     GIR_EraseRootFromParent_Done,
     /*  607051 */   // Label 9841: @607051
     /*  607051 */   GIM_Try, /*On fail goto*//*Label 9842*/ GIMT_Encode4(607123), // Rule ID 5317 //
     /*  607056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  607070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607102 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  607105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607121 */     GIR_RootConstrainSelectedInstOperands,
     /*  607122 */     // GIR_Coverage, 5317,
     /*  607122 */     GIR_EraseRootFromParent_Done,
     /*  607123 */   // Label 9842: @607123
     /*  607123 */   GIM_Try, /*On fail goto*//*Label 9843*/ GIMT_Encode4(607195), // Rule ID 5318 //
     /*  607128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  607139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  607142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  607148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607174 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  607174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  607177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607193 */     GIR_RootConstrainSelectedInstOperands,
     /*  607194 */     // GIR_Coverage, 5318,
     /*  607194 */     GIR_EraseRootFromParent_Done,
     /*  607195 */   // Label 9843: @607195
     /*  607195 */   GIM_Try, /*On fail goto*//*Label 9844*/ GIMT_Encode4(607267), // Rule ID 5319 //
     /*  607200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  607211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  607214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  607220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607246 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  607246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  607249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607265 */     GIR_RootConstrainSelectedInstOperands,
     /*  607266 */     // GIR_Coverage, 5319,
     /*  607266 */     GIR_EraseRootFromParent_Done,
     /*  607267 */   // Label 9844: @607267
     /*  607267 */   GIM_Try, /*On fail goto*//*Label 9845*/ GIMT_Encode4(607339), // Rule ID 5320 //
     /*  607272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  607275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  607283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  607286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  607292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607318 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  607318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  607321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  607337 */     GIR_RootConstrainSelectedInstOperands,
     /*  607338 */     // GIR_Coverage, 5320,
     /*  607338 */     GIR_EraseRootFromParent_Done,
     /*  607339 */   // Label 9845: @607339
     /*  607339 */   GIM_Try, /*On fail goto*//*Label 9846*/ GIMT_Encode4(607411), // Rule ID 5321 //
     /*  607344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  607347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  607355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  607358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  607364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607390 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  607390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  607393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  607409 */     GIR_RootConstrainSelectedInstOperands,
     /*  607410 */     // GIR_Coverage, 5321,
     /*  607410 */     GIR_EraseRootFromParent_Done,
     /*  607411 */   // Label 9846: @607411
     /*  607411 */   GIM_Try, /*On fail goto*//*Label 9847*/ GIMT_Encode4(607483), // Rule ID 5322 //
     /*  607416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  607430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607462 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607481 */     GIR_RootConstrainSelectedInstOperands,
     /*  607482 */     // GIR_Coverage, 5322,
     /*  607482 */     GIR_EraseRootFromParent_Done,
     /*  607483 */   // Label 9847: @607483
     /*  607483 */   GIM_Try, /*On fail goto*//*Label 9848*/ GIMT_Encode4(607555), // Rule ID 5323 //
     /*  607488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  607502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607534 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607553 */     GIR_RootConstrainSelectedInstOperands,
     /*  607554 */     // GIR_Coverage, 5323,
     /*  607554 */     GIR_EraseRootFromParent_Done,
     /*  607555 */   // Label 9848: @607555
     /*  607555 */   GIM_Try, /*On fail goto*//*Label 9849*/ GIMT_Encode4(607627), // Rule ID 5324 //
     /*  607560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  607574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607606 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607625 */     GIR_RootConstrainSelectedInstOperands,
     /*  607626 */     // GIR_Coverage, 5324,
     /*  607626 */     GIR_EraseRootFromParent_Done,
     /*  607627 */   // Label 9849: @607627
     /*  607627 */   GIM_Try, /*On fail goto*//*Label 9850*/ GIMT_Encode4(607699), // Rule ID 5325 //
     /*  607632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  607646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607678 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607697 */     GIR_RootConstrainSelectedInstOperands,
     /*  607698 */     // GIR_Coverage, 5325,
     /*  607698 */     GIR_EraseRootFromParent_Done,
     /*  607699 */   // Label 9850: @607699
     /*  607699 */   GIM_Try, /*On fail goto*//*Label 9851*/ GIMT_Encode4(607771), // Rule ID 5326 //
     /*  607704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  607715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  607718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  607724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607750 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607769 */     GIR_RootConstrainSelectedInstOperands,
     /*  607770 */     // GIR_Coverage, 5326,
     /*  607770 */     GIR_EraseRootFromParent_Done,
     /*  607771 */   // Label 9851: @607771
     /*  607771 */   GIM_Try, /*On fail goto*//*Label 9852*/ GIMT_Encode4(607843), // Rule ID 5327 //
     /*  607776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  607787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  607790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  607796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607822 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607841 */     GIR_RootConstrainSelectedInstOperands,
     /*  607842 */     // GIR_Coverage, 5327,
     /*  607842 */     GIR_EraseRootFromParent_Done,
     /*  607843 */   // Label 9852: @607843
     /*  607843 */   GIM_Try, /*On fail goto*//*Label 9853*/ GIMT_Encode4(607915), // Rule ID 5328 //
     /*  607848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  607862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607894 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607913 */     GIR_RootConstrainSelectedInstOperands,
     /*  607914 */     // GIR_Coverage, 5328,
     /*  607914 */     GIR_EraseRootFromParent_Done,
     /*  607915 */   // Label 9853: @607915
     /*  607915 */   GIM_Try, /*On fail goto*//*Label 9854*/ GIMT_Encode4(607987), // Rule ID 5329 //
     /*  607920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  607934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607966 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607985 */     GIR_RootConstrainSelectedInstOperands,
     /*  607986 */     // GIR_Coverage, 5329,
     /*  607986 */     GIR_EraseRootFromParent_Done,
     /*  607987 */   // Label 9854: @607987
     /*  607987 */   GIM_Try, /*On fail goto*//*Label 9855*/ GIMT_Encode4(608059), // Rule ID 5330 //
     /*  607992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  608006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608038 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  608038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608057 */     GIR_RootConstrainSelectedInstOperands,
     /*  608058 */     // GIR_Coverage, 5330,
     /*  608058 */     GIR_EraseRootFromParent_Done,
     /*  608059 */   // Label 9855: @608059
     /*  608059 */   GIM_Try, /*On fail goto*//*Label 9856*/ GIMT_Encode4(608131), // Rule ID 5331 //
     /*  608064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  608078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608110 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  608110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608129 */     GIR_RootConstrainSelectedInstOperands,
     /*  608130 */     // GIR_Coverage, 5331,
     /*  608130 */     GIR_EraseRootFromParent_Done,
     /*  608131 */   // Label 9856: @608131
     /*  608131 */   GIM_Try, /*On fail goto*//*Label 9857*/ GIMT_Encode4(608203), // Rule ID 5332 //
     /*  608136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  608147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  608150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  608156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608182 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  608182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608201 */     GIR_RootConstrainSelectedInstOperands,
     /*  608202 */     // GIR_Coverage, 5332,
     /*  608202 */     GIR_EraseRootFromParent_Done,
     /*  608203 */   // Label 9857: @608203
     /*  608203 */   GIM_Try, /*On fail goto*//*Label 9858*/ GIMT_Encode4(608275), // Rule ID 5333 //
     /*  608208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  608219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  608222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  608228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608254 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  608254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608273 */     GIR_RootConstrainSelectedInstOperands,
     /*  608274 */     // GIR_Coverage, 5333,
     /*  608274 */     GIR_EraseRootFromParent_Done,
     /*  608275 */   // Label 9858: @608275
     /*  608275 */   GIM_Try, /*On fail goto*//*Label 9859*/ GIMT_Encode4(608347), // Rule ID 5334 //
     /*  608280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  608294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608326 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  608329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608345 */     GIR_RootConstrainSelectedInstOperands,
     /*  608346 */     // GIR_Coverage, 5334,
     /*  608346 */     GIR_EraseRootFromParent_Done,
     /*  608347 */   // Label 9859: @608347
     /*  608347 */   GIM_Try, /*On fail goto*//*Label 9860*/ GIMT_Encode4(608419), // Rule ID 5335 //
     /*  608352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  608366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608398 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  608401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608417 */     GIR_RootConstrainSelectedInstOperands,
     /*  608418 */     // GIR_Coverage, 5335,
     /*  608418 */     GIR_EraseRootFromParent_Done,
     /*  608419 */   // Label 9860: @608419
     /*  608419 */   GIM_Try, /*On fail goto*//*Label 9861*/ GIMT_Encode4(608491), // Rule ID 5336 //
     /*  608424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  608438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608470 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608489 */     GIR_RootConstrainSelectedInstOperands,
     /*  608490 */     // GIR_Coverage, 5336,
     /*  608490 */     GIR_EraseRootFromParent_Done,
     /*  608491 */   // Label 9861: @608491
     /*  608491 */   GIM_Try, /*On fail goto*//*Label 9862*/ GIMT_Encode4(608563), // Rule ID 5337 //
     /*  608496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  608510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608542 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608561 */     GIR_RootConstrainSelectedInstOperands,
     /*  608562 */     // GIR_Coverage, 5337,
     /*  608562 */     GIR_EraseRootFromParent_Done,
     /*  608563 */   // Label 9862: @608563
     /*  608563 */   GIM_Try, /*On fail goto*//*Label 9863*/ GIMT_Encode4(608635), // Rule ID 5338 //
     /*  608568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  608582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608614 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608633 */     GIR_RootConstrainSelectedInstOperands,
     /*  608634 */     // GIR_Coverage, 5338,
     /*  608634 */     GIR_EraseRootFromParent_Done,
     /*  608635 */   // Label 9863: @608635
     /*  608635 */   GIM_Try, /*On fail goto*//*Label 9864*/ GIMT_Encode4(608707), // Rule ID 5339 //
     /*  608640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  608654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608686 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608705 */     GIR_RootConstrainSelectedInstOperands,
     /*  608706 */     // GIR_Coverage, 5339,
     /*  608706 */     GIR_EraseRootFromParent_Done,
     /*  608707 */   // Label 9864: @608707
     /*  608707 */   GIM_Try, /*On fail goto*//*Label 9865*/ GIMT_Encode4(608779), // Rule ID 5340 //
     /*  608712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  608726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608758 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  608761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608777 */     GIR_RootConstrainSelectedInstOperands,
     /*  608778 */     // GIR_Coverage, 5340,
     /*  608778 */     GIR_EraseRootFromParent_Done,
     /*  608779 */   // Label 9865: @608779
     /*  608779 */   GIM_Try, /*On fail goto*//*Label 9866*/ GIMT_Encode4(608851), // Rule ID 5341 //
     /*  608784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  608798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608830 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  608830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  608833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608849 */     GIR_RootConstrainSelectedInstOperands,
     /*  608850 */     // GIR_Coverage, 5341,
     /*  608850 */     GIR_EraseRootFromParent_Done,
     /*  608851 */   // Label 9866: @608851
     /*  608851 */   GIM_Try, /*On fail goto*//*Label 9867*/ GIMT_Encode4(608923), // Rule ID 5342 //
     /*  608856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  608870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608902 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608921 */     GIR_RootConstrainSelectedInstOperands,
     /*  608922 */     // GIR_Coverage, 5342,
     /*  608922 */     GIR_EraseRootFromParent_Done,
     /*  608923 */   // Label 9867: @608923
     /*  608923 */   GIM_Try, /*On fail goto*//*Label 9868*/ GIMT_Encode4(608995), // Rule ID 5343 //
     /*  608928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  608942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608974 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  608974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608993 */     GIR_RootConstrainSelectedInstOperands,
     /*  608994 */     // GIR_Coverage, 5343,
     /*  608994 */     GIR_EraseRootFromParent_Done,
     /*  608995 */   // Label 9868: @608995
     /*  608995 */   GIM_Try, /*On fail goto*//*Label 9869*/ GIMT_Encode4(609067), // Rule ID 5344 //
     /*  609000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  609003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  609014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  609017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609046 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  609046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  609049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609065 */     GIR_RootConstrainSelectedInstOperands,
     /*  609066 */     // GIR_Coverage, 5344,
     /*  609066 */     GIR_EraseRootFromParent_Done,
     /*  609067 */   // Label 9869: @609067
     /*  609067 */   GIM_Try, /*On fail goto*//*Label 9870*/ GIMT_Encode4(609139), // Rule ID 5345 //
     /*  609072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  609075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  609086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  609089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609118 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  609118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  609121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609137 */     GIR_RootConstrainSelectedInstOperands,
     /*  609138 */     // GIR_Coverage, 5345,
     /*  609138 */     GIR_EraseRootFromParent_Done,
     /*  609139 */   // Label 9870: @609139
     /*  609139 */   GIM_Try, /*On fail goto*//*Label 9871*/ GIMT_Encode4(609211), // Rule ID 5608 //
     /*  609144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  609158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  609161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  609193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609209 */     GIR_RootConstrainSelectedInstOperands,
     /*  609210 */     // GIR_Coverage, 5608,
     /*  609210 */     GIR_EraseRootFromParent_Done,
     /*  609211 */   // Label 9871: @609211
     /*  609211 */   GIM_Try, /*On fail goto*//*Label 9872*/ GIMT_Encode4(609283), // Rule ID 5609 //
     /*  609216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  609230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  609233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609262 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  609265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609281 */     GIR_RootConstrainSelectedInstOperands,
     /*  609282 */     // GIR_Coverage, 5609,
     /*  609282 */     GIR_EraseRootFromParent_Done,
     /*  609283 */   // Label 9872: @609283
     /*  609283 */   GIM_Try, /*On fail goto*//*Label 9873*/ GIMT_Encode4(609355), // Rule ID 5610 //
     /*  609288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  609302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  609305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609334 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  609337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609343 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609353 */     GIR_RootConstrainSelectedInstOperands,
     /*  609354 */     // GIR_Coverage, 5610,
     /*  609354 */     GIR_EraseRootFromParent_Done,
     /*  609355 */   // Label 9873: @609355
     /*  609355 */   GIM_Try, /*On fail goto*//*Label 9874*/ GIMT_Encode4(609427), // Rule ID 5611 //
     /*  609360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  609374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  609377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609406 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  609409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609425 */     GIR_RootConstrainSelectedInstOperands,
     /*  609426 */     // GIR_Coverage, 5611,
     /*  609426 */     GIR_EraseRootFromParent_Done,
     /*  609427 */   // Label 9874: @609427
     /*  609427 */   GIM_Try, /*On fail goto*//*Label 9875*/ GIMT_Encode4(609499), // Rule ID 5612 //
     /*  609432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  609446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  609449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609478 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609497 */     GIR_RootConstrainSelectedInstOperands,
     /*  609498 */     // GIR_Coverage, 5612,
     /*  609498 */     GIR_EraseRootFromParent_Done,
     /*  609499 */   // Label 9875: @609499
     /*  609499 */   GIM_Try, /*On fail goto*//*Label 9876*/ GIMT_Encode4(609571), // Rule ID 5613 //
     /*  609504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  609518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  609521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609550 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609569 */     GIR_RootConstrainSelectedInstOperands,
     /*  609570 */     // GIR_Coverage, 5613,
     /*  609570 */     GIR_EraseRootFromParent_Done,
     /*  609571 */   // Label 9876: @609571
     /*  609571 */   GIM_Try, /*On fail goto*//*Label 9877*/ GIMT_Encode4(609643), // Rule ID 5614 //
     /*  609576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  609590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  609593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609622 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  609625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609641 */     GIR_RootConstrainSelectedInstOperands,
     /*  609642 */     // GIR_Coverage, 5614,
     /*  609642 */     GIR_EraseRootFromParent_Done,
     /*  609643 */   // Label 9877: @609643
     /*  609643 */   GIM_Try, /*On fail goto*//*Label 9878*/ GIMT_Encode4(609715), // Rule ID 5615 //
     /*  609648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  609662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  609665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609694 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  609697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609713 */     GIR_RootConstrainSelectedInstOperands,
     /*  609714 */     // GIR_Coverage, 5615,
     /*  609714 */     GIR_EraseRootFromParent_Done,
     /*  609715 */   // Label 9878: @609715
     /*  609715 */   GIM_Try, /*On fail goto*//*Label 9879*/ GIMT_Encode4(609787), // Rule ID 5616 //
     /*  609720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  609734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  609737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609766 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609785 */     GIR_RootConstrainSelectedInstOperands,
     /*  609786 */     // GIR_Coverage, 5616,
     /*  609786 */     GIR_EraseRootFromParent_Done,
     /*  609787 */   // Label 9879: @609787
     /*  609787 */   GIM_Try, /*On fail goto*//*Label 9880*/ GIMT_Encode4(609859), // Rule ID 5617 //
     /*  609792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  609806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  609809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609838 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609857 */     GIR_RootConstrainSelectedInstOperands,
     /*  609858 */     // GIR_Coverage, 5617,
     /*  609858 */     GIR_EraseRootFromParent_Done,
     /*  609859 */   // Label 9880: @609859
     /*  609859 */   GIM_Try, /*On fail goto*//*Label 9881*/ GIMT_Encode4(609931), // Rule ID 5618 //
     /*  609864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  609878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  609881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609910 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  609910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609929 */     GIR_RootConstrainSelectedInstOperands,
     /*  609930 */     // GIR_Coverage, 5618,
     /*  609930 */     GIR_EraseRootFromParent_Done,
     /*  609931 */   // Label 9881: @609931
     /*  609931 */   GIM_Try, /*On fail goto*//*Label 9882*/ GIMT_Encode4(610003), // Rule ID 5619 //
     /*  609936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  609950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  609953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609982 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  609982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610001 */     GIR_RootConstrainSelectedInstOperands,
     /*  610002 */     // GIR_Coverage, 5619,
     /*  610002 */     GIR_EraseRootFromParent_Done,
     /*  610003 */   // Label 9882: @610003
     /*  610003 */   GIM_Try, /*On fail goto*//*Label 9883*/ GIMT_Encode4(610075), // Rule ID 5620 //
     /*  610008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  610022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  610025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610054 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610073 */     GIR_RootConstrainSelectedInstOperands,
     /*  610074 */     // GIR_Coverage, 5620,
     /*  610074 */     GIR_EraseRootFromParent_Done,
     /*  610075 */   // Label 9883: @610075
     /*  610075 */   GIM_Try, /*On fail goto*//*Label 9884*/ GIMT_Encode4(610147), // Rule ID 5621 //
     /*  610080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  610094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  610097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610126 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610145 */     GIR_RootConstrainSelectedInstOperands,
     /*  610146 */     // GIR_Coverage, 5621,
     /*  610146 */     GIR_EraseRootFromParent_Done,
     /*  610147 */   // Label 9884: @610147
     /*  610147 */   GIM_Try, /*On fail goto*//*Label 9885*/ GIMT_Encode4(610219), // Rule ID 5622 //
     /*  610152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  610163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  610166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  610169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  610172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610198 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610217 */     GIR_RootConstrainSelectedInstOperands,
     /*  610218 */     // GIR_Coverage, 5622,
     /*  610218 */     GIR_EraseRootFromParent_Done,
     /*  610219 */   // Label 9885: @610219
     /*  610219 */   GIM_Try, /*On fail goto*//*Label 9886*/ GIMT_Encode4(610291), // Rule ID 5623 //
     /*  610224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  610235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  610238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  610241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  610244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610270 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610289 */     GIR_RootConstrainSelectedInstOperands,
     /*  610290 */     // GIR_Coverage, 5623,
     /*  610290 */     GIR_EraseRootFromParent_Done,
     /*  610291 */   // Label 9886: @610291
     /*  610291 */   GIM_Try, /*On fail goto*//*Label 9887*/ GIMT_Encode4(610363), // Rule ID 5624 //
     /*  610296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  610307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  610310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  610313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  610316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610342 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  610342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610361 */     GIR_RootConstrainSelectedInstOperands,
     /*  610362 */     // GIR_Coverage, 5624,
     /*  610362 */     GIR_EraseRootFromParent_Done,
     /*  610363 */   // Label 9887: @610363
     /*  610363 */   GIM_Try, /*On fail goto*//*Label 9888*/ GIMT_Encode4(610435), // Rule ID 5625 //
     /*  610368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  610379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  610382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  610385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  610388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610414 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  610414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610433 */     GIR_RootConstrainSelectedInstOperands,
     /*  610434 */     // GIR_Coverage, 5625,
     /*  610434 */     GIR_EraseRootFromParent_Done,
     /*  610435 */   // Label 9888: @610435
     /*  610435 */   GIM_Try, /*On fail goto*//*Label 9889*/ GIMT_Encode4(610507), // Rule ID 5626 //
     /*  610440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  610443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  610454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  610457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610486 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  610486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610495 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610505 */     GIR_RootConstrainSelectedInstOperands,
     /*  610506 */     // GIR_Coverage, 5626,
     /*  610506 */     GIR_EraseRootFromParent_Done,
     /*  610507 */   // Label 9889: @610507
     /*  610507 */   GIM_Try, /*On fail goto*//*Label 9890*/ GIMT_Encode4(610579), // Rule ID 5627 //
     /*  610512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  610515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  610526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  610529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610558 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  610558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610577 */     GIR_RootConstrainSelectedInstOperands,
     /*  610578 */     // GIR_Coverage, 5627,
     /*  610578 */     GIR_EraseRootFromParent_Done,
     /*  610579 */   // Label 9890: @610579
     /*  610579 */   GIM_Try, /*On fail goto*//*Label 9891*/ GIMT_Encode4(610651), // Rule ID 5628 //
     /*  610584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  610598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  610601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610630 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610649 */     GIR_RootConstrainSelectedInstOperands,
     /*  610650 */     // GIR_Coverage, 5628,
     /*  610650 */     GIR_EraseRootFromParent_Done,
     /*  610651 */   // Label 9891: @610651
     /*  610651 */   GIM_Try, /*On fail goto*//*Label 9892*/ GIMT_Encode4(610723), // Rule ID 5629 //
     /*  610656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  610670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  610673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610702 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610721 */     GIR_RootConstrainSelectedInstOperands,
     /*  610722 */     // GIR_Coverage, 5629,
     /*  610722 */     GIR_EraseRootFromParent_Done,
     /*  610723 */   // Label 9892: @610723
     /*  610723 */   GIM_Try, /*On fail goto*//*Label 9893*/ GIMT_Encode4(610795), // Rule ID 5630 //
     /*  610728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  610742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  610745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610774 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610793 */     GIR_RootConstrainSelectedInstOperands,
     /*  610794 */     // GIR_Coverage, 5630,
     /*  610794 */     GIR_EraseRootFromParent_Done,
     /*  610795 */   // Label 9893: @610795
     /*  610795 */   GIM_Try, /*On fail goto*//*Label 9894*/ GIMT_Encode4(610867), // Rule ID 5631 //
     /*  610800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  610814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  610817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610846 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610865 */     GIR_RootConstrainSelectedInstOperands,
     /*  610866 */     // GIR_Coverage, 5631,
     /*  610866 */     GIR_EraseRootFromParent_Done,
     /*  610867 */   // Label 9894: @610867
     /*  610867 */   GIM_Try, /*On fail goto*//*Label 9895*/ GIMT_Encode4(610939), // Rule ID 5632 //
     /*  610872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  610883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  610886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  610889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  610892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610918 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610937 */     GIR_RootConstrainSelectedInstOperands,
     /*  610938 */     // GIR_Coverage, 5632,
     /*  610938 */     GIR_EraseRootFromParent_Done,
     /*  610939 */   // Label 9895: @610939
     /*  610939 */   GIM_Try, /*On fail goto*//*Label 9896*/ GIMT_Encode4(611011), // Rule ID 5633 //
     /*  610944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  610955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  610958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  610961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  610964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610990 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611009 */     GIR_RootConstrainSelectedInstOperands,
     /*  611010 */     // GIR_Coverage, 5633,
     /*  611010 */     GIR_EraseRootFromParent_Done,
     /*  611011 */   // Label 9896: @611011
     /*  611011 */   GIM_Try, /*On fail goto*//*Label 9897*/ GIMT_Encode4(611083), // Rule ID 5634 //
     /*  611016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  611030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  611033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611062 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611081 */     GIR_RootConstrainSelectedInstOperands,
     /*  611082 */     // GIR_Coverage, 5634,
     /*  611082 */     GIR_EraseRootFromParent_Done,
     /*  611083 */   // Label 9897: @611083
     /*  611083 */   GIM_Try, /*On fail goto*//*Label 9898*/ GIMT_Encode4(611155), // Rule ID 5635 //
     /*  611088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  611102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  611105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611134 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611153 */     GIR_RootConstrainSelectedInstOperands,
     /*  611154 */     // GIR_Coverage, 5635,
     /*  611154 */     GIR_EraseRootFromParent_Done,
     /*  611155 */   // Label 9898: @611155
     /*  611155 */   GIM_Try, /*On fail goto*//*Label 9899*/ GIMT_Encode4(611227), // Rule ID 5636 //
     /*  611160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  611174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  611177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611206 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611225 */     GIR_RootConstrainSelectedInstOperands,
     /*  611226 */     // GIR_Coverage, 5636,
     /*  611226 */     GIR_EraseRootFromParent_Done,
     /*  611227 */   // Label 9899: @611227
     /*  611227 */   GIM_Try, /*On fail goto*//*Label 9900*/ GIMT_Encode4(611299), // Rule ID 5637 //
     /*  611232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  611246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  611249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611278 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611297 */     GIR_RootConstrainSelectedInstOperands,
     /*  611298 */     // GIR_Coverage, 5637,
     /*  611298 */     GIR_EraseRootFromParent_Done,
     /*  611299 */   // Label 9900: @611299
     /*  611299 */   GIM_Try, /*On fail goto*//*Label 9901*/ GIMT_Encode4(611371), // Rule ID 5638 //
     /*  611304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  611315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  611318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  611321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  611324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611350 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611369 */     GIR_RootConstrainSelectedInstOperands,
     /*  611370 */     // GIR_Coverage, 5638,
     /*  611370 */     GIR_EraseRootFromParent_Done,
     /*  611371 */   // Label 9901: @611371
     /*  611371 */   GIM_Try, /*On fail goto*//*Label 9902*/ GIMT_Encode4(611443), // Rule ID 5639 //
     /*  611376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  611387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  611390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  611393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  611396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611422 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611441 */     GIR_RootConstrainSelectedInstOperands,
     /*  611442 */     // GIR_Coverage, 5639,
     /*  611442 */     GIR_EraseRootFromParent_Done,
     /*  611443 */   // Label 9902: @611443
     /*  611443 */   GIM_Try, /*On fail goto*//*Label 9903*/ GIMT_Encode4(611515), // Rule ID 5640 //
     /*  611448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  611462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  611465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611513 */     GIR_RootConstrainSelectedInstOperands,
     /*  611514 */     // GIR_Coverage, 5640,
     /*  611514 */     GIR_EraseRootFromParent_Done,
     /*  611515 */   // Label 9903: @611515
     /*  611515 */   GIM_Try, /*On fail goto*//*Label 9904*/ GIMT_Encode4(611587), // Rule ID 5641 //
     /*  611520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  611534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  611537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611566 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611585 */     GIR_RootConstrainSelectedInstOperands,
     /*  611586 */     // GIR_Coverage, 5641,
     /*  611586 */     GIR_EraseRootFromParent_Done,
     /*  611587 */   // Label 9904: @611587
     /*  611587 */   GIM_Try, /*On fail goto*//*Label 9905*/ GIMT_Encode4(611659), // Rule ID 5642 //
     /*  611592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  611606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  611609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611638 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611657 */     GIR_RootConstrainSelectedInstOperands,
     /*  611658 */     // GIR_Coverage, 5642,
     /*  611658 */     GIR_EraseRootFromParent_Done,
     /*  611659 */   // Label 9905: @611659
     /*  611659 */   GIM_Try, /*On fail goto*//*Label 9906*/ GIMT_Encode4(611731), // Rule ID 5643 //
     /*  611664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  611678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  611681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611710 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611729 */     GIR_RootConstrainSelectedInstOperands,
     /*  611730 */     // GIR_Coverage, 5643,
     /*  611730 */     GIR_EraseRootFromParent_Done,
     /*  611731 */   // Label 9906: @611731
     /*  611731 */   GIM_Try, /*On fail goto*//*Label 9907*/ GIMT_Encode4(611803), // Rule ID 5644 //
     /*  611736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  611750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  611753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611782 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611801 */     GIR_RootConstrainSelectedInstOperands,
     /*  611802 */     // GIR_Coverage, 5644,
     /*  611802 */     GIR_EraseRootFromParent_Done,
     /*  611803 */   // Label 9907: @611803
     /*  611803 */   GIM_Try, /*On fail goto*//*Label 9908*/ GIMT_Encode4(611875), // Rule ID 5645 //
     /*  611808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  611822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  611825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611854 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611873 */     GIR_RootConstrainSelectedInstOperands,
     /*  611874 */     // GIR_Coverage, 5645,
     /*  611874 */     GIR_EraseRootFromParent_Done,
     /*  611875 */   // Label 9908: @611875
     /*  611875 */   GIM_Try, /*On fail goto*//*Label 9909*/ GIMT_Encode4(611947), // Rule ID 5646 //
     /*  611880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  611883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  611894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  611897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  611900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611926 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  611926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611945 */     GIR_RootConstrainSelectedInstOperands,
     /*  611946 */     // GIR_Coverage, 5646,
     /*  611946 */     GIR_EraseRootFromParent_Done,
     /*  611947 */   // Label 9909: @611947
     /*  611947 */   GIM_Try, /*On fail goto*//*Label 9910*/ GIMT_Encode4(612019), // Rule ID 5647 //
     /*  611952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  611955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  611966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  611969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  611972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  611998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  612001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612017 */     GIR_RootConstrainSelectedInstOperands,
     /*  612018 */     // GIR_Coverage, 5647,
     /*  612018 */     GIR_EraseRootFromParent_Done,
     /*  612019 */   // Label 9910: @612019
     /*  612019 */   GIM_Try, /*On fail goto*//*Label 9911*/ GIMT_Encode4(612091), // Rule ID 5648 //
     /*  612024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  612027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  612038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  612041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612070 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  612070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  612073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612089 */     GIR_RootConstrainSelectedInstOperands,
     /*  612090 */     // GIR_Coverage, 5648,
     /*  612090 */     GIR_EraseRootFromParent_Done,
     /*  612091 */   // Label 9911: @612091
     /*  612091 */   GIM_Try, /*On fail goto*//*Label 9912*/ GIMT_Encode4(612163), // Rule ID 5649 //
     /*  612096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  612099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  612110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  612113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612142 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  612142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  612145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612161 */     GIR_RootConstrainSelectedInstOperands,
     /*  612162 */     // GIR_Coverage, 5649,
     /*  612162 */     GIR_EraseRootFromParent_Done,
     /*  612163 */   // Label 9912: @612163
     /*  612163 */   GIM_Try, /*On fail goto*//*Label 9913*/ GIMT_Encode4(612235), // Rule ID 5650 //
     /*  612168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  612171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  612182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  612185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612214 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  612214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  612217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612233 */     GIR_RootConstrainSelectedInstOperands,
     /*  612234 */     // GIR_Coverage, 5650,
     /*  612234 */     GIR_EraseRootFromParent_Done,
     /*  612235 */   // Label 9913: @612235
     /*  612235 */   GIM_Try, /*On fail goto*//*Label 9914*/ GIMT_Encode4(612307), // Rule ID 5651 //
     /*  612240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  612243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  612254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  612257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612286 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  612286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  612289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612305 */     GIR_RootConstrainSelectedInstOperands,
     /*  612306 */     // GIR_Coverage, 5651,
     /*  612306 */     GIR_EraseRootFromParent_Done,
     /*  612307 */   // Label 9914: @612307
     /*  612307 */   GIM_Try, /*On fail goto*//*Label 9915*/ GIMT_Encode4(612379), // Rule ID 5652 //
     /*  612312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  612326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  612361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612377 */     GIR_RootConstrainSelectedInstOperands,
     /*  612378 */     // GIR_Coverage, 5652,
     /*  612378 */     GIR_EraseRootFromParent_Done,
     /*  612379 */   // Label 9915: @612379
     /*  612379 */   GIM_Try, /*On fail goto*//*Label 9916*/ GIMT_Encode4(612451), // Rule ID 5653 //
     /*  612384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  612398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612430 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  612433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612449 */     GIR_RootConstrainSelectedInstOperands,
     /*  612450 */     // GIR_Coverage, 5653,
     /*  612450 */     GIR_EraseRootFromParent_Done,
     /*  612451 */   // Label 9916: @612451
     /*  612451 */   GIM_Try, /*On fail goto*//*Label 9917*/ GIMT_Encode4(612523), // Rule ID 5654 //
     /*  612456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  612470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612521 */     GIR_RootConstrainSelectedInstOperands,
     /*  612522 */     // GIR_Coverage, 5654,
     /*  612522 */     GIR_EraseRootFromParent_Done,
     /*  612523 */   // Label 9917: @612523
     /*  612523 */   GIM_Try, /*On fail goto*//*Label 9918*/ GIMT_Encode4(612595), // Rule ID 5655 //
     /*  612528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  612542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612574 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612593 */     GIR_RootConstrainSelectedInstOperands,
     /*  612594 */     // GIR_Coverage, 5655,
     /*  612594 */     GIR_EraseRootFromParent_Done,
     /*  612595 */   // Label 9918: @612595
     /*  612595 */   GIM_Try, /*On fail goto*//*Label 9919*/ GIMT_Encode4(612667), // Rule ID 5656 //
     /*  612600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  612614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612646 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612665 */     GIR_RootConstrainSelectedInstOperands,
     /*  612666 */     // GIR_Coverage, 5656,
     /*  612666 */     GIR_EraseRootFromParent_Done,
     /*  612667 */   // Label 9919: @612667
     /*  612667 */   GIM_Try, /*On fail goto*//*Label 9920*/ GIMT_Encode4(612739), // Rule ID 5657 //
     /*  612672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  612686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612718 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612737 */     GIR_RootConstrainSelectedInstOperands,
     /*  612738 */     // GIR_Coverage, 5657,
     /*  612738 */     GIR_EraseRootFromParent_Done,
     /*  612739 */   // Label 9920: @612739
     /*  612739 */   GIM_Try, /*On fail goto*//*Label 9921*/ GIMT_Encode4(612811), // Rule ID 5658 //
     /*  612744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  612758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612790 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612809 */     GIR_RootConstrainSelectedInstOperands,
     /*  612810 */     // GIR_Coverage, 5658,
     /*  612810 */     GIR_EraseRootFromParent_Done,
     /*  612811 */   // Label 9921: @612811
     /*  612811 */   GIM_Try, /*On fail goto*//*Label 9922*/ GIMT_Encode4(612883), // Rule ID 5659 //
     /*  612816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  612830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612862 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  612862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612881 */     GIR_RootConstrainSelectedInstOperands,
     /*  612882 */     // GIR_Coverage, 5659,
     /*  612882 */     GIR_EraseRootFromParent_Done,
     /*  612883 */   // Label 9922: @612883
     /*  612883 */   GIM_Try, /*On fail goto*//*Label 9923*/ GIMT_Encode4(612955), // Rule ID 5660 //
     /*  612888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  612902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612934 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612953 */     GIR_RootConstrainSelectedInstOperands,
     /*  612954 */     // GIR_Coverage, 5660,
     /*  612954 */     GIR_EraseRootFromParent_Done,
     /*  612955 */   // Label 9923: @612955
     /*  612955 */   GIM_Try, /*On fail goto*//*Label 9924*/ GIMT_Encode4(613027), // Rule ID 5661 //
     /*  612960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  612974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613006 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  613009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613025 */     GIR_RootConstrainSelectedInstOperands,
     /*  613026 */     // GIR_Coverage, 5661,
     /*  613026 */     GIR_EraseRootFromParent_Done,
     /*  613027 */   // Label 9924: @613027
     /*  613027 */   GIM_Try, /*On fail goto*//*Label 9925*/ GIMT_Encode4(613099), // Rule ID 5662 //
     /*  613032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  613046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613078 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  613081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613097 */     GIR_RootConstrainSelectedInstOperands,
     /*  613098 */     // GIR_Coverage, 5662,
     /*  613098 */     GIR_EraseRootFromParent_Done,
     /*  613099 */   // Label 9925: @613099
     /*  613099 */   GIM_Try, /*On fail goto*//*Label 9926*/ GIMT_Encode4(613171), // Rule ID 5663 //
     /*  613104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  613118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613150 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  613150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  613153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613169 */     GIR_RootConstrainSelectedInstOperands,
     /*  613170 */     // GIR_Coverage, 5663,
     /*  613170 */     GIR_EraseRootFromParent_Done,
     /*  613171 */   // Label 9926: @613171
     /*  613171 */   GIM_Try, /*On fail goto*//*Label 9927*/ GIMT_Encode4(613243), // Rule ID 5664 //
     /*  613176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  613190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613222 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613241 */     GIR_RootConstrainSelectedInstOperands,
     /*  613242 */     // GIR_Coverage, 5664,
     /*  613242 */     GIR_EraseRootFromParent_Done,
     /*  613243 */   // Label 9927: @613243
     /*  613243 */   GIM_Try, /*On fail goto*//*Label 9928*/ GIMT_Encode4(613315), // Rule ID 5665 //
     /*  613248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  613262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613294 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613313 */     GIR_RootConstrainSelectedInstOperands,
     /*  613314 */     // GIR_Coverage, 5665,
     /*  613314 */     GIR_EraseRootFromParent_Done,
     /*  613315 */   // Label 9928: @613315
     /*  613315 */   GIM_Try, /*On fail goto*//*Label 9929*/ GIMT_Encode4(613387), // Rule ID 5666 //
     /*  613320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  613331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  613334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  613340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613366 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613385 */     GIR_RootConstrainSelectedInstOperands,
     /*  613386 */     // GIR_Coverage, 5666,
     /*  613386 */     GIR_EraseRootFromParent_Done,
     /*  613387 */   // Label 9929: @613387
     /*  613387 */   GIM_Try, /*On fail goto*//*Label 9930*/ GIMT_Encode4(613459), // Rule ID 5667 //
     /*  613392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  613403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  613406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  613412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613438 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613457 */     GIR_RootConstrainSelectedInstOperands,
     /*  613458 */     // GIR_Coverage, 5667,
     /*  613458 */     GIR_EraseRootFromParent_Done,
     /*  613459 */   // Label 9930: @613459
     /*  613459 */   GIM_Try, /*On fail goto*//*Label 9931*/ GIMT_Encode4(613531), // Rule ID 5668 //
     /*  613464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  613478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613510 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613529 */     GIR_RootConstrainSelectedInstOperands,
     /*  613530 */     // GIR_Coverage, 5668,
     /*  613530 */     GIR_EraseRootFromParent_Done,
     /*  613531 */   // Label 9931: @613531
     /*  613531 */   GIM_Try, /*On fail goto*//*Label 9932*/ GIMT_Encode4(613603), // Rule ID 5669 //
     /*  613536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  613550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613582 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  613582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613601 */     GIR_RootConstrainSelectedInstOperands,
     /*  613602 */     // GIR_Coverage, 5669,
     /*  613602 */     GIR_EraseRootFromParent_Done,
     /*  613603 */   // Label 9932: @613603
     /*  613603 */   GIM_Try, /*On fail goto*//*Label 9933*/ GIMT_Encode4(613675), // Rule ID 5670 //
     /*  613608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  613611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  613622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613654 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  613654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  613673 */     GIR_RootConstrainSelectedInstOperands,
     /*  613674 */     // GIR_Coverage, 5670,
     /*  613674 */     GIR_EraseRootFromParent_Done,
     /*  613675 */   // Label 9933: @613675
     /*  613675 */   GIM_Try, /*On fail goto*//*Label 9934*/ GIMT_Encode4(613747), // Rule ID 5671 //
     /*  613680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  613683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  613694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613726 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  613726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  613745 */     GIR_RootConstrainSelectedInstOperands,
     /*  613746 */     // GIR_Coverage, 5671,
     /*  613746 */     GIR_EraseRootFromParent_Done,
     /*  613747 */   // Label 9934: @613747
     /*  613747 */   GIM_Try, /*On fail goto*//*Label 9935*/ GIMT_Encode4(613819), // Rule ID 5672 //
     /*  613752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  613766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613798 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613817 */     GIR_RootConstrainSelectedInstOperands,
     /*  613818 */     // GIR_Coverage, 5672,
     /*  613818 */     GIR_EraseRootFromParent_Done,
     /*  613819 */   // Label 9935: @613819
     /*  613819 */   GIM_Try, /*On fail goto*//*Label 9936*/ GIMT_Encode4(613891), // Rule ID 5673 //
     /*  613824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  613838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613870 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613889 */     GIR_RootConstrainSelectedInstOperands,
     /*  613890 */     // GIR_Coverage, 5673,
     /*  613890 */     GIR_EraseRootFromParent_Done,
     /*  613891 */   // Label 9936: @613891
     /*  613891 */   GIM_Try, /*On fail goto*//*Label 9937*/ GIMT_Encode4(613963), // Rule ID 5674 //
     /*  613896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  613907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  613910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  613916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613942 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613961 */     GIR_RootConstrainSelectedInstOperands,
     /*  613962 */     // GIR_Coverage, 5674,
     /*  613962 */     GIR_EraseRootFromParent_Done,
     /*  613963 */   // Label 9937: @613963
     /*  613963 */   GIM_Try, /*On fail goto*//*Label 9938*/ GIMT_Encode4(614035), // Rule ID 5675 //
     /*  613968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  613979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  613982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  613988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614014 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  614014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614033 */     GIR_RootConstrainSelectedInstOperands,
     /*  614034 */     // GIR_Coverage, 5675,
     /*  614034 */     GIR_EraseRootFromParent_Done,
     /*  614035 */   // Label 9938: @614035
     /*  614035 */   GIM_Try, /*On fail goto*//*Label 9939*/ GIMT_Encode4(614107), // Rule ID 5676 //
     /*  614040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  614051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  614054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  614060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614086 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  614086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614105 */     GIR_RootConstrainSelectedInstOperands,
     /*  614106 */     // GIR_Coverage, 5676,
     /*  614106 */     GIR_EraseRootFromParent_Done,
     /*  614107 */   // Label 9939: @614107
     /*  614107 */   GIM_Try, /*On fail goto*//*Label 9940*/ GIMT_Encode4(614179), // Rule ID 5677 //
     /*  614112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  614123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  614126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  614132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614158 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  614158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614177 */     GIR_RootConstrainSelectedInstOperands,
     /*  614178 */     // GIR_Coverage, 5677,
     /*  614178 */     GIR_EraseRootFromParent_Done,
     /*  614179 */   // Label 9940: @614179
     /*  614179 */   GIM_Try, /*On fail goto*//*Label 9941*/ GIMT_Encode4(614251), // Rule ID 5678 //
     /*  614184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  614198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614230 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614249 */     GIR_RootConstrainSelectedInstOperands,
     /*  614250 */     // GIR_Coverage, 5678,
     /*  614250 */     GIR_EraseRootFromParent_Done,
     /*  614251 */   // Label 9941: @614251
     /*  614251 */   GIM_Try, /*On fail goto*//*Label 9942*/ GIMT_Encode4(614323), // Rule ID 5679 //
     /*  614256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  614270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614321 */     GIR_RootConstrainSelectedInstOperands,
     /*  614322 */     // GIR_Coverage, 5679,
     /*  614322 */     GIR_EraseRootFromParent_Done,
     /*  614323 */   // Label 9942: @614323
     /*  614323 */   GIM_Try, /*On fail goto*//*Label 9943*/ GIMT_Encode4(614395), // Rule ID 5680 //
     /*  614328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  614342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614374 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614393 */     GIR_RootConstrainSelectedInstOperands,
     /*  614394 */     // GIR_Coverage, 5680,
     /*  614394 */     GIR_EraseRootFromParent_Done,
     /*  614395 */   // Label 9943: @614395
     /*  614395 */   GIM_Try, /*On fail goto*//*Label 9944*/ GIMT_Encode4(614467), // Rule ID 5681 //
     /*  614400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  614414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614446 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614465 */     GIR_RootConstrainSelectedInstOperands,
     /*  614466 */     // GIR_Coverage, 5681,
     /*  614466 */     GIR_EraseRootFromParent_Done,
     /*  614467 */   // Label 9944: @614467
     /*  614467 */   GIM_Try, /*On fail goto*//*Label 9945*/ GIMT_Encode4(614539), // Rule ID 5682 //
     /*  614472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  614486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614518 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614537 */     GIR_RootConstrainSelectedInstOperands,
     /*  614538 */     // GIR_Coverage, 5682,
     /*  614538 */     GIR_EraseRootFromParent_Done,
     /*  614539 */   // Label 9945: @614539
     /*  614539 */   GIM_Try, /*On fail goto*//*Label 9946*/ GIMT_Encode4(614611), // Rule ID 5683 //
     /*  614544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  614558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614590 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614609 */     GIR_RootConstrainSelectedInstOperands,
     /*  614610 */     // GIR_Coverage, 5683,
     /*  614610 */     GIR_EraseRootFromParent_Done,
     /*  614611 */   // Label 9946: @614611
     /*  614611 */   GIM_Try, /*On fail goto*//*Label 9947*/ GIMT_Encode4(614683), // Rule ID 5684 //
     /*  614616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  614630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614662 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614681 */     GIR_RootConstrainSelectedInstOperands,
     /*  614682 */     // GIR_Coverage, 5684,
     /*  614682 */     GIR_EraseRootFromParent_Done,
     /*  614683 */   // Label 9947: @614683
     /*  614683 */   GIM_Try, /*On fail goto*//*Label 9948*/ GIMT_Encode4(614755), // Rule ID 5685 //
     /*  614688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  614702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614734 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614753 */     GIR_RootConstrainSelectedInstOperands,
     /*  614754 */     // GIR_Coverage, 5685,
     /*  614754 */     GIR_EraseRootFromParent_Done,
     /*  614755 */   // Label 9948: @614755
     /*  614755 */   GIM_Try, /*On fail goto*//*Label 9949*/ GIMT_Encode4(614827), // Rule ID 5686 //
     /*  614760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  614774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614806 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614825 */     GIR_RootConstrainSelectedInstOperands,
     /*  614826 */     // GIR_Coverage, 5686,
     /*  614826 */     GIR_EraseRootFromParent_Done,
     /*  614827 */   // Label 9949: @614827
     /*  614827 */   GIM_Try, /*On fail goto*//*Label 9950*/ GIMT_Encode4(614899), // Rule ID 5687 //
     /*  614832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  614846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614878 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614887 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614897 */     GIR_RootConstrainSelectedInstOperands,
     /*  614898 */     // GIR_Coverage, 5687,
     /*  614898 */     GIR_EraseRootFromParent_Done,
     /*  614899 */   // Label 9950: @614899
     /*  614899 */   GIM_Try, /*On fail goto*//*Label 9951*/ GIMT_Encode4(614971), // Rule ID 5688 //
     /*  614904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  614918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614950 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614969 */     GIR_RootConstrainSelectedInstOperands,
     /*  614970 */     // GIR_Coverage, 5688,
     /*  614970 */     GIR_EraseRootFromParent_Done,
     /*  614971 */   // Label 9951: @614971
     /*  614971 */   GIM_Try, /*On fail goto*//*Label 9952*/ GIMT_Encode4(615043), // Rule ID 5689 //
     /*  614976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  614990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615022 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  615022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  615025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615041 */     GIR_RootConstrainSelectedInstOperands,
     /*  615042 */     // GIR_Coverage, 5689,
     /*  615042 */     GIR_EraseRootFromParent_Done,
     /*  615043 */   // Label 9952: @615043
     /*  615043 */   GIM_Try, /*On fail goto*//*Label 9953*/ GIMT_Encode4(615115), // Rule ID 5690 //
     /*  615048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  615059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  615062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  615065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  615068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615094 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  615094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  615097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615113 */     GIR_RootConstrainSelectedInstOperands,
     /*  615114 */     // GIR_Coverage, 5690,
     /*  615114 */     GIR_EraseRootFromParent_Done,
     /*  615115 */   // Label 9953: @615115
     /*  615115 */   GIM_Try, /*On fail goto*//*Label 9954*/ GIMT_Encode4(615187), // Rule ID 5691 //
     /*  615120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  615131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  615134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  615137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  615140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615166 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  615166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  615169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615185 */     GIR_RootConstrainSelectedInstOperands,
     /*  615186 */     // GIR_Coverage, 5691,
     /*  615186 */     GIR_EraseRootFromParent_Done,
     /*  615187 */   // Label 9954: @615187
     /*  615187 */   GIM_Try, /*On fail goto*//*Label 9955*/ GIMT_Encode4(615259), // Rule ID 5692 //
     /*  615192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  615203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  615206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  615209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  615212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615238 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  615238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  615241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615257 */     GIR_RootConstrainSelectedInstOperands,
     /*  615258 */     // GIR_Coverage, 5692,
     /*  615258 */     GIR_EraseRootFromParent_Done,
     /*  615259 */   // Label 9955: @615259
     /*  615259 */   GIM_Try, /*On fail goto*//*Label 9956*/ GIMT_Encode4(615331), // Rule ID 5693 //
     /*  615264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  615275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  615278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  615281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  615284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615310 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  615310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  615313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615329 */     GIR_RootConstrainSelectedInstOperands,
     /*  615330 */     // GIR_Coverage, 5693,
     /*  615330 */     GIR_EraseRootFromParent_Done,
     /*  615331 */   // Label 9956: @615331
     /*  615331 */   GIM_Try, /*On fail goto*//*Label 9957*/ GIMT_Encode4(615403), // Rule ID 5694 //
     /*  615336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  615347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  615350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  615353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  615356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615382 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  615382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  615385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615401 */     GIR_RootConstrainSelectedInstOperands,
     /*  615402 */     // GIR_Coverage, 5694,
     /*  615402 */     GIR_EraseRootFromParent_Done,
     /*  615403 */   // Label 9957: @615403
     /*  615403 */   GIM_Try, /*On fail goto*//*Label 9958*/ GIMT_Encode4(615475), // Rule ID 5695 //
     /*  615408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  615419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  615422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  615425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  615428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615454 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  615454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  615457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615473 */     GIR_RootConstrainSelectedInstOperands,
     /*  615474 */     // GIR_Coverage, 5695,
     /*  615474 */     GIR_EraseRootFromParent_Done,
     /*  615475 */   // Label 9958: @615475
     /*  615475 */   GIM_Try, /*On fail goto*//*Label 9959*/ GIMT_Encode4(615550), // Rule ID 5784 //
     /*  615480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  615491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  615497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  615500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615526 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  615529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615548 */     GIR_RootConstrainSelectedInstOperands,
     /*  615549 */     // GIR_Coverage, 5784,
     /*  615549 */     GIR_EraseRootFromParent_Done,
     /*  615550 */   // Label 9959: @615550
     /*  615550 */   GIM_Try, /*On fail goto*//*Label 9960*/ GIMT_Encode4(615625), // Rule ID 5785 //
     /*  615555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  615566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  615572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  615575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615601 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  615604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615623 */     GIR_RootConstrainSelectedInstOperands,
     /*  615624 */     // GIR_Coverage, 5785,
     /*  615624 */     GIR_EraseRootFromParent_Done,
     /*  615625 */   // Label 9960: @615625
     /*  615625 */   GIM_Try, /*On fail goto*//*Label 9961*/ GIMT_Encode4(615700), // Rule ID 5788 //
     /*  615630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  615641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  615647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  615650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615676 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615698 */     GIR_RootConstrainSelectedInstOperands,
     /*  615699 */     // GIR_Coverage, 5788,
     /*  615699 */     GIR_EraseRootFromParent_Done,
     /*  615700 */   // Label 9961: @615700
     /*  615700 */   GIM_Try, /*On fail goto*//*Label 9962*/ GIMT_Encode4(615775), // Rule ID 5789 //
     /*  615705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  615716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  615722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  615725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615751 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615773 */     GIR_RootConstrainSelectedInstOperands,
     /*  615774 */     // GIR_Coverage, 5789,
     /*  615774 */     GIR_EraseRootFromParent_Done,
     /*  615775 */   // Label 9962: @615775
     /*  615775 */   GIM_Try, /*On fail goto*//*Label 9963*/ GIMT_Encode4(615850), // Rule ID 5792 //
     /*  615780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  615791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  615794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  615797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  615800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615826 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615848 */     GIR_RootConstrainSelectedInstOperands,
     /*  615849 */     // GIR_Coverage, 5792,
     /*  615849 */     GIR_EraseRootFromParent_Done,
     /*  615850 */   // Label 9963: @615850
     /*  615850 */   GIM_Try, /*On fail goto*//*Label 9964*/ GIMT_Encode4(615925), // Rule ID 5793 //
     /*  615855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  615866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  615869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  615872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  615875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615901 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615923 */     GIR_RootConstrainSelectedInstOperands,
     /*  615924 */     // GIR_Coverage, 5793,
     /*  615924 */     GIR_EraseRootFromParent_Done,
     /*  615925 */   // Label 9964: @615925
     /*  615925 */   GIM_Try, /*On fail goto*//*Label 9965*/ GIMT_Encode4(616000), // Rule ID 5796 //
     /*  615930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  615941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  615944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  615947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  615950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  615976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615998 */     GIR_RootConstrainSelectedInstOperands,
     /*  615999 */     // GIR_Coverage, 5796,
     /*  615999 */     GIR_EraseRootFromParent_Done,
     /*  616000 */   // Label 9965: @616000
     /*  616000 */   GIM_Try, /*On fail goto*//*Label 9966*/ GIMT_Encode4(616075), // Rule ID 5797 //
     /*  616005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  616016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  616019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  616022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  616025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616051 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  616054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616073 */     GIR_RootConstrainSelectedInstOperands,
     /*  616074 */     // GIR_Coverage, 5797,
     /*  616074 */     GIR_EraseRootFromParent_Done,
     /*  616075 */   // Label 9966: @616075
     /*  616075 */   GIM_Try, /*On fail goto*//*Label 9967*/ GIMT_Encode4(616150), // Rule ID 5800 //
     /*  616080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  616091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  616094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  616097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  616100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  616126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  616129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616148 */     GIR_RootConstrainSelectedInstOperands,
     /*  616149 */     // GIR_Coverage, 5800,
     /*  616149 */     GIR_EraseRootFromParent_Done,
     /*  616150 */   // Label 9967: @616150
     /*  616150 */   GIM_Try, /*On fail goto*//*Label 9968*/ GIMT_Encode4(616225), // Rule ID 5801 //
     /*  616155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  616166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  616169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  616172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  616175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616201 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  616204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616223 */     GIR_RootConstrainSelectedInstOperands,
     /*  616224 */     // GIR_Coverage, 5801,
     /*  616224 */     GIR_EraseRootFromParent_Done,
     /*  616225 */   // Label 9968: @616225
     /*  616225 */   GIM_Try, /*On fail goto*//*Label 9969*/ GIMT_Encode4(616300), // Rule ID 5804 //
     /*  616230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  616241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  616244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  616247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  616250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  616276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  616279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616298 */     GIR_RootConstrainSelectedInstOperands,
     /*  616299 */     // GIR_Coverage, 5804,
     /*  616299 */     GIR_EraseRootFromParent_Done,
     /*  616300 */   // Label 9969: @616300
     /*  616300 */   GIM_Try, /*On fail goto*//*Label 9970*/ GIMT_Encode4(616375), // Rule ID 5805 //
     /*  616305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  616316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  616319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  616322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  616325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616351 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  616351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  616354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616373 */     GIR_RootConstrainSelectedInstOperands,
     /*  616374 */     // GIR_Coverage, 5805,
     /*  616374 */     GIR_EraseRootFromParent_Done,
     /*  616375 */   // Label 9970: @616375
     /*  616375 */   GIM_Try, /*On fail goto*//*Label 9971*/ GIMT_Encode4(616450), // Rule ID 5808 //
     /*  616380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  616391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  616394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  616397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  616400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616448 */     GIR_RootConstrainSelectedInstOperands,
     /*  616449 */     // GIR_Coverage, 5808,
     /*  616449 */     GIR_EraseRootFromParent_Done,
     /*  616450 */   // Label 9971: @616450
     /*  616450 */   GIM_Try, /*On fail goto*//*Label 9972*/ GIMT_Encode4(616525), // Rule ID 5809 //
     /*  616455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  616466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  616469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  616472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  616475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616501 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616523 */     GIR_RootConstrainSelectedInstOperands,
     /*  616524 */     // GIR_Coverage, 5809,
     /*  616524 */     GIR_EraseRootFromParent_Done,
     /*  616525 */   // Label 9972: @616525
     /*  616525 */   GIM_Try, /*On fail goto*//*Label 9973*/ GIMT_Encode4(616600), // Rule ID 5812 //
     /*  616530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  616541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  616547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  616550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  616576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616598 */     GIR_RootConstrainSelectedInstOperands,
     /*  616599 */     // GIR_Coverage, 5812,
     /*  616599 */     GIR_EraseRootFromParent_Done,
     /*  616600 */   // Label 9973: @616600
     /*  616600 */   GIM_Try, /*On fail goto*//*Label 9974*/ GIMT_Encode4(616675), // Rule ID 5813 //
     /*  616605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  616616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  616622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  616625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616651 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616673 */     GIR_RootConstrainSelectedInstOperands,
     /*  616674 */     // GIR_Coverage, 5813,
     /*  616674 */     GIR_EraseRootFromParent_Done,
     /*  616675 */   // Label 9974: @616675
     /*  616675 */   GIM_Try, /*On fail goto*//*Label 9975*/ GIMT_Encode4(616750), // Rule ID 5816 //
     /*  616680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  616691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  616697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  616700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  616726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616748 */     GIR_RootConstrainSelectedInstOperands,
     /*  616749 */     // GIR_Coverage, 5816,
     /*  616749 */     GIR_EraseRootFromParent_Done,
     /*  616750 */   // Label 9975: @616750
     /*  616750 */   GIM_Try, /*On fail goto*//*Label 9976*/ GIMT_Encode4(616825), // Rule ID 5817 //
     /*  616755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  616766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  616772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  616775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616801 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  616801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616823 */     GIR_RootConstrainSelectedInstOperands,
     /*  616824 */     // GIR_Coverage, 5817,
     /*  616824 */     GIR_EraseRootFromParent_Done,
     /*  616825 */   // Label 9976: @616825
     /*  616825 */   GIM_Try, /*On fail goto*//*Label 9977*/ GIMT_Encode4(616900), // Rule ID 5820 //
     /*  616830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  616833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  616841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  616844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  616847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  616850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  616876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  616895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616898 */     GIR_RootConstrainSelectedInstOperands,
     /*  616899 */     // GIR_Coverage, 5820,
     /*  616899 */     GIR_EraseRootFromParent_Done,
     /*  616900 */   // Label 9977: @616900
     /*  616900 */   GIM_Try, /*On fail goto*//*Label 9978*/ GIMT_Encode4(616975), // Rule ID 5821 //
     /*  616905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  616908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  616916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  616919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  616922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  616925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616951 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  616951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  616970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616973 */     GIR_RootConstrainSelectedInstOperands,
     /*  616974 */     // GIR_Coverage, 5821,
     /*  616974 */     GIR_EraseRootFromParent_Done,
     /*  616975 */   // Label 9978: @616975
     /*  616975 */   GIM_Try, /*On fail goto*//*Label 9979*/ GIMT_Encode4(617050), // Rule ID 5824 //
     /*  616980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  616991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  616994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  616997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  617000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  617026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617048 */     GIR_RootConstrainSelectedInstOperands,
     /*  617049 */     // GIR_Coverage, 5824,
     /*  617049 */     GIR_EraseRootFromParent_Done,
     /*  617050 */   // Label 9979: @617050
     /*  617050 */   GIM_Try, /*On fail goto*//*Label 9980*/ GIMT_Encode4(617125), // Rule ID 5825 //
     /*  617055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  617066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  617069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  617072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  617075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  617101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617123 */     GIR_RootConstrainSelectedInstOperands,
     /*  617124 */     // GIR_Coverage, 5825,
     /*  617124 */     GIR_EraseRootFromParent_Done,
     /*  617125 */   // Label 9980: @617125
     /*  617125 */   GIM_Try, /*On fail goto*//*Label 9981*/ GIMT_Encode4(617200), // Rule ID 5828 //
     /*  617130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  617141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  617144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  617147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  617150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617176 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  617176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617198 */     GIR_RootConstrainSelectedInstOperands,
     /*  617199 */     // GIR_Coverage, 5828,
     /*  617199 */     GIR_EraseRootFromParent_Done,
     /*  617200 */   // Label 9981: @617200
     /*  617200 */   GIM_Try, /*On fail goto*//*Label 9982*/ GIMT_Encode4(617275), // Rule ID 5829 //
     /*  617205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  617216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  617219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  617222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  617225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617251 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  617251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617273 */     GIR_RootConstrainSelectedInstOperands,
     /*  617274 */     // GIR_Coverage, 5829,
     /*  617274 */     GIR_EraseRootFromParent_Done,
     /*  617275 */   // Label 9982: @617275
     /*  617275 */   GIM_Try, /*On fail goto*//*Label 9983*/ GIMT_Encode4(617350), // Rule ID 5832 //
     /*  617280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  617291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  617294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  617297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  617300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  617326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617348 */     GIR_RootConstrainSelectedInstOperands,
     /*  617349 */     // GIR_Coverage, 5832,
     /*  617349 */     GIR_EraseRootFromParent_Done,
     /*  617350 */   // Label 9983: @617350
     /*  617350 */   GIM_Try, /*On fail goto*//*Label 9984*/ GIMT_Encode4(617425), // Rule ID 5833 //
     /*  617355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  617366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  617369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  617372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  617375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617401 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  617401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617423 */     GIR_RootConstrainSelectedInstOperands,
     /*  617424 */     // GIR_Coverage, 5833,
     /*  617424 */     GIR_EraseRootFromParent_Done,
     /*  617425 */   // Label 9984: @617425
     /*  617425 */   GIM_Try, /*On fail goto*//*Label 9985*/ GIMT_Encode4(617500), // Rule ID 5836 //
     /*  617430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  617441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  617444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  617447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  617450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617498 */     GIR_RootConstrainSelectedInstOperands,
     /*  617499 */     // GIR_Coverage, 5836,
     /*  617499 */     GIR_EraseRootFromParent_Done,
     /*  617500 */   // Label 9985: @617500
     /*  617500 */   GIM_Try, /*On fail goto*//*Label 9986*/ GIMT_Encode4(617575), // Rule ID 5837 //
     /*  617505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  617516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  617519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  617522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  617525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617573 */     GIR_RootConstrainSelectedInstOperands,
     /*  617574 */     // GIR_Coverage, 5837,
     /*  617574 */     GIR_EraseRootFromParent_Done,
     /*  617575 */   // Label 9986: @617575
     /*  617575 */   GIM_Try, /*On fail goto*//*Label 9987*/ GIMT_Encode4(617650), // Rule ID 5840 //
     /*  617580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  617591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  617597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  617600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617648 */     GIR_RootConstrainSelectedInstOperands,
     /*  617649 */     // GIR_Coverage, 5840,
     /*  617649 */     GIR_EraseRootFromParent_Done,
     /*  617650 */   // Label 9987: @617650
     /*  617650 */   GIM_Try, /*On fail goto*//*Label 9988*/ GIMT_Encode4(617725), // Rule ID 5841 //
     /*  617655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  617666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  617672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  617675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617701 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617723 */     GIR_RootConstrainSelectedInstOperands,
     /*  617724 */     // GIR_Coverage, 5841,
     /*  617724 */     GIR_EraseRootFromParent_Done,
     /*  617725 */   // Label 9988: @617725
     /*  617725 */   GIM_Try, /*On fail goto*//*Label 9989*/ GIMT_Encode4(617800), // Rule ID 5844 //
     /*  617730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  617741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  617747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  617750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617798 */     GIR_RootConstrainSelectedInstOperands,
     /*  617799 */     // GIR_Coverage, 5844,
     /*  617799 */     GIR_EraseRootFromParent_Done,
     /*  617800 */   // Label 9989: @617800
     /*  617800 */   GIM_Try, /*On fail goto*//*Label 9990*/ GIMT_Encode4(617875), // Rule ID 5845 //
     /*  617805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  617816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  617822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  617825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617851 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617873 */     GIR_RootConstrainSelectedInstOperands,
     /*  617874 */     // GIR_Coverage, 5845,
     /*  617874 */     GIR_EraseRootFromParent_Done,
     /*  617875 */   // Label 9990: @617875
     /*  617875 */   GIM_Try, /*On fail goto*//*Label 9991*/ GIMT_Encode4(617950), // Rule ID 5848 //
     /*  617880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  617891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  617894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  617897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  617900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  617926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617948 */     GIR_RootConstrainSelectedInstOperands,
     /*  617949 */     // GIR_Coverage, 5848,
     /*  617949 */     GIR_EraseRootFromParent_Done,
     /*  617950 */   // Label 9991: @617950
     /*  617950 */   GIM_Try, /*On fail goto*//*Label 9992*/ GIMT_Encode4(618025), // Rule ID 5849 //
     /*  617955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  617966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  617969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  617972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  617975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  618001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  618004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618023 */     GIR_RootConstrainSelectedInstOperands,
     /*  618024 */     // GIR_Coverage, 5849,
     /*  618024 */     GIR_EraseRootFromParent_Done,
     /*  618025 */   // Label 9992: @618025
     /*  618025 */   GIM_Try, /*On fail goto*//*Label 9993*/ GIMT_Encode4(618100), // Rule ID 5852 //
     /*  618030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  618041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  618044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  618047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  618050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  618076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  618079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618098 */     GIR_RootConstrainSelectedInstOperands,
     /*  618099 */     // GIR_Coverage, 5852,
     /*  618099 */     GIR_EraseRootFromParent_Done,
     /*  618100 */   // Label 9993: @618100
     /*  618100 */   GIM_Try, /*On fail goto*//*Label 9994*/ GIMT_Encode4(618175), // Rule ID 5853 //
     /*  618105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  618116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  618119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  618122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  618125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618151 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  618151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  618154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618173 */     GIR_RootConstrainSelectedInstOperands,
     /*  618174 */     // GIR_Coverage, 5853,
     /*  618174 */     GIR_EraseRootFromParent_Done,
     /*  618175 */   // Label 9994: @618175
     /*  618175 */   GIM_Try, /*On fail goto*//*Label 9995*/ GIMT_Encode4(618250), // Rule ID 5856 //
     /*  618180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  618191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  618194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  618197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  618200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618226 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  618226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  618229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618248 */     GIR_RootConstrainSelectedInstOperands,
     /*  618249 */     // GIR_Coverage, 5856,
     /*  618249 */     GIR_EraseRootFromParent_Done,
     /*  618250 */   // Label 9995: @618250
     /*  618250 */   GIM_Try, /*On fail goto*//*Label 9996*/ GIMT_Encode4(618325), // Rule ID 5857 //
     /*  618255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  618266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  618269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  618272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  618275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618301 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  618301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  618304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618323 */     GIR_RootConstrainSelectedInstOperands,
     /*  618324 */     // GIR_Coverage, 5857,
     /*  618324 */     GIR_EraseRootFromParent_Done,
     /*  618325 */   // Label 9996: @618325
     /*  618325 */   GIM_Try, /*On fail goto*//*Label 9997*/ GIMT_Encode4(618400), // Rule ID 5860 //
     /*  618330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  618341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  618344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  618347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  618350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  618379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618398 */     GIR_RootConstrainSelectedInstOperands,
     /*  618399 */     // GIR_Coverage, 5860,
     /*  618399 */     GIR_EraseRootFromParent_Done,
     /*  618400 */   // Label 9997: @618400
     /*  618400 */   GIM_Try, /*On fail goto*//*Label 9998*/ GIMT_Encode4(618475), // Rule ID 5861 //
     /*  618405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  618416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  618419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  618422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  618425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  618454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618473 */     GIR_RootConstrainSelectedInstOperands,
     /*  618474 */     // GIR_Coverage, 5861,
     /*  618474 */     GIR_EraseRootFromParent_Done,
     /*  618475 */   // Label 9998: @618475
     /*  618475 */   GIM_Try, /*On fail goto*//*Label 9999*/ GIMT_Encode4(618550), // Rule ID 5864 //
     /*  618480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  618491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  618497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  618500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618526 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  618529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618548 */     GIR_RootConstrainSelectedInstOperands,
     /*  618549 */     // GIR_Coverage, 5864,
     /*  618549 */     GIR_EraseRootFromParent_Done,
     /*  618550 */   // Label 9999: @618550
     /*  618550 */   GIM_Try, /*On fail goto*//*Label 10000*/ GIMT_Encode4(618625), // Rule ID 5865 //
     /*  618555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  618566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  618572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  618575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618601 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  618604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618623 */     GIR_RootConstrainSelectedInstOperands,
     /*  618624 */     // GIR_Coverage, 5865,
     /*  618624 */     GIR_EraseRootFromParent_Done,
     /*  618625 */   // Label 10000: @618625
     /*  618625 */   GIM_Try, /*On fail goto*//*Label 10001*/ GIMT_Encode4(618700), // Rule ID 5868 //
     /*  618630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  618641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  618647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  618650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  618679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618698 */     GIR_RootConstrainSelectedInstOperands,
     /*  618699 */     // GIR_Coverage, 5868,
     /*  618699 */     GIR_EraseRootFromParent_Done,
     /*  618700 */   // Label 10001: @618700
     /*  618700 */   GIM_Try, /*On fail goto*//*Label 10002*/ GIMT_Encode4(618775), // Rule ID 5869 //
     /*  618705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  618716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  618722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  618725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618751 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  618754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618773 */     GIR_RootConstrainSelectedInstOperands,
     /*  618774 */     // GIR_Coverage, 5869,
     /*  618774 */     GIR_EraseRootFromParent_Done,
     /*  618775 */   // Label 10002: @618775
     /*  618775 */   GIM_Try, /*On fail goto*//*Label 10003*/ GIMT_Encode4(618850), // Rule ID 5872 //
     /*  618780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  618791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  618794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  618797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618826 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  618829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618848 */     GIR_RootConstrainSelectedInstOperands,
     /*  618849 */     // GIR_Coverage, 5872,
     /*  618849 */     GIR_EraseRootFromParent_Done,
     /*  618850 */   // Label 10003: @618850
     /*  618850 */   GIM_Try, /*On fail goto*//*Label 10004*/ GIMT_Encode4(618925), // Rule ID 5873 //
     /*  618855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  618866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  618869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  618872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618901 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  618904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618923 */     GIR_RootConstrainSelectedInstOperands,
     /*  618924 */     // GIR_Coverage, 5873,
     /*  618924 */     GIR_EraseRootFromParent_Done,
     /*  618925 */   // Label 10004: @618925
     /*  618925 */   GIM_Try, /*On fail goto*//*Label 10005*/ GIMT_Encode4(619000), // Rule ID 5876 //
     /*  618930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  618941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  618944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  618947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618998 */     GIR_RootConstrainSelectedInstOperands,
     /*  618999 */     // GIR_Coverage, 5876,
     /*  618999 */     GIR_EraseRootFromParent_Done,
     /*  619000 */   // Label 10005: @619000
     /*  619000 */   GIM_Try, /*On fail goto*//*Label 10006*/ GIMT_Encode4(619075), // Rule ID 5877 //
     /*  619005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  619016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  619019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  619022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619051 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  619054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619073 */     GIR_RootConstrainSelectedInstOperands,
     /*  619074 */     // GIR_Coverage, 5877,
     /*  619074 */     GIR_EraseRootFromParent_Done,
     /*  619075 */   // Label 10006: @619075
     /*  619075 */   GIM_Try, /*On fail goto*//*Label 10007*/ GIMT_Encode4(619150), // Rule ID 5880 //
     /*  619080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  619091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  619094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  619097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619126 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619148 */     GIR_RootConstrainSelectedInstOperands,
     /*  619149 */     // GIR_Coverage, 5880,
     /*  619149 */     GIR_EraseRootFromParent_Done,
     /*  619150 */   // Label 10007: @619150
     /*  619150 */   GIM_Try, /*On fail goto*//*Label 10008*/ GIMT_Encode4(619225), // Rule ID 5881 //
     /*  619155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  619166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  619169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  619172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619201 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619223 */     GIR_RootConstrainSelectedInstOperands,
     /*  619224 */     // GIR_Coverage, 5881,
     /*  619224 */     GIR_EraseRootFromParent_Done,
     /*  619225 */   // Label 10008: @619225
     /*  619225 */   GIM_Try, /*On fail goto*//*Label 10009*/ GIMT_Encode4(619300), // Rule ID 5884 //
     /*  619230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  619241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  619244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  619247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  619279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619298 */     GIR_RootConstrainSelectedInstOperands,
     /*  619299 */     // GIR_Coverage, 5884,
     /*  619299 */     GIR_EraseRootFromParent_Done,
     /*  619300 */   // Label 10009: @619300
     /*  619300 */   GIM_Try, /*On fail goto*//*Label 10010*/ GIMT_Encode4(619375), // Rule ID 5885 //
     /*  619305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  619316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  619319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  619322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619351 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  619354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619373 */     GIR_RootConstrainSelectedInstOperands,
     /*  619374 */     // GIR_Coverage, 5885,
     /*  619374 */     GIR_EraseRootFromParent_Done,
     /*  619375 */   // Label 10010: @619375
     /*  619375 */   GIM_Try, /*On fail goto*//*Label 10011*/ GIMT_Encode4(619450), // Rule ID 5888 //
     /*  619380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  619391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  619394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  619397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619426 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619448 */     GIR_RootConstrainSelectedInstOperands,
     /*  619449 */     // GIR_Coverage, 5888,
     /*  619449 */     GIR_EraseRootFromParent_Done,
     /*  619450 */   // Label 10011: @619450
     /*  619450 */   GIM_Try, /*On fail goto*//*Label 10012*/ GIMT_Encode4(619525), // Rule ID 5889 //
     /*  619455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  619466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  619469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  619472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619501 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619523 */     GIR_RootConstrainSelectedInstOperands,
     /*  619524 */     // GIR_Coverage, 5889,
     /*  619524 */     GIR_EraseRootFromParent_Done,
     /*  619525 */   // Label 10012: @619525
     /*  619525 */   GIM_Try, /*On fail goto*//*Label 10013*/ GIMT_Encode4(619600), // Rule ID 5892 //
     /*  619530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  619541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  619544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  619547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619576 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  619576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619598 */     GIR_RootConstrainSelectedInstOperands,
     /*  619599 */     // GIR_Coverage, 5892,
     /*  619599 */     GIR_EraseRootFromParent_Done,
     /*  619600 */   // Label 10013: @619600
     /*  619600 */   GIM_Try, /*On fail goto*//*Label 10014*/ GIMT_Encode4(619675), // Rule ID 5893 //
     /*  619605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  619616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  619619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  619622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619651 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  619651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619673 */     GIR_RootConstrainSelectedInstOperands,
     /*  619674 */     // GIR_Coverage, 5893,
     /*  619674 */     GIR_EraseRootFromParent_Done,
     /*  619675 */   // Label 10014: @619675
     /*  619675 */   GIM_Try, /*On fail goto*//*Label 10015*/ GIMT_Encode4(619750), // Rule ID 5896 //
     /*  619680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  619691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  619694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  619697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619748 */     GIR_RootConstrainSelectedInstOperands,
     /*  619749 */     // GIR_Coverage, 5896,
     /*  619749 */     GIR_EraseRootFromParent_Done,
     /*  619750 */   // Label 10015: @619750
     /*  619750 */   GIM_Try, /*On fail goto*//*Label 10016*/ GIMT_Encode4(619825), // Rule ID 5897 //
     /*  619755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  619766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  619769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  619772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619801 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619823 */     GIR_RootConstrainSelectedInstOperands,
     /*  619824 */     // GIR_Coverage, 5897,
     /*  619824 */     GIR_EraseRootFromParent_Done,
     /*  619825 */   // Label 10016: @619825
     /*  619825 */   GIM_Try, /*On fail goto*//*Label 10017*/ GIMT_Encode4(619900), // Rule ID 5900 //
     /*  619830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  619841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  619844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  619847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619898 */     GIR_RootConstrainSelectedInstOperands,
     /*  619899 */     // GIR_Coverage, 5900,
     /*  619899 */     GIR_EraseRootFromParent_Done,
     /*  619900 */   // Label 10017: @619900
     /*  619900 */   GIM_Try, /*On fail goto*//*Label 10018*/ GIMT_Encode4(619975), // Rule ID 5901 //
     /*  619905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  619916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  619919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  619922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619951 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619973 */     GIR_RootConstrainSelectedInstOperands,
     /*  619974 */     // GIR_Coverage, 5901,
     /*  619974 */     GIR_EraseRootFromParent_Done,
     /*  619975 */   // Label 10018: @619975
     /*  619975 */   GIM_Try, /*On fail goto*//*Label 10019*/ GIMT_Encode4(620050), // Rule ID 5904 //
     /*  619980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  619991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  619994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  619997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  620026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  620029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620048 */     GIR_RootConstrainSelectedInstOperands,
     /*  620049 */     // GIR_Coverage, 5904,
     /*  620049 */     GIR_EraseRootFromParent_Done,
     /*  620050 */   // Label 10019: @620050
     /*  620050 */   GIM_Try, /*On fail goto*//*Label 10020*/ GIMT_Encode4(620125), // Rule ID 5905 //
     /*  620055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  620066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  620069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  620072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620101 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  620101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  620104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620123 */     GIR_RootConstrainSelectedInstOperands,
     /*  620124 */     // GIR_Coverage, 5905,
     /*  620124 */     GIR_EraseRootFromParent_Done,
     /*  620125 */   // Label 10020: @620125
     /*  620125 */   GIM_Try, /*On fail goto*//*Label 10021*/ GIMT_Encode4(620200), // Rule ID 5908 //
     /*  620130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  620133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  620141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  620144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  620147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620176 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  620179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620198 */     GIR_RootConstrainSelectedInstOperands,
     /*  620199 */     // GIR_Coverage, 5908,
     /*  620199 */     GIR_EraseRootFromParent_Done,
     /*  620200 */   // Label 10021: @620200
     /*  620200 */   GIM_Try, /*On fail goto*//*Label 10022*/ GIMT_Encode4(620275), // Rule ID 5909 //
     /*  620205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  620208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  620216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  620219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  620222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620251 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  620254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620273 */     GIR_RootConstrainSelectedInstOperands,
     /*  620274 */     // GIR_Coverage, 5909,
     /*  620274 */     GIR_EraseRootFromParent_Done,
     /*  620275 */   // Label 10022: @620275
     /*  620275 */   GIM_Try, /*On fail goto*//*Label 10023*/ GIMT_Encode4(620350), // Rule ID 5912 //
     /*  620280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  620291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  620294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  620297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620348 */     GIR_RootConstrainSelectedInstOperands,
     /*  620349 */     // GIR_Coverage, 5912,
     /*  620349 */     GIR_EraseRootFromParent_Done,
     /*  620350 */   // Label 10023: @620350
     /*  620350 */   GIM_Try, /*On fail goto*//*Label 10024*/ GIMT_Encode4(620425), // Rule ID 5913 //
     /*  620355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  620366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  620369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  620372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620401 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620423 */     GIR_RootConstrainSelectedInstOperands,
     /*  620424 */     // GIR_Coverage, 5913,
     /*  620424 */     GIR_EraseRootFromParent_Done,
     /*  620425 */   // Label 10024: @620425
     /*  620425 */   GIM_Try, /*On fail goto*//*Label 10025*/ GIMT_Encode4(620500), // Rule ID 5916 //
     /*  620430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  620441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  620444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  620447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620476 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620498 */     GIR_RootConstrainSelectedInstOperands,
     /*  620499 */     // GIR_Coverage, 5916,
     /*  620499 */     GIR_EraseRootFromParent_Done,
     /*  620500 */   // Label 10025: @620500
     /*  620500 */   GIM_Try, /*On fail goto*//*Label 10026*/ GIMT_Encode4(620575), // Rule ID 5917 //
     /*  620505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  620516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  620519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  620522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620551 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620573 */     GIR_RootConstrainSelectedInstOperands,
     /*  620574 */     // GIR_Coverage, 5917,
     /*  620574 */     GIR_EraseRootFromParent_Done,
     /*  620575 */   // Label 10026: @620575
     /*  620575 */   GIM_Try, /*On fail goto*//*Label 10027*/ GIMT_Encode4(620650), // Rule ID 5920 //
     /*  620580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  620591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  620594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  620597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620626 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620648 */     GIR_RootConstrainSelectedInstOperands,
     /*  620649 */     // GIR_Coverage, 5920,
     /*  620649 */     GIR_EraseRootFromParent_Done,
     /*  620650 */   // Label 10027: @620650
     /*  620650 */   GIM_Try, /*On fail goto*//*Label 10028*/ GIMT_Encode4(620725), // Rule ID 5921 //
     /*  620655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  620666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  620669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  620672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620701 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620723 */     GIR_RootConstrainSelectedInstOperands,
     /*  620724 */     // GIR_Coverage, 5921,
     /*  620724 */     GIR_EraseRootFromParent_Done,
     /*  620725 */   // Label 10028: @620725
     /*  620725 */   GIM_Try, /*On fail goto*//*Label 10029*/ GIMT_Encode4(620800), // Rule ID 5924 //
     /*  620730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  620741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  620744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  620747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620798 */     GIR_RootConstrainSelectedInstOperands,
     /*  620799 */     // GIR_Coverage, 5924,
     /*  620799 */     GIR_EraseRootFromParent_Done,
     /*  620800 */   // Label 10029: @620800
     /*  620800 */   GIM_Try, /*On fail goto*//*Label 10030*/ GIMT_Encode4(620875), // Rule ID 5925 //
     /*  620805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  620816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  620819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  620822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620873 */     GIR_RootConstrainSelectedInstOperands,
     /*  620874 */     // GIR_Coverage, 5925,
     /*  620874 */     GIR_EraseRootFromParent_Done,
     /*  620875 */   // Label 10030: @620875
     /*  620875 */   GIM_Try, /*On fail goto*//*Label 10031*/ GIMT_Encode4(620950), // Rule ID 5928 //
     /*  620880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  620891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  620894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  620897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620948 */     GIR_RootConstrainSelectedInstOperands,
     /*  620949 */     // GIR_Coverage, 5928,
     /*  620949 */     GIR_EraseRootFromParent_Done,
     /*  620950 */   // Label 10031: @620950
     /*  620950 */   GIM_Try, /*On fail goto*//*Label 10032*/ GIMT_Encode4(621025), // Rule ID 5929 //
     /*  620955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  620966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  620969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  620972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621001 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  621001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621023 */     GIR_RootConstrainSelectedInstOperands,
     /*  621024 */     // GIR_Coverage, 5929,
     /*  621024 */     GIR_EraseRootFromParent_Done,
     /*  621025 */   // Label 10032: @621025
     /*  621025 */   GIM_Try, /*On fail goto*//*Label 10033*/ GIMT_Encode4(621100), // Rule ID 5932 //
     /*  621030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  621041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  621044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  621047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621076 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  621076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621098 */     GIR_RootConstrainSelectedInstOperands,
     /*  621099 */     // GIR_Coverage, 5932,
     /*  621099 */     GIR_EraseRootFromParent_Done,
     /*  621100 */   // Label 10033: @621100
     /*  621100 */   GIM_Try, /*On fail goto*//*Label 10034*/ GIMT_Encode4(621175), // Rule ID 5933 //
     /*  621105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  621116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  621119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  621122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621151 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  621151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621173 */     GIR_RootConstrainSelectedInstOperands,
     /*  621174 */     // GIR_Coverage, 5933,
     /*  621174 */     GIR_EraseRootFromParent_Done,
     /*  621175 */   // Label 10034: @621175
     /*  621175 */   GIM_Try, /*On fail goto*//*Label 10035*/ GIMT_Encode4(621250), // Rule ID 5936 //
     /*  621180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  621191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  621194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  621197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  621229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621248 */     GIR_RootConstrainSelectedInstOperands,
     /*  621249 */     // GIR_Coverage, 5936,
     /*  621249 */     GIR_EraseRootFromParent_Done,
     /*  621250 */   // Label 10035: @621250
     /*  621250 */   GIM_Try, /*On fail goto*//*Label 10036*/ GIMT_Encode4(621325), // Rule ID 5937 //
     /*  621255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  621266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  621269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  621272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621301 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  621304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621323 */     GIR_RootConstrainSelectedInstOperands,
     /*  621324 */     // GIR_Coverage, 5937,
     /*  621324 */     GIR_EraseRootFromParent_Done,
     /*  621325 */   // Label 10036: @621325
     /*  621325 */   GIM_Try, /*On fail goto*//*Label 10037*/ GIMT_Encode4(621400), // Rule ID 5940 //
     /*  621330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  621341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  621344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  621347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621376 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621398 */     GIR_RootConstrainSelectedInstOperands,
     /*  621399 */     // GIR_Coverage, 5940,
     /*  621399 */     GIR_EraseRootFromParent_Done,
     /*  621400 */   // Label 10037: @621400
     /*  621400 */   GIM_Try, /*On fail goto*//*Label 10038*/ GIMT_Encode4(621475), // Rule ID 5941 //
     /*  621405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  621416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  621419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  621422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621451 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621473 */     GIR_RootConstrainSelectedInstOperands,
     /*  621474 */     // GIR_Coverage, 5941,
     /*  621474 */     GIR_EraseRootFromParent_Done,
     /*  621475 */   // Label 10038: @621475
     /*  621475 */   GIM_Try, /*On fail goto*//*Label 10039*/ GIMT_Encode4(621550), // Rule ID 5944 //
     /*  621480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  621491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  621494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  621497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621526 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621548 */     GIR_RootConstrainSelectedInstOperands,
     /*  621549 */     // GIR_Coverage, 5944,
     /*  621549 */     GIR_EraseRootFromParent_Done,
     /*  621550 */   // Label 10039: @621550
     /*  621550 */   GIM_Try, /*On fail goto*//*Label 10040*/ GIMT_Encode4(621625), // Rule ID 5945 //
     /*  621555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  621566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  621569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  621572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621601 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621623 */     GIR_RootConstrainSelectedInstOperands,
     /*  621624 */     // GIR_Coverage, 5945,
     /*  621624 */     GIR_EraseRootFromParent_Done,
     /*  621625 */   // Label 10040: @621625
     /*  621625 */   GIM_Try, /*On fail goto*//*Label 10041*/ GIMT_Encode4(621700), // Rule ID 5948 //
     /*  621630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  621679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621698 */     GIR_RootConstrainSelectedInstOperands,
     /*  621699 */     // GIR_Coverage, 5948,
     /*  621699 */     GIR_EraseRootFromParent_Done,
     /*  621700 */   // Label 10041: @621700
     /*  621700 */   GIM_Try, /*On fail goto*//*Label 10042*/ GIMT_Encode4(621775), // Rule ID 5949 //
     /*  621705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621751 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  621754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621773 */     GIR_RootConstrainSelectedInstOperands,
     /*  621774 */     // GIR_Coverage, 5949,
     /*  621774 */     GIR_EraseRootFromParent_Done,
     /*  621775 */   // Label 10042: @621775
     /*  621775 */   GIM_Try, /*On fail goto*//*Label 10043*/ GIMT_Encode4(621850), // Rule ID 5952 //
     /*  621780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621826 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621848 */     GIR_RootConstrainSelectedInstOperands,
     /*  621849 */     // GIR_Coverage, 5952,
     /*  621849 */     GIR_EraseRootFromParent_Done,
     /*  621850 */   // Label 10043: @621850
     /*  621850 */   GIM_Try, /*On fail goto*//*Label 10044*/ GIMT_Encode4(621925), // Rule ID 5953 //
     /*  621855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621901 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621923 */     GIR_RootConstrainSelectedInstOperands,
     /*  621924 */     // GIR_Coverage, 5953,
     /*  621924 */     GIR_EraseRootFromParent_Done,
     /*  621925 */   // Label 10044: @621925
     /*  621925 */   GIM_Try, /*On fail goto*//*Label 10045*/ GIMT_Encode4(622000), // Rule ID 5956 //
     /*  621930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  621941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  621944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  621947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621976 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621998 */     GIR_RootConstrainSelectedInstOperands,
     /*  621999 */     // GIR_Coverage, 5956,
     /*  621999 */     GIR_EraseRootFromParent_Done,
     /*  622000 */   // Label 10045: @622000
     /*  622000 */   GIM_Try, /*On fail goto*//*Label 10046*/ GIMT_Encode4(622075), // Rule ID 5957 //
     /*  622005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  622008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  622016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  622019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  622022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622051 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  622051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  622054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  622070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622073 */     GIR_RootConstrainSelectedInstOperands,
     /*  622074 */     // GIR_Coverage, 5957,
     /*  622074 */     GIR_EraseRootFromParent_Done,
     /*  622075 */   // Label 10046: @622075
     /*  622075 */   GIM_Try, /*On fail goto*//*Label 10047*/ GIMT_Encode4(622150), // Rule ID 6048 //
     /*  622080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  622091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  622094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  622097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  622100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622126 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  622129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622148 */     GIR_RootConstrainSelectedInstOperands,
     /*  622149 */     // GIR_Coverage, 6048,
     /*  622149 */     GIR_EraseRootFromParent_Done,
     /*  622150 */   // Label 10047: @622150
     /*  622150 */   GIM_Try, /*On fail goto*//*Label 10048*/ GIMT_Encode4(622225), // Rule ID 6049 //
     /*  622155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  622166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  622169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  622172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  622175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622201 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  622204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622223 */     GIR_RootConstrainSelectedInstOperands,
     /*  622224 */     // GIR_Coverage, 6049,
     /*  622224 */     GIR_EraseRootFromParent_Done,
     /*  622225 */   // Label 10048: @622225
     /*  622225 */   GIM_Try, /*On fail goto*//*Label 10049*/ GIMT_Encode4(622300), // Rule ID 6052 //
     /*  622230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  622241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  622244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  622247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  622250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622276 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  622279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622298 */     GIR_RootConstrainSelectedInstOperands,
     /*  622299 */     // GIR_Coverage, 6052,
     /*  622299 */     GIR_EraseRootFromParent_Done,
     /*  622300 */   // Label 10049: @622300
     /*  622300 */   GIM_Try, /*On fail goto*//*Label 10050*/ GIMT_Encode4(622375), // Rule ID 6053 //
     /*  622305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  622316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  622319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  622322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  622325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622351 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  622354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622373 */     GIR_RootConstrainSelectedInstOperands,
     /*  622374 */     // GIR_Coverage, 6053,
     /*  622374 */     GIR_EraseRootFromParent_Done,
     /*  622375 */   // Label 10050: @622375
     /*  622375 */   GIM_Try, /*On fail goto*//*Label 10051*/ GIMT_Encode4(622450), // Rule ID 6056 //
     /*  622380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  622391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  622394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  622397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  622400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622426 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622448 */     GIR_RootConstrainSelectedInstOperands,
     /*  622449 */     // GIR_Coverage, 6056,
     /*  622449 */     GIR_EraseRootFromParent_Done,
     /*  622450 */   // Label 10051: @622450
     /*  622450 */   GIM_Try, /*On fail goto*//*Label 10052*/ GIMT_Encode4(622525), // Rule ID 6057 //
     /*  622455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  622466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  622469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  622472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  622475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622501 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622523 */     GIR_RootConstrainSelectedInstOperands,
     /*  622524 */     // GIR_Coverage, 6057,
     /*  622524 */     GIR_EraseRootFromParent_Done,
     /*  622525 */   // Label 10052: @622525
     /*  622525 */   GIM_Try, /*On fail goto*//*Label 10053*/ GIMT_Encode4(622600), // Rule ID 6060 //
     /*  622530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  622550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622576 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  622579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622598 */     GIR_RootConstrainSelectedInstOperands,
     /*  622599 */     // GIR_Coverage, 6060,
     /*  622599 */     GIR_EraseRootFromParent_Done,
     /*  622600 */   // Label 10053: @622600
     /*  622600 */   GIM_Try, /*On fail goto*//*Label 10054*/ GIMT_Encode4(622675), // Rule ID 6061 //
     /*  622605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  622625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622651 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  622654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622673 */     GIR_RootConstrainSelectedInstOperands,
     /*  622674 */     // GIR_Coverage, 6061,
     /*  622674 */     GIR_EraseRootFromParent_Done,
     /*  622675 */   // Label 10054: @622675
     /*  622675 */   GIM_Try, /*On fail goto*//*Label 10055*/ GIMT_Encode4(622750), // Rule ID 6064 //
     /*  622680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  622700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622748 */     GIR_RootConstrainSelectedInstOperands,
     /*  622749 */     // GIR_Coverage, 6064,
     /*  622749 */     GIR_EraseRootFromParent_Done,
     /*  622750 */   // Label 10055: @622750
     /*  622750 */   GIM_Try, /*On fail goto*//*Label 10056*/ GIMT_Encode4(622825), // Rule ID 6065 //
     /*  622755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  622775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622801 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622823 */     GIR_RootConstrainSelectedInstOperands,
     /*  622824 */     // GIR_Coverage, 6065,
     /*  622824 */     GIR_EraseRootFromParent_Done,
     /*  622825 */   // Label 10056: @622825
     /*  622825 */   GIM_Try, /*On fail goto*//*Label 10057*/ GIMT_Encode4(622900), // Rule ID 6068 //
     /*  622830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  622850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622876 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  622876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622898 */     GIR_RootConstrainSelectedInstOperands,
     /*  622899 */     // GIR_Coverage, 6068,
     /*  622899 */     GIR_EraseRootFromParent_Done,
     /*  622900 */   // Label 10057: @622900
     /*  622900 */   GIM_Try, /*On fail goto*//*Label 10058*/ GIMT_Encode4(622975), // Rule ID 6069 //
     /*  622905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  622925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622951 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  622951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622973 */     GIR_RootConstrainSelectedInstOperands,
     /*  622974 */     // GIR_Coverage, 6069,
     /*  622974 */     GIR_EraseRootFromParent_Done,
     /*  622975 */   // Label 10058: @622975
     /*  622975 */   GIM_Try, /*On fail goto*//*Label 10059*/ GIMT_Encode4(623050), // Rule ID 6072 //
     /*  622980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  622991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  622994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  622997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  623000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623026 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623048 */     GIR_RootConstrainSelectedInstOperands,
     /*  623049 */     // GIR_Coverage, 6072,
     /*  623049 */     GIR_EraseRootFromParent_Done,
     /*  623050 */   // Label 10059: @623050
     /*  623050 */   GIM_Try, /*On fail goto*//*Label 10060*/ GIMT_Encode4(623125), // Rule ID 6073 //
     /*  623055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  623066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  623069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  623072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  623075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623101 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623123 */     GIR_RootConstrainSelectedInstOperands,
     /*  623124 */     // GIR_Coverage, 6073,
     /*  623124 */     GIR_EraseRootFromParent_Done,
     /*  623125 */   // Label 10060: @623125
     /*  623125 */   GIM_Try, /*On fail goto*//*Label 10061*/ GIMT_Encode4(623200), // Rule ID 6076 //
     /*  623130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  623141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  623144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  623147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  623150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623198 */     GIR_RootConstrainSelectedInstOperands,
     /*  623199 */     // GIR_Coverage, 6076,
     /*  623199 */     GIR_EraseRootFromParent_Done,
     /*  623200 */   // Label 10061: @623200
     /*  623200 */   GIM_Try, /*On fail goto*//*Label 10062*/ GIMT_Encode4(623275), // Rule ID 6077 //
     /*  623205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  623216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  623219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  623222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  623225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623251 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623273 */     GIR_RootConstrainSelectedInstOperands,
     /*  623274 */     // GIR_Coverage, 6077,
     /*  623274 */     GIR_EraseRootFromParent_Done,
     /*  623275 */   // Label 10062: @623275
     /*  623275 */   GIM_Try, /*On fail goto*//*Label 10063*/ GIMT_Encode4(623350), // Rule ID 6080 //
     /*  623280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  623291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  623294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  623297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  623300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  623326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623348 */     GIR_RootConstrainSelectedInstOperands,
     /*  623349 */     // GIR_Coverage, 6080,
     /*  623349 */     GIR_EraseRootFromParent_Done,
     /*  623350 */   // Label 10063: @623350
     /*  623350 */   GIM_Try, /*On fail goto*//*Label 10064*/ GIMT_Encode4(623425), // Rule ID 6081 //
     /*  623355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  623366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  623369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  623372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  623375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623401 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  623401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623423 */     GIR_RootConstrainSelectedInstOperands,
     /*  623424 */     // GIR_Coverage, 6081,
     /*  623424 */     GIR_EraseRootFromParent_Done,
     /*  623425 */   // Label 10064: @623425
     /*  623425 */   GIM_Try, /*On fail goto*//*Label 10065*/ GIMT_Encode4(623500), // Rule ID 6084 //
     /*  623430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  623433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  623441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  623444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  623447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  623450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  623476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623498 */     GIR_RootConstrainSelectedInstOperands,
     /*  623499 */     // GIR_Coverage, 6084,
     /*  623499 */     GIR_EraseRootFromParent_Done,
     /*  623500 */   // Label 10065: @623500
     /*  623500 */   GIM_Try, /*On fail goto*//*Label 10066*/ GIMT_Encode4(623575), // Rule ID 6085 //
     /*  623505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  623508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  623516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  623519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  623522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  623525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623551 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  623551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623573 */     GIR_RootConstrainSelectedInstOperands,
     /*  623574 */     // GIR_Coverage, 6085,
     /*  623574 */     GIR_EraseRootFromParent_Done,
     /*  623575 */   // Label 10066: @623575
     /*  623575 */   GIM_Try, /*On fail goto*//*Label 10067*/ GIMT_Encode4(623650), // Rule ID 6088 //
     /*  623580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  623600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623626 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623648 */     GIR_RootConstrainSelectedInstOperands,
     /*  623649 */     // GIR_Coverage, 6088,
     /*  623649 */     GIR_EraseRootFromParent_Done,
     /*  623650 */   // Label 10067: @623650
     /*  623650 */   GIM_Try, /*On fail goto*//*Label 10068*/ GIMT_Encode4(623725), // Rule ID 6089 //
     /*  623655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  623675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623701 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623723 */     GIR_RootConstrainSelectedInstOperands,
     /*  623724 */     // GIR_Coverage, 6089,
     /*  623724 */     GIR_EraseRootFromParent_Done,
     /*  623725 */   // Label 10068: @623725
     /*  623725 */   GIM_Try, /*On fail goto*//*Label 10069*/ GIMT_Encode4(623800), // Rule ID 6092 //
     /*  623730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  623750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623776 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623798 */     GIR_RootConstrainSelectedInstOperands,
     /*  623799 */     // GIR_Coverage, 6092,
     /*  623799 */     GIR_EraseRootFromParent_Done,
     /*  623800 */   // Label 10069: @623800
     /*  623800 */   GIM_Try, /*On fail goto*//*Label 10070*/ GIMT_Encode4(623875), // Rule ID 6093 //
     /*  623805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  623825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623851 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623873 */     GIR_RootConstrainSelectedInstOperands,
     /*  623874 */     // GIR_Coverage, 6093,
     /*  623874 */     GIR_EraseRootFromParent_Done,
     /*  623875 */   // Label 10070: @623875
     /*  623875 */   GIM_Try, /*On fail goto*//*Label 10071*/ GIMT_Encode4(623950), // Rule ID 6096 //
     /*  623880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  623891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  623894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  623897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  623900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623926 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623948 */     GIR_RootConstrainSelectedInstOperands,
     /*  623949 */     // GIR_Coverage, 6096,
     /*  623949 */     GIR_EraseRootFromParent_Done,
     /*  623950 */   // Label 10071: @623950
     /*  623950 */   GIM_Try, /*On fail goto*//*Label 10072*/ GIMT_Encode4(624025), // Rule ID 6097 //
     /*  623955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  623966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  623969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  623972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  623975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624001 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  624001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624023 */     GIR_RootConstrainSelectedInstOperands,
     /*  624024 */     // GIR_Coverage, 6097,
     /*  624024 */     GIR_EraseRootFromParent_Done,
     /*  624025 */   // Label 10072: @624025
     /*  624025 */   GIM_Try, /*On fail goto*//*Label 10073*/ GIMT_Encode4(624100), // Rule ID 6100 //
     /*  624030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  624041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  624044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  624047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  624050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624076 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624098 */     GIR_RootConstrainSelectedInstOperands,
     /*  624099 */     // GIR_Coverage, 6100,
     /*  624099 */     GIR_EraseRootFromParent_Done,
     /*  624100 */   // Label 10073: @624100
     /*  624100 */   GIM_Try, /*On fail goto*//*Label 10074*/ GIMT_Encode4(624175), // Rule ID 6101 //
     /*  624105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  624116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  624119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  624122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  624125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624151 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624173 */     GIR_RootConstrainSelectedInstOperands,
     /*  624174 */     // GIR_Coverage, 6101,
     /*  624174 */     GIR_EraseRootFromParent_Done,
     /*  624175 */   // Label 10074: @624175
     /*  624175 */   GIM_Try, /*On fail goto*//*Label 10075*/ GIMT_Encode4(624250), // Rule ID 6104 //
     /*  624180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  624191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  624194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  624197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  624200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624226 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624248 */     GIR_RootConstrainSelectedInstOperands,
     /*  624249 */     // GIR_Coverage, 6104,
     /*  624249 */     GIR_EraseRootFromParent_Done,
     /*  624250 */   // Label 10075: @624250
     /*  624250 */   GIM_Try, /*On fail goto*//*Label 10076*/ GIMT_Encode4(624325), // Rule ID 6105 //
     /*  624255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  624266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  624269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  624272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  624275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624301 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624323 */     GIR_RootConstrainSelectedInstOperands,
     /*  624324 */     // GIR_Coverage, 6105,
     /*  624324 */     GIR_EraseRootFromParent_Done,
     /*  624325 */   // Label 10076: @624325
     /*  624325 */   GIM_Try, /*On fail goto*//*Label 10077*/ GIMT_Encode4(624400), // Rule ID 6108 //
     /*  624330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  624341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  624344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  624347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  624350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624376 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624398 */     GIR_RootConstrainSelectedInstOperands,
     /*  624399 */     // GIR_Coverage, 6108,
     /*  624399 */     GIR_EraseRootFromParent_Done,
     /*  624400 */   // Label 10077: @624400
     /*  624400 */   GIM_Try, /*On fail goto*//*Label 10078*/ GIMT_Encode4(624475), // Rule ID 6109 //
     /*  624405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  624416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  624419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  624422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  624425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624451 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624473 */     GIR_RootConstrainSelectedInstOperands,
     /*  624474 */     // GIR_Coverage, 6109,
     /*  624474 */     GIR_EraseRootFromParent_Done,
     /*  624475 */   // Label 10078: @624475
     /*  624475 */   GIM_Try, /*On fail goto*//*Label 10079*/ GIMT_Encode4(624550), // Rule ID 6112 //
     /*  624480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  624500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624548 */     GIR_RootConstrainSelectedInstOperands,
     /*  624549 */     // GIR_Coverage, 6112,
     /*  624549 */     GIR_EraseRootFromParent_Done,
     /*  624550 */   // Label 10079: @624550
     /*  624550 */   GIM_Try, /*On fail goto*//*Label 10080*/ GIMT_Encode4(624625), // Rule ID 6113 //
     /*  624555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  624575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624623 */     GIR_RootConstrainSelectedInstOperands,
     /*  624624 */     // GIR_Coverage, 6113,
     /*  624624 */     GIR_EraseRootFromParent_Done,
     /*  624625 */   // Label 10080: @624625
     /*  624625 */   GIM_Try, /*On fail goto*//*Label 10081*/ GIMT_Encode4(624700), // Rule ID 6116 //
     /*  624630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  624650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624676 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624698 */     GIR_RootConstrainSelectedInstOperands,
     /*  624699 */     // GIR_Coverage, 6116,
     /*  624699 */     GIR_EraseRootFromParent_Done,
     /*  624700 */   // Label 10081: @624700
     /*  624700 */   GIM_Try, /*On fail goto*//*Label 10082*/ GIMT_Encode4(624775), // Rule ID 6117 //
     /*  624705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  624725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624751 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624773 */     GIR_RootConstrainSelectedInstOperands,
     /*  624774 */     // GIR_Coverage, 6117,
     /*  624774 */     GIR_EraseRootFromParent_Done,
     /*  624775 */   // Label 10082: @624775
     /*  624775 */   GIM_Try, /*On fail goto*//*Label 10083*/ GIMT_Encode4(624850), // Rule ID 6120 //
     /*  624780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  624800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624826 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624848 */     GIR_RootConstrainSelectedInstOperands,
     /*  624849 */     // GIR_Coverage, 6120,
     /*  624849 */     GIR_EraseRootFromParent_Done,
     /*  624850 */   // Label 10083: @624850
     /*  624850 */   GIM_Try, /*On fail goto*//*Label 10084*/ GIMT_Encode4(624925), // Rule ID 6121 //
     /*  624855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  624875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624901 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624923 */     GIR_RootConstrainSelectedInstOperands,
     /*  624924 */     // GIR_Coverage, 6121,
     /*  624924 */     GIR_EraseRootFromParent_Done,
     /*  624925 */   // Label 10084: @624925
     /*  624925 */   GIM_Try, /*On fail goto*//*Label 10085*/ GIMT_Encode4(625000), // Rule ID 6124 //
     /*  624930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  624933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  624941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  624944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  624947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  624950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  624976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624998 */     GIR_RootConstrainSelectedInstOperands,
     /*  624999 */     // GIR_Coverage, 6124,
     /*  624999 */     GIR_EraseRootFromParent_Done,
     /*  625000 */   // Label 10085: @625000
     /*  625000 */   GIM_Try, /*On fail goto*//*Label 10086*/ GIMT_Encode4(625075), // Rule ID 6125 //
     /*  625005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  625016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  625019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  625022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  625025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625051 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  625054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625073 */     GIR_RootConstrainSelectedInstOperands,
     /*  625074 */     // GIR_Coverage, 6125,
     /*  625074 */     GIR_EraseRootFromParent_Done,
     /*  625075 */   // Label 10086: @625075
     /*  625075 */   GIM_Try, /*On fail goto*//*Label 10087*/ GIMT_Encode4(625150), // Rule ID 6128 //
     /*  625080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  625091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  625094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  625097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  625100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625126 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  625129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625148 */     GIR_RootConstrainSelectedInstOperands,
     /*  625149 */     // GIR_Coverage, 6128,
     /*  625149 */     GIR_EraseRootFromParent_Done,
     /*  625150 */   // Label 10087: @625150
     /*  625150 */   GIM_Try, /*On fail goto*//*Label 10088*/ GIMT_Encode4(625225), // Rule ID 6129 //
     /*  625155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  625166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  625169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  625172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  625175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625201 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  625204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625223 */     GIR_RootConstrainSelectedInstOperands,
     /*  625224 */     // GIR_Coverage, 6129,
     /*  625224 */     GIR_EraseRootFromParent_Done,
     /*  625225 */   // Label 10088: @625225
     /*  625225 */   GIM_Try, /*On fail goto*//*Label 10089*/ GIMT_Encode4(625300), // Rule ID 6132 //
     /*  625230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  625241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  625244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  625247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  625250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625276 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  625279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625298 */     GIR_RootConstrainSelectedInstOperands,
     /*  625299 */     // GIR_Coverage, 6132,
     /*  625299 */     GIR_EraseRootFromParent_Done,
     /*  625300 */   // Label 10089: @625300
     /*  625300 */   GIM_Try, /*On fail goto*//*Label 10090*/ GIMT_Encode4(625375), // Rule ID 6133 //
     /*  625305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  625316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  625319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  625322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  625325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625351 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  625354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625373 */     GIR_RootConstrainSelectedInstOperands,
     /*  625374 */     // GIR_Coverage, 6133,
     /*  625374 */     GIR_EraseRootFromParent_Done,
     /*  625375 */   // Label 10090: @625375
     /*  625375 */   GIM_Try, /*On fail goto*//*Label 10091*/ GIMT_Encode4(625450), // Rule ID 6136 //
     /*  625380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  625391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  625394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  625397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625426 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  625429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625448 */     GIR_RootConstrainSelectedInstOperands,
     /*  625449 */     // GIR_Coverage, 6136,
     /*  625449 */     GIR_EraseRootFromParent_Done,
     /*  625450 */   // Label 10091: @625450
     /*  625450 */   GIM_Try, /*On fail goto*//*Label 10092*/ GIMT_Encode4(625525), // Rule ID 6137 //
     /*  625455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  625466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  625469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  625472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625501 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  625504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625523 */     GIR_RootConstrainSelectedInstOperands,
     /*  625524 */     // GIR_Coverage, 6137,
     /*  625524 */     GIR_EraseRootFromParent_Done,
     /*  625525 */   // Label 10092: @625525
     /*  625525 */   GIM_Try, /*On fail goto*//*Label 10093*/ GIMT_Encode4(625600), // Rule ID 6140 //
     /*  625530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625576 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625598 */     GIR_RootConstrainSelectedInstOperands,
     /*  625599 */     // GIR_Coverage, 6140,
     /*  625599 */     GIR_EraseRootFromParent_Done,
     /*  625600 */   // Label 10093: @625600
     /*  625600 */   GIM_Try, /*On fail goto*//*Label 10094*/ GIMT_Encode4(625675), // Rule ID 6141 //
     /*  625605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625651 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625673 */     GIR_RootConstrainSelectedInstOperands,
     /*  625674 */     // GIR_Coverage, 6141,
     /*  625674 */     GIR_EraseRootFromParent_Done,
     /*  625675 */   // Label 10094: @625675
     /*  625675 */   GIM_Try, /*On fail goto*//*Label 10095*/ GIMT_Encode4(625750), // Rule ID 6144 //
     /*  625680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625726 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625748 */     GIR_RootConstrainSelectedInstOperands,
     /*  625749 */     // GIR_Coverage, 6144,
     /*  625749 */     GIR_EraseRootFromParent_Done,
     /*  625750 */   // Label 10095: @625750
     /*  625750 */   GIM_Try, /*On fail goto*//*Label 10096*/ GIMT_Encode4(625825), // Rule ID 6145 //
     /*  625755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625801 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625823 */     GIR_RootConstrainSelectedInstOperands,
     /*  625824 */     // GIR_Coverage, 6145,
     /*  625824 */     GIR_EraseRootFromParent_Done,
     /*  625825 */   // Label 10096: @625825
     /*  625825 */   GIM_Try, /*On fail goto*//*Label 10097*/ GIMT_Encode4(625900), // Rule ID 6148 //
     /*  625830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625876 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  625876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625898 */     GIR_RootConstrainSelectedInstOperands,
     /*  625899 */     // GIR_Coverage, 6148,
     /*  625899 */     GIR_EraseRootFromParent_Done,
     /*  625900 */   // Label 10097: @625900
     /*  625900 */   GIM_Try, /*On fail goto*//*Label 10098*/ GIMT_Encode4(625975), // Rule ID 6149 //
     /*  625905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625951 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  625951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625973 */     GIR_RootConstrainSelectedInstOperands,
     /*  625974 */     // GIR_Coverage, 6149,
     /*  625974 */     GIR_EraseRootFromParent_Done,
     /*  625975 */   // Label 10098: @625975
     /*  625975 */   GIM_Try, /*On fail goto*//*Label 10099*/ GIMT_Encode4(626050), // Rule ID 6152 //
     /*  625980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  625991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  625994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  625997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626026 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  626029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626048 */     GIR_RootConstrainSelectedInstOperands,
     /*  626049 */     // GIR_Coverage, 6152,
     /*  626049 */     GIR_EraseRootFromParent_Done,
     /*  626050 */   // Label 10099: @626050
     /*  626050 */   GIM_Try, /*On fail goto*//*Label 10100*/ GIMT_Encode4(626125), // Rule ID 6153 //
     /*  626055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  626066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  626069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  626072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626101 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  626104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626123 */     GIR_RootConstrainSelectedInstOperands,
     /*  626124 */     // GIR_Coverage, 6153,
     /*  626124 */     GIR_EraseRootFromParent_Done,
     /*  626125 */   // Label 10100: @626125
     /*  626125 */   GIM_Try, /*On fail goto*//*Label 10101*/ GIMT_Encode4(626200), // Rule ID 6156 //
     /*  626130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  626141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  626144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  626147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  626179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626198 */     GIR_RootConstrainSelectedInstOperands,
     /*  626199 */     // GIR_Coverage, 6156,
     /*  626199 */     GIR_EraseRootFromParent_Done,
     /*  626200 */   // Label 10101: @626200
     /*  626200 */   GIM_Try, /*On fail goto*//*Label 10102*/ GIMT_Encode4(626275), // Rule ID 6157 //
     /*  626205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  626216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  626219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  626222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626251 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  626254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626273 */     GIR_RootConstrainSelectedInstOperands,
     /*  626274 */     // GIR_Coverage, 6157,
     /*  626274 */     GIR_EraseRootFromParent_Done,
     /*  626275 */   // Label 10102: @626275
     /*  626275 */   GIM_Try, /*On fail goto*//*Label 10103*/ GIMT_Encode4(626350), // Rule ID 6160 //
     /*  626280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  626291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  626294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  626297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626326 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626348 */     GIR_RootConstrainSelectedInstOperands,
     /*  626349 */     // GIR_Coverage, 6160,
     /*  626349 */     GIR_EraseRootFromParent_Done,
     /*  626350 */   // Label 10103: @626350
     /*  626350 */   GIM_Try, /*On fail goto*//*Label 10104*/ GIMT_Encode4(626425), // Rule ID 6161 //
     /*  626355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  626366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  626369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  626372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626401 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626423 */     GIR_RootConstrainSelectedInstOperands,
     /*  626424 */     // GIR_Coverage, 6161,
     /*  626424 */     GIR_EraseRootFromParent_Done,
     /*  626425 */   // Label 10104: @626425
     /*  626425 */   GIM_Try, /*On fail goto*//*Label 10105*/ GIMT_Encode4(626500), // Rule ID 6164 //
     /*  626430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  626441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  626444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  626447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626498 */     GIR_RootConstrainSelectedInstOperands,
     /*  626499 */     // GIR_Coverage, 6164,
     /*  626499 */     GIR_EraseRootFromParent_Done,
     /*  626500 */   // Label 10105: @626500
     /*  626500 */   GIM_Try, /*On fail goto*//*Label 10106*/ GIMT_Encode4(626575), // Rule ID 6165 //
     /*  626505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  626516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  626519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  626522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626551 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626573 */     GIR_RootConstrainSelectedInstOperands,
     /*  626574 */     // GIR_Coverage, 6165,
     /*  626574 */     GIR_EraseRootFromParent_Done,
     /*  626575 */   // Label 10106: @626575
     /*  626575 */   GIM_Try, /*On fail goto*//*Label 10107*/ GIMT_Encode4(626650), // Rule ID 6168 //
     /*  626580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626648 */     GIR_RootConstrainSelectedInstOperands,
     /*  626649 */     // GIR_Coverage, 6168,
     /*  626649 */     GIR_EraseRootFromParent_Done,
     /*  626650 */   // Label 10107: @626650
     /*  626650 */   GIM_Try, /*On fail goto*//*Label 10108*/ GIMT_Encode4(626725), // Rule ID 6169 //
     /*  626655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626701 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626723 */     GIR_RootConstrainSelectedInstOperands,
     /*  626724 */     // GIR_Coverage, 6169,
     /*  626724 */     GIR_EraseRootFromParent_Done,
     /*  626725 */   // Label 10108: @626725
     /*  626725 */   GIM_Try, /*On fail goto*//*Label 10109*/ GIMT_Encode4(626800), // Rule ID 6172 //
     /*  626730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  626733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626776 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  626776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626798 */     GIR_RootConstrainSelectedInstOperands,
     /*  626799 */     // GIR_Coverage, 6172,
     /*  626799 */     GIR_EraseRootFromParent_Done,
     /*  626800 */   // Label 10109: @626800
     /*  626800 */   GIM_Try, /*On fail goto*//*Label 10110*/ GIMT_Encode4(626875), // Rule ID 6173 //
     /*  626805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  626808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626851 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  626851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626873 */     GIR_RootConstrainSelectedInstOperands,
     /*  626874 */     // GIR_Coverage, 6173,
     /*  626874 */     GIR_EraseRootFromParent_Done,
     /*  626875 */   // Label 10110: @626875
     /*  626875 */   GIM_Try, /*On fail goto*//*Label 10111*/ GIMT_Encode4(626950), // Rule ID 6176 //
     /*  626880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  626891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  626894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  626897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626926 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626948 */     GIR_RootConstrainSelectedInstOperands,
     /*  626949 */     // GIR_Coverage, 6176,
     /*  626949 */     GIR_EraseRootFromParent_Done,
     /*  626950 */   // Label 10111: @626950
     /*  626950 */   GIM_Try, /*On fail goto*//*Label 10112*/ GIMT_Encode4(627025), // Rule ID 6177 //
     /*  626955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  626966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  626969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  626972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627001 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627023 */     GIR_RootConstrainSelectedInstOperands,
     /*  627024 */     // GIR_Coverage, 6177,
     /*  627024 */     GIR_EraseRootFromParent_Done,
     /*  627025 */   // Label 10112: @627025
     /*  627025 */   GIM_Try, /*On fail goto*//*Label 10113*/ GIMT_Encode4(627100), // Rule ID 6180 //
     /*  627030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  627041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  627044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  627047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627076 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  627076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627098 */     GIR_RootConstrainSelectedInstOperands,
     /*  627099 */     // GIR_Coverage, 6180,
     /*  627099 */     GIR_EraseRootFromParent_Done,
     /*  627100 */   // Label 10113: @627100
     /*  627100 */   GIM_Try, /*On fail goto*//*Label 10114*/ GIMT_Encode4(627175), // Rule ID 6181 //
     /*  627105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  627116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  627119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  627122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627151 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627173 */     GIR_RootConstrainSelectedInstOperands,
     /*  627174 */     // GIR_Coverage, 6181,
     /*  627174 */     GIR_EraseRootFromParent_Done,
     /*  627175 */   // Label 10114: @627175
     /*  627175 */   GIM_Try, /*On fail goto*//*Label 10115*/ GIMT_Encode4(627250), // Rule ID 6184 //
     /*  627180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  627191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  627194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  627197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627226 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  627226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627248 */     GIR_RootConstrainSelectedInstOperands,
     /*  627249 */     // GIR_Coverage, 6184,
     /*  627249 */     GIR_EraseRootFromParent_Done,
     /*  627250 */   // Label 10115: @627250
     /*  627250 */   GIM_Try, /*On fail goto*//*Label 10116*/ GIMT_Encode4(627325), // Rule ID 6185 //
     /*  627255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  627266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  627269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  627272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627301 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627323 */     GIR_RootConstrainSelectedInstOperands,
     /*  627324 */     // GIR_Coverage, 6185,
     /*  627324 */     GIR_EraseRootFromParent_Done,
     /*  627325 */   // Label 10116: @627325
     /*  627325 */   GIM_Try, /*On fail goto*//*Label 10117*/ GIMT_Encode4(627400), // Rule ID 6188 //
     /*  627330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  627341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  627344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  627347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627398 */     GIR_RootConstrainSelectedInstOperands,
     /*  627399 */     // GIR_Coverage, 6188,
     /*  627399 */     GIR_EraseRootFromParent_Done,
     /*  627400 */   // Label 10117: @627400
     /*  627400 */   GIM_Try, /*On fail goto*//*Label 10118*/ GIMT_Encode4(627475), // Rule ID 6189 //
     /*  627405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  627416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  627419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  627422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627451 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627473 */     GIR_RootConstrainSelectedInstOperands,
     /*  627474 */     // GIR_Coverage, 6189,
     /*  627474 */     GIR_EraseRootFromParent_Done,
     /*  627475 */   // Label 10118: @627475
     /*  627475 */   GIM_Try, /*On fail goto*//*Label 10119*/ GIMT_Encode4(627550), // Rule ID 6192 //
     /*  627480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627526 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627548 */     GIR_RootConstrainSelectedInstOperands,
     /*  627549 */     // GIR_Coverage, 6192,
     /*  627549 */     GIR_EraseRootFromParent_Done,
     /*  627550 */   // Label 10119: @627550
     /*  627550 */   GIM_Try, /*On fail goto*//*Label 10120*/ GIMT_Encode4(627625), // Rule ID 6193 //
     /*  627555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627601 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627623 */     GIR_RootConstrainSelectedInstOperands,
     /*  627624 */     // GIR_Coverage, 6193,
     /*  627624 */     GIR_EraseRootFromParent_Done,
     /*  627625 */   // Label 10120: @627625
     /*  627625 */   GIM_Try, /*On fail goto*//*Label 10121*/ GIMT_Encode4(627700), // Rule ID 6196 //
     /*  627630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627676 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627698 */     GIR_RootConstrainSelectedInstOperands,
     /*  627699 */     // GIR_Coverage, 6196,
     /*  627699 */     GIR_EraseRootFromParent_Done,
     /*  627700 */   // Label 10121: @627700
     /*  627700 */   GIM_Try, /*On fail goto*//*Label 10122*/ GIMT_Encode4(627775), // Rule ID 6197 //
     /*  627705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627751 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627773 */     GIR_RootConstrainSelectedInstOperands,
     /*  627774 */     // GIR_Coverage, 6197,
     /*  627774 */     GIR_EraseRootFromParent_Done,
     /*  627775 */   // Label 10122: @627775
     /*  627775 */   GIM_Try, /*On fail goto*//*Label 10123*/ GIMT_Encode4(627850), // Rule ID 6200 //
     /*  627780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627826 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627848 */     GIR_RootConstrainSelectedInstOperands,
     /*  627849 */     // GIR_Coverage, 6200,
     /*  627849 */     GIR_EraseRootFromParent_Done,
     /*  627850 */   // Label 10123: @627850
     /*  627850 */   GIM_Try, /*On fail goto*//*Label 10124*/ GIMT_Encode4(627925), // Rule ID 6201 //
     /*  627855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627923 */     GIR_RootConstrainSelectedInstOperands,
     /*  627924 */     // GIR_Coverage, 6201,
     /*  627924 */     GIR_EraseRootFromParent_Done,
     /*  627925 */   // Label 10124: @627925
     /*  627925 */   GIM_Try, /*On fail goto*//*Label 10125*/ GIMT_Encode4(628000), // Rule ID 6204 //
     /*  627930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  627941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  627944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  627947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627998 */     GIR_RootConstrainSelectedInstOperands,
     /*  627999 */     // GIR_Coverage, 6204,
     /*  627999 */     GIR_EraseRootFromParent_Done,
     /*  628000 */   // Label 10125: @628000
     /*  628000 */   GIM_Try, /*On fail goto*//*Label 10126*/ GIMT_Encode4(628075), // Rule ID 6205 //
     /*  628005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  628016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  628019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  628022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628051 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  628051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  628054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628073 */     GIR_RootConstrainSelectedInstOperands,
     /*  628074 */     // GIR_Coverage, 6205,
     /*  628074 */     GIR_EraseRootFromParent_Done,
     /*  628075 */   // Label 10126: @628075
     /*  628075 */   GIM_Try, /*On fail goto*//*Label 10127*/ GIMT_Encode4(628150), // Rule ID 6208 //
     /*  628080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  628091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  628094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  628097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628126 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  628126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  628129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628148 */     GIR_RootConstrainSelectedInstOperands,
     /*  628149 */     // GIR_Coverage, 6208,
     /*  628149 */     GIR_EraseRootFromParent_Done,
     /*  628150 */   // Label 10127: @628150
     /*  628150 */   GIM_Try, /*On fail goto*//*Label 10128*/ GIMT_Encode4(628225), // Rule ID 6209 //
     /*  628155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  628166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  628169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  628172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628201 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  628201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  628204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628223 */     GIR_RootConstrainSelectedInstOperands,
     /*  628224 */     // GIR_Coverage, 6209,
     /*  628224 */     GIR_EraseRootFromParent_Done,
     /*  628225 */   // Label 10128: @628225
     /*  628225 */   GIM_Try, /*On fail goto*//*Label 10129*/ GIMT_Encode4(628300), // Rule ID 6212 //
     /*  628230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  628241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  628244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  628247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  628279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628298 */     GIR_RootConstrainSelectedInstOperands,
     /*  628299 */     // GIR_Coverage, 6212,
     /*  628299 */     GIR_EraseRootFromParent_Done,
     /*  628300 */   // Label 10129: @628300
     /*  628300 */   GIM_Try, /*On fail goto*//*Label 10130*/ GIMT_Encode4(628375), // Rule ID 6213 //
     /*  628305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  628316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  628319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  628322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628351 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  628354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628373 */     GIR_RootConstrainSelectedInstOperands,
     /*  628374 */     // GIR_Coverage, 6213,
     /*  628374 */     GIR_EraseRootFromParent_Done,
     /*  628375 */   // Label 10130: @628375
     /*  628375 */   GIM_Try, /*On fail goto*//*Label 10131*/ GIMT_Encode4(628450), // Rule ID 6216 //
     /*  628380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  628391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  628394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  628397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628426 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  628429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628448 */     GIR_RootConstrainSelectedInstOperands,
     /*  628449 */     // GIR_Coverage, 6216,
     /*  628449 */     GIR_EraseRootFromParent_Done,
     /*  628450 */   // Label 10131: @628450
     /*  628450 */   GIM_Try, /*On fail goto*//*Label 10132*/ GIMT_Encode4(628525), // Rule ID 6217 //
     /*  628455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  628466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  628469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  628472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628501 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  628504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628523 */     GIR_RootConstrainSelectedInstOperands,
     /*  628524 */     // GIR_Coverage, 6217,
     /*  628524 */     GIR_EraseRootFromParent_Done,
     /*  628525 */   // Label 10132: @628525
     /*  628525 */   GIM_Try, /*On fail goto*//*Label 10133*/ GIMT_Encode4(628600), // Rule ID 6220 //
     /*  628530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  628579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628598 */     GIR_RootConstrainSelectedInstOperands,
     /*  628599 */     // GIR_Coverage, 6220,
     /*  628599 */     GIR_EraseRootFromParent_Done,
     /*  628600 */   // Label 10133: @628600
     /*  628600 */   GIM_Try, /*On fail goto*//*Label 10134*/ GIMT_Encode4(628675), // Rule ID 6221 //
     /*  628605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628651 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  628654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628673 */     GIR_RootConstrainSelectedInstOperands,
     /*  628674 */     // GIR_Coverage, 6221,
     /*  628674 */     GIR_EraseRootFromParent_Done,
     /*  628675 */   // Label 10134: @628675
     /*  628675 */   GIM_Try, /*On fail goto*//*Label 10135*/ GIMT_Encode4(628750), // Rule ID 6312 //
     /*  628680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  628700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  628729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628748 */     GIR_RootConstrainSelectedInstOperands,
     /*  628749 */     // GIR_Coverage, 6312,
     /*  628749 */     GIR_EraseRootFromParent_Done,
     /*  628750 */   // Label 10135: @628750
     /*  628750 */   GIM_Try, /*On fail goto*//*Label 10136*/ GIMT_Encode4(628825), // Rule ID 6313 //
     /*  628755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  628775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628801 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  628804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628823 */     GIR_RootConstrainSelectedInstOperands,
     /*  628824 */     // GIR_Coverage, 6313,
     /*  628824 */     GIR_EraseRootFromParent_Done,
     /*  628825 */   // Label 10136: @628825
     /*  628825 */   GIM_Try, /*On fail goto*//*Label 10137*/ GIMT_Encode4(628900), // Rule ID 6316 //
     /*  628830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  628850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628876 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628898 */     GIR_RootConstrainSelectedInstOperands,
     /*  628899 */     // GIR_Coverage, 6316,
     /*  628899 */     GIR_EraseRootFromParent_Done,
     /*  628900 */   // Label 10137: @628900
     /*  628900 */   GIM_Try, /*On fail goto*//*Label 10138*/ GIMT_Encode4(628975), // Rule ID 6317 //
     /*  628905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  628925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628951 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628973 */     GIR_RootConstrainSelectedInstOperands,
     /*  628974 */     // GIR_Coverage, 6317,
     /*  628974 */     GIR_EraseRootFromParent_Done,
     /*  628975 */   // Label 10138: @628975
     /*  628975 */   GIM_Try, /*On fail goto*//*Label 10139*/ GIMT_Encode4(629050), // Rule ID 6320 //
     /*  628980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  628991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  628994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  628997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  629000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629026 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629048 */     GIR_RootConstrainSelectedInstOperands,
     /*  629049 */     // GIR_Coverage, 6320,
     /*  629049 */     GIR_EraseRootFromParent_Done,
     /*  629050 */   // Label 10139: @629050
     /*  629050 */   GIM_Try, /*On fail goto*//*Label 10140*/ GIMT_Encode4(629125), // Rule ID 6321 //
     /*  629055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  629066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  629069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  629072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  629075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629101 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629123 */     GIR_RootConstrainSelectedInstOperands,
     /*  629124 */     // GIR_Coverage, 6321,
     /*  629124 */     GIR_EraseRootFromParent_Done,
     /*  629125 */   // Label 10140: @629125
     /*  629125 */   GIM_Try, /*On fail goto*//*Label 10141*/ GIMT_Encode4(629200), // Rule ID 6324 //
     /*  629130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  629141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  629144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  629147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  629150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629176 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  629179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629198 */     GIR_RootConstrainSelectedInstOperands,
     /*  629199 */     // GIR_Coverage, 6324,
     /*  629199 */     GIR_EraseRootFromParent_Done,
     /*  629200 */   // Label 10141: @629200
     /*  629200 */   GIM_Try, /*On fail goto*//*Label 10142*/ GIMT_Encode4(629275), // Rule ID 6325 //
     /*  629205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  629216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  629219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  629222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  629225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629251 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  629254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629273 */     GIR_RootConstrainSelectedInstOperands,
     /*  629274 */     // GIR_Coverage, 6325,
     /*  629274 */     GIR_EraseRootFromParent_Done,
     /*  629275 */   // Label 10142: @629275
     /*  629275 */   GIM_Try, /*On fail goto*//*Label 10143*/ GIMT_Encode4(629350), // Rule ID 6328 //
     /*  629280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  629291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  629294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  629297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  629300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629326 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629348 */     GIR_RootConstrainSelectedInstOperands,
     /*  629349 */     // GIR_Coverage, 6328,
     /*  629349 */     GIR_EraseRootFromParent_Done,
     /*  629350 */   // Label 10143: @629350
     /*  629350 */   GIM_Try, /*On fail goto*//*Label 10144*/ GIMT_Encode4(629425), // Rule ID 6329 //
     /*  629355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  629366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  629369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  629372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  629375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629401 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629423 */     GIR_RootConstrainSelectedInstOperands,
     /*  629424 */     // GIR_Coverage, 6329,
     /*  629424 */     GIR_EraseRootFromParent_Done,
     /*  629425 */   // Label 10144: @629425
     /*  629425 */   GIM_Try, /*On fail goto*//*Label 10145*/ GIMT_Encode4(629500), // Rule ID 6332 //
     /*  629430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  629441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  629444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  629447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  629450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629476 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629498 */     GIR_RootConstrainSelectedInstOperands,
     /*  629499 */     // GIR_Coverage, 6332,
     /*  629499 */     GIR_EraseRootFromParent_Done,
     /*  629500 */   // Label 10145: @629500
     /*  629500 */   GIM_Try, /*On fail goto*//*Label 10146*/ GIMT_Encode4(629575), // Rule ID 6333 //
     /*  629505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  629516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  629519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  629522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  629525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629551 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  629551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629573 */     GIR_RootConstrainSelectedInstOperands,
     /*  629574 */     // GIR_Coverage, 6333,
     /*  629574 */     GIR_EraseRootFromParent_Done,
     /*  629575 */   // Label 10146: @629575
     /*  629575 */   GIM_Try, /*On fail goto*//*Label 10147*/ GIMT_Encode4(629650), // Rule ID 6336 //
     /*  629580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  629600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629626 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629648 */     GIR_RootConstrainSelectedInstOperands,
     /*  629649 */     // GIR_Coverage, 6336,
     /*  629649 */     GIR_EraseRootFromParent_Done,
     /*  629650 */   // Label 10147: @629650
     /*  629650 */   GIM_Try, /*On fail goto*//*Label 10148*/ GIMT_Encode4(629725), // Rule ID 6337 //
     /*  629655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  629675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629701 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629723 */     GIR_RootConstrainSelectedInstOperands,
     /*  629724 */     // GIR_Coverage, 6337,
     /*  629724 */     GIR_EraseRootFromParent_Done,
     /*  629725 */   // Label 10148: @629725
     /*  629725 */   GIM_Try, /*On fail goto*//*Label 10149*/ GIMT_Encode4(629800), // Rule ID 6340 //
     /*  629730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  629750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629776 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629798 */     GIR_RootConstrainSelectedInstOperands,
     /*  629799 */     // GIR_Coverage, 6340,
     /*  629799 */     GIR_EraseRootFromParent_Done,
     /*  629800 */   // Label 10149: @629800
     /*  629800 */   GIM_Try, /*On fail goto*//*Label 10150*/ GIMT_Encode4(629875), // Rule ID 6341 //
     /*  629805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  629825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629851 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629873 */     GIR_RootConstrainSelectedInstOperands,
     /*  629874 */     // GIR_Coverage, 6341,
     /*  629874 */     GIR_EraseRootFromParent_Done,
     /*  629875 */   // Label 10150: @629875
     /*  629875 */   GIM_Try, /*On fail goto*//*Label 10151*/ GIMT_Encode4(629950), // Rule ID 6344 //
     /*  629880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  629891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  629894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  629897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  629900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629926 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629948 */     GIR_RootConstrainSelectedInstOperands,
     /*  629949 */     // GIR_Coverage, 6344,
     /*  629949 */     GIR_EraseRootFromParent_Done,
     /*  629950 */   // Label 10151: @629950
     /*  629950 */   GIM_Try, /*On fail goto*//*Label 10152*/ GIMT_Encode4(630025), // Rule ID 6345 //
     /*  629955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  629966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  629969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  629972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  629975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630001 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  630001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  630004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630023 */     GIR_RootConstrainSelectedInstOperands,
     /*  630024 */     // GIR_Coverage, 6345,
     /*  630024 */     GIR_EraseRootFromParent_Done,
     /*  630025 */   // Label 10152: @630025
     /*  630025 */   GIM_Try, /*On fail goto*//*Label 10153*/ GIMT_Encode4(630100), // Rule ID 6348 //
     /*  630030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  630033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  630041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  630044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  630047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  630050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630076 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  630076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  630079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630098 */     GIR_RootConstrainSelectedInstOperands,
     /*  630099 */     // GIR_Coverage, 6348,
     /*  630099 */     GIR_EraseRootFromParent_Done,
     /*  630100 */   // Label 10153: @630100
     /*  630100 */   GIM_Try, /*On fail goto*//*Label 10154*/ GIMT_Encode4(630175), // Rule ID 6349 //
     /*  630105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  630108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  630116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  630119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  630122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  630125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630151 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  630151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  630154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630173 */     GIR_RootConstrainSelectedInstOperands,
     /*  630174 */     // GIR_Coverage, 6349,
     /*  630174 */     GIR_EraseRootFromParent_Done,
     /*  630175 */   // Label 10154: @630175
     /*  630175 */   GIM_Try, /*On fail goto*//*Label 10155*/ GIMT_Encode4(630250), // Rule ID 6352 //
     /*  630180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  630191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  630194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  630197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  630200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630226 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630248 */     GIR_RootConstrainSelectedInstOperands,
     /*  630249 */     // GIR_Coverage, 6352,
     /*  630249 */     GIR_EraseRootFromParent_Done,
     /*  630250 */   // Label 10155: @630250
     /*  630250 */   GIM_Try, /*On fail goto*//*Label 10156*/ GIMT_Encode4(630325), // Rule ID 6353 //
     /*  630255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  630266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  630269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  630272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  630275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630301 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630323 */     GIR_RootConstrainSelectedInstOperands,
     /*  630324 */     // GIR_Coverage, 6353,
     /*  630324 */     GIR_EraseRootFromParent_Done,
     /*  630325 */   // Label 10156: @630325
     /*  630325 */   GIM_Try, /*On fail goto*//*Label 10157*/ GIMT_Encode4(630400), // Rule ID 6356 //
     /*  630330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  630341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  630344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  630347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  630350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630376 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630398 */     GIR_RootConstrainSelectedInstOperands,
     /*  630399 */     // GIR_Coverage, 6356,
     /*  630399 */     GIR_EraseRootFromParent_Done,
     /*  630400 */   // Label 10157: @630400
     /*  630400 */   GIM_Try, /*On fail goto*//*Label 10158*/ GIMT_Encode4(630475), // Rule ID 6357 //
     /*  630405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  630416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  630419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  630422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  630425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630451 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630473 */     GIR_RootConstrainSelectedInstOperands,
     /*  630474 */     // GIR_Coverage, 6357,
     /*  630474 */     GIR_EraseRootFromParent_Done,
     /*  630475 */   // Label 10158: @630475
     /*  630475 */   GIM_Try, /*On fail goto*//*Label 10159*/ GIMT_Encode4(630550), // Rule ID 6360 //
     /*  630480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  630500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630526 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630548 */     GIR_RootConstrainSelectedInstOperands,
     /*  630549 */     // GIR_Coverage, 6360,
     /*  630549 */     GIR_EraseRootFromParent_Done,
     /*  630550 */   // Label 10159: @630550
     /*  630550 */   GIM_Try, /*On fail goto*//*Label 10160*/ GIMT_Encode4(630625), // Rule ID 6361 //
     /*  630555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  630575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630601 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630623 */     GIR_RootConstrainSelectedInstOperands,
     /*  630624 */     // GIR_Coverage, 6361,
     /*  630624 */     GIR_EraseRootFromParent_Done,
     /*  630625 */   // Label 10160: @630625
     /*  630625 */   GIM_Try, /*On fail goto*//*Label 10161*/ GIMT_Encode4(630700), // Rule ID 6364 //
     /*  630630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  630650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630698 */     GIR_RootConstrainSelectedInstOperands,
     /*  630699 */     // GIR_Coverage, 6364,
     /*  630699 */     GIR_EraseRootFromParent_Done,
     /*  630700 */   // Label 10161: @630700
     /*  630700 */   GIM_Try, /*On fail goto*//*Label 10162*/ GIMT_Encode4(630775), // Rule ID 6365 //
     /*  630705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  630725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630751 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630773 */     GIR_RootConstrainSelectedInstOperands,
     /*  630774 */     // GIR_Coverage, 6365,
     /*  630774 */     GIR_EraseRootFromParent_Done,
     /*  630775 */   // Label 10162: @630775
     /*  630775 */   GIM_Try, /*On fail goto*//*Label 10163*/ GIMT_Encode4(630850), // Rule ID 6368 //
     /*  630780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  630800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630826 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630848 */     GIR_RootConstrainSelectedInstOperands,
     /*  630849 */     // GIR_Coverage, 6368,
     /*  630849 */     GIR_EraseRootFromParent_Done,
     /*  630850 */   // Label 10163: @630850
     /*  630850 */   GIM_Try, /*On fail goto*//*Label 10164*/ GIMT_Encode4(630925), // Rule ID 6369 //
     /*  630855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  630875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630901 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630923 */     GIR_RootConstrainSelectedInstOperands,
     /*  630924 */     // GIR_Coverage, 6369,
     /*  630924 */     GIR_EraseRootFromParent_Done,
     /*  630925 */   // Label 10164: @630925
     /*  630925 */   GIM_Try, /*On fail goto*//*Label 10165*/ GIMT_Encode4(631000), // Rule ID 6372 //
     /*  630930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  630941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  630944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  630947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  630950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630976 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630998 */     GIR_RootConstrainSelectedInstOperands,
     /*  630999 */     // GIR_Coverage, 6372,
     /*  630999 */     GIR_EraseRootFromParent_Done,
     /*  631000 */   // Label 10165: @631000
     /*  631000 */   GIM_Try, /*On fail goto*//*Label 10166*/ GIMT_Encode4(631075), // Rule ID 6373 //
     /*  631005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  631016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  631019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  631022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  631025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631051 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  631051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  631070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631073 */     GIR_RootConstrainSelectedInstOperands,
     /*  631074 */     // GIR_Coverage, 6373,
     /*  631074 */     GIR_EraseRootFromParent_Done,
     /*  631075 */   // Label 10166: @631075
     /*  631075 */   GIM_Try, /*On fail goto*//*Label 10167*/ GIMT_Encode4(631150), // Rule ID 6376 //
     /*  631080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  631091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  631094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  631097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  631100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631126 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  631129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631148 */     GIR_RootConstrainSelectedInstOperands,
     /*  631149 */     // GIR_Coverage, 6376,
     /*  631149 */     GIR_EraseRootFromParent_Done,
     /*  631150 */   // Label 10167: @631150
     /*  631150 */   GIM_Try, /*On fail goto*//*Label 10168*/ GIMT_Encode4(631225), // Rule ID 6377 //
     /*  631155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  631166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  631169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  631172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  631175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631201 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  631204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631223 */     GIR_RootConstrainSelectedInstOperands,
     /*  631224 */     // GIR_Coverage, 6377,
     /*  631224 */     GIR_EraseRootFromParent_Done,
     /*  631225 */   // Label 10168: @631225
     /*  631225 */   GIM_Try, /*On fail goto*//*Label 10169*/ GIMT_Encode4(631300), // Rule ID 6380 //
     /*  631230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  631241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  631244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  631247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  631250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631276 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  631279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631298 */     GIR_RootConstrainSelectedInstOperands,
     /*  631299 */     // GIR_Coverage, 6380,
     /*  631299 */     GIR_EraseRootFromParent_Done,
     /*  631300 */   // Label 10169: @631300
     /*  631300 */   GIM_Try, /*On fail goto*//*Label 10170*/ GIMT_Encode4(631375), // Rule ID 6381 //
     /*  631305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  631316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  631319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  631322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  631325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631351 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  631354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631373 */     GIR_RootConstrainSelectedInstOperands,
     /*  631374 */     // GIR_Coverage, 6381,
     /*  631374 */     GIR_EraseRootFromParent_Done,
     /*  631375 */   // Label 10170: @631375
     /*  631375 */   GIM_Try, /*On fail goto*//*Label 10171*/ GIMT_Encode4(631450), // Rule ID 6384 //
     /*  631380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  631391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  631394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  631397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  631400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631426 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631448 */     GIR_RootConstrainSelectedInstOperands,
     /*  631449 */     // GIR_Coverage, 6384,
     /*  631449 */     GIR_EraseRootFromParent_Done,
     /*  631450 */   // Label 10171: @631450
     /*  631450 */   GIM_Try, /*On fail goto*//*Label 10172*/ GIMT_Encode4(631525), // Rule ID 6385 //
     /*  631455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  631466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  631469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  631472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  631475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631501 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631523 */     GIR_RootConstrainSelectedInstOperands,
     /*  631524 */     // GIR_Coverage, 6385,
     /*  631524 */     GIR_EraseRootFromParent_Done,
     /*  631525 */   // Label 10172: @631525
     /*  631525 */   GIM_Try, /*On fail goto*//*Label 10173*/ GIMT_Encode4(631600), // Rule ID 6388 //
     /*  631530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  631550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  631579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631598 */     GIR_RootConstrainSelectedInstOperands,
     /*  631599 */     // GIR_Coverage, 6388,
     /*  631599 */     GIR_EraseRootFromParent_Done,
     /*  631600 */   // Label 10173: @631600
     /*  631600 */   GIM_Try, /*On fail goto*//*Label 10174*/ GIMT_Encode4(631675), // Rule ID 6389 //
     /*  631605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  631625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631651 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  631654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631673 */     GIR_RootConstrainSelectedInstOperands,
     /*  631674 */     // GIR_Coverage, 6389,
     /*  631674 */     GIR_EraseRootFromParent_Done,
     /*  631675 */   // Label 10174: @631675
     /*  631675 */   GIM_Try, /*On fail goto*//*Label 10175*/ GIMT_Encode4(631750), // Rule ID 6392 //
     /*  631680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  631700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631726 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  631729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631748 */     GIR_RootConstrainSelectedInstOperands,
     /*  631749 */     // GIR_Coverage, 6392,
     /*  631749 */     GIR_EraseRootFromParent_Done,
     /*  631750 */   // Label 10175: @631750
     /*  631750 */   GIM_Try, /*On fail goto*//*Label 10176*/ GIMT_Encode4(631825), // Rule ID 6393 //
     /*  631755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  631775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631801 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  631804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631823 */     GIR_RootConstrainSelectedInstOperands,
     /*  631824 */     // GIR_Coverage, 6393,
     /*  631824 */     GIR_EraseRootFromParent_Done,
     /*  631825 */   // Label 10176: @631825
     /*  631825 */   GIM_Try, /*On fail goto*//*Label 10177*/ GIMT_Encode4(631900), // Rule ID 6396 //
     /*  631830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  631850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631876 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631898 */     GIR_RootConstrainSelectedInstOperands,
     /*  631899 */     // GIR_Coverage, 6396,
     /*  631899 */     GIR_EraseRootFromParent_Done,
     /*  631900 */   // Label 10177: @631900
     /*  631900 */   GIM_Try, /*On fail goto*//*Label 10178*/ GIMT_Encode4(631975), // Rule ID 6397 //
     /*  631905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  631925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631951 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631973 */     GIR_RootConstrainSelectedInstOperands,
     /*  631974 */     // GIR_Coverage, 6397,
     /*  631974 */     GIR_EraseRootFromParent_Done,
     /*  631975 */   // Label 10178: @631975
     /*  631975 */   GIM_Try, /*On fail goto*//*Label 10179*/ GIMT_Encode4(632050), // Rule ID 6400 //
     /*  631980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  631991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  631994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  631997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632026 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  632029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632048 */     GIR_RootConstrainSelectedInstOperands,
     /*  632049 */     // GIR_Coverage, 6400,
     /*  632049 */     GIR_EraseRootFromParent_Done,
     /*  632050 */   // Label 10179: @632050
     /*  632050 */   GIM_Try, /*On fail goto*//*Label 10180*/ GIMT_Encode4(632125), // Rule ID 6401 //
     /*  632055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  632066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  632069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  632072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632101 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  632104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632123 */     GIR_RootConstrainSelectedInstOperands,
     /*  632124 */     // GIR_Coverage, 6401,
     /*  632124 */     GIR_EraseRootFromParent_Done,
     /*  632125 */   // Label 10180: @632125
     /*  632125 */   GIM_Try, /*On fail goto*//*Label 10181*/ GIMT_Encode4(632200), // Rule ID 6404 //
     /*  632130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  632141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  632144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  632147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632176 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  632179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632198 */     GIR_RootConstrainSelectedInstOperands,
     /*  632199 */     // GIR_Coverage, 6404,
     /*  632199 */     GIR_EraseRootFromParent_Done,
     /*  632200 */   // Label 10181: @632200
     /*  632200 */   GIM_Try, /*On fail goto*//*Label 10182*/ GIMT_Encode4(632275), // Rule ID 6405 //
     /*  632205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  632216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  632219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  632222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632251 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  632254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632273 */     GIR_RootConstrainSelectedInstOperands,
     /*  632274 */     // GIR_Coverage, 6405,
     /*  632274 */     GIR_EraseRootFromParent_Done,
     /*  632275 */   // Label 10182: @632275
     /*  632275 */   GIM_Try, /*On fail goto*//*Label 10183*/ GIMT_Encode4(632350), // Rule ID 6408 //
     /*  632280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  632291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  632294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  632297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632326 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632348 */     GIR_RootConstrainSelectedInstOperands,
     /*  632349 */     // GIR_Coverage, 6408,
     /*  632349 */     GIR_EraseRootFromParent_Done,
     /*  632350 */   // Label 10183: @632350
     /*  632350 */   GIM_Try, /*On fail goto*//*Label 10184*/ GIMT_Encode4(632425), // Rule ID 6409 //
     /*  632355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  632366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  632369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  632372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632401 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632423 */     GIR_RootConstrainSelectedInstOperands,
     /*  632424 */     // GIR_Coverage, 6409,
     /*  632424 */     GIR_EraseRootFromParent_Done,
     /*  632425 */   // Label 10184: @632425
     /*  632425 */   GIM_Try, /*On fail goto*//*Label 10185*/ GIMT_Encode4(632500), // Rule ID 6412 //
     /*  632430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  632441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  632444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  632447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632476 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  632479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632498 */     GIR_RootConstrainSelectedInstOperands,
     /*  632499 */     // GIR_Coverage, 6412,
     /*  632499 */     GIR_EraseRootFromParent_Done,
     /*  632500 */   // Label 10185: @632500
     /*  632500 */   GIM_Try, /*On fail goto*//*Label 10186*/ GIMT_Encode4(632575), // Rule ID 6413 //
     /*  632505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  632516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  632519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  632522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632551 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  632554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632573 */     GIR_RootConstrainSelectedInstOperands,
     /*  632574 */     // GIR_Coverage, 6413,
     /*  632574 */     GIR_EraseRootFromParent_Done,
     /*  632575 */   // Label 10186: @632575
     /*  632575 */   GIM_Try, /*On fail goto*//*Label 10187*/ GIMT_Encode4(632650), // Rule ID 6416 //
     /*  632580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632626 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632648 */     GIR_RootConstrainSelectedInstOperands,
     /*  632649 */     // GIR_Coverage, 6416,
     /*  632649 */     GIR_EraseRootFromParent_Done,
     /*  632650 */   // Label 10187: @632650
     /*  632650 */   GIM_Try, /*On fail goto*//*Label 10188*/ GIMT_Encode4(632725), // Rule ID 6417 //
     /*  632655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632701 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632723 */     GIR_RootConstrainSelectedInstOperands,
     /*  632724 */     // GIR_Coverage, 6417,
     /*  632724 */     GIR_EraseRootFromParent_Done,
     /*  632725 */   // Label 10188: @632725
     /*  632725 */   GIM_Try, /*On fail goto*//*Label 10189*/ GIMT_Encode4(632800), // Rule ID 6420 //
     /*  632730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632776 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  632776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632798 */     GIR_RootConstrainSelectedInstOperands,
     /*  632799 */     // GIR_Coverage, 6420,
     /*  632799 */     GIR_EraseRootFromParent_Done,
     /*  632800 */   // Label 10189: @632800
     /*  632800 */   GIM_Try, /*On fail goto*//*Label 10190*/ GIMT_Encode4(632875), // Rule ID 6421 //
     /*  632805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632851 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  632851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632873 */     GIR_RootConstrainSelectedInstOperands,
     /*  632874 */     // GIR_Coverage, 6421,
     /*  632874 */     GIR_EraseRootFromParent_Done,
     /*  632875 */   // Label 10190: @632875
     /*  632875 */   GIM_Try, /*On fail goto*//*Label 10191*/ GIMT_Encode4(632950), // Rule ID 6424 //
     /*  632880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  632891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  632894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  632897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632926 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632948 */     GIR_RootConstrainSelectedInstOperands,
     /*  632949 */     // GIR_Coverage, 6424,
     /*  632949 */     GIR_EraseRootFromParent_Done,
     /*  632950 */   // Label 10191: @632950
     /*  632950 */   GIM_Try, /*On fail goto*//*Label 10192*/ GIMT_Encode4(633025), // Rule ID 6425 //
     /*  632955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  632966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  632969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  632972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633001 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11730:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633023 */     GIR_RootConstrainSelectedInstOperands,
     /*  633024 */     // GIR_Coverage, 6425,
     /*  633024 */     GIR_EraseRootFromParent_Done,
     /*  633025 */   // Label 10192: @633025
     /*  633025 */   GIM_Try, /*On fail goto*//*Label 10193*/ GIMT_Encode4(633100), // Rule ID 6428 //
     /*  633030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  633041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  633044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  633047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633076 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633098 */     GIR_RootConstrainSelectedInstOperands,
     /*  633099 */     // GIR_Coverage, 6428,
     /*  633099 */     GIR_EraseRootFromParent_Done,
     /*  633100 */   // Label 10193: @633100
     /*  633100 */   GIM_Try, /*On fail goto*//*Label 10194*/ GIMT_Encode4(633175), // Rule ID 6429 //
     /*  633105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  633116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  633119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  633122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633151 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633173 */     GIR_RootConstrainSelectedInstOperands,
     /*  633174 */     // GIR_Coverage, 6429,
     /*  633174 */     GIR_EraseRootFromParent_Done,
     /*  633175 */   // Label 10194: @633175
     /*  633175 */   GIM_Try, /*On fail goto*//*Label 10195*/ GIMT_Encode4(633250), // Rule ID 6432 //
     /*  633180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  633191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  633194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  633197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  633226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633248 */     GIR_RootConstrainSelectedInstOperands,
     /*  633249 */     // GIR_Coverage, 6432,
     /*  633249 */     GIR_EraseRootFromParent_Done,
     /*  633250 */   // Label 10195: @633250
     /*  633250 */   GIM_Try, /*On fail goto*//*Label 10196*/ GIMT_Encode4(633325), // Rule ID 6433 //
     /*  633255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  633266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  633269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  633272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633301 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  633301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633323 */     GIR_RootConstrainSelectedInstOperands,
     /*  633324 */     // GIR_Coverage, 6433,
     /*  633324 */     GIR_EraseRootFromParent_Done,
     /*  633325 */   // Label 10196: @633325
     /*  633325 */   GIM_Try, /*On fail goto*//*Label 10197*/ GIMT_Encode4(633400), // Rule ID 6436 //
     /*  633330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  633333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  633341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  633344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  633347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633376 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  633376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633398 */     GIR_RootConstrainSelectedInstOperands,
     /*  633399 */     // GIR_Coverage, 6436,
     /*  633399 */     GIR_EraseRootFromParent_Done,
     /*  633400 */   // Label 10197: @633400
     /*  633400 */   GIM_Try, /*On fail goto*//*Label 10198*/ GIMT_Encode4(633475), // Rule ID 6437 //
     /*  633405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  633408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  633416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  633419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  633422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633451 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  633451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633473 */     GIR_RootConstrainSelectedInstOperands,
     /*  633474 */     // GIR_Coverage, 6437,
     /*  633474 */     GIR_EraseRootFromParent_Done,
     /*  633475 */   // Label 10198: @633475
     /*  633475 */   GIM_Try, /*On fail goto*//*Label 10199*/ GIMT_Encode4(633550), // Rule ID 6440 //
     /*  633480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633526 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633548 */     GIR_RootConstrainSelectedInstOperands,
     /*  633549 */     // GIR_Coverage, 6440,
     /*  633549 */     GIR_EraseRootFromParent_Done,
     /*  633550 */   // Label 10199: @633550
     /*  633550 */   GIM_Try, /*On fail goto*//*Label 10200*/ GIMT_Encode4(633625), // Rule ID 6441 //
     /*  633555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633601 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633623 */     GIR_RootConstrainSelectedInstOperands,
     /*  633624 */     // GIR_Coverage, 6441,
     /*  633624 */     GIR_EraseRootFromParent_Done,
     /*  633625 */   // Label 10200: @633625
     /*  633625 */   GIM_Try, /*On fail goto*//*Label 10201*/ GIMT_Encode4(633700), // Rule ID 6444 //
     /*  633630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633676 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633698 */     GIR_RootConstrainSelectedInstOperands,
     /*  633699 */     // GIR_Coverage, 6444,
     /*  633699 */     GIR_EraseRootFromParent_Done,
     /*  633700 */   // Label 10201: @633700
     /*  633700 */   GIM_Try, /*On fail goto*//*Label 10202*/ GIMT_Encode4(633775), // Rule ID 6445 //
     /*  633705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633751 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633773 */     GIR_RootConstrainSelectedInstOperands,
     /*  633774 */     // GIR_Coverage, 6445,
     /*  633774 */     GIR_EraseRootFromParent_Done,
     /*  633775 */   // Label 10202: @633775
     /*  633775 */   GIM_Try, /*On fail goto*//*Label 10203*/ GIMT_Encode4(633850), // Rule ID 6448 //
     /*  633780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633826 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633848 */     GIR_RootConstrainSelectedInstOperands,
     /*  633849 */     // GIR_Coverage, 6448,
     /*  633849 */     GIR_EraseRootFromParent_Done,
     /*  633850 */   // Label 10203: @633850
     /*  633850 */   GIM_Try, /*On fail goto*//*Label 10204*/ GIMT_Encode4(633925), // Rule ID 6449 //
     /*  633855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633901 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633923 */     GIR_RootConstrainSelectedInstOperands,
     /*  633924 */     // GIR_Coverage, 6449,
     /*  633924 */     GIR_EraseRootFromParent_Done,
     /*  633925 */   // Label 10204: @633925
     /*  633925 */   GIM_Try, /*On fail goto*//*Label 10205*/ GIMT_Encode4(634000), // Rule ID 6452 //
     /*  633930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  633941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  633944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  633947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633998 */     GIR_RootConstrainSelectedInstOperands,
     /*  633999 */     // GIR_Coverage, 6452,
     /*  633999 */     GIR_EraseRootFromParent_Done,
     /*  634000 */   // Label 10205: @634000
     /*  634000 */   GIM_Try, /*On fail goto*//*Label 10206*/ GIMT_Encode4(634075), // Rule ID 6453 //
     /*  634005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  634016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  634019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  634022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634051 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634073 */     GIR_RootConstrainSelectedInstOperands,
     /*  634074 */     // GIR_Coverage, 6453,
     /*  634074 */     GIR_EraseRootFromParent_Done,
     /*  634075 */   // Label 10206: @634075
     /*  634075 */   GIM_Try, /*On fail goto*//*Label 10207*/ GIMT_Encode4(634150), // Rule ID 6456 //
     /*  634080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  634091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  634094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  634097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634126 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634148 */     GIR_RootConstrainSelectedInstOperands,
     /*  634149 */     // GIR_Coverage, 6456,
     /*  634149 */     GIR_EraseRootFromParent_Done,
     /*  634150 */   // Label 10207: @634150
     /*  634150 */   GIM_Try, /*On fail goto*//*Label 10208*/ GIMT_Encode4(634225), // Rule ID 6457 //
     /*  634155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  634166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  634169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  634172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634201 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634223 */     GIR_RootConstrainSelectedInstOperands,
     /*  634224 */     // GIR_Coverage, 6457,
     /*  634224 */     GIR_EraseRootFromParent_Done,
     /*  634225 */   // Label 10208: @634225
     /*  634225 */   GIM_Try, /*On fail goto*//*Label 10209*/ GIMT_Encode4(634300), // Rule ID 6460 //
     /*  634230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  634241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  634244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  634247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634276 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634298 */     GIR_RootConstrainSelectedInstOperands,
     /*  634299 */     // GIR_Coverage, 6460,
     /*  634299 */     GIR_EraseRootFromParent_Done,
     /*  634300 */   // Label 10209: @634300
     /*  634300 */   GIM_Try, /*On fail goto*//*Label 10210*/ GIMT_Encode4(634375), // Rule ID 6461 //
     /*  634305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  634316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  634319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  634322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634351 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634373 */     GIR_RootConstrainSelectedInstOperands,
     /*  634374 */     // GIR_Coverage, 6461,
     /*  634374 */     GIR_EraseRootFromParent_Done,
     /*  634375 */   // Label 10210: @634375
     /*  634375 */   GIM_Try, /*On fail goto*//*Label 10211*/ GIMT_Encode4(634450), // Rule ID 6464 //
     /*  634380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  634391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  634394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  634397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634448 */     GIR_RootConstrainSelectedInstOperands,
     /*  634449 */     // GIR_Coverage, 6464,
     /*  634449 */     GIR_EraseRootFromParent_Done,
     /*  634450 */   // Label 10211: @634450
     /*  634450 */   GIM_Try, /*On fail goto*//*Label 10212*/ GIMT_Encode4(634525), // Rule ID 6465 //
     /*  634455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  634466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  634469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  634472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634523 */     GIR_RootConstrainSelectedInstOperands,
     /*  634524 */     // GIR_Coverage, 6465,
     /*  634524 */     GIR_EraseRootFromParent_Done,
     /*  634525 */   // Label 10212: @634525
     /*  634525 */   GIM_Try, /*On fail goto*//*Label 10213*/ GIMT_Encode4(634600), // Rule ID 6468 //
     /*  634530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634576 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634598 */     GIR_RootConstrainSelectedInstOperands,
     /*  634599 */     // GIR_Coverage, 6468,
     /*  634599 */     GIR_EraseRootFromParent_Done,
     /*  634600 */   // Label 10213: @634600
     /*  634600 */   GIM_Try, /*On fail goto*//*Label 10214*/ GIMT_Encode4(634675), // Rule ID 6469 //
     /*  634605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634651 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634673 */     GIR_RootConstrainSelectedInstOperands,
     /*  634674 */     // GIR_Coverage, 6469,
     /*  634674 */     GIR_EraseRootFromParent_Done,
     /*  634675 */   // Label 10214: @634675
     /*  634675 */   GIM_Try, /*On fail goto*//*Label 10215*/ GIMT_Encode4(634750), // Rule ID 6472 //
     /*  634680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634726 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634748 */     GIR_RootConstrainSelectedInstOperands,
     /*  634749 */     // GIR_Coverage, 6472,
     /*  634749 */     GIR_EraseRootFromParent_Done,
     /*  634750 */   // Label 10215: @634750
     /*  634750 */   GIM_Try, /*On fail goto*//*Label 10216*/ GIMT_Encode4(634825), // Rule ID 6473 //
     /*  634755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634801 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634823 */     GIR_RootConstrainSelectedInstOperands,
     /*  634824 */     // GIR_Coverage, 6473,
     /*  634824 */     GIR_EraseRootFromParent_Done,
     /*  634825 */   // Label 10216: @634825
     /*  634825 */   GIM_Try, /*On fail goto*//*Label 10217*/ GIMT_Encode4(634900), // Rule ID 6476 //
     /*  634830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634898 */     GIR_RootConstrainSelectedInstOperands,
     /*  634899 */     // GIR_Coverage, 6476,
     /*  634899 */     GIR_EraseRootFromParent_Done,
     /*  634900 */   // Label 10217: @634900
     /*  634900 */   GIM_Try, /*On fail goto*//*Label 10218*/ GIMT_Encode4(634975), // Rule ID 6477 //
     /*  634905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  634951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634973 */     GIR_RootConstrainSelectedInstOperands,
     /*  634974 */     // GIR_Coverage, 6477,
     /*  634974 */     GIR_EraseRootFromParent_Done,
     /*  634975 */   // Label 10218: @634975
     /*  634975 */   GIM_Try, /*On fail goto*//*Label 10219*/ GIMT_Encode4(635050), // Rule ID 6480 //
     /*  634980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  634991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  634994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  634997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635026 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  635026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  635029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635048 */     GIR_RootConstrainSelectedInstOperands,
     /*  635049 */     // GIR_Coverage, 6480,
     /*  635049 */     GIR_EraseRootFromParent_Done,
     /*  635050 */   // Label 10219: @635050
     /*  635050 */   GIM_Try, /*On fail goto*//*Label 10220*/ GIMT_Encode4(635125), // Rule ID 6481 //
     /*  635055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  635058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  635066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  635069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  635072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635101 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  635104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635123 */     GIR_RootConstrainSelectedInstOperands,
     /*  635124 */     // GIR_Coverage, 6481,
     /*  635124 */     GIR_EraseRootFromParent_Done,
     /*  635125 */   // Label 10220: @635125
     /*  635125 */   GIM_Try, /*On fail goto*//*Label 10221*/ GIMT_Encode4(635200), // Rule ID 6484 //
     /*  635130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  635133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  635141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  635144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  635147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  635176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  635179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635198 */     GIR_RootConstrainSelectedInstOperands,
     /*  635199 */     // GIR_Coverage, 6484,
     /*  635199 */     GIR_EraseRootFromParent_Done,
     /*  635200 */   // Label 10221: @635200
     /*  635200 */   GIM_Try, /*On fail goto*//*Label 10222*/ GIMT_Encode4(635275), // Rule ID 6485 //
     /*  635205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  635208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  635216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  635219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  635222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635251 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  635254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635273 */     GIR_RootConstrainSelectedInstOperands,
     /*  635274 */     // GIR_Coverage, 6485,
     /*  635274 */     GIR_EraseRootFromParent_Done,
     /*  635275 */   // Label 10222: @635275
     /*  635275 */   GIM_Try, /*On fail goto*//*Label 10223*/ GIMT_Encode4(635350), // Rule ID 6576 //
     /*  635280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  635291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  635294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  635297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  635300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635326 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  635329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635348 */     GIR_RootConstrainSelectedInstOperands,
     /*  635349 */     // GIR_Coverage, 6576,
     /*  635349 */     GIR_EraseRootFromParent_Done,
     /*  635350 */   // Label 10223: @635350
     /*  635350 */   GIM_Try, /*On fail goto*//*Label 10224*/ GIMT_Encode4(635425), // Rule ID 6577 //
     /*  635355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  635366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  635369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  635372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  635375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635401 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  635404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635423 */     GIR_RootConstrainSelectedInstOperands,
     /*  635424 */     // GIR_Coverage, 6577,
     /*  635424 */     GIR_EraseRootFromParent_Done,
     /*  635425 */   // Label 10224: @635425
     /*  635425 */   GIM_Try, /*On fail goto*//*Label 10225*/ GIMT_Encode4(635500), // Rule ID 6580 //
     /*  635430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  635441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  635444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  635447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  635450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635476 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635498 */     GIR_RootConstrainSelectedInstOperands,
     /*  635499 */     // GIR_Coverage, 6580,
     /*  635499 */     GIR_EraseRootFromParent_Done,
     /*  635500 */   // Label 10225: @635500
     /*  635500 */   GIM_Try, /*On fail goto*//*Label 10226*/ GIMT_Encode4(635575), // Rule ID 6581 //
     /*  635505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  635516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  635519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  635522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  635525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635551 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635573 */     GIR_RootConstrainSelectedInstOperands,
     /*  635574 */     // GIR_Coverage, 6581,
     /*  635574 */     GIR_EraseRootFromParent_Done,
     /*  635575 */   // Label 10226: @635575
     /*  635575 */   GIM_Try, /*On fail goto*//*Label 10227*/ GIMT_Encode4(635650), // Rule ID 6584 //
     /*  635580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  635600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635626 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635648 */     GIR_RootConstrainSelectedInstOperands,
     /*  635649 */     // GIR_Coverage, 6584,
     /*  635649 */     GIR_EraseRootFromParent_Done,
     /*  635650 */   // Label 10227: @635650
     /*  635650 */   GIM_Try, /*On fail goto*//*Label 10228*/ GIMT_Encode4(635725), // Rule ID 6585 //
     /*  635655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  635675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635701 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635723 */     GIR_RootConstrainSelectedInstOperands,
     /*  635724 */     // GIR_Coverage, 6585,
     /*  635724 */     GIR_EraseRootFromParent_Done,
     /*  635725 */   // Label 10228: @635725
     /*  635725 */   GIM_Try, /*On fail goto*//*Label 10229*/ GIMT_Encode4(635800), // Rule ID 6588 //
     /*  635730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  635750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635776 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635798 */     GIR_RootConstrainSelectedInstOperands,
     /*  635799 */     // GIR_Coverage, 6588,
     /*  635799 */     GIR_EraseRootFromParent_Done,
     /*  635800 */   // Label 10229: @635800
     /*  635800 */   GIM_Try, /*On fail goto*//*Label 10230*/ GIMT_Encode4(635875), // Rule ID 6589 //
     /*  635805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  635825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635851 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635873 */     GIR_RootConstrainSelectedInstOperands,
     /*  635874 */     // GIR_Coverage, 6589,
     /*  635874 */     GIR_EraseRootFromParent_Done,
     /*  635875 */   // Label 10230: @635875
     /*  635875 */   GIM_Try, /*On fail goto*//*Label 10231*/ GIMT_Encode4(635950), // Rule ID 6592 //
     /*  635880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  635891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  635894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  635897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  635900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635926 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635948 */     GIR_RootConstrainSelectedInstOperands,
     /*  635949 */     // GIR_Coverage, 6592,
     /*  635949 */     GIR_EraseRootFromParent_Done,
     /*  635950 */   // Label 10231: @635950
     /*  635950 */   GIM_Try, /*On fail goto*//*Label 10232*/ GIMT_Encode4(636025), // Rule ID 6593 //
     /*  635955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  635966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  635969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  635972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  635975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636001 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  636004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636023 */     GIR_RootConstrainSelectedInstOperands,
     /*  636024 */     // GIR_Coverage, 6593,
     /*  636024 */     GIR_EraseRootFromParent_Done,
     /*  636025 */   // Label 10232: @636025
     /*  636025 */   GIM_Try, /*On fail goto*//*Label 10233*/ GIMT_Encode4(636100), // Rule ID 6596 //
     /*  636030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  636041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  636044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  636047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  636050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636076 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  636079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636098 */     GIR_RootConstrainSelectedInstOperands,
     /*  636099 */     // GIR_Coverage, 6596,
     /*  636099 */     GIR_EraseRootFromParent_Done,
     /*  636100 */   // Label 10233: @636100
     /*  636100 */   GIM_Try, /*On fail goto*//*Label 10234*/ GIMT_Encode4(636175), // Rule ID 6597 //
     /*  636105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  636116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  636119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  636122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  636125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636151 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  636154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636173 */     GIR_RootConstrainSelectedInstOperands,
     /*  636174 */     // GIR_Coverage, 6597,
     /*  636174 */     GIR_EraseRootFromParent_Done,
     /*  636175 */   // Label 10234: @636175
     /*  636175 */   GIM_Try, /*On fail goto*//*Label 10235*/ GIMT_Encode4(636250), // Rule ID 6600 //
     /*  636180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  636191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  636194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  636197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  636200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636248 */     GIR_RootConstrainSelectedInstOperands,
     /*  636249 */     // GIR_Coverage, 6600,
     /*  636249 */     GIR_EraseRootFromParent_Done,
     /*  636250 */   // Label 10235: @636250
     /*  636250 */   GIM_Try, /*On fail goto*//*Label 10236*/ GIMT_Encode4(636325), // Rule ID 6601 //
     /*  636255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  636266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  636269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  636272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  636275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636301 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636323 */     GIR_RootConstrainSelectedInstOperands,
     /*  636324 */     // GIR_Coverage, 6601,
     /*  636324 */     GIR_EraseRootFromParent_Done,
     /*  636325 */   // Label 10236: @636325
     /*  636325 */   GIM_Try, /*On fail goto*//*Label 10237*/ GIMT_Encode4(636400), // Rule ID 6604 //
     /*  636330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  636341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  636344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  636347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  636350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636376 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  636376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636398 */     GIR_RootConstrainSelectedInstOperands,
     /*  636399 */     // GIR_Coverage, 6604,
     /*  636399 */     GIR_EraseRootFromParent_Done,
     /*  636400 */   // Label 10237: @636400
     /*  636400 */   GIM_Try, /*On fail goto*//*Label 10238*/ GIMT_Encode4(636475), // Rule ID 6605 //
     /*  636405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  636416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  636419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  636422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  636425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636451 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636473 */     GIR_RootConstrainSelectedInstOperands,
     /*  636474 */     // GIR_Coverage, 6605,
     /*  636474 */     GIR_EraseRootFromParent_Done,
     /*  636475 */   // Label 10238: @636475
     /*  636475 */   GIM_Try, /*On fail goto*//*Label 10239*/ GIMT_Encode4(636550), // Rule ID 6608 //
     /*  636480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  636500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636526 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636548 */     GIR_RootConstrainSelectedInstOperands,
     /*  636549 */     // GIR_Coverage, 6608,
     /*  636549 */     GIR_EraseRootFromParent_Done,
     /*  636550 */   // Label 10239: @636550
     /*  636550 */   GIM_Try, /*On fail goto*//*Label 10240*/ GIMT_Encode4(636625), // Rule ID 6609 //
     /*  636555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  636575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636601 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636623 */     GIR_RootConstrainSelectedInstOperands,
     /*  636624 */     // GIR_Coverage, 6609,
     /*  636624 */     GIR_EraseRootFromParent_Done,
     /*  636625 */   // Label 10240: @636625
     /*  636625 */   GIM_Try, /*On fail goto*//*Label 10241*/ GIMT_Encode4(636700), // Rule ID 6612 //
     /*  636630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  636633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  636650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636676 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  636676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636698 */     GIR_RootConstrainSelectedInstOperands,
     /*  636699 */     // GIR_Coverage, 6612,
     /*  636699 */     GIR_EraseRootFromParent_Done,
     /*  636700 */   // Label 10241: @636700
     /*  636700 */   GIM_Try, /*On fail goto*//*Label 10242*/ GIMT_Encode4(636775), // Rule ID 6613 //
     /*  636705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  636708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  636725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636751 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  636751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636773 */     GIR_RootConstrainSelectedInstOperands,
     /*  636774 */     // GIR_Coverage, 6613,
     /*  636774 */     GIR_EraseRootFromParent_Done,
     /*  636775 */   // Label 10242: @636775
     /*  636775 */   GIM_Try, /*On fail goto*//*Label 10243*/ GIMT_Encode4(636850), // Rule ID 6616 //
     /*  636780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  636800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636826 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636848 */     GIR_RootConstrainSelectedInstOperands,
     /*  636849 */     // GIR_Coverage, 6616,
     /*  636849 */     GIR_EraseRootFromParent_Done,
     /*  636850 */   // Label 10243: @636850
     /*  636850 */   GIM_Try, /*On fail goto*//*Label 10244*/ GIMT_Encode4(636925), // Rule ID 6617 //
     /*  636855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  636875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636901 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636923 */     GIR_RootConstrainSelectedInstOperands,
     /*  636924 */     // GIR_Coverage, 6617,
     /*  636924 */     GIR_EraseRootFromParent_Done,
     /*  636925 */   // Label 10244: @636925
     /*  636925 */   GIM_Try, /*On fail goto*//*Label 10245*/ GIMT_Encode4(637000), // Rule ID 6620 //
     /*  636930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  636941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  636944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  636947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  636950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636976 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636998 */     GIR_RootConstrainSelectedInstOperands,
     /*  636999 */     // GIR_Coverage, 6620,
     /*  636999 */     GIR_EraseRootFromParent_Done,
     /*  637000 */   // Label 10245: @637000
     /*  637000 */   GIM_Try, /*On fail goto*//*Label 10246*/ GIMT_Encode4(637075), // Rule ID 6621 //
     /*  637005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  637016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  637019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  637022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  637025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637051 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  637051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637073 */     GIR_RootConstrainSelectedInstOperands,
     /*  637074 */     // GIR_Coverage, 6621,
     /*  637074 */     GIR_EraseRootFromParent_Done,
     /*  637075 */   // Label 10246: @637075
     /*  637075 */   GIM_Try, /*On fail goto*//*Label 10247*/ GIMT_Encode4(637150), // Rule ID 6624 //
     /*  637080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  637091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  637094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  637097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  637100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637126 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  637126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637148 */     GIR_RootConstrainSelectedInstOperands,
     /*  637149 */     // GIR_Coverage, 6624,
     /*  637149 */     GIR_EraseRootFromParent_Done,
     /*  637150 */   // Label 10247: @637150
     /*  637150 */   GIM_Try, /*On fail goto*//*Label 10248*/ GIMT_Encode4(637225), // Rule ID 6625 //
     /*  637155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  637166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  637169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  637172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  637175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637201 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  637201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637223 */     GIR_RootConstrainSelectedInstOperands,
     /*  637224 */     // GIR_Coverage, 6625,
     /*  637224 */     GIR_EraseRootFromParent_Done,
     /*  637225 */   // Label 10248: @637225
     /*  637225 */   GIM_Try, /*On fail goto*//*Label 10249*/ GIMT_Encode4(637300), // Rule ID 6628 //
     /*  637230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  637241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  637244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  637247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  637250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637298 */     GIR_RootConstrainSelectedInstOperands,
     /*  637299 */     // GIR_Coverage, 6628,
     /*  637299 */     GIR_EraseRootFromParent_Done,
     /*  637300 */   // Label 10249: @637300
     /*  637300 */   GIM_Try, /*On fail goto*//*Label 10250*/ GIMT_Encode4(637375), // Rule ID 6629 //
     /*  637305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  637316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  637319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  637322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  637325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637351 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637373 */     GIR_RootConstrainSelectedInstOperands,
     /*  637374 */     // GIR_Coverage, 6629,
     /*  637374 */     GIR_EraseRootFromParent_Done,
     /*  637375 */   // Label 10250: @637375
     /*  637375 */   GIM_Try, /*On fail goto*//*Label 10251*/ GIMT_Encode4(637450), // Rule ID 6632 //
     /*  637380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  637391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  637394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  637397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  637400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637426 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637448 */     GIR_RootConstrainSelectedInstOperands,
     /*  637449 */     // GIR_Coverage, 6632,
     /*  637449 */     GIR_EraseRootFromParent_Done,
     /*  637450 */   // Label 10251: @637450
     /*  637450 */   GIM_Try, /*On fail goto*//*Label 10252*/ GIMT_Encode4(637525), // Rule ID 6633 //
     /*  637455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  637466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  637469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  637472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  637475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637501 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637523 */     GIR_RootConstrainSelectedInstOperands,
     /*  637524 */     // GIR_Coverage, 6633,
     /*  637524 */     GIR_EraseRootFromParent_Done,
     /*  637525 */   // Label 10252: @637525
     /*  637525 */   GIM_Try, /*On fail goto*//*Label 10253*/ GIMT_Encode4(637600), // Rule ID 6636 //
     /*  637530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  637550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637576 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637598 */     GIR_RootConstrainSelectedInstOperands,
     /*  637599 */     // GIR_Coverage, 6636,
     /*  637599 */     GIR_EraseRootFromParent_Done,
     /*  637600 */   // Label 10253: @637600
     /*  637600 */   GIM_Try, /*On fail goto*//*Label 10254*/ GIMT_Encode4(637675), // Rule ID 6637 //
     /*  637605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  637625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637651 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637673 */     GIR_RootConstrainSelectedInstOperands,
     /*  637674 */     // GIR_Coverage, 6637,
     /*  637674 */     GIR_EraseRootFromParent_Done,
     /*  637675 */   // Label 10254: @637675
     /*  637675 */   GIM_Try, /*On fail goto*//*Label 10255*/ GIMT_Encode4(637750), // Rule ID 6640 //
     /*  637680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  637700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637748 */     GIR_RootConstrainSelectedInstOperands,
     /*  637749 */     // GIR_Coverage, 6640,
     /*  637749 */     GIR_EraseRootFromParent_Done,
     /*  637750 */   // Label 10255: @637750
     /*  637750 */   GIM_Try, /*On fail goto*//*Label 10256*/ GIMT_Encode4(637825), // Rule ID 6641 //
     /*  637755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  637775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637823 */     GIR_RootConstrainSelectedInstOperands,
     /*  637824 */     // GIR_Coverage, 6641,
     /*  637824 */     GIR_EraseRootFromParent_Done,
     /*  637825 */   // Label 10256: @637825
     /*  637825 */   GIM_Try, /*On fail goto*//*Label 10257*/ GIMT_Encode4(637900), // Rule ID 6644 //
     /*  637830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  637850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637898 */     GIR_RootConstrainSelectedInstOperands,
     /*  637899 */     // GIR_Coverage, 6644,
     /*  637899 */     GIR_EraseRootFromParent_Done,
     /*  637900 */   // Label 10257: @637900
     /*  637900 */   GIM_Try, /*On fail goto*//*Label 10258*/ GIMT_Encode4(637975), // Rule ID 6645 //
     /*  637905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  637925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637951 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637973 */     GIR_RootConstrainSelectedInstOperands,
     /*  637974 */     // GIR_Coverage, 6645,
     /*  637974 */     GIR_EraseRootFromParent_Done,
     /*  637975 */   // Label 10258: @637975
     /*  637975 */   GIM_Try, /*On fail goto*//*Label 10259*/ GIMT_Encode4(638050), // Rule ID 6648 //
     /*  637980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  637991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  637994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  637997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  638000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638026 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  638026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  638029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638048 */     GIR_RootConstrainSelectedInstOperands,
     /*  638049 */     // GIR_Coverage, 6648,
     /*  638049 */     GIR_EraseRootFromParent_Done,
     /*  638050 */   // Label 10259: @638050
     /*  638050 */   GIM_Try, /*On fail goto*//*Label 10260*/ GIMT_Encode4(638125), // Rule ID 6649 //
     /*  638055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  638066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  638069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  638072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  638075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638101 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  638101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  638104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638123 */     GIR_RootConstrainSelectedInstOperands,
     /*  638124 */     // GIR_Coverage, 6649,
     /*  638124 */     GIR_EraseRootFromParent_Done,
     /*  638125 */   // Label 10260: @638125
     /*  638125 */   GIM_Try, /*On fail goto*//*Label 10261*/ GIMT_Encode4(638200), // Rule ID 6652 //
     /*  638130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  638141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  638144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  638147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  638150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638176 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  638179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638198 */     GIR_RootConstrainSelectedInstOperands,
     /*  638199 */     // GIR_Coverage, 6652,
     /*  638199 */     GIR_EraseRootFromParent_Done,
     /*  638200 */   // Label 10261: @638200
     /*  638200 */   GIM_Try, /*On fail goto*//*Label 10262*/ GIMT_Encode4(638275), // Rule ID 6653 //
     /*  638205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  638216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  638219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  638222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  638225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  638254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638273 */     GIR_RootConstrainSelectedInstOperands,
     /*  638274 */     // GIR_Coverage, 6653,
     /*  638274 */     GIR_EraseRootFromParent_Done,
     /*  638275 */   // Label 10262: @638275
     /*  638275 */   GIM_Try, /*On fail goto*//*Label 10263*/ GIMT_Encode4(638350), // Rule ID 6656 //
     /*  638280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  638291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  638294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  638297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  638300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638326 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  638329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638348 */     GIR_RootConstrainSelectedInstOperands,
     /*  638349 */     // GIR_Coverage, 6656,
     /*  638349 */     GIR_EraseRootFromParent_Done,
     /*  638350 */   // Label 10263: @638350
     /*  638350 */   GIM_Try, /*On fail goto*//*Label 10264*/ GIMT_Encode4(638425), // Rule ID 6657 //
     /*  638355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  638366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  638369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  638372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  638375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638401 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  638404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638423 */     GIR_RootConstrainSelectedInstOperands,
     /*  638424 */     // GIR_Coverage, 6657,
     /*  638424 */     GIR_EraseRootFromParent_Done,
     /*  638425 */   // Label 10264: @638425
     /*  638425 */   GIM_Try, /*On fail goto*//*Label 10265*/ GIMT_Encode4(638500), // Rule ID 6660 //
     /*  638430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  638441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  638444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  638447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  638450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  638479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638498 */     GIR_RootConstrainSelectedInstOperands,
     /*  638499 */     // GIR_Coverage, 6660,
     /*  638499 */     GIR_EraseRootFromParent_Done,
     /*  638500 */   // Label 10265: @638500
     /*  638500 */   GIM_Try, /*On fail goto*//*Label 10266*/ GIMT_Encode4(638575), // Rule ID 6661 //
     /*  638505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  638516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  638519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  638522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  638525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638551 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  638554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638573 */     GIR_RootConstrainSelectedInstOperands,
     /*  638574 */     // GIR_Coverage, 6661,
     /*  638574 */     GIR_EraseRootFromParent_Done,
     /*  638575 */   // Label 10266: @638575
     /*  638575 */   GIM_Try, /*On fail goto*//*Label 10267*/ GIMT_Encode4(638650), // Rule ID 6664 //
     /*  638580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638626 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  638629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638648 */     GIR_RootConstrainSelectedInstOperands,
     /*  638649 */     // GIR_Coverage, 6664,
     /*  638649 */     GIR_EraseRootFromParent_Done,
     /*  638650 */   // Label 10267: @638650
     /*  638650 */   GIM_Try, /*On fail goto*//*Label 10268*/ GIMT_Encode4(638725), // Rule ID 6665 //
     /*  638655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638701 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  638704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638723 */     GIR_RootConstrainSelectedInstOperands,
     /*  638724 */     // GIR_Coverage, 6665,
     /*  638724 */     GIR_EraseRootFromParent_Done,
     /*  638725 */   // Label 10268: @638725
     /*  638725 */   GIM_Try, /*On fail goto*//*Label 10269*/ GIMT_Encode4(638800), // Rule ID 6668 //
     /*  638730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638776 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638798 */     GIR_RootConstrainSelectedInstOperands,
     /*  638799 */     // GIR_Coverage, 6668,
     /*  638799 */     GIR_EraseRootFromParent_Done,
     /*  638800 */   // Label 10269: @638800
     /*  638800 */   GIM_Try, /*On fail goto*//*Label 10270*/ GIMT_Encode4(638875), // Rule ID 6669 //
     /*  638805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638851 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638873 */     GIR_RootConstrainSelectedInstOperands,
     /*  638874 */     // GIR_Coverage, 6669,
     /*  638874 */     GIR_EraseRootFromParent_Done,
     /*  638875 */   // Label 10270: @638875
     /*  638875 */   GIM_Try, /*On fail goto*//*Label 10271*/ GIMT_Encode4(638950), // Rule ID 6672 //
     /*  638880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  638891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  638894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  638897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638926 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638948 */     GIR_RootConstrainSelectedInstOperands,
     /*  638949 */     // GIR_Coverage, 6672,
     /*  638949 */     GIR_EraseRootFromParent_Done,
     /*  638950 */   // Label 10271: @638950
     /*  638950 */   GIM_Try, /*On fail goto*//*Label 10272*/ GIMT_Encode4(639025), // Rule ID 6673 //
     /*  638955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  638966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  638969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  638972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639001 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  639004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639023 */     GIR_RootConstrainSelectedInstOperands,
     /*  639024 */     // GIR_Coverage, 6673,
     /*  639024 */     GIR_EraseRootFromParent_Done,
     /*  639025 */   // Label 10272: @639025
     /*  639025 */   GIM_Try, /*On fail goto*//*Label 10273*/ GIMT_Encode4(639100), // Rule ID 6676 //
     /*  639030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  639041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  639044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  639047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639076 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  639079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639098 */     GIR_RootConstrainSelectedInstOperands,
     /*  639099 */     // GIR_Coverage, 6676,
     /*  639099 */     GIR_EraseRootFromParent_Done,
     /*  639100 */   // Label 10273: @639100
     /*  639100 */   GIM_Try, /*On fail goto*//*Label 10274*/ GIMT_Encode4(639175), // Rule ID 6677 //
     /*  639105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  639116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  639119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  639122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639151 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  639154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639173 */     GIR_RootConstrainSelectedInstOperands,
     /*  639174 */     // GIR_Coverage, 6677,
     /*  639174 */     GIR_EraseRootFromParent_Done,
     /*  639175 */   // Label 10274: @639175
     /*  639175 */   GIM_Try, /*On fail goto*//*Label 10275*/ GIMT_Encode4(639250), // Rule ID 6680 //
     /*  639180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  639191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  639194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  639197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639226 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  639229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639248 */     GIR_RootConstrainSelectedInstOperands,
     /*  639249 */     // GIR_Coverage, 6680,
     /*  639249 */     GIR_EraseRootFromParent_Done,
     /*  639250 */   // Label 10275: @639250
     /*  639250 */   GIM_Try, /*On fail goto*//*Label 10276*/ GIMT_Encode4(639325), // Rule ID 6681 //
     /*  639255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  639266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  639269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  639272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639301 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  639304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639323 */     GIR_RootConstrainSelectedInstOperands,
     /*  639324 */     // GIR_Coverage, 6681,
     /*  639324 */     GIR_EraseRootFromParent_Done,
     /*  639325 */   // Label 10276: @639325
     /*  639325 */   GIM_Try, /*On fail goto*//*Label 10277*/ GIMT_Encode4(639400), // Rule ID 6684 //
     /*  639330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  639341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  639344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  639347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639376 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  639376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  639379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639398 */     GIR_RootConstrainSelectedInstOperands,
     /*  639399 */     // GIR_Coverage, 6684,
     /*  639399 */     GIR_EraseRootFromParent_Done,
     /*  639400 */   // Label 10277: @639400
     /*  639400 */   GIM_Try, /*On fail goto*//*Label 10278*/ GIMT_Encode4(639475), // Rule ID 6685 //
     /*  639405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  639416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  639419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  639422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639451 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  639451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  639454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639473 */     GIR_RootConstrainSelectedInstOperands,
     /*  639474 */     // GIR_Coverage, 6685,
     /*  639474 */     GIR_EraseRootFromParent_Done,
     /*  639475 */   // Label 10278: @639475
     /*  639475 */   GIM_Try, /*On fail goto*//*Label 10279*/ GIMT_Encode4(639550), // Rule ID 6688 //
     /*  639480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639526 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639548 */     GIR_RootConstrainSelectedInstOperands,
     /*  639549 */     // GIR_Coverage, 6688,
     /*  639549 */     GIR_EraseRootFromParent_Done,
     /*  639550 */   // Label 10279: @639550
     /*  639550 */   GIM_Try, /*On fail goto*//*Label 10280*/ GIMT_Encode4(639625), // Rule ID 6689 //
     /*  639555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639601 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639623 */     GIR_RootConstrainSelectedInstOperands,
     /*  639624 */     // GIR_Coverage, 6689,
     /*  639624 */     GIR_EraseRootFromParent_Done,
     /*  639625 */   // Label 10280: @639625
     /*  639625 */   GIM_Try, /*On fail goto*//*Label 10281*/ GIMT_Encode4(639700), // Rule ID 6692 //
     /*  639630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639676 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639698 */     GIR_RootConstrainSelectedInstOperands,
     /*  639699 */     // GIR_Coverage, 6692,
     /*  639699 */     GIR_EraseRootFromParent_Done,
     /*  639700 */   // Label 10281: @639700
     /*  639700 */   GIM_Try, /*On fail goto*//*Label 10282*/ GIMT_Encode4(639775), // Rule ID 6693 //
     /*  639705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639751 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639773 */     GIR_RootConstrainSelectedInstOperands,
     /*  639774 */     // GIR_Coverage, 6693,
     /*  639774 */     GIR_EraseRootFromParent_Done,
     /*  639775 */   // Label 10282: @639775
     /*  639775 */   GIM_Try, /*On fail goto*//*Label 10283*/ GIMT_Encode4(639850), // Rule ID 6696 //
     /*  639780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  639826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639848 */     GIR_RootConstrainSelectedInstOperands,
     /*  639849 */     // GIR_Coverage, 6696,
     /*  639849 */     GIR_EraseRootFromParent_Done,
     /*  639850 */   // Label 10283: @639850
     /*  639850 */   GIM_Try, /*On fail goto*//*Label 10284*/ GIMT_Encode4(639925), // Rule ID 6697 //
     /*  639855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639901 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  639901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639923 */     GIR_RootConstrainSelectedInstOperands,
     /*  639924 */     // GIR_Coverage, 6697,
     /*  639924 */     GIR_EraseRootFromParent_Done,
     /*  639925 */   // Label 10284: @639925
     /*  639925 */   GIM_Try, /*On fail goto*//*Label 10285*/ GIMT_Encode4(640000), // Rule ID 6700 //
     /*  639930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  639933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  639941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  639944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  639947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  639976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  639995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639998 */     GIR_RootConstrainSelectedInstOperands,
     /*  639999 */     // GIR_Coverage, 6700,
     /*  639999 */     GIR_EraseRootFromParent_Done,
     /*  640000 */   // Label 10285: @640000
     /*  640000 */   GIM_Try, /*On fail goto*//*Label 10286*/ GIMT_Encode4(640075), // Rule ID 6701 //
     /*  640005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  640008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  640016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  640019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  640022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640051 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  640051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  640054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640073 */     GIR_RootConstrainSelectedInstOperands,
     /*  640074 */     // GIR_Coverage, 6701,
     /*  640074 */     GIR_EraseRootFromParent_Done,
     /*  640075 */   // Label 10286: @640075
     /*  640075 */   GIM_Try, /*On fail goto*//*Label 10287*/ GIMT_Encode4(640150), // Rule ID 6704 //
     /*  640080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  640091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  640094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  640097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640126 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640148 */     GIR_RootConstrainSelectedInstOperands,
     /*  640149 */     // GIR_Coverage, 6704,
     /*  640149 */     GIR_EraseRootFromParent_Done,
     /*  640150 */   // Label 10287: @640150
     /*  640150 */   GIM_Try, /*On fail goto*//*Label 10288*/ GIMT_Encode4(640225), // Rule ID 6705 //
     /*  640155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  640166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  640169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  640172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640201 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640223 */     GIR_RootConstrainSelectedInstOperands,
     /*  640224 */     // GIR_Coverage, 6705,
     /*  640224 */     GIR_EraseRootFromParent_Done,
     /*  640225 */   // Label 10288: @640225
     /*  640225 */   GIM_Try, /*On fail goto*//*Label 10289*/ GIMT_Encode4(640300), // Rule ID 6708 //
     /*  640230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  640241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  640244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  640247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640276 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640298 */     GIR_RootConstrainSelectedInstOperands,
     /*  640299 */     // GIR_Coverage, 6708,
     /*  640299 */     GIR_EraseRootFromParent_Done,
     /*  640300 */   // Label 10289: @640300
     /*  640300 */   GIM_Try, /*On fail goto*//*Label 10290*/ GIMT_Encode4(640375), // Rule ID 6709 //
     /*  640305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  640316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  640319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  640322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640351 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640373 */     GIR_RootConstrainSelectedInstOperands,
     /*  640374 */     // GIR_Coverage, 6709,
     /*  640374 */     GIR_EraseRootFromParent_Done,
     /*  640375 */   // Label 10290: @640375
     /*  640375 */   GIM_Try, /*On fail goto*//*Label 10291*/ GIMT_Encode4(640450), // Rule ID 6712 //
     /*  640380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  640391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  640394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  640397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640426 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640448 */     GIR_RootConstrainSelectedInstOperands,
     /*  640449 */     // GIR_Coverage, 6712,
     /*  640449 */     GIR_EraseRootFromParent_Done,
     /*  640450 */   // Label 10291: @640450
     /*  640450 */   GIM_Try, /*On fail goto*//*Label 10292*/ GIMT_Encode4(640525), // Rule ID 6713 //
     /*  640455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  640466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  640469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  640472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640501 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640523 */     GIR_RootConstrainSelectedInstOperands,
     /*  640524 */     // GIR_Coverage, 6713,
     /*  640524 */     GIR_EraseRootFromParent_Done,
     /*  640525 */   // Label 10292: @640525
     /*  640525 */   GIM_Try, /*On fail goto*//*Label 10293*/ GIMT_Encode4(640600), // Rule ID 6716 //
     /*  640530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640576 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640598 */     GIR_RootConstrainSelectedInstOperands,
     /*  640599 */     // GIR_Coverage, 6716,
     /*  640599 */     GIR_EraseRootFromParent_Done,
     /*  640600 */   // Label 10293: @640600
     /*  640600 */   GIM_Try, /*On fail goto*//*Label 10294*/ GIMT_Encode4(640675), // Rule ID 6717 //
     /*  640605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640651 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640673 */     GIR_RootConstrainSelectedInstOperands,
     /*  640674 */     // GIR_Coverage, 6717,
     /*  640674 */     GIR_EraseRootFromParent_Done,
     /*  640675 */   // Label 10294: @640675
     /*  640675 */   GIM_Try, /*On fail goto*//*Label 10295*/ GIMT_Encode4(640750), // Rule ID 6720 //
     /*  640680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640726 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640748 */     GIR_RootConstrainSelectedInstOperands,
     /*  640749 */     // GIR_Coverage, 6720,
     /*  640749 */     GIR_EraseRootFromParent_Done,
     /*  640750 */   // Label 10295: @640750
     /*  640750 */   GIM_Try, /*On fail goto*//*Label 10296*/ GIMT_Encode4(640825), // Rule ID 6721 //
     /*  640755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640801 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640823 */     GIR_RootConstrainSelectedInstOperands,
     /*  640824 */     // GIR_Coverage, 6721,
     /*  640824 */     GIR_EraseRootFromParent_Done,
     /*  640825 */   // Label 10296: @640825
     /*  640825 */   GIM_Try, /*On fail goto*//*Label 10297*/ GIMT_Encode4(640900), // Rule ID 6724 //
     /*  640830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640876 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640898 */     GIR_RootConstrainSelectedInstOperands,
     /*  640899 */     // GIR_Coverage, 6724,
     /*  640899 */     GIR_EraseRootFromParent_Done,
     /*  640900 */   // Label 10297: @640900
     /*  640900 */   GIM_Try, /*On fail goto*//*Label 10298*/ GIMT_Encode4(640975), // Rule ID 6725 //
     /*  640905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640951 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640973 */     GIR_RootConstrainSelectedInstOperands,
     /*  640974 */     // GIR_Coverage, 6725,
     /*  640974 */     GIR_EraseRootFromParent_Done,
     /*  640975 */   // Label 10298: @640975
     /*  640975 */   GIM_Try, /*On fail goto*//*Label 10299*/ GIMT_Encode4(641050), // Rule ID 6728 //
     /*  640980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  640991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  640994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  640997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  641029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641048 */     GIR_RootConstrainSelectedInstOperands,
     /*  641049 */     // GIR_Coverage, 6728,
     /*  641049 */     GIR_EraseRootFromParent_Done,
     /*  641050 */   // Label 10299: @641050
     /*  641050 */   GIM_Try, /*On fail goto*//*Label 10300*/ GIMT_Encode4(641125), // Rule ID 6729 //
     /*  641055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  641066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  641069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  641072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641101 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  641104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641123 */     GIR_RootConstrainSelectedInstOperands,
     /*  641124 */     // GIR_Coverage, 6729,
     /*  641124 */     GIR_EraseRootFromParent_Done,
     /*  641125 */   // Label 10300: @641125
     /*  641125 */   GIM_Try, /*On fail goto*//*Label 10301*/ GIMT_Encode4(641200), // Rule ID 6732 //
     /*  641130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  641141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  641144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  641147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641176 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  641179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641198 */     GIR_RootConstrainSelectedInstOperands,
     /*  641199 */     // GIR_Coverage, 6732,
     /*  641199 */     GIR_EraseRootFromParent_Done,
     /*  641200 */   // Label 10301: @641200
     /*  641200 */   GIM_Try, /*On fail goto*//*Label 10302*/ GIMT_Encode4(641275), // Rule ID 6733 //
     /*  641205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  641216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  641219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  641222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641251 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  641254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641273 */     GIR_RootConstrainSelectedInstOperands,
     /*  641274 */     // GIR_Coverage, 6733,
     /*  641274 */     GIR_EraseRootFromParent_Done,
     /*  641275 */   // Label 10302: @641275
     /*  641275 */   GIM_Try, /*On fail goto*//*Label 10303*/ GIMT_Encode4(641350), // Rule ID 6736 //
     /*  641280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  641291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  641294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  641297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641326 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  641329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641348 */     GIR_RootConstrainSelectedInstOperands,
     /*  641349 */     // GIR_Coverage, 6736,
     /*  641349 */     GIR_EraseRootFromParent_Done,
     /*  641350 */   // Label 10303: @641350
     /*  641350 */   GIM_Try, /*On fail goto*//*Label 10304*/ GIMT_Encode4(641425), // Rule ID 6737 //
     /*  641355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  641366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  641369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  641372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641401 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  641404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641423 */     GIR_RootConstrainSelectedInstOperands,
     /*  641424 */     // GIR_Coverage, 6737,
     /*  641424 */     GIR_EraseRootFromParent_Done,
     /*  641425 */   // Label 10304: @641425
     /*  641425 */   GIM_Try, /*On fail goto*//*Label 10305*/ GIMT_Encode4(641500), // Rule ID 6740 //
     /*  641430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  641441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  641444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  641447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  641479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641498 */     GIR_RootConstrainSelectedInstOperands,
     /*  641499 */     // GIR_Coverage, 6740,
     /*  641499 */     GIR_EraseRootFromParent_Done,
     /*  641500 */   // Label 10305: @641500
     /*  641500 */   GIM_Try, /*On fail goto*//*Label 10306*/ GIMT_Encode4(641575), // Rule ID 6741 //
     /*  641505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  641516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  641519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  641522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641551 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  641554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641573 */     GIR_RootConstrainSelectedInstOperands,
     /*  641574 */     // GIR_Coverage, 6741,
     /*  641574 */     GIR_EraseRootFromParent_Done,
     /*  641575 */   // Label 10306: @641575
     /*  641575 */   GIM_Try, /*On fail goto*//*Label 10307*/ GIMT_Encode4(641650), // Rule ID 6744 //
     /*  641580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641626 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  641629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641648 */     GIR_RootConstrainSelectedInstOperands,
     /*  641649 */     // GIR_Coverage, 6744,
     /*  641649 */     GIR_EraseRootFromParent_Done,
     /*  641650 */   // Label 10307: @641650
     /*  641650 */   GIM_Try, /*On fail goto*//*Label 10308*/ GIMT_Encode4(641725), // Rule ID 6745 //
     /*  641655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641701 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  641704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641723 */     GIR_RootConstrainSelectedInstOperands,
     /*  641724 */     // GIR_Coverage, 6745,
     /*  641724 */     GIR_EraseRootFromParent_Done,
     /*  641725 */   // Label 10308: @641725
     /*  641725 */   GIM_Try, /*On fail goto*//*Label 10309*/ GIMT_Encode4(641800), // Rule ID 6748 //
     /*  641730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  641779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641798 */     GIR_RootConstrainSelectedInstOperands,
     /*  641799 */     // GIR_Coverage, 6748,
     /*  641799 */     GIR_EraseRootFromParent_Done,
     /*  641800 */   // Label 10309: @641800
     /*  641800 */   GIM_Try, /*On fail goto*//*Label 10310*/ GIMT_Encode4(641875), // Rule ID 6749 //
     /*  641805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641851 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  641854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641873 */     GIR_RootConstrainSelectedInstOperands,
     /*  641874 */     // GIR_Coverage, 6749,
     /*  641874 */     GIR_EraseRootFromParent_Done,
     /*  641875 */   // Label 10310: @641875
     /*  641875 */   GIM_Try, /*On fail goto*//*Label 10311*/ GIMT_Encode4(641950), // Rule ID 6840 //
     /*  641880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  641891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  641894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  641897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  641900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641926 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  641929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641948 */     GIR_RootConstrainSelectedInstOperands,
     /*  641949 */     // GIR_Coverage, 6840,
     /*  641949 */     GIR_EraseRootFromParent_Done,
     /*  641950 */   // Label 10311: @641950
     /*  641950 */   GIM_Try, /*On fail goto*//*Label 10312*/ GIMT_Encode4(642025), // Rule ID 6841 //
     /*  641955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  641966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  641969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  641972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  641975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642001 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  642004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642023 */     GIR_RootConstrainSelectedInstOperands,
     /*  642024 */     // GIR_Coverage, 6841,
     /*  642024 */     GIR_EraseRootFromParent_Done,
     /*  642025 */   // Label 10312: @642025
     /*  642025 */   GIM_Try, /*On fail goto*//*Label 10313*/ GIMT_Encode4(642100), // Rule ID 6844 //
     /*  642030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  642041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  642044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  642047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  642050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642076 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  642079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642098 */     GIR_RootConstrainSelectedInstOperands,
     /*  642099 */     // GIR_Coverage, 6844,
     /*  642099 */     GIR_EraseRootFromParent_Done,
     /*  642100 */   // Label 10313: @642100
     /*  642100 */   GIM_Try, /*On fail goto*//*Label 10314*/ GIMT_Encode4(642175), // Rule ID 6845 //
     /*  642105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  642116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  642119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  642122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  642125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642151 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  642154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642173 */     GIR_RootConstrainSelectedInstOperands,
     /*  642174 */     // GIR_Coverage, 6845,
     /*  642174 */     GIR_EraseRootFromParent_Done,
     /*  642175 */   // Label 10314: @642175
     /*  642175 */   GIM_Try, /*On fail goto*//*Label 10315*/ GIMT_Encode4(642250), // Rule ID 6848 //
     /*  642180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  642191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  642194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  642197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  642200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642226 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642248 */     GIR_RootConstrainSelectedInstOperands,
     /*  642249 */     // GIR_Coverage, 6848,
     /*  642249 */     GIR_EraseRootFromParent_Done,
     /*  642250 */   // Label 10315: @642250
     /*  642250 */   GIM_Try, /*On fail goto*//*Label 10316*/ GIMT_Encode4(642325), // Rule ID 6849 //
     /*  642255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  642266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  642269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  642272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  642275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642301 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642323 */     GIR_RootConstrainSelectedInstOperands,
     /*  642324 */     // GIR_Coverage, 6849,
     /*  642324 */     GIR_EraseRootFromParent_Done,
     /*  642325 */   // Label 10316: @642325
     /*  642325 */   GIM_Try, /*On fail goto*//*Label 10317*/ GIMT_Encode4(642400), // Rule ID 6852 //
     /*  642330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  642341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  642344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  642347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  642350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  642379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642398 */     GIR_RootConstrainSelectedInstOperands,
     /*  642399 */     // GIR_Coverage, 6852,
     /*  642399 */     GIR_EraseRootFromParent_Done,
     /*  642400 */   // Label 10317: @642400
     /*  642400 */   GIM_Try, /*On fail goto*//*Label 10318*/ GIMT_Encode4(642475), // Rule ID 6853 //
     /*  642405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  642416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  642419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  642422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  642425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642451 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  642454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642473 */     GIR_RootConstrainSelectedInstOperands,
     /*  642474 */     // GIR_Coverage, 6853,
     /*  642474 */     GIR_EraseRootFromParent_Done,
     /*  642475 */   // Label 10318: @642475
     /*  642475 */   GIM_Try, /*On fail goto*//*Label 10319*/ GIMT_Encode4(642550), // Rule ID 6856 //
     /*  642480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  642500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642526 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642548 */     GIR_RootConstrainSelectedInstOperands,
     /*  642549 */     // GIR_Coverage, 6856,
     /*  642549 */     GIR_EraseRootFromParent_Done,
     /*  642550 */   // Label 10319: @642550
     /*  642550 */   GIM_Try, /*On fail goto*//*Label 10320*/ GIMT_Encode4(642625), // Rule ID 6857 //
     /*  642555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  642575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642601 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642623 */     GIR_RootConstrainSelectedInstOperands,
     /*  642624 */     // GIR_Coverage, 6857,
     /*  642624 */     GIR_EraseRootFromParent_Done,
     /*  642625 */   // Label 10320: @642625
     /*  642625 */   GIM_Try, /*On fail goto*//*Label 10321*/ GIMT_Encode4(642700), // Rule ID 6860 //
     /*  642630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  642650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642676 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  642676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642698 */     GIR_RootConstrainSelectedInstOperands,
     /*  642699 */     // GIR_Coverage, 6860,
     /*  642699 */     GIR_EraseRootFromParent_Done,
     /*  642700 */   // Label 10321: @642700
     /*  642700 */   GIM_Try, /*On fail goto*//*Label 10322*/ GIMT_Encode4(642775), // Rule ID 6861 //
     /*  642705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  642725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642751 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  642751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642773 */     GIR_RootConstrainSelectedInstOperands,
     /*  642774 */     // GIR_Coverage, 6861,
     /*  642774 */     GIR_EraseRootFromParent_Done,
     /*  642775 */   // Label 10322: @642775
     /*  642775 */   GIM_Try, /*On fail goto*//*Label 10323*/ GIMT_Encode4(642850), // Rule ID 6864 //
     /*  642780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  642800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642848 */     GIR_RootConstrainSelectedInstOperands,
     /*  642849 */     // GIR_Coverage, 6864,
     /*  642849 */     GIR_EraseRootFromParent_Done,
     /*  642850 */   // Label 10323: @642850
     /*  642850 */   GIM_Try, /*On fail goto*//*Label 10324*/ GIMT_Encode4(642925), // Rule ID 6865 //
     /*  642855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  642875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642901 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642923 */     GIR_RootConstrainSelectedInstOperands,
     /*  642924 */     // GIR_Coverage, 6865,
     /*  642924 */     GIR_EraseRootFromParent_Done,
     /*  642925 */   // Label 10324: @642925
     /*  642925 */   GIM_Try, /*On fail goto*//*Label 10325*/ GIMT_Encode4(643000), // Rule ID 6868 //
     /*  642930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  642941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  642944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  642947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  642950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642998 */     GIR_RootConstrainSelectedInstOperands,
     /*  642999 */     // GIR_Coverage, 6868,
     /*  642999 */     GIR_EraseRootFromParent_Done,
     /*  643000 */   // Label 10325: @643000
     /*  643000 */   GIM_Try, /*On fail goto*//*Label 10326*/ GIMT_Encode4(643075), // Rule ID 6869 //
     /*  643005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  643016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  643019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  643022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  643025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643051 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  643054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643073 */     GIR_RootConstrainSelectedInstOperands,
     /*  643074 */     // GIR_Coverage, 6869,
     /*  643074 */     GIR_EraseRootFromParent_Done,
     /*  643075 */   // Label 10326: @643075
     /*  643075 */   GIM_Try, /*On fail goto*//*Label 10327*/ GIMT_Encode4(643150), // Rule ID 6872 //
     /*  643080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  643091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  643094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  643097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  643100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643126 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  643126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  643129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643148 */     GIR_RootConstrainSelectedInstOperands,
     /*  643149 */     // GIR_Coverage, 6872,
     /*  643149 */     GIR_EraseRootFromParent_Done,
     /*  643150 */   // Label 10327: @643150
     /*  643150 */   GIM_Try, /*On fail goto*//*Label 10328*/ GIMT_Encode4(643225), // Rule ID 6873 //
     /*  643155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  643166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  643169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  643172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  643175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643201 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  643201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  643204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643223 */     GIR_RootConstrainSelectedInstOperands,
     /*  643224 */     // GIR_Coverage, 6873,
     /*  643224 */     GIR_EraseRootFromParent_Done,
     /*  643225 */   // Label 10328: @643225
     /*  643225 */   GIM_Try, /*On fail goto*//*Label 10329*/ GIMT_Encode4(643300), // Rule ID 6876 //
     /*  643230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  643233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  643241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  643244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  643247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  643250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  643276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  643279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643298 */     GIR_RootConstrainSelectedInstOperands,
     /*  643299 */     // GIR_Coverage, 6876,
     /*  643299 */     GIR_EraseRootFromParent_Done,
     /*  643300 */   // Label 10329: @643300
     /*  643300 */   GIM_Try, /*On fail goto*//*Label 10330*/ GIMT_Encode4(643375), // Rule ID 6877 //
     /*  643305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  643308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  643316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  643319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  643322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  643325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643351 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  643351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  643354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643373 */     GIR_RootConstrainSelectedInstOperands,
     /*  643374 */     // GIR_Coverage, 6877,
     /*  643374 */     GIR_EraseRootFromParent_Done,
     /*  643375 */   // Label 10330: @643375
     /*  643375 */   GIM_Try, /*On fail goto*//*Label 10331*/ GIMT_Encode4(643450), // Rule ID 6880 //
     /*  643380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  643391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  643394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  643397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  643400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643426 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643448 */     GIR_RootConstrainSelectedInstOperands,
     /*  643449 */     // GIR_Coverage, 6880,
     /*  643449 */     GIR_EraseRootFromParent_Done,
     /*  643450 */   // Label 10331: @643450
     /*  643450 */   GIM_Try, /*On fail goto*//*Label 10332*/ GIMT_Encode4(643525), // Rule ID 6881 //
     /*  643455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  643466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  643469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  643472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  643475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643501 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643523 */     GIR_RootConstrainSelectedInstOperands,
     /*  643524 */     // GIR_Coverage, 6881,
     /*  643524 */     GIR_EraseRootFromParent_Done,
     /*  643525 */   // Label 10332: @643525
     /*  643525 */   GIM_Try, /*On fail goto*//*Label 10333*/ GIMT_Encode4(643600), // Rule ID 6884 //
     /*  643530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  643550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643576 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643598 */     GIR_RootConstrainSelectedInstOperands,
     /*  643599 */     // GIR_Coverage, 6884,
     /*  643599 */     GIR_EraseRootFromParent_Done,
     /*  643600 */   // Label 10333: @643600
     /*  643600 */   GIM_Try, /*On fail goto*//*Label 10334*/ GIMT_Encode4(643675), // Rule ID 6885 //
     /*  643605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  643625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643651 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643673 */     GIR_RootConstrainSelectedInstOperands,
     /*  643674 */     // GIR_Coverage, 6885,
     /*  643674 */     GIR_EraseRootFromParent_Done,
     /*  643675 */   // Label 10334: @643675
     /*  643675 */   GIM_Try, /*On fail goto*//*Label 10335*/ GIMT_Encode4(643750), // Rule ID 6888 //
     /*  643680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  643700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643726 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643748 */     GIR_RootConstrainSelectedInstOperands,
     /*  643749 */     // GIR_Coverage, 6888,
     /*  643749 */     GIR_EraseRootFromParent_Done,
     /*  643750 */   // Label 10335: @643750
     /*  643750 */   GIM_Try, /*On fail goto*//*Label 10336*/ GIMT_Encode4(643825), // Rule ID 6889 //
     /*  643755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  643775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643801 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643823 */     GIR_RootConstrainSelectedInstOperands,
     /*  643824 */     // GIR_Coverage, 6889,
     /*  643824 */     GIR_EraseRootFromParent_Done,
     /*  643825 */   // Label 10336: @643825
     /*  643825 */   GIM_Try, /*On fail goto*//*Label 10337*/ GIMT_Encode4(643900), // Rule ID 6892 //
     /*  643830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  643850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643898 */     GIR_RootConstrainSelectedInstOperands,
     /*  643899 */     // GIR_Coverage, 6892,
     /*  643899 */     GIR_EraseRootFromParent_Done,
     /*  643900 */   // Label 10337: @643900
     /*  643900 */   GIM_Try, /*On fail goto*//*Label 10338*/ GIMT_Encode4(643975), // Rule ID 6893 //
     /*  643905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  643925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643951 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643973 */     GIR_RootConstrainSelectedInstOperands,
     /*  643974 */     // GIR_Coverage, 6893,
     /*  643974 */     GIR_EraseRootFromParent_Done,
     /*  643975 */   // Label 10338: @643975
     /*  643975 */   GIM_Try, /*On fail goto*//*Label 10339*/ GIMT_Encode4(644050), // Rule ID 6896 //
     /*  643980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  643991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  643994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  643997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  644000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  644026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644048 */     GIR_RootConstrainSelectedInstOperands,
     /*  644049 */     // GIR_Coverage, 6896,
     /*  644049 */     GIR_EraseRootFromParent_Done,
     /*  644050 */   // Label 10339: @644050
     /*  644050 */   GIM_Try, /*On fail goto*//*Label 10340*/ GIMT_Encode4(644125), // Rule ID 6897 //
     /*  644055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  644066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  644069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  644072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  644075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644101 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644123 */     GIR_RootConstrainSelectedInstOperands,
     /*  644124 */     // GIR_Coverage, 6897,
     /*  644124 */     GIR_EraseRootFromParent_Done,
     /*  644125 */   // Label 10340: @644125
     /*  644125 */   GIM_Try, /*On fail goto*//*Label 10341*/ GIMT_Encode4(644200), // Rule ID 6900 //
     /*  644130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  644141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  644144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  644147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  644150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644176 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  644176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644198 */     GIR_RootConstrainSelectedInstOperands,
     /*  644199 */     // GIR_Coverage, 6900,
     /*  644199 */     GIR_EraseRootFromParent_Done,
     /*  644200 */   // Label 10341: @644200
     /*  644200 */   GIM_Try, /*On fail goto*//*Label 10342*/ GIMT_Encode4(644275), // Rule ID 6901 //
     /*  644205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  644216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  644219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  644222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  644225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644251 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644273 */     GIR_RootConstrainSelectedInstOperands,
     /*  644274 */     // GIR_Coverage, 6901,
     /*  644274 */     GIR_EraseRootFromParent_Done,
     /*  644275 */   // Label 10342: @644275
     /*  644275 */   GIM_Try, /*On fail goto*//*Label 10343*/ GIMT_Encode4(644350), // Rule ID 6904 //
     /*  644280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  644291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  644294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  644297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  644300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644326 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  644329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644348 */     GIR_RootConstrainSelectedInstOperands,
     /*  644349 */     // GIR_Coverage, 6904,
     /*  644349 */     GIR_EraseRootFromParent_Done,
     /*  644350 */   // Label 10343: @644350
     /*  644350 */   GIM_Try, /*On fail goto*//*Label 10344*/ GIMT_Encode4(644425), // Rule ID 6905 //
     /*  644355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  644366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  644369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  644372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  644375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  644404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644423 */     GIR_RootConstrainSelectedInstOperands,
     /*  644424 */     // GIR_Coverage, 6905,
     /*  644424 */     GIR_EraseRootFromParent_Done,
     /*  644425 */   // Label 10344: @644425
     /*  644425 */   GIM_Try, /*On fail goto*//*Label 10345*/ GIMT_Encode4(644500), // Rule ID 6908 //
     /*  644430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  644441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  644444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  644447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  644450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644476 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644498 */     GIR_RootConstrainSelectedInstOperands,
     /*  644499 */     // GIR_Coverage, 6908,
     /*  644499 */     GIR_EraseRootFromParent_Done,
     /*  644500 */   // Label 10345: @644500
     /*  644500 */   GIM_Try, /*On fail goto*//*Label 10346*/ GIMT_Encode4(644575), // Rule ID 6909 //
     /*  644505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  644516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  644519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  644522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  644525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644573 */     GIR_RootConstrainSelectedInstOperands,
     /*  644574 */     // GIR_Coverage, 6909,
     /*  644574 */     GIR_EraseRootFromParent_Done,
     /*  644575 */   // Label 10346: @644575
     /*  644575 */   GIM_Try, /*On fail goto*//*Label 10347*/ GIMT_Encode4(644650), // Rule ID 6912 //
     /*  644580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  644600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644648 */     GIR_RootConstrainSelectedInstOperands,
     /*  644649 */     // GIR_Coverage, 6912,
     /*  644649 */     GIR_EraseRootFromParent_Done,
     /*  644650 */   // Label 10347: @644650
     /*  644650 */   GIM_Try, /*On fail goto*//*Label 10348*/ GIMT_Encode4(644725), // Rule ID 6913 //
     /*  644655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  644675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644701 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644723 */     GIR_RootConstrainSelectedInstOperands,
     /*  644724 */     // GIR_Coverage, 6913,
     /*  644724 */     GIR_EraseRootFromParent_Done,
     /*  644725 */   // Label 10348: @644725
     /*  644725 */   GIM_Try, /*On fail goto*//*Label 10349*/ GIMT_Encode4(644800), // Rule ID 6916 //
     /*  644730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  644750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  644779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644798 */     GIR_RootConstrainSelectedInstOperands,
     /*  644799 */     // GIR_Coverage, 6916,
     /*  644799 */     GIR_EraseRootFromParent_Done,
     /*  644800 */   // Label 10349: @644800
     /*  644800 */   GIM_Try, /*On fail goto*//*Label 10350*/ GIMT_Encode4(644875), // Rule ID 6917 //
     /*  644805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  644825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644851 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  644854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644873 */     GIR_RootConstrainSelectedInstOperands,
     /*  644874 */     // GIR_Coverage, 6917,
     /*  644874 */     GIR_EraseRootFromParent_Done,
     /*  644875 */   // Label 10350: @644875
     /*  644875 */   GIM_Try, /*On fail goto*//*Label 10351*/ GIMT_Encode4(644950), // Rule ID 6920 //
     /*  644880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  644891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  644894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  644897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  644900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644926 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644948 */     GIR_RootConstrainSelectedInstOperands,
     /*  644949 */     // GIR_Coverage, 6920,
     /*  644949 */     GIR_EraseRootFromParent_Done,
     /*  644950 */   // Label 10351: @644950
     /*  644950 */   GIM_Try, /*On fail goto*//*Label 10352*/ GIMT_Encode4(645025), // Rule ID 6921 //
     /*  644955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  644966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  644969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  644972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  644975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645001 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  645001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  645004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645023 */     GIR_RootConstrainSelectedInstOperands,
     /*  645024 */     // GIR_Coverage, 6921,
     /*  645024 */     GIR_EraseRootFromParent_Done,
     /*  645025 */   // Label 10352: @645025
     /*  645025 */   GIM_Try, /*On fail goto*//*Label 10353*/ GIMT_Encode4(645100), // Rule ID 6924 //
     /*  645030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  645033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  645041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  645044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  645047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  645050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645076 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  645076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  645079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645098 */     GIR_RootConstrainSelectedInstOperands,
     /*  645099 */     // GIR_Coverage, 6924,
     /*  645099 */     GIR_EraseRootFromParent_Done,
     /*  645100 */   // Label 10353: @645100
     /*  645100 */   GIM_Try, /*On fail goto*//*Label 10354*/ GIMT_Encode4(645175), // Rule ID 6925 //
     /*  645105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  645108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  645116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  645119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  645122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  645125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645151 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  645151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  645154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645173 */     GIR_RootConstrainSelectedInstOperands,
     /*  645174 */     // GIR_Coverage, 6925,
     /*  645174 */     GIR_EraseRootFromParent_Done,
     /*  645175 */   // Label 10354: @645175
     /*  645175 */   GIM_Try, /*On fail goto*//*Label 10355*/ GIMT_Encode4(645250), // Rule ID 6928 //
     /*  645180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  645191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  645194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  645197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645226 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  645229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645248 */     GIR_RootConstrainSelectedInstOperands,
     /*  645249 */     // GIR_Coverage, 6928,
     /*  645249 */     GIR_EraseRootFromParent_Done,
     /*  645250 */   // Label 10355: @645250
     /*  645250 */   GIM_Try, /*On fail goto*//*Label 10356*/ GIMT_Encode4(645325), // Rule ID 6929 //
     /*  645255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  645266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  645269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  645272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645301 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  645304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645323 */     GIR_RootConstrainSelectedInstOperands,
     /*  645324 */     // GIR_Coverage, 6929,
     /*  645324 */     GIR_EraseRootFromParent_Done,
     /*  645325 */   // Label 10356: @645325
     /*  645325 */   GIM_Try, /*On fail goto*//*Label 10357*/ GIMT_Encode4(645400), // Rule ID 6932 //
     /*  645330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  645341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  645344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  645347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  645379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645398 */     GIR_RootConstrainSelectedInstOperands,
     /*  645399 */     // GIR_Coverage, 6932,
     /*  645399 */     GIR_EraseRootFromParent_Done,
     /*  645400 */   // Label 10357: @645400
     /*  645400 */   GIM_Try, /*On fail goto*//*Label 10358*/ GIMT_Encode4(645475), // Rule ID 6933 //
     /*  645405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  645416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  645419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  645422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645451 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  645454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645473 */     GIR_RootConstrainSelectedInstOperands,
     /*  645474 */     // GIR_Coverage, 6933,
     /*  645474 */     GIR_EraseRootFromParent_Done,
     /*  645475 */   // Label 10358: @645475
     /*  645475 */   GIM_Try, /*On fail goto*//*Label 10359*/ GIMT_Encode4(645550), // Rule ID 6936 //
     /*  645480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645526 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645548 */     GIR_RootConstrainSelectedInstOperands,
     /*  645549 */     // GIR_Coverage, 6936,
     /*  645549 */     GIR_EraseRootFromParent_Done,
     /*  645550 */   // Label 10359: @645550
     /*  645550 */   GIM_Try, /*On fail goto*//*Label 10360*/ GIMT_Encode4(645625), // Rule ID 6937 //
     /*  645555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645601 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645623 */     GIR_RootConstrainSelectedInstOperands,
     /*  645624 */     // GIR_Coverage, 6937,
     /*  645624 */     GIR_EraseRootFromParent_Done,
     /*  645625 */   // Label 10360: @645625
     /*  645625 */   GIM_Try, /*On fail goto*//*Label 10361*/ GIMT_Encode4(645700), // Rule ID 6940 //
     /*  645630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645676 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  645679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645698 */     GIR_RootConstrainSelectedInstOperands,
     /*  645699 */     // GIR_Coverage, 6940,
     /*  645699 */     GIR_EraseRootFromParent_Done,
     /*  645700 */   // Label 10361: @645700
     /*  645700 */   GIM_Try, /*On fail goto*//*Label 10362*/ GIMT_Encode4(645775), // Rule ID 6941 //
     /*  645705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645751 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  645754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645773 */     GIR_RootConstrainSelectedInstOperands,
     /*  645774 */     // GIR_Coverage, 6941,
     /*  645774 */     GIR_EraseRootFromParent_Done,
     /*  645775 */   // Label 10362: @645775
     /*  645775 */   GIM_Try, /*On fail goto*//*Label 10363*/ GIMT_Encode4(645850), // Rule ID 6944 //
     /*  645780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645848 */     GIR_RootConstrainSelectedInstOperands,
     /*  645849 */     // GIR_Coverage, 6944,
     /*  645849 */     GIR_EraseRootFromParent_Done,
     /*  645850 */   // Label 10363: @645850
     /*  645850 */   GIM_Try, /*On fail goto*//*Label 10364*/ GIMT_Encode4(645925), // Rule ID 6945 //
     /*  645855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645901 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645923 */     GIR_RootConstrainSelectedInstOperands,
     /*  645924 */     // GIR_Coverage, 6945,
     /*  645924 */     GIR_EraseRootFromParent_Done,
     /*  645925 */   // Label 10364: @645925
     /*  645925 */   GIM_Try, /*On fail goto*//*Label 10365*/ GIMT_Encode4(646000), // Rule ID 6948 //
     /*  645930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  645941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  645944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  645947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645976 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  645976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645998 */     GIR_RootConstrainSelectedInstOperands,
     /*  645999 */     // GIR_Coverage, 6948,
     /*  645999 */     GIR_EraseRootFromParent_Done,
     /*  646000 */   // Label 10365: @646000
     /*  646000 */   GIM_Try, /*On fail goto*//*Label 10366*/ GIMT_Encode4(646075), // Rule ID 6949 //
     /*  646005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  646016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  646019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  646022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646051 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  646054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646073 */     GIR_RootConstrainSelectedInstOperands,
     /*  646074 */     // GIR_Coverage, 6949,
     /*  646074 */     GIR_EraseRootFromParent_Done,
     /*  646075 */   // Label 10366: @646075
     /*  646075 */   GIM_Try, /*On fail goto*//*Label 10367*/ GIMT_Encode4(646150), // Rule ID 6952 //
     /*  646080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  646091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  646094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  646097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646126 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646148 */     GIR_RootConstrainSelectedInstOperands,
     /*  646149 */     // GIR_Coverage, 6952,
     /*  646149 */     GIR_EraseRootFromParent_Done,
     /*  646150 */   // Label 10367: @646150
     /*  646150 */   GIM_Try, /*On fail goto*//*Label 10368*/ GIMT_Encode4(646225), // Rule ID 6953 //
     /*  646155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  646166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  646169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  646172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646201 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646223 */     GIR_RootConstrainSelectedInstOperands,
     /*  646224 */     // GIR_Coverage, 6953,
     /*  646224 */     GIR_EraseRootFromParent_Done,
     /*  646225 */   // Label 10368: @646225
     /*  646225 */   GIM_Try, /*On fail goto*//*Label 10369*/ GIMT_Encode4(646300), // Rule ID 6956 //
     /*  646230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  646241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  646244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  646247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  646276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646298 */     GIR_RootConstrainSelectedInstOperands,
     /*  646299 */     // GIR_Coverage, 6956,
     /*  646299 */     GIR_EraseRootFromParent_Done,
     /*  646300 */   // Label 10369: @646300
     /*  646300 */   GIM_Try, /*On fail goto*//*Label 10370*/ GIMT_Encode4(646375), // Rule ID 6957 //
     /*  646305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  646316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  646319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  646322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646351 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  646351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646373 */     GIR_RootConstrainSelectedInstOperands,
     /*  646374 */     // GIR_Coverage, 6957,
     /*  646374 */     GIR_EraseRootFromParent_Done,
     /*  646375 */   // Label 10370: @646375
     /*  646375 */   GIM_Try, /*On fail goto*//*Label 10371*/ GIMT_Encode4(646450), // Rule ID 6960 //
     /*  646380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  646391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  646394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  646397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646426 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  646426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646448 */     GIR_RootConstrainSelectedInstOperands,
     /*  646449 */     // GIR_Coverage, 6960,
     /*  646449 */     GIR_EraseRootFromParent_Done,
     /*  646450 */   // Label 10371: @646450
     /*  646450 */   GIM_Try, /*On fail goto*//*Label 10372*/ GIMT_Encode4(646525), // Rule ID 6961 //
     /*  646455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  646466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  646469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  646472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646501 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646523 */     GIR_RootConstrainSelectedInstOperands,
     /*  646524 */     // GIR_Coverage, 6961,
     /*  646524 */     GIR_EraseRootFromParent_Done,
     /*  646525 */   // Label 10372: @646525
     /*  646525 */   GIM_Try, /*On fail goto*//*Label 10373*/ GIMT_Encode4(646600), // Rule ID 6964 //
     /*  646530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  646533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  646576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646598 */     GIR_RootConstrainSelectedInstOperands,
     /*  646599 */     // GIR_Coverage, 6964,
     /*  646599 */     GIR_EraseRootFromParent_Done,
     /*  646600 */   // Label 10373: @646600
     /*  646600 */   GIM_Try, /*On fail goto*//*Label 10374*/ GIMT_Encode4(646675), // Rule ID 6965 //
     /*  646605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  646608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646651 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  646651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646673 */     GIR_RootConstrainSelectedInstOperands,
     /*  646674 */     // GIR_Coverage, 6965,
     /*  646674 */     GIR_EraseRootFromParent_Done,
     /*  646675 */   // Label 10374: @646675
     /*  646675 */   GIM_Try, /*On fail goto*//*Label 10375*/ GIMT_Encode4(646750), // Rule ID 6968 //
     /*  646680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646748 */     GIR_RootConstrainSelectedInstOperands,
     /*  646749 */     // GIR_Coverage, 6968,
     /*  646749 */     GIR_EraseRootFromParent_Done,
     /*  646750 */   // Label 10375: @646750
     /*  646750 */   GIM_Try, /*On fail goto*//*Label 10376*/ GIMT_Encode4(646825), // Rule ID 6969 //
     /*  646755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646801 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646823 */     GIR_RootConstrainSelectedInstOperands,
     /*  646824 */     // GIR_Coverage, 6969,
     /*  646824 */     GIR_EraseRootFromParent_Done,
     /*  646825 */   // Label 10376: @646825
     /*  646825 */   GIM_Try, /*On fail goto*//*Label 10377*/ GIMT_Encode4(646900), // Rule ID 6972 //
     /*  646830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646876 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646898 */     GIR_RootConstrainSelectedInstOperands,
     /*  646899 */     // GIR_Coverage, 6972,
     /*  646899 */     GIR_EraseRootFromParent_Done,
     /*  646900 */   // Label 10377: @646900
     /*  646900 */   GIM_Try, /*On fail goto*//*Label 10378*/ GIMT_Encode4(646975), // Rule ID 6973 //
     /*  646905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646951 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646973 */     GIR_RootConstrainSelectedInstOperands,
     /*  646974 */     // GIR_Coverage, 6973,
     /*  646974 */     GIR_EraseRootFromParent_Done,
     /*  646975 */   // Label 10378: @646975
     /*  646975 */   GIM_Try, /*On fail goto*//*Label 10379*/ GIMT_Encode4(647050), // Rule ID 6976 //
     /*  646980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  646991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  646994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  646997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647026 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  647026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647048 */     GIR_RootConstrainSelectedInstOperands,
     /*  647049 */     // GIR_Coverage, 6976,
     /*  647049 */     GIR_EraseRootFromParent_Done,
     /*  647050 */   // Label 10379: @647050
     /*  647050 */   GIM_Try, /*On fail goto*//*Label 10380*/ GIMT_Encode4(647125), // Rule ID 6977 //
     /*  647055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  647066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  647069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  647072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647101 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  647101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647123 */     GIR_RootConstrainSelectedInstOperands,
     /*  647124 */     // GIR_Coverage, 6977,
     /*  647124 */     GIR_EraseRootFromParent_Done,
     /*  647125 */   // Label 10380: @647125
     /*  647125 */   GIM_Try, /*On fail goto*//*Label 10381*/ GIMT_Encode4(647200), // Rule ID 6980 //
     /*  647130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  647141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  647144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  647147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647176 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647198 */     GIR_RootConstrainSelectedInstOperands,
     /*  647199 */     // GIR_Coverage, 6980,
     /*  647199 */     GIR_EraseRootFromParent_Done,
     /*  647200 */   // Label 10381: @647200
     /*  647200 */   GIM_Try, /*On fail goto*//*Label 10382*/ GIMT_Encode4(647275), // Rule ID 6981 //
     /*  647205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  647216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  647219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  647222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647251 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647273 */     GIR_RootConstrainSelectedInstOperands,
     /*  647274 */     // GIR_Coverage, 6981,
     /*  647274 */     GIR_EraseRootFromParent_Done,
     /*  647275 */   // Label 10382: @647275
     /*  647275 */   GIM_Try, /*On fail goto*//*Label 10383*/ GIMT_Encode4(647350), // Rule ID 6984 //
     /*  647280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  647291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  647294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  647297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647326 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647348 */     GIR_RootConstrainSelectedInstOperands,
     /*  647349 */     // GIR_Coverage, 6984,
     /*  647349 */     GIR_EraseRootFromParent_Done,
     /*  647350 */   // Label 10383: @647350
     /*  647350 */   GIM_Try, /*On fail goto*//*Label 10384*/ GIMT_Encode4(647425), // Rule ID 6985 //
     /*  647355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  647366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  647369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  647372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647401 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647423 */     GIR_RootConstrainSelectedInstOperands,
     /*  647424 */     // GIR_Coverage, 6985,
     /*  647424 */     GIR_EraseRootFromParent_Done,
     /*  647425 */   // Label 10384: @647425
     /*  647425 */   GIM_Try, /*On fail goto*//*Label 10385*/ GIMT_Encode4(647500), // Rule ID 6988 //
     /*  647430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  647441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  647444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  647447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647476 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647498 */     GIR_RootConstrainSelectedInstOperands,
     /*  647499 */     // GIR_Coverage, 6988,
     /*  647499 */     GIR_EraseRootFromParent_Done,
     /*  647500 */   // Label 10385: @647500
     /*  647500 */   GIM_Try, /*On fail goto*//*Label 10386*/ GIMT_Encode4(647575), // Rule ID 6989 //
     /*  647505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  647516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  647519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  647522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647551 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647573 */     GIR_RootConstrainSelectedInstOperands,
     /*  647574 */     // GIR_Coverage, 6989,
     /*  647574 */     GIR_EraseRootFromParent_Done,
     /*  647575 */   // Label 10386: @647575
     /*  647575 */   GIM_Try, /*On fail goto*//*Label 10387*/ GIMT_Encode4(647650), // Rule ID 6992 //
     /*  647580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647648 */     GIR_RootConstrainSelectedInstOperands,
     /*  647649 */     // GIR_Coverage, 6992,
     /*  647649 */     GIR_EraseRootFromParent_Done,
     /*  647650 */   // Label 10387: @647650
     /*  647650 */   GIM_Try, /*On fail goto*//*Label 10388*/ GIMT_Encode4(647725), // Rule ID 6993 //
     /*  647655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647701 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647723 */     GIR_RootConstrainSelectedInstOperands,
     /*  647724 */     // GIR_Coverage, 6993,
     /*  647724 */     GIR_EraseRootFromParent_Done,
     /*  647725 */   // Label 10388: @647725
     /*  647725 */   GIM_Try, /*On fail goto*//*Label 10389*/ GIMT_Encode4(647800), // Rule ID 6996 //
     /*  647730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647798 */     GIR_RootConstrainSelectedInstOperands,
     /*  647799 */     // GIR_Coverage, 6996,
     /*  647799 */     GIR_EraseRootFromParent_Done,
     /*  647800 */   // Label 10389: @647800
     /*  647800 */   GIM_Try, /*On fail goto*//*Label 10390*/ GIMT_Encode4(647875), // Rule ID 6997 //
     /*  647805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647851 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647873 */     GIR_RootConstrainSelectedInstOperands,
     /*  647874 */     // GIR_Coverage, 6997,
     /*  647874 */     GIR_EraseRootFromParent_Done,
     /*  647875 */   // Label 10390: @647875
     /*  647875 */   GIM_Try, /*On fail goto*//*Label 10391*/ GIMT_Encode4(647950), // Rule ID 7000 //
     /*  647880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  647891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  647894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  647897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647926 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647948 */     GIR_RootConstrainSelectedInstOperands,
     /*  647949 */     // GIR_Coverage, 7000,
     /*  647949 */     GIR_EraseRootFromParent_Done,
     /*  647950 */   // Label 10391: @647950
     /*  647950 */   GIM_Try, /*On fail goto*//*Label 10392*/ GIMT_Encode4(648025), // Rule ID 7001 //
     /*  647955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  647966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  647969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  647972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648001 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  648001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  648004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648023 */     GIR_RootConstrainSelectedInstOperands,
     /*  648024 */     // GIR_Coverage, 7001,
     /*  648024 */     GIR_EraseRootFromParent_Done,
     /*  648025 */   // Label 10392: @648025
     /*  648025 */   GIM_Try, /*On fail goto*//*Label 10393*/ GIMT_Encode4(648100), // Rule ID 7004 //
     /*  648030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  648041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  648044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  648047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  648079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648098 */     GIR_RootConstrainSelectedInstOperands,
     /*  648099 */     // GIR_Coverage, 7004,
     /*  648099 */     GIR_EraseRootFromParent_Done,
     /*  648100 */   // Label 10393: @648100
     /*  648100 */   GIM_Try, /*On fail goto*//*Label 10394*/ GIMT_Encode4(648175), // Rule ID 7005 //
     /*  648105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  648116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  648119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  648122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648151 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  648154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648173 */     GIR_RootConstrainSelectedInstOperands,
     /*  648174 */     // GIR_Coverage, 7005,
     /*  648174 */     GIR_EraseRootFromParent_Done,
     /*  648175 */   // Label 10394: @648175
     /*  648175 */   GIM_Try, /*On fail goto*//*Label 10395*/ GIMT_Encode4(648250), // Rule ID 7008 //
     /*  648180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  648191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  648194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  648197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648226 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  648229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648248 */     GIR_RootConstrainSelectedInstOperands,
     /*  648249 */     // GIR_Coverage, 7008,
     /*  648249 */     GIR_EraseRootFromParent_Done,
     /*  648250 */   // Label 10395: @648250
     /*  648250 */   GIM_Try, /*On fail goto*//*Label 10396*/ GIMT_Encode4(648325), // Rule ID 7009 //
     /*  648255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  648266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  648269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  648272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648301 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  648304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648323 */     GIR_RootConstrainSelectedInstOperands,
     /*  648324 */     // GIR_Coverage, 7009,
     /*  648324 */     GIR_EraseRootFromParent_Done,
     /*  648325 */   // Label 10396: @648325
     /*  648325 */   GIM_Try, /*On fail goto*//*Label 10397*/ GIMT_Encode4(648400), // Rule ID 7012 //
     /*  648330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  648341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  648344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  648347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648376 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  648379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648398 */     GIR_RootConstrainSelectedInstOperands,
     /*  648399 */     // GIR_Coverage, 7012,
     /*  648399 */     GIR_EraseRootFromParent_Done,
     /*  648400 */   // Label 10397: @648400
     /*  648400 */   GIM_Try, /*On fail goto*//*Label 10398*/ GIMT_Encode4(648475), // Rule ID 7013 //
     /*  648405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  648416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  648419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  648422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648451 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  648454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648473 */     GIR_RootConstrainSelectedInstOperands,
     /*  648474 */     // GIR_Coverage, 7013,
     /*  648474 */     GIR_EraseRootFromParent_Done,
     /*  648475 */   // Label 10398: @648475
     /*  648475 */   GIM_Try, /*On fail goto*//*Label 10399*/ GIMT_Encode4(648550), // Rule ID 7104 //
     /*  648480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  648491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  648494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  648500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648526 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  648529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648548 */     GIR_RootConstrainSelectedInstOperands,
     /*  648549 */     // GIR_Coverage, 7104,
     /*  648549 */     GIR_EraseRootFromParent_Done,
     /*  648550 */   // Label 10399: @648550
     /*  648550 */   GIM_Try, /*On fail goto*//*Label 10400*/ GIMT_Encode4(648625), // Rule ID 7105 //
     /*  648555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  648566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  648569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  648575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648601 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  648604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648623 */     GIR_RootConstrainSelectedInstOperands,
     /*  648624 */     // GIR_Coverage, 7105,
     /*  648624 */     GIR_EraseRootFromParent_Done,
     /*  648625 */   // Label 10400: @648625
     /*  648625 */   GIM_Try, /*On fail goto*//*Label 10401*/ GIMT_Encode4(648700), // Rule ID 7108 //
     /*  648630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  648641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  648644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  648650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648676 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648698 */     GIR_RootConstrainSelectedInstOperands,
     /*  648699 */     // GIR_Coverage, 7108,
     /*  648699 */     GIR_EraseRootFromParent_Done,
     /*  648700 */   // Label 10401: @648700
     /*  648700 */   GIM_Try, /*On fail goto*//*Label 10402*/ GIMT_Encode4(648775), // Rule ID 7109 //
     /*  648705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  648716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  648719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  648725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648751 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648773 */     GIR_RootConstrainSelectedInstOperands,
     /*  648774 */     // GIR_Coverage, 7109,
     /*  648774 */     GIR_EraseRootFromParent_Done,
     /*  648775 */   // Label 10402: @648775
     /*  648775 */   GIM_Try, /*On fail goto*//*Label 10403*/ GIMT_Encode4(648850), // Rule ID 7112 //
     /*  648780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  648791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  648794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  648800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648826 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648848 */     GIR_RootConstrainSelectedInstOperands,
     /*  648849 */     // GIR_Coverage, 7112,
     /*  648849 */     GIR_EraseRootFromParent_Done,
     /*  648850 */   // Label 10403: @648850
     /*  648850 */   GIM_Try, /*On fail goto*//*Label 10404*/ GIMT_Encode4(648925), // Rule ID 7113 //
     /*  648855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  648866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  648869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  648875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648901 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648923 */     GIR_RootConstrainSelectedInstOperands,
     /*  648924 */     // GIR_Coverage, 7113,
     /*  648924 */     GIR_EraseRootFromParent_Done,
     /*  648925 */   // Label 10404: @648925
     /*  648925 */   GIM_Try, /*On fail goto*//*Label 10405*/ GIMT_Encode4(649000), // Rule ID 7116 //
     /*  648930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  648941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  648944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  648947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  648950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  648976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648998 */     GIR_RootConstrainSelectedInstOperands,
     /*  648999 */     // GIR_Coverage, 7116,
     /*  648999 */     GIR_EraseRootFromParent_Done,
     /*  649000 */   // Label 10405: @649000
     /*  649000 */   GIM_Try, /*On fail goto*//*Label 10406*/ GIMT_Encode4(649075), // Rule ID 7117 //
     /*  649005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  649016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  649019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  649022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  649025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649051 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  649054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649073 */     GIR_RootConstrainSelectedInstOperands,
     /*  649074 */     // GIR_Coverage, 7117,
     /*  649074 */     GIR_EraseRootFromParent_Done,
     /*  649075 */   // Label 10406: @649075
     /*  649075 */   GIM_Try, /*On fail goto*//*Label 10407*/ GIMT_Encode4(649150), // Rule ID 7120 //
     /*  649080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  649091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  649094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  649097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  649100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  649129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649148 */     GIR_RootConstrainSelectedInstOperands,
     /*  649149 */     // GIR_Coverage, 7120,
     /*  649149 */     GIR_EraseRootFromParent_Done,
     /*  649150 */   // Label 10407: @649150
     /*  649150 */   GIM_Try, /*On fail goto*//*Label 10408*/ GIMT_Encode4(649225), // Rule ID 7121 //
     /*  649155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  649166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  649169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  649172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  649175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649201 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  649204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649223 */     GIR_RootConstrainSelectedInstOperands,
     /*  649224 */     // GIR_Coverage, 7121,
     /*  649224 */     GIR_EraseRootFromParent_Done,
     /*  649225 */   // Label 10408: @649225
     /*  649225 */   GIM_Try, /*On fail goto*//*Label 10409*/ GIMT_Encode4(649300), // Rule ID 7124 //
     /*  649230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  649241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  649244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  649247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  649250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  649276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  649279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649298 */     GIR_RootConstrainSelectedInstOperands,
     /*  649299 */     // GIR_Coverage, 7124,
     /*  649299 */     GIR_EraseRootFromParent_Done,
     /*  649300 */   // Label 10409: @649300
     /*  649300 */   GIM_Try, /*On fail goto*//*Label 10410*/ GIMT_Encode4(649375), // Rule ID 7125 //
     /*  649305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  649316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  649319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  649322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  649325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649351 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  649351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  649354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649373 */     GIR_RootConstrainSelectedInstOperands,
     /*  649374 */     // GIR_Coverage, 7125,
     /*  649374 */     GIR_EraseRootFromParent_Done,
     /*  649375 */   // Label 10410: @649375
     /*  649375 */   GIM_Try, /*On fail goto*//*Label 10411*/ GIMT_Encode4(649450), // Rule ID 7128 //
     /*  649380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  649391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  649394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  649397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  649400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649448 */     GIR_RootConstrainSelectedInstOperands,
     /*  649449 */     // GIR_Coverage, 7128,
     /*  649449 */     GIR_EraseRootFromParent_Done,
     /*  649450 */   // Label 10411: @649450
     /*  649450 */   GIM_Try, /*On fail goto*//*Label 10412*/ GIMT_Encode4(649525), // Rule ID 7129 //
     /*  649455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  649466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  649469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  649472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  649475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649501 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649523 */     GIR_RootConstrainSelectedInstOperands,
     /*  649524 */     // GIR_Coverage, 7129,
     /*  649524 */     GIR_EraseRootFromParent_Done,
     /*  649525 */   // Label 10412: @649525
     /*  649525 */   GIM_Try, /*On fail goto*//*Label 10413*/ GIMT_Encode4(649600), // Rule ID 7132 //
     /*  649530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  649541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  649544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  649550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649598 */     GIR_RootConstrainSelectedInstOperands,
     /*  649599 */     // GIR_Coverage, 7132,
     /*  649599 */     GIR_EraseRootFromParent_Done,
     /*  649600 */   // Label 10413: @649600
     /*  649600 */   GIM_Try, /*On fail goto*//*Label 10414*/ GIMT_Encode4(649675), // Rule ID 7133 //
     /*  649605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  649616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  649619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  649625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649651 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649673 */     GIR_RootConstrainSelectedInstOperands,
     /*  649674 */     // GIR_Coverage, 7133,
     /*  649674 */     GIR_EraseRootFromParent_Done,
     /*  649675 */   // Label 10414: @649675
     /*  649675 */   GIM_Try, /*On fail goto*//*Label 10415*/ GIMT_Encode4(649750), // Rule ID 7136 //
     /*  649680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  649697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  649700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  649726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649748 */     GIR_RootConstrainSelectedInstOperands,
     /*  649749 */     // GIR_Coverage, 7136,
     /*  649749 */     GIR_EraseRootFromParent_Done,
     /*  649750 */   // Label 10415: @649750
     /*  649750 */   GIM_Try, /*On fail goto*//*Label 10416*/ GIMT_Encode4(649825), // Rule ID 7137 //
     /*  649755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  649772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  649775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649801 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  649801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649823 */     GIR_RootConstrainSelectedInstOperands,
     /*  649824 */     // GIR_Coverage, 7137,
     /*  649824 */     GIR_EraseRootFromParent_Done,
     /*  649825 */   // Label 10416: @649825
     /*  649825 */   GIM_Try, /*On fail goto*//*Label 10417*/ GIMT_Encode4(649900), // Rule ID 7140 //
     /*  649830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  649833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  649841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  649844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  649847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  649850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  649876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  649895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649898 */     GIR_RootConstrainSelectedInstOperands,
     /*  649899 */     // GIR_Coverage, 7140,
     /*  649899 */     GIR_EraseRootFromParent_Done,
     /*  649900 */   // Label 10417: @649900
     /*  649900 */   GIM_Try, /*On fail goto*//*Label 10418*/ GIMT_Encode4(649975), // Rule ID 7141 //
     /*  649905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  649908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  649916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  649919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  649922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  649925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649951 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  649951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  649970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649973 */     GIR_RootConstrainSelectedInstOperands,
     /*  649974 */     // GIR_Coverage, 7141,
     /*  649974 */     GIR_EraseRootFromParent_Done,
     /*  649975 */   // Label 10418: @649975
     /*  649975 */   GIM_Try, /*On fail goto*//*Label 10419*/ GIMT_Encode4(650050), // Rule ID 7144 //
     /*  649980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  649991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  649994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  649997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  650000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650048 */     GIR_RootConstrainSelectedInstOperands,
     /*  650049 */     // GIR_Coverage, 7144,
     /*  650049 */     GIR_EraseRootFromParent_Done,
     /*  650050 */   // Label 10419: @650050
     /*  650050 */   GIM_Try, /*On fail goto*//*Label 10420*/ GIMT_Encode4(650125), // Rule ID 7145 //
     /*  650055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  650066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  650069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  650072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  650075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650123 */     GIR_RootConstrainSelectedInstOperands,
     /*  650124 */     // GIR_Coverage, 7145,
     /*  650124 */     GIR_EraseRootFromParent_Done,
     /*  650125 */   // Label 10420: @650125
     /*  650125 */   GIM_Try, /*On fail goto*//*Label 10421*/ GIMT_Encode4(650200), // Rule ID 7148 //
     /*  650130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  650141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  650144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  650147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  650150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650176 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650198 */     GIR_RootConstrainSelectedInstOperands,
     /*  650199 */     // GIR_Coverage, 7148,
     /*  650199 */     GIR_EraseRootFromParent_Done,
     /*  650200 */   // Label 10421: @650200
     /*  650200 */   GIM_Try, /*On fail goto*//*Label 10422*/ GIMT_Encode4(650275), // Rule ID 7149 //
     /*  650205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  650216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  650219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  650222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  650225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650251 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650273 */     GIR_RootConstrainSelectedInstOperands,
     /*  650274 */     // GIR_Coverage, 7149,
     /*  650274 */     GIR_EraseRootFromParent_Done,
     /*  650275 */   // Label 10422: @650275
     /*  650275 */   GIM_Try, /*On fail goto*//*Label 10423*/ GIMT_Encode4(650350), // Rule ID 7152 //
     /*  650280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  650291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  650294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  650297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  650300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650348 */     GIR_RootConstrainSelectedInstOperands,
     /*  650349 */     // GIR_Coverage, 7152,
     /*  650349 */     GIR_EraseRootFromParent_Done,
     /*  650350 */   // Label 10423: @650350
     /*  650350 */   GIM_Try, /*On fail goto*//*Label 10424*/ GIMT_Encode4(650425), // Rule ID 7153 //
     /*  650355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  650366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  650369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  650372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  650375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650401 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650423 */     GIR_RootConstrainSelectedInstOperands,
     /*  650424 */     // GIR_Coverage, 7153,
     /*  650424 */     GIR_EraseRootFromParent_Done,
     /*  650425 */   // Label 10424: @650425
     /*  650425 */   GIM_Try, /*On fail goto*//*Label 10425*/ GIMT_Encode4(650500), // Rule ID 7156 //
     /*  650430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  650441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  650444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  650447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  650450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650498 */     GIR_RootConstrainSelectedInstOperands,
     /*  650499 */     // GIR_Coverage, 7156,
     /*  650499 */     GIR_EraseRootFromParent_Done,
     /*  650500 */   // Label 10425: @650500
     /*  650500 */   GIM_Try, /*On fail goto*//*Label 10426*/ GIMT_Encode4(650575), // Rule ID 7157 //
     /*  650505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  650516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  650519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  650522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  650525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650573 */     GIR_RootConstrainSelectedInstOperands,
     /*  650574 */     // GIR_Coverage, 7157,
     /*  650574 */     GIR_EraseRootFromParent_Done,
     /*  650575 */   // Label 10426: @650575
     /*  650575 */   GIM_Try, /*On fail goto*//*Label 10427*/ GIMT_Encode4(650650), // Rule ID 7160 //
     /*  650580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  650591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  650594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  650600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650648 */     GIR_RootConstrainSelectedInstOperands,
     /*  650649 */     // GIR_Coverage, 7160,
     /*  650649 */     GIR_EraseRootFromParent_Done,
     /*  650650 */   // Label 10427: @650650
     /*  650650 */   GIM_Try, /*On fail goto*//*Label 10428*/ GIMT_Encode4(650725), // Rule ID 7161 //
     /*  650655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  650666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  650669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  650675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650701 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650723 */     GIR_RootConstrainSelectedInstOperands,
     /*  650724 */     // GIR_Coverage, 7161,
     /*  650724 */     GIR_EraseRootFromParent_Done,
     /*  650725 */   // Label 10428: @650725
     /*  650725 */   GIM_Try, /*On fail goto*//*Label 10429*/ GIMT_Encode4(650800), // Rule ID 7164 //
     /*  650730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  650741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  650744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  650747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  650750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650798 */     GIR_RootConstrainSelectedInstOperands,
     /*  650799 */     // GIR_Coverage, 7164,
     /*  650799 */     GIR_EraseRootFromParent_Done,
     /*  650800 */   // Label 10429: @650800
     /*  650800 */   GIM_Try, /*On fail goto*//*Label 10430*/ GIMT_Encode4(650875), // Rule ID 7165 //
     /*  650805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  650816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  650819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  650822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  650825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650851 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650873 */     GIR_RootConstrainSelectedInstOperands,
     /*  650874 */     // GIR_Coverage, 7165,
     /*  650874 */     GIR_EraseRootFromParent_Done,
     /*  650875 */   // Label 10430: @650875
     /*  650875 */   GIM_Try, /*On fail goto*//*Label 10431*/ GIMT_Encode4(650950), // Rule ID 7168 //
     /*  650880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  650891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  650894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  650897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  650900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650948 */     GIR_RootConstrainSelectedInstOperands,
     /*  650949 */     // GIR_Coverage, 7168,
     /*  650949 */     GIR_EraseRootFromParent_Done,
     /*  650950 */   // Label 10431: @650950
     /*  650950 */   GIM_Try, /*On fail goto*//*Label 10432*/ GIMT_Encode4(651025), // Rule ID 7169 //
     /*  650955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  650966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  650969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  650972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  650975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  651001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  651004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651023 */     GIR_RootConstrainSelectedInstOperands,
     /*  651024 */     // GIR_Coverage, 7169,
     /*  651024 */     GIR_EraseRootFromParent_Done,
     /*  651025 */   // Label 10432: @651025
     /*  651025 */   GIM_Try, /*On fail goto*//*Label 10433*/ GIMT_Encode4(651100), // Rule ID 7172 //
     /*  651030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  651041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  651044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  651047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  651050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  651076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  651079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651098 */     GIR_RootConstrainSelectedInstOperands,
     /*  651099 */     // GIR_Coverage, 7172,
     /*  651099 */     GIR_EraseRootFromParent_Done,
     /*  651100 */   // Label 10433: @651100
     /*  651100 */   GIM_Try, /*On fail goto*//*Label 10434*/ GIMT_Encode4(651175), // Rule ID 7173 //
     /*  651105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  651116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  651119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  651122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  651125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651151 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  651151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  651154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651173 */     GIR_RootConstrainSelectedInstOperands,
     /*  651174 */     // GIR_Coverage, 7173,
     /*  651174 */     GIR_EraseRootFromParent_Done,
     /*  651175 */   // Label 10434: @651175
     /*  651175 */   GIM_Try, /*On fail goto*//*Label 10435*/ GIMT_Encode4(651250), // Rule ID 7176 //
     /*  651180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  651191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  651194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  651197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  651200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651226 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  651226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  651229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651248 */     GIR_RootConstrainSelectedInstOperands,
     /*  651249 */     // GIR_Coverage, 7176,
     /*  651249 */     GIR_EraseRootFromParent_Done,
     /*  651250 */   // Label 10435: @651250
     /*  651250 */   GIM_Try, /*On fail goto*//*Label 10436*/ GIMT_Encode4(651325), // Rule ID 7177 //
     /*  651255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  651266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  651269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  651272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  651275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651301 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  651301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  651304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651323 */     GIR_RootConstrainSelectedInstOperands,
     /*  651324 */     // GIR_Coverage, 7177,
     /*  651324 */     GIR_EraseRootFromParent_Done,
     /*  651325 */   // Label 10436: @651325
     /*  651325 */   GIM_Try, /*On fail goto*//*Label 10437*/ GIMT_Encode4(651400), // Rule ID 7180 //
     /*  651330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  651341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  651344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  651347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  651350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  651379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651398 */     GIR_RootConstrainSelectedInstOperands,
     /*  651399 */     // GIR_Coverage, 7180,
     /*  651399 */     GIR_EraseRootFromParent_Done,
     /*  651400 */   // Label 10437: @651400
     /*  651400 */   GIM_Try, /*On fail goto*//*Label 10438*/ GIMT_Encode4(651475), // Rule ID 7181 //
     /*  651405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  651416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  651419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  651422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  651425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  651454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651473 */     GIR_RootConstrainSelectedInstOperands,
     /*  651474 */     // GIR_Coverage, 7181,
     /*  651474 */     GIR_EraseRootFromParent_Done,
     /*  651475 */   // Label 10438: @651475
     /*  651475 */   GIM_Try, /*On fail goto*//*Label 10439*/ GIMT_Encode4(651550), // Rule ID 7184 //
     /*  651480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  651491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  651494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  651497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  651500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651526 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  651529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651548 */     GIR_RootConstrainSelectedInstOperands,
     /*  651549 */     // GIR_Coverage, 7184,
     /*  651549 */     GIR_EraseRootFromParent_Done,
     /*  651550 */   // Label 10439: @651550
     /*  651550 */   GIM_Try, /*On fail goto*//*Label 10440*/ GIMT_Encode4(651625), // Rule ID 7185 //
     /*  651555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  651566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  651569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  651572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  651575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651601 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  651604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651623 */     GIR_RootConstrainSelectedInstOperands,
     /*  651624 */     // GIR_Coverage, 7185,
     /*  651624 */     GIR_EraseRootFromParent_Done,
     /*  651625 */   // Label 10440: @651625
     /*  651625 */   GIM_Try, /*On fail goto*//*Label 10441*/ GIMT_Encode4(651700), // Rule ID 7188 //
     /*  651630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  651641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  651644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  651647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  651650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  651679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651698 */     GIR_RootConstrainSelectedInstOperands,
     /*  651699 */     // GIR_Coverage, 7188,
     /*  651699 */     GIR_EraseRootFromParent_Done,
     /*  651700 */   // Label 10441: @651700
     /*  651700 */   GIM_Try, /*On fail goto*//*Label 10442*/ GIMT_Encode4(651775), // Rule ID 7189 //
     /*  651705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  651716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  651719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  651722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  651725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651751 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  651754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651773 */     GIR_RootConstrainSelectedInstOperands,
     /*  651774 */     // GIR_Coverage, 7189,
     /*  651774 */     GIR_EraseRootFromParent_Done,
     /*  651775 */   // Label 10442: @651775
     /*  651775 */   GIM_Try, /*On fail goto*//*Label 10443*/ GIMT_Encode4(651850), // Rule ID 7192 //
     /*  651780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  651791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  651794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  651797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651826 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  651829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651848 */     GIR_RootConstrainSelectedInstOperands,
     /*  651849 */     // GIR_Coverage, 7192,
     /*  651849 */     GIR_EraseRootFromParent_Done,
     /*  651850 */   // Label 10443: @651850
     /*  651850 */   GIM_Try, /*On fail goto*//*Label 10444*/ GIMT_Encode4(651925), // Rule ID 7193 //
     /*  651855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  651866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  651869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  651872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651901 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  651904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651923 */     GIR_RootConstrainSelectedInstOperands,
     /*  651924 */     // GIR_Coverage, 7193,
     /*  651924 */     GIR_EraseRootFromParent_Done,
     /*  651925 */   // Label 10444: @651925
     /*  651925 */   GIM_Try, /*On fail goto*//*Label 10445*/ GIMT_Encode4(652000), // Rule ID 7196 //
     /*  651930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  651941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  651944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  651947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651998 */     GIR_RootConstrainSelectedInstOperands,
     /*  651999 */     // GIR_Coverage, 7196,
     /*  651999 */     GIR_EraseRootFromParent_Done,
     /*  652000 */   // Label 10445: @652000
     /*  652000 */   GIM_Try, /*On fail goto*//*Label 10446*/ GIMT_Encode4(652075), // Rule ID 7197 //
     /*  652005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  652016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  652019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  652022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652051 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  652054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652073 */     GIR_RootConstrainSelectedInstOperands,
     /*  652074 */     // GIR_Coverage, 7197,
     /*  652074 */     GIR_EraseRootFromParent_Done,
     /*  652075 */   // Label 10446: @652075
     /*  652075 */   GIM_Try, /*On fail goto*//*Label 10447*/ GIMT_Encode4(652150), // Rule ID 7200 //
     /*  652080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  652091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  652094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  652097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652126 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652148 */     GIR_RootConstrainSelectedInstOperands,
     /*  652149 */     // GIR_Coverage, 7200,
     /*  652149 */     GIR_EraseRootFromParent_Done,
     /*  652150 */   // Label 10447: @652150
     /*  652150 */   GIM_Try, /*On fail goto*//*Label 10448*/ GIMT_Encode4(652225), // Rule ID 7201 //
     /*  652155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  652166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  652169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  652172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652201 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652223 */     GIR_RootConstrainSelectedInstOperands,
     /*  652224 */     // GIR_Coverage, 7201,
     /*  652224 */     GIR_EraseRootFromParent_Done,
     /*  652225 */   // Label 10448: @652225
     /*  652225 */   GIM_Try, /*On fail goto*//*Label 10449*/ GIMT_Encode4(652300), // Rule ID 7204 //
     /*  652230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  652241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  652244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  652247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  652279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652298 */     GIR_RootConstrainSelectedInstOperands,
     /*  652299 */     // GIR_Coverage, 7204,
     /*  652299 */     GIR_EraseRootFromParent_Done,
     /*  652300 */   // Label 10449: @652300
     /*  652300 */   GIM_Try, /*On fail goto*//*Label 10450*/ GIMT_Encode4(652375), // Rule ID 7205 //
     /*  652305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  652316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  652319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  652322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652351 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  652354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652373 */     GIR_RootConstrainSelectedInstOperands,
     /*  652374 */     // GIR_Coverage, 7205,
     /*  652374 */     GIR_EraseRootFromParent_Done,
     /*  652375 */   // Label 10450: @652375
     /*  652375 */   GIM_Try, /*On fail goto*//*Label 10451*/ GIMT_Encode4(652450), // Rule ID 7208 //
     /*  652380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  652391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  652394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  652397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652426 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652448 */     GIR_RootConstrainSelectedInstOperands,
     /*  652449 */     // GIR_Coverage, 7208,
     /*  652449 */     GIR_EraseRootFromParent_Done,
     /*  652450 */   // Label 10451: @652450
     /*  652450 */   GIM_Try, /*On fail goto*//*Label 10452*/ GIMT_Encode4(652525), // Rule ID 7209 //
     /*  652455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  652466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  652469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  652472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652501 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652523 */     GIR_RootConstrainSelectedInstOperands,
     /*  652524 */     // GIR_Coverage, 7209,
     /*  652524 */     GIR_EraseRootFromParent_Done,
     /*  652525 */   // Label 10452: @652525
     /*  652525 */   GIM_Try, /*On fail goto*//*Label 10453*/ GIMT_Encode4(652600), // Rule ID 7212 //
     /*  652530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  652541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  652544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652576 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652598 */     GIR_RootConstrainSelectedInstOperands,
     /*  652599 */     // GIR_Coverage, 7212,
     /*  652599 */     GIR_EraseRootFromParent_Done,
     /*  652600 */   // Label 10453: @652600
     /*  652600 */   GIM_Try, /*On fail goto*//*Label 10454*/ GIMT_Encode4(652675), // Rule ID 7213 //
     /*  652605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  652616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  652619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652651 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652673 */     GIR_RootConstrainSelectedInstOperands,
     /*  652674 */     // GIR_Coverage, 7213,
     /*  652674 */     GIR_EraseRootFromParent_Done,
     /*  652675 */   // Label 10454: @652675
     /*  652675 */   GIM_Try, /*On fail goto*//*Label 10455*/ GIMT_Encode4(652750), // Rule ID 7216 //
     /*  652680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  652691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  652694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  652697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652748 */     GIR_RootConstrainSelectedInstOperands,
     /*  652749 */     // GIR_Coverage, 7216,
     /*  652749 */     GIR_EraseRootFromParent_Done,
     /*  652750 */   // Label 10455: @652750
     /*  652750 */   GIM_Try, /*On fail goto*//*Label 10456*/ GIMT_Encode4(652825), // Rule ID 7217 //
     /*  652755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  652766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  652769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  652772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652801 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11634:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652823 */     GIR_RootConstrainSelectedInstOperands,
     /*  652824 */     // GIR_Coverage, 7217,
     /*  652824 */     GIR_EraseRootFromParent_Done,
     /*  652825 */   // Label 10456: @652825
     /*  652825 */   GIM_Try, /*On fail goto*//*Label 10457*/ GIMT_Encode4(652900), // Rule ID 7220 //
     /*  652830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  652841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  652844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  652847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652898 */     GIR_RootConstrainSelectedInstOperands,
     /*  652899 */     // GIR_Coverage, 7220,
     /*  652899 */     GIR_EraseRootFromParent_Done,
     /*  652900 */   // Label 10457: @652900
     /*  652900 */   GIM_Try, /*On fail goto*//*Label 10458*/ GIMT_Encode4(652975), // Rule ID 7221 //
     /*  652905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  652916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  652919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  652922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652951 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652973 */     GIR_RootConstrainSelectedInstOperands,
     /*  652974 */     // GIR_Coverage, 7221,
     /*  652974 */     GIR_EraseRootFromParent_Done,
     /*  652975 */   // Label 10458: @652975
     /*  652975 */   GIM_Try, /*On fail goto*//*Label 10459*/ GIMT_Encode4(653050), // Rule ID 7224 //
     /*  652980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  652991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  652994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  652997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  653026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  653029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653048 */     GIR_RootConstrainSelectedInstOperands,
     /*  653049 */     // GIR_Coverage, 7224,
     /*  653049 */     GIR_EraseRootFromParent_Done,
     /*  653050 */   // Label 10459: @653050
     /*  653050 */   GIM_Try, /*On fail goto*//*Label 10460*/ GIMT_Encode4(653125), // Rule ID 7225 //
     /*  653055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  653066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  653069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  653072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653101 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  653101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  653104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653123 */     GIR_RootConstrainSelectedInstOperands,
     /*  653124 */     // GIR_Coverage, 7225,
     /*  653124 */     GIR_EraseRootFromParent_Done,
     /*  653125 */   // Label 10460: @653125
     /*  653125 */   GIM_Try, /*On fail goto*//*Label 10461*/ GIMT_Encode4(653200), // Rule ID 7228 //
     /*  653130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  653133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  653141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  653144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  653147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653176 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  653176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  653179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  653195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653198 */     GIR_RootConstrainSelectedInstOperands,
     /*  653199 */     // GIR_Coverage, 7228,
     /*  653199 */     GIR_EraseRootFromParent_Done,
     /*  653200 */   // Label 10461: @653200
     /*  653200 */   GIM_Try, /*On fail goto*//*Label 10462*/ GIMT_Encode4(653275), // Rule ID 7229 //
     /*  653205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  653208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  653216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  653219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  653222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653251 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  653251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  653254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  653270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653273 */     GIR_RootConstrainSelectedInstOperands,
     /*  653274 */     // GIR_Coverage, 7229,
     /*  653274 */     GIR_EraseRootFromParent_Done,
     /*  653275 */   // Label 10462: @653275
     /*  653275 */   GIM_Try, /*On fail goto*//*Label 10463*/ GIMT_Encode4(653350), // Rule ID 7232 //
     /*  653280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  653291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  653294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  653297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653348 */     GIR_RootConstrainSelectedInstOperands,
     /*  653349 */     // GIR_Coverage, 7232,
     /*  653349 */     GIR_EraseRootFromParent_Done,
     /*  653350 */   // Label 10463: @653350
     /*  653350 */   GIM_Try, /*On fail goto*//*Label 10464*/ GIMT_Encode4(653425), // Rule ID 7233 //
     /*  653355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  653366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  653369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  653372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653401 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653423 */     GIR_RootConstrainSelectedInstOperands,
     /*  653424 */     // GIR_Coverage, 7233,
     /*  653424 */     GIR_EraseRootFromParent_Done,
     /*  653425 */   // Label 10464: @653425
     /*  653425 */   GIM_Try, /*On fail goto*//*Label 10465*/ GIMT_Encode4(653500), // Rule ID 7236 //
     /*  653430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  653441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  653444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  653447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653476 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653498 */     GIR_RootConstrainSelectedInstOperands,
     /*  653499 */     // GIR_Coverage, 7236,
     /*  653499 */     GIR_EraseRootFromParent_Done,
     /*  653500 */   // Label 10465: @653500
     /*  653500 */   GIM_Try, /*On fail goto*//*Label 10466*/ GIMT_Encode4(653575), // Rule ID 7237 //
     /*  653505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  653516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  653519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  653522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653551 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653573 */     GIR_RootConstrainSelectedInstOperands,
     /*  653574 */     // GIR_Coverage, 7237,
     /*  653574 */     GIR_EraseRootFromParent_Done,
     /*  653575 */   // Label 10466: @653575
     /*  653575 */   GIM_Try, /*On fail goto*//*Label 10467*/ GIMT_Encode4(653650), // Rule ID 7240 //
     /*  653580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  653591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  653594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  653597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653626 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653648 */     GIR_RootConstrainSelectedInstOperands,
     /*  653649 */     // GIR_Coverage, 7240,
     /*  653649 */     GIR_EraseRootFromParent_Done,
     /*  653650 */   // Label 10467: @653650
     /*  653650 */   GIM_Try, /*On fail goto*//*Label 10468*/ GIMT_Encode4(653725), // Rule ID 7241 //
     /*  653655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  653666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  653669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  653672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653701 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653723 */     GIR_RootConstrainSelectedInstOperands,
     /*  653724 */     // GIR_Coverage, 7241,
     /*  653724 */     GIR_EraseRootFromParent_Done,
     /*  653725 */   // Label 10468: @653725
     /*  653725 */   GIM_Try, /*On fail goto*//*Label 10469*/ GIMT_Encode4(653800), // Rule ID 7244 //
     /*  653730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  653747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653798 */     GIR_RootConstrainSelectedInstOperands,
     /*  653799 */     // GIR_Coverage, 7244,
     /*  653799 */     GIR_EraseRootFromParent_Done,
     /*  653800 */   // Label 10469: @653800
     /*  653800 */   GIM_Try, /*On fail goto*//*Label 10470*/ GIMT_Encode4(653875), // Rule ID 7245 //
     /*  653805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  653822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653873 */     GIR_RootConstrainSelectedInstOperands,
     /*  653874 */     // GIR_Coverage, 7245,
     /*  653874 */     GIR_EraseRootFromParent_Done,
     /*  653875 */   // Label 10470: @653875
     /*  653875 */   GIM_Try, /*On fail goto*//*Label 10471*/ GIMT_Encode4(653950), // Rule ID 7248 //
     /*  653880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  653891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  653894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  653897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653948 */     GIR_RootConstrainSelectedInstOperands,
     /*  653949 */     // GIR_Coverage, 7248,
     /*  653949 */     GIR_EraseRootFromParent_Done,
     /*  653950 */   // Label 10471: @653950
     /*  653950 */   GIM_Try, /*On fail goto*//*Label 10472*/ GIMT_Encode4(654025), // Rule ID 7249 //
     /*  653955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  653966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  653969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  653972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654001 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  654001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654023 */     GIR_RootConstrainSelectedInstOperands,
     /*  654024 */     // GIR_Coverage, 7249,
     /*  654024 */     GIR_EraseRootFromParent_Done,
     /*  654025 */   // Label 10472: @654025
     /*  654025 */   GIM_Try, /*On fail goto*//*Label 10473*/ GIMT_Encode4(654100), // Rule ID 7252 //
     /*  654030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  654041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  654044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  654047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654076 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  654076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654098 */     GIR_RootConstrainSelectedInstOperands,
     /*  654099 */     // GIR_Coverage, 7252,
     /*  654099 */     GIR_EraseRootFromParent_Done,
     /*  654100 */   // Label 10473: @654100
     /*  654100 */   GIM_Try, /*On fail goto*//*Label 10474*/ GIMT_Encode4(654175), // Rule ID 7253 //
     /*  654105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  654116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  654119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  654122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654151 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  654151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654173 */     GIR_RootConstrainSelectedInstOperands,
     /*  654174 */     // GIR_Coverage, 7253,
     /*  654174 */     GIR_EraseRootFromParent_Done,
     /*  654175 */   // Label 10474: @654175
     /*  654175 */   GIM_Try, /*On fail goto*//*Label 10475*/ GIMT_Encode4(654250), // Rule ID 7256 //
     /*  654180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  654191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  654194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  654197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  654229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654248 */     GIR_RootConstrainSelectedInstOperands,
     /*  654249 */     // GIR_Coverage, 7256,
     /*  654249 */     GIR_EraseRootFromParent_Done,
     /*  654250 */   // Label 10475: @654250
     /*  654250 */   GIM_Try, /*On fail goto*//*Label 10476*/ GIMT_Encode4(654325), // Rule ID 7257 //
     /*  654255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  654266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  654269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  654272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654301 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  654304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654323 */     GIR_RootConstrainSelectedInstOperands,
     /*  654324 */     // GIR_Coverage, 7257,
     /*  654324 */     GIR_EraseRootFromParent_Done,
     /*  654325 */   // Label 10476: @654325
     /*  654325 */   GIM_Try, /*On fail goto*//*Label 10477*/ GIMT_Encode4(654400), // Rule ID 7260 //
     /*  654330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  654341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  654344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  654347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654376 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654398 */     GIR_RootConstrainSelectedInstOperands,
     /*  654399 */     // GIR_Coverage, 7260,
     /*  654399 */     GIR_EraseRootFromParent_Done,
     /*  654400 */   // Label 10477: @654400
     /*  654400 */   GIM_Try, /*On fail goto*//*Label 10478*/ GIMT_Encode4(654475), // Rule ID 7261 //
     /*  654405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  654416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  654419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  654422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654451 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654473 */     GIR_RootConstrainSelectedInstOperands,
     /*  654474 */     // GIR_Coverage, 7261,
     /*  654474 */     GIR_EraseRootFromParent_Done,
     /*  654475 */   // Label 10478: @654475
     /*  654475 */   GIM_Try, /*On fail goto*//*Label 10479*/ GIMT_Encode4(654550), // Rule ID 7264 //
     /*  654480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  654497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654526 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654548 */     GIR_RootConstrainSelectedInstOperands,
     /*  654549 */     // GIR_Coverage, 7264,
     /*  654549 */     GIR_EraseRootFromParent_Done,
     /*  654550 */   // Label 10479: @654550
     /*  654550 */   GIM_Try, /*On fail goto*//*Label 10480*/ GIMT_Encode4(654625), // Rule ID 7265 //
     /*  654555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  654572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654601 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654623 */     GIR_RootConstrainSelectedInstOperands,
     /*  654624 */     // GIR_Coverage, 7265,
     /*  654624 */     GIR_EraseRootFromParent_Done,
     /*  654625 */   // Label 10480: @654625
     /*  654625 */   GIM_Try, /*On fail goto*//*Label 10481*/ GIMT_Encode4(654700), // Rule ID 7268 //
     /*  654630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  654647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  654679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654698 */     GIR_RootConstrainSelectedInstOperands,
     /*  654699 */     // GIR_Coverage, 7268,
     /*  654699 */     GIR_EraseRootFromParent_Done,
     /*  654700 */   // Label 10481: @654700
     /*  654700 */   GIM_Try, /*On fail goto*//*Label 10482*/ GIMT_Encode4(654775), // Rule ID 7269 //
     /*  654705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  654722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654751 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  654754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654773 */     GIR_RootConstrainSelectedInstOperands,
     /*  654774 */     // GIR_Coverage, 7269,
     /*  654774 */     GIR_EraseRootFromParent_Done,
     /*  654775 */   // Label 10482: @654775
     /*  654775 */   GIM_Try, /*On fail goto*//*Label 10483*/ GIMT_Encode4(654850), // Rule ID 7272 //
     /*  654780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  654797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654826 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654848 */     GIR_RootConstrainSelectedInstOperands,
     /*  654849 */     // GIR_Coverage, 7272,
     /*  654849 */     GIR_EraseRootFromParent_Done,
     /*  654850 */   // Label 10483: @654850
     /*  654850 */   GIM_Try, /*On fail goto*//*Label 10484*/ GIMT_Encode4(654925), // Rule ID 7273 //
     /*  654855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  654872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654901 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654923 */     GIR_RootConstrainSelectedInstOperands,
     /*  654924 */     // GIR_Coverage, 7273,
     /*  654924 */     GIR_EraseRootFromParent_Done,
     /*  654925 */   // Label 10484: @654925
     /*  654925 */   GIM_Try, /*On fail goto*//*Label 10485*/ GIMT_Encode4(655000), // Rule ID 7276 //
     /*  654930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  654941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  654944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  654947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654976 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654998 */     GIR_RootConstrainSelectedInstOperands,
     /*  654999 */     // GIR_Coverage, 7276,
     /*  654999 */     GIR_EraseRootFromParent_Done,
     /*  655000 */   // Label 10485: @655000
     /*  655000 */   GIM_Try, /*On fail goto*//*Label 10486*/ GIMT_Encode4(655075), // Rule ID 7277 //
     /*  655005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  655008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  655016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  655019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  655022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655051 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  655051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  655054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  655070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655073 */     GIR_RootConstrainSelectedInstOperands,
     /*  655074 */     // GIR_Coverage, 7277,
     /*  655074 */     GIR_EraseRootFromParent_Done,
     /*  655075 */   // Label 10486: @655075
     /*  655075 */   GIM_Try, /*On fail goto*//*Label 10487*/ GIMT_Encode4(655150), // Rule ID 7456 //
     /*  655080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  655091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  655094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  655097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  655100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655126 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  655129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655148 */     GIR_RootConstrainSelectedInstOperands,
     /*  655149 */     // GIR_Coverage, 7456,
     /*  655149 */     GIR_EraseRootFromParent_Done,
     /*  655150 */   // Label 10487: @655150
     /*  655150 */   GIM_Try, /*On fail goto*//*Label 10488*/ GIMT_Encode4(655225), // Rule ID 7457 //
     /*  655155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  655166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  655169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  655172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  655175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655201 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  655204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655223 */     GIR_RootConstrainSelectedInstOperands,
     /*  655224 */     // GIR_Coverage, 7457,
     /*  655224 */     GIR_EraseRootFromParent_Done,
     /*  655225 */   // Label 10488: @655225
     /*  655225 */   GIM_Try, /*On fail goto*//*Label 10489*/ GIMT_Encode4(655300), // Rule ID 7460 //
     /*  655230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  655241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  655244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  655247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  655250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655276 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  655279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655298 */     GIR_RootConstrainSelectedInstOperands,
     /*  655299 */     // GIR_Coverage, 7460,
     /*  655299 */     GIR_EraseRootFromParent_Done,
     /*  655300 */   // Label 10489: @655300
     /*  655300 */   GIM_Try, /*On fail goto*//*Label 10490*/ GIMT_Encode4(655375), // Rule ID 7461 //
     /*  655305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  655316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  655319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  655322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  655325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655351 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  655354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655373 */     GIR_RootConstrainSelectedInstOperands,
     /*  655374 */     // GIR_Coverage, 7461,
     /*  655374 */     GIR_EraseRootFromParent_Done,
     /*  655375 */   // Label 10490: @655375
     /*  655375 */   GIM_Try, /*On fail goto*//*Label 10491*/ GIMT_Encode4(655450), // Rule ID 7464 //
     /*  655380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  655391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  655394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  655397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  655400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655426 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655448 */     GIR_RootConstrainSelectedInstOperands,
     /*  655449 */     // GIR_Coverage, 7464,
     /*  655449 */     GIR_EraseRootFromParent_Done,
     /*  655450 */   // Label 10491: @655450
     /*  655450 */   GIM_Try, /*On fail goto*//*Label 10492*/ GIMT_Encode4(655525), // Rule ID 7465 //
     /*  655455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  655466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  655469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  655472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  655475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655501 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655523 */     GIR_RootConstrainSelectedInstOperands,
     /*  655524 */     // GIR_Coverage, 7465,
     /*  655524 */     GIR_EraseRootFromParent_Done,
     /*  655525 */   // Label 10492: @655525
     /*  655525 */   GIM_Try, /*On fail goto*//*Label 10493*/ GIMT_Encode4(655600), // Rule ID 7468 //
     /*  655530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  655541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  655544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  655547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  655550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655576 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655598 */     GIR_RootConstrainSelectedInstOperands,
     /*  655599 */     // GIR_Coverage, 7468,
     /*  655599 */     GIR_EraseRootFromParent_Done,
     /*  655600 */   // Label 10493: @655600
     /*  655600 */   GIM_Try, /*On fail goto*//*Label 10494*/ GIMT_Encode4(655675), // Rule ID 7469 //
     /*  655605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  655616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  655619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  655622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  655625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655651 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655673 */     GIR_RootConstrainSelectedInstOperands,
     /*  655674 */     // GIR_Coverage, 7469,
     /*  655674 */     GIR_EraseRootFromParent_Done,
     /*  655675 */   // Label 10494: @655675
     /*  655675 */   GIM_Try, /*On fail goto*//*Label 10495*/ GIMT_Encode4(655750), // Rule ID 7472 //
     /*  655680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  655691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  655694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  655697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  655700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  655729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655748 */     GIR_RootConstrainSelectedInstOperands,
     /*  655749 */     // GIR_Coverage, 7472,
     /*  655749 */     GIR_EraseRootFromParent_Done,
     /*  655750 */   // Label 10495: @655750
     /*  655750 */   GIM_Try, /*On fail goto*//*Label 10496*/ GIMT_Encode4(655825), // Rule ID 7473 //
     /*  655755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  655766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  655769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  655772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  655775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655801 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  655804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655823 */     GIR_RootConstrainSelectedInstOperands,
     /*  655824 */     // GIR_Coverage, 7473,
     /*  655824 */     GIR_EraseRootFromParent_Done,
     /*  655825 */   // Label 10496: @655825
     /*  655825 */   GIM_Try, /*On fail goto*//*Label 10497*/ GIMT_Encode4(655900), // Rule ID 7476 //
     /*  655830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  655841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  655844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  655847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  655850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655876 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  655879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655898 */     GIR_RootConstrainSelectedInstOperands,
     /*  655899 */     // GIR_Coverage, 7476,
     /*  655899 */     GIR_EraseRootFromParent_Done,
     /*  655900 */   // Label 10497: @655900
     /*  655900 */   GIM_Try, /*On fail goto*//*Label 10498*/ GIMT_Encode4(655975), // Rule ID 7477 //
     /*  655905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  655916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  655919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  655922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  655925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655951 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  655954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655973 */     GIR_RootConstrainSelectedInstOperands,
     /*  655974 */     // GIR_Coverage, 7477,
     /*  655974 */     GIR_EraseRootFromParent_Done,
     /*  655975 */   // Label 10498: @655975
     /*  655975 */   GIM_Try, /*On fail goto*//*Label 10499*/ GIMT_Encode4(656050), // Rule ID 7480 //
     /*  655980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  655997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  656000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  656029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656048 */     GIR_RootConstrainSelectedInstOperands,
     /*  656049 */     // GIR_Coverage, 7480,
     /*  656049 */     GIR_EraseRootFromParent_Done,
     /*  656050 */   // Label 10499: @656050
     /*  656050 */   GIM_Try, /*On fail goto*//*Label 10500*/ GIMT_Encode4(656125), // Rule ID 7481 //
     /*  656055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  656066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  656069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  656072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  656075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656101 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  656104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656123 */     GIR_RootConstrainSelectedInstOperands,
     /*  656124 */     // GIR_Coverage, 7481,
     /*  656124 */     GIR_EraseRootFromParent_Done,
     /*  656125 */   // Label 10500: @656125
     /*  656125 */   GIM_Try, /*On fail goto*//*Label 10501*/ GIMT_Encode4(656200), // Rule ID 7484 //
     /*  656130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  656141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  656144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  656147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  656150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656176 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  656179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656198 */     GIR_RootConstrainSelectedInstOperands,
     /*  656199 */     // GIR_Coverage, 7484,
     /*  656199 */     GIR_EraseRootFromParent_Done,
     /*  656200 */   // Label 10501: @656200
     /*  656200 */   GIM_Try, /*On fail goto*//*Label 10502*/ GIMT_Encode4(656275), // Rule ID 7485 //
     /*  656205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  656216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  656219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  656222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  656225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656251 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  656254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656273 */     GIR_RootConstrainSelectedInstOperands,
     /*  656274 */     // GIR_Coverage, 7485,
     /*  656274 */     GIR_EraseRootFromParent_Done,
     /*  656275 */   // Label 10502: @656275
     /*  656275 */   GIM_Try, /*On fail goto*//*Label 10503*/ GIMT_Encode4(656350), // Rule ID 7488 //
     /*  656280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  656291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  656294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  656297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  656300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656326 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  656329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656348 */     GIR_RootConstrainSelectedInstOperands,
     /*  656349 */     // GIR_Coverage, 7488,
     /*  656349 */     GIR_EraseRootFromParent_Done,
     /*  656350 */   // Label 10503: @656350
     /*  656350 */   GIM_Try, /*On fail goto*//*Label 10504*/ GIMT_Encode4(656425), // Rule ID 7489 //
     /*  656355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  656366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  656369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  656372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  656375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656401 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  656404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656423 */     GIR_RootConstrainSelectedInstOperands,
     /*  656424 */     // GIR_Coverage, 7489,
     /*  656424 */     GIR_EraseRootFromParent_Done,
     /*  656425 */   // Label 10504: @656425
     /*  656425 */   GIM_Try, /*On fail goto*//*Label 10505*/ GIMT_Encode4(656500), // Rule ID 7492 //
     /*  656430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  656441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  656444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  656447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  656450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656498 */     GIR_RootConstrainSelectedInstOperands,
     /*  656499 */     // GIR_Coverage, 7492,
     /*  656499 */     GIR_EraseRootFromParent_Done,
     /*  656500 */   // Label 10505: @656500
     /*  656500 */   GIM_Try, /*On fail goto*//*Label 10506*/ GIMT_Encode4(656575), // Rule ID 7493 //
     /*  656505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  656516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  656519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  656522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  656525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656573 */     GIR_RootConstrainSelectedInstOperands,
     /*  656574 */     // GIR_Coverage, 7493,
     /*  656574 */     GIR_EraseRootFromParent_Done,
     /*  656575 */   // Label 10506: @656575
     /*  656575 */   GIM_Try, /*On fail goto*//*Label 10507*/ GIMT_Encode4(656650), // Rule ID 7496 //
     /*  656580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  656591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  656594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  656597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  656600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656648 */     GIR_RootConstrainSelectedInstOperands,
     /*  656649 */     // GIR_Coverage, 7496,
     /*  656649 */     GIR_EraseRootFromParent_Done,
     /*  656650 */   // Label 10507: @656650
     /*  656650 */   GIM_Try, /*On fail goto*//*Label 10508*/ GIMT_Encode4(656725), // Rule ID 7497 //
     /*  656655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  656666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  656669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  656672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  656675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656701 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656723 */     GIR_RootConstrainSelectedInstOperands,
     /*  656724 */     // GIR_Coverage, 7497,
     /*  656724 */     GIR_EraseRootFromParent_Done,
     /*  656725 */   // Label 10508: @656725
     /*  656725 */   GIM_Try, /*On fail goto*//*Label 10509*/ GIMT_Encode4(656800), // Rule ID 7500 //
     /*  656730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  656741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  656744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  656747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  656750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656776 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  656779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656798 */     GIR_RootConstrainSelectedInstOperands,
     /*  656799 */     // GIR_Coverage, 7500,
     /*  656799 */     GIR_EraseRootFromParent_Done,
     /*  656800 */   // Label 10509: @656800
     /*  656800 */   GIM_Try, /*On fail goto*//*Label 10510*/ GIMT_Encode4(656875), // Rule ID 7501 //
     /*  656805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  656816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  656819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  656822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  656825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656851 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  656854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656873 */     GIR_RootConstrainSelectedInstOperands,
     /*  656874 */     // GIR_Coverage, 7501,
     /*  656874 */     GIR_EraseRootFromParent_Done,
     /*  656875 */   // Label 10510: @656875
     /*  656875 */   GIM_Try, /*On fail goto*//*Label 10511*/ GIMT_Encode4(656950), // Rule ID 7504 //
     /*  656880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  656897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  656900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656926 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  656929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656948 */     GIR_RootConstrainSelectedInstOperands,
     /*  656949 */     // GIR_Coverage, 7504,
     /*  656949 */     GIR_EraseRootFromParent_Done,
     /*  656950 */   // Label 10511: @656950
     /*  656950 */   GIM_Try, /*On fail goto*//*Label 10512*/ GIMT_Encode4(657025), // Rule ID 7505 //
     /*  656955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  656972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  656975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657001 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  657004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657023 */     GIR_RootConstrainSelectedInstOperands,
     /*  657024 */     // GIR_Coverage, 7505,
     /*  657024 */     GIR_EraseRootFromParent_Done,
     /*  657025 */   // Label 10512: @657025
     /*  657025 */   GIM_Try, /*On fail goto*//*Label 10513*/ GIMT_Encode4(657100), // Rule ID 7508 //
     /*  657030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  657033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  657041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  657044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  657047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  657050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  657079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657098 */     GIR_RootConstrainSelectedInstOperands,
     /*  657099 */     // GIR_Coverage, 7508,
     /*  657099 */     GIR_EraseRootFromParent_Done,
     /*  657100 */   // Label 10513: @657100
     /*  657100 */   GIM_Try, /*On fail goto*//*Label 10514*/ GIMT_Encode4(657175), // Rule ID 7509 //
     /*  657105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  657108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  657116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  657119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  657122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  657125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657151 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  657154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657173 */     GIR_RootConstrainSelectedInstOperands,
     /*  657174 */     // GIR_Coverage, 7509,
     /*  657174 */     GIR_EraseRootFromParent_Done,
     /*  657175 */   // Label 10514: @657175
     /*  657175 */   GIM_Try, /*On fail goto*//*Label 10515*/ GIMT_Encode4(657250), // Rule ID 7512 //
     /*  657180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  657183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  657191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  657194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  657197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  657200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657226 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  657229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657248 */     GIR_RootConstrainSelectedInstOperands,
     /*  657249 */     // GIR_Coverage, 7512,
     /*  657249 */     GIR_EraseRootFromParent_Done,
     /*  657250 */   // Label 10515: @657250
     /*  657250 */   GIM_Try, /*On fail goto*//*Label 10516*/ GIMT_Encode4(657325), // Rule ID 7513 //
     /*  657255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  657258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  657266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  657269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  657272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  657275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657301 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  657304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657323 */     GIR_RootConstrainSelectedInstOperands,
     /*  657324 */     // GIR_Coverage, 7513,
     /*  657324 */     GIR_EraseRootFromParent_Done,
     /*  657325 */   // Label 10516: @657325
     /*  657325 */   GIM_Try, /*On fail goto*//*Label 10517*/ GIMT_Encode4(657400), // Rule ID 7516 //
     /*  657330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  657341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  657344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  657347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657376 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  657379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657398 */     GIR_RootConstrainSelectedInstOperands,
     /*  657399 */     // GIR_Coverage, 7516,
     /*  657399 */     GIR_EraseRootFromParent_Done,
     /*  657400 */   // Label 10517: @657400
     /*  657400 */   GIM_Try, /*On fail goto*//*Label 10518*/ GIMT_Encode4(657475), // Rule ID 7517 //
     /*  657405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  657416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  657419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  657422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657451 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  657454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657473 */     GIR_RootConstrainSelectedInstOperands,
     /*  657474 */     // GIR_Coverage, 7517,
     /*  657474 */     GIR_EraseRootFromParent_Done,
     /*  657475 */   // Label 10518: @657475
     /*  657475 */   GIM_Try, /*On fail goto*//*Label 10519*/ GIMT_Encode4(657550), // Rule ID 7520 //
     /*  657480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  657491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  657494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  657497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657526 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657548 */     GIR_RootConstrainSelectedInstOperands,
     /*  657549 */     // GIR_Coverage, 7520,
     /*  657549 */     GIR_EraseRootFromParent_Done,
     /*  657550 */   // Label 10519: @657550
     /*  657550 */   GIM_Try, /*On fail goto*//*Label 10520*/ GIMT_Encode4(657625), // Rule ID 7521 //
     /*  657555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  657566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  657569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  657572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657601 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657623 */     GIR_RootConstrainSelectedInstOperands,
     /*  657624 */     // GIR_Coverage, 7521,
     /*  657624 */     GIR_EraseRootFromParent_Done,
     /*  657625 */   // Label 10520: @657625
     /*  657625 */   GIM_Try, /*On fail goto*//*Label 10521*/ GIMT_Encode4(657700), // Rule ID 7524 //
     /*  657630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  657641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  657644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  657647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657676 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  657679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657698 */     GIR_RootConstrainSelectedInstOperands,
     /*  657699 */     // GIR_Coverage, 7524,
     /*  657699 */     GIR_EraseRootFromParent_Done,
     /*  657700 */   // Label 10521: @657700
     /*  657700 */   GIM_Try, /*On fail goto*//*Label 10522*/ GIMT_Encode4(657775), // Rule ID 7525 //
     /*  657705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  657716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  657719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  657722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657751 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  657754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657773 */     GIR_RootConstrainSelectedInstOperands,
     /*  657774 */     // GIR_Coverage, 7525,
     /*  657774 */     GIR_EraseRootFromParent_Done,
     /*  657775 */   // Label 10522: @657775
     /*  657775 */   GIM_Try, /*On fail goto*//*Label 10523*/ GIMT_Encode4(657850), // Rule ID 7528 //
     /*  657780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  657791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  657794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  657797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  657829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657848 */     GIR_RootConstrainSelectedInstOperands,
     /*  657849 */     // GIR_Coverage, 7528,
     /*  657849 */     GIR_EraseRootFromParent_Done,
     /*  657850 */   // Label 10523: @657850
     /*  657850 */   GIM_Try, /*On fail goto*//*Label 10524*/ GIMT_Encode4(657925), // Rule ID 7529 //
     /*  657855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  657866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  657869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  657872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657901 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  657904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657923 */     GIR_RootConstrainSelectedInstOperands,
     /*  657924 */     // GIR_Coverage, 7529,
     /*  657924 */     GIR_EraseRootFromParent_Done,
     /*  657925 */   // Label 10524: @657925
     /*  657925 */   GIM_Try, /*On fail goto*//*Label 10525*/ GIMT_Encode4(658000), // Rule ID 7532 //
     /*  657930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  657941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  657944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  657947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657976 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  657979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657998 */     GIR_RootConstrainSelectedInstOperands,
     /*  657999 */     // GIR_Coverage, 7532,
     /*  657999 */     GIR_EraseRootFromParent_Done,
     /*  658000 */   // Label 10525: @658000
     /*  658000 */   GIM_Try, /*On fail goto*//*Label 10526*/ GIMT_Encode4(658075), // Rule ID 7533 //
     /*  658005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  658016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  658019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  658022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658051 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658073 */     GIR_RootConstrainSelectedInstOperands,
     /*  658074 */     // GIR_Coverage, 7533,
     /*  658074 */     GIR_EraseRootFromParent_Done,
     /*  658075 */   // Label 10526: @658075
     /*  658075 */   GIM_Try, /*On fail goto*//*Label 10527*/ GIMT_Encode4(658150), // Rule ID 7536 //
     /*  658080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  658091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  658094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  658097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658126 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658148 */     GIR_RootConstrainSelectedInstOperands,
     /*  658149 */     // GIR_Coverage, 7536,
     /*  658149 */     GIR_EraseRootFromParent_Done,
     /*  658150 */   // Label 10527: @658150
     /*  658150 */   GIM_Try, /*On fail goto*//*Label 10528*/ GIMT_Encode4(658225), // Rule ID 7537 //
     /*  658155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  658166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  658169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  658172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658201 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658223 */     GIR_RootConstrainSelectedInstOperands,
     /*  658224 */     // GIR_Coverage, 7537,
     /*  658224 */     GIR_EraseRootFromParent_Done,
     /*  658225 */   // Label 10528: @658225
     /*  658225 */   GIM_Try, /*On fail goto*//*Label 10529*/ GIMT_Encode4(658300), // Rule ID 7540 //
     /*  658230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  658241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  658244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  658247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  658279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658298 */     GIR_RootConstrainSelectedInstOperands,
     /*  658299 */     // GIR_Coverage, 7540,
     /*  658299 */     GIR_EraseRootFromParent_Done,
     /*  658300 */   // Label 10529: @658300
     /*  658300 */   GIM_Try, /*On fail goto*//*Label 10530*/ GIMT_Encode4(658375), // Rule ID 7541 //
     /*  658305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  658316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  658319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  658322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658351 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  658354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658373 */     GIR_RootConstrainSelectedInstOperands,
     /*  658374 */     // GIR_Coverage, 7541,
     /*  658374 */     GIR_EraseRootFromParent_Done,
     /*  658375 */   // Label 10530: @658375
     /*  658375 */   GIM_Try, /*On fail goto*//*Label 10531*/ GIMT_Encode4(658450), // Rule ID 7544 //
     /*  658380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  658391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  658394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  658397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658426 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  658429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658448 */     GIR_RootConstrainSelectedInstOperands,
     /*  658449 */     // GIR_Coverage, 7544,
     /*  658449 */     GIR_EraseRootFromParent_Done,
     /*  658450 */   // Label 10531: @658450
     /*  658450 */   GIM_Try, /*On fail goto*//*Label 10532*/ GIMT_Encode4(658525), // Rule ID 7545 //
     /*  658455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  658466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  658469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  658472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658501 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  658504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658523 */     GIR_RootConstrainSelectedInstOperands,
     /*  658524 */     // GIR_Coverage, 7545,
     /*  658524 */     GIR_EraseRootFromParent_Done,
     /*  658525 */   // Label 10532: @658525
     /*  658525 */   GIM_Try, /*On fail goto*//*Label 10533*/ GIMT_Encode4(658600), // Rule ID 7548 //
     /*  658530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  658541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  658544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  658547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658598 */     GIR_RootConstrainSelectedInstOperands,
     /*  658599 */     // GIR_Coverage, 7548,
     /*  658599 */     GIR_EraseRootFromParent_Done,
     /*  658600 */   // Label 10533: @658600
     /*  658600 */   GIM_Try, /*On fail goto*//*Label 10534*/ GIMT_Encode4(658675), // Rule ID 7549 //
     /*  658605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  658616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  658619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  658622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658651 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658673 */     GIR_RootConstrainSelectedInstOperands,
     /*  658674 */     // GIR_Coverage, 7549,
     /*  658674 */     GIR_EraseRootFromParent_Done,
     /*  658675 */   // Label 10534: @658675
     /*  658675 */   GIM_Try, /*On fail goto*//*Label 10535*/ GIMT_Encode4(658750), // Rule ID 7552 //
     /*  658680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  658691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  658694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  658697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658748 */     GIR_RootConstrainSelectedInstOperands,
     /*  658749 */     // GIR_Coverage, 7552,
     /*  658749 */     GIR_EraseRootFromParent_Done,
     /*  658750 */   // Label 10535: @658750
     /*  658750 */   GIM_Try, /*On fail goto*//*Label 10536*/ GIMT_Encode4(658825), // Rule ID 7553 //
     /*  658755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  658766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  658769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  658772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658801 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658823 */     GIR_RootConstrainSelectedInstOperands,
     /*  658824 */     // GIR_Coverage, 7553,
     /*  658824 */     GIR_EraseRootFromParent_Done,
     /*  658825 */   // Label 10536: @658825
     /*  658825 */   GIM_Try, /*On fail goto*//*Label 10537*/ GIMT_Encode4(658900), // Rule ID 7556 //
     /*  658830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  658841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  658844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  658847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658876 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658898 */     GIR_RootConstrainSelectedInstOperands,
     /*  658899 */     // GIR_Coverage, 7556,
     /*  658899 */     GIR_EraseRootFromParent_Done,
     /*  658900 */   // Label 10537: @658900
     /*  658900 */   GIM_Try, /*On fail goto*//*Label 10538*/ GIMT_Encode4(658975), // Rule ID 7557 //
     /*  658905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  658916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  658919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  658922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658951 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658973 */     GIR_RootConstrainSelectedInstOperands,
     /*  658974 */     // GIR_Coverage, 7557,
     /*  658974 */     GIR_EraseRootFromParent_Done,
     /*  658975 */   // Label 10538: @658975
     /*  658975 */   GIM_Try, /*On fail goto*//*Label 10539*/ GIMT_Encode4(659050), // Rule ID 7560 //
     /*  658980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  658991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  658994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  658997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  659000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659026 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  659029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659048 */     GIR_RootConstrainSelectedInstOperands,
     /*  659049 */     // GIR_Coverage, 7560,
     /*  659049 */     GIR_EraseRootFromParent_Done,
     /*  659050 */   // Label 10539: @659050
     /*  659050 */   GIM_Try, /*On fail goto*//*Label 10540*/ GIMT_Encode4(659125), // Rule ID 7561 //
     /*  659055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  659066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  659069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  659072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  659075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659101 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  659104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659123 */     GIR_RootConstrainSelectedInstOperands,
     /*  659124 */     // GIR_Coverage, 7561,
     /*  659124 */     GIR_EraseRootFromParent_Done,
     /*  659125 */   // Label 10540: @659125
     /*  659125 */   GIM_Try, /*On fail goto*//*Label 10541*/ GIMT_Encode4(659200), // Rule ID 7564 //
     /*  659130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  659133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  659141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  659144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  659147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  659150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  659179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659198 */     GIR_RootConstrainSelectedInstOperands,
     /*  659199 */     // GIR_Coverage, 7564,
     /*  659199 */     GIR_EraseRootFromParent_Done,
     /*  659200 */   // Label 10541: @659200
     /*  659200 */   GIM_Try, /*On fail goto*//*Label 10542*/ GIMT_Encode4(659275), // Rule ID 7565 //
     /*  659205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  659216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  659219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  659222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  659225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659251 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  659254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659273 */     GIR_RootConstrainSelectedInstOperands,
     /*  659274 */     // GIR_Coverage, 7565,
     /*  659274 */     GIR_EraseRootFromParent_Done,
     /*  659275 */   // Label 10542: @659275
     /*  659275 */   GIM_Try, /*On fail goto*//*Label 10543*/ GIMT_Encode4(659350), // Rule ID 7568 //
     /*  659280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  659283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  659291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  659294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  659297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  659300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659326 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  659329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659348 */     GIR_RootConstrainSelectedInstOperands,
     /*  659349 */     // GIR_Coverage, 7568,
     /*  659349 */     GIR_EraseRootFromParent_Done,
     /*  659350 */   // Label 10543: @659350
     /*  659350 */   GIM_Try, /*On fail goto*//*Label 10544*/ GIMT_Encode4(659425), // Rule ID 7569 //
     /*  659355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  659366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  659369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  659372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  659375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  659404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659423 */     GIR_RootConstrainSelectedInstOperands,
     /*  659424 */     // GIR_Coverage, 7569,
     /*  659424 */     GIR_EraseRootFromParent_Done,
     /*  659425 */   // Label 10544: @659425
     /*  659425 */   GIM_Try, /*On fail goto*//*Label 10545*/ GIMT_Encode4(659500), // Rule ID 7572 //
     /*  659430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  659433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  659441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  659444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  659447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  659450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659476 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  659479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659498 */     GIR_RootConstrainSelectedInstOperands,
     /*  659499 */     // GIR_Coverage, 7572,
     /*  659499 */     GIR_EraseRootFromParent_Done,
     /*  659500 */   // Label 10545: @659500
     /*  659500 */   GIM_Try, /*On fail goto*//*Label 10546*/ GIMT_Encode4(659575), // Rule ID 7573 //
     /*  659505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  659516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  659519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  659522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  659525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  659554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659573 */     GIR_RootConstrainSelectedInstOperands,
     /*  659574 */     // GIR_Coverage, 7573,
     /*  659574 */     GIR_EraseRootFromParent_Done,
     /*  659575 */   // Label 10546: @659575
     /*  659575 */   GIM_Try, /*On fail goto*//*Label 10547*/ GIMT_Encode4(659650), // Rule ID 7636 //
     /*  659580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  659591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  659594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  659597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  659600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659626 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  659629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659648 */     GIR_RootConstrainSelectedInstOperands,
     /*  659649 */     // GIR_Coverage, 7636,
     /*  659649 */     GIR_EraseRootFromParent_Done,
     /*  659650 */   // Label 10547: @659650
     /*  659650 */   GIM_Try, /*On fail goto*//*Label 10548*/ GIMT_Encode4(659725), // Rule ID 7637 //
     /*  659655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  659666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  659669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  659672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  659675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659701 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  659704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659723 */     GIR_RootConstrainSelectedInstOperands,
     /*  659724 */     // GIR_Coverage, 7637,
     /*  659724 */     GIR_EraseRootFromParent_Done,
     /*  659725 */   // Label 10548: @659725
     /*  659725 */   GIM_Try, /*On fail goto*//*Label 10549*/ GIMT_Encode4(659800), // Rule ID 7640 //
     /*  659730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  659741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  659744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  659747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  659750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659776 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  659779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659798 */     GIR_RootConstrainSelectedInstOperands,
     /*  659799 */     // GIR_Coverage, 7640,
     /*  659799 */     GIR_EraseRootFromParent_Done,
     /*  659800 */   // Label 10549: @659800
     /*  659800 */   GIM_Try, /*On fail goto*//*Label 10550*/ GIMT_Encode4(659875), // Rule ID 7641 //
     /*  659805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  659816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  659819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  659822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  659825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659851 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  659854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659873 */     GIR_RootConstrainSelectedInstOperands,
     /*  659874 */     // GIR_Coverage, 7641,
     /*  659874 */     GIR_EraseRootFromParent_Done,
     /*  659875 */   // Label 10550: @659875
     /*  659875 */   GIM_Try, /*On fail goto*//*Label 10551*/ GIMT_Encode4(659950), // Rule ID 7644 //
     /*  659880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  659891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  659894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  659897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  659900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659926 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  659929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659948 */     GIR_RootConstrainSelectedInstOperands,
     /*  659949 */     // GIR_Coverage, 7644,
     /*  659949 */     GIR_EraseRootFromParent_Done,
     /*  659950 */   // Label 10551: @659950
     /*  659950 */   GIM_Try, /*On fail goto*//*Label 10552*/ GIMT_Encode4(660025), // Rule ID 7645 //
     /*  659955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  659966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  659969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  659972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  659975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660001 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660023 */     GIR_RootConstrainSelectedInstOperands,
     /*  660024 */     // GIR_Coverage, 7645,
     /*  660024 */     GIR_EraseRootFromParent_Done,
     /*  660025 */   // Label 10552: @660025
     /*  660025 */   GIM_Try, /*On fail goto*//*Label 10553*/ GIMT_Encode4(660100), // Rule ID 7648 //
     /*  660030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  660041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  660044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  660047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  660050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660076 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660098 */     GIR_RootConstrainSelectedInstOperands,
     /*  660099 */     // GIR_Coverage, 7648,
     /*  660099 */     GIR_EraseRootFromParent_Done,
     /*  660100 */   // Label 10553: @660100
     /*  660100 */   GIM_Try, /*On fail goto*//*Label 10554*/ GIMT_Encode4(660175), // Rule ID 7649 //
     /*  660105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  660116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  660119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  660122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  660125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660151 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660173 */     GIR_RootConstrainSelectedInstOperands,
     /*  660174 */     // GIR_Coverage, 7649,
     /*  660174 */     GIR_EraseRootFromParent_Done,
     /*  660175 */   // Label 10554: @660175
     /*  660175 */   GIM_Try, /*On fail goto*//*Label 10555*/ GIMT_Encode4(660250), // Rule ID 7652 //
     /*  660180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  660191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  660194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  660197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  660200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660226 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660248 */     GIR_RootConstrainSelectedInstOperands,
     /*  660249 */     // GIR_Coverage, 7652,
     /*  660249 */     GIR_EraseRootFromParent_Done,
     /*  660250 */   // Label 10555: @660250
     /*  660250 */   GIM_Try, /*On fail goto*//*Label 10556*/ GIMT_Encode4(660325), // Rule ID 7653 //
     /*  660255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  660266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  660269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  660272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  660275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660301 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660323 */     GIR_RootConstrainSelectedInstOperands,
     /*  660324 */     // GIR_Coverage, 7653,
     /*  660324 */     GIR_EraseRootFromParent_Done,
     /*  660325 */   // Label 10556: @660325
     /*  660325 */   GIM_Try, /*On fail goto*//*Label 10557*/ GIMT_Encode4(660400), // Rule ID 7656 //
     /*  660330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  660341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  660344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  660347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  660350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660376 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  660379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660398 */     GIR_RootConstrainSelectedInstOperands,
     /*  660399 */     // GIR_Coverage, 7656,
     /*  660399 */     GIR_EraseRootFromParent_Done,
     /*  660400 */   // Label 10557: @660400
     /*  660400 */   GIM_Try, /*On fail goto*//*Label 10558*/ GIMT_Encode4(660475), // Rule ID 7657 //
     /*  660405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  660416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  660419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  660422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  660425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660451 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  660454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660473 */     GIR_RootConstrainSelectedInstOperands,
     /*  660474 */     // GIR_Coverage, 7657,
     /*  660474 */     GIR_EraseRootFromParent_Done,
     /*  660475 */   // Label 10558: @660475
     /*  660475 */   GIM_Try, /*On fail goto*//*Label 10559*/ GIMT_Encode4(660550), // Rule ID 7660 //
     /*  660480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  660491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  660494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  660497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  660500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660526 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  660529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660548 */     GIR_RootConstrainSelectedInstOperands,
     /*  660549 */     // GIR_Coverage, 7660,
     /*  660549 */     GIR_EraseRootFromParent_Done,
     /*  660550 */   // Label 10559: @660550
     /*  660550 */   GIM_Try, /*On fail goto*//*Label 10560*/ GIMT_Encode4(660625), // Rule ID 7661 //
     /*  660555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  660566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  660569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  660572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  660575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660601 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  660604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660623 */     GIR_RootConstrainSelectedInstOperands,
     /*  660624 */     // GIR_Coverage, 7661,
     /*  660624 */     GIR_EraseRootFromParent_Done,
     /*  660625 */   // Label 10560: @660625
     /*  660625 */   GIM_Try, /*On fail goto*//*Label 10561*/ GIMT_Encode4(660700), // Rule ID 7664 //
     /*  660630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  660641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  660644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  660647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  660650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660676 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660698 */     GIR_RootConstrainSelectedInstOperands,
     /*  660699 */     // GIR_Coverage, 7664,
     /*  660699 */     GIR_EraseRootFromParent_Done,
     /*  660700 */   // Label 10561: @660700
     /*  660700 */   GIM_Try, /*On fail goto*//*Label 10562*/ GIMT_Encode4(660775), // Rule ID 7665 //
     /*  660705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  660716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  660719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  660722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  660725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660751 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660773 */     GIR_RootConstrainSelectedInstOperands,
     /*  660774 */     // GIR_Coverage, 7665,
     /*  660774 */     GIR_EraseRootFromParent_Done,
     /*  660775 */   // Label 10562: @660775
     /*  660775 */   GIM_Try, /*On fail goto*//*Label 10563*/ GIMT_Encode4(660850), // Rule ID 7668 //
     /*  660780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  660791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  660794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  660797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  660800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660826 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660848 */     GIR_RootConstrainSelectedInstOperands,
     /*  660849 */     // GIR_Coverage, 7668,
     /*  660849 */     GIR_EraseRootFromParent_Done,
     /*  660850 */   // Label 10563: @660850
     /*  660850 */   GIM_Try, /*On fail goto*//*Label 10564*/ GIMT_Encode4(660925), // Rule ID 7669 //
     /*  660855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  660866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  660869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  660872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  660875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660901 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660923 */     GIR_RootConstrainSelectedInstOperands,
     /*  660924 */     // GIR_Coverage, 7669,
     /*  660924 */     GIR_EraseRootFromParent_Done,
     /*  660925 */   // Label 10564: @660925
     /*  660925 */   GIM_Try, /*On fail goto*//*Label 10565*/ GIMT_Encode4(661000), // Rule ID 7672 //
     /*  660930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  660941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  660944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  660947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  660950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660998 */     GIR_RootConstrainSelectedInstOperands,
     /*  660999 */     // GIR_Coverage, 7672,
     /*  660999 */     GIR_EraseRootFromParent_Done,
     /*  661000 */   // Label 10565: @661000
     /*  661000 */   GIM_Try, /*On fail goto*//*Label 10566*/ GIMT_Encode4(661075), // Rule ID 7673 //
     /*  661005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  661016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  661019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  661022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  661025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661051 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  661051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  661054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661073 */     GIR_RootConstrainSelectedInstOperands,
     /*  661074 */     // GIR_Coverage, 7673,
     /*  661074 */     GIR_EraseRootFromParent_Done,
     /*  661075 */   // Label 10566: @661075
     /*  661075 */   GIM_Try, /*On fail goto*//*Label 10567*/ GIMT_Encode4(661150), // Rule ID 7676 //
     /*  661080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  661091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  661094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  661097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  661100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661126 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  661126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  661129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661148 */     GIR_RootConstrainSelectedInstOperands,
     /*  661149 */     // GIR_Coverage, 7676,
     /*  661149 */     GIR_EraseRootFromParent_Done,
     /*  661150 */   // Label 10567: @661150
     /*  661150 */   GIM_Try, /*On fail goto*//*Label 10568*/ GIMT_Encode4(661225), // Rule ID 7677 //
     /*  661155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  661166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  661169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  661172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  661175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661201 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  661201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  661204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661223 */     GIR_RootConstrainSelectedInstOperands,
     /*  661224 */     // GIR_Coverage, 7677,
     /*  661224 */     GIR_EraseRootFromParent_Done,
     /*  661225 */   // Label 10568: @661225
     /*  661225 */   GIM_Try, /*On fail goto*//*Label 10569*/ GIMT_Encode4(661300), // Rule ID 7680 //
     /*  661230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  661241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  661244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  661247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  661250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  661279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661298 */     GIR_RootConstrainSelectedInstOperands,
     /*  661299 */     // GIR_Coverage, 7680,
     /*  661299 */     GIR_EraseRootFromParent_Done,
     /*  661300 */   // Label 10569: @661300
     /*  661300 */   GIM_Try, /*On fail goto*//*Label 10570*/ GIMT_Encode4(661375), // Rule ID 7681 //
     /*  661305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  661316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  661319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  661322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  661325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661351 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  661354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661373 */     GIR_RootConstrainSelectedInstOperands,
     /*  661374 */     // GIR_Coverage, 7681,
     /*  661374 */     GIR_EraseRootFromParent_Done,
     /*  661375 */   // Label 10570: @661375
     /*  661375 */   GIM_Try, /*On fail goto*//*Label 10571*/ GIMT_Encode4(661450), // Rule ID 7684 //
     /*  661380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  661391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  661394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  661397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  661400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661426 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  661429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661448 */     GIR_RootConstrainSelectedInstOperands,
     /*  661449 */     // GIR_Coverage, 7684,
     /*  661449 */     GIR_EraseRootFromParent_Done,
     /*  661450 */   // Label 10571: @661450
     /*  661450 */   GIM_Try, /*On fail goto*//*Label 10572*/ GIMT_Encode4(661525), // Rule ID 7685 //
     /*  661455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  661466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  661469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  661472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  661475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661501 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  661504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661523 */     GIR_RootConstrainSelectedInstOperands,
     /*  661524 */     // GIR_Coverage, 7685,
     /*  661524 */     GIR_EraseRootFromParent_Done,
     /*  661525 */   // Label 10572: @661525
     /*  661525 */   GIM_Try, /*On fail goto*//*Label 10573*/ GIMT_Encode4(661600), // Rule ID 7688 //
     /*  661530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  661541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  661544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  661547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  661550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  661579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661598 */     GIR_RootConstrainSelectedInstOperands,
     /*  661599 */     // GIR_Coverage, 7688,
     /*  661599 */     GIR_EraseRootFromParent_Done,
     /*  661600 */   // Label 10573: @661600
     /*  661600 */   GIM_Try, /*On fail goto*//*Label 10574*/ GIMT_Encode4(661675), // Rule ID 7689 //
     /*  661605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  661616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  661619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  661622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  661625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661651 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  661654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661673 */     GIR_RootConstrainSelectedInstOperands,
     /*  661674 */     // GIR_Coverage, 7689,
     /*  661674 */     GIR_EraseRootFromParent_Done,
     /*  661675 */   // Label 10574: @661675
     /*  661675 */   GIM_Try, /*On fail goto*//*Label 10575*/ GIMT_Encode4(661750), // Rule ID 7692 //
     /*  661680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  661691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  661694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  661697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  661700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661726 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  661729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661748 */     GIR_RootConstrainSelectedInstOperands,
     /*  661749 */     // GIR_Coverage, 7692,
     /*  661749 */     GIR_EraseRootFromParent_Done,
     /*  661750 */   // Label 10575: @661750
     /*  661750 */   GIM_Try, /*On fail goto*//*Label 10576*/ GIMT_Encode4(661825), // Rule ID 7693 //
     /*  661755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  661766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  661769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  661772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  661775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661801 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  661804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661823 */     GIR_RootConstrainSelectedInstOperands,
     /*  661824 */     // GIR_Coverage, 7693,
     /*  661824 */     GIR_EraseRootFromParent_Done,
     /*  661825 */   // Label 10576: @661825
     /*  661825 */   GIM_Try, /*On fail goto*//*Label 10577*/ GIMT_Encode4(661900), // Rule ID 7696 //
     /*  661830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  661841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  661844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  661847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661876 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  661879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661898 */     GIR_RootConstrainSelectedInstOperands,
     /*  661899 */     // GIR_Coverage, 7696,
     /*  661899 */     GIR_EraseRootFromParent_Done,
     /*  661900 */   // Label 10577: @661900
     /*  661900 */   GIM_Try, /*On fail goto*//*Label 10578*/ GIMT_Encode4(661975), // Rule ID 7697 //
     /*  661905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  661916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  661919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  661922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661951 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  661954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661973 */     GIR_RootConstrainSelectedInstOperands,
     /*  661974 */     // GIR_Coverage, 7697,
     /*  661974 */     GIR_EraseRootFromParent_Done,
     /*  661975 */   // Label 10578: @661975
     /*  661975 */   GIM_Try, /*On fail goto*//*Label 10579*/ GIMT_Encode4(662050), // Rule ID 7700 //
     /*  661980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  661991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  661994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  661997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662026 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  662029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662048 */     GIR_RootConstrainSelectedInstOperands,
     /*  662049 */     // GIR_Coverage, 7700,
     /*  662049 */     GIR_EraseRootFromParent_Done,
     /*  662050 */   // Label 10579: @662050
     /*  662050 */   GIM_Try, /*On fail goto*//*Label 10580*/ GIMT_Encode4(662125), // Rule ID 7701 //
     /*  662055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  662066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  662069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  662072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662101 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  662104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662123 */     GIR_RootConstrainSelectedInstOperands,
     /*  662124 */     // GIR_Coverage, 7701,
     /*  662124 */     GIR_EraseRootFromParent_Done,
     /*  662125 */   // Label 10580: @662125
     /*  662125 */   GIM_Try, /*On fail goto*//*Label 10581*/ GIMT_Encode4(662200), // Rule ID 7704 //
     /*  662130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  662141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  662144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  662147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662176 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662198 */     GIR_RootConstrainSelectedInstOperands,
     /*  662199 */     // GIR_Coverage, 7704,
     /*  662199 */     GIR_EraseRootFromParent_Done,
     /*  662200 */   // Label 10581: @662200
     /*  662200 */   GIM_Try, /*On fail goto*//*Label 10582*/ GIMT_Encode4(662275), // Rule ID 7705 //
     /*  662205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  662216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  662219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  662222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662251 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662273 */     GIR_RootConstrainSelectedInstOperands,
     /*  662274 */     // GIR_Coverage, 7705,
     /*  662274 */     GIR_EraseRootFromParent_Done,
     /*  662275 */   // Label 10582: @662275
     /*  662275 */   GIM_Try, /*On fail goto*//*Label 10583*/ GIMT_Encode4(662350), // Rule ID 7708 //
     /*  662280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  662291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  662294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  662297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662326 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  662329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662348 */     GIR_RootConstrainSelectedInstOperands,
     /*  662349 */     // GIR_Coverage, 7708,
     /*  662349 */     GIR_EraseRootFromParent_Done,
     /*  662350 */   // Label 10583: @662350
     /*  662350 */   GIM_Try, /*On fail goto*//*Label 10584*/ GIMT_Encode4(662425), // Rule ID 7709 //
     /*  662355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  662366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  662369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  662372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662401 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  662404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662423 */     GIR_RootConstrainSelectedInstOperands,
     /*  662424 */     // GIR_Coverage, 7709,
     /*  662424 */     GIR_EraseRootFromParent_Done,
     /*  662425 */   // Label 10584: @662425
     /*  662425 */   GIM_Try, /*On fail goto*//*Label 10585*/ GIMT_Encode4(662500), // Rule ID 7712 //
     /*  662430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  662441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  662444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  662447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662476 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662498 */     GIR_RootConstrainSelectedInstOperands,
     /*  662499 */     // GIR_Coverage, 7712,
     /*  662499 */     GIR_EraseRootFromParent_Done,
     /*  662500 */   // Label 10585: @662500
     /*  662500 */   GIM_Try, /*On fail goto*//*Label 10586*/ GIMT_Encode4(662575), // Rule ID 7713 //
     /*  662505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  662516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  662519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  662522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662551 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662573 */     GIR_RootConstrainSelectedInstOperands,
     /*  662574 */     // GIR_Coverage, 7713,
     /*  662574 */     GIR_EraseRootFromParent_Done,
     /*  662575 */   // Label 10586: @662575
     /*  662575 */   GIM_Try, /*On fail goto*//*Label 10587*/ GIMT_Encode4(662650), // Rule ID 7716 //
     /*  662580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  662591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  662594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  662597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662626 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662648 */     GIR_RootConstrainSelectedInstOperands,
     /*  662649 */     // GIR_Coverage, 7716,
     /*  662649 */     GIR_EraseRootFromParent_Done,
     /*  662650 */   // Label 10587: @662650
     /*  662650 */   GIM_Try, /*On fail goto*//*Label 10588*/ GIMT_Encode4(662725), // Rule ID 7717 //
     /*  662655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  662666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  662669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  662672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662701 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662723 */     GIR_RootConstrainSelectedInstOperands,
     /*  662724 */     // GIR_Coverage, 7717,
     /*  662724 */     GIR_EraseRootFromParent_Done,
     /*  662725 */   // Label 10588: @662725
     /*  662725 */   GIM_Try, /*On fail goto*//*Label 10589*/ GIMT_Encode4(662800), // Rule ID 7720 //
     /*  662730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  662741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  662744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  662747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662776 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  662779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662798 */     GIR_RootConstrainSelectedInstOperands,
     /*  662799 */     // GIR_Coverage, 7720,
     /*  662799 */     GIR_EraseRootFromParent_Done,
     /*  662800 */   // Label 10589: @662800
     /*  662800 */   GIM_Try, /*On fail goto*//*Label 10590*/ GIMT_Encode4(662875), // Rule ID 7721 //
     /*  662805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  662816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  662819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  662822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662851 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  662854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662873 */     GIR_RootConstrainSelectedInstOperands,
     /*  662874 */     // GIR_Coverage, 7721,
     /*  662874 */     GIR_EraseRootFromParent_Done,
     /*  662875 */   // Label 10590: @662875
     /*  662875 */   GIM_Try, /*On fail goto*//*Label 10591*/ GIMT_Encode4(662950), // Rule ID 7724 //
     /*  662880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  662891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  662894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  662897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662926 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662948 */     GIR_RootConstrainSelectedInstOperands,
     /*  662949 */     // GIR_Coverage, 7724,
     /*  662949 */     GIR_EraseRootFromParent_Done,
     /*  662950 */   // Label 10591: @662950
     /*  662950 */   GIM_Try, /*On fail goto*//*Label 10592*/ GIMT_Encode4(663025), // Rule ID 7725 //
     /*  662955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  662966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  662969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  662972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663001 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  663001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  663004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663023 */     GIR_RootConstrainSelectedInstOperands,
     /*  663024 */     // GIR_Coverage, 7725,
     /*  663024 */     GIR_EraseRootFromParent_Done,
     /*  663025 */   // Label 10592: @663025
     /*  663025 */   GIM_Try, /*On fail goto*//*Label 10593*/ GIMT_Encode4(663100), // Rule ID 7728 //
     /*  663030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  663041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  663044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  663047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663076 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  663076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  663079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663098 */     GIR_RootConstrainSelectedInstOperands,
     /*  663099 */     // GIR_Coverage, 7728,
     /*  663099 */     GIR_EraseRootFromParent_Done,
     /*  663100 */   // Label 10593: @663100
     /*  663100 */   GIM_Try, /*On fail goto*//*Label 10594*/ GIMT_Encode4(663175), // Rule ID 7729 //
     /*  663105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  663116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  663119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  663122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663151 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  663151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  663154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663173 */     GIR_RootConstrainSelectedInstOperands,
     /*  663174 */     // GIR_Coverage, 7729,
     /*  663174 */     GIR_EraseRootFromParent_Done,
     /*  663175 */   // Label 10594: @663175
     /*  663175 */   GIM_Try, /*On fail goto*//*Label 10595*/ GIMT_Encode4(663250), // Rule ID 7732 //
     /*  663180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  663191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  663194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  663197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663226 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  663226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  663229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663248 */     GIR_RootConstrainSelectedInstOperands,
     /*  663249 */     // GIR_Coverage, 7732,
     /*  663249 */     GIR_EraseRootFromParent_Done,
     /*  663250 */   // Label 10595: @663250
     /*  663250 */   GIM_Try, /*On fail goto*//*Label 10596*/ GIMT_Encode4(663325), // Rule ID 7733 //
     /*  663255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  663266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  663269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  663272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663301 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  663301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  663304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663323 */     GIR_RootConstrainSelectedInstOperands,
     /*  663324 */     // GIR_Coverage, 7733,
     /*  663324 */     GIR_EraseRootFromParent_Done,
     /*  663325 */   // Label 10596: @663325
     /*  663325 */   GIM_Try, /*On fail goto*//*Label 10597*/ GIMT_Encode4(663400), // Rule ID 7736 //
     /*  663330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  663341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  663344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  663347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663376 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  663376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  663379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663398 */     GIR_RootConstrainSelectedInstOperands,
     /*  663399 */     // GIR_Coverage, 7736,
     /*  663399 */     GIR_EraseRootFromParent_Done,
     /*  663400 */   // Label 10597: @663400
     /*  663400 */   GIM_Try, /*On fail goto*//*Label 10598*/ GIMT_Encode4(663475), // Rule ID 7737 //
     /*  663405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  663416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  663419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  663422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663451 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  663451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  663454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663473 */     GIR_RootConstrainSelectedInstOperands,
     /*  663474 */     // GIR_Coverage, 7737,
     /*  663474 */     GIR_EraseRootFromParent_Done,
     /*  663475 */   // Label 10598: @663475
     /*  663475 */   GIM_Try, /*On fail goto*//*Label 10599*/ GIMT_Encode4(663550), // Rule ID 7740 //
     /*  663480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  663491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  663494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  663497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663526 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  663529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663548 */     GIR_RootConstrainSelectedInstOperands,
     /*  663549 */     // GIR_Coverage, 7740,
     /*  663549 */     GIR_EraseRootFromParent_Done,
     /*  663550 */   // Label 10599: @663550
     /*  663550 */   GIM_Try, /*On fail goto*//*Label 10600*/ GIMT_Encode4(663625), // Rule ID 7741 //
     /*  663555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  663566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  663569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  663572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663601 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  663604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663623 */     GIR_RootConstrainSelectedInstOperands,
     /*  663624 */     // GIR_Coverage, 7741,
     /*  663624 */     GIR_EraseRootFromParent_Done,
     /*  663625 */   // Label 10600: @663625
     /*  663625 */   GIM_Try, /*On fail goto*//*Label 10601*/ GIMT_Encode4(663700), // Rule ID 7744 //
     /*  663630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  663641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  663644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  663647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663676 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  663679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663698 */     GIR_RootConstrainSelectedInstOperands,
     /*  663699 */     // GIR_Coverage, 7744,
     /*  663699 */     GIR_EraseRootFromParent_Done,
     /*  663700 */   // Label 10601: @663700
     /*  663700 */   GIM_Try, /*On fail goto*//*Label 10602*/ GIMT_Encode4(663775), // Rule ID 7745 //
     /*  663705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  663716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  663719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  663722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663751 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  663754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663773 */     GIR_RootConstrainSelectedInstOperands,
     /*  663774 */     // GIR_Coverage, 7745,
     /*  663774 */     GIR_EraseRootFromParent_Done,
     /*  663775 */   // Label 10602: @663775
     /*  663775 */   GIM_Try, /*On fail goto*//*Label 10603*/ GIMT_Encode4(663850), // Rule ID 7748 //
     /*  663780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  663791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  663794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  663797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663826 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  663829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663848 */     GIR_RootConstrainSelectedInstOperands,
     /*  663849 */     // GIR_Coverage, 7748,
     /*  663849 */     GIR_EraseRootFromParent_Done,
     /*  663850 */   // Label 10603: @663850
     /*  663850 */   GIM_Try, /*On fail goto*//*Label 10604*/ GIMT_Encode4(663925), // Rule ID 7749 //
     /*  663855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  663866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  663869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  663872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  663904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663923 */     GIR_RootConstrainSelectedInstOperands,
     /*  663924 */     // GIR_Coverage, 7749,
     /*  663924 */     GIR_EraseRootFromParent_Done,
     /*  663925 */   // Label 10604: @663925
     /*  663925 */   GIM_Try, /*On fail goto*//*Label 10605*/ GIMT_Encode4(664000), // Rule ID 7752 //
     /*  663930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  663941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  663944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  663947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  663979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663998 */     GIR_RootConstrainSelectedInstOperands,
     /*  663999 */     // GIR_Coverage, 7752,
     /*  663999 */     GIR_EraseRootFromParent_Done,
     /*  664000 */   // Label 10605: @664000
     /*  664000 */   GIM_Try, /*On fail goto*//*Label 10606*/ GIMT_Encode4(664075), // Rule ID 7753 //
     /*  664005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  664008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  664016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  664019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  664022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  664025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  664044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664051 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  664054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664073 */     GIR_RootConstrainSelectedInstOperands,
     /*  664074 */     // GIR_Coverage, 7753,
     /*  664074 */     GIR_EraseRootFromParent_Done,
     /*  664075 */   // Label 10606: @664075
     /*  664075 */   GIM_Try, /*On fail goto*//*Label 10607*/ GIMT_Encode4(664150), // Rule ID 10268 //
     /*  664080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  664091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  664094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  664097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  664100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664126 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  664126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  664129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664148 */     GIR_RootConstrainSelectedInstOperands,
     /*  664149 */     // GIR_Coverage, 10268,
     /*  664149 */     GIR_EraseRootFromParent_Done,
     /*  664150 */   // Label 10607: @664150
     /*  664150 */   GIM_Try, /*On fail goto*//*Label 10608*/ GIMT_Encode4(664225), // Rule ID 10269 //
     /*  664155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  664166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  664169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  664172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  664175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664201 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  664204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664223 */     GIR_RootConstrainSelectedInstOperands,
     /*  664224 */     // GIR_Coverage, 10269,
     /*  664224 */     GIR_EraseRootFromParent_Done,
     /*  664225 */   // Label 10608: @664225
     /*  664225 */   GIM_Try, /*On fail goto*//*Label 10609*/ GIMT_Encode4(664300), // Rule ID 10272 //
     /*  664230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  664241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  664244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  664247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  664250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664276 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  664276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  664279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664298 */     GIR_RootConstrainSelectedInstOperands,
     /*  664299 */     // GIR_Coverage, 10272,
     /*  664299 */     GIR_EraseRootFromParent_Done,
     /*  664300 */   // Label 10609: @664300
     /*  664300 */   GIM_Try, /*On fail goto*//*Label 10610*/ GIMT_Encode4(664375), // Rule ID 10273 //
     /*  664305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  664316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  664319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  664322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  664325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664351 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  664354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664373 */     GIR_RootConstrainSelectedInstOperands,
     /*  664374 */     // GIR_Coverage, 10273,
     /*  664374 */     GIR_EraseRootFromParent_Done,
     /*  664375 */   // Label 10610: @664375
     /*  664375 */   GIM_Try, /*On fail goto*//*Label 10611*/ GIMT_Encode4(664450), // Rule ID 10276 //
     /*  664380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  664391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  664394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  664397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  664400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664426 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  664426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664448 */     GIR_RootConstrainSelectedInstOperands,
     /*  664449 */     // GIR_Coverage, 10276,
     /*  664449 */     GIR_EraseRootFromParent_Done,
     /*  664450 */   // Label 10611: @664450
     /*  664450 */   GIM_Try, /*On fail goto*//*Label 10612*/ GIMT_Encode4(664525), // Rule ID 10277 //
     /*  664455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  664466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  664469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  664472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  664475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664501 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664523 */     GIR_RootConstrainSelectedInstOperands,
     /*  664524 */     // GIR_Coverage, 10277,
     /*  664524 */     GIR_EraseRootFromParent_Done,
     /*  664525 */   // Label 10612: @664525
     /*  664525 */   GIM_Try, /*On fail goto*//*Label 10613*/ GIMT_Encode4(664600), // Rule ID 10280 //
     /*  664530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  664541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  664544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  664547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  664550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664576 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  664579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664598 */     GIR_RootConstrainSelectedInstOperands,
     /*  664599 */     // GIR_Coverage, 10280,
     /*  664599 */     GIR_EraseRootFromParent_Done,
     /*  664600 */   // Label 10613: @664600
     /*  664600 */   GIM_Try, /*On fail goto*//*Label 10614*/ GIMT_Encode4(664675), // Rule ID 10281 //
     /*  664605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  664616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  664619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  664622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  664625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664651 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  664654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664673 */     GIR_RootConstrainSelectedInstOperands,
     /*  664674 */     // GIR_Coverage, 10281,
     /*  664674 */     GIR_EraseRootFromParent_Done,
     /*  664675 */   // Label 10614: @664675
     /*  664675 */   GIM_Try, /*On fail goto*//*Label 10615*/ GIMT_Encode4(664750), // Rule ID 10284 //
     /*  664680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  664691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  664694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  664697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  664700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664748 */     GIR_RootConstrainSelectedInstOperands,
     /*  664749 */     // GIR_Coverage, 10284,
     /*  664749 */     GIR_EraseRootFromParent_Done,
     /*  664750 */   // Label 10615: @664750
     /*  664750 */   GIM_Try, /*On fail goto*//*Label 10616*/ GIMT_Encode4(664825), // Rule ID 10285 //
     /*  664755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  664766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  664769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  664772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  664775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664801 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664823 */     GIR_RootConstrainSelectedInstOperands,
     /*  664824 */     // GIR_Coverage, 10285,
     /*  664824 */     GIR_EraseRootFromParent_Done,
     /*  664825 */   // Label 10616: @664825
     /*  664825 */   GIM_Try, /*On fail goto*//*Label 10617*/ GIMT_Encode4(664900), // Rule ID 10288 //
     /*  664830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  664841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  664844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  664847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  664850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664876 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664898 */     GIR_RootConstrainSelectedInstOperands,
     /*  664899 */     // GIR_Coverage, 10288,
     /*  664899 */     GIR_EraseRootFromParent_Done,
     /*  664900 */   // Label 10617: @664900
     /*  664900 */   GIM_Try, /*On fail goto*//*Label 10618*/ GIMT_Encode4(664975), // Rule ID 10289 //
     /*  664905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  664916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  664919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  664922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  664925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664951 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664973 */     GIR_RootConstrainSelectedInstOperands,
     /*  664974 */     // GIR_Coverage, 10289,
     /*  664974 */     GIR_EraseRootFromParent_Done,
     /*  664975 */   // Label 10618: @664975
     /*  664975 */   GIM_Try, /*On fail goto*//*Label 10619*/ GIMT_Encode4(665050), // Rule ID 10292 //
     /*  664980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  664991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  664994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  664997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  665000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665026 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665048 */     GIR_RootConstrainSelectedInstOperands,
     /*  665049 */     // GIR_Coverage, 10292,
     /*  665049 */     GIR_EraseRootFromParent_Done,
     /*  665050 */   // Label 10619: @665050
     /*  665050 */   GIM_Try, /*On fail goto*//*Label 10620*/ GIMT_Encode4(665125), // Rule ID 10293 //
     /*  665055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  665066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  665069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  665072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  665075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665101 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665123 */     GIR_RootConstrainSelectedInstOperands,
     /*  665124 */     // GIR_Coverage, 10293,
     /*  665124 */     GIR_EraseRootFromParent_Done,
     /*  665125 */   // Label 10620: @665125
     /*  665125 */   GIM_Try, /*On fail goto*//*Label 10621*/ GIMT_Encode4(665200), // Rule ID 10296 //
     /*  665130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  665141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  665144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  665147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  665150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  665176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665198 */     GIR_RootConstrainSelectedInstOperands,
     /*  665199 */     // GIR_Coverage, 10296,
     /*  665199 */     GIR_EraseRootFromParent_Done,
     /*  665200 */   // Label 10621: @665200
     /*  665200 */   GIM_Try, /*On fail goto*//*Label 10622*/ GIMT_Encode4(665275), // Rule ID 10297 //
     /*  665205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  665216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  665219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  665222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  665225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665251 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  665251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665273 */     GIR_RootConstrainSelectedInstOperands,
     /*  665274 */     // GIR_Coverage, 10297,
     /*  665274 */     GIR_EraseRootFromParent_Done,
     /*  665275 */   // Label 10622: @665275
     /*  665275 */   GIM_Try, /*On fail goto*//*Label 10623*/ GIMT_Encode4(665350), // Rule ID 10300 //
     /*  665280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  665291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  665294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  665297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  665300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  665326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665348 */     GIR_RootConstrainSelectedInstOperands,
     /*  665349 */     // GIR_Coverage, 10300,
     /*  665349 */     GIR_EraseRootFromParent_Done,
     /*  665350 */   // Label 10623: @665350
     /*  665350 */   GIM_Try, /*On fail goto*//*Label 10624*/ GIMT_Encode4(665425), // Rule ID 10301 //
     /*  665355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  665366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  665369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  665372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  665375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665401 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  665401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665423 */     GIR_RootConstrainSelectedInstOperands,
     /*  665424 */     // GIR_Coverage, 10301,
     /*  665424 */     GIR_EraseRootFromParent_Done,
     /*  665425 */   // Label 10624: @665425
     /*  665425 */   GIM_Try, /*On fail goto*//*Label 10625*/ GIMT_Encode4(665500), // Rule ID 10304 //
     /*  665430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  665433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  665441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  665444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  665447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  665450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  665476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665498 */     GIR_RootConstrainSelectedInstOperands,
     /*  665499 */     // GIR_Coverage, 10304,
     /*  665499 */     GIR_EraseRootFromParent_Done,
     /*  665500 */   // Label 10625: @665500
     /*  665500 */   GIM_Try, /*On fail goto*//*Label 10626*/ GIMT_Encode4(665575), // Rule ID 10305 //
     /*  665505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  665508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  665516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  665519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  665522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  665525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665551 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  665551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665573 */     GIR_RootConstrainSelectedInstOperands,
     /*  665574 */     // GIR_Coverage, 10305,
     /*  665574 */     GIR_EraseRootFromParent_Done,
     /*  665575 */   // Label 10626: @665575
     /*  665575 */   GIM_Try, /*On fail goto*//*Label 10627*/ GIMT_Encode4(665650), // Rule ID 10308 //
     /*  665580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  665591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  665594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  665597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  665600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665626 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665648 */     GIR_RootConstrainSelectedInstOperands,
     /*  665649 */     // GIR_Coverage, 10308,
     /*  665649 */     GIR_EraseRootFromParent_Done,
     /*  665650 */   // Label 10627: @665650
     /*  665650 */   GIM_Try, /*On fail goto*//*Label 10628*/ GIMT_Encode4(665725), // Rule ID 10309 //
     /*  665655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  665666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  665669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  665672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  665675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665701 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665723 */     GIR_RootConstrainSelectedInstOperands,
     /*  665724 */     // GIR_Coverage, 10309,
     /*  665724 */     GIR_EraseRootFromParent_Done,
     /*  665725 */   // Label 10628: @665725
     /*  665725 */   GIM_Try, /*On fail goto*//*Label 10629*/ GIMT_Encode4(665800), // Rule ID 10312 //
     /*  665730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  665741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  665744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  665747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  665750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665776 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665798 */     GIR_RootConstrainSelectedInstOperands,
     /*  665799 */     // GIR_Coverage, 10312,
     /*  665799 */     GIR_EraseRootFromParent_Done,
     /*  665800 */   // Label 10629: @665800
     /*  665800 */   GIM_Try, /*On fail goto*//*Label 10630*/ GIMT_Encode4(665875), // Rule ID 10313 //
     /*  665805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  665816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  665819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  665822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  665825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665851 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665873 */     GIR_RootConstrainSelectedInstOperands,
     /*  665874 */     // GIR_Coverage, 10313,
     /*  665874 */     GIR_EraseRootFromParent_Done,
     /*  665875 */   // Label 10630: @665875
     /*  665875 */   GIM_Try, /*On fail goto*//*Label 10631*/ GIMT_Encode4(665950), // Rule ID 10316 //
     /*  665880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  665891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  665894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  665897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  665900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665926 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665948 */     GIR_RootConstrainSelectedInstOperands,
     /*  665949 */     // GIR_Coverage, 10316,
     /*  665949 */     GIR_EraseRootFromParent_Done,
     /*  665950 */   // Label 10631: @665950
     /*  665950 */   GIM_Try, /*On fail goto*//*Label 10632*/ GIMT_Encode4(666025), // Rule ID 10317 //
     /*  665955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  665966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  665969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  665972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  665975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666001 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  666001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666023 */     GIR_RootConstrainSelectedInstOperands,
     /*  666024 */     // GIR_Coverage, 10317,
     /*  666024 */     GIR_EraseRootFromParent_Done,
     /*  666025 */   // Label 10632: @666025
     /*  666025 */   GIM_Try, /*On fail goto*//*Label 10633*/ GIMT_Encode4(666100), // Rule ID 10320 //
     /*  666030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  666041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  666044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  666047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  666050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666076 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666098 */     GIR_RootConstrainSelectedInstOperands,
     /*  666099 */     // GIR_Coverage, 10320,
     /*  666099 */     GIR_EraseRootFromParent_Done,
     /*  666100 */   // Label 10633: @666100
     /*  666100 */   GIM_Try, /*On fail goto*//*Label 10634*/ GIMT_Encode4(666175), // Rule ID 10321 //
     /*  666105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  666116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  666119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  666122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  666125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666151 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666173 */     GIR_RootConstrainSelectedInstOperands,
     /*  666174 */     // GIR_Coverage, 10321,
     /*  666174 */     GIR_EraseRootFromParent_Done,
     /*  666175 */   // Label 10634: @666175
     /*  666175 */   GIM_Try, /*On fail goto*//*Label 10635*/ GIMT_Encode4(666250), // Rule ID 10324 //
     /*  666180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  666191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  666194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  666197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  666200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666226 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666248 */     GIR_RootConstrainSelectedInstOperands,
     /*  666249 */     // GIR_Coverage, 10324,
     /*  666249 */     GIR_EraseRootFromParent_Done,
     /*  666250 */   // Label 10635: @666250
     /*  666250 */   GIM_Try, /*On fail goto*//*Label 10636*/ GIMT_Encode4(666325), // Rule ID 10325 //
     /*  666255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  666266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  666269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  666272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  666275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666301 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666323 */     GIR_RootConstrainSelectedInstOperands,
     /*  666324 */     // GIR_Coverage, 10325,
     /*  666324 */     GIR_EraseRootFromParent_Done,
     /*  666325 */   // Label 10636: @666325
     /*  666325 */   GIM_Try, /*On fail goto*//*Label 10637*/ GIMT_Encode4(666400), // Rule ID 10328 //
     /*  666330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  666341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  666344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  666347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  666350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666376 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666398 */     GIR_RootConstrainSelectedInstOperands,
     /*  666399 */     // GIR_Coverage, 10328,
     /*  666399 */     GIR_EraseRootFromParent_Done,
     /*  666400 */   // Label 10637: @666400
     /*  666400 */   GIM_Try, /*On fail goto*//*Label 10638*/ GIMT_Encode4(666475), // Rule ID 10329 //
     /*  666405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  666416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  666419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  666422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  666425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666451 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666473 */     GIR_RootConstrainSelectedInstOperands,
     /*  666474 */     // GIR_Coverage, 10329,
     /*  666474 */     GIR_EraseRootFromParent_Done,
     /*  666475 */   // Label 10638: @666475
     /*  666475 */   GIM_Try, /*On fail goto*//*Label 10639*/ GIMT_Encode4(666550), // Rule ID 10332 //
     /*  666480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  666491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  666494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  666497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  666500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666548 */     GIR_RootConstrainSelectedInstOperands,
     /*  666549 */     // GIR_Coverage, 10332,
     /*  666549 */     GIR_EraseRootFromParent_Done,
     /*  666550 */   // Label 10639: @666550
     /*  666550 */   GIM_Try, /*On fail goto*//*Label 10640*/ GIMT_Encode4(666625), // Rule ID 10333 //
     /*  666555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  666566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  666569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  666572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  666575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666623 */     GIR_RootConstrainSelectedInstOperands,
     /*  666624 */     // GIR_Coverage, 10333,
     /*  666624 */     GIR_EraseRootFromParent_Done,
     /*  666625 */   // Label 10640: @666625
     /*  666625 */   GIM_Try, /*On fail goto*//*Label 10641*/ GIMT_Encode4(666700), // Rule ID 10336 //
     /*  666630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  666641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  666644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  666647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  666650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666676 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666698 */     GIR_RootConstrainSelectedInstOperands,
     /*  666699 */     // GIR_Coverage, 10336,
     /*  666699 */     GIR_EraseRootFromParent_Done,
     /*  666700 */   // Label 10641: @666700
     /*  666700 */   GIM_Try, /*On fail goto*//*Label 10642*/ GIMT_Encode4(666775), // Rule ID 10337 //
     /*  666705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  666716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  666719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  666722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  666725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666751 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666773 */     GIR_RootConstrainSelectedInstOperands,
     /*  666774 */     // GIR_Coverage, 10337,
     /*  666774 */     GIR_EraseRootFromParent_Done,
     /*  666775 */   // Label 10642: @666775
     /*  666775 */   GIM_Try, /*On fail goto*//*Label 10643*/ GIMT_Encode4(666850), // Rule ID 10340 //
     /*  666780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  666791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  666794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  666797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  666800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666826 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666848 */     GIR_RootConstrainSelectedInstOperands,
     /*  666849 */     // GIR_Coverage, 10340,
     /*  666849 */     GIR_EraseRootFromParent_Done,
     /*  666850 */   // Label 10643: @666850
     /*  666850 */   GIM_Try, /*On fail goto*//*Label 10644*/ GIMT_Encode4(666925), // Rule ID 10341 //
     /*  666855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  666866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  666869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  666872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  666875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666901 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666923 */     GIR_RootConstrainSelectedInstOperands,
     /*  666924 */     // GIR_Coverage, 10341,
     /*  666924 */     GIR_EraseRootFromParent_Done,
     /*  666925 */   // Label 10644: @666925
     /*  666925 */   GIM_Try, /*On fail goto*//*Label 10645*/ GIMT_Encode4(667000), // Rule ID 10344 //
     /*  666930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  666933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  666941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  666944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  666947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  666950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  666976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666998 */     GIR_RootConstrainSelectedInstOperands,
     /*  666999 */     // GIR_Coverage, 10344,
     /*  666999 */     GIR_EraseRootFromParent_Done,
     /*  667000 */   // Label 10645: @667000
     /*  667000 */   GIM_Try, /*On fail goto*//*Label 10646*/ GIMT_Encode4(667075), // Rule ID 10345 //
     /*  667005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  667008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  667016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  667019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  667022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  667025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667051 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  667051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  667054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  667070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667073 */     GIR_RootConstrainSelectedInstOperands,
     /*  667074 */     // GIR_Coverage, 10345,
     /*  667074 */     GIR_EraseRootFromParent_Done,
     /*  667075 */   // Label 10646: @667075
     /*  667075 */   GIM_Try, /*On fail goto*//*Label 10647*/ GIMT_Encode4(667150), // Rule ID 10348 //
     /*  667080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  667083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  667091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  667094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  667097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  667100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667126 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  667126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  667129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  667145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667148 */     GIR_RootConstrainSelectedInstOperands,
     /*  667149 */     // GIR_Coverage, 10348,
     /*  667149 */     GIR_EraseRootFromParent_Done,
     /*  667150 */   // Label 10647: @667150
     /*  667150 */   GIM_Try, /*On fail goto*//*Label 10648*/ GIMT_Encode4(667225), // Rule ID 10349 //
     /*  667155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  667158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  667166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  667169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  667172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  667175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667201 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  667201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  667204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  667220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667223 */     GIR_RootConstrainSelectedInstOperands,
     /*  667224 */     // GIR_Coverage, 10349,
     /*  667224 */     GIR_EraseRootFromParent_Done,
     /*  667225 */   // Label 10648: @667225
     /*  667225 */   GIM_Try, /*On fail goto*//*Label 10649*/ GIMT_Encode4(667300), // Rule ID 10352 //
     /*  667230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  667233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  667241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  667244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  667247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  667250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667276 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  667276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  667279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  667295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667298 */     GIR_RootConstrainSelectedInstOperands,
     /*  667299 */     // GIR_Coverage, 10352,
     /*  667299 */     GIR_EraseRootFromParent_Done,
     /*  667300 */   // Label 10649: @667300
     /*  667300 */   GIM_Try, /*On fail goto*//*Label 10650*/ GIMT_Encode4(667375), // Rule ID 10353 //
     /*  667305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  667308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  667316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  667319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  667322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  667325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667351 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  667351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  667354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  667370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667373 */     GIR_RootConstrainSelectedInstOperands,
     /*  667374 */     // GIR_Coverage, 10353,
     /*  667374 */     GIR_EraseRootFromParent_Done,
     /*  667375 */   // Label 10650: @667375
     /*  667375 */   GIM_Try, /*On fail goto*//*Label 10651*/ GIMT_Encode4(667450), // Rule ID 10356 //
     /*  667380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  667391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  667394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  667397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667426 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  667429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667448 */     GIR_RootConstrainSelectedInstOperands,
     /*  667449 */     // GIR_Coverage, 10356,
     /*  667449 */     GIR_EraseRootFromParent_Done,
     /*  667450 */   // Label 10651: @667450
     /*  667450 */   GIM_Try, /*On fail goto*//*Label 10652*/ GIMT_Encode4(667525), // Rule ID 10357 //
     /*  667455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  667466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  667469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  667472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667501 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  667504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667523 */     GIR_RootConstrainSelectedInstOperands,
     /*  667524 */     // GIR_Coverage, 10357,
     /*  667524 */     GIR_EraseRootFromParent_Done,
     /*  667525 */   // Label 10652: @667525
     /*  667525 */   GIM_Try, /*On fail goto*//*Label 10653*/ GIMT_Encode4(667600), // Rule ID 10360 //
     /*  667530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  667541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  667544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  667547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667576 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667598 */     GIR_RootConstrainSelectedInstOperands,
     /*  667599 */     // GIR_Coverage, 10360,
     /*  667599 */     GIR_EraseRootFromParent_Done,
     /*  667600 */   // Label 10653: @667600
     /*  667600 */   GIM_Try, /*On fail goto*//*Label 10654*/ GIMT_Encode4(667675), // Rule ID 10361 //
     /*  667605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  667616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  667619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  667622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667651 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667673 */     GIR_RootConstrainSelectedInstOperands,
     /*  667674 */     // GIR_Coverage, 10361,
     /*  667674 */     GIR_EraseRootFromParent_Done,
     /*  667675 */   // Label 10654: @667675
     /*  667675 */   GIM_Try, /*On fail goto*//*Label 10655*/ GIMT_Encode4(667750), // Rule ID 10364 //
     /*  667680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  667691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  667694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  667697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667726 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667748 */     GIR_RootConstrainSelectedInstOperands,
     /*  667749 */     // GIR_Coverage, 10364,
     /*  667749 */     GIR_EraseRootFromParent_Done,
     /*  667750 */   // Label 10655: @667750
     /*  667750 */   GIM_Try, /*On fail goto*//*Label 10656*/ GIMT_Encode4(667825), // Rule ID 10365 //
     /*  667755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  667766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  667769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  667772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667801 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667823 */     GIR_RootConstrainSelectedInstOperands,
     /*  667824 */     // GIR_Coverage, 10365,
     /*  667824 */     GIR_EraseRootFromParent_Done,
     /*  667825 */   // Label 10656: @667825
     /*  667825 */   GIM_Try, /*On fail goto*//*Label 10657*/ GIMT_Encode4(667900), // Rule ID 10368 //
     /*  667830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  667841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  667844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  667847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667876 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667898 */     GIR_RootConstrainSelectedInstOperands,
     /*  667899 */     // GIR_Coverage, 10368,
     /*  667899 */     GIR_EraseRootFromParent_Done,
     /*  667900 */   // Label 10657: @667900
     /*  667900 */   GIM_Try, /*On fail goto*//*Label 10658*/ GIMT_Encode4(667975), // Rule ID 10369 //
     /*  667905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  667916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  667919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  667922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667951 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  667951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667973 */     GIR_RootConstrainSelectedInstOperands,
     /*  667974 */     // GIR_Coverage, 10369,
     /*  667974 */     GIR_EraseRootFromParent_Done,
     /*  667975 */   // Label 10658: @667975
     /*  667975 */   GIM_Try, /*On fail goto*//*Label 10659*/ GIMT_Encode4(668050), // Rule ID 10372 //
     /*  667980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  667991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  667994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  667997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668026 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  668029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668048 */     GIR_RootConstrainSelectedInstOperands,
     /*  668049 */     // GIR_Coverage, 10372,
     /*  668049 */     GIR_EraseRootFromParent_Done,
     /*  668050 */   // Label 10659: @668050
     /*  668050 */   GIM_Try, /*On fail goto*//*Label 10660*/ GIMT_Encode4(668125), // Rule ID 10373 //
     /*  668055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  668066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  668069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  668072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668101 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  668104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668123 */     GIR_RootConstrainSelectedInstOperands,
     /*  668124 */     // GIR_Coverage, 10373,
     /*  668124 */     GIR_EraseRootFromParent_Done,
     /*  668125 */   // Label 10660: @668125
     /*  668125 */   GIM_Try, /*On fail goto*//*Label 10661*/ GIMT_Encode4(668200), // Rule ID 10376 //
     /*  668130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  668141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  668144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  668147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  668179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668198 */     GIR_RootConstrainSelectedInstOperands,
     /*  668199 */     // GIR_Coverage, 10376,
     /*  668199 */     GIR_EraseRootFromParent_Done,
     /*  668200 */   // Label 10661: @668200
     /*  668200 */   GIM_Try, /*On fail goto*//*Label 10662*/ GIMT_Encode4(668275), // Rule ID 10377 //
     /*  668205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  668216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  668219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  668222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668251 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  668254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668273 */     GIR_RootConstrainSelectedInstOperands,
     /*  668274 */     // GIR_Coverage, 10377,
     /*  668274 */     GIR_EraseRootFromParent_Done,
     /*  668275 */   // Label 10662: @668275
     /*  668275 */   GIM_Try, /*On fail goto*//*Label 10663*/ GIMT_Encode4(668350), // Rule ID 10380 //
     /*  668280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  668291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  668294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  668297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668326 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668348 */     GIR_RootConstrainSelectedInstOperands,
     /*  668349 */     // GIR_Coverage, 10380,
     /*  668349 */     GIR_EraseRootFromParent_Done,
     /*  668350 */   // Label 10663: @668350
     /*  668350 */   GIM_Try, /*On fail goto*//*Label 10664*/ GIMT_Encode4(668425), // Rule ID 10381 //
     /*  668355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  668366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  668369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  668372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668401 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668423 */     GIR_RootConstrainSelectedInstOperands,
     /*  668424 */     // GIR_Coverage, 10381,
     /*  668424 */     GIR_EraseRootFromParent_Done,
     /*  668425 */   // Label 10664: @668425
     /*  668425 */   GIM_Try, /*On fail goto*//*Label 10665*/ GIMT_Encode4(668500), // Rule ID 10384 //
     /*  668430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  668441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  668444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  668447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668498 */     GIR_RootConstrainSelectedInstOperands,
     /*  668499 */     // GIR_Coverage, 10384,
     /*  668499 */     GIR_EraseRootFromParent_Done,
     /*  668500 */   // Label 10665: @668500
     /*  668500 */   GIM_Try, /*On fail goto*//*Label 10666*/ GIMT_Encode4(668575), // Rule ID 10385 //
     /*  668505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  668516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  668519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  668522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668551 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668573 */     GIR_RootConstrainSelectedInstOperands,
     /*  668574 */     // GIR_Coverage, 10385,
     /*  668574 */     GIR_EraseRootFromParent_Done,
     /*  668575 */   // Label 10666: @668575
     /*  668575 */   GIM_Try, /*On fail goto*//*Label 10667*/ GIMT_Encode4(668650), // Rule ID 10388 //
     /*  668580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  668591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  668594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  668597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668648 */     GIR_RootConstrainSelectedInstOperands,
     /*  668649 */     // GIR_Coverage, 10388,
     /*  668649 */     GIR_EraseRootFromParent_Done,
     /*  668650 */   // Label 10667: @668650
     /*  668650 */   GIM_Try, /*On fail goto*//*Label 10668*/ GIMT_Encode4(668725), // Rule ID 10389 //
     /*  668655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  668666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  668669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  668672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668701 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668723 */     GIR_RootConstrainSelectedInstOperands,
     /*  668724 */     // GIR_Coverage, 10389,
     /*  668724 */     GIR_EraseRootFromParent_Done,
     /*  668725 */   // Label 10668: @668725
     /*  668725 */   GIM_Try, /*On fail goto*//*Label 10669*/ GIMT_Encode4(668800), // Rule ID 10392 //
     /*  668730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  668733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  668741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  668744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  668747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668776 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  668776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668798 */     GIR_RootConstrainSelectedInstOperands,
     /*  668799 */     // GIR_Coverage, 10392,
     /*  668799 */     GIR_EraseRootFromParent_Done,
     /*  668800 */   // Label 10669: @668800
     /*  668800 */   GIM_Try, /*On fail goto*//*Label 10670*/ GIMT_Encode4(668875), // Rule ID 10393 //
     /*  668805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  668808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  668816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  668819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  668822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668851 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  668851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668873 */     GIR_RootConstrainSelectedInstOperands,
     /*  668874 */     // GIR_Coverage, 10393,
     /*  668874 */     GIR_EraseRootFromParent_Done,
     /*  668875 */   // Label 10670: @668875
     /*  668875 */   GIM_Try, /*On fail goto*//*Label 10671*/ GIMT_Encode4(668950), // Rule ID 10396 //
     /*  668880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  668891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  668894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  668897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668926 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668948 */     GIR_RootConstrainSelectedInstOperands,
     /*  668949 */     // GIR_Coverage, 10396,
     /*  668949 */     GIR_EraseRootFromParent_Done,
     /*  668950 */   // Label 10671: @668950
     /*  668950 */   GIM_Try, /*On fail goto*//*Label 10672*/ GIMT_Encode4(669025), // Rule ID 10397 //
     /*  668955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  668966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  668969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  668972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669001 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669023 */     GIR_RootConstrainSelectedInstOperands,
     /*  669024 */     // GIR_Coverage, 10397,
     /*  669024 */     GIR_EraseRootFromParent_Done,
     /*  669025 */   // Label 10672: @669025
     /*  669025 */   GIM_Try, /*On fail goto*//*Label 10673*/ GIMT_Encode4(669100), // Rule ID 10400 //
     /*  669030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  669041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  669044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  669047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669076 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  669076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669098 */     GIR_RootConstrainSelectedInstOperands,
     /*  669099 */     // GIR_Coverage, 10400,
     /*  669099 */     GIR_EraseRootFromParent_Done,
     /*  669100 */   // Label 10673: @669100
     /*  669100 */   GIM_Try, /*On fail goto*//*Label 10674*/ GIMT_Encode4(669175), // Rule ID 10401 //
     /*  669105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  669116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  669119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  669122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669151 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669173 */     GIR_RootConstrainSelectedInstOperands,
     /*  669174 */     // GIR_Coverage, 10401,
     /*  669174 */     GIR_EraseRootFromParent_Done,
     /*  669175 */   // Label 10674: @669175
     /*  669175 */   GIM_Try, /*On fail goto*//*Label 10675*/ GIMT_Encode4(669250), // Rule ID 10404 //
     /*  669180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  669191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  669194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  669197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669226 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  669226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669248 */     GIR_RootConstrainSelectedInstOperands,
     /*  669249 */     // GIR_Coverage, 10404,
     /*  669249 */     GIR_EraseRootFromParent_Done,
     /*  669250 */   // Label 10675: @669250
     /*  669250 */   GIM_Try, /*On fail goto*//*Label 10676*/ GIMT_Encode4(669325), // Rule ID 10405 //
     /*  669255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  669266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  669269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  669272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669301 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669323 */     GIR_RootConstrainSelectedInstOperands,
     /*  669324 */     // GIR_Coverage, 10405,
     /*  669324 */     GIR_EraseRootFromParent_Done,
     /*  669325 */   // Label 10676: @669325
     /*  669325 */   GIM_Try, /*On fail goto*//*Label 10677*/ GIMT_Encode4(669400), // Rule ID 10408 //
     /*  669330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  669341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  669344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  669347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669398 */     GIR_RootConstrainSelectedInstOperands,
     /*  669399 */     // GIR_Coverage, 10408,
     /*  669399 */     GIR_EraseRootFromParent_Done,
     /*  669400 */   // Label 10677: @669400
     /*  669400 */   GIM_Try, /*On fail goto*//*Label 10678*/ GIMT_Encode4(669475), // Rule ID 10409 //
     /*  669405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  669416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  669419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  669422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669451 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669473 */     GIR_RootConstrainSelectedInstOperands,
     /*  669474 */     // GIR_Coverage, 10409,
     /*  669474 */     GIR_EraseRootFromParent_Done,
     /*  669475 */   // Label 10678: @669475
     /*  669475 */   GIM_Try, /*On fail goto*//*Label 10679*/ GIMT_Encode4(669550), // Rule ID 10412 //
     /*  669480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  669491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  669494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  669497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669526 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669548 */     GIR_RootConstrainSelectedInstOperands,
     /*  669549 */     // GIR_Coverage, 10412,
     /*  669549 */     GIR_EraseRootFromParent_Done,
     /*  669550 */   // Label 10679: @669550
     /*  669550 */   GIM_Try, /*On fail goto*//*Label 10680*/ GIMT_Encode4(669625), // Rule ID 10413 //
     /*  669555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  669566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  669569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  669572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669601 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669623 */     GIR_RootConstrainSelectedInstOperands,
     /*  669624 */     // GIR_Coverage, 10413,
     /*  669624 */     GIR_EraseRootFromParent_Done,
     /*  669625 */   // Label 10680: @669625
     /*  669625 */   GIM_Try, /*On fail goto*//*Label 10681*/ GIMT_Encode4(669700), // Rule ID 10416 //
     /*  669630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  669641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  669644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  669647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669676 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669698 */     GIR_RootConstrainSelectedInstOperands,
     /*  669699 */     // GIR_Coverage, 10416,
     /*  669699 */     GIR_EraseRootFromParent_Done,
     /*  669700 */   // Label 10681: @669700
     /*  669700 */   GIM_Try, /*On fail goto*//*Label 10682*/ GIMT_Encode4(669775), // Rule ID 10417 //
     /*  669705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  669716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  669719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  669722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669751 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669773 */     GIR_RootConstrainSelectedInstOperands,
     /*  669774 */     // GIR_Coverage, 10417,
     /*  669774 */     GIR_EraseRootFromParent_Done,
     /*  669775 */   // Label 10682: @669775
     /*  669775 */   GIM_Try, /*On fail goto*//*Label 10683*/ GIMT_Encode4(669850), // Rule ID 10420 //
     /*  669780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  669791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  669794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  669797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669826 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669848 */     GIR_RootConstrainSelectedInstOperands,
     /*  669849 */     // GIR_Coverage, 10420,
     /*  669849 */     GIR_EraseRootFromParent_Done,
     /*  669850 */   // Label 10683: @669850
     /*  669850 */   GIM_Try, /*On fail goto*//*Label 10684*/ GIMT_Encode4(669925), // Rule ID 10421 //
     /*  669855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  669866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  669869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  669872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669923 */     GIR_RootConstrainSelectedInstOperands,
     /*  669924 */     // GIR_Coverage, 10421,
     /*  669924 */     GIR_EraseRootFromParent_Done,
     /*  669925 */   // Label 10684: @669925
     /*  669925 */   GIM_Try, /*On fail goto*//*Label 10685*/ GIMT_Encode4(670000), // Rule ID 10424 //
     /*  669930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  669941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  669944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  669947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669998 */     GIR_RootConstrainSelectedInstOperands,
     /*  669999 */     // GIR_Coverage, 10424,
     /*  669999 */     GIR_EraseRootFromParent_Done,
     /*  670000 */   // Label 10685: @670000
     /*  670000 */   GIM_Try, /*On fail goto*//*Label 10686*/ GIMT_Encode4(670075), // Rule ID 10425 //
     /*  670005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  670016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  670019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  670022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670051 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  670051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  670054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670073 */     GIR_RootConstrainSelectedInstOperands,
     /*  670074 */     // GIR_Coverage, 10425,
     /*  670074 */     GIR_EraseRootFromParent_Done,
     /*  670075 */   // Label 10686: @670075
     /*  670075 */   GIM_Try, /*On fail goto*//*Label 10687*/ GIMT_Encode4(670150), // Rule ID 10428 //
     /*  670080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  670091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  670094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  670097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670126 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  670126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  670129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670148 */     GIR_RootConstrainSelectedInstOperands,
     /*  670149 */     // GIR_Coverage, 10428,
     /*  670149 */     GIR_EraseRootFromParent_Done,
     /*  670150 */   // Label 10687: @670150
     /*  670150 */   GIM_Try, /*On fail goto*//*Label 10688*/ GIMT_Encode4(670225), // Rule ID 10429 //
     /*  670155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  670166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  670169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  670172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670201 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  670201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  670204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670223 */     GIR_RootConstrainSelectedInstOperands,
     /*  670224 */     // GIR_Coverage, 10429,
     /*  670224 */     GIR_EraseRootFromParent_Done,
     /*  670225 */   // Label 10688: @670225
     /*  670225 */   GIM_Try, /*On fail goto*//*Label 10689*/ GIMT_Encode4(670300), // Rule ID 10432 //
     /*  670230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  670241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  670244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  670247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  670279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670298 */     GIR_RootConstrainSelectedInstOperands,
     /*  670299 */     // GIR_Coverage, 10432,
     /*  670299 */     GIR_EraseRootFromParent_Done,
     /*  670300 */   // Label 10689: @670300
     /*  670300 */   GIM_Try, /*On fail goto*//*Label 10690*/ GIMT_Encode4(670375), // Rule ID 10433 //
     /*  670305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  670316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  670319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  670322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670351 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  670354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670373 */     GIR_RootConstrainSelectedInstOperands,
     /*  670374 */     // GIR_Coverage, 10433,
     /*  670374 */     GIR_EraseRootFromParent_Done,
     /*  670375 */   // Label 10690: @670375
     /*  670375 */   GIM_Try, /*On fail goto*//*Label 10691*/ GIMT_Encode4(670450), // Rule ID 10436 //
     /*  670380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  670391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  670394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  670397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670426 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  670429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670448 */     GIR_RootConstrainSelectedInstOperands,
     /*  670449 */     // GIR_Coverage, 10436,
     /*  670449 */     GIR_EraseRootFromParent_Done,
     /*  670450 */   // Label 10691: @670450
     /*  670450 */   GIM_Try, /*On fail goto*//*Label 10692*/ GIMT_Encode4(670525), // Rule ID 10437 //
     /*  670455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  670466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  670469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  670472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670501 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  670504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670523 */     GIR_RootConstrainSelectedInstOperands,
     /*  670524 */     // GIR_Coverage, 10437,
     /*  670524 */     GIR_EraseRootFromParent_Done,
     /*  670525 */   // Label 10692: @670525
     /*  670525 */   GIM_Try, /*On fail goto*//*Label 10693*/ GIMT_Encode4(670600), // Rule ID 10440 //
     /*  670530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  670541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  670544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  670547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  670579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670598 */     GIR_RootConstrainSelectedInstOperands,
     /*  670599 */     // GIR_Coverage, 10440,
     /*  670599 */     GIR_EraseRootFromParent_Done,
     /*  670600 */   // Label 10693: @670600
     /*  670600 */   GIM_Try, /*On fail goto*//*Label 10694*/ GIMT_Encode4(670675), // Rule ID 10441 //
     /*  670605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  670616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  670619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  670622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670651 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  670654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670673 */     GIR_RootConstrainSelectedInstOperands,
     /*  670674 */     // GIR_Coverage, 10441,
     /*  670674 */     GIR_EraseRootFromParent_Done,
     /*  670675 */   // Label 10694: @670675
     /*  670675 */   GIM_Try, /*On fail goto*//*Label 10695*/ GIMT_Encode4(670750), // Rule ID 10444 //
     /*  670680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  670691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  670694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  670697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  670700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  670729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670748 */     GIR_RootConstrainSelectedInstOperands,
     /*  670749 */     // GIR_Coverage, 10444,
     /*  670749 */     GIR_EraseRootFromParent_Done,
     /*  670750 */   // Label 10695: @670750
     /*  670750 */   GIM_Try, /*On fail goto*//*Label 10696*/ GIMT_Encode4(670825), // Rule ID 10445 //
     /*  670755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  670766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  670769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  670772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  670775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670801 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  670804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670823 */     GIR_RootConstrainSelectedInstOperands,
     /*  670824 */     // GIR_Coverage, 10445,
     /*  670824 */     GIR_EraseRootFromParent_Done,
     /*  670825 */   // Label 10696: @670825
     /*  670825 */   GIM_Try, /*On fail goto*//*Label 10697*/ GIMT_Encode4(670900), // Rule ID 10448 //
     /*  670830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  670841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  670844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  670847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  670850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670876 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670898 */     GIR_RootConstrainSelectedInstOperands,
     /*  670899 */     // GIR_Coverage, 10448,
     /*  670899 */     GIR_EraseRootFromParent_Done,
     /*  670900 */   // Label 10697: @670900
     /*  670900 */   GIM_Try, /*On fail goto*//*Label 10698*/ GIMT_Encode4(670975), // Rule ID 10449 //
     /*  670905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  670916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  670919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  670922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  670925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670951 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670973 */     GIR_RootConstrainSelectedInstOperands,
     /*  670974 */     // GIR_Coverage, 10449,
     /*  670974 */     GIR_EraseRootFromParent_Done,
     /*  670975 */   // Label 10698: @670975
     /*  670975 */   GIM_Try, /*On fail goto*//*Label 10699*/ GIMT_Encode4(671050), // Rule ID 10452 //
     /*  670980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  670991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  670994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  670997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  671000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671026 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671048 */     GIR_RootConstrainSelectedInstOperands,
     /*  671049 */     // GIR_Coverage, 10452,
     /*  671049 */     GIR_EraseRootFromParent_Done,
     /*  671050 */   // Label 10699: @671050
     /*  671050 */   GIM_Try, /*On fail goto*//*Label 10700*/ GIMT_Encode4(671125), // Rule ID 10453 //
     /*  671055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  671066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  671069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  671072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  671075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671101 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671123 */     GIR_RootConstrainSelectedInstOperands,
     /*  671124 */     // GIR_Coverage, 10453,
     /*  671124 */     GIR_EraseRootFromParent_Done,
     /*  671125 */   // Label 10700: @671125
     /*  671125 */   GIM_Try, /*On fail goto*//*Label 10701*/ GIMT_Encode4(671200), // Rule ID 10456 //
     /*  671130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  671141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  671144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  671147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  671150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671176 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  671179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671198 */     GIR_RootConstrainSelectedInstOperands,
     /*  671199 */     // GIR_Coverage, 10456,
     /*  671199 */     GIR_EraseRootFromParent_Done,
     /*  671200 */   // Label 10701: @671200
     /*  671200 */   GIM_Try, /*On fail goto*//*Label 10702*/ GIMT_Encode4(671275), // Rule ID 10457 //
     /*  671205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  671216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  671219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  671222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  671225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671251 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  671254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671273 */     GIR_RootConstrainSelectedInstOperands,
     /*  671274 */     // GIR_Coverage, 10457,
     /*  671274 */     GIR_EraseRootFromParent_Done,
     /*  671275 */   // Label 10702: @671275
     /*  671275 */   GIM_Try, /*On fail goto*//*Label 10703*/ GIMT_Encode4(671350), // Rule ID 10460 //
     /*  671280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  671291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  671294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  671297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  671300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671326 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671348 */     GIR_RootConstrainSelectedInstOperands,
     /*  671349 */     // GIR_Coverage, 10460,
     /*  671349 */     GIR_EraseRootFromParent_Done,
     /*  671350 */   // Label 10703: @671350
     /*  671350 */   GIM_Try, /*On fail goto*//*Label 10704*/ GIMT_Encode4(671425), // Rule ID 10461 //
     /*  671355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  671366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  671369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  671372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  671375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671401 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671423 */     GIR_RootConstrainSelectedInstOperands,
     /*  671424 */     // GIR_Coverage, 10461,
     /*  671424 */     GIR_EraseRootFromParent_Done,
     /*  671425 */   // Label 10704: @671425
     /*  671425 */   GIM_Try, /*On fail goto*//*Label 10705*/ GIMT_Encode4(671500), // Rule ID 10464 //
     /*  671430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  671441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  671444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  671447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  671450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671476 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671498 */     GIR_RootConstrainSelectedInstOperands,
     /*  671499 */     // GIR_Coverage, 10464,
     /*  671499 */     GIR_EraseRootFromParent_Done,
     /*  671500 */   // Label 10705: @671500
     /*  671500 */   GIM_Try, /*On fail goto*//*Label 10706*/ GIMT_Encode4(671575), // Rule ID 10465 //
     /*  671505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  671516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  671519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  671522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  671525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671551 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671573 */     GIR_RootConstrainSelectedInstOperands,
     /*  671574 */     // GIR_Coverage, 10465,
     /*  671574 */     GIR_EraseRootFromParent_Done,
     /*  671575 */   // Label 10706: @671575
     /*  671575 */   GIM_Try, /*On fail goto*//*Label 10707*/ GIMT_Encode4(671650), // Rule ID 10468 //
     /*  671580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  671591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  671594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  671597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  671600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671626 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671648 */     GIR_RootConstrainSelectedInstOperands,
     /*  671649 */     // GIR_Coverage, 10468,
     /*  671649 */     GIR_EraseRootFromParent_Done,
     /*  671650 */   // Label 10707: @671650
     /*  671650 */   GIM_Try, /*On fail goto*//*Label 10708*/ GIMT_Encode4(671725), // Rule ID 10469 //
     /*  671655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  671666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  671669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  671672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  671675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671701 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671723 */     GIR_RootConstrainSelectedInstOperands,
     /*  671724 */     // GIR_Coverage, 10469,
     /*  671724 */     GIR_EraseRootFromParent_Done,
     /*  671725 */   // Label 10708: @671725
     /*  671725 */   GIM_Try, /*On fail goto*//*Label 10709*/ GIMT_Encode4(671800), // Rule ID 10472 //
     /*  671730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  671741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  671744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  671747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  671750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671776 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671798 */     GIR_RootConstrainSelectedInstOperands,
     /*  671799 */     // GIR_Coverage, 10472,
     /*  671799 */     GIR_EraseRootFromParent_Done,
     /*  671800 */   // Label 10709: @671800
     /*  671800 */   GIM_Try, /*On fail goto*//*Label 10710*/ GIMT_Encode4(671875), // Rule ID 10473 //
     /*  671805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  671816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  671819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  671822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  671825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671851 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671873 */     GIR_RootConstrainSelectedInstOperands,
     /*  671874 */     // GIR_Coverage, 10473,
     /*  671874 */     GIR_EraseRootFromParent_Done,
     /*  671875 */   // Label 10710: @671875
     /*  671875 */   GIM_Try, /*On fail goto*//*Label 10711*/ GIMT_Encode4(671950), // Rule ID 10476 //
     /*  671880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  671891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  671894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  671897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  671900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671926 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671948 */     GIR_RootConstrainSelectedInstOperands,
     /*  671949 */     // GIR_Coverage, 10476,
     /*  671949 */     GIR_EraseRootFromParent_Done,
     /*  671950 */   // Label 10711: @671950
     /*  671950 */   GIM_Try, /*On fail goto*//*Label 10712*/ GIMT_Encode4(672025), // Rule ID 10477 //
     /*  671955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  671966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  671969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  671972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  671975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672001 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  672001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  672004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672023 */     GIR_RootConstrainSelectedInstOperands,
     /*  672024 */     // GIR_Coverage, 10477,
     /*  672024 */     GIR_EraseRootFromParent_Done,
     /*  672025 */   // Label 10712: @672025
     /*  672025 */   GIM_Try, /*On fail goto*//*Label 10713*/ GIMT_Encode4(672100), // Rule ID 10480 //
     /*  672030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  672033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  672041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  672044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  672047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  672050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672076 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  672076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  672079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672098 */     GIR_RootConstrainSelectedInstOperands,
     /*  672099 */     // GIR_Coverage, 10480,
     /*  672099 */     GIR_EraseRootFromParent_Done,
     /*  672100 */   // Label 10713: @672100
     /*  672100 */   GIM_Try, /*On fail goto*//*Label 10714*/ GIMT_Encode4(672175), // Rule ID 10481 //
     /*  672105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  672108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  672116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  672119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  672122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  672125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672151 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  672151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  672154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672173 */     GIR_RootConstrainSelectedInstOperands,
     /*  672174 */     // GIR_Coverage, 10481,
     /*  672174 */     GIR_EraseRootFromParent_Done,
     /*  672175 */   // Label 10714: @672175
     /*  672175 */   GIM_Try, /*On fail goto*//*Label 10715*/ GIMT_Encode4(672250), // Rule ID 10484 //
     /*  672180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  672191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  672194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  672197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  672200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672226 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672248 */     GIR_RootConstrainSelectedInstOperands,
     /*  672249 */     // GIR_Coverage, 10484,
     /*  672249 */     GIR_EraseRootFromParent_Done,
     /*  672250 */   // Label 10715: @672250
     /*  672250 */   GIM_Try, /*On fail goto*//*Label 10716*/ GIMT_Encode4(672325), // Rule ID 10485 //
     /*  672255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  672266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  672269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  672272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  672275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672301 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672323 */     GIR_RootConstrainSelectedInstOperands,
     /*  672324 */     // GIR_Coverage, 10485,
     /*  672324 */     GIR_EraseRootFromParent_Done,
     /*  672325 */   // Label 10716: @672325
     /*  672325 */   GIM_Try, /*On fail goto*//*Label 10717*/ GIMT_Encode4(672400), // Rule ID 10488 //
     /*  672330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  672341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  672344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  672347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  672350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672376 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672398 */     GIR_RootConstrainSelectedInstOperands,
     /*  672399 */     // GIR_Coverage, 10488,
     /*  672399 */     GIR_EraseRootFromParent_Done,
     /*  672400 */   // Label 10717: @672400
     /*  672400 */   GIM_Try, /*On fail goto*//*Label 10718*/ GIMT_Encode4(672475), // Rule ID 10489 //
     /*  672405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  672416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  672419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  672422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  672425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672451 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672473 */     GIR_RootConstrainSelectedInstOperands,
     /*  672474 */     // GIR_Coverage, 10489,
     /*  672474 */     GIR_EraseRootFromParent_Done,
     /*  672475 */   // Label 10718: @672475
     /*  672475 */   GIM_Try, /*On fail goto*//*Label 10719*/ GIMT_Encode4(672550), // Rule ID 10492 //
     /*  672480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  672491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  672494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  672497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  672500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672526 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672548 */     GIR_RootConstrainSelectedInstOperands,
     /*  672549 */     // GIR_Coverage, 10492,
     /*  672549 */     GIR_EraseRootFromParent_Done,
     /*  672550 */   // Label 10719: @672550
     /*  672550 */   GIM_Try, /*On fail goto*//*Label 10720*/ GIMT_Encode4(672625), // Rule ID 10493 //
     /*  672555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  672566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  672569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  672572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  672575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672601 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672623 */     GIR_RootConstrainSelectedInstOperands,
     /*  672624 */     // GIR_Coverage, 10493,
     /*  672624 */     GIR_EraseRootFromParent_Done,
     /*  672625 */   // Label 10720: @672625
     /*  672625 */   GIM_Try, /*On fail goto*//*Label 10721*/ GIMT_Encode4(672700), // Rule ID 10496 //
     /*  672630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  672641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  672644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  672647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  672650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672698 */     GIR_RootConstrainSelectedInstOperands,
     /*  672699 */     // GIR_Coverage, 10496,
     /*  672699 */     GIR_EraseRootFromParent_Done,
     /*  672700 */   // Label 10721: @672700
     /*  672700 */   GIM_Try, /*On fail goto*//*Label 10722*/ GIMT_Encode4(672775), // Rule ID 10497 //
     /*  672705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  672716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  672719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  672722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  672725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672751 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672773 */     GIR_RootConstrainSelectedInstOperands,
     /*  672774 */     // GIR_Coverage, 10497,
     /*  672774 */     GIR_EraseRootFromParent_Done,
     /*  672775 */   // Label 10722: @672775
     /*  672775 */   GIM_Try, /*On fail goto*//*Label 10723*/ GIMT_Encode4(672850), // Rule ID 10500 //
     /*  672780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  672791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  672794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  672797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  672800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672826 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672848 */     GIR_RootConstrainSelectedInstOperands,
     /*  672849 */     // GIR_Coverage, 10500,
     /*  672849 */     GIR_EraseRootFromParent_Done,
     /*  672850 */   // Label 10723: @672850
     /*  672850 */   GIM_Try, /*On fail goto*//*Label 10724*/ GIMT_Encode4(672925), // Rule ID 10501 //
     /*  672855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  672866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  672869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  672872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  672875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672901 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672923 */     GIR_RootConstrainSelectedInstOperands,
     /*  672924 */     // GIR_Coverage, 10501,
     /*  672924 */     GIR_EraseRootFromParent_Done,
     /*  672925 */   // Label 10724: @672925
     /*  672925 */   GIM_Try, /*On fail goto*//*Label 10725*/ GIMT_Encode4(673000), // Rule ID 10504 //
     /*  672930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  672941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  672944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  672947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  672950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672976 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672998 */     GIR_RootConstrainSelectedInstOperands,
     /*  672999 */     // GIR_Coverage, 10504,
     /*  672999 */     GIR_EraseRootFromParent_Done,
     /*  673000 */   // Label 10725: @673000
     /*  673000 */   GIM_Try, /*On fail goto*//*Label 10726*/ GIMT_Encode4(673075), // Rule ID 10505 //
     /*  673005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  673016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  673019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  673022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  673025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673051 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  673051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  673070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673073 */     GIR_RootConstrainSelectedInstOperands,
     /*  673074 */     // GIR_Coverage, 10505,
     /*  673074 */     GIR_EraseRootFromParent_Done,
     /*  673075 */   // Label 10726: @673075
     /*  673075 */   GIM_Try, /*On fail goto*//*Label 10727*/ GIMT_Encode4(673150), // Rule ID 10508 //
     /*  673080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  673091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  673094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  673097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  673100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673126 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  673129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673148 */     GIR_RootConstrainSelectedInstOperands,
     /*  673149 */     // GIR_Coverage, 10508,
     /*  673149 */     GIR_EraseRootFromParent_Done,
     /*  673150 */   // Label 10727: @673150
     /*  673150 */   GIM_Try, /*On fail goto*//*Label 10728*/ GIMT_Encode4(673225), // Rule ID 10509 //
     /*  673155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  673166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  673169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  673172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  673175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673201 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  673204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673223 */     GIR_RootConstrainSelectedInstOperands,
     /*  673224 */     // GIR_Coverage, 10509,
     /*  673224 */     GIR_EraseRootFromParent_Done,
     /*  673225 */   // Label 10728: @673225
     /*  673225 */   GIM_Try, /*On fail goto*//*Label 10729*/ GIMT_Encode4(673300), // Rule ID 10512 //
     /*  673230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  673241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  673244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  673247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  673250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673276 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  673279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673298 */     GIR_RootConstrainSelectedInstOperands,
     /*  673299 */     // GIR_Coverage, 10512,
     /*  673299 */     GIR_EraseRootFromParent_Done,
     /*  673300 */   // Label 10729: @673300
     /*  673300 */   GIM_Try, /*On fail goto*//*Label 10730*/ GIMT_Encode4(673375), // Rule ID 10513 //
     /*  673305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  673316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  673319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  673322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  673325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673351 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  673354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673373 */     GIR_RootConstrainSelectedInstOperands,
     /*  673374 */     // GIR_Coverage, 10513,
     /*  673374 */     GIR_EraseRootFromParent_Done,
     /*  673375 */   // Label 10730: @673375
     /*  673375 */   GIM_Try, /*On fail goto*//*Label 10731*/ GIMT_Encode4(673450), // Rule ID 10516 //
     /*  673380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  673391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  673394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  673397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  673400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673426 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673448 */     GIR_RootConstrainSelectedInstOperands,
     /*  673449 */     // GIR_Coverage, 10516,
     /*  673449 */     GIR_EraseRootFromParent_Done,
     /*  673450 */   // Label 10731: @673450
     /*  673450 */   GIM_Try, /*On fail goto*//*Label 10732*/ GIMT_Encode4(673525), // Rule ID 10517 //
     /*  673455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  673466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  673469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  673472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  673475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673501 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673523 */     GIR_RootConstrainSelectedInstOperands,
     /*  673524 */     // GIR_Coverage, 10517,
     /*  673524 */     GIR_EraseRootFromParent_Done,
     /*  673525 */   // Label 10732: @673525
     /*  673525 */   GIM_Try, /*On fail goto*//*Label 10733*/ GIMT_Encode4(673600), // Rule ID 10520 //
     /*  673530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  673541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  673544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  673547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  673550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  673579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673598 */     GIR_RootConstrainSelectedInstOperands,
     /*  673599 */     // GIR_Coverage, 10520,
     /*  673599 */     GIR_EraseRootFromParent_Done,
     /*  673600 */   // Label 10733: @673600
     /*  673600 */   GIM_Try, /*On fail goto*//*Label 10734*/ GIMT_Encode4(673675), // Rule ID 10521 //
     /*  673605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  673616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  673619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  673622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  673625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673651 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  673654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673673 */     GIR_RootConstrainSelectedInstOperands,
     /*  673674 */     // GIR_Coverage, 10521,
     /*  673674 */     GIR_EraseRootFromParent_Done,
     /*  673675 */   // Label 10734: @673675
     /*  673675 */   GIM_Try, /*On fail goto*//*Label 10735*/ GIMT_Encode4(673750), // Rule ID 10524 //
     /*  673680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  673691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  673694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  673697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  673700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673726 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  673729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673748 */     GIR_RootConstrainSelectedInstOperands,
     /*  673749 */     // GIR_Coverage, 10524,
     /*  673749 */     GIR_EraseRootFromParent_Done,
     /*  673750 */   // Label 10735: @673750
     /*  673750 */   GIM_Try, /*On fail goto*//*Label 10736*/ GIMT_Encode4(673825), // Rule ID 10525 //
     /*  673755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  673766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  673769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  673772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  673775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673801 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  673804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673823 */     GIR_RootConstrainSelectedInstOperands,
     /*  673824 */     // GIR_Coverage, 10525,
     /*  673824 */     GIR_EraseRootFromParent_Done,
     /*  673825 */   // Label 10736: @673825
     /*  673825 */   GIM_Try, /*On fail goto*//*Label 10737*/ GIMT_Encode4(673900), // Rule ID 10528 //
     /*  673830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  673841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  673844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  673847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  673850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673876 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673898 */     GIR_RootConstrainSelectedInstOperands,
     /*  673899 */     // GIR_Coverage, 10528,
     /*  673899 */     GIR_EraseRootFromParent_Done,
     /*  673900 */   // Label 10737: @673900
     /*  673900 */   GIM_Try, /*On fail goto*//*Label 10738*/ GIMT_Encode4(673975), // Rule ID 10529 //
     /*  673905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  673916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  673919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  673922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  673925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673951 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673973 */     GIR_RootConstrainSelectedInstOperands,
     /*  673974 */     // GIR_Coverage, 10529,
     /*  673974 */     GIR_EraseRootFromParent_Done,
     /*  673975 */   // Label 10738: @673975
     /*  673975 */   GIM_Try, /*On fail goto*//*Label 10739*/ GIMT_Encode4(674050), // Rule ID 10532 //
     /*  673980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  673991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  673994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  673997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674026 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  674029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674048 */     GIR_RootConstrainSelectedInstOperands,
     /*  674049 */     // GIR_Coverage, 10532,
     /*  674049 */     GIR_EraseRootFromParent_Done,
     /*  674050 */   // Label 10739: @674050
     /*  674050 */   GIM_Try, /*On fail goto*//*Label 10740*/ GIMT_Encode4(674125), // Rule ID 10533 //
     /*  674055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  674066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  674069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  674072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674101 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  674104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674123 */     GIR_RootConstrainSelectedInstOperands,
     /*  674124 */     // GIR_Coverage, 10533,
     /*  674124 */     GIR_EraseRootFromParent_Done,
     /*  674125 */   // Label 10740: @674125
     /*  674125 */   GIM_Try, /*On fail goto*//*Label 10741*/ GIMT_Encode4(674200), // Rule ID 10536 //
     /*  674130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  674141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  674144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  674147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674176 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  674179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674198 */     GIR_RootConstrainSelectedInstOperands,
     /*  674199 */     // GIR_Coverage, 10536,
     /*  674199 */     GIR_EraseRootFromParent_Done,
     /*  674200 */   // Label 10741: @674200
     /*  674200 */   GIM_Try, /*On fail goto*//*Label 10742*/ GIMT_Encode4(674275), // Rule ID 10537 //
     /*  674205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  674216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  674219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  674222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674251 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  674254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674273 */     GIR_RootConstrainSelectedInstOperands,
     /*  674274 */     // GIR_Coverage, 10537,
     /*  674274 */     GIR_EraseRootFromParent_Done,
     /*  674275 */   // Label 10742: @674275
     /*  674275 */   GIM_Try, /*On fail goto*//*Label 10743*/ GIMT_Encode4(674350), // Rule ID 10540 //
     /*  674280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  674291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  674294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  674297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674326 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674348 */     GIR_RootConstrainSelectedInstOperands,
     /*  674349 */     // GIR_Coverage, 10540,
     /*  674349 */     GIR_EraseRootFromParent_Done,
     /*  674350 */   // Label 10743: @674350
     /*  674350 */   GIM_Try, /*On fail goto*//*Label 10744*/ GIMT_Encode4(674425), // Rule ID 10541 //
     /*  674355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  674366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  674369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  674372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674401 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674423 */     GIR_RootConstrainSelectedInstOperands,
     /*  674424 */     // GIR_Coverage, 10541,
     /*  674424 */     GIR_EraseRootFromParent_Done,
     /*  674425 */   // Label 10744: @674425
     /*  674425 */   GIM_Try, /*On fail goto*//*Label 10745*/ GIMT_Encode4(674500), // Rule ID 10544 //
     /*  674430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  674441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  674444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  674447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674476 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  674479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674498 */     GIR_RootConstrainSelectedInstOperands,
     /*  674499 */     // GIR_Coverage, 10544,
     /*  674499 */     GIR_EraseRootFromParent_Done,
     /*  674500 */   // Label 10745: @674500
     /*  674500 */   GIM_Try, /*On fail goto*//*Label 10746*/ GIMT_Encode4(674575), // Rule ID 10545 //
     /*  674505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  674516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  674519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  674522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674551 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  674554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674573 */     GIR_RootConstrainSelectedInstOperands,
     /*  674574 */     // GIR_Coverage, 10545,
     /*  674574 */     GIR_EraseRootFromParent_Done,
     /*  674575 */   // Label 10746: @674575
     /*  674575 */   GIM_Try, /*On fail goto*//*Label 10747*/ GIMT_Encode4(674650), // Rule ID 10548 //
     /*  674580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  674591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  674594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  674597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674626 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674648 */     GIR_RootConstrainSelectedInstOperands,
     /*  674649 */     // GIR_Coverage, 10548,
     /*  674649 */     GIR_EraseRootFromParent_Done,
     /*  674650 */   // Label 10747: @674650
     /*  674650 */   GIM_Try, /*On fail goto*//*Label 10748*/ GIMT_Encode4(674725), // Rule ID 10549 //
     /*  674655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  674666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  674669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  674672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674701 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674723 */     GIR_RootConstrainSelectedInstOperands,
     /*  674724 */     // GIR_Coverage, 10549,
     /*  674724 */     GIR_EraseRootFromParent_Done,
     /*  674725 */   // Label 10748: @674725
     /*  674725 */   GIM_Try, /*On fail goto*//*Label 10749*/ GIMT_Encode4(674800), // Rule ID 10552 //
     /*  674730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  674741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  674744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  674747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674776 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  674776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674798 */     GIR_RootConstrainSelectedInstOperands,
     /*  674799 */     // GIR_Coverage, 10552,
     /*  674799 */     GIR_EraseRootFromParent_Done,
     /*  674800 */   // Label 10749: @674800
     /*  674800 */   GIM_Try, /*On fail goto*//*Label 10750*/ GIMT_Encode4(674875), // Rule ID 10553 //
     /*  674805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  674816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  674819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  674822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674851 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  674851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674873 */     GIR_RootConstrainSelectedInstOperands,
     /*  674874 */     // GIR_Coverage, 10553,
     /*  674874 */     GIR_EraseRootFromParent_Done,
     /*  674875 */   // Label 10750: @674875
     /*  674875 */   GIM_Try, /*On fail goto*//*Label 10751*/ GIMT_Encode4(674950), // Rule ID 10556 //
     /*  674880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  674891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  674894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  674897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674926 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674948 */     GIR_RootConstrainSelectedInstOperands,
     /*  674949 */     // GIR_Coverage, 10556,
     /*  674949 */     GIR_EraseRootFromParent_Done,
     /*  674950 */   // Label 10751: @674950
     /*  674950 */   GIM_Try, /*On fail goto*//*Label 10752*/ GIMT_Encode4(675025), // Rule ID 10557 //
     /*  674955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  674966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  674969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  674972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675001 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675023 */     GIR_RootConstrainSelectedInstOperands,
     /*  675024 */     // GIR_Coverage, 10557,
     /*  675024 */     GIR_EraseRootFromParent_Done,
     /*  675025 */   // Label 10752: @675025
     /*  675025 */   GIM_Try, /*On fail goto*//*Label 10753*/ GIMT_Encode4(675100), // Rule ID 10560 //
     /*  675030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  675041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  675044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  675047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675076 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675098 */     GIR_RootConstrainSelectedInstOperands,
     /*  675099 */     // GIR_Coverage, 10560,
     /*  675099 */     GIR_EraseRootFromParent_Done,
     /*  675100 */   // Label 10753: @675100
     /*  675100 */   GIM_Try, /*On fail goto*//*Label 10754*/ GIMT_Encode4(675175), // Rule ID 10561 //
     /*  675105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  675116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  675119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  675122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675151 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675173 */     GIR_RootConstrainSelectedInstOperands,
     /*  675174 */     // GIR_Coverage, 10561,
     /*  675174 */     GIR_EraseRootFromParent_Done,
     /*  675175 */   // Label 10754: @675175
     /*  675175 */   GIM_Try, /*On fail goto*//*Label 10755*/ GIMT_Encode4(675250), // Rule ID 10564 //
     /*  675180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  675191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  675194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  675197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  675226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675248 */     GIR_RootConstrainSelectedInstOperands,
     /*  675249 */     // GIR_Coverage, 10564,
     /*  675249 */     GIR_EraseRootFromParent_Done,
     /*  675250 */   // Label 10755: @675250
     /*  675250 */   GIM_Try, /*On fail goto*//*Label 10756*/ GIMT_Encode4(675325), // Rule ID 10565 //
     /*  675255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  675266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  675269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  675272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675301 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  675301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675323 */     GIR_RootConstrainSelectedInstOperands,
     /*  675324 */     // GIR_Coverage, 10565,
     /*  675324 */     GIR_EraseRootFromParent_Done,
     /*  675325 */   // Label 10756: @675325
     /*  675325 */   GIM_Try, /*On fail goto*//*Label 10757*/ GIMT_Encode4(675400), // Rule ID 10568 //
     /*  675330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  675333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  675341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  675344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  675347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675376 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  675376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675398 */     GIR_RootConstrainSelectedInstOperands,
     /*  675399 */     // GIR_Coverage, 10568,
     /*  675399 */     GIR_EraseRootFromParent_Done,
     /*  675400 */   // Label 10757: @675400
     /*  675400 */   GIM_Try, /*On fail goto*//*Label 10758*/ GIMT_Encode4(675475), // Rule ID 10569 //
     /*  675405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  675408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  675416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  675419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  675422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675451 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  675451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675473 */     GIR_RootConstrainSelectedInstOperands,
     /*  675474 */     // GIR_Coverage, 10569,
     /*  675474 */     GIR_EraseRootFromParent_Done,
     /*  675475 */   // Label 10758: @675475
     /*  675475 */   GIM_Try, /*On fail goto*//*Label 10759*/ GIMT_Encode4(675550), // Rule ID 10572 //
     /*  675480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  675491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  675494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  675497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675526 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675548 */     GIR_RootConstrainSelectedInstOperands,
     /*  675549 */     // GIR_Coverage, 10572,
     /*  675549 */     GIR_EraseRootFromParent_Done,
     /*  675550 */   // Label 10759: @675550
     /*  675550 */   GIM_Try, /*On fail goto*//*Label 10760*/ GIMT_Encode4(675625), // Rule ID 10573 //
     /*  675555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  675566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  675569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  675572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675601 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675623 */     GIR_RootConstrainSelectedInstOperands,
     /*  675624 */     // GIR_Coverage, 10573,
     /*  675624 */     GIR_EraseRootFromParent_Done,
     /*  675625 */   // Label 10760: @675625
     /*  675625 */   GIM_Try, /*On fail goto*//*Label 10761*/ GIMT_Encode4(675700), // Rule ID 10576 //
     /*  675630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  675641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  675644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  675647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675676 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675698 */     GIR_RootConstrainSelectedInstOperands,
     /*  675699 */     // GIR_Coverage, 10576,
     /*  675699 */     GIR_EraseRootFromParent_Done,
     /*  675700 */   // Label 10761: @675700
     /*  675700 */   GIM_Try, /*On fail goto*//*Label 10762*/ GIMT_Encode4(675775), // Rule ID 10577 //
     /*  675705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  675716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  675719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  675722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675751 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675773 */     GIR_RootConstrainSelectedInstOperands,
     /*  675774 */     // GIR_Coverage, 10577,
     /*  675774 */     GIR_EraseRootFromParent_Done,
     /*  675775 */   // Label 10762: @675775
     /*  675775 */   GIM_Try, /*On fail goto*//*Label 10763*/ GIMT_Encode4(675850), // Rule ID 10580 //
     /*  675780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  675791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  675794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  675797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675826 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675848 */     GIR_RootConstrainSelectedInstOperands,
     /*  675849 */     // GIR_Coverage, 10580,
     /*  675849 */     GIR_EraseRootFromParent_Done,
     /*  675850 */   // Label 10763: @675850
     /*  675850 */   GIM_Try, /*On fail goto*//*Label 10764*/ GIMT_Encode4(675925), // Rule ID 10581 //
     /*  675855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  675866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  675869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  675872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675901 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675923 */     GIR_RootConstrainSelectedInstOperands,
     /*  675924 */     // GIR_Coverage, 10581,
     /*  675924 */     GIR_EraseRootFromParent_Done,
     /*  675925 */   // Label 10764: @675925
     /*  675925 */   GIM_Try, /*On fail goto*//*Label 10765*/ GIMT_Encode4(676000), // Rule ID 10584 //
     /*  675930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  675941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  675944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  675947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675998 */     GIR_RootConstrainSelectedInstOperands,
     /*  675999 */     // GIR_Coverage, 10584,
     /*  675999 */     GIR_EraseRootFromParent_Done,
     /*  676000 */   // Label 10765: @676000
     /*  676000 */   GIM_Try, /*On fail goto*//*Label 10766*/ GIMT_Encode4(676075), // Rule ID 10585 //
     /*  676005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  676016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  676019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  676022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676051 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676073 */     GIR_RootConstrainSelectedInstOperands,
     /*  676074 */     // GIR_Coverage, 10585,
     /*  676074 */     GIR_EraseRootFromParent_Done,
     /*  676075 */   // Label 10766: @676075
     /*  676075 */   GIM_Try, /*On fail goto*//*Label 10767*/ GIMT_Encode4(676150), // Rule ID 10588 //
     /*  676080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  676091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  676094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  676097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676126 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676148 */     GIR_RootConstrainSelectedInstOperands,
     /*  676149 */     // GIR_Coverage, 10588,
     /*  676149 */     GIR_EraseRootFromParent_Done,
     /*  676150 */   // Label 10767: @676150
     /*  676150 */   GIM_Try, /*On fail goto*//*Label 10768*/ GIMT_Encode4(676225), // Rule ID 10589 //
     /*  676155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  676166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  676169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  676172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676201 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676223 */     GIR_RootConstrainSelectedInstOperands,
     /*  676224 */     // GIR_Coverage, 10589,
     /*  676224 */     GIR_EraseRootFromParent_Done,
     /*  676225 */   // Label 10768: @676225
     /*  676225 */   GIM_Try, /*On fail goto*//*Label 10769*/ GIMT_Encode4(676300), // Rule ID 10592 //
     /*  676230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  676241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  676244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  676247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676276 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676298 */     GIR_RootConstrainSelectedInstOperands,
     /*  676299 */     // GIR_Coverage, 10592,
     /*  676299 */     GIR_EraseRootFromParent_Done,
     /*  676300 */   // Label 10769: @676300
     /*  676300 */   GIM_Try, /*On fail goto*//*Label 10770*/ GIMT_Encode4(676375), // Rule ID 10593 //
     /*  676305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  676316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  676319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  676322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676351 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676373 */     GIR_RootConstrainSelectedInstOperands,
     /*  676374 */     // GIR_Coverage, 10593,
     /*  676374 */     GIR_EraseRootFromParent_Done,
     /*  676375 */   // Label 10770: @676375
     /*  676375 */   GIM_Try, /*On fail goto*//*Label 10771*/ GIMT_Encode4(676450), // Rule ID 10596 //
     /*  676380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  676391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  676394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  676397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676448 */     GIR_RootConstrainSelectedInstOperands,
     /*  676449 */     // GIR_Coverage, 10596,
     /*  676449 */     GIR_EraseRootFromParent_Done,
     /*  676450 */   // Label 10771: @676450
     /*  676450 */   GIM_Try, /*On fail goto*//*Label 10772*/ GIMT_Encode4(676525), // Rule ID 10597 //
     /*  676455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  676466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  676469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  676472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676523 */     GIR_RootConstrainSelectedInstOperands,
     /*  676524 */     // GIR_Coverage, 10597,
     /*  676524 */     GIR_EraseRootFromParent_Done,
     /*  676525 */   // Label 10772: @676525
     /*  676525 */   GIM_Try, /*On fail goto*//*Label 10773*/ GIMT_Encode4(676600), // Rule ID 10600 //
     /*  676530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  676541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  676544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  676547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676576 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676598 */     GIR_RootConstrainSelectedInstOperands,
     /*  676599 */     // GIR_Coverage, 10600,
     /*  676599 */     GIR_EraseRootFromParent_Done,
     /*  676600 */   // Label 10773: @676600
     /*  676600 */   GIM_Try, /*On fail goto*//*Label 10774*/ GIMT_Encode4(676675), // Rule ID 10601 //
     /*  676605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  676616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  676619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  676622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676651 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676673 */     GIR_RootConstrainSelectedInstOperands,
     /*  676674 */     // GIR_Coverage, 10601,
     /*  676674 */     GIR_EraseRootFromParent_Done,
     /*  676675 */   // Label 10774: @676675
     /*  676675 */   GIM_Try, /*On fail goto*//*Label 10775*/ GIMT_Encode4(676750), // Rule ID 10604 //
     /*  676680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  676691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  676694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  676697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676726 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676748 */     GIR_RootConstrainSelectedInstOperands,
     /*  676749 */     // GIR_Coverage, 10604,
     /*  676749 */     GIR_EraseRootFromParent_Done,
     /*  676750 */   // Label 10775: @676750
     /*  676750 */   GIM_Try, /*On fail goto*//*Label 10776*/ GIMT_Encode4(676825), // Rule ID 10605 //
     /*  676755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  676766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  676769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  676772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676801 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676823 */     GIR_RootConstrainSelectedInstOperands,
     /*  676824 */     // GIR_Coverage, 10605,
     /*  676824 */     GIR_EraseRootFromParent_Done,
     /*  676825 */   // Label 10776: @676825
     /*  676825 */   GIM_Try, /*On fail goto*//*Label 10777*/ GIMT_Encode4(676900), // Rule ID 10608 //
     /*  676830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  676841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  676844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  676847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  676876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676898 */     GIR_RootConstrainSelectedInstOperands,
     /*  676899 */     // GIR_Coverage, 10608,
     /*  676899 */     GIR_EraseRootFromParent_Done,
     /*  676900 */   // Label 10777: @676900
     /*  676900 */   GIM_Try, /*On fail goto*//*Label 10778*/ GIMT_Encode4(676975), // Rule ID 10609 //
     /*  676905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  676908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  676916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  676919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  676922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  676951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676973 */     GIR_RootConstrainSelectedInstOperands,
     /*  676974 */     // GIR_Coverage, 10609,
     /*  676974 */     GIR_EraseRootFromParent_Done,
     /*  676975 */   // Label 10778: @676975
     /*  676975 */   GIM_Try, /*On fail goto*//*Label 10779*/ GIMT_Encode4(677050), // Rule ID 10612 //
     /*  676980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  676991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  676994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  676997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677026 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  677026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  677029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677048 */     GIR_RootConstrainSelectedInstOperands,
     /*  677049 */     // GIR_Coverage, 10612,
     /*  677049 */     GIR_EraseRootFromParent_Done,
     /*  677050 */   // Label 10779: @677050
     /*  677050 */   GIM_Try, /*On fail goto*//*Label 10780*/ GIMT_Encode4(677125), // Rule ID 10613 //
     /*  677055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  677058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  677066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  677069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  677072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  677075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677101 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  677101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  677104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677123 */     GIR_RootConstrainSelectedInstOperands,
     /*  677124 */     // GIR_Coverage, 10613,
     /*  677124 */     GIR_EraseRootFromParent_Done,
     /*  677125 */   // Label 10780: @677125
     /*  677125 */   GIM_Try, /*On fail goto*//*Label 10781*/ GIMT_Encode4(677200), // Rule ID 10616 //
     /*  677130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  677133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  677141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  677144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  677147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  677176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  677179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677198 */     GIR_RootConstrainSelectedInstOperands,
     /*  677199 */     // GIR_Coverage, 10616,
     /*  677199 */     GIR_EraseRootFromParent_Done,
     /*  677200 */   // Label 10781: @677200
     /*  677200 */   GIM_Try, /*On fail goto*//*Label 10782*/ GIMT_Encode4(677275), // Rule ID 10617 //
     /*  677205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  677208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  677216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  677219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  677222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  677225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677251 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  677251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  677254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677273 */     GIR_RootConstrainSelectedInstOperands,
     /*  677274 */     // GIR_Coverage, 10617,
     /*  677274 */     GIR_EraseRootFromParent_Done,
     /*  677275 */   // Label 10782: @677275
     /*  677275 */   GIM_Try, /*On fail goto*//*Label 10783*/ GIMT_Encode4(677350), // Rule ID 10620 //
     /*  677280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  677291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  677294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  677297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  677300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677326 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  677329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677348 */     GIR_RootConstrainSelectedInstOperands,
     /*  677349 */     // GIR_Coverage, 10620,
     /*  677349 */     GIR_EraseRootFromParent_Done,
     /*  677350 */   // Label 10783: @677350
     /*  677350 */   GIM_Try, /*On fail goto*//*Label 10784*/ GIMT_Encode4(677425), // Rule ID 10621 //
     /*  677355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  677366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  677369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  677372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  677375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677401 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  677404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677423 */     GIR_RootConstrainSelectedInstOperands,
     /*  677424 */     // GIR_Coverage, 10621,
     /*  677424 */     GIR_EraseRootFromParent_Done,
     /*  677425 */   // Label 10784: @677425
     /*  677425 */   GIM_Try, /*On fail goto*//*Label 10785*/ GIMT_Encode4(677500), // Rule ID 10624 //
     /*  677430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  677441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  677444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  677447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  677450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677476 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677498 */     GIR_RootConstrainSelectedInstOperands,
     /*  677499 */     // GIR_Coverage, 10624,
     /*  677499 */     GIR_EraseRootFromParent_Done,
     /*  677500 */   // Label 10785: @677500
     /*  677500 */   GIM_Try, /*On fail goto*//*Label 10786*/ GIMT_Encode4(677575), // Rule ID 10625 //
     /*  677505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  677516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  677519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  677522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  677525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677551 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677573 */     GIR_RootConstrainSelectedInstOperands,
     /*  677574 */     // GIR_Coverage, 10625,
     /*  677574 */     GIR_EraseRootFromParent_Done,
     /*  677575 */   // Label 10786: @677575
     /*  677575 */   GIM_Try, /*On fail goto*//*Label 10787*/ GIMT_Encode4(677650), // Rule ID 10628 //
     /*  677580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  677591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  677594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  677597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  677600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677626 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677648 */     GIR_RootConstrainSelectedInstOperands,
     /*  677649 */     // GIR_Coverage, 10628,
     /*  677649 */     GIR_EraseRootFromParent_Done,
     /*  677650 */   // Label 10787: @677650
     /*  677650 */   GIM_Try, /*On fail goto*//*Label 10788*/ GIMT_Encode4(677725), // Rule ID 10629 //
     /*  677655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  677666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  677669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  677672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  677675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677701 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677723 */     GIR_RootConstrainSelectedInstOperands,
     /*  677724 */     // GIR_Coverage, 10629,
     /*  677724 */     GIR_EraseRootFromParent_Done,
     /*  677725 */   // Label 10788: @677725
     /*  677725 */   GIM_Try, /*On fail goto*//*Label 10789*/ GIMT_Encode4(677800), // Rule ID 10632 //
     /*  677730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  677741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  677744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  677747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  677750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677776 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677798 */     GIR_RootConstrainSelectedInstOperands,
     /*  677799 */     // GIR_Coverage, 10632,
     /*  677799 */     GIR_EraseRootFromParent_Done,
     /*  677800 */   // Label 10789: @677800
     /*  677800 */   GIM_Try, /*On fail goto*//*Label 10790*/ GIMT_Encode4(677875), // Rule ID 10633 //
     /*  677805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  677816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  677819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  677822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  677825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677851 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677873 */     GIR_RootConstrainSelectedInstOperands,
     /*  677874 */     // GIR_Coverage, 10633,
     /*  677874 */     GIR_EraseRootFromParent_Done,
     /*  677875 */   // Label 10790: @677875
     /*  677875 */   GIM_Try, /*On fail goto*//*Label 10791*/ GIMT_Encode4(677950), // Rule ID 10636 //
     /*  677880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  677891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  677894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  677897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  677900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677926 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677948 */     GIR_RootConstrainSelectedInstOperands,
     /*  677949 */     // GIR_Coverage, 10636,
     /*  677949 */     GIR_EraseRootFromParent_Done,
     /*  677950 */   // Label 10791: @677950
     /*  677950 */   GIM_Try, /*On fail goto*//*Label 10792*/ GIMT_Encode4(678025), // Rule ID 10637 //
     /*  677955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  677966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  677969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  677972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  677975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678001 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  678004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678023 */     GIR_RootConstrainSelectedInstOperands,
     /*  678024 */     // GIR_Coverage, 10637,
     /*  678024 */     GIR_EraseRootFromParent_Done,
     /*  678025 */   // Label 10792: @678025
     /*  678025 */   GIM_Try, /*On fail goto*//*Label 10793*/ GIMT_Encode4(678100), // Rule ID 10640 //
     /*  678030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  678041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  678044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  678047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  678050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678076 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  678079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678098 */     GIR_RootConstrainSelectedInstOperands,
     /*  678099 */     // GIR_Coverage, 10640,
     /*  678099 */     GIR_EraseRootFromParent_Done,
     /*  678100 */   // Label 10793: @678100
     /*  678100 */   GIM_Try, /*On fail goto*//*Label 10794*/ GIMT_Encode4(678175), // Rule ID 10641 //
     /*  678105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  678116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  678119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  678122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  678125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678151 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  678154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678173 */     GIR_RootConstrainSelectedInstOperands,
     /*  678174 */     // GIR_Coverage, 10641,
     /*  678174 */     GIR_EraseRootFromParent_Done,
     /*  678175 */   // Label 10794: @678175
     /*  678175 */   GIM_Try, /*On fail goto*//*Label 10795*/ GIMT_Encode4(678250), // Rule ID 10644 //
     /*  678180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  678191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  678194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  678197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  678200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678248 */     GIR_RootConstrainSelectedInstOperands,
     /*  678249 */     // GIR_Coverage, 10644,
     /*  678249 */     GIR_EraseRootFromParent_Done,
     /*  678250 */   // Label 10795: @678250
     /*  678250 */   GIM_Try, /*On fail goto*//*Label 10796*/ GIMT_Encode4(678325), // Rule ID 10645 //
     /*  678255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  678266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  678269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  678272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  678275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678301 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678323 */     GIR_RootConstrainSelectedInstOperands,
     /*  678324 */     // GIR_Coverage, 10645,
     /*  678324 */     GIR_EraseRootFromParent_Done,
     /*  678325 */   // Label 10796: @678325
     /*  678325 */   GIM_Try, /*On fail goto*//*Label 10797*/ GIMT_Encode4(678400), // Rule ID 10648 //
     /*  678330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  678341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  678344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  678347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  678350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678376 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  678376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678398 */     GIR_RootConstrainSelectedInstOperands,
     /*  678399 */     // GIR_Coverage, 10648,
     /*  678399 */     GIR_EraseRootFromParent_Done,
     /*  678400 */   // Label 10797: @678400
     /*  678400 */   GIM_Try, /*On fail goto*//*Label 10798*/ GIMT_Encode4(678475), // Rule ID 10649 //
     /*  678405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  678416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  678419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  678422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  678425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678451 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678473 */     GIR_RootConstrainSelectedInstOperands,
     /*  678474 */     // GIR_Coverage, 10649,
     /*  678474 */     GIR_EraseRootFromParent_Done,
     /*  678475 */   // Label 10798: @678475
     /*  678475 */   GIM_Try, /*On fail goto*//*Label 10799*/ GIMT_Encode4(678550), // Rule ID 10652 //
     /*  678480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  678491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  678494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  678497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  678500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678526 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678548 */     GIR_RootConstrainSelectedInstOperands,
     /*  678549 */     // GIR_Coverage, 10652,
     /*  678549 */     GIR_EraseRootFromParent_Done,
     /*  678550 */   // Label 10799: @678550
     /*  678550 */   GIM_Try, /*On fail goto*//*Label 10800*/ GIMT_Encode4(678625), // Rule ID 10653 //
     /*  678555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  678566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  678569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  678572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  678575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678601 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678623 */     GIR_RootConstrainSelectedInstOperands,
     /*  678624 */     // GIR_Coverage, 10653,
     /*  678624 */     GIR_EraseRootFromParent_Done,
     /*  678625 */   // Label 10800: @678625
     /*  678625 */   GIM_Try, /*On fail goto*//*Label 10801*/ GIMT_Encode4(678700), // Rule ID 10656 //
     /*  678630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  678633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  678641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  678644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  678647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  678650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678676 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  678676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678698 */     GIR_RootConstrainSelectedInstOperands,
     /*  678699 */     // GIR_Coverage, 10656,
     /*  678699 */     GIR_EraseRootFromParent_Done,
     /*  678700 */   // Label 10801: @678700
     /*  678700 */   GIM_Try, /*On fail goto*//*Label 10802*/ GIMT_Encode4(678775), // Rule ID 10657 //
     /*  678705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  678708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  678716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  678719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  678722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  678725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678751 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  678751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678773 */     GIR_RootConstrainSelectedInstOperands,
     /*  678774 */     // GIR_Coverage, 10657,
     /*  678774 */     GIR_EraseRootFromParent_Done,
     /*  678775 */   // Label 10802: @678775
     /*  678775 */   GIM_Try, /*On fail goto*//*Label 10803*/ GIMT_Encode4(678850), // Rule ID 10660 //
     /*  678780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  678791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  678794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  678797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  678800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678826 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678848 */     GIR_RootConstrainSelectedInstOperands,
     /*  678849 */     // GIR_Coverage, 10660,
     /*  678849 */     GIR_EraseRootFromParent_Done,
     /*  678850 */   // Label 10803: @678850
     /*  678850 */   GIM_Try, /*On fail goto*//*Label 10804*/ GIMT_Encode4(678925), // Rule ID 10661 //
     /*  678855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  678866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  678869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  678872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  678875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678901 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678923 */     GIR_RootConstrainSelectedInstOperands,
     /*  678924 */     // GIR_Coverage, 10661,
     /*  678924 */     GIR_EraseRootFromParent_Done,
     /*  678925 */   // Label 10804: @678925
     /*  678925 */   GIM_Try, /*On fail goto*//*Label 10805*/ GIMT_Encode4(679000), // Rule ID 10664 //
     /*  678930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  678941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  678944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  678947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  678950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678976 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678998 */     GIR_RootConstrainSelectedInstOperands,
     /*  678999 */     // GIR_Coverage, 10664,
     /*  678999 */     GIR_EraseRootFromParent_Done,
     /*  679000 */   // Label 10805: @679000
     /*  679000 */   GIM_Try, /*On fail goto*//*Label 10806*/ GIMT_Encode4(679075), // Rule ID 10665 //
     /*  679005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  679016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  679019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  679022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  679025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679051 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679073 */     GIR_RootConstrainSelectedInstOperands,
     /*  679074 */     // GIR_Coverage, 10665,
     /*  679074 */     GIR_EraseRootFromParent_Done,
     /*  679075 */   // Label 10806: @679075
     /*  679075 */   GIM_Try, /*On fail goto*//*Label 10807*/ GIMT_Encode4(679150), // Rule ID 10668 //
     /*  679080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  679091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  679094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  679097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  679100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679126 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  679126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679148 */     GIR_RootConstrainSelectedInstOperands,
     /*  679149 */     // GIR_Coverage, 10668,
     /*  679149 */     GIR_EraseRootFromParent_Done,
     /*  679150 */   // Label 10807: @679150
     /*  679150 */   GIM_Try, /*On fail goto*//*Label 10808*/ GIMT_Encode4(679225), // Rule ID 10669 //
     /*  679155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  679166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  679169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  679172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  679175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679201 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679223 */     GIR_RootConstrainSelectedInstOperands,
     /*  679224 */     // GIR_Coverage, 10669,
     /*  679224 */     GIR_EraseRootFromParent_Done,
     /*  679225 */   // Label 10808: @679225
     /*  679225 */   GIM_Try, /*On fail goto*//*Label 10809*/ GIMT_Encode4(679300), // Rule ID 10672 //
     /*  679230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  679241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  679244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  679247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  679250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679298 */     GIR_RootConstrainSelectedInstOperands,
     /*  679299 */     // GIR_Coverage, 10672,
     /*  679299 */     GIR_EraseRootFromParent_Done,
     /*  679300 */   // Label 10809: @679300
     /*  679300 */   GIM_Try, /*On fail goto*//*Label 10810*/ GIMT_Encode4(679375), // Rule ID 10673 //
     /*  679305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  679316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  679319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  679322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  679325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679351 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679373 */     GIR_RootConstrainSelectedInstOperands,
     /*  679374 */     // GIR_Coverage, 10673,
     /*  679374 */     GIR_EraseRootFromParent_Done,
     /*  679375 */   // Label 10810: @679375
     /*  679375 */   GIM_Try, /*On fail goto*//*Label 10811*/ GIMT_Encode4(679450), // Rule ID 10676 //
     /*  679380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  679391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  679394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  679397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  679400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679426 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679448 */     GIR_RootConstrainSelectedInstOperands,
     /*  679449 */     // GIR_Coverage, 10676,
     /*  679449 */     GIR_EraseRootFromParent_Done,
     /*  679450 */   // Label 10811: @679450
     /*  679450 */   GIM_Try, /*On fail goto*//*Label 10812*/ GIMT_Encode4(679525), // Rule ID 10677 //
     /*  679455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  679466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  679469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  679472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  679475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679501 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679523 */     GIR_RootConstrainSelectedInstOperands,
     /*  679524 */     // GIR_Coverage, 10677,
     /*  679524 */     GIR_EraseRootFromParent_Done,
     /*  679525 */   // Label 10812: @679525
     /*  679525 */   GIM_Try, /*On fail goto*//*Label 10813*/ GIMT_Encode4(679600), // Rule ID 10680 //
     /*  679530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  679541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  679544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  679547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  679550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679576 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679598 */     GIR_RootConstrainSelectedInstOperands,
     /*  679599 */     // GIR_Coverage, 10680,
     /*  679599 */     GIR_EraseRootFromParent_Done,
     /*  679600 */   // Label 10813: @679600
     /*  679600 */   GIM_Try, /*On fail goto*//*Label 10814*/ GIMT_Encode4(679675), // Rule ID 10681 //
     /*  679605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  679616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  679619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  679622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  679625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679651 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679673 */     GIR_RootConstrainSelectedInstOperands,
     /*  679674 */     // GIR_Coverage, 10681,
     /*  679674 */     GIR_EraseRootFromParent_Done,
     /*  679675 */   // Label 10814: @679675
     /*  679675 */   GIM_Try, /*On fail goto*//*Label 10815*/ GIMT_Encode4(679750), // Rule ID 10684 //
     /*  679680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  679691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  679694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  679697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  679700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679748 */     GIR_RootConstrainSelectedInstOperands,
     /*  679749 */     // GIR_Coverage, 10684,
     /*  679749 */     GIR_EraseRootFromParent_Done,
     /*  679750 */   // Label 10815: @679750
     /*  679750 */   GIM_Try, /*On fail goto*//*Label 10816*/ GIMT_Encode4(679825), // Rule ID 10685 //
     /*  679755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  679766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  679769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  679772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  679775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679823 */     GIR_RootConstrainSelectedInstOperands,
     /*  679824 */     // GIR_Coverage, 10685,
     /*  679824 */     GIR_EraseRootFromParent_Done,
     /*  679825 */   // Label 10816: @679825
     /*  679825 */   GIM_Try, /*On fail goto*//*Label 10817*/ GIMT_Encode4(679900), // Rule ID 10688 //
     /*  679830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  679841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  679844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  679847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  679850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679898 */     GIR_RootConstrainSelectedInstOperands,
     /*  679899 */     // GIR_Coverage, 10688,
     /*  679899 */     GIR_EraseRootFromParent_Done,
     /*  679900 */   // Label 10817: @679900
     /*  679900 */   GIM_Try, /*On fail goto*//*Label 10818*/ GIMT_Encode4(679975), // Rule ID 10689 //
     /*  679905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  679916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  679919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  679922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  679925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679951 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679973 */     GIR_RootConstrainSelectedInstOperands,
     /*  679974 */     // GIR_Coverage, 10689,
     /*  679974 */     GIR_EraseRootFromParent_Done,
     /*  679975 */   // Label 10818: @679975
     /*  679975 */   GIM_Try, /*On fail goto*//*Label 10819*/ GIMT_Encode4(680050), // Rule ID 10692 //
     /*  679980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  679991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  679994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  679997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  680000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680026 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  680026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  680029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680048 */     GIR_RootConstrainSelectedInstOperands,
     /*  680049 */     // GIR_Coverage, 10692,
     /*  680049 */     GIR_EraseRootFromParent_Done,
     /*  680050 */   // Label 10819: @680050
     /*  680050 */   GIM_Try, /*On fail goto*//*Label 10820*/ GIMT_Encode4(680125), // Rule ID 10693 //
     /*  680055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  680066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  680069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  680072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  680075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680101 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  680101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  680104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680123 */     GIR_RootConstrainSelectedInstOperands,
     /*  680124 */     // GIR_Coverage, 10693,
     /*  680124 */     GIR_EraseRootFromParent_Done,
     /*  680125 */   // Label 10820: @680125
     /*  680125 */   GIM_Try, /*On fail goto*//*Label 10821*/ GIMT_Encode4(680200), // Rule ID 10696 //
     /*  680130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  680141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  680144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  680147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  680150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680176 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  680179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680198 */     GIR_RootConstrainSelectedInstOperands,
     /*  680199 */     // GIR_Coverage, 10696,
     /*  680199 */     GIR_EraseRootFromParent_Done,
     /*  680200 */   // Label 10821: @680200
     /*  680200 */   GIM_Try, /*On fail goto*//*Label 10822*/ GIMT_Encode4(680275), // Rule ID 10697 //
     /*  680205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  680216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  680219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  680222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  680225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  680254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680273 */     GIR_RootConstrainSelectedInstOperands,
     /*  680274 */     // GIR_Coverage, 10697,
     /*  680274 */     GIR_EraseRootFromParent_Done,
     /*  680275 */   // Label 10822: @680275
     /*  680275 */   GIM_Try, /*On fail goto*//*Label 10823*/ GIMT_Encode4(680350), // Rule ID 10700 //
     /*  680280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  680291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  680294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  680297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  680300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680326 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  680329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680348 */     GIR_RootConstrainSelectedInstOperands,
     /*  680349 */     // GIR_Coverage, 10700,
     /*  680349 */     GIR_EraseRootFromParent_Done,
     /*  680350 */   // Label 10823: @680350
     /*  680350 */   GIM_Try, /*On fail goto*//*Label 10824*/ GIMT_Encode4(680425), // Rule ID 10701 //
     /*  680355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  680366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  680369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  680372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  680375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680401 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  680404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680423 */     GIR_RootConstrainSelectedInstOperands,
     /*  680424 */     // GIR_Coverage, 10701,
     /*  680424 */     GIR_EraseRootFromParent_Done,
     /*  680425 */   // Label 10824: @680425
     /*  680425 */   GIM_Try, /*On fail goto*//*Label 10825*/ GIMT_Encode4(680500), // Rule ID 10704 //
     /*  680430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  680441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  680444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  680447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  680450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  680479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680498 */     GIR_RootConstrainSelectedInstOperands,
     /*  680499 */     // GIR_Coverage, 10704,
     /*  680499 */     GIR_EraseRootFromParent_Done,
     /*  680500 */   // Label 10825: @680500
     /*  680500 */   GIM_Try, /*On fail goto*//*Label 10826*/ GIMT_Encode4(680575), // Rule ID 10705 //
     /*  680505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  680516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  680519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  680522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  680525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680551 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  680554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680573 */     GIR_RootConstrainSelectedInstOperands,
     /*  680574 */     // GIR_Coverage, 10705,
     /*  680574 */     GIR_EraseRootFromParent_Done,
     /*  680575 */   // Label 10826: @680575
     /*  680575 */   GIM_Try, /*On fail goto*//*Label 10827*/ GIMT_Encode4(680650), // Rule ID 10708 //
     /*  680580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  680591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  680594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  680597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680626 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  680629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680648 */     GIR_RootConstrainSelectedInstOperands,
     /*  680649 */     // GIR_Coverage, 10708,
     /*  680649 */     GIR_EraseRootFromParent_Done,
     /*  680650 */   // Label 10827: @680650
     /*  680650 */   GIM_Try, /*On fail goto*//*Label 10828*/ GIMT_Encode4(680725), // Rule ID 10709 //
     /*  680655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  680666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  680669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  680672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680701 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  680704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680723 */     GIR_RootConstrainSelectedInstOperands,
     /*  680724 */     // GIR_Coverage, 10709,
     /*  680724 */     GIR_EraseRootFromParent_Done,
     /*  680725 */   // Label 10828: @680725
     /*  680725 */   GIM_Try, /*On fail goto*//*Label 10829*/ GIMT_Encode4(680800), // Rule ID 10712 //
     /*  680730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  680741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  680744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  680747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680776 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680798 */     GIR_RootConstrainSelectedInstOperands,
     /*  680799 */     // GIR_Coverage, 10712,
     /*  680799 */     GIR_EraseRootFromParent_Done,
     /*  680800 */   // Label 10829: @680800
     /*  680800 */   GIM_Try, /*On fail goto*//*Label 10830*/ GIMT_Encode4(680875), // Rule ID 10713 //
     /*  680805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  680816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  680819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  680822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680851 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680873 */     GIR_RootConstrainSelectedInstOperands,
     /*  680874 */     // GIR_Coverage, 10713,
     /*  680874 */     GIR_EraseRootFromParent_Done,
     /*  680875 */   // Label 10830: @680875
     /*  680875 */   GIM_Try, /*On fail goto*//*Label 10831*/ GIMT_Encode4(680950), // Rule ID 10716 //
     /*  680880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  680891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  680894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  680897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680926 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680948 */     GIR_RootConstrainSelectedInstOperands,
     /*  680949 */     // GIR_Coverage, 10716,
     /*  680949 */     GIR_EraseRootFromParent_Done,
     /*  680950 */   // Label 10831: @680950
     /*  680950 */   GIM_Try, /*On fail goto*//*Label 10832*/ GIMT_Encode4(681025), // Rule ID 10717 //
     /*  680955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  680966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  680969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  680972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681001 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  681004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681023 */     GIR_RootConstrainSelectedInstOperands,
     /*  681024 */     // GIR_Coverage, 10717,
     /*  681024 */     GIR_EraseRootFromParent_Done,
     /*  681025 */   // Label 10832: @681025
     /*  681025 */   GIM_Try, /*On fail goto*//*Label 10833*/ GIMT_Encode4(681100), // Rule ID 10720 //
     /*  681030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  681041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  681044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  681047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681076 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  681079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681098 */     GIR_RootConstrainSelectedInstOperands,
     /*  681099 */     // GIR_Coverage, 10720,
     /*  681099 */     GIR_EraseRootFromParent_Done,
     /*  681100 */   // Label 10833: @681100
     /*  681100 */   GIM_Try, /*On fail goto*//*Label 10834*/ GIMT_Encode4(681175), // Rule ID 10721 //
     /*  681105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  681116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  681119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  681122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681151 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  681154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681173 */     GIR_RootConstrainSelectedInstOperands,
     /*  681174 */     // GIR_Coverage, 10721,
     /*  681174 */     GIR_EraseRootFromParent_Done,
     /*  681175 */   // Label 10834: @681175
     /*  681175 */   GIM_Try, /*On fail goto*//*Label 10835*/ GIMT_Encode4(681250), // Rule ID 10724 //
     /*  681180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  681191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  681194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  681197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681226 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  681229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681248 */     GIR_RootConstrainSelectedInstOperands,
     /*  681249 */     // GIR_Coverage, 10724,
     /*  681249 */     GIR_EraseRootFromParent_Done,
     /*  681250 */   // Label 10835: @681250
     /*  681250 */   GIM_Try, /*On fail goto*//*Label 10836*/ GIMT_Encode4(681325), // Rule ID 10725 //
     /*  681255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  681266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  681269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  681272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681301 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  681304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681323 */     GIR_RootConstrainSelectedInstOperands,
     /*  681324 */     // GIR_Coverage, 10725,
     /*  681324 */     GIR_EraseRootFromParent_Done,
     /*  681325 */   // Label 10836: @681325
     /*  681325 */   GIM_Try, /*On fail goto*//*Label 10837*/ GIMT_Encode4(681400), // Rule ID 10728 //
     /*  681330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  681341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  681344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  681347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681376 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  681379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681398 */     GIR_RootConstrainSelectedInstOperands,
     /*  681399 */     // GIR_Coverage, 10728,
     /*  681399 */     GIR_EraseRootFromParent_Done,
     /*  681400 */   // Label 10837: @681400
     /*  681400 */   GIM_Try, /*On fail goto*//*Label 10838*/ GIMT_Encode4(681475), // Rule ID 10729 //
     /*  681405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  681416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  681419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  681422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681451 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  681451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  681454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681473 */     GIR_RootConstrainSelectedInstOperands,
     /*  681474 */     // GIR_Coverage, 10729,
     /*  681474 */     GIR_EraseRootFromParent_Done,
     /*  681475 */   // Label 10838: @681475
     /*  681475 */   GIM_Try, /*On fail goto*//*Label 10839*/ GIMT_Encode4(681550), // Rule ID 10732 //
     /*  681480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  681491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  681494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  681497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681526 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681548 */     GIR_RootConstrainSelectedInstOperands,
     /*  681549 */     // GIR_Coverage, 10732,
     /*  681549 */     GIR_EraseRootFromParent_Done,
     /*  681550 */   // Label 10839: @681550
     /*  681550 */   GIM_Try, /*On fail goto*//*Label 10840*/ GIMT_Encode4(681625), // Rule ID 10733 //
     /*  681555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  681566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  681569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  681572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681601 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681623 */     GIR_RootConstrainSelectedInstOperands,
     /*  681624 */     // GIR_Coverage, 10733,
     /*  681624 */     GIR_EraseRootFromParent_Done,
     /*  681625 */   // Label 10840: @681625
     /*  681625 */   GIM_Try, /*On fail goto*//*Label 10841*/ GIMT_Encode4(681700), // Rule ID 10736 //
     /*  681630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  681641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  681644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  681647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681676 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681698 */     GIR_RootConstrainSelectedInstOperands,
     /*  681699 */     // GIR_Coverage, 10736,
     /*  681699 */     GIR_EraseRootFromParent_Done,
     /*  681700 */   // Label 10841: @681700
     /*  681700 */   GIM_Try, /*On fail goto*//*Label 10842*/ GIMT_Encode4(681775), // Rule ID 10737 //
     /*  681705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  681716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  681719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  681722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681751 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681773 */     GIR_RootConstrainSelectedInstOperands,
     /*  681774 */     // GIR_Coverage, 10737,
     /*  681774 */     GIR_EraseRootFromParent_Done,
     /*  681775 */   // Label 10842: @681775
     /*  681775 */   GIM_Try, /*On fail goto*//*Label 10843*/ GIMT_Encode4(681850), // Rule ID 10740 //
     /*  681780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  681791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  681794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  681797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681848 */     GIR_RootConstrainSelectedInstOperands,
     /*  681849 */     // GIR_Coverage, 10740,
     /*  681849 */     GIR_EraseRootFromParent_Done,
     /*  681850 */   // Label 10843: @681850
     /*  681850 */   GIM_Try, /*On fail goto*//*Label 10844*/ GIMT_Encode4(681925), // Rule ID 10741 //
     /*  681855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  681866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  681869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  681872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681901 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  681901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681923 */     GIR_RootConstrainSelectedInstOperands,
     /*  681924 */     // GIR_Coverage, 10741,
     /*  681924 */     GIR_EraseRootFromParent_Done,
     /*  681925 */   // Label 10844: @681925
     /*  681925 */   GIM_Try, /*On fail goto*//*Label 10845*/ GIMT_Encode4(682000), // Rule ID 10744 //
     /*  681930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  681933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  681941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  681944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  681947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  681976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  681995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681998 */     GIR_RootConstrainSelectedInstOperands,
     /*  681999 */     // GIR_Coverage, 10744,
     /*  681999 */     GIR_EraseRootFromParent_Done,
     /*  682000 */   // Label 10845: @682000
     /*  682000 */   GIM_Try, /*On fail goto*//*Label 10846*/ GIMT_Encode4(682075), // Rule ID 10745 //
     /*  682005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  682008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  682016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  682019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  682022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682051 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  682051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  682054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682073 */     GIR_RootConstrainSelectedInstOperands,
     /*  682074 */     // GIR_Coverage, 10745,
     /*  682074 */     GIR_EraseRootFromParent_Done,
     /*  682075 */   // Label 10846: @682075
     /*  682075 */   GIM_Try, /*On fail goto*//*Label 10847*/ GIMT_Encode4(682150), // Rule ID 10748 //
     /*  682080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  682091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  682094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  682097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682126 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682148 */     GIR_RootConstrainSelectedInstOperands,
     /*  682149 */     // GIR_Coverage, 10748,
     /*  682149 */     GIR_EraseRootFromParent_Done,
     /*  682150 */   // Label 10847: @682150
     /*  682150 */   GIM_Try, /*On fail goto*//*Label 10848*/ GIMT_Encode4(682225), // Rule ID 10749 //
     /*  682155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  682166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  682169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  682172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682201 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682223 */     GIR_RootConstrainSelectedInstOperands,
     /*  682224 */     // GIR_Coverage, 10749,
     /*  682224 */     GIR_EraseRootFromParent_Done,
     /*  682225 */   // Label 10848: @682225
     /*  682225 */   GIM_Try, /*On fail goto*//*Label 10849*/ GIMT_Encode4(682300), // Rule ID 10752 //
     /*  682230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  682241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  682244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  682247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682276 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682298 */     GIR_RootConstrainSelectedInstOperands,
     /*  682299 */     // GIR_Coverage, 10752,
     /*  682299 */     GIR_EraseRootFromParent_Done,
     /*  682300 */   // Label 10849: @682300
     /*  682300 */   GIM_Try, /*On fail goto*//*Label 10850*/ GIMT_Encode4(682375), // Rule ID 10753 //
     /*  682305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  682316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  682319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  682322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682351 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682373 */     GIR_RootConstrainSelectedInstOperands,
     /*  682374 */     // GIR_Coverage, 10753,
     /*  682374 */     GIR_EraseRootFromParent_Done,
     /*  682375 */   // Label 10850: @682375
     /*  682375 */   GIM_Try, /*On fail goto*//*Label 10851*/ GIMT_Encode4(682450), // Rule ID 10756 //
     /*  682380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  682391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  682394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  682397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682426 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682448 */     GIR_RootConstrainSelectedInstOperands,
     /*  682449 */     // GIR_Coverage, 10756,
     /*  682449 */     GIR_EraseRootFromParent_Done,
     /*  682450 */   // Label 10851: @682450
     /*  682450 */   GIM_Try, /*On fail goto*//*Label 10852*/ GIMT_Encode4(682525), // Rule ID 10757 //
     /*  682455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  682466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  682469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  682472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682501 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682523 */     GIR_RootConstrainSelectedInstOperands,
     /*  682524 */     // GIR_Coverage, 10757,
     /*  682524 */     GIR_EraseRootFromParent_Done,
     /*  682525 */   // Label 10852: @682525
     /*  682525 */   GIM_Try, /*On fail goto*//*Label 10853*/ GIMT_Encode4(682600), // Rule ID 10760 //
     /*  682530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  682541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  682544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  682547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682576 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682598 */     GIR_RootConstrainSelectedInstOperands,
     /*  682599 */     // GIR_Coverage, 10760,
     /*  682599 */     GIR_EraseRootFromParent_Done,
     /*  682600 */   // Label 10853: @682600
     /*  682600 */   GIM_Try, /*On fail goto*//*Label 10854*/ GIMT_Encode4(682675), // Rule ID 10761 //
     /*  682605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  682616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  682619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  682622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682651 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682673 */     GIR_RootConstrainSelectedInstOperands,
     /*  682674 */     // GIR_Coverage, 10761,
     /*  682674 */     GIR_EraseRootFromParent_Done,
     /*  682675 */   // Label 10854: @682675
     /*  682675 */   GIM_Try, /*On fail goto*//*Label 10855*/ GIMT_Encode4(682750), // Rule ID 10764 //
     /*  682680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  682691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  682694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  682697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682726 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682748 */     GIR_RootConstrainSelectedInstOperands,
     /*  682749 */     // GIR_Coverage, 10764,
     /*  682749 */     GIR_EraseRootFromParent_Done,
     /*  682750 */   // Label 10855: @682750
     /*  682750 */   GIM_Try, /*On fail goto*//*Label 10856*/ GIMT_Encode4(682825), // Rule ID 10765 //
     /*  682755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  682766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  682769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  682772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682801 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682823 */     GIR_RootConstrainSelectedInstOperands,
     /*  682824 */     // GIR_Coverage, 10765,
     /*  682824 */     GIR_EraseRootFromParent_Done,
     /*  682825 */   // Label 10856: @682825
     /*  682825 */   GIM_Try, /*On fail goto*//*Label 10857*/ GIMT_Encode4(682900), // Rule ID 10768 //
     /*  682830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  682841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  682844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  682847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682876 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682898 */     GIR_RootConstrainSelectedInstOperands,
     /*  682899 */     // GIR_Coverage, 10768,
     /*  682899 */     GIR_EraseRootFromParent_Done,
     /*  682900 */   // Label 10857: @682900
     /*  682900 */   GIM_Try, /*On fail goto*//*Label 10858*/ GIMT_Encode4(682975), // Rule ID 10769 //
     /*  682905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  682916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  682919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  682922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682951 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682973 */     GIR_RootConstrainSelectedInstOperands,
     /*  682974 */     // GIR_Coverage, 10769,
     /*  682974 */     GIR_EraseRootFromParent_Done,
     /*  682975 */   // Label 10858: @682975
     /*  682975 */   GIM_Try, /*On fail goto*//*Label 10859*/ GIMT_Encode4(683050), // Rule ID 10772 //
     /*  682980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  682991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  682994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  682997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  683029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683048 */     GIR_RootConstrainSelectedInstOperands,
     /*  683049 */     // GIR_Coverage, 10772,
     /*  683049 */     GIR_EraseRootFromParent_Done,
     /*  683050 */   // Label 10859: @683050
     /*  683050 */   GIM_Try, /*On fail goto*//*Label 10860*/ GIMT_Encode4(683125), // Rule ID 10773 //
     /*  683055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  683066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  683069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  683072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683101 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  683104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683123 */     GIR_RootConstrainSelectedInstOperands,
     /*  683124 */     // GIR_Coverage, 10773,
     /*  683124 */     GIR_EraseRootFromParent_Done,
     /*  683125 */   // Label 10860: @683125
     /*  683125 */   GIM_Try, /*On fail goto*//*Label 10861*/ GIMT_Encode4(683200), // Rule ID 10776 //
     /*  683130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  683141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  683144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  683147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683176 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  683179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683198 */     GIR_RootConstrainSelectedInstOperands,
     /*  683199 */     // GIR_Coverage, 10776,
     /*  683199 */     GIR_EraseRootFromParent_Done,
     /*  683200 */   // Label 10861: @683200
     /*  683200 */   GIM_Try, /*On fail goto*//*Label 10862*/ GIMT_Encode4(683275), // Rule ID 10777 //
     /*  683205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  683216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  683219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  683222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683251 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  683254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683273 */     GIR_RootConstrainSelectedInstOperands,
     /*  683274 */     // GIR_Coverage, 10777,
     /*  683274 */     GIR_EraseRootFromParent_Done,
     /*  683275 */   // Label 10862: @683275
     /*  683275 */   GIM_Try, /*On fail goto*//*Label 10863*/ GIMT_Encode4(683350), // Rule ID 10780 //
     /*  683280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  683291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  683294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  683297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683326 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  683329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683348 */     GIR_RootConstrainSelectedInstOperands,
     /*  683349 */     // GIR_Coverage, 10780,
     /*  683349 */     GIR_EraseRootFromParent_Done,
     /*  683350 */   // Label 10863: @683350
     /*  683350 */   GIM_Try, /*On fail goto*//*Label 10864*/ GIMT_Encode4(683425), // Rule ID 10781 //
     /*  683355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  683366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  683369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  683372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683401 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  683404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683423 */     GIR_RootConstrainSelectedInstOperands,
     /*  683424 */     // GIR_Coverage, 10781,
     /*  683424 */     GIR_EraseRootFromParent_Done,
     /*  683425 */   // Label 10864: @683425
     /*  683425 */   GIM_Try, /*On fail goto*//*Label 10865*/ GIMT_Encode4(683500), // Rule ID 10784 //
     /*  683430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  683441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  683444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  683447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  683479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683498 */     GIR_RootConstrainSelectedInstOperands,
     /*  683499 */     // GIR_Coverage, 10784,
     /*  683499 */     GIR_EraseRootFromParent_Done,
     /*  683500 */   // Label 10865: @683500
     /*  683500 */   GIM_Try, /*On fail goto*//*Label 10866*/ GIMT_Encode4(683575), // Rule ID 10785 //
     /*  683505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  683516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  683519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  683522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683551 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  683554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683573 */     GIR_RootConstrainSelectedInstOperands,
     /*  683574 */     // GIR_Coverage, 10785,
     /*  683574 */     GIR_EraseRootFromParent_Done,
     /*  683575 */   // Label 10866: @683575
     /*  683575 */   GIM_Try, /*On fail goto*//*Label 10867*/ GIMT_Encode4(683650), // Rule ID 10788 //
     /*  683580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  683591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  683594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  683597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683626 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  683629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683648 */     GIR_RootConstrainSelectedInstOperands,
     /*  683649 */     // GIR_Coverage, 10788,
     /*  683649 */     GIR_EraseRootFromParent_Done,
     /*  683650 */   // Label 10867: @683650
     /*  683650 */   GIM_Try, /*On fail goto*//*Label 10868*/ GIMT_Encode4(683725), // Rule ID 10789 //
     /*  683655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  683666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  683669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  683672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683701 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  683704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683723 */     GIR_RootConstrainSelectedInstOperands,
     /*  683724 */     // GIR_Coverage, 10789,
     /*  683724 */     GIR_EraseRootFromParent_Done,
     /*  683725 */   // Label 10868: @683725
     /*  683725 */   GIM_Try, /*On fail goto*//*Label 10869*/ GIMT_Encode4(683800), // Rule ID 10792 //
     /*  683730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  683741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  683744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  683747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  683779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683798 */     GIR_RootConstrainSelectedInstOperands,
     /*  683799 */     // GIR_Coverage, 10792,
     /*  683799 */     GIR_EraseRootFromParent_Done,
     /*  683800 */   // Label 10869: @683800
     /*  683800 */   GIM_Try, /*On fail goto*//*Label 10870*/ GIMT_Encode4(683875), // Rule ID 10793 //
     /*  683805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  683816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  683819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  683822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683851 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  683854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683873 */     GIR_RootConstrainSelectedInstOperands,
     /*  683874 */     // GIR_Coverage, 10793,
     /*  683874 */     GIR_EraseRootFromParent_Done,
     /*  683875 */   // Label 10870: @683875
     /*  683875 */   GIM_Try, /*On fail goto*//*Label 10871*/ GIMT_Encode4(683950), // Rule ID 10796 //
     /*  683880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  683891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  683894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  683897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  683900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683926 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  683929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683948 */     GIR_RootConstrainSelectedInstOperands,
     /*  683949 */     // GIR_Coverage, 10796,
     /*  683949 */     GIR_EraseRootFromParent_Done,
     /*  683950 */   // Label 10871: @683950
     /*  683950 */   GIM_Try, /*On fail goto*//*Label 10872*/ GIMT_Encode4(684025), // Rule ID 10797 //
     /*  683955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  683966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  683969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  683972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  683975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684001 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  684004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684023 */     GIR_RootConstrainSelectedInstOperands,
     /*  684024 */     // GIR_Coverage, 10797,
     /*  684024 */     GIR_EraseRootFromParent_Done,
     /*  684025 */   // Label 10872: @684025
     /*  684025 */   GIM_Try, /*On fail goto*//*Label 10873*/ GIMT_Encode4(684100), // Rule ID 10800 //
     /*  684030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  684041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  684044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  684047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  684050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684076 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  684079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684098 */     GIR_RootConstrainSelectedInstOperands,
     /*  684099 */     // GIR_Coverage, 10800,
     /*  684099 */     GIR_EraseRootFromParent_Done,
     /*  684100 */   // Label 10873: @684100
     /*  684100 */   GIM_Try, /*On fail goto*//*Label 10874*/ GIMT_Encode4(684175), // Rule ID 10801 //
     /*  684105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  684116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  684119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  684122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  684125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684151 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  684154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684173 */     GIR_RootConstrainSelectedInstOperands,
     /*  684174 */     // GIR_Coverage, 10801,
     /*  684174 */     GIR_EraseRootFromParent_Done,
     /*  684175 */   // Label 10874: @684175
     /*  684175 */   GIM_Try, /*On fail goto*//*Label 10875*/ GIMT_Encode4(684250), // Rule ID 10804 //
     /*  684180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  684191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  684194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  684197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  684200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684226 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684248 */     GIR_RootConstrainSelectedInstOperands,
     /*  684249 */     // GIR_Coverage, 10804,
     /*  684249 */     GIR_EraseRootFromParent_Done,
     /*  684250 */   // Label 10875: @684250
     /*  684250 */   GIM_Try, /*On fail goto*//*Label 10876*/ GIMT_Encode4(684325), // Rule ID 10805 //
     /*  684255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  684266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  684269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  684272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  684275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684301 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684323 */     GIR_RootConstrainSelectedInstOperands,
     /*  684324 */     // GIR_Coverage, 10805,
     /*  684324 */     GIR_EraseRootFromParent_Done,
     /*  684325 */   // Label 10876: @684325
     /*  684325 */   GIM_Try, /*On fail goto*//*Label 10877*/ GIMT_Encode4(684400), // Rule ID 10808 //
     /*  684330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  684341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  684344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  684347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  684350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  684379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684398 */     GIR_RootConstrainSelectedInstOperands,
     /*  684399 */     // GIR_Coverage, 10808,
     /*  684399 */     GIR_EraseRootFromParent_Done,
     /*  684400 */   // Label 10877: @684400
     /*  684400 */   GIM_Try, /*On fail goto*//*Label 10878*/ GIMT_Encode4(684475), // Rule ID 10809 //
     /*  684405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  684416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  684419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  684422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  684425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684451 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  684454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684473 */     GIR_RootConstrainSelectedInstOperands,
     /*  684474 */     // GIR_Coverage, 10809,
     /*  684474 */     GIR_EraseRootFromParent_Done,
     /*  684475 */   // Label 10878: @684475
     /*  684475 */   GIM_Try, /*On fail goto*//*Label 10879*/ GIMT_Encode4(684550), // Rule ID 10812 //
     /*  684480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  684491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  684494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  684497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  684500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684526 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684548 */     GIR_RootConstrainSelectedInstOperands,
     /*  684549 */     // GIR_Coverage, 10812,
     /*  684549 */     GIR_EraseRootFromParent_Done,
     /*  684550 */   // Label 10879: @684550
     /*  684550 */   GIM_Try, /*On fail goto*//*Label 10880*/ GIMT_Encode4(684625), // Rule ID 10813 //
     /*  684555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  684566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  684569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  684572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  684575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684601 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684623 */     GIR_RootConstrainSelectedInstOperands,
     /*  684624 */     // GIR_Coverage, 10813,
     /*  684624 */     GIR_EraseRootFromParent_Done,
     /*  684625 */   // Label 10880: @684625
     /*  684625 */   GIM_Try, /*On fail goto*//*Label 10881*/ GIMT_Encode4(684700), // Rule ID 10816 //
     /*  684630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  684641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  684644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  684647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  684650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684676 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  684676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684698 */     GIR_RootConstrainSelectedInstOperands,
     /*  684699 */     // GIR_Coverage, 10816,
     /*  684699 */     GIR_EraseRootFromParent_Done,
     /*  684700 */   // Label 10881: @684700
     /*  684700 */   GIM_Try, /*On fail goto*//*Label 10882*/ GIMT_Encode4(684775), // Rule ID 10817 //
     /*  684705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  684716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  684719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  684722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  684725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684751 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  684751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684773 */     GIR_RootConstrainSelectedInstOperands,
     /*  684774 */     // GIR_Coverage, 10817,
     /*  684774 */     GIR_EraseRootFromParent_Done,
     /*  684775 */   // Label 10882: @684775
     /*  684775 */   GIM_Try, /*On fail goto*//*Label 10883*/ GIMT_Encode4(684850), // Rule ID 10820 //
     /*  684780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  684791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  684794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  684797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  684800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684848 */     GIR_RootConstrainSelectedInstOperands,
     /*  684849 */     // GIR_Coverage, 10820,
     /*  684849 */     GIR_EraseRootFromParent_Done,
     /*  684850 */   // Label 10883: @684850
     /*  684850 */   GIM_Try, /*On fail goto*//*Label 10884*/ GIMT_Encode4(684925), // Rule ID 10821 //
     /*  684855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  684866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  684869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  684872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  684875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684901 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684923 */     GIR_RootConstrainSelectedInstOperands,
     /*  684924 */     // GIR_Coverage, 10821,
     /*  684924 */     GIR_EraseRootFromParent_Done,
     /*  684925 */   // Label 10884: @684925
     /*  684925 */   GIM_Try, /*On fail goto*//*Label 10885*/ GIMT_Encode4(685000), // Rule ID 10824 //
     /*  684930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  684941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  684944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  684947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  684950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684998 */     GIR_RootConstrainSelectedInstOperands,
     /*  684999 */     // GIR_Coverage, 10824,
     /*  684999 */     GIR_EraseRootFromParent_Done,
     /*  685000 */   // Label 10885: @685000
     /*  685000 */   GIM_Try, /*On fail goto*//*Label 10886*/ GIMT_Encode4(685075), // Rule ID 10825 //
     /*  685005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  685016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  685019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  685022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  685025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685051 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  685054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685073 */     GIR_RootConstrainSelectedInstOperands,
     /*  685074 */     // GIR_Coverage, 10825,
     /*  685074 */     GIR_EraseRootFromParent_Done,
     /*  685075 */   // Label 10886: @685075
     /*  685075 */   GIM_Try, /*On fail goto*//*Label 10887*/ GIMT_Encode4(685150), // Rule ID 10828 //
     /*  685080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  685091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  685094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  685097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  685100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685126 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  685126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  685129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685148 */     GIR_RootConstrainSelectedInstOperands,
     /*  685149 */     // GIR_Coverage, 10828,
     /*  685149 */     GIR_EraseRootFromParent_Done,
     /*  685150 */   // Label 10887: @685150
     /*  685150 */   GIM_Try, /*On fail goto*//*Label 10888*/ GIMT_Encode4(685225), // Rule ID 10829 //
     /*  685155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  685166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  685169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  685172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  685175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685201 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  685201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  685204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685223 */     GIR_RootConstrainSelectedInstOperands,
     /*  685224 */     // GIR_Coverage, 10829,
     /*  685224 */     GIR_EraseRootFromParent_Done,
     /*  685225 */   // Label 10888: @685225
     /*  685225 */   GIM_Try, /*On fail goto*//*Label 10889*/ GIMT_Encode4(685300), // Rule ID 10832 //
     /*  685230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  685233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  685241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  685244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  685247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  685250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  685276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  685279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685298 */     GIR_RootConstrainSelectedInstOperands,
     /*  685299 */     // GIR_Coverage, 10832,
     /*  685299 */     GIR_EraseRootFromParent_Done,
     /*  685300 */   // Label 10889: @685300
     /*  685300 */   GIM_Try, /*On fail goto*//*Label 10890*/ GIMT_Encode4(685375), // Rule ID 10833 //
     /*  685305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  685308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  685316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  685319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  685322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  685325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685351 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  685351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  685354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685373 */     GIR_RootConstrainSelectedInstOperands,
     /*  685374 */     // GIR_Coverage, 10833,
     /*  685374 */     GIR_EraseRootFromParent_Done,
     /*  685375 */   // Label 10890: @685375
     /*  685375 */   GIM_Try, /*On fail goto*//*Label 10891*/ GIMT_Encode4(685450), // Rule ID 10836 //
     /*  685380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  685391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  685394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  685397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  685400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685426 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685448 */     GIR_RootConstrainSelectedInstOperands,
     /*  685449 */     // GIR_Coverage, 10836,
     /*  685449 */     GIR_EraseRootFromParent_Done,
     /*  685450 */   // Label 10891: @685450
     /*  685450 */   GIM_Try, /*On fail goto*//*Label 10892*/ GIMT_Encode4(685525), // Rule ID 10837 //
     /*  685455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  685466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  685469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  685472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  685475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685501 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685523 */     GIR_RootConstrainSelectedInstOperands,
     /*  685524 */     // GIR_Coverage, 10837,
     /*  685524 */     GIR_EraseRootFromParent_Done,
     /*  685525 */   // Label 10892: @685525
     /*  685525 */   GIM_Try, /*On fail goto*//*Label 10893*/ GIMT_Encode4(685600), // Rule ID 10840 //
     /*  685530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  685541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  685544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  685547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  685550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685576 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685598 */     GIR_RootConstrainSelectedInstOperands,
     /*  685599 */     // GIR_Coverage, 10840,
     /*  685599 */     GIR_EraseRootFromParent_Done,
     /*  685600 */   // Label 10893: @685600
     /*  685600 */   GIM_Try, /*On fail goto*//*Label 10894*/ GIMT_Encode4(685675), // Rule ID 10841 //
     /*  685605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  685616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  685619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  685622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  685625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685651 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685673 */     GIR_RootConstrainSelectedInstOperands,
     /*  685674 */     // GIR_Coverage, 10841,
     /*  685674 */     GIR_EraseRootFromParent_Done,
     /*  685675 */   // Label 10894: @685675
     /*  685675 */   GIM_Try, /*On fail goto*//*Label 10895*/ GIMT_Encode4(685750), // Rule ID 10844 //
     /*  685680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  685691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  685694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  685697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  685700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685726 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685748 */     GIR_RootConstrainSelectedInstOperands,
     /*  685749 */     // GIR_Coverage, 10844,
     /*  685749 */     GIR_EraseRootFromParent_Done,
     /*  685750 */   // Label 10895: @685750
     /*  685750 */   GIM_Try, /*On fail goto*//*Label 10896*/ GIMT_Encode4(685825), // Rule ID 10845 //
     /*  685755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  685766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  685769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  685772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  685775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685801 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685823 */     GIR_RootConstrainSelectedInstOperands,
     /*  685824 */     // GIR_Coverage, 10845,
     /*  685824 */     GIR_EraseRootFromParent_Done,
     /*  685825 */   // Label 10896: @685825
     /*  685825 */   GIM_Try, /*On fail goto*//*Label 10897*/ GIMT_Encode4(685900), // Rule ID 10848 //
     /*  685830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  685841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  685844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  685847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  685850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685898 */     GIR_RootConstrainSelectedInstOperands,
     /*  685899 */     // GIR_Coverage, 10848,
     /*  685899 */     GIR_EraseRootFromParent_Done,
     /*  685900 */   // Label 10897: @685900
     /*  685900 */   GIM_Try, /*On fail goto*//*Label 10898*/ GIMT_Encode4(685975), // Rule ID 10849 //
     /*  685905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  685916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  685919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  685922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  685925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685951 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685973 */     GIR_RootConstrainSelectedInstOperands,
     /*  685974 */     // GIR_Coverage, 10849,
     /*  685974 */     GIR_EraseRootFromParent_Done,
     /*  685975 */   // Label 10898: @685975
     /*  685975 */   GIM_Try, /*On fail goto*//*Label 10899*/ GIMT_Encode4(686050), // Rule ID 10852 //
     /*  685980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  685991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  685994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  685997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  686000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  686026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686048 */     GIR_RootConstrainSelectedInstOperands,
     /*  686049 */     // GIR_Coverage, 10852,
     /*  686049 */     GIR_EraseRootFromParent_Done,
     /*  686050 */   // Label 10899: @686050
     /*  686050 */   GIM_Try, /*On fail goto*//*Label 10900*/ GIMT_Encode4(686125), // Rule ID 10853 //
     /*  686055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  686066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  686069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  686072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  686075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686101 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686123 */     GIR_RootConstrainSelectedInstOperands,
     /*  686124 */     // GIR_Coverage, 10853,
     /*  686124 */     GIR_EraseRootFromParent_Done,
     /*  686125 */   // Label 10900: @686125
     /*  686125 */   GIM_Try, /*On fail goto*//*Label 10901*/ GIMT_Encode4(686200), // Rule ID 10856 //
     /*  686130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  686141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  686144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  686147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  686150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686176 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  686176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686198 */     GIR_RootConstrainSelectedInstOperands,
     /*  686199 */     // GIR_Coverage, 10856,
     /*  686199 */     GIR_EraseRootFromParent_Done,
     /*  686200 */   // Label 10901: @686200
     /*  686200 */   GIM_Try, /*On fail goto*//*Label 10902*/ GIMT_Encode4(686275), // Rule ID 10857 //
     /*  686205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  686216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  686219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  686222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  686225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686251 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686273 */     GIR_RootConstrainSelectedInstOperands,
     /*  686274 */     // GIR_Coverage, 10857,
     /*  686274 */     GIR_EraseRootFromParent_Done,
     /*  686275 */   // Label 10902: @686275
     /*  686275 */   GIM_Try, /*On fail goto*//*Label 10903*/ GIMT_Encode4(686350), // Rule ID 10860 //
     /*  686280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  686291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  686294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  686297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  686300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686326 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  686329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686348 */     GIR_RootConstrainSelectedInstOperands,
     /*  686349 */     // GIR_Coverage, 10860,
     /*  686349 */     GIR_EraseRootFromParent_Done,
     /*  686350 */   // Label 10903: @686350
     /*  686350 */   GIM_Try, /*On fail goto*//*Label 10904*/ GIMT_Encode4(686425), // Rule ID 10861 //
     /*  686355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  686366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  686369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  686372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  686375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  686404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686423 */     GIR_RootConstrainSelectedInstOperands,
     /*  686424 */     // GIR_Coverage, 10861,
     /*  686424 */     GIR_EraseRootFromParent_Done,
     /*  686425 */   // Label 10904: @686425
     /*  686425 */   GIM_Try, /*On fail goto*//*Label 10905*/ GIMT_Encode4(686500), // Rule ID 10864 //
     /*  686430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  686441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  686444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  686447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  686450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686476 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686498 */     GIR_RootConstrainSelectedInstOperands,
     /*  686499 */     // GIR_Coverage, 10864,
     /*  686499 */     GIR_EraseRootFromParent_Done,
     /*  686500 */   // Label 10905: @686500
     /*  686500 */   GIM_Try, /*On fail goto*//*Label 10906*/ GIMT_Encode4(686575), // Rule ID 10865 //
     /*  686505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  686516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  686519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  686522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  686525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686573 */     GIR_RootConstrainSelectedInstOperands,
     /*  686574 */     // GIR_Coverage, 10865,
     /*  686574 */     GIR_EraseRootFromParent_Done,
     /*  686575 */   // Label 10906: @686575
     /*  686575 */   GIM_Try, /*On fail goto*//*Label 10907*/ GIMT_Encode4(686650), // Rule ID 10868 //
     /*  686580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  686591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  686594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  686597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  686600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686648 */     GIR_RootConstrainSelectedInstOperands,
     /*  686649 */     // GIR_Coverage, 10868,
     /*  686649 */     GIR_EraseRootFromParent_Done,
     /*  686650 */   // Label 10907: @686650
     /*  686650 */   GIM_Try, /*On fail goto*//*Label 10908*/ GIMT_Encode4(686725), // Rule ID 10869 //
     /*  686655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  686666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  686669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  686672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  686675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686701 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686723 */     GIR_RootConstrainSelectedInstOperands,
     /*  686724 */     // GIR_Coverage, 10869,
     /*  686724 */     GIR_EraseRootFromParent_Done,
     /*  686725 */   // Label 10908: @686725
     /*  686725 */   GIM_Try, /*On fail goto*//*Label 10909*/ GIMT_Encode4(686800), // Rule ID 10872 //
     /*  686730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  686741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  686744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  686747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  686750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  686779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686798 */     GIR_RootConstrainSelectedInstOperands,
     /*  686799 */     // GIR_Coverage, 10872,
     /*  686799 */     GIR_EraseRootFromParent_Done,
     /*  686800 */   // Label 10909: @686800
     /*  686800 */   GIM_Try, /*On fail goto*//*Label 10910*/ GIMT_Encode4(686875), // Rule ID 10873 //
     /*  686805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  686816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  686819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  686822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  686825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686851 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  686854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686873 */     GIR_RootConstrainSelectedInstOperands,
     /*  686874 */     // GIR_Coverage, 10873,
     /*  686874 */     GIR_EraseRootFromParent_Done,
     /*  686875 */   // Label 10910: @686875
     /*  686875 */   GIM_Try, /*On fail goto*//*Label 10911*/ GIMT_Encode4(686950), // Rule ID 10876 //
     /*  686880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  686891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  686894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  686897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  686900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686926 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686948 */     GIR_RootConstrainSelectedInstOperands,
     /*  686949 */     // GIR_Coverage, 10876,
     /*  686949 */     GIR_EraseRootFromParent_Done,
     /*  686950 */   // Label 10911: @686950
     /*  686950 */   GIM_Try, /*On fail goto*//*Label 10912*/ GIMT_Encode4(687025), // Rule ID 10877 //
     /*  686955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  686966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  686969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  686972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  686975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687001 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  687001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  687004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687023 */     GIR_RootConstrainSelectedInstOperands,
     /*  687024 */     // GIR_Coverage, 10877,
     /*  687024 */     GIR_EraseRootFromParent_Done,
     /*  687025 */   // Label 10912: @687025
     /*  687025 */   GIM_Try, /*On fail goto*//*Label 10913*/ GIMT_Encode4(687100), // Rule ID 10880 //
     /*  687030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  687033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  687041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  687044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  687047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  687050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687076 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  687076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  687079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687098 */     GIR_RootConstrainSelectedInstOperands,
     /*  687099 */     // GIR_Coverage, 10880,
     /*  687099 */     GIR_EraseRootFromParent_Done,
     /*  687100 */   // Label 10913: @687100
     /*  687100 */   GIM_Try, /*On fail goto*//*Label 10914*/ GIMT_Encode4(687175), // Rule ID 10881 //
     /*  687105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  687108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  687116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  687119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  687122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  687125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687151 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  687151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  687154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687173 */     GIR_RootConstrainSelectedInstOperands,
     /*  687174 */     // GIR_Coverage, 10881,
     /*  687174 */     GIR_EraseRootFromParent_Done,
     /*  687175 */   // Label 10914: @687175
     /*  687175 */   GIM_Try, /*On fail goto*//*Label 10915*/ GIMT_Encode4(687250), // Rule ID 10884 //
     /*  687180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  687191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  687194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  687197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687226 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  687229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687248 */     GIR_RootConstrainSelectedInstOperands,
     /*  687249 */     // GIR_Coverage, 10884,
     /*  687249 */     GIR_EraseRootFromParent_Done,
     /*  687250 */   // Label 10915: @687250
     /*  687250 */   GIM_Try, /*On fail goto*//*Label 10916*/ GIMT_Encode4(687325), // Rule ID 10885 //
     /*  687255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  687266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  687269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  687272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687301 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  687304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687323 */     GIR_RootConstrainSelectedInstOperands,
     /*  687324 */     // GIR_Coverage, 10885,
     /*  687324 */     GIR_EraseRootFromParent_Done,
     /*  687325 */   // Label 10916: @687325
     /*  687325 */   GIM_Try, /*On fail goto*//*Label 10917*/ GIMT_Encode4(687400), // Rule ID 10888 //
     /*  687330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  687341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  687344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  687347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  687379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687398 */     GIR_RootConstrainSelectedInstOperands,
     /*  687399 */     // GIR_Coverage, 10888,
     /*  687399 */     GIR_EraseRootFromParent_Done,
     /*  687400 */   // Label 10917: @687400
     /*  687400 */   GIM_Try, /*On fail goto*//*Label 10918*/ GIMT_Encode4(687475), // Rule ID 10889 //
     /*  687405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  687416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  687419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  687422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687451 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  687454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687473 */     GIR_RootConstrainSelectedInstOperands,
     /*  687474 */     // GIR_Coverage, 10889,
     /*  687474 */     GIR_EraseRootFromParent_Done,
     /*  687475 */   // Label 10918: @687475
     /*  687475 */   GIM_Try, /*On fail goto*//*Label 10919*/ GIMT_Encode4(687550), // Rule ID 10892 //
     /*  687480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  687491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  687494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  687497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687526 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687548 */     GIR_RootConstrainSelectedInstOperands,
     /*  687549 */     // GIR_Coverage, 10892,
     /*  687549 */     GIR_EraseRootFromParent_Done,
     /*  687550 */   // Label 10919: @687550
     /*  687550 */   GIM_Try, /*On fail goto*//*Label 10920*/ GIMT_Encode4(687625), // Rule ID 10893 //
     /*  687555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  687566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  687569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  687572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687601 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687623 */     GIR_RootConstrainSelectedInstOperands,
     /*  687624 */     // GIR_Coverage, 10893,
     /*  687624 */     GIR_EraseRootFromParent_Done,
     /*  687625 */   // Label 10920: @687625
     /*  687625 */   GIM_Try, /*On fail goto*//*Label 10921*/ GIMT_Encode4(687700), // Rule ID 10896 //
     /*  687630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  687641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  687644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  687647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687676 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  687679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687698 */     GIR_RootConstrainSelectedInstOperands,
     /*  687699 */     // GIR_Coverage, 10896,
     /*  687699 */     GIR_EraseRootFromParent_Done,
     /*  687700 */   // Label 10921: @687700
     /*  687700 */   GIM_Try, /*On fail goto*//*Label 10922*/ GIMT_Encode4(687775), // Rule ID 10897 //
     /*  687705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  687716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  687719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  687722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687751 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  687754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687773 */     GIR_RootConstrainSelectedInstOperands,
     /*  687774 */     // GIR_Coverage, 10897,
     /*  687774 */     GIR_EraseRootFromParent_Done,
     /*  687775 */   // Label 10922: @687775
     /*  687775 */   GIM_Try, /*On fail goto*//*Label 10923*/ GIMT_Encode4(687850), // Rule ID 10900 //
     /*  687780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  687791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  687794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  687797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687848 */     GIR_RootConstrainSelectedInstOperands,
     /*  687849 */     // GIR_Coverage, 10900,
     /*  687849 */     GIR_EraseRootFromParent_Done,
     /*  687850 */   // Label 10923: @687850
     /*  687850 */   GIM_Try, /*On fail goto*//*Label 10924*/ GIMT_Encode4(687925), // Rule ID 10901 //
     /*  687855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  687866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  687869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  687872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687901 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687923 */     GIR_RootConstrainSelectedInstOperands,
     /*  687924 */     // GIR_Coverage, 10901,
     /*  687924 */     GIR_EraseRootFromParent_Done,
     /*  687925 */   // Label 10924: @687925
     /*  687925 */   GIM_Try, /*On fail goto*//*Label 10925*/ GIMT_Encode4(688000), // Rule ID 10904 //
     /*  687930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  687941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  687944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  687947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687976 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  687976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687998 */     GIR_RootConstrainSelectedInstOperands,
     /*  687999 */     // GIR_Coverage, 10904,
     /*  687999 */     GIR_EraseRootFromParent_Done,
     /*  688000 */   // Label 10925: @688000
     /*  688000 */   GIM_Try, /*On fail goto*//*Label 10926*/ GIMT_Encode4(688075), // Rule ID 10905 //
     /*  688005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  688016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  688019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  688022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688051 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  688054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688073 */     GIR_RootConstrainSelectedInstOperands,
     /*  688074 */     // GIR_Coverage, 10905,
     /*  688074 */     GIR_EraseRootFromParent_Done,
     /*  688075 */   // Label 10926: @688075
     /*  688075 */   GIM_Try, /*On fail goto*//*Label 10927*/ GIMT_Encode4(688150), // Rule ID 10908 //
     /*  688080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  688091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  688094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  688097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688126 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688148 */     GIR_RootConstrainSelectedInstOperands,
     /*  688149 */     // GIR_Coverage, 10908,
     /*  688149 */     GIR_EraseRootFromParent_Done,
     /*  688150 */   // Label 10927: @688150
     /*  688150 */   GIM_Try, /*On fail goto*//*Label 10928*/ GIMT_Encode4(688225), // Rule ID 10909 //
     /*  688155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  688166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  688169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  688172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688201 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688223 */     GIR_RootConstrainSelectedInstOperands,
     /*  688224 */     // GIR_Coverage, 10909,
     /*  688224 */     GIR_EraseRootFromParent_Done,
     /*  688225 */   // Label 10928: @688225
     /*  688225 */   GIM_Try, /*On fail goto*//*Label 10929*/ GIMT_Encode4(688300), // Rule ID 10912 //
     /*  688230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  688241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  688244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  688247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688298 */     GIR_RootConstrainSelectedInstOperands,
     /*  688299 */     // GIR_Coverage, 10912,
     /*  688299 */     GIR_EraseRootFromParent_Done,
     /*  688300 */   // Label 10929: @688300
     /*  688300 */   GIM_Try, /*On fail goto*//*Label 10930*/ GIMT_Encode4(688375), // Rule ID 10913 //
     /*  688305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  688316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  688319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  688322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688351 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688373 */     GIR_RootConstrainSelectedInstOperands,
     /*  688374 */     // GIR_Coverage, 10913,
     /*  688374 */     GIR_EraseRootFromParent_Done,
     /*  688375 */   // Label 10930: @688375
     /*  688375 */   GIM_Try, /*On fail goto*//*Label 10931*/ GIMT_Encode4(688450), // Rule ID 10916 //
     /*  688380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  688391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  688394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  688397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688426 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  688426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688448 */     GIR_RootConstrainSelectedInstOperands,
     /*  688449 */     // GIR_Coverage, 10916,
     /*  688449 */     GIR_EraseRootFromParent_Done,
     /*  688450 */   // Label 10931: @688450
     /*  688450 */   GIM_Try, /*On fail goto*//*Label 10932*/ GIMT_Encode4(688525), // Rule ID 10917 //
     /*  688455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  688466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  688469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  688472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688501 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688523 */     GIR_RootConstrainSelectedInstOperands,
     /*  688524 */     // GIR_Coverage, 10917,
     /*  688524 */     GIR_EraseRootFromParent_Done,
     /*  688525 */   // Label 10932: @688525
     /*  688525 */   GIM_Try, /*On fail goto*//*Label 10933*/ GIMT_Encode4(688600), // Rule ID 10920 //
     /*  688530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  688533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  688541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  688544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  688547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  688576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688598 */     GIR_RootConstrainSelectedInstOperands,
     /*  688599 */     // GIR_Coverage, 10920,
     /*  688599 */     GIR_EraseRootFromParent_Done,
     /*  688600 */   // Label 10933: @688600
     /*  688600 */   GIM_Try, /*On fail goto*//*Label 10934*/ GIMT_Encode4(688675), // Rule ID 10921 //
     /*  688605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  688608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  688616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  688619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  688622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688651 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  688651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688673 */     GIR_RootConstrainSelectedInstOperands,
     /*  688674 */     // GIR_Coverage, 10921,
     /*  688674 */     GIR_EraseRootFromParent_Done,
     /*  688675 */   // Label 10934: @688675
     /*  688675 */   GIM_Try, /*On fail goto*//*Label 10935*/ GIMT_Encode4(688750), // Rule ID 10924 //
     /*  688680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  688691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  688694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  688697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688748 */     GIR_RootConstrainSelectedInstOperands,
     /*  688749 */     // GIR_Coverage, 10924,
     /*  688749 */     GIR_EraseRootFromParent_Done,
     /*  688750 */   // Label 10935: @688750
     /*  688750 */   GIM_Try, /*On fail goto*//*Label 10936*/ GIMT_Encode4(688825), // Rule ID 10925 //
     /*  688755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  688766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  688769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  688772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688801 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688823 */     GIR_RootConstrainSelectedInstOperands,
     /*  688824 */     // GIR_Coverage, 10925,
     /*  688824 */     GIR_EraseRootFromParent_Done,
     /*  688825 */   // Label 10936: @688825
     /*  688825 */   GIM_Try, /*On fail goto*//*Label 10937*/ GIMT_Encode4(688900), // Rule ID 10928 //
     /*  688830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  688841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  688844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  688847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688876 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688898 */     GIR_RootConstrainSelectedInstOperands,
     /*  688899 */     // GIR_Coverage, 10928,
     /*  688899 */     GIR_EraseRootFromParent_Done,
     /*  688900 */   // Label 10937: @688900
     /*  688900 */   GIM_Try, /*On fail goto*//*Label 10938*/ GIMT_Encode4(688975), // Rule ID 10929 //
     /*  688905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  688916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  688919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  688922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688951 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688973 */     GIR_RootConstrainSelectedInstOperands,
     /*  688974 */     // GIR_Coverage, 10929,
     /*  688974 */     GIR_EraseRootFromParent_Done,
     /*  688975 */   // Label 10938: @688975
     /*  688975 */   GIM_Try, /*On fail goto*//*Label 10939*/ GIMT_Encode4(689050), // Rule ID 10932 //
     /*  688980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  688991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  688994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  688997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689026 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  689026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689048 */     GIR_RootConstrainSelectedInstOperands,
     /*  689049 */     // GIR_Coverage, 10932,
     /*  689049 */     GIR_EraseRootFromParent_Done,
     /*  689050 */   // Label 10939: @689050
     /*  689050 */   GIM_Try, /*On fail goto*//*Label 10940*/ GIMT_Encode4(689125), // Rule ID 10933 //
     /*  689055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  689066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  689069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  689072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689101 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  689101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689123 */     GIR_RootConstrainSelectedInstOperands,
     /*  689124 */     // GIR_Coverage, 10933,
     /*  689124 */     GIR_EraseRootFromParent_Done,
     /*  689125 */   // Label 10940: @689125
     /*  689125 */   GIM_Try, /*On fail goto*//*Label 10941*/ GIMT_Encode4(689200), // Rule ID 10936 //
     /*  689130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  689141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  689144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  689147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689176 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689198 */     GIR_RootConstrainSelectedInstOperands,
     /*  689199 */     // GIR_Coverage, 10936,
     /*  689199 */     GIR_EraseRootFromParent_Done,
     /*  689200 */   // Label 10941: @689200
     /*  689200 */   GIM_Try, /*On fail goto*//*Label 10942*/ GIMT_Encode4(689275), // Rule ID 10937 //
     /*  689205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  689216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  689219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  689222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689251 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689273 */     GIR_RootConstrainSelectedInstOperands,
     /*  689274 */     // GIR_Coverage, 10937,
     /*  689274 */     GIR_EraseRootFromParent_Done,
     /*  689275 */   // Label 10942: @689275
     /*  689275 */   GIM_Try, /*On fail goto*//*Label 10943*/ GIMT_Encode4(689350), // Rule ID 10940 //
     /*  689280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  689291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  689294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  689297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689326 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689348 */     GIR_RootConstrainSelectedInstOperands,
     /*  689349 */     // GIR_Coverage, 10940,
     /*  689349 */     GIR_EraseRootFromParent_Done,
     /*  689350 */   // Label 10943: @689350
     /*  689350 */   GIM_Try, /*On fail goto*//*Label 10944*/ GIMT_Encode4(689425), // Rule ID 10941 //
     /*  689355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  689366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  689369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  689372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689401 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689423 */     GIR_RootConstrainSelectedInstOperands,
     /*  689424 */     // GIR_Coverage, 10941,
     /*  689424 */     GIR_EraseRootFromParent_Done,
     /*  689425 */   // Label 10944: @689425
     /*  689425 */   GIM_Try, /*On fail goto*//*Label 10945*/ GIMT_Encode4(689500), // Rule ID 10944 //
     /*  689430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  689441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  689444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  689447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689476 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689498 */     GIR_RootConstrainSelectedInstOperands,
     /*  689499 */     // GIR_Coverage, 10944,
     /*  689499 */     GIR_EraseRootFromParent_Done,
     /*  689500 */   // Label 10945: @689500
     /*  689500 */   GIM_Try, /*On fail goto*//*Label 10946*/ GIMT_Encode4(689575), // Rule ID 10945 //
     /*  689505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  689516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  689519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  689522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689551 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689573 */     GIR_RootConstrainSelectedInstOperands,
     /*  689574 */     // GIR_Coverage, 10945,
     /*  689574 */     GIR_EraseRootFromParent_Done,
     /*  689575 */   // Label 10946: @689575
     /*  689575 */   GIM_Try, /*On fail goto*//*Label 10947*/ GIMT_Encode4(689650), // Rule ID 10948 //
     /*  689580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  689591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  689594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  689597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689648 */     GIR_RootConstrainSelectedInstOperands,
     /*  689649 */     // GIR_Coverage, 10948,
     /*  689649 */     GIR_EraseRootFromParent_Done,
     /*  689650 */   // Label 10947: @689650
     /*  689650 */   GIM_Try, /*On fail goto*//*Label 10948*/ GIMT_Encode4(689725), // Rule ID 10949 //
     /*  689655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  689666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  689669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  689672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689701 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689723 */     GIR_RootConstrainSelectedInstOperands,
     /*  689724 */     // GIR_Coverage, 10949,
     /*  689724 */     GIR_EraseRootFromParent_Done,
     /*  689725 */   // Label 10948: @689725
     /*  689725 */   GIM_Try, /*On fail goto*//*Label 10949*/ GIMT_Encode4(689800), // Rule ID 10952 //
     /*  689730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  689741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  689744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  689747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689798 */     GIR_RootConstrainSelectedInstOperands,
     /*  689799 */     // GIR_Coverage, 10952,
     /*  689799 */     GIR_EraseRootFromParent_Done,
     /*  689800 */   // Label 10949: @689800
     /*  689800 */   GIM_Try, /*On fail goto*//*Label 10950*/ GIMT_Encode4(689875), // Rule ID 10953 //
     /*  689805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  689816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  689819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  689822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689851 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689873 */     GIR_RootConstrainSelectedInstOperands,
     /*  689874 */     // GIR_Coverage, 10953,
     /*  689874 */     GIR_EraseRootFromParent_Done,
     /*  689875 */   // Label 10950: @689875
     /*  689875 */   GIM_Try, /*On fail goto*//*Label 10951*/ GIMT_Encode4(689950), // Rule ID 10956 //
     /*  689880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  689891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  689894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  689897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689926 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689948 */     GIR_RootConstrainSelectedInstOperands,
     /*  689949 */     // GIR_Coverage, 10956,
     /*  689949 */     GIR_EraseRootFromParent_Done,
     /*  689950 */   // Label 10951: @689950
     /*  689950 */   GIM_Try, /*On fail goto*//*Label 10952*/ GIMT_Encode4(690025), // Rule ID 10957 //
     /*  689955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  689966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  689969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  689972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690001 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  690001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  690004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690023 */     GIR_RootConstrainSelectedInstOperands,
     /*  690024 */     // GIR_Coverage, 10957,
     /*  690024 */     GIR_EraseRootFromParent_Done,
     /*  690025 */   // Label 10952: @690025
     /*  690025 */   GIM_Try, /*On fail goto*//*Label 10953*/ GIMT_Encode4(690100), // Rule ID 10960 //
     /*  690030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  690041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  690044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  690047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  690050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  690079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690098 */     GIR_RootConstrainSelectedInstOperands,
     /*  690099 */     // GIR_Coverage, 10960,
     /*  690099 */     GIR_EraseRootFromParent_Done,
     /*  690100 */   // Label 10953: @690100
     /*  690100 */   GIM_Try, /*On fail goto*//*Label 10954*/ GIMT_Encode4(690175), // Rule ID 10961 //
     /*  690105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  690116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  690119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  690122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  690125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690151 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  690154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690173 */     GIR_RootConstrainSelectedInstOperands,
     /*  690174 */     // GIR_Coverage, 10961,
     /*  690174 */     GIR_EraseRootFromParent_Done,
     /*  690175 */   // Label 10954: @690175
     /*  690175 */   GIM_Try, /*On fail goto*//*Label 10955*/ GIMT_Encode4(690250), // Rule ID 10964 //
     /*  690180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  690191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  690194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  690197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  690200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690226 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  690229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690248 */     GIR_RootConstrainSelectedInstOperands,
     /*  690249 */     // GIR_Coverage, 10964,
     /*  690249 */     GIR_EraseRootFromParent_Done,
     /*  690250 */   // Label 10955: @690250
     /*  690250 */   GIM_Try, /*On fail goto*//*Label 10956*/ GIMT_Encode4(690325), // Rule ID 10965 //
     /*  690255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  690266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  690269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  690272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  690275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690301 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  690304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690323 */     GIR_RootConstrainSelectedInstOperands,
     /*  690324 */     // GIR_Coverage, 10965,
     /*  690324 */     GIR_EraseRootFromParent_Done,
     /*  690325 */   // Label 10956: @690325
     /*  690325 */   GIM_Try, /*On fail goto*//*Label 10957*/ GIMT_Encode4(690400), // Rule ID 10968 //
     /*  690330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  690341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  690344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  690347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  690350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690376 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  690379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690398 */     GIR_RootConstrainSelectedInstOperands,
     /*  690399 */     // GIR_Coverage, 10968,
     /*  690399 */     GIR_EraseRootFromParent_Done,
     /*  690400 */   // Label 10957: @690400
     /*  690400 */   GIM_Try, /*On fail goto*//*Label 10958*/ GIMT_Encode4(690475), // Rule ID 10969 //
     /*  690405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  690416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  690419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  690422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  690425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690451 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  690454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690473 */     GIR_RootConstrainSelectedInstOperands,
     /*  690474 */     // GIR_Coverage, 10969,
     /*  690474 */     GIR_EraseRootFromParent_Done,
     /*  690475 */   // Label 10958: @690475
     /*  690475 */   GIM_Try, /*On fail goto*//*Label 10959*/ GIMT_Encode4(690550), // Rule ID 10972 //
     /*  690480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  690491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  690494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  690497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  690500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690526 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  690529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690548 */     GIR_RootConstrainSelectedInstOperands,
     /*  690549 */     // GIR_Coverage, 10972,
     /*  690549 */     GIR_EraseRootFromParent_Done,
     /*  690550 */   // Label 10959: @690550
     /*  690550 */   GIM_Try, /*On fail goto*//*Label 10960*/ GIMT_Encode4(690625), // Rule ID 10973 //
     /*  690555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  690566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  690569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  690572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  690575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690601 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  690604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690623 */     GIR_RootConstrainSelectedInstOperands,
     /*  690624 */     // GIR_Coverage, 10973,
     /*  690624 */     GIR_EraseRootFromParent_Done,
     /*  690625 */   // Label 10960: @690625
     /*  690625 */   GIM_Try, /*On fail goto*//*Label 10961*/ GIMT_Encode4(690700), // Rule ID 10976 //
     /*  690630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  690641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  690644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  690647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  690650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690676 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690698 */     GIR_RootConstrainSelectedInstOperands,
     /*  690699 */     // GIR_Coverage, 10976,
     /*  690699 */     GIR_EraseRootFromParent_Done,
     /*  690700 */   // Label 10961: @690700
     /*  690700 */   GIM_Try, /*On fail goto*//*Label 10962*/ GIMT_Encode4(690775), // Rule ID 10977 //
     /*  690705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  690716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  690719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  690722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  690725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690751 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690773 */     GIR_RootConstrainSelectedInstOperands,
     /*  690774 */     // GIR_Coverage, 10977,
     /*  690774 */     GIR_EraseRootFromParent_Done,
     /*  690775 */   // Label 10962: @690775
     /*  690775 */   GIM_Try, /*On fail goto*//*Label 10963*/ GIMT_Encode4(690850), // Rule ID 10980 //
     /*  690780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  690791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  690794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  690797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  690800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690826 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690848 */     GIR_RootConstrainSelectedInstOperands,
     /*  690849 */     // GIR_Coverage, 10980,
     /*  690849 */     GIR_EraseRootFromParent_Done,
     /*  690850 */   // Label 10963: @690850
     /*  690850 */   GIM_Try, /*On fail goto*//*Label 10964*/ GIMT_Encode4(690925), // Rule ID 10981 //
     /*  690855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  690866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  690869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  690872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  690875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690901 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690923 */     GIR_RootConstrainSelectedInstOperands,
     /*  690924 */     // GIR_Coverage, 10981,
     /*  690924 */     GIR_EraseRootFromParent_Done,
     /*  690925 */   // Label 10964: @690925
     /*  690925 */   GIM_Try, /*On fail goto*//*Label 10965*/ GIMT_Encode4(691000), // Rule ID 10984 //
     /*  690930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  690941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  690944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  690947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  690950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  690976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690998 */     GIR_RootConstrainSelectedInstOperands,
     /*  690999 */     // GIR_Coverage, 10984,
     /*  690999 */     GIR_EraseRootFromParent_Done,
     /*  691000 */   // Label 10965: @691000
     /*  691000 */   GIM_Try, /*On fail goto*//*Label 10966*/ GIMT_Encode4(691075), // Rule ID 10985 //
     /*  691005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  691016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  691019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  691022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  691025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691051 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  691054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691073 */     GIR_RootConstrainSelectedInstOperands,
     /*  691074 */     // GIR_Coverage, 10985,
     /*  691074 */     GIR_EraseRootFromParent_Done,
     /*  691075 */   // Label 10966: @691075
     /*  691075 */   GIM_Try, /*On fail goto*//*Label 10967*/ GIMT_Encode4(691150), // Rule ID 10988 //
     /*  691080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  691091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  691094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  691097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  691100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  691129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691148 */     GIR_RootConstrainSelectedInstOperands,
     /*  691149 */     // GIR_Coverage, 10988,
     /*  691149 */     GIR_EraseRootFromParent_Done,
     /*  691150 */   // Label 10967: @691150
     /*  691150 */   GIM_Try, /*On fail goto*//*Label 10968*/ GIMT_Encode4(691225), // Rule ID 10989 //
     /*  691155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  691166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  691169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  691172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  691175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691201 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  691204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691223 */     GIR_RootConstrainSelectedInstOperands,
     /*  691224 */     // GIR_Coverage, 10989,
     /*  691224 */     GIR_EraseRootFromParent_Done,
     /*  691225 */   // Label 10968: @691225
     /*  691225 */   GIM_Try, /*On fail goto*//*Label 10969*/ GIMT_Encode4(691300), // Rule ID 10992 //
     /*  691230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  691241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  691244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  691247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  691250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  691279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691298 */     GIR_RootConstrainSelectedInstOperands,
     /*  691299 */     // GIR_Coverage, 10992,
     /*  691299 */     GIR_EraseRootFromParent_Done,
     /*  691300 */   // Label 10969: @691300
     /*  691300 */   GIM_Try, /*On fail goto*//*Label 10970*/ GIMT_Encode4(691375), // Rule ID 10993 //
     /*  691305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  691316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  691319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  691322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  691325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691351 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  691351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  691354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691373 */     GIR_RootConstrainSelectedInstOperands,
     /*  691374 */     // GIR_Coverage, 10993,
     /*  691374 */     GIR_EraseRootFromParent_Done,
     /*  691375 */   // Label 10970: @691375
     /*  691375 */   GIM_Try, /*On fail goto*//*Label 10971*/ GIMT_Encode4(691450), // Rule ID 10996 //
     /*  691380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  691391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  691394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  691397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  691400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691448 */     GIR_RootConstrainSelectedInstOperands,
     /*  691449 */     // GIR_Coverage, 10996,
     /*  691449 */     GIR_EraseRootFromParent_Done,
     /*  691450 */   // Label 10971: @691450
     /*  691450 */   GIM_Try, /*On fail goto*//*Label 10972*/ GIMT_Encode4(691525), // Rule ID 10997 //
     /*  691455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  691466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  691469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  691472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  691475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691501 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691523 */     GIR_RootConstrainSelectedInstOperands,
     /*  691524 */     // GIR_Coverage, 10997,
     /*  691524 */     GIR_EraseRootFromParent_Done,
     /*  691525 */   // Label 10972: @691525
     /*  691525 */   GIM_Try, /*On fail goto*//*Label 10973*/ GIMT_Encode4(691600), // Rule ID 11000 //
     /*  691530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  691541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  691544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  691547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  691550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691598 */     GIR_RootConstrainSelectedInstOperands,
     /*  691599 */     // GIR_Coverage, 11000,
     /*  691599 */     GIR_EraseRootFromParent_Done,
     /*  691600 */   // Label 10973: @691600
     /*  691600 */   GIM_Try, /*On fail goto*//*Label 10974*/ GIMT_Encode4(691675), // Rule ID 11001 //
     /*  691605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  691616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  691619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  691622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  691625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691651 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691673 */     GIR_RootConstrainSelectedInstOperands,
     /*  691674 */     // GIR_Coverage, 11001,
     /*  691674 */     GIR_EraseRootFromParent_Done,
     /*  691675 */   // Label 10974: @691675
     /*  691675 */   GIM_Try, /*On fail goto*//*Label 10975*/ GIMT_Encode4(691750), // Rule ID 11004 //
     /*  691680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  691691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  691694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  691697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  691700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691748 */     GIR_RootConstrainSelectedInstOperands,
     /*  691749 */     // GIR_Coverage, 11004,
     /*  691749 */     GIR_EraseRootFromParent_Done,
     /*  691750 */   // Label 10975: @691750
     /*  691750 */   GIM_Try, /*On fail goto*//*Label 10976*/ GIMT_Encode4(691825), // Rule ID 11005 //
     /*  691755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  691766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  691769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  691772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  691775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691801 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  691801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691823 */     GIR_RootConstrainSelectedInstOperands,
     /*  691824 */     // GIR_Coverage, 11005,
     /*  691824 */     GIR_EraseRootFromParent_Done,
     /*  691825 */   // Label 10976: @691825
     /*  691825 */   GIM_Try, /*On fail goto*//*Label 10977*/ GIMT_Encode4(691900), // Rule ID 11008 //
     /*  691830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  691833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  691841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  691844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  691847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  691850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  691876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691898 */     GIR_RootConstrainSelectedInstOperands,
     /*  691899 */     // GIR_Coverage, 11008,
     /*  691899 */     GIR_EraseRootFromParent_Done,
     /*  691900 */   // Label 10977: @691900
     /*  691900 */   GIM_Try, /*On fail goto*//*Label 10978*/ GIMT_Encode4(691975), // Rule ID 11009 //
     /*  691905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  691908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  691916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  691919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  691922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  691925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691951 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  691951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691973 */     GIR_RootConstrainSelectedInstOperands,
     /*  691974 */     // GIR_Coverage, 11009,
     /*  691974 */     GIR_EraseRootFromParent_Done,
     /*  691975 */   // Label 10978: @691975
     /*  691975 */   GIM_Try, /*On fail goto*//*Label 10979*/ GIMT_Encode4(692050), // Rule ID 11012 //
     /*  691980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  691991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  691994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  691997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  692000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692048 */     GIR_RootConstrainSelectedInstOperands,
     /*  692049 */     // GIR_Coverage, 11012,
     /*  692049 */     GIR_EraseRootFromParent_Done,
     /*  692050 */   // Label 10979: @692050
     /*  692050 */   GIM_Try, /*On fail goto*//*Label 10980*/ GIMT_Encode4(692125), // Rule ID 11013 //
     /*  692055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  692066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  692069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  692072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  692075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692123 */     GIR_RootConstrainSelectedInstOperands,
     /*  692124 */     // GIR_Coverage, 11013,
     /*  692124 */     GIR_EraseRootFromParent_Done,
     /*  692125 */   // Label 10980: @692125
     /*  692125 */   GIM_Try, /*On fail goto*//*Label 10981*/ GIMT_Encode4(692200), // Rule ID 11016 //
     /*  692130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  692141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  692144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  692147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  692150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692176 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692198 */     GIR_RootConstrainSelectedInstOperands,
     /*  692199 */     // GIR_Coverage, 11016,
     /*  692199 */     GIR_EraseRootFromParent_Done,
     /*  692200 */   // Label 10981: @692200
     /*  692200 */   GIM_Try, /*On fail goto*//*Label 10982*/ GIMT_Encode4(692275), // Rule ID 11017 //
     /*  692205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  692216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  692219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  692222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  692225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692251 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692273 */     GIR_RootConstrainSelectedInstOperands,
     /*  692274 */     // GIR_Coverage, 11017,
     /*  692274 */     GIR_EraseRootFromParent_Done,
     /*  692275 */   // Label 10982: @692275
     /*  692275 */   GIM_Try, /*On fail goto*//*Label 10983*/ GIMT_Encode4(692350), // Rule ID 11020 //
     /*  692280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  692291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  692294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  692297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  692300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692348 */     GIR_RootConstrainSelectedInstOperands,
     /*  692349 */     // GIR_Coverage, 11020,
     /*  692349 */     GIR_EraseRootFromParent_Done,
     /*  692350 */   // Label 10983: @692350
     /*  692350 */   GIM_Try, /*On fail goto*//*Label 10984*/ GIMT_Encode4(692425), // Rule ID 11021 //
     /*  692355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  692366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  692369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  692372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  692375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692401 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692423 */     GIR_RootConstrainSelectedInstOperands,
     /*  692424 */     // GIR_Coverage, 11021,
     /*  692424 */     GIR_EraseRootFromParent_Done,
     /*  692425 */   // Label 10984: @692425
     /*  692425 */   GIM_Try, /*On fail goto*//*Label 10985*/ GIMT_Encode4(692500), // Rule ID 11024 //
     /*  692430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  692441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  692444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  692447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  692450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692498 */     GIR_RootConstrainSelectedInstOperands,
     /*  692499 */     // GIR_Coverage, 11024,
     /*  692499 */     GIR_EraseRootFromParent_Done,
     /*  692500 */   // Label 10985: @692500
     /*  692500 */   GIM_Try, /*On fail goto*//*Label 10986*/ GIMT_Encode4(692575), // Rule ID 11025 //
     /*  692505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  692516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  692519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  692522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  692525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692573 */     GIR_RootConstrainSelectedInstOperands,
     /*  692574 */     // GIR_Coverage, 11025,
     /*  692574 */     GIR_EraseRootFromParent_Done,
     /*  692575 */   // Label 10986: @692575
     /*  692575 */   GIM_Try, /*On fail goto*//*Label 10987*/ GIMT_Encode4(692650), // Rule ID 11028 //
     /*  692580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  692600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692648 */     GIR_RootConstrainSelectedInstOperands,
     /*  692649 */     // GIR_Coverage, 11028,
     /*  692649 */     GIR_EraseRootFromParent_Done,
     /*  692650 */   // Label 10987: @692650
     /*  692650 */   GIM_Try, /*On fail goto*//*Label 10988*/ GIMT_Encode4(692725), // Rule ID 11029 //
     /*  692655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  692675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692701 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692723 */     GIR_RootConstrainSelectedInstOperands,
     /*  692724 */     // GIR_Coverage, 11029,
     /*  692724 */     GIR_EraseRootFromParent_Done,
     /*  692725 */   // Label 10988: @692725
     /*  692725 */   GIM_Try, /*On fail goto*//*Label 10989*/ GIMT_Encode4(692800), // Rule ID 11032 //
     /*  692730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  692750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692798 */     GIR_RootConstrainSelectedInstOperands,
     /*  692799 */     // GIR_Coverage, 11032,
     /*  692799 */     GIR_EraseRootFromParent_Done,
     /*  692800 */   // Label 10989: @692800
     /*  692800 */   GIM_Try, /*On fail goto*//*Label 10990*/ GIMT_Encode4(692875), // Rule ID 11033 //
     /*  692805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  692825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692851 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692873 */     GIR_RootConstrainSelectedInstOperands,
     /*  692874 */     // GIR_Coverage, 11033,
     /*  692874 */     GIR_EraseRootFromParent_Done,
     /*  692875 */   // Label 10990: @692875
     /*  692875 */   GIM_Try, /*On fail goto*//*Label 10991*/ GIMT_Encode4(692950), // Rule ID 11036 //
     /*  692880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  692891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  692894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  692897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  692900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692948 */     GIR_RootConstrainSelectedInstOperands,
     /*  692949 */     // GIR_Coverage, 11036,
     /*  692949 */     GIR_EraseRootFromParent_Done,
     /*  692950 */   // Label 10991: @692950
     /*  692950 */   GIM_Try, /*On fail goto*//*Label 10992*/ GIMT_Encode4(693025), // Rule ID 11037 //
     /*  692955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  692966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  692969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  692972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  692975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  693004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693023 */     GIR_RootConstrainSelectedInstOperands,
     /*  693024 */     // GIR_Coverage, 11037,
     /*  693024 */     GIR_EraseRootFromParent_Done,
     /*  693025 */   // Label 10992: @693025
     /*  693025 */   GIM_Try, /*On fail goto*//*Label 10993*/ GIMT_Encode4(693100), // Rule ID 11040 //
     /*  693030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  693041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  693044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  693047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  693050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  693076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  693079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693098 */     GIR_RootConstrainSelectedInstOperands,
     /*  693099 */     // GIR_Coverage, 11040,
     /*  693099 */     GIR_EraseRootFromParent_Done,
     /*  693100 */   // Label 10993: @693100
     /*  693100 */   GIM_Try, /*On fail goto*//*Label 10994*/ GIMT_Encode4(693175), // Rule ID 11041 //
     /*  693105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  693116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  693119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  693122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  693125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693151 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  693154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693173 */     GIR_RootConstrainSelectedInstOperands,
     /*  693174 */     // GIR_Coverage, 11041,
     /*  693174 */     GIR_EraseRootFromParent_Done,
     /*  693175 */   // Label 10994: @693175
     /*  693175 */   GIM_Try, /*On fail goto*//*Label 10995*/ GIMT_Encode4(693250), // Rule ID 11044 //
     /*  693180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  693191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  693194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  693197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  693200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693226 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  693226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  693229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693248 */     GIR_RootConstrainSelectedInstOperands,
     /*  693249 */     // GIR_Coverage, 11044,
     /*  693249 */     GIR_EraseRootFromParent_Done,
     /*  693250 */   // Label 10995: @693250
     /*  693250 */   GIM_Try, /*On fail goto*//*Label 10996*/ GIMT_Encode4(693325), // Rule ID 11045 //
     /*  693255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  693266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  693269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  693272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  693275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693301 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  693304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693323 */     GIR_RootConstrainSelectedInstOperands,
     /*  693324 */     // GIR_Coverage, 11045,
     /*  693324 */     GIR_EraseRootFromParent_Done,
     /*  693325 */   // Label 10996: @693325
     /*  693325 */   GIM_Try, /*On fail goto*//*Label 10997*/ GIMT_Encode4(693400), // Rule ID 11048 //
     /*  693330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  693341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  693344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  693347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  693350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  693379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693398 */     GIR_RootConstrainSelectedInstOperands,
     /*  693399 */     // GIR_Coverage, 11048,
     /*  693399 */     GIR_EraseRootFromParent_Done,
     /*  693400 */   // Label 10997: @693400
     /*  693400 */   GIM_Try, /*On fail goto*//*Label 10998*/ GIMT_Encode4(693475), // Rule ID 11049 //
     /*  693405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  693416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  693419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  693422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  693425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  693454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693473 */     GIR_RootConstrainSelectedInstOperands,
     /*  693474 */     // GIR_Coverage, 11049,
     /*  693474 */     GIR_EraseRootFromParent_Done,
     /*  693475 */   // Label 10998: @693475
     /*  693475 */   GIM_Try, /*On fail goto*//*Label 10999*/ GIMT_Encode4(693550), // Rule ID 11052 //
     /*  693480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  693500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693526 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  693529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693548 */     GIR_RootConstrainSelectedInstOperands,
     /*  693549 */     // GIR_Coverage, 11052,
     /*  693549 */     GIR_EraseRootFromParent_Done,
     /*  693550 */   // Label 10999: @693550
     /*  693550 */   GIM_Try, /*On fail goto*//*Label 11000*/ GIMT_Encode4(693625), // Rule ID 11053 //
     /*  693555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  693575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693601 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  693604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693623 */     GIR_RootConstrainSelectedInstOperands,
     /*  693624 */     // GIR_Coverage, 11053,
     /*  693624 */     GIR_EraseRootFromParent_Done,
     /*  693625 */   // Label 11000: @693625
     /*  693625 */   GIM_Try, /*On fail goto*//*Label 11001*/ GIMT_Encode4(693700), // Rule ID 11056 //
     /*  693630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  693650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  693679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693698 */     GIR_RootConstrainSelectedInstOperands,
     /*  693699 */     // GIR_Coverage, 11056,
     /*  693699 */     GIR_EraseRootFromParent_Done,
     /*  693700 */   // Label 11001: @693700
     /*  693700 */   GIM_Try, /*On fail goto*//*Label 11002*/ GIMT_Encode4(693775), // Rule ID 11057 //
     /*  693705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  693725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693751 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  693754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693773 */     GIR_RootConstrainSelectedInstOperands,
     /*  693774 */     // GIR_Coverage, 11057,
     /*  693774 */     GIR_EraseRootFromParent_Done,
     /*  693775 */   // Label 11002: @693775
     /*  693775 */   GIM_Try, /*On fail goto*//*Label 11003*/ GIMT_Encode4(693850), // Rule ID 11060 //
     /*  693780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  693791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  693794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  693797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693826 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  693829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693848 */     GIR_RootConstrainSelectedInstOperands,
     /*  693849 */     // GIR_Coverage, 11060,
     /*  693849 */     GIR_EraseRootFromParent_Done,
     /*  693850 */   // Label 11003: @693850
     /*  693850 */   GIM_Try, /*On fail goto*//*Label 11004*/ GIMT_Encode4(693925), // Rule ID 11061 //
     /*  693855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  693866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  693869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  693872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693901 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  693904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693923 */     GIR_RootConstrainSelectedInstOperands,
     /*  693924 */     // GIR_Coverage, 11061,
     /*  693924 */     GIR_EraseRootFromParent_Done,
     /*  693925 */   // Label 11004: @693925
     /*  693925 */   GIM_Try, /*On fail goto*//*Label 11005*/ GIMT_Encode4(694000), // Rule ID 11064 //
     /*  693930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  693941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  693944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  693947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693998 */     GIR_RootConstrainSelectedInstOperands,
     /*  693999 */     // GIR_Coverage, 11064,
     /*  693999 */     GIR_EraseRootFromParent_Done,
     /*  694000 */   // Label 11005: @694000
     /*  694000 */   GIM_Try, /*On fail goto*//*Label 11006*/ GIMT_Encode4(694075), // Rule ID 11065 //
     /*  694005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  694016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  694019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  694022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694051 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  694054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694073 */     GIR_RootConstrainSelectedInstOperands,
     /*  694074 */     // GIR_Coverage, 11065,
     /*  694074 */     GIR_EraseRootFromParent_Done,
     /*  694075 */   // Label 11006: @694075
     /*  694075 */   GIM_Try, /*On fail goto*//*Label 11007*/ GIMT_Encode4(694150), // Rule ID 11068 //
     /*  694080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  694091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  694094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  694097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694126 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694148 */     GIR_RootConstrainSelectedInstOperands,
     /*  694149 */     // GIR_Coverage, 11068,
     /*  694149 */     GIR_EraseRootFromParent_Done,
     /*  694150 */   // Label 11007: @694150
     /*  694150 */   GIM_Try, /*On fail goto*//*Label 11008*/ GIMT_Encode4(694225), // Rule ID 11069 //
     /*  694155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  694166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  694169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  694172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694201 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694223 */     GIR_RootConstrainSelectedInstOperands,
     /*  694224 */     // GIR_Coverage, 11069,
     /*  694224 */     GIR_EraseRootFromParent_Done,
     /*  694225 */   // Label 11008: @694225
     /*  694225 */   GIM_Try, /*On fail goto*//*Label 11009*/ GIMT_Encode4(694300), // Rule ID 11072 //
     /*  694230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  694241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  694244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  694247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  694279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694298 */     GIR_RootConstrainSelectedInstOperands,
     /*  694299 */     // GIR_Coverage, 11072,
     /*  694299 */     GIR_EraseRootFromParent_Done,
     /*  694300 */   // Label 11009: @694300
     /*  694300 */   GIM_Try, /*On fail goto*//*Label 11010*/ GIMT_Encode4(694375), // Rule ID 11073 //
     /*  694305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  694316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  694319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  694322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694351 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  694354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694373 */     GIR_RootConstrainSelectedInstOperands,
     /*  694374 */     // GIR_Coverage, 11073,
     /*  694374 */     GIR_EraseRootFromParent_Done,
     /*  694375 */   // Label 11010: @694375
     /*  694375 */   GIM_Try, /*On fail goto*//*Label 11011*/ GIMT_Encode4(694450), // Rule ID 11076 //
     /*  694380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  694391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  694394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  694397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694426 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694448 */     GIR_RootConstrainSelectedInstOperands,
     /*  694449 */     // GIR_Coverage, 11076,
     /*  694449 */     GIR_EraseRootFromParent_Done,
     /*  694450 */   // Label 11011: @694450
     /*  694450 */   GIM_Try, /*On fail goto*//*Label 11012*/ GIMT_Encode4(694525), // Rule ID 11077 //
     /*  694455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  694466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  694469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  694472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694501 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694523 */     GIR_RootConstrainSelectedInstOperands,
     /*  694524 */     // GIR_Coverage, 11077,
     /*  694524 */     GIR_EraseRootFromParent_Done,
     /*  694525 */   // Label 11012: @694525
     /*  694525 */   GIM_Try, /*On fail goto*//*Label 11013*/ GIMT_Encode4(694600), // Rule ID 11080 //
     /*  694530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694576 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  694576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694598 */     GIR_RootConstrainSelectedInstOperands,
     /*  694599 */     // GIR_Coverage, 11080,
     /*  694599 */     GIR_EraseRootFromParent_Done,
     /*  694600 */   // Label 11013: @694600
     /*  694600 */   GIM_Try, /*On fail goto*//*Label 11014*/ GIMT_Encode4(694675), // Rule ID 11081 //
     /*  694605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694651 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  694651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694673 */     GIR_RootConstrainSelectedInstOperands,
     /*  694674 */     // GIR_Coverage, 11081,
     /*  694674 */     GIR_EraseRootFromParent_Done,
     /*  694675 */   // Label 11014: @694675
     /*  694675 */   GIM_Try, /*On fail goto*//*Label 11015*/ GIMT_Encode4(694750), // Rule ID 11084 //
     /*  694680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  694691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  694694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  694697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694748 */     GIR_RootConstrainSelectedInstOperands,
     /*  694749 */     // GIR_Coverage, 11084,
     /*  694749 */     GIR_EraseRootFromParent_Done,
     /*  694750 */   // Label 11015: @694750
     /*  694750 */   GIM_Try, /*On fail goto*//*Label 11016*/ GIMT_Encode4(694825), // Rule ID 11085 //
     /*  694755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  694766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  694769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  694772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694801 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694823 */     GIR_RootConstrainSelectedInstOperands,
     /*  694824 */     // GIR_Coverage, 11085,
     /*  694824 */     GIR_EraseRootFromParent_Done,
     /*  694825 */   // Label 11016: @694825
     /*  694825 */   GIM_Try, /*On fail goto*//*Label 11017*/ GIMT_Encode4(694900), // Rule ID 11088 //
     /*  694830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694898 */     GIR_RootConstrainSelectedInstOperands,
     /*  694899 */     // GIR_Coverage, 11088,
     /*  694899 */     GIR_EraseRootFromParent_Done,
     /*  694900 */   // Label 11017: @694900
     /*  694900 */   GIM_Try, /*On fail goto*//*Label 11018*/ GIMT_Encode4(694975), // Rule ID 11089 //
     /*  694905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694951 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694973 */     GIR_RootConstrainSelectedInstOperands,
     /*  694974 */     // GIR_Coverage, 11089,
     /*  694974 */     GIR_EraseRootFromParent_Done,
     /*  694975 */   // Label 11018: @694975
     /*  694975 */   GIM_Try, /*On fail goto*//*Label 11019*/ GIMT_Encode4(695050), // Rule ID 11092 //
     /*  694980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  694991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  694994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  694997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  695029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695048 */     GIR_RootConstrainSelectedInstOperands,
     /*  695049 */     // GIR_Coverage, 11092,
     /*  695049 */     GIR_EraseRootFromParent_Done,
     /*  695050 */   // Label 11019: @695050
     /*  695050 */   GIM_Try, /*On fail goto*//*Label 11020*/ GIMT_Encode4(695125), // Rule ID 11093 //
     /*  695055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  695066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  695069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  695072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695101 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  695104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695123 */     GIR_RootConstrainSelectedInstOperands,
     /*  695124 */     // GIR_Coverage, 11093,
     /*  695124 */     GIR_EraseRootFromParent_Done,
     /*  695125 */   // Label 11020: @695125
     /*  695125 */   GIM_Try, /*On fail goto*//*Label 11021*/ GIMT_Encode4(695200), // Rule ID 11096 //
     /*  695130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  695133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  695141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  695144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  695147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695176 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  695176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  695179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695198 */     GIR_RootConstrainSelectedInstOperands,
     /*  695199 */     // GIR_Coverage, 11096,
     /*  695199 */     GIR_EraseRootFromParent_Done,
     /*  695200 */   // Label 11021: @695200
     /*  695200 */   GIM_Try, /*On fail goto*//*Label 11022*/ GIMT_Encode4(695275), // Rule ID 11097 //
     /*  695205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  695208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  695216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  695219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  695222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695251 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  695251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  695254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695273 */     GIR_RootConstrainSelectedInstOperands,
     /*  695274 */     // GIR_Coverage, 11097,
     /*  695274 */     GIR_EraseRootFromParent_Done,
     /*  695275 */   // Label 11022: @695275
     /*  695275 */   GIM_Try, /*On fail goto*//*Label 11023*/ GIMT_Encode4(695350), // Rule ID 11100 //
     /*  695280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  695291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  695294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  695297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695348 */     GIR_RootConstrainSelectedInstOperands,
     /*  695349 */     // GIR_Coverage, 11100,
     /*  695349 */     GIR_EraseRootFromParent_Done,
     /*  695350 */   // Label 11023: @695350
     /*  695350 */   GIM_Try, /*On fail goto*//*Label 11024*/ GIMT_Encode4(695425), // Rule ID 11101 //
     /*  695355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  695366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  695369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  695372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695401 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695423 */     GIR_RootConstrainSelectedInstOperands,
     /*  695424 */     // GIR_Coverage, 11101,
     /*  695424 */     GIR_EraseRootFromParent_Done,
     /*  695425 */   // Label 11024: @695425
     /*  695425 */   GIM_Try, /*On fail goto*//*Label 11025*/ GIMT_Encode4(695500), // Rule ID 11104 //
     /*  695430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  695441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  695444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  695447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695476 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695498 */     GIR_RootConstrainSelectedInstOperands,
     /*  695499 */     // GIR_Coverage, 11104,
     /*  695499 */     GIR_EraseRootFromParent_Done,
     /*  695500 */   // Label 11025: @695500
     /*  695500 */   GIM_Try, /*On fail goto*//*Label 11026*/ GIMT_Encode4(695575), // Rule ID 11105 //
     /*  695505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  695516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  695519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  695522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695551 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695573 */     GIR_RootConstrainSelectedInstOperands,
     /*  695574 */     // GIR_Coverage, 11105,
     /*  695574 */     GIR_EraseRootFromParent_Done,
     /*  695575 */   // Label 11026: @695575
     /*  695575 */   GIM_Try, /*On fail goto*//*Label 11027*/ GIMT_Encode4(695650), // Rule ID 11108 //
     /*  695580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  695591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  695594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  695597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695626 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695648 */     GIR_RootConstrainSelectedInstOperands,
     /*  695649 */     // GIR_Coverage, 11108,
     /*  695649 */     GIR_EraseRootFromParent_Done,
     /*  695650 */   // Label 11027: @695650
     /*  695650 */   GIM_Try, /*On fail goto*//*Label 11028*/ GIMT_Encode4(695725), // Rule ID 11109 //
     /*  695655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  695666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  695669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  695672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695701 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695723 */     GIR_RootConstrainSelectedInstOperands,
     /*  695724 */     // GIR_Coverage, 11109,
     /*  695724 */     GIR_EraseRootFromParent_Done,
     /*  695725 */   // Label 11028: @695725
     /*  695725 */   GIM_Try, /*On fail goto*//*Label 11029*/ GIMT_Encode4(695800), // Rule ID 11112 //
     /*  695730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  695741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  695744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  695747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695798 */     GIR_RootConstrainSelectedInstOperands,
     /*  695799 */     // GIR_Coverage, 11112,
     /*  695799 */     GIR_EraseRootFromParent_Done,
     /*  695800 */   // Label 11029: @695800
     /*  695800 */   GIM_Try, /*On fail goto*//*Label 11030*/ GIMT_Encode4(695875), // Rule ID 11113 //
     /*  695805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  695816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  695819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  695822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695873 */     GIR_RootConstrainSelectedInstOperands,
     /*  695874 */     // GIR_Coverage, 11113,
     /*  695874 */     GIR_EraseRootFromParent_Done,
     /*  695875 */   // Label 11030: @695875
     /*  695875 */   GIM_Try, /*On fail goto*//*Label 11031*/ GIMT_Encode4(695950), // Rule ID 11116 //
     /*  695880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  695891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  695894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  695897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695948 */     GIR_RootConstrainSelectedInstOperands,
     /*  695949 */     // GIR_Coverage, 11116,
     /*  695949 */     GIR_EraseRootFromParent_Done,
     /*  695950 */   // Label 11031: @695950
     /*  695950 */   GIM_Try, /*On fail goto*//*Label 11032*/ GIMT_Encode4(696025), // Rule ID 11117 //
     /*  695955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  695966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  695969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  695972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696001 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  696001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696023 */     GIR_RootConstrainSelectedInstOperands,
     /*  696024 */     // GIR_Coverage, 11117,
     /*  696024 */     GIR_EraseRootFromParent_Done,
     /*  696025 */   // Label 11032: @696025
     /*  696025 */   GIM_Try, /*On fail goto*//*Label 11033*/ GIMT_Encode4(696100), // Rule ID 11120 //
     /*  696030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  696041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  696044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  696047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696076 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  696076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696098 */     GIR_RootConstrainSelectedInstOperands,
     /*  696099 */     // GIR_Coverage, 11120,
     /*  696099 */     GIR_EraseRootFromParent_Done,
     /*  696100 */   // Label 11033: @696100
     /*  696100 */   GIM_Try, /*On fail goto*//*Label 11034*/ GIMT_Encode4(696175), // Rule ID 11121 //
     /*  696105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  696116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  696119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  696122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696151 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  696151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696173 */     GIR_RootConstrainSelectedInstOperands,
     /*  696174 */     // GIR_Coverage, 11121,
     /*  696174 */     GIR_EraseRootFromParent_Done,
     /*  696175 */   // Label 11034: @696175
     /*  696175 */   GIM_Try, /*On fail goto*//*Label 11035*/ GIMT_Encode4(696250), // Rule ID 11124 //
     /*  696180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  696191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  696194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  696197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  696229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696248 */     GIR_RootConstrainSelectedInstOperands,
     /*  696249 */     // GIR_Coverage, 11124,
     /*  696249 */     GIR_EraseRootFromParent_Done,
     /*  696250 */   // Label 11035: @696250
     /*  696250 */   GIM_Try, /*On fail goto*//*Label 11036*/ GIMT_Encode4(696325), // Rule ID 11125 //
     /*  696255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  696266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  696269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  696272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696301 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  696304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696323 */     GIR_RootConstrainSelectedInstOperands,
     /*  696324 */     // GIR_Coverage, 11125,
     /*  696324 */     GIR_EraseRootFromParent_Done,
     /*  696325 */   // Label 11036: @696325
     /*  696325 */   GIM_Try, /*On fail goto*//*Label 11037*/ GIMT_Encode4(696400), // Rule ID 11128 //
     /*  696330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  696341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  696344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  696347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696376 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696398 */     GIR_RootConstrainSelectedInstOperands,
     /*  696399 */     // GIR_Coverage, 11128,
     /*  696399 */     GIR_EraseRootFromParent_Done,
     /*  696400 */   // Label 11037: @696400
     /*  696400 */   GIM_Try, /*On fail goto*//*Label 11038*/ GIMT_Encode4(696475), // Rule ID 11129 //
     /*  696405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  696416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  696419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  696422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696451 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696473 */     GIR_RootConstrainSelectedInstOperands,
     /*  696474 */     // GIR_Coverage, 11129,
     /*  696474 */     GIR_EraseRootFromParent_Done,
     /*  696475 */   // Label 11038: @696475
     /*  696475 */   GIM_Try, /*On fail goto*//*Label 11039*/ GIMT_Encode4(696550), // Rule ID 11132 //
     /*  696480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  696491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  696494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  696497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696526 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696548 */     GIR_RootConstrainSelectedInstOperands,
     /*  696549 */     // GIR_Coverage, 11132,
     /*  696549 */     GIR_EraseRootFromParent_Done,
     /*  696550 */   // Label 11039: @696550
     /*  696550 */   GIM_Try, /*On fail goto*//*Label 11040*/ GIMT_Encode4(696625), // Rule ID 11133 //
     /*  696555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  696566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  696569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  696572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696601 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696623 */     GIR_RootConstrainSelectedInstOperands,
     /*  696624 */     // GIR_Coverage, 11133,
     /*  696624 */     GIR_EraseRootFromParent_Done,
     /*  696625 */   // Label 11040: @696625
     /*  696625 */   GIM_Try, /*On fail goto*//*Label 11041*/ GIMT_Encode4(696700), // Rule ID 11136 //
     /*  696630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  696641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  696644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  696647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  696679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696698 */     GIR_RootConstrainSelectedInstOperands,
     /*  696699 */     // GIR_Coverage, 11136,
     /*  696699 */     GIR_EraseRootFromParent_Done,
     /*  696700 */   // Label 11041: @696700
     /*  696700 */   GIM_Try, /*On fail goto*//*Label 11042*/ GIMT_Encode4(696775), // Rule ID 11137 //
     /*  696705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  696716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  696719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  696722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696751 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  696754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696773 */     GIR_RootConstrainSelectedInstOperands,
     /*  696774 */     // GIR_Coverage, 11137,
     /*  696774 */     GIR_EraseRootFromParent_Done,
     /*  696775 */   // Label 11042: @696775
     /*  696775 */   GIM_Try, /*On fail goto*//*Label 11043*/ GIMT_Encode4(696850), // Rule ID 11140 //
     /*  696780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  696791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  696794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  696797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696826 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696848 */     GIR_RootConstrainSelectedInstOperands,
     /*  696849 */     // GIR_Coverage, 11140,
     /*  696849 */     GIR_EraseRootFromParent_Done,
     /*  696850 */   // Label 11043: @696850
     /*  696850 */   GIM_Try, /*On fail goto*//*Label 11044*/ GIMT_Encode4(696925), // Rule ID 11141 //
     /*  696855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  696866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  696869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  696872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696901 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696923 */     GIR_RootConstrainSelectedInstOperands,
     /*  696924 */     // GIR_Coverage, 11141,
     /*  696924 */     GIR_EraseRootFromParent_Done,
     /*  696925 */   // Label 11044: @696925
     /*  696925 */   GIM_Try, /*On fail goto*//*Label 11045*/ GIMT_Encode4(697000), // Rule ID 11144 //
     /*  696930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  696941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  696944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  696947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696976 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696998 */     GIR_RootConstrainSelectedInstOperands,
     /*  696999 */     // GIR_Coverage, 11144,
     /*  696999 */     GIR_EraseRootFromParent_Done,
     /*  697000 */   // Label 11045: @697000
     /*  697000 */   GIM_Try, /*On fail goto*//*Label 11046*/ GIMT_Encode4(697075), // Rule ID 11145 //
     /*  697005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  697008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  697016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  697019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  697022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697051 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  697051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  697054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  697070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697073 */     GIR_RootConstrainSelectedInstOperands,
     /*  697074 */     // GIR_Coverage, 11145,
     /*  697074 */     GIR_EraseRootFromParent_Done,
     /*  697075 */   // Label 11046: @697075
     /*  697075 */   GIM_Try, /*On fail goto*//*Label 11047*/ GIMT_Encode4(697150), // Rule ID 11148 //
     /*  697080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  697091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  697094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  697097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  697100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697126 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  697129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697148 */     GIR_RootConstrainSelectedInstOperands,
     /*  697149 */     // GIR_Coverage, 11148,
     /*  697149 */     GIR_EraseRootFromParent_Done,
     /*  697150 */   // Label 11047: @697150
     /*  697150 */   GIM_Try, /*On fail goto*//*Label 11048*/ GIMT_Encode4(697225), // Rule ID 11149 //
     /*  697155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  697166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  697169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  697172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  697175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697201 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  697204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697223 */     GIR_RootConstrainSelectedInstOperands,
     /*  697224 */     // GIR_Coverage, 11149,
     /*  697224 */     GIR_EraseRootFromParent_Done,
     /*  697225 */   // Label 11048: @697225
     /*  697225 */   GIM_Try, /*On fail goto*//*Label 11049*/ GIMT_Encode4(697300), // Rule ID 11152 //
     /*  697230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  697241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  697244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  697247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  697250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697276 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  697279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697298 */     GIR_RootConstrainSelectedInstOperands,
     /*  697299 */     // GIR_Coverage, 11152,
     /*  697299 */     GIR_EraseRootFromParent_Done,
     /*  697300 */   // Label 11049: @697300
     /*  697300 */   GIM_Try, /*On fail goto*//*Label 11050*/ GIMT_Encode4(697375), // Rule ID 11153 //
     /*  697305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  697316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  697319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  697322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  697325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697351 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  697354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697373 */     GIR_RootConstrainSelectedInstOperands,
     /*  697374 */     // GIR_Coverage, 11153,
     /*  697374 */     GIR_EraseRootFromParent_Done,
     /*  697375 */   // Label 11050: @697375
     /*  697375 */   GIM_Try, /*On fail goto*//*Label 11051*/ GIMT_Encode4(697450), // Rule ID 11156 //
     /*  697380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  697391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  697394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  697397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  697400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697426 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697448 */     GIR_RootConstrainSelectedInstOperands,
     /*  697449 */     // GIR_Coverage, 11156,
     /*  697449 */     GIR_EraseRootFromParent_Done,
     /*  697450 */   // Label 11051: @697450
     /*  697450 */   GIM_Try, /*On fail goto*//*Label 11052*/ GIMT_Encode4(697525), // Rule ID 11157 //
     /*  697455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  697466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  697469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  697472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  697475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697501 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697523 */     GIR_RootConstrainSelectedInstOperands,
     /*  697524 */     // GIR_Coverage, 11157,
     /*  697524 */     GIR_EraseRootFromParent_Done,
     /*  697525 */   // Label 11052: @697525
     /*  697525 */   GIM_Try, /*On fail goto*//*Label 11053*/ GIMT_Encode4(697600), // Rule ID 11160 //
     /*  697530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  697541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  697544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  697547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  697550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697576 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  697579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697598 */     GIR_RootConstrainSelectedInstOperands,
     /*  697599 */     // GIR_Coverage, 11160,
     /*  697599 */     GIR_EraseRootFromParent_Done,
     /*  697600 */   // Label 11053: @697600
     /*  697600 */   GIM_Try, /*On fail goto*//*Label 11054*/ GIMT_Encode4(697675), // Rule ID 11161 //
     /*  697605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  697616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  697619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  697622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  697625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697651 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  697654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697673 */     GIR_RootConstrainSelectedInstOperands,
     /*  697674 */     // GIR_Coverage, 11161,
     /*  697674 */     GIR_EraseRootFromParent_Done,
     /*  697675 */   // Label 11054: @697675
     /*  697675 */   GIM_Try, /*On fail goto*//*Label 11055*/ GIMT_Encode4(697750), // Rule ID 11164 //
     /*  697680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  697691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  697694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  697697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  697700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697748 */     GIR_RootConstrainSelectedInstOperands,
     /*  697749 */     // GIR_Coverage, 11164,
     /*  697749 */     GIR_EraseRootFromParent_Done,
     /*  697750 */   // Label 11055: @697750
     /*  697750 */   GIM_Try, /*On fail goto*//*Label 11056*/ GIMT_Encode4(697825), // Rule ID 11165 //
     /*  697755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  697766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  697769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  697772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  697775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697801 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697823 */     GIR_RootConstrainSelectedInstOperands,
     /*  697824 */     // GIR_Coverage, 11165,
     /*  697824 */     GIR_EraseRootFromParent_Done,
     /*  697825 */   // Label 11056: @697825
     /*  697825 */   GIM_Try, /*On fail goto*//*Label 11057*/ GIMT_Encode4(697900), // Rule ID 11168 //
     /*  697830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  697841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  697844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  697847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  697850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697876 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  697876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697898 */     GIR_RootConstrainSelectedInstOperands,
     /*  697899 */     // GIR_Coverage, 11168,
     /*  697899 */     GIR_EraseRootFromParent_Done,
     /*  697900 */   // Label 11057: @697900
     /*  697900 */   GIM_Try, /*On fail goto*//*Label 11058*/ GIMT_Encode4(697975), // Rule ID 11169 //
     /*  697905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  697916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  697919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  697922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  697925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697951 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  697951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697973 */     GIR_RootConstrainSelectedInstOperands,
     /*  697974 */     // GIR_Coverage, 11169,
     /*  697974 */     GIR_EraseRootFromParent_Done,
     /*  697975 */   // Label 11058: @697975
     /*  697975 */   GIM_Try, /*On fail goto*//*Label 11059*/ GIMT_Encode4(698050), // Rule ID 11172 //
     /*  697980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  697991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  697994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  697997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  698000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698026 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  698029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698048 */     GIR_RootConstrainSelectedInstOperands,
     /*  698049 */     // GIR_Coverage, 11172,
     /*  698049 */     GIR_EraseRootFromParent_Done,
     /*  698050 */   // Label 11059: @698050
     /*  698050 */   GIM_Try, /*On fail goto*//*Label 11060*/ GIMT_Encode4(698125), // Rule ID 11173 //
     /*  698055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  698066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  698069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  698072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  698075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698101 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  698104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698123 */     GIR_RootConstrainSelectedInstOperands,
     /*  698124 */     // GIR_Coverage, 11173,
     /*  698124 */     GIR_EraseRootFromParent_Done,
     /*  698125 */   // Label 11060: @698125
     /*  698125 */   GIM_Try, /*On fail goto*//*Label 11061*/ GIMT_Encode4(698200), // Rule ID 11176 //
     /*  698130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  698141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  698144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  698147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  698150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  698179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698198 */     GIR_RootConstrainSelectedInstOperands,
     /*  698199 */     // GIR_Coverage, 11176,
     /*  698199 */     GIR_EraseRootFromParent_Done,
     /*  698200 */   // Label 11061: @698200
     /*  698200 */   GIM_Try, /*On fail goto*//*Label 11062*/ GIMT_Encode4(698275), // Rule ID 11177 //
     /*  698205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  698216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  698219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  698222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  698225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698251 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  698254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698273 */     GIR_RootConstrainSelectedInstOperands,
     /*  698274 */     // GIR_Coverage, 11177,
     /*  698274 */     GIR_EraseRootFromParent_Done,
     /*  698275 */   // Label 11062: @698275
     /*  698275 */   GIM_Try, /*On fail goto*//*Label 11063*/ GIMT_Encode4(698350), // Rule ID 11180 //
     /*  698280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  698291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  698294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  698297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  698300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  698326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  698329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698348 */     GIR_RootConstrainSelectedInstOperands,
     /*  698349 */     // GIR_Coverage, 11180,
     /*  698349 */     GIR_EraseRootFromParent_Done,
     /*  698350 */   // Label 11063: @698350
     /*  698350 */   GIM_Try, /*On fail goto*//*Label 11064*/ GIMT_Encode4(698425), // Rule ID 11181 //
     /*  698355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  698366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  698369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  698372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  698375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698401 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  698401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  698404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698423 */     GIR_RootConstrainSelectedInstOperands,
     /*  698424 */     // GIR_Coverage, 11181,
     /*  698424 */     GIR_EraseRootFromParent_Done,
     /*  698425 */   // Label 11064: @698425
     /*  698425 */   GIM_Try, /*On fail goto*//*Label 11065*/ GIMT_Encode4(698500), // Rule ID 11184 //
     /*  698430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  698441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  698444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  698447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  698450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698476 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698498 */     GIR_RootConstrainSelectedInstOperands,
     /*  698499 */     // GIR_Coverage, 11184,
     /*  698499 */     GIR_EraseRootFromParent_Done,
     /*  698500 */   // Label 11065: @698500
     /*  698500 */   GIM_Try, /*On fail goto*//*Label 11066*/ GIMT_Encode4(698575), // Rule ID 11185 //
     /*  698505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  698516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  698519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  698522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  698525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698551 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698573 */     GIR_RootConstrainSelectedInstOperands,
     /*  698574 */     // GIR_Coverage, 11185,
     /*  698574 */     GIR_EraseRootFromParent_Done,
     /*  698575 */   // Label 11066: @698575
     /*  698575 */   GIM_Try, /*On fail goto*//*Label 11067*/ GIMT_Encode4(698650), // Rule ID 11188 //
     /*  698580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  698591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  698594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  698597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  698600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698626 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698648 */     GIR_RootConstrainSelectedInstOperands,
     /*  698649 */     // GIR_Coverage, 11188,
     /*  698649 */     GIR_EraseRootFromParent_Done,
     /*  698650 */   // Label 11067: @698650
     /*  698650 */   GIM_Try, /*On fail goto*//*Label 11068*/ GIMT_Encode4(698725), // Rule ID 11189 //
     /*  698655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  698666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  698669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  698672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  698675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698701 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698723 */     GIR_RootConstrainSelectedInstOperands,
     /*  698724 */     // GIR_Coverage, 11189,
     /*  698724 */     GIR_EraseRootFromParent_Done,
     /*  698725 */   // Label 11068: @698725
     /*  698725 */   GIM_Try, /*On fail goto*//*Label 11069*/ GIMT_Encode4(698800), // Rule ID 11192 //
     /*  698730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  698741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  698744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  698747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  698750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698776 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698798 */     GIR_RootConstrainSelectedInstOperands,
     /*  698799 */     // GIR_Coverage, 11192,
     /*  698799 */     GIR_EraseRootFromParent_Done,
     /*  698800 */   // Label 11069: @698800
     /*  698800 */   GIM_Try, /*On fail goto*//*Label 11070*/ GIMT_Encode4(698875), // Rule ID 11193 //
     /*  698805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  698816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  698819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  698822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  698825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698851 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698873 */     GIR_RootConstrainSelectedInstOperands,
     /*  698874 */     // GIR_Coverage, 11193,
     /*  698874 */     GIR_EraseRootFromParent_Done,
     /*  698875 */   // Label 11070: @698875
     /*  698875 */   GIM_Try, /*On fail goto*//*Label 11071*/ GIMT_Encode4(698950), // Rule ID 11196 //
     /*  698880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  698891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  698894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  698897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  698900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698926 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698948 */     GIR_RootConstrainSelectedInstOperands,
     /*  698949 */     // GIR_Coverage, 11196,
     /*  698949 */     GIR_EraseRootFromParent_Done,
     /*  698950 */   // Label 11071: @698950
     /*  698950 */   GIM_Try, /*On fail goto*//*Label 11072*/ GIMT_Encode4(699025), // Rule ID 11197 //
     /*  698955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  698966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  698969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  698972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  698975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699001 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  699004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699023 */     GIR_RootConstrainSelectedInstOperands,
     /*  699024 */     // GIR_Coverage, 11197,
     /*  699024 */     GIR_EraseRootFromParent_Done,
     /*  699025 */   // Label 11072: @699025
     /*  699025 */   GIM_Try, /*On fail goto*//*Label 11073*/ GIMT_Encode4(699100), // Rule ID 11200 //
     /*  699030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  699041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  699044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  699047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  699050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699076 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  699079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699098 */     GIR_RootConstrainSelectedInstOperands,
     /*  699099 */     // GIR_Coverage, 11200,
     /*  699099 */     GIR_EraseRootFromParent_Done,
     /*  699100 */   // Label 11073: @699100
     /*  699100 */   GIM_Try, /*On fail goto*//*Label 11074*/ GIMT_Encode4(699175), // Rule ID 11201 //
     /*  699105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  699116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  699119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  699122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  699125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699151 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  699154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699173 */     GIR_RootConstrainSelectedInstOperands,
     /*  699174 */     // GIR_Coverage, 11201,
     /*  699174 */     GIR_EraseRootFromParent_Done,
     /*  699175 */   // Label 11074: @699175
     /*  699175 */   GIM_Try, /*On fail goto*//*Label 11075*/ GIMT_Encode4(699250), // Rule ID 11204 //
     /*  699180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  699191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  699194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  699197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  699200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699226 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  699229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699248 */     GIR_RootConstrainSelectedInstOperands,
     /*  699249 */     // GIR_Coverage, 11204,
     /*  699249 */     GIR_EraseRootFromParent_Done,
     /*  699250 */   // Label 11075: @699250
     /*  699250 */   GIM_Try, /*On fail goto*//*Label 11076*/ GIMT_Encode4(699325), // Rule ID 11205 //
     /*  699255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  699266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  699269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  699272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  699275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699301 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  699304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699323 */     GIR_RootConstrainSelectedInstOperands,
     /*  699324 */     // GIR_Coverage, 11205,
     /*  699324 */     GIR_EraseRootFromParent_Done,
     /*  699325 */   // Label 11076: @699325
     /*  699325 */   GIM_Try, /*On fail goto*//*Label 11077*/ GIMT_Encode4(699400), // Rule ID 11208 //
     /*  699330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  699341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  699344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  699347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  699350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  699379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699398 */     GIR_RootConstrainSelectedInstOperands,
     /*  699399 */     // GIR_Coverage, 11208,
     /*  699399 */     GIR_EraseRootFromParent_Done,
     /*  699400 */   // Label 11077: @699400
     /*  699400 */   GIM_Try, /*On fail goto*//*Label 11078*/ GIMT_Encode4(699475), // Rule ID 11209 //
     /*  699405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  699416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  699419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  699422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  699425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699451 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  699454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699473 */     GIR_RootConstrainSelectedInstOperands,
     /*  699474 */     // GIR_Coverage, 11209,
     /*  699474 */     GIR_EraseRootFromParent_Done,
     /*  699475 */   // Label 11078: @699475
     /*  699475 */   GIM_Try, /*On fail goto*//*Label 11079*/ GIMT_Encode4(699550), // Rule ID 11212 //
     /*  699480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  699500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699526 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  699529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699548 */     GIR_RootConstrainSelectedInstOperands,
     /*  699549 */     // GIR_Coverage, 11212,
     /*  699549 */     GIR_EraseRootFromParent_Done,
     /*  699550 */   // Label 11079: @699550
     /*  699550 */   GIM_Try, /*On fail goto*//*Label 11080*/ GIMT_Encode4(699625), // Rule ID 11213 //
     /*  699555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  699575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699601 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  699604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699623 */     GIR_RootConstrainSelectedInstOperands,
     /*  699624 */     // GIR_Coverage, 11213,
     /*  699624 */     GIR_EraseRootFromParent_Done,
     /*  699625 */   // Label 11080: @699625
     /*  699625 */   GIM_Try, /*On fail goto*//*Label 11081*/ GIMT_Encode4(699700), // Rule ID 11216 //
     /*  699630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  699641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  699644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  699647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  699650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699676 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  699679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699698 */     GIR_RootConstrainSelectedInstOperands,
     /*  699699 */     // GIR_Coverage, 11216,
     /*  699699 */     GIR_EraseRootFromParent_Done,
     /*  699700 */   // Label 11081: @699700
     /*  699700 */   GIM_Try, /*On fail goto*//*Label 11082*/ GIMT_Encode4(699775), // Rule ID 11217 //
     /*  699705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  699716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  699719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  699722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  699725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699751 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  699754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699773 */     GIR_RootConstrainSelectedInstOperands,
     /*  699774 */     // GIR_Coverage, 11217,
     /*  699774 */     GIR_EraseRootFromParent_Done,
     /*  699775 */   // Label 11082: @699775
     /*  699775 */   GIM_Try, /*On fail goto*//*Label 11083*/ GIMT_Encode4(699850), // Rule ID 11220 //
     /*  699780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  699791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  699794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  699797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699826 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  699826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  699829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699848 */     GIR_RootConstrainSelectedInstOperands,
     /*  699849 */     // GIR_Coverage, 11220,
     /*  699849 */     GIR_EraseRootFromParent_Done,
     /*  699850 */   // Label 11083: @699850
     /*  699850 */   GIM_Try, /*On fail goto*//*Label 11084*/ GIMT_Encode4(699925), // Rule ID 11221 //
     /*  699855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  699866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  699869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  699872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699901 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  699904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699923 */     GIR_RootConstrainSelectedInstOperands,
     /*  699924 */     // GIR_Coverage, 11221,
     /*  699924 */     GIR_EraseRootFromParent_Done,
     /*  699925 */   // Label 11084: @699925
     /*  699925 */   GIM_Try, /*On fail goto*//*Label 11085*/ GIMT_Encode4(700000), // Rule ID 11224 //
     /*  699930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  699941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  699944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  699947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  699976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699998 */     GIR_RootConstrainSelectedInstOperands,
     /*  699999 */     // GIR_Coverage, 11224,
     /*  699999 */     GIR_EraseRootFromParent_Done,
     /*  700000 */   // Label 11085: @700000
     /*  700000 */   GIM_Try, /*On fail goto*//*Label 11086*/ GIMT_Encode4(700075), // Rule ID 11225 //
     /*  700005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  700016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  700019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  700022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700051 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  700054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700073 */     GIR_RootConstrainSelectedInstOperands,
     /*  700074 */     // GIR_Coverage, 11225,
     /*  700074 */     GIR_EraseRootFromParent_Done,
     /*  700075 */   // Label 11086: @700075
     /*  700075 */   GIM_Try, /*On fail goto*//*Label 11087*/ GIMT_Encode4(700150), // Rule ID 11228 //
     /*  700080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  700091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  700094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  700097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700126 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700148 */     GIR_RootConstrainSelectedInstOperands,
     /*  700149 */     // GIR_Coverage, 11228,
     /*  700149 */     GIR_EraseRootFromParent_Done,
     /*  700150 */   // Label 11087: @700150
     /*  700150 */   GIM_Try, /*On fail goto*//*Label 11088*/ GIMT_Encode4(700225), // Rule ID 11229 //
     /*  700155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  700166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  700169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  700172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700201 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700223 */     GIR_RootConstrainSelectedInstOperands,
     /*  700224 */     // GIR_Coverage, 11229,
     /*  700224 */     GIR_EraseRootFromParent_Done,
     /*  700225 */   // Label 11088: @700225
     /*  700225 */   GIM_Try, /*On fail goto*//*Label 11089*/ GIMT_Encode4(700300), // Rule ID 11232 //
     /*  700230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  700241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  700244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  700247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  700279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700298 */     GIR_RootConstrainSelectedInstOperands,
     /*  700299 */     // GIR_Coverage, 11232,
     /*  700299 */     GIR_EraseRootFromParent_Done,
     /*  700300 */   // Label 11089: @700300
     /*  700300 */   GIM_Try, /*On fail goto*//*Label 11090*/ GIMT_Encode4(700375), // Rule ID 11233 //
     /*  700305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  700316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  700319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  700322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700351 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  700354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700373 */     GIR_RootConstrainSelectedInstOperands,
     /*  700374 */     // GIR_Coverage, 11233,
     /*  700374 */     GIR_EraseRootFromParent_Done,
     /*  700375 */   // Label 11090: @700375
     /*  700375 */   GIM_Try, /*On fail goto*//*Label 11091*/ GIMT_Encode4(700450), // Rule ID 11236 //
     /*  700380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  700391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  700394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  700397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700426 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700448 */     GIR_RootConstrainSelectedInstOperands,
     /*  700449 */     // GIR_Coverage, 11236,
     /*  700449 */     GIR_EraseRootFromParent_Done,
     /*  700450 */   // Label 11091: @700450
     /*  700450 */   GIM_Try, /*On fail goto*//*Label 11092*/ GIMT_Encode4(700525), // Rule ID 11237 //
     /*  700455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  700466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  700469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  700472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700501 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700523 */     GIR_RootConstrainSelectedInstOperands,
     /*  700524 */     // GIR_Coverage, 11237,
     /*  700524 */     GIR_EraseRootFromParent_Done,
     /*  700525 */   // Label 11092: @700525
     /*  700525 */   GIM_Try, /*On fail goto*//*Label 11093*/ GIMT_Encode4(700600), // Rule ID 11240 //
     /*  700530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  700541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  700544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  700547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700576 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  700576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700598 */     GIR_RootConstrainSelectedInstOperands,
     /*  700599 */     // GIR_Coverage, 11240,
     /*  700599 */     GIR_EraseRootFromParent_Done,
     /*  700600 */   // Label 11093: @700600
     /*  700600 */   GIM_Try, /*On fail goto*//*Label 11094*/ GIMT_Encode4(700675), // Rule ID 11241 //
     /*  700605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  700616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  700619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  700622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700651 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  700651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700673 */     GIR_RootConstrainSelectedInstOperands,
     /*  700674 */     // GIR_Coverage, 11241,
     /*  700674 */     GIR_EraseRootFromParent_Done,
     /*  700675 */   // Label 11094: @700675
     /*  700675 */   GIM_Try, /*On fail goto*//*Label 11095*/ GIMT_Encode4(700750), // Rule ID 11244 //
     /*  700680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  700691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  700694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  700697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700748 */     GIR_RootConstrainSelectedInstOperands,
     /*  700749 */     // GIR_Coverage, 11244,
     /*  700749 */     GIR_EraseRootFromParent_Done,
     /*  700750 */   // Label 11095: @700750
     /*  700750 */   GIM_Try, /*On fail goto*//*Label 11096*/ GIMT_Encode4(700825), // Rule ID 11245 //
     /*  700755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  700766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  700769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  700772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700801 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700823 */     GIR_RootConstrainSelectedInstOperands,
     /*  700824 */     // GIR_Coverage, 11245,
     /*  700824 */     GIR_EraseRootFromParent_Done,
     /*  700825 */   // Label 11096: @700825
     /*  700825 */   GIM_Try, /*On fail goto*//*Label 11097*/ GIMT_Encode4(700900), // Rule ID 11248 //
     /*  700830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  700841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  700844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  700847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700898 */     GIR_RootConstrainSelectedInstOperands,
     /*  700899 */     // GIR_Coverage, 11248,
     /*  700899 */     GIR_EraseRootFromParent_Done,
     /*  700900 */   // Label 11097: @700900
     /*  700900 */   GIM_Try, /*On fail goto*//*Label 11098*/ GIMT_Encode4(700975), // Rule ID 11249 //
     /*  700905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  700916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  700919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  700922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700951 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700973 */     GIR_RootConstrainSelectedInstOperands,
     /*  700974 */     // GIR_Coverage, 11249,
     /*  700974 */     GIR_EraseRootFromParent_Done,
     /*  700975 */   // Label 11098: @700975
     /*  700975 */   GIM_Try, /*On fail goto*//*Label 11099*/ GIMT_Encode4(701050), // Rule ID 11252 //
     /*  700980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  700991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  700994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  700997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  701029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701048 */     GIR_RootConstrainSelectedInstOperands,
     /*  701049 */     // GIR_Coverage, 11252,
     /*  701049 */     GIR_EraseRootFromParent_Done,
     /*  701050 */   // Label 11099: @701050
     /*  701050 */   GIM_Try, /*On fail goto*//*Label 11100*/ GIMT_Encode4(701125), // Rule ID 11253 //
     /*  701055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  701066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  701069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  701072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701101 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  701104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701123 */     GIR_RootConstrainSelectedInstOperands,
     /*  701124 */     // GIR_Coverage, 11253,
     /*  701124 */     GIR_EraseRootFromParent_Done,
     /*  701125 */   // Label 11100: @701125
     /*  701125 */   GIM_Try, /*On fail goto*//*Label 11101*/ GIMT_Encode4(701200), // Rule ID 11256 //
     /*  701130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  701141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  701144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  701147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701176 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701198 */     GIR_RootConstrainSelectedInstOperands,
     /*  701199 */     // GIR_Coverage, 11256,
     /*  701199 */     GIR_EraseRootFromParent_Done,
     /*  701200 */   // Label 11101: @701200
     /*  701200 */   GIM_Try, /*On fail goto*//*Label 11102*/ GIMT_Encode4(701275), // Rule ID 11257 //
     /*  701205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  701216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  701219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  701222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701251 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701273 */     GIR_RootConstrainSelectedInstOperands,
     /*  701274 */     // GIR_Coverage, 11257,
     /*  701274 */     GIR_EraseRootFromParent_Done,
     /*  701275 */   // Label 11102: @701275
     /*  701275 */   GIM_Try, /*On fail goto*//*Label 11103*/ GIMT_Encode4(701350), // Rule ID 11260 //
     /*  701280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  701291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  701294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  701297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701326 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701348 */     GIR_RootConstrainSelectedInstOperands,
     /*  701349 */     // GIR_Coverage, 11260,
     /*  701349 */     GIR_EraseRootFromParent_Done,
     /*  701350 */   // Label 11103: @701350
     /*  701350 */   GIM_Try, /*On fail goto*//*Label 11104*/ GIMT_Encode4(701425), // Rule ID 11261 //
     /*  701355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  701366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  701369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  701372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701401 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701423 */     GIR_RootConstrainSelectedInstOperands,
     /*  701424 */     // GIR_Coverage, 11261,
     /*  701424 */     GIR_EraseRootFromParent_Done,
     /*  701425 */   // Label 11104: @701425
     /*  701425 */   GIM_Try, /*On fail goto*//*Label 11105*/ GIMT_Encode4(701500), // Rule ID 11264 //
     /*  701430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  701441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  701444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  701447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701476 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701498 */     GIR_RootConstrainSelectedInstOperands,
     /*  701499 */     // GIR_Coverage, 11264,
     /*  701499 */     GIR_EraseRootFromParent_Done,
     /*  701500 */   // Label 11105: @701500
     /*  701500 */   GIM_Try, /*On fail goto*//*Label 11106*/ GIMT_Encode4(701575), // Rule ID 11265 //
     /*  701505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  701516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  701519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  701522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701551 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701573 */     GIR_RootConstrainSelectedInstOperands,
     /*  701574 */     // GIR_Coverage, 11265,
     /*  701574 */     GIR_EraseRootFromParent_Done,
     /*  701575 */   // Label 11106: @701575
     /*  701575 */   GIM_Try, /*On fail goto*//*Label 11107*/ GIMT_Encode4(701650), // Rule ID 11268 //
     /*  701580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  701591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  701594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  701597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701648 */     GIR_RootConstrainSelectedInstOperands,
     /*  701649 */     // GIR_Coverage, 11268,
     /*  701649 */     GIR_EraseRootFromParent_Done,
     /*  701650 */   // Label 11107: @701650
     /*  701650 */   GIM_Try, /*On fail goto*//*Label 11108*/ GIMT_Encode4(701725), // Rule ID 11269 //
     /*  701655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  701666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  701669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  701672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701701 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701723 */     GIR_RootConstrainSelectedInstOperands,
     /*  701724 */     // GIR_Coverage, 11269,
     /*  701724 */     GIR_EraseRootFromParent_Done,
     /*  701725 */   // Label 11108: @701725
     /*  701725 */   GIM_Try, /*On fail goto*//*Label 11109*/ GIMT_Encode4(701800), // Rule ID 11272 //
     /*  701730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  701741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  701744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  701747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701776 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701798 */     GIR_RootConstrainSelectedInstOperands,
     /*  701799 */     // GIR_Coverage, 11272,
     /*  701799 */     GIR_EraseRootFromParent_Done,
     /*  701800 */   // Label 11109: @701800
     /*  701800 */   GIM_Try, /*On fail goto*//*Label 11110*/ GIMT_Encode4(701875), // Rule ID 11273 //
     /*  701805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  701816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  701819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  701822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701851 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701873 */     GIR_RootConstrainSelectedInstOperands,
     /*  701874 */     // GIR_Coverage, 11273,
     /*  701874 */     GIR_EraseRootFromParent_Done,
     /*  701875 */   // Label 11110: @701875
     /*  701875 */   GIM_Try, /*On fail goto*//*Label 11111*/ GIMT_Encode4(701950), // Rule ID 11276 //
     /*  701880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  701891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  701894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  701897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701926 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701948 */     GIR_RootConstrainSelectedInstOperands,
     /*  701949 */     // GIR_Coverage, 11276,
     /*  701949 */     GIR_EraseRootFromParent_Done,
     /*  701950 */   // Label 11111: @701950
     /*  701950 */   GIM_Try, /*On fail goto*//*Label 11112*/ GIMT_Encode4(702025), // Rule ID 11277 //
     /*  701955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  701966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  701969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  701972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702001 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  702004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702023 */     GIR_RootConstrainSelectedInstOperands,
     /*  702024 */     // GIR_Coverage, 11277,
     /*  702024 */     GIR_EraseRootFromParent_Done,
     /*  702025 */   // Label 11112: @702025
     /*  702025 */   GIM_Try, /*On fail goto*//*Label 11113*/ GIMT_Encode4(702100), // Rule ID 11280 //
     /*  702030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  702041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  702044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  702047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  702050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  702069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  702079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702098 */     GIR_RootConstrainSelectedInstOperands,
     /*  702099 */     // GIR_Coverage, 11280,
     /*  702099 */     GIR_EraseRootFromParent_Done,
     /*  702100 */   // Label 11113: @702100
     /*  702100 */   GIM_Try, /*On fail goto*//*Label 11114*/ GIMT_Encode4(702175), // Rule ID 11281 //
     /*  702105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  702116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  702119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  702122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  702125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  702144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702151 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  702154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702173 */     GIR_RootConstrainSelectedInstOperands,
     /*  702174 */     // GIR_Coverage, 11281,
     /*  702174 */     GIR_EraseRootFromParent_Done,
     /*  702175 */   // Label 11114: @702175
     /*  702175 */   GIM_Try, /*On fail goto*//*Label 11115*/ GIMT_Encode4(702250), // Rule ID 11284 //
     /*  702180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  702191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  702194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  702197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  702200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  702219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702226 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  702229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702248 */     GIR_RootConstrainSelectedInstOperands,
     /*  702249 */     // GIR_Coverage, 11284,
     /*  702249 */     GIR_EraseRootFromParent_Done,
     /*  702250 */   // Label 11115: @702250
     /*  702250 */   GIM_Try, /*On fail goto*//*Label 11116*/ GIMT_Encode4(702325), // Rule ID 11285 //
     /*  702255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  702266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  702269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  702272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  702275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  702294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702301 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  702304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702323 */     GIR_RootConstrainSelectedInstOperands,
     /*  702324 */     // GIR_Coverage, 11285,
     /*  702324 */     GIR_EraseRootFromParent_Done,
     /*  702325 */   // Label 11116: @702325
     /*  702325 */   GIM_Try, /*On fail goto*//*Label 11117*/ GIMT_Encode4(702400), // Rule ID 11288 //
     /*  702330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  702341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  702344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  702347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  702350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  702369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702376 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  702379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702398 */     GIR_RootConstrainSelectedInstOperands,
     /*  702399 */     // GIR_Coverage, 11288,
     /*  702399 */     GIR_EraseRootFromParent_Done,
     /*  702400 */   // Label 11117: @702400
     /*  702400 */   GIM_Try, /*On fail goto*//*Label 11118*/ GIMT_Encode4(702475), // Rule ID 11289 //
     /*  702405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  702416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  702419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  702422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  702425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  702444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702451 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  702454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702473 */     GIR_RootConstrainSelectedInstOperands,
     /*  702474 */     // GIR_Coverage, 11289,
     /*  702474 */     GIR_EraseRootFromParent_Done,
     /*  702475 */   // Label 11118: @702475
     /*  702475 */   GIM_Try, /*On fail goto*//*Label 11119*/ GIMT_Encode4(702550), // Rule ID 11292 //
     /*  702480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  702491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  702494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  702497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  702500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702526 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  702529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702548 */     GIR_RootConstrainSelectedInstOperands,
     /*  702549 */     // GIR_Coverage, 11292,
     /*  702549 */     GIR_EraseRootFromParent_Done,
     /*  702550 */   // Label 11119: @702550
     /*  702550 */   GIM_Try, /*On fail goto*//*Label 11120*/ GIMT_Encode4(702625), // Rule ID 11293 //
     /*  702555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  702566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  702569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  702572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  702575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702601 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  702604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702623 */     GIR_RootConstrainSelectedInstOperands,
     /*  702624 */     // GIR_Coverage, 11293,
     /*  702624 */     GIR_EraseRootFromParent_Done,
     /*  702625 */   // Label 11120: @702625
     /*  702625 */   GIM_Try, /*On fail goto*//*Label 11121*/ GIMT_Encode4(702700), // Rule ID 11296 //
     /*  702630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  702641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  702644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  702647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  702650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702676 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702698 */     GIR_RootConstrainSelectedInstOperands,
     /*  702699 */     // GIR_Coverage, 11296,
     /*  702699 */     GIR_EraseRootFromParent_Done,
     /*  702700 */   // Label 11121: @702700
     /*  702700 */   GIM_Try, /*On fail goto*//*Label 11122*/ GIMT_Encode4(702775), // Rule ID 11297 //
     /*  702705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  702716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  702719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  702722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  702725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702751 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702773 */     GIR_RootConstrainSelectedInstOperands,
     /*  702774 */     // GIR_Coverage, 11297,
     /*  702774 */     GIR_EraseRootFromParent_Done,
     /*  702775 */   // Label 11122: @702775
     /*  702775 */   GIM_Try, /*On fail goto*//*Label 11123*/ GIMT_Encode4(702850), // Rule ID 11300 //
     /*  702780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  702791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  702794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  702797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  702800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702826 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702848 */     GIR_RootConstrainSelectedInstOperands,
     /*  702849 */     // GIR_Coverage, 11300,
     /*  702849 */     GIR_EraseRootFromParent_Done,
     /*  702850 */   // Label 11123: @702850
     /*  702850 */   GIM_Try, /*On fail goto*//*Label 11124*/ GIMT_Encode4(702925), // Rule ID 11301 //
     /*  702855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  702866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  702869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  702872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  702875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702901 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702923 */     GIR_RootConstrainSelectedInstOperands,
     /*  702924 */     // GIR_Coverage, 11301,
     /*  702924 */     GIR_EraseRootFromParent_Done,
     /*  702925 */   // Label 11124: @702925
     /*  702925 */   GIM_Try, /*On fail goto*//*Label 11125*/ GIMT_Encode4(703000), // Rule ID 11304 //
     /*  702930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  702941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  702944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  702947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  702950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702998 */     GIR_RootConstrainSelectedInstOperands,
     /*  702999 */     // GIR_Coverage, 11304,
     /*  702999 */     GIR_EraseRootFromParent_Done,
     /*  703000 */   // Label 11125: @703000
     /*  703000 */   GIM_Try, /*On fail goto*//*Label 11126*/ GIMT_Encode4(703075), // Rule ID 11305 //
     /*  703005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  703016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  703019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  703022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  703025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703051 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  703054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703073 */     GIR_RootConstrainSelectedInstOperands,
     /*  703074 */     // GIR_Coverage, 11305,
     /*  703074 */     GIR_EraseRootFromParent_Done,
     /*  703075 */   // Label 11126: @703075
     /*  703075 */   GIM_Try, /*On fail goto*//*Label 11127*/ GIMT_Encode4(703150), // Rule ID 11308 //
     /*  703080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  703091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  703094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  703097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  703100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  703129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703148 */     GIR_RootConstrainSelectedInstOperands,
     /*  703149 */     // GIR_Coverage, 11308,
     /*  703149 */     GIR_EraseRootFromParent_Done,
     /*  703150 */   // Label 11127: @703150
     /*  703150 */   GIM_Try, /*On fail goto*//*Label 11128*/ GIMT_Encode4(703225), // Rule ID 11309 //
     /*  703155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  703166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  703169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  703172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  703175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703201 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  703204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703223 */     GIR_RootConstrainSelectedInstOperands,
     /*  703224 */     // GIR_Coverage, 11309,
     /*  703224 */     GIR_EraseRootFromParent_Done,
     /*  703225 */   // Label 11128: @703225
     /*  703225 */   GIM_Try, /*On fail goto*//*Label 11129*/ GIMT_Encode4(703300), // Rule ID 11312 //
     /*  703230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  703241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  703244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  703247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  703250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  703279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703298 */     GIR_RootConstrainSelectedInstOperands,
     /*  703299 */     // GIR_Coverage, 11312,
     /*  703299 */     GIR_EraseRootFromParent_Done,
     /*  703300 */   // Label 11129: @703300
     /*  703300 */   GIM_Try, /*On fail goto*//*Label 11130*/ GIMT_Encode4(703375), // Rule ID 11313 //
     /*  703305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  703316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  703319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  703322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  703325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703351 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  703351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  703354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703373 */     GIR_RootConstrainSelectedInstOperands,
     /*  703374 */     // GIR_Coverage, 11313,
     /*  703374 */     GIR_EraseRootFromParent_Done,
     /*  703375 */   // Label 11130: @703375
     /*  703375 */   GIM_Try, /*On fail goto*//*Label 11131*/ GIMT_Encode4(703450), // Rule ID 11316 //
     /*  703380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  703391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  703394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  703397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  703400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703448 */     GIR_RootConstrainSelectedInstOperands,
     /*  703449 */     // GIR_Coverage, 11316,
     /*  703449 */     GIR_EraseRootFromParent_Done,
     /*  703450 */   // Label 11131: @703450
     /*  703450 */   GIM_Try, /*On fail goto*//*Label 11132*/ GIMT_Encode4(703525), // Rule ID 11317 //
     /*  703455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  703466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  703469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  703472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  703475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703501 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703523 */     GIR_RootConstrainSelectedInstOperands,
     /*  703524 */     // GIR_Coverage, 11317,
     /*  703524 */     GIR_EraseRootFromParent_Done,
     /*  703525 */   // Label 11132: @703525
     /*  703525 */   GIM_Try, /*On fail goto*//*Label 11133*/ GIMT_Encode4(703600), // Rule ID 11320 //
     /*  703530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  703541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  703544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  703547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  703550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703598 */     GIR_RootConstrainSelectedInstOperands,
     /*  703599 */     // GIR_Coverage, 11320,
     /*  703599 */     GIR_EraseRootFromParent_Done,
     /*  703600 */   // Label 11133: @703600
     /*  703600 */   GIM_Try, /*On fail goto*//*Label 11134*/ GIMT_Encode4(703675), // Rule ID 11321 //
     /*  703605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  703616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  703619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  703622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  703625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703651 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703673 */     GIR_RootConstrainSelectedInstOperands,
     /*  703674 */     // GIR_Coverage, 11321,
     /*  703674 */     GIR_EraseRootFromParent_Done,
     /*  703675 */   // Label 11134: @703675
     /*  703675 */   GIM_Try, /*On fail goto*//*Label 11135*/ GIMT_Encode4(703750), // Rule ID 11324 //
     /*  703680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  703691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  703694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  703697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  703700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703748 */     GIR_RootConstrainSelectedInstOperands,
     /*  703749 */     // GIR_Coverage, 11324,
     /*  703749 */     GIR_EraseRootFromParent_Done,
     /*  703750 */   // Label 11135: @703750
     /*  703750 */   GIM_Try, /*On fail goto*//*Label 11136*/ GIMT_Encode4(703825), // Rule ID 11325 //
     /*  703755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  703766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  703769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  703772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  703775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703801 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  703801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703823 */     GIR_RootConstrainSelectedInstOperands,
     /*  703824 */     // GIR_Coverage, 11325,
     /*  703824 */     GIR_EraseRootFromParent_Done,
     /*  703825 */   // Label 11136: @703825
     /*  703825 */   GIM_Try, /*On fail goto*//*Label 11137*/ GIMT_Encode4(703900), // Rule ID 11328 //
     /*  703830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  703841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  703844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  703847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  703850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703876 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703898 */     GIR_RootConstrainSelectedInstOperands,
     /*  703899 */     // GIR_Coverage, 11328,
     /*  703899 */     GIR_EraseRootFromParent_Done,
     /*  703900 */   // Label 11137: @703900
     /*  703900 */   GIM_Try, /*On fail goto*//*Label 11138*/ GIMT_Encode4(703975), // Rule ID 11329 //
     /*  703905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  703916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  703919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  703922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  703925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703951 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703973 */     GIR_RootConstrainSelectedInstOperands,
     /*  703974 */     // GIR_Coverage, 11329,
     /*  703974 */     GIR_EraseRootFromParent_Done,
     /*  703975 */   // Label 11138: @703975
     /*  703975 */   GIM_Try, /*On fail goto*//*Label 11139*/ GIMT_Encode4(704050), // Rule ID 11332 //
     /*  703980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  703991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  703994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  703997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  704000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704026 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704048 */     GIR_RootConstrainSelectedInstOperands,
     /*  704049 */     // GIR_Coverage, 11332,
     /*  704049 */     GIR_EraseRootFromParent_Done,
     /*  704050 */   // Label 11139: @704050
     /*  704050 */   GIM_Try, /*On fail goto*//*Label 11140*/ GIMT_Encode4(704125), // Rule ID 11333 //
     /*  704055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  704066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  704069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  704072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  704075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704101 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704123 */     GIR_RootConstrainSelectedInstOperands,
     /*  704124 */     // GIR_Coverage, 11333,
     /*  704124 */     GIR_EraseRootFromParent_Done,
     /*  704125 */   // Label 11140: @704125
     /*  704125 */   GIM_Try, /*On fail goto*//*Label 11141*/ GIMT_Encode4(704200), // Rule ID 11336 //
     /*  704130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  704141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  704144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  704147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  704150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704176 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704198 */     GIR_RootConstrainSelectedInstOperands,
     /*  704199 */     // GIR_Coverage, 11336,
     /*  704199 */     GIR_EraseRootFromParent_Done,
     /*  704200 */   // Label 11141: @704200
     /*  704200 */   GIM_Try, /*On fail goto*//*Label 11142*/ GIMT_Encode4(704275), // Rule ID 11337 //
     /*  704205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  704216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  704219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  704222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  704225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704251 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704273 */     GIR_RootConstrainSelectedInstOperands,
     /*  704274 */     // GIR_Coverage, 11337,
     /*  704274 */     GIR_EraseRootFromParent_Done,
     /*  704275 */   // Label 11142: @704275
     /*  704275 */   GIM_Try, /*On fail goto*//*Label 11143*/ GIMT_Encode4(704350), // Rule ID 11340 //
     /*  704280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  704291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  704294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  704297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  704300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  704329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704348 */     GIR_RootConstrainSelectedInstOperands,
     /*  704349 */     // GIR_Coverage, 11340,
     /*  704349 */     GIR_EraseRootFromParent_Done,
     /*  704350 */   // Label 11143: @704350
     /*  704350 */   GIM_Try, /*On fail goto*//*Label 11144*/ GIMT_Encode4(704425), // Rule ID 11341 //
     /*  704355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  704366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  704369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  704372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  704375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704401 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  704404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704423 */     GIR_RootConstrainSelectedInstOperands,
     /*  704424 */     // GIR_Coverage, 11341,
     /*  704424 */     GIR_EraseRootFromParent_Done,
     /*  704425 */   // Label 11144: @704425
     /*  704425 */   GIM_Try, /*On fail goto*//*Label 11145*/ GIMT_Encode4(704500), // Rule ID 11344 //
     /*  704430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  704441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  704444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  704447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  704450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704476 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704498 */     GIR_RootConstrainSelectedInstOperands,
     /*  704499 */     // GIR_Coverage, 11344,
     /*  704499 */     GIR_EraseRootFromParent_Done,
     /*  704500 */   // Label 11145: @704500
     /*  704500 */   GIM_Try, /*On fail goto*//*Label 11146*/ GIMT_Encode4(704575), // Rule ID 11345 //
     /*  704505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  704516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  704519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  704522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  704525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704551 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704573 */     GIR_RootConstrainSelectedInstOperands,
     /*  704574 */     // GIR_Coverage, 11345,
     /*  704574 */     GIR_EraseRootFromParent_Done,
     /*  704575 */   // Label 11146: @704575
     /*  704575 */   GIM_Try, /*On fail goto*//*Label 11147*/ GIMT_Encode4(704650), // Rule ID 11348 //
     /*  704580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  704591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  704594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  704597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  704600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704626 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704648 */     GIR_RootConstrainSelectedInstOperands,
     /*  704649 */     // GIR_Coverage, 11348,
     /*  704649 */     GIR_EraseRootFromParent_Done,
     /*  704650 */   // Label 11147: @704650
     /*  704650 */   GIM_Try, /*On fail goto*//*Label 11148*/ GIMT_Encode4(704725), // Rule ID 11349 //
     /*  704655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  704666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  704669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  704672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  704675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704701 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704723 */     GIR_RootConstrainSelectedInstOperands,
     /*  704724 */     // GIR_Coverage, 11349,
     /*  704724 */     GIR_EraseRootFromParent_Done,
     /*  704725 */   // Label 11148: @704725
     /*  704725 */   GIM_Try, /*On fail goto*//*Label 11149*/ GIMT_Encode4(704800), // Rule ID 11352 //
     /*  704730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  704741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  704744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  704747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  704750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  704779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704798 */     GIR_RootConstrainSelectedInstOperands,
     /*  704799 */     // GIR_Coverage, 11352,
     /*  704799 */     GIR_EraseRootFromParent_Done,
     /*  704800 */   // Label 11149: @704800
     /*  704800 */   GIM_Try, /*On fail goto*//*Label 11150*/ GIMT_Encode4(704875), // Rule ID 11353 //
     /*  704805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  704816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  704819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  704822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  704825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  704854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704873 */     GIR_RootConstrainSelectedInstOperands,
     /*  704874 */     // GIR_Coverage, 11353,
     /*  704874 */     GIR_EraseRootFromParent_Done,
     /*  704875 */   // Label 11150: @704875
     /*  704875 */   GIM_Try, /*On fail goto*//*Label 11151*/ GIMT_Encode4(704950), // Rule ID 11356 //
     /*  704880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  704891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  704894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  704897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  704900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704948 */     GIR_RootConstrainSelectedInstOperands,
     /*  704949 */     // GIR_Coverage, 11356,
     /*  704949 */     GIR_EraseRootFromParent_Done,
     /*  704950 */   // Label 11151: @704950
     /*  704950 */   GIM_Try, /*On fail goto*//*Label 11152*/ GIMT_Encode4(705025), // Rule ID 11357 //
     /*  704955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  704966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  704969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  704972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  704975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705001 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  705004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705023 */     GIR_RootConstrainSelectedInstOperands,
     /*  705024 */     // GIR_Coverage, 11357,
     /*  705024 */     GIR_EraseRootFromParent_Done,
     /*  705025 */   // Label 11152: @705025
     /*  705025 */   GIM_Try, /*On fail goto*//*Label 11153*/ GIMT_Encode4(705100), // Rule ID 11360 //
     /*  705030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  705041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  705044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  705047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  705050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  705079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705098 */     GIR_RootConstrainSelectedInstOperands,
     /*  705099 */     // GIR_Coverage, 11360,
     /*  705099 */     GIR_EraseRootFromParent_Done,
     /*  705100 */   // Label 11153: @705100
     /*  705100 */   GIM_Try, /*On fail goto*//*Label 11154*/ GIMT_Encode4(705175), // Rule ID 11361 //
     /*  705105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  705116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  705119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  705122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  705125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705151 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  705154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705173 */     GIR_RootConstrainSelectedInstOperands,
     /*  705174 */     // GIR_Coverage, 11361,
     /*  705174 */     GIR_EraseRootFromParent_Done,
     /*  705175 */   // Label 11154: @705175
     /*  705175 */   GIM_Try, /*On fail goto*//*Label 11155*/ GIMT_Encode4(705250), // Rule ID 11364 //
     /*  705180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  705191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  705194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  705197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705226 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  705229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705248 */     GIR_RootConstrainSelectedInstOperands,
     /*  705249 */     // GIR_Coverage, 11364,
     /*  705249 */     GIR_EraseRootFromParent_Done,
     /*  705250 */   // Label 11155: @705250
     /*  705250 */   GIM_Try, /*On fail goto*//*Label 11156*/ GIMT_Encode4(705325), // Rule ID 11365 //
     /*  705255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  705266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  705269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  705272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705301 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  705304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705323 */     GIR_RootConstrainSelectedInstOperands,
     /*  705324 */     // GIR_Coverage, 11365,
     /*  705324 */     GIR_EraseRootFromParent_Done,
     /*  705325 */   // Label 11156: @705325
     /*  705325 */   GIM_Try, /*On fail goto*//*Label 11157*/ GIMT_Encode4(705400), // Rule ID 11368 //
     /*  705330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  705341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  705344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  705347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  705379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705398 */     GIR_RootConstrainSelectedInstOperands,
     /*  705399 */     // GIR_Coverage, 11368,
     /*  705399 */     GIR_EraseRootFromParent_Done,
     /*  705400 */   // Label 11157: @705400
     /*  705400 */   GIM_Try, /*On fail goto*//*Label 11158*/ GIMT_Encode4(705475), // Rule ID 11369 //
     /*  705405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  705416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  705419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  705422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705451 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  705454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705473 */     GIR_RootConstrainSelectedInstOperands,
     /*  705474 */     // GIR_Coverage, 11369,
     /*  705474 */     GIR_EraseRootFromParent_Done,
     /*  705475 */   // Label 11158: @705475
     /*  705475 */   GIM_Try, /*On fail goto*//*Label 11159*/ GIMT_Encode4(705550), // Rule ID 11372 //
     /*  705480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  705491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  705494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  705497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705526 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705548 */     GIR_RootConstrainSelectedInstOperands,
     /*  705549 */     // GIR_Coverage, 11372,
     /*  705549 */     GIR_EraseRootFromParent_Done,
     /*  705550 */   // Label 11159: @705550
     /*  705550 */   GIM_Try, /*On fail goto*//*Label 11160*/ GIMT_Encode4(705625), // Rule ID 11373 //
     /*  705555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  705566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  705569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  705572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705601 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705623 */     GIR_RootConstrainSelectedInstOperands,
     /*  705624 */     // GIR_Coverage, 11373,
     /*  705624 */     GIR_EraseRootFromParent_Done,
     /*  705625 */   // Label 11160: @705625
     /*  705625 */   GIM_Try, /*On fail goto*//*Label 11161*/ GIMT_Encode4(705700), // Rule ID 11376 //
     /*  705630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  705641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  705644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  705647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705676 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  705679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705698 */     GIR_RootConstrainSelectedInstOperands,
     /*  705699 */     // GIR_Coverage, 11376,
     /*  705699 */     GIR_EraseRootFromParent_Done,
     /*  705700 */   // Label 11161: @705700
     /*  705700 */   GIM_Try, /*On fail goto*//*Label 11162*/ GIMT_Encode4(705775), // Rule ID 11377 //
     /*  705705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  705716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  705719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  705722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705751 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  705754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705773 */     GIR_RootConstrainSelectedInstOperands,
     /*  705774 */     // GIR_Coverage, 11377,
     /*  705774 */     GIR_EraseRootFromParent_Done,
     /*  705775 */   // Label 11162: @705775
     /*  705775 */   GIM_Try, /*On fail goto*//*Label 11163*/ GIMT_Encode4(705850), // Rule ID 11380 //
     /*  705780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  705791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  705794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  705797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705848 */     GIR_RootConstrainSelectedInstOperands,
     /*  705849 */     // GIR_Coverage, 11380,
     /*  705849 */     GIR_EraseRootFromParent_Done,
     /*  705850 */   // Label 11163: @705850
     /*  705850 */   GIM_Try, /*On fail goto*//*Label 11164*/ GIMT_Encode4(705925), // Rule ID 11381 //
     /*  705855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  705866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  705869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  705872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705901 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705923 */     GIR_RootConstrainSelectedInstOperands,
     /*  705924 */     // GIR_Coverage, 11381,
     /*  705924 */     GIR_EraseRootFromParent_Done,
     /*  705925 */   // Label 11164: @705925
     /*  705925 */   GIM_Try, /*On fail goto*//*Label 11165*/ GIMT_Encode4(706000), // Rule ID 11384 //
     /*  705930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  705941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  705944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  705947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705976 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705998 */     GIR_RootConstrainSelectedInstOperands,
     /*  705999 */     // GIR_Coverage, 11384,
     /*  705999 */     GIR_EraseRootFromParent_Done,
     /*  706000 */   // Label 11165: @706000
     /*  706000 */   GIM_Try, /*On fail goto*//*Label 11166*/ GIMT_Encode4(706075), // Rule ID 11385 //
     /*  706005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  706016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  706019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  706022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706051 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  706054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706073 */     GIR_RootConstrainSelectedInstOperands,
     /*  706074 */     // GIR_Coverage, 11385,
     /*  706074 */     GIR_EraseRootFromParent_Done,
     /*  706075 */   // Label 11166: @706075
     /*  706075 */   GIM_Try, /*On fail goto*//*Label 11167*/ GIMT_Encode4(706150), // Rule ID 11388 //
     /*  706080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  706091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  706094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  706097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706126 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706148 */     GIR_RootConstrainSelectedInstOperands,
     /*  706149 */     // GIR_Coverage, 11388,
     /*  706149 */     GIR_EraseRootFromParent_Done,
     /*  706150 */   // Label 11167: @706150
     /*  706150 */   GIM_Try, /*On fail goto*//*Label 11168*/ GIMT_Encode4(706225), // Rule ID 11389 //
     /*  706155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  706166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  706169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  706172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706201 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706223 */     GIR_RootConstrainSelectedInstOperands,
     /*  706224 */     // GIR_Coverage, 11389,
     /*  706224 */     GIR_EraseRootFromParent_Done,
     /*  706225 */   // Label 11168: @706225
     /*  706225 */   GIM_Try, /*On fail goto*//*Label 11169*/ GIMT_Encode4(706300), // Rule ID 11392 //
     /*  706230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  706241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  706244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  706247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706298 */     GIR_RootConstrainSelectedInstOperands,
     /*  706299 */     // GIR_Coverage, 11392,
     /*  706299 */     GIR_EraseRootFromParent_Done,
     /*  706300 */   // Label 11169: @706300
     /*  706300 */   GIM_Try, /*On fail goto*//*Label 11170*/ GIMT_Encode4(706375), // Rule ID 11393 //
     /*  706305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  706316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  706319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  706322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706351 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706373 */     GIR_RootConstrainSelectedInstOperands,
     /*  706374 */     // GIR_Coverage, 11393,
     /*  706374 */     GIR_EraseRootFromParent_Done,
     /*  706375 */   // Label 11170: @706375
     /*  706375 */   GIM_Try, /*On fail goto*//*Label 11171*/ GIMT_Encode4(706450), // Rule ID 11396 //
     /*  706380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  706391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  706394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  706397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706426 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  706426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706448 */     GIR_RootConstrainSelectedInstOperands,
     /*  706449 */     // GIR_Coverage, 11396,
     /*  706449 */     GIR_EraseRootFromParent_Done,
     /*  706450 */   // Label 11171: @706450
     /*  706450 */   GIM_Try, /*On fail goto*//*Label 11172*/ GIMT_Encode4(706525), // Rule ID 11397 //
     /*  706455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  706466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  706469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  706472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706501 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706523 */     GIR_RootConstrainSelectedInstOperands,
     /*  706524 */     // GIR_Coverage, 11397,
     /*  706524 */     GIR_EraseRootFromParent_Done,
     /*  706525 */   // Label 11172: @706525
     /*  706525 */   GIM_Try, /*On fail goto*//*Label 11173*/ GIMT_Encode4(706600), // Rule ID 11400 //
     /*  706530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  706541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  706544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  706547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706598 */     GIR_RootConstrainSelectedInstOperands,
     /*  706599 */     // GIR_Coverage, 11400,
     /*  706599 */     GIR_EraseRootFromParent_Done,
     /*  706600 */   // Label 11173: @706600
     /*  706600 */   GIM_Try, /*On fail goto*//*Label 11174*/ GIMT_Encode4(706675), // Rule ID 11401 //
     /*  706605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  706616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  706619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  706622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706651 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706673 */     GIR_RootConstrainSelectedInstOperands,
     /*  706674 */     // GIR_Coverage, 11401,
     /*  706674 */     GIR_EraseRootFromParent_Done,
     /*  706675 */   // Label 11174: @706675
     /*  706675 */   GIM_Try, /*On fail goto*//*Label 11175*/ GIMT_Encode4(706750), // Rule ID 11404 //
     /*  706680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  706691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  706694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  706697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706726 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706748 */     GIR_RootConstrainSelectedInstOperands,
     /*  706749 */     // GIR_Coverage, 11404,
     /*  706749 */     GIR_EraseRootFromParent_Done,
     /*  706750 */   // Label 11175: @706750
     /*  706750 */   GIM_Try, /*On fail goto*//*Label 11176*/ GIMT_Encode4(706825), // Rule ID 11405 //
     /*  706755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  706766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  706769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  706772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706801 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706823 */     GIR_RootConstrainSelectedInstOperands,
     /*  706824 */     // GIR_Coverage, 11405,
     /*  706824 */     GIR_EraseRootFromParent_Done,
     /*  706825 */   // Label 11176: @706825
     /*  706825 */   GIM_Try, /*On fail goto*//*Label 11177*/ GIMT_Encode4(706900), // Rule ID 11408 //
     /*  706830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  706841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  706844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  706847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706876 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706898 */     GIR_RootConstrainSelectedInstOperands,
     /*  706899 */     // GIR_Coverage, 11408,
     /*  706899 */     GIR_EraseRootFromParent_Done,
     /*  706900 */   // Label 11177: @706900
     /*  706900 */   GIM_Try, /*On fail goto*//*Label 11178*/ GIMT_Encode4(706975), // Rule ID 11409 //
     /*  706905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  706916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  706919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  706922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706951 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706973 */     GIR_RootConstrainSelectedInstOperands,
     /*  706974 */     // GIR_Coverage, 11409,
     /*  706974 */     GIR_EraseRootFromParent_Done,
     /*  706975 */   // Label 11178: @706975
     /*  706975 */   GIM_Try, /*On fail goto*//*Label 11179*/ GIMT_Encode4(707050), // Rule ID 11412 //
     /*  706980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  706991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  706994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  706997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707026 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  707029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707048 */     GIR_RootConstrainSelectedInstOperands,
     /*  707049 */     // GIR_Coverage, 11412,
     /*  707049 */     GIR_EraseRootFromParent_Done,
     /*  707050 */   // Label 11179: @707050
     /*  707050 */   GIM_Try, /*On fail goto*//*Label 11180*/ GIMT_Encode4(707125), // Rule ID 11413 //
     /*  707055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  707066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  707069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  707072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  707104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707123 */     GIR_RootConstrainSelectedInstOperands,
     /*  707124 */     // GIR_Coverage, 11413,
     /*  707124 */     GIR_EraseRootFromParent_Done,
     /*  707125 */   // Label 11180: @707125
     /*  707125 */   GIM_Try, /*On fail goto*//*Label 11181*/ GIMT_Encode4(707200), // Rule ID 11416 //
     /*  707130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  707141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  707144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  707147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707176 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  707179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707198 */     GIR_RootConstrainSelectedInstOperands,
     /*  707199 */     // GIR_Coverage, 11416,
     /*  707199 */     GIR_EraseRootFromParent_Done,
     /*  707200 */   // Label 11181: @707200
     /*  707200 */   GIM_Try, /*On fail goto*//*Label 11182*/ GIMT_Encode4(707275), // Rule ID 11417 //
     /*  707205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  707216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  707219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  707222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707251 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  707254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707273 */     GIR_RootConstrainSelectedInstOperands,
     /*  707274 */     // GIR_Coverage, 11417,
     /*  707274 */     GIR_EraseRootFromParent_Done,
     /*  707275 */   // Label 11182: @707275
     /*  707275 */   GIM_Try, /*On fail goto*//*Label 11183*/ GIMT_Encode4(707350), // Rule ID 11420 //
     /*  707280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  707291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  707294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  707297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  707329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707348 */     GIR_RootConstrainSelectedInstOperands,
     /*  707349 */     // GIR_Coverage, 11420,
     /*  707349 */     GIR_EraseRootFromParent_Done,
     /*  707350 */   // Label 11183: @707350
     /*  707350 */   GIM_Try, /*On fail goto*//*Label 11184*/ GIMT_Encode4(707425), // Rule ID 11421 //
     /*  707355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  707366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  707369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  707372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707401 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  707404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707423 */     GIR_RootConstrainSelectedInstOperands,
     /*  707424 */     // GIR_Coverage, 11421,
     /*  707424 */     GIR_EraseRootFromParent_Done,
     /*  707425 */   // Label 11184: @707425
     /*  707425 */   GIM_Try, /*On fail goto*//*Label 11185*/ GIMT_Encode4(707500), // Rule ID 11424 //
     /*  707430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  707441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  707444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  707447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  707479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707498 */     GIR_RootConstrainSelectedInstOperands,
     /*  707499 */     // GIR_Coverage, 11424,
     /*  707499 */     GIR_EraseRootFromParent_Done,
     /*  707500 */   // Label 11185: @707500
     /*  707500 */   GIM_Try, /*On fail goto*//*Label 11186*/ GIMT_Encode4(707575), // Rule ID 11425 //
     /*  707505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  707516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  707519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  707522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707551 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  707554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707573 */     GIR_RootConstrainSelectedInstOperands,
     /*  707574 */     // GIR_Coverage, 11425,
     /*  707574 */     GIR_EraseRootFromParent_Done,
     /*  707575 */   // Label 11186: @707575
     /*  707575 */   GIM_Try, /*On fail goto*//*Label 11187*/ GIMT_Encode4(707650), // Rule ID 11428 //
     /*  707580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  707591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  707594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  707597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707626 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  707629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707648 */     GIR_RootConstrainSelectedInstOperands,
     /*  707649 */     // GIR_Coverage, 11428,
     /*  707649 */     GIR_EraseRootFromParent_Done,
     /*  707650 */   // Label 11187: @707650
     /*  707650 */   GIM_Try, /*On fail goto*//*Label 11188*/ GIMT_Encode4(707725), // Rule ID 11429 //
     /*  707655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  707666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  707669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  707672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707701 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  707704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707723 */     GIR_RootConstrainSelectedInstOperands,
     /*  707724 */     // GIR_Coverage, 11429,
     /*  707724 */     GIR_EraseRootFromParent_Done,
     /*  707725 */   // Label 11188: @707725
     /*  707725 */   GIM_Try, /*On fail goto*//*Label 11189*/ GIMT_Encode4(707800), // Rule ID 11432 //
     /*  707730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  707741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  707744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  707747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707776 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  707779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707798 */     GIR_RootConstrainSelectedInstOperands,
     /*  707799 */     // GIR_Coverage, 11432,
     /*  707799 */     GIR_EraseRootFromParent_Done,
     /*  707800 */   // Label 11189: @707800
     /*  707800 */   GIM_Try, /*On fail goto*//*Label 11190*/ GIMT_Encode4(707875), // Rule ID 11433 //
     /*  707805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  707816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  707819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  707822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707851 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  707854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707873 */     GIR_RootConstrainSelectedInstOperands,
     /*  707874 */     // GIR_Coverage, 11433,
     /*  707874 */     GIR_EraseRootFromParent_Done,
     /*  707875 */   // Label 11190: @707875
     /*  707875 */   GIM_Try, /*On fail goto*//*Label 11191*/ GIMT_Encode4(707950), // Rule ID 11436 //
     /*  707880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  707891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  707894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  707897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  707900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707926 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  707929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707948 */     GIR_RootConstrainSelectedInstOperands,
     /*  707949 */     // GIR_Coverage, 11436,
     /*  707949 */     GIR_EraseRootFromParent_Done,
     /*  707950 */   // Label 11191: @707950
     /*  707950 */   GIM_Try, /*On fail goto*//*Label 11192*/ GIMT_Encode4(708025), // Rule ID 11437 //
     /*  707955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  707966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  707969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  707972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  707975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708001 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  708004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708023 */     GIR_RootConstrainSelectedInstOperands,
     /*  708024 */     // GIR_Coverage, 11437,
     /*  708024 */     GIR_EraseRootFromParent_Done,
     /*  708025 */   // Label 11192: @708025
     /*  708025 */   GIM_Try, /*On fail goto*//*Label 11193*/ GIMT_Encode4(708100), // Rule ID 11440 //
     /*  708030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  708041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  708044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  708047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  708050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708076 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  708079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708098 */     GIR_RootConstrainSelectedInstOperands,
     /*  708099 */     // GIR_Coverage, 11440,
     /*  708099 */     GIR_EraseRootFromParent_Done,
     /*  708100 */   // Label 11193: @708100
     /*  708100 */   GIM_Try, /*On fail goto*//*Label 11194*/ GIMT_Encode4(708175), // Rule ID 11441 //
     /*  708105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  708116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  708119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  708122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  708125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708151 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  708154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708173 */     GIR_RootConstrainSelectedInstOperands,
     /*  708174 */     // GIR_Coverage, 11441,
     /*  708174 */     GIR_EraseRootFromParent_Done,
     /*  708175 */   // Label 11194: @708175
     /*  708175 */   GIM_Try, /*On fail goto*//*Label 11195*/ GIMT_Encode4(708250), // Rule ID 11444 //
     /*  708180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  708191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  708194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  708197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  708200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708226 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708248 */     GIR_RootConstrainSelectedInstOperands,
     /*  708249 */     // GIR_Coverage, 11444,
     /*  708249 */     GIR_EraseRootFromParent_Done,
     /*  708250 */   // Label 11195: @708250
     /*  708250 */   GIM_Try, /*On fail goto*//*Label 11196*/ GIMT_Encode4(708325), // Rule ID 11445 //
     /*  708255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  708266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  708269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  708272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  708275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708301 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708323 */     GIR_RootConstrainSelectedInstOperands,
     /*  708324 */     // GIR_Coverage, 11445,
     /*  708324 */     GIR_EraseRootFromParent_Done,
     /*  708325 */   // Label 11196: @708325
     /*  708325 */   GIM_Try, /*On fail goto*//*Label 11197*/ GIMT_Encode4(708400), // Rule ID 11448 //
     /*  708330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  708341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  708344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  708347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  708350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  708379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708398 */     GIR_RootConstrainSelectedInstOperands,
     /*  708399 */     // GIR_Coverage, 11448,
     /*  708399 */     GIR_EraseRootFromParent_Done,
     /*  708400 */   // Label 11197: @708400
     /*  708400 */   GIM_Try, /*On fail goto*//*Label 11198*/ GIMT_Encode4(708475), // Rule ID 11449 //
     /*  708405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  708416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  708419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  708422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  708425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708451 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  708454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708473 */     GIR_RootConstrainSelectedInstOperands,
     /*  708474 */     // GIR_Coverage, 11449,
     /*  708474 */     GIR_EraseRootFromParent_Done,
     /*  708475 */   // Label 11198: @708475
     /*  708475 */   GIM_Try, /*On fail goto*//*Label 11199*/ GIMT_Encode4(708550), // Rule ID 11452 //
     /*  708480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  708491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  708494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  708497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  708500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708526 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708548 */     GIR_RootConstrainSelectedInstOperands,
     /*  708549 */     // GIR_Coverage, 11452,
     /*  708549 */     GIR_EraseRootFromParent_Done,
     /*  708550 */   // Label 11199: @708550
     /*  708550 */   GIM_Try, /*On fail goto*//*Label 11200*/ GIMT_Encode4(708625), // Rule ID 11453 //
     /*  708555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  708566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  708569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  708572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  708575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708601 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708623 */     GIR_RootConstrainSelectedInstOperands,
     /*  708624 */     // GIR_Coverage, 11453,
     /*  708624 */     GIR_EraseRootFromParent_Done,
     /*  708625 */   // Label 11200: @708625
     /*  708625 */   GIM_Try, /*On fail goto*//*Label 11201*/ GIMT_Encode4(708700), // Rule ID 11456 //
     /*  708630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  708641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  708644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  708647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  708650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708676 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708698 */     GIR_RootConstrainSelectedInstOperands,
     /*  708699 */     // GIR_Coverage, 11456,
     /*  708699 */     GIR_EraseRootFromParent_Done,
     /*  708700 */   // Label 11201: @708700
     /*  708700 */   GIM_Try, /*On fail goto*//*Label 11202*/ GIMT_Encode4(708775), // Rule ID 11457 //
     /*  708705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  708716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  708719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  708722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  708725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708751 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708773 */     GIR_RootConstrainSelectedInstOperands,
     /*  708774 */     // GIR_Coverage, 11457,
     /*  708774 */     GIR_EraseRootFromParent_Done,
     /*  708775 */   // Label 11202: @708775
     /*  708775 */   GIM_Try, /*On fail goto*//*Label 11203*/ GIMT_Encode4(708850), // Rule ID 11460 //
     /*  708780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  708791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  708794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  708797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  708800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708848 */     GIR_RootConstrainSelectedInstOperands,
     /*  708849 */     // GIR_Coverage, 11460,
     /*  708849 */     GIR_EraseRootFromParent_Done,
     /*  708850 */   // Label 11203: @708850
     /*  708850 */   GIM_Try, /*On fail goto*//*Label 11204*/ GIMT_Encode4(708925), // Rule ID 11461 //
     /*  708855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  708866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  708869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  708872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  708875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708901 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708923 */     GIR_RootConstrainSelectedInstOperands,
     /*  708924 */     // GIR_Coverage, 11461,
     /*  708924 */     GIR_EraseRootFromParent_Done,
     /*  708925 */   // Label 11204: @708925
     /*  708925 */   GIM_Try, /*On fail goto*//*Label 11205*/ GIMT_Encode4(709000), // Rule ID 11464 //
     /*  708930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  708941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  708944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  708947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  708950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708998 */     GIR_RootConstrainSelectedInstOperands,
     /*  708999 */     // GIR_Coverage, 11464,
     /*  708999 */     GIR_EraseRootFromParent_Done,
     /*  709000 */   // Label 11205: @709000
     /*  709000 */   GIM_Try, /*On fail goto*//*Label 11206*/ GIMT_Encode4(709075), // Rule ID 11465 //
     /*  709005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  709016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  709019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  709022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  709025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709051 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  709054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709073 */     GIR_RootConstrainSelectedInstOperands,
     /*  709074 */     // GIR_Coverage, 11465,
     /*  709074 */     GIR_EraseRootFromParent_Done,
     /*  709075 */   // Label 11206: @709075
     /*  709075 */   GIM_Try, /*On fail goto*//*Label 11207*/ GIMT_Encode4(709150), // Rule ID 11468 //
     /*  709080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  709091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  709094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  709097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  709100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709126 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  709129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709148 */     GIR_RootConstrainSelectedInstOperands,
     /*  709149 */     // GIR_Coverage, 11468,
     /*  709149 */     GIR_EraseRootFromParent_Done,
     /*  709150 */   // Label 11207: @709150
     /*  709150 */   GIM_Try, /*On fail goto*//*Label 11208*/ GIMT_Encode4(709225), // Rule ID 11469 //
     /*  709155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  709166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  709169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  709172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  709175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709201 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  709204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709223 */     GIR_RootConstrainSelectedInstOperands,
     /*  709224 */     // GIR_Coverage, 11469,
     /*  709224 */     GIR_EraseRootFromParent_Done,
     /*  709225 */   // Label 11208: @709225
     /*  709225 */   GIM_Try, /*On fail goto*//*Label 11209*/ GIMT_Encode4(709300), // Rule ID 11472 //
     /*  709230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  709241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  709244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  709247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  709250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709276 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709298 */     GIR_RootConstrainSelectedInstOperands,
     /*  709299 */     // GIR_Coverage, 11472,
     /*  709299 */     GIR_EraseRootFromParent_Done,
     /*  709300 */   // Label 11209: @709300
     /*  709300 */   GIM_Try, /*On fail goto*//*Label 11210*/ GIMT_Encode4(709375), // Rule ID 11473 //
     /*  709305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  709316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  709319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  709322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  709325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709351 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709373 */     GIR_RootConstrainSelectedInstOperands,
     /*  709374 */     // GIR_Coverage, 11473,
     /*  709374 */     GIR_EraseRootFromParent_Done,
     /*  709375 */   // Label 11210: @709375
     /*  709375 */   GIM_Try, /*On fail goto*//*Label 11211*/ GIMT_Encode4(709450), // Rule ID 11476 //
     /*  709380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  709391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  709394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  709397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  709400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709426 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709448 */     GIR_RootConstrainSelectedInstOperands,
     /*  709449 */     // GIR_Coverage, 11476,
     /*  709449 */     GIR_EraseRootFromParent_Done,
     /*  709450 */   // Label 11211: @709450
     /*  709450 */   GIM_Try, /*On fail goto*//*Label 11212*/ GIMT_Encode4(709525), // Rule ID 11477 //
     /*  709455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  709466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  709469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  709472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  709475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709501 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709523 */     GIR_RootConstrainSelectedInstOperands,
     /*  709524 */     // GIR_Coverage, 11477,
     /*  709524 */     GIR_EraseRootFromParent_Done,
     /*  709525 */   // Label 11212: @709525
     /*  709525 */   GIM_Try, /*On fail goto*//*Label 11213*/ GIMT_Encode4(709600), // Rule ID 11480 //
     /*  709530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  709541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  709544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  709547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  709550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709576 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709598 */     GIR_RootConstrainSelectedInstOperands,
     /*  709599 */     // GIR_Coverage, 11480,
     /*  709599 */     GIR_EraseRootFromParent_Done,
     /*  709600 */   // Label 11213: @709600
     /*  709600 */   GIM_Try, /*On fail goto*//*Label 11214*/ GIMT_Encode4(709675), // Rule ID 11481 //
     /*  709605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  709616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  709619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  709622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  709625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709651 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709673 */     GIR_RootConstrainSelectedInstOperands,
     /*  709674 */     // GIR_Coverage, 11481,
     /*  709674 */     GIR_EraseRootFromParent_Done,
     /*  709675 */   // Label 11214: @709675
     /*  709675 */   GIM_Try, /*On fail goto*//*Label 11215*/ GIMT_Encode4(709750), // Rule ID 11484 //
     /*  709680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  709691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  709694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  709697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  709700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709748 */     GIR_RootConstrainSelectedInstOperands,
     /*  709749 */     // GIR_Coverage, 11484,
     /*  709749 */     GIR_EraseRootFromParent_Done,
     /*  709750 */   // Label 11215: @709750
     /*  709750 */   GIM_Try, /*On fail goto*//*Label 11216*/ GIMT_Encode4(709825), // Rule ID 11485 //
     /*  709755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  709766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  709769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  709772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  709775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709801 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709823 */     GIR_RootConstrainSelectedInstOperands,
     /*  709824 */     // GIR_Coverage, 11485,
     /*  709824 */     GIR_EraseRootFromParent_Done,
     /*  709825 */   // Label 11216: @709825
     /*  709825 */   GIM_Try, /*On fail goto*//*Label 11217*/ GIMT_Encode4(709900), // Rule ID 11488 //
     /*  709830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  709841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  709844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  709847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  709850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709876 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709898 */     GIR_RootConstrainSelectedInstOperands,
     /*  709899 */     // GIR_Coverage, 11488,
     /*  709899 */     GIR_EraseRootFromParent_Done,
     /*  709900 */   // Label 11217: @709900
     /*  709900 */   GIM_Try, /*On fail goto*//*Label 11218*/ GIMT_Encode4(709975), // Rule ID 11489 //
     /*  709905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  709916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  709919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  709922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  709925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709951 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709973 */     GIR_RootConstrainSelectedInstOperands,
     /*  709974 */     // GIR_Coverage, 11489,
     /*  709974 */     GIR_EraseRootFromParent_Done,
     /*  709975 */   // Label 11218: @709975
     /*  709975 */   GIM_Try, /*On fail goto*//*Label 11219*/ GIMT_Encode4(710050), // Rule ID 11492 //
     /*  709980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  709991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  709994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  709997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  710000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710026 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  710029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710048 */     GIR_RootConstrainSelectedInstOperands,
     /*  710049 */     // GIR_Coverage, 11492,
     /*  710049 */     GIR_EraseRootFromParent_Done,
     /*  710050 */   // Label 11219: @710050
     /*  710050 */   GIM_Try, /*On fail goto*//*Label 11220*/ GIMT_Encode4(710125), // Rule ID 11493 //
     /*  710055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  710066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  710069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  710072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  710075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710101 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  710104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710123 */     GIR_RootConstrainSelectedInstOperands,
     /*  710124 */     // GIR_Coverage, 11493,
     /*  710124 */     GIR_EraseRootFromParent_Done,
     /*  710125 */   // Label 11220: @710125
     /*  710125 */   GIM_Try, /*On fail goto*//*Label 11221*/ GIMT_Encode4(710200), // Rule ID 11496 //
     /*  710130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  710141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  710144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  710147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  710150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  710179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710198 */     GIR_RootConstrainSelectedInstOperands,
     /*  710199 */     // GIR_Coverage, 11496,
     /*  710199 */     GIR_EraseRootFromParent_Done,
     /*  710200 */   // Label 11221: @710200
     /*  710200 */   GIM_Try, /*On fail goto*//*Label 11222*/ GIMT_Encode4(710275), // Rule ID 11497 //
     /*  710205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  710216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  710219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  710222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  710225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710251 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  710254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710273 */     GIR_RootConstrainSelectedInstOperands,
     /*  710274 */     // GIR_Coverage, 11497,
     /*  710274 */     GIR_EraseRootFromParent_Done,
     /*  710275 */   // Label 11222: @710275
     /*  710275 */   GIM_Try, /*On fail goto*//*Label 11223*/ GIMT_Encode4(710350), // Rule ID 11500 //
     /*  710280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  710291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  710294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  710297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  710300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710326 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  710329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710348 */     GIR_RootConstrainSelectedInstOperands,
     /*  710349 */     // GIR_Coverage, 11500,
     /*  710349 */     GIR_EraseRootFromParent_Done,
     /*  710350 */   // Label 11223: @710350
     /*  710350 */   GIM_Try, /*On fail goto*//*Label 11224*/ GIMT_Encode4(710425), // Rule ID 11501 //
     /*  710355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  710366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  710369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  710372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  710375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710401 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  710404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710423 */     GIR_RootConstrainSelectedInstOperands,
     /*  710424 */     // GIR_Coverage, 11501,
     /*  710424 */     GIR_EraseRootFromParent_Done,
     /*  710425 */   // Label 11224: @710425
     /*  710425 */   GIM_Try, /*On fail goto*//*Label 11225*/ GIMT_Encode4(710500), // Rule ID 11504 //
     /*  710430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  710441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  710444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  710447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  710450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710476 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  710479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710498 */     GIR_RootConstrainSelectedInstOperands,
     /*  710499 */     // GIR_Coverage, 11504,
     /*  710499 */     GIR_EraseRootFromParent_Done,
     /*  710500 */   // Label 11225: @710500
     /*  710500 */   GIM_Try, /*On fail goto*//*Label 11226*/ GIMT_Encode4(710575), // Rule ID 11505 //
     /*  710505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  710516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  710519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  710522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  710525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710551 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  710554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710573 */     GIR_RootConstrainSelectedInstOperands,
     /*  710574 */     // GIR_Coverage, 11505,
     /*  710574 */     GIR_EraseRootFromParent_Done,
     /*  710575 */   // Label 11226: @710575
     /*  710575 */   GIM_Try, /*On fail goto*//*Label 11227*/ GIMT_Encode4(710650), // Rule ID 11508 //
     /*  710580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  710591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  710594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  710597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710626 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  710629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710648 */     GIR_RootConstrainSelectedInstOperands,
     /*  710649 */     // GIR_Coverage, 11508,
     /*  710649 */     GIR_EraseRootFromParent_Done,
     /*  710650 */   // Label 11227: @710650
     /*  710650 */   GIM_Try, /*On fail goto*//*Label 11228*/ GIMT_Encode4(710725), // Rule ID 11509 //
     /*  710655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  710666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  710669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  710672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710701 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  710704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710723 */     GIR_RootConstrainSelectedInstOperands,
     /*  710724 */     // GIR_Coverage, 11509,
     /*  710724 */     GIR_EraseRootFromParent_Done,
     /*  710725 */   // Label 11228: @710725
     /*  710725 */   GIM_Try, /*On fail goto*//*Label 11229*/ GIMT_Encode4(710800), // Rule ID 11512 //
     /*  710730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  710741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  710744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  710747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710776 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710798 */     GIR_RootConstrainSelectedInstOperands,
     /*  710799 */     // GIR_Coverage, 11512,
     /*  710799 */     GIR_EraseRootFromParent_Done,
     /*  710800 */   // Label 11229: @710800
     /*  710800 */   GIM_Try, /*On fail goto*//*Label 11230*/ GIMT_Encode4(710875), // Rule ID 11513 //
     /*  710805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  710816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  710819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  710822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710851 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710873 */     GIR_RootConstrainSelectedInstOperands,
     /*  710874 */     // GIR_Coverage, 11513,
     /*  710874 */     GIR_EraseRootFromParent_Done,
     /*  710875 */   // Label 11230: @710875
     /*  710875 */   GIM_Try, /*On fail goto*//*Label 11231*/ GIMT_Encode4(710950), // Rule ID 11516 //
     /*  710880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  710891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  710894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  710897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710926 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710948 */     GIR_RootConstrainSelectedInstOperands,
     /*  710949 */     // GIR_Coverage, 11516,
     /*  710949 */     GIR_EraseRootFromParent_Done,
     /*  710950 */   // Label 11231: @710950
     /*  710950 */   GIM_Try, /*On fail goto*//*Label 11232*/ GIMT_Encode4(711025), // Rule ID 11517 //
     /*  710955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  710966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  710969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  710972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711001 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  711004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711023 */     GIR_RootConstrainSelectedInstOperands,
     /*  711024 */     // GIR_Coverage, 11517,
     /*  711024 */     GIR_EraseRootFromParent_Done,
     /*  711025 */   // Label 11232: @711025
     /*  711025 */   GIM_Try, /*On fail goto*//*Label 11233*/ GIMT_Encode4(711100), // Rule ID 11520 //
     /*  711030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  711041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  711044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  711047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711076 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  711079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711098 */     GIR_RootConstrainSelectedInstOperands,
     /*  711099 */     // GIR_Coverage, 11520,
     /*  711099 */     GIR_EraseRootFromParent_Done,
     /*  711100 */   // Label 11233: @711100
     /*  711100 */   GIM_Try, /*On fail goto*//*Label 11234*/ GIMT_Encode4(711175), // Rule ID 11521 //
     /*  711105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  711116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  711119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  711122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711151 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  711154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711173 */     GIR_RootConstrainSelectedInstOperands,
     /*  711174 */     // GIR_Coverage, 11521,
     /*  711174 */     GIR_EraseRootFromParent_Done,
     /*  711175 */   // Label 11234: @711175
     /*  711175 */   GIM_Try, /*On fail goto*//*Label 11235*/ GIMT_Encode4(711250), // Rule ID 11524 //
     /*  711180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  711191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  711194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  711197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711226 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  711229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711248 */     GIR_RootConstrainSelectedInstOperands,
     /*  711249 */     // GIR_Coverage, 11524,
     /*  711249 */     GIR_EraseRootFromParent_Done,
     /*  711250 */   // Label 11235: @711250
     /*  711250 */   GIM_Try, /*On fail goto*//*Label 11236*/ GIMT_Encode4(711325), // Rule ID 11525 //
     /*  711255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  711266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  711269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  711272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711301 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  711304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711323 */     GIR_RootConstrainSelectedInstOperands,
     /*  711324 */     // GIR_Coverage, 11525,
     /*  711324 */     GIR_EraseRootFromParent_Done,
     /*  711325 */   // Label 11236: @711325
     /*  711325 */   GIM_Try, /*On fail goto*//*Label 11237*/ GIMT_Encode4(711400), // Rule ID 11528 //
     /*  711330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  711341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  711344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  711347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711376 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  711376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  711379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711398 */     GIR_RootConstrainSelectedInstOperands,
     /*  711399 */     // GIR_Coverage, 11528,
     /*  711399 */     GIR_EraseRootFromParent_Done,
     /*  711400 */   // Label 11237: @711400
     /*  711400 */   GIM_Try, /*On fail goto*//*Label 11238*/ GIMT_Encode4(711475), // Rule ID 11529 //
     /*  711405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  711416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  711419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  711422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711451 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  711454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711473 */     GIR_RootConstrainSelectedInstOperands,
     /*  711474 */     // GIR_Coverage, 11529,
     /*  711474 */     GIR_EraseRootFromParent_Done,
     /*  711475 */   // Label 11238: @711475
     /*  711475 */   GIM_Try, /*On fail goto*//*Label 11239*/ GIMT_Encode4(711550), // Rule ID 11532 //
     /*  711480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  711491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  711494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  711497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711526 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711548 */     GIR_RootConstrainSelectedInstOperands,
     /*  711549 */     // GIR_Coverage, 11532,
     /*  711549 */     GIR_EraseRootFromParent_Done,
     /*  711550 */   // Label 11239: @711550
     /*  711550 */   GIM_Try, /*On fail goto*//*Label 11240*/ GIMT_Encode4(711625), // Rule ID 11533 //
     /*  711555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  711566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  711569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  711572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711601 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711623 */     GIR_RootConstrainSelectedInstOperands,
     /*  711624 */     // GIR_Coverage, 11533,
     /*  711624 */     GIR_EraseRootFromParent_Done,
     /*  711625 */   // Label 11240: @711625
     /*  711625 */   GIM_Try, /*On fail goto*//*Label 11241*/ GIMT_Encode4(711700), // Rule ID 11536 //
     /*  711630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  711641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  711644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  711647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711676 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711698 */     GIR_RootConstrainSelectedInstOperands,
     /*  711699 */     // GIR_Coverage, 11536,
     /*  711699 */     GIR_EraseRootFromParent_Done,
     /*  711700 */   // Label 11241: @711700
     /*  711700 */   GIM_Try, /*On fail goto*//*Label 11242*/ GIMT_Encode4(711775), // Rule ID 11537 //
     /*  711705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  711716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  711719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  711722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711751 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711773 */     GIR_RootConstrainSelectedInstOperands,
     /*  711774 */     // GIR_Coverage, 11537,
     /*  711774 */     GIR_EraseRootFromParent_Done,
     /*  711775 */   // Label 11242: @711775
     /*  711775 */   GIM_Try, /*On fail goto*//*Label 11243*/ GIMT_Encode4(711850), // Rule ID 11540 //
     /*  711780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  711791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  711794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  711797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  711826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711848 */     GIR_RootConstrainSelectedInstOperands,
     /*  711849 */     // GIR_Coverage, 11540,
     /*  711849 */     GIR_EraseRootFromParent_Done,
     /*  711850 */   // Label 11243: @711850
     /*  711850 */   GIM_Try, /*On fail goto*//*Label 11244*/ GIMT_Encode4(711925), // Rule ID 11541 //
     /*  711855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  711866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  711869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  711872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711901 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711923 */     GIR_RootConstrainSelectedInstOperands,
     /*  711924 */     // GIR_Coverage, 11541,
     /*  711924 */     GIR_EraseRootFromParent_Done,
     /*  711925 */   // Label 11244: @711925
     /*  711925 */   GIM_Try, /*On fail goto*//*Label 11245*/ GIMT_Encode4(712000), // Rule ID 11544 //
     /*  711930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  711941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  711944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  711947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711976 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711998 */     GIR_RootConstrainSelectedInstOperands,
     /*  711999 */     // GIR_Coverage, 11544,
     /*  711999 */     GIR_EraseRootFromParent_Done,
     /*  712000 */   // Label 11245: @712000
     /*  712000 */   GIM_Try, /*On fail goto*//*Label 11246*/ GIMT_Encode4(712075), // Rule ID 11545 //
     /*  712005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  712016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  712019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  712022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712051 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712073 */     GIR_RootConstrainSelectedInstOperands,
     /*  712074 */     // GIR_Coverage, 11545,
     /*  712074 */     GIR_EraseRootFromParent_Done,
     /*  712075 */   // Label 11246: @712075
     /*  712075 */   GIM_Try, /*On fail goto*//*Label 11247*/ GIMT_Encode4(712150), // Rule ID 11548 //
     /*  712080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  712091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  712094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  712097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712126 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712148 */     GIR_RootConstrainSelectedInstOperands,
     /*  712149 */     // GIR_Coverage, 11548,
     /*  712149 */     GIR_EraseRootFromParent_Done,
     /*  712150 */   // Label 11247: @712150
     /*  712150 */   GIM_Try, /*On fail goto*//*Label 11248*/ GIMT_Encode4(712225), // Rule ID 11549 //
     /*  712155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  712166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  712169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  712172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712201 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712223 */     GIR_RootConstrainSelectedInstOperands,
     /*  712224 */     // GIR_Coverage, 11549,
     /*  712224 */     GIR_EraseRootFromParent_Done,
     /*  712225 */   // Label 11248: @712225
     /*  712225 */   GIM_Try, /*On fail goto*//*Label 11249*/ GIMT_Encode4(712300), // Rule ID 11552 //
     /*  712230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  712241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  712244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  712247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712276 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712298 */     GIR_RootConstrainSelectedInstOperands,
     /*  712299 */     // GIR_Coverage, 11552,
     /*  712299 */     GIR_EraseRootFromParent_Done,
     /*  712300 */   // Label 11249: @712300
     /*  712300 */   GIM_Try, /*On fail goto*//*Label 11250*/ GIMT_Encode4(712375), // Rule ID 11553 //
     /*  712305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  712316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  712319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  712322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712351 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712373 */     GIR_RootConstrainSelectedInstOperands,
     /*  712374 */     // GIR_Coverage, 11553,
     /*  712374 */     GIR_EraseRootFromParent_Done,
     /*  712375 */   // Label 11250: @712375
     /*  712375 */   GIM_Try, /*On fail goto*//*Label 11251*/ GIMT_Encode4(712450), // Rule ID 11556 //
     /*  712380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  712391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  712394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  712397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712426 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712448 */     GIR_RootConstrainSelectedInstOperands,
     /*  712449 */     // GIR_Coverage, 11556,
     /*  712449 */     GIR_EraseRootFromParent_Done,
     /*  712450 */   // Label 11251: @712450
     /*  712450 */   GIM_Try, /*On fail goto*//*Label 11252*/ GIMT_Encode4(712525), // Rule ID 11557 //
     /*  712455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  712466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  712469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  712472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712501 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712523 */     GIR_RootConstrainSelectedInstOperands,
     /*  712524 */     // GIR_Coverage, 11557,
     /*  712524 */     GIR_EraseRootFromParent_Done,
     /*  712525 */   // Label 11252: @712525
     /*  712525 */   GIM_Try, /*On fail goto*//*Label 11253*/ GIMT_Encode4(712600), // Rule ID 11560 //
     /*  712530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  712541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  712544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  712547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712576 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712598 */     GIR_RootConstrainSelectedInstOperands,
     /*  712599 */     // GIR_Coverage, 11560,
     /*  712599 */     GIR_EraseRootFromParent_Done,
     /*  712600 */   // Label 11253: @712600
     /*  712600 */   GIM_Try, /*On fail goto*//*Label 11254*/ GIMT_Encode4(712675), // Rule ID 11561 //
     /*  712605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  712616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  712619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  712622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712651 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712673 */     GIR_RootConstrainSelectedInstOperands,
     /*  712674 */     // GIR_Coverage, 11561,
     /*  712674 */     GIR_EraseRootFromParent_Done,
     /*  712675 */   // Label 11254: @712675
     /*  712675 */   GIM_Try, /*On fail goto*//*Label 11255*/ GIMT_Encode4(712750), // Rule ID 11564 //
     /*  712680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  712691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  712694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  712697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712726 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712748 */     GIR_RootConstrainSelectedInstOperands,
     /*  712749 */     // GIR_Coverage, 11564,
     /*  712749 */     GIR_EraseRootFromParent_Done,
     /*  712750 */   // Label 11255: @712750
     /*  712750 */   GIM_Try, /*On fail goto*//*Label 11256*/ GIMT_Encode4(712825), // Rule ID 11565 //
     /*  712755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  712766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  712769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  712772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712801 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712823 */     GIR_RootConstrainSelectedInstOperands,
     /*  712824 */     // GIR_Coverage, 11565,
     /*  712824 */     GIR_EraseRootFromParent_Done,
     /*  712825 */   // Label 11256: @712825
     /*  712825 */   GIM_Try, /*On fail goto*//*Label 11257*/ GIMT_Encode4(712900), // Rule ID 11568 //
     /*  712830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  712841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  712844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  712847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712898 */     GIR_RootConstrainSelectedInstOperands,
     /*  712899 */     // GIR_Coverage, 11568,
     /*  712899 */     GIR_EraseRootFromParent_Done,
     /*  712900 */   // Label 11257: @712900
     /*  712900 */   GIM_Try, /*On fail goto*//*Label 11258*/ GIMT_Encode4(712975), // Rule ID 11569 //
     /*  712905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  712916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  712919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  712922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712973 */     GIR_RootConstrainSelectedInstOperands,
     /*  712974 */     // GIR_Coverage, 11569,
     /*  712974 */     GIR_EraseRootFromParent_Done,
     /*  712975 */   // Label 11258: @712975
     /*  712975 */   GIM_Try, /*On fail goto*//*Label 11259*/ GIMT_Encode4(713050), // Rule ID 11572 //
     /*  712980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  712991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  712994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  712997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  713026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  713029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713048 */     GIR_RootConstrainSelectedInstOperands,
     /*  713049 */     // GIR_Coverage, 11572,
     /*  713049 */     GIR_EraseRootFromParent_Done,
     /*  713050 */   // Label 11259: @713050
     /*  713050 */   GIM_Try, /*On fail goto*//*Label 11260*/ GIMT_Encode4(713125), // Rule ID 11573 //
     /*  713055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  713066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  713069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  713072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713101 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  713101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  713104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713123 */     GIR_RootConstrainSelectedInstOperands,
     /*  713124 */     // GIR_Coverage, 11573,
     /*  713124 */     GIR_EraseRootFromParent_Done,
     /*  713125 */   // Label 11260: @713125
     /*  713125 */   GIM_Try, /*On fail goto*//*Label 11261*/ GIMT_Encode4(713200), // Rule ID 11576 //
     /*  713130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  713141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  713144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  713147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713176 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  713176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  713179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713198 */     GIR_RootConstrainSelectedInstOperands,
     /*  713199 */     // GIR_Coverage, 11576,
     /*  713199 */     GIR_EraseRootFromParent_Done,
     /*  713200 */   // Label 11261: @713200
     /*  713200 */   GIM_Try, /*On fail goto*//*Label 11262*/ GIMT_Encode4(713275), // Rule ID 11577 //
     /*  713205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  713216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  713219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  713222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713251 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  713251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  713254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713273 */     GIR_RootConstrainSelectedInstOperands,
     /*  713274 */     // GIR_Coverage, 11577,
     /*  713274 */     GIR_EraseRootFromParent_Done,
     /*  713275 */   // Label 11262: @713275
     /*  713275 */   GIM_Try, /*On fail goto*//*Label 11263*/ GIMT_Encode4(713350), // Rule ID 11580 //
     /*  713280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  713300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713326 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  713329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713348 */     GIR_RootConstrainSelectedInstOperands,
     /*  713349 */     // GIR_Coverage, 11580,
     /*  713349 */     GIR_EraseRootFromParent_Done,
     /*  713350 */   // Label 11263: @713350
     /*  713350 */   GIM_Try, /*On fail goto*//*Label 11264*/ GIMT_Encode4(713425), // Rule ID 11581 //
     /*  713355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  713375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713401 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  713404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713423 */     GIR_RootConstrainSelectedInstOperands,
     /*  713424 */     // GIR_Coverage, 11581,
     /*  713424 */     GIR_EraseRootFromParent_Done,
     /*  713425 */   // Label 11264: @713425
     /*  713425 */   GIM_Try, /*On fail goto*//*Label 11265*/ GIMT_Encode4(713500), // Rule ID 11584 //
     /*  713430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  713450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  713479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713498 */     GIR_RootConstrainSelectedInstOperands,
     /*  713499 */     // GIR_Coverage, 11584,
     /*  713499 */     GIR_EraseRootFromParent_Done,
     /*  713500 */   // Label 11265: @713500
     /*  713500 */   GIM_Try, /*On fail goto*//*Label 11266*/ GIMT_Encode4(713575), // Rule ID 11585 //
     /*  713505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  713525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713551 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  713554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713573 */     GIR_RootConstrainSelectedInstOperands,
     /*  713574 */     // GIR_Coverage, 11585,
     /*  713574 */     GIR_EraseRootFromParent_Done,
     /*  713575 */   // Label 11266: @713575
     /*  713575 */   GIM_Try, /*On fail goto*//*Label 11267*/ GIMT_Encode4(713650), // Rule ID 11588 //
     /*  713580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  713600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713626 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  713629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713648 */     GIR_RootConstrainSelectedInstOperands,
     /*  713649 */     // GIR_Coverage, 11588,
     /*  713649 */     GIR_EraseRootFromParent_Done,
     /*  713650 */   // Label 11267: @713650
     /*  713650 */   GIM_Try, /*On fail goto*//*Label 11268*/ GIMT_Encode4(713725), // Rule ID 11589 //
     /*  713655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  713675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713701 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  713704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713723 */     GIR_RootConstrainSelectedInstOperands,
     /*  713724 */     // GIR_Coverage, 11589,
     /*  713724 */     GIR_EraseRootFromParent_Done,
     /*  713725 */   // Label 11268: @713725
     /*  713725 */   GIM_Try, /*On fail goto*//*Label 11269*/ GIMT_Encode4(713800), // Rule ID 11592 //
     /*  713730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  713750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  713779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713798 */     GIR_RootConstrainSelectedInstOperands,
     /*  713799 */     // GIR_Coverage, 11592,
     /*  713799 */     GIR_EraseRootFromParent_Done,
     /*  713800 */   // Label 11269: @713800
     /*  713800 */   GIM_Try, /*On fail goto*//*Label 11270*/ GIMT_Encode4(713875), // Rule ID 11593 //
     /*  713805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  713825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713851 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  713854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713873 */     GIR_RootConstrainSelectedInstOperands,
     /*  713874 */     // GIR_Coverage, 11593,
     /*  713874 */     GIR_EraseRootFromParent_Done,
     /*  713875 */   // Label 11270: @713875
     /*  713875 */   GIM_Try, /*On fail goto*//*Label 11271*/ GIMT_Encode4(713950), // Rule ID 11596 //
     /*  713880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713926 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  713929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713948 */     GIR_RootConstrainSelectedInstOperands,
     /*  713949 */     // GIR_Coverage, 11596,
     /*  713949 */     GIR_EraseRootFromParent_Done,
     /*  713950 */   // Label 11271: @713950
     /*  713950 */   GIM_Try, /*On fail goto*//*Label 11272*/ GIMT_Encode4(714025), // Rule ID 11597 //
     /*  713955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714001 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  714004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714023 */     GIR_RootConstrainSelectedInstOperands,
     /*  714024 */     // GIR_Coverage, 11597,
     /*  714024 */     GIR_EraseRootFromParent_Done,
     /*  714025 */   // Label 11272: @714025
     /*  714025 */   GIM_Try, /*On fail goto*//*Label 11273*/ GIMT_Encode4(714100), // Rule ID 11600 //
     /*  714030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  714038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  714079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714098 */     GIR_RootConstrainSelectedInstOperands,
     /*  714099 */     // GIR_Coverage, 11600,
     /*  714099 */     GIR_EraseRootFromParent_Done,
     /*  714100 */   // Label 11273: @714100
     /*  714100 */   GIM_Try, /*On fail goto*//*Label 11274*/ GIMT_Encode4(714175), // Rule ID 11601 //
     /*  714105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  714113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714151 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  714154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714173 */     GIR_RootConstrainSelectedInstOperands,
     /*  714174 */     // GIR_Coverage, 11601,
     /*  714174 */     GIR_EraseRootFromParent_Done,
     /*  714175 */   // Label 11274: @714175
     /*  714175 */   GIM_Try, /*On fail goto*//*Label 11275*/ GIMT_Encode4(714250), // Rule ID 11604 //
     /*  714180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  714188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714226 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  714229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714248 */     GIR_RootConstrainSelectedInstOperands,
     /*  714249 */     // GIR_Coverage, 11604,
     /*  714249 */     GIR_EraseRootFromParent_Done,
     /*  714250 */   // Label 11275: @714250
     /*  714250 */   GIM_Try, /*On fail goto*//*Label 11276*/ GIMT_Encode4(714325), // Rule ID 11605 //
     /*  714255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  714263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714301 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  714304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714323 */     GIR_RootConstrainSelectedInstOperands,
     /*  714324 */     // GIR_Coverage, 11605,
     /*  714324 */     GIR_EraseRootFromParent_Done,
     /*  714325 */   // Label 11276: @714325
     /*  714325 */   GIM_Try, /*On fail goto*//*Label 11277*/ GIMT_Encode4(714400), // Rule ID 11608 //
     /*  714330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  714338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714376 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  714379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714398 */     GIR_RootConstrainSelectedInstOperands,
     /*  714399 */     // GIR_Coverage, 11608,
     /*  714399 */     GIR_EraseRootFromParent_Done,
     /*  714400 */   // Label 11277: @714400
     /*  714400 */   GIM_Try, /*On fail goto*//*Label 11278*/ GIMT_Encode4(714475), // Rule ID 11609 //
     /*  714405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  714413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714451 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  714454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714473 */     GIR_RootConstrainSelectedInstOperands,
     /*  714474 */     // GIR_Coverage, 11609,
     /*  714474 */     GIR_EraseRootFromParent_Done,
     /*  714475 */   // Label 11278: @714475
     /*  714475 */   GIM_Try, /*On fail goto*//*Label 11279*/ GIMT_Encode4(714550), // Rule ID 11612 //
     /*  714480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  714529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714548 */     GIR_RootConstrainSelectedInstOperands,
     /*  714549 */     // GIR_Coverage, 11612,
     /*  714549 */     GIR_EraseRootFromParent_Done,
     /*  714550 */   // Label 11279: @714550
     /*  714550 */   GIM_Try, /*On fail goto*//*Label 11280*/ GIMT_Encode4(714625), // Rule ID 11613 //
     /*  714555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714601 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  714604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714623 */     GIR_RootConstrainSelectedInstOperands,
     /*  714624 */     // GIR_Coverage, 11613,
     /*  714624 */     GIR_EraseRootFromParent_Done,
     /*  714625 */   // Label 11280: @714625
     /*  714625 */   GIM_Try, /*On fail goto*//*Label 11281*/ GIMT_Encode4(714700), // Rule ID 11616 //
     /*  714630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  714650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  714679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714698 */     GIR_RootConstrainSelectedInstOperands,
     /*  714699 */     // GIR_Coverage, 11616,
     /*  714699 */     GIR_EraseRootFromParent_Done,
     /*  714700 */   // Label 11281: @714700
     /*  714700 */   GIM_Try, /*On fail goto*//*Label 11282*/ GIMT_Encode4(714775), // Rule ID 11617 //
     /*  714705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  714725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714751 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  714754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714773 */     GIR_RootConstrainSelectedInstOperands,
     /*  714774 */     // GIR_Coverage, 11617,
     /*  714774 */     GIR_EraseRootFromParent_Done,
     /*  714775 */   // Label 11282: @714775
     /*  714775 */   GIM_Try, /*On fail goto*//*Label 11283*/ GIMT_Encode4(714850), // Rule ID 11620 //
     /*  714780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  714800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714826 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  714829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714848 */     GIR_RootConstrainSelectedInstOperands,
     /*  714849 */     // GIR_Coverage, 11620,
     /*  714849 */     GIR_EraseRootFromParent_Done,
     /*  714850 */   // Label 11283: @714850
     /*  714850 */   GIM_Try, /*On fail goto*//*Label 11284*/ GIMT_Encode4(714925), // Rule ID 11621 //
     /*  714855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  714875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714901 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  714904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714923 */     GIR_RootConstrainSelectedInstOperands,
     /*  714924 */     // GIR_Coverage, 11621,
     /*  714924 */     GIR_EraseRootFromParent_Done,
     /*  714925 */   // Label 11284: @714925
     /*  714925 */   GIM_Try, /*On fail goto*//*Label 11285*/ GIMT_Encode4(715000), // Rule ID 11624 //
     /*  714930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  714950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714976 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  714979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714998 */     GIR_RootConstrainSelectedInstOperands,
     /*  714999 */     // GIR_Coverage, 11624,
     /*  714999 */     GIR_EraseRootFromParent_Done,
     /*  715000 */   // Label 11285: @715000
     /*  715000 */   GIM_Try, /*On fail goto*//*Label 11286*/ GIMT_Encode4(715075), // Rule ID 11625 //
     /*  715005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  715025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715051 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  715054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715073 */     GIR_RootConstrainSelectedInstOperands,
     /*  715074 */     // GIR_Coverage, 11625,
     /*  715074 */     GIR_EraseRootFromParent_Done,
     /*  715075 */   // Label 11286: @715075
     /*  715075 */   GIM_Try, /*On fail goto*//*Label 11287*/ GIMT_Encode4(715150), // Rule ID 11628 //
     /*  715080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  715129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715148 */     GIR_RootConstrainSelectedInstOperands,
     /*  715149 */     // GIR_Coverage, 11628,
     /*  715149 */     GIR_EraseRootFromParent_Done,
     /*  715150 */   // Label 11287: @715150
     /*  715150 */   GIM_Try, /*On fail goto*//*Label 11288*/ GIMT_Encode4(715225), // Rule ID 11629 //
     /*  715155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715201 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  715204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715223 */     GIR_RootConstrainSelectedInstOperands,
     /*  715224 */     // GIR_Coverage, 11629,
     /*  715224 */     GIR_EraseRootFromParent_Done,
     /*  715225 */   // Label 11288: @715225
     /*  715225 */   GIM_Try, /*On fail goto*//*Label 11289*/ GIMT_Encode4(715300), // Rule ID 11632 //
     /*  715230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  715279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715298 */     GIR_RootConstrainSelectedInstOperands,
     /*  715299 */     // GIR_Coverage, 11632,
     /*  715299 */     GIR_EraseRootFromParent_Done,
     /*  715300 */   // Label 11289: @715300
     /*  715300 */   GIM_Try, /*On fail goto*//*Label 11290*/ GIMT_Encode4(715375), // Rule ID 11633 //
     /*  715305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715351 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  715354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715373 */     GIR_RootConstrainSelectedInstOperands,
     /*  715374 */     // GIR_Coverage, 11633,
     /*  715374 */     GIR_EraseRootFromParent_Done,
     /*  715375 */   // Label 11290: @715375
     /*  715375 */   GIM_Try, /*On fail goto*//*Label 11291*/ GIMT_Encode4(715450), // Rule ID 11636 //
     /*  715380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715426 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  715429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715448 */     GIR_RootConstrainSelectedInstOperands,
     /*  715449 */     // GIR_Coverage, 11636,
     /*  715449 */     GIR_EraseRootFromParent_Done,
     /*  715450 */   // Label 11291: @715450
     /*  715450 */   GIM_Try, /*On fail goto*//*Label 11292*/ GIMT_Encode4(715525), // Rule ID 11637 //
     /*  715455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715501 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  715504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715523 */     GIR_RootConstrainSelectedInstOperands,
     /*  715524 */     // GIR_Coverage, 11637,
     /*  715524 */     GIR_EraseRootFromParent_Done,
     /*  715525 */   // Label 11292: @715525
     /*  715525 */   GIM_Try, /*On fail goto*//*Label 11293*/ GIMT_Encode4(715600), // Rule ID 11640 //
     /*  715530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  715579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715598 */     GIR_RootConstrainSelectedInstOperands,
     /*  715599 */     // GIR_Coverage, 11640,
     /*  715599 */     GIR_EraseRootFromParent_Done,
     /*  715600 */   // Label 11293: @715600
     /*  715600 */   GIM_Try, /*On fail goto*//*Label 11294*/ GIMT_Encode4(715675), // Rule ID 11641 //
     /*  715605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715651 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  715654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715673 */     GIR_RootConstrainSelectedInstOperands,
     /*  715674 */     // GIR_Coverage, 11641,
     /*  715674 */     GIR_EraseRootFromParent_Done,
     /*  715675 */   // Label 11294: @715675
     /*  715675 */   GIM_Try, /*On fail goto*//*Label 11295*/ GIMT_Encode4(715750), // Rule ID 11644 //
     /*  715680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  715700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715726 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  715729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715748 */     GIR_RootConstrainSelectedInstOperands,
     /*  715749 */     // GIR_Coverage, 11644,
     /*  715749 */     GIR_EraseRootFromParent_Done,
     /*  715750 */   // Label 11295: @715750
     /*  715750 */   GIM_Try, /*On fail goto*//*Label 11296*/ GIMT_Encode4(715825), // Rule ID 11645 //
     /*  715755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  715775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715801 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  715804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715823 */     GIR_RootConstrainSelectedInstOperands,
     /*  715824 */     // GIR_Coverage, 11645,
     /*  715824 */     GIR_EraseRootFromParent_Done,
     /*  715825 */   // Label 11296: @715825
     /*  715825 */   GIM_Try, /*On fail goto*//*Label 11297*/ GIMT_Encode4(715900), // Rule ID 11648 //
     /*  715830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  715850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  715879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715898 */     GIR_RootConstrainSelectedInstOperands,
     /*  715899 */     // GIR_Coverage, 11648,
     /*  715899 */     GIR_EraseRootFromParent_Done,
     /*  715900 */   // Label 11297: @715900
     /*  715900 */   GIM_Try, /*On fail goto*//*Label 11298*/ GIMT_Encode4(715975), // Rule ID 11649 //
     /*  715905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  715925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  715954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715973 */     GIR_RootConstrainSelectedInstOperands,
     /*  715974 */     // GIR_Coverage, 11649,
     /*  715974 */     GIR_EraseRootFromParent_Done,
     /*  715975 */   // Label 11298: @715975
     /*  715975 */   GIM_Try, /*On fail goto*//*Label 11299*/ GIMT_Encode4(716050), // Rule ID 11652 //
     /*  715980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  716000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716026 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  716029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716048 */     GIR_RootConstrainSelectedInstOperands,
     /*  716049 */     // GIR_Coverage, 11652,
     /*  716049 */     GIR_EraseRootFromParent_Done,
     /*  716050 */   // Label 11299: @716050
     /*  716050 */   GIM_Try, /*On fail goto*//*Label 11300*/ GIMT_Encode4(716125), // Rule ID 11653 //
     /*  716055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  716066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  716069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  716072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  716075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716101 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  716104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716123 */     GIR_RootConstrainSelectedInstOperands,
     /*  716124 */     // GIR_Coverage, 11653,
     /*  716124 */     GIR_EraseRootFromParent_Done,
     /*  716125 */   // Label 11300: @716125
     /*  716125 */   GIM_Try, /*On fail goto*//*Label 11301*/ GIMT_Encode4(716200), // Rule ID 11656 //
     /*  716130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  716141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  716144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  716147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  716150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  716179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716198 */     GIR_RootConstrainSelectedInstOperands,
     /*  716199 */     // GIR_Coverage, 11656,
     /*  716199 */     GIR_EraseRootFromParent_Done,
     /*  716200 */   // Label 11301: @716200
     /*  716200 */   GIM_Try, /*On fail goto*//*Label 11302*/ GIMT_Encode4(716275), // Rule ID 11657 //
     /*  716205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  716216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  716219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  716222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  716225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716251 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  716254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716273 */     GIR_RootConstrainSelectedInstOperands,
     /*  716274 */     // GIR_Coverage, 11657,
     /*  716274 */     GIR_EraseRootFromParent_Done,
     /*  716275 */   // Label 11302: @716275
     /*  716275 */   GIM_Try, /*On fail goto*//*Label 11303*/ GIMT_Encode4(716350), // Rule ID 11660 //
     /*  716280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  716291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  716294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  716297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716326 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  716329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716348 */     GIR_RootConstrainSelectedInstOperands,
     /*  716349 */     // GIR_Coverage, 11660,
     /*  716349 */     GIR_EraseRootFromParent_Done,
     /*  716350 */   // Label 11303: @716350
     /*  716350 */   GIM_Try, /*On fail goto*//*Label 11304*/ GIMT_Encode4(716425), // Rule ID 11661 //
     /*  716355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  716366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  716369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  716372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716401 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  716404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716423 */     GIR_RootConstrainSelectedInstOperands,
     /*  716424 */     // GIR_Coverage, 11661,
     /*  716424 */     GIR_EraseRootFromParent_Done,
     /*  716425 */   // Label 11304: @716425
     /*  716425 */   GIM_Try, /*On fail goto*//*Label 11305*/ GIMT_Encode4(716500), // Rule ID 11664 //
     /*  716430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  716441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  716444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  716447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  716479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716498 */     GIR_RootConstrainSelectedInstOperands,
     /*  716499 */     // GIR_Coverage, 11664,
     /*  716499 */     GIR_EraseRootFromParent_Done,
     /*  716500 */   // Label 11305: @716500
     /*  716500 */   GIM_Try, /*On fail goto*//*Label 11306*/ GIMT_Encode4(716575), // Rule ID 11665 //
     /*  716505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  716516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  716519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  716522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716551 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  716554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716573 */     GIR_RootConstrainSelectedInstOperands,
     /*  716574 */     // GIR_Coverage, 11665,
     /*  716574 */     GIR_EraseRootFromParent_Done,
     /*  716575 */   // Label 11306: @716575
     /*  716575 */   GIM_Try, /*On fail goto*//*Label 11307*/ GIMT_Encode4(716650), // Rule ID 11668 //
     /*  716580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  716591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  716594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  716597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716626 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716648 */     GIR_RootConstrainSelectedInstOperands,
     /*  716649 */     // GIR_Coverage, 11668,
     /*  716649 */     GIR_EraseRootFromParent_Done,
     /*  716650 */   // Label 11307: @716650
     /*  716650 */   GIM_Try, /*On fail goto*//*Label 11308*/ GIMT_Encode4(716725), // Rule ID 11669 //
     /*  716655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  716666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  716669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  716672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716701 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716723 */     GIR_RootConstrainSelectedInstOperands,
     /*  716724 */     // GIR_Coverage, 11669,
     /*  716724 */     GIR_EraseRootFromParent_Done,
     /*  716725 */   // Label 11308: @716725
     /*  716725 */   GIM_Try, /*On fail goto*//*Label 11309*/ GIMT_Encode4(716800), // Rule ID 11672 //
     /*  716730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  716741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  716744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  716747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716798 */     GIR_RootConstrainSelectedInstOperands,
     /*  716799 */     // GIR_Coverage, 11672,
     /*  716799 */     GIR_EraseRootFromParent_Done,
     /*  716800 */   // Label 11309: @716800
     /*  716800 */   GIM_Try, /*On fail goto*//*Label 11310*/ GIMT_Encode4(716875), // Rule ID 11673 //
     /*  716805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  716816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  716819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  716822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716851 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716873 */     GIR_RootConstrainSelectedInstOperands,
     /*  716874 */     // GIR_Coverage, 11673,
     /*  716874 */     GIR_EraseRootFromParent_Done,
     /*  716875 */   // Label 11310: @716875
     /*  716875 */   GIM_Try, /*On fail goto*//*Label 11311*/ GIMT_Encode4(716950), // Rule ID 11676 //
     /*  716880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  716891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  716894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  716897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  716900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716926 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  716929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716948 */     GIR_RootConstrainSelectedInstOperands,
     /*  716949 */     // GIR_Coverage, 11676,
     /*  716949 */     GIR_EraseRootFromParent_Done,
     /*  716950 */   // Label 11311: @716950
     /*  716950 */   GIM_Try, /*On fail goto*//*Label 11312*/ GIMT_Encode4(717025), // Rule ID 11677 //
     /*  716955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  716966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  716969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  716972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  716975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717001 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  717001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  717004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717023 */     GIR_RootConstrainSelectedInstOperands,
     /*  717024 */     // GIR_Coverage, 11677,
     /*  717024 */     GIR_EraseRootFromParent_Done,
     /*  717025 */   // Label 11312: @717025
     /*  717025 */   GIM_Try, /*On fail goto*//*Label 11313*/ GIMT_Encode4(717100), // Rule ID 11680 //
     /*  717030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  717041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  717044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  717047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  717050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717076 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  717079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717098 */     GIR_RootConstrainSelectedInstOperands,
     /*  717099 */     // GIR_Coverage, 11680,
     /*  717099 */     GIR_EraseRootFromParent_Done,
     /*  717100 */   // Label 11313: @717100
     /*  717100 */   GIM_Try, /*On fail goto*//*Label 11314*/ GIMT_Encode4(717175), // Rule ID 11681 //
     /*  717105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  717116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  717119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  717122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  717125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717151 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  717151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  717154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717173 */     GIR_RootConstrainSelectedInstOperands,
     /*  717174 */     // GIR_Coverage, 11681,
     /*  717174 */     GIR_EraseRootFromParent_Done,
     /*  717175 */   // Label 11314: @717175
     /*  717175 */   GIM_Try, /*On fail goto*//*Label 11315*/ GIMT_Encode4(717250), // Rule ID 11684 //
     /*  717180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  717191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  717194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  717197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  717200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717226 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  717229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717248 */     GIR_RootConstrainSelectedInstOperands,
     /*  717249 */     // GIR_Coverage, 11684,
     /*  717249 */     GIR_EraseRootFromParent_Done,
     /*  717250 */   // Label 11315: @717250
     /*  717250 */   GIM_Try, /*On fail goto*//*Label 11316*/ GIMT_Encode4(717325), // Rule ID 11685 //
     /*  717255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  717266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  717269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  717272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  717275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717301 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  717301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  717304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717323 */     GIR_RootConstrainSelectedInstOperands,
     /*  717324 */     // GIR_Coverage, 11685,
     /*  717324 */     GIR_EraseRootFromParent_Done,
     /*  717325 */   // Label 11316: @717325
     /*  717325 */   GIM_Try, /*On fail goto*//*Label 11317*/ GIMT_Encode4(717400), // Rule ID 11688 //
     /*  717330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  717341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  717344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  717347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  717350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  717379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717398 */     GIR_RootConstrainSelectedInstOperands,
     /*  717399 */     // GIR_Coverage, 11688,
     /*  717399 */     GIR_EraseRootFromParent_Done,
     /*  717400 */   // Label 11317: @717400
     /*  717400 */   GIM_Try, /*On fail goto*//*Label 11318*/ GIMT_Encode4(717475), // Rule ID 11689 //
     /*  717405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  717416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  717419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  717422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  717425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717451 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  717454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717473 */     GIR_RootConstrainSelectedInstOperands,
     /*  717474 */     // GIR_Coverage, 11689,
     /*  717474 */     GIR_EraseRootFromParent_Done,
     /*  717475 */   // Label 11318: @717475
     /*  717475 */   GIM_Try, /*On fail goto*//*Label 11319*/ GIMT_Encode4(717550), // Rule ID 11692 //
     /*  717480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  717491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  717494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  717497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  717500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717526 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  717529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717548 */     GIR_RootConstrainSelectedInstOperands,
     /*  717549 */     // GIR_Coverage, 11692,
     /*  717549 */     GIR_EraseRootFromParent_Done,
     /*  717550 */   // Label 11319: @717550
     /*  717550 */   GIM_Try, /*On fail goto*//*Label 11320*/ GIMT_Encode4(717625), // Rule ID 11693 //
     /*  717555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  717566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  717569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  717572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  717575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717601 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  717604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717623 */     GIR_RootConstrainSelectedInstOperands,
     /*  717624 */     // GIR_Coverage, 11693,
     /*  717624 */     GIR_EraseRootFromParent_Done,
     /*  717625 */   // Label 11320: @717625
     /*  717625 */   GIM_Try, /*On fail goto*//*Label 11321*/ GIMT_Encode4(717700), // Rule ID 11696 //
     /*  717630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  717641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  717644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  717647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  717650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717676 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  717676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  717679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717698 */     GIR_RootConstrainSelectedInstOperands,
     /*  717699 */     // GIR_Coverage, 11696,
     /*  717699 */     GIR_EraseRootFromParent_Done,
     /*  717700 */   // Label 11321: @717700
     /*  717700 */   GIM_Try, /*On fail goto*//*Label 11322*/ GIMT_Encode4(717775), // Rule ID 11697 //
     /*  717705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  717716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  717719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  717722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  717725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717751 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  717751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  717754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717773 */     GIR_RootConstrainSelectedInstOperands,
     /*  717774 */     // GIR_Coverage, 11697,
     /*  717774 */     GIR_EraseRootFromParent_Done,
     /*  717775 */   // Label 11322: @717775
     /*  717775 */   GIM_Try, /*On fail goto*//*Label 11323*/ GIMT_Encode4(717850), // Rule ID 11700 //
     /*  717780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  717791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  717794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  717797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  717800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  717829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717848 */     GIR_RootConstrainSelectedInstOperands,
     /*  717849 */     // GIR_Coverage, 11700,
     /*  717849 */     GIR_EraseRootFromParent_Done,
     /*  717850 */   // Label 11323: @717850
     /*  717850 */   GIM_Try, /*On fail goto*//*Label 11324*/ GIMT_Encode4(717925), // Rule ID 11701 //
     /*  717855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  717866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  717869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  717872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  717875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717901 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  717901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  717904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717923 */     GIR_RootConstrainSelectedInstOperands,
     /*  717924 */     // GIR_Coverage, 11701,
     /*  717924 */     GIR_EraseRootFromParent_Done,
     /*  717925 */   // Label 11324: @717925
     /*  717925 */   GIM_Try, /*On fail goto*//*Label 11325*/ GIMT_Encode4(718000), // Rule ID 11704 //
     /*  717930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  717941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  717944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  717947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  717950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  717979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717998 */     GIR_RootConstrainSelectedInstOperands,
     /*  717999 */     // GIR_Coverage, 11704,
     /*  717999 */     GIR_EraseRootFromParent_Done,
     /*  718000 */   // Label 11325: @718000
     /*  718000 */   GIM_Try, /*On fail goto*//*Label 11326*/ GIMT_Encode4(718075), // Rule ID 11705 //
     /*  718005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  718016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  718019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  718022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  718025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718051 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  718054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718073 */     GIR_RootConstrainSelectedInstOperands,
     /*  718074 */     // GIR_Coverage, 11705,
     /*  718074 */     GIR_EraseRootFromParent_Done,
     /*  718075 */   // Label 11326: @718075
     /*  718075 */   GIM_Try, /*On fail goto*//*Label 11327*/ GIMT_Encode4(718150), // Rule ID 11708 //
     /*  718080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  718091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  718094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  718097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  718100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718126 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  718126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  718129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718148 */     GIR_RootConstrainSelectedInstOperands,
     /*  718149 */     // GIR_Coverage, 11708,
     /*  718149 */     GIR_EraseRootFromParent_Done,
     /*  718150 */   // Label 11327: @718150
     /*  718150 */   GIM_Try, /*On fail goto*//*Label 11328*/ GIMT_Encode4(718225), // Rule ID 11709 //
     /*  718155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  718166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  718169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  718172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  718175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718201 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  718201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  718204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718223 */     GIR_RootConstrainSelectedInstOperands,
     /*  718224 */     // GIR_Coverage, 11709,
     /*  718224 */     GIR_EraseRootFromParent_Done,
     /*  718225 */   // Label 11328: @718225
     /*  718225 */   GIM_Try, /*On fail goto*//*Label 11329*/ GIMT_Encode4(718300), // Rule ID 11712 //
     /*  718230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  718233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  718241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  718244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  718247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  718250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  718279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718298 */     GIR_RootConstrainSelectedInstOperands,
     /*  718299 */     // GIR_Coverage, 11712,
     /*  718299 */     GIR_EraseRootFromParent_Done,
     /*  718300 */   // Label 11329: @718300
     /*  718300 */   GIM_Try, /*On fail goto*//*Label 11330*/ GIMT_Encode4(718375), // Rule ID 11713 //
     /*  718305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  718308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  718316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  718319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  718322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  718325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718351 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  718354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718373 */     GIR_RootConstrainSelectedInstOperands,
     /*  718374 */     // GIR_Coverage, 11713,
     /*  718374 */     GIR_EraseRootFromParent_Done,
     /*  718375 */   // Label 11330: @718375
     /*  718375 */   GIM_Try, /*On fail goto*//*Label 11331*/ GIMT_Encode4(718450), // Rule ID 11716 //
     /*  718380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  718391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  718394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  718397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  718400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718426 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  718429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718448 */     GIR_RootConstrainSelectedInstOperands,
     /*  718449 */     // GIR_Coverage, 11716,
     /*  718449 */     GIR_EraseRootFromParent_Done,
     /*  718450 */   // Label 11331: @718450
     /*  718450 */   GIM_Try, /*On fail goto*//*Label 11332*/ GIMT_Encode4(718525), // Rule ID 11717 //
     /*  718455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  718466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  718469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  718472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  718475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718501 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  718504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718523 */     GIR_RootConstrainSelectedInstOperands,
     /*  718524 */     // GIR_Coverage, 11717,
     /*  718524 */     GIR_EraseRootFromParent_Done,
     /*  718525 */   // Label 11332: @718525
     /*  718525 */   GIM_Try, /*On fail goto*//*Label 11333*/ GIMT_Encode4(718600), // Rule ID 11720 //
     /*  718530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  718541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  718544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  718547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  718550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718576 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  718579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718598 */     GIR_RootConstrainSelectedInstOperands,
     /*  718599 */     // GIR_Coverage, 11720,
     /*  718599 */     GIR_EraseRootFromParent_Done,
     /*  718600 */   // Label 11333: @718600
     /*  718600 */   GIM_Try, /*On fail goto*//*Label 11334*/ GIMT_Encode4(718675), // Rule ID 11721 //
     /*  718605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  718616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  718619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  718622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  718625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718651 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  718654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718673 */     GIR_RootConstrainSelectedInstOperands,
     /*  718674 */     // GIR_Coverage, 11721,
     /*  718674 */     GIR_EraseRootFromParent_Done,
     /*  718675 */   // Label 11334: @718675
     /*  718675 */   GIM_Try, /*On fail goto*//*Label 11335*/ GIMT_Encode4(718750), // Rule ID 11724 //
     /*  718680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  718691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  718694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  718697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  718700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718726 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  718729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718748 */     GIR_RootConstrainSelectedInstOperands,
     /*  718749 */     // GIR_Coverage, 11724,
     /*  718749 */     GIR_EraseRootFromParent_Done,
     /*  718750 */   // Label 11335: @718750
     /*  718750 */   GIM_Try, /*On fail goto*//*Label 11336*/ GIMT_Encode4(718825), // Rule ID 11725 //
     /*  718755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  718766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  718769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  718772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  718775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718801 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  718804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718823 */     GIR_RootConstrainSelectedInstOperands,
     /*  718824 */     // GIR_Coverage, 11725,
     /*  718824 */     GIR_EraseRootFromParent_Done,
     /*  718825 */   // Label 11336: @718825
     /*  718825 */   GIM_Try, /*On fail goto*//*Label 11337*/ GIMT_Encode4(718900), // Rule ID 11728 //
     /*  718830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  718841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  718844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  718847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  718850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  718876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  718879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718898 */     GIR_RootConstrainSelectedInstOperands,
     /*  718899 */     // GIR_Coverage, 11728,
     /*  718899 */     GIR_EraseRootFromParent_Done,
     /*  718900 */   // Label 11337: @718900
     /*  718900 */   GIM_Try, /*On fail goto*//*Label 11338*/ GIMT_Encode4(718975), // Rule ID 11729 //
     /*  718905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  718916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  718919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  718922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  718925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718951 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  718954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718973 */     GIR_RootConstrainSelectedInstOperands,
     /*  718974 */     // GIR_Coverage, 11729,
     /*  718974 */     GIR_EraseRootFromParent_Done,
     /*  718975 */   // Label 11338: @718975
     /*  718975 */   GIM_Try, /*On fail goto*//*Label 11339*/ GIMT_Encode4(719050), // Rule ID 11732 //
     /*  718980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  718991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  718994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  718997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  719000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  719026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  719029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719048 */     GIR_RootConstrainSelectedInstOperands,
     /*  719049 */     // GIR_Coverage, 11732,
     /*  719049 */     GIR_EraseRootFromParent_Done,
     /*  719050 */   // Label 11339: @719050
     /*  719050 */   GIM_Try, /*On fail goto*//*Label 11340*/ GIMT_Encode4(719125), // Rule ID 11733 //
     /*  719055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  719066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  719069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  719072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  719075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719101 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  719101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  719104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719123 */     GIR_RootConstrainSelectedInstOperands,
     /*  719124 */     // GIR_Coverage, 11733,
     /*  719124 */     GIR_EraseRootFromParent_Done,
     /*  719125 */   // Label 11340: @719125
     /*  719125 */   GIM_Try, /*On fail goto*//*Label 11341*/ GIMT_Encode4(719200), // Rule ID 11736 //
     /*  719130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  719141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  719144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  719147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  719150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719176 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  719176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  719179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719198 */     GIR_RootConstrainSelectedInstOperands,
     /*  719199 */     // GIR_Coverage, 11736,
     /*  719199 */     GIR_EraseRootFromParent_Done,
     /*  719200 */   // Label 11341: @719200
     /*  719200 */   GIM_Try, /*On fail goto*//*Label 11342*/ GIMT_Encode4(719275), // Rule ID 11737 //
     /*  719205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  719216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  719219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  719222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  719225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719251 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  719251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  719254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719273 */     GIR_RootConstrainSelectedInstOperands,
     /*  719274 */     // GIR_Coverage, 11737,
     /*  719274 */     GIR_EraseRootFromParent_Done,
     /*  719275 */   // Label 11342: @719275
     /*  719275 */   GIM_Try, /*On fail goto*//*Label 11343*/ GIMT_Encode4(719350), // Rule ID 11740 //
     /*  719280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  719291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  719294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  719297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  719300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719326 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  719329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719348 */     GIR_RootConstrainSelectedInstOperands,
     /*  719349 */     // GIR_Coverage, 11740,
     /*  719349 */     GIR_EraseRootFromParent_Done,
     /*  719350 */   // Label 11343: @719350
     /*  719350 */   GIM_Try, /*On fail goto*//*Label 11344*/ GIMT_Encode4(719425), // Rule ID 11741 //
     /*  719355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  719366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  719369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  719372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  719375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  719401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  719404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719423 */     GIR_RootConstrainSelectedInstOperands,
     /*  719424 */     // GIR_Coverage, 11741,
     /*  719424 */     GIR_EraseRootFromParent_Done,
     /*  719425 */   // Label 11344: @719425
     /*  719425 */   GIM_Try, /*On fail goto*//*Label 11345*/ GIMT_Encode4(719500), // Rule ID 11744 //
     /*  719430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  719441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  719444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  719447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  719450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719476 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  719479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719498 */     GIR_RootConstrainSelectedInstOperands,
     /*  719499 */     // GIR_Coverage, 11744,
     /*  719499 */     GIR_EraseRootFromParent_Done,
     /*  719500 */   // Label 11345: @719500
     /*  719500 */   GIM_Try, /*On fail goto*//*Label 11346*/ GIMT_Encode4(719575), // Rule ID 11745 //
     /*  719505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  719516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  719519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  719522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  719525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  719551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  719554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719573 */     GIR_RootConstrainSelectedInstOperands,
     /*  719574 */     // GIR_Coverage, 11745,
     /*  719574 */     GIR_EraseRootFromParent_Done,
     /*  719575 */   // Label 11346: @719575
     /*  719575 */   GIM_Try, /*On fail goto*//*Label 11347*/ GIMT_Encode4(719650), // Rule ID 11748 //
     /*  719580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  719591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  719594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  719597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  719600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  719629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719648 */     GIR_RootConstrainSelectedInstOperands,
     /*  719649 */     // GIR_Coverage, 11748,
     /*  719649 */     GIR_EraseRootFromParent_Done,
     /*  719650 */   // Label 11347: @719650
     /*  719650 */   GIM_Try, /*On fail goto*//*Label 11348*/ GIMT_Encode4(719725), // Rule ID 11749 //
     /*  719655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  719666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  719669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  719672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  719675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719701 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  719701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  719704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719723 */     GIR_RootConstrainSelectedInstOperands,
     /*  719724 */     // GIR_Coverage, 11749,
     /*  719724 */     GIR_EraseRootFromParent_Done,
     /*  719725 */   // Label 11348: @719725
     /*  719725 */   GIM_Try, /*On fail goto*//*Label 11349*/ GIMT_Encode4(719800), // Rule ID 11752 //
     /*  719730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  719733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  719750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  719779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719798 */     GIR_RootConstrainSelectedInstOperands,
     /*  719799 */     // GIR_Coverage, 11752,
     /*  719799 */     GIR_EraseRootFromParent_Done,
     /*  719800 */   // Label 11349: @719800
     /*  719800 */   GIM_Try, /*On fail goto*//*Label 11350*/ GIMT_Encode4(719875), // Rule ID 11753 //
     /*  719805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  719808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  719825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719851 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  719854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719873 */     GIR_RootConstrainSelectedInstOperands,
     /*  719874 */     // GIR_Coverage, 11753,
     /*  719874 */     GIR_EraseRootFromParent_Done,
     /*  719875 */   // Label 11350: @719875
     /*  719875 */   GIM_Try, /*On fail goto*//*Label 11351*/ GIMT_Encode4(719950), // Rule ID 11756 //
     /*  719880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  719883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  719900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719926 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  719929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719948 */     GIR_RootConstrainSelectedInstOperands,
     /*  719949 */     // GIR_Coverage, 11756,
     /*  719949 */     GIR_EraseRootFromParent_Done,
     /*  719950 */   // Label 11351: @719950
     /*  719950 */   GIM_Try, /*On fail goto*//*Label 11352*/ GIMT_Encode4(720025), // Rule ID 11757 //
     /*  719955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  719958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  719975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720001 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  720001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  720004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720023 */     GIR_RootConstrainSelectedInstOperands,
     /*  720024 */     // GIR_Coverage, 11757,
     /*  720024 */     GIR_EraseRootFromParent_Done,
     /*  720025 */   // Label 11352: @720025
     /*  720025 */   GIM_Try, /*On fail goto*//*Label 11353*/ GIMT_Encode4(720100), // Rule ID 11760 //
     /*  720030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  720033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  720041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  720044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  720047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  720050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720076 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  720076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  720079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720098 */     GIR_RootConstrainSelectedInstOperands,
     /*  720099 */     // GIR_Coverage, 11760,
     /*  720099 */     GIR_EraseRootFromParent_Done,
     /*  720100 */   // Label 11353: @720100
     /*  720100 */   GIM_Try, /*On fail goto*//*Label 11354*/ GIMT_Encode4(720175), // Rule ID 11761 //
     /*  720105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  720108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  720116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  720119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  720122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  720125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720151 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  720151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  720154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720173 */     GIR_RootConstrainSelectedInstOperands,
     /*  720174 */     // GIR_Coverage, 11761,
     /*  720174 */     GIR_EraseRootFromParent_Done,
     /*  720175 */   // Label 11354: @720175
     /*  720175 */   GIM_Try, /*On fail goto*//*Label 11355*/ GIMT_Encode4(720250), // Rule ID 11764 //
     /*  720180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  720191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  720194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  720197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720226 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  720229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720248 */     GIR_RootConstrainSelectedInstOperands,
     /*  720249 */     // GIR_Coverage, 11764,
     /*  720249 */     GIR_EraseRootFromParent_Done,
     /*  720250 */   // Label 11355: @720250
     /*  720250 */   GIM_Try, /*On fail goto*//*Label 11356*/ GIMT_Encode4(720325), // Rule ID 11765 //
     /*  720255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  720266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  720269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  720272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720301 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  720304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720323 */     GIR_RootConstrainSelectedInstOperands,
     /*  720324 */     // GIR_Coverage, 11765,
     /*  720324 */     GIR_EraseRootFromParent_Done,
     /*  720325 */   // Label 11356: @720325
     /*  720325 */   GIM_Try, /*On fail goto*//*Label 11357*/ GIMT_Encode4(720400), // Rule ID 11768 //
     /*  720330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  720341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  720344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  720347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  720379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720398 */     GIR_RootConstrainSelectedInstOperands,
     /*  720399 */     // GIR_Coverage, 11768,
     /*  720399 */     GIR_EraseRootFromParent_Done,
     /*  720400 */   // Label 11357: @720400
     /*  720400 */   GIM_Try, /*On fail goto*//*Label 11358*/ GIMT_Encode4(720475), // Rule ID 11769 //
     /*  720405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  720416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  720419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  720422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720451 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  720454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720473 */     GIR_RootConstrainSelectedInstOperands,
     /*  720474 */     // GIR_Coverage, 11769,
     /*  720474 */     GIR_EraseRootFromParent_Done,
     /*  720475 */   // Label 11358: @720475
     /*  720475 */   GIM_Try, /*On fail goto*//*Label 11359*/ GIMT_Encode4(720550), // Rule ID 11772 //
     /*  720480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  720491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  720494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  720497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720526 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  720529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720548 */     GIR_RootConstrainSelectedInstOperands,
     /*  720549 */     // GIR_Coverage, 11772,
     /*  720549 */     GIR_EraseRootFromParent_Done,
     /*  720550 */   // Label 11359: @720550
     /*  720550 */   GIM_Try, /*On fail goto*//*Label 11360*/ GIMT_Encode4(720625), // Rule ID 11773 //
     /*  720555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  720566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  720569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  720572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720601 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  720604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720623 */     GIR_RootConstrainSelectedInstOperands,
     /*  720624 */     // GIR_Coverage, 11773,
     /*  720624 */     GIR_EraseRootFromParent_Done,
     /*  720625 */   // Label 11360: @720625
     /*  720625 */   GIM_Try, /*On fail goto*//*Label 11361*/ GIMT_Encode4(720700), // Rule ID 11776 //
     /*  720630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  720641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  720644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  720647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720676 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  720679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720698 */     GIR_RootConstrainSelectedInstOperands,
     /*  720699 */     // GIR_Coverage, 11776,
     /*  720699 */     GIR_EraseRootFromParent_Done,
     /*  720700 */   // Label 11361: @720700
     /*  720700 */   GIM_Try, /*On fail goto*//*Label 11362*/ GIMT_Encode4(720775), // Rule ID 11777 //
     /*  720705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  720716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  720719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  720722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720751 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  720754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720773 */     GIR_RootConstrainSelectedInstOperands,
     /*  720774 */     // GIR_Coverage, 11777,
     /*  720774 */     GIR_EraseRootFromParent_Done,
     /*  720775 */   // Label 11362: @720775
     /*  720775 */   GIM_Try, /*On fail goto*//*Label 11363*/ GIMT_Encode4(720850), // Rule ID 11780 //
     /*  720780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  720791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  720794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  720797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  720829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720848 */     GIR_RootConstrainSelectedInstOperands,
     /*  720849 */     // GIR_Coverage, 11780,
     /*  720849 */     GIR_EraseRootFromParent_Done,
     /*  720850 */   // Label 11363: @720850
     /*  720850 */   GIM_Try, /*On fail goto*//*Label 11364*/ GIMT_Encode4(720925), // Rule ID 11781 //
     /*  720855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  720866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  720869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  720872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720901 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  720904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720923 */     GIR_RootConstrainSelectedInstOperands,
     /*  720924 */     // GIR_Coverage, 11781,
     /*  720924 */     GIR_EraseRootFromParent_Done,
     /*  720925 */   // Label 11364: @720925
     /*  720925 */   GIM_Try, /*On fail goto*//*Label 11365*/ GIMT_Encode4(721000), // Rule ID 11784 //
     /*  720930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  720941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  720944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  720947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720976 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  720976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  720979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720998 */     GIR_RootConstrainSelectedInstOperands,
     /*  720999 */     // GIR_Coverage, 11784,
     /*  720999 */     GIR_EraseRootFromParent_Done,
     /*  721000 */   // Label 11365: @721000
     /*  721000 */   GIM_Try, /*On fail goto*//*Label 11366*/ GIMT_Encode4(721075), // Rule ID 11785 //
     /*  721005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  721016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  721019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  721022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721051 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  721054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721073 */     GIR_RootConstrainSelectedInstOperands,
     /*  721074 */     // GIR_Coverage, 11785,
     /*  721074 */     GIR_EraseRootFromParent_Done,
     /*  721075 */   // Label 11366: @721075
     /*  721075 */   GIM_Try, /*On fail goto*//*Label 11367*/ GIMT_Encode4(721150), // Rule ID 11788 //
     /*  721080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  721097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721126 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  721129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721148 */     GIR_RootConstrainSelectedInstOperands,
     /*  721149 */     // GIR_Coverage, 11788,
     /*  721149 */     GIR_EraseRootFromParent_Done,
     /*  721150 */   // Label 11367: @721150
     /*  721150 */   GIM_Try, /*On fail goto*//*Label 11368*/ GIMT_Encode4(721225), // Rule ID 11789 //
     /*  721155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  721172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721201 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  721204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721223 */     GIR_RootConstrainSelectedInstOperands,
     /*  721224 */     // GIR_Coverage, 11789,
     /*  721224 */     GIR_EraseRootFromParent_Done,
     /*  721225 */   // Label 11368: @721225
     /*  721225 */   GIM_Try, /*On fail goto*//*Label 11369*/ GIMT_Encode4(721300), // Rule ID 11792 //
     /*  721230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  721241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  721244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  721247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  721276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  721279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721298 */     GIR_RootConstrainSelectedInstOperands,
     /*  721299 */     // GIR_Coverage, 11792,
     /*  721299 */     GIR_EraseRootFromParent_Done,
     /*  721300 */   // Label 11369: @721300
     /*  721300 */   GIM_Try, /*On fail goto*//*Label 11370*/ GIMT_Encode4(721375), // Rule ID 11793 //
     /*  721305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  721316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  721319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  721322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721351 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  721351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  721354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721373 */     GIR_RootConstrainSelectedInstOperands,
     /*  721374 */     // GIR_Coverage, 11793,
     /*  721374 */     GIR_EraseRootFromParent_Done,
     /*  721375 */   // Label 11370: @721375
     /*  721375 */   GIM_Try, /*On fail goto*//*Label 11371*/ GIMT_Encode4(721450), // Rule ID 11796 //
     /*  721380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  721391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  721394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  721397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721426 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  721426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  721429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721448 */     GIR_RootConstrainSelectedInstOperands,
     /*  721449 */     // GIR_Coverage, 11796,
     /*  721449 */     GIR_EraseRootFromParent_Done,
     /*  721450 */   // Label 11371: @721450
     /*  721450 */   GIM_Try, /*On fail goto*//*Label 11372*/ GIMT_Encode4(721525), // Rule ID 11797 //
     /*  721455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  721466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  721469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  721472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721501 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  721504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721523 */     GIR_RootConstrainSelectedInstOperands,
     /*  721524 */     // GIR_Coverage, 11797,
     /*  721524 */     GIR_EraseRootFromParent_Done,
     /*  721525 */   // Label 11372: @721525
     /*  721525 */   GIM_Try, /*On fail goto*//*Label 11373*/ GIMT_Encode4(721600), // Rule ID 11800 //
     /*  721530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  721533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  721547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  721576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  721579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721598 */     GIR_RootConstrainSelectedInstOperands,
     /*  721599 */     // GIR_Coverage, 11800,
     /*  721599 */     GIR_EraseRootFromParent_Done,
     /*  721600 */   // Label 11373: @721600
     /*  721600 */   GIM_Try, /*On fail goto*//*Label 11374*/ GIMT_Encode4(721675), // Rule ID 11801 //
     /*  721605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  721608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  721622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721651 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  721651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  721654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721673 */     GIR_RootConstrainSelectedInstOperands,
     /*  721674 */     // GIR_Coverage, 11801,
     /*  721674 */     GIR_EraseRootFromParent_Done,
     /*  721675 */   // Label 11374: @721675
     /*  721675 */   GIM_Try, /*On fail goto*//*Label 11375*/ GIMT_Encode4(721750), // Rule ID 11804 //
     /*  721680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  721691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  721694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  721697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  721729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721748 */     GIR_RootConstrainSelectedInstOperands,
     /*  721749 */     // GIR_Coverage, 11804,
     /*  721749 */     GIR_EraseRootFromParent_Done,
     /*  721750 */   // Label 11375: @721750
     /*  721750 */   GIM_Try, /*On fail goto*//*Label 11376*/ GIMT_Encode4(721825), // Rule ID 11805 //
     /*  721755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  721766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  721769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  721772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721801 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  721804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721823 */     GIR_RootConstrainSelectedInstOperands,
     /*  721824 */     // GIR_Coverage, 11805,
     /*  721824 */     GIR_EraseRootFromParent_Done,
     /*  721825 */   // Label 11376: @721825
     /*  721825 */   GIM_Try, /*On fail goto*//*Label 11377*/ GIMT_Encode4(721900), // Rule ID 11808 //
     /*  721830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  721841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  721844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  721847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721876 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  721879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721898 */     GIR_RootConstrainSelectedInstOperands,
     /*  721899 */     // GIR_Coverage, 11808,
     /*  721899 */     GIR_EraseRootFromParent_Done,
     /*  721900 */   // Label 11377: @721900
     /*  721900 */   GIM_Try, /*On fail goto*//*Label 11378*/ GIMT_Encode4(721975), // Rule ID 11809 //
     /*  721905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  721916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  721919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  721922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721951 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  721954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721973 */     GIR_RootConstrainSelectedInstOperands,
     /*  721974 */     // GIR_Coverage, 11809,
     /*  721974 */     GIR_EraseRootFromParent_Done,
     /*  721975 */   // Label 11378: @721975
     /*  721975 */   GIM_Try, /*On fail goto*//*Label 11379*/ GIMT_Encode4(722050), // Rule ID 11812 //
     /*  721980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  721991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  721994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  721997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722026 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  722026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  722029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722048 */     GIR_RootConstrainSelectedInstOperands,
     /*  722049 */     // GIR_Coverage, 11812,
     /*  722049 */     GIR_EraseRootFromParent_Done,
     /*  722050 */   // Label 11379: @722050
     /*  722050 */   GIM_Try, /*On fail goto*//*Label 11380*/ GIMT_Encode4(722125), // Rule ID 11813 //
     /*  722055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  722066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  722069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  722072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722101 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  722101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  722104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722123 */     GIR_RootConstrainSelectedInstOperands,
     /*  722124 */     // GIR_Coverage, 11813,
     /*  722124 */     GIR_EraseRootFromParent_Done,
     /*  722125 */   // Label 11380: @722125
     /*  722125 */   GIM_Try, /*On fail goto*//*Label 11381*/ GIMT_Encode4(722200), // Rule ID 11816 //
     /*  722130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  722141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  722144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  722147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722176 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  722179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722198 */     GIR_RootConstrainSelectedInstOperands,
     /*  722199 */     // GIR_Coverage, 11816,
     /*  722199 */     GIR_EraseRootFromParent_Done,
     /*  722200 */   // Label 11381: @722200
     /*  722200 */   GIM_Try, /*On fail goto*//*Label 11382*/ GIMT_Encode4(722275), // Rule ID 11817 //
     /*  722205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  722216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  722219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  722222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722251 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  722254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722273 */     GIR_RootConstrainSelectedInstOperands,
     /*  722274 */     // GIR_Coverage, 11817,
     /*  722274 */     GIR_EraseRootFromParent_Done,
     /*  722275 */   // Label 11382: @722275
     /*  722275 */   GIM_Try, /*On fail goto*//*Label 11383*/ GIMT_Encode4(722350), // Rule ID 11820 //
     /*  722280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  722291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  722294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  722297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722326 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  722329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722348 */     GIR_RootConstrainSelectedInstOperands,
     /*  722349 */     // GIR_Coverage, 11820,
     /*  722349 */     GIR_EraseRootFromParent_Done,
     /*  722350 */   // Label 11383: @722350
     /*  722350 */   GIM_Try, /*On fail goto*//*Label 11384*/ GIMT_Encode4(722425), // Rule ID 11821 //
     /*  722355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  722366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  722369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  722372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722401 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  722404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722423 */     GIR_RootConstrainSelectedInstOperands,
     /*  722424 */     // GIR_Coverage, 11821,
     /*  722424 */     GIR_EraseRootFromParent_Done,
     /*  722425 */   // Label 11384: @722425
     /*  722425 */   GIM_Try, /*On fail goto*//*Label 11385*/ GIMT_Encode4(722500), // Rule ID 11824 //
     /*  722430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  722441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  722444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  722447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722476 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  722479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722498 */     GIR_RootConstrainSelectedInstOperands,
     /*  722499 */     // GIR_Coverage, 11824,
     /*  722499 */     GIR_EraseRootFromParent_Done,
     /*  722500 */   // Label 11385: @722500
     /*  722500 */   GIM_Try, /*On fail goto*//*Label 11386*/ GIMT_Encode4(722575), // Rule ID 11825 //
     /*  722505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  722516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  722519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  722522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722551 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  722554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722573 */     GIR_RootConstrainSelectedInstOperands,
     /*  722574 */     // GIR_Coverage, 11825,
     /*  722574 */     GIR_EraseRootFromParent_Done,
     /*  722575 */   // Label 11386: @722575
     /*  722575 */   GIM_Try, /*On fail goto*//*Label 11387*/ GIMT_Encode4(722650), // Rule ID 11828 //
     /*  722580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  722591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  722594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  722597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  722629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722648 */     GIR_RootConstrainSelectedInstOperands,
     /*  722649 */     // GIR_Coverage, 11828,
     /*  722649 */     GIR_EraseRootFromParent_Done,
     /*  722650 */   // Label 11387: @722650
     /*  722650 */   GIM_Try, /*On fail goto*//*Label 11388*/ GIMT_Encode4(722725), // Rule ID 11829 //
     /*  722655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  722666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  722669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  722672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722701 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  722704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722723 */     GIR_RootConstrainSelectedInstOperands,
     /*  722724 */     // GIR_Coverage, 11829,
     /*  722724 */     GIR_EraseRootFromParent_Done,
     /*  722725 */   // Label 11388: @722725
     /*  722725 */   GIM_Try, /*On fail goto*//*Label 11389*/ GIMT_Encode4(722800), // Rule ID 11832 //
     /*  722730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  722741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  722744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  722747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  722779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722798 */     GIR_RootConstrainSelectedInstOperands,
     /*  722799 */     // GIR_Coverage, 11832,
     /*  722799 */     GIR_EraseRootFromParent_Done,
     /*  722800 */   // Label 11389: @722800
     /*  722800 */   GIM_Try, /*On fail goto*//*Label 11390*/ GIMT_Encode4(722875), // Rule ID 11833 //
     /*  722805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  722816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  722819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  722822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722851 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  722854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722873 */     GIR_RootConstrainSelectedInstOperands,
     /*  722874 */     // GIR_Coverage, 11833,
     /*  722874 */     GIR_EraseRootFromParent_Done,
     /*  722875 */   // Label 11390: @722875
     /*  722875 */   GIM_Try, /*On fail goto*//*Label 11391*/ GIMT_Encode4(722950), // Rule ID 11836 //
     /*  722880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  722891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  722894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  722897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722926 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  722929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722948 */     GIR_RootConstrainSelectedInstOperands,
     /*  722949 */     // GIR_Coverage, 11836,
     /*  722949 */     GIR_EraseRootFromParent_Done,
     /*  722950 */   // Label 11391: @722950
     /*  722950 */   GIM_Try, /*On fail goto*//*Label 11392*/ GIMT_Encode4(723025), // Rule ID 11837 //
     /*  722955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  722966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  722969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  722972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723001 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  723001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  723004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723023 */     GIR_RootConstrainSelectedInstOperands,
     /*  723024 */     // GIR_Coverage, 11837,
     /*  723024 */     GIR_EraseRootFromParent_Done,
     /*  723025 */   // Label 11392: @723025
     /*  723025 */   GIM_Try, /*On fail goto*//*Label 11393*/ GIMT_Encode4(723100), // Rule ID 11840 //
     /*  723030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  723041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  723044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  723047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  723050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  723079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723098 */     GIR_RootConstrainSelectedInstOperands,
     /*  723099 */     // GIR_Coverage, 11840,
     /*  723099 */     GIR_EraseRootFromParent_Done,
     /*  723100 */   // Label 11393: @723100
     /*  723100 */   GIM_Try, /*On fail goto*//*Label 11394*/ GIMT_Encode4(723175), // Rule ID 11841 //
     /*  723105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  723116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  723119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  723122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  723125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723151 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  723154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723173 */     GIR_RootConstrainSelectedInstOperands,
     /*  723174 */     // GIR_Coverage, 11841,
     /*  723174 */     GIR_EraseRootFromParent_Done,
     /*  723175 */   // Label 11394: @723175
     /*  723175 */   GIM_Try, /*On fail goto*//*Label 11395*/ GIMT_Encode4(723250), // Rule ID 11844 //
     /*  723180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  723191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  723194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  723197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  723200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723226 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  723229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723248 */     GIR_RootConstrainSelectedInstOperands,
     /*  723249 */     // GIR_Coverage, 11844,
     /*  723249 */     GIR_EraseRootFromParent_Done,
     /*  723250 */   // Label 11395: @723250
     /*  723250 */   GIM_Try, /*On fail goto*//*Label 11396*/ GIMT_Encode4(723325), // Rule ID 11845 //
     /*  723255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  723266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  723269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  723272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  723275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723301 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  723304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723323 */     GIR_RootConstrainSelectedInstOperands,
     /*  723324 */     // GIR_Coverage, 11845,
     /*  723324 */     GIR_EraseRootFromParent_Done,
     /*  723325 */   // Label 11396: @723325
     /*  723325 */   GIM_Try, /*On fail goto*//*Label 11397*/ GIMT_Encode4(723400), // Rule ID 11848 //
     /*  723330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  723341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  723344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  723347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  723350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723376 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  723379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723398 */     GIR_RootConstrainSelectedInstOperands,
     /*  723399 */     // GIR_Coverage, 11848,
     /*  723399 */     GIR_EraseRootFromParent_Done,
     /*  723400 */   // Label 11397: @723400
     /*  723400 */   GIM_Try, /*On fail goto*//*Label 11398*/ GIMT_Encode4(723475), // Rule ID 11849 //
     /*  723405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  723416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  723419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  723422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  723425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723451 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  723454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723473 */     GIR_RootConstrainSelectedInstOperands,
     /*  723474 */     // GIR_Coverage, 11849,
     /*  723474 */     GIR_EraseRootFromParent_Done,
     /*  723475 */   // Label 11398: @723475
     /*  723475 */   GIM_Try, /*On fail goto*//*Label 11399*/ GIMT_Encode4(723550), // Rule ID 11852 //
     /*  723480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  723491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  723494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  723497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  723500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723526 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  723529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723548 */     GIR_RootConstrainSelectedInstOperands,
     /*  723549 */     // GIR_Coverage, 11852,
     /*  723549 */     GIR_EraseRootFromParent_Done,
     /*  723550 */   // Label 11399: @723550
     /*  723550 */   GIM_Try, /*On fail goto*//*Label 11400*/ GIMT_Encode4(723625), // Rule ID 11853 //
     /*  723555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  723566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  723569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  723572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  723575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723601 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  723604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723623 */     GIR_RootConstrainSelectedInstOperands,
     /*  723624 */     // GIR_Coverage, 11853,
     /*  723624 */     GIR_EraseRootFromParent_Done,
     /*  723625 */   // Label 11400: @723625
     /*  723625 */   GIM_Try, /*On fail goto*//*Label 11401*/ GIMT_Encode4(723700), // Rule ID 11856 //
     /*  723630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  723641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  723644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  723647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  723650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723676 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  723679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723698 */     GIR_RootConstrainSelectedInstOperands,
     /*  723699 */     // GIR_Coverage, 11856,
     /*  723699 */     GIR_EraseRootFromParent_Done,
     /*  723700 */   // Label 11401: @723700
     /*  723700 */   GIM_Try, /*On fail goto*//*Label 11402*/ GIMT_Encode4(723775), // Rule ID 11857 //
     /*  723705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  723716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  723719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  723722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  723725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723751 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  723754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723773 */     GIR_RootConstrainSelectedInstOperands,
     /*  723774 */     // GIR_Coverage, 11857,
     /*  723774 */     GIR_EraseRootFromParent_Done,
     /*  723775 */   // Label 11402: @723775
     /*  723775 */   GIM_Try, /*On fail goto*//*Label 11403*/ GIMT_Encode4(723850), // Rule ID 11860 //
     /*  723780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  723791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  723794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  723797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  723800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723826 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  723829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723848 */     GIR_RootConstrainSelectedInstOperands,
     /*  723849 */     // GIR_Coverage, 11860,
     /*  723849 */     GIR_EraseRootFromParent_Done,
     /*  723850 */   // Label 11403: @723850
     /*  723850 */   GIM_Try, /*On fail goto*//*Label 11404*/ GIMT_Encode4(723925), // Rule ID 11861 //
     /*  723855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  723866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  723869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  723872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  723875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723901 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  723904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723923 */     GIR_RootConstrainSelectedInstOperands,
     /*  723924 */     // GIR_Coverage, 11861,
     /*  723924 */     GIR_EraseRootFromParent_Done,
     /*  723925 */   // Label 11404: @723925
     /*  723925 */   GIM_Try, /*On fail goto*//*Label 11405*/ GIMT_Encode4(724000), // Rule ID 11864 //
     /*  723930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  723941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  723944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  723947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  723950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  723976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  723979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723998 */     GIR_RootConstrainSelectedInstOperands,
     /*  723999 */     // GIR_Coverage, 11864,
     /*  723999 */     GIR_EraseRootFromParent_Done,
     /*  724000 */   // Label 11405: @724000
     /*  724000 */   GIM_Try, /*On fail goto*//*Label 11406*/ GIMT_Encode4(724075), // Rule ID 11865 //
     /*  724005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  724016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  724019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  724022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  724025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724051 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  724054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724073 */     GIR_RootConstrainSelectedInstOperands,
     /*  724074 */     // GIR_Coverage, 11865,
     /*  724074 */     GIR_EraseRootFromParent_Done,
     /*  724075 */   // Label 11406: @724075
     /*  724075 */   GIM_Try, /*On fail goto*//*Label 11407*/ GIMT_Encode4(724150), // Rule ID 11868 //
     /*  724080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  724091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  724094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  724097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  724100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  724129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724148 */     GIR_RootConstrainSelectedInstOperands,
     /*  724149 */     // GIR_Coverage, 11868,
     /*  724149 */     GIR_EraseRootFromParent_Done,
     /*  724150 */   // Label 11407: @724150
     /*  724150 */   GIM_Try, /*On fail goto*//*Label 11408*/ GIMT_Encode4(724225), // Rule ID 11869 //
     /*  724155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  724166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  724169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  724172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  724175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724201 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  724204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724223 */     GIR_RootConstrainSelectedInstOperands,
     /*  724224 */     // GIR_Coverage, 11869,
     /*  724224 */     GIR_EraseRootFromParent_Done,
     /*  724225 */   // Label 11408: @724225
     /*  724225 */   GIM_Try, /*On fail goto*//*Label 11409*/ GIMT_Encode4(724300), // Rule ID 11872 //
     /*  724230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  724241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  724244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  724247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  724250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  724279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724298 */     GIR_RootConstrainSelectedInstOperands,
     /*  724299 */     // GIR_Coverage, 11872,
     /*  724299 */     GIR_EraseRootFromParent_Done,
     /*  724300 */   // Label 11409: @724300
     /*  724300 */   GIM_Try, /*On fail goto*//*Label 11410*/ GIMT_Encode4(724375), // Rule ID 11873 //
     /*  724305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  724316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  724319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  724322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  724325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724351 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  724354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724373 */     GIR_RootConstrainSelectedInstOperands,
     /*  724374 */     // GIR_Coverage, 11873,
     /*  724374 */     GIR_EraseRootFromParent_Done,
     /*  724375 */   // Label 11410: @724375
     /*  724375 */   GIM_Try, /*On fail goto*//*Label 11411*/ GIMT_Encode4(724450), // Rule ID 11876 //
     /*  724380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  724391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  724394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  724397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  724400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  724429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724448 */     GIR_RootConstrainSelectedInstOperands,
     /*  724449 */     // GIR_Coverage, 11876,
     /*  724449 */     GIR_EraseRootFromParent_Done,
     /*  724450 */   // Label 11411: @724450
     /*  724450 */   GIM_Try, /*On fail goto*//*Label 11412*/ GIMT_Encode4(724525), // Rule ID 11877 //
     /*  724455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  724466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  724469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  724472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  724475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724501 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  724504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724523 */     GIR_RootConstrainSelectedInstOperands,
     /*  724524 */     // GIR_Coverage, 11877,
     /*  724524 */     GIR_EraseRootFromParent_Done,
     /*  724525 */   // Label 11412: @724525
     /*  724525 */   GIM_Try, /*On fail goto*//*Label 11413*/ GIMT_Encode4(724600), // Rule ID 11880 //
     /*  724530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  724541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  724544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  724547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  724550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  724579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724598 */     GIR_RootConstrainSelectedInstOperands,
     /*  724599 */     // GIR_Coverage, 11880,
     /*  724599 */     GIR_EraseRootFromParent_Done,
     /*  724600 */   // Label 11413: @724600
     /*  724600 */   GIM_Try, /*On fail goto*//*Label 11414*/ GIMT_Encode4(724675), // Rule ID 11881 //
     /*  724605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  724616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  724619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  724622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  724625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724651 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  724654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724673 */     GIR_RootConstrainSelectedInstOperands,
     /*  724674 */     // GIR_Coverage, 11881,
     /*  724674 */     GIR_EraseRootFromParent_Done,
     /*  724675 */   // Label 11414: @724675
     /*  724675 */   GIM_Try, /*On fail goto*//*Label 11415*/ GIMT_Encode4(724750), // Rule ID 11884 //
     /*  724680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  724697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  724729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724748 */     GIR_RootConstrainSelectedInstOperands,
     /*  724749 */     // GIR_Coverage, 11884,
     /*  724749 */     GIR_EraseRootFromParent_Done,
     /*  724750 */   // Label 11415: @724750
     /*  724750 */   GIM_Try, /*On fail goto*//*Label 11416*/ GIMT_Encode4(724825), // Rule ID 11885 //
     /*  724755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  724772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724801 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  724804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724823 */     GIR_RootConstrainSelectedInstOperands,
     /*  724824 */     // GIR_Coverage, 11885,
     /*  724824 */     GIR_EraseRootFromParent_Done,
     /*  724825 */   // Label 11416: @724825
     /*  724825 */   GIM_Try, /*On fail goto*//*Label 11417*/ GIMT_Encode4(724900), // Rule ID 11888 //
     /*  724830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  724833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  724847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  724876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  724879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724898 */     GIR_RootConstrainSelectedInstOperands,
     /*  724899 */     // GIR_Coverage, 11888,
     /*  724899 */     GIR_EraseRootFromParent_Done,
     /*  724900 */   // Label 11417: @724900
     /*  724900 */   GIM_Try, /*On fail goto*//*Label 11418*/ GIMT_Encode4(724975), // Rule ID 11889 //
     /*  724905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  724908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  724922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724951 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  724951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  724954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724973 */     GIR_RootConstrainSelectedInstOperands,
     /*  724974 */     // GIR_Coverage, 11889,
     /*  724974 */     GIR_EraseRootFromParent_Done,
     /*  724975 */   // Label 11418: @724975
     /*  724975 */   GIM_Try, /*On fail goto*//*Label 11419*/ GIMT_Encode4(725050), // Rule ID 11892 //
     /*  724980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  724991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  724994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  724997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  725000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  725029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725048 */     GIR_RootConstrainSelectedInstOperands,
     /*  725049 */     // GIR_Coverage, 11892,
     /*  725049 */     GIR_EraseRootFromParent_Done,
     /*  725050 */   // Label 11419: @725050
     /*  725050 */   GIM_Try, /*On fail goto*//*Label 11420*/ GIMT_Encode4(725125), // Rule ID 11893 //
     /*  725055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  725066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  725069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  725072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  725075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  725104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725123 */     GIR_RootConstrainSelectedInstOperands,
     /*  725124 */     // GIR_Coverage, 11893,
     /*  725124 */     GIR_EraseRootFromParent_Done,
     /*  725125 */   // Label 11420: @725125
     /*  725125 */   GIM_Try, /*On fail goto*//*Label 11421*/ GIMT_Encode4(725200), // Rule ID 11896 //
     /*  725130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  725141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  725144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  725147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  725150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725176 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  725179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725198 */     GIR_RootConstrainSelectedInstOperands,
     /*  725199 */     // GIR_Coverage, 11896,
     /*  725199 */     GIR_EraseRootFromParent_Done,
     /*  725200 */   // Label 11421: @725200
     /*  725200 */   GIM_Try, /*On fail goto*//*Label 11422*/ GIMT_Encode4(725275), // Rule ID 11897 //
     /*  725205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  725216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  725219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  725222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  725225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725251 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  725254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725273 */     GIR_RootConstrainSelectedInstOperands,
     /*  725274 */     // GIR_Coverage, 11897,
     /*  725274 */     GIR_EraseRootFromParent_Done,
     /*  725275 */   // Label 11422: @725275
     /*  725275 */   GIM_Try, /*On fail goto*//*Label 11423*/ GIMT_Encode4(725350), // Rule ID 11900 //
     /*  725280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  725291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  725294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  725297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  725300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  725329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725348 */     GIR_RootConstrainSelectedInstOperands,
     /*  725349 */     // GIR_Coverage, 11900,
     /*  725349 */     GIR_EraseRootFromParent_Done,
     /*  725350 */   // Label 11423: @725350
     /*  725350 */   GIM_Try, /*On fail goto*//*Label 11424*/ GIMT_Encode4(725425), // Rule ID 11901 //
     /*  725355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  725366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  725369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  725372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  725375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725401 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  725404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725423 */     GIR_RootConstrainSelectedInstOperands,
     /*  725424 */     // GIR_Coverage, 11901,
     /*  725424 */     GIR_EraseRootFromParent_Done,
     /*  725425 */   // Label 11424: @725425
     /*  725425 */   GIM_Try, /*On fail goto*//*Label 11425*/ GIMT_Encode4(725500), // Rule ID 11904 //
     /*  725430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  725441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  725444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  725447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  725450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  725479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725498 */     GIR_RootConstrainSelectedInstOperands,
     /*  725499 */     // GIR_Coverage, 11904,
     /*  725499 */     GIR_EraseRootFromParent_Done,
     /*  725500 */   // Label 11425: @725500
     /*  725500 */   GIM_Try, /*On fail goto*//*Label 11426*/ GIMT_Encode4(725575), // Rule ID 11905 //
     /*  725505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  725516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  725519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  725522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  725525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  725554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725573 */     GIR_RootConstrainSelectedInstOperands,
     /*  725574 */     // GIR_Coverage, 11905,
     /*  725574 */     GIR_EraseRootFromParent_Done,
     /*  725575 */   // Label 11426: @725575
     /*  725575 */   GIM_Try, /*On fail goto*//*Label 11427*/ GIMT_Encode4(725650), // Rule ID 11908 //
     /*  725580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  725591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  725594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  725597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  725600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  725629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725648 */     GIR_RootConstrainSelectedInstOperands,
     /*  725649 */     // GIR_Coverage, 11908,
     /*  725649 */     GIR_EraseRootFromParent_Done,
     /*  725650 */   // Label 11427: @725650
     /*  725650 */   GIM_Try, /*On fail goto*//*Label 11428*/ GIMT_Encode4(725725), // Rule ID 11909 //
     /*  725655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  725666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  725669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  725672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  725675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725701 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  725704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725723 */     GIR_RootConstrainSelectedInstOperands,
     /*  725724 */     // GIR_Coverage, 11909,
     /*  725724 */     GIR_EraseRootFromParent_Done,
     /*  725725 */   // Label 11428: @725725
     /*  725725 */   GIM_Try, /*On fail goto*//*Label 11429*/ GIMT_Encode4(725800), // Rule ID 11912 //
     /*  725730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  725741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  725744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  725747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  725750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  725779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725798 */     GIR_RootConstrainSelectedInstOperands,
     /*  725799 */     // GIR_Coverage, 11912,
     /*  725799 */     GIR_EraseRootFromParent_Done,
     /*  725800 */   // Label 11429: @725800
     /*  725800 */   GIM_Try, /*On fail goto*//*Label 11430*/ GIMT_Encode4(725875), // Rule ID 11913 //
     /*  725805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  725816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  725819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  725822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  725825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725851 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  725854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725873 */     GIR_RootConstrainSelectedInstOperands,
     /*  725874 */     // GIR_Coverage, 11913,
     /*  725874 */     GIR_EraseRootFromParent_Done,
     /*  725875 */   // Label 11430: @725875
     /*  725875 */   GIM_Try, /*On fail goto*//*Label 11431*/ GIMT_Encode4(725950), // Rule ID 11916 //
     /*  725880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  725891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  725894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  725897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  725900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  725929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725948 */     GIR_RootConstrainSelectedInstOperands,
     /*  725949 */     // GIR_Coverage, 11916,
     /*  725949 */     GIR_EraseRootFromParent_Done,
     /*  725950 */   // Label 11431: @725950
     /*  725950 */   GIM_Try, /*On fail goto*//*Label 11432*/ GIMT_Encode4(726025), // Rule ID 11917 //
     /*  725955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  725966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  725969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  725972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  725975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  726004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726023 */     GIR_RootConstrainSelectedInstOperands,
     /*  726024 */     // GIR_Coverage, 11917,
     /*  726024 */     GIR_EraseRootFromParent_Done,
     /*  726025 */   // Label 11432: @726025
     /*  726025 */   GIM_Try, /*On fail goto*//*Label 11433*/ GIMT_Encode4(726100), // Rule ID 11920 //
     /*  726030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  726041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  726044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  726047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  726050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  726076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  726079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726098 */     GIR_RootConstrainSelectedInstOperands,
     /*  726099 */     // GIR_Coverage, 11920,
     /*  726099 */     GIR_EraseRootFromParent_Done,
     /*  726100 */   // Label 11433: @726100
     /*  726100 */   GIM_Try, /*On fail goto*//*Label 11434*/ GIMT_Encode4(726175), // Rule ID 11921 //
     /*  726105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  726116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  726119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  726122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  726125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726151 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  726154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726173 */     GIR_RootConstrainSelectedInstOperands,
     /*  726174 */     // GIR_Coverage, 11921,
     /*  726174 */     GIR_EraseRootFromParent_Done,
     /*  726175 */   // Label 11434: @726175
     /*  726175 */   GIM_Try, /*On fail goto*//*Label 11435*/ GIMT_Encode4(726250), // Rule ID 11924 //
     /*  726180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  726191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  726194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  726197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  726200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726226 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  726226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  726229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726248 */     GIR_RootConstrainSelectedInstOperands,
     /*  726249 */     // GIR_Coverage, 11924,
     /*  726249 */     GIR_EraseRootFromParent_Done,
     /*  726250 */   // Label 11435: @726250
     /*  726250 */   GIM_Try, /*On fail goto*//*Label 11436*/ GIMT_Encode4(726325), // Rule ID 11925 //
     /*  726255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  726266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  726269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  726272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  726275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726301 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  726304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726323 */     GIR_RootConstrainSelectedInstOperands,
     /*  726324 */     // GIR_Coverage, 11925,
     /*  726324 */     GIR_EraseRootFromParent_Done,
     /*  726325 */   // Label 11436: @726325
     /*  726325 */   GIM_Try, /*On fail goto*//*Label 11437*/ GIMT_Encode4(726400), // Rule ID 11928 //
     /*  726330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  726341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  726344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  726347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  726350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  726379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726398 */     GIR_RootConstrainSelectedInstOperands,
     /*  726399 */     // GIR_Coverage, 11928,
     /*  726399 */     GIR_EraseRootFromParent_Done,
     /*  726400 */   // Label 11437: @726400
     /*  726400 */   GIM_Try, /*On fail goto*//*Label 11438*/ GIMT_Encode4(726475), // Rule ID 11929 //
     /*  726405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  726416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  726419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  726422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  726425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  726454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726473 */     GIR_RootConstrainSelectedInstOperands,
     /*  726474 */     // GIR_Coverage, 11929,
     /*  726474 */     GIR_EraseRootFromParent_Done,
     /*  726475 */   // Label 11438: @726475
     /*  726475 */   GIM_Try, /*On fail goto*//*Label 11439*/ GIMT_Encode4(726550), // Rule ID 11932 //
     /*  726480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  726491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  726494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  726497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  726500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726526 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  726529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726548 */     GIR_RootConstrainSelectedInstOperands,
     /*  726549 */     // GIR_Coverage, 11932,
     /*  726549 */     GIR_EraseRootFromParent_Done,
     /*  726550 */   // Label 11439: @726550
     /*  726550 */   GIM_Try, /*On fail goto*//*Label 11440*/ GIMT_Encode4(726625), // Rule ID 11933 //
     /*  726555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  726566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  726569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  726572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  726575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726601 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  726604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726623 */     GIR_RootConstrainSelectedInstOperands,
     /*  726624 */     // GIR_Coverage, 11933,
     /*  726624 */     GIR_EraseRootFromParent_Done,
     /*  726625 */   // Label 11440: @726625
     /*  726625 */   GIM_Try, /*On fail goto*//*Label 11441*/ GIMT_Encode4(726700), // Rule ID 11936 //
     /*  726630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  726641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  726644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  726647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  726650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  726679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726698 */     GIR_RootConstrainSelectedInstOperands,
     /*  726699 */     // GIR_Coverage, 11936,
     /*  726699 */     GIR_EraseRootFromParent_Done,
     /*  726700 */   // Label 11441: @726700
     /*  726700 */   GIM_Try, /*On fail goto*//*Label 11442*/ GIMT_Encode4(726775), // Rule ID 11937 //
     /*  726705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  726716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  726719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  726722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  726725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726751 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  726754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726773 */     GIR_RootConstrainSelectedInstOperands,
     /*  726774 */     // GIR_Coverage, 11937,
     /*  726774 */     GIR_EraseRootFromParent_Done,
     /*  726775 */   // Label 11442: @726775
     /*  726775 */   GIM_Try, /*On fail goto*//*Label 11443*/ GIMT_Encode4(726850), // Rule ID 11940 //
     /*  726780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  726791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  726794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  726797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726826 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  726829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726848 */     GIR_RootConstrainSelectedInstOperands,
     /*  726849 */     // GIR_Coverage, 11940,
     /*  726849 */     GIR_EraseRootFromParent_Done,
     /*  726850 */   // Label 11443: @726850
     /*  726850 */   GIM_Try, /*On fail goto*//*Label 11444*/ GIMT_Encode4(726925), // Rule ID 11941 //
     /*  726855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  726866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  726869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  726872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726901 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  726904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726923 */     GIR_RootConstrainSelectedInstOperands,
     /*  726924 */     // GIR_Coverage, 11941,
     /*  726924 */     GIR_EraseRootFromParent_Done,
     /*  726925 */   // Label 11444: @726925
     /*  726925 */   GIM_Try, /*On fail goto*//*Label 11445*/ GIMT_Encode4(727000), // Rule ID 11944 //
     /*  726930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  726941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  726944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  726947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  726979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726998 */     GIR_RootConstrainSelectedInstOperands,
     /*  726999 */     // GIR_Coverage, 11944,
     /*  726999 */     GIR_EraseRootFromParent_Done,
     /*  727000 */   // Label 11445: @727000
     /*  727000 */   GIM_Try, /*On fail goto*//*Label 11446*/ GIMT_Encode4(727075), // Rule ID 11945 //
     /*  727005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  727016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  727019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  727022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727051 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  727054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727073 */     GIR_RootConstrainSelectedInstOperands,
     /*  727074 */     // GIR_Coverage, 11945,
     /*  727074 */     GIR_EraseRootFromParent_Done,
     /*  727075 */   // Label 11446: @727075
     /*  727075 */   GIM_Try, /*On fail goto*//*Label 11447*/ GIMT_Encode4(727150), // Rule ID 11948 //
     /*  727080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  727091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  727094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  727097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727126 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  727129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727148 */     GIR_RootConstrainSelectedInstOperands,
     /*  727149 */     // GIR_Coverage, 11948,
     /*  727149 */     GIR_EraseRootFromParent_Done,
     /*  727150 */   // Label 11447: @727150
     /*  727150 */   GIM_Try, /*On fail goto*//*Label 11448*/ GIMT_Encode4(727225), // Rule ID 11949 //
     /*  727155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  727166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  727169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  727172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727201 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  727204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727223 */     GIR_RootConstrainSelectedInstOperands,
     /*  727224 */     // GIR_Coverage, 11949,
     /*  727224 */     GIR_EraseRootFromParent_Done,
     /*  727225 */   // Label 11448: @727225
     /*  727225 */   GIM_Try, /*On fail goto*//*Label 11449*/ GIMT_Encode4(727300), // Rule ID 11952 //
     /*  727230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  727241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  727244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  727247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  727279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727298 */     GIR_RootConstrainSelectedInstOperands,
     /*  727299 */     // GIR_Coverage, 11952,
     /*  727299 */     GIR_EraseRootFromParent_Done,
     /*  727300 */   // Label 11449: @727300
     /*  727300 */   GIM_Try, /*On fail goto*//*Label 11450*/ GIMT_Encode4(727375), // Rule ID 11953 //
     /*  727305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  727316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  727319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  727322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727351 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  727354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727373 */     GIR_RootConstrainSelectedInstOperands,
     /*  727374 */     // GIR_Coverage, 11953,
     /*  727374 */     GIR_EraseRootFromParent_Done,
     /*  727375 */   // Label 11450: @727375
     /*  727375 */   GIM_Try, /*On fail goto*//*Label 11451*/ GIMT_Encode4(727450), // Rule ID 11956 //
     /*  727380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  727391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  727394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  727397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727426 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  727429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727448 */     GIR_RootConstrainSelectedInstOperands,
     /*  727449 */     // GIR_Coverage, 11956,
     /*  727449 */     GIR_EraseRootFromParent_Done,
     /*  727450 */   // Label 11451: @727450
     /*  727450 */   GIM_Try, /*On fail goto*//*Label 11452*/ GIMT_Encode4(727525), // Rule ID 11957 //
     /*  727455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  727466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  727469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  727472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727501 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  727504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727523 */     GIR_RootConstrainSelectedInstOperands,
     /*  727524 */     // GIR_Coverage, 11957,
     /*  727524 */     GIR_EraseRootFromParent_Done,
     /*  727525 */   // Label 11452: @727525
     /*  727525 */   GIM_Try, /*On fail goto*//*Label 11453*/ GIMT_Encode4(727600), // Rule ID 11960 //
     /*  727530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  727541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  727544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  727547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727576 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  727576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  727579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727598 */     GIR_RootConstrainSelectedInstOperands,
     /*  727599 */     // GIR_Coverage, 11960,
     /*  727599 */     GIR_EraseRootFromParent_Done,
     /*  727600 */   // Label 11453: @727600
     /*  727600 */   GIM_Try, /*On fail goto*//*Label 11454*/ GIMT_Encode4(727675), // Rule ID 11961 //
     /*  727605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  727616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  727619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  727622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727651 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  727651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  727654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727673 */     GIR_RootConstrainSelectedInstOperands,
     /*  727674 */     // GIR_Coverage, 11961,
     /*  727674 */     GIR_EraseRootFromParent_Done,
     /*  727675 */   // Label 11454: @727675
     /*  727675 */   GIM_Try, /*On fail goto*//*Label 11455*/ GIMT_Encode4(727750), // Rule ID 11964 //
     /*  727680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  727691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  727694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  727697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  727729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727748 */     GIR_RootConstrainSelectedInstOperands,
     /*  727749 */     // GIR_Coverage, 11964,
     /*  727749 */     GIR_EraseRootFromParent_Done,
     /*  727750 */   // Label 11455: @727750
     /*  727750 */   GIM_Try, /*On fail goto*//*Label 11456*/ GIMT_Encode4(727825), // Rule ID 11965 //
     /*  727755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  727766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  727769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  727772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727801 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  727804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727823 */     GIR_RootConstrainSelectedInstOperands,
     /*  727824 */     // GIR_Coverage, 11965,
     /*  727824 */     GIR_EraseRootFromParent_Done,
     /*  727825 */   // Label 11456: @727825
     /*  727825 */   GIM_Try, /*On fail goto*//*Label 11457*/ GIMT_Encode4(727900), // Rule ID 11968 //
     /*  727830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  727847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  727879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727898 */     GIR_RootConstrainSelectedInstOperands,
     /*  727899 */     // GIR_Coverage, 11968,
     /*  727899 */     GIR_EraseRootFromParent_Done,
     /*  727900 */   // Label 11457: @727900
     /*  727900 */   GIM_Try, /*On fail goto*//*Label 11458*/ GIMT_Encode4(727975), // Rule ID 11969 //
     /*  727905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  727922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727951 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  727954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727973 */     GIR_RootConstrainSelectedInstOperands,
     /*  727974 */     // GIR_Coverage, 11969,
     /*  727974 */     GIR_EraseRootFromParent_Done,
     /*  727975 */   // Label 11458: @727975
     /*  727975 */   GIM_Try, /*On fail goto*//*Label 11459*/ GIMT_Encode4(728050), // Rule ID 11972 //
     /*  727980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  727997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  728026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  728029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728048 */     GIR_RootConstrainSelectedInstOperands,
     /*  728049 */     // GIR_Coverage, 11972,
     /*  728049 */     GIR_EraseRootFromParent_Done,
     /*  728050 */   // Label 11459: @728050
     /*  728050 */   GIM_Try, /*On fail goto*//*Label 11460*/ GIMT_Encode4(728125), // Rule ID 11973 //
     /*  728055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  728066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  728069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  728072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728101 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  728101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  728104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728123 */     GIR_RootConstrainSelectedInstOperands,
     /*  728124 */     // GIR_Coverage, 11973,
     /*  728124 */     GIR_EraseRootFromParent_Done,
     /*  728125 */   // Label 11460: @728125
     /*  728125 */   GIM_Try, /*On fail goto*//*Label 11461*/ GIMT_Encode4(728200), // Rule ID 11976 //
     /*  728130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  728133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  728141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  728144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  728147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728176 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  728176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  728179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728198 */     GIR_RootConstrainSelectedInstOperands,
     /*  728199 */     // GIR_Coverage, 11976,
     /*  728199 */     GIR_EraseRootFromParent_Done,
     /*  728200 */   // Label 11461: @728200
     /*  728200 */   GIM_Try, /*On fail goto*//*Label 11462*/ GIMT_Encode4(728275), // Rule ID 11977 //
     /*  728205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  728208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  728216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  728219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  728222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728251 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  728251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  728254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728273 */     GIR_RootConstrainSelectedInstOperands,
     /*  728274 */     // GIR_Coverage, 11977,
     /*  728274 */     GIR_EraseRootFromParent_Done,
     /*  728275 */   // Label 11462: @728275
     /*  728275 */   GIM_Try, /*On fail goto*//*Label 11463*/ GIMT_Encode4(728350), // Rule ID 11980 //
     /*  728280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  728291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  728294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  728297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  728329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728348 */     GIR_RootConstrainSelectedInstOperands,
     /*  728349 */     // GIR_Coverage, 11980,
     /*  728349 */     GIR_EraseRootFromParent_Done,
     /*  728350 */   // Label 11463: @728350
     /*  728350 */   GIM_Try, /*On fail goto*//*Label 11464*/ GIMT_Encode4(728425), // Rule ID 11981 //
     /*  728355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  728366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  728369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  728372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728401 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  728404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728423 */     GIR_RootConstrainSelectedInstOperands,
     /*  728424 */     // GIR_Coverage, 11981,
     /*  728424 */     GIR_EraseRootFromParent_Done,
     /*  728425 */   // Label 11464: @728425
     /*  728425 */   GIM_Try, /*On fail goto*//*Label 11465*/ GIMT_Encode4(728500), // Rule ID 11984 //
     /*  728430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  728441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  728444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  728447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728476 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  728479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728498 */     GIR_RootConstrainSelectedInstOperands,
     /*  728499 */     // GIR_Coverage, 11984,
     /*  728499 */     GIR_EraseRootFromParent_Done,
     /*  728500 */   // Label 11465: @728500
     /*  728500 */   GIM_Try, /*On fail goto*//*Label 11466*/ GIMT_Encode4(728575), // Rule ID 11985 //
     /*  728505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  728516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  728519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  728522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728551 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  728554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728573 */     GIR_RootConstrainSelectedInstOperands,
     /*  728574 */     // GIR_Coverage, 11985,
     /*  728574 */     GIR_EraseRootFromParent_Done,
     /*  728575 */   // Label 11466: @728575
     /*  728575 */   GIM_Try, /*On fail goto*//*Label 11467*/ GIMT_Encode4(728650), // Rule ID 11988 //
     /*  728580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  728591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  728594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  728597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728626 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  728629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728648 */     GIR_RootConstrainSelectedInstOperands,
     /*  728649 */     // GIR_Coverage, 11988,
     /*  728649 */     GIR_EraseRootFromParent_Done,
     /*  728650 */   // Label 11467: @728650
     /*  728650 */   GIM_Try, /*On fail goto*//*Label 11468*/ GIMT_Encode4(728725), // Rule ID 11989 //
     /*  728655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  728666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  728669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  728672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728701 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  728704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728723 */     GIR_RootConstrainSelectedInstOperands,
     /*  728724 */     // GIR_Coverage, 11989,
     /*  728724 */     GIR_EraseRootFromParent_Done,
     /*  728725 */   // Label 11468: @728725
     /*  728725 */   GIM_Try, /*On fail goto*//*Label 11469*/ GIMT_Encode4(728800), // Rule ID 11992 //
     /*  728730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  728741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  728744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  728747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  728779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728798 */     GIR_RootConstrainSelectedInstOperands,
     /*  728799 */     // GIR_Coverage, 11992,
     /*  728799 */     GIR_EraseRootFromParent_Done,
     /*  728800 */   // Label 11469: @728800
     /*  728800 */   GIM_Try, /*On fail goto*//*Label 11470*/ GIMT_Encode4(728875), // Rule ID 11993 //
     /*  728805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  728816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  728819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  728822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  728854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728873 */     GIR_RootConstrainSelectedInstOperands,
     /*  728874 */     // GIR_Coverage, 11993,
     /*  728874 */     GIR_EraseRootFromParent_Done,
     /*  728875 */   // Label 11470: @728875
     /*  728875 */   GIM_Try, /*On fail goto*//*Label 11471*/ GIMT_Encode4(728950), // Rule ID 11996 //
     /*  728880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  728891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  728894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  728897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  728929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728948 */     GIR_RootConstrainSelectedInstOperands,
     /*  728949 */     // GIR_Coverage, 11996,
     /*  728949 */     GIR_EraseRootFromParent_Done,
     /*  728950 */   // Label 11471: @728950
     /*  728950 */   GIM_Try, /*On fail goto*//*Label 11472*/ GIMT_Encode4(729025), // Rule ID 11997 //
     /*  728955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  728966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  728969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  728972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729001 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  729001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  729004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729023 */     GIR_RootConstrainSelectedInstOperands,
     /*  729024 */     // GIR_Coverage, 11997,
     /*  729024 */     GIR_EraseRootFromParent_Done,
     /*  729025 */   // Label 11472: @729025
     /*  729025 */   GIM_Try, /*On fail goto*//*Label 11473*/ GIMT_Encode4(729100), // Rule ID 12000 //
     /*  729030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  729041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  729044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  729047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729076 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  729076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  729079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729098 */     GIR_RootConstrainSelectedInstOperands,
     /*  729099 */     // GIR_Coverage, 12000,
     /*  729099 */     GIR_EraseRootFromParent_Done,
     /*  729100 */   // Label 11473: @729100
     /*  729100 */   GIM_Try, /*On fail goto*//*Label 11474*/ GIMT_Encode4(729175), // Rule ID 12001 //
     /*  729105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  729116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  729119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  729122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729151 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  729151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  729154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729173 */     GIR_RootConstrainSelectedInstOperands,
     /*  729174 */     // GIR_Coverage, 12001,
     /*  729174 */     GIR_EraseRootFromParent_Done,
     /*  729175 */   // Label 11474: @729175
     /*  729175 */   GIM_Try, /*On fail goto*//*Label 11475*/ GIMT_Encode4(729250), // Rule ID 12004 //
     /*  729180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  729191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  729194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  729197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  729229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729248 */     GIR_RootConstrainSelectedInstOperands,
     /*  729249 */     // GIR_Coverage, 12004,
     /*  729249 */     GIR_EraseRootFromParent_Done,
     /*  729250 */   // Label 11475: @729250
     /*  729250 */   GIM_Try, /*On fail goto*//*Label 11476*/ GIMT_Encode4(729325), // Rule ID 12005 //
     /*  729255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  729266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  729269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  729272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729301 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  729304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729323 */     GIR_RootConstrainSelectedInstOperands,
     /*  729324 */     // GIR_Coverage, 12005,
     /*  729324 */     GIR_EraseRootFromParent_Done,
     /*  729325 */   // Label 11476: @729325
     /*  729325 */   GIM_Try, /*On fail goto*//*Label 11477*/ GIMT_Encode4(729400), // Rule ID 12008 //
     /*  729330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  729341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  729344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  729347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729376 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  729379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729398 */     GIR_RootConstrainSelectedInstOperands,
     /*  729399 */     // GIR_Coverage, 12008,
     /*  729399 */     GIR_EraseRootFromParent_Done,
     /*  729400 */   // Label 11477: @729400
     /*  729400 */   GIM_Try, /*On fail goto*//*Label 11478*/ GIMT_Encode4(729475), // Rule ID 12009 //
     /*  729405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  729416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  729419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  729422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729451 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  729454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729473 */     GIR_RootConstrainSelectedInstOperands,
     /*  729474 */     // GIR_Coverage, 12009,
     /*  729474 */     GIR_EraseRootFromParent_Done,
     /*  729475 */   // Label 11478: @729475
     /*  729475 */   GIM_Try, /*On fail goto*//*Label 11479*/ GIMT_Encode4(729550), // Rule ID 12012 //
     /*  729480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  729491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  729494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  729497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729526 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  729529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729548 */     GIR_RootConstrainSelectedInstOperands,
     /*  729549 */     // GIR_Coverage, 12012,
     /*  729549 */     GIR_EraseRootFromParent_Done,
     /*  729550 */   // Label 11479: @729550
     /*  729550 */   GIM_Try, /*On fail goto*//*Label 11480*/ GIMT_Encode4(729625), // Rule ID 12013 //
     /*  729555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  729566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  729569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  729572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729601 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  729604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729623 */     GIR_RootConstrainSelectedInstOperands,
     /*  729624 */     // GIR_Coverage, 12013,
     /*  729624 */     GIR_EraseRootFromParent_Done,
     /*  729625 */   // Label 11480: @729625
     /*  729625 */   GIM_Try, /*On fail goto*//*Label 11481*/ GIMT_Encode4(729700), // Rule ID 12016 //
     /*  729630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  729641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  729644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  729647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  729679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729698 */     GIR_RootConstrainSelectedInstOperands,
     /*  729699 */     // GIR_Coverage, 12016,
     /*  729699 */     GIR_EraseRootFromParent_Done,
     /*  729700 */   // Label 11481: @729700
     /*  729700 */   GIM_Try, /*On fail goto*//*Label 11482*/ GIMT_Encode4(729775), // Rule ID 12017 //
     /*  729705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  729716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  729719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  729722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729751 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  729754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729773 */     GIR_RootConstrainSelectedInstOperands,
     /*  729774 */     // GIR_Coverage, 12017,
     /*  729774 */     GIR_EraseRootFromParent_Done,
     /*  729775 */   // Label 11482: @729775
     /*  729775 */   GIM_Try, /*On fail goto*//*Label 11483*/ GIMT_Encode4(729850), // Rule ID 12020 //
     /*  729780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  729791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  729794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  729797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729826 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  729829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729848 */     GIR_RootConstrainSelectedInstOperands,
     /*  729849 */     // GIR_Coverage, 12020,
     /*  729849 */     GIR_EraseRootFromParent_Done,
     /*  729850 */   // Label 11483: @729850
     /*  729850 */   GIM_Try, /*On fail goto*//*Label 11484*/ GIMT_Encode4(729925), // Rule ID 12021 //
     /*  729855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  729866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  729869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  729872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729901 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  729904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729923 */     GIR_RootConstrainSelectedInstOperands,
     /*  729924 */     // GIR_Coverage, 12021,
     /*  729924 */     GIR_EraseRootFromParent_Done,
     /*  729925 */   // Label 11484: @729925
     /*  729925 */   GIM_Try, /*On fail goto*//*Label 11485*/ GIMT_Encode4(730000), // Rule ID 12024 //
     /*  729930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  729941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  729944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  729947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729976 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  729979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729998 */     GIR_RootConstrainSelectedInstOperands,
     /*  729999 */     // GIR_Coverage, 12024,
     /*  729999 */     GIR_EraseRootFromParent_Done,
     /*  730000 */   // Label 11485: @730000
     /*  730000 */   GIM_Try, /*On fail goto*//*Label 11486*/ GIMT_Encode4(730075), // Rule ID 12025 //
     /*  730005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  730008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  730016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  730019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  730022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730051 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  730051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  730054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  730070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730073 */     GIR_RootConstrainSelectedInstOperands,
     /*  730074 */     // GIR_Coverage, 12025,
     /*  730074 */     GIR_EraseRootFromParent_Done,
     /*  730075 */   // Label 11486: @730075
     /*  730075 */   GIM_Try, /*On fail goto*//*Label 11487*/ GIMT_Encode4(730150), // Rule ID 12028 //
     /*  730080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  730091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  730094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  730097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  730100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730126 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  730129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730148 */     GIR_RootConstrainSelectedInstOperands,
     /*  730149 */     // GIR_Coverage, 12028,
     /*  730149 */     GIR_EraseRootFromParent_Done,
     /*  730150 */   // Label 11487: @730150
     /*  730150 */   GIM_Try, /*On fail goto*//*Label 11488*/ GIMT_Encode4(730225), // Rule ID 12029 //
     /*  730155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  730166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  730169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  730172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  730175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730201 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  730204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730223 */     GIR_RootConstrainSelectedInstOperands,
     /*  730224 */     // GIR_Coverage, 12029,
     /*  730224 */     GIR_EraseRootFromParent_Done,
     /*  730225 */   // Label 11488: @730225
     /*  730225 */   GIM_Try, /*On fail goto*//*Label 11489*/ GIMT_Encode4(730300), // Rule ID 12032 //
     /*  730230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  730241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  730244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  730247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  730250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730276 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  730279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730298 */     GIR_RootConstrainSelectedInstOperands,
     /*  730299 */     // GIR_Coverage, 12032,
     /*  730299 */     GIR_EraseRootFromParent_Done,
     /*  730300 */   // Label 11489: @730300
     /*  730300 */   GIM_Try, /*On fail goto*//*Label 11490*/ GIMT_Encode4(730375), // Rule ID 12033 //
     /*  730305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  730316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  730319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  730322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  730325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730351 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  730354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730373 */     GIR_RootConstrainSelectedInstOperands,
     /*  730374 */     // GIR_Coverage, 12033,
     /*  730374 */     GIR_EraseRootFromParent_Done,
     /*  730375 */   // Label 11490: @730375
     /*  730375 */   GIM_Try, /*On fail goto*//*Label 11491*/ GIMT_Encode4(730450), // Rule ID 12036 //
     /*  730380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  730391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  730394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  730397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  730400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730426 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  730429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730448 */     GIR_RootConstrainSelectedInstOperands,
     /*  730449 */     // GIR_Coverage, 12036,
     /*  730449 */     GIR_EraseRootFromParent_Done,
     /*  730450 */   // Label 11491: @730450
     /*  730450 */   GIM_Try, /*On fail goto*//*Label 11492*/ GIMT_Encode4(730525), // Rule ID 12037 //
     /*  730455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  730466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  730469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  730472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  730475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730501 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  730504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730523 */     GIR_RootConstrainSelectedInstOperands,
     /*  730524 */     // GIR_Coverage, 12037,
     /*  730524 */     GIR_EraseRootFromParent_Done,
     /*  730525 */   // Label 11492: @730525
     /*  730525 */   GIM_Try, /*On fail goto*//*Label 11493*/ GIMT_Encode4(730600), // Rule ID 12040 //
     /*  730530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  730541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  730544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  730547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  730550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730576 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  730579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730598 */     GIR_RootConstrainSelectedInstOperands,
     /*  730599 */     // GIR_Coverage, 12040,
     /*  730599 */     GIR_EraseRootFromParent_Done,
     /*  730600 */   // Label 11493: @730600
     /*  730600 */   GIM_Try, /*On fail goto*//*Label 11494*/ GIMT_Encode4(730675), // Rule ID 12041 //
     /*  730605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  730616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  730619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  730622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  730625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730651 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  730654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730673 */     GIR_RootConstrainSelectedInstOperands,
     /*  730674 */     // GIR_Coverage, 12041,
     /*  730674 */     GIR_EraseRootFromParent_Done,
     /*  730675 */   // Label 11494: @730675
     /*  730675 */   GIM_Try, /*On fail goto*//*Label 11495*/ GIMT_Encode4(730750), // Rule ID 12044 //
     /*  730680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  730691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  730694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  730697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  730700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  730729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730748 */     GIR_RootConstrainSelectedInstOperands,
     /*  730749 */     // GIR_Coverage, 12044,
     /*  730749 */     GIR_EraseRootFromParent_Done,
     /*  730750 */   // Label 11495: @730750
     /*  730750 */   GIM_Try, /*On fail goto*//*Label 11496*/ GIMT_Encode4(730825), // Rule ID 12045 //
     /*  730755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  730766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  730769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  730772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  730775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730801 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  730804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730823 */     GIR_RootConstrainSelectedInstOperands,
     /*  730824 */     // GIR_Coverage, 12045,
     /*  730824 */     GIR_EraseRootFromParent_Done,
     /*  730825 */   // Label 11496: @730825
     /*  730825 */   GIM_Try, /*On fail goto*//*Label 11497*/ GIMT_Encode4(730900), // Rule ID 12048 //
     /*  730830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  730841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  730844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  730847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  730850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730876 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  730876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  730879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730898 */     GIR_RootConstrainSelectedInstOperands,
     /*  730899 */     // GIR_Coverage, 12048,
     /*  730899 */     GIR_EraseRootFromParent_Done,
     /*  730900 */   // Label 11497: @730900
     /*  730900 */   GIM_Try, /*On fail goto*//*Label 11498*/ GIMT_Encode4(730975), // Rule ID 12049 //
     /*  730905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  730916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  730919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  730922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  730925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730951 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  730951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  730954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730973 */     GIR_RootConstrainSelectedInstOperands,
     /*  730974 */     // GIR_Coverage, 12049,
     /*  730974 */     GIR_EraseRootFromParent_Done,
     /*  730975 */   // Label 11498: @730975
     /*  730975 */   GIM_Try, /*On fail goto*//*Label 11499*/ GIMT_Encode4(731050), // Rule ID 12052 //
     /*  730980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  730991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  730994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  730997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  731000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731026 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  731029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731048 */     GIR_RootConstrainSelectedInstOperands,
     /*  731049 */     // GIR_Coverage, 12052,
     /*  731049 */     GIR_EraseRootFromParent_Done,
     /*  731050 */   // Label 11499: @731050
     /*  731050 */   GIM_Try, /*On fail goto*//*Label 11500*/ GIMT_Encode4(731125), // Rule ID 12053 //
     /*  731055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  731066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  731069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  731072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  731075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731101 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  731104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731123 */     GIR_RootConstrainSelectedInstOperands,
     /*  731124 */     // GIR_Coverage, 12053,
     /*  731124 */     GIR_EraseRootFromParent_Done,
     /*  731125 */   // Label 11500: @731125
     /*  731125 */   GIM_Try, /*On fail goto*//*Label 11501*/ GIMT_Encode4(731200), // Rule ID 12056 //
     /*  731130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  731141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  731144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  731147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  731150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  731179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731198 */     GIR_RootConstrainSelectedInstOperands,
     /*  731199 */     // GIR_Coverage, 12056,
     /*  731199 */     GIR_EraseRootFromParent_Done,
     /*  731200 */   // Label 11501: @731200
     /*  731200 */   GIM_Try, /*On fail goto*//*Label 11502*/ GIMT_Encode4(731275), // Rule ID 12057 //
     /*  731205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  731216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  731219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  731222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  731225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731251 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  731254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731273 */     GIR_RootConstrainSelectedInstOperands,
     /*  731274 */     // GIR_Coverage, 12057,
     /*  731274 */     GIR_EraseRootFromParent_Done,
     /*  731275 */   // Label 11502: @731275
     /*  731275 */   GIM_Try, /*On fail goto*//*Label 11503*/ GIMT_Encode4(731350), // Rule ID 12060 //
     /*  731280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  731291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  731294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  731297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  731300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  731326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  731329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731348 */     GIR_RootConstrainSelectedInstOperands,
     /*  731349 */     // GIR_Coverage, 12060,
     /*  731349 */     GIR_EraseRootFromParent_Done,
     /*  731350 */   // Label 11503: @731350
     /*  731350 */   GIM_Try, /*On fail goto*//*Label 11504*/ GIMT_Encode4(731425), // Rule ID 12061 //
     /*  731355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  731366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  731369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  731372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  731375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731401 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  731401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  731404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731423 */     GIR_RootConstrainSelectedInstOperands,
     /*  731424 */     // GIR_Coverage, 12061,
     /*  731424 */     GIR_EraseRootFromParent_Done,
     /*  731425 */   // Label 11504: @731425
     /*  731425 */   GIM_Try, /*On fail goto*//*Label 11505*/ GIMT_Encode4(731500), // Rule ID 12064 //
     /*  731430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  731433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  731447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  731450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  731476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  731479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731498 */     GIR_RootConstrainSelectedInstOperands,
     /*  731499 */     // GIR_Coverage, 12064,
     /*  731499 */     GIR_EraseRootFromParent_Done,
     /*  731500 */   // Label 11505: @731500
     /*  731500 */   GIM_Try, /*On fail goto*//*Label 11506*/ GIMT_Encode4(731575), // Rule ID 12065 //
     /*  731505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  731508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  731522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  731525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731551 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  731551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  731554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731573 */     GIR_RootConstrainSelectedInstOperands,
     /*  731574 */     // GIR_Coverage, 12065,
     /*  731574 */     GIR_EraseRootFromParent_Done,
     /*  731575 */   // Label 11506: @731575
     /*  731575 */   GIM_Try, /*On fail goto*//*Label 11507*/ GIMT_Encode4(731650), // Rule ID 12068 //
     /*  731580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  731591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  731594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  731597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  731600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731626 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  731629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731648 */     GIR_RootConstrainSelectedInstOperands,
     /*  731649 */     // GIR_Coverage, 12068,
     /*  731649 */     GIR_EraseRootFromParent_Done,
     /*  731650 */   // Label 11507: @731650
     /*  731650 */   GIM_Try, /*On fail goto*//*Label 11508*/ GIMT_Encode4(731725), // Rule ID 12069 //
     /*  731655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  731666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  731669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  731672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  731675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731701 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  731704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731723 */     GIR_RootConstrainSelectedInstOperands,
     /*  731724 */     // GIR_Coverage, 12069,
     /*  731724 */     GIR_EraseRootFromParent_Done,
     /*  731725 */   // Label 11508: @731725
     /*  731725 */   GIM_Try, /*On fail goto*//*Label 11509*/ GIMT_Encode4(731800), // Rule ID 12072 //
     /*  731730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  731741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  731744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  731747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  731750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731776 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  731779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731798 */     GIR_RootConstrainSelectedInstOperands,
     /*  731799 */     // GIR_Coverage, 12072,
     /*  731799 */     GIR_EraseRootFromParent_Done,
     /*  731800 */   // Label 11509: @731800
     /*  731800 */   GIM_Try, /*On fail goto*//*Label 11510*/ GIMT_Encode4(731875), // Rule ID 12073 //
     /*  731805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  731816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  731819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  731822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  731825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731851 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  731854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731873 */     GIR_RootConstrainSelectedInstOperands,
     /*  731874 */     // GIR_Coverage, 12073,
     /*  731874 */     GIR_EraseRootFromParent_Done,
     /*  731875 */   // Label 11510: @731875
     /*  731875 */   GIM_Try, /*On fail goto*//*Label 11511*/ GIMT_Encode4(731950), // Rule ID 12076 //
     /*  731880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  731891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  731894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  731897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  731900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731926 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  731929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731948 */     GIR_RootConstrainSelectedInstOperands,
     /*  731949 */     // GIR_Coverage, 12076,
     /*  731949 */     GIR_EraseRootFromParent_Done,
     /*  731950 */   // Label 11511: @731950
     /*  731950 */   GIM_Try, /*On fail goto*//*Label 11512*/ GIMT_Encode4(732025), // Rule ID 12077 //
     /*  731955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  731966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  731969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  731972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  731975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732001 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  732001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  732004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732023 */     GIR_RootConstrainSelectedInstOperands,
     /*  732024 */     // GIR_Coverage, 12077,
     /*  732024 */     GIR_EraseRootFromParent_Done,
     /*  732025 */   // Label 11512: @732025
     /*  732025 */   GIM_Try, /*On fail goto*//*Label 11513*/ GIMT_Encode4(732100), // Rule ID 12080 //
     /*  732030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  732041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  732044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  732047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  732050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732076 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  732079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732098 */     GIR_RootConstrainSelectedInstOperands,
     /*  732099 */     // GIR_Coverage, 12080,
     /*  732099 */     GIR_EraseRootFromParent_Done,
     /*  732100 */   // Label 11513: @732100
     /*  732100 */   GIM_Try, /*On fail goto*//*Label 11514*/ GIMT_Encode4(732175), // Rule ID 12081 //
     /*  732105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  732116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  732119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  732122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  732125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732151 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  732154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732173 */     GIR_RootConstrainSelectedInstOperands,
     /*  732174 */     // GIR_Coverage, 12081,
     /*  732174 */     GIR_EraseRootFromParent_Done,
     /*  732175 */   // Label 11514: @732175
     /*  732175 */   GIM_Try, /*On fail goto*//*Label 11515*/ GIMT_Encode4(732250), // Rule ID 12084 //
     /*  732180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  732191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  732194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  732197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  732200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732226 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  732229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732248 */     GIR_RootConstrainSelectedInstOperands,
     /*  732249 */     // GIR_Coverage, 12084,
     /*  732249 */     GIR_EraseRootFromParent_Done,
     /*  732250 */   // Label 11515: @732250
     /*  732250 */   GIM_Try, /*On fail goto*//*Label 11516*/ GIMT_Encode4(732325), // Rule ID 12085 //
     /*  732255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  732266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  732269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  732272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  732275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732301 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  732304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732323 */     GIR_RootConstrainSelectedInstOperands,
     /*  732324 */     // GIR_Coverage, 12085,
     /*  732324 */     GIR_EraseRootFromParent_Done,
     /*  732325 */   // Label 11516: @732325
     /*  732325 */   GIM_Try, /*On fail goto*//*Label 11517*/ GIMT_Encode4(732400), // Rule ID 12088 //
     /*  732330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  732341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  732344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  732347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  732350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732376 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  732379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732398 */     GIR_RootConstrainSelectedInstOperands,
     /*  732399 */     // GIR_Coverage, 12088,
     /*  732399 */     GIR_EraseRootFromParent_Done,
     /*  732400 */   // Label 11517: @732400
     /*  732400 */   GIM_Try, /*On fail goto*//*Label 11518*/ GIMT_Encode4(732475), // Rule ID 12089 //
     /*  732405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  732416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  732419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  732422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  732425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732451 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  732454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732473 */     GIR_RootConstrainSelectedInstOperands,
     /*  732474 */     // GIR_Coverage, 12089,
     /*  732474 */     GIR_EraseRootFromParent_Done,
     /*  732475 */   // Label 11518: @732475
     /*  732475 */   GIM_Try, /*On fail goto*//*Label 11519*/ GIMT_Encode4(732550), // Rule ID 12092 //
     /*  732480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  732491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  732494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  732497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  732500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  732529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732548 */     GIR_RootConstrainSelectedInstOperands,
     /*  732549 */     // GIR_Coverage, 12092,
     /*  732549 */     GIR_EraseRootFromParent_Done,
     /*  732550 */   // Label 11519: @732550
     /*  732550 */   GIM_Try, /*On fail goto*//*Label 11520*/ GIMT_Encode4(732625), // Rule ID 12093 //
     /*  732555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  732566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  732569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  732572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  732575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  732604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732623 */     GIR_RootConstrainSelectedInstOperands,
     /*  732624 */     // GIR_Coverage, 12093,
     /*  732624 */     GIR_EraseRootFromParent_Done,
     /*  732625 */   // Label 11520: @732625
     /*  732625 */   GIM_Try, /*On fail goto*//*Label 11521*/ GIMT_Encode4(732700), // Rule ID 12096 //
     /*  732630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  732641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  732644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  732647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  732650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732676 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  732679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732698 */     GIR_RootConstrainSelectedInstOperands,
     /*  732699 */     // GIR_Coverage, 12096,
     /*  732699 */     GIR_EraseRootFromParent_Done,
     /*  732700 */   // Label 11521: @732700
     /*  732700 */   GIM_Try, /*On fail goto*//*Label 11522*/ GIMT_Encode4(732775), // Rule ID 12097 //
     /*  732705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  732716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  732719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  732722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  732725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732751 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  732754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732773 */     GIR_RootConstrainSelectedInstOperands,
     /*  732774 */     // GIR_Coverage, 12097,
     /*  732774 */     GIR_EraseRootFromParent_Done,
     /*  732775 */   // Label 11522: @732775
     /*  732775 */   GIM_Try, /*On fail goto*//*Label 11523*/ GIMT_Encode4(732850), // Rule ID 12100 //
     /*  732780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  732791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  732794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  732797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  732800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732826 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  732829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732848 */     GIR_RootConstrainSelectedInstOperands,
     /*  732849 */     // GIR_Coverage, 12100,
     /*  732849 */     GIR_EraseRootFromParent_Done,
     /*  732850 */   // Label 11523: @732850
     /*  732850 */   GIM_Try, /*On fail goto*//*Label 11524*/ GIMT_Encode4(732925), // Rule ID 12101 //
     /*  732855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  732866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  732869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  732872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  732875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732901 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  732904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732923 */     GIR_RootConstrainSelectedInstOperands,
     /*  732924 */     // GIR_Coverage, 12101,
     /*  732924 */     GIR_EraseRootFromParent_Done,
     /*  732925 */   // Label 11524: @732925
     /*  732925 */   GIM_Try, /*On fail goto*//*Label 11525*/ GIMT_Encode4(733000), // Rule ID 12104 //
     /*  732930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  732933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  732941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  732944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  732947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  732950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  732976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  732979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732998 */     GIR_RootConstrainSelectedInstOperands,
     /*  732999 */     // GIR_Coverage, 12104,
     /*  732999 */     GIR_EraseRootFromParent_Done,
     /*  733000 */   // Label 11525: @733000
     /*  733000 */   GIM_Try, /*On fail goto*//*Label 11526*/ GIMT_Encode4(733075), // Rule ID 12105 //
     /*  733005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  733016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  733019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  733022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  733025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733051 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  733054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733073 */     GIR_RootConstrainSelectedInstOperands,
     /*  733074 */     // GIR_Coverage, 12105,
     /*  733074 */     GIR_EraseRootFromParent_Done,
     /*  733075 */   // Label 11526: @733075
     /*  733075 */   GIM_Try, /*On fail goto*//*Label 11527*/ GIMT_Encode4(733150), // Rule ID 12108 //
     /*  733080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  733083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  733091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  733094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  733097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  733100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733126 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  733126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  733129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733148 */     GIR_RootConstrainSelectedInstOperands,
     /*  733149 */     // GIR_Coverage, 12108,
     /*  733149 */     GIR_EraseRootFromParent_Done,
     /*  733150 */   // Label 11527: @733150
     /*  733150 */   GIM_Try, /*On fail goto*//*Label 11528*/ GIMT_Encode4(733225), // Rule ID 12109 //
     /*  733155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  733166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  733169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  733172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  733175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733201 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  733204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733223 */     GIR_RootConstrainSelectedInstOperands,
     /*  733224 */     // GIR_Coverage, 12109,
     /*  733224 */     GIR_EraseRootFromParent_Done,
     /*  733225 */   // Label 11528: @733225
     /*  733225 */   GIM_Try, /*On fail goto*//*Label 11529*/ GIMT_Encode4(733300), // Rule ID 12112 //
     /*  733230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  733233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  733241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  733244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  733247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  733250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733276 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  733276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  733279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733298 */     GIR_RootConstrainSelectedInstOperands,
     /*  733299 */     // GIR_Coverage, 12112,
     /*  733299 */     GIR_EraseRootFromParent_Done,
     /*  733300 */   // Label 11529: @733300
     /*  733300 */   GIM_Try, /*On fail goto*//*Label 11530*/ GIMT_Encode4(733375), // Rule ID 12113 //
     /*  733305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  733316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  733319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  733322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  733325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733351 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  733354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733373 */     GIR_RootConstrainSelectedInstOperands,
     /*  733374 */     // GIR_Coverage, 12113,
     /*  733374 */     GIR_EraseRootFromParent_Done,
     /*  733375 */   // Label 11530: @733375
     /*  733375 */   GIM_Try, /*On fail goto*//*Label 11531*/ GIMT_Encode4(733450), // Rule ID 12116 //
     /*  733380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  733391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  733394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  733397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733426 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  733429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733448 */     GIR_RootConstrainSelectedInstOperands,
     /*  733449 */     // GIR_Coverage, 12116,
     /*  733449 */     GIR_EraseRootFromParent_Done,
     /*  733450 */   // Label 11531: @733450
     /*  733450 */   GIM_Try, /*On fail goto*//*Label 11532*/ GIMT_Encode4(733525), // Rule ID 12117 //
     /*  733455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  733466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  733469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  733472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733501 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  733504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733523 */     GIR_RootConstrainSelectedInstOperands,
     /*  733524 */     // GIR_Coverage, 12117,
     /*  733524 */     GIR_EraseRootFromParent_Done,
     /*  733525 */   // Label 11532: @733525
     /*  733525 */   GIM_Try, /*On fail goto*//*Label 11533*/ GIMT_Encode4(733600), // Rule ID 12120 //
     /*  733530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  733541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  733544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  733547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733576 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  733579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733598 */     GIR_RootConstrainSelectedInstOperands,
     /*  733599 */     // GIR_Coverage, 12120,
     /*  733599 */     GIR_EraseRootFromParent_Done,
     /*  733600 */   // Label 11533: @733600
     /*  733600 */   GIM_Try, /*On fail goto*//*Label 11534*/ GIMT_Encode4(733675), // Rule ID 12121 //
     /*  733605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  733616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  733619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  733622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733651 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  733654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733673 */     GIR_RootConstrainSelectedInstOperands,
     /*  733674 */     // GIR_Coverage, 12121,
     /*  733674 */     GIR_EraseRootFromParent_Done,
     /*  733675 */   // Label 11534: @733675
     /*  733675 */   GIM_Try, /*On fail goto*//*Label 11535*/ GIMT_Encode4(733750), // Rule ID 12124 //
     /*  733680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  733691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  733694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  733697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733726 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  733729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733748 */     GIR_RootConstrainSelectedInstOperands,
     /*  733749 */     // GIR_Coverage, 12124,
     /*  733749 */     GIR_EraseRootFromParent_Done,
     /*  733750 */   // Label 11535: @733750
     /*  733750 */   GIM_Try, /*On fail goto*//*Label 11536*/ GIMT_Encode4(733825), // Rule ID 12125 //
     /*  733755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  733766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  733769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  733772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733801 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  733804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733823 */     GIR_RootConstrainSelectedInstOperands,
     /*  733824 */     // GIR_Coverage, 12125,
     /*  733824 */     GIR_EraseRootFromParent_Done,
     /*  733825 */   // Label 11536: @733825
     /*  733825 */   GIM_Try, /*On fail goto*//*Label 11537*/ GIMT_Encode4(733900), // Rule ID 12128 //
     /*  733830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  733841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  733844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  733847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733876 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  733879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733898 */     GIR_RootConstrainSelectedInstOperands,
     /*  733899 */     // GIR_Coverage, 12128,
     /*  733899 */     GIR_EraseRootFromParent_Done,
     /*  733900 */   // Label 11537: @733900
     /*  733900 */   GIM_Try, /*On fail goto*//*Label 11538*/ GIMT_Encode4(733975), // Rule ID 12129 //
     /*  733905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  733916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  733919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  733922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733951 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  733951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  733954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733973 */     GIR_RootConstrainSelectedInstOperands,
     /*  733974 */     // GIR_Coverage, 12129,
     /*  733974 */     GIR_EraseRootFromParent_Done,
     /*  733975 */   // Label 11538: @733975
     /*  733975 */   GIM_Try, /*On fail goto*//*Label 11539*/ GIMT_Encode4(734050), // Rule ID 12132 //
     /*  733980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  733991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  733994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  733997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734026 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  734029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734048 */     GIR_RootConstrainSelectedInstOperands,
     /*  734049 */     // GIR_Coverage, 12132,
     /*  734049 */     GIR_EraseRootFromParent_Done,
     /*  734050 */   // Label 11539: @734050
     /*  734050 */   GIM_Try, /*On fail goto*//*Label 11540*/ GIMT_Encode4(734125), // Rule ID 12133 //
     /*  734055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  734066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  734069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  734072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734101 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  734104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734123 */     GIR_RootConstrainSelectedInstOperands,
     /*  734124 */     // GIR_Coverage, 12133,
     /*  734124 */     GIR_EraseRootFromParent_Done,
     /*  734125 */   // Label 11540: @734125
     /*  734125 */   GIM_Try, /*On fail goto*//*Label 11541*/ GIMT_Encode4(734200), // Rule ID 12136 //
     /*  734130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  734141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  734144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  734147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  734179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734198 */     GIR_RootConstrainSelectedInstOperands,
     /*  734199 */     // GIR_Coverage, 12136,
     /*  734199 */     GIR_EraseRootFromParent_Done,
     /*  734200 */   // Label 11541: @734200
     /*  734200 */   GIM_Try, /*On fail goto*//*Label 11542*/ GIMT_Encode4(734275), // Rule ID 12137 //
     /*  734205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  734216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  734219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  734222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734251 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  734254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734273 */     GIR_RootConstrainSelectedInstOperands,
     /*  734274 */     // GIR_Coverage, 12137,
     /*  734274 */     GIR_EraseRootFromParent_Done,
     /*  734275 */   // Label 11542: @734275
     /*  734275 */   GIM_Try, /*On fail goto*//*Label 11543*/ GIMT_Encode4(734350), // Rule ID 12140 //
     /*  734280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  734291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  734294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  734297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734326 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  734329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734348 */     GIR_RootConstrainSelectedInstOperands,
     /*  734349 */     // GIR_Coverage, 12140,
     /*  734349 */     GIR_EraseRootFromParent_Done,
     /*  734350 */   // Label 11543: @734350
     /*  734350 */   GIM_Try, /*On fail goto*//*Label 11544*/ GIMT_Encode4(734425), // Rule ID 12141 //
     /*  734355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  734366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  734369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  734372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734401 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  734404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734423 */     GIR_RootConstrainSelectedInstOperands,
     /*  734424 */     // GIR_Coverage, 12141,
     /*  734424 */     GIR_EraseRootFromParent_Done,
     /*  734425 */   // Label 11544: @734425
     /*  734425 */   GIM_Try, /*On fail goto*//*Label 11545*/ GIMT_Encode4(734500), // Rule ID 12144 //
     /*  734430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  734441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  734444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  734447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  734479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734498 */     GIR_RootConstrainSelectedInstOperands,
     /*  734499 */     // GIR_Coverage, 12144,
     /*  734499 */     GIR_EraseRootFromParent_Done,
     /*  734500 */   // Label 11545: @734500
     /*  734500 */   GIM_Try, /*On fail goto*//*Label 11546*/ GIMT_Encode4(734575), // Rule ID 12145 //
     /*  734505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  734516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  734519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  734522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734551 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  734554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734573 */     GIR_RootConstrainSelectedInstOperands,
     /*  734574 */     // GIR_Coverage, 12145,
     /*  734574 */     GIR_EraseRootFromParent_Done,
     /*  734575 */   // Label 11546: @734575
     /*  734575 */   GIM_Try, /*On fail goto*//*Label 11547*/ GIMT_Encode4(734650), // Rule ID 12148 //
     /*  734580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  734597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  734629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734648 */     GIR_RootConstrainSelectedInstOperands,
     /*  734649 */     // GIR_Coverage, 12148,
     /*  734649 */     GIR_EraseRootFromParent_Done,
     /*  734650 */   // Label 11547: @734650
     /*  734650 */   GIM_Try, /*On fail goto*//*Label 11548*/ GIMT_Encode4(734725), // Rule ID 12149 //
     /*  734655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  734672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734701 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  734704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734723 */     GIR_RootConstrainSelectedInstOperands,
     /*  734724 */     // GIR_Coverage, 12149,
     /*  734724 */     GIR_EraseRootFromParent_Done,
     /*  734725 */   // Label 11548: @734725
     /*  734725 */   GIM_Try, /*On fail goto*//*Label 11549*/ GIMT_Encode4(734800), // Rule ID 12152 //
     /*  734730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  734733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  734747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734776 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  734776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  734779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734798 */     GIR_RootConstrainSelectedInstOperands,
     /*  734799 */     // GIR_Coverage, 12152,
     /*  734799 */     GIR_EraseRootFromParent_Done,
     /*  734800 */   // Label 11549: @734800
     /*  734800 */   GIM_Try, /*On fail goto*//*Label 11550*/ GIMT_Encode4(734875), // Rule ID 12153 //
     /*  734805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  734808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  734822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734851 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  734851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  734854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734873 */     GIR_RootConstrainSelectedInstOperands,
     /*  734874 */     // GIR_Coverage, 12153,
     /*  734874 */     GIR_EraseRootFromParent_Done,
     /*  734875 */   // Label 11550: @734875
     /*  734875 */   GIM_Try, /*On fail goto*//*Label 11551*/ GIMT_Encode4(734950), // Rule ID 12156 //
     /*  734880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  734891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  734894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  734897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734926 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  734929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734948 */     GIR_RootConstrainSelectedInstOperands,
     /*  734949 */     // GIR_Coverage, 12156,
     /*  734949 */     GIR_EraseRootFromParent_Done,
     /*  734950 */   // Label 11551: @734950
     /*  734950 */   GIM_Try, /*On fail goto*//*Label 11552*/ GIMT_Encode4(735025), // Rule ID 12157 //
     /*  734955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  734966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  734969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  734972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735001 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  735004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735023 */     GIR_RootConstrainSelectedInstOperands,
     /*  735024 */     // GIR_Coverage, 12157,
     /*  735024 */     GIR_EraseRootFromParent_Done,
     /*  735025 */   // Label 11552: @735025
     /*  735025 */   GIM_Try, /*On fail goto*//*Label 11553*/ GIMT_Encode4(735100), // Rule ID 12160 //
     /*  735030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  735041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  735044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  735047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735076 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  735079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735098 */     GIR_RootConstrainSelectedInstOperands,
     /*  735099 */     // GIR_Coverage, 12160,
     /*  735099 */     GIR_EraseRootFromParent_Done,
     /*  735100 */   // Label 11553: @735100
     /*  735100 */   GIM_Try, /*On fail goto*//*Label 11554*/ GIMT_Encode4(735175), // Rule ID 12161 //
     /*  735105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  735116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  735119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  735122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735151 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  735154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735173 */     GIR_RootConstrainSelectedInstOperands,
     /*  735174 */     // GIR_Coverage, 12161,
     /*  735174 */     GIR_EraseRootFromParent_Done,
     /*  735175 */   // Label 11554: @735175
     /*  735175 */   GIM_Try, /*On fail goto*//*Label 11555*/ GIMT_Encode4(735250), // Rule ID 12164 //
     /*  735180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  735191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  735194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  735197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735226 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  735229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735248 */     GIR_RootConstrainSelectedInstOperands,
     /*  735249 */     // GIR_Coverage, 12164,
     /*  735249 */     GIR_EraseRootFromParent_Done,
     /*  735250 */   // Label 11555: @735250
     /*  735250 */   GIM_Try, /*On fail goto*//*Label 11556*/ GIMT_Encode4(735325), // Rule ID 12165 //
     /*  735255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  735266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  735269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  735272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735301 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  735304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735323 */     GIR_RootConstrainSelectedInstOperands,
     /*  735324 */     // GIR_Coverage, 12165,
     /*  735324 */     GIR_EraseRootFromParent_Done,
     /*  735325 */   // Label 11556: @735325
     /*  735325 */   GIM_Try, /*On fail goto*//*Label 11557*/ GIMT_Encode4(735400), // Rule ID 12168 //
     /*  735330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  735341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  735344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  735347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  735379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735398 */     GIR_RootConstrainSelectedInstOperands,
     /*  735399 */     // GIR_Coverage, 12168,
     /*  735399 */     GIR_EraseRootFromParent_Done,
     /*  735400 */   // Label 11557: @735400
     /*  735400 */   GIM_Try, /*On fail goto*//*Label 11558*/ GIMT_Encode4(735475), // Rule ID 12169 //
     /*  735405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  735416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  735419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  735422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735451 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  735454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735473 */     GIR_RootConstrainSelectedInstOperands,
     /*  735474 */     // GIR_Coverage, 12169,
     /*  735474 */     GIR_EraseRootFromParent_Done,
     /*  735475 */   // Label 11558: @735475
     /*  735475 */   GIM_Try, /*On fail goto*//*Label 11559*/ GIMT_Encode4(735550), // Rule ID 12172 //
     /*  735480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  735491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  735494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  735497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735526 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  735529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735548 */     GIR_RootConstrainSelectedInstOperands,
     /*  735549 */     // GIR_Coverage, 12172,
     /*  735549 */     GIR_EraseRootFromParent_Done,
     /*  735550 */   // Label 11559: @735550
     /*  735550 */   GIM_Try, /*On fail goto*//*Label 11560*/ GIMT_Encode4(735625), // Rule ID 12173 //
     /*  735555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  735566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  735569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  735572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735601 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  735604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735623 */     GIR_RootConstrainSelectedInstOperands,
     /*  735624 */     // GIR_Coverage, 12173,
     /*  735624 */     GIR_EraseRootFromParent_Done,
     /*  735625 */   // Label 11560: @735625
     /*  735625 */   GIM_Try, /*On fail goto*//*Label 11561*/ GIMT_Encode4(735700), // Rule ID 12176 //
     /*  735630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  735641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  735644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  735647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735676 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  735679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735698 */     GIR_RootConstrainSelectedInstOperands,
     /*  735699 */     // GIR_Coverage, 12176,
     /*  735699 */     GIR_EraseRootFromParent_Done,
     /*  735700 */   // Label 11561: @735700
     /*  735700 */   GIM_Try, /*On fail goto*//*Label 11562*/ GIMT_Encode4(735775), // Rule ID 12177 //
     /*  735705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  735716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  735719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  735722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735751 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  735754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735773 */     GIR_RootConstrainSelectedInstOperands,
     /*  735774 */     // GIR_Coverage, 12177,
     /*  735774 */     GIR_EraseRootFromParent_Done,
     /*  735775 */   // Label 11562: @735775
     /*  735775 */   GIM_Try, /*On fail goto*//*Label 11563*/ GIMT_Encode4(735850), // Rule ID 12180 //
     /*  735780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  735791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  735794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  735797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735826 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  735829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735848 */     GIR_RootConstrainSelectedInstOperands,
     /*  735849 */     // GIR_Coverage, 12180,
     /*  735849 */     GIR_EraseRootFromParent_Done,
     /*  735850 */   // Label 11563: @735850
     /*  735850 */   GIM_Try, /*On fail goto*//*Label 11564*/ GIMT_Encode4(735925), // Rule ID 12181 //
     /*  735855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  735866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  735869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  735872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  735904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735923 */     GIR_RootConstrainSelectedInstOperands,
     /*  735924 */     // GIR_Coverage, 12181,
     /*  735924 */     GIR_EraseRootFromParent_Done,
     /*  735925 */   // Label 11564: @735925
     /*  735925 */   GIM_Try, /*On fail goto*//*Label 11565*/ GIMT_Encode4(736000), // Rule ID 12184 //
     /*  735930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  735941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  735944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  735947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  735979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735998 */     GIR_RootConstrainSelectedInstOperands,
     /*  735999 */     // GIR_Coverage, 12184,
     /*  735999 */     GIR_EraseRootFromParent_Done,
     /*  736000 */   // Label 11565: @736000
     /*  736000 */   GIM_Try, /*On fail goto*//*Label 11566*/ GIMT_Encode4(736075), // Rule ID 12185 //
     /*  736005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  736016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  736019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  736022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736051 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  736051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  736054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736073 */     GIR_RootConstrainSelectedInstOperands,
     /*  736074 */     // GIR_Coverage, 12185,
     /*  736074 */     GIR_EraseRootFromParent_Done,
     /*  736075 */   // Label 11566: @736075
     /*  736075 */   GIM_Try, /*On fail goto*//*Label 11567*/ GIMT_Encode4(736150), // Rule ID 12188 //
     /*  736080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  736091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  736094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  736097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736126 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  736126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  736129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736148 */     GIR_RootConstrainSelectedInstOperands,
     /*  736149 */     // GIR_Coverage, 12188,
     /*  736149 */     GIR_EraseRootFromParent_Done,
     /*  736150 */   // Label 11567: @736150
     /*  736150 */   GIM_Try, /*On fail goto*//*Label 11568*/ GIMT_Encode4(736225), // Rule ID 12189 //
     /*  736155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  736166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  736169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  736172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736201 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  736201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  736204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736223 */     GIR_RootConstrainSelectedInstOperands,
     /*  736224 */     // GIR_Coverage, 12189,
     /*  736224 */     GIR_EraseRootFromParent_Done,
     /*  736225 */   // Label 11568: @736225
     /*  736225 */   GIM_Try, /*On fail goto*//*Label 11569*/ GIMT_Encode4(736300), // Rule ID 12192 //
     /*  736230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  736241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  736244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  736247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  736279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736298 */     GIR_RootConstrainSelectedInstOperands,
     /*  736299 */     // GIR_Coverage, 12192,
     /*  736299 */     GIR_EraseRootFromParent_Done,
     /*  736300 */   // Label 11569: @736300
     /*  736300 */   GIM_Try, /*On fail goto*//*Label 11570*/ GIMT_Encode4(736375), // Rule ID 12193 //
     /*  736305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  736316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  736319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  736322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736351 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  736354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736373 */     GIR_RootConstrainSelectedInstOperands,
     /*  736374 */     // GIR_Coverage, 12193,
     /*  736374 */     GIR_EraseRootFromParent_Done,
     /*  736375 */   // Label 11570: @736375
     /*  736375 */   GIM_Try, /*On fail goto*//*Label 11571*/ GIMT_Encode4(736450), // Rule ID 12196 //
     /*  736380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  736391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  736394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  736397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736426 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  736429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736448 */     GIR_RootConstrainSelectedInstOperands,
     /*  736449 */     // GIR_Coverage, 12196,
     /*  736449 */     GIR_EraseRootFromParent_Done,
     /*  736450 */   // Label 11571: @736450
     /*  736450 */   GIM_Try, /*On fail goto*//*Label 11572*/ GIMT_Encode4(736525), // Rule ID 12197 //
     /*  736455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  736466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  736469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  736472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736501 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  736504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736523 */     GIR_RootConstrainSelectedInstOperands,
     /*  736524 */     // GIR_Coverage, 12197,
     /*  736524 */     GIR_EraseRootFromParent_Done,
     /*  736525 */   // Label 11572: @736525
     /*  736525 */   GIM_Try, /*On fail goto*//*Label 11573*/ GIMT_Encode4(736600), // Rule ID 12200 //
     /*  736530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  736541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  736544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  736547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  736579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736598 */     GIR_RootConstrainSelectedInstOperands,
     /*  736599 */     // GIR_Coverage, 12200,
     /*  736599 */     GIR_EraseRootFromParent_Done,
     /*  736600 */   // Label 11573: @736600
     /*  736600 */   GIM_Try, /*On fail goto*//*Label 11574*/ GIMT_Encode4(736675), // Rule ID 12201 //
     /*  736605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  736616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  736619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  736622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736651 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  736654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736673 */     GIR_RootConstrainSelectedInstOperands,
     /*  736674 */     // GIR_Coverage, 12201,
     /*  736674 */     GIR_EraseRootFromParent_Done,
     /*  736675 */   // Label 11574: @736675
     /*  736675 */   GIM_Try, /*On fail goto*//*Label 11575*/ GIMT_Encode4(736750), // Rule ID 12204 //
     /*  736680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  736691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  736694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  736697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  736700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  736729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736748 */     GIR_RootConstrainSelectedInstOperands,
     /*  736749 */     // GIR_Coverage, 12204,
     /*  736749 */     GIR_EraseRootFromParent_Done,
     /*  736750 */   // Label 11575: @736750
     /*  736750 */   GIM_Try, /*On fail goto*//*Label 11576*/ GIMT_Encode4(736825), // Rule ID 12205 //
     /*  736755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  736766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  736769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  736772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  736775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736801 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  736804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736823 */     GIR_RootConstrainSelectedInstOperands,
     /*  736824 */     // GIR_Coverage, 12205,
     /*  736824 */     GIR_EraseRootFromParent_Done,
     /*  736825 */   // Label 11576: @736825
     /*  736825 */   GIM_Try, /*On fail goto*//*Label 11577*/ GIMT_Encode4(736900), // Rule ID 12208 //
     /*  736830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  736841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  736844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  736847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  736850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736876 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  736879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736898 */     GIR_RootConstrainSelectedInstOperands,
     /*  736899 */     // GIR_Coverage, 12208,
     /*  736899 */     GIR_EraseRootFromParent_Done,
     /*  736900 */   // Label 11577: @736900
     /*  736900 */   GIM_Try, /*On fail goto*//*Label 11578*/ GIMT_Encode4(736975), // Rule ID 12209 //
     /*  736905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  736916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  736919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  736922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  736925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736951 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  736954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736973 */     GIR_RootConstrainSelectedInstOperands,
     /*  736974 */     // GIR_Coverage, 12209,
     /*  736974 */     GIR_EraseRootFromParent_Done,
     /*  736975 */   // Label 11578: @736975
     /*  736975 */   GIM_Try, /*On fail goto*//*Label 11579*/ GIMT_Encode4(737050), // Rule ID 12212 //
     /*  736980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  736991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  736994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  736997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  737000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737026 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  737029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737048 */     GIR_RootConstrainSelectedInstOperands,
     /*  737049 */     // GIR_Coverage, 12212,
     /*  737049 */     GIR_EraseRootFromParent_Done,
     /*  737050 */   // Label 11579: @737050
     /*  737050 */   GIM_Try, /*On fail goto*//*Label 11580*/ GIMT_Encode4(737125), // Rule ID 12213 //
     /*  737055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  737066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  737069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  737072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  737075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737101 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  737104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737123 */     GIR_RootConstrainSelectedInstOperands,
     /*  737124 */     // GIR_Coverage, 12213,
     /*  737124 */     GIR_EraseRootFromParent_Done,
     /*  737125 */   // Label 11580: @737125
     /*  737125 */   GIM_Try, /*On fail goto*//*Label 11581*/ GIMT_Encode4(737200), // Rule ID 12216 //
     /*  737130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  737141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  737144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  737147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  737150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737176 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  737179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737198 */     GIR_RootConstrainSelectedInstOperands,
     /*  737199 */     // GIR_Coverage, 12216,
     /*  737199 */     GIR_EraseRootFromParent_Done,
     /*  737200 */   // Label 11581: @737200
     /*  737200 */   GIM_Try, /*On fail goto*//*Label 11582*/ GIMT_Encode4(737275), // Rule ID 12217 //
     /*  737205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  737216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  737219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  737222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  737225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737251 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  737254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737273 */     GIR_RootConstrainSelectedInstOperands,
     /*  737274 */     // GIR_Coverage, 12217,
     /*  737274 */     GIR_EraseRootFromParent_Done,
     /*  737275 */   // Label 11582: @737275
     /*  737275 */   GIM_Try, /*On fail goto*//*Label 11583*/ GIMT_Encode4(737350), // Rule ID 12220 //
     /*  737280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  737291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  737294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  737297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  737300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737326 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  737329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737348 */     GIR_RootConstrainSelectedInstOperands,
     /*  737349 */     // GIR_Coverage, 12220,
     /*  737349 */     GIR_EraseRootFromParent_Done,
     /*  737350 */   // Label 11583: @737350
     /*  737350 */   GIM_Try, /*On fail goto*//*Label 11584*/ GIMT_Encode4(737425), // Rule ID 12221 //
     /*  737355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  737366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  737369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  737372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  737375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737401 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  737404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737423 */     GIR_RootConstrainSelectedInstOperands,
     /*  737424 */     // GIR_Coverage, 12221,
     /*  737424 */     GIR_EraseRootFromParent_Done,
     /*  737425 */   // Label 11584: @737425
     /*  737425 */   GIM_Try, /*On fail goto*//*Label 11585*/ GIMT_Encode4(737500), // Rule ID 12224 //
     /*  737430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  737441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  737444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  737447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  737450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737476 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  737479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737498 */     GIR_RootConstrainSelectedInstOperands,
     /*  737499 */     // GIR_Coverage, 12224,
     /*  737499 */     GIR_EraseRootFromParent_Done,
     /*  737500 */   // Label 11585: @737500
     /*  737500 */   GIM_Try, /*On fail goto*//*Label 11586*/ GIMT_Encode4(737575), // Rule ID 12225 //
     /*  737505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  737516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  737519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  737522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  737525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737551 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  737554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737573 */     GIR_RootConstrainSelectedInstOperands,
     /*  737574 */     // GIR_Coverage, 12225,
     /*  737574 */     GIR_EraseRootFromParent_Done,
     /*  737575 */   // Label 11586: @737575
     /*  737575 */   GIM_Try, /*On fail goto*//*Label 11587*/ GIMT_Encode4(737650), // Rule ID 12228 //
     /*  737580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  737591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  737594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  737597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  737600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737626 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  737629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737648 */     GIR_RootConstrainSelectedInstOperands,
     /*  737649 */     // GIR_Coverage, 12228,
     /*  737649 */     GIR_EraseRootFromParent_Done,
     /*  737650 */   // Label 11587: @737650
     /*  737650 */   GIM_Try, /*On fail goto*//*Label 11588*/ GIMT_Encode4(737725), // Rule ID 12229 //
     /*  737655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  737666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  737669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  737672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  737675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737701 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  737704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737723 */     GIR_RootConstrainSelectedInstOperands,
     /*  737724 */     // GIR_Coverage, 12229,
     /*  737724 */     GIR_EraseRootFromParent_Done,
     /*  737725 */   // Label 11588: @737725
     /*  737725 */   GIM_Try, /*On fail goto*//*Label 11589*/ GIMT_Encode4(737800), // Rule ID 12232 //
     /*  737730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  737747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  737750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737776 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  737779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737798 */     GIR_RootConstrainSelectedInstOperands,
     /*  737799 */     // GIR_Coverage, 12232,
     /*  737799 */     GIR_EraseRootFromParent_Done,
     /*  737800 */   // Label 11589: @737800
     /*  737800 */   GIM_Try, /*On fail goto*//*Label 11590*/ GIMT_Encode4(737875), // Rule ID 12233 //
     /*  737805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  737822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  737825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737851 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  737854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737873 */     GIR_RootConstrainSelectedInstOperands,
     /*  737874 */     // GIR_Coverage, 12233,
     /*  737874 */     GIR_EraseRootFromParent_Done,
     /*  737875 */   // Label 11590: @737875
     /*  737875 */   GIM_Try, /*On fail goto*//*Label 11591*/ GIMT_Encode4(737950), // Rule ID 12236 //
     /*  737880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  737897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737926 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  737929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737948 */     GIR_RootConstrainSelectedInstOperands,
     /*  737949 */     // GIR_Coverage, 12236,
     /*  737949 */     GIR_EraseRootFromParent_Done,
     /*  737950 */   // Label 11591: @737950
     /*  737950 */   GIM_Try, /*On fail goto*//*Label 11592*/ GIMT_Encode4(738025), // Rule ID 12237 //
     /*  737955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  737972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738001 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  738001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  738004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738023 */     GIR_RootConstrainSelectedInstOperands,
     /*  738024 */     // GIR_Coverage, 12237,
     /*  738024 */     GIR_EraseRootFromParent_Done,
     /*  738025 */   // Label 11592: @738025
     /*  738025 */   GIM_Try, /*On fail goto*//*Label 11593*/ GIMT_Encode4(738100), // Rule ID 12240 //
     /*  738030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  738033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  738041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  738044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  738047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  738050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738076 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  738076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  738079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738098 */     GIR_RootConstrainSelectedInstOperands,
     /*  738099 */     // GIR_Coverage, 12240,
     /*  738099 */     GIR_EraseRootFromParent_Done,
     /*  738100 */   // Label 11593: @738100
     /*  738100 */   GIM_Try, /*On fail goto*//*Label 11594*/ GIMT_Encode4(738175), // Rule ID 12241 //
     /*  738105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  738108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  738116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  738119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  738122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  738125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738151 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  738151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  738154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738173 */     GIR_RootConstrainSelectedInstOperands,
     /*  738174 */     // GIR_Coverage, 12241,
     /*  738174 */     GIR_EraseRootFromParent_Done,
     /*  738175 */   // Label 11594: @738175
     /*  738175 */   GIM_Try, /*On fail goto*//*Label 11595*/ GIMT_Encode4(738250), // Rule ID 12244 //
     /*  738180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  738191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  738194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  738197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  738200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738226 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  738229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738248 */     GIR_RootConstrainSelectedInstOperands,
     /*  738249 */     // GIR_Coverage, 12244,
     /*  738249 */     GIR_EraseRootFromParent_Done,
     /*  738250 */   // Label 11595: @738250
     /*  738250 */   GIM_Try, /*On fail goto*//*Label 11596*/ GIMT_Encode4(738325), // Rule ID 12245 //
     /*  738255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  738266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  738269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  738272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  738275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738301 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  738304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738323 */     GIR_RootConstrainSelectedInstOperands,
     /*  738324 */     // GIR_Coverage, 12245,
     /*  738324 */     GIR_EraseRootFromParent_Done,
     /*  738325 */   // Label 11596: @738325
     /*  738325 */   GIM_Try, /*On fail goto*//*Label 11597*/ GIMT_Encode4(738400), // Rule ID 12248 //
     /*  738330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  738341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  738344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  738347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  738350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738376 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  738379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738398 */     GIR_RootConstrainSelectedInstOperands,
     /*  738399 */     // GIR_Coverage, 12248,
     /*  738399 */     GIR_EraseRootFromParent_Done,
     /*  738400 */   // Label 11597: @738400
     /*  738400 */   GIM_Try, /*On fail goto*//*Label 11598*/ GIMT_Encode4(738475), // Rule ID 12249 //
     /*  738405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  738416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  738419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  738422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  738425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738451 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  738454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738473 */     GIR_RootConstrainSelectedInstOperands,
     /*  738474 */     // GIR_Coverage, 12249,
     /*  738474 */     GIR_EraseRootFromParent_Done,
     /*  738475 */   // Label 11598: @738475
     /*  738475 */   GIM_Try, /*On fail goto*//*Label 11599*/ GIMT_Encode4(738550), // Rule ID 12252 //
     /*  738480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  738491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  738494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  738497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  738500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738526 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  738529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738548 */     GIR_RootConstrainSelectedInstOperands,
     /*  738549 */     // GIR_Coverage, 12252,
     /*  738549 */     GIR_EraseRootFromParent_Done,
     /*  738550 */   // Label 11599: @738550
     /*  738550 */   GIM_Try, /*On fail goto*//*Label 11600*/ GIMT_Encode4(738625), // Rule ID 12253 //
     /*  738555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  738566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  738569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  738572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  738575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738601 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  738604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738623 */     GIR_RootConstrainSelectedInstOperands,
     /*  738624 */     // GIR_Coverage, 12253,
     /*  738624 */     GIR_EraseRootFromParent_Done,
     /*  738625 */   // Label 11600: @738625
     /*  738625 */   GIM_Try, /*On fail goto*//*Label 11601*/ GIMT_Encode4(738700), // Rule ID 12256 //
     /*  738630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  738641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  738644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  738647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  738650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  738679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738698 */     GIR_RootConstrainSelectedInstOperands,
     /*  738699 */     // GIR_Coverage, 12256,
     /*  738699 */     GIR_EraseRootFromParent_Done,
     /*  738700 */   // Label 11601: @738700
     /*  738700 */   GIM_Try, /*On fail goto*//*Label 11602*/ GIMT_Encode4(738775), // Rule ID 12257 //
     /*  738705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  738716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  738719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  738722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  738725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738751 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  738754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738773 */     GIR_RootConstrainSelectedInstOperands,
     /*  738774 */     // GIR_Coverage, 12257,
     /*  738774 */     GIR_EraseRootFromParent_Done,
     /*  738775 */   // Label 11602: @738775
     /*  738775 */   GIM_Try, /*On fail goto*//*Label 11603*/ GIMT_Encode4(738850), // Rule ID 12260 //
     /*  738780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  738791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  738794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  738797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  738800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738826 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  738829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738848 */     GIR_RootConstrainSelectedInstOperands,
     /*  738849 */     // GIR_Coverage, 12260,
     /*  738849 */     GIR_EraseRootFromParent_Done,
     /*  738850 */   // Label 11603: @738850
     /*  738850 */   GIM_Try, /*On fail goto*//*Label 11604*/ GIMT_Encode4(738925), // Rule ID 12261 //
     /*  738855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  738866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  738869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  738872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  738875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738901 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  738904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738923 */     GIR_RootConstrainSelectedInstOperands,
     /*  738924 */     // GIR_Coverage, 12261,
     /*  738924 */     GIR_EraseRootFromParent_Done,
     /*  738925 */   // Label 11604: @738925
     /*  738925 */   GIM_Try, /*On fail goto*//*Label 11605*/ GIMT_Encode4(739000), // Rule ID 12264 //
     /*  738930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  738941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  738944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  738947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  738950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738976 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  738979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738998 */     GIR_RootConstrainSelectedInstOperands,
     /*  738999 */     // GIR_Coverage, 12264,
     /*  738999 */     GIR_EraseRootFromParent_Done,
     /*  739000 */   // Label 11605: @739000
     /*  739000 */   GIM_Try, /*On fail goto*//*Label 11606*/ GIMT_Encode4(739075), // Rule ID 12265 //
     /*  739005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  739016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  739019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  739022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  739025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739051 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  739051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  739054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739073 */     GIR_RootConstrainSelectedInstOperands,
     /*  739074 */     // GIR_Coverage, 12265,
     /*  739074 */     GIR_EraseRootFromParent_Done,
     /*  739075 */   // Label 11606: @739075
     /*  739075 */   GIM_Try, /*On fail goto*//*Label 11607*/ GIMT_Encode4(739150), // Rule ID 12268 //
     /*  739080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  739091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  739094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  739097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  739100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739126 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  739129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739148 */     GIR_RootConstrainSelectedInstOperands,
     /*  739149 */     // GIR_Coverage, 12268,
     /*  739149 */     GIR_EraseRootFromParent_Done,
     /*  739150 */   // Label 11607: @739150
     /*  739150 */   GIM_Try, /*On fail goto*//*Label 11608*/ GIMT_Encode4(739225), // Rule ID 12269 //
     /*  739155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  739166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  739169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  739172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  739175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739201 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  739204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739223 */     GIR_RootConstrainSelectedInstOperands,
     /*  739224 */     // GIR_Coverage, 12269,
     /*  739224 */     GIR_EraseRootFromParent_Done,
     /*  739225 */   // Label 11608: @739225
     /*  739225 */   GIM_Try, /*On fail goto*//*Label 11609*/ GIMT_Encode4(739300), // Rule ID 12272 //
     /*  739230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  739241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  739244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  739247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  739250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739276 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  739279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739298 */     GIR_RootConstrainSelectedInstOperands,
     /*  739299 */     // GIR_Coverage, 12272,
     /*  739299 */     GIR_EraseRootFromParent_Done,
     /*  739300 */   // Label 11609: @739300
     /*  739300 */   GIM_Try, /*On fail goto*//*Label 11610*/ GIMT_Encode4(739375), // Rule ID 12273 //
     /*  739305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  739316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  739319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  739322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  739325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739351 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  739354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739373 */     GIR_RootConstrainSelectedInstOperands,
     /*  739374 */     // GIR_Coverage, 12273,
     /*  739374 */     GIR_EraseRootFromParent_Done,
     /*  739375 */   // Label 11610: @739375
     /*  739375 */   GIM_Try, /*On fail goto*//*Label 11611*/ GIMT_Encode4(739450), // Rule ID 12276 //
     /*  739380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  739391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  739394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  739397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  739400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739426 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  739429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739448 */     GIR_RootConstrainSelectedInstOperands,
     /*  739449 */     // GIR_Coverage, 12276,
     /*  739449 */     GIR_EraseRootFromParent_Done,
     /*  739450 */   // Label 11611: @739450
     /*  739450 */   GIM_Try, /*On fail goto*//*Label 11612*/ GIMT_Encode4(739525), // Rule ID 12277 //
     /*  739455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  739466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  739469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  739472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  739475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739501 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  739504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739523 */     GIR_RootConstrainSelectedInstOperands,
     /*  739524 */     // GIR_Coverage, 12277,
     /*  739524 */     GIR_EraseRootFromParent_Done,
     /*  739525 */   // Label 11612: @739525
     /*  739525 */   GIM_Try, /*On fail goto*//*Label 11613*/ GIMT_Encode4(739600), // Rule ID 12280 //
     /*  739530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  739541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  739544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  739547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  739550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  739579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739598 */     GIR_RootConstrainSelectedInstOperands,
     /*  739599 */     // GIR_Coverage, 12280,
     /*  739599 */     GIR_EraseRootFromParent_Done,
     /*  739600 */   // Label 11613: @739600
     /*  739600 */   GIM_Try, /*On fail goto*//*Label 11614*/ GIMT_Encode4(739675), // Rule ID 12281 //
     /*  739605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  739616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  739619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  739622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  739625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739651 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  739654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739673 */     GIR_RootConstrainSelectedInstOperands,
     /*  739674 */     // GIR_Coverage, 12281,
     /*  739674 */     GIR_EraseRootFromParent_Done,
     /*  739675 */   // Label 11614: @739675
     /*  739675 */   GIM_Try, /*On fail goto*//*Label 11615*/ GIMT_Encode4(739750), // Rule ID 12284 //
     /*  739680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  739691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  739694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  739697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  739700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739726 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  739729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739748 */     GIR_RootConstrainSelectedInstOperands,
     /*  739749 */     // GIR_Coverage, 12284,
     /*  739749 */     GIR_EraseRootFromParent_Done,
     /*  739750 */   // Label 11615: @739750
     /*  739750 */   GIM_Try, /*On fail goto*//*Label 11616*/ GIMT_Encode4(739825), // Rule ID 12285 //
     /*  739755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  739766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  739769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  739772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  739775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739801 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  739804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739823 */     GIR_RootConstrainSelectedInstOperands,
     /*  739824 */     // GIR_Coverage, 12285,
     /*  739824 */     GIR_EraseRootFromParent_Done,
     /*  739825 */   // Label 11616: @739825
     /*  739825 */   GIM_Try, /*On fail goto*//*Label 11617*/ GIMT_Encode4(739900), // Rule ID 12288 //
     /*  739830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  739841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  739844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  739847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  739850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739876 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  739879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739898 */     GIR_RootConstrainSelectedInstOperands,
     /*  739899 */     // GIR_Coverage, 12288,
     /*  739899 */     GIR_EraseRootFromParent_Done,
     /*  739900 */   // Label 11617: @739900
     /*  739900 */   GIM_Try, /*On fail goto*//*Label 11618*/ GIMT_Encode4(739975), // Rule ID 12289 //
     /*  739905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  739916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  739919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  739922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  739925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739951 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  739954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739973 */     GIR_RootConstrainSelectedInstOperands,
     /*  739974 */     // GIR_Coverage, 12289,
     /*  739974 */     GIR_EraseRootFromParent_Done,
     /*  739975 */   // Label 11618: @739975
     /*  739975 */   GIM_Try, /*On fail goto*//*Label 11619*/ GIMT_Encode4(740050), // Rule ID 12292 //
     /*  739980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  739991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  739994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  739997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740026 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  740029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740048 */     GIR_RootConstrainSelectedInstOperands,
     /*  740049 */     // GIR_Coverage, 12292,
     /*  740049 */     GIR_EraseRootFromParent_Done,
     /*  740050 */   // Label 11619: @740050
     /*  740050 */   GIM_Try, /*On fail goto*//*Label 11620*/ GIMT_Encode4(740125), // Rule ID 12293 //
     /*  740055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  740066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  740069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  740072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740101 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  740104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740123 */     GIR_RootConstrainSelectedInstOperands,
     /*  740124 */     // GIR_Coverage, 12293,
     /*  740124 */     GIR_EraseRootFromParent_Done,
     /*  740125 */   // Label 11620: @740125
     /*  740125 */   GIM_Try, /*On fail goto*//*Label 11621*/ GIMT_Encode4(740200), // Rule ID 12296 //
     /*  740130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  740141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  740144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  740147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740176 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  740179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740198 */     GIR_RootConstrainSelectedInstOperands,
     /*  740199 */     // GIR_Coverage, 12296,
     /*  740199 */     GIR_EraseRootFromParent_Done,
     /*  740200 */   // Label 11621: @740200
     /*  740200 */   GIM_Try, /*On fail goto*//*Label 11622*/ GIMT_Encode4(740275), // Rule ID 12297 //
     /*  740205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  740216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  740219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  740222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740251 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  740254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740273 */     GIR_RootConstrainSelectedInstOperands,
     /*  740274 */     // GIR_Coverage, 12297,
     /*  740274 */     GIR_EraseRootFromParent_Done,
     /*  740275 */   // Label 11622: @740275
     /*  740275 */   GIM_Try, /*On fail goto*//*Label 11623*/ GIMT_Encode4(740350), // Rule ID 12300 //
     /*  740280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  740291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  740294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  740297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740326 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  740329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740348 */     GIR_RootConstrainSelectedInstOperands,
     /*  740349 */     // GIR_Coverage, 12300,
     /*  740349 */     GIR_EraseRootFromParent_Done,
     /*  740350 */   // Label 11623: @740350
     /*  740350 */   GIM_Try, /*On fail goto*//*Label 11624*/ GIMT_Encode4(740425), // Rule ID 12301 //
     /*  740355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  740366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  740369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  740372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740401 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  740404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740423 */     GIR_RootConstrainSelectedInstOperands,
     /*  740424 */     // GIR_Coverage, 12301,
     /*  740424 */     GIR_EraseRootFromParent_Done,
     /*  740425 */   // Label 11624: @740425
     /*  740425 */   GIM_Try, /*On fail goto*//*Label 11625*/ GIMT_Encode4(740500), // Rule ID 12304 //
     /*  740430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  740441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  740444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  740447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740476 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  740479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740498 */     GIR_RootConstrainSelectedInstOperands,
     /*  740499 */     // GIR_Coverage, 12304,
     /*  740499 */     GIR_EraseRootFromParent_Done,
     /*  740500 */   // Label 11625: @740500
     /*  740500 */   GIM_Try, /*On fail goto*//*Label 11626*/ GIMT_Encode4(740575), // Rule ID 12305 //
     /*  740505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  740516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  740519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  740522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740551 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  740554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740573 */     GIR_RootConstrainSelectedInstOperands,
     /*  740574 */     // GIR_Coverage, 12305,
     /*  740574 */     GIR_EraseRootFromParent_Done,
     /*  740575 */   // Label 11626: @740575
     /*  740575 */   GIM_Try, /*On fail goto*//*Label 11627*/ GIMT_Encode4(740650), // Rule ID 12308 //
     /*  740580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  740591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  740594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  740597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740626 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  740629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740648 */     GIR_RootConstrainSelectedInstOperands,
     /*  740649 */     // GIR_Coverage, 12308,
     /*  740649 */     GIR_EraseRootFromParent_Done,
     /*  740650 */   // Label 11627: @740650
     /*  740650 */   GIM_Try, /*On fail goto*//*Label 11628*/ GIMT_Encode4(740725), // Rule ID 12309 //
     /*  740655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  740666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  740669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  740672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740701 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  740704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740723 */     GIR_RootConstrainSelectedInstOperands,
     /*  740724 */     // GIR_Coverage, 12309,
     /*  740724 */     GIR_EraseRootFromParent_Done,
     /*  740725 */   // Label 11628: @740725
     /*  740725 */   GIM_Try, /*On fail goto*//*Label 11629*/ GIMT_Encode4(740800), // Rule ID 12312 //
     /*  740730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  740741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  740744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  740747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740776 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  740776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  740779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740798 */     GIR_RootConstrainSelectedInstOperands,
     /*  740799 */     // GIR_Coverage, 12312,
     /*  740799 */     GIR_EraseRootFromParent_Done,
     /*  740800 */   // Label 11629: @740800
     /*  740800 */   GIM_Try, /*On fail goto*//*Label 11630*/ GIMT_Encode4(740875), // Rule ID 12313 //
     /*  740805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  740816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  740819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  740822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740851 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  740851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  740854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740873 */     GIR_RootConstrainSelectedInstOperands,
     /*  740874 */     // GIR_Coverage, 12313,
     /*  740874 */     GIR_EraseRootFromParent_Done,
     /*  740875 */   // Label 11630: @740875
     /*  740875 */   GIM_Try, /*On fail goto*//*Label 11631*/ GIMT_Encode4(740950), // Rule ID 12316 //
     /*  740880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  740891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  740894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  740897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740926 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  740929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740948 */     GIR_RootConstrainSelectedInstOperands,
     /*  740949 */     // GIR_Coverage, 12316,
     /*  740949 */     GIR_EraseRootFromParent_Done,
     /*  740950 */   // Label 11631: @740950
     /*  740950 */   GIM_Try, /*On fail goto*//*Label 11632*/ GIMT_Encode4(741025), // Rule ID 12317 //
     /*  740955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  740966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  740969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  740972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741001 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  741004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741023 */     GIR_RootConstrainSelectedInstOperands,
     /*  741024 */     // GIR_Coverage, 12317,
     /*  741024 */     GIR_EraseRootFromParent_Done,
     /*  741025 */   // Label 11632: @741025
     /*  741025 */   GIM_Try, /*On fail goto*//*Label 11633*/ GIMT_Encode4(741100), // Rule ID 12320 //
     /*  741030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  741047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741076 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  741079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741098 */     GIR_RootConstrainSelectedInstOperands,
     /*  741099 */     // GIR_Coverage, 12320,
     /*  741099 */     GIR_EraseRootFromParent_Done,
     /*  741100 */   // Label 11633: @741100
     /*  741100 */   GIM_Try, /*On fail goto*//*Label 11634*/ GIMT_Encode4(741175), // Rule ID 12321 //
     /*  741105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  741122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741151 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  741154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741173 */     GIR_RootConstrainSelectedInstOperands,
     /*  741174 */     // GIR_Coverage, 12321,
     /*  741174 */     GIR_EraseRootFromParent_Done,
     /*  741175 */   // Label 11634: @741175
     /*  741175 */   GIM_Try, /*On fail goto*//*Label 11635*/ GIMT_Encode4(741250), // Rule ID 12324 //
     /*  741180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  741197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  741226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  741229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741248 */     GIR_RootConstrainSelectedInstOperands,
     /*  741249 */     // GIR_Coverage, 12324,
     /*  741249 */     GIR_EraseRootFromParent_Done,
     /*  741250 */   // Label 11635: @741250
     /*  741250 */   GIM_Try, /*On fail goto*//*Label 11636*/ GIMT_Encode4(741325), // Rule ID 12325 //
     /*  741255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  741272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741301 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  741301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  741304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741323 */     GIR_RootConstrainSelectedInstOperands,
     /*  741324 */     // GIR_Coverage, 12325,
     /*  741324 */     GIR_EraseRootFromParent_Done,
     /*  741325 */   // Label 11636: @741325
     /*  741325 */   GIM_Try, /*On fail goto*//*Label 11637*/ GIMT_Encode4(741400), // Rule ID 12328 //
     /*  741330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  741333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  741341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  741344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  741347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741376 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  741376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  741379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  741395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741398 */     GIR_RootConstrainSelectedInstOperands,
     /*  741399 */     // GIR_Coverage, 12328,
     /*  741399 */     GIR_EraseRootFromParent_Done,
     /*  741400 */   // Label 11637: @741400
     /*  741400 */   GIM_Try, /*On fail goto*//*Label 11638*/ GIMT_Encode4(741475), // Rule ID 12329 //
     /*  741405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  741408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  741416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  741419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  741422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741451 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  741451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  741454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  741470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741473 */     GIR_RootConstrainSelectedInstOperands,
     /*  741474 */     // GIR_Coverage, 12329,
     /*  741474 */     GIR_EraseRootFromParent_Done,
     /*  741475 */   // Label 11638: @741475
     /*  741475 */   GIM_Try, /*On fail goto*//*Label 11639*/ GIMT_Encode4(741550), // Rule ID 12332 //
     /*  741480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  741491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  741494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  741497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741526 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  741529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741548 */     GIR_RootConstrainSelectedInstOperands,
     /*  741549 */     // GIR_Coverage, 12332,
     /*  741549 */     GIR_EraseRootFromParent_Done,
     /*  741550 */   // Label 11639: @741550
     /*  741550 */   GIM_Try, /*On fail goto*//*Label 11640*/ GIMT_Encode4(741625), // Rule ID 12333 //
     /*  741555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  741566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  741569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  741572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741601 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  741604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741623 */     GIR_RootConstrainSelectedInstOperands,
     /*  741624 */     // GIR_Coverage, 12333,
     /*  741624 */     GIR_EraseRootFromParent_Done,
     /*  741625 */   // Label 11640: @741625
     /*  741625 */   GIM_Try, /*On fail goto*//*Label 11641*/ GIMT_Encode4(741700), // Rule ID 12336 //
     /*  741630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  741641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  741644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  741647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741676 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  741679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741698 */     GIR_RootConstrainSelectedInstOperands,
     /*  741699 */     // GIR_Coverage, 12336,
     /*  741699 */     GIR_EraseRootFromParent_Done,
     /*  741700 */   // Label 11641: @741700
     /*  741700 */   GIM_Try, /*On fail goto*//*Label 11642*/ GIMT_Encode4(741775), // Rule ID 12337 //
     /*  741705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  741716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  741719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  741722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741751 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  741754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741773 */     GIR_RootConstrainSelectedInstOperands,
     /*  741774 */     // GIR_Coverage, 12337,
     /*  741774 */     GIR_EraseRootFromParent_Done,
     /*  741775 */   // Label 11642: @741775
     /*  741775 */   GIM_Try, /*On fail goto*//*Label 11643*/ GIMT_Encode4(741850), // Rule ID 12340 //
     /*  741780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  741791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  741794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  741797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741826 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  741829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741848 */     GIR_RootConstrainSelectedInstOperands,
     /*  741849 */     // GIR_Coverage, 12340,
     /*  741849 */     GIR_EraseRootFromParent_Done,
     /*  741850 */   // Label 11643: @741850
     /*  741850 */   GIM_Try, /*On fail goto*//*Label 11644*/ GIMT_Encode4(741925), // Rule ID 12341 //
     /*  741855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  741866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  741869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  741872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741901 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  741904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741923 */     GIR_RootConstrainSelectedInstOperands,
     /*  741924 */     // GIR_Coverage, 12341,
     /*  741924 */     GIR_EraseRootFromParent_Done,
     /*  741925 */   // Label 11644: @741925
     /*  741925 */   GIM_Try, /*On fail goto*//*Label 11645*/ GIMT_Encode4(742000), // Rule ID 12344 //
     /*  741930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  741941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  741944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  741947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  741979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741998 */     GIR_RootConstrainSelectedInstOperands,
     /*  741999 */     // GIR_Coverage, 12344,
     /*  741999 */     GIR_EraseRootFromParent_Done,
     /*  742000 */   // Label 11645: @742000
     /*  742000 */   GIM_Try, /*On fail goto*//*Label 11646*/ GIMT_Encode4(742075), // Rule ID 12345 //
     /*  742005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  742016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  742019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  742022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742051 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  742054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742073 */     GIR_RootConstrainSelectedInstOperands,
     /*  742074 */     // GIR_Coverage, 12345,
     /*  742074 */     GIR_EraseRootFromParent_Done,
     /*  742075 */   // Label 11646: @742075
     /*  742075 */   GIM_Try, /*On fail goto*//*Label 11647*/ GIMT_Encode4(742150), // Rule ID 12348 //
     /*  742080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  742091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  742094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  742097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742126 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  742129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742148 */     GIR_RootConstrainSelectedInstOperands,
     /*  742149 */     // GIR_Coverage, 12348,
     /*  742149 */     GIR_EraseRootFromParent_Done,
     /*  742150 */   // Label 11647: @742150
     /*  742150 */   GIM_Try, /*On fail goto*//*Label 11648*/ GIMT_Encode4(742225), // Rule ID 12349 //
     /*  742155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  742166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  742169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  742172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742201 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  742204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742223 */     GIR_RootConstrainSelectedInstOperands,
     /*  742224 */     // GIR_Coverage, 12349,
     /*  742224 */     GIR_EraseRootFromParent_Done,
     /*  742225 */   // Label 11648: @742225
     /*  742225 */   GIM_Try, /*On fail goto*//*Label 11649*/ GIMT_Encode4(742300), // Rule ID 12352 //
     /*  742230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  742241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  742244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  742247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742276 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  742279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742298 */     GIR_RootConstrainSelectedInstOperands,
     /*  742299 */     // GIR_Coverage, 12352,
     /*  742299 */     GIR_EraseRootFromParent_Done,
     /*  742300 */   // Label 11649: @742300
     /*  742300 */   GIM_Try, /*On fail goto*//*Label 11650*/ GIMT_Encode4(742375), // Rule ID 12353 //
     /*  742305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  742316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  742319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  742322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742351 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  742354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742373 */     GIR_RootConstrainSelectedInstOperands,
     /*  742374 */     // GIR_Coverage, 12353,
     /*  742374 */     GIR_EraseRootFromParent_Done,
     /*  742375 */   // Label 11650: @742375
     /*  742375 */   GIM_Try, /*On fail goto*//*Label 11651*/ GIMT_Encode4(742450), // Rule ID 12356 //
     /*  742380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  742391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  742394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  742397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  742429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742448 */     GIR_RootConstrainSelectedInstOperands,
     /*  742449 */     // GIR_Coverage, 12356,
     /*  742449 */     GIR_EraseRootFromParent_Done,
     /*  742450 */   // Label 11651: @742450
     /*  742450 */   GIM_Try, /*On fail goto*//*Label 11652*/ GIMT_Encode4(742525), // Rule ID 12357 //
     /*  742455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  742466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  742469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  742472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  742504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742523 */     GIR_RootConstrainSelectedInstOperands,
     /*  742524 */     // GIR_Coverage, 12357,
     /*  742524 */     GIR_EraseRootFromParent_Done,
     /*  742525 */   // Label 11652: @742525
     /*  742525 */   GIM_Try, /*On fail goto*//*Label 11653*/ GIMT_Encode4(742600), // Rule ID 12360 //
     /*  742530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  742541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  742544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  742547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742576 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  742579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742598 */     GIR_RootConstrainSelectedInstOperands,
     /*  742599 */     // GIR_Coverage, 12360,
     /*  742599 */     GIR_EraseRootFromParent_Done,
     /*  742600 */   // Label 11653: @742600
     /*  742600 */   GIM_Try, /*On fail goto*//*Label 11654*/ GIMT_Encode4(742675), // Rule ID 12361 //
     /*  742605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  742616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  742619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  742622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742651 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  742654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742673 */     GIR_RootConstrainSelectedInstOperands,
     /*  742674 */     // GIR_Coverage, 12361,
     /*  742674 */     GIR_EraseRootFromParent_Done,
     /*  742675 */   // Label 11654: @742675
     /*  742675 */   GIM_Try, /*On fail goto*//*Label 11655*/ GIMT_Encode4(742750), // Rule ID 12364 //
     /*  742680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  742691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  742694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  742697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742726 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  742729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742748 */     GIR_RootConstrainSelectedInstOperands,
     /*  742749 */     // GIR_Coverage, 12364,
     /*  742749 */     GIR_EraseRootFromParent_Done,
     /*  742750 */   // Label 11655: @742750
     /*  742750 */   GIM_Try, /*On fail goto*//*Label 11656*/ GIMT_Encode4(742825), // Rule ID 12365 //
     /*  742755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  742766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  742769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  742772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742801 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  742804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742823 */     GIR_RootConstrainSelectedInstOperands,
     /*  742824 */     // GIR_Coverage, 12365,
     /*  742824 */     GIR_EraseRootFromParent_Done,
     /*  742825 */   // Label 11656: @742825
     /*  742825 */   GIM_Try, /*On fail goto*//*Label 11657*/ GIMT_Encode4(742900), // Rule ID 12368 //
     /*  742830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  742841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  742844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  742847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  742876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  742879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742898 */     GIR_RootConstrainSelectedInstOperands,
     /*  742899 */     // GIR_Coverage, 12368,
     /*  742899 */     GIR_EraseRootFromParent_Done,
     /*  742900 */   // Label 11657: @742900
     /*  742900 */   GIM_Try, /*On fail goto*//*Label 11658*/ GIMT_Encode4(742975), // Rule ID 12369 //
     /*  742905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  742908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  742916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  742919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  742922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11568:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  742951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  742954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742973 */     GIR_RootConstrainSelectedInstOperands,
     /*  742974 */     // GIR_Coverage, 12369,
     /*  742974 */     GIR_EraseRootFromParent_Done,
     /*  742975 */   // Label 11658: @742975
     /*  742975 */   GIM_Try, /*On fail goto*//*Label 11659*/ GIMT_Encode4(743050), // Rule ID 12372 //
     /*  742980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  742991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  742994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  742997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743026 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  743026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  743029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743048 */     GIR_RootConstrainSelectedInstOperands,
     /*  743049 */     // GIR_Coverage, 12372,
     /*  743049 */     GIR_EraseRootFromParent_Done,
     /*  743050 */   // Label 11659: @743050
     /*  743050 */   GIM_Try, /*On fail goto*//*Label 11660*/ GIMT_Encode4(743125), // Rule ID 12373 //
     /*  743055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  743058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  743066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  743069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  743072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  743075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743101 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11568:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  743101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  743104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743123 */     GIR_RootConstrainSelectedInstOperands,
     /*  743124 */     // GIR_Coverage, 12373,
     /*  743124 */     GIR_EraseRootFromParent_Done,
     /*  743125 */   // Label 11660: @743125
     /*  743125 */   GIM_Try, /*On fail goto*//*Label 11661*/ GIMT_Encode4(743200), // Rule ID 12376 //
     /*  743130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  743133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  743141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  743144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  743147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  743176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  743179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743198 */     GIR_RootConstrainSelectedInstOperands,
     /*  743199 */     // GIR_Coverage, 12376,
     /*  743199 */     GIR_EraseRootFromParent_Done,
     /*  743200 */   // Label 11661: @743200
     /*  743200 */   GIM_Try, /*On fail goto*//*Label 11662*/ GIMT_Encode4(743275), // Rule ID 12377 //
     /*  743205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  743208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  743216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  743219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  743222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  743225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743251 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11568:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  743251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  743254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743273 */     GIR_RootConstrainSelectedInstOperands,
     /*  743274 */     // GIR_Coverage, 12377,
     /*  743274 */     GIR_EraseRootFromParent_Done,
     /*  743275 */   // Label 11662: @743275
     /*  743275 */   GIM_Try, /*On fail goto*//*Label 11663*/ GIMT_Encode4(743350), // Rule ID 12380 //
     /*  743280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  743291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  743294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  743297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  743300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743326 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  743329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743348 */     GIR_RootConstrainSelectedInstOperands,
     /*  743349 */     // GIR_Coverage, 12380,
     /*  743349 */     GIR_EraseRootFromParent_Done,
     /*  743350 */   // Label 11663: @743350
     /*  743350 */   GIM_Try, /*On fail goto*//*Label 11664*/ GIMT_Encode4(743425), // Rule ID 12381 //
     /*  743355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  743366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  743369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  743372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  743375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743401 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  743404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743423 */     GIR_RootConstrainSelectedInstOperands,
     /*  743424 */     // GIR_Coverage, 12381,
     /*  743424 */     GIR_EraseRootFromParent_Done,
     /*  743425 */   // Label 11664: @743425
     /*  743425 */   GIM_Try, /*On fail goto*//*Label 11665*/ GIMT_Encode4(743500), // Rule ID 12384 //
     /*  743430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  743441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  743444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  743447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  743450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743476 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743498 */     GIR_RootConstrainSelectedInstOperands,
     /*  743499 */     // GIR_Coverage, 12384,
     /*  743499 */     GIR_EraseRootFromParent_Done,
     /*  743500 */   // Label 11665: @743500
     /*  743500 */   GIM_Try, /*On fail goto*//*Label 11666*/ GIMT_Encode4(743575), // Rule ID 12385 //
     /*  743505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  743516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  743519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  743522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  743525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743551 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743573 */     GIR_RootConstrainSelectedInstOperands,
     /*  743574 */     // GIR_Coverage, 12385,
     /*  743574 */     GIR_EraseRootFromParent_Done,
     /*  743575 */   // Label 11666: @743575
     /*  743575 */   GIM_Try, /*On fail goto*//*Label 11667*/ GIMT_Encode4(743650), // Rule ID 12388 //
     /*  743580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  743597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  743600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743648 */     GIR_RootConstrainSelectedInstOperands,
     /*  743649 */     // GIR_Coverage, 12388,
     /*  743649 */     GIR_EraseRootFromParent_Done,
     /*  743650 */   // Label 11667: @743650
     /*  743650 */   GIM_Try, /*On fail goto*//*Label 11668*/ GIMT_Encode4(743725), // Rule ID 12389 //
     /*  743655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  743672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  743675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743701 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743723 */     GIR_RootConstrainSelectedInstOperands,
     /*  743724 */     // GIR_Coverage, 12389,
     /*  743724 */     GIR_EraseRootFromParent_Done,
     /*  743725 */   // Label 11668: @743725
     /*  743725 */   GIM_Try, /*On fail goto*//*Label 11669*/ GIMT_Encode4(743800), // Rule ID 12392 //
     /*  743730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  743741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  743744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  743747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  743750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  743779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743798 */     GIR_RootConstrainSelectedInstOperands,
     /*  743799 */     // GIR_Coverage, 12392,
     /*  743799 */     GIR_EraseRootFromParent_Done,
     /*  743800 */   // Label 11669: @743800
     /*  743800 */   GIM_Try, /*On fail goto*//*Label 11670*/ GIMT_Encode4(743875), // Rule ID 12393 //
     /*  743805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  743816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  743819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  743822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  743825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  743854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743873 */     GIR_RootConstrainSelectedInstOperands,
     /*  743874 */     // GIR_Coverage, 12393,
     /*  743874 */     GIR_EraseRootFromParent_Done,
     /*  743875 */   // Label 11670: @743875
     /*  743875 */   GIM_Try, /*On fail goto*//*Label 11671*/ GIMT_Encode4(743950), // Rule ID 12396 //
     /*  743880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  743891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  743894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  743897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  743900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  743929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743948 */     GIR_RootConstrainSelectedInstOperands,
     /*  743949 */     // GIR_Coverage, 12396,
     /*  743949 */     GIR_EraseRootFromParent_Done,
     /*  743950 */   // Label 11671: @743950
     /*  743950 */   GIM_Try, /*On fail goto*//*Label 11672*/ GIMT_Encode4(744025), // Rule ID 12397 //
     /*  743955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  743966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  743969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  743972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  743975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744001 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  744001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744023 */     GIR_RootConstrainSelectedInstOperands,
     /*  744024 */     // GIR_Coverage, 12397,
     /*  744024 */     GIR_EraseRootFromParent_Done,
     /*  744025 */   // Label 11672: @744025
     /*  744025 */   GIM_Try, /*On fail goto*//*Label 11673*/ GIMT_Encode4(744100), // Rule ID 12400 //
     /*  744030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  744041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  744044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  744047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  744050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744076 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  744076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744098 */     GIR_RootConstrainSelectedInstOperands,
     /*  744099 */     // GIR_Coverage, 12400,
     /*  744099 */     GIR_EraseRootFromParent_Done,
     /*  744100 */   // Label 11673: @744100
     /*  744100 */   GIM_Try, /*On fail goto*//*Label 11674*/ GIMT_Encode4(744175), // Rule ID 12401 //
     /*  744105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  744116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  744119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  744122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  744125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744151 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  744151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744173 */     GIR_RootConstrainSelectedInstOperands,
     /*  744174 */     // GIR_Coverage, 12401,
     /*  744174 */     GIR_EraseRootFromParent_Done,
     /*  744175 */   // Label 11674: @744175
     /*  744175 */   GIM_Try, /*On fail goto*//*Label 11675*/ GIMT_Encode4(744250), // Rule ID 12404 //
     /*  744180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  744191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  744194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  744197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  744200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744226 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  744229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744248 */     GIR_RootConstrainSelectedInstOperands,
     /*  744249 */     // GIR_Coverage, 12404,
     /*  744249 */     GIR_EraseRootFromParent_Done,
     /*  744250 */   // Label 11675: @744250
     /*  744250 */   GIM_Try, /*On fail goto*//*Label 11676*/ GIMT_Encode4(744325), // Rule ID 12405 //
     /*  744255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  744266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  744269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  744272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  744275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744301 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  744304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744323 */     GIR_RootConstrainSelectedInstOperands,
     /*  744324 */     // GIR_Coverage, 12405,
     /*  744324 */     GIR_EraseRootFromParent_Done,
     /*  744325 */   // Label 11676: @744325
     /*  744325 */   GIM_Try, /*On fail goto*//*Label 11677*/ GIMT_Encode4(744400), // Rule ID 12408 //
     /*  744330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  744341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  744344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  744347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  744350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744376 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11710:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  744379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744398 */     GIR_RootConstrainSelectedInstOperands,
     /*  744399 */     // GIR_Coverage, 12408,
     /*  744399 */     GIR_EraseRootFromParent_Done,
     /*  744400 */   // Label 11677: @744400
     /*  744400 */   GIM_Try, /*On fail goto*//*Label 11678*/ GIMT_Encode4(744475), // Rule ID 12409 //
     /*  744405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  744416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  744419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  744422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  744425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744451 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11710:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  744454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744473 */     GIR_RootConstrainSelectedInstOperands,
     /*  744474 */     // GIR_Coverage, 12409,
     /*  744474 */     GIR_EraseRootFromParent_Done,
     /*  744475 */   // Label 11678: @744475
     /*  744475 */   GIM_Try, /*On fail goto*//*Label 11679*/ GIMT_Encode4(744550), // Rule ID 12412 //
     /*  744480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  744491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  744494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744548 */     GIR_RootConstrainSelectedInstOperands,
     /*  744549 */     // GIR_Coverage, 12412,
     /*  744549 */     GIR_EraseRootFromParent_Done,
     /*  744550 */   // Label 11679: @744550
     /*  744550 */   GIM_Try, /*On fail goto*//*Label 11680*/ GIMT_Encode4(744625), // Rule ID 12413 //
     /*  744555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  744566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  744569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744623 */     GIR_RootConstrainSelectedInstOperands,
     /*  744624 */     // GIR_Coverage, 12413,
     /*  744624 */     GIR_EraseRootFromParent_Done,
     /*  744625 */   // Label 11680: @744625
     /*  744625 */   GIM_Try, /*On fail goto*//*Label 11681*/ GIMT_Encode4(744700), // Rule ID 12416 //
     /*  744630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  744641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  744644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  744647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  744650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744676 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744698 */     GIR_RootConstrainSelectedInstOperands,
     /*  744699 */     // GIR_Coverage, 12416,
     /*  744699 */     GIR_EraseRootFromParent_Done,
     /*  744700 */   // Label 11681: @744700
     /*  744700 */   GIM_Try, /*On fail goto*//*Label 11682*/ GIMT_Encode4(744775), // Rule ID 12417 //
     /*  744705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  744716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  744719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  744722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  744725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744751 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744773 */     GIR_RootConstrainSelectedInstOperands,
     /*  744774 */     // GIR_Coverage, 12417,
     /*  744774 */     GIR_EraseRootFromParent_Done,
     /*  744775 */   // Label 11682: @744775
     /*  744775 */   GIM_Try, /*On fail goto*//*Label 11683*/ GIMT_Encode4(744850), // Rule ID 12420 //
     /*  744780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  744791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  744794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  744797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  744800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744826 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744848 */     GIR_RootConstrainSelectedInstOperands,
     /*  744849 */     // GIR_Coverage, 12420,
     /*  744849 */     GIR_EraseRootFromParent_Done,
     /*  744850 */   // Label 11683: @744850
     /*  744850 */   GIM_Try, /*On fail goto*//*Label 11684*/ GIMT_Encode4(744925), // Rule ID 12421 //
     /*  744855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  744866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  744869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  744872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  744875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744901 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744923 */     GIR_RootConstrainSelectedInstOperands,
     /*  744924 */     // GIR_Coverage, 12421,
     /*  744924 */     GIR_EraseRootFromParent_Done,
     /*  744925 */   // Label 11684: @744925
     /*  744925 */   GIM_Try, /*On fail goto*//*Label 11685*/ GIMT_Encode4(745000), // Rule ID 12424 //
     /*  744930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  744947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  744950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  744979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744998 */     GIR_RootConstrainSelectedInstOperands,
     /*  744999 */     // GIR_Coverage, 12424,
     /*  744999 */     GIR_EraseRootFromParent_Done,
     /*  745000 */   // Label 11685: @745000
     /*  745000 */   GIM_Try, /*On fail goto*//*Label 11686*/ GIMT_Encode4(745075), // Rule ID 12425 //
     /*  745005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  745008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  745016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  745019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  745022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  745025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745051 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  745054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745073 */     GIR_RootConstrainSelectedInstOperands,
     /*  745074 */     // GIR_Coverage, 12425,
     /*  745074 */     GIR_EraseRootFromParent_Done,
     /*  745075 */   // Label 11686: @745075
     /*  745075 */   GIM_Try, /*On fail goto*//*Label 11687*/ GIMT_Encode4(745150), // Rule ID 12428 //
     /*  745080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  745083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  745091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  745094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  745097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  745100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745126 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  745126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  745129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745148 */     GIR_RootConstrainSelectedInstOperands,
     /*  745149 */     // GIR_Coverage, 12428,
     /*  745149 */     GIR_EraseRootFromParent_Done,
     /*  745150 */   // Label 11687: @745150
     /*  745150 */   GIM_Try, /*On fail goto*//*Label 11688*/ GIMT_Encode4(745225), // Rule ID 12429 //
     /*  745155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  745158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  745166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  745169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  745172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  745175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745201 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  745204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745223 */     GIR_RootConstrainSelectedInstOperands,
     /*  745224 */     // GIR_Coverage, 12429,
     /*  745224 */     GIR_EraseRootFromParent_Done,
     /*  745225 */   // Label 11688: @745225
     /*  745225 */   GIM_Try, /*On fail goto*//*Label 11689*/ GIMT_Encode4(745300), // Rule ID 12432 //
     /*  745230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  745233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  745241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  745244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  745247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  745250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745276 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  745276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  745279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745298 */     GIR_RootConstrainSelectedInstOperands,
     /*  745299 */     // GIR_Coverage, 12432,
     /*  745299 */     GIR_EraseRootFromParent_Done,
     /*  745300 */   // Label 11689: @745300
     /*  745300 */   GIM_Try, /*On fail goto*//*Label 11690*/ GIMT_Encode4(745375), // Rule ID 12433 //
     /*  745305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  745308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  745316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  745319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  745322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  745325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745351 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  745354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745373 */     GIR_RootConstrainSelectedInstOperands,
     /*  745374 */     // GIR_Coverage, 12433,
     /*  745374 */     GIR_EraseRootFromParent_Done,
     /*  745375 */   // Label 11690: @745375
     /*  745375 */   GIM_Try, /*On fail goto*//*Label 11691*/ GIMT_Encode4(745450), // Rule ID 12436 //
     /*  745380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  745383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  745391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  745394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  745397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  745400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745426 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  745426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  745429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745448 */     GIR_RootConstrainSelectedInstOperands,
     /*  745449 */     // GIR_Coverage, 12436,
     /*  745449 */     GIR_EraseRootFromParent_Done,
     /*  745450 */   // Label 11691: @745450
     /*  745450 */   GIM_Try, /*On fail goto*//*Label 11692*/ GIMT_Encode4(745525), // Rule ID 12437 //
     /*  745455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  745458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  745466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  745469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  745472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  745475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745501 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  745504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745523 */     GIR_RootConstrainSelectedInstOperands,
     /*  745524 */     // GIR_Coverage, 12437,
     /*  745524 */     GIR_EraseRootFromParent_Done,
     /*  745525 */   // Label 11692: @745525
     /*  745525 */   GIM_Try, /*On fail goto*//*Label 11693*/ GIMT_Encode4(745600), // Rule ID 12440 //
     /*  745530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  745541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  745544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  745547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745576 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  745579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745598 */     GIR_RootConstrainSelectedInstOperands,
     /*  745599 */     // GIR_Coverage, 12440,
     /*  745599 */     GIR_EraseRootFromParent_Done,
     /*  745600 */   // Label 11693: @745600
     /*  745600 */   GIM_Try, /*On fail goto*//*Label 11694*/ GIMT_Encode4(745675), // Rule ID 12441 //
     /*  745605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  745616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  745619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  745622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745651 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  745654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745673 */     GIR_RootConstrainSelectedInstOperands,
     /*  745674 */     // GIR_Coverage, 12441,
     /*  745674 */     GIR_EraseRootFromParent_Done,
     /*  745675 */   // Label 11694: @745675
     /*  745675 */   GIM_Try, /*On fail goto*//*Label 11695*/ GIMT_Encode4(745750), // Rule ID 12444 //
     /*  745680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  745691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  745694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  745697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  745729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745748 */     GIR_RootConstrainSelectedInstOperands,
     /*  745749 */     // GIR_Coverage, 12444,
     /*  745749 */     GIR_EraseRootFromParent_Done,
     /*  745750 */   // Label 11695: @745750
     /*  745750 */   GIM_Try, /*On fail goto*//*Label 11696*/ GIMT_Encode4(745825), // Rule ID 12445 //
     /*  745755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  745766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  745769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  745772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745801 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  745804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745823 */     GIR_RootConstrainSelectedInstOperands,
     /*  745824 */     // GIR_Coverage, 12445,
     /*  745824 */     GIR_EraseRootFromParent_Done,
     /*  745825 */   // Label 11696: @745825
     /*  745825 */   GIM_Try, /*On fail goto*//*Label 11697*/ GIMT_Encode4(745900), // Rule ID 12448 //
     /*  745830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  745841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  745844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  745847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  745879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745898 */     GIR_RootConstrainSelectedInstOperands,
     /*  745899 */     // GIR_Coverage, 12448,
     /*  745899 */     GIR_EraseRootFromParent_Done,
     /*  745900 */   // Label 11697: @745900
     /*  745900 */   GIM_Try, /*On fail goto*//*Label 11698*/ GIMT_Encode4(745975), // Rule ID 12449 //
     /*  745905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  745916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  745919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  745922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745951 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  745954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745973 */     GIR_RootConstrainSelectedInstOperands,
     /*  745974 */     // GIR_Coverage, 12449,
     /*  745974 */     GIR_EraseRootFromParent_Done,
     /*  745975 */   // Label 11698: @745975
     /*  745975 */   GIM_Try, /*On fail goto*//*Label 11699*/ GIMT_Encode4(746050), // Rule ID 12452 //
     /*  745980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  745991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  745994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  745997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746026 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746048 */     GIR_RootConstrainSelectedInstOperands,
     /*  746049 */     // GIR_Coverage, 12452,
     /*  746049 */     GIR_EraseRootFromParent_Done,
     /*  746050 */   // Label 11699: @746050
     /*  746050 */   GIM_Try, /*On fail goto*//*Label 11700*/ GIMT_Encode4(746125), // Rule ID 12453 //
     /*  746055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  746066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  746069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  746072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  746101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746123 */     GIR_RootConstrainSelectedInstOperands,
     /*  746124 */     // GIR_Coverage, 12453,
     /*  746124 */     GIR_EraseRootFromParent_Done,
     /*  746125 */   // Label 11700: @746125
     /*  746125 */   GIM_Try, /*On fail goto*//*Label 11701*/ GIMT_Encode4(746200), // Rule ID 12456 //
     /*  746130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  746141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  746144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  746147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746176 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746198 */     GIR_RootConstrainSelectedInstOperands,
     /*  746199 */     // GIR_Coverage, 12456,
     /*  746199 */     GIR_EraseRootFromParent_Done,
     /*  746200 */   // Label 11701: @746200
     /*  746200 */   GIM_Try, /*On fail goto*//*Label 11702*/ GIMT_Encode4(746275), // Rule ID 12457 //
     /*  746205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  746216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  746219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  746222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746251 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  746251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746273 */     GIR_RootConstrainSelectedInstOperands,
     /*  746274 */     // GIR_Coverage, 12457,
     /*  746274 */     GIR_EraseRootFromParent_Done,
     /*  746275 */   // Label 11702: @746275
     /*  746275 */   GIM_Try, /*On fail goto*//*Label 11703*/ GIMT_Encode4(746350), // Rule ID 12460 //
     /*  746280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  746291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  746294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  746297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  746329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746348 */     GIR_RootConstrainSelectedInstOperands,
     /*  746349 */     // GIR_Coverage, 12460,
     /*  746349 */     GIR_EraseRootFromParent_Done,
     /*  746350 */   // Label 11703: @746350
     /*  746350 */   GIM_Try, /*On fail goto*//*Label 11704*/ GIMT_Encode4(746425), // Rule ID 12461 //
     /*  746355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  746366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  746369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  746372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746401 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  746401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  746404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746423 */     GIR_RootConstrainSelectedInstOperands,
     /*  746424 */     // GIR_Coverage, 12461,
     /*  746424 */     GIR_EraseRootFromParent_Done,
     /*  746425 */   // Label 11704: @746425
     /*  746425 */   GIM_Try, /*On fail goto*//*Label 11705*/ GIMT_Encode4(746500), // Rule ID 12464 //
     /*  746430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  746441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  746444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  746447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746476 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  746479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746498 */     GIR_RootConstrainSelectedInstOperands,
     /*  746499 */     // GIR_Coverage, 12464,
     /*  746499 */     GIR_EraseRootFromParent_Done,
     /*  746500 */   // Label 11705: @746500
     /*  746500 */   GIM_Try, /*On fail goto*//*Label 11706*/ GIMT_Encode4(746575), // Rule ID 12465 //
     /*  746505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  746516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  746519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  746522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746551 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  746554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746573 */     GIR_RootConstrainSelectedInstOperands,
     /*  746574 */     // GIR_Coverage, 12465,
     /*  746574 */     GIR_EraseRootFromParent_Done,
     /*  746575 */   // Label 11706: @746575
     /*  746575 */   GIM_Try, /*On fail goto*//*Label 11707*/ GIMT_Encode4(746650), // Rule ID 12468 //
     /*  746580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  746591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  746594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  746597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11710:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746648 */     GIR_RootConstrainSelectedInstOperands,
     /*  746649 */     // GIR_Coverage, 12468,
     /*  746649 */     GIR_EraseRootFromParent_Done,
     /*  746650 */   // Label 11707: @746650
     /*  746650 */   GIM_Try, /*On fail goto*//*Label 11708*/ GIMT_Encode4(746725), // Rule ID 12469 //
     /*  746655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  746666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  746669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  746672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746701 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11710:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746723 */     GIR_RootConstrainSelectedInstOperands,
     /*  746724 */     // GIR_Coverage, 12469,
     /*  746724 */     GIR_EraseRootFromParent_Done,
     /*  746725 */   // Label 11708: @746725
     /*  746725 */   GIM_Try, /*On fail goto*//*Label 11709*/ GIMT_Encode4(746800), // Rule ID 12472 //
     /*  746730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  746741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  746744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  746747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746798 */     GIR_RootConstrainSelectedInstOperands,
     /*  746799 */     // GIR_Coverage, 12472,
     /*  746799 */     GIR_EraseRootFromParent_Done,
     /*  746800 */   // Label 11709: @746800
     /*  746800 */   GIM_Try, /*On fail goto*//*Label 11710*/ GIMT_Encode4(746875), // Rule ID 12473 //
     /*  746805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  746816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  746819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  746822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746873 */     GIR_RootConstrainSelectedInstOperands,
     /*  746874 */     // GIR_Coverage, 12473,
     /*  746874 */     GIR_EraseRootFromParent_Done,
     /*  746875 */   // Label 11710: @746875
     /*  746875 */   GIM_Try, /*On fail goto*//*Label 11711*/ GIMT_Encode4(746950), // Rule ID 12476 //
     /*  746880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  746891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  746894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  746897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746948 */     GIR_RootConstrainSelectedInstOperands,
     /*  746949 */     // GIR_Coverage, 12476,
     /*  746949 */     GIR_EraseRootFromParent_Done,
     /*  746950 */   // Label 11711: @746950
     /*  746950 */   GIM_Try, /*On fail goto*//*Label 11712*/ GIMT_Encode4(747025), // Rule ID 12477 //
     /*  746955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  746966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  746969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  746972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747001 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  747001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  747004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747023 */     GIR_RootConstrainSelectedInstOperands,
     /*  747024 */     // GIR_Coverage, 12477,
     /*  747024 */     GIR_EraseRootFromParent_Done,
     /*  747025 */   // Label 11712: @747025
     /*  747025 */   GIM_Try, /*On fail goto*//*Label 11713*/ GIMT_Encode4(747100), // Rule ID 12480 //
     /*  747030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  747041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  747044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  747047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  747076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  747079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747098 */     GIR_RootConstrainSelectedInstOperands,
     /*  747099 */     // GIR_Coverage, 12480,
     /*  747099 */     GIR_EraseRootFromParent_Done,
     /*  747100 */   // Label 11713: @747100
     /*  747100 */   GIM_Try, /*On fail goto*//*Label 11714*/ GIMT_Encode4(747175), // Rule ID 12481 //
     /*  747105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  747116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  747119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  747122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747151 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  747151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  747154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747173 */     GIR_RootConstrainSelectedInstOperands,
     /*  747174 */     // GIR_Coverage, 12481,
     /*  747174 */     GIR_EraseRootFromParent_Done,
     /*  747175 */   // Label 11714: @747175
     /*  747175 */   GIM_Try, /*On fail goto*//*Label 11715*/ GIMT_Encode4(747250), // Rule ID 12484 //
     /*  747180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  747183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  747191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  747194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  747197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  747229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747248 */     GIR_RootConstrainSelectedInstOperands,
     /*  747249 */     // GIR_Coverage, 12484,
     /*  747249 */     GIR_EraseRootFromParent_Done,
     /*  747250 */   // Label 11715: @747250
     /*  747250 */   GIM_Try, /*On fail goto*//*Label 11716*/ GIMT_Encode4(747325), // Rule ID 12485 //
     /*  747255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  747258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  747266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  747269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  747272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747301 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  747304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747323 */     GIR_RootConstrainSelectedInstOperands,
     /*  747324 */     // GIR_Coverage, 12485,
     /*  747324 */     GIR_EraseRootFromParent_Done,
     /*  747325 */   // Label 11716: @747325
     /*  747325 */   GIM_Try, /*On fail goto*//*Label 11717*/ GIMT_Encode4(747400), // Rule ID 12488 //
     /*  747330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  747333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  747341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  747344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  747347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  747379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747398 */     GIR_RootConstrainSelectedInstOperands,
     /*  747399 */     // GIR_Coverage, 12488,
     /*  747399 */     GIR_EraseRootFromParent_Done,
     /*  747400 */   // Label 11717: @747400
     /*  747400 */   GIM_Try, /*On fail goto*//*Label 11718*/ GIMT_Encode4(747475), // Rule ID 12489 //
     /*  747405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  747408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  747416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  747419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  747422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  747454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747473 */     GIR_RootConstrainSelectedInstOperands,
     /*  747474 */     // GIR_Coverage, 12489,
     /*  747474 */     GIR_EraseRootFromParent_Done,
     /*  747475 */   // Label 11718: @747475
     /*  747475 */   GIM_Try, /*On fail goto*//*Label 11719*/ GIMT_Encode4(747550), // Rule ID 12492 //
     /*  747480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  747483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  747491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  747494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  747497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747526 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  747529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747548 */     GIR_RootConstrainSelectedInstOperands,
     /*  747549 */     // GIR_Coverage, 12492,
     /*  747549 */     GIR_EraseRootFromParent_Done,
     /*  747550 */   // Label 11719: @747550
     /*  747550 */   GIM_Try, /*On fail goto*//*Label 11720*/ GIMT_Encode4(747625), // Rule ID 12493 //
     /*  747555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  747558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  747566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  747569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  747572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747601 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  747604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747623 */     GIR_RootConstrainSelectedInstOperands,
     /*  747624 */     // GIR_Coverage, 12493,
     /*  747624 */     GIR_EraseRootFromParent_Done,
     /*  747625 */   // Label 11720: @747625
     /*  747625 */   GIM_Try, /*On fail goto*//*Label 11721*/ GIMT_Encode4(747700), // Rule ID 12496 //
     /*  747630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  747633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  747641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  747644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  747647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  747679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747698 */     GIR_RootConstrainSelectedInstOperands,
     /*  747699 */     // GIR_Coverage, 12496,
     /*  747699 */     GIR_EraseRootFromParent_Done,
     /*  747700 */   // Label 11721: @747700
     /*  747700 */   GIM_Try, /*On fail goto*//*Label 11722*/ GIMT_Encode4(747775), // Rule ID 12497 //
     /*  747705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  747708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  747716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  747719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  747722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747751 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  747754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747773 */     GIR_RootConstrainSelectedInstOperands,
     /*  747774 */     // GIR_Coverage, 12497,
     /*  747774 */     GIR_EraseRootFromParent_Done,
     /*  747775 */   // Label 11722: @747775
     /*  747775 */   GIM_Try, /*On fail goto*//*Label 11723*/ GIMT_Encode4(747850), // Rule ID 12500 //
     /*  747780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  747791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  747794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  747797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  747800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747826 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  747829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747848 */     GIR_RootConstrainSelectedInstOperands,
     /*  747849 */     // GIR_Coverage, 12500,
     /*  747849 */     GIR_EraseRootFromParent_Done,
     /*  747850 */   // Label 11723: @747850
     /*  747850 */   GIM_Try, /*On fail goto*//*Label 11724*/ GIMT_Encode4(747925), // Rule ID 12501 //
     /*  747855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  747866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  747869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  747872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  747875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747901 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  747904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747923 */     GIR_RootConstrainSelectedInstOperands,
     /*  747924 */     // GIR_Coverage, 12501,
     /*  747924 */     GIR_EraseRootFromParent_Done,
     /*  747925 */   // Label 11724: @747925
     /*  747925 */   GIM_Try, /*On fail goto*//*Label 11725*/ GIMT_Encode4(748000), // Rule ID 12504 //
     /*  747930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  747941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  747944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  747947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  747950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747976 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  747979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747998 */     GIR_RootConstrainSelectedInstOperands,
     /*  747999 */     // GIR_Coverage, 12504,
     /*  747999 */     GIR_EraseRootFromParent_Done,
     /*  748000 */   // Label 11725: @748000
     /*  748000 */   GIM_Try, /*On fail goto*//*Label 11726*/ GIMT_Encode4(748075), // Rule ID 12505 //
     /*  748005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  748016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  748019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  748022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  748025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748051 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  748054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748073 */     GIR_RootConstrainSelectedInstOperands,
     /*  748074 */     // GIR_Coverage, 12505,
     /*  748074 */     GIR_EraseRootFromParent_Done,
     /*  748075 */   // Label 11726: @748075
     /*  748075 */   GIM_Try, /*On fail goto*//*Label 11727*/ GIMT_Encode4(748150), // Rule ID 12508 //
     /*  748080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  748091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  748094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  748097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  748100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748126 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  748126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748148 */     GIR_RootConstrainSelectedInstOperands,
     /*  748149 */     // GIR_Coverage, 12508,
     /*  748149 */     GIR_EraseRootFromParent_Done,
     /*  748150 */   // Label 11727: @748150
     /*  748150 */   GIM_Try, /*On fail goto*//*Label 11728*/ GIMT_Encode4(748225), // Rule ID 12509 //
     /*  748155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  748166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  748169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  748172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  748175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748201 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748223 */     GIR_RootConstrainSelectedInstOperands,
     /*  748224 */     // GIR_Coverage, 12509,
     /*  748224 */     GIR_EraseRootFromParent_Done,
     /*  748225 */   // Label 11728: @748225
     /*  748225 */   GIM_Try, /*On fail goto*//*Label 11729*/ GIMT_Encode4(748300), // Rule ID 12512 //
     /*  748230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  748241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  748244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  748247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  748250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  748276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  748279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748298 */     GIR_RootConstrainSelectedInstOperands,
     /*  748299 */     // GIR_Coverage, 12512,
     /*  748299 */     GIR_EraseRootFromParent_Done,
     /*  748300 */   // Label 11729: @748300
     /*  748300 */   GIM_Try, /*On fail goto*//*Label 11730*/ GIMT_Encode4(748375), // Rule ID 12513 //
     /*  748305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  748316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  748319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  748322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  748325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748351 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  748354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748373 */     GIR_RootConstrainSelectedInstOperands,
     /*  748374 */     // GIR_Coverage, 12513,
     /*  748374 */     GIR_EraseRootFromParent_Done,
     /*  748375 */   // Label 11730: @748375
     /*  748375 */   GIM_Try, /*On fail goto*//*Label 11731*/ GIMT_Encode4(748450), // Rule ID 12516 //
     /*  748380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  748391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  748394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  748397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  748400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748426 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  748426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748448 */     GIR_RootConstrainSelectedInstOperands,
     /*  748449 */     // GIR_Coverage, 12516,
     /*  748449 */     GIR_EraseRootFromParent_Done,
     /*  748450 */   // Label 11731: @748450
     /*  748450 */   GIM_Try, /*On fail goto*//*Label 11732*/ GIMT_Encode4(748525), // Rule ID 12517 //
     /*  748455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  748466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  748469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  748472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  748475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748501 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748523 */     GIR_RootConstrainSelectedInstOperands,
     /*  748524 */     // GIR_Coverage, 12517,
     /*  748524 */     GIR_EraseRootFromParent_Done,
     /*  748525 */   // Label 11732: @748525
     /*  748525 */   GIM_Try, /*On fail goto*//*Label 11733*/ GIMT_Encode4(748600), // Rule ID 12520 //
     /*  748530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  748541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  748544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  748547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  748550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748576 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  748576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748598 */     GIR_RootConstrainSelectedInstOperands,
     /*  748599 */     // GIR_Coverage, 12520,
     /*  748599 */     GIR_EraseRootFromParent_Done,
     /*  748600 */   // Label 11733: @748600
     /*  748600 */   GIM_Try, /*On fail goto*//*Label 11734*/ GIMT_Encode4(748675), // Rule ID 12521 //
     /*  748605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  748616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  748619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  748622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  748625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748651 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748673 */     GIR_RootConstrainSelectedInstOperands,
     /*  748674 */     // GIR_Coverage, 12521,
     /*  748674 */     GIR_EraseRootFromParent_Done,
     /*  748675 */   // Label 11734: @748675
     /*  748675 */   GIM_Try, /*On fail goto*//*Label 11735*/ GIMT_Encode4(748750), // Rule ID 12524 //
     /*  748680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  748691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  748694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  748697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  748700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748726 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  748729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748748 */     GIR_RootConstrainSelectedInstOperands,
     /*  748749 */     // GIR_Coverage, 12524,
     /*  748749 */     GIR_EraseRootFromParent_Done,
     /*  748750 */   // Label 11735: @748750
     /*  748750 */   GIM_Try, /*On fail goto*//*Label 11736*/ GIMT_Encode4(748825), // Rule ID 12525 //
     /*  748755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  748766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  748769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  748772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  748775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748801 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  748804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748823 */     GIR_RootConstrainSelectedInstOperands,
     /*  748824 */     // GIR_Coverage, 12525,
     /*  748824 */     GIR_EraseRootFromParent_Done,
     /*  748825 */   // Label 11736: @748825
     /*  748825 */   GIM_Try, /*On fail goto*//*Label 11737*/ GIMT_Encode4(748900), // Rule ID 12528 //
     /*  748830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  748841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  748844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  748847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  748850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748876 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748898 */     GIR_RootConstrainSelectedInstOperands,
     /*  748899 */     // GIR_Coverage, 12528,
     /*  748899 */     GIR_EraseRootFromParent_Done,
     /*  748900 */   // Label 11737: @748900
     /*  748900 */   GIM_Try, /*On fail goto*//*Label 11738*/ GIMT_Encode4(748975), // Rule ID 12529 //
     /*  748905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  748916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  748919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  748922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  748925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748951 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748973 */     GIR_RootConstrainSelectedInstOperands,
     /*  748974 */     // GIR_Coverage, 12529,
     /*  748974 */     GIR_EraseRootFromParent_Done,
     /*  748975 */   // Label 11738: @748975
     /*  748975 */   GIM_Try, /*On fail goto*//*Label 11739*/ GIMT_Encode4(749050), // Rule ID 12532 //
     /*  748980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  748991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  748994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  748997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  749000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  749026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  749029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749048 */     GIR_RootConstrainSelectedInstOperands,
     /*  749049 */     // GIR_Coverage, 12532,
     /*  749049 */     GIR_EraseRootFromParent_Done,
     /*  749050 */   // Label 11739: @749050
     /*  749050 */   GIM_Try, /*On fail goto*//*Label 11740*/ GIMT_Encode4(749125), // Rule ID 12533 //
     /*  749055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  749066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  749069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  749072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  749075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749101 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  749101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  749104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749123 */     GIR_RootConstrainSelectedInstOperands,
     /*  749124 */     // GIR_Coverage, 12533,
     /*  749124 */     GIR_EraseRootFromParent_Done,
     /*  749125 */   // Label 11740: @749125
     /*  749125 */   GIM_Try, /*On fail goto*//*Label 11741*/ GIMT_Encode4(749200), // Rule ID 12536 //
     /*  749130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  749141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  749144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  749147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  749150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749176 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  749176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  749179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749198 */     GIR_RootConstrainSelectedInstOperands,
     /*  749199 */     // GIR_Coverage, 12536,
     /*  749199 */     GIR_EraseRootFromParent_Done,
     /*  749200 */   // Label 11741: @749200
     /*  749200 */   GIM_Try, /*On fail goto*//*Label 11742*/ GIMT_Encode4(749275), // Rule ID 12537 //
     /*  749205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  749216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  749219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  749222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  749225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749251 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  749251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  749254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749273 */     GIR_RootConstrainSelectedInstOperands,
     /*  749274 */     // GIR_Coverage, 12537,
     /*  749274 */     GIR_EraseRootFromParent_Done,
     /*  749275 */   // Label 11742: @749275
     /*  749275 */   GIM_Try, /*On fail goto*//*Label 11743*/ GIMT_Encode4(749350), // Rule ID 12540 //
     /*  749280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  749291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  749294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  749297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  749300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749326 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  749326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  749329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749348 */     GIR_RootConstrainSelectedInstOperands,
     /*  749349 */     // GIR_Coverage, 12540,
     /*  749349 */     GIR_EraseRootFromParent_Done,
     /*  749350 */   // Label 11743: @749350
     /*  749350 */   GIM_Try, /*On fail goto*//*Label 11744*/ GIMT_Encode4(749425), // Rule ID 12541 //
     /*  749355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  749366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  749369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  749372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  749375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749401 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  749401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  749404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749423 */     GIR_RootConstrainSelectedInstOperands,
     /*  749424 */     // GIR_Coverage, 12541,
     /*  749424 */     GIR_EraseRootFromParent_Done,
     /*  749425 */   // Label 11744: @749425
     /*  749425 */   GIM_Try, /*On fail goto*//*Label 11745*/ GIMT_Encode4(749500), // Rule ID 12544 //
     /*  749430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  749441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  749444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  749447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  749450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  749479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749498 */     GIR_RootConstrainSelectedInstOperands,
     /*  749499 */     // GIR_Coverage, 12544,
     /*  749499 */     GIR_EraseRootFromParent_Done,
     /*  749500 */   // Label 11745: @749500
     /*  749500 */   GIM_Try, /*On fail goto*//*Label 11746*/ GIMT_Encode4(749575), // Rule ID 12545 //
     /*  749505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  749516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  749519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  749522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  749525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749551 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  749554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749573 */     GIR_RootConstrainSelectedInstOperands,
     /*  749574 */     // GIR_Coverage, 12545,
     /*  749574 */     GIR_EraseRootFromParent_Done,
     /*  749575 */   // Label 11746: @749575
     /*  749575 */   GIM_Try, /*On fail goto*//*Label 11747*/ GIMT_Encode4(749650), // Rule ID 12548 //
     /*  749580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  749591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  749594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  749597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  749600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749626 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  749629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749648 */     GIR_RootConstrainSelectedInstOperands,
     /*  749649 */     // GIR_Coverage, 12548,
     /*  749649 */     GIR_EraseRootFromParent_Done,
     /*  749650 */   // Label 11747: @749650
     /*  749650 */   GIM_Try, /*On fail goto*//*Label 11748*/ GIMT_Encode4(749725), // Rule ID 12549 //
     /*  749655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  749666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  749669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  749672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  749675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749701 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  749704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749723 */     GIR_RootConstrainSelectedInstOperands,
     /*  749724 */     // GIR_Coverage, 12549,
     /*  749724 */     GIR_EraseRootFromParent_Done,
     /*  749725 */   // Label 11748: @749725
     /*  749725 */   GIM_Try, /*On fail goto*//*Label 11749*/ GIMT_Encode4(749800), // Rule ID 12552 //
     /*  749730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  749741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  749744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  749747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  749750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749776 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  749779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749798 */     GIR_RootConstrainSelectedInstOperands,
     /*  749799 */     // GIR_Coverage, 12552,
     /*  749799 */     GIR_EraseRootFromParent_Done,
     /*  749800 */   // Label 11749: @749800
     /*  749800 */   GIM_Try, /*On fail goto*//*Label 11750*/ GIMT_Encode4(749875), // Rule ID 12553 //
     /*  749805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  749816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  749819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  749822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  749825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749851 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  749854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749873 */     GIR_RootConstrainSelectedInstOperands,
     /*  749874 */     // GIR_Coverage, 12553,
     /*  749874 */     GIR_EraseRootFromParent_Done,
     /*  749875 */   // Label 11750: @749875
     /*  749875 */   GIM_Try, /*On fail goto*//*Label 11751*/ GIMT_Encode4(749950), // Rule ID 12556 //
     /*  749880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  749891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  749894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  749897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  749900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  749929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749948 */     GIR_RootConstrainSelectedInstOperands,
     /*  749949 */     // GIR_Coverage, 12556,
     /*  749949 */     GIR_EraseRootFromParent_Done,
     /*  749950 */   // Label 11751: @749950
     /*  749950 */   GIM_Try, /*On fail goto*//*Label 11752*/ GIMT_Encode4(750025), // Rule ID 12557 //
     /*  749955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  749966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  749969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  749972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  749975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750001 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  750001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  750004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750023 */     GIR_RootConstrainSelectedInstOperands,
     /*  750024 */     // GIR_Coverage, 12557,
     /*  750024 */     GIR_EraseRootFromParent_Done,
     /*  750025 */   // Label 11752: @750025
     /*  750025 */   GIM_Try, /*On fail goto*//*Label 11753*/ GIMT_Encode4(750100), // Rule ID 12560 //
     /*  750030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  750041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  750044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  750047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750076 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  750079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750098 */     GIR_RootConstrainSelectedInstOperands,
     /*  750099 */     // GIR_Coverage, 12560,
     /*  750099 */     GIR_EraseRootFromParent_Done,
     /*  750100 */   // Label 11753: @750100
     /*  750100 */   GIM_Try, /*On fail goto*//*Label 11754*/ GIMT_Encode4(750175), // Rule ID 12561 //
     /*  750105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  750116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  750119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  750122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750151 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  750154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750173 */     GIR_RootConstrainSelectedInstOperands,
     /*  750174 */     // GIR_Coverage, 12561,
     /*  750174 */     GIR_EraseRootFromParent_Done,
     /*  750175 */   // Label 11754: @750175
     /*  750175 */   GIM_Try, /*On fail goto*//*Label 11755*/ GIMT_Encode4(750250), // Rule ID 12564 //
     /*  750180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  750191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  750194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  750197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750226 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  750229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750248 */     GIR_RootConstrainSelectedInstOperands,
     /*  750249 */     // GIR_Coverage, 12564,
     /*  750249 */     GIR_EraseRootFromParent_Done,
     /*  750250 */   // Label 11755: @750250
     /*  750250 */   GIM_Try, /*On fail goto*//*Label 11756*/ GIMT_Encode4(750325), // Rule ID 12565 //
     /*  750255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  750266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  750269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  750272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750301 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  750304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750323 */     GIR_RootConstrainSelectedInstOperands,
     /*  750324 */     // GIR_Coverage, 12565,
     /*  750324 */     GIR_EraseRootFromParent_Done,
     /*  750325 */   // Label 11756: @750325
     /*  750325 */   GIM_Try, /*On fail goto*//*Label 11757*/ GIMT_Encode4(750400), // Rule ID 12568 //
     /*  750330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  750341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  750344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  750347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750376 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  750379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750398 */     GIR_RootConstrainSelectedInstOperands,
     /*  750399 */     // GIR_Coverage, 12568,
     /*  750399 */     GIR_EraseRootFromParent_Done,
     /*  750400 */   // Label 11757: @750400
     /*  750400 */   GIM_Try, /*On fail goto*//*Label 11758*/ GIMT_Encode4(750475), // Rule ID 12569 //
     /*  750405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  750416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  750419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  750422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750451 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  750454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750473 */     GIR_RootConstrainSelectedInstOperands,
     /*  750474 */     // GIR_Coverage, 12569,
     /*  750474 */     GIR_EraseRootFromParent_Done,
     /*  750475 */   // Label 11758: @750475
     /*  750475 */   GIM_Try, /*On fail goto*//*Label 11759*/ GIMT_Encode4(750550), // Rule ID 12572 //
     /*  750480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  750491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  750494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  750497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750526 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750548 */     GIR_RootConstrainSelectedInstOperands,
     /*  750549 */     // GIR_Coverage, 12572,
     /*  750549 */     GIR_EraseRootFromParent_Done,
     /*  750550 */   // Label 11759: @750550
     /*  750550 */   GIM_Try, /*On fail goto*//*Label 11760*/ GIMT_Encode4(750625), // Rule ID 12573 //
     /*  750555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  750566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  750569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  750572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750601 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750623 */     GIR_RootConstrainSelectedInstOperands,
     /*  750624 */     // GIR_Coverage, 12573,
     /*  750624 */     GIR_EraseRootFromParent_Done,
     /*  750625 */   // Label 11760: @750625
     /*  750625 */   GIM_Try, /*On fail goto*//*Label 11761*/ GIMT_Encode4(750700), // Rule ID 12576 //
     /*  750630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  750641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  750644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  750647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  750679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750698 */     GIR_RootConstrainSelectedInstOperands,
     /*  750699 */     // GIR_Coverage, 12576,
     /*  750699 */     GIR_EraseRootFromParent_Done,
     /*  750700 */   // Label 11761: @750700
     /*  750700 */   GIM_Try, /*On fail goto*//*Label 11762*/ GIMT_Encode4(750775), // Rule ID 12577 //
     /*  750705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  750716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  750719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  750722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750751 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  750754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750773 */     GIR_RootConstrainSelectedInstOperands,
     /*  750774 */     // GIR_Coverage, 12577,
     /*  750774 */     GIR_EraseRootFromParent_Done,
     /*  750775 */   // Label 11762: @750775
     /*  750775 */   GIM_Try, /*On fail goto*//*Label 11763*/ GIMT_Encode4(750850), // Rule ID 12580 //
     /*  750780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  750791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  750794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  750797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750826 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  750829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750848 */     GIR_RootConstrainSelectedInstOperands,
     /*  750849 */     // GIR_Coverage, 12580,
     /*  750849 */     GIR_EraseRootFromParent_Done,
     /*  750850 */   // Label 11763: @750850
     /*  750850 */   GIM_Try, /*On fail goto*//*Label 11764*/ GIMT_Encode4(750925), // Rule ID 12581 //
     /*  750855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  750866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  750869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  750872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750901 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  750904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750923 */     GIR_RootConstrainSelectedInstOperands,
     /*  750924 */     // GIR_Coverage, 12581,
     /*  750924 */     GIR_EraseRootFromParent_Done,
     /*  750925 */   // Label 11764: @750925
     /*  750925 */   GIM_Try, /*On fail goto*//*Label 11765*/ GIMT_Encode4(751000), // Rule ID 12584 //
     /*  750930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  750941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  750944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  750947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750976 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  750979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750998 */     GIR_RootConstrainSelectedInstOperands,
     /*  750999 */     // GIR_Coverage, 12584,
     /*  750999 */     GIR_EraseRootFromParent_Done,
     /*  751000 */   // Label 11765: @751000
     /*  751000 */   GIM_Try, /*On fail goto*//*Label 11766*/ GIMT_Encode4(751075), // Rule ID 12585 //
     /*  751005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  751016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  751019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  751022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751051 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  751054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751073 */     GIR_RootConstrainSelectedInstOperands,
     /*  751074 */     // GIR_Coverage, 12585,
     /*  751074 */     GIR_EraseRootFromParent_Done,
     /*  751075 */   // Label 11766: @751075
     /*  751075 */   GIM_Try, /*On fail goto*//*Label 11767*/ GIMT_Encode4(751150), // Rule ID 12588 //
     /*  751080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  751091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  751094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  751097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751126 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  751126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  751129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751148 */     GIR_RootConstrainSelectedInstOperands,
     /*  751149 */     // GIR_Coverage, 12588,
     /*  751149 */     GIR_EraseRootFromParent_Done,
     /*  751150 */   // Label 11767: @751150
     /*  751150 */   GIM_Try, /*On fail goto*//*Label 11768*/ GIMT_Encode4(751225), // Rule ID 12589 //
     /*  751155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  751166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  751169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  751172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751201 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  751204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751223 */     GIR_RootConstrainSelectedInstOperands,
     /*  751224 */     // GIR_Coverage, 12589,
     /*  751224 */     GIR_EraseRootFromParent_Done,
     /*  751225 */   // Label 11768: @751225
     /*  751225 */   GIM_Try, /*On fail goto*//*Label 11769*/ GIMT_Encode4(751300), // Rule ID 12592 //
     /*  751230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  751241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  751244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  751247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  751276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  751279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751298 */     GIR_RootConstrainSelectedInstOperands,
     /*  751299 */     // GIR_Coverage, 12592,
     /*  751299 */     GIR_EraseRootFromParent_Done,
     /*  751300 */   // Label 11769: @751300
     /*  751300 */   GIM_Try, /*On fail goto*//*Label 11770*/ GIMT_Encode4(751375), // Rule ID 12593 //
     /*  751305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  751316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  751319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  751322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751351 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  751354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751373 */     GIR_RootConstrainSelectedInstOperands,
     /*  751374 */     // GIR_Coverage, 12593,
     /*  751374 */     GIR_EraseRootFromParent_Done,
     /*  751375 */   // Label 11770: @751375
     /*  751375 */   GIM_Try, /*On fail goto*//*Label 11771*/ GIMT_Encode4(751450), // Rule ID 12596 //
     /*  751380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  751391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  751394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  751397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751426 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  751426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  751429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751448 */     GIR_RootConstrainSelectedInstOperands,
     /*  751449 */     // GIR_Coverage, 12596,
     /*  751449 */     GIR_EraseRootFromParent_Done,
     /*  751450 */   // Label 11771: @751450
     /*  751450 */   GIM_Try, /*On fail goto*//*Label 11772*/ GIMT_Encode4(751525), // Rule ID 12597 //
     /*  751455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  751466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  751469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  751472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751501 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  751504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751523 */     GIR_RootConstrainSelectedInstOperands,
     /*  751524 */     // GIR_Coverage, 12597,
     /*  751524 */     GIR_EraseRootFromParent_Done,
     /*  751525 */   // Label 11772: @751525
     /*  751525 */   GIM_Try, /*On fail goto*//*Label 11773*/ GIMT_Encode4(751600), // Rule ID 12600 //
     /*  751530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  751541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  751544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  751547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751576 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  751576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751598 */     GIR_RootConstrainSelectedInstOperands,
     /*  751599 */     // GIR_Coverage, 12600,
     /*  751599 */     GIR_EraseRootFromParent_Done,
     /*  751600 */   // Label 11773: @751600
     /*  751600 */   GIM_Try, /*On fail goto*//*Label 11774*/ GIMT_Encode4(751675), // Rule ID 12601 //
     /*  751605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  751616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  751619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  751622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751651 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751673 */     GIR_RootConstrainSelectedInstOperands,
     /*  751674 */     // GIR_Coverage, 12601,
     /*  751674 */     GIR_EraseRootFromParent_Done,
     /*  751675 */   // Label 11774: @751675
     /*  751675 */   GIM_Try, /*On fail goto*//*Label 11775*/ GIMT_Encode4(751750), // Rule ID 12604 //
     /*  751680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  751691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  751694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  751697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751726 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  751729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751748 */     GIR_RootConstrainSelectedInstOperands,
     /*  751749 */     // GIR_Coverage, 12604,
     /*  751749 */     GIR_EraseRootFromParent_Done,
     /*  751750 */   // Label 11775: @751750
     /*  751750 */   GIM_Try, /*On fail goto*//*Label 11776*/ GIMT_Encode4(751825), // Rule ID 12605 //
     /*  751755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  751766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  751769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  751772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751801 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  751804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751823 */     GIR_RootConstrainSelectedInstOperands,
     /*  751824 */     // GIR_Coverage, 12605,
     /*  751824 */     GIR_EraseRootFromParent_Done,
     /*  751825 */   // Label 11776: @751825
     /*  751825 */   GIM_Try, /*On fail goto*//*Label 11777*/ GIMT_Encode4(751900), // Rule ID 12608 //
     /*  751830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  751841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  751844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  751847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  751879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751898 */     GIR_RootConstrainSelectedInstOperands,
     /*  751899 */     // GIR_Coverage, 12608,
     /*  751899 */     GIR_EraseRootFromParent_Done,
     /*  751900 */   // Label 11777: @751900
     /*  751900 */   GIM_Try, /*On fail goto*//*Label 11778*/ GIMT_Encode4(751975), // Rule ID 12609 //
     /*  751905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  751916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  751919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  751922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  751954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751973 */     GIR_RootConstrainSelectedInstOperands,
     /*  751974 */     // GIR_Coverage, 12609,
     /*  751974 */     GIR_EraseRootFromParent_Done,
     /*  751975 */   // Label 11778: @751975
     /*  751975 */   GIM_Try, /*On fail goto*//*Label 11779*/ GIMT_Encode4(752050), // Rule ID 12612 //
     /*  751980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  751991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  751994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  751997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  752000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752026 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  752026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  752029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752048 */     GIR_RootConstrainSelectedInstOperands,
     /*  752049 */     // GIR_Coverage, 12612,
     /*  752049 */     GIR_EraseRootFromParent_Done,
     /*  752050 */   // Label 11779: @752050
     /*  752050 */   GIM_Try, /*On fail goto*//*Label 11780*/ GIMT_Encode4(752125), // Rule ID 12613 //
     /*  752055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  752058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  752066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  752069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  752072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  752075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752101 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  752101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  752104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752123 */     GIR_RootConstrainSelectedInstOperands,
     /*  752124 */     // GIR_Coverage, 12613,
     /*  752124 */     GIR_EraseRootFromParent_Done,
     /*  752125 */   // Label 11780: @752125
     /*  752125 */   GIM_Try, /*On fail goto*//*Label 11781*/ GIMT_Encode4(752200), // Rule ID 12616 //
     /*  752130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  752133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  752141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  752144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  752147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  752150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  752176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  752179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752198 */     GIR_RootConstrainSelectedInstOperands,
     /*  752199 */     // GIR_Coverage, 12616,
     /*  752199 */     GIR_EraseRootFromParent_Done,
     /*  752200 */   // Label 11781: @752200
     /*  752200 */   GIM_Try, /*On fail goto*//*Label 11782*/ GIMT_Encode4(752275), // Rule ID 12617 //
     /*  752205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  752208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  752216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  752219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  752222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  752225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752251 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  752251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  752254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752273 */     GIR_RootConstrainSelectedInstOperands,
     /*  752274 */     // GIR_Coverage, 12617,
     /*  752274 */     GIR_EraseRootFromParent_Done,
     /*  752275 */   // Label 11782: @752275
     /*  752275 */   GIM_Try, /*On fail goto*//*Label 11783*/ GIMT_Encode4(752350), // Rule ID 12620 //
     /*  752280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  752291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  752294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  752297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  752300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752326 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  752329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752348 */     GIR_RootConstrainSelectedInstOperands,
     /*  752349 */     // GIR_Coverage, 12620,
     /*  752349 */     GIR_EraseRootFromParent_Done,
     /*  752350 */   // Label 11783: @752350
     /*  752350 */   GIM_Try, /*On fail goto*//*Label 11784*/ GIMT_Encode4(752425), // Rule ID 12621 //
     /*  752355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  752366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  752369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  752372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  752375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752401 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  752404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752423 */     GIR_RootConstrainSelectedInstOperands,
     /*  752424 */     // GIR_Coverage, 12621,
     /*  752424 */     GIR_EraseRootFromParent_Done,
     /*  752425 */   // Label 11784: @752425
     /*  752425 */   GIM_Try, /*On fail goto*//*Label 11785*/ GIMT_Encode4(752500), // Rule ID 12624 //
     /*  752430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  752441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  752444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  752447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  752450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752476 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752498 */     GIR_RootConstrainSelectedInstOperands,
     /*  752499 */     // GIR_Coverage, 12624,
     /*  752499 */     GIR_EraseRootFromParent_Done,
     /*  752500 */   // Label 11785: @752500
     /*  752500 */   GIM_Try, /*On fail goto*//*Label 11786*/ GIMT_Encode4(752575), // Rule ID 12625 //
     /*  752505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  752516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  752519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  752522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  752525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752551 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752573 */     GIR_RootConstrainSelectedInstOperands,
     /*  752574 */     // GIR_Coverage, 12625,
     /*  752574 */     GIR_EraseRootFromParent_Done,
     /*  752575 */   // Label 11786: @752575
     /*  752575 */   GIM_Try, /*On fail goto*//*Label 11787*/ GIMT_Encode4(752650), // Rule ID 12628 //
     /*  752580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  752591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  752594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  752597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  752600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752648 */     GIR_RootConstrainSelectedInstOperands,
     /*  752649 */     // GIR_Coverage, 12628,
     /*  752649 */     GIR_EraseRootFromParent_Done,
     /*  752650 */   // Label 11787: @752650
     /*  752650 */   GIM_Try, /*On fail goto*//*Label 11788*/ GIMT_Encode4(752725), // Rule ID 12629 //
     /*  752655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  752666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  752669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  752672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  752675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752701 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752723 */     GIR_RootConstrainSelectedInstOperands,
     /*  752724 */     // GIR_Coverage, 12629,
     /*  752724 */     GIR_EraseRootFromParent_Done,
     /*  752725 */   // Label 11788: @752725
     /*  752725 */   GIM_Try, /*On fail goto*//*Label 11789*/ GIMT_Encode4(752800), // Rule ID 12632 //
     /*  752730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  752741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  752744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  752747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  752750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  752779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752798 */     GIR_RootConstrainSelectedInstOperands,
     /*  752799 */     // GIR_Coverage, 12632,
     /*  752799 */     GIR_EraseRootFromParent_Done,
     /*  752800 */   // Label 11789: @752800
     /*  752800 */   GIM_Try, /*On fail goto*//*Label 11790*/ GIMT_Encode4(752875), // Rule ID 12633 //
     /*  752805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  752816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  752819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  752822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  752825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  752854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752873 */     GIR_RootConstrainSelectedInstOperands,
     /*  752874 */     // GIR_Coverage, 12633,
     /*  752874 */     GIR_EraseRootFromParent_Done,
     /*  752875 */   // Label 11790: @752875
     /*  752875 */   GIM_Try, /*On fail goto*//*Label 11791*/ GIMT_Encode4(752950), // Rule ID 12636 //
     /*  752880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  752891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  752894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  752897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  752900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  752929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752948 */     GIR_RootConstrainSelectedInstOperands,
     /*  752949 */     // GIR_Coverage, 12636,
     /*  752949 */     GIR_EraseRootFromParent_Done,
     /*  752950 */   // Label 11791: @752950
     /*  752950 */   GIM_Try, /*On fail goto*//*Label 11792*/ GIMT_Encode4(753025), // Rule ID 12637 //
     /*  752955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  752966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  752969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  752972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  752975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753001 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753023 */     GIR_RootConstrainSelectedInstOperands,
     /*  753024 */     // GIR_Coverage, 12637,
     /*  753024 */     GIR_EraseRootFromParent_Done,
     /*  753025 */   // Label 11792: @753025
     /*  753025 */   GIM_Try, /*On fail goto*//*Label 11793*/ GIMT_Encode4(753100), // Rule ID 12640 //
     /*  753030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  753041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  753044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  753047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  753050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753076 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753098 */     GIR_RootConstrainSelectedInstOperands,
     /*  753099 */     // GIR_Coverage, 12640,
     /*  753099 */     GIR_EraseRootFromParent_Done,
     /*  753100 */   // Label 11793: @753100
     /*  753100 */   GIM_Try, /*On fail goto*//*Label 11794*/ GIMT_Encode4(753175), // Rule ID 12641 //
     /*  753105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  753116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  753119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  753122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  753125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753151 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753173 */     GIR_RootConstrainSelectedInstOperands,
     /*  753174 */     // GIR_Coverage, 12641,
     /*  753174 */     GIR_EraseRootFromParent_Done,
     /*  753175 */   // Label 11794: @753175
     /*  753175 */   GIM_Try, /*On fail goto*//*Label 11795*/ GIMT_Encode4(753250), // Rule ID 12644 //
     /*  753180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  753191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  753194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  753197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  753200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753226 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  753229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753248 */     GIR_RootConstrainSelectedInstOperands,
     /*  753249 */     // GIR_Coverage, 12644,
     /*  753249 */     GIR_EraseRootFromParent_Done,
     /*  753250 */   // Label 11795: @753250
     /*  753250 */   GIM_Try, /*On fail goto*//*Label 11796*/ GIMT_Encode4(753325), // Rule ID 12645 //
     /*  753255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  753266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  753269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  753272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  753275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753301 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  753304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753323 */     GIR_RootConstrainSelectedInstOperands,
     /*  753324 */     // GIR_Coverage, 12645,
     /*  753324 */     GIR_EraseRootFromParent_Done,
     /*  753325 */   // Label 11796: @753325
     /*  753325 */   GIM_Try, /*On fail goto*//*Label 11797*/ GIMT_Encode4(753400), // Rule ID 12648 //
     /*  753330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  753341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  753344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  753347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  753350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753376 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  753379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753398 */     GIR_RootConstrainSelectedInstOperands,
     /*  753399 */     // GIR_Coverage, 12648,
     /*  753399 */     GIR_EraseRootFromParent_Done,
     /*  753400 */   // Label 11797: @753400
     /*  753400 */   GIM_Try, /*On fail goto*//*Label 11798*/ GIMT_Encode4(753475), // Rule ID 12649 //
     /*  753405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  753416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  753419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  753422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  753425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753451 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  753454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753473 */     GIR_RootConstrainSelectedInstOperands,
     /*  753474 */     // GIR_Coverage, 12649,
     /*  753474 */     GIR_EraseRootFromParent_Done,
     /*  753475 */   // Label 11798: @753475
     /*  753475 */   GIM_Try, /*On fail goto*//*Label 11799*/ GIMT_Encode4(753550), // Rule ID 12652 //
     /*  753480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  753491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  753494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  753497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  753500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753548 */     GIR_RootConstrainSelectedInstOperands,
     /*  753549 */     // GIR_Coverage, 12652,
     /*  753549 */     GIR_EraseRootFromParent_Done,
     /*  753550 */   // Label 11799: @753550
     /*  753550 */   GIM_Try, /*On fail goto*//*Label 11800*/ GIMT_Encode4(753625), // Rule ID 12653 //
     /*  753555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  753566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  753569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  753572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  753575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753623 */     GIR_RootConstrainSelectedInstOperands,
     /*  753624 */     // GIR_Coverage, 12653,
     /*  753624 */     GIR_EraseRootFromParent_Done,
     /*  753625 */   // Label 11800: @753625
     /*  753625 */   GIM_Try, /*On fail goto*//*Label 11801*/ GIMT_Encode4(753700), // Rule ID 12656 //
     /*  753630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  753641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  753644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  753647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  753650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753676 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753698 */     GIR_RootConstrainSelectedInstOperands,
     /*  753699 */     // GIR_Coverage, 12656,
     /*  753699 */     GIR_EraseRootFromParent_Done,
     /*  753700 */   // Label 11801: @753700
     /*  753700 */   GIM_Try, /*On fail goto*//*Label 11802*/ GIMT_Encode4(753775), // Rule ID 12657 //
     /*  753705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  753716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  753719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  753722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  753725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753751 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753773 */     GIR_RootConstrainSelectedInstOperands,
     /*  753774 */     // GIR_Coverage, 12657,
     /*  753774 */     GIR_EraseRootFromParent_Done,
     /*  753775 */   // Label 11802: @753775
     /*  753775 */   GIM_Try, /*On fail goto*//*Label 11803*/ GIMT_Encode4(753850), // Rule ID 12660 //
     /*  753780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  753791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  753794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  753797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  753800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753826 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753848 */     GIR_RootConstrainSelectedInstOperands,
     /*  753849 */     // GIR_Coverage, 12660,
     /*  753849 */     GIR_EraseRootFromParent_Done,
     /*  753850 */   // Label 11803: @753850
     /*  753850 */   GIM_Try, /*On fail goto*//*Label 11804*/ GIMT_Encode4(753925), // Rule ID 12661 //
     /*  753855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  753866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  753869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  753872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  753875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753901 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753923 */     GIR_RootConstrainSelectedInstOperands,
     /*  753924 */     // GIR_Coverage, 12661,
     /*  753924 */     GIR_EraseRootFromParent_Done,
     /*  753925 */   // Label 11804: @753925
     /*  753925 */   GIM_Try, /*On fail goto*//*Label 11805*/ GIMT_Encode4(754000), // Rule ID 12664 //
     /*  753930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  753941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  753944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  753947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  753950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  753979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753998 */     GIR_RootConstrainSelectedInstOperands,
     /*  753999 */     // GIR_Coverage, 12664,
     /*  753999 */     GIR_EraseRootFromParent_Done,
     /*  754000 */   // Label 11805: @754000
     /*  754000 */   GIM_Try, /*On fail goto*//*Label 11806*/ GIMT_Encode4(754075), // Rule ID 12665 //
     /*  754005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  754008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  754016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  754019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  754022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  754025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754051 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  754051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  754054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754073 */     GIR_RootConstrainSelectedInstOperands,
     /*  754074 */     // GIR_Coverage, 12665,
     /*  754074 */     GIR_EraseRootFromParent_Done,
     /*  754075 */   // Label 11806: @754075
     /*  754075 */   GIM_Try, /*On fail goto*//*Label 11807*/ GIMT_Encode4(754150), // Rule ID 12668 //
     /*  754080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  754083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  754091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  754094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  754097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  754100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754126 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  754126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  754129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754148 */     GIR_RootConstrainSelectedInstOperands,
     /*  754149 */     // GIR_Coverage, 12668,
     /*  754149 */     GIR_EraseRootFromParent_Done,
     /*  754150 */   // Label 11807: @754150
     /*  754150 */   GIM_Try, /*On fail goto*//*Label 11808*/ GIMT_Encode4(754225), // Rule ID 12669 //
     /*  754155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  754158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  754166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  754169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  754172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  754175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754201 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  754201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  754204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754223 */     GIR_RootConstrainSelectedInstOperands,
     /*  754224 */     // GIR_Coverage, 12669,
     /*  754224 */     GIR_EraseRootFromParent_Done,
     /*  754225 */   // Label 11808: @754225
     /*  754225 */   GIM_Try, /*On fail goto*//*Label 11809*/ GIMT_Encode4(754300), // Rule ID 12672 //
     /*  754230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  754233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  754241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  754244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  754247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  754250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754276 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  754276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  754279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754298 */     GIR_RootConstrainSelectedInstOperands,
     /*  754299 */     // GIR_Coverage, 12672,
     /*  754299 */     GIR_EraseRootFromParent_Done,
     /*  754300 */   // Label 11809: @754300
     /*  754300 */   GIM_Try, /*On fail goto*//*Label 11810*/ GIMT_Encode4(754375), // Rule ID 12673 //
     /*  754305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  754308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  754316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  754319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  754322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  754325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754351 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  754351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  754354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754373 */     GIR_RootConstrainSelectedInstOperands,
     /*  754374 */     // GIR_Coverage, 12673,
     /*  754374 */     GIR_EraseRootFromParent_Done,
     /*  754375 */   // Label 11810: @754375
     /*  754375 */   GIM_Try, /*On fail goto*//*Label 11811*/ GIMT_Encode4(754450), // Rule ID 12676 //
     /*  754380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  754383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  754391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  754394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  754397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  754400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754426 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  754426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  754429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754448 */     GIR_RootConstrainSelectedInstOperands,
     /*  754449 */     // GIR_Coverage, 12676,
     /*  754449 */     GIR_EraseRootFromParent_Done,
     /*  754450 */   // Label 11811: @754450
     /*  754450 */   GIM_Try, /*On fail goto*//*Label 11812*/ GIMT_Encode4(754525), // Rule ID 12677 //
     /*  754455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  754458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  754466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  754469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  754472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  754475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754501 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  754501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  754504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754523 */     GIR_RootConstrainSelectedInstOperands,
     /*  754524 */     // GIR_Coverage, 12677,
     /*  754524 */     GIR_EraseRootFromParent_Done,
     /*  754525 */   // Label 11812: @754525
     /*  754525 */   GIM_Try, /*On fail goto*//*Label 11813*/ GIMT_Encode4(754600), // Rule ID 12680 //
     /*  754530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  754541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  754544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  754547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754576 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  754579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754598 */     GIR_RootConstrainSelectedInstOperands,
     /*  754599 */     // GIR_Coverage, 12680,
     /*  754599 */     GIR_EraseRootFromParent_Done,
     /*  754600 */   // Label 11813: @754600
     /*  754600 */   GIM_Try, /*On fail goto*//*Label 11814*/ GIMT_Encode4(754675), // Rule ID 12681 //
     /*  754605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  754616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  754619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  754622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754651 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  754654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754673 */     GIR_RootConstrainSelectedInstOperands,
     /*  754674 */     // GIR_Coverage, 12681,
     /*  754674 */     GIR_EraseRootFromParent_Done,
     /*  754675 */   // Label 11814: @754675
     /*  754675 */   GIM_Try, /*On fail goto*//*Label 11815*/ GIMT_Encode4(754750), // Rule ID 12684 //
     /*  754680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  754691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  754694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  754697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  754729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754748 */     GIR_RootConstrainSelectedInstOperands,
     /*  754749 */     // GIR_Coverage, 12684,
     /*  754749 */     GIR_EraseRootFromParent_Done,
     /*  754750 */   // Label 11815: @754750
     /*  754750 */   GIM_Try, /*On fail goto*//*Label 11816*/ GIMT_Encode4(754825), // Rule ID 12685 //
     /*  754755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  754766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  754769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  754772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754801 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  754804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754823 */     GIR_RootConstrainSelectedInstOperands,
     /*  754824 */     // GIR_Coverage, 12685,
     /*  754824 */     GIR_EraseRootFromParent_Done,
     /*  754825 */   // Label 11816: @754825
     /*  754825 */   GIM_Try, /*On fail goto*//*Label 11817*/ GIMT_Encode4(754900), // Rule ID 12688 //
     /*  754830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  754841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  754844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  754847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  754879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754898 */     GIR_RootConstrainSelectedInstOperands,
     /*  754899 */     // GIR_Coverage, 12688,
     /*  754899 */     GIR_EraseRootFromParent_Done,
     /*  754900 */   // Label 11817: @754900
     /*  754900 */   GIM_Try, /*On fail goto*//*Label 11818*/ GIMT_Encode4(754975), // Rule ID 12689 //
     /*  754905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  754916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  754919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  754922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754951 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  754954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754973 */     GIR_RootConstrainSelectedInstOperands,
     /*  754974 */     // GIR_Coverage, 12689,
     /*  754974 */     GIR_EraseRootFromParent_Done,
     /*  754975 */   // Label 11818: @754975
     /*  754975 */   GIM_Try, /*On fail goto*//*Label 11819*/ GIMT_Encode4(755050), // Rule ID 12692 //
     /*  754980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  754991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  754994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  754997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755026 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755048 */     GIR_RootConstrainSelectedInstOperands,
     /*  755049 */     // GIR_Coverage, 12692,
     /*  755049 */     GIR_EraseRootFromParent_Done,
     /*  755050 */   // Label 11819: @755050
     /*  755050 */   GIM_Try, /*On fail goto*//*Label 11820*/ GIMT_Encode4(755125), // Rule ID 12693 //
     /*  755055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  755066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  755069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  755072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755123 */     GIR_RootConstrainSelectedInstOperands,
     /*  755124 */     // GIR_Coverage, 12693,
     /*  755124 */     GIR_EraseRootFromParent_Done,
     /*  755125 */   // Label 11820: @755125
     /*  755125 */   GIM_Try, /*On fail goto*//*Label 11821*/ GIMT_Encode4(755200), // Rule ID 12696 //
     /*  755130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  755141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  755144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  755147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755176 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755198 */     GIR_RootConstrainSelectedInstOperands,
     /*  755199 */     // GIR_Coverage, 12696,
     /*  755199 */     GIR_EraseRootFromParent_Done,
     /*  755200 */   // Label 11821: @755200
     /*  755200 */   GIM_Try, /*On fail goto*//*Label 11822*/ GIMT_Encode4(755275), // Rule ID 12697 //
     /*  755205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  755216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  755219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  755222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755251 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755273 */     GIR_RootConstrainSelectedInstOperands,
     /*  755274 */     // GIR_Coverage, 12697,
     /*  755274 */     GIR_EraseRootFromParent_Done,
     /*  755275 */   // Label 11822: @755275
     /*  755275 */   GIM_Try, /*On fail goto*//*Label 11823*/ GIMT_Encode4(755350), // Rule ID 12700 //
     /*  755280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  755291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  755294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  755297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  755329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755348 */     GIR_RootConstrainSelectedInstOperands,
     /*  755349 */     // GIR_Coverage, 12700,
     /*  755349 */     GIR_EraseRootFromParent_Done,
     /*  755350 */   // Label 11823: @755350
     /*  755350 */   GIM_Try, /*On fail goto*//*Label 11824*/ GIMT_Encode4(755425), // Rule ID 12701 //
     /*  755355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  755366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  755369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  755372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755401 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  755404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755423 */     GIR_RootConstrainSelectedInstOperands,
     /*  755424 */     // GIR_Coverage, 12701,
     /*  755424 */     GIR_EraseRootFromParent_Done,
     /*  755425 */   // Label 11824: @755425
     /*  755425 */   GIM_Try, /*On fail goto*//*Label 11825*/ GIMT_Encode4(755500), // Rule ID 12704 //
     /*  755430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  755441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  755444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  755447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755476 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  755479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755498 */     GIR_RootConstrainSelectedInstOperands,
     /*  755499 */     // GIR_Coverage, 12704,
     /*  755499 */     GIR_EraseRootFromParent_Done,
     /*  755500 */   // Label 11825: @755500
     /*  755500 */   GIM_Try, /*On fail goto*//*Label 11826*/ GIMT_Encode4(755575), // Rule ID 12705 //
     /*  755505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  755516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  755519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  755522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755551 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  755554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755573 */     GIR_RootConstrainSelectedInstOperands,
     /*  755574 */     // GIR_Coverage, 12705,
     /*  755574 */     GIR_EraseRootFromParent_Done,
     /*  755575 */   // Label 11826: @755575
     /*  755575 */   GIM_Try, /*On fail goto*//*Label 11827*/ GIMT_Encode4(755650), // Rule ID 12708 //
     /*  755580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  755591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  755594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  755597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755648 */     GIR_RootConstrainSelectedInstOperands,
     /*  755649 */     // GIR_Coverage, 12708,
     /*  755649 */     GIR_EraseRootFromParent_Done,
     /*  755650 */   // Label 11827: @755650
     /*  755650 */   GIM_Try, /*On fail goto*//*Label 11828*/ GIMT_Encode4(755725), // Rule ID 12709 //
     /*  755655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  755666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  755669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  755672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755701 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755723 */     GIR_RootConstrainSelectedInstOperands,
     /*  755724 */     // GIR_Coverage, 12709,
     /*  755724 */     GIR_EraseRootFromParent_Done,
     /*  755725 */   // Label 11828: @755725
     /*  755725 */   GIM_Try, /*On fail goto*//*Label 11829*/ GIMT_Encode4(755800), // Rule ID 12712 //
     /*  755730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  755741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  755744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  755747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755798 */     GIR_RootConstrainSelectedInstOperands,
     /*  755799 */     // GIR_Coverage, 12712,
     /*  755799 */     GIR_EraseRootFromParent_Done,
     /*  755800 */   // Label 11829: @755800
     /*  755800 */   GIM_Try, /*On fail goto*//*Label 11830*/ GIMT_Encode4(755875), // Rule ID 12713 //
     /*  755805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  755816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  755819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  755822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755873 */     GIR_RootConstrainSelectedInstOperands,
     /*  755874 */     // GIR_Coverage, 12713,
     /*  755874 */     GIR_EraseRootFromParent_Done,
     /*  755875 */   // Label 11830: @755875
     /*  755875 */   GIM_Try, /*On fail goto*//*Label 11831*/ GIMT_Encode4(755950), // Rule ID 12716 //
     /*  755880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  755891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  755894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  755897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755948 */     GIR_RootConstrainSelectedInstOperands,
     /*  755949 */     // GIR_Coverage, 12716,
     /*  755949 */     GIR_EraseRootFromParent_Done,
     /*  755950 */   // Label 11831: @755950
     /*  755950 */   GIM_Try, /*On fail goto*//*Label 11832*/ GIMT_Encode4(756025), // Rule ID 12717 //
     /*  755955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  755966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  755969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  755972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756001 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  756004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756023 */     GIR_RootConstrainSelectedInstOperands,
     /*  756024 */     // GIR_Coverage, 12717,
     /*  756024 */     GIR_EraseRootFromParent_Done,
     /*  756025 */   // Label 11832: @756025
     /*  756025 */   GIM_Try, /*On fail goto*//*Label 11833*/ GIMT_Encode4(756100), // Rule ID 12720 //
     /*  756030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  756041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  756044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  756047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  756079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756098 */     GIR_RootConstrainSelectedInstOperands,
     /*  756099 */     // GIR_Coverage, 12720,
     /*  756099 */     GIR_EraseRootFromParent_Done,
     /*  756100 */   // Label 11833: @756100
     /*  756100 */   GIM_Try, /*On fail goto*//*Label 11834*/ GIMT_Encode4(756175), // Rule ID 12721 //
     /*  756105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  756116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  756119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  756122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756151 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  756154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756173 */     GIR_RootConstrainSelectedInstOperands,
     /*  756174 */     // GIR_Coverage, 12721,
     /*  756174 */     GIR_EraseRootFromParent_Done,
     /*  756175 */   // Label 11834: @756175
     /*  756175 */   GIM_Try, /*On fail goto*//*Label 11835*/ GIMT_Encode4(756250), // Rule ID 12724 //
     /*  756180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  756183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  756191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  756194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  756197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  756229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756248 */     GIR_RootConstrainSelectedInstOperands,
     /*  756249 */     // GIR_Coverage, 12724,
     /*  756249 */     GIR_EraseRootFromParent_Done,
     /*  756250 */   // Label 11835: @756250
     /*  756250 */   GIM_Try, /*On fail goto*//*Label 11836*/ GIMT_Encode4(756325), // Rule ID 12725 //
     /*  756255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  756258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  756266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  756269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  756272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756301 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  756304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756323 */     GIR_RootConstrainSelectedInstOperands,
     /*  756324 */     // GIR_Coverage, 12725,
     /*  756324 */     GIR_EraseRootFromParent_Done,
     /*  756325 */   // Label 11836: @756325
     /*  756325 */   GIM_Try, /*On fail goto*//*Label 11837*/ GIMT_Encode4(756400), // Rule ID 12728 //
     /*  756330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  756333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  756341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  756344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  756347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  756379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756398 */     GIR_RootConstrainSelectedInstOperands,
     /*  756399 */     // GIR_Coverage, 12728,
     /*  756399 */     GIR_EraseRootFromParent_Done,
     /*  756400 */   // Label 11837: @756400
     /*  756400 */   GIM_Try, /*On fail goto*//*Label 11838*/ GIMT_Encode4(756475), // Rule ID 12729 //
     /*  756405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  756408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  756416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  756419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  756422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  756454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756473 */     GIR_RootConstrainSelectedInstOperands,
     /*  756474 */     // GIR_Coverage, 12729,
     /*  756474 */     GIR_EraseRootFromParent_Done,
     /*  756475 */   // Label 11838: @756475
     /*  756475 */   GIM_Try, /*On fail goto*//*Label 11839*/ GIMT_Encode4(756550), // Rule ID 12732 //
     /*  756480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  756483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  756491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  756494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  756497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756526 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  756529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756548 */     GIR_RootConstrainSelectedInstOperands,
     /*  756549 */     // GIR_Coverage, 12732,
     /*  756549 */     GIR_EraseRootFromParent_Done,
     /*  756550 */   // Label 11839: @756550
     /*  756550 */   GIM_Try, /*On fail goto*//*Label 11840*/ GIMT_Encode4(756625), // Rule ID 12733 //
     /*  756555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  756558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  756566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  756569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  756572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756601 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  756604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756623 */     GIR_RootConstrainSelectedInstOperands,
     /*  756624 */     // GIR_Coverage, 12733,
     /*  756624 */     GIR_EraseRootFromParent_Done,
     /*  756625 */   // Label 11840: @756625
     /*  756625 */   GIM_Try, /*On fail goto*//*Label 11841*/ GIMT_Encode4(756700), // Rule ID 12736 //
     /*  756630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  756633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  756641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  756644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  756647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  756679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756698 */     GIR_RootConstrainSelectedInstOperands,
     /*  756699 */     // GIR_Coverage, 12736,
     /*  756699 */     GIR_EraseRootFromParent_Done,
     /*  756700 */   // Label 11841: @756700
     /*  756700 */   GIM_Try, /*On fail goto*//*Label 11842*/ GIMT_Encode4(756775), // Rule ID 12737 //
     /*  756705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  756708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  756716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  756719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  756722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756751 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  756754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756773 */     GIR_RootConstrainSelectedInstOperands,
     /*  756774 */     // GIR_Coverage, 12737,
     /*  756774 */     GIR_EraseRootFromParent_Done,
     /*  756775 */   // Label 11842: @756775
     /*  756775 */   GIM_Try, /*On fail goto*//*Label 11843*/ GIMT_Encode4(756853), // Rule ID 14066 //
     /*  756780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  756791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  756794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  756797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  756800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756826 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  756829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756851 */     GIR_RootConstrainSelectedInstOperands,
     /*  756852 */     // GIR_Coverage, 14066,
     /*  756852 */     GIR_EraseRootFromParent_Done,
     /*  756853 */   // Label 11843: @756853
     /*  756853 */   GIM_Try, /*On fail goto*//*Label 11844*/ GIMT_Encode4(756931), // Rule ID 14067 //
     /*  756858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  756869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  756872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  756875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  756878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756904 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  756907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756929 */     GIR_RootConstrainSelectedInstOperands,
     /*  756930 */     // GIR_Coverage, 14067,
     /*  756930 */     GIR_EraseRootFromParent_Done,
     /*  756931 */   // Label 11844: @756931
     /*  756931 */   GIM_Try, /*On fail goto*//*Label 11845*/ GIMT_Encode4(757009), // Rule ID 14070 //
     /*  756936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  756947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  756950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  756953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  756956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756982 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757007 */     GIR_RootConstrainSelectedInstOperands,
     /*  757008 */     // GIR_Coverage, 14070,
     /*  757008 */     GIR_EraseRootFromParent_Done,
     /*  757009 */   // Label 11845: @757009
     /*  757009 */   GIM_Try, /*On fail goto*//*Label 11846*/ GIMT_Encode4(757087), // Rule ID 14071 //
     /*  757014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  757025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  757028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  757031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  757034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757060 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  757060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  757063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757085 */     GIR_RootConstrainSelectedInstOperands,
     /*  757086 */     // GIR_Coverage, 14071,
     /*  757086 */     GIR_EraseRootFromParent_Done,
     /*  757087 */   // Label 11846: @757087
     /*  757087 */   GIM_Try, /*On fail goto*//*Label 11847*/ GIMT_Encode4(757165), // Rule ID 14074 //
     /*  757092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  757103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  757106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  757109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  757112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757138 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757163 */     GIR_RootConstrainSelectedInstOperands,
     /*  757164 */     // GIR_Coverage, 14074,
     /*  757164 */     GIR_EraseRootFromParent_Done,
     /*  757165 */   // Label 11847: @757165
     /*  757165 */   GIM_Try, /*On fail goto*//*Label 11848*/ GIMT_Encode4(757243), // Rule ID 14075 //
     /*  757170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  757181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  757184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  757187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  757190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757216 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  757216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757241 */     GIR_RootConstrainSelectedInstOperands,
     /*  757242 */     // GIR_Coverage, 14075,
     /*  757242 */     GIR_EraseRootFromParent_Done,
     /*  757243 */   // Label 11848: @757243
     /*  757243 */   GIM_Try, /*On fail goto*//*Label 11849*/ GIMT_Encode4(757321), // Rule ID 14078 //
     /*  757248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  757259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  757262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  757265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  757268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757294 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  757297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757319 */     GIR_RootConstrainSelectedInstOperands,
     /*  757320 */     // GIR_Coverage, 14078,
     /*  757320 */     GIR_EraseRootFromParent_Done,
     /*  757321 */   // Label 11849: @757321
     /*  757321 */   GIM_Try, /*On fail goto*//*Label 11850*/ GIMT_Encode4(757399), // Rule ID 14079 //
     /*  757326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  757337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  757340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  757343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  757346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757372 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  757375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757397 */     GIR_RootConstrainSelectedInstOperands,
     /*  757398 */     // GIR_Coverage, 14079,
     /*  757398 */     GIR_EraseRootFromParent_Done,
     /*  757399 */   // Label 11850: @757399
     /*  757399 */   GIM_Try, /*On fail goto*//*Label 11851*/ GIMT_Encode4(757477), // Rule ID 14082 //
     /*  757404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  757415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  757418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  757421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  757424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757450 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757475 */     GIR_RootConstrainSelectedInstOperands,
     /*  757476 */     // GIR_Coverage, 14082,
     /*  757476 */     GIR_EraseRootFromParent_Done,
     /*  757477 */   // Label 11851: @757477
     /*  757477 */   GIM_Try, /*On fail goto*//*Label 11852*/ GIMT_Encode4(757555), // Rule ID 14083 //
     /*  757482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  757493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  757496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  757499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  757502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757528 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757553 */     GIR_RootConstrainSelectedInstOperands,
     /*  757554 */     // GIR_Coverage, 14083,
     /*  757554 */     GIR_EraseRootFromParent_Done,
     /*  757555 */   // Label 11852: @757555
     /*  757555 */   GIM_Try, /*On fail goto*//*Label 11853*/ GIMT_Encode4(757633), // Rule ID 14086 //
     /*  757560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  757571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  757574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  757580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757631 */     GIR_RootConstrainSelectedInstOperands,
     /*  757632 */     // GIR_Coverage, 14086,
     /*  757632 */     GIR_EraseRootFromParent_Done,
     /*  757633 */   // Label 11853: @757633
     /*  757633 */   GIM_Try, /*On fail goto*//*Label 11854*/ GIMT_Encode4(757711), // Rule ID 14087 //
     /*  757638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  757649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  757652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  757658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757709 */     GIR_RootConstrainSelectedInstOperands,
     /*  757710 */     // GIR_Coverage, 14087,
     /*  757710 */     GIR_EraseRootFromParent_Done,
     /*  757711 */   // Label 11854: @757711
     /*  757711 */   GIM_Try, /*On fail goto*//*Label 11855*/ GIMT_Encode4(757789), // Rule ID 14090 //
     /*  757716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  757727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  757730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  757733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  757736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757762 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757787 */     GIR_RootConstrainSelectedInstOperands,
     /*  757788 */     // GIR_Coverage, 14090,
     /*  757788 */     GIR_EraseRootFromParent_Done,
     /*  757789 */   // Label 11855: @757789
     /*  757789 */   GIM_Try, /*On fail goto*//*Label 11856*/ GIMT_Encode4(757867), // Rule ID 14091 //
     /*  757794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  757805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  757808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  757811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  757814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  757840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757865 */     GIR_RootConstrainSelectedInstOperands,
     /*  757866 */     // GIR_Coverage, 14091,
     /*  757866 */     GIR_EraseRootFromParent_Done,
     /*  757867 */   // Label 11856: @757867
     /*  757867 */   GIM_Try, /*On fail goto*//*Label 11857*/ GIMT_Encode4(757945), // Rule ID 14094 //
     /*  757872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  757883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  757886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  757889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  757892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757943 */     GIR_RootConstrainSelectedInstOperands,
     /*  757944 */     // GIR_Coverage, 14094,
     /*  757944 */     GIR_EraseRootFromParent_Done,
     /*  757945 */   // Label 11857: @757945
     /*  757945 */   GIM_Try, /*On fail goto*//*Label 11858*/ GIMT_Encode4(758023), // Rule ID 14095 //
     /*  757950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  757961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  757964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  757967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  757970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758021 */     GIR_RootConstrainSelectedInstOperands,
     /*  758022 */     // GIR_Coverage, 14095,
     /*  758022 */     GIR_EraseRootFromParent_Done,
     /*  758023 */   // Label 11858: @758023
     /*  758023 */   GIM_Try, /*On fail goto*//*Label 11859*/ GIMT_Encode4(758101), // Rule ID 14098 //
     /*  758028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  758039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  758042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  758045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  758048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  758074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  758077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758099 */     GIR_RootConstrainSelectedInstOperands,
     /*  758100 */     // GIR_Coverage, 14098,
     /*  758100 */     GIR_EraseRootFromParent_Done,
     /*  758101 */   // Label 11859: @758101
     /*  758101 */   GIM_Try, /*On fail goto*//*Label 11860*/ GIMT_Encode4(758179), // Rule ID 14099 //
     /*  758106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  758117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  758120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  758123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  758126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  758152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  758155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758177 */     GIR_RootConstrainSelectedInstOperands,
     /*  758178 */     // GIR_Coverage, 14099,
     /*  758178 */     GIR_EraseRootFromParent_Done,
     /*  758179 */   // Label 11860: @758179
     /*  758179 */   GIM_Try, /*On fail goto*//*Label 11861*/ GIMT_Encode4(758257), // Rule ID 14102 //
     /*  758184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  758187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  758195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  758198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  758201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  758204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  758230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  758233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  758249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758255 */     GIR_RootConstrainSelectedInstOperands,
     /*  758256 */     // GIR_Coverage, 14102,
     /*  758256 */     GIR_EraseRootFromParent_Done,
     /*  758257 */   // Label 11861: @758257
     /*  758257 */   GIM_Try, /*On fail goto*//*Label 11862*/ GIMT_Encode4(758335), // Rule ID 14103 //
     /*  758262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  758265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  758273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  758276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  758279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  758282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  758308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  758311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  758327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758333 */     GIR_RootConstrainSelectedInstOperands,
     /*  758334 */     // GIR_Coverage, 14103,
     /*  758334 */     GIR_EraseRootFromParent_Done,
     /*  758335 */   // Label 11862: @758335
     /*  758335 */   GIM_Try, /*On fail goto*//*Label 11863*/ GIMT_Encode4(758413), // Rule ID 14106 //
     /*  758340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  758351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  758354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  758357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  758360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758386 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758411 */     GIR_RootConstrainSelectedInstOperands,
     /*  758412 */     // GIR_Coverage, 14106,
     /*  758412 */     GIR_EraseRootFromParent_Done,
     /*  758413 */   // Label 11863: @758413
     /*  758413 */   GIM_Try, /*On fail goto*//*Label 11864*/ GIMT_Encode4(758491), // Rule ID 14107 //
     /*  758418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  758429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  758432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  758435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  758438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758464 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758489 */     GIR_RootConstrainSelectedInstOperands,
     /*  758490 */     // GIR_Coverage, 14107,
     /*  758490 */     GIR_EraseRootFromParent_Done,
     /*  758491 */   // Label 11864: @758491
     /*  758491 */   GIM_Try, /*On fail goto*//*Label 11865*/ GIMT_Encode4(758569), // Rule ID 14110 //
     /*  758496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  758507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  758510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  758513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  758516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758542 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758567 */     GIR_RootConstrainSelectedInstOperands,
     /*  758568 */     // GIR_Coverage, 14110,
     /*  758568 */     GIR_EraseRootFromParent_Done,
     /*  758569 */   // Label 11865: @758569
     /*  758569 */   GIM_Try, /*On fail goto*//*Label 11866*/ GIMT_Encode4(758647), // Rule ID 14111 //
     /*  758574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  758585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  758588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  758591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  758594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758620 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758645 */     GIR_RootConstrainSelectedInstOperands,
     /*  758646 */     // GIR_Coverage, 14111,
     /*  758646 */     GIR_EraseRootFromParent_Done,
     /*  758647 */   // Label 11866: @758647
     /*  758647 */   GIM_Try, /*On fail goto*//*Label 11867*/ GIMT_Encode4(758725), // Rule ID 14114 //
     /*  758652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  758663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  758666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  758669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  758672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758698 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758723 */     GIR_RootConstrainSelectedInstOperands,
     /*  758724 */     // GIR_Coverage, 14114,
     /*  758724 */     GIR_EraseRootFromParent_Done,
     /*  758725 */   // Label 11867: @758725
     /*  758725 */   GIM_Try, /*On fail goto*//*Label 11868*/ GIMT_Encode4(758803), // Rule ID 14115 //
     /*  758730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  758741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  758744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  758747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  758750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758776 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758801 */     GIR_RootConstrainSelectedInstOperands,
     /*  758802 */     // GIR_Coverage, 14115,
     /*  758802 */     GIR_EraseRootFromParent_Done,
     /*  758803 */   // Label 11868: @758803
     /*  758803 */   GIM_Try, /*On fail goto*//*Label 11869*/ GIMT_Encode4(758881), // Rule ID 14118 //
     /*  758808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  758825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  758828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758854 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758879 */     GIR_RootConstrainSelectedInstOperands,
     /*  758880 */     // GIR_Coverage, 14118,
     /*  758880 */     GIR_EraseRootFromParent_Done,
     /*  758881 */   // Label 11869: @758881
     /*  758881 */   GIM_Try, /*On fail goto*//*Label 11870*/ GIMT_Encode4(758959), // Rule ID 14119 //
     /*  758886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  758903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  758906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758932 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758957 */     GIR_RootConstrainSelectedInstOperands,
     /*  758958 */     // GIR_Coverage, 14119,
     /*  758958 */     GIR_EraseRootFromParent_Done,
     /*  758959 */   // Label 11870: @758959
     /*  758959 */   GIM_Try, /*On fail goto*//*Label 11871*/ GIMT_Encode4(759037), // Rule ID 14122 //
     /*  758964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  758981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  758984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759010 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759035 */     GIR_RootConstrainSelectedInstOperands,
     /*  759036 */     // GIR_Coverage, 14122,
     /*  759036 */     GIR_EraseRootFromParent_Done,
     /*  759037 */   // Label 11871: @759037
     /*  759037 */   GIM_Try, /*On fail goto*//*Label 11872*/ GIMT_Encode4(759115), // Rule ID 14123 //
     /*  759042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  759053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  759056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  759059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  759062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759088 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759113 */     GIR_RootConstrainSelectedInstOperands,
     /*  759114 */     // GIR_Coverage, 14123,
     /*  759114 */     GIR_EraseRootFromParent_Done,
     /*  759115 */   // Label 11872: @759115
     /*  759115 */   GIM_Try, /*On fail goto*//*Label 11873*/ GIMT_Encode4(759193), // Rule ID 14126 //
     /*  759120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  759131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  759134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  759137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  759140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759166 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759191 */     GIR_RootConstrainSelectedInstOperands,
     /*  759192 */     // GIR_Coverage, 14126,
     /*  759192 */     GIR_EraseRootFromParent_Done,
     /*  759193 */   // Label 11873: @759193
     /*  759193 */   GIM_Try, /*On fail goto*//*Label 11874*/ GIMT_Encode4(759271), // Rule ID 14127 //
     /*  759198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  759209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  759212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  759215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  759218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759244 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759269 */     GIR_RootConstrainSelectedInstOperands,
     /*  759270 */     // GIR_Coverage, 14127,
     /*  759270 */     GIR_EraseRootFromParent_Done,
     /*  759271 */   // Label 11874: @759271
     /*  759271 */   GIM_Try, /*On fail goto*//*Label 11875*/ GIMT_Encode4(759349), // Rule ID 14130 //
     /*  759276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  759287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  759290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  759293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  759296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  759325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759347 */     GIR_RootConstrainSelectedInstOperands,
     /*  759348 */     // GIR_Coverage, 14130,
     /*  759348 */     GIR_EraseRootFromParent_Done,
     /*  759349 */   // Label 11875: @759349
     /*  759349 */   GIM_Try, /*On fail goto*//*Label 11876*/ GIMT_Encode4(759427), // Rule ID 14131 //
     /*  759354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  759365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  759368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  759371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  759374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759400 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  759403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759425 */     GIR_RootConstrainSelectedInstOperands,
     /*  759426 */     // GIR_Coverage, 14131,
     /*  759426 */     GIR_EraseRootFromParent_Done,
     /*  759427 */   // Label 11876: @759427
     /*  759427 */   GIM_Try, /*On fail goto*//*Label 11877*/ GIMT_Encode4(759505), // Rule ID 14134 //
     /*  759432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  759443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  759446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  759449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  759452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759500 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759503 */     GIR_RootConstrainSelectedInstOperands,
     /*  759504 */     // GIR_Coverage, 14134,
     /*  759504 */     GIR_EraseRootFromParent_Done,
     /*  759505 */   // Label 11877: @759505
     /*  759505 */   GIM_Try, /*On fail goto*//*Label 11878*/ GIMT_Encode4(759583), // Rule ID 14135 //
     /*  759510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  759521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  759524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  759527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  759530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759581 */     GIR_RootConstrainSelectedInstOperands,
     /*  759582 */     // GIR_Coverage, 14135,
     /*  759582 */     GIR_EraseRootFromParent_Done,
     /*  759583 */   // Label 11878: @759583
     /*  759583 */   GIM_Try, /*On fail goto*//*Label 11879*/ GIMT_Encode4(759661), // Rule ID 14138 //
     /*  759588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  759605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  759608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759634 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759659 */     GIR_RootConstrainSelectedInstOperands,
     /*  759660 */     // GIR_Coverage, 14138,
     /*  759660 */     GIR_EraseRootFromParent_Done,
     /*  759661 */   // Label 11879: @759661
     /*  759661 */   GIM_Try, /*On fail goto*//*Label 11880*/ GIMT_Encode4(759739), // Rule ID 14139 //
     /*  759666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  759683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  759686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759712 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759737 */     GIR_RootConstrainSelectedInstOperands,
     /*  759738 */     // GIR_Coverage, 14139,
     /*  759738 */     GIR_EraseRootFromParent_Done,
     /*  759739 */   // Label 11880: @759739
     /*  759739 */   GIM_Try, /*On fail goto*//*Label 11881*/ GIMT_Encode4(759817), // Rule ID 14142 //
     /*  759744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  759747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  759761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  759764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  759793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759815 */     GIR_RootConstrainSelectedInstOperands,
     /*  759816 */     // GIR_Coverage, 14142,
     /*  759816 */     GIR_EraseRootFromParent_Done,
     /*  759817 */   // Label 11881: @759817
     /*  759817 */   GIM_Try, /*On fail goto*//*Label 11882*/ GIMT_Encode4(759895), // Rule ID 14143 //
     /*  759822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  759825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  759839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  759842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  759871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759893 */     GIR_RootConstrainSelectedInstOperands,
     /*  759894 */     // GIR_Coverage, 14143,
     /*  759894 */     GIR_EraseRootFromParent_Done,
     /*  759895 */   // Label 11882: @759895
     /*  759895 */   GIM_Try, /*On fail goto*//*Label 11883*/ GIMT_Encode4(759973), // Rule ID 14146 //
     /*  759900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  759903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  759917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  759920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759946 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759971 */     GIR_RootConstrainSelectedInstOperands,
     /*  759972 */     // GIR_Coverage, 14146,
     /*  759972 */     GIR_EraseRootFromParent_Done,
     /*  759973 */   // Label 11883: @759973
     /*  759973 */   GIM_Try, /*On fail goto*//*Label 11884*/ GIMT_Encode4(760051), // Rule ID 14147 //
     /*  759978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  759981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  759995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  759998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760024 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  760024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  760027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  760043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760049 */     GIR_RootConstrainSelectedInstOperands,
     /*  760050 */     // GIR_Coverage, 14147,
     /*  760050 */     GIR_EraseRootFromParent_Done,
     /*  760051 */   // Label 11884: @760051
     /*  760051 */   GIM_Try, /*On fail goto*//*Label 11885*/ GIMT_Encode4(760129), // Rule ID 14150 //
     /*  760056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  760059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  760067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  760070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  760073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  760076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  760102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  760105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  760121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760127 */     GIR_RootConstrainSelectedInstOperands,
     /*  760128 */     // GIR_Coverage, 14150,
     /*  760128 */     GIR_EraseRootFromParent_Done,
     /*  760129 */   // Label 11885: @760129
     /*  760129 */   GIM_Try, /*On fail goto*//*Label 11886*/ GIMT_Encode4(760207), // Rule ID 14151 //
     /*  760134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  760137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  760145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  760148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  760151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  760154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760180 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  760180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  760183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  760199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760205 */     GIR_RootConstrainSelectedInstOperands,
     /*  760206 */     // GIR_Coverage, 14151,
     /*  760206 */     GIR_EraseRootFromParent_Done,
     /*  760207 */   // Label 11886: @760207
     /*  760207 */   GIM_Try, /*On fail goto*//*Label 11887*/ GIMT_Encode4(760285), // Rule ID 14154 //
     /*  760212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  760223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  760226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  760229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760258 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  760261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760283 */     GIR_RootConstrainSelectedInstOperands,
     /*  760284 */     // GIR_Coverage, 14154,
     /*  760284 */     GIR_EraseRootFromParent_Done,
     /*  760285 */   // Label 11887: @760285
     /*  760285 */   GIM_Try, /*On fail goto*//*Label 11888*/ GIMT_Encode4(760363), // Rule ID 14155 //
     /*  760290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  760301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  760304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  760307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760336 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  760339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760361 */     GIR_RootConstrainSelectedInstOperands,
     /*  760362 */     // GIR_Coverage, 14155,
     /*  760362 */     GIR_EraseRootFromParent_Done,
     /*  760363 */   // Label 11888: @760363
     /*  760363 */   GIM_Try, /*On fail goto*//*Label 11889*/ GIMT_Encode4(760441), // Rule ID 14158 //
     /*  760368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  760379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  760382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  760385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760414 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760439 */     GIR_RootConstrainSelectedInstOperands,
     /*  760440 */     // GIR_Coverage, 14158,
     /*  760440 */     GIR_EraseRootFromParent_Done,
     /*  760441 */   // Label 11889: @760441
     /*  760441 */   GIM_Try, /*On fail goto*//*Label 11890*/ GIMT_Encode4(760519), // Rule ID 14159 //
     /*  760446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  760457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  760460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  760463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760492 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760517 */     GIR_RootConstrainSelectedInstOperands,
     /*  760518 */     // GIR_Coverage, 14159,
     /*  760518 */     GIR_EraseRootFromParent_Done,
     /*  760519 */   // Label 11890: @760519
     /*  760519 */   GIM_Try, /*On fail goto*//*Label 11891*/ GIMT_Encode4(760597), // Rule ID 14162 //
     /*  760524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  760535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  760538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  760541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760570 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760595 */     GIR_RootConstrainSelectedInstOperands,
     /*  760596 */     // GIR_Coverage, 14162,
     /*  760596 */     GIR_EraseRootFromParent_Done,
     /*  760597 */   // Label 11891: @760597
     /*  760597 */   GIM_Try, /*On fail goto*//*Label 11892*/ GIMT_Encode4(760675), // Rule ID 14163 //
     /*  760602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  760613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  760616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  760619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760648 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760673 */     GIR_RootConstrainSelectedInstOperands,
     /*  760674 */     // GIR_Coverage, 14163,
     /*  760674 */     GIR_EraseRootFromParent_Done,
     /*  760675 */   // Label 11892: @760675
     /*  760675 */   GIM_Try, /*On fail goto*//*Label 11893*/ GIMT_Encode4(760753), // Rule ID 14166 //
     /*  760680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  760691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  760694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  760697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760726 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760751 */     GIR_RootConstrainSelectedInstOperands,
     /*  760752 */     // GIR_Coverage, 14166,
     /*  760752 */     GIR_EraseRootFromParent_Done,
     /*  760753 */   // Label 11893: @760753
     /*  760753 */   GIM_Try, /*On fail goto*//*Label 11894*/ GIMT_Encode4(760831), // Rule ID 14167 //
     /*  760758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  760769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  760772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  760775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760804 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760829 */     GIR_RootConstrainSelectedInstOperands,
     /*  760830 */     // GIR_Coverage, 14167,
     /*  760830 */     GIR_EraseRootFromParent_Done,
     /*  760831 */   // Label 11894: @760831
     /*  760831 */   GIM_Try, /*On fail goto*//*Label 11895*/ GIMT_Encode4(760909), // Rule ID 14170 //
     /*  760836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760882 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760907 */     GIR_RootConstrainSelectedInstOperands,
     /*  760908 */     // GIR_Coverage, 14170,
     /*  760908 */     GIR_EraseRootFromParent_Done,
     /*  760909 */   // Label 11895: @760909
     /*  760909 */   GIM_Try, /*On fail goto*//*Label 11896*/ GIMT_Encode4(760987), // Rule ID 14171 //
     /*  760914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760960 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760985 */     GIR_RootConstrainSelectedInstOperands,
     /*  760986 */     // GIR_Coverage, 14171,
     /*  760986 */     GIR_EraseRootFromParent_Done,
     /*  760987 */   // Label 11896: @760987
     /*  760987 */   GIM_Try, /*On fail goto*//*Label 11897*/ GIMT_Encode4(761065), // Rule ID 14174 //
     /*  760992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  761003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  761006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  761009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761038 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  761041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761063 */     GIR_RootConstrainSelectedInstOperands,
     /*  761064 */     // GIR_Coverage, 14174,
     /*  761064 */     GIR_EraseRootFromParent_Done,
     /*  761065 */   // Label 11897: @761065
     /*  761065 */   GIM_Try, /*On fail goto*//*Label 11898*/ GIMT_Encode4(761143), // Rule ID 14175 //
     /*  761070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  761081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  761084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  761087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761116 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  761119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761141 */     GIR_RootConstrainSelectedInstOperands,
     /*  761142 */     // GIR_Coverage, 14175,
     /*  761142 */     GIR_EraseRootFromParent_Done,
     /*  761143 */   // Label 11898: @761143
     /*  761143 */   GIM_Try, /*On fail goto*//*Label 11899*/ GIMT_Encode4(761221), // Rule ID 14178 //
     /*  761148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  761159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  761162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  761165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761194 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761219 */     GIR_RootConstrainSelectedInstOperands,
     /*  761220 */     // GIR_Coverage, 14178,
     /*  761220 */     GIR_EraseRootFromParent_Done,
     /*  761221 */   // Label 11899: @761221
     /*  761221 */   GIM_Try, /*On fail goto*//*Label 11900*/ GIMT_Encode4(761299), // Rule ID 14179 //
     /*  761226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  761237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  761240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  761243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761272 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761297 */     GIR_RootConstrainSelectedInstOperands,
     /*  761298 */     // GIR_Coverage, 14179,
     /*  761298 */     GIR_EraseRootFromParent_Done,
     /*  761299 */   // Label 11900: @761299
     /*  761299 */   GIM_Try, /*On fail goto*//*Label 11901*/ GIMT_Encode4(761377), // Rule ID 14182 //
     /*  761304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  761315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  761318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  761321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761350 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  761350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761375 */     GIR_RootConstrainSelectedInstOperands,
     /*  761376 */     // GIR_Coverage, 14182,
     /*  761376 */     GIR_EraseRootFromParent_Done,
     /*  761377 */   // Label 11901: @761377
     /*  761377 */   GIM_Try, /*On fail goto*//*Label 11902*/ GIMT_Encode4(761455), // Rule ID 14183 //
     /*  761382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  761393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  761396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  761399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761428 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  761428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761453 */     GIR_RootConstrainSelectedInstOperands,
     /*  761454 */     // GIR_Coverage, 14183,
     /*  761454 */     GIR_EraseRootFromParent_Done,
     /*  761455 */   // Label 11902: @761455
     /*  761455 */   GIM_Try, /*On fail goto*//*Label 11903*/ GIMT_Encode4(761533), // Rule ID 14186 //
     /*  761460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  761471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  761474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  761477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761506 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761531 */     GIR_RootConstrainSelectedInstOperands,
     /*  761532 */     // GIR_Coverage, 14186,
     /*  761532 */     GIR_EraseRootFromParent_Done,
     /*  761533 */   // Label 11903: @761533
     /*  761533 */   GIM_Try, /*On fail goto*//*Label 11904*/ GIMT_Encode4(761611), // Rule ID 14187 //
     /*  761538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  761549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  761552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  761555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761609 */     GIR_RootConstrainSelectedInstOperands,
     /*  761610 */     // GIR_Coverage, 14187,
     /*  761610 */     GIR_EraseRootFromParent_Done,
     /*  761611 */   // Label 11904: @761611
     /*  761611 */   GIM_Try, /*On fail goto*//*Label 11905*/ GIMT_Encode4(761689), // Rule ID 14190 //
     /*  761616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  761619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  761627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  761630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  761633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761662 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  761662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761687 */     GIR_RootConstrainSelectedInstOperands,
     /*  761688 */     // GIR_Coverage, 14190,
     /*  761688 */     GIR_EraseRootFromParent_Done,
     /*  761689 */   // Label 11905: @761689
     /*  761689 */   GIM_Try, /*On fail goto*//*Label 11906*/ GIMT_Encode4(761767), // Rule ID 14191 //
     /*  761694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  761697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  761705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  761708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  761711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761740 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  761740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761765 */     GIR_RootConstrainSelectedInstOperands,
     /*  761766 */     // GIR_Coverage, 14191,
     /*  761766 */     GIR_EraseRootFromParent_Done,
     /*  761767 */   // Label 11906: @761767
     /*  761767 */   GIM_Try, /*On fail goto*//*Label 11907*/ GIMT_Encode4(761845), // Rule ID 14194 //
     /*  761772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  761783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  761786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  761789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761843 */     GIR_RootConstrainSelectedInstOperands,
     /*  761844 */     // GIR_Coverage, 14194,
     /*  761844 */     GIR_EraseRootFromParent_Done,
     /*  761845 */   // Label 11907: @761845
     /*  761845 */   GIM_Try, /*On fail goto*//*Label 11908*/ GIMT_Encode4(761923), // Rule ID 14195 //
     /*  761850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  761861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  761864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  761867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761921 */     GIR_RootConstrainSelectedInstOperands,
     /*  761922 */     // GIR_Coverage, 14195,
     /*  761922 */     GIR_EraseRootFromParent_Done,
     /*  761923 */   // Label 11908: @761923
     /*  761923 */   GIM_Try, /*On fail goto*//*Label 11909*/ GIMT_Encode4(762001), // Rule ID 14198 //
     /*  761928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  761939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  761942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  761945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761974 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  761977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761999 */     GIR_RootConstrainSelectedInstOperands,
     /*  762000 */     // GIR_Coverage, 14198,
     /*  762000 */     GIR_EraseRootFromParent_Done,
     /*  762001 */   // Label 11909: @762001
     /*  762001 */   GIM_Try, /*On fail goto*//*Label 11910*/ GIMT_Encode4(762079), // Rule ID 14199 //
     /*  762006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  762017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  762020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  762023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762052 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  762052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762077 */     GIR_RootConstrainSelectedInstOperands,
     /*  762078 */     // GIR_Coverage, 14199,
     /*  762078 */     GIR_EraseRootFromParent_Done,
     /*  762079 */   // Label 11910: @762079
     /*  762079 */   GIM_Try, /*On fail goto*//*Label 11911*/ GIMT_Encode4(762157), // Rule ID 14202 //
     /*  762084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  762095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  762098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  762101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762130 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  762130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762155 */     GIR_RootConstrainSelectedInstOperands,
     /*  762156 */     // GIR_Coverage, 14202,
     /*  762156 */     GIR_EraseRootFromParent_Done,
     /*  762157 */   // Label 11911: @762157
     /*  762157 */   GIM_Try, /*On fail goto*//*Label 11912*/ GIMT_Encode4(762235), // Rule ID 14203 //
     /*  762162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  762173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  762176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  762179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762208 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  762208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762233 */     GIR_RootConstrainSelectedInstOperands,
     /*  762234 */     // GIR_Coverage, 14203,
     /*  762234 */     GIR_EraseRootFromParent_Done,
     /*  762235 */   // Label 11912: @762235
     /*  762235 */   GIM_Try, /*On fail goto*//*Label 11913*/ GIMT_Encode4(762313), // Rule ID 14206 //
     /*  762240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  762251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  762254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  762257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762286 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762311 */     GIR_RootConstrainSelectedInstOperands,
     /*  762312 */     // GIR_Coverage, 14206,
     /*  762312 */     GIR_EraseRootFromParent_Done,
     /*  762313 */   // Label 11913: @762313
     /*  762313 */   GIM_Try, /*On fail goto*//*Label 11914*/ GIMT_Encode4(762391), // Rule ID 14207 //
     /*  762318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  762329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  762332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  762335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762364 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762389 */     GIR_RootConstrainSelectedInstOperands,
     /*  762390 */     // GIR_Coverage, 14207,
     /*  762390 */     GIR_EraseRootFromParent_Done,
     /*  762391 */   // Label 11914: @762391
     /*  762391 */   GIM_Try, /*On fail goto*//*Label 11915*/ GIMT_Encode4(762469), // Rule ID 14210 //
     /*  762396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  762407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  762410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  762413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762442 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762467 */     GIR_RootConstrainSelectedInstOperands,
     /*  762468 */     // GIR_Coverage, 14210,
     /*  762468 */     GIR_EraseRootFromParent_Done,
     /*  762469 */   // Label 11915: @762469
     /*  762469 */   GIM_Try, /*On fail goto*//*Label 11916*/ GIMT_Encode4(762547), // Rule ID 14211 //
     /*  762474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  762485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  762488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  762491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762520 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762545 */     GIR_RootConstrainSelectedInstOperands,
     /*  762546 */     // GIR_Coverage, 14211,
     /*  762546 */     GIR_EraseRootFromParent_Done,
     /*  762547 */   // Label 11916: @762547
     /*  762547 */   GIM_Try, /*On fail goto*//*Label 11917*/ GIMT_Encode4(762625), // Rule ID 14214 //
     /*  762552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  762563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  762566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  762569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762598 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762623 */     GIR_RootConstrainSelectedInstOperands,
     /*  762624 */     // GIR_Coverage, 14214,
     /*  762624 */     GIR_EraseRootFromParent_Done,
     /*  762625 */   // Label 11917: @762625
     /*  762625 */   GIM_Try, /*On fail goto*//*Label 11918*/ GIMT_Encode4(762703), // Rule ID 14215 //
     /*  762630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  762641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  762644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  762647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762676 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762701 */     GIR_RootConstrainSelectedInstOperands,
     /*  762702 */     // GIR_Coverage, 14215,
     /*  762702 */     GIR_EraseRootFromParent_Done,
     /*  762703 */   // Label 11918: @762703
     /*  762703 */   GIM_Try, /*On fail goto*//*Label 11919*/ GIMT_Encode4(762781), // Rule ID 14218 //
     /*  762708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  762719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  762722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  762725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762779 */     GIR_RootConstrainSelectedInstOperands,
     /*  762780 */     // GIR_Coverage, 14218,
     /*  762780 */     GIR_EraseRootFromParent_Done,
     /*  762781 */   // Label 11919: @762781
     /*  762781 */   GIM_Try, /*On fail goto*//*Label 11920*/ GIMT_Encode4(762859), // Rule ID 14219 //
     /*  762786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  762797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  762800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  762803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762857 */     GIR_RootConstrainSelectedInstOperands,
     /*  762858 */     // GIR_Coverage, 14219,
     /*  762858 */     GIR_EraseRootFromParent_Done,
     /*  762859 */   // Label 11920: @762859
     /*  762859 */   GIM_Try, /*On fail goto*//*Label 11921*/ GIMT_Encode4(762937), // Rule ID 14222 //
     /*  762864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  762875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  762878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  762881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762910 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762935 */     GIR_RootConstrainSelectedInstOperands,
     /*  762936 */     // GIR_Coverage, 14222,
     /*  762936 */     GIR_EraseRootFromParent_Done,
     /*  762937 */   // Label 11921: @762937
     /*  762937 */   GIM_Try, /*On fail goto*//*Label 11922*/ GIMT_Encode4(763015), // Rule ID 14223 //
     /*  762942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  762953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  762956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  762959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762988 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763013 */     GIR_RootConstrainSelectedInstOperands,
     /*  763014 */     // GIR_Coverage, 14223,
     /*  763014 */     GIR_EraseRootFromParent_Done,
     /*  763015 */   // Label 11922: @763015
     /*  763015 */   GIM_Try, /*On fail goto*//*Label 11923*/ GIMT_Encode4(763093), // Rule ID 14226 //
     /*  763020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  763031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  763034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  763037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763066 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  763066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  763069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763091 */     GIR_RootConstrainSelectedInstOperands,
     /*  763092 */     // GIR_Coverage, 14226,
     /*  763092 */     GIR_EraseRootFromParent_Done,
     /*  763093 */   // Label 11923: @763093
     /*  763093 */   GIM_Try, /*On fail goto*//*Label 11924*/ GIMT_Encode4(763171), // Rule ID 14227 //
     /*  763098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  763109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  763112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  763115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763144 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  763144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  763147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763169 */     GIR_RootConstrainSelectedInstOperands,
     /*  763170 */     // GIR_Coverage, 14227,
     /*  763170 */     GIR_EraseRootFromParent_Done,
     /*  763171 */   // Label 11924: @763171
     /*  763171 */   GIM_Try, /*On fail goto*//*Label 11925*/ GIMT_Encode4(763249), // Rule ID 14230 //
     /*  763176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  763187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  763190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  763193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763222 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  763225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763247 */     GIR_RootConstrainSelectedInstOperands,
     /*  763248 */     // GIR_Coverage, 14230,
     /*  763248 */     GIR_EraseRootFromParent_Done,
     /*  763249 */   // Label 11925: @763249
     /*  763249 */   GIM_Try, /*On fail goto*//*Label 11926*/ GIMT_Encode4(763327), // Rule ID 14231 //
     /*  763254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  763265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  763268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  763271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  763303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763325 */     GIR_RootConstrainSelectedInstOperands,
     /*  763326 */     // GIR_Coverage, 14231,
     /*  763326 */     GIR_EraseRootFromParent_Done,
     /*  763327 */   // Label 11926: @763327
     /*  763327 */   GIM_Try, /*On fail goto*//*Label 11927*/ GIMT_Encode4(763405), // Rule ID 14234 //
     /*  763332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  763343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  763346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  763349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763378 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  763381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763403 */     GIR_RootConstrainSelectedInstOperands,
     /*  763404 */     // GIR_Coverage, 14234,
     /*  763404 */     GIR_EraseRootFromParent_Done,
     /*  763405 */   // Label 11927: @763405
     /*  763405 */   GIM_Try, /*On fail goto*//*Label 11928*/ GIMT_Encode4(763483), // Rule ID 14235 //
     /*  763410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  763421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  763424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  763427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763456 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  763459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763481 */     GIR_RootConstrainSelectedInstOperands,
     /*  763482 */     // GIR_Coverage, 14235,
     /*  763482 */     GIR_EraseRootFromParent_Done,
     /*  763483 */   // Label 11928: @763483
     /*  763483 */   GIM_Try, /*On fail goto*//*Label 11929*/ GIMT_Encode4(763561), // Rule ID 14238 //
     /*  763488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  763499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  763502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  763505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763534 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  763537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763559 */     GIR_RootConstrainSelectedInstOperands,
     /*  763560 */     // GIR_Coverage, 14238,
     /*  763560 */     GIR_EraseRootFromParent_Done,
     /*  763561 */   // Label 11929: @763561
     /*  763561 */   GIM_Try, /*On fail goto*//*Label 11930*/ GIMT_Encode4(763639), // Rule ID 14239 //
     /*  763566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  763577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  763580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  763583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763612 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  763615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763637 */     GIR_RootConstrainSelectedInstOperands,
     /*  763638 */     // GIR_Coverage, 14239,
     /*  763638 */     GIR_EraseRootFromParent_Done,
     /*  763639 */   // Label 11930: @763639
     /*  763639 */   GIM_Try, /*On fail goto*//*Label 11931*/ GIMT_Encode4(763717), // Rule ID 14330 //
     /*  763644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  763655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  763658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  763661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  763664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763690 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  763693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763715 */     GIR_RootConstrainSelectedInstOperands,
     /*  763716 */     // GIR_Coverage, 14330,
     /*  763716 */     GIR_EraseRootFromParent_Done,
     /*  763717 */   // Label 11931: @763717
     /*  763717 */   GIM_Try, /*On fail goto*//*Label 11932*/ GIMT_Encode4(763795), // Rule ID 14331 //
     /*  763722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  763733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  763736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  763739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  763742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763768 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  763771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763793 */     GIR_RootConstrainSelectedInstOperands,
     /*  763794 */     // GIR_Coverage, 14331,
     /*  763794 */     GIR_EraseRootFromParent_Done,
     /*  763795 */   // Label 11932: @763795
     /*  763795 */   GIM_Try, /*On fail goto*//*Label 11933*/ GIMT_Encode4(763873), // Rule ID 14334 //
     /*  763800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  763811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  763814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  763817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  763820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763846 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763871 */     GIR_RootConstrainSelectedInstOperands,
     /*  763872 */     // GIR_Coverage, 14334,
     /*  763872 */     GIR_EraseRootFromParent_Done,
     /*  763873 */   // Label 11933: @763873
     /*  763873 */   GIM_Try, /*On fail goto*//*Label 11934*/ GIMT_Encode4(763951), // Rule ID 14335 //
     /*  763878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  763889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  763892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  763895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  763898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763924 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763949 */     GIR_RootConstrainSelectedInstOperands,
     /*  763950 */     // GIR_Coverage, 14335,
     /*  763950 */     GIR_EraseRootFromParent_Done,
     /*  763951 */   // Label 11934: @763951
     /*  763951 */   GIM_Try, /*On fail goto*//*Label 11935*/ GIMT_Encode4(764029), // Rule ID 14338 //
     /*  763956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  763967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  763970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  763973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  763976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764002 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764027 */     GIR_RootConstrainSelectedInstOperands,
     /*  764028 */     // GIR_Coverage, 14338,
     /*  764028 */     GIR_EraseRootFromParent_Done,
     /*  764029 */   // Label 11935: @764029
     /*  764029 */   GIM_Try, /*On fail goto*//*Label 11936*/ GIMT_Encode4(764107), // Rule ID 14339 //
     /*  764034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  764045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  764048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  764051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  764054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764080 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764102 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764105 */     GIR_RootConstrainSelectedInstOperands,
     /*  764106 */     // GIR_Coverage, 14339,
     /*  764106 */     GIR_EraseRootFromParent_Done,
     /*  764107 */   // Label 11936: @764107
     /*  764107 */   GIM_Try, /*On fail goto*//*Label 11937*/ GIMT_Encode4(764185), // Rule ID 14342 //
     /*  764112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  764123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  764126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  764129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  764132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764158 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  764161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764183 */     GIR_RootConstrainSelectedInstOperands,
     /*  764184 */     // GIR_Coverage, 14342,
     /*  764184 */     GIR_EraseRootFromParent_Done,
     /*  764185 */   // Label 11937: @764185
     /*  764185 */   GIM_Try, /*On fail goto*//*Label 11938*/ GIMT_Encode4(764263), // Rule ID 14343 //
     /*  764190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  764201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  764204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  764207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  764210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764236 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  764239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764261 */     GIR_RootConstrainSelectedInstOperands,
     /*  764262 */     // GIR_Coverage, 14343,
     /*  764262 */     GIR_EraseRootFromParent_Done,
     /*  764263 */   // Label 11938: @764263
     /*  764263 */   GIM_Try, /*On fail goto*//*Label 11939*/ GIMT_Encode4(764341), // Rule ID 14346 //
     /*  764268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  764279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  764282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  764285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  764288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764314 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764339 */     GIR_RootConstrainSelectedInstOperands,
     /*  764340 */     // GIR_Coverage, 14346,
     /*  764340 */     GIR_EraseRootFromParent_Done,
     /*  764341 */   // Label 11939: @764341
     /*  764341 */   GIM_Try, /*On fail goto*//*Label 11940*/ GIMT_Encode4(764419), // Rule ID 14347 //
     /*  764346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  764357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  764360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  764363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  764366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764392 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764417 */     GIR_RootConstrainSelectedInstOperands,
     /*  764418 */     // GIR_Coverage, 14347,
     /*  764418 */     GIR_EraseRootFromParent_Done,
     /*  764419 */   // Label 11940: @764419
     /*  764419 */   GIM_Try, /*On fail goto*//*Label 11941*/ GIMT_Encode4(764497), // Rule ID 14350 //
     /*  764424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  764435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  764438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  764441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  764444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764470 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764495 */     GIR_RootConstrainSelectedInstOperands,
     /*  764496 */     // GIR_Coverage, 14350,
     /*  764496 */     GIR_EraseRootFromParent_Done,
     /*  764497 */   // Label 11941: @764497
     /*  764497 */   GIM_Try, /*On fail goto*//*Label 11942*/ GIMT_Encode4(764575), // Rule ID 14351 //
     /*  764502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  764513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  764516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  764519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  764522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764548 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764573 */     GIR_RootConstrainSelectedInstOperands,
     /*  764574 */     // GIR_Coverage, 14351,
     /*  764574 */     GIR_EraseRootFromParent_Done,
     /*  764575 */   // Label 11942: @764575
     /*  764575 */   GIM_Try, /*On fail goto*//*Label 11943*/ GIMT_Encode4(764653), // Rule ID 14354 //
     /*  764580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  764591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  764594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  764597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  764600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764626 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764651 */     GIR_RootConstrainSelectedInstOperands,
     /*  764652 */     // GIR_Coverage, 14354,
     /*  764652 */     GIR_EraseRootFromParent_Done,
     /*  764653 */   // Label 11943: @764653
     /*  764653 */   GIM_Try, /*On fail goto*//*Label 11944*/ GIMT_Encode4(764731), // Rule ID 14355 //
     /*  764658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  764669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  764672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  764675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  764678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764704 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764729 */     GIR_RootConstrainSelectedInstOperands,
     /*  764730 */     // GIR_Coverage, 14355,
     /*  764730 */     GIR_EraseRootFromParent_Done,
     /*  764731 */   // Label 11944: @764731
     /*  764731 */   GIM_Try, /*On fail goto*//*Label 11945*/ GIMT_Encode4(764809), // Rule ID 14358 //
     /*  764736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  764747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  764750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  764753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  764756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764807 */     GIR_RootConstrainSelectedInstOperands,
     /*  764808 */     // GIR_Coverage, 14358,
     /*  764808 */     GIR_EraseRootFromParent_Done,
     /*  764809 */   // Label 11945: @764809
     /*  764809 */   GIM_Try, /*On fail goto*//*Label 11946*/ GIMT_Encode4(764887), // Rule ID 14359 //
     /*  764814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  764825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  764828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  764831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  764834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764885 */     GIR_RootConstrainSelectedInstOperands,
     /*  764886 */     // GIR_Coverage, 14359,
     /*  764886 */     GIR_EraseRootFromParent_Done,
     /*  764887 */   // Label 11946: @764887
     /*  764887 */   GIM_Try, /*On fail goto*//*Label 11947*/ GIMT_Encode4(764965), // Rule ID 14362 //
     /*  764892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  764903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  764912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764938 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764963 */     GIR_RootConstrainSelectedInstOperands,
     /*  764964 */     // GIR_Coverage, 14362,
     /*  764964 */     GIR_EraseRootFromParent_Done,
     /*  764965 */   // Label 11947: @764965
     /*  764965 */   GIM_Try, /*On fail goto*//*Label 11948*/ GIMT_Encode4(765043), // Rule ID 14363 //
     /*  764970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  764981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  764990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765016 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  765016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  765019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765041 */     GIR_RootConstrainSelectedInstOperands,
     /*  765042 */     // GIR_Coverage, 14363,
     /*  765042 */     GIR_EraseRootFromParent_Done,
     /*  765043 */   // Label 11948: @765043
     /*  765043 */   GIM_Try, /*On fail goto*//*Label 11949*/ GIMT_Encode4(765121), // Rule ID 14366 //
     /*  765048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  765051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  765059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  765062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  765065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  765068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  765094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  765097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765119 */     GIR_RootConstrainSelectedInstOperands,
     /*  765120 */     // GIR_Coverage, 14366,
     /*  765120 */     GIR_EraseRootFromParent_Done,
     /*  765121 */   // Label 11949: @765121
     /*  765121 */   GIM_Try, /*On fail goto*//*Label 11950*/ GIMT_Encode4(765199), // Rule ID 14367 //
     /*  765126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  765129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  765137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  765140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  765143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  765146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765172 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  765172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  765175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765197 */     GIR_RootConstrainSelectedInstOperands,
     /*  765198 */     // GIR_Coverage, 14367,
     /*  765198 */     GIR_EraseRootFromParent_Done,
     /*  765199 */   // Label 11950: @765199
     /*  765199 */   GIM_Try, /*On fail goto*//*Label 11951*/ GIMT_Encode4(765277), // Rule ID 14370 //
     /*  765204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  765215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  765218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  765221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  765224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765250 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765275 */     GIR_RootConstrainSelectedInstOperands,
     /*  765276 */     // GIR_Coverage, 14370,
     /*  765276 */     GIR_EraseRootFromParent_Done,
     /*  765277 */   // Label 11951: @765277
     /*  765277 */   GIM_Try, /*On fail goto*//*Label 11952*/ GIMT_Encode4(765355), // Rule ID 14371 //
     /*  765282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  765293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  765296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  765299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  765302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765328 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765353 */     GIR_RootConstrainSelectedInstOperands,
     /*  765354 */     // GIR_Coverage, 14371,
     /*  765354 */     GIR_EraseRootFromParent_Done,
     /*  765355 */   // Label 11952: @765355
     /*  765355 */   GIM_Try, /*On fail goto*//*Label 11953*/ GIMT_Encode4(765433), // Rule ID 14374 //
     /*  765360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  765371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  765374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  765377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  765380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765406 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765431 */     GIR_RootConstrainSelectedInstOperands,
     /*  765432 */     // GIR_Coverage, 14374,
     /*  765432 */     GIR_EraseRootFromParent_Done,
     /*  765433 */   // Label 11953: @765433
     /*  765433 */   GIM_Try, /*On fail goto*//*Label 11954*/ GIMT_Encode4(765511), // Rule ID 14375 //
     /*  765438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  765449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  765452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  765455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  765458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765484 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765509 */     GIR_RootConstrainSelectedInstOperands,
     /*  765510 */     // GIR_Coverage, 14375,
     /*  765510 */     GIR_EraseRootFromParent_Done,
     /*  765511 */   // Label 11954: @765511
     /*  765511 */   GIM_Try, /*On fail goto*//*Label 11955*/ GIMT_Encode4(765589), // Rule ID 14378 //
     /*  765516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  765527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  765530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  765533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  765536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765562 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765587 */     GIR_RootConstrainSelectedInstOperands,
     /*  765588 */     // GIR_Coverage, 14378,
     /*  765588 */     GIR_EraseRootFromParent_Done,
     /*  765589 */   // Label 11955: @765589
     /*  765589 */   GIM_Try, /*On fail goto*//*Label 11956*/ GIMT_Encode4(765667), // Rule ID 14379 //
     /*  765594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  765605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  765608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  765611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  765614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765640 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765665 */     GIR_RootConstrainSelectedInstOperands,
     /*  765666 */     // GIR_Coverage, 14379,
     /*  765666 */     GIR_EraseRootFromParent_Done,
     /*  765667 */   // Label 11956: @765667
     /*  765667 */   GIM_Try, /*On fail goto*//*Label 11957*/ GIMT_Encode4(765745), // Rule ID 14382 //
     /*  765672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  765683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  765686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  765689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  765692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765743 */     GIR_RootConstrainSelectedInstOperands,
     /*  765744 */     // GIR_Coverage, 14382,
     /*  765744 */     GIR_EraseRootFromParent_Done,
     /*  765745 */   // Label 11957: @765745
     /*  765745 */   GIM_Try, /*On fail goto*//*Label 11958*/ GIMT_Encode4(765823), // Rule ID 14383 //
     /*  765750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  765761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  765764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  765767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  765770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765821 */     GIR_RootConstrainSelectedInstOperands,
     /*  765822 */     // GIR_Coverage, 14383,
     /*  765822 */     GIR_EraseRootFromParent_Done,
     /*  765823 */   // Label 11958: @765823
     /*  765823 */   GIM_Try, /*On fail goto*//*Label 11959*/ GIMT_Encode4(765901), // Rule ID 14386 //
     /*  765828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  765839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  765842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  765845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  765848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765899 */     GIR_RootConstrainSelectedInstOperands,
     /*  765900 */     // GIR_Coverage, 14386,
     /*  765900 */     GIR_EraseRootFromParent_Done,
     /*  765901 */   // Label 11959: @765901
     /*  765901 */   GIM_Try, /*On fail goto*//*Label 11960*/ GIMT_Encode4(765979), // Rule ID 14387 //
     /*  765906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  765917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  765920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  765923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  765926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765952 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765977 */     GIR_RootConstrainSelectedInstOperands,
     /*  765978 */     // GIR_Coverage, 14387,
     /*  765978 */     GIR_EraseRootFromParent_Done,
     /*  765979 */   // Label 11960: @765979
     /*  765979 */   GIM_Try, /*On fail goto*//*Label 11961*/ GIMT_Encode4(766057), // Rule ID 14390 //
     /*  765984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  765995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  765998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  766001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  766004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766030 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  766030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766055 */     GIR_RootConstrainSelectedInstOperands,
     /*  766056 */     // GIR_Coverage, 14390,
     /*  766056 */     GIR_EraseRootFromParent_Done,
     /*  766057 */   // Label 11961: @766057
     /*  766057 */   GIM_Try, /*On fail goto*//*Label 11962*/ GIMT_Encode4(766135), // Rule ID 14391 //
     /*  766062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  766073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  766076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  766079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  766082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766108 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  766108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766133 */     GIR_RootConstrainSelectedInstOperands,
     /*  766134 */     // GIR_Coverage, 14391,
     /*  766134 */     GIR_EraseRootFromParent_Done,
     /*  766135 */   // Label 11962: @766135
     /*  766135 */   GIM_Try, /*On fail goto*//*Label 11963*/ GIMT_Encode4(766213), // Rule ID 14394 //
     /*  766140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  766151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  766154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  766157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  766160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766186 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  766189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766211 */     GIR_RootConstrainSelectedInstOperands,
     /*  766212 */     // GIR_Coverage, 14394,
     /*  766212 */     GIR_EraseRootFromParent_Done,
     /*  766213 */   // Label 11963: @766213
     /*  766213 */   GIM_Try, /*On fail goto*//*Label 11964*/ GIMT_Encode4(766291), // Rule ID 14395 //
     /*  766218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  766229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  766232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  766235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  766238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  766267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766289 */     GIR_RootConstrainSelectedInstOperands,
     /*  766290 */     // GIR_Coverage, 14395,
     /*  766290 */     GIR_EraseRootFromParent_Done,
     /*  766291 */   // Label 11964: @766291
     /*  766291 */   GIM_Try, /*On fail goto*//*Label 11965*/ GIMT_Encode4(766369), // Rule ID 14398 //
     /*  766296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  766307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  766310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  766313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  766316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766342 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  766345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766367 */     GIR_RootConstrainSelectedInstOperands,
     /*  766368 */     // GIR_Coverage, 14398,
     /*  766368 */     GIR_EraseRootFromParent_Done,
     /*  766369 */   // Label 11965: @766369
     /*  766369 */   GIM_Try, /*On fail goto*//*Label 11966*/ GIMT_Encode4(766447), // Rule ID 14399 //
     /*  766374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  766385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  766388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  766391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  766394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766420 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  766423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766445 */     GIR_RootConstrainSelectedInstOperands,
     /*  766446 */     // GIR_Coverage, 14399,
     /*  766446 */     GIR_EraseRootFromParent_Done,
     /*  766447 */   // Label 11966: @766447
     /*  766447 */   GIM_Try, /*On fail goto*//*Label 11967*/ GIMT_Encode4(766525), // Rule ID 14402 //
     /*  766452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  766463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  766466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  766469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  766472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766523 */     GIR_RootConstrainSelectedInstOperands,
     /*  766524 */     // GIR_Coverage, 14402,
     /*  766524 */     GIR_EraseRootFromParent_Done,
     /*  766525 */   // Label 11967: @766525
     /*  766525 */   GIM_Try, /*On fail goto*//*Label 11968*/ GIMT_Encode4(766603), // Rule ID 14403 //
     /*  766530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  766541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  766544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  766547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  766550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766576 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766601 */     GIR_RootConstrainSelectedInstOperands,
     /*  766602 */     // GIR_Coverage, 14403,
     /*  766602 */     GIR_EraseRootFromParent_Done,
     /*  766603 */   // Label 11968: @766603
     /*  766603 */   GIM_Try, /*On fail goto*//*Label 11969*/ GIMT_Encode4(766681), // Rule ID 14406 //
     /*  766608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  766619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  766622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  766625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  766628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  766657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766679 */     GIR_RootConstrainSelectedInstOperands,
     /*  766680 */     // GIR_Coverage, 14406,
     /*  766680 */     GIR_EraseRootFromParent_Done,
     /*  766681 */   // Label 11969: @766681
     /*  766681 */   GIM_Try, /*On fail goto*//*Label 11970*/ GIMT_Encode4(766759), // Rule ID 14407 //
     /*  766686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  766697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  766700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  766703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  766706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766732 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  766735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766757 */     GIR_RootConstrainSelectedInstOperands,
     /*  766758 */     // GIR_Coverage, 14407,
     /*  766758 */     GIR_EraseRootFromParent_Done,
     /*  766759 */   // Label 11970: @766759
     /*  766759 */   GIM_Try, /*On fail goto*//*Label 11971*/ GIMT_Encode4(766837), // Rule ID 14410 //
     /*  766764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  766775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  766778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  766781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  766784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766810 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  766813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766835 */     GIR_RootConstrainSelectedInstOperands,
     /*  766836 */     // GIR_Coverage, 14410,
     /*  766836 */     GIR_EraseRootFromParent_Done,
     /*  766837 */   // Label 11971: @766837
     /*  766837 */   GIM_Try, /*On fail goto*//*Label 11972*/ GIMT_Encode4(766915), // Rule ID 14411 //
     /*  766842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  766853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  766856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  766859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  766862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766888 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  766891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766913 */     GIR_RootConstrainSelectedInstOperands,
     /*  766914 */     // GIR_Coverage, 14411,
     /*  766914 */     GIR_EraseRootFromParent_Done,
     /*  766915 */   // Label 11972: @766915
     /*  766915 */   GIM_Try, /*On fail goto*//*Label 11973*/ GIMT_Encode4(766993), // Rule ID 14414 //
     /*  766920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  766931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  766934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  766937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  766940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766966 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766991 */     GIR_RootConstrainSelectedInstOperands,
     /*  766992 */     // GIR_Coverage, 14414,
     /*  766992 */     GIR_EraseRootFromParent_Done,
     /*  766993 */   // Label 11973: @766993
     /*  766993 */   GIM_Try, /*On fail goto*//*Label 11974*/ GIMT_Encode4(767071), // Rule ID 14415 //
     /*  766998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  767001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  767009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  767012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  767015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  767018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767044 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  767044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  767047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  767063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767069 */     GIR_RootConstrainSelectedInstOperands,
     /*  767070 */     // GIR_Coverage, 14415,
     /*  767070 */     GIR_EraseRootFromParent_Done,
     /*  767071 */   // Label 11974: @767071
     /*  767071 */   GIM_Try, /*On fail goto*//*Label 11975*/ GIMT_Encode4(767149), // Rule ID 14418 //
     /*  767076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  767087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  767090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  767093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767122 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  767125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767147 */     GIR_RootConstrainSelectedInstOperands,
     /*  767148 */     // GIR_Coverage, 14418,
     /*  767148 */     GIR_EraseRootFromParent_Done,
     /*  767149 */   // Label 11975: @767149
     /*  767149 */   GIM_Try, /*On fail goto*//*Label 11976*/ GIMT_Encode4(767227), // Rule ID 14419 //
     /*  767154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  767165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  767168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  767171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767200 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  767203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767225 */     GIR_RootConstrainSelectedInstOperands,
     /*  767226 */     // GIR_Coverage, 14419,
     /*  767226 */     GIR_EraseRootFromParent_Done,
     /*  767227 */   // Label 11976: @767227
     /*  767227 */   GIM_Try, /*On fail goto*//*Label 11977*/ GIMT_Encode4(767305), // Rule ID 14422 //
     /*  767232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  767243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  767246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  767249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767278 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  767281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767303 */     GIR_RootConstrainSelectedInstOperands,
     /*  767304 */     // GIR_Coverage, 14422,
     /*  767304 */     GIR_EraseRootFromParent_Done,
     /*  767305 */   // Label 11977: @767305
     /*  767305 */   GIM_Try, /*On fail goto*//*Label 11978*/ GIMT_Encode4(767383), // Rule ID 14423 //
     /*  767310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  767321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  767324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  767327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767356 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  767359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767381 */     GIR_RootConstrainSelectedInstOperands,
     /*  767382 */     // GIR_Coverage, 14423,
     /*  767382 */     GIR_EraseRootFromParent_Done,
     /*  767383 */   // Label 11978: @767383
     /*  767383 */   GIM_Try, /*On fail goto*//*Label 11979*/ GIMT_Encode4(767461), // Rule ID 14426 //
     /*  767388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  767399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  767402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  767405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767434 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767459 */     GIR_RootConstrainSelectedInstOperands,
     /*  767460 */     // GIR_Coverage, 14426,
     /*  767460 */     GIR_EraseRootFromParent_Done,
     /*  767461 */   // Label 11979: @767461
     /*  767461 */   GIM_Try, /*On fail goto*//*Label 11980*/ GIMT_Encode4(767539), // Rule ID 14427 //
     /*  767466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  767477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  767480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  767483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767512 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767537 */     GIR_RootConstrainSelectedInstOperands,
     /*  767538 */     // GIR_Coverage, 14427,
     /*  767538 */     GIR_EraseRootFromParent_Done,
     /*  767539 */   // Label 11980: @767539
     /*  767539 */   GIM_Try, /*On fail goto*//*Label 11981*/ GIMT_Encode4(767617), // Rule ID 14430 //
     /*  767544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  767555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  767558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  767561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767590 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  767593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767615 */     GIR_RootConstrainSelectedInstOperands,
     /*  767616 */     // GIR_Coverage, 14430,
     /*  767616 */     GIR_EraseRootFromParent_Done,
     /*  767617 */   // Label 11981: @767617
     /*  767617 */   GIM_Try, /*On fail goto*//*Label 11982*/ GIMT_Encode4(767695), // Rule ID 14431 //
     /*  767622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  767633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  767636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  767639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  767671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767693 */     GIR_RootConstrainSelectedInstOperands,
     /*  767694 */     // GIR_Coverage, 14431,
     /*  767694 */     GIR_EraseRootFromParent_Done,
     /*  767695 */   // Label 11982: @767695
     /*  767695 */   GIM_Try, /*On fail goto*//*Label 11983*/ GIMT_Encode4(767773), // Rule ID 14434 //
     /*  767700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  767711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  767714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  767717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767746 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767771 */     GIR_RootConstrainSelectedInstOperands,
     /*  767772 */     // GIR_Coverage, 14434,
     /*  767772 */     GIR_EraseRootFromParent_Done,
     /*  767773 */   // Label 11983: @767773
     /*  767773 */   GIM_Try, /*On fail goto*//*Label 11984*/ GIMT_Encode4(767851), // Rule ID 14435 //
     /*  767778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  767789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  767792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  767795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767824 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767849 */     GIR_RootConstrainSelectedInstOperands,
     /*  767850 */     // GIR_Coverage, 14435,
     /*  767850 */     GIR_EraseRootFromParent_Done,
     /*  767851 */   // Label 11984: @767851
     /*  767851 */   GIM_Try, /*On fail goto*//*Label 11985*/ GIMT_Encode4(767929), // Rule ID 14438 //
     /*  767856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  767867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  767870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  767873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767902 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  767902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767927 */     GIR_RootConstrainSelectedInstOperands,
     /*  767928 */     // GIR_Coverage, 14438,
     /*  767928 */     GIR_EraseRootFromParent_Done,
     /*  767929 */   // Label 11985: @767929
     /*  767929 */   GIM_Try, /*On fail goto*//*Label 11986*/ GIMT_Encode4(768007), // Rule ID 14439 //
     /*  767934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  767945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  767948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  767951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767980 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  767980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768005 */     GIR_RootConstrainSelectedInstOperands,
     /*  768006 */     // GIR_Coverage, 14439,
     /*  768006 */     GIR_EraseRootFromParent_Done,
     /*  768007 */   // Label 11986: @768007
     /*  768007 */   GIM_Try, /*On fail goto*//*Label 11987*/ GIMT_Encode4(768085), // Rule ID 14442 //
     /*  768012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  768023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  768026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  768029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768058 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768083 */     GIR_RootConstrainSelectedInstOperands,
     /*  768084 */     // GIR_Coverage, 14442,
     /*  768084 */     GIR_EraseRootFromParent_Done,
     /*  768085 */   // Label 11987: @768085
     /*  768085 */   GIM_Try, /*On fail goto*//*Label 11988*/ GIMT_Encode4(768163), // Rule ID 14443 //
     /*  768090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  768101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  768104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  768107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768136 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768161 */     GIR_RootConstrainSelectedInstOperands,
     /*  768162 */     // GIR_Coverage, 14443,
     /*  768162 */     GIR_EraseRootFromParent_Done,
     /*  768163 */   // Label 11988: @768163
     /*  768163 */   GIM_Try, /*On fail goto*//*Label 11989*/ GIMT_Encode4(768241), // Rule ID 14446 //
     /*  768168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  768179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  768182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  768185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768214 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  768214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768239 */     GIR_RootConstrainSelectedInstOperands,
     /*  768240 */     // GIR_Coverage, 14446,
     /*  768240 */     GIR_EraseRootFromParent_Done,
     /*  768241 */   // Label 11989: @768241
     /*  768241 */   GIM_Try, /*On fail goto*//*Label 11990*/ GIMT_Encode4(768319), // Rule ID 14447 //
     /*  768246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  768257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  768260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  768263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768292 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  768292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768317 */     GIR_RootConstrainSelectedInstOperands,
     /*  768318 */     // GIR_Coverage, 14447,
     /*  768318 */     GIR_EraseRootFromParent_Done,
     /*  768319 */   // Label 11990: @768319
     /*  768319 */   GIM_Try, /*On fail goto*//*Label 11991*/ GIMT_Encode4(768397), // Rule ID 14450 //
     /*  768324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  768335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  768338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  768341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768370 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  768370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768395 */     GIR_RootConstrainSelectedInstOperands,
     /*  768396 */     // GIR_Coverage, 14450,
     /*  768396 */     GIR_EraseRootFromParent_Done,
     /*  768397 */   // Label 11991: @768397
     /*  768397 */   GIM_Try, /*On fail goto*//*Label 11992*/ GIMT_Encode4(768475), // Rule ID 14451 //
     /*  768402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  768413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  768416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  768419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  768448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768473 */     GIR_RootConstrainSelectedInstOperands,
     /*  768474 */     // GIR_Coverage, 14451,
     /*  768474 */     GIR_EraseRootFromParent_Done,
     /*  768475 */   // Label 11992: @768475
     /*  768475 */   GIM_Try, /*On fail goto*//*Label 11993*/ GIMT_Encode4(768553), // Rule ID 14454 //
     /*  768480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  768483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  768491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  768494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  768497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  768526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768551 */     GIR_RootConstrainSelectedInstOperands,
     /*  768552 */     // GIR_Coverage, 14454,
     /*  768552 */     GIR_EraseRootFromParent_Done,
     /*  768553 */   // Label 11993: @768553
     /*  768553 */   GIM_Try, /*On fail goto*//*Label 11994*/ GIMT_Encode4(768631), // Rule ID 14455 //
     /*  768558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  768561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  768569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  768572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  768575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768604 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  768604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768629 */     GIR_RootConstrainSelectedInstOperands,
     /*  768630 */     // GIR_Coverage, 14455,
     /*  768630 */     GIR_EraseRootFromParent_Done,
     /*  768631 */   // Label 11994: @768631
     /*  768631 */   GIM_Try, /*On fail goto*//*Label 11995*/ GIMT_Encode4(768709), // Rule ID 14458 //
     /*  768636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  768647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  768650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  768653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768682 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768707 */     GIR_RootConstrainSelectedInstOperands,
     /*  768708 */     // GIR_Coverage, 14458,
     /*  768708 */     GIR_EraseRootFromParent_Done,
     /*  768709 */   // Label 11995: @768709
     /*  768709 */   GIM_Try, /*On fail goto*//*Label 11996*/ GIMT_Encode4(768787), // Rule ID 14459 //
     /*  768714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  768725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  768728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  768731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768760 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768782 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768785 */     GIR_RootConstrainSelectedInstOperands,
     /*  768786 */     // GIR_Coverage, 14459,
     /*  768786 */     GIR_EraseRootFromParent_Done,
     /*  768787 */   // Label 11996: @768787
     /*  768787 */   GIM_Try, /*On fail goto*//*Label 11997*/ GIMT_Encode4(768865), // Rule ID 14462 //
     /*  768792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  768803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  768806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  768809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768838 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768863 */     GIR_RootConstrainSelectedInstOperands,
     /*  768864 */     // GIR_Coverage, 14462,
     /*  768864 */     GIR_EraseRootFromParent_Done,
     /*  768865 */   // Label 11997: @768865
     /*  768865 */   GIM_Try, /*On fail goto*//*Label 11998*/ GIMT_Encode4(768943), // Rule ID 14463 //
     /*  768870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  768881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  768884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  768887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768916 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768938 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768941 */     GIR_RootConstrainSelectedInstOperands,
     /*  768942 */     // GIR_Coverage, 14463,
     /*  768942 */     GIR_EraseRootFromParent_Done,
     /*  768943 */   // Label 11998: @768943
     /*  768943 */   GIM_Try, /*On fail goto*//*Label 11999*/ GIMT_Encode4(769021), // Rule ID 14466 //
     /*  768948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  768959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  768962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  768965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768994 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  768997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769019 */     GIR_RootConstrainSelectedInstOperands,
     /*  769020 */     // GIR_Coverage, 14466,
     /*  769020 */     GIR_EraseRootFromParent_Done,
     /*  769021 */   // Label 11999: @769021
     /*  769021 */   GIM_Try, /*On fail goto*//*Label 12000*/ GIMT_Encode4(769099), // Rule ID 14467 //
     /*  769026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  769037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  769040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  769043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769072 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  769072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769097 */     GIR_RootConstrainSelectedInstOperands,
     /*  769098 */     // GIR_Coverage, 14467,
     /*  769098 */     GIR_EraseRootFromParent_Done,
     /*  769099 */   // Label 12000: @769099
     /*  769099 */   GIM_Try, /*On fail goto*//*Label 12001*/ GIMT_Encode4(769177), // Rule ID 14470 //
     /*  769104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  769115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  769118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  769121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769150 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769175 */     GIR_RootConstrainSelectedInstOperands,
     /*  769176 */     // GIR_Coverage, 14470,
     /*  769176 */     GIR_EraseRootFromParent_Done,
     /*  769177 */   // Label 12001: @769177
     /*  769177 */   GIM_Try, /*On fail goto*//*Label 12002*/ GIMT_Encode4(769255), // Rule ID 14471 //
     /*  769182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  769193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  769196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  769199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769253 */     GIR_RootConstrainSelectedInstOperands,
     /*  769254 */     // GIR_Coverage, 14471,
     /*  769254 */     GIR_EraseRootFromParent_Done,
     /*  769255 */   // Label 12002: @769255
     /*  769255 */   GIM_Try, /*On fail goto*//*Label 12003*/ GIMT_Encode4(769333), // Rule ID 14474 //
     /*  769260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  769271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  769274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  769277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769331 */     GIR_RootConstrainSelectedInstOperands,
     /*  769332 */     // GIR_Coverage, 14474,
     /*  769332 */     GIR_EraseRootFromParent_Done,
     /*  769333 */   // Label 12003: @769333
     /*  769333 */   GIM_Try, /*On fail goto*//*Label 12004*/ GIMT_Encode4(769411), // Rule ID 14475 //
     /*  769338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  769349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  769352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  769355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769384 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769409 */     GIR_RootConstrainSelectedInstOperands,
     /*  769410 */     // GIR_Coverage, 14475,
     /*  769410 */     GIR_EraseRootFromParent_Done,
     /*  769411 */   // Label 12004: @769411
     /*  769411 */   GIM_Try, /*On fail goto*//*Label 12005*/ GIMT_Encode4(769489), // Rule ID 14478 //
     /*  769416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  769427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  769430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  769433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769462 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769487 */     GIR_RootConstrainSelectedInstOperands,
     /*  769488 */     // GIR_Coverage, 14478,
     /*  769488 */     GIR_EraseRootFromParent_Done,
     /*  769489 */   // Label 12005: @769489
     /*  769489 */   GIM_Try, /*On fail goto*//*Label 12006*/ GIMT_Encode4(769567), // Rule ID 14479 //
     /*  769494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  769505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  769508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  769511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769540 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769565 */     GIR_RootConstrainSelectedInstOperands,
     /*  769566 */     // GIR_Coverage, 14479,
     /*  769566 */     GIR_EraseRootFromParent_Done,
     /*  769567 */   // Label 12006: @769567
     /*  769567 */   GIM_Try, /*On fail goto*//*Label 12007*/ GIMT_Encode4(769645), // Rule ID 14482 //
     /*  769572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  769583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  769586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  769589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769618 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769643 */     GIR_RootConstrainSelectedInstOperands,
     /*  769644 */     // GIR_Coverage, 14482,
     /*  769644 */     GIR_EraseRootFromParent_Done,
     /*  769645 */   // Label 12007: @769645
     /*  769645 */   GIM_Try, /*On fail goto*//*Label 12008*/ GIMT_Encode4(769723), // Rule ID 14483 //
     /*  769650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  769661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  769664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  769667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769721 */     GIR_RootConstrainSelectedInstOperands,
     /*  769722 */     // GIR_Coverage, 14483,
     /*  769722 */     GIR_EraseRootFromParent_Done,
     /*  769723 */   // Label 12008: @769723
     /*  769723 */   GIM_Try, /*On fail goto*//*Label 12009*/ GIMT_Encode4(769801), // Rule ID 14486 //
     /*  769728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  769739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  769742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  769745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769774 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769799 */     GIR_RootConstrainSelectedInstOperands,
     /*  769800 */     // GIR_Coverage, 14486,
     /*  769800 */     GIR_EraseRootFromParent_Done,
     /*  769801 */   // Label 12009: @769801
     /*  769801 */   GIM_Try, /*On fail goto*//*Label 12010*/ GIMT_Encode4(769879), // Rule ID 14487 //
     /*  769806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  769817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  769820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  769823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769877 */     GIR_RootConstrainSelectedInstOperands,
     /*  769878 */     // GIR_Coverage, 14487,
     /*  769878 */     GIR_EraseRootFromParent_Done,
     /*  769879 */   // Label 12010: @769879
     /*  769879 */   GIM_Try, /*On fail goto*//*Label 12011*/ GIMT_Encode4(769957), // Rule ID 14490 //
     /*  769884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  769895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  769898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  769901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769930 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769955 */     GIR_RootConstrainSelectedInstOperands,
     /*  769956 */     // GIR_Coverage, 14490,
     /*  769956 */     GIR_EraseRootFromParent_Done,
     /*  769957 */   // Label 12011: @769957
     /*  769957 */   GIM_Try, /*On fail goto*//*Label 12012*/ GIMT_Encode4(770035), // Rule ID 14491 //
     /*  769962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  769973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  769976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  769979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770008 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  770008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  770011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  770027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770033 */     GIR_RootConstrainSelectedInstOperands,
     /*  770034 */     // GIR_Coverage, 14491,
     /*  770034 */     GIR_EraseRootFromParent_Done,
     /*  770035 */   // Label 12012: @770035
     /*  770035 */   GIM_Try, /*On fail goto*//*Label 12013*/ GIMT_Encode4(770113), // Rule ID 14494 //
     /*  770040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  770043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  770051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  770054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  770057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770086 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  770089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770111 */     GIR_RootConstrainSelectedInstOperands,
     /*  770112 */     // GIR_Coverage, 14494,
     /*  770112 */     GIR_EraseRootFromParent_Done,
     /*  770113 */   // Label 12013: @770113
     /*  770113 */   GIM_Try, /*On fail goto*//*Label 12014*/ GIMT_Encode4(770191), // Rule ID 14495 //
     /*  770118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  770121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  770129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  770132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  770135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  770138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  770167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770189 */     GIR_RootConstrainSelectedInstOperands,
     /*  770190 */     // GIR_Coverage, 14495,
     /*  770190 */     GIR_EraseRootFromParent_Done,
     /*  770191 */   // Label 12014: @770191
     /*  770191 */   GIM_Try, /*On fail goto*//*Label 12015*/ GIMT_Encode4(770269), // Rule ID 14498 //
     /*  770196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  770199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  770207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  770210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  770213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770242 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  770245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770267 */     GIR_RootConstrainSelectedInstOperands,
     /*  770268 */     // GIR_Coverage, 14498,
     /*  770268 */     GIR_EraseRootFromParent_Done,
     /*  770269 */   // Label 12015: @770269
     /*  770269 */   GIM_Try, /*On fail goto*//*Label 12016*/ GIMT_Encode4(770347), // Rule ID 14499 //
     /*  770274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  770277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  770285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  770288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  770291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  770294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770320 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  770323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770345 */     GIR_RootConstrainSelectedInstOperands,
     /*  770346 */     // GIR_Coverage, 14499,
     /*  770346 */     GIR_EraseRootFromParent_Done,
     /*  770347 */   // Label 12016: @770347
     /*  770347 */   GIM_Try, /*On fail goto*//*Label 12017*/ GIMT_Encode4(770425), // Rule ID 14502 //
     /*  770352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  770355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  770363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  770366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  770369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770398 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  770401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770423 */     GIR_RootConstrainSelectedInstOperands,
     /*  770424 */     // GIR_Coverage, 14502,
     /*  770424 */     GIR_EraseRootFromParent_Done,
     /*  770425 */   // Label 12017: @770425
     /*  770425 */   GIM_Try, /*On fail goto*//*Label 12018*/ GIMT_Encode4(770503), // Rule ID 14503 //
     /*  770430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  770433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  770441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  770444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  770447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  770450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  770479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770501 */     GIR_RootConstrainSelectedInstOperands,
     /*  770502 */     // GIR_Coverage, 14503,
     /*  770502 */     GIR_EraseRootFromParent_Done,
     /*  770503 */   // Label 12018: @770503
     /*  770503 */   GIM_Try, /*On fail goto*//*Label 12019*/ GIMT_Encode4(770581), // Rule ID 14594 //
     /*  770508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  770519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  770522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  770525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  770528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770554 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  770557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770579 */     GIR_RootConstrainSelectedInstOperands,
     /*  770580 */     // GIR_Coverage, 14594,
     /*  770580 */     GIR_EraseRootFromParent_Done,
     /*  770581 */   // Label 12019: @770581
     /*  770581 */   GIM_Try, /*On fail goto*//*Label 12020*/ GIMT_Encode4(770659), // Rule ID 14595 //
     /*  770586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  770597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  770600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  770603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  770606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770632 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  770635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770657 */     GIR_RootConstrainSelectedInstOperands,
     /*  770658 */     // GIR_Coverage, 14595,
     /*  770658 */     GIR_EraseRootFromParent_Done,
     /*  770659 */   // Label 12020: @770659
     /*  770659 */   GIM_Try, /*On fail goto*//*Label 12021*/ GIMT_Encode4(770737), // Rule ID 14598 //
     /*  770664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  770675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  770678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  770681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  770684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770710 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770735 */     GIR_RootConstrainSelectedInstOperands,
     /*  770736 */     // GIR_Coverage, 14598,
     /*  770736 */     GIR_EraseRootFromParent_Done,
     /*  770737 */   // Label 12021: @770737
     /*  770737 */   GIM_Try, /*On fail goto*//*Label 12022*/ GIMT_Encode4(770815), // Rule ID 14599 //
     /*  770742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  770753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  770756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  770759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  770762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770788 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770813 */     GIR_RootConstrainSelectedInstOperands,
     /*  770814 */     // GIR_Coverage, 14599,
     /*  770814 */     GIR_EraseRootFromParent_Done,
     /*  770815 */   // Label 12022: @770815
     /*  770815 */   GIM_Try, /*On fail goto*//*Label 12023*/ GIMT_Encode4(770893), // Rule ID 14602 //
     /*  770820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  770831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  770834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  770837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  770840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770866 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770891 */     GIR_RootConstrainSelectedInstOperands,
     /*  770892 */     // GIR_Coverage, 14602,
     /*  770892 */     GIR_EraseRootFromParent_Done,
     /*  770893 */   // Label 12023: @770893
     /*  770893 */   GIM_Try, /*On fail goto*//*Label 12024*/ GIMT_Encode4(770971), // Rule ID 14603 //
     /*  770898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  770909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  770912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  770915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  770918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770944 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770966 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770969 */     GIR_RootConstrainSelectedInstOperands,
     /*  770970 */     // GIR_Coverage, 14603,
     /*  770970 */     GIR_EraseRootFromParent_Done,
     /*  770971 */   // Label 12024: @770971
     /*  770971 */   GIM_Try, /*On fail goto*//*Label 12025*/ GIMT_Encode4(771049), // Rule ID 14606 //
     /*  770976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  770987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  770990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  770993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  770996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771022 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  771025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771047 */     GIR_RootConstrainSelectedInstOperands,
     /*  771048 */     // GIR_Coverage, 14606,
     /*  771048 */     GIR_EraseRootFromParent_Done,
     /*  771049 */   // Label 12025: @771049
     /*  771049 */   GIM_Try, /*On fail goto*//*Label 12026*/ GIMT_Encode4(771127), // Rule ID 14607 //
     /*  771054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  771065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  771068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  771071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  771074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771100 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  771103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771125 */     GIR_RootConstrainSelectedInstOperands,
     /*  771126 */     // GIR_Coverage, 14607,
     /*  771126 */     GIR_EraseRootFromParent_Done,
     /*  771127 */   // Label 12026: @771127
     /*  771127 */   GIM_Try, /*On fail goto*//*Label 12027*/ GIMT_Encode4(771205), // Rule ID 14610 //
     /*  771132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  771143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  771146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  771149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  771152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771178 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  771181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771203 */     GIR_RootConstrainSelectedInstOperands,
     /*  771204 */     // GIR_Coverage, 14610,
     /*  771204 */     GIR_EraseRootFromParent_Done,
     /*  771205 */   // Label 12027: @771205
     /*  771205 */   GIM_Try, /*On fail goto*//*Label 12028*/ GIMT_Encode4(771283), // Rule ID 14611 //
     /*  771210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  771221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  771224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  771227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  771230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771256 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  771259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771281 */     GIR_RootConstrainSelectedInstOperands,
     /*  771282 */     // GIR_Coverage, 14611,
     /*  771282 */     GIR_EraseRootFromParent_Done,
     /*  771283 */   // Label 12028: @771283
     /*  771283 */   GIM_Try, /*On fail goto*//*Label 12029*/ GIMT_Encode4(771361), // Rule ID 14614 //
     /*  771288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  771299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  771302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  771305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  771308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771334 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  771337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771359 */     GIR_RootConstrainSelectedInstOperands,
     /*  771360 */     // GIR_Coverage, 14614,
     /*  771360 */     GIR_EraseRootFromParent_Done,
     /*  771361 */   // Label 12029: @771361
     /*  771361 */   GIM_Try, /*On fail goto*//*Label 12030*/ GIMT_Encode4(771439), // Rule ID 14615 //
     /*  771366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  771377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  771380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  771383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  771386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771412 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  771415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771437 */     GIR_RootConstrainSelectedInstOperands,
     /*  771438 */     // GIR_Coverage, 14615,
     /*  771438 */     GIR_EraseRootFromParent_Done,
     /*  771439 */   // Label 12030: @771439
     /*  771439 */   GIM_Try, /*On fail goto*//*Label 12031*/ GIMT_Encode4(771517), // Rule ID 14618 //
     /*  771444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  771455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  771458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  771461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  771464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771490 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771515 */     GIR_RootConstrainSelectedInstOperands,
     /*  771516 */     // GIR_Coverage, 14618,
     /*  771516 */     GIR_EraseRootFromParent_Done,
     /*  771517 */   // Label 12031: @771517
     /*  771517 */   GIM_Try, /*On fail goto*//*Label 12032*/ GIMT_Encode4(771595), // Rule ID 14619 //
     /*  771522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  771533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  771536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  771539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  771542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771568 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771593 */     GIR_RootConstrainSelectedInstOperands,
     /*  771594 */     // GIR_Coverage, 14619,
     /*  771594 */     GIR_EraseRootFromParent_Done,
     /*  771595 */   // Label 12032: @771595
     /*  771595 */   GIM_Try, /*On fail goto*//*Label 12033*/ GIMT_Encode4(771673), // Rule ID 14622 //
     /*  771600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  771611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  771614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  771617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  771620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771671 */     GIR_RootConstrainSelectedInstOperands,
     /*  771672 */     // GIR_Coverage, 14622,
     /*  771672 */     GIR_EraseRootFromParent_Done,
     /*  771673 */   // Label 12033: @771673
     /*  771673 */   GIM_Try, /*On fail goto*//*Label 12034*/ GIMT_Encode4(771751), // Rule ID 14623 //
     /*  771678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  771689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  771692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  771695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  771698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771749 */     GIR_RootConstrainSelectedInstOperands,
     /*  771750 */     // GIR_Coverage, 14623,
     /*  771750 */     GIR_EraseRootFromParent_Done,
     /*  771751 */   // Label 12034: @771751
     /*  771751 */   GIM_Try, /*On fail goto*//*Label 12035*/ GIMT_Encode4(771829), // Rule ID 14626 //
     /*  771756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  771767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  771770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  771773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  771776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771827 */     GIR_RootConstrainSelectedInstOperands,
     /*  771828 */     // GIR_Coverage, 14626,
     /*  771828 */     GIR_EraseRootFromParent_Done,
     /*  771829 */   // Label 12035: @771829
     /*  771829 */   GIM_Try, /*On fail goto*//*Label 12036*/ GIMT_Encode4(771907), // Rule ID 14627 //
     /*  771834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  771845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  771848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  771851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  771854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771905 */     GIR_RootConstrainSelectedInstOperands,
     /*  771906 */     // GIR_Coverage, 14627,
     /*  771906 */     GIR_EraseRootFromParent_Done,
     /*  771907 */   // Label 12036: @771907
     /*  771907 */   GIM_Try, /*On fail goto*//*Label 12037*/ GIMT_Encode4(771985), // Rule ID 14630 //
     /*  771912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  771915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  771923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  771926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  771929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  771932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  771958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771983 */     GIR_RootConstrainSelectedInstOperands,
     /*  771984 */     // GIR_Coverage, 14630,
     /*  771984 */     GIR_EraseRootFromParent_Done,
     /*  771985 */   // Label 12037: @771985
     /*  771985 */   GIM_Try, /*On fail goto*//*Label 12038*/ GIMT_Encode4(772063), // Rule ID 14631 //
     /*  771990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  771993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  772001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  772004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  772007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  772010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772036 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  772036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  772039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772061 */     GIR_RootConstrainSelectedInstOperands,
     /*  772062 */     // GIR_Coverage, 14631,
     /*  772062 */     GIR_EraseRootFromParent_Done,
     /*  772063 */   // Label 12038: @772063
     /*  772063 */   GIM_Try, /*On fail goto*//*Label 12039*/ GIMT_Encode4(772141), // Rule ID 14634 //
     /*  772068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  772079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  772082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  772085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  772088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772114 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  772114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772139 */     GIR_RootConstrainSelectedInstOperands,
     /*  772140 */     // GIR_Coverage, 14634,
     /*  772140 */     GIR_EraseRootFromParent_Done,
     /*  772141 */   // Label 12039: @772141
     /*  772141 */   GIM_Try, /*On fail goto*//*Label 12040*/ GIMT_Encode4(772219), // Rule ID 14635 //
     /*  772146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  772157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  772160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  772163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  772166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772192 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772217 */     GIR_RootConstrainSelectedInstOperands,
     /*  772218 */     // GIR_Coverage, 14635,
     /*  772218 */     GIR_EraseRootFromParent_Done,
     /*  772219 */   // Label 12040: @772219
     /*  772219 */   GIM_Try, /*On fail goto*//*Label 12041*/ GIMT_Encode4(772297), // Rule ID 14638 //
     /*  772224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  772235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  772238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  772241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  772244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772270 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  772270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772295 */     GIR_RootConstrainSelectedInstOperands,
     /*  772296 */     // GIR_Coverage, 14638,
     /*  772296 */     GIR_EraseRootFromParent_Done,
     /*  772297 */   // Label 12041: @772297
     /*  772297 */   GIM_Try, /*On fail goto*//*Label 12042*/ GIMT_Encode4(772375), // Rule ID 14639 //
     /*  772302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  772313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  772316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  772319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  772322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772348 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772373 */     GIR_RootConstrainSelectedInstOperands,
     /*  772374 */     // GIR_Coverage, 14639,
     /*  772374 */     GIR_EraseRootFromParent_Done,
     /*  772375 */   // Label 12042: @772375
     /*  772375 */   GIM_Try, /*On fail goto*//*Label 12043*/ GIMT_Encode4(772453), // Rule ID 14642 //
     /*  772380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  772391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  772394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  772397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  772400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772426 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  772426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772448 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772451 */     GIR_RootConstrainSelectedInstOperands,
     /*  772452 */     // GIR_Coverage, 14642,
     /*  772452 */     GIR_EraseRootFromParent_Done,
     /*  772453 */   // Label 12043: @772453
     /*  772453 */   GIM_Try, /*On fail goto*//*Label 12044*/ GIMT_Encode4(772531), // Rule ID 14643 //
     /*  772458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  772469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  772472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  772475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  772478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772504 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772529 */     GIR_RootConstrainSelectedInstOperands,
     /*  772530 */     // GIR_Coverage, 14643,
     /*  772530 */     GIR_EraseRootFromParent_Done,
     /*  772531 */   // Label 12044: @772531
     /*  772531 */   GIM_Try, /*On fail goto*//*Label 12045*/ GIMT_Encode4(772609), // Rule ID 14646 //
     /*  772536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  772547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  772550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  772553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  772556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772582 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772607 */     GIR_RootConstrainSelectedInstOperands,
     /*  772608 */     // GIR_Coverage, 14646,
     /*  772608 */     GIR_EraseRootFromParent_Done,
     /*  772609 */   // Label 12045: @772609
     /*  772609 */   GIM_Try, /*On fail goto*//*Label 12046*/ GIMT_Encode4(772687), // Rule ID 14647 //
     /*  772614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  772625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  772628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  772631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  772634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772685 */     GIR_RootConstrainSelectedInstOperands,
     /*  772686 */     // GIR_Coverage, 14647,
     /*  772686 */     GIR_EraseRootFromParent_Done,
     /*  772687 */   // Label 12046: @772687
     /*  772687 */   GIM_Try, /*On fail goto*//*Label 12047*/ GIMT_Encode4(772765), // Rule ID 14650 //
     /*  772692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  772703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  772706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  772709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  772712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772738 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772763 */     GIR_RootConstrainSelectedInstOperands,
     /*  772764 */     // GIR_Coverage, 14650,
     /*  772764 */     GIR_EraseRootFromParent_Done,
     /*  772765 */   // Label 12047: @772765
     /*  772765 */   GIM_Try, /*On fail goto*//*Label 12048*/ GIMT_Encode4(772843), // Rule ID 14651 //
     /*  772770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  772781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  772784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  772787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  772790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772816 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772841 */     GIR_RootConstrainSelectedInstOperands,
     /*  772842 */     // GIR_Coverage, 14651,
     /*  772842 */     GIR_EraseRootFromParent_Done,
     /*  772843 */   // Label 12048: @772843
     /*  772843 */   GIM_Try, /*On fail goto*//*Label 12049*/ GIMT_Encode4(772921), // Rule ID 14654 //
     /*  772848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  772859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  772862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  772865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  772868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772894 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772919 */     GIR_RootConstrainSelectedInstOperands,
     /*  772920 */     // GIR_Coverage, 14654,
     /*  772920 */     GIR_EraseRootFromParent_Done,
     /*  772921 */   // Label 12049: @772921
     /*  772921 */   GIM_Try, /*On fail goto*//*Label 12050*/ GIMT_Encode4(772999), // Rule ID 14655 //
     /*  772926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  772937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  772940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  772943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  772946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772972 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772997 */     GIR_RootConstrainSelectedInstOperands,
     /*  772998 */     // GIR_Coverage, 14655,
     /*  772998 */     GIR_EraseRootFromParent_Done,
     /*  772999 */   // Label 12050: @772999
     /*  772999 */   GIM_Try, /*On fail goto*//*Label 12051*/ GIMT_Encode4(773077), // Rule ID 14658 //
     /*  773004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  773015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  773018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  773021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  773024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773050 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  773053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773075 */     GIR_RootConstrainSelectedInstOperands,
     /*  773076 */     // GIR_Coverage, 14658,
     /*  773076 */     GIR_EraseRootFromParent_Done,
     /*  773077 */   // Label 12051: @773077
     /*  773077 */   GIM_Try, /*On fail goto*//*Label 12052*/ GIMT_Encode4(773155), // Rule ID 14659 //
     /*  773082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  773093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  773096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  773099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  773102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773128 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  773131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773153 */     GIR_RootConstrainSelectedInstOperands,
     /*  773154 */     // GIR_Coverage, 14659,
     /*  773154 */     GIR_EraseRootFromParent_Done,
     /*  773155 */   // Label 12052: @773155
     /*  773155 */   GIM_Try, /*On fail goto*//*Label 12053*/ GIMT_Encode4(773233), // Rule ID 14662 //
     /*  773160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  773171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  773174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  773177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  773180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  773209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773231 */     GIR_RootConstrainSelectedInstOperands,
     /*  773232 */     // GIR_Coverage, 14662,
     /*  773232 */     GIR_EraseRootFromParent_Done,
     /*  773233 */   // Label 12053: @773233
     /*  773233 */   GIM_Try, /*On fail goto*//*Label 12054*/ GIMT_Encode4(773311), // Rule ID 14663 //
     /*  773238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  773249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  773252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  773255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  773258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773284 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  773287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773309 */     GIR_RootConstrainSelectedInstOperands,
     /*  773310 */     // GIR_Coverage, 14663,
     /*  773310 */     GIR_EraseRootFromParent_Done,
     /*  773311 */   // Label 12054: @773311
     /*  773311 */   GIM_Try, /*On fail goto*//*Label 12055*/ GIMT_Encode4(773389), // Rule ID 14666 //
     /*  773316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  773327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  773330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  773333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  773336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773362 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  773365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773387 */     GIR_RootConstrainSelectedInstOperands,
     /*  773388 */     // GIR_Coverage, 14666,
     /*  773388 */     GIR_EraseRootFromParent_Done,
     /*  773389 */   // Label 12055: @773389
     /*  773389 */   GIM_Try, /*On fail goto*//*Label 12056*/ GIMT_Encode4(773467), // Rule ID 14667 //
     /*  773394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  773405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  773408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  773411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  773414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773440 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  773443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773465 */     GIR_RootConstrainSelectedInstOperands,
     /*  773466 */     // GIR_Coverage, 14667,
     /*  773466 */     GIR_EraseRootFromParent_Done,
     /*  773467 */   // Label 12056: @773467
     /*  773467 */   GIM_Try, /*On fail goto*//*Label 12057*/ GIMT_Encode4(773545), // Rule ID 14670 //
     /*  773472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  773483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  773486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  773489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  773492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773518 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  773521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773543 */     GIR_RootConstrainSelectedInstOperands,
     /*  773544 */     // GIR_Coverage, 14670,
     /*  773544 */     GIR_EraseRootFromParent_Done,
     /*  773545 */   // Label 12057: @773545
     /*  773545 */   GIM_Try, /*On fail goto*//*Label 12058*/ GIMT_Encode4(773623), // Rule ID 14671 //
     /*  773550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  773561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  773564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  773567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  773570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  773599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773621 */     GIR_RootConstrainSelectedInstOperands,
     /*  773622 */     // GIR_Coverage, 14671,
     /*  773622 */     GIR_EraseRootFromParent_Done,
     /*  773623 */   // Label 12058: @773623
     /*  773623 */   GIM_Try, /*On fail goto*//*Label 12059*/ GIMT_Encode4(773701), // Rule ID 14674 //
     /*  773628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  773648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773674 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  773677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773699 */     GIR_RootConstrainSelectedInstOperands,
     /*  773700 */     // GIR_Coverage, 14674,
     /*  773700 */     GIR_EraseRootFromParent_Done,
     /*  773701 */   // Label 12059: @773701
     /*  773701 */   GIM_Try, /*On fail goto*//*Label 12060*/ GIMT_Encode4(773779), // Rule ID 14675 //
     /*  773706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  773726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773752 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  773755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773777 */     GIR_RootConstrainSelectedInstOperands,
     /*  773778 */     // GIR_Coverage, 14675,
     /*  773778 */     GIR_EraseRootFromParent_Done,
     /*  773779 */   // Label 12060: @773779
     /*  773779 */   GIM_Try, /*On fail goto*//*Label 12061*/ GIMT_Encode4(773857), // Rule ID 14678 //
     /*  773784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  773804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773830 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  773833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773855 */     GIR_RootConstrainSelectedInstOperands,
     /*  773856 */     // GIR_Coverage, 14678,
     /*  773856 */     GIR_EraseRootFromParent_Done,
     /*  773857 */   // Label 12061: @773857
     /*  773857 */   GIM_Try, /*On fail goto*//*Label 12062*/ GIMT_Encode4(773935), // Rule ID 14679 //
     /*  773862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  773882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773908 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  773911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773933 */     GIR_RootConstrainSelectedInstOperands,
     /*  773934 */     // GIR_Coverage, 14679,
     /*  773934 */     GIR_EraseRootFromParent_Done,
     /*  773935 */   // Label 12062: @773935
     /*  773935 */   GIM_Try, /*On fail goto*//*Label 12063*/ GIMT_Encode4(774013), // Rule ID 14682 //
     /*  773940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  773951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  773954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  773957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773986 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  773989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774011 */     GIR_RootConstrainSelectedInstOperands,
     /*  774012 */     // GIR_Coverage, 14682,
     /*  774012 */     GIR_EraseRootFromParent_Done,
     /*  774013 */   // Label 12063: @774013
     /*  774013 */   GIM_Try, /*On fail goto*//*Label 12064*/ GIMT_Encode4(774091), // Rule ID 14683 //
     /*  774018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  774029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  774032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  774035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  774067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774089 */     GIR_RootConstrainSelectedInstOperands,
     /*  774090 */     // GIR_Coverage, 14683,
     /*  774090 */     GIR_EraseRootFromParent_Done,
     /*  774091 */   // Label 12064: @774091
     /*  774091 */   GIM_Try, /*On fail goto*//*Label 12065*/ GIMT_Encode4(774169), // Rule ID 14686 //
     /*  774096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  774107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  774110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  774113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774142 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  774145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774167 */     GIR_RootConstrainSelectedInstOperands,
     /*  774168 */     // GIR_Coverage, 14686,
     /*  774168 */     GIR_EraseRootFromParent_Done,
     /*  774169 */   // Label 12065: @774169
     /*  774169 */   GIM_Try, /*On fail goto*//*Label 12066*/ GIMT_Encode4(774247), // Rule ID 14687 //
     /*  774174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  774185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  774188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  774191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774220 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  774223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774245 */     GIR_RootConstrainSelectedInstOperands,
     /*  774246 */     // GIR_Coverage, 14687,
     /*  774246 */     GIR_EraseRootFromParent_Done,
     /*  774247 */   // Label 12066: @774247
     /*  774247 */   GIM_Try, /*On fail goto*//*Label 12067*/ GIMT_Encode4(774325), // Rule ID 14690 //
     /*  774252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  774263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  774266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  774269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774298 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774323 */     GIR_RootConstrainSelectedInstOperands,
     /*  774324 */     // GIR_Coverage, 14690,
     /*  774324 */     GIR_EraseRootFromParent_Done,
     /*  774325 */   // Label 12067: @774325
     /*  774325 */   GIM_Try, /*On fail goto*//*Label 12068*/ GIMT_Encode4(774403), // Rule ID 14691 //
     /*  774330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  774341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  774344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  774347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774376 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774401 */     GIR_RootConstrainSelectedInstOperands,
     /*  774402 */     // GIR_Coverage, 14691,
     /*  774402 */     GIR_EraseRootFromParent_Done,
     /*  774403 */   // Label 12068: @774403
     /*  774403 */   GIM_Try, /*On fail goto*//*Label 12069*/ GIMT_Encode4(774481), // Rule ID 14694 //
     /*  774408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  774419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  774422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  774425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774454 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  774457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774479 */     GIR_RootConstrainSelectedInstOperands,
     /*  774480 */     // GIR_Coverage, 14694,
     /*  774480 */     GIR_EraseRootFromParent_Done,
     /*  774481 */   // Label 12069: @774481
     /*  774481 */   GIM_Try, /*On fail goto*//*Label 12070*/ GIMT_Encode4(774559), // Rule ID 14695 //
     /*  774486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  774497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  774500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  774503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774532 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  774535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774557 */     GIR_RootConstrainSelectedInstOperands,
     /*  774558 */     // GIR_Coverage, 14695,
     /*  774558 */     GIR_EraseRootFromParent_Done,
     /*  774559 */   // Label 12070: @774559
     /*  774559 */   GIM_Try, /*On fail goto*//*Label 12071*/ GIMT_Encode4(774637), // Rule ID 14698 //
     /*  774564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774610 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774635 */     GIR_RootConstrainSelectedInstOperands,
     /*  774636 */     // GIR_Coverage, 14698,
     /*  774636 */     GIR_EraseRootFromParent_Done,
     /*  774637 */   // Label 12071: @774637
     /*  774637 */   GIM_Try, /*On fail goto*//*Label 12072*/ GIMT_Encode4(774715), // Rule ID 14699 //
     /*  774642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774688 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774713 */     GIR_RootConstrainSelectedInstOperands,
     /*  774714 */     // GIR_Coverage, 14699,
     /*  774714 */     GIR_EraseRootFromParent_Done,
     /*  774715 */   // Label 12072: @774715
     /*  774715 */   GIM_Try, /*On fail goto*//*Label 12073*/ GIMT_Encode4(774793), // Rule ID 14702 //
     /*  774720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  774731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  774734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  774737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774766 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  774766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774791 */     GIR_RootConstrainSelectedInstOperands,
     /*  774792 */     // GIR_Coverage, 14702,
     /*  774792 */     GIR_EraseRootFromParent_Done,
     /*  774793 */   // Label 12073: @774793
     /*  774793 */   GIM_Try, /*On fail goto*//*Label 12074*/ GIMT_Encode4(774871), // Rule ID 14703 //
     /*  774798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  774809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  774812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  774815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774844 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  774844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774869 */     GIR_RootConstrainSelectedInstOperands,
     /*  774870 */     // GIR_Coverage, 14703,
     /*  774870 */     GIR_EraseRootFromParent_Done,
     /*  774871 */   // Label 12074: @774871
     /*  774871 */   GIM_Try, /*On fail goto*//*Label 12075*/ GIMT_Encode4(774949), // Rule ID 14706 //
     /*  774876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  774887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  774890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  774893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774922 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774947 */     GIR_RootConstrainSelectedInstOperands,
     /*  774948 */     // GIR_Coverage, 14706,
     /*  774948 */     GIR_EraseRootFromParent_Done,
     /*  774949 */   // Label 12075: @774949
     /*  774949 */   GIM_Try, /*On fail goto*//*Label 12076*/ GIMT_Encode4(775027), // Rule ID 14707 //
     /*  774954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  774965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  774968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  774971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775000 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775025 */     GIR_RootConstrainSelectedInstOperands,
     /*  775026 */     // GIR_Coverage, 14707,
     /*  775026 */     GIR_EraseRootFromParent_Done,
     /*  775027 */   // Label 12076: @775027
     /*  775027 */   GIM_Try, /*On fail goto*//*Label 12077*/ GIMT_Encode4(775105), // Rule ID 14710 //
     /*  775032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  775043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  775046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  775049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775078 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775103 */     GIR_RootConstrainSelectedInstOperands,
     /*  775104 */     // GIR_Coverage, 14710,
     /*  775104 */     GIR_EraseRootFromParent_Done,
     /*  775105 */   // Label 12077: @775105
     /*  775105 */   GIM_Try, /*On fail goto*//*Label 12078*/ GIMT_Encode4(775183), // Rule ID 14711 //
     /*  775110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  775121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  775124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  775127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775181 */     GIR_RootConstrainSelectedInstOperands,
     /*  775182 */     // GIR_Coverage, 14711,
     /*  775182 */     GIR_EraseRootFromParent_Done,
     /*  775183 */   // Label 12078: @775183
     /*  775183 */   GIM_Try, /*On fail goto*//*Label 12079*/ GIMT_Encode4(775261), // Rule ID 14714 //
     /*  775188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  775199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  775202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  775205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  775234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775259 */     GIR_RootConstrainSelectedInstOperands,
     /*  775260 */     // GIR_Coverage, 14714,
     /*  775260 */     GIR_EraseRootFromParent_Done,
     /*  775261 */   // Label 12079: @775261
     /*  775261 */   GIM_Try, /*On fail goto*//*Label 12080*/ GIMT_Encode4(775339), // Rule ID 14715 //
     /*  775266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  775277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  775280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  775283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775312 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  775312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775337 */     GIR_RootConstrainSelectedInstOperands,
     /*  775338 */     // GIR_Coverage, 14715,
     /*  775338 */     GIR_EraseRootFromParent_Done,
     /*  775339 */   // Label 12080: @775339
     /*  775339 */   GIM_Try, /*On fail goto*//*Label 12081*/ GIMT_Encode4(775417), // Rule ID 14718 //
     /*  775344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  775347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  775355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  775358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  775361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  775390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  775409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775415 */     GIR_RootConstrainSelectedInstOperands,
     /*  775416 */     // GIR_Coverage, 14718,
     /*  775416 */     GIR_EraseRootFromParent_Done,
     /*  775417 */   // Label 12081: @775417
     /*  775417 */   GIM_Try, /*On fail goto*//*Label 12082*/ GIMT_Encode4(775495), // Rule ID 14719 //
     /*  775422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  775425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  775433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  775436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  775439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775468 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  775468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  775487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775493 */     GIR_RootConstrainSelectedInstOperands,
     /*  775494 */     // GIR_Coverage, 14719,
     /*  775494 */     GIR_EraseRootFromParent_Done,
     /*  775495 */   // Label 12082: @775495
     /*  775495 */   GIM_Try, /*On fail goto*//*Label 12083*/ GIMT_Encode4(775573), // Rule ID 14722 //
     /*  775500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  775511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  775514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  775517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775546 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775571 */     GIR_RootConstrainSelectedInstOperands,
     /*  775572 */     // GIR_Coverage, 14722,
     /*  775572 */     GIR_EraseRootFromParent_Done,
     /*  775573 */   // Label 12083: @775573
     /*  775573 */   GIM_Try, /*On fail goto*//*Label 12084*/ GIMT_Encode4(775651), // Rule ID 14723 //
     /*  775578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  775589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  775592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  775595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775624 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775649 */     GIR_RootConstrainSelectedInstOperands,
     /*  775650 */     // GIR_Coverage, 14723,
     /*  775650 */     GIR_EraseRootFromParent_Done,
     /*  775651 */   // Label 12084: @775651
     /*  775651 */   GIM_Try, /*On fail goto*//*Label 12085*/ GIMT_Encode4(775729), // Rule ID 14726 //
     /*  775656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  775667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  775670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  775673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775702 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775727 */     GIR_RootConstrainSelectedInstOperands,
     /*  775728 */     // GIR_Coverage, 14726,
     /*  775728 */     GIR_EraseRootFromParent_Done,
     /*  775729 */   // Label 12085: @775729
     /*  775729 */   GIM_Try, /*On fail goto*//*Label 12086*/ GIMT_Encode4(775807), // Rule ID 14727 //
     /*  775734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  775745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  775748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  775751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775780 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775805 */     GIR_RootConstrainSelectedInstOperands,
     /*  775806 */     // GIR_Coverage, 14727,
     /*  775806 */     GIR_EraseRootFromParent_Done,
     /*  775807 */   // Label 12086: @775807
     /*  775807 */   GIM_Try, /*On fail goto*//*Label 12087*/ GIMT_Encode4(775885), // Rule ID 14730 //
     /*  775812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  775823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  775826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  775829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775858 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775883 */     GIR_RootConstrainSelectedInstOperands,
     /*  775884 */     // GIR_Coverage, 14730,
     /*  775884 */     GIR_EraseRootFromParent_Done,
     /*  775885 */   // Label 12087: @775885
     /*  775885 */   GIM_Try, /*On fail goto*//*Label 12088*/ GIMT_Encode4(775963), // Rule ID 14731 //
     /*  775890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  775901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  775904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  775907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775936 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775961 */     GIR_RootConstrainSelectedInstOperands,
     /*  775962 */     // GIR_Coverage, 14731,
     /*  775962 */     GIR_EraseRootFromParent_Done,
     /*  775963 */   // Label 12088: @775963
     /*  775963 */   GIM_Try, /*On fail goto*//*Label 12089*/ GIMT_Encode4(776041), // Rule ID 14734 //
     /*  775968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776039 */     GIR_RootConstrainSelectedInstOperands,
     /*  776040 */     // GIR_Coverage, 14734,
     /*  776040 */     GIR_EraseRootFromParent_Done,
     /*  776041 */   // Label 12089: @776041
     /*  776041 */   GIM_Try, /*On fail goto*//*Label 12090*/ GIMT_Encode4(776119), // Rule ID 14735 //
     /*  776046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  776057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  776060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  776063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776092 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776117 */     GIR_RootConstrainSelectedInstOperands,
     /*  776118 */     // GIR_Coverage, 14735,
     /*  776118 */     GIR_EraseRootFromParent_Done,
     /*  776119 */   // Label 12090: @776119
     /*  776119 */   GIM_Try, /*On fail goto*//*Label 12091*/ GIMT_Encode4(776197), // Rule ID 14738 //
     /*  776124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  776135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  776138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  776141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776170 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776195 */     GIR_RootConstrainSelectedInstOperands,
     /*  776196 */     // GIR_Coverage, 14738,
     /*  776196 */     GIR_EraseRootFromParent_Done,
     /*  776197 */   // Label 12091: @776197
     /*  776197 */   GIM_Try, /*On fail goto*//*Label 12092*/ GIMT_Encode4(776275), // Rule ID 14739 //
     /*  776202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  776213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  776216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  776219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776248 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776273 */     GIR_RootConstrainSelectedInstOperands,
     /*  776274 */     // GIR_Coverage, 14739,
     /*  776274 */     GIR_EraseRootFromParent_Done,
     /*  776275 */   // Label 12092: @776275
     /*  776275 */   GIM_Try, /*On fail goto*//*Label 12093*/ GIMT_Encode4(776353), // Rule ID 14742 //
     /*  776280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  776291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  776294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  776297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776351 */     GIR_RootConstrainSelectedInstOperands,
     /*  776352 */     // GIR_Coverage, 14742,
     /*  776352 */     GIR_EraseRootFromParent_Done,
     /*  776353 */   // Label 12093: @776353
     /*  776353 */   GIM_Try, /*On fail goto*//*Label 12094*/ GIMT_Encode4(776431), // Rule ID 14743 //
     /*  776358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  776369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  776372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  776375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776404 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776429 */     GIR_RootConstrainSelectedInstOperands,
     /*  776430 */     // GIR_Coverage, 14743,
     /*  776430 */     GIR_EraseRootFromParent_Done,
     /*  776431 */   // Label 12094: @776431
     /*  776431 */   GIM_Try, /*On fail goto*//*Label 12095*/ GIMT_Encode4(776509), // Rule ID 14746 //
     /*  776436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  776447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  776450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  776453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776482 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776507 */     GIR_RootConstrainSelectedInstOperands,
     /*  776508 */     // GIR_Coverage, 14746,
     /*  776508 */     GIR_EraseRootFromParent_Done,
     /*  776509 */   // Label 12095: @776509
     /*  776509 */   GIM_Try, /*On fail goto*//*Label 12096*/ GIMT_Encode4(776587), // Rule ID 14747 //
     /*  776514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  776525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  776528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  776531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776585 */     GIR_RootConstrainSelectedInstOperands,
     /*  776586 */     // GIR_Coverage, 14747,
     /*  776586 */     GIR_EraseRootFromParent_Done,
     /*  776587 */   // Label 12096: @776587
     /*  776587 */   GIM_Try, /*On fail goto*//*Label 12097*/ GIMT_Encode4(776665), // Rule ID 14750 //
     /*  776592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  776603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  776606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  776609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776638 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776663 */     GIR_RootConstrainSelectedInstOperands,
     /*  776664 */     // GIR_Coverage, 14750,
     /*  776664 */     GIR_EraseRootFromParent_Done,
     /*  776665 */   // Label 12097: @776665
     /*  776665 */   GIM_Try, /*On fail goto*//*Label 12098*/ GIMT_Encode4(776743), // Rule ID 14751 //
     /*  776670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  776681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  776684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  776687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776741 */     GIR_RootConstrainSelectedInstOperands,
     /*  776742 */     // GIR_Coverage, 14751,
     /*  776742 */     GIR_EraseRootFromParent_Done,
     /*  776743 */   // Label 12098: @776743
     /*  776743 */   GIM_Try, /*On fail goto*//*Label 12099*/ GIMT_Encode4(776821), // Rule ID 14754 //
     /*  776748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  776759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  776762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  776765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776794 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776819 */     GIR_RootConstrainSelectedInstOperands,
     /*  776820 */     // GIR_Coverage, 14754,
     /*  776820 */     GIR_EraseRootFromParent_Done,
     /*  776821 */   // Label 12099: @776821
     /*  776821 */   GIM_Try, /*On fail goto*//*Label 12100*/ GIMT_Encode4(776899), // Rule ID 14755 //
     /*  776826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  776837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  776840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  776843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776872 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776897 */     GIR_RootConstrainSelectedInstOperands,
     /*  776898 */     // GIR_Coverage, 14755,
     /*  776898 */     GIR_EraseRootFromParent_Done,
     /*  776899 */   // Label 12100: @776899
     /*  776899 */   GIM_Try, /*On fail goto*//*Label 12101*/ GIMT_Encode4(776977), // Rule ID 14758 //
     /*  776904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  776907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  776950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776975 */     GIR_RootConstrainSelectedInstOperands,
     /*  776976 */     // GIR_Coverage, 14758,
     /*  776976 */     GIR_EraseRootFromParent_Done,
     /*  776977 */   // Label 12101: @776977
     /*  776977 */   GIM_Try, /*On fail goto*//*Label 12102*/ GIMT_Encode4(777055), // Rule ID 14759 //
     /*  776982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777028 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  777028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  777031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777053 */     GIR_RootConstrainSelectedInstOperands,
     /*  777054 */     // GIR_Coverage, 14759,
     /*  777054 */     GIR_EraseRootFromParent_Done,
     /*  777055 */   // Label 12102: @777055
     /*  777055 */   GIM_Try, /*On fail goto*//*Label 12103*/ GIMT_Encode4(777133), // Rule ID 14762 //
     /*  777060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  777063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  777071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  777074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  777077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777106 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  777106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  777109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777131 */     GIR_RootConstrainSelectedInstOperands,
     /*  777132 */     // GIR_Coverage, 14762,
     /*  777132 */     GIR_EraseRootFromParent_Done,
     /*  777133 */   // Label 12103: @777133
     /*  777133 */   GIM_Try, /*On fail goto*//*Label 12104*/ GIMT_Encode4(777211), // Rule ID 14763 //
     /*  777138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  777141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  777149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  777152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  777155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777184 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  777184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  777187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777209 */     GIR_RootConstrainSelectedInstOperands,
     /*  777210 */     // GIR_Coverage, 14763,
     /*  777210 */     GIR_EraseRootFromParent_Done,
     /*  777211 */   // Label 12104: @777211
     /*  777211 */   GIM_Try, /*On fail goto*//*Label 12105*/ GIMT_Encode4(777289), // Rule ID 14766 //
     /*  777216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  777219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  777227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  777230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  777233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777262 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  777262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  777265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777287 */     GIR_RootConstrainSelectedInstOperands,
     /*  777288 */     // GIR_Coverage, 14766,
     /*  777288 */     GIR_EraseRootFromParent_Done,
     /*  777289 */   // Label 12105: @777289
     /*  777289 */   GIM_Try, /*On fail goto*//*Label 12106*/ GIMT_Encode4(777367), // Rule ID 14767 //
     /*  777294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  777297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  777305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  777308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  777311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  777340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  777343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777365 */     GIR_RootConstrainSelectedInstOperands,
     /*  777366 */     // GIR_Coverage, 14767,
     /*  777366 */     GIR_EraseRootFromParent_Done,
     /*  777367 */   // Label 12106: @777367
     /*  777367 */   GIM_Try, /*On fail goto*//*Label 12107*/ GIMT_Encode4(777445), // Rule ID 14770 //
     /*  777372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  777383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  777386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  777389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  777392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777418 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  777421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777443 */     GIR_RootConstrainSelectedInstOperands,
     /*  777444 */     // GIR_Coverage, 14770,
     /*  777444 */     GIR_EraseRootFromParent_Done,
     /*  777445 */   // Label 12107: @777445
     /*  777445 */   GIM_Try, /*On fail goto*//*Label 12108*/ GIMT_Encode4(777523), // Rule ID 14771 //
     /*  777450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  777461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  777464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  777467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  777470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  777499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777521 */     GIR_RootConstrainSelectedInstOperands,
     /*  777522 */     // GIR_Coverage, 14771,
     /*  777522 */     GIR_EraseRootFromParent_Done,
     /*  777523 */   // Label 12108: @777523
     /*  777523 */   GIM_Try, /*On fail goto*//*Label 12109*/ GIMT_Encode4(777601), // Rule ID 14774 //
     /*  777528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  777539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  777542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  777545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  777548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777574 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777599 */     GIR_RootConstrainSelectedInstOperands,
     /*  777600 */     // GIR_Coverage, 14774,
     /*  777600 */     GIR_EraseRootFromParent_Done,
     /*  777601 */   // Label 12109: @777601
     /*  777601 */   GIM_Try, /*On fail goto*//*Label 12110*/ GIMT_Encode4(777679), // Rule ID 14775 //
     /*  777606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  777617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  777620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  777623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  777626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777652 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777677 */     GIR_RootConstrainSelectedInstOperands,
     /*  777678 */     // GIR_Coverage, 14775,
     /*  777678 */     GIR_EraseRootFromParent_Done,
     /*  777679 */   // Label 12110: @777679
     /*  777679 */   GIM_Try, /*On fail goto*//*Label 12111*/ GIMT_Encode4(777757), // Rule ID 14778 //
     /*  777684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  777695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  777698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  777701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  777704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777730 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777755 */     GIR_RootConstrainSelectedInstOperands,
     /*  777756 */     // GIR_Coverage, 14778,
     /*  777756 */     GIR_EraseRootFromParent_Done,
     /*  777757 */   // Label 12111: @777757
     /*  777757 */   GIM_Try, /*On fail goto*//*Label 12112*/ GIMT_Encode4(777835), // Rule ID 14779 //
     /*  777762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  777773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  777776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  777779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  777782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777808 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777833 */     GIR_RootConstrainSelectedInstOperands,
     /*  777834 */     // GIR_Coverage, 14779,
     /*  777834 */     GIR_EraseRootFromParent_Done,
     /*  777835 */   // Label 12112: @777835
     /*  777835 */   GIM_Try, /*On fail goto*//*Label 12113*/ GIMT_Encode4(777913), // Rule ID 14782 //
     /*  777840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  777851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  777854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  777857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  777860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777886 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777911 */     GIR_RootConstrainSelectedInstOperands,
     /*  777912 */     // GIR_Coverage, 14782,
     /*  777912 */     GIR_EraseRootFromParent_Done,
     /*  777913 */   // Label 12113: @777913
     /*  777913 */   GIM_Try, /*On fail goto*//*Label 12114*/ GIMT_Encode4(777991), // Rule ID 14783 //
     /*  777918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  777929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  777932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  777935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  777938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777964 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777986 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777989 */     GIR_RootConstrainSelectedInstOperands,
     /*  777990 */     // GIR_Coverage, 14783,
     /*  777990 */     GIR_EraseRootFromParent_Done,
     /*  777991 */   // Label 12114: @777991
     /*  777991 */   GIM_Try, /*On fail goto*//*Label 12115*/ GIMT_Encode4(778069), // Rule ID 14786 //
     /*  777996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  778007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  778010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  778013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  778016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778042 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  778045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778067 */     GIR_RootConstrainSelectedInstOperands,
     /*  778068 */     // GIR_Coverage, 14786,
     /*  778068 */     GIR_EraseRootFromParent_Done,
     /*  778069 */   // Label 12115: @778069
     /*  778069 */   GIM_Try, /*On fail goto*//*Label 12116*/ GIMT_Encode4(778147), // Rule ID 14787 //
     /*  778074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  778085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  778088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  778091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  778094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778120 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  778123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778145 */     GIR_RootConstrainSelectedInstOperands,
     /*  778146 */     // GIR_Coverage, 14787,
     /*  778146 */     GIR_EraseRootFromParent_Done,
     /*  778147 */   // Label 12116: @778147
     /*  778147 */   GIM_Try, /*On fail goto*//*Label 12117*/ GIMT_Encode4(778225), // Rule ID 14790 //
     /*  778152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  778163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  778166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  778169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  778172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778198 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  778198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  778201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778223 */     GIR_RootConstrainSelectedInstOperands,
     /*  778224 */     // GIR_Coverage, 14790,
     /*  778224 */     GIR_EraseRootFromParent_Done,
     /*  778225 */   // Label 12117: @778225
     /*  778225 */   GIM_Try, /*On fail goto*//*Label 12118*/ GIMT_Encode4(778303), // Rule ID 14791 //
     /*  778230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  778241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  778244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  778247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  778250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  778276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  778279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778301 */     GIR_RootConstrainSelectedInstOperands,
     /*  778302 */     // GIR_Coverage, 14791,
     /*  778302 */     GIR_EraseRootFromParent_Done,
     /*  778303 */   // Label 12118: @778303
     /*  778303 */   GIM_Try, /*On fail goto*//*Label 12119*/ GIMT_Encode4(778381), // Rule ID 14794 //
     /*  778308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  778319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  778322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  778325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  778328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778354 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778379 */     GIR_RootConstrainSelectedInstOperands,
     /*  778380 */     // GIR_Coverage, 14794,
     /*  778380 */     GIR_EraseRootFromParent_Done,
     /*  778381 */   // Label 12119: @778381
     /*  778381 */   GIM_Try, /*On fail goto*//*Label 12120*/ GIMT_Encode4(778459), // Rule ID 14795 //
     /*  778386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  778397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  778400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  778403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  778406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778457 */     GIR_RootConstrainSelectedInstOperands,
     /*  778458 */     // GIR_Coverage, 14795,
     /*  778458 */     GIR_EraseRootFromParent_Done,
     /*  778459 */   // Label 12120: @778459
     /*  778459 */   GIM_Try, /*On fail goto*//*Label 12121*/ GIMT_Encode4(778537), // Rule ID 14798 //
     /*  778464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  778475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  778478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  778481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  778484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778510 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778535 */     GIR_RootConstrainSelectedInstOperands,
     /*  778536 */     // GIR_Coverage, 14798,
     /*  778536 */     GIR_EraseRootFromParent_Done,
     /*  778537 */   // Label 12121: @778537
     /*  778537 */   GIM_Try, /*On fail goto*//*Label 12122*/ GIMT_Encode4(778615), // Rule ID 14799 //
     /*  778542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  778553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  778556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  778559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  778562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778588 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778613 */     GIR_RootConstrainSelectedInstOperands,
     /*  778614 */     // GIR_Coverage, 14799,
     /*  778614 */     GIR_EraseRootFromParent_Done,
     /*  778615 */   // Label 12122: @778615
     /*  778615 */   GIM_Try, /*On fail goto*//*Label 12123*/ GIMT_Encode4(778693), // Rule ID 14802 //
     /*  778620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  778631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  778634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  778637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  778640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778666 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  778666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778691 */     GIR_RootConstrainSelectedInstOperands,
     /*  778692 */     // GIR_Coverage, 14802,
     /*  778692 */     GIR_EraseRootFromParent_Done,
     /*  778693 */   // Label 12123: @778693
     /*  778693 */   GIM_Try, /*On fail goto*//*Label 12124*/ GIMT_Encode4(778771), // Rule ID 14803 //
     /*  778698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  778709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  778712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  778715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  778718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  778744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778769 */     GIR_RootConstrainSelectedInstOperands,
     /*  778770 */     // GIR_Coverage, 14803,
     /*  778770 */     GIR_EraseRootFromParent_Done,
     /*  778771 */   // Label 12124: @778771
     /*  778771 */   GIM_Try, /*On fail goto*//*Label 12125*/ GIMT_Encode4(778849), // Rule ID 14806 //
     /*  778776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  778779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  778787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  778790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  778793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  778796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  778822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778847 */     GIR_RootConstrainSelectedInstOperands,
     /*  778848 */     // GIR_Coverage, 14806,
     /*  778848 */     GIR_EraseRootFromParent_Done,
     /*  778849 */   // Label 12125: @778849
     /*  778849 */   GIM_Try, /*On fail goto*//*Label 12126*/ GIMT_Encode4(778927), // Rule ID 14807 //
     /*  778854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  778857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  778865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  778868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  778871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  778874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778900 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  778900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778925 */     GIR_RootConstrainSelectedInstOperands,
     /*  778926 */     // GIR_Coverage, 14807,
     /*  778926 */     GIR_EraseRootFromParent_Done,
     /*  778927 */   // Label 12126: @778927
     /*  778927 */   GIM_Try, /*On fail goto*//*Label 12127*/ GIMT_Encode4(779005), // Rule ID 14810 //
     /*  778932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  778943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  778946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  778949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  778952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778978 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  778981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779003 */     GIR_RootConstrainSelectedInstOperands,
     /*  779004 */     // GIR_Coverage, 14810,
     /*  779004 */     GIR_EraseRootFromParent_Done,
     /*  779005 */   // Label 12127: @779005
     /*  779005 */   GIM_Try, /*On fail goto*//*Label 12128*/ GIMT_Encode4(779083), // Rule ID 14811 //
     /*  779010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  779021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  779024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  779027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  779030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779056 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  779056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779081 */     GIR_RootConstrainSelectedInstOperands,
     /*  779082 */     // GIR_Coverage, 14811,
     /*  779082 */     GIR_EraseRootFromParent_Done,
     /*  779083 */   // Label 12128: @779083
     /*  779083 */   GIM_Try, /*On fail goto*//*Label 12129*/ GIMT_Encode4(779161), // Rule ID 14814 //
     /*  779088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  779099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  779102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  779105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  779108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779134 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  779134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779159 */     GIR_RootConstrainSelectedInstOperands,
     /*  779160 */     // GIR_Coverage, 14814,
     /*  779160 */     GIR_EraseRootFromParent_Done,
     /*  779161 */   // Label 12129: @779161
     /*  779161 */   GIM_Try, /*On fail goto*//*Label 12130*/ GIMT_Encode4(779239), // Rule ID 14815 //
     /*  779166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  779177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  779180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  779183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  779186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779212 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  779212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779237 */     GIR_RootConstrainSelectedInstOperands,
     /*  779238 */     // GIR_Coverage, 14815,
     /*  779238 */     GIR_EraseRootFromParent_Done,
     /*  779239 */   // Label 12130: @779239
     /*  779239 */   GIM_Try, /*On fail goto*//*Label 12131*/ GIMT_Encode4(779317), // Rule ID 14818 //
     /*  779244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  779255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  779258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  779261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  779264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779290 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  779290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779315 */     GIR_RootConstrainSelectedInstOperands,
     /*  779316 */     // GIR_Coverage, 14818,
     /*  779316 */     GIR_EraseRootFromParent_Done,
     /*  779317 */   // Label 12131: @779317
     /*  779317 */   GIM_Try, /*On fail goto*//*Label 12132*/ GIMT_Encode4(779395), // Rule ID 14819 //
     /*  779322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  779333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  779336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  779339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  779342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779368 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  779368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779393 */     GIR_RootConstrainSelectedInstOperands,
     /*  779394 */     // GIR_Coverage, 14819,
     /*  779394 */     GIR_EraseRootFromParent_Done,
     /*  779395 */   // Label 12132: @779395
     /*  779395 */   GIM_Try, /*On fail goto*//*Label 12133*/ GIMT_Encode4(779473), // Rule ID 14822 //
     /*  779400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  779411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  779414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  779417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  779420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779446 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779471 */     GIR_RootConstrainSelectedInstOperands,
     /*  779472 */     // GIR_Coverage, 14822,
     /*  779472 */     GIR_EraseRootFromParent_Done,
     /*  779473 */   // Label 12133: @779473
     /*  779473 */   GIM_Try, /*On fail goto*//*Label 12134*/ GIMT_Encode4(779551), // Rule ID 14823 //
     /*  779478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  779489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  779492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  779495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  779498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779524 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779549 */     GIR_RootConstrainSelectedInstOperands,
     /*  779550 */     // GIR_Coverage, 14823,
     /*  779550 */     GIR_EraseRootFromParent_Done,
     /*  779551 */   // Label 12134: @779551
     /*  779551 */   GIM_Try, /*On fail goto*//*Label 12135*/ GIMT_Encode4(779629), // Rule ID 14826 //
     /*  779556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  779567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  779570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  779573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  779576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779602 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779627 */     GIR_RootConstrainSelectedInstOperands,
     /*  779628 */     // GIR_Coverage, 14826,
     /*  779628 */     GIR_EraseRootFromParent_Done,
     /*  779629 */   // Label 12135: @779629
     /*  779629 */   GIM_Try, /*On fail goto*//*Label 12136*/ GIMT_Encode4(779707), // Rule ID 14827 //
     /*  779634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  779645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  779648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  779651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  779654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779680 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779705 */     GIR_RootConstrainSelectedInstOperands,
     /*  779706 */     // GIR_Coverage, 14827,
     /*  779706 */     GIR_EraseRootFromParent_Done,
     /*  779707 */   // Label 12136: @779707
     /*  779707 */   GIM_Try, /*On fail goto*//*Label 12137*/ GIMT_Encode4(779785), // Rule ID 14830 //
     /*  779712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  779723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  779726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  779729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  779732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779758 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779783 */     GIR_RootConstrainSelectedInstOperands,
     /*  779784 */     // GIR_Coverage, 14830,
     /*  779784 */     GIR_EraseRootFromParent_Done,
     /*  779785 */   // Label 12137: @779785
     /*  779785 */   GIM_Try, /*On fail goto*//*Label 12138*/ GIMT_Encode4(779863), // Rule ID 14831 //
     /*  779790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  779801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  779804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  779807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  779810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779836 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779861 */     GIR_RootConstrainSelectedInstOperands,
     /*  779862 */     // GIR_Coverage, 14831,
     /*  779862 */     GIR_EraseRootFromParent_Done,
     /*  779863 */   // Label 12138: @779863
     /*  779863 */   GIM_Try, /*On fail goto*//*Label 12139*/ GIMT_Encode4(779941), // Rule ID 14834 //
     /*  779868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  779879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  779882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  779885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  779888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779914 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  779914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779939 */     GIR_RootConstrainSelectedInstOperands,
     /*  779940 */     // GIR_Coverage, 14834,
     /*  779940 */     GIR_EraseRootFromParent_Done,
     /*  779941 */   // Label 12139: @779941
     /*  779941 */   GIM_Try, /*On fail goto*//*Label 12140*/ GIMT_Encode4(780019), // Rule ID 14835 //
     /*  779946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  779957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  779960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  779963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  779966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780017 */     GIR_RootConstrainSelectedInstOperands,
     /*  780018 */     // GIR_Coverage, 14835,
     /*  780018 */     GIR_EraseRootFromParent_Done,
     /*  780019 */   // Label 12140: @780019
     /*  780019 */   GIM_Try, /*On fail goto*//*Label 12141*/ GIMT_Encode4(780097), // Rule ID 14838 //
     /*  780024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  780035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  780038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  780041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  780044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780070 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  780070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  780073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780095 */     GIR_RootConstrainSelectedInstOperands,
     /*  780096 */     // GIR_Coverage, 14838,
     /*  780096 */     GIR_EraseRootFromParent_Done,
     /*  780097 */   // Label 12141: @780097
     /*  780097 */   GIM_Try, /*On fail goto*//*Label 12142*/ GIMT_Encode4(780175), // Rule ID 14839 //
     /*  780102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  780113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  780116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  780119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  780122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780148 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  780148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  780151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780173 */     GIR_RootConstrainSelectedInstOperands,
     /*  780174 */     // GIR_Coverage, 14839,
     /*  780174 */     GIR_EraseRootFromParent_Done,
     /*  780175 */   // Label 12142: @780175
     /*  780175 */   GIM_Try, /*On fail goto*//*Label 12143*/ GIMT_Encode4(780253), // Rule ID 14842 //
     /*  780180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  780191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  780194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  780197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  780200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780226 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  780226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  780229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780251 */     GIR_RootConstrainSelectedInstOperands,
     /*  780252 */     // GIR_Coverage, 14842,
     /*  780252 */     GIR_EraseRootFromParent_Done,
     /*  780253 */   // Label 12143: @780253
     /*  780253 */   GIM_Try, /*On fail goto*//*Label 12144*/ GIMT_Encode4(780331), // Rule ID 14843 //
     /*  780258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  780269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  780272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  780275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  780278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  780304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  780307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780326 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780329 */     GIR_RootConstrainSelectedInstOperands,
     /*  780330 */     // GIR_Coverage, 14843,
     /*  780330 */     GIR_EraseRootFromParent_Done,
     /*  780331 */   // Label 12144: @780331
     /*  780331 */   GIM_Try, /*On fail goto*//*Label 12145*/ GIMT_Encode4(780409), // Rule ID 14846 //
     /*  780336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  780347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  780350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  780353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  780356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  780385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780407 */     GIR_RootConstrainSelectedInstOperands,
     /*  780408 */     // GIR_Coverage, 14846,
     /*  780408 */     GIR_EraseRootFromParent_Done,
     /*  780409 */   // Label 12145: @780409
     /*  780409 */   GIM_Try, /*On fail goto*//*Label 12146*/ GIMT_Encode4(780487), // Rule ID 14847 //
     /*  780414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  780425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  780428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  780431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  780434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  780463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780485 */     GIR_RootConstrainSelectedInstOperands,
     /*  780486 */     // GIR_Coverage, 14847,
     /*  780486 */     GIR_EraseRootFromParent_Done,
     /*  780487 */   // Label 12146: @780487
     /*  780487 */   GIM_Try, /*On fail goto*//*Label 12147*/ GIMT_Encode4(780565), // Rule ID 14850 //
     /*  780492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  780503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  780506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  780509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  780512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780538 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  780541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780563 */     GIR_RootConstrainSelectedInstOperands,
     /*  780564 */     // GIR_Coverage, 14850,
     /*  780564 */     GIR_EraseRootFromParent_Done,
     /*  780565 */   // Label 12147: @780565
     /*  780565 */   GIM_Try, /*On fail goto*//*Label 12148*/ GIMT_Encode4(780643), // Rule ID 14851 //
     /*  780570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  780581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  780584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  780587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  780590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  780619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780641 */     GIR_RootConstrainSelectedInstOperands,
     /*  780642 */     // GIR_Coverage, 14851,
     /*  780642 */     GIR_EraseRootFromParent_Done,
     /*  780643 */   // Label 12148: @780643
     /*  780643 */   GIM_Try, /*On fail goto*//*Label 12149*/ GIMT_Encode4(780721), // Rule ID 14854 //
     /*  780648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  780659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  780662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  780665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  780668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  780697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780719 */     GIR_RootConstrainSelectedInstOperands,
     /*  780720 */     // GIR_Coverage, 14854,
     /*  780720 */     GIR_EraseRootFromParent_Done,
     /*  780721 */   // Label 12149: @780721
     /*  780721 */   GIM_Try, /*On fail goto*//*Label 12150*/ GIMT_Encode4(780799), // Rule ID 14855 //
     /*  780726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  780737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  780740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  780743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  780746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780772 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  780775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780797 */     GIR_RootConstrainSelectedInstOperands,
     /*  780798 */     // GIR_Coverage, 14855,
     /*  780798 */     GIR_EraseRootFromParent_Done,
     /*  780799 */   // Label 12150: @780799
     /*  780799 */   GIM_Try, /*On fail goto*//*Label 12151*/ GIMT_Encode4(780877), // Rule ID 14858 //
     /*  780804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  780815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  780818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  780821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780850 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  780853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780875 */     GIR_RootConstrainSelectedInstOperands,
     /*  780876 */     // GIR_Coverage, 14858,
     /*  780876 */     GIR_EraseRootFromParent_Done,
     /*  780877 */   // Label 12151: @780877
     /*  780877 */   GIM_Try, /*On fail goto*//*Label 12152*/ GIMT_Encode4(780955), // Rule ID 14859 //
     /*  780882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  780893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  780896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  780899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780928 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  780931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780953 */     GIR_RootConstrainSelectedInstOperands,
     /*  780954 */     // GIR_Coverage, 14859,
     /*  780954 */     GIR_EraseRootFromParent_Done,
     /*  780955 */   // Label 12152: @780955
     /*  780955 */   GIM_Try, /*On fail goto*//*Label 12153*/ GIMT_Encode4(781033), // Rule ID 14862 //
     /*  780960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  780971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  780974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  780977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781006 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  781009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781031 */     GIR_RootConstrainSelectedInstOperands,
     /*  781032 */     // GIR_Coverage, 14862,
     /*  781032 */     GIR_EraseRootFromParent_Done,
     /*  781033 */   // Label 12153: @781033
     /*  781033 */   GIM_Try, /*On fail goto*//*Label 12154*/ GIMT_Encode4(781111), // Rule ID 14863 //
     /*  781038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  781049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  781052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  781055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781084 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  781087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781109 */     GIR_RootConstrainSelectedInstOperands,
     /*  781110 */     // GIR_Coverage, 14863,
     /*  781110 */     GIR_EraseRootFromParent_Done,
     /*  781111 */   // Label 12154: @781111
     /*  781111 */   GIM_Try, /*On fail goto*//*Label 12155*/ GIMT_Encode4(781189), // Rule ID 14866 //
     /*  781116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  781127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  781130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  781133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781162 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781187 */     GIR_RootConstrainSelectedInstOperands,
     /*  781188 */     // GIR_Coverage, 14866,
     /*  781188 */     GIR_EraseRootFromParent_Done,
     /*  781189 */   // Label 12155: @781189
     /*  781189 */   GIM_Try, /*On fail goto*//*Label 12156*/ GIMT_Encode4(781267), // Rule ID 14867 //
     /*  781194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  781205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  781208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  781211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781240 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781265 */     GIR_RootConstrainSelectedInstOperands,
     /*  781266 */     // GIR_Coverage, 14867,
     /*  781266 */     GIR_EraseRootFromParent_Done,
     /*  781267 */   // Label 12156: @781267
     /*  781267 */   GIM_Try, /*On fail goto*//*Label 12157*/ GIMT_Encode4(781345), // Rule ID 14870 //
     /*  781272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  781283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  781286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  781289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781318 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  781321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781343 */     GIR_RootConstrainSelectedInstOperands,
     /*  781344 */     // GIR_Coverage, 14870,
     /*  781344 */     GIR_EraseRootFromParent_Done,
     /*  781345 */   // Label 12157: @781345
     /*  781345 */   GIM_Try, /*On fail goto*//*Label 12158*/ GIMT_Encode4(781423), // Rule ID 14871 //
     /*  781350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  781361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  781364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  781367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781396 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  781399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781421 */     GIR_RootConstrainSelectedInstOperands,
     /*  781422 */     // GIR_Coverage, 14871,
     /*  781422 */     GIR_EraseRootFromParent_Done,
     /*  781423 */   // Label 12158: @781423
     /*  781423 */   GIM_Try, /*On fail goto*//*Label 12159*/ GIMT_Encode4(781501), // Rule ID 14874 //
     /*  781428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  781439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  781442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  781445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781474 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781499 */     GIR_RootConstrainSelectedInstOperands,
     /*  781500 */     // GIR_Coverage, 14874,
     /*  781500 */     GIR_EraseRootFromParent_Done,
     /*  781501 */   // Label 12159: @781501
     /*  781501 */   GIM_Try, /*On fail goto*//*Label 12160*/ GIMT_Encode4(781579), // Rule ID 14875 //
     /*  781506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  781517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  781520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  781523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781577 */     GIR_RootConstrainSelectedInstOperands,
     /*  781578 */     // GIR_Coverage, 14875,
     /*  781578 */     GIR_EraseRootFromParent_Done,
     /*  781579 */   // Label 12160: @781579
     /*  781579 */   GIM_Try, /*On fail goto*//*Label 12161*/ GIMT_Encode4(781657), // Rule ID 14878 //
     /*  781584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781630 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  781630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781655 */     GIR_RootConstrainSelectedInstOperands,
     /*  781656 */     // GIR_Coverage, 14878,
     /*  781656 */     GIR_EraseRootFromParent_Done,
     /*  781657 */   // Label 12161: @781657
     /*  781657 */   GIM_Try, /*On fail goto*//*Label 12162*/ GIMT_Encode4(781735), // Rule ID 14879 //
     /*  781662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781708 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  781708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781733 */     GIR_RootConstrainSelectedInstOperands,
     /*  781734 */     // GIR_Coverage, 14879,
     /*  781734 */     GIR_EraseRootFromParent_Done,
     /*  781735 */   // Label 12162: @781735
     /*  781735 */   GIM_Try, /*On fail goto*//*Label 12163*/ GIMT_Encode4(781813), // Rule ID 14882 //
     /*  781740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  781751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  781754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  781757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781786 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781811 */     GIR_RootConstrainSelectedInstOperands,
     /*  781812 */     // GIR_Coverage, 14882,
     /*  781812 */     GIR_EraseRootFromParent_Done,
     /*  781813 */   // Label 12163: @781813
     /*  781813 */   GIM_Try, /*On fail goto*//*Label 12164*/ GIMT_Encode4(781891), // Rule ID 14883 //
     /*  781818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  781829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  781832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  781835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781864 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11672:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781889 */     GIR_RootConstrainSelectedInstOperands,
     /*  781890 */     // GIR_Coverage, 14883,
     /*  781890 */     GIR_EraseRootFromParent_Done,
     /*  781891 */   // Label 12164: @781891
     /*  781891 */   GIM_Try, /*On fail goto*//*Label 12165*/ GIMT_Encode4(781969), // Rule ID 14886 //
     /*  781896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781942 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781967 */     GIR_RootConstrainSelectedInstOperands,
     /*  781968 */     // GIR_Coverage, 14886,
     /*  781968 */     GIR_EraseRootFromParent_Done,
     /*  781969 */   // Label 12165: @781969
     /*  781969 */   GIM_Try, /*On fail goto*//*Label 12166*/ GIMT_Encode4(782047), // Rule ID 14887 //
     /*  781974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  782023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782045 */     GIR_RootConstrainSelectedInstOperands,
     /*  782046 */     // GIR_Coverage, 14887,
     /*  782046 */     GIR_EraseRootFromParent_Done,
     /*  782047 */   // Label 12166: @782047
     /*  782047 */   GIM_Try, /*On fail goto*//*Label 12167*/ GIMT_Encode4(782125), // Rule ID 14890 //
     /*  782052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  782063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  782066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  782069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782098 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  782098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  782101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782123 */     GIR_RootConstrainSelectedInstOperands,
     /*  782124 */     // GIR_Coverage, 14890,
     /*  782124 */     GIR_EraseRootFromParent_Done,
     /*  782125 */   // Label 12167: @782125
     /*  782125 */   GIM_Try, /*On fail goto*//*Label 12168*/ GIMT_Encode4(782203), // Rule ID 14891 //
     /*  782130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  782141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  782144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  782147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  782176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  782179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782201 */     GIR_RootConstrainSelectedInstOperands,
     /*  782202 */     // GIR_Coverage, 14891,
     /*  782202 */     GIR_EraseRootFromParent_Done,
     /*  782203 */   // Label 12168: @782203
     /*  782203 */   GIM_Try, /*On fail goto*//*Label 12169*/ GIMT_Encode4(782281), // Rule ID 14894 //
     /*  782208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  782211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  782219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  782222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  782225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782254 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  782254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  782257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782279 */     GIR_RootConstrainSelectedInstOperands,
     /*  782280 */     // GIR_Coverage, 14894,
     /*  782280 */     GIR_EraseRootFromParent_Done,
     /*  782281 */   // Label 12169: @782281
     /*  782281 */   GIM_Try, /*On fail goto*//*Label 12170*/ GIMT_Encode4(782359), // Rule ID 14895 //
     /*  782286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  782289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  782297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  782300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  782303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782332 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  782332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  782335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782357 */     GIR_RootConstrainSelectedInstOperands,
     /*  782358 */     // GIR_Coverage, 14895,
     /*  782358 */     GIR_EraseRootFromParent_Done,
     /*  782359 */   // Label 12170: @782359
     /*  782359 */   GIM_Try, /*On fail goto*//*Label 12171*/ GIMT_Encode4(782437), // Rule ID 14898 //
     /*  782364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  782375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  782378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  782381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782410 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782435 */     GIR_RootConstrainSelectedInstOperands,
     /*  782436 */     // GIR_Coverage, 14898,
     /*  782436 */     GIR_EraseRootFromParent_Done,
     /*  782437 */   // Label 12171: @782437
     /*  782437 */   GIM_Try, /*On fail goto*//*Label 12172*/ GIMT_Encode4(782515), // Rule ID 14899 //
     /*  782442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  782453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  782456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  782459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782488 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782513 */     GIR_RootConstrainSelectedInstOperands,
     /*  782514 */     // GIR_Coverage, 14899,
     /*  782514 */     GIR_EraseRootFromParent_Done,
     /*  782515 */   // Label 12172: @782515
     /*  782515 */   GIM_Try, /*On fail goto*//*Label 12173*/ GIMT_Encode4(782593), // Rule ID 14902 //
     /*  782520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  782531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  782534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  782537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782566 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782591 */     GIR_RootConstrainSelectedInstOperands,
     /*  782592 */     // GIR_Coverage, 14902,
     /*  782592 */     GIR_EraseRootFromParent_Done,
     /*  782593 */   // Label 12173: @782593
     /*  782593 */   GIM_Try, /*On fail goto*//*Label 12174*/ GIMT_Encode4(782671), // Rule ID 14903 //
     /*  782598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  782609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  782612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  782615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782644 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782669 */     GIR_RootConstrainSelectedInstOperands,
     /*  782670 */     // GIR_Coverage, 14903,
     /*  782670 */     GIR_EraseRootFromParent_Done,
     /*  782671 */   // Label 12174: @782671
     /*  782671 */   GIM_Try, /*On fail goto*//*Label 12175*/ GIMT_Encode4(782749), // Rule ID 14906 //
     /*  782676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  782687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  782690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  782693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782722 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782747 */     GIR_RootConstrainSelectedInstOperands,
     /*  782748 */     // GIR_Coverage, 14906,
     /*  782748 */     GIR_EraseRootFromParent_Done,
     /*  782749 */   // Label 12175: @782749
     /*  782749 */   GIM_Try, /*On fail goto*//*Label 12176*/ GIMT_Encode4(782827), // Rule ID 14907 //
     /*  782754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  782765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  782768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  782771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782800 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782825 */     GIR_RootConstrainSelectedInstOperands,
     /*  782826 */     // GIR_Coverage, 14907,
     /*  782826 */     GIR_EraseRootFromParent_Done,
     /*  782827 */   // Label 12176: @782827
     /*  782827 */   GIM_Try, /*On fail goto*//*Label 12177*/ GIMT_Encode4(782905), // Rule ID 14910 //
     /*  782832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  782843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  782846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  782849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782878 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782903 */     GIR_RootConstrainSelectedInstOperands,
     /*  782904 */     // GIR_Coverage, 14910,
     /*  782904 */     GIR_EraseRootFromParent_Done,
     /*  782905 */   // Label 12177: @782905
     /*  782905 */   GIM_Try, /*On fail goto*//*Label 12178*/ GIMT_Encode4(782983), // Rule ID 14911 //
     /*  782910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  782921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  782924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  782927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782978 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782981 */     GIR_RootConstrainSelectedInstOperands,
     /*  782982 */     // GIR_Coverage, 14911,
     /*  782982 */     GIR_EraseRootFromParent_Done,
     /*  782983 */   // Label 12178: @782983
     /*  782983 */   GIM_Try, /*On fail goto*//*Label 12179*/ GIMT_Encode4(783061), // Rule ID 14914 //
     /*  782988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  782999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  783002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  783005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783059 */     GIR_RootConstrainSelectedInstOperands,
     /*  783060 */     // GIR_Coverage, 14914,
     /*  783060 */     GIR_EraseRootFromParent_Done,
     /*  783061 */   // Label 12179: @783061
     /*  783061 */   GIM_Try, /*On fail goto*//*Label 12180*/ GIMT_Encode4(783139), // Rule ID 14915 //
     /*  783066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  783077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  783080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  783083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783112 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783137 */     GIR_RootConstrainSelectedInstOperands,
     /*  783138 */     // GIR_Coverage, 14915,
     /*  783138 */     GIR_EraseRootFromParent_Done,
     /*  783139 */   // Label 12180: @783139
     /*  783139 */   GIM_Try, /*On fail goto*//*Label 12181*/ GIMT_Encode4(783217), // Rule ID 14918 //
     /*  783144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  783155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  783158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  783161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783190 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783215 */     GIR_RootConstrainSelectedInstOperands,
     /*  783216 */     // GIR_Coverage, 14918,
     /*  783216 */     GIR_EraseRootFromParent_Done,
     /*  783217 */   // Label 12181: @783217
     /*  783217 */   GIM_Try, /*On fail goto*//*Label 12182*/ GIMT_Encode4(783295), // Rule ID 14919 //
     /*  783222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  783233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  783236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  783239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783293 */     GIR_RootConstrainSelectedInstOperands,
     /*  783294 */     // GIR_Coverage, 14919,
     /*  783294 */     GIR_EraseRootFromParent_Done,
     /*  783295 */   // Label 12182: @783295
     /*  783295 */   GIM_Try, /*On fail goto*//*Label 12183*/ GIMT_Encode4(783373), // Rule ID 14922 //
     /*  783300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  783311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  783314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  783317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  783349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783371 */     GIR_RootConstrainSelectedInstOperands,
     /*  783372 */     // GIR_Coverage, 14922,
     /*  783372 */     GIR_EraseRootFromParent_Done,
     /*  783373 */   // Label 12183: @783373
     /*  783373 */   GIM_Try, /*On fail goto*//*Label 12184*/ GIMT_Encode4(783451), // Rule ID 14923 //
     /*  783378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  783389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  783392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  783395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  783427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783449 */     GIR_RootConstrainSelectedInstOperands,
     /*  783450 */     // GIR_Coverage, 14923,
     /*  783450 */     GIR_EraseRootFromParent_Done,
     /*  783451 */   // Label 12184: @783451
     /*  783451 */   GIM_Try, /*On fail goto*//*Label 12185*/ GIMT_Encode4(783529), // Rule ID 14926 //
     /*  783456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  783467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  783470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  783473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783527 */     GIR_RootConstrainSelectedInstOperands,
     /*  783528 */     // GIR_Coverage, 14926,
     /*  783528 */     GIR_EraseRootFromParent_Done,
     /*  783529 */   // Label 12185: @783529
     /*  783529 */   GIM_Try, /*On fail goto*//*Label 12186*/ GIMT_Encode4(783607), // Rule ID 14927 //
     /*  783534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  783545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  783548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  783551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783580 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783605 */     GIR_RootConstrainSelectedInstOperands,
     /*  783606 */     // GIR_Coverage, 14927,
     /*  783606 */     GIR_EraseRootFromParent_Done,
     /*  783607 */   // Label 12186: @783607
     /*  783607 */   GIM_Try, /*On fail goto*//*Label 12187*/ GIMT_Encode4(783685), // Rule ID 14930 //
     /*  783612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  783623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  783626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  783629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783658 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783683 */     GIR_RootConstrainSelectedInstOperands,
     /*  783684 */     // GIR_Coverage, 14930,
     /*  783684 */     GIR_EraseRootFromParent_Done,
     /*  783685 */   // Label 12187: @783685
     /*  783685 */   GIM_Try, /*On fail goto*//*Label 12188*/ GIMT_Encode4(783763), // Rule ID 14931 //
     /*  783690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  783701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  783704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  783707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783761 */     GIR_RootConstrainSelectedInstOperands,
     /*  783762 */     // GIR_Coverage, 14931,
     /*  783762 */     GIR_EraseRootFromParent_Done,
     /*  783763 */   // Label 12188: @783763
     /*  783763 */   GIM_Try, /*On fail goto*//*Label 12189*/ GIMT_Encode4(783841), // Rule ID 14934 //
     /*  783768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  783779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  783782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  783785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  783817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783839 */     GIR_RootConstrainSelectedInstOperands,
     /*  783840 */     // GIR_Coverage, 14934,
     /*  783840 */     GIR_EraseRootFromParent_Done,
     /*  783841 */   // Label 12189: @783841
     /*  783841 */   GIM_Try, /*On fail goto*//*Label 12190*/ GIMT_Encode4(783919), // Rule ID 14935 //
     /*  783846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  783857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  783860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  783863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  783895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783917 */     GIR_RootConstrainSelectedInstOperands,
     /*  783918 */     // GIR_Coverage, 14935,
     /*  783918 */     GIR_EraseRootFromParent_Done,
     /*  783919 */   // Label 12190: @783919
     /*  783919 */   GIM_Try, /*On fail goto*//*Label 12191*/ GIMT_Encode4(783997), // Rule ID 14938 //
     /*  783924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  783935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  783938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  783941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783970 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783995 */     GIR_RootConstrainSelectedInstOperands,
     /*  783996 */     // GIR_Coverage, 14938,
     /*  783996 */     GIR_EraseRootFromParent_Done,
     /*  783997 */   // Label 12191: @783997
     /*  783997 */   GIM_Try, /*On fail goto*//*Label 12192*/ GIMT_Encode4(784075), // Rule ID 14939 //
     /*  784002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  784005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  784013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  784016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  784019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784048 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  784048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  784051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784073 */     GIR_RootConstrainSelectedInstOperands,
     /*  784074 */     // GIR_Coverage, 14939,
     /*  784074 */     GIR_EraseRootFromParent_Done,
     /*  784075 */   // Label 12192: @784075
     /*  784075 */   GIM_Try, /*On fail goto*//*Label 12193*/ GIMT_Encode4(784153), // Rule ID 14942 //
     /*  784080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  784083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  784091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  784094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  784097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784126 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  784126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  784129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784151 */     GIR_RootConstrainSelectedInstOperands,
     /*  784152 */     // GIR_Coverage, 14942,
     /*  784152 */     GIR_EraseRootFromParent_Done,
     /*  784153 */   // Label 12193: @784153
     /*  784153 */   GIM_Try, /*On fail goto*//*Label 12194*/ GIMT_Encode4(784231), // Rule ID 14943 //
     /*  784158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  784161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  784169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  784172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  784175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784204 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  784204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  784207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784229 */     GIR_RootConstrainSelectedInstOperands,
     /*  784230 */     // GIR_Coverage, 14943,
     /*  784230 */     GIR_EraseRootFromParent_Done,
     /*  784231 */   // Label 12194: @784231
     /*  784231 */   GIM_Try, /*On fail goto*//*Label 12195*/ GIMT_Encode4(784306), // Rule ID 19184 //
     /*  784236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  784247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  784250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  784253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  784256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784282 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  784285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784304 */     GIR_RootConstrainSelectedInstOperands,
     /*  784305 */     // GIR_Coverage, 19184,
     /*  784305 */     GIR_EraseRootFromParent_Done,
     /*  784306 */   // Label 12195: @784306
     /*  784306 */   GIM_Try, /*On fail goto*//*Label 12196*/ GIMT_Encode4(784381), // Rule ID 19185 //
     /*  784311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  784322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  784325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  784328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  784331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784357 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  784360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784379 */     GIR_RootConstrainSelectedInstOperands,
     /*  784380 */     // GIR_Coverage, 19185,
     /*  784380 */     GIR_EraseRootFromParent_Done,
     /*  784381 */   // Label 12196: @784381
     /*  784381 */   GIM_Try, /*On fail goto*//*Label 12197*/ GIMT_Encode4(784456), // Rule ID 19188 //
     /*  784386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  784397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  784400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  784403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  784406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784432 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  784435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784454 */     GIR_RootConstrainSelectedInstOperands,
     /*  784455 */     // GIR_Coverage, 19188,
     /*  784455 */     GIR_EraseRootFromParent_Done,
     /*  784456 */   // Label 12197: @784456
     /*  784456 */   GIM_Try, /*On fail goto*//*Label 12198*/ GIMT_Encode4(784531), // Rule ID 19189 //
     /*  784461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  784472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  784475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  784478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  784481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784507 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  784510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784529 */     GIR_RootConstrainSelectedInstOperands,
     /*  784530 */     // GIR_Coverage, 19189,
     /*  784530 */     GIR_EraseRootFromParent_Done,
     /*  784531 */   // Label 12198: @784531
     /*  784531 */   GIM_Try, /*On fail goto*//*Label 12199*/ GIMT_Encode4(784606), // Rule ID 19192 //
     /*  784536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  784539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  784547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  784550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  784553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  784556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784582 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  784582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  784585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784604 */     GIR_RootConstrainSelectedInstOperands,
     /*  784605 */     // GIR_Coverage, 19192,
     /*  784605 */     GIR_EraseRootFromParent_Done,
     /*  784606 */   // Label 12199: @784606
     /*  784606 */   GIM_Try, /*On fail goto*//*Label 12200*/ GIMT_Encode4(784681), // Rule ID 19193 //
     /*  784611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  784614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  784622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  784625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  784628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  784631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784657 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  784657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  784660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784679 */     GIR_RootConstrainSelectedInstOperands,
     /*  784680 */     // GIR_Coverage, 19193,
     /*  784680 */     GIR_EraseRootFromParent_Done,
     /*  784681 */   // Label 12200: @784681
     /*  784681 */   GIM_Try, /*On fail goto*//*Label 12201*/ GIMT_Encode4(784756), // Rule ID 19196 //
     /*  784686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  784697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  784700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  784703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  784706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784732 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  784735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784754 */     GIR_RootConstrainSelectedInstOperands,
     /*  784755 */     // GIR_Coverage, 19196,
     /*  784755 */     GIR_EraseRootFromParent_Done,
     /*  784756 */   // Label 12201: @784756
     /*  784756 */   GIM_Try, /*On fail goto*//*Label 12202*/ GIMT_Encode4(784831), // Rule ID 19197 //
     /*  784761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  784772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  784775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  784778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  784781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784807 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  784810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784829 */     GIR_RootConstrainSelectedInstOperands,
     /*  784830 */     // GIR_Coverage, 19197,
     /*  784830 */     GIR_EraseRootFromParent_Done,
     /*  784831 */   // Label 12202: @784831
     /*  784831 */   GIM_Try, /*On fail goto*//*Label 12203*/ GIMT_Encode4(784906), // Rule ID 19200 //
     /*  784836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  784839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  784847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  784850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  784853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  784856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784882 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  784882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  784885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784904 */     GIR_RootConstrainSelectedInstOperands,
     /*  784905 */     // GIR_Coverage, 19200,
     /*  784905 */     GIR_EraseRootFromParent_Done,
     /*  784906 */   // Label 12203: @784906
     /*  784906 */   GIM_Try, /*On fail goto*//*Label 12204*/ GIMT_Encode4(784981), // Rule ID 19201 //
     /*  784911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  784914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  784922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  784925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  784928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  784931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784957 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  784957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  784960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784979 */     GIR_RootConstrainSelectedInstOperands,
     /*  784980 */     // GIR_Coverage, 19201,
     /*  784980 */     GIR_EraseRootFromParent_Done,
     /*  784981 */   // Label 12204: @784981
     /*  784981 */   GIM_Try, /*On fail goto*//*Label 12205*/ GIMT_Encode4(785056), // Rule ID 19204 //
     /*  784986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  784989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  784997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  785000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  785003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  785006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785032 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  785035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785054 */     GIR_RootConstrainSelectedInstOperands,
     /*  785055 */     // GIR_Coverage, 19204,
     /*  785055 */     GIR_EraseRootFromParent_Done,
     /*  785056 */   // Label 12205: @785056
     /*  785056 */   GIM_Try, /*On fail goto*//*Label 12206*/ GIMT_Encode4(785131), // Rule ID 19205 //
     /*  785061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  785064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  785072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  785075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  785078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  785081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785107 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  785110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785129 */     GIR_RootConstrainSelectedInstOperands,
     /*  785130 */     // GIR_Coverage, 19205,
     /*  785130 */     GIR_EraseRootFromParent_Done,
     /*  785131 */   // Label 12206: @785131
     /*  785131 */   GIM_Try, /*On fail goto*//*Label 12207*/ GIMT_Encode4(785206), // Rule ID 19208 //
     /*  785136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  785139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  785147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  785150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  785153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  785156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785182 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  785185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785204 */     GIR_RootConstrainSelectedInstOperands,
     /*  785205 */     // GIR_Coverage, 19208,
     /*  785205 */     GIR_EraseRootFromParent_Done,
     /*  785206 */   // Label 12207: @785206
     /*  785206 */   GIM_Try, /*On fail goto*//*Label 12208*/ GIMT_Encode4(785281), // Rule ID 19209 //
     /*  785211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  785214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  785222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  785225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  785228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  785231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785257 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  785260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785279 */     GIR_RootConstrainSelectedInstOperands,
     /*  785280 */     // GIR_Coverage, 19209,
     /*  785280 */     GIR_EraseRootFromParent_Done,
     /*  785281 */   // Label 12208: @785281
     /*  785281 */   GIM_Try, /*On fail goto*//*Label 12209*/ GIMT_Encode4(785356), // Rule ID 19212 //
     /*  785286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  785289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  785297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  785300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  785303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  785306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785332 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  785335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785354 */     GIR_RootConstrainSelectedInstOperands,
     /*  785355 */     // GIR_Coverage, 19212,
     /*  785355 */     GIR_EraseRootFromParent_Done,
     /*  785356 */   // Label 12209: @785356
     /*  785356 */   GIM_Try, /*On fail goto*//*Label 12210*/ GIMT_Encode4(785431), // Rule ID 19213 //
     /*  785361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  785364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  785372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  785375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  785378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  785381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785407 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  785410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785429 */     GIR_RootConstrainSelectedInstOperands,
     /*  785430 */     // GIR_Coverage, 19213,
     /*  785430 */     GIR_EraseRootFromParent_Done,
     /*  785431 */   // Label 12210: @785431
     /*  785431 */   GIM_Try, /*On fail goto*//*Label 12211*/ GIMT_Encode4(785506), // Rule ID 19216 //
     /*  785436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  785439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  785447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  785450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  785453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  785456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785482 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  785485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785504 */     GIR_RootConstrainSelectedInstOperands,
     /*  785505 */     // GIR_Coverage, 19216,
     /*  785505 */     GIR_EraseRootFromParent_Done,
     /*  785506 */   // Label 12211: @785506
     /*  785506 */   GIM_Try, /*On fail goto*//*Label 12212*/ GIMT_Encode4(785581), // Rule ID 19217 //
     /*  785511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  785514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  785522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  785525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  785528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  785531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785557 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  785560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785579 */     GIR_RootConstrainSelectedInstOperands,
     /*  785580 */     // GIR_Coverage, 19217,
     /*  785580 */     GIR_EraseRootFromParent_Done,
     /*  785581 */   // Label 12212: @785581
     /*  785581 */   GIM_Try, /*On fail goto*//*Label 12213*/ GIMT_Encode4(785656), // Rule ID 19220 //
     /*  785586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  785597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  785600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  785603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  785606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785632 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  785635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785654 */     GIR_RootConstrainSelectedInstOperands,
     /*  785655 */     // GIR_Coverage, 19220,
     /*  785655 */     GIR_EraseRootFromParent_Done,
     /*  785656 */   // Label 12213: @785656
     /*  785656 */   GIM_Try, /*On fail goto*//*Label 12214*/ GIMT_Encode4(785731), // Rule ID 19221 //
     /*  785661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  785672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  785675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  785678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  785681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785707 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  785710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785729 */     GIR_RootConstrainSelectedInstOperands,
     /*  785730 */     // GIR_Coverage, 19221,
     /*  785730 */     GIR_EraseRootFromParent_Done,
     /*  785731 */   // Label 12214: @785731
     /*  785731 */   GIM_Try, /*On fail goto*//*Label 12215*/ GIMT_Encode4(785806), // Rule ID 19224 //
     /*  785736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  785747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  785750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  785753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  785756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785782 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  785785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785804 */     GIR_RootConstrainSelectedInstOperands,
     /*  785805 */     // GIR_Coverage, 19224,
     /*  785805 */     GIR_EraseRootFromParent_Done,
     /*  785806 */   // Label 12215: @785806
     /*  785806 */   GIM_Try, /*On fail goto*//*Label 12216*/ GIMT_Encode4(785881), // Rule ID 19225 //
     /*  785811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  785822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  785825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  785828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  785831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785857 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  785860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785879 */     GIR_RootConstrainSelectedInstOperands,
     /*  785880 */     // GIR_Coverage, 19225,
     /*  785880 */     GIR_EraseRootFromParent_Done,
     /*  785881 */   // Label 12216: @785881
     /*  785881 */   GIM_Try, /*On fail goto*//*Label 12217*/ GIMT_Encode4(785956), // Rule ID 19228 //
     /*  785886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  785897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  785900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  785903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  785906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785932 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  785935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785954 */     GIR_RootConstrainSelectedInstOperands,
     /*  785955 */     // GIR_Coverage, 19228,
     /*  785955 */     GIR_EraseRootFromParent_Done,
     /*  785956 */   // Label 12217: @785956
     /*  785956 */   GIM_Try, /*On fail goto*//*Label 12218*/ GIMT_Encode4(786031), // Rule ID 19229 //
     /*  785961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  785972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  785975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  785978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  785981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786007 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  786010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786029 */     GIR_RootConstrainSelectedInstOperands,
     /*  786030 */     // GIR_Coverage, 19229,
     /*  786030 */     GIR_EraseRootFromParent_Done,
     /*  786031 */   // Label 12218: @786031
     /*  786031 */   GIM_Try, /*On fail goto*//*Label 12219*/ GIMT_Encode4(786106), // Rule ID 19232 //
     /*  786036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  786039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  786047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  786050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  786053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  786056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786082 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  786082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  786085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786104 */     GIR_RootConstrainSelectedInstOperands,
     /*  786105 */     // GIR_Coverage, 19232,
     /*  786105 */     GIR_EraseRootFromParent_Done,
     /*  786106 */   // Label 12219: @786106
     /*  786106 */   GIM_Try, /*On fail goto*//*Label 12220*/ GIMT_Encode4(786181), // Rule ID 19233 //
     /*  786111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  786114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  786122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  786125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  786128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  786131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786157 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  786157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  786160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786179 */     GIR_RootConstrainSelectedInstOperands,
     /*  786180 */     // GIR_Coverage, 19233,
     /*  786180 */     GIR_EraseRootFromParent_Done,
     /*  786181 */   // Label 12220: @786181
     /*  786181 */   GIM_Try, /*On fail goto*//*Label 12221*/ GIMT_Encode4(786256), // Rule ID 19236 //
     /*  786186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  786189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  786197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  786200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  786203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  786206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786232 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  786232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  786235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786254 */     GIR_RootConstrainSelectedInstOperands,
     /*  786255 */     // GIR_Coverage, 19236,
     /*  786255 */     GIR_EraseRootFromParent_Done,
     /*  786256 */   // Label 12221: @786256
     /*  786256 */   GIM_Try, /*On fail goto*//*Label 12222*/ GIMT_Encode4(786331), // Rule ID 19237 //
     /*  786261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  786264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  786272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  786275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  786278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  786281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786307 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  786307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  786310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786329 */     GIR_RootConstrainSelectedInstOperands,
     /*  786330 */     // GIR_Coverage, 19237,
     /*  786330 */     GIR_EraseRootFromParent_Done,
     /*  786331 */   // Label 12222: @786331
     /*  786331 */   GIM_Try, /*On fail goto*//*Label 12223*/ GIMT_Encode4(786406), // Rule ID 19240 //
     /*  786336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  786339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  786347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  786350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  786353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  786356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786382 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  786382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  786385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786404 */     GIR_RootConstrainSelectedInstOperands,
     /*  786405 */     // GIR_Coverage, 19240,
     /*  786405 */     GIR_EraseRootFromParent_Done,
     /*  786406 */   // Label 12223: @786406
     /*  786406 */   GIM_Try, /*On fail goto*//*Label 12224*/ GIMT_Encode4(786481), // Rule ID 19241 //
     /*  786411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  786414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  786422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  786425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  786428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  786431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786457 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  786457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  786460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786479 */     GIR_RootConstrainSelectedInstOperands,
     /*  786480 */     // GIR_Coverage, 19241,
     /*  786480 */     GIR_EraseRootFromParent_Done,
     /*  786481 */   // Label 12224: @786481
     /*  786481 */   GIM_Try, /*On fail goto*//*Label 12225*/ GIMT_Encode4(786556), // Rule ID 19244 //
     /*  786486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  786497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  786500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  786503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786532 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  786535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786554 */     GIR_RootConstrainSelectedInstOperands,
     /*  786555 */     // GIR_Coverage, 19244,
     /*  786555 */     GIR_EraseRootFromParent_Done,
     /*  786556 */   // Label 12225: @786556
     /*  786556 */   GIM_Try, /*On fail goto*//*Label 12226*/ GIMT_Encode4(786631), // Rule ID 19245 //
     /*  786561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  786572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  786575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  786578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786607 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  786610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786629 */     GIR_RootConstrainSelectedInstOperands,
     /*  786630 */     // GIR_Coverage, 19245,
     /*  786630 */     GIR_EraseRootFromParent_Done,
     /*  786631 */   // Label 12226: @786631
     /*  786631 */   GIM_Try, /*On fail goto*//*Label 12227*/ GIMT_Encode4(786706), // Rule ID 19248 //
     /*  786636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  786647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  786650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  786653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786682 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  786685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786704 */     GIR_RootConstrainSelectedInstOperands,
     /*  786705 */     // GIR_Coverage, 19248,
     /*  786705 */     GIR_EraseRootFromParent_Done,
     /*  786706 */   // Label 12227: @786706
     /*  786706 */   GIM_Try, /*On fail goto*//*Label 12228*/ GIMT_Encode4(786781), // Rule ID 19249 //
     /*  786711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  786722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  786725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  786728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786757 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  786760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786779 */     GIR_RootConstrainSelectedInstOperands,
     /*  786780 */     // GIR_Coverage, 19249,
     /*  786780 */     GIR_EraseRootFromParent_Done,
     /*  786781 */   // Label 12228: @786781
     /*  786781 */   GIM_Try, /*On fail goto*//*Label 12229*/ GIMT_Encode4(786856), // Rule ID 19252 //
     /*  786786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  786789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  786797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  786800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  786803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786832 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  786835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786854 */     GIR_RootConstrainSelectedInstOperands,
     /*  786855 */     // GIR_Coverage, 19252,
     /*  786855 */     GIR_EraseRootFromParent_Done,
     /*  786856 */   // Label 12229: @786856
     /*  786856 */   GIM_Try, /*On fail goto*//*Label 12230*/ GIMT_Encode4(786931), // Rule ID 19253 //
     /*  786861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  786864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  786872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  786875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  786878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786907 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  786910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786929 */     GIR_RootConstrainSelectedInstOperands,
     /*  786930 */     // GIR_Coverage, 19253,
     /*  786930 */     GIR_EraseRootFromParent_Done,
     /*  786931 */   // Label 12230: @786931
     /*  786931 */   GIM_Try, /*On fail goto*//*Label 12231*/ GIMT_Encode4(787006), // Rule ID 19256 //
     /*  786936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  786947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  786950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  786953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786982 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  786985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787004 */     GIR_RootConstrainSelectedInstOperands,
     /*  787005 */     // GIR_Coverage, 19256,
     /*  787005 */     GIR_EraseRootFromParent_Done,
     /*  787006 */   // Label 12231: @787006
     /*  787006 */   GIM_Try, /*On fail goto*//*Label 12232*/ GIMT_Encode4(787081), // Rule ID 19257 //
     /*  787011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  787022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  787025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  787028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787057 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  787060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787079 */     GIR_RootConstrainSelectedInstOperands,
     /*  787080 */     // GIR_Coverage, 19257,
     /*  787080 */     GIR_EraseRootFromParent_Done,
     /*  787081 */   // Label 12232: @787081
     /*  787081 */   GIM_Try, /*On fail goto*//*Label 12233*/ GIMT_Encode4(787156), // Rule ID 19260 //
     /*  787086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  787097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  787100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  787103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787132 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  787135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787154 */     GIR_RootConstrainSelectedInstOperands,
     /*  787155 */     // GIR_Coverage, 19260,
     /*  787155 */     GIR_EraseRootFromParent_Done,
     /*  787156 */   // Label 12233: @787156
     /*  787156 */   GIM_Try, /*On fail goto*//*Label 12234*/ GIMT_Encode4(787231), // Rule ID 19261 //
     /*  787161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  787172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  787175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  787178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787207 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  787210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787229 */     GIR_RootConstrainSelectedInstOperands,
     /*  787230 */     // GIR_Coverage, 19261,
     /*  787230 */     GIR_EraseRootFromParent_Done,
     /*  787231 */   // Label 12234: @787231
     /*  787231 */   GIM_Try, /*On fail goto*//*Label 12235*/ GIMT_Encode4(787306), // Rule ID 19264 //
     /*  787236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  787239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  787247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  787250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  787253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787282 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  787285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787304 */     GIR_RootConstrainSelectedInstOperands,
     /*  787305 */     // GIR_Coverage, 19264,
     /*  787305 */     GIR_EraseRootFromParent_Done,
     /*  787306 */   // Label 12235: @787306
     /*  787306 */   GIM_Try, /*On fail goto*//*Label 12236*/ GIMT_Encode4(787381), // Rule ID 19265 //
     /*  787311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  787314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  787322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  787325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  787328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787357 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  787360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787379 */     GIR_RootConstrainSelectedInstOperands,
     /*  787380 */     // GIR_Coverage, 19265,
     /*  787380 */     GIR_EraseRootFromParent_Done,
     /*  787381 */   // Label 12236: @787381
     /*  787381 */   GIM_Try, /*On fail goto*//*Label 12237*/ GIMT_Encode4(787456), // Rule ID 19268 //
     /*  787386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  787397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  787400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  787403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787432 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  787435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787454 */     GIR_RootConstrainSelectedInstOperands,
     /*  787455 */     // GIR_Coverage, 19268,
     /*  787455 */     GIR_EraseRootFromParent_Done,
     /*  787456 */   // Label 12237: @787456
     /*  787456 */   GIM_Try, /*On fail goto*//*Label 12238*/ GIMT_Encode4(787531), // Rule ID 19269 //
     /*  787461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  787472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  787475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  787478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787507 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  787510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787529 */     GIR_RootConstrainSelectedInstOperands,
     /*  787530 */     // GIR_Coverage, 19269,
     /*  787530 */     GIR_EraseRootFromParent_Done,
     /*  787531 */   // Label 12238: @787531
     /*  787531 */   GIM_Try, /*On fail goto*//*Label 12239*/ GIMT_Encode4(787606), // Rule ID 19272 //
     /*  787536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  787547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  787550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  787553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787582 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  787585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787604 */     GIR_RootConstrainSelectedInstOperands,
     /*  787605 */     // GIR_Coverage, 19272,
     /*  787605 */     GIR_EraseRootFromParent_Done,
     /*  787606 */   // Label 12239: @787606
     /*  787606 */   GIM_Try, /*On fail goto*//*Label 12240*/ GIMT_Encode4(787681), // Rule ID 19273 //
     /*  787611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  787622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  787625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  787628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787657 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  787660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787679 */     GIR_RootConstrainSelectedInstOperands,
     /*  787680 */     // GIR_Coverage, 19273,
     /*  787680 */     GIR_EraseRootFromParent_Done,
     /*  787681 */   // Label 12240: @787681
     /*  787681 */   GIM_Try, /*On fail goto*//*Label 12241*/ GIMT_Encode4(787756), // Rule ID 19276 //
     /*  787686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  787697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  787700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  787703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787732 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  787735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787754 */     GIR_RootConstrainSelectedInstOperands,
     /*  787755 */     // GIR_Coverage, 19276,
     /*  787755 */     GIR_EraseRootFromParent_Done,
     /*  787756 */   // Label 12241: @787756
     /*  787756 */   GIM_Try, /*On fail goto*//*Label 12242*/ GIMT_Encode4(787831), // Rule ID 19277 //
     /*  787761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  787772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  787775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  787778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787807 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  787810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787829 */     GIR_RootConstrainSelectedInstOperands,
     /*  787830 */     // GIR_Coverage, 19277,
     /*  787830 */     GIR_EraseRootFromParent_Done,
     /*  787831 */   // Label 12242: @787831
     /*  787831 */   GIM_Try, /*On fail goto*//*Label 12243*/ GIMT_Encode4(787906), // Rule ID 19280 //
     /*  787836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  787847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  787850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  787853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787882 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  787885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787904 */     GIR_RootConstrainSelectedInstOperands,
     /*  787905 */     // GIR_Coverage, 19280,
     /*  787905 */     GIR_EraseRootFromParent_Done,
     /*  787906 */   // Label 12243: @787906
     /*  787906 */   GIM_Try, /*On fail goto*//*Label 12244*/ GIMT_Encode4(787981), // Rule ID 19281 //
     /*  787911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  787922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  787925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  787928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787957 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  787960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787979 */     GIR_RootConstrainSelectedInstOperands,
     /*  787980 */     // GIR_Coverage, 19281,
     /*  787980 */     GIR_EraseRootFromParent_Done,
     /*  787981 */   // Label 12244: @787981
     /*  787981 */   GIM_Try, /*On fail goto*//*Label 12245*/ GIMT_Encode4(788056), // Rule ID 19284 //
     /*  787986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  787997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  788000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  788003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  788006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  788025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788032 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  788035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788054 */     GIR_RootConstrainSelectedInstOperands,
     /*  788055 */     // GIR_Coverage, 19284,
     /*  788055 */     GIR_EraseRootFromParent_Done,
     /*  788056 */   // Label 12245: @788056
     /*  788056 */   GIM_Try, /*On fail goto*//*Label 12246*/ GIMT_Encode4(788131), // Rule ID 19285 //
     /*  788061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  788064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  788072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  788075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  788078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  788081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  788100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788107 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  788110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788129 */     GIR_RootConstrainSelectedInstOperands,
     /*  788130 */     // GIR_Coverage, 19285,
     /*  788130 */     GIR_EraseRootFromParent_Done,
     /*  788131 */   // Label 12246: @788131
     /*  788131 */   GIM_Try, /*On fail goto*//*Label 12247*/ GIMT_Encode4(788206), // Rule ID 19288 //
     /*  788136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  788139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  788147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  788150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  788153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  788156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  788175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788182 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  788185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788204 */     GIR_RootConstrainSelectedInstOperands,
     /*  788205 */     // GIR_Coverage, 19288,
     /*  788205 */     GIR_EraseRootFromParent_Done,
     /*  788206 */   // Label 12247: @788206
     /*  788206 */   GIM_Try, /*On fail goto*//*Label 12248*/ GIMT_Encode4(788281), // Rule ID 19289 //
     /*  788211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  788214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  788222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  788225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  788228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  788231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  788250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788257 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  788260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788279 */     GIR_RootConstrainSelectedInstOperands,
     /*  788280 */     // GIR_Coverage, 19289,
     /*  788280 */     GIR_EraseRootFromParent_Done,
     /*  788281 */   // Label 12248: @788281
     /*  788281 */   GIM_Try, /*On fail goto*//*Label 12249*/ GIMT_Encode4(788356), // Rule ID 19292 //
     /*  788286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  788289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  788297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  788300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  788303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788332 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  788335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788354 */     GIR_RootConstrainSelectedInstOperands,
     /*  788355 */     // GIR_Coverage, 19292,
     /*  788355 */     GIR_EraseRootFromParent_Done,
     /*  788356 */   // Label 12249: @788356
     /*  788356 */   GIM_Try, /*On fail goto*//*Label 12250*/ GIMT_Encode4(788431), // Rule ID 19293 //
     /*  788361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  788372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  788375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  788378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788407 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  788410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788429 */     GIR_RootConstrainSelectedInstOperands,
     /*  788430 */     // GIR_Coverage, 19293,
     /*  788430 */     GIR_EraseRootFromParent_Done,
     /*  788431 */   // Label 12250: @788431
     /*  788431 */   GIM_Try, /*On fail goto*//*Label 12251*/ GIMT_Encode4(788506), // Rule ID 19296 //
     /*  788436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  788439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  788447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  788450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  788453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788482 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  788485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788504 */     GIR_RootConstrainSelectedInstOperands,
     /*  788505 */     // GIR_Coverage, 19296,
     /*  788505 */     GIR_EraseRootFromParent_Done,
     /*  788506 */   // Label 12251: @788506
     /*  788506 */   GIM_Try, /*On fail goto*//*Label 12252*/ GIMT_Encode4(788581), // Rule ID 19297 //
     /*  788511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  788522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  788525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  788528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788557 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  788560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788579 */     GIR_RootConstrainSelectedInstOperands,
     /*  788580 */     // GIR_Coverage, 19297,
     /*  788580 */     GIR_EraseRootFromParent_Done,
     /*  788581 */   // Label 12252: @788581
     /*  788581 */   GIM_Try, /*On fail goto*//*Label 12253*/ GIMT_Encode4(788656), // Rule ID 19300 //
     /*  788586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  788589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  788597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  788600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  788603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788632 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  788635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788654 */     GIR_RootConstrainSelectedInstOperands,
     /*  788655 */     // GIR_Coverage, 19300,
     /*  788655 */     GIR_EraseRootFromParent_Done,
     /*  788656 */   // Label 12253: @788656
     /*  788656 */   GIM_Try, /*On fail goto*//*Label 12254*/ GIMT_Encode4(788731), // Rule ID 19301 //
     /*  788661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  788672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  788675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  788678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788707 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  788710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788729 */     GIR_RootConstrainSelectedInstOperands,
     /*  788730 */     // GIR_Coverage, 19301,
     /*  788730 */     GIR_EraseRootFromParent_Done,
     /*  788731 */   // Label 12254: @788731
     /*  788731 */   GIM_Try, /*On fail goto*//*Label 12255*/ GIMT_Encode4(788806), // Rule ID 19304 //
     /*  788736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  788747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  788750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  788753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  788756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788782 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  788785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788804 */     GIR_RootConstrainSelectedInstOperands,
     /*  788805 */     // GIR_Coverage, 19304,
     /*  788805 */     GIR_EraseRootFromParent_Done,
     /*  788806 */   // Label 12255: @788806
     /*  788806 */   GIM_Try, /*On fail goto*//*Label 12256*/ GIMT_Encode4(788881), // Rule ID 19305 //
     /*  788811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  788822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  788825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  788828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  788831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788857 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  788860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788879 */     GIR_RootConstrainSelectedInstOperands,
     /*  788880 */     // GIR_Coverage, 19305,
     /*  788880 */     GIR_EraseRootFromParent_Done,
     /*  788881 */   // Label 12256: @788881
     /*  788881 */   GIM_Try, /*On fail goto*//*Label 12257*/ GIMT_Encode4(788956), // Rule ID 19308 //
     /*  788886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  788897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  788900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  788903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  788906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788932 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  788935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788954 */     GIR_RootConstrainSelectedInstOperands,
     /*  788955 */     // GIR_Coverage, 19308,
     /*  788955 */     GIR_EraseRootFromParent_Done,
     /*  788956 */   // Label 12257: @788956
     /*  788956 */   GIM_Try, /*On fail goto*//*Label 12258*/ GIMT_Encode4(789031), // Rule ID 19309 //
     /*  788961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  788972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  788975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  788978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  788981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789007 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  789010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789029 */     GIR_RootConstrainSelectedInstOperands,
     /*  789030 */     // GIR_Coverage, 19309,
     /*  789030 */     GIR_EraseRootFromParent_Done,
     /*  789031 */   // Label 12258: @789031
     /*  789031 */   GIM_Try, /*On fail goto*//*Label 12259*/ GIMT_Encode4(789106), // Rule ID 19312 //
     /*  789036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  789047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  789050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  789053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  789056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789082 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  789085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789104 */     GIR_RootConstrainSelectedInstOperands,
     /*  789105 */     // GIR_Coverage, 19312,
     /*  789105 */     GIR_EraseRootFromParent_Done,
     /*  789106 */   // Label 12259: @789106
     /*  789106 */   GIM_Try, /*On fail goto*//*Label 12260*/ GIMT_Encode4(789181), // Rule ID 19313 //
     /*  789111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  789122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  789125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  789128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  789131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789157 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  789160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789179 */     GIR_RootConstrainSelectedInstOperands,
     /*  789180 */     // GIR_Coverage, 19313,
     /*  789180 */     GIR_EraseRootFromParent_Done,
     /*  789181 */   // Label 12260: @789181
     /*  789181 */   GIM_Try, /*On fail goto*//*Label 12261*/ GIMT_Encode4(789256), // Rule ID 19316 //
     /*  789186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  789197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  789200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  789203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  789206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789232 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  789235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789254 */     GIR_RootConstrainSelectedInstOperands,
     /*  789255 */     // GIR_Coverage, 19316,
     /*  789255 */     GIR_EraseRootFromParent_Done,
     /*  789256 */   // Label 12261: @789256
     /*  789256 */   GIM_Try, /*On fail goto*//*Label 12262*/ GIMT_Encode4(789331), // Rule ID 19317 //
     /*  789261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  789272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  789275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  789278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  789281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789307 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  789310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789329 */     GIR_RootConstrainSelectedInstOperands,
     /*  789330 */     // GIR_Coverage, 19317,
     /*  789330 */     GIR_EraseRootFromParent_Done,
     /*  789331 */   // Label 12262: @789331
     /*  789331 */   GIM_Try, /*On fail goto*//*Label 12263*/ GIMT_Encode4(789406), // Rule ID 19320 //
     /*  789336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  789347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  789350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  789353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  789356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789382 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  789385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789404 */     GIR_RootConstrainSelectedInstOperands,
     /*  789405 */     // GIR_Coverage, 19320,
     /*  789405 */     GIR_EraseRootFromParent_Done,
     /*  789406 */   // Label 12263: @789406
     /*  789406 */   GIM_Try, /*On fail goto*//*Label 12264*/ GIMT_Encode4(789481), // Rule ID 19321 //
     /*  789411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  789422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  789425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  789428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  789431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789457 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  789460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789479 */     GIR_RootConstrainSelectedInstOperands,
     /*  789480 */     // GIR_Coverage, 19321,
     /*  789480 */     GIR_EraseRootFromParent_Done,
     /*  789481 */   // Label 12264: @789481
     /*  789481 */   GIM_Try, /*On fail goto*//*Label 12265*/ GIMT_Encode4(789556), // Rule ID 19324 //
     /*  789486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  789497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  789500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  789503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  789506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789532 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  789535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789554 */     GIR_RootConstrainSelectedInstOperands,
     /*  789555 */     // GIR_Coverage, 19324,
     /*  789555 */     GIR_EraseRootFromParent_Done,
     /*  789556 */   // Label 12265: @789556
     /*  789556 */   GIM_Try, /*On fail goto*//*Label 12266*/ GIMT_Encode4(789631), // Rule ID 19325 //
     /*  789561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  789572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  789575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  789578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  789581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789607 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  789610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789629 */     GIR_RootConstrainSelectedInstOperands,
     /*  789630 */     // GIR_Coverage, 19325,
     /*  789630 */     GIR_EraseRootFromParent_Done,
     /*  789631 */   // Label 12266: @789631
     /*  789631 */   GIM_Try, /*On fail goto*//*Label 12267*/ GIMT_Encode4(789706), // Rule ID 19328 //
     /*  789636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  789647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  789650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  789653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  789656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789682 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  789685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789704 */     GIR_RootConstrainSelectedInstOperands,
     /*  789705 */     // GIR_Coverage, 19328,
     /*  789705 */     GIR_EraseRootFromParent_Done,
     /*  789706 */   // Label 12267: @789706
     /*  789706 */   GIM_Try, /*On fail goto*//*Label 12268*/ GIMT_Encode4(789781), // Rule ID 19329 //
     /*  789711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  789722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  789725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  789728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  789731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789757 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  789760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789779 */     GIR_RootConstrainSelectedInstOperands,
     /*  789780 */     // GIR_Coverage, 19329,
     /*  789780 */     GIR_EraseRootFromParent_Done,
     /*  789781 */   // Label 12268: @789781
     /*  789781 */   GIM_Try, /*On fail goto*//*Label 12269*/ GIMT_Encode4(789856), // Rule ID 19332 //
     /*  789786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  789797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  789800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  789803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  789806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789832 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  789835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789854 */     GIR_RootConstrainSelectedInstOperands,
     /*  789855 */     // GIR_Coverage, 19332,
     /*  789855 */     GIR_EraseRootFromParent_Done,
     /*  789856 */   // Label 12269: @789856
     /*  789856 */   GIM_Try, /*On fail goto*//*Label 12270*/ GIMT_Encode4(789931), // Rule ID 19333 //
     /*  789861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  789872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  789875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  789878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  789881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789907 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  789910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789929 */     GIR_RootConstrainSelectedInstOperands,
     /*  789930 */     // GIR_Coverage, 19333,
     /*  789930 */     GIR_EraseRootFromParent_Done,
     /*  789931 */   // Label 12270: @789931
     /*  789931 */   GIM_Try, /*On fail goto*//*Label 12271*/ GIMT_Encode4(790006), // Rule ID 19336 //
     /*  789936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  789947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  789950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  789953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  789956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789982 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  789985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790004 */     GIR_RootConstrainSelectedInstOperands,
     /*  790005 */     // GIR_Coverage, 19336,
     /*  790005 */     GIR_EraseRootFromParent_Done,
     /*  790006 */   // Label 12271: @790006
     /*  790006 */   GIM_Try, /*On fail goto*//*Label 12272*/ GIMT_Encode4(790081), // Rule ID 19337 //
     /*  790011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  790022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  790025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  790028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  790031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790057 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  790060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790079 */     GIR_RootConstrainSelectedInstOperands,
     /*  790080 */     // GIR_Coverage, 19337,
     /*  790080 */     GIR_EraseRootFromParent_Done,
     /*  790081 */   // Label 12272: @790081
     /*  790081 */   GIM_Try, /*On fail goto*//*Label 12273*/ GIMT_Encode4(790156), // Rule ID 19340 //
     /*  790086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  790097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  790100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  790103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  790106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790132 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  790135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790154 */     GIR_RootConstrainSelectedInstOperands,
     /*  790155 */     // GIR_Coverage, 19340,
     /*  790155 */     GIR_EraseRootFromParent_Done,
     /*  790156 */   // Label 12273: @790156
     /*  790156 */   GIM_Try, /*On fail goto*//*Label 12274*/ GIMT_Encode4(790231), // Rule ID 19341 //
     /*  790161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  790172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  790175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  790178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  790181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790207 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  790210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790229 */     GIR_RootConstrainSelectedInstOperands,
     /*  790230 */     // GIR_Coverage, 19341,
     /*  790230 */     GIR_EraseRootFromParent_Done,
     /*  790231 */   // Label 12274: @790231
     /*  790231 */   GIM_Try, /*On fail goto*//*Label 12275*/ GIMT_Encode4(790306), // Rule ID 19344 //
     /*  790236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  790247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  790250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  790253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  790256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790282 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  790285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790304 */     GIR_RootConstrainSelectedInstOperands,
     /*  790305 */     // GIR_Coverage, 19344,
     /*  790305 */     GIR_EraseRootFromParent_Done,
     /*  790306 */   // Label 12275: @790306
     /*  790306 */   GIM_Try, /*On fail goto*//*Label 12276*/ GIMT_Encode4(790381), // Rule ID 19345 //
     /*  790311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  790322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  790325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  790328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  790331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790357 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  790360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790379 */     GIR_RootConstrainSelectedInstOperands,
     /*  790380 */     // GIR_Coverage, 19345,
     /*  790380 */     GIR_EraseRootFromParent_Done,
     /*  790381 */   // Label 12276: @790381
     /*  790381 */   GIM_Try, /*On fail goto*//*Label 12277*/ GIMT_Encode4(790456), // Rule ID 19348 //
     /*  790386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  790397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  790400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  790403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  790406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790432 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  790435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790454 */     GIR_RootConstrainSelectedInstOperands,
     /*  790455 */     // GIR_Coverage, 19348,
     /*  790455 */     GIR_EraseRootFromParent_Done,
     /*  790456 */   // Label 12277: @790456
     /*  790456 */   GIM_Try, /*On fail goto*//*Label 12278*/ GIMT_Encode4(790531), // Rule ID 19349 //
     /*  790461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  790472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  790475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  790478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  790481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790507 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  790510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790529 */     GIR_RootConstrainSelectedInstOperands,
     /*  790530 */     // GIR_Coverage, 19349,
     /*  790530 */     GIR_EraseRootFromParent_Done,
     /*  790531 */   // Label 12278: @790531
     /*  790531 */   GIM_Try, /*On fail goto*//*Label 12279*/ GIMT_Encode4(790606), // Rule ID 19352 //
     /*  790536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  790547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  790550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  790553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  790556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790582 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  790585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790604 */     GIR_RootConstrainSelectedInstOperands,
     /*  790605 */     // GIR_Coverage, 19352,
     /*  790605 */     GIR_EraseRootFromParent_Done,
     /*  790606 */   // Label 12279: @790606
     /*  790606 */   GIM_Try, /*On fail goto*//*Label 12280*/ GIMT_Encode4(790681), // Rule ID 19353 //
     /*  790611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  790622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  790625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  790628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  790631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790657 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  790660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790679 */     GIR_RootConstrainSelectedInstOperands,
     /*  790680 */     // GIR_Coverage, 19353,
     /*  790680 */     GIR_EraseRootFromParent_Done,
     /*  790681 */   // Label 12280: @790681
     /*  790681 */   GIM_Try, /*On fail goto*//*Label 12281*/ GIMT_Encode4(790756), // Rule ID 19356 //
     /*  790686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  790697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  790700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  790703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  790706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790732 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  790735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790754 */     GIR_RootConstrainSelectedInstOperands,
     /*  790755 */     // GIR_Coverage, 19356,
     /*  790755 */     GIR_EraseRootFromParent_Done,
     /*  790756 */   // Label 12281: @790756
     /*  790756 */   GIM_Try, /*On fail goto*//*Label 12282*/ GIMT_Encode4(790831), // Rule ID 19357 //
     /*  790761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  790772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  790775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  790778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  790781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790807 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  790810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790829 */     GIR_RootConstrainSelectedInstOperands,
     /*  790830 */     // GIR_Coverage, 19357,
     /*  790830 */     GIR_EraseRootFromParent_Done,
     /*  790831 */   // Label 12282: @790831
     /*  790831 */   GIM_Try, /*On fail goto*//*Label 12283*/ GIMT_Encode4(790906), // Rule ID 19360 //
     /*  790836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  790847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  790850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  790853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  790856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790882 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  790885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790904 */     GIR_RootConstrainSelectedInstOperands,
     /*  790905 */     // GIR_Coverage, 19360,
     /*  790905 */     GIR_EraseRootFromParent_Done,
     /*  790906 */   // Label 12283: @790906
     /*  790906 */   GIM_Try, /*On fail goto*//*Label 12284*/ GIMT_Encode4(790981), // Rule ID 19361 //
     /*  790911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  790922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  790925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  790928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  790931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790957 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  790960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790979 */     GIR_RootConstrainSelectedInstOperands,
     /*  790980 */     // GIR_Coverage, 19361,
     /*  790980 */     GIR_EraseRootFromParent_Done,
     /*  790981 */   // Label 12284: @790981
     /*  790981 */   GIM_Try, /*On fail goto*//*Label 12285*/ GIMT_Encode4(791056), // Rule ID 19364 //
     /*  790986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  790997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  791000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  791003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791032 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  791035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791054 */     GIR_RootConstrainSelectedInstOperands,
     /*  791055 */     // GIR_Coverage, 19364,
     /*  791055 */     GIR_EraseRootFromParent_Done,
     /*  791056 */   // Label 12285: @791056
     /*  791056 */   GIM_Try, /*On fail goto*//*Label 12286*/ GIMT_Encode4(791131), // Rule ID 19365 //
     /*  791061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  791072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  791075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  791078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791107 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  791110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791129 */     GIR_RootConstrainSelectedInstOperands,
     /*  791130 */     // GIR_Coverage, 19365,
     /*  791130 */     GIR_EraseRootFromParent_Done,
     /*  791131 */   // Label 12286: @791131
     /*  791131 */   GIM_Try, /*On fail goto*//*Label 12287*/ GIMT_Encode4(791206), // Rule ID 19368 //
     /*  791136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  791147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  791150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  791153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791182 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  791185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791204 */     GIR_RootConstrainSelectedInstOperands,
     /*  791205 */     // GIR_Coverage, 19368,
     /*  791205 */     GIR_EraseRootFromParent_Done,
     /*  791206 */   // Label 12287: @791206
     /*  791206 */   GIM_Try, /*On fail goto*//*Label 12288*/ GIMT_Encode4(791281), // Rule ID 19369 //
     /*  791211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  791222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  791225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  791228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791257 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  791260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791279 */     GIR_RootConstrainSelectedInstOperands,
     /*  791280 */     // GIR_Coverage, 19369,
     /*  791280 */     GIR_EraseRootFromParent_Done,
     /*  791281 */   // Label 12288: @791281
     /*  791281 */   GIM_Try, /*On fail goto*//*Label 12289*/ GIMT_Encode4(791356), // Rule ID 19372 //
     /*  791286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  791297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  791300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  791303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791332 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  791335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791354 */     GIR_RootConstrainSelectedInstOperands,
     /*  791355 */     // GIR_Coverage, 19372,
     /*  791355 */     GIR_EraseRootFromParent_Done,
     /*  791356 */   // Label 12289: @791356
     /*  791356 */   GIM_Try, /*On fail goto*//*Label 12290*/ GIMT_Encode4(791431), // Rule ID 19373 //
     /*  791361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  791372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  791375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  791378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791407 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  791410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791429 */     GIR_RootConstrainSelectedInstOperands,
     /*  791430 */     // GIR_Coverage, 19373,
     /*  791430 */     GIR_EraseRootFromParent_Done,
     /*  791431 */   // Label 12290: @791431
     /*  791431 */   GIM_Try, /*On fail goto*//*Label 12291*/ GIMT_Encode4(791506), // Rule ID 19376 //
     /*  791436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  791447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  791450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  791453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791482 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  791485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791504 */     GIR_RootConstrainSelectedInstOperands,
     /*  791505 */     // GIR_Coverage, 19376,
     /*  791505 */     GIR_EraseRootFromParent_Done,
     /*  791506 */   // Label 12291: @791506
     /*  791506 */   GIM_Try, /*On fail goto*//*Label 12292*/ GIMT_Encode4(791581), // Rule ID 19377 //
     /*  791511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  791522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  791525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  791528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791557 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  791560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791579 */     GIR_RootConstrainSelectedInstOperands,
     /*  791580 */     // GIR_Coverage, 19377,
     /*  791580 */     GIR_EraseRootFromParent_Done,
     /*  791581 */   // Label 12292: @791581
     /*  791581 */   GIM_Try, /*On fail goto*//*Label 12293*/ GIMT_Encode4(791656), // Rule ID 19380 //
     /*  791586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  791597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  791600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  791603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791632 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  791635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791654 */     GIR_RootConstrainSelectedInstOperands,
     /*  791655 */     // GIR_Coverage, 19380,
     /*  791655 */     GIR_EraseRootFromParent_Done,
     /*  791656 */   // Label 12293: @791656
     /*  791656 */   GIM_Try, /*On fail goto*//*Label 12294*/ GIMT_Encode4(791731), // Rule ID 19381 //
     /*  791661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  791672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  791675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  791678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791707 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  791710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791729 */     GIR_RootConstrainSelectedInstOperands,
     /*  791730 */     // GIR_Coverage, 19381,
     /*  791730 */     GIR_EraseRootFromParent_Done,
     /*  791731 */   // Label 12294: @791731
     /*  791731 */   GIM_Try, /*On fail goto*//*Label 12295*/ GIMT_Encode4(791806), // Rule ID 19384 //
     /*  791736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  791739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  791747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  791750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  791753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791782 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  791782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  791785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791804 */     GIR_RootConstrainSelectedInstOperands,
     /*  791805 */     // GIR_Coverage, 19384,
     /*  791805 */     GIR_EraseRootFromParent_Done,
     /*  791806 */   // Label 12295: @791806
     /*  791806 */   GIM_Try, /*On fail goto*//*Label 12296*/ GIMT_Encode4(791881), // Rule ID 19385 //
     /*  791811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  791814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  791822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  791825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  791828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791857 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  791857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  791860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791879 */     GIR_RootConstrainSelectedInstOperands,
     /*  791880 */     // GIR_Coverage, 19385,
     /*  791880 */     GIR_EraseRootFromParent_Done,
     /*  791881 */   // Label 12296: @791881
     /*  791881 */   GIM_Try, /*On fail goto*//*Label 12297*/ GIMT_Encode4(791956), // Rule ID 19388 //
     /*  791886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  791897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  791900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  791903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791932 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  791935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791954 */     GIR_RootConstrainSelectedInstOperands,
     /*  791955 */     // GIR_Coverage, 19388,
     /*  791955 */     GIR_EraseRootFromParent_Done,
     /*  791956 */   // Label 12297: @791956
     /*  791956 */   GIM_Try, /*On fail goto*//*Label 12298*/ GIMT_Encode4(792031), // Rule ID 19389 //
     /*  791961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  791972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  791975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  791978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  792000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792007 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  792010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792029 */     GIR_RootConstrainSelectedInstOperands,
     /*  792030 */     // GIR_Coverage, 19389,
     /*  792030 */     GIR_EraseRootFromParent_Done,
     /*  792031 */   // Label 12298: @792031
     /*  792031 */   GIM_Try, /*On fail goto*//*Label 12299*/ GIMT_Encode4(792106), // Rule ID 19392 //
     /*  792036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  792047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  792050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  792053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  792056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  792075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792082 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  792085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792104 */     GIR_RootConstrainSelectedInstOperands,
     /*  792105 */     // GIR_Coverage, 19392,
     /*  792105 */     GIR_EraseRootFromParent_Done,
     /*  792106 */   // Label 12299: @792106
     /*  792106 */   GIM_Try, /*On fail goto*//*Label 12300*/ GIMT_Encode4(792181), // Rule ID 19393 //
     /*  792111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  792122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  792125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  792128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  792131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  792150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792157 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  792160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792179 */     GIR_RootConstrainSelectedInstOperands,
     /*  792180 */     // GIR_Coverage, 19393,
     /*  792180 */     GIR_EraseRootFromParent_Done,
     /*  792181 */   // Label 12300: @792181
     /*  792181 */   GIM_Try, /*On fail goto*//*Label 12301*/ GIMT_Encode4(792256), // Rule ID 19396 //
     /*  792186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  792197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  792200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  792203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  792206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  792225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792232 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  792235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792254 */     GIR_RootConstrainSelectedInstOperands,
     /*  792255 */     // GIR_Coverage, 19396,
     /*  792255 */     GIR_EraseRootFromParent_Done,
     /*  792256 */   // Label 12301: @792256
     /*  792256 */   GIM_Try, /*On fail goto*//*Label 12302*/ GIMT_Encode4(792331), // Rule ID 19397 //
     /*  792261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  792272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  792275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  792278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  792281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  792300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792307 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  792310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792329 */     GIR_RootConstrainSelectedInstOperands,
     /*  792330 */     // GIR_Coverage, 19397,
     /*  792330 */     GIR_EraseRootFromParent_Done,
     /*  792331 */   // Label 12302: @792331
     /*  792331 */   GIM_Try, /*On fail goto*//*Label 12303*/ GIMT_Encode4(792406), // Rule ID 19400 //
     /*  792336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  792347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  792350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  792353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792382 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  792385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792404 */     GIR_RootConstrainSelectedInstOperands,
     /*  792405 */     // GIR_Coverage, 19400,
     /*  792405 */     GIR_EraseRootFromParent_Done,
     /*  792406 */   // Label 12303: @792406
     /*  792406 */   GIM_Try, /*On fail goto*//*Label 12304*/ GIMT_Encode4(792481), // Rule ID 19401 //
     /*  792411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  792422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  792425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  792428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792457 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  792460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792479 */     GIR_RootConstrainSelectedInstOperands,
     /*  792480 */     // GIR_Coverage, 19401,
     /*  792480 */     GIR_EraseRootFromParent_Done,
     /*  792481 */   // Label 12304: @792481
     /*  792481 */   GIM_Try, /*On fail goto*//*Label 12305*/ GIMT_Encode4(792556), // Rule ID 19404 //
     /*  792486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  792497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  792500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  792503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792532 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  792535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792554 */     GIR_RootConstrainSelectedInstOperands,
     /*  792555 */     // GIR_Coverage, 19404,
     /*  792555 */     GIR_EraseRootFromParent_Done,
     /*  792556 */   // Label 12305: @792556
     /*  792556 */   GIM_Try, /*On fail goto*//*Label 12306*/ GIMT_Encode4(792631), // Rule ID 19405 //
     /*  792561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  792572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  792575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  792578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792607 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  792610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792629 */     GIR_RootConstrainSelectedInstOperands,
     /*  792630 */     // GIR_Coverage, 19405,
     /*  792630 */     GIR_EraseRootFromParent_Done,
     /*  792631 */   // Label 12306: @792631
     /*  792631 */   GIM_Try, /*On fail goto*//*Label 12307*/ GIMT_Encode4(792706), // Rule ID 19408 //
     /*  792636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  792647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  792650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  792653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792682 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  792685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792704 */     GIR_RootConstrainSelectedInstOperands,
     /*  792705 */     // GIR_Coverage, 19408,
     /*  792705 */     GIR_EraseRootFromParent_Done,
     /*  792706 */   // Label 12307: @792706
     /*  792706 */   GIM_Try, /*On fail goto*//*Label 12308*/ GIMT_Encode4(792781), // Rule ID 19409 //
     /*  792711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  792722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  792725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  792728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792757 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  792760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792779 */     GIR_RootConstrainSelectedInstOperands,
     /*  792780 */     // GIR_Coverage, 19409,
     /*  792780 */     GIR_EraseRootFromParent_Done,
     /*  792781 */   // Label 12308: @792781
     /*  792781 */   GIM_Try, /*On fail goto*//*Label 12309*/ GIMT_Encode4(792856), // Rule ID 19412 //
     /*  792786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  792797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  792800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  792803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792832 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  792835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792854 */     GIR_RootConstrainSelectedInstOperands,
     /*  792855 */     // GIR_Coverage, 19412,
     /*  792855 */     GIR_EraseRootFromParent_Done,
     /*  792856 */   // Label 12309: @792856
     /*  792856 */   GIM_Try, /*On fail goto*//*Label 12310*/ GIMT_Encode4(792931), // Rule ID 19413 //
     /*  792861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  792872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  792875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  792878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792907 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  792910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792929 */     GIR_RootConstrainSelectedInstOperands,
     /*  792930 */     // GIR_Coverage, 19413,
     /*  792930 */     GIR_EraseRootFromParent_Done,
     /*  792931 */   // Label 12310: @792931
     /*  792931 */   GIM_Try, /*On fail goto*//*Label 12311*/ GIMT_Encode4(793006), // Rule ID 19416 //
     /*  792936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  792947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  792950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  792953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792982 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  792985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793004 */     GIR_RootConstrainSelectedInstOperands,
     /*  793005 */     // GIR_Coverage, 19416,
     /*  793005 */     GIR_EraseRootFromParent_Done,
     /*  793006 */   // Label 12311: @793006
     /*  793006 */   GIM_Try, /*On fail goto*//*Label 12312*/ GIMT_Encode4(793081), // Rule ID 19417 //
     /*  793011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  793014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  793022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  793025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  793028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  793031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  793050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793057 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  793057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  793060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793079 */     GIR_RootConstrainSelectedInstOperands,
     /*  793080 */     // GIR_Coverage, 19417,
     /*  793080 */     GIR_EraseRootFromParent_Done,
     /*  793081 */   // Label 12312: @793081
     /*  793081 */   GIM_Try, /*On fail goto*//*Label 12313*/ GIMT_Encode4(793156), // Rule ID 19420 //
     /*  793086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  793089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  793097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  793100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  793103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  793106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  793125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793132 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  793132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  793135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793154 */     GIR_RootConstrainSelectedInstOperands,
     /*  793155 */     // GIR_Coverage, 19420,
     /*  793155 */     GIR_EraseRootFromParent_Done,
     /*  793156 */   // Label 12313: @793156
     /*  793156 */   GIM_Try, /*On fail goto*//*Label 12314*/ GIMT_Encode4(793231), // Rule ID 19421 //
     /*  793161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  793164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  793172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  793175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  793178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  793181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  793200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793207 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  793207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  793210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793229 */     GIR_RootConstrainSelectedInstOperands,
     /*  793230 */     // GIR_Coverage, 19421,
     /*  793230 */     GIR_EraseRootFromParent_Done,
     /*  793231 */   // Label 12314: @793231
     /*  793231 */   GIM_Try, /*On fail goto*//*Label 12315*/ GIMT_Encode4(793306), // Rule ID 19424 //
     /*  793236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  793247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  793250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  793253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  793256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793282 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  793285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793304 */     GIR_RootConstrainSelectedInstOperands,
     /*  793305 */     // GIR_Coverage, 19424,
     /*  793305 */     GIR_EraseRootFromParent_Done,
     /*  793306 */   // Label 12315: @793306
     /*  793306 */   GIM_Try, /*On fail goto*//*Label 12316*/ GIMT_Encode4(793381), // Rule ID 19425 //
     /*  793311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  793322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  793325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  793328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  793331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793357 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  793360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793379 */     GIR_RootConstrainSelectedInstOperands,
     /*  793380 */     // GIR_Coverage, 19425,
     /*  793380 */     GIR_EraseRootFromParent_Done,
     /*  793381 */   // Label 12316: @793381
     /*  793381 */   GIM_Try, /*On fail goto*//*Label 12317*/ GIMT_Encode4(793456), // Rule ID 19428 //
     /*  793386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  793397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  793400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  793403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  793406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793432 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  793435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793454 */     GIR_RootConstrainSelectedInstOperands,
     /*  793455 */     // GIR_Coverage, 19428,
     /*  793455 */     GIR_EraseRootFromParent_Done,
     /*  793456 */   // Label 12317: @793456
     /*  793456 */   GIM_Try, /*On fail goto*//*Label 12318*/ GIMT_Encode4(793531), // Rule ID 19429 //
     /*  793461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  793472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  793475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  793478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  793481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793507 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  793510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793529 */     GIR_RootConstrainSelectedInstOperands,
     /*  793530 */     // GIR_Coverage, 19429,
     /*  793530 */     GIR_EraseRootFromParent_Done,
     /*  793531 */   // Label 12318: @793531
     /*  793531 */   GIM_Try, /*On fail goto*//*Label 12319*/ GIMT_Encode4(793606), // Rule ID 19432 //
     /*  793536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  793547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  793550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  793553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  793556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793582 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  793585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793604 */     GIR_RootConstrainSelectedInstOperands,
     /*  793605 */     // GIR_Coverage, 19432,
     /*  793605 */     GIR_EraseRootFromParent_Done,
     /*  793606 */   // Label 12319: @793606
     /*  793606 */   GIM_Try, /*On fail goto*//*Label 12320*/ GIMT_Encode4(793681), // Rule ID 19433 //
     /*  793611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  793622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  793625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  793628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  793631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793657 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  793660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793679 */     GIR_RootConstrainSelectedInstOperands,
     /*  793680 */     // GIR_Coverage, 19433,
     /*  793680 */     GIR_EraseRootFromParent_Done,
     /*  793681 */   // Label 12320: @793681
     /*  793681 */   GIM_Try, /*On fail goto*//*Label 12321*/ GIMT_Encode4(793756), // Rule ID 19436 //
     /*  793686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  793697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  793700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  793703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  793706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793732 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  793735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793754 */     GIR_RootConstrainSelectedInstOperands,
     /*  793755 */     // GIR_Coverage, 19436,
     /*  793755 */     GIR_EraseRootFromParent_Done,
     /*  793756 */   // Label 12321: @793756
     /*  793756 */   GIM_Try, /*On fail goto*//*Label 12322*/ GIMT_Encode4(793831), // Rule ID 19437 //
     /*  793761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  793772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  793775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  793778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  793781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793807 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  793810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793829 */     GIR_RootConstrainSelectedInstOperands,
     /*  793830 */     // GIR_Coverage, 19437,
     /*  793830 */     GIR_EraseRootFromParent_Done,
     /*  793831 */   // Label 12322: @793831
     /*  793831 */   GIM_Try, /*On fail goto*//*Label 12323*/ GIMT_Encode4(793906), // Rule ID 19440 //
     /*  793836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  793847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  793850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  793853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  793856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793882 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  793885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793904 */     GIR_RootConstrainSelectedInstOperands,
     /*  793905 */     // GIR_Coverage, 19440,
     /*  793905 */     GIR_EraseRootFromParent_Done,
     /*  793906 */   // Label 12323: @793906
     /*  793906 */   GIM_Try, /*On fail goto*//*Label 12324*/ GIMT_Encode4(793981), // Rule ID 19441 //
     /*  793911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  793922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  793925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  793928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  793931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793957 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  793960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793979 */     GIR_RootConstrainSelectedInstOperands,
     /*  793980 */     // GIR_Coverage, 19441,
     /*  793980 */     GIR_EraseRootFromParent_Done,
     /*  793981 */   // Label 12324: @793981
     /*  793981 */   GIM_Try, /*On fail goto*//*Label 12325*/ GIMT_Encode4(794056), // Rule ID 19444 //
     /*  793986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  793989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  793997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  794000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  794003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  794006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794032 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  794035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794054 */     GIR_RootConstrainSelectedInstOperands,
     /*  794055 */     // GIR_Coverage, 19444,
     /*  794055 */     GIR_EraseRootFromParent_Done,
     /*  794056 */   // Label 12325: @794056
     /*  794056 */   GIM_Try, /*On fail goto*//*Label 12326*/ GIMT_Encode4(794131), // Rule ID 19445 //
     /*  794061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  794072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  794075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  794078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  794081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794107 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  794110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794129 */     GIR_RootConstrainSelectedInstOperands,
     /*  794130 */     // GIR_Coverage, 19445,
     /*  794130 */     GIR_EraseRootFromParent_Done,
     /*  794131 */   // Label 12326: @794131
     /*  794131 */   GIM_Try, /*On fail goto*//*Label 12327*/ GIMT_Encode4(794206), // Rule ID 19448 //
     /*  794136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  794147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  794150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  794153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  794156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794182 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  794185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794204 */     GIR_RootConstrainSelectedInstOperands,
     /*  794205 */     // GIR_Coverage, 19448,
     /*  794205 */     GIR_EraseRootFromParent_Done,
     /*  794206 */   // Label 12327: @794206
     /*  794206 */   GIM_Try, /*On fail goto*//*Label 12328*/ GIMT_Encode4(794281), // Rule ID 19449 //
     /*  794211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  794222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  794225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  794228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  794231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794257 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  794260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794279 */     GIR_RootConstrainSelectedInstOperands,
     /*  794280 */     // GIR_Coverage, 19449,
     /*  794280 */     GIR_EraseRootFromParent_Done,
     /*  794281 */   // Label 12328: @794281
     /*  794281 */   GIM_Try, /*On fail goto*//*Label 12329*/ GIMT_Encode4(794356), // Rule ID 19452 //
     /*  794286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  794297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  794300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  794303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  794306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794332 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  794335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794354 */     GIR_RootConstrainSelectedInstOperands,
     /*  794355 */     // GIR_Coverage, 19452,
     /*  794355 */     GIR_EraseRootFromParent_Done,
     /*  794356 */   // Label 12329: @794356
     /*  794356 */   GIM_Try, /*On fail goto*//*Label 12330*/ GIMT_Encode4(794431), // Rule ID 19453 //
     /*  794361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  794372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  794375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  794378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  794381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794407 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  794410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794429 */     GIR_RootConstrainSelectedInstOperands,
     /*  794430 */     // GIR_Coverage, 19453,
     /*  794430 */     GIR_EraseRootFromParent_Done,
     /*  794431 */   // Label 12330: @794431
     /*  794431 */   GIM_Try, /*On fail goto*//*Label 12331*/ GIMT_Encode4(794506), // Rule ID 19456 //
     /*  794436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  794447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  794450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  794453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  794456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794482 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  794485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794504 */     GIR_RootConstrainSelectedInstOperands,
     /*  794505 */     // GIR_Coverage, 19456,
     /*  794505 */     GIR_EraseRootFromParent_Done,
     /*  794506 */   // Label 12331: @794506
     /*  794506 */   GIM_Try, /*On fail goto*//*Label 12332*/ GIMT_Encode4(794581), // Rule ID 19457 //
     /*  794511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  794522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  794525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  794528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  794531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794557 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  794560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794579 */     GIR_RootConstrainSelectedInstOperands,
     /*  794580 */     // GIR_Coverage, 19457,
     /*  794580 */     GIR_EraseRootFromParent_Done,
     /*  794581 */   // Label 12332: @794581
     /*  794581 */   GIM_Try, /*On fail goto*//*Label 12333*/ GIMT_Encode4(794656), // Rule ID 19460 //
     /*  794586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  794597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  794600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  794603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  794606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794632 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  794635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794654 */     GIR_RootConstrainSelectedInstOperands,
     /*  794655 */     // GIR_Coverage, 19460,
     /*  794655 */     GIR_EraseRootFromParent_Done,
     /*  794656 */   // Label 12333: @794656
     /*  794656 */   GIM_Try, /*On fail goto*//*Label 12334*/ GIMT_Encode4(794731), // Rule ID 19461 //
     /*  794661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  794672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  794675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  794678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  794681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794707 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  794710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794729 */     GIR_RootConstrainSelectedInstOperands,
     /*  794730 */     // GIR_Coverage, 19461,
     /*  794730 */     GIR_EraseRootFromParent_Done,
     /*  794731 */   // Label 12334: @794731
     /*  794731 */   GIM_Try, /*On fail goto*//*Label 12335*/ GIMT_Encode4(794806), // Rule ID 19464 //
     /*  794736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  794747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  794750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  794753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  794756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794782 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  794785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794804 */     GIR_RootConstrainSelectedInstOperands,
     /*  794805 */     // GIR_Coverage, 19464,
     /*  794805 */     GIR_EraseRootFromParent_Done,
     /*  794806 */   // Label 12335: @794806
     /*  794806 */   GIM_Try, /*On fail goto*//*Label 12336*/ GIMT_Encode4(794881), // Rule ID 19465 //
     /*  794811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  794822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  794825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  794828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  794831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794857 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  794860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794879 */     GIR_RootConstrainSelectedInstOperands,
     /*  794880 */     // GIR_Coverage, 19465,
     /*  794880 */     GIR_EraseRootFromParent_Done,
     /*  794881 */   // Label 12336: @794881
     /*  794881 */   GIM_Try, /*On fail goto*//*Label 12337*/ GIMT_Encode4(794956), // Rule ID 19468 //
     /*  794886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  794897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  794900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  794903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  794906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794932 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  794935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794954 */     GIR_RootConstrainSelectedInstOperands,
     /*  794955 */     // GIR_Coverage, 19468,
     /*  794955 */     GIR_EraseRootFromParent_Done,
     /*  794956 */   // Label 12337: @794956
     /*  794956 */   GIM_Try, /*On fail goto*//*Label 12338*/ GIMT_Encode4(795031), // Rule ID 19469 //
     /*  794961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  794972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  794975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  794978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  794981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795007 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  795010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795029 */     GIR_RootConstrainSelectedInstOperands,
     /*  795030 */     // GIR_Coverage, 19469,
     /*  795030 */     GIR_EraseRootFromParent_Done,
     /*  795031 */   // Label 12338: @795031
     /*  795031 */   GIM_Try, /*On fail goto*//*Label 12339*/ GIMT_Encode4(795106), // Rule ID 19472 //
     /*  795036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  795039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  795047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  795050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  795053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  795056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795082 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  795082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  795085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795104 */     GIR_RootConstrainSelectedInstOperands,
     /*  795105 */     // GIR_Coverage, 19472,
     /*  795105 */     GIR_EraseRootFromParent_Done,
     /*  795106 */   // Label 12339: @795106
     /*  795106 */   GIM_Try, /*On fail goto*//*Label 12340*/ GIMT_Encode4(795181), // Rule ID 19473 //
     /*  795111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  795114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  795122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  795125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  795128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  795131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795157 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  795157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  795160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795179 */     GIR_RootConstrainSelectedInstOperands,
     /*  795180 */     // GIR_Coverage, 19473,
     /*  795180 */     GIR_EraseRootFromParent_Done,
     /*  795181 */   // Label 12340: @795181
     /*  795181 */   GIM_Try, /*On fail goto*//*Label 12341*/ GIMT_Encode4(795256), // Rule ID 19476 //
     /*  795186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  795189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  795197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  795200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  795203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  795206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795232 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  795232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  795235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795254 */     GIR_RootConstrainSelectedInstOperands,
     /*  795255 */     // GIR_Coverage, 19476,
     /*  795255 */     GIR_EraseRootFromParent_Done,
     /*  795256 */   // Label 12341: @795256
     /*  795256 */   GIM_Try, /*On fail goto*//*Label 12342*/ GIMT_Encode4(795331), // Rule ID 19477 //
     /*  795261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  795264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  795272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  795275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  795278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  795281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795307 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  795307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  795310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795329 */     GIR_RootConstrainSelectedInstOperands,
     /*  795330 */     // GIR_Coverage, 19477,
     /*  795330 */     GIR_EraseRootFromParent_Done,
     /*  795331 */   // Label 12342: @795331
     /*  795331 */   GIM_Try, /*On fail goto*//*Label 12343*/ GIMT_Encode4(795406), // Rule ID 19480 //
     /*  795336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  795339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  795347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  795350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  795353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  795356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795382 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  795382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  795385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795404 */     GIR_RootConstrainSelectedInstOperands,
     /*  795405 */     // GIR_Coverage, 19480,
     /*  795405 */     GIR_EraseRootFromParent_Done,
     /*  795406 */   // Label 12343: @795406
     /*  795406 */   GIM_Try, /*On fail goto*//*Label 12344*/ GIMT_Encode4(795481), // Rule ID 19481 //
     /*  795411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  795414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  795422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  795425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  795428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  795431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795457 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  795457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  795460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795479 */     GIR_RootConstrainSelectedInstOperands,
     /*  795480 */     // GIR_Coverage, 19481,
     /*  795480 */     GIR_EraseRootFromParent_Done,
     /*  795481 */   // Label 12344: @795481
     /*  795481 */   GIM_Try, /*On fail goto*//*Label 12345*/ GIMT_Encode4(795556), // Rule ID 19484 //
     /*  795486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  795497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  795500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  795503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795532 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  795535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795554 */     GIR_RootConstrainSelectedInstOperands,
     /*  795555 */     // GIR_Coverage, 19484,
     /*  795555 */     GIR_EraseRootFromParent_Done,
     /*  795556 */   // Label 12345: @795556
     /*  795556 */   GIM_Try, /*On fail goto*//*Label 12346*/ GIMT_Encode4(795631), // Rule ID 19485 //
     /*  795561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  795572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  795575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  795578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795607 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  795610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795629 */     GIR_RootConstrainSelectedInstOperands,
     /*  795630 */     // GIR_Coverage, 19485,
     /*  795630 */     GIR_EraseRootFromParent_Done,
     /*  795631 */   // Label 12346: @795631
     /*  795631 */   GIM_Try, /*On fail goto*//*Label 12347*/ GIMT_Encode4(795706), // Rule ID 19488 //
     /*  795636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  795647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  795650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  795653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795682 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  795685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795704 */     GIR_RootConstrainSelectedInstOperands,
     /*  795705 */     // GIR_Coverage, 19488,
     /*  795705 */     GIR_EraseRootFromParent_Done,
     /*  795706 */   // Label 12347: @795706
     /*  795706 */   GIM_Try, /*On fail goto*//*Label 12348*/ GIMT_Encode4(795781), // Rule ID 19489 //
     /*  795711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  795722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  795725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  795728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795757 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  795760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795779 */     GIR_RootConstrainSelectedInstOperands,
     /*  795780 */     // GIR_Coverage, 19489,
     /*  795780 */     GIR_EraseRootFromParent_Done,
     /*  795781 */   // Label 12348: @795781
     /*  795781 */   GIM_Try, /*On fail goto*//*Label 12349*/ GIMT_Encode4(795856), // Rule ID 19492 //
     /*  795786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  795789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  795797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  795800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  795803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795832 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  795835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795854 */     GIR_RootConstrainSelectedInstOperands,
     /*  795855 */     // GIR_Coverage, 19492,
     /*  795855 */     GIR_EraseRootFromParent_Done,
     /*  795856 */   // Label 12349: @795856
     /*  795856 */   GIM_Try, /*On fail goto*//*Label 12350*/ GIMT_Encode4(795931), // Rule ID 19493 //
     /*  795861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  795872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  795875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  795878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795907 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  795910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795929 */     GIR_RootConstrainSelectedInstOperands,
     /*  795930 */     // GIR_Coverage, 19493,
     /*  795930 */     GIR_EraseRootFromParent_Done,
     /*  795931 */   // Label 12350: @795931
     /*  795931 */   GIM_Try, /*On fail goto*//*Label 12351*/ GIMT_Encode4(796006), // Rule ID 19496 //
     /*  795936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  795947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  795950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  795953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795982 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  795985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796004 */     GIR_RootConstrainSelectedInstOperands,
     /*  796005 */     // GIR_Coverage, 19496,
     /*  796005 */     GIR_EraseRootFromParent_Done,
     /*  796006 */   // Label 12351: @796006
     /*  796006 */   GIM_Try, /*On fail goto*//*Label 12352*/ GIMT_Encode4(796081), // Rule ID 19497 //
     /*  796011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  796022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  796025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  796028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796057 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  796060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796079 */     GIR_RootConstrainSelectedInstOperands,
     /*  796080 */     // GIR_Coverage, 19497,
     /*  796080 */     GIR_EraseRootFromParent_Done,
     /*  796081 */   // Label 12352: @796081
     /*  796081 */   GIM_Try, /*On fail goto*//*Label 12353*/ GIMT_Encode4(796156), // Rule ID 19500 //
     /*  796086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  796097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  796100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  796103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796132 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  796135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796154 */     GIR_RootConstrainSelectedInstOperands,
     /*  796155 */     // GIR_Coverage, 19500,
     /*  796155 */     GIR_EraseRootFromParent_Done,
     /*  796156 */   // Label 12353: @796156
     /*  796156 */   GIM_Try, /*On fail goto*//*Label 12354*/ GIMT_Encode4(796231), // Rule ID 19501 //
     /*  796161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  796172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  796175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  796178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796207 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  796210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796229 */     GIR_RootConstrainSelectedInstOperands,
     /*  796230 */     // GIR_Coverage, 19501,
     /*  796230 */     GIR_EraseRootFromParent_Done,
     /*  796231 */   // Label 12354: @796231
     /*  796231 */   GIM_Try, /*On fail goto*//*Label 12355*/ GIMT_Encode4(796306), // Rule ID 19504 //
     /*  796236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  796247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  796250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  796253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796282 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  796285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796304 */     GIR_RootConstrainSelectedInstOperands,
     /*  796305 */     // GIR_Coverage, 19504,
     /*  796305 */     GIR_EraseRootFromParent_Done,
     /*  796306 */   // Label 12355: @796306
     /*  796306 */   GIM_Try, /*On fail goto*//*Label 12356*/ GIMT_Encode4(796381), // Rule ID 19505 //
     /*  796311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  796322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  796325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  796328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796357 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  796360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796379 */     GIR_RootConstrainSelectedInstOperands,
     /*  796380 */     // GIR_Coverage, 19505,
     /*  796380 */     GIR_EraseRootFromParent_Done,
     /*  796381 */   // Label 12356: @796381
     /*  796381 */   GIM_Try, /*On fail goto*//*Label 12357*/ GIMT_Encode4(796456), // Rule ID 19508 //
     /*  796386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  796397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  796400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  796403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796432 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  796435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796454 */     GIR_RootConstrainSelectedInstOperands,
     /*  796455 */     // GIR_Coverage, 19508,
     /*  796455 */     GIR_EraseRootFromParent_Done,
     /*  796456 */   // Label 12357: @796456
     /*  796456 */   GIM_Try, /*On fail goto*//*Label 12358*/ GIMT_Encode4(796531), // Rule ID 19509 //
     /*  796461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  796472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  796475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  796478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796507 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  796510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796529 */     GIR_RootConstrainSelectedInstOperands,
     /*  796530 */     // GIR_Coverage, 19509,
     /*  796530 */     GIR_EraseRootFromParent_Done,
     /*  796531 */   // Label 12358: @796531
     /*  796531 */   GIM_Try, /*On fail goto*//*Label 12359*/ GIMT_Encode4(796606), // Rule ID 19512 //
     /*  796536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  796547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  796550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  796553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796582 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  796585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796604 */     GIR_RootConstrainSelectedInstOperands,
     /*  796605 */     // GIR_Coverage, 19512,
     /*  796605 */     GIR_EraseRootFromParent_Done,
     /*  796606 */   // Label 12359: @796606
     /*  796606 */   GIM_Try, /*On fail goto*//*Label 12360*/ GIMT_Encode4(796681), // Rule ID 19513 //
     /*  796611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  796622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  796625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  796628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796657 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  796660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796679 */     GIR_RootConstrainSelectedInstOperands,
     /*  796680 */     // GIR_Coverage, 19513,
     /*  796680 */     GIR_EraseRootFromParent_Done,
     /*  796681 */   // Label 12360: @796681
     /*  796681 */   GIM_Try, /*On fail goto*//*Label 12361*/ GIMT_Encode4(796756), // Rule ID 19516 //
     /*  796686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  796697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  796700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  796703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796732 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  796735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796754 */     GIR_RootConstrainSelectedInstOperands,
     /*  796755 */     // GIR_Coverage, 19516,
     /*  796755 */     GIR_EraseRootFromParent_Done,
     /*  796756 */   // Label 12361: @796756
     /*  796756 */   GIM_Try, /*On fail goto*//*Label 12362*/ GIMT_Encode4(796831), // Rule ID 19517 //
     /*  796761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  796772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  796775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  796778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796807 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  796810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796829 */     GIR_RootConstrainSelectedInstOperands,
     /*  796830 */     // GIR_Coverage, 19517,
     /*  796830 */     GIR_EraseRootFromParent_Done,
     /*  796831 */   // Label 12362: @796831
     /*  796831 */   GIM_Try, /*On fail goto*//*Label 12363*/ GIMT_Encode4(796906), // Rule ID 19520 //
     /*  796836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  796847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  796850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  796853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796882 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  796885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796904 */     GIR_RootConstrainSelectedInstOperands,
     /*  796905 */     // GIR_Coverage, 19520,
     /*  796905 */     GIR_EraseRootFromParent_Done,
     /*  796906 */   // Label 12363: @796906
     /*  796906 */   GIM_Try, /*On fail goto*//*Label 12364*/ GIMT_Encode4(796981), // Rule ID 19521 //
     /*  796911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  796922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  796925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  796928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796957 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  796960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796979 */     GIR_RootConstrainSelectedInstOperands,
     /*  796980 */     // GIR_Coverage, 19521,
     /*  796980 */     GIR_EraseRootFromParent_Done,
     /*  796981 */   // Label 12364: @796981
     /*  796981 */   GIM_Try, /*On fail goto*//*Label 12365*/ GIMT_Encode4(797056), // Rule ID 19524 //
     /*  796986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  796997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  797000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  797003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  797006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  797025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797032 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  797032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  797035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797054 */     GIR_RootConstrainSelectedInstOperands,
     /*  797055 */     // GIR_Coverage, 19524,
     /*  797055 */     GIR_EraseRootFromParent_Done,
     /*  797056 */   // Label 12365: @797056
     /*  797056 */   GIM_Try, /*On fail goto*//*Label 12366*/ GIMT_Encode4(797131), // Rule ID 19525 //
     /*  797061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  797064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  797072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  797075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  797078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  797081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  797100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797107 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  797110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797129 */     GIR_RootConstrainSelectedInstOperands,
     /*  797130 */     // GIR_Coverage, 19525,
     /*  797130 */     GIR_EraseRootFromParent_Done,
     /*  797131 */   // Label 12366: @797131
     /*  797131 */   GIM_Try, /*On fail goto*//*Label 12367*/ GIMT_Encode4(797206), // Rule ID 19528 //
     /*  797136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  797139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  797147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  797150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  797153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  797156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  797175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797182 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  797182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  797185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797204 */     GIR_RootConstrainSelectedInstOperands,
     /*  797205 */     // GIR_Coverage, 19528,
     /*  797205 */     GIR_EraseRootFromParent_Done,
     /*  797206 */   // Label 12367: @797206
     /*  797206 */   GIM_Try, /*On fail goto*//*Label 12368*/ GIMT_Encode4(797281), // Rule ID 19529 //
     /*  797211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  797214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  797222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  797225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  797228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  797231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  797250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797257 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  797260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797279 */     GIR_RootConstrainSelectedInstOperands,
     /*  797280 */     // GIR_Coverage, 19529,
     /*  797280 */     GIR_EraseRootFromParent_Done,
     /*  797281 */   // Label 12368: @797281
     /*  797281 */   GIM_Try, /*On fail goto*//*Label 12369*/ GIMT_Encode4(797356), // Rule ID 19532 //
     /*  797286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  797289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  797297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  797300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  797303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797332 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  797335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797354 */     GIR_RootConstrainSelectedInstOperands,
     /*  797355 */     // GIR_Coverage, 19532,
     /*  797355 */     GIR_EraseRootFromParent_Done,
     /*  797356 */   // Label 12369: @797356
     /*  797356 */   GIM_Try, /*On fail goto*//*Label 12370*/ GIMT_Encode4(797431), // Rule ID 19533 //
     /*  797361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  797372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  797375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  797378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797407 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  797410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797429 */     GIR_RootConstrainSelectedInstOperands,
     /*  797430 */     // GIR_Coverage, 19533,
     /*  797430 */     GIR_EraseRootFromParent_Done,
     /*  797431 */   // Label 12370: @797431
     /*  797431 */   GIM_Try, /*On fail goto*//*Label 12371*/ GIMT_Encode4(797506), // Rule ID 19536 //
     /*  797436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  797439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  797447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  797450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  797453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797482 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  797485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797504 */     GIR_RootConstrainSelectedInstOperands,
     /*  797505 */     // GIR_Coverage, 19536,
     /*  797505 */     GIR_EraseRootFromParent_Done,
     /*  797506 */   // Label 12371: @797506
     /*  797506 */   GIM_Try, /*On fail goto*//*Label 12372*/ GIMT_Encode4(797581), // Rule ID 19537 //
     /*  797511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  797522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  797525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  797528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797557 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  797560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797579 */     GIR_RootConstrainSelectedInstOperands,
     /*  797580 */     // GIR_Coverage, 19537,
     /*  797580 */     GIR_EraseRootFromParent_Done,
     /*  797581 */   // Label 12372: @797581
     /*  797581 */   GIM_Try, /*On fail goto*//*Label 12373*/ GIMT_Encode4(797656), // Rule ID 19540 //
     /*  797586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  797589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  797597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  797600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  797603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797632 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  797635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797654 */     GIR_RootConstrainSelectedInstOperands,
     /*  797655 */     // GIR_Coverage, 19540,
     /*  797655 */     GIR_EraseRootFromParent_Done,
     /*  797656 */   // Label 12373: @797656
     /*  797656 */   GIM_Try, /*On fail goto*//*Label 12374*/ GIMT_Encode4(797731), // Rule ID 19541 //
     /*  797661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  797672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  797675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  797678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797707 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  797710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797729 */     GIR_RootConstrainSelectedInstOperands,
     /*  797730 */     // GIR_Coverage, 19541,
     /*  797730 */     GIR_EraseRootFromParent_Done,
     /*  797731 */   // Label 12374: @797731
     /*  797731 */   GIM_Try, /*On fail goto*//*Label 12375*/ GIMT_Encode4(797806), // Rule ID 19544 //
     /*  797736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  797747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  797750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  797753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  797756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797782 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  797785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797804 */     GIR_RootConstrainSelectedInstOperands,
     /*  797805 */     // GIR_Coverage, 19544,
     /*  797805 */     GIR_EraseRootFromParent_Done,
     /*  797806 */   // Label 12375: @797806
     /*  797806 */   GIM_Try, /*On fail goto*//*Label 12376*/ GIMT_Encode4(797881), // Rule ID 19545 //
     /*  797811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  797822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  797825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  797828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  797831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797857 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  797860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797879 */     GIR_RootConstrainSelectedInstOperands,
     /*  797880 */     // GIR_Coverage, 19545,
     /*  797880 */     GIR_EraseRootFromParent_Done,
     /*  797881 */   // Label 12376: @797881
     /*  797881 */   GIM_Try, /*On fail goto*//*Label 12377*/ GIMT_Encode4(797956), // Rule ID 19548 //
     /*  797886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  797897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  797900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  797903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  797906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797932 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  797935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797954 */     GIR_RootConstrainSelectedInstOperands,
     /*  797955 */     // GIR_Coverage, 19548,
     /*  797955 */     GIR_EraseRootFromParent_Done,
     /*  797956 */   // Label 12377: @797956
     /*  797956 */   GIM_Try, /*On fail goto*//*Label 12378*/ GIMT_Encode4(798031), // Rule ID 19549 //
     /*  797961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  797972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  797975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  797978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  797981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798007 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  798010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798029 */     GIR_RootConstrainSelectedInstOperands,
     /*  798030 */     // GIR_Coverage, 19549,
     /*  798030 */     GIR_EraseRootFromParent_Done,
     /*  798031 */   // Label 12378: @798031
     /*  798031 */   GIM_Try, /*On fail goto*//*Label 12379*/ GIMT_Encode4(798106), // Rule ID 19552 //
     /*  798036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  798047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  798050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  798053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  798056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798082 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  798085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798104 */     GIR_RootConstrainSelectedInstOperands,
     /*  798105 */     // GIR_Coverage, 19552,
     /*  798105 */     GIR_EraseRootFromParent_Done,
     /*  798106 */   // Label 12379: @798106
     /*  798106 */   GIM_Try, /*On fail goto*//*Label 12380*/ GIMT_Encode4(798181), // Rule ID 19553 //
     /*  798111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  798122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  798125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  798128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  798131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798157 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  798160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798179 */     GIR_RootConstrainSelectedInstOperands,
     /*  798180 */     // GIR_Coverage, 19553,
     /*  798180 */     GIR_EraseRootFromParent_Done,
     /*  798181 */   // Label 12380: @798181
     /*  798181 */   GIM_Try, /*On fail goto*//*Label 12381*/ GIMT_Encode4(798256), // Rule ID 19556 //
     /*  798186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  798197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  798200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  798203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  798206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798232 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  798235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798254 */     GIR_RootConstrainSelectedInstOperands,
     /*  798255 */     // GIR_Coverage, 19556,
     /*  798255 */     GIR_EraseRootFromParent_Done,
     /*  798256 */   // Label 12381: @798256
     /*  798256 */   GIM_Try, /*On fail goto*//*Label 12382*/ GIMT_Encode4(798331), // Rule ID 19557 //
     /*  798261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  798272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  798275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  798278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  798281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798307 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  798310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798329 */     GIR_RootConstrainSelectedInstOperands,
     /*  798330 */     // GIR_Coverage, 19557,
     /*  798330 */     GIR_EraseRootFromParent_Done,
     /*  798331 */   // Label 12382: @798331
     /*  798331 */   GIM_Try, /*On fail goto*//*Label 12383*/ GIMT_Encode4(798406), // Rule ID 19560 //
     /*  798336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  798347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  798350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  798353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  798356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798382 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  798385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798404 */     GIR_RootConstrainSelectedInstOperands,
     /*  798405 */     // GIR_Coverage, 19560,
     /*  798405 */     GIR_EraseRootFromParent_Done,
     /*  798406 */   // Label 12383: @798406
     /*  798406 */   GIM_Try, /*On fail goto*//*Label 12384*/ GIMT_Encode4(798481), // Rule ID 19561 //
     /*  798411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  798422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  798425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  798428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  798431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798457 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  798460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798479 */     GIR_RootConstrainSelectedInstOperands,
     /*  798480 */     // GIR_Coverage, 19561,
     /*  798480 */     GIR_EraseRootFromParent_Done,
     /*  798481 */   // Label 12384: @798481
     /*  798481 */   GIM_Try, /*On fail goto*//*Label 12385*/ GIMT_Encode4(798556), // Rule ID 19564 //
     /*  798486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  798497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  798500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  798503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  798506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798532 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  798535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798554 */     GIR_RootConstrainSelectedInstOperands,
     /*  798555 */     // GIR_Coverage, 19564,
     /*  798555 */     GIR_EraseRootFromParent_Done,
     /*  798556 */   // Label 12385: @798556
     /*  798556 */   GIM_Try, /*On fail goto*//*Label 12386*/ GIMT_Encode4(798631), // Rule ID 19565 //
     /*  798561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  798572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  798575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  798578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  798581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798607 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  798610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798629 */     GIR_RootConstrainSelectedInstOperands,
     /*  798630 */     // GIR_Coverage, 19565,
     /*  798630 */     GIR_EraseRootFromParent_Done,
     /*  798631 */   // Label 12386: @798631
     /*  798631 */   GIM_Try, /*On fail goto*//*Label 12387*/ GIMT_Encode4(798706), // Rule ID 19568 //
     /*  798636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  798647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  798650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  798653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  798656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798682 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  798685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798704 */     GIR_RootConstrainSelectedInstOperands,
     /*  798705 */     // GIR_Coverage, 19568,
     /*  798705 */     GIR_EraseRootFromParent_Done,
     /*  798706 */   // Label 12387: @798706
     /*  798706 */   GIM_Try, /*On fail goto*//*Label 12388*/ GIMT_Encode4(798781), // Rule ID 19569 //
     /*  798711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  798722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  798725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  798728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  798731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798757 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  798760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798779 */     GIR_RootConstrainSelectedInstOperands,
     /*  798780 */     // GIR_Coverage, 19569,
     /*  798780 */     GIR_EraseRootFromParent_Done,
     /*  798781 */   // Label 12388: @798781
     /*  798781 */   GIM_Try, /*On fail goto*//*Label 12389*/ GIMT_Encode4(798856), // Rule ID 19572 //
     /*  798786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  798797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  798800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  798803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  798806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798832 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  798835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798854 */     GIR_RootConstrainSelectedInstOperands,
     /*  798855 */     // GIR_Coverage, 19572,
     /*  798855 */     GIR_EraseRootFromParent_Done,
     /*  798856 */   // Label 12389: @798856
     /*  798856 */   GIM_Try, /*On fail goto*//*Label 12390*/ GIMT_Encode4(798931), // Rule ID 19573 //
     /*  798861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  798872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  798875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  798878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  798881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798907 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  798910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798929 */     GIR_RootConstrainSelectedInstOperands,
     /*  798930 */     // GIR_Coverage, 19573,
     /*  798930 */     GIR_EraseRootFromParent_Done,
     /*  798931 */   // Label 12390: @798931
     /*  798931 */   GIM_Try, /*On fail goto*//*Label 12391*/ GIMT_Encode4(799006), // Rule ID 19576 //
     /*  798936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  798947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  798950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  798953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  798956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798982 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  798985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799004 */     GIR_RootConstrainSelectedInstOperands,
     /*  799005 */     // GIR_Coverage, 19576,
     /*  799005 */     GIR_EraseRootFromParent_Done,
     /*  799006 */   // Label 12391: @799006
     /*  799006 */   GIM_Try, /*On fail goto*//*Label 12392*/ GIMT_Encode4(799081), // Rule ID 19577 //
     /*  799011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  799022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  799025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  799028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  799031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799057 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  799060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799079 */     GIR_RootConstrainSelectedInstOperands,
     /*  799080 */     // GIR_Coverage, 19577,
     /*  799080 */     GIR_EraseRootFromParent_Done,
     /*  799081 */   // Label 12392: @799081
     /*  799081 */   GIM_Try, /*On fail goto*//*Label 12393*/ GIMT_Encode4(799156), // Rule ID 19580 //
     /*  799086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  799097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  799100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  799103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  799106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799132 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  799135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799154 */     GIR_RootConstrainSelectedInstOperands,
     /*  799155 */     // GIR_Coverage, 19580,
     /*  799155 */     GIR_EraseRootFromParent_Done,
     /*  799156 */   // Label 12393: @799156
     /*  799156 */   GIM_Try, /*On fail goto*//*Label 12394*/ GIMT_Encode4(799231), // Rule ID 19581 //
     /*  799161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  799172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  799175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  799178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  799181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799207 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  799210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799229 */     GIR_RootConstrainSelectedInstOperands,
     /*  799230 */     // GIR_Coverage, 19581,
     /*  799230 */     GIR_EraseRootFromParent_Done,
     /*  799231 */   // Label 12394: @799231
     /*  799231 */   GIM_Try, /*On fail goto*//*Label 12395*/ GIMT_Encode4(799306), // Rule ID 19584 //
     /*  799236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  799247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  799250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  799253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  799256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799282 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  799285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799304 */     GIR_RootConstrainSelectedInstOperands,
     /*  799305 */     // GIR_Coverage, 19584,
     /*  799305 */     GIR_EraseRootFromParent_Done,
     /*  799306 */   // Label 12395: @799306
     /*  799306 */   GIM_Try, /*On fail goto*//*Label 12396*/ GIMT_Encode4(799381), // Rule ID 19585 //
     /*  799311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  799322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  799325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  799328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  799331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799357 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  799360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799379 */     GIR_RootConstrainSelectedInstOperands,
     /*  799380 */     // GIR_Coverage, 19585,
     /*  799380 */     GIR_EraseRootFromParent_Done,
     /*  799381 */   // Label 12396: @799381
     /*  799381 */   GIM_Try, /*On fail goto*//*Label 12397*/ GIMT_Encode4(799456), // Rule ID 19588 //
     /*  799386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  799397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  799400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  799403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  799406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799432 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  799435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799454 */     GIR_RootConstrainSelectedInstOperands,
     /*  799455 */     // GIR_Coverage, 19588,
     /*  799455 */     GIR_EraseRootFromParent_Done,
     /*  799456 */   // Label 12397: @799456
     /*  799456 */   GIM_Try, /*On fail goto*//*Label 12398*/ GIMT_Encode4(799531), // Rule ID 19589 //
     /*  799461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  799472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  799475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  799478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  799481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799507 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  799510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799529 */     GIR_RootConstrainSelectedInstOperands,
     /*  799530 */     // GIR_Coverage, 19589,
     /*  799530 */     GIR_EraseRootFromParent_Done,
     /*  799531 */   // Label 12398: @799531
     /*  799531 */   GIM_Try, /*On fail goto*//*Label 12399*/ GIMT_Encode4(799606), // Rule ID 19592 //
     /*  799536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  799547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  799550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  799553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  799556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799582 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  799585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799604 */     GIR_RootConstrainSelectedInstOperands,
     /*  799605 */     // GIR_Coverage, 19592,
     /*  799605 */     GIR_EraseRootFromParent_Done,
     /*  799606 */   // Label 12399: @799606
     /*  799606 */   GIM_Try, /*On fail goto*//*Label 12400*/ GIMT_Encode4(799681), // Rule ID 19593 //
     /*  799611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  799622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  799625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  799628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  799631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799657 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  799660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799679 */     GIR_RootConstrainSelectedInstOperands,
     /*  799680 */     // GIR_Coverage, 19593,
     /*  799680 */     GIR_EraseRootFromParent_Done,
     /*  799681 */   // Label 12400: @799681
     /*  799681 */   GIM_Try, /*On fail goto*//*Label 12401*/ GIMT_Encode4(799756), // Rule ID 19596 //
     /*  799686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  799697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  799700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  799703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  799706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799732 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  799735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799754 */     GIR_RootConstrainSelectedInstOperands,
     /*  799755 */     // GIR_Coverage, 19596,
     /*  799755 */     GIR_EraseRootFromParent_Done,
     /*  799756 */   // Label 12401: @799756
     /*  799756 */   GIM_Try, /*On fail goto*//*Label 12402*/ GIMT_Encode4(799831), // Rule ID 19597 //
     /*  799761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  799772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  799775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  799778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  799781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799807 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  799810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799829 */     GIR_RootConstrainSelectedInstOperands,
     /*  799830 */     // GIR_Coverage, 19597,
     /*  799830 */     GIR_EraseRootFromParent_Done,
     /*  799831 */   // Label 12402: @799831
     /*  799831 */   GIM_Try, /*On fail goto*//*Label 12403*/ GIMT_Encode4(799906), // Rule ID 19600 //
     /*  799836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  799847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  799850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  799853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  799856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799882 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  799885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799904 */     GIR_RootConstrainSelectedInstOperands,
     /*  799905 */     // GIR_Coverage, 19600,
     /*  799905 */     GIR_EraseRootFromParent_Done,
     /*  799906 */   // Label 12403: @799906
     /*  799906 */   GIM_Try, /*On fail goto*//*Label 12404*/ GIMT_Encode4(799981), // Rule ID 19601 //
     /*  799911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  799922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  799925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  799928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  799931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799957 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  799960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799979 */     GIR_RootConstrainSelectedInstOperands,
     /*  799980 */     // GIR_Coverage, 19601,
     /*  799980 */     GIR_EraseRootFromParent_Done,
     /*  799981 */   // Label 12404: @799981
     /*  799981 */   GIM_Try, /*On fail goto*//*Label 12405*/ GIMT_Encode4(800056), // Rule ID 19604 //
     /*  799986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  799997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  800000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  800003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800032 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  800035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800054 */     GIR_RootConstrainSelectedInstOperands,
     /*  800055 */     // GIR_Coverage, 19604,
     /*  800055 */     GIR_EraseRootFromParent_Done,
     /*  800056 */   // Label 12405: @800056
     /*  800056 */   GIM_Try, /*On fail goto*//*Label 12406*/ GIMT_Encode4(800131), // Rule ID 19605 //
     /*  800061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  800072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  800075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  800078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800107 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  800110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800129 */     GIR_RootConstrainSelectedInstOperands,
     /*  800130 */     // GIR_Coverage, 19605,
     /*  800130 */     GIR_EraseRootFromParent_Done,
     /*  800131 */   // Label 12406: @800131
     /*  800131 */   GIM_Try, /*On fail goto*//*Label 12407*/ GIMT_Encode4(800206), // Rule ID 19608 //
     /*  800136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  800147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  800150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  800153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800182 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  800185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800204 */     GIR_RootConstrainSelectedInstOperands,
     /*  800205 */     // GIR_Coverage, 19608,
     /*  800205 */     GIR_EraseRootFromParent_Done,
     /*  800206 */   // Label 12407: @800206
     /*  800206 */   GIM_Try, /*On fail goto*//*Label 12408*/ GIMT_Encode4(800281), // Rule ID 19609 //
     /*  800211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  800222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  800225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  800228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800257 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  800260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800279 */     GIR_RootConstrainSelectedInstOperands,
     /*  800280 */     // GIR_Coverage, 19609,
     /*  800280 */     GIR_EraseRootFromParent_Done,
     /*  800281 */   // Label 12408: @800281
     /*  800281 */   GIM_Try, /*On fail goto*//*Label 12409*/ GIMT_Encode4(800356), // Rule ID 19612 //
     /*  800286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  800297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  800300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  800303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800332 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  800335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800354 */     GIR_RootConstrainSelectedInstOperands,
     /*  800355 */     // GIR_Coverage, 19612,
     /*  800355 */     GIR_EraseRootFromParent_Done,
     /*  800356 */   // Label 12409: @800356
     /*  800356 */   GIM_Try, /*On fail goto*//*Label 12410*/ GIMT_Encode4(800431), // Rule ID 19613 //
     /*  800361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  800372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  800375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  800378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800407 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  800410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800429 */     GIR_RootConstrainSelectedInstOperands,
     /*  800430 */     // GIR_Coverage, 19613,
     /*  800430 */     GIR_EraseRootFromParent_Done,
     /*  800431 */   // Label 12410: @800431
     /*  800431 */   GIM_Try, /*On fail goto*//*Label 12411*/ GIMT_Encode4(800506), // Rule ID 19616 //
     /*  800436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  800447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  800450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  800453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800482 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  800485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800504 */     GIR_RootConstrainSelectedInstOperands,
     /*  800505 */     // GIR_Coverage, 19616,
     /*  800505 */     GIR_EraseRootFromParent_Done,
     /*  800506 */   // Label 12411: @800506
     /*  800506 */   GIM_Try, /*On fail goto*//*Label 12412*/ GIMT_Encode4(800581), // Rule ID 19617 //
     /*  800511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  800522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  800525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  800528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800557 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  800560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800579 */     GIR_RootConstrainSelectedInstOperands,
     /*  800580 */     // GIR_Coverage, 19617,
     /*  800580 */     GIR_EraseRootFromParent_Done,
     /*  800581 */   // Label 12412: @800581
     /*  800581 */   GIM_Try, /*On fail goto*//*Label 12413*/ GIMT_Encode4(800656), // Rule ID 19620 //
     /*  800586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  800597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  800600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  800603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800632 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  800635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800654 */     GIR_RootConstrainSelectedInstOperands,
     /*  800655 */     // GIR_Coverage, 19620,
     /*  800655 */     GIR_EraseRootFromParent_Done,
     /*  800656 */   // Label 12413: @800656
     /*  800656 */   GIM_Try, /*On fail goto*//*Label 12414*/ GIMT_Encode4(800731), // Rule ID 19621 //
     /*  800661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  800672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  800675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  800678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800707 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  800710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800729 */     GIR_RootConstrainSelectedInstOperands,
     /*  800730 */     // GIR_Coverage, 19621,
     /*  800730 */     GIR_EraseRootFromParent_Done,
     /*  800731 */   // Label 12414: @800731
     /*  800731 */   GIM_Try, /*On fail goto*//*Label 12415*/ GIMT_Encode4(800806), // Rule ID 19624 //
     /*  800736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  800739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  800747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  800750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  800753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800782 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  800782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  800785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800804 */     GIR_RootConstrainSelectedInstOperands,
     /*  800805 */     // GIR_Coverage, 19624,
     /*  800805 */     GIR_EraseRootFromParent_Done,
     /*  800806 */   // Label 12415: @800806
     /*  800806 */   GIM_Try, /*On fail goto*//*Label 12416*/ GIMT_Encode4(800881), // Rule ID 19625 //
     /*  800811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  800814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  800822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  800825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  800828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800857 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  800857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  800860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800879 */     GIR_RootConstrainSelectedInstOperands,
     /*  800880 */     // GIR_Coverage, 19625,
     /*  800880 */     GIR_EraseRootFromParent_Done,
     /*  800881 */   // Label 12416: @800881
     /*  800881 */   GIM_Try, /*On fail goto*//*Label 12417*/ GIMT_Encode4(800956), // Rule ID 19628 //
     /*  800886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  800897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  800900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  800903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800932 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  800935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800954 */     GIR_RootConstrainSelectedInstOperands,
     /*  800955 */     // GIR_Coverage, 19628,
     /*  800955 */     GIR_EraseRootFromParent_Done,
     /*  800956 */   // Label 12417: @800956
     /*  800956 */   GIM_Try, /*On fail goto*//*Label 12418*/ GIMT_Encode4(801031), // Rule ID 19629 //
     /*  800961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  800972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  800975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  800978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  801000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801007 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  801010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801029 */     GIR_RootConstrainSelectedInstOperands,
     /*  801030 */     // GIR_Coverage, 19629,
     /*  801030 */     GIR_EraseRootFromParent_Done,
     /*  801031 */   // Label 12418: @801031
     /*  801031 */   GIM_Try, /*On fail goto*//*Label 12419*/ GIMT_Encode4(801106), // Rule ID 19632 //
     /*  801036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  801047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  801050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  801053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  801056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  801075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801082 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  801085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801104 */     GIR_RootConstrainSelectedInstOperands,
     /*  801105 */     // GIR_Coverage, 19632,
     /*  801105 */     GIR_EraseRootFromParent_Done,
     /*  801106 */   // Label 12419: @801106
     /*  801106 */   GIM_Try, /*On fail goto*//*Label 12420*/ GIMT_Encode4(801181), // Rule ID 19633 //
     /*  801111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  801122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  801125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  801128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  801131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  801150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801157 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  801160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801179 */     GIR_RootConstrainSelectedInstOperands,
     /*  801180 */     // GIR_Coverage, 19633,
     /*  801180 */     GIR_EraseRootFromParent_Done,
     /*  801181 */   // Label 12420: @801181
     /*  801181 */   GIM_Try, /*On fail goto*//*Label 12421*/ GIMT_Encode4(801256), // Rule ID 19636 //
     /*  801186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  801197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  801200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  801203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  801206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  801225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801232 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  801235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801254 */     GIR_RootConstrainSelectedInstOperands,
     /*  801255 */     // GIR_Coverage, 19636,
     /*  801255 */     GIR_EraseRootFromParent_Done,
     /*  801256 */   // Label 12421: @801256
     /*  801256 */   GIM_Try, /*On fail goto*//*Label 12422*/ GIMT_Encode4(801331), // Rule ID 19637 //
     /*  801261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  801272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  801275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  801278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  801281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  801300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801307 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  801310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801329 */     GIR_RootConstrainSelectedInstOperands,
     /*  801330 */     // GIR_Coverage, 19637,
     /*  801330 */     GIR_EraseRootFromParent_Done,
     /*  801331 */   // Label 12422: @801331
     /*  801331 */   GIM_Try, /*On fail goto*//*Label 12423*/ GIMT_Encode4(801406), // Rule ID 19640 //
     /*  801336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  801347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  801350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  801353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801382 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  801385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801404 */     GIR_RootConstrainSelectedInstOperands,
     /*  801405 */     // GIR_Coverage, 19640,
     /*  801405 */     GIR_EraseRootFromParent_Done,
     /*  801406 */   // Label 12423: @801406
     /*  801406 */   GIM_Try, /*On fail goto*//*Label 12424*/ GIMT_Encode4(801481), // Rule ID 19641 //
     /*  801411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  801422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  801425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  801428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801457 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  801460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801479 */     GIR_RootConstrainSelectedInstOperands,
     /*  801480 */     // GIR_Coverage, 19641,
     /*  801480 */     GIR_EraseRootFromParent_Done,
     /*  801481 */   // Label 12424: @801481
     /*  801481 */   GIM_Try, /*On fail goto*//*Label 12425*/ GIMT_Encode4(801556), // Rule ID 19644 //
     /*  801486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  801497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  801500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  801503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801532 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  801535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801554 */     GIR_RootConstrainSelectedInstOperands,
     /*  801555 */     // GIR_Coverage, 19644,
     /*  801555 */     GIR_EraseRootFromParent_Done,
     /*  801556 */   // Label 12425: @801556
     /*  801556 */   GIM_Try, /*On fail goto*//*Label 12426*/ GIMT_Encode4(801631), // Rule ID 19645 //
     /*  801561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  801572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  801575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  801578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801607 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  801610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801629 */     GIR_RootConstrainSelectedInstOperands,
     /*  801630 */     // GIR_Coverage, 19645,
     /*  801630 */     GIR_EraseRootFromParent_Done,
     /*  801631 */   // Label 12426: @801631
     /*  801631 */   GIM_Try, /*On fail goto*//*Label 12427*/ GIMT_Encode4(801706), // Rule ID 19648 //
     /*  801636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  801647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  801650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  801653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801682 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  801685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801704 */     GIR_RootConstrainSelectedInstOperands,
     /*  801705 */     // GIR_Coverage, 19648,
     /*  801705 */     GIR_EraseRootFromParent_Done,
     /*  801706 */   // Label 12427: @801706
     /*  801706 */   GIM_Try, /*On fail goto*//*Label 12428*/ GIMT_Encode4(801781), // Rule ID 19649 //
     /*  801711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  801722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  801725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  801728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801757 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  801760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801779 */     GIR_RootConstrainSelectedInstOperands,
     /*  801780 */     // GIR_Coverage, 19649,
     /*  801780 */     GIR_EraseRootFromParent_Done,
     /*  801781 */   // Label 12428: @801781
     /*  801781 */   GIM_Try, /*On fail goto*//*Label 12429*/ GIMT_Encode4(801856), // Rule ID 19652 //
     /*  801786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  801797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  801800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  801803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801832 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  801835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801854 */     GIR_RootConstrainSelectedInstOperands,
     /*  801855 */     // GIR_Coverage, 19652,
     /*  801855 */     GIR_EraseRootFromParent_Done,
     /*  801856 */   // Label 12429: @801856
     /*  801856 */   GIM_Try, /*On fail goto*//*Label 12430*/ GIMT_Encode4(801931), // Rule ID 19653 //
     /*  801861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  801872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  801875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  801878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801907 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  801910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801929 */     GIR_RootConstrainSelectedInstOperands,
     /*  801930 */     // GIR_Coverage, 19653,
     /*  801930 */     GIR_EraseRootFromParent_Done,
     /*  801931 */   // Label 12430: @801931
     /*  801931 */   GIM_Try, /*On fail goto*//*Label 12431*/ GIMT_Encode4(802006), // Rule ID 19656 //
     /*  801936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  801947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  801950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  801953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801982 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  801985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802004 */     GIR_RootConstrainSelectedInstOperands,
     /*  802005 */     // GIR_Coverage, 19656,
     /*  802005 */     GIR_EraseRootFromParent_Done,
     /*  802006 */   // Label 12431: @802006
     /*  802006 */   GIM_Try, /*On fail goto*//*Label 12432*/ GIMT_Encode4(802081), // Rule ID 19657 //
     /*  802011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  802014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  802022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  802025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  802028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  802031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  802050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802057 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  802057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  802060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802079 */     GIR_RootConstrainSelectedInstOperands,
     /*  802080 */     // GIR_Coverage, 19657,
     /*  802080 */     GIR_EraseRootFromParent_Done,
     /*  802081 */   // Label 12432: @802081
     /*  802081 */   GIM_Try, /*On fail goto*//*Label 12433*/ GIMT_Encode4(802156), // Rule ID 19660 //
     /*  802086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  802089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  802097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  802100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  802103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  802106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  802125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802132 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  802132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  802135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802154 */     GIR_RootConstrainSelectedInstOperands,
     /*  802155 */     // GIR_Coverage, 19660,
     /*  802155 */     GIR_EraseRootFromParent_Done,
     /*  802156 */   // Label 12433: @802156
     /*  802156 */   GIM_Try, /*On fail goto*//*Label 12434*/ GIMT_Encode4(802231), // Rule ID 19661 //
     /*  802161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  802164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  802172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  802175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  802178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  802181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  802200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802207 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  802207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  802210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802229 */     GIR_RootConstrainSelectedInstOperands,
     /*  802230 */     // GIR_Coverage, 19661,
     /*  802230 */     GIR_EraseRootFromParent_Done,
     /*  802231 */   // Label 12434: @802231
     /*  802231 */   GIM_Try, /*On fail goto*//*Label 12435*/ GIMT_Encode4(802306), // Rule ID 19664 //
     /*  802236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  802247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  802250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  802253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  802256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802282 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  802285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802304 */     GIR_RootConstrainSelectedInstOperands,
     /*  802305 */     // GIR_Coverage, 19664,
     /*  802305 */     GIR_EraseRootFromParent_Done,
     /*  802306 */   // Label 12435: @802306
     /*  802306 */   GIM_Try, /*On fail goto*//*Label 12436*/ GIMT_Encode4(802381), // Rule ID 19665 //
     /*  802311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  802322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  802325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  802328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  802331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802357 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  802360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802379 */     GIR_RootConstrainSelectedInstOperands,
     /*  802380 */     // GIR_Coverage, 19665,
     /*  802380 */     GIR_EraseRootFromParent_Done,
     /*  802381 */   // Label 12436: @802381
     /*  802381 */   GIM_Try, /*On fail goto*//*Label 12437*/ GIMT_Encode4(802456), // Rule ID 19668 //
     /*  802386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  802397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  802400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  802403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  802406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802432 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  802435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802454 */     GIR_RootConstrainSelectedInstOperands,
     /*  802455 */     // GIR_Coverage, 19668,
     /*  802455 */     GIR_EraseRootFromParent_Done,
     /*  802456 */   // Label 12437: @802456
     /*  802456 */   GIM_Try, /*On fail goto*//*Label 12438*/ GIMT_Encode4(802531), // Rule ID 19669 //
     /*  802461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  802472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  802475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  802478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  802481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802507 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  802510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802529 */     GIR_RootConstrainSelectedInstOperands,
     /*  802530 */     // GIR_Coverage, 19669,
     /*  802530 */     GIR_EraseRootFromParent_Done,
     /*  802531 */   // Label 12438: @802531
     /*  802531 */   GIM_Try, /*On fail goto*//*Label 12439*/ GIMT_Encode4(802606), // Rule ID 19672 //
     /*  802536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  802547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  802550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  802553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  802556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802582 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  802585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802604 */     GIR_RootConstrainSelectedInstOperands,
     /*  802605 */     // GIR_Coverage, 19672,
     /*  802605 */     GIR_EraseRootFromParent_Done,
     /*  802606 */   // Label 12439: @802606
     /*  802606 */   GIM_Try, /*On fail goto*//*Label 12440*/ GIMT_Encode4(802681), // Rule ID 19673 //
     /*  802611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  802622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  802625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  802628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  802631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802657 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  802660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802679 */     GIR_RootConstrainSelectedInstOperands,
     /*  802680 */     // GIR_Coverage, 19673,
     /*  802680 */     GIR_EraseRootFromParent_Done,
     /*  802681 */   // Label 12440: @802681
     /*  802681 */   GIM_Try, /*On fail goto*//*Label 12441*/ GIMT_Encode4(802756), // Rule ID 19676 //
     /*  802686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  802697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  802700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  802703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  802706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802732 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  802735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802754 */     GIR_RootConstrainSelectedInstOperands,
     /*  802755 */     // GIR_Coverage, 19676,
     /*  802755 */     GIR_EraseRootFromParent_Done,
     /*  802756 */   // Label 12441: @802756
     /*  802756 */   GIM_Try, /*On fail goto*//*Label 12442*/ GIMT_Encode4(802831), // Rule ID 19677 //
     /*  802761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  802772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  802775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  802778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  802781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802807 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  802810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802829 */     GIR_RootConstrainSelectedInstOperands,
     /*  802830 */     // GIR_Coverage, 19677,
     /*  802830 */     GIR_EraseRootFromParent_Done,
     /*  802831 */   // Label 12442: @802831
     /*  802831 */   GIM_Try, /*On fail goto*//*Label 12443*/ GIMT_Encode4(802906), // Rule ID 19680 //
     /*  802836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  802847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  802850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  802853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  802856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802882 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  802885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802904 */     GIR_RootConstrainSelectedInstOperands,
     /*  802905 */     // GIR_Coverage, 19680,
     /*  802905 */     GIR_EraseRootFromParent_Done,
     /*  802906 */   // Label 12443: @802906
     /*  802906 */   GIM_Try, /*On fail goto*//*Label 12444*/ GIMT_Encode4(802981), // Rule ID 19681 //
     /*  802911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  802922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  802925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  802928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  802931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802957 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  802960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802979 */     GIR_RootConstrainSelectedInstOperands,
     /*  802980 */     // GIR_Coverage, 19681,
     /*  802980 */     GIR_EraseRootFromParent_Done,
     /*  802981 */   // Label 12444: @802981
     /*  802981 */   GIM_Try, /*On fail goto*//*Label 12445*/ GIMT_Encode4(803056), // Rule ID 19684 //
     /*  802986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  802989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  802997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  803000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  803003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  803006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803032 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  803035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803054 */     GIR_RootConstrainSelectedInstOperands,
     /*  803055 */     // GIR_Coverage, 19684,
     /*  803055 */     GIR_EraseRootFromParent_Done,
     /*  803056 */   // Label 12445: @803056
     /*  803056 */   GIM_Try, /*On fail goto*//*Label 12446*/ GIMT_Encode4(803131), // Rule ID 19685 //
     /*  803061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  803072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  803075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  803078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  803081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803107 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  803110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803129 */     GIR_RootConstrainSelectedInstOperands,
     /*  803130 */     // GIR_Coverage, 19685,
     /*  803130 */     GIR_EraseRootFromParent_Done,
     /*  803131 */   // Label 12446: @803131
     /*  803131 */   GIM_Try, /*On fail goto*//*Label 12447*/ GIMT_Encode4(803206), // Rule ID 19688 //
     /*  803136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  803147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  803150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  803153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  803156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803182 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  803185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803204 */     GIR_RootConstrainSelectedInstOperands,
     /*  803205 */     // GIR_Coverage, 19688,
     /*  803205 */     GIR_EraseRootFromParent_Done,
     /*  803206 */   // Label 12447: @803206
     /*  803206 */   GIM_Try, /*On fail goto*//*Label 12448*/ GIMT_Encode4(803281), // Rule ID 19689 //
     /*  803211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  803222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  803225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  803228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  803231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803257 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  803260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803279 */     GIR_RootConstrainSelectedInstOperands,
     /*  803280 */     // GIR_Coverage, 19689,
     /*  803280 */     GIR_EraseRootFromParent_Done,
     /*  803281 */   // Label 12448: @803281
     /*  803281 */   GIM_Try, /*On fail goto*//*Label 12449*/ GIMT_Encode4(803356), // Rule ID 19692 //
     /*  803286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  803297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  803300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  803303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  803306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803332 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  803335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803354 */     GIR_RootConstrainSelectedInstOperands,
     /*  803355 */     // GIR_Coverage, 19692,
     /*  803355 */     GIR_EraseRootFromParent_Done,
     /*  803356 */   // Label 12449: @803356
     /*  803356 */   GIM_Try, /*On fail goto*//*Label 12450*/ GIMT_Encode4(803431), // Rule ID 19693 //
     /*  803361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  803372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  803375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  803378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  803381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803407 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  803410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803429 */     GIR_RootConstrainSelectedInstOperands,
     /*  803430 */     // GIR_Coverage, 19693,
     /*  803430 */     GIR_EraseRootFromParent_Done,
     /*  803431 */   // Label 12450: @803431
     /*  803431 */   GIM_Try, /*On fail goto*//*Label 12451*/ GIMT_Encode4(803506), // Rule ID 19696 //
     /*  803436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  803447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  803450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  803453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  803456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803482 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  803485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803504 */     GIR_RootConstrainSelectedInstOperands,
     /*  803505 */     // GIR_Coverage, 19696,
     /*  803505 */     GIR_EraseRootFromParent_Done,
     /*  803506 */   // Label 12451: @803506
     /*  803506 */   GIM_Try, /*On fail goto*//*Label 12452*/ GIMT_Encode4(803581), // Rule ID 19697 //
     /*  803511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  803522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  803525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  803528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  803531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803557 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  803560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803579 */     GIR_RootConstrainSelectedInstOperands,
     /*  803580 */     // GIR_Coverage, 19697,
     /*  803580 */     GIR_EraseRootFromParent_Done,
     /*  803581 */   // Label 12452: @803581
     /*  803581 */   GIM_Try, /*On fail goto*//*Label 12453*/ GIMT_Encode4(803656), // Rule ID 19700 //
     /*  803586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  803597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  803600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  803603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  803606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803632 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  803635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803654 */     GIR_RootConstrainSelectedInstOperands,
     /*  803655 */     // GIR_Coverage, 19700,
     /*  803655 */     GIR_EraseRootFromParent_Done,
     /*  803656 */   // Label 12453: @803656
     /*  803656 */   GIM_Try, /*On fail goto*//*Label 12454*/ GIMT_Encode4(803731), // Rule ID 19701 //
     /*  803661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  803672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  803675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  803678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  803681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803707 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  803710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803729 */     GIR_RootConstrainSelectedInstOperands,
     /*  803730 */     // GIR_Coverage, 19701,
     /*  803730 */     GIR_EraseRootFromParent_Done,
     /*  803731 */   // Label 12454: @803731
     /*  803731 */   GIM_Try, /*On fail goto*//*Label 12455*/ GIMT_Encode4(803806), // Rule ID 19704 //
     /*  803736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  803747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  803750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  803753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  803756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803782 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  803785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803804 */     GIR_RootConstrainSelectedInstOperands,
     /*  803805 */     // GIR_Coverage, 19704,
     /*  803805 */     GIR_EraseRootFromParent_Done,
     /*  803806 */   // Label 12455: @803806
     /*  803806 */   GIM_Try, /*On fail goto*//*Label 12456*/ GIMT_Encode4(803881), // Rule ID 19705 //
     /*  803811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  803822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  803825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  803828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  803831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803857 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  803860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803879 */     GIR_RootConstrainSelectedInstOperands,
     /*  803880 */     // GIR_Coverage, 19705,
     /*  803880 */     GIR_EraseRootFromParent_Done,
     /*  803881 */   // Label 12456: @803881
     /*  803881 */   GIM_Try, /*On fail goto*//*Label 12457*/ GIMT_Encode4(803956), // Rule ID 19708 //
     /*  803886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  803897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  803900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  803903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  803906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803932 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  803935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803954 */     GIR_RootConstrainSelectedInstOperands,
     /*  803955 */     // GIR_Coverage, 19708,
     /*  803955 */     GIR_EraseRootFromParent_Done,
     /*  803956 */   // Label 12457: @803956
     /*  803956 */   GIM_Try, /*On fail goto*//*Label 12458*/ GIMT_Encode4(804031), // Rule ID 19709 //
     /*  803961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  803972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  803975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  803978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  803981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804007 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  804010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804029 */     GIR_RootConstrainSelectedInstOperands,
     /*  804030 */     // GIR_Coverage, 19709,
     /*  804030 */     GIR_EraseRootFromParent_Done,
     /*  804031 */   // Label 12458: @804031
     /*  804031 */   GIM_Try, /*On fail goto*//*Label 12459*/ GIMT_Encode4(804106), // Rule ID 19712 //
     /*  804036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  804039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  804047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  804050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  804053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  804056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804082 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  804082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  804085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804104 */     GIR_RootConstrainSelectedInstOperands,
     /*  804105 */     // GIR_Coverage, 19712,
     /*  804105 */     GIR_EraseRootFromParent_Done,
     /*  804106 */   // Label 12459: @804106
     /*  804106 */   GIM_Try, /*On fail goto*//*Label 12460*/ GIMT_Encode4(804181), // Rule ID 19713 //
     /*  804111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  804114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  804122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  804125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  804128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  804131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804157 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  804157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  804160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804179 */     GIR_RootConstrainSelectedInstOperands,
     /*  804180 */     // GIR_Coverage, 19713,
     /*  804180 */     GIR_EraseRootFromParent_Done,
     /*  804181 */   // Label 12460: @804181
     /*  804181 */   GIM_Try, /*On fail goto*//*Label 12461*/ GIMT_Encode4(804256), // Rule ID 19716 //
     /*  804186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  804189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  804197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  804200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  804203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  804206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804232 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  804232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  804235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804254 */     GIR_RootConstrainSelectedInstOperands,
     /*  804255 */     // GIR_Coverage, 19716,
     /*  804255 */     GIR_EraseRootFromParent_Done,
     /*  804256 */   // Label 12461: @804256
     /*  804256 */   GIM_Try, /*On fail goto*//*Label 12462*/ GIMT_Encode4(804331), // Rule ID 19717 //
     /*  804261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  804264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  804272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  804275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  804278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  804281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804307 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  804307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  804310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804329 */     GIR_RootConstrainSelectedInstOperands,
     /*  804330 */     // GIR_Coverage, 19717,
     /*  804330 */     GIR_EraseRootFromParent_Done,
     /*  804331 */   // Label 12462: @804331
     /*  804331 */   GIM_Try, /*On fail goto*//*Label 12463*/ GIMT_Encode4(804406), // Rule ID 19720 //
     /*  804336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  804339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  804347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  804350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  804353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  804356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804382 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  804382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  804385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804404 */     GIR_RootConstrainSelectedInstOperands,
     /*  804405 */     // GIR_Coverage, 19720,
     /*  804405 */     GIR_EraseRootFromParent_Done,
     /*  804406 */   // Label 12463: @804406
     /*  804406 */   GIM_Try, /*On fail goto*//*Label 12464*/ GIMT_Encode4(804481), // Rule ID 19721 //
     /*  804411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  804414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  804422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  804425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  804428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  804431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804457 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  804457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  804460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804479 */     GIR_RootConstrainSelectedInstOperands,
     /*  804480 */     // GIR_Coverage, 19721,
     /*  804480 */     GIR_EraseRootFromParent_Done,
     /*  804481 */   // Label 12464: @804481
     /*  804481 */   GIM_Try, /*On fail goto*//*Label 12465*/ GIMT_Encode4(804556), // Rule ID 19724 //
     /*  804486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  804497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  804500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  804503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804532 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  804535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804554 */     GIR_RootConstrainSelectedInstOperands,
     /*  804555 */     // GIR_Coverage, 19724,
     /*  804555 */     GIR_EraseRootFromParent_Done,
     /*  804556 */   // Label 12465: @804556
     /*  804556 */   GIM_Try, /*On fail goto*//*Label 12466*/ GIMT_Encode4(804631), // Rule ID 19725 //
     /*  804561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  804572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  804575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  804578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804607 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  804610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804629 */     GIR_RootConstrainSelectedInstOperands,
     /*  804630 */     // GIR_Coverage, 19725,
     /*  804630 */     GIR_EraseRootFromParent_Done,
     /*  804631 */   // Label 12466: @804631
     /*  804631 */   GIM_Try, /*On fail goto*//*Label 12467*/ GIMT_Encode4(804706), // Rule ID 19728 //
     /*  804636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  804647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  804650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  804653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804682 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  804685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804704 */     GIR_RootConstrainSelectedInstOperands,
     /*  804705 */     // GIR_Coverage, 19728,
     /*  804705 */     GIR_EraseRootFromParent_Done,
     /*  804706 */   // Label 12467: @804706
     /*  804706 */   GIM_Try, /*On fail goto*//*Label 12468*/ GIMT_Encode4(804781), // Rule ID 19729 //
     /*  804711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  804722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  804725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  804728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804757 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  804760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804779 */     GIR_RootConstrainSelectedInstOperands,
     /*  804780 */     // GIR_Coverage, 19729,
     /*  804780 */     GIR_EraseRootFromParent_Done,
     /*  804781 */   // Label 12468: @804781
     /*  804781 */   GIM_Try, /*On fail goto*//*Label 12469*/ GIMT_Encode4(804856), // Rule ID 19732 //
     /*  804786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  804789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  804797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  804800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  804803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804832 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  804835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804854 */     GIR_RootConstrainSelectedInstOperands,
     /*  804855 */     // GIR_Coverage, 19732,
     /*  804855 */     GIR_EraseRootFromParent_Done,
     /*  804856 */   // Label 12469: @804856
     /*  804856 */   GIM_Try, /*On fail goto*//*Label 12470*/ GIMT_Encode4(804931), // Rule ID 19733 //
     /*  804861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  804872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  804875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  804878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804907 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  804910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804929 */     GIR_RootConstrainSelectedInstOperands,
     /*  804930 */     // GIR_Coverage, 19733,
     /*  804930 */     GIR_EraseRootFromParent_Done,
     /*  804931 */   // Label 12470: @804931
     /*  804931 */   GIM_Try, /*On fail goto*//*Label 12471*/ GIMT_Encode4(805006), // Rule ID 19736 //
     /*  804936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  804947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  804950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  804953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804982 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  804985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805004 */     GIR_RootConstrainSelectedInstOperands,
     /*  805005 */     // GIR_Coverage, 19736,
     /*  805005 */     GIR_EraseRootFromParent_Done,
     /*  805006 */   // Label 12471: @805006
     /*  805006 */   GIM_Try, /*On fail goto*//*Label 12472*/ GIMT_Encode4(805081), // Rule ID 19737 //
     /*  805011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  805022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  805025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  805028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805057 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  805060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805079 */     GIR_RootConstrainSelectedInstOperands,
     /*  805080 */     // GIR_Coverage, 19737,
     /*  805080 */     GIR_EraseRootFromParent_Done,
     /*  805081 */   // Label 12472: @805081
     /*  805081 */   GIM_Try, /*On fail goto*//*Label 12473*/ GIMT_Encode4(805156), // Rule ID 19740 //
     /*  805086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  805097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  805100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  805103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805132 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  805135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805154 */     GIR_RootConstrainSelectedInstOperands,
     /*  805155 */     // GIR_Coverage, 19740,
     /*  805155 */     GIR_EraseRootFromParent_Done,
     /*  805156 */   // Label 12473: @805156
     /*  805156 */   GIM_Try, /*On fail goto*//*Label 12474*/ GIMT_Encode4(805231), // Rule ID 19741 //
     /*  805161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  805172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  805175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  805178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805207 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  805210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805229 */     GIR_RootConstrainSelectedInstOperands,
     /*  805230 */     // GIR_Coverage, 19741,
     /*  805230 */     GIR_EraseRootFromParent_Done,
     /*  805231 */   // Label 12474: @805231
     /*  805231 */   GIM_Try, /*On fail goto*//*Label 12475*/ GIMT_Encode4(805306), // Rule ID 19744 //
     /*  805236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  805247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  805250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  805253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805282 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  805285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805304 */     GIR_RootConstrainSelectedInstOperands,
     /*  805305 */     // GIR_Coverage, 19744,
     /*  805305 */     GIR_EraseRootFromParent_Done,
     /*  805306 */   // Label 12475: @805306
     /*  805306 */   GIM_Try, /*On fail goto*//*Label 12476*/ GIMT_Encode4(805381), // Rule ID 19745 //
     /*  805311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  805322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  805325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  805328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805357 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  805360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805379 */     GIR_RootConstrainSelectedInstOperands,
     /*  805380 */     // GIR_Coverage, 19745,
     /*  805380 */     GIR_EraseRootFromParent_Done,
     /*  805381 */   // Label 12476: @805381
     /*  805381 */   GIM_Try, /*On fail goto*//*Label 12477*/ GIMT_Encode4(805456), // Rule ID 19748 //
     /*  805386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  805397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  805400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  805403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805432 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  805435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805454 */     GIR_RootConstrainSelectedInstOperands,
     /*  805455 */     // GIR_Coverage, 19748,
     /*  805455 */     GIR_EraseRootFromParent_Done,
     /*  805456 */   // Label 12477: @805456
     /*  805456 */   GIM_Try, /*On fail goto*//*Label 12478*/ GIMT_Encode4(805531), // Rule ID 19749 //
     /*  805461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  805472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  805475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  805478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805507 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  805510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805529 */     GIR_RootConstrainSelectedInstOperands,
     /*  805530 */     // GIR_Coverage, 19749,
     /*  805530 */     GIR_EraseRootFromParent_Done,
     /*  805531 */   // Label 12478: @805531
     /*  805531 */   GIM_Try, /*On fail goto*//*Label 12479*/ GIMT_Encode4(805606), // Rule ID 19752 //
     /*  805536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  805547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  805550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  805553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805582 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  805585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805604 */     GIR_RootConstrainSelectedInstOperands,
     /*  805605 */     // GIR_Coverage, 19752,
     /*  805605 */     GIR_EraseRootFromParent_Done,
     /*  805606 */   // Label 12479: @805606
     /*  805606 */   GIM_Try, /*On fail goto*//*Label 12480*/ GIMT_Encode4(805681), // Rule ID 19753 //
     /*  805611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  805622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  805625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  805628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805657 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  805660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805679 */     GIR_RootConstrainSelectedInstOperands,
     /*  805680 */     // GIR_Coverage, 19753,
     /*  805680 */     GIR_EraseRootFromParent_Done,
     /*  805681 */   // Label 12480: @805681
     /*  805681 */   GIM_Try, /*On fail goto*//*Label 12481*/ GIMT_Encode4(805756), // Rule ID 19756 //
     /*  805686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  805697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  805700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  805703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805732 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  805735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805754 */     GIR_RootConstrainSelectedInstOperands,
     /*  805755 */     // GIR_Coverage, 19756,
     /*  805755 */     GIR_EraseRootFromParent_Done,
     /*  805756 */   // Label 12481: @805756
     /*  805756 */   GIM_Try, /*On fail goto*//*Label 12482*/ GIMT_Encode4(805831), // Rule ID 19757 //
     /*  805761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  805772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  805775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  805778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805807 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  805810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805829 */     GIR_RootConstrainSelectedInstOperands,
     /*  805830 */     // GIR_Coverage, 19757,
     /*  805830 */     GIR_EraseRootFromParent_Done,
     /*  805831 */   // Label 12482: @805831
     /*  805831 */   GIM_Try, /*On fail goto*//*Label 12483*/ GIMT_Encode4(805906), // Rule ID 19760 //
     /*  805836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  805847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  805850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  805853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805882 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  805885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805904 */     GIR_RootConstrainSelectedInstOperands,
     /*  805905 */     // GIR_Coverage, 19760,
     /*  805905 */     GIR_EraseRootFromParent_Done,
     /*  805906 */   // Label 12483: @805906
     /*  805906 */   GIM_Try, /*On fail goto*//*Label 12484*/ GIMT_Encode4(805981), // Rule ID 19761 //
     /*  805911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  805922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  805925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  805928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805957 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  805960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805979 */     GIR_RootConstrainSelectedInstOperands,
     /*  805980 */     // GIR_Coverage, 19761,
     /*  805980 */     GIR_EraseRootFromParent_Done,
     /*  805981 */   // Label 12484: @805981
     /*  805981 */   GIM_Try, /*On fail goto*//*Label 12485*/ GIMT_Encode4(806056), // Rule ID 19764 //
     /*  805986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  805997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  806000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  806003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  806006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  806025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806032 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  806035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806054 */     GIR_RootConstrainSelectedInstOperands,
     /*  806055 */     // GIR_Coverage, 19764,
     /*  806055 */     GIR_EraseRootFromParent_Done,
     /*  806056 */   // Label 12485: @806056
     /*  806056 */   GIM_Try, /*On fail goto*//*Label 12486*/ GIMT_Encode4(806131), // Rule ID 19765 //
     /*  806061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  806064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  806072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  806075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  806078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  806081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  806100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806107 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  806110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806129 */     GIR_RootConstrainSelectedInstOperands,
     /*  806130 */     // GIR_Coverage, 19765,
     /*  806130 */     GIR_EraseRootFromParent_Done,
     /*  806131 */   // Label 12486: @806131
     /*  806131 */   GIM_Try, /*On fail goto*//*Label 12487*/ GIMT_Encode4(806206), // Rule ID 19768 //
     /*  806136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  806139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  806147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  806150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  806153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  806156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  806175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806182 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  806185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806204 */     GIR_RootConstrainSelectedInstOperands,
     /*  806205 */     // GIR_Coverage, 19768,
     /*  806205 */     GIR_EraseRootFromParent_Done,
     /*  806206 */   // Label 12487: @806206
     /*  806206 */   GIM_Try, /*On fail goto*//*Label 12488*/ GIMT_Encode4(806281), // Rule ID 19769 //
     /*  806211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  806214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  806222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  806225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  806228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  806231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  806250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806257 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  806260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806279 */     GIR_RootConstrainSelectedInstOperands,
     /*  806280 */     // GIR_Coverage, 19769,
     /*  806280 */     GIR_EraseRootFromParent_Done,
     /*  806281 */   // Label 12488: @806281
     /*  806281 */   GIM_Try, /*On fail goto*//*Label 12489*/ GIMT_Encode4(806356), // Rule ID 19772 //
     /*  806286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  806289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  806297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  806300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  806303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806332 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  806335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806354 */     GIR_RootConstrainSelectedInstOperands,
     /*  806355 */     // GIR_Coverage, 19772,
     /*  806355 */     GIR_EraseRootFromParent_Done,
     /*  806356 */   // Label 12489: @806356
     /*  806356 */   GIM_Try, /*On fail goto*//*Label 12490*/ GIMT_Encode4(806431), // Rule ID 19773 //
     /*  806361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  806364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  806372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  806375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  806378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806407 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  806407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  806410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806429 */     GIR_RootConstrainSelectedInstOperands,
     /*  806430 */     // GIR_Coverage, 19773,
     /*  806430 */     GIR_EraseRootFromParent_Done,
     /*  806431 */   // Label 12490: @806431
     /*  806431 */   GIM_Try, /*On fail goto*//*Label 12491*/ GIMT_Encode4(806506), // Rule ID 19776 //
     /*  806436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  806439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  806447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  806450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  806453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806482 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  806485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806504 */     GIR_RootConstrainSelectedInstOperands,
     /*  806505 */     // GIR_Coverage, 19776,
     /*  806505 */     GIR_EraseRootFromParent_Done,
     /*  806506 */   // Label 12491: @806506
     /*  806506 */   GIM_Try, /*On fail goto*//*Label 12492*/ GIMT_Encode4(806581), // Rule ID 19777 //
     /*  806511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  806514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  806522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  806525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  806528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806557 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  806557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  806560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806579 */     GIR_RootConstrainSelectedInstOperands,
     /*  806580 */     // GIR_Coverage, 19777,
     /*  806580 */     GIR_EraseRootFromParent_Done,
     /*  806581 */   // Label 12492: @806581
     /*  806581 */   GIM_Try, /*On fail goto*//*Label 12493*/ GIMT_Encode4(806656), // Rule ID 19780 //
     /*  806586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  806589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  806597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  806600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  806603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806632 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  806635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806654 */     GIR_RootConstrainSelectedInstOperands,
     /*  806655 */     // GIR_Coverage, 19780,
     /*  806655 */     GIR_EraseRootFromParent_Done,
     /*  806656 */   // Label 12493: @806656
     /*  806656 */   GIM_Try, /*On fail goto*//*Label 12494*/ GIMT_Encode4(806731), // Rule ID 19781 //
     /*  806661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  806664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  806672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  806675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  806678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806707 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  806707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  806710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806729 */     GIR_RootConstrainSelectedInstOperands,
     /*  806730 */     // GIR_Coverage, 19781,
     /*  806730 */     GIR_EraseRootFromParent_Done,
     /*  806731 */   // Label 12494: @806731
     /*  806731 */   GIM_Try, /*On fail goto*//*Label 12495*/ GIMT_Encode4(806806), // Rule ID 21998 //
     /*  806736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  806753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806782 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  806782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  806785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806804 */     GIR_RootConstrainSelectedInstOperands,
     /*  806805 */     // GIR_Coverage, 21998,
     /*  806805 */     GIR_EraseRootFromParent_Done,
     /*  806806 */   // Label 12495: @806806
     /*  806806 */   GIM_Try, /*On fail goto*//*Label 12496*/ GIMT_Encode4(806881), // Rule ID 21999 //
     /*  806811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  806828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806857 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  806857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  806860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806879 */     GIR_RootConstrainSelectedInstOperands,
     /*  806880 */     // GIR_Coverage, 21999,
     /*  806880 */     GIR_EraseRootFromParent_Done,
     /*  806881 */   // Label 12496: @806881
     /*  806881 */   GIM_Try, /*On fail goto*//*Label 12497*/ GIMT_Encode4(806956), // Rule ID 22002 //
     /*  806886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  806903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806932 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  806932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  806935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806954 */     GIR_RootConstrainSelectedInstOperands,
     /*  806955 */     // GIR_Coverage, 22002,
     /*  806955 */     GIR_EraseRootFromParent_Done,
     /*  806956 */   // Label 12497: @806956
     /*  806956 */   GIM_Try, /*On fail goto*//*Label 12498*/ GIMT_Encode4(807031), // Rule ID 22003 //
     /*  806961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  806978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807007 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  807010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807029 */     GIR_RootConstrainSelectedInstOperands,
     /*  807030 */     // GIR_Coverage, 22003,
     /*  807030 */     GIR_EraseRootFromParent_Done,
     /*  807031 */   // Label 12498: @807031
     /*  807031 */   GIM_Try, /*On fail goto*//*Label 12499*/ GIMT_Encode4(807106), // Rule ID 22006 //
     /*  807036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  807053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807082 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  807085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807104 */     GIR_RootConstrainSelectedInstOperands,
     /*  807105 */     // GIR_Coverage, 22006,
     /*  807105 */     GIR_EraseRootFromParent_Done,
     /*  807106 */   // Label 12499: @807106
     /*  807106 */   GIM_Try, /*On fail goto*//*Label 12500*/ GIMT_Encode4(807181), // Rule ID 22007 //
     /*  807111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  807128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807157 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  807160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807179 */     GIR_RootConstrainSelectedInstOperands,
     /*  807180 */     // GIR_Coverage, 22007,
     /*  807180 */     GIR_EraseRootFromParent_Done,
     /*  807181 */   // Label 12500: @807181
     /*  807181 */   GIM_Try, /*On fail goto*//*Label 12501*/ GIMT_Encode4(807256), // Rule ID 22010 //
     /*  807186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  807203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  807235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807254 */     GIR_RootConstrainSelectedInstOperands,
     /*  807255 */     // GIR_Coverage, 22010,
     /*  807255 */     GIR_EraseRootFromParent_Done,
     /*  807256 */   // Label 12501: @807256
     /*  807256 */   GIM_Try, /*On fail goto*//*Label 12502*/ GIMT_Encode4(807331), // Rule ID 22011 //
     /*  807261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  807278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807307 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  807310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807329 */     GIR_RootConstrainSelectedInstOperands,
     /*  807330 */     // GIR_Coverage, 22011,
     /*  807330 */     GIR_EraseRootFromParent_Done,
     /*  807331 */   // Label 12502: @807331
     /*  807331 */   GIM_Try, /*On fail goto*//*Label 12503*/ GIMT_Encode4(807406), // Rule ID 22014 //
     /*  807336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  807347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  807350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  807353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  807356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  807382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  807385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807404 */     GIR_RootConstrainSelectedInstOperands,
     /*  807405 */     // GIR_Coverage, 22014,
     /*  807405 */     GIR_EraseRootFromParent_Done,
     /*  807406 */   // Label 12503: @807406
     /*  807406 */   GIM_Try, /*On fail goto*//*Label 12504*/ GIMT_Encode4(807481), // Rule ID 22015 //
     /*  807411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  807422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  807425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  807428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  807431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807457 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  807457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  807460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807479 */     GIR_RootConstrainSelectedInstOperands,
     /*  807480 */     // GIR_Coverage, 22015,
     /*  807480 */     GIR_EraseRootFromParent_Done,
     /*  807481 */   // Label 12504: @807481
     /*  807481 */   GIM_Try, /*On fail goto*//*Label 12505*/ GIMT_Encode4(807556), // Rule ID 22018 //
     /*  807486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  807503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807532 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  807535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807554 */     GIR_RootConstrainSelectedInstOperands,
     /*  807555 */     // GIR_Coverage, 22018,
     /*  807555 */     GIR_EraseRootFromParent_Done,
     /*  807556 */   // Label 12505: @807556
     /*  807556 */   GIM_Try, /*On fail goto*//*Label 12506*/ GIMT_Encode4(807631), // Rule ID 22019 //
     /*  807561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  807578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807607 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  807610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807629 */     GIR_RootConstrainSelectedInstOperands,
     /*  807630 */     // GIR_Coverage, 22019,
     /*  807630 */     GIR_EraseRootFromParent_Done,
     /*  807631 */   // Label 12506: @807631
     /*  807631 */   GIM_Try, /*On fail goto*//*Label 12507*/ GIMT_Encode4(807706), // Rule ID 22022 //
     /*  807636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  807653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  807685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807704 */     GIR_RootConstrainSelectedInstOperands,
     /*  807705 */     // GIR_Coverage, 22022,
     /*  807705 */     GIR_EraseRootFromParent_Done,
     /*  807706 */   // Label 12507: @807706
     /*  807706 */   GIM_Try, /*On fail goto*//*Label 12508*/ GIMT_Encode4(807781), // Rule ID 22023 //
     /*  807711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  807728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807757 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  807760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807779 */     GIR_RootConstrainSelectedInstOperands,
     /*  807780 */     // GIR_Coverage, 22023,
     /*  807780 */     GIR_EraseRootFromParent_Done,
     /*  807781 */   // Label 12508: @807781
     /*  807781 */   GIM_Try, /*On fail goto*//*Label 12509*/ GIMT_Encode4(807856), // Rule ID 22026 //
     /*  807786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  807797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  807800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  807803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  807806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807832 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  807832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  807835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807854 */     GIR_RootConstrainSelectedInstOperands,
     /*  807855 */     // GIR_Coverage, 22026,
     /*  807855 */     GIR_EraseRootFromParent_Done,
     /*  807856 */   // Label 12509: @807856
     /*  807856 */   GIM_Try, /*On fail goto*//*Label 12510*/ GIMT_Encode4(807931), // Rule ID 22027 //
     /*  807861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  807872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  807875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  807878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  807881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807907 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  807907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  807910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807929 */     GIR_RootConstrainSelectedInstOperands,
     /*  807930 */     // GIR_Coverage, 22027,
     /*  807930 */     GIR_EraseRootFromParent_Done,
     /*  807931 */   // Label 12510: @807931
     /*  807931 */   GIM_Try, /*On fail goto*//*Label 12511*/ GIMT_Encode4(808006), // Rule ID 22030 //
     /*  807936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  807939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  807947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  807950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  807953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  807956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807982 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  807985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808004 */     GIR_RootConstrainSelectedInstOperands,
     /*  808005 */     // GIR_Coverage, 22030,
     /*  808005 */     GIR_EraseRootFromParent_Done,
     /*  808006 */   // Label 12511: @808006
     /*  808006 */   GIM_Try, /*On fail goto*//*Label 12512*/ GIMT_Encode4(808081), // Rule ID 22031 //
     /*  808011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  808014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  808028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  808031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808057 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  808057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  808060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808079 */     GIR_RootConstrainSelectedInstOperands,
     /*  808080 */     // GIR_Coverage, 22031,
     /*  808080 */     GIR_EraseRootFromParent_Done,
     /*  808081 */   // Label 12512: @808081
     /*  808081 */   GIM_Try, /*On fail goto*//*Label 12513*/ GIMT_Encode4(808156), // Rule ID 22034 //
     /*  808086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  808103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  808132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  808135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808154 */     GIR_RootConstrainSelectedInstOperands,
     /*  808155 */     // GIR_Coverage, 22034,
     /*  808155 */     GIR_EraseRootFromParent_Done,
     /*  808156 */   // Label 12513: @808156
     /*  808156 */   GIM_Try, /*On fail goto*//*Label 12514*/ GIMT_Encode4(808231), // Rule ID 22035 //
     /*  808161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  808178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808207 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  808207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  808210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808229 */     GIR_RootConstrainSelectedInstOperands,
     /*  808230 */     // GIR_Coverage, 22035,
     /*  808230 */     GIR_EraseRootFromParent_Done,
     /*  808231 */   // Label 12514: @808231
     /*  808231 */   GIM_Try, /*On fail goto*//*Label 12515*/ GIMT_Encode4(808306), // Rule ID 22038 //
     /*  808236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  808253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808282 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  808282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  808285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808304 */     GIR_RootConstrainSelectedInstOperands,
     /*  808305 */     // GIR_Coverage, 22038,
     /*  808305 */     GIR_EraseRootFromParent_Done,
     /*  808306 */   // Label 12515: @808306
     /*  808306 */   GIM_Try, /*On fail goto*//*Label 12516*/ GIMT_Encode4(808381), // Rule ID 22039 //
     /*  808311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  808328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808357 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  808357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  808360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808379 */     GIR_RootConstrainSelectedInstOperands,
     /*  808380 */     // GIR_Coverage, 22039,
     /*  808380 */     GIR_EraseRootFromParent_Done,
     /*  808381 */   // Label 12516: @808381
     /*  808381 */   GIM_Try, /*On fail goto*//*Label 12517*/ GIMT_Encode4(808456), // Rule ID 22042 //
     /*  808386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  808403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  808432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  808435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808454 */     GIR_RootConstrainSelectedInstOperands,
     /*  808455 */     // GIR_Coverage, 22042,
     /*  808455 */     GIR_EraseRootFromParent_Done,
     /*  808456 */   // Label 12517: @808456
     /*  808456 */   GIM_Try, /*On fail goto*//*Label 12518*/ GIMT_Encode4(808531), // Rule ID 22043 //
     /*  808461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  808478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808507 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  808507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  808510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808529 */     GIR_RootConstrainSelectedInstOperands,
     /*  808530 */     // GIR_Coverage, 22043,
     /*  808530 */     GIR_EraseRootFromParent_Done,
     /*  808531 */   // Label 12518: @808531
     /*  808531 */   GIM_Try, /*On fail goto*//*Label 12519*/ GIMT_Encode4(808606), // Rule ID 22046 //
     /*  808536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  808553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808582 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  808585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808604 */     GIR_RootConstrainSelectedInstOperands,
     /*  808605 */     // GIR_Coverage, 22046,
     /*  808605 */     GIR_EraseRootFromParent_Done,
     /*  808606 */   // Label 12519: @808606
     /*  808606 */   GIM_Try, /*On fail goto*//*Label 12520*/ GIMT_Encode4(808681), // Rule ID 22047 //
     /*  808611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  808628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808657 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  808660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808679 */     GIR_RootConstrainSelectedInstOperands,
     /*  808680 */     // GIR_Coverage, 22047,
     /*  808680 */     GIR_EraseRootFromParent_Done,
     /*  808681 */   // Label 12520: @808681
     /*  808681 */   GIM_Try, /*On fail goto*//*Label 12521*/ GIMT_Encode4(808756), // Rule ID 22050 //
     /*  808686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  808703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808732 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  808735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808754 */     GIR_RootConstrainSelectedInstOperands,
     /*  808755 */     // GIR_Coverage, 22050,
     /*  808755 */     GIR_EraseRootFromParent_Done,
     /*  808756 */   // Label 12521: @808756
     /*  808756 */   GIM_Try, /*On fail goto*//*Label 12522*/ GIMT_Encode4(808831), // Rule ID 22051 //
     /*  808761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  808778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808807 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  808810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808829 */     GIR_RootConstrainSelectedInstOperands,
     /*  808830 */     // GIR_Coverage, 22051,
     /*  808830 */     GIR_EraseRootFromParent_Done,
     /*  808831 */   // Label 12522: @808831
     /*  808831 */   GIM_Try, /*On fail goto*//*Label 12523*/ GIMT_Encode4(808906), // Rule ID 22054 //
     /*  808836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  808853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  808885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808904 */     GIR_RootConstrainSelectedInstOperands,
     /*  808905 */     // GIR_Coverage, 22054,
     /*  808905 */     GIR_EraseRootFromParent_Done,
     /*  808906 */   // Label 12523: @808906
     /*  808906 */   GIM_Try, /*On fail goto*//*Label 12524*/ GIMT_Encode4(808981), // Rule ID 22055 //
     /*  808911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  808928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808957 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  808960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808979 */     GIR_RootConstrainSelectedInstOperands,
     /*  808980 */     // GIR_Coverage, 22055,
     /*  808980 */     GIR_EraseRootFromParent_Done,
     /*  808981 */   // Label 12524: @808981
     /*  808981 */   GIM_Try, /*On fail goto*//*Label 12525*/ GIMT_Encode4(809056), // Rule ID 22058 //
     /*  808986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  809003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809032 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  809035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809054 */     GIR_RootConstrainSelectedInstOperands,
     /*  809055 */     // GIR_Coverage, 22058,
     /*  809055 */     GIR_EraseRootFromParent_Done,
     /*  809056 */   // Label 12525: @809056
     /*  809056 */   GIM_Try, /*On fail goto*//*Label 12526*/ GIMT_Encode4(809131), // Rule ID 22059 //
     /*  809061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  809072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  809078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809107 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  809110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809129 */     GIR_RootConstrainSelectedInstOperands,
     /*  809130 */     // GIR_Coverage, 22059,
     /*  809130 */     GIR_EraseRootFromParent_Done,
     /*  809131 */   // Label 12526: @809131
     /*  809131 */   GIM_Try, /*On fail goto*//*Label 12527*/ GIMT_Encode4(809206), // Rule ID 22062 //
     /*  809136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  809147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  809153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809182 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  809185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809204 */     GIR_RootConstrainSelectedInstOperands,
     /*  809205 */     // GIR_Coverage, 22062,
     /*  809205 */     GIR_EraseRootFromParent_Done,
     /*  809206 */   // Label 12527: @809206
     /*  809206 */   GIM_Try, /*On fail goto*//*Label 12528*/ GIMT_Encode4(809281), // Rule ID 22063 //
     /*  809211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  809222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  809228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809257 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  809260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809279 */     GIR_RootConstrainSelectedInstOperands,
     /*  809280 */     // GIR_Coverage, 22063,
     /*  809280 */     GIR_EraseRootFromParent_Done,
     /*  809281 */   // Label 12528: @809281
     /*  809281 */   GIM_Try, /*On fail goto*//*Label 12529*/ GIMT_Encode4(809356), // Rule ID 22066 //
     /*  809286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  809297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  809303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809332 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  809335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809354 */     GIR_RootConstrainSelectedInstOperands,
     /*  809355 */     // GIR_Coverage, 22066,
     /*  809355 */     GIR_EraseRootFromParent_Done,
     /*  809356 */   // Label 12529: @809356
     /*  809356 */   GIM_Try, /*On fail goto*//*Label 12530*/ GIMT_Encode4(809431), // Rule ID 22067 //
     /*  809361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  809372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  809378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809407 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  809410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809429 */     GIR_RootConstrainSelectedInstOperands,
     /*  809430 */     // GIR_Coverage, 22067,
     /*  809430 */     GIR_EraseRootFromParent_Done,
     /*  809431 */   // Label 12530: @809431
     /*  809431 */   GIM_Try, /*On fail goto*//*Label 12531*/ GIMT_Encode4(809506), // Rule ID 22070 //
     /*  809436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  809439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  809453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  809485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809504 */     GIR_RootConstrainSelectedInstOperands,
     /*  809505 */     // GIR_Coverage, 22070,
     /*  809505 */     GIR_EraseRootFromParent_Done,
     /*  809506 */   // Label 12531: @809506
     /*  809506 */   GIM_Try, /*On fail goto*//*Label 12532*/ GIMT_Encode4(809581), // Rule ID 22071 //
     /*  809511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  809514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  809528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809557 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  809560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809579 */     GIR_RootConstrainSelectedInstOperands,
     /*  809580 */     // GIR_Coverage, 22071,
     /*  809580 */     GIR_EraseRootFromParent_Done,
     /*  809581 */   // Label 12532: @809581
     /*  809581 */   GIM_Try, /*On fail goto*//*Label 12533*/ GIMT_Encode4(809656), // Rule ID 22074 //
     /*  809586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  809589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  809603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809632 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  809635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809654 */     GIR_RootConstrainSelectedInstOperands,
     /*  809655 */     // GIR_Coverage, 22074,
     /*  809655 */     GIR_EraseRootFromParent_Done,
     /*  809656 */   // Label 12533: @809656
     /*  809656 */   GIM_Try, /*On fail goto*//*Label 12534*/ GIMT_Encode4(809731), // Rule ID 22075 //
     /*  809661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  809664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  809678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809707 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  809710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809729 */     GIR_RootConstrainSelectedInstOperands,
     /*  809730 */     // GIR_Coverage, 22075,
     /*  809730 */     GIR_EraseRootFromParent_Done,
     /*  809731 */   // Label 12534: @809731
     /*  809731 */   GIM_Try, /*On fail goto*//*Label 12535*/ GIMT_Encode4(809806), // Rule ID 22078 //
     /*  809736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  809739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  809753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809782 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  809785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809804 */     GIR_RootConstrainSelectedInstOperands,
     /*  809805 */     // GIR_Coverage, 22078,
     /*  809805 */     GIR_EraseRootFromParent_Done,
     /*  809806 */   // Label 12535: @809806
     /*  809806 */   GIM_Try, /*On fail goto*//*Label 12536*/ GIMT_Encode4(809881), // Rule ID 22079 //
     /*  809811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  809814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  809828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809857 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  809860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809879 */     GIR_RootConstrainSelectedInstOperands,
     /*  809880 */     // GIR_Coverage, 22079,
     /*  809880 */     GIR_EraseRootFromParent_Done,
     /*  809881 */   // Label 12536: @809881
     /*  809881 */   GIM_Try, /*On fail goto*//*Label 12537*/ GIMT_Encode4(809956), // Rule ID 22082 //
     /*  809886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  809903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809932 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  809935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809954 */     GIR_RootConstrainSelectedInstOperands,
     /*  809955 */     // GIR_Coverage, 22082,
     /*  809955 */     GIR_EraseRootFromParent_Done,
     /*  809956 */   // Label 12537: @809956
     /*  809956 */   GIM_Try, /*On fail goto*//*Label 12538*/ GIMT_Encode4(810031), // Rule ID 22083 //
     /*  809961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  809978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810007 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  810010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810029 */     GIR_RootConstrainSelectedInstOperands,
     /*  810030 */     // GIR_Coverage, 22083,
     /*  810030 */     GIR_EraseRootFromParent_Done,
     /*  810031 */   // Label 12538: @810031
     /*  810031 */   GIM_Try, /*On fail goto*//*Label 12539*/ GIMT_Encode4(810106), // Rule ID 22086 //
     /*  810036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  810053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810082 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  810085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810104 */     GIR_RootConstrainSelectedInstOperands,
     /*  810105 */     // GIR_Coverage, 22086,
     /*  810105 */     GIR_EraseRootFromParent_Done,
     /*  810106 */   // Label 12539: @810106
     /*  810106 */   GIM_Try, /*On fail goto*//*Label 12540*/ GIMT_Encode4(810181), // Rule ID 22087 //
     /*  810111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  810128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810157 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  810160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810179 */     GIR_RootConstrainSelectedInstOperands,
     /*  810180 */     // GIR_Coverage, 22087,
     /*  810180 */     GIR_EraseRootFromParent_Done,
     /*  810181 */   // Label 12540: @810181
     /*  810181 */   GIM_Try, /*On fail goto*//*Label 12541*/ GIMT_Encode4(810256), // Rule ID 22090 //
     /*  810186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  810203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  810235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810254 */     GIR_RootConstrainSelectedInstOperands,
     /*  810255 */     // GIR_Coverage, 22090,
     /*  810255 */     GIR_EraseRootFromParent_Done,
     /*  810256 */   // Label 12541: @810256
     /*  810256 */   GIM_Try, /*On fail goto*//*Label 12542*/ GIMT_Encode4(810331), // Rule ID 22091 //
     /*  810261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  810278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810307 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  810310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810329 */     GIR_RootConstrainSelectedInstOperands,
     /*  810330 */     // GIR_Coverage, 22091,
     /*  810330 */     GIR_EraseRootFromParent_Done,
     /*  810331 */   // Label 12542: @810331
     /*  810331 */   GIM_Try, /*On fail goto*//*Label 12543*/ GIMT_Encode4(810406), // Rule ID 22094 //
     /*  810336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  810353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  810385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810404 */     GIR_RootConstrainSelectedInstOperands,
     /*  810405 */     // GIR_Coverage, 22094,
     /*  810405 */     GIR_EraseRootFromParent_Done,
     /*  810406 */   // Label 12543: @810406
     /*  810406 */   GIM_Try, /*On fail goto*//*Label 12544*/ GIMT_Encode4(810481), // Rule ID 22095 //
     /*  810411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  810428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810457 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  810460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810479 */     GIR_RootConstrainSelectedInstOperands,
     /*  810480 */     // GIR_Coverage, 22095,
     /*  810480 */     GIR_EraseRootFromParent_Done,
     /*  810481 */   // Label 12544: @810481
     /*  810481 */   GIM_Try, /*On fail goto*//*Label 12545*/ GIMT_Encode4(810556), // Rule ID 22098 //
     /*  810486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  810503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  810535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810554 */     GIR_RootConstrainSelectedInstOperands,
     /*  810555 */     // GIR_Coverage, 22098,
     /*  810555 */     GIR_EraseRootFromParent_Done,
     /*  810556 */   // Label 12545: @810556
     /*  810556 */   GIM_Try, /*On fail goto*//*Label 12546*/ GIMT_Encode4(810631), // Rule ID 22099 //
     /*  810561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  810578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810607 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  810610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810629 */     GIR_RootConstrainSelectedInstOperands,
     /*  810630 */     // GIR_Coverage, 22099,
     /*  810630 */     GIR_EraseRootFromParent_Done,
     /*  810631 */   // Label 12546: @810631
     /*  810631 */   GIM_Try, /*On fail goto*//*Label 12547*/ GIMT_Encode4(810706), // Rule ID 22102 //
     /*  810636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  810653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  810685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810704 */     GIR_RootConstrainSelectedInstOperands,
     /*  810705 */     // GIR_Coverage, 22102,
     /*  810705 */     GIR_EraseRootFromParent_Done,
     /*  810706 */   // Label 12547: @810706
     /*  810706 */   GIM_Try, /*On fail goto*//*Label 12548*/ GIMT_Encode4(810781), // Rule ID 22103 //
     /*  810711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  810728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810757 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  810760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810779 */     GIR_RootConstrainSelectedInstOperands,
     /*  810780 */     // GIR_Coverage, 22103,
     /*  810780 */     GIR_EraseRootFromParent_Done,
     /*  810781 */   // Label 12548: @810781
     /*  810781 */   GIM_Try, /*On fail goto*//*Label 12549*/ GIMT_Encode4(810856), // Rule ID 22106 //
     /*  810786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  810803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810832 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  810835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810854 */     GIR_RootConstrainSelectedInstOperands,
     /*  810855 */     // GIR_Coverage, 22106,
     /*  810855 */     GIR_EraseRootFromParent_Done,
     /*  810856 */   // Label 12549: @810856
     /*  810856 */   GIM_Try, /*On fail goto*//*Label 12550*/ GIMT_Encode4(810931), // Rule ID 22107 //
     /*  810861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  810878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810907 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  810910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810929 */     GIR_RootConstrainSelectedInstOperands,
     /*  810930 */     // GIR_Coverage, 22107,
     /*  810930 */     GIR_EraseRootFromParent_Done,
     /*  810931 */   // Label 12550: @810931
     /*  810931 */   GIM_Try, /*On fail goto*//*Label 12551*/ GIMT_Encode4(811006), // Rule ID 22110 //
     /*  810936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  810953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  810985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811004 */     GIR_RootConstrainSelectedInstOperands,
     /*  811005 */     // GIR_Coverage, 22110,
     /*  811005 */     GIR_EraseRootFromParent_Done,
     /*  811006 */   // Label 12551: @811006
     /*  811006 */   GIM_Try, /*On fail goto*//*Label 12552*/ GIMT_Encode4(811081), // Rule ID 22111 //
     /*  811011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  811028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811057 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  811060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811079 */     GIR_RootConstrainSelectedInstOperands,
     /*  811080 */     // GIR_Coverage, 22111,
     /*  811080 */     GIR_EraseRootFromParent_Done,
     /*  811081 */   // Label 12552: @811081
     /*  811081 */   GIM_Try, /*On fail goto*//*Label 12553*/ GIMT_Encode4(811156), // Rule ID 22114 //
     /*  811086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  811103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811132 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  811132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  811135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811154 */     GIR_RootConstrainSelectedInstOperands,
     /*  811155 */     // GIR_Coverage, 22114,
     /*  811155 */     GIR_EraseRootFromParent_Done,
     /*  811156 */   // Label 12553: @811156
     /*  811156 */   GIM_Try, /*On fail goto*//*Label 12554*/ GIMT_Encode4(811231), // Rule ID 22115 //
     /*  811161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  811178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811207 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  811207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  811210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811229 */     GIR_RootConstrainSelectedInstOperands,
     /*  811230 */     // GIR_Coverage, 22115,
     /*  811230 */     GIR_EraseRootFromParent_Done,
     /*  811231 */   // Label 12554: @811231
     /*  811231 */   GIM_Try, /*On fail goto*//*Label 12555*/ GIMT_Encode4(811306), // Rule ID 22118 //
     /*  811236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  811239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  811247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  811250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  811253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  811256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  811282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  811285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  811301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811304 */     GIR_RootConstrainSelectedInstOperands,
     /*  811305 */     // GIR_Coverage, 22118,
     /*  811305 */     GIR_EraseRootFromParent_Done,
     /*  811306 */   // Label 12555: @811306
     /*  811306 */   GIM_Try, /*On fail goto*//*Label 12556*/ GIMT_Encode4(811381), // Rule ID 22119 //
     /*  811311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  811314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  811322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  811325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  811328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  811331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811357 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  811357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  811360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  811376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811379 */     GIR_RootConstrainSelectedInstOperands,
     /*  811380 */     // GIR_Coverage, 22119,
     /*  811380 */     GIR_EraseRootFromParent_Done,
     /*  811381 */   // Label 12556: @811381
     /*  811381 */   GIM_Try, /*On fail goto*//*Label 12557*/ GIMT_Encode4(811456), // Rule ID 22122 //
     /*  811386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  811403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  811435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811454 */     GIR_RootConstrainSelectedInstOperands,
     /*  811455 */     // GIR_Coverage, 22122,
     /*  811455 */     GIR_EraseRootFromParent_Done,
     /*  811456 */   // Label 12557: @811456
     /*  811456 */   GIM_Try, /*On fail goto*//*Label 12558*/ GIMT_Encode4(811531), // Rule ID 22123 //
     /*  811461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  811478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811507 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  811510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811529 */     GIR_RootConstrainSelectedInstOperands,
     /*  811530 */     // GIR_Coverage, 22123,
     /*  811530 */     GIR_EraseRootFromParent_Done,
     /*  811531 */   // Label 12558: @811531
     /*  811531 */   GIM_Try, /*On fail goto*//*Label 12559*/ GIMT_Encode4(811606), // Rule ID 22126 //
     /*  811536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  811553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  811585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811604 */     GIR_RootConstrainSelectedInstOperands,
     /*  811605 */     // GIR_Coverage, 22126,
     /*  811605 */     GIR_EraseRootFromParent_Done,
     /*  811606 */   // Label 12559: @811606
     /*  811606 */   GIM_Try, /*On fail goto*//*Label 12560*/ GIMT_Encode4(811681), // Rule ID 22127 //
     /*  811611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  811628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811657 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  811660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811679 */     GIR_RootConstrainSelectedInstOperands,
     /*  811680 */     // GIR_Coverage, 22127,
     /*  811680 */     GIR_EraseRootFromParent_Done,
     /*  811681 */   // Label 12560: @811681
     /*  811681 */   GIM_Try, /*On fail goto*//*Label 12561*/ GIMT_Encode4(811756), // Rule ID 22130 //
     /*  811686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  811703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  811735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811754 */     GIR_RootConstrainSelectedInstOperands,
     /*  811755 */     // GIR_Coverage, 22130,
     /*  811755 */     GIR_EraseRootFromParent_Done,
     /*  811756 */   // Label 12561: @811756
     /*  811756 */   GIM_Try, /*On fail goto*//*Label 12562*/ GIMT_Encode4(811831), // Rule ID 22131 //
     /*  811761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  811778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811807 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  811810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811829 */     GIR_RootConstrainSelectedInstOperands,
     /*  811830 */     // GIR_Coverage, 22131,
     /*  811830 */     GIR_EraseRootFromParent_Done,
     /*  811831 */   // Label 12562: @811831
     /*  811831 */   GIM_Try, /*On fail goto*//*Label 12563*/ GIMT_Encode4(811906), // Rule ID 22134 //
     /*  811836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  811853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  811885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811904 */     GIR_RootConstrainSelectedInstOperands,
     /*  811905 */     // GIR_Coverage, 22134,
     /*  811905 */     GIR_EraseRootFromParent_Done,
     /*  811906 */   // Label 12563: @811906
     /*  811906 */   GIM_Try, /*On fail goto*//*Label 12564*/ GIMT_Encode4(811981), // Rule ID 22135 //
     /*  811911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  811928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811957 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  811960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811979 */     GIR_RootConstrainSelectedInstOperands,
     /*  811980 */     // GIR_Coverage, 22135,
     /*  811980 */     GIR_EraseRootFromParent_Done,
     /*  811981 */   // Label 12564: @811981
     /*  811981 */   GIM_Try, /*On fail goto*//*Label 12565*/ GIMT_Encode4(812056), // Rule ID 22138 //
     /*  811986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  812003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  812032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  812035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812054 */     GIR_RootConstrainSelectedInstOperands,
     /*  812055 */     // GIR_Coverage, 22138,
     /*  812055 */     GIR_EraseRootFromParent_Done,
     /*  812056 */   // Label 12565: @812056
     /*  812056 */   GIM_Try, /*On fail goto*//*Label 12566*/ GIMT_Encode4(812131), // Rule ID 22139 //
     /*  812061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  812078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812107 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  812107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  812110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812129 */     GIR_RootConstrainSelectedInstOperands,
     /*  812130 */     // GIR_Coverage, 22139,
     /*  812130 */     GIR_EraseRootFromParent_Done,
     /*  812131 */   // Label 12566: @812131
     /*  812131 */   GIM_Try, /*On fail goto*//*Label 12567*/ GIMT_Encode4(812206), // Rule ID 22142 //
     /*  812136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  812153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  812182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  812185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812204 */     GIR_RootConstrainSelectedInstOperands,
     /*  812205 */     // GIR_Coverage, 22142,
     /*  812205 */     GIR_EraseRootFromParent_Done,
     /*  812206 */   // Label 12567: @812206
     /*  812206 */   GIM_Try, /*On fail goto*//*Label 12568*/ GIMT_Encode4(812281), // Rule ID 22143 //
     /*  812211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  812228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812257 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  812257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  812260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812279 */     GIR_RootConstrainSelectedInstOperands,
     /*  812280 */     // GIR_Coverage, 22143,
     /*  812280 */     GIR_EraseRootFromParent_Done,
     /*  812281 */   // Label 12568: @812281
     /*  812281 */   GIM_Try, /*On fail goto*//*Label 12569*/ GIMT_Encode4(812356), // Rule ID 22146 //
     /*  812286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  812303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812332 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  812335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812354 */     GIR_RootConstrainSelectedInstOperands,
     /*  812355 */     // GIR_Coverage, 22146,
     /*  812355 */     GIR_EraseRootFromParent_Done,
     /*  812356 */   // Label 12569: @812356
     /*  812356 */   GIM_Try, /*On fail goto*//*Label 12570*/ GIMT_Encode4(812431), // Rule ID 22147 //
     /*  812361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  812378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812407 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  812410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812429 */     GIR_RootConstrainSelectedInstOperands,
     /*  812430 */     // GIR_Coverage, 22147,
     /*  812430 */     GIR_EraseRootFromParent_Done,
     /*  812431 */   // Label 12570: @812431
     /*  812431 */   GIM_Try, /*On fail goto*//*Label 12571*/ GIMT_Encode4(812506), // Rule ID 22150 //
     /*  812436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  812453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812482 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  812485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812504 */     GIR_RootConstrainSelectedInstOperands,
     /*  812505 */     // GIR_Coverage, 22150,
     /*  812505 */     GIR_EraseRootFromParent_Done,
     /*  812506 */   // Label 12571: @812506
     /*  812506 */   GIM_Try, /*On fail goto*//*Label 12572*/ GIMT_Encode4(812581), // Rule ID 22151 //
     /*  812511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  812528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812557 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  812560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812579 */     GIR_RootConstrainSelectedInstOperands,
     /*  812580 */     // GIR_Coverage, 22151,
     /*  812580 */     GIR_EraseRootFromParent_Done,
     /*  812581 */   // Label 12572: @812581
     /*  812581 */   GIM_Try, /*On fail goto*//*Label 12573*/ GIMT_Encode4(812656), // Rule ID 22154 //
     /*  812586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  812603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812632 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  812635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812654 */     GIR_RootConstrainSelectedInstOperands,
     /*  812655 */     // GIR_Coverage, 22154,
     /*  812655 */     GIR_EraseRootFromParent_Done,
     /*  812656 */   // Label 12573: @812656
     /*  812656 */   GIM_Try, /*On fail goto*//*Label 12574*/ GIMT_Encode4(812731), // Rule ID 22155 //
     /*  812661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  812678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812707 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  812710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812729 */     GIR_RootConstrainSelectedInstOperands,
     /*  812730 */     // GIR_Coverage, 22155,
     /*  812730 */     GIR_EraseRootFromParent_Done,
     /*  812731 */   // Label 12574: @812731
     /*  812731 */   GIM_Try, /*On fail goto*//*Label 12575*/ GIMT_Encode4(812806), // Rule ID 22158 //
     /*  812736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  812753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812782 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  812785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812804 */     GIR_RootConstrainSelectedInstOperands,
     /*  812805 */     // GIR_Coverage, 22158,
     /*  812805 */     GIR_EraseRootFromParent_Done,
     /*  812806 */   // Label 12575: @812806
     /*  812806 */   GIM_Try, /*On fail goto*//*Label 12576*/ GIMT_Encode4(812881), // Rule ID 22159 //
     /*  812811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  812828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812857 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  812860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812879 */     GIR_RootConstrainSelectedInstOperands,
     /*  812880 */     // GIR_Coverage, 22159,
     /*  812880 */     GIR_EraseRootFromParent_Done,
     /*  812881 */   // Label 12576: @812881
     /*  812881 */   GIM_Try, /*On fail goto*//*Label 12577*/ GIMT_Encode4(812956), // Rule ID 22162 //
     /*  812886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  812903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812932 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  812935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812954 */     GIR_RootConstrainSelectedInstOperands,
     /*  812955 */     // GIR_Coverage, 22162,
     /*  812955 */     GIR_EraseRootFromParent_Done,
     /*  812956 */   // Label 12577: @812956
     /*  812956 */   GIM_Try, /*On fail goto*//*Label 12578*/ GIMT_Encode4(813031), // Rule ID 22163 //
     /*  812961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  812978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813007 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  813007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  813010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813029 */     GIR_RootConstrainSelectedInstOperands,
     /*  813030 */     // GIR_Coverage, 22163,
     /*  813030 */     GIR_EraseRootFromParent_Done,
     /*  813031 */   // Label 12578: @813031
     /*  813031 */   GIM_Try, /*On fail goto*//*Label 12579*/ GIMT_Encode4(813106), // Rule ID 22166 //
     /*  813036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  813039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  813050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  813053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  813082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  813085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813104 */     GIR_RootConstrainSelectedInstOperands,
     /*  813105 */     // GIR_Coverage, 22166,
     /*  813105 */     GIR_EraseRootFromParent_Done,
     /*  813106 */   // Label 12579: @813106
     /*  813106 */   GIM_Try, /*On fail goto*//*Label 12580*/ GIMT_Encode4(813181), // Rule ID 22167 //
     /*  813111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  813114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  813125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  813128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813157 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  813157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  813160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813179 */     GIR_RootConstrainSelectedInstOperands,
     /*  813180 */     // GIR_Coverage, 22167,
     /*  813180 */     GIR_EraseRootFromParent_Done,
     /*  813181 */   // Label 12580: @813181
     /*  813181 */   GIM_Try, /*On fail goto*//*Label 12581*/ GIMT_Encode4(813256), // Rule ID 22170 //
     /*  813186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  813203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  813235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813254 */     GIR_RootConstrainSelectedInstOperands,
     /*  813255 */     // GIR_Coverage, 22170,
     /*  813255 */     GIR_EraseRootFromParent_Done,
     /*  813256 */   // Label 12581: @813256
     /*  813256 */   GIM_Try, /*On fail goto*//*Label 12582*/ GIMT_Encode4(813331), // Rule ID 22171 //
     /*  813261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  813278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813307 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  813310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813329 */     GIR_RootConstrainSelectedInstOperands,
     /*  813330 */     // GIR_Coverage, 22171,
     /*  813330 */     GIR_EraseRootFromParent_Done,
     /*  813331 */   // Label 12582: @813331
     /*  813331 */   GIM_Try, /*On fail goto*//*Label 12583*/ GIMT_Encode4(813406), // Rule ID 22174 //
     /*  813336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  813353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813382 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  813385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813404 */     GIR_RootConstrainSelectedInstOperands,
     /*  813405 */     // GIR_Coverage, 22174,
     /*  813405 */     GIR_EraseRootFromParent_Done,
     /*  813406 */   // Label 12583: @813406
     /*  813406 */   GIM_Try, /*On fail goto*//*Label 12584*/ GIMT_Encode4(813481), // Rule ID 22175 //
     /*  813411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  813428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813457 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  813460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813479 */     GIR_RootConstrainSelectedInstOperands,
     /*  813480 */     // GIR_Coverage, 22175,
     /*  813480 */     GIR_EraseRootFromParent_Done,
     /*  813481 */   // Label 12584: @813481
     /*  813481 */   GIM_Try, /*On fail goto*//*Label 12585*/ GIMT_Encode4(813556), // Rule ID 22178 //
     /*  813486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  813503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813532 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  813535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813554 */     GIR_RootConstrainSelectedInstOperands,
     /*  813555 */     // GIR_Coverage, 22178,
     /*  813555 */     GIR_EraseRootFromParent_Done,
     /*  813556 */   // Label 12585: @813556
     /*  813556 */   GIM_Try, /*On fail goto*//*Label 12586*/ GIMT_Encode4(813631), // Rule ID 22179 //
     /*  813561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  813578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813607 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  813610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813629 */     GIR_RootConstrainSelectedInstOperands,
     /*  813630 */     // GIR_Coverage, 22179,
     /*  813630 */     GIR_EraseRootFromParent_Done,
     /*  813631 */   // Label 12586: @813631
     /*  813631 */   GIM_Try, /*On fail goto*//*Label 12587*/ GIMT_Encode4(813706), // Rule ID 22182 //
     /*  813636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  813653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  813685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813704 */     GIR_RootConstrainSelectedInstOperands,
     /*  813705 */     // GIR_Coverage, 22182,
     /*  813705 */     GIR_EraseRootFromParent_Done,
     /*  813706 */   // Label 12587: @813706
     /*  813706 */   GIM_Try, /*On fail goto*//*Label 12588*/ GIMT_Encode4(813781), // Rule ID 22183 //
     /*  813711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  813728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813757 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  813760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813779 */     GIR_RootConstrainSelectedInstOperands,
     /*  813780 */     // GIR_Coverage, 22183,
     /*  813780 */     GIR_EraseRootFromParent_Done,
     /*  813781 */   // Label 12588: @813781
     /*  813781 */   GIM_Try, /*On fail goto*//*Label 12589*/ GIMT_Encode4(813856), // Rule ID 22186 //
     /*  813786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  813803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813832 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  813835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813854 */     GIR_RootConstrainSelectedInstOperands,
     /*  813855 */     // GIR_Coverage, 22186,
     /*  813855 */     GIR_EraseRootFromParent_Done,
     /*  813856 */   // Label 12589: @813856
     /*  813856 */   GIM_Try, /*On fail goto*//*Label 12590*/ GIMT_Encode4(813931), // Rule ID 22187 //
     /*  813861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  813878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813907 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  813910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813929 */     GIR_RootConstrainSelectedInstOperands,
     /*  813930 */     // GIR_Coverage, 22187,
     /*  813930 */     GIR_EraseRootFromParent_Done,
     /*  813931 */   // Label 12590: @813931
     /*  813931 */   GIM_Try, /*On fail goto*//*Label 12591*/ GIMT_Encode4(814006), // Rule ID 22190 //
     /*  813936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  813950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  813953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813982 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  813982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  813985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814004 */     GIR_RootConstrainSelectedInstOperands,
     /*  814005 */     // GIR_Coverage, 22190,
     /*  814005 */     GIR_EraseRootFromParent_Done,
     /*  814006 */   // Label 12591: @814006
     /*  814006 */   GIM_Try, /*On fail goto*//*Label 12592*/ GIMT_Encode4(814081), // Rule ID 22191 //
     /*  814011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  814028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814057 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  814057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  814060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814079 */     GIR_RootConstrainSelectedInstOperands,
     /*  814080 */     // GIR_Coverage, 22191,
     /*  814080 */     GIR_EraseRootFromParent_Done,
     /*  814081 */   // Label 12592: @814081
     /*  814081 */   GIM_Try, /*On fail goto*//*Label 12593*/ GIMT_Encode4(814156), // Rule ID 22194 //
     /*  814086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  814103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  814135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814154 */     GIR_RootConstrainSelectedInstOperands,
     /*  814155 */     // GIR_Coverage, 22194,
     /*  814155 */     GIR_EraseRootFromParent_Done,
     /*  814156 */   // Label 12593: @814156
     /*  814156 */   GIM_Try, /*On fail goto*//*Label 12594*/ GIMT_Encode4(814231), // Rule ID 22195 //
     /*  814161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  814178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814207 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  814210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814229 */     GIR_RootConstrainSelectedInstOperands,
     /*  814230 */     // GIR_Coverage, 22195,
     /*  814230 */     GIR_EraseRootFromParent_Done,
     /*  814231 */   // Label 12594: @814231
     /*  814231 */   GIM_Try, /*On fail goto*//*Label 12595*/ GIMT_Encode4(814306), // Rule ID 22198 //
     /*  814236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  814253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814282 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  814282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  814285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814304 */     GIR_RootConstrainSelectedInstOperands,
     /*  814305 */     // GIR_Coverage, 22198,
     /*  814305 */     GIR_EraseRootFromParent_Done,
     /*  814306 */   // Label 12595: @814306
     /*  814306 */   GIM_Try, /*On fail goto*//*Label 12596*/ GIMT_Encode4(814381), // Rule ID 22199 //
     /*  814311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  814328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814357 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  814357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  814360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814379 */     GIR_RootConstrainSelectedInstOperands,
     /*  814380 */     // GIR_Coverage, 22199,
     /*  814380 */     GIR_EraseRootFromParent_Done,
     /*  814381 */   // Label 12596: @814381
     /*  814381 */   GIM_Try, /*On fail goto*//*Label 12597*/ GIMT_Encode4(814456), // Rule ID 22202 //
     /*  814386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  814403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  814432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  814435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814454 */     GIR_RootConstrainSelectedInstOperands,
     /*  814455 */     // GIR_Coverage, 22202,
     /*  814455 */     GIR_EraseRootFromParent_Done,
     /*  814456 */   // Label 12597: @814456
     /*  814456 */   GIM_Try, /*On fail goto*//*Label 12598*/ GIMT_Encode4(814531), // Rule ID 22203 //
     /*  814461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  814478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814507 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  814507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  814510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814529 */     GIR_RootConstrainSelectedInstOperands,
     /*  814530 */     // GIR_Coverage, 22203,
     /*  814530 */     GIR_EraseRootFromParent_Done,
     /*  814531 */   // Label 12598: @814531
     /*  814531 */   GIM_Try, /*On fail goto*//*Label 12599*/ GIMT_Encode4(814606), // Rule ID 22206 //
     /*  814536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  814539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  814547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  814550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  814553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  814556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814582 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  814582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  814585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  814601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814604 */     GIR_RootConstrainSelectedInstOperands,
     /*  814605 */     // GIR_Coverage, 22206,
     /*  814605 */     GIR_EraseRootFromParent_Done,
     /*  814606 */   // Label 12599: @814606
     /*  814606 */   GIM_Try, /*On fail goto*//*Label 12600*/ GIMT_Encode4(814681), // Rule ID 22207 //
     /*  814611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  814614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  814622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  814625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  814628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  814631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814657 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  814657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  814660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  814676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814679 */     GIR_RootConstrainSelectedInstOperands,
     /*  814680 */     // GIR_Coverage, 22207,
     /*  814680 */     GIR_EraseRootFromParent_Done,
     /*  814681 */   // Label 12600: @814681
     /*  814681 */   GIM_Try, /*On fail goto*//*Label 12601*/ GIMT_Encode4(814756), // Rule ID 22210 //
     /*  814686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  814703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  814735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814754 */     GIR_RootConstrainSelectedInstOperands,
     /*  814755 */     // GIR_Coverage, 22210,
     /*  814755 */     GIR_EraseRootFromParent_Done,
     /*  814756 */   // Label 12601: @814756
     /*  814756 */   GIM_Try, /*On fail goto*//*Label 12602*/ GIMT_Encode4(814831), // Rule ID 22211 //
     /*  814761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  814778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814807 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  814810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814829 */     GIR_RootConstrainSelectedInstOperands,
     /*  814830 */     // GIR_Coverage, 22211,
     /*  814830 */     GIR_EraseRootFromParent_Done,
     /*  814831 */   // Label 12602: @814831
     /*  814831 */   GIM_Try, /*On fail goto*//*Label 12603*/ GIMT_Encode4(814906), // Rule ID 22214 //
     /*  814836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  814853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814882 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  814885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814904 */     GIR_RootConstrainSelectedInstOperands,
     /*  814905 */     // GIR_Coverage, 22214,
     /*  814905 */     GIR_EraseRootFromParent_Done,
     /*  814906 */   // Label 12603: @814906
     /*  814906 */   GIM_Try, /*On fail goto*//*Label 12604*/ GIMT_Encode4(814981), // Rule ID 22215 //
     /*  814911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  814928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814957 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  814960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814979 */     GIR_RootConstrainSelectedInstOperands,
     /*  814980 */     // GIR_Coverage, 22215,
     /*  814980 */     GIR_EraseRootFromParent_Done,
     /*  814981 */   // Label 12604: @814981
     /*  814981 */   GIM_Try, /*On fail goto*//*Label 12605*/ GIMT_Encode4(815056), // Rule ID 22218 //
     /*  814986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  815003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  815032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  815035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815054 */     GIR_RootConstrainSelectedInstOperands,
     /*  815055 */     // GIR_Coverage, 22218,
     /*  815055 */     GIR_EraseRootFromParent_Done,
     /*  815056 */   // Label 12605: @815056
     /*  815056 */   GIM_Try, /*On fail goto*//*Label 12606*/ GIMT_Encode4(815131), // Rule ID 22219 //
     /*  815061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  815072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  815078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815107 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  815107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  815110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815129 */     GIR_RootConstrainSelectedInstOperands,
     /*  815130 */     // GIR_Coverage, 22219,
     /*  815130 */     GIR_EraseRootFromParent_Done,
     /*  815131 */   // Label 12606: @815131
     /*  815131 */   GIM_Try, /*On fail goto*//*Label 12607*/ GIMT_Encode4(815206), // Rule ID 22222 //
     /*  815136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  815153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  815185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815204 */     GIR_RootConstrainSelectedInstOperands,
     /*  815205 */     // GIR_Coverage, 22222,
     /*  815205 */     GIR_EraseRootFromParent_Done,
     /*  815206 */   // Label 12607: @815206
     /*  815206 */   GIM_Try, /*On fail goto*//*Label 12608*/ GIMT_Encode4(815281), // Rule ID 22223 //
     /*  815211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  815228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815257 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  815260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815279 */     GIR_RootConstrainSelectedInstOperands,
     /*  815280 */     // GIR_Coverage, 22223,
     /*  815280 */     GIR_EraseRootFromParent_Done,
     /*  815281 */   // Label 12608: @815281
     /*  815281 */   GIM_Try, /*On fail goto*//*Label 12609*/ GIMT_Encode4(815356), // Rule ID 22226 //
     /*  815286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  815303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  815335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815354 */     GIR_RootConstrainSelectedInstOperands,
     /*  815355 */     // GIR_Coverage, 22226,
     /*  815355 */     GIR_EraseRootFromParent_Done,
     /*  815356 */   // Label 12609: @815356
     /*  815356 */   GIM_Try, /*On fail goto*//*Label 12610*/ GIMT_Encode4(815431), // Rule ID 22227 //
     /*  815361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  815378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815407 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  815410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815429 */     GIR_RootConstrainSelectedInstOperands,
     /*  815430 */     // GIR_Coverage, 22227,
     /*  815430 */     GIR_EraseRootFromParent_Done,
     /*  815431 */   // Label 12610: @815431
     /*  815431 */   GIM_Try, /*On fail goto*//*Label 12611*/ GIMT_Encode4(815506), // Rule ID 22230 //
     /*  815436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  815453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815482 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  815485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815504 */     GIR_RootConstrainSelectedInstOperands,
     /*  815505 */     // GIR_Coverage, 22230,
     /*  815505 */     GIR_EraseRootFromParent_Done,
     /*  815506 */   // Label 12611: @815506
     /*  815506 */   GIM_Try, /*On fail goto*//*Label 12612*/ GIMT_Encode4(815581), // Rule ID 22231 //
     /*  815511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  815528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815557 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  815560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815579 */     GIR_RootConstrainSelectedInstOperands,
     /*  815580 */     // GIR_Coverage, 22231,
     /*  815580 */     GIR_EraseRootFromParent_Done,
     /*  815581 */   // Label 12612: @815581
     /*  815581 */   GIM_Try, /*On fail goto*//*Label 12613*/ GIMT_Encode4(815656), // Rule ID 22234 //
     /*  815586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  815603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815632 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  815635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815654 */     GIR_RootConstrainSelectedInstOperands,
     /*  815655 */     // GIR_Coverage, 22234,
     /*  815655 */     GIR_EraseRootFromParent_Done,
     /*  815656 */   // Label 12613: @815656
     /*  815656 */   GIM_Try, /*On fail goto*//*Label 12614*/ GIMT_Encode4(815731), // Rule ID 22235 //
     /*  815661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  815678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815707 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  815710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815729 */     GIR_RootConstrainSelectedInstOperands,
     /*  815730 */     // GIR_Coverage, 22235,
     /*  815730 */     GIR_EraseRootFromParent_Done,
     /*  815731 */   // Label 12614: @815731
     /*  815731 */   GIM_Try, /*On fail goto*//*Label 12615*/ GIMT_Encode4(815806), // Rule ID 22238 //
     /*  815736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  815753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815782 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  815785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815804 */     GIR_RootConstrainSelectedInstOperands,
     /*  815805 */     // GIR_Coverage, 22238,
     /*  815805 */     GIR_EraseRootFromParent_Done,
     /*  815806 */   // Label 12615: @815806
     /*  815806 */   GIM_Try, /*On fail goto*//*Label 12616*/ GIMT_Encode4(815881), // Rule ID 22239 //
     /*  815811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  815828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815857 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  815860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815879 */     GIR_RootConstrainSelectedInstOperands,
     /*  815880 */     // GIR_Coverage, 22239,
     /*  815880 */     GIR_EraseRootFromParent_Done,
     /*  815881 */   // Label 12616: @815881
     /*  815881 */   GIM_Try, /*On fail goto*//*Label 12617*/ GIMT_Encode4(815956), // Rule ID 22242 //
     /*  815886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  815903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815932 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  815935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815954 */     GIR_RootConstrainSelectedInstOperands,
     /*  815955 */     // GIR_Coverage, 22242,
     /*  815955 */     GIR_EraseRootFromParent_Done,
     /*  815956 */   // Label 12617: @815956
     /*  815956 */   GIM_Try, /*On fail goto*//*Label 12618*/ GIMT_Encode4(816031), // Rule ID 22243 //
     /*  815961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  815978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816007 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  816007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  816010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816029 */     GIR_RootConstrainSelectedInstOperands,
     /*  816030 */     // GIR_Coverage, 22243,
     /*  816030 */     GIR_EraseRootFromParent_Done,
     /*  816031 */   // Label 12618: @816031
     /*  816031 */   GIM_Try, /*On fail goto*//*Label 12619*/ GIMT_Encode4(816106), // Rule ID 22246 //
     /*  816036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  816053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  816085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816104 */     GIR_RootConstrainSelectedInstOperands,
     /*  816105 */     // GIR_Coverage, 22246,
     /*  816105 */     GIR_EraseRootFromParent_Done,
     /*  816106 */   // Label 12619: @816106
     /*  816106 */   GIM_Try, /*On fail goto*//*Label 12620*/ GIMT_Encode4(816181), // Rule ID 22247 //
     /*  816111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  816128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816157 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  816160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816179 */     GIR_RootConstrainSelectedInstOperands,
     /*  816180 */     // GIR_Coverage, 22247,
     /*  816180 */     GIR_EraseRootFromParent_Done,
     /*  816181 */   // Label 12620: @816181
     /*  816181 */   GIM_Try, /*On fail goto*//*Label 12621*/ GIMT_Encode4(816256), // Rule ID 22250 //
     /*  816186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  816203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816232 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  816235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816254 */     GIR_RootConstrainSelectedInstOperands,
     /*  816255 */     // GIR_Coverage, 22250,
     /*  816255 */     GIR_EraseRootFromParent_Done,
     /*  816256 */   // Label 12621: @816256
     /*  816256 */   GIM_Try, /*On fail goto*//*Label 12622*/ GIMT_Encode4(816331), // Rule ID 22251 //
     /*  816261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  816278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816307 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  816310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816329 */     GIR_RootConstrainSelectedInstOperands,
     /*  816330 */     // GIR_Coverage, 22251,
     /*  816330 */     GIR_EraseRootFromParent_Done,
     /*  816331 */   // Label 12622: @816331
     /*  816331 */   GIM_Try, /*On fail goto*//*Label 12623*/ GIMT_Encode4(816406), // Rule ID 22254 //
     /*  816336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  816353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816382 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  816385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816404 */     GIR_RootConstrainSelectedInstOperands,
     /*  816405 */     // GIR_Coverage, 22254,
     /*  816405 */     GIR_EraseRootFromParent_Done,
     /*  816406 */   // Label 12623: @816406
     /*  816406 */   GIM_Try, /*On fail goto*//*Label 12624*/ GIMT_Encode4(816481), // Rule ID 22255 //
     /*  816411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  816428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816457 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  816460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816479 */     GIR_RootConstrainSelectedInstOperands,
     /*  816480 */     // GIR_Coverage, 22255,
     /*  816480 */     GIR_EraseRootFromParent_Done,
     /*  816481 */   // Label 12624: @816481
     /*  816481 */   GIM_Try, /*On fail goto*//*Label 12625*/ GIMT_Encode4(816556), // Rule ID 22258 //
     /*  816486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  816503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816532 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  816535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816554 */     GIR_RootConstrainSelectedInstOperands,
     /*  816555 */     // GIR_Coverage, 22258,
     /*  816555 */     GIR_EraseRootFromParent_Done,
     /*  816556 */   // Label 12625: @816556
     /*  816556 */   GIM_Try, /*On fail goto*//*Label 12626*/ GIMT_Encode4(816631), // Rule ID 22259 //
     /*  816561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  816578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816607 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  816610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816629 */     GIR_RootConstrainSelectedInstOperands,
     /*  816630 */     // GIR_Coverage, 22259,
     /*  816630 */     GIR_EraseRootFromParent_Done,
     /*  816631 */   // Label 12626: @816631
     /*  816631 */   GIM_Try, /*On fail goto*//*Label 12627*/ GIMT_Encode4(816706), // Rule ID 22262 //
     /*  816636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  816653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816682 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  816685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816704 */     GIR_RootConstrainSelectedInstOperands,
     /*  816705 */     // GIR_Coverage, 22262,
     /*  816705 */     GIR_EraseRootFromParent_Done,
     /*  816706 */   // Label 12627: @816706
     /*  816706 */   GIM_Try, /*On fail goto*//*Label 12628*/ GIMT_Encode4(816781), // Rule ID 22263 //
     /*  816711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  816728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816757 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  816760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816779 */     GIR_RootConstrainSelectedInstOperands,
     /*  816780 */     // GIR_Coverage, 22263,
     /*  816780 */     GIR_EraseRootFromParent_Done,
     /*  816781 */   // Label 12628: @816781
     /*  816781 */   GIM_Try, /*On fail goto*//*Label 12629*/ GIMT_Encode4(816856), // Rule ID 22266 //
     /*  816786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  816803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816832 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  816835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816854 */     GIR_RootConstrainSelectedInstOperands,
     /*  816855 */     // GIR_Coverage, 22266,
     /*  816855 */     GIR_EraseRootFromParent_Done,
     /*  816856 */   // Label 12629: @816856
     /*  816856 */   GIM_Try, /*On fail goto*//*Label 12630*/ GIMT_Encode4(816931), // Rule ID 22267 //
     /*  816861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  816878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816907 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  816910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816929 */     GIR_RootConstrainSelectedInstOperands,
     /*  816930 */     // GIR_Coverage, 22267,
     /*  816930 */     GIR_EraseRootFromParent_Done,
     /*  816931 */   // Label 12630: @816931
     /*  816931 */   GIM_Try, /*On fail goto*//*Label 12631*/ GIMT_Encode4(817006), // Rule ID 22270 //
     /*  816936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  816953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  816982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  816985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817004 */     GIR_RootConstrainSelectedInstOperands,
     /*  817005 */     // GIR_Coverage, 22270,
     /*  817005 */     GIR_EraseRootFromParent_Done,
     /*  817006 */   // Label 12631: @817006
     /*  817006 */   GIM_Try, /*On fail goto*//*Label 12632*/ GIMT_Encode4(817081), // Rule ID 22271 //
     /*  817011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  817028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817057 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  817060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817079 */     GIR_RootConstrainSelectedInstOperands,
     /*  817080 */     // GIR_Coverage, 22271,
     /*  817080 */     GIR_EraseRootFromParent_Done,
     /*  817081 */   // Label 12632: @817081
     /*  817081 */   GIM_Try, /*On fail goto*//*Label 12633*/ GIMT_Encode4(817156), // Rule ID 22274 //
     /*  817086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  817103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817132 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  817135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817154 */     GIR_RootConstrainSelectedInstOperands,
     /*  817155 */     // GIR_Coverage, 22274,
     /*  817155 */     GIR_EraseRootFromParent_Done,
     /*  817156 */   // Label 12633: @817156
     /*  817156 */   GIM_Try, /*On fail goto*//*Label 12634*/ GIMT_Encode4(817231), // Rule ID 22275 //
     /*  817161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  817178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817207 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  817210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817229 */     GIR_RootConstrainSelectedInstOperands,
     /*  817230 */     // GIR_Coverage, 22275,
     /*  817230 */     GIR_EraseRootFromParent_Done,
     /*  817231 */   // Label 12634: @817231
     /*  817231 */   GIM_Try, /*On fail goto*//*Label 12635*/ GIMT_Encode4(817306), // Rule ID 22278 //
     /*  817236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  817253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817282 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  817282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  817285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817304 */     GIR_RootConstrainSelectedInstOperands,
     /*  817305 */     // GIR_Coverage, 22278,
     /*  817305 */     GIR_EraseRootFromParent_Done,
     /*  817306 */   // Label 12635: @817306
     /*  817306 */   GIM_Try, /*On fail goto*//*Label 12636*/ GIMT_Encode4(817381), // Rule ID 22279 //
     /*  817311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  817328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817357 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  817357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  817360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817379 */     GIR_RootConstrainSelectedInstOperands,
     /*  817380 */     // GIR_Coverage, 22279,
     /*  817380 */     GIR_EraseRootFromParent_Done,
     /*  817381 */   // Label 12636: @817381
     /*  817381 */   GIM_Try, /*On fail goto*//*Label 12637*/ GIMT_Encode4(817456), // Rule ID 22282 //
     /*  817386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  817403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  817435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817454 */     GIR_RootConstrainSelectedInstOperands,
     /*  817455 */     // GIR_Coverage, 22282,
     /*  817455 */     GIR_EraseRootFromParent_Done,
     /*  817456 */   // Label 12637: @817456
     /*  817456 */   GIM_Try, /*On fail goto*//*Label 12638*/ GIMT_Encode4(817531), // Rule ID 22283 //
     /*  817461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  817478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817507 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  817510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817529 */     GIR_RootConstrainSelectedInstOperands,
     /*  817530 */     // GIR_Coverage, 22283,
     /*  817530 */     GIR_EraseRootFromParent_Done,
     /*  817531 */   // Label 12638: @817531
     /*  817531 */   GIM_Try, /*On fail goto*//*Label 12639*/ GIMT_Encode4(817606), // Rule ID 22286 //
     /*  817536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  817553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817582 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  817585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817604 */     GIR_RootConstrainSelectedInstOperands,
     /*  817605 */     // GIR_Coverage, 22286,
     /*  817605 */     GIR_EraseRootFromParent_Done,
     /*  817606 */   // Label 12639: @817606
     /*  817606 */   GIM_Try, /*On fail goto*//*Label 12640*/ GIMT_Encode4(817681), // Rule ID 22287 //
     /*  817611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  817628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817657 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  817660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817679 */     GIR_RootConstrainSelectedInstOperands,
     /*  817680 */     // GIR_Coverage, 22287,
     /*  817680 */     GIR_EraseRootFromParent_Done,
     /*  817681 */   // Label 12640: @817681
     /*  817681 */   GIM_Try, /*On fail goto*//*Label 12641*/ GIMT_Encode4(817756), // Rule ID 22290 //
     /*  817686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  817703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817732 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  817732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  817735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817754 */     GIR_RootConstrainSelectedInstOperands,
     /*  817755 */     // GIR_Coverage, 22290,
     /*  817755 */     GIR_EraseRootFromParent_Done,
     /*  817756 */   // Label 12641: @817756
     /*  817756 */   GIM_Try, /*On fail goto*//*Label 12642*/ GIMT_Encode4(817831), // Rule ID 22291 //
     /*  817761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  817778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817807 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  817807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  817810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817829 */     GIR_RootConstrainSelectedInstOperands,
     /*  817830 */     // GIR_Coverage, 22291,
     /*  817830 */     GIR_EraseRootFromParent_Done,
     /*  817831 */   // Label 12642: @817831
     /*  817831 */   GIM_Try, /*On fail goto*//*Label 12643*/ GIMT_Encode4(817906), // Rule ID 22294 //
     /*  817836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  817839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  817850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  817856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817882 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  817882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  817885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  817901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817904 */     GIR_RootConstrainSelectedInstOperands,
     /*  817905 */     // GIR_Coverage, 22294,
     /*  817905 */     GIR_EraseRootFromParent_Done,
     /*  817906 */   // Label 12643: @817906
     /*  817906 */   GIM_Try, /*On fail goto*//*Label 12644*/ GIMT_Encode4(817981), // Rule ID 22295 //
     /*  817911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  817914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  817925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  817931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817957 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  817957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  817960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  817976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817979 */     GIR_RootConstrainSelectedInstOperands,
     /*  817980 */     // GIR_Coverage, 22295,
     /*  817980 */     GIR_EraseRootFromParent_Done,
     /*  817981 */   // Label 12644: @817981
     /*  817981 */   GIM_Try, /*On fail goto*//*Label 12645*/ GIMT_Encode4(818056), // Rule ID 22298 //
     /*  817986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  818003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  818035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818054 */     GIR_RootConstrainSelectedInstOperands,
     /*  818055 */     // GIR_Coverage, 22298,
     /*  818055 */     GIR_EraseRootFromParent_Done,
     /*  818056 */   // Label 12645: @818056
     /*  818056 */   GIM_Try, /*On fail goto*//*Label 12646*/ GIMT_Encode4(818131), // Rule ID 22299 //
     /*  818061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  818078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818107 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  818110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818129 */     GIR_RootConstrainSelectedInstOperands,
     /*  818130 */     // GIR_Coverage, 22299,
     /*  818130 */     GIR_EraseRootFromParent_Done,
     /*  818131 */   // Label 12646: @818131
     /*  818131 */   GIM_Try, /*On fail goto*//*Label 12647*/ GIMT_Encode4(818206), // Rule ID 22302 //
     /*  818136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  818153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818182 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  818185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818204 */     GIR_RootConstrainSelectedInstOperands,
     /*  818205 */     // GIR_Coverage, 22302,
     /*  818205 */     GIR_EraseRootFromParent_Done,
     /*  818206 */   // Label 12647: @818206
     /*  818206 */   GIM_Try, /*On fail goto*//*Label 12648*/ GIMT_Encode4(818281), // Rule ID 22303 //
     /*  818211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  818228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818257 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  818260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818279 */     GIR_RootConstrainSelectedInstOperands,
     /*  818280 */     // GIR_Coverage, 22303,
     /*  818280 */     GIR_EraseRootFromParent_Done,
     /*  818281 */   // Label 12648: @818281
     /*  818281 */   GIM_Try, /*On fail goto*//*Label 12649*/ GIMT_Encode4(818356), // Rule ID 22306 //
     /*  818286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  818303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818332 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  818335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818354 */     GIR_RootConstrainSelectedInstOperands,
     /*  818355 */     // GIR_Coverage, 22306,
     /*  818355 */     GIR_EraseRootFromParent_Done,
     /*  818356 */   // Label 12649: @818356
     /*  818356 */   GIM_Try, /*On fail goto*//*Label 12650*/ GIMT_Encode4(818431), // Rule ID 22307 //
     /*  818361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  818378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818407 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  818410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818429 */     GIR_RootConstrainSelectedInstOperands,
     /*  818430 */     // GIR_Coverage, 22307,
     /*  818430 */     GIR_EraseRootFromParent_Done,
     /*  818431 */   // Label 12650: @818431
     /*  818431 */   GIM_Try, /*On fail goto*//*Label 12651*/ GIMT_Encode4(818506), // Rule ID 22310 //
     /*  818436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  818453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818482 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  818485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818504 */     GIR_RootConstrainSelectedInstOperands,
     /*  818505 */     // GIR_Coverage, 22310,
     /*  818505 */     GIR_EraseRootFromParent_Done,
     /*  818506 */   // Label 12651: @818506
     /*  818506 */   GIM_Try, /*On fail goto*//*Label 12652*/ GIMT_Encode4(818581), // Rule ID 22311 //
     /*  818511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  818528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818557 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  818560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818579 */     GIR_RootConstrainSelectedInstOperands,
     /*  818580 */     // GIR_Coverage, 22311,
     /*  818580 */     GIR_EraseRootFromParent_Done,
     /*  818581 */   // Label 12652: @818581
     /*  818581 */   GIM_Try, /*On fail goto*//*Label 12653*/ GIMT_Encode4(818656), // Rule ID 22314 //
     /*  818586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  818603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  818635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818654 */     GIR_RootConstrainSelectedInstOperands,
     /*  818655 */     // GIR_Coverage, 22314,
     /*  818655 */     GIR_EraseRootFromParent_Done,
     /*  818656 */   // Label 12653: @818656
     /*  818656 */   GIM_Try, /*On fail goto*//*Label 12654*/ GIMT_Encode4(818731), // Rule ID 22315 //
     /*  818661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  818678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818707 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  818710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818729 */     GIR_RootConstrainSelectedInstOperands,
     /*  818730 */     // GIR_Coverage, 22315,
     /*  818730 */     GIR_EraseRootFromParent_Done,
     /*  818731 */   // Label 12654: @818731
     /*  818731 */   GIM_Try, /*On fail goto*//*Label 12655*/ GIMT_Encode4(818806), // Rule ID 22318 //
     /*  818736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  818753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  818785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818804 */     GIR_RootConstrainSelectedInstOperands,
     /*  818805 */     // GIR_Coverage, 22318,
     /*  818805 */     GIR_EraseRootFromParent_Done,
     /*  818806 */   // Label 12655: @818806
     /*  818806 */   GIM_Try, /*On fail goto*//*Label 12656*/ GIMT_Encode4(818881), // Rule ID 22319 //
     /*  818811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  818828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818857 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  818860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818879 */     GIR_RootConstrainSelectedInstOperands,
     /*  818880 */     // GIR_Coverage, 22319,
     /*  818880 */     GIR_EraseRootFromParent_Done,
     /*  818881 */   // Label 12656: @818881
     /*  818881 */   GIM_Try, /*On fail goto*//*Label 12657*/ GIMT_Encode4(818956), // Rule ID 22322 //
     /*  818886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  818903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818932 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  818932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  818935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818954 */     GIR_RootConstrainSelectedInstOperands,
     /*  818955 */     // GIR_Coverage, 22322,
     /*  818955 */     GIR_EraseRootFromParent_Done,
     /*  818956 */   // Label 12657: @818956
     /*  818956 */   GIM_Try, /*On fail goto*//*Label 12658*/ GIMT_Encode4(819031), // Rule ID 22323 //
     /*  818961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  818978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819007 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  819007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  819010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819029 */     GIR_RootConstrainSelectedInstOperands,
     /*  819030 */     // GIR_Coverage, 22323,
     /*  819030 */     GIR_EraseRootFromParent_Done,
     /*  819031 */   // Label 12658: @819031
     /*  819031 */   GIM_Try, /*On fail goto*//*Label 12659*/ GIMT_Encode4(819106), // Rule ID 22326 //
     /*  819036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  819053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819082 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  819082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  819085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819104 */     GIR_RootConstrainSelectedInstOperands,
     /*  819105 */     // GIR_Coverage, 22326,
     /*  819105 */     GIR_EraseRootFromParent_Done,
     /*  819106 */   // Label 12659: @819106
     /*  819106 */   GIM_Try, /*On fail goto*//*Label 12660*/ GIMT_Encode4(819181), // Rule ID 22327 //
     /*  819111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  819128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819157 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  819157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  819160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819179 */     GIR_RootConstrainSelectedInstOperands,
     /*  819180 */     // GIR_Coverage, 22327,
     /*  819180 */     GIR_EraseRootFromParent_Done,
     /*  819181 */   // Label 12660: @819181
     /*  819181 */   GIM_Try, /*On fail goto*//*Label 12661*/ GIMT_Encode4(819256), // Rule ID 22330 //
     /*  819186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  819203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  819232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  819235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819254 */     GIR_RootConstrainSelectedInstOperands,
     /*  819255 */     // GIR_Coverage, 22330,
     /*  819255 */     GIR_EraseRootFromParent_Done,
     /*  819256 */   // Label 12661: @819256
     /*  819256 */   GIM_Try, /*On fail goto*//*Label 12662*/ GIMT_Encode4(819331), // Rule ID 22331 //
     /*  819261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  819278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819307 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  819307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  819310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819329 */     GIR_RootConstrainSelectedInstOperands,
     /*  819330 */     // GIR_Coverage, 22331,
     /*  819330 */     GIR_EraseRootFromParent_Done,
     /*  819331 */   // Label 12662: @819331
     /*  819331 */   GIM_Try, /*On fail goto*//*Label 12663*/ GIMT_Encode4(819406), // Rule ID 22334 //
     /*  819336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  819353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819382 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  819385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819404 */     GIR_RootConstrainSelectedInstOperands,
     /*  819405 */     // GIR_Coverage, 22334,
     /*  819405 */     GIR_EraseRootFromParent_Done,
     /*  819406 */   // Label 12663: @819406
     /*  819406 */   GIM_Try, /*On fail goto*//*Label 12664*/ GIMT_Encode4(819481), // Rule ID 22335 //
     /*  819411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  819428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819457 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  819460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819479 */     GIR_RootConstrainSelectedInstOperands,
     /*  819480 */     // GIR_Coverage, 22335,
     /*  819480 */     GIR_EraseRootFromParent_Done,
     /*  819481 */   // Label 12664: @819481
     /*  819481 */   GIM_Try, /*On fail goto*//*Label 12665*/ GIMT_Encode4(819556), // Rule ID 22338 //
     /*  819486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  819503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819532 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  819535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819554 */     GIR_RootConstrainSelectedInstOperands,
     /*  819555 */     // GIR_Coverage, 22338,
     /*  819555 */     GIR_EraseRootFromParent_Done,
     /*  819556 */   // Label 12665: @819556
     /*  819556 */   GIM_Try, /*On fail goto*//*Label 12666*/ GIMT_Encode4(819631), // Rule ID 22339 //
     /*  819561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  819578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819607 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  819610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819629 */     GIR_RootConstrainSelectedInstOperands,
     /*  819630 */     // GIR_Coverage, 22339,
     /*  819630 */     GIR_EraseRootFromParent_Done,
     /*  819631 */   // Label 12666: @819631
     /*  819631 */   GIM_Try, /*On fail goto*//*Label 12667*/ GIMT_Encode4(819706), // Rule ID 22342 //
     /*  819636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  819653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819682 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  819685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819704 */     GIR_RootConstrainSelectedInstOperands,
     /*  819705 */     // GIR_Coverage, 22342,
     /*  819705 */     GIR_EraseRootFromParent_Done,
     /*  819706 */   // Label 12667: @819706
     /*  819706 */   GIM_Try, /*On fail goto*//*Label 12668*/ GIMT_Encode4(819781), // Rule ID 22343 //
     /*  819711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  819728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819757 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  819760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819779 */     GIR_RootConstrainSelectedInstOperands,
     /*  819780 */     // GIR_Coverage, 22343,
     /*  819780 */     GIR_EraseRootFromParent_Done,
     /*  819781 */   // Label 12668: @819781
     /*  819781 */   GIM_Try, /*On fail goto*//*Label 12669*/ GIMT_Encode4(819856), // Rule ID 22346 //
     /*  819786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819832 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  819835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819854 */     GIR_RootConstrainSelectedInstOperands,
     /*  819855 */     // GIR_Coverage, 22346,
     /*  819855 */     GIR_EraseRootFromParent_Done,
     /*  819856 */   // Label 12669: @819856
     /*  819856 */   GIM_Try, /*On fail goto*//*Label 12670*/ GIMT_Encode4(819931), // Rule ID 22347 //
     /*  819861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819907 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  819910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819929 */     GIR_RootConstrainSelectedInstOperands,
     /*  819930 */     // GIR_Coverage, 22347,
     /*  819930 */     GIR_EraseRootFromParent_Done,
     /*  819931 */   // Label 12670: @819931
     /*  819931 */   GIM_Try, /*On fail goto*//*Label 12671*/ GIMT_Encode4(820006), // Rule ID 22350 //
     /*  819936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  819953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  819985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820004 */     GIR_RootConstrainSelectedInstOperands,
     /*  820005 */     // GIR_Coverage, 22350,
     /*  820005 */     GIR_EraseRootFromParent_Done,
     /*  820006 */   // Label 12671: @820006
     /*  820006 */   GIM_Try, /*On fail goto*//*Label 12672*/ GIMT_Encode4(820081), // Rule ID 22351 //
     /*  820011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  820028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820057 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  820060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820079 */     GIR_RootConstrainSelectedInstOperands,
     /*  820080 */     // GIR_Coverage, 22351,
     /*  820080 */     GIR_EraseRootFromParent_Done,
     /*  820081 */   // Label 12672: @820081
     /*  820081 */   GIM_Try, /*On fail goto*//*Label 12673*/ GIMT_Encode4(820156), // Rule ID 22354 //
     /*  820086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  820103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  820135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820154 */     GIR_RootConstrainSelectedInstOperands,
     /*  820155 */     // GIR_Coverage, 22354,
     /*  820155 */     GIR_EraseRootFromParent_Done,
     /*  820156 */   // Label 12673: @820156
     /*  820156 */   GIM_Try, /*On fail goto*//*Label 12674*/ GIMT_Encode4(820231), // Rule ID 22355 //
     /*  820161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  820178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820207 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  820210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820229 */     GIR_RootConstrainSelectedInstOperands,
     /*  820230 */     // GIR_Coverage, 22355,
     /*  820230 */     GIR_EraseRootFromParent_Done,
     /*  820231 */   // Label 12674: @820231
     /*  820231 */   GIM_Try, /*On fail goto*//*Label 12675*/ GIMT_Encode4(820306), // Rule ID 22358 //
     /*  820236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  820253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820282 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  820285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820304 */     GIR_RootConstrainSelectedInstOperands,
     /*  820305 */     // GIR_Coverage, 22358,
     /*  820305 */     GIR_EraseRootFromParent_Done,
     /*  820306 */   // Label 12675: @820306
     /*  820306 */   GIM_Try, /*On fail goto*//*Label 12676*/ GIMT_Encode4(820381), // Rule ID 22359 //
     /*  820311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  820328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820357 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  820360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820379 */     GIR_RootConstrainSelectedInstOperands,
     /*  820380 */     // GIR_Coverage, 22359,
     /*  820380 */     GIR_EraseRootFromParent_Done,
     /*  820381 */   // Label 12676: @820381
     /*  820381 */   GIM_Try, /*On fail goto*//*Label 12677*/ GIMT_Encode4(820456), // Rule ID 22362 //
     /*  820386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  820403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820432 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  820435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820454 */     GIR_RootConstrainSelectedInstOperands,
     /*  820455 */     // GIR_Coverage, 22362,
     /*  820455 */     GIR_EraseRootFromParent_Done,
     /*  820456 */   // Label 12677: @820456
     /*  820456 */   GIM_Try, /*On fail goto*//*Label 12678*/ GIMT_Encode4(820531), // Rule ID 22363 //
     /*  820461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  820478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820507 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  820510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820529 */     GIR_RootConstrainSelectedInstOperands,
     /*  820530 */     // GIR_Coverage, 22363,
     /*  820530 */     GIR_EraseRootFromParent_Done,
     /*  820531 */   // Label 12678: @820531
     /*  820531 */   GIM_Try, /*On fail goto*//*Label 12679*/ GIMT_Encode4(820606), // Rule ID 22366 //
     /*  820536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820582 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  820582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  820585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820604 */     GIR_RootConstrainSelectedInstOperands,
     /*  820605 */     // GIR_Coverage, 22366,
     /*  820605 */     GIR_EraseRootFromParent_Done,
     /*  820606 */   // Label 12679: @820606
     /*  820606 */   GIM_Try, /*On fail goto*//*Label 12680*/ GIMT_Encode4(820681), // Rule ID 22367 //
     /*  820611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820657 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  820657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  820660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820679 */     GIR_RootConstrainSelectedInstOperands,
     /*  820680 */     // GIR_Coverage, 22367,
     /*  820680 */     GIR_EraseRootFromParent_Done,
     /*  820681 */   // Label 12680: @820681
     /*  820681 */   GIM_Try, /*On fail goto*//*Label 12681*/ GIMT_Encode4(820756), // Rule ID 22370 //
     /*  820686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  820735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820754 */     GIR_RootConstrainSelectedInstOperands,
     /*  820755 */     // GIR_Coverage, 22370,
     /*  820755 */     GIR_EraseRootFromParent_Done,
     /*  820756 */   // Label 12681: @820756
     /*  820756 */   GIM_Try, /*On fail goto*//*Label 12682*/ GIMT_Encode4(820831), // Rule ID 22371 //
     /*  820761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820807 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  820810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820829 */     GIR_RootConstrainSelectedInstOperands,
     /*  820830 */     // GIR_Coverage, 22371,
     /*  820830 */     GIR_EraseRootFromParent_Done,
     /*  820831 */   // Label 12682: @820831
     /*  820831 */   GIM_Try, /*On fail goto*//*Label 12683*/ GIMT_Encode4(820906), // Rule ID 22374 //
     /*  820836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  820885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820904 */     GIR_RootConstrainSelectedInstOperands,
     /*  820905 */     // GIR_Coverage, 22374,
     /*  820905 */     GIR_EraseRootFromParent_Done,
     /*  820906 */   // Label 12683: @820906
     /*  820906 */   GIM_Try, /*On fail goto*//*Label 12684*/ GIMT_Encode4(820981), // Rule ID 22375 //
     /*  820911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820957 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  820960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820979 */     GIR_RootConstrainSelectedInstOperands,
     /*  820980 */     // GIR_Coverage, 22375,
     /*  820980 */     GIR_EraseRootFromParent_Done,
     /*  820981 */   // Label 12684: @820981
     /*  820981 */   GIM_Try, /*On fail goto*//*Label 12685*/ GIMT_Encode4(821056), // Rule ID 22378 //
     /*  820986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  821003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821032 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  821032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  821035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821054 */     GIR_RootConstrainSelectedInstOperands,
     /*  821055 */     // GIR_Coverage, 22378,
     /*  821055 */     GIR_EraseRootFromParent_Done,
     /*  821056 */   // Label 12685: @821056
     /*  821056 */   GIM_Try, /*On fail goto*//*Label 12686*/ GIMT_Encode4(821131), // Rule ID 22379 //
     /*  821061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  821078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821107 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  821107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  821110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821129 */     GIR_RootConstrainSelectedInstOperands,
     /*  821130 */     // GIR_Coverage, 22379,
     /*  821130 */     GIR_EraseRootFromParent_Done,
     /*  821131 */   // Label 12686: @821131
     /*  821131 */   GIM_Try, /*On fail goto*//*Label 12687*/ GIMT_Encode4(821206), // Rule ID 22382 //
     /*  821136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  821139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  821153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821182 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  821182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  821185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821204 */     GIR_RootConstrainSelectedInstOperands,
     /*  821205 */     // GIR_Coverage, 22382,
     /*  821205 */     GIR_EraseRootFromParent_Done,
     /*  821206 */   // Label 12687: @821206
     /*  821206 */   GIM_Try, /*On fail goto*//*Label 12688*/ GIMT_Encode4(821281), // Rule ID 22383 //
     /*  821211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  821214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  821228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821257 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  821257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  821260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821279 */     GIR_RootConstrainSelectedInstOperands,
     /*  821280 */     // GIR_Coverage, 22383,
     /*  821280 */     GIR_EraseRootFromParent_Done,
     /*  821281 */   // Label 12688: @821281
     /*  821281 */   GIM_Try, /*On fail goto*//*Label 12689*/ GIMT_Encode4(821356), // Rule ID 22386 //
     /*  821286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  821303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821332 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  821335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821354 */     GIR_RootConstrainSelectedInstOperands,
     /*  821355 */     // GIR_Coverage, 22386,
     /*  821355 */     GIR_EraseRootFromParent_Done,
     /*  821356 */   // Label 12689: @821356
     /*  821356 */   GIM_Try, /*On fail goto*//*Label 12690*/ GIMT_Encode4(821431), // Rule ID 22387 //
     /*  821361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  821378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821407 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  821410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821429 */     GIR_RootConstrainSelectedInstOperands,
     /*  821430 */     // GIR_Coverage, 22387,
     /*  821430 */     GIR_EraseRootFromParent_Done,
     /*  821431 */   // Label 12690: @821431
     /*  821431 */   GIM_Try, /*On fail goto*//*Label 12691*/ GIMT_Encode4(821506), // Rule ID 22390 //
     /*  821436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  821453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821482 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  821485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821504 */     GIR_RootConstrainSelectedInstOperands,
     /*  821505 */     // GIR_Coverage, 22390,
     /*  821505 */     GIR_EraseRootFromParent_Done,
     /*  821506 */   // Label 12691: @821506
     /*  821506 */   GIM_Try, /*On fail goto*//*Label 12692*/ GIMT_Encode4(821581), // Rule ID 22391 //
     /*  821511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  821528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821557 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  821560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821579 */     GIR_RootConstrainSelectedInstOperands,
     /*  821580 */     // GIR_Coverage, 22391,
     /*  821580 */     GIR_EraseRootFromParent_Done,
     /*  821581 */   // Label 12692: @821581
     /*  821581 */   GIM_Try, /*On fail goto*//*Label 12693*/ GIMT_Encode4(821656), // Rule ID 22394 //
     /*  821586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821632 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  821635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821654 */     GIR_RootConstrainSelectedInstOperands,
     /*  821655 */     // GIR_Coverage, 22394,
     /*  821655 */     GIR_EraseRootFromParent_Done,
     /*  821656 */   // Label 12693: @821656
     /*  821656 */   GIM_Try, /*On fail goto*//*Label 12694*/ GIMT_Encode4(821731), // Rule ID 22395 //
     /*  821661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821707 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  821710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821729 */     GIR_RootConstrainSelectedInstOperands,
     /*  821730 */     // GIR_Coverage, 22395,
     /*  821730 */     GIR_EraseRootFromParent_Done,
     /*  821731 */   // Label 12694: @821731
     /*  821731 */   GIM_Try, /*On fail goto*//*Label 12695*/ GIMT_Encode4(821806), // Rule ID 22398 //
     /*  821736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  821785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821804 */     GIR_RootConstrainSelectedInstOperands,
     /*  821805 */     // GIR_Coverage, 22398,
     /*  821805 */     GIR_EraseRootFromParent_Done,
     /*  821806 */   // Label 12695: @821806
     /*  821806 */   GIM_Try, /*On fail goto*//*Label 12696*/ GIMT_Encode4(821881), // Rule ID 22399 //
     /*  821811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821857 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  821860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821879 */     GIR_RootConstrainSelectedInstOperands,
     /*  821880 */     // GIR_Coverage, 22399,
     /*  821880 */     GIR_EraseRootFromParent_Done,
     /*  821881 */   // Label 12696: @821881
     /*  821881 */   GIM_Try, /*On fail goto*//*Label 12697*/ GIMT_Encode4(821956), // Rule ID 22402 //
     /*  821886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  821903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  821935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821954 */     GIR_RootConstrainSelectedInstOperands,
     /*  821955 */     // GIR_Coverage, 22402,
     /*  821955 */     GIR_EraseRootFromParent_Done,
     /*  821956 */   // Label 12697: @821956
     /*  821956 */   GIM_Try, /*On fail goto*//*Label 12698*/ GIMT_Encode4(822031), // Rule ID 22403 //
     /*  821961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  821978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822007 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  822007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  822010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822029 */     GIR_RootConstrainSelectedInstOperands,
     /*  822030 */     // GIR_Coverage, 22403,
     /*  822030 */     GIR_EraseRootFromParent_Done,
     /*  822031 */   // Label 12698: @822031
     /*  822031 */   GIM_Try, /*On fail goto*//*Label 12699*/ GIMT_Encode4(822106), // Rule ID 22406 //
     /*  822036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  822053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822082 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  822082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  822085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822104 */     GIR_RootConstrainSelectedInstOperands,
     /*  822105 */     // GIR_Coverage, 22406,
     /*  822105 */     GIR_EraseRootFromParent_Done,
     /*  822106 */   // Label 12699: @822106
     /*  822106 */   GIM_Try, /*On fail goto*//*Label 12700*/ GIMT_Encode4(822181), // Rule ID 22407 //
     /*  822111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  822128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822157 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  822157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  822160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822179 */     GIR_RootConstrainSelectedInstOperands,
     /*  822180 */     // GIR_Coverage, 22407,
     /*  822180 */     GIR_EraseRootFromParent_Done,
     /*  822181 */   // Label 12700: @822181
     /*  822181 */   GIM_Try, /*On fail goto*//*Label 12701*/ GIMT_Encode4(822256), // Rule ID 22410 //
     /*  822186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  822203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  822235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822254 */     GIR_RootConstrainSelectedInstOperands,
     /*  822255 */     // GIR_Coverage, 22410,
     /*  822255 */     GIR_EraseRootFromParent_Done,
     /*  822256 */   // Label 12701: @822256
     /*  822256 */   GIM_Try, /*On fail goto*//*Label 12702*/ GIMT_Encode4(822331), // Rule ID 22411 //
     /*  822261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  822278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822307 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  822310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822329 */     GIR_RootConstrainSelectedInstOperands,
     /*  822330 */     // GIR_Coverage, 22411,
     /*  822330 */     GIR_EraseRootFromParent_Done,
     /*  822331 */   // Label 12702: @822331
     /*  822331 */   GIM_Try, /*On fail goto*//*Label 12703*/ GIMT_Encode4(822406), // Rule ID 22414 //
     /*  822336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  822353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  822385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822404 */     GIR_RootConstrainSelectedInstOperands,
     /*  822405 */     // GIR_Coverage, 22414,
     /*  822405 */     GIR_EraseRootFromParent_Done,
     /*  822406 */   // Label 12703: @822406
     /*  822406 */   GIM_Try, /*On fail goto*//*Label 12704*/ GIMT_Encode4(822481), // Rule ID 22415 //
     /*  822411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  822428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822457 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  822460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822479 */     GIR_RootConstrainSelectedInstOperands,
     /*  822480 */     // GIR_Coverage, 22415,
     /*  822480 */     GIR_EraseRootFromParent_Done,
     /*  822481 */   // Label 12704: @822481
     /*  822481 */   GIM_Try, /*On fail goto*//*Label 12705*/ GIMT_Encode4(822556), // Rule ID 22418 //
     /*  822486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  822535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822554 */     GIR_RootConstrainSelectedInstOperands,
     /*  822555 */     // GIR_Coverage, 22418,
     /*  822555 */     GIR_EraseRootFromParent_Done,
     /*  822556 */   // Label 12705: @822556
     /*  822556 */   GIM_Try, /*On fail goto*//*Label 12706*/ GIMT_Encode4(822631), // Rule ID 22419 //
     /*  822561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822607 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  822610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822629 */     GIR_RootConstrainSelectedInstOperands,
     /*  822630 */     // GIR_Coverage, 22419,
     /*  822630 */     GIR_EraseRootFromParent_Done,
     /*  822631 */   // Label 12706: @822631
     /*  822631 */   GIM_Try, /*On fail goto*//*Label 12707*/ GIMT_Encode4(822706), // Rule ID 22422 //
     /*  822636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822682 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  822685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822704 */     GIR_RootConstrainSelectedInstOperands,
     /*  822705 */     // GIR_Coverage, 22422,
     /*  822705 */     GIR_EraseRootFromParent_Done,
     /*  822706 */   // Label 12707: @822706
     /*  822706 */   GIM_Try, /*On fail goto*//*Label 12708*/ GIMT_Encode4(822781), // Rule ID 22423 //
     /*  822711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822757 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  822760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822779 */     GIR_RootConstrainSelectedInstOperands,
     /*  822780 */     // GIR_Coverage, 22423,
     /*  822780 */     GIR_EraseRootFromParent_Done,
     /*  822781 */   // Label 12708: @822781
     /*  822781 */   GIM_Try, /*On fail goto*//*Label 12709*/ GIMT_Encode4(822856), // Rule ID 22426 //
     /*  822786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  822803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822832 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  822835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822854 */     GIR_RootConstrainSelectedInstOperands,
     /*  822855 */     // GIR_Coverage, 22426,
     /*  822855 */     GIR_EraseRootFromParent_Done,
     /*  822856 */   // Label 12709: @822856
     /*  822856 */   GIM_Try, /*On fail goto*//*Label 12710*/ GIMT_Encode4(822931), // Rule ID 22427 //
     /*  822861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  822878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822907 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  822910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822929 */     GIR_RootConstrainSelectedInstOperands,
     /*  822930 */     // GIR_Coverage, 22427,
     /*  822930 */     GIR_EraseRootFromParent_Done,
     /*  822931 */   // Label 12710: @822931
     /*  822931 */   GIM_Try, /*On fail goto*//*Label 12711*/ GIMT_Encode4(823006), // Rule ID 22430 //
     /*  822936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  822953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822982 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  822985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823004 */     GIR_RootConstrainSelectedInstOperands,
     /*  823005 */     // GIR_Coverage, 22430,
     /*  823005 */     GIR_EraseRootFromParent_Done,
     /*  823006 */   // Label 12711: @823006
     /*  823006 */   GIM_Try, /*On fail goto*//*Label 12712*/ GIMT_Encode4(823081), // Rule ID 22431 //
     /*  823011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  823014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  823022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  823025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  823028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  823031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823057 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  823057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  823060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823079 */     GIR_RootConstrainSelectedInstOperands,
     /*  823080 */     // GIR_Coverage, 22431,
     /*  823080 */     GIR_EraseRootFromParent_Done,
     /*  823081 */   // Label 12712: @823081
     /*  823081 */   GIM_Try, /*On fail goto*//*Label 12713*/ GIMT_Encode4(823156), // Rule ID 22434 //
     /*  823086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  823103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  823135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823154 */     GIR_RootConstrainSelectedInstOperands,
     /*  823155 */     // GIR_Coverage, 22434,
     /*  823155 */     GIR_EraseRootFromParent_Done,
     /*  823156 */   // Label 12713: @823156
     /*  823156 */   GIM_Try, /*On fail goto*//*Label 12714*/ GIMT_Encode4(823231), // Rule ID 22435 //
     /*  823161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  823178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823207 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  823210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823229 */     GIR_RootConstrainSelectedInstOperands,
     /*  823230 */     // GIR_Coverage, 22435,
     /*  823230 */     GIR_EraseRootFromParent_Done,
     /*  823231 */   // Label 12714: @823231
     /*  823231 */   GIM_Try, /*On fail goto*//*Label 12715*/ GIMT_Encode4(823306), // Rule ID 22438 //
     /*  823236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  823253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823282 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  823285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823304 */     GIR_RootConstrainSelectedInstOperands,
     /*  823305 */     // GIR_Coverage, 22438,
     /*  823305 */     GIR_EraseRootFromParent_Done,
     /*  823306 */   // Label 12715: @823306
     /*  823306 */   GIM_Try, /*On fail goto*//*Label 12716*/ GIMT_Encode4(823381), // Rule ID 22439 //
     /*  823311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  823328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823357 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  823360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823379 */     GIR_RootConstrainSelectedInstOperands,
     /*  823380 */     // GIR_Coverage, 22439,
     /*  823380 */     GIR_EraseRootFromParent_Done,
     /*  823381 */   // Label 12716: @823381
     /*  823381 */   GIM_Try, /*On fail goto*//*Label 12717*/ GIMT_Encode4(823456), // Rule ID 22442 //
     /*  823386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  823403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  823435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823454 */     GIR_RootConstrainSelectedInstOperands,
     /*  823455 */     // GIR_Coverage, 22442,
     /*  823455 */     GIR_EraseRootFromParent_Done,
     /*  823456 */   // Label 12717: @823456
     /*  823456 */   GIM_Try, /*On fail goto*//*Label 12718*/ GIMT_Encode4(823531), // Rule ID 22443 //
     /*  823461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  823478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823507 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  823510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823529 */     GIR_RootConstrainSelectedInstOperands,
     /*  823530 */     // GIR_Coverage, 22443,
     /*  823530 */     GIR_EraseRootFromParent_Done,
     /*  823531 */   // Label 12718: @823531
     /*  823531 */   GIM_Try, /*On fail goto*//*Label 12719*/ GIMT_Encode4(823606), // Rule ID 22446 //
     /*  823536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823582 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  823585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823604 */     GIR_RootConstrainSelectedInstOperands,
     /*  823605 */     // GIR_Coverage, 22446,
     /*  823605 */     GIR_EraseRootFromParent_Done,
     /*  823606 */   // Label 12719: @823606
     /*  823606 */   GIM_Try, /*On fail goto*//*Label 12720*/ GIMT_Encode4(823681), // Rule ID 22447 //
     /*  823611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823657 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  823660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823679 */     GIR_RootConstrainSelectedInstOperands,
     /*  823680 */     // GIR_Coverage, 22447,
     /*  823680 */     GIR_EraseRootFromParent_Done,
     /*  823681 */   // Label 12720: @823681
     /*  823681 */   GIM_Try, /*On fail goto*//*Label 12721*/ GIMT_Encode4(823756), // Rule ID 22450 //
     /*  823686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  823703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823732 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  823735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823754 */     GIR_RootConstrainSelectedInstOperands,
     /*  823755 */     // GIR_Coverage, 22450,
     /*  823755 */     GIR_EraseRootFromParent_Done,
     /*  823756 */   // Label 12721: @823756
     /*  823756 */   GIM_Try, /*On fail goto*//*Label 12722*/ GIMT_Encode4(823831), // Rule ID 22451 //
     /*  823761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  823778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823807 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  823810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823829 */     GIR_RootConstrainSelectedInstOperands,
     /*  823830 */     // GIR_Coverage, 22451,
     /*  823830 */     GIR_EraseRootFromParent_Done,
     /*  823831 */   // Label 12722: @823831
     /*  823831 */   GIM_Try, /*On fail goto*//*Label 12723*/ GIMT_Encode4(823906), // Rule ID 22454 //
     /*  823836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  823853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823882 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  823882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  823885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823904 */     GIR_RootConstrainSelectedInstOperands,
     /*  823905 */     // GIR_Coverage, 22454,
     /*  823905 */     GIR_EraseRootFromParent_Done,
     /*  823906 */   // Label 12723: @823906
     /*  823906 */   GIM_Try, /*On fail goto*//*Label 12724*/ GIMT_Encode4(823981), // Rule ID 22455 //
     /*  823911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  823928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823957 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  823957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  823960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823979 */     GIR_RootConstrainSelectedInstOperands,
     /*  823980 */     // GIR_Coverage, 22455,
     /*  823980 */     GIR_EraseRootFromParent_Done,
     /*  823981 */   // Label 12724: @823981
     /*  823981 */   GIM_Try, /*On fail goto*//*Label 12725*/ GIMT_Encode4(824056), // Rule ID 22458 //
     /*  823986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  824003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  824035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824054 */     GIR_RootConstrainSelectedInstOperands,
     /*  824055 */     // GIR_Coverage, 22458,
     /*  824055 */     GIR_EraseRootFromParent_Done,
     /*  824056 */   // Label 12725: @824056
     /*  824056 */   GIM_Try, /*On fail goto*//*Label 12726*/ GIMT_Encode4(824131), // Rule ID 22459 //
     /*  824061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  824078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824107 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  824110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824129 */     GIR_RootConstrainSelectedInstOperands,
     /*  824130 */     // GIR_Coverage, 22459,
     /*  824130 */     GIR_EraseRootFromParent_Done,
     /*  824131 */   // Label 12726: @824131
     /*  824131 */   GIM_Try, /*On fail goto*//*Label 12727*/ GIMT_Encode4(824206), // Rule ID 22462 //
     /*  824136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  824153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  824185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824204 */     GIR_RootConstrainSelectedInstOperands,
     /*  824205 */     // GIR_Coverage, 22462,
     /*  824205 */     GIR_EraseRootFromParent_Done,
     /*  824206 */   // Label 12727: @824206
     /*  824206 */   GIM_Try, /*On fail goto*//*Label 12728*/ GIMT_Encode4(824281), // Rule ID 22463 //
     /*  824211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  824228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824257 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  824260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824279 */     GIR_RootConstrainSelectedInstOperands,
     /*  824280 */     // GIR_Coverage, 22463,
     /*  824280 */     GIR_EraseRootFromParent_Done,
     /*  824281 */   // Label 12728: @824281
     /*  824281 */   GIM_Try, /*On fail goto*//*Label 12729*/ GIMT_Encode4(824356), // Rule ID 22466 //
     /*  824286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  824303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824332 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  824332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  824335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824354 */     GIR_RootConstrainSelectedInstOperands,
     /*  824355 */     // GIR_Coverage, 22466,
     /*  824355 */     GIR_EraseRootFromParent_Done,
     /*  824356 */   // Label 12729: @824356
     /*  824356 */   GIM_Try, /*On fail goto*//*Label 12730*/ GIMT_Encode4(824431), // Rule ID 22467 //
     /*  824361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  824378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824407 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  824407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  824410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824429 */     GIR_RootConstrainSelectedInstOperands,
     /*  824430 */     // GIR_Coverage, 22467,
     /*  824430 */     GIR_EraseRootFromParent_Done,
     /*  824431 */   // Label 12730: @824431
     /*  824431 */   GIM_Try, /*On fail goto*//*Label 12731*/ GIMT_Encode4(824506), // Rule ID 22470 //
     /*  824436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  824439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  824447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  824450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  824453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  824456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  824482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  824485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  824501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824504 */     GIR_RootConstrainSelectedInstOperands,
     /*  824505 */     // GIR_Coverage, 22470,
     /*  824505 */     GIR_EraseRootFromParent_Done,
     /*  824506 */   // Label 12731: @824506
     /*  824506 */   GIM_Try, /*On fail goto*//*Label 12732*/ GIMT_Encode4(824581), // Rule ID 22471 //
     /*  824511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  824514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  824522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  824525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  824528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  824531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824557 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  824557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  824560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  824576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824579 */     GIR_RootConstrainSelectedInstOperands,
     /*  824580 */     // GIR_Coverage, 22471,
     /*  824580 */     GIR_EraseRootFromParent_Done,
     /*  824581 */   // Label 12732: @824581
     /*  824581 */   GIM_Try, /*On fail goto*//*Label 12733*/ GIMT_Encode4(824656), // Rule ID 22474 //
     /*  824586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  824603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824632 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  824635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824654 */     GIR_RootConstrainSelectedInstOperands,
     /*  824655 */     // GIR_Coverage, 22474,
     /*  824655 */     GIR_EraseRootFromParent_Done,
     /*  824656 */   // Label 12733: @824656
     /*  824656 */   GIM_Try, /*On fail goto*//*Label 12734*/ GIMT_Encode4(824731), // Rule ID 22475 //
     /*  824661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  824678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824707 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  824710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824729 */     GIR_RootConstrainSelectedInstOperands,
     /*  824730 */     // GIR_Coverage, 22475,
     /*  824730 */     GIR_EraseRootFromParent_Done,
     /*  824731 */   // Label 12734: @824731
     /*  824731 */   GIM_Try, /*On fail goto*//*Label 12735*/ GIMT_Encode4(824806), // Rule ID 22478 //
     /*  824736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  824753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824782 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  824785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824804 */     GIR_RootConstrainSelectedInstOperands,
     /*  824805 */     // GIR_Coverage, 22478,
     /*  824805 */     GIR_EraseRootFromParent_Done,
     /*  824806 */   // Label 12735: @824806
     /*  824806 */   GIM_Try, /*On fail goto*//*Label 12736*/ GIMT_Encode4(824881), // Rule ID 22479 //
     /*  824811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  824828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824857 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  824860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824879 */     GIR_RootConstrainSelectedInstOperands,
     /*  824880 */     // GIR_Coverage, 22479,
     /*  824880 */     GIR_EraseRootFromParent_Done,
     /*  824881 */   // Label 12736: @824881
     /*  824881 */   GIM_Try, /*On fail goto*//*Label 12737*/ GIMT_Encode4(824956), // Rule ID 22482 //
     /*  824886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  824903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824932 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  824935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824954 */     GIR_RootConstrainSelectedInstOperands,
     /*  824955 */     // GIR_Coverage, 22482,
     /*  824955 */     GIR_EraseRootFromParent_Done,
     /*  824956 */   // Label 12737: @824956
     /*  824956 */   GIM_Try, /*On fail goto*//*Label 12738*/ GIMT_Encode4(825031), // Rule ID 22483 //
     /*  824961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  824978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825007 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  825007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  825010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825029 */     GIR_RootConstrainSelectedInstOperands,
     /*  825030 */     // GIR_Coverage, 22483,
     /*  825030 */     GIR_EraseRootFromParent_Done,
     /*  825031 */   // Label 12738: @825031
     /*  825031 */   GIM_Try, /*On fail goto*//*Label 12739*/ GIMT_Encode4(825106), // Rule ID 22486 //
     /*  825036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  825053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825082 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  825085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825104 */     GIR_RootConstrainSelectedInstOperands,
     /*  825105 */     // GIR_Coverage, 22486,
     /*  825105 */     GIR_EraseRootFromParent_Done,
     /*  825106 */   // Label 12739: @825106
     /*  825106 */   GIM_Try, /*On fail goto*//*Label 12740*/ GIMT_Encode4(825181), // Rule ID 22487 //
     /*  825111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  825128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825157 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  825160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825179 */     GIR_RootConstrainSelectedInstOperands,
     /*  825180 */     // GIR_Coverage, 22487,
     /*  825180 */     GIR_EraseRootFromParent_Done,
     /*  825181 */   // Label 12740: @825181
     /*  825181 */   GIM_Try, /*On fail goto*//*Label 12741*/ GIMT_Encode4(825256), // Rule ID 22490 //
     /*  825186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  825203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  825235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825254 */     GIR_RootConstrainSelectedInstOperands,
     /*  825255 */     // GIR_Coverage, 22490,
     /*  825255 */     GIR_EraseRootFromParent_Done,
     /*  825256 */   // Label 12741: @825256
     /*  825256 */   GIM_Try, /*On fail goto*//*Label 12742*/ GIMT_Encode4(825331), // Rule ID 22491 //
     /*  825261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  825278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825307 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  825310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825329 */     GIR_RootConstrainSelectedInstOperands,
     /*  825330 */     // GIR_Coverage, 22491,
     /*  825330 */     GIR_EraseRootFromParent_Done,
     /*  825331 */   // Label 12742: @825331
     /*  825331 */   GIM_Try, /*On fail goto*//*Label 12743*/ GIMT_Encode4(825406), // Rule ID 22494 //
     /*  825336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  825353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  825385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825404 */     GIR_RootConstrainSelectedInstOperands,
     /*  825405 */     // GIR_Coverage, 22494,
     /*  825405 */     GIR_EraseRootFromParent_Done,
     /*  825406 */   // Label 12743: @825406
     /*  825406 */   GIM_Try, /*On fail goto*//*Label 12744*/ GIMT_Encode4(825481), // Rule ID 22495 //
     /*  825411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  825428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825457 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  825460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825479 */     GIR_RootConstrainSelectedInstOperands,
     /*  825480 */     // GIR_Coverage, 22495,
     /*  825480 */     GIR_EraseRootFromParent_Done,
     /*  825481 */   // Label 12744: @825481
     /*  825481 */   GIM_Try, /*On fail goto*//*Label 12745*/ GIMT_Encode4(825556), // Rule ID 22498 //
     /*  825486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  825503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  825535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825554 */     GIR_RootConstrainSelectedInstOperands,
     /*  825555 */     // GIR_Coverage, 22498,
     /*  825555 */     GIR_EraseRootFromParent_Done,
     /*  825556 */   // Label 12745: @825556
     /*  825556 */   GIM_Try, /*On fail goto*//*Label 12746*/ GIMT_Encode4(825631), // Rule ID 22499 //
     /*  825561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  825578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825607 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  825610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825629 */     GIR_RootConstrainSelectedInstOperands,
     /*  825630 */     // GIR_Coverage, 22499,
     /*  825630 */     GIR_EraseRootFromParent_Done,
     /*  825631 */   // Label 12746: @825631
     /*  825631 */   GIM_Try, /*On fail goto*//*Label 12747*/ GIMT_Encode4(825706), // Rule ID 22502 //
     /*  825636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  825653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  825685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825704 */     GIR_RootConstrainSelectedInstOperands,
     /*  825705 */     // GIR_Coverage, 22502,
     /*  825705 */     GIR_EraseRootFromParent_Done,
     /*  825706 */   // Label 12747: @825706
     /*  825706 */   GIM_Try, /*On fail goto*//*Label 12748*/ GIMT_Encode4(825781), // Rule ID 22503 //
     /*  825711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  825728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825757 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  825760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825779 */     GIR_RootConstrainSelectedInstOperands,
     /*  825780 */     // GIR_Coverage, 22503,
     /*  825780 */     GIR_EraseRootFromParent_Done,
     /*  825781 */   // Label 12748: @825781
     /*  825781 */   GIM_Try, /*On fail goto*//*Label 12749*/ GIMT_Encode4(825856), // Rule ID 22506 //
     /*  825786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  825803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825832 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  825835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825854 */     GIR_RootConstrainSelectedInstOperands,
     /*  825855 */     // GIR_Coverage, 22506,
     /*  825855 */     GIR_EraseRootFromParent_Done,
     /*  825856 */   // Label 12749: @825856
     /*  825856 */   GIM_Try, /*On fail goto*//*Label 12750*/ GIMT_Encode4(825931), // Rule ID 22507 //
     /*  825861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  825878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825907 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  825910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825929 */     GIR_RootConstrainSelectedInstOperands,
     /*  825930 */     // GIR_Coverage, 22507,
     /*  825930 */     GIR_EraseRootFromParent_Done,
     /*  825931 */   // Label 12750: @825931
     /*  825931 */   GIM_Try, /*On fail goto*//*Label 12751*/ GIMT_Encode4(826006), // Rule ID 22510 //
     /*  825936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  825939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  825953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825982 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  825982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  825985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826004 */     GIR_RootConstrainSelectedInstOperands,
     /*  826005 */     // GIR_Coverage, 22510,
     /*  826005 */     GIR_EraseRootFromParent_Done,
     /*  826006 */   // Label 12751: @826006
     /*  826006 */   GIM_Try, /*On fail goto*//*Label 12752*/ GIMT_Encode4(826081), // Rule ID 22511 //
     /*  826011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  826028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826057 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  826060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826079 */     GIR_RootConstrainSelectedInstOperands,
     /*  826080 */     // GIR_Coverage, 22511,
     /*  826080 */     GIR_EraseRootFromParent_Done,
     /*  826081 */   // Label 12752: @826081
     /*  826081 */   GIM_Try, /*On fail goto*//*Label 12753*/ GIMT_Encode4(826156), // Rule ID 22514 //
     /*  826086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  826103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826132 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  826132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  826135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826154 */     GIR_RootConstrainSelectedInstOperands,
     /*  826155 */     // GIR_Coverage, 22514,
     /*  826155 */     GIR_EraseRootFromParent_Done,
     /*  826156 */   // Label 12753: @826156
     /*  826156 */   GIM_Try, /*On fail goto*//*Label 12754*/ GIMT_Encode4(826231), // Rule ID 22515 //
     /*  826161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  826178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826207 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  826210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826229 */     GIR_RootConstrainSelectedInstOperands,
     /*  826230 */     // GIR_Coverage, 22515,
     /*  826230 */     GIR_EraseRootFromParent_Done,
     /*  826231 */   // Label 12754: @826231
     /*  826231 */   GIM_Try, /*On fail goto*//*Label 12755*/ GIMT_Encode4(826306), // Rule ID 22518 //
     /*  826236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  826253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  826282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  826285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826304 */     GIR_RootConstrainSelectedInstOperands,
     /*  826305 */     // GIR_Coverage, 22518,
     /*  826305 */     GIR_EraseRootFromParent_Done,
     /*  826306 */   // Label 12755: @826306
     /*  826306 */   GIM_Try, /*On fail goto*//*Label 12756*/ GIMT_Encode4(826381), // Rule ID 22519 //
     /*  826311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  826328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826357 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  826360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826379 */     GIR_RootConstrainSelectedInstOperands,
     /*  826380 */     // GIR_Coverage, 22519,
     /*  826380 */     GIR_EraseRootFromParent_Done,
     /*  826381 */   // Label 12756: @826381
     /*  826381 */   GIM_Try, /*On fail goto*//*Label 12757*/ GIMT_Encode4(826456), // Rule ID 22522 //
     /*  826386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  826403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  826435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826454 */     GIR_RootConstrainSelectedInstOperands,
     /*  826455 */     // GIR_Coverage, 22522,
     /*  826455 */     GIR_EraseRootFromParent_Done,
     /*  826456 */   // Label 12757: @826456
     /*  826456 */   GIM_Try, /*On fail goto*//*Label 12758*/ GIMT_Encode4(826531), // Rule ID 22523 //
     /*  826461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  826478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826507 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  826510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826529 */     GIR_RootConstrainSelectedInstOperands,
     /*  826530 */     // GIR_Coverage, 22523,
     /*  826530 */     GIR_EraseRootFromParent_Done,
     /*  826531 */   // Label 12758: @826531
     /*  826531 */   GIM_Try, /*On fail goto*//*Label 12759*/ GIMT_Encode4(826606), // Rule ID 22526 //
     /*  826536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  826553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  826585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826604 */     GIR_RootConstrainSelectedInstOperands,
     /*  826605 */     // GIR_Coverage, 22526,
     /*  826605 */     GIR_EraseRootFromParent_Done,
     /*  826606 */   // Label 12759: @826606
     /*  826606 */   GIM_Try, /*On fail goto*//*Label 12760*/ GIMT_Encode4(826681), // Rule ID 22527 //
     /*  826611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  826628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826657 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  826660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826679 */     GIR_RootConstrainSelectedInstOperands,
     /*  826680 */     // GIR_Coverage, 22527,
     /*  826680 */     GIR_EraseRootFromParent_Done,
     /*  826681 */   // Label 12760: @826681
     /*  826681 */   GIM_Try, /*On fail goto*//*Label 12761*/ GIMT_Encode4(826756), // Rule ID 22530 //
     /*  826686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  826703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  826735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826754 */     GIR_RootConstrainSelectedInstOperands,
     /*  826755 */     // GIR_Coverage, 22530,
     /*  826755 */     GIR_EraseRootFromParent_Done,
     /*  826756 */   // Label 12761: @826756
     /*  826756 */   GIM_Try, /*On fail goto*//*Label 12762*/ GIMT_Encode4(826831), // Rule ID 22531 //
     /*  826761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  826778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826807 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  826810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826829 */     GIR_RootConstrainSelectedInstOperands,
     /*  826830 */     // GIR_Coverage, 22531,
     /*  826830 */     GIR_EraseRootFromParent_Done,
     /*  826831 */   // Label 12762: @826831
     /*  826831 */   GIM_Try, /*On fail goto*//*Label 12763*/ GIMT_Encode4(826906), // Rule ID 22534 //
     /*  826836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  826853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  826882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  826885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826904 */     GIR_RootConstrainSelectedInstOperands,
     /*  826905 */     // GIR_Coverage, 22534,
     /*  826905 */     GIR_EraseRootFromParent_Done,
     /*  826906 */   // Label 12763: @826906
     /*  826906 */   GIM_Try, /*On fail goto*//*Label 12764*/ GIMT_Encode4(826981), // Rule ID 22535 //
     /*  826911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  826928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826957 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  826957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  826960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826979 */     GIR_RootConstrainSelectedInstOperands,
     /*  826980 */     // GIR_Coverage, 22535,
     /*  826980 */     GIR_EraseRootFromParent_Done,
     /*  826981 */   // Label 12764: @826981
     /*  826981 */   GIM_Try, /*On fail goto*//*Label 12765*/ GIMT_Encode4(827056), // Rule ID 22538 //
     /*  826986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  827003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  827035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827054 */     GIR_RootConstrainSelectedInstOperands,
     /*  827055 */     // GIR_Coverage, 22538,
     /*  827055 */     GIR_EraseRootFromParent_Done,
     /*  827056 */   // Label 12765: @827056
     /*  827056 */   GIM_Try, /*On fail goto*//*Label 12766*/ GIMT_Encode4(827131), // Rule ID 22539 //
     /*  827061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  827078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827107 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  827110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827129 */     GIR_RootConstrainSelectedInstOperands,
     /*  827130 */     // GIR_Coverage, 22539,
     /*  827130 */     GIR_EraseRootFromParent_Done,
     /*  827131 */   // Label 12766: @827131
     /*  827131 */   GIM_Try, /*On fail goto*//*Label 12767*/ GIMT_Encode4(827206), // Rule ID 22542 //
     /*  827136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  827153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827182 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  827182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  827185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827204 */     GIR_RootConstrainSelectedInstOperands,
     /*  827205 */     // GIR_Coverage, 22542,
     /*  827205 */     GIR_EraseRootFromParent_Done,
     /*  827206 */   // Label 12767: @827206
     /*  827206 */   GIM_Try, /*On fail goto*//*Label 12768*/ GIMT_Encode4(827281), // Rule ID 22543 //
     /*  827211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  827228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827257 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  827257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  827260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827279 */     GIR_RootConstrainSelectedInstOperands,
     /*  827280 */     // GIR_Coverage, 22543,
     /*  827280 */     GIR_EraseRootFromParent_Done,
     /*  827281 */   // Label 12768: @827281
     /*  827281 */   GIM_Try, /*On fail goto*//*Label 12769*/ GIMT_Encode4(827356), // Rule ID 22546 //
     /*  827286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  827303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827332 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  827335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827354 */     GIR_RootConstrainSelectedInstOperands,
     /*  827355 */     // GIR_Coverage, 22546,
     /*  827355 */     GIR_EraseRootFromParent_Done,
     /*  827356 */   // Label 12769: @827356
     /*  827356 */   GIM_Try, /*On fail goto*//*Label 12770*/ GIMT_Encode4(827431), // Rule ID 22547 //
     /*  827361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  827378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827407 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  827410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827429 */     GIR_RootConstrainSelectedInstOperands,
     /*  827430 */     // GIR_Coverage, 22547,
     /*  827430 */     GIR_EraseRootFromParent_Done,
     /*  827431 */   // Label 12770: @827431
     /*  827431 */   GIM_Try, /*On fail goto*//*Label 12771*/ GIMT_Encode4(827506), // Rule ID 22550 //
     /*  827436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  827453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827482 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  827485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827504 */     GIR_RootConstrainSelectedInstOperands,
     /*  827505 */     // GIR_Coverage, 22550,
     /*  827505 */     GIR_EraseRootFromParent_Done,
     /*  827506 */   // Label 12771: @827506
     /*  827506 */   GIM_Try, /*On fail goto*//*Label 12772*/ GIMT_Encode4(827581), // Rule ID 22551 //
     /*  827511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  827528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827557 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  827560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827579 */     GIR_RootConstrainSelectedInstOperands,
     /*  827580 */     // GIR_Coverage, 22551,
     /*  827580 */     GIR_EraseRootFromParent_Done,
     /*  827581 */   // Label 12772: @827581
     /*  827581 */   GIM_Try, /*On fail goto*//*Label 12773*/ GIMT_Encode4(827656), // Rule ID 22554 //
     /*  827586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827632 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  827632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  827635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827654 */     GIR_RootConstrainSelectedInstOperands,
     /*  827655 */     // GIR_Coverage, 22554,
     /*  827655 */     GIR_EraseRootFromParent_Done,
     /*  827656 */   // Label 12773: @827656
     /*  827656 */   GIM_Try, /*On fail goto*//*Label 12774*/ GIMT_Encode4(827731), // Rule ID 22555 //
     /*  827661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827707 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  827707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  827710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827729 */     GIR_RootConstrainSelectedInstOperands,
     /*  827730 */     // GIR_Coverage, 22555,
     /*  827730 */     GIR_EraseRootFromParent_Done,
     /*  827731 */   // Label 12774: @827731
     /*  827731 */   GIM_Try, /*On fail goto*//*Label 12775*/ GIMT_Encode4(827806), // Rule ID 22558 //
     /*  827736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  827739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  827747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  827750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  827753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  827756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827782 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  827782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  827785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827804 */     GIR_RootConstrainSelectedInstOperands,
     /*  827805 */     // GIR_Coverage, 22558,
     /*  827805 */     GIR_EraseRootFromParent_Done,
     /*  827806 */   // Label 12775: @827806
     /*  827806 */   GIM_Try, /*On fail goto*//*Label 12776*/ GIMT_Encode4(827881), // Rule ID 22559 //
     /*  827811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  827814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  827822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  827825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  827828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  827831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827857 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  827857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  827860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827879 */     GIR_RootConstrainSelectedInstOperands,
     /*  827880 */     // GIR_Coverage, 22559,
     /*  827880 */     GIR_EraseRootFromParent_Done,
     /*  827881 */   // Label 12776: @827881
     /*  827881 */   GIM_Try, /*On fail goto*//*Label 12777*/ GIMT_Encode4(827956), // Rule ID 22562 //
     /*  827886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  827903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827932 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  827935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827954 */     GIR_RootConstrainSelectedInstOperands,
     /*  827955 */     // GIR_Coverage, 22562,
     /*  827955 */     GIR_EraseRootFromParent_Done,
     /*  827956 */   // Label 12777: @827956
     /*  827956 */   GIM_Try, /*On fail goto*//*Label 12778*/ GIMT_Encode4(828031), // Rule ID 22563 //
     /*  827961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  827978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828007 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  828010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828029 */     GIR_RootConstrainSelectedInstOperands,
     /*  828030 */     // GIR_Coverage, 22563,
     /*  828030 */     GIR_EraseRootFromParent_Done,
     /*  828031 */   // Label 12778: @828031
     /*  828031 */   GIM_Try, /*On fail goto*//*Label 12779*/ GIMT_Encode4(828106), // Rule ID 22566 //
     /*  828036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  828053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828082 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  828082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  828085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828104 */     GIR_RootConstrainSelectedInstOperands,
     /*  828105 */     // GIR_Coverage, 22566,
     /*  828105 */     GIR_EraseRootFromParent_Done,
     /*  828106 */   // Label 12779: @828106
     /*  828106 */   GIM_Try, /*On fail goto*//*Label 12780*/ GIMT_Encode4(828181), // Rule ID 22567 //
     /*  828111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  828128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828157 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  828160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828179 */     GIR_RootConstrainSelectedInstOperands,
     /*  828180 */     // GIR_Coverage, 22567,
     /*  828180 */     GIR_EraseRootFromParent_Done,
     /*  828181 */   // Label 12780: @828181
     /*  828181 */   GIM_Try, /*On fail goto*//*Label 12781*/ GIMT_Encode4(828256), // Rule ID 22570 //
     /*  828186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  828203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  828232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  828235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828254 */     GIR_RootConstrainSelectedInstOperands,
     /*  828255 */     // GIR_Coverage, 22570,
     /*  828255 */     GIR_EraseRootFromParent_Done,
     /*  828256 */   // Label 12781: @828256
     /*  828256 */   GIM_Try, /*On fail goto*//*Label 12782*/ GIMT_Encode4(828331), // Rule ID 22571 //
     /*  828261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  828278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828307 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  828310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828329 */     GIR_RootConstrainSelectedInstOperands,
     /*  828330 */     // GIR_Coverage, 22571,
     /*  828330 */     GIR_EraseRootFromParent_Done,
     /*  828331 */   // Label 12782: @828331
     /*  828331 */   GIM_Try, /*On fail goto*//*Label 12783*/ GIMT_Encode4(828406), // Rule ID 22574 //
     /*  828336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  828353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  828385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828404 */     GIR_RootConstrainSelectedInstOperands,
     /*  828405 */     // GIR_Coverage, 22574,
     /*  828405 */     GIR_EraseRootFromParent_Done,
     /*  828406 */   // Label 12783: @828406
     /*  828406 */   GIM_Try, /*On fail goto*//*Label 12784*/ GIMT_Encode4(828481), // Rule ID 22575 //
     /*  828411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  828428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828457 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  828460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828479 */     GIR_RootConstrainSelectedInstOperands,
     /*  828480 */     // GIR_Coverage, 22575,
     /*  828480 */     GIR_EraseRootFromParent_Done,
     /*  828481 */   // Label 12784: @828481
     /*  828481 */   GIM_Try, /*On fail goto*//*Label 12785*/ GIMT_Encode4(828556), // Rule ID 22578 //
     /*  828486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  828535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828554 */     GIR_RootConstrainSelectedInstOperands,
     /*  828555 */     // GIR_Coverage, 22578,
     /*  828555 */     GIR_EraseRootFromParent_Done,
     /*  828556 */   // Label 12785: @828556
     /*  828556 */   GIM_Try, /*On fail goto*//*Label 12786*/ GIMT_Encode4(828631), // Rule ID 22579 //
     /*  828561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828607 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  828610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828629 */     GIR_RootConstrainSelectedInstOperands,
     /*  828630 */     // GIR_Coverage, 22579,
     /*  828630 */     GIR_EraseRootFromParent_Done,
     /*  828631 */   // Label 12786: @828631
     /*  828631 */   GIM_Try, /*On fail goto*//*Label 12787*/ GIMT_Encode4(828706), // Rule ID 22582 //
     /*  828636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  828685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828704 */     GIR_RootConstrainSelectedInstOperands,
     /*  828705 */     // GIR_Coverage, 22582,
     /*  828705 */     GIR_EraseRootFromParent_Done,
     /*  828706 */   // Label 12787: @828706
     /*  828706 */   GIM_Try, /*On fail goto*//*Label 12788*/ GIMT_Encode4(828781), // Rule ID 22583 //
     /*  828711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828757 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  828760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828779 */     GIR_RootConstrainSelectedInstOperands,
     /*  828780 */     // GIR_Coverage, 22583,
     /*  828780 */     GIR_EraseRootFromParent_Done,
     /*  828781 */   // Label 12788: @828781
     /*  828781 */   GIM_Try, /*On fail goto*//*Label 12789*/ GIMT_Encode4(828856), // Rule ID 22586 //
     /*  828786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828832 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  828835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828854 */     GIR_RootConstrainSelectedInstOperands,
     /*  828855 */     // GIR_Coverage, 22586,
     /*  828855 */     GIR_EraseRootFromParent_Done,
     /*  828856 */   // Label 12789: @828856
     /*  828856 */   GIM_Try, /*On fail goto*//*Label 12790*/ GIMT_Encode4(828931), // Rule ID 22587 //
     /*  828861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828907 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  828907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  828910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828929 */     GIR_RootConstrainSelectedInstOperands,
     /*  828930 */     // GIR_Coverage, 22587,
     /*  828930 */     GIR_EraseRootFromParent_Done,
     /*  828931 */   // Label 12790: @828931
     /*  828931 */   GIM_Try, /*On fail goto*//*Label 12791*/ GIMT_Encode4(829006), // Rule ID 22590 //
     /*  828936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  828953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828982 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  828985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829004 */     GIR_RootConstrainSelectedInstOperands,
     /*  829005 */     // GIR_Coverage, 22590,
     /*  829005 */     GIR_EraseRootFromParent_Done,
     /*  829006 */   // Label 12791: @829006
     /*  829006 */   GIM_Try, /*On fail goto*//*Label 12792*/ GIMT_Encode4(829081), // Rule ID 22591 //
     /*  829011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  829028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829057 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  829057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  829060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829079 */     GIR_RootConstrainSelectedInstOperands,
     /*  829080 */     // GIR_Coverage, 22591,
     /*  829080 */     GIR_EraseRootFromParent_Done,
     /*  829081 */   // Label 12792: @829081
     /*  829081 */   GIM_Try, /*On fail goto*//*Label 12793*/ GIMT_Encode4(829156), // Rule ID 22594 //
     /*  829086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  829103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829132 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  829132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  829135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829154 */     GIR_RootConstrainSelectedInstOperands,
     /*  829155 */     // GIR_Coverage, 22594,
     /*  829155 */     GIR_EraseRootFromParent_Done,
     /*  829156 */   // Label 12793: @829156
     /*  829156 */   GIM_Try, /*On fail goto*//*Label 12794*/ GIMT_Encode4(829231), // Rule ID 22595 //
     /*  829161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  829178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829207 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  829207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  829210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829229 */     GIR_RootConstrainSelectedInstOperands,
     /*  829230 */     // GIR_Coverage, 22595,
     /*  829230 */     GIR_EraseRootFromParent_Done,
     /*  829231 */   // Label 12794: @829231
     /*  829231 */   GIM_Try, /*On fail goto*//*Label 12795*/ GIMT_Encode4(829306), // Rule ID 22598 //
     /*  829236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  829253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  829285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829304 */     GIR_RootConstrainSelectedInstOperands,
     /*  829305 */     // GIR_Coverage, 22598,
     /*  829305 */     GIR_EraseRootFromParent_Done,
     /*  829306 */   // Label 12795: @829306
     /*  829306 */   GIM_Try, /*On fail goto*//*Label 12796*/ GIMT_Encode4(829381), // Rule ID 22599 //
     /*  829311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  829328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829357 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  829360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829379 */     GIR_RootConstrainSelectedInstOperands,
     /*  829380 */     // GIR_Coverage, 22599,
     /*  829380 */     GIR_EraseRootFromParent_Done,
     /*  829381 */   // Label 12796: @829381
     /*  829381 */   GIM_Try, /*On fail goto*//*Label 12797*/ GIMT_Encode4(829456), // Rule ID 22602 //
     /*  829386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  829403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829432 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  829435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829454 */     GIR_RootConstrainSelectedInstOperands,
     /*  829455 */     // GIR_Coverage, 22602,
     /*  829455 */     GIR_EraseRootFromParent_Done,
     /*  829456 */   // Label 12797: @829456
     /*  829456 */   GIM_Try, /*On fail goto*//*Label 12798*/ GIMT_Encode4(829531), // Rule ID 22603 //
     /*  829461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  829478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829507 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  829510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829529 */     GIR_RootConstrainSelectedInstOperands,
     /*  829530 */     // GIR_Coverage, 22603,
     /*  829530 */     GIR_EraseRootFromParent_Done,
     /*  829531 */   // Label 12798: @829531
     /*  829531 */   GIM_Try, /*On fail goto*//*Label 12799*/ GIMT_Encode4(829606), // Rule ID 22606 //
     /*  829536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829582 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  829585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829604 */     GIR_RootConstrainSelectedInstOperands,
     /*  829605 */     // GIR_Coverage, 22606,
     /*  829605 */     GIR_EraseRootFromParent_Done,
     /*  829606 */   // Label 12799: @829606
     /*  829606 */   GIM_Try, /*On fail goto*//*Label 12800*/ GIMT_Encode4(829681), // Rule ID 22607 //
     /*  829611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829657 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  829660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829679 */     GIR_RootConstrainSelectedInstOperands,
     /*  829680 */     // GIR_Coverage, 22607,
     /*  829680 */     GIR_EraseRootFromParent_Done,
     /*  829681 */   // Label 12800: @829681
     /*  829681 */   GIM_Try, /*On fail goto*//*Label 12801*/ GIMT_Encode4(829756), // Rule ID 22610 //
     /*  829686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  829703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  829735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829754 */     GIR_RootConstrainSelectedInstOperands,
     /*  829755 */     // GIR_Coverage, 22610,
     /*  829755 */     GIR_EraseRootFromParent_Done,
     /*  829756 */   // Label 12801: @829756
     /*  829756 */   GIM_Try, /*On fail goto*//*Label 12802*/ GIMT_Encode4(829831), // Rule ID 22611 //
     /*  829761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  829778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829807 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  829810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829829 */     GIR_RootConstrainSelectedInstOperands,
     /*  829830 */     // GIR_Coverage, 22611,
     /*  829830 */     GIR_EraseRootFromParent_Done,
     /*  829831 */   // Label 12802: @829831
     /*  829831 */   GIM_Try, /*On fail goto*//*Label 12803*/ GIMT_Encode4(829906), // Rule ID 22614 //
     /*  829836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  829853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829882 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  829885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829904 */     GIR_RootConstrainSelectedInstOperands,
     /*  829905 */     // GIR_Coverage, 22614,
     /*  829905 */     GIR_EraseRootFromParent_Done,
     /*  829906 */   // Label 12803: @829906
     /*  829906 */   GIM_Try, /*On fail goto*//*Label 12804*/ GIMT_Encode4(829981), // Rule ID 22615 //
     /*  829911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  829928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829957 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  829960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829979 */     GIR_RootConstrainSelectedInstOperands,
     /*  829980 */     // GIR_Coverage, 22615,
     /*  829980 */     GIR_EraseRootFromParent_Done,
     /*  829981 */   // Label 12804: @829981
     /*  829981 */   GIM_Try, /*On fail goto*//*Label 12805*/ GIMT_Encode4(830056), // Rule ID 22618 //
     /*  829986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  830003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  830035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830054 */     GIR_RootConstrainSelectedInstOperands,
     /*  830055 */     // GIR_Coverage, 22618,
     /*  830055 */     GIR_EraseRootFromParent_Done,
     /*  830056 */   // Label 12805: @830056
     /*  830056 */   GIM_Try, /*On fail goto*//*Label 12806*/ GIMT_Encode4(830131), // Rule ID 22619 //
     /*  830061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  830078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830107 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  830110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830129 */     GIR_RootConstrainSelectedInstOperands,
     /*  830130 */     // GIR_Coverage, 22619,
     /*  830130 */     GIR_EraseRootFromParent_Done,
     /*  830131 */   // Label 12806: @830131
     /*  830131 */   GIM_Try, /*On fail goto*//*Label 12807*/ GIMT_Encode4(830206), // Rule ID 22622 //
     /*  830136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  830153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  830185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830204 */     GIR_RootConstrainSelectedInstOperands,
     /*  830205 */     // GIR_Coverage, 22622,
     /*  830205 */     GIR_EraseRootFromParent_Done,
     /*  830206 */   // Label 12807: @830206
     /*  830206 */   GIM_Try, /*On fail goto*//*Label 12808*/ GIMT_Encode4(830281), // Rule ID 22623 //
     /*  830211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  830228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830257 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  830260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830279 */     GIR_RootConstrainSelectedInstOperands,
     /*  830280 */     // GIR_Coverage, 22623,
     /*  830280 */     GIR_EraseRootFromParent_Done,
     /*  830281 */   // Label 12808: @830281
     /*  830281 */   GIM_Try, /*On fail goto*//*Label 12809*/ GIMT_Encode4(830356), // Rule ID 22626 //
     /*  830286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  830303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  830335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830354 */     GIR_RootConstrainSelectedInstOperands,
     /*  830355 */     // GIR_Coverage, 22626,
     /*  830355 */     GIR_EraseRootFromParent_Done,
     /*  830356 */   // Label 12809: @830356
     /*  830356 */   GIM_Try, /*On fail goto*//*Label 12810*/ GIMT_Encode4(830431), // Rule ID 22627 //
     /*  830361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  830378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830407 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  830410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830429 */     GIR_RootConstrainSelectedInstOperands,
     /*  830430 */     // GIR_Coverage, 22627,
     /*  830430 */     GIR_EraseRootFromParent_Done,
     /*  830431 */   // Label 12810: @830431
     /*  830431 */   GIM_Try, /*On fail goto*//*Label 12811*/ GIMT_Encode4(830506), // Rule ID 22630 //
     /*  830436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  830453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830482 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  830482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  830485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830504 */     GIR_RootConstrainSelectedInstOperands,
     /*  830505 */     // GIR_Coverage, 22630,
     /*  830505 */     GIR_EraseRootFromParent_Done,
     /*  830506 */   // Label 12811: @830506
     /*  830506 */   GIM_Try, /*On fail goto*//*Label 12812*/ GIMT_Encode4(830581), // Rule ID 22631 //
     /*  830511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  830528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830557 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  830557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  830560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830579 */     GIR_RootConstrainSelectedInstOperands,
     /*  830580 */     // GIR_Coverage, 22631,
     /*  830580 */     GIR_EraseRootFromParent_Done,
     /*  830581 */   // Label 12812: @830581
     /*  830581 */   GIM_Try, /*On fail goto*//*Label 12813*/ GIMT_Encode4(830656), // Rule ID 22634 //
     /*  830586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  830603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830632 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  830635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830654 */     GIR_RootConstrainSelectedInstOperands,
     /*  830655 */     // GIR_Coverage, 22634,
     /*  830655 */     GIR_EraseRootFromParent_Done,
     /*  830656 */   // Label 12813: @830656
     /*  830656 */   GIM_Try, /*On fail goto*//*Label 12814*/ GIMT_Encode4(830731), // Rule ID 22635 //
     /*  830661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  830678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830707 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  830710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830729 */     GIR_RootConstrainSelectedInstOperands,
     /*  830730 */     // GIR_Coverage, 22635,
     /*  830730 */     GIR_EraseRootFromParent_Done,
     /*  830731 */   // Label 12814: @830731
     /*  830731 */   GIM_Try, /*On fail goto*//*Label 12815*/ GIMT_Encode4(830806), // Rule ID 22638 //
     /*  830736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  830785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830804 */     GIR_RootConstrainSelectedInstOperands,
     /*  830805 */     // GIR_Coverage, 22638,
     /*  830805 */     GIR_EraseRootFromParent_Done,
     /*  830806 */   // Label 12815: @830806
     /*  830806 */   GIM_Try, /*On fail goto*//*Label 12816*/ GIMT_Encode4(830881), // Rule ID 22639 //
     /*  830811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830857 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  830860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830879 */     GIR_RootConstrainSelectedInstOperands,
     /*  830880 */     // GIR_Coverage, 22639,
     /*  830880 */     GIR_EraseRootFromParent_Done,
     /*  830881 */   // Label 12816: @830881
     /*  830881 */   GIM_Try, /*On fail goto*//*Label 12817*/ GIMT_Encode4(830956), // Rule ID 22642 //
     /*  830886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  830903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830932 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  830932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  830935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830954 */     GIR_RootConstrainSelectedInstOperands,
     /*  830955 */     // GIR_Coverage, 22642,
     /*  830955 */     GIR_EraseRootFromParent_Done,
     /*  830956 */   // Label 12817: @830956
     /*  830956 */   GIM_Try, /*On fail goto*//*Label 12818*/ GIMT_Encode4(831031), // Rule ID 22643 //
     /*  830961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  830978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831007 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  831007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  831010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831029 */     GIR_RootConstrainSelectedInstOperands,
     /*  831030 */     // GIR_Coverage, 22643,
     /*  831030 */     GIR_EraseRootFromParent_Done,
     /*  831031 */   // Label 12818: @831031
     /*  831031 */   GIM_Try, /*On fail goto*//*Label 12819*/ GIMT_Encode4(831106), // Rule ID 22646 //
     /*  831036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  831039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  831053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  831082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  831085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831104 */     GIR_RootConstrainSelectedInstOperands,
     /*  831105 */     // GIR_Coverage, 22646,
     /*  831105 */     GIR_EraseRootFromParent_Done,
     /*  831106 */   // Label 12819: @831106
     /*  831106 */   GIM_Try, /*On fail goto*//*Label 12820*/ GIMT_Encode4(831181), // Rule ID 22647 //
     /*  831111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  831114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  831128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831157 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  831157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  831160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831179 */     GIR_RootConstrainSelectedInstOperands,
     /*  831180 */     // GIR_Coverage, 22647,
     /*  831180 */     GIR_EraseRootFromParent_Done,
     /*  831181 */   // Label 12820: @831181
     /*  831181 */   GIM_Try, /*On fail goto*//*Label 12821*/ GIMT_Encode4(831256), // Rule ID 22650 //
     /*  831186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  831203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  831235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831254 */     GIR_RootConstrainSelectedInstOperands,
     /*  831255 */     // GIR_Coverage, 22650,
     /*  831255 */     GIR_EraseRootFromParent_Done,
     /*  831256 */   // Label 12821: @831256
     /*  831256 */   GIM_Try, /*On fail goto*//*Label 12822*/ GIMT_Encode4(831331), // Rule ID 22651 //
     /*  831261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  831278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831307 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  831310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831329 */     GIR_RootConstrainSelectedInstOperands,
     /*  831330 */     // GIR_Coverage, 22651,
     /*  831330 */     GIR_EraseRootFromParent_Done,
     /*  831331 */   // Label 12822: @831331
     /*  831331 */   GIM_Try, /*On fail goto*//*Label 12823*/ GIMT_Encode4(831406), // Rule ID 22654 //
     /*  831336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  831353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831382 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  831385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831404 */     GIR_RootConstrainSelectedInstOperands,
     /*  831405 */     // GIR_Coverage, 22654,
     /*  831405 */     GIR_EraseRootFromParent_Done,
     /*  831406 */   // Label 12823: @831406
     /*  831406 */   GIM_Try, /*On fail goto*//*Label 12824*/ GIMT_Encode4(831481), // Rule ID 22655 //
     /*  831411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  831428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831457 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  831460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831479 */     GIR_RootConstrainSelectedInstOperands,
     /*  831480 */     // GIR_Coverage, 22655,
     /*  831480 */     GIR_EraseRootFromParent_Done,
     /*  831481 */   // Label 12824: @831481
     /*  831481 */   GIM_Try, /*On fail goto*//*Label 12825*/ GIMT_Encode4(831556), // Rule ID 22658 //
     /*  831486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  831503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831532 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  831535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831554 */     GIR_RootConstrainSelectedInstOperands,
     /*  831555 */     // GIR_Coverage, 22658,
     /*  831555 */     GIR_EraseRootFromParent_Done,
     /*  831556 */   // Label 12825: @831556
     /*  831556 */   GIM_Try, /*On fail goto*//*Label 12826*/ GIMT_Encode4(831631), // Rule ID 22659 //
     /*  831561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  831578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831607 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  831610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831629 */     GIR_RootConstrainSelectedInstOperands,
     /*  831630 */     // GIR_Coverage, 22659,
     /*  831630 */     GIR_EraseRootFromParent_Done,
     /*  831631 */   // Label 12826: @831631
     /*  831631 */   GIM_Try, /*On fail goto*//*Label 12827*/ GIMT_Encode4(831706), // Rule ID 22662 //
     /*  831636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  831685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831704 */     GIR_RootConstrainSelectedInstOperands,
     /*  831705 */     // GIR_Coverage, 22662,
     /*  831705 */     GIR_EraseRootFromParent_Done,
     /*  831706 */   // Label 12827: @831706
     /*  831706 */   GIM_Try, /*On fail goto*//*Label 12828*/ GIMT_Encode4(831781), // Rule ID 22663 //
     /*  831711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831757 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  831760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831779 */     GIR_RootConstrainSelectedInstOperands,
     /*  831780 */     // GIR_Coverage, 22663,
     /*  831780 */     GIR_EraseRootFromParent_Done,
     /*  831781 */   // Label 12828: @831781
     /*  831781 */   GIM_Try, /*On fail goto*//*Label 12829*/ GIMT_Encode4(831856), // Rule ID 22666 //
     /*  831786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831832 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  831835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831854 */     GIR_RootConstrainSelectedInstOperands,
     /*  831855 */     // GIR_Coverage, 22666,
     /*  831855 */     GIR_EraseRootFromParent_Done,
     /*  831856 */   // Label 12829: @831856
     /*  831856 */   GIM_Try, /*On fail goto*//*Label 12830*/ GIMT_Encode4(831931), // Rule ID 22667 //
     /*  831861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831907 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  831910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831929 */     GIR_RootConstrainSelectedInstOperands,
     /*  831930 */     // GIR_Coverage, 22667,
     /*  831930 */     GIR_EraseRootFromParent_Done,
     /*  831931 */   // Label 12830: @831931
     /*  831931 */   GIM_Try, /*On fail goto*//*Label 12831*/ GIMT_Encode4(832006), // Rule ID 22670 //
     /*  831936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  831953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  831985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  832001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832004 */     GIR_RootConstrainSelectedInstOperands,
     /*  832005 */     // GIR_Coverage, 22670,
     /*  832005 */     GIR_EraseRootFromParent_Done,
     /*  832006 */   // Label 12831: @832006
     /*  832006 */   GIM_Try, /*On fail goto*//*Label 12832*/ GIMT_Encode4(832081), // Rule ID 22671 //
     /*  832011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  832028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832057 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  832057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  832060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  832076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832079 */     GIR_RootConstrainSelectedInstOperands,
     /*  832080 */     // GIR_Coverage, 22671,
     /*  832080 */     GIR_EraseRootFromParent_Done,
     /*  832081 */   // Label 12832: @832081
     /*  832081 */   GIM_Try, /*On fail goto*//*Label 12833*/ GIMT_Encode4(832156), // Rule ID 22674 //
     /*  832086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  832103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832132 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  832135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832154 */     GIR_RootConstrainSelectedInstOperands,
     /*  832155 */     // GIR_Coverage, 22674,
     /*  832155 */     GIR_EraseRootFromParent_Done,
     /*  832156 */   // Label 12833: @832156
     /*  832156 */   GIM_Try, /*On fail goto*//*Label 12834*/ GIMT_Encode4(832231), // Rule ID 22675 //
     /*  832161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  832178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832207 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  832210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832229 */     GIR_RootConstrainSelectedInstOperands,
     /*  832230 */     // GIR_Coverage, 22675,
     /*  832230 */     GIR_EraseRootFromParent_Done,
     /*  832231 */   // Label 12834: @832231
     /*  832231 */   GIM_Try, /*On fail goto*//*Label 12835*/ GIMT_Encode4(832306), // Rule ID 22678 //
     /*  832236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  832253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832282 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  832285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832304 */     GIR_RootConstrainSelectedInstOperands,
     /*  832305 */     // GIR_Coverage, 22678,
     /*  832305 */     GIR_EraseRootFromParent_Done,
     /*  832306 */   // Label 12835: @832306
     /*  832306 */   GIM_Try, /*On fail goto*//*Label 12836*/ GIMT_Encode4(832381), // Rule ID 22679 //
     /*  832311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  832328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832357 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  832360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832379 */     GIR_RootConstrainSelectedInstOperands,
     /*  832380 */     // GIR_Coverage, 22679,
     /*  832380 */     GIR_EraseRootFromParent_Done,
     /*  832381 */   // Label 12836: @832381
     /*  832381 */   GIM_Try, /*On fail goto*//*Label 12837*/ GIMT_Encode4(832456), // Rule ID 22682 //
     /*  832386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  832403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  832435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832454 */     GIR_RootConstrainSelectedInstOperands,
     /*  832455 */     // GIR_Coverage, 22682,
     /*  832455 */     GIR_EraseRootFromParent_Done,
     /*  832456 */   // Label 12837: @832456
     /*  832456 */   GIM_Try, /*On fail goto*//*Label 12838*/ GIMT_Encode4(832531), // Rule ID 22683 //
     /*  832461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  832478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832507 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  832510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832529 */     GIR_RootConstrainSelectedInstOperands,
     /*  832530 */     // GIR_Coverage, 22683,
     /*  832530 */     GIR_EraseRootFromParent_Done,
     /*  832531 */   // Label 12838: @832531
     /*  832531 */   GIM_Try, /*On fail goto*//*Label 12839*/ GIMT_Encode4(832606), // Rule ID 22686 //
     /*  832536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832582 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  832585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832604 */     GIR_RootConstrainSelectedInstOperands,
     /*  832605 */     // GIR_Coverage, 22686,
     /*  832605 */     GIR_EraseRootFromParent_Done,
     /*  832606 */   // Label 12839: @832606
     /*  832606 */   GIM_Try, /*On fail goto*//*Label 12840*/ GIMT_Encode4(832681), // Rule ID 22687 //
     /*  832611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832657 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  832660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832679 */     GIR_RootConstrainSelectedInstOperands,
     /*  832680 */     // GIR_Coverage, 22687,
     /*  832680 */     GIR_EraseRootFromParent_Done,
     /*  832681 */   // Label 12840: @832681
     /*  832681 */   GIM_Try, /*On fail goto*//*Label 12841*/ GIMT_Encode4(832756), // Rule ID 22690 //
     /*  832686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832732 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  832735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832754 */     GIR_RootConstrainSelectedInstOperands,
     /*  832755 */     // GIR_Coverage, 22690,
     /*  832755 */     GIR_EraseRootFromParent_Done,
     /*  832756 */   // Label 12841: @832756
     /*  832756 */   GIM_Try, /*On fail goto*//*Label 12842*/ GIMT_Encode4(832831), // Rule ID 22691 //
     /*  832761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832807 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  832810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832829 */     GIR_RootConstrainSelectedInstOperands,
     /*  832830 */     // GIR_Coverage, 22691,
     /*  832830 */     GIR_EraseRootFromParent_Done,
     /*  832831 */   // Label 12842: @832831
     /*  832831 */   GIM_Try, /*On fail goto*//*Label 12843*/ GIMT_Encode4(832906), // Rule ID 22694 //
     /*  832836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832882 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  832885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832904 */     GIR_RootConstrainSelectedInstOperands,
     /*  832905 */     // GIR_Coverage, 22694,
     /*  832905 */     GIR_EraseRootFromParent_Done,
     /*  832906 */   // Label 12843: @832906
     /*  832906 */   GIM_Try, /*On fail goto*//*Label 12844*/ GIMT_Encode4(832981), // Rule ID 22695 //
     /*  832911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832957 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  832960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832979 */     GIR_RootConstrainSelectedInstOperands,
     /*  832980 */     // GIR_Coverage, 22695,
     /*  832980 */     GIR_EraseRootFromParent_Done,
     /*  832981 */   // Label 12844: @832981
     /*  832981 */   GIM_Try, /*On fail goto*//*Label 12845*/ GIMT_Encode4(833056), // Rule ID 22698 //
     /*  832986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  833003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  833035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833054 */     GIR_RootConstrainSelectedInstOperands,
     /*  833055 */     // GIR_Coverage, 22698,
     /*  833055 */     GIR_EraseRootFromParent_Done,
     /*  833056 */   // Label 12845: @833056
     /*  833056 */   GIM_Try, /*On fail goto*//*Label 12846*/ GIMT_Encode4(833131), // Rule ID 22699 //
     /*  833061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  833078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833107 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  833110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833129 */     GIR_RootConstrainSelectedInstOperands,
     /*  833130 */     // GIR_Coverage, 22699,
     /*  833130 */     GIR_EraseRootFromParent_Done,
     /*  833131 */   // Label 12846: @833131
     /*  833131 */   GIM_Try, /*On fail goto*//*Label 12847*/ GIMT_Encode4(833206), // Rule ID 22702 //
     /*  833136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  833153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  833185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833204 */     GIR_RootConstrainSelectedInstOperands,
     /*  833205 */     // GIR_Coverage, 22702,
     /*  833205 */     GIR_EraseRootFromParent_Done,
     /*  833206 */   // Label 12847: @833206
     /*  833206 */   GIM_Try, /*On fail goto*//*Label 12848*/ GIMT_Encode4(833281), // Rule ID 22703 //
     /*  833211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  833228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833257 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  833260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833279 */     GIR_RootConstrainSelectedInstOperands,
     /*  833280 */     // GIR_Coverage, 22703,
     /*  833280 */     GIR_EraseRootFromParent_Done,
     /*  833281 */   // Label 12848: @833281
     /*  833281 */   GIM_Try, /*On fail goto*//*Label 12849*/ GIMT_Encode4(833356), // Rule ID 22706 //
     /*  833286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  833303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  833335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833354 */     GIR_RootConstrainSelectedInstOperands,
     /*  833355 */     // GIR_Coverage, 22706,
     /*  833355 */     GIR_EraseRootFromParent_Done,
     /*  833356 */   // Label 12849: @833356
     /*  833356 */   GIM_Try, /*On fail goto*//*Label 12850*/ GIMT_Encode4(833431), // Rule ID 22707 //
     /*  833361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  833378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833407 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  833410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833429 */     GIR_RootConstrainSelectedInstOperands,
     /*  833430 */     // GIR_Coverage, 22707,
     /*  833430 */     GIR_EraseRootFromParent_Done,
     /*  833431 */   // Label 12850: @833431
     /*  833431 */   GIM_Try, /*On fail goto*//*Label 12851*/ GIMT_Encode4(833506), // Rule ID 22710 //
     /*  833436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  833453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833482 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  833485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833504 */     GIR_RootConstrainSelectedInstOperands,
     /*  833505 */     // GIR_Coverage, 22710,
     /*  833505 */     GIR_EraseRootFromParent_Done,
     /*  833506 */   // Label 12851: @833506
     /*  833506 */   GIM_Try, /*On fail goto*//*Label 12852*/ GIMT_Encode4(833581), // Rule ID 22711 //
     /*  833511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  833528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833557 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  833560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833579 */     GIR_RootConstrainSelectedInstOperands,
     /*  833580 */     // GIR_Coverage, 22711,
     /*  833580 */     GIR_EraseRootFromParent_Done,
     /*  833581 */   // Label 12852: @833581
     /*  833581 */   GIM_Try, /*On fail goto*//*Label 12853*/ GIMT_Encode4(833656), // Rule ID 22714 //
     /*  833586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833632 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  833635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833654 */     GIR_RootConstrainSelectedInstOperands,
     /*  833655 */     // GIR_Coverage, 22714,
     /*  833655 */     GIR_EraseRootFromParent_Done,
     /*  833656 */   // Label 12853: @833656
     /*  833656 */   GIM_Try, /*On fail goto*//*Label 12854*/ GIMT_Encode4(833731), // Rule ID 22715 //
     /*  833661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833707 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  833710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833729 */     GIR_RootConstrainSelectedInstOperands,
     /*  833730 */     // GIR_Coverage, 22715,
     /*  833730 */     GIR_EraseRootFromParent_Done,
     /*  833731 */   // Label 12854: @833731
     /*  833731 */   GIM_Try, /*On fail goto*//*Label 12855*/ GIMT_Encode4(833806), // Rule ID 22718 //
     /*  833736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833782 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  833782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  833785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833804 */     GIR_RootConstrainSelectedInstOperands,
     /*  833805 */     // GIR_Coverage, 22718,
     /*  833805 */     GIR_EraseRootFromParent_Done,
     /*  833806 */   // Label 12855: @833806
     /*  833806 */   GIM_Try, /*On fail goto*//*Label 12856*/ GIMT_Encode4(833881), // Rule ID 22719 //
     /*  833811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833857 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  833857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  833860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833879 */     GIR_RootConstrainSelectedInstOperands,
     /*  833880 */     // GIR_Coverage, 22719,
     /*  833880 */     GIR_EraseRootFromParent_Done,
     /*  833881 */   // Label 12856: @833881
     /*  833881 */   GIM_Try, /*On fail goto*//*Label 12857*/ GIMT_Encode4(833956), // Rule ID 22722 //
     /*  833886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  833903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  833935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833954 */     GIR_RootConstrainSelectedInstOperands,
     /*  833955 */     // GIR_Coverage, 22722,
     /*  833955 */     GIR_EraseRootFromParent_Done,
     /*  833956 */   // Label 12857: @833956
     /*  833956 */   GIM_Try, /*On fail goto*//*Label 12858*/ GIMT_Encode4(834031), // Rule ID 22723 //
     /*  833961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  833978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834007 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  834010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834029 */     GIR_RootConstrainSelectedInstOperands,
     /*  834030 */     // GIR_Coverage, 22723,
     /*  834030 */     GIR_EraseRootFromParent_Done,
     /*  834031 */   // Label 12858: @834031
     /*  834031 */   GIM_Try, /*On fail goto*//*Label 12859*/ GIMT_Encode4(834106), // Rule ID 22726 //
     /*  834036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  834053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834082 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  834085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834104 */     GIR_RootConstrainSelectedInstOperands,
     /*  834105 */     // GIR_Coverage, 22726,
     /*  834105 */     GIR_EraseRootFromParent_Done,
     /*  834106 */   // Label 12859: @834106
     /*  834106 */   GIM_Try, /*On fail goto*//*Label 12860*/ GIMT_Encode4(834181), // Rule ID 22727 //
     /*  834111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  834128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834157 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  834160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834179 */     GIR_RootConstrainSelectedInstOperands,
     /*  834180 */     // GIR_Coverage, 22727,
     /*  834180 */     GIR_EraseRootFromParent_Done,
     /*  834181 */   // Label 12860: @834181
     /*  834181 */   GIM_Try, /*On fail goto*//*Label 12861*/ GIMT_Encode4(834256), // Rule ID 22730 //
     /*  834186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  834203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834232 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  834232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  834235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834254 */     GIR_RootConstrainSelectedInstOperands,
     /*  834255 */     // GIR_Coverage, 22730,
     /*  834255 */     GIR_EraseRootFromParent_Done,
     /*  834256 */   // Label 12861: @834256
     /*  834256 */   GIM_Try, /*On fail goto*//*Label 12862*/ GIMT_Encode4(834331), // Rule ID 22731 //
     /*  834261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  834278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834307 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  834307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  834310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834329 */     GIR_RootConstrainSelectedInstOperands,
     /*  834330 */     // GIR_Coverage, 22731,
     /*  834330 */     GIR_EraseRootFromParent_Done,
     /*  834331 */   // Label 12862: @834331
     /*  834331 */   GIM_Try, /*On fail goto*//*Label 12863*/ GIMT_Encode4(834406), // Rule ID 22734 //
     /*  834336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  834353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  834385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834404 */     GIR_RootConstrainSelectedInstOperands,
     /*  834405 */     // GIR_Coverage, 22734,
     /*  834405 */     GIR_EraseRootFromParent_Done,
     /*  834406 */   // Label 12863: @834406
     /*  834406 */   GIM_Try, /*On fail goto*//*Label 12864*/ GIMT_Encode4(834481), // Rule ID 22735 //
     /*  834411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  834428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834457 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  834460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834479 */     GIR_RootConstrainSelectedInstOperands,
     /*  834480 */     // GIR_Coverage, 22735,
     /*  834480 */     GIR_EraseRootFromParent_Done,
     /*  834481 */   // Label 12864: @834481
     /*  834481 */   GIM_Try, /*On fail goto*//*Label 12865*/ GIMT_Encode4(834556), // Rule ID 22738 //
     /*  834486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  834535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834554 */     GIR_RootConstrainSelectedInstOperands,
     /*  834555 */     // GIR_Coverage, 22738,
     /*  834555 */     GIR_EraseRootFromParent_Done,
     /*  834556 */   // Label 12865: @834556
     /*  834556 */   GIM_Try, /*On fail goto*//*Label 12866*/ GIMT_Encode4(834631), // Rule ID 22739 //
     /*  834561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834607 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  834610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834629 */     GIR_RootConstrainSelectedInstOperands,
     /*  834630 */     // GIR_Coverage, 22739,
     /*  834630 */     GIR_EraseRootFromParent_Done,
     /*  834631 */   // Label 12866: @834631
     /*  834631 */   GIM_Try, /*On fail goto*//*Label 12867*/ GIMT_Encode4(834706), // Rule ID 22742 //
     /*  834636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  834685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834704 */     GIR_RootConstrainSelectedInstOperands,
     /*  834705 */     // GIR_Coverage, 22742,
     /*  834705 */     GIR_EraseRootFromParent_Done,
     /*  834706 */   // Label 12867: @834706
     /*  834706 */   GIM_Try, /*On fail goto*//*Label 12868*/ GIMT_Encode4(834781), // Rule ID 22743 //
     /*  834711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834757 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  834760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834779 */     GIR_RootConstrainSelectedInstOperands,
     /*  834780 */     // GIR_Coverage, 22743,
     /*  834780 */     GIR_EraseRootFromParent_Done,
     /*  834781 */   // Label 12868: @834781
     /*  834781 */   GIM_Try, /*On fail goto*//*Label 12869*/ GIMT_Encode4(834856), // Rule ID 22746 //
     /*  834786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  834803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834832 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  834835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834854 */     GIR_RootConstrainSelectedInstOperands,
     /*  834855 */     // GIR_Coverage, 22746,
     /*  834855 */     GIR_EraseRootFromParent_Done,
     /*  834856 */   // Label 12869: @834856
     /*  834856 */   GIM_Try, /*On fail goto*//*Label 12870*/ GIMT_Encode4(834931), // Rule ID 22747 //
     /*  834861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  834878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834907 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  834910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834929 */     GIR_RootConstrainSelectedInstOperands,
     /*  834930 */     // GIR_Coverage, 22747,
     /*  834930 */     GIR_EraseRootFromParent_Done,
     /*  834931 */   // Label 12870: @834931
     /*  834931 */   GIM_Try, /*On fail goto*//*Label 12871*/ GIMT_Encode4(835006), // Rule ID 22750 //
     /*  834936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  834953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834982 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  834985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835004 */     GIR_RootConstrainSelectedInstOperands,
     /*  835005 */     // GIR_Coverage, 22750,
     /*  835005 */     GIR_EraseRootFromParent_Done,
     /*  835006 */   // Label 12871: @835006
     /*  835006 */   GIM_Try, /*On fail goto*//*Label 12872*/ GIMT_Encode4(835081), // Rule ID 22751 //
     /*  835011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  835028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835057 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  835060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835079 */     GIR_RootConstrainSelectedInstOperands,
     /*  835080 */     // GIR_Coverage, 22751,
     /*  835080 */     GIR_EraseRootFromParent_Done,
     /*  835081 */   // Label 12872: @835081
     /*  835081 */   GIM_Try, /*On fail goto*//*Label 12873*/ GIMT_Encode4(835156), // Rule ID 22754 //
     /*  835086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  835103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835132 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  835135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835154 */     GIR_RootConstrainSelectedInstOperands,
     /*  835155 */     // GIR_Coverage, 22754,
     /*  835155 */     GIR_EraseRootFromParent_Done,
     /*  835156 */   // Label 12873: @835156
     /*  835156 */   GIM_Try, /*On fail goto*//*Label 12874*/ GIMT_Encode4(835231), // Rule ID 22755 //
     /*  835161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  835178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835207 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  835210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835229 */     GIR_RootConstrainSelectedInstOperands,
     /*  835230 */     // GIR_Coverage, 22755,
     /*  835230 */     GIR_EraseRootFromParent_Done,
     /*  835231 */   // Label 12874: @835231
     /*  835231 */   GIM_Try, /*On fail goto*//*Label 12875*/ GIMT_Encode4(835306), // Rule ID 22758 //
     /*  835236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  835253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  835285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835304 */     GIR_RootConstrainSelectedInstOperands,
     /*  835305 */     // GIR_Coverage, 22758,
     /*  835305 */     GIR_EraseRootFromParent_Done,
     /*  835306 */   // Label 12875: @835306
     /*  835306 */   GIM_Try, /*On fail goto*//*Label 12876*/ GIMT_Encode4(835381), // Rule ID 22759 //
     /*  835311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  835328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835357 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  835360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835379 */     GIR_RootConstrainSelectedInstOperands,
     /*  835380 */     // GIR_Coverage, 22759,
     /*  835380 */     GIR_EraseRootFromParent_Done,
     /*  835381 */   // Label 12876: @835381
     /*  835381 */   GIM_Try, /*On fail goto*//*Label 12877*/ GIMT_Encode4(835456), // Rule ID 22762 //
     /*  835386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  835403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835432 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  835435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835454 */     GIR_RootConstrainSelectedInstOperands,
     /*  835455 */     // GIR_Coverage, 22762,
     /*  835455 */     GIR_EraseRootFromParent_Done,
     /*  835456 */   // Label 12877: @835456
     /*  835456 */   GIM_Try, /*On fail goto*//*Label 12878*/ GIMT_Encode4(835531), // Rule ID 22763 //
     /*  835461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  835478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835507 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  835510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835529 */     GIR_RootConstrainSelectedInstOperands,
     /*  835530 */     // GIR_Coverage, 22763,
     /*  835530 */     GIR_EraseRootFromParent_Done,
     /*  835531 */   // Label 12878: @835531
     /*  835531 */   GIM_Try, /*On fail goto*//*Label 12879*/ GIMT_Encode4(835606), // Rule ID 22766 //
     /*  835536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835582 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  835585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835604 */     GIR_RootConstrainSelectedInstOperands,
     /*  835605 */     // GIR_Coverage, 22766,
     /*  835605 */     GIR_EraseRootFromParent_Done,
     /*  835606 */   // Label 12879: @835606
     /*  835606 */   GIM_Try, /*On fail goto*//*Label 12880*/ GIMT_Encode4(835681), // Rule ID 22767 //
     /*  835611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835657 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  835660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835679 */     GIR_RootConstrainSelectedInstOperands,
     /*  835680 */     // GIR_Coverage, 22767,
     /*  835680 */     GIR_EraseRootFromParent_Done,
     /*  835681 */   // Label 12880: @835681
     /*  835681 */   GIM_Try, /*On fail goto*//*Label 12881*/ GIMT_Encode4(835756), // Rule ID 22770 //
     /*  835686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  835703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835732 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  835732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  835735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835754 */     GIR_RootConstrainSelectedInstOperands,
     /*  835755 */     // GIR_Coverage, 22770,
     /*  835755 */     GIR_EraseRootFromParent_Done,
     /*  835756 */   // Label 12881: @835756
     /*  835756 */   GIM_Try, /*On fail goto*//*Label 12882*/ GIMT_Encode4(835831), // Rule ID 22771 //
     /*  835761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  835778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835807 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  835807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  835810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835829 */     GIR_RootConstrainSelectedInstOperands,
     /*  835830 */     // GIR_Coverage, 22771,
     /*  835830 */     GIR_EraseRootFromParent_Done,
     /*  835831 */   // Label 12882: @835831
     /*  835831 */   GIM_Try, /*On fail goto*//*Label 12883*/ GIMT_Encode4(835906), // Rule ID 22774 //
     /*  835836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  835853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  835882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  835885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835904 */     GIR_RootConstrainSelectedInstOperands,
     /*  835905 */     // GIR_Coverage, 22774,
     /*  835905 */     GIR_EraseRootFromParent_Done,
     /*  835906 */   // Label 12883: @835906
     /*  835906 */   GIM_Try, /*On fail goto*//*Label 12884*/ GIMT_Encode4(835981), // Rule ID 22775 //
     /*  835911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  835928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835957 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  835957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  835960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835979 */     GIR_RootConstrainSelectedInstOperands,
     /*  835980 */     // GIR_Coverage, 22775,
     /*  835980 */     GIR_EraseRootFromParent_Done,
     /*  835981 */   // Label 12884: @835981
     /*  835981 */   GIM_Try, /*On fail goto*//*Label 12885*/ GIMT_Encode4(836056), // Rule ID 22778 //
     /*  835986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  836003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  836035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836054 */     GIR_RootConstrainSelectedInstOperands,
     /*  836055 */     // GIR_Coverage, 22778,
     /*  836055 */     GIR_EraseRootFromParent_Done,
     /*  836056 */   // Label 12885: @836056
     /*  836056 */   GIM_Try, /*On fail goto*//*Label 12886*/ GIMT_Encode4(836131), // Rule ID 22779 //
     /*  836061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  836078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836107 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  836110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836129 */     GIR_RootConstrainSelectedInstOperands,
     /*  836130 */     // GIR_Coverage, 22779,
     /*  836130 */     GIR_EraseRootFromParent_Done,
     /*  836131 */   // Label 12886: @836131
     /*  836131 */   GIM_Try, /*On fail goto*//*Label 12887*/ GIMT_Encode4(836206), // Rule ID 22782 //
     /*  836136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  836153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836182 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  836185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836204 */     GIR_RootConstrainSelectedInstOperands,
     /*  836205 */     // GIR_Coverage, 22782,
     /*  836205 */     GIR_EraseRootFromParent_Done,
     /*  836206 */   // Label 12887: @836206
     /*  836206 */   GIM_Try, /*On fail goto*//*Label 12888*/ GIMT_Encode4(836281), // Rule ID 22783 //
     /*  836211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  836228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836257 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  836260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836279 */     GIR_RootConstrainSelectedInstOperands,
     /*  836280 */     // GIR_Coverage, 22783,
     /*  836280 */     GIR_EraseRootFromParent_Done,
     /*  836281 */   // Label 12888: @836281
     /*  836281 */   GIM_Try, /*On fail goto*//*Label 12889*/ GIMT_Encode4(836356), // Rule ID 22786 //
     /*  836286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  836303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836332 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  836335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836354 */     GIR_RootConstrainSelectedInstOperands,
     /*  836355 */     // GIR_Coverage, 22786,
     /*  836355 */     GIR_EraseRootFromParent_Done,
     /*  836356 */   // Label 12889: @836356
     /*  836356 */   GIM_Try, /*On fail goto*//*Label 12890*/ GIMT_Encode4(836431), // Rule ID 22787 //
     /*  836361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  836378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836407 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  836410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836429 */     GIR_RootConstrainSelectedInstOperands,
     /*  836430 */     // GIR_Coverage, 22787,
     /*  836430 */     GIR_EraseRootFromParent_Done,
     /*  836431 */   // Label 12890: @836431
     /*  836431 */   GIM_Try, /*On fail goto*//*Label 12891*/ GIMT_Encode4(836506), // Rule ID 22790 //
     /*  836436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  836453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  836482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  836485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836504 */     GIR_RootConstrainSelectedInstOperands,
     /*  836505 */     // GIR_Coverage, 22790,
     /*  836505 */     GIR_EraseRootFromParent_Done,
     /*  836506 */   // Label 12891: @836506
     /*  836506 */   GIM_Try, /*On fail goto*//*Label 12892*/ GIMT_Encode4(836581), // Rule ID 22791 //
     /*  836511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  836528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836557 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  836557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  836560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836579 */     GIR_RootConstrainSelectedInstOperands,
     /*  836580 */     // GIR_Coverage, 22791,
     /*  836580 */     GIR_EraseRootFromParent_Done,
     /*  836581 */   // Label 12892: @836581
     /*  836581 */   GIM_Try, /*On fail goto*//*Label 12893*/ GIMT_Encode4(836656), // Rule ID 22794 //
     /*  836586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  836603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  836635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836654 */     GIR_RootConstrainSelectedInstOperands,
     /*  836655 */     // GIR_Coverage, 22794,
     /*  836655 */     GIR_EraseRootFromParent_Done,
     /*  836656 */   // Label 12893: @836656
     /*  836656 */   GIM_Try, /*On fail goto*//*Label 12894*/ GIMT_Encode4(836731), // Rule ID 22795 //
     /*  836661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  836678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836707 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  836710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836729 */     GIR_RootConstrainSelectedInstOperands,
     /*  836730 */     // GIR_Coverage, 22795,
     /*  836730 */     GIR_EraseRootFromParent_Done,
     /*  836731 */   // Label 12894: @836731
     /*  836731 */   GIM_Try, /*On fail goto*//*Label 12895*/ GIMT_Encode4(836806), // Rule ID 22798 //
     /*  836736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  836753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836782 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  836785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836804 */     GIR_RootConstrainSelectedInstOperands,
     /*  836805 */     // GIR_Coverage, 22798,
     /*  836805 */     GIR_EraseRootFromParent_Done,
     /*  836806 */   // Label 12895: @836806
     /*  836806 */   GIM_Try, /*On fail goto*//*Label 12896*/ GIMT_Encode4(836881), // Rule ID 22799 //
     /*  836811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  836828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836857 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  836860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836879 */     GIR_RootConstrainSelectedInstOperands,
     /*  836880 */     // GIR_Coverage, 22799,
     /*  836880 */     GIR_EraseRootFromParent_Done,
     /*  836881 */   // Label 12896: @836881
     /*  836881 */   GIM_Try, /*On fail goto*//*Label 12897*/ GIMT_Encode4(836956), // Rule ID 22802 //
     /*  836886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  836903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836932 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  836932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  836935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836954 */     GIR_RootConstrainSelectedInstOperands,
     /*  836955 */     // GIR_Coverage, 22802,
     /*  836955 */     GIR_EraseRootFromParent_Done,
     /*  836956 */   // Label 12897: @836956
     /*  836956 */   GIM_Try, /*On fail goto*//*Label 12898*/ GIMT_Encode4(837031), // Rule ID 22803 //
     /*  836961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  836978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837007 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  837010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837029 */     GIR_RootConstrainSelectedInstOperands,
     /*  837030 */     // GIR_Coverage, 22803,
     /*  837030 */     GIR_EraseRootFromParent_Done,
     /*  837031 */   // Label 12898: @837031
     /*  837031 */   GIM_Try, /*On fail goto*//*Label 12899*/ GIMT_Encode4(837106), // Rule ID 22806 //
     /*  837036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  837053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837082 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  837085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837104 */     GIR_RootConstrainSelectedInstOperands,
     /*  837105 */     // GIR_Coverage, 22806,
     /*  837105 */     GIR_EraseRootFromParent_Done,
     /*  837106 */   // Label 12899: @837106
     /*  837106 */   GIM_Try, /*On fail goto*//*Label 12900*/ GIMT_Encode4(837181), // Rule ID 22807 //
     /*  837111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  837128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837157 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  837160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837179 */     GIR_RootConstrainSelectedInstOperands,
     /*  837180 */     // GIR_Coverage, 22807,
     /*  837180 */     GIR_EraseRootFromParent_Done,
     /*  837181 */   // Label 12900: @837181
     /*  837181 */   GIM_Try, /*On fail goto*//*Label 12901*/ GIMT_Encode4(837256), // Rule ID 22810 //
     /*  837186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  837203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  837235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837254 */     GIR_RootConstrainSelectedInstOperands,
     /*  837255 */     // GIR_Coverage, 22810,
     /*  837255 */     GIR_EraseRootFromParent_Done,
     /*  837256 */   // Label 12901: @837256
     /*  837256 */   GIM_Try, /*On fail goto*//*Label 12902*/ GIMT_Encode4(837331), // Rule ID 22811 //
     /*  837261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  837278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837307 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  837310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837329 */     GIR_RootConstrainSelectedInstOperands,
     /*  837330 */     // GIR_Coverage, 22811,
     /*  837330 */     GIR_EraseRootFromParent_Done,
     /*  837331 */   // Label 12902: @837331
     /*  837331 */   GIM_Try, /*On fail goto*//*Label 12903*/ GIMT_Encode4(837406), // Rule ID 22814 //
     /*  837336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  837353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  837385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837404 */     GIR_RootConstrainSelectedInstOperands,
     /*  837405 */     // GIR_Coverage, 22814,
     /*  837405 */     GIR_EraseRootFromParent_Done,
     /*  837406 */   // Label 12903: @837406
     /*  837406 */   GIM_Try, /*On fail goto*//*Label 12904*/ GIMT_Encode4(837481), // Rule ID 22815 //
     /*  837411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  837428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837457 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  837460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837479 */     GIR_RootConstrainSelectedInstOperands,
     /*  837480 */     // GIR_Coverage, 22815,
     /*  837480 */     GIR_EraseRootFromParent_Done,
     /*  837481 */   // Label 12904: @837481
     /*  837481 */   GIM_Try, /*On fail goto*//*Label 12905*/ GIMT_Encode4(837556), // Rule ID 22818 //
     /*  837486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  837503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  837535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837554 */     GIR_RootConstrainSelectedInstOperands,
     /*  837555 */     // GIR_Coverage, 22818,
     /*  837555 */     GIR_EraseRootFromParent_Done,
     /*  837556 */   // Label 12905: @837556
     /*  837556 */   GIM_Try, /*On fail goto*//*Label 12906*/ GIMT_Encode4(837631), // Rule ID 22819 //
     /*  837561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  837578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837607 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  837610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837629 */     GIR_RootConstrainSelectedInstOperands,
     /*  837630 */     // GIR_Coverage, 22819,
     /*  837630 */     GIR_EraseRootFromParent_Done,
     /*  837631 */   // Label 12906: @837631
     /*  837631 */   GIM_Try, /*On fail goto*//*Label 12907*/ GIMT_Encode4(837706), // Rule ID 22822 //
     /*  837636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  837653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  837685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837704 */     GIR_RootConstrainSelectedInstOperands,
     /*  837705 */     // GIR_Coverage, 22822,
     /*  837705 */     GIR_EraseRootFromParent_Done,
     /*  837706 */   // Label 12907: @837706
     /*  837706 */   GIM_Try, /*On fail goto*//*Label 12908*/ GIMT_Encode4(837781), // Rule ID 22823 //
     /*  837711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  837728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837757 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  837760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837779 */     GIR_RootConstrainSelectedInstOperands,
     /*  837780 */     // GIR_Coverage, 22823,
     /*  837780 */     GIR_EraseRootFromParent_Done,
     /*  837781 */   // Label 12908: @837781
     /*  837781 */   GIM_Try, /*On fail goto*//*Label 12909*/ GIMT_Encode4(837856), // Rule ID 22826 //
     /*  837786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  837803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837832 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  837835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837854 */     GIR_RootConstrainSelectedInstOperands,
     /*  837855 */     // GIR_Coverage, 22826,
     /*  837855 */     GIR_EraseRootFromParent_Done,
     /*  837856 */   // Label 12909: @837856
     /*  837856 */   GIM_Try, /*On fail goto*//*Label 12910*/ GIMT_Encode4(837931), // Rule ID 22827 //
     /*  837861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  837878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837907 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  837910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837929 */     GIR_RootConstrainSelectedInstOperands,
     /*  837930 */     // GIR_Coverage, 22827,
     /*  837930 */     GIR_EraseRootFromParent_Done,
     /*  837931 */   // Label 12910: @837931
     /*  837931 */   GIM_Try, /*On fail goto*//*Label 12911*/ GIMT_Encode4(838006), // Rule ID 22830 //
     /*  837936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  837953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837982 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  837985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838004 */     GIR_RootConstrainSelectedInstOperands,
     /*  838005 */     // GIR_Coverage, 22830,
     /*  838005 */     GIR_EraseRootFromParent_Done,
     /*  838006 */   // Label 12911: @838006
     /*  838006 */   GIM_Try, /*On fail goto*//*Label 12912*/ GIMT_Encode4(838081), // Rule ID 22831 //
     /*  838011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  838019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  838028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838057 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  838060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838079 */     GIR_RootConstrainSelectedInstOperands,
     /*  838080 */     // GIR_Coverage, 22831,
     /*  838080 */     GIR_EraseRootFromParent_Done,
     /*  838081 */   // Label 12912: @838081
     /*  838081 */   GIM_Try, /*On fail goto*//*Label 12913*/ GIMT_Encode4(838156), // Rule ID 22834 //
     /*  838086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  838094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  838103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838132 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  838135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838154 */     GIR_RootConstrainSelectedInstOperands,
     /*  838155 */     // GIR_Coverage, 22834,
     /*  838155 */     GIR_EraseRootFromParent_Done,
     /*  838156 */   // Label 12913: @838156
     /*  838156 */   GIM_Try, /*On fail goto*//*Label 12914*/ GIMT_Encode4(838231), // Rule ID 22835 //
     /*  838161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  838169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  838178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838207 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  838210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838229 */     GIR_RootConstrainSelectedInstOperands,
     /*  838230 */     // GIR_Coverage, 22835,
     /*  838230 */     GIR_EraseRootFromParent_Done,
     /*  838231 */   // Label 12914: @838231
     /*  838231 */   GIM_Try, /*On fail goto*//*Label 12915*/ GIMT_Encode4(838306), // Rule ID 22838 //
     /*  838236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  838244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  838253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  838285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838304 */     GIR_RootConstrainSelectedInstOperands,
     /*  838305 */     // GIR_Coverage, 22838,
     /*  838305 */     GIR_EraseRootFromParent_Done,
     /*  838306 */   // Label 12915: @838306
     /*  838306 */   GIM_Try, /*On fail goto*//*Label 12916*/ GIMT_Encode4(838381), // Rule ID 22839 //
     /*  838311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  838319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  838328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838357 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  838360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838379 */     GIR_RootConstrainSelectedInstOperands,
     /*  838380 */     // GIR_Coverage, 22839,
     /*  838380 */     GIR_EraseRootFromParent_Done,
     /*  838381 */   // Label 12916: @838381
     /*  838381 */   GIM_Try, /*On fail goto*//*Label 12917*/ GIMT_Encode4(838456), // Rule ID 22958 //
     /*  838386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  838403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838432 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  838435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838454 */     GIR_RootConstrainSelectedInstOperands,
     /*  838455 */     // GIR_Coverage, 22958,
     /*  838455 */     GIR_EraseRootFromParent_Done,
     /*  838456 */   // Label 12917: @838456
     /*  838456 */   GIM_Try, /*On fail goto*//*Label 12918*/ GIMT_Encode4(838531), // Rule ID 22959 //
     /*  838461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  838478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838507 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  838510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838529 */     GIR_RootConstrainSelectedInstOperands,
     /*  838530 */     // GIR_Coverage, 22959,
     /*  838530 */     GIR_EraseRootFromParent_Done,
     /*  838531 */   // Label 12918: @838531
     /*  838531 */   GIM_Try, /*On fail goto*//*Label 12919*/ GIMT_Encode4(838606), // Rule ID 22962 //
     /*  838536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  838553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838582 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  838585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838604 */     GIR_RootConstrainSelectedInstOperands,
     /*  838605 */     // GIR_Coverage, 22962,
     /*  838605 */     GIR_EraseRootFromParent_Done,
     /*  838606 */   // Label 12919: @838606
     /*  838606 */   GIM_Try, /*On fail goto*//*Label 12920*/ GIMT_Encode4(838681), // Rule ID 22963 //
     /*  838611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  838628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838657 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  838660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838679 */     GIR_RootConstrainSelectedInstOperands,
     /*  838680 */     // GIR_Coverage, 22963,
     /*  838680 */     GIR_EraseRootFromParent_Done,
     /*  838681 */   // Label 12920: @838681
     /*  838681 */   GIM_Try, /*On fail goto*//*Label 12921*/ GIMT_Encode4(838756), // Rule ID 22966 //
     /*  838686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  838689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  838703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838732 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  838735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838754 */     GIR_RootConstrainSelectedInstOperands,
     /*  838755 */     // GIR_Coverage, 22966,
     /*  838755 */     GIR_EraseRootFromParent_Done,
     /*  838756 */   // Label 12921: @838756
     /*  838756 */   GIM_Try, /*On fail goto*//*Label 12922*/ GIMT_Encode4(838831), // Rule ID 22967 //
     /*  838761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  838764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  838778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838807 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  838810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838829 */     GIR_RootConstrainSelectedInstOperands,
     /*  838830 */     // GIR_Coverage, 22967,
     /*  838830 */     GIR_EraseRootFromParent_Done,
     /*  838831 */   // Label 12922: @838831
     /*  838831 */   GIM_Try, /*On fail goto*//*Label 12923*/ GIMT_Encode4(838906), // Rule ID 22970 //
     /*  838836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  838853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838882 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  838885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838904 */     GIR_RootConstrainSelectedInstOperands,
     /*  838905 */     // GIR_Coverage, 22970,
     /*  838905 */     GIR_EraseRootFromParent_Done,
     /*  838906 */   // Label 12923: @838906
     /*  838906 */   GIM_Try, /*On fail goto*//*Label 12924*/ GIMT_Encode4(838981), // Rule ID 22971 //
     /*  838911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  838928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838957 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  838960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838979 */     GIR_RootConstrainSelectedInstOperands,
     /*  838980 */     // GIR_Coverage, 22971,
     /*  838980 */     GIR_EraseRootFromParent_Done,
     /*  838981 */   // Label 12924: @838981
     /*  838981 */   GIM_Try, /*On fail goto*//*Label 12925*/ GIMT_Encode4(839056), // Rule ID 22974 //
     /*  838986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  838989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  839003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839032 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  839035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839054 */     GIR_RootConstrainSelectedInstOperands,
     /*  839055 */     // GIR_Coverage, 22974,
     /*  839055 */     GIR_EraseRootFromParent_Done,
     /*  839056 */   // Label 12925: @839056
     /*  839056 */   GIM_Try, /*On fail goto*//*Label 12926*/ GIMT_Encode4(839131), // Rule ID 22975 //
     /*  839061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  839078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839107 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  839110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839129 */     GIR_RootConstrainSelectedInstOperands,
     /*  839130 */     // GIR_Coverage, 22975,
     /*  839130 */     GIR_EraseRootFromParent_Done,
     /*  839131 */   // Label 12926: @839131
     /*  839131 */   GIM_Try, /*On fail goto*//*Label 12927*/ GIMT_Encode4(839206), // Rule ID 22978 //
     /*  839136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  839139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  839153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839182 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  839182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  839185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839204 */     GIR_RootConstrainSelectedInstOperands,
     /*  839205 */     // GIR_Coverage, 22978,
     /*  839205 */     GIR_EraseRootFromParent_Done,
     /*  839206 */   // Label 12927: @839206
     /*  839206 */   GIM_Try, /*On fail goto*//*Label 12928*/ GIMT_Encode4(839281), // Rule ID 22979 //
     /*  839211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  839214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  839228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839257 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  839257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  839260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839279 */     GIR_RootConstrainSelectedInstOperands,
     /*  839280 */     // GIR_Coverage, 22979,
     /*  839280 */     GIR_EraseRootFromParent_Done,
     /*  839281 */   // Label 12928: @839281
     /*  839281 */   GIM_Try, /*On fail goto*//*Label 12929*/ GIMT_Encode4(839356), // Rule ID 22982 //
     /*  839286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  839289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  839303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839332 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  839335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839354 */     GIR_RootConstrainSelectedInstOperands,
     /*  839355 */     // GIR_Coverage, 22982,
     /*  839355 */     GIR_EraseRootFromParent_Done,
     /*  839356 */   // Label 12929: @839356
     /*  839356 */   GIM_Try, /*On fail goto*//*Label 12930*/ GIMT_Encode4(839431), // Rule ID 22983 //
     /*  839361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  839364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  839378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839407 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  839410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839429 */     GIR_RootConstrainSelectedInstOperands,
     /*  839430 */     // GIR_Coverage, 22983,
     /*  839430 */     GIR_EraseRootFromParent_Done,
     /*  839431 */   // Label 12930: @839431
     /*  839431 */   GIM_Try, /*On fail goto*//*Label 12931*/ GIMT_Encode4(839506), // Rule ID 22986 //
     /*  839436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  839439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  839453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839482 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  839485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839504 */     GIR_RootConstrainSelectedInstOperands,
     /*  839505 */     // GIR_Coverage, 22986,
     /*  839505 */     GIR_EraseRootFromParent_Done,
     /*  839506 */   // Label 12931: @839506
     /*  839506 */   GIM_Try, /*On fail goto*//*Label 12932*/ GIMT_Encode4(839581), // Rule ID 22987 //
     /*  839511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  839514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  839528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839557 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  839560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839579 */     GIR_RootConstrainSelectedInstOperands,
     /*  839580 */     // GIR_Coverage, 22987,
     /*  839580 */     GIR_EraseRootFromParent_Done,
     /*  839581 */   // Label 12932: @839581
     /*  839581 */   GIM_Try, /*On fail goto*//*Label 12933*/ GIMT_Encode4(839656), // Rule ID 22990 //
     /*  839586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  839589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  839603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839632 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  839635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839654 */     GIR_RootConstrainSelectedInstOperands,
     /*  839655 */     // GIR_Coverage, 22990,
     /*  839655 */     GIR_EraseRootFromParent_Done,
     /*  839656 */   // Label 12933: @839656
     /*  839656 */   GIM_Try, /*On fail goto*//*Label 12934*/ GIMT_Encode4(839731), // Rule ID 22991 //
     /*  839661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  839664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  839678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839707 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  839710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839729 */     GIR_RootConstrainSelectedInstOperands,
     /*  839730 */     // GIR_Coverage, 22991,
     /*  839730 */     GIR_EraseRootFromParent_Done,
     /*  839731 */   // Label 12934: @839731
     /*  839731 */   GIM_Try, /*On fail goto*//*Label 12935*/ GIMT_Encode4(839806), // Rule ID 22994 //
     /*  839736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  839739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  839753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839782 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  839785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839804 */     GIR_RootConstrainSelectedInstOperands,
     /*  839805 */     // GIR_Coverage, 22994,
     /*  839805 */     GIR_EraseRootFromParent_Done,
     /*  839806 */   // Label 12935: @839806
     /*  839806 */   GIM_Try, /*On fail goto*//*Label 12936*/ GIMT_Encode4(839881), // Rule ID 22995 //
     /*  839811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  839828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839857 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  839860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839879 */     GIR_RootConstrainSelectedInstOperands,
     /*  839880 */     // GIR_Coverage, 22995,
     /*  839880 */     GIR_EraseRootFromParent_Done,
     /*  839881 */   // Label 12936: @839881
     /*  839881 */   GIM_Try, /*On fail goto*//*Label 12937*/ GIMT_Encode4(839956), // Rule ID 22998 //
     /*  839886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  839889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  839903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839932 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  839935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839954 */     GIR_RootConstrainSelectedInstOperands,
     /*  839955 */     // GIR_Coverage, 22998,
     /*  839955 */     GIR_EraseRootFromParent_Done,
     /*  839956 */   // Label 12937: @839956
     /*  839956 */   GIM_Try, /*On fail goto*//*Label 12938*/ GIMT_Encode4(840031), // Rule ID 22999 //
     /*  839961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  839978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840007 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  840007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  840010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840029 */     GIR_RootConstrainSelectedInstOperands,
     /*  840030 */     // GIR_Coverage, 22999,
     /*  840030 */     GIR_EraseRootFromParent_Done,
     /*  840031 */   // Label 12938: @840031
     /*  840031 */   GIM_Try, /*On fail goto*//*Label 12939*/ GIMT_Encode4(840106), // Rule ID 23002 //
     /*  840036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  840039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  840053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840082 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  840082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  840085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840104 */     GIR_RootConstrainSelectedInstOperands,
     /*  840105 */     // GIR_Coverage, 23002,
     /*  840105 */     GIR_EraseRootFromParent_Done,
     /*  840106 */   // Label 12939: @840106
     /*  840106 */   GIM_Try, /*On fail goto*//*Label 12940*/ GIMT_Encode4(840181), // Rule ID 23003 //
     /*  840111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  840114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  840128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840157 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  840157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  840160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840179 */     GIR_RootConstrainSelectedInstOperands,
     /*  840180 */     // GIR_Coverage, 23003,
     /*  840180 */     GIR_EraseRootFromParent_Done,
     /*  840181 */   // Label 12940: @840181
     /*  840181 */   GIM_Try, /*On fail goto*//*Label 12941*/ GIMT_Encode4(840256), // Rule ID 23006 //
     /*  840186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  840189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  840203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840232 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  840235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840254 */     GIR_RootConstrainSelectedInstOperands,
     /*  840255 */     // GIR_Coverage, 23006,
     /*  840255 */     GIR_EraseRootFromParent_Done,
     /*  840256 */   // Label 12941: @840256
     /*  840256 */   GIM_Try, /*On fail goto*//*Label 12942*/ GIMT_Encode4(840331), // Rule ID 23007 //
     /*  840261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  840264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  840278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840307 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  840307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  840310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840329 */     GIR_RootConstrainSelectedInstOperands,
     /*  840330 */     // GIR_Coverage, 23007,
     /*  840330 */     GIR_EraseRootFromParent_Done,
     /*  840331 */   // Label 12942: @840331
     /*  840331 */   GIM_Try, /*On fail goto*//*Label 12943*/ GIMT_Encode4(840406), // Rule ID 23010 //
     /*  840336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  840339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  840353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840382 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  840385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840404 */     GIR_RootConstrainSelectedInstOperands,
     /*  840405 */     // GIR_Coverage, 23010,
     /*  840405 */     GIR_EraseRootFromParent_Done,
     /*  840406 */   // Label 12943: @840406
     /*  840406 */   GIM_Try, /*On fail goto*//*Label 12944*/ GIMT_Encode4(840481), // Rule ID 23011 //
     /*  840411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  840414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  840428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840457 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  840457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  840460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840479 */     GIR_RootConstrainSelectedInstOperands,
     /*  840480 */     // GIR_Coverage, 23011,
     /*  840480 */     GIR_EraseRootFromParent_Done,
     /*  840481 */   // Label 12944: @840481
     /*  840481 */   GIM_Try, /*On fail goto*//*Label 12945*/ GIMT_Encode4(840556), // Rule ID 23014 //
     /*  840486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  840489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  840503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840532 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  840535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840554 */     GIR_RootConstrainSelectedInstOperands,
     /*  840555 */     // GIR_Coverage, 23014,
     /*  840555 */     GIR_EraseRootFromParent_Done,
     /*  840556 */   // Label 12945: @840556
     /*  840556 */   GIM_Try, /*On fail goto*//*Label 12946*/ GIMT_Encode4(840631), // Rule ID 23015 //
     /*  840561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  840564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  840578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840607 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  840607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  840610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840629 */     GIR_RootConstrainSelectedInstOperands,
     /*  840630 */     // GIR_Coverage, 23015,
     /*  840630 */     GIR_EraseRootFromParent_Done,
     /*  840631 */   // Label 12946: @840631
     /*  840631 */   GIM_Try, /*On fail goto*//*Label 12947*/ GIMT_Encode4(840706), // Rule ID 23018 //
     /*  840636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  840653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840682 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  840685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840704 */     GIR_RootConstrainSelectedInstOperands,
     /*  840705 */     // GIR_Coverage, 23018,
     /*  840705 */     GIR_EraseRootFromParent_Done,
     /*  840706 */   // Label 12947: @840706
     /*  840706 */   GIM_Try, /*On fail goto*//*Label 12948*/ GIMT_Encode4(840781), // Rule ID 23019 //
     /*  840711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  840728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840757 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  840760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840779 */     GIR_RootConstrainSelectedInstOperands,
     /*  840780 */     // GIR_Coverage, 23019,
     /*  840780 */     GIR_EraseRootFromParent_Done,
     /*  840781 */   // Label 12948: @840781
     /*  840781 */   GIM_Try, /*On fail goto*//*Label 12949*/ GIMT_Encode4(840856), // Rule ID 23022 //
     /*  840786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  840803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840832 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  840835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840854 */     GIR_RootConstrainSelectedInstOperands,
     /*  840855 */     // GIR_Coverage, 23022,
     /*  840855 */     GIR_EraseRootFromParent_Done,
     /*  840856 */   // Label 12949: @840856
     /*  840856 */   GIM_Try, /*On fail goto*//*Label 12950*/ GIMT_Encode4(840931), // Rule ID 23023 //
     /*  840861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  840878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840907 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  840910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840929 */     GIR_RootConstrainSelectedInstOperands,
     /*  840930 */     // GIR_Coverage, 23023,
     /*  840930 */     GIR_EraseRootFromParent_Done,
     /*  840931 */   // Label 12950: @840931
     /*  840931 */   GIM_Try, /*On fail goto*//*Label 12951*/ GIMT_Encode4(841006), // Rule ID 23026 //
     /*  840936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  840939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  840953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840982 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  840982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  840985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841004 */     GIR_RootConstrainSelectedInstOperands,
     /*  841005 */     // GIR_Coverage, 23026,
     /*  841005 */     GIR_EraseRootFromParent_Done,
     /*  841006 */   // Label 12951: @841006
     /*  841006 */   GIM_Try, /*On fail goto*//*Label 12952*/ GIMT_Encode4(841081), // Rule ID 23027 //
     /*  841011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  841028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841057 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  841060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841079 */     GIR_RootConstrainSelectedInstOperands,
     /*  841080 */     // GIR_Coverage, 23027,
     /*  841080 */     GIR_EraseRootFromParent_Done,
     /*  841081 */   // Label 12952: @841081
     /*  841081 */   GIM_Try, /*On fail goto*//*Label 12953*/ GIMT_Encode4(841156), // Rule ID 23030 //
     /*  841086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  841103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841132 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  841135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841154 */     GIR_RootConstrainSelectedInstOperands,
     /*  841155 */     // GIR_Coverage, 23030,
     /*  841155 */     GIR_EraseRootFromParent_Done,
     /*  841156 */   // Label 12953: @841156
     /*  841156 */   GIM_Try, /*On fail goto*//*Label 12954*/ GIMT_Encode4(841231), // Rule ID 23031 //
     /*  841161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  841178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841207 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  841210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841229 */     GIR_RootConstrainSelectedInstOperands,
     /*  841230 */     // GIR_Coverage, 23031,
     /*  841230 */     GIR_EraseRootFromParent_Done,
     /*  841231 */   // Label 12954: @841231
     /*  841231 */   GIM_Try, /*On fail goto*//*Label 12955*/ GIMT_Encode4(841306), // Rule ID 23034 //
     /*  841236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  841253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841282 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  841285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841304 */     GIR_RootConstrainSelectedInstOperands,
     /*  841305 */     // GIR_Coverage, 23034,
     /*  841305 */     GIR_EraseRootFromParent_Done,
     /*  841306 */   // Label 12955: @841306
     /*  841306 */   GIM_Try, /*On fail goto*//*Label 12956*/ GIMT_Encode4(841381), // Rule ID 23035 //
     /*  841311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  841328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841357 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  841360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841379 */     GIR_RootConstrainSelectedInstOperands,
     /*  841380 */     // GIR_Coverage, 23035,
     /*  841380 */     GIR_EraseRootFromParent_Done,
     /*  841381 */   // Label 12956: @841381
     /*  841381 */   GIM_Try, /*On fail goto*//*Label 12957*/ GIMT_Encode4(841456), // Rule ID 23038 //
     /*  841386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  841389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  841403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841432 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  841432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  841435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  841451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841454 */     GIR_RootConstrainSelectedInstOperands,
     /*  841455 */     // GIR_Coverage, 23038,
     /*  841455 */     GIR_EraseRootFromParent_Done,
     /*  841456 */   // Label 12957: @841456
     /*  841456 */   GIM_Try, /*On fail goto*//*Label 12958*/ GIMT_Encode4(841531), // Rule ID 23039 //
     /*  841461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  841464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  841478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841507 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  841507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  841510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  841526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841529 */     GIR_RootConstrainSelectedInstOperands,
     /*  841530 */     // GIR_Coverage, 23039,
     /*  841530 */     GIR_EraseRootFromParent_Done,
     /*  841531 */   // Label 12958: @841531
     /*  841531 */   GIM_Try, /*On fail goto*//*Label 12959*/ GIMT_Encode4(841606), // Rule ID 23042 //
     /*  841536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  841553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841582 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  841585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841604 */     GIR_RootConstrainSelectedInstOperands,
     /*  841605 */     // GIR_Coverage, 23042,
     /*  841605 */     GIR_EraseRootFromParent_Done,
     /*  841606 */   // Label 12959: @841606
     /*  841606 */   GIM_Try, /*On fail goto*//*Label 12960*/ GIMT_Encode4(841681), // Rule ID 23043 //
     /*  841611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  841628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841657 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  841660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841679 */     GIR_RootConstrainSelectedInstOperands,
     /*  841680 */     // GIR_Coverage, 23043,
     /*  841680 */     GIR_EraseRootFromParent_Done,
     /*  841681 */   // Label 12960: @841681
     /*  841681 */   GIM_Try, /*On fail goto*//*Label 12961*/ GIMT_Encode4(841756), // Rule ID 23046 //
     /*  841686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841732 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  841735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841754 */     GIR_RootConstrainSelectedInstOperands,
     /*  841755 */     // GIR_Coverage, 23046,
     /*  841755 */     GIR_EraseRootFromParent_Done,
     /*  841756 */   // Label 12961: @841756
     /*  841756 */   GIM_Try, /*On fail goto*//*Label 12962*/ GIMT_Encode4(841831), // Rule ID 23047 //
     /*  841761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841807 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  841810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841829 */     GIR_RootConstrainSelectedInstOperands,
     /*  841830 */     // GIR_Coverage, 23047,
     /*  841830 */     GIR_EraseRootFromParent_Done,
     /*  841831 */   // Label 12962: @841831
     /*  841831 */   GIM_Try, /*On fail goto*//*Label 12963*/ GIMT_Encode4(841906), // Rule ID 23050 //
     /*  841836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841882 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  841885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841904 */     GIR_RootConstrainSelectedInstOperands,
     /*  841905 */     // GIR_Coverage, 23050,
     /*  841905 */     GIR_EraseRootFromParent_Done,
     /*  841906 */   // Label 12963: @841906
     /*  841906 */   GIM_Try, /*On fail goto*//*Label 12964*/ GIMT_Encode4(841981), // Rule ID 23051 //
     /*  841911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841957 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  841960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841979 */     GIR_RootConstrainSelectedInstOperands,
     /*  841980 */     // GIR_Coverage, 23051,
     /*  841980 */     GIR_EraseRootFromParent_Done,
     /*  841981 */   // Label 12964: @841981
     /*  841981 */   GIM_Try, /*On fail goto*//*Label 12965*/ GIMT_Encode4(842056), // Rule ID 23054 //
     /*  841986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  842003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842032 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  842032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  842035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842054 */     GIR_RootConstrainSelectedInstOperands,
     /*  842055 */     // GIR_Coverage, 23054,
     /*  842055 */     GIR_EraseRootFromParent_Done,
     /*  842056 */   // Label 12965: @842056
     /*  842056 */   GIM_Try, /*On fail goto*//*Label 12966*/ GIMT_Encode4(842131), // Rule ID 23055 //
     /*  842061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  842064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  842078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842107 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  842107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  842110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842129 */     GIR_RootConstrainSelectedInstOperands,
     /*  842130 */     // GIR_Coverage, 23055,
     /*  842130 */     GIR_EraseRootFromParent_Done,
     /*  842131 */   // Label 12966: @842131
     /*  842131 */   GIM_Try, /*On fail goto*//*Label 12967*/ GIMT_Encode4(842206), // Rule ID 23058 //
     /*  842136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  842139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  842153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842182 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  842182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  842185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842204 */     GIR_RootConstrainSelectedInstOperands,
     /*  842205 */     // GIR_Coverage, 23058,
     /*  842205 */     GIR_EraseRootFromParent_Done,
     /*  842206 */   // Label 12967: @842206
     /*  842206 */   GIM_Try, /*On fail goto*//*Label 12968*/ GIMT_Encode4(842281), // Rule ID 23059 //
     /*  842211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  842214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  842228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842257 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  842257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  842260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842279 */     GIR_RootConstrainSelectedInstOperands,
     /*  842280 */     // GIR_Coverage, 23059,
     /*  842280 */     GIR_EraseRootFromParent_Done,
     /*  842281 */   // Label 12968: @842281
     /*  842281 */   GIM_Try, /*On fail goto*//*Label 12969*/ GIMT_Encode4(842356), // Rule ID 23062 //
     /*  842286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  842289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  842303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842332 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  842332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  842335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842354 */     GIR_RootConstrainSelectedInstOperands,
     /*  842355 */     // GIR_Coverage, 23062,
     /*  842355 */     GIR_EraseRootFromParent_Done,
     /*  842356 */   // Label 12969: @842356
     /*  842356 */   GIM_Try, /*On fail goto*//*Label 12970*/ GIMT_Encode4(842431), // Rule ID 23063 //
     /*  842361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  842364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  842378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842407 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  842407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  842410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842429 */     GIR_RootConstrainSelectedInstOperands,
     /*  842430 */     // GIR_Coverage, 23063,
     /*  842430 */     GIR_EraseRootFromParent_Done,
     /*  842431 */   // Label 12970: @842431
     /*  842431 */   GIM_Try, /*On fail goto*//*Label 12971*/ GIMT_Encode4(842506), // Rule ID 23066 //
     /*  842436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  842439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  842453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842482 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  842485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842504 */     GIR_RootConstrainSelectedInstOperands,
     /*  842505 */     // GIR_Coverage, 23066,
     /*  842505 */     GIR_EraseRootFromParent_Done,
     /*  842506 */   // Label 12971: @842506
     /*  842506 */   GIM_Try, /*On fail goto*//*Label 12972*/ GIMT_Encode4(842581), // Rule ID 23067 //
     /*  842511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  842528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842557 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  842560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842579 */     GIR_RootConstrainSelectedInstOperands,
     /*  842580 */     // GIR_Coverage, 23067,
     /*  842580 */     GIR_EraseRootFromParent_Done,
     /*  842581 */   // Label 12972: @842581
     /*  842581 */   GIM_Try, /*On fail goto*//*Label 12973*/ GIMT_Encode4(842656), // Rule ID 23070 //
     /*  842586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  842589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  842603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842632 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  842635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842654 */     GIR_RootConstrainSelectedInstOperands,
     /*  842655 */     // GIR_Coverage, 23070,
     /*  842655 */     GIR_EraseRootFromParent_Done,
     /*  842656 */   // Label 12973: @842656
     /*  842656 */   GIM_Try, /*On fail goto*//*Label 12974*/ GIMT_Encode4(842731), // Rule ID 23071 //
     /*  842661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  842678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842707 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  842710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842729 */     GIR_RootConstrainSelectedInstOperands,
     /*  842730 */     // GIR_Coverage, 23071,
     /*  842730 */     GIR_EraseRootFromParent_Done,
     /*  842731 */   // Label 12974: @842731
     /*  842731 */   GIM_Try, /*On fail goto*//*Label 12975*/ GIMT_Encode4(842806), // Rule ID 23074 //
     /*  842736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  842739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  842753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842782 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  842785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842804 */     GIR_RootConstrainSelectedInstOperands,
     /*  842805 */     // GIR_Coverage, 23074,
     /*  842805 */     GIR_EraseRootFromParent_Done,
     /*  842806 */   // Label 12975: @842806
     /*  842806 */   GIM_Try, /*On fail goto*//*Label 12976*/ GIMT_Encode4(842881), // Rule ID 23075 //
     /*  842811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  842828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842857 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  842860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842879 */     GIR_RootConstrainSelectedInstOperands,
     /*  842880 */     // GIR_Coverage, 23075,
     /*  842880 */     GIR_EraseRootFromParent_Done,
     /*  842881 */   // Label 12976: @842881
     /*  842881 */   GIM_Try, /*On fail goto*//*Label 12977*/ GIMT_Encode4(842956), // Rule ID 23356 //
     /*  842886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  842897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  842900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  842903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  842906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842932 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  842935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842954 */     GIR_RootConstrainSelectedInstOperands,
     /*  842955 */     // GIR_Coverage, 23356,
     /*  842955 */     GIR_EraseRootFromParent_Done,
     /*  842956 */   // Label 12977: @842956
     /*  842956 */   GIM_Try, /*On fail goto*//*Label 12978*/ GIMT_Encode4(843031), // Rule ID 23357 //
     /*  842961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  842972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  842975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  842978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  842981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843007 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  843010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843016 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843029 */     GIR_RootConstrainSelectedInstOperands,
     /*  843030 */     // GIR_Coverage, 23357,
     /*  843030 */     GIR_EraseRootFromParent_Done,
     /*  843031 */   // Label 12978: @843031
     /*  843031 */   GIM_Try, /*On fail goto*//*Label 12979*/ GIMT_Encode4(843106), // Rule ID 23360 //
     /*  843036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  843047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  843050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  843053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  843056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843082 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  843085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843104 */     GIR_RootConstrainSelectedInstOperands,
     /*  843105 */     // GIR_Coverage, 23360,
     /*  843105 */     GIR_EraseRootFromParent_Done,
     /*  843106 */   // Label 12979: @843106
     /*  843106 */   GIM_Try, /*On fail goto*//*Label 12980*/ GIMT_Encode4(843181), // Rule ID 23361 //
     /*  843111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  843122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  843125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  843128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  843131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843157 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  843160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843179 */     GIR_RootConstrainSelectedInstOperands,
     /*  843180 */     // GIR_Coverage, 23361,
     /*  843180 */     GIR_EraseRootFromParent_Done,
     /*  843181 */   // Label 12980: @843181
     /*  843181 */   GIM_Try, /*On fail goto*//*Label 12981*/ GIMT_Encode4(843256), // Rule ID 23364 //
     /*  843186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  843197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  843200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  843203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  843206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843232 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  843235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843254 */     GIR_RootConstrainSelectedInstOperands,
     /*  843255 */     // GIR_Coverage, 23364,
     /*  843255 */     GIR_EraseRootFromParent_Done,
     /*  843256 */   // Label 12981: @843256
     /*  843256 */   GIM_Try, /*On fail goto*//*Label 12982*/ GIMT_Encode4(843331), // Rule ID 23365 //
     /*  843261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  843272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  843275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  843278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  843281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843307 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  843310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843329 */     GIR_RootConstrainSelectedInstOperands,
     /*  843330 */     // GIR_Coverage, 23365,
     /*  843330 */     GIR_EraseRootFromParent_Done,
     /*  843331 */   // Label 12982: @843331
     /*  843331 */   GIM_Try, /*On fail goto*//*Label 12983*/ GIMT_Encode4(843406), // Rule ID 23368 //
     /*  843336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  843347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  843350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  843353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  843356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843382 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  843385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843404 */     GIR_RootConstrainSelectedInstOperands,
     /*  843405 */     // GIR_Coverage, 23368,
     /*  843405 */     GIR_EraseRootFromParent_Done,
     /*  843406 */   // Label 12983: @843406
     /*  843406 */   GIM_Try, /*On fail goto*//*Label 12984*/ GIMT_Encode4(843481), // Rule ID 23369 //
     /*  843411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  843422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  843425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  843428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  843431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843457 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  843460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843479 */     GIR_RootConstrainSelectedInstOperands,
     /*  843480 */     // GIR_Coverage, 23369,
     /*  843480 */     GIR_EraseRootFromParent_Done,
     /*  843481 */   // Label 12984: @843481
     /*  843481 */   GIM_Try, /*On fail goto*//*Label 12985*/ GIMT_Encode4(843556), // Rule ID 23372 //
     /*  843486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  843497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  843500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  843503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  843506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843532 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  843535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843554 */     GIR_RootConstrainSelectedInstOperands,
     /*  843555 */     // GIR_Coverage, 23372,
     /*  843555 */     GIR_EraseRootFromParent_Done,
     /*  843556 */   // Label 12985: @843556
     /*  843556 */   GIM_Try, /*On fail goto*//*Label 12986*/ GIMT_Encode4(843631), // Rule ID 23373 //
     /*  843561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  843572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  843575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  843578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  843581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843607 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  843610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843616 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843629 */     GIR_RootConstrainSelectedInstOperands,
     /*  843630 */     // GIR_Coverage, 23373,
     /*  843630 */     GIR_EraseRootFromParent_Done,
     /*  843631 */   // Label 12986: @843631
     /*  843631 */   GIM_Try, /*On fail goto*//*Label 12987*/ GIMT_Encode4(843706), // Rule ID 23376 //
     /*  843636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  843647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  843650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  843653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  843656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843682 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  843685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843691 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843704 */     GIR_RootConstrainSelectedInstOperands,
     /*  843705 */     // GIR_Coverage, 23376,
     /*  843705 */     GIR_EraseRootFromParent_Done,
     /*  843706 */   // Label 12987: @843706
     /*  843706 */   GIM_Try, /*On fail goto*//*Label 12988*/ GIMT_Encode4(843781), // Rule ID 23377 //
     /*  843711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  843722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  843725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  843728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  843731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843757 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  843760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843766 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843779 */     GIR_RootConstrainSelectedInstOperands,
     /*  843780 */     // GIR_Coverage, 23377,
     /*  843780 */     GIR_EraseRootFromParent_Done,
     /*  843781 */   // Label 12988: @843781
     /*  843781 */   GIM_Try, /*On fail goto*//*Label 12989*/ GIMT_Encode4(843856), // Rule ID 23380 //
     /*  843786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  843797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  843800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  843803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  843806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843832 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  843835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843854 */     GIR_RootConstrainSelectedInstOperands,
     /*  843855 */     // GIR_Coverage, 23380,
     /*  843855 */     GIR_EraseRootFromParent_Done,
     /*  843856 */   // Label 12989: @843856
     /*  843856 */   GIM_Try, /*On fail goto*//*Label 12990*/ GIMT_Encode4(843931), // Rule ID 23381 //
     /*  843861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  843872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  843875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  843878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  843881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843907 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  843910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843929 */     GIR_RootConstrainSelectedInstOperands,
     /*  843930 */     // GIR_Coverage, 23381,
     /*  843930 */     GIR_EraseRootFromParent_Done,
     /*  843931 */   // Label 12990: @843931
     /*  843931 */   GIM_Try, /*On fail goto*//*Label 12991*/ GIMT_Encode4(844006), // Rule ID 23384 //
     /*  843936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  843947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  843950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  843953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  843956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843982 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  843985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844004 */     GIR_RootConstrainSelectedInstOperands,
     /*  844005 */     // GIR_Coverage, 23384,
     /*  844005 */     GIR_EraseRootFromParent_Done,
     /*  844006 */   // Label 12991: @844006
     /*  844006 */   GIM_Try, /*On fail goto*//*Label 12992*/ GIMT_Encode4(844081), // Rule ID 23385 //
     /*  844011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  844022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  844025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  844028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  844031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844057 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  844060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844066 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844079 */     GIR_RootConstrainSelectedInstOperands,
     /*  844080 */     // GIR_Coverage, 23385,
     /*  844080 */     GIR_EraseRootFromParent_Done,
     /*  844081 */   // Label 12992: @844081
     /*  844081 */   GIM_Try, /*On fail goto*//*Label 12993*/ GIMT_Encode4(844156), // Rule ID 23388 //
     /*  844086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  844097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  844100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  844103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  844106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844132 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  844135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844154 */     GIR_RootConstrainSelectedInstOperands,
     /*  844155 */     // GIR_Coverage, 23388,
     /*  844155 */     GIR_EraseRootFromParent_Done,
     /*  844156 */   // Label 12993: @844156
     /*  844156 */   GIM_Try, /*On fail goto*//*Label 12994*/ GIMT_Encode4(844231), // Rule ID 23389 //
     /*  844161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  844172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  844175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  844178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  844181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844207 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  844210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844229 */     GIR_RootConstrainSelectedInstOperands,
     /*  844230 */     // GIR_Coverage, 23389,
     /*  844230 */     GIR_EraseRootFromParent_Done,
     /*  844231 */   // Label 12994: @844231
     /*  844231 */   GIM_Try, /*On fail goto*//*Label 12995*/ GIMT_Encode4(844306), // Rule ID 23392 //
     /*  844236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  844247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  844250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  844253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  844256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844282 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  844285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844304 */     GIR_RootConstrainSelectedInstOperands,
     /*  844305 */     // GIR_Coverage, 23392,
     /*  844305 */     GIR_EraseRootFromParent_Done,
     /*  844306 */   // Label 12995: @844306
     /*  844306 */   GIM_Try, /*On fail goto*//*Label 12996*/ GIMT_Encode4(844381), // Rule ID 23393 //
     /*  844311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  844322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  844325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  844328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  844331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844357 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  844360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844379 */     GIR_RootConstrainSelectedInstOperands,
     /*  844380 */     // GIR_Coverage, 23393,
     /*  844380 */     GIR_EraseRootFromParent_Done,
     /*  844381 */   // Label 12996: @844381
     /*  844381 */   GIM_Try, /*On fail goto*//*Label 12997*/ GIMT_Encode4(844456), // Rule ID 23396 //
     /*  844386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  844397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  844400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  844403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  844406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844432 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  844435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844454 */     GIR_RootConstrainSelectedInstOperands,
     /*  844455 */     // GIR_Coverage, 23396,
     /*  844455 */     GIR_EraseRootFromParent_Done,
     /*  844456 */   // Label 12997: @844456
     /*  844456 */   GIM_Try, /*On fail goto*//*Label 12998*/ GIMT_Encode4(844531), // Rule ID 23397 //
     /*  844461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  844472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  844475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  844478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  844481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844507 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  844510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844529 */     GIR_RootConstrainSelectedInstOperands,
     /*  844530 */     // GIR_Coverage, 23397,
     /*  844530 */     GIR_EraseRootFromParent_Done,
     /*  844531 */   // Label 12998: @844531
     /*  844531 */   GIM_Try, /*On fail goto*//*Label 12999*/ GIMT_Encode4(844606), // Rule ID 23400 //
     /*  844536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  844547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  844550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  844553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  844556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844582 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  844585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844604 */     GIR_RootConstrainSelectedInstOperands,
     /*  844605 */     // GIR_Coverage, 23400,
     /*  844605 */     GIR_EraseRootFromParent_Done,
     /*  844606 */   // Label 12999: @844606
     /*  844606 */   GIM_Try, /*On fail goto*//*Label 13000*/ GIMT_Encode4(844681), // Rule ID 23401 //
     /*  844611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  844622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  844625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  844628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  844631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844657 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  844660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844666 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844679 */     GIR_RootConstrainSelectedInstOperands,
     /*  844680 */     // GIR_Coverage, 23401,
     /*  844680 */     GIR_EraseRootFromParent_Done,
     /*  844681 */   // Label 13000: @844681
     /*  844681 */   GIM_Try, /*On fail goto*//*Label 13001*/ GIMT_Encode4(844756), // Rule ID 23404 //
     /*  844686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  844697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  844700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  844703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  844706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844732 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  844735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844754 */     GIR_RootConstrainSelectedInstOperands,
     /*  844755 */     // GIR_Coverage, 23404,
     /*  844755 */     GIR_EraseRootFromParent_Done,
     /*  844756 */   // Label 13001: @844756
     /*  844756 */   GIM_Try, /*On fail goto*//*Label 13002*/ GIMT_Encode4(844831), // Rule ID 23405 //
     /*  844761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  844772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  844775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  844778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  844781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844807 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  844810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844816 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844829 */     GIR_RootConstrainSelectedInstOperands,
     /*  844830 */     // GIR_Coverage, 23405,
     /*  844830 */     GIR_EraseRootFromParent_Done,
     /*  844831 */   // Label 13002: @844831
     /*  844831 */   GIM_Try, /*On fail goto*//*Label 13003*/ GIMT_Encode4(844906), // Rule ID 23408 //
     /*  844836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  844847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  844850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  844853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  844856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844882 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  844885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844904 */     GIR_RootConstrainSelectedInstOperands,
     /*  844905 */     // GIR_Coverage, 23408,
     /*  844905 */     GIR_EraseRootFromParent_Done,
     /*  844906 */   // Label 13003: @844906
     /*  844906 */   GIM_Try, /*On fail goto*//*Label 13004*/ GIMT_Encode4(844981), // Rule ID 23409 //
     /*  844911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  844922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  844925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  844928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  844931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844957 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  844960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844966 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844979 */     GIR_RootConstrainSelectedInstOperands,
     /*  844980 */     // GIR_Coverage, 23409,
     /*  844980 */     GIR_EraseRootFromParent_Done,
     /*  844981 */   // Label 13004: @844981
     /*  844981 */   GIM_Try, /*On fail goto*//*Label 13005*/ GIMT_Encode4(845056), // Rule ID 23412 //
     /*  844986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  844997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  845000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  845003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  845006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845032 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  845035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845054 */     GIR_RootConstrainSelectedInstOperands,
     /*  845055 */     // GIR_Coverage, 23412,
     /*  845055 */     GIR_EraseRootFromParent_Done,
     /*  845056 */   // Label 13005: @845056
     /*  845056 */   GIM_Try, /*On fail goto*//*Label 13006*/ GIMT_Encode4(845131), // Rule ID 23413 //
     /*  845061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  845072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  845075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  845078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  845081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845107 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  845110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845116 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845129 */     GIR_RootConstrainSelectedInstOperands,
     /*  845130 */     // GIR_Coverage, 23413,
     /*  845130 */     GIR_EraseRootFromParent_Done,
     /*  845131 */   // Label 13006: @845131
     /*  845131 */   GIM_Try, /*On fail goto*//*Label 13007*/ GIMT_Encode4(845206), // Rule ID 23416 //
     /*  845136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  845147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  845150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  845153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  845156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845182 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  845185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845204 */     GIR_RootConstrainSelectedInstOperands,
     /*  845205 */     // GIR_Coverage, 23416,
     /*  845205 */     GIR_EraseRootFromParent_Done,
     /*  845206 */   // Label 13007: @845206
     /*  845206 */   GIM_Try, /*On fail goto*//*Label 13008*/ GIMT_Encode4(845281), // Rule ID 23417 //
     /*  845211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  845222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  845225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  845228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  845231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845257 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  845260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845266 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845279 */     GIR_RootConstrainSelectedInstOperands,
     /*  845280 */     // GIR_Coverage, 23417,
     /*  845280 */     GIR_EraseRootFromParent_Done,
     /*  845281 */   // Label 13008: @845281
     /*  845281 */   GIM_Try, /*On fail goto*//*Label 13009*/ GIMT_Encode4(845356), // Rule ID 23420 //
     /*  845286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  845297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  845300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  845303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  845306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  845335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845354 */     GIR_RootConstrainSelectedInstOperands,
     /*  845355 */     // GIR_Coverage, 23420,
     /*  845355 */     GIR_EraseRootFromParent_Done,
     /*  845356 */   // Label 13009: @845356
     /*  845356 */   GIM_Try, /*On fail goto*//*Label 13010*/ GIMT_Encode4(845431), // Rule ID 23421 //
     /*  845361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  845372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  845375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  845378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  845381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845407 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  845410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845416 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845429 */     GIR_RootConstrainSelectedInstOperands,
     /*  845430 */     // GIR_Coverage, 23421,
     /*  845430 */     GIR_EraseRootFromParent_Done,
     /*  845431 */   // Label 13010: @845431
     /*  845431 */   GIM_Try, /*On fail goto*//*Label 13011*/ GIMT_Encode4(845506), // Rule ID 23424 //
     /*  845436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  845447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  845450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  845453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  845456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845482 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  845485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845504 */     GIR_RootConstrainSelectedInstOperands,
     /*  845505 */     // GIR_Coverage, 23424,
     /*  845505 */     GIR_EraseRootFromParent_Done,
     /*  845506 */   // Label 13011: @845506
     /*  845506 */   GIM_Try, /*On fail goto*//*Label 13012*/ GIMT_Encode4(845581), // Rule ID 23425 //
     /*  845511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  845522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  845525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  845528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  845531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845557 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  845560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845566 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845579 */     GIR_RootConstrainSelectedInstOperands,
     /*  845580 */     // GIR_Coverage, 23425,
     /*  845580 */     GIR_EraseRootFromParent_Done,
     /*  845581 */   // Label 13012: @845581
     /*  845581 */   GIM_Try, /*On fail goto*//*Label 13013*/ GIMT_Encode4(845656), // Rule ID 23428 //
     /*  845586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  845597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  845600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  845603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  845606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845632 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  845635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845654 */     GIR_RootConstrainSelectedInstOperands,
     /*  845655 */     // GIR_Coverage, 23428,
     /*  845655 */     GIR_EraseRootFromParent_Done,
     /*  845656 */   // Label 13013: @845656
     /*  845656 */   GIM_Try, /*On fail goto*//*Label 13014*/ GIMT_Encode4(845731), // Rule ID 23429 //
     /*  845661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  845672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  845675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  845678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  845681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845707 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  845710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845729 */     GIR_RootConstrainSelectedInstOperands,
     /*  845730 */     // GIR_Coverage, 23429,
     /*  845730 */     GIR_EraseRootFromParent_Done,
     /*  845731 */   // Label 13014: @845731
     /*  845731 */   GIM_Try, /*On fail goto*//*Label 13015*/ GIMT_Encode4(845806), // Rule ID 23432 //
     /*  845736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  845747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  845750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  845753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  845756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845782 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  845785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845804 */     GIR_RootConstrainSelectedInstOperands,
     /*  845805 */     // GIR_Coverage, 23432,
     /*  845805 */     GIR_EraseRootFromParent_Done,
     /*  845806 */   // Label 13015: @845806
     /*  845806 */   GIM_Try, /*On fail goto*//*Label 13016*/ GIMT_Encode4(845881), // Rule ID 23433 //
     /*  845811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  845822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  845825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  845828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  845831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845857 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  845860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845866 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845879 */     GIR_RootConstrainSelectedInstOperands,
     /*  845880 */     // GIR_Coverage, 23433,
     /*  845880 */     GIR_EraseRootFromParent_Done,
     /*  845881 */   // Label 13016: @845881
     /*  845881 */   GIM_Try, /*On fail goto*//*Label 13017*/ GIMT_Encode4(845956), // Rule ID 23974 //
     /*  845886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  845897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  845900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  845903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845932 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  845932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  845935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845954 */     GIR_RootConstrainSelectedInstOperands,
     /*  845955 */     // GIR_Coverage, 23974,
     /*  845955 */     GIR_EraseRootFromParent_Done,
     /*  845956 */   // Label 13017: @845956
     /*  845956 */   GIM_Try, /*On fail goto*//*Label 13018*/ GIMT_Encode4(846031), // Rule ID 23975 //
     /*  845961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  845972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  845975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  845978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846007 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  846007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  846010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846029 */     GIR_RootConstrainSelectedInstOperands,
     /*  846030 */     // GIR_Coverage, 23975,
     /*  846030 */     GIR_EraseRootFromParent_Done,
     /*  846031 */   // Label 13018: @846031
     /*  846031 */   GIM_Try, /*On fail goto*//*Label 13019*/ GIMT_Encode4(846106), // Rule ID 23978 //
     /*  846036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  846047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  846050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  846053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846082 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  846085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846104 */     GIR_RootConstrainSelectedInstOperands,
     /*  846105 */     // GIR_Coverage, 23978,
     /*  846105 */     GIR_EraseRootFromParent_Done,
     /*  846106 */   // Label 13019: @846106
     /*  846106 */   GIM_Try, /*On fail goto*//*Label 13020*/ GIMT_Encode4(846181), // Rule ID 23979 //
     /*  846111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  846122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  846125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  846128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846157 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  846157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  846160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846179 */     GIR_RootConstrainSelectedInstOperands,
     /*  846180 */     // GIR_Coverage, 23979,
     /*  846180 */     GIR_EraseRootFromParent_Done,
     /*  846181 */   // Label 13020: @846181
     /*  846181 */   GIM_Try, /*On fail goto*//*Label 13021*/ GIMT_Encode4(846256), // Rule ID 23982 //
     /*  846186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  846197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  846200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  846203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846232 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846254 */     GIR_RootConstrainSelectedInstOperands,
     /*  846255 */     // GIR_Coverage, 23982,
     /*  846255 */     GIR_EraseRootFromParent_Done,
     /*  846256 */   // Label 13021: @846256
     /*  846256 */   GIM_Try, /*On fail goto*//*Label 13022*/ GIMT_Encode4(846331), // Rule ID 23983 //
     /*  846261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  846272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  846275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  846278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846307 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  846307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846329 */     GIR_RootConstrainSelectedInstOperands,
     /*  846330 */     // GIR_Coverage, 23983,
     /*  846330 */     GIR_EraseRootFromParent_Done,
     /*  846331 */   // Label 13022: @846331
     /*  846331 */   GIM_Try, /*On fail goto*//*Label 13023*/ GIMT_Encode4(846406), // Rule ID 23986 //
     /*  846336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  846347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  846350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  846353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846382 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  846382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  846385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846404 */     GIR_RootConstrainSelectedInstOperands,
     /*  846405 */     // GIR_Coverage, 23986,
     /*  846405 */     GIR_EraseRootFromParent_Done,
     /*  846406 */   // Label 13023: @846406
     /*  846406 */   GIM_Try, /*On fail goto*//*Label 13024*/ GIMT_Encode4(846481), // Rule ID 23987 //
     /*  846411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  846422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  846425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  846428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846457 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  846457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  846460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846479 */     GIR_RootConstrainSelectedInstOperands,
     /*  846480 */     // GIR_Coverage, 23987,
     /*  846480 */     GIR_EraseRootFromParent_Done,
     /*  846481 */   // Label 13024: @846481
     /*  846481 */   GIM_Try, /*On fail goto*//*Label 13025*/ GIMT_Encode4(846556), // Rule ID 23990 //
     /*  846486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  846497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  846500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  846503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846532 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  846532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846554 */     GIR_RootConstrainSelectedInstOperands,
     /*  846555 */     // GIR_Coverage, 23990,
     /*  846555 */     GIR_EraseRootFromParent_Done,
     /*  846556 */   // Label 13025: @846556
     /*  846556 */   GIM_Try, /*On fail goto*//*Label 13026*/ GIMT_Encode4(846631), // Rule ID 23991 //
     /*  846561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  846572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  846575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  846578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846607 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  846607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846629 */     GIR_RootConstrainSelectedInstOperands,
     /*  846630 */     // GIR_Coverage, 23991,
     /*  846630 */     GIR_EraseRootFromParent_Done,
     /*  846631 */   // Label 13026: @846631
     /*  846631 */   GIM_Try, /*On fail goto*//*Label 13027*/ GIMT_Encode4(846706), // Rule ID 23994 //
     /*  846636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  846647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  846650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  846653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846682 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  846682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846704 */     GIR_RootConstrainSelectedInstOperands,
     /*  846705 */     // GIR_Coverage, 23994,
     /*  846705 */     GIR_EraseRootFromParent_Done,
     /*  846706 */   // Label 13027: @846706
     /*  846706 */   GIM_Try, /*On fail goto*//*Label 13028*/ GIMT_Encode4(846781), // Rule ID 23995 //
     /*  846711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  846722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  846725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  846728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846757 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  846757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846779 */     GIR_RootConstrainSelectedInstOperands,
     /*  846780 */     // GIR_Coverage, 23995,
     /*  846780 */     GIR_EraseRootFromParent_Done,
     /*  846781 */   // Label 13028: @846781
     /*  846781 */   GIM_Try, /*On fail goto*//*Label 13029*/ GIMT_Encode4(846856), // Rule ID 23998 //
     /*  846786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  846797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  846800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  846803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846832 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846854 */     GIR_RootConstrainSelectedInstOperands,
     /*  846855 */     // GIR_Coverage, 23998,
     /*  846855 */     GIR_EraseRootFromParent_Done,
     /*  846856 */   // Label 13029: @846856
     /*  846856 */   GIM_Try, /*On fail goto*//*Label 13030*/ GIMT_Encode4(846931), // Rule ID 23999 //
     /*  846861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  846872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  846875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  846878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846907 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  846907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846929 */     GIR_RootConstrainSelectedInstOperands,
     /*  846930 */     // GIR_Coverage, 23999,
     /*  846930 */     GIR_EraseRootFromParent_Done,
     /*  846931 */   // Label 13030: @846931
     /*  846931 */   GIM_Try, /*On fail goto*//*Label 13031*/ GIMT_Encode4(847006), // Rule ID 24002 //
     /*  846936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  846947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  846950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  846953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  846982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847004 */     GIR_RootConstrainSelectedInstOperands,
     /*  847005 */     // GIR_Coverage, 24002,
     /*  847005 */     GIR_EraseRootFromParent_Done,
     /*  847006 */   // Label 13031: @847006
     /*  847006 */   GIM_Try, /*On fail goto*//*Label 13032*/ GIMT_Encode4(847081), // Rule ID 24003 //
     /*  847011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  847022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  847025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  847028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847057 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  847057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  847060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847079 */     GIR_RootConstrainSelectedInstOperands,
     /*  847080 */     // GIR_Coverage, 24003,
     /*  847080 */     GIR_EraseRootFromParent_Done,
     /*  847081 */   // Label 13032: @847081
     /*  847081 */   GIM_Try, /*On fail goto*//*Label 13033*/ GIMT_Encode4(847156), // Rule ID 24006 //
     /*  847086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  847097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  847100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  847103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847132 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  847132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  847135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847154 */     GIR_RootConstrainSelectedInstOperands,
     /*  847155 */     // GIR_Coverage, 24006,
     /*  847155 */     GIR_EraseRootFromParent_Done,
     /*  847156 */   // Label 13033: @847156
     /*  847156 */   GIM_Try, /*On fail goto*//*Label 13034*/ GIMT_Encode4(847231), // Rule ID 24007 //
     /*  847161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  847172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  847175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  847178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847207 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  847207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  847210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847229 */     GIR_RootConstrainSelectedInstOperands,
     /*  847230 */     // GIR_Coverage, 24007,
     /*  847230 */     GIR_EraseRootFromParent_Done,
     /*  847231 */   // Label 13034: @847231
     /*  847231 */   GIM_Try, /*On fail goto*//*Label 13035*/ GIMT_Encode4(847306), // Rule ID 24010 //
     /*  847236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  847239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  847247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  847250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  847253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  847282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  847285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  847301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847304 */     GIR_RootConstrainSelectedInstOperands,
     /*  847305 */     // GIR_Coverage, 24010,
     /*  847305 */     GIR_EraseRootFromParent_Done,
     /*  847306 */   // Label 13035: @847306
     /*  847306 */   GIM_Try, /*On fail goto*//*Label 13036*/ GIMT_Encode4(847381), // Rule ID 24011 //
     /*  847311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  847314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  847322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  847325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  847328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847357 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  847357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  847360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  847376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847379 */     GIR_RootConstrainSelectedInstOperands,
     /*  847380 */     // GIR_Coverage, 24011,
     /*  847380 */     GIR_EraseRootFromParent_Done,
     /*  847381 */   // Label 13036: @847381
     /*  847381 */   GIM_Try, /*On fail goto*//*Label 13037*/ GIMT_Encode4(847456), // Rule ID 24014 //
     /*  847386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  847397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  847400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  847403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847432 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  847432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847454 */     GIR_RootConstrainSelectedInstOperands,
     /*  847455 */     // GIR_Coverage, 24014,
     /*  847455 */     GIR_EraseRootFromParent_Done,
     /*  847456 */   // Label 13037: @847456
     /*  847456 */   GIM_Try, /*On fail goto*//*Label 13038*/ GIMT_Encode4(847531), // Rule ID 24015 //
     /*  847461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  847472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  847475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  847478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847507 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  847507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847529 */     GIR_RootConstrainSelectedInstOperands,
     /*  847530 */     // GIR_Coverage, 24015,
     /*  847530 */     GIR_EraseRootFromParent_Done,
     /*  847531 */   // Label 13038: @847531
     /*  847531 */   GIM_Try, /*On fail goto*//*Label 13039*/ GIMT_Encode4(847606), // Rule ID 24018 //
     /*  847536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  847547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  847550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  847553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847582 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  847582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847604 */     GIR_RootConstrainSelectedInstOperands,
     /*  847605 */     // GIR_Coverage, 24018,
     /*  847605 */     GIR_EraseRootFromParent_Done,
     /*  847606 */   // Label 13039: @847606
     /*  847606 */   GIM_Try, /*On fail goto*//*Label 13040*/ GIMT_Encode4(847681), // Rule ID 24019 //
     /*  847611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  847622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  847625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  847628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847657 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  847657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847679 */     GIR_RootConstrainSelectedInstOperands,
     /*  847680 */     // GIR_Coverage, 24019,
     /*  847680 */     GIR_EraseRootFromParent_Done,
     /*  847681 */   // Label 13040: @847681
     /*  847681 */   GIM_Try, /*On fail goto*//*Label 13041*/ GIMT_Encode4(847756), // Rule ID 24022 //
     /*  847686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  847697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  847700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  847703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847732 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  847732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847754 */     GIR_RootConstrainSelectedInstOperands,
     /*  847755 */     // GIR_Coverage, 24022,
     /*  847755 */     GIR_EraseRootFromParent_Done,
     /*  847756 */   // Label 13041: @847756
     /*  847756 */   GIM_Try, /*On fail goto*//*Label 13042*/ GIMT_Encode4(847831), // Rule ID 24023 //
     /*  847761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  847772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  847775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  847778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847807 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  847807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847829 */     GIR_RootConstrainSelectedInstOperands,
     /*  847830 */     // GIR_Coverage, 24023,
     /*  847830 */     GIR_EraseRootFromParent_Done,
     /*  847831 */   // Label 13042: @847831
     /*  847831 */   GIM_Try, /*On fail goto*//*Label 13043*/ GIMT_Encode4(847906), // Rule ID 24026 //
     /*  847836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  847847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  847850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  847853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  847882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847904 */     GIR_RootConstrainSelectedInstOperands,
     /*  847905 */     // GIR_Coverage, 24026,
     /*  847905 */     GIR_EraseRootFromParent_Done,
     /*  847906 */   // Label 13043: @847906
     /*  847906 */   GIM_Try, /*On fail goto*//*Label 13044*/ GIMT_Encode4(847981), // Rule ID 24027 //
     /*  847911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  847922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  847925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  847928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847957 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  847957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847979 */     GIR_RootConstrainSelectedInstOperands,
     /*  847980 */     // GIR_Coverage, 24027,
     /*  847980 */     GIR_EraseRootFromParent_Done,
     /*  847981 */   // Label 13044: @847981
     /*  847981 */   GIM_Try, /*On fail goto*//*Label 13045*/ GIMT_Encode4(848056), // Rule ID 24030 //
     /*  847986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  847997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  848000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  848003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848032 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  848032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848054 */     GIR_RootConstrainSelectedInstOperands,
     /*  848055 */     // GIR_Coverage, 24030,
     /*  848055 */     GIR_EraseRootFromParent_Done,
     /*  848056 */   // Label 13045: @848056
     /*  848056 */   GIM_Try, /*On fail goto*//*Label 13046*/ GIMT_Encode4(848131), // Rule ID 24031 //
     /*  848061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  848072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  848075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  848078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848107 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  848107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848129 */     GIR_RootConstrainSelectedInstOperands,
     /*  848130 */     // GIR_Coverage, 24031,
     /*  848130 */     GIR_EraseRootFromParent_Done,
     /*  848131 */   // Label 13046: @848131
     /*  848131 */   GIM_Try, /*On fail goto*//*Label 13047*/ GIMT_Encode4(848206), // Rule ID 24034 //
     /*  848136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  848147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  848150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  848153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848182 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  848182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848204 */     GIR_RootConstrainSelectedInstOperands,
     /*  848205 */     // GIR_Coverage, 24034,
     /*  848205 */     GIR_EraseRootFromParent_Done,
     /*  848206 */   // Label 13047: @848206
     /*  848206 */   GIM_Try, /*On fail goto*//*Label 13048*/ GIMT_Encode4(848281), // Rule ID 24035 //
     /*  848211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  848222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  848225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  848228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848257 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  848257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848279 */     GIR_RootConstrainSelectedInstOperands,
     /*  848280 */     // GIR_Coverage, 24035,
     /*  848280 */     GIR_EraseRootFromParent_Done,
     /*  848281 */   // Label 13048: @848281
     /*  848281 */   GIM_Try, /*On fail goto*//*Label 13049*/ GIMT_Encode4(848356), // Rule ID 24038 //
     /*  848286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  848297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  848300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  848303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  848332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  848335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848354 */     GIR_RootConstrainSelectedInstOperands,
     /*  848355 */     // GIR_Coverage, 24038,
     /*  848355 */     GIR_EraseRootFromParent_Done,
     /*  848356 */   // Label 13049: @848356
     /*  848356 */   GIM_Try, /*On fail goto*//*Label 13050*/ GIMT_Encode4(848431), // Rule ID 24039 //
     /*  848361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  848372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  848375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  848378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  848407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  848410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848429 */     GIR_RootConstrainSelectedInstOperands,
     /*  848430 */     // GIR_Coverage, 24039,
     /*  848430 */     GIR_EraseRootFromParent_Done,
     /*  848431 */   // Label 13050: @848431
     /*  848431 */   GIM_Try, /*On fail goto*//*Label 13051*/ GIMT_Encode4(848506), // Rule ID 24042 //
     /*  848436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  848447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  848450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  848453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  848482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848504 */     GIR_RootConstrainSelectedInstOperands,
     /*  848505 */     // GIR_Coverage, 24042,
     /*  848505 */     GIR_EraseRootFromParent_Done,
     /*  848506 */   // Label 13051: @848506
     /*  848506 */   GIM_Try, /*On fail goto*//*Label 13052*/ GIMT_Encode4(848581), // Rule ID 24043 //
     /*  848511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  848522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  848525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  848528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848557 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  848557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848579 */     GIR_RootConstrainSelectedInstOperands,
     /*  848580 */     // GIR_Coverage, 24043,
     /*  848580 */     GIR_EraseRootFromParent_Done,
     /*  848581 */   // Label 13052: @848581
     /*  848581 */   GIM_Try, /*On fail goto*//*Label 13053*/ GIMT_Encode4(848656), // Rule ID 24046 //
     /*  848586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  848597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  848600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  848603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  848632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848654 */     GIR_RootConstrainSelectedInstOperands,
     /*  848655 */     // GIR_Coverage, 24046,
     /*  848655 */     GIR_EraseRootFromParent_Done,
     /*  848656 */   // Label 13053: @848656
     /*  848656 */   GIM_Try, /*On fail goto*//*Label 13054*/ GIMT_Encode4(848731), // Rule ID 24047 //
     /*  848661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  848672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  848675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  848678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848707 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  848707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848729 */     GIR_RootConstrainSelectedInstOperands,
     /*  848730 */     // GIR_Coverage, 24047,
     /*  848730 */     GIR_EraseRootFromParent_Done,
     /*  848731 */   // Label 13054: @848731
     /*  848731 */   GIM_Try, /*On fail goto*//*Label 13055*/ GIMT_Encode4(848806), // Rule ID 24050 //
     /*  848736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  848739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  848747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  848750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  848753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848782 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  848782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  848785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848804 */     GIR_RootConstrainSelectedInstOperands,
     /*  848805 */     // GIR_Coverage, 24050,
     /*  848805 */     GIR_EraseRootFromParent_Done,
     /*  848806 */   // Label 13055: @848806
     /*  848806 */   GIM_Try, /*On fail goto*//*Label 13056*/ GIMT_Encode4(848881), // Rule ID 24051 //
     /*  848811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  848814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  848822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  848825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  848828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848857 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  848857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  848860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848879 */     GIR_RootConstrainSelectedInstOperands,
     /*  848880 */     // GIR_Coverage, 24051,
     /*  848880 */     GIR_EraseRootFromParent_Done,
     /*  848881 */   // Label 13056: @848881
     /*  848881 */   GIM_Try, /*On fail goto*//*Label 13057*/ GIMT_Encode4(848956), // Rule ID 24054 //
     /*  848886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  848889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  848897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  848900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  848903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848932 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  848932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848954 */     GIR_RootConstrainSelectedInstOperands,
     /*  848955 */     // GIR_Coverage, 24054,
     /*  848955 */     GIR_EraseRootFromParent_Done,
     /*  848956 */   // Label 13057: @848956
     /*  848956 */   GIM_Try, /*On fail goto*//*Label 13058*/ GIMT_Encode4(849031), // Rule ID 24055 //
     /*  848961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  848964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  848972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  848975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  848978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849007 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  849007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  849010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  849026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849029 */     GIR_RootConstrainSelectedInstOperands,
     /*  849030 */     // GIR_Coverage, 24055,
     /*  849030 */     GIR_EraseRootFromParent_Done,
     /*  849031 */   // Label 13058: @849031
     /*  849031 */   GIM_Try, /*On fail goto*//*Label 13059*/ GIMT_Encode4(849106), // Rule ID 24058 //
     /*  849036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  849039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  849047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  849050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  849053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849082 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  849082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  849085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  849101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849104 */     GIR_RootConstrainSelectedInstOperands,
     /*  849105 */     // GIR_Coverage, 24058,
     /*  849105 */     GIR_EraseRootFromParent_Done,
     /*  849106 */   // Label 13059: @849106
     /*  849106 */   GIM_Try, /*On fail goto*//*Label 13060*/ GIMT_Encode4(849181), // Rule ID 24059 //
     /*  849111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  849114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  849122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  849125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  849128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849157 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  849157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  849160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  849176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849179 */     GIR_RootConstrainSelectedInstOperands,
     /*  849180 */     // GIR_Coverage, 24059,
     /*  849180 */     GIR_EraseRootFromParent_Done,
     /*  849181 */   // Label 13060: @849181
     /*  849181 */   GIM_Try, /*On fail goto*//*Label 13061*/ GIMT_Encode4(849256), // Rule ID 24062 //
     /*  849186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  849197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  849200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  849203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849232 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  849235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849254 */     GIR_RootConstrainSelectedInstOperands,
     /*  849255 */     // GIR_Coverage, 24062,
     /*  849255 */     GIR_EraseRootFromParent_Done,
     /*  849256 */   // Label 13061: @849256
     /*  849256 */   GIM_Try, /*On fail goto*//*Label 13062*/ GIMT_Encode4(849331), // Rule ID 24063 //
     /*  849261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  849272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  849275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  849278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849307 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  849310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849329 */     GIR_RootConstrainSelectedInstOperands,
     /*  849330 */     // GIR_Coverage, 24063,
     /*  849330 */     GIR_EraseRootFromParent_Done,
     /*  849331 */   // Label 13062: @849331
     /*  849331 */   GIM_Try, /*On fail goto*//*Label 13063*/ GIMT_Encode4(849406), // Rule ID 24066 //
     /*  849336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  849347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  849350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  849353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849382 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  849385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849404 */     GIR_RootConstrainSelectedInstOperands,
     /*  849405 */     // GIR_Coverage, 24066,
     /*  849405 */     GIR_EraseRootFromParent_Done,
     /*  849406 */   // Label 13063: @849406
     /*  849406 */   GIM_Try, /*On fail goto*//*Label 13064*/ GIMT_Encode4(849481), // Rule ID 24067 //
     /*  849411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  849422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  849425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  849428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849457 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  849460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849479 */     GIR_RootConstrainSelectedInstOperands,
     /*  849480 */     // GIR_Coverage, 24067,
     /*  849480 */     GIR_EraseRootFromParent_Done,
     /*  849481 */   // Label 13064: @849481
     /*  849481 */   GIM_Try, /*On fail goto*//*Label 13065*/ GIMT_Encode4(849556), // Rule ID 24070 //
     /*  849486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  849500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849532 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849554 */     GIR_RootConstrainSelectedInstOperands,
     /*  849555 */     // GIR_Coverage, 24070,
     /*  849555 */     GIR_EraseRootFromParent_Done,
     /*  849556 */   // Label 13065: @849556
     /*  849556 */   GIM_Try, /*On fail goto*//*Label 13066*/ GIMT_Encode4(849631), // Rule ID 24071 //
     /*  849561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  849575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849607 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849629 */     GIR_RootConstrainSelectedInstOperands,
     /*  849630 */     // GIR_Coverage, 24071,
     /*  849630 */     GIR_EraseRootFromParent_Done,
     /*  849631 */   // Label 13066: @849631
     /*  849631 */   GIM_Try, /*On fail goto*//*Label 13067*/ GIMT_Encode4(849706), // Rule ID 24074 //
     /*  849636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  849647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  849650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  849653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849682 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  849685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849704 */     GIR_RootConstrainSelectedInstOperands,
     /*  849705 */     // GIR_Coverage, 24074,
     /*  849705 */     GIR_EraseRootFromParent_Done,
     /*  849706 */   // Label 13067: @849706
     /*  849706 */   GIM_Try, /*On fail goto*//*Label 13068*/ GIMT_Encode4(849781), // Rule ID 24075 //
     /*  849711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  849722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  849725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  849728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849757 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  849760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849779 */     GIR_RootConstrainSelectedInstOperands,
     /*  849780 */     // GIR_Coverage, 24075,
     /*  849780 */     GIR_EraseRootFromParent_Done,
     /*  849781 */   // Label 13068: @849781
     /*  849781 */   GIM_Try, /*On fail goto*//*Label 13069*/ GIMT_Encode4(849856), // Rule ID 24078 //
     /*  849786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  849797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  849800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  849803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849832 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849854 */     GIR_RootConstrainSelectedInstOperands,
     /*  849855 */     // GIR_Coverage, 24078,
     /*  849855 */     GIR_EraseRootFromParent_Done,
     /*  849856 */   // Label 13069: @849856
     /*  849856 */   GIM_Try, /*On fail goto*//*Label 13070*/ GIMT_Encode4(849931), // Rule ID 24079 //
     /*  849861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  849872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  849875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  849878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849907 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849929 */     GIR_RootConstrainSelectedInstOperands,
     /*  849930 */     // GIR_Coverage, 24079,
     /*  849930 */     GIR_EraseRootFromParent_Done,
     /*  849931 */   // Label 13070: @849931
     /*  849931 */   GIM_Try, /*On fail goto*//*Label 13071*/ GIMT_Encode4(850006), // Rule ID 24082 //
     /*  849936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  849947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  849950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  849953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849982 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  849982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850004 */     GIR_RootConstrainSelectedInstOperands,
     /*  850005 */     // GIR_Coverage, 24082,
     /*  850005 */     GIR_EraseRootFromParent_Done,
     /*  850006 */   // Label 13071: @850006
     /*  850006 */   GIM_Try, /*On fail goto*//*Label 13072*/ GIMT_Encode4(850081), // Rule ID 24083 //
     /*  850011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  850022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  850025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  850028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850057 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  850057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  850060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850079 */     GIR_RootConstrainSelectedInstOperands,
     /*  850080 */     // GIR_Coverage, 24083,
     /*  850080 */     GIR_EraseRootFromParent_Done,
     /*  850081 */   // Label 13072: @850081
     /*  850081 */   GIM_Try, /*On fail goto*//*Label 13073*/ GIMT_Encode4(850156), // Rule ID 24086 //
     /*  850086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  850097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  850100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  850103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850154 */     GIR_RootConstrainSelectedInstOperands,
     /*  850155 */     // GIR_Coverage, 24086,
     /*  850155 */     GIR_EraseRootFromParent_Done,
     /*  850156 */   // Label 13073: @850156
     /*  850156 */   GIM_Try, /*On fail goto*//*Label 13074*/ GIMT_Encode4(850231), // Rule ID 24087 //
     /*  850161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  850172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  850175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  850178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850207 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850229 */     GIR_RootConstrainSelectedInstOperands,
     /*  850230 */     // GIR_Coverage, 24087,
     /*  850230 */     GIR_EraseRootFromParent_Done,
     /*  850231 */   // Label 13074: @850231
     /*  850231 */   GIM_Try, /*On fail goto*//*Label 13075*/ GIMT_Encode4(850306), // Rule ID 24090 //
     /*  850236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  850247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  850250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  850253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850282 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  850282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850304 */     GIR_RootConstrainSelectedInstOperands,
     /*  850305 */     // GIR_Coverage, 24090,
     /*  850305 */     GIR_EraseRootFromParent_Done,
     /*  850306 */   // Label 13075: @850306
     /*  850306 */   GIM_Try, /*On fail goto*//*Label 13076*/ GIMT_Encode4(850381), // Rule ID 24091 //
     /*  850311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  850322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  850325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  850328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850357 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  850357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850379 */     GIR_RootConstrainSelectedInstOperands,
     /*  850380 */     // GIR_Coverage, 24091,
     /*  850380 */     GIR_EraseRootFromParent_Done,
     /*  850381 */   // Label 13076: @850381
     /*  850381 */   GIM_Try, /*On fail goto*//*Label 13077*/ GIMT_Encode4(850456), // Rule ID 24094 //
     /*  850386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  850397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  850400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  850403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  850432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850454 */     GIR_RootConstrainSelectedInstOperands,
     /*  850455 */     // GIR_Coverage, 24094,
     /*  850455 */     GIR_EraseRootFromParent_Done,
     /*  850456 */   // Label 13077: @850456
     /*  850456 */   GIM_Try, /*On fail goto*//*Label 13078*/ GIMT_Encode4(850531), // Rule ID 24095 //
     /*  850461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  850472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  850475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  850478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850507 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  850507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850529 */     GIR_RootConstrainSelectedInstOperands,
     /*  850530 */     // GIR_Coverage, 24095,
     /*  850530 */     GIR_EraseRootFromParent_Done,
     /*  850531 */   // Label 13078: @850531
     /*  850531 */   GIM_Try, /*On fail goto*//*Label 13079*/ GIMT_Encode4(850606), // Rule ID 24098 //
     /*  850536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  850539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  850547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  850550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  850553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850582 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  850582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  850601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850604 */     GIR_RootConstrainSelectedInstOperands,
     /*  850605 */     // GIR_Coverage, 24098,
     /*  850605 */     GIR_EraseRootFromParent_Done,
     /*  850606 */   // Label 13079: @850606
     /*  850606 */   GIM_Try, /*On fail goto*//*Label 13080*/ GIMT_Encode4(850681), // Rule ID 24099 //
     /*  850611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  850614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  850622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  850625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  850628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850657 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  850657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  850676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850679 */     GIR_RootConstrainSelectedInstOperands,
     /*  850680 */     // GIR_Coverage, 24099,
     /*  850680 */     GIR_EraseRootFromParent_Done,
     /*  850681 */   // Label 13080: @850681
     /*  850681 */   GIM_Try, /*On fail goto*//*Label 13081*/ GIMT_Encode4(850756), // Rule ID 24102 //
     /*  850686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  850697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  850700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  850703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850732 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850754 */     GIR_RootConstrainSelectedInstOperands,
     /*  850755 */     // GIR_Coverage, 24102,
     /*  850755 */     GIR_EraseRootFromParent_Done,
     /*  850756 */   // Label 13081: @850756
     /*  850756 */   GIM_Try, /*On fail goto*//*Label 13082*/ GIMT_Encode4(850831), // Rule ID 24103 //
     /*  850761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  850772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  850775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  850778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850807 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850829 */     GIR_RootConstrainSelectedInstOperands,
     /*  850830 */     // GIR_Coverage, 24103,
     /*  850830 */     GIR_EraseRootFromParent_Done,
     /*  850831 */   // Label 13082: @850831
     /*  850831 */   GIM_Try, /*On fail goto*//*Label 13083*/ GIMT_Encode4(850906), // Rule ID 24106 //
     /*  850836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  850847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  850850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  850853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850882 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850904 */     GIR_RootConstrainSelectedInstOperands,
     /*  850905 */     // GIR_Coverage, 24106,
     /*  850905 */     GIR_EraseRootFromParent_Done,
     /*  850906 */   // Label 13083: @850906
     /*  850906 */   GIM_Try, /*On fail goto*//*Label 13084*/ GIMT_Encode4(850981), // Rule ID 24107 //
     /*  850911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  850922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  850925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  850928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850957 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850979 */     GIR_RootConstrainSelectedInstOperands,
     /*  850980 */     // GIR_Coverage, 24107,
     /*  850980 */     GIR_EraseRootFromParent_Done,
     /*  850981 */   // Label 13084: @850981
     /*  850981 */   GIM_Try, /*On fail goto*//*Label 13085*/ GIMT_Encode4(851056), // Rule ID 24110 //
     /*  850986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  850997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  851000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  851003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851032 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  851032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851054 */     GIR_RootConstrainSelectedInstOperands,
     /*  851055 */     // GIR_Coverage, 24110,
     /*  851055 */     GIR_EraseRootFromParent_Done,
     /*  851056 */   // Label 13085: @851056
     /*  851056 */   GIM_Try, /*On fail goto*//*Label 13086*/ GIMT_Encode4(851131), // Rule ID 24111 //
     /*  851061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  851072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  851075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  851078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851107 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  851107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851129 */     GIR_RootConstrainSelectedInstOperands,
     /*  851130 */     // GIR_Coverage, 24111,
     /*  851130 */     GIR_EraseRootFromParent_Done,
     /*  851131 */   // Label 13086: @851131
     /*  851131 */   GIM_Try, /*On fail goto*//*Label 13087*/ GIMT_Encode4(851206), // Rule ID 24114 //
     /*  851136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  851147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  851150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  851153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851182 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851204 */     GIR_RootConstrainSelectedInstOperands,
     /*  851205 */     // GIR_Coverage, 24114,
     /*  851205 */     GIR_EraseRootFromParent_Done,
     /*  851206 */   // Label 13087: @851206
     /*  851206 */   GIM_Try, /*On fail goto*//*Label 13088*/ GIMT_Encode4(851281), // Rule ID 24115 //
     /*  851211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  851222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  851225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  851228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851257 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851279 */     GIR_RootConstrainSelectedInstOperands,
     /*  851280 */     // GIR_Coverage, 24115,
     /*  851280 */     GIR_EraseRootFromParent_Done,
     /*  851281 */   // Label 13088: @851281
     /*  851281 */   GIM_Try, /*On fail goto*//*Label 13089*/ GIMT_Encode4(851356), // Rule ID 24118 //
     /*  851286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  851297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  851300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  851303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851332 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851354 */     GIR_RootConstrainSelectedInstOperands,
     /*  851355 */     // GIR_Coverage, 24118,
     /*  851355 */     GIR_EraseRootFromParent_Done,
     /*  851356 */   // Label 13089: @851356
     /*  851356 */   GIM_Try, /*On fail goto*//*Label 13090*/ GIMT_Encode4(851431), // Rule ID 24119 //
     /*  851361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  851372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  851375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  851378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851407 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851429 */     GIR_RootConstrainSelectedInstOperands,
     /*  851430 */     // GIR_Coverage, 24119,
     /*  851430 */     GIR_EraseRootFromParent_Done,
     /*  851431 */   // Label 13090: @851431
     /*  851431 */   GIM_Try, /*On fail goto*//*Label 13091*/ GIMT_Encode4(851506), // Rule ID 24122 //
     /*  851436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  851447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  851450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  851453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851482 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851504 */     GIR_RootConstrainSelectedInstOperands,
     /*  851505 */     // GIR_Coverage, 24122,
     /*  851505 */     GIR_EraseRootFromParent_Done,
     /*  851506 */   // Label 13091: @851506
     /*  851506 */   GIM_Try, /*On fail goto*//*Label 13092*/ GIMT_Encode4(851581), // Rule ID 24123 //
     /*  851511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  851522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  851525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  851528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851557 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851579 */     GIR_RootConstrainSelectedInstOperands,
     /*  851580 */     // GIR_Coverage, 24123,
     /*  851580 */     GIR_EraseRootFromParent_Done,
     /*  851581 */   // Label 13092: @851581
     /*  851581 */   GIM_Try, /*On fail goto*//*Label 13093*/ GIMT_Encode4(851656), // Rule ID 24126 //
     /*  851586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  851597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  851600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  851603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851654 */     GIR_RootConstrainSelectedInstOperands,
     /*  851655 */     // GIR_Coverage, 24126,
     /*  851655 */     GIR_EraseRootFromParent_Done,
     /*  851656 */   // Label 13093: @851656
     /*  851656 */   GIM_Try, /*On fail goto*//*Label 13094*/ GIMT_Encode4(851731), // Rule ID 24127 //
     /*  851661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  851672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  851675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  851678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851707 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851729 */     GIR_RootConstrainSelectedInstOperands,
     /*  851730 */     // GIR_Coverage, 24127,
     /*  851730 */     GIR_EraseRootFromParent_Done,
     /*  851731 */   // Label 13094: @851731
     /*  851731 */   GIM_Try, /*On fail goto*//*Label 13095*/ GIMT_Encode4(851806), // Rule ID 24130 //
     /*  851736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  851747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  851750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  851753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851782 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851804 */     GIR_RootConstrainSelectedInstOperands,
     /*  851805 */     // GIR_Coverage, 24130,
     /*  851805 */     GIR_EraseRootFromParent_Done,
     /*  851806 */   // Label 13095: @851806
     /*  851806 */   GIM_Try, /*On fail goto*//*Label 13096*/ GIMT_Encode4(851881), // Rule ID 24131 //
     /*  851811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  851822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  851825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  851828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851857 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851879 */     GIR_RootConstrainSelectedInstOperands,
     /*  851880 */     // GIR_Coverage, 24131,
     /*  851880 */     GIR_EraseRootFromParent_Done,
     /*  851881 */   // Label 13096: @851881
     /*  851881 */   GIM_Try, /*On fail goto*//*Label 13097*/ GIMT_Encode4(851956), // Rule ID 24134 //
     /*  851886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  851897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  851900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  851903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851954 */     GIR_RootConstrainSelectedInstOperands,
     /*  851955 */     // GIR_Coverage, 24134,
     /*  851955 */     GIR_EraseRootFromParent_Done,
     /*  851956 */   // Label 13097: @851956
     /*  851956 */   GIM_Try, /*On fail goto*//*Label 13098*/ GIMT_Encode4(852031), // Rule ID 24135 //
     /*  851961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  851972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  851975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  851978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852007 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  852007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  852010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852029 */     GIR_RootConstrainSelectedInstOperands,
     /*  852030 */     // GIR_Coverage, 24135,
     /*  852030 */     GIR_EraseRootFromParent_Done,
     /*  852031 */   // Label 13098: @852031
     /*  852031 */   GIM_Try, /*On fail goto*//*Label 13099*/ GIMT_Encode4(852106), // Rule ID 24138 //
     /*  852036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  852039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  852047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  852050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  852053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852082 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  852085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852104 */     GIR_RootConstrainSelectedInstOperands,
     /*  852105 */     // GIR_Coverage, 24138,
     /*  852105 */     GIR_EraseRootFromParent_Done,
     /*  852106 */   // Label 13099: @852106
     /*  852106 */   GIM_Try, /*On fail goto*//*Label 13100*/ GIMT_Encode4(852181), // Rule ID 24139 //
     /*  852111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  852114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  852122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  852125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  852128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852157 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  852160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852179 */     GIR_RootConstrainSelectedInstOperands,
     /*  852180 */     // GIR_Coverage, 24139,
     /*  852180 */     GIR_EraseRootFromParent_Done,
     /*  852181 */   // Label 13100: @852181
     /*  852181 */   GIM_Try, /*On fail goto*//*Label 13101*/ GIMT_Encode4(852256), // Rule ID 24142 //
     /*  852186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  852189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  852197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  852200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  852203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852232 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  852235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852254 */     GIR_RootConstrainSelectedInstOperands,
     /*  852255 */     // GIR_Coverage, 24142,
     /*  852255 */     GIR_EraseRootFromParent_Done,
     /*  852256 */   // Label 13101: @852256
     /*  852256 */   GIM_Try, /*On fail goto*//*Label 13102*/ GIMT_Encode4(852331), // Rule ID 24143 //
     /*  852261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  852264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  852272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  852275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  852278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852307 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  852310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852329 */     GIR_RootConstrainSelectedInstOperands,
     /*  852330 */     // GIR_Coverage, 24143,
     /*  852330 */     GIR_EraseRootFromParent_Done,
     /*  852331 */   // Label 13102: @852331
     /*  852331 */   GIM_Try, /*On fail goto*//*Label 13103*/ GIMT_Encode4(852406), // Rule ID 24146 //
     /*  852336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  852339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  852347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  852350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  852353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852382 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  852385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852404 */     GIR_RootConstrainSelectedInstOperands,
     /*  852405 */     // GIR_Coverage, 24146,
     /*  852405 */     GIR_EraseRootFromParent_Done,
     /*  852406 */   // Label 13103: @852406
     /*  852406 */   GIM_Try, /*On fail goto*//*Label 13104*/ GIMT_Encode4(852481), // Rule ID 24147 //
     /*  852411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  852414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  852422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  852425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  852428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852457 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  852460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852479 */     GIR_RootConstrainSelectedInstOperands,
     /*  852480 */     // GIR_Coverage, 24147,
     /*  852480 */     GIR_EraseRootFromParent_Done,
     /*  852481 */   // Label 13104: @852481
     /*  852481 */   GIM_Try, /*On fail goto*//*Label 13105*/ GIMT_Encode4(852556), // Rule ID 24390 //
     /*  852486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  852497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  852500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  852503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852532 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  852535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852554 */     GIR_RootConstrainSelectedInstOperands,
     /*  852555 */     // GIR_Coverage, 24390,
     /*  852555 */     GIR_EraseRootFromParent_Done,
     /*  852556 */   // Label 13105: @852556
     /*  852556 */   GIM_Try, /*On fail goto*//*Label 13106*/ GIMT_Encode4(852631), // Rule ID 24391 //
     /*  852561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  852572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  852575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  852578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852607 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  852610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852629 */     GIR_RootConstrainSelectedInstOperands,
     /*  852630 */     // GIR_Coverage, 24391,
     /*  852630 */     GIR_EraseRootFromParent_Done,
     /*  852631 */   // Label 13106: @852631
     /*  852631 */   GIM_Try, /*On fail goto*//*Label 13107*/ GIMT_Encode4(852706), // Rule ID 24394 //
     /*  852636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  852647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  852650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  852653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852682 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  852685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852704 */     GIR_RootConstrainSelectedInstOperands,
     /*  852705 */     // GIR_Coverage, 24394,
     /*  852705 */     GIR_EraseRootFromParent_Done,
     /*  852706 */   // Label 13107: @852706
     /*  852706 */   GIM_Try, /*On fail goto*//*Label 13108*/ GIMT_Encode4(852781), // Rule ID 24395 //
     /*  852711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  852722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  852725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  852728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852757 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  852760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852779 */     GIR_RootConstrainSelectedInstOperands,
     /*  852780 */     // GIR_Coverage, 24395,
     /*  852780 */     GIR_EraseRootFromParent_Done,
     /*  852781 */   // Label 13108: @852781
     /*  852781 */   GIM_Try, /*On fail goto*//*Label 13109*/ GIMT_Encode4(852856), // Rule ID 24398 //
     /*  852786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  852789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  852797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  852800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  852803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852832 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  852832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  852835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852854 */     GIR_RootConstrainSelectedInstOperands,
     /*  852855 */     // GIR_Coverage, 24398,
     /*  852855 */     GIR_EraseRootFromParent_Done,
     /*  852856 */   // Label 13109: @852856
     /*  852856 */   GIM_Try, /*On fail goto*//*Label 13110*/ GIMT_Encode4(852931), // Rule ID 24399 //
     /*  852861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  852864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  852872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  852875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  852878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852907 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  852907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  852910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852929 */     GIR_RootConstrainSelectedInstOperands,
     /*  852930 */     // GIR_Coverage, 24399,
     /*  852930 */     GIR_EraseRootFromParent_Done,
     /*  852931 */   // Label 13110: @852931
     /*  852931 */   GIM_Try, /*On fail goto*//*Label 13111*/ GIMT_Encode4(853006), // Rule ID 24402 //
     /*  852936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  852947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  852950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  852953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852982 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11328:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  852985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853004 */     GIR_RootConstrainSelectedInstOperands,
     /*  853005 */     // GIR_Coverage, 24402,
     /*  853005 */     GIR_EraseRootFromParent_Done,
     /*  853006 */   // Label 13111: @853006
     /*  853006 */   GIM_Try, /*On fail goto*//*Label 13112*/ GIMT_Encode4(853081), // Rule ID 24403 //
     /*  853011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  853022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  853025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  853028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853057 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11328:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  853060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853079 */     GIR_RootConstrainSelectedInstOperands,
     /*  853080 */     // GIR_Coverage, 24403,
     /*  853080 */     GIR_EraseRootFromParent_Done,
     /*  853081 */   // Label 13112: @853081
     /*  853081 */   GIM_Try, /*On fail goto*//*Label 13113*/ GIMT_Encode4(853156), // Rule ID 24406 //
     /*  853086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  853097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  853100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  853103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853132 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  853135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853154 */     GIR_RootConstrainSelectedInstOperands,
     /*  853155 */     // GIR_Coverage, 24406,
     /*  853155 */     GIR_EraseRootFromParent_Done,
     /*  853156 */   // Label 13113: @853156
     /*  853156 */   GIM_Try, /*On fail goto*//*Label 13114*/ GIMT_Encode4(853231), // Rule ID 24407 //
     /*  853161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  853164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  853172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  853175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  853178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853207 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  853210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853229 */     GIR_RootConstrainSelectedInstOperands,
     /*  853230 */     // GIR_Coverage, 24407,
     /*  853230 */     GIR_EraseRootFromParent_Done,
     /*  853231 */   // Label 13114: @853231
     /*  853231 */   GIM_Try, /*On fail goto*//*Label 13115*/ GIMT_Encode4(853306), // Rule ID 24410 //
     /*  853236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  853239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  853250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853282 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  853282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  853285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853304 */     GIR_RootConstrainSelectedInstOperands,
     /*  853305 */     // GIR_Coverage, 24410,
     /*  853305 */     GIR_EraseRootFromParent_Done,
     /*  853306 */   // Label 13115: @853306
     /*  853306 */   GIM_Try, /*On fail goto*//*Label 13116*/ GIMT_Encode4(853381), // Rule ID 24411 //
     /*  853311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  853314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  853325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853357 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  853357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  853360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853379 */     GIR_RootConstrainSelectedInstOperands,
     /*  853380 */     // GIR_Coverage, 24411,
     /*  853380 */     GIR_EraseRootFromParent_Done,
     /*  853381 */   // Label 13116: @853381
     /*  853381 */   GIM_Try, /*On fail goto*//*Label 13117*/ GIMT_Encode4(853456), // Rule ID 24414 //
     /*  853386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  853389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  853397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  853400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  853403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853432 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11328:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  853435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853454 */     GIR_RootConstrainSelectedInstOperands,
     /*  853455 */     // GIR_Coverage, 24414,
     /*  853455 */     GIR_EraseRootFromParent_Done,
     /*  853456 */   // Label 13117: @853456
     /*  853456 */   GIM_Try, /*On fail goto*//*Label 13118*/ GIMT_Encode4(853531), // Rule ID 24415 //
     /*  853461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  853472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  853475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  853478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853507 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11328:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  853510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853529 */     GIR_RootConstrainSelectedInstOperands,
     /*  853530 */     // GIR_Coverage, 24415,
     /*  853530 */     GIR_EraseRootFromParent_Done,
     /*  853531 */   // Label 13118: @853531
     /*  853531 */   GIM_Try, /*On fail goto*//*Label 13119*/ GIMT_Encode4(853606), // Rule ID 24418 //
     /*  853536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  853539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  853547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  853550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  853553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853582 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11328:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  853585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853604 */     GIR_RootConstrainSelectedInstOperands,
     /*  853605 */     // GIR_Coverage, 24418,
     /*  853605 */     GIR_EraseRootFromParent_Done,
     /*  853606 */   // Label 13119: @853606
     /*  853606 */   GIM_Try, /*On fail goto*//*Label 13120*/ GIMT_Encode4(853681), // Rule ID 24419 //
     /*  853611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  853622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  853625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  853628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853657 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11328:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  853660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853679 */     GIR_RootConstrainSelectedInstOperands,
     /*  853680 */     // GIR_Coverage, 24419,
     /*  853680 */     GIR_EraseRootFromParent_Done,
     /*  853681 */   // Label 13120: @853681
     /*  853681 */   GIM_Try, /*On fail goto*//*Label 13121*/ GIMT_Encode4(853756), // Rule ID 24422 //
     /*  853686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  853689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  853697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  853700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  853703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853732 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11328:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  853735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853754 */     GIR_RootConstrainSelectedInstOperands,
     /*  853755 */     // GIR_Coverage, 24422,
     /*  853755 */     GIR_EraseRootFromParent_Done,
     /*  853756 */   // Label 13121: @853756
     /*  853756 */   GIM_Try, /*On fail goto*//*Label 13122*/ GIMT_Encode4(853831), // Rule ID 24423 //
     /*  853761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  853772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  853775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  853778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853807 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11328:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  853810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853829 */     GIR_RootConstrainSelectedInstOperands,
     /*  853830 */     // GIR_Coverage, 24423,
     /*  853830 */     GIR_EraseRootFromParent_Done,
     /*  853831 */   // Label 13122: @853831
     /*  853831 */   GIM_Try, /*On fail goto*//*Label 13123*/ GIMT_Encode4(853906), // Rule ID 24426 //
     /*  853836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  853847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  853850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  853853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853882 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11328:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  853885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853904 */     GIR_RootConstrainSelectedInstOperands,
     /*  853905 */     // GIR_Coverage, 24426,
     /*  853905 */     GIR_EraseRootFromParent_Done,
     /*  853906 */   // Label 13123: @853906
     /*  853906 */   GIM_Try, /*On fail goto*//*Label 13124*/ GIMT_Encode4(853981), // Rule ID 24427 //
     /*  853911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  853914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  853922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  853925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  853928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853957 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11328:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  853960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853979 */     GIR_RootConstrainSelectedInstOperands,
     /*  853980 */     // GIR_Coverage, 24427,
     /*  853980 */     GIR_EraseRootFromParent_Done,
     /*  853981 */   // Label 13124: @853981
     /*  853981 */   GIM_Try, /*On fail goto*//*Label 13125*/ GIMT_Encode4(854056), // Rule ID 24430 //
     /*  853986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  853997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  854000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  854003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854032 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11328:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  854032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  854035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854054 */     GIR_RootConstrainSelectedInstOperands,
     /*  854055 */     // GIR_Coverage, 24430,
     /*  854055 */     GIR_EraseRootFromParent_Done,
     /*  854056 */   // Label 13125: @854056
     /*  854056 */   GIM_Try, /*On fail goto*//*Label 13126*/ GIMT_Encode4(854131), // Rule ID 24431 //
     /*  854061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  854064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  854072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  854075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  854078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854107 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11328:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  854107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  854110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854129 */     GIR_RootConstrainSelectedInstOperands,
     /*  854130 */     // GIR_Coverage, 24431,
     /*  854130 */     GIR_EraseRootFromParent_Done,
     /*  854131 */   // Label 13126: @854131
     /*  854131 */   GIM_Try, /*On fail goto*//*Label 13127*/ GIMT_Encode4(854206), // Rule ID 24434 //
     /*  854136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  854139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  854147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  854150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  854153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854182 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11328:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  854182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  854185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854204 */     GIR_RootConstrainSelectedInstOperands,
     /*  854205 */     // GIR_Coverage, 24434,
     /*  854205 */     GIR_EraseRootFromParent_Done,
     /*  854206 */   // Label 13127: @854206
     /*  854206 */   GIM_Try, /*On fail goto*//*Label 13128*/ GIMT_Encode4(854281), // Rule ID 24435 //
     /*  854211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  854214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  854222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  854225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  854228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854257 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11328:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  854257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  854260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854279 */     GIR_RootConstrainSelectedInstOperands,
     /*  854280 */     // GIR_Coverage, 24435,
     /*  854280 */     GIR_EraseRootFromParent_Done,
     /*  854281 */   // Label 13128: @854281
     /*  854281 */   GIM_Try, /*On fail goto*//*Label 13129*/ GIMT_Encode4(854356), // Rule ID 24438 //
     /*  854286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  854289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  854297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  854300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  854303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854332 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11328:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  854332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  854335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854354 */     GIR_RootConstrainSelectedInstOperands,
     /*  854355 */     // GIR_Coverage, 24438,
     /*  854355 */     GIR_EraseRootFromParent_Done,
     /*  854356 */   // Label 13129: @854356
     /*  854356 */   GIM_Try, /*On fail goto*//*Label 13130*/ GIMT_Encode4(854431), // Rule ID 24439 //
     /*  854361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  854364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  854372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  854375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  854378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854407 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11328:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  854410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854429 */     GIR_RootConstrainSelectedInstOperands,
     /*  854430 */     // GIR_Coverage, 24439,
     /*  854430 */     GIR_EraseRootFromParent_Done,
     /*  854431 */   // Label 13130: @854431
     /*  854431 */   GIM_Try, /*On fail goto*//*Label 13131*/ GIMT_Encode4(854506), // Rule ID 24442 //
     /*  854436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  854439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  854447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  854450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  854453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854482 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11328:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  854482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  854485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854504 */     GIR_RootConstrainSelectedInstOperands,
     /*  854505 */     // GIR_Coverage, 24442,
     /*  854505 */     GIR_EraseRootFromParent_Done,
     /*  854506 */   // Label 13131: @854506
     /*  854506 */   GIM_Try, /*On fail goto*//*Label 13132*/ GIMT_Encode4(854581), // Rule ID 24443 //
     /*  854511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  854514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  854522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  854525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  854528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854557 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11328:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  854560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854579 */     GIR_RootConstrainSelectedInstOperands,
     /*  854580 */     // GIR_Coverage, 24443,
     /*  854580 */     GIR_EraseRootFromParent_Done,
     /*  854581 */   // Label 13132: @854581
     /*  854581 */   GIM_Try, /*On fail goto*//*Label 13133*/ GIMT_Encode4(854656), // Rule ID 24446 //
     /*  854586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  854589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  854597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  854600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  854603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854632 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11328:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  854632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  854635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854654 */     GIR_RootConstrainSelectedInstOperands,
     /*  854655 */     // GIR_Coverage, 24446,
     /*  854655 */     GIR_EraseRootFromParent_Done,
     /*  854656 */   // Label 13133: @854656
     /*  854656 */   GIM_Try, /*On fail goto*//*Label 13134*/ GIMT_Encode4(854731), // Rule ID 24447 //
     /*  854661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  854664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  854672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  854675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  854678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854707 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11328:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  854710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854729 */     GIR_RootConstrainSelectedInstOperands,
     /*  854730 */     // GIR_Coverage, 24447,
     /*  854730 */     GIR_EraseRootFromParent_Done,
     /*  854731 */   // Label 13134: @854731
     /*  854731 */   GIM_Try, /*On fail goto*//*Label 13135*/ GIMT_Encode4(854806), // Rule ID 24450 //
     /*  854736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  854747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  854750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  854753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854782 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  854785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854804 */     GIR_RootConstrainSelectedInstOperands,
     /*  854805 */     // GIR_Coverage, 24450,
     /*  854805 */     GIR_EraseRootFromParent_Done,
     /*  854806 */   // Label 13135: @854806
     /*  854806 */   GIM_Try, /*On fail goto*//*Label 13136*/ GIMT_Encode4(854881), // Rule ID 24451 //
     /*  854811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  854822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  854825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  854828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854857 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  854860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854879 */     GIR_RootConstrainSelectedInstOperands,
     /*  854880 */     // GIR_Coverage, 24451,
     /*  854880 */     GIR_EraseRootFromParent_Done,
     /*  854881 */   // Label 13136: @854881
     /*  854881 */   GIM_Try, /*On fail goto*//*Label 13137*/ GIMT_Encode4(854956), // Rule ID 24454 //
     /*  854886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  854897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  854900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  854903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854932 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  854935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854954 */     GIR_RootConstrainSelectedInstOperands,
     /*  854955 */     // GIR_Coverage, 24454,
     /*  854955 */     GIR_EraseRootFromParent_Done,
     /*  854956 */   // Label 13137: @854956
     /*  854956 */   GIM_Try, /*On fail goto*//*Label 13138*/ GIMT_Encode4(855031), // Rule ID 24455 //
     /*  854961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  854972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  854975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  854978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855007 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  855010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855029 */     GIR_RootConstrainSelectedInstOperands,
     /*  855030 */     // GIR_Coverage, 24455,
     /*  855030 */     GIR_EraseRootFromParent_Done,
     /*  855031 */   // Label 13138: @855031
     /*  855031 */   GIM_Try, /*On fail goto*//*Label 13139*/ GIMT_Encode4(855106), // Rule ID 24458 //
     /*  855036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  855047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  855050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  855053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855082 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  855085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855104 */     GIR_RootConstrainSelectedInstOperands,
     /*  855105 */     // GIR_Coverage, 24458,
     /*  855105 */     GIR_EraseRootFromParent_Done,
     /*  855106 */   // Label 13139: @855106
     /*  855106 */   GIM_Try, /*On fail goto*//*Label 13140*/ GIMT_Encode4(855181), // Rule ID 24459 //
     /*  855111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  855114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  855122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  855125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  855128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855157 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  855160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855179 */     GIR_RootConstrainSelectedInstOperands,
     /*  855180 */     // GIR_Coverage, 24459,
     /*  855180 */     GIR_EraseRootFromParent_Done,
     /*  855181 */   // Label 13140: @855181
     /*  855181 */   GIM_Try, /*On fail goto*//*Label 13141*/ GIMT_Encode4(855256), // Rule ID 24462 //
     /*  855186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  855197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  855200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  855203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855232 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  855235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855254 */     GIR_RootConstrainSelectedInstOperands,
     /*  855255 */     // GIR_Coverage, 24462,
     /*  855255 */     GIR_EraseRootFromParent_Done,
     /*  855256 */   // Label 13141: @855256
     /*  855256 */   GIM_Try, /*On fail goto*//*Label 13142*/ GIMT_Encode4(855331), // Rule ID 24463 //
     /*  855261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  855272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  855275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  855278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855307 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  855310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855329 */     GIR_RootConstrainSelectedInstOperands,
     /*  855330 */     // GIR_Coverage, 24463,
     /*  855330 */     GIR_EraseRootFromParent_Done,
     /*  855331 */   // Label 13142: @855331
     /*  855331 */   GIM_Try, /*On fail goto*//*Label 13143*/ GIMT_Encode4(855406), // Rule ID 24466 //
     /*  855336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  855347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  855350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  855353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855382 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  855385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855404 */     GIR_RootConstrainSelectedInstOperands,
     /*  855405 */     // GIR_Coverage, 24466,
     /*  855405 */     GIR_EraseRootFromParent_Done,
     /*  855406 */   // Label 13143: @855406
     /*  855406 */   GIM_Try, /*On fail goto*//*Label 13144*/ GIMT_Encode4(855481), // Rule ID 24467 //
     /*  855411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  855414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  855422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  855425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  855428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855457 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  855460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855479 */     GIR_RootConstrainSelectedInstOperands,
     /*  855480 */     // GIR_Coverage, 24467,
     /*  855480 */     GIR_EraseRootFromParent_Done,
     /*  855481 */   // Label 13144: @855481
     /*  855481 */   GIM_Try, /*On fail goto*//*Label 13145*/ GIMT_Encode4(855556), // Rule ID 24470 //
     /*  855486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  855489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  855497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  855500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  855503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855532 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  855535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855554 */     GIR_RootConstrainSelectedInstOperands,
     /*  855555 */     // GIR_Coverage, 24470,
     /*  855555 */     GIR_EraseRootFromParent_Done,
     /*  855556 */   // Label 13145: @855556
     /*  855556 */   GIM_Try, /*On fail goto*//*Label 13146*/ GIMT_Encode4(855631), // Rule ID 24471 //
     /*  855561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  855564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  855572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  855575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  855578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855607 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  855610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855629 */     GIR_RootConstrainSelectedInstOperands,
     /*  855630 */     // GIR_Coverage, 24471,
     /*  855630 */     GIR_EraseRootFromParent_Done,
     /*  855631 */   // Label 13146: @855631
     /*  855631 */   GIM_Try, /*On fail goto*//*Label 13147*/ GIMT_Encode4(855706), // Rule ID 24474 //
     /*  855636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  855647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  855650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  855653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855682 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  855685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855704 */     GIR_RootConstrainSelectedInstOperands,
     /*  855705 */     // GIR_Coverage, 24474,
     /*  855705 */     GIR_EraseRootFromParent_Done,
     /*  855706 */   // Label 13147: @855706
     /*  855706 */   GIM_Try, /*On fail goto*//*Label 13148*/ GIMT_Encode4(855781), // Rule ID 24475 //
     /*  855711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  855722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  855725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  855728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855757 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  855760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855779 */     GIR_RootConstrainSelectedInstOperands,
     /*  855780 */     // GIR_Coverage, 24475,
     /*  855780 */     GIR_EraseRootFromParent_Done,
     /*  855781 */   // Label 13148: @855781
     /*  855781 */   GIM_Try, /*On fail goto*//*Label 13149*/ GIMT_Encode4(855856), // Rule ID 24478 //
     /*  855786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  855800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855832 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  855835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855854 */     GIR_RootConstrainSelectedInstOperands,
     /*  855855 */     // GIR_Coverage, 24478,
     /*  855855 */     GIR_EraseRootFromParent_Done,
     /*  855856 */   // Label 13149: @855856
     /*  855856 */   GIM_Try, /*On fail goto*//*Label 13150*/ GIMT_Encode4(855931), // Rule ID 24479 //
     /*  855861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  855875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855907 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  855910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855929 */     GIR_RootConstrainSelectedInstOperands,
     /*  855930 */     // GIR_Coverage, 24479,
     /*  855930 */     GIR_EraseRootFromParent_Done,
     /*  855931 */   // Label 13150: @855931
     /*  855931 */   GIM_Try, /*On fail goto*//*Label 13151*/ GIMT_Encode4(856006), // Rule ID 24482 //
     /*  855936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  855950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855982 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  855985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856004 */     GIR_RootConstrainSelectedInstOperands,
     /*  856005 */     // GIR_Coverage, 24482,
     /*  856005 */     GIR_EraseRootFromParent_Done,
     /*  856006 */   // Label 13151: @856006
     /*  856006 */   GIM_Try, /*On fail goto*//*Label 13152*/ GIMT_Encode4(856081), // Rule ID 24483 //
     /*  856011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  856014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  856022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  856025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  856028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856057 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  856057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  856060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856079 */     GIR_RootConstrainSelectedInstOperands,
     /*  856080 */     // GIR_Coverage, 24483,
     /*  856080 */     GIR_EraseRootFromParent_Done,
     /*  856081 */   // Label 13152: @856081
     /*  856081 */   GIM_Try, /*On fail goto*//*Label 13153*/ GIMT_Encode4(856156), // Rule ID 24486 //
     /*  856086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  856089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  856097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  856100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  856103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856132 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  856132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  856135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856154 */     GIR_RootConstrainSelectedInstOperands,
     /*  856155 */     // GIR_Coverage, 24486,
     /*  856155 */     GIR_EraseRootFromParent_Done,
     /*  856156 */   // Label 13153: @856156
     /*  856156 */   GIM_Try, /*On fail goto*//*Label 13154*/ GIMT_Encode4(856231), // Rule ID 24487 //
     /*  856161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  856164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  856172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  856175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  856178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856207 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  856210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856229 */     GIR_RootConstrainSelectedInstOperands,
     /*  856230 */     // GIR_Coverage, 24487,
     /*  856230 */     GIR_EraseRootFromParent_Done,
     /*  856231 */   // Label 13154: @856231
     /*  856231 */   GIM_Try, /*On fail goto*//*Label 13155*/ GIMT_Encode4(856306), // Rule ID 24490 //
     /*  856236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  856239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  856247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  856250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  856253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856282 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  856282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  856285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856304 */     GIR_RootConstrainSelectedInstOperands,
     /*  856305 */     // GIR_Coverage, 24490,
     /*  856305 */     GIR_EraseRootFromParent_Done,
     /*  856306 */   // Label 13155: @856306
     /*  856306 */   GIM_Try, /*On fail goto*//*Label 13156*/ GIMT_Encode4(856381), // Rule ID 24491 //
     /*  856311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  856314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  856322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  856325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  856328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856357 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  856360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856379 */     GIR_RootConstrainSelectedInstOperands,
     /*  856380 */     // GIR_Coverage, 24491,
     /*  856380 */     GIR_EraseRootFromParent_Done,
     /*  856381 */   // Label 13156: @856381
     /*  856381 */   GIM_Try, /*On fail goto*//*Label 13157*/ GIMT_Encode4(856456), // Rule ID 24494 //
     /*  856386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  856389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  856397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  856400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  856403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856432 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  856432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  856435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856454 */     GIR_RootConstrainSelectedInstOperands,
     /*  856455 */     // GIR_Coverage, 24494,
     /*  856455 */     GIR_EraseRootFromParent_Done,
     /*  856456 */   // Label 13157: @856456
     /*  856456 */   GIM_Try, /*On fail goto*//*Label 13158*/ GIMT_Encode4(856531), // Rule ID 24495 //
     /*  856461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  856464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  856472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  856475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  856478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856507 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  856510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856529 */     GIR_RootConstrainSelectedInstOperands,
     /*  856530 */     // GIR_Coverage, 24495,
     /*  856530 */     GIR_EraseRootFromParent_Done,
     /*  856531 */   // Label 13158: @856531
     /*  856531 */   GIM_Try, /*On fail goto*//*Label 13159*/ GIMT_Encode4(856606), // Rule ID 24498 //
     /*  856536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  856547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  856550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  856553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856582 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  856585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856604 */     GIR_RootConstrainSelectedInstOperands,
     /*  856605 */     // GIR_Coverage, 24498,
     /*  856605 */     GIR_EraseRootFromParent_Done,
     /*  856606 */   // Label 13159: @856606
     /*  856606 */   GIM_Try, /*On fail goto*//*Label 13160*/ GIMT_Encode4(856681), // Rule ID 24499 //
     /*  856611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  856622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  856625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  856628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856657 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  856660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856679 */     GIR_RootConstrainSelectedInstOperands,
     /*  856680 */     // GIR_Coverage, 24499,
     /*  856680 */     GIR_EraseRootFromParent_Done,
     /*  856681 */   // Label 13160: @856681
     /*  856681 */   GIM_Try, /*On fail goto*//*Label 13161*/ GIMT_Encode4(856756), // Rule ID 24502 //
     /*  856686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  856697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  856700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  856703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856732 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  856735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856754 */     GIR_RootConstrainSelectedInstOperands,
     /*  856755 */     // GIR_Coverage, 24502,
     /*  856755 */     GIR_EraseRootFromParent_Done,
     /*  856756 */   // Label 13161: @856756
     /*  856756 */   GIM_Try, /*On fail goto*//*Label 13162*/ GIMT_Encode4(856831), // Rule ID 24503 //
     /*  856761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  856772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  856775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  856778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856807 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  856810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856829 */     GIR_RootConstrainSelectedInstOperands,
     /*  856830 */     // GIR_Coverage, 24503,
     /*  856830 */     GIR_EraseRootFromParent_Done,
     /*  856831 */   // Label 13162: @856831
     /*  856831 */   GIM_Try, /*On fail goto*//*Label 13163*/ GIMT_Encode4(856906), // Rule ID 24506 //
     /*  856836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  856847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  856850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  856853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856882 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  856885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856904 */     GIR_RootConstrainSelectedInstOperands,
     /*  856905 */     // GIR_Coverage, 24506,
     /*  856905 */     GIR_EraseRootFromParent_Done,
     /*  856906 */   // Label 13163: @856906
     /*  856906 */   GIM_Try, /*On fail goto*//*Label 13164*/ GIMT_Encode4(856981), // Rule ID 24507 //
     /*  856911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  856922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  856925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  856928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856957 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  856960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856979 */     GIR_RootConstrainSelectedInstOperands,
     /*  856980 */     // GIR_Coverage, 24507,
     /*  856980 */     GIR_EraseRootFromParent_Done,
     /*  856981 */   // Label 13164: @856981
     /*  856981 */   GIM_Try, /*On fail goto*//*Label 13165*/ GIMT_Encode4(857056), // Rule ID 24510 //
     /*  856986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  856997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  857000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  857003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  857006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857032 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  857035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857054 */     GIR_RootConstrainSelectedInstOperands,
     /*  857055 */     // GIR_Coverage, 24510,
     /*  857055 */     GIR_EraseRootFromParent_Done,
     /*  857056 */   // Label 13165: @857056
     /*  857056 */   GIM_Try, /*On fail goto*//*Label 13166*/ GIMT_Encode4(857131), // Rule ID 24511 //
     /*  857061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  857072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  857075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  857078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  857081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857107 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  857110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857129 */     GIR_RootConstrainSelectedInstOperands,
     /*  857130 */     // GIR_Coverage, 24511,
     /*  857130 */     GIR_EraseRootFromParent_Done,
     /*  857131 */   // Label 13166: @857131
     /*  857131 */   GIM_Try, /*On fail goto*//*Label 13167*/ GIMT_Encode4(857206), // Rule ID 24514 //
     /*  857136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  857147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  857150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  857153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  857156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857182 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  857185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857204 */     GIR_RootConstrainSelectedInstOperands,
     /*  857205 */     // GIR_Coverage, 24514,
     /*  857205 */     GIR_EraseRootFromParent_Done,
     /*  857206 */   // Label 13167: @857206
     /*  857206 */   GIM_Try, /*On fail goto*//*Label 13168*/ GIMT_Encode4(857281), // Rule ID 24515 //
     /*  857211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  857222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  857225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  857228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  857231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857257 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  857260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857279 */     GIR_RootConstrainSelectedInstOperands,
     /*  857280 */     // GIR_Coverage, 24515,
     /*  857280 */     GIR_EraseRootFromParent_Done,
     /*  857281 */   // Label 13168: @857281
     /*  857281 */   GIM_Try, /*On fail goto*//*Label 13169*/ GIMT_Encode4(857356), // Rule ID 24518 //
     /*  857286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  857297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  857300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  857303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  857306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857332 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  857335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857354 */     GIR_RootConstrainSelectedInstOperands,
     /*  857355 */     // GIR_Coverage, 24518,
     /*  857355 */     GIR_EraseRootFromParent_Done,
     /*  857356 */   // Label 13169: @857356
     /*  857356 */   GIM_Try, /*On fail goto*//*Label 13170*/ GIMT_Encode4(857431), // Rule ID 24519 //
     /*  857361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  857372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  857375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  857378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  857381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857407 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  857410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857429 */     GIR_RootConstrainSelectedInstOperands,
     /*  857430 */     // GIR_Coverage, 24519,
     /*  857430 */     GIR_EraseRootFromParent_Done,
     /*  857431 */   // Label 13170: @857431
     /*  857431 */   GIM_Try, /*On fail goto*//*Label 13171*/ GIMT_Encode4(857506), // Rule ID 24522 //
     /*  857436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  857447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  857450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  857453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  857456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857482 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  857485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857504 */     GIR_RootConstrainSelectedInstOperands,
     /*  857505 */     // GIR_Coverage, 24522,
     /*  857505 */     GIR_EraseRootFromParent_Done,
     /*  857506 */   // Label 13171: @857506
     /*  857506 */   GIM_Try, /*On fail goto*//*Label 13172*/ GIMT_Encode4(857581), // Rule ID 24523 //
     /*  857511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  857522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  857525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  857528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  857531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857557 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  857560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857579 */     GIR_RootConstrainSelectedInstOperands,
     /*  857580 */     // GIR_Coverage, 24523,
     /*  857580 */     GIR_EraseRootFromParent_Done,
     /*  857581 */   // Label 13172: @857581
     /*  857581 */   GIM_Try, /*On fail goto*//*Label 13173*/ GIMT_Encode4(857656), // Rule ID 24526 //
     /*  857586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  857597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  857600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  857603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  857606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857632 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  857635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857654 */     GIR_RootConstrainSelectedInstOperands,
     /*  857655 */     // GIR_Coverage, 24526,
     /*  857655 */     GIR_EraseRootFromParent_Done,
     /*  857656 */   // Label 13173: @857656
     /*  857656 */   GIM_Try, /*On fail goto*//*Label 13174*/ GIMT_Encode4(857731), // Rule ID 24527 //
     /*  857661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  857672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  857675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  857678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  857681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857707 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  857710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857729 */     GIR_RootConstrainSelectedInstOperands,
     /*  857730 */     // GIR_Coverage, 24527,
     /*  857730 */     GIR_EraseRootFromParent_Done,
     /*  857731 */   // Label 13174: @857731
     /*  857731 */   GIM_Try, /*On fail goto*//*Label 13175*/ GIMT_Encode4(857806), // Rule ID 24530 //
     /*  857736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  857747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  857750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  857753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  857756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  857785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857804 */     GIR_RootConstrainSelectedInstOperands,
     /*  857805 */     // GIR_Coverage, 24530,
     /*  857805 */     GIR_EraseRootFromParent_Done,
     /*  857806 */   // Label 13175: @857806
     /*  857806 */   GIM_Try, /*On fail goto*//*Label 13176*/ GIMT_Encode4(857881), // Rule ID 24531 //
     /*  857811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  857822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  857825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  857828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  857831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857857 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  857860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857879 */     GIR_RootConstrainSelectedInstOperands,
     /*  857880 */     // GIR_Coverage, 24531,
     /*  857880 */     GIR_EraseRootFromParent_Done,
     /*  857881 */   // Label 13176: @857881
     /*  857881 */   GIM_Try, /*On fail goto*//*Label 13177*/ GIMT_Encode4(857956), // Rule ID 24534 //
     /*  857886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  857897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  857900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  857903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  857906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857932 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  857935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857954 */     GIR_RootConstrainSelectedInstOperands,
     /*  857955 */     // GIR_Coverage, 24534,
     /*  857955 */     GIR_EraseRootFromParent_Done,
     /*  857956 */   // Label 13177: @857956
     /*  857956 */   GIM_Try, /*On fail goto*//*Label 13178*/ GIMT_Encode4(858031), // Rule ID 24535 //
     /*  857961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  857972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  857975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  857978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  857981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858007 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  858010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858029 */     GIR_RootConstrainSelectedInstOperands,
     /*  858030 */     // GIR_Coverage, 24535,
     /*  858030 */     GIR_EraseRootFromParent_Done,
     /*  858031 */   // Label 13178: @858031
     /*  858031 */   GIM_Try, /*On fail goto*//*Label 13179*/ GIMT_Encode4(858106), // Rule ID 24538 //
     /*  858036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  858047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  858050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  858053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  858056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858082 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  858085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858104 */     GIR_RootConstrainSelectedInstOperands,
     /*  858105 */     // GIR_Coverage, 24538,
     /*  858105 */     GIR_EraseRootFromParent_Done,
     /*  858106 */   // Label 13179: @858106
     /*  858106 */   GIM_Try, /*On fail goto*//*Label 13180*/ GIMT_Encode4(858181), // Rule ID 24539 //
     /*  858111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  858122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  858125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  858128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  858131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858157 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  858160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858179 */     GIR_RootConstrainSelectedInstOperands,
     /*  858180 */     // GIR_Coverage, 24539,
     /*  858180 */     GIR_EraseRootFromParent_Done,
     /*  858181 */   // Label 13180: @858181
     /*  858181 */   GIM_Try, /*On fail goto*//*Label 13181*/ GIMT_Encode4(858256), // Rule ID 24542 //
     /*  858186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  858197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  858200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  858203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  858206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  858232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  858235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858254 */     GIR_RootConstrainSelectedInstOperands,
     /*  858255 */     // GIR_Coverage, 24542,
     /*  858255 */     GIR_EraseRootFromParent_Done,
     /*  858256 */   // Label 13181: @858256
     /*  858256 */   GIM_Try, /*On fail goto*//*Label 13182*/ GIMT_Encode4(858331), // Rule ID 24543 //
     /*  858261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  858272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  858275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  858278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  858281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858307 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  858307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  858310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858329 */     GIR_RootConstrainSelectedInstOperands,
     /*  858330 */     // GIR_Coverage, 24543,
     /*  858330 */     GIR_EraseRootFromParent_Done,
     /*  858331 */   // Label 13182: @858331
     /*  858331 */   GIM_Try, /*On fail goto*//*Label 13183*/ GIMT_Encode4(858406), // Rule ID 24546 //
     /*  858336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  858339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  858347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  858350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  858353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  858356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858382 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  858382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  858385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858404 */     GIR_RootConstrainSelectedInstOperands,
     /*  858405 */     // GIR_Coverage, 24546,
     /*  858405 */     GIR_EraseRootFromParent_Done,
     /*  858406 */   // Label 13183: @858406
     /*  858406 */   GIM_Try, /*On fail goto*//*Label 13184*/ GIMT_Encode4(858481), // Rule ID 24547 //
     /*  858411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  858414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  858422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  858425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  858428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  858431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858457 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  858457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  858460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858479 */     GIR_RootConstrainSelectedInstOperands,
     /*  858480 */     // GIR_Coverage, 24547,
     /*  858480 */     GIR_EraseRootFromParent_Done,
     /*  858481 */   // Label 13184: @858481
     /*  858481 */   GIM_Try, /*On fail goto*//*Label 13185*/ GIMT_Encode4(858556), // Rule ID 24550 //
     /*  858486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  858497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  858500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  858503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  858506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  858532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  858535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858554 */     GIR_RootConstrainSelectedInstOperands,
     /*  858555 */     // GIR_Coverage, 24550,
     /*  858555 */     GIR_EraseRootFromParent_Done,
     /*  858556 */   // Label 13185: @858556
     /*  858556 */   GIM_Try, /*On fail goto*//*Label 13186*/ GIMT_Encode4(858631), // Rule ID 24551 //
     /*  858561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  858572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  858575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  858578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  858581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858607 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  858610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858629 */     GIR_RootConstrainSelectedInstOperands,
     /*  858630 */     // GIR_Coverage, 24551,
     /*  858630 */     GIR_EraseRootFromParent_Done,
     /*  858631 */   // Label 13186: @858631
     /*  858631 */   GIM_Try, /*On fail goto*//*Label 13187*/ GIMT_Encode4(858706), // Rule ID 24554 //
     /*  858636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  858647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  858650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  858653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  858656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858682 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  858682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  858685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858704 */     GIR_RootConstrainSelectedInstOperands,
     /*  858705 */     // GIR_Coverage, 24554,
     /*  858705 */     GIR_EraseRootFromParent_Done,
     /*  858706 */   // Label 13187: @858706
     /*  858706 */   GIM_Try, /*On fail goto*//*Label 13188*/ GIMT_Encode4(858781), // Rule ID 24555 //
     /*  858711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  858722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  858725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  858728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  858731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858757 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  858760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858779 */     GIR_RootConstrainSelectedInstOperands,
     /*  858780 */     // GIR_Coverage, 24555,
     /*  858780 */     GIR_EraseRootFromParent_Done,
     /*  858781 */   // Label 13188: @858781
     /*  858781 */   GIM_Try, /*On fail goto*//*Label 13189*/ GIMT_Encode4(858856), // Rule ID 24558 //
     /*  858786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  858797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  858800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  858803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  858806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858832 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  858832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  858835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858854 */     GIR_RootConstrainSelectedInstOperands,
     /*  858855 */     // GIR_Coverage, 24558,
     /*  858855 */     GIR_EraseRootFromParent_Done,
     /*  858856 */   // Label 13189: @858856
     /*  858856 */   GIM_Try, /*On fail goto*//*Label 13190*/ GIMT_Encode4(858931), // Rule ID 24559 //
     /*  858861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  858872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  858875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  858878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  858881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858907 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  858910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858929 */     GIR_RootConstrainSelectedInstOperands,
     /*  858930 */     // GIR_Coverage, 24559,
     /*  858930 */     GIR_EraseRootFromParent_Done,
     /*  858931 */   // Label 13190: @858931
     /*  858931 */   GIM_Try, /*On fail goto*//*Label 13191*/ GIMT_Encode4(859006), // Rule ID 24562 //
     /*  858936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  858947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  858950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  858953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  858956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858982 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  858985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859004 */     GIR_RootConstrainSelectedInstOperands,
     /*  859005 */     // GIR_Coverage, 24562,
     /*  859005 */     GIR_EraseRootFromParent_Done,
     /*  859006 */   // Label 13191: @859006
     /*  859006 */   GIM_Try, /*On fail goto*//*Label 13192*/ GIMT_Encode4(859081), // Rule ID 24563 //
     /*  859011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  859022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  859025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  859028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  859031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859057 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  859060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859079 */     GIR_RootConstrainSelectedInstOperands,
     /*  859080 */     // GIR_Coverage, 24563,
     /*  859080 */     GIR_EraseRootFromParent_Done,
     /*  859081 */   // Label 13192: @859081
     /*  859081 */   GIM_Try, /*On fail goto*//*Label 13193*/ GIMT_Encode4(859156), // Rule ID 24566 //
     /*  859086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  859097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  859100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  859103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  859106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859132 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  859132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  859135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859154 */     GIR_RootConstrainSelectedInstOperands,
     /*  859155 */     // GIR_Coverage, 24566,
     /*  859155 */     GIR_EraseRootFromParent_Done,
     /*  859156 */   // Label 13193: @859156
     /*  859156 */   GIM_Try, /*On fail goto*//*Label 13194*/ GIMT_Encode4(859231), // Rule ID 24567 //
     /*  859161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  859172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  859175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  859178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  859181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859207 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  859210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859229 */     GIR_RootConstrainSelectedInstOperands,
     /*  859230 */     // GIR_Coverage, 24567,
     /*  859230 */     GIR_EraseRootFromParent_Done,
     /*  859231 */   // Label 13194: @859231
     /*  859231 */   GIM_Try, /*On fail goto*//*Label 13195*/ GIMT_Encode4(859306), // Rule ID 24570 //
     /*  859236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  859247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  859250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  859253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  859256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859282 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  859282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  859285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859304 */     GIR_RootConstrainSelectedInstOperands,
     /*  859305 */     // GIR_Coverage, 24570,
     /*  859305 */     GIR_EraseRootFromParent_Done,
     /*  859306 */   // Label 13195: @859306
     /*  859306 */   GIM_Try, /*On fail goto*//*Label 13196*/ GIMT_Encode4(859381), // Rule ID 24571 //
     /*  859311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  859322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  859325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  859328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  859331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859357 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  859360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859379 */     GIR_RootConstrainSelectedInstOperands,
     /*  859380 */     // GIR_Coverage, 24571,
     /*  859380 */     GIR_EraseRootFromParent_Done,
     /*  859381 */   // Label 13196: @859381
     /*  859381 */   GIM_Try, /*On fail goto*//*Label 13197*/ GIMT_Encode4(859456), // Rule ID 24574 //
     /*  859386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  859397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  859400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  859403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  859406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  859435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859454 */     GIR_RootConstrainSelectedInstOperands,
     /*  859455 */     // GIR_Coverage, 24574,
     /*  859455 */     GIR_EraseRootFromParent_Done,
     /*  859456 */   // Label 13197: @859456
     /*  859456 */   GIM_Try, /*On fail goto*//*Label 13198*/ GIMT_Encode4(859531), // Rule ID 24575 //
     /*  859461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  859472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  859475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  859478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  859481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859507 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  859510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859529 */     GIR_RootConstrainSelectedInstOperands,
     /*  859530 */     // GIR_Coverage, 24575,
     /*  859530 */     GIR_EraseRootFromParent_Done,
     /*  859531 */   // Label 13198: @859531
     /*  859531 */   GIM_Try, /*On fail goto*//*Label 13199*/ GIMT_Encode4(859606), // Rule ID 24578 //
     /*  859536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  859547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  859550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  859553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  859556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  859585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859604 */     GIR_RootConstrainSelectedInstOperands,
     /*  859605 */     // GIR_Coverage, 24578,
     /*  859605 */     GIR_EraseRootFromParent_Done,
     /*  859606 */   // Label 13199: @859606
     /*  859606 */   GIM_Try, /*On fail goto*//*Label 13200*/ GIMT_Encode4(859681), // Rule ID 24579 //
     /*  859611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  859622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  859625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  859628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  859631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859657 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  859660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859679 */     GIR_RootConstrainSelectedInstOperands,
     /*  859680 */     // GIR_Coverage, 24579,
     /*  859680 */     GIR_EraseRootFromParent_Done,
     /*  859681 */   // Label 13200: @859681
     /*  859681 */   GIM_Try, /*On fail goto*//*Label 13201*/ GIMT_Encode4(859756), // Rule ID 24582 //
     /*  859686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  859697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  859700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  859703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  859706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859732 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  859735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859754 */     GIR_RootConstrainSelectedInstOperands,
     /*  859755 */     // GIR_Coverage, 24582,
     /*  859755 */     GIR_EraseRootFromParent_Done,
     /*  859756 */   // Label 13201: @859756
     /*  859756 */   GIM_Try, /*On fail goto*//*Label 13202*/ GIMT_Encode4(859831), // Rule ID 24583 //
     /*  859761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  859772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  859775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  859778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  859781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859807 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  859810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859829 */     GIR_RootConstrainSelectedInstOperands,
     /*  859830 */     // GIR_Coverage, 24583,
     /*  859830 */     GIR_EraseRootFromParent_Done,
     /*  859831 */   // Label 13202: @859831
     /*  859831 */   GIM_Try, /*On fail goto*//*Label 13203*/ GIMT_Encode4(859906), // Rule ID 24586 //
     /*  859836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  859839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  859847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  859850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  859853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  859856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  859882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  859885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859904 */     GIR_RootConstrainSelectedInstOperands,
     /*  859905 */     // GIR_Coverage, 24586,
     /*  859905 */     GIR_EraseRootFromParent_Done,
     /*  859906 */   // Label 13203: @859906
     /*  859906 */   GIM_Try, /*On fail goto*//*Label 13204*/ GIMT_Encode4(859981), // Rule ID 24587 //
     /*  859911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  859914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  859922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  859925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  859928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  859931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859957 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  859957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  859960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859979 */     GIR_RootConstrainSelectedInstOperands,
     /*  859980 */     // GIR_Coverage, 24587,
     /*  859980 */     GIR_EraseRootFromParent_Done,
     /*  859981 */   // Label 13204: @859981
     /*  859981 */   GIM_Try, /*On fail goto*//*Label 13205*/ GIMT_Encode4(860056), // Rule ID 24590 //
     /*  859986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  859989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  859997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  860000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  860003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  860006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860032 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  860032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  860035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860054 */     GIR_RootConstrainSelectedInstOperands,
     /*  860055 */     // GIR_Coverage, 24590,
     /*  860055 */     GIR_EraseRootFromParent_Done,
     /*  860056 */   // Label 13205: @860056
     /*  860056 */   GIM_Try, /*On fail goto*//*Label 13206*/ GIMT_Encode4(860131), // Rule ID 24591 //
     /*  860061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  860064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  860072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  860075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  860078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  860081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860107 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  860107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  860110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860129 */     GIR_RootConstrainSelectedInstOperands,
     /*  860130 */     // GIR_Coverage, 24591,
     /*  860130 */     GIR_EraseRootFromParent_Done,
     /*  860131 */   // Label 13206: @860131
     /*  860131 */   GIM_Try, /*On fail goto*//*Label 13207*/ GIMT_Encode4(860206), // Rule ID 24594 //
     /*  860136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  860139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  860147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  860150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  860153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  860156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860182 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  860182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  860185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860204 */     GIR_RootConstrainSelectedInstOperands,
     /*  860205 */     // GIR_Coverage, 24594,
     /*  860205 */     GIR_EraseRootFromParent_Done,
     /*  860206 */   // Label 13207: @860206
     /*  860206 */   GIM_Try, /*On fail goto*//*Label 13208*/ GIMT_Encode4(860281), // Rule ID 24595 //
     /*  860211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  860214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  860222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  860225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  860228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  860231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860257 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  860257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  860260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860279 */     GIR_RootConstrainSelectedInstOperands,
     /*  860280 */     // GIR_Coverage, 24595,
     /*  860280 */     GIR_EraseRootFromParent_Done,
     /*  860281 */   // Label 13208: @860281
     /*  860281 */   GIM_Try, /*On fail goto*//*Label 13209*/ GIMT_Encode4(860356), // Rule ID 24598 //
     /*  860286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  860297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  860300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  860303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860332 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  860335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860354 */     GIR_RootConstrainSelectedInstOperands,
     /*  860355 */     // GIR_Coverage, 24598,
     /*  860355 */     GIR_EraseRootFromParent_Done,
     /*  860356 */   // Label 13209: @860356
     /*  860356 */   GIM_Try, /*On fail goto*//*Label 13210*/ GIMT_Encode4(860431), // Rule ID 24599 //
     /*  860361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  860372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  860375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  860378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860407 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  860410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860429 */     GIR_RootConstrainSelectedInstOperands,
     /*  860430 */     // GIR_Coverage, 24599,
     /*  860430 */     GIR_EraseRootFromParent_Done,
     /*  860431 */   // Label 13210: @860431
     /*  860431 */   GIM_Try, /*On fail goto*//*Label 13211*/ GIMT_Encode4(860506), // Rule ID 24602 //
     /*  860436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  860447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  860450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  860453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860482 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860504 */     GIR_RootConstrainSelectedInstOperands,
     /*  860505 */     // GIR_Coverage, 24602,
     /*  860505 */     GIR_EraseRootFromParent_Done,
     /*  860506 */   // Label 13211: @860506
     /*  860506 */   GIM_Try, /*On fail goto*//*Label 13212*/ GIMT_Encode4(860581), // Rule ID 24603 //
     /*  860511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  860522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  860525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  860528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860557 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860579 */     GIR_RootConstrainSelectedInstOperands,
     /*  860580 */     // GIR_Coverage, 24603,
     /*  860580 */     GIR_EraseRootFromParent_Done,
     /*  860581 */   // Label 13212: @860581
     /*  860581 */   GIM_Try, /*On fail goto*//*Label 13213*/ GIMT_Encode4(860656), // Rule ID 24606 //
     /*  860586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  860597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  860600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  860603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860632 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860654 */     GIR_RootConstrainSelectedInstOperands,
     /*  860655 */     // GIR_Coverage, 24606,
     /*  860655 */     GIR_EraseRootFromParent_Done,
     /*  860656 */   // Label 13213: @860656
     /*  860656 */   GIM_Try, /*On fail goto*//*Label 13214*/ GIMT_Encode4(860731), // Rule ID 24607 //
     /*  860661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  860672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  860675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  860678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860707 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860729 */     GIR_RootConstrainSelectedInstOperands,
     /*  860730 */     // GIR_Coverage, 24607,
     /*  860730 */     GIR_EraseRootFromParent_Done,
     /*  860731 */   // Label 13214: @860731
     /*  860731 */   GIM_Try, /*On fail goto*//*Label 13215*/ GIMT_Encode4(860806), // Rule ID 24610 //
     /*  860736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  860747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  860750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  860753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860782 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860804 */     GIR_RootConstrainSelectedInstOperands,
     /*  860805 */     // GIR_Coverage, 24610,
     /*  860805 */     GIR_EraseRootFromParent_Done,
     /*  860806 */   // Label 13215: @860806
     /*  860806 */   GIM_Try, /*On fail goto*//*Label 13216*/ GIMT_Encode4(860881), // Rule ID 24611 //
     /*  860811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  860822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  860825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  860828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860857 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860879 */     GIR_RootConstrainSelectedInstOperands,
     /*  860880 */     // GIR_Coverage, 24611,
     /*  860880 */     GIR_EraseRootFromParent_Done,
     /*  860881 */   // Label 13216: @860881
     /*  860881 */   GIM_Try, /*On fail goto*//*Label 13217*/ GIMT_Encode4(860956), // Rule ID 24614 //
     /*  860886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  860897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  860900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  860903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860932 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860954 */     GIR_RootConstrainSelectedInstOperands,
     /*  860955 */     // GIR_Coverage, 24614,
     /*  860955 */     GIR_EraseRootFromParent_Done,
     /*  860956 */   // Label 13217: @860956
     /*  860956 */   GIM_Try, /*On fail goto*//*Label 13218*/ GIMT_Encode4(861031), // Rule ID 24615 //
     /*  860961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  860972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  860975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  860978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861007 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  861007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  861010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861029 */     GIR_RootConstrainSelectedInstOperands,
     /*  861030 */     // GIR_Coverage, 24615,
     /*  861030 */     GIR_EraseRootFromParent_Done,
     /*  861031 */   // Label 13218: @861031
     /*  861031 */   GIM_Try, /*On fail goto*//*Label 13219*/ GIMT_Encode4(861106), // Rule ID 24618 //
     /*  861036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  861047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  861050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  861053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861082 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  861082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  861085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861104 */     GIR_RootConstrainSelectedInstOperands,
     /*  861105 */     // GIR_Coverage, 24618,
     /*  861105 */     GIR_EraseRootFromParent_Done,
     /*  861106 */   // Label 13219: @861106
     /*  861106 */   GIM_Try, /*On fail goto*//*Label 13220*/ GIMT_Encode4(861181), // Rule ID 24619 //
     /*  861111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  861122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  861125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  861128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861157 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  861157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  861160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861179 */     GIR_RootConstrainSelectedInstOperands,
     /*  861180 */     // GIR_Coverage, 24619,
     /*  861180 */     GIR_EraseRootFromParent_Done,
     /*  861181 */   // Label 13220: @861181
     /*  861181 */   GIM_Try, /*On fail goto*//*Label 13221*/ GIMT_Encode4(861256), // Rule ID 24622 //
     /*  861186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  861197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  861200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  861203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861254 */     GIR_RootConstrainSelectedInstOperands,
     /*  861255 */     // GIR_Coverage, 24622,
     /*  861255 */     GIR_EraseRootFromParent_Done,
     /*  861256 */   // Label 13221: @861256
     /*  861256 */   GIM_Try, /*On fail goto*//*Label 13222*/ GIMT_Encode4(861331), // Rule ID 24623 //
     /*  861261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  861272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  861275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  861278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861307 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861329 */     GIR_RootConstrainSelectedInstOperands,
     /*  861330 */     // GIR_Coverage, 24623,
     /*  861330 */     GIR_EraseRootFromParent_Done,
     /*  861331 */   // Label 13222: @861331
     /*  861331 */   GIM_Try, /*On fail goto*//*Label 13223*/ GIMT_Encode4(861406), // Rule ID 24626 //
     /*  861336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  861347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  861350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  861353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861404 */     GIR_RootConstrainSelectedInstOperands,
     /*  861405 */     // GIR_Coverage, 24626,
     /*  861405 */     GIR_EraseRootFromParent_Done,
     /*  861406 */   // Label 13223: @861406
     /*  861406 */   GIM_Try, /*On fail goto*//*Label 13224*/ GIMT_Encode4(861481), // Rule ID 24627 //
     /*  861411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  861422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  861425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  861428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861457 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  861457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861479 */     GIR_RootConstrainSelectedInstOperands,
     /*  861480 */     // GIR_Coverage, 24627,
     /*  861480 */     GIR_EraseRootFromParent_Done,
     /*  861481 */   // Label 13224: @861481
     /*  861481 */   GIM_Try, /*On fail goto*//*Label 13225*/ GIMT_Encode4(861556), // Rule ID 24630 //
     /*  861486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  861500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  861532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861554 */     GIR_RootConstrainSelectedInstOperands,
     /*  861555 */     // GIR_Coverage, 24630,
     /*  861555 */     GIR_EraseRootFromParent_Done,
     /*  861556 */   // Label 13225: @861556
     /*  861556 */   GIM_Try, /*On fail goto*//*Label 13226*/ GIMT_Encode4(861631), // Rule ID 24631 //
     /*  861561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  861575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861607 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  861607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861629 */     GIR_RootConstrainSelectedInstOperands,
     /*  861630 */     // GIR_Coverage, 24631,
     /*  861630 */     GIR_EraseRootFromParent_Done,
     /*  861631 */   // Label 13226: @861631
     /*  861631 */   GIM_Try, /*On fail goto*//*Label 13227*/ GIMT_Encode4(861706), // Rule ID 24634 //
     /*  861636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  861639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  861647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  861650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  861653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861682 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  861682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  861701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861704 */     GIR_RootConstrainSelectedInstOperands,
     /*  861705 */     // GIR_Coverage, 24634,
     /*  861705 */     GIR_EraseRootFromParent_Done,
     /*  861706 */   // Label 13227: @861706
     /*  861706 */   GIM_Try, /*On fail goto*//*Label 13228*/ GIMT_Encode4(861781), // Rule ID 24635 //
     /*  861711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  861714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  861722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  861725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  861728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861757 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  861757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  861776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861779 */     GIR_RootConstrainSelectedInstOperands,
     /*  861780 */     // GIR_Coverage, 24635,
     /*  861780 */     GIR_EraseRootFromParent_Done,
     /*  861781 */   // Label 13228: @861781
     /*  861781 */   GIM_Try, /*On fail goto*//*Label 13229*/ GIMT_Encode4(861856), // Rule ID 24638 //
     /*  861786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  861797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  861800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  861803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861832 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861854 */     GIR_RootConstrainSelectedInstOperands,
     /*  861855 */     // GIR_Coverage, 24638,
     /*  861855 */     GIR_EraseRootFromParent_Done,
     /*  861856 */   // Label 13229: @861856
     /*  861856 */   GIM_Try, /*On fail goto*//*Label 13230*/ GIMT_Encode4(861931), // Rule ID 24639 //
     /*  861861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  861872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  861875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  861878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861907 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861929 */     GIR_RootConstrainSelectedInstOperands,
     /*  861930 */     // GIR_Coverage, 24639,
     /*  861930 */     GIR_EraseRootFromParent_Done,
     /*  861931 */   // Label 13230: @861931
     /*  861931 */   GIM_Try, /*On fail goto*//*Label 13231*/ GIMT_Encode4(862006), // Rule ID 24642 //
     /*  861936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  861947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  861950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  861953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861982 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862004 */     GIR_RootConstrainSelectedInstOperands,
     /*  862005 */     // GIR_Coverage, 24642,
     /*  862005 */     GIR_EraseRootFromParent_Done,
     /*  862006 */   // Label 13231: @862006
     /*  862006 */   GIM_Try, /*On fail goto*//*Label 13232*/ GIMT_Encode4(862081), // Rule ID 24643 //
     /*  862011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  862022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  862025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  862028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862057 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  862057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862079 */     GIR_RootConstrainSelectedInstOperands,
     /*  862080 */     // GIR_Coverage, 24643,
     /*  862080 */     GIR_EraseRootFromParent_Done,
     /*  862081 */   // Label 13232: @862081
     /*  862081 */   GIM_Try, /*On fail goto*//*Label 13233*/ GIMT_Encode4(862156), // Rule ID 24646 //
     /*  862086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  862097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  862100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  862103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862132 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  862132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862154 */     GIR_RootConstrainSelectedInstOperands,
     /*  862155 */     // GIR_Coverage, 24646,
     /*  862155 */     GIR_EraseRootFromParent_Done,
     /*  862156 */   // Label 13233: @862156
     /*  862156 */   GIM_Try, /*On fail goto*//*Label 13234*/ GIMT_Encode4(862231), // Rule ID 24647 //
     /*  862161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  862172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  862175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  862178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862207 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  862207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862229 */     GIR_RootConstrainSelectedInstOperands,
     /*  862230 */     // GIR_Coverage, 24647,
     /*  862230 */     GIR_EraseRootFromParent_Done,
     /*  862231 */   // Label 13234: @862231
     /*  862231 */   GIM_Try, /*On fail goto*//*Label 13235*/ GIMT_Encode4(862306), // Rule ID 24650 //
     /*  862236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  862247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  862250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  862253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862282 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862304 */     GIR_RootConstrainSelectedInstOperands,
     /*  862305 */     // GIR_Coverage, 24650,
     /*  862305 */     GIR_EraseRootFromParent_Done,
     /*  862306 */   // Label 13235: @862306
     /*  862306 */   GIM_Try, /*On fail goto*//*Label 13236*/ GIMT_Encode4(862381), // Rule ID 24651 //
     /*  862311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  862322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  862325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  862328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862357 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862379 */     GIR_RootConstrainSelectedInstOperands,
     /*  862380 */     // GIR_Coverage, 24651,
     /*  862380 */     GIR_EraseRootFromParent_Done,
     /*  862381 */   // Label 13236: @862381
     /*  862381 */   GIM_Try, /*On fail goto*//*Label 13237*/ GIMT_Encode4(862456), // Rule ID 24654 //
     /*  862386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  862397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  862400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  862403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862432 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862454 */     GIR_RootConstrainSelectedInstOperands,
     /*  862455 */     // GIR_Coverage, 24654,
     /*  862455 */     GIR_EraseRootFromParent_Done,
     /*  862456 */   // Label 13237: @862456
     /*  862456 */   GIM_Try, /*On fail goto*//*Label 13238*/ GIMT_Encode4(862531), // Rule ID 24655 //
     /*  862461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  862472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  862475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  862478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862507 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862529 */     GIR_RootConstrainSelectedInstOperands,
     /*  862530 */     // GIR_Coverage, 24655,
     /*  862530 */     GIR_EraseRootFromParent_Done,
     /*  862531 */   // Label 13238: @862531
     /*  862531 */   GIM_Try, /*On fail goto*//*Label 13239*/ GIMT_Encode4(862606), // Rule ID 24658 //
     /*  862536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  862547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  862550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  862553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862582 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862604 */     GIR_RootConstrainSelectedInstOperands,
     /*  862605 */     // GIR_Coverage, 24658,
     /*  862605 */     GIR_EraseRootFromParent_Done,
     /*  862606 */   // Label 13239: @862606
     /*  862606 */   GIM_Try, /*On fail goto*//*Label 13240*/ GIMT_Encode4(862681), // Rule ID 24659 //
     /*  862611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  862622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  862625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  862628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862657 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862679 */     GIR_RootConstrainSelectedInstOperands,
     /*  862680 */     // GIR_Coverage, 24659,
     /*  862680 */     GIR_EraseRootFromParent_Done,
     /*  862681 */   // Label 13240: @862681
     /*  862681 */   GIM_Try, /*On fail goto*//*Label 13241*/ GIMT_Encode4(862756), // Rule ID 24662 //
     /*  862686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  862700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862754 */     GIR_RootConstrainSelectedInstOperands,
     /*  862755 */     // GIR_Coverage, 24662,
     /*  862755 */     GIR_EraseRootFromParent_Done,
     /*  862756 */   // Label 13241: @862756
     /*  862756 */   GIM_Try, /*On fail goto*//*Label 13242*/ GIMT_Encode4(862831), // Rule ID 24663 //
     /*  862761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  862775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862807 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862829 */     GIR_RootConstrainSelectedInstOperands,
     /*  862830 */     // GIR_Coverage, 24663,
     /*  862830 */     GIR_EraseRootFromParent_Done,
     /*  862831 */   // Label 13242: @862831
     /*  862831 */   GIM_Try, /*On fail goto*//*Label 13243*/ GIMT_Encode4(862906), // Rule ID 24666 //
     /*  862836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  862850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862882 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862904 */     GIR_RootConstrainSelectedInstOperands,
     /*  862905 */     // GIR_Coverage, 24666,
     /*  862905 */     GIR_EraseRootFromParent_Done,
     /*  862906 */   // Label 13243: @862906
     /*  862906 */   GIM_Try, /*On fail goto*//*Label 13244*/ GIMT_Encode4(862981), // Rule ID 24667 //
     /*  862911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  862925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862957 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862979 */     GIR_RootConstrainSelectedInstOperands,
     /*  862980 */     // GIR_Coverage, 24667,
     /*  862980 */     GIR_EraseRootFromParent_Done,
     /*  862981 */   // Label 13244: @862981
     /*  862981 */   GIM_Try, /*On fail goto*//*Label 13245*/ GIMT_Encode4(863056), // Rule ID 24670 //
     /*  862986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  862997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  863000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  863003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863032 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  863032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  863035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863054 */     GIR_RootConstrainSelectedInstOperands,
     /*  863055 */     // GIR_Coverage, 24670,
     /*  863055 */     GIR_EraseRootFromParent_Done,
     /*  863056 */   // Label 13245: @863056
     /*  863056 */   GIM_Try, /*On fail goto*//*Label 13246*/ GIMT_Encode4(863131), // Rule ID 24671 //
     /*  863061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  863072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  863075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  863078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863107 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  863107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  863110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863129 */     GIR_RootConstrainSelectedInstOperands,
     /*  863130 */     // GIR_Coverage, 24671,
     /*  863130 */     GIR_EraseRootFromParent_Done,
     /*  863131 */   // Label 13246: @863131
     /*  863131 */   GIM_Try, /*On fail goto*//*Label 13247*/ GIMT_Encode4(863206), // Rule ID 24674 //
     /*  863136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  863139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  863147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  863150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  863153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  863185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863204 */     GIR_RootConstrainSelectedInstOperands,
     /*  863205 */     // GIR_Coverage, 24674,
     /*  863205 */     GIR_EraseRootFromParent_Done,
     /*  863206 */   // Label 13247: @863206
     /*  863206 */   GIM_Try, /*On fail goto*//*Label 13248*/ GIMT_Encode4(863281), // Rule ID 24675 //
     /*  863211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  863222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  863225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  863228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863257 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  863260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863279 */     GIR_RootConstrainSelectedInstOperands,
     /*  863280 */     // GIR_Coverage, 24675,
     /*  863280 */     GIR_EraseRootFromParent_Done,
     /*  863281 */   // Label 13248: @863281
     /*  863281 */   GIM_Try, /*On fail goto*//*Label 13249*/ GIMT_Encode4(863356), // Rule ID 24678 //
     /*  863286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  863289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  863297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  863300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  863303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863332 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  863335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863354 */     GIR_RootConstrainSelectedInstOperands,
     /*  863355 */     // GIR_Coverage, 24678,
     /*  863355 */     GIR_EraseRootFromParent_Done,
     /*  863356 */   // Label 13249: @863356
     /*  863356 */   GIM_Try, /*On fail goto*//*Label 13250*/ GIMT_Encode4(863431), // Rule ID 24679 //
     /*  863361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  863372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  863375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  863378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863407 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  863410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863429 */     GIR_RootConstrainSelectedInstOperands,
     /*  863430 */     // GIR_Coverage, 24679,
     /*  863430 */     GIR_EraseRootFromParent_Done,
     /*  863431 */   // Label 13250: @863431
     /*  863431 */   GIM_Try, /*On fail goto*//*Label 13251*/ GIMT_Encode4(863506), // Rule ID 24682 //
     /*  863436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  863439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  863447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  863450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  863453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863482 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  863485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863504 */     GIR_RootConstrainSelectedInstOperands,
     /*  863505 */     // GIR_Coverage, 24682,
     /*  863505 */     GIR_EraseRootFromParent_Done,
     /*  863506 */   // Label 13251: @863506
     /*  863506 */   GIM_Try, /*On fail goto*//*Label 13252*/ GIMT_Encode4(863581), // Rule ID 24683 //
     /*  863511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  863522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  863525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  863528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863557 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  863560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863579 */     GIR_RootConstrainSelectedInstOperands,
     /*  863580 */     // GIR_Coverage, 24683,
     /*  863580 */     GIR_EraseRootFromParent_Done,
     /*  863581 */   // Label 13252: @863581
     /*  863581 */   GIM_Try, /*On fail goto*//*Label 13253*/ GIMT_Encode4(863656), // Rule ID 24774 //
     /*  863586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  863597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  863600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  863603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863632 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  863635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863654 */     GIR_RootConstrainSelectedInstOperands,
     /*  863655 */     // GIR_Coverage, 24774,
     /*  863655 */     GIR_EraseRootFromParent_Done,
     /*  863656 */   // Label 13253: @863656
     /*  863656 */   GIM_Try, /*On fail goto*//*Label 13254*/ GIMT_Encode4(863731), // Rule ID 24775 //
     /*  863661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  863672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  863675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  863678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863707 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  863710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863729 */     GIR_RootConstrainSelectedInstOperands,
     /*  863730 */     // GIR_Coverage, 24775,
     /*  863730 */     GIR_EraseRootFromParent_Done,
     /*  863731 */   // Label 13254: @863731
     /*  863731 */   GIM_Try, /*On fail goto*//*Label 13255*/ GIMT_Encode4(863806), // Rule ID 24778 //
     /*  863736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  863747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  863750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  863753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863782 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  863785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863804 */     GIR_RootConstrainSelectedInstOperands,
     /*  863805 */     // GIR_Coverage, 24778,
     /*  863805 */     GIR_EraseRootFromParent_Done,
     /*  863806 */   // Label 13255: @863806
     /*  863806 */   GIM_Try, /*On fail goto*//*Label 13256*/ GIMT_Encode4(863881), // Rule ID 24779 //
     /*  863811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  863822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  863825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  863828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863857 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  863860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863879 */     GIR_RootConstrainSelectedInstOperands,
     /*  863880 */     // GIR_Coverage, 24779,
     /*  863880 */     GIR_EraseRootFromParent_Done,
     /*  863881 */   // Label 13256: @863881
     /*  863881 */   GIM_Try, /*On fail goto*//*Label 13257*/ GIMT_Encode4(863956), // Rule ID 24782 //
     /*  863886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  863897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  863900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  863903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  863906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863932 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  863935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863954 */     GIR_RootConstrainSelectedInstOperands,
     /*  863955 */     // GIR_Coverage, 24782,
     /*  863955 */     GIR_EraseRootFromParent_Done,
     /*  863956 */   // Label 13257: @863956
     /*  863956 */   GIM_Try, /*On fail goto*//*Label 13258*/ GIMT_Encode4(864031), // Rule ID 24783 //
     /*  863961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  863972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  863975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  863978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  863981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864007 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  864010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864029 */     GIR_RootConstrainSelectedInstOperands,
     /*  864030 */     // GIR_Coverage, 24783,
     /*  864030 */     GIR_EraseRootFromParent_Done,
     /*  864031 */   // Label 13258: @864031
     /*  864031 */   GIM_Try, /*On fail goto*//*Label 13259*/ GIMT_Encode4(864106), // Rule ID 24786 //
     /*  864036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  864047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  864050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  864053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864082 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  864085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864104 */     GIR_RootConstrainSelectedInstOperands,
     /*  864105 */     // GIR_Coverage, 24786,
     /*  864105 */     GIR_EraseRootFromParent_Done,
     /*  864106 */   // Label 13259: @864106
     /*  864106 */   GIM_Try, /*On fail goto*//*Label 13260*/ GIMT_Encode4(864181), // Rule ID 24787 //
     /*  864111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  864122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  864125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  864128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864157 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  864160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864179 */     GIR_RootConstrainSelectedInstOperands,
     /*  864180 */     // GIR_Coverage, 24787,
     /*  864180 */     GIR_EraseRootFromParent_Done,
     /*  864181 */   // Label 13260: @864181
     /*  864181 */   GIM_Try, /*On fail goto*//*Label 13261*/ GIMT_Encode4(864256), // Rule ID 24790 //
     /*  864186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  864197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  864200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  864203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  864206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864232 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  864235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864254 */     GIR_RootConstrainSelectedInstOperands,
     /*  864255 */     // GIR_Coverage, 24790,
     /*  864255 */     GIR_EraseRootFromParent_Done,
     /*  864256 */   // Label 13261: @864256
     /*  864256 */   GIM_Try, /*On fail goto*//*Label 13262*/ GIMT_Encode4(864331), // Rule ID 24791 //
     /*  864261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  864272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  864275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  864278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  864281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864307 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  864310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864329 */     GIR_RootConstrainSelectedInstOperands,
     /*  864330 */     // GIR_Coverage, 24791,
     /*  864330 */     GIR_EraseRootFromParent_Done,
     /*  864331 */   // Label 13262: @864331
     /*  864331 */   GIM_Try, /*On fail goto*//*Label 13263*/ GIMT_Encode4(864406), // Rule ID 24794 //
     /*  864336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  864347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  864350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  864353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864382 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  864382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  864385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864404 */     GIR_RootConstrainSelectedInstOperands,
     /*  864405 */     // GIR_Coverage, 24794,
     /*  864405 */     GIR_EraseRootFromParent_Done,
     /*  864406 */   // Label 13263: @864406
     /*  864406 */   GIM_Try, /*On fail goto*//*Label 13264*/ GIMT_Encode4(864481), // Rule ID 24795 //
     /*  864411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  864422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  864425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  864428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864457 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  864457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  864460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864479 */     GIR_RootConstrainSelectedInstOperands,
     /*  864480 */     // GIR_Coverage, 24795,
     /*  864480 */     GIR_EraseRootFromParent_Done,
     /*  864481 */   // Label 13264: @864481
     /*  864481 */   GIM_Try, /*On fail goto*//*Label 13265*/ GIMT_Encode4(864556), // Rule ID 24798 //
     /*  864486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  864497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  864500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  864503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  864506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864532 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  864535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864554 */     GIR_RootConstrainSelectedInstOperands,
     /*  864555 */     // GIR_Coverage, 24798,
     /*  864555 */     GIR_EraseRootFromParent_Done,
     /*  864556 */   // Label 13265: @864556
     /*  864556 */   GIM_Try, /*On fail goto*//*Label 13266*/ GIMT_Encode4(864631), // Rule ID 24799 //
     /*  864561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  864572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  864575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  864578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  864581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864607 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  864610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864629 */     GIR_RootConstrainSelectedInstOperands,
     /*  864630 */     // GIR_Coverage, 24799,
     /*  864630 */     GIR_EraseRootFromParent_Done,
     /*  864631 */   // Label 13266: @864631
     /*  864631 */   GIM_Try, /*On fail goto*//*Label 13267*/ GIMT_Encode4(864706), // Rule ID 24802 //
     /*  864636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  864647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  864650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  864653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  864656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  864685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864704 */     GIR_RootConstrainSelectedInstOperands,
     /*  864705 */     // GIR_Coverage, 24802,
     /*  864705 */     GIR_EraseRootFromParent_Done,
     /*  864706 */   // Label 13267: @864706
     /*  864706 */   GIM_Try, /*On fail goto*//*Label 13268*/ GIMT_Encode4(864781), // Rule ID 24803 //
     /*  864711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  864722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  864725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  864728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  864731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864757 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  864760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864779 */     GIR_RootConstrainSelectedInstOperands,
     /*  864780 */     // GIR_Coverage, 24803,
     /*  864780 */     GIR_EraseRootFromParent_Done,
     /*  864781 */   // Label 13268: @864781
     /*  864781 */   GIM_Try, /*On fail goto*//*Label 13269*/ GIMT_Encode4(864856), // Rule ID 24806 //
     /*  864786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  864797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  864800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  864803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  864806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864832 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  864832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  864835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864854 */     GIR_RootConstrainSelectedInstOperands,
     /*  864855 */     // GIR_Coverage, 24806,
     /*  864855 */     GIR_EraseRootFromParent_Done,
     /*  864856 */   // Label 13269: @864856
     /*  864856 */   GIM_Try, /*On fail goto*//*Label 13270*/ GIMT_Encode4(864931), // Rule ID 24807 //
     /*  864861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  864872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  864875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  864878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  864881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864907 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  864907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  864910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864929 */     GIR_RootConstrainSelectedInstOperands,
     /*  864930 */     // GIR_Coverage, 24807,
     /*  864930 */     GIR_EraseRootFromParent_Done,
     /*  864931 */   // Label 13270: @864931
     /*  864931 */   GIM_Try, /*On fail goto*//*Label 13271*/ GIMT_Encode4(865006), // Rule ID 24810 //
     /*  864936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  864939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  864947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  864950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  864953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864982 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  864982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  864985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865004 */     GIR_RootConstrainSelectedInstOperands,
     /*  865005 */     // GIR_Coverage, 24810,
     /*  865005 */     GIR_EraseRootFromParent_Done,
     /*  865006 */   // Label 13271: @865006
     /*  865006 */   GIM_Try, /*On fail goto*//*Label 13272*/ GIMT_Encode4(865081), // Rule ID 24811 //
     /*  865011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  865014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  865022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  865025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  865028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  865031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865057 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  865057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  865060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865079 */     GIR_RootConstrainSelectedInstOperands,
     /*  865080 */     // GIR_Coverage, 24811,
     /*  865080 */     GIR_EraseRootFromParent_Done,
     /*  865081 */   // Label 13272: @865081
     /*  865081 */   GIM_Try, /*On fail goto*//*Label 13273*/ GIMT_Encode4(865156), // Rule ID 24814 //
     /*  865086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  865097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  865100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  865103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865132 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  865132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  865135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865154 */     GIR_RootConstrainSelectedInstOperands,
     /*  865155 */     // GIR_Coverage, 24814,
     /*  865155 */     GIR_EraseRootFromParent_Done,
     /*  865156 */   // Label 13273: @865156
     /*  865156 */   GIM_Try, /*On fail goto*//*Label 13274*/ GIMT_Encode4(865231), // Rule ID 24815 //
     /*  865161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  865172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  865175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  865178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865207 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  865207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  865210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865229 */     GIR_RootConstrainSelectedInstOperands,
     /*  865230 */     // GIR_Coverage, 24815,
     /*  865230 */     GIR_EraseRootFromParent_Done,
     /*  865231 */   // Label 13274: @865231
     /*  865231 */   GIM_Try, /*On fail goto*//*Label 13275*/ GIMT_Encode4(865306), // Rule ID 24818 //
     /*  865236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  865247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  865250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  865253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  865256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865282 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  865282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  865285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865304 */     GIR_RootConstrainSelectedInstOperands,
     /*  865305 */     // GIR_Coverage, 24818,
     /*  865305 */     GIR_EraseRootFromParent_Done,
     /*  865306 */   // Label 13275: @865306
     /*  865306 */   GIM_Try, /*On fail goto*//*Label 13276*/ GIMT_Encode4(865381), // Rule ID 24819 //
     /*  865311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  865322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  865325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  865328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  865331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865357 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  865357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  865360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865379 */     GIR_RootConstrainSelectedInstOperands,
     /*  865380 */     // GIR_Coverage, 24819,
     /*  865380 */     GIR_EraseRootFromParent_Done,
     /*  865381 */   // Label 13276: @865381
     /*  865381 */   GIM_Try, /*On fail goto*//*Label 13277*/ GIMT_Encode4(865456), // Rule ID 24822 //
     /*  865386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  865397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  865400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  865403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865432 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  865435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865454 */     GIR_RootConstrainSelectedInstOperands,
     /*  865455 */     // GIR_Coverage, 24822,
     /*  865455 */     GIR_EraseRootFromParent_Done,
     /*  865456 */   // Label 13277: @865456
     /*  865456 */   GIM_Try, /*On fail goto*//*Label 13278*/ GIMT_Encode4(865531), // Rule ID 24823 //
     /*  865461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  865472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  865475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  865478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865507 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  865510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865529 */     GIR_RootConstrainSelectedInstOperands,
     /*  865530 */     // GIR_Coverage, 24823,
     /*  865530 */     GIR_EraseRootFromParent_Done,
     /*  865531 */   // Label 13278: @865531
     /*  865531 */   GIM_Try, /*On fail goto*//*Label 13279*/ GIMT_Encode4(865606), // Rule ID 24826 //
     /*  865536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  865547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  865550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  865553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865582 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  865585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865604 */     GIR_RootConstrainSelectedInstOperands,
     /*  865605 */     // GIR_Coverage, 24826,
     /*  865605 */     GIR_EraseRootFromParent_Done,
     /*  865606 */   // Label 13279: @865606
     /*  865606 */   GIM_Try, /*On fail goto*//*Label 13280*/ GIMT_Encode4(865681), // Rule ID 24827 //
     /*  865611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  865622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  865625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  865628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865657 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  865660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865679 */     GIR_RootConstrainSelectedInstOperands,
     /*  865680 */     // GIR_Coverage, 24827,
     /*  865680 */     GIR_EraseRootFromParent_Done,
     /*  865681 */   // Label 13280: @865681
     /*  865681 */   GIM_Try, /*On fail goto*//*Label 13281*/ GIMT_Encode4(865756), // Rule ID 24830 //
     /*  865686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  865697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  865700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  865703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  865706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865732 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  865735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865754 */     GIR_RootConstrainSelectedInstOperands,
     /*  865755 */     // GIR_Coverage, 24830,
     /*  865755 */     GIR_EraseRootFromParent_Done,
     /*  865756 */   // Label 13281: @865756
     /*  865756 */   GIM_Try, /*On fail goto*//*Label 13282*/ GIMT_Encode4(865831), // Rule ID 24831 //
     /*  865761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  865772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  865775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  865778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  865781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865807 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  865810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865829 */     GIR_RootConstrainSelectedInstOperands,
     /*  865830 */     // GIR_Coverage, 24831,
     /*  865830 */     GIR_EraseRootFromParent_Done,
     /*  865831 */   // Label 13282: @865831
     /*  865831 */   GIM_Try, /*On fail goto*//*Label 13283*/ GIMT_Encode4(865906), // Rule ID 24834 //
     /*  865836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  865847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  865850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  865853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  865856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865882 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  865882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  865885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865904 */     GIR_RootConstrainSelectedInstOperands,
     /*  865905 */     // GIR_Coverage, 24834,
     /*  865905 */     GIR_EraseRootFromParent_Done,
     /*  865906 */   // Label 13283: @865906
     /*  865906 */   GIM_Try, /*On fail goto*//*Label 13284*/ GIMT_Encode4(865981), // Rule ID 24835 //
     /*  865911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  865922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  865925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  865928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  865931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865957 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  865957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  865960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865979 */     GIR_RootConstrainSelectedInstOperands,
     /*  865980 */     // GIR_Coverage, 24835,
     /*  865980 */     GIR_EraseRootFromParent_Done,
     /*  865981 */   // Label 13284: @865981
     /*  865981 */   GIM_Try, /*On fail goto*//*Label 13285*/ GIMT_Encode4(866056), // Rule ID 24838 //
     /*  865986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  865997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  866000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  866003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  866006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866032 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  866035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866054 */     GIR_RootConstrainSelectedInstOperands,
     /*  866055 */     // GIR_Coverage, 24838,
     /*  866055 */     GIR_EraseRootFromParent_Done,
     /*  866056 */   // Label 13285: @866056
     /*  866056 */   GIM_Try, /*On fail goto*//*Label 13286*/ GIMT_Encode4(866131), // Rule ID 24839 //
     /*  866061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  866072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  866075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  866078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  866081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866107 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  866110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866129 */     GIR_RootConstrainSelectedInstOperands,
     /*  866130 */     // GIR_Coverage, 24839,
     /*  866130 */     GIR_EraseRootFromParent_Done,
     /*  866131 */   // Label 13286: @866131
     /*  866131 */   GIM_Try, /*On fail goto*//*Label 13287*/ GIMT_Encode4(866206), // Rule ID 24842 //
     /*  866136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  866147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  866150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  866153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  866156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866182 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  866185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866204 */     GIR_RootConstrainSelectedInstOperands,
     /*  866205 */     // GIR_Coverage, 24842,
     /*  866205 */     GIR_EraseRootFromParent_Done,
     /*  866206 */   // Label 13287: @866206
     /*  866206 */   GIM_Try, /*On fail goto*//*Label 13288*/ GIMT_Encode4(866281), // Rule ID 24843 //
     /*  866211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  866222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  866225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  866228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  866231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866257 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  866260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866279 */     GIR_RootConstrainSelectedInstOperands,
     /*  866280 */     // GIR_Coverage, 24843,
     /*  866280 */     GIR_EraseRootFromParent_Done,
     /*  866281 */   // Label 13288: @866281
     /*  866281 */   GIM_Try, /*On fail goto*//*Label 13289*/ GIMT_Encode4(866356), // Rule ID 24846 //
     /*  866286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  866289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  866297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  866300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  866303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  866306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  866335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866354 */     GIR_RootConstrainSelectedInstOperands,
     /*  866355 */     // GIR_Coverage, 24846,
     /*  866355 */     GIR_EraseRootFromParent_Done,
     /*  866356 */   // Label 13289: @866356
     /*  866356 */   GIM_Try, /*On fail goto*//*Label 13290*/ GIMT_Encode4(866431), // Rule ID 24847 //
     /*  866361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  866364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  866372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  866375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  866378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  866381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866407 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  866410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866429 */     GIR_RootConstrainSelectedInstOperands,
     /*  866430 */     // GIR_Coverage, 24847,
     /*  866430 */     GIR_EraseRootFromParent_Done,
     /*  866431 */   // Label 13290: @866431
     /*  866431 */   GIM_Try, /*On fail goto*//*Label 13291*/ GIMT_Encode4(866506), // Rule ID 24850 //
     /*  866436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  866439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  866447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  866450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  866453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  866456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866482 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  866485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866504 */     GIR_RootConstrainSelectedInstOperands,
     /*  866505 */     // GIR_Coverage, 24850,
     /*  866505 */     GIR_EraseRootFromParent_Done,
     /*  866506 */   // Label 13291: @866506
     /*  866506 */   GIM_Try, /*On fail goto*//*Label 13292*/ GIMT_Encode4(866581), // Rule ID 24851 //
     /*  866511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  866514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  866522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  866525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  866528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  866531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866557 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  866560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866579 */     GIR_RootConstrainSelectedInstOperands,
     /*  866580 */     // GIR_Coverage, 24851,
     /*  866580 */     GIR_EraseRootFromParent_Done,
     /*  866581 */   // Label 13292: @866581
     /*  866581 */   GIM_Try, /*On fail goto*//*Label 13293*/ GIMT_Encode4(866656), // Rule ID 24854 //
     /*  866586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  866589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  866606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866632 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  866635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866654 */     GIR_RootConstrainSelectedInstOperands,
     /*  866655 */     // GIR_Coverage, 24854,
     /*  866655 */     GIR_EraseRootFromParent_Done,
     /*  866656 */   // Label 13293: @866656
     /*  866656 */   GIM_Try, /*On fail goto*//*Label 13294*/ GIMT_Encode4(866731), // Rule ID 24855 //
     /*  866661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  866664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  866681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866707 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  866710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866729 */     GIR_RootConstrainSelectedInstOperands,
     /*  866730 */     // GIR_Coverage, 24855,
     /*  866730 */     GIR_EraseRootFromParent_Done,
     /*  866731 */   // Label 13294: @866731
     /*  866731 */   GIM_Try, /*On fail goto*//*Label 13295*/ GIMT_Encode4(866806), // Rule ID 24858 //
     /*  866736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  866747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  866750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  866753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  866756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866782 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  866782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  866785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866804 */     GIR_RootConstrainSelectedInstOperands,
     /*  866805 */     // GIR_Coverage, 24858,
     /*  866805 */     GIR_EraseRootFromParent_Done,
     /*  866806 */   // Label 13295: @866806
     /*  866806 */   GIM_Try, /*On fail goto*//*Label 13296*/ GIMT_Encode4(866881), // Rule ID 24859 //
     /*  866811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  866822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  866825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  866828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  866831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866857 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  866857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  866860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866879 */     GIR_RootConstrainSelectedInstOperands,
     /*  866880 */     // GIR_Coverage, 24859,
     /*  866880 */     GIR_EraseRootFromParent_Done,
     /*  866881 */   // Label 13296: @866881
     /*  866881 */   GIM_Try, /*On fail goto*//*Label 13297*/ GIMT_Encode4(866956), // Rule ID 24862 //
     /*  866886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  866897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  866900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  866903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  866906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866932 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  866932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  866935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866954 */     GIR_RootConstrainSelectedInstOperands,
     /*  866955 */     // GIR_Coverage, 24862,
     /*  866955 */     GIR_EraseRootFromParent_Done,
     /*  866956 */   // Label 13297: @866956
     /*  866956 */   GIM_Try, /*On fail goto*//*Label 13298*/ GIMT_Encode4(867031), // Rule ID 24863 //
     /*  866961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  866972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  866975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  866978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  866981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867007 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  867010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867029 */     GIR_RootConstrainSelectedInstOperands,
     /*  867030 */     // GIR_Coverage, 24863,
     /*  867030 */     GIR_EraseRootFromParent_Done,
     /*  867031 */   // Label 13298: @867031
     /*  867031 */   GIM_Try, /*On fail goto*//*Label 13299*/ GIMT_Encode4(867106), // Rule ID 24866 //
     /*  867036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  867047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  867050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  867053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  867056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867082 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  867085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867104 */     GIR_RootConstrainSelectedInstOperands,
     /*  867105 */     // GIR_Coverage, 24866,
     /*  867105 */     GIR_EraseRootFromParent_Done,
     /*  867106 */   // Label 13299: @867106
     /*  867106 */   GIM_Try, /*On fail goto*//*Label 13300*/ GIMT_Encode4(867181), // Rule ID 24867 //
     /*  867111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  867122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  867125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  867128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  867131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867157 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  867160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867179 */     GIR_RootConstrainSelectedInstOperands,
     /*  867180 */     // GIR_Coverage, 24867,
     /*  867180 */     GIR_EraseRootFromParent_Done,
     /*  867181 */   // Label 13300: @867181
     /*  867181 */   GIM_Try, /*On fail goto*//*Label 13301*/ GIMT_Encode4(867256), // Rule ID 24870 //
     /*  867186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  867197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  867200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  867203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  867206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867232 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  867235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867254 */     GIR_RootConstrainSelectedInstOperands,
     /*  867255 */     // GIR_Coverage, 24870,
     /*  867255 */     GIR_EraseRootFromParent_Done,
     /*  867256 */   // Label 13301: @867256
     /*  867256 */   GIM_Try, /*On fail goto*//*Label 13302*/ GIMT_Encode4(867331), // Rule ID 24871 //
     /*  867261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  867272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  867275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  867278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  867281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867307 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  867310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867329 */     GIR_RootConstrainSelectedInstOperands,
     /*  867330 */     // GIR_Coverage, 24871,
     /*  867330 */     GIR_EraseRootFromParent_Done,
     /*  867331 */   // Label 13302: @867331
     /*  867331 */   GIM_Try, /*On fail goto*//*Label 13303*/ GIMT_Encode4(867406), // Rule ID 24874 //
     /*  867336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  867347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  867350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  867353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  867356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867382 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  867385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867404 */     GIR_RootConstrainSelectedInstOperands,
     /*  867405 */     // GIR_Coverage, 24874,
     /*  867405 */     GIR_EraseRootFromParent_Done,
     /*  867406 */   // Label 13303: @867406
     /*  867406 */   GIM_Try, /*On fail goto*//*Label 13304*/ GIMT_Encode4(867481), // Rule ID 24875 //
     /*  867411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  867422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  867425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  867428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  867431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867457 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  867460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867479 */     GIR_RootConstrainSelectedInstOperands,
     /*  867480 */     // GIR_Coverage, 24875,
     /*  867480 */     GIR_EraseRootFromParent_Done,
     /*  867481 */   // Label 13304: @867481
     /*  867481 */   GIM_Try, /*On fail goto*//*Label 13305*/ GIMT_Encode4(867556), // Rule ID 24878 //
     /*  867486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  867489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  867497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  867500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  867503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  867506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867532 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  867532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  867535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867554 */     GIR_RootConstrainSelectedInstOperands,
     /*  867555 */     // GIR_Coverage, 24878,
     /*  867555 */     GIR_EraseRootFromParent_Done,
     /*  867556 */   // Label 13305: @867556
     /*  867556 */   GIM_Try, /*On fail goto*//*Label 13306*/ GIMT_Encode4(867631), // Rule ID 24879 //
     /*  867561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  867564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  867572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  867575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  867578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  867581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867607 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  867607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  867610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867629 */     GIR_RootConstrainSelectedInstOperands,
     /*  867630 */     // GIR_Coverage, 24879,
     /*  867630 */     GIR_EraseRootFromParent_Done,
     /*  867631 */   // Label 13306: @867631
     /*  867631 */   GIM_Try, /*On fail goto*//*Label 13307*/ GIMT_Encode4(867706), // Rule ID 24882 //
     /*  867636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  867647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  867650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  867653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  867656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867682 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  867685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867704 */     GIR_RootConstrainSelectedInstOperands,
     /*  867705 */     // GIR_Coverage, 24882,
     /*  867705 */     GIR_EraseRootFromParent_Done,
     /*  867706 */   // Label 13307: @867706
     /*  867706 */   GIM_Try, /*On fail goto*//*Label 13308*/ GIMT_Encode4(867781), // Rule ID 24883 //
     /*  867711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  867722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  867725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  867728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  867731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867757 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  867760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867779 */     GIR_RootConstrainSelectedInstOperands,
     /*  867780 */     // GIR_Coverage, 24883,
     /*  867780 */     GIR_EraseRootFromParent_Done,
     /*  867781 */   // Label 13308: @867781
     /*  867781 */   GIM_Try, /*On fail goto*//*Label 13309*/ GIMT_Encode4(867856), // Rule ID 24886 //
     /*  867786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  867797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  867800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  867803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  867806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867832 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  867835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867854 */     GIR_RootConstrainSelectedInstOperands,
     /*  867855 */     // GIR_Coverage, 24886,
     /*  867855 */     GIR_EraseRootFromParent_Done,
     /*  867856 */   // Label 13309: @867856
     /*  867856 */   GIM_Try, /*On fail goto*//*Label 13310*/ GIMT_Encode4(867931), // Rule ID 24887 //
     /*  867861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  867872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  867875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  867878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  867881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867907 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  867910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867929 */     GIR_RootConstrainSelectedInstOperands,
     /*  867930 */     // GIR_Coverage, 24887,
     /*  867930 */     GIR_EraseRootFromParent_Done,
     /*  867931 */   // Label 13310: @867931
     /*  867931 */   GIM_Try, /*On fail goto*//*Label 13311*/ GIMT_Encode4(868006), // Rule ID 24890 //
     /*  867936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  867947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  867950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  867953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  867956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867982 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  867985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868004 */     GIR_RootConstrainSelectedInstOperands,
     /*  868005 */     // GIR_Coverage, 24890,
     /*  868005 */     GIR_EraseRootFromParent_Done,
     /*  868006 */   // Label 13311: @868006
     /*  868006 */   GIM_Try, /*On fail goto*//*Label 13312*/ GIMT_Encode4(868081), // Rule ID 24891 //
     /*  868011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  868022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  868025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  868028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  868031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868057 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  868060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868079 */     GIR_RootConstrainSelectedInstOperands,
     /*  868080 */     // GIR_Coverage, 24891,
     /*  868080 */     GIR_EraseRootFromParent_Done,
     /*  868081 */   // Label 13312: @868081
     /*  868081 */   GIM_Try, /*On fail goto*//*Label 13313*/ GIMT_Encode4(868156), // Rule ID 24894 //
     /*  868086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  868097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  868100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  868103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  868106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868132 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  868132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  868135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868154 */     GIR_RootConstrainSelectedInstOperands,
     /*  868155 */     // GIR_Coverage, 24894,
     /*  868155 */     GIR_EraseRootFromParent_Done,
     /*  868156 */   // Label 13313: @868156
     /*  868156 */   GIM_Try, /*On fail goto*//*Label 13314*/ GIMT_Encode4(868231), // Rule ID 24895 //
     /*  868161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  868172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  868175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  868178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  868181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868207 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  868207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  868210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868229 */     GIR_RootConstrainSelectedInstOperands,
     /*  868230 */     // GIR_Coverage, 24895,
     /*  868230 */     GIR_EraseRootFromParent_Done,
     /*  868231 */   // Label 13314: @868231
     /*  868231 */   GIM_Try, /*On fail goto*//*Label 13315*/ GIMT_Encode4(868306), // Rule ID 24898 //
     /*  868236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  868247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  868250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  868253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  868256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868282 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  868282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  868285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868304 */     GIR_RootConstrainSelectedInstOperands,
     /*  868305 */     // GIR_Coverage, 24898,
     /*  868305 */     GIR_EraseRootFromParent_Done,
     /*  868306 */   // Label 13315: @868306
     /*  868306 */   GIM_Try, /*On fail goto*//*Label 13316*/ GIMT_Encode4(868381), // Rule ID 24899 //
     /*  868311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  868322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  868325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  868328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  868331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868357 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  868357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  868360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868379 */     GIR_RootConstrainSelectedInstOperands,
     /*  868380 */     // GIR_Coverage, 24899,
     /*  868380 */     GIR_EraseRootFromParent_Done,
     /*  868381 */   // Label 13316: @868381
     /*  868381 */   GIM_Try, /*On fail goto*//*Label 13317*/ GIMT_Encode4(868456), // Rule ID 24902 //
     /*  868386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  868397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  868400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  868403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  868406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868432 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  868432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  868435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868454 */     GIR_RootConstrainSelectedInstOperands,
     /*  868455 */     // GIR_Coverage, 24902,
     /*  868455 */     GIR_EraseRootFromParent_Done,
     /*  868456 */   // Label 13317: @868456
     /*  868456 */   GIM_Try, /*On fail goto*//*Label 13318*/ GIMT_Encode4(868531), // Rule ID 24903 //
     /*  868461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  868472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  868475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  868478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  868481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868507 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  868507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  868510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868529 */     GIR_RootConstrainSelectedInstOperands,
     /*  868530 */     // GIR_Coverage, 24903,
     /*  868530 */     GIR_EraseRootFromParent_Done,
     /*  868531 */   // Label 13318: @868531
     /*  868531 */   GIM_Try, /*On fail goto*//*Label 13319*/ GIMT_Encode4(868606), // Rule ID 24906 //
     /*  868536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  868539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  868547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  868550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  868553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  868556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868582 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  868585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868604 */     GIR_RootConstrainSelectedInstOperands,
     /*  868605 */     // GIR_Coverage, 24906,
     /*  868605 */     GIR_EraseRootFromParent_Done,
     /*  868606 */   // Label 13319: @868606
     /*  868606 */   GIM_Try, /*On fail goto*//*Label 13320*/ GIMT_Encode4(868681), // Rule ID 24907 //
     /*  868611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  868614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  868622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  868625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  868628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  868631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868657 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  868660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868679 */     GIR_RootConstrainSelectedInstOperands,
     /*  868680 */     // GIR_Coverage, 24907,
     /*  868680 */     GIR_EraseRootFromParent_Done,
     /*  868681 */   // Label 13320: @868681
     /*  868681 */   GIM_Try, /*On fail goto*//*Label 13321*/ GIMT_Encode4(868756), // Rule ID 24910 //
     /*  868686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  868689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  868697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  868700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  868703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  868706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868732 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  868735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868754 */     GIR_RootConstrainSelectedInstOperands,
     /*  868755 */     // GIR_Coverage, 24910,
     /*  868755 */     GIR_EraseRootFromParent_Done,
     /*  868756 */   // Label 13321: @868756
     /*  868756 */   GIM_Try, /*On fail goto*//*Label 13322*/ GIMT_Encode4(868831), // Rule ID 24911 //
     /*  868761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  868764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  868772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  868775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  868778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  868781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868807 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  868810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868829 */     GIR_RootConstrainSelectedInstOperands,
     /*  868830 */     // GIR_Coverage, 24911,
     /*  868830 */     GIR_EraseRootFromParent_Done,
     /*  868831 */   // Label 13322: @868831
     /*  868831 */   GIM_Try, /*On fail goto*//*Label 13323*/ GIMT_Encode4(868906), // Rule ID 24914 //
     /*  868836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  868839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  868847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  868850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  868853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  868856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868882 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  868885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868904 */     GIR_RootConstrainSelectedInstOperands,
     /*  868905 */     // GIR_Coverage, 24914,
     /*  868905 */     GIR_EraseRootFromParent_Done,
     /*  868906 */   // Label 13323: @868906
     /*  868906 */   GIM_Try, /*On fail goto*//*Label 13324*/ GIMT_Encode4(868981), // Rule ID 24915 //
     /*  868911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  868914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  868922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  868925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  868928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  868931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868957 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  868960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868979 */     GIR_RootConstrainSelectedInstOperands,
     /*  868980 */     // GIR_Coverage, 24915,
     /*  868980 */     GIR_EraseRootFromParent_Done,
     /*  868981 */   // Label 13324: @868981
     /*  868981 */   GIM_Try, /*On fail goto*//*Label 13325*/ GIMT_Encode4(869056), // Rule ID 24918 //
     /*  868986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  868997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  869000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  869003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869032 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  869035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869054 */     GIR_RootConstrainSelectedInstOperands,
     /*  869055 */     // GIR_Coverage, 24918,
     /*  869055 */     GIR_EraseRootFromParent_Done,
     /*  869056 */   // Label 13325: @869056
     /*  869056 */   GIM_Try, /*On fail goto*//*Label 13326*/ GIMT_Encode4(869131), // Rule ID 24919 //
     /*  869061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  869072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  869075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  869078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869107 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  869110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869129 */     GIR_RootConstrainSelectedInstOperands,
     /*  869130 */     // GIR_Coverage, 24919,
     /*  869130 */     GIR_EraseRootFromParent_Done,
     /*  869131 */   // Label 13326: @869131
     /*  869131 */   GIM_Try, /*On fail goto*//*Label 13327*/ GIMT_Encode4(869206), // Rule ID 24922 //
     /*  869136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  869147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  869150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  869153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869182 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  869185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869204 */     GIR_RootConstrainSelectedInstOperands,
     /*  869205 */     // GIR_Coverage, 24922,
     /*  869205 */     GIR_EraseRootFromParent_Done,
     /*  869206 */   // Label 13327: @869206
     /*  869206 */   GIM_Try, /*On fail goto*//*Label 13328*/ GIMT_Encode4(869281), // Rule ID 24923 //
     /*  869211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  869222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  869225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  869228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869257 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  869260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869279 */     GIR_RootConstrainSelectedInstOperands,
     /*  869280 */     // GIR_Coverage, 24923,
     /*  869280 */     GIR_EraseRootFromParent_Done,
     /*  869281 */   // Label 13328: @869281
     /*  869281 */   GIM_Try, /*On fail goto*//*Label 13329*/ GIMT_Encode4(869356), // Rule ID 24926 //
     /*  869286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  869297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  869300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  869303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869332 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  869335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869354 */     GIR_RootConstrainSelectedInstOperands,
     /*  869355 */     // GIR_Coverage, 24926,
     /*  869355 */     GIR_EraseRootFromParent_Done,
     /*  869356 */   // Label 13329: @869356
     /*  869356 */   GIM_Try, /*On fail goto*//*Label 13330*/ GIMT_Encode4(869431), // Rule ID 24927 //
     /*  869361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  869372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  869375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  869378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869407 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  869410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869429 */     GIR_RootConstrainSelectedInstOperands,
     /*  869430 */     // GIR_Coverage, 24927,
     /*  869430 */     GIR_EraseRootFromParent_Done,
     /*  869431 */   // Label 13330: @869431
     /*  869431 */   GIM_Try, /*On fail goto*//*Label 13331*/ GIMT_Encode4(869506), // Rule ID 24930 //
     /*  869436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  869447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  869450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  869453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869482 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869504 */     GIR_RootConstrainSelectedInstOperands,
     /*  869505 */     // GIR_Coverage, 24930,
     /*  869505 */     GIR_EraseRootFromParent_Done,
     /*  869506 */   // Label 13331: @869506
     /*  869506 */   GIM_Try, /*On fail goto*//*Label 13332*/ GIMT_Encode4(869581), // Rule ID 24931 //
     /*  869511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  869522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  869525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  869528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869557 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869579 */     GIR_RootConstrainSelectedInstOperands,
     /*  869580 */     // GIR_Coverage, 24931,
     /*  869580 */     GIR_EraseRootFromParent_Done,
     /*  869581 */   // Label 13332: @869581
     /*  869581 */   GIM_Try, /*On fail goto*//*Label 13333*/ GIMT_Encode4(869656), // Rule ID 24934 //
     /*  869586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  869597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  869600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  869603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869632 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869654 */     GIR_RootConstrainSelectedInstOperands,
     /*  869655 */     // GIR_Coverage, 24934,
     /*  869655 */     GIR_EraseRootFromParent_Done,
     /*  869656 */   // Label 13333: @869656
     /*  869656 */   GIM_Try, /*On fail goto*//*Label 13334*/ GIMT_Encode4(869731), // Rule ID 24935 //
     /*  869661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  869672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  869675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  869678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869707 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869729 */     GIR_RootConstrainSelectedInstOperands,
     /*  869730 */     // GIR_Coverage, 24935,
     /*  869730 */     GIR_EraseRootFromParent_Done,
     /*  869731 */   // Label 13334: @869731
     /*  869731 */   GIM_Try, /*On fail goto*//*Label 13335*/ GIMT_Encode4(869806), // Rule ID 24938 //
     /*  869736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  869739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  869747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  869750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  869753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869782 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  869782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869804 */     GIR_RootConstrainSelectedInstOperands,
     /*  869805 */     // GIR_Coverage, 24938,
     /*  869805 */     GIR_EraseRootFromParent_Done,
     /*  869806 */   // Label 13335: @869806
     /*  869806 */   GIM_Try, /*On fail goto*//*Label 13336*/ GIMT_Encode4(869881), // Rule ID 24939 //
     /*  869811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  869814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  869822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  869825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  869828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869857 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  869857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869879 */     GIR_RootConstrainSelectedInstOperands,
     /*  869880 */     // GIR_Coverage, 24939,
     /*  869880 */     GIR_EraseRootFromParent_Done,
     /*  869881 */   // Label 13336: @869881
     /*  869881 */   GIM_Try, /*On fail goto*//*Label 13337*/ GIMT_Encode4(869956), // Rule ID 24942 //
     /*  869886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  869897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  869900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  869903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869932 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  869935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869954 */     GIR_RootConstrainSelectedInstOperands,
     /*  869955 */     // GIR_Coverage, 24942,
     /*  869955 */     GIR_EraseRootFromParent_Done,
     /*  869956 */   // Label 13337: @869956
     /*  869956 */   GIM_Try, /*On fail goto*//*Label 13338*/ GIMT_Encode4(870031), // Rule ID 24943 //
     /*  869961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  869972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  869975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  869978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870007 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  870007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870029 */     GIR_RootConstrainSelectedInstOperands,
     /*  870030 */     // GIR_Coverage, 24943,
     /*  870030 */     GIR_EraseRootFromParent_Done,
     /*  870031 */   // Label 13338: @870031
     /*  870031 */   GIM_Try, /*On fail goto*//*Label 13339*/ GIMT_Encode4(870106), // Rule ID 24946 //
     /*  870036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  870047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  870050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  870053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870082 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870104 */     GIR_RootConstrainSelectedInstOperands,
     /*  870105 */     // GIR_Coverage, 24946,
     /*  870105 */     GIR_EraseRootFromParent_Done,
     /*  870106 */   // Label 13339: @870106
     /*  870106 */   GIM_Try, /*On fail goto*//*Label 13340*/ GIMT_Encode4(870181), // Rule ID 24947 //
     /*  870111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  870122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  870125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  870128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870157 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  870157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870179 */     GIR_RootConstrainSelectedInstOperands,
     /*  870180 */     // GIR_Coverage, 24947,
     /*  870180 */     GIR_EraseRootFromParent_Done,
     /*  870181 */   // Label 13340: @870181
     /*  870181 */   GIM_Try, /*On fail goto*//*Label 13341*/ GIMT_Encode4(870256), // Rule ID 24950 //
     /*  870186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  870197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  870200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  870203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870232 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870254 */     GIR_RootConstrainSelectedInstOperands,
     /*  870255 */     // GIR_Coverage, 24950,
     /*  870255 */     GIR_EraseRootFromParent_Done,
     /*  870256 */   // Label 13341: @870256
     /*  870256 */   GIM_Try, /*On fail goto*//*Label 13342*/ GIMT_Encode4(870331), // Rule ID 24951 //
     /*  870261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  870272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  870275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  870278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870307 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  870307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870329 */     GIR_RootConstrainSelectedInstOperands,
     /*  870330 */     // GIR_Coverage, 24951,
     /*  870330 */     GIR_EraseRootFromParent_Done,
     /*  870331 */   // Label 13342: @870331
     /*  870331 */   GIM_Try, /*On fail goto*//*Label 13343*/ GIMT_Encode4(870406), // Rule ID 24954 //
     /*  870336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  870347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  870350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  870353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870382 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870404 */     GIR_RootConstrainSelectedInstOperands,
     /*  870405 */     // GIR_Coverage, 24954,
     /*  870405 */     GIR_EraseRootFromParent_Done,
     /*  870406 */   // Label 13343: @870406
     /*  870406 */   GIM_Try, /*On fail goto*//*Label 13344*/ GIMT_Encode4(870481), // Rule ID 24955 //
     /*  870411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  870422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  870425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  870428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870457 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870479 */     GIR_RootConstrainSelectedInstOperands,
     /*  870480 */     // GIR_Coverage, 24955,
     /*  870480 */     GIR_EraseRootFromParent_Done,
     /*  870481 */   // Label 13344: @870481
     /*  870481 */   GIM_Try, /*On fail goto*//*Label 13345*/ GIMT_Encode4(870556), // Rule ID 24958 //
     /*  870486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  870497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  870500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  870503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870532 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870554 */     GIR_RootConstrainSelectedInstOperands,
     /*  870555 */     // GIR_Coverage, 24958,
     /*  870555 */     GIR_EraseRootFromParent_Done,
     /*  870556 */   // Label 13345: @870556
     /*  870556 */   GIM_Try, /*On fail goto*//*Label 13346*/ GIMT_Encode4(870631), // Rule ID 24959 //
     /*  870561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  870572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  870575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  870578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870607 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870629 */     GIR_RootConstrainSelectedInstOperands,
     /*  870630 */     // GIR_Coverage, 24959,
     /*  870630 */     GIR_EraseRootFromParent_Done,
     /*  870631 */   // Label 13346: @870631
     /*  870631 */   GIM_Try, /*On fail goto*//*Label 13347*/ GIMT_Encode4(870706), // Rule ID 24962 //
     /*  870636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  870647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  870650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  870653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870682 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870704 */     GIR_RootConstrainSelectedInstOperands,
     /*  870705 */     // GIR_Coverage, 24962,
     /*  870705 */     GIR_EraseRootFromParent_Done,
     /*  870706 */   // Label 13347: @870706
     /*  870706 */   GIM_Try, /*On fail goto*//*Label 13348*/ GIMT_Encode4(870781), // Rule ID 24963 //
     /*  870711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  870722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  870725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  870728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870757 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870779 */     GIR_RootConstrainSelectedInstOperands,
     /*  870780 */     // GIR_Coverage, 24963,
     /*  870780 */     GIR_EraseRootFromParent_Done,
     /*  870781 */   // Label 13348: @870781
     /*  870781 */   GIM_Try, /*On fail goto*//*Label 13349*/ GIMT_Encode4(870856), // Rule ID 24966 //
     /*  870786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  870789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  870797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  870800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  870803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870832 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870854 */     GIR_RootConstrainSelectedInstOperands,
     /*  870855 */     // GIR_Coverage, 24966,
     /*  870855 */     GIR_EraseRootFromParent_Done,
     /*  870856 */   // Label 13349: @870856
     /*  870856 */   GIM_Try, /*On fail goto*//*Label 13350*/ GIMT_Encode4(870931), // Rule ID 24967 //
     /*  870861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  870864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  870872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  870875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  870878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870907 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  870907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870929 */     GIR_RootConstrainSelectedInstOperands,
     /*  870930 */     // GIR_Coverage, 24967,
     /*  870930 */     GIR_EraseRootFromParent_Done,
     /*  870931 */   // Label 13350: @870931
     /*  870931 */   GIM_Try, /*On fail goto*//*Label 13351*/ GIMT_Encode4(871006), // Rule ID 24970 //
     /*  870936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  870939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  870947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  870950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  870953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870982 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871004 */     GIR_RootConstrainSelectedInstOperands,
     /*  871005 */     // GIR_Coverage, 24970,
     /*  871005 */     GIR_EraseRootFromParent_Done,
     /*  871006 */   // Label 13351: @871006
     /*  871006 */   GIM_Try, /*On fail goto*//*Label 13352*/ GIMT_Encode4(871081), // Rule ID 24971 //
     /*  871011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  871014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  871022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  871025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  871028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871057 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  871060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871079 */     GIR_RootConstrainSelectedInstOperands,
     /*  871080 */     // GIR_Coverage, 24971,
     /*  871080 */     GIR_EraseRootFromParent_Done,
     /*  871081 */   // Label 13352: @871081
     /*  871081 */   GIM_Try, /*On fail goto*//*Label 13353*/ GIMT_Encode4(871156), // Rule ID 24974 //
     /*  871086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  871089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  871097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  871100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  871103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871132 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  871135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871154 */     GIR_RootConstrainSelectedInstOperands,
     /*  871155 */     // GIR_Coverage, 24974,
     /*  871155 */     GIR_EraseRootFromParent_Done,
     /*  871156 */   // Label 13353: @871156
     /*  871156 */   GIM_Try, /*On fail goto*//*Label 13354*/ GIMT_Encode4(871231), // Rule ID 24975 //
     /*  871161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  871164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  871172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  871175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  871178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871207 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  871210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871229 */     GIR_RootConstrainSelectedInstOperands,
     /*  871230 */     // GIR_Coverage, 24975,
     /*  871230 */     GIR_EraseRootFromParent_Done,
     /*  871231 */   // Label 13354: @871231
     /*  871231 */   GIM_Try, /*On fail goto*//*Label 13355*/ GIMT_Encode4(871306), // Rule ID 25038 //
     /*  871236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  871247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  871250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  871253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871282 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  871285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871304 */     GIR_RootConstrainSelectedInstOperands,
     /*  871305 */     // GIR_Coverage, 25038,
     /*  871305 */     GIR_EraseRootFromParent_Done,
     /*  871306 */   // Label 13355: @871306
     /*  871306 */   GIM_Try, /*On fail goto*//*Label 13356*/ GIMT_Encode4(871381), // Rule ID 25039 //
     /*  871311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  871322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  871325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  871328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871357 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  871360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871379 */     GIR_RootConstrainSelectedInstOperands,
     /*  871380 */     // GIR_Coverage, 25039,
     /*  871380 */     GIR_EraseRootFromParent_Done,
     /*  871381 */   // Label 13356: @871381
     /*  871381 */   GIM_Try, /*On fail goto*//*Label 13357*/ GIMT_Encode4(871456), // Rule ID 25042 //
     /*  871386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  871397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  871400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  871403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871432 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  871435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871454 */     GIR_RootConstrainSelectedInstOperands,
     /*  871455 */     // GIR_Coverage, 25042,
     /*  871455 */     GIR_EraseRootFromParent_Done,
     /*  871456 */   // Label 13357: @871456
     /*  871456 */   GIM_Try, /*On fail goto*//*Label 13358*/ GIMT_Encode4(871531), // Rule ID 25043 //
     /*  871461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  871472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  871475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  871478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871507 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  871510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871529 */     GIR_RootConstrainSelectedInstOperands,
     /*  871530 */     // GIR_Coverage, 25043,
     /*  871530 */     GIR_EraseRootFromParent_Done,
     /*  871531 */   // Label 13358: @871531
     /*  871531 */   GIM_Try, /*On fail goto*//*Label 13359*/ GIMT_Encode4(871606), // Rule ID 25046 //
     /*  871536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  871547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  871550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  871553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871582 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  871585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871604 */     GIR_RootConstrainSelectedInstOperands,
     /*  871605 */     // GIR_Coverage, 25046,
     /*  871605 */     GIR_EraseRootFromParent_Done,
     /*  871606 */   // Label 13359: @871606
     /*  871606 */   GIM_Try, /*On fail goto*//*Label 13360*/ GIMT_Encode4(871681), // Rule ID 25047 //
     /*  871611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  871622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  871625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  871628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871657 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  871660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871679 */     GIR_RootConstrainSelectedInstOperands,
     /*  871680 */     // GIR_Coverage, 25047,
     /*  871680 */     GIR_EraseRootFromParent_Done,
     /*  871681 */   // Label 13360: @871681
     /*  871681 */   GIM_Try, /*On fail goto*//*Label 13361*/ GIMT_Encode4(871756), // Rule ID 25050 //
     /*  871686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  871697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  871700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  871703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  871706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871732 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  871735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871754 */     GIR_RootConstrainSelectedInstOperands,
     /*  871755 */     // GIR_Coverage, 25050,
     /*  871755 */     GIR_EraseRootFromParent_Done,
     /*  871756 */   // Label 13361: @871756
     /*  871756 */   GIM_Try, /*On fail goto*//*Label 13362*/ GIMT_Encode4(871831), // Rule ID 25051 //
     /*  871761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  871772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  871775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  871778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  871781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871807 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  871810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871829 */     GIR_RootConstrainSelectedInstOperands,
     /*  871830 */     // GIR_Coverage, 25051,
     /*  871830 */     GIR_EraseRootFromParent_Done,
     /*  871831 */   // Label 13362: @871831
     /*  871831 */   GIM_Try, /*On fail goto*//*Label 13363*/ GIMT_Encode4(871906), // Rule ID 25054 //
     /*  871836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  871847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  871850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  871853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871882 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  871885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871904 */     GIR_RootConstrainSelectedInstOperands,
     /*  871905 */     // GIR_Coverage, 25054,
     /*  871905 */     GIR_EraseRootFromParent_Done,
     /*  871906 */   // Label 13363: @871906
     /*  871906 */   GIM_Try, /*On fail goto*//*Label 13364*/ GIMT_Encode4(871981), // Rule ID 25055 //
     /*  871911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  871922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  871925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  871928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871957 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  871960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871979 */     GIR_RootConstrainSelectedInstOperands,
     /*  871980 */     // GIR_Coverage, 25055,
     /*  871980 */     GIR_EraseRootFromParent_Done,
     /*  871981 */   // Label 13364: @871981
     /*  871981 */   GIM_Try, /*On fail goto*//*Label 13365*/ GIMT_Encode4(872056), // Rule ID 25058 //
     /*  871986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  871989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  871997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  872000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  872003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  872006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872032 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  872035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872054 */     GIR_RootConstrainSelectedInstOperands,
     /*  872055 */     // GIR_Coverage, 25058,
     /*  872055 */     GIR_EraseRootFromParent_Done,
     /*  872056 */   // Label 13365: @872056
     /*  872056 */   GIM_Try, /*On fail goto*//*Label 13366*/ GIMT_Encode4(872131), // Rule ID 25059 //
     /*  872061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  872064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  872072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  872075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  872078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  872081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872107 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  872110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872129 */     GIR_RootConstrainSelectedInstOperands,
     /*  872130 */     // GIR_Coverage, 25059,
     /*  872130 */     GIR_EraseRootFromParent_Done,
     /*  872131 */   // Label 13366: @872131
     /*  872131 */   GIM_Try, /*On fail goto*//*Label 13367*/ GIMT_Encode4(872206), // Rule ID 25062 //
     /*  872136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  872147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  872150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  872153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872182 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  872182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  872185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872204 */     GIR_RootConstrainSelectedInstOperands,
     /*  872205 */     // GIR_Coverage, 25062,
     /*  872205 */     GIR_EraseRootFromParent_Done,
     /*  872206 */   // Label 13367: @872206
     /*  872206 */   GIM_Try, /*On fail goto*//*Label 13368*/ GIMT_Encode4(872281), // Rule ID 25063 //
     /*  872211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  872222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  872225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  872228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872257 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  872257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  872260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872279 */     GIR_RootConstrainSelectedInstOperands,
     /*  872280 */     // GIR_Coverage, 25063,
     /*  872280 */     GIR_EraseRootFromParent_Done,
     /*  872281 */   // Label 13368: @872281
     /*  872281 */   GIM_Try, /*On fail goto*//*Label 13369*/ GIMT_Encode4(872356), // Rule ID 25066 //
     /*  872286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  872297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  872300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  872303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  872306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872332 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  872332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  872335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872354 */     GIR_RootConstrainSelectedInstOperands,
     /*  872355 */     // GIR_Coverage, 25066,
     /*  872355 */     GIR_EraseRootFromParent_Done,
     /*  872356 */   // Label 13369: @872356
     /*  872356 */   GIM_Try, /*On fail goto*//*Label 13370*/ GIMT_Encode4(872431), // Rule ID 25067 //
     /*  872361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  872372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  872375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  872378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  872381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872407 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  872407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  872410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872429 */     GIR_RootConstrainSelectedInstOperands,
     /*  872430 */     // GIR_Coverage, 25067,
     /*  872430 */     GIR_EraseRootFromParent_Done,
     /*  872431 */   // Label 13370: @872431
     /*  872431 */   GIM_Try, /*On fail goto*//*Label 13371*/ GIMT_Encode4(872506), // Rule ID 25070 //
     /*  872436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  872447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  872450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  872453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  872456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872482 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  872482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  872485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872504 */     GIR_RootConstrainSelectedInstOperands,
     /*  872505 */     // GIR_Coverage, 25070,
     /*  872505 */     GIR_EraseRootFromParent_Done,
     /*  872506 */   // Label 13371: @872506
     /*  872506 */   GIM_Try, /*On fail goto*//*Label 13372*/ GIMT_Encode4(872581), // Rule ID 25071 //
     /*  872511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  872522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  872525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  872528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  872531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872557 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  872557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  872560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872579 */     GIR_RootConstrainSelectedInstOperands,
     /*  872580 */     // GIR_Coverage, 25071,
     /*  872580 */     GIR_EraseRootFromParent_Done,
     /*  872581 */   // Label 13372: @872581
     /*  872581 */   GIM_Try, /*On fail goto*//*Label 13373*/ GIMT_Encode4(872656), // Rule ID 25074 //
     /*  872586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  872597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  872600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  872603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872632 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  872635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872654 */     GIR_RootConstrainSelectedInstOperands,
     /*  872655 */     // GIR_Coverage, 25074,
     /*  872655 */     GIR_EraseRootFromParent_Done,
     /*  872656 */   // Label 13373: @872656
     /*  872656 */   GIM_Try, /*On fail goto*//*Label 13374*/ GIMT_Encode4(872731), // Rule ID 25075 //
     /*  872661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  872672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  872675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  872678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872707 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  872710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872729 */     GIR_RootConstrainSelectedInstOperands,
     /*  872730 */     // GIR_Coverage, 25075,
     /*  872730 */     GIR_EraseRootFromParent_Done,
     /*  872731 */   // Label 13374: @872731
     /*  872731 */   GIM_Try, /*On fail goto*//*Label 13375*/ GIMT_Encode4(872806), // Rule ID 25078 //
     /*  872736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  872747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  872750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872782 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  872785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872804 */     GIR_RootConstrainSelectedInstOperands,
     /*  872805 */     // GIR_Coverage, 25078,
     /*  872805 */     GIR_EraseRootFromParent_Done,
     /*  872806 */   // Label 13375: @872806
     /*  872806 */   GIM_Try, /*On fail goto*//*Label 13376*/ GIMT_Encode4(872881), // Rule ID 25079 //
     /*  872811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  872822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  872825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872857 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  872860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872879 */     GIR_RootConstrainSelectedInstOperands,
     /*  872880 */     // GIR_Coverage, 25079,
     /*  872880 */     GIR_EraseRootFromParent_Done,
     /*  872881 */   // Label 13376: @872881
     /*  872881 */   GIM_Try, /*On fail goto*//*Label 13377*/ GIMT_Encode4(872956), // Rule ID 25082 //
     /*  872886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  872897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  872900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  872906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872932 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  872935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872954 */     GIR_RootConstrainSelectedInstOperands,
     /*  872955 */     // GIR_Coverage, 25082,
     /*  872955 */     GIR_EraseRootFromParent_Done,
     /*  872956 */   // Label 13377: @872956
     /*  872956 */   GIM_Try, /*On fail goto*//*Label 13378*/ GIMT_Encode4(873031), // Rule ID 25083 //
     /*  872961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  872972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  872975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  872981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873007 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  873007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  873010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  873026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873029 */     GIR_RootConstrainSelectedInstOperands,
     /*  873030 */     // GIR_Coverage, 25083,
     /*  873030 */     GIR_EraseRootFromParent_Done,
     /*  873031 */   // Label 13378: @873031
     /*  873031 */   GIM_Try, /*On fail goto*//*Label 13379*/ GIMT_Encode4(873106), // Rule ID 25086 //
     /*  873036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  873039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  873044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  873047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  873050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  873053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  873056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873082 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  873082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  873085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873104 */     GIR_RootConstrainSelectedInstOperands,
     /*  873105 */     // GIR_Coverage, 25086,
     /*  873105 */     GIR_EraseRootFromParent_Done,
     /*  873106 */   // Label 13379: @873106
     /*  873106 */   GIM_Try, /*On fail goto*//*Label 13380*/ GIMT_Encode4(873181), // Rule ID 25087 //
     /*  873111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  873114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  873119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  873122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  873125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  873128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  873131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873157 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  873157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  873160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873179 */     GIR_RootConstrainSelectedInstOperands,
     /*  873180 */     // GIR_Coverage, 25087,
     /*  873180 */     GIR_EraseRootFromParent_Done,
     /*  873181 */   // Label 13380: @873181
     /*  873181 */   GIM_Try, /*On fail goto*//*Label 13381*/ GIMT_Encode4(873256), // Rule ID 25090 //
     /*  873186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  873189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  873194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  873197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  873200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  873203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  873206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873232 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  873232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  873235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873254 */     GIR_RootConstrainSelectedInstOperands,
     /*  873255 */     // GIR_Coverage, 25090,
     /*  873255 */     GIR_EraseRootFromParent_Done,
     /*  873256 */   // Label 13381: @873256
     /*  873256 */   GIM_Try, /*On fail goto*//*Label 13382*/ GIMT_Encode4(873331), // Rule ID 25091 //
     /*  873261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  873264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  873269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  873272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  873275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  873278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  873281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873307 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  873307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  873310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873329 */     GIR_RootConstrainSelectedInstOperands,
     /*  873330 */     // GIR_Coverage, 25091,
     /*  873330 */     GIR_EraseRootFromParent_Done,
     /*  873331 */   // Label 13382: @873331
     /*  873331 */   GIM_Try, /*On fail goto*//*Label 13383*/ GIMT_Encode4(873406), // Rule ID 25094 //
     /*  873336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  873339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  873344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  873347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  873350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  873353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  873356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873382 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  873382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  873385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873404 */     GIR_RootConstrainSelectedInstOperands,
     /*  873405 */     // GIR_Coverage, 25094,
     /*  873405 */     GIR_EraseRootFromParent_Done,
     /*  873406 */   // Label 13383: @873406
     /*  873406 */   GIM_Try, /*On fail goto*//*Label 13384*/ GIMT_Encode4(873481), // Rule ID 25095 //
     /*  873411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  873414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  873419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  873422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  873425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  873428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  873431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873457 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  873457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  873460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873479 */     GIR_RootConstrainSelectedInstOperands,
     /*  873480 */     // GIR_Coverage, 25095,
     /*  873480 */     GIR_EraseRootFromParent_Done,
     /*  873481 */   // Label 13384: @873481
     /*  873481 */   GIM_Try, /*On fail goto*//*Label 13385*/ GIMT_Encode4(873553), // Rule ID 25098 //
     /*  873486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  873497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  873500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  873503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873532 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  873535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873551 */     GIR_RootConstrainSelectedInstOperands,
     /*  873552 */     // GIR_Coverage, 25098,
     /*  873552 */     GIR_EraseRootFromParent_Done,
     /*  873553 */   // Label 13385: @873553
     /*  873553 */   GIM_Try, /*On fail goto*//*Label 13386*/ GIMT_Encode4(873625), // Rule ID 25099 //
     /*  873558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  873569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  873572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  873575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873604 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  873604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  873607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873623 */     GIR_RootConstrainSelectedInstOperands,
     /*  873624 */     // GIR_Coverage, 25099,
     /*  873624 */     GIR_EraseRootFromParent_Done,
     /*  873625 */   // Label 13386: @873625
     /*  873625 */   GIM_Try, /*On fail goto*//*Label 13387*/ GIMT_Encode4(873697), // Rule ID 25100 //
     /*  873630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  873641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  873644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  873647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873676 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  873679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873695 */     GIR_RootConstrainSelectedInstOperands,
     /*  873696 */     // GIR_Coverage, 25100,
     /*  873696 */     GIR_EraseRootFromParent_Done,
     /*  873697 */   // Label 13387: @873697
     /*  873697 */   GIM_Try, /*On fail goto*//*Label 13388*/ GIMT_Encode4(873769), // Rule ID 25101 //
     /*  873702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  873713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  873716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  873719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873748 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  873748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  873751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873767 */     GIR_RootConstrainSelectedInstOperands,
     /*  873768 */     // GIR_Coverage, 25101,
     /*  873768 */     GIR_EraseRootFromParent_Done,
     /*  873769 */   // Label 13388: @873769
     /*  873769 */   GIM_Try, /*On fail goto*//*Label 13389*/ GIMT_Encode4(873841), // Rule ID 25102 //
     /*  873774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  873785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  873788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  873791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873820 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  873820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  873823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873839 */     GIR_RootConstrainSelectedInstOperands,
     /*  873840 */     // GIR_Coverage, 25102,
     /*  873840 */     GIR_EraseRootFromParent_Done,
     /*  873841 */   // Label 13389: @873841
     /*  873841 */   GIM_Try, /*On fail goto*//*Label 13390*/ GIMT_Encode4(873913), // Rule ID 25103 //
     /*  873846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  873857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  873860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  873863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873892 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  873892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  873895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873911 */     GIR_RootConstrainSelectedInstOperands,
     /*  873912 */     // GIR_Coverage, 25103,
     /*  873912 */     GIR_EraseRootFromParent_Done,
     /*  873913 */   // Label 13390: @873913
     /*  873913 */   GIM_Try, /*On fail goto*//*Label 13391*/ GIMT_Encode4(873985), // Rule ID 25104 //
     /*  873918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  873964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  873967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873983 */     GIR_RootConstrainSelectedInstOperands,
     /*  873984 */     // GIR_Coverage, 25104,
     /*  873984 */     GIR_EraseRootFromParent_Done,
     /*  873985 */   // Label 13391: @873985
     /*  873985 */   GIM_Try, /*On fail goto*//*Label 13392*/ GIMT_Encode4(874057), // Rule ID 25105 //
     /*  873990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  874001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  874004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  874007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  874010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874036 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  874036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  874039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874055 */     GIR_RootConstrainSelectedInstOperands,
     /*  874056 */     // GIR_Coverage, 25105,
     /*  874056 */     GIR_EraseRootFromParent_Done,
     /*  874057 */   // Label 13392: @874057
     /*  874057 */   GIM_Try, /*On fail goto*//*Label 13393*/ GIMT_Encode4(874129), // Rule ID 25106 //
     /*  874062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  874073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  874076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  874079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  874082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  874108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  874111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874127 */     GIR_RootConstrainSelectedInstOperands,
     /*  874128 */     // GIR_Coverage, 25106,
     /*  874128 */     GIR_EraseRootFromParent_Done,
     /*  874129 */   // Label 13393: @874129
     /*  874129 */   GIM_Try, /*On fail goto*//*Label 13394*/ GIMT_Encode4(874201), // Rule ID 25107 //
     /*  874134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  874145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  874148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  874151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  874154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874180 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  874180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  874183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874199 */     GIR_RootConstrainSelectedInstOperands,
     /*  874200 */     // GIR_Coverage, 25107,
     /*  874200 */     GIR_EraseRootFromParent_Done,
     /*  874201 */   // Label 13394: @874201
     /*  874201 */   GIM_Try, /*On fail goto*//*Label 13395*/ GIMT_Encode4(874273), // Rule ID 25108 //
     /*  874206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  874217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  874220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  874223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  874226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  874255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874271 */     GIR_RootConstrainSelectedInstOperands,
     /*  874272 */     // GIR_Coverage, 25108,
     /*  874272 */     GIR_EraseRootFromParent_Done,
     /*  874273 */   // Label 13395: @874273
     /*  874273 */   GIM_Try, /*On fail goto*//*Label 13396*/ GIMT_Encode4(874345), // Rule ID 25109 //
     /*  874278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  874289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  874292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  874295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  874298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874324 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  874324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  874327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874343 */     GIR_RootConstrainSelectedInstOperands,
     /*  874344 */     // GIR_Coverage, 25109,
     /*  874344 */     GIR_EraseRootFromParent_Done,
     /*  874345 */   // Label 13396: @874345
     /*  874345 */   GIM_Try, /*On fail goto*//*Label 13397*/ GIMT_Encode4(874417), // Rule ID 25110 //
     /*  874350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  874361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  874364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  874367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  874370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874396 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  874396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  874399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874415 */     GIR_RootConstrainSelectedInstOperands,
     /*  874416 */     // GIR_Coverage, 25110,
     /*  874416 */     GIR_EraseRootFromParent_Done,
     /*  874417 */   // Label 13397: @874417
     /*  874417 */   GIM_Try, /*On fail goto*//*Label 13398*/ GIMT_Encode4(874489), // Rule ID 25111 //
     /*  874422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  874433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  874436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  874439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  874442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874468 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  874468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  874471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874487 */     GIR_RootConstrainSelectedInstOperands,
     /*  874488 */     // GIR_Coverage, 25111,
     /*  874488 */     GIR_EraseRootFromParent_Done,
     /*  874489 */   // Label 13398: @874489
     /*  874489 */   GIM_Try, /*On fail goto*//*Label 13399*/ GIMT_Encode4(874561), // Rule ID 25112 //
     /*  874494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  874505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  874508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  874511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  874514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  874540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  874543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874559 */     GIR_RootConstrainSelectedInstOperands,
     /*  874560 */     // GIR_Coverage, 25112,
     /*  874560 */     GIR_EraseRootFromParent_Done,
     /*  874561 */   // Label 13399: @874561
     /*  874561 */   GIM_Try, /*On fail goto*//*Label 13400*/ GIMT_Encode4(874633), // Rule ID 25113 //
     /*  874566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  874577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  874580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  874583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  874586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874612 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  874612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  874615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874631 */     GIR_RootConstrainSelectedInstOperands,
     /*  874632 */     // GIR_Coverage, 25113,
     /*  874632 */     GIR_EraseRootFromParent_Done,
     /*  874633 */   // Label 13400: @874633
     /*  874633 */   GIM_Try, /*On fail goto*//*Label 13401*/ GIMT_Encode4(874705), // Rule ID 25114 //
     /*  874638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  874641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  874649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  874652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  874655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  874658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874684 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  874684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  874687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  874703 */     GIR_RootConstrainSelectedInstOperands,
     /*  874704 */     // GIR_Coverage, 25114,
     /*  874704 */     GIR_EraseRootFromParent_Done,
     /*  874705 */   // Label 13401: @874705
     /*  874705 */   GIM_Try, /*On fail goto*//*Label 13402*/ GIMT_Encode4(874777), // Rule ID 25115 //
     /*  874710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  874713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  874721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  874724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  874727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  874730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874756 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  874756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  874759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  874775 */     GIR_RootConstrainSelectedInstOperands,
     /*  874776 */     // GIR_Coverage, 25115,
     /*  874776 */     GIR_EraseRootFromParent_Done,
     /*  874777 */   // Label 13402: @874777
     /*  874777 */   GIM_Try, /*On fail goto*//*Label 13403*/ GIMT_Encode4(874849), // Rule ID 25116 //
     /*  874782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  874793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  874796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  874799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874828 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  874831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874847 */     GIR_RootConstrainSelectedInstOperands,
     /*  874848 */     // GIR_Coverage, 25116,
     /*  874848 */     GIR_EraseRootFromParent_Done,
     /*  874849 */   // Label 13403: @874849
     /*  874849 */   GIM_Try, /*On fail goto*//*Label 13404*/ GIMT_Encode4(874921), // Rule ID 25117 //
     /*  874854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  874865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  874868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  874871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874900 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  874900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  874903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874919 */     GIR_RootConstrainSelectedInstOperands,
     /*  874920 */     // GIR_Coverage, 25117,
     /*  874920 */     GIR_EraseRootFromParent_Done,
     /*  874921 */   // Label 13404: @874921
     /*  874921 */   GIM_Try, /*On fail goto*//*Label 13405*/ GIMT_Encode4(874993), // Rule ID 25118 //
     /*  874926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  874937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  874940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  874943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  874946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874972 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  874975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874991 */     GIR_RootConstrainSelectedInstOperands,
     /*  874992 */     // GIR_Coverage, 25118,
     /*  874992 */     GIR_EraseRootFromParent_Done,
     /*  874993 */   // Label 13405: @874993
     /*  874993 */   GIM_Try, /*On fail goto*//*Label 13406*/ GIMT_Encode4(875065), // Rule ID 25119 //
     /*  874998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  875009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  875012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  875015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  875018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875044 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  875044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  875047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  875063 */     GIR_RootConstrainSelectedInstOperands,
     /*  875064 */     // GIR_Coverage, 25119,
     /*  875064 */     GIR_EraseRootFromParent_Done,
     /*  875065 */   // Label 13406: @875065
     /*  875065 */   GIM_Try, /*On fail goto*//*Label 13407*/ GIMT_Encode4(875137), // Rule ID 25120 //
     /*  875070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  875081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  875084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  875087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  875090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875116 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  875116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  875119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  875135 */     GIR_RootConstrainSelectedInstOperands,
     /*  875136 */     // GIR_Coverage, 25120,
     /*  875136 */     GIR_EraseRootFromParent_Done,
     /*  875137 */   // Label 13407: @875137
     /*  875137 */   GIM_Try, /*On fail goto*//*Label 13408*/ GIMT_Encode4(875209), // Rule ID 25121 //
     /*  875142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  875153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  875156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  875159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  875162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875188 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  875188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  875191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  875207 */     GIR_RootConstrainSelectedInstOperands,
     /*  875208 */     // GIR_Coverage, 25121,
     /*  875208 */     GIR_EraseRootFromParent_Done,
     /*  875209 */   // Label 13408: @875209
     /*  875209 */   GIM_Try, /*On fail goto*//*Label 13409*/ GIMT_Encode4(875281), // Rule ID 25122 //
     /*  875214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  875225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  875228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  875231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875260 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  875260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  875263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875279 */     GIR_RootConstrainSelectedInstOperands,
     /*  875280 */     // GIR_Coverage, 25122,
     /*  875280 */     GIR_EraseRootFromParent_Done,
     /*  875281 */   // Label 13409: @875281
     /*  875281 */   GIM_Try, /*On fail goto*//*Label 13410*/ GIMT_Encode4(875353), // Rule ID 25123 //
     /*  875286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  875297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  875300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  875303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875332 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  875332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  875335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875351 */     GIR_RootConstrainSelectedInstOperands,
     /*  875352 */     // GIR_Coverage, 25123,
     /*  875352 */     GIR_EraseRootFromParent_Done,
     /*  875353 */   // Label 13410: @875353
     /*  875353 */   GIM_Try, /*On fail goto*//*Label 13411*/ GIMT_Encode4(875425), // Rule ID 25124 //
     /*  875358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  875369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  875372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  875375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  875378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  875404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  875407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875423 */     GIR_RootConstrainSelectedInstOperands,
     /*  875424 */     // GIR_Coverage, 25124,
     /*  875424 */     GIR_EraseRootFromParent_Done,
     /*  875425 */   // Label 13411: @875425
     /*  875425 */   GIM_Try, /*On fail goto*//*Label 13412*/ GIMT_Encode4(875497), // Rule ID 25125 //
     /*  875430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  875441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  875444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  875447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  875450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875476 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  875476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  875479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875495 */     GIR_RootConstrainSelectedInstOperands,
     /*  875496 */     // GIR_Coverage, 25125,
     /*  875496 */     GIR_EraseRootFromParent_Done,
     /*  875497 */   // Label 13412: @875497
     /*  875497 */   GIM_Try, /*On fail goto*//*Label 13413*/ GIMT_Encode4(875569), // Rule ID 25126 //
     /*  875502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  875513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  875516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  875519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  875522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875548 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  875548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  875551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875567 */     GIR_RootConstrainSelectedInstOperands,
     /*  875568 */     // GIR_Coverage, 25126,
     /*  875568 */     GIR_EraseRootFromParent_Done,
     /*  875569 */   // Label 13413: @875569
     /*  875569 */   GIM_Try, /*On fail goto*//*Label 13414*/ GIMT_Encode4(875641), // Rule ID 25127 //
     /*  875574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  875585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  875588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  875591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  875594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875620 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  875620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  875623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875639 */     GIR_RootConstrainSelectedInstOperands,
     /*  875640 */     // GIR_Coverage, 25127,
     /*  875640 */     GIR_EraseRootFromParent_Done,
     /*  875641 */   // Label 13414: @875641
     /*  875641 */   GIM_Try, /*On fail goto*//*Label 13415*/ GIMT_Encode4(875713), // Rule ID 25128 //
     /*  875646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  875657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  875660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  875663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  875695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875711 */     GIR_RootConstrainSelectedInstOperands,
     /*  875712 */     // GIR_Coverage, 25128,
     /*  875712 */     GIR_EraseRootFromParent_Done,
     /*  875713 */   // Label 13415: @875713
     /*  875713 */   GIM_Try, /*On fail goto*//*Label 13416*/ GIMT_Encode4(875785), // Rule ID 25129 //
     /*  875718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  875729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  875732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  875735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  875767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875783 */     GIR_RootConstrainSelectedInstOperands,
     /*  875784 */     // GIR_Coverage, 25129,
     /*  875784 */     GIR_EraseRootFromParent_Done,
     /*  875785 */   // Label 13416: @875785
     /*  875785 */   GIM_Try, /*On fail goto*//*Label 13417*/ GIMT_Encode4(875857), // Rule ID 25130 //
     /*  875790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  875801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  875804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  875807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  875839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875855 */     GIR_RootConstrainSelectedInstOperands,
     /*  875856 */     // GIR_Coverage, 25130,
     /*  875856 */     GIR_EraseRootFromParent_Done,
     /*  875857 */   // Label 13417: @875857
     /*  875857 */   GIM_Try, /*On fail goto*//*Label 13418*/ GIMT_Encode4(875929), // Rule ID 25131 //
     /*  875862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  875873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  875876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  875879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  875911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875927 */     GIR_RootConstrainSelectedInstOperands,
     /*  875928 */     // GIR_Coverage, 25131,
     /*  875928 */     GIR_EraseRootFromParent_Done,
     /*  875929 */   // Label 13418: @875929
     /*  875929 */   GIM_Try, /*On fail goto*//*Label 13419*/ GIMT_Encode4(876001), // Rule ID 25132 //
     /*  875934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  875945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  875948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  875951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  875954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875980 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  875983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875999 */     GIR_RootConstrainSelectedInstOperands,
     /*  876000 */     // GIR_Coverage, 25132,
     /*  876000 */     GIR_EraseRootFromParent_Done,
     /*  876001 */   // Label 13419: @876001
     /*  876001 */   GIM_Try, /*On fail goto*//*Label 13420*/ GIMT_Encode4(876073), // Rule ID 25133 //
     /*  876006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  876017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  876020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  876023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  876026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876052 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  876052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  876055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876071 */     GIR_RootConstrainSelectedInstOperands,
     /*  876072 */     // GIR_Coverage, 25133,
     /*  876072 */     GIR_EraseRootFromParent_Done,
     /*  876073 */   // Label 13420: @876073
     /*  876073 */   GIM_Try, /*On fail goto*//*Label 13421*/ GIMT_Encode4(876145), // Rule ID 25134 //
     /*  876078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  876081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  876089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  876092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  876095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  876124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  876127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876143 */     GIR_RootConstrainSelectedInstOperands,
     /*  876144 */     // GIR_Coverage, 25134,
     /*  876144 */     GIR_EraseRootFromParent_Done,
     /*  876145 */   // Label 13421: @876145
     /*  876145 */   GIM_Try, /*On fail goto*//*Label 13422*/ GIMT_Encode4(876217), // Rule ID 25135 //
     /*  876150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  876153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  876161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  876164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  876167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  876199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876215 */     GIR_RootConstrainSelectedInstOperands,
     /*  876216 */     // GIR_Coverage, 25135,
     /*  876216 */     GIR_EraseRootFromParent_Done,
     /*  876217 */   // Label 13422: @876217
     /*  876217 */   GIM_Try, /*On fail goto*//*Label 13423*/ GIMT_Encode4(876289), // Rule ID 25136 //
     /*  876222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  876225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  876233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  876236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  876239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876268 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  876268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  876271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876287 */     GIR_RootConstrainSelectedInstOperands,
     /*  876288 */     // GIR_Coverage, 25136,
     /*  876288 */     GIR_EraseRootFromParent_Done,
     /*  876289 */   // Label 13423: @876289
     /*  876289 */   GIM_Try, /*On fail goto*//*Label 13424*/ GIMT_Encode4(876361), // Rule ID 25137 //
     /*  876294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  876297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  876305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  876308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  876311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876340 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  876343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876359 */     GIR_RootConstrainSelectedInstOperands,
     /*  876360 */     // GIR_Coverage, 25137,
     /*  876360 */     GIR_EraseRootFromParent_Done,
     /*  876361 */   // Label 13424: @876361
     /*  876361 */   GIM_Try, /*On fail goto*//*Label 13425*/ GIMT_Encode4(876433), // Rule ID 25138 //
     /*  876366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  876369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  876377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  876380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  876383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  876386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876412 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  876412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  876415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876431 */     GIR_RootConstrainSelectedInstOperands,
     /*  876432 */     // GIR_Coverage, 25138,
     /*  876432 */     GIR_EraseRootFromParent_Done,
     /*  876433 */   // Label 13425: @876433
     /*  876433 */   GIM_Try, /*On fail goto*//*Label 13426*/ GIMT_Encode4(876505), // Rule ID 25139 //
     /*  876438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  876441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  876449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  876452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  876455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  876458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  876487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876503 */     GIR_RootConstrainSelectedInstOperands,
     /*  876504 */     // GIR_Coverage, 25139,
     /*  876504 */     GIR_EraseRootFromParent_Done,
     /*  876505 */   // Label 13426: @876505
     /*  876505 */   GIM_Try, /*On fail goto*//*Label 13427*/ GIMT_Encode4(876577), // Rule ID 25140 //
     /*  876510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  876521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  876524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  876527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876556 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  876559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876575 */     GIR_RootConstrainSelectedInstOperands,
     /*  876576 */     // GIR_Coverage, 25140,
     /*  876576 */     GIR_EraseRootFromParent_Done,
     /*  876577 */   // Label 13427: @876577
     /*  876577 */   GIM_Try, /*On fail goto*//*Label 13428*/ GIMT_Encode4(876649), // Rule ID 25141 //
     /*  876582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  876593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  876596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  876599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876628 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  876628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  876631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876647 */     GIR_RootConstrainSelectedInstOperands,
     /*  876648 */     // GIR_Coverage, 25141,
     /*  876648 */     GIR_EraseRootFromParent_Done,
     /*  876649 */   // Label 13428: @876649
     /*  876649 */   GIM_Try, /*On fail goto*//*Label 13429*/ GIMT_Encode4(876721), // Rule ID 25142 //
     /*  876654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  876665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  876668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  876671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876700 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  876703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876719 */     GIR_RootConstrainSelectedInstOperands,
     /*  876720 */     // GIR_Coverage, 25142,
     /*  876720 */     GIR_EraseRootFromParent_Done,
     /*  876721 */   // Label 13429: @876721
     /*  876721 */   GIM_Try, /*On fail goto*//*Label 13430*/ GIMT_Encode4(876793), // Rule ID 25143 //
     /*  876726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  876737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  876740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  876743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876772 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  876772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  876775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876791 */     GIR_RootConstrainSelectedInstOperands,
     /*  876792 */     // GIR_Coverage, 25143,
     /*  876792 */     GIR_EraseRootFromParent_Done,
     /*  876793 */   // Label 13430: @876793
     /*  876793 */   GIM_Try, /*On fail goto*//*Label 13431*/ GIMT_Encode4(876865), // Rule ID 25144 //
     /*  876798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  876809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  876812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  876815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876844 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  876844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  876847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876863 */     GIR_RootConstrainSelectedInstOperands,
     /*  876864 */     // GIR_Coverage, 25144,
     /*  876864 */     GIR_EraseRootFromParent_Done,
     /*  876865 */   // Label 13431: @876865
     /*  876865 */   GIM_Try, /*On fail goto*//*Label 13432*/ GIMT_Encode4(876937), // Rule ID 25145 //
     /*  876870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  876881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  876884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  876887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876916 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  876916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  876919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876935 */     GIR_RootConstrainSelectedInstOperands,
     /*  876936 */     // GIR_Coverage, 25145,
     /*  876936 */     GIR_EraseRootFromParent_Done,
     /*  876937 */   // Label 13432: @876937
     /*  876937 */   GIM_Try, /*On fail goto*//*Label 13433*/ GIMT_Encode4(877009), // Rule ID 25146 //
     /*  876942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  876953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  876956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  876959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876988 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  876991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877007 */     GIR_RootConstrainSelectedInstOperands,
     /*  877008 */     // GIR_Coverage, 25146,
     /*  877008 */     GIR_EraseRootFromParent_Done,
     /*  877009 */   // Label 13433: @877009
     /*  877009 */   GIM_Try, /*On fail goto*//*Label 13434*/ GIMT_Encode4(877081), // Rule ID 25147 //
     /*  877014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  877025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  877028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  877031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877060 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  877063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877079 */     GIR_RootConstrainSelectedInstOperands,
     /*  877080 */     // GIR_Coverage, 25147,
     /*  877080 */     GIR_EraseRootFromParent_Done,
     /*  877081 */   // Label 13434: @877081
     /*  877081 */   GIM_Try, /*On fail goto*//*Label 13435*/ GIMT_Encode4(877153), // Rule ID 25148 //
     /*  877086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  877097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  877100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  877103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877132 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  877135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877151 */     GIR_RootConstrainSelectedInstOperands,
     /*  877152 */     // GIR_Coverage, 25148,
     /*  877152 */     GIR_EraseRootFromParent_Done,
     /*  877153 */   // Label 13435: @877153
     /*  877153 */   GIM_Try, /*On fail goto*//*Label 13436*/ GIMT_Encode4(877225), // Rule ID 25149 //
     /*  877158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  877169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  877172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  877175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877204 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  877207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877223 */     GIR_RootConstrainSelectedInstOperands,
     /*  877224 */     // GIR_Coverage, 25149,
     /*  877224 */     GIR_EraseRootFromParent_Done,
     /*  877225 */   // Label 13436: @877225
     /*  877225 */   GIM_Try, /*On fail goto*//*Label 13437*/ GIMT_Encode4(877297), // Rule ID 25150 //
     /*  877230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  877233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  877241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  877244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  877247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  877250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877276 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  877276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  877279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877295 */     GIR_RootConstrainSelectedInstOperands,
     /*  877296 */     // GIR_Coverage, 25150,
     /*  877296 */     GIR_EraseRootFromParent_Done,
     /*  877297 */   // Label 13437: @877297
     /*  877297 */   GIM_Try, /*On fail goto*//*Label 13438*/ GIMT_Encode4(877369), // Rule ID 25151 //
     /*  877302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  877305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  877313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  877316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  877319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  877322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877348 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  877348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  877351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877367 */     GIR_RootConstrainSelectedInstOperands,
     /*  877368 */     // GIR_Coverage, 25151,
     /*  877368 */     GIR_EraseRootFromParent_Done,
     /*  877369 */   // Label 13438: @877369
     /*  877369 */   GIM_Try, /*On fail goto*//*Label 13439*/ GIMT_Encode4(877441), // Rule ID 25152 //
     /*  877374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  877385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  877388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  877391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877420 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  877423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877439 */     GIR_RootConstrainSelectedInstOperands,
     /*  877440 */     // GIR_Coverage, 25152,
     /*  877440 */     GIR_EraseRootFromParent_Done,
     /*  877441 */   // Label 13439: @877441
     /*  877441 */   GIM_Try, /*On fail goto*//*Label 13440*/ GIMT_Encode4(877513), // Rule ID 25153 //
     /*  877446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  877457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  877460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  877463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877492 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  877495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877511 */     GIR_RootConstrainSelectedInstOperands,
     /*  877512 */     // GIR_Coverage, 25153,
     /*  877512 */     GIR_EraseRootFromParent_Done,
     /*  877513 */   // Label 13440: @877513
     /*  877513 */   GIM_Try, /*On fail goto*//*Label 13441*/ GIMT_Encode4(877585), // Rule ID 25154 //
     /*  877518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  877529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  877532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  877535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877564 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  877567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877583 */     GIR_RootConstrainSelectedInstOperands,
     /*  877584 */     // GIR_Coverage, 25154,
     /*  877584 */     GIR_EraseRootFromParent_Done,
     /*  877585 */   // Label 13441: @877585
     /*  877585 */   GIM_Try, /*On fail goto*//*Label 13442*/ GIMT_Encode4(877657), // Rule ID 25155 //
     /*  877590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  877601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  877604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  877607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877636 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  877639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877655 */     GIR_RootConstrainSelectedInstOperands,
     /*  877656 */     // GIR_Coverage, 25155,
     /*  877656 */     GIR_EraseRootFromParent_Done,
     /*  877657 */   // Label 13442: @877657
     /*  877657 */   GIM_Try, /*On fail goto*//*Label 13443*/ GIMT_Encode4(877729), // Rule ID 25156 //
     /*  877662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  877673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  877676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  877679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  877682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877708 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  877711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877727 */     GIR_RootConstrainSelectedInstOperands,
     /*  877728 */     // GIR_Coverage, 25156,
     /*  877728 */     GIR_EraseRootFromParent_Done,
     /*  877729 */   // Label 13443: @877729
     /*  877729 */   GIM_Try, /*On fail goto*//*Label 13444*/ GIMT_Encode4(877801), // Rule ID 25157 //
     /*  877734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  877745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  877748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  877751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  877754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877780 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  877783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877799 */     GIR_RootConstrainSelectedInstOperands,
     /*  877800 */     // GIR_Coverage, 25157,
     /*  877800 */     GIR_EraseRootFromParent_Done,
     /*  877801 */   // Label 13444: @877801
     /*  877801 */   GIM_Try, /*On fail goto*//*Label 13445*/ GIMT_Encode4(877873), // Rule ID 25158 //
     /*  877806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  877817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  877820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  877823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877852 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  877855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877871 */     GIR_RootConstrainSelectedInstOperands,
     /*  877872 */     // GIR_Coverage, 25158,
     /*  877872 */     GIR_EraseRootFromParent_Done,
     /*  877873 */   // Label 13445: @877873
     /*  877873 */   GIM_Try, /*On fail goto*//*Label 13446*/ GIMT_Encode4(877945), // Rule ID 25159 //
     /*  877878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  877889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  877892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  877895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877924 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  877927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877943 */     GIR_RootConstrainSelectedInstOperands,
     /*  877944 */     // GIR_Coverage, 25159,
     /*  877944 */     GIR_EraseRootFromParent_Done,
     /*  877945 */   // Label 13446: @877945
     /*  877945 */   GIM_Try, /*On fail goto*//*Label 13447*/ GIMT_Encode4(878017), // Rule ID 25160 //
     /*  877950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  877961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  877964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  877967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877996 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  877999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878015 */     GIR_RootConstrainSelectedInstOperands,
     /*  878016 */     // GIR_Coverage, 25160,
     /*  878016 */     GIR_EraseRootFromParent_Done,
     /*  878017 */   // Label 13447: @878017
     /*  878017 */   GIM_Try, /*On fail goto*//*Label 13448*/ GIMT_Encode4(878089), // Rule ID 25161 //
     /*  878022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  878033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  878036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  878039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878068 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  878068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  878071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878087 */     GIR_RootConstrainSelectedInstOperands,
     /*  878088 */     // GIR_Coverage, 25161,
     /*  878088 */     GIR_EraseRootFromParent_Done,
     /*  878089 */   // Label 13448: @878089
     /*  878089 */   GIM_Try, /*On fail goto*//*Label 13449*/ GIMT_Encode4(878161), // Rule ID 25162 //
     /*  878094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  878105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  878108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  878111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  878114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878140 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  878140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  878143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878159 */     GIR_RootConstrainSelectedInstOperands,
     /*  878160 */     // GIR_Coverage, 25162,
     /*  878160 */     GIR_EraseRootFromParent_Done,
     /*  878161 */   // Label 13449: @878161
     /*  878161 */   GIM_Try, /*On fail goto*//*Label 13450*/ GIMT_Encode4(878233), // Rule ID 25163 //
     /*  878166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  878177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  878180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  878183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  878186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878212 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  878212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  878215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878231 */     GIR_RootConstrainSelectedInstOperands,
     /*  878232 */     // GIR_Coverage, 25163,
     /*  878232 */     GIR_EraseRootFromParent_Done,
     /*  878233 */   // Label 13450: @878233
     /*  878233 */   GIM_Try, /*On fail goto*//*Label 13451*/ GIMT_Encode4(878305), // Rule ID 25164 //
     /*  878238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  878241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  878249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  878252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  878255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  878258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878284 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  878284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  878287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878303 */     GIR_RootConstrainSelectedInstOperands,
     /*  878304 */     // GIR_Coverage, 25164,
     /*  878304 */     GIR_EraseRootFromParent_Done,
     /*  878305 */   // Label 13451: @878305
     /*  878305 */   GIM_Try, /*On fail goto*//*Label 13452*/ GIMT_Encode4(878377), // Rule ID 25165 //
     /*  878310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  878313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  878321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  878324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  878327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  878330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878356 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  878356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  878359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878375 */     GIR_RootConstrainSelectedInstOperands,
     /*  878376 */     // GIR_Coverage, 25165,
     /*  878376 */     GIR_EraseRootFromParent_Done,
     /*  878377 */   // Label 13452: @878377
     /*  878377 */   GIM_Try, /*On fail goto*//*Label 13453*/ GIMT_Encode4(878449), // Rule ID 25166 //
     /*  878382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  878385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  878393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  878396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  878399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  878402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878428 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  878428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  878431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878447 */     GIR_RootConstrainSelectedInstOperands,
     /*  878448 */     // GIR_Coverage, 25166,
     /*  878448 */     GIR_EraseRootFromParent_Done,
     /*  878449 */   // Label 13453: @878449
     /*  878449 */   GIM_Try, /*On fail goto*//*Label 13454*/ GIMT_Encode4(878521), // Rule ID 25167 //
     /*  878454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  878457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  878465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  878468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  878471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  878474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878500 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  878500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  878503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878519 */     GIR_RootConstrainSelectedInstOperands,
     /*  878520 */     // GIR_Coverage, 25167,
     /*  878520 */     GIR_EraseRootFromParent_Done,
     /*  878521 */   // Label 13454: @878521
     /*  878521 */   GIM_Try, /*On fail goto*//*Label 13455*/ GIMT_Encode4(878593), // Rule ID 25168 //
     /*  878526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  878529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  878537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  878540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  878543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878572 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  878572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  878575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878591 */     GIR_RootConstrainSelectedInstOperands,
     /*  878592 */     // GIR_Coverage, 25168,
     /*  878592 */     GIR_EraseRootFromParent_Done,
     /*  878593 */   // Label 13455: @878593
     /*  878593 */   GIM_Try, /*On fail goto*//*Label 13456*/ GIMT_Encode4(878665), // Rule ID 25169 //
     /*  878598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  878601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  878609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  878612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  878615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878644 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  878644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  878647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878663 */     GIR_RootConstrainSelectedInstOperands,
     /*  878664 */     // GIR_Coverage, 25169,
     /*  878664 */     GIR_EraseRootFromParent_Done,
     /*  878665 */   // Label 13456: @878665
     /*  878665 */   GIM_Try, /*On fail goto*//*Label 13457*/ GIMT_Encode4(878740), // Rule ID 60624 //
     /*  878670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  878673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  878678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  878681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  878684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  878687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  878690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878716 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  878716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  878719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878738 */     GIR_RootConstrainSelectedInstOperands,
     /*  878739 */     // GIR_Coverage, 60624,
     /*  878739 */     GIR_EraseRootFromParent_Done,
     /*  878740 */   // Label 13457: @878740
     /*  878740 */   GIM_Try, /*On fail goto*//*Label 13458*/ GIMT_Encode4(878815), // Rule ID 60625 //
     /*  878745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  878748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  878753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  878756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  878759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  878762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  878765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878791 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  878791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  878794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878813 */     GIR_RootConstrainSelectedInstOperands,
     /*  878814 */     // GIR_Coverage, 60625,
     /*  878814 */     GIR_EraseRootFromParent_Done,
     /*  878815 */   // Label 13458: @878815
     /*  878815 */   GIM_Try, /*On fail goto*//*Label 13459*/ GIMT_Encode4(878890), // Rule ID 60982 //
     /*  878820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  878831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  878834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  878837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  878840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878866 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  878869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878888 */     GIR_RootConstrainSelectedInstOperands,
     /*  878889 */     // GIR_Coverage, 60982,
     /*  878889 */     GIR_EraseRootFromParent_Done,
     /*  878890 */   // Label 13459: @878890
     /*  878890 */   GIM_Try, /*On fail goto*//*Label 13460*/ GIMT_Encode4(878965), // Rule ID 60983 //
     /*  878895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  878906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  878909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  878912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  878915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878941 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  878944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878963 */     GIR_RootConstrainSelectedInstOperands,
     /*  878964 */     // GIR_Coverage, 60983,
     /*  878964 */     GIR_EraseRootFromParent_Done,
     /*  878965 */   // Label 13460: @878965
     /*  878965 */   GIM_Try, /*On fail goto*//*Label 13461*/ GIMT_Encode4(879040), // Rule ID 60986 //
     /*  878970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  878981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  878984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  878987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  878990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879016 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  879019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879038 */     GIR_RootConstrainSelectedInstOperands,
     /*  879039 */     // GIR_Coverage, 60986,
     /*  879039 */     GIR_EraseRootFromParent_Done,
     /*  879040 */   // Label 13461: @879040
     /*  879040 */   GIM_Try, /*On fail goto*//*Label 13462*/ GIMT_Encode4(879115), // Rule ID 60987 //
     /*  879045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  879056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  879059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  879062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  879065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879091 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  879094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879113 */     GIR_RootConstrainSelectedInstOperands,
     /*  879114 */     // GIR_Coverage, 60987,
     /*  879114 */     GIR_EraseRootFromParent_Done,
     /*  879115 */   // Label 13462: @879115
     /*  879115 */   GIM_Try, /*On fail goto*//*Label 13463*/ GIMT_Encode4(879190), // Rule ID 60990 //
     /*  879120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  879131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  879134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  879137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  879140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879166 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879188 */     GIR_RootConstrainSelectedInstOperands,
     /*  879189 */     // GIR_Coverage, 60990,
     /*  879189 */     GIR_EraseRootFromParent_Done,
     /*  879190 */   // Label 13463: @879190
     /*  879190 */   GIM_Try, /*On fail goto*//*Label 13464*/ GIMT_Encode4(879265), // Rule ID 60991 //
     /*  879195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  879206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  879209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  879212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  879215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879241 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879263 */     GIR_RootConstrainSelectedInstOperands,
     /*  879264 */     // GIR_Coverage, 60991,
     /*  879264 */     GIR_EraseRootFromParent_Done,
     /*  879265 */   // Label 13464: @879265
     /*  879265 */   GIM_Try, /*On fail goto*//*Label 13465*/ GIMT_Encode4(879340), // Rule ID 60994 //
     /*  879270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  879281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  879284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  879287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  879290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  879319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879338 */     GIR_RootConstrainSelectedInstOperands,
     /*  879339 */     // GIR_Coverage, 60994,
     /*  879339 */     GIR_EraseRootFromParent_Done,
     /*  879340 */   // Label 13465: @879340
     /*  879340 */   GIM_Try, /*On fail goto*//*Label 13466*/ GIMT_Encode4(879415), // Rule ID 60995 //
     /*  879345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  879356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  879359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  879362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  879365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879391 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  879394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879413 */     GIR_RootConstrainSelectedInstOperands,
     /*  879414 */     // GIR_Coverage, 60995,
     /*  879414 */     GIR_EraseRootFromParent_Done,
     /*  879415 */   // Label 13466: @879415
     /*  879415 */   GIM_Try, /*On fail goto*//*Label 13467*/ GIMT_Encode4(879490), // Rule ID 60998 //
     /*  879420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  879431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  879434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  879437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  879440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879466 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879488 */     GIR_RootConstrainSelectedInstOperands,
     /*  879489 */     // GIR_Coverage, 60998,
     /*  879489 */     GIR_EraseRootFromParent_Done,
     /*  879490 */   // Label 13467: @879490
     /*  879490 */   GIM_Try, /*On fail goto*//*Label 13468*/ GIMT_Encode4(879565), // Rule ID 60999 //
     /*  879495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  879506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  879509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  879512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  879515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879541 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879563 */     GIR_RootConstrainSelectedInstOperands,
     /*  879564 */     // GIR_Coverage, 60999,
     /*  879564 */     GIR_EraseRootFromParent_Done,
     /*  879565 */   // Label 13468: @879565
     /*  879565 */   GIM_Try, /*On fail goto*//*Label 13469*/ GIMT_Encode4(879640), // Rule ID 61002 //
     /*  879570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  879581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  879584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  879587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  879590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879616 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879638 */     GIR_RootConstrainSelectedInstOperands,
     /*  879639 */     // GIR_Coverage, 61002,
     /*  879639 */     GIR_EraseRootFromParent_Done,
     /*  879640 */   // Label 13469: @879640
     /*  879640 */   GIM_Try, /*On fail goto*//*Label 13470*/ GIMT_Encode4(879715), // Rule ID 61003 //
     /*  879645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  879656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  879659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  879662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  879665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879691 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879713 */     GIR_RootConstrainSelectedInstOperands,
     /*  879714 */     // GIR_Coverage, 61003,
     /*  879714 */     GIR_EraseRootFromParent_Done,
     /*  879715 */   // Label 13470: @879715
     /*  879715 */   GIM_Try, /*On fail goto*//*Label 13471*/ GIMT_Encode4(879790), // Rule ID 61006 //
     /*  879720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  879731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  879734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  879737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  879740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879766 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  879769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879788 */     GIR_RootConstrainSelectedInstOperands,
     /*  879789 */     // GIR_Coverage, 61006,
     /*  879789 */     GIR_EraseRootFromParent_Done,
     /*  879790 */   // Label 13471: @879790
     /*  879790 */   GIM_Try, /*On fail goto*//*Label 13472*/ GIMT_Encode4(879865), // Rule ID 61007 //
     /*  879795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  879806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  879809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  879812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  879815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879841 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  879844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879863 */     GIR_RootConstrainSelectedInstOperands,
     /*  879864 */     // GIR_Coverage, 61007,
     /*  879864 */     GIR_EraseRootFromParent_Done,
     /*  879865 */   // Label 13472: @879865
     /*  879865 */   GIM_Try, /*On fail goto*//*Label 13473*/ GIMT_Encode4(879940), // Rule ID 61010 //
     /*  879870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  879881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  879884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  879887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  879890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879938 */     GIR_RootConstrainSelectedInstOperands,
     /*  879939 */     // GIR_Coverage, 61010,
     /*  879939 */     GIR_EraseRootFromParent_Done,
     /*  879940 */   // Label 13473: @879940
     /*  879940 */   GIM_Try, /*On fail goto*//*Label 13474*/ GIMT_Encode4(880015), // Rule ID 61011 //
     /*  879945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  879956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  879959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  879962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  879965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879991 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880013 */     GIR_RootConstrainSelectedInstOperands,
     /*  880014 */     // GIR_Coverage, 61011,
     /*  880014 */     GIR_EraseRootFromParent_Done,
     /*  880015 */   // Label 13474: @880015
     /*  880015 */   GIM_Try, /*On fail goto*//*Label 13475*/ GIMT_Encode4(880090), // Rule ID 61014 //
     /*  880020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  880031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  880034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  880037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  880040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  880066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  880069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880088 */     GIR_RootConstrainSelectedInstOperands,
     /*  880089 */     // GIR_Coverage, 61014,
     /*  880089 */     GIR_EraseRootFromParent_Done,
     /*  880090 */   // Label 13475: @880090
     /*  880090 */   GIM_Try, /*On fail goto*//*Label 13476*/ GIMT_Encode4(880165), // Rule ID 61015 //
     /*  880095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  880106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  880109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  880112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  880115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  880141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  880144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880163 */     GIR_RootConstrainSelectedInstOperands,
     /*  880164 */     // GIR_Coverage, 61015,
     /*  880164 */     GIR_EraseRootFromParent_Done,
     /*  880165 */   // Label 13476: @880165
     /*  880165 */   GIM_Try, /*On fail goto*//*Label 13477*/ GIMT_Encode4(880240), // Rule ID 61018 //
     /*  880170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  880181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  880184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  880187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  880190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  880216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  880219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880238 */     GIR_RootConstrainSelectedInstOperands,
     /*  880239 */     // GIR_Coverage, 61018,
     /*  880239 */     GIR_EraseRootFromParent_Done,
     /*  880240 */   // Label 13477: @880240
     /*  880240 */   GIM_Try, /*On fail goto*//*Label 13478*/ GIMT_Encode4(880315), // Rule ID 61019 //
     /*  880245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  880256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  880259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  880262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  880265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880291 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  880291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  880294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880313 */     GIR_RootConstrainSelectedInstOperands,
     /*  880314 */     // GIR_Coverage, 61019,
     /*  880314 */     GIR_EraseRootFromParent_Done,
     /*  880315 */   // Label 13478: @880315
     /*  880315 */   GIM_Try, /*On fail goto*//*Label 13479*/ GIMT_Encode4(880390), // Rule ID 61022 //
     /*  880320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  880331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  880334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  880337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  880340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880366 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  880366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  880369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880388 */     GIR_RootConstrainSelectedInstOperands,
     /*  880389 */     // GIR_Coverage, 61022,
     /*  880389 */     GIR_EraseRootFromParent_Done,
     /*  880390 */   // Label 13479: @880390
     /*  880390 */   GIM_Try, /*On fail goto*//*Label 13480*/ GIMT_Encode4(880465), // Rule ID 61023 //
     /*  880395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  880406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  880409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  880412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  880415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880441 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  880441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  880444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880463 */     GIR_RootConstrainSelectedInstOperands,
     /*  880464 */     // GIR_Coverage, 61023,
     /*  880464 */     GIR_EraseRootFromParent_Done,
     /*  880465 */   // Label 13480: @880465
     /*  880465 */   GIM_Try, /*On fail goto*//*Label 13481*/ GIMT_Encode4(880540), // Rule ID 61026 //
     /*  880470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  880481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  880484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  880487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  880490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880516 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  880519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880538 */     GIR_RootConstrainSelectedInstOperands,
     /*  880539 */     // GIR_Coverage, 61026,
     /*  880539 */     GIR_EraseRootFromParent_Done,
     /*  880540 */   // Label 13481: @880540
     /*  880540 */   GIM_Try, /*On fail goto*//*Label 13482*/ GIMT_Encode4(880615), // Rule ID 61027 //
     /*  880545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  880556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  880559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  880562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  880565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880591 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  880594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880613 */     GIR_RootConstrainSelectedInstOperands,
     /*  880614 */     // GIR_Coverage, 61027,
     /*  880614 */     GIR_EraseRootFromParent_Done,
     /*  880615 */   // Label 13482: @880615
     /*  880615 */   GIM_Try, /*On fail goto*//*Label 13483*/ GIMT_Encode4(880690), // Rule ID 61030 //
     /*  880620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  880631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  880634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  880637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  880640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880666 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  880669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880688 */     GIR_RootConstrainSelectedInstOperands,
     /*  880689 */     // GIR_Coverage, 61030,
     /*  880689 */     GIR_EraseRootFromParent_Done,
     /*  880690 */   // Label 13483: @880690
     /*  880690 */   GIM_Try, /*On fail goto*//*Label 13484*/ GIMT_Encode4(880765), // Rule ID 61031 //
     /*  880695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  880706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  880709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  880712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  880715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880741 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  880744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880763 */     GIR_RootConstrainSelectedInstOperands,
     /*  880764 */     // GIR_Coverage, 61031,
     /*  880764 */     GIR_EraseRootFromParent_Done,
     /*  880765 */   // Label 13484: @880765
     /*  880765 */   GIM_Try, /*On fail goto*//*Label 13485*/ GIMT_Encode4(880840), // Rule ID 61034 //
     /*  880770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  880781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  880784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  880790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880816 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  880819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880838 */     GIR_RootConstrainSelectedInstOperands,
     /*  880839 */     // GIR_Coverage, 61034,
     /*  880839 */     GIR_EraseRootFromParent_Done,
     /*  880840 */   // Label 13485: @880840
     /*  880840 */   GIM_Try, /*On fail goto*//*Label 13486*/ GIMT_Encode4(880915), // Rule ID 61035 //
     /*  880845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  880856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  880859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  880865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880891 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  880894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880913 */     GIR_RootConstrainSelectedInstOperands,
     /*  880914 */     // GIR_Coverage, 61035,
     /*  880914 */     GIR_EraseRootFromParent_Done,
     /*  880915 */   // Label 13486: @880915
     /*  880915 */   GIM_Try, /*On fail goto*//*Label 13487*/ GIMT_Encode4(880990), // Rule ID 61038 //
     /*  880920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  880931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  880934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  880940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880966 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  880969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880988 */     GIR_RootConstrainSelectedInstOperands,
     /*  880989 */     // GIR_Coverage, 61038,
     /*  880989 */     GIR_EraseRootFromParent_Done,
     /*  880990 */   // Label 13487: @880990
     /*  880990 */   GIM_Try, /*On fail goto*//*Label 13488*/ GIMT_Encode4(881065), // Rule ID 61039 //
     /*  880995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  881006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  881009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  881012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  881015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881041 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  881041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  881044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  881060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881063 */     GIR_RootConstrainSelectedInstOperands,
     /*  881064 */     // GIR_Coverage, 61039,
     /*  881064 */     GIR_EraseRootFromParent_Done,
     /*  881065 */   // Label 13488: @881065
     /*  881065 */   GIM_Try, /*On fail goto*//*Label 13489*/ GIMT_Encode4(881140), // Rule ID 61042 //
     /*  881070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  881081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  881084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  881087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881116 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  881119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881138 */     GIR_RootConstrainSelectedInstOperands,
     /*  881139 */     // GIR_Coverage, 61042,
     /*  881139 */     GIR_EraseRootFromParent_Done,
     /*  881140 */   // Label 13489: @881140
     /*  881140 */   GIM_Try, /*On fail goto*//*Label 13490*/ GIMT_Encode4(881215), // Rule ID 61043 //
     /*  881145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  881156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  881159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  881162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881191 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  881194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881213 */     GIR_RootConstrainSelectedInstOperands,
     /*  881214 */     // GIR_Coverage, 61043,
     /*  881214 */     GIR_EraseRootFromParent_Done,
     /*  881215 */   // Label 13490: @881215
     /*  881215 */   GIM_Try, /*On fail goto*//*Label 13491*/ GIMT_Encode4(881290), // Rule ID 61050 //
     /*  881220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  881231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  881234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  881237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881266 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  881269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881288 */     GIR_RootConstrainSelectedInstOperands,
     /*  881289 */     // GIR_Coverage, 61050,
     /*  881289 */     GIR_EraseRootFromParent_Done,
     /*  881290 */   // Label 13491: @881290
     /*  881290 */   GIM_Try, /*On fail goto*//*Label 13492*/ GIMT_Encode4(881365), // Rule ID 61051 //
     /*  881295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  881306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  881309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  881312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881341 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  881344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881363 */     GIR_RootConstrainSelectedInstOperands,
     /*  881364 */     // GIR_Coverage, 61051,
     /*  881364 */     GIR_EraseRootFromParent_Done,
     /*  881365 */   // Label 13492: @881365
     /*  881365 */   GIM_Try, /*On fail goto*//*Label 13493*/ GIMT_Encode4(881440), // Rule ID 61058 //
     /*  881370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  881381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  881384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  881387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881438 */     GIR_RootConstrainSelectedInstOperands,
     /*  881439 */     // GIR_Coverage, 61058,
     /*  881439 */     GIR_EraseRootFromParent_Done,
     /*  881440 */   // Label 13493: @881440
     /*  881440 */   GIM_Try, /*On fail goto*//*Label 13494*/ GIMT_Encode4(881515), // Rule ID 61059 //
     /*  881445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  881456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  881459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  881462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881491 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881513 */     GIR_RootConstrainSelectedInstOperands,
     /*  881514 */     // GIR_Coverage, 61059,
     /*  881514 */     GIR_EraseRootFromParent_Done,
     /*  881515 */   // Label 13494: @881515
     /*  881515 */   GIM_Try, /*On fail goto*//*Label 13495*/ GIMT_Encode4(881590), // Rule ID 61066 //
     /*  881520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  881531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  881534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  881537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881566 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881588 */     GIR_RootConstrainSelectedInstOperands,
     /*  881589 */     // GIR_Coverage, 61066,
     /*  881589 */     GIR_EraseRootFromParent_Done,
     /*  881590 */   // Label 13495: @881590
     /*  881590 */   GIM_Try, /*On fail goto*//*Label 13496*/ GIMT_Encode4(881665), // Rule ID 61067 //
     /*  881595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  881606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  881609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  881612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881641 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881663 */     GIR_RootConstrainSelectedInstOperands,
     /*  881664 */     // GIR_Coverage, 61067,
     /*  881664 */     GIR_EraseRootFromParent_Done,
     /*  881665 */   // Label 13496: @881665
     /*  881665 */   GIM_Try, /*On fail goto*//*Label 13497*/ GIMT_Encode4(881740), // Rule ID 61074 //
     /*  881670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  881681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  881684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  881687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881716 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  881719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881738 */     GIR_RootConstrainSelectedInstOperands,
     /*  881739 */     // GIR_Coverage, 61074,
     /*  881739 */     GIR_EraseRootFromParent_Done,
     /*  881740 */   // Label 13497: @881740
     /*  881740 */   GIM_Try, /*On fail goto*//*Label 13498*/ GIMT_Encode4(881815), // Rule ID 61075 //
     /*  881745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  881756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  881759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  881762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881791 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  881794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881813 */     GIR_RootConstrainSelectedInstOperands,
     /*  881814 */     // GIR_Coverage, 61075,
     /*  881814 */     GIR_EraseRootFromParent_Done,
     /*  881815 */   // Label 13498: @881815
     /*  881815 */   GIM_Try, /*On fail goto*//*Label 13499*/ GIMT_Encode4(881890), // Rule ID 61082 //
     /*  881820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  881831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  881834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  881837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881866 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  881869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881888 */     GIR_RootConstrainSelectedInstOperands,
     /*  881889 */     // GIR_Coverage, 61082,
     /*  881889 */     GIR_EraseRootFromParent_Done,
     /*  881890 */   // Label 13499: @881890
     /*  881890 */   GIM_Try, /*On fail goto*//*Label 13500*/ GIMT_Encode4(881965), // Rule ID 61083 //
     /*  881895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  881906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  881909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  881912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881941 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  881944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881963 */     GIR_RootConstrainSelectedInstOperands,
     /*  881964 */     // GIR_Coverage, 61083,
     /*  881964 */     GIR_EraseRootFromParent_Done,
     /*  881965 */   // Label 13500: @881965
     /*  881965 */   GIM_Try, /*On fail goto*//*Label 13501*/ GIMT_Encode4(882040), // Rule ID 61090 //
     /*  881970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  881981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  881984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  881987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  882019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882038 */     GIR_RootConstrainSelectedInstOperands,
     /*  882039 */     // GIR_Coverage, 61090,
     /*  882039 */     GIR_EraseRootFromParent_Done,
     /*  882040 */   // Label 13501: @882040
     /*  882040 */   GIM_Try, /*On fail goto*//*Label 13502*/ GIMT_Encode4(882115), // Rule ID 61091 //
     /*  882045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  882056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  882059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  882062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882091 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  882094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882113 */     GIR_RootConstrainSelectedInstOperands,
     /*  882114 */     // GIR_Coverage, 61091,
     /*  882114 */     GIR_EraseRootFromParent_Done,
     /*  882115 */   // Label 13502: @882115
     /*  882115 */   GIM_Try, /*On fail goto*//*Label 13503*/ GIMT_Encode4(882190), // Rule ID 61098 //
     /*  882120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  882131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  882134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  882137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  882169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882188 */     GIR_RootConstrainSelectedInstOperands,
     /*  882189 */     // GIR_Coverage, 61098,
     /*  882189 */     GIR_EraseRootFromParent_Done,
     /*  882190 */   // Label 13503: @882190
     /*  882190 */   GIM_Try, /*On fail goto*//*Label 13504*/ GIMT_Encode4(882265), // Rule ID 61099 //
     /*  882195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  882206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  882209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  882212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882241 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  882244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882263 */     GIR_RootConstrainSelectedInstOperands,
     /*  882264 */     // GIR_Coverage, 61099,
     /*  882264 */     GIR_EraseRootFromParent_Done,
     /*  882265 */   // Label 13504: @882265
     /*  882265 */   GIM_Try, /*On fail goto*//*Label 13505*/ GIMT_Encode4(882340), // Rule ID 61106 //
     /*  882270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  882281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  882284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  882287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882338 */     GIR_RootConstrainSelectedInstOperands,
     /*  882339 */     // GIR_Coverage, 61106,
     /*  882339 */     GIR_EraseRootFromParent_Done,
     /*  882340 */   // Label 13505: @882340
     /*  882340 */   GIM_Try, /*On fail goto*//*Label 13506*/ GIMT_Encode4(882415), // Rule ID 61107 //
     /*  882345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  882356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  882359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  882362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882391 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882413 */     GIR_RootConstrainSelectedInstOperands,
     /*  882414 */     // GIR_Coverage, 61107,
     /*  882414 */     GIR_EraseRootFromParent_Done,
     /*  882415 */   // Label 13506: @882415
     /*  882415 */   GIM_Try, /*On fail goto*//*Label 13507*/ GIMT_Encode4(882490), // Rule ID 61114 //
     /*  882420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  882431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  882434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  882437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882466 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882488 */     GIR_RootConstrainSelectedInstOperands,
     /*  882489 */     // GIR_Coverage, 61114,
     /*  882489 */     GIR_EraseRootFromParent_Done,
     /*  882490 */   // Label 13507: @882490
     /*  882490 */   GIM_Try, /*On fail goto*//*Label 13508*/ GIMT_Encode4(882565), // Rule ID 61115 //
     /*  882495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  882506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  882509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  882512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882541 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882563 */     GIR_RootConstrainSelectedInstOperands,
     /*  882564 */     // GIR_Coverage, 61115,
     /*  882564 */     GIR_EraseRootFromParent_Done,
     /*  882565 */   // Label 13508: @882565
     /*  882565 */   GIM_Try, /*On fail goto*//*Label 13509*/ GIMT_Encode4(882640), // Rule ID 61122 //
     /*  882570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  882581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  882584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  882587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882616 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882638 */     GIR_RootConstrainSelectedInstOperands,
     /*  882639 */     // GIR_Coverage, 61122,
     /*  882639 */     GIR_EraseRootFromParent_Done,
     /*  882640 */   // Label 13509: @882640
     /*  882640 */   GIM_Try, /*On fail goto*//*Label 13510*/ GIMT_Encode4(882715), // Rule ID 61123 //
     /*  882645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  882656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  882659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  882662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882691 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882713 */     GIR_RootConstrainSelectedInstOperands,
     /*  882714 */     // GIR_Coverage, 61123,
     /*  882714 */     GIR_EraseRootFromParent_Done,
     /*  882715 */   // Label 13510: @882715
     /*  882715 */   GIM_Try, /*On fail goto*//*Label 13511*/ GIMT_Encode4(882790), // Rule ID 61130 //
     /*  882720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882766 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  882769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882788 */     GIR_RootConstrainSelectedInstOperands,
     /*  882789 */     // GIR_Coverage, 61130,
     /*  882789 */     GIR_EraseRootFromParent_Done,
     /*  882790 */   // Label 13511: @882790
     /*  882790 */   GIM_Try, /*On fail goto*//*Label 13512*/ GIMT_Encode4(882865), // Rule ID 61131 //
     /*  882795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882841 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  882844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882863 */     GIR_RootConstrainSelectedInstOperands,
     /*  882864 */     // GIR_Coverage, 61131,
     /*  882864 */     GIR_EraseRootFromParent_Done,
     /*  882865 */   // Label 13512: @882865
     /*  882865 */   GIM_Try, /*On fail goto*//*Label 13513*/ GIMT_Encode4(882940), // Rule ID 61138 //
     /*  882870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  882881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  882884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  882887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882916 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882938 */     GIR_RootConstrainSelectedInstOperands,
     /*  882939 */     // GIR_Coverage, 61138,
     /*  882939 */     GIR_EraseRootFromParent_Done,
     /*  882940 */   // Label 13513: @882940
     /*  882940 */   GIM_Try, /*On fail goto*//*Label 13514*/ GIMT_Encode4(883015), // Rule ID 61139 //
     /*  882945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  882956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  882959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  882962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882991 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11720:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883013 */     GIR_RootConstrainSelectedInstOperands,
     /*  883014 */     // GIR_Coverage, 61139,
     /*  883014 */     GIR_EraseRootFromParent_Done,
     /*  883015 */   // Label 13514: @883015
     /*  883015 */   GIM_Try, /*On fail goto*//*Label 13515*/ GIMT_Encode4(883090), // Rule ID 61146 //
     /*  883020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  883037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  883066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  883069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883088 */     GIR_RootConstrainSelectedInstOperands,
     /*  883089 */     // GIR_Coverage, 61146,
     /*  883089 */     GIR_EraseRootFromParent_Done,
     /*  883090 */   // Label 13515: @883090
     /*  883090 */   GIM_Try, /*On fail goto*//*Label 13516*/ GIMT_Encode4(883165), // Rule ID 61147 //
     /*  883095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  883112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883141 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11720:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  883141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  883144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883163 */     GIR_RootConstrainSelectedInstOperands,
     /*  883164 */     // GIR_Coverage, 61147,
     /*  883164 */     GIR_EraseRootFromParent_Done,
     /*  883165 */   // Label 13516: @883165
     /*  883165 */   GIM_Try, /*On fail goto*//*Label 13517*/ GIMT_Encode4(883240), // Rule ID 61154 //
     /*  883170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  883187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883216 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  883216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  883219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883238 */     GIR_RootConstrainSelectedInstOperands,
     /*  883239 */     // GIR_Coverage, 61154,
     /*  883239 */     GIR_EraseRootFromParent_Done,
     /*  883240 */   // Label 13517: @883240
     /*  883240 */   GIM_Try, /*On fail goto*//*Label 13518*/ GIMT_Encode4(883315), // Rule ID 61155 //
     /*  883245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  883262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883291 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11720:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  883291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  883294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883313 */     GIR_RootConstrainSelectedInstOperands,
     /*  883314 */     // GIR_Coverage, 61155,
     /*  883314 */     GIR_EraseRootFromParent_Done,
     /*  883315 */   // Label 13518: @883315
     /*  883315 */   GIM_Try, /*On fail goto*//*Label 13519*/ GIMT_Encode4(883390), // Rule ID 61162 //
     /*  883320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  883340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883366 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  883369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883388 */     GIR_RootConstrainSelectedInstOperands,
     /*  883389 */     // GIR_Coverage, 61162,
     /*  883389 */     GIR_EraseRootFromParent_Done,
     /*  883390 */   // Label 13519: @883390
     /*  883390 */   GIM_Try, /*On fail goto*//*Label 13520*/ GIMT_Encode4(883465), // Rule ID 61163 //
     /*  883395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  883415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883441 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  883444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883463 */     GIR_RootConstrainSelectedInstOperands,
     /*  883464 */     // GIR_Coverage, 61163,
     /*  883464 */     GIR_EraseRootFromParent_Done,
     /*  883465 */   // Label 13520: @883465
     /*  883465 */   GIM_Try, /*On fail goto*//*Label 13521*/ GIMT_Encode4(883540), // Rule ID 61166 //
     /*  883470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  883490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  883519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883538 */     GIR_RootConstrainSelectedInstOperands,
     /*  883539 */     // GIR_Coverage, 61166,
     /*  883539 */     GIR_EraseRootFromParent_Done,
     /*  883540 */   // Label 13521: @883540
     /*  883540 */   GIM_Try, /*On fail goto*//*Label 13522*/ GIMT_Encode4(883615), // Rule ID 61167 //
     /*  883545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  883565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883591 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  883594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883613 */     GIR_RootConstrainSelectedInstOperands,
     /*  883614 */     // GIR_Coverage, 61167,
     /*  883614 */     GIR_EraseRootFromParent_Done,
     /*  883615 */   // Label 13522: @883615
     /*  883615 */   GIM_Try, /*On fail goto*//*Label 13523*/ GIMT_Encode4(883690), // Rule ID 61170 //
     /*  883620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  883640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883666 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  883669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883688 */     GIR_RootConstrainSelectedInstOperands,
     /*  883689 */     // GIR_Coverage, 61170,
     /*  883689 */     GIR_EraseRootFromParent_Done,
     /*  883690 */   // Label 13523: @883690
     /*  883690 */   GIM_Try, /*On fail goto*//*Label 13524*/ GIMT_Encode4(883765), // Rule ID 61171 //
     /*  883695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  883715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883741 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  883744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883763 */     GIR_RootConstrainSelectedInstOperands,
     /*  883764 */     // GIR_Coverage, 61171,
     /*  883764 */     GIR_EraseRootFromParent_Done,
     /*  883765 */   // Label 13524: @883765
     /*  883765 */   GIM_Try, /*On fail goto*//*Label 13525*/ GIMT_Encode4(883840), // Rule ID 61174 //
     /*  883770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  883790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883816 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  883819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883838 */     GIR_RootConstrainSelectedInstOperands,
     /*  883839 */     // GIR_Coverage, 61174,
     /*  883839 */     GIR_EraseRootFromParent_Done,
     /*  883840 */   // Label 13525: @883840
     /*  883840 */   GIM_Try, /*On fail goto*//*Label 13526*/ GIMT_Encode4(883915), // Rule ID 61175 //
     /*  883845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  883865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883891 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  883894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883913 */     GIR_RootConstrainSelectedInstOperands,
     /*  883914 */     // GIR_Coverage, 61175,
     /*  883914 */     GIR_EraseRootFromParent_Done,
     /*  883915 */   // Label 13526: @883915
     /*  883915 */   GIM_Try, /*On fail goto*//*Label 13527*/ GIMT_Encode4(883990), // Rule ID 61178 //
     /*  883920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883966 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  883969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883988 */     GIR_RootConstrainSelectedInstOperands,
     /*  883989 */     // GIR_Coverage, 61178,
     /*  883989 */     GIR_EraseRootFromParent_Done,
     /*  883990 */   // Label 13527: @883990
     /*  883990 */   GIM_Try, /*On fail goto*//*Label 13528*/ GIMT_Encode4(884065), // Rule ID 61179 //
     /*  883995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884041 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  884044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884063 */     GIR_RootConstrainSelectedInstOperands,
     /*  884064 */     // GIR_Coverage, 61179,
     /*  884064 */     GIR_EraseRootFromParent_Done,
     /*  884065 */   // Label 13528: @884065
     /*  884065 */   GIM_Try, /*On fail goto*//*Label 13529*/ GIMT_Encode4(884140), // Rule ID 61182 //
     /*  884070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  884119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884138 */     GIR_RootConstrainSelectedInstOperands,
     /*  884139 */     // GIR_Coverage, 61182,
     /*  884139 */     GIR_EraseRootFromParent_Done,
     /*  884140 */   // Label 13529: @884140
     /*  884140 */   GIM_Try, /*On fail goto*//*Label 13530*/ GIMT_Encode4(884215), // Rule ID 61183 //
     /*  884145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884191 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  884194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884213 */     GIR_RootConstrainSelectedInstOperands,
     /*  884214 */     // GIR_Coverage, 61183,
     /*  884214 */     GIR_EraseRootFromParent_Done,
     /*  884215 */   // Label 13530: @884215
     /*  884215 */   GIM_Try, /*On fail goto*//*Label 13531*/ GIMT_Encode4(884290), // Rule ID 61186 //
     /*  884220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884266 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  884269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884288 */     GIR_RootConstrainSelectedInstOperands,
     /*  884289 */     // GIR_Coverage, 61186,
     /*  884289 */     GIR_EraseRootFromParent_Done,
     /*  884290 */   // Label 13531: @884290
     /*  884290 */   GIM_Try, /*On fail goto*//*Label 13532*/ GIMT_Encode4(884365), // Rule ID 61187 //
     /*  884295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884341 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  884344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884363 */     GIR_RootConstrainSelectedInstOperands,
     /*  884364 */     // GIR_Coverage, 61187,
     /*  884364 */     GIR_EraseRootFromParent_Done,
     /*  884365 */   // Label 13532: @884365
     /*  884365 */   GIM_Try, /*On fail goto*//*Label 13533*/ GIMT_Encode4(884440), // Rule ID 61190 //
     /*  884370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884416 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  884419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884438 */     GIR_RootConstrainSelectedInstOperands,
     /*  884439 */     // GIR_Coverage, 61190,
     /*  884439 */     GIR_EraseRootFromParent_Done,
     /*  884440 */   // Label 13533: @884440
     /*  884440 */   GIM_Try, /*On fail goto*//*Label 13534*/ GIMT_Encode4(884515), // Rule ID 61191 //
     /*  884445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884491 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  884494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884513 */     GIR_RootConstrainSelectedInstOperands,
     /*  884514 */     // GIR_Coverage, 61191,
     /*  884514 */     GIR_EraseRootFromParent_Done,
     /*  884515 */   // Label 13534: @884515
     /*  884515 */   GIM_Try, /*On fail goto*//*Label 13535*/ GIMT_Encode4(884590), // Rule ID 61194 //
     /*  884520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  884540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  884569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884588 */     GIR_RootConstrainSelectedInstOperands,
     /*  884589 */     // GIR_Coverage, 61194,
     /*  884589 */     GIR_EraseRootFromParent_Done,
     /*  884590 */   // Label 13535: @884590
     /*  884590 */   GIM_Try, /*On fail goto*//*Label 13536*/ GIMT_Encode4(884665), // Rule ID 61195 //
     /*  884595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  884615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884641 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  884644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884663 */     GIR_RootConstrainSelectedInstOperands,
     /*  884664 */     // GIR_Coverage, 61195,
     /*  884664 */     GIR_EraseRootFromParent_Done,
     /*  884665 */   // Label 13536: @884665
     /*  884665 */   GIM_Try, /*On fail goto*//*Label 13537*/ GIMT_Encode4(884740), // Rule ID 61198 //
     /*  884670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  884690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884716 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  884719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884738 */     GIR_RootConstrainSelectedInstOperands,
     /*  884739 */     // GIR_Coverage, 61198,
     /*  884739 */     GIR_EraseRootFromParent_Done,
     /*  884740 */   // Label 13537: @884740
     /*  884740 */   GIM_Try, /*On fail goto*//*Label 13538*/ GIMT_Encode4(884815), // Rule ID 61199 //
     /*  884745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  884765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  884794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884813 */     GIR_RootConstrainSelectedInstOperands,
     /*  884814 */     // GIR_Coverage, 61199,
     /*  884814 */     GIR_EraseRootFromParent_Done,
     /*  884815 */   // Label 13538: @884815
     /*  884815 */   GIM_Try, /*On fail goto*//*Label 13539*/ GIMT_Encode4(884890), // Rule ID 61202 //
     /*  884820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  884840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884866 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  884869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884888 */     GIR_RootConstrainSelectedInstOperands,
     /*  884889 */     // GIR_Coverage, 61202,
     /*  884889 */     GIR_EraseRootFromParent_Done,
     /*  884890 */   // Label 13539: @884890
     /*  884890 */   GIM_Try, /*On fail goto*//*Label 13540*/ GIMT_Encode4(884965), // Rule ID 61203 //
     /*  884895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  884915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884941 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  884944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884963 */     GIR_RootConstrainSelectedInstOperands,
     /*  884964 */     // GIR_Coverage, 61203,
     /*  884964 */     GIR_EraseRootFromParent_Done,
     /*  884965 */   // Label 13540: @884965
     /*  884965 */   GIM_Try, /*On fail goto*//*Label 13541*/ GIMT_Encode4(885040), // Rule ID 61206 //
     /*  884970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  884990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  885019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885038 */     GIR_RootConstrainSelectedInstOperands,
     /*  885039 */     // GIR_Coverage, 61206,
     /*  885039 */     GIR_EraseRootFromParent_Done,
     /*  885040 */   // Label 13541: @885040
     /*  885040 */   GIM_Try, /*On fail goto*//*Label 13542*/ GIMT_Encode4(885115), // Rule ID 61207 //
     /*  885045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  885056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  885059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  885062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  885065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885091 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  885094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885113 */     GIR_RootConstrainSelectedInstOperands,
     /*  885114 */     // GIR_Coverage, 61207,
     /*  885114 */     GIR_EraseRootFromParent_Done,
     /*  885115 */   // Label 13542: @885115
     /*  885115 */   GIM_Try, /*On fail goto*//*Label 13543*/ GIMT_Encode4(885190), // Rule ID 61210 //
     /*  885120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  885123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  885131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  885134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  885137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885166 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  885169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885188 */     GIR_RootConstrainSelectedInstOperands,
     /*  885189 */     // GIR_Coverage, 61210,
     /*  885189 */     GIR_EraseRootFromParent_Done,
     /*  885190 */   // Label 13543: @885190
     /*  885190 */   GIM_Try, /*On fail goto*//*Label 13544*/ GIMT_Encode4(885265), // Rule ID 61211 //
     /*  885195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  885206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  885209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  885212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885241 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  885244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885263 */     GIR_RootConstrainSelectedInstOperands,
     /*  885264 */     // GIR_Coverage, 61211,
     /*  885264 */     GIR_EraseRootFromParent_Done,
     /*  885265 */   // Label 13544: @885265
     /*  885265 */   GIM_Try, /*On fail goto*//*Label 13545*/ GIMT_Encode4(885340), // Rule ID 61214 //
     /*  885270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  885273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  885281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  885284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  885287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  885319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885338 */     GIR_RootConstrainSelectedInstOperands,
     /*  885339 */     // GIR_Coverage, 61214,
     /*  885339 */     GIR_EraseRootFromParent_Done,
     /*  885340 */   // Label 13545: @885340
     /*  885340 */   GIM_Try, /*On fail goto*//*Label 13546*/ GIMT_Encode4(885415), // Rule ID 61215 //
     /*  885345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  885356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  885359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  885362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885391 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  885394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885413 */     GIR_RootConstrainSelectedInstOperands,
     /*  885414 */     // GIR_Coverage, 61215,
     /*  885414 */     GIR_EraseRootFromParent_Done,
     /*  885415 */   // Label 13546: @885415
     /*  885415 */   GIM_Try, /*On fail goto*//*Label 13547*/ GIMT_Encode4(885490), // Rule ID 61218 //
     /*  885420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  885423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  885431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  885434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  885437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885466 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  885469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885488 */     GIR_RootConstrainSelectedInstOperands,
     /*  885489 */     // GIR_Coverage, 61218,
     /*  885489 */     GIR_EraseRootFromParent_Done,
     /*  885490 */   // Label 13547: @885490
     /*  885490 */   GIM_Try, /*On fail goto*//*Label 13548*/ GIMT_Encode4(885565), // Rule ID 61219 //
     /*  885495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  885506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  885509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  885512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885541 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  885544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885563 */     GIR_RootConstrainSelectedInstOperands,
     /*  885564 */     // GIR_Coverage, 61219,
     /*  885564 */     GIR_EraseRootFromParent_Done,
     /*  885565 */   // Label 13548: @885565
     /*  885565 */   GIM_Try, /*On fail goto*//*Label 13549*/ GIMT_Encode4(885640), // Rule ID 61222 //
     /*  885570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  885573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  885581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  885584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  885587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885616 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  885619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885638 */     GIR_RootConstrainSelectedInstOperands,
     /*  885639 */     // GIR_Coverage, 61222,
     /*  885639 */     GIR_EraseRootFromParent_Done,
     /*  885640 */   // Label 13549: @885640
     /*  885640 */   GIM_Try, /*On fail goto*//*Label 13550*/ GIMT_Encode4(885715), // Rule ID 61223 //
     /*  885645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  885656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  885659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  885662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885691 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  885694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885713 */     GIR_RootConstrainSelectedInstOperands,
     /*  885714 */     // GIR_Coverage, 61223,
     /*  885714 */     GIR_EraseRootFromParent_Done,
     /*  885715 */   // Label 13550: @885715
     /*  885715 */   GIM_Try, /*On fail goto*//*Label 13551*/ GIMT_Encode4(885790), // Rule ID 61226 //
     /*  885720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  885731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  885734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  885737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  885740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885766 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  885769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885788 */     GIR_RootConstrainSelectedInstOperands,
     /*  885789 */     // GIR_Coverage, 61226,
     /*  885789 */     GIR_EraseRootFromParent_Done,
     /*  885790 */   // Label 13551: @885790
     /*  885790 */   GIM_Try, /*On fail goto*//*Label 13552*/ GIMT_Encode4(885865), // Rule ID 61227 //
     /*  885795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  885806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  885809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  885812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  885815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885841 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  885844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885863 */     GIR_RootConstrainSelectedInstOperands,
     /*  885864 */     // GIR_Coverage, 61227,
     /*  885864 */     GIR_EraseRootFromParent_Done,
     /*  885865 */   // Label 13552: @885865
     /*  885865 */   GIM_Try, /*On fail goto*//*Label 13553*/ GIMT_Encode4(885940), // Rule ID 61230 //
     /*  885870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  885881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  885884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  885887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  885890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885916 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885938 */     GIR_RootConstrainSelectedInstOperands,
     /*  885939 */     // GIR_Coverage, 61230,
     /*  885939 */     GIR_EraseRootFromParent_Done,
     /*  885940 */   // Label 13553: @885940
     /*  885940 */   GIM_Try, /*On fail goto*//*Label 13554*/ GIMT_Encode4(886015), // Rule ID 61231 //
     /*  885945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  885956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  885959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  885962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  885965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885991 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886013 */     GIR_RootConstrainSelectedInstOperands,
     /*  886014 */     // GIR_Coverage, 61231,
     /*  886014 */     GIR_EraseRootFromParent_Done,
     /*  886015 */   // Label 13554: @886015
     /*  886015 */   GIM_Try, /*On fail goto*//*Label 13555*/ GIMT_Encode4(886090), // Rule ID 61234 //
     /*  886020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  886031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  886034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  886037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  886040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886066 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886088 */     GIR_RootConstrainSelectedInstOperands,
     /*  886089 */     // GIR_Coverage, 61234,
     /*  886089 */     GIR_EraseRootFromParent_Done,
     /*  886090 */   // Label 13555: @886090
     /*  886090 */   GIM_Try, /*On fail goto*//*Label 13556*/ GIMT_Encode4(886165), // Rule ID 61235 //
     /*  886095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  886106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  886109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  886112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  886115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886141 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  886141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886163 */     GIR_RootConstrainSelectedInstOperands,
     /*  886164 */     // GIR_Coverage, 61235,
     /*  886164 */     GIR_EraseRootFromParent_Done,
     /*  886165 */   // Label 13556: @886165
     /*  886165 */   GIM_Try, /*On fail goto*//*Label 13557*/ GIMT_Encode4(886240), // Rule ID 61238 //
     /*  886170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  886181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  886184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  886187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  886190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886216 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  886216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  886219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886238 */     GIR_RootConstrainSelectedInstOperands,
     /*  886239 */     // GIR_Coverage, 61238,
     /*  886239 */     GIR_EraseRootFromParent_Done,
     /*  886240 */   // Label 13557: @886240
     /*  886240 */   GIM_Try, /*On fail goto*//*Label 13558*/ GIMT_Encode4(886315), // Rule ID 61239 //
     /*  886245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  886256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  886259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  886262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  886265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886291 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  886291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  886294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886313 */     GIR_RootConstrainSelectedInstOperands,
     /*  886314 */     // GIR_Coverage, 61239,
     /*  886314 */     GIR_EraseRootFromParent_Done,
     /*  886315 */   // Label 13558: @886315
     /*  886315 */   GIM_Try, /*On fail goto*//*Label 13559*/ GIMT_Encode4(886390), // Rule ID 61242 //
     /*  886320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  886331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  886334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  886337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  886340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  886366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886388 */     GIR_RootConstrainSelectedInstOperands,
     /*  886389 */     // GIR_Coverage, 61242,
     /*  886389 */     GIR_EraseRootFromParent_Done,
     /*  886390 */   // Label 13559: @886390
     /*  886390 */   GIM_Try, /*On fail goto*//*Label 13560*/ GIMT_Encode4(886465), // Rule ID 61243 //
     /*  886395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  886406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  886409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  886412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  886415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886441 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  886441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886463 */     GIR_RootConstrainSelectedInstOperands,
     /*  886464 */     // GIR_Coverage, 61243,
     /*  886464 */     GIR_EraseRootFromParent_Done,
     /*  886465 */   // Label 13560: @886465
     /*  886465 */   GIM_Try, /*On fail goto*//*Label 13561*/ GIMT_Encode4(886540), // Rule ID 61246 //
     /*  886470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  886481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  886484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  886490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886516 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886538 */     GIR_RootConstrainSelectedInstOperands,
     /*  886539 */     // GIR_Coverage, 61246,
     /*  886539 */     GIR_EraseRootFromParent_Done,
     /*  886540 */   // Label 13561: @886540
     /*  886540 */   GIM_Try, /*On fail goto*//*Label 13562*/ GIMT_Encode4(886615), // Rule ID 61247 //
     /*  886545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  886556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  886559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  886565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886591 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886613 */     GIR_RootConstrainSelectedInstOperands,
     /*  886614 */     // GIR_Coverage, 61247,
     /*  886614 */     GIR_EraseRootFromParent_Done,
     /*  886615 */   // Label 13562: @886615
     /*  886615 */   GIM_Try, /*On fail goto*//*Label 13563*/ GIMT_Encode4(886690), // Rule ID 61250 //
     /*  886620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  886631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  886634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  886637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  886640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886666 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886688 */     GIR_RootConstrainSelectedInstOperands,
     /*  886689 */     // GIR_Coverage, 61250,
     /*  886689 */     GIR_EraseRootFromParent_Done,
     /*  886690 */   // Label 13563: @886690
     /*  886690 */   GIM_Try, /*On fail goto*//*Label 13564*/ GIMT_Encode4(886765), // Rule ID 61251 //
     /*  886695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  886706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  886709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  886712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  886715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886741 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  886741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886763 */     GIR_RootConstrainSelectedInstOperands,
     /*  886764 */     // GIR_Coverage, 61251,
     /*  886764 */     GIR_EraseRootFromParent_Done,
     /*  886765 */   // Label 13564: @886765
     /*  886765 */   GIM_Try, /*On fail goto*//*Label 13565*/ GIMT_Encode4(886840), // Rule ID 61254 //
     /*  886770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  886781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  886784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  886787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  886790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886816 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  886816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886838 */     GIR_RootConstrainSelectedInstOperands,
     /*  886839 */     // GIR_Coverage, 61254,
     /*  886839 */     GIR_EraseRootFromParent_Done,
     /*  886840 */   // Label 13565: @886840
     /*  886840 */   GIM_Try, /*On fail goto*//*Label 13566*/ GIMT_Encode4(886915), // Rule ID 61255 //
     /*  886845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  886856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  886859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  886862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  886865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886891 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  886891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886913 */     GIR_RootConstrainSelectedInstOperands,
     /*  886914 */     // GIR_Coverage, 61255,
     /*  886914 */     GIR_EraseRootFromParent_Done,
     /*  886915 */   // Label 13566: @886915
     /*  886915 */   GIM_Try, /*On fail goto*//*Label 13567*/ GIMT_Encode4(886990), // Rule ID 61258 //
     /*  886920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  886931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  886934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  886937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  886940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886988 */     GIR_RootConstrainSelectedInstOperands,
     /*  886989 */     // GIR_Coverage, 61258,
     /*  886989 */     GIR_EraseRootFromParent_Done,
     /*  886990 */   // Label 13567: @886990
     /*  886990 */   GIM_Try, /*On fail goto*//*Label 13568*/ GIMT_Encode4(887065), // Rule ID 61259 //
     /*  886995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  887006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  887009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  887012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  887015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887041 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  887041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  887044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887063 */     GIR_RootConstrainSelectedInstOperands,
     /*  887064 */     // GIR_Coverage, 61259,
     /*  887064 */     GIR_EraseRootFromParent_Done,
     /*  887065 */   // Label 13568: @887065
     /*  887065 */   GIM_Try, /*On fail goto*//*Label 13569*/ GIMT_Encode4(887140), // Rule ID 61262 //
     /*  887070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  887081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  887084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  887090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887116 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  887119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887138 */     GIR_RootConstrainSelectedInstOperands,
     /*  887139 */     // GIR_Coverage, 61262,
     /*  887139 */     GIR_EraseRootFromParent_Done,
     /*  887140 */   // Label 13569: @887140
     /*  887140 */   GIM_Try, /*On fail goto*//*Label 13570*/ GIMT_Encode4(887215), // Rule ID 61263 //
     /*  887145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  887156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  887159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  887165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887191 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  887194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887213 */     GIR_RootConstrainSelectedInstOperands,
     /*  887214 */     // GIR_Coverage, 61263,
     /*  887214 */     GIR_EraseRootFromParent_Done,
     /*  887215 */   // Label 13570: @887215
     /*  887215 */   GIM_Try, /*On fail goto*//*Label 13571*/ GIMT_Encode4(887290), // Rule ID 61266 //
     /*  887220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  887231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  887234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  887237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  887240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  887266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887288 */     GIR_RootConstrainSelectedInstOperands,
     /*  887289 */     // GIR_Coverage, 61266,
     /*  887289 */     GIR_EraseRootFromParent_Done,
     /*  887290 */   // Label 13571: @887290
     /*  887290 */   GIM_Try, /*On fail goto*//*Label 13572*/ GIMT_Encode4(887365), // Rule ID 61267 //
     /*  887295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  887306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  887309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  887312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  887315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887341 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  887341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887363 */     GIR_RootConstrainSelectedInstOperands,
     /*  887364 */     // GIR_Coverage, 61267,
     /*  887364 */     GIR_EraseRootFromParent_Done,
     /*  887365 */   // Label 13572: @887365
     /*  887365 */   GIM_Try, /*On fail goto*//*Label 13573*/ GIMT_Encode4(887440), // Rule ID 61270 //
     /*  887370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  887381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  887384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  887387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  887390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887416 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  887416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887438 */     GIR_RootConstrainSelectedInstOperands,
     /*  887439 */     // GIR_Coverage, 61270,
     /*  887439 */     GIR_EraseRootFromParent_Done,
     /*  887440 */   // Label 13573: @887440
     /*  887440 */   GIM_Try, /*On fail goto*//*Label 13574*/ GIMT_Encode4(887515), // Rule ID 61271 //
     /*  887445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  887456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  887459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  887462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  887465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887491 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  887491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887513 */     GIR_RootConstrainSelectedInstOperands,
     /*  887514 */     // GIR_Coverage, 61271,
     /*  887514 */     GIR_EraseRootFromParent_Done,
     /*  887515 */   // Label 13574: @887515
     /*  887515 */   GIM_Try, /*On fail goto*//*Label 13575*/ GIMT_Encode4(887590), // Rule ID 61274 //
     /*  887520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  887531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  887534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  887537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  887540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887566 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  887566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887588 */     GIR_RootConstrainSelectedInstOperands,
     /*  887589 */     // GIR_Coverage, 61274,
     /*  887589 */     GIR_EraseRootFromParent_Done,
     /*  887590 */   // Label 13575: @887590
     /*  887590 */   GIM_Try, /*On fail goto*//*Label 13576*/ GIMT_Encode4(887665), // Rule ID 61275 //
     /*  887595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  887606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  887609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  887612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  887615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887641 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  887641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887663 */     GIR_RootConstrainSelectedInstOperands,
     /*  887664 */     // GIR_Coverage, 61275,
     /*  887664 */     GIR_EraseRootFromParent_Done,
     /*  887665 */   // Label 13576: @887665
     /*  887665 */   GIM_Try, /*On fail goto*//*Label 13577*/ GIMT_Encode4(887740), // Rule ID 61278 //
     /*  887670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  887681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  887684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  887687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  887690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  887716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887738 */     GIR_RootConstrainSelectedInstOperands,
     /*  887739 */     // GIR_Coverage, 61278,
     /*  887739 */     GIR_EraseRootFromParent_Done,
     /*  887740 */   // Label 13577: @887740
     /*  887740 */   GIM_Try, /*On fail goto*//*Label 13578*/ GIMT_Encode4(887815), // Rule ID 61279 //
     /*  887745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  887756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  887759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  887762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  887765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  887791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887813 */     GIR_RootConstrainSelectedInstOperands,
     /*  887814 */     // GIR_Coverage, 61279,
     /*  887814 */     GIR_EraseRootFromParent_Done,
     /*  887815 */   // Label 13578: @887815
     /*  887815 */   GIM_Try, /*On fail goto*//*Label 13579*/ GIMT_Encode4(887890), // Rule ID 61282 //
     /*  887820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  887831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  887834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  887837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  887840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  887866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887888 */     GIR_RootConstrainSelectedInstOperands,
     /*  887889 */     // GIR_Coverage, 61282,
     /*  887889 */     GIR_EraseRootFromParent_Done,
     /*  887890 */   // Label 13579: @887890
     /*  887890 */   GIM_Try, /*On fail goto*//*Label 13580*/ GIMT_Encode4(887965), // Rule ID 61283 //
     /*  887895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  887906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  887909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  887912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  887915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887941 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  887941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887963 */     GIR_RootConstrainSelectedInstOperands,
     /*  887964 */     // GIR_Coverage, 61283,
     /*  887964 */     GIR_EraseRootFromParent_Done,
     /*  887965 */   // Label 13580: @887965
     /*  887965 */   GIM_Try, /*On fail goto*//*Label 13581*/ GIMT_Encode4(888040), // Rule ID 61286 //
     /*  887970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  887981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  887984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  887987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  887990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888016 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  888016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888038 */     GIR_RootConstrainSelectedInstOperands,
     /*  888039 */     // GIR_Coverage, 61286,
     /*  888039 */     GIR_EraseRootFromParent_Done,
     /*  888040 */   // Label 13581: @888040
     /*  888040 */   GIM_Try, /*On fail goto*//*Label 13582*/ GIMT_Encode4(888115), // Rule ID 61287 //
     /*  888045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  888056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  888059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  888062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  888065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888091 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  888091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888113 */     GIR_RootConstrainSelectedInstOperands,
     /*  888114 */     // GIR_Coverage, 61287,
     /*  888114 */     GIR_EraseRootFromParent_Done,
     /*  888115 */   // Label 13582: @888115
     /*  888115 */   GIM_Try, /*On fail goto*//*Label 13583*/ GIMT_Encode4(888190), // Rule ID 61290 //
     /*  888120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  888131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  888134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  888137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  888140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  888166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  888169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888188 */     GIR_RootConstrainSelectedInstOperands,
     /*  888189 */     // GIR_Coverage, 61290,
     /*  888189 */     GIR_EraseRootFromParent_Done,
     /*  888190 */   // Label 13583: @888190
     /*  888190 */   GIM_Try, /*On fail goto*//*Label 13584*/ GIMT_Encode4(888265), // Rule ID 61291 //
     /*  888195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  888206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  888209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  888212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  888215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888241 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  888241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  888244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888263 */     GIR_RootConstrainSelectedInstOperands,
     /*  888264 */     // GIR_Coverage, 61291,
     /*  888264 */     GIR_EraseRootFromParent_Done,
     /*  888265 */   // Label 13584: @888265
     /*  888265 */   GIM_Try, /*On fail goto*//*Label 13585*/ GIMT_Encode4(888340), // Rule ID 61294 //
     /*  888270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  888281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  888284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  888287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  888290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888316 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  888316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  888319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888338 */     GIR_RootConstrainSelectedInstOperands,
     /*  888339 */     // GIR_Coverage, 61294,
     /*  888339 */     GIR_EraseRootFromParent_Done,
     /*  888340 */   // Label 13585: @888340
     /*  888340 */   GIM_Try, /*On fail goto*//*Label 13586*/ GIMT_Encode4(888415), // Rule ID 61295 //
     /*  888345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  888356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  888359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  888362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  888365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888391 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  888391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  888394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888413 */     GIR_RootConstrainSelectedInstOperands,
     /*  888414 */     // GIR_Coverage, 61295,
     /*  888414 */     GIR_EraseRootFromParent_Done,
     /*  888415 */   // Label 13586: @888415
     /*  888415 */   GIM_Try, /*On fail goto*//*Label 13587*/ GIMT_Encode4(888490), // Rule ID 61298 //
     /*  888420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  888431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  888434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  888437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  888440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888466 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  888466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888488 */     GIR_RootConstrainSelectedInstOperands,
     /*  888489 */     // GIR_Coverage, 61298,
     /*  888489 */     GIR_EraseRootFromParent_Done,
     /*  888490 */   // Label 13587: @888490
     /*  888490 */   GIM_Try, /*On fail goto*//*Label 13588*/ GIMT_Encode4(888565), // Rule ID 61299 //
     /*  888495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  888506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  888509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  888512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  888515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888541 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  888541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888563 */     GIR_RootConstrainSelectedInstOperands,
     /*  888564 */     // GIR_Coverage, 61299,
     /*  888564 */     GIR_EraseRootFromParent_Done,
     /*  888565 */   // Label 13588: @888565
     /*  888565 */   GIM_Try, /*On fail goto*//*Label 13589*/ GIMT_Encode4(888640), // Rule ID 61302 //
     /*  888570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  888590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  888619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888638 */     GIR_RootConstrainSelectedInstOperands,
     /*  888639 */     // GIR_Coverage, 61302,
     /*  888639 */     GIR_EraseRootFromParent_Done,
     /*  888640 */   // Label 13589: @888640
     /*  888640 */   GIM_Try, /*On fail goto*//*Label 13590*/ GIMT_Encode4(888715), // Rule ID 61303 //
     /*  888645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  888665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888691 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  888694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888713 */     GIR_RootConstrainSelectedInstOperands,
     /*  888714 */     // GIR_Coverage, 61303,
     /*  888714 */     GIR_EraseRootFromParent_Done,
     /*  888715 */   // Label 13590: @888715
     /*  888715 */   GIM_Try, /*On fail goto*//*Label 13591*/ GIMT_Encode4(888790), // Rule ID 61306 //
     /*  888720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  888740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888766 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  888769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888788 */     GIR_RootConstrainSelectedInstOperands,
     /*  888789 */     // GIR_Coverage, 61306,
     /*  888789 */     GIR_EraseRootFromParent_Done,
     /*  888790 */   // Label 13591: @888790
     /*  888790 */   GIM_Try, /*On fail goto*//*Label 13592*/ GIMT_Encode4(888865), // Rule ID 61307 //
     /*  888795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  888815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888841 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  888844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888863 */     GIR_RootConstrainSelectedInstOperands,
     /*  888864 */     // GIR_Coverage, 61307,
     /*  888864 */     GIR_EraseRootFromParent_Done,
     /*  888865 */   // Label 13592: @888865
     /*  888865 */   GIM_Try, /*On fail goto*//*Label 13593*/ GIMT_Encode4(888940), // Rule ID 61310 //
     /*  888870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  888890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888916 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888938 */     GIR_RootConstrainSelectedInstOperands,
     /*  888939 */     // GIR_Coverage, 61310,
     /*  888939 */     GIR_EraseRootFromParent_Done,
     /*  888940 */   // Label 13593: @888940
     /*  888940 */   GIM_Try, /*On fail goto*//*Label 13594*/ GIMT_Encode4(889015), // Rule ID 61311 //
     /*  888945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  888965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888991 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889013 */     GIR_RootConstrainSelectedInstOperands,
     /*  889014 */     // GIR_Coverage, 61311,
     /*  889014 */     GIR_EraseRootFromParent_Done,
     /*  889015 */   // Label 13594: @889015
     /*  889015 */   GIM_Try, /*On fail goto*//*Label 13595*/ GIMT_Encode4(889090), // Rule ID 61314 //
     /*  889020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  889031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  889034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  889037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889066 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  889069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889088 */     GIR_RootConstrainSelectedInstOperands,
     /*  889089 */     // GIR_Coverage, 61314,
     /*  889089 */     GIR_EraseRootFromParent_Done,
     /*  889090 */   // Label 13595: @889090
     /*  889090 */   GIM_Try, /*On fail goto*//*Label 13596*/ GIMT_Encode4(889165), // Rule ID 61315 //
     /*  889095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  889106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  889109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  889112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889141 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  889144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889163 */     GIR_RootConstrainSelectedInstOperands,
     /*  889164 */     // GIR_Coverage, 61315,
     /*  889164 */     GIR_EraseRootFromParent_Done,
     /*  889165 */   // Label 13596: @889165
     /*  889165 */   GIM_Try, /*On fail goto*//*Label 13597*/ GIMT_Encode4(889240), // Rule ID 61318 //
     /*  889170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  889181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  889184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  889187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889216 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  889219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889238 */     GIR_RootConstrainSelectedInstOperands,
     /*  889239 */     // GIR_Coverage, 61318,
     /*  889239 */     GIR_EraseRootFromParent_Done,
     /*  889240 */   // Label 13597: @889240
     /*  889240 */   GIM_Try, /*On fail goto*//*Label 13598*/ GIMT_Encode4(889315), // Rule ID 61319 //
     /*  889245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  889256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  889259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  889262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889291 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  889294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889313 */     GIR_RootConstrainSelectedInstOperands,
     /*  889314 */     // GIR_Coverage, 61319,
     /*  889314 */     GIR_EraseRootFromParent_Done,
     /*  889315 */   // Label 13598: @889315
     /*  889315 */   GIM_Try, /*On fail goto*//*Label 13599*/ GIMT_Encode4(889390), // Rule ID 61322 //
     /*  889320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  889331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  889334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  889337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889366 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889388 */     GIR_RootConstrainSelectedInstOperands,
     /*  889389 */     // GIR_Coverage, 61322,
     /*  889389 */     GIR_EraseRootFromParent_Done,
     /*  889390 */   // Label 13599: @889390
     /*  889390 */   GIM_Try, /*On fail goto*//*Label 13600*/ GIMT_Encode4(889465), // Rule ID 61323 //
     /*  889395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  889406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  889409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  889412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889441 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889463 */     GIR_RootConstrainSelectedInstOperands,
     /*  889464 */     // GIR_Coverage, 61323,
     /*  889464 */     GIR_EraseRootFromParent_Done,
     /*  889465 */   // Label 13600: @889465
     /*  889465 */   GIM_Try, /*On fail goto*//*Label 13601*/ GIMT_Encode4(889540), // Rule ID 61326 //
     /*  889470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  889481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  889484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  889487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889516 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  889519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889538 */     GIR_RootConstrainSelectedInstOperands,
     /*  889539 */     // GIR_Coverage, 61326,
     /*  889539 */     GIR_EraseRootFromParent_Done,
     /*  889540 */   // Label 13601: @889540
     /*  889540 */   GIM_Try, /*On fail goto*//*Label 13602*/ GIMT_Encode4(889615), // Rule ID 61327 //
     /*  889545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  889556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  889559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  889562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889591 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  889594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889613 */     GIR_RootConstrainSelectedInstOperands,
     /*  889614 */     // GIR_Coverage, 61327,
     /*  889614 */     GIR_EraseRootFromParent_Done,
     /*  889615 */   // Label 13602: @889615
     /*  889615 */   GIM_Try, /*On fail goto*//*Label 13603*/ GIMT_Encode4(889690), // Rule ID 61330 //
     /*  889620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  889631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  889634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  889637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889666 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889688 */     GIR_RootConstrainSelectedInstOperands,
     /*  889689 */     // GIR_Coverage, 61330,
     /*  889689 */     GIR_EraseRootFromParent_Done,
     /*  889690 */   // Label 13603: @889690
     /*  889690 */   GIM_Try, /*On fail goto*//*Label 13604*/ GIMT_Encode4(889765), // Rule ID 61331 //
     /*  889695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  889706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  889709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  889712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889741 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889763 */     GIR_RootConstrainSelectedInstOperands,
     /*  889764 */     // GIR_Coverage, 61331,
     /*  889764 */     GIR_EraseRootFromParent_Done,
     /*  889765 */   // Label 13604: @889765
     /*  889765 */   GIM_Try, /*On fail goto*//*Label 13605*/ GIMT_Encode4(889840), // Rule ID 61334 //
     /*  889770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  889781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  889784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  889787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889816 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  889816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889838 */     GIR_RootConstrainSelectedInstOperands,
     /*  889839 */     // GIR_Coverage, 61334,
     /*  889839 */     GIR_EraseRootFromParent_Done,
     /*  889840 */   // Label 13605: @889840
     /*  889840 */   GIM_Try, /*On fail goto*//*Label 13606*/ GIMT_Encode4(889915), // Rule ID 61335 //
     /*  889845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  889856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  889859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  889862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889891 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  889891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889913 */     GIR_RootConstrainSelectedInstOperands,
     /*  889914 */     // GIR_Coverage, 61335,
     /*  889914 */     GIR_EraseRootFromParent_Done,
     /*  889915 */   // Label 13606: @889915
     /*  889915 */   GIM_Try, /*On fail goto*//*Label 13607*/ GIMT_Encode4(889990), // Rule ID 61338 //
     /*  889920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  889931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  889934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  889937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889966 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889988 */     GIR_RootConstrainSelectedInstOperands,
     /*  889989 */     // GIR_Coverage, 61338,
     /*  889989 */     GIR_EraseRootFromParent_Done,
     /*  889990 */   // Label 13607: @889990
     /*  889990 */   GIM_Try, /*On fail goto*//*Label 13608*/ GIMT_Encode4(890065), // Rule ID 61339 //
     /*  889995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  890006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  890009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  890012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890041 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890063 */     GIR_RootConstrainSelectedInstOperands,
     /*  890064 */     // GIR_Coverage, 61339,
     /*  890064 */     GIR_EraseRootFromParent_Done,
     /*  890065 */   // Label 13608: @890065
     /*  890065 */   GIM_Try, /*On fail goto*//*Label 13609*/ GIMT_Encode4(890140), // Rule ID 61342 //
     /*  890070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  890081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  890084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  890087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890116 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890138 */     GIR_RootConstrainSelectedInstOperands,
     /*  890139 */     // GIR_Coverage, 61342,
     /*  890139 */     GIR_EraseRootFromParent_Done,
     /*  890140 */   // Label 13609: @890140
     /*  890140 */   GIM_Try, /*On fail goto*//*Label 13610*/ GIMT_Encode4(890215), // Rule ID 61343 //
     /*  890145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  890156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  890159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  890162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890191 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890213 */     GIR_RootConstrainSelectedInstOperands,
     /*  890214 */     // GIR_Coverage, 61343,
     /*  890214 */     GIR_EraseRootFromParent_Done,
     /*  890215 */   // Label 13610: @890215
     /*  890215 */   GIM_Try, /*On fail goto*//*Label 13611*/ GIMT_Encode4(890290), // Rule ID 61346 //
     /*  890220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  890231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  890234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  890237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890266 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  890266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890288 */     GIR_RootConstrainSelectedInstOperands,
     /*  890289 */     // GIR_Coverage, 61346,
     /*  890289 */     GIR_EraseRootFromParent_Done,
     /*  890290 */   // Label 13611: @890290
     /*  890290 */   GIM_Try, /*On fail goto*//*Label 13612*/ GIMT_Encode4(890365), // Rule ID 61347 //
     /*  890295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  890306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  890309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  890312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890341 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  890341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890363 */     GIR_RootConstrainSelectedInstOperands,
     /*  890364 */     // GIR_Coverage, 61347,
     /*  890364 */     GIR_EraseRootFromParent_Done,
     /*  890365 */   // Label 13612: @890365
     /*  890365 */   GIM_Try, /*On fail goto*//*Label 13613*/ GIMT_Encode4(890440), // Rule ID 61350 //
     /*  890370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  890381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  890384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  890387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890416 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  890416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890438 */     GIR_RootConstrainSelectedInstOperands,
     /*  890439 */     // GIR_Coverage, 61350,
     /*  890439 */     GIR_EraseRootFromParent_Done,
     /*  890440 */   // Label 13613: @890440
     /*  890440 */   GIM_Try, /*On fail goto*//*Label 13614*/ GIMT_Encode4(890515), // Rule ID 61351 //
     /*  890445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  890456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  890459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  890462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890491 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  890491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890513 */     GIR_RootConstrainSelectedInstOperands,
     /*  890514 */     // GIR_Coverage, 61351,
     /*  890514 */     GIR_EraseRootFromParent_Done,
     /*  890515 */   // Label 13614: @890515
     /*  890515 */   GIM_Try, /*On fail goto*//*Label 13615*/ GIMT_Encode4(890590), // Rule ID 61354 //
     /*  890520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  890531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  890534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  890537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890566 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890588 */     GIR_RootConstrainSelectedInstOperands,
     /*  890589 */     // GIR_Coverage, 61354,
     /*  890589 */     GIR_EraseRootFromParent_Done,
     /*  890590 */   // Label 13615: @890590
     /*  890590 */   GIM_Try, /*On fail goto*//*Label 13616*/ GIMT_Encode4(890665), // Rule ID 61355 //
     /*  890595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  890606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  890609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  890612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890641 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890663 */     GIR_RootConstrainSelectedInstOperands,
     /*  890664 */     // GIR_Coverage, 61355,
     /*  890664 */     GIR_EraseRootFromParent_Done,
     /*  890665 */   // Label 13616: @890665
     /*  890665 */   GIM_Try, /*On fail goto*//*Label 13617*/ GIMT_Encode4(890740), // Rule ID 61358 //
     /*  890670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  890681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  890684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  890687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890716 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890738 */     GIR_RootConstrainSelectedInstOperands,
     /*  890739 */     // GIR_Coverage, 61358,
     /*  890739 */     GIR_EraseRootFromParent_Done,
     /*  890740 */   // Label 13617: @890740
     /*  890740 */   GIM_Try, /*On fail goto*//*Label 13618*/ GIMT_Encode4(890815), // Rule ID 61359 //
     /*  890745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  890756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  890759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  890762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890791 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890813 */     GIR_RootConstrainSelectedInstOperands,
     /*  890814 */     // GIR_Coverage, 61359,
     /*  890814 */     GIR_EraseRootFromParent_Done,
     /*  890815 */   // Label 13618: @890815
     /*  890815 */   GIM_Try, /*On fail goto*//*Label 13619*/ GIMT_Encode4(890890), // Rule ID 61362 //
     /*  890820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  890831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  890834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  890837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890866 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890888 */     GIR_RootConstrainSelectedInstOperands,
     /*  890889 */     // GIR_Coverage, 61362,
     /*  890889 */     GIR_EraseRootFromParent_Done,
     /*  890890 */   // Label 13619: @890890
     /*  890890 */   GIM_Try, /*On fail goto*//*Label 13620*/ GIMT_Encode4(890965), // Rule ID 61363 //
     /*  890895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  890906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  890909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  890912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890941 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890963 */     GIR_RootConstrainSelectedInstOperands,
     /*  890964 */     // GIR_Coverage, 61363,
     /*  890964 */     GIR_EraseRootFromParent_Done,
     /*  890965 */   // Label 13620: @890965
     /*  890965 */   GIM_Try, /*On fail goto*//*Label 13621*/ GIMT_Encode4(891040), // Rule ID 61366 //
     /*  890970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  890981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  890984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  890987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891016 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891038 */     GIR_RootConstrainSelectedInstOperands,
     /*  891039 */     // GIR_Coverage, 61366,
     /*  891039 */     GIR_EraseRootFromParent_Done,
     /*  891040 */   // Label 13621: @891040
     /*  891040 */   GIM_Try, /*On fail goto*//*Label 13622*/ GIMT_Encode4(891115), // Rule ID 61367 //
     /*  891045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  891056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  891059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  891062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891113 */     GIR_RootConstrainSelectedInstOperands,
     /*  891114 */     // GIR_Coverage, 61367,
     /*  891114 */     GIR_EraseRootFromParent_Done,
     /*  891115 */   // Label 13622: @891115
     /*  891115 */   GIM_Try, /*On fail goto*//*Label 13623*/ GIMT_Encode4(891190), // Rule ID 61370 //
     /*  891120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  891131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  891134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  891137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891166 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891188 */     GIR_RootConstrainSelectedInstOperands,
     /*  891189 */     // GIR_Coverage, 61370,
     /*  891189 */     GIR_EraseRootFromParent_Done,
     /*  891190 */   // Label 13623: @891190
     /*  891190 */   GIM_Try, /*On fail goto*//*Label 13624*/ GIMT_Encode4(891265), // Rule ID 61371 //
     /*  891195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  891206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  891209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  891212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891241 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891263 */     GIR_RootConstrainSelectedInstOperands,
     /*  891264 */     // GIR_Coverage, 61371,
     /*  891264 */     GIR_EraseRootFromParent_Done,
     /*  891265 */   // Label 13624: @891265
     /*  891265 */   GIM_Try, /*On fail goto*//*Label 13625*/ GIMT_Encode4(891340), // Rule ID 61374 //
     /*  891270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  891281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  891284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  891287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891316 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891338 */     GIR_RootConstrainSelectedInstOperands,
     /*  891339 */     // GIR_Coverage, 61374,
     /*  891339 */     GIR_EraseRootFromParent_Done,
     /*  891340 */   // Label 13625: @891340
     /*  891340 */   GIM_Try, /*On fail goto*//*Label 13626*/ GIMT_Encode4(891415), // Rule ID 61375 //
     /*  891345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  891356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  891359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  891362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891391 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891413 */     GIR_RootConstrainSelectedInstOperands,
     /*  891414 */     // GIR_Coverage, 61375,
     /*  891414 */     GIR_EraseRootFromParent_Done,
     /*  891415 */   // Label 13626: @891415
     /*  891415 */   GIM_Try, /*On fail goto*//*Label 13627*/ GIMT_Encode4(891490), // Rule ID 61378 //
     /*  891420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  891431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  891434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  891437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891466 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891488 */     GIR_RootConstrainSelectedInstOperands,
     /*  891489 */     // GIR_Coverage, 61378,
     /*  891489 */     GIR_EraseRootFromParent_Done,
     /*  891490 */   // Label 13627: @891490
     /*  891490 */   GIM_Try, /*On fail goto*//*Label 13628*/ GIMT_Encode4(891565), // Rule ID 61379 //
     /*  891495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  891506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  891509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  891512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891563 */     GIR_RootConstrainSelectedInstOperands,
     /*  891564 */     // GIR_Coverage, 61379,
     /*  891564 */     GIR_EraseRootFromParent_Done,
     /*  891565 */   // Label 13628: @891565
     /*  891565 */   GIM_Try, /*On fail goto*//*Label 13629*/ GIMT_Encode4(891640), // Rule ID 61382 //
     /*  891570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  891581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  891584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  891587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891616 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891638 */     GIR_RootConstrainSelectedInstOperands,
     /*  891639 */     // GIR_Coverage, 61382,
     /*  891639 */     GIR_EraseRootFromParent_Done,
     /*  891640 */   // Label 13629: @891640
     /*  891640 */   GIM_Try, /*On fail goto*//*Label 13630*/ GIMT_Encode4(891715), // Rule ID 61383 //
     /*  891645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  891656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  891659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  891662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891691 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891713 */     GIR_RootConstrainSelectedInstOperands,
     /*  891714 */     // GIR_Coverage, 61383,
     /*  891714 */     GIR_EraseRootFromParent_Done,
     /*  891715 */   // Label 13630: @891715
     /*  891715 */   GIM_Try, /*On fail goto*//*Label 13631*/ GIMT_Encode4(891790), // Rule ID 61386 //
     /*  891720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  891731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  891734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  891737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891766 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891788 */     GIR_RootConstrainSelectedInstOperands,
     /*  891789 */     // GIR_Coverage, 61386,
     /*  891789 */     GIR_EraseRootFromParent_Done,
     /*  891790 */   // Label 13631: @891790
     /*  891790 */   GIM_Try, /*On fail goto*//*Label 13632*/ GIMT_Encode4(891865), // Rule ID 61387 //
     /*  891795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  891806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  891809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  891812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891841 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891863 */     GIR_RootConstrainSelectedInstOperands,
     /*  891864 */     // GIR_Coverage, 61387,
     /*  891864 */     GIR_EraseRootFromParent_Done,
     /*  891865 */   // Label 13632: @891865
     /*  891865 */   GIM_Try, /*On fail goto*//*Label 13633*/ GIMT_Encode4(891940), // Rule ID 61390 //
     /*  891870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  891881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  891884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  891887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891916 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  891916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891938 */     GIR_RootConstrainSelectedInstOperands,
     /*  891939 */     // GIR_Coverage, 61390,
     /*  891939 */     GIR_EraseRootFromParent_Done,
     /*  891940 */   // Label 13633: @891940
     /*  891940 */   GIM_Try, /*On fail goto*//*Label 13634*/ GIMT_Encode4(892015), // Rule ID 61391 //
     /*  891945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  891956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  891959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  891962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891991 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  891991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892013 */     GIR_RootConstrainSelectedInstOperands,
     /*  892014 */     // GIR_Coverage, 61391,
     /*  892014 */     GIR_EraseRootFromParent_Done,
     /*  892015 */   // Label 13634: @892015
     /*  892015 */   GIM_Try, /*On fail goto*//*Label 13635*/ GIMT_Encode4(892090), // Rule ID 61394 //
     /*  892020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  892031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  892034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  892037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  892066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  892069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892088 */     GIR_RootConstrainSelectedInstOperands,
     /*  892089 */     // GIR_Coverage, 61394,
     /*  892089 */     GIR_EraseRootFromParent_Done,
     /*  892090 */   // Label 13635: @892090
     /*  892090 */   GIM_Try, /*On fail goto*//*Label 13636*/ GIMT_Encode4(892165), // Rule ID 61395 //
     /*  892095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  892106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  892109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  892112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892141 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  892141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  892144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892163 */     GIR_RootConstrainSelectedInstOperands,
     /*  892164 */     // GIR_Coverage, 61395,
     /*  892164 */     GIR_EraseRootFromParent_Done,
     /*  892165 */   // Label 13636: @892165
     /*  892165 */   GIM_Try, /*On fail goto*//*Label 13637*/ GIMT_Encode4(892240), // Rule ID 61398 //
     /*  892170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  892181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  892184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  892187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892216 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  892216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  892219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892238 */     GIR_RootConstrainSelectedInstOperands,
     /*  892239 */     // GIR_Coverage, 61398,
     /*  892239 */     GIR_EraseRootFromParent_Done,
     /*  892240 */   // Label 13637: @892240
     /*  892240 */   GIM_Try, /*On fail goto*//*Label 13638*/ GIMT_Encode4(892315), // Rule ID 61399 //
     /*  892245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  892256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  892259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  892262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892291 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  892291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  892294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892313 */     GIR_RootConstrainSelectedInstOperands,
     /*  892314 */     // GIR_Coverage, 61399,
     /*  892314 */     GIR_EraseRootFromParent_Done,
     /*  892315 */   // Label 13638: @892315
     /*  892315 */   GIM_Try, /*On fail goto*//*Label 13639*/ GIMT_Encode4(892390), // Rule ID 61578 //
     /*  892320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  892331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  892334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  892337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  892340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892366 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  892369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892388 */     GIR_RootConstrainSelectedInstOperands,
     /*  892389 */     // GIR_Coverage, 61578,
     /*  892389 */     GIR_EraseRootFromParent_Done,
     /*  892390 */   // Label 13639: @892390
     /*  892390 */   GIM_Try, /*On fail goto*//*Label 13640*/ GIMT_Encode4(892465), // Rule ID 61579 //
     /*  892395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  892406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  892409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  892412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  892415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892441 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  892444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892463 */     GIR_RootConstrainSelectedInstOperands,
     /*  892464 */     // GIR_Coverage, 61579,
     /*  892464 */     GIR_EraseRootFromParent_Done,
     /*  892465 */   // Label 13640: @892465
     /*  892465 */   GIM_Try, /*On fail goto*//*Label 13641*/ GIMT_Encode4(892540), // Rule ID 61582 //
     /*  892470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  892481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  892484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  892487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  892490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892516 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892538 */     GIR_RootConstrainSelectedInstOperands,
     /*  892539 */     // GIR_Coverage, 61582,
     /*  892539 */     GIR_EraseRootFromParent_Done,
     /*  892540 */   // Label 13641: @892540
     /*  892540 */   GIM_Try, /*On fail goto*//*Label 13642*/ GIMT_Encode4(892615), // Rule ID 61583 //
     /*  892545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  892556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  892559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  892562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  892565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892591 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892613 */     GIR_RootConstrainSelectedInstOperands,
     /*  892614 */     // GIR_Coverage, 61583,
     /*  892614 */     GIR_EraseRootFromParent_Done,
     /*  892615 */   // Label 13642: @892615
     /*  892615 */   GIM_Try, /*On fail goto*//*Label 13643*/ GIMT_Encode4(892690), // Rule ID 61586 //
     /*  892620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  892631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  892634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  892637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  892640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892666 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892688 */     GIR_RootConstrainSelectedInstOperands,
     /*  892689 */     // GIR_Coverage, 61586,
     /*  892689 */     GIR_EraseRootFromParent_Done,
     /*  892690 */   // Label 13643: @892690
     /*  892690 */   GIM_Try, /*On fail goto*//*Label 13644*/ GIMT_Encode4(892765), // Rule ID 61587 //
     /*  892695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  892706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  892709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  892712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  892715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892741 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892763 */     GIR_RootConstrainSelectedInstOperands,
     /*  892764 */     // GIR_Coverage, 61587,
     /*  892764 */     GIR_EraseRootFromParent_Done,
     /*  892765 */   // Label 13644: @892765
     /*  892765 */   GIM_Try, /*On fail goto*//*Label 13645*/ GIMT_Encode4(892840), // Rule ID 61590 //
     /*  892770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  892781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  892784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  892787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  892790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892816 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892838 */     GIR_RootConstrainSelectedInstOperands,
     /*  892839 */     // GIR_Coverage, 61590,
     /*  892839 */     GIR_EraseRootFromParent_Done,
     /*  892840 */   // Label 13645: @892840
     /*  892840 */   GIM_Try, /*On fail goto*//*Label 13646*/ GIMT_Encode4(892915), // Rule ID 61591 //
     /*  892845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  892856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  892859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  892862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  892865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892891 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  892891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892913 */     GIR_RootConstrainSelectedInstOperands,
     /*  892914 */     // GIR_Coverage, 61591,
     /*  892914 */     GIR_EraseRootFromParent_Done,
     /*  892915 */   // Label 13646: @892915
     /*  892915 */   GIM_Try, /*On fail goto*//*Label 13647*/ GIMT_Encode4(892990), // Rule ID 61594 //
     /*  892920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  892931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  892934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  892937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  892940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892966 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892988 */     GIR_RootConstrainSelectedInstOperands,
     /*  892989 */     // GIR_Coverage, 61594,
     /*  892989 */     GIR_EraseRootFromParent_Done,
     /*  892990 */   // Label 13647: @892990
     /*  892990 */   GIM_Try, /*On fail goto*//*Label 13648*/ GIMT_Encode4(893065), // Rule ID 61595 //
     /*  892995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  893006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  893009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  893012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  893015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893041 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  893044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893063 */     GIR_RootConstrainSelectedInstOperands,
     /*  893064 */     // GIR_Coverage, 61595,
     /*  893064 */     GIR_EraseRootFromParent_Done,
     /*  893065 */   // Label 13648: @893065
     /*  893065 */   GIM_Try, /*On fail goto*//*Label 13649*/ GIMT_Encode4(893140), // Rule ID 61598 //
     /*  893070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  893081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  893084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  893087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  893090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893116 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  893116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  893119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893138 */     GIR_RootConstrainSelectedInstOperands,
     /*  893139 */     // GIR_Coverage, 61598,
     /*  893139 */     GIR_EraseRootFromParent_Done,
     /*  893140 */   // Label 13649: @893140
     /*  893140 */   GIM_Try, /*On fail goto*//*Label 13650*/ GIMT_Encode4(893215), // Rule ID 61599 //
     /*  893145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  893156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  893159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  893162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  893165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893191 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  893191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  893194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893213 */     GIR_RootConstrainSelectedInstOperands,
     /*  893214 */     // GIR_Coverage, 61599,
     /*  893214 */     GIR_EraseRootFromParent_Done,
     /*  893215 */   // Label 13650: @893215
     /*  893215 */   GIM_Try, /*On fail goto*//*Label 13651*/ GIMT_Encode4(893290), // Rule ID 61602 //
     /*  893220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  893231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  893234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  893237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  893240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893266 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893288 */     GIR_RootConstrainSelectedInstOperands,
     /*  893289 */     // GIR_Coverage, 61602,
     /*  893289 */     GIR_EraseRootFromParent_Done,
     /*  893290 */   // Label 13651: @893290
     /*  893290 */   GIM_Try, /*On fail goto*//*Label 13652*/ GIMT_Encode4(893365), // Rule ID 61603 //
     /*  893295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  893306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  893309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  893312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  893315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893341 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893363 */     GIR_RootConstrainSelectedInstOperands,
     /*  893364 */     // GIR_Coverage, 61603,
     /*  893364 */     GIR_EraseRootFromParent_Done,
     /*  893365 */   // Label 13652: @893365
     /*  893365 */   GIM_Try, /*On fail goto*//*Label 13653*/ GIMT_Encode4(893440), // Rule ID 61606 //
     /*  893370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  893381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  893384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  893387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  893390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  893416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893438 */     GIR_RootConstrainSelectedInstOperands,
     /*  893439 */     // GIR_Coverage, 61606,
     /*  893439 */     GIR_EraseRootFromParent_Done,
     /*  893440 */   // Label 13653: @893440
     /*  893440 */   GIM_Try, /*On fail goto*//*Label 13654*/ GIMT_Encode4(893515), // Rule ID 61607 //
     /*  893445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  893456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  893459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  893462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  893465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893491 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893513 */     GIR_RootConstrainSelectedInstOperands,
     /*  893514 */     // GIR_Coverage, 61607,
     /*  893514 */     GIR_EraseRootFromParent_Done,
     /*  893515 */   // Label 13654: @893515
     /*  893515 */   GIM_Try, /*On fail goto*//*Label 13655*/ GIMT_Encode4(893590), // Rule ID 61610 //
     /*  893520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  893531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  893534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  893537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  893540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893566 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  893566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893588 */     GIR_RootConstrainSelectedInstOperands,
     /*  893589 */     // GIR_Coverage, 61610,
     /*  893589 */     GIR_EraseRootFromParent_Done,
     /*  893590 */   // Label 13655: @893590
     /*  893590 */   GIM_Try, /*On fail goto*//*Label 13656*/ GIMT_Encode4(893665), // Rule ID 61611 //
     /*  893595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  893606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  893609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  893612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  893615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893641 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  893641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893663 */     GIR_RootConstrainSelectedInstOperands,
     /*  893664 */     // GIR_Coverage, 61611,
     /*  893664 */     GIR_EraseRootFromParent_Done,
     /*  893665 */   // Label 13656: @893665
     /*  893665 */   GIM_Try, /*On fail goto*//*Label 13657*/ GIMT_Encode4(893740), // Rule ID 61614 //
     /*  893670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  893681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  893684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  893687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  893690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893716 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  893716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893738 */     GIR_RootConstrainSelectedInstOperands,
     /*  893739 */     // GIR_Coverage, 61614,
     /*  893739 */     GIR_EraseRootFromParent_Done,
     /*  893740 */   // Label 13657: @893740
     /*  893740 */   GIM_Try, /*On fail goto*//*Label 13658*/ GIMT_Encode4(893815), // Rule ID 61615 //
     /*  893745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  893756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  893759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  893762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  893765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893791 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  893791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893813 */     GIR_RootConstrainSelectedInstOperands,
     /*  893814 */     // GIR_Coverage, 61615,
     /*  893814 */     GIR_EraseRootFromParent_Done,
     /*  893815 */   // Label 13658: @893815
     /*  893815 */   GIM_Try, /*On fail goto*//*Label 13659*/ GIMT_Encode4(893890), // Rule ID 61618 //
     /*  893820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  893831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  893834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  893837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  893840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893866 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893888 */     GIR_RootConstrainSelectedInstOperands,
     /*  893889 */     // GIR_Coverage, 61618,
     /*  893889 */     GIR_EraseRootFromParent_Done,
     /*  893890 */   // Label 13659: @893890
     /*  893890 */   GIM_Try, /*On fail goto*//*Label 13660*/ GIMT_Encode4(893965), // Rule ID 61619 //
     /*  893895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  893906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  893909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  893912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  893915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893941 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893963 */     GIR_RootConstrainSelectedInstOperands,
     /*  893964 */     // GIR_Coverage, 61619,
     /*  893964 */     GIR_EraseRootFromParent_Done,
     /*  893965 */   // Label 13660: @893965
     /*  893965 */   GIM_Try, /*On fail goto*//*Label 13661*/ GIMT_Encode4(894040), // Rule ID 61622 //
     /*  893970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  893981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  893984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  893987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  893990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894016 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  894016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894038 */     GIR_RootConstrainSelectedInstOperands,
     /*  894039 */     // GIR_Coverage, 61622,
     /*  894039 */     GIR_EraseRootFromParent_Done,
     /*  894040 */   // Label 13661: @894040
     /*  894040 */   GIM_Try, /*On fail goto*//*Label 13662*/ GIMT_Encode4(894115), // Rule ID 61623 //
     /*  894045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  894056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  894059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  894062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  894065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894091 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  894091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894113 */     GIR_RootConstrainSelectedInstOperands,
     /*  894114 */     // GIR_Coverage, 61623,
     /*  894114 */     GIR_EraseRootFromParent_Done,
     /*  894115 */   // Label 13662: @894115
     /*  894115 */   GIM_Try, /*On fail goto*//*Label 13663*/ GIMT_Encode4(894190), // Rule ID 61626 //
     /*  894120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  894131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  894134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  894137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  894140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894166 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  894166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894188 */     GIR_RootConstrainSelectedInstOperands,
     /*  894189 */     // GIR_Coverage, 61626,
     /*  894189 */     GIR_EraseRootFromParent_Done,
     /*  894190 */   // Label 13663: @894190
     /*  894190 */   GIM_Try, /*On fail goto*//*Label 13664*/ GIMT_Encode4(894265), // Rule ID 61627 //
     /*  894195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  894206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  894209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  894212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  894215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894241 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  894241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894263 */     GIR_RootConstrainSelectedInstOperands,
     /*  894264 */     // GIR_Coverage, 61627,
     /*  894264 */     GIR_EraseRootFromParent_Done,
     /*  894265 */   // Label 13664: @894265
     /*  894265 */   GIM_Try, /*On fail goto*//*Label 13665*/ GIMT_Encode4(894340), // Rule ID 61630 //
     /*  894270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  894281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  894284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  894287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  894290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894338 */     GIR_RootConstrainSelectedInstOperands,
     /*  894339 */     // GIR_Coverage, 61630,
     /*  894339 */     GIR_EraseRootFromParent_Done,
     /*  894340 */   // Label 13665: @894340
     /*  894340 */   GIM_Try, /*On fail goto*//*Label 13666*/ GIMT_Encode4(894415), // Rule ID 61631 //
     /*  894345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  894356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  894359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  894362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  894365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894391 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894413 */     GIR_RootConstrainSelectedInstOperands,
     /*  894414 */     // GIR_Coverage, 61631,
     /*  894414 */     GIR_EraseRootFromParent_Done,
     /*  894415 */   // Label 13666: @894415
     /*  894415 */   GIM_Try, /*On fail goto*//*Label 13667*/ GIMT_Encode4(894490), // Rule ID 61634 //
     /*  894420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  894431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  894434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  894437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  894440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894466 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894488 */     GIR_RootConstrainSelectedInstOperands,
     /*  894489 */     // GIR_Coverage, 61634,
     /*  894489 */     GIR_EraseRootFromParent_Done,
     /*  894490 */   // Label 13667: @894490
     /*  894490 */   GIM_Try, /*On fail goto*//*Label 13668*/ GIMT_Encode4(894565), // Rule ID 61635 //
     /*  894495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  894506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  894509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  894512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  894515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894541 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894563 */     GIR_RootConstrainSelectedInstOperands,
     /*  894564 */     // GIR_Coverage, 61635,
     /*  894564 */     GIR_EraseRootFromParent_Done,
     /*  894565 */   // Label 13668: @894565
     /*  894565 */   GIM_Try, /*On fail goto*//*Label 13669*/ GIMT_Encode4(894640), // Rule ID 61638 //
     /*  894570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  894581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  894584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  894587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  894590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894616 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894638 */     GIR_RootConstrainSelectedInstOperands,
     /*  894639 */     // GIR_Coverage, 61638,
     /*  894639 */     GIR_EraseRootFromParent_Done,
     /*  894640 */   // Label 13669: @894640
     /*  894640 */   GIM_Try, /*On fail goto*//*Label 13670*/ GIMT_Encode4(894715), // Rule ID 61639 //
     /*  894645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  894656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  894659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  894662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  894665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894691 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894713 */     GIR_RootConstrainSelectedInstOperands,
     /*  894714 */     // GIR_Coverage, 61639,
     /*  894714 */     GIR_EraseRootFromParent_Done,
     /*  894715 */   // Label 13670: @894715
     /*  894715 */   GIM_Try, /*On fail goto*//*Label 13671*/ GIMT_Encode4(894790), // Rule ID 61642 //
     /*  894720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  894731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  894734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  894737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  894740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894788 */     GIR_RootConstrainSelectedInstOperands,
     /*  894789 */     // GIR_Coverage, 61642,
     /*  894789 */     GIR_EraseRootFromParent_Done,
     /*  894790 */   // Label 13671: @894790
     /*  894790 */   GIM_Try, /*On fail goto*//*Label 13672*/ GIMT_Encode4(894865), // Rule ID 61643 //
     /*  894795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  894806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  894809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  894812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  894815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894841 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894863 */     GIR_RootConstrainSelectedInstOperands,
     /*  894864 */     // GIR_Coverage, 61643,
     /*  894864 */     GIR_EraseRootFromParent_Done,
     /*  894865 */   // Label 13672: @894865
     /*  894865 */   GIM_Try, /*On fail goto*//*Label 13673*/ GIMT_Encode4(894940), // Rule ID 61646 //
     /*  894870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  894881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  894884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  894887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  894890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894916 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894938 */     GIR_RootConstrainSelectedInstOperands,
     /*  894939 */     // GIR_Coverage, 61646,
     /*  894939 */     GIR_EraseRootFromParent_Done,
     /*  894940 */   // Label 13673: @894940
     /*  894940 */   GIM_Try, /*On fail goto*//*Label 13674*/ GIMT_Encode4(895015), // Rule ID 61647 //
     /*  894945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  894956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  894959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  894962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  894965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894991 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895013 */     GIR_RootConstrainSelectedInstOperands,
     /*  895014 */     // GIR_Coverage, 61647,
     /*  895014 */     GIR_EraseRootFromParent_Done,
     /*  895015 */   // Label 13674: @895015
     /*  895015 */   GIM_Try, /*On fail goto*//*Label 13675*/ GIMT_Encode4(895090), // Rule ID 61650 //
     /*  895020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  895031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  895034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  895037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  895040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895066 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  895066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  895069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895088 */     GIR_RootConstrainSelectedInstOperands,
     /*  895089 */     // GIR_Coverage, 61650,
     /*  895089 */     GIR_EraseRootFromParent_Done,
     /*  895090 */   // Label 13675: @895090
     /*  895090 */   GIM_Try, /*On fail goto*//*Label 13676*/ GIMT_Encode4(895165), // Rule ID 61651 //
     /*  895095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  895106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  895109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  895112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  895115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895141 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  895141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  895144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895163 */     GIR_RootConstrainSelectedInstOperands,
     /*  895164 */     // GIR_Coverage, 61651,
     /*  895164 */     GIR_EraseRootFromParent_Done,
     /*  895165 */   // Label 13676: @895165
     /*  895165 */   GIM_Try, /*On fail goto*//*Label 13677*/ GIMT_Encode4(895240), // Rule ID 61654 //
     /*  895170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  895181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  895184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  895187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  895190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895216 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  895219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895238 */     GIR_RootConstrainSelectedInstOperands,
     /*  895239 */     // GIR_Coverage, 61654,
     /*  895239 */     GIR_EraseRootFromParent_Done,
     /*  895240 */   // Label 13677: @895240
     /*  895240 */   GIM_Try, /*On fail goto*//*Label 13678*/ GIMT_Encode4(895315), // Rule ID 61655 //
     /*  895245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  895256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  895259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  895262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  895265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895291 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  895294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895313 */     GIR_RootConstrainSelectedInstOperands,
     /*  895314 */     // GIR_Coverage, 61655,
     /*  895314 */     GIR_EraseRootFromParent_Done,
     /*  895315 */   // Label 13678: @895315
     /*  895315 */   GIM_Try, /*On fail goto*//*Label 13679*/ GIMT_Encode4(895390), // Rule ID 61658 //
     /*  895320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  895331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  895334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  895337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  895340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895366 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  895369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895388 */     GIR_RootConstrainSelectedInstOperands,
     /*  895389 */     // GIR_Coverage, 61658,
     /*  895389 */     GIR_EraseRootFromParent_Done,
     /*  895390 */   // Label 13679: @895390
     /*  895390 */   GIM_Try, /*On fail goto*//*Label 13680*/ GIMT_Encode4(895465), // Rule ID 61659 //
     /*  895395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  895406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  895409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  895412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  895415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895441 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  895444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895463 */     GIR_RootConstrainSelectedInstOperands,
     /*  895464 */     // GIR_Coverage, 61659,
     /*  895464 */     GIR_EraseRootFromParent_Done,
     /*  895465 */   // Label 13680: @895465
     /*  895465 */   GIM_Try, /*On fail goto*//*Label 13681*/ GIMT_Encode4(895540), // Rule ID 61662 //
     /*  895470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  895481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  895484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  895487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  895490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895516 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  895519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895538 */     GIR_RootConstrainSelectedInstOperands,
     /*  895539 */     // GIR_Coverage, 61662,
     /*  895539 */     GIR_EraseRootFromParent_Done,
     /*  895540 */   // Label 13681: @895540
     /*  895540 */   GIM_Try, /*On fail goto*//*Label 13682*/ GIMT_Encode4(895615), // Rule ID 61663 //
     /*  895545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  895556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  895559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  895562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  895565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895591 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  895594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895613 */     GIR_RootConstrainSelectedInstOperands,
     /*  895614 */     // GIR_Coverage, 61663,
     /*  895614 */     GIR_EraseRootFromParent_Done,
     /*  895615 */   // Label 13682: @895615
     /*  895615 */   GIM_Try, /*On fail goto*//*Label 13683*/ GIMT_Encode4(895690), // Rule ID 61666 //
     /*  895620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  895631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  895634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  895637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895666 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  895669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895688 */     GIR_RootConstrainSelectedInstOperands,
     /*  895689 */     // GIR_Coverage, 61666,
     /*  895689 */     GIR_EraseRootFromParent_Done,
     /*  895690 */   // Label 13683: @895690
     /*  895690 */   GIM_Try, /*On fail goto*//*Label 13684*/ GIMT_Encode4(895765), // Rule ID 61667 //
     /*  895695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  895706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  895709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  895712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895741 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  895744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895763 */     GIR_RootConstrainSelectedInstOperands,
     /*  895764 */     // GIR_Coverage, 61667,
     /*  895764 */     GIR_EraseRootFromParent_Done,
     /*  895765 */   // Label 13684: @895765
     /*  895765 */   GIM_Try, /*On fail goto*//*Label 13685*/ GIMT_Encode4(895840), // Rule ID 61670 //
     /*  895770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  895781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  895784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  895787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895816 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895838 */     GIR_RootConstrainSelectedInstOperands,
     /*  895839 */     // GIR_Coverage, 61670,
     /*  895839 */     GIR_EraseRootFromParent_Done,
     /*  895840 */   // Label 13685: @895840
     /*  895840 */   GIM_Try, /*On fail goto*//*Label 13686*/ GIMT_Encode4(895915), // Rule ID 61671 //
     /*  895845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  895856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  895859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  895862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895891 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895913 */     GIR_RootConstrainSelectedInstOperands,
     /*  895914 */     // GIR_Coverage, 61671,
     /*  895914 */     GIR_EraseRootFromParent_Done,
     /*  895915 */   // Label 13686: @895915
     /*  895915 */   GIM_Try, /*On fail goto*//*Label 13687*/ GIMT_Encode4(895990), // Rule ID 61674 //
     /*  895920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  895931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  895934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  895937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895966 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895988 */     GIR_RootConstrainSelectedInstOperands,
     /*  895989 */     // GIR_Coverage, 61674,
     /*  895989 */     GIR_EraseRootFromParent_Done,
     /*  895990 */   // Label 13687: @895990
     /*  895990 */   GIM_Try, /*On fail goto*//*Label 13688*/ GIMT_Encode4(896065), // Rule ID 61675 //
     /*  895995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  896006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  896009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  896012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896041 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  896044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896063 */     GIR_RootConstrainSelectedInstOperands,
     /*  896064 */     // GIR_Coverage, 61675,
     /*  896064 */     GIR_EraseRootFromParent_Done,
     /*  896065 */   // Label 13688: @896065
     /*  896065 */   GIM_Try, /*On fail goto*//*Label 13689*/ GIMT_Encode4(896140), // Rule ID 61678 //
     /*  896070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  896081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  896084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  896087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896116 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  896119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896138 */     GIR_RootConstrainSelectedInstOperands,
     /*  896139 */     // GIR_Coverage, 61678,
     /*  896139 */     GIR_EraseRootFromParent_Done,
     /*  896140 */   // Label 13689: @896140
     /*  896140 */   GIM_Try, /*On fail goto*//*Label 13690*/ GIMT_Encode4(896215), // Rule ID 61679 //
     /*  896145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  896156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  896159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  896162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896191 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  896194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896213 */     GIR_RootConstrainSelectedInstOperands,
     /*  896214 */     // GIR_Coverage, 61679,
     /*  896214 */     GIR_EraseRootFromParent_Done,
     /*  896215 */   // Label 13690: @896215
     /*  896215 */   GIM_Try, /*On fail goto*//*Label 13691*/ GIMT_Encode4(896290), // Rule ID 61682 //
     /*  896220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  896231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  896234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  896237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896266 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  896269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896288 */     GIR_RootConstrainSelectedInstOperands,
     /*  896289 */     // GIR_Coverage, 61682,
     /*  896289 */     GIR_EraseRootFromParent_Done,
     /*  896290 */   // Label 13691: @896290
     /*  896290 */   GIM_Try, /*On fail goto*//*Label 13692*/ GIMT_Encode4(896365), // Rule ID 61683 //
     /*  896295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  896306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  896309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  896312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896341 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  896344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896363 */     GIR_RootConstrainSelectedInstOperands,
     /*  896364 */     // GIR_Coverage, 61683,
     /*  896364 */     GIR_EraseRootFromParent_Done,
     /*  896365 */   // Label 13692: @896365
     /*  896365 */   GIM_Try, /*On fail goto*//*Label 13693*/ GIMT_Encode4(896440), // Rule ID 61686 //
     /*  896370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  896381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  896384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  896387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  896416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  896419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896438 */     GIR_RootConstrainSelectedInstOperands,
     /*  896439 */     // GIR_Coverage, 61686,
     /*  896439 */     GIR_EraseRootFromParent_Done,
     /*  896440 */   // Label 13693: @896440
     /*  896440 */   GIM_Try, /*On fail goto*//*Label 13694*/ GIMT_Encode4(896515), // Rule ID 61687 //
     /*  896445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  896456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  896459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  896462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896491 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  896491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  896494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896513 */     GIR_RootConstrainSelectedInstOperands,
     /*  896514 */     // GIR_Coverage, 61687,
     /*  896514 */     GIR_EraseRootFromParent_Done,
     /*  896515 */   // Label 13694: @896515
     /*  896515 */   GIM_Try, /*On fail goto*//*Label 13695*/ GIMT_Encode4(896590), // Rule ID 61690 //
     /*  896520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  896531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  896534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  896537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896566 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896588 */     GIR_RootConstrainSelectedInstOperands,
     /*  896589 */     // GIR_Coverage, 61690,
     /*  896589 */     GIR_EraseRootFromParent_Done,
     /*  896590 */   // Label 13695: @896590
     /*  896590 */   GIM_Try, /*On fail goto*//*Label 13696*/ GIMT_Encode4(896665), // Rule ID 61691 //
     /*  896595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  896606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  896609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  896612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896641 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896663 */     GIR_RootConstrainSelectedInstOperands,
     /*  896664 */     // GIR_Coverage, 61691,
     /*  896664 */     GIR_EraseRootFromParent_Done,
     /*  896665 */   // Label 13696: @896665
     /*  896665 */   GIM_Try, /*On fail goto*//*Label 13697*/ GIMT_Encode4(896740), // Rule ID 61694 //
     /*  896670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  896681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  896684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  896687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896738 */     GIR_RootConstrainSelectedInstOperands,
     /*  896739 */     // GIR_Coverage, 61694,
     /*  896739 */     GIR_EraseRootFromParent_Done,
     /*  896740 */   // Label 13697: @896740
     /*  896740 */   GIM_Try, /*On fail goto*//*Label 13698*/ GIMT_Encode4(896815), // Rule ID 61695 //
     /*  896745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  896756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  896759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  896762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896791 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896813 */     GIR_RootConstrainSelectedInstOperands,
     /*  896814 */     // GIR_Coverage, 61695,
     /*  896814 */     GIR_EraseRootFromParent_Done,
     /*  896815 */   // Label 13698: @896815
     /*  896815 */   GIM_Try, /*On fail goto*//*Label 13699*/ GIMT_Encode4(896890), // Rule ID 61698 //
     /*  896820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  896831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  896834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  896837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896866 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  896866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896888 */     GIR_RootConstrainSelectedInstOperands,
     /*  896889 */     // GIR_Coverage, 61698,
     /*  896889 */     GIR_EraseRootFromParent_Done,
     /*  896890 */   // Label 13699: @896890
     /*  896890 */   GIM_Try, /*On fail goto*//*Label 13700*/ GIMT_Encode4(896965), // Rule ID 61699 //
     /*  896895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  896906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  896909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  896912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896941 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  896941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896963 */     GIR_RootConstrainSelectedInstOperands,
     /*  896964 */     // GIR_Coverage, 61699,
     /*  896964 */     GIR_EraseRootFromParent_Done,
     /*  896965 */   // Label 13700: @896965
     /*  896965 */   GIM_Try, /*On fail goto*//*Label 13701*/ GIMT_Encode4(897040), // Rule ID 61702 //
     /*  896970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  896981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  896984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  896987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897016 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  897016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  897019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897038 */     GIR_RootConstrainSelectedInstOperands,
     /*  897039 */     // GIR_Coverage, 61702,
     /*  897039 */     GIR_EraseRootFromParent_Done,
     /*  897040 */   // Label 13701: @897040
     /*  897040 */   GIM_Try, /*On fail goto*//*Label 13702*/ GIMT_Encode4(897115), // Rule ID 61703 //
     /*  897045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  897056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  897059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  897062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897091 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  897091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  897094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897113 */     GIR_RootConstrainSelectedInstOperands,
     /*  897114 */     // GIR_Coverage, 61703,
     /*  897114 */     GIR_EraseRootFromParent_Done,
     /*  897115 */   // Label 13702: @897115
     /*  897115 */   GIM_Try, /*On fail goto*//*Label 13703*/ GIMT_Encode4(897190), // Rule ID 61706 //
     /*  897120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  897131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  897134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  897137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897166 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897188 */     GIR_RootConstrainSelectedInstOperands,
     /*  897189 */     // GIR_Coverage, 61706,
     /*  897189 */     GIR_EraseRootFromParent_Done,
     /*  897190 */   // Label 13703: @897190
     /*  897190 */   GIM_Try, /*On fail goto*//*Label 13704*/ GIMT_Encode4(897265), // Rule ID 61707 //
     /*  897195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  897206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  897209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  897212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897241 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897263 */     GIR_RootConstrainSelectedInstOperands,
     /*  897264 */     // GIR_Coverage, 61707,
     /*  897264 */     GIR_EraseRootFromParent_Done,
     /*  897265 */   // Label 13704: @897265
     /*  897265 */   GIM_Try, /*On fail goto*//*Label 13705*/ GIMT_Encode4(897340), // Rule ID 61710 //
     /*  897270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  897281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  897284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  897287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897316 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897338 */     GIR_RootConstrainSelectedInstOperands,
     /*  897339 */     // GIR_Coverage, 61710,
     /*  897339 */     GIR_EraseRootFromParent_Done,
     /*  897340 */   // Label 13705: @897340
     /*  897340 */   GIM_Try, /*On fail goto*//*Label 13706*/ GIMT_Encode4(897415), // Rule ID 61711 //
     /*  897345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  897356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  897359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  897362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897391 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897413 */     GIR_RootConstrainSelectedInstOperands,
     /*  897414 */     // GIR_Coverage, 61711,
     /*  897414 */     GIR_EraseRootFromParent_Done,
     /*  897415 */   // Label 13706: @897415
     /*  897415 */   GIM_Try, /*On fail goto*//*Label 13707*/ GIMT_Encode4(897490), // Rule ID 61714 //
     /*  897420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  897431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  897434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  897437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897466 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897488 */     GIR_RootConstrainSelectedInstOperands,
     /*  897489 */     // GIR_Coverage, 61714,
     /*  897489 */     GIR_EraseRootFromParent_Done,
     /*  897490 */   // Label 13707: @897490
     /*  897490 */   GIM_Try, /*On fail goto*//*Label 13708*/ GIMT_Encode4(897565), // Rule ID 61715 //
     /*  897495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  897506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  897509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  897512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897541 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897563 */     GIR_RootConstrainSelectedInstOperands,
     /*  897564 */     // GIR_Coverage, 61715,
     /*  897564 */     GIR_EraseRootFromParent_Done,
     /*  897565 */   // Label 13708: @897565
     /*  897565 */   GIM_Try, /*On fail goto*//*Label 13709*/ GIMT_Encode4(897640), // Rule ID 61718 //
     /*  897570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  897581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  897584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  897587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897638 */     GIR_RootConstrainSelectedInstOperands,
     /*  897639 */     // GIR_Coverage, 61718,
     /*  897639 */     GIR_EraseRootFromParent_Done,
     /*  897640 */   // Label 13709: @897640
     /*  897640 */   GIM_Try, /*On fail goto*//*Label 13710*/ GIMT_Encode4(897715), // Rule ID 61719 //
     /*  897645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  897656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  897659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  897662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897691 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897713 */     GIR_RootConstrainSelectedInstOperands,
     /*  897714 */     // GIR_Coverage, 61719,
     /*  897714 */     GIR_EraseRootFromParent_Done,
     /*  897715 */   // Label 13710: @897715
     /*  897715 */   GIM_Try, /*On fail goto*//*Label 13711*/ GIMT_Encode4(897790), // Rule ID 61722 //
     /*  897720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897766 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897788 */     GIR_RootConstrainSelectedInstOperands,
     /*  897789 */     // GIR_Coverage, 61722,
     /*  897789 */     GIR_EraseRootFromParent_Done,
     /*  897790 */   // Label 13711: @897790
     /*  897790 */   GIM_Try, /*On fail goto*//*Label 13712*/ GIMT_Encode4(897865), // Rule ID 61723 //
     /*  897795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897841 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897863 */     GIR_RootConstrainSelectedInstOperands,
     /*  897864 */     // GIR_Coverage, 61723,
     /*  897864 */     GIR_EraseRootFromParent_Done,
     /*  897865 */   // Label 13712: @897865
     /*  897865 */   GIM_Try, /*On fail goto*//*Label 13713*/ GIMT_Encode4(897940), // Rule ID 61726 //
     /*  897870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  897881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  897884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  897887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897916 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897938 */     GIR_RootConstrainSelectedInstOperands,
     /*  897939 */     // GIR_Coverage, 61726,
     /*  897939 */     GIR_EraseRootFromParent_Done,
     /*  897940 */   // Label 13713: @897940
     /*  897940 */   GIM_Try, /*On fail goto*//*Label 13714*/ GIMT_Encode4(898015), // Rule ID 61727 //
     /*  897945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  897956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  897959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  897962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897991 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898013 */     GIR_RootConstrainSelectedInstOperands,
     /*  898014 */     // GIR_Coverage, 61727,
     /*  898014 */     GIR_EraseRootFromParent_Done,
     /*  898015 */   // Label 13714: @898015
     /*  898015 */   GIM_Try, /*On fail goto*//*Label 13715*/ GIMT_Encode4(898090), // Rule ID 61730 //
     /*  898020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  898031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  898034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  898037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  898069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898088 */     GIR_RootConstrainSelectedInstOperands,
     /*  898089 */     // GIR_Coverage, 61730,
     /*  898089 */     GIR_EraseRootFromParent_Done,
     /*  898090 */   // Label 13715: @898090
     /*  898090 */   GIM_Try, /*On fail goto*//*Label 13716*/ GIMT_Encode4(898165), // Rule ID 61731 //
     /*  898095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  898106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  898109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  898112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  898144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898163 */     GIR_RootConstrainSelectedInstOperands,
     /*  898164 */     // GIR_Coverage, 61731,
     /*  898164 */     GIR_EraseRootFromParent_Done,
     /*  898165 */   // Label 13716: @898165
     /*  898165 */   GIM_Try, /*On fail goto*//*Label 13717*/ GIMT_Encode4(898240), // Rule ID 61734 //
     /*  898170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  898181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  898184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  898187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  898219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898238 */     GIR_RootConstrainSelectedInstOperands,
     /*  898239 */     // GIR_Coverage, 61734,
     /*  898239 */     GIR_EraseRootFromParent_Done,
     /*  898240 */   // Label 13717: @898240
     /*  898240 */   GIM_Try, /*On fail goto*//*Label 13718*/ GIMT_Encode4(898315), // Rule ID 61735 //
     /*  898245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  898256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  898259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  898262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898291 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  898294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898313 */     GIR_RootConstrainSelectedInstOperands,
     /*  898314 */     // GIR_Coverage, 61735,
     /*  898314 */     GIR_EraseRootFromParent_Done,
     /*  898315 */   // Label 13718: @898315
     /*  898315 */   GIM_Try, /*On fail goto*//*Label 13719*/ GIMT_Encode4(898390), // Rule ID 61738 //
     /*  898320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  898331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  898334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  898337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898366 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  898369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898388 */     GIR_RootConstrainSelectedInstOperands,
     /*  898389 */     // GIR_Coverage, 61738,
     /*  898389 */     GIR_EraseRootFromParent_Done,
     /*  898390 */   // Label 13719: @898390
     /*  898390 */   GIM_Try, /*On fail goto*//*Label 13720*/ GIMT_Encode4(898465), // Rule ID 61739 //
     /*  898395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  898406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  898409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  898412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898441 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  898444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898463 */     GIR_RootConstrainSelectedInstOperands,
     /*  898464 */     // GIR_Coverage, 61739,
     /*  898464 */     GIR_EraseRootFromParent_Done,
     /*  898465 */   // Label 13720: @898465
     /*  898465 */   GIM_Try, /*On fail goto*//*Label 13721*/ GIMT_Encode4(898540), // Rule ID 61742 //
     /*  898470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  898481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  898484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  898487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  898519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898538 */     GIR_RootConstrainSelectedInstOperands,
     /*  898539 */     // GIR_Coverage, 61742,
     /*  898539 */     GIR_EraseRootFromParent_Done,
     /*  898540 */   // Label 13721: @898540
     /*  898540 */   GIM_Try, /*On fail goto*//*Label 13722*/ GIMT_Encode4(898615), // Rule ID 61743 //
     /*  898545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  898556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  898559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  898562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898591 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  898594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898613 */     GIR_RootConstrainSelectedInstOperands,
     /*  898614 */     // GIR_Coverage, 61743,
     /*  898614 */     GIR_EraseRootFromParent_Done,
     /*  898615 */   // Label 13722: @898615
     /*  898615 */   GIM_Try, /*On fail goto*//*Label 13723*/ GIMT_Encode4(898690), // Rule ID 61746 //
     /*  898620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898666 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  898669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898688 */     GIR_RootConstrainSelectedInstOperands,
     /*  898689 */     // GIR_Coverage, 61746,
     /*  898689 */     GIR_EraseRootFromParent_Done,
     /*  898690 */   // Label 13723: @898690
     /*  898690 */   GIM_Try, /*On fail goto*//*Label 13724*/ GIMT_Encode4(898765), // Rule ID 61747 //
     /*  898695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898741 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  898744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898763 */     GIR_RootConstrainSelectedInstOperands,
     /*  898764 */     // GIR_Coverage, 61747,
     /*  898764 */     GIR_EraseRootFromParent_Done,
     /*  898765 */   // Label 13724: @898765
     /*  898765 */   GIM_Try, /*On fail goto*//*Label 13725*/ GIMT_Encode4(898840), // Rule ID 61750 //
     /*  898770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898816 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  898819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898838 */     GIR_RootConstrainSelectedInstOperands,
     /*  898839 */     // GIR_Coverage, 61750,
     /*  898839 */     GIR_EraseRootFromParent_Done,
     /*  898840 */   // Label 13725: @898840
     /*  898840 */   GIM_Try, /*On fail goto*//*Label 13726*/ GIMT_Encode4(898915), // Rule ID 61751 //
     /*  898845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898891 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  898894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898913 */     GIR_RootConstrainSelectedInstOperands,
     /*  898914 */     // GIR_Coverage, 61751,
     /*  898914 */     GIR_EraseRootFromParent_Done,
     /*  898915 */   // Label 13726: @898915
     /*  898915 */   GIM_Try, /*On fail goto*//*Label 13727*/ GIMT_Encode4(898990), // Rule ID 61838 //
     /*  898920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  898931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  898934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  898937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  898940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898966 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  898966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  898969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898988 */     GIR_RootConstrainSelectedInstOperands,
     /*  898989 */     // GIR_Coverage, 61838,
     /*  898989 */     GIR_EraseRootFromParent_Done,
     /*  898990 */   // Label 13727: @898990
     /*  898990 */   GIM_Try, /*On fail goto*//*Label 13728*/ GIMT_Encode4(899065), // Rule ID 61839 //
     /*  898995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  899006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  899009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  899012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  899015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899041 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  899044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899063 */     GIR_RootConstrainSelectedInstOperands,
     /*  899064 */     // GIR_Coverage, 61839,
     /*  899064 */     GIR_EraseRootFromParent_Done,
     /*  899065 */   // Label 13728: @899065
     /*  899065 */   GIM_Try, /*On fail goto*//*Label 13729*/ GIMT_Encode4(899140), // Rule ID 61842 //
     /*  899070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  899081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  899084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  899087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  899090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899116 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  899119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899138 */     GIR_RootConstrainSelectedInstOperands,
     /*  899139 */     // GIR_Coverage, 61842,
     /*  899139 */     GIR_EraseRootFromParent_Done,
     /*  899140 */   // Label 13729: @899140
     /*  899140 */   GIM_Try, /*On fail goto*//*Label 13730*/ GIMT_Encode4(899215), // Rule ID 61843 //
     /*  899145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  899156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  899159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  899162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  899165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899191 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  899194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899213 */     GIR_RootConstrainSelectedInstOperands,
     /*  899214 */     // GIR_Coverage, 61843,
     /*  899214 */     GIR_EraseRootFromParent_Done,
     /*  899215 */   // Label 13730: @899215
     /*  899215 */   GIM_Try, /*On fail goto*//*Label 13731*/ GIMT_Encode4(899290), // Rule ID 61846 //
     /*  899220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  899231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  899234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  899237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  899240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899266 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899288 */     GIR_RootConstrainSelectedInstOperands,
     /*  899289 */     // GIR_Coverage, 61846,
     /*  899289 */     GIR_EraseRootFromParent_Done,
     /*  899290 */   // Label 13731: @899290
     /*  899290 */   GIM_Try, /*On fail goto*//*Label 13732*/ GIMT_Encode4(899365), // Rule ID 61847 //
     /*  899295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  899306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  899309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  899312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  899315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899341 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899363 */     GIR_RootConstrainSelectedInstOperands,
     /*  899364 */     // GIR_Coverage, 61847,
     /*  899364 */     GIR_EraseRootFromParent_Done,
     /*  899365 */   // Label 13732: @899365
     /*  899365 */   GIM_Try, /*On fail goto*//*Label 13733*/ GIMT_Encode4(899440), // Rule ID 61850 //
     /*  899370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  899381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  899384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  899387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  899390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899416 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  899419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899438 */     GIR_RootConstrainSelectedInstOperands,
     /*  899439 */     // GIR_Coverage, 61850,
     /*  899439 */     GIR_EraseRootFromParent_Done,
     /*  899440 */   // Label 13733: @899440
     /*  899440 */   GIM_Try, /*On fail goto*//*Label 13734*/ GIMT_Encode4(899515), // Rule ID 61851 //
     /*  899445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  899456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  899459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  899462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  899465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899491 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  899494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899513 */     GIR_RootConstrainSelectedInstOperands,
     /*  899514 */     // GIR_Coverage, 61851,
     /*  899514 */     GIR_EraseRootFromParent_Done,
     /*  899515 */   // Label 13734: @899515
     /*  899515 */   GIM_Try, /*On fail goto*//*Label 13735*/ GIMT_Encode4(899590), // Rule ID 61854 //
     /*  899520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  899531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  899534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  899537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  899540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899566 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899588 */     GIR_RootConstrainSelectedInstOperands,
     /*  899589 */     // GIR_Coverage, 61854,
     /*  899589 */     GIR_EraseRootFromParent_Done,
     /*  899590 */   // Label 13735: @899590
     /*  899590 */   GIM_Try, /*On fail goto*//*Label 13736*/ GIMT_Encode4(899665), // Rule ID 61855 //
     /*  899595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  899606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  899609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  899612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  899615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899641 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899663 */     GIR_RootConstrainSelectedInstOperands,
     /*  899664 */     // GIR_Coverage, 61855,
     /*  899664 */     GIR_EraseRootFromParent_Done,
     /*  899665 */   // Label 13736: @899665
     /*  899665 */   GIM_Try, /*On fail goto*//*Label 13737*/ GIMT_Encode4(899740), // Rule ID 61858 //
     /*  899670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  899687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  899690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899716 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899738 */     GIR_RootConstrainSelectedInstOperands,
     /*  899739 */     // GIR_Coverage, 61858,
     /*  899739 */     GIR_EraseRootFromParent_Done,
     /*  899740 */   // Label 13737: @899740
     /*  899740 */   GIM_Try, /*On fail goto*//*Label 13738*/ GIMT_Encode4(899815), // Rule ID 61859 //
     /*  899745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  899762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  899765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899791 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899813 */     GIR_RootConstrainSelectedInstOperands,
     /*  899814 */     // GIR_Coverage, 61859,
     /*  899814 */     GIR_EraseRootFromParent_Done,
     /*  899815 */   // Label 13738: @899815
     /*  899815 */   GIM_Try, /*On fail goto*//*Label 13739*/ GIMT_Encode4(899890), // Rule ID 61862 //
     /*  899820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  899831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  899834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  899837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  899840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899866 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899888 */     GIR_RootConstrainSelectedInstOperands,
     /*  899889 */     // GIR_Coverage, 61862,
     /*  899889 */     GIR_EraseRootFromParent_Done,
     /*  899890 */   // Label 13739: @899890
     /*  899890 */   GIM_Try, /*On fail goto*//*Label 13740*/ GIMT_Encode4(899965), // Rule ID 61863 //
     /*  899895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  899906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  899909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  899912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  899915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899941 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899963 */     GIR_RootConstrainSelectedInstOperands,
     /*  899964 */     // GIR_Coverage, 61863,
     /*  899964 */     GIR_EraseRootFromParent_Done,
     /*  899965 */   // Label 13740: @899965
     /*  899965 */   GIM_Try, /*On fail goto*//*Label 13741*/ GIMT_Encode4(900040), // Rule ID 61866 //
     /*  899970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  899981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  899984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  899987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  899990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  900019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900038 */     GIR_RootConstrainSelectedInstOperands,
     /*  900039 */     // GIR_Coverage, 61866,
     /*  900039 */     GIR_EraseRootFromParent_Done,
     /*  900040 */   // Label 13741: @900040
     /*  900040 */   GIM_Try, /*On fail goto*//*Label 13742*/ GIMT_Encode4(900115), // Rule ID 61867 //
     /*  900045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  900056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  900059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  900062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  900065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900091 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  900094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900113 */     GIR_RootConstrainSelectedInstOperands,
     /*  900114 */     // GIR_Coverage, 61867,
     /*  900114 */     GIR_EraseRootFromParent_Done,
     /*  900115 */   // Label 13742: @900115
     /*  900115 */   GIM_Try, /*On fail goto*//*Label 13743*/ GIMT_Encode4(900190), // Rule ID 61870 //
     /*  900120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  900131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  900134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  900137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  900140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  900166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  900169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900188 */     GIR_RootConstrainSelectedInstOperands,
     /*  900189 */     // GIR_Coverage, 61870,
     /*  900189 */     GIR_EraseRootFromParent_Done,
     /*  900190 */   // Label 13743: @900190
     /*  900190 */   GIM_Try, /*On fail goto*//*Label 13744*/ GIMT_Encode4(900265), // Rule ID 61871 //
     /*  900195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  900206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  900209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  900212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  900215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900241 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  900241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  900244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900263 */     GIR_RootConstrainSelectedInstOperands,
     /*  900264 */     // GIR_Coverage, 61871,
     /*  900264 */     GIR_EraseRootFromParent_Done,
     /*  900265 */   // Label 13744: @900265
     /*  900265 */   GIM_Try, /*On fail goto*//*Label 13745*/ GIMT_Encode4(900340), // Rule ID 61874 //
     /*  900270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  900281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  900284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  900287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  900290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  900316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  900319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  900335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900338 */     GIR_RootConstrainSelectedInstOperands,
     /*  900339 */     // GIR_Coverage, 61874,
     /*  900339 */     GIR_EraseRootFromParent_Done,
     /*  900340 */   // Label 13745: @900340
     /*  900340 */   GIM_Try, /*On fail goto*//*Label 13746*/ GIMT_Encode4(900415), // Rule ID 61875 //
     /*  900345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  900356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  900359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  900362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  900365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900391 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  900391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  900394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  900410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900413 */     GIR_RootConstrainSelectedInstOperands,
     /*  900414 */     // GIR_Coverage, 61875,
     /*  900414 */     GIR_EraseRootFromParent_Done,
     /*  900415 */   // Label 13746: @900415
     /*  900415 */   GIM_Try, /*On fail goto*//*Label 13747*/ GIMT_Encode4(900490), // Rule ID 61878 //
     /*  900420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  900431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  900434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  900437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  900440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900466 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900488 */     GIR_RootConstrainSelectedInstOperands,
     /*  900489 */     // GIR_Coverage, 61878,
     /*  900489 */     GIR_EraseRootFromParent_Done,
     /*  900490 */   // Label 13747: @900490
     /*  900490 */   GIM_Try, /*On fail goto*//*Label 13748*/ GIMT_Encode4(900565), // Rule ID 61879 //
     /*  900495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  900506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  900509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  900512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  900515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900541 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900563 */     GIR_RootConstrainSelectedInstOperands,
     /*  900564 */     // GIR_Coverage, 61879,
     /*  900564 */     GIR_EraseRootFromParent_Done,
     /*  900565 */   // Label 13748: @900565
     /*  900565 */   GIM_Try, /*On fail goto*//*Label 13749*/ GIMT_Encode4(900640), // Rule ID 61882 //
     /*  900570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  900581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  900584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  900587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  900590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900616 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900638 */     GIR_RootConstrainSelectedInstOperands,
     /*  900639 */     // GIR_Coverage, 61882,
     /*  900639 */     GIR_EraseRootFromParent_Done,
     /*  900640 */   // Label 13749: @900640
     /*  900640 */   GIM_Try, /*On fail goto*//*Label 13750*/ GIMT_Encode4(900715), // Rule ID 61883 //
     /*  900645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  900656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  900659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  900662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  900665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900691 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900713 */     GIR_RootConstrainSelectedInstOperands,
     /*  900714 */     // GIR_Coverage, 61883,
     /*  900714 */     GIR_EraseRootFromParent_Done,
     /*  900715 */   // Label 13750: @900715
     /*  900715 */   GIM_Try, /*On fail goto*//*Label 13751*/ GIMT_Encode4(900790), // Rule ID 61886 //
     /*  900720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  900731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  900734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  900737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  900740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900766 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900788 */     GIR_RootConstrainSelectedInstOperands,
     /*  900789 */     // GIR_Coverage, 61886,
     /*  900789 */     GIR_EraseRootFromParent_Done,
     /*  900790 */   // Label 13751: @900790
     /*  900790 */   GIM_Try, /*On fail goto*//*Label 13752*/ GIMT_Encode4(900865), // Rule ID 61887 //
     /*  900795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  900806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  900809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  900812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  900815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900841 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900863 */     GIR_RootConstrainSelectedInstOperands,
     /*  900864 */     // GIR_Coverage, 61887,
     /*  900864 */     GIR_EraseRootFromParent_Done,
     /*  900865 */   // Label 13752: @900865
     /*  900865 */   GIM_Try, /*On fail goto*//*Label 13753*/ GIMT_Encode4(900940), // Rule ID 61890 //
     /*  900870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  900881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  900884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  900887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  900890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900938 */     GIR_RootConstrainSelectedInstOperands,
     /*  900939 */     // GIR_Coverage, 61890,
     /*  900939 */     GIR_EraseRootFromParent_Done,
     /*  900940 */   // Label 13753: @900940
     /*  900940 */   GIM_Try, /*On fail goto*//*Label 13754*/ GIMT_Encode4(901015), // Rule ID 61891 //
     /*  900945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  900956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  900959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  900962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  900965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900991 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901013 */     GIR_RootConstrainSelectedInstOperands,
     /*  901014 */     // GIR_Coverage, 61891,
     /*  901014 */     GIR_EraseRootFromParent_Done,
     /*  901015 */   // Label 13754: @901015
     /*  901015 */   GIM_Try, /*On fail goto*//*Label 13755*/ GIMT_Encode4(901090), // Rule ID 61894 //
     /*  901020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  901031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  901034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  901037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  901040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901066 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  901066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901088 */     GIR_RootConstrainSelectedInstOperands,
     /*  901089 */     // GIR_Coverage, 61894,
     /*  901089 */     GIR_EraseRootFromParent_Done,
     /*  901090 */   // Label 13755: @901090
     /*  901090 */   GIM_Try, /*On fail goto*//*Label 13756*/ GIMT_Encode4(901165), // Rule ID 61895 //
     /*  901095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  901106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  901109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  901112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  901115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901141 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  901141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901163 */     GIR_RootConstrainSelectedInstOperands,
     /*  901164 */     // GIR_Coverage, 61895,
     /*  901164 */     GIR_EraseRootFromParent_Done,
     /*  901165 */   // Label 13756: @901165
     /*  901165 */   GIM_Try, /*On fail goto*//*Label 13757*/ GIMT_Encode4(901240), // Rule ID 61898 //
     /*  901170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  901181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  901184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  901187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  901190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901216 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  901216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901238 */     GIR_RootConstrainSelectedInstOperands,
     /*  901239 */     // GIR_Coverage, 61898,
     /*  901239 */     GIR_EraseRootFromParent_Done,
     /*  901240 */   // Label 13757: @901240
     /*  901240 */   GIM_Try, /*On fail goto*//*Label 13758*/ GIMT_Encode4(901315), // Rule ID 61899 //
     /*  901245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  901256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  901259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  901262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  901265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901291 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  901291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901313 */     GIR_RootConstrainSelectedInstOperands,
     /*  901314 */     // GIR_Coverage, 61899,
     /*  901314 */     GIR_EraseRootFromParent_Done,
     /*  901315 */   // Label 13758: @901315
     /*  901315 */   GIM_Try, /*On fail goto*//*Label 13759*/ GIMT_Encode4(901390), // Rule ID 61902 //
     /*  901320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  901331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  901334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  901337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  901340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  901369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901388 */     GIR_RootConstrainSelectedInstOperands,
     /*  901389 */     // GIR_Coverage, 61902,
     /*  901389 */     GIR_EraseRootFromParent_Done,
     /*  901390 */   // Label 13759: @901390
     /*  901390 */   GIM_Try, /*On fail goto*//*Label 13760*/ GIMT_Encode4(901465), // Rule ID 61903 //
     /*  901395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  901406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  901409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  901412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  901415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  901444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901463 */     GIR_RootConstrainSelectedInstOperands,
     /*  901464 */     // GIR_Coverage, 61903,
     /*  901464 */     GIR_EraseRootFromParent_Done,
     /*  901465 */   // Label 13760: @901465
     /*  901465 */   GIM_Try, /*On fail goto*//*Label 13761*/ GIMT_Encode4(901540), // Rule ID 61906 //
     /*  901470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  901481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  901484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  901487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  901490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901538 */     GIR_RootConstrainSelectedInstOperands,
     /*  901539 */     // GIR_Coverage, 61906,
     /*  901539 */     GIR_EraseRootFromParent_Done,
     /*  901540 */   // Label 13761: @901540
     /*  901540 */   GIM_Try, /*On fail goto*//*Label 13762*/ GIMT_Encode4(901615), // Rule ID 61907 //
     /*  901545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  901556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  901559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  901562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  901565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901591 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901613 */     GIR_RootConstrainSelectedInstOperands,
     /*  901614 */     // GIR_Coverage, 61907,
     /*  901614 */     GIR_EraseRootFromParent_Done,
     /*  901615 */   // Label 13762: @901615
     /*  901615 */   GIM_Try, /*On fail goto*//*Label 13763*/ GIMT_Encode4(901690), // Rule ID 61910 //
     /*  901620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  901631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  901634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  901637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  901640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901688 */     GIR_RootConstrainSelectedInstOperands,
     /*  901689 */     // GIR_Coverage, 61910,
     /*  901689 */     GIR_EraseRootFromParent_Done,
     /*  901690 */   // Label 13763: @901690
     /*  901690 */   GIM_Try, /*On fail goto*//*Label 13764*/ GIMT_Encode4(901765), // Rule ID 61911 //
     /*  901695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  901706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  901709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  901712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  901715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901741 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901763 */     GIR_RootConstrainSelectedInstOperands,
     /*  901764 */     // GIR_Coverage, 61911,
     /*  901764 */     GIR_EraseRootFromParent_Done,
     /*  901765 */   // Label 13764: @901765
     /*  901765 */   GIM_Try, /*On fail goto*//*Label 13765*/ GIMT_Encode4(901840), // Rule ID 61914 //
     /*  901770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  901781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  901784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  901787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  901790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  901819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901838 */     GIR_RootConstrainSelectedInstOperands,
     /*  901839 */     // GIR_Coverage, 61914,
     /*  901839 */     GIR_EraseRootFromParent_Done,
     /*  901840 */   // Label 13765: @901840
     /*  901840 */   GIM_Try, /*On fail goto*//*Label 13766*/ GIMT_Encode4(901915), // Rule ID 61915 //
     /*  901845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  901856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  901859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  901862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  901865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  901891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  901894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901913 */     GIR_RootConstrainSelectedInstOperands,
     /*  901914 */     // GIR_Coverage, 61915,
     /*  901914 */     GIR_EraseRootFromParent_Done,
     /*  901915 */   // Label 13766: @901915
     /*  901915 */   GIM_Try, /*On fail goto*//*Label 13767*/ GIMT_Encode4(901990), // Rule ID 61918 //
     /*  901920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  901931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  901934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  901937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  901940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901988 */     GIR_RootConstrainSelectedInstOperands,
     /*  901989 */     // GIR_Coverage, 61918,
     /*  901989 */     GIR_EraseRootFromParent_Done,
     /*  901990 */   // Label 13767: @901990
     /*  901990 */   GIM_Try, /*On fail goto*//*Label 13768*/ GIMT_Encode4(902065), // Rule ID 61919 //
     /*  901995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  902006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  902009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  902012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  902015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902041 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  902041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  902044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902063 */     GIR_RootConstrainSelectedInstOperands,
     /*  902064 */     // GIR_Coverage, 61919,
     /*  902064 */     GIR_EraseRootFromParent_Done,
     /*  902065 */   // Label 13768: @902065
     /*  902065 */   GIM_Try, /*On fail goto*//*Label 13769*/ GIMT_Encode4(902140), // Rule ID 61922 //
     /*  902070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  902081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  902084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  902087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  902090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  902116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  902119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902138 */     GIR_RootConstrainSelectedInstOperands,
     /*  902139 */     // GIR_Coverage, 61922,
     /*  902139 */     GIR_EraseRootFromParent_Done,
     /*  902140 */   // Label 13769: @902140
     /*  902140 */   GIM_Try, /*On fail goto*//*Label 13770*/ GIMT_Encode4(902215), // Rule ID 61923 //
     /*  902145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  902156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  902159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  902162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  902165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902191 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  902191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  902194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902213 */     GIR_RootConstrainSelectedInstOperands,
     /*  902214 */     // GIR_Coverage, 61923,
     /*  902214 */     GIR_EraseRootFromParent_Done,
     /*  902215 */   // Label 13770: @902215
     /*  902215 */   GIM_Try, /*On fail goto*//*Label 13771*/ GIMT_Encode4(902290), // Rule ID 61926 //
     /*  902220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  902231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  902234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  902237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902266 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  902269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902288 */     GIR_RootConstrainSelectedInstOperands,
     /*  902289 */     // GIR_Coverage, 61926,
     /*  902289 */     GIR_EraseRootFromParent_Done,
     /*  902290 */   // Label 13771: @902290
     /*  902290 */   GIM_Try, /*On fail goto*//*Label 13772*/ GIMT_Encode4(902365), // Rule ID 61927 //
     /*  902295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  902306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  902309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  902312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902341 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  902344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902363 */     GIR_RootConstrainSelectedInstOperands,
     /*  902364 */     // GIR_Coverage, 61927,
     /*  902364 */     GIR_EraseRootFromParent_Done,
     /*  902365 */   // Label 13772: @902365
     /*  902365 */   GIM_Try, /*On fail goto*//*Label 13773*/ GIMT_Encode4(902440), // Rule ID 61930 //
     /*  902370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  902381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  902384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  902387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902416 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902438 */     GIR_RootConstrainSelectedInstOperands,
     /*  902439 */     // GIR_Coverage, 61930,
     /*  902439 */     GIR_EraseRootFromParent_Done,
     /*  902440 */   // Label 13773: @902440
     /*  902440 */   GIM_Try, /*On fail goto*//*Label 13774*/ GIMT_Encode4(902515), // Rule ID 61931 //
     /*  902445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  902456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  902459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  902462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902491 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902513 */     GIR_RootConstrainSelectedInstOperands,
     /*  902514 */     // GIR_Coverage, 61931,
     /*  902514 */     GIR_EraseRootFromParent_Done,
     /*  902515 */   // Label 13774: @902515
     /*  902515 */   GIM_Try, /*On fail goto*//*Label 13775*/ GIMT_Encode4(902590), // Rule ID 61934 //
     /*  902520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  902531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  902534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902566 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902588 */     GIR_RootConstrainSelectedInstOperands,
     /*  902589 */     // GIR_Coverage, 61934,
     /*  902589 */     GIR_EraseRootFromParent_Done,
     /*  902590 */   // Label 13775: @902590
     /*  902590 */   GIM_Try, /*On fail goto*//*Label 13776*/ GIMT_Encode4(902665), // Rule ID 61935 //
     /*  902595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  902606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  902609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902641 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902663 */     GIR_RootConstrainSelectedInstOperands,
     /*  902664 */     // GIR_Coverage, 61935,
     /*  902664 */     GIR_EraseRootFromParent_Done,
     /*  902665 */   // Label 13776: @902665
     /*  902665 */   GIM_Try, /*On fail goto*//*Label 13777*/ GIMT_Encode4(902740), // Rule ID 61938 //
     /*  902670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  902681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  902684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902716 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902738 */     GIR_RootConstrainSelectedInstOperands,
     /*  902739 */     // GIR_Coverage, 61938,
     /*  902739 */     GIR_EraseRootFromParent_Done,
     /*  902740 */   // Label 13777: @902740
     /*  902740 */   GIM_Try, /*On fail goto*//*Label 13778*/ GIMT_Encode4(902815), // Rule ID 61939 //
     /*  902745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  902756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  902759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902791 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902813 */     GIR_RootConstrainSelectedInstOperands,
     /*  902814 */     // GIR_Coverage, 61939,
     /*  902814 */     GIR_EraseRootFromParent_Done,
     /*  902815 */   // Label 13778: @902815
     /*  902815 */   GIM_Try, /*On fail goto*//*Label 13779*/ GIMT_Encode4(902890), // Rule ID 61942 //
     /*  902820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902866 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902888 */     GIR_RootConstrainSelectedInstOperands,
     /*  902889 */     // GIR_Coverage, 61942,
     /*  902889 */     GIR_EraseRootFromParent_Done,
     /*  902890 */   // Label 13779: @902890
     /*  902890 */   GIM_Try, /*On fail goto*//*Label 13780*/ GIMT_Encode4(902965), // Rule ID 61943 //
     /*  902895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902941 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902963 */     GIR_RootConstrainSelectedInstOperands,
     /*  902964 */     // GIR_Coverage, 61943,
     /*  902964 */     GIR_EraseRootFromParent_Done,
     /*  902965 */   // Label 13780: @902965
     /*  902965 */   GIM_Try, /*On fail goto*//*Label 13781*/ GIMT_Encode4(903040), // Rule ID 61946 //
     /*  902970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  902981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  902984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  902987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  903016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  903019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903038 */     GIR_RootConstrainSelectedInstOperands,
     /*  903039 */     // GIR_Coverage, 61946,
     /*  903039 */     GIR_EraseRootFromParent_Done,
     /*  903040 */   // Label 13781: @903040
     /*  903040 */   GIM_Try, /*On fail goto*//*Label 13782*/ GIMT_Encode4(903115), // Rule ID 61947 //
     /*  903045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  903056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  903059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  903062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903091 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  903091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  903094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903113 */     GIR_RootConstrainSelectedInstOperands,
     /*  903114 */     // GIR_Coverage, 61947,
     /*  903114 */     GIR_EraseRootFromParent_Done,
     /*  903115 */   // Label 13782: @903115
     /*  903115 */   GIM_Try, /*On fail goto*//*Label 13783*/ GIMT_Encode4(903190), // Rule ID 61950 //
     /*  903120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  903131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  903134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  903137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903166 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903188 */     GIR_RootConstrainSelectedInstOperands,
     /*  903189 */     // GIR_Coverage, 61950,
     /*  903189 */     GIR_EraseRootFromParent_Done,
     /*  903190 */   // Label 13783: @903190
     /*  903190 */   GIM_Try, /*On fail goto*//*Label 13784*/ GIMT_Encode4(903265), // Rule ID 61951 //
     /*  903195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  903206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  903209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  903212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903241 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903263 */     GIR_RootConstrainSelectedInstOperands,
     /*  903264 */     // GIR_Coverage, 61951,
     /*  903264 */     GIR_EraseRootFromParent_Done,
     /*  903265 */   // Label 13784: @903265
     /*  903265 */   GIM_Try, /*On fail goto*//*Label 13785*/ GIMT_Encode4(903340), // Rule ID 61954 //
     /*  903270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  903281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  903284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  903287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  903316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903338 */     GIR_RootConstrainSelectedInstOperands,
     /*  903339 */     // GIR_Coverage, 61954,
     /*  903339 */     GIR_EraseRootFromParent_Done,
     /*  903340 */   // Label 13785: @903340
     /*  903340 */   GIM_Try, /*On fail goto*//*Label 13786*/ GIMT_Encode4(903415), // Rule ID 61955 //
     /*  903345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  903356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  903359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  903362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903391 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903413 */     GIR_RootConstrainSelectedInstOperands,
     /*  903414 */     // GIR_Coverage, 61955,
     /*  903414 */     GIR_EraseRootFromParent_Done,
     /*  903415 */   // Label 13786: @903415
     /*  903415 */   GIM_Try, /*On fail goto*//*Label 13787*/ GIMT_Encode4(903490), // Rule ID 61958 //
     /*  903420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  903431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  903434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  903437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  903466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903488 */     GIR_RootConstrainSelectedInstOperands,
     /*  903489 */     // GIR_Coverage, 61958,
     /*  903489 */     GIR_EraseRootFromParent_Done,
     /*  903490 */   // Label 13787: @903490
     /*  903490 */   GIM_Try, /*On fail goto*//*Label 13788*/ GIMT_Encode4(903565), // Rule ID 61959 //
     /*  903495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  903506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  903509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  903512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903541 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  903541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903563 */     GIR_RootConstrainSelectedInstOperands,
     /*  903564 */     // GIR_Coverage, 61959,
     /*  903564 */     GIR_EraseRootFromParent_Done,
     /*  903565 */   // Label 13788: @903565
     /*  903565 */   GIM_Try, /*On fail goto*//*Label 13789*/ GIMT_Encode4(903640), // Rule ID 61962 //
     /*  903570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  903587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903616 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  903616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903638 */     GIR_RootConstrainSelectedInstOperands,
     /*  903639 */     // GIR_Coverage, 61962,
     /*  903639 */     GIR_EraseRootFromParent_Done,
     /*  903640 */   // Label 13789: @903640
     /*  903640 */   GIM_Try, /*On fail goto*//*Label 13790*/ GIMT_Encode4(903715), // Rule ID 61963 //
     /*  903645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  903662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903691 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  903691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903713 */     GIR_RootConstrainSelectedInstOperands,
     /*  903714 */     // GIR_Coverage, 61963,
     /*  903714 */     GIR_EraseRootFromParent_Done,
     /*  903715 */   // Label 13790: @903715
     /*  903715 */   GIM_Try, /*On fail goto*//*Label 13791*/ GIMT_Encode4(903790), // Rule ID 61966 //
     /*  903720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  903731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  903734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  903737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903766 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903788 */     GIR_RootConstrainSelectedInstOperands,
     /*  903789 */     // GIR_Coverage, 61966,
     /*  903789 */     GIR_EraseRootFromParent_Done,
     /*  903790 */   // Label 13791: @903790
     /*  903790 */   GIM_Try, /*On fail goto*//*Label 13792*/ GIMT_Encode4(903865), // Rule ID 61967 //
     /*  903795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  903806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  903809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  903812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903841 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903863 */     GIR_RootConstrainSelectedInstOperands,
     /*  903864 */     // GIR_Coverage, 61967,
     /*  903864 */     GIR_EraseRootFromParent_Done,
     /*  903865 */   // Label 13792: @903865
     /*  903865 */   GIM_Try, /*On fail goto*//*Label 13793*/ GIMT_Encode4(903940), // Rule ID 61970 //
     /*  903870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  903881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  903884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  903887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903916 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903938 */     GIR_RootConstrainSelectedInstOperands,
     /*  903939 */     // GIR_Coverage, 61970,
     /*  903939 */     GIR_EraseRootFromParent_Done,
     /*  903940 */   // Label 13793: @903940
     /*  903940 */   GIM_Try, /*On fail goto*//*Label 13794*/ GIMT_Encode4(904015), // Rule ID 61971 //
     /*  903945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  903956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  903959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  903962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903991 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904013 */     GIR_RootConstrainSelectedInstOperands,
     /*  904014 */     // GIR_Coverage, 61971,
     /*  904014 */     GIR_EraseRootFromParent_Done,
     /*  904015 */   // Label 13794: @904015
     /*  904015 */   GIM_Try, /*On fail goto*//*Label 13795*/ GIMT_Encode4(904090), // Rule ID 61974 //
     /*  904020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  904031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  904034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  904037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904066 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  904066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904088 */     GIR_RootConstrainSelectedInstOperands,
     /*  904089 */     // GIR_Coverage, 61974,
     /*  904089 */     GIR_EraseRootFromParent_Done,
     /*  904090 */   // Label 13795: @904090
     /*  904090 */   GIM_Try, /*On fail goto*//*Label 13796*/ GIMT_Encode4(904165), // Rule ID 61975 //
     /*  904095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  904106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  904109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  904112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904141 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  904141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904163 */     GIR_RootConstrainSelectedInstOperands,
     /*  904164 */     // GIR_Coverage, 61975,
     /*  904164 */     GIR_EraseRootFromParent_Done,
     /*  904165 */   // Label 13796: @904165
     /*  904165 */   GIM_Try, /*On fail goto*//*Label 13797*/ GIMT_Encode4(904240), // Rule ID 61978 //
     /*  904170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  904181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  904184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  904187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904238 */     GIR_RootConstrainSelectedInstOperands,
     /*  904239 */     // GIR_Coverage, 61978,
     /*  904239 */     GIR_EraseRootFromParent_Done,
     /*  904240 */   // Label 13797: @904240
     /*  904240 */   GIM_Try, /*On fail goto*//*Label 13798*/ GIMT_Encode4(904315), // Rule ID 61979 //
     /*  904245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  904256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  904259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  904262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904291 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904313 */     GIR_RootConstrainSelectedInstOperands,
     /*  904314 */     // GIR_Coverage, 61979,
     /*  904314 */     GIR_EraseRootFromParent_Done,
     /*  904315 */   // Label 13798: @904315
     /*  904315 */   GIM_Try, /*On fail goto*//*Label 13799*/ GIMT_Encode4(904390), // Rule ID 61982 //
     /*  904320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  904331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  904334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  904337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904366 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904388 */     GIR_RootConstrainSelectedInstOperands,
     /*  904389 */     // GIR_Coverage, 61982,
     /*  904389 */     GIR_EraseRootFromParent_Done,
     /*  904390 */   // Label 13799: @904390
     /*  904390 */   GIM_Try, /*On fail goto*//*Label 13800*/ GIMT_Encode4(904465), // Rule ID 61983 //
     /*  904395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  904406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  904409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  904412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904441 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904463 */     GIR_RootConstrainSelectedInstOperands,
     /*  904464 */     // GIR_Coverage, 61983,
     /*  904464 */     GIR_EraseRootFromParent_Done,
     /*  904465 */   // Label 13800: @904465
     /*  904465 */   GIM_Try, /*On fail goto*//*Label 13801*/ GIMT_Encode4(904540), // Rule ID 61986 //
     /*  904470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  904481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  904484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  904487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904516 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904538 */     GIR_RootConstrainSelectedInstOperands,
     /*  904539 */     // GIR_Coverage, 61986,
     /*  904539 */     GIR_EraseRootFromParent_Done,
     /*  904540 */   // Label 13801: @904540
     /*  904540 */   GIM_Try, /*On fail goto*//*Label 13802*/ GIMT_Encode4(904615), // Rule ID 61987 //
     /*  904545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  904556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  904559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  904562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904591 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904613 */     GIR_RootConstrainSelectedInstOperands,
     /*  904614 */     // GIR_Coverage, 61987,
     /*  904614 */     GIR_EraseRootFromParent_Done,
     /*  904615 */   // Label 13802: @904615
     /*  904615 */   GIM_Try, /*On fail goto*//*Label 13803*/ GIMT_Encode4(904690), // Rule ID 61990 //
     /*  904620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904666 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904688 */     GIR_RootConstrainSelectedInstOperands,
     /*  904689 */     // GIR_Coverage, 61990,
     /*  904689 */     GIR_EraseRootFromParent_Done,
     /*  904690 */   // Label 13803: @904690
     /*  904690 */   GIM_Try, /*On fail goto*//*Label 13804*/ GIMT_Encode4(904765), // Rule ID 61991 //
     /*  904695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904763 */     GIR_RootConstrainSelectedInstOperands,
     /*  904764 */     // GIR_Coverage, 61991,
     /*  904764 */     GIR_EraseRootFromParent_Done,
     /*  904765 */   // Label 13804: @904765
     /*  904765 */   GIM_Try, /*On fail goto*//*Label 13805*/ GIMT_Encode4(904840), // Rule ID 61994 //
     /*  904770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904816 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904838 */     GIR_RootConstrainSelectedInstOperands,
     /*  904839 */     // GIR_Coverage, 61994,
     /*  904839 */     GIR_EraseRootFromParent_Done,
     /*  904840 */   // Label 13805: @904840
     /*  904840 */   GIM_Try, /*On fail goto*//*Label 13806*/ GIMT_Encode4(904915), // Rule ID 61995 //
     /*  904845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904891 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904913 */     GIR_RootConstrainSelectedInstOperands,
     /*  904914 */     // GIR_Coverage, 61995,
     /*  904914 */     GIR_EraseRootFromParent_Done,
     /*  904915 */   // Label 13806: @904915
     /*  904915 */   GIM_Try, /*On fail goto*//*Label 13807*/ GIMT_Encode4(904990), // Rule ID 61998 //
     /*  904920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  904931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  904934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  904937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904966 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904988 */     GIR_RootConstrainSelectedInstOperands,
     /*  904989 */     // GIR_Coverage, 61998,
     /*  904989 */     GIR_EraseRootFromParent_Done,
     /*  904990 */   // Label 13807: @904990
     /*  904990 */   GIM_Try, /*On fail goto*//*Label 13808*/ GIMT_Encode4(905065), // Rule ID 61999 //
     /*  904995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  905006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905041 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  905044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905063 */     GIR_RootConstrainSelectedInstOperands,
     /*  905064 */     // GIR_Coverage, 61999,
     /*  905064 */     GIR_EraseRootFromParent_Done,
     /*  905065 */   // Label 13808: @905065
     /*  905065 */   GIM_Try, /*On fail goto*//*Label 13809*/ GIMT_Encode4(905140), // Rule ID 62002 //
     /*  905070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  905081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  905084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  905087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  905090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  905116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  905119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905138 */     GIR_RootConstrainSelectedInstOperands,
     /*  905139 */     // GIR_Coverage, 62002,
     /*  905139 */     GIR_EraseRootFromParent_Done,
     /*  905140 */   // Label 13809: @905140
     /*  905140 */   GIM_Try, /*On fail goto*//*Label 13810*/ GIMT_Encode4(905215), // Rule ID 62003 //
     /*  905145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  905156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  905159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  905162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905191 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  905194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905213 */     GIR_RootConstrainSelectedInstOperands,
     /*  905214 */     // GIR_Coverage, 62003,
     /*  905214 */     GIR_EraseRootFromParent_Done,
     /*  905215 */   // Label 13810: @905215
     /*  905215 */   GIM_Try, /*On fail goto*//*Label 13811*/ GIMT_Encode4(905290), // Rule ID 62006 //
     /*  905220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  905231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  905234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  905237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  905240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905266 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  905266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  905269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905288 */     GIR_RootConstrainSelectedInstOperands,
     /*  905289 */     // GIR_Coverage, 62006,
     /*  905289 */     GIR_EraseRootFromParent_Done,
     /*  905290 */   // Label 13811: @905290
     /*  905290 */   GIM_Try, /*On fail goto*//*Label 13812*/ GIMT_Encode4(905365), // Rule ID 62007 //
     /*  905295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  905306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  905309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  905312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905341 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  905344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905363 */     GIR_RootConstrainSelectedInstOperands,
     /*  905364 */     // GIR_Coverage, 62007,
     /*  905364 */     GIR_EraseRootFromParent_Done,
     /*  905365 */   // Label 13812: @905365
     /*  905365 */   GIM_Try, /*On fail goto*//*Label 13813*/ GIMT_Encode4(905440), // Rule ID 62010 //
     /*  905370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  905381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  905384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  905387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  905390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905416 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  905416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  905419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905438 */     GIR_RootConstrainSelectedInstOperands,
     /*  905439 */     // GIR_Coverage, 62010,
     /*  905439 */     GIR_EraseRootFromParent_Done,
     /*  905440 */   // Label 13813: @905440
     /*  905440 */   GIM_Try, /*On fail goto*//*Label 13814*/ GIMT_Encode4(905515), // Rule ID 62011 //
     /*  905445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  905456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  905459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  905462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905491 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  905494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905513 */     GIR_RootConstrainSelectedInstOperands,
     /*  905514 */     // GIR_Coverage, 62011,
     /*  905514 */     GIR_EraseRootFromParent_Done,
     /*  905515 */   // Label 13814: @905515
     /*  905515 */   GIM_Try, /*On fail goto*//*Label 13815*/ GIMT_Encode4(905590), // Rule ID 62454 //
     /*  905520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  905531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  905534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  905537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  905540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905566 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  905569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905588 */     GIR_RootConstrainSelectedInstOperands,
     /*  905589 */     // GIR_Coverage, 62454,
     /*  905589 */     GIR_EraseRootFromParent_Done,
     /*  905590 */   // Label 13815: @905590
     /*  905590 */   GIM_Try, /*On fail goto*//*Label 13816*/ GIMT_Encode4(905665), // Rule ID 62455 //
     /*  905595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  905606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  905609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  905612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  905615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905641 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  905644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905663 */     GIR_RootConstrainSelectedInstOperands,
     /*  905664 */     // GIR_Coverage, 62455,
     /*  905664 */     GIR_EraseRootFromParent_Done,
     /*  905665 */   // Label 13816: @905665
     /*  905665 */   GIM_Try, /*On fail goto*//*Label 13817*/ GIMT_Encode4(905740), // Rule ID 62456 //
     /*  905670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  905681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  905684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  905687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  905690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905716 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  905719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905738 */     GIR_RootConstrainSelectedInstOperands,
     /*  905739 */     // GIR_Coverage, 62456,
     /*  905739 */     GIR_EraseRootFromParent_Done,
     /*  905740 */   // Label 13817: @905740
     /*  905740 */   GIM_Try, /*On fail goto*//*Label 13818*/ GIMT_Encode4(905815), // Rule ID 62457 //
     /*  905745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  905756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  905759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  905762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  905765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  905794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905813 */     GIR_RootConstrainSelectedInstOperands,
     /*  905814 */     // GIR_Coverage, 62457,
     /*  905814 */     GIR_EraseRootFromParent_Done,
     /*  905815 */   // Label 13818: @905815
     /*  905815 */   GIM_Try, /*On fail goto*//*Label 13819*/ GIMT_Encode4(905890), // Rule ID 62458 //
     /*  905820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  905831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  905834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  905837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  905840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  905869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905888 */     GIR_RootConstrainSelectedInstOperands,
     /*  905889 */     // GIR_Coverage, 62458,
     /*  905889 */     GIR_EraseRootFromParent_Done,
     /*  905890 */   // Label 13819: @905890
     /*  905890 */   GIM_Try, /*On fail goto*//*Label 13820*/ GIMT_Encode4(905965), // Rule ID 62459 //
     /*  905895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  905906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  905909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  905912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  905915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905941 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  905944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905963 */     GIR_RootConstrainSelectedInstOperands,
     /*  905964 */     // GIR_Coverage, 62459,
     /*  905964 */     GIR_EraseRootFromParent_Done,
     /*  905965 */   // Label 13820: @905965
     /*  905965 */   GIM_Try, /*On fail goto*//*Label 13821*/ GIMT_Encode4(906040), // Rule ID 62460 //
     /*  905970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  905981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  905990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  906016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  906019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906038 */     GIR_RootConstrainSelectedInstOperands,
     /*  906039 */     // GIR_Coverage, 62460,
     /*  906039 */     GIR_EraseRootFromParent_Done,
     /*  906040 */   // Label 13821: @906040
     /*  906040 */   GIM_Try, /*On fail goto*//*Label 13822*/ GIMT_Encode4(906115), // Rule ID 62461 //
     /*  906045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  906048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  906053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  906056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  906059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  906062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  906065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906091 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  906091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  906094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906113 */     GIR_RootConstrainSelectedInstOperands,
     /*  906114 */     // GIR_Coverage, 62461,
     /*  906114 */     GIR_EraseRootFromParent_Done,
     /*  906115 */   // Label 13822: @906115
     /*  906115 */   GIM_Try, /*On fail goto*//*Label 13823*/ GIMT_Encode4(906179), // Rule ID 64530 //
     /*  906120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuN),
     /*  906128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906156 */     // MIs[0] imm5
     /*  906156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906164 */     // (intrinsic_wo_chain:{ *:[i32] } 11046:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACUN),
     /*  906167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906175 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906177 */     GIR_RootConstrainSelectedInstOperands,
     /*  906178 */     // GIR_Coverage, 64530,
     /*  906178 */     GIR_EraseRootFromParent_Done,
     /*  906179 */   // Label 13823: @906179
     /*  906179 */   GIM_Try, /*On fail goto*//*Label 13824*/ GIMT_Encode4(906243), // Rule ID 64531 //
     /*  906184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuN),
     /*  906192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906220 */     // MIs[0] imm5
     /*  906220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906228 */     // (intrinsic_wo_chain:{ *:[i32] } 11042:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHUN),
     /*  906231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906239 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906241 */     GIR_RootConstrainSelectedInstOperands,
     /*  906242 */     // GIR_Coverage, 64531,
     /*  906242 */     GIR_EraseRootFromParent_Done,
     /*  906243 */   // Label 13824: @906243
     /*  906243 */   GIM_Try, /*On fail goto*//*Label 13825*/ GIMT_Encode4(906307), // Rule ID 64532 //
     /*  906248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsN),
     /*  906256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906284 */     // MIs[0] imm5
     /*  906284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906292 */     // (intrinsic_wo_chain:{ *:[i32] } 11044:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSN),
     /*  906295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906303 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906305 */     GIR_RootConstrainSelectedInstOperands,
     /*  906306 */     // GIR_Coverage, 64532,
     /*  906306 */     GIR_EraseRootFromParent_Done,
     /*  906307 */   // Label 13825: @906307
     /*  906307 */   GIM_Try, /*On fail goto*//*Label 13826*/ GIMT_Encode4(906371), // Rule ID 64533 //
     /*  906312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsN),
     /*  906320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906348 */     // MIs[0] imm5
     /*  906348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906356 */     // (intrinsic_wo_chain:{ *:[i32] } 11040:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSN),
     /*  906359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906367 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906369 */     GIR_RootConstrainSelectedInstOperands,
     /*  906370 */     // GIR_Coverage, 64533,
     /*  906370 */     GIR_EraseRootFromParent_Done,
     /*  906371 */   // Label 13826: @906371
     /*  906371 */   GIM_Try, /*On fail goto*//*Label 13827*/ GIMT_Encode4(906435), // Rule ID 64534 //
     /*  906376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuRN),
     /*  906384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906412 */     // MIs[0] imm5
     /*  906412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906420 */     // (intrinsic_wo_chain:{ *:[i32] } 11047:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACURN),
     /*  906423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906431 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906433 */     GIR_RootConstrainSelectedInstOperands,
     /*  906434 */     // GIR_Coverage, 64534,
     /*  906434 */     GIR_EraseRootFromParent_Done,
     /*  906435 */   // Label 13827: @906435
     /*  906435 */   GIM_Try, /*On fail goto*//*Label 13828*/ GIMT_Encode4(906499), // Rule ID 64535 //
     /*  906440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuRN),
     /*  906448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906476 */     // MIs[0] imm5
     /*  906476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906479 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906484 */     // (intrinsic_wo_chain:{ *:[i32] } 11043:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHURN),
     /*  906487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906495 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906497 */     GIR_RootConstrainSelectedInstOperands,
     /*  906498 */     // GIR_Coverage, 64535,
     /*  906498 */     GIR_EraseRootFromParent_Done,
     /*  906499 */   // Label 13828: @906499
     /*  906499 */   GIM_Try, /*On fail goto*//*Label 13829*/ GIMT_Encode4(906563), // Rule ID 64536 //
     /*  906504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsRN),
     /*  906512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906540 */     // MIs[0] imm5
     /*  906540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906548 */     // (intrinsic_wo_chain:{ *:[i32] } 11045:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSRN),
     /*  906551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906559 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906561 */     GIR_RootConstrainSelectedInstOperands,
     /*  906562 */     // GIR_Coverage, 64536,
     /*  906562 */     GIR_EraseRootFromParent_Done,
     /*  906563 */   // Label 13829: @906563
     /*  906563 */   GIM_Try, /*On fail goto*//*Label 13830*/ GIMT_Encode4(906627), // Rule ID 64537 //
     /*  906568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsRN),
     /*  906576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906604 */     // MIs[0] imm5
     /*  906604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906607 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906612 */     // (intrinsic_wo_chain:{ *:[i32] } 11041:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSRN),
     /*  906615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906623 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906625 */     GIR_RootConstrainSelectedInstOperands,
     /*  906626 */     // GIR_Coverage, 64537,
     /*  906626 */     GIR_EraseRootFromParent_Done,
     /*  906627 */   // Label 13830: @906627
     /*  906627 */   GIM_Reject,
     /*  906628 */ // Label 6984: @906628
     /*  906628 */ GIM_Try, /*On fail goto*//*Label 13831*/ GIMT_Encode4(1402179),
     /*  906633 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  906636 */   GIM_Try, /*On fail goto*//*Label 13832*/ GIMT_Encode4(906719), // Rule ID 62869 //
     /*  906641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  906652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  906655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  906658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906665 */     // MIs[0] op1
     /*  906665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906681 */     // MIs[0] op4
     /*  906681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906696 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  906696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF8),
     /*  906699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906701 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906703 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906705 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906707 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906717 */     GIR_RootConstrainSelectedInstOperands,
     /*  906718 */     // GIR_Coverage, 62869,
     /*  906718 */     GIR_EraseRootFromParent_Done,
     /*  906719 */   // Label 13832: @906719
     /*  906719 */   GIM_Try, /*On fail goto*//*Label 13833*/ GIMT_Encode4(906802), // Rule ID 62870 //
     /*  906724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  906735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  906738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  906741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906748 */     // MIs[0] op1
     /*  906748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906764 */     // MIs[0] op4
     /*  906764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906767 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906779 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  906779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF8),
     /*  906782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906784 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906786 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906788 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906790 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906800 */     GIR_RootConstrainSelectedInstOperands,
     /*  906801 */     // GIR_Coverage, 62870,
     /*  906801 */     GIR_EraseRootFromParent_Done,
     /*  906802 */   // Label 13833: @906802
     /*  906802 */   GIM_Try, /*On fail goto*//*Label 13834*/ GIMT_Encode4(906885), // Rule ID 62913 //
     /*  906807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  906818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  906821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  906824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906831 */     // MIs[0] op1
     /*  906831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906847 */     // MIs[0] op4
     /*  906847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906850 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906862 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  906862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF4),
     /*  906865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906867 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906869 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906871 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906873 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906883 */     GIR_RootConstrainSelectedInstOperands,
     /*  906884 */     // GIR_Coverage, 62913,
     /*  906884 */     GIR_EraseRootFromParent_Done,
     /*  906885 */   // Label 13834: @906885
     /*  906885 */   GIM_Try, /*On fail goto*//*Label 13835*/ GIMT_Encode4(906968), // Rule ID 62914 //
     /*  906890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  906901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  906904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  906907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906914 */     // MIs[0] op1
     /*  906914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906930 */     // MIs[0] op4
     /*  906930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906945 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  906945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF4),
     /*  906948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906950 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906952 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906954 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906956 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906966 */     GIR_RootConstrainSelectedInstOperands,
     /*  906967 */     // GIR_Coverage, 62914,
     /*  906967 */     GIR_EraseRootFromParent_Done,
     /*  906968 */   // Label 13835: @906968
     /*  906968 */   GIM_Try, /*On fail goto*//*Label 13836*/ GIMT_Encode4(907051), // Rule ID 62957 //
     /*  906973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  906984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  906987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  906990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906997 */     // MIs[0] op1
     /*  906997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907013 */     // MIs[0] op4
     /*  907013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907016 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907028 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  907028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907033 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907035 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907037 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907039 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907049 */     GIR_RootConstrainSelectedInstOperands,
     /*  907050 */     // GIR_Coverage, 62957,
     /*  907050 */     GIR_EraseRootFromParent_Done,
     /*  907051 */   // Label 13836: @907051
     /*  907051 */   GIM_Try, /*On fail goto*//*Label 13837*/ GIMT_Encode4(907134), // Rule ID 62958 //
     /*  907056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  907067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  907070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  907073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907080 */     // MIs[0] op1
     /*  907080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907096 */     // MIs[0] op4
     /*  907096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907111 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  907111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907116 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907118 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907120 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907122 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907132 */     GIR_RootConstrainSelectedInstOperands,
     /*  907133 */     // GIR_Coverage, 62958,
     /*  907133 */     GIR_EraseRootFromParent_Done,
     /*  907134 */   // Label 13837: @907134
     /*  907134 */   GIM_Try, /*On fail goto*//*Label 13838*/ GIMT_Encode4(907217), // Rule ID 63001 //
     /*  907139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  907150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  907153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  907156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907163 */     // MIs[0] op1
     /*  907163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907166 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907179 */     // MIs[0] op4
     /*  907179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  907194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF4),
     /*  907197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907199 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907201 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907203 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907205 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907215 */     GIR_RootConstrainSelectedInstOperands,
     /*  907216 */     // GIR_Coverage, 63001,
     /*  907216 */     GIR_EraseRootFromParent_Done,
     /*  907217 */   // Label 13838: @907217
     /*  907217 */   GIM_Try, /*On fail goto*//*Label 13839*/ GIMT_Encode4(907300), // Rule ID 63002 //
     /*  907222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  907233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  907236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  907239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907246 */     // MIs[0] op1
     /*  907246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907249 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907262 */     // MIs[0] op4
     /*  907262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907277 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  907277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF4),
     /*  907280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907282 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907284 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907286 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907288 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907298 */     GIR_RootConstrainSelectedInstOperands,
     /*  907299 */     // GIR_Coverage, 63002,
     /*  907299 */     GIR_EraseRootFromParent_Done,
     /*  907300 */   // Label 13839: @907300
     /*  907300 */   GIM_Try, /*On fail goto*//*Label 13840*/ GIMT_Encode4(907383), // Rule ID 63057 //
     /*  907305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  907316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  907319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  907322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907329 */     // MIs[0] op1
     /*  907329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907345 */     // MIs[0] op4
     /*  907345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907360 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  907360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907365 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907367 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907369 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907371 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907381 */     GIR_RootConstrainSelectedInstOperands,
     /*  907382 */     // GIR_Coverage, 63057,
     /*  907382 */     GIR_EraseRootFromParent_Done,
     /*  907383 */   // Label 13840: @907383
     /*  907383 */   GIM_Try, /*On fail goto*//*Label 13841*/ GIMT_Encode4(907466), // Rule ID 63058 //
     /*  907388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  907399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  907402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  907405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907412 */     // MIs[0] op1
     /*  907412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907428 */     // MIs[0] op4
     /*  907428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907431 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907443 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  907443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907448 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907450 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907452 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907454 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907464 */     GIR_RootConstrainSelectedInstOperands,
     /*  907465 */     // GIR_Coverage, 63058,
     /*  907465 */     GIR_EraseRootFromParent_Done,
     /*  907466 */   // Label 13841: @907466
     /*  907466 */   GIM_Try, /*On fail goto*//*Label 13842*/ GIMT_Encode4(907549), // Rule ID 63113 //
     /*  907471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  907482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  907485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  907488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907495 */     // MIs[0] op1
     /*  907495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907511 */     // MIs[0] op4
     /*  907511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907526 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  907526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907531 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907533 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907535 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907537 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907547 */     GIR_RootConstrainSelectedInstOperands,
     /*  907548 */     // GIR_Coverage, 63113,
     /*  907548 */     GIR_EraseRootFromParent_Done,
     /*  907549 */   // Label 13842: @907549
     /*  907549 */   GIM_Try, /*On fail goto*//*Label 13843*/ GIMT_Encode4(907632), // Rule ID 63114 //
     /*  907554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  907565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  907568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  907571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907578 */     // MIs[0] op1
     /*  907578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907594 */     // MIs[0] op4
     /*  907594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907609 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  907609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907614 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907616 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907618 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907620 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907630 */     GIR_RootConstrainSelectedInstOperands,
     /*  907631 */     // GIR_Coverage, 63114,
     /*  907631 */     GIR_EraseRootFromParent_Done,
     /*  907632 */   // Label 13843: @907632
     /*  907632 */   GIM_Try, /*On fail goto*//*Label 13844*/ GIMT_Encode4(907715), // Rule ID 63169 //
     /*  907637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  907648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  907651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  907654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907661 */     // MIs[0] op1
     /*  907661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907677 */     // MIs[0] op4
     /*  907677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907692 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  907692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907697 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907699 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907701 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907703 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907713 */     GIR_RootConstrainSelectedInstOperands,
     /*  907714 */     // GIR_Coverage, 63169,
     /*  907714 */     GIR_EraseRootFromParent_Done,
     /*  907715 */   // Label 13844: @907715
     /*  907715 */   GIM_Try, /*On fail goto*//*Label 13845*/ GIMT_Encode4(907798), // Rule ID 63170 //
     /*  907720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  907731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  907734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  907737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907744 */     // MIs[0] op1
     /*  907744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907760 */     // MIs[0] op4
     /*  907760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907775 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  907775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907780 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907782 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907784 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907786 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907796 */     GIR_RootConstrainSelectedInstOperands,
     /*  907797 */     // GIR_Coverage, 63170,
     /*  907797 */     GIR_EraseRootFromParent_Done,
     /*  907798 */   // Label 13845: @907798
     /*  907798 */   GIM_Try, /*On fail goto*//*Label 13846*/ GIMT_Encode4(907881), // Rule ID 63213 //
     /*  907803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  907814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  907817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  907820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907827 */     // MIs[0] op1
     /*  907827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907843 */     // MIs[0] op4
     /*  907843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907858 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  907858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907863 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907865 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907867 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907869 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907879 */     GIR_RootConstrainSelectedInstOperands,
     /*  907880 */     // GIR_Coverage, 63213,
     /*  907880 */     GIR_EraseRootFromParent_Done,
     /*  907881 */   // Label 13846: @907881
     /*  907881 */   GIM_Try, /*On fail goto*//*Label 13847*/ GIMT_Encode4(907964), // Rule ID 63214 //
     /*  907886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  907897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  907900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  907903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907910 */     // MIs[0] op1
     /*  907910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907913 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907926 */     // MIs[0] op4
     /*  907926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907929 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907941 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  907941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907946 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907948 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907950 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907952 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907962 */     GIR_RootConstrainSelectedInstOperands,
     /*  907963 */     // GIR_Coverage, 63214,
     /*  907963 */     GIR_EraseRootFromParent_Done,
     /*  907964 */   // Label 13847: @907964
     /*  907964 */   GIM_Try, /*On fail goto*//*Label 13848*/ GIMT_Encode4(908047), // Rule ID 63269 //
     /*  907969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  907980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  907983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  907986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907993 */     // MIs[0] op1
     /*  907993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908009 */     // MIs[0] op4
     /*  908009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908024 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  908024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  908027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908029 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908031 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908033 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908035 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908045 */     GIR_RootConstrainSelectedInstOperands,
     /*  908046 */     // GIR_Coverage, 63269,
     /*  908046 */     GIR_EraseRootFromParent_Done,
     /*  908047 */   // Label 13848: @908047
     /*  908047 */   GIM_Try, /*On fail goto*//*Label 13849*/ GIMT_Encode4(908130), // Rule ID 63270 //
     /*  908052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  908063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  908066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  908069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908076 */     // MIs[0] op1
     /*  908076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908092 */     // MIs[0] op4
     /*  908092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908107 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  908107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  908110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908112 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908114 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908116 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908118 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908128 */     GIR_RootConstrainSelectedInstOperands,
     /*  908129 */     // GIR_Coverage, 63270,
     /*  908129 */     GIR_EraseRootFromParent_Done,
     /*  908130 */   // Label 13849: @908130
     /*  908130 */   GIM_Try, /*On fail goto*//*Label 13850*/ GIMT_Encode4(908213), // Rule ID 63325 //
     /*  908135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  908146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  908149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  908152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908159 */     // MIs[0] op1
     /*  908159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908175 */     // MIs[0] op4
     /*  908175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908190 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  908190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  908193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908195 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908197 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908199 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908201 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908211 */     GIR_RootConstrainSelectedInstOperands,
     /*  908212 */     // GIR_Coverage, 63325,
     /*  908212 */     GIR_EraseRootFromParent_Done,
     /*  908213 */   // Label 13850: @908213
     /*  908213 */   GIM_Try, /*On fail goto*//*Label 13851*/ GIMT_Encode4(908296), // Rule ID 63326 //
     /*  908218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  908229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  908232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  908235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908242 */     // MIs[0] op1
     /*  908242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908258 */     // MIs[0] op4
     /*  908258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908261 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908273 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  908273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  908276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908278 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908280 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908282 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908284 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908294 */     GIR_RootConstrainSelectedInstOperands,
     /*  908295 */     // GIR_Coverage, 63326,
     /*  908295 */     GIR_EraseRootFromParent_Done,
     /*  908296 */   // Label 13851: @908296
     /*  908296 */   GIM_Try, /*On fail goto*//*Label 13852*/ GIMT_Encode4(908379), // Rule ID 63381 //
     /*  908301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  908312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  908315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  908318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908325 */     // MIs[0] op1
     /*  908325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908328 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908341 */     // MIs[0] op4
     /*  908341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908356 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  908356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  908359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908361 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908363 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908365 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908367 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908377 */     GIR_RootConstrainSelectedInstOperands,
     /*  908378 */     // GIR_Coverage, 63381,
     /*  908378 */     GIR_EraseRootFromParent_Done,
     /*  908379 */   // Label 13852: @908379
     /*  908379 */   GIM_Try, /*On fail goto*//*Label 13853*/ GIMT_Encode4(908462), // Rule ID 63382 //
     /*  908384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  908395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  908398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  908401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908408 */     // MIs[0] op1
     /*  908408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908424 */     // MIs[0] op4
     /*  908424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908439 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  908439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  908442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908444 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908446 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908448 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908450 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908460 */     GIR_RootConstrainSelectedInstOperands,
     /*  908461 */     // GIR_Coverage, 63382,
     /*  908461 */     GIR_EraseRootFromParent_Done,
     /*  908462 */   // Label 13853: @908462
     /*  908462 */   GIM_Try, /*On fail goto*//*Label 13854*/ GIMT_Encode4(908545), // Rule ID 63425 //
     /*  908467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  908478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  908481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  908484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908491 */     // MIs[0] op1
     /*  908491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908507 */     // MIs[0] op4
     /*  908507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908522 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  908522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  908525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908527 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908529 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908531 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908533 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908543 */     GIR_RootConstrainSelectedInstOperands,
     /*  908544 */     // GIR_Coverage, 63425,
     /*  908544 */     GIR_EraseRootFromParent_Done,
     /*  908545 */   // Label 13854: @908545
     /*  908545 */   GIM_Try, /*On fail goto*//*Label 13855*/ GIMT_Encode4(908628), // Rule ID 63426 //
     /*  908550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  908561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  908564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  908567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908574 */     // MIs[0] op1
     /*  908574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908590 */     // MIs[0] op4
     /*  908590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908605 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  908605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  908608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908610 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908612 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908614 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908616 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908626 */     GIR_RootConstrainSelectedInstOperands,
     /*  908627 */     // GIR_Coverage, 63426,
     /*  908627 */     GIR_EraseRootFromParent_Done,
     /*  908628 */   // Label 13855: @908628
     /*  908628 */   GIM_Try, /*On fail goto*//*Label 13856*/ GIMT_Encode4(908711), // Rule ID 63469 //
     /*  908633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  908644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  908647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  908650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908657 */     // MIs[0] op1
     /*  908657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908673 */     // MIs[0] op4
     /*  908673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908688 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  908688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  908691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908693 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908695 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908697 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908699 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908709 */     GIR_RootConstrainSelectedInstOperands,
     /*  908710 */     // GIR_Coverage, 63469,
     /*  908710 */     GIR_EraseRootFromParent_Done,
     /*  908711 */   // Label 13856: @908711
     /*  908711 */   GIM_Try, /*On fail goto*//*Label 13857*/ GIMT_Encode4(908794), // Rule ID 63470 //
     /*  908716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  908727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  908730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  908733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908740 */     // MIs[0] op1
     /*  908740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908756 */     // MIs[0] op4
     /*  908756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  908771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  908774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908776 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908778 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908780 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908782 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908792 */     GIR_RootConstrainSelectedInstOperands,
     /*  908793 */     // GIR_Coverage, 63470,
     /*  908793 */     GIR_EraseRootFromParent_Done,
     /*  908794 */   // Label 13857: @908794
     /*  908794 */   GIM_Try, /*On fail goto*//*Label 13858*/ GIMT_Encode4(908877), // Rule ID 63513 //
     /*  908799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  908810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  908813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  908816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908823 */     // MIs[0] op1
     /*  908823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908839 */     // MIs[0] op4
     /*  908839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908854 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  908854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  908857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908859 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908861 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908863 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908865 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908875 */     GIR_RootConstrainSelectedInstOperands,
     /*  908876 */     // GIR_Coverage, 63513,
     /*  908876 */     GIR_EraseRootFromParent_Done,
     /*  908877 */   // Label 13858: @908877
     /*  908877 */   GIM_Try, /*On fail goto*//*Label 13859*/ GIMT_Encode4(908960), // Rule ID 63514 //
     /*  908882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  908893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  908896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  908899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908906 */     // MIs[0] op1
     /*  908906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908922 */     // MIs[0] op4
     /*  908922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908925 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908937 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  908937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  908940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908942 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908944 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908946 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908948 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908958 */     GIR_RootConstrainSelectedInstOperands,
     /*  908959 */     // GIR_Coverage, 63514,
     /*  908959 */     GIR_EraseRootFromParent_Done,
     /*  908960 */   // Label 13859: @908960
     /*  908960 */   GIM_Try, /*On fail goto*//*Label 13860*/ GIMT_Encode4(909043), // Rule ID 63569 //
     /*  908965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  908976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  908979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  908982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908989 */     // MIs[0] op1
     /*  908989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909005 */     // MIs[0] op4
     /*  909005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909020 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  909020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  909023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909025 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909027 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909029 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909031 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  909041 */     GIR_RootConstrainSelectedInstOperands,
     /*  909042 */     // GIR_Coverage, 63569,
     /*  909042 */     GIR_EraseRootFromParent_Done,
     /*  909043 */   // Label 13860: @909043
     /*  909043 */   GIM_Try, /*On fail goto*//*Label 13861*/ GIMT_Encode4(909126), // Rule ID 63570 //
     /*  909048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  909059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  909062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  909065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909072 */     // MIs[0] op1
     /*  909072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909088 */     // MIs[0] op4
     /*  909088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909091 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909103 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  909103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  909106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909108 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909110 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909112 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909114 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  909124 */     GIR_RootConstrainSelectedInstOperands,
     /*  909125 */     // GIR_Coverage, 63570,
     /*  909125 */     GIR_EraseRootFromParent_Done,
     /*  909126 */   // Label 13861: @909126
     /*  909126 */   GIM_Try, /*On fail goto*//*Label 13862*/ GIMT_Encode4(909209), // Rule ID 63625 //
     /*  909131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  909142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  909145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  909148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909155 */     // MIs[0] op1
     /*  909155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909171 */     // MIs[0] op4
     /*  909171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909186 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  909186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  909189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909191 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909193 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909195 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909197 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  909207 */     GIR_RootConstrainSelectedInstOperands,
     /*  909208 */     // GIR_Coverage, 63625,
     /*  909208 */     GIR_EraseRootFromParent_Done,
     /*  909209 */   // Label 13862: @909209
     /*  909209 */   GIM_Try, /*On fail goto*//*Label 13863*/ GIMT_Encode4(909292), // Rule ID 63626 //
     /*  909214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  909225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  909228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  909231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909238 */     // MIs[0] op1
     /*  909238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909254 */     // MIs[0] op4
     /*  909254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909257 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909269 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  909269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  909272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909274 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909276 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909278 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909280 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  909290 */     GIR_RootConstrainSelectedInstOperands,
     /*  909291 */     // GIR_Coverage, 63626,
     /*  909291 */     GIR_EraseRootFromParent_Done,
     /*  909292 */   // Label 13863: @909292
     /*  909292 */   GIM_Try, /*On fail goto*//*Label 13864*/ GIMT_Encode4(909375), // Rule ID 63681 //
     /*  909297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  909308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  909311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  909314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909321 */     // MIs[0] op1
     /*  909321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909337 */     // MIs[0] op4
     /*  909337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  909352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  909355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909357 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909359 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909361 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909363 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909373 */     GIR_RootConstrainSelectedInstOperands,
     /*  909374 */     // GIR_Coverage, 63681,
     /*  909374 */     GIR_EraseRootFromParent_Done,
     /*  909375 */   // Label 13864: @909375
     /*  909375 */   GIM_Try, /*On fail goto*//*Label 13865*/ GIMT_Encode4(909458), // Rule ID 63682 //
     /*  909380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  909391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  909394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  909397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909404 */     // MIs[0] op1
     /*  909404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909420 */     // MIs[0] op4
     /*  909420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909435 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  909435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  909438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909440 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909442 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909444 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909446 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909456 */     GIR_RootConstrainSelectedInstOperands,
     /*  909457 */     // GIR_Coverage, 63682,
     /*  909457 */     GIR_EraseRootFromParent_Done,
     /*  909458 */   // Label 13865: @909458
     /*  909458 */   GIM_Try, /*On fail goto*//*Label 13866*/ GIMT_Encode4(909541), // Rule ID 63737 //
     /*  909463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  909474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  909477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  909480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909487 */     // MIs[0] op1
     /*  909487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909503 */     // MIs[0] op4
     /*  909503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  909518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  909521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909523 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909525 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909527 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909529 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909539 */     GIR_RootConstrainSelectedInstOperands,
     /*  909540 */     // GIR_Coverage, 63737,
     /*  909540 */     GIR_EraseRootFromParent_Done,
     /*  909541 */   // Label 13866: @909541
     /*  909541 */   GIM_Try, /*On fail goto*//*Label 13867*/ GIMT_Encode4(909624), // Rule ID 63738 //
     /*  909546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  909557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  909560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  909563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909570 */     // MIs[0] op1
     /*  909570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909573 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909586 */     // MIs[0] op4
     /*  909586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909601 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  909601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  909604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909606 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909608 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909610 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909612 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909622 */     GIR_RootConstrainSelectedInstOperands,
     /*  909623 */     // GIR_Coverage, 63738,
     /*  909623 */     GIR_EraseRootFromParent_Done,
     /*  909624 */   // Label 13867: @909624
     /*  909624 */   GIM_Try, /*On fail goto*//*Label 13868*/ GIMT_Encode4(909707), // Rule ID 63793 //
     /*  909629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  909643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  909646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909653 */     // MIs[0] op1
     /*  909653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909669 */     // MIs[0] op4
     /*  909669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909684 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  909684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  909687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909689 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909691 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909693 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909695 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909705 */     GIR_RootConstrainSelectedInstOperands,
     /*  909706 */     // GIR_Coverage, 63793,
     /*  909706 */     GIR_EraseRootFromParent_Done,
     /*  909707 */   // Label 13868: @909707
     /*  909707 */   GIM_Try, /*On fail goto*//*Label 13869*/ GIMT_Encode4(909790), // Rule ID 63794 //
     /*  909712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  909726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  909729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909736 */     // MIs[0] op1
     /*  909736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909752 */     // MIs[0] op4
     /*  909752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909767 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  909767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  909770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909772 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909774 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909776 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909778 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909788 */     GIR_RootConstrainSelectedInstOperands,
     /*  909789 */     // GIR_Coverage, 63794,
     /*  909789 */     GIR_EraseRootFromParent_Done,
     /*  909790 */   // Label 13869: @909790
     /*  909790 */   GIM_Try, /*On fail goto*//*Label 13870*/ GIMT_Encode4(909873), // Rule ID 63849 //
     /*  909795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  909806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  909809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  909812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909819 */     // MIs[0] op1
     /*  909819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909835 */     // MIs[0] op4
     /*  909835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  909850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  909853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909855 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909857 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909859 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909861 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909871 */     GIR_RootConstrainSelectedInstOperands,
     /*  909872 */     // GIR_Coverage, 63849,
     /*  909872 */     GIR_EraseRootFromParent_Done,
     /*  909873 */   // Label 13870: @909873
     /*  909873 */   GIM_Try, /*On fail goto*//*Label 13871*/ GIMT_Encode4(909956), // Rule ID 63850 //
     /*  909878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  909889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  909892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  909895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909902 */     // MIs[0] op1
     /*  909902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909918 */     // MIs[0] op4
     /*  909918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909933 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  909933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  909936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909938 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909940 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909942 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909944 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909954 */     GIR_RootConstrainSelectedInstOperands,
     /*  909955 */     // GIR_Coverage, 63850,
     /*  909955 */     GIR_EraseRootFromParent_Done,
     /*  909956 */   // Label 13871: @909956
     /*  909956 */   GIM_Try, /*On fail goto*//*Label 13872*/ GIMT_Encode4(910039), // Rule ID 63905 //
     /*  909961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  909972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  909975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  909978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909985 */     // MIs[0] op1
     /*  909985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910001 */     // MIs[0] op4
     /*  910001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910004 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910016 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  910016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  910019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910021 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910023 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910025 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910027 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910037 */     GIR_RootConstrainSelectedInstOperands,
     /*  910038 */     // GIR_Coverage, 63905,
     /*  910038 */     GIR_EraseRootFromParent_Done,
     /*  910039 */   // Label 13872: @910039
     /*  910039 */   GIM_Try, /*On fail goto*//*Label 13873*/ GIMT_Encode4(910122), // Rule ID 63906 //
     /*  910044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  910055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  910058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  910061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910068 */     // MIs[0] op1
     /*  910068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910084 */     // MIs[0] op4
     /*  910084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910087 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910099 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  910099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  910102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910104 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910106 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910108 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910110 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910120 */     GIR_RootConstrainSelectedInstOperands,
     /*  910121 */     // GIR_Coverage, 63906,
     /*  910121 */     GIR_EraseRootFromParent_Done,
     /*  910122 */   // Label 13873: @910122
     /*  910122 */   GIM_Try, /*On fail goto*//*Label 13874*/ GIMT_Encode4(910205), // Rule ID 63961 //
     /*  910127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  910138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  910141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  910144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910151 */     // MIs[0] op1
     /*  910151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910167 */     // MIs[0] op4
     /*  910167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910182 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11126:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  910182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  910185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910187 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910189 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910191 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910193 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910203 */     GIR_RootConstrainSelectedInstOperands,
     /*  910204 */     // GIR_Coverage, 63961,
     /*  910204 */     GIR_EraseRootFromParent_Done,
     /*  910205 */   // Label 13874: @910205
     /*  910205 */   GIM_Try, /*On fail goto*//*Label 13875*/ GIMT_Encode4(910288), // Rule ID 63962 //
     /*  910210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  910221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  910224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  910227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910234 */     // MIs[0] op1
     /*  910234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910250 */     // MIs[0] op4
     /*  910250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910265 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11126:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  910265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  910268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910270 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910272 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910274 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910276 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910286 */     GIR_RootConstrainSelectedInstOperands,
     /*  910287 */     // GIR_Coverage, 63962,
     /*  910287 */     GIR_EraseRootFromParent_Done,
     /*  910288 */   // Label 13875: @910288
     /*  910288 */   GIM_Try, /*On fail goto*//*Label 13876*/ GIMT_Encode4(910371), // Rule ID 63991 //
     /*  910293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  910304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  910307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  910310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910317 */     // MIs[0] op1
     /*  910317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910320 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910333 */     // MIs[0] op4
     /*  910333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910348 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF8),
     /*  910351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910353 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910355 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910357 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910359 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910369 */     GIR_RootConstrainSelectedInstOperands,
     /*  910370 */     // GIR_Coverage, 63991,
     /*  910370 */     GIR_EraseRootFromParent_Done,
     /*  910371 */   // Label 13876: @910371
     /*  910371 */   GIM_Try, /*On fail goto*//*Label 13877*/ GIMT_Encode4(910454), // Rule ID 63992 //
     /*  910376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  910387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  910390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  910393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910400 */     // MIs[0] op1
     /*  910400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910416 */     // MIs[0] op4
     /*  910416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910431 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF8),
     /*  910434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910436 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910438 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910440 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910442 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910452 */     GIR_RootConstrainSelectedInstOperands,
     /*  910453 */     // GIR_Coverage, 63992,
     /*  910453 */     GIR_EraseRootFromParent_Done,
     /*  910454 */   // Label 13877: @910454
     /*  910454 */   GIM_Try, /*On fail goto*//*Label 13878*/ GIMT_Encode4(910537), // Rule ID 64009 //
     /*  910459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910483 */     // MIs[0] op1
     /*  910483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910499 */     // MIs[0] op4
     /*  910499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910514 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF4),
     /*  910517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910519 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910521 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910523 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910525 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910535 */     GIR_RootConstrainSelectedInstOperands,
     /*  910536 */     // GIR_Coverage, 64009,
     /*  910536 */     GIR_EraseRootFromParent_Done,
     /*  910537 */   // Label 13878: @910537
     /*  910537 */   GIM_Try, /*On fail goto*//*Label 13879*/ GIMT_Encode4(910620), // Rule ID 64010 //
     /*  910542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910566 */     // MIs[0] op1
     /*  910566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910582 */     // MIs[0] op4
     /*  910582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910597 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF4),
     /*  910600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910602 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910604 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910606 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910608 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910618 */     GIR_RootConstrainSelectedInstOperands,
     /*  910619 */     // GIR_Coverage, 64010,
     /*  910619 */     GIR_EraseRootFromParent_Done,
     /*  910620 */   // Label 13879: @910620
     /*  910620 */   GIM_Try, /*On fail goto*//*Label 13880*/ GIMT_Encode4(910703), // Rule ID 64027 //
     /*  910625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  910636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  910639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910649 */     // MIs[0] op1
     /*  910649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910665 */     // MIs[0] op4
     /*  910665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910680 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  910683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910685 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910687 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910689 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910691 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910701 */     GIR_RootConstrainSelectedInstOperands,
     /*  910702 */     // GIR_Coverage, 64027,
     /*  910702 */     GIR_EraseRootFromParent_Done,
     /*  910703 */   // Label 13880: @910703
     /*  910703 */   GIM_Try, /*On fail goto*//*Label 13881*/ GIMT_Encode4(910786), // Rule ID 64028 //
     /*  910708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  910719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  910722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910732 */     // MIs[0] op1
     /*  910732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910748 */     // MIs[0] op4
     /*  910748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910763 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  910766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910768 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910770 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910772 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910774 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910784 */     GIR_RootConstrainSelectedInstOperands,
     /*  910785 */     // GIR_Coverage, 64028,
     /*  910785 */     GIR_EraseRootFromParent_Done,
     /*  910786 */   // Label 13881: @910786
     /*  910786 */   GIM_Try, /*On fail goto*//*Label 13882*/ GIMT_Encode4(910869), // Rule ID 64045 //
     /*  910791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  910802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  910805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  910808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910815 */     // MIs[0] op1
     /*  910815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910831 */     // MIs[0] op4
     /*  910831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  910849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910851 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910853 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910855 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910857 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910867 */     GIR_RootConstrainSelectedInstOperands,
     /*  910868 */     // GIR_Coverage, 64045,
     /*  910868 */     GIR_EraseRootFromParent_Done,
     /*  910869 */   // Label 13882: @910869
     /*  910869 */   GIM_Try, /*On fail goto*//*Label 13883*/ GIMT_Encode4(910952), // Rule ID 64046 //
     /*  910874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  910885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  910888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  910891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910898 */     // MIs[0] op1
     /*  910898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910914 */     // MIs[0] op4
     /*  910914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910929 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  910932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910934 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910936 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910938 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910940 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910950 */     GIR_RootConstrainSelectedInstOperands,
     /*  910951 */     // GIR_Coverage, 64046,
     /*  910951 */     GIR_EraseRootFromParent_Done,
     /*  910952 */   // Label 13883: @910952
     /*  910952 */   GIM_Try, /*On fail goto*//*Label 13884*/ GIMT_Encode4(911035), // Rule ID 64063 //
     /*  910957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  910968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  910971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  910974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910981 */     // MIs[0] op1
     /*  910981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910997 */     // MIs[0] op4
     /*  910997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911012 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  911012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  911015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911017 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911019 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911021 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911023 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911033 */     GIR_RootConstrainSelectedInstOperands,
     /*  911034 */     // GIR_Coverage, 64063,
     /*  911034 */     GIR_EraseRootFromParent_Done,
     /*  911035 */   // Label 13884: @911035
     /*  911035 */   GIM_Try, /*On fail goto*//*Label 13885*/ GIMT_Encode4(911118), // Rule ID 64064 //
     /*  911040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  911051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  911054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  911057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911064 */     // MIs[0] op1
     /*  911064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911080 */     // MIs[0] op4
     /*  911080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911095 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  911095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  911098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911100 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911102 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911104 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911106 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911116 */     GIR_RootConstrainSelectedInstOperands,
     /*  911117 */     // GIR_Coverage, 64064,
     /*  911117 */     GIR_EraseRootFromParent_Done,
     /*  911118 */   // Label 13885: @911118
     /*  911118 */   GIM_Try, /*On fail goto*//*Label 13886*/ GIMT_Encode4(911201), // Rule ID 64081 //
     /*  911123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  911134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  911137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  911140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911147 */     // MIs[0] op1
     /*  911147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911163 */     // MIs[0] op4
     /*  911163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911166 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911178 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  911178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  911181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911183 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911185 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911187 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911189 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911199 */     GIR_RootConstrainSelectedInstOperands,
     /*  911200 */     // GIR_Coverage, 64081,
     /*  911200 */     GIR_EraseRootFromParent_Done,
     /*  911201 */   // Label 13886: @911201
     /*  911201 */   GIM_Try, /*On fail goto*//*Label 13887*/ GIMT_Encode4(911284), // Rule ID 64082 //
     /*  911206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  911217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  911220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  911223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911230 */     // MIs[0] op1
     /*  911230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911246 */     // MIs[0] op4
     /*  911246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911249 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911261 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  911261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  911264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911266 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911268 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911270 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911272 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911282 */     GIR_RootConstrainSelectedInstOperands,
     /*  911283 */     // GIR_Coverage, 64082,
     /*  911283 */     GIR_EraseRootFromParent_Done,
     /*  911284 */   // Label 13887: @911284
     /*  911284 */   GIM_Try, /*On fail goto*//*Label 13888*/ GIMT_Encode4(911367), // Rule ID 64099 //
     /*  911289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  911300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  911303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  911306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911313 */     // MIs[0] op1
     /*  911313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911316 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911329 */     // MIs[0] op4
     /*  911329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF4),
     /*  911347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911349 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911351 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911353 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911355 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911365 */     GIR_RootConstrainSelectedInstOperands,
     /*  911366 */     // GIR_Coverage, 64099,
     /*  911366 */     GIR_EraseRootFromParent_Done,
     /*  911367 */   // Label 13888: @911367
     /*  911367 */   GIM_Try, /*On fail goto*//*Label 13889*/ GIMT_Encode4(911450), // Rule ID 64100 //
     /*  911372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  911383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  911386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  911389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911396 */     // MIs[0] op1
     /*  911396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911412 */     // MIs[0] op4
     /*  911412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911427 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF4),
     /*  911430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911432 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911434 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911436 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911438 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911448 */     GIR_RootConstrainSelectedInstOperands,
     /*  911449 */     // GIR_Coverage, 64100,
     /*  911449 */     GIR_EraseRootFromParent_Done,
     /*  911450 */   // Label 13889: @911450
     /*  911450 */   GIM_Try, /*On fail goto*//*Label 13890*/ GIMT_Encode4(911533), // Rule ID 64123 //
     /*  911455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  911472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911479 */     // MIs[0] op1
     /*  911479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911495 */     // MIs[0] op4
     /*  911495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911510 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  911513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911515 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911517 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911519 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911521 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911531 */     GIR_RootConstrainSelectedInstOperands,
     /*  911532 */     // GIR_Coverage, 64123,
     /*  911532 */     GIR_EraseRootFromParent_Done,
     /*  911533 */   // Label 13890: @911533
     /*  911533 */   GIM_Try, /*On fail goto*//*Label 13891*/ GIMT_Encode4(911616), // Rule ID 64124 //
     /*  911538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  911555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911562 */     // MIs[0] op1
     /*  911562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911565 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911578 */     // MIs[0] op4
     /*  911578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911593 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  911596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911598 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911600 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911602 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911604 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911614 */     GIR_RootConstrainSelectedInstOperands,
     /*  911615 */     // GIR_Coverage, 64124,
     /*  911615 */     GIR_EraseRootFromParent_Done,
     /*  911616 */   // Label 13891: @911616
     /*  911616 */   GIM_Try, /*On fail goto*//*Label 13892*/ GIMT_Encode4(911699), // Rule ID 64147 //
     /*  911621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  911632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  911635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911645 */     // MIs[0] op1
     /*  911645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911661 */     // MIs[0] op4
     /*  911661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  911679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911681 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911683 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911685 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911687 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911697 */     GIR_RootConstrainSelectedInstOperands,
     /*  911698 */     // GIR_Coverage, 64147,
     /*  911698 */     GIR_EraseRootFromParent_Done,
     /*  911699 */   // Label 13892: @911699
     /*  911699 */   GIM_Try, /*On fail goto*//*Label 13893*/ GIMT_Encode4(911782), // Rule ID 64148 //
     /*  911704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  911715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  911718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911728 */     // MIs[0] op1
     /*  911728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911744 */     // MIs[0] op4
     /*  911744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  911762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911764 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911766 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911768 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911770 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911780 */     GIR_RootConstrainSelectedInstOperands,
     /*  911781 */     // GIR_Coverage, 64148,
     /*  911781 */     GIR_EraseRootFromParent_Done,
     /*  911782 */   // Label 13893: @911782
     /*  911782 */   GIM_Try, /*On fail goto*//*Label 13894*/ GIMT_Encode4(911865), // Rule ID 64171 //
     /*  911787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  911798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  911801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  911804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911811 */     // MIs[0] op1
     /*  911811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911814 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911827 */     // MIs[0] op4
     /*  911827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911842 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  911845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911847 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911849 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911851 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911853 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911863 */     GIR_RootConstrainSelectedInstOperands,
     /*  911864 */     // GIR_Coverage, 64171,
     /*  911864 */     GIR_EraseRootFromParent_Done,
     /*  911865 */   // Label 13894: @911865
     /*  911865 */   GIM_Try, /*On fail goto*//*Label 13895*/ GIMT_Encode4(911948), // Rule ID 64172 //
     /*  911870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  911881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  911884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  911887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911894 */     // MIs[0] op1
     /*  911894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911897 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911910 */     // MIs[0] op4
     /*  911910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911913 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911925 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  911928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911930 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911932 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911934 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911936 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911946 */     GIR_RootConstrainSelectedInstOperands,
     /*  911947 */     // GIR_Coverage, 64172,
     /*  911947 */     GIR_EraseRootFromParent_Done,
     /*  911948 */   // Label 13895: @911948
     /*  911948 */   GIM_Try, /*On fail goto*//*Label 13896*/ GIMT_Encode4(912031), // Rule ID 64195 //
     /*  911953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  911964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  911967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  911970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911977 */     // MIs[0] op1
     /*  911977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911993 */     // MIs[0] op4
     /*  911993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912008 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  912008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  912011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912013 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912015 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912017 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912019 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912029 */     GIR_RootConstrainSelectedInstOperands,
     /*  912030 */     // GIR_Coverage, 64195,
     /*  912030 */     GIR_EraseRootFromParent_Done,
     /*  912031 */   // Label 13896: @912031
     /*  912031 */   GIM_Try, /*On fail goto*//*Label 13897*/ GIMT_Encode4(912114), // Rule ID 64196 //
     /*  912036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  912047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  912050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  912053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912060 */     // MIs[0] op1
     /*  912060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912076 */     // MIs[0] op4
     /*  912076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912091 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  912091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  912094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912096 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912098 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912100 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912102 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912112 */     GIR_RootConstrainSelectedInstOperands,
     /*  912113 */     // GIR_Coverage, 64196,
     /*  912113 */     GIR_EraseRootFromParent_Done,
     /*  912114 */   // Label 13897: @912114
     /*  912114 */   GIM_Try, /*On fail goto*//*Label 13898*/ GIMT_Encode4(912197), // Rule ID 64219 //
     /*  912119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  912130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  912133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  912136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912143 */     // MIs[0] op1
     /*  912143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912159 */     // MIs[0] op4
     /*  912159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  912177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912179 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912181 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912183 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912185 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912195 */     GIR_RootConstrainSelectedInstOperands,
     /*  912196 */     // GIR_Coverage, 64219,
     /*  912196 */     GIR_EraseRootFromParent_Done,
     /*  912197 */   // Label 13898: @912197
     /*  912197 */   GIM_Try, /*On fail goto*//*Label 13899*/ GIMT_Encode4(912280), // Rule ID 64220 //
     /*  912202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  912213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  912216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  912219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912226 */     // MIs[0] op1
     /*  912226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912229 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912242 */     // MIs[0] op4
     /*  912242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912257 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  912260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912262 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912264 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912266 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912268 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912278 */     GIR_RootConstrainSelectedInstOperands,
     /*  912279 */     // GIR_Coverage, 64220,
     /*  912279 */     GIR_EraseRootFromParent_Done,
     /*  912280 */   // Label 13899: @912280
     /*  912280 */   GIM_Try, /*On fail goto*//*Label 13900*/ GIMT_Encode4(912363), // Rule ID 64243 //
     /*  912285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  912296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  912299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  912302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912309 */     // MIs[0] op1
     /*  912309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912312 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912325 */     // MIs[0] op4
     /*  912325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912328 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  912343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912345 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912347 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912349 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912351 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912361 */     GIR_RootConstrainSelectedInstOperands,
     /*  912362 */     // GIR_Coverage, 64243,
     /*  912362 */     GIR_EraseRootFromParent_Done,
     /*  912363 */   // Label 13900: @912363
     /*  912363 */   GIM_Try, /*On fail goto*//*Label 13901*/ GIMT_Encode4(912446), // Rule ID 64244 //
     /*  912368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  912379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  912382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  912385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912392 */     // MIs[0] op1
     /*  912392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912408 */     // MIs[0] op4
     /*  912408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912423 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  912426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912428 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912430 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912432 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912434 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912444 */     GIR_RootConstrainSelectedInstOperands,
     /*  912445 */     // GIR_Coverage, 64244,
     /*  912445 */     GIR_EraseRootFromParent_Done,
     /*  912446 */   // Label 13901: @912446
     /*  912446 */   GIM_Try, /*On fail goto*//*Label 13902*/ GIMT_Encode4(912529), // Rule ID 64267 //
     /*  912451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  912462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  912465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912475 */     // MIs[0] op1
     /*  912475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912491 */     // MIs[0] op4
     /*  912491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912506 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  912509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912511 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912513 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912515 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912517 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912527 */     GIR_RootConstrainSelectedInstOperands,
     /*  912528 */     // GIR_Coverage, 64267,
     /*  912528 */     GIR_EraseRootFromParent_Done,
     /*  912529 */   // Label 13902: @912529
     /*  912529 */   GIM_Try, /*On fail goto*//*Label 13903*/ GIMT_Encode4(912612), // Rule ID 64268 //
     /*  912534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  912545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  912548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912558 */     // MIs[0] op1
     /*  912558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912574 */     // MIs[0] op4
     /*  912574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912589 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  912592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912594 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912596 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912598 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912600 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912610 */     GIR_RootConstrainSelectedInstOperands,
     /*  912611 */     // GIR_Coverage, 64268,
     /*  912611 */     GIR_EraseRootFromParent_Done,
     /*  912612 */   // Label 13903: @912612
     /*  912612 */   GIM_Try, /*On fail goto*//*Label 13904*/ GIMT_Encode4(912695), // Rule ID 64291 //
     /*  912617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  912628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  912631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912641 */     // MIs[0] op1
     /*  912641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912657 */     // MIs[0] op4
     /*  912657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912672 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11128:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  912675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912677 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912679 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912681 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912683 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912693 */     GIR_RootConstrainSelectedInstOperands,
     /*  912694 */     // GIR_Coverage, 64291,
     /*  912694 */     GIR_EraseRootFromParent_Done,
     /*  912695 */   // Label 13904: @912695
     /*  912695 */   GIM_Try, /*On fail goto*//*Label 13905*/ GIMT_Encode4(912778), // Rule ID 64292 //
     /*  912700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  912711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  912714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912724 */     // MIs[0] op1
     /*  912724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912740 */     // MIs[0] op4
     /*  912740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912755 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  912758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912760 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912762 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912764 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912766 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912776 */     GIR_RootConstrainSelectedInstOperands,
     /*  912777 */     // GIR_Coverage, 64292,
     /*  912777 */     GIR_EraseRootFromParent_Done,
     /*  912778 */   // Label 13905: @912778
     /*  912778 */   GIM_Try, /*On fail goto*//*Label 13906*/ GIMT_Encode4(912856), // Rule ID 60620 //
     /*  912783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  912794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  912797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  912800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912815 */     // MIs[0] rs2
     /*  912815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912823 */     // MIs[0] policy
     /*  912823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912833 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  912836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912854 */     GIR_RootConstrainSelectedInstOperands,
     /*  912855 */     // GIR_Coverage, 60620,
     /*  912855 */     GIR_EraseRootFromParent_Done,
     /*  912856 */   // Label 13906: @912856
     /*  912856 */   GIM_Try, /*On fail goto*//*Label 13907*/ GIMT_Encode4(912934), // Rule ID 60621 //
     /*  912861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  912872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  912875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  912878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912893 */     // MIs[0] rs2
     /*  912893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912896 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912901 */     // MIs[0] policy
     /*  912901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912911 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  912914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912932 */     GIR_RootConstrainSelectedInstOperands,
     /*  912933 */     // GIR_Coverage, 60621,
     /*  912933 */     GIR_EraseRootFromParent_Done,
     /*  912934 */   // Label 13907: @912934
     /*  912934 */   GIM_Try, /*On fail goto*//*Label 13908*/ GIMT_Encode4(913012), // Rule ID 62276 //
     /*  912939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  912950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  912953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  912956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912971 */     // MIs[0] rs2
     /*  912971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912979 */     // MIs[0] policy
     /*  912979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912989 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  912992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913010 */     GIR_RootConstrainSelectedInstOperands,
     /*  913011 */     // GIR_Coverage, 62276,
     /*  913011 */     GIR_EraseRootFromParent_Done,
     /*  913012 */   // Label 13908: @913012
     /*  913012 */   GIM_Try, /*On fail goto*//*Label 13909*/ GIMT_Encode4(913090), // Rule ID 62277 //
     /*  913017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  913020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  913028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  913031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  913034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913049 */     // MIs[0] rs2
     /*  913049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913057 */     // MIs[0] policy
     /*  913057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913067 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  913070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913088 */     GIR_RootConstrainSelectedInstOperands,
     /*  913089 */     // GIR_Coverage, 62277,
     /*  913089 */     GIR_EraseRootFromParent_Done,
     /*  913090 */   // Label 13909: @913090
     /*  913090 */   GIM_Try, /*On fail goto*//*Label 13910*/ GIMT_Encode4(913168), // Rule ID 62278 //
     /*  913095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  913098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  913106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  913109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  913112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913127 */     // MIs[0] rs2
     /*  913127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913135 */     // MIs[0] policy
     /*  913135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913145 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  913148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913166 */     GIR_RootConstrainSelectedInstOperands,
     /*  913167 */     // GIR_Coverage, 62278,
     /*  913167 */     GIR_EraseRootFromParent_Done,
     /*  913168 */   // Label 13910: @913168
     /*  913168 */   GIM_Try, /*On fail goto*//*Label 13911*/ GIMT_Encode4(913246), // Rule ID 62279 //
     /*  913173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  913176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  913184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  913187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  913190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913205 */     // MIs[0] rs2
     /*  913205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913208 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913213 */     // MIs[0] policy
     /*  913213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913223 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  913226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913244 */     GIR_RootConstrainSelectedInstOperands,
     /*  913245 */     // GIR_Coverage, 62279,
     /*  913245 */     GIR_EraseRootFromParent_Done,
     /*  913246 */   // Label 13911: @913246
     /*  913246 */   GIM_Try, /*On fail goto*//*Label 13912*/ GIMT_Encode4(913324), // Rule ID 62280 //
     /*  913251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  913254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  913262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  913265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  913268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913283 */     // MIs[0] rs2
     /*  913283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913291 */     // MIs[0] policy
     /*  913291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913301 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  913304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913322 */     GIR_RootConstrainSelectedInstOperands,
     /*  913323 */     // GIR_Coverage, 62280,
     /*  913323 */     GIR_EraseRootFromParent_Done,
     /*  913324 */   // Label 13912: @913324
     /*  913324 */   GIM_Try, /*On fail goto*//*Label 13913*/ GIMT_Encode4(913402), // Rule ID 62281 //
     /*  913329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  913332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  913340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  913343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  913346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913361 */     // MIs[0] rs2
     /*  913361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913369 */     // MIs[0] policy
     /*  913369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913379 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  913382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913400 */     GIR_RootConstrainSelectedInstOperands,
     /*  913401 */     // GIR_Coverage, 62281,
     /*  913401 */     GIR_EraseRootFromParent_Done,
     /*  913402 */   // Label 13913: @913402
     /*  913402 */   GIM_Try, /*On fail goto*//*Label 13914*/ GIMT_Encode4(913480), // Rule ID 62282 //
     /*  913407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  913410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913439 */     // MIs[0] rs2
     /*  913439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913447 */     // MIs[0] policy
     /*  913447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913457 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  913460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913478 */     GIR_RootConstrainSelectedInstOperands,
     /*  913479 */     // GIR_Coverage, 62282,
     /*  913479 */     GIR_EraseRootFromParent_Done,
     /*  913480 */   // Label 13914: @913480
     /*  913480 */   GIM_Try, /*On fail goto*//*Label 13915*/ GIMT_Encode4(913558), // Rule ID 62283 //
     /*  913485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  913488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913517 */     // MIs[0] rs2
     /*  913517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913525 */     // MIs[0] policy
     /*  913525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913535 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  913538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913556 */     GIR_RootConstrainSelectedInstOperands,
     /*  913557 */     // GIR_Coverage, 62283,
     /*  913557 */     GIR_EraseRootFromParent_Done,
     /*  913558 */   // Label 13915: @913558
     /*  913558 */   GIM_Try, /*On fail goto*//*Label 13916*/ GIMT_Encode4(913636), // Rule ID 62444 //
     /*  913563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  913574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  913577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  913580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913595 */     // MIs[0] rs2
     /*  913595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913598 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913603 */     // MIs[0] policy
     /*  913603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913613 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  913616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913634 */     GIR_RootConstrainSelectedInstOperands,
     /*  913635 */     // GIR_Coverage, 62444,
     /*  913635 */     GIR_EraseRootFromParent_Done,
     /*  913636 */   // Label 13916: @913636
     /*  913636 */   GIM_Try, /*On fail goto*//*Label 13917*/ GIMT_Encode4(913714), // Rule ID 62445 //
     /*  913641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  913652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  913655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  913658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913673 */     // MIs[0] rs2
     /*  913673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913681 */     // MIs[0] policy
     /*  913681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913691 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  913694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913712 */     GIR_RootConstrainSelectedInstOperands,
     /*  913713 */     // GIR_Coverage, 62445,
     /*  913713 */     GIR_EraseRootFromParent_Done,
     /*  913714 */   // Label 13917: @913714
     /*  913714 */   GIM_Try, /*On fail goto*//*Label 13918*/ GIMT_Encode4(913792), // Rule ID 62446 //
     /*  913719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  913730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  913733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  913736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913751 */     // MIs[0] rs2
     /*  913751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913754 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913759 */     // MIs[0] policy
     /*  913759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913769 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11611:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  913772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913790 */     GIR_RootConstrainSelectedInstOperands,
     /*  913791 */     // GIR_Coverage, 62446,
     /*  913791 */     GIR_EraseRootFromParent_Done,
     /*  913792 */   // Label 13918: @913792
     /*  913792 */   GIM_Try, /*On fail goto*//*Label 13919*/ GIMT_Encode4(913870), // Rule ID 62447 //
     /*  913797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  913808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  913811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  913814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913829 */     // MIs[0] rs2
     /*  913829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913832 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913837 */     // MIs[0] policy
     /*  913837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913847 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11611:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  913850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913868 */     GIR_RootConstrainSelectedInstOperands,
     /*  913869 */     // GIR_Coverage, 62447,
     /*  913869 */     GIR_EraseRootFromParent_Done,
     /*  913870 */   // Label 13919: @913870
     /*  913870 */   GIM_Try, /*On fail goto*//*Label 13920*/ GIMT_Encode4(913948), // Rule ID 62448 //
     /*  913875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  913886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  913889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  913892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913907 */     // MIs[0] rs2
     /*  913907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913915 */     // MIs[0] policy
     /*  913915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  913928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913946 */     GIR_RootConstrainSelectedInstOperands,
     /*  913947 */     // GIR_Coverage, 62448,
     /*  913947 */     GIR_EraseRootFromParent_Done,
     /*  913948 */   // Label 13920: @913948
     /*  913948 */   GIM_Try, /*On fail goto*//*Label 13921*/ GIMT_Encode4(914026), // Rule ID 62449 //
     /*  913953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  913964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  913967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  913970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913985 */     // MIs[0] rs2
     /*  913985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913993 */     // MIs[0] policy
     /*  913993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914003 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  914006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  914008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914024 */     GIR_RootConstrainSelectedInstOperands,
     /*  914025 */     // GIR_Coverage, 62449,
     /*  914025 */     GIR_EraseRootFromParent_Done,
     /*  914026 */   // Label 13921: @914026
     /*  914026 */   GIM_Try, /*On fail goto*//*Label 13922*/ GIMT_Encode4(914104), // Rule ID 62450 //
     /*  914031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  914034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  914039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  914042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  914045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  914048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914063 */     // MIs[0] rs2
     /*  914063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  914066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  914071 */     // MIs[0] policy
     /*  914071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914081 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  914084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  914086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914102 */     GIR_RootConstrainSelectedInstOperands,
     /*  914103 */     // GIR_Coverage, 62450,
     /*  914103 */     GIR_EraseRootFromParent_Done,
     /*  914104 */   // Label 13922: @914104
     /*  914104 */   GIM_Try, /*On fail goto*//*Label 13923*/ GIMT_Encode4(914182), // Rule ID 62451 //
     /*  914109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  914112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  914117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  914120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  914123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  914126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914141 */     // MIs[0] rs2
     /*  914141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  914144 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  914149 */     // MIs[0] policy
     /*  914149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914159 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  914162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  914164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914180 */     GIR_RootConstrainSelectedInstOperands,
     /*  914181 */     // GIR_Coverage, 62451,
     /*  914181 */     GIR_EraseRootFromParent_Done,
     /*  914182 */   // Label 13923: @914182
     /*  914182 */   GIM_Try, /*On fail goto*//*Label 13924*/ GIMT_Encode4(914260), // Rule ID 62452 //
     /*  914187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  914190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  914195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  914198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  914201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  914204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914219 */     // MIs[0] rs2
     /*  914219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  914222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  914227 */     // MIs[0] policy
     /*  914227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914237 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  914240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  914242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914258 */     GIR_RootConstrainSelectedInstOperands,
     /*  914259 */     // GIR_Coverage, 62452,
     /*  914259 */     GIR_EraseRootFromParent_Done,
     /*  914260 */   // Label 13924: @914260
     /*  914260 */   GIM_Try, /*On fail goto*//*Label 13925*/ GIMT_Encode4(914338), // Rule ID 62453 //
     /*  914265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  914268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  914273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  914276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  914279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  914282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914297 */     // MIs[0] rs2
     /*  914297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  914300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  914305 */     // MIs[0] policy
     /*  914305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914315 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  914318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  914320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914336 */     GIR_RootConstrainSelectedInstOperands,
     /*  914337 */     // GIR_Coverage, 62453,
     /*  914337 */     GIR_EraseRootFromParent_Done,
     /*  914338 */   // Label 13925: @914338
     /*  914338 */   GIM_Try, /*On fail goto*//*Label 13926*/ GIMT_Encode4(914426), // Rule ID 23710 //
     /*  914343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  914354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  914357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  914360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914390 */     // MIs[1] Operand 1
     /*  914390 */     // No operand predicates
     /*  914390 */     // MIs[0] policy
     /*  914390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914402 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  914405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914424 */     GIR_RootConstrainSelectedInstOperands,
     /*  914425 */     // GIR_Coverage, 23710,
     /*  914425 */     GIR_EraseRootFromParent_Done,
     /*  914426 */   // Label 13926: @914426
     /*  914426 */   GIM_Try, /*On fail goto*//*Label 13927*/ GIMT_Encode4(914514), // Rule ID 23711 //
     /*  914431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  914442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  914445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  914448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914478 */     // MIs[1] Operand 1
     /*  914478 */     // No operand predicates
     /*  914478 */     // MIs[0] policy
     /*  914478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914490 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  914493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914512 */     GIR_RootConstrainSelectedInstOperands,
     /*  914513 */     // GIR_Coverage, 23711,
     /*  914513 */     GIR_EraseRootFromParent_Done,
     /*  914514 */   // Label 13927: @914514
     /*  914514 */   GIM_Try, /*On fail goto*//*Label 13928*/ GIMT_Encode4(914602), // Rule ID 23714 //
     /*  914519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  914530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  914533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  914536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914566 */     // MIs[1] Operand 1
     /*  914566 */     // No operand predicates
     /*  914566 */     // MIs[0] policy
     /*  914566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914578 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914600 */     GIR_RootConstrainSelectedInstOperands,
     /*  914601 */     // GIR_Coverage, 23714,
     /*  914601 */     GIR_EraseRootFromParent_Done,
     /*  914602 */   // Label 13928: @914602
     /*  914602 */   GIM_Try, /*On fail goto*//*Label 13929*/ GIMT_Encode4(914690), // Rule ID 23715 //
     /*  914607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  914618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  914621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  914624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914654 */     // MIs[1] Operand 1
     /*  914654 */     // No operand predicates
     /*  914654 */     // MIs[0] policy
     /*  914654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914666 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914688 */     GIR_RootConstrainSelectedInstOperands,
     /*  914689 */     // GIR_Coverage, 23715,
     /*  914689 */     GIR_EraseRootFromParent_Done,
     /*  914690 */   // Label 13929: @914690
     /*  914690 */   GIM_Try, /*On fail goto*//*Label 13930*/ GIMT_Encode4(914778), // Rule ID 23718 //
     /*  914695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  914706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  914709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  914712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914742 */     // MIs[1] Operand 1
     /*  914742 */     // No operand predicates
     /*  914742 */     // MIs[0] policy
     /*  914742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914754 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914776 */     GIR_RootConstrainSelectedInstOperands,
     /*  914777 */     // GIR_Coverage, 23718,
     /*  914777 */     GIR_EraseRootFromParent_Done,
     /*  914778 */   // Label 13930: @914778
     /*  914778 */   GIM_Try, /*On fail goto*//*Label 13931*/ GIMT_Encode4(914866), // Rule ID 23719 //
     /*  914783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  914794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  914797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  914800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914830 */     // MIs[1] Operand 1
     /*  914830 */     // No operand predicates
     /*  914830 */     // MIs[0] policy
     /*  914830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914842 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914864 */     GIR_RootConstrainSelectedInstOperands,
     /*  914865 */     // GIR_Coverage, 23719,
     /*  914865 */     GIR_EraseRootFromParent_Done,
     /*  914866 */   // Label 13931: @914866
     /*  914866 */   GIM_Try, /*On fail goto*//*Label 13932*/ GIMT_Encode4(914954), // Rule ID 23722 //
     /*  914871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  914882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  914885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  914888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914918 */     // MIs[1] Operand 1
     /*  914918 */     // No operand predicates
     /*  914918 */     // MIs[0] policy
     /*  914918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914930 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914952 */     GIR_RootConstrainSelectedInstOperands,
     /*  914953 */     // GIR_Coverage, 23722,
     /*  914953 */     GIR_EraseRootFromParent_Done,
     /*  914954 */   // Label 13932: @914954
     /*  914954 */   GIM_Try, /*On fail goto*//*Label 13933*/ GIMT_Encode4(915042), // Rule ID 23723 //
     /*  914959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  914970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  914973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  914976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915006 */     // MIs[1] Operand 1
     /*  915006 */     // No operand predicates
     /*  915006 */     // MIs[0] policy
     /*  915006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  915021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915040 */     GIR_RootConstrainSelectedInstOperands,
     /*  915041 */     // GIR_Coverage, 23723,
     /*  915041 */     GIR_EraseRootFromParent_Done,
     /*  915042 */   // Label 13933: @915042
     /*  915042 */   GIM_Try, /*On fail goto*//*Label 13934*/ GIMT_Encode4(915130), // Rule ID 23726 //
     /*  915047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  915058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  915061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  915064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915094 */     // MIs[1] Operand 1
     /*  915094 */     // No operand predicates
     /*  915094 */     // MIs[0] policy
     /*  915094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915106 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  915109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915128 */     GIR_RootConstrainSelectedInstOperands,
     /*  915129 */     // GIR_Coverage, 23726,
     /*  915129 */     GIR_EraseRootFromParent_Done,
     /*  915130 */   // Label 13934: @915130
     /*  915130 */   GIM_Try, /*On fail goto*//*Label 13935*/ GIMT_Encode4(915218), // Rule ID 23727 //
     /*  915135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  915146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  915149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  915152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915182 */     // MIs[1] Operand 1
     /*  915182 */     // No operand predicates
     /*  915182 */     // MIs[0] policy
     /*  915182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  915197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915216 */     GIR_RootConstrainSelectedInstOperands,
     /*  915217 */     // GIR_Coverage, 23727,
     /*  915217 */     GIR_EraseRootFromParent_Done,
     /*  915218 */   // Label 13935: @915218
     /*  915218 */   GIM_Try, /*On fail goto*//*Label 13936*/ GIMT_Encode4(915306), // Rule ID 23730 //
     /*  915223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  915234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  915237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  915240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915270 */     // MIs[1] Operand 1
     /*  915270 */     // No operand predicates
     /*  915270 */     // MIs[0] policy
     /*  915270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915282 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  915285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915304 */     GIR_RootConstrainSelectedInstOperands,
     /*  915305 */     // GIR_Coverage, 23730,
     /*  915305 */     GIR_EraseRootFromParent_Done,
     /*  915306 */   // Label 13936: @915306
     /*  915306 */   GIM_Try, /*On fail goto*//*Label 13937*/ GIMT_Encode4(915394), // Rule ID 23731 //
     /*  915311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  915322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  915325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  915328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915358 */     // MIs[1] Operand 1
     /*  915358 */     // No operand predicates
     /*  915358 */     // MIs[0] policy
     /*  915358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  915373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915392 */     GIR_RootConstrainSelectedInstOperands,
     /*  915393 */     // GIR_Coverage, 23731,
     /*  915393 */     GIR_EraseRootFromParent_Done,
     /*  915394 */   // Label 13937: @915394
     /*  915394 */   GIM_Try, /*On fail goto*//*Label 13938*/ GIMT_Encode4(915482), // Rule ID 23734 //
     /*  915399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  915410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  915413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  915416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915446 */     // MIs[1] Operand 1
     /*  915446 */     // No operand predicates
     /*  915446 */     // MIs[0] policy
     /*  915446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915458 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915480 */     GIR_RootConstrainSelectedInstOperands,
     /*  915481 */     // GIR_Coverage, 23734,
     /*  915481 */     GIR_EraseRootFromParent_Done,
     /*  915482 */   // Label 13938: @915482
     /*  915482 */   GIM_Try, /*On fail goto*//*Label 13939*/ GIMT_Encode4(915570), // Rule ID 23735 //
     /*  915487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  915498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  915501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  915504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915534 */     // MIs[1] Operand 1
     /*  915534 */     // No operand predicates
     /*  915534 */     // MIs[0] policy
     /*  915534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915546 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915568 */     GIR_RootConstrainSelectedInstOperands,
     /*  915569 */     // GIR_Coverage, 23735,
     /*  915569 */     GIR_EraseRootFromParent_Done,
     /*  915570 */   // Label 13939: @915570
     /*  915570 */   GIM_Try, /*On fail goto*//*Label 13940*/ GIMT_Encode4(915658), // Rule ID 23738 //
     /*  915575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  915586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  915589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  915592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915622 */     // MIs[1] Operand 1
     /*  915622 */     // No operand predicates
     /*  915622 */     // MIs[0] policy
     /*  915622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915634 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915656 */     GIR_RootConstrainSelectedInstOperands,
     /*  915657 */     // GIR_Coverage, 23738,
     /*  915657 */     GIR_EraseRootFromParent_Done,
     /*  915658 */   // Label 13940: @915658
     /*  915658 */   GIM_Try, /*On fail goto*//*Label 13941*/ GIMT_Encode4(915746), // Rule ID 23739 //
     /*  915663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  915674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  915677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  915680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915710 */     // MIs[1] Operand 1
     /*  915710 */     // No operand predicates
     /*  915710 */     // MIs[0] policy
     /*  915710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915722 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915744 */     GIR_RootConstrainSelectedInstOperands,
     /*  915745 */     // GIR_Coverage, 23739,
     /*  915745 */     GIR_EraseRootFromParent_Done,
     /*  915746 */   // Label 13941: @915746
     /*  915746 */   GIM_Try, /*On fail goto*//*Label 13942*/ GIMT_Encode4(915834), // Rule ID 23742 //
     /*  915751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  915762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  915765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  915768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915798 */     // MIs[1] Operand 1
     /*  915798 */     // No operand predicates
     /*  915798 */     // MIs[0] policy
     /*  915798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915832 */     GIR_RootConstrainSelectedInstOperands,
     /*  915833 */     // GIR_Coverage, 23742,
     /*  915833 */     GIR_EraseRootFromParent_Done,
     /*  915834 */   // Label 13942: @915834
     /*  915834 */   GIM_Try, /*On fail goto*//*Label 13943*/ GIMT_Encode4(915922), // Rule ID 23743 //
     /*  915839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  915850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  915853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  915856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915886 */     // MIs[1] Operand 1
     /*  915886 */     // No operand predicates
     /*  915886 */     // MIs[0] policy
     /*  915886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915898 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915920 */     GIR_RootConstrainSelectedInstOperands,
     /*  915921 */     // GIR_Coverage, 23743,
     /*  915921 */     GIR_EraseRootFromParent_Done,
     /*  915922 */   // Label 13943: @915922
     /*  915922 */   GIM_Try, /*On fail goto*//*Label 13944*/ GIMT_Encode4(916010), // Rule ID 23746 //
     /*  915927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  915930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  915941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  915944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915974 */     // MIs[1] Operand 1
     /*  915974 */     // No operand predicates
     /*  915974 */     // MIs[0] policy
     /*  915974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915986 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  916006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916008 */     GIR_RootConstrainSelectedInstOperands,
     /*  916009 */     // GIR_Coverage, 23746,
     /*  916009 */     GIR_EraseRootFromParent_Done,
     /*  916010 */   // Label 13944: @916010
     /*  916010 */   GIM_Try, /*On fail goto*//*Label 13945*/ GIMT_Encode4(916098), // Rule ID 23747 //
     /*  916015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  916018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  916026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  916029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  916032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916062 */     // MIs[1] Operand 1
     /*  916062 */     // No operand predicates
     /*  916062 */     // MIs[0] policy
     /*  916062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  916077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  916094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916096 */     GIR_RootConstrainSelectedInstOperands,
     /*  916097 */     // GIR_Coverage, 23747,
     /*  916097 */     GIR_EraseRootFromParent_Done,
     /*  916098 */   // Label 13945: @916098
     /*  916098 */   GIM_Try, /*On fail goto*//*Label 13946*/ GIMT_Encode4(916186), // Rule ID 23750 //
     /*  916103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  916114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  916117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  916120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916150 */     // MIs[1] Operand 1
     /*  916150 */     // No operand predicates
     /*  916150 */     // MIs[0] policy
     /*  916150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916162 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916184 */     GIR_RootConstrainSelectedInstOperands,
     /*  916185 */     // GIR_Coverage, 23750,
     /*  916185 */     GIR_EraseRootFromParent_Done,
     /*  916186 */   // Label 13946: @916186
     /*  916186 */   GIM_Try, /*On fail goto*//*Label 13947*/ GIMT_Encode4(916274), // Rule ID 23751 //
     /*  916191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  916202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  916205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  916208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916238 */     // MIs[1] Operand 1
     /*  916238 */     // No operand predicates
     /*  916238 */     // MIs[0] policy
     /*  916238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916250 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916272 */     GIR_RootConstrainSelectedInstOperands,
     /*  916273 */     // GIR_Coverage, 23751,
     /*  916273 */     GIR_EraseRootFromParent_Done,
     /*  916274 */   // Label 13947: @916274
     /*  916274 */   GIM_Try, /*On fail goto*//*Label 13948*/ GIMT_Encode4(916362), // Rule ID 23754 //
     /*  916279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  916290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  916293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  916296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916326 */     // MIs[1] Operand 1
     /*  916326 */     // No operand predicates
     /*  916326 */     // MIs[0] policy
     /*  916326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916338 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916360 */     GIR_RootConstrainSelectedInstOperands,
     /*  916361 */     // GIR_Coverage, 23754,
     /*  916361 */     GIR_EraseRootFromParent_Done,
     /*  916362 */   // Label 13948: @916362
     /*  916362 */   GIM_Try, /*On fail goto*//*Label 13949*/ GIMT_Encode4(916450), // Rule ID 23755 //
     /*  916367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  916378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  916381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  916384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916414 */     // MIs[1] Operand 1
     /*  916414 */     // No operand predicates
     /*  916414 */     // MIs[0] policy
     /*  916414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916426 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916448 */     GIR_RootConstrainSelectedInstOperands,
     /*  916449 */     // GIR_Coverage, 23755,
     /*  916449 */     GIR_EraseRootFromParent_Done,
     /*  916450 */   // Label 13949: @916450
     /*  916450 */   GIM_Try, /*On fail goto*//*Label 13950*/ GIMT_Encode4(916538), // Rule ID 23758 //
     /*  916455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  916466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  916469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  916472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916502 */     // MIs[1] Operand 1
     /*  916502 */     // No operand predicates
     /*  916502 */     // MIs[0] policy
     /*  916502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916514 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916536 */     GIR_RootConstrainSelectedInstOperands,
     /*  916537 */     // GIR_Coverage, 23758,
     /*  916537 */     GIR_EraseRootFromParent_Done,
     /*  916538 */   // Label 13950: @916538
     /*  916538 */   GIM_Try, /*On fail goto*//*Label 13951*/ GIMT_Encode4(916626), // Rule ID 23759 //
     /*  916543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  916554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  916557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  916560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916590 */     // MIs[1] Operand 1
     /*  916590 */     // No operand predicates
     /*  916590 */     // MIs[0] policy
     /*  916590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916602 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916624 */     GIR_RootConstrainSelectedInstOperands,
     /*  916625 */     // GIR_Coverage, 23759,
     /*  916625 */     GIR_EraseRootFromParent_Done,
     /*  916626 */   // Label 13951: @916626
     /*  916626 */   GIM_Try, /*On fail goto*//*Label 13952*/ GIMT_Encode4(916714), // Rule ID 23762 //
     /*  916631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  916642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  916645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  916648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916678 */     // MIs[1] Operand 1
     /*  916678 */     // No operand predicates
     /*  916678 */     // MIs[0] policy
     /*  916678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916690 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916712 */     GIR_RootConstrainSelectedInstOperands,
     /*  916713 */     // GIR_Coverage, 23762,
     /*  916713 */     GIR_EraseRootFromParent_Done,
     /*  916714 */   // Label 13952: @916714
     /*  916714 */   GIM_Try, /*On fail goto*//*Label 13953*/ GIMT_Encode4(916802), // Rule ID 23763 //
     /*  916719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  916730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  916733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  916736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916766 */     // MIs[1] Operand 1
     /*  916766 */     // No operand predicates
     /*  916766 */     // MIs[0] policy
     /*  916766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916778 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916800 */     GIR_RootConstrainSelectedInstOperands,
     /*  916801 */     // GIR_Coverage, 23763,
     /*  916801 */     GIR_EraseRootFromParent_Done,
     /*  916802 */   // Label 13953: @916802
     /*  916802 */   GIM_Try, /*On fail goto*//*Label 13954*/ GIMT_Encode4(916890), // Rule ID 23766 //
     /*  916807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  916818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  916821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  916824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916854 */     // MIs[1] Operand 1
     /*  916854 */     // No operand predicates
     /*  916854 */     // MIs[0] policy
     /*  916854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916888 */     GIR_RootConstrainSelectedInstOperands,
     /*  916889 */     // GIR_Coverage, 23766,
     /*  916889 */     GIR_EraseRootFromParent_Done,
     /*  916890 */   // Label 13954: @916890
     /*  916890 */   GIM_Try, /*On fail goto*//*Label 13955*/ GIMT_Encode4(916978), // Rule ID 23767 //
     /*  916895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  916906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  916909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  916912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916942 */     // MIs[1] Operand 1
     /*  916942 */     // No operand predicates
     /*  916942 */     // MIs[0] policy
     /*  916942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916954 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916976 */     GIR_RootConstrainSelectedInstOperands,
     /*  916977 */     // GIR_Coverage, 23767,
     /*  916977 */     GIR_EraseRootFromParent_Done,
     /*  916978 */   // Label 13955: @916978
     /*  916978 */   GIM_Try, /*On fail goto*//*Label 13956*/ GIMT_Encode4(917066), // Rule ID 23770 //
     /*  916983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  916994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  916997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  917000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917030 */     // MIs[1] Operand 1
     /*  917030 */     // No operand predicates
     /*  917030 */     // MIs[0] policy
     /*  917030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917042 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  917062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917064 */     GIR_RootConstrainSelectedInstOperands,
     /*  917065 */     // GIR_Coverage, 23770,
     /*  917065 */     GIR_EraseRootFromParent_Done,
     /*  917066 */   // Label 13956: @917066
     /*  917066 */   GIM_Try, /*On fail goto*//*Label 13957*/ GIMT_Encode4(917154), // Rule ID 23771 //
     /*  917071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  917082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  917085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  917088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917118 */     // MIs[1] Operand 1
     /*  917118 */     // No operand predicates
     /*  917118 */     // MIs[0] policy
     /*  917118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917130 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  917150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917152 */     GIR_RootConstrainSelectedInstOperands,
     /*  917153 */     // GIR_Coverage, 23771,
     /*  917153 */     GIR_EraseRootFromParent_Done,
     /*  917154 */   // Label 13957: @917154
     /*  917154 */   GIM_Try, /*On fail goto*//*Label 13958*/ GIMT_Encode4(917242), // Rule ID 23774 //
     /*  917159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  917170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  917173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  917176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917206 */     // MIs[1] Operand 1
     /*  917206 */     // No operand predicates
     /*  917206 */     // MIs[0] policy
     /*  917206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  917221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917240 */     GIR_RootConstrainSelectedInstOperands,
     /*  917241 */     // GIR_Coverage, 23774,
     /*  917241 */     GIR_EraseRootFromParent_Done,
     /*  917242 */   // Label 13958: @917242
     /*  917242 */   GIM_Try, /*On fail goto*//*Label 13959*/ GIMT_Encode4(917330), // Rule ID 23775 //
     /*  917247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  917258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  917261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  917264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917294 */     // MIs[1] Operand 1
     /*  917294 */     // No operand predicates
     /*  917294 */     // MIs[0] policy
     /*  917294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  917309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917328 */     GIR_RootConstrainSelectedInstOperands,
     /*  917329 */     // GIR_Coverage, 23775,
     /*  917329 */     GIR_EraseRootFromParent_Done,
     /*  917330 */   // Label 13959: @917330
     /*  917330 */   GIM_Try, /*On fail goto*//*Label 13960*/ GIMT_Encode4(917418), // Rule ID 23778 //
     /*  917335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  917346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  917349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  917352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917382 */     // MIs[1] Operand 1
     /*  917382 */     // No operand predicates
     /*  917382 */     // MIs[0] policy
     /*  917382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917394 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917416 */     GIR_RootConstrainSelectedInstOperands,
     /*  917417 */     // GIR_Coverage, 23778,
     /*  917417 */     GIR_EraseRootFromParent_Done,
     /*  917418 */   // Label 13960: @917418
     /*  917418 */   GIM_Try, /*On fail goto*//*Label 13961*/ GIMT_Encode4(917506), // Rule ID 23779 //
     /*  917423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  917434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  917437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  917440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917470 */     // MIs[1] Operand 1
     /*  917470 */     // No operand predicates
     /*  917470 */     // MIs[0] policy
     /*  917470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917504 */     GIR_RootConstrainSelectedInstOperands,
     /*  917505 */     // GIR_Coverage, 23779,
     /*  917505 */     GIR_EraseRootFromParent_Done,
     /*  917506 */   // Label 13961: @917506
     /*  917506 */   GIM_Try, /*On fail goto*//*Label 13962*/ GIMT_Encode4(917594), // Rule ID 23782 //
     /*  917511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  917522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  917525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  917528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917558 */     // MIs[1] Operand 1
     /*  917558 */     // No operand predicates
     /*  917558 */     // MIs[0] policy
     /*  917558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917570 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917592 */     GIR_RootConstrainSelectedInstOperands,
     /*  917593 */     // GIR_Coverage, 23782,
     /*  917593 */     GIR_EraseRootFromParent_Done,
     /*  917594 */   // Label 13962: @917594
     /*  917594 */   GIM_Try, /*On fail goto*//*Label 13963*/ GIMT_Encode4(917682), // Rule ID 23783 //
     /*  917599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  917610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  917613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  917616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917646 */     // MIs[1] Operand 1
     /*  917646 */     // No operand predicates
     /*  917646 */     // MIs[0] policy
     /*  917646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917658 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917680 */     GIR_RootConstrainSelectedInstOperands,
     /*  917681 */     // GIR_Coverage, 23783,
     /*  917681 */     GIR_EraseRootFromParent_Done,
     /*  917682 */   // Label 13963: @917682
     /*  917682 */   GIM_Try, /*On fail goto*//*Label 13964*/ GIMT_Encode4(917770), // Rule ID 23786 //
     /*  917687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  917690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  917698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  917701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  917704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917734 */     // MIs[1] Operand 1
     /*  917734 */     // No operand predicates
     /*  917734 */     // MIs[0] policy
     /*  917734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  917749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917768 */     GIR_RootConstrainSelectedInstOperands,
     /*  917769 */     // GIR_Coverage, 23786,
     /*  917769 */     GIR_EraseRootFromParent_Done,
     /*  917770 */   // Label 13964: @917770
     /*  917770 */   GIM_Try, /*On fail goto*//*Label 13965*/ GIMT_Encode4(917858), // Rule ID 23787 //
     /*  917775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  917778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  917786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  917789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  917792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917822 */     // MIs[1] Operand 1
     /*  917822 */     // No operand predicates
     /*  917822 */     // MIs[0] policy
     /*  917822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917834 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  917837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917856 */     GIR_RootConstrainSelectedInstOperands,
     /*  917857 */     // GIR_Coverage, 23787,
     /*  917857 */     GIR_EraseRootFromParent_Done,
     /*  917858 */   // Label 13965: @917858
     /*  917858 */   GIM_Try, /*On fail goto*//*Label 13966*/ GIMT_Encode4(917946), // Rule ID 23790 //
     /*  917863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  917866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  917874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  917877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  917880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917910 */     // MIs[1] Operand 1
     /*  917910 */     // No operand predicates
     /*  917910 */     // MIs[0] policy
     /*  917910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917922 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917944 */     GIR_RootConstrainSelectedInstOperands,
     /*  917945 */     // GIR_Coverage, 23790,
     /*  917945 */     GIR_EraseRootFromParent_Done,
     /*  917946 */   // Label 13966: @917946
     /*  917946 */   GIM_Try, /*On fail goto*//*Label 13967*/ GIMT_Encode4(918034), // Rule ID 23791 //
     /*  917951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  917954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  917962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  917965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  917968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917998 */     // MIs[1] Operand 1
     /*  917998 */     // No operand predicates
     /*  917998 */     // MIs[0] policy
     /*  917998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918010 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  918013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  918030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918032 */     GIR_RootConstrainSelectedInstOperands,
     /*  918033 */     // GIR_Coverage, 23791,
     /*  918033 */     GIR_EraseRootFromParent_Done,
     /*  918034 */   // Label 13967: @918034
     /*  918034 */   GIM_Try, /*On fail goto*//*Label 13968*/ GIMT_Encode4(918122), // Rule ID 23794 //
     /*  918039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  918042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  918050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  918053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  918056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918086 */     // MIs[1] Operand 1
     /*  918086 */     // No operand predicates
     /*  918086 */     // MIs[0] policy
     /*  918086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918098 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  918101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  918118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918120 */     GIR_RootConstrainSelectedInstOperands,
     /*  918121 */     // GIR_Coverage, 23794,
     /*  918121 */     GIR_EraseRootFromParent_Done,
     /*  918122 */   // Label 13968: @918122
     /*  918122 */   GIM_Try, /*On fail goto*//*Label 13969*/ GIMT_Encode4(918210), // Rule ID 23795 //
     /*  918127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  918130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  918138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  918141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  918144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918174 */     // MIs[1] Operand 1
     /*  918174 */     // No operand predicates
     /*  918174 */     // MIs[0] policy
     /*  918174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918186 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  918189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  918206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918208 */     GIR_RootConstrainSelectedInstOperands,
     /*  918209 */     // GIR_Coverage, 23795,
     /*  918209 */     GIR_EraseRootFromParent_Done,
     /*  918210 */   // Label 13969: @918210
     /*  918210 */   GIM_Try, /*On fail goto*//*Label 13970*/ GIMT_Encode4(918298), // Rule ID 23886 //
     /*  918215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  918226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  918229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  918232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918262 */     // MIs[1] Operand 1
     /*  918262 */     // No operand predicates
     /*  918262 */     // MIs[0] policy
     /*  918262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  918277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918296 */     GIR_RootConstrainSelectedInstOperands,
     /*  918297 */     // GIR_Coverage, 23886,
     /*  918297 */     GIR_EraseRootFromParent_Done,
     /*  918298 */   // Label 13970: @918298
     /*  918298 */   GIM_Try, /*On fail goto*//*Label 13971*/ GIMT_Encode4(918386), // Rule ID 23887 //
     /*  918303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  918314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  918317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  918320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918350 */     // MIs[1] Operand 1
     /*  918350 */     // No operand predicates
     /*  918350 */     // MIs[0] policy
     /*  918350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918362 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  918365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918384 */     GIR_RootConstrainSelectedInstOperands,
     /*  918385 */     // GIR_Coverage, 23887,
     /*  918385 */     GIR_EraseRootFromParent_Done,
     /*  918386 */   // Label 13971: @918386
     /*  918386 */   GIM_Try, /*On fail goto*//*Label 13972*/ GIMT_Encode4(918474), // Rule ID 23890 //
     /*  918391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  918402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  918405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  918408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918438 */     // MIs[1] Operand 1
     /*  918438 */     // No operand predicates
     /*  918438 */     // MIs[0] policy
     /*  918438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918450 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918472 */     GIR_RootConstrainSelectedInstOperands,
     /*  918473 */     // GIR_Coverage, 23890,
     /*  918473 */     GIR_EraseRootFromParent_Done,
     /*  918474 */   // Label 13972: @918474
     /*  918474 */   GIM_Try, /*On fail goto*//*Label 13973*/ GIMT_Encode4(918562), // Rule ID 23891 //
     /*  918479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  918490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  918493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  918496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918526 */     // MIs[1] Operand 1
     /*  918526 */     // No operand predicates
     /*  918526 */     // MIs[0] policy
     /*  918526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918538 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918560 */     GIR_RootConstrainSelectedInstOperands,
     /*  918561 */     // GIR_Coverage, 23891,
     /*  918561 */     GIR_EraseRootFromParent_Done,
     /*  918562 */   // Label 13973: @918562
     /*  918562 */   GIM_Try, /*On fail goto*//*Label 13974*/ GIMT_Encode4(918650), // Rule ID 23894 //
     /*  918567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  918578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  918581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  918584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918614 */     // MIs[1] Operand 1
     /*  918614 */     // No operand predicates
     /*  918614 */     // MIs[0] policy
     /*  918614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918626 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918648 */     GIR_RootConstrainSelectedInstOperands,
     /*  918649 */     // GIR_Coverage, 23894,
     /*  918649 */     GIR_EraseRootFromParent_Done,
     /*  918650 */   // Label 13974: @918650
     /*  918650 */   GIM_Try, /*On fail goto*//*Label 13975*/ GIMT_Encode4(918738), // Rule ID 23895 //
     /*  918655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  918666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  918669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  918672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918702 */     // MIs[1] Operand 1
     /*  918702 */     // No operand predicates
     /*  918702 */     // MIs[0] policy
     /*  918702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918714 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918736 */     GIR_RootConstrainSelectedInstOperands,
     /*  918737 */     // GIR_Coverage, 23895,
     /*  918737 */     GIR_EraseRootFromParent_Done,
     /*  918738 */   // Label 13975: @918738
     /*  918738 */   GIM_Try, /*On fail goto*//*Label 13976*/ GIMT_Encode4(918826), // Rule ID 23898 //
     /*  918743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  918754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  918757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  918760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918790 */     // MIs[1] Operand 1
     /*  918790 */     // No operand predicates
     /*  918790 */     // MIs[0] policy
     /*  918790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918802 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918824 */     GIR_RootConstrainSelectedInstOperands,
     /*  918825 */     // GIR_Coverage, 23898,
     /*  918825 */     GIR_EraseRootFromParent_Done,
     /*  918826 */   // Label 13976: @918826
     /*  918826 */   GIM_Try, /*On fail goto*//*Label 13977*/ GIMT_Encode4(918914), // Rule ID 23899 //
     /*  918831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  918842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  918845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  918848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918874 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918878 */     // MIs[1] Operand 1
     /*  918878 */     // No operand predicates
     /*  918878 */     // MIs[0] policy
     /*  918878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918890 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918912 */     GIR_RootConstrainSelectedInstOperands,
     /*  918913 */     // GIR_Coverage, 23899,
     /*  918913 */     GIR_EraseRootFromParent_Done,
     /*  918914 */   // Label 13977: @918914
     /*  918914 */   GIM_Try, /*On fail goto*//*Label 13978*/ GIMT_Encode4(919002), // Rule ID 23902 //
     /*  918919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  918930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  918933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  918936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918966 */     // MIs[1] Operand 1
     /*  918966 */     // No operand predicates
     /*  918966 */     // MIs[0] policy
     /*  918966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918978 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919000 */     GIR_RootConstrainSelectedInstOperands,
     /*  919001 */     // GIR_Coverage, 23902,
     /*  919001 */     GIR_EraseRootFromParent_Done,
     /*  919002 */   // Label 13978: @919002
     /*  919002 */   GIM_Try, /*On fail goto*//*Label 13979*/ GIMT_Encode4(919090), // Rule ID 23903 //
     /*  919007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  919018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  919021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  919024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919054 */     // MIs[1] Operand 1
     /*  919054 */     // No operand predicates
     /*  919054 */     // MIs[0] policy
     /*  919054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919066 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  919069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919088 */     GIR_RootConstrainSelectedInstOperands,
     /*  919089 */     // GIR_Coverage, 23903,
     /*  919089 */     GIR_EraseRootFromParent_Done,
     /*  919090 */   // Label 13979: @919090
     /*  919090 */   GIM_Try, /*On fail goto*//*Label 13980*/ GIMT_Encode4(919178), // Rule ID 23906 //
     /*  919095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  919106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  919109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  919112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919142 */     // MIs[1] Operand 1
     /*  919142 */     // No operand predicates
     /*  919142 */     // MIs[0] policy
     /*  919142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919154 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  919157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919176 */     GIR_RootConstrainSelectedInstOperands,
     /*  919177 */     // GIR_Coverage, 23906,
     /*  919177 */     GIR_EraseRootFromParent_Done,
     /*  919178 */   // Label 13980: @919178
     /*  919178 */   GIM_Try, /*On fail goto*//*Label 13981*/ GIMT_Encode4(919266), // Rule ID 23907 //
     /*  919183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  919194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  919197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  919200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919230 */     // MIs[1] Operand 1
     /*  919230 */     // No operand predicates
     /*  919230 */     // MIs[0] policy
     /*  919230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919242 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  919245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919264 */     GIR_RootConstrainSelectedInstOperands,
     /*  919265 */     // GIR_Coverage, 23907,
     /*  919265 */     GIR_EraseRootFromParent_Done,
     /*  919266 */   // Label 13981: @919266
     /*  919266 */   GIM_Try, /*On fail goto*//*Label 13982*/ GIMT_Encode4(919354), // Rule ID 23910 //
     /*  919271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  919282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  919285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  919288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919318 */     // MIs[1] Operand 1
     /*  919318 */     // No operand predicates
     /*  919318 */     // MIs[0] policy
     /*  919318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919330 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919352 */     GIR_RootConstrainSelectedInstOperands,
     /*  919353 */     // GIR_Coverage, 23910,
     /*  919353 */     GIR_EraseRootFromParent_Done,
     /*  919354 */   // Label 13982: @919354
     /*  919354 */   GIM_Try, /*On fail goto*//*Label 13983*/ GIMT_Encode4(919442), // Rule ID 23911 //
     /*  919359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  919370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  919373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  919376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919406 */     // MIs[1] Operand 1
     /*  919406 */     // No operand predicates
     /*  919406 */     // MIs[0] policy
     /*  919406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919418 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919440 */     GIR_RootConstrainSelectedInstOperands,
     /*  919441 */     // GIR_Coverage, 23911,
     /*  919441 */     GIR_EraseRootFromParent_Done,
     /*  919442 */   // Label 13983: @919442
     /*  919442 */   GIM_Try, /*On fail goto*//*Label 13984*/ GIMT_Encode4(919530), // Rule ID 23914 //
     /*  919447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  919458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  919461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  919464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919494 */     // MIs[1] Operand 1
     /*  919494 */     // No operand predicates
     /*  919494 */     // MIs[0] policy
     /*  919494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919528 */     GIR_RootConstrainSelectedInstOperands,
     /*  919529 */     // GIR_Coverage, 23914,
     /*  919529 */     GIR_EraseRootFromParent_Done,
     /*  919530 */   // Label 13984: @919530
     /*  919530 */   GIM_Try, /*On fail goto*//*Label 13985*/ GIMT_Encode4(919618), // Rule ID 23915 //
     /*  919535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  919546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  919549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  919552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919582 */     // MIs[1] Operand 1
     /*  919582 */     // No operand predicates
     /*  919582 */     // MIs[0] policy
     /*  919582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919594 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919616 */     GIR_RootConstrainSelectedInstOperands,
     /*  919617 */     // GIR_Coverage, 23915,
     /*  919617 */     GIR_EraseRootFromParent_Done,
     /*  919618 */   // Label 13985: @919618
     /*  919618 */   GIM_Try, /*On fail goto*//*Label 13986*/ GIMT_Encode4(919706), // Rule ID 23918 //
     /*  919623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  919634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  919637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  919640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919670 */     // MIs[1] Operand 1
     /*  919670 */     // No operand predicates
     /*  919670 */     // MIs[0] policy
     /*  919670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919704 */     GIR_RootConstrainSelectedInstOperands,
     /*  919705 */     // GIR_Coverage, 23918,
     /*  919705 */     GIR_EraseRootFromParent_Done,
     /*  919706 */   // Label 13986: @919706
     /*  919706 */   GIM_Try, /*On fail goto*//*Label 13987*/ GIMT_Encode4(919794), // Rule ID 23919 //
     /*  919711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  919722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  919725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  919728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919758 */     // MIs[1] Operand 1
     /*  919758 */     // No operand predicates
     /*  919758 */     // MIs[0] policy
     /*  919758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919792 */     GIR_RootConstrainSelectedInstOperands,
     /*  919793 */     // GIR_Coverage, 23919,
     /*  919793 */     GIR_EraseRootFromParent_Done,
     /*  919794 */   // Label 13987: @919794
     /*  919794 */   GIM_Try, /*On fail goto*//*Label 13988*/ GIMT_Encode4(919882), // Rule ID 23922 //
     /*  919799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  919802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  919810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  919813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  919816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919846 */     // MIs[1] Operand 1
     /*  919846 */     // No operand predicates
     /*  919846 */     // MIs[0] policy
     /*  919846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919858 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  919878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919880 */     GIR_RootConstrainSelectedInstOperands,
     /*  919881 */     // GIR_Coverage, 23922,
     /*  919881 */     GIR_EraseRootFromParent_Done,
     /*  919882 */   // Label 13988: @919882
     /*  919882 */   GIM_Try, /*On fail goto*//*Label 13989*/ GIMT_Encode4(919970), // Rule ID 23923 //
     /*  919887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  919890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  919898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  919901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  919904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919934 */     // MIs[1] Operand 1
     /*  919934 */     // No operand predicates
     /*  919934 */     // MIs[0] policy
     /*  919934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  919966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919968 */     GIR_RootConstrainSelectedInstOperands,
     /*  919969 */     // GIR_Coverage, 23923,
     /*  919969 */     GIR_EraseRootFromParent_Done,
     /*  919970 */   // Label 13989: @919970
     /*  919970 */   GIM_Try, /*On fail goto*//*Label 13990*/ GIMT_Encode4(920058), // Rule ID 23926 //
     /*  919975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  919986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  919989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  919992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920022 */     // MIs[1] Operand 1
     /*  920022 */     // No operand predicates
     /*  920022 */     // MIs[0] policy
     /*  920022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920034 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920056 */     GIR_RootConstrainSelectedInstOperands,
     /*  920057 */     // GIR_Coverage, 23926,
     /*  920057 */     GIR_EraseRootFromParent_Done,
     /*  920058 */   // Label 13990: @920058
     /*  920058 */   GIM_Try, /*On fail goto*//*Label 13991*/ GIMT_Encode4(920146), // Rule ID 23927 //
     /*  920063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  920074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  920077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  920080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920110 */     // MIs[1] Operand 1
     /*  920110 */     // No operand predicates
     /*  920110 */     // MIs[0] policy
     /*  920110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920122 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920144 */     GIR_RootConstrainSelectedInstOperands,
     /*  920145 */     // GIR_Coverage, 23927,
     /*  920145 */     GIR_EraseRootFromParent_Done,
     /*  920146 */   // Label 13991: @920146
     /*  920146 */   GIM_Try, /*On fail goto*//*Label 13992*/ GIMT_Encode4(920234), // Rule ID 23930 //
     /*  920151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  920162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  920165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  920168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920198 */     // MIs[1] Operand 1
     /*  920198 */     // No operand predicates
     /*  920198 */     // MIs[0] policy
     /*  920198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920210 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920232 */     GIR_RootConstrainSelectedInstOperands,
     /*  920233 */     // GIR_Coverage, 23930,
     /*  920233 */     GIR_EraseRootFromParent_Done,
     /*  920234 */   // Label 13992: @920234
     /*  920234 */   GIM_Try, /*On fail goto*//*Label 13993*/ GIMT_Encode4(920322), // Rule ID 23931 //
     /*  920239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  920250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  920253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  920256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920286 */     // MIs[1] Operand 1
     /*  920286 */     // No operand predicates
     /*  920286 */     // MIs[0] policy
     /*  920286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920298 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920320 */     GIR_RootConstrainSelectedInstOperands,
     /*  920321 */     // GIR_Coverage, 23931,
     /*  920321 */     GIR_EraseRootFromParent_Done,
     /*  920322 */   // Label 13993: @920322
     /*  920322 */   GIM_Try, /*On fail goto*//*Label 13994*/ GIMT_Encode4(920410), // Rule ID 23934 //
     /*  920327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  920338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  920341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  920344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920374 */     // MIs[1] Operand 1
     /*  920374 */     // No operand predicates
     /*  920374 */     // MIs[0] policy
     /*  920374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920386 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920408 */     GIR_RootConstrainSelectedInstOperands,
     /*  920409 */     // GIR_Coverage, 23934,
     /*  920409 */     GIR_EraseRootFromParent_Done,
     /*  920410 */   // Label 13994: @920410
     /*  920410 */   GIM_Try, /*On fail goto*//*Label 13995*/ GIMT_Encode4(920498), // Rule ID 23935 //
     /*  920415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  920426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  920429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  920432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920462 */     // MIs[1] Operand 1
     /*  920462 */     // No operand predicates
     /*  920462 */     // MIs[0] policy
     /*  920462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920474 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920496 */     GIR_RootConstrainSelectedInstOperands,
     /*  920497 */     // GIR_Coverage, 23935,
     /*  920497 */     GIR_EraseRootFromParent_Done,
     /*  920498 */   // Label 13995: @920498
     /*  920498 */   GIM_Try, /*On fail goto*//*Label 13996*/ GIMT_Encode4(920586), // Rule ID 23938 //
     /*  920503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  920514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  920517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  920520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920550 */     // MIs[1] Operand 1
     /*  920550 */     // No operand predicates
     /*  920550 */     // MIs[0] policy
     /*  920550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920562 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920584 */     GIR_RootConstrainSelectedInstOperands,
     /*  920585 */     // GIR_Coverage, 23938,
     /*  920585 */     GIR_EraseRootFromParent_Done,
     /*  920586 */   // Label 13996: @920586
     /*  920586 */   GIM_Try, /*On fail goto*//*Label 13997*/ GIMT_Encode4(920674), // Rule ID 23939 //
     /*  920591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  920602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  920605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  920608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920638 */     // MIs[1] Operand 1
     /*  920638 */     // No operand predicates
     /*  920638 */     // MIs[0] policy
     /*  920638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920672 */     GIR_RootConstrainSelectedInstOperands,
     /*  920673 */     // GIR_Coverage, 23939,
     /*  920673 */     GIR_EraseRootFromParent_Done,
     /*  920674 */   // Label 13997: @920674
     /*  920674 */   GIM_Try, /*On fail goto*//*Label 13998*/ GIMT_Encode4(920762), // Rule ID 23942 //
     /*  920679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  920690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  920693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  920696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920722 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920726 */     // MIs[1] Operand 1
     /*  920726 */     // No operand predicates
     /*  920726 */     // MIs[0] policy
     /*  920726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920738 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920760 */     GIR_RootConstrainSelectedInstOperands,
     /*  920761 */     // GIR_Coverage, 23942,
     /*  920761 */     GIR_EraseRootFromParent_Done,
     /*  920762 */   // Label 13998: @920762
     /*  920762 */   GIM_Try, /*On fail goto*//*Label 13999*/ GIMT_Encode4(920850), // Rule ID 23943 //
     /*  920767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  920778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  920781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  920784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920814 */     // MIs[1] Operand 1
     /*  920814 */     // No operand predicates
     /*  920814 */     // MIs[0] policy
     /*  920814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920826 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920848 */     GIR_RootConstrainSelectedInstOperands,
     /*  920849 */     // GIR_Coverage, 23943,
     /*  920849 */     GIR_EraseRootFromParent_Done,
     /*  920850 */   // Label 13999: @920850
     /*  920850 */   GIM_Try, /*On fail goto*//*Label 14000*/ GIMT_Encode4(920938), // Rule ID 23946 //
     /*  920855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  920866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  920869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  920872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920902 */     // MIs[1] Operand 1
     /*  920902 */     // No operand predicates
     /*  920902 */     // MIs[0] policy
     /*  920902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920914 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920936 */     GIR_RootConstrainSelectedInstOperands,
     /*  920937 */     // GIR_Coverage, 23946,
     /*  920937 */     GIR_EraseRootFromParent_Done,
     /*  920938 */   // Label 14000: @920938
     /*  920938 */   GIM_Try, /*On fail goto*//*Label 14001*/ GIMT_Encode4(921026), // Rule ID 23947 //
     /*  920943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  920954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  920957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  920960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920990 */     // MIs[1] Operand 1
     /*  920990 */     // No operand predicates
     /*  920990 */     // MIs[0] policy
     /*  920990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921002 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921024 */     GIR_RootConstrainSelectedInstOperands,
     /*  921025 */     // GIR_Coverage, 23947,
     /*  921025 */     GIR_EraseRootFromParent_Done,
     /*  921026 */   // Label 14001: @921026
     /*  921026 */   GIM_Try, /*On fail goto*//*Label 14002*/ GIMT_Encode4(921114), // Rule ID 23950 //
     /*  921031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  921042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  921045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  921048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921078 */     // MIs[1] Operand 1
     /*  921078 */     // No operand predicates
     /*  921078 */     // MIs[0] policy
     /*  921078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  921093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921112 */     GIR_RootConstrainSelectedInstOperands,
     /*  921113 */     // GIR_Coverage, 23950,
     /*  921113 */     GIR_EraseRootFromParent_Done,
     /*  921114 */   // Label 14002: @921114
     /*  921114 */   GIM_Try, /*On fail goto*//*Label 14003*/ GIMT_Encode4(921202), // Rule ID 23951 //
     /*  921119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  921130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  921133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  921136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921166 */     // MIs[1] Operand 1
     /*  921166 */     // No operand predicates
     /*  921166 */     // MIs[0] policy
     /*  921166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921178 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  921181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921200 */     GIR_RootConstrainSelectedInstOperands,
     /*  921201 */     // GIR_Coverage, 23951,
     /*  921201 */     GIR_EraseRootFromParent_Done,
     /*  921202 */   // Label 14003: @921202
     /*  921202 */   GIM_Try, /*On fail goto*//*Label 14004*/ GIMT_Encode4(921290), // Rule ID 23954 //
     /*  921207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  921218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  921221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  921224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921254 */     // MIs[1] Operand 1
     /*  921254 */     // No operand predicates
     /*  921254 */     // MIs[0] policy
     /*  921254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  921269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921288 */     GIR_RootConstrainSelectedInstOperands,
     /*  921289 */     // GIR_Coverage, 23954,
     /*  921289 */     GIR_EraseRootFromParent_Done,
     /*  921290 */   // Label 14004: @921290
     /*  921290 */   GIM_Try, /*On fail goto*//*Label 14005*/ GIMT_Encode4(921378), // Rule ID 23955 //
     /*  921295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  921306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  921309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  921312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921342 */     // MIs[1] Operand 1
     /*  921342 */     // No operand predicates
     /*  921342 */     // MIs[0] policy
     /*  921342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921354 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  921357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921376 */     GIR_RootConstrainSelectedInstOperands,
     /*  921377 */     // GIR_Coverage, 23955,
     /*  921377 */     GIR_EraseRootFromParent_Done,
     /*  921378 */   // Label 14005: @921378
     /*  921378 */   GIM_Try, /*On fail goto*//*Label 14006*/ GIMT_Encode4(921466), // Rule ID 23958 //
     /*  921383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  921394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  921397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  921400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921430 */     // MIs[1] Operand 1
     /*  921430 */     // No operand predicates
     /*  921430 */     // MIs[0] policy
     /*  921430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921442 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921464 */     GIR_RootConstrainSelectedInstOperands,
     /*  921465 */     // GIR_Coverage, 23958,
     /*  921465 */     GIR_EraseRootFromParent_Done,
     /*  921466 */   // Label 14006: @921466
     /*  921466 */   GIM_Try, /*On fail goto*//*Label 14007*/ GIMT_Encode4(921554), // Rule ID 23959 //
     /*  921471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  921482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  921485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  921488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921518 */     // MIs[1] Operand 1
     /*  921518 */     // No operand predicates
     /*  921518 */     // MIs[0] policy
     /*  921518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921530 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921552 */     GIR_RootConstrainSelectedInstOperands,
     /*  921553 */     // GIR_Coverage, 23959,
     /*  921553 */     GIR_EraseRootFromParent_Done,
     /*  921554 */   // Label 14007: @921554
     /*  921554 */   GIM_Try, /*On fail goto*//*Label 14008*/ GIMT_Encode4(921642), // Rule ID 23962 //
     /*  921559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  921570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  921573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  921576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921606 */     // MIs[1] Operand 1
     /*  921606 */     // No operand predicates
     /*  921606 */     // MIs[0] policy
     /*  921606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  921621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921640 */     GIR_RootConstrainSelectedInstOperands,
     /*  921641 */     // GIR_Coverage, 23962,
     /*  921641 */     GIR_EraseRootFromParent_Done,
     /*  921642 */   // Label 14008: @921642
     /*  921642 */   GIM_Try, /*On fail goto*//*Label 14009*/ GIMT_Encode4(921730), // Rule ID 23963 //
     /*  921647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  921658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  921661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  921664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921694 */     // MIs[1] Operand 1
     /*  921694 */     // No operand predicates
     /*  921694 */     // MIs[0] policy
     /*  921694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921706 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  921709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921728 */     GIR_RootConstrainSelectedInstOperands,
     /*  921729 */     // GIR_Coverage, 23963,
     /*  921729 */     GIR_EraseRootFromParent_Done,
     /*  921730 */   // Label 14009: @921730
     /*  921730 */   GIM_Try, /*On fail goto*//*Label 14010*/ GIMT_Encode4(921818), // Rule ID 23966 //
     /*  921735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  921746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  921749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  921752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921782 */     // MIs[1] Operand 1
     /*  921782 */     // No operand predicates
     /*  921782 */     // MIs[0] policy
     /*  921782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  921797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921816 */     GIR_RootConstrainSelectedInstOperands,
     /*  921817 */     // GIR_Coverage, 23966,
     /*  921817 */     GIR_EraseRootFromParent_Done,
     /*  921818 */   // Label 14010: @921818
     /*  921818 */   GIM_Try, /*On fail goto*//*Label 14011*/ GIMT_Encode4(921906), // Rule ID 23967 //
     /*  921823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  921834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  921837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  921840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921870 */     // MIs[1] Operand 1
     /*  921870 */     // No operand predicates
     /*  921870 */     // MIs[0] policy
     /*  921870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921882 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  921885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921904 */     GIR_RootConstrainSelectedInstOperands,
     /*  921905 */     // GIR_Coverage, 23967,
     /*  921905 */     GIR_EraseRootFromParent_Done,
     /*  921906 */   // Label 14011: @921906
     /*  921906 */   GIM_Try, /*On fail goto*//*Label 14012*/ GIMT_Encode4(921994), // Rule ID 23970 //
     /*  921911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  921922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  921925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  921928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921958 */     // MIs[1] Operand 1
     /*  921958 */     // No operand predicates
     /*  921958 */     // MIs[0] policy
     /*  921958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921970 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921992 */     GIR_RootConstrainSelectedInstOperands,
     /*  921993 */     // GIR_Coverage, 23970,
     /*  921993 */     GIR_EraseRootFromParent_Done,
     /*  921994 */   // Label 14012: @921994
     /*  921994 */   GIM_Try, /*On fail goto*//*Label 14013*/ GIMT_Encode4(922082), // Rule ID 23971 //
     /*  921999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  922002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  922010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  922013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  922016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922046 */     // MIs[1] Operand 1
     /*  922046 */     // No operand predicates
     /*  922046 */     // MIs[0] policy
     /*  922046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922058 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  922061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  922078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922080 */     GIR_RootConstrainSelectedInstOperands,
     /*  922081 */     // GIR_Coverage, 23971,
     /*  922081 */     GIR_EraseRootFromParent_Done,
     /*  922082 */   // Label 14013: @922082
     /*  922082 */   GIM_Try, /*On fail goto*//*Label 14014*/ GIMT_Encode4(922170), // Rule ID 24210 //
     /*  922087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  922098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  922101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  922104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922134 */     // MIs[1] Operand 1
     /*  922134 */     // No operand predicates
     /*  922134 */     // MIs[0] policy
     /*  922134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922146 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  922149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922168 */     GIR_RootConstrainSelectedInstOperands,
     /*  922169 */     // GIR_Coverage, 24210,
     /*  922169 */     GIR_EraseRootFromParent_Done,
     /*  922170 */   // Label 14014: @922170
     /*  922170 */   GIM_Try, /*On fail goto*//*Label 14015*/ GIMT_Encode4(922258), // Rule ID 24211 //
     /*  922175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  922186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  922189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  922192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922222 */     // MIs[1] Operand 1
     /*  922222 */     // No operand predicates
     /*  922222 */     // MIs[0] policy
     /*  922222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922234 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  922237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922256 */     GIR_RootConstrainSelectedInstOperands,
     /*  922257 */     // GIR_Coverage, 24211,
     /*  922257 */     GIR_EraseRootFromParent_Done,
     /*  922258 */   // Label 14015: @922258
     /*  922258 */   GIM_Try, /*On fail goto*//*Label 14016*/ GIMT_Encode4(922346), // Rule ID 24214 //
     /*  922263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  922274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  922277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  922280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922310 */     // MIs[1] Operand 1
     /*  922310 */     // No operand predicates
     /*  922310 */     // MIs[0] policy
     /*  922310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922322 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  922325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922344 */     GIR_RootConstrainSelectedInstOperands,
     /*  922345 */     // GIR_Coverage, 24214,
     /*  922345 */     GIR_EraseRootFromParent_Done,
     /*  922346 */   // Label 14016: @922346
     /*  922346 */   GIM_Try, /*On fail goto*//*Label 14017*/ GIMT_Encode4(922434), // Rule ID 24215 //
     /*  922351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  922362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  922365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  922368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922394 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922398 */     // MIs[1] Operand 1
     /*  922398 */     // No operand predicates
     /*  922398 */     // MIs[0] policy
     /*  922398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922410 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  922413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922432 */     GIR_RootConstrainSelectedInstOperands,
     /*  922433 */     // GIR_Coverage, 24215,
     /*  922433 */     GIR_EraseRootFromParent_Done,
     /*  922434 */   // Label 14017: @922434
     /*  922434 */   GIM_Try, /*On fail goto*//*Label 14018*/ GIMT_Encode4(922522), // Rule ID 24218 //
     /*  922439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  922450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  922453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  922456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922486 */     // MIs[1] Operand 1
     /*  922486 */     // No operand predicates
     /*  922486 */     // MIs[0] policy
     /*  922486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922498 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  922501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922520 */     GIR_RootConstrainSelectedInstOperands,
     /*  922521 */     // GIR_Coverage, 24218,
     /*  922521 */     GIR_EraseRootFromParent_Done,
     /*  922522 */   // Label 14018: @922522
     /*  922522 */   GIM_Try, /*On fail goto*//*Label 14019*/ GIMT_Encode4(922610), // Rule ID 24219 //
     /*  922527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  922538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  922541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  922544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922574 */     // MIs[1] Operand 1
     /*  922574 */     // No operand predicates
     /*  922574 */     // MIs[0] policy
     /*  922574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922586 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  922589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922608 */     GIR_RootConstrainSelectedInstOperands,
     /*  922609 */     // GIR_Coverage, 24219,
     /*  922609 */     GIR_EraseRootFromParent_Done,
     /*  922610 */   // Label 14019: @922610
     /*  922610 */   GIM_Try, /*On fail goto*//*Label 14020*/ GIMT_Encode4(922698), // Rule ID 24222 //
     /*  922615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  922626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  922629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  922632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922662 */     // MIs[1] Operand 1
     /*  922662 */     // No operand predicates
     /*  922662 */     // MIs[0] policy
     /*  922662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922674 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922696 */     GIR_RootConstrainSelectedInstOperands,
     /*  922697 */     // GIR_Coverage, 24222,
     /*  922697 */     GIR_EraseRootFromParent_Done,
     /*  922698 */   // Label 14020: @922698
     /*  922698 */   GIM_Try, /*On fail goto*//*Label 14021*/ GIMT_Encode4(922786), // Rule ID 24223 //
     /*  922703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  922714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  922717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  922720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922750 */     // MIs[1] Operand 1
     /*  922750 */     // No operand predicates
     /*  922750 */     // MIs[0] policy
     /*  922750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922762 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922784 */     GIR_RootConstrainSelectedInstOperands,
     /*  922785 */     // GIR_Coverage, 24223,
     /*  922785 */     GIR_EraseRootFromParent_Done,
     /*  922786 */   // Label 14021: @922786
     /*  922786 */   GIM_Try, /*On fail goto*//*Label 14022*/ GIMT_Encode4(922874), // Rule ID 24226 //
     /*  922791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  922802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  922805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  922808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922838 */     // MIs[1] Operand 1
     /*  922838 */     // No operand predicates
     /*  922838 */     // MIs[0] policy
     /*  922838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922850 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922872 */     GIR_RootConstrainSelectedInstOperands,
     /*  922873 */     // GIR_Coverage, 24226,
     /*  922873 */     GIR_EraseRootFromParent_Done,
     /*  922874 */   // Label 14022: @922874
     /*  922874 */   GIM_Try, /*On fail goto*//*Label 14023*/ GIMT_Encode4(922962), // Rule ID 24227 //
     /*  922879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  922890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  922893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  922896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922926 */     // MIs[1] Operand 1
     /*  922926 */     // No operand predicates
     /*  922926 */     // MIs[0] policy
     /*  922926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922938 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922960 */     GIR_RootConstrainSelectedInstOperands,
     /*  922961 */     // GIR_Coverage, 24227,
     /*  922961 */     GIR_EraseRootFromParent_Done,
     /*  922962 */   // Label 14023: @922962
     /*  922962 */   GIM_Try, /*On fail goto*//*Label 14024*/ GIMT_Encode4(923050), // Rule ID 24230 //
     /*  922967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  922970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  922978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  922981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  922984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923014 */     // MIs[1] Operand 1
     /*  923014 */     // No operand predicates
     /*  923014 */     // MIs[0] policy
     /*  923014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923026 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  923029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923048 */     GIR_RootConstrainSelectedInstOperands,
     /*  923049 */     // GIR_Coverage, 24230,
     /*  923049 */     GIR_EraseRootFromParent_Done,
     /*  923050 */   // Label 14024: @923050
     /*  923050 */   GIM_Try, /*On fail goto*//*Label 14025*/ GIMT_Encode4(923138), // Rule ID 24231 //
     /*  923055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  923058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  923066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  923069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  923072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923102 */     // MIs[1] Operand 1
     /*  923102 */     // No operand predicates
     /*  923102 */     // MIs[0] policy
     /*  923102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923114 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  923117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923136 */     GIR_RootConstrainSelectedInstOperands,
     /*  923137 */     // GIR_Coverage, 24231,
     /*  923137 */     GIR_EraseRootFromParent_Done,
     /*  923138 */   // Label 14025: @923138
     /*  923138 */   GIM_Try, /*On fail goto*//*Label 14026*/ GIMT_Encode4(923226), // Rule ID 24234 //
     /*  923143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  923154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  923157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  923160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923190 */     // MIs[1] Operand 1
     /*  923190 */     // No operand predicates
     /*  923190 */     // MIs[0] policy
     /*  923190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923202 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923224 */     GIR_RootConstrainSelectedInstOperands,
     /*  923225 */     // GIR_Coverage, 24234,
     /*  923225 */     GIR_EraseRootFromParent_Done,
     /*  923226 */   // Label 14026: @923226
     /*  923226 */   GIM_Try, /*On fail goto*//*Label 14027*/ GIMT_Encode4(923314), // Rule ID 24235 //
     /*  923231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  923242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  923245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  923248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923278 */     // MIs[1] Operand 1
     /*  923278 */     // No operand predicates
     /*  923278 */     // MIs[0] policy
     /*  923278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923290 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923312 */     GIR_RootConstrainSelectedInstOperands,
     /*  923313 */     // GIR_Coverage, 24235,
     /*  923313 */     GIR_EraseRootFromParent_Done,
     /*  923314 */   // Label 14027: @923314
     /*  923314 */   GIM_Try, /*On fail goto*//*Label 14028*/ GIMT_Encode4(923402), // Rule ID 24238 //
     /*  923319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  923330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  923333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  923336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923366 */     // MIs[1] Operand 1
     /*  923366 */     // No operand predicates
     /*  923366 */     // MIs[0] policy
     /*  923366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923378 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923400 */     GIR_RootConstrainSelectedInstOperands,
     /*  923401 */     // GIR_Coverage, 24238,
     /*  923401 */     GIR_EraseRootFromParent_Done,
     /*  923402 */   // Label 14028: @923402
     /*  923402 */   GIM_Try, /*On fail goto*//*Label 14029*/ GIMT_Encode4(923490), // Rule ID 24239 //
     /*  923407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  923418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  923421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  923424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923454 */     // MIs[1] Operand 1
     /*  923454 */     // No operand predicates
     /*  923454 */     // MIs[0] policy
     /*  923454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923466 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923488 */     GIR_RootConstrainSelectedInstOperands,
     /*  923489 */     // GIR_Coverage, 24239,
     /*  923489 */     GIR_EraseRootFromParent_Done,
     /*  923490 */   // Label 14029: @923490
     /*  923490 */   GIM_Try, /*On fail goto*//*Label 14030*/ GIMT_Encode4(923578), // Rule ID 24242 //
     /*  923495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  923506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  923509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  923512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923542 */     // MIs[1] Operand 1
     /*  923542 */     // No operand predicates
     /*  923542 */     // MIs[0] policy
     /*  923542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923554 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923576 */     GIR_RootConstrainSelectedInstOperands,
     /*  923577 */     // GIR_Coverage, 24242,
     /*  923577 */     GIR_EraseRootFromParent_Done,
     /*  923578 */   // Label 14030: @923578
     /*  923578 */   GIM_Try, /*On fail goto*//*Label 14031*/ GIMT_Encode4(923666), // Rule ID 24243 //
     /*  923583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  923594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  923597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  923600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923630 */     // MIs[1] Operand 1
     /*  923630 */     // No operand predicates
     /*  923630 */     // MIs[0] policy
     /*  923630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923642 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923664 */     GIR_RootConstrainSelectedInstOperands,
     /*  923665 */     // GIR_Coverage, 24243,
     /*  923665 */     GIR_EraseRootFromParent_Done,
     /*  923666 */   // Label 14031: @923666
     /*  923666 */   GIM_Try, /*On fail goto*//*Label 14032*/ GIMT_Encode4(923754), // Rule ID 24246 //
     /*  923671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  923682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  923685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  923688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923718 */     // MIs[1] Operand 1
     /*  923718 */     // No operand predicates
     /*  923718 */     // MIs[0] policy
     /*  923718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923730 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923752 */     GIR_RootConstrainSelectedInstOperands,
     /*  923753 */     // GIR_Coverage, 24246,
     /*  923753 */     GIR_EraseRootFromParent_Done,
     /*  923754 */   // Label 14032: @923754
     /*  923754 */   GIM_Try, /*On fail goto*//*Label 14033*/ GIMT_Encode4(923842), // Rule ID 24247 //
     /*  923759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  923770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  923773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  923776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923806 */     // MIs[1] Operand 1
     /*  923806 */     // No operand predicates
     /*  923806 */     // MIs[0] policy
     /*  923806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923818 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923840 */     GIR_RootConstrainSelectedInstOperands,
     /*  923841 */     // GIR_Coverage, 24247,
     /*  923841 */     GIR_EraseRootFromParent_Done,
     /*  923842 */   // Label 14033: @923842
     /*  923842 */   GIM_Try, /*On fail goto*//*Label 14034*/ GIMT_Encode4(923930), // Rule ID 24250 //
     /*  923847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  923858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  923861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  923864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923894 */     // MIs[1] Operand 1
     /*  923894 */     // No operand predicates
     /*  923894 */     // MIs[0] policy
     /*  923894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923906 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923928 */     GIR_RootConstrainSelectedInstOperands,
     /*  923929 */     // GIR_Coverage, 24250,
     /*  923929 */     GIR_EraseRootFromParent_Done,
     /*  923930 */   // Label 14034: @923930
     /*  923930 */   GIM_Try, /*On fail goto*//*Label 14035*/ GIMT_Encode4(924018), // Rule ID 24251 //
     /*  923935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  923946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  923949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  923952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923982 */     // MIs[1] Operand 1
     /*  923982 */     // No operand predicates
     /*  923982 */     // MIs[0] policy
     /*  923982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923994 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924016 */     GIR_RootConstrainSelectedInstOperands,
     /*  924017 */     // GIR_Coverage, 24251,
     /*  924017 */     GIR_EraseRootFromParent_Done,
     /*  924018 */   // Label 14035: @924018
     /*  924018 */   GIM_Try, /*On fail goto*//*Label 14036*/ GIMT_Encode4(924106), // Rule ID 24254 //
     /*  924023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  924034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  924037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  924040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924070 */     // MIs[1] Operand 1
     /*  924070 */     // No operand predicates
     /*  924070 */     // MIs[0] policy
     /*  924070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924082 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  924085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924104 */     GIR_RootConstrainSelectedInstOperands,
     /*  924105 */     // GIR_Coverage, 24254,
     /*  924105 */     GIR_EraseRootFromParent_Done,
     /*  924106 */   // Label 14036: @924106
     /*  924106 */   GIM_Try, /*On fail goto*//*Label 14037*/ GIMT_Encode4(924194), // Rule ID 24255 //
     /*  924111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  924122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  924125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  924128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924158 */     // MIs[1] Operand 1
     /*  924158 */     // No operand predicates
     /*  924158 */     // MIs[0] policy
     /*  924158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924170 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  924173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924192 */     GIR_RootConstrainSelectedInstOperands,
     /*  924193 */     // GIR_Coverage, 24255,
     /*  924193 */     GIR_EraseRootFromParent_Done,
     /*  924194 */   // Label 14037: @924194
     /*  924194 */   GIM_Try, /*On fail goto*//*Label 14038*/ GIMT_Encode4(924282), // Rule ID 24258 //
     /*  924199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  924202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  924210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  924213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  924216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924246 */     // MIs[1] Operand 1
     /*  924246 */     // No operand predicates
     /*  924246 */     // MIs[0] policy
     /*  924246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924258 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  924261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924280 */     GIR_RootConstrainSelectedInstOperands,
     /*  924281 */     // GIR_Coverage, 24258,
     /*  924281 */     GIR_EraseRootFromParent_Done,
     /*  924282 */   // Label 14038: @924282
     /*  924282 */   GIM_Try, /*On fail goto*//*Label 14039*/ GIMT_Encode4(924370), // Rule ID 24259 //
     /*  924287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  924290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  924298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  924301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  924304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924334 */     // MIs[1] Operand 1
     /*  924334 */     // No operand predicates
     /*  924334 */     // MIs[0] policy
     /*  924334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924346 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  924349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924368 */     GIR_RootConstrainSelectedInstOperands,
     /*  924369 */     // GIR_Coverage, 24259,
     /*  924369 */     GIR_EraseRootFromParent_Done,
     /*  924370 */   // Label 14039: @924370
     /*  924370 */   GIM_Try, /*On fail goto*//*Label 14040*/ GIMT_Encode4(924458), // Rule ID 24262 //
     /*  924375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  924378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  924386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  924389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  924392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924422 */     // MIs[1] Operand 1
     /*  924422 */     // No operand predicates
     /*  924422 */     // MIs[0] policy
     /*  924422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924434 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  924437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924456 */     GIR_RootConstrainSelectedInstOperands,
     /*  924457 */     // GIR_Coverage, 24262,
     /*  924457 */     GIR_EraseRootFromParent_Done,
     /*  924458 */   // Label 14040: @924458
     /*  924458 */   GIM_Try, /*On fail goto*//*Label 14041*/ GIMT_Encode4(924546), // Rule ID 24263 //
     /*  924463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  924466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  924474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  924477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  924480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924510 */     // MIs[1] Operand 1
     /*  924510 */     // No operand predicates
     /*  924510 */     // MIs[0] policy
     /*  924510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924522 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  924525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924544 */     GIR_RootConstrainSelectedInstOperands,
     /*  924545 */     // GIR_Coverage, 24263,
     /*  924545 */     GIR_EraseRootFromParent_Done,
     /*  924546 */   // Label 14041: @924546
     /*  924546 */   GIM_Try, /*On fail goto*//*Label 14042*/ GIMT_Encode4(924634), // Rule ID 24266 //
     /*  924551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  924554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  924562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  924565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  924568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924598 */     // MIs[1] Operand 1
     /*  924598 */     // No operand predicates
     /*  924598 */     // MIs[0] policy
     /*  924598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924610 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  924613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924632 */     GIR_RootConstrainSelectedInstOperands,
     /*  924633 */     // GIR_Coverage, 24266,
     /*  924633 */     GIR_EraseRootFromParent_Done,
     /*  924634 */   // Label 14042: @924634
     /*  924634 */   GIM_Try, /*On fail goto*//*Label 14043*/ GIMT_Encode4(924722), // Rule ID 24267 //
     /*  924639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  924642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  924650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  924653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  924656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924686 */     // MIs[1] Operand 1
     /*  924686 */     // No operand predicates
     /*  924686 */     // MIs[0] policy
     /*  924686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924698 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  924701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924720 */     GIR_RootConstrainSelectedInstOperands,
     /*  924721 */     // GIR_Coverage, 24267,
     /*  924721 */     GIR_EraseRootFromParent_Done,
     /*  924722 */   // Label 14043: @924722
     /*  924722 */   GIM_Try, /*On fail goto*//*Label 14044*/ GIMT_Encode4(924810), // Rule ID 24330 //
     /*  924727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  924738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  924741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  924744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924774 */     // MIs[1] Operand 1
     /*  924774 */     // No operand predicates
     /*  924774 */     // MIs[0] policy
     /*  924774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924786 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  924789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924808 */     GIR_RootConstrainSelectedInstOperands,
     /*  924809 */     // GIR_Coverage, 24330,
     /*  924809 */     GIR_EraseRootFromParent_Done,
     /*  924810 */   // Label 14044: @924810
     /*  924810 */   GIM_Try, /*On fail goto*//*Label 14045*/ GIMT_Encode4(924898), // Rule ID 24331 //
     /*  924815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  924826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  924829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  924832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924862 */     // MIs[1] Operand 1
     /*  924862 */     // No operand predicates
     /*  924862 */     // MIs[0] policy
     /*  924862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924874 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  924877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924896 */     GIR_RootConstrainSelectedInstOperands,
     /*  924897 */     // GIR_Coverage, 24331,
     /*  924897 */     GIR_EraseRootFromParent_Done,
     /*  924898 */   // Label 14045: @924898
     /*  924898 */   GIM_Try, /*On fail goto*//*Label 14046*/ GIMT_Encode4(924986), // Rule ID 24334 //
     /*  924903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  924914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  924917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  924920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924950 */     // MIs[1] Operand 1
     /*  924950 */     // No operand predicates
     /*  924950 */     // MIs[0] policy
     /*  924950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924962 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924984 */     GIR_RootConstrainSelectedInstOperands,
     /*  924985 */     // GIR_Coverage, 24334,
     /*  924985 */     GIR_EraseRootFromParent_Done,
     /*  924986 */   // Label 14046: @924986
     /*  924986 */   GIM_Try, /*On fail goto*//*Label 14047*/ GIMT_Encode4(925074), // Rule ID 24335 //
     /*  924991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  925002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  925005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  925008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925038 */     // MIs[1] Operand 1
     /*  925038 */     // No operand predicates
     /*  925038 */     // MIs[0] policy
     /*  925038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925050 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  925053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925072 */     GIR_RootConstrainSelectedInstOperands,
     /*  925073 */     // GIR_Coverage, 24335,
     /*  925073 */     GIR_EraseRootFromParent_Done,
     /*  925074 */   // Label 14047: @925074
     /*  925074 */   GIM_Try, /*On fail goto*//*Label 14048*/ GIMT_Encode4(925162), // Rule ID 24338 //
     /*  925079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  925090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  925093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  925096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925126 */     // MIs[1] Operand 1
     /*  925126 */     // No operand predicates
     /*  925126 */     // MIs[0] policy
     /*  925126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925138 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  925141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925160 */     GIR_RootConstrainSelectedInstOperands,
     /*  925161 */     // GIR_Coverage, 24338,
     /*  925161 */     GIR_EraseRootFromParent_Done,
     /*  925162 */   // Label 14048: @925162
     /*  925162 */   GIM_Try, /*On fail goto*//*Label 14049*/ GIMT_Encode4(925250), // Rule ID 24339 //
     /*  925167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  925178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  925181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  925184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925214 */     // MIs[1] Operand 1
     /*  925214 */     // No operand predicates
     /*  925214 */     // MIs[0] policy
     /*  925214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925226 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  925229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925248 */     GIR_RootConstrainSelectedInstOperands,
     /*  925249 */     // GIR_Coverage, 24339,
     /*  925249 */     GIR_EraseRootFromParent_Done,
     /*  925250 */   // Label 14049: @925250
     /*  925250 */   GIM_Try, /*On fail goto*//*Label 14050*/ GIMT_Encode4(925338), // Rule ID 24342 //
     /*  925255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  925266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  925269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  925272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925302 */     // MIs[1] Operand 1
     /*  925302 */     // No operand predicates
     /*  925302 */     // MIs[0] policy
     /*  925302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925314 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925336 */     GIR_RootConstrainSelectedInstOperands,
     /*  925337 */     // GIR_Coverage, 24342,
     /*  925337 */     GIR_EraseRootFromParent_Done,
     /*  925338 */   // Label 14050: @925338
     /*  925338 */   GIM_Try, /*On fail goto*//*Label 14051*/ GIMT_Encode4(925426), // Rule ID 24343 //
     /*  925343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  925354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  925357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  925360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925390 */     // MIs[1] Operand 1
     /*  925390 */     // No operand predicates
     /*  925390 */     // MIs[0] policy
     /*  925390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925402 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925424 */     GIR_RootConstrainSelectedInstOperands,
     /*  925425 */     // GIR_Coverage, 24343,
     /*  925425 */     GIR_EraseRootFromParent_Done,
     /*  925426 */   // Label 14051: @925426
     /*  925426 */   GIM_Try, /*On fail goto*//*Label 14052*/ GIMT_Encode4(925514), // Rule ID 24346 //
     /*  925431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  925442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  925445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  925448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925478 */     // MIs[1] Operand 1
     /*  925478 */     // No operand predicates
     /*  925478 */     // MIs[0] policy
     /*  925478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925490 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925512 */     GIR_RootConstrainSelectedInstOperands,
     /*  925513 */     // GIR_Coverage, 24346,
     /*  925513 */     GIR_EraseRootFromParent_Done,
     /*  925514 */   // Label 14052: @925514
     /*  925514 */   GIM_Try, /*On fail goto*//*Label 14053*/ GIMT_Encode4(925602), // Rule ID 24347 //
     /*  925519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  925530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  925533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  925536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925566 */     // MIs[1] Operand 1
     /*  925566 */     // No operand predicates
     /*  925566 */     // MIs[0] policy
     /*  925566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925578 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925600 */     GIR_RootConstrainSelectedInstOperands,
     /*  925601 */     // GIR_Coverage, 24347,
     /*  925601 */     GIR_EraseRootFromParent_Done,
     /*  925602 */   // Label 14053: @925602
     /*  925602 */   GIM_Try, /*On fail goto*//*Label 14054*/ GIMT_Encode4(925690), // Rule ID 24350 //
     /*  925607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  925610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  925618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  925621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  925624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925654 */     // MIs[1] Operand 1
     /*  925654 */     // No operand predicates
     /*  925654 */     // MIs[0] policy
     /*  925654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925666 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925688 */     GIR_RootConstrainSelectedInstOperands,
     /*  925689 */     // GIR_Coverage, 24350,
     /*  925689 */     GIR_EraseRootFromParent_Done,
     /*  925690 */   // Label 14054: @925690
     /*  925690 */   GIM_Try, /*On fail goto*//*Label 14055*/ GIMT_Encode4(925778), // Rule ID 24351 //
     /*  925695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  925698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  925706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  925709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  925712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925742 */     // MIs[1] Operand 1
     /*  925742 */     // No operand predicates
     /*  925742 */     // MIs[0] policy
     /*  925742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925754 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925776 */     GIR_RootConstrainSelectedInstOperands,
     /*  925777 */     // GIR_Coverage, 24351,
     /*  925777 */     GIR_EraseRootFromParent_Done,
     /*  925778 */   // Label 14055: @925778
     /*  925778 */   GIM_Try, /*On fail goto*//*Label 14056*/ GIMT_Encode4(925866), // Rule ID 24354 //
     /*  925783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  925794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  925797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  925800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925830 */     // MIs[1] Operand 1
     /*  925830 */     // No operand predicates
     /*  925830 */     // MIs[0] policy
     /*  925830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925842 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925864 */     GIR_RootConstrainSelectedInstOperands,
     /*  925865 */     // GIR_Coverage, 24354,
     /*  925865 */     GIR_EraseRootFromParent_Done,
     /*  925866 */   // Label 14056: @925866
     /*  925866 */   GIM_Try, /*On fail goto*//*Label 14057*/ GIMT_Encode4(925954), // Rule ID 24355 //
     /*  925871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  925882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  925885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  925888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925918 */     // MIs[1] Operand 1
     /*  925918 */     // No operand predicates
     /*  925918 */     // MIs[0] policy
     /*  925918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925930 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925952 */     GIR_RootConstrainSelectedInstOperands,
     /*  925953 */     // GIR_Coverage, 24355,
     /*  925953 */     GIR_EraseRootFromParent_Done,
     /*  925954 */   // Label 14057: @925954
     /*  925954 */   GIM_Try, /*On fail goto*//*Label 14058*/ GIMT_Encode4(926042), // Rule ID 24358 //
     /*  925959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  925970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  925973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  925976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926006 */     // MIs[1] Operand 1
     /*  926006 */     // No operand predicates
     /*  926006 */     // MIs[0] policy
     /*  926006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926018 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926040 */     GIR_RootConstrainSelectedInstOperands,
     /*  926041 */     // GIR_Coverage, 24358,
     /*  926041 */     GIR_EraseRootFromParent_Done,
     /*  926042 */   // Label 14058: @926042
     /*  926042 */   GIM_Try, /*On fail goto*//*Label 14059*/ GIMT_Encode4(926130), // Rule ID 24359 //
     /*  926047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  926058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  926061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  926064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926094 */     // MIs[1] Operand 1
     /*  926094 */     // No operand predicates
     /*  926094 */     // MIs[0] policy
     /*  926094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926106 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926128 */     GIR_RootConstrainSelectedInstOperands,
     /*  926129 */     // GIR_Coverage, 24359,
     /*  926129 */     GIR_EraseRootFromParent_Done,
     /*  926130 */   // Label 14059: @926130
     /*  926130 */   GIM_Try, /*On fail goto*//*Label 14060*/ GIMT_Encode4(926218), // Rule ID 24362 //
     /*  926135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  926146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  926149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  926152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926182 */     // MIs[1] Operand 1
     /*  926182 */     // No operand predicates
     /*  926182 */     // MIs[0] policy
     /*  926182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926194 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926216 */     GIR_RootConstrainSelectedInstOperands,
     /*  926217 */     // GIR_Coverage, 24362,
     /*  926217 */     GIR_EraseRootFromParent_Done,
     /*  926218 */   // Label 14060: @926218
     /*  926218 */   GIM_Try, /*On fail goto*//*Label 14061*/ GIMT_Encode4(926306), // Rule ID 24363 //
     /*  926223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  926234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  926237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  926240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926270 */     // MIs[1] Operand 1
     /*  926270 */     // No operand predicates
     /*  926270 */     // MIs[0] policy
     /*  926270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926282 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926304 */     GIR_RootConstrainSelectedInstOperands,
     /*  926305 */     // GIR_Coverage, 24363,
     /*  926305 */     GIR_EraseRootFromParent_Done,
     /*  926306 */   // Label 14061: @926306
     /*  926306 */   GIM_Try, /*On fail goto*//*Label 14062*/ GIMT_Encode4(926394), // Rule ID 24366 //
     /*  926311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  926322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  926325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  926328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926358 */     // MIs[1] Operand 1
     /*  926358 */     // No operand predicates
     /*  926358 */     // MIs[0] policy
     /*  926358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926370 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926392 */     GIR_RootConstrainSelectedInstOperands,
     /*  926393 */     // GIR_Coverage, 24366,
     /*  926393 */     GIR_EraseRootFromParent_Done,
     /*  926394 */   // Label 14062: @926394
     /*  926394 */   GIM_Try, /*On fail goto*//*Label 14063*/ GIMT_Encode4(926482), // Rule ID 24367 //
     /*  926399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  926410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  926413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  926416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926446 */     // MIs[1] Operand 1
     /*  926446 */     // No operand predicates
     /*  926446 */     // MIs[0] policy
     /*  926446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926458 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926480 */     GIR_RootConstrainSelectedInstOperands,
     /*  926481 */     // GIR_Coverage, 24367,
     /*  926481 */     GIR_EraseRootFromParent_Done,
     /*  926482 */   // Label 14063: @926482
     /*  926482 */   GIM_Try, /*On fail goto*//*Label 14064*/ GIMT_Encode4(926570), // Rule ID 24370 //
     /*  926487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  926498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  926501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  926504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926534 */     // MIs[1] Operand 1
     /*  926534 */     // No operand predicates
     /*  926534 */     // MIs[0] policy
     /*  926534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926546 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926568 */     GIR_RootConstrainSelectedInstOperands,
     /*  926569 */     // GIR_Coverage, 24370,
     /*  926569 */     GIR_EraseRootFromParent_Done,
     /*  926570 */   // Label 14064: @926570
     /*  926570 */   GIM_Try, /*On fail goto*//*Label 14065*/ GIMT_Encode4(926658), // Rule ID 24371 //
     /*  926575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  926586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  926589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  926592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926622 */     // MIs[1] Operand 1
     /*  926622 */     // No operand predicates
     /*  926622 */     // MIs[0] policy
     /*  926622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926634 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926656 */     GIR_RootConstrainSelectedInstOperands,
     /*  926657 */     // GIR_Coverage, 24371,
     /*  926657 */     GIR_EraseRootFromParent_Done,
     /*  926658 */   // Label 14065: @926658
     /*  926658 */   GIM_Try, /*On fail goto*//*Label 14066*/ GIMT_Encode4(926746), // Rule ID 24374 //
     /*  926663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  926674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  926677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  926680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926710 */     // MIs[1] Operand 1
     /*  926710 */     // No operand predicates
     /*  926710 */     // MIs[0] policy
     /*  926710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926722 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926744 */     GIR_RootConstrainSelectedInstOperands,
     /*  926745 */     // GIR_Coverage, 24374,
     /*  926745 */     GIR_EraseRootFromParent_Done,
     /*  926746 */   // Label 14066: @926746
     /*  926746 */   GIM_Try, /*On fail goto*//*Label 14067*/ GIMT_Encode4(926834), // Rule ID 24375 //
     /*  926751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  926762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  926765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  926768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926798 */     // MIs[1] Operand 1
     /*  926798 */     // No operand predicates
     /*  926798 */     // MIs[0] policy
     /*  926798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926810 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926832 */     GIR_RootConstrainSelectedInstOperands,
     /*  926833 */     // GIR_Coverage, 24375,
     /*  926833 */     GIR_EraseRootFromParent_Done,
     /*  926834 */   // Label 14067: @926834
     /*  926834 */   GIM_Try, /*On fail goto*//*Label 14068*/ GIMT_Encode4(926922), // Rule ID 24378 //
     /*  926839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  926842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  926850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  926853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  926856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926886 */     // MIs[1] Operand 1
     /*  926886 */     // No operand predicates
     /*  926886 */     // MIs[0] policy
     /*  926886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926898 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926920 */     GIR_RootConstrainSelectedInstOperands,
     /*  926921 */     // GIR_Coverage, 24378,
     /*  926921 */     GIR_EraseRootFromParent_Done,
     /*  926922 */   // Label 14068: @926922
     /*  926922 */   GIM_Try, /*On fail goto*//*Label 14069*/ GIMT_Encode4(927010), // Rule ID 24379 //
     /*  926927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  926930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  926938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  926941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  926944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926974 */     // MIs[1] Operand 1
     /*  926974 */     // No operand predicates
     /*  926974 */     // MIs[0] policy
     /*  926974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926986 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927008 */     GIR_RootConstrainSelectedInstOperands,
     /*  927009 */     // GIR_Coverage, 24379,
     /*  927009 */     GIR_EraseRootFromParent_Done,
     /*  927010 */   // Label 14069: @927010
     /*  927010 */   GIM_Try, /*On fail goto*//*Label 14070*/ GIMT_Encode4(927098), // Rule ID 24382 //
     /*  927015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  927018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  927023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  927026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  927029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  927032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927062 */     // MIs[1] Operand 1
     /*  927062 */     // No operand predicates
     /*  927062 */     // MIs[0] policy
     /*  927062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927074 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  927077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927096 */     GIR_RootConstrainSelectedInstOperands,
     /*  927097 */     // GIR_Coverage, 24382,
     /*  927097 */     GIR_EraseRootFromParent_Done,
     /*  927098 */   // Label 14070: @927098
     /*  927098 */   GIM_Try, /*On fail goto*//*Label 14071*/ GIMT_Encode4(927186), // Rule ID 24383 //
     /*  927103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  927106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  927111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  927114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  927117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  927120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927150 */     // MIs[1] Operand 1
     /*  927150 */     // No operand predicates
     /*  927150 */     // MIs[0] policy
     /*  927150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927162 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  927165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927184 */     GIR_RootConstrainSelectedInstOperands,
     /*  927185 */     // GIR_Coverage, 24383,
     /*  927185 */     GIR_EraseRootFromParent_Done,
     /*  927186 */   // Label 14071: @927186
     /*  927186 */   GIM_Try, /*On fail goto*//*Label 14072*/ GIMT_Encode4(927274), // Rule ID 24386 //
     /*  927191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  927194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  927199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  927202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  927205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  927208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927238 */     // MIs[1] Operand 1
     /*  927238 */     // No operand predicates
     /*  927238 */     // MIs[0] policy
     /*  927238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927250 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  927253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927272 */     GIR_RootConstrainSelectedInstOperands,
     /*  927273 */     // GIR_Coverage, 24386,
     /*  927273 */     GIR_EraseRootFromParent_Done,
     /*  927274 */   // Label 14072: @927274
     /*  927274 */   GIM_Try, /*On fail goto*//*Label 14073*/ GIMT_Encode4(927362), // Rule ID 24387 //
     /*  927279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  927282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  927287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  927290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  927293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  927296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927326 */     // MIs[1] Operand 1
     /*  927326 */     // No operand predicates
     /*  927326 */     // MIs[0] policy
     /*  927326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927338 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  927341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927360 */     GIR_RootConstrainSelectedInstOperands,
     /*  927361 */     // GIR_Coverage, 24387,
     /*  927361 */     GIR_EraseRootFromParent_Done,
     /*  927362 */   // Label 14073: @927362
     /*  927362 */   GIM_Try, /*On fail goto*//*Label 14074*/ GIMT_Encode4(927453), // Rule ID 15998 //
     /*  927367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  927378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  927381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  927384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927414 */     // MIs[1] Operand 1
     /*  927414 */     // No operand predicates
     /*  927414 */     // MIs[0] round
     /*  927414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927426 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  927426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  927429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927438 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927451 */     GIR_RootConstrainSelectedInstOperands,
     /*  927452 */     // GIR_Coverage, 15998,
     /*  927452 */     GIR_EraseRootFromParent_Done,
     /*  927453 */   // Label 14074: @927453
     /*  927453 */   GIM_Try, /*On fail goto*//*Label 14075*/ GIMT_Encode4(927544), // Rule ID 15999 //
     /*  927458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  927469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  927472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  927475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927505 */     // MIs[1] Operand 1
     /*  927505 */     // No operand predicates
     /*  927505 */     // MIs[0] round
     /*  927505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927517 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  927520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927542 */     GIR_RootConstrainSelectedInstOperands,
     /*  927543 */     // GIR_Coverage, 15999,
     /*  927543 */     GIR_EraseRootFromParent_Done,
     /*  927544 */   // Label 14075: @927544
     /*  927544 */   GIM_Try, /*On fail goto*//*Label 14076*/ GIMT_Encode4(927635), // Rule ID 16002 //
     /*  927549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  927560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  927563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  927566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927596 */     // MIs[1] Operand 1
     /*  927596 */     // No operand predicates
     /*  927596 */     // MIs[0] round
     /*  927596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927608 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  927608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927620 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927633 */     GIR_RootConstrainSelectedInstOperands,
     /*  927634 */     // GIR_Coverage, 16002,
     /*  927634 */     GIR_EraseRootFromParent_Done,
     /*  927635 */   // Label 14076: @927635
     /*  927635 */   GIM_Try, /*On fail goto*//*Label 14077*/ GIMT_Encode4(927726), // Rule ID 16003 //
     /*  927640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  927651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  927654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  927657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927687 */     // MIs[1] Operand 1
     /*  927687 */     // No operand predicates
     /*  927687 */     // MIs[0] round
     /*  927687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927699 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927724 */     GIR_RootConstrainSelectedInstOperands,
     /*  927725 */     // GIR_Coverage, 16003,
     /*  927725 */     GIR_EraseRootFromParent_Done,
     /*  927726 */   // Label 14077: @927726
     /*  927726 */   GIM_Try, /*On fail goto*//*Label 14078*/ GIMT_Encode4(927817), // Rule ID 16006 //
     /*  927731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  927742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  927745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  927748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927778 */     // MIs[1] Operand 1
     /*  927778 */     // No operand predicates
     /*  927778 */     // MIs[0] round
     /*  927778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927790 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  927790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927802 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927815 */     GIR_RootConstrainSelectedInstOperands,
     /*  927816 */     // GIR_Coverage, 16006,
     /*  927816 */     GIR_EraseRootFromParent_Done,
     /*  927817 */   // Label 14078: @927817
     /*  927817 */   GIM_Try, /*On fail goto*//*Label 14079*/ GIMT_Encode4(927908), // Rule ID 16007 //
     /*  927822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  927833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  927836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  927839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927869 */     // MIs[1] Operand 1
     /*  927869 */     // No operand predicates
     /*  927869 */     // MIs[0] round
     /*  927869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927881 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927906 */     GIR_RootConstrainSelectedInstOperands,
     /*  927907 */     // GIR_Coverage, 16007,
     /*  927907 */     GIR_EraseRootFromParent_Done,
     /*  927908 */   // Label 14079: @927908
     /*  927908 */   GIM_Try, /*On fail goto*//*Label 14080*/ GIMT_Encode4(927999), // Rule ID 16010 //
     /*  927913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  927924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  927927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  927930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927960 */     // MIs[1] Operand 1
     /*  927960 */     // No operand predicates
     /*  927960 */     // MIs[0] round
     /*  927960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927972 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  927972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927984 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927997 */     GIR_RootConstrainSelectedInstOperands,
     /*  927998 */     // GIR_Coverage, 16010,
     /*  927998 */     GIR_EraseRootFromParent_Done,
     /*  927999 */   // Label 14080: @927999
     /*  927999 */   GIM_Try, /*On fail goto*//*Label 14081*/ GIMT_Encode4(928090), // Rule ID 16011 //
     /*  928004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  928015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  928018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  928021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928051 */     // MIs[1] Operand 1
     /*  928051 */     // No operand predicates
     /*  928051 */     // MIs[0] round
     /*  928051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928063 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  928063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  928066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928088 */     GIR_RootConstrainSelectedInstOperands,
     /*  928089 */     // GIR_Coverage, 16011,
     /*  928089 */     GIR_EraseRootFromParent_Done,
     /*  928090 */   // Label 14081: @928090
     /*  928090 */   GIM_Try, /*On fail goto*//*Label 14082*/ GIMT_Encode4(928181), // Rule ID 16014 //
     /*  928095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  928106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  928109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  928112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928142 */     // MIs[1] Operand 1
     /*  928142 */     // No operand predicates
     /*  928142 */     // MIs[0] round
     /*  928142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928154 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  928154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  928157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928179 */     GIR_RootConstrainSelectedInstOperands,
     /*  928180 */     // GIR_Coverage, 16014,
     /*  928180 */     GIR_EraseRootFromParent_Done,
     /*  928181 */   // Label 14082: @928181
     /*  928181 */   GIM_Try, /*On fail goto*//*Label 14083*/ GIMT_Encode4(928272), // Rule ID 16015 //
     /*  928186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  928197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  928200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  928203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928233 */     // MIs[1] Operand 1
     /*  928233 */     // No operand predicates
     /*  928233 */     // MIs[0] round
     /*  928233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928245 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  928245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  928248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928270 */     GIR_RootConstrainSelectedInstOperands,
     /*  928271 */     // GIR_Coverage, 16015,
     /*  928271 */     GIR_EraseRootFromParent_Done,
     /*  928272 */   // Label 14083: @928272
     /*  928272 */   GIM_Try, /*On fail goto*//*Label 14084*/ GIMT_Encode4(928363), // Rule ID 16018 //
     /*  928277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  928288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  928291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  928294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928324 */     // MIs[1] Operand 1
     /*  928324 */     // No operand predicates
     /*  928324 */     // MIs[0] round
     /*  928324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928336 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  928336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  928339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928348 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928361 */     GIR_RootConstrainSelectedInstOperands,
     /*  928362 */     // GIR_Coverage, 16018,
     /*  928362 */     GIR_EraseRootFromParent_Done,
     /*  928363 */   // Label 14084: @928363
     /*  928363 */   GIM_Try, /*On fail goto*//*Label 14085*/ GIMT_Encode4(928454), // Rule ID 16019 //
     /*  928368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  928379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  928382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  928385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928415 */     // MIs[1] Operand 1
     /*  928415 */     // No operand predicates
     /*  928415 */     // MIs[0] round
     /*  928415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928427 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  928427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  928430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928452 */     GIR_RootConstrainSelectedInstOperands,
     /*  928453 */     // GIR_Coverage, 16019,
     /*  928453 */     GIR_EraseRootFromParent_Done,
     /*  928454 */   // Label 14085: @928454
     /*  928454 */   GIM_Try, /*On fail goto*//*Label 14086*/ GIMT_Encode4(928545), // Rule ID 16022 //
     /*  928459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  928470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  928473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  928476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928502 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928506 */     // MIs[1] Operand 1
     /*  928506 */     // No operand predicates
     /*  928506 */     // MIs[0] round
     /*  928506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928518 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  928518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928530 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928543 */     GIR_RootConstrainSelectedInstOperands,
     /*  928544 */     // GIR_Coverage, 16022,
     /*  928544 */     GIR_EraseRootFromParent_Done,
     /*  928545 */   // Label 14086: @928545
     /*  928545 */   GIM_Try, /*On fail goto*//*Label 14087*/ GIMT_Encode4(928636), // Rule ID 16023 //
     /*  928550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  928561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  928564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  928567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928597 */     // MIs[1] Operand 1
     /*  928597 */     // No operand predicates
     /*  928597 */     // MIs[0] round
     /*  928597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928609 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  928609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928634 */     GIR_RootConstrainSelectedInstOperands,
     /*  928635 */     // GIR_Coverage, 16023,
     /*  928635 */     GIR_EraseRootFromParent_Done,
     /*  928636 */   // Label 14087: @928636
     /*  928636 */   GIM_Try, /*On fail goto*//*Label 14088*/ GIMT_Encode4(928727), // Rule ID 16026 //
     /*  928641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  928658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928688 */     // MIs[1] Operand 1
     /*  928688 */     // No operand predicates
     /*  928688 */     // MIs[0] round
     /*  928688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  928700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928712 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928725 */     GIR_RootConstrainSelectedInstOperands,
     /*  928726 */     // GIR_Coverage, 16026,
     /*  928726 */     GIR_EraseRootFromParent_Done,
     /*  928727 */   // Label 14088: @928727
     /*  928727 */   GIM_Try, /*On fail goto*//*Label 14089*/ GIMT_Encode4(928818), // Rule ID 16027 //
     /*  928732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  928749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928779 */     // MIs[1] Operand 1
     /*  928779 */     // No operand predicates
     /*  928779 */     // MIs[0] round
     /*  928779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928791 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  928791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928816 */     GIR_RootConstrainSelectedInstOperands,
     /*  928817 */     // GIR_Coverage, 16027,
     /*  928817 */     GIR_EraseRootFromParent_Done,
     /*  928818 */   // Label 14089: @928818
     /*  928818 */   GIM_Try, /*On fail goto*//*Label 14090*/ GIMT_Encode4(928909), // Rule ID 16030 //
     /*  928823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  928840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928870 */     // MIs[1] Operand 1
     /*  928870 */     // No operand predicates
     /*  928870 */     // MIs[0] round
     /*  928870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928882 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  928882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928894 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928907 */     GIR_RootConstrainSelectedInstOperands,
     /*  928908 */     // GIR_Coverage, 16030,
     /*  928908 */     GIR_EraseRootFromParent_Done,
     /*  928909 */   // Label 14090: @928909
     /*  928909 */   GIM_Try, /*On fail goto*//*Label 14091*/ GIMT_Encode4(929000), // Rule ID 16031 //
     /*  928914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  928931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928961 */     // MIs[1] Operand 1
     /*  928961 */     // No operand predicates
     /*  928961 */     // MIs[0] round
     /*  928961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928973 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  928973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928998 */     GIR_RootConstrainSelectedInstOperands,
     /*  928999 */     // GIR_Coverage, 16031,
     /*  928999 */     GIR_EraseRootFromParent_Done,
     /*  929000 */   // Label 14091: @929000
     /*  929000 */   GIM_Try, /*On fail goto*//*Label 14092*/ GIMT_Encode4(929091), // Rule ID 16034 //
     /*  929005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  929008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  929016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  929019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  929022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929052 */     // MIs[1] Operand 1
     /*  929052 */     // No operand predicates
     /*  929052 */     // MIs[0] round
     /*  929052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929064 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  929064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  929067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929076 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  929086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929089 */     GIR_RootConstrainSelectedInstOperands,
     /*  929090 */     // GIR_Coverage, 16034,
     /*  929090 */     GIR_EraseRootFromParent_Done,
     /*  929091 */   // Label 14092: @929091
     /*  929091 */   GIM_Try, /*On fail goto*//*Label 14093*/ GIMT_Encode4(929182), // Rule ID 16035 //
     /*  929096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  929099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  929107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  929110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  929113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929143 */     // MIs[1] Operand 1
     /*  929143 */     // No operand predicates
     /*  929143 */     // MIs[0] round
     /*  929143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929155 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  929155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  929158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  929177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929180 */     GIR_RootConstrainSelectedInstOperands,
     /*  929181 */     // GIR_Coverage, 16035,
     /*  929181 */     GIR_EraseRootFromParent_Done,
     /*  929182 */   // Label 14093: @929182
     /*  929182 */   GIM_Try, /*On fail goto*//*Label 14094*/ GIMT_Encode4(929273), // Rule ID 16038 //
     /*  929187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  929198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  929201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  929204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929234 */     // MIs[1] Operand 1
     /*  929234 */     // No operand predicates
     /*  929234 */     // MIs[0] round
     /*  929234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929246 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  929246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929258 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929271 */     GIR_RootConstrainSelectedInstOperands,
     /*  929272 */     // GIR_Coverage, 16038,
     /*  929272 */     GIR_EraseRootFromParent_Done,
     /*  929273 */   // Label 14094: @929273
     /*  929273 */   GIM_Try, /*On fail goto*//*Label 14095*/ GIMT_Encode4(929364), // Rule ID 16039 //
     /*  929278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  929289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  929292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  929295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929325 */     // MIs[1] Operand 1
     /*  929325 */     // No operand predicates
     /*  929325 */     // MIs[0] round
     /*  929325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929337 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  929337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929362 */     GIR_RootConstrainSelectedInstOperands,
     /*  929363 */     // GIR_Coverage, 16039,
     /*  929363 */     GIR_EraseRootFromParent_Done,
     /*  929364 */   // Label 14095: @929364
     /*  929364 */   GIM_Try, /*On fail goto*//*Label 14096*/ GIMT_Encode4(929455), // Rule ID 16042 //
     /*  929369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  929380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  929383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  929386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929416 */     // MIs[1] Operand 1
     /*  929416 */     // No operand predicates
     /*  929416 */     // MIs[0] round
     /*  929416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929428 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  929428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929440 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929453 */     GIR_RootConstrainSelectedInstOperands,
     /*  929454 */     // GIR_Coverage, 16042,
     /*  929454 */     GIR_EraseRootFromParent_Done,
     /*  929455 */   // Label 14096: @929455
     /*  929455 */   GIM_Try, /*On fail goto*//*Label 14097*/ GIMT_Encode4(929546), // Rule ID 16043 //
     /*  929460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  929471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  929474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  929477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929507 */     // MIs[1] Operand 1
     /*  929507 */     // No operand predicates
     /*  929507 */     // MIs[0] round
     /*  929507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929519 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  929519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929544 */     GIR_RootConstrainSelectedInstOperands,
     /*  929545 */     // GIR_Coverage, 16043,
     /*  929545 */     GIR_EraseRootFromParent_Done,
     /*  929546 */   // Label 14097: @929546
     /*  929546 */   GIM_Try, /*On fail goto*//*Label 14098*/ GIMT_Encode4(929637), // Rule ID 16046 //
     /*  929551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  929562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  929565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  929568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929598 */     // MIs[1] Operand 1
     /*  929598 */     // No operand predicates
     /*  929598 */     // MIs[0] round
     /*  929598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929610 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  929610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929622 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929635 */     GIR_RootConstrainSelectedInstOperands,
     /*  929636 */     // GIR_Coverage, 16046,
     /*  929636 */     GIR_EraseRootFromParent_Done,
     /*  929637 */   // Label 14098: @929637
     /*  929637 */   GIM_Try, /*On fail goto*//*Label 14099*/ GIMT_Encode4(929728), // Rule ID 16047 //
     /*  929642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  929653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  929656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  929659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929689 */     // MIs[1] Operand 1
     /*  929689 */     // No operand predicates
     /*  929689 */     // MIs[0] round
     /*  929689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929701 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  929701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929726 */     GIR_RootConstrainSelectedInstOperands,
     /*  929727 */     // GIR_Coverage, 16047,
     /*  929727 */     GIR_EraseRootFromParent_Done,
     /*  929728 */   // Label 14099: @929728
     /*  929728 */   GIM_Try, /*On fail goto*//*Label 14100*/ GIMT_Encode4(929819), // Rule ID 16050 //
     /*  929733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  929750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929780 */     // MIs[1] Operand 1
     /*  929780 */     // No operand predicates
     /*  929780 */     // MIs[0] round
     /*  929780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929792 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  929792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929804 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929817 */     GIR_RootConstrainSelectedInstOperands,
     /*  929818 */     // GIR_Coverage, 16050,
     /*  929818 */     GIR_EraseRootFromParent_Done,
     /*  929819 */   // Label 14100: @929819
     /*  929819 */   GIM_Try, /*On fail goto*//*Label 14101*/ GIMT_Encode4(929910), // Rule ID 16051 //
     /*  929824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  929841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929871 */     // MIs[1] Operand 1
     /*  929871 */     // No operand predicates
     /*  929871 */     // MIs[0] round
     /*  929871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929883 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  929883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929908 */     GIR_RootConstrainSelectedInstOperands,
     /*  929909 */     // GIR_Coverage, 16051,
     /*  929909 */     GIR_EraseRootFromParent_Done,
     /*  929910 */   // Label 14101: @929910
     /*  929910 */   GIM_Try, /*On fail goto*//*Label 14102*/ GIMT_Encode4(930001), // Rule ID 16054 //
     /*  929915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  929932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929962 */     // MIs[1] Operand 1
     /*  929962 */     // No operand predicates
     /*  929962 */     // MIs[0] round
     /*  929962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929974 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  929974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929986 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929999 */     GIR_RootConstrainSelectedInstOperands,
     /*  930000 */     // GIR_Coverage, 16054,
     /*  930000 */     GIR_EraseRootFromParent_Done,
     /*  930001 */   // Label 14102: @930001
     /*  930001 */   GIM_Try, /*On fail goto*//*Label 14103*/ GIMT_Encode4(930092), // Rule ID 16055 //
     /*  930006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  930017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  930020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  930023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930053 */     // MIs[1] Operand 1
     /*  930053 */     // No operand predicates
     /*  930053 */     // MIs[0] round
     /*  930053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930065 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  930065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  930087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930090 */     GIR_RootConstrainSelectedInstOperands,
     /*  930091 */     // GIR_Coverage, 16055,
     /*  930091 */     GIR_EraseRootFromParent_Done,
     /*  930092 */   // Label 14103: @930092
     /*  930092 */   GIM_Try, /*On fail goto*//*Label 14104*/ GIMT_Encode4(930183), // Rule ID 16058 //
     /*  930097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  930108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  930111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  930114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930144 */     // MIs[1] Operand 1
     /*  930144 */     // No operand predicates
     /*  930144 */     // MIs[0] round
     /*  930144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930156 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  930156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930168 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  930178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930181 */     GIR_RootConstrainSelectedInstOperands,
     /*  930182 */     // GIR_Coverage, 16058,
     /*  930182 */     GIR_EraseRootFromParent_Done,
     /*  930183 */   // Label 14104: @930183
     /*  930183 */   GIM_Try, /*On fail goto*//*Label 14105*/ GIMT_Encode4(930274), // Rule ID 16059 //
     /*  930188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  930199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  930202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  930205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930235 */     // MIs[1] Operand 1
     /*  930235 */     // No operand predicates
     /*  930235 */     // MIs[0] round
     /*  930235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930247 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  930247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  930269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930272 */     GIR_RootConstrainSelectedInstOperands,
     /*  930273 */     // GIR_Coverage, 16059,
     /*  930273 */     GIR_EraseRootFromParent_Done,
     /*  930274 */   // Label 14105: @930274
     /*  930274 */   GIM_Try, /*On fail goto*//*Label 14106*/ GIMT_Encode4(930365), // Rule ID 16062 //
     /*  930279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  930290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  930293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  930296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930326 */     // MIs[1] Operand 1
     /*  930326 */     // No operand predicates
     /*  930326 */     // MIs[0] round
     /*  930326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  930338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  930341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930350 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930363 */     GIR_RootConstrainSelectedInstOperands,
     /*  930364 */     // GIR_Coverage, 16062,
     /*  930364 */     GIR_EraseRootFromParent_Done,
     /*  930365 */   // Label 14106: @930365
     /*  930365 */   GIM_Try, /*On fail goto*//*Label 14107*/ GIMT_Encode4(930456), // Rule ID 16063 //
     /*  930370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  930381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  930384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  930387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930417 */     // MIs[1] Operand 1
     /*  930417 */     // No operand predicates
     /*  930417 */     // MIs[0] round
     /*  930417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  930429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  930432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930454 */     GIR_RootConstrainSelectedInstOperands,
     /*  930455 */     // GIR_Coverage, 16063,
     /*  930455 */     GIR_EraseRootFromParent_Done,
     /*  930456 */   // Label 14107: @930456
     /*  930456 */   GIM_Try, /*On fail goto*//*Label 14108*/ GIMT_Encode4(930547), // Rule ID 16066 //
     /*  930461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  930472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  930475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  930478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930508 */     // MIs[1] Operand 1
     /*  930508 */     // No operand predicates
     /*  930508 */     // MIs[0] round
     /*  930508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  930520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930532 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930545 */     GIR_RootConstrainSelectedInstOperands,
     /*  930546 */     // GIR_Coverage, 16066,
     /*  930546 */     GIR_EraseRootFromParent_Done,
     /*  930547 */   // Label 14108: @930547
     /*  930547 */   GIM_Try, /*On fail goto*//*Label 14109*/ GIMT_Encode4(930638), // Rule ID 16067 //
     /*  930552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  930563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  930566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  930569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930599 */     // MIs[1] Operand 1
     /*  930599 */     // No operand predicates
     /*  930599 */     // MIs[0] round
     /*  930599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930611 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  930611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930636 */     GIR_RootConstrainSelectedInstOperands,
     /*  930637 */     // GIR_Coverage, 16067,
     /*  930637 */     GIR_EraseRootFromParent_Done,
     /*  930638 */   // Label 14109: @930638
     /*  930638 */   GIM_Try, /*On fail goto*//*Label 14110*/ GIMT_Encode4(930729), // Rule ID 16070 //
     /*  930643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  930660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930690 */     // MIs[1] Operand 1
     /*  930690 */     // No operand predicates
     /*  930690 */     // MIs[0] round
     /*  930690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930702 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  930702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930714 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930727 */     GIR_RootConstrainSelectedInstOperands,
     /*  930728 */     // GIR_Coverage, 16070,
     /*  930728 */     GIR_EraseRootFromParent_Done,
     /*  930729 */   // Label 14110: @930729
     /*  930729 */   GIM_Try, /*On fail goto*//*Label 14111*/ GIMT_Encode4(930820), // Rule ID 16071 //
     /*  930734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  930751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930781 */     // MIs[1] Operand 1
     /*  930781 */     // No operand predicates
     /*  930781 */     // MIs[0] round
     /*  930781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930793 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  930793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930818 */     GIR_RootConstrainSelectedInstOperands,
     /*  930819 */     // GIR_Coverage, 16071,
     /*  930819 */     GIR_EraseRootFromParent_Done,
     /*  930820 */   // Label 14111: @930820
     /*  930820 */   GIM_Try, /*On fail goto*//*Label 14112*/ GIMT_Encode4(930911), // Rule ID 16074 //
     /*  930825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  930842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930872 */     // MIs[1] Operand 1
     /*  930872 */     // No operand predicates
     /*  930872 */     // MIs[0] round
     /*  930872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  930884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  930887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930896 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930909 */     GIR_RootConstrainSelectedInstOperands,
     /*  930910 */     // GIR_Coverage, 16074,
     /*  930910 */     GIR_EraseRootFromParent_Done,
     /*  930911 */   // Label 14112: @930911
     /*  930911 */   GIM_Try, /*On fail goto*//*Label 14113*/ GIMT_Encode4(931002), // Rule ID 16075 //
     /*  930916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  930933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930963 */     // MIs[1] Operand 1
     /*  930963 */     // No operand predicates
     /*  930963 */     // MIs[0] round
     /*  930963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930975 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  930975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  930978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931000 */     GIR_RootConstrainSelectedInstOperands,
     /*  931001 */     // GIR_Coverage, 16075,
     /*  931001 */     GIR_EraseRootFromParent_Done,
     /*  931002 */   // Label 14113: @931002
     /*  931002 */   GIM_Try, /*On fail goto*//*Label 14114*/ GIMT_Encode4(931093), // Rule ID 16078 //
     /*  931007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  931010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  931018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  931021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  931024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  931034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  931038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  931042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931054 */     // MIs[1] Operand 1
     /*  931054 */     // No operand predicates
     /*  931054 */     // MIs[0] round
     /*  931054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  931066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  931069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931078 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  931088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931091 */     GIR_RootConstrainSelectedInstOperands,
     /*  931092 */     // GIR_Coverage, 16078,
     /*  931092 */     GIR_EraseRootFromParent_Done,
     /*  931093 */   // Label 14114: @931093
     /*  931093 */   GIM_Try, /*On fail goto*//*Label 14115*/ GIMT_Encode4(931184), // Rule ID 16079 //
     /*  931098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  931101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  931109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  931112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  931115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  931125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  931129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  931133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931145 */     // MIs[1] Operand 1
     /*  931145 */     // No operand predicates
     /*  931145 */     // MIs[0] round
     /*  931145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931157 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  931157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  931160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  931179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931182 */     GIR_RootConstrainSelectedInstOperands,
     /*  931183 */     // GIR_Coverage, 16079,
     /*  931183 */     GIR_EraseRootFromParent_Done,
     /*  931184 */   // Label 14115: @931184
     /*  931184 */   GIM_Try, /*On fail goto*//*Label 14116*/ GIMT_Encode4(931275), // Rule ID 16082 //
     /*  931189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  931192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  931200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  931203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  931206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  931216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  931220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  931224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931236 */     // MIs[1] Operand 1
     /*  931236 */     // No operand predicates
     /*  931236 */     // MIs[0] round
     /*  931236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931248 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  931248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  931251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931260 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  931270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931273 */     GIR_RootConstrainSelectedInstOperands,
     /*  931274 */     // GIR_Coverage, 16082,
     /*  931274 */     GIR_EraseRootFromParent_Done,
     /*  931275 */   // Label 14116: @931275
     /*  931275 */   GIM_Try, /*On fail goto*//*Label 14117*/ GIMT_Encode4(931366), // Rule ID 16083 //
     /*  931280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  931283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  931291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  931294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  931297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  931307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  931311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  931315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931327 */     // MIs[1] Operand 1
     /*  931327 */     // No operand predicates
     /*  931327 */     // MIs[0] round
     /*  931327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931339 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  931339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  931342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  931361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931364 */     GIR_RootConstrainSelectedInstOperands,
     /*  931365 */     // GIR_Coverage, 16083,
     /*  931365 */     GIR_EraseRootFromParent_Done,
     /*  931366 */   // Label 14117: @931366
     /*  931366 */   GIM_Try, /*On fail goto*//*Label 14118*/ GIMT_Encode4(931457), // Rule ID 16262 //
     /*  931371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  931382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  931385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  931388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931418 */     // MIs[1] Operand 1
     /*  931418 */     // No operand predicates
     /*  931418 */     // MIs[0] round
     /*  931418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931430 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  931433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931442 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931455 */     GIR_RootConstrainSelectedInstOperands,
     /*  931456 */     // GIR_Coverage, 16262,
     /*  931456 */     GIR_EraseRootFromParent_Done,
     /*  931457 */   // Label 14118: @931457
     /*  931457 */   GIM_Try, /*On fail goto*//*Label 14119*/ GIMT_Encode4(931548), // Rule ID 16263 //
     /*  931462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  931473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  931476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  931479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931509 */     // MIs[1] Operand 1
     /*  931509 */     // No operand predicates
     /*  931509 */     // MIs[0] round
     /*  931509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931521 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  931524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931546 */     GIR_RootConstrainSelectedInstOperands,
     /*  931547 */     // GIR_Coverage, 16263,
     /*  931547 */     GIR_EraseRootFromParent_Done,
     /*  931548 */   // Label 14119: @931548
     /*  931548 */   GIM_Try, /*On fail goto*//*Label 14120*/ GIMT_Encode4(931639), // Rule ID 16266 //
     /*  931553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  931564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  931567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  931570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931600 */     // MIs[1] Operand 1
     /*  931600 */     // No operand predicates
     /*  931600 */     // MIs[0] round
     /*  931600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931612 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931624 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931637 */     GIR_RootConstrainSelectedInstOperands,
     /*  931638 */     // GIR_Coverage, 16266,
     /*  931638 */     GIR_EraseRootFromParent_Done,
     /*  931639 */   // Label 14120: @931639
     /*  931639 */   GIM_Try, /*On fail goto*//*Label 14121*/ GIMT_Encode4(931730), // Rule ID 16267 //
     /*  931644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  931655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  931658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  931661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931691 */     // MIs[1] Operand 1
     /*  931691 */     // No operand predicates
     /*  931691 */     // MIs[0] round
     /*  931691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931703 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931728 */     GIR_RootConstrainSelectedInstOperands,
     /*  931729 */     // GIR_Coverage, 16267,
     /*  931729 */     GIR_EraseRootFromParent_Done,
     /*  931730 */   // Label 14121: @931730
     /*  931730 */   GIM_Try, /*On fail goto*//*Label 14122*/ GIMT_Encode4(931821), // Rule ID 16270 //
     /*  931735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  931746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  931749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  931752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931782 */     // MIs[1] Operand 1
     /*  931782 */     // No operand predicates
     /*  931782 */     // MIs[0] round
     /*  931782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931794 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931806 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931819 */     GIR_RootConstrainSelectedInstOperands,
     /*  931820 */     // GIR_Coverage, 16270,
     /*  931820 */     GIR_EraseRootFromParent_Done,
     /*  931821 */   // Label 14122: @931821
     /*  931821 */   GIM_Try, /*On fail goto*//*Label 14123*/ GIMT_Encode4(931912), // Rule ID 16271 //
     /*  931826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  931837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  931840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  931843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931873 */     // MIs[1] Operand 1
     /*  931873 */     // No operand predicates
     /*  931873 */     // MIs[0] round
     /*  931873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931885 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931910 */     GIR_RootConstrainSelectedInstOperands,
     /*  931911 */     // GIR_Coverage, 16271,
     /*  931911 */     GIR_EraseRootFromParent_Done,
     /*  931912 */   // Label 14123: @931912
     /*  931912 */   GIM_Try, /*On fail goto*//*Label 14124*/ GIMT_Encode4(932003), // Rule ID 16274 //
     /*  931917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931964 */     // MIs[1] Operand 1
     /*  931964 */     // No operand predicates
     /*  931964 */     // MIs[0] round
     /*  931964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  931976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931988 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932001 */     GIR_RootConstrainSelectedInstOperands,
     /*  932002 */     // GIR_Coverage, 16274,
     /*  932002 */     GIR_EraseRootFromParent_Done,
     /*  932003 */   // Label 14124: @932003
     /*  932003 */   GIM_Try, /*On fail goto*//*Label 14125*/ GIMT_Encode4(932094), // Rule ID 16275 //
     /*  932008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  932019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  932022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  932025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932055 */     // MIs[1] Operand 1
     /*  932055 */     // No operand predicates
     /*  932055 */     // MIs[0] round
     /*  932055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932067 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  932067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  932070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932092 */     GIR_RootConstrainSelectedInstOperands,
     /*  932093 */     // GIR_Coverage, 16275,
     /*  932093 */     GIR_EraseRootFromParent_Done,
     /*  932094 */   // Label 14125: @932094
     /*  932094 */   GIM_Try, /*On fail goto*//*Label 14126*/ GIMT_Encode4(932185), // Rule ID 16278 //
     /*  932099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  932110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  932113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  932116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932146 */     // MIs[1] Operand 1
     /*  932146 */     // No operand predicates
     /*  932146 */     // MIs[0] round
     /*  932146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932158 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  932158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  932161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932170 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932183 */     GIR_RootConstrainSelectedInstOperands,
     /*  932184 */     // GIR_Coverage, 16278,
     /*  932184 */     GIR_EraseRootFromParent_Done,
     /*  932185 */   // Label 14126: @932185
     /*  932185 */   GIM_Try, /*On fail goto*//*Label 14127*/ GIMT_Encode4(932276), // Rule ID 16279 //
     /*  932190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  932201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  932204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  932207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932237 */     // MIs[1] Operand 1
     /*  932237 */     // No operand predicates
     /*  932237 */     // MIs[0] round
     /*  932237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932249 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  932249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  932252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932274 */     GIR_RootConstrainSelectedInstOperands,
     /*  932275 */     // GIR_Coverage, 16279,
     /*  932275 */     GIR_EraseRootFromParent_Done,
     /*  932276 */   // Label 14127: @932276
     /*  932276 */   GIM_Try, /*On fail goto*//*Label 14128*/ GIMT_Encode4(932367), // Rule ID 16282 //
     /*  932281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  932292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  932295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  932298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932328 */     // MIs[1] Operand 1
     /*  932328 */     // No operand predicates
     /*  932328 */     // MIs[0] round
     /*  932328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932340 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  932340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  932343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932352 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932365 */     GIR_RootConstrainSelectedInstOperands,
     /*  932366 */     // GIR_Coverage, 16282,
     /*  932366 */     GIR_EraseRootFromParent_Done,
     /*  932367 */   // Label 14128: @932367
     /*  932367 */   GIM_Try, /*On fail goto*//*Label 14129*/ GIMT_Encode4(932458), // Rule ID 16283 //
     /*  932372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  932383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  932386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  932389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932419 */     // MIs[1] Operand 1
     /*  932419 */     // No operand predicates
     /*  932419 */     // MIs[0] round
     /*  932419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932431 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  932431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  932434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932456 */     GIR_RootConstrainSelectedInstOperands,
     /*  932457 */     // GIR_Coverage, 16283,
     /*  932457 */     GIR_EraseRootFromParent_Done,
     /*  932458 */   // Label 14129: @932458
     /*  932458 */   GIM_Try, /*On fail goto*//*Label 14130*/ GIMT_Encode4(932549), // Rule ID 16286 //
     /*  932463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  932474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  932477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  932480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932510 */     // MIs[1] Operand 1
     /*  932510 */     // No operand predicates
     /*  932510 */     // MIs[0] round
     /*  932510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932522 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932534 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932547 */     GIR_RootConstrainSelectedInstOperands,
     /*  932548 */     // GIR_Coverage, 16286,
     /*  932548 */     GIR_EraseRootFromParent_Done,
     /*  932549 */   // Label 14130: @932549
     /*  932549 */   GIM_Try, /*On fail goto*//*Label 14131*/ GIMT_Encode4(932640), // Rule ID 16287 //
     /*  932554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  932565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  932568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  932571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932601 */     // MIs[1] Operand 1
     /*  932601 */     // No operand predicates
     /*  932601 */     // MIs[0] round
     /*  932601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932613 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932638 */     GIR_RootConstrainSelectedInstOperands,
     /*  932639 */     // GIR_Coverage, 16287,
     /*  932639 */     GIR_EraseRootFromParent_Done,
     /*  932640 */   // Label 14131: @932640
     /*  932640 */   GIM_Try, /*On fail goto*//*Label 14132*/ GIMT_Encode4(932731), // Rule ID 16290 //
     /*  932645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  932656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  932659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  932662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932692 */     // MIs[1] Operand 1
     /*  932692 */     // No operand predicates
     /*  932692 */     // MIs[0] round
     /*  932692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932704 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  932704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932716 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932729 */     GIR_RootConstrainSelectedInstOperands,
     /*  932730 */     // GIR_Coverage, 16290,
     /*  932730 */     GIR_EraseRootFromParent_Done,
     /*  932731 */   // Label 14132: @932731
     /*  932731 */   GIM_Try, /*On fail goto*//*Label 14133*/ GIMT_Encode4(932822), // Rule ID 16291 //
     /*  932736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  932747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  932750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  932753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932783 */     // MIs[1] Operand 1
     /*  932783 */     // No operand predicates
     /*  932783 */     // MIs[0] round
     /*  932783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932795 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  932795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932820 */     GIR_RootConstrainSelectedInstOperands,
     /*  932821 */     // GIR_Coverage, 16291,
     /*  932821 */     GIR_EraseRootFromParent_Done,
     /*  932822 */   // Label 14133: @932822
     /*  932822 */   GIM_Try, /*On fail goto*//*Label 14134*/ GIMT_Encode4(932913), // Rule ID 16294 //
     /*  932827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  932838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  932841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  932844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932874 */     // MIs[1] Operand 1
     /*  932874 */     // No operand predicates
     /*  932874 */     // MIs[0] round
     /*  932874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  932886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932898 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932911 */     GIR_RootConstrainSelectedInstOperands,
     /*  932912 */     // GIR_Coverage, 16294,
     /*  932912 */     GIR_EraseRootFromParent_Done,
     /*  932913 */   // Label 14134: @932913
     /*  932913 */   GIM_Try, /*On fail goto*//*Label 14135*/ GIMT_Encode4(933004), // Rule ID 16295 //
     /*  932918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  932929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  932932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  932935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932965 */     // MIs[1] Operand 1
     /*  932965 */     // No operand predicates
     /*  932965 */     // MIs[0] round
     /*  932965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932977 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  932977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933002 */     GIR_RootConstrainSelectedInstOperands,
     /*  933003 */     // GIR_Coverage, 16295,
     /*  933003 */     GIR_EraseRootFromParent_Done,
     /*  933004 */   // Label 14135: @933004
     /*  933004 */   GIM_Try, /*On fail goto*//*Label 14136*/ GIMT_Encode4(933095), // Rule ID 16298 //
     /*  933009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  933012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  933020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  933023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  933026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933056 */     // MIs[1] Operand 1
     /*  933056 */     // No operand predicates
     /*  933056 */     // MIs[0] round
     /*  933056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  933068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  933071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933080 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  933090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933093 */     GIR_RootConstrainSelectedInstOperands,
     /*  933094 */     // GIR_Coverage, 16298,
     /*  933094 */     GIR_EraseRootFromParent_Done,
     /*  933095 */   // Label 14136: @933095
     /*  933095 */   GIM_Try, /*On fail goto*//*Label 14137*/ GIMT_Encode4(933186), // Rule ID 16299 //
     /*  933100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  933103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  933111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  933114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  933117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933147 */     // MIs[1] Operand 1
     /*  933147 */     // No operand predicates
     /*  933147 */     // MIs[0] round
     /*  933147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933159 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  933159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  933162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  933181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933184 */     GIR_RootConstrainSelectedInstOperands,
     /*  933185 */     // GIR_Coverage, 16299,
     /*  933185 */     GIR_EraseRootFromParent_Done,
     /*  933186 */   // Label 14137: @933186
     /*  933186 */   GIM_Try, /*On fail goto*//*Label 14138*/ GIMT_Encode4(933277), // Rule ID 16302 //
     /*  933191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  933202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  933205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  933208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933238 */     // MIs[1] Operand 1
     /*  933238 */     // No operand predicates
     /*  933238 */     // MIs[0] round
     /*  933238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933250 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  933250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933262 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933275 */     GIR_RootConstrainSelectedInstOperands,
     /*  933276 */     // GIR_Coverage, 16302,
     /*  933276 */     GIR_EraseRootFromParent_Done,
     /*  933277 */   // Label 14138: @933277
     /*  933277 */   GIM_Try, /*On fail goto*//*Label 14139*/ GIMT_Encode4(933368), // Rule ID 16303 //
     /*  933282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  933293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  933296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  933299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933329 */     // MIs[1] Operand 1
     /*  933329 */     // No operand predicates
     /*  933329 */     // MIs[0] round
     /*  933329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933341 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  933341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933366 */     GIR_RootConstrainSelectedInstOperands,
     /*  933367 */     // GIR_Coverage, 16303,
     /*  933367 */     GIR_EraseRootFromParent_Done,
     /*  933368 */   // Label 14139: @933368
     /*  933368 */   GIM_Try, /*On fail goto*//*Label 14140*/ GIMT_Encode4(933459), // Rule ID 16306 //
     /*  933373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  933384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  933387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  933390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933420 */     // MIs[1] Operand 1
     /*  933420 */     // No operand predicates
     /*  933420 */     // MIs[0] round
     /*  933420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933432 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  933432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933444 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933457 */     GIR_RootConstrainSelectedInstOperands,
     /*  933458 */     // GIR_Coverage, 16306,
     /*  933458 */     GIR_EraseRootFromParent_Done,
     /*  933459 */   // Label 14140: @933459
     /*  933459 */   GIM_Try, /*On fail goto*//*Label 14141*/ GIMT_Encode4(933550), // Rule ID 16307 //
     /*  933464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  933475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  933478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  933481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933511 */     // MIs[1] Operand 1
     /*  933511 */     // No operand predicates
     /*  933511 */     // MIs[0] round
     /*  933511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933523 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  933523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933548 */     GIR_RootConstrainSelectedInstOperands,
     /*  933549 */     // GIR_Coverage, 16307,
     /*  933549 */     GIR_EraseRootFromParent_Done,
     /*  933550 */   // Label 14141: @933550
     /*  933550 */   GIM_Try, /*On fail goto*//*Label 14142*/ GIMT_Encode4(933641), // Rule ID 16310 //
     /*  933555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  933566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  933569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  933572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933602 */     // MIs[1] Operand 1
     /*  933602 */     // No operand predicates
     /*  933602 */     // MIs[0] round
     /*  933602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933614 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  933614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933626 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933639 */     GIR_RootConstrainSelectedInstOperands,
     /*  933640 */     // GIR_Coverage, 16310,
     /*  933640 */     GIR_EraseRootFromParent_Done,
     /*  933641 */   // Label 14142: @933641
     /*  933641 */   GIM_Try, /*On fail goto*//*Label 14143*/ GIMT_Encode4(933732), // Rule ID 16311 //
     /*  933646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  933657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  933660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  933663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933693 */     // MIs[1] Operand 1
     /*  933693 */     // No operand predicates
     /*  933693 */     // MIs[0] round
     /*  933693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933705 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  933705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933730 */     GIR_RootConstrainSelectedInstOperands,
     /*  933731 */     // GIR_Coverage, 16311,
     /*  933731 */     GIR_EraseRootFromParent_Done,
     /*  933732 */   // Label 14143: @933732
     /*  933732 */   GIM_Try, /*On fail goto*//*Label 14144*/ GIMT_Encode4(933823), // Rule ID 16314 //
     /*  933737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  933748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  933751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  933754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933784 */     // MIs[1] Operand 1
     /*  933784 */     // No operand predicates
     /*  933784 */     // MIs[0] round
     /*  933784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933808 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933821 */     GIR_RootConstrainSelectedInstOperands,
     /*  933822 */     // GIR_Coverage, 16314,
     /*  933822 */     GIR_EraseRootFromParent_Done,
     /*  933823 */   // Label 14144: @933823
     /*  933823 */   GIM_Try, /*On fail goto*//*Label 14145*/ GIMT_Encode4(933914), // Rule ID 16315 //
     /*  933828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  933839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  933842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  933845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933875 */     // MIs[1] Operand 1
     /*  933875 */     // No operand predicates
     /*  933875 */     // MIs[0] round
     /*  933875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933887 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933912 */     GIR_RootConstrainSelectedInstOperands,
     /*  933913 */     // GIR_Coverage, 16315,
     /*  933913 */     GIR_EraseRootFromParent_Done,
     /*  933914 */   // Label 14145: @933914
     /*  933914 */   GIM_Try, /*On fail goto*//*Label 14146*/ GIMT_Encode4(934005), // Rule ID 16318 //
     /*  933919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  933930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  933933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  933936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933966 */     // MIs[1] Operand 1
     /*  933966 */     // No operand predicates
     /*  933966 */     // MIs[0] round
     /*  933966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933978 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  934000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934003 */     GIR_RootConstrainSelectedInstOperands,
     /*  934004 */     // GIR_Coverage, 16318,
     /*  934004 */     GIR_EraseRootFromParent_Done,
     /*  934005 */   // Label 14146: @934005
     /*  934005 */   GIM_Try, /*On fail goto*//*Label 14147*/ GIMT_Encode4(934096), // Rule ID 16319 //
     /*  934010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  934021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  934024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  934027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934057 */     // MIs[1] Operand 1
     /*  934057 */     // No operand predicates
     /*  934057 */     // MIs[0] round
     /*  934057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934069 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  934069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  934091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934094 */     GIR_RootConstrainSelectedInstOperands,
     /*  934095 */     // GIR_Coverage, 16319,
     /*  934095 */     GIR_EraseRootFromParent_Done,
     /*  934096 */   // Label 14147: @934096
     /*  934096 */   GIM_Try, /*On fail goto*//*Label 14148*/ GIMT_Encode4(934187), // Rule ID 16322 //
     /*  934101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  934112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  934115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  934118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934148 */     // MIs[1] Operand 1
     /*  934148 */     // No operand predicates
     /*  934148 */     // MIs[0] round
     /*  934148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934160 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  934160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934172 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  934182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934185 */     GIR_RootConstrainSelectedInstOperands,
     /*  934186 */     // GIR_Coverage, 16322,
     /*  934186 */     GIR_EraseRootFromParent_Done,
     /*  934187 */   // Label 14148: @934187
     /*  934187 */   GIM_Try, /*On fail goto*//*Label 14149*/ GIMT_Encode4(934278), // Rule ID 16323 //
     /*  934192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  934203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  934206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  934209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934239 */     // MIs[1] Operand 1
     /*  934239 */     // No operand predicates
     /*  934239 */     // MIs[0] round
     /*  934239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934251 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  934251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  934273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934276 */     GIR_RootConstrainSelectedInstOperands,
     /*  934277 */     // GIR_Coverage, 16323,
     /*  934277 */     GIR_EraseRootFromParent_Done,
     /*  934278 */   // Label 14149: @934278
     /*  934278 */   GIM_Try, /*On fail goto*//*Label 14150*/ GIMT_Encode4(934369), // Rule ID 16326 //
     /*  934283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  934294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  934297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  934300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934330 */     // MIs[1] Operand 1
     /*  934330 */     // No operand predicates
     /*  934330 */     // MIs[0] round
     /*  934330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  934342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934354 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934367 */     GIR_RootConstrainSelectedInstOperands,
     /*  934368 */     // GIR_Coverage, 16326,
     /*  934368 */     GIR_EraseRootFromParent_Done,
     /*  934369 */   // Label 14150: @934369
     /*  934369 */   GIM_Try, /*On fail goto*//*Label 14151*/ GIMT_Encode4(934460), // Rule ID 16327 //
     /*  934374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  934385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  934388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  934391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934421 */     // MIs[1] Operand 1
     /*  934421 */     // No operand predicates
     /*  934421 */     // MIs[0] round
     /*  934421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  934433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934458 */     GIR_RootConstrainSelectedInstOperands,
     /*  934459 */     // GIR_Coverage, 16327,
     /*  934459 */     GIR_EraseRootFromParent_Done,
     /*  934460 */   // Label 14151: @934460
     /*  934460 */   GIM_Try, /*On fail goto*//*Label 14152*/ GIMT_Encode4(934551), // Rule ID 16330 //
     /*  934465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  934476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  934479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  934482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934512 */     // MIs[1] Operand 1
     /*  934512 */     // No operand predicates
     /*  934512 */     // MIs[0] round
     /*  934512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  934524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934536 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934549 */     GIR_RootConstrainSelectedInstOperands,
     /*  934550 */     // GIR_Coverage, 16330,
     /*  934550 */     GIR_EraseRootFromParent_Done,
     /*  934551 */   // Label 14152: @934551
     /*  934551 */   GIM_Try, /*On fail goto*//*Label 14153*/ GIMT_Encode4(934642), // Rule ID 16331 //
     /*  934556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  934567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  934570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  934573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934603 */     // MIs[1] Operand 1
     /*  934603 */     // No operand predicates
     /*  934603 */     // MIs[0] round
     /*  934603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934615 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  934615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934640 */     GIR_RootConstrainSelectedInstOperands,
     /*  934641 */     // GIR_Coverage, 16331,
     /*  934641 */     GIR_EraseRootFromParent_Done,
     /*  934642 */   // Label 14153: @934642
     /*  934642 */   GIM_Try, /*On fail goto*//*Label 14154*/ GIMT_Encode4(934733), // Rule ID 16334 //
     /*  934647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  934658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  934661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  934664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934694 */     // MIs[1] Operand 1
     /*  934694 */     // No operand predicates
     /*  934694 */     // MIs[0] round
     /*  934694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934706 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  934706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934718 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934731 */     GIR_RootConstrainSelectedInstOperands,
     /*  934732 */     // GIR_Coverage, 16334,
     /*  934732 */     GIR_EraseRootFromParent_Done,
     /*  934733 */   // Label 14154: @934733
     /*  934733 */   GIM_Try, /*On fail goto*//*Label 14155*/ GIMT_Encode4(934824), // Rule ID 16335 //
     /*  934738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  934749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  934752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  934755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934785 */     // MIs[1] Operand 1
     /*  934785 */     // No operand predicates
     /*  934785 */     // MIs[0] round
     /*  934785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934797 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  934797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934822 */     GIR_RootConstrainSelectedInstOperands,
     /*  934823 */     // GIR_Coverage, 16335,
     /*  934823 */     GIR_EraseRootFromParent_Done,
     /*  934824 */   // Label 14155: @934824
     /*  934824 */   GIM_Try, /*On fail goto*//*Label 14156*/ GIMT_Encode4(934915), // Rule ID 16338 //
     /*  934829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  934840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  934843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  934846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934876 */     // MIs[1] Operand 1
     /*  934876 */     // No operand predicates
     /*  934876 */     // MIs[0] round
     /*  934876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934888 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934900 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934913 */     GIR_RootConstrainSelectedInstOperands,
     /*  934914 */     // GIR_Coverage, 16338,
     /*  934914 */     GIR_EraseRootFromParent_Done,
     /*  934915 */   // Label 14156: @934915
     /*  934915 */   GIM_Try, /*On fail goto*//*Label 14157*/ GIMT_Encode4(935006), // Rule ID 16339 //
     /*  934920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  934931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  934934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  934937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934967 */     // MIs[1] Operand 1
     /*  934967 */     // No operand predicates
     /*  934967 */     // MIs[0] round
     /*  934967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934979 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  935001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935004 */     GIR_RootConstrainSelectedInstOperands,
     /*  935005 */     // GIR_Coverage, 16339,
     /*  935005 */     GIR_EraseRootFromParent_Done,
     /*  935006 */   // Label 14157: @935006
     /*  935006 */   GIM_Try, /*On fail goto*//*Label 14158*/ GIMT_Encode4(935097), // Rule ID 16342 //
     /*  935011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  935014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  935022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  935025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  935028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935058 */     // MIs[1] Operand 1
     /*  935058 */     // No operand predicates
     /*  935058 */     // MIs[0] round
     /*  935058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935070 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  935070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  935073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935082 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  935092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935095 */     GIR_RootConstrainSelectedInstOperands,
     /*  935096 */     // GIR_Coverage, 16342,
     /*  935096 */     GIR_EraseRootFromParent_Done,
     /*  935097 */   // Label 14158: @935097
     /*  935097 */   GIM_Try, /*On fail goto*//*Label 14159*/ GIMT_Encode4(935188), // Rule ID 16343 //
     /*  935102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  935105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  935113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  935116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  935119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935149 */     // MIs[1] Operand 1
     /*  935149 */     // No operand predicates
     /*  935149 */     // MIs[0] round
     /*  935149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935161 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  935161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  935164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  935183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935186 */     GIR_RootConstrainSelectedInstOperands,
     /*  935187 */     // GIR_Coverage, 16343,
     /*  935187 */     GIR_EraseRootFromParent_Done,
     /*  935188 */   // Label 14159: @935188
     /*  935188 */   GIM_Try, /*On fail goto*//*Label 14160*/ GIMT_Encode4(935279), // Rule ID 16346 //
     /*  935193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  935196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  935204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  935207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  935210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935240 */     // MIs[1] Operand 1
     /*  935240 */     // No operand predicates
     /*  935240 */     // MIs[0] round
     /*  935240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935252 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  935252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  935255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935264 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  935274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935277 */     GIR_RootConstrainSelectedInstOperands,
     /*  935278 */     // GIR_Coverage, 16346,
     /*  935278 */     GIR_EraseRootFromParent_Done,
     /*  935279 */   // Label 14160: @935279
     /*  935279 */   GIM_Try, /*On fail goto*//*Label 14161*/ GIMT_Encode4(935370), // Rule ID 16347 //
     /*  935284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  935287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  935295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  935298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  935301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935331 */     // MIs[1] Operand 1
     /*  935331 */     // No operand predicates
     /*  935331 */     // MIs[0] round
     /*  935331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935343 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  935343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  935346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  935365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935368 */     GIR_RootConstrainSelectedInstOperands,
     /*  935369 */     // GIR_Coverage, 16347,
     /*  935369 */     GIR_EraseRootFromParent_Done,
     /*  935370 */   // Label 14161: @935370
     /*  935370 */   GIM_Try, /*On fail goto*//*Label 14162*/ GIMT_Encode4(935464), // Rule ID 16470 //
     /*  935375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  935386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  935389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  935392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935422 */     // MIs[1] Operand 1
     /*  935422 */     // No operand predicates
     /*  935422 */     // MIs[0] round
     /*  935422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935434 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  935437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935462 */     GIR_RootConstrainSelectedInstOperands,
     /*  935463 */     // GIR_Coverage, 16470,
     /*  935463 */     GIR_EraseRootFromParent_Done,
     /*  935464 */   // Label 14162: @935464
     /*  935464 */   GIM_Try, /*On fail goto*//*Label 14163*/ GIMT_Encode4(935558), // Rule ID 16471 //
     /*  935469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  935480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  935483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  935486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935516 */     // MIs[1] Operand 1
     /*  935516 */     // No operand predicates
     /*  935516 */     // MIs[0] round
     /*  935516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935528 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  935531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935540 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935556 */     GIR_RootConstrainSelectedInstOperands,
     /*  935557 */     // GIR_Coverage, 16471,
     /*  935557 */     GIR_EraseRootFromParent_Done,
     /*  935558 */   // Label 14163: @935558
     /*  935558 */   GIM_Try, /*On fail goto*//*Label 14164*/ GIMT_Encode4(935652), // Rule ID 16474 //
     /*  935563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  935574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  935577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  935580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935610 */     // MIs[1] Operand 1
     /*  935610 */     // No operand predicates
     /*  935610 */     // MIs[0] round
     /*  935610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935622 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  935625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935634 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935650 */     GIR_RootConstrainSelectedInstOperands,
     /*  935651 */     // GIR_Coverage, 16474,
     /*  935651 */     GIR_EraseRootFromParent_Done,
     /*  935652 */   // Label 14164: @935652
     /*  935652 */   GIM_Try, /*On fail goto*//*Label 14165*/ GIMT_Encode4(935746), // Rule ID 16475 //
     /*  935657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  935668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  935671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  935674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935704 */     // MIs[1] Operand 1
     /*  935704 */     // No operand predicates
     /*  935704 */     // MIs[0] round
     /*  935704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935716 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  935719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935728 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935744 */     GIR_RootConstrainSelectedInstOperands,
     /*  935745 */     // GIR_Coverage, 16475,
     /*  935745 */     GIR_EraseRootFromParent_Done,
     /*  935746 */   // Label 14165: @935746
     /*  935746 */   GIM_Try, /*On fail goto*//*Label 14166*/ GIMT_Encode4(935840), // Rule ID 16478 //
     /*  935751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  935762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  935765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  935768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935798 */     // MIs[1] Operand 1
     /*  935798 */     // No operand predicates
     /*  935798 */     // MIs[0] round
     /*  935798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935810 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  935813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935822 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935838 */     GIR_RootConstrainSelectedInstOperands,
     /*  935839 */     // GIR_Coverage, 16478,
     /*  935839 */     GIR_EraseRootFromParent_Done,
     /*  935840 */   // Label 14166: @935840
     /*  935840 */   GIM_Try, /*On fail goto*//*Label 14167*/ GIMT_Encode4(935934), // Rule ID 16479 //
     /*  935845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  935856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  935859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  935862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935892 */     // MIs[1] Operand 1
     /*  935892 */     // No operand predicates
     /*  935892 */     // MIs[0] round
     /*  935892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935904 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  935907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935916 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935932 */     GIR_RootConstrainSelectedInstOperands,
     /*  935933 */     // GIR_Coverage, 16479,
     /*  935933 */     GIR_EraseRootFromParent_Done,
     /*  935934 */   // Label 14167: @935934
     /*  935934 */   GIM_Try, /*On fail goto*//*Label 14168*/ GIMT_Encode4(936028), // Rule ID 16482 //
     /*  935939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  935950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  935953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  935956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935986 */     // MIs[1] Operand 1
     /*  935986 */     // No operand predicates
     /*  935986 */     // MIs[0] round
     /*  935986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935998 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  936001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936010 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936026 */     GIR_RootConstrainSelectedInstOperands,
     /*  936027 */     // GIR_Coverage, 16482,
     /*  936027 */     GIR_EraseRootFromParent_Done,
     /*  936028 */   // Label 14168: @936028
     /*  936028 */   GIM_Try, /*On fail goto*//*Label 14169*/ GIMT_Encode4(936122), // Rule ID 16483 //
     /*  936033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  936044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  936047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  936050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936080 */     // MIs[1] Operand 1
     /*  936080 */     // No operand predicates
     /*  936080 */     // MIs[0] round
     /*  936080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936092 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  936092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  936095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936104 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936120 */     GIR_RootConstrainSelectedInstOperands,
     /*  936121 */     // GIR_Coverage, 16483,
     /*  936121 */     GIR_EraseRootFromParent_Done,
     /*  936122 */   // Label 14169: @936122
     /*  936122 */   GIM_Try, /*On fail goto*//*Label 14170*/ GIMT_Encode4(936216), // Rule ID 16486 //
     /*  936127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  936138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  936141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  936144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936174 */     // MIs[1] Operand 1
     /*  936174 */     // No operand predicates
     /*  936174 */     // MIs[0] round
     /*  936174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936186 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  936186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  936189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936198 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936214 */     GIR_RootConstrainSelectedInstOperands,
     /*  936215 */     // GIR_Coverage, 16486,
     /*  936215 */     GIR_EraseRootFromParent_Done,
     /*  936216 */   // Label 14170: @936216
     /*  936216 */   GIM_Try, /*On fail goto*//*Label 14171*/ GIMT_Encode4(936310), // Rule ID 16487 //
     /*  936221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  936232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  936235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  936238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936268 */     // MIs[1] Operand 1
     /*  936268 */     // No operand predicates
     /*  936268 */     // MIs[0] round
     /*  936268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936280 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  936280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  936283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936292 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936308 */     GIR_RootConstrainSelectedInstOperands,
     /*  936309 */     // GIR_Coverage, 16487,
     /*  936309 */     GIR_EraseRootFromParent_Done,
     /*  936310 */   // Label 14171: @936310
     /*  936310 */   GIM_Try, /*On fail goto*//*Label 14172*/ GIMT_Encode4(936404), // Rule ID 16490 //
     /*  936315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  936326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  936329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  936332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936362 */     // MIs[1] Operand 1
     /*  936362 */     // No operand predicates
     /*  936362 */     // MIs[0] round
     /*  936362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936374 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  936374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  936377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936386 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936402 */     GIR_RootConstrainSelectedInstOperands,
     /*  936403 */     // GIR_Coverage, 16490,
     /*  936403 */     GIR_EraseRootFromParent_Done,
     /*  936404 */   // Label 14172: @936404
     /*  936404 */   GIM_Try, /*On fail goto*//*Label 14173*/ GIMT_Encode4(936498), // Rule ID 16491 //
     /*  936409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  936420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  936423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  936426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936456 */     // MIs[1] Operand 1
     /*  936456 */     // No operand predicates
     /*  936456 */     // MIs[0] round
     /*  936456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936468 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  936468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  936471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936480 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936496 */     GIR_RootConstrainSelectedInstOperands,
     /*  936497 */     // GIR_Coverage, 16491,
     /*  936497 */     GIR_EraseRootFromParent_Done,
     /*  936498 */   // Label 14173: @936498
     /*  936498 */   GIM_Try, /*On fail goto*//*Label 14174*/ GIMT_Encode4(936592), // Rule ID 16494 //
     /*  936503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  936514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  936517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  936520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936550 */     // MIs[1] Operand 1
     /*  936550 */     // No operand predicates
     /*  936550 */     // MIs[0] round
     /*  936550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936562 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  936565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936574 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936590 */     GIR_RootConstrainSelectedInstOperands,
     /*  936591 */     // GIR_Coverage, 16494,
     /*  936591 */     GIR_EraseRootFromParent_Done,
     /*  936592 */   // Label 14174: @936592
     /*  936592 */   GIM_Try, /*On fail goto*//*Label 14175*/ GIMT_Encode4(936686), // Rule ID 16495 //
     /*  936597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  936608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  936611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  936614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936644 */     // MIs[1] Operand 1
     /*  936644 */     // No operand predicates
     /*  936644 */     // MIs[0] round
     /*  936644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936656 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  936659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936668 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936684 */     GIR_RootConstrainSelectedInstOperands,
     /*  936685 */     // GIR_Coverage, 16495,
     /*  936685 */     GIR_EraseRootFromParent_Done,
     /*  936686 */   // Label 14175: @936686
     /*  936686 */   GIM_Try, /*On fail goto*//*Label 14176*/ GIMT_Encode4(936780), // Rule ID 16498 //
     /*  936691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  936702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  936705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  936708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936738 */     // MIs[1] Operand 1
     /*  936738 */     // No operand predicates
     /*  936738 */     // MIs[0] round
     /*  936738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936750 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  936753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936762 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936778 */     GIR_RootConstrainSelectedInstOperands,
     /*  936779 */     // GIR_Coverage, 16498,
     /*  936779 */     GIR_EraseRootFromParent_Done,
     /*  936780 */   // Label 14176: @936780
     /*  936780 */   GIM_Try, /*On fail goto*//*Label 14177*/ GIMT_Encode4(936874), // Rule ID 16499 //
     /*  936785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  936796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  936799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  936802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936832 */     // MIs[1] Operand 1
     /*  936832 */     // No operand predicates
     /*  936832 */     // MIs[0] round
     /*  936832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  936847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936856 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936872 */     GIR_RootConstrainSelectedInstOperands,
     /*  936873 */     // GIR_Coverage, 16499,
     /*  936873 */     GIR_EraseRootFromParent_Done,
     /*  936874 */   // Label 14177: @936874
     /*  936874 */   GIM_Try, /*On fail goto*//*Label 14178*/ GIMT_Encode4(936968), // Rule ID 16502 //
     /*  936879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  936896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936926 */     // MIs[1] Operand 1
     /*  936926 */     // No operand predicates
     /*  936926 */     // MIs[0] round
     /*  936926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936938 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  936941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936966 */     GIR_RootConstrainSelectedInstOperands,
     /*  936967 */     // GIR_Coverage, 16502,
     /*  936967 */     GIR_EraseRootFromParent_Done,
     /*  936968 */   // Label 14178: @936968
     /*  936968 */   GIM_Try, /*On fail goto*//*Label 14179*/ GIMT_Encode4(937062), // Rule ID 16503 //
     /*  936973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  936990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937020 */     // MIs[1] Operand 1
     /*  937020 */     // No operand predicates
     /*  937020 */     // MIs[0] round
     /*  937020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  937032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  937035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937044 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937060 */     GIR_RootConstrainSelectedInstOperands,
     /*  937061 */     // GIR_Coverage, 16503,
     /*  937061 */     GIR_EraseRootFromParent_Done,
     /*  937062 */   // Label 14179: @937062
     /*  937062 */   GIM_Try, /*On fail goto*//*Label 14180*/ GIMT_Encode4(937156), // Rule ID 16506 //
     /*  937067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  937078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  937081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  937084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937114 */     // MIs[1] Operand 1
     /*  937114 */     // No operand predicates
     /*  937114 */     // MIs[0] round
     /*  937114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937126 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  937126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  937129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937138 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937154 */     GIR_RootConstrainSelectedInstOperands,
     /*  937155 */     // GIR_Coverage, 16506,
     /*  937155 */     GIR_EraseRootFromParent_Done,
     /*  937156 */   // Label 14180: @937156
     /*  937156 */   GIM_Try, /*On fail goto*//*Label 14181*/ GIMT_Encode4(937250), // Rule ID 16507 //
     /*  937161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  937172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  937175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  937178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937208 */     // MIs[1] Operand 1
     /*  937208 */     // No operand predicates
     /*  937208 */     // MIs[0] round
     /*  937208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  937220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  937223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937232 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937248 */     GIR_RootConstrainSelectedInstOperands,
     /*  937249 */     // GIR_Coverage, 16507,
     /*  937249 */     GIR_EraseRootFromParent_Done,
     /*  937250 */   // Label 14181: @937250
     /*  937250 */   GIM_Try, /*On fail goto*//*Label 14182*/ GIMT_Encode4(937344), // Rule ID 16510 //
     /*  937255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  937266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  937269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  937272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937302 */     // MIs[1] Operand 1
     /*  937302 */     // No operand predicates
     /*  937302 */     // MIs[0] round
     /*  937302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937314 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  937314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  937317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937342 */     GIR_RootConstrainSelectedInstOperands,
     /*  937343 */     // GIR_Coverage, 16510,
     /*  937343 */     GIR_EraseRootFromParent_Done,
     /*  937344 */   // Label 14182: @937344
     /*  937344 */   GIM_Try, /*On fail goto*//*Label 14183*/ GIMT_Encode4(937438), // Rule ID 16511 //
     /*  937349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  937360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  937363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  937366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937396 */     // MIs[1] Operand 1
     /*  937396 */     // No operand predicates
     /*  937396 */     // MIs[0] round
     /*  937396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937408 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  937408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  937411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937420 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937436 */     GIR_RootConstrainSelectedInstOperands,
     /*  937437 */     // GIR_Coverage, 16511,
     /*  937437 */     GIR_EraseRootFromParent_Done,
     /*  937438 */   // Label 14183: @937438
     /*  937438 */   GIM_Try, /*On fail goto*//*Label 14184*/ GIMT_Encode4(937532), // Rule ID 16514 //
     /*  937443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  937454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  937457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  937460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937490 */     // MIs[1] Operand 1
     /*  937490 */     // No operand predicates
     /*  937490 */     // MIs[0] round
     /*  937490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  937505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937514 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937530 */     GIR_RootConstrainSelectedInstOperands,
     /*  937531 */     // GIR_Coverage, 16514,
     /*  937531 */     GIR_EraseRootFromParent_Done,
     /*  937532 */   // Label 14184: @937532
     /*  937532 */   GIM_Try, /*On fail goto*//*Label 14185*/ GIMT_Encode4(937626), // Rule ID 16515 //
     /*  937537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  937548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  937551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  937554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937584 */     // MIs[1] Operand 1
     /*  937584 */     // No operand predicates
     /*  937584 */     // MIs[0] round
     /*  937584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  937599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937608 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937624 */     GIR_RootConstrainSelectedInstOperands,
     /*  937625 */     // GIR_Coverage, 16515,
     /*  937625 */     GIR_EraseRootFromParent_Done,
     /*  937626 */   // Label 14185: @937626
     /*  937626 */   GIM_Try, /*On fail goto*//*Label 14186*/ GIMT_Encode4(937720), // Rule ID 16518 //
     /*  937631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  937642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  937645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  937648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937678 */     // MIs[1] Operand 1
     /*  937678 */     // No operand predicates
     /*  937678 */     // MIs[0] round
     /*  937678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  937693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937702 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937718 */     GIR_RootConstrainSelectedInstOperands,
     /*  937719 */     // GIR_Coverage, 16518,
     /*  937719 */     GIR_EraseRootFromParent_Done,
     /*  937720 */   // Label 14186: @937720
     /*  937720 */   GIM_Try, /*On fail goto*//*Label 14187*/ GIMT_Encode4(937814), // Rule ID 16519 //
     /*  937725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  937736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  937739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  937742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937772 */     // MIs[1] Operand 1
     /*  937772 */     // No operand predicates
     /*  937772 */     // MIs[0] round
     /*  937772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937784 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  937787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937796 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937812 */     GIR_RootConstrainSelectedInstOperands,
     /*  937813 */     // GIR_Coverage, 16519,
     /*  937813 */     GIR_EraseRootFromParent_Done,
     /*  937814 */   // Label 14187: @937814
     /*  937814 */   GIM_Try, /*On fail goto*//*Label 14188*/ GIMT_Encode4(937908), // Rule ID 16522 //
     /*  937819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  937830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  937833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  937836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937866 */     // MIs[1] Operand 1
     /*  937866 */     // No operand predicates
     /*  937866 */     // MIs[0] round
     /*  937866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  937881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937890 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937903 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937906 */     GIR_RootConstrainSelectedInstOperands,
     /*  937907 */     // GIR_Coverage, 16522,
     /*  937907 */     GIR_EraseRootFromParent_Done,
     /*  937908 */   // Label 14188: @937908
     /*  937908 */   GIM_Try, /*On fail goto*//*Label 14189*/ GIMT_Encode4(938002), // Rule ID 16523 //
     /*  937913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  937924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  937927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  937930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937960 */     // MIs[1] Operand 1
     /*  937960 */     // No operand predicates
     /*  937960 */     // MIs[0] round
     /*  937960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  937975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937984 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938000 */     GIR_RootConstrainSelectedInstOperands,
     /*  938001 */     // GIR_Coverage, 16523,
     /*  938001 */     GIR_EraseRootFromParent_Done,
     /*  938002 */   // Label 14189: @938002
     /*  938002 */   GIM_Try, /*On fail goto*//*Label 14190*/ GIMT_Encode4(938096), // Rule ID 16526 //
     /*  938007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  938010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  938015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  938018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  938021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  938024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938054 */     // MIs[1] Operand 1
     /*  938054 */     // No operand predicates
     /*  938054 */     // MIs[0] round
     /*  938054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  938066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  938069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938078 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  938088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938094 */     GIR_RootConstrainSelectedInstOperands,
     /*  938095 */     // GIR_Coverage, 16526,
     /*  938095 */     GIR_EraseRootFromParent_Done,
     /*  938096 */   // Label 14190: @938096
     /*  938096 */   GIM_Try, /*On fail goto*//*Label 14191*/ GIMT_Encode4(938190), // Rule ID 16527 //
     /*  938101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  938104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  938109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  938112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  938115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  938118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938148 */     // MIs[1] Operand 1
     /*  938148 */     // No operand predicates
     /*  938148 */     // MIs[0] round
     /*  938148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938160 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  938160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  938163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938172 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  938182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938188 */     GIR_RootConstrainSelectedInstOperands,
     /*  938189 */     // GIR_Coverage, 16527,
     /*  938189 */     GIR_EraseRootFromParent_Done,
     /*  938190 */   // Label 14191: @938190
     /*  938190 */   GIM_Try, /*On fail goto*//*Label 14192*/ GIMT_Encode4(938284), // Rule ID 16650 //
     /*  938195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  938206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  938209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  938212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938242 */     // MIs[1] Operand 1
     /*  938242 */     // No operand predicates
     /*  938242 */     // MIs[0] round
     /*  938242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938254 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  938257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938266 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938282 */     GIR_RootConstrainSelectedInstOperands,
     /*  938283 */     // GIR_Coverage, 16650,
     /*  938283 */     GIR_EraseRootFromParent_Done,
     /*  938284 */   // Label 14192: @938284
     /*  938284 */   GIM_Try, /*On fail goto*//*Label 14193*/ GIMT_Encode4(938378), // Rule ID 16651 //
     /*  938289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  938300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  938303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  938306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938336 */     // MIs[1] Operand 1
     /*  938336 */     // No operand predicates
     /*  938336 */     // MIs[0] round
     /*  938336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938348 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  938351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938360 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938376 */     GIR_RootConstrainSelectedInstOperands,
     /*  938377 */     // GIR_Coverage, 16651,
     /*  938377 */     GIR_EraseRootFromParent_Done,
     /*  938378 */   // Label 14193: @938378
     /*  938378 */   GIM_Try, /*On fail goto*//*Label 14194*/ GIMT_Encode4(938472), // Rule ID 16654 //
     /*  938383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  938394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  938397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  938400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938430 */     // MIs[1] Operand 1
     /*  938430 */     // No operand predicates
     /*  938430 */     // MIs[0] round
     /*  938430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938442 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  938445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938454 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938470 */     GIR_RootConstrainSelectedInstOperands,
     /*  938471 */     // GIR_Coverage, 16654,
     /*  938471 */     GIR_EraseRootFromParent_Done,
     /*  938472 */   // Label 14194: @938472
     /*  938472 */   GIM_Try, /*On fail goto*//*Label 14195*/ GIMT_Encode4(938566), // Rule ID 16655 //
     /*  938477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  938488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  938491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  938494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938524 */     // MIs[1] Operand 1
     /*  938524 */     // No operand predicates
     /*  938524 */     // MIs[0] round
     /*  938524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938536 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  938539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938548 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938564 */     GIR_RootConstrainSelectedInstOperands,
     /*  938565 */     // GIR_Coverage, 16655,
     /*  938565 */     GIR_EraseRootFromParent_Done,
     /*  938566 */   // Label 14195: @938566
     /*  938566 */   GIM_Try, /*On fail goto*//*Label 14196*/ GIMT_Encode4(938660), // Rule ID 16658 //
     /*  938571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  938582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  938585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  938588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938618 */     // MIs[1] Operand 1
     /*  938618 */     // No operand predicates
     /*  938618 */     // MIs[0] round
     /*  938618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938630 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  938633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938642 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938658 */     GIR_RootConstrainSelectedInstOperands,
     /*  938659 */     // GIR_Coverage, 16658,
     /*  938659 */     GIR_EraseRootFromParent_Done,
     /*  938660 */   // Label 14196: @938660
     /*  938660 */   GIM_Try, /*On fail goto*//*Label 14197*/ GIMT_Encode4(938754), // Rule ID 16659 //
     /*  938665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  938676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  938679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  938682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938712 */     // MIs[1] Operand 1
     /*  938712 */     // No operand predicates
     /*  938712 */     // MIs[0] round
     /*  938712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938724 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  938727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938736 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938752 */     GIR_RootConstrainSelectedInstOperands,
     /*  938753 */     // GIR_Coverage, 16659,
     /*  938753 */     GIR_EraseRootFromParent_Done,
     /*  938754 */   // Label 14197: @938754
     /*  938754 */   GIM_Try, /*On fail goto*//*Label 14198*/ GIMT_Encode4(938848), // Rule ID 16662 //
     /*  938759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  938770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  938773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  938776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938806 */     // MIs[1] Operand 1
     /*  938806 */     // No operand predicates
     /*  938806 */     // MIs[0] round
     /*  938806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  938821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938830 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938846 */     GIR_RootConstrainSelectedInstOperands,
     /*  938847 */     // GIR_Coverage, 16662,
     /*  938847 */     GIR_EraseRootFromParent_Done,
     /*  938848 */   // Label 14198: @938848
     /*  938848 */   GIM_Try, /*On fail goto*//*Label 14199*/ GIMT_Encode4(938942), // Rule ID 16663 //
     /*  938853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  938864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  938867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  938870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938900 */     // MIs[1] Operand 1
     /*  938900 */     // No operand predicates
     /*  938900 */     // MIs[0] round
     /*  938900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938912 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  938915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938924 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938940 */     GIR_RootConstrainSelectedInstOperands,
     /*  938941 */     // GIR_Coverage, 16663,
     /*  938941 */     GIR_EraseRootFromParent_Done,
     /*  938942 */   // Label 14199: @938942
     /*  938942 */   GIM_Try, /*On fail goto*//*Label 14200*/ GIMT_Encode4(939036), // Rule ID 16666 //
     /*  938947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  938958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  938961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  938964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938994 */     // MIs[1] Operand 1
     /*  938994 */     // No operand predicates
     /*  938994 */     // MIs[0] round
     /*  938994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  939006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939018 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939034 */     GIR_RootConstrainSelectedInstOperands,
     /*  939035 */     // GIR_Coverage, 16666,
     /*  939035 */     GIR_EraseRootFromParent_Done,
     /*  939036 */   // Label 14200: @939036
     /*  939036 */   GIM_Try, /*On fail goto*//*Label 14201*/ GIMT_Encode4(939130), // Rule ID 16667 //
     /*  939041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  939052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  939055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  939058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939088 */     // MIs[1] Operand 1
     /*  939088 */     // No operand predicates
     /*  939088 */     // MIs[0] round
     /*  939088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939100 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939112 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939128 */     GIR_RootConstrainSelectedInstOperands,
     /*  939129 */     // GIR_Coverage, 16667,
     /*  939129 */     GIR_EraseRootFromParent_Done,
     /*  939130 */   // Label 14201: @939130
     /*  939130 */   GIM_Try, /*On fail goto*//*Label 14202*/ GIMT_Encode4(939224), // Rule ID 16670 //
     /*  939135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  939146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  939149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  939152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939182 */     // MIs[1] Operand 1
     /*  939182 */     // No operand predicates
     /*  939182 */     // MIs[0] round
     /*  939182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939194 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  939194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  939197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939206 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939222 */     GIR_RootConstrainSelectedInstOperands,
     /*  939223 */     // GIR_Coverage, 16670,
     /*  939223 */     GIR_EraseRootFromParent_Done,
     /*  939224 */   // Label 14202: @939224
     /*  939224 */   GIM_Try, /*On fail goto*//*Label 14203*/ GIMT_Encode4(939318), // Rule ID 16671 //
     /*  939229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  939240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  939243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  939246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939276 */     // MIs[1] Operand 1
     /*  939276 */     // No operand predicates
     /*  939276 */     // MIs[0] round
     /*  939276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939288 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  939291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939300 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939316 */     GIR_RootConstrainSelectedInstOperands,
     /*  939317 */     // GIR_Coverage, 16671,
     /*  939317 */     GIR_EraseRootFromParent_Done,
     /*  939318 */   // Label 14203: @939318
     /*  939318 */   GIM_Try, /*On fail goto*//*Label 14204*/ GIMT_Encode4(939412), // Rule ID 16674 //
     /*  939323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  939334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  939337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  939340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939370 */     // MIs[1] Operand 1
     /*  939370 */     // No operand predicates
     /*  939370 */     // MIs[0] round
     /*  939370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939382 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  939385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939394 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939410 */     GIR_RootConstrainSelectedInstOperands,
     /*  939411 */     // GIR_Coverage, 16674,
     /*  939411 */     GIR_EraseRootFromParent_Done,
     /*  939412 */   // Label 14204: @939412
     /*  939412 */   GIM_Try, /*On fail goto*//*Label 14205*/ GIMT_Encode4(939506), // Rule ID 16675 //
     /*  939417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  939428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  939431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  939434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939464 */     // MIs[1] Operand 1
     /*  939464 */     // No operand predicates
     /*  939464 */     // MIs[0] round
     /*  939464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939476 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  939479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939488 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939504 */     GIR_RootConstrainSelectedInstOperands,
     /*  939505 */     // GIR_Coverage, 16675,
     /*  939505 */     GIR_EraseRootFromParent_Done,
     /*  939506 */   // Label 14205: @939506
     /*  939506 */   GIM_Try, /*On fail goto*//*Label 14206*/ GIMT_Encode4(939600), // Rule ID 16678 //
     /*  939511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  939522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  939525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  939528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939558 */     // MIs[1] Operand 1
     /*  939558 */     // No operand predicates
     /*  939558 */     // MIs[0] round
     /*  939558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939570 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939582 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939598 */     GIR_RootConstrainSelectedInstOperands,
     /*  939599 */     // GIR_Coverage, 16678,
     /*  939599 */     GIR_EraseRootFromParent_Done,
     /*  939600 */   // Label 14206: @939600
     /*  939600 */   GIM_Try, /*On fail goto*//*Label 14207*/ GIMT_Encode4(939694), // Rule ID 16679 //
     /*  939605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  939616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  939619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  939622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939652 */     // MIs[1] Operand 1
     /*  939652 */     // No operand predicates
     /*  939652 */     // MIs[0] round
     /*  939652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939664 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939676 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939692 */     GIR_RootConstrainSelectedInstOperands,
     /*  939693 */     // GIR_Coverage, 16679,
     /*  939693 */     GIR_EraseRootFromParent_Done,
     /*  939694 */   // Label 14207: @939694
     /*  939694 */   GIM_Try, /*On fail goto*//*Label 14208*/ GIMT_Encode4(939788), // Rule ID 16682 //
     /*  939699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  939710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  939713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  939716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939746 */     // MIs[1] Operand 1
     /*  939746 */     // No operand predicates
     /*  939746 */     // MIs[0] round
     /*  939746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939758 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  939761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939770 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939786 */     GIR_RootConstrainSelectedInstOperands,
     /*  939787 */     // GIR_Coverage, 16682,
     /*  939787 */     GIR_EraseRootFromParent_Done,
     /*  939788 */   // Label 14208: @939788
     /*  939788 */   GIM_Try, /*On fail goto*//*Label 14209*/ GIMT_Encode4(939882), // Rule ID 16683 //
     /*  939793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  939804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  939807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  939810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939840 */     // MIs[1] Operand 1
     /*  939840 */     // No operand predicates
     /*  939840 */     // MIs[0] round
     /*  939840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  939855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939864 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939880 */     GIR_RootConstrainSelectedInstOperands,
     /*  939881 */     // GIR_Coverage, 16683,
     /*  939881 */     GIR_EraseRootFromParent_Done,
     /*  939882 */   // Label 14209: @939882
     /*  939882 */   GIM_Try, /*On fail goto*//*Label 14210*/ GIMT_Encode4(939976), // Rule ID 16686 //
     /*  939887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  939898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  939901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  939904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939934 */     // MIs[1] Operand 1
     /*  939934 */     // No operand predicates
     /*  939934 */     // MIs[0] round
     /*  939934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939946 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939958 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939974 */     GIR_RootConstrainSelectedInstOperands,
     /*  939975 */     // GIR_Coverage, 16686,
     /*  939975 */     GIR_EraseRootFromParent_Done,
     /*  939976 */   // Label 14210: @939976
     /*  939976 */   GIM_Try, /*On fail goto*//*Label 14211*/ GIMT_Encode4(940070), // Rule ID 16687 //
     /*  939981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  939992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  939995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  939998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940024 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940028 */     // MIs[1] Operand 1
     /*  940028 */     // No operand predicates
     /*  940028 */     // MIs[0] round
     /*  940028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940040 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  940043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940052 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940068 */     GIR_RootConstrainSelectedInstOperands,
     /*  940069 */     // GIR_Coverage, 16687,
     /*  940069 */     GIR_EraseRootFromParent_Done,
     /*  940070 */   // Label 14211: @940070
     /*  940070 */   GIM_Try, /*On fail goto*//*Label 14212*/ GIMT_Encode4(940164), // Rule ID 16690 //
     /*  940075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  940086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  940089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  940092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940122 */     // MIs[1] Operand 1
     /*  940122 */     // No operand predicates
     /*  940122 */     // MIs[0] round
     /*  940122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  940134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940146 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940162 */     GIR_RootConstrainSelectedInstOperands,
     /*  940163 */     // GIR_Coverage, 16690,
     /*  940163 */     GIR_EraseRootFromParent_Done,
     /*  940164 */   // Label 14212: @940164
     /*  940164 */   GIM_Try, /*On fail goto*//*Label 14213*/ GIMT_Encode4(940258), // Rule ID 16691 //
     /*  940169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  940180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  940183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  940186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940216 */     // MIs[1] Operand 1
     /*  940216 */     // No operand predicates
     /*  940216 */     // MIs[0] round
     /*  940216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940228 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940240 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940256 */     GIR_RootConstrainSelectedInstOperands,
     /*  940257 */     // GIR_Coverage, 16691,
     /*  940257 */     GIR_EraseRootFromParent_Done,
     /*  940258 */   // Label 14213: @940258
     /*  940258 */   GIM_Try, /*On fail goto*//*Label 14214*/ GIMT_Encode4(940352), // Rule ID 16694 //
     /*  940263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  940280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940310 */     // MIs[1] Operand 1
     /*  940310 */     // No operand predicates
     /*  940310 */     // MIs[0] round
     /*  940310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  940325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940334 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940350 */     GIR_RootConstrainSelectedInstOperands,
     /*  940351 */     // GIR_Coverage, 16694,
     /*  940351 */     GIR_EraseRootFromParent_Done,
     /*  940352 */   // Label 14214: @940352
     /*  940352 */   GIM_Try, /*On fail goto*//*Label 14215*/ GIMT_Encode4(940446), // Rule ID 16695 //
     /*  940357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  940374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940404 */     // MIs[1] Operand 1
     /*  940404 */     // No operand predicates
     /*  940404 */     // MIs[0] round
     /*  940404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  940419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940428 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940444 */     GIR_RootConstrainSelectedInstOperands,
     /*  940445 */     // GIR_Coverage, 16695,
     /*  940445 */     GIR_EraseRootFromParent_Done,
     /*  940446 */   // Label 14215: @940446
     /*  940446 */   GIM_Try, /*On fail goto*//*Label 14216*/ GIMT_Encode4(940540), // Rule ID 16698 //
     /*  940451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  940468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940498 */     // MIs[1] Operand 1
     /*  940498 */     // No operand predicates
     /*  940498 */     // MIs[0] round
     /*  940498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940510 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  940513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940522 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940538 */     GIR_RootConstrainSelectedInstOperands,
     /*  940539 */     // GIR_Coverage, 16698,
     /*  940539 */     GIR_EraseRootFromParent_Done,
     /*  940540 */   // Label 14216: @940540
     /*  940540 */   GIM_Try, /*On fail goto*//*Label 14217*/ GIMT_Encode4(940634), // Rule ID 16699 //
     /*  940545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  940562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940592 */     // MIs[1] Operand 1
     /*  940592 */     // No operand predicates
     /*  940592 */     // MIs[0] round
     /*  940592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940604 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  940607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940616 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940632 */     GIR_RootConstrainSelectedInstOperands,
     /*  940633 */     // GIR_Coverage, 16699,
     /*  940633 */     GIR_EraseRootFromParent_Done,
     /*  940634 */   // Label 14217: @940634
     /*  940634 */   GIM_Try, /*On fail goto*//*Label 14218*/ GIMT_Encode4(940728), // Rule ID 16702 //
     /*  940639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  940656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940686 */     // MIs[1] Operand 1
     /*  940686 */     // No operand predicates
     /*  940686 */     // MIs[0] round
     /*  940686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  940701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940726 */     GIR_RootConstrainSelectedInstOperands,
     /*  940727 */     // GIR_Coverage, 16702,
     /*  940727 */     GIR_EraseRootFromParent_Done,
     /*  940728 */   // Label 14218: @940728
     /*  940728 */   GIM_Try, /*On fail goto*//*Label 14219*/ GIMT_Encode4(940822), // Rule ID 16703 //
     /*  940733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  940750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940780 */     // MIs[1] Operand 1
     /*  940780 */     // No operand predicates
     /*  940780 */     // MIs[0] round
     /*  940780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940792 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  940795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940804 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940820 */     GIR_RootConstrainSelectedInstOperands,
     /*  940821 */     // GIR_Coverage, 16703,
     /*  940821 */     GIR_EraseRootFromParent_Done,
     /*  940822 */   // Label 14219: @940822
     /*  940822 */   GIM_Try, /*On fail goto*//*Label 14220*/ GIMT_Encode4(940916), // Rule ID 16706 //
     /*  940827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  940838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  940841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  940844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940874 */     // MIs[1] Operand 1
     /*  940874 */     // No operand predicates
     /*  940874 */     // MIs[0] round
     /*  940874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940886 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940898 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940914 */     GIR_RootConstrainSelectedInstOperands,
     /*  940915 */     // GIR_Coverage, 16706,
     /*  940915 */     GIR_EraseRootFromParent_Done,
     /*  940916 */   // Label 14220: @940916
     /*  940916 */   GIM_Try, /*On fail goto*//*Label 14221*/ GIMT_Encode4(941010), // Rule ID 16707 //
     /*  940921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  940932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  940935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  940938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940968 */     // MIs[1] Operand 1
     /*  940968 */     // No operand predicates
     /*  940968 */     // MIs[0] round
     /*  940968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940992 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941008 */     GIR_RootConstrainSelectedInstOperands,
     /*  941009 */     // GIR_Coverage, 16707,
     /*  941009 */     GIR_EraseRootFromParent_Done,
     /*  941010 */   // Label 14221: @941010
     /*  941010 */   GIM_Try, /*On fail goto*//*Label 14222*/ GIMT_Encode4(941094), // Rule ID 2774 //
     /*  941015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  941026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  941029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  941032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  941035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941058 */     // MIs[0] round
     /*  941058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941070 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  941073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941092 */     GIR_RootConstrainSelectedInstOperands,
     /*  941093 */     // GIR_Coverage, 2774,
     /*  941093 */     GIR_EraseRootFromParent_Done,
     /*  941094 */   // Label 14222: @941094
     /*  941094 */   GIM_Try, /*On fail goto*//*Label 14223*/ GIMT_Encode4(941178), // Rule ID 2775 //
     /*  941099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  941110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  941113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  941116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  941119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941142 */     // MIs[0] round
     /*  941142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941154 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  941157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941176 */     GIR_RootConstrainSelectedInstOperands,
     /*  941177 */     // GIR_Coverage, 2775,
     /*  941177 */     GIR_EraseRootFromParent_Done,
     /*  941178 */   // Label 14223: @941178
     /*  941178 */   GIM_Try, /*On fail goto*//*Label 14224*/ GIMT_Encode4(941262), // Rule ID 17154 //
     /*  941183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  941194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  941197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  941200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  941203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941226 */     // MIs[0] round
     /*  941226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941238 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  941241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941260 */     GIR_RootConstrainSelectedInstOperands,
     /*  941261 */     // GIR_Coverage, 17154,
     /*  941261 */     GIR_EraseRootFromParent_Done,
     /*  941262 */   // Label 14224: @941262
     /*  941262 */   GIM_Try, /*On fail goto*//*Label 14225*/ GIMT_Encode4(941346), // Rule ID 17155 //
     /*  941267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  941278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  941281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  941284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  941287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941310 */     // MIs[0] round
     /*  941310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941322 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  941325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941344 */     GIR_RootConstrainSelectedInstOperands,
     /*  941345 */     // GIR_Coverage, 17155,
     /*  941345 */     GIR_EraseRootFromParent_Done,
     /*  941346 */   // Label 14225: @941346
     /*  941346 */   GIM_Try, /*On fail goto*//*Label 14226*/ GIMT_Encode4(941430), // Rule ID 17164 //
     /*  941351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  941362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  941365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  941368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  941371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941394 */     // MIs[0] round
     /*  941394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941406 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  941409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941428 */     GIR_RootConstrainSelectedInstOperands,
     /*  941429 */     // GIR_Coverage, 17164,
     /*  941429 */     GIR_EraseRootFromParent_Done,
     /*  941430 */   // Label 14226: @941430
     /*  941430 */   GIM_Try, /*On fail goto*//*Label 14227*/ GIMT_Encode4(941514), // Rule ID 17165 //
     /*  941435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  941446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  941449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  941452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  941455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941478 */     // MIs[0] round
     /*  941478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941490 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  941493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941512 */     GIR_RootConstrainSelectedInstOperands,
     /*  941513 */     // GIR_Coverage, 17165,
     /*  941513 */     GIR_EraseRootFromParent_Done,
     /*  941514 */   // Label 14227: @941514
     /*  941514 */   GIM_Try, /*On fail goto*//*Label 14228*/ GIMT_Encode4(941598), // Rule ID 17174 //
     /*  941519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  941536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  941539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941562 */     // MIs[0] round
     /*  941562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941574 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  941577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941596 */     GIR_RootConstrainSelectedInstOperands,
     /*  941597 */     // GIR_Coverage, 17174,
     /*  941597 */     GIR_EraseRootFromParent_Done,
     /*  941598 */   // Label 14228: @941598
     /*  941598 */   GIM_Try, /*On fail goto*//*Label 14229*/ GIMT_Encode4(941682), // Rule ID 17175 //
     /*  941603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  941620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  941623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941646 */     // MIs[0] round
     /*  941646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941658 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  941661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941680 */     GIR_RootConstrainSelectedInstOperands,
     /*  941681 */     // GIR_Coverage, 17175,
     /*  941681 */     GIR_EraseRootFromParent_Done,
     /*  941682 */   // Label 14229: @941682
     /*  941682 */   GIM_Try, /*On fail goto*//*Label 14230*/ GIMT_Encode4(941766), // Rule ID 17184 //
     /*  941687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  941698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  941701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  941704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  941707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941730 */     // MIs[0] round
     /*  941730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941742 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  941745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941764 */     GIR_RootConstrainSelectedInstOperands,
     /*  941765 */     // GIR_Coverage, 17184,
     /*  941765 */     GIR_EraseRootFromParent_Done,
     /*  941766 */   // Label 14230: @941766
     /*  941766 */   GIM_Try, /*On fail goto*//*Label 14231*/ GIMT_Encode4(941850), // Rule ID 17185 //
     /*  941771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  941782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  941785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  941788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  941791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941814 */     // MIs[0] round
     /*  941814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941826 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  941829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941848 */     GIR_RootConstrainSelectedInstOperands,
     /*  941849 */     // GIR_Coverage, 17185,
     /*  941849 */     GIR_EraseRootFromParent_Done,
     /*  941850 */   // Label 14231: @941850
     /*  941850 */   GIM_Try, /*On fail goto*//*Label 14232*/ GIMT_Encode4(941934), // Rule ID 17194 //
     /*  941855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  941866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  941869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  941872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  941875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941898 */     // MIs[0] round
     /*  941898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941910 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  941913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941932 */     GIR_RootConstrainSelectedInstOperands,
     /*  941933 */     // GIR_Coverage, 17194,
     /*  941933 */     GIR_EraseRootFromParent_Done,
     /*  941934 */   // Label 14232: @941934
     /*  941934 */   GIM_Try, /*On fail goto*//*Label 14233*/ GIMT_Encode4(942018), // Rule ID 17195 //
     /*  941939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  941950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  941953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  941956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  941959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941982 */     // MIs[0] round
     /*  941982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941994 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  941994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  941997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942016 */     GIR_RootConstrainSelectedInstOperands,
     /*  942017 */     // GIR_Coverage, 17195,
     /*  942017 */     GIR_EraseRootFromParent_Done,
     /*  942018 */   // Label 14233: @942018
     /*  942018 */   GIM_Try, /*On fail goto*//*Label 14234*/ GIMT_Encode4(942102), // Rule ID 17204 //
     /*  942023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  942026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  942031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  942034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  942037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  942040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  942043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942066 */     // MIs[0] round
     /*  942066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942078 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  942078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  942081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942100 */     GIR_RootConstrainSelectedInstOperands,
     /*  942101 */     // GIR_Coverage, 17204,
     /*  942101 */     GIR_EraseRootFromParent_Done,
     /*  942102 */   // Label 14234: @942102
     /*  942102 */   GIM_Try, /*On fail goto*//*Label 14235*/ GIMT_Encode4(942186), // Rule ID 17205 //
     /*  942107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  942110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  942115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  942118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  942121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  942124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  942127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942150 */     // MIs[0] round
     /*  942150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942162 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  942162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  942165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942184 */     GIR_RootConstrainSelectedInstOperands,
     /*  942185 */     // GIR_Coverage, 17205,
     /*  942185 */     GIR_EraseRootFromParent_Done,
     /*  942186 */   // Label 14235: @942186
     /*  942186 */   GIM_Try, /*On fail goto*//*Label 14236*/ GIMT_Encode4(942270), // Rule ID 17214 //
     /*  942191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  942194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  942199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  942202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  942205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  942208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  942211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942234 */     // MIs[0] round
     /*  942234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942246 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  942246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  942249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942268 */     GIR_RootConstrainSelectedInstOperands,
     /*  942269 */     // GIR_Coverage, 17214,
     /*  942269 */     GIR_EraseRootFromParent_Done,
     /*  942270 */   // Label 14236: @942270
     /*  942270 */   GIM_Try, /*On fail goto*//*Label 14237*/ GIMT_Encode4(942354), // Rule ID 17215 //
     /*  942275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  942278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  942283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  942286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  942289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  942292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  942295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942318 */     // MIs[0] round
     /*  942318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942330 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  942330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  942333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942352 */     GIR_RootConstrainSelectedInstOperands,
     /*  942353 */     // GIR_Coverage, 17215,
     /*  942353 */     GIR_EraseRootFromParent_Done,
     /*  942354 */   // Label 14237: @942354
     /*  942354 */   GIM_Try, /*On fail goto*//*Label 14238*/ GIMT_Encode4(942438), // Rule ID 17224 //
     /*  942359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  942362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  942367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  942370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  942373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  942376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  942379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942402 */     // MIs[0] round
     /*  942402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942414 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  942414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  942417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942436 */     GIR_RootConstrainSelectedInstOperands,
     /*  942437 */     // GIR_Coverage, 17224,
     /*  942437 */     GIR_EraseRootFromParent_Done,
     /*  942438 */   // Label 14238: @942438
     /*  942438 */   GIM_Try, /*On fail goto*//*Label 14239*/ GIMT_Encode4(942522), // Rule ID 17225 //
     /*  942443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  942446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  942451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  942454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  942457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  942460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  942463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942486 */     // MIs[0] round
     /*  942486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942498 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11336:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  942498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  942501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942520 */     GIR_RootConstrainSelectedInstOperands,
     /*  942521 */     // GIR_Coverage, 17225,
     /*  942521 */     GIR_EraseRootFromParent_Done,
     /*  942522 */   // Label 14239: @942522
     /*  942522 */   GIM_Try, /*On fail goto*//*Label 14240*/ GIMT_Encode4(942606), // Rule ID 17270 //
     /*  942527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  942538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  942541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  942544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  942547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942570 */     // MIs[0] round
     /*  942570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942582 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  942585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942604 */     GIR_RootConstrainSelectedInstOperands,
     /*  942605 */     // GIR_Coverage, 17270,
     /*  942605 */     GIR_EraseRootFromParent_Done,
     /*  942606 */   // Label 14240: @942606
     /*  942606 */   GIM_Try, /*On fail goto*//*Label 14241*/ GIMT_Encode4(942690), // Rule ID 17271 //
     /*  942611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  942622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  942625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  942628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  942631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942654 */     // MIs[0] round
     /*  942654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942666 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  942669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942688 */     GIR_RootConstrainSelectedInstOperands,
     /*  942689 */     // GIR_Coverage, 17271,
     /*  942689 */     GIR_EraseRootFromParent_Done,
     /*  942690 */   // Label 14241: @942690
     /*  942690 */   GIM_Try, /*On fail goto*//*Label 14242*/ GIMT_Encode4(942774), // Rule ID 17280 //
     /*  942695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  942706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  942709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  942712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  942715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942738 */     // MIs[0] round
     /*  942738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942750 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  942753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942772 */     GIR_RootConstrainSelectedInstOperands,
     /*  942773 */     // GIR_Coverage, 17280,
     /*  942773 */     GIR_EraseRootFromParent_Done,
     /*  942774 */   // Label 14242: @942774
     /*  942774 */   GIM_Try, /*On fail goto*//*Label 14243*/ GIMT_Encode4(942858), // Rule ID 17281 //
     /*  942779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  942790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  942793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  942796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  942799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942822 */     // MIs[0] round
     /*  942822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942834 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  942837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942856 */     GIR_RootConstrainSelectedInstOperands,
     /*  942857 */     // GIR_Coverage, 17281,
     /*  942857 */     GIR_EraseRootFromParent_Done,
     /*  942858 */   // Label 14243: @942858
     /*  942858 */   GIM_Try, /*On fail goto*//*Label 14244*/ GIMT_Encode4(942942), // Rule ID 17290 //
     /*  942863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  942874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  942877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  942880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  942883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942906 */     // MIs[0] round
     /*  942906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942918 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  942921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942940 */     GIR_RootConstrainSelectedInstOperands,
     /*  942941 */     // GIR_Coverage, 17290,
     /*  942941 */     GIR_EraseRootFromParent_Done,
     /*  942942 */   // Label 14244: @942942
     /*  942942 */   GIM_Try, /*On fail goto*//*Label 14245*/ GIMT_Encode4(943026), // Rule ID 17291 //
     /*  942947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  942958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  942961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  942964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  942967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942990 */     // MIs[0] round
     /*  942990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943002 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  943002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  943005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943024 */     GIR_RootConstrainSelectedInstOperands,
     /*  943025 */     // GIR_Coverage, 17291,
     /*  943025 */     GIR_EraseRootFromParent_Done,
     /*  943026 */   // Label 14245: @943026
     /*  943026 */   GIM_Try, /*On fail goto*//*Label 14246*/ GIMT_Encode4(943110), // Rule ID 17300 //
     /*  943031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  943034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  943042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  943045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  943048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  943051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943074 */     // MIs[0] round
     /*  943074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943086 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  943086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  943089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943108 */     GIR_RootConstrainSelectedInstOperands,
     /*  943109 */     // GIR_Coverage, 17300,
     /*  943109 */     GIR_EraseRootFromParent_Done,
     /*  943110 */   // Label 14246: @943110
     /*  943110 */   GIM_Try, /*On fail goto*//*Label 14247*/ GIMT_Encode4(943194), // Rule ID 17301 //
     /*  943115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  943118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  943126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  943129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  943132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  943135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943158 */     // MIs[0] round
     /*  943158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943170 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  943170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  943173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943192 */     GIR_RootConstrainSelectedInstOperands,
     /*  943193 */     // GIR_Coverage, 17301,
     /*  943193 */     GIR_EraseRootFromParent_Done,
     /*  943194 */   // Label 14247: @943194
     /*  943194 */   GIM_Try, /*On fail goto*//*Label 14248*/ GIMT_Encode4(943278), // Rule ID 17310 //
     /*  943199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  943202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  943210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  943213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  943216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  943219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943242 */     // MIs[0] round
     /*  943242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943254 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  943254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  943257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943276 */     GIR_RootConstrainSelectedInstOperands,
     /*  943277 */     // GIR_Coverage, 17310,
     /*  943277 */     GIR_EraseRootFromParent_Done,
     /*  943278 */   // Label 14248: @943278
     /*  943278 */   GIM_Try, /*On fail goto*//*Label 14249*/ GIMT_Encode4(943362), // Rule ID 17311 //
     /*  943283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  943286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  943294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  943297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  943300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  943303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943326 */     // MIs[0] round
     /*  943326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943338 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  943338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  943341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943360 */     GIR_RootConstrainSelectedInstOperands,
     /*  943361 */     // GIR_Coverage, 17311,
     /*  943361 */     GIR_EraseRootFromParent_Done,
     /*  943362 */   // Label 14249: @943362
     /*  943362 */   GIM_Try, /*On fail goto*//*Label 14250*/ GIMT_Encode4(943446), // Rule ID 17320 //
     /*  943367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  943378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  943381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  943384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  943387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943410 */     // MIs[0] round
     /*  943410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943422 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  943425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943444 */     GIR_RootConstrainSelectedInstOperands,
     /*  943445 */     // GIR_Coverage, 17320,
     /*  943445 */     GIR_EraseRootFromParent_Done,
     /*  943446 */   // Label 14250: @943446
     /*  943446 */   GIM_Try, /*On fail goto*//*Label 14251*/ GIMT_Encode4(943530), // Rule ID 17321 //
     /*  943451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  943462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  943465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  943468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  943471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943494 */     // MIs[0] round
     /*  943494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943506 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  943509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943528 */     GIR_RootConstrainSelectedInstOperands,
     /*  943529 */     // GIR_Coverage, 17321,
     /*  943529 */     GIR_EraseRootFromParent_Done,
     /*  943530 */   // Label 14251: @943530
     /*  943530 */   GIM_Try, /*On fail goto*//*Label 14252*/ GIMT_Encode4(943614), // Rule ID 17330 //
     /*  943535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  943546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  943549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  943552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  943555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943578 */     // MIs[0] round
     /*  943578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943590 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  943593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943612 */     GIR_RootConstrainSelectedInstOperands,
     /*  943613 */     // GIR_Coverage, 17330,
     /*  943613 */     GIR_EraseRootFromParent_Done,
     /*  943614 */   // Label 14252: @943614
     /*  943614 */   GIM_Try, /*On fail goto*//*Label 14253*/ GIMT_Encode4(943698), // Rule ID 17331 //
     /*  943619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  943630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  943633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  943636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  943639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943662 */     // MIs[0] round
     /*  943662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943674 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  943677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943696 */     GIR_RootConstrainSelectedInstOperands,
     /*  943697 */     // GIR_Coverage, 17331,
     /*  943697 */     GIR_EraseRootFromParent_Done,
     /*  943698 */   // Label 14253: @943698
     /*  943698 */   GIM_Try, /*On fail goto*//*Label 14254*/ GIMT_Encode4(943782), // Rule ID 17340 //
     /*  943703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  943714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  943717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  943720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  943723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943746 */     // MIs[0] round
     /*  943746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943758 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  943761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943780 */     GIR_RootConstrainSelectedInstOperands,
     /*  943781 */     // GIR_Coverage, 17340,
     /*  943781 */     GIR_EraseRootFromParent_Done,
     /*  943782 */   // Label 14254: @943782
     /*  943782 */   GIM_Try, /*On fail goto*//*Label 14255*/ GIMT_Encode4(943866), // Rule ID 17341 //
     /*  943787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  943798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  943801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  943804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  943807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943830 */     // MIs[0] round
     /*  943830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943842 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  943845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943864 */     GIR_RootConstrainSelectedInstOperands,
     /*  943865 */     // GIR_Coverage, 17341,
     /*  943865 */     GIR_EraseRootFromParent_Done,
     /*  943866 */   // Label 14255: @943866
     /*  943866 */   GIM_Try, /*On fail goto*//*Label 14256*/ GIMT_Encode4(943950), // Rule ID 17350 //
     /*  943871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  943882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  943885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  943888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  943891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943914 */     // MIs[0] round
     /*  943914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943926 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  943929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943948 */     GIR_RootConstrainSelectedInstOperands,
     /*  943949 */     // GIR_Coverage, 17350,
     /*  943949 */     GIR_EraseRootFromParent_Done,
     /*  943950 */   // Label 14256: @943950
     /*  943950 */   GIM_Try, /*On fail goto*//*Label 14257*/ GIMT_Encode4(944034), // Rule ID 17351 //
     /*  943955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  943966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  943969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  943972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  943975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943998 */     // MIs[0] round
     /*  943998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944010 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11372:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  944010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  944013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944032 */     GIR_RootConstrainSelectedInstOperands,
     /*  944033 */     // GIR_Coverage, 17351,
     /*  944033 */     GIR_EraseRootFromParent_Done,
     /*  944034 */   // Label 14257: @944034
     /*  944034 */   GIM_Try, /*On fail goto*//*Label 14258*/ GIMT_Encode4(944116), // Rule ID 62845 //
     /*  944039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  944050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  944053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  944056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944066 */     // MIs[0] op1
     /*  944066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944093 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF8),
     /*  944096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944098 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944100 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944102 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944104 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944114 */     GIR_RootConstrainSelectedInstOperands,
     /*  944115 */     // GIR_Coverage, 62845,
     /*  944115 */     GIR_EraseRootFromParent_Done,
     /*  944116 */   // Label 14258: @944116
     /*  944116 */   GIM_Try, /*On fail goto*//*Label 14259*/ GIMT_Encode4(944198), // Rule ID 62846 //
     /*  944121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  944132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  944135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  944138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944148 */     // MIs[0] op1
     /*  944148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944151 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944175 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF8),
     /*  944178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944180 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944182 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944184 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944186 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944196 */     GIR_RootConstrainSelectedInstOperands,
     /*  944197 */     // GIR_Coverage, 62846,
     /*  944197 */     GIR_EraseRootFromParent_Done,
     /*  944198 */   // Label 14259: @944198
     /*  944198 */   GIM_Try, /*On fail goto*//*Label 14260*/ GIMT_Encode4(944280), // Rule ID 62875 //
     /*  944203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  944214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  944217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  944220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  944223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944230 */     // MIs[0] op1
     /*  944230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944257 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF8),
     /*  944260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944262 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944264 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944266 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944268 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944278 */     GIR_RootConstrainSelectedInstOperands,
     /*  944279 */     // GIR_Coverage, 62875,
     /*  944279 */     GIR_EraseRootFromParent_Done,
     /*  944280 */   // Label 14260: @944280
     /*  944280 */   GIM_Try, /*On fail goto*//*Label 14261*/ GIMT_Encode4(944362), // Rule ID 62876 //
     /*  944285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  944296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  944299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  944302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  944305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944312 */     // MIs[0] op1
     /*  944312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944339 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF8),
     /*  944342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944344 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944346 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944348 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944350 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944360 */     GIR_RootConstrainSelectedInstOperands,
     /*  944361 */     // GIR_Coverage, 62876,
     /*  944361 */     GIR_EraseRootFromParent_Done,
     /*  944362 */   // Label 14261: @944362
     /*  944362 */   GIM_Try, /*On fail goto*//*Label 14262*/ GIMT_Encode4(944444), // Rule ID 62907 //
     /*  944367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  944378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944394 */     // MIs[0] op1
     /*  944394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944397 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF4),
     /*  944424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944426 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944428 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944430 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944432 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944442 */     GIR_RootConstrainSelectedInstOperands,
     /*  944443 */     // GIR_Coverage, 62907,
     /*  944443 */     GIR_EraseRootFromParent_Done,
     /*  944444 */   // Label 14262: @944444
     /*  944444 */   GIM_Try, /*On fail goto*//*Label 14263*/ GIMT_Encode4(944526), // Rule ID 62908 //
     /*  944449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  944460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944476 */     // MIs[0] op1
     /*  944476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944479 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944503 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF4),
     /*  944506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944508 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944510 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944512 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944514 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944524 */     GIR_RootConstrainSelectedInstOperands,
     /*  944525 */     // GIR_Coverage, 62908,
     /*  944525 */     GIR_EraseRootFromParent_Done,
     /*  944526 */   // Label 14263: @944526
     /*  944526 */   GIM_Try, /*On fail goto*//*Label 14264*/ GIMT_Encode4(944608), // Rule ID 62919 //
     /*  944531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  944542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  944551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944558 */     // MIs[0] op1
     /*  944558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944585 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF4),
     /*  944588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944590 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944592 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944594 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944596 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944606 */     GIR_RootConstrainSelectedInstOperands,
     /*  944607 */     // GIR_Coverage, 62919,
     /*  944607 */     GIR_EraseRootFromParent_Done,
     /*  944608 */   // Label 14264: @944608
     /*  944608 */   GIM_Try, /*On fail goto*//*Label 14265*/ GIMT_Encode4(944690), // Rule ID 62920 //
     /*  944613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  944624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  944633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944640 */     // MIs[0] op1
     /*  944640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944667 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF4),
     /*  944670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944672 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944674 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944676 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944678 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944688 */     GIR_RootConstrainSelectedInstOperands,
     /*  944689 */     // GIR_Coverage, 62920,
     /*  944689 */     GIR_EraseRootFromParent_Done,
     /*  944690 */   // Label 14265: @944690
     /*  944690 */   GIM_Try, /*On fail goto*//*Label 14266*/ GIMT_Encode4(944772), // Rule ID 62951 //
     /*  944695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944722 */     // MIs[0] op1
     /*  944722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944725 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944749 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  944752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944754 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944756 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944758 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944760 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944770 */     GIR_RootConstrainSelectedInstOperands,
     /*  944771 */     // GIR_Coverage, 62951,
     /*  944771 */     GIR_EraseRootFromParent_Done,
     /*  944772 */   // Label 14266: @944772
     /*  944772 */   GIM_Try, /*On fail goto*//*Label 14267*/ GIMT_Encode4(944854), // Rule ID 62952 //
     /*  944777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944804 */     // MIs[0] op1
     /*  944804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944807 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944831 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  944834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944836 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944838 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944840 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944842 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944852 */     GIR_RootConstrainSelectedInstOperands,
     /*  944853 */     // GIR_Coverage, 62952,
     /*  944853 */     GIR_EraseRootFromParent_Done,
     /*  944854 */   // Label 14267: @944854
     /*  944854 */   GIM_Try, /*On fail goto*//*Label 14268*/ GIMT_Encode4(944936), // Rule ID 62963 //
     /*  944859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  944879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944886 */     // MIs[0] op1
     /*  944886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944913 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  944916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944918 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944920 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944922 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944924 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944934 */     GIR_RootConstrainSelectedInstOperands,
     /*  944935 */     // GIR_Coverage, 62963,
     /*  944935 */     GIR_EraseRootFromParent_Done,
     /*  944936 */   // Label 14268: @944936
     /*  944936 */   GIM_Try, /*On fail goto*//*Label 14269*/ GIMT_Encode4(945018), // Rule ID 62964 //
     /*  944941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  944961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944968 */     // MIs[0] op1
     /*  944968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944995 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  944998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945000 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945002 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945004 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945006 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  945016 */     GIR_RootConstrainSelectedInstOperands,
     /*  945017 */     // GIR_Coverage, 62964,
     /*  945017 */     GIR_EraseRootFromParent_Done,
     /*  945018 */   // Label 14269: @945018
     /*  945018 */   GIM_Try, /*On fail goto*//*Label 14270*/ GIMT_Encode4(945100), // Rule ID 62995 //
     /*  945023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  945034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  945037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945050 */     // MIs[0] op1
     /*  945050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945053 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945077 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF4),
     /*  945080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945082 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945084 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945086 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945088 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945098 */     GIR_RootConstrainSelectedInstOperands,
     /*  945099 */     // GIR_Coverage, 62995,
     /*  945099 */     GIR_EraseRootFromParent_Done,
     /*  945100 */   // Label 14270: @945100
     /*  945100 */   GIM_Try, /*On fail goto*//*Label 14271*/ GIMT_Encode4(945182), // Rule ID 62996 //
     /*  945105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  945116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  945119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945132 */     // MIs[0] op1
     /*  945132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945159 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF4),
     /*  945162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945164 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945166 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945168 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945170 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945180 */     GIR_RootConstrainSelectedInstOperands,
     /*  945181 */     // GIR_Coverage, 62996,
     /*  945181 */     GIR_EraseRootFromParent_Done,
     /*  945182 */   // Label 14271: @945182
     /*  945182 */   GIM_Try, /*On fail goto*//*Label 14272*/ GIMT_Encode4(945264), // Rule ID 63007 //
     /*  945187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  945198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  945201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  945207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945214 */     // MIs[0] op1
     /*  945214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945241 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF4),
     /*  945244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945246 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945248 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945250 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945252 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945262 */     GIR_RootConstrainSelectedInstOperands,
     /*  945263 */     // GIR_Coverage, 63007,
     /*  945263 */     GIR_EraseRootFromParent_Done,
     /*  945264 */   // Label 14272: @945264
     /*  945264 */   GIM_Try, /*On fail goto*//*Label 14273*/ GIMT_Encode4(945346), // Rule ID 63008 //
     /*  945269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  945280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  945283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  945289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945296 */     // MIs[0] op1
     /*  945296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945299 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945323 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF4),
     /*  945326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945328 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945330 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945332 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945334 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945344 */     GIR_RootConstrainSelectedInstOperands,
     /*  945345 */     // GIR_Coverage, 63008,
     /*  945345 */     GIR_EraseRootFromParent_Done,
     /*  945346 */   // Label 14273: @945346
     /*  945346 */   GIM_Try, /*On fail goto*//*Label 14274*/ GIMT_Encode4(945428), // Rule ID 63019 //
     /*  945351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  945362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  945365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  945371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945378 */     // MIs[0] op1
     /*  945378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945381 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945405 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_MF4),
     /*  945408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945410 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945412 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945414 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945416 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945426 */     GIR_RootConstrainSelectedInstOperands,
     /*  945427 */     // GIR_Coverage, 63019,
     /*  945427 */     GIR_EraseRootFromParent_Done,
     /*  945428 */   // Label 14274: @945428
     /*  945428 */   GIM_Try, /*On fail goto*//*Label 14275*/ GIMT_Encode4(945510), // Rule ID 63020 //
     /*  945433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  945444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  945447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  945453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945460 */     // MIs[0] op1
     /*  945460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945463 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945487 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_MF4),
     /*  945490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945492 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945494 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945496 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945498 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945508 */     GIR_RootConstrainSelectedInstOperands,
     /*  945509 */     // GIR_Coverage, 63020,
     /*  945509 */     GIR_EraseRootFromParent_Done,
     /*  945510 */   // Label 14275: @945510
     /*  945510 */   GIM_Try, /*On fail goto*//*Label 14276*/ GIMT_Encode4(945592), // Rule ID 63051 //
     /*  945515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945542 */     // MIs[0] op1
     /*  945542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945545 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945569 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  945572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945574 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945576 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945578 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945580 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945590 */     GIR_RootConstrainSelectedInstOperands,
     /*  945591 */     // GIR_Coverage, 63051,
     /*  945591 */     GIR_EraseRootFromParent_Done,
     /*  945592 */   // Label 14276: @945592
     /*  945592 */   GIM_Try, /*On fail goto*//*Label 14277*/ GIMT_Encode4(945674), // Rule ID 63052 //
     /*  945597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945624 */     // MIs[0] op1
     /*  945624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945651 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  945654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945656 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945658 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945660 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945662 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945672 */     GIR_RootConstrainSelectedInstOperands,
     /*  945673 */     // GIR_Coverage, 63052,
     /*  945673 */     GIR_EraseRootFromParent_Done,
     /*  945674 */   // Label 14277: @945674
     /*  945674 */   GIM_Try, /*On fail goto*//*Label 14278*/ GIMT_Encode4(945756), // Rule ID 63063 //
     /*  945679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  945699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945706 */     // MIs[0] op1
     /*  945706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945709 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945733 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  945736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945738 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945740 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945742 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945744 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945754 */     GIR_RootConstrainSelectedInstOperands,
     /*  945755 */     // GIR_Coverage, 63063,
     /*  945755 */     GIR_EraseRootFromParent_Done,
     /*  945756 */   // Label 14278: @945756
     /*  945756 */   GIM_Try, /*On fail goto*//*Label 14279*/ GIMT_Encode4(945838), // Rule ID 63064 //
     /*  945761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  945781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945788 */     // MIs[0] op1
     /*  945788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945791 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945815 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  945818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945820 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945822 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945824 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945826 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945836 */     GIR_RootConstrainSelectedInstOperands,
     /*  945837 */     // GIR_Coverage, 63064,
     /*  945837 */     GIR_EraseRootFromParent_Done,
     /*  945838 */   // Label 14279: @945838
     /*  945838 */   GIM_Try, /*On fail goto*//*Label 14280*/ GIMT_Encode4(945920), // Rule ID 63075 //
     /*  945843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  945863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945870 */     // MIs[0] op1
     /*  945870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945873 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945897 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_MF2),
     /*  945900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945902 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945904 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945906 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945908 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945918 */     GIR_RootConstrainSelectedInstOperands,
     /*  945919 */     // GIR_Coverage, 63075,
     /*  945919 */     GIR_EraseRootFromParent_Done,
     /*  945920 */   // Label 14280: @945920
     /*  945920 */   GIM_Try, /*On fail goto*//*Label 14281*/ GIMT_Encode4(946002), // Rule ID 63076 //
     /*  945925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  945945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945952 */     // MIs[0] op1
     /*  945952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945979 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_MF2),
     /*  945982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945984 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945986 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945988 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945990 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946000 */     GIR_RootConstrainSelectedInstOperands,
     /*  946001 */     // GIR_Coverage, 63076,
     /*  946001 */     GIR_EraseRootFromParent_Done,
     /*  946002 */   // Label 14281: @946002
     /*  946002 */   GIM_Try, /*On fail goto*//*Label 14282*/ GIMT_Encode4(946084), // Rule ID 63107 //
     /*  946007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  946018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  946021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946034 */     // MIs[0] op1
     /*  946034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946037 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946061 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  946061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  946064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946066 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946068 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946070 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946072 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946082 */     GIR_RootConstrainSelectedInstOperands,
     /*  946083 */     // GIR_Coverage, 63107,
     /*  946083 */     GIR_EraseRootFromParent_Done,
     /*  946084 */   // Label 14282: @946084
     /*  946084 */   GIM_Try, /*On fail goto*//*Label 14283*/ GIMT_Encode4(946166), // Rule ID 63108 //
     /*  946089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  946100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  946103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946116 */     // MIs[0] op1
     /*  946116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946143 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  946143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  946146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946148 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946150 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946152 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946154 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946164 */     GIR_RootConstrainSelectedInstOperands,
     /*  946165 */     // GIR_Coverage, 63108,
     /*  946165 */     GIR_EraseRootFromParent_Done,
     /*  946166 */   // Label 14283: @946166
     /*  946166 */   GIM_Try, /*On fail goto*//*Label 14284*/ GIMT_Encode4(946248), // Rule ID 63119 //
     /*  946171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  946182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  946185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  946191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946198 */     // MIs[0] op1
     /*  946198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946225 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  946225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  946228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946230 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946232 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946234 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946236 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946246 */     GIR_RootConstrainSelectedInstOperands,
     /*  946247 */     // GIR_Coverage, 63119,
     /*  946247 */     GIR_EraseRootFromParent_Done,
     /*  946248 */   // Label 14284: @946248
     /*  946248 */   GIM_Try, /*On fail goto*//*Label 14285*/ GIMT_Encode4(946330), // Rule ID 63120 //
     /*  946253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  946264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  946267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  946273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946280 */     // MIs[0] op1
     /*  946280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946307 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  946307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  946310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946312 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946314 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946316 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946318 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946328 */     GIR_RootConstrainSelectedInstOperands,
     /*  946329 */     // GIR_Coverage, 63120,
     /*  946329 */     GIR_EraseRootFromParent_Done,
     /*  946330 */   // Label 14285: @946330
     /*  946330 */   GIM_Try, /*On fail goto*//*Label 14286*/ GIMT_Encode4(946412), // Rule ID 63131 //
     /*  946335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  946343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  946346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  946349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946362 */     // MIs[0] op1
     /*  946362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946365 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  946370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  946382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946389 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  946389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_MF2),
     /*  946392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946394 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946396 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946398 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946400 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946410 */     GIR_RootConstrainSelectedInstOperands,
     /*  946411 */     // GIR_Coverage, 63131,
     /*  946411 */     GIR_EraseRootFromParent_Done,
     /*  946412 */   // Label 14286: @946412
     /*  946412 */   GIM_Try, /*On fail goto*//*Label 14287*/ GIMT_Encode4(946494), // Rule ID 63132 //
     /*  946417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  946425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  946428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  946431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946444 */     // MIs[0] op1
     /*  946444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946447 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  946452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  946464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946471 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  946471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_MF2),
     /*  946474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946476 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946478 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946480 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946482 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946492 */     GIR_RootConstrainSelectedInstOperands,
     /*  946493 */     // GIR_Coverage, 63132,
     /*  946493 */     GIR_EraseRootFromParent_Done,
     /*  946494 */   // Label 14287: @946494
     /*  946494 */   GIM_Try, /*On fail goto*//*Label 14288*/ GIMT_Encode4(946576), // Rule ID 63163 //
     /*  946499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946526 */     // MIs[0] op1
     /*  946526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946529 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946553 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  946553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946558 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946560 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946562 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946564 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946574 */     GIR_RootConstrainSelectedInstOperands,
     /*  946575 */     // GIR_Coverage, 63163,
     /*  946575 */     GIR_EraseRootFromParent_Done,
     /*  946576 */   // Label 14288: @946576
     /*  946576 */   GIM_Try, /*On fail goto*//*Label 14289*/ GIMT_Encode4(946658), // Rule ID 63164 //
     /*  946581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946608 */     // MIs[0] op1
     /*  946608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946635 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  946635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946640 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946642 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946644 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946646 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946656 */     GIR_RootConstrainSelectedInstOperands,
     /*  946657 */     // GIR_Coverage, 63164,
     /*  946657 */     GIR_EraseRootFromParent_Done,
     /*  946658 */   // Label 14289: @946658
     /*  946658 */   GIM_Try, /*On fail goto*//*Label 14290*/ GIMT_Encode4(946740), // Rule ID 63175 //
     /*  946663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  946683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946690 */     // MIs[0] op1
     /*  946690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946717 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  946717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  946720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946722 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946724 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946726 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946728 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946738 */     GIR_RootConstrainSelectedInstOperands,
     /*  946739 */     // GIR_Coverage, 63175,
     /*  946739 */     GIR_EraseRootFromParent_Done,
     /*  946740 */   // Label 14290: @946740
     /*  946740 */   GIM_Try, /*On fail goto*//*Label 14291*/ GIMT_Encode4(946822), // Rule ID 63176 //
     /*  946745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  946765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946772 */     // MIs[0] op1
     /*  946772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946799 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  946799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  946802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946804 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946806 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946808 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946810 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946820 */     GIR_RootConstrainSelectedInstOperands,
     /*  946821 */     // GIR_Coverage, 63176,
     /*  946821 */     GIR_EraseRootFromParent_Done,
     /*  946822 */   // Label 14291: @946822
     /*  946822 */   GIM_Try, /*On fail goto*//*Label 14292*/ GIMT_Encode4(946904), // Rule ID 63207 //
     /*  946827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946854 */     // MIs[0] op1
     /*  946854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946857 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946881 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  946881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946886 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946888 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946890 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946892 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946902 */     GIR_RootConstrainSelectedInstOperands,
     /*  946903 */     // GIR_Coverage, 63207,
     /*  946903 */     GIR_EraseRootFromParent_Done,
     /*  946904 */   // Label 14292: @946904
     /*  946904 */   GIM_Try, /*On fail goto*//*Label 14293*/ GIMT_Encode4(946986), // Rule ID 63208 //
     /*  946909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946936 */     // MIs[0] op1
     /*  946936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946963 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  946963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946968 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946970 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946972 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946974 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946984 */     GIR_RootConstrainSelectedInstOperands,
     /*  946985 */     // GIR_Coverage, 63208,
     /*  946985 */     GIR_EraseRootFromParent_Done,
     /*  946986 */   // Label 14293: @946986
     /*  946986 */   GIM_Try, /*On fail goto*//*Label 14294*/ GIMT_Encode4(947068), // Rule ID 63219 //
     /*  946991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  947002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  947005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  947008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  947011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947018 */     // MIs[0] op1
     /*  947018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947045 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  947045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  947048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947050 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947052 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947054 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947056 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947066 */     GIR_RootConstrainSelectedInstOperands,
     /*  947067 */     // GIR_Coverage, 63219,
     /*  947067 */     GIR_EraseRootFromParent_Done,
     /*  947068 */   // Label 14294: @947068
     /*  947068 */   GIM_Try, /*On fail goto*//*Label 14295*/ GIMT_Encode4(947150), // Rule ID 63220 //
     /*  947073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  947084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  947087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  947090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  947093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947100 */     // MIs[0] op1
     /*  947100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  947127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  947130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947132 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947134 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947136 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947138 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947148 */     GIR_RootConstrainSelectedInstOperands,
     /*  947149 */     // GIR_Coverage, 63220,
     /*  947149 */     GIR_EraseRootFromParent_Done,
     /*  947150 */   // Label 14295: @947150
     /*  947150 */   GIM_Try, /*On fail goto*//*Label 14296*/ GIMT_Encode4(947232), // Rule ID 63231 //
     /*  947155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  947166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  947169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  947172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  947175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947182 */     // MIs[0] op1
     /*  947182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  947202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947209 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  947209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M1),
     /*  947212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947214 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947216 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947218 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947220 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947230 */     GIR_RootConstrainSelectedInstOperands,
     /*  947231 */     // GIR_Coverage, 63231,
     /*  947231 */     GIR_EraseRootFromParent_Done,
     /*  947232 */   // Label 14296: @947232
     /*  947232 */   GIM_Try, /*On fail goto*//*Label 14297*/ GIMT_Encode4(947314), // Rule ID 63232 //
     /*  947237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  947248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  947251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  947254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  947257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947264 */     // MIs[0] op1
     /*  947264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  947284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947291 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  947291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M1),
     /*  947294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947296 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947298 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947300 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947302 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947312 */     GIR_RootConstrainSelectedInstOperands,
     /*  947313 */     // GIR_Coverage, 63232,
     /*  947313 */     GIR_EraseRootFromParent_Done,
     /*  947314 */   // Label 14297: @947314
     /*  947314 */   GIM_Try, /*On fail goto*//*Label 14298*/ GIMT_Encode4(947396), // Rule ID 63263 //
     /*  947319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947346 */     // MIs[0] op1
     /*  947346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947349 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947373 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  947373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  947376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947378 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947380 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947382 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947384 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947394 */     GIR_RootConstrainSelectedInstOperands,
     /*  947395 */     // GIR_Coverage, 63263,
     /*  947395 */     GIR_EraseRootFromParent_Done,
     /*  947396 */   // Label 14298: @947396
     /*  947396 */   GIM_Try, /*On fail goto*//*Label 14299*/ GIMT_Encode4(947478), // Rule ID 63264 //
     /*  947401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947428 */     // MIs[0] op1
     /*  947428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947431 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947455 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  947455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  947458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947460 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947462 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947464 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947466 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947476 */     GIR_RootConstrainSelectedInstOperands,
     /*  947477 */     // GIR_Coverage, 63264,
     /*  947477 */     GIR_EraseRootFromParent_Done,
     /*  947478 */   // Label 14299: @947478
     /*  947478 */   GIM_Try, /*On fail goto*//*Label 14300*/ GIMT_Encode4(947560), // Rule ID 63275 //
     /*  947483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  947503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947510 */     // MIs[0] op1
     /*  947510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947537 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  947537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  947540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947542 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947544 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947546 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947548 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947558 */     GIR_RootConstrainSelectedInstOperands,
     /*  947559 */     // GIR_Coverage, 63275,
     /*  947559 */     GIR_EraseRootFromParent_Done,
     /*  947560 */   // Label 14300: @947560
     /*  947560 */   GIM_Try, /*On fail goto*//*Label 14301*/ GIMT_Encode4(947642), // Rule ID 63276 //
     /*  947565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  947585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947592 */     // MIs[0] op1
     /*  947592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947619 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  947619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  947622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947624 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947626 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947628 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947630 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947640 */     GIR_RootConstrainSelectedInstOperands,
     /*  947641 */     // GIR_Coverage, 63276,
     /*  947641 */     GIR_EraseRootFromParent_Done,
     /*  947642 */   // Label 14301: @947642
     /*  947642 */   GIM_Try, /*On fail goto*//*Label 14302*/ GIMT_Encode4(947724), // Rule ID 63287 //
     /*  947647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947674 */     // MIs[0] op1
     /*  947674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  947694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947701 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  947701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M1),
     /*  947704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947706 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947708 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947710 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947712 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947722 */     GIR_RootConstrainSelectedInstOperands,
     /*  947723 */     // GIR_Coverage, 63287,
     /*  947723 */     GIR_EraseRootFromParent_Done,
     /*  947724 */   // Label 14302: @947724
     /*  947724 */   GIM_Try, /*On fail goto*//*Label 14303*/ GIMT_Encode4(947806), // Rule ID 63288 //
     /*  947729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947756 */     // MIs[0] op1
     /*  947756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  947776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947783 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  947783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M1),
     /*  947786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947788 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947790 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947792 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947794 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947804 */     GIR_RootConstrainSelectedInstOperands,
     /*  947805 */     // GIR_Coverage, 63288,
     /*  947805 */     GIR_EraseRootFromParent_Done,
     /*  947806 */   // Label 14303: @947806
     /*  947806 */   GIM_Try, /*On fail goto*//*Label 14304*/ GIMT_Encode4(947888), // Rule ID 63319 //
     /*  947811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947838 */     // MIs[0] op1
     /*  947838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947865 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  947865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  947868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947870 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947872 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947874 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947876 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947886 */     GIR_RootConstrainSelectedInstOperands,
     /*  947887 */     // GIR_Coverage, 63319,
     /*  947887 */     GIR_EraseRootFromParent_Done,
     /*  947888 */   // Label 14304: @947888
     /*  947888 */   GIM_Try, /*On fail goto*//*Label 14305*/ GIMT_Encode4(947970), // Rule ID 63320 //
     /*  947893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947920 */     // MIs[0] op1
     /*  947920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947923 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947947 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  947947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  947950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947952 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947954 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947956 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947958 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947968 */     GIR_RootConstrainSelectedInstOperands,
     /*  947969 */     // GIR_Coverage, 63320,
     /*  947969 */     GIR_EraseRootFromParent_Done,
     /*  947970 */   // Label 14305: @947970
     /*  947970 */   GIM_Try, /*On fail goto*//*Label 14306*/ GIMT_Encode4(948052), // Rule ID 63331 //
     /*  947975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  947995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948002 */     // MIs[0] op1
     /*  948002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948029 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  948029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  948032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948034 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948036 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948038 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948040 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  948050 */     GIR_RootConstrainSelectedInstOperands,
     /*  948051 */     // GIR_Coverage, 63331,
     /*  948051 */     GIR_EraseRootFromParent_Done,
     /*  948052 */   // Label 14306: @948052
     /*  948052 */   GIM_Try, /*On fail goto*//*Label 14307*/ GIMT_Encode4(948134), // Rule ID 63332 //
     /*  948057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  948068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  948071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  948074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  948077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948084 */     // MIs[0] op1
     /*  948084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948087 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948111 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  948111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  948114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948116 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948118 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948120 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948122 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  948132 */     GIR_RootConstrainSelectedInstOperands,
     /*  948133 */     // GIR_Coverage, 63332,
     /*  948133 */     GIR_EraseRootFromParent_Done,
     /*  948134 */   // Label 14307: @948134
     /*  948134 */   GIM_Try, /*On fail goto*//*Label 14308*/ GIMT_Encode4(948216), // Rule ID 63343 //
     /*  948139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  948147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  948150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  948153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  948156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948166 */     // MIs[0] op1
     /*  948166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  948174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  948186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948193 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  948193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M1),
     /*  948196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948198 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948200 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948202 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948204 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  948214 */     GIR_RootConstrainSelectedInstOperands,
     /*  948215 */     // GIR_Coverage, 63343,
     /*  948215 */     GIR_EraseRootFromParent_Done,
     /*  948216 */   // Label 14308: @948216
     /*  948216 */   GIM_Try, /*On fail goto*//*Label 14309*/ GIMT_Encode4(948298), // Rule ID 63344 //
     /*  948221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  948229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  948232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  948235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  948238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948248 */     // MIs[0] op1
     /*  948248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  948256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  948268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948275 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  948275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M1),
     /*  948278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948280 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948282 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948284 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948286 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  948296 */     GIR_RootConstrainSelectedInstOperands,
     /*  948297 */     // GIR_Coverage, 63344,
     /*  948297 */     GIR_EraseRootFromParent_Done,
     /*  948298 */   // Label 14309: @948298
     /*  948298 */   GIM_Try, /*On fail goto*//*Label 14310*/ GIMT_Encode4(948380), // Rule ID 63375 //
     /*  948303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  948314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  948317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  948320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948330 */     // MIs[0] op1
     /*  948330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948333 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948357 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  948360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948362 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948364 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948366 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948368 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948378 */     GIR_RootConstrainSelectedInstOperands,
     /*  948379 */     // GIR_Coverage, 63375,
     /*  948379 */     GIR_EraseRootFromParent_Done,
     /*  948380 */   // Label 14310: @948380
     /*  948380 */   GIM_Try, /*On fail goto*//*Label 14311*/ GIMT_Encode4(948462), // Rule ID 63376 //
     /*  948385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  948396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  948399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  948402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948412 */     // MIs[0] op1
     /*  948412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948439 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  948442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948444 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948446 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948448 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948450 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948460 */     GIR_RootConstrainSelectedInstOperands,
     /*  948461 */     // GIR_Coverage, 63376,
     /*  948461 */     GIR_EraseRootFromParent_Done,
     /*  948462 */   // Label 14311: @948462
     /*  948462 */   GIM_Try, /*On fail goto*//*Label 14312*/ GIMT_Encode4(948544), // Rule ID 63387 //
     /*  948467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  948478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  948481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  948484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  948487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948494 */     // MIs[0] op1
     /*  948494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948521 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  948524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948526 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948528 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948530 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948532 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948542 */     GIR_RootConstrainSelectedInstOperands,
     /*  948543 */     // GIR_Coverage, 63387,
     /*  948543 */     GIR_EraseRootFromParent_Done,
     /*  948544 */   // Label 14312: @948544
     /*  948544 */   GIM_Try, /*On fail goto*//*Label 14313*/ GIMT_Encode4(948626), // Rule ID 63388 //
     /*  948549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  948560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  948563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  948566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  948569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948576 */     // MIs[0] op1
     /*  948576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948579 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948603 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  948606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948608 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948610 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948612 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948614 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948624 */     GIR_RootConstrainSelectedInstOperands,
     /*  948625 */     // GIR_Coverage, 63388,
     /*  948625 */     GIR_EraseRootFromParent_Done,
     /*  948626 */   // Label 14313: @948626
     /*  948626 */   GIM_Try, /*On fail goto*//*Label 14314*/ GIMT_Encode4(948708), // Rule ID 63419 //
     /*  948631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948658 */     // MIs[0] op1
     /*  948658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948685 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  948688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948690 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948692 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948694 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948696 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948706 */     GIR_RootConstrainSelectedInstOperands,
     /*  948707 */     // GIR_Coverage, 63419,
     /*  948707 */     GIR_EraseRootFromParent_Done,
     /*  948708 */   // Label 14314: @948708
     /*  948708 */   GIM_Try, /*On fail goto*//*Label 14315*/ GIMT_Encode4(948790), // Rule ID 63420 //
     /*  948713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948740 */     // MIs[0] op1
     /*  948740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948767 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  948770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948772 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948774 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948776 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948778 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948788 */     GIR_RootConstrainSelectedInstOperands,
     /*  948789 */     // GIR_Coverage, 63420,
     /*  948789 */     GIR_EraseRootFromParent_Done,
     /*  948790 */   // Label 14315: @948790
     /*  948790 */   GIM_Try, /*On fail goto*//*Label 14316*/ GIMT_Encode4(948872), // Rule ID 63431 //
     /*  948795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  948815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948822 */     // MIs[0] op1
     /*  948822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948825 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948849 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  948852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948854 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948856 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948858 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948860 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948870 */     GIR_RootConstrainSelectedInstOperands,
     /*  948871 */     // GIR_Coverage, 63431,
     /*  948871 */     GIR_EraseRootFromParent_Done,
     /*  948872 */   // Label 14316: @948872
     /*  948872 */   GIM_Try, /*On fail goto*//*Label 14317*/ GIMT_Encode4(948954), // Rule ID 63432 //
     /*  948877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  948897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948904 */     // MIs[0] op1
     /*  948904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948907 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948931 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  948934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948936 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948938 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948940 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948942 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948952 */     GIR_RootConstrainSelectedInstOperands,
     /*  948953 */     // GIR_Coverage, 63432,
     /*  948953 */     GIR_EraseRootFromParent_Done,
     /*  948954 */   // Label 14317: @948954
     /*  948954 */   GIM_Try, /*On fail goto*//*Label 14318*/ GIMT_Encode4(949036), // Rule ID 63463 //
     /*  948959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948986 */     // MIs[0] op1
     /*  948986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948989 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949013 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  949013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  949016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949018 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949020 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949022 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949024 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949034 */     GIR_RootConstrainSelectedInstOperands,
     /*  949035 */     // GIR_Coverage, 63463,
     /*  949035 */     GIR_EraseRootFromParent_Done,
     /*  949036 */   // Label 14318: @949036
     /*  949036 */   GIM_Try, /*On fail goto*//*Label 14319*/ GIMT_Encode4(949118), // Rule ID 63464 //
     /*  949041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  949052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  949055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  949058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949068 */     // MIs[0] op1
     /*  949068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949095 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  949095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  949098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949100 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949102 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949104 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949106 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949116 */     GIR_RootConstrainSelectedInstOperands,
     /*  949117 */     // GIR_Coverage, 63464,
     /*  949117 */     GIR_EraseRootFromParent_Done,
     /*  949118 */   // Label 14319: @949118
     /*  949118 */   GIM_Try, /*On fail goto*//*Label 14320*/ GIMT_Encode4(949200), // Rule ID 63475 //
     /*  949123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  949134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  949137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  949140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  949143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949150 */     // MIs[0] op1
     /*  949150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949153 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949177 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  949177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  949180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949182 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949184 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949186 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949188 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949198 */     GIR_RootConstrainSelectedInstOperands,
     /*  949199 */     // GIR_Coverage, 63475,
     /*  949199 */     GIR_EraseRootFromParent_Done,
     /*  949200 */   // Label 14320: @949200
     /*  949200 */   GIM_Try, /*On fail goto*//*Label 14321*/ GIMT_Encode4(949282), // Rule ID 63476 //
     /*  949205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  949216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  949219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  949222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  949225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949232 */     // MIs[0] op1
     /*  949232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949259 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  949259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  949262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949264 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949266 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949268 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949270 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949280 */     GIR_RootConstrainSelectedInstOperands,
     /*  949281 */     // GIR_Coverage, 63476,
     /*  949281 */     GIR_EraseRootFromParent_Done,
     /*  949282 */   // Label 14321: @949282
     /*  949282 */   GIM_Try, /*On fail goto*//*Label 14322*/ GIMT_Encode4(949364), // Rule ID 63507 //
     /*  949287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949314 */     // MIs[0] op1
     /*  949314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949341 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  949344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949346 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949348 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949350 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949352 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949362 */     GIR_RootConstrainSelectedInstOperands,
     /*  949363 */     // GIR_Coverage, 63507,
     /*  949363 */     GIR_EraseRootFromParent_Done,
     /*  949364 */   // Label 14322: @949364
     /*  949364 */   GIM_Try, /*On fail goto*//*Label 14323*/ GIMT_Encode4(949446), // Rule ID 63508 //
     /*  949369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949396 */     // MIs[0] op1
     /*  949396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949423 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  949426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949428 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949430 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949432 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949434 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949444 */     GIR_RootConstrainSelectedInstOperands,
     /*  949445 */     // GIR_Coverage, 63508,
     /*  949445 */     GIR_EraseRootFromParent_Done,
     /*  949446 */   // Label 14323: @949446
     /*  949446 */   GIM_Try, /*On fail goto*//*Label 14324*/ GIMT_Encode4(949528), // Rule ID 63519 //
     /*  949451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  949471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949478 */     // MIs[0] op1
     /*  949478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949505 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  949508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949510 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949512 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949514 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949516 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949526 */     GIR_RootConstrainSelectedInstOperands,
     /*  949527 */     // GIR_Coverage, 63519,
     /*  949527 */     GIR_EraseRootFromParent_Done,
     /*  949528 */   // Label 14324: @949528
     /*  949528 */   GIM_Try, /*On fail goto*//*Label 14325*/ GIMT_Encode4(949610), // Rule ID 63520 //
     /*  949533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  949553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949560 */     // MIs[0] op1
     /*  949560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949587 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  949590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949592 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949594 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949596 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949598 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949608 */     GIR_RootConstrainSelectedInstOperands,
     /*  949609 */     // GIR_Coverage, 63520,
     /*  949609 */     GIR_EraseRootFromParent_Done,
     /*  949610 */   // Label 14325: @949610
     /*  949610 */   GIM_Try, /*On fail goto*//*Label 14326*/ GIMT_Encode4(949692), // Rule ID 63531 //
     /*  949615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949642 */     // MIs[0] op1
     /*  949642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949645 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949669 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M2),
     /*  949672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949674 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949676 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949678 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949680 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949690 */     GIR_RootConstrainSelectedInstOperands,
     /*  949691 */     // GIR_Coverage, 63531,
     /*  949691 */     GIR_EraseRootFromParent_Done,
     /*  949692 */   // Label 14326: @949692
     /*  949692 */   GIM_Try, /*On fail goto*//*Label 14327*/ GIMT_Encode4(949774), // Rule ID 63532 //
     /*  949697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949724 */     // MIs[0] op1
     /*  949724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949751 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M2),
     /*  949754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949756 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949758 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949760 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949762 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949772 */     GIR_RootConstrainSelectedInstOperands,
     /*  949773 */     // GIR_Coverage, 63532,
     /*  949773 */     GIR_EraseRootFromParent_Done,
     /*  949774 */   // Label 14327: @949774
     /*  949774 */   GIM_Try, /*On fail goto*//*Label 14328*/ GIMT_Encode4(949856), // Rule ID 63563 //
     /*  949779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949806 */     // MIs[0] op1
     /*  949806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949833 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  949836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949838 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949840 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949842 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949844 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949854 */     GIR_RootConstrainSelectedInstOperands,
     /*  949855 */     // GIR_Coverage, 63563,
     /*  949855 */     GIR_EraseRootFromParent_Done,
     /*  949856 */   // Label 14328: @949856
     /*  949856 */   GIM_Try, /*On fail goto*//*Label 14329*/ GIMT_Encode4(949938), // Rule ID 63564 //
     /*  949861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949888 */     // MIs[0] op1
     /*  949888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949915 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  949918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949920 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949922 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949924 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949926 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949936 */     GIR_RootConstrainSelectedInstOperands,
     /*  949937 */     // GIR_Coverage, 63564,
     /*  949937 */     GIR_EraseRootFromParent_Done,
     /*  949938 */   // Label 14329: @949938
     /*  949938 */   GIM_Try, /*On fail goto*//*Label 14330*/ GIMT_Encode4(950020), // Rule ID 63575 //
     /*  949943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  949963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949970 */     // MIs[0] op1
     /*  949970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949973 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949997 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  950000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950002 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950004 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950006 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950008 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950018 */     GIR_RootConstrainSelectedInstOperands,
     /*  950019 */     // GIR_Coverage, 63575,
     /*  950019 */     GIR_EraseRootFromParent_Done,
     /*  950020 */   // Label 14330: @950020
     /*  950020 */   GIM_Try, /*On fail goto*//*Label 14331*/ GIMT_Encode4(950102), // Rule ID 63576 //
     /*  950025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  950036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  950039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  950042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  950045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950052 */     // MIs[0] op1
     /*  950052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950079 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  950082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950084 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950086 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950088 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950090 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950100 */     GIR_RootConstrainSelectedInstOperands,
     /*  950101 */     // GIR_Coverage, 63576,
     /*  950101 */     GIR_EraseRootFromParent_Done,
     /*  950102 */   // Label 14331: @950102
     /*  950102 */   GIM_Try, /*On fail goto*//*Label 14332*/ GIMT_Encode4(950184), // Rule ID 63587 //
     /*  950107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  950118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  950121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  950124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950134 */     // MIs[0] op1
     /*  950134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950161 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M4),
     /*  950164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950166 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950168 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950170 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950172 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950182 */     GIR_RootConstrainSelectedInstOperands,
     /*  950183 */     // GIR_Coverage, 63587,
     /*  950183 */     GIR_EraseRootFromParent_Done,
     /*  950184 */   // Label 14332: @950184
     /*  950184 */   GIM_Try, /*On fail goto*//*Label 14333*/ GIMT_Encode4(950266), // Rule ID 63588 //
     /*  950189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  950200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  950203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  950206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950216 */     // MIs[0] op1
     /*  950216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950243 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M4),
     /*  950246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950248 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950250 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950252 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950254 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950264 */     GIR_RootConstrainSelectedInstOperands,
     /*  950265 */     // GIR_Coverage, 63588,
     /*  950265 */     GIR_EraseRootFromParent_Done,
     /*  950266 */   // Label 14333: @950266
     /*  950266 */   GIM_Try, /*On fail goto*//*Label 14334*/ GIMT_Encode4(950348), // Rule ID 63619 //
     /*  950271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950298 */     // MIs[0] op1
     /*  950298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950301 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950325 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  950328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950330 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950332 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950334 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950336 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950346 */     GIR_RootConstrainSelectedInstOperands,
     /*  950347 */     // GIR_Coverage, 63619,
     /*  950347 */     GIR_EraseRootFromParent_Done,
     /*  950348 */   // Label 14334: @950348
     /*  950348 */   GIM_Try, /*On fail goto*//*Label 14335*/ GIMT_Encode4(950430), // Rule ID 63620 //
     /*  950353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950380 */     // MIs[0] op1
     /*  950380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950383 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950407 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  950410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950412 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950414 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950416 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950418 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950428 */     GIR_RootConstrainSelectedInstOperands,
     /*  950429 */     // GIR_Coverage, 63620,
     /*  950429 */     GIR_EraseRootFromParent_Done,
     /*  950430 */   // Label 14335: @950430
     /*  950430 */   GIM_Try, /*On fail goto*//*Label 14336*/ GIMT_Encode4(950512), // Rule ID 63631 //
     /*  950435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  950455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950462 */     // MIs[0] op1
     /*  950462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950489 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  950492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950494 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950496 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950498 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950500 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950510 */     GIR_RootConstrainSelectedInstOperands,
     /*  950511 */     // GIR_Coverage, 63631,
     /*  950511 */     GIR_EraseRootFromParent_Done,
     /*  950512 */   // Label 14336: @950512
     /*  950512 */   GIM_Try, /*On fail goto*//*Label 14337*/ GIMT_Encode4(950594), // Rule ID 63632 //
     /*  950517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  950537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950544 */     // MIs[0] op1
     /*  950544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950547 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950571 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  950574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950576 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950578 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950580 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950582 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950592 */     GIR_RootConstrainSelectedInstOperands,
     /*  950593 */     // GIR_Coverage, 63632,
     /*  950593 */     GIR_EraseRootFromParent_Done,
     /*  950594 */   // Label 14337: @950594
     /*  950594 */   GIM_Try, /*On fail goto*//*Label 14338*/ GIMT_Encode4(950676), // Rule ID 63643 //
     /*  950599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950626 */     // MIs[0] op1
     /*  950626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950653 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M8),
     /*  950656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950658 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950660 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950662 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950664 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950674 */     GIR_RootConstrainSelectedInstOperands,
     /*  950675 */     // GIR_Coverage, 63643,
     /*  950675 */     GIR_EraseRootFromParent_Done,
     /*  950676 */   // Label 14338: @950676
     /*  950676 */   GIM_Try, /*On fail goto*//*Label 14339*/ GIMT_Encode4(950758), // Rule ID 63644 //
     /*  950681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950708 */     // MIs[0] op1
     /*  950708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950711 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950735 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M8),
     /*  950738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950740 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950742 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950744 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950746 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950756 */     GIR_RootConstrainSelectedInstOperands,
     /*  950757 */     // GIR_Coverage, 63644,
     /*  950757 */     GIR_EraseRootFromParent_Done,
     /*  950758 */   // Label 14339: @950758
     /*  950758 */   GIM_Try, /*On fail goto*//*Label 14340*/ GIMT_Encode4(950840), // Rule ID 63675 //
     /*  950763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950790 */     // MIs[0] op1
     /*  950790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950817 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  950820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950822 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950824 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950826 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950828 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950838 */     GIR_RootConstrainSelectedInstOperands,
     /*  950839 */     // GIR_Coverage, 63675,
     /*  950839 */     GIR_EraseRootFromParent_Done,
     /*  950840 */   // Label 14340: @950840
     /*  950840 */   GIM_Try, /*On fail goto*//*Label 14341*/ GIMT_Encode4(950922), // Rule ID 63676 //
     /*  950845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950872 */     // MIs[0] op1
     /*  950872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  950902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950904 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950906 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950908 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950910 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950920 */     GIR_RootConstrainSelectedInstOperands,
     /*  950921 */     // GIR_Coverage, 63676,
     /*  950921 */     GIR_EraseRootFromParent_Done,
     /*  950922 */   // Label 14341: @950922
     /*  950922 */   GIM_Try, /*On fail goto*//*Label 14342*/ GIMT_Encode4(951004), // Rule ID 63687 //
     /*  950927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  950947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950954 */     // MIs[0] op1
     /*  950954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950957 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950981 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  950984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950986 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950988 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950990 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950992 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951002 */     GIR_RootConstrainSelectedInstOperands,
     /*  951003 */     // GIR_Coverage, 63687,
     /*  951003 */     GIR_EraseRootFromParent_Done,
     /*  951004 */   // Label 14342: @951004
     /*  951004 */   GIM_Try, /*On fail goto*//*Label 14343*/ GIMT_Encode4(951086), // Rule ID 63688 //
     /*  951009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  951020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  951023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  951026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  951029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951036 */     // MIs[0] op1
     /*  951036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951063 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  951066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951068 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951070 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951072 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951074 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951084 */     GIR_RootConstrainSelectedInstOperands,
     /*  951085 */     // GIR_Coverage, 63688,
     /*  951085 */     GIR_EraseRootFromParent_Done,
     /*  951086 */   // Label 14343: @951086
     /*  951086 */   GIM_Try, /*On fail goto*//*Label 14344*/ GIMT_Encode4(951168), // Rule ID 63699 //
     /*  951091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  951102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  951105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  951108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951118 */     // MIs[0] op1
     /*  951118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951145 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M2),
     /*  951148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951150 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951152 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951154 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951156 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951166 */     GIR_RootConstrainSelectedInstOperands,
     /*  951167 */     // GIR_Coverage, 63699,
     /*  951167 */     GIR_EraseRootFromParent_Done,
     /*  951168 */   // Label 14344: @951168
     /*  951168 */   GIM_Try, /*On fail goto*//*Label 14345*/ GIMT_Encode4(951250), // Rule ID 63700 //
     /*  951173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  951184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  951187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  951190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951200 */     // MIs[0] op1
     /*  951200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951227 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M2),
     /*  951230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951232 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951234 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951236 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951238 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951248 */     GIR_RootConstrainSelectedInstOperands,
     /*  951249 */     // GIR_Coverage, 63700,
     /*  951249 */     GIR_EraseRootFromParent_Done,
     /*  951250 */   // Label 14345: @951250
     /*  951250 */   GIM_Try, /*On fail goto*//*Label 14346*/ GIMT_Encode4(951332), // Rule ID 63731 //
     /*  951255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951282 */     // MIs[0] op1
     /*  951282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951309 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  951312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951314 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951316 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951318 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951320 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951330 */     GIR_RootConstrainSelectedInstOperands,
     /*  951331 */     // GIR_Coverage, 63731,
     /*  951331 */     GIR_EraseRootFromParent_Done,
     /*  951332 */   // Label 14346: @951332
     /*  951332 */   GIM_Try, /*On fail goto*//*Label 14347*/ GIMT_Encode4(951414), // Rule ID 63732 //
     /*  951337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951364 */     // MIs[0] op1
     /*  951364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951367 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951391 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  951394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951396 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951398 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951400 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951402 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951412 */     GIR_RootConstrainSelectedInstOperands,
     /*  951413 */     // GIR_Coverage, 63732,
     /*  951413 */     GIR_EraseRootFromParent_Done,
     /*  951414 */   // Label 14347: @951414
     /*  951414 */   GIM_Try, /*On fail goto*//*Label 14348*/ GIMT_Encode4(951496), // Rule ID 63743 //
     /*  951419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  951439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951446 */     // MIs[0] op1
     /*  951446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951473 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  951476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951478 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951480 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951482 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951484 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951494 */     GIR_RootConstrainSelectedInstOperands,
     /*  951495 */     // GIR_Coverage, 63743,
     /*  951495 */     GIR_EraseRootFromParent_Done,
     /*  951496 */   // Label 14348: @951496
     /*  951496 */   GIM_Try, /*On fail goto*//*Label 14349*/ GIMT_Encode4(951578), // Rule ID 63744 //
     /*  951501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  951521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951528 */     // MIs[0] op1
     /*  951528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951555 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  951558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951560 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951562 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951564 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951566 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951576 */     GIR_RootConstrainSelectedInstOperands,
     /*  951577 */     // GIR_Coverage, 63744,
     /*  951577 */     GIR_EraseRootFromParent_Done,
     /*  951578 */   // Label 14349: @951578
     /*  951578 */   GIM_Try, /*On fail goto*//*Label 14350*/ GIMT_Encode4(951660), // Rule ID 63755 //
     /*  951583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951610 */     // MIs[0] op1
     /*  951610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951637 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M4),
     /*  951640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951642 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951644 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951646 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951648 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951658 */     GIR_RootConstrainSelectedInstOperands,
     /*  951659 */     // GIR_Coverage, 63755,
     /*  951659 */     GIR_EraseRootFromParent_Done,
     /*  951660 */   // Label 14350: @951660
     /*  951660 */   GIM_Try, /*On fail goto*//*Label 14351*/ GIMT_Encode4(951742), // Rule ID 63756 //
     /*  951665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951692 */     // MIs[0] op1
     /*  951692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951719 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M4),
     /*  951722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951724 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951726 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951728 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951730 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951740 */     GIR_RootConstrainSelectedInstOperands,
     /*  951741 */     // GIR_Coverage, 63756,
     /*  951741 */     GIR_EraseRootFromParent_Done,
     /*  951742 */   // Label 14351: @951742
     /*  951742 */   GIM_Try, /*On fail goto*//*Label 14352*/ GIMT_Encode4(951824), // Rule ID 63787 //
     /*  951747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951774 */     // MIs[0] op1
     /*  951774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951801 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  951804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951806 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951808 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951810 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951812 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951822 */     GIR_RootConstrainSelectedInstOperands,
     /*  951823 */     // GIR_Coverage, 63787,
     /*  951823 */     GIR_EraseRootFromParent_Done,
     /*  951824 */   // Label 14352: @951824
     /*  951824 */   GIM_Try, /*On fail goto*//*Label 14353*/ GIMT_Encode4(951906), // Rule ID 63788 //
     /*  951829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951856 */     // MIs[0] op1
     /*  951856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951859 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951883 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  951886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951888 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951890 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951892 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951894 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951904 */     GIR_RootConstrainSelectedInstOperands,
     /*  951905 */     // GIR_Coverage, 63788,
     /*  951905 */     GIR_EraseRootFromParent_Done,
     /*  951906 */   // Label 14353: @951906
     /*  951906 */   GIM_Try, /*On fail goto*//*Label 14354*/ GIMT_Encode4(951988), // Rule ID 63799 //
     /*  951911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  951931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951938 */     // MIs[0] op1
     /*  951938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951965 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  951968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951970 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951972 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951974 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951976 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951986 */     GIR_RootConstrainSelectedInstOperands,
     /*  951987 */     // GIR_Coverage, 63799,
     /*  951987 */     GIR_EraseRootFromParent_Done,
     /*  951988 */   // Label 14354: @951988
     /*  951988 */   GIM_Try, /*On fail goto*//*Label 14355*/ GIMT_Encode4(952070), // Rule ID 63800 //
     /*  951993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  952004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  952007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  952010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  952013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952020 */     // MIs[0] op1
     /*  952020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952047 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  952047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  952050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952052 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952054 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952056 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952058 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  952068 */     GIR_RootConstrainSelectedInstOperands,
     /*  952069 */     // GIR_Coverage, 63800,
     /*  952069 */     GIR_EraseRootFromParent_Done,
     /*  952070 */   // Label 14355: @952070
     /*  952070 */   GIM_Try, /*On fail goto*//*Label 14356*/ GIMT_Encode4(952152), // Rule ID 63811 //
     /*  952075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  952086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  952089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  952092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952102 */     // MIs[0] op1
     /*  952102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  952122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952129 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  952129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M8),
     /*  952132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952134 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952136 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952138 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952140 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  952150 */     GIR_RootConstrainSelectedInstOperands,
     /*  952151 */     // GIR_Coverage, 63811,
     /*  952151 */     GIR_EraseRootFromParent_Done,
     /*  952152 */   // Label 14356: @952152
     /*  952152 */   GIM_Try, /*On fail goto*//*Label 14357*/ GIMT_Encode4(952234), // Rule ID 63812 //
     /*  952157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  952168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  952171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  952174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952184 */     // MIs[0] op1
     /*  952184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952187 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  952204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952211 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  952211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M8),
     /*  952214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952216 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952218 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952220 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952222 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  952232 */     GIR_RootConstrainSelectedInstOperands,
     /*  952233 */     // GIR_Coverage, 63812,
     /*  952233 */     GIR_EraseRootFromParent_Done,
     /*  952234 */   // Label 14357: @952234
     /*  952234 */   GIM_Try, /*On fail goto*//*Label 14358*/ GIMT_Encode4(952316), // Rule ID 63843 //
     /*  952239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952266 */     // MIs[0] op1
     /*  952266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952293 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  952296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952298 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952300 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952302 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952304 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952314 */     GIR_RootConstrainSelectedInstOperands,
     /*  952315 */     // GIR_Coverage, 63843,
     /*  952315 */     GIR_EraseRootFromParent_Done,
     /*  952316 */   // Label 14358: @952316
     /*  952316 */   GIM_Try, /*On fail goto*//*Label 14359*/ GIMT_Encode4(952398), // Rule ID 63844 //
     /*  952321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952348 */     // MIs[0] op1
     /*  952348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952375 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  952378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952380 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952382 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952384 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952386 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952396 */     GIR_RootConstrainSelectedInstOperands,
     /*  952397 */     // GIR_Coverage, 63844,
     /*  952397 */     GIR_EraseRootFromParent_Done,
     /*  952398 */   // Label 14359: @952398
     /*  952398 */   GIM_Try, /*On fail goto*//*Label 14360*/ GIMT_Encode4(952480), // Rule ID 63855 //
     /*  952403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  952423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952430 */     // MIs[0] op1
     /*  952430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952457 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  952460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952462 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952464 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952466 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952468 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952478 */     GIR_RootConstrainSelectedInstOperands,
     /*  952479 */     // GIR_Coverage, 63855,
     /*  952479 */     GIR_EraseRootFromParent_Done,
     /*  952480 */   // Label 14360: @952480
     /*  952480 */   GIM_Try, /*On fail goto*//*Label 14361*/ GIMT_Encode4(952562), // Rule ID 63856 //
     /*  952485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  952505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952512 */     // MIs[0] op1
     /*  952512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952515 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952539 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  952542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952544 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952546 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952548 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952550 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952560 */     GIR_RootConstrainSelectedInstOperands,
     /*  952561 */     // GIR_Coverage, 63856,
     /*  952561 */     GIR_EraseRootFromParent_Done,
     /*  952562 */   // Label 14361: @952562
     /*  952562 */   GIM_Try, /*On fail goto*//*Label 14362*/ GIMT_Encode4(952644), // Rule ID 63867 //
     /*  952567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952594 */     // MIs[0] op1
     /*  952594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952621 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M2),
     /*  952624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952626 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952628 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952630 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952632 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952642 */     GIR_RootConstrainSelectedInstOperands,
     /*  952643 */     // GIR_Coverage, 63867,
     /*  952643 */     GIR_EraseRootFromParent_Done,
     /*  952644 */   // Label 14362: @952644
     /*  952644 */   GIM_Try, /*On fail goto*//*Label 14363*/ GIMT_Encode4(952726), // Rule ID 63868 //
     /*  952649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952676 */     // MIs[0] op1
     /*  952676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952703 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M2),
     /*  952706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952708 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952710 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952712 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952714 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952724 */     GIR_RootConstrainSelectedInstOperands,
     /*  952725 */     // GIR_Coverage, 63868,
     /*  952725 */     GIR_EraseRootFromParent_Done,
     /*  952726 */   // Label 14363: @952726
     /*  952726 */   GIM_Try, /*On fail goto*//*Label 14364*/ GIMT_Encode4(952808), // Rule ID 63899 //
     /*  952731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952758 */     // MIs[0] op1
     /*  952758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952785 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  952788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952790 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952792 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952794 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952796 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952806 */     GIR_RootConstrainSelectedInstOperands,
     /*  952807 */     // GIR_Coverage, 63899,
     /*  952807 */     GIR_EraseRootFromParent_Done,
     /*  952808 */   // Label 14364: @952808
     /*  952808 */   GIM_Try, /*On fail goto*//*Label 14365*/ GIMT_Encode4(952890), // Rule ID 63900 //
     /*  952813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952840 */     // MIs[0] op1
     /*  952840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952867 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  952870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952872 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952874 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952876 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952878 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952888 */     GIR_RootConstrainSelectedInstOperands,
     /*  952889 */     // GIR_Coverage, 63900,
     /*  952889 */     GIR_EraseRootFromParent_Done,
     /*  952890 */   // Label 14365: @952890
     /*  952890 */   GIM_Try, /*On fail goto*//*Label 14366*/ GIMT_Encode4(952972), // Rule ID 63911 //
     /*  952895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  952915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952922 */     // MIs[0] op1
     /*  952922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952925 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952949 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  952952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952954 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952956 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952958 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952960 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952970 */     GIR_RootConstrainSelectedInstOperands,
     /*  952971 */     // GIR_Coverage, 63911,
     /*  952971 */     GIR_EraseRootFromParent_Done,
     /*  952972 */   // Label 14366: @952972
     /*  952972 */   GIM_Try, /*On fail goto*//*Label 14367*/ GIMT_Encode4(953054), // Rule ID 63912 //
     /*  952977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  952997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953004 */     // MIs[0] op1
     /*  953004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953007 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953031 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  953034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953036 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953038 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953040 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953042 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953052 */     GIR_RootConstrainSelectedInstOperands,
     /*  953053 */     // GIR_Coverage, 63912,
     /*  953053 */     GIR_EraseRootFromParent_Done,
     /*  953054 */   // Label 14367: @953054
     /*  953054 */   GIM_Try, /*On fail goto*//*Label 14368*/ GIMT_Encode4(953136), // Rule ID 63923 //
     /*  953059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  953070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  953073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  953076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953086 */     // MIs[0] op1
     /*  953086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  953106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953113 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  953113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M4),
     /*  953116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953118 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953120 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953122 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953124 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953134 */     GIR_RootConstrainSelectedInstOperands,
     /*  953135 */     // GIR_Coverage, 63923,
     /*  953135 */     GIR_EraseRootFromParent_Done,
     /*  953136 */   // Label 14368: @953136
     /*  953136 */   GIM_Try, /*On fail goto*//*Label 14369*/ GIMT_Encode4(953218), // Rule ID 63924 //
     /*  953141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  953152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  953155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  953158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953168 */     // MIs[0] op1
     /*  953168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953171 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  953188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953195 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M4),
     /*  953198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953200 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953202 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953204 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953206 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953216 */     GIR_RootConstrainSelectedInstOperands,
     /*  953217 */     // GIR_Coverage, 63924,
     /*  953217 */     GIR_EraseRootFromParent_Done,
     /*  953218 */   // Label 14369: @953218
     /*  953218 */   GIM_Try, /*On fail goto*//*Label 14370*/ GIMT_Encode4(953300), // Rule ID 63955 //
     /*  953223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  953231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953250 */     // MIs[0] op1
     /*  953250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953277 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  953277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  953280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953282 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953284 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953286 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953288 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953298 */     GIR_RootConstrainSelectedInstOperands,
     /*  953299 */     // GIR_Coverage, 63955,
     /*  953299 */     GIR_EraseRootFromParent_Done,
     /*  953300 */   // Label 14370: @953300
     /*  953300 */   GIM_Try, /*On fail goto*//*Label 14371*/ GIMT_Encode4(953382), // Rule ID 63956 //
     /*  953305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  953313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953332 */     // MIs[0] op1
     /*  953332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953359 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  953362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953364 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953366 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953368 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953370 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953380 */     GIR_RootConstrainSelectedInstOperands,
     /*  953381 */     // GIR_Coverage, 63956,
     /*  953381 */     GIR_EraseRootFromParent_Done,
     /*  953382 */   // Label 14371: @953382
     /*  953382 */   GIM_Try, /*On fail goto*//*Label 14372*/ GIMT_Encode4(953464), // Rule ID 63967 //
     /*  953387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  953407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953414 */     // MIs[0] op1
     /*  953414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953417 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953441 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11132:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  953441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  953444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953446 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953448 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953450 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953452 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953462 */     GIR_RootConstrainSelectedInstOperands,
     /*  953463 */     // GIR_Coverage, 63967,
     /*  953463 */     GIR_EraseRootFromParent_Done,
     /*  953464 */   // Label 14372: @953464
     /*  953464 */   GIM_Try, /*On fail goto*//*Label 14373*/ GIMT_Encode4(953546), // Rule ID 63968 //
     /*  953469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  953489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953496 */     // MIs[0] op1
     /*  953496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953523 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11132:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  953526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953528 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953530 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953532 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953534 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953544 */     GIR_RootConstrainSelectedInstOperands,
     /*  953545 */     // GIR_Coverage, 63968,
     /*  953545 */     GIR_EraseRootFromParent_Done,
     /*  953546 */   // Label 14373: @953546
     /*  953546 */   GIM_Try, /*On fail goto*//*Label 14374*/ GIMT_Encode4(953628), // Rule ID 63979 //
     /*  953551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953578 */     // MIs[0] op1
     /*  953578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  953598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953605 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11118:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  953605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M8),
     /*  953608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953610 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953612 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953614 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953616 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953626 */     GIR_RootConstrainSelectedInstOperands,
     /*  953627 */     // GIR_Coverage, 63979,
     /*  953627 */     GIR_EraseRootFromParent_Done,
     /*  953628 */   // Label 14374: @953628
     /*  953628 */   GIM_Try, /*On fail goto*//*Label 14375*/ GIMT_Encode4(953710), // Rule ID 63980 //
     /*  953633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953660 */     // MIs[0] op1
     /*  953660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  953680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953687 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11118:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M8),
     /*  953690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953692 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953694 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953696 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953698 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953708 */     GIR_RootConstrainSelectedInstOperands,
     /*  953709 */     // GIR_Coverage, 63980,
     /*  953709 */     GIR_EraseRootFromParent_Done,
     /*  953710 */   // Label 14375: @953710
     /*  953710 */   GIM_Try, /*On fail goto*//*Label 14376*/ GIMT_Encode4(953792), // Rule ID 63985 //
     /*  953715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953742 */     // MIs[0] op1
     /*  953742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953769 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF8),
     /*  953772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953774 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953776 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953778 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953780 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953790 */     GIR_RootConstrainSelectedInstOperands,
     /*  953791 */     // GIR_Coverage, 63985,
     /*  953791 */     GIR_EraseRootFromParent_Done,
     /*  953792 */   // Label 14376: @953792
     /*  953792 */   GIM_Try, /*On fail goto*//*Label 14377*/ GIMT_Encode4(953874), // Rule ID 63986 //
     /*  953797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953824 */     // MIs[0] op1
     /*  953824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953851 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF8),
     /*  953854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953856 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953858 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953860 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953862 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953872 */     GIR_RootConstrainSelectedInstOperands,
     /*  953873 */     // GIR_Coverage, 63986,
     /*  953873 */     GIR_EraseRootFromParent_Done,
     /*  953874 */   // Label 14377: @953874
     /*  953874 */   GIM_Try, /*On fail goto*//*Label 14378*/ GIMT_Encode4(953956), // Rule ID 63997 //
     /*  953879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  953899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953906 */     // MIs[0] op1
     /*  953906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953933 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF8),
     /*  953936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953938 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953940 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953942 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953944 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953954 */     GIR_RootConstrainSelectedInstOperands,
     /*  953955 */     // GIR_Coverage, 63997,
     /*  953955 */     GIR_EraseRootFromParent_Done,
     /*  953956 */   // Label 14378: @953956
     /*  953956 */   GIM_Try, /*On fail goto*//*Label 14379*/ GIMT_Encode4(954038), // Rule ID 63998 //
     /*  953961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  953981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953988 */     // MIs[0] op1
     /*  953988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953991 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954015 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF8),
     /*  954018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954020 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954022 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954024 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954026 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954036 */     GIR_RootConstrainSelectedInstOperands,
     /*  954037 */     // GIR_Coverage, 63998,
     /*  954037 */     GIR_EraseRootFromParent_Done,
     /*  954038 */   // Label 14379: @954038
     /*  954038 */   GIM_Try, /*On fail goto*//*Label 14380*/ GIMT_Encode4(954120), // Rule ID 64003 //
     /*  954043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  954054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  954057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  954060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954070 */     // MIs[0] op1
     /*  954070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954073 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954097 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF4),
     /*  954100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954102 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954104 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954106 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954108 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954118 */     GIR_RootConstrainSelectedInstOperands,
     /*  954119 */     // GIR_Coverage, 64003,
     /*  954119 */     GIR_EraseRootFromParent_Done,
     /*  954120 */   // Label 14380: @954120
     /*  954120 */   GIM_Try, /*On fail goto*//*Label 14381*/ GIMT_Encode4(954202), // Rule ID 64004 //
     /*  954125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  954136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  954139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  954142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954152 */     // MIs[0] op1
     /*  954152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954179 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF4),
     /*  954182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954184 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954186 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954188 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954190 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954200 */     GIR_RootConstrainSelectedInstOperands,
     /*  954201 */     // GIR_Coverage, 64004,
     /*  954201 */     GIR_EraseRootFromParent_Done,
     /*  954202 */   // Label 14381: @954202
     /*  954202 */   GIM_Try, /*On fail goto*//*Label 14382*/ GIMT_Encode4(954284), // Rule ID 64015 //
     /*  954207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  954218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  954221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  954224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  954227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954234 */     // MIs[0] op1
     /*  954234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954261 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF4),
     /*  954264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954266 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954268 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954270 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954272 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954282 */     GIR_RootConstrainSelectedInstOperands,
     /*  954283 */     // GIR_Coverage, 64015,
     /*  954283 */     GIR_EraseRootFromParent_Done,
     /*  954284 */   // Label 14382: @954284
     /*  954284 */   GIM_Try, /*On fail goto*//*Label 14383*/ GIMT_Encode4(954366), // Rule ID 64016 //
     /*  954289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  954300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  954303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  954306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  954309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954316 */     // MIs[0] op1
     /*  954316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954319 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954343 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF4),
     /*  954346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954348 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954350 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954352 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954354 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954364 */     GIR_RootConstrainSelectedInstOperands,
     /*  954365 */     // GIR_Coverage, 64016,
     /*  954365 */     GIR_EraseRootFromParent_Done,
     /*  954366 */   // Label 14383: @954366
     /*  954366 */   GIM_Try, /*On fail goto*//*Label 14384*/ GIMT_Encode4(954448), // Rule ID 64021 //
     /*  954371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954398 */     // MIs[0] op1
     /*  954398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954425 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  954428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954430 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954432 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954434 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954436 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954446 */     GIR_RootConstrainSelectedInstOperands,
     /*  954447 */     // GIR_Coverage, 64021,
     /*  954447 */     GIR_EraseRootFromParent_Done,
     /*  954448 */   // Label 14384: @954448
     /*  954448 */   GIM_Try, /*On fail goto*//*Label 14385*/ GIMT_Encode4(954530), // Rule ID 64022 //
     /*  954453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954480 */     // MIs[0] op1
     /*  954480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954507 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  954510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954512 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954514 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954516 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954518 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954528 */     GIR_RootConstrainSelectedInstOperands,
     /*  954529 */     // GIR_Coverage, 64022,
     /*  954529 */     GIR_EraseRootFromParent_Done,
     /*  954530 */   // Label 14385: @954530
     /*  954530 */   GIM_Try, /*On fail goto*//*Label 14386*/ GIMT_Encode4(954612), // Rule ID 64033 //
     /*  954535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  954555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954562 */     // MIs[0] op1
     /*  954562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954565 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954589 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  954592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954594 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954596 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954598 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954600 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954610 */     GIR_RootConstrainSelectedInstOperands,
     /*  954611 */     // GIR_Coverage, 64033,
     /*  954611 */     GIR_EraseRootFromParent_Done,
     /*  954612 */   // Label 14386: @954612
     /*  954612 */   GIM_Try, /*On fail goto*//*Label 14387*/ GIMT_Encode4(954694), // Rule ID 64034 //
     /*  954617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  954637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954644 */     // MIs[0] op1
     /*  954644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954647 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954671 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  954674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954676 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954678 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954680 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954682 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954692 */     GIR_RootConstrainSelectedInstOperands,
     /*  954693 */     // GIR_Coverage, 64034,
     /*  954693 */     GIR_EraseRootFromParent_Done,
     /*  954694 */   // Label 14387: @954694
     /*  954694 */   GIM_Try, /*On fail goto*//*Label 14388*/ GIMT_Encode4(954776), // Rule ID 64039 //
     /*  954699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954726 */     // MIs[0] op1
     /*  954726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954753 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  954756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954758 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954760 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954762 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954764 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954774 */     GIR_RootConstrainSelectedInstOperands,
     /*  954775 */     // GIR_Coverage, 64039,
     /*  954775 */     GIR_EraseRootFromParent_Done,
     /*  954776 */   // Label 14388: @954776
     /*  954776 */   GIM_Try, /*On fail goto*//*Label 14389*/ GIMT_Encode4(954858), // Rule ID 64040 //
     /*  954781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954808 */     // MIs[0] op1
     /*  954808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  954838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954840 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954842 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954844 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954846 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954856 */     GIR_RootConstrainSelectedInstOperands,
     /*  954857 */     // GIR_Coverage, 64040,
     /*  954857 */     GIR_EraseRootFromParent_Done,
     /*  954858 */   // Label 14389: @954858
     /*  954858 */   GIM_Try, /*On fail goto*//*Label 14390*/ GIMT_Encode4(954940), // Rule ID 64051 //
     /*  954863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  954883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954890 */     // MIs[0] op1
     /*  954890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954917 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  954920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954922 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954924 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954926 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954928 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954938 */     GIR_RootConstrainSelectedInstOperands,
     /*  954939 */     // GIR_Coverage, 64051,
     /*  954939 */     GIR_EraseRootFromParent_Done,
     /*  954940 */   // Label 14390: @954940
     /*  954940 */   GIM_Try, /*On fail goto*//*Label 14391*/ GIMT_Encode4(955022), // Rule ID 64052 //
     /*  954945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  954965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954972 */     // MIs[0] op1
     /*  954972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954975 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954999 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  955002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955004 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955006 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955008 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955010 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955020 */     GIR_RootConstrainSelectedInstOperands,
     /*  955021 */     // GIR_Coverage, 64052,
     /*  955021 */     GIR_EraseRootFromParent_Done,
     /*  955022 */   // Label 14391: @955022
     /*  955022 */   GIM_Try, /*On fail goto*//*Label 14392*/ GIMT_Encode4(955104), // Rule ID 64057 //
     /*  955027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  955038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  955041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  955044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955054 */     // MIs[0] op1
     /*  955054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955081 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  955081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  955084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955086 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955088 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955090 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955092 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955102 */     GIR_RootConstrainSelectedInstOperands,
     /*  955103 */     // GIR_Coverage, 64057,
     /*  955103 */     GIR_EraseRootFromParent_Done,
     /*  955104 */   // Label 14392: @955104
     /*  955104 */   GIM_Try, /*On fail goto*//*Label 14393*/ GIMT_Encode4(955186), // Rule ID 64058 //
     /*  955109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  955120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  955123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  955126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955136 */     // MIs[0] op1
     /*  955136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955139 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955163 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  955163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  955166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955168 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955170 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955172 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955174 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955184 */     GIR_RootConstrainSelectedInstOperands,
     /*  955185 */     // GIR_Coverage, 64058,
     /*  955185 */     GIR_EraseRootFromParent_Done,
     /*  955186 */   // Label 14393: @955186
     /*  955186 */   GIM_Try, /*On fail goto*//*Label 14394*/ GIMT_Encode4(955268), // Rule ID 64069 //
     /*  955191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  955202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  955205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  955208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  955211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955218 */     // MIs[0] op1
     /*  955218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955221 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955245 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  955245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  955248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955250 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955252 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955254 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955256 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955266 */     GIR_RootConstrainSelectedInstOperands,
     /*  955267 */     // GIR_Coverage, 64069,
     /*  955267 */     GIR_EraseRootFromParent_Done,
     /*  955268 */   // Label 14394: @955268
     /*  955268 */   GIM_Try, /*On fail goto*//*Label 14395*/ GIMT_Encode4(955350), // Rule ID 64070 //
     /*  955273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  955284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  955287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  955290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  955293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955300 */     // MIs[0] op1
     /*  955300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955327 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  955327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  955330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955332 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955334 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955336 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955338 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955348 */     GIR_RootConstrainSelectedInstOperands,
     /*  955349 */     // GIR_Coverage, 64070,
     /*  955349 */     GIR_EraseRootFromParent_Done,
     /*  955350 */   // Label 14395: @955350
     /*  955350 */   GIM_Try, /*On fail goto*//*Label 14396*/ GIMT_Encode4(955432), // Rule ID 64075 //
     /*  955355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  955366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  955369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  955372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955382 */     // MIs[0] op1
     /*  955382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955409 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  955409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  955412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955414 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955416 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955418 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955420 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955430 */     GIR_RootConstrainSelectedInstOperands,
     /*  955431 */     // GIR_Coverage, 64075,
     /*  955431 */     GIR_EraseRootFromParent_Done,
     /*  955432 */   // Label 14396: @955432
     /*  955432 */   GIM_Try, /*On fail goto*//*Label 14397*/ GIMT_Encode4(955514), // Rule ID 64076 //
     /*  955437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  955448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  955451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  955454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955464 */     // MIs[0] op1
     /*  955464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955491 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  955491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  955494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955496 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955498 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955500 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955502 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955512 */     GIR_RootConstrainSelectedInstOperands,
     /*  955513 */     // GIR_Coverage, 64076,
     /*  955513 */     GIR_EraseRootFromParent_Done,
     /*  955514 */   // Label 14397: @955514
     /*  955514 */   GIM_Try, /*On fail goto*//*Label 14398*/ GIMT_Encode4(955596), // Rule ID 64087 //
     /*  955519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  955530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  955533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  955536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  955539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955546 */     // MIs[0] op1
     /*  955546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955549 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955573 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  955573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  955576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955578 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955580 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955582 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955584 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955594 */     GIR_RootConstrainSelectedInstOperands,
     /*  955595 */     // GIR_Coverage, 64087,
     /*  955595 */     GIR_EraseRootFromParent_Done,
     /*  955596 */   // Label 14398: @955596
     /*  955596 */   GIM_Try, /*On fail goto*//*Label 14399*/ GIMT_Encode4(955678), // Rule ID 64088 //
     /*  955601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  955612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  955615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  955618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  955621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955628 */     // MIs[0] op1
     /*  955628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955631 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955655 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  955655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  955658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955660 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955662 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955664 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955666 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955676 */     GIR_RootConstrainSelectedInstOperands,
     /*  955677 */     // GIR_Coverage, 64088,
     /*  955677 */     GIR_EraseRootFromParent_Done,
     /*  955678 */   // Label 14399: @955678
     /*  955678 */   GIM_Try, /*On fail goto*//*Label 14400*/ GIMT_Encode4(955760), // Rule ID 64093 //
     /*  955683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955710 */     // MIs[0] op1
     /*  955710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955737 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF4),
     /*  955740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955742 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955744 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955746 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955748 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955758 */     GIR_RootConstrainSelectedInstOperands,
     /*  955759 */     // GIR_Coverage, 64093,
     /*  955759 */     GIR_EraseRootFromParent_Done,
     /*  955760 */   // Label 14400: @955760
     /*  955760 */   GIM_Try, /*On fail goto*//*Label 14401*/ GIMT_Encode4(955842), // Rule ID 64094 //
     /*  955765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955792 */     // MIs[0] op1
     /*  955792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955795 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955819 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF4),
     /*  955822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955824 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955826 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955828 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955830 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955840 */     GIR_RootConstrainSelectedInstOperands,
     /*  955841 */     // GIR_Coverage, 64094,
     /*  955841 */     GIR_EraseRootFromParent_Done,
     /*  955842 */   // Label 14401: @955842
     /*  955842 */   GIM_Try, /*On fail goto*//*Label 14402*/ GIMT_Encode4(955924), // Rule ID 64105 //
     /*  955847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  955867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955874 */     // MIs[0] op1
     /*  955874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955901 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF4),
     /*  955904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955906 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955908 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955910 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955912 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955922 */     GIR_RootConstrainSelectedInstOperands,
     /*  955923 */     // GIR_Coverage, 64105,
     /*  955923 */     GIR_EraseRootFromParent_Done,
     /*  955924 */   // Label 14402: @955924
     /*  955924 */   GIM_Try, /*On fail goto*//*Label 14403*/ GIMT_Encode4(956006), // Rule ID 64106 //
     /*  955929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  955949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955956 */     // MIs[0] op1
     /*  955956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955983 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF4),
     /*  955986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955988 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955990 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955992 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955994 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956004 */     GIR_RootConstrainSelectedInstOperands,
     /*  956005 */     // GIR_Coverage, 64106,
     /*  956005 */     GIR_EraseRootFromParent_Done,
     /*  956006 */   // Label 14403: @956006
     /*  956006 */   GIM_Try, /*On fail goto*//*Label 14404*/ GIMT_Encode4(956088), // Rule ID 64111 //
     /*  956011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  956022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  956025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  956028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956038 */     // MIs[0] op1
     /*  956038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956041 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956065 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_MF4),
     /*  956068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956070 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956072 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956074 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956076 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956086 */     GIR_RootConstrainSelectedInstOperands,
     /*  956087 */     // GIR_Coverage, 64111,
     /*  956087 */     GIR_EraseRootFromParent_Done,
     /*  956088 */   // Label 14404: @956088
     /*  956088 */   GIM_Try, /*On fail goto*//*Label 14405*/ GIMT_Encode4(956170), // Rule ID 64112 //
     /*  956093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  956104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  956107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  956110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956120 */     // MIs[0] op1
     /*  956120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956147 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_MF4),
     /*  956150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956152 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956154 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956156 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956158 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956168 */     GIR_RootConstrainSelectedInstOperands,
     /*  956169 */     // GIR_Coverage, 64112,
     /*  956169 */     GIR_EraseRootFromParent_Done,
     /*  956170 */   // Label 14405: @956170
     /*  956170 */   GIM_Try, /*On fail goto*//*Label 14406*/ GIMT_Encode4(956252), // Rule ID 64117 //
     /*  956175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956202 */     // MIs[0] op1
     /*  956202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956205 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956229 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  956232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956234 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956236 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956238 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956240 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956250 */     GIR_RootConstrainSelectedInstOperands,
     /*  956251 */     // GIR_Coverage, 64117,
     /*  956251 */     GIR_EraseRootFromParent_Done,
     /*  956252 */   // Label 14406: @956252
     /*  956252 */   GIM_Try, /*On fail goto*//*Label 14407*/ GIMT_Encode4(956334), // Rule ID 64118 //
     /*  956257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956284 */     // MIs[0] op1
     /*  956284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956311 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  956314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956316 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956318 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956320 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956322 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956332 */     GIR_RootConstrainSelectedInstOperands,
     /*  956333 */     // GIR_Coverage, 64118,
     /*  956333 */     GIR_EraseRootFromParent_Done,
     /*  956334 */   // Label 14407: @956334
     /*  956334 */   GIM_Try, /*On fail goto*//*Label 14408*/ GIMT_Encode4(956416), // Rule ID 64129 //
     /*  956339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  956359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956366 */     // MIs[0] op1
     /*  956366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956393 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  956396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956398 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956400 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956402 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956404 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956414 */     GIR_RootConstrainSelectedInstOperands,
     /*  956415 */     // GIR_Coverage, 64129,
     /*  956415 */     GIR_EraseRootFromParent_Done,
     /*  956416 */   // Label 14408: @956416
     /*  956416 */   GIM_Try, /*On fail goto*//*Label 14409*/ GIMT_Encode4(956498), // Rule ID 64130 //
     /*  956421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  956441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956448 */     // MIs[0] op1
     /*  956448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956475 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  956478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956480 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956482 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956484 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956486 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956496 */     GIR_RootConstrainSelectedInstOperands,
     /*  956497 */     // GIR_Coverage, 64130,
     /*  956497 */     GIR_EraseRootFromParent_Done,
     /*  956498 */   // Label 14409: @956498
     /*  956498 */   GIM_Try, /*On fail goto*//*Label 14410*/ GIMT_Encode4(956580), // Rule ID 64135 //
     /*  956503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956530 */     // MIs[0] op1
     /*  956530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956533 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956557 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_MF2),
     /*  956560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956562 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956564 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956566 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956568 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956578 */     GIR_RootConstrainSelectedInstOperands,
     /*  956579 */     // GIR_Coverage, 64135,
     /*  956579 */     GIR_EraseRootFromParent_Done,
     /*  956580 */   // Label 14410: @956580
     /*  956580 */   GIM_Try, /*On fail goto*//*Label 14411*/ GIMT_Encode4(956662), // Rule ID 64136 //
     /*  956585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956612 */     // MIs[0] op1
     /*  956612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956639 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_MF2),
     /*  956642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956644 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956646 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956648 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956650 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956660 */     GIR_RootConstrainSelectedInstOperands,
     /*  956661 */     // GIR_Coverage, 64136,
     /*  956661 */     GIR_EraseRootFromParent_Done,
     /*  956662 */   // Label 14411: @956662
     /*  956662 */   GIM_Try, /*On fail goto*//*Label 14412*/ GIMT_Encode4(956744), // Rule ID 64141 //
     /*  956667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956694 */     // MIs[0] op1
     /*  956694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956697 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  956724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956726 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956728 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956730 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956732 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956742 */     GIR_RootConstrainSelectedInstOperands,
     /*  956743 */     // GIR_Coverage, 64141,
     /*  956743 */     GIR_EraseRootFromParent_Done,
     /*  956744 */   // Label 14412: @956744
     /*  956744 */   GIM_Try, /*On fail goto*//*Label 14413*/ GIMT_Encode4(956826), // Rule ID 64142 //
     /*  956749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956776 */     // MIs[0] op1
     /*  956776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  956806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956808 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956810 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956812 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956814 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956824 */     GIR_RootConstrainSelectedInstOperands,
     /*  956825 */     // GIR_Coverage, 64142,
     /*  956825 */     GIR_EraseRootFromParent_Done,
     /*  956826 */   // Label 14413: @956826
     /*  956826 */   GIM_Try, /*On fail goto*//*Label 14414*/ GIMT_Encode4(956908), // Rule ID 64153 //
     /*  956831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  956851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956858 */     // MIs[0] op1
     /*  956858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956861 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956885 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  956888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956890 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956892 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956894 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956896 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956906 */     GIR_RootConstrainSelectedInstOperands,
     /*  956907 */     // GIR_Coverage, 64153,
     /*  956907 */     GIR_EraseRootFromParent_Done,
     /*  956908 */   // Label 14414: @956908
     /*  956908 */   GIM_Try, /*On fail goto*//*Label 14415*/ GIMT_Encode4(956990), // Rule ID 64154 //
     /*  956913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  956933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956940 */     // MIs[0] op1
     /*  956940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956967 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  956970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956972 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956974 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956976 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956978 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956988 */     GIR_RootConstrainSelectedInstOperands,
     /*  956989 */     // GIR_Coverage, 64154,
     /*  956989 */     GIR_EraseRootFromParent_Done,
     /*  956990 */   // Label 14415: @956990
     /*  956990 */   GIM_Try, /*On fail goto*//*Label 14416*/ GIMT_Encode4(957072), // Rule ID 64159 //
     /*  956995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  957006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  957009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  957012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957022 */     // MIs[0] op1
     /*  957022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957025 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M1),
     /*  957052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957054 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957056 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957058 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957060 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957070 */     GIR_RootConstrainSelectedInstOperands,
     /*  957071 */     // GIR_Coverage, 64159,
     /*  957071 */     GIR_EraseRootFromParent_Done,
     /*  957072 */   // Label 14416: @957072
     /*  957072 */   GIM_Try, /*On fail goto*//*Label 14417*/ GIMT_Encode4(957154), // Rule ID 64160 //
     /*  957077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  957088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  957091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  957094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957104 */     // MIs[0] op1
     /*  957104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957131 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M1),
     /*  957134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957136 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957138 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957140 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957142 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957152 */     GIR_RootConstrainSelectedInstOperands,
     /*  957153 */     // GIR_Coverage, 64160,
     /*  957153 */     GIR_EraseRootFromParent_Done,
     /*  957154 */   // Label 14417: @957154
     /*  957154 */   GIM_Try, /*On fail goto*//*Label 14418*/ GIMT_Encode4(957236), // Rule ID 64165 //
     /*  957159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957186 */     // MIs[0] op1
     /*  957186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957213 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  957216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957218 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957220 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957222 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957224 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957234 */     GIR_RootConstrainSelectedInstOperands,
     /*  957235 */     // GIR_Coverage, 64165,
     /*  957235 */     GIR_EraseRootFromParent_Done,
     /*  957236 */   // Label 14418: @957236
     /*  957236 */   GIM_Try, /*On fail goto*//*Label 14419*/ GIMT_Encode4(957318), // Rule ID 64166 //
     /*  957241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957268 */     // MIs[0] op1
     /*  957268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957295 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  957298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957300 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957302 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957304 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957306 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957316 */     GIR_RootConstrainSelectedInstOperands,
     /*  957317 */     // GIR_Coverage, 64166,
     /*  957317 */     GIR_EraseRootFromParent_Done,
     /*  957318 */   // Label 14419: @957318
     /*  957318 */   GIM_Try, /*On fail goto*//*Label 14420*/ GIMT_Encode4(957400), // Rule ID 64177 //
     /*  957323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  957343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957350 */     // MIs[0] op1
     /*  957350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957377 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  957380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957382 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957384 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957386 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957388 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957398 */     GIR_RootConstrainSelectedInstOperands,
     /*  957399 */     // GIR_Coverage, 64177,
     /*  957399 */     GIR_EraseRootFromParent_Done,
     /*  957400 */   // Label 14420: @957400
     /*  957400 */   GIM_Try, /*On fail goto*//*Label 14421*/ GIMT_Encode4(957482), // Rule ID 64178 //
     /*  957405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  957425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957432 */     // MIs[0] op1
     /*  957432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957459 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  957462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957464 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957466 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957468 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957470 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957480 */     GIR_RootConstrainSelectedInstOperands,
     /*  957481 */     // GIR_Coverage, 64178,
     /*  957481 */     GIR_EraseRootFromParent_Done,
     /*  957482 */   // Label 14421: @957482
     /*  957482 */   GIM_Try, /*On fail goto*//*Label 14422*/ GIMT_Encode4(957564), // Rule ID 64183 //
     /*  957487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957514 */     // MIs[0] op1
     /*  957514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957541 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M2),
     /*  957544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957546 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957548 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957550 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957552 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957562 */     GIR_RootConstrainSelectedInstOperands,
     /*  957563 */     // GIR_Coverage, 64183,
     /*  957563 */     GIR_EraseRootFromParent_Done,
     /*  957564 */   // Label 14422: @957564
     /*  957564 */   GIM_Try, /*On fail goto*//*Label 14423*/ GIMT_Encode4(957646), // Rule ID 64184 //
     /*  957569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957596 */     // MIs[0] op1
     /*  957596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957623 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M2),
     /*  957626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957628 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957630 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957632 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957634 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957644 */     GIR_RootConstrainSelectedInstOperands,
     /*  957645 */     // GIR_Coverage, 64184,
     /*  957645 */     GIR_EraseRootFromParent_Done,
     /*  957646 */   // Label 14423: @957646
     /*  957646 */   GIM_Try, /*On fail goto*//*Label 14424*/ GIMT_Encode4(957728), // Rule ID 64189 //
     /*  957651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957678 */     // MIs[0] op1
     /*  957678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957705 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  957708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957710 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957712 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957714 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957716 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957726 */     GIR_RootConstrainSelectedInstOperands,
     /*  957727 */     // GIR_Coverage, 64189,
     /*  957727 */     GIR_EraseRootFromParent_Done,
     /*  957728 */   // Label 14424: @957728
     /*  957728 */   GIM_Try, /*On fail goto*//*Label 14425*/ GIMT_Encode4(957810), // Rule ID 64190 //
     /*  957733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957760 */     // MIs[0] op1
     /*  957760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957787 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  957790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957792 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957794 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957796 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957798 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957808 */     GIR_RootConstrainSelectedInstOperands,
     /*  957809 */     // GIR_Coverage, 64190,
     /*  957809 */     GIR_EraseRootFromParent_Done,
     /*  957810 */   // Label 14425: @957810
     /*  957810 */   GIM_Try, /*On fail goto*//*Label 14426*/ GIMT_Encode4(957892), // Rule ID 64201 //
     /*  957815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  957835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957842 */     // MIs[0] op1
     /*  957842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957845 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957869 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  957872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957874 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957876 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957878 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957880 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957890 */     GIR_RootConstrainSelectedInstOperands,
     /*  957891 */     // GIR_Coverage, 64201,
     /*  957891 */     GIR_EraseRootFromParent_Done,
     /*  957892 */   // Label 14426: @957892
     /*  957892 */   GIM_Try, /*On fail goto*//*Label 14427*/ GIMT_Encode4(957974), // Rule ID 64202 //
     /*  957897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  957917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957924 */     // MIs[0] op1
     /*  957924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957951 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  957954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957956 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957958 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957960 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957962 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957972 */     GIR_RootConstrainSelectedInstOperands,
     /*  957973 */     // GIR_Coverage, 64202,
     /*  957973 */     GIR_EraseRootFromParent_Done,
     /*  957974 */   // Label 14427: @957974
     /*  957974 */   GIM_Try, /*On fail goto*//*Label 14428*/ GIMT_Encode4(958056), // Rule ID 64207 //
     /*  957979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958006 */     // MIs[0] op1
     /*  958006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  958026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958033 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  958033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M4),
     /*  958036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958038 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958040 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958042 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958044 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  958054 */     GIR_RootConstrainSelectedInstOperands,
     /*  958055 */     // GIR_Coverage, 64207,
     /*  958055 */     GIR_EraseRootFromParent_Done,
     /*  958056 */   // Label 14428: @958056
     /*  958056 */   GIM_Try, /*On fail goto*//*Label 14429*/ GIMT_Encode4(958138), // Rule ID 64208 //
     /*  958061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  958072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  958075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  958078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  958081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958088 */     // MIs[0] op1
     /*  958088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958091 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  958108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958115 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  958115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M4),
     /*  958118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958120 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958122 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958124 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958126 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  958136 */     GIR_RootConstrainSelectedInstOperands,
     /*  958137 */     // GIR_Coverage, 64208,
     /*  958137 */     GIR_EraseRootFromParent_Done,
     /*  958138 */   // Label 14429: @958138
     /*  958138 */   GIM_Try, /*On fail goto*//*Label 14430*/ GIMT_Encode4(958220), // Rule ID 64213 //
     /*  958143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958170 */     // MIs[0] op1
     /*  958170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958173 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958197 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  958200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958202 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958204 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958206 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958208 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958218 */     GIR_RootConstrainSelectedInstOperands,
     /*  958219 */     // GIR_Coverage, 64213,
     /*  958219 */     GIR_EraseRootFromParent_Done,
     /*  958220 */   // Label 14430: @958220
     /*  958220 */   GIM_Try, /*On fail goto*//*Label 14431*/ GIMT_Encode4(958302), // Rule ID 64214 //
     /*  958225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958252 */     // MIs[0] op1
     /*  958252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958279 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  958282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958284 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958286 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958288 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958290 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958300 */     GIR_RootConstrainSelectedInstOperands,
     /*  958301 */     // GIR_Coverage, 64214,
     /*  958301 */     GIR_EraseRootFromParent_Done,
     /*  958302 */   // Label 14431: @958302
     /*  958302 */   GIM_Try, /*On fail goto*//*Label 14432*/ GIMT_Encode4(958384), // Rule ID 64225 //
     /*  958307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  958327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958334 */     // MIs[0] op1
     /*  958334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958361 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  958364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958366 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958368 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958370 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958372 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958382 */     GIR_RootConstrainSelectedInstOperands,
     /*  958383 */     // GIR_Coverage, 64225,
     /*  958383 */     GIR_EraseRootFromParent_Done,
     /*  958384 */   // Label 14432: @958384
     /*  958384 */   GIM_Try, /*On fail goto*//*Label 14433*/ GIMT_Encode4(958466), // Rule ID 64226 //
     /*  958389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  958409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958416 */     // MIs[0] op1
     /*  958416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958443 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  958446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958448 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958450 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958452 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958454 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958464 */     GIR_RootConstrainSelectedInstOperands,
     /*  958465 */     // GIR_Coverage, 64226,
     /*  958465 */     GIR_EraseRootFromParent_Done,
     /*  958466 */   // Label 14433: @958466
     /*  958466 */   GIM_Try, /*On fail goto*//*Label 14434*/ GIMT_Encode4(958548), // Rule ID 64231 //
     /*  958471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958498 */     // MIs[0] op1
     /*  958498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958525 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_MF2),
     /*  958528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958530 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958532 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958534 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958536 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958546 */     GIR_RootConstrainSelectedInstOperands,
     /*  958547 */     // GIR_Coverage, 64231,
     /*  958547 */     GIR_EraseRootFromParent_Done,
     /*  958548 */   // Label 14434: @958548
     /*  958548 */   GIM_Try, /*On fail goto*//*Label 14435*/ GIMT_Encode4(958630), // Rule ID 64232 //
     /*  958553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958580 */     // MIs[0] op1
     /*  958580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958607 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_MF2),
     /*  958610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958612 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958614 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958616 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958618 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958628 */     GIR_RootConstrainSelectedInstOperands,
     /*  958629 */     // GIR_Coverage, 64232,
     /*  958629 */     GIR_EraseRootFromParent_Done,
     /*  958630 */   // Label 14435: @958630
     /*  958630 */   GIM_Try, /*On fail goto*//*Label 14436*/ GIMT_Encode4(958712), // Rule ID 64237 //
     /*  958635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958662 */     // MIs[0] op1
     /*  958662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958665 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  958692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958694 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958696 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958698 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958700 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958710 */     GIR_RootConstrainSelectedInstOperands,
     /*  958711 */     // GIR_Coverage, 64237,
     /*  958711 */     GIR_EraseRootFromParent_Done,
     /*  958712 */   // Label 14436: @958712
     /*  958712 */   GIM_Try, /*On fail goto*//*Label 14437*/ GIMT_Encode4(958794), // Rule ID 64238 //
     /*  958717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958744 */     // MIs[0] op1
     /*  958744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958771 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  958774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958776 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958778 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958780 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958782 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958792 */     GIR_RootConstrainSelectedInstOperands,
     /*  958793 */     // GIR_Coverage, 64238,
     /*  958793 */     GIR_EraseRootFromParent_Done,
     /*  958794 */   // Label 14437: @958794
     /*  958794 */   GIM_Try, /*On fail goto*//*Label 14438*/ GIMT_Encode4(958876), // Rule ID 64249 //
     /*  958799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  958819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958826 */     // MIs[0] op1
     /*  958826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958829 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958853 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  958856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958858 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958860 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958862 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958864 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958874 */     GIR_RootConstrainSelectedInstOperands,
     /*  958875 */     // GIR_Coverage, 64249,
     /*  958875 */     GIR_EraseRootFromParent_Done,
     /*  958876 */   // Label 14438: @958876
     /*  958876 */   GIM_Try, /*On fail goto*//*Label 14439*/ GIMT_Encode4(958958), // Rule ID 64250 //
     /*  958881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  958901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958908 */     // MIs[0] op1
     /*  958908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958935 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  958938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958940 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958942 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958944 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958946 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958956 */     GIR_RootConstrainSelectedInstOperands,
     /*  958957 */     // GIR_Coverage, 64250,
     /*  958957 */     GIR_EraseRootFromParent_Done,
     /*  958958 */   // Label 14439: @958958
     /*  958958 */   GIM_Try, /*On fail goto*//*Label 14440*/ GIMT_Encode4(959040), // Rule ID 64255 //
     /*  958963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958990 */     // MIs[0] op1
     /*  958990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959017 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M1),
     /*  959020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959022 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959024 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959026 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959028 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959038 */     GIR_RootConstrainSelectedInstOperands,
     /*  959039 */     // GIR_Coverage, 64255,
     /*  959039 */     GIR_EraseRootFromParent_Done,
     /*  959040 */   // Label 14440: @959040
     /*  959040 */   GIM_Try, /*On fail goto*//*Label 14441*/ GIMT_Encode4(959122), // Rule ID 64256 //
     /*  959045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  959056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  959059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  959062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959072 */     // MIs[0] op1
     /*  959072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959099 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M1),
     /*  959102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959104 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959106 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959108 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959110 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959120 */     GIR_RootConstrainSelectedInstOperands,
     /*  959121 */     // GIR_Coverage, 64256,
     /*  959121 */     GIR_EraseRootFromParent_Done,
     /*  959122 */   // Label 14441: @959122
     /*  959122 */   GIM_Try, /*On fail goto*//*Label 14442*/ GIMT_Encode4(959204), // Rule ID 64261 //
     /*  959127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959154 */     // MIs[0] op1
     /*  959154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959157 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959181 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  959184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959186 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959188 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959190 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959192 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959202 */     GIR_RootConstrainSelectedInstOperands,
     /*  959203 */     // GIR_Coverage, 64261,
     /*  959203 */     GIR_EraseRootFromParent_Done,
     /*  959204 */   // Label 14442: @959204
     /*  959204 */   GIM_Try, /*On fail goto*//*Label 14443*/ GIMT_Encode4(959286), // Rule ID 64262 //
     /*  959209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959236 */     // MIs[0] op1
     /*  959236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959263 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  959266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959268 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959270 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959272 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959274 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959284 */     GIR_RootConstrainSelectedInstOperands,
     /*  959285 */     // GIR_Coverage, 64262,
     /*  959285 */     GIR_EraseRootFromParent_Done,
     /*  959286 */   // Label 14443: @959286
     /*  959286 */   GIM_Try, /*On fail goto*//*Label 14444*/ GIMT_Encode4(959368), // Rule ID 64273 //
     /*  959291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  959311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959318 */     // MIs[0] op1
     /*  959318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959345 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  959348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959350 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959352 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959354 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959356 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959366 */     GIR_RootConstrainSelectedInstOperands,
     /*  959367 */     // GIR_Coverage, 64273,
     /*  959367 */     GIR_EraseRootFromParent_Done,
     /*  959368 */   // Label 14444: @959368
     /*  959368 */   GIM_Try, /*On fail goto*//*Label 14445*/ GIMT_Encode4(959450), // Rule ID 64274 //
     /*  959373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  959393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959400 */     // MIs[0] op1
     /*  959400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959427 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  959430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959432 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959434 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959436 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959438 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959448 */     GIR_RootConstrainSelectedInstOperands,
     /*  959449 */     // GIR_Coverage, 64274,
     /*  959449 */     GIR_EraseRootFromParent_Done,
     /*  959450 */   // Label 14445: @959450
     /*  959450 */   GIM_Try, /*On fail goto*//*Label 14446*/ GIMT_Encode4(959532), // Rule ID 64279 //
     /*  959455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959482 */     // MIs[0] op1
     /*  959482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959485 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959509 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M2),
     /*  959512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959514 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959516 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959518 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959520 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959530 */     GIR_RootConstrainSelectedInstOperands,
     /*  959531 */     // GIR_Coverage, 64279,
     /*  959531 */     GIR_EraseRootFromParent_Done,
     /*  959532 */   // Label 14446: @959532
     /*  959532 */   GIM_Try, /*On fail goto*//*Label 14447*/ GIMT_Encode4(959614), // Rule ID 64280 //
     /*  959537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959564 */     // MIs[0] op1
     /*  959564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959567 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959591 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M2),
     /*  959594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959596 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959598 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959600 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959602 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959612 */     GIR_RootConstrainSelectedInstOperands,
     /*  959613 */     // GIR_Coverage, 64280,
     /*  959613 */     GIR_EraseRootFromParent_Done,
     /*  959614 */   // Label 14447: @959614
     /*  959614 */   GIM_Try, /*On fail goto*//*Label 14448*/ GIMT_Encode4(959696), // Rule ID 64285 //
     /*  959619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959646 */     // MIs[0] op1
     /*  959646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959649 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959673 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  959676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959678 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959680 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959682 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959684 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959694 */     GIR_RootConstrainSelectedInstOperands,
     /*  959695 */     // GIR_Coverage, 64285,
     /*  959695 */     GIR_EraseRootFromParent_Done,
     /*  959696 */   // Label 14448: @959696
     /*  959696 */   GIM_Try, /*On fail goto*//*Label 14449*/ GIMT_Encode4(959778), // Rule ID 64286 //
     /*  959701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959728 */     // MIs[0] op1
     /*  959728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959755 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  959758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959760 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959762 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959764 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959766 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959776 */     GIR_RootConstrainSelectedInstOperands,
     /*  959777 */     // GIR_Coverage, 64286,
     /*  959777 */     GIR_EraseRootFromParent_Done,
     /*  959778 */   // Label 14449: @959778
     /*  959778 */   GIM_Try, /*On fail goto*//*Label 14450*/ GIMT_Encode4(959860), // Rule ID 64297 //
     /*  959783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  959803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959810 */     // MIs[0] op1
     /*  959810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959837 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  959840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959842 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959844 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959846 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959848 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959858 */     GIR_RootConstrainSelectedInstOperands,
     /*  959859 */     // GIR_Coverage, 64297,
     /*  959859 */     GIR_EraseRootFromParent_Done,
     /*  959860 */   // Label 14450: @959860
     /*  959860 */   GIM_Try, /*On fail goto*//*Label 14451*/ GIMT_Encode4(959942), // Rule ID 64298 //
     /*  959865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  959885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959892 */     // MIs[0] op1
     /*  959892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959919 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  959922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959924 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959926 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959928 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959930 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959940 */     GIR_RootConstrainSelectedInstOperands,
     /*  959941 */     // GIR_Coverage, 64298,
     /*  959941 */     GIR_EraseRootFromParent_Done,
     /*  959942 */   // Label 14451: @959942
     /*  959942 */   GIM_Try, /*On fail goto*//*Label 14452*/ GIMT_Encode4(960024), // Rule ID 64303 //
     /*  959947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959974 */     // MIs[0] op1
     /*  959974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960001 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  960001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M4),
     /*  960004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960006 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960008 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960010 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960012 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960022 */     GIR_RootConstrainSelectedInstOperands,
     /*  960023 */     // GIR_Coverage, 64303,
     /*  960023 */     GIR_EraseRootFromParent_Done,
     /*  960024 */   // Label 14452: @960024
     /*  960024 */   GIM_Try, /*On fail goto*//*Label 14453*/ GIMT_Encode4(960106), // Rule ID 64304 //
     /*  960029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  960037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  960040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  960043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  960046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  960049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  960056 */     // MIs[0] op1
     /*  960056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960059 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  960064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  960068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  960076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960083 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  960083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M4),
     /*  960086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960088 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960090 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960092 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960094 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960104 */     GIR_RootConstrainSelectedInstOperands,
     /*  960105 */     // GIR_Coverage, 64304,
     /*  960105 */     GIR_EraseRootFromParent_Done,
     /*  960106 */   // Label 14453: @960106
     /*  960106 */   GIM_Try, /*On fail goto*//*Label 14454*/ GIMT_Encode4(960198), // Rule ID 5216 //
     /*  960111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  960122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  960125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  960128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960161 */     // MIs[1] Operand 1
     /*  960161 */     // No operand predicates
     /*  960161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960174 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  960174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  960177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960196 */     GIR_RootConstrainSelectedInstOperands,
     /*  960197 */     // GIR_Coverage, 5216,
     /*  960197 */     GIR_EraseRootFromParent_Done,
     /*  960198 */   // Label 14454: @960198
     /*  960198 */   GIM_Try, /*On fail goto*//*Label 14455*/ GIMT_Encode4(960290), // Rule ID 5217 //
     /*  960203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  960214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  960217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  960220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960253 */     // MIs[1] Operand 1
     /*  960253 */     // No operand predicates
     /*  960253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960266 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  960266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  960269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960288 */     GIR_RootConstrainSelectedInstOperands,
     /*  960289 */     // GIR_Coverage, 5217,
     /*  960289 */     GIR_EraseRootFromParent_Done,
     /*  960290 */   // Label 14455: @960290
     /*  960290 */   GIM_Try, /*On fail goto*//*Label 14456*/ GIMT_Encode4(960382), // Rule ID 5218 //
     /*  960295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  960306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  960309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  960312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960345 */     // MIs[1] Operand 1
     /*  960345 */     // No operand predicates
     /*  960345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960358 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  960358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  960361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960380 */     GIR_RootConstrainSelectedInstOperands,
     /*  960381 */     // GIR_Coverage, 5218,
     /*  960381 */     GIR_EraseRootFromParent_Done,
     /*  960382 */   // Label 14456: @960382
     /*  960382 */   GIM_Try, /*On fail goto*//*Label 14457*/ GIMT_Encode4(960474), // Rule ID 5219 //
     /*  960387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  960398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  960401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  960404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960437 */     // MIs[1] Operand 1
     /*  960437 */     // No operand predicates
     /*  960437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960450 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  960450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  960453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960472 */     GIR_RootConstrainSelectedInstOperands,
     /*  960473 */     // GIR_Coverage, 5219,
     /*  960473 */     GIR_EraseRootFromParent_Done,
     /*  960474 */   // Label 14457: @960474
     /*  960474 */   GIM_Try, /*On fail goto*//*Label 14458*/ GIMT_Encode4(960566), // Rule ID 5220 //
     /*  960479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  960490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  960493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  960496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  960502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960529 */     // MIs[1] Operand 1
     /*  960529 */     // No operand predicates
     /*  960529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960542 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  960542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960564 */     GIR_RootConstrainSelectedInstOperands,
     /*  960565 */     // GIR_Coverage, 5220,
     /*  960565 */     GIR_EraseRootFromParent_Done,
     /*  960566 */   // Label 14458: @960566
     /*  960566 */   GIM_Try, /*On fail goto*//*Label 14459*/ GIMT_Encode4(960658), // Rule ID 5221 //
     /*  960571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  960582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  960585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  960588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  960594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960621 */     // MIs[1] Operand 1
     /*  960621 */     // No operand predicates
     /*  960621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960634 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  960634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960656 */     GIR_RootConstrainSelectedInstOperands,
     /*  960657 */     // GIR_Coverage, 5221,
     /*  960657 */     GIR_EraseRootFromParent_Done,
     /*  960658 */   // Label 14459: @960658
     /*  960658 */   GIM_Try, /*On fail goto*//*Label 14460*/ GIMT_Encode4(960750), // Rule ID 5222 //
     /*  960663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  960674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  960677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  960680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960713 */     // MIs[1] Operand 1
     /*  960713 */     // No operand predicates
     /*  960713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960726 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  960729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960748 */     GIR_RootConstrainSelectedInstOperands,
     /*  960749 */     // GIR_Coverage, 5222,
     /*  960749 */     GIR_EraseRootFromParent_Done,
     /*  960750 */   // Label 14460: @960750
     /*  960750 */   GIM_Try, /*On fail goto*//*Label 14461*/ GIMT_Encode4(960842), // Rule ID 5223 //
     /*  960755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  960766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  960769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  960772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960805 */     // MIs[1] Operand 1
     /*  960805 */     // No operand predicates
     /*  960805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960818 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  960821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960840 */     GIR_RootConstrainSelectedInstOperands,
     /*  960841 */     // GIR_Coverage, 5223,
     /*  960841 */     GIR_EraseRootFromParent_Done,
     /*  960842 */   // Label 14461: @960842
     /*  960842 */   GIM_Try, /*On fail goto*//*Label 14462*/ GIMT_Encode4(960934), // Rule ID 5224 //
     /*  960847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  960858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  960861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  960864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960897 */     // MIs[1] Operand 1
     /*  960897 */     // No operand predicates
     /*  960897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960910 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960932 */     GIR_RootConstrainSelectedInstOperands,
     /*  960933 */     // GIR_Coverage, 5224,
     /*  960933 */     GIR_EraseRootFromParent_Done,
     /*  960934 */   // Label 14462: @960934
     /*  960934 */   GIM_Try, /*On fail goto*//*Label 14463*/ GIMT_Encode4(961026), // Rule ID 5225 //
     /*  960939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  960950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  960953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  960956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960989 */     // MIs[1] Operand 1
     /*  960989 */     // No operand predicates
     /*  960989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961002 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  961005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961024 */     GIR_RootConstrainSelectedInstOperands,
     /*  961025 */     // GIR_Coverage, 5225,
     /*  961025 */     GIR_EraseRootFromParent_Done,
     /*  961026 */   // Label 14463: @961026
     /*  961026 */   GIM_Try, /*On fail goto*//*Label 14464*/ GIMT_Encode4(961118), // Rule ID 5226 //
     /*  961031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  961042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  961045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  961048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  961054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961081 */     // MIs[1] Operand 1
     /*  961081 */     // No operand predicates
     /*  961081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961094 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  961094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  961097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961116 */     GIR_RootConstrainSelectedInstOperands,
     /*  961117 */     // GIR_Coverage, 5226,
     /*  961117 */     GIR_EraseRootFromParent_Done,
     /*  961118 */   // Label 14464: @961118
     /*  961118 */   GIM_Try, /*On fail goto*//*Label 14465*/ GIMT_Encode4(961210), // Rule ID 5227 //
     /*  961123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  961134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  961137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  961140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  961146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961173 */     // MIs[1] Operand 1
     /*  961173 */     // No operand predicates
     /*  961173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  961186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  961189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961208 */     GIR_RootConstrainSelectedInstOperands,
     /*  961209 */     // GIR_Coverage, 5227,
     /*  961209 */     GIR_EraseRootFromParent_Done,
     /*  961210 */   // Label 14465: @961210
     /*  961210 */   GIM_Try, /*On fail goto*//*Label 14466*/ GIMT_Encode4(961302), // Rule ID 5228 //
     /*  961215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  961226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  961229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  961232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  961238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961265 */     // MIs[1] Operand 1
     /*  961265 */     // No operand predicates
     /*  961265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961278 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  961278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961300 */     GIR_RootConstrainSelectedInstOperands,
     /*  961301 */     // GIR_Coverage, 5228,
     /*  961301 */     GIR_EraseRootFromParent_Done,
     /*  961302 */   // Label 14466: @961302
     /*  961302 */   GIM_Try, /*On fail goto*//*Label 14467*/ GIMT_Encode4(961394), // Rule ID 5229 //
     /*  961307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  961318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  961321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  961324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  961330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961357 */     // MIs[1] Operand 1
     /*  961357 */     // No operand predicates
     /*  961357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961370 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  961370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961392 */     GIR_RootConstrainSelectedInstOperands,
     /*  961393 */     // GIR_Coverage, 5229,
     /*  961393 */     GIR_EraseRootFromParent_Done,
     /*  961394 */   // Label 14467: @961394
     /*  961394 */   GIM_Try, /*On fail goto*//*Label 14468*/ GIMT_Encode4(961486), // Rule ID 5230 //
     /*  961399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  961410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  961413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  961416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  961422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961449 */     // MIs[1] Operand 1
     /*  961449 */     // No operand predicates
     /*  961449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961462 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  961462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961484 */     GIR_RootConstrainSelectedInstOperands,
     /*  961485 */     // GIR_Coverage, 5230,
     /*  961485 */     GIR_EraseRootFromParent_Done,
     /*  961486 */   // Label 14468: @961486
     /*  961486 */   GIM_Try, /*On fail goto*//*Label 14469*/ GIMT_Encode4(961578), // Rule ID 5231 //
     /*  961491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  961502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  961505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  961508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  961514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961541 */     // MIs[1] Operand 1
     /*  961541 */     // No operand predicates
     /*  961541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961554 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961576 */     GIR_RootConstrainSelectedInstOperands,
     /*  961577 */     // GIR_Coverage, 5231,
     /*  961577 */     GIR_EraseRootFromParent_Done,
     /*  961578 */   // Label 14469: @961578
     /*  961578 */   GIM_Try, /*On fail goto*//*Label 14470*/ GIMT_Encode4(961670), // Rule ID 5232 //
     /*  961583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  961594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  961597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  961600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  961606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961633 */     // MIs[1] Operand 1
     /*  961633 */     // No operand predicates
     /*  961633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961646 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  961646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961668 */     GIR_RootConstrainSelectedInstOperands,
     /*  961669 */     // GIR_Coverage, 5232,
     /*  961669 */     GIR_EraseRootFromParent_Done,
     /*  961670 */   // Label 14470: @961670
     /*  961670 */   GIM_Try, /*On fail goto*//*Label 14471*/ GIMT_Encode4(961762), // Rule ID 5233 //
     /*  961675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  961686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  961689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  961692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  961698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961725 */     // MIs[1] Operand 1
     /*  961725 */     // No operand predicates
     /*  961725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  961738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961760 */     GIR_RootConstrainSelectedInstOperands,
     /*  961761 */     // GIR_Coverage, 5233,
     /*  961761 */     GIR_EraseRootFromParent_Done,
     /*  961762 */   // Label 14471: @961762
     /*  961762 */   GIM_Try, /*On fail goto*//*Label 14472*/ GIMT_Encode4(961854), // Rule ID 5234 //
     /*  961767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  961770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  961781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  961790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961817 */     // MIs[1] Operand 1
     /*  961817 */     // No operand predicates
     /*  961817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961830 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  961830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  961852 */     GIR_RootConstrainSelectedInstOperands,
     /*  961853 */     // GIR_Coverage, 5234,
     /*  961853 */     GIR_EraseRootFromParent_Done,
     /*  961854 */   // Label 14472: @961854
     /*  961854 */   GIM_Try, /*On fail goto*//*Label 14473*/ GIMT_Encode4(961946), // Rule ID 5235 //
     /*  961859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  961862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  961873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  961882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961909 */     // MIs[1] Operand 1
     /*  961909 */     // No operand predicates
     /*  961909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961922 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  961922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  961944 */     GIR_RootConstrainSelectedInstOperands,
     /*  961945 */     // GIR_Coverage, 5235,
     /*  961945 */     GIR_EraseRootFromParent_Done,
     /*  961946 */   // Label 14473: @961946
     /*  961946 */   GIM_Try, /*On fail goto*//*Label 14474*/ GIMT_Encode4(962038), // Rule ID 5236 //
     /*  961951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  961962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  961965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  961968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  961974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962001 */     // MIs[1] Operand 1
     /*  962001 */     // No operand predicates
     /*  962001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  962014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962036 */     GIR_RootConstrainSelectedInstOperands,
     /*  962037 */     // GIR_Coverage, 5236,
     /*  962037 */     GIR_EraseRootFromParent_Done,
     /*  962038 */   // Label 14474: @962038
     /*  962038 */   GIM_Try, /*On fail goto*//*Label 14475*/ GIMT_Encode4(962130), // Rule ID 5237 //
     /*  962043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  962054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  962057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  962060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962093 */     // MIs[1] Operand 1
     /*  962093 */     // No operand predicates
     /*  962093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962106 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  962106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962128 */     GIR_RootConstrainSelectedInstOperands,
     /*  962129 */     // GIR_Coverage, 5237,
     /*  962129 */     GIR_EraseRootFromParent_Done,
     /*  962130 */   // Label 14475: @962130
     /*  962130 */   GIM_Try, /*On fail goto*//*Label 14476*/ GIMT_Encode4(962222), // Rule ID 5238 //
     /*  962135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  962146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  962149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  962152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962185 */     // MIs[1] Operand 1
     /*  962185 */     // No operand predicates
     /*  962185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962198 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  962198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962220 */     GIR_RootConstrainSelectedInstOperands,
     /*  962221 */     // GIR_Coverage, 5238,
     /*  962221 */     GIR_EraseRootFromParent_Done,
     /*  962222 */   // Label 14476: @962222
     /*  962222 */   GIM_Try, /*On fail goto*//*Label 14477*/ GIMT_Encode4(962314), // Rule ID 5239 //
     /*  962227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  962238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  962241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  962244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962277 */     // MIs[1] Operand 1
     /*  962277 */     // No operand predicates
     /*  962277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962290 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  962290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962312 */     GIR_RootConstrainSelectedInstOperands,
     /*  962313 */     // GIR_Coverage, 5239,
     /*  962313 */     GIR_EraseRootFromParent_Done,
     /*  962314 */   // Label 14477: @962314
     /*  962314 */   GIM_Try, /*On fail goto*//*Label 14478*/ GIMT_Encode4(962406), // Rule ID 5240 //
     /*  962319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  962330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  962333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  962336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  962342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962369 */     // MIs[1] Operand 1
     /*  962369 */     // No operand predicates
     /*  962369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962382 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  962382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962404 */     GIR_RootConstrainSelectedInstOperands,
     /*  962405 */     // GIR_Coverage, 5240,
     /*  962405 */     GIR_EraseRootFromParent_Done,
     /*  962406 */   // Label 14478: @962406
     /*  962406 */   GIM_Try, /*On fail goto*//*Label 14479*/ GIMT_Encode4(962498), // Rule ID 5241 //
     /*  962411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  962422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  962425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  962428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  962434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962461 */     // MIs[1] Operand 1
     /*  962461 */     // No operand predicates
     /*  962461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962474 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  962474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962496 */     GIR_RootConstrainSelectedInstOperands,
     /*  962497 */     // GIR_Coverage, 5241,
     /*  962497 */     GIR_EraseRootFromParent_Done,
     /*  962498 */   // Label 14479: @962498
     /*  962498 */   GIM_Try, /*On fail goto*//*Label 14480*/ GIMT_Encode4(962590), // Rule ID 5242 //
     /*  962503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  962514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  962517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  962520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962553 */     // MIs[1] Operand 1
     /*  962553 */     // No operand predicates
     /*  962553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962566 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  962566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962588 */     GIR_RootConstrainSelectedInstOperands,
     /*  962589 */     // GIR_Coverage, 5242,
     /*  962589 */     GIR_EraseRootFromParent_Done,
     /*  962590 */   // Label 14480: @962590
     /*  962590 */   GIM_Try, /*On fail goto*//*Label 14481*/ GIMT_Encode4(962682), // Rule ID 5243 //
     /*  962595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  962606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  962609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  962612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962645 */     // MIs[1] Operand 1
     /*  962645 */     // No operand predicates
     /*  962645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962658 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  962658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962680 */     GIR_RootConstrainSelectedInstOperands,
     /*  962681 */     // GIR_Coverage, 5243,
     /*  962681 */     GIR_EraseRootFromParent_Done,
     /*  962682 */   // Label 14481: @962682
     /*  962682 */   GIM_Try, /*On fail goto*//*Label 14482*/ GIMT_Encode4(962774), // Rule ID 5244 //
     /*  962687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  962698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  962701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  962704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962737 */     // MIs[1] Operand 1
     /*  962737 */     // No operand predicates
     /*  962737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962750 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  962750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962772 */     GIR_RootConstrainSelectedInstOperands,
     /*  962773 */     // GIR_Coverage, 5244,
     /*  962773 */     GIR_EraseRootFromParent_Done,
     /*  962774 */   // Label 14482: @962774
     /*  962774 */   GIM_Try, /*On fail goto*//*Label 14483*/ GIMT_Encode4(962866), // Rule ID 5245 //
     /*  962779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  962790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  962793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  962796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962829 */     // MIs[1] Operand 1
     /*  962829 */     // No operand predicates
     /*  962829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962842 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  962842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962864 */     GIR_RootConstrainSelectedInstOperands,
     /*  962865 */     // GIR_Coverage, 5245,
     /*  962865 */     GIR_EraseRootFromParent_Done,
     /*  962866 */   // Label 14483: @962866
     /*  962866 */   GIM_Try, /*On fail goto*//*Label 14484*/ GIMT_Encode4(962958), // Rule ID 5246 //
     /*  962871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  962882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  962885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  962888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962921 */     // MIs[1] Operand 1
     /*  962921 */     // No operand predicates
     /*  962921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962934 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  962934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962956 */     GIR_RootConstrainSelectedInstOperands,
     /*  962957 */     // GIR_Coverage, 5246,
     /*  962957 */     GIR_EraseRootFromParent_Done,
     /*  962958 */   // Label 14484: @962958
     /*  962958 */   GIM_Try, /*On fail goto*//*Label 14485*/ GIMT_Encode4(963050), // Rule ID 5247 //
     /*  962963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  962974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  962977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  962980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963013 */     // MIs[1] Operand 1
     /*  963013 */     // No operand predicates
     /*  963013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963026 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  963026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  963048 */     GIR_RootConstrainSelectedInstOperands,
     /*  963049 */     // GIR_Coverage, 5247,
     /*  963049 */     GIR_EraseRootFromParent_Done,
     /*  963050 */   // Label 14485: @963050
     /*  963050 */   GIM_Try, /*On fail goto*//*Label 14486*/ GIMT_Encode4(963142), // Rule ID 5248 //
     /*  963055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  963066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  963069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  963072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963105 */     // MIs[1] Operand 1
     /*  963105 */     // No operand predicates
     /*  963105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  963121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963140 */     GIR_RootConstrainSelectedInstOperands,
     /*  963141 */     // GIR_Coverage, 5248,
     /*  963141 */     GIR_EraseRootFromParent_Done,
     /*  963142 */   // Label 14486: @963142
     /*  963142 */   GIM_Try, /*On fail goto*//*Label 14487*/ GIMT_Encode4(963234), // Rule ID 5249 //
     /*  963147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  963158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  963161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  963164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963197 */     // MIs[1] Operand 1
     /*  963197 */     // No operand predicates
     /*  963197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  963213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963232 */     GIR_RootConstrainSelectedInstOperands,
     /*  963233 */     // GIR_Coverage, 5249,
     /*  963233 */     GIR_EraseRootFromParent_Done,
     /*  963234 */   // Label 14487: @963234
     /*  963234 */   GIM_Try, /*On fail goto*//*Label 14488*/ GIMT_Encode4(963326), // Rule ID 5250 //
     /*  963239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  963250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  963253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  963256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  963262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963289 */     // MIs[1] Operand 1
     /*  963289 */     // No operand predicates
     /*  963289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  963305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963324 */     GIR_RootConstrainSelectedInstOperands,
     /*  963325 */     // GIR_Coverage, 5250,
     /*  963325 */     GIR_EraseRootFromParent_Done,
     /*  963326 */   // Label 14488: @963326
     /*  963326 */   GIM_Try, /*On fail goto*//*Label 14489*/ GIMT_Encode4(963418), // Rule ID 5251 //
     /*  963331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  963342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  963345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  963348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  963354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963381 */     // MIs[1] Operand 1
     /*  963381 */     // No operand predicates
     /*  963381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963394 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  963397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963416 */     GIR_RootConstrainSelectedInstOperands,
     /*  963417 */     // GIR_Coverage, 5251,
     /*  963417 */     GIR_EraseRootFromParent_Done,
     /*  963418 */   // Label 14489: @963418
     /*  963418 */   GIM_Try, /*On fail goto*//*Label 14490*/ GIMT_Encode4(963510), // Rule ID 5252 //
     /*  963423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  963434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  963437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  963440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  963446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963473 */     // MIs[1] Operand 1
     /*  963473 */     // No operand predicates
     /*  963473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963508 */     GIR_RootConstrainSelectedInstOperands,
     /*  963509 */     // GIR_Coverage, 5252,
     /*  963509 */     GIR_EraseRootFromParent_Done,
     /*  963510 */   // Label 14490: @963510
     /*  963510 */   GIM_Try, /*On fail goto*//*Label 14491*/ GIMT_Encode4(963602), // Rule ID 5253 //
     /*  963515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  963526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  963529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  963532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  963538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963565 */     // MIs[1] Operand 1
     /*  963565 */     // No operand predicates
     /*  963565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963578 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963600 */     GIR_RootConstrainSelectedInstOperands,
     /*  963601 */     // GIR_Coverage, 5253,
     /*  963601 */     GIR_EraseRootFromParent_Done,
     /*  963602 */   // Label 14491: @963602
     /*  963602 */   GIM_Try, /*On fail goto*//*Label 14492*/ GIMT_Encode4(963694), // Rule ID 5254 //
     /*  963607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  963610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  963618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  963621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  963624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963657 */     // MIs[1] Operand 1
     /*  963657 */     // No operand predicates
     /*  963657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  963670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  963673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963692 */     GIR_RootConstrainSelectedInstOperands,
     /*  963693 */     // GIR_Coverage, 5254,
     /*  963693 */     GIR_EraseRootFromParent_Done,
     /*  963694 */   // Label 14492: @963694
     /*  963694 */   GIM_Try, /*On fail goto*//*Label 14493*/ GIMT_Encode4(963786), // Rule ID 5255 //
     /*  963699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  963702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  963710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  963713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  963716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963749 */     // MIs[1] Operand 1
     /*  963749 */     // No operand predicates
     /*  963749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963762 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  963762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  963765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963784 */     GIR_RootConstrainSelectedInstOperands,
     /*  963785 */     // GIR_Coverage, 5255,
     /*  963785 */     GIR_EraseRootFromParent_Done,
     /*  963786 */   // Label 14493: @963786
     /*  963786 */   GIM_Try, /*On fail goto*//*Label 14494*/ GIMT_Encode4(963878), // Rule ID 5256 //
     /*  963791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  963794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  963802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  963805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  963808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963841 */     // MIs[1] Operand 1
     /*  963841 */     // No operand predicates
     /*  963841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963854 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  963854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  963857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963876 */     GIR_RootConstrainSelectedInstOperands,
     /*  963877 */     // GIR_Coverage, 5256,
     /*  963877 */     GIR_EraseRootFromParent_Done,
     /*  963878 */   // Label 14494: @963878
     /*  963878 */   GIM_Try, /*On fail goto*//*Label 14495*/ GIMT_Encode4(963970), // Rule ID 5257 //
     /*  963883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  963886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  963894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  963897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  963900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963933 */     // MIs[1] Operand 1
     /*  963933 */     // No operand predicates
     /*  963933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963946 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  963946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  963949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963968 */     GIR_RootConstrainSelectedInstOperands,
     /*  963969 */     // GIR_Coverage, 5257,
     /*  963969 */     GIR_EraseRootFromParent_Done,
     /*  963970 */   // Label 14495: @963970
     /*  963970 */   GIM_Try, /*On fail goto*//*Label 14496*/ GIMT_Encode4(964062), // Rule ID 5258 //
     /*  963975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  963978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  963989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  963998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  964005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  964009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  964013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964025 */     // MIs[1] Operand 1
     /*  964025 */     // No operand predicates
     /*  964025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964038 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  964038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  964041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  964060 */     GIR_RootConstrainSelectedInstOperands,
     /*  964061 */     // GIR_Coverage, 5258,
     /*  964061 */     GIR_EraseRootFromParent_Done,
     /*  964062 */   // Label 14496: @964062
     /*  964062 */   GIM_Try, /*On fail goto*//*Label 14497*/ GIMT_Encode4(964154), // Rule ID 5259 //
     /*  964067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  964070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  964078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  964081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  964084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  964090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  964097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  964101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  964105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964117 */     // MIs[1] Operand 1
     /*  964117 */     // No operand predicates
     /*  964117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964130 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  964130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  964133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  964152 */     GIR_RootConstrainSelectedInstOperands,
     /*  964153 */     // GIR_Coverage, 5259,
     /*  964153 */     GIR_EraseRootFromParent_Done,
     /*  964154 */   // Label 14497: @964154
     /*  964154 */   GIM_Try, /*On fail goto*//*Label 14498*/ GIMT_Encode4(964249), // Rule ID 7990 //
     /*  964159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  964176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964209 */     // MIs[1] Operand 1
     /*  964209 */     // No operand predicates
     /*  964209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964222 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  964222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  964225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964247 */     GIR_RootConstrainSelectedInstOperands,
     /*  964248 */     // GIR_Coverage, 7990,
     /*  964248 */     GIR_EraseRootFromParent_Done,
     /*  964249 */   // Label 14498: @964249
     /*  964249 */   GIM_Try, /*On fail goto*//*Label 14499*/ GIMT_Encode4(964344), // Rule ID 7991 //
     /*  964254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  964271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964304 */     // MIs[1] Operand 1
     /*  964304 */     // No operand predicates
     /*  964304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964317 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  964320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964342 */     GIR_RootConstrainSelectedInstOperands,
     /*  964343 */     // GIR_Coverage, 7991,
     /*  964343 */     GIR_EraseRootFromParent_Done,
     /*  964344 */   // Label 14499: @964344
     /*  964344 */   GIM_Try, /*On fail goto*//*Label 14500*/ GIMT_Encode4(964439), // Rule ID 7994 //
     /*  964349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  964366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964399 */     // MIs[1] Operand 1
     /*  964399 */     // No operand predicates
     /*  964399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964412 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  964412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964437 */     GIR_RootConstrainSelectedInstOperands,
     /*  964438 */     // GIR_Coverage, 7994,
     /*  964438 */     GIR_EraseRootFromParent_Done,
     /*  964439 */   // Label 14500: @964439
     /*  964439 */   GIM_Try, /*On fail goto*//*Label 14501*/ GIMT_Encode4(964534), // Rule ID 7995 //
     /*  964444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  964461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964494 */     // MIs[1] Operand 1
     /*  964494 */     // No operand predicates
     /*  964494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964507 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964532 */     GIR_RootConstrainSelectedInstOperands,
     /*  964533 */     // GIR_Coverage, 7995,
     /*  964533 */     GIR_EraseRootFromParent_Done,
     /*  964534 */   // Label 14501: @964534
     /*  964534 */   GIM_Try, /*On fail goto*//*Label 14502*/ GIMT_Encode4(964629), // Rule ID 7998 //
     /*  964539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  964550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  964553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  964556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964589 */     // MIs[1] Operand 1
     /*  964589 */     // No operand predicates
     /*  964589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964602 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  964602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964627 */     GIR_RootConstrainSelectedInstOperands,
     /*  964628 */     // GIR_Coverage, 7998,
     /*  964628 */     GIR_EraseRootFromParent_Done,
     /*  964629 */   // Label 14502: @964629
     /*  964629 */   GIM_Try, /*On fail goto*//*Label 14503*/ GIMT_Encode4(964724), // Rule ID 7999 //
     /*  964634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  964645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  964648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  964651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964684 */     // MIs[1] Operand 1
     /*  964684 */     // No operand predicates
     /*  964684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964697 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964722 */     GIR_RootConstrainSelectedInstOperands,
     /*  964723 */     // GIR_Coverage, 7999,
     /*  964723 */     GIR_EraseRootFromParent_Done,
     /*  964724 */   // Label 14503: @964724
     /*  964724 */   GIM_Try, /*On fail goto*//*Label 14504*/ GIMT_Encode4(964819), // Rule ID 8002 //
     /*  964729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  964746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964779 */     // MIs[1] Operand 1
     /*  964779 */     // No operand predicates
     /*  964779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964792 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  964792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964817 */     GIR_RootConstrainSelectedInstOperands,
     /*  964818 */     // GIR_Coverage, 8002,
     /*  964818 */     GIR_EraseRootFromParent_Done,
     /*  964819 */   // Label 14504: @964819
     /*  964819 */   GIM_Try, /*On fail goto*//*Label 14505*/ GIMT_Encode4(964914), // Rule ID 8003 //
     /*  964824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  964841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964874 */     // MIs[1] Operand 1
     /*  964874 */     // No operand predicates
     /*  964874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964887 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  964887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964912 */     GIR_RootConstrainSelectedInstOperands,
     /*  964913 */     // GIR_Coverage, 8003,
     /*  964913 */     GIR_EraseRootFromParent_Done,
     /*  964914 */   // Label 14505: @964914
     /*  964914 */   GIM_Try, /*On fail goto*//*Label 14506*/ GIMT_Encode4(965009), // Rule ID 8006 //
     /*  964919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964969 */     // MIs[1] Operand 1
     /*  964969 */     // No operand predicates
     /*  964969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964982 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  964982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965007 */     GIR_RootConstrainSelectedInstOperands,
     /*  965008 */     // GIR_Coverage, 8006,
     /*  965008 */     GIR_EraseRootFromParent_Done,
     /*  965009 */   // Label 14506: @965009
     /*  965009 */   GIM_Try, /*On fail goto*//*Label 14507*/ GIMT_Encode4(965104), // Rule ID 8007 //
     /*  965014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  965025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  965028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  965031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  965037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965064 */     // MIs[1] Operand 1
     /*  965064 */     // No operand predicates
     /*  965064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965077 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  965077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  965080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965102 */     GIR_RootConstrainSelectedInstOperands,
     /*  965103 */     // GIR_Coverage, 8007,
     /*  965103 */     GIR_EraseRootFromParent_Done,
     /*  965104 */   // Label 14507: @965104
     /*  965104 */   GIM_Try, /*On fail goto*//*Label 14508*/ GIMT_Encode4(965199), // Rule ID 8010 //
     /*  965109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  965120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  965123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  965126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965159 */     // MIs[1] Operand 1
     /*  965159 */     // No operand predicates
     /*  965159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965172 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  965172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  965175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965197 */     GIR_RootConstrainSelectedInstOperands,
     /*  965198 */     // GIR_Coverage, 8010,
     /*  965198 */     GIR_EraseRootFromParent_Done,
     /*  965199 */   // Label 14508: @965199
     /*  965199 */   GIM_Try, /*On fail goto*//*Label 14509*/ GIMT_Encode4(965294), // Rule ID 8011 //
     /*  965204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  965215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  965218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  965221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965254 */     // MIs[1] Operand 1
     /*  965254 */     // No operand predicates
     /*  965254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965267 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  965267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  965270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965292 */     GIR_RootConstrainSelectedInstOperands,
     /*  965293 */     // GIR_Coverage, 8011,
     /*  965293 */     GIR_EraseRootFromParent_Done,
     /*  965294 */   // Label 14509: @965294
     /*  965294 */   GIM_Try, /*On fail goto*//*Label 14510*/ GIMT_Encode4(965389), // Rule ID 8014 //
     /*  965299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  965310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  965313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  965316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  965322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965349 */     // MIs[1] Operand 1
     /*  965349 */     // No operand predicates
     /*  965349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965362 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  965362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965387 */     GIR_RootConstrainSelectedInstOperands,
     /*  965388 */     // GIR_Coverage, 8014,
     /*  965388 */     GIR_EraseRootFromParent_Done,
     /*  965389 */   // Label 14510: @965389
     /*  965389 */   GIM_Try, /*On fail goto*//*Label 14511*/ GIMT_Encode4(965484), // Rule ID 8015 //
     /*  965394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  965405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  965408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  965411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  965417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965444 */     // MIs[1] Operand 1
     /*  965444 */     // No operand predicates
     /*  965444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965457 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  965457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965482 */     GIR_RootConstrainSelectedInstOperands,
     /*  965483 */     // GIR_Coverage, 8015,
     /*  965483 */     GIR_EraseRootFromParent_Done,
     /*  965484 */   // Label 14511: @965484
     /*  965484 */   GIM_Try, /*On fail goto*//*Label 14512*/ GIMT_Encode4(965579), // Rule ID 8018 //
     /*  965489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  965500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  965503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  965506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  965512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965539 */     // MIs[1] Operand 1
     /*  965539 */     // No operand predicates
     /*  965539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965552 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  965552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965577 */     GIR_RootConstrainSelectedInstOperands,
     /*  965578 */     // GIR_Coverage, 8018,
     /*  965578 */     GIR_EraseRootFromParent_Done,
     /*  965579 */   // Label 14512: @965579
     /*  965579 */   GIM_Try, /*On fail goto*//*Label 14513*/ GIMT_Encode4(965674), // Rule ID 8019 //
     /*  965584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  965595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  965598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  965601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  965607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965634 */     // MIs[1] Operand 1
     /*  965634 */     // No operand predicates
     /*  965634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965647 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  965647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965672 */     GIR_RootConstrainSelectedInstOperands,
     /*  965673 */     // GIR_Coverage, 8019,
     /*  965673 */     GIR_EraseRootFromParent_Done,
     /*  965674 */   // Label 14513: @965674
     /*  965674 */   GIM_Try, /*On fail goto*//*Label 14514*/ GIMT_Encode4(965769), // Rule ID 8022 //
     /*  965679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  965690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  965693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  965696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  965702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965729 */     // MIs[1] Operand 1
     /*  965729 */     // No operand predicates
     /*  965729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965742 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  965742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965767 */     GIR_RootConstrainSelectedInstOperands,
     /*  965768 */     // GIR_Coverage, 8022,
     /*  965768 */     GIR_EraseRootFromParent_Done,
     /*  965769 */   // Label 14514: @965769
     /*  965769 */   GIM_Try, /*On fail goto*//*Label 14515*/ GIMT_Encode4(965864), // Rule ID 8023 //
     /*  965774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  965785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  965788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  965791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  965797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965824 */     // MIs[1] Operand 1
     /*  965824 */     // No operand predicates
     /*  965824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965837 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  965837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965862 */     GIR_RootConstrainSelectedInstOperands,
     /*  965863 */     // GIR_Coverage, 8023,
     /*  965863 */     GIR_EraseRootFromParent_Done,
     /*  965864 */   // Label 14515: @965864
     /*  965864 */   GIM_Try, /*On fail goto*//*Label 14516*/ GIMT_Encode4(965959), // Rule ID 8026 //
     /*  965869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  965872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  965880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  965883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  965886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965919 */     // MIs[1] Operand 1
     /*  965919 */     // No operand predicates
     /*  965919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965932 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  965932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  965954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965957 */     GIR_RootConstrainSelectedInstOperands,
     /*  965958 */     // GIR_Coverage, 8026,
     /*  965958 */     GIR_EraseRootFromParent_Done,
     /*  965959 */   // Label 14516: @965959
     /*  965959 */   GIM_Try, /*On fail goto*//*Label 14517*/ GIMT_Encode4(966054), // Rule ID 8027 //
     /*  965964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  965967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  965975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  965978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  965981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966014 */     // MIs[1] Operand 1
     /*  966014 */     // No operand predicates
     /*  966014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966027 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  966027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  966030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  966049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966052 */     GIR_RootConstrainSelectedInstOperands,
     /*  966053 */     // GIR_Coverage, 8027,
     /*  966053 */     GIR_EraseRootFromParent_Done,
     /*  966054 */   // Label 14517: @966054
     /*  966054 */   GIM_Try, /*On fail goto*//*Label 14518*/ GIMT_Encode4(966149), // Rule ID 8030 //
     /*  966059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  966076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966109 */     // MIs[1] Operand 1
     /*  966109 */     // No operand predicates
     /*  966109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966122 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  966122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966147 */     GIR_RootConstrainSelectedInstOperands,
     /*  966148 */     // GIR_Coverage, 8030,
     /*  966148 */     GIR_EraseRootFromParent_Done,
     /*  966149 */   // Label 14518: @966149
     /*  966149 */   GIM_Try, /*On fail goto*//*Label 14519*/ GIMT_Encode4(966244), // Rule ID 8031 //
     /*  966154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  966171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966204 */     // MIs[1] Operand 1
     /*  966204 */     // No operand predicates
     /*  966204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966217 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  966217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966242 */     GIR_RootConstrainSelectedInstOperands,
     /*  966243 */     // GIR_Coverage, 8031,
     /*  966243 */     GIR_EraseRootFromParent_Done,
     /*  966244 */   // Label 14519: @966244
     /*  966244 */   GIM_Try, /*On fail goto*//*Label 14520*/ GIMT_Encode4(966339), // Rule ID 8034 //
     /*  966249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  966260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  966263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  966266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966299 */     // MIs[1] Operand 1
     /*  966299 */     // No operand predicates
     /*  966299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966312 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  966312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966337 */     GIR_RootConstrainSelectedInstOperands,
     /*  966338 */     // GIR_Coverage, 8034,
     /*  966338 */     GIR_EraseRootFromParent_Done,
     /*  966339 */   // Label 14520: @966339
     /*  966339 */   GIM_Try, /*On fail goto*//*Label 14521*/ GIMT_Encode4(966434), // Rule ID 8035 //
     /*  966344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  966355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  966358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  966361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966394 */     // MIs[1] Operand 1
     /*  966394 */     // No operand predicates
     /*  966394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966407 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  966407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966432 */     GIR_RootConstrainSelectedInstOperands,
     /*  966433 */     // GIR_Coverage, 8035,
     /*  966433 */     GIR_EraseRootFromParent_Done,
     /*  966434 */   // Label 14521: @966434
     /*  966434 */   GIM_Try, /*On fail goto*//*Label 14522*/ GIMT_Encode4(966529), // Rule ID 8038 //
     /*  966439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  966450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  966453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  966456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  966462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966489 */     // MIs[1] Operand 1
     /*  966489 */     // No operand predicates
     /*  966489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966502 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  966502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966527 */     GIR_RootConstrainSelectedInstOperands,
     /*  966528 */     // GIR_Coverage, 8038,
     /*  966528 */     GIR_EraseRootFromParent_Done,
     /*  966529 */   // Label 14522: @966529
     /*  966529 */   GIM_Try, /*On fail goto*//*Label 14523*/ GIMT_Encode4(966624), // Rule ID 8039 //
     /*  966534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  966545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  966548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  966551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  966557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966584 */     // MIs[1] Operand 1
     /*  966584 */     // No operand predicates
     /*  966584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966597 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  966597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966622 */     GIR_RootConstrainSelectedInstOperands,
     /*  966623 */     // GIR_Coverage, 8039,
     /*  966623 */     GIR_EraseRootFromParent_Done,
     /*  966624 */   // Label 14523: @966624
     /*  966624 */   GIM_Try, /*On fail goto*//*Label 14524*/ GIMT_Encode4(966719), // Rule ID 8042 //
     /*  966629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  966640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  966643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  966646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966679 */     // MIs[1] Operand 1
     /*  966679 */     // No operand predicates
     /*  966679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966692 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  966692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966717 */     GIR_RootConstrainSelectedInstOperands,
     /*  966718 */     // GIR_Coverage, 8042,
     /*  966718 */     GIR_EraseRootFromParent_Done,
     /*  966719 */   // Label 14524: @966719
     /*  966719 */   GIM_Try, /*On fail goto*//*Label 14525*/ GIMT_Encode4(966814), // Rule ID 8043 //
     /*  966724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  966735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  966738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  966741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966774 */     // MIs[1] Operand 1
     /*  966774 */     // No operand predicates
     /*  966774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966787 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  966787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966812 */     GIR_RootConstrainSelectedInstOperands,
     /*  966813 */     // GIR_Coverage, 8043,
     /*  966813 */     GIR_EraseRootFromParent_Done,
     /*  966814 */   // Label 14525: @966814
     /*  966814 */   GIM_Try, /*On fail goto*//*Label 14526*/ GIMT_Encode4(966909), // Rule ID 8046 //
     /*  966819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966869 */     // MIs[1] Operand 1
     /*  966869 */     // No operand predicates
     /*  966869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966882 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  966882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966907 */     GIR_RootConstrainSelectedInstOperands,
     /*  966908 */     // GIR_Coverage, 8046,
     /*  966908 */     GIR_EraseRootFromParent_Done,
     /*  966909 */   // Label 14526: @966909
     /*  966909 */   GIM_Try, /*On fail goto*//*Label 14527*/ GIMT_Encode4(967004), // Rule ID 8047 //
     /*  966914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966964 */     // MIs[1] Operand 1
     /*  966964 */     // No operand predicates
     /*  966964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966977 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  966977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967002 */     GIR_RootConstrainSelectedInstOperands,
     /*  967003 */     // GIR_Coverage, 8047,
     /*  967003 */     GIR_EraseRootFromParent_Done,
     /*  967004 */   // Label 14527: @967004
     /*  967004 */   GIM_Try, /*On fail goto*//*Label 14528*/ GIMT_Encode4(967099), // Rule ID 8050 //
     /*  967009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  967020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  967023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  967026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  967032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967059 */     // MIs[1] Operand 1
     /*  967059 */     // No operand predicates
     /*  967059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967072 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  967072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  967094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967097 */     GIR_RootConstrainSelectedInstOperands,
     /*  967098 */     // GIR_Coverage, 8050,
     /*  967098 */     GIR_EraseRootFromParent_Done,
     /*  967099 */   // Label 14528: @967099
     /*  967099 */   GIM_Try, /*On fail goto*//*Label 14529*/ GIMT_Encode4(967194), // Rule ID 8051 //
     /*  967104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  967115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  967118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  967121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  967127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967154 */     // MIs[1] Operand 1
     /*  967154 */     // No operand predicates
     /*  967154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967167 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  967167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  967189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967192 */     GIR_RootConstrainSelectedInstOperands,
     /*  967193 */     // GIR_Coverage, 8051,
     /*  967193 */     GIR_EraseRootFromParent_Done,
     /*  967194 */   // Label 14529: @967194
     /*  967194 */   GIM_Try, /*On fail goto*//*Label 14530*/ GIMT_Encode4(967289), // Rule ID 8054 //
     /*  967199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  967216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967249 */     // MIs[1] Operand 1
     /*  967249 */     // No operand predicates
     /*  967249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967262 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  967262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  967265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967287 */     GIR_RootConstrainSelectedInstOperands,
     /*  967288 */     // GIR_Coverage, 8054,
     /*  967288 */     GIR_EraseRootFromParent_Done,
     /*  967289 */   // Label 14530: @967289
     /*  967289 */   GIM_Try, /*On fail goto*//*Label 14531*/ GIMT_Encode4(967384), // Rule ID 8055 //
     /*  967294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  967311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967344 */     // MIs[1] Operand 1
     /*  967344 */     // No operand predicates
     /*  967344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967357 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  967357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  967360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967382 */     GIR_RootConstrainSelectedInstOperands,
     /*  967383 */     // GIR_Coverage, 8055,
     /*  967383 */     GIR_EraseRootFromParent_Done,
     /*  967384 */   // Label 14531: @967384
     /*  967384 */   GIM_Try, /*On fail goto*//*Label 14532*/ GIMT_Encode4(967479), // Rule ID 8058 //
     /*  967389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  967400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  967403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  967406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967439 */     // MIs[1] Operand 1
     /*  967439 */     // No operand predicates
     /*  967439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  967452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  967455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967477 */     GIR_RootConstrainSelectedInstOperands,
     /*  967478 */     // GIR_Coverage, 8058,
     /*  967478 */     GIR_EraseRootFromParent_Done,
     /*  967479 */   // Label 14532: @967479
     /*  967479 */   GIM_Try, /*On fail goto*//*Label 14533*/ GIMT_Encode4(967574), // Rule ID 8059 //
     /*  967484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  967495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  967498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  967501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967534 */     // MIs[1] Operand 1
     /*  967534 */     // No operand predicates
     /*  967534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967547 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  967547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  967550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967572 */     GIR_RootConstrainSelectedInstOperands,
     /*  967573 */     // GIR_Coverage, 8059,
     /*  967573 */     GIR_EraseRootFromParent_Done,
     /*  967574 */   // Label 14533: @967574
     /*  967574 */   GIM_Try, /*On fail goto*//*Label 14534*/ GIMT_Encode4(967669), // Rule ID 8062 //
     /*  967579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  967590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  967593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  967596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  967602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967629 */     // MIs[1] Operand 1
     /*  967629 */     // No operand predicates
     /*  967629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967642 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  967642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967667 */     GIR_RootConstrainSelectedInstOperands,
     /*  967668 */     // GIR_Coverage, 8062,
     /*  967668 */     GIR_EraseRootFromParent_Done,
     /*  967669 */   // Label 14534: @967669
     /*  967669 */   GIM_Try, /*On fail goto*//*Label 14535*/ GIMT_Encode4(967764), // Rule ID 8063 //
     /*  967674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  967685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  967688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  967691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  967697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967724 */     // MIs[1] Operand 1
     /*  967724 */     // No operand predicates
     /*  967724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967737 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  967737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967762 */     GIR_RootConstrainSelectedInstOperands,
     /*  967763 */     // GIR_Coverage, 8063,
     /*  967763 */     GIR_EraseRootFromParent_Done,
     /*  967764 */   // Label 14535: @967764
     /*  967764 */   GIM_Try, /*On fail goto*//*Label 14536*/ GIMT_Encode4(967859), // Rule ID 8066 //
     /*  967769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  967786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967819 */     // MIs[1] Operand 1
     /*  967819 */     // No operand predicates
     /*  967819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967832 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  967832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  967835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967857 */     GIR_RootConstrainSelectedInstOperands,
     /*  967858 */     // GIR_Coverage, 8066,
     /*  967858 */     GIR_EraseRootFromParent_Done,
     /*  967859 */   // Label 14536: @967859
     /*  967859 */   GIM_Try, /*On fail goto*//*Label 14537*/ GIMT_Encode4(967954), // Rule ID 8067 //
     /*  967864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  967881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967914 */     // MIs[1] Operand 1
     /*  967914 */     // No operand predicates
     /*  967914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967927 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  967927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  967930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967952 */     GIR_RootConstrainSelectedInstOperands,
     /*  967953 */     // GIR_Coverage, 8067,
     /*  967953 */     GIR_EraseRootFromParent_Done,
     /*  967954 */   // Label 14537: @967954
     /*  967954 */   GIM_Try, /*On fail goto*//*Label 14538*/ GIMT_Encode4(968049), // Rule ID 8070 //
     /*  967959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  967976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968009 */     // MIs[1] Operand 1
     /*  968009 */     // No operand predicates
     /*  968009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968022 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  968022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  968025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  968044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968047 */     GIR_RootConstrainSelectedInstOperands,
     /*  968048 */     // GIR_Coverage, 8070,
     /*  968048 */     GIR_EraseRootFromParent_Done,
     /*  968049 */   // Label 14538: @968049
     /*  968049 */   GIM_Try, /*On fail goto*//*Label 14539*/ GIMT_Encode4(968144), // Rule ID 8071 //
     /*  968054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  968057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  968071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  968092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968104 */     // MIs[1] Operand 1
     /*  968104 */     // No operand predicates
     /*  968104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968117 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  968117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  968120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  968139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968142 */     GIR_RootConstrainSelectedInstOperands,
     /*  968143 */     // GIR_Coverage, 8071,
     /*  968143 */     GIR_EraseRootFromParent_Done,
     /*  968144 */   // Label 14539: @968144
     /*  968144 */   GIM_Try, /*On fail goto*//*Label 14540*/ GIMT_Encode4(968239), // Rule ID 8074 //
     /*  968149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  968152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  968160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  968163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  968166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  968172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  968187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968199 */     // MIs[1] Operand 1
     /*  968199 */     // No operand predicates
     /*  968199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968212 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  968212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  968215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  968234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968237 */     GIR_RootConstrainSelectedInstOperands,
     /*  968238 */     // GIR_Coverage, 8074,
     /*  968238 */     GIR_EraseRootFromParent_Done,
     /*  968239 */   // Label 14540: @968239
     /*  968239 */   GIM_Try, /*On fail goto*//*Label 14541*/ GIMT_Encode4(968334), // Rule ID 8075 //
     /*  968244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  968247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  968255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  968258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  968261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  968267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  968282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968294 */     // MIs[1] Operand 1
     /*  968294 */     // No operand predicates
     /*  968294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968307 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  968307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  968310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  968329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968332 */     GIR_RootConstrainSelectedInstOperands,
     /*  968333 */     // GIR_Coverage, 8075,
     /*  968333 */     GIR_EraseRootFromParent_Done,
     /*  968334 */   // Label 14541: @968334
     /*  968334 */   GIM_Try, /*On fail goto*//*Label 14542*/ GIMT_Encode4(968429), // Rule ID 8254 //
     /*  968339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  968356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968389 */     // MIs[1] Operand 1
     /*  968389 */     // No operand predicates
     /*  968389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968402 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  968405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968427 */     GIR_RootConstrainSelectedInstOperands,
     /*  968428 */     // GIR_Coverage, 8254,
     /*  968428 */     GIR_EraseRootFromParent_Done,
     /*  968429 */   // Label 14542: @968429
     /*  968429 */   GIM_Try, /*On fail goto*//*Label 14543*/ GIMT_Encode4(968524), // Rule ID 8255 //
     /*  968434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  968451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968484 */     // MIs[1] Operand 1
     /*  968484 */     // No operand predicates
     /*  968484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968497 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  968500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968522 */     GIR_RootConstrainSelectedInstOperands,
     /*  968523 */     // GIR_Coverage, 8255,
     /*  968523 */     GIR_EraseRootFromParent_Done,
     /*  968524 */   // Label 14543: @968524
     /*  968524 */   GIM_Try, /*On fail goto*//*Label 14544*/ GIMT_Encode4(968619), // Rule ID 8258 //
     /*  968529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  968546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968579 */     // MIs[1] Operand 1
     /*  968579 */     // No operand predicates
     /*  968579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968592 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968617 */     GIR_RootConstrainSelectedInstOperands,
     /*  968618 */     // GIR_Coverage, 8258,
     /*  968618 */     GIR_EraseRootFromParent_Done,
     /*  968619 */   // Label 14544: @968619
     /*  968619 */   GIM_Try, /*On fail goto*//*Label 14545*/ GIMT_Encode4(968714), // Rule ID 8259 //
     /*  968624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  968641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968674 */     // MIs[1] Operand 1
     /*  968674 */     // No operand predicates
     /*  968674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968687 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968712 */     GIR_RootConstrainSelectedInstOperands,
     /*  968713 */     // GIR_Coverage, 8259,
     /*  968713 */     GIR_EraseRootFromParent_Done,
     /*  968714 */   // Label 14545: @968714
     /*  968714 */   GIM_Try, /*On fail goto*//*Label 14546*/ GIMT_Encode4(968809), // Rule ID 8262 //
     /*  968719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  968736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968769 */     // MIs[1] Operand 1
     /*  968769 */     // No operand predicates
     /*  968769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968782 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968807 */     GIR_RootConstrainSelectedInstOperands,
     /*  968808 */     // GIR_Coverage, 8262,
     /*  968808 */     GIR_EraseRootFromParent_Done,
     /*  968809 */   // Label 14546: @968809
     /*  968809 */   GIM_Try, /*On fail goto*//*Label 14547*/ GIMT_Encode4(968904), // Rule ID 8263 //
     /*  968814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  968831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968864 */     // MIs[1] Operand 1
     /*  968864 */     // No operand predicates
     /*  968864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968877 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968902 */     GIR_RootConstrainSelectedInstOperands,
     /*  968903 */     // GIR_Coverage, 8263,
     /*  968903 */     GIR_EraseRootFromParent_Done,
     /*  968904 */   // Label 14547: @968904
     /*  968904 */   GIM_Try, /*On fail goto*//*Label 14548*/ GIMT_Encode4(968999), // Rule ID 8266 //
     /*  968909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968959 */     // MIs[1] Operand 1
     /*  968959 */     // No operand predicates
     /*  968959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968972 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968997 */     GIR_RootConstrainSelectedInstOperands,
     /*  968998 */     // GIR_Coverage, 8266,
     /*  968998 */     GIR_EraseRootFromParent_Done,
     /*  968999 */   // Label 14548: @968999
     /*  968999 */   GIM_Try, /*On fail goto*//*Label 14549*/ GIMT_Encode4(969094), // Rule ID 8267 //
     /*  969004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  969021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969054 */     // MIs[1] Operand 1
     /*  969054 */     // No operand predicates
     /*  969054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969067 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  969067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  969070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969092 */     GIR_RootConstrainSelectedInstOperands,
     /*  969093 */     // GIR_Coverage, 8267,
     /*  969093 */     GIR_EraseRootFromParent_Done,
     /*  969094 */   // Label 14549: @969094
     /*  969094 */   GIM_Try, /*On fail goto*//*Label 14550*/ GIMT_Encode4(969189), // Rule ID 8270 //
     /*  969099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  969116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969149 */     // MIs[1] Operand 1
     /*  969149 */     // No operand predicates
     /*  969149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969162 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  969162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  969165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969187 */     GIR_RootConstrainSelectedInstOperands,
     /*  969188 */     // GIR_Coverage, 8270,
     /*  969188 */     GIR_EraseRootFromParent_Done,
     /*  969189 */   // Label 14550: @969189
     /*  969189 */   GIM_Try, /*On fail goto*//*Label 14551*/ GIMT_Encode4(969284), // Rule ID 8271 //
     /*  969194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  969211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969244 */     // MIs[1] Operand 1
     /*  969244 */     // No operand predicates
     /*  969244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969257 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  969257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  969260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969282 */     GIR_RootConstrainSelectedInstOperands,
     /*  969283 */     // GIR_Coverage, 8271,
     /*  969283 */     GIR_EraseRootFromParent_Done,
     /*  969284 */   // Label 14551: @969284
     /*  969284 */   GIM_Try, /*On fail goto*//*Label 14552*/ GIMT_Encode4(969379), // Rule ID 8274 //
     /*  969289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  969306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969339 */     // MIs[1] Operand 1
     /*  969339 */     // No operand predicates
     /*  969339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969352 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  969352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  969355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969377 */     GIR_RootConstrainSelectedInstOperands,
     /*  969378 */     // GIR_Coverage, 8274,
     /*  969378 */     GIR_EraseRootFromParent_Done,
     /*  969379 */   // Label 14552: @969379
     /*  969379 */   GIM_Try, /*On fail goto*//*Label 14553*/ GIMT_Encode4(969474), // Rule ID 8275 //
     /*  969384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  969401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969434 */     // MIs[1] Operand 1
     /*  969434 */     // No operand predicates
     /*  969434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969447 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  969447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  969450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969472 */     GIR_RootConstrainSelectedInstOperands,
     /*  969473 */     // GIR_Coverage, 8275,
     /*  969473 */     GIR_EraseRootFromParent_Done,
     /*  969474 */   // Label 14553: @969474
     /*  969474 */   GIM_Try, /*On fail goto*//*Label 14554*/ GIMT_Encode4(969569), // Rule ID 8278 //
     /*  969479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  969490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  969493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  969496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  969502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969529 */     // MIs[1] Operand 1
     /*  969529 */     // No operand predicates
     /*  969529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969542 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969567 */     GIR_RootConstrainSelectedInstOperands,
     /*  969568 */     // GIR_Coverage, 8278,
     /*  969568 */     GIR_EraseRootFromParent_Done,
     /*  969569 */   // Label 14554: @969569
     /*  969569 */   GIM_Try, /*On fail goto*//*Label 14555*/ GIMT_Encode4(969664), // Rule ID 8279 //
     /*  969574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  969585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  969588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  969591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  969597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969624 */     // MIs[1] Operand 1
     /*  969624 */     // No operand predicates
     /*  969624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969637 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969662 */     GIR_RootConstrainSelectedInstOperands,
     /*  969663 */     // GIR_Coverage, 8279,
     /*  969663 */     GIR_EraseRootFromParent_Done,
     /*  969664 */   // Label 14555: @969664
     /*  969664 */   GIM_Try, /*On fail goto*//*Label 14556*/ GIMT_Encode4(969759), // Rule ID 8282 //
     /*  969669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  969680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  969683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  969686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  969692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969719 */     // MIs[1] Operand 1
     /*  969719 */     // No operand predicates
     /*  969719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969732 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  969732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969757 */     GIR_RootConstrainSelectedInstOperands,
     /*  969758 */     // GIR_Coverage, 8282,
     /*  969758 */     GIR_EraseRootFromParent_Done,
     /*  969759 */   // Label 14556: @969759
     /*  969759 */   GIM_Try, /*On fail goto*//*Label 14557*/ GIMT_Encode4(969854), // Rule ID 8283 //
     /*  969764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  969775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  969778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  969781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  969787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969814 */     // MIs[1] Operand 1
     /*  969814 */     // No operand predicates
     /*  969814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969827 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  969827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969852 */     GIR_RootConstrainSelectedInstOperands,
     /*  969853 */     // GIR_Coverage, 8283,
     /*  969853 */     GIR_EraseRootFromParent_Done,
     /*  969854 */   // Label 14557: @969854
     /*  969854 */   GIM_Try, /*On fail goto*//*Label 14558*/ GIMT_Encode4(969949), // Rule ID 8286 //
     /*  969859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969909 */     // MIs[1] Operand 1
     /*  969909 */     // No operand predicates
     /*  969909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969922 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  969922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969947 */     GIR_RootConstrainSelectedInstOperands,
     /*  969948 */     // GIR_Coverage, 8286,
     /*  969948 */     GIR_EraseRootFromParent_Done,
     /*  969949 */   // Label 14558: @969949
     /*  969949 */   GIM_Try, /*On fail goto*//*Label 14559*/ GIMT_Encode4(970044), // Rule ID 8287 //
     /*  969954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970004 */     // MIs[1] Operand 1
     /*  970004 */     // No operand predicates
     /*  970004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970017 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  970017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  970020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970042 */     GIR_RootConstrainSelectedInstOperands,
     /*  970043 */     // GIR_Coverage, 8287,
     /*  970043 */     GIR_EraseRootFromParent_Done,
     /*  970044 */   // Label 14559: @970044
     /*  970044 */   GIM_Try, /*On fail goto*//*Label 14560*/ GIMT_Encode4(970139), // Rule ID 8290 //
     /*  970049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  970052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  970060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  970063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  970066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  970072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970099 */     // MIs[1] Operand 1
     /*  970099 */     // No operand predicates
     /*  970099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  970112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  970115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  970134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970137 */     GIR_RootConstrainSelectedInstOperands,
     /*  970138 */     // GIR_Coverage, 8290,
     /*  970138 */     GIR_EraseRootFromParent_Done,
     /*  970139 */   // Label 14560: @970139
     /*  970139 */   GIM_Try, /*On fail goto*//*Label 14561*/ GIMT_Encode4(970234), // Rule ID 8291 //
     /*  970144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  970147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  970155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  970158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  970161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  970167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970194 */     // MIs[1] Operand 1
     /*  970194 */     // No operand predicates
     /*  970194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970207 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  970207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  970210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  970229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970232 */     GIR_RootConstrainSelectedInstOperands,
     /*  970233 */     // GIR_Coverage, 8291,
     /*  970233 */     GIR_EraseRootFromParent_Done,
     /*  970234 */   // Label 14561: @970234
     /*  970234 */   GIM_Try, /*On fail goto*//*Label 14562*/ GIMT_Encode4(970329), // Rule ID 8294 //
     /*  970239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  970256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970289 */     // MIs[1] Operand 1
     /*  970289 */     // No operand predicates
     /*  970289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970302 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  970302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970327 */     GIR_RootConstrainSelectedInstOperands,
     /*  970328 */     // GIR_Coverage, 8294,
     /*  970328 */     GIR_EraseRootFromParent_Done,
     /*  970329 */   // Label 14562: @970329
     /*  970329 */   GIM_Try, /*On fail goto*//*Label 14563*/ GIMT_Encode4(970424), // Rule ID 8295 //
     /*  970334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  970351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970384 */     // MIs[1] Operand 1
     /*  970384 */     // No operand predicates
     /*  970384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970397 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  970397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970422 */     GIR_RootConstrainSelectedInstOperands,
     /*  970423 */     // GIR_Coverage, 8295,
     /*  970423 */     GIR_EraseRootFromParent_Done,
     /*  970424 */   // Label 14563: @970424
     /*  970424 */   GIM_Try, /*On fail goto*//*Label 14564*/ GIMT_Encode4(970519), // Rule ID 8298 //
     /*  970429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  970446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970479 */     // MIs[1] Operand 1
     /*  970479 */     // No operand predicates
     /*  970479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970492 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  970492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970517 */     GIR_RootConstrainSelectedInstOperands,
     /*  970518 */     // GIR_Coverage, 8298,
     /*  970518 */     GIR_EraseRootFromParent_Done,
     /*  970519 */   // Label 14564: @970519
     /*  970519 */   GIM_Try, /*On fail goto*//*Label 14565*/ GIMT_Encode4(970614), // Rule ID 8299 //
     /*  970524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  970541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970574 */     // MIs[1] Operand 1
     /*  970574 */     // No operand predicates
     /*  970574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970587 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  970587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970612 */     GIR_RootConstrainSelectedInstOperands,
     /*  970613 */     // GIR_Coverage, 8299,
     /*  970613 */     GIR_EraseRootFromParent_Done,
     /*  970614 */   // Label 14565: @970614
     /*  970614 */   GIM_Try, /*On fail goto*//*Label 14566*/ GIMT_Encode4(970709), // Rule ID 8302 //
     /*  970619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  970630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  970633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  970636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  970642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970669 */     // MIs[1] Operand 1
     /*  970669 */     // No operand predicates
     /*  970669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970682 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  970682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970707 */     GIR_RootConstrainSelectedInstOperands,
     /*  970708 */     // GIR_Coverage, 8302,
     /*  970708 */     GIR_EraseRootFromParent_Done,
     /*  970709 */   // Label 14566: @970709
     /*  970709 */   GIM_Try, /*On fail goto*//*Label 14567*/ GIMT_Encode4(970804), // Rule ID 8303 //
     /*  970714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  970725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  970728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  970731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  970737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970764 */     // MIs[1] Operand 1
     /*  970764 */     // No operand predicates
     /*  970764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970777 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  970777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970802 */     GIR_RootConstrainSelectedInstOperands,
     /*  970803 */     // GIR_Coverage, 8303,
     /*  970803 */     GIR_EraseRootFromParent_Done,
     /*  970804 */   // Label 14567: @970804
     /*  970804 */   GIM_Try, /*On fail goto*//*Label 14568*/ GIMT_Encode4(970899), // Rule ID 8306 //
     /*  970809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970859 */     // MIs[1] Operand 1
     /*  970859 */     // No operand predicates
     /*  970859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970872 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970897 */     GIR_RootConstrainSelectedInstOperands,
     /*  970898 */     // GIR_Coverage, 8306,
     /*  970898 */     GIR_EraseRootFromParent_Done,
     /*  970899 */   // Label 14568: @970899
     /*  970899 */   GIM_Try, /*On fail goto*//*Label 14569*/ GIMT_Encode4(970994), // Rule ID 8307 //
     /*  970904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970954 */     // MIs[1] Operand 1
     /*  970954 */     // No operand predicates
     /*  970954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970967 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970992 */     GIR_RootConstrainSelectedInstOperands,
     /*  970993 */     // GIR_Coverage, 8307,
     /*  970993 */     GIR_EraseRootFromParent_Done,
     /*  970994 */   // Label 14569: @970994
     /*  970994 */   GIM_Try, /*On fail goto*//*Label 14570*/ GIMT_Encode4(971089), // Rule ID 8310 //
     /*  970999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  971016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971049 */     // MIs[1] Operand 1
     /*  971049 */     // No operand predicates
     /*  971049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971062 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  971062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  971084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971087 */     GIR_RootConstrainSelectedInstOperands,
     /*  971088 */     // GIR_Coverage, 8310,
     /*  971088 */     GIR_EraseRootFromParent_Done,
     /*  971089 */   // Label 14570: @971089
     /*  971089 */   GIM_Try, /*On fail goto*//*Label 14571*/ GIMT_Encode4(971184), // Rule ID 8311 //
     /*  971094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  971111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971144 */     // MIs[1] Operand 1
     /*  971144 */     // No operand predicates
     /*  971144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971157 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  971157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  971179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971182 */     GIR_RootConstrainSelectedInstOperands,
     /*  971183 */     // GIR_Coverage, 8311,
     /*  971183 */     GIR_EraseRootFromParent_Done,
     /*  971184 */   // Label 14571: @971184
     /*  971184 */   GIM_Try, /*On fail goto*//*Label 14572*/ GIMT_Encode4(971279), // Rule ID 8314 //
     /*  971189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  971200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  971203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  971206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  971212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971239 */     // MIs[1] Operand 1
     /*  971239 */     // No operand predicates
     /*  971239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971252 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  971252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  971274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971277 */     GIR_RootConstrainSelectedInstOperands,
     /*  971278 */     // GIR_Coverage, 8314,
     /*  971278 */     GIR_EraseRootFromParent_Done,
     /*  971279 */   // Label 14572: @971279
     /*  971279 */   GIM_Try, /*On fail goto*//*Label 14573*/ GIMT_Encode4(971374), // Rule ID 8315 //
     /*  971284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  971295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  971298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  971301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  971307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971334 */     // MIs[1] Operand 1
     /*  971334 */     // No operand predicates
     /*  971334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971347 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  971347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  971369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971372 */     GIR_RootConstrainSelectedInstOperands,
     /*  971373 */     // GIR_Coverage, 8315,
     /*  971373 */     GIR_EraseRootFromParent_Done,
     /*  971374 */   // Label 14573: @971374
     /*  971374 */   GIM_Try, /*On fail goto*//*Label 14574*/ GIMT_Encode4(971469), // Rule ID 8318 //
     /*  971379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  971396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971429 */     // MIs[1] Operand 1
     /*  971429 */     // No operand predicates
     /*  971429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  971442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  971445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971467 */     GIR_RootConstrainSelectedInstOperands,
     /*  971468 */     // GIR_Coverage, 8318,
     /*  971468 */     GIR_EraseRootFromParent_Done,
     /*  971469 */   // Label 14574: @971469
     /*  971469 */   GIM_Try, /*On fail goto*//*Label 14575*/ GIMT_Encode4(971564), // Rule ID 8319 //
     /*  971474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  971491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971524 */     // MIs[1] Operand 1
     /*  971524 */     // No operand predicates
     /*  971524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971537 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  971540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971562 */     GIR_RootConstrainSelectedInstOperands,
     /*  971563 */     // GIR_Coverage, 8319,
     /*  971563 */     GIR_EraseRootFromParent_Done,
     /*  971564 */   // Label 14575: @971564
     /*  971564 */   GIM_Try, /*On fail goto*//*Label 14576*/ GIMT_Encode4(971659), // Rule ID 8322 //
     /*  971569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  971586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971619 */     // MIs[1] Operand 1
     /*  971619 */     // No operand predicates
     /*  971619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971632 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  971632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971657 */     GIR_RootConstrainSelectedInstOperands,
     /*  971658 */     // GIR_Coverage, 8322,
     /*  971658 */     GIR_EraseRootFromParent_Done,
     /*  971659 */   // Label 14576: @971659
     /*  971659 */   GIM_Try, /*On fail goto*//*Label 14577*/ GIMT_Encode4(971754), // Rule ID 8323 //
     /*  971664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  971681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971714 */     // MIs[1] Operand 1
     /*  971714 */     // No operand predicates
     /*  971714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971727 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971752 */     GIR_RootConstrainSelectedInstOperands,
     /*  971753 */     // GIR_Coverage, 8323,
     /*  971753 */     GIR_EraseRootFromParent_Done,
     /*  971754 */   // Label 14577: @971754
     /*  971754 */   GIM_Try, /*On fail goto*//*Label 14578*/ GIMT_Encode4(971849), // Rule ID 8326 //
     /*  971759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  971776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971809 */     // MIs[1] Operand 1
     /*  971809 */     // No operand predicates
     /*  971809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971822 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  971822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971847 */     GIR_RootConstrainSelectedInstOperands,
     /*  971848 */     // GIR_Coverage, 8326,
     /*  971848 */     GIR_EraseRootFromParent_Done,
     /*  971849 */   // Label 14578: @971849
     /*  971849 */   GIM_Try, /*On fail goto*//*Label 14579*/ GIMT_Encode4(971944), // Rule ID 8327 //
     /*  971854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  971871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971904 */     // MIs[1] Operand 1
     /*  971904 */     // No operand predicates
     /*  971904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971917 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971942 */     GIR_RootConstrainSelectedInstOperands,
     /*  971943 */     // GIR_Coverage, 8327,
     /*  971943 */     GIR_EraseRootFromParent_Done,
     /*  971944 */   // Label 14579: @971944
     /*  971944 */   GIM_Try, /*On fail goto*//*Label 14580*/ GIMT_Encode4(972039), // Rule ID 8330 //
     /*  971949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  971966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971999 */     // MIs[1] Operand 1
     /*  971999 */     // No operand predicates
     /*  971999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972012 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  972012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  972015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972037 */     GIR_RootConstrainSelectedInstOperands,
     /*  972038 */     // GIR_Coverage, 8330,
     /*  972038 */     GIR_EraseRootFromParent_Done,
     /*  972039 */   // Label 14580: @972039
     /*  972039 */   GIM_Try, /*On fail goto*//*Label 14581*/ GIMT_Encode4(972134), // Rule ID 8331 //
     /*  972044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  972047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  972061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  972082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972094 */     // MIs[1] Operand 1
     /*  972094 */     // No operand predicates
     /*  972094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972107 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  972107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  972110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972132 */     GIR_RootConstrainSelectedInstOperands,
     /*  972133 */     // GIR_Coverage, 8331,
     /*  972133 */     GIR_EraseRootFromParent_Done,
     /*  972134 */   // Label 14581: @972134
     /*  972134 */   GIM_Try, /*On fail goto*//*Label 14582*/ GIMT_Encode4(972229), // Rule ID 8334 //
     /*  972139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  972142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  972156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  972177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972189 */     // MIs[1] Operand 1
     /*  972189 */     // No operand predicates
     /*  972189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972202 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  972202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  972205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972227 */     GIR_RootConstrainSelectedInstOperands,
     /*  972228 */     // GIR_Coverage, 8334,
     /*  972228 */     GIR_EraseRootFromParent_Done,
     /*  972229 */   // Label 14582: @972229
     /*  972229 */   GIM_Try, /*On fail goto*//*Label 14583*/ GIMT_Encode4(972324), // Rule ID 8335 //
     /*  972234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  972237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  972251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  972272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972284 */     // MIs[1] Operand 1
     /*  972284 */     // No operand predicates
     /*  972284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972297 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  972297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  972300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972322 */     GIR_RootConstrainSelectedInstOperands,
     /*  972323 */     // GIR_Coverage, 8335,
     /*  972323 */     GIR_EraseRootFromParent_Done,
     /*  972324 */   // Label 14583: @972324
     /*  972324 */   GIM_Try, /*On fail goto*//*Label 14584*/ GIMT_Encode4(972419), // Rule ID 8338 //
     /*  972329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  972332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  972340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  972343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  972346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  972352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  972367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972379 */     // MIs[1] Operand 1
     /*  972379 */     // No operand predicates
     /*  972379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972392 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  972392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  972395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972417 */     GIR_RootConstrainSelectedInstOperands,
     /*  972418 */     // GIR_Coverage, 8338,
     /*  972418 */     GIR_EraseRootFromParent_Done,
     /*  972419 */   // Label 14584: @972419
     /*  972419 */   GIM_Try, /*On fail goto*//*Label 14585*/ GIMT_Encode4(972514), // Rule ID 8339 //
     /*  972424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  972427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  972435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  972438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  972441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  972447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  972462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972474 */     // MIs[1] Operand 1
     /*  972474 */     // No operand predicates
     /*  972474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972487 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  972487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  972490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972512 */     GIR_RootConstrainSelectedInstOperands,
     /*  972513 */     // GIR_Coverage, 8339,
     /*  972513 */     GIR_EraseRootFromParent_Done,
     /*  972514 */   // Label 14585: @972514
     /*  972514 */   GIM_Try, /*On fail goto*//*Label 14586*/ GIMT_Encode4(972609), // Rule ID 8870 //
     /*  972519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  972536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972569 */     // MIs[1] Operand 1
     /*  972569 */     // No operand predicates
     /*  972569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972582 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  972585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972607 */     GIR_RootConstrainSelectedInstOperands,
     /*  972608 */     // GIR_Coverage, 8870,
     /*  972608 */     GIR_EraseRootFromParent_Done,
     /*  972609 */   // Label 14586: @972609
     /*  972609 */   GIM_Try, /*On fail goto*//*Label 14587*/ GIMT_Encode4(972704), // Rule ID 8871 //
     /*  972614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  972631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972664 */     // MIs[1] Operand 1
     /*  972664 */     // No operand predicates
     /*  972664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972677 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  972680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972702 */     GIR_RootConstrainSelectedInstOperands,
     /*  972703 */     // GIR_Coverage, 8871,
     /*  972703 */     GIR_EraseRootFromParent_Done,
     /*  972704 */   // Label 14587: @972704
     /*  972704 */   GIM_Try, /*On fail goto*//*Label 14588*/ GIMT_Encode4(972799), // Rule ID 8874 //
     /*  972709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  972726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972759 */     // MIs[1] Operand 1
     /*  972759 */     // No operand predicates
     /*  972759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972772 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972797 */     GIR_RootConstrainSelectedInstOperands,
     /*  972798 */     // GIR_Coverage, 8874,
     /*  972798 */     GIR_EraseRootFromParent_Done,
     /*  972799 */   // Label 14588: @972799
     /*  972799 */   GIM_Try, /*On fail goto*//*Label 14589*/ GIMT_Encode4(972894), // Rule ID 8875 //
     /*  972804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  972821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972854 */     // MIs[1] Operand 1
     /*  972854 */     // No operand predicates
     /*  972854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972867 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972892 */     GIR_RootConstrainSelectedInstOperands,
     /*  972893 */     // GIR_Coverage, 8875,
     /*  972893 */     GIR_EraseRootFromParent_Done,
     /*  972894 */   // Label 14589: @972894
     /*  972894 */   GIM_Try, /*On fail goto*//*Label 14590*/ GIMT_Encode4(972989), // Rule ID 8878 //
     /*  972899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  972916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972949 */     // MIs[1] Operand 1
     /*  972949 */     // No operand predicates
     /*  972949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972962 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972987 */     GIR_RootConstrainSelectedInstOperands,
     /*  972988 */     // GIR_Coverage, 8878,
     /*  972988 */     GIR_EraseRootFromParent_Done,
     /*  972989 */   // Label 14590: @972989
     /*  972989 */   GIM_Try, /*On fail goto*//*Label 14591*/ GIMT_Encode4(973084), // Rule ID 8879 //
     /*  972994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  973011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973044 */     // MIs[1] Operand 1
     /*  973044 */     // No operand predicates
     /*  973044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973057 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973082 */     GIR_RootConstrainSelectedInstOperands,
     /*  973083 */     // GIR_Coverage, 8879,
     /*  973083 */     GIR_EraseRootFromParent_Done,
     /*  973084 */   // Label 14591: @973084
     /*  973084 */   GIM_Try, /*On fail goto*//*Label 14592*/ GIMT_Encode4(973179), // Rule ID 8882 //
     /*  973089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  973106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973139 */     // MIs[1] Operand 1
     /*  973139 */     // No operand predicates
     /*  973139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973152 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  973152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  973155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973177 */     GIR_RootConstrainSelectedInstOperands,
     /*  973178 */     // GIR_Coverage, 8882,
     /*  973178 */     GIR_EraseRootFromParent_Done,
     /*  973179 */   // Label 14592: @973179
     /*  973179 */   GIM_Try, /*On fail goto*//*Label 14593*/ GIMT_Encode4(973274), // Rule ID 8883 //
     /*  973184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  973201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973234 */     // MIs[1] Operand 1
     /*  973234 */     // No operand predicates
     /*  973234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973247 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  973247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  973250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973272 */     GIR_RootConstrainSelectedInstOperands,
     /*  973273 */     // GIR_Coverage, 8883,
     /*  973273 */     GIR_EraseRootFromParent_Done,
     /*  973274 */   // Label 14593: @973274
     /*  973274 */   GIM_Try, /*On fail goto*//*Label 14594*/ GIMT_Encode4(973369), // Rule ID 8886 //
     /*  973279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  973296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973329 */     // MIs[1] Operand 1
     /*  973329 */     // No operand predicates
     /*  973329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973342 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  973342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973367 */     GIR_RootConstrainSelectedInstOperands,
     /*  973368 */     // GIR_Coverage, 8886,
     /*  973368 */     GIR_EraseRootFromParent_Done,
     /*  973369 */   // Label 14594: @973369
     /*  973369 */   GIM_Try, /*On fail goto*//*Label 14595*/ GIMT_Encode4(973464), // Rule ID 8887 //
     /*  973374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  973391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973424 */     // MIs[1] Operand 1
     /*  973424 */     // No operand predicates
     /*  973424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973437 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  973437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973462 */     GIR_RootConstrainSelectedInstOperands,
     /*  973463 */     // GIR_Coverage, 8887,
     /*  973463 */     GIR_EraseRootFromParent_Done,
     /*  973464 */   // Label 14595: @973464
     /*  973464 */   GIM_Try, /*On fail goto*//*Label 14596*/ GIMT_Encode4(973559), // Rule ID 8890 //
     /*  973469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  973486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973519 */     // MIs[1] Operand 1
     /*  973519 */     // No operand predicates
     /*  973519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973532 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  973532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973557 */     GIR_RootConstrainSelectedInstOperands,
     /*  973558 */     // GIR_Coverage, 8890,
     /*  973558 */     GIR_EraseRootFromParent_Done,
     /*  973559 */   // Label 14596: @973559
     /*  973559 */   GIM_Try, /*On fail goto*//*Label 14597*/ GIMT_Encode4(973654), // Rule ID 8891 //
     /*  973564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  973581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973614 */     // MIs[1] Operand 1
     /*  973614 */     // No operand predicates
     /*  973614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973627 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  973627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973652 */     GIR_RootConstrainSelectedInstOperands,
     /*  973653 */     // GIR_Coverage, 8891,
     /*  973653 */     GIR_EraseRootFromParent_Done,
     /*  973654 */   // Label 14597: @973654
     /*  973654 */   GIM_Try, /*On fail goto*//*Label 14598*/ GIMT_Encode4(973749), // Rule ID 8894 //
     /*  973659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  973670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  973673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  973676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  973682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973709 */     // MIs[1] Operand 1
     /*  973709 */     // No operand predicates
     /*  973709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973722 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  973722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973747 */     GIR_RootConstrainSelectedInstOperands,
     /*  973748 */     // GIR_Coverage, 8894,
     /*  973748 */     GIR_EraseRootFromParent_Done,
     /*  973749 */   // Label 14598: @973749
     /*  973749 */   GIM_Try, /*On fail goto*//*Label 14599*/ GIMT_Encode4(973844), // Rule ID 8895 //
     /*  973754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  973765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  973768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  973771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  973777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973804 */     // MIs[1] Operand 1
     /*  973804 */     // No operand predicates
     /*  973804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973817 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973842 */     GIR_RootConstrainSelectedInstOperands,
     /*  973843 */     // GIR_Coverage, 8895,
     /*  973843 */     GIR_EraseRootFromParent_Done,
     /*  973844 */   // Label 14599: @973844
     /*  973844 */   GIM_Try, /*On fail goto*//*Label 14600*/ GIMT_Encode4(973939), // Rule ID 8898 //
     /*  973849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973899 */     // MIs[1] Operand 1
     /*  973899 */     // No operand predicates
     /*  973899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973912 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  973912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973937 */     GIR_RootConstrainSelectedInstOperands,
     /*  973938 */     // GIR_Coverage, 8898,
     /*  973938 */     GIR_EraseRootFromParent_Done,
     /*  973939 */   // Label 14600: @973939
     /*  973939 */   GIM_Try, /*On fail goto*//*Label 14601*/ GIMT_Encode4(974034), // Rule ID 8899 //
     /*  973944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973994 */     // MIs[1] Operand 1
     /*  973994 */     // No operand predicates
     /*  973994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974007 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  974010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974032 */     GIR_RootConstrainSelectedInstOperands,
     /*  974033 */     // GIR_Coverage, 8899,
     /*  974033 */     GIR_EraseRootFromParent_Done,
     /*  974034 */   // Label 14601: @974034
     /*  974034 */   GIM_Try, /*On fail goto*//*Label 14602*/ GIMT_Encode4(974129), // Rule ID 8902 //
     /*  974039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  974050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  974053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  974056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  974062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974089 */     // MIs[1] Operand 1
     /*  974089 */     // No operand predicates
     /*  974089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974102 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  974102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  974105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  974124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974127 */     GIR_RootConstrainSelectedInstOperands,
     /*  974128 */     // GIR_Coverage, 8902,
     /*  974128 */     GIR_EraseRootFromParent_Done,
     /*  974129 */   // Label 14602: @974129
     /*  974129 */   GIM_Try, /*On fail goto*//*Label 14603*/ GIMT_Encode4(974224), // Rule ID 8903 //
     /*  974134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  974145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  974148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  974151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  974157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974184 */     // MIs[1] Operand 1
     /*  974184 */     // No operand predicates
     /*  974184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974197 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  974197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  974200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  974219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974222 */     GIR_RootConstrainSelectedInstOperands,
     /*  974223 */     // GIR_Coverage, 8903,
     /*  974223 */     GIR_EraseRootFromParent_Done,
     /*  974224 */   // Label 14603: @974224
     /*  974224 */   GIM_Try, /*On fail goto*//*Label 14604*/ GIMT_Encode4(974319), // Rule ID 8906 //
     /*  974229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  974232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  974240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  974243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  974246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  974252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974279 */     // MIs[1] Operand 1
     /*  974279 */     // No operand predicates
     /*  974279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974292 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  974292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  974295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  974314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974317 */     GIR_RootConstrainSelectedInstOperands,
     /*  974318 */     // GIR_Coverage, 8906,
     /*  974318 */     GIR_EraseRootFromParent_Done,
     /*  974319 */   // Label 14604: @974319
     /*  974319 */   GIM_Try, /*On fail goto*//*Label 14605*/ GIMT_Encode4(974414), // Rule ID 8907 //
     /*  974324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  974327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  974335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  974338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  974341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  974347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974374 */     // MIs[1] Operand 1
     /*  974374 */     // No operand predicates
     /*  974374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974387 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  974387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  974390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  974409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974412 */     GIR_RootConstrainSelectedInstOperands,
     /*  974413 */     // GIR_Coverage, 8907,
     /*  974413 */     GIR_EraseRootFromParent_Done,
     /*  974414 */   // Label 14605: @974414
     /*  974414 */   GIM_Try, /*On fail goto*//*Label 14606*/ GIMT_Encode4(974509), // Rule ID 8910 //
     /*  974419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  974436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974469 */     // MIs[1] Operand 1
     /*  974469 */     // No operand predicates
     /*  974469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974482 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974507 */     GIR_RootConstrainSelectedInstOperands,
     /*  974508 */     // GIR_Coverage, 8910,
     /*  974508 */     GIR_EraseRootFromParent_Done,
     /*  974509 */   // Label 14606: @974509
     /*  974509 */   GIM_Try, /*On fail goto*//*Label 14607*/ GIMT_Encode4(974604), // Rule ID 8911 //
     /*  974514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  974531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974564 */     // MIs[1] Operand 1
     /*  974564 */     // No operand predicates
     /*  974564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974577 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974602 */     GIR_RootConstrainSelectedInstOperands,
     /*  974603 */     // GIR_Coverage, 8911,
     /*  974603 */     GIR_EraseRootFromParent_Done,
     /*  974604 */   // Label 14607: @974604
     /*  974604 */   GIM_Try, /*On fail goto*//*Label 14608*/ GIMT_Encode4(974699), // Rule ID 8914 //
     /*  974609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  974626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974659 */     // MIs[1] Operand 1
     /*  974659 */     // No operand predicates
     /*  974659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974672 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974697 */     GIR_RootConstrainSelectedInstOperands,
     /*  974698 */     // GIR_Coverage, 8914,
     /*  974698 */     GIR_EraseRootFromParent_Done,
     /*  974699 */   // Label 14608: @974699
     /*  974699 */   GIM_Try, /*On fail goto*//*Label 14609*/ GIMT_Encode4(974794), // Rule ID 8915 //
     /*  974704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  974721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974754 */     // MIs[1] Operand 1
     /*  974754 */     // No operand predicates
     /*  974754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974767 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974792 */     GIR_RootConstrainSelectedInstOperands,
     /*  974793 */     // GIR_Coverage, 8915,
     /*  974793 */     GIR_EraseRootFromParent_Done,
     /*  974794 */   // Label 14609: @974794
     /*  974794 */   GIM_Try, /*On fail goto*//*Label 14610*/ GIMT_Encode4(974889), // Rule ID 8918 //
     /*  974799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  974810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  974813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  974816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  974822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974849 */     // MIs[1] Operand 1
     /*  974849 */     // No operand predicates
     /*  974849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974862 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  974865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974887 */     GIR_RootConstrainSelectedInstOperands,
     /*  974888 */     // GIR_Coverage, 8918,
     /*  974888 */     GIR_EraseRootFromParent_Done,
     /*  974889 */   // Label 14610: @974889
     /*  974889 */   GIM_Try, /*On fail goto*//*Label 14611*/ GIMT_Encode4(974984), // Rule ID 8919 //
     /*  974894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  974905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  974908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  974911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  974917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974944 */     // MIs[1] Operand 1
     /*  974944 */     // No operand predicates
     /*  974944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974957 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  974960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974982 */     GIR_RootConstrainSelectedInstOperands,
     /*  974983 */     // GIR_Coverage, 8919,
     /*  974983 */     GIR_EraseRootFromParent_Done,
     /*  974984 */   // Label 14611: @974984
     /*  974984 */   GIM_Try, /*On fail goto*//*Label 14612*/ GIMT_Encode4(975079), // Rule ID 8922 //
     /*  974989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  975006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975039 */     // MIs[1] Operand 1
     /*  975039 */     // No operand predicates
     /*  975039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975052 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  975052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975077 */     GIR_RootConstrainSelectedInstOperands,
     /*  975078 */     // GIR_Coverage, 8922,
     /*  975078 */     GIR_EraseRootFromParent_Done,
     /*  975079 */   // Label 14612: @975079
     /*  975079 */   GIM_Try, /*On fail goto*//*Label 14613*/ GIMT_Encode4(975174), // Rule ID 8923 //
     /*  975084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  975101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975134 */     // MIs[1] Operand 1
     /*  975134 */     // No operand predicates
     /*  975134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975147 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  975147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975172 */     GIR_RootConstrainSelectedInstOperands,
     /*  975173 */     // GIR_Coverage, 8923,
     /*  975173 */     GIR_EraseRootFromParent_Done,
     /*  975174 */   // Label 14613: @975174
     /*  975174 */   GIM_Try, /*On fail goto*//*Label 14614*/ GIMT_Encode4(975269), // Rule ID 8926 //
     /*  975179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  975196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975229 */     // MIs[1] Operand 1
     /*  975229 */     // No operand predicates
     /*  975229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975242 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  975242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975267 */     GIR_RootConstrainSelectedInstOperands,
     /*  975268 */     // GIR_Coverage, 8926,
     /*  975268 */     GIR_EraseRootFromParent_Done,
     /*  975269 */   // Label 14614: @975269
     /*  975269 */   GIM_Try, /*On fail goto*//*Label 14615*/ GIMT_Encode4(975364), // Rule ID 8927 //
     /*  975274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  975291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975324 */     // MIs[1] Operand 1
     /*  975324 */     // No operand predicates
     /*  975324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975337 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  975337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975362 */     GIR_RootConstrainSelectedInstOperands,
     /*  975363 */     // GIR_Coverage, 8927,
     /*  975363 */     GIR_EraseRootFromParent_Done,
     /*  975364 */   // Label 14615: @975364
     /*  975364 */   GIM_Try, /*On fail goto*//*Label 14616*/ GIMT_Encode4(975459), // Rule ID 8930 //
     /*  975369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  975380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  975383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  975386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  975392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975419 */     // MIs[1] Operand 1
     /*  975419 */     // No operand predicates
     /*  975419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975432 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  975432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975457 */     GIR_RootConstrainSelectedInstOperands,
     /*  975458 */     // GIR_Coverage, 8930,
     /*  975458 */     GIR_EraseRootFromParent_Done,
     /*  975459 */   // Label 14616: @975459
     /*  975459 */   GIM_Try, /*On fail goto*//*Label 14617*/ GIMT_Encode4(975554), // Rule ID 8931 //
     /*  975464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  975475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  975478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  975481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  975487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975514 */     // MIs[1] Operand 1
     /*  975514 */     // No operand predicates
     /*  975514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975527 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  975527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975552 */     GIR_RootConstrainSelectedInstOperands,
     /*  975553 */     // GIR_Coverage, 8931,
     /*  975553 */     GIR_EraseRootFromParent_Done,
     /*  975554 */   // Label 14617: @975554
     /*  975554 */   GIM_Try, /*On fail goto*//*Label 14618*/ GIMT_Encode4(975649), // Rule ID 8934 //
     /*  975559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  975576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975609 */     // MIs[1] Operand 1
     /*  975609 */     // No operand predicates
     /*  975609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975622 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975647 */     GIR_RootConstrainSelectedInstOperands,
     /*  975648 */     // GIR_Coverage, 8934,
     /*  975648 */     GIR_EraseRootFromParent_Done,
     /*  975649 */   // Label 14618: @975649
     /*  975649 */   GIM_Try, /*On fail goto*//*Label 14619*/ GIMT_Encode4(975744), // Rule ID 8935 //
     /*  975654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  975671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975704 */     // MIs[1] Operand 1
     /*  975704 */     // No operand predicates
     /*  975704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975717 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975742 */     GIR_RootConstrainSelectedInstOperands,
     /*  975743 */     // GIR_Coverage, 8935,
     /*  975743 */     GIR_EraseRootFromParent_Done,
     /*  975744 */   // Label 14619: @975744
     /*  975744 */   GIM_Try, /*On fail goto*//*Label 14620*/ GIMT_Encode4(975839), // Rule ID 8938 //
     /*  975749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  975766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975799 */     // MIs[1] Operand 1
     /*  975799 */     // No operand predicates
     /*  975799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975812 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975837 */     GIR_RootConstrainSelectedInstOperands,
     /*  975838 */     // GIR_Coverage, 8938,
     /*  975838 */     GIR_EraseRootFromParent_Done,
     /*  975839 */   // Label 14620: @975839
     /*  975839 */   GIM_Try, /*On fail goto*//*Label 14621*/ GIMT_Encode4(975934), // Rule ID 8939 //
     /*  975844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  975861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975894 */     // MIs[1] Operand 1
     /*  975894 */     // No operand predicates
     /*  975894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975907 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975932 */     GIR_RootConstrainSelectedInstOperands,
     /*  975933 */     // GIR_Coverage, 8939,
     /*  975933 */     GIR_EraseRootFromParent_Done,
     /*  975934 */   // Label 14621: @975934
     /*  975934 */   GIM_Try, /*On fail goto*//*Label 14622*/ GIMT_Encode4(976029), // Rule ID 8942 //
     /*  975939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975989 */     // MIs[1] Operand 1
     /*  975989 */     // No operand predicates
     /*  975989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976002 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  976002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  976005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976027 */     GIR_RootConstrainSelectedInstOperands,
     /*  976028 */     // GIR_Coverage, 8942,
     /*  976028 */     GIR_EraseRootFromParent_Done,
     /*  976029 */   // Label 14622: @976029
     /*  976029 */   GIM_Try, /*On fail goto*//*Label 14623*/ GIMT_Encode4(976124), // Rule ID 8943 //
     /*  976034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  976045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  976048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  976051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  976057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  976072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976084 */     // MIs[1] Operand 1
     /*  976084 */     // No operand predicates
     /*  976084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976097 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  976097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  976100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976122 */     GIR_RootConstrainSelectedInstOperands,
     /*  976123 */     // GIR_Coverage, 8943,
     /*  976123 */     GIR_EraseRootFromParent_Done,
     /*  976124 */   // Label 14623: @976124
     /*  976124 */   GIM_Try, /*On fail goto*//*Label 14624*/ GIMT_Encode4(976219), // Rule ID 8946 //
     /*  976129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  976132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  976146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  976167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976179 */     // MIs[1] Operand 1
     /*  976179 */     // No operand predicates
     /*  976179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976192 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  976192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  976195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976217 */     GIR_RootConstrainSelectedInstOperands,
     /*  976218 */     // GIR_Coverage, 8946,
     /*  976218 */     GIR_EraseRootFromParent_Done,
     /*  976219 */   // Label 14624: @976219
     /*  976219 */   GIM_Try, /*On fail goto*//*Label 14625*/ GIMT_Encode4(976314), // Rule ID 8947 //
     /*  976224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  976227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  976241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  976262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976274 */     // MIs[1] Operand 1
     /*  976274 */     // No operand predicates
     /*  976274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976287 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  976287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  976290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976312 */     GIR_RootConstrainSelectedInstOperands,
     /*  976313 */     // GIR_Coverage, 8947,
     /*  976313 */     GIR_EraseRootFromParent_Done,
     /*  976314 */   // Label 14625: @976314
     /*  976314 */   GIM_Try, /*On fail goto*//*Label 14626*/ GIMT_Encode4(976409), // Rule ID 8950 //
     /*  976319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  976322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  976336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  976357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976369 */     // MIs[1] Operand 1
     /*  976369 */     // No operand predicates
     /*  976369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976382 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  976382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  976385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976407 */     GIR_RootConstrainSelectedInstOperands,
     /*  976408 */     // GIR_Coverage, 8950,
     /*  976408 */     GIR_EraseRootFromParent_Done,
     /*  976409 */   // Label 14626: @976409
     /*  976409 */   GIM_Try, /*On fail goto*//*Label 14627*/ GIMT_Encode4(976504), // Rule ID 8951 //
     /*  976414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  976417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  976431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  976452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976464 */     // MIs[1] Operand 1
     /*  976464 */     // No operand predicates
     /*  976464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976477 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  976477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  976480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976502 */     GIR_RootConstrainSelectedInstOperands,
     /*  976503 */     // GIR_Coverage, 8951,
     /*  976503 */     GIR_EraseRootFromParent_Done,
     /*  976504 */   // Label 14627: @976504
     /*  976504 */   GIM_Try, /*On fail goto*//*Label 14628*/ GIMT_Encode4(976599), // Rule ID 8954 //
     /*  976509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  976512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  976520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  976523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  976526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  976532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  976547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976559 */     // MIs[1] Operand 1
     /*  976559 */     // No operand predicates
     /*  976559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976572 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  976572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  976575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976597 */     GIR_RootConstrainSelectedInstOperands,
     /*  976598 */     // GIR_Coverage, 8954,
     /*  976598 */     GIR_EraseRootFromParent_Done,
     /*  976599 */   // Label 14628: @976599
     /*  976599 */   GIM_Try, /*On fail goto*//*Label 14629*/ GIMT_Encode4(976694), // Rule ID 8955 //
     /*  976604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  976607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  976615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  976618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  976621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  976627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  976642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976654 */     // MIs[1] Operand 1
     /*  976654 */     // No operand predicates
     /*  976654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976667 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  976667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  976670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976692 */     GIR_RootConstrainSelectedInstOperands,
     /*  976693 */     // GIR_Coverage, 8955,
     /*  976693 */     GIR_EraseRootFromParent_Done,
     /*  976694 */   // Label 14629: @976694
     /*  976694 */   GIM_Try, /*On fail goto*//*Label 14630*/ GIMT_Encode4(976789), // Rule ID 9134 //
     /*  976699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  976716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976749 */     // MIs[1] Operand 1
     /*  976749 */     // No operand predicates
     /*  976749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976762 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  976765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976787 */     GIR_RootConstrainSelectedInstOperands,
     /*  976788 */     // GIR_Coverage, 9134,
     /*  976788 */     GIR_EraseRootFromParent_Done,
     /*  976789 */   // Label 14630: @976789
     /*  976789 */   GIM_Try, /*On fail goto*//*Label 14631*/ GIMT_Encode4(976884), // Rule ID 9135 //
     /*  976794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  976811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976844 */     // MIs[1] Operand 1
     /*  976844 */     // No operand predicates
     /*  976844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976857 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  976860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976882 */     GIR_RootConstrainSelectedInstOperands,
     /*  976883 */     // GIR_Coverage, 9135,
     /*  976883 */     GIR_EraseRootFromParent_Done,
     /*  976884 */   // Label 14631: @976884
     /*  976884 */   GIM_Try, /*On fail goto*//*Label 14632*/ GIMT_Encode4(976979), // Rule ID 9138 //
     /*  976889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  976906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976939 */     // MIs[1] Operand 1
     /*  976939 */     // No operand predicates
     /*  976939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976952 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976977 */     GIR_RootConstrainSelectedInstOperands,
     /*  976978 */     // GIR_Coverage, 9138,
     /*  976978 */     GIR_EraseRootFromParent_Done,
     /*  976979 */   // Label 14632: @976979
     /*  976979 */   GIM_Try, /*On fail goto*//*Label 14633*/ GIMT_Encode4(977074), // Rule ID 9139 //
     /*  976984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  977001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977034 */     // MIs[1] Operand 1
     /*  977034 */     // No operand predicates
     /*  977034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977047 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  977050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977072 */     GIR_RootConstrainSelectedInstOperands,
     /*  977073 */     // GIR_Coverage, 9139,
     /*  977073 */     GIR_EraseRootFromParent_Done,
     /*  977074 */   // Label 14633: @977074
     /*  977074 */   GIM_Try, /*On fail goto*//*Label 14634*/ GIMT_Encode4(977169), // Rule ID 9142 //
     /*  977079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  977096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977129 */     // MIs[1] Operand 1
     /*  977129 */     // No operand predicates
     /*  977129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977142 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  977142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977167 */     GIR_RootConstrainSelectedInstOperands,
     /*  977168 */     // GIR_Coverage, 9142,
     /*  977168 */     GIR_EraseRootFromParent_Done,
     /*  977169 */   // Label 14634: @977169
     /*  977169 */   GIM_Try, /*On fail goto*//*Label 14635*/ GIMT_Encode4(977264), // Rule ID 9143 //
     /*  977174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  977191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977224 */     // MIs[1] Operand 1
     /*  977224 */     // No operand predicates
     /*  977224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977237 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977262 */     GIR_RootConstrainSelectedInstOperands,
     /*  977263 */     // GIR_Coverage, 9143,
     /*  977263 */     GIR_EraseRootFromParent_Done,
     /*  977264 */   // Label 14635: @977264
     /*  977264 */   GIM_Try, /*On fail goto*//*Label 14636*/ GIMT_Encode4(977359), // Rule ID 9146 //
     /*  977269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  977286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977319 */     // MIs[1] Operand 1
     /*  977319 */     // No operand predicates
     /*  977319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977332 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  977332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  977335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977357 */     GIR_RootConstrainSelectedInstOperands,
     /*  977358 */     // GIR_Coverage, 9146,
     /*  977358 */     GIR_EraseRootFromParent_Done,
     /*  977359 */   // Label 14636: @977359
     /*  977359 */   GIM_Try, /*On fail goto*//*Label 14637*/ GIMT_Encode4(977454), // Rule ID 9147 //
     /*  977364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  977381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977414 */     // MIs[1] Operand 1
     /*  977414 */     // No operand predicates
     /*  977414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977427 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  977427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  977430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977452 */     GIR_RootConstrainSelectedInstOperands,
     /*  977453 */     // GIR_Coverage, 9147,
     /*  977453 */     GIR_EraseRootFromParent_Done,
     /*  977454 */   // Label 14637: @977454
     /*  977454 */   GIM_Try, /*On fail goto*//*Label 14638*/ GIMT_Encode4(977549), // Rule ID 9150 //
     /*  977459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  977476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977509 */     // MIs[1] Operand 1
     /*  977509 */     // No operand predicates
     /*  977509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977522 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  977522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977547 */     GIR_RootConstrainSelectedInstOperands,
     /*  977548 */     // GIR_Coverage, 9150,
     /*  977548 */     GIR_EraseRootFromParent_Done,
     /*  977549 */   // Label 14638: @977549
     /*  977549 */   GIM_Try, /*On fail goto*//*Label 14639*/ GIMT_Encode4(977644), // Rule ID 9151 //
     /*  977554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  977571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977604 */     // MIs[1] Operand 1
     /*  977604 */     // No operand predicates
     /*  977604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977617 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  977617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977642 */     GIR_RootConstrainSelectedInstOperands,
     /*  977643 */     // GIR_Coverage, 9151,
     /*  977643 */     GIR_EraseRootFromParent_Done,
     /*  977644 */   // Label 14639: @977644
     /*  977644 */   GIM_Try, /*On fail goto*//*Label 14640*/ GIMT_Encode4(977739), // Rule ID 9154 //
     /*  977649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  977666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977699 */     // MIs[1] Operand 1
     /*  977699 */     // No operand predicates
     /*  977699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977712 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  977712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977737 */     GIR_RootConstrainSelectedInstOperands,
     /*  977738 */     // GIR_Coverage, 9154,
     /*  977738 */     GIR_EraseRootFromParent_Done,
     /*  977739 */   // Label 14640: @977739
     /*  977739 */   GIM_Try, /*On fail goto*//*Label 14641*/ GIMT_Encode4(977834), // Rule ID 9155 //
     /*  977744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  977761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977794 */     // MIs[1] Operand 1
     /*  977794 */     // No operand predicates
     /*  977794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977807 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  977807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977832 */     GIR_RootConstrainSelectedInstOperands,
     /*  977833 */     // GIR_Coverage, 9155,
     /*  977833 */     GIR_EraseRootFromParent_Done,
     /*  977834 */   // Label 14641: @977834
     /*  977834 */   GIM_Try, /*On fail goto*//*Label 14642*/ GIMT_Encode4(977929), // Rule ID 9158 //
     /*  977839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  977850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  977853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  977856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  977862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977889 */     // MIs[1] Operand 1
     /*  977889 */     // No operand predicates
     /*  977889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977902 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  977902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977927 */     GIR_RootConstrainSelectedInstOperands,
     /*  977928 */     // GIR_Coverage, 9158,
     /*  977928 */     GIR_EraseRootFromParent_Done,
     /*  977929 */   // Label 14642: @977929
     /*  977929 */   GIM_Try, /*On fail goto*//*Label 14643*/ GIMT_Encode4(978024), // Rule ID 9159 //
     /*  977934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  977945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  977948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  977951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  977957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977984 */     // MIs[1] Operand 1
     /*  977984 */     // No operand predicates
     /*  977984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977997 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978022 */     GIR_RootConstrainSelectedInstOperands,
     /*  978023 */     // GIR_Coverage, 9159,
     /*  978023 */     GIR_EraseRootFromParent_Done,
     /*  978024 */   // Label 14643: @978024
     /*  978024 */   GIM_Try, /*On fail goto*//*Label 14644*/ GIMT_Encode4(978119), // Rule ID 9162 //
     /*  978029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  978040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  978043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  978046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  978052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978079 */     // MIs[1] Operand 1
     /*  978079 */     // No operand predicates
     /*  978079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978092 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978117 */     GIR_RootConstrainSelectedInstOperands,
     /*  978118 */     // GIR_Coverage, 9162,
     /*  978118 */     GIR_EraseRootFromParent_Done,
     /*  978119 */   // Label 14644: @978119
     /*  978119 */   GIM_Try, /*On fail goto*//*Label 14645*/ GIMT_Encode4(978214), // Rule ID 9163 //
     /*  978124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  978135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  978138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  978141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  978147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978174 */     // MIs[1] Operand 1
     /*  978174 */     // No operand predicates
     /*  978174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978187 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978212 */     GIR_RootConstrainSelectedInstOperands,
     /*  978213 */     // GIR_Coverage, 9163,
     /*  978213 */     GIR_EraseRootFromParent_Done,
     /*  978214 */   // Label 14645: @978214
     /*  978214 */   GIM_Try, /*On fail goto*//*Label 14646*/ GIMT_Encode4(978309), // Rule ID 9166 //
     /*  978219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  978230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  978233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  978236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  978242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978269 */     // MIs[1] Operand 1
     /*  978269 */     // No operand predicates
     /*  978269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978282 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  978282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  978304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978307 */     GIR_RootConstrainSelectedInstOperands,
     /*  978308 */     // GIR_Coverage, 9166,
     /*  978308 */     GIR_EraseRootFromParent_Done,
     /*  978309 */   // Label 14646: @978309
     /*  978309 */   GIM_Try, /*On fail goto*//*Label 14647*/ GIMT_Encode4(978404), // Rule ID 9167 //
     /*  978314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  978325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  978328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  978331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  978337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978364 */     // MIs[1] Operand 1
     /*  978364 */     // No operand predicates
     /*  978364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978377 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  978377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  978399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978402 */     GIR_RootConstrainSelectedInstOperands,
     /*  978403 */     // GIR_Coverage, 9167,
     /*  978403 */     GIR_EraseRootFromParent_Done,
     /*  978404 */   // Label 14647: @978404
     /*  978404 */   GIM_Try, /*On fail goto*//*Label 14648*/ GIMT_Encode4(978499), // Rule ID 9170 //
     /*  978409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  978412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  978420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  978423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  978426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  978432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978459 */     // MIs[1] Operand 1
     /*  978459 */     // No operand predicates
     /*  978459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978472 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  978472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  978494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978497 */     GIR_RootConstrainSelectedInstOperands,
     /*  978498 */     // GIR_Coverage, 9170,
     /*  978498 */     GIR_EraseRootFromParent_Done,
     /*  978499 */   // Label 14648: @978499
     /*  978499 */   GIM_Try, /*On fail goto*//*Label 14649*/ GIMT_Encode4(978594), // Rule ID 9171 //
     /*  978504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  978507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  978515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  978518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  978521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  978527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978554 */     // MIs[1] Operand 1
     /*  978554 */     // No operand predicates
     /*  978554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978567 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  978567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  978589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978592 */     GIR_RootConstrainSelectedInstOperands,
     /*  978593 */     // GIR_Coverage, 9171,
     /*  978593 */     GIR_EraseRootFromParent_Done,
     /*  978594 */   // Label 14649: @978594
     /*  978594 */   GIM_Try, /*On fail goto*//*Label 14650*/ GIMT_Encode4(978689), // Rule ID 9174 //
     /*  978599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  978616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978649 */     // MIs[1] Operand 1
     /*  978649 */     // No operand predicates
     /*  978649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978662 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978687 */     GIR_RootConstrainSelectedInstOperands,
     /*  978688 */     // GIR_Coverage, 9174,
     /*  978688 */     GIR_EraseRootFromParent_Done,
     /*  978689 */   // Label 14650: @978689
     /*  978689 */   GIM_Try, /*On fail goto*//*Label 14651*/ GIMT_Encode4(978784), // Rule ID 9175 //
     /*  978694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  978711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978744 */     // MIs[1] Operand 1
     /*  978744 */     // No operand predicates
     /*  978744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978757 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978782 */     GIR_RootConstrainSelectedInstOperands,
     /*  978783 */     // GIR_Coverage, 9175,
     /*  978783 */     GIR_EraseRootFromParent_Done,
     /*  978784 */   // Label 14651: @978784
     /*  978784 */   GIM_Try, /*On fail goto*//*Label 14652*/ GIMT_Encode4(978879), // Rule ID 9178 //
     /*  978789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  978806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978839 */     // MIs[1] Operand 1
     /*  978839 */     // No operand predicates
     /*  978839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978852 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  978855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978877 */     GIR_RootConstrainSelectedInstOperands,
     /*  978878 */     // GIR_Coverage, 9178,
     /*  978878 */     GIR_EraseRootFromParent_Done,
     /*  978879 */   // Label 14652: @978879
     /*  978879 */   GIM_Try, /*On fail goto*//*Label 14653*/ GIMT_Encode4(978974), // Rule ID 9179 //
     /*  978884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  978901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978934 */     // MIs[1] Operand 1
     /*  978934 */     // No operand predicates
     /*  978934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978947 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  978950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978972 */     GIR_RootConstrainSelectedInstOperands,
     /*  978973 */     // GIR_Coverage, 9179,
     /*  978973 */     GIR_EraseRootFromParent_Done,
     /*  978974 */   // Label 14653: @978974
     /*  978974 */   GIM_Try, /*On fail goto*//*Label 14654*/ GIMT_Encode4(979069), // Rule ID 9182 //
     /*  978979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  978990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  978993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  978996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  979002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979029 */     // MIs[1] Operand 1
     /*  979029 */     // No operand predicates
     /*  979029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979042 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  979042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  979064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979067 */     GIR_RootConstrainSelectedInstOperands,
     /*  979068 */     // GIR_Coverage, 9182,
     /*  979068 */     GIR_EraseRootFromParent_Done,
     /*  979069 */   // Label 14654: @979069
     /*  979069 */   GIM_Try, /*On fail goto*//*Label 14655*/ GIMT_Encode4(979164), // Rule ID 9183 //
     /*  979074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  979085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  979088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  979091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  979097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979124 */     // MIs[1] Operand 1
     /*  979124 */     // No operand predicates
     /*  979124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979137 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  979137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  979159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979162 */     GIR_RootConstrainSelectedInstOperands,
     /*  979163 */     // GIR_Coverage, 9183,
     /*  979163 */     GIR_EraseRootFromParent_Done,
     /*  979164 */   // Label 14655: @979164
     /*  979164 */   GIM_Try, /*On fail goto*//*Label 14656*/ GIMT_Encode4(979259), // Rule ID 9186 //
     /*  979169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  979186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979219 */     // MIs[1] Operand 1
     /*  979219 */     // No operand predicates
     /*  979219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979232 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  979232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979257 */     GIR_RootConstrainSelectedInstOperands,
     /*  979258 */     // GIR_Coverage, 9186,
     /*  979258 */     GIR_EraseRootFromParent_Done,
     /*  979259 */   // Label 14656: @979259
     /*  979259 */   GIM_Try, /*On fail goto*//*Label 14657*/ GIMT_Encode4(979354), // Rule ID 9187 //
     /*  979264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  979281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979314 */     // MIs[1] Operand 1
     /*  979314 */     // No operand predicates
     /*  979314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979327 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  979327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979352 */     GIR_RootConstrainSelectedInstOperands,
     /*  979353 */     // GIR_Coverage, 9187,
     /*  979353 */     GIR_EraseRootFromParent_Done,
     /*  979354 */   // Label 14657: @979354
     /*  979354 */   GIM_Try, /*On fail goto*//*Label 14658*/ GIMT_Encode4(979449), // Rule ID 9190 //
     /*  979359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  979376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979409 */     // MIs[1] Operand 1
     /*  979409 */     // No operand predicates
     /*  979409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979422 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  979422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979447 */     GIR_RootConstrainSelectedInstOperands,
     /*  979448 */     // GIR_Coverage, 9190,
     /*  979448 */     GIR_EraseRootFromParent_Done,
     /*  979449 */   // Label 14658: @979449
     /*  979449 */   GIM_Try, /*On fail goto*//*Label 14659*/ GIMT_Encode4(979544), // Rule ID 9191 //
     /*  979454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  979471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979504 */     // MIs[1] Operand 1
     /*  979504 */     // No operand predicates
     /*  979504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979517 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  979517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979542 */     GIR_RootConstrainSelectedInstOperands,
     /*  979543 */     // GIR_Coverage, 9191,
     /*  979543 */     GIR_EraseRootFromParent_Done,
     /*  979544 */   // Label 14659: @979544
     /*  979544 */   GIM_Try, /*On fail goto*//*Label 14660*/ GIMT_Encode4(979639), // Rule ID 9194 //
     /*  979549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  979560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  979563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  979566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  979572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979599 */     // MIs[1] Operand 1
     /*  979599 */     // No operand predicates
     /*  979599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979612 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  979612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979637 */     GIR_RootConstrainSelectedInstOperands,
     /*  979638 */     // GIR_Coverage, 9194,
     /*  979638 */     GIR_EraseRootFromParent_Done,
     /*  979639 */   // Label 14660: @979639
     /*  979639 */   GIM_Try, /*On fail goto*//*Label 14661*/ GIMT_Encode4(979734), // Rule ID 9195 //
     /*  979644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  979655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  979658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  979661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  979667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979694 */     // MIs[1] Operand 1
     /*  979694 */     // No operand predicates
     /*  979694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979707 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  979707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979732 */     GIR_RootConstrainSelectedInstOperands,
     /*  979733 */     // GIR_Coverage, 9195,
     /*  979733 */     GIR_EraseRootFromParent_Done,
     /*  979734 */   // Label 14661: @979734
     /*  979734 */   GIM_Try, /*On fail goto*//*Label 14662*/ GIMT_Encode4(979829), // Rule ID 9198 //
     /*  979739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  979756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979789 */     // MIs[1] Operand 1
     /*  979789 */     // No operand predicates
     /*  979789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979802 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979827 */     GIR_RootConstrainSelectedInstOperands,
     /*  979828 */     // GIR_Coverage, 9198,
     /*  979828 */     GIR_EraseRootFromParent_Done,
     /*  979829 */   // Label 14662: @979829
     /*  979829 */   GIM_Try, /*On fail goto*//*Label 14663*/ GIMT_Encode4(979924), // Rule ID 9199 //
     /*  979834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  979851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979884 */     // MIs[1] Operand 1
     /*  979884 */     // No operand predicates
     /*  979884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979897 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979922 */     GIR_RootConstrainSelectedInstOperands,
     /*  979923 */     // GIR_Coverage, 9199,
     /*  979923 */     GIR_EraseRootFromParent_Done,
     /*  979924 */   // Label 14663: @979924
     /*  979924 */   GIM_Try, /*On fail goto*//*Label 14664*/ GIMT_Encode4(980019), // Rule ID 9202 //
     /*  979929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  979946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979979 */     // MIs[1] Operand 1
     /*  979979 */     // No operand predicates
     /*  979979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979992 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  980014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980017 */     GIR_RootConstrainSelectedInstOperands,
     /*  980018 */     // GIR_Coverage, 9202,
     /*  980018 */     GIR_EraseRootFromParent_Done,
     /*  980019 */   // Label 14664: @980019
     /*  980019 */   GIM_Try, /*On fail goto*//*Label 14665*/ GIMT_Encode4(980114), // Rule ID 9203 //
     /*  980024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  980035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  980038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  980041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  980047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  980062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980074 */     // MIs[1] Operand 1
     /*  980074 */     // No operand predicates
     /*  980074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980087 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  980087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  980090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  980109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980112 */     GIR_RootConstrainSelectedInstOperands,
     /*  980113 */     // GIR_Coverage, 9203,
     /*  980113 */     GIR_EraseRootFromParent_Done,
     /*  980114 */   // Label 14665: @980114
     /*  980114 */   GIM_Try, /*On fail goto*//*Label 14666*/ GIMT_Encode4(980209), // Rule ID 9206 //
     /*  980119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  980130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  980133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  980136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  980142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980169 */     // MIs[1] Operand 1
     /*  980169 */     // No operand predicates
     /*  980169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980182 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  980182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  980185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  980204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980207 */     GIR_RootConstrainSelectedInstOperands,
     /*  980208 */     // GIR_Coverage, 9206,
     /*  980208 */     GIR_EraseRootFromParent_Done,
     /*  980209 */   // Label 14666: @980209
     /*  980209 */   GIM_Try, /*On fail goto*//*Label 14667*/ GIMT_Encode4(980304), // Rule ID 9207 //
     /*  980214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  980225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  980228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  980231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  980237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980264 */     // MIs[1] Operand 1
     /*  980264 */     // No operand predicates
     /*  980264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980277 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  980277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  980280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  980299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980302 */     GIR_RootConstrainSelectedInstOperands,
     /*  980303 */     // GIR_Coverage, 9207,
     /*  980303 */     GIR_EraseRootFromParent_Done,
     /*  980304 */   // Label 14667: @980304
     /*  980304 */   GIM_Try, /*On fail goto*//*Label 14668*/ GIMT_Encode4(980399), // Rule ID 9210 //
     /*  980309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  980326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  980347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980359 */     // MIs[1] Operand 1
     /*  980359 */     // No operand predicates
     /*  980359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980372 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  980372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  980375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980397 */     GIR_RootConstrainSelectedInstOperands,
     /*  980398 */     // GIR_Coverage, 9210,
     /*  980398 */     GIR_EraseRootFromParent_Done,
     /*  980399 */   // Label 14668: @980399
     /*  980399 */   GIM_Try, /*On fail goto*//*Label 14669*/ GIMT_Encode4(980494), // Rule ID 9211 //
     /*  980404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  980421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  980442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980454 */     // MIs[1] Operand 1
     /*  980454 */     // No operand predicates
     /*  980454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980467 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  980470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980492 */     GIR_RootConstrainSelectedInstOperands,
     /*  980493 */     // GIR_Coverage, 9211,
     /*  980493 */     GIR_EraseRootFromParent_Done,
     /*  980494 */   // Label 14669: @980494
     /*  980494 */   GIM_Try, /*On fail goto*//*Label 14670*/ GIMT_Encode4(980589), // Rule ID 9214 //
     /*  980499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  980516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  980537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980549 */     // MIs[1] Operand 1
     /*  980549 */     // No operand predicates
     /*  980549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980562 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  980562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  980565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980587 */     GIR_RootConstrainSelectedInstOperands,
     /*  980588 */     // GIR_Coverage, 9214,
     /*  980588 */     GIR_EraseRootFromParent_Done,
     /*  980589 */   // Label 14670: @980589
     /*  980589 */   GIM_Try, /*On fail goto*//*Label 14671*/ GIMT_Encode4(980684), // Rule ID 9215 //
     /*  980594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  980611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  980632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980644 */     // MIs[1] Operand 1
     /*  980644 */     // No operand predicates
     /*  980644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980657 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  980660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980682 */     GIR_RootConstrainSelectedInstOperands,
     /*  980683 */     // GIR_Coverage, 9215,
     /*  980683 */     GIR_EraseRootFromParent_Done,
     /*  980684 */   // Label 14671: @980684
     /*  980684 */   GIM_Try, /*On fail goto*//*Label 14672*/ GIMT_Encode4(980779), // Rule ID 9218 //
     /*  980689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  980700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  980703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  980706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  980712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980739 */     // MIs[1] Operand 1
     /*  980739 */     // No operand predicates
     /*  980739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980752 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  980752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  980755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980777 */     GIR_RootConstrainSelectedInstOperands,
     /*  980778 */     // GIR_Coverage, 9218,
     /*  980778 */     GIR_EraseRootFromParent_Done,
     /*  980779 */   // Label 14672: @980779
     /*  980779 */   GIM_Try, /*On fail goto*//*Label 14673*/ GIMT_Encode4(980874), // Rule ID 9219 //
     /*  980784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  980795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  980798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  980801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  980807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980834 */     // MIs[1] Operand 1
     /*  980834 */     // No operand predicates
     /*  980834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980847 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  980850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980872 */     GIR_RootConstrainSelectedInstOperands,
     /*  980873 */     // GIR_Coverage, 9219,
     /*  980873 */     GIR_EraseRootFromParent_Done,
     /*  980874 */   // Label 14673: @980874
     /*  980874 */   GIM_Try, /*On fail goto*//*Label 14674*/ GIMT_Encode4(980969), // Rule ID 9310 //
     /*  980879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980929 */     // MIs[1] Operand 1
     /*  980929 */     // No operand predicates
     /*  980929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980942 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  980945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980967 */     GIR_RootConstrainSelectedInstOperands,
     /*  980968 */     // GIR_Coverage, 9310,
     /*  980968 */     GIR_EraseRootFromParent_Done,
     /*  980969 */   // Label 14674: @980969
     /*  980969 */   GIM_Try, /*On fail goto*//*Label 14675*/ GIMT_Encode4(981064), // Rule ID 9311 //
     /*  980974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981024 */     // MIs[1] Operand 1
     /*  981024 */     // No operand predicates
     /*  981024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981037 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  981037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  981040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981062 */     GIR_RootConstrainSelectedInstOperands,
     /*  981063 */     // GIR_Coverage, 9311,
     /*  981063 */     GIR_EraseRootFromParent_Done,
     /*  981064 */   // Label 14675: @981064
     /*  981064 */   GIM_Try, /*On fail goto*//*Label 14676*/ GIMT_Encode4(981159), // Rule ID 9314 //
     /*  981069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  981086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981119 */     // MIs[1] Operand 1
     /*  981119 */     // No operand predicates
     /*  981119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981132 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  981132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  981135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981157 */     GIR_RootConstrainSelectedInstOperands,
     /*  981158 */     // GIR_Coverage, 9314,
     /*  981158 */     GIR_EraseRootFromParent_Done,
     /*  981159 */   // Label 14676: @981159
     /*  981159 */   GIM_Try, /*On fail goto*//*Label 14677*/ GIMT_Encode4(981254), // Rule ID 9315 //
     /*  981164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  981181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981214 */     // MIs[1] Operand 1
     /*  981214 */     // No operand predicates
     /*  981214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981227 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  981227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  981230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981252 */     GIR_RootConstrainSelectedInstOperands,
     /*  981253 */     // GIR_Coverage, 9315,
     /*  981253 */     GIR_EraseRootFromParent_Done,
     /*  981254 */   // Label 14677: @981254
     /*  981254 */   GIM_Try, /*On fail goto*//*Label 14678*/ GIMT_Encode4(981349), // Rule ID 9318 //
     /*  981259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  981276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981309 */     // MIs[1] Operand 1
     /*  981309 */     // No operand predicates
     /*  981309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981322 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  981322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981347 */     GIR_RootConstrainSelectedInstOperands,
     /*  981348 */     // GIR_Coverage, 9318,
     /*  981348 */     GIR_EraseRootFromParent_Done,
     /*  981349 */   // Label 14678: @981349
     /*  981349 */   GIM_Try, /*On fail goto*//*Label 14679*/ GIMT_Encode4(981444), // Rule ID 9319 //
     /*  981354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  981371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981404 */     // MIs[1] Operand 1
     /*  981404 */     // No operand predicates
     /*  981404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981417 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  981417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981442 */     GIR_RootConstrainSelectedInstOperands,
     /*  981443 */     // GIR_Coverage, 9319,
     /*  981443 */     GIR_EraseRootFromParent_Done,
     /*  981444 */   // Label 14679: @981444
     /*  981444 */   GIM_Try, /*On fail goto*//*Label 14680*/ GIMT_Encode4(981539), // Rule ID 9322 //
     /*  981449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  981466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981499 */     // MIs[1] Operand 1
     /*  981499 */     // No operand predicates
     /*  981499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981512 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  981515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981537 */     GIR_RootConstrainSelectedInstOperands,
     /*  981538 */     // GIR_Coverage, 9322,
     /*  981538 */     GIR_EraseRootFromParent_Done,
     /*  981539 */   // Label 14680: @981539
     /*  981539 */   GIM_Try, /*On fail goto*//*Label 14681*/ GIMT_Encode4(981634), // Rule ID 9323 //
     /*  981544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  981561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981594 */     // MIs[1] Operand 1
     /*  981594 */     // No operand predicates
     /*  981594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981607 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  981610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981632 */     GIR_RootConstrainSelectedInstOperands,
     /*  981633 */     // GIR_Coverage, 9323,
     /*  981633 */     GIR_EraseRootFromParent_Done,
     /*  981634 */   // Label 14681: @981634
     /*  981634 */   GIM_Try, /*On fail goto*//*Label 14682*/ GIMT_Encode4(981729), // Rule ID 9326 //
     /*  981639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  981656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981689 */     // MIs[1] Operand 1
     /*  981689 */     // No operand predicates
     /*  981689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981702 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981727 */     GIR_RootConstrainSelectedInstOperands,
     /*  981728 */     // GIR_Coverage, 9326,
     /*  981728 */     GIR_EraseRootFromParent_Done,
     /*  981729 */   // Label 14682: @981729
     /*  981729 */   GIM_Try, /*On fail goto*//*Label 14683*/ GIMT_Encode4(981824), // Rule ID 9327 //
     /*  981734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  981751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981784 */     // MIs[1] Operand 1
     /*  981784 */     // No operand predicates
     /*  981784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981797 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981822 */     GIR_RootConstrainSelectedInstOperands,
     /*  981823 */     // GIR_Coverage, 9327,
     /*  981823 */     GIR_EraseRootFromParent_Done,
     /*  981824 */   // Label 14683: @981824
     /*  981824 */   GIM_Try, /*On fail goto*//*Label 14684*/ GIMT_Encode4(981919), // Rule ID 9330 //
     /*  981829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981879 */     // MIs[1] Operand 1
     /*  981879 */     // No operand predicates
     /*  981879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981892 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  981892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981917 */     GIR_RootConstrainSelectedInstOperands,
     /*  981918 */     // GIR_Coverage, 9330,
     /*  981918 */     GIR_EraseRootFromParent_Done,
     /*  981919 */   // Label 14684: @981919
     /*  981919 */   GIM_Try, /*On fail goto*//*Label 14685*/ GIMT_Encode4(982014), // Rule ID 9331 //
     /*  981924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981974 */     // MIs[1] Operand 1
     /*  981974 */     // No operand predicates
     /*  981974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981987 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  981987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  982009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982012 */     GIR_RootConstrainSelectedInstOperands,
     /*  982013 */     // GIR_Coverage, 9331,
     /*  982013 */     GIR_EraseRootFromParent_Done,
     /*  982014 */   // Label 14685: @982014
     /*  982014 */   GIM_Try, /*On fail goto*//*Label 14686*/ GIMT_Encode4(982109), // Rule ID 9334 //
     /*  982019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  982036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982069 */     // MIs[1] Operand 1
     /*  982069 */     // No operand predicates
     /*  982069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982082 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982107 */     GIR_RootConstrainSelectedInstOperands,
     /*  982108 */     // GIR_Coverage, 9334,
     /*  982108 */     GIR_EraseRootFromParent_Done,
     /*  982109 */   // Label 14686: @982109
     /*  982109 */   GIM_Try, /*On fail goto*//*Label 14687*/ GIMT_Encode4(982204), // Rule ID 9335 //
     /*  982114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  982131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982164 */     // MIs[1] Operand 1
     /*  982164 */     // No operand predicates
     /*  982164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982177 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982202 */     GIR_RootConstrainSelectedInstOperands,
     /*  982203 */     // GIR_Coverage, 9335,
     /*  982203 */     GIR_EraseRootFromParent_Done,
     /*  982204 */   // Label 14687: @982204
     /*  982204 */   GIM_Try, /*On fail goto*//*Label 14688*/ GIMT_Encode4(982299), // Rule ID 9338 //
     /*  982209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  982220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  982223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  982226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  982232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982259 */     // MIs[1] Operand 1
     /*  982259 */     // No operand predicates
     /*  982259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982272 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982297 */     GIR_RootConstrainSelectedInstOperands,
     /*  982298 */     // GIR_Coverage, 9338,
     /*  982298 */     GIR_EraseRootFromParent_Done,
     /*  982299 */   // Label 14688: @982299
     /*  982299 */   GIM_Try, /*On fail goto*//*Label 14689*/ GIMT_Encode4(982394), // Rule ID 9339 //
     /*  982304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  982315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  982318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  982321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  982327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982354 */     // MIs[1] Operand 1
     /*  982354 */     // No operand predicates
     /*  982354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982367 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  982367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982392 */     GIR_RootConstrainSelectedInstOperands,
     /*  982393 */     // GIR_Coverage, 9339,
     /*  982393 */     GIR_EraseRootFromParent_Done,
     /*  982394 */   // Label 14689: @982394
     /*  982394 */   GIM_Try, /*On fail goto*//*Label 14690*/ GIMT_Encode4(982489), // Rule ID 9342 //
     /*  982399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  982410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  982413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  982416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  982422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982449 */     // MIs[1] Operand 1
     /*  982449 */     // No operand predicates
     /*  982449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982462 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  982462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  982484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982487 */     GIR_RootConstrainSelectedInstOperands,
     /*  982488 */     // GIR_Coverage, 9342,
     /*  982488 */     GIR_EraseRootFromParent_Done,
     /*  982489 */   // Label 14690: @982489
     /*  982489 */   GIM_Try, /*On fail goto*//*Label 14691*/ GIMT_Encode4(982584), // Rule ID 9343 //
     /*  982494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  982505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  982508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  982511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  982517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982544 */     // MIs[1] Operand 1
     /*  982544 */     // No operand predicates
     /*  982544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982557 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  982557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  982579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982582 */     GIR_RootConstrainSelectedInstOperands,
     /*  982583 */     // GIR_Coverage, 9343,
     /*  982583 */     GIR_EraseRootFromParent_Done,
     /*  982584 */   // Label 14691: @982584
     /*  982584 */   GIM_Try, /*On fail goto*//*Label 14692*/ GIMT_Encode4(982679), // Rule ID 9346 //
     /*  982589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  982592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  982600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  982603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  982606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  982612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982639 */     // MIs[1] Operand 1
     /*  982639 */     // No operand predicates
     /*  982639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982652 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  982652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  982674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982677 */     GIR_RootConstrainSelectedInstOperands,
     /*  982678 */     // GIR_Coverage, 9346,
     /*  982678 */     GIR_EraseRootFromParent_Done,
     /*  982679 */   // Label 14692: @982679
     /*  982679 */   GIM_Try, /*On fail goto*//*Label 14693*/ GIMT_Encode4(982774), // Rule ID 9347 //
     /*  982684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  982687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  982695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  982698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  982701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  982707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982734 */     // MIs[1] Operand 1
     /*  982734 */     // No operand predicates
     /*  982734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982747 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  982747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  982769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982772 */     GIR_RootConstrainSelectedInstOperands,
     /*  982773 */     // GIR_Coverage, 9347,
     /*  982773 */     GIR_EraseRootFromParent_Done,
     /*  982774 */   // Label 14693: @982774
     /*  982774 */   GIM_Try, /*On fail goto*//*Label 14694*/ GIMT_Encode4(982869), // Rule ID 9350 //
     /*  982779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  982796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982829 */     // MIs[1] Operand 1
     /*  982829 */     // No operand predicates
     /*  982829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982842 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  982845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982867 */     GIR_RootConstrainSelectedInstOperands,
     /*  982868 */     // GIR_Coverage, 9350,
     /*  982868 */     GIR_EraseRootFromParent_Done,
     /*  982869 */   // Label 14694: @982869
     /*  982869 */   GIM_Try, /*On fail goto*//*Label 14695*/ GIMT_Encode4(982964), // Rule ID 9351 //
     /*  982874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  982891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982924 */     // MIs[1] Operand 1
     /*  982924 */     // No operand predicates
     /*  982924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982937 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  982940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982962 */     GIR_RootConstrainSelectedInstOperands,
     /*  982963 */     // GIR_Coverage, 9351,
     /*  982963 */     GIR_EraseRootFromParent_Done,
     /*  982964 */   // Label 14695: @982964
     /*  982964 */   GIM_Try, /*On fail goto*//*Label 14696*/ GIMT_Encode4(983059), // Rule ID 9354 //
     /*  982969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983019 */     // MIs[1] Operand 1
     /*  983019 */     // No operand predicates
     /*  983019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983032 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  983032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  983054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983057 */     GIR_RootConstrainSelectedInstOperands,
     /*  983058 */     // GIR_Coverage, 9354,
     /*  983058 */     GIR_EraseRootFromParent_Done,
     /*  983059 */   // Label 14696: @983059
     /*  983059 */   GIM_Try, /*On fail goto*//*Label 14697*/ GIMT_Encode4(983154), // Rule ID 9355 //
     /*  983064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  983075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  983078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  983081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  983087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983114 */     // MIs[1] Operand 1
     /*  983114 */     // No operand predicates
     /*  983114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983127 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  983127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  983149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983152 */     GIR_RootConstrainSelectedInstOperands,
     /*  983153 */     // GIR_Coverage, 9355,
     /*  983153 */     GIR_EraseRootFromParent_Done,
     /*  983154 */   // Label 14697: @983154
     /*  983154 */   GIM_Try, /*On fail goto*//*Label 14698*/ GIMT_Encode4(983249), // Rule ID 9358 //
     /*  983159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  983170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  983173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  983176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  983182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983209 */     // MIs[1] Operand 1
     /*  983209 */     // No operand predicates
     /*  983209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983222 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  983222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  983244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983247 */     GIR_RootConstrainSelectedInstOperands,
     /*  983248 */     // GIR_Coverage, 9358,
     /*  983248 */     GIR_EraseRootFromParent_Done,
     /*  983249 */   // Label 14698: @983249
     /*  983249 */   GIM_Try, /*On fail goto*//*Label 14699*/ GIMT_Encode4(983344), // Rule ID 9359 //
     /*  983254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  983265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  983268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  983271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  983277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983304 */     // MIs[1] Operand 1
     /*  983304 */     // No operand predicates
     /*  983304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983317 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  983317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  983339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983342 */     GIR_RootConstrainSelectedInstOperands,
     /*  983343 */     // GIR_Coverage, 9359,
     /*  983343 */     GIR_EraseRootFromParent_Done,
     /*  983344 */   // Label 14699: @983344
     /*  983344 */   GIM_Try, /*On fail goto*//*Label 14700*/ GIMT_Encode4(983439), // Rule ID 9362 //
     /*  983349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  983366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983399 */     // MIs[1] Operand 1
     /*  983399 */     // No operand predicates
     /*  983399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983412 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  983412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983437 */     GIR_RootConstrainSelectedInstOperands,
     /*  983438 */     // GIR_Coverage, 9362,
     /*  983438 */     GIR_EraseRootFromParent_Done,
     /*  983439 */   // Label 14700: @983439
     /*  983439 */   GIM_Try, /*On fail goto*//*Label 14701*/ GIMT_Encode4(983534), // Rule ID 9363 //
     /*  983444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  983461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983494 */     // MIs[1] Operand 1
     /*  983494 */     // No operand predicates
     /*  983494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983507 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983532 */     GIR_RootConstrainSelectedInstOperands,
     /*  983533 */     // GIR_Coverage, 9363,
     /*  983533 */     GIR_EraseRootFromParent_Done,
     /*  983534 */   // Label 14701: @983534
     /*  983534 */   GIM_Try, /*On fail goto*//*Label 14702*/ GIMT_Encode4(983629), // Rule ID 9366 //
     /*  983539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  983556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983589 */     // MIs[1] Operand 1
     /*  983589 */     // No operand predicates
     /*  983589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983602 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  983602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983627 */     GIR_RootConstrainSelectedInstOperands,
     /*  983628 */     // GIR_Coverage, 9366,
     /*  983628 */     GIR_EraseRootFromParent_Done,
     /*  983629 */   // Label 14702: @983629
     /*  983629 */   GIM_Try, /*On fail goto*//*Label 14703*/ GIMT_Encode4(983724), // Rule ID 9367 //
     /*  983634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  983651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983684 */     // MIs[1] Operand 1
     /*  983684 */     // No operand predicates
     /*  983684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983697 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983722 */     GIR_RootConstrainSelectedInstOperands,
     /*  983723 */     // GIR_Coverage, 9367,
     /*  983723 */     GIR_EraseRootFromParent_Done,
     /*  983724 */   // Label 14703: @983724
     /*  983724 */   GIM_Try, /*On fail goto*//*Label 14704*/ GIMT_Encode4(983819), // Rule ID 9370 //
     /*  983729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  983740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  983743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  983746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  983752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983779 */     // MIs[1] Operand 1
     /*  983779 */     // No operand predicates
     /*  983779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983792 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  983792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983817 */     GIR_RootConstrainSelectedInstOperands,
     /*  983818 */     // GIR_Coverage, 9370,
     /*  983818 */     GIR_EraseRootFromParent_Done,
     /*  983819 */   // Label 14704: @983819
     /*  983819 */   GIM_Try, /*On fail goto*//*Label 14705*/ GIMT_Encode4(983914), // Rule ID 9371 //
     /*  983824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  983835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  983838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  983841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  983847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983874 */     // MIs[1] Operand 1
     /*  983874 */     // No operand predicates
     /*  983874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983887 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983912 */     GIR_RootConstrainSelectedInstOperands,
     /*  983913 */     // GIR_Coverage, 9371,
     /*  983913 */     GIR_EraseRootFromParent_Done,
     /*  983914 */   // Label 14705: @983914
     /*  983914 */   GIM_Try, /*On fail goto*//*Label 14706*/ GIMT_Encode4(984009), // Rule ID 9374 //
     /*  983919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  983936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983969 */     // MIs[1] Operand 1
     /*  983969 */     // No operand predicates
     /*  983969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983982 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984007 */     GIR_RootConstrainSelectedInstOperands,
     /*  984008 */     // GIR_Coverage, 9374,
     /*  984008 */     GIR_EraseRootFromParent_Done,
     /*  984009 */   // Label 14706: @984009
     /*  984009 */   GIM_Try, /*On fail goto*//*Label 14707*/ GIMT_Encode4(984104), // Rule ID 9375 //
     /*  984014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  984031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  984052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984064 */     // MIs[1] Operand 1
     /*  984064 */     // No operand predicates
     /*  984064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984077 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  984077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  984080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984102 */     GIR_RootConstrainSelectedInstOperands,
     /*  984103 */     // GIR_Coverage, 9375,
     /*  984103 */     GIR_EraseRootFromParent_Done,
     /*  984104 */   // Label 14707: @984104
     /*  984104 */   GIM_Try, /*On fail goto*//*Label 14708*/ GIMT_Encode4(984199), // Rule ID 9378 //
     /*  984109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  984126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984159 */     // MIs[1] Operand 1
     /*  984159 */     // No operand predicates
     /*  984159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984172 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  984172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  984175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984197 */     GIR_RootConstrainSelectedInstOperands,
     /*  984198 */     // GIR_Coverage, 9378,
     /*  984198 */     GIR_EraseRootFromParent_Done,
     /*  984199 */   // Label 14708: @984199
     /*  984199 */   GIM_Try, /*On fail goto*//*Label 14709*/ GIMT_Encode4(984294), // Rule ID 9379 //
     /*  984204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  984221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984254 */     // MIs[1] Operand 1
     /*  984254 */     // No operand predicates
     /*  984254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984267 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  984267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  984270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984292 */     GIR_RootConstrainSelectedInstOperands,
     /*  984293 */     // GIR_Coverage, 9379,
     /*  984293 */     GIR_EraseRootFromParent_Done,
     /*  984294 */   // Label 14709: @984294
     /*  984294 */   GIM_Try, /*On fail goto*//*Label 14710*/ GIMT_Encode4(984389), // Rule ID 9382 //
     /*  984299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  984310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  984313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  984316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  984322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984349 */     // MIs[1] Operand 1
     /*  984349 */     // No operand predicates
     /*  984349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984362 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  984362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  984365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984387 */     GIR_RootConstrainSelectedInstOperands,
     /*  984388 */     // GIR_Coverage, 9382,
     /*  984388 */     GIR_EraseRootFromParent_Done,
     /*  984389 */   // Label 14710: @984389
     /*  984389 */   GIM_Try, /*On fail goto*//*Label 14711*/ GIMT_Encode4(984484), // Rule ID 9383 //
     /*  984394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  984405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  984408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  984411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  984417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984444 */     // MIs[1] Operand 1
     /*  984444 */     // No operand predicates
     /*  984444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984457 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  984457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  984460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984482 */     GIR_RootConstrainSelectedInstOperands,
     /*  984483 */     // GIR_Coverage, 9383,
     /*  984483 */     GIR_EraseRootFromParent_Done,
     /*  984484 */   // Label 14711: @984484
     /*  984484 */   GIM_Try, /*On fail goto*//*Label 14712*/ GIMT_Encode4(984579), // Rule ID 9386 //
     /*  984489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  984506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  984527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984539 */     // MIs[1] Operand 1
     /*  984539 */     // No operand predicates
     /*  984539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984552 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  984555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984577 */     GIR_RootConstrainSelectedInstOperands,
     /*  984578 */     // GIR_Coverage, 9386,
     /*  984578 */     GIR_EraseRootFromParent_Done,
     /*  984579 */   // Label 14712: @984579
     /*  984579 */   GIM_Try, /*On fail goto*//*Label 14713*/ GIMT_Encode4(984674), // Rule ID 9387 //
     /*  984584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  984601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  984622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984634 */     // MIs[1] Operand 1
     /*  984634 */     // No operand predicates
     /*  984634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984647 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  984650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984672 */     GIR_RootConstrainSelectedInstOperands,
     /*  984673 */     // GIR_Coverage, 9387,
     /*  984673 */     GIR_EraseRootFromParent_Done,
     /*  984674 */   // Label 14713: @984674
     /*  984674 */   GIM_Try, /*On fail goto*//*Label 14714*/ GIMT_Encode4(984769), // Rule ID 9390 //
     /*  984679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  984696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984729 */     // MIs[1] Operand 1
     /*  984729 */     // No operand predicates
     /*  984729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984742 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  984745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984767 */     GIR_RootConstrainSelectedInstOperands,
     /*  984768 */     // GIR_Coverage, 9390,
     /*  984768 */     GIR_EraseRootFromParent_Done,
     /*  984769 */   // Label 14714: @984769
     /*  984769 */   GIM_Try, /*On fail goto*//*Label 14715*/ GIMT_Encode4(984864), // Rule ID 9391 //
     /*  984774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  984791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984824 */     // MIs[1] Operand 1
     /*  984824 */     // No operand predicates
     /*  984824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984837 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  984840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984862 */     GIR_RootConstrainSelectedInstOperands,
     /*  984863 */     // GIR_Coverage, 9391,
     /*  984863 */     GIR_EraseRootFromParent_Done,
     /*  984864 */   // Label 14715: @984864
     /*  984864 */   GIM_Try, /*On fail goto*//*Label 14716*/ GIMT_Encode4(984959), // Rule ID 9394 //
     /*  984869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  984886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984919 */     // MIs[1] Operand 1
     /*  984919 */     // No operand predicates
     /*  984919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984932 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  984935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984957 */     GIR_RootConstrainSelectedInstOperands,
     /*  984958 */     // GIR_Coverage, 9394,
     /*  984958 */     GIR_EraseRootFromParent_Done,
     /*  984959 */   // Label 14716: @984959
     /*  984959 */   GIM_Try, /*On fail goto*//*Label 14717*/ GIMT_Encode4(985054), // Rule ID 9395 //
     /*  984964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  984981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  985002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985014 */     // MIs[1] Operand 1
     /*  985014 */     // No operand predicates
     /*  985014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985027 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  985027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  985030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  985049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985052 */     GIR_RootConstrainSelectedInstOperands,
     /*  985053 */     // GIR_Coverage, 9395,
     /*  985053 */     GIR_EraseRootFromParent_Done,
     /*  985054 */   // Label 14717: @985054
     /*  985054 */   GIM_Try, /*On fail goto*//*Label 14718*/ GIMT_Encode4(985149), // Rule ID 9486 //
     /*  985059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  985076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985109 */     // MIs[1] Operand 1
     /*  985109 */     // No operand predicates
     /*  985109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985122 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  985125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985147 */     GIR_RootConstrainSelectedInstOperands,
     /*  985148 */     // GIR_Coverage, 9486,
     /*  985148 */     GIR_EraseRootFromParent_Done,
     /*  985149 */   // Label 14718: @985149
     /*  985149 */   GIM_Try, /*On fail goto*//*Label 14719*/ GIMT_Encode4(985244), // Rule ID 9487 //
     /*  985154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  985171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985204 */     // MIs[1] Operand 1
     /*  985204 */     // No operand predicates
     /*  985204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985217 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  985220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985242 */     GIR_RootConstrainSelectedInstOperands,
     /*  985243 */     // GIR_Coverage, 9487,
     /*  985243 */     GIR_EraseRootFromParent_Done,
     /*  985244 */   // Label 14719: @985244
     /*  985244 */   GIM_Try, /*On fail goto*//*Label 14720*/ GIMT_Encode4(985339), // Rule ID 9490 //
     /*  985249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  985266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985299 */     // MIs[1] Operand 1
     /*  985299 */     // No operand predicates
     /*  985299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985312 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  985315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985337 */     GIR_RootConstrainSelectedInstOperands,
     /*  985338 */     // GIR_Coverage, 9490,
     /*  985338 */     GIR_EraseRootFromParent_Done,
     /*  985339 */   // Label 14720: @985339
     /*  985339 */   GIM_Try, /*On fail goto*//*Label 14721*/ GIMT_Encode4(985434), // Rule ID 9491 //
     /*  985344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  985361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985394 */     // MIs[1] Operand 1
     /*  985394 */     // No operand predicates
     /*  985394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985407 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  985410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985432 */     GIR_RootConstrainSelectedInstOperands,
     /*  985433 */     // GIR_Coverage, 9491,
     /*  985433 */     GIR_EraseRootFromParent_Done,
     /*  985434 */   // Label 14721: @985434
     /*  985434 */   GIM_Try, /*On fail goto*//*Label 14722*/ GIMT_Encode4(985529), // Rule ID 9494 //
     /*  985439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  985456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985489 */     // MIs[1] Operand 1
     /*  985489 */     // No operand predicates
     /*  985489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985502 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985527 */     GIR_RootConstrainSelectedInstOperands,
     /*  985528 */     // GIR_Coverage, 9494,
     /*  985528 */     GIR_EraseRootFromParent_Done,
     /*  985529 */   // Label 14722: @985529
     /*  985529 */   GIM_Try, /*On fail goto*//*Label 14723*/ GIMT_Encode4(985624), // Rule ID 9495 //
     /*  985534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  985551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985584 */     // MIs[1] Operand 1
     /*  985584 */     // No operand predicates
     /*  985584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985597 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985622 */     GIR_RootConstrainSelectedInstOperands,
     /*  985623 */     // GIR_Coverage, 9495,
     /*  985623 */     GIR_EraseRootFromParent_Done,
     /*  985624 */   // Label 14723: @985624
     /*  985624 */   GIM_Try, /*On fail goto*//*Label 14724*/ GIMT_Encode4(985719), // Rule ID 9498 //
     /*  985629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  985646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985679 */     // MIs[1] Operand 1
     /*  985679 */     // No operand predicates
     /*  985679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985692 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  985695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985717 */     GIR_RootConstrainSelectedInstOperands,
     /*  985718 */     // GIR_Coverage, 9498,
     /*  985718 */     GIR_EraseRootFromParent_Done,
     /*  985719 */   // Label 14724: @985719
     /*  985719 */   GIM_Try, /*On fail goto*//*Label 14725*/ GIMT_Encode4(985814), // Rule ID 9499 //
     /*  985724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  985741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985774 */     // MIs[1] Operand 1
     /*  985774 */     // No operand predicates
     /*  985774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985787 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  985790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985812 */     GIR_RootConstrainSelectedInstOperands,
     /*  985813 */     // GIR_Coverage, 9499,
     /*  985813 */     GIR_EraseRootFromParent_Done,
     /*  985814 */   // Label 14725: @985814
     /*  985814 */   GIM_Try, /*On fail goto*//*Label 14726*/ GIMT_Encode4(985909), // Rule ID 9502 //
     /*  985819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  985836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985869 */     // MIs[1] Operand 1
     /*  985869 */     // No operand predicates
     /*  985869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985882 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985907 */     GIR_RootConstrainSelectedInstOperands,
     /*  985908 */     // GIR_Coverage, 9502,
     /*  985908 */     GIR_EraseRootFromParent_Done,
     /*  985909 */   // Label 14726: @985909
     /*  985909 */   GIM_Try, /*On fail goto*//*Label 14727*/ GIMT_Encode4(986004), // Rule ID 9503 //
     /*  985914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  985931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985964 */     // MIs[1] Operand 1
     /*  985964 */     // No operand predicates
     /*  985964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985977 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986002 */     GIR_RootConstrainSelectedInstOperands,
     /*  986003 */     // GIR_Coverage, 9503,
     /*  986003 */     GIR_EraseRootFromParent_Done,
     /*  986004 */   // Label 14727: @986004
     /*  986004 */   GIM_Try, /*On fail goto*//*Label 14728*/ GIMT_Encode4(986099), // Rule ID 9506 //
     /*  986009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  986026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986059 */     // MIs[1] Operand 1
     /*  986059 */     // No operand predicates
     /*  986059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986072 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  986072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  986075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986097 */     GIR_RootConstrainSelectedInstOperands,
     /*  986098 */     // GIR_Coverage, 9506,
     /*  986098 */     GIR_EraseRootFromParent_Done,
     /*  986099 */   // Label 14728: @986099
     /*  986099 */   GIM_Try, /*On fail goto*//*Label 14729*/ GIMT_Encode4(986194), // Rule ID 9507 //
     /*  986104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  986121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986154 */     // MIs[1] Operand 1
     /*  986154 */     // No operand predicates
     /*  986154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986167 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  986167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  986170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986192 */     GIR_RootConstrainSelectedInstOperands,
     /*  986193 */     // GIR_Coverage, 9507,
     /*  986193 */     GIR_EraseRootFromParent_Done,
     /*  986194 */   // Label 14729: @986194
     /*  986194 */   GIM_Try, /*On fail goto*//*Label 14730*/ GIMT_Encode4(986289), // Rule ID 9510 //
     /*  986199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  986210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  986213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  986216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  986222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986249 */     // MIs[1] Operand 1
     /*  986249 */     // No operand predicates
     /*  986249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986262 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986287 */     GIR_RootConstrainSelectedInstOperands,
     /*  986288 */     // GIR_Coverage, 9510,
     /*  986288 */     GIR_EraseRootFromParent_Done,
     /*  986289 */   // Label 14730: @986289
     /*  986289 */   GIM_Try, /*On fail goto*//*Label 14731*/ GIMT_Encode4(986384), // Rule ID 9511 //
     /*  986294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  986305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  986308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  986311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  986317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986344 */     // MIs[1] Operand 1
     /*  986344 */     // No operand predicates
     /*  986344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986357 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986382 */     GIR_RootConstrainSelectedInstOperands,
     /*  986383 */     // GIR_Coverage, 9511,
     /*  986383 */     GIR_EraseRootFromParent_Done,
     /*  986384 */   // Label 14731: @986384
     /*  986384 */   GIM_Try, /*On fail goto*//*Label 14732*/ GIMT_Encode4(986479), // Rule ID 9514 //
     /*  986389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  986400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  986403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  986406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  986412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986439 */     // MIs[1] Operand 1
     /*  986439 */     // No operand predicates
     /*  986439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986452 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  986452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986477 */     GIR_RootConstrainSelectedInstOperands,
     /*  986478 */     // GIR_Coverage, 9514,
     /*  986478 */     GIR_EraseRootFromParent_Done,
     /*  986479 */   // Label 14732: @986479
     /*  986479 */   GIM_Try, /*On fail goto*//*Label 14733*/ GIMT_Encode4(986574), // Rule ID 9515 //
     /*  986484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  986495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  986498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  986501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  986507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986534 */     // MIs[1] Operand 1
     /*  986534 */     // No operand predicates
     /*  986534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986547 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  986547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986572 */     GIR_RootConstrainSelectedInstOperands,
     /*  986573 */     // GIR_Coverage, 9515,
     /*  986573 */     GIR_EraseRootFromParent_Done,
     /*  986574 */   // Label 14733: @986574
     /*  986574 */   GIM_Try, /*On fail goto*//*Label 14734*/ GIMT_Encode4(986669), // Rule ID 9518 //
     /*  986579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  986590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  986593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  986596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  986602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986629 */     // MIs[1] Operand 1
     /*  986629 */     // No operand predicates
     /*  986629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986642 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  986642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986667 */     GIR_RootConstrainSelectedInstOperands,
     /*  986668 */     // GIR_Coverage, 9518,
     /*  986668 */     GIR_EraseRootFromParent_Done,
     /*  986669 */   // Label 14734: @986669
     /*  986669 */   GIM_Try, /*On fail goto*//*Label 14735*/ GIMT_Encode4(986764), // Rule ID 9519 //
     /*  986674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  986685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  986688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  986691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  986697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986724 */     // MIs[1] Operand 1
     /*  986724 */     // No operand predicates
     /*  986724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986737 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  986737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986762 */     GIR_RootConstrainSelectedInstOperands,
     /*  986763 */     // GIR_Coverage, 9519,
     /*  986763 */     GIR_EraseRootFromParent_Done,
     /*  986764 */   // Label 14735: @986764
     /*  986764 */   GIM_Try, /*On fail goto*//*Label 14736*/ GIMT_Encode4(986859), // Rule ID 9522 //
     /*  986769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  986772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  986786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986819 */     // MIs[1] Operand 1
     /*  986819 */     // No operand predicates
     /*  986819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986832 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  986832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986857 */     GIR_RootConstrainSelectedInstOperands,
     /*  986858 */     // GIR_Coverage, 9522,
     /*  986858 */     GIR_EraseRootFromParent_Done,
     /*  986859 */   // Label 14736: @986859
     /*  986859 */   GIM_Try, /*On fail goto*//*Label 14737*/ GIMT_Encode4(986954), // Rule ID 9523 //
     /*  986864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  986867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  986881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986914 */     // MIs[1] Operand 1
     /*  986914 */     // No operand predicates
     /*  986914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986927 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  986927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986952 */     GIR_RootConstrainSelectedInstOperands,
     /*  986953 */     // GIR_Coverage, 9523,
     /*  986953 */     GIR_EraseRootFromParent_Done,
     /*  986954 */   // Label 14737: @986954
     /*  986954 */   GIM_Try, /*On fail goto*//*Label 14738*/ GIMT_Encode4(987049), // Rule ID 9526 //
     /*  986959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  986976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987009 */     // MIs[1] Operand 1
     /*  987009 */     // No operand predicates
     /*  987009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987022 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  987022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987047 */     GIR_RootConstrainSelectedInstOperands,
     /*  987048 */     // GIR_Coverage, 9526,
     /*  987048 */     GIR_EraseRootFromParent_Done,
     /*  987049 */   // Label 14738: @987049
     /*  987049 */   GIM_Try, /*On fail goto*//*Label 14739*/ GIMT_Encode4(987144), // Rule ID 9527 //
     /*  987054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  987071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987104 */     // MIs[1] Operand 1
     /*  987104 */     // No operand predicates
     /*  987104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987117 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  987117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987142 */     GIR_RootConstrainSelectedInstOperands,
     /*  987143 */     // GIR_Coverage, 9527,
     /*  987143 */     GIR_EraseRootFromParent_Done,
     /*  987144 */   // Label 14739: @987144
     /*  987144 */   GIM_Try, /*On fail goto*//*Label 14740*/ GIMT_Encode4(987239), // Rule ID 9530 //
     /*  987149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  987166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987199 */     // MIs[1] Operand 1
     /*  987199 */     // No operand predicates
     /*  987199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987212 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  987212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987237 */     GIR_RootConstrainSelectedInstOperands,
     /*  987238 */     // GIR_Coverage, 9530,
     /*  987238 */     GIR_EraseRootFromParent_Done,
     /*  987239 */   // Label 14740: @987239
     /*  987239 */   GIM_Try, /*On fail goto*//*Label 14741*/ GIMT_Encode4(987334), // Rule ID 9531 //
     /*  987244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  987261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987294 */     // MIs[1] Operand 1
     /*  987294 */     // No operand predicates
     /*  987294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987307 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  987307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987332 */     GIR_RootConstrainSelectedInstOperands,
     /*  987333 */     // GIR_Coverage, 9531,
     /*  987333 */     GIR_EraseRootFromParent_Done,
     /*  987334 */   // Label 14741: @987334
     /*  987334 */   GIM_Try, /*On fail goto*//*Label 14742*/ GIMT_Encode4(987429), // Rule ID 9534 //
     /*  987339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  987350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  987353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  987356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  987362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987389 */     // MIs[1] Operand 1
     /*  987389 */     // No operand predicates
     /*  987389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987402 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  987402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987427 */     GIR_RootConstrainSelectedInstOperands,
     /*  987428 */     // GIR_Coverage, 9534,
     /*  987428 */     GIR_EraseRootFromParent_Done,
     /*  987429 */   // Label 14742: @987429
     /*  987429 */   GIM_Try, /*On fail goto*//*Label 14743*/ GIMT_Encode4(987524), // Rule ID 9535 //
     /*  987434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  987445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  987448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  987451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  987457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987484 */     // MIs[1] Operand 1
     /*  987484 */     // No operand predicates
     /*  987484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987497 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  987497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987522 */     GIR_RootConstrainSelectedInstOperands,
     /*  987523 */     // GIR_Coverage, 9535,
     /*  987523 */     GIR_EraseRootFromParent_Done,
     /*  987524 */   // Label 14743: @987524
     /*  987524 */   GIM_Try, /*On fail goto*//*Label 14744*/ GIMT_Encode4(987619), // Rule ID 9538 //
     /*  987529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  987546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987579 */     // MIs[1] Operand 1
     /*  987579 */     // No operand predicates
     /*  987579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987592 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987617 */     GIR_RootConstrainSelectedInstOperands,
     /*  987618 */     // GIR_Coverage, 9538,
     /*  987618 */     GIR_EraseRootFromParent_Done,
     /*  987619 */   // Label 14744: @987619
     /*  987619 */   GIM_Try, /*On fail goto*//*Label 14745*/ GIMT_Encode4(987714), // Rule ID 9539 //
     /*  987624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  987641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987674 */     // MIs[1] Operand 1
     /*  987674 */     // No operand predicates
     /*  987674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987687 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987712 */     GIR_RootConstrainSelectedInstOperands,
     /*  987713 */     // GIR_Coverage, 9539,
     /*  987713 */     GIR_EraseRootFromParent_Done,
     /*  987714 */   // Label 14745: @987714
     /*  987714 */   GIM_Try, /*On fail goto*//*Label 14746*/ GIMT_Encode4(987809), // Rule ID 9542 //
     /*  987719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  987736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987769 */     // MIs[1] Operand 1
     /*  987769 */     // No operand predicates
     /*  987769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987782 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987807 */     GIR_RootConstrainSelectedInstOperands,
     /*  987808 */     // GIR_Coverage, 9542,
     /*  987808 */     GIR_EraseRootFromParent_Done,
     /*  987809 */   // Label 14746: @987809
     /*  987809 */   GIM_Try, /*On fail goto*//*Label 14747*/ GIMT_Encode4(987904), // Rule ID 9543 //
     /*  987814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  987831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987864 */     // MIs[1] Operand 1
     /*  987864 */     // No operand predicates
     /*  987864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987877 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987902 */     GIR_RootConstrainSelectedInstOperands,
     /*  987903 */     // GIR_Coverage, 9543,
     /*  987903 */     GIR_EraseRootFromParent_Done,
     /*  987904 */   // Label 14747: @987904
     /*  987904 */   GIM_Try, /*On fail goto*//*Label 14748*/ GIMT_Encode4(987999), // Rule ID 9546 //
     /*  987909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  987926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987959 */     // MIs[1] Operand 1
     /*  987959 */     // No operand predicates
     /*  987959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987972 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987997 */     GIR_RootConstrainSelectedInstOperands,
     /*  987998 */     // GIR_Coverage, 9546,
     /*  987998 */     GIR_EraseRootFromParent_Done,
     /*  987999 */   // Label 14748: @987999
     /*  987999 */   GIM_Try, /*On fail goto*//*Label 14749*/ GIMT_Encode4(988094), // Rule ID 9547 //
     /*  988004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  988015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  988018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  988021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  988027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988054 */     // MIs[1] Operand 1
     /*  988054 */     // No operand predicates
     /*  988054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988067 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  988067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  988089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988092 */     GIR_RootConstrainSelectedInstOperands,
     /*  988093 */     // GIR_Coverage, 9547,
     /*  988093 */     GIR_EraseRootFromParent_Done,
     /*  988094 */   // Label 14749: @988094
     /*  988094 */   GIM_Try, /*On fail goto*//*Label 14750*/ GIMT_Encode4(988189), // Rule ID 9550 //
     /*  988099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  988116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988149 */     // MIs[1] Operand 1
     /*  988149 */     // No operand predicates
     /*  988149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988162 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  988162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  988165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988187 */     GIR_RootConstrainSelectedInstOperands,
     /*  988188 */     // GIR_Coverage, 9550,
     /*  988188 */     GIR_EraseRootFromParent_Done,
     /*  988189 */   // Label 14750: @988189
     /*  988189 */   GIM_Try, /*On fail goto*//*Label 14751*/ GIMT_Encode4(988284), // Rule ID 9551 //
     /*  988194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  988211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988244 */     // MIs[1] Operand 1
     /*  988244 */     // No operand predicates
     /*  988244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988257 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  988257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  988260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988282 */     GIR_RootConstrainSelectedInstOperands,
     /*  988283 */     // GIR_Coverage, 9551,
     /*  988283 */     GIR_EraseRootFromParent_Done,
     /*  988284 */   // Label 14751: @988284
     /*  988284 */   GIM_Try, /*On fail goto*//*Label 14752*/ GIMT_Encode4(988379), // Rule ID 9554 //
     /*  988289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  988306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988339 */     // MIs[1] Operand 1
     /*  988339 */     // No operand predicates
     /*  988339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988352 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  988352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  988355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988377 */     GIR_RootConstrainSelectedInstOperands,
     /*  988378 */     // GIR_Coverage, 9554,
     /*  988378 */     GIR_EraseRootFromParent_Done,
     /*  988379 */   // Label 14752: @988379
     /*  988379 */   GIM_Try, /*On fail goto*//*Label 14753*/ GIMT_Encode4(988474), // Rule ID 9555 //
     /*  988384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  988401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988434 */     // MIs[1] Operand 1
     /*  988434 */     // No operand predicates
     /*  988434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988447 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  988447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  988450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988472 */     GIR_RootConstrainSelectedInstOperands,
     /*  988473 */     // GIR_Coverage, 9555,
     /*  988473 */     GIR_EraseRootFromParent_Done,
     /*  988474 */   // Label 14753: @988474
     /*  988474 */   GIM_Try, /*On fail goto*//*Label 14754*/ GIMT_Encode4(988569), // Rule ID 9558 //
     /*  988479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  988490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  988493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  988496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  988502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988529 */     // MIs[1] Operand 1
     /*  988529 */     // No operand predicates
     /*  988529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988542 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  988542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988567 */     GIR_RootConstrainSelectedInstOperands,
     /*  988568 */     // GIR_Coverage, 9558,
     /*  988568 */     GIR_EraseRootFromParent_Done,
     /*  988569 */   // Label 14754: @988569
     /*  988569 */   GIM_Try, /*On fail goto*//*Label 14755*/ GIMT_Encode4(988664), // Rule ID 9559 //
     /*  988574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  988585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  988588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  988591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  988597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988624 */     // MIs[1] Operand 1
     /*  988624 */     // No operand predicates
     /*  988624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988637 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  988637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988662 */     GIR_RootConstrainSelectedInstOperands,
     /*  988663 */     // GIR_Coverage, 9559,
     /*  988663 */     GIR_EraseRootFromParent_Done,
     /*  988664 */   // Label 14755: @988664
     /*  988664 */   GIM_Try, /*On fail goto*//*Label 14756*/ GIMT_Encode4(988759), // Rule ID 9562 //
     /*  988669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  988680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  988683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  988686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988719 */     // MIs[1] Operand 1
     /*  988719 */     // No operand predicates
     /*  988719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988732 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  988735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988757 */     GIR_RootConstrainSelectedInstOperands,
     /*  988758 */     // GIR_Coverage, 9562,
     /*  988758 */     GIR_EraseRootFromParent_Done,
     /*  988759 */   // Label 14756: @988759
     /*  988759 */   GIM_Try, /*On fail goto*//*Label 14757*/ GIMT_Encode4(988854), // Rule ID 9563 //
     /*  988764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  988775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  988778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  988781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988814 */     // MIs[1] Operand 1
     /*  988814 */     // No operand predicates
     /*  988814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988827 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  988830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988852 */     GIR_RootConstrainSelectedInstOperands,
     /*  988853 */     // GIR_Coverage, 9563,
     /*  988853 */     GIR_EraseRootFromParent_Done,
     /*  988854 */   // Label 14757: @988854
     /*  988854 */   GIM_Try, /*On fail goto*//*Label 14758*/ GIMT_Encode4(988949), // Rule ID 9566 //
     /*  988859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  988876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988909 */     // MIs[1] Operand 1
     /*  988909 */     // No operand predicates
     /*  988909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988922 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  988925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988947 */     GIR_RootConstrainSelectedInstOperands,
     /*  988948 */     // GIR_Coverage, 9566,
     /*  988948 */     GIR_EraseRootFromParent_Done,
     /*  988949 */   // Label 14758: @988949
     /*  988949 */   GIM_Try, /*On fail goto*//*Label 14759*/ GIMT_Encode4(989044), // Rule ID 9567 //
     /*  988954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  988971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989004 */     // MIs[1] Operand 1
     /*  989004 */     // No operand predicates
     /*  989004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989017 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  989017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  989020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989042 */     GIR_RootConstrainSelectedInstOperands,
     /*  989043 */     // GIR_Coverage, 9567,
     /*  989043 */     GIR_EraseRootFromParent_Done,
     /*  989044 */   // Label 14759: @989044
     /*  989044 */   GIM_Try, /*On fail goto*//*Label 14760*/ GIMT_Encode4(989139), // Rule ID 9570 //
     /*  989049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  989052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  989060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  989063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  989066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989099 */     // MIs[1] Operand 1
     /*  989099 */     // No operand predicates
     /*  989099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989112 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  989112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  989115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989137 */     GIR_RootConstrainSelectedInstOperands,
     /*  989138 */     // GIR_Coverage, 9570,
     /*  989138 */     GIR_EraseRootFromParent_Done,
     /*  989139 */   // Label 14760: @989139
     /*  989139 */   GIM_Try, /*On fail goto*//*Label 14761*/ GIMT_Encode4(989234), // Rule ID 9571 //
     /*  989144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  989147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  989155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  989158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  989161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989194 */     // MIs[1] Operand 1
     /*  989194 */     // No operand predicates
     /*  989194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989207 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  989207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  989210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989232 */     GIR_RootConstrainSelectedInstOperands,
     /*  989233 */     // GIR_Coverage, 9571,
     /*  989233 */     GIR_EraseRootFromParent_Done,
     /*  989234 */   // Label 14761: @989234
     /*  989234 */   GIM_Try, /*On fail goto*//*Label 14762*/ GIMT_Encode4(989326), // Rule ID 13948 //
     /*  989239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  989250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  989253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  989256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989289 */     // MIs[1] Operand 1
     /*  989289 */     // No operand predicates
     /*  989289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989302 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  989305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989324 */     GIR_RootConstrainSelectedInstOperands,
     /*  989325 */     // GIR_Coverage, 13948,
     /*  989325 */     GIR_EraseRootFromParent_Done,
     /*  989326 */   // Label 14762: @989326
     /*  989326 */   GIM_Try, /*On fail goto*//*Label 14763*/ GIMT_Encode4(989418), // Rule ID 13949 //
     /*  989331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  989342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  989345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  989348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989381 */     // MIs[1] Operand 1
     /*  989381 */     // No operand predicates
     /*  989381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989394 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  989394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  989397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989416 */     GIR_RootConstrainSelectedInstOperands,
     /*  989417 */     // GIR_Coverage, 13949,
     /*  989417 */     GIR_EraseRootFromParent_Done,
     /*  989418 */   // Label 14763: @989418
     /*  989418 */   GIM_Try, /*On fail goto*//*Label 14764*/ GIMT_Encode4(989510), // Rule ID 13950 //
     /*  989423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  989434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  989437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  989440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989473 */     // MIs[1] Operand 1
     /*  989473 */     // No operand predicates
     /*  989473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989486 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989508 */     GIR_RootConstrainSelectedInstOperands,
     /*  989509 */     // GIR_Coverage, 13950,
     /*  989509 */     GIR_EraseRootFromParent_Done,
     /*  989510 */   // Label 14764: @989510
     /*  989510 */   GIM_Try, /*On fail goto*//*Label 14765*/ GIMT_Encode4(989602), // Rule ID 13951 //
     /*  989515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  989526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  989529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  989532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989565 */     // MIs[1] Operand 1
     /*  989565 */     // No operand predicates
     /*  989565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989578 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  989578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989600 */     GIR_RootConstrainSelectedInstOperands,
     /*  989601 */     // GIR_Coverage, 13951,
     /*  989601 */     GIR_EraseRootFromParent_Done,
     /*  989602 */   // Label 14765: @989602
     /*  989602 */   GIM_Try, /*On fail goto*//*Label 14766*/ GIMT_Encode4(989694), // Rule ID 13952 //
     /*  989607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  989618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  989621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  989624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989657 */     // MIs[1] Operand 1
     /*  989657 */     // No operand predicates
     /*  989657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989670 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989692 */     GIR_RootConstrainSelectedInstOperands,
     /*  989693 */     // GIR_Coverage, 13952,
     /*  989693 */     GIR_EraseRootFromParent_Done,
     /*  989694 */   // Label 14766: @989694
     /*  989694 */   GIM_Try, /*On fail goto*//*Label 14767*/ GIMT_Encode4(989786), // Rule ID 13953 //
     /*  989699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  989710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  989713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  989716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989749 */     // MIs[1] Operand 1
     /*  989749 */     // No operand predicates
     /*  989749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989762 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  989762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989784 */     GIR_RootConstrainSelectedInstOperands,
     /*  989785 */     // GIR_Coverage, 13953,
     /*  989785 */     GIR_EraseRootFromParent_Done,
     /*  989786 */   // Label 14767: @989786
     /*  989786 */   GIM_Try, /*On fail goto*//*Label 14768*/ GIMT_Encode4(989878), // Rule ID 13954 //
     /*  989791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  989802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  989805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989841 */     // MIs[1] Operand 1
     /*  989841 */     // No operand predicates
     /*  989841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989854 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  989854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989876 */     GIR_RootConstrainSelectedInstOperands,
     /*  989877 */     // GIR_Coverage, 13954,
     /*  989877 */     GIR_EraseRootFromParent_Done,
     /*  989878 */   // Label 14768: @989878
     /*  989878 */   GIM_Try, /*On fail goto*//*Label 14769*/ GIMT_Encode4(989970), // Rule ID 13955 //
     /*  989883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  989894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  989897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989933 */     // MIs[1] Operand 1
     /*  989933 */     // No operand predicates
     /*  989933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  989946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989968 */     GIR_RootConstrainSelectedInstOperands,
     /*  989969 */     // GIR_Coverage, 13955,
     /*  989969 */     GIR_EraseRootFromParent_Done,
     /*  989970 */   // Label 14769: @989970
     /*  989970 */   GIM_Try, /*On fail goto*//*Label 14770*/ GIMT_Encode4(990062), // Rule ID 13956 //
     /*  989975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  989986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  989989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990025 */     // MIs[1] Operand 1
     /*  990025 */     // No operand predicates
     /*  990025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990038 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  990038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  990041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990060 */     GIR_RootConstrainSelectedInstOperands,
     /*  990061 */     // GIR_Coverage, 13956,
     /*  990061 */     GIR_EraseRootFromParent_Done,
     /*  990062 */   // Label 14770: @990062
     /*  990062 */   GIM_Try, /*On fail goto*//*Label 14771*/ GIMT_Encode4(990154), // Rule ID 13957 //
     /*  990067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  990078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  990081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  990084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  990090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990117 */     // MIs[1] Operand 1
     /*  990117 */     // No operand predicates
     /*  990117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990130 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  990130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  990133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990152 */     GIR_RootConstrainSelectedInstOperands,
     /*  990153 */     // GIR_Coverage, 13957,
     /*  990153 */     GIR_EraseRootFromParent_Done,
     /*  990154 */   // Label 14771: @990154
     /*  990154 */   GIM_Try, /*On fail goto*//*Label 14772*/ GIMT_Encode4(990246), // Rule ID 13958 //
     /*  990159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  990170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  990173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  990176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990209 */     // MIs[1] Operand 1
     /*  990209 */     // No operand predicates
     /*  990209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990222 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  990222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  990225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990244 */     GIR_RootConstrainSelectedInstOperands,
     /*  990245 */     // GIR_Coverage, 13958,
     /*  990245 */     GIR_EraseRootFromParent_Done,
     /*  990246 */   // Label 14772: @990246
     /*  990246 */   GIM_Try, /*On fail goto*//*Label 14773*/ GIMT_Encode4(990338), // Rule ID 13959 //
     /*  990251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  990262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  990265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  990268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990301 */     // MIs[1] Operand 1
     /*  990301 */     // No operand predicates
     /*  990301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990314 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  990314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  990317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990336 */     GIR_RootConstrainSelectedInstOperands,
     /*  990337 */     // GIR_Coverage, 13959,
     /*  990337 */     GIR_EraseRootFromParent_Done,
     /*  990338 */   // Label 14773: @990338
     /*  990338 */   GIM_Try, /*On fail goto*//*Label 14774*/ GIMT_Encode4(990430), // Rule ID 13960 //
     /*  990343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  990354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  990357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  990360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  990366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990393 */     // MIs[1] Operand 1
     /*  990393 */     // No operand predicates
     /*  990393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990406 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  990406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990428 */     GIR_RootConstrainSelectedInstOperands,
     /*  990429 */     // GIR_Coverage, 13960,
     /*  990429 */     GIR_EraseRootFromParent_Done,
     /*  990430 */   // Label 14774: @990430
     /*  990430 */   GIM_Try, /*On fail goto*//*Label 14775*/ GIMT_Encode4(990522), // Rule ID 13961 //
     /*  990435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  990446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  990449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  990452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  990458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990485 */     // MIs[1] Operand 1
     /*  990485 */     // No operand predicates
     /*  990485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990498 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  990498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990520 */     GIR_RootConstrainSelectedInstOperands,
     /*  990521 */     // GIR_Coverage, 13961,
     /*  990521 */     GIR_EraseRootFromParent_Done,
     /*  990522 */   // Label 14775: @990522
     /*  990522 */   GIM_Try, /*On fail goto*//*Label 14776*/ GIMT_Encode4(990614), // Rule ID 13962 //
     /*  990527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  990538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  990541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  990544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  990550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990577 */     // MIs[1] Operand 1
     /*  990577 */     // No operand predicates
     /*  990577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  990590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990612 */     GIR_RootConstrainSelectedInstOperands,
     /*  990613 */     // GIR_Coverage, 13962,
     /*  990613 */     GIR_EraseRootFromParent_Done,
     /*  990614 */   // Label 14776: @990614
     /*  990614 */   GIM_Try, /*On fail goto*//*Label 14777*/ GIMT_Encode4(990706), // Rule ID 13963 //
     /*  990619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  990630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  990633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  990636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  990642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990669 */     // MIs[1] Operand 1
     /*  990669 */     // No operand predicates
     /*  990669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  990682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990704 */     GIR_RootConstrainSelectedInstOperands,
     /*  990705 */     // GIR_Coverage, 13963,
     /*  990705 */     GIR_EraseRootFromParent_Done,
     /*  990706 */   // Label 14777: @990706
     /*  990706 */   GIM_Try, /*On fail goto*//*Label 14778*/ GIMT_Encode4(990798), // Rule ID 13964 //
     /*  990711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  990722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  990725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  990728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  990734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990761 */     // MIs[1] Operand 1
     /*  990761 */     // No operand predicates
     /*  990761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  990774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990796 */     GIR_RootConstrainSelectedInstOperands,
     /*  990797 */     // GIR_Coverage, 13964,
     /*  990797 */     GIR_EraseRootFromParent_Done,
     /*  990798 */   // Label 14778: @990798
     /*  990798 */   GIM_Try, /*On fail goto*//*Label 14779*/ GIMT_Encode4(990890), // Rule ID 13965 //
     /*  990803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  990814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  990817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  990820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  990826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990853 */     // MIs[1] Operand 1
     /*  990853 */     // No operand predicates
     /*  990853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990866 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  990866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990888 */     GIR_RootConstrainSelectedInstOperands,
     /*  990889 */     // GIR_Coverage, 13965,
     /*  990889 */     GIR_EraseRootFromParent_Done,
     /*  990890 */   // Label 14779: @990890
     /*  990890 */   GIM_Try, /*On fail goto*//*Label 14780*/ GIMT_Encode4(990982), // Rule ID 13966 //
     /*  990895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  990898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  990906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  990909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990945 */     // MIs[1] Operand 1
     /*  990945 */     // No operand predicates
     /*  990945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  990958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990980 */     GIR_RootConstrainSelectedInstOperands,
     /*  990981 */     // GIR_Coverage, 13966,
     /*  990981 */     GIR_EraseRootFromParent_Done,
     /*  990982 */   // Label 14780: @990982
     /*  990982 */   GIM_Try, /*On fail goto*//*Label 14781*/ GIMT_Encode4(991074), // Rule ID 13967 //
     /*  990987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  990990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  990998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  991001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  991004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  991010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  991017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991037 */     // MIs[1] Operand 1
     /*  991037 */     // No operand predicates
     /*  991037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991050 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  991050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  991053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  991072 */     GIR_RootConstrainSelectedInstOperands,
     /*  991073 */     // GIR_Coverage, 13967,
     /*  991073 */     GIR_EraseRootFromParent_Done,
     /*  991074 */   // Label 14781: @991074
     /*  991074 */   GIM_Try, /*On fail goto*//*Label 14782*/ GIMT_Encode4(991166), // Rule ID 13968 //
     /*  991079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  991090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  991093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  991096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991129 */     // MIs[1] Operand 1
     /*  991129 */     // No operand predicates
     /*  991129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991142 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  991142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991164 */     GIR_RootConstrainSelectedInstOperands,
     /*  991165 */     // GIR_Coverage, 13968,
     /*  991165 */     GIR_EraseRootFromParent_Done,
     /*  991166 */   // Label 14782: @991166
     /*  991166 */   GIM_Try, /*On fail goto*//*Label 14783*/ GIMT_Encode4(991258), // Rule ID 13969 //
     /*  991171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  991182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  991185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  991188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991221 */     // MIs[1] Operand 1
     /*  991221 */     // No operand predicates
     /*  991221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991234 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  991234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991256 */     GIR_RootConstrainSelectedInstOperands,
     /*  991257 */     // GIR_Coverage, 13969,
     /*  991257 */     GIR_EraseRootFromParent_Done,
     /*  991258 */   // Label 14783: @991258
     /*  991258 */   GIM_Try, /*On fail goto*//*Label 14784*/ GIMT_Encode4(991350), // Rule ID 13970 //
     /*  991263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  991274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  991277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  991280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991313 */     // MIs[1] Operand 1
     /*  991313 */     // No operand predicates
     /*  991313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991326 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  991326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991348 */     GIR_RootConstrainSelectedInstOperands,
     /*  991349 */     // GIR_Coverage, 13970,
     /*  991349 */     GIR_EraseRootFromParent_Done,
     /*  991350 */   // Label 14784: @991350
     /*  991350 */   GIM_Try, /*On fail goto*//*Label 14785*/ GIMT_Encode4(991442), // Rule ID 13971 //
     /*  991355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  991366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  991369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  991372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991405 */     // MIs[1] Operand 1
     /*  991405 */     // No operand predicates
     /*  991405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991418 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  991418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991440 */     GIR_RootConstrainSelectedInstOperands,
     /*  991441 */     // GIR_Coverage, 13971,
     /*  991441 */     GIR_EraseRootFromParent_Done,
     /*  991442 */   // Label 14785: @991442
     /*  991442 */   GIM_Try, /*On fail goto*//*Label 14786*/ GIMT_Encode4(991534), // Rule ID 13972 //
     /*  991447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  991458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  991461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  991464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  991470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991497 */     // MIs[1] Operand 1
     /*  991497 */     // No operand predicates
     /*  991497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991510 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  991510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991532 */     GIR_RootConstrainSelectedInstOperands,
     /*  991533 */     // GIR_Coverage, 13972,
     /*  991533 */     GIR_EraseRootFromParent_Done,
     /*  991534 */   // Label 14786: @991534
     /*  991534 */   GIM_Try, /*On fail goto*//*Label 14787*/ GIMT_Encode4(991626), // Rule ID 13973 //
     /*  991539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  991550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  991553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  991556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  991562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991589 */     // MIs[1] Operand 1
     /*  991589 */     // No operand predicates
     /*  991589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991602 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  991602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991624 */     GIR_RootConstrainSelectedInstOperands,
     /*  991625 */     // GIR_Coverage, 13973,
     /*  991625 */     GIR_EraseRootFromParent_Done,
     /*  991626 */   // Label 14787: @991626
     /*  991626 */   GIM_Try, /*On fail goto*//*Label 14788*/ GIMT_Encode4(991718), // Rule ID 13974 //
     /*  991631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  991642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  991645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  991648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991681 */     // MIs[1] Operand 1
     /*  991681 */     // No operand predicates
     /*  991681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  991694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991716 */     GIR_RootConstrainSelectedInstOperands,
     /*  991717 */     // GIR_Coverage, 13974,
     /*  991717 */     GIR_EraseRootFromParent_Done,
     /*  991718 */   // Label 14788: @991718
     /*  991718 */   GIM_Try, /*On fail goto*//*Label 14789*/ GIMT_Encode4(991810), // Rule ID 13975 //
     /*  991723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  991734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  991737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  991740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991773 */     // MIs[1] Operand 1
     /*  991773 */     // No operand predicates
     /*  991773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991786 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  991786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991808 */     GIR_RootConstrainSelectedInstOperands,
     /*  991809 */     // GIR_Coverage, 13975,
     /*  991809 */     GIR_EraseRootFromParent_Done,
     /*  991810 */   // Label 14789: @991810
     /*  991810 */   GIM_Try, /*On fail goto*//*Label 14790*/ GIMT_Encode4(991902), // Rule ID 13976 //
     /*  991815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  991826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  991829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  991832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991865 */     // MIs[1] Operand 1
     /*  991865 */     // No operand predicates
     /*  991865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991878 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  991878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991900 */     GIR_RootConstrainSelectedInstOperands,
     /*  991901 */     // GIR_Coverage, 13976,
     /*  991901 */     GIR_EraseRootFromParent_Done,
     /*  991902 */   // Label 14790: @991902
     /*  991902 */   GIM_Try, /*On fail goto*//*Label 14791*/ GIMT_Encode4(991994), // Rule ID 13977 //
     /*  991907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  991918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  991921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  991924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991957 */     // MIs[1] Operand 1
     /*  991957 */     // No operand predicates
     /*  991957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991970 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  991970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991992 */     GIR_RootConstrainSelectedInstOperands,
     /*  991993 */     // GIR_Coverage, 13977,
     /*  991993 */     GIR_EraseRootFromParent_Done,
     /*  991994 */   // Label 14791: @991994
     /*  991994 */   GIM_Try, /*On fail goto*//*Label 14792*/ GIMT_Encode4(992086), // Rule ID 13978 //
     /*  991999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  992010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  992013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  992016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  992022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992049 */     // MIs[1] Operand 1
     /*  992049 */     // No operand predicates
     /*  992049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992062 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  992062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992084 */     GIR_RootConstrainSelectedInstOperands,
     /*  992085 */     // GIR_Coverage, 13978,
     /*  992085 */     GIR_EraseRootFromParent_Done,
     /*  992086 */   // Label 14792: @992086
     /*  992086 */   GIM_Try, /*On fail goto*//*Label 14793*/ GIMT_Encode4(992178), // Rule ID 13979 //
     /*  992091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  992102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  992105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  992108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  992114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992141 */     // MIs[1] Operand 1
     /*  992141 */     // No operand predicates
     /*  992141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992154 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  992154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992176 */     GIR_RootConstrainSelectedInstOperands,
     /*  992177 */     // GIR_Coverage, 13979,
     /*  992177 */     GIR_EraseRootFromParent_Done,
     /*  992178 */   // Label 14793: @992178
     /*  992178 */   GIM_Try, /*On fail goto*//*Label 14794*/ GIMT_Encode4(992270), // Rule ID 13980 //
     /*  992183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  992194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  992197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  992200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  992213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992233 */     // MIs[1] Operand 1
     /*  992233 */     // No operand predicates
     /*  992233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  992246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  992249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992268 */     GIR_RootConstrainSelectedInstOperands,
     /*  992269 */     // GIR_Coverage, 13980,
     /*  992269 */     GIR_EraseRootFromParent_Done,
     /*  992270 */   // Label 14794: @992270
     /*  992270 */   GIM_Try, /*On fail goto*//*Label 14795*/ GIMT_Encode4(992362), // Rule ID 13981 //
     /*  992275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  992286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  992289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  992292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  992305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992325 */     // MIs[1] Operand 1
     /*  992325 */     // No operand predicates
     /*  992325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  992338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  992341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992360 */     GIR_RootConstrainSelectedInstOperands,
     /*  992361 */     // GIR_Coverage, 13981,
     /*  992361 */     GIR_EraseRootFromParent_Done,
     /*  992362 */   // Label 14795: @992362
     /*  992362 */   GIM_Try, /*On fail goto*//*Label 14796*/ GIMT_Encode4(992454), // Rule ID 13982 //
     /*  992367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  992378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  992381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  992384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992417 */     // MIs[1] Operand 1
     /*  992417 */     // No operand predicates
     /*  992417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  992430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992452 */     GIR_RootConstrainSelectedInstOperands,
     /*  992453 */     // GIR_Coverage, 13982,
     /*  992453 */     GIR_EraseRootFromParent_Done,
     /*  992454 */   // Label 14796: @992454
     /*  992454 */   GIM_Try, /*On fail goto*//*Label 14797*/ GIMT_Encode4(992546), // Rule ID 13983 //
     /*  992459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  992470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  992473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  992476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992509 */     // MIs[1] Operand 1
     /*  992509 */     // No operand predicates
     /*  992509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992522 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  992522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992544 */     GIR_RootConstrainSelectedInstOperands,
     /*  992545 */     // GIR_Coverage, 13983,
     /*  992545 */     GIR_EraseRootFromParent_Done,
     /*  992546 */   // Label 14797: @992546
     /*  992546 */   GIM_Try, /*On fail goto*//*Label 14798*/ GIMT_Encode4(992638), // Rule ID 13984 //
     /*  992551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  992562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  992565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  992568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  992574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992601 */     // MIs[1] Operand 1
     /*  992601 */     // No operand predicates
     /*  992601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  992614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992636 */     GIR_RootConstrainSelectedInstOperands,
     /*  992637 */     // GIR_Coverage, 13984,
     /*  992637 */     GIR_EraseRootFromParent_Done,
     /*  992638 */   // Label 14798: @992638
     /*  992638 */   GIM_Try, /*On fail goto*//*Label 14799*/ GIMT_Encode4(992730), // Rule ID 13985 //
     /*  992643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  992654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  992657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  992660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  992666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992693 */     // MIs[1] Operand 1
     /*  992693 */     // No operand predicates
     /*  992693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992706 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  992706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992728 */     GIR_RootConstrainSelectedInstOperands,
     /*  992729 */     // GIR_Coverage, 13985,
     /*  992729 */     GIR_EraseRootFromParent_Done,
     /*  992730 */   // Label 14799: @992730
     /*  992730 */   GIM_Try, /*On fail goto*//*Label 14800*/ GIMT_Encode4(992822), // Rule ID 13986 //
     /*  992735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  992746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  992749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  992752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  992765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992785 */     // MIs[1] Operand 1
     /*  992785 */     // No operand predicates
     /*  992785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  992798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  992801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992820 */     GIR_RootConstrainSelectedInstOperands,
     /*  992821 */     // GIR_Coverage, 13986,
     /*  992821 */     GIR_EraseRootFromParent_Done,
     /*  992822 */   // Label 14800: @992822
     /*  992822 */   GIM_Try, /*On fail goto*//*Label 14801*/ GIMT_Encode4(992914), // Rule ID 13987 //
     /*  992827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  992838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  992841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  992844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  992857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992877 */     // MIs[1] Operand 1
     /*  992877 */     // No operand predicates
     /*  992877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992890 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  992890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  992893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992912 */     GIR_RootConstrainSelectedInstOperands,
     /*  992913 */     // GIR_Coverage, 13987,
     /*  992913 */     GIR_EraseRootFromParent_Done,
     /*  992914 */   // Label 14801: @992914
     /*  992914 */   GIM_Try, /*On fail goto*//*Label 14802*/ GIMT_Encode4(993006), // Rule ID 13988 //
     /*  992919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  992930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  992933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  992936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992969 */     // MIs[1] Operand 1
     /*  992969 */     // No operand predicates
     /*  992969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992982 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  992982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  993004 */     GIR_RootConstrainSelectedInstOperands,
     /*  993005 */     // GIR_Coverage, 13988,
     /*  993005 */     GIR_EraseRootFromParent_Done,
     /*  993006 */   // Label 14802: @993006
     /*  993006 */   GIM_Try, /*On fail goto*//*Label 14803*/ GIMT_Encode4(993098), // Rule ID 13989 //
     /*  993011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  993014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  993022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  993025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  993028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  993034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  993041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993061 */     // MIs[1] Operand 1
     /*  993061 */     // No operand predicates
     /*  993061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993074 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  993074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  993077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  993096 */     GIR_RootConstrainSelectedInstOperands,
     /*  993097 */     // GIR_Coverage, 13989,
     /*  993097 */     GIR_EraseRootFromParent_Done,
     /*  993098 */   // Label 14803: @993098
     /*  993098 */   GIM_Try, /*On fail goto*//*Label 14804*/ GIMT_Encode4(993190), // Rule ID 13990 //
     /*  993103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  993106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  993114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  993117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  993120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  993123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  993126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  993133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993153 */     // MIs[1] Operand 1
     /*  993153 */     // No operand predicates
     /*  993153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993166 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  993166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  993169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  993188 */     GIR_RootConstrainSelectedInstOperands,
     /*  993189 */     // GIR_Coverage, 13990,
     /*  993189 */     GIR_EraseRootFromParent_Done,
     /*  993190 */   // Label 14804: @993190
     /*  993190 */   GIM_Try, /*On fail goto*//*Label 14805*/ GIMT_Encode4(993282), // Rule ID 13991 //
     /*  993195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  993198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  993206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  993209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  993212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  993218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  993225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993245 */     // MIs[1] Operand 1
     /*  993245 */     // No operand predicates
     /*  993245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993258 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  993258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  993261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  993280 */     GIR_RootConstrainSelectedInstOperands,
     /*  993281 */     // GIR_Coverage, 13991,
     /*  993281 */     GIR_EraseRootFromParent_Done,
     /*  993282 */   // Label 14805: @993282
     /*  993282 */   GIM_Try, /*On fail goto*//*Label 14806*/ GIMT_Encode4(993358), // Rule ID 2778 //
     /*  993287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  993298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  993301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  993304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993315 */     // MIs[0] passthru
     /*  993315 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993324 */     // MIs[0] round
     /*  993324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993334 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  993337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993356 */     GIR_RootConstrainSelectedInstOperands,
     /*  993357 */     // GIR_Coverage, 2778,
     /*  993357 */     GIR_EraseRootFromParent_Done,
     /*  993358 */   // Label 14806: @993358
     /*  993358 */   GIM_Try, /*On fail goto*//*Label 14807*/ GIMT_Encode4(993434), // Rule ID 2779 //
     /*  993363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  993374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  993377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  993380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993391 */     // MIs[0] passthru
     /*  993391 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993400 */     // MIs[0] round
     /*  993400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993410 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  993413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993432 */     GIR_RootConstrainSelectedInstOperands,
     /*  993433 */     // GIR_Coverage, 2779,
     /*  993433 */     GIR_EraseRootFromParent_Done,
     /*  993434 */   // Label 14807: @993434
     /*  993434 */   GIM_Try, /*On fail goto*//*Label 14808*/ GIMT_Encode4(993510), // Rule ID 17158 //
     /*  993439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  993450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  993453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  993456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993467 */     // MIs[0] passthru
     /*  993467 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993476 */     // MIs[0] round
     /*  993476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993486 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  993489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993508 */     GIR_RootConstrainSelectedInstOperands,
     /*  993509 */     // GIR_Coverage, 17158,
     /*  993509 */     GIR_EraseRootFromParent_Done,
     /*  993510 */   // Label 14808: @993510
     /*  993510 */   GIM_Try, /*On fail goto*//*Label 14809*/ GIMT_Encode4(993586), // Rule ID 17159 //
     /*  993515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  993526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  993529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  993532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993543 */     // MIs[0] passthru
     /*  993543 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993552 */     // MIs[0] round
     /*  993552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993562 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  993565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993584 */     GIR_RootConstrainSelectedInstOperands,
     /*  993585 */     // GIR_Coverage, 17159,
     /*  993585 */     GIR_EraseRootFromParent_Done,
     /*  993586 */   // Label 14809: @993586
     /*  993586 */   GIM_Try, /*On fail goto*//*Label 14810*/ GIMT_Encode4(993662), // Rule ID 17168 //
     /*  993591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  993602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  993605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  993608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993619 */     // MIs[0] passthru
     /*  993619 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993628 */     // MIs[0] round
     /*  993628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993638 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  993641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993660 */     GIR_RootConstrainSelectedInstOperands,
     /*  993661 */     // GIR_Coverage, 17168,
     /*  993661 */     GIR_EraseRootFromParent_Done,
     /*  993662 */   // Label 14810: @993662
     /*  993662 */   GIM_Try, /*On fail goto*//*Label 14811*/ GIMT_Encode4(993738), // Rule ID 17169 //
     /*  993667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  993678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  993681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  993684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993695 */     // MIs[0] passthru
     /*  993695 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993704 */     // MIs[0] round
     /*  993704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993714 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  993717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993736 */     GIR_RootConstrainSelectedInstOperands,
     /*  993737 */     // GIR_Coverage, 17169,
     /*  993737 */     GIR_EraseRootFromParent_Done,
     /*  993738 */   // Label 14811: @993738
     /*  993738 */   GIM_Try, /*On fail goto*//*Label 14812*/ GIMT_Encode4(993814), // Rule ID 17178 //
     /*  993743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  993754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  993757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  993760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993771 */     // MIs[0] passthru
     /*  993771 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993780 */     // MIs[0] round
     /*  993780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993790 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  993793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993812 */     GIR_RootConstrainSelectedInstOperands,
     /*  993813 */     // GIR_Coverage, 17178,
     /*  993813 */     GIR_EraseRootFromParent_Done,
     /*  993814 */   // Label 14812: @993814
     /*  993814 */   GIM_Try, /*On fail goto*//*Label 14813*/ GIMT_Encode4(993890), // Rule ID 17179 //
     /*  993819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  993830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  993833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  993836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993847 */     // MIs[0] passthru
     /*  993847 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993856 */     // MIs[0] round
     /*  993856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993866 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  993869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993888 */     GIR_RootConstrainSelectedInstOperands,
     /*  993889 */     // GIR_Coverage, 17179,
     /*  993889 */     GIR_EraseRootFromParent_Done,
     /*  993890 */   // Label 14813: @993890
     /*  993890 */   GIM_Try, /*On fail goto*//*Label 14814*/ GIMT_Encode4(993966), // Rule ID 17188 //
     /*  993895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  993906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  993909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  993912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993923 */     // MIs[0] passthru
     /*  993923 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993932 */     // MIs[0] round
     /*  993932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993942 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  993945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993964 */     GIR_RootConstrainSelectedInstOperands,
     /*  993965 */     // GIR_Coverage, 17188,
     /*  993965 */     GIR_EraseRootFromParent_Done,
     /*  993966 */   // Label 14814: @993966
     /*  993966 */   GIM_Try, /*On fail goto*//*Label 14815*/ GIMT_Encode4(994042), // Rule ID 17189 //
     /*  993971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  993982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  993985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  993988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993999 */     // MIs[0] passthru
     /*  993999 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994008 */     // MIs[0] round
     /*  994008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994018 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  994021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994040 */     GIR_RootConstrainSelectedInstOperands,
     /*  994041 */     // GIR_Coverage, 17189,
     /*  994041 */     GIR_EraseRootFromParent_Done,
     /*  994042 */   // Label 14815: @994042
     /*  994042 */   GIM_Try, /*On fail goto*//*Label 14816*/ GIMT_Encode4(994118), // Rule ID 17198 //
     /*  994047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  994058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  994061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  994064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994075 */     // MIs[0] passthru
     /*  994075 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994084 */     // MIs[0] round
     /*  994084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994094 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  994097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994116 */     GIR_RootConstrainSelectedInstOperands,
     /*  994117 */     // GIR_Coverage, 17198,
     /*  994117 */     GIR_EraseRootFromParent_Done,
     /*  994118 */   // Label 14816: @994118
     /*  994118 */   GIM_Try, /*On fail goto*//*Label 14817*/ GIMT_Encode4(994194), // Rule ID 17199 //
     /*  994123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  994134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  994137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  994140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994151 */     // MIs[0] passthru
     /*  994151 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994160 */     // MIs[0] round
     /*  994160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994170 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  994173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994192 */     GIR_RootConstrainSelectedInstOperands,
     /*  994193 */     // GIR_Coverage, 17199,
     /*  994193 */     GIR_EraseRootFromParent_Done,
     /*  994194 */   // Label 14817: @994194
     /*  994194 */   GIM_Try, /*On fail goto*//*Label 14818*/ GIMT_Encode4(994270), // Rule ID 17208 //
     /*  994199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  994210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  994213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  994216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994227 */     // MIs[0] passthru
     /*  994227 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994236 */     // MIs[0] round
     /*  994236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994246 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  994249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994268 */     GIR_RootConstrainSelectedInstOperands,
     /*  994269 */     // GIR_Coverage, 17208,
     /*  994269 */     GIR_EraseRootFromParent_Done,
     /*  994270 */   // Label 14818: @994270
     /*  994270 */   GIM_Try, /*On fail goto*//*Label 14819*/ GIMT_Encode4(994346), // Rule ID 17209 //
     /*  994275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  994286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  994289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  994292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994303 */     // MIs[0] passthru
     /*  994303 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994312 */     // MIs[0] round
     /*  994312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994322 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  994325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994344 */     GIR_RootConstrainSelectedInstOperands,
     /*  994345 */     // GIR_Coverage, 17209,
     /*  994345 */     GIR_EraseRootFromParent_Done,
     /*  994346 */   // Label 14819: @994346
     /*  994346 */   GIM_Try, /*On fail goto*//*Label 14820*/ GIMT_Encode4(994422), // Rule ID 17218 //
     /*  994351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  994362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  994365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  994368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994379 */     // MIs[0] passthru
     /*  994379 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994388 */     // MIs[0] round
     /*  994388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994398 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  994401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994420 */     GIR_RootConstrainSelectedInstOperands,
     /*  994421 */     // GIR_Coverage, 17218,
     /*  994421 */     GIR_EraseRootFromParent_Done,
     /*  994422 */   // Label 14820: @994422
     /*  994422 */   GIM_Try, /*On fail goto*//*Label 14821*/ GIMT_Encode4(994498), // Rule ID 17219 //
     /*  994427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  994438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  994441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  994444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994455 */     // MIs[0] passthru
     /*  994455 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994464 */     // MIs[0] round
     /*  994464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994474 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  994477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994496 */     GIR_RootConstrainSelectedInstOperands,
     /*  994497 */     // GIR_Coverage, 17219,
     /*  994497 */     GIR_EraseRootFromParent_Done,
     /*  994498 */   // Label 14821: @994498
     /*  994498 */   GIM_Try, /*On fail goto*//*Label 14822*/ GIMT_Encode4(994574), // Rule ID 17228 //
     /*  994503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  994514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  994517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  994520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994531 */     // MIs[0] passthru
     /*  994531 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994540 */     // MIs[0] round
     /*  994540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994550 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  994553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994572 */     GIR_RootConstrainSelectedInstOperands,
     /*  994573 */     // GIR_Coverage, 17228,
     /*  994573 */     GIR_EraseRootFromParent_Done,
     /*  994574 */   // Label 14822: @994574
     /*  994574 */   GIM_Try, /*On fail goto*//*Label 14823*/ GIMT_Encode4(994650), // Rule ID 17229 //
     /*  994579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  994590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  994593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  994596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994607 */     // MIs[0] passthru
     /*  994607 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994616 */     // MIs[0] round
     /*  994616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994626 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  994629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994648 */     GIR_RootConstrainSelectedInstOperands,
     /*  994649 */     // GIR_Coverage, 17229,
     /*  994649 */     GIR_EraseRootFromParent_Done,
     /*  994650 */   // Label 14823: @994650
     /*  994650 */   GIM_Try, /*On fail goto*//*Label 14824*/ GIMT_Encode4(994726), // Rule ID 17274 //
     /*  994655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  994666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  994669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  994672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994683 */     // MIs[0] passthru
     /*  994683 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994692 */     // MIs[0] round
     /*  994692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994702 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  994705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994724 */     GIR_RootConstrainSelectedInstOperands,
     /*  994725 */     // GIR_Coverage, 17274,
     /*  994725 */     GIR_EraseRootFromParent_Done,
     /*  994726 */   // Label 14824: @994726
     /*  994726 */   GIM_Try, /*On fail goto*//*Label 14825*/ GIMT_Encode4(994802), // Rule ID 17275 //
     /*  994731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  994742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  994745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  994748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994759 */     // MIs[0] passthru
     /*  994759 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994768 */     // MIs[0] round
     /*  994768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994778 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  994781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994800 */     GIR_RootConstrainSelectedInstOperands,
     /*  994801 */     // GIR_Coverage, 17275,
     /*  994801 */     GIR_EraseRootFromParent_Done,
     /*  994802 */   // Label 14825: @994802
     /*  994802 */   GIM_Try, /*On fail goto*//*Label 14826*/ GIMT_Encode4(994878), // Rule ID 17284 //
     /*  994807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  994818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  994821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  994824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994835 */     // MIs[0] passthru
     /*  994835 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994844 */     // MIs[0] round
     /*  994844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994854 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  994857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994876 */     GIR_RootConstrainSelectedInstOperands,
     /*  994877 */     // GIR_Coverage, 17284,
     /*  994877 */     GIR_EraseRootFromParent_Done,
     /*  994878 */   // Label 14826: @994878
     /*  994878 */   GIM_Try, /*On fail goto*//*Label 14827*/ GIMT_Encode4(994954), // Rule ID 17285 //
     /*  994883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  994894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  994897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  994900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994911 */     // MIs[0] passthru
     /*  994911 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994920 */     // MIs[0] round
     /*  994920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994930 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  994933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994952 */     GIR_RootConstrainSelectedInstOperands,
     /*  994953 */     // GIR_Coverage, 17285,
     /*  994953 */     GIR_EraseRootFromParent_Done,
     /*  994954 */   // Label 14827: @994954
     /*  994954 */   GIM_Try, /*On fail goto*//*Label 14828*/ GIMT_Encode4(995030), // Rule ID 17294 //
     /*  994959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  994970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  994973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  994976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994987 */     // MIs[0] passthru
     /*  994987 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994996 */     // MIs[0] round
     /*  994996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995006 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  995006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  995009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995028 */     GIR_RootConstrainSelectedInstOperands,
     /*  995029 */     // GIR_Coverage, 17294,
     /*  995029 */     GIR_EraseRootFromParent_Done,
     /*  995030 */   // Label 14828: @995030
     /*  995030 */   GIM_Try, /*On fail goto*//*Label 14829*/ GIMT_Encode4(995106), // Rule ID 17295 //
     /*  995035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  995038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  995046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  995049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  995052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995063 */     // MIs[0] passthru
     /*  995063 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995072 */     // MIs[0] round
     /*  995072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995082 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  995082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  995085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995104 */     GIR_RootConstrainSelectedInstOperands,
     /*  995105 */     // GIR_Coverage, 17295,
     /*  995105 */     GIR_EraseRootFromParent_Done,
     /*  995106 */   // Label 14829: @995106
     /*  995106 */   GIM_Try, /*On fail goto*//*Label 14830*/ GIMT_Encode4(995182), // Rule ID 17304 //
     /*  995111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  995114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  995122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  995125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  995128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995139 */     // MIs[0] passthru
     /*  995139 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995148 */     // MIs[0] round
     /*  995148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995158 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  995158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  995161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995180 */     GIR_RootConstrainSelectedInstOperands,
     /*  995181 */     // GIR_Coverage, 17304,
     /*  995181 */     GIR_EraseRootFromParent_Done,
     /*  995182 */   // Label 14830: @995182
     /*  995182 */   GIM_Try, /*On fail goto*//*Label 14831*/ GIMT_Encode4(995258), // Rule ID 17305 //
     /*  995187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  995190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  995198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  995201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  995204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995215 */     // MIs[0] passthru
     /*  995215 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995224 */     // MIs[0] round
     /*  995224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995234 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  995234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  995237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995256 */     GIR_RootConstrainSelectedInstOperands,
     /*  995257 */     // GIR_Coverage, 17305,
     /*  995257 */     GIR_EraseRootFromParent_Done,
     /*  995258 */   // Label 14831: @995258
     /*  995258 */   GIM_Try, /*On fail goto*//*Label 14832*/ GIMT_Encode4(995334), // Rule ID 17314 //
     /*  995263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  995266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  995274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  995277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  995280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995291 */     // MIs[0] passthru
     /*  995291 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995300 */     // MIs[0] round
     /*  995300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995310 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  995310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  995313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995332 */     GIR_RootConstrainSelectedInstOperands,
     /*  995333 */     // GIR_Coverage, 17314,
     /*  995333 */     GIR_EraseRootFromParent_Done,
     /*  995334 */   // Label 14832: @995334
     /*  995334 */   GIM_Try, /*On fail goto*//*Label 14833*/ GIMT_Encode4(995410), // Rule ID 17315 //
     /*  995339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  995342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  995350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  995353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  995356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995367 */     // MIs[0] passthru
     /*  995367 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995376 */     // MIs[0] round
     /*  995376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995386 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  995386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  995389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995408 */     GIR_RootConstrainSelectedInstOperands,
     /*  995409 */     // GIR_Coverage, 17315,
     /*  995409 */     GIR_EraseRootFromParent_Done,
     /*  995410 */   // Label 14833: @995410
     /*  995410 */   GIM_Try, /*On fail goto*//*Label 14834*/ GIMT_Encode4(995486), // Rule ID 17324 //
     /*  995415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  995426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  995429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  995432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995443 */     // MIs[0] passthru
     /*  995443 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995452 */     // MIs[0] round
     /*  995452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995462 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  995465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995484 */     GIR_RootConstrainSelectedInstOperands,
     /*  995485 */     // GIR_Coverage, 17324,
     /*  995485 */     GIR_EraseRootFromParent_Done,
     /*  995486 */   // Label 14834: @995486
     /*  995486 */   GIM_Try, /*On fail goto*//*Label 14835*/ GIMT_Encode4(995562), // Rule ID 17325 //
     /*  995491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  995502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  995505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  995508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995519 */     // MIs[0] passthru
     /*  995519 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995528 */     // MIs[0] round
     /*  995528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995538 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  995541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995560 */     GIR_RootConstrainSelectedInstOperands,
     /*  995561 */     // GIR_Coverage, 17325,
     /*  995561 */     GIR_EraseRootFromParent_Done,
     /*  995562 */   // Label 14835: @995562
     /*  995562 */   GIM_Try, /*On fail goto*//*Label 14836*/ GIMT_Encode4(995638), // Rule ID 17334 //
     /*  995567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  995578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  995581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  995584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995595 */     // MIs[0] passthru
     /*  995595 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995604 */     // MIs[0] round
     /*  995604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995614 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  995617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995636 */     GIR_RootConstrainSelectedInstOperands,
     /*  995637 */     // GIR_Coverage, 17334,
     /*  995637 */     GIR_EraseRootFromParent_Done,
     /*  995638 */   // Label 14836: @995638
     /*  995638 */   GIM_Try, /*On fail goto*//*Label 14837*/ GIMT_Encode4(995714), // Rule ID 17335 //
     /*  995643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  995654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  995657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  995660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995671 */     // MIs[0] passthru
     /*  995671 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995680 */     // MIs[0] round
     /*  995680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995690 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  995693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995712 */     GIR_RootConstrainSelectedInstOperands,
     /*  995713 */     // GIR_Coverage, 17335,
     /*  995713 */     GIR_EraseRootFromParent_Done,
     /*  995714 */   // Label 14837: @995714
     /*  995714 */   GIM_Try, /*On fail goto*//*Label 14838*/ GIMT_Encode4(995790), // Rule ID 17344 //
     /*  995719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  995730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  995733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  995736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995747 */     // MIs[0] passthru
     /*  995747 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995756 */     // MIs[0] round
     /*  995756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995766 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  995769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995788 */     GIR_RootConstrainSelectedInstOperands,
     /*  995789 */     // GIR_Coverage, 17344,
     /*  995789 */     GIR_EraseRootFromParent_Done,
     /*  995790 */   // Label 14838: @995790
     /*  995790 */   GIM_Try, /*On fail goto*//*Label 14839*/ GIMT_Encode4(995866), // Rule ID 17345 //
     /*  995795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  995806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  995809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  995812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995823 */     // MIs[0] passthru
     /*  995823 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995832 */     // MIs[0] round
     /*  995832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995842 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  995845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995864 */     GIR_RootConstrainSelectedInstOperands,
     /*  995865 */     // GIR_Coverage, 17345,
     /*  995865 */     GIR_EraseRootFromParent_Done,
     /*  995866 */   // Label 14839: @995866
     /*  995866 */   GIM_Try, /*On fail goto*//*Label 14840*/ GIMT_Encode4(995942), // Rule ID 17354 //
     /*  995871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  995882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  995885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  995888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995899 */     // MIs[0] passthru
     /*  995899 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995908 */     // MIs[0] round
     /*  995908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995918 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  995921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995940 */     GIR_RootConstrainSelectedInstOperands,
     /*  995941 */     // GIR_Coverage, 17354,
     /*  995941 */     GIR_EraseRootFromParent_Done,
     /*  995942 */   // Label 14840: @995942
     /*  995942 */   GIM_Try, /*On fail goto*//*Label 14841*/ GIMT_Encode4(996018), // Rule ID 17355 //
     /*  995947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  995958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  995961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  995964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995975 */     // MIs[0] passthru
     /*  995975 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995984 */     // MIs[0] round
     /*  995984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995994 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  995997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  996005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  996016 */     GIR_RootConstrainSelectedInstOperands,
     /*  996017 */     // GIR_Coverage, 17355,
     /*  996017 */     GIR_EraseRootFromParent_Done,
     /*  996018 */   // Label 14841: @996018
     /*  996018 */   GIM_Try, /*On fail goto*//*Label 14842*/ GIMT_Encode4(996095), // Rule ID 2708 //
     /*  996023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  996031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  996034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  996037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  996040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996062 */     // MIs[0] policy
     /*  996062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996072 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  996075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996093 */     GIR_RootConstrainSelectedInstOperands,
     /*  996094 */     // GIR_Coverage, 2708,
     /*  996094 */     GIR_EraseRootFromParent_Done,
     /*  996095 */   // Label 14842: @996095
     /*  996095 */   GIM_Try, /*On fail goto*//*Label 14843*/ GIMT_Encode4(996172), // Rule ID 2709 //
     /*  996100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  996108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  996111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  996114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  996117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996139 */     // MIs[0] policy
     /*  996139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996149 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  996152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996170 */     GIR_RootConstrainSelectedInstOperands,
     /*  996171 */     // GIR_Coverage, 2709,
     /*  996171 */     GIR_EraseRootFromParent_Done,
     /*  996172 */   // Label 14843: @996172
     /*  996172 */   GIM_Try, /*On fail goto*//*Label 14844*/ GIMT_Encode4(996249), // Rule ID 2712 //
     /*  996177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  996194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996216 */     // MIs[0] policy
     /*  996216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996226 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  996229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996247 */     GIR_RootConstrainSelectedInstOperands,
     /*  996248 */     // GIR_Coverage, 2712,
     /*  996248 */     GIR_EraseRootFromParent_Done,
     /*  996249 */   // Label 14844: @996249
     /*  996249 */   GIM_Try, /*On fail goto*//*Label 14845*/ GIMT_Encode4(996326), // Rule ID 2713 //
     /*  996254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  996271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996293 */     // MIs[0] policy
     /*  996293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996303 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  996306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996312 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996324 */     GIR_RootConstrainSelectedInstOperands,
     /*  996325 */     // GIR_Coverage, 2713,
     /*  996325 */     GIR_EraseRootFromParent_Done,
     /*  996326 */   // Label 14845: @996326
     /*  996326 */   GIM_Try, /*On fail goto*//*Label 14846*/ GIMT_Encode4(996403), // Rule ID 2716 //
     /*  996331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  996334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  996339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996370 */     // MIs[0] policy
     /*  996370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996380 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  996383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996401 */     GIR_RootConstrainSelectedInstOperands,
     /*  996402 */     // GIR_Coverage, 2716,
     /*  996402 */     GIR_EraseRootFromParent_Done,
     /*  996403 */   // Label 14846: @996403
     /*  996403 */   GIM_Try, /*On fail goto*//*Label 14847*/ GIMT_Encode4(996480), // Rule ID 2717 //
     /*  996408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  996411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  996416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996447 */     // MIs[0] policy
     /*  996447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996457 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  996460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996478 */     GIR_RootConstrainSelectedInstOperands,
     /*  996479 */     // GIR_Coverage, 2717,
     /*  996479 */     GIR_EraseRootFromParent_Done,
     /*  996480 */   // Label 14847: @996480
     /*  996480 */   GIM_Try, /*On fail goto*//*Label 14848*/ GIMT_Encode4(996557), // Rule ID 2752 //
     /*  996485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  996488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  996493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996524 */     // MIs[0] policy
     /*  996524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  996537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996555 */     GIR_RootConstrainSelectedInstOperands,
     /*  996556 */     // GIR_Coverage, 2752,
     /*  996556 */     GIR_EraseRootFromParent_Done,
     /*  996557 */   // Label 14848: @996557
     /*  996557 */   GIM_Try, /*On fail goto*//*Label 14849*/ GIMT_Encode4(996634), // Rule ID 2753 //
     /*  996562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  996565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  996570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996601 */     // MIs[0] policy
     /*  996601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996611 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  996614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996632 */     GIR_RootConstrainSelectedInstOperands,
     /*  996633 */     // GIR_Coverage, 2753,
     /*  996633 */     GIR_EraseRootFromParent_Done,
     /*  996634 */   // Label 14849: @996634
     /*  996634 */   GIM_Try, /*On fail goto*//*Label 14850*/ GIMT_Encode4(996711), // Rule ID 2784 //
     /*  996639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  996647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  996650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  996653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  996656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  996659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996678 */     // MIs[0] policy
     /*  996678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996688 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*  996691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  996695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996709 */     GIR_RootConstrainSelectedInstOperands,
     /*  996710 */     // GIR_Coverage, 2784,
     /*  996710 */     GIR_EraseRootFromParent_Done,
     /*  996711 */   // Label 14850: @996711
     /*  996711 */   GIM_Try, /*On fail goto*//*Label 14851*/ GIMT_Encode4(996788), // Rule ID 2785 //
     /*  996716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  996724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  996727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  996730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  996733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  996736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996755 */     // MIs[0] policy
     /*  996755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996765 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*  996768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  996772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996786 */     GIR_RootConstrainSelectedInstOperands,
     /*  996787 */     // GIR_Coverage, 2785,
     /*  996787 */     GIR_EraseRootFromParent_Done,
     /*  996788 */   // Label 14851: @996788
     /*  996788 */   GIM_Try, /*On fail goto*//*Label 14852*/ GIMT_Encode4(996865), // Rule ID 4912 //
     /*  996793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  996804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  996807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  996810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996832 */     // MIs[0] policy
     /*  996832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996842 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11733:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  996845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996863 */     GIR_RootConstrainSelectedInstOperands,
     /*  996864 */     // GIR_Coverage, 4912,
     /*  996864 */     GIR_EraseRootFromParent_Done,
     /*  996865 */   // Label 14852: @996865
     /*  996865 */   GIM_Try, /*On fail goto*//*Label 14853*/ GIMT_Encode4(996942), // Rule ID 4913 //
     /*  996870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  996881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  996884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  996887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996909 */     // MIs[0] policy
     /*  996909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996919 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11733:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  996922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996928 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996940 */     GIR_RootConstrainSelectedInstOperands,
     /*  996941 */     // GIR_Coverage, 4913,
     /*  996941 */     GIR_EraseRootFromParent_Done,
     /*  996942 */   // Label 14853: @996942
     /*  996942 */   GIM_Try, /*On fail goto*//*Label 14854*/ GIMT_Encode4(997019), // Rule ID 4916 //
     /*  996947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  996958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  996961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  996964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  996967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996986 */     // MIs[0] policy
     /*  996986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11733:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  996999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997017 */     GIR_RootConstrainSelectedInstOperands,
     /*  997018 */     // GIR_Coverage, 4916,
     /*  997018 */     GIR_EraseRootFromParent_Done,
     /*  997019 */   // Label 14854: @997019
     /*  997019 */   GIM_Try, /*On fail goto*//*Label 14855*/ GIMT_Encode4(997096), // Rule ID 4917 //
     /*  997024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  997035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  997038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  997041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997063 */     // MIs[0] policy
     /*  997063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997073 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11733:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997082 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997094 */     GIR_RootConstrainSelectedInstOperands,
     /*  997095 */     // GIR_Coverage, 4917,
     /*  997095 */     GIR_EraseRootFromParent_Done,
     /*  997096 */   // Label 14855: @997096
     /*  997096 */   GIM_Try, /*On fail goto*//*Label 14856*/ GIMT_Encode4(997173), // Rule ID 4920 //
     /*  997101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  997112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  997115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  997118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997140 */     // MIs[0] policy
     /*  997140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997150 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997171 */     GIR_RootConstrainSelectedInstOperands,
     /*  997172 */     // GIR_Coverage, 4920,
     /*  997172 */     GIR_EraseRootFromParent_Done,
     /*  997173 */   // Label 14856: @997173
     /*  997173 */   GIM_Try, /*On fail goto*//*Label 14857*/ GIMT_Encode4(997250), // Rule ID 4921 //
     /*  997178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  997189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  997192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  997195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997217 */     // MIs[0] policy
     /*  997217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997248 */     GIR_RootConstrainSelectedInstOperands,
     /*  997249 */     // GIR_Coverage, 4921,
     /*  997249 */     GIR_EraseRootFromParent_Done,
     /*  997250 */   // Label 14857: @997250
     /*  997250 */   GIM_Try, /*On fail goto*//*Label 14858*/ GIMT_Encode4(997327), // Rule ID 4924 //
     /*  997255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  997266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  997269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  997272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997294 */     // MIs[0] policy
     /*  997294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997304 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  997307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997325 */     GIR_RootConstrainSelectedInstOperands,
     /*  997326 */     // GIR_Coverage, 4924,
     /*  997326 */     GIR_EraseRootFromParent_Done,
     /*  997327 */   // Label 14858: @997327
     /*  997327 */   GIM_Try, /*On fail goto*//*Label 14859*/ GIMT_Encode4(997404), // Rule ID 4925 //
     /*  997332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  997343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  997346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  997349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997371 */     // MIs[0] policy
     /*  997371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997381 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  997384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997390 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997402 */     GIR_RootConstrainSelectedInstOperands,
     /*  997403 */     // GIR_Coverage, 4925,
     /*  997403 */     GIR_EraseRootFromParent_Done,
     /*  997404 */   // Label 14859: @997404
     /*  997404 */   GIM_Try, /*On fail goto*//*Label 14860*/ GIMT_Encode4(997481), // Rule ID 4928 //
     /*  997409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  997420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  997423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  997426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  997429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997448 */     // MIs[0] policy
     /*  997448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997458 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997479 */     GIR_RootConstrainSelectedInstOperands,
     /*  997480 */     // GIR_Coverage, 4928,
     /*  997480 */     GIR_EraseRootFromParent_Done,
     /*  997481 */   // Label 14860: @997481
     /*  997481 */   GIM_Try, /*On fail goto*//*Label 14861*/ GIMT_Encode4(997558), // Rule ID 4929 //
     /*  997486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  997497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  997500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  997503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  997506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997525 */     // MIs[0] policy
     /*  997525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997535 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997556 */     GIR_RootConstrainSelectedInstOperands,
     /*  997557 */     // GIR_Coverage, 4929,
     /*  997557 */     GIR_EraseRootFromParent_Done,
     /*  997558 */   // Label 14861: @997558
     /*  997558 */   GIM_Try, /*On fail goto*//*Label 14862*/ GIMT_Encode4(997635), // Rule ID 4932 //
     /*  997563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  997574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  997577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  997580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997602 */     // MIs[0] policy
     /*  997602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997612 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  997615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997633 */     GIR_RootConstrainSelectedInstOperands,
     /*  997634 */     // GIR_Coverage, 4932,
     /*  997634 */     GIR_EraseRootFromParent_Done,
     /*  997635 */   // Label 14862: @997635
     /*  997635 */   GIM_Try, /*On fail goto*//*Label 14863*/ GIMT_Encode4(997712), // Rule ID 4933 //
     /*  997640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  997651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  997654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  997657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997679 */     // MIs[0] policy
     /*  997679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997689 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  997692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997710 */     GIR_RootConstrainSelectedInstOperands,
     /*  997711 */     // GIR_Coverage, 4933,
     /*  997711 */     GIR_EraseRootFromParent_Done,
     /*  997712 */   // Label 14863: @997712
     /*  997712 */   GIM_Try, /*On fail goto*//*Label 14864*/ GIMT_Encode4(997789), // Rule ID 4936 //
     /*  997717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  997728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  997731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  997734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  997737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997756 */     // MIs[0] policy
     /*  997756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997766 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997787 */     GIR_RootConstrainSelectedInstOperands,
     /*  997788 */     // GIR_Coverage, 4936,
     /*  997788 */     GIR_EraseRootFromParent_Done,
     /*  997789 */   // Label 14864: @997789
     /*  997789 */   GIM_Try, /*On fail goto*//*Label 14865*/ GIMT_Encode4(997866), // Rule ID 4937 //
     /*  997794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  997805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  997808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  997811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  997814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997833 */     // MIs[0] policy
     /*  997833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997843 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997864 */     GIR_RootConstrainSelectedInstOperands,
     /*  997865 */     // GIR_Coverage, 4937,
     /*  997865 */     GIR_EraseRootFromParent_Done,
     /*  997866 */   // Label 14865: @997866
     /*  997866 */   GIM_Try, /*On fail goto*//*Label 14866*/ GIMT_Encode4(997943), // Rule ID 4940 //
     /*  997871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  997882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  997885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  997888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997910 */     // MIs[0] policy
     /*  997910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997941 */     GIR_RootConstrainSelectedInstOperands,
     /*  997942 */     // GIR_Coverage, 4940,
     /*  997942 */     GIR_EraseRootFromParent_Done,
     /*  997943 */   // Label 14866: @997943
     /*  997943 */   GIM_Try, /*On fail goto*//*Label 14867*/ GIMT_Encode4(998020), // Rule ID 4941 //
     /*  997948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  997959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  997962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  997965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997987 */     // MIs[0] policy
     /*  997987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997997 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  998000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998006 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998018 */     GIR_RootConstrainSelectedInstOperands,
     /*  998019 */     // GIR_Coverage, 4941,
     /*  998019 */     GIR_EraseRootFromParent_Done,
     /*  998020 */   // Label 14867: @998020
     /*  998020 */   GIM_Try, /*On fail goto*//*Label 14868*/ GIMT_Encode4(998097), // Rule ID 4944 //
     /*  998025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  998042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998064 */     // MIs[0] policy
     /*  998064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998074 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  998077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998095 */     GIR_RootConstrainSelectedInstOperands,
     /*  998096 */     // GIR_Coverage, 4944,
     /*  998096 */     GIR_EraseRootFromParent_Done,
     /*  998097 */   // Label 14868: @998097
     /*  998097 */   GIM_Try, /*On fail goto*//*Label 14869*/ GIMT_Encode4(998174), // Rule ID 4945 //
     /*  998102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  998119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998141 */     // MIs[0] policy
     /*  998141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998151 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  998154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998160 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998172 */     GIR_RootConstrainSelectedInstOperands,
     /*  998173 */     // GIR_Coverage, 4945,
     /*  998173 */     GIR_EraseRootFromParent_Done,
     /*  998174 */   // Label 14869: @998174
     /*  998174 */   GIM_Try, /*On fail goto*//*Label 14870*/ GIMT_Encode4(998251), // Rule ID 4948 //
     /*  998179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  998190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  998193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  998196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  998199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998218 */     // MIs[0] policy
     /*  998218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998228 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  998231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998249 */     GIR_RootConstrainSelectedInstOperands,
     /*  998250 */     // GIR_Coverage, 4948,
     /*  998250 */     GIR_EraseRootFromParent_Done,
     /*  998251 */   // Label 14870: @998251
     /*  998251 */   GIM_Try, /*On fail goto*//*Label 14871*/ GIMT_Encode4(998328), // Rule ID 4949 //
     /*  998256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  998267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  998270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  998273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  998276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998295 */     // MIs[0] policy
     /*  998295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998305 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  998308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998314 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998326 */     GIR_RootConstrainSelectedInstOperands,
     /*  998327 */     // GIR_Coverage, 4949,
     /*  998327 */     GIR_EraseRootFromParent_Done,
     /*  998328 */   // Label 14871: @998328
     /*  998328 */   GIM_Try, /*On fail goto*//*Label 14872*/ GIMT_Encode4(998405), // Rule ID 4952 //
     /*  998333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  998344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  998347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  998350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998372 */     // MIs[0] policy
     /*  998372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998382 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  998385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998403 */     GIR_RootConstrainSelectedInstOperands,
     /*  998404 */     // GIR_Coverage, 4952,
     /*  998404 */     GIR_EraseRootFromParent_Done,
     /*  998405 */   // Label 14872: @998405
     /*  998405 */   GIM_Try, /*On fail goto*//*Label 14873*/ GIMT_Encode4(998482), // Rule ID 4953 //
     /*  998410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  998421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  998424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  998427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998449 */     // MIs[0] policy
     /*  998449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998459 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  998462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998468 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998480 */     GIR_RootConstrainSelectedInstOperands,
     /*  998481 */     // GIR_Coverage, 4953,
     /*  998481 */     GIR_EraseRootFromParent_Done,
     /*  998482 */   // Label 14873: @998482
     /*  998482 */   GIM_Try, /*On fail goto*//*Label 14874*/ GIMT_Encode4(998559), // Rule ID 4956 //
     /*  998487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  998504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998526 */     // MIs[0] policy
     /*  998526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998536 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  998539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998557 */     GIR_RootConstrainSelectedInstOperands,
     /*  998558 */     // GIR_Coverage, 4956,
     /*  998558 */     GIR_EraseRootFromParent_Done,
     /*  998559 */   // Label 14874: @998559
     /*  998559 */   GIM_Try, /*On fail goto*//*Label 14875*/ GIMT_Encode4(998636), // Rule ID 4957 //
     /*  998564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  998581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998603 */     // MIs[0] policy
     /*  998603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998613 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  998616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998622 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998634 */     GIR_RootConstrainSelectedInstOperands,
     /*  998635 */     // GIR_Coverage, 4957,
     /*  998635 */     GIR_EraseRootFromParent_Done,
     /*  998636 */   // Label 14875: @998636
     /*  998636 */   GIM_Try, /*On fail goto*//*Label 14876*/ GIMT_Encode4(998713), // Rule ID 4960 //
     /*  998641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  998652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  998655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  998658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998680 */     // MIs[0] policy
     /*  998680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998690 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  998693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998711 */     GIR_RootConstrainSelectedInstOperands,
     /*  998712 */     // GIR_Coverage, 4960,
     /*  998712 */     GIR_EraseRootFromParent_Done,
     /*  998713 */   // Label 14876: @998713
     /*  998713 */   GIM_Try, /*On fail goto*//*Label 14877*/ GIMT_Encode4(998790), // Rule ID 4961 //
     /*  998718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  998729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  998732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  998735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998757 */     // MIs[0] policy
     /*  998757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998767 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  998770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998788 */     GIR_RootConstrainSelectedInstOperands,
     /*  998789 */     // GIR_Coverage, 4961,
     /*  998789 */     GIR_EraseRootFromParent_Done,
     /*  998790 */   // Label 14877: @998790
     /*  998790 */   GIM_Try, /*On fail goto*//*Label 14878*/ GIMT_Encode4(998867), // Rule ID 4964 //
     /*  998795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  998806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  998809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  998812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998834 */     // MIs[0] policy
     /*  998834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998844 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  998847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998865 */     GIR_RootConstrainSelectedInstOperands,
     /*  998866 */     // GIR_Coverage, 4964,
     /*  998866 */     GIR_EraseRootFromParent_Done,
     /*  998867 */   // Label 14878: @998867
     /*  998867 */   GIM_Try, /*On fail goto*//*Label 14879*/ GIMT_Encode4(998944), // Rule ID 4965 //
     /*  998872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  998883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  998886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  998889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998911 */     // MIs[0] policy
     /*  998911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998921 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  998924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998930 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998942 */     GIR_RootConstrainSelectedInstOperands,
     /*  998943 */     // GIR_Coverage, 4965,
     /*  998943 */     GIR_EraseRootFromParent_Done,
     /*  998944 */   // Label 14879: @998944
     /*  998944 */   GIM_Try, /*On fail goto*//*Label 14880*/ GIMT_Encode4(999021), // Rule ID 4968 //
     /*  998949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  998960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  998963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  998966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998988 */     // MIs[0] policy
     /*  998988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /*  999001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999019 */     GIR_RootConstrainSelectedInstOperands,
     /*  999020 */     // GIR_Coverage, 4968,
     /*  999020 */     GIR_EraseRootFromParent_Done,
     /*  999021 */   // Label 14880: @999021
     /*  999021 */   GIM_Try, /*On fail goto*//*Label 14881*/ GIMT_Encode4(999098), // Rule ID 4969 //
     /*  999026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  999037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  999040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999065 */     // MIs[0] policy
     /*  999065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999075 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /*  999078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999096 */     GIR_RootConstrainSelectedInstOperands,
     /*  999097 */     // GIR_Coverage, 4969,
     /*  999097 */     GIR_EraseRootFromParent_Done,
     /*  999098 */   // Label 14881: @999098
     /*  999098 */   GIM_Try, /*On fail goto*//*Label 14882*/ GIMT_Encode4(999175), // Rule ID 4972 //
     /*  999103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  999114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  999117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  999120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999142 */     // MIs[0] policy
     /*  999142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  999155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999173 */     GIR_RootConstrainSelectedInstOperands,
     /*  999174 */     // GIR_Coverage, 4972,
     /*  999174 */     GIR_EraseRootFromParent_Done,
     /*  999175 */   // Label 14882: @999175
     /*  999175 */   GIM_Try, /*On fail goto*//*Label 14883*/ GIMT_Encode4(999252), // Rule ID 4973 //
     /*  999180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  999191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  999194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  999197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999219 */     // MIs[0] policy
     /*  999219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999229 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  999232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999238 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999250 */     GIR_RootConstrainSelectedInstOperands,
     /*  999251 */     // GIR_Coverage, 4973,
     /*  999251 */     GIR_EraseRootFromParent_Done,
     /*  999252 */   // Label 14883: @999252
     /*  999252 */   GIM_Try, /*On fail goto*//*Label 14884*/ GIMT_Encode4(999329), // Rule ID 4976 //
     /*  999257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  999268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  999271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  999274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999296 */     // MIs[0] policy
     /*  999296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  999309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999327 */     GIR_RootConstrainSelectedInstOperands,
     /*  999328 */     // GIR_Coverage, 4976,
     /*  999328 */     GIR_EraseRootFromParent_Done,
     /*  999329 */   // Label 14884: @999329
     /*  999329 */   GIM_Try, /*On fail goto*//*Label 14885*/ GIMT_Encode4(999406), // Rule ID 4977 //
     /*  999334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  999345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  999348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  999351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999373 */     // MIs[0] policy
     /*  999373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999383 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  999386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999392 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999404 */     GIR_RootConstrainSelectedInstOperands,
     /*  999405 */     // GIR_Coverage, 4977,
     /*  999405 */     GIR_EraseRootFromParent_Done,
     /*  999406 */   // Label 14885: @999406
     /*  999406 */   GIM_Try, /*On fail goto*//*Label 14886*/ GIMT_Encode4(999483), // Rule ID 4980 //
     /*  999411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  999422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  999425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  999428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999450 */     // MIs[0] policy
     /*  999450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999481 */     GIR_RootConstrainSelectedInstOperands,
     /*  999482 */     // GIR_Coverage, 4980,
     /*  999482 */     GIR_EraseRootFromParent_Done,
     /*  999483 */   // Label 14886: @999483
     /*  999483 */   GIM_Try, /*On fail goto*//*Label 14887*/ GIMT_Encode4(999560), // Rule ID 4981 //
     /*  999488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  999499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  999502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  999505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999527 */     // MIs[0] policy
     /*  999527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999537 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999546 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999558 */     GIR_RootConstrainSelectedInstOperands,
     /*  999559 */     // GIR_Coverage, 4981,
     /*  999559 */     GIR_EraseRootFromParent_Done,
     /*  999560 */   // Label 14887: @999560
     /*  999560 */   GIM_Try, /*On fail goto*//*Label 14888*/ GIMT_Encode4(999637), // Rule ID 4984 //
     /*  999565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  999576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  999579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  999582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  999585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999604 */     // MIs[0] policy
     /*  999604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999635 */     GIR_RootConstrainSelectedInstOperands,
     /*  999636 */     // GIR_Coverage, 4984,
     /*  999636 */     GIR_EraseRootFromParent_Done,
     /*  999637 */   // Label 14888: @999637
     /*  999637 */   GIM_Try, /*On fail goto*//*Label 14889*/ GIMT_Encode4(999714), // Rule ID 4985 //
     /*  999642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  999653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  999656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  999659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  999662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999681 */     // MIs[0] policy
     /*  999681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999691 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999700 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999712 */     GIR_RootConstrainSelectedInstOperands,
     /*  999713 */     // GIR_Coverage, 4985,
     /*  999713 */     GIR_EraseRootFromParent_Done,
     /*  999714 */   // Label 14889: @999714
     /*  999714 */   GIM_Try, /*On fail goto*//*Label 14890*/ GIMT_Encode4(999791), // Rule ID 4988 //
     /*  999719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999758 */     // MIs[0] policy
     /*  999758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  999771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999789 */     GIR_RootConstrainSelectedInstOperands,
     /*  999790 */     // GIR_Coverage, 4988,
     /*  999790 */     GIR_EraseRootFromParent_Done,
     /*  999791 */   // Label 14890: @999791
     /*  999791 */   GIM_Try, /*On fail goto*//*Label 14891*/ GIMT_Encode4(999868), // Rule ID 4989 //
     /*  999796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999835 */     // MIs[0] policy
     /*  999835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999845 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  999848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999854 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999866 */     GIR_RootConstrainSelectedInstOperands,
     /*  999867 */     // GIR_Coverage, 4989,
     /*  999867 */     GIR_EraseRootFromParent_Done,
     /*  999868 */   // Label 14891: @999868
     /*  999868 */   GIM_Try, /*On fail goto*//*Label 14892*/ GIMT_Encode4(999945), // Rule ID 4992 //
     /*  999873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  999884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  999887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  999890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999912 */     // MIs[0] policy
     /*  999912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999922 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  999925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999943 */     GIR_RootConstrainSelectedInstOperands,
     /*  999944 */     // GIR_Coverage, 4992,
     /*  999944 */     GIR_EraseRootFromParent_Done,
     /*  999945 */   // Label 14892: @999945
     /*  999945 */   GIM_Try, /*On fail goto*//*Label 14893*/ GIMT_Encode4(1000022), // Rule ID 4993 //
     /*  999950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  999961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  999964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  999967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999989 */     // MIs[0] policy
     /*  999989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999999 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /* 1000002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000021 */     // GIR_Coverage, 4993,
     /* 1000021 */     GIR_EraseRootFromParent_Done,
     /* 1000022 */   // Label 14893: @1000022
     /* 1000022 */   GIM_Try, /*On fail goto*//*Label 14894*/ GIMT_Encode4(1000099), // Rule ID 4996 //
     /* 1000027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1000038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1000041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1000044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000066 */     // MIs[0] policy
     /* 1000066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000076 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /* 1000079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000098 */     // GIR_Coverage, 4996,
     /* 1000098 */     GIR_EraseRootFromParent_Done,
     /* 1000099 */   // Label 14894: @1000099
     /* 1000099 */   GIM_Try, /*On fail goto*//*Label 14895*/ GIMT_Encode4(1000176), // Rule ID 4997 //
     /* 1000104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1000115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1000118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1000121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000143 */     // MIs[0] policy
     /* 1000143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000153 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /* 1000156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000162 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000175 */     // GIR_Coverage, 4997,
     /* 1000175 */     GIR_EraseRootFromParent_Done,
     /* 1000176 */   // Label 14895: @1000176
     /* 1000176 */   GIM_Try, /*On fail goto*//*Label 14896*/ GIMT_Encode4(1000253), // Rule ID 5000 //
     /* 1000181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1000192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1000195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1000198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000220 */     // MIs[0] policy
     /* 1000220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000230 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /* 1000233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000252 */     // GIR_Coverage, 5000,
     /* 1000252 */     GIR_EraseRootFromParent_Done,
     /* 1000253 */   // Label 14896: @1000253
     /* 1000253 */   GIM_Try, /*On fail goto*//*Label 14897*/ GIMT_Encode4(1000330), // Rule ID 5001 //
     /* 1000258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1000269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1000272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1000275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000297 */     // MIs[0] policy
     /* 1000297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000307 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /* 1000310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000329 */     // GIR_Coverage, 5001,
     /* 1000329 */     GIR_EraseRootFromParent_Done,
     /* 1000330 */   // Label 14897: @1000330
     /* 1000330 */   GIM_Try, /*On fail goto*//*Label 14898*/ GIMT_Encode4(1000407), // Rule ID 5004 //
     /* 1000335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1000346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1000349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000374 */     // MIs[0] policy
     /* 1000374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /* 1000387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000406 */     // GIR_Coverage, 5004,
     /* 1000406 */     GIR_EraseRootFromParent_Done,
     /* 1000407 */   // Label 14898: @1000407
     /* 1000407 */   GIM_Try, /*On fail goto*//*Label 14899*/ GIMT_Encode4(1000484), // Rule ID 5005 //
     /* 1000412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1000423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1000426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000451 */     // MIs[0] policy
     /* 1000451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000461 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /* 1000464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000470 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000483 */     // GIR_Coverage, 5005,
     /* 1000483 */     GIR_EraseRootFromParent_Done,
     /* 1000484 */   // Label 14899: @1000484
     /* 1000484 */   GIM_Try, /*On fail goto*//*Label 14900*/ GIMT_Encode4(1000561), // Rule ID 5008 //
     /* 1000489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1000500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1000503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000528 */     // MIs[0] policy
     /* 1000528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000538 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /* 1000541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000560 */     // GIR_Coverage, 5008,
     /* 1000560 */     GIR_EraseRootFromParent_Done,
     /* 1000561 */   // Label 14900: @1000561
     /* 1000561 */   GIM_Try, /*On fail goto*//*Label 14901*/ GIMT_Encode4(1000638), // Rule ID 5009 //
     /* 1000566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1000577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1000580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000605 */     // MIs[0] policy
     /* 1000605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000615 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /* 1000618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000624 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000637 */     // GIR_Coverage, 5009,
     /* 1000637 */     GIR_EraseRootFromParent_Done,
     /* 1000638 */   // Label 14901: @1000638
     /* 1000638 */   GIM_Try, /*On fail goto*//*Label 14902*/ GIMT_Encode4(1000715), // Rule ID 5012 //
     /* 1000643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1000654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1000657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000682 */     // MIs[0] policy
     /* 1000682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000692 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /* 1000695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000714 */     // GIR_Coverage, 5012,
     /* 1000714 */     GIR_EraseRootFromParent_Done,
     /* 1000715 */   // Label 14902: @1000715
     /* 1000715 */   GIM_Try, /*On fail goto*//*Label 14903*/ GIMT_Encode4(1000792), // Rule ID 5013 //
     /* 1000720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1000731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1000734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000759 */     // MIs[0] policy
     /* 1000759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000769 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /* 1000772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000778 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000791 */     // GIR_Coverage, 5013,
     /* 1000791 */     GIR_EraseRootFromParent_Done,
     /* 1000792 */   // Label 14903: @1000792
     /* 1000792 */   GIM_Try, /*On fail goto*//*Label 14904*/ GIMT_Encode4(1000869), // Rule ID 5016 //
     /* 1000797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1000808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1000811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000836 */     // MIs[0] policy
     /* 1000836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /* 1000849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000868 */     // GIR_Coverage, 5016,
     /* 1000868 */     GIR_EraseRootFromParent_Done,
     /* 1000869 */   // Label 14904: @1000869
     /* 1000869 */   GIM_Try, /*On fail goto*//*Label 14905*/ GIMT_Encode4(1000946), // Rule ID 5017 //
     /* 1000874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1000885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1000888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000913 */     // MIs[0] policy
     /* 1000913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000923 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /* 1000926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000932 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000945 */     // GIR_Coverage, 5017,
     /* 1000945 */     GIR_EraseRootFromParent_Done,
     /* 1000946 */   // Label 14905: @1000946
     /* 1000946 */   GIM_Try, /*On fail goto*//*Label 14906*/ GIMT_Encode4(1001023), // Rule ID 5020 //
     /* 1000951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1000962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1000965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000990 */     // MIs[0] policy
     /* 1000990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001000 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1001003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001022 */     // GIR_Coverage, 5020,
     /* 1001022 */     GIR_EraseRootFromParent_Done,
     /* 1001023 */   // Label 14906: @1001023
     /* 1001023 */   GIM_Try, /*On fail goto*//*Label 14907*/ GIMT_Encode4(1001100), // Rule ID 5021 //
     /* 1001028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1001039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1001042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1001045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001067 */     // MIs[0] policy
     /* 1001067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001077 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1001080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001099 */     // GIR_Coverage, 5021,
     /* 1001099 */     GIR_EraseRootFromParent_Done,
     /* 1001100 */   // Label 14907: @1001100
     /* 1001100 */   GIM_Try, /*On fail goto*//*Label 14908*/ GIMT_Encode4(1001177), // Rule ID 5024 //
     /* 1001105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1001116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1001119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1001122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001144 */     // MIs[0] policy
     /* 1001144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001154 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1001157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001176 */     // GIR_Coverage, 5024,
     /* 1001176 */     GIR_EraseRootFromParent_Done,
     /* 1001177 */   // Label 14908: @1001177
     /* 1001177 */   GIM_Try, /*On fail goto*//*Label 14909*/ GIMT_Encode4(1001254), // Rule ID 5025 //
     /* 1001182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1001193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1001196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1001199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001221 */     // MIs[0] policy
     /* 1001221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001231 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1001234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001240 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001253 */     // GIR_Coverage, 5025,
     /* 1001253 */     GIR_EraseRootFromParent_Done,
     /* 1001254 */   // Label 14909: @1001254
     /* 1001254 */   GIM_Try, /*On fail goto*//*Label 14910*/ GIMT_Encode4(1001331), // Rule ID 5028 //
     /* 1001259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1001270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1001273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1001276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001298 */     // MIs[0] policy
     /* 1001298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1001311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001330 */     // GIR_Coverage, 5028,
     /* 1001330 */     GIR_EraseRootFromParent_Done,
     /* 1001331 */   // Label 14910: @1001331
     /* 1001331 */   GIM_Try, /*On fail goto*//*Label 14911*/ GIMT_Encode4(1001408), // Rule ID 5029 //
     /* 1001336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1001347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1001350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1001353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001375 */     // MIs[0] policy
     /* 1001375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001385 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1001388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001394 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001407 */     // GIR_Coverage, 5029,
     /* 1001407 */     GIR_EraseRootFromParent_Done,
     /* 1001408 */   // Label 14911: @1001408
     /* 1001408 */   GIM_Try, /*On fail goto*//*Label 14912*/ GIMT_Encode4(1001485), // Rule ID 5032 //
     /* 1001413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1001424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1001427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1001430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001452 */     // MIs[0] policy
     /* 1001452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001462 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001484 */     // GIR_Coverage, 5032,
     /* 1001484 */     GIR_EraseRootFromParent_Done,
     /* 1001485 */   // Label 14912: @1001485
     /* 1001485 */   GIM_Try, /*On fail goto*//*Label 14913*/ GIMT_Encode4(1001562), // Rule ID 5033 //
     /* 1001490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1001501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1001504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1001507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001529 */     // MIs[0] policy
     /* 1001529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001539 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001561 */     // GIR_Coverage, 5033,
     /* 1001561 */     GIR_EraseRootFromParent_Done,
     /* 1001562 */   // Label 14913: @1001562
     /* 1001562 */   GIM_Try, /*On fail goto*//*Label 14914*/ GIMT_Encode4(1001639), // Rule ID 5036 //
     /* 1001567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1001578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1001581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1001584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001606 */     // MIs[0] policy
     /* 1001606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001638 */     // GIR_Coverage, 5036,
     /* 1001638 */     GIR_EraseRootFromParent_Done,
     /* 1001639 */   // Label 14914: @1001639
     /* 1001639 */   GIM_Try, /*On fail goto*//*Label 14915*/ GIMT_Encode4(1001716), // Rule ID 5037 //
     /* 1001644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1001655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1001658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1001661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001683 */     // MIs[0] policy
     /* 1001683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001693 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001715 */     // GIR_Coverage, 5037,
     /* 1001715 */     GIR_EraseRootFromParent_Done,
     /* 1001716 */   // Label 14915: @1001716
     /* 1001716 */   GIM_Try, /*On fail goto*//*Label 14916*/ GIMT_Encode4(1001793), // Rule ID 5040 //
     /* 1001721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1001732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1001735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1001738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1001741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001760 */     // MIs[0] policy
     /* 1001760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001770 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1001773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001792 */     // GIR_Coverage, 5040,
     /* 1001792 */     GIR_EraseRootFromParent_Done,
     /* 1001793 */   // Label 14916: @1001793
     /* 1001793 */   GIM_Try, /*On fail goto*//*Label 14917*/ GIMT_Encode4(1001870), // Rule ID 5041 //
     /* 1001798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1001809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1001812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1001815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1001818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001837 */     // MIs[0] policy
     /* 1001837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001847 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1001850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001856 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001869 */     // GIR_Coverage, 5041,
     /* 1001869 */     GIR_EraseRootFromParent_Done,
     /* 1001870 */   // Label 14917: @1001870
     /* 1001870 */   GIM_Try, /*On fail goto*//*Label 14918*/ GIMT_Encode4(1001947), // Rule ID 5044 //
     /* 1001875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1001886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1001889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1001892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001914 */     // MIs[0] policy
     /* 1001914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1001927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001946 */     // GIR_Coverage, 5044,
     /* 1001946 */     GIR_EraseRootFromParent_Done,
     /* 1001947 */   // Label 14918: @1001947
     /* 1001947 */   GIM_Try, /*On fail goto*//*Label 14919*/ GIMT_Encode4(1002024), // Rule ID 5045 //
     /* 1001952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1001963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1001966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1001969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001991 */     // MIs[0] policy
     /* 1001991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002001 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1002004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002010 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002023 */     // GIR_Coverage, 5045,
     /* 1002023 */     GIR_EraseRootFromParent_Done,
     /* 1002024 */   // Label 14919: @1002024
     /* 1002024 */   GIM_Try, /*On fail goto*//*Label 14920*/ GIMT_Encode4(1002101), // Rule ID 5048 //
     /* 1002029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1002040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1002043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1002046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002068 */     // MIs[0] policy
     /* 1002068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1002081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002100 */     // GIR_Coverage, 5048,
     /* 1002100 */     GIR_EraseRootFromParent_Done,
     /* 1002101 */   // Label 14920: @1002101
     /* 1002101 */   GIM_Try, /*On fail goto*//*Label 14921*/ GIMT_Encode4(1002178), // Rule ID 5049 //
     /* 1002106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1002117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1002120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1002123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002145 */     // MIs[0] policy
     /* 1002145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002155 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1002158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002164 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002177 */     // GIR_Coverage, 5049,
     /* 1002177 */     GIR_EraseRootFromParent_Done,
     /* 1002178 */   // Label 14921: @1002178
     /* 1002178 */   GIM_Try, /*On fail goto*//*Label 14922*/ GIMT_Encode4(1002255), // Rule ID 5052 //
     /* 1002183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1002194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1002197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1002200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002222 */     // MIs[0] policy
     /* 1002222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1002235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002254 */     // GIR_Coverage, 5052,
     /* 1002254 */     GIR_EraseRootFromParent_Done,
     /* 1002255 */   // Label 14922: @1002255
     /* 1002255 */   GIM_Try, /*On fail goto*//*Label 14923*/ GIMT_Encode4(1002332), // Rule ID 5053 //
     /* 1002260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1002271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1002274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1002277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002299 */     // MIs[0] policy
     /* 1002299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002309 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1002312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002318 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002331 */     // GIR_Coverage, 5053,
     /* 1002331 */     GIR_EraseRootFromParent_Done,
     /* 1002332 */   // Label 14923: @1002332
     /* 1002332 */   GIM_Try, /*On fail goto*//*Label 14924*/ GIMT_Encode4(1002409), // Rule ID 5056 //
     /* 1002337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1002348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1002351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1002354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002376 */     // MIs[0] policy
     /* 1002376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002386 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1002389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002408 */     // GIR_Coverage, 5056,
     /* 1002408 */     GIR_EraseRootFromParent_Done,
     /* 1002409 */   // Label 14924: @1002409
     /* 1002409 */   GIM_Try, /*On fail goto*//*Label 14925*/ GIMT_Encode4(1002486), // Rule ID 5057 //
     /* 1002414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1002425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1002428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1002431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002453 */     // MIs[0] policy
     /* 1002453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002463 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1002466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002472 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002485 */     // GIR_Coverage, 5057,
     /* 1002485 */     GIR_EraseRootFromParent_Done,
     /* 1002486 */   // Label 14925: @1002486
     /* 1002486 */   GIM_Try, /*On fail goto*//*Label 14926*/ GIMT_Encode4(1002563), // Rule ID 5060 //
     /* 1002491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1002502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1002505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1002508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1002511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002530 */     // MIs[0] policy
     /* 1002530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002540 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002562 */     // GIR_Coverage, 5060,
     /* 1002562 */     GIR_EraseRootFromParent_Done,
     /* 1002563 */   // Label 14926: @1002563
     /* 1002563 */   GIM_Try, /*On fail goto*//*Label 14927*/ GIMT_Encode4(1002640), // Rule ID 5061 //
     /* 1002568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1002579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1002582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1002585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1002588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002607 */     // MIs[0] policy
     /* 1002607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002617 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002639 */     // GIR_Coverage, 5061,
     /* 1002639 */     GIR_EraseRootFromParent_Done,
     /* 1002640 */   // Label 14927: @1002640
     /* 1002640 */   GIM_Try, /*On fail goto*//*Label 14928*/ GIMT_Encode4(1002717), // Rule ID 5064 //
     /* 1002645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1002656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1002659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1002662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002684 */     // MIs[0] policy
     /* 1002684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002694 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1002697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002716 */     // GIR_Coverage, 5064,
     /* 1002716 */     GIR_EraseRootFromParent_Done,
     /* 1002717 */   // Label 14928: @1002717
     /* 1002717 */   GIM_Try, /*On fail goto*//*Label 14929*/ GIMT_Encode4(1002794), // Rule ID 5065 //
     /* 1002722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1002733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1002736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1002739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002761 */     // MIs[0] policy
     /* 1002761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002771 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1002774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002793 */     // GIR_Coverage, 5065,
     /* 1002793 */     GIR_EraseRootFromParent_Done,
     /* 1002794 */   // Label 14929: @1002794
     /* 1002794 */   GIM_Try, /*On fail goto*//*Label 14930*/ GIMT_Encode4(1002871), // Rule ID 5068 //
     /* 1002799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1002810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1002813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1002816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002838 */     // MIs[0] policy
     /* 1002838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002848 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1002851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002870 */     // GIR_Coverage, 5068,
     /* 1002870 */     GIR_EraseRootFromParent_Done,
     /* 1002871 */   // Label 14930: @1002871
     /* 1002871 */   GIM_Try, /*On fail goto*//*Label 14931*/ GIMT_Encode4(1002948), // Rule ID 5069 //
     /* 1002876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1002887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1002890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1002893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002915 */     // MIs[0] policy
     /* 1002915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002925 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1002928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002934 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002947 */     // GIR_Coverage, 5069,
     /* 1002947 */     GIR_EraseRootFromParent_Done,
     /* 1002948 */   // Label 14931: @1002948
     /* 1002948 */   GIM_Try, /*On fail goto*//*Label 14932*/ GIMT_Encode4(1003025), // Rule ID 5072 //
     /* 1002953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1002964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1002967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1002970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002992 */     // MIs[0] policy
     /* 1002992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003002 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1003005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003024 */     // GIR_Coverage, 5072,
     /* 1003024 */     GIR_EraseRootFromParent_Done,
     /* 1003025 */   // Label 14932: @1003025
     /* 1003025 */   GIM_Try, /*On fail goto*//*Label 14933*/ GIMT_Encode4(1003102), // Rule ID 5073 //
     /* 1003030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1003047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003069 */     // MIs[0] policy
     /* 1003069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003079 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1003082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003088 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003101 */     // GIR_Coverage, 5073,
     /* 1003101 */     GIR_EraseRootFromParent_Done,
     /* 1003102 */   // Label 14933: @1003102
     /* 1003102 */   GIM_Try, /*On fail goto*//*Label 14934*/ GIMT_Encode4(1003179), // Rule ID 5076 //
     /* 1003107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1003118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1003121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1003124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003146 */     // MIs[0] policy
     /* 1003146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003156 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1003159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003178 */     // GIR_Coverage, 5076,
     /* 1003178 */     GIR_EraseRootFromParent_Done,
     /* 1003179 */   // Label 14934: @1003179
     /* 1003179 */   GIM_Try, /*On fail goto*//*Label 14935*/ GIMT_Encode4(1003256), // Rule ID 5077 //
     /* 1003184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1003195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1003198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1003201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003223 */     // MIs[0] policy
     /* 1003223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003233 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1003236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003242 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003255 */     // GIR_Coverage, 5077,
     /* 1003255 */     GIR_EraseRootFromParent_Done,
     /* 1003256 */   // Label 14935: @1003256
     /* 1003256 */   GIM_Try, /*On fail goto*//*Label 14936*/ GIMT_Encode4(1003333), // Rule ID 5080 //
     /* 1003261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1003272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1003275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1003278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003300 */     // MIs[0] policy
     /* 1003300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003310 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1003313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003332 */     // GIR_Coverage, 5080,
     /* 1003332 */     GIR_EraseRootFromParent_Done,
     /* 1003333 */   // Label 14936: @1003333
     /* 1003333 */   GIM_Try, /*On fail goto*//*Label 14937*/ GIMT_Encode4(1003410), // Rule ID 5081 //
     /* 1003338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1003349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1003352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1003355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003377 */     // MIs[0] policy
     /* 1003377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003387 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1003390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003396 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003409 */     // GIR_Coverage, 5081,
     /* 1003409 */     GIR_EraseRootFromParent_Done,
     /* 1003410 */   // Label 14937: @1003410
     /* 1003410 */   GIM_Try, /*On fail goto*//*Label 14938*/ GIMT_Encode4(1003487), // Rule ID 5084 //
     /* 1003415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1003426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1003429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1003432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003454 */     // MIs[0] policy
     /* 1003454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003486 */     // GIR_Coverage, 5084,
     /* 1003486 */     GIR_EraseRootFromParent_Done,
     /* 1003487 */   // Label 14938: @1003487
     /* 1003487 */   GIM_Try, /*On fail goto*//*Label 14939*/ GIMT_Encode4(1003564), // Rule ID 5085 //
     /* 1003492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1003503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1003506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1003509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003531 */     // MIs[0] policy
     /* 1003531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003541 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003550 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003563 */     // GIR_Coverage, 5085,
     /* 1003563 */     GIR_EraseRootFromParent_Done,
     /* 1003564 */   // Label 14939: @1003564
     /* 1003564 */   GIM_Try, /*On fail goto*//*Label 14940*/ GIMT_Encode4(1003641), // Rule ID 5088 //
     /* 1003569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1003580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1003583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1003586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003608 */     // MIs[0] policy
     /* 1003608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003618 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003640 */     // GIR_Coverage, 5088,
     /* 1003640 */     GIR_EraseRootFromParent_Done,
     /* 1003641 */   // Label 14940: @1003641
     /* 1003641 */   GIM_Try, /*On fail goto*//*Label 14941*/ GIMT_Encode4(1003718), // Rule ID 5089 //
     /* 1003646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1003657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1003660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1003663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003685 */     // MIs[0] policy
     /* 1003685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003695 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003717 */     // GIR_Coverage, 5089,
     /* 1003717 */     GIR_EraseRootFromParent_Done,
     /* 1003718 */   // Label 14941: @1003718
     /* 1003718 */   GIM_Try, /*On fail goto*//*Label 14942*/ GIMT_Encode4(1003795), // Rule ID 5092 //
     /* 1003723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1003734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1003737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1003740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003762 */     // MIs[0] policy
     /* 1003762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003772 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003794 */     // GIR_Coverage, 5092,
     /* 1003794 */     GIR_EraseRootFromParent_Done,
     /* 1003795 */   // Label 14942: @1003795
     /* 1003795 */   GIM_Try, /*On fail goto*//*Label 14943*/ GIMT_Encode4(1003872), // Rule ID 5093 //
     /* 1003800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1003811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1003814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1003817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003839 */     // MIs[0] policy
     /* 1003839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003849 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003858 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003871 */     // GIR_Coverage, 5093,
     /* 1003871 */     GIR_EraseRootFromParent_Done,
     /* 1003872 */   // Label 14943: @1003872
     /* 1003872 */   GIM_Try, /*On fail goto*//*Label 14944*/ GIMT_Encode4(1003949), // Rule ID 5096 //
     /* 1003877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1003888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1003891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1003894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1003897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003916 */     // MIs[0] policy
     /* 1003916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003926 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1003929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003948 */     // GIR_Coverage, 5096,
     /* 1003948 */     GIR_EraseRootFromParent_Done,
     /* 1003949 */   // Label 14944: @1003949
     /* 1003949 */   GIM_Try, /*On fail goto*//*Label 14945*/ GIMT_Encode4(1004026), // Rule ID 5097 //
     /* 1003954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1003965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1003968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1003971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1003974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003993 */     // MIs[0] policy
     /* 1003993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004003 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1004006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1004022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004025 */     // GIR_Coverage, 5097,
     /* 1004025 */     GIR_EraseRootFromParent_Done,
     /* 1004026 */   // Label 14945: @1004026
     /* 1004026 */   GIM_Try, /*On fail goto*//*Label 14946*/ GIMT_Encode4(1004103), // Rule ID 5100 //
     /* 1004031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1004042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1004045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1004048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004070 */     // MIs[0] policy
     /* 1004070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004080 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1004083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004102 */     // GIR_Coverage, 5100,
     /* 1004102 */     GIR_EraseRootFromParent_Done,
     /* 1004103 */   // Label 14946: @1004103
     /* 1004103 */   GIM_Try, /*On fail goto*//*Label 14947*/ GIMT_Encode4(1004180), // Rule ID 5101 //
     /* 1004108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1004119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1004122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1004125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004147 */     // MIs[0] policy
     /* 1004147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004157 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1004160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004179 */     // GIR_Coverage, 5101,
     /* 1004179 */     GIR_EraseRootFromParent_Done,
     /* 1004180 */   // Label 14947: @1004180
     /* 1004180 */   GIM_Try, /*On fail goto*//*Label 14948*/ GIMT_Encode4(1004257), // Rule ID 5104 //
     /* 1004185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1004196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1004199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1004202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004224 */     // MIs[0] policy
     /* 1004224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1004237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004256 */     // GIR_Coverage, 5104,
     /* 1004256 */     GIR_EraseRootFromParent_Done,
     /* 1004257 */   // Label 14948: @1004257
     /* 1004257 */   GIM_Try, /*On fail goto*//*Label 14949*/ GIMT_Encode4(1004334), // Rule ID 5105 //
     /* 1004262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1004273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1004276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1004279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004301 */     // MIs[0] policy
     /* 1004301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1004314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004320 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004333 */     // GIR_Coverage, 5105,
     /* 1004333 */     GIR_EraseRootFromParent_Done,
     /* 1004334 */   // Label 14949: @1004334
     /* 1004334 */   GIM_Try, /*On fail goto*//*Label 14950*/ GIMT_Encode4(1004411), // Rule ID 5108 //
     /* 1004339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1004356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004378 */     // MIs[0] policy
     /* 1004378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004388 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1004391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004410 */     // GIR_Coverage, 5108,
     /* 1004410 */     GIR_EraseRootFromParent_Done,
     /* 1004411 */   // Label 14950: @1004411
     /* 1004411 */   GIM_Try, /*On fail goto*//*Label 14951*/ GIMT_Encode4(1004488), // Rule ID 5109 //
     /* 1004416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1004433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004455 */     // MIs[0] policy
     /* 1004455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004465 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1004468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004474 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004487 */     // GIR_Coverage, 5109,
     /* 1004487 */     GIR_EraseRootFromParent_Done,
     /* 1004488 */   // Label 14951: @1004488
     /* 1004488 */   GIM_Try, /*On fail goto*//*Label 14952*/ GIMT_Encode4(1004565), // Rule ID 5112 //
     /* 1004493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1004510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004532 */     // MIs[0] policy
     /* 1004532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004542 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1004545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004564 */     // GIR_Coverage, 5112,
     /* 1004564 */     GIR_EraseRootFromParent_Done,
     /* 1004565 */   // Label 14952: @1004565
     /* 1004565 */   GIM_Try, /*On fail goto*//*Label 14953*/ GIMT_Encode4(1004642), // Rule ID 5113 //
     /* 1004570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1004587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004609 */     // MIs[0] policy
     /* 1004609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004619 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1004622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004641 */     // GIR_Coverage, 5113,
     /* 1004641 */     GIR_EraseRootFromParent_Done,
     /* 1004642 */   // Label 14953: @1004642
     /* 1004642 */   GIM_Try, /*On fail goto*//*Label 14954*/ GIMT_Encode4(1004719), // Rule ID 5116 //
     /* 1004647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1004658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1004661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1004664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004686 */     // MIs[0] policy
     /* 1004686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004696 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1004699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004718 */     // GIR_Coverage, 5116,
     /* 1004718 */     GIR_EraseRootFromParent_Done,
     /* 1004719 */   // Label 14954: @1004719
     /* 1004719 */   GIM_Try, /*On fail goto*//*Label 14955*/ GIMT_Encode4(1004796), // Rule ID 5117 //
     /* 1004724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1004735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1004738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1004741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004763 */     // MIs[0] policy
     /* 1004763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004773 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1004776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004782 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004795 */     // GIR_Coverage, 5117,
     /* 1004795 */     GIR_EraseRootFromParent_Done,
     /* 1004796 */   // Label 14955: @1004796
     /* 1004796 */   GIM_Try, /*On fail goto*//*Label 14956*/ GIMT_Encode4(1004873), // Rule ID 5120 //
     /* 1004801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1004812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1004815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004840 */     // MIs[0] policy
     /* 1004840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1004853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004872 */     // GIR_Coverage, 5120,
     /* 1004872 */     GIR_EraseRootFromParent_Done,
     /* 1004873 */   // Label 14956: @1004873
     /* 1004873 */   GIM_Try, /*On fail goto*//*Label 14957*/ GIMT_Encode4(1004950), // Rule ID 5121 //
     /* 1004878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1004889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1004892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004917 */     // MIs[0] policy
     /* 1004917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1004930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004936 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004949 */     // GIR_Coverage, 5121,
     /* 1004949 */     GIR_EraseRootFromParent_Done,
     /* 1004950 */   // Label 14957: @1004950
     /* 1004950 */   GIM_Try, /*On fail goto*//*Label 14958*/ GIMT_Encode4(1005027), // Rule ID 5124 //
     /* 1004955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004994 */     // MIs[0] policy
     /* 1004994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005004 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1005007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005026 */     // GIR_Coverage, 5124,
     /* 1005026 */     GIR_EraseRootFromParent_Done,
     /* 1005027 */   // Label 14958: @1005027
     /* 1005027 */   GIM_Try, /*On fail goto*//*Label 14959*/ GIMT_Encode4(1005104), // Rule ID 5125 //
     /* 1005032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1005035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1005043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1005046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1005049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1005052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1005059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005071 */     // MIs[0] policy
     /* 1005071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005081 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1005084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005103 */     // GIR_Coverage, 5125,
     /* 1005103 */     GIR_EraseRootFromParent_Done,
     /* 1005104 */   // Label 14959: @1005104
     /* 1005104 */   GIM_Try, /*On fail goto*//*Label 14960*/ GIMT_Encode4(1005181), // Rule ID 5128 //
     /* 1005109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1005112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1005120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1005123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1005126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1005129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005148 */     // MIs[0] policy
     /* 1005148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1005161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005180 */     // GIR_Coverage, 5128,
     /* 1005180 */     GIR_EraseRootFromParent_Done,
     /* 1005181 */   // Label 14960: @1005181
     /* 1005181 */   GIM_Try, /*On fail goto*//*Label 14961*/ GIMT_Encode4(1005258), // Rule ID 5129 //
     /* 1005186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1005189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1005197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1005200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1005203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1005206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005225 */     // MIs[0] policy
     /* 1005225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005235 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1005238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005257 */     // GIR_Coverage, 5129,
     /* 1005257 */     GIR_EraseRootFromParent_Done,
     /* 1005258 */   // Label 14961: @1005258
     /* 1005258 */   GIM_Try, /*On fail goto*//*Label 14962*/ GIMT_Encode4(1005335), // Rule ID 12740 //
     /* 1005263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1005274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1005277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1005280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1005283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005302 */     // MIs[0] policy
     /* 1005302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005312 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1005315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005334 */     // GIR_Coverage, 12740,
     /* 1005334 */     GIR_EraseRootFromParent_Done,
     /* 1005335 */   // Label 14962: @1005335
     /* 1005335 */   GIM_Try, /*On fail goto*//*Label 14963*/ GIMT_Encode4(1005412), // Rule ID 12741 //
     /* 1005340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1005351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1005354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1005357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1005360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005379 */     // MIs[0] policy
     /* 1005379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005389 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1005392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005411 */     // GIR_Coverage, 12741,
     /* 1005411 */     GIR_EraseRootFromParent_Done,
     /* 1005412 */   // Label 14963: @1005412
     /* 1005412 */   GIM_Try, /*On fail goto*//*Label 14964*/ GIMT_Encode4(1005489), // Rule ID 12744 //
     /* 1005417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1005428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1005431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1005434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1005437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005456 */     // MIs[0] policy
     /* 1005456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005466 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005488 */     // GIR_Coverage, 12744,
     /* 1005488 */     GIR_EraseRootFromParent_Done,
     /* 1005489 */   // Label 14964: @1005489
     /* 1005489 */   GIM_Try, /*On fail goto*//*Label 14965*/ GIMT_Encode4(1005566), // Rule ID 12745 //
     /* 1005494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1005505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1005508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1005511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1005514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005533 */     // MIs[0] policy
     /* 1005533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005543 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005565 */     // GIR_Coverage, 12745,
     /* 1005565 */     GIR_EraseRootFromParent_Done,
     /* 1005566 */   // Label 14965: @1005566
     /* 1005566 */   GIM_Try, /*On fail goto*//*Label 14966*/ GIMT_Encode4(1005643), // Rule ID 12748 //
     /* 1005571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1005582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1005585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1005588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1005591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005610 */     // MIs[0] policy
     /* 1005610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005620 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1005623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005642 */     // GIR_Coverage, 12748,
     /* 1005642 */     GIR_EraseRootFromParent_Done,
     /* 1005643 */   // Label 14966: @1005643
     /* 1005643 */   GIM_Try, /*On fail goto*//*Label 14967*/ GIMT_Encode4(1005720), // Rule ID 12749 //
     /* 1005648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1005659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1005662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1005665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1005668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005687 */     // MIs[0] policy
     /* 1005687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005697 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1005700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005719 */     // GIR_Coverage, 12749,
     /* 1005719 */     GIR_EraseRootFromParent_Done,
     /* 1005720 */   // Label 14967: @1005720
     /* 1005720 */   GIM_Try, /*On fail goto*//*Label 14968*/ GIMT_Encode4(1005797), // Rule ID 12752 //
     /* 1005725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1005736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1005739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1005742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1005745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005764 */     // MIs[0] policy
     /* 1005764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005774 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005796 */     // GIR_Coverage, 12752,
     /* 1005796 */     GIR_EraseRootFromParent_Done,
     /* 1005797 */   // Label 14968: @1005797
     /* 1005797 */   GIM_Try, /*On fail goto*//*Label 14969*/ GIMT_Encode4(1005874), // Rule ID 12753 //
     /* 1005802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1005813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1005816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1005819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1005822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005841 */     // MIs[0] policy
     /* 1005841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005851 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005873 */     // GIR_Coverage, 12753,
     /* 1005873 */     GIR_EraseRootFromParent_Done,
     /* 1005874 */   // Label 14969: @1005874
     /* 1005874 */   GIM_Try, /*On fail goto*//*Label 14970*/ GIMT_Encode4(1005951), // Rule ID 12756 //
     /* 1005879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1005890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1005893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1005896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1005899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005918 */     // MIs[0] policy
     /* 1005918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005928 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005950 */     // GIR_Coverage, 12756,
     /* 1005950 */     GIR_EraseRootFromParent_Done,
     /* 1005951 */   // Label 14970: @1005951
     /* 1005951 */   GIM_Try, /*On fail goto*//*Label 14971*/ GIMT_Encode4(1006028), // Rule ID 12757 //
     /* 1005956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1005967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1005970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1005973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1005976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005995 */     // MIs[0] policy
     /* 1005995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006005 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1006008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006027 */     // GIR_Coverage, 12757,
     /* 1006027 */     GIR_EraseRootFromParent_Done,
     /* 1006028 */   // Label 14971: @1006028
     /* 1006028 */   GIM_Try, /*On fail goto*//*Label 14972*/ GIMT_Encode4(1006105), // Rule ID 12760 //
     /* 1006033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1006044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1006047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1006050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1006053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006072 */     // MIs[0] policy
     /* 1006072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006082 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006104 */     // GIR_Coverage, 12760,
     /* 1006104 */     GIR_EraseRootFromParent_Done,
     /* 1006105 */   // Label 14972: @1006105
     /* 1006105 */   GIM_Try, /*On fail goto*//*Label 14973*/ GIMT_Encode4(1006182), // Rule ID 12761 //
     /* 1006110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1006121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1006124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1006127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1006130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006149 */     // MIs[0] policy
     /* 1006149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006159 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006181 */     // GIR_Coverage, 12761,
     /* 1006181 */     GIR_EraseRootFromParent_Done,
     /* 1006182 */   // Label 14973: @1006182
     /* 1006182 */   GIM_Try, /*On fail goto*//*Label 14974*/ GIMT_Encode4(1006259), // Rule ID 12764 //
     /* 1006187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1006198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1006201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1006204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1006207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006226 */     // MIs[0] policy
     /* 1006226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006236 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006258 */     // GIR_Coverage, 12764,
     /* 1006258 */     GIR_EraseRootFromParent_Done,
     /* 1006259 */   // Label 14974: @1006259
     /* 1006259 */   GIM_Try, /*On fail goto*//*Label 14975*/ GIMT_Encode4(1006336), // Rule ID 12765 //
     /* 1006264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1006275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1006278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1006281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1006284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006303 */     // MIs[0] policy
     /* 1006303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006313 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006335 */     // GIR_Coverage, 12765,
     /* 1006335 */     GIR_EraseRootFromParent_Done,
     /* 1006336 */   // Label 14975: @1006336
     /* 1006336 */   GIM_Try, /*On fail goto*//*Label 14976*/ GIMT_Encode4(1006413), // Rule ID 12768 //
     /* 1006341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1006352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1006355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1006358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1006361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006380 */     // MIs[0] policy
     /* 1006380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006412 */     // GIR_Coverage, 12768,
     /* 1006412 */     GIR_EraseRootFromParent_Done,
     /* 1006413 */   // Label 14976: @1006413
     /* 1006413 */   GIM_Try, /*On fail goto*//*Label 14977*/ GIMT_Encode4(1006490), // Rule ID 12769 //
     /* 1006418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1006429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1006432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1006435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1006438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006457 */     // MIs[0] policy
     /* 1006457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006467 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006489 */     // GIR_Coverage, 12769,
     /* 1006489 */     GIR_EraseRootFromParent_Done,
     /* 1006490 */   // Label 14977: @1006490
     /* 1006490 */   GIM_Try, /*On fail goto*//*Label 14978*/ GIMT_Encode4(1006567), // Rule ID 12772 //
     /* 1006495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1006498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1006512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1006515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006534 */     // MIs[0] policy
     /* 1006534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006566 */     // GIR_Coverage, 12772,
     /* 1006566 */     GIR_EraseRootFromParent_Done,
     /* 1006567 */   // Label 14978: @1006567
     /* 1006567 */   GIM_Try, /*On fail goto*//*Label 14979*/ GIMT_Encode4(1006644), // Rule ID 12773 //
     /* 1006572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1006575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1006589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1006592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006611 */     // MIs[0] policy
     /* 1006611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006621 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006643 */     // GIR_Coverage, 12773,
     /* 1006643 */     GIR_EraseRootFromParent_Done,
     /* 1006644 */   // Label 14979: @1006644
     /* 1006644 */   GIM_Try, /*On fail goto*//*Label 14980*/ GIMT_Encode4(1006721), // Rule ID 12776 //
     /* 1006649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1006660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1006663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1006666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1006669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006688 */     // MIs[0] policy
     /* 1006688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006720 */     // GIR_Coverage, 12776,
     /* 1006720 */     GIR_EraseRootFromParent_Done,
     /* 1006721 */   // Label 14980: @1006721
     /* 1006721 */   GIM_Try, /*On fail goto*//*Label 14981*/ GIMT_Encode4(1006798), // Rule ID 12777 //
     /* 1006726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1006737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1006740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1006743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1006746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006765 */     // MIs[0] policy
     /* 1006765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006775 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006797 */     // GIR_Coverage, 12777,
     /* 1006797 */     GIR_EraseRootFromParent_Done,
     /* 1006798 */   // Label 14981: @1006798
     /* 1006798 */   GIM_Try, /*On fail goto*//*Label 14982*/ GIMT_Encode4(1006875), // Rule ID 12780 //
     /* 1006803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1006814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1006817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1006820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1006823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006842 */     // MIs[0] policy
     /* 1006842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006852 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006874 */     // GIR_Coverage, 12780,
     /* 1006874 */     GIR_EraseRootFromParent_Done,
     /* 1006875 */   // Label 14982: @1006875
     /* 1006875 */   GIM_Try, /*On fail goto*//*Label 14983*/ GIMT_Encode4(1006952), // Rule ID 12781 //
     /* 1006880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1006891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1006894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1006897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1006900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006919 */     // MIs[0] policy
     /* 1006919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006929 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006951 */     // GIR_Coverage, 12781,
     /* 1006951 */     GIR_EraseRootFromParent_Done,
     /* 1006952 */   // Label 14983: @1006952
     /* 1006952 */   GIM_Try, /*On fail goto*//*Label 14984*/ GIMT_Encode4(1007029), // Rule ID 12784 //
     /* 1006957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1006968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1006971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1006974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1006977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006996 */     // MIs[0] policy
     /* 1006996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007006 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007028 */     // GIR_Coverage, 12784,
     /* 1007028 */     GIR_EraseRootFromParent_Done,
     /* 1007029 */   // Label 14984: @1007029
     /* 1007029 */   GIM_Try, /*On fail goto*//*Label 14985*/ GIMT_Encode4(1007106), // Rule ID 12785 //
     /* 1007034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1007045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1007048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1007051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1007054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007073 */     // MIs[0] policy
     /* 1007073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007083 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007105 */     // GIR_Coverage, 12785,
     /* 1007105 */     GIR_EraseRootFromParent_Done,
     /* 1007106 */   // Label 14985: @1007106
     /* 1007106 */   GIM_Try, /*On fail goto*//*Label 14986*/ GIMT_Encode4(1007183), // Rule ID 12788 //
     /* 1007111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1007122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1007125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1007128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1007131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007150 */     // MIs[0] policy
     /* 1007150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007182 */     // GIR_Coverage, 12788,
     /* 1007182 */     GIR_EraseRootFromParent_Done,
     /* 1007183 */   // Label 14986: @1007183
     /* 1007183 */   GIM_Try, /*On fail goto*//*Label 14987*/ GIMT_Encode4(1007260), // Rule ID 12789 //
     /* 1007188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1007199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1007202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1007205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1007208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007227 */     // MIs[0] policy
     /* 1007227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007237 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007259 */     // GIR_Coverage, 12789,
     /* 1007259 */     GIR_EraseRootFromParent_Done,
     /* 1007260 */   // Label 14987: @1007260
     /* 1007260 */   GIM_Try, /*On fail goto*//*Label 14988*/ GIMT_Encode4(1007337), // Rule ID 12792 //
     /* 1007265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1007276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1007279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1007282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1007285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007304 */     // MIs[0] policy
     /* 1007304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007314 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007336 */     // GIR_Coverage, 12792,
     /* 1007336 */     GIR_EraseRootFromParent_Done,
     /* 1007337 */   // Label 14988: @1007337
     /* 1007337 */   GIM_Try, /*On fail goto*//*Label 14989*/ GIMT_Encode4(1007414), // Rule ID 12793 //
     /* 1007342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1007353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1007356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1007359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1007362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007381 */     // MIs[0] policy
     /* 1007381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007391 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007413 */     // GIR_Coverage, 12793,
     /* 1007413 */     GIR_EraseRootFromParent_Done,
     /* 1007414 */   // Label 14989: @1007414
     /* 1007414 */   GIM_Try, /*On fail goto*//*Label 14990*/ GIMT_Encode4(1007491), // Rule ID 12796 //
     /* 1007419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1007430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1007433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1007436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1007439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007458 */     // MIs[0] policy
     /* 1007458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007468 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007490 */     // GIR_Coverage, 12796,
     /* 1007490 */     GIR_EraseRootFromParent_Done,
     /* 1007491 */   // Label 14990: @1007491
     /* 1007491 */   GIM_Try, /*On fail goto*//*Label 14991*/ GIMT_Encode4(1007568), // Rule ID 12797 //
     /* 1007496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1007507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1007510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1007513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1007516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007535 */     // MIs[0] policy
     /* 1007535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007545 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007567 */     // GIR_Coverage, 12797,
     /* 1007567 */     GIR_EraseRootFromParent_Done,
     /* 1007568 */   // Label 14991: @1007568
     /* 1007568 */   GIM_Try, /*On fail goto*//*Label 14992*/ GIMT_Encode4(1007645), // Rule ID 12800 //
     /* 1007573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1007584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1007587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1007590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1007593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007612 */     // MIs[0] policy
     /* 1007612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007622 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007644 */     // GIR_Coverage, 12800,
     /* 1007644 */     GIR_EraseRootFromParent_Done,
     /* 1007645 */   // Label 14992: @1007645
     /* 1007645 */   GIM_Try, /*On fail goto*//*Label 14993*/ GIMT_Encode4(1007722), // Rule ID 12801 //
     /* 1007650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1007661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1007664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1007667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1007670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007689 */     // MIs[0] policy
     /* 1007689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007699 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007721 */     // GIR_Coverage, 12801,
     /* 1007721 */     GIR_EraseRootFromParent_Done,
     /* 1007722 */   // Label 14993: @1007722
     /* 1007722 */   GIM_Try, /*On fail goto*//*Label 14994*/ GIMT_Encode4(1007799), // Rule ID 12804 //
     /* 1007727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1007738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1007741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1007744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1007747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007766 */     // MIs[0] policy
     /* 1007766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007798 */     // GIR_Coverage, 12804,
     /* 1007798 */     GIR_EraseRootFromParent_Done,
     /* 1007799 */   // Label 14994: @1007799
     /* 1007799 */   GIM_Try, /*On fail goto*//*Label 14995*/ GIMT_Encode4(1007876), // Rule ID 12805 //
     /* 1007804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1007815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1007818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1007821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1007824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007843 */     // MIs[0] policy
     /* 1007843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007853 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007875 */     // GIR_Coverage, 12805,
     /* 1007875 */     GIR_EraseRootFromParent_Done,
     /* 1007876 */   // Label 14995: @1007876
     /* 1007876 */   GIM_Try, /*On fail goto*//*Label 14996*/ GIMT_Encode4(1007953), // Rule ID 12808 //
     /* 1007881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1007892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1007895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1007898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1007901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007920 */     // MIs[0] policy
     /* 1007920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007930 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007952 */     // GIR_Coverage, 12808,
     /* 1007952 */     GIR_EraseRootFromParent_Done,
     /* 1007953 */   // Label 14996: @1007953
     /* 1007953 */   GIM_Try, /*On fail goto*//*Label 14997*/ GIMT_Encode4(1008030), // Rule ID 12809 //
     /* 1007958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1007969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1007972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1007975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1007978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007997 */     // MIs[0] policy
     /* 1007997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008007 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1008010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008029 */     // GIR_Coverage, 12809,
     /* 1008029 */     GIR_EraseRootFromParent_Done,
     /* 1008030 */   // Label 14997: @1008030
     /* 1008030 */   GIM_Try, /*On fail goto*//*Label 14998*/ GIMT_Encode4(1008107), // Rule ID 12812 //
     /* 1008035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1008038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1008046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1008049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1008052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1008055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008074 */     // MIs[0] policy
     /* 1008074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1008087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008106 */     // GIR_Coverage, 12812,
     /* 1008106 */     GIR_EraseRootFromParent_Done,
     /* 1008107 */   // Label 14998: @1008107
     /* 1008107 */   GIM_Try, /*On fail goto*//*Label 14999*/ GIMT_Encode4(1008184), // Rule ID 12813 //
     /* 1008112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1008115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1008123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1008126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1008129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1008132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008151 */     // MIs[0] policy
     /* 1008151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1008164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008183 */     // GIR_Coverage, 12813,
     /* 1008183 */     GIR_EraseRootFromParent_Done,
     /* 1008184 */   // Label 14999: @1008184
     /* 1008184 */   GIM_Try, /*On fail goto*//*Label 15000*/ GIMT_Encode4(1008261), // Rule ID 12816 //
     /* 1008189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1008192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1008200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1008203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1008206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1008209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008228 */     // MIs[0] policy
     /* 1008228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008238 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1008241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008260 */     // GIR_Coverage, 12816,
     /* 1008260 */     GIR_EraseRootFromParent_Done,
     /* 1008261 */   // Label 15000: @1008261
     /* 1008261 */   GIM_Try, /*On fail goto*//*Label 15001*/ GIMT_Encode4(1008338), // Rule ID 12817 //
     /* 1008266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1008269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1008277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1008280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1008283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1008286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008305 */     // MIs[0] policy
     /* 1008305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008315 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1008318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008337 */     // GIR_Coverage, 12817,
     /* 1008337 */     GIR_EraseRootFromParent_Done,
     /* 1008338 */   // Label 15001: @1008338
     /* 1008338 */   GIM_Try, /*On fail goto*//*Label 15002*/ GIMT_Encode4(1008415), // Rule ID 12820 //
     /* 1008343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1008346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1008354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1008357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1008360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1008363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008382 */     // MIs[0] policy
     /* 1008382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008392 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1008395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008414 */     // GIR_Coverage, 12820,
     /* 1008414 */     GIR_EraseRootFromParent_Done,
     /* 1008415 */   // Label 15002: @1008415
     /* 1008415 */   GIM_Try, /*On fail goto*//*Label 15003*/ GIMT_Encode4(1008492), // Rule ID 12821 //
     /* 1008420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1008423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1008431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1008434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1008437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1008440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008459 */     // MIs[0] policy
     /* 1008459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008469 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1008472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008491 */     // GIR_Coverage, 12821,
     /* 1008491 */     GIR_EraseRootFromParent_Done,
     /* 1008492 */   // Label 15003: @1008492
     /* 1008492 */   GIM_Try, /*On fail goto*//*Label 15004*/ GIMT_Encode4(1008569), // Rule ID 12824 //
     /* 1008497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1008508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1008511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1008517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008536 */     // MIs[0] policy
     /* 1008536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008546 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1008549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008568 */     // GIR_Coverage, 12824,
     /* 1008568 */     GIR_EraseRootFromParent_Done,
     /* 1008569 */   // Label 15004: @1008569
     /* 1008569 */   GIM_Try, /*On fail goto*//*Label 15005*/ GIMT_Encode4(1008646), // Rule ID 12825 //
     /* 1008574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1008585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1008588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1008594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008613 */     // MIs[0] policy
     /* 1008613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008623 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1008626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008645 */     // GIR_Coverage, 12825,
     /* 1008645 */     GIR_EraseRootFromParent_Done,
     /* 1008646 */   // Label 15005: @1008646
     /* 1008646 */   GIM_Try, /*On fail goto*//*Label 15006*/ GIMT_Encode4(1008723), // Rule ID 12828 //
     /* 1008651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1008662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1008665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1008671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008690 */     // MIs[0] policy
     /* 1008690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008700 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008722 */     // GIR_Coverage, 12828,
     /* 1008722 */     GIR_EraseRootFromParent_Done,
     /* 1008723 */   // Label 15006: @1008723
     /* 1008723 */   GIM_Try, /*On fail goto*//*Label 15007*/ GIMT_Encode4(1008800), // Rule ID 12829 //
     /* 1008728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1008739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1008742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1008748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008767 */     // MIs[0] policy
     /* 1008767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008777 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008799 */     // GIR_Coverage, 12829,
     /* 1008799 */     GIR_EraseRootFromParent_Done,
     /* 1008800 */   // Label 15007: @1008800
     /* 1008800 */   GIM_Try, /*On fail goto*//*Label 15008*/ GIMT_Encode4(1008877), // Rule ID 12832 //
     /* 1008805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1008816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1008819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1008825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008844 */     // MIs[0] policy
     /* 1008844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008854 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008876 */     // GIR_Coverage, 12832,
     /* 1008876 */     GIR_EraseRootFromParent_Done,
     /* 1008877 */   // Label 15008: @1008877
     /* 1008877 */   GIM_Try, /*On fail goto*//*Label 15009*/ GIMT_Encode4(1008954), // Rule ID 12833 //
     /* 1008882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1008893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1008896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1008902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008921 */     // MIs[0] policy
     /* 1008921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008931 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008953 */     // GIR_Coverage, 12833,
     /* 1008953 */     GIR_EraseRootFromParent_Done,
     /* 1008954 */   // Label 15009: @1008954
     /* 1008954 */   GIM_Try, /*On fail goto*//*Label 15010*/ GIMT_Encode4(1009031), // Rule ID 12836 //
     /* 1008959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1008970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1008973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1008979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008998 */     // MIs[0] policy
     /* 1008998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009008 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1009011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009030 */     // GIR_Coverage, 12836,
     /* 1009030 */     GIR_EraseRootFromParent_Done,
     /* 1009031 */   // Label 15010: @1009031
     /* 1009031 */   GIM_Try, /*On fail goto*//*Label 15011*/ GIMT_Encode4(1009108), // Rule ID 12837 //
     /* 1009036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1009047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1009050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1009056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009075 */     // MIs[0] policy
     /* 1009075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009085 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1009088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009107 */     // GIR_Coverage, 12837,
     /* 1009107 */     GIR_EraseRootFromParent_Done,
     /* 1009108 */   // Label 15011: @1009108
     /* 1009108 */   GIM_Try, /*On fail goto*//*Label 15012*/ GIMT_Encode4(1009185), // Rule ID 12840 //
     /* 1009113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1009124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1009127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1009133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009152 */     // MIs[0] policy
     /* 1009152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009162 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1009165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009184 */     // GIR_Coverage, 12840,
     /* 1009184 */     GIR_EraseRootFromParent_Done,
     /* 1009185 */   // Label 15012: @1009185
     /* 1009185 */   GIM_Try, /*On fail goto*//*Label 15013*/ GIMT_Encode4(1009262), // Rule ID 12841 //
     /* 1009190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1009201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1009204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1009210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009229 */     // MIs[0] policy
     /* 1009229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009239 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1009242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009261 */     // GIR_Coverage, 12841,
     /* 1009261 */     GIR_EraseRootFromParent_Done,
     /* 1009262 */   // Label 15013: @1009262
     /* 1009262 */   GIM_Try, /*On fail goto*//*Label 15014*/ GIMT_Encode4(1009339), // Rule ID 12844 //
     /* 1009267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1009278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1009281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1009287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009306 */     // MIs[0] policy
     /* 1009306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009316 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1009319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009338 */     // GIR_Coverage, 12844,
     /* 1009338 */     GIR_EraseRootFromParent_Done,
     /* 1009339 */   // Label 15014: @1009339
     /* 1009339 */   GIM_Try, /*On fail goto*//*Label 15015*/ GIMT_Encode4(1009416), // Rule ID 12845 //
     /* 1009344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1009355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1009358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1009364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009383 */     // MIs[0] policy
     /* 1009383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009393 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1009396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009415 */     // GIR_Coverage, 12845,
     /* 1009415 */     GIR_EraseRootFromParent_Done,
     /* 1009416 */   // Label 15015: @1009416
     /* 1009416 */   GIM_Try, /*On fail goto*//*Label 15016*/ GIMT_Encode4(1009493), // Rule ID 12848 //
     /* 1009421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1009432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1009435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1009441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009460 */     // MIs[0] policy
     /* 1009460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009492 */     // GIR_Coverage, 12848,
     /* 1009492 */     GIR_EraseRootFromParent_Done,
     /* 1009493 */   // Label 15016: @1009493
     /* 1009493 */   GIM_Try, /*On fail goto*//*Label 15017*/ GIMT_Encode4(1009570), // Rule ID 12849 //
     /* 1009498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1009509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1009512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1009518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009537 */     // MIs[0] policy
     /* 1009537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009547 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009569 */     // GIR_Coverage, 12849,
     /* 1009569 */     GIR_EraseRootFromParent_Done,
     /* 1009570 */   // Label 15017: @1009570
     /* 1009570 */   GIM_Try, /*On fail goto*//*Label 15018*/ GIMT_Encode4(1009647), // Rule ID 12852 //
     /* 1009575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1009586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1009589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1009595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009614 */     // MIs[0] policy
     /* 1009614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009646 */     // GIR_Coverage, 12852,
     /* 1009646 */     GIR_EraseRootFromParent_Done,
     /* 1009647 */   // Label 15018: @1009647
     /* 1009647 */   GIM_Try, /*On fail goto*//*Label 15019*/ GIMT_Encode4(1009724), // Rule ID 12853 //
     /* 1009652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1009663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1009666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1009672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009691 */     // MIs[0] policy
     /* 1009691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009701 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009723 */     // GIR_Coverage, 12853,
     /* 1009723 */     GIR_EraseRootFromParent_Done,
     /* 1009724 */   // Label 15019: @1009724
     /* 1009724 */   GIM_Try, /*On fail goto*//*Label 15020*/ GIMT_Encode4(1009801), // Rule ID 12856 //
     /* 1009729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1009740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1009743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1009749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009768 */     // MIs[0] policy
     /* 1009768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009778 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009800 */     // GIR_Coverage, 12856,
     /* 1009800 */     GIR_EraseRootFromParent_Done,
     /* 1009801 */   // Label 15020: @1009801
     /* 1009801 */   GIM_Try, /*On fail goto*//*Label 15021*/ GIMT_Encode4(1009878), // Rule ID 12857 //
     /* 1009806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1009817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1009820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1009826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009845 */     // MIs[0] policy
     /* 1009845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009855 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009877 */     // GIR_Coverage, 12857,
     /* 1009877 */     GIR_EraseRootFromParent_Done,
     /* 1009878 */   // Label 15021: @1009878
     /* 1009878 */   GIM_Try, /*On fail goto*//*Label 15022*/ GIMT_Encode4(1009955), // Rule ID 12860 //
     /* 1009883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1009886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1009894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1009897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1009903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009922 */     // MIs[0] policy
     /* 1009922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009932 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1009951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009954 */     // GIR_Coverage, 12860,
     /* 1009954 */     GIR_EraseRootFromParent_Done,
     /* 1009955 */   // Label 15022: @1009955
     /* 1009955 */   GIM_Try, /*On fail goto*//*Label 15023*/ GIMT_Encode4(1010032), // Rule ID 12861 //
     /* 1009960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1009963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1009971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1009974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1009980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009999 */     // MIs[0] policy
     /* 1009999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010009 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1010012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1010028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010031 */     // GIR_Coverage, 12861,
     /* 1010031 */     GIR_EraseRootFromParent_Done,
     /* 1010032 */   // Label 15023: @1010032
     /* 1010032 */   GIM_Try, /*On fail goto*//*Label 15024*/ GIMT_Encode4(1010109), // Rule ID 12864 //
     /* 1010037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1010048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1010051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1010057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010076 */     // MIs[0] policy
     /* 1010076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010086 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010108 */     // GIR_Coverage, 12864,
     /* 1010108 */     GIR_EraseRootFromParent_Done,
     /* 1010109 */   // Label 15024: @1010109
     /* 1010109 */   GIM_Try, /*On fail goto*//*Label 15025*/ GIMT_Encode4(1010186), // Rule ID 12865 //
     /* 1010114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1010125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1010128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1010134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010153 */     // MIs[0] policy
     /* 1010153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010163 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010185 */     // GIR_Coverage, 12865,
     /* 1010185 */     GIR_EraseRootFromParent_Done,
     /* 1010186 */   // Label 15025: @1010186
     /* 1010186 */   GIM_Try, /*On fail goto*//*Label 15026*/ GIMT_Encode4(1010263), // Rule ID 12868 //
     /* 1010191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1010202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1010205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1010211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010230 */     // MIs[0] policy
     /* 1010230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010240 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010262 */     // GIR_Coverage, 12868,
     /* 1010262 */     GIR_EraseRootFromParent_Done,
     /* 1010263 */   // Label 15026: @1010263
     /* 1010263 */   GIM_Try, /*On fail goto*//*Label 15027*/ GIMT_Encode4(1010340), // Rule ID 12869 //
     /* 1010268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1010279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1010282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1010288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010307 */     // MIs[0] policy
     /* 1010307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010317 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010339 */     // GIR_Coverage, 12869,
     /* 1010339 */     GIR_EraseRootFromParent_Done,
     /* 1010340 */   // Label 15027: @1010340
     /* 1010340 */   GIM_Try, /*On fail goto*//*Label 15028*/ GIMT_Encode4(1010417), // Rule ID 12872 //
     /* 1010345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1010356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1010359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1010365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010384 */     // MIs[0] policy
     /* 1010384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010394 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010416 */     // GIR_Coverage, 12872,
     /* 1010416 */     GIR_EraseRootFromParent_Done,
     /* 1010417 */   // Label 15028: @1010417
     /* 1010417 */   GIM_Try, /*On fail goto*//*Label 15029*/ GIMT_Encode4(1010494), // Rule ID 12873 //
     /* 1010422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1010433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1010436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1010442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010461 */     // MIs[0] policy
     /* 1010461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010471 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010493 */     // GIR_Coverage, 12873,
     /* 1010493 */     GIR_EraseRootFromParent_Done,
     /* 1010494 */   // Label 15029: @1010494
     /* 1010494 */   GIM_Try, /*On fail goto*//*Label 15030*/ GIMT_Encode4(1010571), // Rule ID 12876 //
     /* 1010499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1010519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010538 */     // MIs[0] policy
     /* 1010538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010548 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010570 */     // GIR_Coverage, 12876,
     /* 1010570 */     GIR_EraseRootFromParent_Done,
     /* 1010571 */   // Label 15030: @1010571
     /* 1010571 */   GIM_Try, /*On fail goto*//*Label 15031*/ GIMT_Encode4(1010648), // Rule ID 12877 //
     /* 1010576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1010596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010615 */     // MIs[0] policy
     /* 1010615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010625 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010647 */     // GIR_Coverage, 12877,
     /* 1010647 */     GIR_EraseRootFromParent_Done,
     /* 1010648 */   // Label 15031: @1010648
     /* 1010648 */   GIM_Try, /*On fail goto*//*Label 15032*/ GIMT_Encode4(1010725), // Rule ID 12880 //
     /* 1010653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1010664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1010667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1010673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010692 */     // MIs[0] policy
     /* 1010692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010724 */     // GIR_Coverage, 12880,
     /* 1010724 */     GIR_EraseRootFromParent_Done,
     /* 1010725 */   // Label 15032: @1010725
     /* 1010725 */   GIM_Try, /*On fail goto*//*Label 15033*/ GIMT_Encode4(1010802), // Rule ID 12881 //
     /* 1010730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1010741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1010744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1010750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010769 */     // MIs[0] policy
     /* 1010769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010779 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010801 */     // GIR_Coverage, 12881,
     /* 1010801 */     GIR_EraseRootFromParent_Done,
     /* 1010802 */   // Label 15033: @1010802
     /* 1010802 */   GIM_Try, /*On fail goto*//*Label 15034*/ GIMT_Encode4(1010879), // Rule ID 12884 //
     /* 1010807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1010818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1010821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1010827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010846 */     // MIs[0] policy
     /* 1010846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010856 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010878 */     // GIR_Coverage, 12884,
     /* 1010878 */     GIR_EraseRootFromParent_Done,
     /* 1010879 */   // Label 15034: @1010879
     /* 1010879 */   GIM_Try, /*On fail goto*//*Label 15035*/ GIMT_Encode4(1010956), // Rule ID 12885 //
     /* 1010884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1010895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1010898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1010904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010923 */     // MIs[0] policy
     /* 1010923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010933 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010955 */     // GIR_Coverage, 12885,
     /* 1010955 */     GIR_EraseRootFromParent_Done,
     /* 1010956 */   // Label 15035: @1010956
     /* 1010956 */   GIM_Try, /*On fail goto*//*Label 15036*/ GIMT_Encode4(1011033), // Rule ID 12888 //
     /* 1010961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1010972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1010975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1010981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011000 */     // MIs[0] policy
     /* 1011000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011010 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1011013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011032 */     // GIR_Coverage, 12888,
     /* 1011032 */     GIR_EraseRootFromParent_Done,
     /* 1011033 */   // Label 15036: @1011033
     /* 1011033 */   GIM_Try, /*On fail goto*//*Label 15037*/ GIMT_Encode4(1011110), // Rule ID 12889 //
     /* 1011038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1011049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1011052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1011058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011077 */     // MIs[0] policy
     /* 1011077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011087 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1011090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011109 */     // GIR_Coverage, 12889,
     /* 1011109 */     GIR_EraseRootFromParent_Done,
     /* 1011110 */   // Label 15037: @1011110
     /* 1011110 */   GIM_Try, /*On fail goto*//*Label 15038*/ GIMT_Encode4(1011187), // Rule ID 12892 //
     /* 1011115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1011126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1011129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1011135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011154 */     // MIs[0] policy
     /* 1011154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011164 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1011167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011186 */     // GIR_Coverage, 12892,
     /* 1011186 */     GIR_EraseRootFromParent_Done,
     /* 1011187 */   // Label 15038: @1011187
     /* 1011187 */   GIM_Try, /*On fail goto*//*Label 15039*/ GIMT_Encode4(1011264), // Rule ID 12893 //
     /* 1011192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1011203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1011206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1011212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011231 */     // MIs[0] policy
     /* 1011231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011241 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1011244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011263 */     // GIR_Coverage, 12893,
     /* 1011263 */     GIR_EraseRootFromParent_Done,
     /* 1011264 */   // Label 15039: @1011264
     /* 1011264 */   GIM_Try, /*On fail goto*//*Label 15040*/ GIMT_Encode4(1011341), // Rule ID 12896 //
     /* 1011269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1011280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1011283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1011289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011308 */     // MIs[0] policy
     /* 1011308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011318 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1011321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011340 */     // GIR_Coverage, 12896,
     /* 1011340 */     GIR_EraseRootFromParent_Done,
     /* 1011341 */   // Label 15040: @1011341
     /* 1011341 */   GIM_Try, /*On fail goto*//*Label 15041*/ GIMT_Encode4(1011418), // Rule ID 12897 //
     /* 1011346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1011357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1011360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1011366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011385 */     // MIs[0] policy
     /* 1011385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011395 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1011398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011417 */     // GIR_Coverage, 12897,
     /* 1011417 */     GIR_EraseRootFromParent_Done,
     /* 1011418 */   // Label 15041: @1011418
     /* 1011418 */   GIM_Try, /*On fail goto*//*Label 15042*/ GIMT_Encode4(1011495), // Rule ID 12900 //
     /* 1011423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1011434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1011437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1011443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011462 */     // MIs[0] policy
     /* 1011462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1011475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011494 */     // GIR_Coverage, 12900,
     /* 1011494 */     GIR_EraseRootFromParent_Done,
     /* 1011495 */   // Label 15042: @1011495
     /* 1011495 */   GIM_Try, /*On fail goto*//*Label 15043*/ GIMT_Encode4(1011572), // Rule ID 12901 //
     /* 1011500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1011511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1011514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1011520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011539 */     // MIs[0] policy
     /* 1011539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011549 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1011552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011571 */     // GIR_Coverage, 12901,
     /* 1011571 */     GIR_EraseRootFromParent_Done,
     /* 1011572 */   // Label 15043: @1011572
     /* 1011572 */   GIM_Try, /*On fail goto*//*Label 15044*/ GIMT_Encode4(1011649), // Rule ID 12904 //
     /* 1011577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1011588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1011591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1011597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011616 */     // MIs[0] policy
     /* 1011616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011626 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1011629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011648 */     // GIR_Coverage, 12904,
     /* 1011648 */     GIR_EraseRootFromParent_Done,
     /* 1011649 */   // Label 15044: @1011649
     /* 1011649 */   GIM_Try, /*On fail goto*//*Label 15045*/ GIMT_Encode4(1011726), // Rule ID 12905 //
     /* 1011654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1011665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1011668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1011674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011693 */     // MIs[0] policy
     /* 1011693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011703 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1011706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011725 */     // GIR_Coverage, 12905,
     /* 1011725 */     GIR_EraseRootFromParent_Done,
     /* 1011726 */   // Label 15045: @1011726
     /* 1011726 */   GIM_Try, /*On fail goto*//*Label 15046*/ GIMT_Encode4(1011803), // Rule ID 12908 //
     /* 1011731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1011742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1011745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1011751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011770 */     // MIs[0] policy
     /* 1011770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011780 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1011783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011802 */     // GIR_Coverage, 12908,
     /* 1011802 */     GIR_EraseRootFromParent_Done,
     /* 1011803 */   // Label 15046: @1011803
     /* 1011803 */   GIM_Try, /*On fail goto*//*Label 15047*/ GIMT_Encode4(1011880), // Rule ID 12909 //
     /* 1011808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1011819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1011822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1011828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011847 */     // MIs[0] policy
     /* 1011847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011857 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1011860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011879 */     // GIR_Coverage, 12909,
     /* 1011879 */     GIR_EraseRootFromParent_Done,
     /* 1011880 */   // Label 15047: @1011880
     /* 1011880 */   GIM_Try, /*On fail goto*//*Label 15048*/ GIMT_Encode4(1011957), // Rule ID 12912 //
     /* 1011885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1011896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1011899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1011902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011924 */     // MIs[0] policy
     /* 1011924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011934 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1011937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011956 */     // GIR_Coverage, 12912,
     /* 1011956 */     GIR_EraseRootFromParent_Done,
     /* 1011957 */   // Label 15048: @1011957
     /* 1011957 */   GIM_Try, /*On fail goto*//*Label 15049*/ GIMT_Encode4(1012034), // Rule ID 12913 //
     /* 1011962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1011973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1011976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1011979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012001 */     // MIs[0] policy
     /* 1012001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012011 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1012014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012033 */     // GIR_Coverage, 12913,
     /* 1012033 */     GIR_EraseRootFromParent_Done,
     /* 1012034 */   // Label 15049: @1012034
     /* 1012034 */   GIM_Try, /*On fail goto*//*Label 15050*/ GIMT_Encode4(1012111), // Rule ID 12916 //
     /* 1012039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1012050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1012053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1012056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1012059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012078 */     // MIs[0] policy
     /* 1012078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012088 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1012091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012110 */     // GIR_Coverage, 12916,
     /* 1012110 */     GIR_EraseRootFromParent_Done,
     /* 1012111 */   // Label 15050: @1012111
     /* 1012111 */   GIM_Try, /*On fail goto*//*Label 15051*/ GIMT_Encode4(1012188), // Rule ID 12917 //
     /* 1012116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1012127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1012130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1012133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1012136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012155 */     // MIs[0] policy
     /* 1012155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012165 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1012168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012187 */     // GIR_Coverage, 12917,
     /* 1012187 */     GIR_EraseRootFromParent_Done,
     /* 1012188 */   // Label 15051: @1012188
     /* 1012188 */   GIM_Try, /*On fail goto*//*Label 15052*/ GIMT_Encode4(1012265), // Rule ID 12920 //
     /* 1012193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1012204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1012207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1012210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1012213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012232 */     // MIs[0] policy
     /* 1012232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012242 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012264 */     // GIR_Coverage, 12920,
     /* 1012264 */     GIR_EraseRootFromParent_Done,
     /* 1012265 */   // Label 15052: @1012265
     /* 1012265 */   GIM_Try, /*On fail goto*//*Label 15053*/ GIMT_Encode4(1012342), // Rule ID 12921 //
     /* 1012270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1012281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1012284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1012287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1012290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012309 */     // MIs[0] policy
     /* 1012309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012319 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012341 */     // GIR_Coverage, 12921,
     /* 1012341 */     GIR_EraseRootFromParent_Done,
     /* 1012342 */   // Label 15053: @1012342
     /* 1012342 */   GIM_Try, /*On fail goto*//*Label 15054*/ GIMT_Encode4(1012419), // Rule ID 12924 //
     /* 1012347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1012358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1012361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1012364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1012367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012386 */     // MIs[0] policy
     /* 1012386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012396 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1012399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012418 */     // GIR_Coverage, 12924,
     /* 1012418 */     GIR_EraseRootFromParent_Done,
     /* 1012419 */   // Label 15054: @1012419
     /* 1012419 */   GIM_Try, /*On fail goto*//*Label 15055*/ GIMT_Encode4(1012496), // Rule ID 12925 //
     /* 1012424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1012435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1012438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1012441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1012444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012463 */     // MIs[0] policy
     /* 1012463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012473 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1012476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012495 */     // GIR_Coverage, 12925,
     /* 1012495 */     GIR_EraseRootFromParent_Done,
     /* 1012496 */   // Label 15055: @1012496
     /* 1012496 */   GIM_Try, /*On fail goto*//*Label 15056*/ GIMT_Encode4(1012573), // Rule ID 12928 //
     /* 1012501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1012512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1012515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1012518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1012521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012540 */     // MIs[0] policy
     /* 1012540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012550 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012572 */     // GIR_Coverage, 12928,
     /* 1012572 */     GIR_EraseRootFromParent_Done,
     /* 1012573 */   // Label 15056: @1012573
     /* 1012573 */   GIM_Try, /*On fail goto*//*Label 15057*/ GIMT_Encode4(1012650), // Rule ID 12929 //
     /* 1012578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1012589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1012592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1012595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1012598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012617 */     // MIs[0] policy
     /* 1012617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012627 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012649 */     // GIR_Coverage, 12929,
     /* 1012649 */     GIR_EraseRootFromParent_Done,
     /* 1012650 */   // Label 15057: @1012650
     /* 1012650 */   GIM_Try, /*On fail goto*//*Label 15058*/ GIMT_Encode4(1012727), // Rule ID 12932 //
     /* 1012655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1012672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012694 */     // MIs[0] policy
     /* 1012694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012704 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012726 */     // GIR_Coverage, 12932,
     /* 1012726 */     GIR_EraseRootFromParent_Done,
     /* 1012727 */   // Label 15058: @1012727
     /* 1012727 */   GIM_Try, /*On fail goto*//*Label 15059*/ GIMT_Encode4(1012804), // Rule ID 12933 //
     /* 1012732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1012749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012771 */     // MIs[0] policy
     /* 1012771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012781 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012803 */     // GIR_Coverage, 12933,
     /* 1012803 */     GIR_EraseRootFromParent_Done,
     /* 1012804 */   // Label 15059: @1012804
     /* 1012804 */   GIM_Try, /*On fail goto*//*Label 15060*/ GIMT_Encode4(1012881), // Rule ID 12936 //
     /* 1012809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1012820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1012823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1012826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1012829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012848 */     // MIs[0] policy
     /* 1012848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012858 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012880 */     // GIR_Coverage, 12936,
     /* 1012880 */     GIR_EraseRootFromParent_Done,
     /* 1012881 */   // Label 15060: @1012881
     /* 1012881 */   GIM_Try, /*On fail goto*//*Label 15061*/ GIMT_Encode4(1012958), // Rule ID 12937 //
     /* 1012886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1012897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1012900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1012903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1012906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012925 */     // MIs[0] policy
     /* 1012925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012935 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012957 */     // GIR_Coverage, 12937,
     /* 1012957 */     GIR_EraseRootFromParent_Done,
     /* 1012958 */   // Label 15061: @1012958
     /* 1012958 */   GIM_Try, /*On fail goto*//*Label 15062*/ GIMT_Encode4(1013035), // Rule ID 12940 //
     /* 1012963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1012974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1012977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1012980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1012983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013002 */     // MIs[0] policy
     /* 1013002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013012 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1013015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013034 */     // GIR_Coverage, 12940,
     /* 1013034 */     GIR_EraseRootFromParent_Done,
     /* 1013035 */   // Label 15062: @1013035
     /* 1013035 */   GIM_Try, /*On fail goto*//*Label 15063*/ GIMT_Encode4(1013112), // Rule ID 12941 //
     /* 1013040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1013051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1013054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1013057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1013060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013079 */     // MIs[0] policy
     /* 1013079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013089 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1013092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013111 */     // GIR_Coverage, 12941,
     /* 1013111 */     GIR_EraseRootFromParent_Done,
     /* 1013112 */   // Label 15063: @1013112
     /* 1013112 */   GIM_Try, /*On fail goto*//*Label 15064*/ GIMT_Encode4(1013189), // Rule ID 12944 //
     /* 1013117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1013128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1013131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1013134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1013137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013156 */     // MIs[0] policy
     /* 1013156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1013169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013188 */     // GIR_Coverage, 12944,
     /* 1013188 */     GIR_EraseRootFromParent_Done,
     /* 1013189 */   // Label 15064: @1013189
     /* 1013189 */   GIM_Try, /*On fail goto*//*Label 15065*/ GIMT_Encode4(1013266), // Rule ID 12945 //
     /* 1013194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1013205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1013208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1013211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1013214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013233 */     // MIs[0] policy
     /* 1013233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013243 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1013246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013265 */     // GIR_Coverage, 12945,
     /* 1013265 */     GIR_EraseRootFromParent_Done,
     /* 1013266 */   // Label 15065: @1013266
     /* 1013266 */   GIM_Try, /*On fail goto*//*Label 15066*/ GIMT_Encode4(1013343), // Rule ID 12948 //
     /* 1013271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1013274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1013282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1013285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1013288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1013291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013310 */     // MIs[0] policy
     /* 1013310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013320 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1013323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1013339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013342 */     // GIR_Coverage, 12948,
     /* 1013342 */     GIR_EraseRootFromParent_Done,
     /* 1013343 */   // Label 15066: @1013343
     /* 1013343 */   GIM_Try, /*On fail goto*//*Label 15067*/ GIMT_Encode4(1013420), // Rule ID 12949 //
     /* 1013348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1013351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1013359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1013362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1013365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1013368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013387 */     // MIs[0] policy
     /* 1013387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013397 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1013400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1013416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013419 */     // GIR_Coverage, 12949,
     /* 1013419 */     GIR_EraseRootFromParent_Done,
     /* 1013420 */   // Label 15067: @1013420
     /* 1013420 */   GIM_Try, /*On fail goto*//*Label 15068*/ GIMT_Encode4(1013497), // Rule ID 12952 //
     /* 1013425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1013436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1013439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1013442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1013445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013464 */     // MIs[0] policy
     /* 1013464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013496 */     // GIR_Coverage, 12952,
     /* 1013496 */     GIR_EraseRootFromParent_Done,
     /* 1013497 */   // Label 15068: @1013497
     /* 1013497 */   GIM_Try, /*On fail goto*//*Label 15069*/ GIMT_Encode4(1013574), // Rule ID 12953 //
     /* 1013502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1013513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1013516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1013519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1013522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013541 */     // MIs[0] policy
     /* 1013541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013551 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013573 */     // GIR_Coverage, 12953,
     /* 1013573 */     GIR_EraseRootFromParent_Done,
     /* 1013574 */   // Label 15069: @1013574
     /* 1013574 */   GIM_Try, /*On fail goto*//*Label 15070*/ GIMT_Encode4(1013651), // Rule ID 12956 //
     /* 1013579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1013590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1013593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1013596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1013599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013618 */     // MIs[0] policy
     /* 1013618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013628 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013650 */     // GIR_Coverage, 12956,
     /* 1013650 */     GIR_EraseRootFromParent_Done,
     /* 1013651 */   // Label 15070: @1013651
     /* 1013651 */   GIM_Try, /*On fail goto*//*Label 15071*/ GIMT_Encode4(1013728), // Rule ID 12957 //
     /* 1013656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1013667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1013670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1013673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1013676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013695 */     // MIs[0] policy
     /* 1013695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013705 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013727 */     // GIR_Coverage, 12957,
     /* 1013727 */     GIR_EraseRootFromParent_Done,
     /* 1013728 */   // Label 15071: @1013728
     /* 1013728 */   GIM_Try, /*On fail goto*//*Label 15072*/ GIMT_Encode4(1013805), // Rule ID 12960 //
     /* 1013733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1013744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1013747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1013750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1013753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013772 */     // MIs[0] policy
     /* 1013772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013782 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013804 */     // GIR_Coverage, 12960,
     /* 1013804 */     GIR_EraseRootFromParent_Done,
     /* 1013805 */   // Label 15072: @1013805
     /* 1013805 */   GIM_Try, /*On fail goto*//*Label 15073*/ GIMT_Encode4(1013882), // Rule ID 12961 //
     /* 1013810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1013821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1013824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1013827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1013830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013849 */     // MIs[0] policy
     /* 1013849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013859 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013881 */     // GIR_Coverage, 12961,
     /* 1013881 */     GIR_EraseRootFromParent_Done,
     /* 1013882 */   // Label 15073: @1013882
     /* 1013882 */   GIM_Try, /*On fail goto*//*Label 15074*/ GIMT_Encode4(1013959), // Rule ID 12964 //
     /* 1013887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1013898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1013901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1013904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013926 */     // MIs[0] policy
     /* 1013926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013936 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013958 */     // GIR_Coverage, 12964,
     /* 1013958 */     GIR_EraseRootFromParent_Done,
     /* 1013959 */   // Label 15074: @1013959
     /* 1013959 */   GIM_Try, /*On fail goto*//*Label 15075*/ GIMT_Encode4(1014036), // Rule ID 12965 //
     /* 1013964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1013975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1013978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1013981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014003 */     // MIs[0] policy
     /* 1014003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014013 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014035 */     // GIR_Coverage, 12965,
     /* 1014035 */     GIR_EraseRootFromParent_Done,
     /* 1014036 */   // Label 15075: @1014036
     /* 1014036 */   GIM_Try, /*On fail goto*//*Label 15076*/ GIMT_Encode4(1014113), // Rule ID 12968 //
     /* 1014041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1014052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1014055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1014058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1014061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014080 */     // MIs[0] policy
     /* 1014080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014090 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014112 */     // GIR_Coverage, 12968,
     /* 1014112 */     GIR_EraseRootFromParent_Done,
     /* 1014113 */   // Label 15076: @1014113
     /* 1014113 */   GIM_Try, /*On fail goto*//*Label 15077*/ GIMT_Encode4(1014190), // Rule ID 12969 //
     /* 1014118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1014129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1014132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1014135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1014138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014157 */     // MIs[0] policy
     /* 1014157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014167 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014189 */     // GIR_Coverage, 12969,
     /* 1014189 */     GIR_EraseRootFromParent_Done,
     /* 1014190 */   // Label 15077: @1014190
     /* 1014190 */   GIM_Try, /*On fail goto*//*Label 15078*/ GIMT_Encode4(1014267), // Rule ID 12972 //
     /* 1014195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1014206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1014209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1014212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1014215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014234 */     // MIs[0] policy
     /* 1014234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014244 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014266 */     // GIR_Coverage, 12972,
     /* 1014266 */     GIR_EraseRootFromParent_Done,
     /* 1014267 */   // Label 15078: @1014267
     /* 1014267 */   GIM_Try, /*On fail goto*//*Label 15079*/ GIMT_Encode4(1014344), // Rule ID 12973 //
     /* 1014272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1014283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1014286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1014289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1014292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014311 */     // MIs[0] policy
     /* 1014311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014321 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014343 */     // GIR_Coverage, 12973,
     /* 1014343 */     GIR_EraseRootFromParent_Done,
     /* 1014344 */   // Label 15079: @1014344
     /* 1014344 */   GIM_Try, /*On fail goto*//*Label 15080*/ GIMT_Encode4(1014421), // Rule ID 12976 //
     /* 1014349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1014360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1014363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1014366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1014369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014388 */     // MIs[0] policy
     /* 1014388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014398 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014420 */     // GIR_Coverage, 12976,
     /* 1014420 */     GIR_EraseRootFromParent_Done,
     /* 1014421 */   // Label 15080: @1014421
     /* 1014421 */   GIM_Try, /*On fail goto*//*Label 15081*/ GIMT_Encode4(1014498), // Rule ID 12977 //
     /* 1014426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1014437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1014440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1014443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1014446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014465 */     // MIs[0] policy
     /* 1014465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014475 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014497 */     // GIR_Coverage, 12977,
     /* 1014497 */     GIR_EraseRootFromParent_Done,
     /* 1014498 */   // Label 15081: @1014498
     /* 1014498 */   GIM_Try, /*On fail goto*//*Label 15082*/ GIMT_Encode4(1014575), // Rule ID 12980 //
     /* 1014503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1014520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014542 */     // MIs[0] policy
     /* 1014542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014552 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014574 */     // GIR_Coverage, 12980,
     /* 1014574 */     GIR_EraseRootFromParent_Done,
     /* 1014575 */   // Label 15082: @1014575
     /* 1014575 */   GIM_Try, /*On fail goto*//*Label 15083*/ GIMT_Encode4(1014652), // Rule ID 12981 //
     /* 1014580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1014597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014619 */     // MIs[0] policy
     /* 1014619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014629 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014651 */     // GIR_Coverage, 12981,
     /* 1014651 */     GIR_EraseRootFromParent_Done,
     /* 1014652 */   // Label 15083: @1014652
     /* 1014652 */   GIM_Try, /*On fail goto*//*Label 15084*/ GIMT_Encode4(1014729), // Rule ID 12984 //
     /* 1014657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1014674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014696 */     // MIs[0] policy
     /* 1014696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014706 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014728 */     // GIR_Coverage, 12984,
     /* 1014728 */     GIR_EraseRootFromParent_Done,
     /* 1014729 */   // Label 15084: @1014729
     /* 1014729 */   GIM_Try, /*On fail goto*//*Label 15085*/ GIMT_Encode4(1014806), // Rule ID 12985 //
     /* 1014734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1014751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014773 */     // MIs[0] policy
     /* 1014773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014783 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014805 */     // GIR_Coverage, 12985,
     /* 1014805 */     GIR_EraseRootFromParent_Done,
     /* 1014806 */   // Label 15085: @1014806
     /* 1014806 */   GIM_Try, /*On fail goto*//*Label 15086*/ GIMT_Encode4(1014883), // Rule ID 12988 //
     /* 1014811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1014822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1014825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1014828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1014831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014850 */     // MIs[0] policy
     /* 1014850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014882 */     // GIR_Coverage, 12988,
     /* 1014882 */     GIR_EraseRootFromParent_Done,
     /* 1014883 */   // Label 15086: @1014883
     /* 1014883 */   GIM_Try, /*On fail goto*//*Label 15087*/ GIMT_Encode4(1014960), // Rule ID 12989 //
     /* 1014888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1014891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1014899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1014902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1014905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1014908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014927 */     // MIs[0] policy
     /* 1014927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014937 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014959 */     // GIR_Coverage, 12989,
     /* 1014959 */     GIR_EraseRootFromParent_Done,
     /* 1014960 */   // Label 15087: @1014960
     /* 1014960 */   GIM_Try, /*On fail goto*//*Label 15088*/ GIMT_Encode4(1015037), // Rule ID 12992 //
     /* 1014965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1014976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1014979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1014982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1014985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015004 */     // MIs[0] policy
     /* 1015004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015014 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1015017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015036 */     // GIR_Coverage, 12992,
     /* 1015036 */     GIR_EraseRootFromParent_Done,
     /* 1015037 */   // Label 15088: @1015037
     /* 1015037 */   GIM_Try, /*On fail goto*//*Label 15089*/ GIMT_Encode4(1015114), // Rule ID 12993 //
     /* 1015042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1015045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1015053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1015056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1015059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1015062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015081 */     // MIs[0] policy
     /* 1015081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015091 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1015094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015113 */     // GIR_Coverage, 12993,
     /* 1015113 */     GIR_EraseRootFromParent_Done,
     /* 1015114 */   // Label 15089: @1015114
     /* 1015114 */   GIM_Try, /*On fail goto*//*Label 15090*/ GIMT_Encode4(1015191), // Rule ID 12996 //
     /* 1015119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1015122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1015130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1015133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1015136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1015139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015158 */     // MIs[0] policy
     /* 1015158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1015171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015190 */     // GIR_Coverage, 12996,
     /* 1015190 */     GIR_EraseRootFromParent_Done,
     /* 1015191 */   // Label 15090: @1015191
     /* 1015191 */   GIM_Try, /*On fail goto*//*Label 15091*/ GIMT_Encode4(1015268), // Rule ID 12997 //
     /* 1015196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1015199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1015207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1015210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1015213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1015216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015235 */     // MIs[0] policy
     /* 1015235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015245 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1015248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015267 */     // GIR_Coverage, 12997,
     /* 1015267 */     GIR_EraseRootFromParent_Done,
     /* 1015268 */   // Label 15091: @1015268
     /* 1015268 */   GIM_Try, /*On fail goto*//*Label 15092*/ GIMT_Encode4(1015345), // Rule ID 13000 //
     /* 1015273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1015284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1015287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1015293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015312 */     // MIs[0] policy
     /* 1015312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015322 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1015325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015344 */     // GIR_Coverage, 13000,
     /* 1015344 */     GIR_EraseRootFromParent_Done,
     /* 1015345 */   // Label 15092: @1015345
     /* 1015345 */   GIM_Try, /*On fail goto*//*Label 15093*/ GIMT_Encode4(1015422), // Rule ID 13001 //
     /* 1015350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1015361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1015364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1015370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015389 */     // MIs[0] policy
     /* 1015389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015399 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1015402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015421 */     // GIR_Coverage, 13001,
     /* 1015421 */     GIR_EraseRootFromParent_Done,
     /* 1015422 */   // Label 15093: @1015422
     /* 1015422 */   GIM_Try, /*On fail goto*//*Label 15094*/ GIMT_Encode4(1015499), // Rule ID 13004 //
     /* 1015427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1015438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1015441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1015447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015466 */     // MIs[0] policy
     /* 1015466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015476 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015498 */     // GIR_Coverage, 13004,
     /* 1015498 */     GIR_EraseRootFromParent_Done,
     /* 1015499 */   // Label 15094: @1015499
     /* 1015499 */   GIM_Try, /*On fail goto*//*Label 15095*/ GIMT_Encode4(1015576), // Rule ID 13005 //
     /* 1015504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1015515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1015518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1015524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015543 */     // MIs[0] policy
     /* 1015543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015553 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015575 */     // GIR_Coverage, 13005,
     /* 1015575 */     GIR_EraseRootFromParent_Done,
     /* 1015576 */   // Label 15095: @1015576
     /* 1015576 */   GIM_Try, /*On fail goto*//*Label 15096*/ GIMT_Encode4(1015653), // Rule ID 13008 //
     /* 1015581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1015592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1015595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1015601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015620 */     // MIs[0] policy
     /* 1015620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015630 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015652 */     // GIR_Coverage, 13008,
     /* 1015652 */     GIR_EraseRootFromParent_Done,
     /* 1015653 */   // Label 15096: @1015653
     /* 1015653 */   GIM_Try, /*On fail goto*//*Label 15097*/ GIMT_Encode4(1015730), // Rule ID 13009 //
     /* 1015658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1015669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1015672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1015678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015697 */     // MIs[0] policy
     /* 1015697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015707 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015729 */     // GIR_Coverage, 13009,
     /* 1015729 */     GIR_EraseRootFromParent_Done,
     /* 1015730 */   // Label 15097: @1015730
     /* 1015730 */   GIM_Try, /*On fail goto*//*Label 15098*/ GIMT_Encode4(1015807), // Rule ID 13012 //
     /* 1015735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1015746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1015749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1015755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015774 */     // MIs[0] policy
     /* 1015774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015784 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015806 */     // GIR_Coverage, 13012,
     /* 1015806 */     GIR_EraseRootFromParent_Done,
     /* 1015807 */   // Label 15098: @1015807
     /* 1015807 */   GIM_Try, /*On fail goto*//*Label 15099*/ GIMT_Encode4(1015884), // Rule ID 13013 //
     /* 1015812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1015823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1015826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1015832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015851 */     // MIs[0] policy
     /* 1015851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015861 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015883 */     // GIR_Coverage, 13013,
     /* 1015883 */     GIR_EraseRootFromParent_Done,
     /* 1015884 */   // Label 15099: @1015884
     /* 1015884 */   GIM_Try, /*On fail goto*//*Label 15100*/ GIMT_Encode4(1015961), // Rule ID 13016 //
     /* 1015889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1015900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1015903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015928 */     // MIs[0] policy
     /* 1015928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015938 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015960 */     // GIR_Coverage, 13016,
     /* 1015960 */     GIR_EraseRootFromParent_Done,
     /* 1015961 */   // Label 15100: @1015961
     /* 1015961 */   GIM_Try, /*On fail goto*//*Label 15101*/ GIMT_Encode4(1016038), // Rule ID 13017 //
     /* 1015966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1015977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1015980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016005 */     // MIs[0] policy
     /* 1016005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016015 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1016018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016037 */     // GIR_Coverage, 13017,
     /* 1016037 */     GIR_EraseRootFromParent_Done,
     /* 1016038 */   // Label 15101: @1016038
     /* 1016038 */   GIM_Try, /*On fail goto*//*Label 15102*/ GIMT_Encode4(1016115), // Rule ID 13020 //
     /* 1016043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1016054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1016057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1016063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016082 */     // MIs[0] policy
     /* 1016082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016092 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1016095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016114 */     // GIR_Coverage, 13020,
     /* 1016114 */     GIR_EraseRootFromParent_Done,
     /* 1016115 */   // Label 15102: @1016115
     /* 1016115 */   GIM_Try, /*On fail goto*//*Label 15103*/ GIMT_Encode4(1016192), // Rule ID 13021 //
     /* 1016120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1016131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1016134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1016140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016159 */     // MIs[0] policy
     /* 1016159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016169 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1016172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016191 */     // GIR_Coverage, 13021,
     /* 1016191 */     GIR_EraseRootFromParent_Done,
     /* 1016192 */   // Label 15103: @1016192
     /* 1016192 */   GIM_Try, /*On fail goto*//*Label 15104*/ GIMT_Encode4(1016269), // Rule ID 13024 //
     /* 1016197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1016208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1016211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1016217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016236 */     // MIs[0] policy
     /* 1016236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016246 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016268 */     // GIR_Coverage, 13024,
     /* 1016268 */     GIR_EraseRootFromParent_Done,
     /* 1016269 */   // Label 15104: @1016269
     /* 1016269 */   GIM_Try, /*On fail goto*//*Label 15105*/ GIMT_Encode4(1016346), // Rule ID 13025 //
     /* 1016274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1016285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1016288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1016294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016313 */     // MIs[0] policy
     /* 1016313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016323 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016345 */     // GIR_Coverage, 13025,
     /* 1016345 */     GIR_EraseRootFromParent_Done,
     /* 1016346 */   // Label 15105: @1016346
     /* 1016346 */   GIM_Try, /*On fail goto*//*Label 15106*/ GIMT_Encode4(1016423), // Rule ID 13028 //
     /* 1016351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1016362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1016365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1016371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016390 */     // MIs[0] policy
     /* 1016390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016422 */     // GIR_Coverage, 13028,
     /* 1016422 */     GIR_EraseRootFromParent_Done,
     /* 1016423 */   // Label 15106: @1016423
     /* 1016423 */   GIM_Try, /*On fail goto*//*Label 15107*/ GIMT_Encode4(1016500), // Rule ID 13029 //
     /* 1016428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1016439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1016442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1016448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016467 */     // MIs[0] policy
     /* 1016467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016499 */     // GIR_Coverage, 13029,
     /* 1016499 */     GIR_EraseRootFromParent_Done,
     /* 1016500 */   // Label 15107: @1016500
     /* 1016500 */   GIM_Try, /*On fail goto*//*Label 15108*/ GIMT_Encode4(1016577), // Rule ID 13032 //
     /* 1016505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016544 */     // MIs[0] policy
     /* 1016544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016554 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016576 */     // GIR_Coverage, 13032,
     /* 1016576 */     GIR_EraseRootFromParent_Done,
     /* 1016577 */   // Label 15108: @1016577
     /* 1016577 */   GIM_Try, /*On fail goto*//*Label 15109*/ GIMT_Encode4(1016654), // Rule ID 13033 //
     /* 1016582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016621 */     // MIs[0] policy
     /* 1016621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016631 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016653 */     // GIR_Coverage, 13033,
     /* 1016653 */     GIR_EraseRootFromParent_Done,
     /* 1016654 */   // Label 15109: @1016654
     /* 1016654 */   GIM_Try, /*On fail goto*//*Label 15110*/ GIMT_Encode4(1016731), // Rule ID 13036 //
     /* 1016659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1016662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016698 */     // MIs[0] policy
     /* 1016698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016708 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016730 */     // GIR_Coverage, 13036,
     /* 1016730 */     GIR_EraseRootFromParent_Done,
     /* 1016731 */   // Label 15110: @1016731
     /* 1016731 */   GIM_Try, /*On fail goto*//*Label 15111*/ GIMT_Encode4(1016808), // Rule ID 13037 //
     /* 1016736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1016739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016775 */     // MIs[0] policy
     /* 1016775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016785 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016807 */     // GIR_Coverage, 13037,
     /* 1016807 */     GIR_EraseRootFromParent_Done,
     /* 1016808 */   // Label 15111: @1016808
     /* 1016808 */   GIM_Try, /*On fail goto*//*Label 15112*/ GIMT_Encode4(1016885), // Rule ID 13040 //
     /* 1016813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1016824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1016827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1016833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016852 */     // MIs[0] policy
     /* 1016852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016862 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016884 */     // GIR_Coverage, 13040,
     /* 1016884 */     GIR_EraseRootFromParent_Done,
     /* 1016885 */   // Label 15112: @1016885
     /* 1016885 */   GIM_Try, /*On fail goto*//*Label 15113*/ GIMT_Encode4(1016962), // Rule ID 13041 //
     /* 1016890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1016901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1016904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1016910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016929 */     // MIs[0] policy
     /* 1016929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016939 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016961 */     // GIR_Coverage, 13041,
     /* 1016961 */     GIR_EraseRootFromParent_Done,
     /* 1016962 */   // Label 15113: @1016962
     /* 1016962 */   GIM_Try, /*On fail goto*//*Label 15114*/ GIMT_Encode4(1017039), // Rule ID 13044 //
     /* 1016967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1016978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1016981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1016987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017006 */     // MIs[0] policy
     /* 1017006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017016 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017038 */     // GIR_Coverage, 13044,
     /* 1017038 */     GIR_EraseRootFromParent_Done,
     /* 1017039 */   // Label 15114: @1017039
     /* 1017039 */   GIM_Try, /*On fail goto*//*Label 15115*/ GIMT_Encode4(1017116), // Rule ID 13045 //
     /* 1017044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1017055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1017058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1017064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017083 */     // MIs[0] policy
     /* 1017083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017093 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017115 */     // GIR_Coverage, 13045,
     /* 1017115 */     GIR_EraseRootFromParent_Done,
     /* 1017116 */   // Label 15115: @1017116
     /* 1017116 */   GIM_Try, /*On fail goto*//*Label 15116*/ GIMT_Encode4(1017193), // Rule ID 13048 //
     /* 1017121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1017132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1017135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1017141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017160 */     // MIs[0] policy
     /* 1017160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017170 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017192 */     // GIR_Coverage, 13048,
     /* 1017192 */     GIR_EraseRootFromParent_Done,
     /* 1017193 */   // Label 15116: @1017193
     /* 1017193 */   GIM_Try, /*On fail goto*//*Label 15117*/ GIMT_Encode4(1017270), // Rule ID 13049 //
     /* 1017198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1017209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1017212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1017218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017237 */     // MIs[0] policy
     /* 1017237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017247 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017269 */     // GIR_Coverage, 13049,
     /* 1017269 */     GIR_EraseRootFromParent_Done,
     /* 1017270 */   // Label 15117: @1017270
     /* 1017270 */   GIM_Try, /*On fail goto*//*Label 15118*/ GIMT_Encode4(1017347), // Rule ID 13052 //
     /* 1017275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1017286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1017289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1017295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017314 */     // MIs[0] policy
     /* 1017314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017346 */     // GIR_Coverage, 13052,
     /* 1017346 */     GIR_EraseRootFromParent_Done,
     /* 1017347 */   // Label 15118: @1017347
     /* 1017347 */   GIM_Try, /*On fail goto*//*Label 15119*/ GIMT_Encode4(1017424), // Rule ID 13053 //
     /* 1017352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1017363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1017366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1017372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017391 */     // MIs[0] policy
     /* 1017391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017401 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017423 */     // GIR_Coverage, 13053,
     /* 1017423 */     GIR_EraseRootFromParent_Done,
     /* 1017424 */   // Label 15119: @1017424
     /* 1017424 */   GIM_Try, /*On fail goto*//*Label 15120*/ GIMT_Encode4(1017501), // Rule ID 13056 //
     /* 1017429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1017440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1017443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1017449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017468 */     // MIs[0] policy
     /* 1017468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017478 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017500 */     // GIR_Coverage, 13056,
     /* 1017500 */     GIR_EraseRootFromParent_Done,
     /* 1017501 */   // Label 15120: @1017501
     /* 1017501 */   GIM_Try, /*On fail goto*//*Label 15121*/ GIMT_Encode4(1017578), // Rule ID 13057 //
     /* 1017506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1017517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1017520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1017526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017545 */     // MIs[0] policy
     /* 1017545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017555 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017577 */     // GIR_Coverage, 13057,
     /* 1017577 */     GIR_EraseRootFromParent_Done,
     /* 1017578 */   // Label 15121: @1017578
     /* 1017578 */   GIM_Try, /*On fail goto*//*Label 15122*/ GIMT_Encode4(1017655), // Rule ID 13060 //
     /* 1017583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1017594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1017597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1017603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017622 */     // MIs[0] policy
     /* 1017622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017632 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017654 */     // GIR_Coverage, 13060,
     /* 1017654 */     GIR_EraseRootFromParent_Done,
     /* 1017655 */   // Label 15122: @1017655
     /* 1017655 */   GIM_Try, /*On fail goto*//*Label 15123*/ GIMT_Encode4(1017732), // Rule ID 13061 //
     /* 1017660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1017671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1017674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1017680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017699 */     // MIs[0] policy
     /* 1017699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017709 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017731 */     // GIR_Coverage, 13061,
     /* 1017731 */     GIR_EraseRootFromParent_Done,
     /* 1017732 */   // Label 15123: @1017732
     /* 1017732 */   GIM_Try, /*On fail goto*//*Label 15124*/ GIMT_Encode4(1017809), // Rule ID 13064 //
     /* 1017737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017776 */     // MIs[0] policy
     /* 1017776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017786 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017808 */     // GIR_Coverage, 13064,
     /* 1017808 */     GIR_EraseRootFromParent_Done,
     /* 1017809 */   // Label 15124: @1017809
     /* 1017809 */   GIM_Try, /*On fail goto*//*Label 15125*/ GIMT_Encode4(1017886), // Rule ID 13065 //
     /* 1017814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017853 */     // MIs[0] policy
     /* 1017853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017863 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017885 */     // GIR_Coverage, 13065,
     /* 1017885 */     GIR_EraseRootFromParent_Done,
     /* 1017886 */   // Label 15125: @1017886
     /* 1017886 */   GIM_Try, /*On fail goto*//*Label 15126*/ GIMT_Encode4(1017963), // Rule ID 13068 //
     /* 1017891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017930 */     // MIs[0] policy
     /* 1017930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017940 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017962 */     // GIR_Coverage, 13068,
     /* 1017962 */     GIR_EraseRootFromParent_Done,
     /* 1017963 */   // Label 15126: @1017963
     /* 1017963 */   GIM_Try, /*On fail goto*//*Label 15127*/ GIMT_Encode4(1018040), // Rule ID 13069 //
     /* 1017968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018007 */     // MIs[0] policy
     /* 1018007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018017 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1018020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018039 */     // GIR_Coverage, 13069,
     /* 1018039 */     GIR_EraseRootFromParent_Done,
     /* 1018040 */   // Label 15127: @1018040
     /* 1018040 */   GIM_Try, /*On fail goto*//*Label 15128*/ GIMT_Encode4(1018117), // Rule ID 13072 //
     /* 1018045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1018056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1018059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1018065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018084 */     // MIs[0] policy
     /* 1018084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018094 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1018097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018116 */     // GIR_Coverage, 13072,
     /* 1018116 */     GIR_EraseRootFromParent_Done,
     /* 1018117 */   // Label 15128: @1018117
     /* 1018117 */   GIM_Try, /*On fail goto*//*Label 15129*/ GIMT_Encode4(1018194), // Rule ID 13073 //
     /* 1018122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1018133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1018136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1018142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018161 */     // MIs[0] policy
     /* 1018161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018171 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1018174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018193 */     // GIR_Coverage, 13073,
     /* 1018193 */     GIR_EraseRootFromParent_Done,
     /* 1018194 */   // Label 15129: @1018194
     /* 1018194 */   GIM_Try, /*On fail goto*//*Label 15130*/ GIMT_Encode4(1018271), // Rule ID 13076 //
     /* 1018199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1018210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1018213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1018219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018238 */     // MIs[0] policy
     /* 1018238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018248 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1018251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018270 */     // GIR_Coverage, 13076,
     /* 1018270 */     GIR_EraseRootFromParent_Done,
     /* 1018271 */   // Label 15130: @1018271
     /* 1018271 */   GIM_Try, /*On fail goto*//*Label 15131*/ GIMT_Encode4(1018348), // Rule ID 13077 //
     /* 1018276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1018287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1018290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1018296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018315 */     // MIs[0] policy
     /* 1018315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018325 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1018328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018347 */     // GIR_Coverage, 13077,
     /* 1018347 */     GIR_EraseRootFromParent_Done,
     /* 1018348 */   // Label 15131: @1018348
     /* 1018348 */   GIM_Try, /*On fail goto*//*Label 15132*/ GIMT_Encode4(1018425), // Rule ID 13080 //
     /* 1018353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1018364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1018367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1018373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018392 */     // MIs[0] policy
     /* 1018392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018402 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1018405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018424 */     // GIR_Coverage, 13080,
     /* 1018424 */     GIR_EraseRootFromParent_Done,
     /* 1018425 */   // Label 15132: @1018425
     /* 1018425 */   GIM_Try, /*On fail goto*//*Label 15133*/ GIMT_Encode4(1018502), // Rule ID 13081 //
     /* 1018430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1018441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1018444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1018450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018469 */     // MIs[0] policy
     /* 1018469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018479 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1018482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018501 */     // GIR_Coverage, 13081,
     /* 1018501 */     GIR_EraseRootFromParent_Done,
     /* 1018502 */   // Label 15133: @1018502
     /* 1018502 */   GIM_Try, /*On fail goto*//*Label 15134*/ GIMT_Encode4(1018579), // Rule ID 13084 //
     /* 1018507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1018518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1018521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1018527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018546 */     // MIs[0] policy
     /* 1018546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018556 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1018559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018578 */     // GIR_Coverage, 13084,
     /* 1018578 */     GIR_EraseRootFromParent_Done,
     /* 1018579 */   // Label 15134: @1018579
     /* 1018579 */   GIM_Try, /*On fail goto*//*Label 15135*/ GIMT_Encode4(1018656), // Rule ID 13085 //
     /* 1018584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1018595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1018598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1018604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018623 */     // MIs[0] policy
     /* 1018623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018633 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1018636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018655 */     // GIR_Coverage, 13085,
     /* 1018655 */     GIR_EraseRootFromParent_Done,
     /* 1018656 */   // Label 15135: @1018656
     /* 1018656 */   GIM_Try, /*On fail goto*//*Label 15136*/ GIMT_Encode4(1018733), // Rule ID 13088 //
     /* 1018661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1018672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1018675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1018678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1018681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018700 */     // MIs[0] policy
     /* 1018700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018710 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1018713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018732 */     // GIR_Coverage, 13088,
     /* 1018732 */     GIR_EraseRootFromParent_Done,
     /* 1018733 */   // Label 15136: @1018733
     /* 1018733 */   GIM_Try, /*On fail goto*//*Label 15137*/ GIMT_Encode4(1018810), // Rule ID 13089 //
     /* 1018738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1018749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1018752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1018755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1018758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018777 */     // MIs[0] policy
     /* 1018777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018787 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1018790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018809 */     // GIR_Coverage, 13089,
     /* 1018809 */     GIR_EraseRootFromParent_Done,
     /* 1018810 */   // Label 15137: @1018810
     /* 1018810 */   GIM_Try, /*On fail goto*//*Label 15138*/ GIMT_Encode4(1018887), // Rule ID 13092 //
     /* 1018815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1018826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1018829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1018832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1018835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018854 */     // MIs[0] policy
     /* 1018854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018864 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018886 */     // GIR_Coverage, 13092,
     /* 1018886 */     GIR_EraseRootFromParent_Done,
     /* 1018887 */   // Label 15138: @1018887
     /* 1018887 */   GIM_Try, /*On fail goto*//*Label 15139*/ GIMT_Encode4(1018964), // Rule ID 13093 //
     /* 1018892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1018903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1018906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1018909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1018912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018931 */     // MIs[0] policy
     /* 1018931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018941 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018963 */     // GIR_Coverage, 13093,
     /* 1018963 */     GIR_EraseRootFromParent_Done,
     /* 1018964 */   // Label 15139: @1018964
     /* 1018964 */   GIM_Try, /*On fail goto*//*Label 15140*/ GIMT_Encode4(1019041), // Rule ID 13096 //
     /* 1018969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1018980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1018983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1018986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1018989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019008 */     // MIs[0] policy
     /* 1019008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019018 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019040 */     // GIR_Coverage, 13096,
     /* 1019040 */     GIR_EraseRootFromParent_Done,
     /* 1019041 */   // Label 15140: @1019041
     /* 1019041 */   GIM_Try, /*On fail goto*//*Label 15141*/ GIMT_Encode4(1019118), // Rule ID 13097 //
     /* 1019046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1019057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1019060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1019063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1019066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019085 */     // MIs[0] policy
     /* 1019085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019095 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019117 */     // GIR_Coverage, 13097,
     /* 1019117 */     GIR_EraseRootFromParent_Done,
     /* 1019118 */   // Label 15141: @1019118
     /* 1019118 */   GIM_Try, /*On fail goto*//*Label 15142*/ GIMT_Encode4(1019195), // Rule ID 13100 //
     /* 1019123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1019134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1019137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1019140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1019143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019162 */     // MIs[0] policy
     /* 1019162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019172 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1019175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019194 */     // GIR_Coverage, 13100,
     /* 1019194 */     GIR_EraseRootFromParent_Done,
     /* 1019195 */   // Label 15142: @1019195
     /* 1019195 */   GIM_Try, /*On fail goto*//*Label 15143*/ GIMT_Encode4(1019272), // Rule ID 13101 //
     /* 1019200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1019211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1019214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1019217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1019220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019239 */     // MIs[0] policy
     /* 1019239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019249 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1019252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019271 */     // GIR_Coverage, 13101,
     /* 1019271 */     GIR_EraseRootFromParent_Done,
     /* 1019272 */   // Label 15143: @1019272
     /* 1019272 */   GIM_Try, /*On fail goto*//*Label 15144*/ GIMT_Encode4(1019349), // Rule ID 13104 //
     /* 1019277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1019288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1019291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1019294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1019297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019316 */     // MIs[0] policy
     /* 1019316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019326 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019348 */     // GIR_Coverage, 13104,
     /* 1019348 */     GIR_EraseRootFromParent_Done,
     /* 1019349 */   // Label 15144: @1019349
     /* 1019349 */   GIM_Try, /*On fail goto*//*Label 15145*/ GIMT_Encode4(1019426), // Rule ID 13105 //
     /* 1019354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1019365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1019368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1019371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1019374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019393 */     // MIs[0] policy
     /* 1019393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019403 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019425 */     // GIR_Coverage, 13105,
     /* 1019425 */     GIR_EraseRootFromParent_Done,
     /* 1019426 */   // Label 15145: @1019426
     /* 1019426 */   GIM_Try, /*On fail goto*//*Label 15146*/ GIMT_Encode4(1019503), // Rule ID 13108 //
     /* 1019431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1019442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1019445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1019448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1019451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019470 */     // MIs[0] policy
     /* 1019470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019480 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019502 */     // GIR_Coverage, 13108,
     /* 1019502 */     GIR_EraseRootFromParent_Done,
     /* 1019503 */   // Label 15146: @1019503
     /* 1019503 */   GIM_Try, /*On fail goto*//*Label 15147*/ GIMT_Encode4(1019580), // Rule ID 13109 //
     /* 1019508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1019519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1019522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1019525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1019528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019547 */     // MIs[0] policy
     /* 1019547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019557 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019579 */     // GIR_Coverage, 13109,
     /* 1019579 */     GIR_EraseRootFromParent_Done,
     /* 1019580 */   // Label 15147: @1019580
     /* 1019580 */   GIM_Try, /*On fail goto*//*Label 15148*/ GIMT_Encode4(1019657), // Rule ID 13112 //
     /* 1019585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1019596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1019599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1019602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019624 */     // MIs[0] policy
     /* 1019624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019634 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019656 */     // GIR_Coverage, 13112,
     /* 1019656 */     GIR_EraseRootFromParent_Done,
     /* 1019657 */   // Label 15148: @1019657
     /* 1019657 */   GIM_Try, /*On fail goto*//*Label 15149*/ GIMT_Encode4(1019734), // Rule ID 13113 //
     /* 1019662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1019673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1019676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1019679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019701 */     // MIs[0] policy
     /* 1019701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019711 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019733 */     // GIR_Coverage, 13113,
     /* 1019733 */     GIR_EraseRootFromParent_Done,
     /* 1019734 */   // Label 15149: @1019734
     /* 1019734 */   GIM_Try, /*On fail goto*//*Label 15150*/ GIMT_Encode4(1019811), // Rule ID 13116 //
     /* 1019739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1019750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1019753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1019756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1019759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019778 */     // MIs[0] policy
     /* 1019778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019788 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019810 */     // GIR_Coverage, 13116,
     /* 1019810 */     GIR_EraseRootFromParent_Done,
     /* 1019811 */   // Label 15150: @1019811
     /* 1019811 */   GIM_Try, /*On fail goto*//*Label 15151*/ GIMT_Encode4(1019888), // Rule ID 13117 //
     /* 1019816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1019827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1019830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1019833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1019836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019855 */     // MIs[0] policy
     /* 1019855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019865 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019887 */     // GIR_Coverage, 13117,
     /* 1019887 */     GIR_EraseRootFromParent_Done,
     /* 1019888 */   // Label 15151: @1019888
     /* 1019888 */   GIM_Try, /*On fail goto*//*Label 15152*/ GIMT_Encode4(1019965), // Rule ID 13120 //
     /* 1019893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1019910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019932 */     // MIs[0] policy
     /* 1019932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019942 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019964 */     // GIR_Coverage, 13120,
     /* 1019964 */     GIR_EraseRootFromParent_Done,
     /* 1019965 */   // Label 15152: @1019965
     /* 1019965 */   GIM_Try, /*On fail goto*//*Label 15153*/ GIMT_Encode4(1020042), // Rule ID 13121 //
     /* 1019970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1019987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020009 */     // MIs[0] policy
     /* 1020009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020019 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1020022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020041 */     // GIR_Coverage, 13121,
     /* 1020041 */     GIR_EraseRootFromParent_Done,
     /* 1020042 */   // Label 15153: @1020042
     /* 1020042 */   GIM_Try, /*On fail goto*//*Label 15154*/ GIMT_Encode4(1020119), // Rule ID 13124 //
     /* 1020047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1020050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1020058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1020061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1020064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1020067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020086 */     // MIs[0] policy
     /* 1020086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020096 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1020099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020118 */     // GIR_Coverage, 13124,
     /* 1020118 */     GIR_EraseRootFromParent_Done,
     /* 1020119 */   // Label 15154: @1020119
     /* 1020119 */   GIM_Try, /*On fail goto*//*Label 15155*/ GIMT_Encode4(1020196), // Rule ID 13125 //
     /* 1020124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1020127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1020135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1020138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1020141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1020144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020163 */     // MIs[0] policy
     /* 1020163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020173 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1020176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020195 */     // GIR_Coverage, 13125,
     /* 1020195 */     GIR_EraseRootFromParent_Done,
     /* 1020196 */   // Label 15155: @1020196
     /* 1020196 */   GIM_Try, /*On fail goto*//*Label 15156*/ GIMT_Encode4(1020273), // Rule ID 13128 //
     /* 1020201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1020212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1020215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1020218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1020221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020240 */     // MIs[0] policy
     /* 1020240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020250 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020272 */     // GIR_Coverage, 13128,
     /* 1020272 */     GIR_EraseRootFromParent_Done,
     /* 1020273 */   // Label 15156: @1020273
     /* 1020273 */   GIM_Try, /*On fail goto*//*Label 15157*/ GIMT_Encode4(1020350), // Rule ID 13129 //
     /* 1020278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1020289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1020292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1020295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1020298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020317 */     // MIs[0] policy
     /* 1020317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020327 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020349 */     // GIR_Coverage, 13129,
     /* 1020349 */     GIR_EraseRootFromParent_Done,
     /* 1020350 */   // Label 15157: @1020350
     /* 1020350 */   GIM_Try, /*On fail goto*//*Label 15158*/ GIMT_Encode4(1020427), // Rule ID 13132 //
     /* 1020355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1020366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1020369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1020372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1020375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020394 */     // MIs[0] policy
     /* 1020394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020404 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020426 */     // GIR_Coverage, 13132,
     /* 1020426 */     GIR_EraseRootFromParent_Done,
     /* 1020427 */   // Label 15158: @1020427
     /* 1020427 */   GIM_Try, /*On fail goto*//*Label 15159*/ GIMT_Encode4(1020504), // Rule ID 13133 //
     /* 1020432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1020443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1020446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1020449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1020452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020471 */     // MIs[0] policy
     /* 1020471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020481 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020503 */     // GIR_Coverage, 13133,
     /* 1020503 */     GIR_EraseRootFromParent_Done,
     /* 1020504 */   // Label 15159: @1020504
     /* 1020504 */   GIM_Try, /*On fail goto*//*Label 15160*/ GIMT_Encode4(1020581), // Rule ID 13136 //
     /* 1020509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1020520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1020523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1020526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020548 */     // MIs[0] policy
     /* 1020548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020558 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020580 */     // GIR_Coverage, 13136,
     /* 1020580 */     GIR_EraseRootFromParent_Done,
     /* 1020581 */   // Label 15160: @1020581
     /* 1020581 */   GIM_Try, /*On fail goto*//*Label 15161*/ GIMT_Encode4(1020658), // Rule ID 13137 //
     /* 1020586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1020597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1020600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1020603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020625 */     // MIs[0] policy
     /* 1020625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020635 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020657 */     // GIR_Coverage, 13137,
     /* 1020657 */     GIR_EraseRootFromParent_Done,
     /* 1020658 */   // Label 15161: @1020658
     /* 1020658 */   GIM_Try, /*On fail goto*//*Label 15162*/ GIMT_Encode4(1020735), // Rule ID 13140 //
     /* 1020663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1020674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1020677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1020680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1020683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020702 */     // MIs[0] policy
     /* 1020702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020734 */     // GIR_Coverage, 13140,
     /* 1020734 */     GIR_EraseRootFromParent_Done,
     /* 1020735 */   // Label 15162: @1020735
     /* 1020735 */   GIM_Try, /*On fail goto*//*Label 15163*/ GIMT_Encode4(1020812), // Rule ID 13141 //
     /* 1020740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1020751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1020754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1020757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1020760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020779 */     // MIs[0] policy
     /* 1020779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020789 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020811 */     // GIR_Coverage, 13141,
     /* 1020811 */     GIR_EraseRootFromParent_Done,
     /* 1020812 */   // Label 15163: @1020812
     /* 1020812 */   GIM_Try, /*On fail goto*//*Label 15164*/ GIMT_Encode4(1020889), // Rule ID 13144 //
     /* 1020817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1020828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1020831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1020834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1020837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020856 */     // MIs[0] policy
     /* 1020856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020888 */     // GIR_Coverage, 13144,
     /* 1020888 */     GIR_EraseRootFromParent_Done,
     /* 1020889 */   // Label 15164: @1020889
     /* 1020889 */   GIM_Try, /*On fail goto*//*Label 15165*/ GIMT_Encode4(1020966), // Rule ID 13145 //
     /* 1020894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1020905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1020908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1020911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1020914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020933 */     // MIs[0] policy
     /* 1020933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020943 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020965 */     // GIR_Coverage, 13145,
     /* 1020965 */     GIR_EraseRootFromParent_Done,
     /* 1020966 */   // Label 15165: @1020966
     /* 1020966 */   GIM_Try, /*On fail goto*//*Label 15166*/ GIMT_Encode4(1021043), // Rule ID 13148 //
     /* 1020971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1020982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1020985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1020988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1020991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021010 */     // MIs[0] policy
     /* 1021010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021020 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1021039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021042 */     // GIR_Coverage, 13148,
     /* 1021042 */     GIR_EraseRootFromParent_Done,
     /* 1021043 */   // Label 15166: @1021043
     /* 1021043 */   GIM_Try, /*On fail goto*//*Label 15167*/ GIMT_Encode4(1021120), // Rule ID 13149 //
     /* 1021048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1021059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1021062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1021065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1021068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021087 */     // MIs[0] policy
     /* 1021087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021097 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1021116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021119 */     // GIR_Coverage, 13149,
     /* 1021119 */     GIR_EraseRootFromParent_Done,
     /* 1021120 */   // Label 15167: @1021120
     /* 1021120 */   GIM_Try, /*On fail goto*//*Label 15168*/ GIMT_Encode4(1021197), // Rule ID 13152 //
     /* 1021125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1021136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1021139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1021142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1021145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021164 */     // MIs[0] policy
     /* 1021164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1021177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021196 */     // GIR_Coverage, 13152,
     /* 1021196 */     GIR_EraseRootFromParent_Done,
     /* 1021197 */   // Label 15168: @1021197
     /* 1021197 */   GIM_Try, /*On fail goto*//*Label 15169*/ GIMT_Encode4(1021274), // Rule ID 13153 //
     /* 1021202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1021213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1021216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1021219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1021222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021241 */     // MIs[0] policy
     /* 1021241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021251 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1021254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021273 */     // GIR_Coverage, 13153,
     /* 1021273 */     GIR_EraseRootFromParent_Done,
     /* 1021274 */   // Label 15169: @1021274
     /* 1021274 */   GIM_Try, /*On fail goto*//*Label 15170*/ GIMT_Encode4(1021351), // Rule ID 13156 //
     /* 1021279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1021290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1021293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1021296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1021299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021318 */     // MIs[0] policy
     /* 1021318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1021331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021350 */     // GIR_Coverage, 13156,
     /* 1021350 */     GIR_EraseRootFromParent_Done,
     /* 1021351 */   // Label 15170: @1021351
     /* 1021351 */   GIM_Try, /*On fail goto*//*Label 15171*/ GIMT_Encode4(1021428), // Rule ID 13157 //
     /* 1021356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1021367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1021370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1021373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1021376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021395 */     // MIs[0] policy
     /* 1021395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021405 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1021408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021427 */     // GIR_Coverage, 13157,
     /* 1021427 */     GIR_EraseRootFromParent_Done,
     /* 1021428 */   // Label 15171: @1021428
     /* 1021428 */   GIM_Try, /*On fail goto*//*Label 15172*/ GIMT_Encode4(1021505), // Rule ID 13160 //
     /* 1021433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1021444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1021447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1021450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1021453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021472 */     // MIs[0] policy
     /* 1021472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021482 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021504 */     // GIR_Coverage, 13160,
     /* 1021504 */     GIR_EraseRootFromParent_Done,
     /* 1021505 */   // Label 15172: @1021505
     /* 1021505 */   GIM_Try, /*On fail goto*//*Label 15173*/ GIMT_Encode4(1021582), // Rule ID 13161 //
     /* 1021510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1021521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1021524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1021527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1021530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021549 */     // MIs[0] policy
     /* 1021549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021559 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021581 */     // GIR_Coverage, 13161,
     /* 1021581 */     GIR_EraseRootFromParent_Done,
     /* 1021582 */   // Label 15173: @1021582
     /* 1021582 */   GIM_Try, /*On fail goto*//*Label 15174*/ GIMT_Encode4(1021659), // Rule ID 13164 //
     /* 1021587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1021598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1021601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1021604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1021607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021626 */     // MIs[0] policy
     /* 1021626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1021639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021658 */     // GIR_Coverage, 13164,
     /* 1021658 */     GIR_EraseRootFromParent_Done,
     /* 1021659 */   // Label 15174: @1021659
     /* 1021659 */   GIM_Try, /*On fail goto*//*Label 15175*/ GIMT_Encode4(1021736), // Rule ID 13165 //
     /* 1021664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1021675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1021678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1021681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1021684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021703 */     // MIs[0] policy
     /* 1021703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021713 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1021716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021735 */     // GIR_Coverage, 13165,
     /* 1021735 */     GIR_EraseRootFromParent_Done,
     /* 1021736 */   // Label 15175: @1021736
     /* 1021736 */   GIM_Try, /*On fail goto*//*Label 15176*/ GIMT_Encode4(1021813), // Rule ID 13168 //
     /* 1021741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1021752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1021755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1021758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1021761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021780 */     // MIs[0] policy
     /* 1021780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021790 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1021793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021812 */     // GIR_Coverage, 13168,
     /* 1021812 */     GIR_EraseRootFromParent_Done,
     /* 1021813 */   // Label 15176: @1021813
     /* 1021813 */   GIM_Try, /*On fail goto*//*Label 15177*/ GIMT_Encode4(1021890), // Rule ID 13169 //
     /* 1021818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1021829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1021832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1021835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1021838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021857 */     // MIs[0] policy
     /* 1021857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021867 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1021870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021889 */     // GIR_Coverage, 13169,
     /* 1021889 */     GIR_EraseRootFromParent_Done,
     /* 1021890 */   // Label 15177: @1021890
     /* 1021890 */   GIM_Try, /*On fail goto*//*Label 15178*/ GIMT_Encode4(1021967), // Rule ID 13172 //
     /* 1021895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1021912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021934 */     // MIs[0] policy
     /* 1021934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021944 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021966 */     // GIR_Coverage, 13172,
     /* 1021966 */     GIR_EraseRootFromParent_Done,
     /* 1021967 */   // Label 15178: @1021967
     /* 1021967 */   GIM_Try, /*On fail goto*//*Label 15179*/ GIMT_Encode4(1022044), // Rule ID 13173 //
     /* 1021972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1021989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022011 */     // MIs[0] policy
     /* 1022011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022021 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1022024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1022040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022043 */     // GIR_Coverage, 13173,
     /* 1022043 */     GIR_EraseRootFromParent_Done,
     /* 1022044 */   // Label 15179: @1022044
     /* 1022044 */   GIM_Try, /*On fail goto*//*Label 15180*/ GIMT_Encode4(1022121), // Rule ID 13176 //
     /* 1022049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1022060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1022063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1022069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022088 */     // MIs[0] policy
     /* 1022088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022098 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1022101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022120 */     // GIR_Coverage, 13176,
     /* 1022120 */     GIR_EraseRootFromParent_Done,
     /* 1022121 */   // Label 15180: @1022121
     /* 1022121 */   GIM_Try, /*On fail goto*//*Label 15181*/ GIMT_Encode4(1022198), // Rule ID 13177 //
     /* 1022126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1022137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1022140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1022146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022165 */     // MIs[0] policy
     /* 1022165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022175 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1022178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022197 */     // GIR_Coverage, 13177,
     /* 1022197 */     GIR_EraseRootFromParent_Done,
     /* 1022198 */   // Label 15181: @1022198
     /* 1022198 */   GIM_Try, /*On fail goto*//*Label 15182*/ GIMT_Encode4(1022275), // Rule ID 13180 //
     /* 1022203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1022214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1022217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1022223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022242 */     // MIs[0] policy
     /* 1022242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022252 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1022255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022274 */     // GIR_Coverage, 13180,
     /* 1022274 */     GIR_EraseRootFromParent_Done,
     /* 1022275 */   // Label 15182: @1022275
     /* 1022275 */   GIM_Try, /*On fail goto*//*Label 15183*/ GIMT_Encode4(1022352), // Rule ID 13181 //
     /* 1022280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1022291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1022294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1022300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022319 */     // MIs[0] policy
     /* 1022319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022329 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1022332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022351 */     // GIR_Coverage, 13181,
     /* 1022351 */     GIR_EraseRootFromParent_Done,
     /* 1022352 */   // Label 15183: @1022352
     /* 1022352 */   GIM_Try, /*On fail goto*//*Label 15184*/ GIMT_Encode4(1022429), // Rule ID 13184 //
     /* 1022357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1022368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1022371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1022377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022396 */     // MIs[0] policy
     /* 1022396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022406 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022428 */     // GIR_Coverage, 13184,
     /* 1022428 */     GIR_EraseRootFromParent_Done,
     /* 1022429 */   // Label 15184: @1022429
     /* 1022429 */   GIM_Try, /*On fail goto*//*Label 15185*/ GIMT_Encode4(1022506), // Rule ID 13185 //
     /* 1022434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1022445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1022448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1022454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022473 */     // MIs[0] policy
     /* 1022473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022483 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022505 */     // GIR_Coverage, 13185,
     /* 1022505 */     GIR_EraseRootFromParent_Done,
     /* 1022506 */   // Label 15185: @1022506
     /* 1022506 */   GIM_Try, /*On fail goto*//*Label 15186*/ GIMT_Encode4(1022583), // Rule ID 13188 //
     /* 1022511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1022522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1022525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1022531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022550 */     // MIs[0] policy
     /* 1022550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022560 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1022563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022582 */     // GIR_Coverage, 13188,
     /* 1022582 */     GIR_EraseRootFromParent_Done,
     /* 1022583 */   // Label 15186: @1022583
     /* 1022583 */   GIM_Try, /*On fail goto*//*Label 15187*/ GIMT_Encode4(1022660), // Rule ID 13189 //
     /* 1022588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1022599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1022602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1022608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022627 */     // MIs[0] policy
     /* 1022627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022637 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1022640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022659 */     // GIR_Coverage, 13189,
     /* 1022659 */     GIR_EraseRootFromParent_Done,
     /* 1022660 */   // Label 15187: @1022660
     /* 1022660 */   GIM_Try, /*On fail goto*//*Label 15188*/ GIMT_Encode4(1022737), // Rule ID 13192 //
     /* 1022665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1022676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1022679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1022685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022704 */     // MIs[0] policy
     /* 1022704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022714 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022736 */     // GIR_Coverage, 13192,
     /* 1022736 */     GIR_EraseRootFromParent_Done,
     /* 1022737 */   // Label 15188: @1022737
     /* 1022737 */   GIM_Try, /*On fail goto*//*Label 15189*/ GIMT_Encode4(1022814), // Rule ID 13193 //
     /* 1022742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1022753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1022756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1022762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022781 */     // MIs[0] policy
     /* 1022781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022791 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022813 */     // GIR_Coverage, 13193,
     /* 1022813 */     GIR_EraseRootFromParent_Done,
     /* 1022814 */   // Label 15189: @1022814
     /* 1022814 */   GIM_Try, /*On fail goto*//*Label 15190*/ GIMT_Encode4(1022891), // Rule ID 13196 //
     /* 1022819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1022839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022858 */     // MIs[0] policy
     /* 1022858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022890 */     // GIR_Coverage, 13196,
     /* 1022890 */     GIR_EraseRootFromParent_Done,
     /* 1022891 */   // Label 15190: @1022891
     /* 1022891 */   GIM_Try, /*On fail goto*//*Label 15191*/ GIMT_Encode4(1022968), // Rule ID 13197 //
     /* 1022896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1022916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022935 */     // MIs[0] policy
     /* 1022935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022945 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022967 */     // GIR_Coverage, 13197,
     /* 1022967 */     GIR_EraseRootFromParent_Done,
     /* 1022968 */   // Label 15191: @1022968
     /* 1022968 */   GIM_Try, /*On fail goto*//*Label 15192*/ GIMT_Encode4(1023045), // Rule ID 13200 //
     /* 1022973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1022984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1022987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1022993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023012 */     // MIs[0] policy
     /* 1023012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023022 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023044 */     // GIR_Coverage, 13200,
     /* 1023044 */     GIR_EraseRootFromParent_Done,
     /* 1023045 */   // Label 15192: @1023045
     /* 1023045 */   GIM_Try, /*On fail goto*//*Label 15193*/ GIMT_Encode4(1023122), // Rule ID 13201 //
     /* 1023050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1023061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1023064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1023070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023089 */     // MIs[0] policy
     /* 1023089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023099 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023121 */     // GIR_Coverage, 13201,
     /* 1023121 */     GIR_EraseRootFromParent_Done,
     /* 1023122 */   // Label 15193: @1023122
     /* 1023122 */   GIM_Try, /*On fail goto*//*Label 15194*/ GIMT_Encode4(1023199), // Rule ID 13204 //
     /* 1023127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1023138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1023141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1023147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023166 */     // MIs[0] policy
     /* 1023166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023198 */     // GIR_Coverage, 13204,
     /* 1023198 */     GIR_EraseRootFromParent_Done,
     /* 1023199 */   // Label 15194: @1023199
     /* 1023199 */   GIM_Try, /*On fail goto*//*Label 15195*/ GIMT_Encode4(1023276), // Rule ID 13205 //
     /* 1023204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1023215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1023218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1023224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023243 */     // MIs[0] policy
     /* 1023243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023253 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023275 */     // GIR_Coverage, 13205,
     /* 1023275 */     GIR_EraseRootFromParent_Done,
     /* 1023276 */   // Label 15195: @1023276
     /* 1023276 */   GIM_Try, /*On fail goto*//*Label 15196*/ GIMT_Encode4(1023353), // Rule ID 13208 //
     /* 1023281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1023292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1023295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1023301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023320 */     // MIs[0] policy
     /* 1023320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023352 */     // GIR_Coverage, 13208,
     /* 1023352 */     GIR_EraseRootFromParent_Done,
     /* 1023353 */   // Label 15196: @1023353
     /* 1023353 */   GIM_Try, /*On fail goto*//*Label 15197*/ GIMT_Encode4(1023430), // Rule ID 13209 //
     /* 1023358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1023369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1023372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1023378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023397 */     // MIs[0] policy
     /* 1023397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023407 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023429 */     // GIR_Coverage, 13209,
     /* 1023429 */     GIR_EraseRootFromParent_Done,
     /* 1023430 */   // Label 15197: @1023430
     /* 1023430 */   GIM_Try, /*On fail goto*//*Label 15198*/ GIMT_Encode4(1023507), // Rule ID 13212 //
     /* 1023435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1023438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1023446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1023449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1023455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023474 */     // MIs[0] policy
     /* 1023474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023484 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1023503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023506 */     // GIR_Coverage, 13212,
     /* 1023506 */     GIR_EraseRootFromParent_Done,
     /* 1023507 */   // Label 15198: @1023507
     /* 1023507 */   GIM_Try, /*On fail goto*//*Label 15199*/ GIMT_Encode4(1023584), // Rule ID 13213 //
     /* 1023512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1023515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1023523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1023526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1023532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023551 */     // MIs[0] policy
     /* 1023551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023561 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1023580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023583 */     // GIR_Coverage, 13213,
     /* 1023583 */     GIR_EraseRootFromParent_Done,
     /* 1023584 */   // Label 15199: @1023584
     /* 1023584 */   GIM_Try, /*On fail goto*//*Label 15200*/ GIMT_Encode4(1023661), // Rule ID 13216 //
     /* 1023589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1023600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1023603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023628 */     // MIs[0] policy
     /* 1023628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023638 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023660 */     // GIR_Coverage, 13216,
     /* 1023660 */     GIR_EraseRootFromParent_Done,
     /* 1023661 */   // Label 15200: @1023661
     /* 1023661 */   GIM_Try, /*On fail goto*//*Label 15201*/ GIMT_Encode4(1023738), // Rule ID 13217 //
     /* 1023666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1023677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1023680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023705 */     // MIs[0] policy
     /* 1023705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023715 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023737 */     // GIR_Coverage, 13217,
     /* 1023737 */     GIR_EraseRootFromParent_Done,
     /* 1023738 */   // Label 15201: @1023738
     /* 1023738 */   GIM_Try, /*On fail goto*//*Label 15202*/ GIMT_Encode4(1023815), // Rule ID 13220 //
     /* 1023743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1023754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1023757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023782 */     // MIs[0] policy
     /* 1023782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023792 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023814 */     // GIR_Coverage, 13220,
     /* 1023814 */     GIR_EraseRootFromParent_Done,
     /* 1023815 */   // Label 15202: @1023815
     /* 1023815 */   GIM_Try, /*On fail goto*//*Label 15203*/ GIMT_Encode4(1023892), // Rule ID 13221 //
     /* 1023820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1023831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1023834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023859 */     // MIs[0] policy
     /* 1023859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023869 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023891 */     // GIR_Coverage, 13221,
     /* 1023891 */     GIR_EraseRootFromParent_Done,
     /* 1023892 */   // Label 15203: @1023892
     /* 1023892 */   GIM_Try, /*On fail goto*//*Label 15204*/ GIMT_Encode4(1023969), // Rule ID 13224 //
     /* 1023897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023936 */     // MIs[0] policy
     /* 1023936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023946 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023968 */     // GIR_Coverage, 13224,
     /* 1023968 */     GIR_EraseRootFromParent_Done,
     /* 1023969 */   // Label 15204: @1023969
     /* 1023969 */   GIM_Try, /*On fail goto*//*Label 15205*/ GIMT_Encode4(1024046), // Rule ID 13225 //
     /* 1023974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024013 */     // MIs[0] policy
     /* 1024013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024023 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1024042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024045 */     // GIR_Coverage, 13225,
     /* 1024045 */     GIR_EraseRootFromParent_Done,
     /* 1024046 */   // Label 15205: @1024046
     /* 1024046 */   GIM_Try, /*On fail goto*//*Label 15206*/ GIMT_Encode4(1024123), // Rule ID 13228 //
     /* 1024051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1024062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1024065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1024071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024090 */     // MIs[0] policy
     /* 1024090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024100 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024122 */     // GIR_Coverage, 13228,
     /* 1024122 */     GIR_EraseRootFromParent_Done,
     /* 1024123 */   // Label 15206: @1024123
     /* 1024123 */   GIM_Try, /*On fail goto*//*Label 15207*/ GIMT_Encode4(1024200), // Rule ID 13229 //
     /* 1024128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1024139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1024142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1024148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024167 */     // MIs[0] policy
     /* 1024167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024177 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024199 */     // GIR_Coverage, 13229,
     /* 1024199 */     GIR_EraseRootFromParent_Done,
     /* 1024200 */   // Label 15207: @1024200
     /* 1024200 */   GIM_Try, /*On fail goto*//*Label 15208*/ GIMT_Encode4(1024277), // Rule ID 13232 //
     /* 1024205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1024216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1024219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1024225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024244 */     // MIs[0] policy
     /* 1024244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024254 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024276 */     // GIR_Coverage, 13232,
     /* 1024276 */     GIR_EraseRootFromParent_Done,
     /* 1024277 */   // Label 15208: @1024277
     /* 1024277 */   GIM_Try, /*On fail goto*//*Label 15209*/ GIMT_Encode4(1024354), // Rule ID 13233 //
     /* 1024282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1024293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1024296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1024302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024321 */     // MIs[0] policy
     /* 1024321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024331 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024353 */     // GIR_Coverage, 13233,
     /* 1024353 */     GIR_EraseRootFromParent_Done,
     /* 1024354 */   // Label 15209: @1024354
     /* 1024354 */   GIM_Try, /*On fail goto*//*Label 15210*/ GIMT_Encode4(1024431), // Rule ID 13236 //
     /* 1024359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1024370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1024373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1024379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024398 */     // MIs[0] policy
     /* 1024398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024408 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024430 */     // GIR_Coverage, 13236,
     /* 1024430 */     GIR_EraseRootFromParent_Done,
     /* 1024431 */   // Label 15210: @1024431
     /* 1024431 */   GIM_Try, /*On fail goto*//*Label 15211*/ GIMT_Encode4(1024508), // Rule ID 13237 //
     /* 1024436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1024447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1024450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1024456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024475 */     // MIs[0] policy
     /* 1024475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024485 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024507 */     // GIR_Coverage, 13237,
     /* 1024507 */     GIR_EraseRootFromParent_Done,
     /* 1024508 */   // Label 15211: @1024508
     /* 1024508 */   GIM_Try, /*On fail goto*//*Label 15212*/ GIMT_Encode4(1024585), // Rule ID 13240 //
     /* 1024513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1024533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024552 */     // MIs[0] policy
     /* 1024552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024584 */     // GIR_Coverage, 13240,
     /* 1024584 */     GIR_EraseRootFromParent_Done,
     /* 1024585 */   // Label 15212: @1024585
     /* 1024585 */   GIM_Try, /*On fail goto*//*Label 15213*/ GIMT_Encode4(1024662), // Rule ID 13241 //
     /* 1024590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1024610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024629 */     // MIs[0] policy
     /* 1024629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024661 */     // GIR_Coverage, 13241,
     /* 1024661 */     GIR_EraseRootFromParent_Done,
     /* 1024662 */   // Label 15213: @1024662
     /* 1024662 */   GIM_Try, /*On fail goto*//*Label 15214*/ GIMT_Encode4(1024739), // Rule ID 13244 //
     /* 1024667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1024687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024706 */     // MIs[0] policy
     /* 1024706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024738 */     // GIR_Coverage, 13244,
     /* 1024738 */     GIR_EraseRootFromParent_Done,
     /* 1024739 */   // Label 15214: @1024739
     /* 1024739 */   GIM_Try, /*On fail goto*//*Label 15215*/ GIMT_Encode4(1024816), // Rule ID 13245 //
     /* 1024744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1024764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024783 */     // MIs[0] policy
     /* 1024783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024793 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024815 */     // GIR_Coverage, 13245,
     /* 1024815 */     GIR_EraseRootFromParent_Done,
     /* 1024816 */   // Label 15215: @1024816
     /* 1024816 */   GIM_Try, /*On fail goto*//*Label 15216*/ GIMT_Encode4(1024893), // Rule ID 13248 //
     /* 1024821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1024841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024860 */     // MIs[0] policy
     /* 1024860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024870 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024892 */     // GIR_Coverage, 13248,
     /* 1024892 */     GIR_EraseRootFromParent_Done,
     /* 1024893 */   // Label 15216: @1024893
     /* 1024893 */   GIM_Try, /*On fail goto*//*Label 15217*/ GIMT_Encode4(1024970), // Rule ID 13249 //
     /* 1024898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1024918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024937 */     // MIs[0] policy
     /* 1024937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024947 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024969 */     // GIR_Coverage, 13249,
     /* 1024969 */     GIR_EraseRootFromParent_Done,
     /* 1024970 */   // Label 15217: @1024970
     /* 1024970 */   GIM_Try, /*On fail goto*//*Label 15218*/ GIMT_Encode4(1025047), // Rule ID 13252 //
     /* 1024975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1024978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1024986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1024989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1024995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025014 */     // MIs[0] policy
     /* 1025014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1025027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025046 */     // GIR_Coverage, 13252,
     /* 1025046 */     GIR_EraseRootFromParent_Done,
     /* 1025047 */   // Label 15218: @1025047
     /* 1025047 */   GIM_Try, /*On fail goto*//*Label 15219*/ GIMT_Encode4(1025124), // Rule ID 13253 //
     /* 1025052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1025063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1025066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1025072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025091 */     // MIs[0] policy
     /* 1025091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025101 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1025104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025123 */     // GIR_Coverage, 13253,
     /* 1025123 */     GIR_EraseRootFromParent_Done,
     /* 1025124 */   // Label 15219: @1025124
     /* 1025124 */   GIM_Try, /*On fail goto*//*Label 15220*/ GIMT_Encode4(1025201), // Rule ID 13256 //
     /* 1025129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1025132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1025140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1025143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1025146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1025149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025168 */     // MIs[0] policy
     /* 1025168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025178 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1025181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025200 */     // GIR_Coverage, 13256,
     /* 1025200 */     GIR_EraseRootFromParent_Done,
     /* 1025201 */   // Label 15220: @1025201
     /* 1025201 */   GIM_Try, /*On fail goto*//*Label 15221*/ GIMT_Encode4(1025278), // Rule ID 13257 //
     /* 1025206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1025217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1025220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1025226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025245 */     // MIs[0] policy
     /* 1025245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025255 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1025258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025277 */     // GIR_Coverage, 13257,
     /* 1025277 */     GIR_EraseRootFromParent_Done,
     /* 1025278 */   // Label 15221: @1025278
     /* 1025278 */   GIM_Try, /*On fail goto*//*Label 15222*/ GIMT_Encode4(1025355), // Rule ID 13260 //
     /* 1025283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1025286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1025294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1025297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1025300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1025303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025322 */     // MIs[0] policy
     /* 1025322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025332 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1025335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025354 */     // GIR_Coverage, 13260,
     /* 1025354 */     GIR_EraseRootFromParent_Done,
     /* 1025355 */   // Label 15222: @1025355
     /* 1025355 */   GIM_Try, /*On fail goto*//*Label 15223*/ GIMT_Encode4(1025432), // Rule ID 13261 //
     /* 1025360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1025371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1025374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1025380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025399 */     // MIs[0] policy
     /* 1025399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025409 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1025412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025431 */     // GIR_Coverage, 13261,
     /* 1025431 */     GIR_EraseRootFromParent_Done,
     /* 1025432 */   // Label 15223: @1025432
     /* 1025432 */   GIM_Try, /*On fail goto*//*Label 15224*/ GIMT_Encode4(1025509), // Rule ID 13264 //
     /* 1025437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1025448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1025451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1025454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1025457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025476 */     // MIs[0] policy
     /* 1025476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025486 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1025489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025508 */     // GIR_Coverage, 13264,
     /* 1025508 */     GIR_EraseRootFromParent_Done,
     /* 1025509 */   // Label 15224: @1025509
     /* 1025509 */   GIM_Try, /*On fail goto*//*Label 15225*/ GIMT_Encode4(1025586), // Rule ID 13265 //
     /* 1025514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1025525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1025528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1025531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1025534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025553 */     // MIs[0] policy
     /* 1025553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025563 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1025566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025585 */     // GIR_Coverage, 13265,
     /* 1025585 */     GIR_EraseRootFromParent_Done,
     /* 1025586 */   // Label 15225: @1025586
     /* 1025586 */   GIM_Try, /*On fail goto*//*Label 15226*/ GIMT_Encode4(1025663), // Rule ID 13268 //
     /* 1025591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1025602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1025605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1025608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1025611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025630 */     // MIs[0] policy
     /* 1025630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025640 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025662 */     // GIR_Coverage, 13268,
     /* 1025662 */     GIR_EraseRootFromParent_Done,
     /* 1025663 */   // Label 15226: @1025663
     /* 1025663 */   GIM_Try, /*On fail goto*//*Label 15227*/ GIMT_Encode4(1025740), // Rule ID 13269 //
     /* 1025668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1025679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1025682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1025685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1025688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025707 */     // MIs[0] policy
     /* 1025707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025717 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025739 */     // GIR_Coverage, 13269,
     /* 1025739 */     GIR_EraseRootFromParent_Done,
     /* 1025740 */   // Label 15227: @1025740
     /* 1025740 */   GIM_Try, /*On fail goto*//*Label 15228*/ GIMT_Encode4(1025817), // Rule ID 13272 //
     /* 1025745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1025756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1025759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1025762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1025765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025784 */     // MIs[0] policy
     /* 1025784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025794 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025816 */     // GIR_Coverage, 13272,
     /* 1025816 */     GIR_EraseRootFromParent_Done,
     /* 1025817 */   // Label 15228: @1025817
     /* 1025817 */   GIM_Try, /*On fail goto*//*Label 15229*/ GIMT_Encode4(1025894), // Rule ID 13273 //
     /* 1025822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1025833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1025836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1025839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1025842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025861 */     // MIs[0] policy
     /* 1025861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025871 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025893 */     // GIR_Coverage, 13273,
     /* 1025893 */     GIR_EraseRootFromParent_Done,
     /* 1025894 */   // Label 15229: @1025894
     /* 1025894 */   GIM_Try, /*On fail goto*//*Label 15230*/ GIMT_Encode4(1025971), // Rule ID 13276 //
     /* 1025899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1025916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025938 */     // MIs[0] policy
     /* 1025938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025948 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025970 */     // GIR_Coverage, 13276,
     /* 1025970 */     GIR_EraseRootFromParent_Done,
     /* 1025971 */   // Label 15230: @1025971
     /* 1025971 */   GIM_Try, /*On fail goto*//*Label 15231*/ GIMT_Encode4(1026048), // Rule ID 13277 //
     /* 1025976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1025993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026015 */     // MIs[0] policy
     /* 1026015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026025 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1026028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026047 */     // GIR_Coverage, 13277,
     /* 1026047 */     GIR_EraseRootFromParent_Done,
     /* 1026048 */   // Label 15231: @1026048
     /* 1026048 */   GIM_Try, /*On fail goto*//*Label 15232*/ GIMT_Encode4(1026125), // Rule ID 13280 //
     /* 1026053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1026064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1026067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1026070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1026073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026092 */     // MIs[0] policy
     /* 1026092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026102 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1026105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026124 */     // GIR_Coverage, 13280,
     /* 1026124 */     GIR_EraseRootFromParent_Done,
     /* 1026125 */   // Label 15232: @1026125
     /* 1026125 */   GIM_Try, /*On fail goto*//*Label 15233*/ GIMT_Encode4(1026202), // Rule ID 13281 //
     /* 1026130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1026141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1026144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1026147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1026150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026169 */     // MIs[0] policy
     /* 1026169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026179 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1026182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026201 */     // GIR_Coverage, 13281,
     /* 1026201 */     GIR_EraseRootFromParent_Done,
     /* 1026202 */   // Label 15233: @1026202
     /* 1026202 */   GIM_Try, /*On fail goto*//*Label 15234*/ GIMT_Encode4(1026279), // Rule ID 13284 //
     /* 1026207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1026218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1026221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1026224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1026227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026246 */     // MIs[0] policy
     /* 1026246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026256 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1026259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026278 */     // GIR_Coverage, 13284,
     /* 1026278 */     GIR_EraseRootFromParent_Done,
     /* 1026279 */   // Label 15234: @1026279
     /* 1026279 */   GIM_Try, /*On fail goto*//*Label 15235*/ GIMT_Encode4(1026356), // Rule ID 13285 //
     /* 1026284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1026295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1026298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1026301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1026304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026323 */     // MIs[0] policy
     /* 1026323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026333 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1026336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026355 */     // GIR_Coverage, 13285,
     /* 1026355 */     GIR_EraseRootFromParent_Done,
     /* 1026356 */   // Label 15235: @1026356
     /* 1026356 */   GIM_Try, /*On fail goto*//*Label 15236*/ GIMT_Encode4(1026433), // Rule ID 13288 //
     /* 1026361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1026372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1026375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1026381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026400 */     // MIs[0] policy
     /* 1026400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026410 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026432 */     // GIR_Coverage, 13288,
     /* 1026432 */     GIR_EraseRootFromParent_Done,
     /* 1026433 */   // Label 15236: @1026433
     /* 1026433 */   GIM_Try, /*On fail goto*//*Label 15237*/ GIMT_Encode4(1026510), // Rule ID 13289 //
     /* 1026438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1026449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1026452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1026458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026477 */     // MIs[0] policy
     /* 1026477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026487 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026509 */     // GIR_Coverage, 13289,
     /* 1026509 */     GIR_EraseRootFromParent_Done,
     /* 1026510 */   // Label 15237: @1026510
     /* 1026510 */   GIM_Try, /*On fail goto*//*Label 15238*/ GIMT_Encode4(1026587), // Rule ID 13292 //
     /* 1026515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1026526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1026529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1026532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1026535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026554 */     // MIs[0] policy
     /* 1026554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026586 */     // GIR_Coverage, 13292,
     /* 1026586 */     GIR_EraseRootFromParent_Done,
     /* 1026587 */   // Label 15238: @1026587
     /* 1026587 */   GIM_Try, /*On fail goto*//*Label 15239*/ GIMT_Encode4(1026664), // Rule ID 13293 //
     /* 1026592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1026603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1026606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1026609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1026612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026631 */     // MIs[0] policy
     /* 1026631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026641 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026663 */     // GIR_Coverage, 13293,
     /* 1026663 */     GIR_EraseRootFromParent_Done,
     /* 1026664 */   // Label 15239: @1026664
     /* 1026664 */   GIM_Try, /*On fail goto*//*Label 15240*/ GIMT_Encode4(1026741), // Rule ID 13296 //
     /* 1026669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1026686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1026689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026708 */     // MIs[0] policy
     /* 1026708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026740 */     // GIR_Coverage, 13296,
     /* 1026740 */     GIR_EraseRootFromParent_Done,
     /* 1026741 */   // Label 15240: @1026741
     /* 1026741 */   GIM_Try, /*On fail goto*//*Label 15241*/ GIMT_Encode4(1026818), // Rule ID 13297 //
     /* 1026746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1026763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1026766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026785 */     // MIs[0] policy
     /* 1026785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026795 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026817 */     // GIR_Coverage, 13297,
     /* 1026817 */     GIR_EraseRootFromParent_Done,
     /* 1026818 */   // Label 15241: @1026818
     /* 1026818 */   GIM_Try, /*On fail goto*//*Label 15242*/ GIMT_Encode4(1026895), // Rule ID 13300 //
     /* 1026823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1026826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1026834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1026837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1026840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1026843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026862 */     // MIs[0] policy
     /* 1026862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026872 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1026891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026894 */     // GIR_Coverage, 13300,
     /* 1026894 */     GIR_EraseRootFromParent_Done,
     /* 1026895 */   // Label 15242: @1026895
     /* 1026895 */   GIM_Try, /*On fail goto*//*Label 15243*/ GIMT_Encode4(1026972), // Rule ID 13301 //
     /* 1026900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1026903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1026911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1026914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1026917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1026920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026939 */     // MIs[0] policy
     /* 1026939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026949 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1026968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026971 */     // GIR_Coverage, 13301,
     /* 1026971 */     GIR_EraseRootFromParent_Done,
     /* 1026972 */   // Label 15243: @1026972
     /* 1026972 */   GIM_Try, /*On fail goto*//*Label 15244*/ GIMT_Encode4(1027049), // Rule ID 13304 //
     /* 1026977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1026988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1026991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1026994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027016 */     // MIs[0] policy
     /* 1027016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027048 */     // GIR_Coverage, 13304,
     /* 1027048 */     GIR_EraseRootFromParent_Done,
     /* 1027049 */   // Label 15244: @1027049
     /* 1027049 */   GIM_Try, /*On fail goto*//*Label 15245*/ GIMT_Encode4(1027126), // Rule ID 13305 //
     /* 1027054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1027065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1027068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1027071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1027074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027093 */     // MIs[0] policy
     /* 1027093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027103 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027125 */     // GIR_Coverage, 13305,
     /* 1027125 */     GIR_EraseRootFromParent_Done,
     /* 1027126 */   // Label 15245: @1027126
     /* 1027126 */   GIM_Try, /*On fail goto*//*Label 15246*/ GIMT_Encode4(1027203), // Rule ID 13308 //
     /* 1027131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1027142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1027145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1027148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1027151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027170 */     // MIs[0] policy
     /* 1027170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027180 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027202 */     // GIR_Coverage, 13308,
     /* 1027202 */     GIR_EraseRootFromParent_Done,
     /* 1027203 */   // Label 15246: @1027203
     /* 1027203 */   GIM_Try, /*On fail goto*//*Label 15247*/ GIMT_Encode4(1027280), // Rule ID 13309 //
     /* 1027208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1027219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1027222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1027225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1027228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027247 */     // MIs[0] policy
     /* 1027247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027257 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027279 */     // GIR_Coverage, 13309,
     /* 1027279 */     GIR_EraseRootFromParent_Done,
     /* 1027280 */   // Label 15247: @1027280
     /* 1027280 */   GIM_Try, /*On fail goto*//*Label 15248*/ GIMT_Encode4(1027357), // Rule ID 13312 //
     /* 1027285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1027296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1027299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1027302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1027305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027324 */     // MIs[0] policy
     /* 1027324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027334 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027356 */     // GIR_Coverage, 13312,
     /* 1027356 */     GIR_EraseRootFromParent_Done,
     /* 1027357 */   // Label 15248: @1027357
     /* 1027357 */   GIM_Try, /*On fail goto*//*Label 15249*/ GIMT_Encode4(1027434), // Rule ID 13313 //
     /* 1027362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1027373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1027376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1027379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1027382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027401 */     // MIs[0] policy
     /* 1027401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027411 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027433 */     // GIR_Coverage, 13313,
     /* 1027433 */     GIR_EraseRootFromParent_Done,
     /* 1027434 */   // Label 15249: @1027434
     /* 1027434 */   GIM_Try, /*On fail goto*//*Label 15250*/ GIMT_Encode4(1027511), // Rule ID 13316 //
     /* 1027439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1027450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1027453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1027456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1027459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027478 */     // MIs[0] policy
     /* 1027478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027488 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027510 */     // GIR_Coverage, 13316,
     /* 1027510 */     GIR_EraseRootFromParent_Done,
     /* 1027511 */   // Label 15250: @1027511
     /* 1027511 */   GIM_Try, /*On fail goto*//*Label 15251*/ GIMT_Encode4(1027588), // Rule ID 13317 //
     /* 1027516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1027527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1027530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1027533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1027536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027555 */     // MIs[0] policy
     /* 1027555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027565 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027587 */     // GIR_Coverage, 13317,
     /* 1027587 */     GIR_EraseRootFromParent_Done,
     /* 1027588 */   // Label 15251: @1027588
     /* 1027588 */   GIM_Try, /*On fail goto*//*Label 15252*/ GIMT_Encode4(1027665), // Rule ID 13320 //
     /* 1027593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1027604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1027607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1027610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1027613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027632 */     // MIs[0] policy
     /* 1027632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027642 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027664 */     // GIR_Coverage, 13320,
     /* 1027664 */     GIR_EraseRootFromParent_Done,
     /* 1027665 */   // Label 15252: @1027665
     /* 1027665 */   GIM_Try, /*On fail goto*//*Label 15253*/ GIMT_Encode4(1027742), // Rule ID 13321 //
     /* 1027670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1027681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1027684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1027687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1027690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027709 */     // MIs[0] policy
     /* 1027709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027719 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027741 */     // GIR_Coverage, 13321,
     /* 1027741 */     GIR_EraseRootFromParent_Done,
     /* 1027742 */   // Label 15253: @1027742
     /* 1027742 */   GIM_Try, /*On fail goto*//*Label 15254*/ GIMT_Encode4(1027819), // Rule ID 13324 //
     /* 1027747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1027758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1027761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1027764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1027767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027786 */     // MIs[0] policy
     /* 1027786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027796 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027818 */     // GIR_Coverage, 13324,
     /* 1027818 */     GIR_EraseRootFromParent_Done,
     /* 1027819 */   // Label 15254: @1027819
     /* 1027819 */   GIM_Try, /*On fail goto*//*Label 15255*/ GIMT_Encode4(1027896), // Rule ID 13325 //
     /* 1027824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1027835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1027838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1027841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1027844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027863 */     // MIs[0] policy
     /* 1027863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027873 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027895 */     // GIR_Coverage, 13325,
     /* 1027895 */     GIR_EraseRootFromParent_Done,
     /* 1027896 */   // Label 15255: @1027896
     /* 1027896 */   GIM_Try, /*On fail goto*//*Label 15256*/ GIMT_Encode4(1027973), // Rule ID 13328 //
     /* 1027901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1027918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027940 */     // MIs[0] policy
     /* 1027940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027972 */     // GIR_Coverage, 13328,
     /* 1027972 */     GIR_EraseRootFromParent_Done,
     /* 1027973 */   // Label 15256: @1027973
     /* 1027973 */   GIM_Try, /*On fail goto*//*Label 15257*/ GIMT_Encode4(1028050), // Rule ID 13329 //
     /* 1027978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1027995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028017 */     // MIs[0] policy
     /* 1028017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028027 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1028030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028049 */     // GIR_Coverage, 13329,
     /* 1028049 */     GIR_EraseRootFromParent_Done,
     /* 1028050 */   // Label 15257: @1028050
     /* 1028050 */   GIM_Try, /*On fail goto*//*Label 15258*/ GIMT_Encode4(1028127), // Rule ID 13332 //
     /* 1028055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1028066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1028069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1028072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1028075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028094 */     // MIs[0] policy
     /* 1028094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028104 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1028107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028126 */     // GIR_Coverage, 13332,
     /* 1028126 */     GIR_EraseRootFromParent_Done,
     /* 1028127 */   // Label 15258: @1028127
     /* 1028127 */   GIM_Try, /*On fail goto*//*Label 15259*/ GIMT_Encode4(1028204), // Rule ID 13333 //
     /* 1028132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1028143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1028146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1028149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1028152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028171 */     // MIs[0] policy
     /* 1028171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028181 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1028184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028203 */     // GIR_Coverage, 13333,
     /* 1028203 */     GIR_EraseRootFromParent_Done,
     /* 1028204 */   // Label 15259: @1028204
     /* 1028204 */   GIM_Try, /*On fail goto*//*Label 15260*/ GIMT_Encode4(1028281), // Rule ID 13336 //
     /* 1028209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1028220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1028223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1028226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1028229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028248 */     // MIs[0] policy
     /* 1028248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028258 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1028261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028280 */     // GIR_Coverage, 13336,
     /* 1028280 */     GIR_EraseRootFromParent_Done,
     /* 1028281 */   // Label 15260: @1028281
     /* 1028281 */   GIM_Try, /*On fail goto*//*Label 15261*/ GIMT_Encode4(1028358), // Rule ID 13337 //
     /* 1028286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1028297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1028300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1028303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1028306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028325 */     // MIs[0] policy
     /* 1028325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028335 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1028338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028357 */     // GIR_Coverage, 13337,
     /* 1028357 */     GIR_EraseRootFromParent_Done,
     /* 1028358 */   // Label 15261: @1028358
     /* 1028358 */   GIM_Try, /*On fail goto*//*Label 15262*/ GIMT_Encode4(1028435), // Rule ID 13340 //
     /* 1028363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1028374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1028377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1028380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1028383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028402 */     // MIs[0] policy
     /* 1028402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028412 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1028415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028434 */     // GIR_Coverage, 13340,
     /* 1028434 */     GIR_EraseRootFromParent_Done,
     /* 1028435 */   // Label 15262: @1028435
     /* 1028435 */   GIM_Try, /*On fail goto*//*Label 15263*/ GIMT_Encode4(1028512), // Rule ID 13341 //
     /* 1028440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1028451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1028454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1028457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1028460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028479 */     // MIs[0] policy
     /* 1028479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028489 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1028492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028511 */     // GIR_Coverage, 13341,
     /* 1028511 */     GIR_EraseRootFromParent_Done,
     /* 1028512 */   // Label 15263: @1028512
     /* 1028512 */   GIM_Try, /*On fail goto*//*Label 15264*/ GIMT_Encode4(1028589), // Rule ID 13344 //
     /* 1028517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1028528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1028531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1028534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1028537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028556 */     // MIs[0] policy
     /* 1028556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028566 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1028569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028588 */     // GIR_Coverage, 13344,
     /* 1028588 */     GIR_EraseRootFromParent_Done,
     /* 1028589 */   // Label 15264: @1028589
     /* 1028589 */   GIM_Try, /*On fail goto*//*Label 15265*/ GIMT_Encode4(1028666), // Rule ID 13345 //
     /* 1028594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1028605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1028608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1028611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1028614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028633 */     // MIs[0] policy
     /* 1028633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028643 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1028646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028665 */     // GIR_Coverage, 13345,
     /* 1028665 */     GIR_EraseRootFromParent_Done,
     /* 1028666 */   // Label 15265: @1028666
     /* 1028666 */   GIM_Try, /*On fail goto*//*Label 15266*/ GIMT_Encode4(1028743), // Rule ID 13348 //
     /* 1028671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1028682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1028685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1028688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1028691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028710 */     // MIs[0] policy
     /* 1028710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028720 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1028723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028742 */     // GIR_Coverage, 13348,
     /* 1028742 */     GIR_EraseRootFromParent_Done,
     /* 1028743 */   // Label 15266: @1028743
     /* 1028743 */   GIM_Try, /*On fail goto*//*Label 15267*/ GIMT_Encode4(1028820), // Rule ID 13349 //
     /* 1028748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1028759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1028762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1028765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1028768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028787 */     // MIs[0] policy
     /* 1028787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028797 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1028800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028819 */     // GIR_Coverage, 13349,
     /* 1028819 */     GIR_EraseRootFromParent_Done,
     /* 1028820 */   // Label 15267: @1028820
     /* 1028820 */   GIM_Try, /*On fail goto*//*Label 15268*/ GIMT_Encode4(1028897), // Rule ID 13352 //
     /* 1028825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1028836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1028839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1028845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028864 */     // MIs[0] policy
     /* 1028864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028874 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1028877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028896 */     // GIR_Coverage, 13352,
     /* 1028896 */     GIR_EraseRootFromParent_Done,
     /* 1028897 */   // Label 15268: @1028897
     /* 1028897 */   GIM_Try, /*On fail goto*//*Label 15269*/ GIMT_Encode4(1028974), // Rule ID 13353 //
     /* 1028902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1028913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1028916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1028922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028941 */     // MIs[0] policy
     /* 1028941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028951 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1028954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028973 */     // GIR_Coverage, 13353,
     /* 1028973 */     GIR_EraseRootFromParent_Done,
     /* 1028974 */   // Label 15269: @1028974
     /* 1028974 */   GIM_Try, /*On fail goto*//*Label 15270*/ GIMT_Encode4(1029051), // Rule ID 13356 //
     /* 1028979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1028990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1028993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1028999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029018 */     // MIs[0] policy
     /* 1029018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029028 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1029031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029050 */     // GIR_Coverage, 13356,
     /* 1029050 */     GIR_EraseRootFromParent_Done,
     /* 1029051 */   // Label 15270: @1029051
     /* 1029051 */   GIM_Try, /*On fail goto*//*Label 15271*/ GIMT_Encode4(1029128), // Rule ID 13357 //
     /* 1029056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1029067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1029070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1029076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029095 */     // MIs[0] policy
     /* 1029095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029105 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1029108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029127 */     // GIR_Coverage, 13357,
     /* 1029127 */     GIR_EraseRootFromParent_Done,
     /* 1029128 */   // Label 15271: @1029128
     /* 1029128 */   GIM_Try, /*On fail goto*//*Label 15272*/ GIMT_Encode4(1029205), // Rule ID 13360 //
     /* 1029133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1029144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1029147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1029153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029172 */     // MIs[0] policy
     /* 1029172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029182 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029204 */     // GIR_Coverage, 13360,
     /* 1029204 */     GIR_EraseRootFromParent_Done,
     /* 1029205 */   // Label 15272: @1029205
     /* 1029205 */   GIM_Try, /*On fail goto*//*Label 15273*/ GIMT_Encode4(1029282), // Rule ID 13361 //
     /* 1029210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1029221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1029224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1029230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029249 */     // MIs[0] policy
     /* 1029249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029259 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029281 */     // GIR_Coverage, 13361,
     /* 1029281 */     GIR_EraseRootFromParent_Done,
     /* 1029282 */   // Label 15273: @1029282
     /* 1029282 */   GIM_Try, /*On fail goto*//*Label 15274*/ GIMT_Encode4(1029359), // Rule ID 13364 //
     /* 1029287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1029298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1029301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1029307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029326 */     // MIs[0] policy
     /* 1029326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029336 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1029339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029358 */     // GIR_Coverage, 13364,
     /* 1029358 */     GIR_EraseRootFromParent_Done,
     /* 1029359 */   // Label 15274: @1029359
     /* 1029359 */   GIM_Try, /*On fail goto*//*Label 15275*/ GIMT_Encode4(1029436), // Rule ID 13365 //
     /* 1029364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1029375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1029378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1029384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029403 */     // MIs[0] policy
     /* 1029403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029413 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1029416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029435 */     // GIR_Coverage, 13365,
     /* 1029435 */     GIR_EraseRootFromParent_Done,
     /* 1029436 */   // Label 15275: @1029436
     /* 1029436 */   GIM_Try, /*On fail goto*//*Label 15276*/ GIMT_Encode4(1029513), // Rule ID 13368 //
     /* 1029441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1029452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1029455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1029461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029480 */     // MIs[0] policy
     /* 1029480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029490 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029512 */     // GIR_Coverage, 13368,
     /* 1029512 */     GIR_EraseRootFromParent_Done,
     /* 1029513 */   // Label 15276: @1029513
     /* 1029513 */   GIM_Try, /*On fail goto*//*Label 15277*/ GIMT_Encode4(1029590), // Rule ID 13369 //
     /* 1029518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1029529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1029532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1029538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029557 */     // MIs[0] policy
     /* 1029557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029567 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029589 */     // GIR_Coverage, 13369,
     /* 1029589 */     GIR_EraseRootFromParent_Done,
     /* 1029590 */   // Label 15277: @1029590
     /* 1029590 */   GIM_Try, /*On fail goto*//*Label 15278*/ GIMT_Encode4(1029667), // Rule ID 13372 //
     /* 1029595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1029615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029634 */     // MIs[0] policy
     /* 1029634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029644 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029666 */     // GIR_Coverage, 13372,
     /* 1029666 */     GIR_EraseRootFromParent_Done,
     /* 1029667 */   // Label 15278: @1029667
     /* 1029667 */   GIM_Try, /*On fail goto*//*Label 15279*/ GIMT_Encode4(1029744), // Rule ID 13373 //
     /* 1029672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1029692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029711 */     // MIs[0] policy
     /* 1029711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029743 */     // GIR_Coverage, 13373,
     /* 1029743 */     GIR_EraseRootFromParent_Done,
     /* 1029744 */   // Label 15279: @1029744
     /* 1029744 */   GIM_Try, /*On fail goto*//*Label 15280*/ GIMT_Encode4(1029821), // Rule ID 13376 //
     /* 1029749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1029760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1029763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029788 */     // MIs[0] policy
     /* 1029788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029798 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029820 */     // GIR_Coverage, 13376,
     /* 1029820 */     GIR_EraseRootFromParent_Done,
     /* 1029821 */   // Label 15280: @1029821
     /* 1029821 */   GIM_Try, /*On fail goto*//*Label 15281*/ GIMT_Encode4(1029898), // Rule ID 13377 //
     /* 1029826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1029837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1029840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029865 */     // MIs[0] policy
     /* 1029865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029875 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029897 */     // GIR_Coverage, 13377,
     /* 1029897 */     GIR_EraseRootFromParent_Done,
     /* 1029898 */   // Label 15281: @1029898
     /* 1029898 */   GIM_Try, /*On fail goto*//*Label 15282*/ GIMT_Encode4(1029975), // Rule ID 13380 //
     /* 1029903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1029923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029942 */     // MIs[0] policy
     /* 1029942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029974 */     // GIR_Coverage, 13380,
     /* 1029974 */     GIR_EraseRootFromParent_Done,
     /* 1029975 */   // Label 15282: @1029975
     /* 1029975 */   GIM_Try, /*On fail goto*//*Label 15283*/ GIMT_Encode4(1030052), // Rule ID 13381 //
     /* 1029980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1030000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030019 */     // MIs[0] policy
     /* 1030019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030029 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1030032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030051 */     // GIR_Coverage, 13381,
     /* 1030051 */     GIR_EraseRootFromParent_Done,
     /* 1030052 */   // Label 15283: @1030052
     /* 1030052 */   GIM_Try, /*On fail goto*//*Label 15284*/ GIMT_Encode4(1030129), // Rule ID 13384 //
     /* 1030057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1030068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1030071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1030077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030096 */     // MIs[0] policy
     /* 1030096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030106 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1030109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030128 */     // GIR_Coverage, 13384,
     /* 1030128 */     GIR_EraseRootFromParent_Done,
     /* 1030129 */   // Label 15284: @1030129
     /* 1030129 */   GIM_Try, /*On fail goto*//*Label 15285*/ GIMT_Encode4(1030206), // Rule ID 13385 //
     /* 1030134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1030145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1030148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1030154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030173 */     // MIs[0] policy
     /* 1030173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030183 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1030186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030205 */     // GIR_Coverage, 13385,
     /* 1030205 */     GIR_EraseRootFromParent_Done,
     /* 1030206 */   // Label 15285: @1030206
     /* 1030206 */   GIM_Try, /*On fail goto*//*Label 15286*/ GIMT_Encode4(1030283), // Rule ID 13388 //
     /* 1030211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1030214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1030222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1030225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1030231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030250 */     // MIs[0] policy
     /* 1030250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030260 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1030263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1030279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030282 */     // GIR_Coverage, 13388,
     /* 1030282 */     GIR_EraseRootFromParent_Done,
     /* 1030283 */   // Label 15286: @1030283
     /* 1030283 */   GIM_Try, /*On fail goto*//*Label 15287*/ GIMT_Encode4(1030360), // Rule ID 13389 //
     /* 1030288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1030291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1030299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1030302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1030308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030327 */     // MIs[0] policy
     /* 1030327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030337 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1030340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1030356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030359 */     // GIR_Coverage, 13389,
     /* 1030359 */     GIR_EraseRootFromParent_Done,
     /* 1030360 */   // Label 15287: @1030360
     /* 1030360 */   GIM_Try, /*On fail goto*//*Label 15288*/ GIMT_Encode4(1030437), // Rule ID 13392 //
     /* 1030365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1030376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1030379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1030385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030404 */     // MIs[0] policy
     /* 1030404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030414 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030436 */     // GIR_Coverage, 13392,
     /* 1030436 */     GIR_EraseRootFromParent_Done,
     /* 1030437 */   // Label 15288: @1030437
     /* 1030437 */   GIM_Try, /*On fail goto*//*Label 15289*/ GIMT_Encode4(1030514), // Rule ID 13393 //
     /* 1030442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1030453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1030456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1030462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030481 */     // MIs[0] policy
     /* 1030481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030491 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030513 */     // GIR_Coverage, 13393,
     /* 1030513 */     GIR_EraseRootFromParent_Done,
     /* 1030514 */   // Label 15289: @1030514
     /* 1030514 */   GIM_Try, /*On fail goto*//*Label 15290*/ GIMT_Encode4(1030591), // Rule ID 13396 //
     /* 1030519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1030530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1030533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1030539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030558 */     // MIs[0] policy
     /* 1030558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030568 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030590 */     // GIR_Coverage, 13396,
     /* 1030590 */     GIR_EraseRootFromParent_Done,
     /* 1030591 */   // Label 15290: @1030591
     /* 1030591 */   GIM_Try, /*On fail goto*//*Label 15291*/ GIMT_Encode4(1030668), // Rule ID 13397 //
     /* 1030596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1030607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1030610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1030616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030635 */     // MIs[0] policy
     /* 1030635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030645 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030667 */     // GIR_Coverage, 13397,
     /* 1030667 */     GIR_EraseRootFromParent_Done,
     /* 1030668 */   // Label 15291: @1030668
     /* 1030668 */   GIM_Try, /*On fail goto*//*Label 15292*/ GIMT_Encode4(1030745), // Rule ID 13400 //
     /* 1030673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1030684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1030687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1030693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030712 */     // MIs[0] policy
     /* 1030712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030722 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030744 */     // GIR_Coverage, 13400,
     /* 1030744 */     GIR_EraseRootFromParent_Done,
     /* 1030745 */   // Label 15292: @1030745
     /* 1030745 */   GIM_Try, /*On fail goto*//*Label 15293*/ GIMT_Encode4(1030822), // Rule ID 13401 //
     /* 1030750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1030761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1030764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1030770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030789 */     // MIs[0] policy
     /* 1030789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030799 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030821 */     // GIR_Coverage, 13401,
     /* 1030821 */     GIR_EraseRootFromParent_Done,
     /* 1030822 */   // Label 15293: @1030822
     /* 1030822 */   GIM_Try, /*On fail goto*//*Label 15294*/ GIMT_Encode4(1030899), // Rule ID 13404 //
     /* 1030827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1030838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1030841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1030847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030866 */     // MIs[0] policy
     /* 1030866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030898 */     // GIR_Coverage, 13404,
     /* 1030898 */     GIR_EraseRootFromParent_Done,
     /* 1030899 */   // Label 15294: @1030899
     /* 1030899 */   GIM_Try, /*On fail goto*//*Label 15295*/ GIMT_Encode4(1030976), // Rule ID 13405 //
     /* 1030904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1030915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1030918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1030924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030943 */     // MIs[0] policy
     /* 1030943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030953 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030975 */     // GIR_Coverage, 13405,
     /* 1030975 */     GIR_EraseRootFromParent_Done,
     /* 1030976 */   // Label 15295: @1030976
     /* 1030976 */   GIM_Try, /*On fail goto*//*Label 15296*/ GIMT_Encode4(1031053), // Rule ID 13408 //
     /* 1030981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1030992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1030995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1031001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031020 */     // MIs[0] policy
     /* 1031020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031030 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031052 */     // GIR_Coverage, 13408,
     /* 1031052 */     GIR_EraseRootFromParent_Done,
     /* 1031053 */   // Label 15296: @1031053
     /* 1031053 */   GIM_Try, /*On fail goto*//*Label 15297*/ GIMT_Encode4(1031130), // Rule ID 13409 //
     /* 1031058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1031069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1031072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1031078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031097 */     // MIs[0] policy
     /* 1031097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031107 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031129 */     // GIR_Coverage, 13409,
     /* 1031129 */     GIR_EraseRootFromParent_Done,
     /* 1031130 */   // Label 15297: @1031130
     /* 1031130 */   GIM_Try, /*On fail goto*//*Label 15298*/ GIMT_Encode4(1031207), // Rule ID 13412 //
     /* 1031135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1031146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1031149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1031155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031174 */     // MIs[0] policy
     /* 1031174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031184 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031206 */     // GIR_Coverage, 13412,
     /* 1031206 */     GIR_EraseRootFromParent_Done,
     /* 1031207 */   // Label 15298: @1031207
     /* 1031207 */   GIM_Try, /*On fail goto*//*Label 15299*/ GIMT_Encode4(1031284), // Rule ID 13413 //
     /* 1031212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1031223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1031226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1031232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031251 */     // MIs[0] policy
     /* 1031251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031261 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031283 */     // GIR_Coverage, 13413,
     /* 1031283 */     GIR_EraseRootFromParent_Done,
     /* 1031284 */   // Label 15299: @1031284
     /* 1031284 */   GIM_Try, /*On fail goto*//*Label 15300*/ GIMT_Encode4(1031361), // Rule ID 13416 //
     /* 1031289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1031300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1031303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1031309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031328 */     // MIs[0] policy
     /* 1031328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1031341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031360 */     // GIR_Coverage, 13416,
     /* 1031360 */     GIR_EraseRootFromParent_Done,
     /* 1031361 */   // Label 15300: @1031361
     /* 1031361 */   GIM_Try, /*On fail goto*//*Label 15301*/ GIMT_Encode4(1031438), // Rule ID 13417 //
     /* 1031366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1031377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1031380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1031386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031405 */     // MIs[0] policy
     /* 1031405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1031418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031437 */     // GIR_Coverage, 13417,
     /* 1031437 */     GIR_EraseRootFromParent_Done,
     /* 1031438 */   // Label 15301: @1031438
     /* 1031438 */   GIM_Try, /*On fail goto*//*Label 15302*/ GIMT_Encode4(1031515), // Rule ID 13420 //
     /* 1031443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1031454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1031457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1031463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031482 */     // MIs[0] policy
     /* 1031482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031492 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031514 */     // GIR_Coverage, 13420,
     /* 1031514 */     GIR_EraseRootFromParent_Done,
     /* 1031515 */   // Label 15302: @1031515
     /* 1031515 */   GIM_Try, /*On fail goto*//*Label 15303*/ GIMT_Encode4(1031592), // Rule ID 13421 //
     /* 1031520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1031531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1031534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1031540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031559 */     // MIs[0] policy
     /* 1031559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031569 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031591 */     // GIR_Coverage, 13421,
     /* 1031591 */     GIR_EraseRootFromParent_Done,
     /* 1031592 */   // Label 15303: @1031592
     /* 1031592 */   GIM_Try, /*On fail goto*//*Label 15304*/ GIMT_Encode4(1031669), // Rule ID 13424 //
     /* 1031597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1031608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1031611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1031617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031636 */     // MIs[0] policy
     /* 1031636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031668 */     // GIR_Coverage, 13424,
     /* 1031668 */     GIR_EraseRootFromParent_Done,
     /* 1031669 */   // Label 15304: @1031669
     /* 1031669 */   GIM_Try, /*On fail goto*//*Label 15305*/ GIMT_Encode4(1031746), // Rule ID 13425 //
     /* 1031674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1031685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1031688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1031694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031713 */     // MIs[0] policy
     /* 1031713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031723 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031745 */     // GIR_Coverage, 13425,
     /* 1031745 */     GIR_EraseRootFromParent_Done,
     /* 1031746 */   // Label 15305: @1031746
     /* 1031746 */   GIM_Try, /*On fail goto*//*Label 15306*/ GIMT_Encode4(1031823), // Rule ID 13428 //
     /* 1031751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1031762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1031765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1031771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031790 */     // MIs[0] policy
     /* 1031790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031800 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1031803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031822 */     // GIR_Coverage, 13428,
     /* 1031822 */     GIR_EraseRootFromParent_Done,
     /* 1031823 */   // Label 15306: @1031823
     /* 1031823 */   GIM_Try, /*On fail goto*//*Label 15307*/ GIMT_Encode4(1031900), // Rule ID 13429 //
     /* 1031828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1031839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1031842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1031848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031867 */     // MIs[0] policy
     /* 1031867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031877 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1031880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031899 */     // GIR_Coverage, 13429,
     /* 1031899 */     GIR_EraseRootFromParent_Done,
     /* 1031900 */   // Label 15307: @1031900
     /* 1031900 */   GIM_Try, /*On fail goto*//*Label 15308*/ GIMT_Encode4(1031977), // Rule ID 13432 //
     /* 1031905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1031925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031944 */     // MIs[0] policy
     /* 1031944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031954 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031976 */     // GIR_Coverage, 13432,
     /* 1031976 */     GIR_EraseRootFromParent_Done,
     /* 1031977 */   // Label 15308: @1031977
     /* 1031977 */   GIM_Try, /*On fail goto*//*Label 15309*/ GIMT_Encode4(1032054), // Rule ID 13433 //
     /* 1031982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1032002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032021 */     // MIs[0] policy
     /* 1032021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032031 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1032034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1032050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032053 */     // GIR_Coverage, 13433,
     /* 1032053 */     GIR_EraseRootFromParent_Done,
     /* 1032054 */   // Label 15309: @1032054
     /* 1032054 */   GIM_Try, /*On fail goto*//*Label 15310*/ GIMT_Encode4(1032131), // Rule ID 13436 //
     /* 1032059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1032062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1032070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1032073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1032079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032098 */     // MIs[0] policy
     /* 1032098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032108 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1032111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1032127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032130 */     // GIR_Coverage, 13436,
     /* 1032130 */     GIR_EraseRootFromParent_Done,
     /* 1032131 */   // Label 15310: @1032131
     /* 1032131 */   GIM_Try, /*On fail goto*//*Label 15311*/ GIMT_Encode4(1032208), // Rule ID 13437 //
     /* 1032136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1032139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1032147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1032150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1032153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1032156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032175 */     // MIs[0] policy
     /* 1032175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032185 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1032188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1032204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032207 */     // GIR_Coverage, 13437,
     /* 1032207 */     GIR_EraseRootFromParent_Done,
     /* 1032208 */   // Label 15311: @1032208
     /* 1032208 */   GIM_Try, /*On fail goto*//*Label 15312*/ GIMT_Encode4(1032285), // Rule ID 13440 //
     /* 1032213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1032224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1032227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1032230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1032233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032252 */     // MIs[0] policy
     /* 1032252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032262 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1032265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032284 */     // GIR_Coverage, 13440,
     /* 1032284 */     GIR_EraseRootFromParent_Done,
     /* 1032285 */   // Label 15312: @1032285
     /* 1032285 */   GIM_Try, /*On fail goto*//*Label 15313*/ GIMT_Encode4(1032362), // Rule ID 13441 //
     /* 1032290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1032301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1032304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1032307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1032310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032329 */     // MIs[0] policy
     /* 1032329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032339 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1032342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032361 */     // GIR_Coverage, 13441,
     /* 1032361 */     GIR_EraseRootFromParent_Done,
     /* 1032362 */   // Label 15313: @1032362
     /* 1032362 */   GIM_Try, /*On fail goto*//*Label 15314*/ GIMT_Encode4(1032439), // Rule ID 13444 //
     /* 1032367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1032378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1032381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1032384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1032387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032406 */     // MIs[0] policy
     /* 1032406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032416 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1032419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032438 */     // GIR_Coverage, 13444,
     /* 1032438 */     GIR_EraseRootFromParent_Done,
     /* 1032439 */   // Label 15314: @1032439
     /* 1032439 */   GIM_Try, /*On fail goto*//*Label 15315*/ GIMT_Encode4(1032516), // Rule ID 13445 //
     /* 1032444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1032455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1032458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1032461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1032464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032483 */     // MIs[0] policy
     /* 1032483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1032496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032515 */     // GIR_Coverage, 13445,
     /* 1032515 */     GIR_EraseRootFromParent_Done,
     /* 1032516 */   // Label 15315: @1032516
     /* 1032516 */   GIM_Try, /*On fail goto*//*Label 15316*/ GIMT_Encode4(1032593), // Rule ID 13448 //
     /* 1032521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1032532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1032535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1032538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1032541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032560 */     // MIs[0] policy
     /* 1032560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032570 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032592 */     // GIR_Coverage, 13448,
     /* 1032592 */     GIR_EraseRootFromParent_Done,
     /* 1032593 */   // Label 15316: @1032593
     /* 1032593 */   GIM_Try, /*On fail goto*//*Label 15317*/ GIMT_Encode4(1032670), // Rule ID 13449 //
     /* 1032598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1032609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1032612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1032615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1032618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032637 */     // MIs[0] policy
     /* 1032637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032647 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032669 */     // GIR_Coverage, 13449,
     /* 1032669 */     GIR_EraseRootFromParent_Done,
     /* 1032670 */   // Label 15317: @1032670
     /* 1032670 */   GIM_Try, /*On fail goto*//*Label 15318*/ GIMT_Encode4(1032747), // Rule ID 13452 //
     /* 1032675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1032686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1032689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1032692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1032695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032714 */     // MIs[0] policy
     /* 1032714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1032727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032746 */     // GIR_Coverage, 13452,
     /* 1032746 */     GIR_EraseRootFromParent_Done,
     /* 1032747 */   // Label 15318: @1032747
     /* 1032747 */   GIM_Try, /*On fail goto*//*Label 15319*/ GIMT_Encode4(1032824), // Rule ID 13453 //
     /* 1032752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1032763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1032766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1032769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1032772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032791 */     // MIs[0] policy
     /* 1032791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032801 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1032804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032823 */     // GIR_Coverage, 13453,
     /* 1032823 */     GIR_EraseRootFromParent_Done,
     /* 1032824 */   // Label 15319: @1032824
     /* 1032824 */   GIM_Try, /*On fail goto*//*Label 15320*/ GIMT_Encode4(1032901), // Rule ID 13456 //
     /* 1032829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1032840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1032843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1032846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1032849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032868 */     // MIs[0] policy
     /* 1032868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032878 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1032881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032900 */     // GIR_Coverage, 13456,
     /* 1032900 */     GIR_EraseRootFromParent_Done,
     /* 1032901 */   // Label 15320: @1032901
     /* 1032901 */   GIM_Try, /*On fail goto*//*Label 15321*/ GIMT_Encode4(1032978), // Rule ID 13457 //
     /* 1032906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1032917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1032920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1032923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1032926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032945 */     // MIs[0] policy
     /* 1032945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032955 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1032958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032977 */     // GIR_Coverage, 13457,
     /* 1032977 */     GIR_EraseRootFromParent_Done,
     /* 1032978 */   // Label 15321: @1032978
     /* 1032978 */   GIM_Try, /*On fail goto*//*Label 15322*/ GIMT_Encode4(1033055), // Rule ID 13460 //
     /* 1032983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1032994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1032997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1033000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1033003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033022 */     // MIs[0] policy
     /* 1033022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033032 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033054 */     // GIR_Coverage, 13460,
     /* 1033054 */     GIR_EraseRootFromParent_Done,
     /* 1033055 */   // Label 15322: @1033055
     /* 1033055 */   GIM_Try, /*On fail goto*//*Label 15323*/ GIMT_Encode4(1033132), // Rule ID 13461 //
     /* 1033060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1033071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1033074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1033077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1033080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033099 */     // MIs[0] policy
     /* 1033099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033109 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033131 */     // GIR_Coverage, 13461,
     /* 1033131 */     GIR_EraseRootFromParent_Done,
     /* 1033132 */   // Label 15323: @1033132
     /* 1033132 */   GIM_Try, /*On fail goto*//*Label 15324*/ GIMT_Encode4(1033209), // Rule ID 13464 //
     /* 1033137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1033148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1033151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1033154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1033157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033176 */     // MIs[0] policy
     /* 1033176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1033189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033208 */     // GIR_Coverage, 13464,
     /* 1033208 */     GIR_EraseRootFromParent_Done,
     /* 1033209 */   // Label 15324: @1033209
     /* 1033209 */   GIM_Try, /*On fail goto*//*Label 15325*/ GIMT_Encode4(1033286), // Rule ID 13465 //
     /* 1033214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1033225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1033228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1033231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1033234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033253 */     // MIs[0] policy
     /* 1033253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033263 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1033266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033285 */     // GIR_Coverage, 13465,
     /* 1033285 */     GIR_EraseRootFromParent_Done,
     /* 1033286 */   // Label 15325: @1033286
     /* 1033286 */   GIM_Try, /*On fail goto*//*Label 15326*/ GIMT_Encode4(1033363), // Rule ID 13468 //
     /* 1033291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1033302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1033305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1033308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1033311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033330 */     // MIs[0] policy
     /* 1033330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1033343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033362 */     // GIR_Coverage, 13468,
     /* 1033362 */     GIR_EraseRootFromParent_Done,
     /* 1033363 */   // Label 15326: @1033363
     /* 1033363 */   GIM_Try, /*On fail goto*//*Label 15327*/ GIMT_Encode4(1033440), // Rule ID 13469 //
     /* 1033368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1033379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1033382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1033385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1033388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033407 */     // MIs[0] policy
     /* 1033407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033417 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1033420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033439 */     // GIR_Coverage, 13469,
     /* 1033439 */     GIR_EraseRootFromParent_Done,
     /* 1033440 */   // Label 15327: @1033440
     /* 1033440 */   GIM_Try, /*On fail goto*//*Label 15328*/ GIMT_Encode4(1033517), // Rule ID 13472 //
     /* 1033445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1033456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1033459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1033462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1033465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033484 */     // MIs[0] policy
     /* 1033484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033516 */     // GIR_Coverage, 13472,
     /* 1033516 */     GIR_EraseRootFromParent_Done,
     /* 1033517 */   // Label 15328: @1033517
     /* 1033517 */   GIM_Try, /*On fail goto*//*Label 15329*/ GIMT_Encode4(1033594), // Rule ID 13473 //
     /* 1033522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1033533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1033536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1033539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1033542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033561 */     // MIs[0] policy
     /* 1033561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033593 */     // GIR_Coverage, 13473,
     /* 1033593 */     GIR_EraseRootFromParent_Done,
     /* 1033594 */   // Label 15329: @1033594
     /* 1033594 */   GIM_Try, /*On fail goto*//*Label 15330*/ GIMT_Encode4(1033671), // Rule ID 13476 //
     /* 1033599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1033610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1033613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1033616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1033619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033638 */     // MIs[0] policy
     /* 1033638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033648 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033670 */     // GIR_Coverage, 13476,
     /* 1033670 */     GIR_EraseRootFromParent_Done,
     /* 1033671 */   // Label 15330: @1033671
     /* 1033671 */   GIM_Try, /*On fail goto*//*Label 15331*/ GIMT_Encode4(1033748), // Rule ID 13477 //
     /* 1033676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1033687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1033690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1033693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1033696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033715 */     // MIs[0] policy
     /* 1033715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033725 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033747 */     // GIR_Coverage, 13477,
     /* 1033747 */     GIR_EraseRootFromParent_Done,
     /* 1033748 */   // Label 15331: @1033748
     /* 1033748 */   GIM_Try, /*On fail goto*//*Label 15332*/ GIMT_Encode4(1033825), // Rule ID 13480 //
     /* 1033753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1033764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1033767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1033770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1033773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033792 */     // MIs[0] policy
     /* 1033792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033802 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033824 */     // GIR_Coverage, 13480,
     /* 1033824 */     GIR_EraseRootFromParent_Done,
     /* 1033825 */   // Label 15332: @1033825
     /* 1033825 */   GIM_Try, /*On fail goto*//*Label 15333*/ GIMT_Encode4(1033902), // Rule ID 13481 //
     /* 1033830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1033841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1033844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1033847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1033850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033869 */     // MIs[0] policy
     /* 1033869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033879 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033901 */     // GIR_Coverage, 13481,
     /* 1033901 */     GIR_EraseRootFromParent_Done,
     /* 1033902 */   // Label 15333: @1033902
     /* 1033902 */   GIM_Try, /*On fail goto*//*Label 15334*/ GIMT_Encode4(1033979), // Rule ID 13484 //
     /* 1033907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1033924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1033927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033946 */     // MIs[0] policy
     /* 1033946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033956 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1033959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033978 */     // GIR_Coverage, 13484,
     /* 1033978 */     GIR_EraseRootFromParent_Done,
     /* 1033979 */   // Label 15334: @1033979
     /* 1033979 */   GIM_Try, /*On fail goto*//*Label 15335*/ GIMT_Encode4(1034056), // Rule ID 13485 //
     /* 1033984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1034001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1034004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034023 */     // MIs[0] policy
     /* 1034023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034033 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1034036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034055 */     // GIR_Coverage, 13485,
     /* 1034055 */     GIR_EraseRootFromParent_Done,
     /* 1034056 */   // Label 15335: @1034056
     /* 1034056 */   GIM_Try, /*On fail goto*//*Label 15336*/ GIMT_Encode4(1034133), // Rule ID 13488 //
     /* 1034061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1034064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1034072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1034075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1034078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1034081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034100 */     // MIs[0] policy
     /* 1034100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1034113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034132 */     // GIR_Coverage, 13488,
     /* 1034132 */     GIR_EraseRootFromParent_Done,
     /* 1034133 */   // Label 15336: @1034133
     /* 1034133 */   GIM_Try, /*On fail goto*//*Label 15337*/ GIMT_Encode4(1034210), // Rule ID 13489 //
     /* 1034138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1034141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1034149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1034152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1034155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1034158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034177 */     // MIs[0] policy
     /* 1034177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034187 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1034190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034209 */     // GIR_Coverage, 13489,
     /* 1034209 */     GIR_EraseRootFromParent_Done,
     /* 1034210 */   // Label 15337: @1034210
     /* 1034210 */   GIM_Try, /*On fail goto*//*Label 15338*/ GIMT_Encode4(1034287), // Rule ID 13492 //
     /* 1034215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1034218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1034226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1034229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1034232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1034235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034254 */     // MIs[0] policy
     /* 1034254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1034267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034286 */     // GIR_Coverage, 13492,
     /* 1034286 */     GIR_EraseRootFromParent_Done,
     /* 1034287 */   // Label 15338: @1034287
     /* 1034287 */   GIM_Try, /*On fail goto*//*Label 15339*/ GIMT_Encode4(1034364), // Rule ID 13493 //
     /* 1034292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1034295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1034303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1034306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1034309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1034312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034331 */     // MIs[0] policy
     /* 1034331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034341 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1034344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034363 */     // GIR_Coverage, 13493,
     /* 1034363 */     GIR_EraseRootFromParent_Done,
     /* 1034364 */   // Label 15339: @1034364
     /* 1034364 */   GIM_Try, /*On fail goto*//*Label 15340*/ GIMT_Encode4(1034441), // Rule ID 13496 //
     /* 1034369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1034372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1034380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1034383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1034386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1034389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034408 */     // MIs[0] policy
     /* 1034408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034418 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1034421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034440 */     // GIR_Coverage, 13496,
     /* 1034440 */     GIR_EraseRootFromParent_Done,
     /* 1034441 */   // Label 15340: @1034441
     /* 1034441 */   GIM_Try, /*On fail goto*//*Label 15341*/ GIMT_Encode4(1034518), // Rule ID 13497 //
     /* 1034446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1034449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1034457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1034460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1034463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1034466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034485 */     // MIs[0] policy
     /* 1034485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034495 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1034498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034517 */     // GIR_Coverage, 13497,
     /* 1034517 */     GIR_EraseRootFromParent_Done,
     /* 1034518 */   // Label 15341: @1034518
     /* 1034518 */   GIM_Try, /*On fail goto*//*Label 15342*/ GIMT_Encode4(1034595), // Rule ID 13500 //
     /* 1034523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1034534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1034537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1034543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034562 */     // MIs[0] policy
     /* 1034562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034572 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1034575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034594 */     // GIR_Coverage, 13500,
     /* 1034594 */     GIR_EraseRootFromParent_Done,
     /* 1034595 */   // Label 15342: @1034595
     /* 1034595 */   GIM_Try, /*On fail goto*//*Label 15343*/ GIMT_Encode4(1034672), // Rule ID 13501 //
     /* 1034600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1034611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1034614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1034620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034639 */     // MIs[0] policy
     /* 1034639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034649 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1034652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034671 */     // GIR_Coverage, 13501,
     /* 1034671 */     GIR_EraseRootFromParent_Done,
     /* 1034672 */   // Label 15343: @1034672
     /* 1034672 */   GIM_Try, /*On fail goto*//*Label 15344*/ GIMT_Encode4(1034749), // Rule ID 13504 //
     /* 1034677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1034688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1034691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1034697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034716 */     // MIs[0] policy
     /* 1034716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1034729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034748 */     // GIR_Coverage, 13504,
     /* 1034748 */     GIR_EraseRootFromParent_Done,
     /* 1034749 */   // Label 15344: @1034749
     /* 1034749 */   GIM_Try, /*On fail goto*//*Label 15345*/ GIMT_Encode4(1034826), // Rule ID 13505 //
     /* 1034754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1034765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1034768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1034774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034793 */     // MIs[0] policy
     /* 1034793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034803 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1034806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034825 */     // GIR_Coverage, 13505,
     /* 1034825 */     GIR_EraseRootFromParent_Done,
     /* 1034826 */   // Label 15345: @1034826
     /* 1034826 */   GIM_Try, /*On fail goto*//*Label 15346*/ GIMT_Encode4(1034903), // Rule ID 13508 //
     /* 1034831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1034842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1034845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1034851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034870 */     // MIs[0] policy
     /* 1034870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034880 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1034883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034902 */     // GIR_Coverage, 13508,
     /* 1034902 */     GIR_EraseRootFromParent_Done,
     /* 1034903 */   // Label 15346: @1034903
     /* 1034903 */   GIM_Try, /*On fail goto*//*Label 15347*/ GIMT_Encode4(1034980), // Rule ID 13509 //
     /* 1034908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1034919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1034922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1034928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034947 */     // MIs[0] policy
     /* 1034947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034957 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1034960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034979 */     // GIR_Coverage, 13509,
     /* 1034979 */     GIR_EraseRootFromParent_Done,
     /* 1034980 */   // Label 15347: @1034980
     /* 1034980 */   GIM_Try, /*On fail goto*//*Label 15348*/ GIMT_Encode4(1035057), // Rule ID 13512 //
     /* 1034985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1034996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1034999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1035005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035024 */     // MIs[0] policy
     /* 1035024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035034 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035056 */     // GIR_Coverage, 13512,
     /* 1035056 */     GIR_EraseRootFromParent_Done,
     /* 1035057 */   // Label 15348: @1035057
     /* 1035057 */   GIM_Try, /*On fail goto*//*Label 15349*/ GIMT_Encode4(1035134), // Rule ID 13513 //
     /* 1035062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1035073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1035076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1035082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035101 */     // MIs[0] policy
     /* 1035101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035111 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035133 */     // GIR_Coverage, 13513,
     /* 1035133 */     GIR_EraseRootFromParent_Done,
     /* 1035134 */   // Label 15349: @1035134
     /* 1035134 */   GIM_Try, /*On fail goto*//*Label 15350*/ GIMT_Encode4(1035211), // Rule ID 13516 //
     /* 1035139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1035150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1035153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1035159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035178 */     // MIs[0] policy
     /* 1035178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035188 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035210 */     // GIR_Coverage, 13516,
     /* 1035210 */     GIR_EraseRootFromParent_Done,
     /* 1035211 */   // Label 15350: @1035211
     /* 1035211 */   GIM_Try, /*On fail goto*//*Label 15351*/ GIMT_Encode4(1035288), // Rule ID 13517 //
     /* 1035216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1035227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1035230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1035236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035255 */     // MIs[0] policy
     /* 1035255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035265 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035287 */     // GIR_Coverage, 13517,
     /* 1035287 */     GIR_EraseRootFromParent_Done,
     /* 1035288 */   // Label 15351: @1035288
     /* 1035288 */   GIM_Try, /*On fail goto*//*Label 15352*/ GIMT_Encode4(1035365), // Rule ID 13520 //
     /* 1035293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1035304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1035307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1035313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035332 */     // MIs[0] policy
     /* 1035332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035342 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1035345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035364 */     // GIR_Coverage, 13520,
     /* 1035364 */     GIR_EraseRootFromParent_Done,
     /* 1035365 */   // Label 15352: @1035365
     /* 1035365 */   GIM_Try, /*On fail goto*//*Label 15353*/ GIMT_Encode4(1035442), // Rule ID 13521 //
     /* 1035370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1035381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1035384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1035390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035409 */     // MIs[0] policy
     /* 1035409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035419 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1035422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035441 */     // GIR_Coverage, 13521,
     /* 1035441 */     GIR_EraseRootFromParent_Done,
     /* 1035442 */   // Label 15353: @1035442
     /* 1035442 */   GIM_Try, /*On fail goto*//*Label 15354*/ GIMT_Encode4(1035519), // Rule ID 13524 //
     /* 1035447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1035458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1035461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1035467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035486 */     // MIs[0] policy
     /* 1035486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035496 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1035499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035518 */     // GIR_Coverage, 13524,
     /* 1035518 */     GIR_EraseRootFromParent_Done,
     /* 1035519 */   // Label 15354: @1035519
     /* 1035519 */   GIM_Try, /*On fail goto*//*Label 15355*/ GIMT_Encode4(1035596), // Rule ID 13525 //
     /* 1035524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1035535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1035538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1035544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035563 */     // MIs[0] policy
     /* 1035563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035573 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1035576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035595 */     // GIR_Coverage, 13525,
     /* 1035595 */     GIR_EraseRootFromParent_Done,
     /* 1035596 */   // Label 15355: @1035596
     /* 1035596 */   GIM_Try, /*On fail goto*//*Label 15356*/ GIMT_Encode4(1035673), // Rule ID 13528 //
     /* 1035601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1035612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1035615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1035621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035640 */     // MIs[0] policy
     /* 1035640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035672 */     // GIR_Coverage, 13528,
     /* 1035672 */     GIR_EraseRootFromParent_Done,
     /* 1035673 */   // Label 15356: @1035673
     /* 1035673 */   GIM_Try, /*On fail goto*//*Label 15357*/ GIMT_Encode4(1035750), // Rule ID 13529 //
     /* 1035678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1035689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1035692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1035698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035717 */     // MIs[0] policy
     /* 1035717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035727 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035749 */     // GIR_Coverage, 13529,
     /* 1035749 */     GIR_EraseRootFromParent_Done,
     /* 1035750 */   // Label 15357: @1035750
     /* 1035750 */   GIM_Try, /*On fail goto*//*Label 15358*/ GIMT_Encode4(1035827), // Rule ID 13532 //
     /* 1035755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1035766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1035769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1035775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035794 */     // MIs[0] policy
     /* 1035794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035826 */     // GIR_Coverage, 13532,
     /* 1035826 */     GIR_EraseRootFromParent_Done,
     /* 1035827 */   // Label 15358: @1035827
     /* 1035827 */   GIM_Try, /*On fail goto*//*Label 15359*/ GIMT_Encode4(1035904), // Rule ID 13533 //
     /* 1035832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1035843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1035846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1035852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035871 */     // MIs[0] policy
     /* 1035871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035881 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035903 */     // GIR_Coverage, 13533,
     /* 1035903 */     GIR_EraseRootFromParent_Done,
     /* 1035904 */   // Label 15359: @1035904
     /* 1035904 */   GIM_Try, /*On fail goto*//*Label 15360*/ GIMT_Encode4(1035981), // Rule ID 13536 //
     /* 1035909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1035920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1035923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1035929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035948 */     // MIs[0] policy
     /* 1035948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035958 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035980 */     // GIR_Coverage, 13536,
     /* 1035980 */     GIR_EraseRootFromParent_Done,
     /* 1035981 */   // Label 15360: @1035981
     /* 1035981 */   GIM_Try, /*On fail goto*//*Label 15361*/ GIMT_Encode4(1036058), // Rule ID 13537 //
     /* 1035986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1035997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1036000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1036006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036025 */     // MIs[0] policy
     /* 1036025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036035 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1036038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036057 */     // GIR_Coverage, 13537,
     /* 1036057 */     GIR_EraseRootFromParent_Done,
     /* 1036058 */   // Label 15361: @1036058
     /* 1036058 */   GIM_Try, /*On fail goto*//*Label 15362*/ GIMT_Encode4(1036135), // Rule ID 13540 //
     /* 1036063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1036074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1036077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1036083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036102 */     // MIs[0] policy
     /* 1036102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1036115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036134 */     // GIR_Coverage, 13540,
     /* 1036134 */     GIR_EraseRootFromParent_Done,
     /* 1036135 */   // Label 15362: @1036135
     /* 1036135 */   GIM_Try, /*On fail goto*//*Label 15363*/ GIMT_Encode4(1036212), // Rule ID 13541 //
     /* 1036140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1036151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1036154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1036160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036179 */     // MIs[0] policy
     /* 1036179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036189 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1036192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036211 */     // GIR_Coverage, 13541,
     /* 1036211 */     GIR_EraseRootFromParent_Done,
     /* 1036212 */   // Label 15363: @1036212
     /* 1036212 */   GIM_Try, /*On fail goto*//*Label 15364*/ GIMT_Encode4(1036289), // Rule ID 13544 //
     /* 1036217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1036220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1036228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1036231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1036237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036256 */     // MIs[0] policy
     /* 1036256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036266 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1036269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036288 */     // GIR_Coverage, 13544,
     /* 1036288 */     GIR_EraseRootFromParent_Done,
     /* 1036289 */   // Label 15364: @1036289
     /* 1036289 */   GIM_Try, /*On fail goto*//*Label 15365*/ GIMT_Encode4(1036366), // Rule ID 13545 //
     /* 1036294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1036297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1036305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1036308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1036314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036333 */     // MIs[0] policy
     /* 1036333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036343 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1036346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036365 */     // GIR_Coverage, 13545,
     /* 1036365 */     GIR_EraseRootFromParent_Done,
     /* 1036366 */   // Label 15365: @1036366
     /* 1036366 */   GIM_Try, /*On fail goto*//*Label 15366*/ GIMT_Encode4(1036443), // Rule ID 13548 //
     /* 1036371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1036374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1036382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1036385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1036391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036410 */     // MIs[0] policy
     /* 1036410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036420 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1036423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036442 */     // GIR_Coverage, 13548,
     /* 1036442 */     GIR_EraseRootFromParent_Done,
     /* 1036443 */   // Label 15366: @1036443
     /* 1036443 */   GIM_Try, /*On fail goto*//*Label 15367*/ GIMT_Encode4(1036520), // Rule ID 13549 //
     /* 1036448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1036451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1036459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1036462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1036468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036487 */     // MIs[0] policy
     /* 1036487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036497 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1036500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036519 */     // GIR_Coverage, 13549,
     /* 1036519 */     GIR_EraseRootFromParent_Done,
     /* 1036520 */   // Label 15367: @1036520
     /* 1036520 */   GIM_Try, /*On fail goto*//*Label 15368*/ GIMT_Encode4(1036597), // Rule ID 13552 //
     /* 1036525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1036528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1036536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1036539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1036545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036564 */     // MIs[0] policy
     /* 1036564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036574 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1036577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036596 */     // GIR_Coverage, 13552,
     /* 1036596 */     GIR_EraseRootFromParent_Done,
     /* 1036597 */   // Label 15368: @1036597
     /* 1036597 */   GIM_Try, /*On fail goto*//*Label 15369*/ GIMT_Encode4(1036674), // Rule ID 13553 //
     /* 1036602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1036605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1036613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1036616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1036622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036641 */     // MIs[0] policy
     /* 1036641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036651 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1036654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036673 */     // GIR_Coverage, 13553,
     /* 1036673 */     GIR_EraseRootFromParent_Done,
     /* 1036674 */   // Label 15369: @1036674
     /* 1036674 */   GIM_Try, /*On fail goto*//*Label 15370*/ GIMT_Encode4(1036751), // Rule ID 13556 //
     /* 1036679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1036682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1036690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1036693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1036699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036718 */     // MIs[0] policy
     /* 1036718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036728 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1036731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036750 */     // GIR_Coverage, 13556,
     /* 1036750 */     GIR_EraseRootFromParent_Done,
     /* 1036751 */   // Label 15370: @1036751
     /* 1036751 */   GIM_Try, /*On fail goto*//*Label 15371*/ GIMT_Encode4(1036828), // Rule ID 13557 //
     /* 1036756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1036759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1036767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1036770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1036776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036795 */     // MIs[0] policy
     /* 1036795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036805 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1036808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036827 */     // GIR_Coverage, 13557,
     /* 1036827 */     GIR_EraseRootFromParent_Done,
     /* 1036828 */   // Label 15371: @1036828
     /* 1036828 */   GIM_Try, /*On fail goto*//*Label 15372*/ GIMT_Encode4(1036905), // Rule ID 13560 //
     /* 1036833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1036844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1036847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1036850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1036853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036872 */     // MIs[0] policy
     /* 1036872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036882 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1036885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036904 */     // GIR_Coverage, 13560,
     /* 1036904 */     GIR_EraseRootFromParent_Done,
     /* 1036905 */   // Label 15372: @1036905
     /* 1036905 */   GIM_Try, /*On fail goto*//*Label 15373*/ GIMT_Encode4(1036982), // Rule ID 13561 //
     /* 1036910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1036921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1036924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1036927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1036930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036949 */     // MIs[0] policy
     /* 1036949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036959 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1036962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036981 */     // GIR_Coverage, 13561,
     /* 1036981 */     GIR_EraseRootFromParent_Done,
     /* 1036982 */   // Label 15373: @1036982
     /* 1036982 */   GIM_Try, /*On fail goto*//*Label 15374*/ GIMT_Encode4(1037059), // Rule ID 13564 //
     /* 1036987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1036998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1037001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1037004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1037007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037026 */     // MIs[0] policy
     /* 1037026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037036 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1037039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037058 */     // GIR_Coverage, 13564,
     /* 1037058 */     GIR_EraseRootFromParent_Done,
     /* 1037059 */   // Label 15374: @1037059
     /* 1037059 */   GIM_Try, /*On fail goto*//*Label 15375*/ GIMT_Encode4(1037136), // Rule ID 13565 //
     /* 1037064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1037075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1037078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1037081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1037084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037103 */     // MIs[0] policy
     /* 1037103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037113 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1037116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037135 */     // GIR_Coverage, 13565,
     /* 1037135 */     GIR_EraseRootFromParent_Done,
     /* 1037136 */   // Label 15375: @1037136
     /* 1037136 */   GIM_Try, /*On fail goto*//*Label 15376*/ GIMT_Encode4(1037213), // Rule ID 13568 //
     /* 1037141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1037152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1037155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1037158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1037161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037180 */     // MIs[0] policy
     /* 1037180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037212 */     // GIR_Coverage, 13568,
     /* 1037212 */     GIR_EraseRootFromParent_Done,
     /* 1037213 */   // Label 15376: @1037213
     /* 1037213 */   GIM_Try, /*On fail goto*//*Label 15377*/ GIMT_Encode4(1037290), // Rule ID 13569 //
     /* 1037218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1037229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1037232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1037235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1037238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037257 */     // MIs[0] policy
     /* 1037257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037267 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037289 */     // GIR_Coverage, 13569,
     /* 1037289 */     GIR_EraseRootFromParent_Done,
     /* 1037290 */   // Label 15377: @1037290
     /* 1037290 */   GIM_Try, /*On fail goto*//*Label 15378*/ GIMT_Encode4(1037367), // Rule ID 13572 //
     /* 1037295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1037306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1037309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1037312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1037315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037334 */     // MIs[0] policy
     /* 1037334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1037347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037366 */     // GIR_Coverage, 13572,
     /* 1037366 */     GIR_EraseRootFromParent_Done,
     /* 1037367 */   // Label 15378: @1037367
     /* 1037367 */   GIM_Try, /*On fail goto*//*Label 15379*/ GIMT_Encode4(1037444), // Rule ID 13573 //
     /* 1037372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1037383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1037386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1037389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1037392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037411 */     // MIs[0] policy
     /* 1037411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1037424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037443 */     // GIR_Coverage, 13573,
     /* 1037443 */     GIR_EraseRootFromParent_Done,
     /* 1037444 */   // Label 15379: @1037444
     /* 1037444 */   GIM_Try, /*On fail goto*//*Label 15380*/ GIMT_Encode4(1037521), // Rule ID 13576 //
     /* 1037449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1037460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1037463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1037466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1037469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037488 */     // MIs[0] policy
     /* 1037488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037498 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037520 */     // GIR_Coverage, 13576,
     /* 1037520 */     GIR_EraseRootFromParent_Done,
     /* 1037521 */   // Label 15380: @1037521
     /* 1037521 */   GIM_Try, /*On fail goto*//*Label 15381*/ GIMT_Encode4(1037598), // Rule ID 13577 //
     /* 1037526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1037537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1037540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1037543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1037546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037565 */     // MIs[0] policy
     /* 1037565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037575 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037597 */     // GIR_Coverage, 13577,
     /* 1037597 */     GIR_EraseRootFromParent_Done,
     /* 1037598 */   // Label 15381: @1037598
     /* 1037598 */   GIM_Try, /*On fail goto*//*Label 15382*/ GIMT_Encode4(1037675), // Rule ID 13580 //
     /* 1037603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1037614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1037617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1037620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1037623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037642 */     // MIs[0] policy
     /* 1037642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037652 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1037655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037674 */     // GIR_Coverage, 13580,
     /* 1037674 */     GIR_EraseRootFromParent_Done,
     /* 1037675 */   // Label 15382: @1037675
     /* 1037675 */   GIM_Try, /*On fail goto*//*Label 15383*/ GIMT_Encode4(1037752), // Rule ID 13581 //
     /* 1037680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1037691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1037694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1037697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1037700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037719 */     // MIs[0] policy
     /* 1037719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037729 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1037732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037751 */     // GIR_Coverage, 13581,
     /* 1037751 */     GIR_EraseRootFromParent_Done,
     /* 1037752 */   // Label 15383: @1037752
     /* 1037752 */   GIM_Try, /*On fail goto*//*Label 15384*/ GIMT_Encode4(1037829), // Rule ID 13584 //
     /* 1037757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1037768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1037771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1037774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1037777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037796 */     // MIs[0] policy
     /* 1037796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037806 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1037809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037828 */     // GIR_Coverage, 13584,
     /* 1037828 */     GIR_EraseRootFromParent_Done,
     /* 1037829 */   // Label 15384: @1037829
     /* 1037829 */   GIM_Try, /*On fail goto*//*Label 15385*/ GIMT_Encode4(1037906), // Rule ID 13585 //
     /* 1037834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1037845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1037848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1037851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1037854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037873 */     // MIs[0] policy
     /* 1037873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037883 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1037886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037905 */     // GIR_Coverage, 13585,
     /* 1037905 */     GIR_EraseRootFromParent_Done,
     /* 1037906 */   // Label 15385: @1037906
     /* 1037906 */   GIM_Try, /*On fail goto*//*Label 15386*/ GIMT_Encode4(1037983), // Rule ID 13588 //
     /* 1037911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1037922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1037925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1037928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1037931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037950 */     // MIs[0] policy
     /* 1037950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037960 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037982 */     // GIR_Coverage, 13588,
     /* 1037982 */     GIR_EraseRootFromParent_Done,
     /* 1037983 */   // Label 15386: @1037983
     /* 1037983 */   GIM_Try, /*On fail goto*//*Label 15387*/ GIMT_Encode4(1038060), // Rule ID 13589 //
     /* 1037988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1037999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1038002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1038005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1038008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038027 */     // MIs[0] policy
     /* 1038027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038037 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1038040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038059 */     // GIR_Coverage, 13589,
     /* 1038059 */     GIR_EraseRootFromParent_Done,
     /* 1038060 */   // Label 15387: @1038060
     /* 1038060 */   GIM_Try, /*On fail goto*//*Label 15388*/ GIMT_Encode4(1038137), // Rule ID 13592 //
     /* 1038065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1038076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1038079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1038082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1038085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038104 */     // MIs[0] policy
     /* 1038104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038114 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1038117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038136 */     // GIR_Coverage, 13592,
     /* 1038136 */     GIR_EraseRootFromParent_Done,
     /* 1038137 */   // Label 15388: @1038137
     /* 1038137 */   GIM_Try, /*On fail goto*//*Label 15389*/ GIMT_Encode4(1038214), // Rule ID 13593 //
     /* 1038142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1038153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1038156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1038159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1038162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038181 */     // MIs[0] policy
     /* 1038181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038191 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1038194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038213 */     // GIR_Coverage, 13593,
     /* 1038213 */     GIR_EraseRootFromParent_Done,
     /* 1038214 */   // Label 15389: @1038214
     /* 1038214 */   GIM_Try, /*On fail goto*//*Label 15390*/ GIMT_Encode4(1038291), // Rule ID 13596 //
     /* 1038219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1038230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1038233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1038236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1038239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038258 */     // MIs[0] policy
     /* 1038258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038268 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1038271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038290 */     // GIR_Coverage, 13596,
     /* 1038290 */     GIR_EraseRootFromParent_Done,
     /* 1038291 */   // Label 15390: @1038291
     /* 1038291 */   GIM_Try, /*On fail goto*//*Label 15391*/ GIMT_Encode4(1038368), // Rule ID 13597 //
     /* 1038296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1038307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1038310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1038313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1038316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038335 */     // MIs[0] policy
     /* 1038335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038345 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1038348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038367 */     // GIR_Coverage, 13597,
     /* 1038367 */     GIR_EraseRootFromParent_Done,
     /* 1038368 */   // Label 15391: @1038368
     /* 1038368 */   GIM_Try, /*On fail goto*//*Label 15392*/ GIMT_Encode4(1038445), // Rule ID 13600 //
     /* 1038373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1038384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1038387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1038390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1038393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038412 */     // MIs[0] policy
     /* 1038412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038422 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1038425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038444 */     // GIR_Coverage, 13600,
     /* 1038444 */     GIR_EraseRootFromParent_Done,
     /* 1038445 */   // Label 15392: @1038445
     /* 1038445 */   GIM_Try, /*On fail goto*//*Label 15393*/ GIMT_Encode4(1038522), // Rule ID 13601 //
     /* 1038450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1038461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1038464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1038467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1038470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038489 */     // MIs[0] policy
     /* 1038489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1038502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038521 */     // GIR_Coverage, 13601,
     /* 1038521 */     GIR_EraseRootFromParent_Done,
     /* 1038522 */   // Label 15393: @1038522
     /* 1038522 */   GIM_Try, /*On fail goto*//*Label 15394*/ GIMT_Encode4(1038599), // Rule ID 13604 //
     /* 1038527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1038538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1038541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1038544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1038547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038566 */     // MIs[0] policy
     /* 1038566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1038579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038598 */     // GIR_Coverage, 13604,
     /* 1038598 */     GIR_EraseRootFromParent_Done,
     /* 1038599 */   // Label 15394: @1038599
     /* 1038599 */   GIM_Try, /*On fail goto*//*Label 15395*/ GIMT_Encode4(1038676), // Rule ID 13605 //
     /* 1038604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1038615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1038618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1038621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1038624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038643 */     // MIs[0] policy
     /* 1038643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038653 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1038656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038675 */     // GIR_Coverage, 13605,
     /* 1038675 */     GIR_EraseRootFromParent_Done,
     /* 1038676 */   // Label 15395: @1038676
     /* 1038676 */   GIM_Try, /*On fail goto*//*Label 15396*/ GIMT_Encode4(1038753), // Rule ID 13608 //
     /* 1038681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1038692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1038695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1038698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1038701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038720 */     // MIs[0] policy
     /* 1038720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038730 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1038733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038752 */     // GIR_Coverage, 13608,
     /* 1038752 */     GIR_EraseRootFromParent_Done,
     /* 1038753 */   // Label 15396: @1038753
     /* 1038753 */   GIM_Try, /*On fail goto*//*Label 15397*/ GIMT_Encode4(1038830), // Rule ID 13609 //
     /* 1038758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1038769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1038772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1038775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1038778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038797 */     // MIs[0] policy
     /* 1038797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038807 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1038810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038829 */     // GIR_Coverage, 13609,
     /* 1038829 */     GIR_EraseRootFromParent_Done,
     /* 1038830 */   // Label 15397: @1038830
     /* 1038830 */   GIM_Try, /*On fail goto*//*Label 15398*/ GIMT_Encode4(1038907), // Rule ID 13612 //
     /* 1038835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1038846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1038849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1038852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1038855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038874 */     // MIs[0] policy
     /* 1038874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1038887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038906 */     // GIR_Coverage, 13612,
     /* 1038906 */     GIR_EraseRootFromParent_Done,
     /* 1038907 */   // Label 15398: @1038907
     /* 1038907 */   GIM_Try, /*On fail goto*//*Label 15399*/ GIMT_Encode4(1038984), // Rule ID 13613 //
     /* 1038912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1038923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1038926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1038929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1038932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038951 */     // MIs[0] policy
     /* 1038951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038961 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1038964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038983 */     // GIR_Coverage, 13613,
     /* 1038983 */     GIR_EraseRootFromParent_Done,
     /* 1038984 */   // Label 15399: @1038984
     /* 1038984 */   GIM_Try, /*On fail goto*//*Label 15400*/ GIMT_Encode4(1039061), // Rule ID 13616 //
     /* 1038989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1039000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1039003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1039006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1039009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039028 */     // MIs[0] policy
     /* 1039028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039038 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1039041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039060 */     // GIR_Coverage, 13616,
     /* 1039060 */     GIR_EraseRootFromParent_Done,
     /* 1039061 */   // Label 15400: @1039061
     /* 1039061 */   GIM_Try, /*On fail goto*//*Label 15401*/ GIMT_Encode4(1039138), // Rule ID 13617 //
     /* 1039066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1039069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1039077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1039080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1039083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1039086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039105 */     // MIs[0] policy
     /* 1039105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039115 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1039118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039137 */     // GIR_Coverage, 13617,
     /* 1039137 */     GIR_EraseRootFromParent_Done,
     /* 1039138 */   // Label 15401: @1039138
     /* 1039138 */   GIM_Try, /*On fail goto*//*Label 15402*/ GIMT_Encode4(1039215), // Rule ID 13620 //
     /* 1039143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1039154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1039157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1039163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039182 */     // MIs[0] policy
     /* 1039182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039192 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1039195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039214 */     // GIR_Coverage, 13620,
     /* 1039214 */     GIR_EraseRootFromParent_Done,
     /* 1039215 */   // Label 15402: @1039215
     /* 1039215 */   GIM_Try, /*On fail goto*//*Label 15403*/ GIMT_Encode4(1039292), // Rule ID 13621 //
     /* 1039220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1039231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1039234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1039240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039259 */     // MIs[0] policy
     /* 1039259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039269 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1039272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039291 */     // GIR_Coverage, 13621,
     /* 1039291 */     GIR_EraseRootFromParent_Done,
     /* 1039292 */   // Label 15403: @1039292
     /* 1039292 */   GIM_Try, /*On fail goto*//*Label 15404*/ GIMT_Encode4(1039369), // Rule ID 13624 //
     /* 1039297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1039308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1039311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1039317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039336 */     // MIs[0] policy
     /* 1039336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039346 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1039349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039368 */     // GIR_Coverage, 13624,
     /* 1039368 */     GIR_EraseRootFromParent_Done,
     /* 1039369 */   // Label 15404: @1039369
     /* 1039369 */   GIM_Try, /*On fail goto*//*Label 15405*/ GIMT_Encode4(1039446), // Rule ID 13625 //
     /* 1039374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1039385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1039388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1039394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039413 */     // MIs[0] policy
     /* 1039413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039423 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1039426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039445 */     // GIR_Coverage, 13625,
     /* 1039445 */     GIR_EraseRootFromParent_Done,
     /* 1039446 */   // Label 15405: @1039446
     /* 1039446 */   GIM_Try, /*On fail goto*//*Label 15406*/ GIMT_Encode4(1039523), // Rule ID 13628 //
     /* 1039451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1039462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1039465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1039471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039490 */     // MIs[0] policy
     /* 1039490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039500 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039522 */     // GIR_Coverage, 13628,
     /* 1039522 */     GIR_EraseRootFromParent_Done,
     /* 1039523 */   // Label 15406: @1039523
     /* 1039523 */   GIM_Try, /*On fail goto*//*Label 15407*/ GIMT_Encode4(1039600), // Rule ID 13629 //
     /* 1039528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1039539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1039542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1039548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039567 */     // MIs[0] policy
     /* 1039567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039577 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039599 */     // GIR_Coverage, 13629,
     /* 1039599 */     GIR_EraseRootFromParent_Done,
     /* 1039600 */   // Label 15407: @1039600
     /* 1039600 */   GIM_Try, /*On fail goto*//*Label 15408*/ GIMT_Encode4(1039677), // Rule ID 13632 //
     /* 1039605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1039616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1039619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1039625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039644 */     // MIs[0] policy
     /* 1039644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039654 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1039657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039676 */     // GIR_Coverage, 13632,
     /* 1039676 */     GIR_EraseRootFromParent_Done,
     /* 1039677 */   // Label 15408: @1039677
     /* 1039677 */   GIM_Try, /*On fail goto*//*Label 15409*/ GIMT_Encode4(1039754), // Rule ID 13633 //
     /* 1039682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1039693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1039696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1039702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039721 */     // MIs[0] policy
     /* 1039721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1039734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039753 */     // GIR_Coverage, 13633,
     /* 1039753 */     GIR_EraseRootFromParent_Done,
     /* 1039754 */   // Label 15409: @1039754
     /* 1039754 */   GIM_Try, /*On fail goto*//*Label 15410*/ GIMT_Encode4(1039831), // Rule ID 13636 //
     /* 1039759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1039770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1039773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1039779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039798 */     // MIs[0] policy
     /* 1039798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039808 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1039811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039830 */     // GIR_Coverage, 13636,
     /* 1039830 */     GIR_EraseRootFromParent_Done,
     /* 1039831 */   // Label 15410: @1039831
     /* 1039831 */   GIM_Try, /*On fail goto*//*Label 15411*/ GIMT_Encode4(1039908), // Rule ID 13637 //
     /* 1039836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1039847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1039850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1039856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039875 */     // MIs[0] policy
     /* 1039875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039885 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1039888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039907 */     // GIR_Coverage, 13637,
     /* 1039907 */     GIR_EraseRootFromParent_Done,
     /* 1039908 */   // Label 15411: @1039908
     /* 1039908 */   GIM_Try, /*On fail goto*//*Label 15412*/ GIMT_Encode4(1039985), // Rule ID 13640 //
     /* 1039913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1039924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1039927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1039933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039952 */     // MIs[0] policy
     /* 1039952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039962 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1039965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039984 */     // GIR_Coverage, 13640,
     /* 1039984 */     GIR_EraseRootFromParent_Done,
     /* 1039985 */   // Label 15412: @1039985
     /* 1039985 */   GIM_Try, /*On fail goto*//*Label 15413*/ GIMT_Encode4(1040062), // Rule ID 13641 //
     /* 1039990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1040001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1040004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1040010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040029 */     // MIs[0] policy
     /* 1040029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040039 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040058 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040061 */     // GIR_Coverage, 13641,
     /* 1040061 */     GIR_EraseRootFromParent_Done,
     /* 1040062 */   // Label 15413: @1040062
     /* 1040062 */   GIM_Try, /*On fail goto*//*Label 15414*/ GIMT_Encode4(1040139), // Rule ID 13644 //
     /* 1040067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1040078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1040081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1040087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040106 */     // MIs[0] policy
     /* 1040106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040116 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1040119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040138 */     // GIR_Coverage, 13644,
     /* 1040138 */     GIR_EraseRootFromParent_Done,
     /* 1040139 */   // Label 15414: @1040139
     /* 1040139 */   GIM_Try, /*On fail goto*//*Label 15415*/ GIMT_Encode4(1040216), // Rule ID 13645 //
     /* 1040144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1040155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1040158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1040164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040183 */     // MIs[0] policy
     /* 1040183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040193 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1040196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040215 */     // GIR_Coverage, 13645,
     /* 1040215 */     GIR_EraseRootFromParent_Done,
     /* 1040216 */   // Label 15415: @1040216
     /* 1040216 */   GIM_Try, /*On fail goto*//*Label 15416*/ GIMT_Encode4(1040293), // Rule ID 13648 //
     /* 1040221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1040232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1040235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1040241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040260 */     // MIs[0] policy
     /* 1040260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1040273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040292 */     // GIR_Coverage, 13648,
     /* 1040292 */     GIR_EraseRootFromParent_Done,
     /* 1040293 */   // Label 15416: @1040293
     /* 1040293 */   GIM_Try, /*On fail goto*//*Label 15417*/ GIMT_Encode4(1040370), // Rule ID 13649 //
     /* 1040298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1040309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1040312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1040318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040337 */     // MIs[0] policy
     /* 1040337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040347 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1040350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040369 */     // GIR_Coverage, 13649,
     /* 1040369 */     GIR_EraseRootFromParent_Done,
     /* 1040370 */   // Label 15417: @1040370
     /* 1040370 */   GIM_Try, /*On fail goto*//*Label 15418*/ GIMT_Encode4(1040447), // Rule ID 13652 //
     /* 1040375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1040386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1040389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1040395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040414 */     // MIs[0] policy
     /* 1040414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1040427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040446 */     // GIR_Coverage, 13652,
     /* 1040446 */     GIR_EraseRootFromParent_Done,
     /* 1040447 */   // Label 15418: @1040447
     /* 1040447 */   GIM_Try, /*On fail goto*//*Label 15419*/ GIMT_Encode4(1040524), // Rule ID 13653 //
     /* 1040452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1040463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1040466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1040472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040491 */     // MIs[0] policy
     /* 1040491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1040504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040523 */     // GIR_Coverage, 13653,
     /* 1040523 */     GIR_EraseRootFromParent_Done,
     /* 1040524 */   // Label 15419: @1040524
     /* 1040524 */   GIM_Try, /*On fail goto*//*Label 15420*/ GIMT_Encode4(1040601), // Rule ID 13656 //
     /* 1040529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1040540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1040543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1040549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040568 */     // MIs[0] policy
     /* 1040568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040578 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040600 */     // GIR_Coverage, 13656,
     /* 1040600 */     GIR_EraseRootFromParent_Done,
     /* 1040601 */   // Label 15420: @1040601
     /* 1040601 */   GIM_Try, /*On fail goto*//*Label 15421*/ GIMT_Encode4(1040678), // Rule ID 13657 //
     /* 1040606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1040617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1040620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1040626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040645 */     // MIs[0] policy
     /* 1040645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040655 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040677 */     // GIR_Coverage, 13657,
     /* 1040677 */     GIR_EraseRootFromParent_Done,
     /* 1040678 */   // Label 15421: @1040678
     /* 1040678 */   GIM_Try, /*On fail goto*//*Label 15422*/ GIMT_Encode4(1040755), // Rule ID 13660 //
     /* 1040683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1040694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1040697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1040703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040722 */     // MIs[0] policy
     /* 1040722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040732 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040751 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040754 */     // GIR_Coverage, 13660,
     /* 1040754 */     GIR_EraseRootFromParent_Done,
     /* 1040755 */   // Label 15422: @1040755
     /* 1040755 */   GIM_Try, /*On fail goto*//*Label 15423*/ GIMT_Encode4(1040832), // Rule ID 13661 //
     /* 1040760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1040771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1040774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1040780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040799 */     // MIs[0] policy
     /* 1040799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040809 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040831 */     // GIR_Coverage, 13661,
     /* 1040831 */     GIR_EraseRootFromParent_Done,
     /* 1040832 */   // Label 15423: @1040832
     /* 1040832 */   GIM_Try, /*On fail goto*//*Label 15424*/ GIMT_Encode4(1040909), // Rule ID 13664 //
     /* 1040837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1040848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1040851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1040857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040876 */     // MIs[0] policy
     /* 1040876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040886 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1040889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040905 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040908 */     // GIR_Coverage, 13664,
     /* 1040908 */     GIR_EraseRootFromParent_Done,
     /* 1040909 */   // Label 15424: @1040909
     /* 1040909 */   GIM_Try, /*On fail goto*//*Label 15425*/ GIMT_Encode4(1040986), // Rule ID 13665 //
     /* 1040914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1040925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1040928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1040934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040953 */     // MIs[0] policy
     /* 1040953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040963 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1040966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040985 */     // GIR_Coverage, 13665,
     /* 1040985 */     GIR_EraseRootFromParent_Done,
     /* 1040986 */   // Label 15425: @1040986
     /* 1040986 */   GIM_Try, /*On fail goto*//*Label 15426*/ GIMT_Encode4(1041063), // Rule ID 13668 //
     /* 1040991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1041002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1041005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1041008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1041011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041030 */     // MIs[0] policy
     /* 1041030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1041043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041062 */     // GIR_Coverage, 13668,
     /* 1041062 */     GIR_EraseRootFromParent_Done,
     /* 1041063 */   // Label 15426: @1041063
     /* 1041063 */   GIM_Try, /*On fail goto*//*Label 15427*/ GIMT_Encode4(1041140), // Rule ID 13669 //
     /* 1041068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1041071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1041079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1041082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1041085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1041088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041107 */     // MIs[0] policy
     /* 1041107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041117 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1041120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041139 */     // GIR_Coverage, 13669,
     /* 1041139 */     GIR_EraseRootFromParent_Done,
     /* 1041140 */   // Label 15427: @1041140
     /* 1041140 */   GIM_Try, /*On fail goto*//*Label 15428*/ GIMT_Encode4(1041217), // Rule ID 13672 //
     /* 1041145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1041148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1041156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1041159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1041162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1041165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041184 */     // MIs[0] policy
     /* 1041184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041194 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1041197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041213 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041216 */     // GIR_Coverage, 13672,
     /* 1041216 */     GIR_EraseRootFromParent_Done,
     /* 1041217 */   // Label 15428: @1041217
     /* 1041217 */   GIM_Try, /*On fail goto*//*Label 15429*/ GIMT_Encode4(1041294), // Rule ID 13673 //
     /* 1041222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1041225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1041233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1041236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1041239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1041242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041261 */     // MIs[0] policy
     /* 1041261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1041274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041293 */     // GIR_Coverage, 13673,
     /* 1041293 */     GIR_EraseRootFromParent_Done,
     /* 1041294 */   // Label 15429: @1041294
     /* 1041294 */   GIM_Try, /*On fail goto*//*Label 15430*/ GIMT_Encode4(1041371), // Rule ID 13676 //
     /* 1041299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1041302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1041310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1041313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1041316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1041319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041338 */     // MIs[0] policy
     /* 1041338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041348 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1041351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041370 */     // GIR_Coverage, 13676,
     /* 1041370 */     GIR_EraseRootFromParent_Done,
     /* 1041371 */   // Label 15430: @1041371
     /* 1041371 */   GIM_Try, /*On fail goto*//*Label 15431*/ GIMT_Encode4(1041448), // Rule ID 13677 //
     /* 1041376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1041379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1041387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1041390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1041393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1041396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041415 */     // MIs[0] policy
     /* 1041415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041425 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1041428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041447 */     // GIR_Coverage, 13677,
     /* 1041447 */     GIR_EraseRootFromParent_Done,
     /* 1041448 */   // Label 15431: @1041448
     /* 1041448 */   GIM_Try, /*On fail goto*//*Label 15432*/ GIMT_Encode4(1041525), // Rule ID 13680 //
     /* 1041453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1041464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1041467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1041470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1041473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041492 */     // MIs[0] policy
     /* 1041492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041502 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1041505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041524 */     // GIR_Coverage, 13680,
     /* 1041524 */     GIR_EraseRootFromParent_Done,
     /* 1041525 */   // Label 15432: @1041525
     /* 1041525 */   GIM_Try, /*On fail goto*//*Label 15433*/ GIMT_Encode4(1041602), // Rule ID 13681 //
     /* 1041530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1041541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1041544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1041547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1041550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041569 */     // MIs[0] policy
     /* 1041569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041579 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1041582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041601 */     // GIR_Coverage, 13681,
     /* 1041601 */     GIR_EraseRootFromParent_Done,
     /* 1041602 */   // Label 15433: @1041602
     /* 1041602 */   GIM_Try, /*On fail goto*//*Label 15434*/ GIMT_Encode4(1041679), // Rule ID 13684 //
     /* 1041607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1041618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1041621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1041624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1041627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041646 */     // MIs[0] policy
     /* 1041646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041656 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1041659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041678 */     // GIR_Coverage, 13684,
     /* 1041678 */     GIR_EraseRootFromParent_Done,
     /* 1041679 */   // Label 15434: @1041679
     /* 1041679 */   GIM_Try, /*On fail goto*//*Label 15435*/ GIMT_Encode4(1041756), // Rule ID 13685 //
     /* 1041684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1041695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1041698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1041701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1041704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041723 */     // MIs[0] policy
     /* 1041723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041733 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1041736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041755 */     // GIR_Coverage, 13685,
     /* 1041755 */     GIR_EraseRootFromParent_Done,
     /* 1041756 */   // Label 15435: @1041756
     /* 1041756 */   GIM_Try, /*On fail goto*//*Label 15436*/ GIMT_Encode4(1041833), // Rule ID 13688 //
     /* 1041761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1041772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1041775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1041778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1041781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041800 */     // MIs[0] policy
     /* 1041800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041810 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1041813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041832 */     // GIR_Coverage, 13688,
     /* 1041832 */     GIR_EraseRootFromParent_Done,
     /* 1041833 */   // Label 15436: @1041833
     /* 1041833 */   GIM_Try, /*On fail goto*//*Label 15437*/ GIMT_Encode4(1041910), // Rule ID 13689 //
     /* 1041838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1041849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1041852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1041855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1041858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041877 */     // MIs[0] policy
     /* 1041877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041887 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1041890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041909 */     // GIR_Coverage, 13689,
     /* 1041909 */     GIR_EraseRootFromParent_Done,
     /* 1041910 */   // Label 15437: @1041910
     /* 1041910 */   GIM_Try, /*On fail goto*//*Label 15438*/ GIMT_Encode4(1041987), // Rule ID 13692 //
     /* 1041915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1041926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1041929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1041932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1041935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041954 */     // MIs[0] policy
     /* 1041954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1041967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041986 */     // GIR_Coverage, 13692,
     /* 1041986 */     GIR_EraseRootFromParent_Done,
     /* 1041987 */   // Label 15438: @1041987
     /* 1041987 */   GIM_Try, /*On fail goto*//*Label 15439*/ GIMT_Encode4(1042064), // Rule ID 13693 //
     /* 1041992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1042003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1042006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1042009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1042012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042031 */     // MIs[0] policy
     /* 1042031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042041 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042063 */     // GIR_Coverage, 13693,
     /* 1042063 */     GIR_EraseRootFromParent_Done,
     /* 1042064 */   // Label 15439: @1042064
     /* 1042064 */   GIM_Try, /*On fail goto*//*Label 15440*/ GIMT_Encode4(1042141), // Rule ID 13696 //
     /* 1042069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1042080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1042083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1042086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1042089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042108 */     // MIs[0] policy
     /* 1042108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042140 */     // GIR_Coverage, 13696,
     /* 1042140 */     GIR_EraseRootFromParent_Done,
     /* 1042141 */   // Label 15440: @1042141
     /* 1042141 */   GIM_Try, /*On fail goto*//*Label 15441*/ GIMT_Encode4(1042218), // Rule ID 13697 //
     /* 1042146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1042157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1042160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1042163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1042166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042185 */     // MIs[0] policy
     /* 1042185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042195 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042217 */     // GIR_Coverage, 13697,
     /* 1042217 */     GIR_EraseRootFromParent_Done,
     /* 1042218 */   // Label 15441: @1042218
     /* 1042218 */   GIM_Try, /*On fail goto*//*Label 15442*/ GIMT_Encode4(1042295), // Rule ID 13700 //
     /* 1042223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1042234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1042237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1042240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1042243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042262 */     // MIs[0] policy
     /* 1042262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042272 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1042275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042294 */     // GIR_Coverage, 13700,
     /* 1042294 */     GIR_EraseRootFromParent_Done,
     /* 1042295 */   // Label 15442: @1042295
     /* 1042295 */   GIM_Try, /*On fail goto*//*Label 15443*/ GIMT_Encode4(1042372), // Rule ID 13701 //
     /* 1042300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1042311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1042314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1042317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1042320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042339 */     // MIs[0] policy
     /* 1042339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042349 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1042352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042371 */     // GIR_Coverage, 13701,
     /* 1042371 */     GIR_EraseRootFromParent_Done,
     /* 1042372 */   // Label 15443: @1042372
     /* 1042372 */   GIM_Try, /*On fail goto*//*Label 15444*/ GIMT_Encode4(1042449), // Rule ID 13704 //
     /* 1042377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1042388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1042391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1042394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1042397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042416 */     // MIs[0] policy
     /* 1042416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042426 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1042429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042448 */     // GIR_Coverage, 13704,
     /* 1042448 */     GIR_EraseRootFromParent_Done,
     /* 1042449 */   // Label 15444: @1042449
     /* 1042449 */   GIM_Try, /*On fail goto*//*Label 15445*/ GIMT_Encode4(1042526), // Rule ID 13705 //
     /* 1042454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1042465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1042468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1042471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1042474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042493 */     // MIs[0] policy
     /* 1042493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042503 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1042506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042525 */     // GIR_Coverage, 13705,
     /* 1042525 */     GIR_EraseRootFromParent_Done,
     /* 1042526 */   // Label 15445: @1042526
     /* 1042526 */   GIM_Try, /*On fail goto*//*Label 15446*/ GIMT_Encode4(1042603), // Rule ID 13708 //
     /* 1042531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1042542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1042545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1042548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1042551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042570 */     // MIs[0] policy
     /* 1042570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042580 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042602 */     // GIR_Coverage, 13708,
     /* 1042602 */     GIR_EraseRootFromParent_Done,
     /* 1042603 */   // Label 15446: @1042603
     /* 1042603 */   GIM_Try, /*On fail goto*//*Label 15447*/ GIMT_Encode4(1042680), // Rule ID 13709 //
     /* 1042608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1042619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1042622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1042625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1042628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042647 */     // MIs[0] policy
     /* 1042647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042657 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042679 */     // GIR_Coverage, 13709,
     /* 1042679 */     GIR_EraseRootFromParent_Done,
     /* 1042680 */   // Label 15447: @1042680
     /* 1042680 */   GIM_Try, /*On fail goto*//*Label 15448*/ GIMT_Encode4(1042757), // Rule ID 13712 //
     /* 1042685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1042696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1042699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1042702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1042705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042724 */     // MIs[0] policy
     /* 1042724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042756 */     // GIR_Coverage, 13712,
     /* 1042756 */     GIR_EraseRootFromParent_Done,
     /* 1042757 */   // Label 15448: @1042757
     /* 1042757 */   GIM_Try, /*On fail goto*//*Label 15449*/ GIMT_Encode4(1042834), // Rule ID 13713 //
     /* 1042762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1042773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1042776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1042779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1042782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042801 */     // MIs[0] policy
     /* 1042801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042833 */     // GIR_Coverage, 13713,
     /* 1042833 */     GIR_EraseRootFromParent_Done,
     /* 1042834 */   // Label 15449: @1042834
     /* 1042834 */   GIM_Try, /*On fail goto*//*Label 15450*/ GIMT_Encode4(1042911), // Rule ID 13716 //
     /* 1042839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1042850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1042853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1042856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1042859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042878 */     // MIs[0] policy
     /* 1042878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042888 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042910 */     // GIR_Coverage, 13716,
     /* 1042910 */     GIR_EraseRootFromParent_Done,
     /* 1042911 */   // Label 15450: @1042911
     /* 1042911 */   GIM_Try, /*On fail goto*//*Label 15451*/ GIMT_Encode4(1042988), // Rule ID 13717 //
     /* 1042916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1042927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1042930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1042933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1042936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042955 */     // MIs[0] policy
     /* 1042955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042965 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042987 */     // GIR_Coverage, 13717,
     /* 1042987 */     GIR_EraseRootFromParent_Done,
     /* 1042988 */   // Label 15451: @1042988
     /* 1042988 */   GIM_Try, /*On fail goto*//*Label 15452*/ GIMT_Encode4(1043065), // Rule ID 13720 //
     /* 1042993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1043004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1043007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1043010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1043013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043032 */     // MIs[0] policy
     /* 1043032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043042 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1043045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043064 */     // GIR_Coverage, 13720,
     /* 1043064 */     GIR_EraseRootFromParent_Done,
     /* 1043065 */   // Label 15452: @1043065
     /* 1043065 */   GIM_Try, /*On fail goto*//*Label 15453*/ GIMT_Encode4(1043142), // Rule ID 13721 //
     /* 1043070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1043081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1043084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1043087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1043090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043109 */     // MIs[0] policy
     /* 1043109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043119 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1043122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043141 */     // GIR_Coverage, 13721,
     /* 1043141 */     GIR_EraseRootFromParent_Done,
     /* 1043142 */   // Label 15453: @1043142
     /* 1043142 */   GIM_Try, /*On fail goto*//*Label 15454*/ GIMT_Encode4(1043219), // Rule ID 13724 //
     /* 1043147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1043150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1043158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1043161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1043164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1043167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043186 */     // MIs[0] policy
     /* 1043186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043196 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1043199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043218 */     // GIR_Coverage, 13724,
     /* 1043218 */     GIR_EraseRootFromParent_Done,
     /* 1043219 */   // Label 15454: @1043219
     /* 1043219 */   GIM_Try, /*On fail goto*//*Label 15455*/ GIMT_Encode4(1043296), // Rule ID 13725 //
     /* 1043224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1043227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1043235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1043238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1043241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1043244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043263 */     // MIs[0] policy
     /* 1043263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043273 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1043276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043295 */     // GIR_Coverage, 13725,
     /* 1043295 */     GIR_EraseRootFromParent_Done,
     /* 1043296 */   // Label 15455: @1043296
     /* 1043296 */   GIM_Try, /*On fail goto*//*Label 15456*/ GIMT_Encode4(1043373), // Rule ID 13728 //
     /* 1043301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1043304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1043312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1043315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1043318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1043321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043340 */     // MIs[0] policy
     /* 1043340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1043353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043372 */     // GIR_Coverage, 13728,
     /* 1043372 */     GIR_EraseRootFromParent_Done,
     /* 1043373 */   // Label 15456: @1043373
     /* 1043373 */   GIM_Try, /*On fail goto*//*Label 15457*/ GIMT_Encode4(1043450), // Rule ID 13729 //
     /* 1043378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1043381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1043389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1043392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1043395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1043398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043417 */     // MIs[0] policy
     /* 1043417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043427 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1043430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043449 */     // GIR_Coverage, 13729,
     /* 1043449 */     GIR_EraseRootFromParent_Done,
     /* 1043450 */   // Label 15457: @1043450
     /* 1043450 */   GIM_Try, /*On fail goto*//*Label 15458*/ GIMT_Encode4(1043527), // Rule ID 13732 //
     /* 1043455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1043458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1043466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1043469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1043472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1043475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043494 */     // MIs[0] policy
     /* 1043494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043504 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1043507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043526 */     // GIR_Coverage, 13732,
     /* 1043526 */     GIR_EraseRootFromParent_Done,
     /* 1043527 */   // Label 15458: @1043527
     /* 1043527 */   GIM_Try, /*On fail goto*//*Label 15459*/ GIMT_Encode4(1043604), // Rule ID 13733 //
     /* 1043532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1043535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1043543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1043546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1043549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1043552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043571 */     // MIs[0] policy
     /* 1043571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043581 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1043584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043603 */     // GIR_Coverage, 13733,
     /* 1043603 */     GIR_EraseRootFromParent_Done,
     /* 1043604 */   // Label 15459: @1043604
     /* 1043604 */   GIM_Try, /*On fail goto*//*Label 15460*/ GIMT_Encode4(1043681), // Rule ID 13736 //
     /* 1043609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1043612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1043620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1043623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1043626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1043629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043648 */     // MIs[0] policy
     /* 1043648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043658 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1043661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043680 */     // GIR_Coverage, 13736,
     /* 1043680 */     GIR_EraseRootFromParent_Done,
     /* 1043681 */   // Label 15460: @1043681
     /* 1043681 */   GIM_Try, /*On fail goto*//*Label 15461*/ GIMT_Encode4(1043758), // Rule ID 13737 //
     /* 1043686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1043689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1043697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1043700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1043703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1043706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043725 */     // MIs[0] policy
     /* 1043725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043735 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1043738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043757 */     // GIR_Coverage, 13737,
     /* 1043757 */     GIR_EraseRootFromParent_Done,
     /* 1043758 */   // Label 15461: @1043758
     /* 1043758 */   GIM_Try, /*On fail goto*//*Label 15462*/ GIMT_Encode4(1043835), // Rule ID 13740 //
     /* 1043763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1043774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1043777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1043783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043802 */     // MIs[0] policy
     /* 1043802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043812 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1043815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043834 */     // GIR_Coverage, 13740,
     /* 1043834 */     GIR_EraseRootFromParent_Done,
     /* 1043835 */   // Label 15462: @1043835
     /* 1043835 */   GIM_Try, /*On fail goto*//*Label 15463*/ GIMT_Encode4(1043912), // Rule ID 13741 //
     /* 1043840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1043851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1043854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1043860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043879 */     // MIs[0] policy
     /* 1043879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043889 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1043892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043911 */     // GIR_Coverage, 13741,
     /* 1043911 */     GIR_EraseRootFromParent_Done,
     /* 1043912 */   // Label 15463: @1043912
     /* 1043912 */   GIM_Try, /*On fail goto*//*Label 15464*/ GIMT_Encode4(1043989), // Rule ID 13744 //
     /* 1043917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1043928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1043931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1043937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043956 */     // MIs[0] policy
     /* 1043956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043966 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1043969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043988 */     // GIR_Coverage, 13744,
     /* 1043988 */     GIR_EraseRootFromParent_Done,
     /* 1043989 */   // Label 15464: @1043989
     /* 1043989 */   GIM_Try, /*On fail goto*//*Label 15465*/ GIMT_Encode4(1044066), // Rule ID 13745 //
     /* 1043994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1044005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1044008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1044014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044033 */     // MIs[0] policy
     /* 1044033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044043 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1044046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044065 */     // GIR_Coverage, 13745,
     /* 1044065 */     GIR_EraseRootFromParent_Done,
     /* 1044066 */   // Label 15465: @1044066
     /* 1044066 */   GIM_Try, /*On fail goto*//*Label 15466*/ GIMT_Encode4(1044143), // Rule ID 13748 //
     /* 1044071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1044082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1044085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1044091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044110 */     // MIs[0] policy
     /* 1044110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044142 */     // GIR_Coverage, 13748,
     /* 1044142 */     GIR_EraseRootFromParent_Done,
     /* 1044143 */   // Label 15466: @1044143
     /* 1044143 */   GIM_Try, /*On fail goto*//*Label 15467*/ GIMT_Encode4(1044220), // Rule ID 13749 //
     /* 1044148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1044159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1044162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1044168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044187 */     // MIs[0] policy
     /* 1044187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044197 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044219 */     // GIR_Coverage, 13749,
     /* 1044219 */     GIR_EraseRootFromParent_Done,
     /* 1044220 */   // Label 15467: @1044220
     /* 1044220 */   GIM_Try, /*On fail goto*//*Label 15468*/ GIMT_Encode4(1044297), // Rule ID 13752 //
     /* 1044225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1044236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1044239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1044245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044264 */     // MIs[0] policy
     /* 1044264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1044277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044293 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044296 */     // GIR_Coverage, 13752,
     /* 1044296 */     GIR_EraseRootFromParent_Done,
     /* 1044297 */   // Label 15468: @1044297
     /* 1044297 */   GIM_Try, /*On fail goto*//*Label 15469*/ GIMT_Encode4(1044374), // Rule ID 13753 //
     /* 1044302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1044313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1044316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1044322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044341 */     // MIs[0] policy
     /* 1044341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044351 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1044354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044373 */     // GIR_Coverage, 13753,
     /* 1044373 */     GIR_EraseRootFromParent_Done,
     /* 1044374 */   // Label 15469: @1044374
     /* 1044374 */   GIM_Try, /*On fail goto*//*Label 15470*/ GIMT_Encode4(1044451), // Rule ID 13756 //
     /* 1044379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1044390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1044393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1044399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044418 */     // MIs[0] policy
     /* 1044418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044428 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044450 */     // GIR_Coverage, 13756,
     /* 1044450 */     GIR_EraseRootFromParent_Done,
     /* 1044451 */   // Label 15470: @1044451
     /* 1044451 */   GIM_Try, /*On fail goto*//*Label 15471*/ GIMT_Encode4(1044528), // Rule ID 13757 //
     /* 1044456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1044467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1044470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1044476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044495 */     // MIs[0] policy
     /* 1044495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044505 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044527 */     // GIR_Coverage, 13757,
     /* 1044527 */     GIR_EraseRootFromParent_Done,
     /* 1044528 */   // Label 15471: @1044528
     /* 1044528 */   GIM_Try, /*On fail goto*//*Label 15472*/ GIMT_Encode4(1044605), // Rule ID 13760 //
     /* 1044533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1044544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1044547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1044553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044572 */     // MIs[0] policy
     /* 1044572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044582 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044601 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044604 */     // GIR_Coverage, 13760,
     /* 1044604 */     GIR_EraseRootFromParent_Done,
     /* 1044605 */   // Label 15472: @1044605
     /* 1044605 */   GIM_Try, /*On fail goto*//*Label 15473*/ GIMT_Encode4(1044682), // Rule ID 13761 //
     /* 1044610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1044621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1044624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1044630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044649 */     // MIs[0] policy
     /* 1044649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044659 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044681 */     // GIR_Coverage, 13761,
     /* 1044681 */     GIR_EraseRootFromParent_Done,
     /* 1044682 */   // Label 15473: @1044682
     /* 1044682 */   GIM_Try, /*On fail goto*//*Label 15474*/ GIMT_Encode4(1044759), // Rule ID 13764 //
     /* 1044687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1044698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1044701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1044707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044726 */     // MIs[0] policy
     /* 1044726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044736 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1044739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044758 */     // GIR_Coverage, 13764,
     /* 1044758 */     GIR_EraseRootFromParent_Done,
     /* 1044759 */   // Label 15474: @1044759
     /* 1044759 */   GIM_Try, /*On fail goto*//*Label 15475*/ GIMT_Encode4(1044836), // Rule ID 13765 //
     /* 1044764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1044775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1044778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1044784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044803 */     // MIs[0] policy
     /* 1044803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044813 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1044816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044835 */     // GIR_Coverage, 13765,
     /* 1044835 */     GIR_EraseRootFromParent_Done,
     /* 1044836 */   // Label 15475: @1044836
     /* 1044836 */   GIM_Try, /*On fail goto*//*Label 15476*/ GIMT_Encode4(1044913), // Rule ID 13768 //
     /* 1044841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1044852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1044855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1044861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044880 */     // MIs[0] policy
     /* 1044880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044890 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044909 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044912 */     // GIR_Coverage, 13768,
     /* 1044912 */     GIR_EraseRootFromParent_Done,
     /* 1044913 */   // Label 15476: @1044913
     /* 1044913 */   GIM_Try, /*On fail goto*//*Label 15477*/ GIMT_Encode4(1044990), // Rule ID 13769 //
     /* 1044918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1044929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1044932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1044938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044957 */     // MIs[0] policy
     /* 1044957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044967 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044986 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044989 */     // GIR_Coverage, 13769,
     /* 1044989 */     GIR_EraseRootFromParent_Done,
     /* 1044990 */   // Label 15477: @1044990
     /* 1044990 */   GIM_Try, /*On fail goto*//*Label 15478*/ GIMT_Encode4(1045067), // Rule ID 13772 //
     /* 1044995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1045006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1045009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1045015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045034 */     // MIs[0] policy
     /* 1045034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045044 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1045047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045066 */     // GIR_Coverage, 13772,
     /* 1045066 */     GIR_EraseRootFromParent_Done,
     /* 1045067 */   // Label 15478: @1045067
     /* 1045067 */   GIM_Try, /*On fail goto*//*Label 15479*/ GIMT_Encode4(1045144), // Rule ID 13773 //
     /* 1045072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1045083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1045086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1045092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045111 */     // MIs[0] policy
     /* 1045111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045121 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1045124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045143 */     // GIR_Coverage, 13773,
     /* 1045143 */     GIR_EraseRootFromParent_Done,
     /* 1045144 */   // Label 15479: @1045144
     /* 1045144 */   GIM_Try, /*On fail goto*//*Label 15480*/ GIMT_Encode4(1045221), // Rule ID 13776 //
     /* 1045149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1045160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1045163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1045169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045188 */     // MIs[0] policy
     /* 1045188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045198 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1045201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045217 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045220 */     // GIR_Coverage, 13776,
     /* 1045220 */     GIR_EraseRootFromParent_Done,
     /* 1045221 */   // Label 15480: @1045221
     /* 1045221 */   GIM_Try, /*On fail goto*//*Label 15481*/ GIMT_Encode4(1045298), // Rule ID 13777 //
     /* 1045226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1045237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1045240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1045246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045265 */     // MIs[0] policy
     /* 1045265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045275 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1045278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045297 */     // GIR_Coverage, 13777,
     /* 1045297 */     GIR_EraseRootFromParent_Done,
     /* 1045298 */   // Label 15481: @1045298
     /* 1045298 */   GIM_Try, /*On fail goto*//*Label 15482*/ GIMT_Encode4(1045375), // Rule ID 13780 //
     /* 1045303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1045314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1045317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1045323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045342 */     // MIs[0] policy
     /* 1045342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045352 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1045355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045374 */     // GIR_Coverage, 13780,
     /* 1045374 */     GIR_EraseRootFromParent_Done,
     /* 1045375 */   // Label 15482: @1045375
     /* 1045375 */   GIM_Try, /*On fail goto*//*Label 15483*/ GIMT_Encode4(1045452), // Rule ID 13781 //
     /* 1045380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1045391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1045394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1045400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045419 */     // MIs[0] policy
     /* 1045419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045429 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1045432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045451 */     // GIR_Coverage, 13781,
     /* 1045451 */     GIR_EraseRootFromParent_Done,
     /* 1045452 */   // Label 15483: @1045452
     /* 1045452 */   GIM_Try, /*On fail goto*//*Label 15484*/ GIMT_Encode4(1045529), // Rule ID 13784 //
     /* 1045457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1045468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1045471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1045477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045496 */     // MIs[0] policy
     /* 1045496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045506 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1045509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045528 */     // GIR_Coverage, 13784,
     /* 1045528 */     GIR_EraseRootFromParent_Done,
     /* 1045529 */   // Label 15484: @1045529
     /* 1045529 */   GIM_Try, /*On fail goto*//*Label 15485*/ GIMT_Encode4(1045606), // Rule ID 13785 //
     /* 1045534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1045545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1045548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1045554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045573 */     // MIs[0] policy
     /* 1045573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045583 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1045586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045602 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045605 */     // GIR_Coverage, 13785,
     /* 1045605 */     GIR_EraseRootFromParent_Done,
     /* 1045606 */   // Label 15485: @1045606
     /* 1045606 */   GIM_Try, /*On fail goto*//*Label 15486*/ GIMT_Encode4(1045683), // Rule ID 13788 //
     /* 1045611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1045622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1045625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1045631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045650 */     // MIs[0] policy
     /* 1045650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1045663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045682 */     // GIR_Coverage, 13788,
     /* 1045682 */     GIR_EraseRootFromParent_Done,
     /* 1045683 */   // Label 15486: @1045683
     /* 1045683 */   GIM_Try, /*On fail goto*//*Label 15487*/ GIMT_Encode4(1045760), // Rule ID 13789 //
     /* 1045688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1045699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1045702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1045708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045727 */     // MIs[0] policy
     /* 1045727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045737 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1045740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045759 */     // GIR_Coverage, 13789,
     /* 1045759 */     GIR_EraseRootFromParent_Done,
     /* 1045760 */   // Label 15487: @1045760
     /* 1045760 */   GIM_Try, /*On fail goto*//*Label 15488*/ GIMT_Encode4(1045837), // Rule ID 13792 //
     /* 1045765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1045776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1045779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1045785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045804 */     // MIs[0] policy
     /* 1045804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045814 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1045817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045836 */     // GIR_Coverage, 13792,
     /* 1045836 */     GIR_EraseRootFromParent_Done,
     /* 1045837 */   // Label 15488: @1045837
     /* 1045837 */   GIM_Try, /*On fail goto*//*Label 15489*/ GIMT_Encode4(1045914), // Rule ID 13793 //
     /* 1045842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1045853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1045856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1045862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045881 */     // MIs[0] policy
     /* 1045881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045891 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1045894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045913 */     // GIR_Coverage, 13793,
     /* 1045913 */     GIR_EraseRootFromParent_Done,
     /* 1045914 */   // Label 15489: @1045914
     /* 1045914 */   GIM_Try, /*On fail goto*//*Label 15490*/ GIMT_Encode4(1045991), // Rule ID 13796 //
     /* 1045919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1045930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1045933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1045939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045958 */     // MIs[0] policy
     /* 1045958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1045971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045990 */     // GIR_Coverage, 13796,
     /* 1045990 */     GIR_EraseRootFromParent_Done,
     /* 1045991 */   // Label 15490: @1045991
     /* 1045991 */   GIM_Try, /*On fail goto*//*Label 15491*/ GIMT_Encode4(1046068), // Rule ID 13797 //
     /* 1045996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1046007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1046010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1046016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046035 */     // MIs[0] policy
     /* 1046035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046045 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1046048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046067 */     // GIR_Coverage, 13797,
     /* 1046067 */     GIR_EraseRootFromParent_Done,
     /* 1046068 */   // Label 15491: @1046068
     /* 1046068 */   GIM_Try, /*On fail goto*//*Label 15492*/ GIMT_Encode4(1046145), // Rule ID 13800 //
     /* 1046073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1046084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1046087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1046093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046112 */     // MIs[0] policy
     /* 1046112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046122 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1046125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046141 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046144 */     // GIR_Coverage, 13800,
     /* 1046144 */     GIR_EraseRootFromParent_Done,
     /* 1046145 */   // Label 15492: @1046145
     /* 1046145 */   GIM_Try, /*On fail goto*//*Label 15493*/ GIMT_Encode4(1046222), // Rule ID 13801 //
     /* 1046150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1046161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1046164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1046170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046189 */     // MIs[0] policy
     /* 1046189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046199 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1046202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046218 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046221 */     // GIR_Coverage, 13801,
     /* 1046221 */     GIR_EraseRootFromParent_Done,
     /* 1046222 */   // Label 15493: @1046222
     /* 1046222 */   GIM_Try, /*On fail goto*//*Label 15494*/ GIMT_Encode4(1046299), // Rule ID 13804 //
     /* 1046227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1046238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1046241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1046247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046266 */     // MIs[0] policy
     /* 1046266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046276 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1046279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046298 */     // GIR_Coverage, 13804,
     /* 1046298 */     GIR_EraseRootFromParent_Done,
     /* 1046299 */   // Label 15494: @1046299
     /* 1046299 */   GIM_Try, /*On fail goto*//*Label 15495*/ GIMT_Encode4(1046376), // Rule ID 13805 //
     /* 1046304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1046315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1046318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1046324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046343 */     // MIs[0] policy
     /* 1046343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046353 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1046356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046375 */     // GIR_Coverage, 13805,
     /* 1046375 */     GIR_EraseRootFromParent_Done,
     /* 1046376 */   // Label 15495: @1046376
     /* 1046376 */   GIM_Try, /*On fail goto*//*Label 15496*/ GIMT_Encode4(1046453), // Rule ID 13808 //
     /* 1046381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1046392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1046395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1046401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046420 */     // MIs[0] policy
     /* 1046420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046430 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046452 */     // GIR_Coverage, 13808,
     /* 1046452 */     GIR_EraseRootFromParent_Done,
     /* 1046453 */   // Label 15496: @1046453
     /* 1046453 */   GIM_Try, /*On fail goto*//*Label 15497*/ GIMT_Encode4(1046530), // Rule ID 13809 //
     /* 1046458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1046469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1046472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1046478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046497 */     // MIs[0] policy
     /* 1046497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046507 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046529 */     // GIR_Coverage, 13809,
     /* 1046529 */     GIR_EraseRootFromParent_Done,
     /* 1046530 */   // Label 15497: @1046530
     /* 1046530 */   GIM_Try, /*On fail goto*//*Label 15498*/ GIMT_Encode4(1046607), // Rule ID 13812 //
     /* 1046535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1046546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1046549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1046555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046574 */     // MIs[0] policy
     /* 1046574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046606 */     // GIR_Coverage, 13812,
     /* 1046606 */     GIR_EraseRootFromParent_Done,
     /* 1046607 */   // Label 15498: @1046607
     /* 1046607 */   GIM_Try, /*On fail goto*//*Label 15499*/ GIMT_Encode4(1046684), // Rule ID 13813 //
     /* 1046612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1046623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1046626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1046632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046651 */     // MIs[0] policy
     /* 1046651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046661 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046683 */     // GIR_Coverage, 13813,
     /* 1046683 */     GIR_EraseRootFromParent_Done,
     /* 1046684 */   // Label 15499: @1046684
     /* 1046684 */   GIM_Try, /*On fail goto*//*Label 15500*/ GIMT_Encode4(1046761), // Rule ID 13816 //
     /* 1046689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1046700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1046703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1046709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046728 */     // MIs[0] policy
     /* 1046728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046738 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1046741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046760 */     // GIR_Coverage, 13816,
     /* 1046760 */     GIR_EraseRootFromParent_Done,
     /* 1046761 */   // Label 15500: @1046761
     /* 1046761 */   GIM_Try, /*On fail goto*//*Label 15501*/ GIMT_Encode4(1046838), // Rule ID 13817 //
     /* 1046766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1046777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1046780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1046786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046805 */     // MIs[0] policy
     /* 1046805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046815 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1046818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046837 */     // GIR_Coverage, 13817,
     /* 1046837 */     GIR_EraseRootFromParent_Done,
     /* 1046838 */   // Label 15501: @1046838
     /* 1046838 */   GIM_Try, /*On fail goto*//*Label 15502*/ GIMT_Encode4(1046915), // Rule ID 13820 //
     /* 1046843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1046854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1046857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1046863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046882 */     // MIs[0] policy
     /* 1046882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046892 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1046895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046914 */     // GIR_Coverage, 13820,
     /* 1046914 */     GIR_EraseRootFromParent_Done,
     /* 1046915 */   // Label 15502: @1046915
     /* 1046915 */   GIM_Try, /*On fail goto*//*Label 15503*/ GIMT_Encode4(1046992), // Rule ID 13821 //
     /* 1046920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1046931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1046934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1046940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046959 */     // MIs[0] policy
     /* 1046959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046969 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1046972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046991 */     // GIR_Coverage, 13821,
     /* 1046991 */     GIR_EraseRootFromParent_Done,
     /* 1046992 */   // Label 15503: @1046992
     /* 1046992 */   GIM_Try, /*On fail goto*//*Label 15504*/ GIMT_Encode4(1047069), // Rule ID 13824 //
     /* 1046997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1047008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1047011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1047017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047036 */     // MIs[0] policy
     /* 1047036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1047049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047068 */     // GIR_Coverage, 13824,
     /* 1047068 */     GIR_EraseRootFromParent_Done,
     /* 1047069 */   // Label 15504: @1047069
     /* 1047069 */   GIM_Try, /*On fail goto*//*Label 15505*/ GIMT_Encode4(1047146), // Rule ID 13825 //
     /* 1047074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1047085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1047088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1047094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047113 */     // MIs[0] policy
     /* 1047113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047123 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1047126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047145 */     // GIR_Coverage, 13825,
     /* 1047145 */     GIR_EraseRootFromParent_Done,
     /* 1047146 */   // Label 15505: @1047146
     /* 1047146 */   GIM_Try, /*On fail goto*//*Label 15506*/ GIMT_Encode4(1047223), // Rule ID 13828 //
     /* 1047151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1047162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1047165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1047171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047190 */     // MIs[0] policy
     /* 1047190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047200 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11708:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1047203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047222 */     // GIR_Coverage, 13828,
     /* 1047222 */     GIR_EraseRootFromParent_Done,
     /* 1047223 */   // Label 15506: @1047223
     /* 1047223 */   GIM_Try, /*On fail goto*//*Label 15507*/ GIMT_Encode4(1047300), // Rule ID 13829 //
     /* 1047228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1047239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1047242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1047248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047267 */     // MIs[0] policy
     /* 1047267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11708:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1047280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047299 */     // GIR_Coverage, 13829,
     /* 1047299 */     GIR_EraseRootFromParent_Done,
     /* 1047300 */   // Label 15507: @1047300
     /* 1047300 */   GIM_Try, /*On fail goto*//*Label 15508*/ GIMT_Encode4(1047377), // Rule ID 13832 //
     /* 1047305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1047316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1047319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1047325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047344 */     // MIs[0] policy
     /* 1047344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047354 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1047357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047373 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047376 */     // GIR_Coverage, 13832,
     /* 1047376 */     GIR_EraseRootFromParent_Done,
     /* 1047377 */   // Label 15508: @1047377
     /* 1047377 */   GIM_Try, /*On fail goto*//*Label 15509*/ GIMT_Encode4(1047454), // Rule ID 13833 //
     /* 1047382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1047393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1047396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1047402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047421 */     // MIs[0] policy
     /* 1047421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047431 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1047434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047450 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047453 */     // GIR_Coverage, 13833,
     /* 1047453 */     GIR_EraseRootFromParent_Done,
     /* 1047454 */   // Label 15509: @1047454
     /* 1047454 */   GIM_Try, /*On fail goto*//*Label 15510*/ GIMT_Encode4(1047531), // Rule ID 13836 //
     /* 1047459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1047470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1047473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1047479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047498 */     // MIs[0] policy
     /* 1047498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047530 */     // GIR_Coverage, 13836,
     /* 1047530 */     GIR_EraseRootFromParent_Done,
     /* 1047531 */   // Label 15510: @1047531
     /* 1047531 */   GIM_Try, /*On fail goto*//*Label 15511*/ GIMT_Encode4(1047608), // Rule ID 13837 //
     /* 1047536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1047547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1047550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1047556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047575 */     // MIs[0] policy
     /* 1047575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047585 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047604 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047607 */     // GIR_Coverage, 13837,
     /* 1047607 */     GIR_EraseRootFromParent_Done,
     /* 1047608 */   // Label 15511: @1047608
     /* 1047608 */   GIM_Try, /*On fail goto*//*Label 15512*/ GIMT_Encode4(1047685), // Rule ID 13840 //
     /* 1047613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1047624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1047627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1047633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047652 */     // MIs[0] policy
     /* 1047652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047662 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047684 */     // GIR_Coverage, 13840,
     /* 1047684 */     GIR_EraseRootFromParent_Done,
     /* 1047685 */   // Label 15512: @1047685
     /* 1047685 */   GIM_Try, /*On fail goto*//*Label 15513*/ GIMT_Encode4(1047762), // Rule ID 13841 //
     /* 1047690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1047701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1047704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1047710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047729 */     // MIs[0] policy
     /* 1047729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047739 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047761 */     // GIR_Coverage, 13841,
     /* 1047761 */     GIR_EraseRootFromParent_Done,
     /* 1047762 */   // Label 15513: @1047762
     /* 1047762 */   GIM_Try, /*On fail goto*//*Label 15514*/ GIMT_Encode4(1047839), // Rule ID 13844 //
     /* 1047767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1047778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1047781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1047787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047806 */     // MIs[0] policy
     /* 1047806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1047819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047838 */     // GIR_Coverage, 13844,
     /* 1047838 */     GIR_EraseRootFromParent_Done,
     /* 1047839 */   // Label 15514: @1047839
     /* 1047839 */   GIM_Try, /*On fail goto*//*Label 15515*/ GIMT_Encode4(1047916), // Rule ID 13845 //
     /* 1047844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1047855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1047858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1047864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047883 */     // MIs[0] policy
     /* 1047883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047893 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1047896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047915 */     // GIR_Coverage, 13845,
     /* 1047915 */     GIR_EraseRootFromParent_Done,
     /* 1047916 */   // Label 15515: @1047916
     /* 1047916 */   GIM_Try, /*On fail goto*//*Label 15516*/ GIMT_Encode4(1047993), // Rule ID 13848 //
     /* 1047921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1047932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1047935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1047941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047960 */     // MIs[0] policy
     /* 1047960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047970 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1047973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047992 */     // GIR_Coverage, 13848,
     /* 1047992 */     GIR_EraseRootFromParent_Done,
     /* 1047993 */   // Label 15516: @1047993
     /* 1047993 */   GIM_Try, /*On fail goto*//*Label 15517*/ GIMT_Encode4(1048070), // Rule ID 13849 //
     /* 1047998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1048001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1048006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1048009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1048012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1048018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048037 */     // MIs[0] policy
     /* 1048037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048047 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1048050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048069 */     // GIR_Coverage, 13849,
     /* 1048069 */     GIR_EraseRootFromParent_Done,
     /* 1048070 */   // Label 15517: @1048070
     /* 1048070 */   GIM_Try, /*On fail goto*//*Label 15518*/ GIMT_Encode4(1048147), // Rule ID 13852 //
     /* 1048075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1048078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1048083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1048086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1048089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1048095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048114 */     // MIs[0] policy
     /* 1048114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048124 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1048127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048146 */     // GIR_Coverage, 13852,
     /* 1048146 */     GIR_EraseRootFromParent_Done,
     /* 1048147 */   // Label 15518: @1048147
     /* 1048147 */   GIM_Try, /*On fail goto*//*Label 15519*/ GIMT_Encode4(1048224), // Rule ID 13853 //
     /* 1048152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1048155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1048160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1048163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1048166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1048172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048191 */     // MIs[0] policy
     /* 1048191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048201 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1048204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048223 */     // GIR_Coverage, 13853,
     /* 1048223 */     GIR_EraseRootFromParent_Done,
     /* 1048224 */   // Label 15519: @1048224
     /* 1048224 */   GIM_Try, /*On fail goto*//*Label 15520*/ GIMT_Encode4(1048301), // Rule ID 13856 //
     /* 1048229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1048232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1048237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1048240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1048243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1048249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048268 */     // MIs[0] policy
     /* 1048268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048278 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1048281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048300 */     // GIR_Coverage, 13856,
     /* 1048300 */     GIR_EraseRootFromParent_Done,
     /* 1048301 */   // Label 15520: @1048301
     /* 1048301 */   GIM_Try, /*On fail goto*//*Label 15521*/ GIMT_Encode4(1048378), // Rule ID 13857 //
     /* 1048306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1048309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1048314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1048317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1048320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1048326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048345 */     // MIs[0] policy
     /* 1048345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048355 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1048358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048377 */     // GIR_Coverage, 13857,
     /* 1048377 */     GIR_EraseRootFromParent_Done,
     /* 1048378 */   // Label 15521: @1048378
     /* 1048378 */   GIM_Try, /*On fail goto*//*Label 15522*/ GIMT_Encode4(1048455), // Rule ID 19070 //
     /* 1048383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1048394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1048397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1048400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048422 */     // MIs[0] policy
     /* 1048422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048432 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1048435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048454 */     // GIR_Coverage, 19070,
     /* 1048454 */     GIR_EraseRootFromParent_Done,
     /* 1048455 */   // Label 15522: @1048455
     /* 1048455 */   GIM_Try, /*On fail goto*//*Label 15523*/ GIMT_Encode4(1048532), // Rule ID 19071 //
     /* 1048460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1048471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1048474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1048477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048499 */     // MIs[0] policy
     /* 1048499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048509 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1048512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048518 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048531 */     // GIR_Coverage, 19071,
     /* 1048531 */     GIR_EraseRootFromParent_Done,
     /* 1048532 */   // Label 15523: @1048532
     /* 1048532 */   GIM_Try, /*On fail goto*//*Label 15524*/ GIMT_Encode4(1048609), // Rule ID 19074 //
     /* 1048537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1048540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1048554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048576 */     // MIs[0] policy
     /* 1048576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048586 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1048589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048605 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048608 */     // GIR_Coverage, 19074,
     /* 1048608 */     GIR_EraseRootFromParent_Done,
     /* 1048609 */   // Label 15524: @1048609
     /* 1048609 */   GIM_Try, /*On fail goto*//*Label 15525*/ GIMT_Encode4(1048686), // Rule ID 19075 //
     /* 1048614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1048617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1048631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048653 */     // MIs[0] policy
     /* 1048653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048663 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1048666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048672 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048685 */     // GIR_Coverage, 19075,
     /* 1048685 */     GIR_EraseRootFromParent_Done,
     /* 1048686 */   // Label 15525: @1048686
     /* 1048686 */   GIM_Try, /*On fail goto*//*Label 15526*/ GIMT_Encode4(1048763), // Rule ID 19078 //
     /* 1048691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1048702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1048705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1048708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1048711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048730 */     // MIs[0] policy
     /* 1048730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048740 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11317:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1048743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048762 */     // GIR_Coverage, 19078,
     /* 1048762 */     GIR_EraseRootFromParent_Done,
     /* 1048763 */   // Label 15526: @1048763
     /* 1048763 */   GIM_Try, /*On fail goto*//*Label 15527*/ GIMT_Encode4(1048840), // Rule ID 19079 //
     /* 1048768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1048779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1048782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1048785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1048788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048807 */     // MIs[0] policy
     /* 1048807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048817 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11317:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1048820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048826 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048839 */     // GIR_Coverage, 19079,
     /* 1048839 */     GIR_EraseRootFromParent_Done,
     /* 1048840 */   // Label 15527: @1048840
     /* 1048840 */   GIM_Try, /*On fail goto*//*Label 15528*/ GIMT_Encode4(1048917), // Rule ID 19082 //
     /* 1048845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1048848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1048862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048884 */     // MIs[0] policy
     /* 1048884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048894 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1048897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048916 */     // GIR_Coverage, 19082,
     /* 1048916 */     GIR_EraseRootFromParent_Done,
     /* 1048917 */   // Label 15528: @1048917
     /* 1048917 */   GIM_Try, /*On fail goto*//*Label 15529*/ GIMT_Encode4(1048994), // Rule ID 19083 //
     /* 1048922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1048925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1048939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048961 */     // MIs[0] policy
     /* 1048961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048971 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1048974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048993 */     // GIR_Coverage, 19083,
     /* 1048993 */     GIR_EraseRootFromParent_Done,
     /* 1048994 */   // Label 15529: @1048994
     /* 1048994 */   GIM_Try, /*On fail goto*//*Label 15530*/ GIMT_Encode4(1049071), // Rule ID 19086 //
     /* 1048999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1049002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1049010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1049013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1049016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1049019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1049026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049038 */     // MIs[0] policy
     /* 1049038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049048 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1049051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049070 */     // GIR_Coverage, 19086,
     /* 1049070 */     GIR_EraseRootFromParent_Done,
     /* 1049071 */   // Label 15530: @1049071
     /* 1049071 */   GIM_Try, /*On fail goto*//*Label 15531*/ GIMT_Encode4(1049148), // Rule ID 19087 //
     /* 1049076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1049079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1049087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1049090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1049093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1049096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1049103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049115 */     // MIs[0] policy
     /* 1049115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049125 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1049128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049134 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049147 */     // GIR_Coverage, 19087,
     /* 1049147 */     GIR_EraseRootFromParent_Done,
     /* 1049148 */   // Label 15531: @1049148
     /* 1049148 */   GIM_Try, /*On fail goto*//*Label 15532*/ GIMT_Encode4(1049225), // Rule ID 19090 //
     /* 1049153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1049156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1049164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1049167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1049170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049192 */     // MIs[0] policy
     /* 1049192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049202 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1049205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049224 */     // GIR_Coverage, 19090,
     /* 1049224 */     GIR_EraseRootFromParent_Done,
     /* 1049225 */   // Label 15532: @1049225
     /* 1049225 */   GIM_Try, /*On fail goto*//*Label 15533*/ GIMT_Encode4(1049302), // Rule ID 19091 //
     /* 1049230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1049233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1049241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1049244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1049247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049269 */     // MIs[0] policy
     /* 1049269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049279 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1049282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049301 */     // GIR_Coverage, 19091,
     /* 1049301 */     GIR_EraseRootFromParent_Done,
     /* 1049302 */   // Label 15533: @1049302
     /* 1049302 */   GIM_Try, /*On fail goto*//*Label 15534*/ GIMT_Encode4(1049379), // Rule ID 19094 //
     /* 1049307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1049310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1049318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1049321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1049324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1049327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049346 */     // MIs[0] policy
     /* 1049346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049356 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1049359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049378 */     // GIR_Coverage, 19094,
     /* 1049378 */     GIR_EraseRootFromParent_Done,
     /* 1049379 */   // Label 15534: @1049379
     /* 1049379 */   GIM_Try, /*On fail goto*//*Label 15535*/ GIMT_Encode4(1049456), // Rule ID 19095 //
     /* 1049384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1049387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1049395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1049398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1049401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1049404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049423 */     // MIs[0] policy
     /* 1049423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049433 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1049436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049442 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049455 */     // GIR_Coverage, 19095,
     /* 1049455 */     GIR_EraseRootFromParent_Done,
     /* 1049456 */   // Label 15535: @1049456
     /* 1049456 */   GIM_Try, /*On fail goto*//*Label 15536*/ GIMT_Encode4(1049533), // Rule ID 19098 //
     /* 1049461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1049464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1049472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1049475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1049478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1049481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049500 */     // MIs[0] policy
     /* 1049500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049510 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1049513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049529 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049532 */     // GIR_Coverage, 19098,
     /* 1049532 */     GIR_EraseRootFromParent_Done,
     /* 1049533 */   // Label 15536: @1049533
     /* 1049533 */   GIM_Try, /*On fail goto*//*Label 15537*/ GIMT_Encode4(1049610), // Rule ID 19099 //
     /* 1049538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1049541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1049549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1049552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1049555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1049558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049577 */     // MIs[0] policy
     /* 1049577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049587 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1049590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049609 */     // GIR_Coverage, 19099,
     /* 1049609 */     GIR_EraseRootFromParent_Done,
     /* 1049610 */   // Label 15537: @1049610
     /* 1049610 */   GIM_Try, /*On fail goto*//*Label 15538*/ GIMT_Encode4(1049687), // Rule ID 19102 //
     /* 1049615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1049618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1049626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1049629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1049632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049654 */     // MIs[0] policy
     /* 1049654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049664 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1049667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049683 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049686 */     // GIR_Coverage, 19102,
     /* 1049686 */     GIR_EraseRootFromParent_Done,
     /* 1049687 */   // Label 15538: @1049687
     /* 1049687 */   GIM_Try, /*On fail goto*//*Label 15539*/ GIMT_Encode4(1049764), // Rule ID 19103 //
     /* 1049692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1049695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1049703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1049706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1049709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049731 */     // MIs[0] policy
     /* 1049731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049741 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1049744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049750 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049763 */     // GIR_Coverage, 19103,
     /* 1049763 */     GIR_EraseRootFromParent_Done,
     /* 1049764 */   // Label 15539: @1049764
     /* 1049764 */   GIM_Try, /*On fail goto*//*Label 15540*/ GIMT_Encode4(1049841), // Rule ID 19106 //
     /* 1049769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1049772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1049780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1049783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1049786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049808 */     // MIs[0] policy
     /* 1049808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049818 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1049821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049840 */     // GIR_Coverage, 19106,
     /* 1049840 */     GIR_EraseRootFromParent_Done,
     /* 1049841 */   // Label 15540: @1049841
     /* 1049841 */   GIM_Try, /*On fail goto*//*Label 15541*/ GIMT_Encode4(1049918), // Rule ID 19107 //
     /* 1049846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1049849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1049857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1049860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1049863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049885 */     // MIs[0] policy
     /* 1049885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049895 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1049898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049904 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049917 */     // GIR_Coverage, 19107,
     /* 1049917 */     GIR_EraseRootFromParent_Done,
     /* 1049918 */   // Label 15541: @1049918
     /* 1049918 */   GIM_Try, /*On fail goto*//*Label 15542*/ GIMT_Encode4(1049995), // Rule ID 19110 //
     /* 1049923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1049926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1049934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1049937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1049940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1049943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049962 */     // MIs[0] policy
     /* 1049962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049972 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1049975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049991 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049994 */     // GIR_Coverage, 19110,
     /* 1049994 */     GIR_EraseRootFromParent_Done,
     /* 1049995 */   // Label 15542: @1049995
     /* 1049995 */   GIM_Try, /*On fail goto*//*Label 15543*/ GIMT_Encode4(1050072), // Rule ID 19111 //
     /* 1050000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1050003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1050011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1050014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1050017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1050020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1050027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050039 */     // MIs[0] policy
     /* 1050039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050049 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1050052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050058 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050071 */     // GIR_Coverage, 19111,
     /* 1050071 */     GIR_EraseRootFromParent_Done,
     /* 1050072 */   // Label 15543: @1050072
     /* 1050072 */   GIM_Try, /*On fail goto*//*Label 15544*/ GIMT_Encode4(1050149), // Rule ID 19114 //
     /* 1050077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1050080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1050088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1050091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1050094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1050104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050116 */     // MIs[0] policy
     /* 1050116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050126 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1050129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050148 */     // GIR_Coverage, 19114,
     /* 1050148 */     GIR_EraseRootFromParent_Done,
     /* 1050149 */   // Label 15544: @1050149
     /* 1050149 */   GIM_Try, /*On fail goto*//*Label 15545*/ GIMT_Encode4(1050226), // Rule ID 19115 //
     /* 1050154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1050157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1050165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1050168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1050171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1050181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050193 */     // MIs[0] policy
     /* 1050193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050203 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1050206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050225 */     // GIR_Coverage, 19115,
     /* 1050225 */     GIR_EraseRootFromParent_Done,
     /* 1050226 */   // Label 15545: @1050226
     /* 1050226 */   GIM_Try, /*On fail goto*//*Label 15546*/ GIMT_Encode4(1050303), // Rule ID 19118 //
     /* 1050231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1050234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1050242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1050245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1050248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1050258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050270 */     // MIs[0] policy
     /* 1050270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050280 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1050283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050302 */     // GIR_Coverage, 19118,
     /* 1050302 */     GIR_EraseRootFromParent_Done,
     /* 1050303 */   // Label 15546: @1050303
     /* 1050303 */   GIM_Try, /*On fail goto*//*Label 15547*/ GIMT_Encode4(1050380), // Rule ID 19119 //
     /* 1050308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1050311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1050319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1050322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1050325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1050335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050347 */     // MIs[0] policy
     /* 1050347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050357 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1050360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050379 */     // GIR_Coverage, 19119,
     /* 1050379 */     GIR_EraseRootFromParent_Done,
     /* 1050380 */   // Label 15547: @1050380
     /* 1050380 */   GIM_Try, /*On fail goto*//*Label 15548*/ GIMT_Encode4(1050457), // Rule ID 19122 //
     /* 1050385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1050388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1050396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1050399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1050402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1050412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050424 */     // MIs[0] policy
     /* 1050424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050434 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1050437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050456 */     // GIR_Coverage, 19122,
     /* 1050456 */     GIR_EraseRootFromParent_Done,
     /* 1050457 */   // Label 15548: @1050457
     /* 1050457 */   GIM_Try, /*On fail goto*//*Label 15549*/ GIMT_Encode4(1050534), // Rule ID 19123 //
     /* 1050462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1050465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1050473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1050476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1050479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1050489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050501 */     // MIs[0] policy
     /* 1050501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050511 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1050514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050520 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050530 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050533 */     // GIR_Coverage, 19123,
     /* 1050533 */     GIR_EraseRootFromParent_Done,
     /* 1050534 */   // Label 15549: @1050534
     /* 1050534 */   GIM_Try, /*On fail goto*//*Label 15550*/ GIMT_Encode4(1050611), // Rule ID 20506 //
     /* 1050539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1050550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1050553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1050556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050578 */     // MIs[0] policy
     /* 1050578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050588 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050610 */     // GIR_Coverage, 20506,
     /* 1050610 */     GIR_EraseRootFromParent_Done,
     /* 1050611 */   // Label 15550: @1050611
     /* 1050611 */   GIM_Try, /*On fail goto*//*Label 15551*/ GIMT_Encode4(1050688), // Rule ID 20507 //
     /* 1050616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1050627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1050630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1050633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050655 */     // MIs[0] policy
     /* 1050655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050665 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050687 */     // GIR_Coverage, 20507,
     /* 1050687 */     GIR_EraseRootFromParent_Done,
     /* 1050688 */   // Label 15551: @1050688
     /* 1050688 */   GIM_Try, /*On fail goto*//*Label 15552*/ GIMT_Encode4(1050765), // Rule ID 20510 //
     /* 1050693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1050696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1050704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1050707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1050710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050732 */     // MIs[0] policy
     /* 1050732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050742 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050764 */     // GIR_Coverage, 20510,
     /* 1050764 */     GIR_EraseRootFromParent_Done,
     /* 1050765 */   // Label 15552: @1050765
     /* 1050765 */   GIM_Try, /*On fail goto*//*Label 15553*/ GIMT_Encode4(1050842), // Rule ID 20511 //
     /* 1050770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1050773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1050781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1050784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1050787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050809 */     // MIs[0] policy
     /* 1050809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050819 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050828 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050841 */     // GIR_Coverage, 20511,
     /* 1050841 */     GIR_EraseRootFromParent_Done,
     /* 1050842 */   // Label 15553: @1050842
     /* 1050842 */   GIM_Try, /*On fail goto*//*Label 15554*/ GIMT_Encode4(1050919), // Rule ID 20514 //
     /* 1050847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1050858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1050861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1050864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050886 */     // MIs[0] policy
     /* 1050886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050896 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050918 */     // GIR_Coverage, 20514,
     /* 1050918 */     GIR_EraseRootFromParent_Done,
     /* 1050919 */   // Label 15554: @1050919
     /* 1050919 */   GIM_Try, /*On fail goto*//*Label 15555*/ GIMT_Encode4(1050996), // Rule ID 20515 //
     /* 1050924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1050935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1050938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1050941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050963 */     // MIs[0] policy
     /* 1050963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050973 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050982 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050995 */     // GIR_Coverage, 20515,
     /* 1050995 */     GIR_EraseRootFromParent_Done,
     /* 1050996 */   // Label 15555: @1050996
     /* 1050996 */   GIM_Try, /*On fail goto*//*Label 15556*/ GIMT_Encode4(1051073), // Rule ID 20518 //
     /* 1051001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1051004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1051012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1051015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1051018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051040 */     // MIs[0] policy
     /* 1051040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1051053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051069 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051072 */     // GIR_Coverage, 20518,
     /* 1051072 */     GIR_EraseRootFromParent_Done,
     /* 1051073 */   // Label 15556: @1051073
     /* 1051073 */   GIM_Try, /*On fail goto*//*Label 15557*/ GIMT_Encode4(1051150), // Rule ID 20519 //
     /* 1051078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1051089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1051092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1051095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051117 */     // MIs[0] policy
     /* 1051117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051127 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1051130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051136 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051146 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051149 */     // GIR_Coverage, 20519,
     /* 1051149 */     GIR_EraseRootFromParent_Done,
     /* 1051150 */   // Label 15557: @1051150
     /* 1051150 */   GIM_Try, /*On fail goto*//*Label 15558*/ GIMT_Encode4(1051227), // Rule ID 20522 //
     /* 1051155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1051158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1051166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1051169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1051172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1051175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051194 */     // MIs[0] policy
     /* 1051194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051204 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1051207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051223 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051226 */     // GIR_Coverage, 20522,
     /* 1051226 */     GIR_EraseRootFromParent_Done,
     /* 1051227 */   // Label 15558: @1051227
     /* 1051227 */   GIM_Try, /*On fail goto*//*Label 15559*/ GIMT_Encode4(1051304), // Rule ID 20523 //
     /* 1051232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1051235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1051243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1051246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1051249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1051252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051271 */     // MIs[0] policy
     /* 1051271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051281 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1051284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051290 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051303 */     // GIR_Coverage, 20523,
     /* 1051303 */     GIR_EraseRootFromParent_Done,
     /* 1051304 */   // Label 15559: @1051304
     /* 1051304 */   GIM_Try, /*On fail goto*//*Label 15560*/ GIMT_Encode4(1051381), // Rule ID 20526 //
     /* 1051309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1051312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1051320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1051323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1051326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051348 */     // MIs[0] policy
     /* 1051348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051358 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051377 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051380 */     // GIR_Coverage, 20526,
     /* 1051380 */     GIR_EraseRootFromParent_Done,
     /* 1051381 */   // Label 15560: @1051381
     /* 1051381 */   GIM_Try, /*On fail goto*//*Label 15561*/ GIMT_Encode4(1051458), // Rule ID 20527 //
     /* 1051386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1051389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1051397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1051400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1051403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051425 */     // MIs[0] policy
     /* 1051425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051435 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051457 */     // GIR_Coverage, 20527,
     /* 1051457 */     GIR_EraseRootFromParent_Done,
     /* 1051458 */   // Label 15561: @1051458
     /* 1051458 */   GIM_Try, /*On fail goto*//*Label 15562*/ GIMT_Encode4(1051535), // Rule ID 20530 //
     /* 1051463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1051466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1051474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1051477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1051480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051502 */     // MIs[0] policy
     /* 1051502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051512 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051534 */     // GIR_Coverage, 20530,
     /* 1051534 */     GIR_EraseRootFromParent_Done,
     /* 1051535 */   // Label 15562: @1051535
     /* 1051535 */   GIM_Try, /*On fail goto*//*Label 15563*/ GIMT_Encode4(1051612), // Rule ID 20531 //
     /* 1051540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1051543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1051551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1051554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1051557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051579 */     // MIs[0] policy
     /* 1051579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051589 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051598 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051611 */     // GIR_Coverage, 20531,
     /* 1051611 */     GIR_EraseRootFromParent_Done,
     /* 1051612 */   // Label 15563: @1051612
     /* 1051612 */   GIM_Try, /*On fail goto*//*Label 15564*/ GIMT_Encode4(1051689), // Rule ID 20534 //
     /* 1051617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1051620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1051628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1051631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1051634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1051637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051656 */     // MIs[0] policy
     /* 1051656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051666 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051688 */     // GIR_Coverage, 20534,
     /* 1051688 */     GIR_EraseRootFromParent_Done,
     /* 1051689 */   // Label 15564: @1051689
     /* 1051689 */   GIM_Try, /*On fail goto*//*Label 15565*/ GIMT_Encode4(1051766), // Rule ID 20535 //
     /* 1051694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1051697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1051705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1051708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1051711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1051714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051733 */     // MIs[0] policy
     /* 1051733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051743 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051752 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051765 */     // GIR_Coverage, 20535,
     /* 1051765 */     GIR_EraseRootFromParent_Done,
     /* 1051766 */   // Label 15565: @1051766
     /* 1051766 */   GIM_Try, /*On fail goto*//*Label 15566*/ GIMT_Encode4(1051843), // Rule ID 20538 //
     /* 1051771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1051774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1051782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1051785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1051788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1051791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051810 */     // MIs[0] policy
     /* 1051810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051820 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051839 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051842 */     // GIR_Coverage, 20538,
     /* 1051842 */     GIR_EraseRootFromParent_Done,
     /* 1051843 */   // Label 15566: @1051843
     /* 1051843 */   GIM_Try, /*On fail goto*//*Label 15567*/ GIMT_Encode4(1051920), // Rule ID 20539 //
     /* 1051848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1051859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1051862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1051865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1051868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051887 */     // MIs[0] policy
     /* 1051887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051897 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051906 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051916 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051919 */     // GIR_Coverage, 20539,
     /* 1051919 */     GIR_EraseRootFromParent_Done,
     /* 1051920 */   // Label 15567: @1051920
     /* 1051920 */   GIM_Try, /*On fail goto*//*Label 15568*/ GIMT_Encode4(1051997), // Rule ID 20542 //
     /* 1051925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1051928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1051936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1051939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1051942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051964 */     // MIs[0] policy
     /* 1051964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051974 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051993 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051996 */     // GIR_Coverage, 20542,
     /* 1051996 */     GIR_EraseRootFromParent_Done,
     /* 1051997 */   // Label 15568: @1051997
     /* 1051997 */   GIM_Try, /*On fail goto*//*Label 15569*/ GIMT_Encode4(1052074), // Rule ID 20543 //
     /* 1052002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1052005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1052013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1052016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1052019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052041 */     // MIs[0] policy
     /* 1052041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052051 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1052054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052060 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052073 */     // GIR_Coverage, 20543,
     /* 1052073 */     GIR_EraseRootFromParent_Done,
     /* 1052074 */   // Label 15569: @1052074
     /* 1052074 */   GIM_Try, /*On fail goto*//*Label 15570*/ GIMT_Encode4(1052151), // Rule ID 20546 //
     /* 1052079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1052082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1052090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1052093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1052096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1052099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052118 */     // MIs[0] policy
     /* 1052118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052128 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1052131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052150 */     // GIR_Coverage, 20546,
     /* 1052150 */     GIR_EraseRootFromParent_Done,
     /* 1052151 */   // Label 15570: @1052151
     /* 1052151 */   GIM_Try, /*On fail goto*//*Label 15571*/ GIMT_Encode4(1052228), // Rule ID 20547 //
     /* 1052156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1052159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1052167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1052170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1052173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1052176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052195 */     // MIs[0] policy
     /* 1052195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052205 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1052208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052214 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052227 */     // GIR_Coverage, 20547,
     /* 1052227 */     GIR_EraseRootFromParent_Done,
     /* 1052228 */   // Label 15571: @1052228
     /* 1052228 */   GIM_Try, /*On fail goto*//*Label 15572*/ GIMT_Encode4(1052305), // Rule ID 20550 //
     /* 1052233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1052236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1052244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1052247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1052250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1052260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052272 */     // MIs[0] policy
     /* 1052272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1052285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052301 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052304 */     // GIR_Coverage, 20550,
     /* 1052304 */     GIR_EraseRootFromParent_Done,
     /* 1052305 */   // Label 15572: @1052305
     /* 1052305 */   GIM_Try, /*On fail goto*//*Label 15573*/ GIMT_Encode4(1052382), // Rule ID 20551 //
     /* 1052310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1052313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1052321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1052324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1052327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1052337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052349 */     // MIs[0] policy
     /* 1052349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052359 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1052362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052368 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052381 */     // GIR_Coverage, 20551,
     /* 1052381 */     GIR_EraseRootFromParent_Done,
     /* 1052382 */   // Label 15573: @1052382
     /* 1052382 */   GIM_Try, /*On fail goto*//*Label 15574*/ GIMT_Encode4(1052459), // Rule ID 20554 //
     /* 1052387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1052390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1052398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1052401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1052404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052426 */     // MIs[0] policy
     /* 1052426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1052439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052455 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052458 */     // GIR_Coverage, 20554,
     /* 1052458 */     GIR_EraseRootFromParent_Done,
     /* 1052459 */   // Label 15574: @1052459
     /* 1052459 */   GIM_Try, /*On fail goto*//*Label 15575*/ GIMT_Encode4(1052536), // Rule ID 20555 //
     /* 1052464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1052467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1052475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1052478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1052481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052503 */     // MIs[0] policy
     /* 1052503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052513 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1052516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052522 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052535 */     // GIR_Coverage, 20555,
     /* 1052535 */     GIR_EraseRootFromParent_Done,
     /* 1052536 */   // Label 15575: @1052536
     /* 1052536 */   GIM_Try, /*On fail goto*//*Label 15576*/ GIMT_Encode4(1052613), // Rule ID 20558 //
     /* 1052541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1052544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1052552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1052555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1052558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052580 */     // MIs[0] policy
     /* 1052580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1052593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052612 */     // GIR_Coverage, 20558,
     /* 1052612 */     GIR_EraseRootFromParent_Done,
     /* 1052613 */   // Label 15576: @1052613
     /* 1052613 */   GIM_Try, /*On fail goto*//*Label 15577*/ GIMT_Encode4(1052690), // Rule ID 20559 //
     /* 1052618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1052621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1052629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1052632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1052635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052657 */     // MIs[0] policy
     /* 1052657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052667 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1052670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052689 */     // GIR_Coverage, 20559,
     /* 1052689 */     GIR_EraseRootFromParent_Done,
     /* 1052690 */   // Label 15577: @1052690
     /* 1052690 */   GIM_Try, /*On fail goto*//*Label 15578*/ GIMT_Encode4(1052767), // Rule ID 20884 //
     /* 1052695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1052706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1052709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1052712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052734 */     // MIs[0] policy
     /* 1052734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1052747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052763 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052766 */     // GIR_Coverage, 20884,
     /* 1052766 */     GIR_EraseRootFromParent_Done,
     /* 1052767 */   // Label 15578: @1052767
     /* 1052767 */   GIM_Try, /*On fail goto*//*Label 15579*/ GIMT_Encode4(1052844), // Rule ID 20885 //
     /* 1052772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1052783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1052786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1052789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052811 */     // MIs[0] policy
     /* 1052811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052821 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1052824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052830 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052843 */     // GIR_Coverage, 20885,
     /* 1052843 */     GIR_EraseRootFromParent_Done,
     /* 1052844 */   // Label 15579: @1052844
     /* 1052844 */   GIM_Try, /*On fail goto*//*Label 15580*/ GIMT_Encode4(1052921), // Rule ID 20888 //
     /* 1052849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1052860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1052863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1052866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052888 */     // MIs[0] policy
     /* 1052888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052898 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052917 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052920 */     // GIR_Coverage, 20888,
     /* 1052920 */     GIR_EraseRootFromParent_Done,
     /* 1052921 */   // Label 15580: @1052921
     /* 1052921 */   GIM_Try, /*On fail goto*//*Label 15581*/ GIMT_Encode4(1052998), // Rule ID 20889 //
     /* 1052926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1052937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1052940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1052943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052965 */     // MIs[0] policy
     /* 1052965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052975 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052997 */     // GIR_Coverage, 20889,
     /* 1052997 */     GIR_EraseRootFromParent_Done,
     /* 1052998 */   // Label 15581: @1052998
     /* 1052998 */   GIM_Try, /*On fail goto*//*Label 15582*/ GIMT_Encode4(1053075), // Rule ID 20892 //
     /* 1053003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1053006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1053014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1053017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1053020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1053023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053042 */     // MIs[0] policy
     /* 1053042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1053055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053071 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053074 */     // GIR_Coverage, 20892,
     /* 1053074 */     GIR_EraseRootFromParent_Done,
     /* 1053075 */   // Label 15582: @1053075
     /* 1053075 */   GIM_Try, /*On fail goto*//*Label 15583*/ GIMT_Encode4(1053152), // Rule ID 20893 //
     /* 1053080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1053083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1053091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1053094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1053097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1053100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053119 */     // MIs[0] policy
     /* 1053119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053129 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1053132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053151 */     // GIR_Coverage, 20893,
     /* 1053151 */     GIR_EraseRootFromParent_Done,
     /* 1053152 */   // Label 15583: @1053152
     /* 1053152 */   GIM_Try, /*On fail goto*//*Label 15584*/ GIMT_Encode4(1053229), // Rule ID 20896 //
     /* 1053157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1053168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1053171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1053174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053196 */     // MIs[0] policy
     /* 1053196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053206 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053228 */     // GIR_Coverage, 20896,
     /* 1053228 */     GIR_EraseRootFromParent_Done,
     /* 1053229 */   // Label 15584: @1053229
     /* 1053229 */   GIM_Try, /*On fail goto*//*Label 15585*/ GIMT_Encode4(1053306), // Rule ID 20897 //
     /* 1053234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1053245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1053248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1053251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053273 */     // MIs[0] policy
     /* 1053273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053283 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053305 */     // GIR_Coverage, 20897,
     /* 1053305 */     GIR_EraseRootFromParent_Done,
     /* 1053306 */   // Label 15585: @1053306
     /* 1053306 */   GIM_Try, /*On fail goto*//*Label 15586*/ GIMT_Encode4(1053383), // Rule ID 20900 //
     /* 1053311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1053314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1053322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1053325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1053328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1053331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053350 */     // MIs[0] policy
     /* 1053350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053382 */     // GIR_Coverage, 20900,
     /* 1053382 */     GIR_EraseRootFromParent_Done,
     /* 1053383 */   // Label 15586: @1053383
     /* 1053383 */   GIM_Try, /*On fail goto*//*Label 15587*/ GIMT_Encode4(1053460), // Rule ID 20901 //
     /* 1053388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1053391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1053399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1053402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1053405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1053408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053427 */     // MIs[0] policy
     /* 1053427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053437 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053446 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053459 */     // GIR_Coverage, 20901,
     /* 1053459 */     GIR_EraseRootFromParent_Done,
     /* 1053460 */   // Label 15587: @1053460
     /* 1053460 */   GIM_Try, /*On fail goto*//*Label 15588*/ GIMT_Encode4(1053537), // Rule ID 20904 //
     /* 1053465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1053468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1053476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1053479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1053482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1053485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053504 */     // MIs[0] policy
     /* 1053504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053533 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053536 */     // GIR_Coverage, 20904,
     /* 1053536 */     GIR_EraseRootFromParent_Done,
     /* 1053537 */   // Label 15588: @1053537
     /* 1053537 */   GIM_Try, /*On fail goto*//*Label 15589*/ GIMT_Encode4(1053614), // Rule ID 20905 //
     /* 1053542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1053545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1053553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1053556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1053559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1053562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053581 */     // MIs[0] policy
     /* 1053581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053591 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053600 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053610 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053613 */     // GIR_Coverage, 20905,
     /* 1053613 */     GIR_EraseRootFromParent_Done,
     /* 1053614 */   // Label 15589: @1053614
     /* 1053614 */   GIM_Try, /*On fail goto*//*Label 15590*/ GIMT_Encode4(1053691), // Rule ID 20908 //
     /* 1053619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1053630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1053633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1053636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053658 */     // MIs[0] policy
     /* 1053658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053668 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053690 */     // GIR_Coverage, 20908,
     /* 1053690 */     GIR_EraseRootFromParent_Done,
     /* 1053691 */   // Label 15590: @1053691
     /* 1053691 */   GIM_Try, /*On fail goto*//*Label 15591*/ GIMT_Encode4(1053768), // Rule ID 20909 //
     /* 1053696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1053707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1053710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1053713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053735 */     // MIs[0] policy
     /* 1053735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053745 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053754 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053764 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053767 */     // GIR_Coverage, 20909,
     /* 1053767 */     GIR_EraseRootFromParent_Done,
     /* 1053768 */   // Label 15591: @1053768
     /* 1053768 */   GIM_Try, /*On fail goto*//*Label 15592*/ GIMT_Encode4(1053845), // Rule ID 20912 //
     /* 1053773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1053784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1053787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1053790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053812 */     // MIs[0] policy
     /* 1053812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053822 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053841 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053844 */     // GIR_Coverage, 20912,
     /* 1053844 */     GIR_EraseRootFromParent_Done,
     /* 1053845 */   // Label 15592: @1053845
     /* 1053845 */   GIM_Try, /*On fail goto*//*Label 15593*/ GIMT_Encode4(1053922), // Rule ID 20913 //
     /* 1053850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1053861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1053864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1053867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053889 */     // MIs[0] policy
     /* 1053889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053899 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053921 */     // GIR_Coverage, 20913,
     /* 1053921 */     GIR_EraseRootFromParent_Done,
     /* 1053922 */   // Label 15593: @1053922
     /* 1053922 */   GIM_Try, /*On fail goto*//*Label 15594*/ GIMT_Encode4(1053999), // Rule ID 20916 //
     /* 1053927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1053938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1053941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1053944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1053947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053966 */     // MIs[0] policy
     /* 1053966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053976 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053998 */     // GIR_Coverage, 20916,
     /* 1053998 */     GIR_EraseRootFromParent_Done,
     /* 1053999 */   // Label 15594: @1053999
     /* 1053999 */   GIM_Try, /*On fail goto*//*Label 15595*/ GIMT_Encode4(1054076), // Rule ID 20917 //
     /* 1054004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1054015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1054018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1054021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1054024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054043 */     // MIs[0] policy
     /* 1054043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054053 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054062 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054075 */     // GIR_Coverage, 20917,
     /* 1054075 */     GIR_EraseRootFromParent_Done,
     /* 1054076 */   // Label 15595: @1054076
     /* 1054076 */   GIM_Try, /*On fail goto*//*Label 15596*/ GIMT_Encode4(1054153), // Rule ID 20920 //
     /* 1054081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1054092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1054095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1054098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054120 */     // MIs[0] policy
     /* 1054120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054130 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1054133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054152 */     // GIR_Coverage, 20920,
     /* 1054152 */     GIR_EraseRootFromParent_Done,
     /* 1054153 */   // Label 15596: @1054153
     /* 1054153 */   GIM_Try, /*On fail goto*//*Label 15597*/ GIMT_Encode4(1054230), // Rule ID 20921 //
     /* 1054158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1054169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1054172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1054175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054197 */     // MIs[0] policy
     /* 1054197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054207 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1054210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054229 */     // GIR_Coverage, 20921,
     /* 1054229 */     GIR_EraseRootFromParent_Done,
     /* 1054230 */   // Label 15597: @1054230
     /* 1054230 */   GIM_Try, /*On fail goto*//*Label 15598*/ GIMT_Encode4(1054307), // Rule ID 20924 //
     /* 1054235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1054246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1054249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1054252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054274 */     // MIs[0] policy
     /* 1054274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054284 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1054287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054306 */     // GIR_Coverage, 20924,
     /* 1054306 */     GIR_EraseRootFromParent_Done,
     /* 1054307 */   // Label 15598: @1054307
     /* 1054307 */   GIM_Try, /*On fail goto*//*Label 15599*/ GIMT_Encode4(1054384), // Rule ID 20925 //
     /* 1054312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1054323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1054326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1054329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054351 */     // MIs[0] policy
     /* 1054351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054361 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1054364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054380 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054383 */     // GIR_Coverage, 20925,
     /* 1054383 */     GIR_EraseRootFromParent_Done,
     /* 1054384 */   // Label 15599: @1054384
     /* 1054384 */   GIM_Try, /*On fail goto*//*Label 15600*/ GIMT_Encode4(1054461), // Rule ID 20928 //
     /* 1054389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1054400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1054403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1054406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1054409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054428 */     // MIs[0] policy
     /* 1054428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054438 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054457 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054460 */     // GIR_Coverage, 20928,
     /* 1054460 */     GIR_EraseRootFromParent_Done,
     /* 1054461 */   // Label 15600: @1054461
     /* 1054461 */   GIM_Try, /*On fail goto*//*Label 15601*/ GIMT_Encode4(1054538), // Rule ID 20929 //
     /* 1054466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1054477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1054480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1054483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1054486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054505 */     // MIs[0] policy
     /* 1054505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054515 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054537 */     // GIR_Coverage, 20929,
     /* 1054537 */     GIR_EraseRootFromParent_Done,
     /* 1054538 */   // Label 15601: @1054538
     /* 1054538 */   GIM_Try, /*On fail goto*//*Label 15602*/ GIMT_Encode4(1054615), // Rule ID 20932 //
     /* 1054543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1054554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1054557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1054560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054582 */     // MIs[0] policy
     /* 1054582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054592 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1054595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054614 */     // GIR_Coverage, 20932,
     /* 1054614 */     GIR_EraseRootFromParent_Done,
     /* 1054615 */   // Label 15602: @1054615
     /* 1054615 */   GIM_Try, /*On fail goto*//*Label 15603*/ GIMT_Encode4(1054692), // Rule ID 20933 //
     /* 1054620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1054631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1054634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1054637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054659 */     // MIs[0] policy
     /* 1054659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1054672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054678 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054691 */     // GIR_Coverage, 20933,
     /* 1054691 */     GIR_EraseRootFromParent_Done,
     /* 1054692 */   // Label 15603: @1054692
     /* 1054692 */   GIM_Try, /*On fail goto*//*Label 15604*/ GIMT_Encode4(1054769), // Rule ID 20936 //
     /* 1054697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1054708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1054711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1054714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054736 */     // MIs[0] policy
     /* 1054736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054746 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1054749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054768 */     // GIR_Coverage, 20936,
     /* 1054768 */     GIR_EraseRootFromParent_Done,
     /* 1054769 */   // Label 15604: @1054769
     /* 1054769 */   GIM_Try, /*On fail goto*//*Label 15605*/ GIMT_Encode4(1054846), // Rule ID 20937 //
     /* 1054774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1054785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1054788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1054791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054813 */     // MIs[0] policy
     /* 1054813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054823 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1054826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054832 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054842 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054845 */     // GIR_Coverage, 20937,
     /* 1054845 */     GIR_EraseRootFromParent_Done,
     /* 1054846 */   // Label 15605: @1054846
     /* 1054846 */   GIM_Try, /*On fail goto*//*Label 15606*/ GIMT_Encode4(1054923), // Rule ID 20940 //
     /* 1054851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1054862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1054865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1054868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054890 */     // MIs[0] policy
     /* 1054890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054900 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054919 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054922 */     // GIR_Coverage, 20940,
     /* 1054922 */     GIR_EraseRootFromParent_Done,
     /* 1054923 */   // Label 15606: @1054923
     /* 1054923 */   GIM_Try, /*On fail goto*//*Label 15607*/ GIMT_Encode4(1055000), // Rule ID 20941 //
     /* 1054928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1054939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1054942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1054945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054967 */     // MIs[0] policy
     /* 1054967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054977 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054986 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054996 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054999 */     // GIR_Coverage, 20941,
     /* 1054999 */     GIR_EraseRootFromParent_Done,
     /* 1055000 */   // Label 15607: @1055000
     /* 1055000 */   GIM_Try, /*On fail goto*//*Label 15608*/ GIMT_Encode4(1055077), // Rule ID 20944 //
     /* 1055005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1055016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1055019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1055022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055044 */     // MIs[0] policy
     /* 1055044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055054 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1055057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055076 */     // GIR_Coverage, 20944,
     /* 1055076 */     GIR_EraseRootFromParent_Done,
     /* 1055077 */   // Label 15608: @1055077
     /* 1055077 */   GIM_Try, /*On fail goto*//*Label 15609*/ GIMT_Encode4(1055154), // Rule ID 20945 //
     /* 1055082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1055093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1055096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1055099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055121 */     // MIs[0] policy
     /* 1055121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055131 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1055134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055153 */     // GIR_Coverage, 20945,
     /* 1055153 */     GIR_EraseRootFromParent_Done,
     /* 1055154 */   // Label 15609: @1055154
     /* 1055154 */   GIM_Try, /*On fail goto*//*Label 15610*/ GIMT_Encode4(1055231), // Rule ID 20948 //
     /* 1055159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1055170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1055173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1055176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055198 */     // MIs[0] policy
     /* 1055198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055208 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1055211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055230 */     // GIR_Coverage, 20948,
     /* 1055230 */     GIR_EraseRootFromParent_Done,
     /* 1055231 */   // Label 15610: @1055231
     /* 1055231 */   GIM_Try, /*On fail goto*//*Label 15611*/ GIMT_Encode4(1055308), // Rule ID 20949 //
     /* 1055236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1055247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1055250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1055253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055275 */     // MIs[0] policy
     /* 1055275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055285 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1055288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055294 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055307 */     // GIR_Coverage, 20949,
     /* 1055307 */     GIR_EraseRootFromParent_Done,
     /* 1055308 */   // Label 15611: @1055308
     /* 1055308 */   GIM_Try, /*On fail goto*//*Label 15612*/ GIMT_Encode4(1055385), // Rule ID 20952 //
     /* 1055313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1055324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1055327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1055330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055352 */     // MIs[0] policy
     /* 1055352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055362 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1055365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055381 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055384 */     // GIR_Coverage, 20952,
     /* 1055384 */     GIR_EraseRootFromParent_Done,
     /* 1055385 */   // Label 15612: @1055385
     /* 1055385 */   GIM_Try, /*On fail goto*//*Label 15613*/ GIMT_Encode4(1055462), // Rule ID 20953 //
     /* 1055390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1055401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1055404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1055407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055429 */     // MIs[0] policy
     /* 1055429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055439 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1055442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055448 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055458 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055461 */     // GIR_Coverage, 20953,
     /* 1055461 */     GIR_EraseRootFromParent_Done,
     /* 1055462 */   // Label 15613: @1055462
     /* 1055462 */   GIM_Try, /*On fail goto*//*Label 15614*/ GIMT_Encode4(1055539), // Rule ID 20956 //
     /* 1055467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1055478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1055481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1055484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055506 */     // MIs[0] policy
     /* 1055506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055516 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055538 */     // GIR_Coverage, 20956,
     /* 1055538 */     GIR_EraseRootFromParent_Done,
     /* 1055539 */   // Label 15614: @1055539
     /* 1055539 */   GIM_Try, /*On fail goto*//*Label 15615*/ GIMT_Encode4(1055616), // Rule ID 20957 //
     /* 1055544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1055555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1055558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1055561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055583 */     // MIs[0] policy
     /* 1055583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055593 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055602 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055615 */     // GIR_Coverage, 20957,
     /* 1055615 */     GIR_EraseRootFromParent_Done,
     /* 1055616 */   // Label 15615: @1055616
     /* 1055616 */   GIM_Try, /*On fail goto*//*Label 15616*/ GIMT_Encode4(1055693), // Rule ID 20960 //
     /* 1055621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1055632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1055635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1055638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055660 */     // MIs[0] policy
     /* 1055660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055692 */     // GIR_Coverage, 20960,
     /* 1055692 */     GIR_EraseRootFromParent_Done,
     /* 1055693 */   // Label 15616: @1055693
     /* 1055693 */   GIM_Try, /*On fail goto*//*Label 15617*/ GIMT_Encode4(1055770), // Rule ID 20961 //
     /* 1055698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1055709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1055712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1055715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055737 */     // MIs[0] policy
     /* 1055737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055747 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055769 */     // GIR_Coverage, 20961,
     /* 1055769 */     GIR_EraseRootFromParent_Done,
     /* 1055770 */   // Label 15617: @1055770
     /* 1055770 */   GIM_Try, /*On fail goto*//*Label 15618*/ GIMT_Encode4(1055847), // Rule ID 20964 //
     /* 1055775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1055778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1055786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1055789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1055792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055814 */     // MIs[0] policy
     /* 1055814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055824 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055846 */     // GIR_Coverage, 20964,
     /* 1055846 */     GIR_EraseRootFromParent_Done,
     /* 1055847 */   // Label 15618: @1055847
     /* 1055847 */   GIM_Try, /*On fail goto*//*Label 15619*/ GIMT_Encode4(1055924), // Rule ID 20965 //
     /* 1055852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1055855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1055863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1055866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1055869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055891 */     // MIs[0] policy
     /* 1055891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055901 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055910 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055923 */     // GIR_Coverage, 20965,
     /* 1055923 */     GIR_EraseRootFromParent_Done,
     /* 1055924 */   // Label 15619: @1055924
     /* 1055924 */   GIM_Try, /*On fail goto*//*Label 15620*/ GIMT_Encode4(1056001), // Rule ID 20968 //
     /* 1055929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1055940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1055943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1055946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055968 */     // MIs[0] policy
     /* 1055968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1055981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056000 */     // GIR_Coverage, 20968,
     /* 1056000 */     GIR_EraseRootFromParent_Done,
     /* 1056001 */   // Label 15620: @1056001
     /* 1056001 */   GIM_Try, /*On fail goto*//*Label 15621*/ GIMT_Encode4(1056078), // Rule ID 20969 //
     /* 1056006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1056017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1056020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1056023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056045 */     // MIs[0] policy
     /* 1056045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056055 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056064 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056077 */     // GIR_Coverage, 20969,
     /* 1056077 */     GIR_EraseRootFromParent_Done,
     /* 1056078 */   // Label 15621: @1056078
     /* 1056078 */   GIM_Try, /*On fail goto*//*Label 15622*/ GIMT_Encode4(1056155), // Rule ID 20972 //
     /* 1056083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1056094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1056097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1056100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056122 */     // MIs[0] policy
     /* 1056122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056132 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056151 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056154 */     // GIR_Coverage, 20972,
     /* 1056154 */     GIR_EraseRootFromParent_Done,
     /* 1056155 */   // Label 15622: @1056155
     /* 1056155 */   GIM_Try, /*On fail goto*//*Label 15623*/ GIMT_Encode4(1056232), // Rule ID 20973 //
     /* 1056160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1056171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1056174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1056177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056199 */     // MIs[0] policy
     /* 1056199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056209 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056218 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056228 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056231 */     // GIR_Coverage, 20973,
     /* 1056231 */     GIR_EraseRootFromParent_Done,
     /* 1056232 */   // Label 15623: @1056232
     /* 1056232 */   GIM_Try, /*On fail goto*//*Label 15624*/ GIMT_Encode4(1056309), // Rule ID 20976 //
     /* 1056237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1056248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1056251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1056254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1056257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056276 */     // MIs[0] policy
     /* 1056276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056305 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056308 */     // GIR_Coverage, 20976,
     /* 1056308 */     GIR_EraseRootFromParent_Done,
     /* 1056309 */   // Label 15624: @1056309
     /* 1056309 */   GIM_Try, /*On fail goto*//*Label 15625*/ GIMT_Encode4(1056386), // Rule ID 20977 //
     /* 1056314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1056325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1056328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1056331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1056334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056353 */     // MIs[0] policy
     /* 1056353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056363 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056372 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056385 */     // GIR_Coverage, 20977,
     /* 1056385 */     GIR_EraseRootFromParent_Done,
     /* 1056386 */   // Label 15625: @1056386
     /* 1056386 */   GIM_Try, /*On fail goto*//*Label 15626*/ GIMT_Encode4(1056463), // Rule ID 20980 //
     /* 1056391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1056402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1056405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1056408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056430 */     // MIs[0] policy
     /* 1056430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056462 */     // GIR_Coverage, 20980,
     /* 1056462 */     GIR_EraseRootFromParent_Done,
     /* 1056463 */   // Label 15626: @1056463
     /* 1056463 */   GIM_Try, /*On fail goto*//*Label 15627*/ GIMT_Encode4(1056540), // Rule ID 20981 //
     /* 1056468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1056479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1056482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1056485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056507 */     // MIs[0] policy
     /* 1056507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056517 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056526 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056539 */     // GIR_Coverage, 20981,
     /* 1056539 */     GIR_EraseRootFromParent_Done,
     /* 1056540 */   // Label 15627: @1056540
     /* 1056540 */   GIM_Try, /*On fail goto*//*Label 15628*/ GIMT_Encode4(1056617), // Rule ID 20984 //
     /* 1056545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1056556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1056559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1056562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056584 */     // MIs[0] policy
     /* 1056584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056594 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056613 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056616 */     // GIR_Coverage, 20984,
     /* 1056616 */     GIR_EraseRootFromParent_Done,
     /* 1056617 */   // Label 15628: @1056617
     /* 1056617 */   GIM_Try, /*On fail goto*//*Label 15629*/ GIMT_Encode4(1056694), // Rule ID 20985 //
     /* 1056622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1056633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1056636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1056639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056661 */     // MIs[0] policy
     /* 1056661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056671 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056680 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056693 */     // GIR_Coverage, 20985,
     /* 1056693 */     GIR_EraseRootFromParent_Done,
     /* 1056694 */   // Label 15629: @1056694
     /* 1056694 */   GIM_Try, /*On fail goto*//*Label 15630*/ GIMT_Encode4(1056771), // Rule ID 20988 //
     /* 1056699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1056710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1056713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1056716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056738 */     // MIs[0] policy
     /* 1056738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056748 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056767 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056770 */     // GIR_Coverage, 20988,
     /* 1056770 */     GIR_EraseRootFromParent_Done,
     /* 1056771 */   // Label 15630: @1056771
     /* 1056771 */   GIM_Try, /*On fail goto*//*Label 15631*/ GIMT_Encode4(1056848), // Rule ID 20989 //
     /* 1056776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1056787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1056790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1056793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056815 */     // MIs[0] policy
     /* 1056815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056825 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056834 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056847 */     // GIR_Coverage, 20989,
     /* 1056847 */     GIR_EraseRootFromParent_Done,
     /* 1056848 */   // Label 15631: @1056848
     /* 1056848 */   GIM_Try, /*On fail goto*//*Label 15632*/ GIMT_Encode4(1056925), // Rule ID 20992 //
     /* 1056853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1056856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1056864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1056867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1056870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056892 */     // MIs[0] policy
     /* 1056892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056902 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056924 */     // GIR_Coverage, 20992,
     /* 1056924 */     GIR_EraseRootFromParent_Done,
     /* 1056925 */   // Label 15632: @1056925
     /* 1056925 */   GIM_Try, /*On fail goto*//*Label 15633*/ GIMT_Encode4(1057002), // Rule ID 20993 //
     /* 1056930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1056933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1056941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1056944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1056947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056969 */     // MIs[0] policy
     /* 1056969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056979 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057001 */     // GIR_Coverage, 20993,
     /* 1057001 */     GIR_EraseRootFromParent_Done,
     /* 1057002 */   // Label 15633: @1057002
     /* 1057002 */   GIM_Try, /*On fail goto*//*Label 15634*/ GIMT_Encode4(1057079), // Rule ID 20996 //
     /* 1057007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1057010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1057015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1057018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1057021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1057024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057046 */     // MIs[0] policy
     /* 1057046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057056 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1057059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057078 */     // GIR_Coverage, 20996,
     /* 1057078 */     GIR_EraseRootFromParent_Done,
     /* 1057079 */   // Label 15634: @1057079
     /* 1057079 */   GIM_Try, /*On fail goto*//*Label 15635*/ GIMT_Encode4(1057156), // Rule ID 20997 //
     /* 1057084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1057087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1057092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1057095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1057098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1057101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057123 */     // MIs[0] policy
     /* 1057123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057133 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1057136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057142 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057155 */     // GIR_Coverage, 20997,
     /* 1057155 */     GIR_EraseRootFromParent_Done,
     /* 1057156 */   // Label 15635: @1057156
     /* 1057156 */   GIM_Try, /*On fail goto*//*Label 15636*/ GIMT_Encode4(1057233), // Rule ID 21000 //
     /* 1057161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1057164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1057169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1057172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1057175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1057178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057200 */     // MIs[0] policy
     /* 1057200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057210 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1057213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057229 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057232 */     // GIR_Coverage, 21000,
     /* 1057232 */     GIR_EraseRootFromParent_Done,
     /* 1057233 */   // Label 15636: @1057233
     /* 1057233 */   GIM_Try, /*On fail goto*//*Label 15637*/ GIMT_Encode4(1057310), // Rule ID 21001 //
     /* 1057238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1057241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1057246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1057249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1057252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1057255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057277 */     // MIs[0] policy
     /* 1057277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057287 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1057290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057296 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057306 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057309 */     // GIR_Coverage, 21001,
     /* 1057309 */     GIR_EraseRootFromParent_Done,
     /* 1057310 */   // Label 15637: @1057310
     /* 1057310 */   GIM_Try, /*On fail goto*//*Label 15638*/ GIMT_Encode4(1057387), // Rule ID 21268 //
     /* 1057315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1057326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1057329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1057332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1057335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057354 */     // MIs[0] policy
     /* 1057354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057364 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1057367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057383 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057386 */     // GIR_Coverage, 21268,
     /* 1057386 */     GIR_EraseRootFromParent_Done,
     /* 1057387 */   // Label 15638: @1057387
     /* 1057387 */   GIM_Try, /*On fail goto*//*Label 15639*/ GIMT_Encode4(1057464), // Rule ID 21269 //
     /* 1057392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1057403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1057406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1057409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1057412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057431 */     // MIs[0] policy
     /* 1057431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057441 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1057444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057450 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057460 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057463 */     // GIR_Coverage, 21269,
     /* 1057463 */     GIR_EraseRootFromParent_Done,
     /* 1057464 */   // Label 15639: @1057464
     /* 1057464 */   GIM_Try, /*On fail goto*//*Label 15640*/ GIMT_Encode4(1057541), // Rule ID 21272 //
     /* 1057469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1057480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1057483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1057486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057508 */     // MIs[0] policy
     /* 1057508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057518 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057537 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057540 */     // GIR_Coverage, 21272,
     /* 1057540 */     GIR_EraseRootFromParent_Done,
     /* 1057541 */   // Label 15640: @1057541
     /* 1057541 */   GIM_Try, /*On fail goto*//*Label 15641*/ GIMT_Encode4(1057618), // Rule ID 21273 //
     /* 1057546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1057557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1057560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1057563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057585 */     // MIs[0] policy
     /* 1057585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057595 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057604 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057617 */     // GIR_Coverage, 21273,
     /* 1057617 */     GIR_EraseRootFromParent_Done,
     /* 1057618 */   // Label 15641: @1057618
     /* 1057618 */   GIM_Try, /*On fail goto*//*Label 15642*/ GIMT_Encode4(1057695), // Rule ID 21276 //
     /* 1057623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1057640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057662 */     // MIs[0] policy
     /* 1057662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057694 */     // GIR_Coverage, 21276,
     /* 1057694 */     GIR_EraseRootFromParent_Done,
     /* 1057695 */   // Label 15642: @1057695
     /* 1057695 */   GIM_Try, /*On fail goto*//*Label 15643*/ GIMT_Encode4(1057772), // Rule ID 21277 //
     /* 1057700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1057717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057739 */     // MIs[0] policy
     /* 1057739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057758 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057771 */     // GIR_Coverage, 21277,
     /* 1057771 */     GIR_EraseRootFromParent_Done,
     /* 1057772 */   // Label 15643: @1057772
     /* 1057772 */   GIM_Try, /*On fail goto*//*Label 15644*/ GIMT_Encode4(1057849), // Rule ID 21280 //
     /* 1057777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1057794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057816 */     // MIs[0] policy
     /* 1057816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057826 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057845 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057848 */     // GIR_Coverage, 21280,
     /* 1057848 */     GIR_EraseRootFromParent_Done,
     /* 1057849 */   // Label 15644: @1057849
     /* 1057849 */   GIM_Try, /*On fail goto*//*Label 15645*/ GIMT_Encode4(1057926), // Rule ID 21281 //
     /* 1057854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1057871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057893 */     // MIs[0] policy
     /* 1057893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057903 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057912 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057922 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057925 */     // GIR_Coverage, 21281,
     /* 1057925 */     GIR_EraseRootFromParent_Done,
     /* 1057926 */   // Label 15645: @1057926
     /* 1057926 */   GIM_Try, /*On fail goto*//*Label 15646*/ GIMT_Encode4(1058003), // Rule ID 21284 //
     /* 1057931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1057948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057970 */     // MIs[0] policy
     /* 1057970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057980 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058002 */     // GIR_Coverage, 21284,
     /* 1058002 */     GIR_EraseRootFromParent_Done,
     /* 1058003 */   // Label 15646: @1058003
     /* 1058003 */   GIM_Try, /*On fail goto*//*Label 15647*/ GIMT_Encode4(1058080), // Rule ID 21285 //
     /* 1058008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1058019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1058022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1058025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1058028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058047 */     // MIs[0] policy
     /* 1058047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058057 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058066 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058079 */     // GIR_Coverage, 21285,
     /* 1058079 */     GIR_EraseRootFromParent_Done,
     /* 1058080 */   // Label 15647: @1058080
     /* 1058080 */   GIM_Try, /*On fail goto*//*Label 15648*/ GIMT_Encode4(1058157), // Rule ID 21288 //
     /* 1058085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1058096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1058099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1058102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058124 */     // MIs[0] policy
     /* 1058124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058134 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1058137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058156 */     // GIR_Coverage, 21288,
     /* 1058156 */     GIR_EraseRootFromParent_Done,
     /* 1058157 */   // Label 15648: @1058157
     /* 1058157 */   GIM_Try, /*On fail goto*//*Label 15649*/ GIMT_Encode4(1058234), // Rule ID 21289 //
     /* 1058162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1058173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1058176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1058179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058201 */     // MIs[0] policy
     /* 1058201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058211 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1058214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058233 */     // GIR_Coverage, 21289,
     /* 1058233 */     GIR_EraseRootFromParent_Done,
     /* 1058234 */   // Label 15649: @1058234
     /* 1058234 */   GIM_Try, /*On fail goto*//*Label 15650*/ GIMT_Encode4(1058311), // Rule ID 21292 //
     /* 1058239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1058250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1058253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1058256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058278 */     // MIs[0] policy
     /* 1058278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058288 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1058291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058307 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058310 */     // GIR_Coverage, 21292,
     /* 1058310 */     GIR_EraseRootFromParent_Done,
     /* 1058311 */   // Label 15650: @1058311
     /* 1058311 */   GIM_Try, /*On fail goto*//*Label 15651*/ GIMT_Encode4(1058388), // Rule ID 21293 //
     /* 1058316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1058327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1058330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1058333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058355 */     // MIs[0] policy
     /* 1058355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058365 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1058368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058374 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058387 */     // GIR_Coverage, 21293,
     /* 1058387 */     GIR_EraseRootFromParent_Done,
     /* 1058388 */   // Label 15651: @1058388
     /* 1058388 */   GIM_Try, /*On fail goto*//*Label 15652*/ GIMT_Encode4(1058465), // Rule ID 21296 //
     /* 1058393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1058404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1058410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058432 */     // MIs[0] policy
     /* 1058432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058442 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1058445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058464 */     // GIR_Coverage, 21296,
     /* 1058464 */     GIR_EraseRootFromParent_Done,
     /* 1058465 */   // Label 15652: @1058465
     /* 1058465 */   GIM_Try, /*On fail goto*//*Label 15653*/ GIMT_Encode4(1058542), // Rule ID 21297 //
     /* 1058470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1058481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1058487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058509 */     // MIs[0] policy
     /* 1058509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058519 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1058522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058541 */     // GIR_Coverage, 21297,
     /* 1058541 */     GIR_EraseRootFromParent_Done,
     /* 1058542 */   // Label 15653: @1058542
     /* 1058542 */   GIM_Try, /*On fail goto*//*Label 15654*/ GIMT_Encode4(1058619), // Rule ID 21300 //
     /* 1058547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1058564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058586 */     // MIs[0] policy
     /* 1058586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058596 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058618 */     // GIR_Coverage, 21300,
     /* 1058618 */     GIR_EraseRootFromParent_Done,
     /* 1058619 */   // Label 15654: @1058619
     /* 1058619 */   GIM_Try, /*On fail goto*//*Label 15655*/ GIMT_Encode4(1058696), // Rule ID 21301 //
     /* 1058624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1058641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058663 */     // MIs[0] policy
     /* 1058663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058673 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058695 */     // GIR_Coverage, 21301,
     /* 1058695 */     GIR_EraseRootFromParent_Done,
     /* 1058696 */   // Label 15655: @1058696
     /* 1058696 */   GIM_Try, /*On fail goto*//*Label 15656*/ GIMT_Encode4(1058773), // Rule ID 21304 //
     /* 1058701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1058712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1058715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058740 */     // MIs[0] policy
     /* 1058740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058750 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1058753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058772 */     // GIR_Coverage, 21304,
     /* 1058772 */     GIR_EraseRootFromParent_Done,
     /* 1058773 */   // Label 15656: @1058773
     /* 1058773 */   GIM_Try, /*On fail goto*//*Label 15657*/ GIMT_Encode4(1058850), // Rule ID 21305 //
     /* 1058778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1058789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1058792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058817 */     // MIs[0] policy
     /* 1058817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058827 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1058830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058849 */     // GIR_Coverage, 21305,
     /* 1058849 */     GIR_EraseRootFromParent_Done,
     /* 1058850 */   // Label 15657: @1058850
     /* 1058850 */   GIM_Try, /*On fail goto*//*Label 15658*/ GIMT_Encode4(1058927), // Rule ID 21308 //
     /* 1058855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1058866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1058869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058894 */     // MIs[0] policy
     /* 1058894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058926 */     // GIR_Coverage, 21308,
     /* 1058926 */     GIR_EraseRootFromParent_Done,
     /* 1058927 */   // Label 15658: @1058927
     /* 1058927 */   GIM_Try, /*On fail goto*//*Label 15659*/ GIMT_Encode4(1059004), // Rule ID 21309 //
     /* 1058932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1058943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1058946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058971 */     // MIs[0] policy
     /* 1058971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058981 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059003 */     // GIR_Coverage, 21309,
     /* 1059003 */     GIR_EraseRootFromParent_Done,
     /* 1059004 */   // Label 15659: @1059004
     /* 1059004 */   GIM_Try, /*On fail goto*//*Label 15660*/ GIMT_Encode4(1059081), // Rule ID 21312 //
     /* 1059009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1059020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1059023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1059026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059048 */     // MIs[0] policy
     /* 1059048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1059061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059080 */     // GIR_Coverage, 21312,
     /* 1059080 */     GIR_EraseRootFromParent_Done,
     /* 1059081 */   // Label 15660: @1059081
     /* 1059081 */   GIM_Try, /*On fail goto*//*Label 15661*/ GIMT_Encode4(1059158), // Rule ID 21313 //
     /* 1059086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1059097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1059100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1059103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059125 */     // MIs[0] policy
     /* 1059125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1059138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059144 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059157 */     // GIR_Coverage, 21313,
     /* 1059157 */     GIR_EraseRootFromParent_Done,
     /* 1059158 */   // Label 15661: @1059158
     /* 1059158 */   GIM_Try, /*On fail goto*//*Label 15662*/ GIMT_Encode4(1059235), // Rule ID 21316 //
     /* 1059163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1059174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1059177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1059180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059202 */     // MIs[0] policy
     /* 1059202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059212 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1059215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059234 */     // GIR_Coverage, 21316,
     /* 1059234 */     GIR_EraseRootFromParent_Done,
     /* 1059235 */   // Label 15662: @1059235
     /* 1059235 */   GIM_Try, /*On fail goto*//*Label 15663*/ GIMT_Encode4(1059312), // Rule ID 21317 //
     /* 1059240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1059251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1059254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1059257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059279 */     // MIs[0] policy
     /* 1059279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059289 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1059292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059298 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059311 */     // GIR_Coverage, 21317,
     /* 1059311 */     GIR_EraseRootFromParent_Done,
     /* 1059312 */   // Label 15663: @1059312
     /* 1059312 */   GIM_Try, /*On fail goto*//*Label 15664*/ GIMT_Encode4(1059389), // Rule ID 21320 //
     /* 1059317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1059328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1059331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1059334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1059337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059356 */     // MIs[0] policy
     /* 1059356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059366 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1059369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059388 */     // GIR_Coverage, 21320,
     /* 1059388 */     GIR_EraseRootFromParent_Done,
     /* 1059389 */   // Label 15664: @1059389
     /* 1059389 */   GIM_Try, /*On fail goto*//*Label 15665*/ GIMT_Encode4(1059466), // Rule ID 21321 //
     /* 1059394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1059405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1059408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1059411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1059414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059433 */     // MIs[0] policy
     /* 1059433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059443 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1059446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059465 */     // GIR_Coverage, 21321,
     /* 1059465 */     GIR_EraseRootFromParent_Done,
     /* 1059466 */   // Label 15665: @1059466
     /* 1059466 */   GIM_Try, /*On fail goto*//*Label 15666*/ GIMT_Encode4(1059543), // Rule ID 21324 //
     /* 1059471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1059482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1059485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1059488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059510 */     // MIs[0] policy
     /* 1059510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059520 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1059523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059542 */     // GIR_Coverage, 21324,
     /* 1059542 */     GIR_EraseRootFromParent_Done,
     /* 1059543 */   // Label 15666: @1059543
     /* 1059543 */   GIM_Try, /*On fail goto*//*Label 15667*/ GIMT_Encode4(1059620), // Rule ID 21325 //
     /* 1059548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1059559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1059562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1059565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059587 */     // MIs[0] policy
     /* 1059587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059597 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1059600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059606 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059619 */     // GIR_Coverage, 21325,
     /* 1059619 */     GIR_EraseRootFromParent_Done,
     /* 1059620 */   // Label 15667: @1059620
     /* 1059620 */   GIM_Try, /*On fail goto*//*Label 15668*/ GIMT_Encode4(1059697), // Rule ID 21328 //
     /* 1059625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1059636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1059639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059664 */     // MIs[0] policy
     /* 1059664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059674 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1059677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059696 */     // GIR_Coverage, 21328,
     /* 1059696 */     GIR_EraseRootFromParent_Done,
     /* 1059697 */   // Label 15668: @1059697
     /* 1059697 */   GIM_Try, /*On fail goto*//*Label 15669*/ GIMT_Encode4(1059774), // Rule ID 21329 //
     /* 1059702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1059713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1059716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059741 */     // MIs[0] policy
     /* 1059741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059751 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1059754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059760 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059773 */     // GIR_Coverage, 21329,
     /* 1059773 */     GIR_EraseRootFromParent_Done,
     /* 1059774 */   // Label 15669: @1059774
     /* 1059774 */   GIM_Try, /*On fail goto*//*Label 15670*/ GIMT_Encode4(1059851), // Rule ID 21332 //
     /* 1059779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1059790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1059793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1059796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059818 */     // MIs[0] policy
     /* 1059818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059828 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1059831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059847 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059850 */     // GIR_Coverage, 21332,
     /* 1059850 */     GIR_EraseRootFromParent_Done,
     /* 1059851 */   // Label 15670: @1059851
     /* 1059851 */   GIM_Try, /*On fail goto*//*Label 15671*/ GIMT_Encode4(1059928), // Rule ID 21333 //
     /* 1059856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1059867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1059870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1059873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059895 */     // MIs[0] policy
     /* 1059895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059905 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1059908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059914 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059927 */     // GIR_Coverage, 21333,
     /* 1059927 */     GIR_EraseRootFromParent_Done,
     /* 1059928 */   // Label 15671: @1059928
     /* 1059928 */   GIM_Try, /*On fail goto*//*Label 15672*/ GIMT_Encode4(1060005), // Rule ID 21336 //
     /* 1059933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1059944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1059947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1059950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059972 */     // MIs[0] policy
     /* 1059972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059982 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1059985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060004 */     // GIR_Coverage, 21336,
     /* 1060004 */     GIR_EraseRootFromParent_Done,
     /* 1060005 */   // Label 15672: @1060005
     /* 1060005 */   GIM_Try, /*On fail goto*//*Label 15673*/ GIMT_Encode4(1060082), // Rule ID 21337 //
     /* 1060010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1060013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1060018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1060021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1060024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1060027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060049 */     // MIs[0] policy
     /* 1060049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060059 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1060062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060081 */     // GIR_Coverage, 21337,
     /* 1060081 */     GIR_EraseRootFromParent_Done,
     /* 1060082 */   // Label 15673: @1060082
     /* 1060082 */   GIM_Try, /*On fail goto*//*Label 15674*/ GIMT_Encode4(1060159), // Rule ID 21340 //
     /* 1060087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1060098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1060101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1060104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060126 */     // MIs[0] policy
     /* 1060126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060136 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1060139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060158 */     // GIR_Coverage, 21340,
     /* 1060158 */     GIR_EraseRootFromParent_Done,
     /* 1060159 */   // Label 15674: @1060159
     /* 1060159 */   GIM_Try, /*On fail goto*//*Label 15675*/ GIMT_Encode4(1060236), // Rule ID 21341 //
     /* 1060164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1060175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1060178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1060181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060203 */     // MIs[0] policy
     /* 1060203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060213 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1060216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060235 */     // GIR_Coverage, 21341,
     /* 1060235 */     GIR_EraseRootFromParent_Done,
     /* 1060236 */   // Label 15675: @1060236
     /* 1060236 */   GIM_Try, /*On fail goto*//*Label 15676*/ GIMT_Encode4(1060313), // Rule ID 21344 //
     /* 1060241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1060252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1060255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1060258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060280 */     // MIs[0] policy
     /* 1060280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060290 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1060293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060312 */     // GIR_Coverage, 21344,
     /* 1060312 */     GIR_EraseRootFromParent_Done,
     /* 1060313 */   // Label 15676: @1060313
     /* 1060313 */   GIM_Try, /*On fail goto*//*Label 15677*/ GIMT_Encode4(1060390), // Rule ID 21345 //
     /* 1060318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1060329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1060332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1060335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060357 */     // MIs[0] policy
     /* 1060357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060367 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1060370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060376 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060389 */     // GIR_Coverage, 21345,
     /* 1060389 */     GIR_EraseRootFromParent_Done,
     /* 1060390 */   // Label 15677: @1060390
     /* 1060390 */   GIM_Try, /*On fail goto*//*Label 15678*/ GIMT_Encode4(1060467), // Rule ID 21348 //
     /* 1060395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1060406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1060409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1060412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060434 */     // MIs[0] policy
     /* 1060434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060444 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1060447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060466 */     // GIR_Coverage, 21348,
     /* 1060466 */     GIR_EraseRootFromParent_Done,
     /* 1060467 */   // Label 15678: @1060467
     /* 1060467 */   GIM_Try, /*On fail goto*//*Label 15679*/ GIMT_Encode4(1060544), // Rule ID 21349 //
     /* 1060472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1060483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1060486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1060489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060511 */     // MIs[0] policy
     /* 1060511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060521 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1060524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060543 */     // GIR_Coverage, 21349,
     /* 1060543 */     GIR_EraseRootFromParent_Done,
     /* 1060544 */   // Label 15679: @1060544
     /* 1060544 */   GIM_Try, /*On fail goto*//*Label 15680*/ GIMT_Encode4(1060621), // Rule ID 21352 //
     /* 1060549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1060560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1060563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1060566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060588 */     // MIs[0] policy
     /* 1060588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060598 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1060601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060620 */     // GIR_Coverage, 21352,
     /* 1060620 */     GIR_EraseRootFromParent_Done,
     /* 1060621 */   // Label 15680: @1060621
     /* 1060621 */   GIM_Try, /*On fail goto*//*Label 15681*/ GIMT_Encode4(1060698), // Rule ID 21353 //
     /* 1060626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1060637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1060640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1060643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060665 */     // MIs[0] policy
     /* 1060665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060675 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1060678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060697 */     // GIR_Coverage, 21353,
     /* 1060697 */     GIR_EraseRootFromParent_Done,
     /* 1060698 */   // Label 15681: @1060698
     /* 1060698 */   GIM_Try, /*On fail goto*//*Label 15682*/ GIMT_Encode4(1060775), // Rule ID 21356 //
     /* 1060703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1060714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1060717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1060720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060742 */     // MIs[0] policy
     /* 1060742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060752 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1060755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060774 */     // GIR_Coverage, 21356,
     /* 1060774 */     GIR_EraseRootFromParent_Done,
     /* 1060775 */   // Label 15682: @1060775
     /* 1060775 */   GIM_Try, /*On fail goto*//*Label 15683*/ GIMT_Encode4(1060852), // Rule ID 21357 //
     /* 1060780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1060791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1060794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1060797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060819 */     // MIs[0] policy
     /* 1060819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060829 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1060832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060838 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060851 */     // GIR_Coverage, 21357,
     /* 1060851 */     GIR_EraseRootFromParent_Done,
     /* 1060852 */   // Label 15683: @1060852
     /* 1060852 */   GIM_Try, /*On fail goto*//*Label 15684*/ GIMT_Encode4(1060929), // Rule ID 21360 //
     /* 1060857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1060868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1060871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1060874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1060877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060896 */     // MIs[0] policy
     /* 1060896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060906 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1060909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060928 */     // GIR_Coverage, 21360,
     /* 1060928 */     GIR_EraseRootFromParent_Done,
     /* 1060929 */   // Label 15684: @1060929
     /* 1060929 */   GIM_Try, /*On fail goto*//*Label 15685*/ GIMT_Encode4(1061006), // Rule ID 21361 //
     /* 1060934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1060945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1060948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1060951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1060954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060973 */     // MIs[0] policy
     /* 1060973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060983 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1060986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061005 */     // GIR_Coverage, 21361,
     /* 1061005 */     GIR_EraseRootFromParent_Done,
     /* 1061006 */   // Label 15685: @1061006
     /* 1061006 */   GIM_Try, /*On fail goto*//*Label 15686*/ GIMT_Encode4(1061083), // Rule ID 21364 //
     /* 1061011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1061022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1061025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1061028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061050 */     // MIs[0] policy
     /* 1061050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061060 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1061063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061082 */     // GIR_Coverage, 21364,
     /* 1061082 */     GIR_EraseRootFromParent_Done,
     /* 1061083 */   // Label 15686: @1061083
     /* 1061083 */   GIM_Try, /*On fail goto*//*Label 15687*/ GIMT_Encode4(1061160), // Rule ID 21365 //
     /* 1061088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1061099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1061102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1061105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061127 */     // MIs[0] policy
     /* 1061127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061137 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1061140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061146 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061159 */     // GIR_Coverage, 21365,
     /* 1061159 */     GIR_EraseRootFromParent_Done,
     /* 1061160 */   // Label 15687: @1061160
     /* 1061160 */   GIM_Try, /*On fail goto*//*Label 15688*/ GIMT_Encode4(1061237), // Rule ID 21368 //
     /* 1061165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1061176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1061179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1061182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061204 */     // MIs[0] policy
     /* 1061204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061214 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1061217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061236 */     // GIR_Coverage, 21368,
     /* 1061236 */     GIR_EraseRootFromParent_Done,
     /* 1061237 */   // Label 15688: @1061237
     /* 1061237 */   GIM_Try, /*On fail goto*//*Label 15689*/ GIMT_Encode4(1061314), // Rule ID 21369 //
     /* 1061242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1061253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1061256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1061259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061281 */     // MIs[0] policy
     /* 1061281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061291 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1061294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061313 */     // GIR_Coverage, 21369,
     /* 1061313 */     GIR_EraseRootFromParent_Done,
     /* 1061314 */   // Label 15689: @1061314
     /* 1061314 */   GIM_Try, /*On fail goto*//*Label 15690*/ GIMT_Encode4(1061391), // Rule ID 21372 //
     /* 1061319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1061330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1061333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1061336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061358 */     // MIs[0] policy
     /* 1061358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061368 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1061371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061390 */     // GIR_Coverage, 21372,
     /* 1061390 */     GIR_EraseRootFromParent_Done,
     /* 1061391 */   // Label 15690: @1061391
     /* 1061391 */   GIM_Try, /*On fail goto*//*Label 15691*/ GIMT_Encode4(1061468), // Rule ID 21373 //
     /* 1061396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1061407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1061410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1061413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061435 */     // MIs[0] policy
     /* 1061435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061445 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1061448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061454 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061467 */     // GIR_Coverage, 21373,
     /* 1061467 */     GIR_EraseRootFromParent_Done,
     /* 1061468 */   // Label 15691: @1061468
     /* 1061468 */   GIM_Try, /*On fail goto*//*Label 15692*/ GIMT_Encode4(1061545), // Rule ID 21376 //
     /* 1061473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1061484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1061487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1061490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061512 */     // MIs[0] policy
     /* 1061512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061522 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1061525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061544 */     // GIR_Coverage, 21376,
     /* 1061544 */     GIR_EraseRootFromParent_Done,
     /* 1061545 */   // Label 15692: @1061545
     /* 1061545 */   GIM_Try, /*On fail goto*//*Label 15693*/ GIMT_Encode4(1061622), // Rule ID 21377 //
     /* 1061550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1061561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1061564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1061567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061589 */     // MIs[0] policy
     /* 1061589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061599 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1061602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061608 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061621 */     // GIR_Coverage, 21377,
     /* 1061621 */     GIR_EraseRootFromParent_Done,
     /* 1061622 */   // Label 15693: @1061622
     /* 1061622 */   GIM_Try, /*On fail goto*//*Label 15694*/ GIMT_Encode4(1061699), // Rule ID 21380 //
     /* 1061627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1061644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1061647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061666 */     // MIs[0] policy
     /* 1061666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061676 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1061679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061698 */     // GIR_Coverage, 21380,
     /* 1061698 */     GIR_EraseRootFromParent_Done,
     /* 1061699 */   // Label 15694: @1061699
     /* 1061699 */   GIM_Try, /*On fail goto*//*Label 15695*/ GIMT_Encode4(1061776), // Rule ID 21381 //
     /* 1061704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1061721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1061724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061743 */     // MIs[0] policy
     /* 1061743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061753 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1061756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061762 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061775 */     // GIR_Coverage, 21381,
     /* 1061775 */     GIR_EraseRootFromParent_Done,
     /* 1061776 */   // Label 15695: @1061776
     /* 1061776 */   GIM_Try, /*On fail goto*//*Label 15696*/ GIMT_Encode4(1061853), // Rule ID 21384 //
     /* 1061781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1061792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1061795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1061798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061820 */     // MIs[0] policy
     /* 1061820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061830 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1061833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061852 */     // GIR_Coverage, 21384,
     /* 1061852 */     GIR_EraseRootFromParent_Done,
     /* 1061853 */   // Label 15696: @1061853
     /* 1061853 */   GIM_Try, /*On fail goto*//*Label 15697*/ GIMT_Encode4(1061930), // Rule ID 21385 //
     /* 1061858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1061869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1061872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1061875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061897 */     // MIs[0] policy
     /* 1061897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061907 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1061910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061929 */     // GIR_Coverage, 21385,
     /* 1061929 */     GIR_EraseRootFromParent_Done,
     /* 1061930 */   // Label 15697: @1061930
     /* 1061930 */   GIM_Try, /*On fail goto*//*Label 15698*/ GIMT_Encode4(1062007), // Rule ID 21388 //
     /* 1061935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1061946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1061949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1061952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061974 */     // MIs[0] policy
     /* 1061974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061984 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1061987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062006 */     // GIR_Coverage, 21388,
     /* 1062006 */     GIR_EraseRootFromParent_Done,
     /* 1062007 */   // Label 15698: @1062007
     /* 1062007 */   GIM_Try, /*On fail goto*//*Label 15699*/ GIMT_Encode4(1062084), // Rule ID 21389 //
     /* 1062012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1062015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1062020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1062023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1062026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1062029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062051 */     // MIs[0] policy
     /* 1062051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062061 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1062064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062083 */     // GIR_Coverage, 21389,
     /* 1062083 */     GIR_EraseRootFromParent_Done,
     /* 1062084 */   // Label 15699: @1062084
     /* 1062084 */   GIM_Try, /*On fail goto*//*Label 15700*/ GIMT_Encode4(1062161), // Rule ID 21392 //
     /* 1062089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1062092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1062097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1062100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1062103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1062106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062128 */     // MIs[0] policy
     /* 1062128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062138 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1062141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062160 */     // GIR_Coverage, 21392,
     /* 1062160 */     GIR_EraseRootFromParent_Done,
     /* 1062161 */   // Label 15700: @1062161
     /* 1062161 */   GIM_Try, /*On fail goto*//*Label 15701*/ GIMT_Encode4(1062238), // Rule ID 21393 //
     /* 1062166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1062169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1062174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1062177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1062180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1062183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062205 */     // MIs[0] policy
     /* 1062205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062215 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1062218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062224 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062237 */     // GIR_Coverage, 21393,
     /* 1062237 */     GIR_EraseRootFromParent_Done,
     /* 1062238 */   // Label 15701: @1062238
     /* 1062238 */   GIM_Try, /*On fail goto*//*Label 15702*/ GIMT_Encode4(1062315), // Rule ID 21396 //
     /* 1062243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1062246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1062251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1062254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1062257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1062260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062282 */     // MIs[0] policy
     /* 1062282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062292 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1062295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062314 */     // GIR_Coverage, 21396,
     /* 1062314 */     GIR_EraseRootFromParent_Done,
     /* 1062315 */   // Label 15702: @1062315
     /* 1062315 */   GIM_Try, /*On fail goto*//*Label 15703*/ GIMT_Encode4(1062392), // Rule ID 21397 //
     /* 1062320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1062323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1062328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1062331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1062334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1062337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062359 */     // MIs[0] policy
     /* 1062359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062369 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1062372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062378 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062391 */     // GIR_Coverage, 21397,
     /* 1062391 */     GIR_EraseRootFromParent_Done,
     /* 1062392 */   // Label 15703: @1062392
     /* 1062392 */   GIM_Try, /*On fail goto*//*Label 15704*/ GIMT_Encode4(1062469), // Rule ID 21400 //
     /* 1062397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1062408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1062411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1062414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062436 */     // MIs[0] policy
     /* 1062436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062446 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1062449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062468 */     // GIR_Coverage, 21400,
     /* 1062468 */     GIR_EraseRootFromParent_Done,
     /* 1062469 */   // Label 15704: @1062469
     /* 1062469 */   GIM_Try, /*On fail goto*//*Label 15705*/ GIMT_Encode4(1062546), // Rule ID 21401 //
     /* 1062474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1062485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1062488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1062491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062513 */     // MIs[0] policy
     /* 1062513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062523 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1062526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062545 */     // GIR_Coverage, 21401,
     /* 1062545 */     GIR_EraseRootFromParent_Done,
     /* 1062546 */   // Label 15705: @1062546
     /* 1062546 */   GIM_Try, /*On fail goto*//*Label 15706*/ GIMT_Encode4(1062623), // Rule ID 21404 //
     /* 1062551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1062562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1062565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1062568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062590 */     // MIs[0] policy
     /* 1062590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062600 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1062603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062622 */     // GIR_Coverage, 21404,
     /* 1062622 */     GIR_EraseRootFromParent_Done,
     /* 1062623 */   // Label 15706: @1062623
     /* 1062623 */   GIM_Try, /*On fail goto*//*Label 15707*/ GIMT_Encode4(1062700), // Rule ID 21405 //
     /* 1062628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1062639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1062642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1062645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062667 */     // MIs[0] policy
     /* 1062667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062677 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1062680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062699 */     // GIR_Coverage, 21405,
     /* 1062699 */     GIR_EraseRootFromParent_Done,
     /* 1062700 */   // Label 15707: @1062700
     /* 1062700 */   GIM_Try, /*On fail goto*//*Label 15708*/ GIMT_Encode4(1062777), // Rule ID 21408 //
     /* 1062705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1062716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1062719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1062722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062744 */     // MIs[0] policy
     /* 1062744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062754 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1062757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062776 */     // GIR_Coverage, 21408,
     /* 1062776 */     GIR_EraseRootFromParent_Done,
     /* 1062777 */   // Label 15708: @1062777
     /* 1062777 */   GIM_Try, /*On fail goto*//*Label 15709*/ GIMT_Encode4(1062854), // Rule ID 21409 //
     /* 1062782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1062793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1062796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1062799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062821 */     // MIs[0] policy
     /* 1062821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062831 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1062834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062840 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062853 */     // GIR_Coverage, 21409,
     /* 1062853 */     GIR_EraseRootFromParent_Done,
     /* 1062854 */   // Label 15709: @1062854
     /* 1062854 */   GIM_Try, /*On fail goto*//*Label 15710*/ GIMT_Encode4(1062931), // Rule ID 21412 //
     /* 1062859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1062870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1062873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1062876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062898 */     // MIs[0] policy
     /* 1062898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062908 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1062911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062930 */     // GIR_Coverage, 21412,
     /* 1062930 */     GIR_EraseRootFromParent_Done,
     /* 1062931 */   // Label 15710: @1062931
     /* 1062931 */   GIM_Try, /*On fail goto*//*Label 15711*/ GIMT_Encode4(1063008), // Rule ID 21413 //
     /* 1062936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1062947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1062950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1062953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062975 */     // MIs[0] policy
     /* 1062975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062985 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1062988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062994 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063007 */     // GIR_Coverage, 21413,
     /* 1063007 */     GIR_EraseRootFromParent_Done,
     /* 1063008 */   // Label 15711: @1063008
     /* 1063008 */   GIM_Try, /*On fail goto*//*Label 15712*/ GIMT_Encode4(1063085), // Rule ID 21416 //
     /* 1063013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1063016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1063024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1063027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1063030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1063033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063052 */     // MIs[0] policy
     /* 1063052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063062 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1063065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063084 */     // GIR_Coverage, 21416,
     /* 1063084 */     GIR_EraseRootFromParent_Done,
     /* 1063085 */   // Label 15712: @1063085
     /* 1063085 */   GIM_Try, /*On fail goto*//*Label 15713*/ GIMT_Encode4(1063162), // Rule ID 21417 //
     /* 1063090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1063093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1063101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1063104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1063107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1063110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063129 */     // MIs[0] policy
     /* 1063129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063139 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1063142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063148 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063161 */     // GIR_Coverage, 21417,
     /* 1063161 */     GIR_EraseRootFromParent_Done,
     /* 1063162 */   // Label 15713: @1063162
     /* 1063162 */   GIM_Try, /*On fail goto*//*Label 15714*/ GIMT_Encode4(1063239), // Rule ID 21420 //
     /* 1063167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1063170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1063178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1063181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1063184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1063187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063206 */     // MIs[0] policy
     /* 1063206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063216 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1063219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063238 */     // GIR_Coverage, 21420,
     /* 1063238 */     GIR_EraseRootFromParent_Done,
     /* 1063239 */   // Label 15714: @1063239
     /* 1063239 */   GIM_Try, /*On fail goto*//*Label 15715*/ GIMT_Encode4(1063316), // Rule ID 21421 //
     /* 1063244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1063247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1063255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1063258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1063261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1063264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063283 */     // MIs[0] policy
     /* 1063283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063293 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1063296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063302 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063315 */     // GIR_Coverage, 21421,
     /* 1063315 */     GIR_EraseRootFromParent_Done,
     /* 1063316 */   // Label 15715: @1063316
     /* 1063316 */   GIM_Try, /*On fail goto*//*Label 15716*/ GIMT_Encode4(1063393), // Rule ID 21424 //
     /* 1063321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1063332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1063335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1063338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063360 */     // MIs[0] policy
     /* 1063360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063370 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1063373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063392 */     // GIR_Coverage, 21424,
     /* 1063392 */     GIR_EraseRootFromParent_Done,
     /* 1063393 */   // Label 15716: @1063393
     /* 1063393 */   GIM_Try, /*On fail goto*//*Label 15717*/ GIMT_Encode4(1063470), // Rule ID 21425 //
     /* 1063398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1063409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1063412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1063415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063437 */     // MIs[0] policy
     /* 1063437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063447 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1063450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063456 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063469 */     // GIR_Coverage, 21425,
     /* 1063469 */     GIR_EraseRootFromParent_Done,
     /* 1063470 */   // Label 15717: @1063470
     /* 1063470 */   GIM_Try, /*On fail goto*//*Label 15718*/ GIMT_Encode4(1063547), // Rule ID 21428 //
     /* 1063475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1063486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1063489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1063492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063514 */     // MIs[0] policy
     /* 1063514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1063527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063546 */     // GIR_Coverage, 21428,
     /* 1063546 */     GIR_EraseRootFromParent_Done,
     /* 1063547 */   // Label 15718: @1063547
     /* 1063547 */   GIM_Try, /*On fail goto*//*Label 15719*/ GIMT_Encode4(1063624), // Rule ID 21429 //
     /* 1063552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1063563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1063566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1063569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063591 */     // MIs[0] policy
     /* 1063591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063601 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1063604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063610 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063623 */     // GIR_Coverage, 21429,
     /* 1063623 */     GIR_EraseRootFromParent_Done,
     /* 1063624 */   // Label 15719: @1063624
     /* 1063624 */   GIM_Try, /*On fail goto*//*Label 15720*/ GIMT_Encode4(1063701), // Rule ID 21432 //
     /* 1063629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1063640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1063643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1063646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063668 */     // MIs[0] policy
     /* 1063668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063678 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1063681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063700 */     // GIR_Coverage, 21432,
     /* 1063700 */     GIR_EraseRootFromParent_Done,
     /* 1063701 */   // Label 15720: @1063701
     /* 1063701 */   GIM_Try, /*On fail goto*//*Label 15721*/ GIMT_Encode4(1063778), // Rule ID 21433 //
     /* 1063706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1063717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1063720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1063723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063745 */     // MIs[0] policy
     /* 1063745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063755 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1063758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063764 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063777 */     // GIR_Coverage, 21433,
     /* 1063777 */     GIR_EraseRootFromParent_Done,
     /* 1063778 */   // Label 15721: @1063778
     /* 1063778 */   GIM_Try, /*On fail goto*//*Label 15722*/ GIMT_Encode4(1063855), // Rule ID 21436 //
     /* 1063783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1063794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1063797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1063800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063822 */     // MIs[0] policy
     /* 1063822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063832 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1063835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063854 */     // GIR_Coverage, 21436,
     /* 1063854 */     GIR_EraseRootFromParent_Done,
     /* 1063855 */   // Label 15722: @1063855
     /* 1063855 */   GIM_Try, /*On fail goto*//*Label 15723*/ GIMT_Encode4(1063932), // Rule ID 21437 //
     /* 1063860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1063871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1063874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1063877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063899 */     // MIs[0] policy
     /* 1063899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063909 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1063912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063918 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063931 */     // GIR_Coverage, 21437,
     /* 1063931 */     GIR_EraseRootFromParent_Done,
     /* 1063932 */   // Label 15723: @1063932
     /* 1063932 */   GIM_Try, /*On fail goto*//*Label 15724*/ GIMT_Encode4(1064009), // Rule ID 21440 //
     /* 1063937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1063948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1063951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1063954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1063957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063976 */     // MIs[0] policy
     /* 1063976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063986 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1063989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064008 */     // GIR_Coverage, 21440,
     /* 1064008 */     GIR_EraseRootFromParent_Done,
     /* 1064009 */   // Label 15724: @1064009
     /* 1064009 */   GIM_Try, /*On fail goto*//*Label 15725*/ GIMT_Encode4(1064086), // Rule ID 21441 //
     /* 1064014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1064017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1064025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1064028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1064031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1064034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064053 */     // MIs[0] policy
     /* 1064053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064063 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1064066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064072 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064085 */     // GIR_Coverage, 21441,
     /* 1064085 */     GIR_EraseRootFromParent_Done,
     /* 1064086 */   // Label 15725: @1064086
     /* 1064086 */   GIM_Try, /*On fail goto*//*Label 15726*/ GIMT_Encode4(1064163), // Rule ID 21444 //
     /* 1064091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1064094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1064102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1064105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1064108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064130 */     // MIs[0] policy
     /* 1064130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064140 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1064143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064162 */     // GIR_Coverage, 21444,
     /* 1064162 */     GIR_EraseRootFromParent_Done,
     /* 1064163 */   // Label 15726: @1064163
     /* 1064163 */   GIM_Try, /*On fail goto*//*Label 15727*/ GIMT_Encode4(1064240), // Rule ID 21445 //
     /* 1064168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1064171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1064179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1064182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1064185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064207 */     // MIs[0] policy
     /* 1064207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064217 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1064220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064226 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064239 */     // GIR_Coverage, 21445,
     /* 1064239 */     GIR_EraseRootFromParent_Done,
     /* 1064240 */   // Label 15727: @1064240
     /* 1064240 */   GIM_Try, /*On fail goto*//*Label 15728*/ GIMT_Encode4(1064317), // Rule ID 21448 //
     /* 1064245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1064248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1064256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1064259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1064262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064284 */     // MIs[0] policy
     /* 1064284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064294 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1064297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064316 */     // GIR_Coverage, 21448,
     /* 1064316 */     GIR_EraseRootFromParent_Done,
     /* 1064317 */   // Label 15728: @1064317
     /* 1064317 */   GIM_Try, /*On fail goto*//*Label 15729*/ GIMT_Encode4(1064394), // Rule ID 21449 //
     /* 1064322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1064325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1064333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1064336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1064339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064361 */     // MIs[0] policy
     /* 1064361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064371 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1064374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064393 */     // GIR_Coverage, 21449,
     /* 1064393 */     GIR_EraseRootFromParent_Done,
     /* 1064394 */   // Label 15729: @1064394
     /* 1064394 */   GIM_Try, /*On fail goto*//*Label 15730*/ GIMT_Encode4(1064471), // Rule ID 21452 //
     /* 1064399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1064402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1064410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1064413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1064416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064438 */     // MIs[0] policy
     /* 1064438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064448 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1064451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064470 */     // GIR_Coverage, 21452,
     /* 1064470 */     GIR_EraseRootFromParent_Done,
     /* 1064471 */   // Label 15730: @1064471
     /* 1064471 */   GIM_Try, /*On fail goto*//*Label 15731*/ GIMT_Encode4(1064548), // Rule ID 21453 //
     /* 1064476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1064479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1064487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1064490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1064493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064515 */     // MIs[0] policy
     /* 1064515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064525 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1064528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064534 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064547 */     // GIR_Coverage, 21453,
     /* 1064547 */     GIR_EraseRootFromParent_Done,
     /* 1064548 */   // Label 15731: @1064548
     /* 1064548 */   GIM_Try, /*On fail goto*//*Label 15732*/ GIMT_Encode4(1064625), // Rule ID 21456 //
     /* 1064553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1064556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1064564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1064567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1064570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064592 */     // MIs[0] policy
     /* 1064592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064602 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1064605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064624 */     // GIR_Coverage, 21456,
     /* 1064624 */     GIR_EraseRootFromParent_Done,
     /* 1064625 */   // Label 15732: @1064625
     /* 1064625 */   GIM_Try, /*On fail goto*//*Label 15733*/ GIMT_Encode4(1064702), // Rule ID 21457 //
     /* 1064630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1064633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1064641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1064644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1064647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064669 */     // MIs[0] policy
     /* 1064669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064679 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1064682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064688 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064701 */     // GIR_Coverage, 21457,
     /* 1064701 */     GIR_EraseRootFromParent_Done,
     /* 1064702 */   // Label 15733: @1064702
     /* 1064702 */   GIM_Try, /*On fail goto*//*Label 15734*/ GIMT_Encode4(1064779), // Rule ID 21460 //
     /* 1064707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1064718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1064721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1064724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064746 */     // MIs[0] policy
     /* 1064746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064756 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1064759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064778 */     // GIR_Coverage, 21460,
     /* 1064778 */     GIR_EraseRootFromParent_Done,
     /* 1064779 */   // Label 15734: @1064779
     /* 1064779 */   GIM_Try, /*On fail goto*//*Label 15735*/ GIMT_Encode4(1064856), // Rule ID 21461 //
     /* 1064784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1064795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1064798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1064801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064823 */     // MIs[0] policy
     /* 1064823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064833 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1064836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064842 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064855 */     // GIR_Coverage, 21461,
     /* 1064855 */     GIR_EraseRootFromParent_Done,
     /* 1064856 */   // Label 15735: @1064856
     /* 1064856 */   GIM_Try, /*On fail goto*//*Label 15736*/ GIMT_Encode4(1064933), // Rule ID 21464 //
     /* 1064861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1064872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1064875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1064878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064900 */     // MIs[0] policy
     /* 1064900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064910 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1064913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064932 */     // GIR_Coverage, 21464,
     /* 1064932 */     GIR_EraseRootFromParent_Done,
     /* 1064933 */   // Label 15736: @1064933
     /* 1064933 */   GIM_Try, /*On fail goto*//*Label 15737*/ GIMT_Encode4(1065010), // Rule ID 21465 //
     /* 1064938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1064949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1064952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1064955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064977 */     // MIs[0] policy
     /* 1064977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064987 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1064990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064996 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065009 */     // GIR_Coverage, 21465,
     /* 1065009 */     GIR_EraseRootFromParent_Done,
     /* 1065010 */   // Label 15737: @1065010
     /* 1065010 */   GIM_Try, /*On fail goto*//*Label 15738*/ GIMT_Encode4(1065087), // Rule ID 21468 //
     /* 1065015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1065018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1065026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1065029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1065032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065054 */     // MIs[0] policy
     /* 1065054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065064 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1065067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065086 */     // GIR_Coverage, 21468,
     /* 1065086 */     GIR_EraseRootFromParent_Done,
     /* 1065087 */   // Label 15738: @1065087
     /* 1065087 */   GIM_Try, /*On fail goto*//*Label 15739*/ GIMT_Encode4(1065164), // Rule ID 21469 //
     /* 1065092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1065095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1065103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1065106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1065109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065131 */     // MIs[0] policy
     /* 1065131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065141 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1065144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065150 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065163 */     // GIR_Coverage, 21469,
     /* 1065163 */     GIR_EraseRootFromParent_Done,
     /* 1065164 */   // Label 15739: @1065164
     /* 1065164 */   GIM_Try, /*On fail goto*//*Label 15740*/ GIMT_Encode4(1065241), // Rule ID 21472 //
     /* 1065169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1065172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1065180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1065183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1065186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065208 */     // MIs[0] policy
     /* 1065208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065218 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1065221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065240 */     // GIR_Coverage, 21472,
     /* 1065240 */     GIR_EraseRootFromParent_Done,
     /* 1065241 */   // Label 15740: @1065241
     /* 1065241 */   GIM_Try, /*On fail goto*//*Label 15741*/ GIMT_Encode4(1065318), // Rule ID 21473 //
     /* 1065246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1065249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1065257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1065260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1065263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065285 */     // MIs[0] policy
     /* 1065285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065295 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1065298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065304 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065317 */     // GIR_Coverage, 21473,
     /* 1065317 */     GIR_EraseRootFromParent_Done,
     /* 1065318 */   // Label 15741: @1065318
     /* 1065318 */   GIM_Try, /*On fail goto*//*Label 15742*/ GIMT_Encode4(1065395), // Rule ID 21476 //
     /* 1065323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1065326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1065334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1065337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1065340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1065343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065362 */     // MIs[0] policy
     /* 1065362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065372 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1065375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065394 */     // GIR_Coverage, 21476,
     /* 1065394 */     GIR_EraseRootFromParent_Done,
     /* 1065395 */   // Label 15742: @1065395
     /* 1065395 */   GIM_Try, /*On fail goto*//*Label 15743*/ GIMT_Encode4(1065472), // Rule ID 21477 //
     /* 1065400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1065403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1065411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1065414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1065417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1065420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065439 */     // MIs[0] policy
     /* 1065439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065449 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1065452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065458 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065471 */     // GIR_Coverage, 21477,
     /* 1065471 */     GIR_EraseRootFromParent_Done,
     /* 1065472 */   // Label 15743: @1065472
     /* 1065472 */   GIM_Try, /*On fail goto*//*Label 15744*/ GIMT_Encode4(1065549), // Rule ID 21480 //
     /* 1065477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1065488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1065491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1065494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065516 */     // MIs[0] policy
     /* 1065516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065526 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1065529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065548 */     // GIR_Coverage, 21480,
     /* 1065548 */     GIR_EraseRootFromParent_Done,
     /* 1065549 */   // Label 15744: @1065549
     /* 1065549 */   GIM_Try, /*On fail goto*//*Label 15745*/ GIMT_Encode4(1065626), // Rule ID 21481 //
     /* 1065554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1065565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1065568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1065571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065593 */     // MIs[0] policy
     /* 1065593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065603 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1065606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065625 */     // GIR_Coverage, 21481,
     /* 1065625 */     GIR_EraseRootFromParent_Done,
     /* 1065626 */   // Label 15745: @1065626
     /* 1065626 */   GIM_Try, /*On fail goto*//*Label 15746*/ GIMT_Encode4(1065703), // Rule ID 21484 //
     /* 1065631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1065648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065670 */     // MIs[0] policy
     /* 1065670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065680 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1065683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065702 */     // GIR_Coverage, 21484,
     /* 1065702 */     GIR_EraseRootFromParent_Done,
     /* 1065703 */   // Label 15746: @1065703
     /* 1065703 */   GIM_Try, /*On fail goto*//*Label 15747*/ GIMT_Encode4(1065780), // Rule ID 21485 //
     /* 1065708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1065725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065747 */     // MIs[0] policy
     /* 1065747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065757 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1065760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065766 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065779 */     // GIR_Coverage, 21485,
     /* 1065779 */     GIR_EraseRootFromParent_Done,
     /* 1065780 */   // Label 15747: @1065780
     /* 1065780 */   GIM_Try, /*On fail goto*//*Label 15748*/ GIMT_Encode4(1065857), // Rule ID 21488 //
     /* 1065785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1065802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065824 */     // MIs[0] policy
     /* 1065824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065834 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1065837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065856 */     // GIR_Coverage, 21488,
     /* 1065856 */     GIR_EraseRootFromParent_Done,
     /* 1065857 */   // Label 15748: @1065857
     /* 1065857 */   GIM_Try, /*On fail goto*//*Label 15749*/ GIMT_Encode4(1065934), // Rule ID 21489 //
     /* 1065862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1065879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065901 */     // MIs[0] policy
     /* 1065901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065911 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1065914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065920 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065933 */     // GIR_Coverage, 21489,
     /* 1065933 */     GIR_EraseRootFromParent_Done,
     /* 1065934 */   // Label 15749: @1065934
     /* 1065934 */   GIM_Try, /*On fail goto*//*Label 15750*/ GIMT_Encode4(1066011), // Rule ID 21492 //
     /* 1065939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1065956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065978 */     // MIs[0] policy
     /* 1065978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065988 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1065991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1066007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066010 */     // GIR_Coverage, 21492,
     /* 1066010 */     GIR_EraseRootFromParent_Done,
     /* 1066011 */   // Label 15750: @1066011
     /* 1066011 */   GIM_Try, /*On fail goto*//*Label 15751*/ GIMT_Encode4(1066088), // Rule ID 21493 //
     /* 1066016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1066019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1066024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1066027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1066030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1066033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1066043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066055 */     // MIs[0] policy
     /* 1066055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066065 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1066068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1066084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066087 */     // GIR_Coverage, 21493,
     /* 1066087 */     GIR_EraseRootFromParent_Done,
     /* 1066088 */   // Label 15751: @1066088
     /* 1066088 */   GIM_Try, /*On fail goto*//*Label 15752*/ GIMT_Encode4(1066165), // Rule ID 21736 //
     /* 1066093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1066104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1066107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1066110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066132 */     // MIs[0] policy
     /* 1066132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066142 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1066145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066164 */     // GIR_Coverage, 21736,
     /* 1066164 */     GIR_EraseRootFromParent_Done,
     /* 1066165 */   // Label 15752: @1066165
     /* 1066165 */   GIM_Try, /*On fail goto*//*Label 15753*/ GIMT_Encode4(1066242), // Rule ID 21737 //
     /* 1066170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1066181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1066184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1066187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066209 */     // MIs[0] policy
     /* 1066209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066219 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1066222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066228 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066241 */     // GIR_Coverage, 21737,
     /* 1066241 */     GIR_EraseRootFromParent_Done,
     /* 1066242 */   // Label 15753: @1066242
     /* 1066242 */   GIM_Try, /*On fail goto*//*Label 15754*/ GIMT_Encode4(1066319), // Rule ID 21740 //
     /* 1066247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1066258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1066261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1066264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066286 */     // MIs[0] policy
     /* 1066286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066296 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1066299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066318 */     // GIR_Coverage, 21740,
     /* 1066318 */     GIR_EraseRootFromParent_Done,
     /* 1066319 */   // Label 15754: @1066319
     /* 1066319 */   GIM_Try, /*On fail goto*//*Label 15755*/ GIMT_Encode4(1066396), // Rule ID 21741 //
     /* 1066324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1066335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1066338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1066341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066363 */     // MIs[0] policy
     /* 1066363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066373 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1066376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066382 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066395 */     // GIR_Coverage, 21741,
     /* 1066395 */     GIR_EraseRootFromParent_Done,
     /* 1066396 */   // Label 15755: @1066396
     /* 1066396 */   GIM_Try, /*On fail goto*//*Label 15756*/ GIMT_Encode4(1066473), // Rule ID 21744 //
     /* 1066401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1066412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1066415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1066418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066440 */     // MIs[0] policy
     /* 1066440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066450 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066472 */     // GIR_Coverage, 21744,
     /* 1066472 */     GIR_EraseRootFromParent_Done,
     /* 1066473 */   // Label 15756: @1066473
     /* 1066473 */   GIM_Try, /*On fail goto*//*Label 15757*/ GIMT_Encode4(1066550), // Rule ID 21745 //
     /* 1066478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1066489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1066492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1066495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066517 */     // MIs[0] policy
     /* 1066517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066527 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066549 */     // GIR_Coverage, 21745,
     /* 1066549 */     GIR_EraseRootFromParent_Done,
     /* 1066550 */   // Label 15757: @1066550
     /* 1066550 */   GIM_Try, /*On fail goto*//*Label 15758*/ GIMT_Encode4(1066627), // Rule ID 21748 //
     /* 1066555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1066566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1066569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1066572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066594 */     // MIs[0] policy
     /* 1066594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066604 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066626 */     // GIR_Coverage, 21748,
     /* 1066626 */     GIR_EraseRootFromParent_Done,
     /* 1066627 */   // Label 15758: @1066627
     /* 1066627 */   GIM_Try, /*On fail goto*//*Label 15759*/ GIMT_Encode4(1066704), // Rule ID 21749 //
     /* 1066632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1066643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1066646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1066649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066671 */     // MIs[0] policy
     /* 1066671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066681 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066690 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066703 */     // GIR_Coverage, 21749,
     /* 1066703 */     GIR_EraseRootFromParent_Done,
     /* 1066704 */   // Label 15759: @1066704
     /* 1066704 */   GIM_Try, /*On fail goto*//*Label 15760*/ GIMT_Encode4(1066781), // Rule ID 21752 //
     /* 1066709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1066720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1066723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1066726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066748 */     // MIs[0] policy
     /* 1066748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066758 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1066761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066780 */     // GIR_Coverage, 21752,
     /* 1066780 */     GIR_EraseRootFromParent_Done,
     /* 1066781 */   // Label 15760: @1066781
     /* 1066781 */   GIM_Try, /*On fail goto*//*Label 15761*/ GIMT_Encode4(1066858), // Rule ID 21753 //
     /* 1066786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1066797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1066800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1066803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066825 */     // MIs[0] policy
     /* 1066825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066835 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1066838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066857 */     // GIR_Coverage, 21753,
     /* 1066857 */     GIR_EraseRootFromParent_Done,
     /* 1066858 */   // Label 15761: @1066858
     /* 1066858 */   GIM_Try, /*On fail goto*//*Label 15762*/ GIMT_Encode4(1066935), // Rule ID 21756 //
     /* 1066863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1066874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1066877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1066880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1066883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066902 */     // MIs[0] policy
     /* 1066902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066912 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1066915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066934 */     // GIR_Coverage, 21756,
     /* 1066934 */     GIR_EraseRootFromParent_Done,
     /* 1066935 */   // Label 15762: @1066935
     /* 1066935 */   GIM_Try, /*On fail goto*//*Label 15763*/ GIMT_Encode4(1067012), // Rule ID 21757 //
     /* 1066940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1066951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1066954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1066957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1066960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066979 */     // MIs[0] policy
     /* 1066979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066989 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1066992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066998 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067011 */     // GIR_Coverage, 21757,
     /* 1067011 */     GIR_EraseRootFromParent_Done,
     /* 1067012 */   // Label 15763: @1067012
     /* 1067012 */   GIM_Try, /*On fail goto*//*Label 15764*/ GIMT_Encode4(1067089), // Rule ID 21760 //
     /* 1067017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1067028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1067031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1067034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067056 */     // MIs[0] policy
     /* 1067056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067066 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1067069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067088 */     // GIR_Coverage, 21760,
     /* 1067088 */     GIR_EraseRootFromParent_Done,
     /* 1067089 */   // Label 15764: @1067089
     /* 1067089 */   GIM_Try, /*On fail goto*//*Label 15765*/ GIMT_Encode4(1067166), // Rule ID 21761 //
     /* 1067094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1067105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1067108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1067111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067133 */     // MIs[0] policy
     /* 1067133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067143 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1067146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067152 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067165 */     // GIR_Coverage, 21761,
     /* 1067165 */     GIR_EraseRootFromParent_Done,
     /* 1067166 */   // Label 15765: @1067166
     /* 1067166 */   GIM_Try, /*On fail goto*//*Label 15766*/ GIMT_Encode4(1067243), // Rule ID 21764 //
     /* 1067171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1067182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1067185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1067188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067210 */     // MIs[0] policy
     /* 1067210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067220 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1067223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067242 */     // GIR_Coverage, 21764,
     /* 1067242 */     GIR_EraseRootFromParent_Done,
     /* 1067243 */   // Label 15766: @1067243
     /* 1067243 */   GIM_Try, /*On fail goto*//*Label 15767*/ GIMT_Encode4(1067320), // Rule ID 21765 //
     /* 1067248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1067259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1067262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1067265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067287 */     // MIs[0] policy
     /* 1067287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067297 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1067300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067306 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067319 */     // GIR_Coverage, 21765,
     /* 1067319 */     GIR_EraseRootFromParent_Done,
     /* 1067320 */   // Label 15767: @1067320
     /* 1067320 */   GIM_Try, /*On fail goto*//*Label 15768*/ GIMT_Encode4(1067397), // Rule ID 21768 //
     /* 1067325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1067336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1067339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1067342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067364 */     // MIs[0] policy
     /* 1067364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1067377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067396 */     // GIR_Coverage, 21768,
     /* 1067396 */     GIR_EraseRootFromParent_Done,
     /* 1067397 */   // Label 15768: @1067397
     /* 1067397 */   GIM_Try, /*On fail goto*//*Label 15769*/ GIMT_Encode4(1067474), // Rule ID 21769 //
     /* 1067402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1067413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1067416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1067419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067441 */     // MIs[0] policy
     /* 1067441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067451 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1067454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067473 */     // GIR_Coverage, 21769,
     /* 1067473 */     GIR_EraseRootFromParent_Done,
     /* 1067474 */   // Label 15769: @1067474
     /* 1067474 */   GIM_Try, /*On fail goto*//*Label 15770*/ GIMT_Encode4(1067551), // Rule ID 21772 //
     /* 1067479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1067490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1067493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1067496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067518 */     // MIs[0] policy
     /* 1067518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067528 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067550 */     // GIR_Coverage, 21772,
     /* 1067550 */     GIR_EraseRootFromParent_Done,
     /* 1067551 */   // Label 15770: @1067551
     /* 1067551 */   GIM_Try, /*On fail goto*//*Label 15771*/ GIMT_Encode4(1067628), // Rule ID 21773 //
     /* 1067556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1067567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1067570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1067573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067595 */     // MIs[0] policy
     /* 1067595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067614 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067627 */     // GIR_Coverage, 21773,
     /* 1067627 */     GIR_EraseRootFromParent_Done,
     /* 1067628 */   // Label 15771: @1067628
     /* 1067628 */   GIM_Try, /*On fail goto*//*Label 15772*/ GIMT_Encode4(1067705), // Rule ID 21776 //
     /* 1067633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1067644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1067647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1067650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1067653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067672 */     // MIs[0] policy
     /* 1067672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067682 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067691 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067704 */     // GIR_Coverage, 21776,
     /* 1067704 */     GIR_EraseRootFromParent_Done,
     /* 1067705 */   // Label 15772: @1067705
     /* 1067705 */   GIM_Try, /*On fail goto*//*Label 15773*/ GIMT_Encode4(1067782), // Rule ID 21777 //
     /* 1067710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1067721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1067724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1067727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1067730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067749 */     // MIs[0] policy
     /* 1067749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067759 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067768 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067781 */     // GIR_Coverage, 21777,
     /* 1067781 */     GIR_EraseRootFromParent_Done,
     /* 1067782 */   // Label 15773: @1067782
     /* 1067782 */   GIM_Try, /*On fail goto*//*Label 15774*/ GIMT_Encode4(1067859), // Rule ID 21780 //
     /* 1067787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1067798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1067801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1067804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067826 */     // MIs[0] policy
     /* 1067826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067836 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1067839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067858 */     // GIR_Coverage, 21780,
     /* 1067858 */     GIR_EraseRootFromParent_Done,
     /* 1067859 */   // Label 15774: @1067859
     /* 1067859 */   GIM_Try, /*On fail goto*//*Label 15775*/ GIMT_Encode4(1067936), // Rule ID 21781 //
     /* 1067864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1067875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1067878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1067881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067903 */     // MIs[0] policy
     /* 1067903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067913 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1067916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067922 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067935 */     // GIR_Coverage, 21781,
     /* 1067935 */     GIR_EraseRootFromParent_Done,
     /* 1067936 */   // Label 15775: @1067936
     /* 1067936 */   GIM_Try, /*On fail goto*//*Label 15776*/ GIMT_Encode4(1068013), // Rule ID 21784 //
     /* 1067941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1067952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1067955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1067958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067980 */     // MIs[0] policy
     /* 1067980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1067993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068012 */     // GIR_Coverage, 21784,
     /* 1068012 */     GIR_EraseRootFromParent_Done,
     /* 1068013 */   // Label 15776: @1068013
     /* 1068013 */   GIM_Try, /*On fail goto*//*Label 15777*/ GIMT_Encode4(1068090), // Rule ID 21785 //
     /* 1068018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1068021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1068026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1068029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1068032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1068035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068057 */     // MIs[0] policy
     /* 1068057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068067 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1068070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068076 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068089 */     // GIR_Coverage, 21785,
     /* 1068089 */     GIR_EraseRootFromParent_Done,
     /* 1068090 */   // Label 15777: @1068090
     /* 1068090 */   GIM_Try, /*On fail goto*//*Label 15778*/ GIMT_Encode4(1068167), // Rule ID 21788 //
     /* 1068095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1068098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1068103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1068106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1068109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1068112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068134 */     // MIs[0] policy
     /* 1068134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068144 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1068147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068166 */     // GIR_Coverage, 21788,
     /* 1068166 */     GIR_EraseRootFromParent_Done,
     /* 1068167 */   // Label 15778: @1068167
     /* 1068167 */   GIM_Try, /*On fail goto*//*Label 15779*/ GIMT_Encode4(1068244), // Rule ID 21789 //
     /* 1068172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1068175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1068180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1068183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1068186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1068189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068211 */     // MIs[0] policy
     /* 1068211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1068224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068230 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068243 */     // GIR_Coverage, 21789,
     /* 1068243 */     GIR_EraseRootFromParent_Done,
     /* 1068244 */   // Label 15779: @1068244
     /* 1068244 */   GIM_Try, /*On fail goto*//*Label 15780*/ GIMT_Encode4(1068321), // Rule ID 21792 //
     /* 1068249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1068252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1068257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1068260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1068263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1068266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068288 */     // MIs[0] policy
     /* 1068288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068298 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1068301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068320 */     // GIR_Coverage, 21792,
     /* 1068320 */     GIR_EraseRootFromParent_Done,
     /* 1068321 */   // Label 15780: @1068321
     /* 1068321 */   GIM_Try, /*On fail goto*//*Label 15781*/ GIMT_Encode4(1068398), // Rule ID 21793 //
     /* 1068326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1068329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1068334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1068337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1068340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1068343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068365 */     // MIs[0] policy
     /* 1068365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068375 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1068378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068384 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068397 */     // GIR_Coverage, 21793,
     /* 1068397 */     GIR_EraseRootFromParent_Done,
     /* 1068398 */   // Label 15781: @1068398
     /* 1068398 */   GIM_Try, /*On fail goto*//*Label 15782*/ GIMT_Encode4(1068475), // Rule ID 21796 //
     /* 1068403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1068414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1068417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1068420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068442 */     // MIs[0] policy
     /* 1068442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068452 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1068455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068474 */     // GIR_Coverage, 21796,
     /* 1068474 */     GIR_EraseRootFromParent_Done,
     /* 1068475 */   // Label 15782: @1068475
     /* 1068475 */   GIM_Try, /*On fail goto*//*Label 15783*/ GIMT_Encode4(1068552), // Rule ID 21797 //
     /* 1068480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1068491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1068494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1068497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068519 */     // MIs[0] policy
     /* 1068519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068529 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1068532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068538 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068551 */     // GIR_Coverage, 21797,
     /* 1068551 */     GIR_EraseRootFromParent_Done,
     /* 1068552 */   // Label 15783: @1068552
     /* 1068552 */   GIM_Try, /*On fail goto*//*Label 15784*/ GIMT_Encode4(1068629), // Rule ID 21800 //
     /* 1068557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1068568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1068571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1068574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068596 */     // MIs[0] policy
     /* 1068596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068606 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068628 */     // GIR_Coverage, 21800,
     /* 1068628 */     GIR_EraseRootFromParent_Done,
     /* 1068629 */   // Label 15784: @1068629
     /* 1068629 */   GIM_Try, /*On fail goto*//*Label 15785*/ GIMT_Encode4(1068706), // Rule ID 21801 //
     /* 1068634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1068645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1068648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1068651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068673 */     // MIs[0] policy
     /* 1068673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068683 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068705 */     // GIR_Coverage, 21801,
     /* 1068705 */     GIR_EraseRootFromParent_Done,
     /* 1068706 */   // Label 15785: @1068706
     /* 1068706 */   GIM_Try, /*On fail goto*//*Label 15786*/ GIMT_Encode4(1068783), // Rule ID 21804 //
     /* 1068711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1068722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1068725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1068728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068750 */     // MIs[0] policy
     /* 1068750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068760 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1068763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068782 */     // GIR_Coverage, 21804,
     /* 1068782 */     GIR_EraseRootFromParent_Done,
     /* 1068783 */   // Label 15786: @1068783
     /* 1068783 */   GIM_Try, /*On fail goto*//*Label 15787*/ GIMT_Encode4(1068860), // Rule ID 21805 //
     /* 1068788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1068799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1068802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1068805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068827 */     // MIs[0] policy
     /* 1068827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068837 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1068840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068846 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068859 */     // GIR_Coverage, 21805,
     /* 1068859 */     GIR_EraseRootFromParent_Done,
     /* 1068860 */   // Label 15787: @1068860
     /* 1068860 */   GIM_Try, /*On fail goto*//*Label 15788*/ GIMT_Encode4(1068937), // Rule ID 21808 //
     /* 1068865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1068876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1068879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1068882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068904 */     // MIs[0] policy
     /* 1068904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068914 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1068917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068936 */     // GIR_Coverage, 21808,
     /* 1068936 */     GIR_EraseRootFromParent_Done,
     /* 1068937 */   // Label 15788: @1068937
     /* 1068937 */   GIM_Try, /*On fail goto*//*Label 15789*/ GIMT_Encode4(1069014), // Rule ID 21809 //
     /* 1068942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1068953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1068956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1068959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068981 */     // MIs[0] policy
     /* 1068981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068991 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1068994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069000 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069013 */     // GIR_Coverage, 21809,
     /* 1069013 */     GIR_EraseRootFromParent_Done,
     /* 1069014 */   // Label 15789: @1069014
     /* 1069014 */   GIM_Try, /*On fail goto*//*Label 15790*/ GIMT_Encode4(1069091), // Rule ID 21812 //
     /* 1069019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1069022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1069030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1069033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1069036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1069039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069058 */     // MIs[0] policy
     /* 1069058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069068 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069090 */     // GIR_Coverage, 21812,
     /* 1069090 */     GIR_EraseRootFromParent_Done,
     /* 1069091 */   // Label 15790: @1069091
     /* 1069091 */   GIM_Try, /*On fail goto*//*Label 15791*/ GIMT_Encode4(1069168), // Rule ID 21813 //
     /* 1069096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1069099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1069107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1069110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1069113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1069116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069135 */     // MIs[0] policy
     /* 1069135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069145 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069154 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069167 */     // GIR_Coverage, 21813,
     /* 1069167 */     GIR_EraseRootFromParent_Done,
     /* 1069168 */   // Label 15791: @1069168
     /* 1069168 */   GIM_Try, /*On fail goto*//*Label 15792*/ GIMT_Encode4(1069245), // Rule ID 21816 //
     /* 1069173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1069176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1069184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1069187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1069190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1069193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069212 */     // MIs[0] policy
     /* 1069212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069222 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069244 */     // GIR_Coverage, 21816,
     /* 1069244 */     GIR_EraseRootFromParent_Done,
     /* 1069245 */   // Label 15792: @1069245
     /* 1069245 */   GIM_Try, /*On fail goto*//*Label 15793*/ GIMT_Encode4(1069322), // Rule ID 21817 //
     /* 1069250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1069253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1069261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1069264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1069267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1069270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069289 */     // MIs[0] policy
     /* 1069289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069299 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069321 */     // GIR_Coverage, 21817,
     /* 1069321 */     GIR_EraseRootFromParent_Done,
     /* 1069322 */   // Label 15793: @1069322
     /* 1069322 */   GIM_Try, /*On fail goto*//*Label 15794*/ GIMT_Encode4(1069399), // Rule ID 21820 //
     /* 1069327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1069338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1069341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1069344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069366 */     // MIs[0] policy
     /* 1069366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1069379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069398 */     // GIR_Coverage, 21820,
     /* 1069398 */     GIR_EraseRootFromParent_Done,
     /* 1069399 */   // Label 15794: @1069399
     /* 1069399 */   GIM_Try, /*On fail goto*//*Label 15795*/ GIMT_Encode4(1069476), // Rule ID 21821 //
     /* 1069404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1069415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1069418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1069421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069443 */     // MIs[0] policy
     /* 1069443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069453 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1069456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069462 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069475 */     // GIR_Coverage, 21821,
     /* 1069475 */     GIR_EraseRootFromParent_Done,
     /* 1069476 */   // Label 15795: @1069476
     /* 1069476 */   GIM_Try, /*On fail goto*//*Label 15796*/ GIMT_Encode4(1069553), // Rule ID 21824 //
     /* 1069481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1069492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1069495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069520 */     // MIs[0] policy
     /* 1069520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069530 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069552 */     // GIR_Coverage, 21824,
     /* 1069552 */     GIR_EraseRootFromParent_Done,
     /* 1069553 */   // Label 15796: @1069553
     /* 1069553 */   GIM_Try, /*On fail goto*//*Label 15797*/ GIMT_Encode4(1069630), // Rule ID 21825 //
     /* 1069558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1069569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1069572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069597 */     // MIs[0] policy
     /* 1069597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069607 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069616 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069629 */     // GIR_Coverage, 21825,
     /* 1069629 */     GIR_EraseRootFromParent_Done,
     /* 1069630 */   // Label 15797: @1069630
     /* 1069630 */   GIM_Try, /*On fail goto*//*Label 15798*/ GIMT_Encode4(1069707), // Rule ID 21828 //
     /* 1069635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1069646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1069649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1069652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069674 */     // MIs[0] policy
     /* 1069674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069684 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069706 */     // GIR_Coverage, 21828,
     /* 1069706 */     GIR_EraseRootFromParent_Done,
     /* 1069707 */   // Label 15798: @1069707
     /* 1069707 */   GIM_Try, /*On fail goto*//*Label 15799*/ GIMT_Encode4(1069784), // Rule ID 21829 //
     /* 1069712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1069723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1069726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1069729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069751 */     // MIs[0] policy
     /* 1069751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069761 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069770 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069783 */     // GIR_Coverage, 21829,
     /* 1069783 */     GIR_EraseRootFromParent_Done,
     /* 1069784 */   // Label 15799: @1069784
     /* 1069784 */   GIM_Try, /*On fail goto*//*Label 15800*/ GIMT_Encode4(1069861), // Rule ID 21832 //
     /* 1069789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1069800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1069803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1069806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069828 */     // MIs[0] policy
     /* 1069828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069860 */     // GIR_Coverage, 21832,
     /* 1069860 */     GIR_EraseRootFromParent_Done,
     /* 1069861 */   // Label 15800: @1069861
     /* 1069861 */   GIM_Try, /*On fail goto*//*Label 15801*/ GIMT_Encode4(1069938), // Rule ID 21833 //
     /* 1069866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1069877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1069880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1069883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069905 */     // MIs[0] policy
     /* 1069905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069915 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069937 */     // GIR_Coverage, 21833,
     /* 1069937 */     GIR_EraseRootFromParent_Done,
     /* 1069938 */   // Label 15801: @1069938
     /* 1069938 */   GIM_Try, /*On fail goto*//*Label 15802*/ GIMT_Encode4(1070015), // Rule ID 21836 //
     /* 1069943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1069954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1069957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1069960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1069963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069982 */     // MIs[0] policy
     /* 1069982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069992 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070014 */     // GIR_Coverage, 21836,
     /* 1070014 */     GIR_EraseRootFromParent_Done,
     /* 1070015 */   // Label 15802: @1070015
     /* 1070015 */   GIM_Try, /*On fail goto*//*Label 15803*/ GIMT_Encode4(1070092), // Rule ID 21837 //
     /* 1070020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1070023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1070031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1070034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1070037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1070040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070059 */     // MIs[0] policy
     /* 1070059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070069 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1070072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070078 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070091 */     // GIR_Coverage, 21837,
     /* 1070091 */     GIR_EraseRootFromParent_Done,
     /* 1070092 */   // Label 15803: @1070092
     /* 1070092 */   GIM_Try, /*On fail goto*//*Label 15804*/ GIMT_Encode4(1070169), // Rule ID 21840 //
     /* 1070097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1070100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1070108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1070111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1070114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070136 */     // MIs[0] policy
     /* 1070136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1070149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070155 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070168 */     // GIR_Coverage, 21840,
     /* 1070168 */     GIR_EraseRootFromParent_Done,
     /* 1070169 */   // Label 15804: @1070169
     /* 1070169 */   GIM_Try, /*On fail goto*//*Label 15805*/ GIMT_Encode4(1070246), // Rule ID 21841 //
     /* 1070174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1070177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1070185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1070188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1070191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070213 */     // MIs[0] policy
     /* 1070213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070223 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1070226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070232 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070245 */     // GIR_Coverage, 21841,
     /* 1070245 */     GIR_EraseRootFromParent_Done,
     /* 1070246 */   // Label 15805: @1070246
     /* 1070246 */   GIM_Try, /*On fail goto*//*Label 15806*/ GIMT_Encode4(1070323), // Rule ID 21844 //
     /* 1070251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1070254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1070262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1070265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1070268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070290 */     // MIs[0] policy
     /* 1070290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1070303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070322 */     // GIR_Coverage, 21844,
     /* 1070322 */     GIR_EraseRootFromParent_Done,
     /* 1070323 */   // Label 15806: @1070323
     /* 1070323 */   GIM_Try, /*On fail goto*//*Label 15807*/ GIMT_Encode4(1070400), // Rule ID 21845 //
     /* 1070328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1070331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1070339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1070342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1070345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070367 */     // MIs[0] policy
     /* 1070367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070377 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1070380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070386 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070399 */     // GIR_Coverage, 21845,
     /* 1070399 */     GIR_EraseRootFromParent_Done,
     /* 1070400 */   // Label 15807: @1070400
     /* 1070400 */   GIM_Try, /*On fail goto*//*Label 15808*/ GIMT_Encode4(1070477), // Rule ID 21848 //
     /* 1070405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1070408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1070416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1070419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1070422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070444 */     // MIs[0] policy
     /* 1070444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070454 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1070457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070476 */     // GIR_Coverage, 21848,
     /* 1070476 */     GIR_EraseRootFromParent_Done,
     /* 1070477 */   // Label 15808: @1070477
     /* 1070477 */   GIM_Try, /*On fail goto*//*Label 15809*/ GIMT_Encode4(1070554), // Rule ID 21849 //
     /* 1070482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1070485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1070493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1070496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1070499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070521 */     // MIs[0] policy
     /* 1070521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070531 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1070534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070540 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070553 */     // GIR_Coverage, 21849,
     /* 1070553 */     GIR_EraseRootFromParent_Done,
     /* 1070554 */   // Label 15809: @1070554
     /* 1070554 */   GIM_Try, /*On fail goto*//*Label 15810*/ GIMT_Encode4(1070631), // Rule ID 21852 //
     /* 1070559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1070562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1070570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1070573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1070576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070598 */     // MIs[0] policy
     /* 1070598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070608 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1070611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070630 */     // GIR_Coverage, 21852,
     /* 1070630 */     GIR_EraseRootFromParent_Done,
     /* 1070631 */   // Label 15810: @1070631
     /* 1070631 */   GIM_Try, /*On fail goto*//*Label 15811*/ GIMT_Encode4(1070708), // Rule ID 21853 //
     /* 1070636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1070639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1070647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1070650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1070653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070675 */     // MIs[0] policy
     /* 1070675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070685 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1070688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070694 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070707 */     // GIR_Coverage, 21853,
     /* 1070707 */     GIR_EraseRootFromParent_Done,
     /* 1070708 */   // Label 15811: @1070708
     /* 1070708 */   GIM_Try, /*On fail goto*//*Label 15812*/ GIMT_Encode4(1070785), // Rule ID 21964 //
     /* 1070713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1070724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1070727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1070730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070752 */     // MIs[0] policy
     /* 1070752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070762 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1070765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070784 */     // GIR_Coverage, 21964,
     /* 1070784 */     GIR_EraseRootFromParent_Done,
     /* 1070785 */   // Label 15812: @1070785
     /* 1070785 */   GIM_Try, /*On fail goto*//*Label 15813*/ GIMT_Encode4(1070862), // Rule ID 21965 //
     /* 1070790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1070801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1070804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1070807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070829 */     // MIs[0] policy
     /* 1070829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070839 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1070842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070861 */     // GIR_Coverage, 21965,
     /* 1070861 */     GIR_EraseRootFromParent_Done,
     /* 1070862 */   // Label 15813: @1070862
     /* 1070862 */   GIM_Try, /*On fail goto*//*Label 15814*/ GIMT_Encode4(1070939), // Rule ID 21968 //
     /* 1070867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1070878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1070881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070906 */     // MIs[0] policy
     /* 1070906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070916 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1070919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070938 */     // GIR_Coverage, 21968,
     /* 1070938 */     GIR_EraseRootFromParent_Done,
     /* 1070939 */   // Label 15814: @1070939
     /* 1070939 */   GIM_Try, /*On fail goto*//*Label 15815*/ GIMT_Encode4(1071016), // Rule ID 21969 //
     /* 1070944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1070955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1070958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070983 */     // MIs[0] policy
     /* 1070983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070993 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1070996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071002 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071015 */     // GIR_Coverage, 21969,
     /* 1071015 */     GIR_EraseRootFromParent_Done,
     /* 1071016 */   // Label 15815: @1071016
     /* 1071016 */   GIM_Try, /*On fail goto*//*Label 15816*/ GIMT_Encode4(1071093), // Rule ID 21972 //
     /* 1071021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1071024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1071032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1071035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1071038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071060 */     // MIs[0] policy
     /* 1071060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071070 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1071073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071092 */     // GIR_Coverage, 21972,
     /* 1071092 */     GIR_EraseRootFromParent_Done,
     /* 1071093 */   // Label 15816: @1071093
     /* 1071093 */   GIM_Try, /*On fail goto*//*Label 15817*/ GIMT_Encode4(1071170), // Rule ID 21973 //
     /* 1071098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1071101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1071109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1071112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1071115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071137 */     // MIs[0] policy
     /* 1071137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071147 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1071150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071156 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071169 */     // GIR_Coverage, 21973,
     /* 1071169 */     GIR_EraseRootFromParent_Done,
     /* 1071170 */   // Label 15817: @1071170
     /* 1071170 */   GIM_Try, /*On fail goto*//*Label 15818*/ GIMT_Encode4(1071247), // Rule ID 21976 //
     /* 1071175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1071178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1071186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1071189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1071192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071214 */     // MIs[0] policy
     /* 1071214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071224 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1071227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071246 */     // GIR_Coverage, 21976,
     /* 1071246 */     GIR_EraseRootFromParent_Done,
     /* 1071247 */   // Label 15818: @1071247
     /* 1071247 */   GIM_Try, /*On fail goto*//*Label 15819*/ GIMT_Encode4(1071324), // Rule ID 21977 //
     /* 1071252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1071255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1071263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1071266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1071269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071291 */     // MIs[0] policy
     /* 1071291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071301 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1071304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071310 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071323 */     // GIR_Coverage, 21977,
     /* 1071323 */     GIR_EraseRootFromParent_Done,
     /* 1071324 */   // Label 15819: @1071324
     /* 1071324 */   GIM_Try, /*On fail goto*//*Label 15820*/ GIMT_Encode4(1071401), // Rule ID 21980 //
     /* 1071329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1071332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1071340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1071343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1071346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1071349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071368 */     // MIs[0] policy
     /* 1071368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071378 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1071381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071400 */     // GIR_Coverage, 21980,
     /* 1071400 */     GIR_EraseRootFromParent_Done,
     /* 1071401 */   // Label 15820: @1071401
     /* 1071401 */   GIM_Try, /*On fail goto*//*Label 15821*/ GIMT_Encode4(1071478), // Rule ID 21981 //
     /* 1071406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1071409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1071417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1071420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1071423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1071426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071445 */     // MIs[0] policy
     /* 1071445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071455 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1071458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071464 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071477 */     // GIR_Coverage, 21981,
     /* 1071477 */     GIR_EraseRootFromParent_Done,
     /* 1071478 */   // Label 15821: @1071478
     /* 1071478 */   GIM_Try, /*On fail goto*//*Label 15822*/ GIMT_Encode4(1071555), // Rule ID 21984 //
     /* 1071483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1071500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071522 */     // MIs[0] policy
     /* 1071522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071532 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1071535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071554 */     // GIR_Coverage, 21984,
     /* 1071554 */     GIR_EraseRootFromParent_Done,
     /* 1071555 */   // Label 15822: @1071555
     /* 1071555 */   GIM_Try, /*On fail goto*//*Label 15823*/ GIMT_Encode4(1071632), // Rule ID 21985 //
     /* 1071560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1071577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071599 */     // MIs[0] policy
     /* 1071599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071609 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1071612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071618 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071631 */     // GIR_Coverage, 21985,
     /* 1071631 */     GIR_EraseRootFromParent_Done,
     /* 1071632 */   // Label 15823: @1071632
     /* 1071632 */   GIM_Try, /*On fail goto*//*Label 15824*/ GIMT_Encode4(1071709), // Rule ID 21988 //
     /* 1071637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1071648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1071651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1071654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071676 */     // MIs[0] policy
     /* 1071676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071686 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1071689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071708 */     // GIR_Coverage, 21988,
     /* 1071708 */     GIR_EraseRootFromParent_Done,
     /* 1071709 */   // Label 15824: @1071709
     /* 1071709 */   GIM_Try, /*On fail goto*//*Label 15825*/ GIMT_Encode4(1071786), // Rule ID 21989 //
     /* 1071714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1071725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1071728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1071731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071753 */     // MIs[0] policy
     /* 1071753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071763 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1071766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071785 */     // GIR_Coverage, 21989,
     /* 1071785 */     GIR_EraseRootFromParent_Done,
     /* 1071786 */   // Label 15825: @1071786
     /* 1071786 */   GIM_Try, /*On fail goto*//*Label 15826*/ GIMT_Encode4(1071863), // Rule ID 21992 //
     /* 1071791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1071808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071830 */     // MIs[0] policy
     /* 1071830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071840 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1071843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071862 */     // GIR_Coverage, 21992,
     /* 1071862 */     GIR_EraseRootFromParent_Done,
     /* 1071863 */   // Label 15826: @1071863
     /* 1071863 */   GIM_Try, /*On fail goto*//*Label 15827*/ GIMT_Encode4(1071940), // Rule ID 21993 //
     /* 1071868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1071885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071907 */     // MIs[0] policy
     /* 1071907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071917 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1071920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071926 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071939 */     // GIR_Coverage, 21993,
     /* 1071939 */     GIR_EraseRootFromParent_Done,
     /* 1071940 */   // Label 15827: @1071940
     /* 1071940 */   GIM_Try, /*On fail goto*//*Label 15828*/ GIMT_Encode4(1072017), // Rule ID 21996 //
     /* 1071945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1071962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071984 */     // MIs[0] policy
     /* 1071984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071994 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1071997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072003 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072016 */     // GIR_Coverage, 21996,
     /* 1072016 */     GIR_EraseRootFromParent_Done,
     /* 1072017 */   // Label 15828: @1072017
     /* 1072017 */   GIM_Try, /*On fail goto*//*Label 15829*/ GIMT_Encode4(1072094), // Rule ID 21997 //
     /* 1072022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1072025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1072030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1072033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1072036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1072039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1072049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072061 */     // MIs[0] policy
     /* 1072061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072071 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1072074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072080 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072093 */     // GIR_Coverage, 21997,
     /* 1072093 */     GIR_EraseRootFromParent_Done,
     /* 1072094 */   // Label 15829: @1072094
     /* 1072094 */   GIM_Try, /*On fail goto*//*Label 15830*/ GIMT_Encode4(1072171), // Rule ID 23436 //
     /* 1072099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1072110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1072113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072138 */     // MIs[0] policy
     /* 1072138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072148 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1072151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072170 */     // GIR_Coverage, 23436,
     /* 1072170 */     GIR_EraseRootFromParent_Done,
     /* 1072171 */   // Label 15830: @1072171
     /* 1072171 */   GIM_Try, /*On fail goto*//*Label 15831*/ GIMT_Encode4(1072248), // Rule ID 23437 //
     /* 1072176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1072187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1072190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072215 */     // MIs[0] policy
     /* 1072215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072225 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1072228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072234 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072247 */     // GIR_Coverage, 23437,
     /* 1072247 */     GIR_EraseRootFromParent_Done,
     /* 1072248 */   // Label 15831: @1072248
     /* 1072248 */   GIM_Try, /*On fail goto*//*Label 15832*/ GIMT_Encode4(1072325), // Rule ID 23440 //
     /* 1072253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1072264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1072267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1072270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072292 */     // MIs[0] policy
     /* 1072292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072302 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072324 */     // GIR_Coverage, 23440,
     /* 1072324 */     GIR_EraseRootFromParent_Done,
     /* 1072325 */   // Label 15832: @1072325
     /* 1072325 */   GIM_Try, /*On fail goto*//*Label 15833*/ GIMT_Encode4(1072402), // Rule ID 23441 //
     /* 1072330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1072341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1072344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1072347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072369 */     // MIs[0] policy
     /* 1072369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072379 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072388 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072401 */     // GIR_Coverage, 23441,
     /* 1072401 */     GIR_EraseRootFromParent_Done,
     /* 1072402 */   // Label 15833: @1072402
     /* 1072402 */   GIM_Try, /*On fail goto*//*Label 15834*/ GIMT_Encode4(1072479), // Rule ID 23444 //
     /* 1072407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1072418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1072421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072446 */     // MIs[0] policy
     /* 1072446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072456 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1072459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072478 */     // GIR_Coverage, 23444,
     /* 1072478 */     GIR_EraseRootFromParent_Done,
     /* 1072479 */   // Label 15834: @1072479
     /* 1072479 */   GIM_Try, /*On fail goto*//*Label 15835*/ GIMT_Encode4(1072556), // Rule ID 23445 //
     /* 1072484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1072495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1072498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072523 */     // MIs[0] policy
     /* 1072523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072533 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1072536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072542 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072555 */     // GIR_Coverage, 23445,
     /* 1072555 */     GIR_EraseRootFromParent_Done,
     /* 1072556 */   // Label 15835: @1072556
     /* 1072556 */   GIM_Try, /*On fail goto*//*Label 15836*/ GIMT_Encode4(1072633), // Rule ID 23448 //
     /* 1072561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1072572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1072575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072600 */     // MIs[0] policy
     /* 1072600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072610 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072632 */     // GIR_Coverage, 23448,
     /* 1072632 */     GIR_EraseRootFromParent_Done,
     /* 1072633 */   // Label 15836: @1072633
     /* 1072633 */   GIM_Try, /*On fail goto*//*Label 15837*/ GIMT_Encode4(1072710), // Rule ID 23449 //
     /* 1072638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1072649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1072652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072677 */     // MIs[0] policy
     /* 1072677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072687 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072696 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072709 */     // GIR_Coverage, 23449,
     /* 1072709 */     GIR_EraseRootFromParent_Done,
     /* 1072710 */   // Label 15837: @1072710
     /* 1072710 */   GIM_Try, /*On fail goto*//*Label 15838*/ GIMT_Encode4(1072787), // Rule ID 23452 //
     /* 1072715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1072726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1072729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072754 */     // MIs[0] policy
     /* 1072754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072764 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072786 */     // GIR_Coverage, 23452,
     /* 1072786 */     GIR_EraseRootFromParent_Done,
     /* 1072787 */   // Label 15838: @1072787
     /* 1072787 */   GIM_Try, /*On fail goto*//*Label 15839*/ GIMT_Encode4(1072864), // Rule ID 23453 //
     /* 1072792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1072803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1072806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072831 */     // MIs[0] policy
     /* 1072831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072841 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072850 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072863 */     // GIR_Coverage, 23453,
     /* 1072863 */     GIR_EraseRootFromParent_Done,
     /* 1072864 */   // Label 15839: @1072864
     /* 1072864 */   GIM_Try, /*On fail goto*//*Label 15840*/ GIMT_Encode4(1072941), // Rule ID 23456 //
     /* 1072869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1072880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1072883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1072886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072908 */     // MIs[0] policy
     /* 1072908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072918 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072940 */     // GIR_Coverage, 23456,
     /* 1072940 */     GIR_EraseRootFromParent_Done,
     /* 1072941 */   // Label 15840: @1072941
     /* 1072941 */   GIM_Try, /*On fail goto*//*Label 15841*/ GIMT_Encode4(1073018), // Rule ID 23457 //
     /* 1072946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1072957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1072960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1072963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072985 */     // MIs[0] policy
     /* 1072985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072995 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073017 */     // GIR_Coverage, 23457,
     /* 1073017 */     GIR_EraseRootFromParent_Done,
     /* 1073018 */   // Label 15841: @1073018
     /* 1073018 */   GIM_Try, /*On fail goto*//*Label 15842*/ GIMT_Encode4(1073095), // Rule ID 23460 //
     /* 1073023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1073034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1073037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1073040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073062 */     // MIs[0] policy
     /* 1073062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073072 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1073075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073094 */     // GIR_Coverage, 23460,
     /* 1073094 */     GIR_EraseRootFromParent_Done,
     /* 1073095 */   // Label 15842: @1073095
     /* 1073095 */   GIM_Try, /*On fail goto*//*Label 15843*/ GIMT_Encode4(1073172), // Rule ID 23461 //
     /* 1073100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1073111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1073114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1073117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073139 */     // MIs[0] policy
     /* 1073139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1073152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073171 */     // GIR_Coverage, 23461,
     /* 1073171 */     GIR_EraseRootFromParent_Done,
     /* 1073172 */   // Label 15843: @1073172
     /* 1073172 */   GIM_Try, /*On fail goto*//*Label 15844*/ GIMT_Encode4(1073249), // Rule ID 23464 //
     /* 1073177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1073188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1073191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1073194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1073197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073216 */     // MIs[0] policy
     /* 1073216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1073229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073248 */     // GIR_Coverage, 23464,
     /* 1073248 */     GIR_EraseRootFromParent_Done,
     /* 1073249 */   // Label 15844: @1073249
     /* 1073249 */   GIM_Try, /*On fail goto*//*Label 15845*/ GIMT_Encode4(1073326), // Rule ID 23465 //
     /* 1073254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1073265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1073268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1073271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1073274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073293 */     // MIs[0] policy
     /* 1073293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073303 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1073306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073312 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073325 */     // GIR_Coverage, 23465,
     /* 1073325 */     GIR_EraseRootFromParent_Done,
     /* 1073326 */   // Label 15845: @1073326
     /* 1073326 */   GIM_Try, /*On fail goto*//*Label 15846*/ GIMT_Encode4(1073403), // Rule ID 23468 //
     /* 1073331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1073334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1073342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1073345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1073348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1073351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073370 */     // MIs[0] policy
     /* 1073370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073380 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1073383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1073399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073402 */     // GIR_Coverage, 23468,
     /* 1073402 */     GIR_EraseRootFromParent_Done,
     /* 1073403 */   // Label 15846: @1073403
     /* 1073403 */   GIM_Try, /*On fail goto*//*Label 15847*/ GIMT_Encode4(1073480), // Rule ID 23469 //
     /* 1073408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1073411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1073419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1073422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1073425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1073428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073447 */     // MIs[0] policy
     /* 1073447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073457 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1073460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1073476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073479 */     // GIR_Coverage, 23469,
     /* 1073479 */     GIR_EraseRootFromParent_Done,
     /* 1073480 */   // Label 15847: @1073480
     /* 1073480 */   GIM_Try, /*On fail goto*//*Label 15848*/ GIMT_Encode4(1073557), // Rule ID 23472 //
     /* 1073485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1073496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1073499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073524 */     // MIs[0] policy
     /* 1073524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073534 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073556 */     // GIR_Coverage, 23472,
     /* 1073556 */     GIR_EraseRootFromParent_Done,
     /* 1073557 */   // Label 15848: @1073557
     /* 1073557 */   GIM_Try, /*On fail goto*//*Label 15849*/ GIMT_Encode4(1073634), // Rule ID 23473 //
     /* 1073562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1073573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1073576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073601 */     // MIs[0] policy
     /* 1073601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073611 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073633 */     // GIR_Coverage, 23473,
     /* 1073633 */     GIR_EraseRootFromParent_Done,
     /* 1073634 */   // Label 15849: @1073634
     /* 1073634 */   GIM_Try, /*On fail goto*//*Label 15850*/ GIMT_Encode4(1073711), // Rule ID 23476 //
     /* 1073639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1073650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1073653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073678 */     // MIs[0] policy
     /* 1073678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073688 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073710 */     // GIR_Coverage, 23476,
     /* 1073710 */     GIR_EraseRootFromParent_Done,
     /* 1073711 */   // Label 15850: @1073711
     /* 1073711 */   GIM_Try, /*On fail goto*//*Label 15851*/ GIMT_Encode4(1073788), // Rule ID 23477 //
     /* 1073716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1073727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1073730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073755 */     // MIs[0] policy
     /* 1073755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073765 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073774 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073787 */     // GIR_Coverage, 23477,
     /* 1073787 */     GIR_EraseRootFromParent_Done,
     /* 1073788 */   // Label 15851: @1073788
     /* 1073788 */   GIM_Try, /*On fail goto*//*Label 15852*/ GIMT_Encode4(1073865), // Rule ID 23480 //
     /* 1073793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1073804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1073807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1073810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1073813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073832 */     // MIs[0] policy
     /* 1073832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073842 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073864 */     // GIR_Coverage, 23480,
     /* 1073864 */     GIR_EraseRootFromParent_Done,
     /* 1073865 */   // Label 15852: @1073865
     /* 1073865 */   GIM_Try, /*On fail goto*//*Label 15853*/ GIMT_Encode4(1073942), // Rule ID 23481 //
     /* 1073870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1073881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1073884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1073887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1073890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073909 */     // MIs[0] policy
     /* 1073909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073919 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073928 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073941 */     // GIR_Coverage, 23481,
     /* 1073941 */     GIR_EraseRootFromParent_Done,
     /* 1073942 */   // Label 15853: @1073942
     /* 1073942 */   GIM_Try, /*On fail goto*//*Label 15854*/ GIMT_Encode4(1074019), // Rule ID 23484 //
     /* 1073947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1073958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1073961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1073964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073986 */     // MIs[0] policy
     /* 1073986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074018 */     // GIR_Coverage, 23484,
     /* 1074018 */     GIR_EraseRootFromParent_Done,
     /* 1074019 */   // Label 15854: @1074019
     /* 1074019 */   GIM_Try, /*On fail goto*//*Label 15855*/ GIMT_Encode4(1074096), // Rule ID 23485 //
     /* 1074024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1074035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1074038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074063 */     // MIs[0] policy
     /* 1074063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074073 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074082 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074095 */     // GIR_Coverage, 23485,
     /* 1074095 */     GIR_EraseRootFromParent_Done,
     /* 1074096 */   // Label 15855: @1074096
     /* 1074096 */   GIM_Try, /*On fail goto*//*Label 15856*/ GIMT_Encode4(1074173), // Rule ID 23488 //
     /* 1074101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1074112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1074115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1074118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074140 */     // MIs[0] policy
     /* 1074140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074150 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074172 */     // GIR_Coverage, 23488,
     /* 1074172 */     GIR_EraseRootFromParent_Done,
     /* 1074173 */   // Label 15856: @1074173
     /* 1074173 */   GIM_Try, /*On fail goto*//*Label 15857*/ GIMT_Encode4(1074250), // Rule ID 23489 //
     /* 1074178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1074189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1074192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1074195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074217 */     // MIs[0] policy
     /* 1074217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074227 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074249 */     // GIR_Coverage, 23489,
     /* 1074249 */     GIR_EraseRootFromParent_Done,
     /* 1074250 */   // Label 15857: @1074250
     /* 1074250 */   GIM_Try, /*On fail goto*//*Label 15858*/ GIMT_Encode4(1074327), // Rule ID 23492 //
     /* 1074255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1074266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1074269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1074272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1074275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074294 */     // MIs[0] policy
     /* 1074294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074304 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074326 */     // GIR_Coverage, 23492,
     /* 1074326 */     GIR_EraseRootFromParent_Done,
     /* 1074327 */   // Label 15858: @1074327
     /* 1074327 */   GIM_Try, /*On fail goto*//*Label 15859*/ GIMT_Encode4(1074404), // Rule ID 23493 //
     /* 1074332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1074343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1074346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1074349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1074352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074371 */     // MIs[0] policy
     /* 1074371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074381 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074390 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074403 */     // GIR_Coverage, 23493,
     /* 1074403 */     GIR_EraseRootFromParent_Done,
     /* 1074404 */   // Label 15859: @1074404
     /* 1074404 */   GIM_Try, /*On fail goto*//*Label 15860*/ GIMT_Encode4(1074481), // Rule ID 23496 //
     /* 1074409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1074420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1074423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1074426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074448 */     // MIs[0] policy
     /* 1074448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074480 */     // GIR_Coverage, 23496,
     /* 1074480 */     GIR_EraseRootFromParent_Done,
     /* 1074481 */   // Label 15860: @1074481
     /* 1074481 */   GIM_Try, /*On fail goto*//*Label 15861*/ GIMT_Encode4(1074558), // Rule ID 23497 //
     /* 1074486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1074497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1074500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1074503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074525 */     // MIs[0] policy
     /* 1074525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074535 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074557 */     // GIR_Coverage, 23497,
     /* 1074557 */     GIR_EraseRootFromParent_Done,
     /* 1074558 */   // Label 15861: @1074558
     /* 1074558 */   GIM_Try, /*On fail goto*//*Label 15862*/ GIMT_Encode4(1074635), // Rule ID 23500 //
     /* 1074563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1074574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1074577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074602 */     // MIs[0] policy
     /* 1074602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074612 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074634 */     // GIR_Coverage, 23500,
     /* 1074634 */     GIR_EraseRootFromParent_Done,
     /* 1074635 */   // Label 15862: @1074635
     /* 1074635 */   GIM_Try, /*On fail goto*//*Label 15863*/ GIMT_Encode4(1074712), // Rule ID 23501 //
     /* 1074640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1074651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1074654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074679 */     // MIs[0] policy
     /* 1074679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074689 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074711 */     // GIR_Coverage, 23501,
     /* 1074711 */     GIR_EraseRootFromParent_Done,
     /* 1074712 */   // Label 15863: @1074712
     /* 1074712 */   GIM_Try, /*On fail goto*//*Label 15864*/ GIMT_Encode4(1074789), // Rule ID 23504 //
     /* 1074717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1074728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1074731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1074734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074756 */     // MIs[0] policy
     /* 1074756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074766 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074788 */     // GIR_Coverage, 23504,
     /* 1074788 */     GIR_EraseRootFromParent_Done,
     /* 1074789 */   // Label 15864: @1074789
     /* 1074789 */   GIM_Try, /*On fail goto*//*Label 15865*/ GIMT_Encode4(1074866), // Rule ID 23505 //
     /* 1074794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1074805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1074808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1074811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074833 */     // MIs[0] policy
     /* 1074833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074843 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074865 */     // GIR_Coverage, 23505,
     /* 1074865 */     GIR_EraseRootFromParent_Done,
     /* 1074866 */   // Label 15865: @1074866
     /* 1074866 */   GIM_Try, /*On fail goto*//*Label 15866*/ GIMT_Encode4(1074943), // Rule ID 23508 //
     /* 1074871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1074874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1074882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1074885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1074888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1074891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074910 */     // MIs[0] policy
     /* 1074910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074920 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074942 */     // GIR_Coverage, 23508,
     /* 1074942 */     GIR_EraseRootFromParent_Done,
     /* 1074943 */   // Label 15866: @1074943
     /* 1074943 */   GIM_Try, /*On fail goto*//*Label 15867*/ GIMT_Encode4(1075020), // Rule ID 23509 //
     /* 1074948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1074951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1074959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1074962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1074965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1074968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074987 */     // MIs[0] policy
     /* 1074987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074997 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1075000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075006 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075019 */     // GIR_Coverage, 23509,
     /* 1075019 */     GIR_EraseRootFromParent_Done,
     /* 1075020 */   // Label 15867: @1075020
     /* 1075020 */   GIM_Try, /*On fail goto*//*Label 15868*/ GIMT_Encode4(1075097), // Rule ID 23512 //
     /* 1075025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1075028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1075036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1075039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1075042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1075045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1075052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075064 */     // MIs[0] policy
     /* 1075064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075074 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1075077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075096 */     // GIR_Coverage, 23512,
     /* 1075096 */     GIR_EraseRootFromParent_Done,
     /* 1075097 */   // Label 15868: @1075097
     /* 1075097 */   GIM_Try, /*On fail goto*//*Label 15869*/ GIMT_Encode4(1075174), // Rule ID 23513 //
     /* 1075102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1075105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1075113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1075116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1075119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1075122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1075129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075141 */     // MIs[0] policy
     /* 1075141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075151 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1075154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075160 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075173 */     // GIR_Coverage, 23513,
     /* 1075173 */     GIR_EraseRootFromParent_Done,
     /* 1075174 */   // Label 15869: @1075174
     /* 1075174 */   GIM_Try, /*On fail goto*//*Label 15870*/ GIMT_Encode4(1075251), // Rule ID 23516 //
     /* 1075179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1075182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1075190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1075193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1075196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1075199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1075206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075218 */     // MIs[0] policy
     /* 1075218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075228 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1075231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075250 */     // GIR_Coverage, 23516,
     /* 1075250 */     GIR_EraseRootFromParent_Done,
     /* 1075251 */   // Label 15870: @1075251
     /* 1075251 */   GIM_Try, /*On fail goto*//*Label 15871*/ GIMT_Encode4(1075328), // Rule ID 23517 //
     /* 1075256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1075259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1075267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1075270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1075273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1075276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1075283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075295 */     // MIs[0] policy
     /* 1075295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075305 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1075308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075314 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075327 */     // GIR_Coverage, 23517,
     /* 1075327 */     GIR_EraseRootFromParent_Done,
     /* 1075328 */   // Label 15871: @1075328
     /* 1075328 */   GIM_Try, /*On fail goto*//*Label 15872*/ GIMT_Encode4(1075405), // Rule ID 23622 //
     /* 1075333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1075344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1075347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1075350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075372 */     // MIs[0] policy
     /* 1075372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075382 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1075385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075404 */     // GIR_Coverage, 23622,
     /* 1075404 */     GIR_EraseRootFromParent_Done,
     /* 1075405 */   // Label 15872: @1075405
     /* 1075405 */   GIM_Try, /*On fail goto*//*Label 15873*/ GIMT_Encode4(1075482), // Rule ID 23623 //
     /* 1075410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1075421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1075424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1075427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075449 */     // MIs[0] policy
     /* 1075449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075459 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1075462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075481 */     // GIR_Coverage, 23623,
     /* 1075481 */     GIR_EraseRootFromParent_Done,
     /* 1075482 */   // Label 15873: @1075482
     /* 1075482 */   GIM_Try, /*On fail goto*//*Label 15874*/ GIMT_Encode4(1075559), // Rule ID 23626 //
     /* 1075487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1075498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1075501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1075504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075526 */     // MIs[0] policy
     /* 1075526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075536 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075558 */     // GIR_Coverage, 23626,
     /* 1075558 */     GIR_EraseRootFromParent_Done,
     /* 1075559 */   // Label 15874: @1075559
     /* 1075559 */   GIM_Try, /*On fail goto*//*Label 15875*/ GIMT_Encode4(1075636), // Rule ID 23627 //
     /* 1075564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1075575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1075578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1075581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075603 */     // MIs[0] policy
     /* 1075603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075613 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075635 */     // GIR_Coverage, 23627,
     /* 1075635 */     GIR_EraseRootFromParent_Done,
     /* 1075636 */   // Label 15875: @1075636
     /* 1075636 */   GIM_Try, /*On fail goto*//*Label 15876*/ GIMT_Encode4(1075713), // Rule ID 23630 //
     /* 1075641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1075652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1075655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1075658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075680 */     // MIs[0] policy
     /* 1075680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075690 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075712 */     // GIR_Coverage, 23630,
     /* 1075712 */     GIR_EraseRootFromParent_Done,
     /* 1075713 */   // Label 15876: @1075713
     /* 1075713 */   GIM_Try, /*On fail goto*//*Label 15877*/ GIMT_Encode4(1075790), // Rule ID 23631 //
     /* 1075718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1075729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1075732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1075735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075757 */     // MIs[0] policy
     /* 1075757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075767 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075789 */     // GIR_Coverage, 23631,
     /* 1075789 */     GIR_EraseRootFromParent_Done,
     /* 1075790 */   // Label 15877: @1075790
     /* 1075790 */   GIM_Try, /*On fail goto*//*Label 15878*/ GIMT_Encode4(1075867), // Rule ID 23634 //
     /* 1075795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1075806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1075809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1075812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075834 */     // MIs[0] policy
     /* 1075834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075844 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075866 */     // GIR_Coverage, 23634,
     /* 1075866 */     GIR_EraseRootFromParent_Done,
     /* 1075867 */   // Label 15878: @1075867
     /* 1075867 */   GIM_Try, /*On fail goto*//*Label 15879*/ GIMT_Encode4(1075944), // Rule ID 23635 //
     /* 1075872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1075883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1075886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1075889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075911 */     // MIs[0] policy
     /* 1075911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075921 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075943 */     // GIR_Coverage, 23635,
     /* 1075943 */     GIR_EraseRootFromParent_Done,
     /* 1075944 */   // Label 15879: @1075944
     /* 1075944 */   GIM_Try, /*On fail goto*//*Label 15880*/ GIMT_Encode4(1076021), // Rule ID 23638 //
     /* 1075949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1075960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1075963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1075966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075988 */     // MIs[0] policy
     /* 1075988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075998 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1076001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076020 */     // GIR_Coverage, 23638,
     /* 1076020 */     GIR_EraseRootFromParent_Done,
     /* 1076021 */   // Label 15880: @1076021
     /* 1076021 */   GIM_Try, /*On fail goto*//*Label 15881*/ GIMT_Encode4(1076098), // Rule ID 23639 //
     /* 1076026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1076037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1076040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1076043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076065 */     // MIs[0] policy
     /* 1076065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076075 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1076078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076097 */     // GIR_Coverage, 23639,
     /* 1076097 */     GIR_EraseRootFromParent_Done,
     /* 1076098 */   // Label 15881: @1076098
     /* 1076098 */   GIM_Try, /*On fail goto*//*Label 15882*/ GIMT_Encode4(1076175), // Rule ID 23642 //
     /* 1076103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1076114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1076117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1076120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076142 */     // MIs[0] policy
     /* 1076142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076152 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1076155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076174 */     // GIR_Coverage, 23642,
     /* 1076174 */     GIR_EraseRootFromParent_Done,
     /* 1076175 */   // Label 15882: @1076175
     /* 1076175 */   GIM_Try, /*On fail goto*//*Label 15883*/ GIMT_Encode4(1076252), // Rule ID 23643 //
     /* 1076180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1076191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1076194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1076197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076219 */     // MIs[0] policy
     /* 1076219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076229 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1076232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076251 */     // GIR_Coverage, 23643,
     /* 1076251 */     GIR_EraseRootFromParent_Done,
     /* 1076252 */   // Label 15883: @1076252
     /* 1076252 */   GIM_Try, /*On fail goto*//*Label 15884*/ GIMT_Encode4(1076329), // Rule ID 23646 //
     /* 1076257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1076268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1076271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1076274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076296 */     // MIs[0] policy
     /* 1076296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076306 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076328 */     // GIR_Coverage, 23646,
     /* 1076328 */     GIR_EraseRootFromParent_Done,
     /* 1076329 */   // Label 15884: @1076329
     /* 1076329 */   GIM_Try, /*On fail goto*//*Label 15885*/ GIMT_Encode4(1076406), // Rule ID 23647 //
     /* 1076334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1076345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1076348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1076351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076373 */     // MIs[0] policy
     /* 1076373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076383 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076405 */     // GIR_Coverage, 23647,
     /* 1076405 */     GIR_EraseRootFromParent_Done,
     /* 1076406 */   // Label 15885: @1076406
     /* 1076406 */   GIM_Try, /*On fail goto*//*Label 15886*/ GIMT_Encode4(1076483), // Rule ID 23650 //
     /* 1076411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1076422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1076425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1076428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076450 */     // MIs[0] policy
     /* 1076450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076460 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076482 */     // GIR_Coverage, 23650,
     /* 1076482 */     GIR_EraseRootFromParent_Done,
     /* 1076483 */   // Label 15886: @1076483
     /* 1076483 */   GIM_Try, /*On fail goto*//*Label 15887*/ GIMT_Encode4(1076560), // Rule ID 23651 //
     /* 1076488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1076499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1076502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1076505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076527 */     // MIs[0] policy
     /* 1076527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076537 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076559 */     // GIR_Coverage, 23651,
     /* 1076559 */     GIR_EraseRootFromParent_Done,
     /* 1076560 */   // Label 15887: @1076560
     /* 1076560 */   GIM_Try, /*On fail goto*//*Label 15888*/ GIMT_Encode4(1076637), // Rule ID 23654 //
     /* 1076565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1076576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1076579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1076582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076604 */     // MIs[0] policy
     /* 1076604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076614 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076636 */     // GIR_Coverage, 23654,
     /* 1076636 */     GIR_EraseRootFromParent_Done,
     /* 1076637 */   // Label 15888: @1076637
     /* 1076637 */   GIM_Try, /*On fail goto*//*Label 15889*/ GIMT_Encode4(1076714), // Rule ID 23655 //
     /* 1076642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1076653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1076656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1076659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076681 */     // MIs[0] policy
     /* 1076681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076691 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076713 */     // GIR_Coverage, 23655,
     /* 1076713 */     GIR_EraseRootFromParent_Done,
     /* 1076714 */   // Label 15889: @1076714
     /* 1076714 */   GIM_Try, /*On fail goto*//*Label 15890*/ GIMT_Encode4(1076791), // Rule ID 23658 //
     /* 1076719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1076722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1076730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1076733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1076736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076758 */     // MIs[0] policy
     /* 1076758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076790 */     // GIR_Coverage, 23658,
     /* 1076790 */     GIR_EraseRootFromParent_Done,
     /* 1076791 */   // Label 15890: @1076791
     /* 1076791 */   GIM_Try, /*On fail goto*//*Label 15891*/ GIMT_Encode4(1076868), // Rule ID 23659 //
     /* 1076796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1076799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1076807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1076810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1076813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076835 */     // MIs[0] policy
     /* 1076835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076845 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076867 */     // GIR_Coverage, 23659,
     /* 1076867 */     GIR_EraseRootFromParent_Done,
     /* 1076868 */   // Label 15891: @1076868
     /* 1076868 */   GIM_Try, /*On fail goto*//*Label 15892*/ GIMT_Encode4(1076945), // Rule ID 23662 //
     /* 1076873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1076884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1076887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1076890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076912 */     // MIs[0] policy
     /* 1076912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076922 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076944 */     // GIR_Coverage, 23662,
     /* 1076944 */     GIR_EraseRootFromParent_Done,
     /* 1076945 */   // Label 15892: @1076945
     /* 1076945 */   GIM_Try, /*On fail goto*//*Label 15893*/ GIMT_Encode4(1077022), // Rule ID 23663 //
     /* 1076950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1076961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1076964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1076967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076989 */     // MIs[0] policy
     /* 1076989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076999 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077021 */     // GIR_Coverage, 23663,
     /* 1077021 */     GIR_EraseRootFromParent_Done,
     /* 1077022 */   // Label 15893: @1077022
     /* 1077022 */   GIM_Try, /*On fail goto*//*Label 15894*/ GIMT_Encode4(1077099), // Rule ID 23666 //
     /* 1077027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1077038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1077041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1077044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077066 */     // MIs[0] policy
     /* 1077066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077076 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077098 */     // GIR_Coverage, 23666,
     /* 1077098 */     GIR_EraseRootFromParent_Done,
     /* 1077099 */   // Label 15894: @1077099
     /* 1077099 */   GIM_Try, /*On fail goto*//*Label 15895*/ GIMT_Encode4(1077176), // Rule ID 23667 //
     /* 1077104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1077115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1077118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1077121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077143 */     // MIs[0] policy
     /* 1077143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077153 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077175 */     // GIR_Coverage, 23667,
     /* 1077175 */     GIR_EraseRootFromParent_Done,
     /* 1077176 */   // Label 15895: @1077176
     /* 1077176 */   GIM_Try, /*On fail goto*//*Label 15896*/ GIMT_Encode4(1077253), // Rule ID 23670 //
     /* 1077181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1077192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1077195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1077198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077220 */     // MIs[0] policy
     /* 1077220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077230 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077252 */     // GIR_Coverage, 23670,
     /* 1077252 */     GIR_EraseRootFromParent_Done,
     /* 1077253 */   // Label 15896: @1077253
     /* 1077253 */   GIM_Try, /*On fail goto*//*Label 15897*/ GIMT_Encode4(1077330), // Rule ID 23671 //
     /* 1077258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1077269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1077272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1077275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077297 */     // MIs[0] policy
     /* 1077297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077307 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077329 */     // GIR_Coverage, 23671,
     /* 1077329 */     GIR_EraseRootFromParent_Done,
     /* 1077330 */   // Label 15897: @1077330
     /* 1077330 */   GIM_Try, /*On fail goto*//*Label 15898*/ GIMT_Encode4(1077407), // Rule ID 23674 //
     /* 1077335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1077346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1077349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1077352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077374 */     // MIs[0] policy
     /* 1077374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077406 */     // GIR_Coverage, 23674,
     /* 1077406 */     GIR_EraseRootFromParent_Done,
     /* 1077407 */   // Label 15898: @1077407
     /* 1077407 */   GIM_Try, /*On fail goto*//*Label 15899*/ GIMT_Encode4(1077484), // Rule ID 23675 //
     /* 1077412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1077423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1077426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1077429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077451 */     // MIs[0] policy
     /* 1077451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077461 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077483 */     // GIR_Coverage, 23675,
     /* 1077483 */     GIR_EraseRootFromParent_Done,
     /* 1077484 */   // Label 15899: @1077484
     /* 1077484 */   GIM_Try, /*On fail goto*//*Label 15900*/ GIMT_Encode4(1077561), // Rule ID 23678 //
     /* 1077489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1077500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1077503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1077506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077528 */     // MIs[0] policy
     /* 1077528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077538 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077560 */     // GIR_Coverage, 23678,
     /* 1077560 */     GIR_EraseRootFromParent_Done,
     /* 1077561 */   // Label 15900: @1077561
     /* 1077561 */   GIM_Try, /*On fail goto*//*Label 15901*/ GIMT_Encode4(1077638), // Rule ID 23679 //
     /* 1077566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1077577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1077580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1077583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077605 */     // MIs[0] policy
     /* 1077605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077615 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077637 */     // GIR_Coverage, 23679,
     /* 1077637 */     GIR_EraseRootFromParent_Done,
     /* 1077638 */   // Label 15901: @1077638
     /* 1077638 */   GIM_Try, /*On fail goto*//*Label 15902*/ GIMT_Encode4(1077715), // Rule ID 23682 //
     /* 1077643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1077654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1077657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1077660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077682 */     // MIs[0] policy
     /* 1077682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077692 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077714 */     // GIR_Coverage, 23682,
     /* 1077714 */     GIR_EraseRootFromParent_Done,
     /* 1077715 */   // Label 15902: @1077715
     /* 1077715 */   GIM_Try, /*On fail goto*//*Label 15903*/ GIMT_Encode4(1077792), // Rule ID 23683 //
     /* 1077720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1077731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1077734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1077737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077759 */     // MIs[0] policy
     /* 1077759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077769 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077791 */     // GIR_Coverage, 23683,
     /* 1077791 */     GIR_EraseRootFromParent_Done,
     /* 1077792 */   // Label 15903: @1077792
     /* 1077792 */   GIM_Try, /*On fail goto*//*Label 15904*/ GIMT_Encode4(1077869), // Rule ID 23686 //
     /* 1077797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1077808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1077811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1077814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077836 */     // MIs[0] policy
     /* 1077836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077846 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077868 */     // GIR_Coverage, 23686,
     /* 1077868 */     GIR_EraseRootFromParent_Done,
     /* 1077869 */   // Label 15904: @1077869
     /* 1077869 */   GIM_Try, /*On fail goto*//*Label 15905*/ GIMT_Encode4(1077946), // Rule ID 23687 //
     /* 1077874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1077885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1077888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1077891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077913 */     // MIs[0] policy
     /* 1077913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077923 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077945 */     // GIR_Coverage, 23687,
     /* 1077945 */     GIR_EraseRootFromParent_Done,
     /* 1077946 */   // Label 15905: @1077946
     /* 1077946 */   GIM_Try, /*On fail goto*//*Label 15906*/ GIMT_Encode4(1078023), // Rule ID 23690 //
     /* 1077951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1077962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1077965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1077968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077990 */     // MIs[0] policy
     /* 1077990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078000 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1078003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078022 */     // GIR_Coverage, 23690,
     /* 1078022 */     GIR_EraseRootFromParent_Done,
     /* 1078023 */   // Label 15906: @1078023
     /* 1078023 */   GIM_Try, /*On fail goto*//*Label 15907*/ GIMT_Encode4(1078100), // Rule ID 23691 //
     /* 1078028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1078039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1078042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1078045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078067 */     // MIs[0] policy
     /* 1078067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078077 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1078080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078099 */     // GIR_Coverage, 23691,
     /* 1078099 */     GIR_EraseRootFromParent_Done,
     /* 1078100 */   // Label 15907: @1078100
     /* 1078100 */   GIM_Try, /*On fail goto*//*Label 15908*/ GIMT_Encode4(1078177), // Rule ID 23694 //
     /* 1078105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1078116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1078119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1078122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078144 */     // MIs[0] policy
     /* 1078144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078154 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1078157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078176 */     // GIR_Coverage, 23694,
     /* 1078176 */     GIR_EraseRootFromParent_Done,
     /* 1078177 */   // Label 15908: @1078177
     /* 1078177 */   GIM_Try, /*On fail goto*//*Label 15909*/ GIMT_Encode4(1078254), // Rule ID 23695 //
     /* 1078182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1078193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1078196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1078199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078221 */     // MIs[0] policy
     /* 1078221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078231 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1078234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078253 */     // GIR_Coverage, 23695,
     /* 1078253 */     GIR_EraseRootFromParent_Done,
     /* 1078254 */   // Label 15909: @1078254
     /* 1078254 */   GIM_Try, /*On fail goto*//*Label 15910*/ GIMT_Encode4(1078331), // Rule ID 23698 //
     /* 1078259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1078270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1078273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1078276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078298 */     // MIs[0] policy
     /* 1078298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078308 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1078311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078330 */     // GIR_Coverage, 23698,
     /* 1078330 */     GIR_EraseRootFromParent_Done,
     /* 1078331 */   // Label 15910: @1078331
     /* 1078331 */   GIM_Try, /*On fail goto*//*Label 15911*/ GIMT_Encode4(1078408), // Rule ID 23699 //
     /* 1078336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1078347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1078350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1078353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078375 */     // MIs[0] policy
     /* 1078375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078385 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1078388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078407 */     // GIR_Coverage, 23699,
     /* 1078407 */     GIR_EraseRootFromParent_Done,
     /* 1078408 */   // Label 15911: @1078408
     /* 1078408 */   GIM_Try, /*On fail goto*//*Label 15912*/ GIMT_Encode4(1078485), // Rule ID 23702 //
     /* 1078413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1078424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1078427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1078430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078452 */     // MIs[0] policy
     /* 1078452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078462 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1078465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078484 */     // GIR_Coverage, 23702,
     /* 1078484 */     GIR_EraseRootFromParent_Done,
     /* 1078485 */   // Label 15912: @1078485
     /* 1078485 */   GIM_Try, /*On fail goto*//*Label 15913*/ GIMT_Encode4(1078562), // Rule ID 23703 //
     /* 1078490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1078501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1078504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1078507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078529 */     // MIs[0] policy
     /* 1078529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078539 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1078542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078561 */     // GIR_Coverage, 23703,
     /* 1078561 */     GIR_EraseRootFromParent_Done,
     /* 1078562 */   // Label 15913: @1078562
     /* 1078562 */   GIM_Try, /*On fail goto*//*Label 15914*/ GIMT_Encode4(1078639), // Rule ID 23706 //
     /* 1078567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1078578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1078581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1078584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078606 */     // MIs[0] policy
     /* 1078606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078616 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1078619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078638 */     // GIR_Coverage, 23706,
     /* 1078638 */     GIR_EraseRootFromParent_Done,
     /* 1078639 */   // Label 15914: @1078639
     /* 1078639 */   GIM_Try, /*On fail goto*//*Label 15915*/ GIMT_Encode4(1078716), // Rule ID 23707 //
     /* 1078644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1078655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1078658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1078661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078683 */     // MIs[0] policy
     /* 1078683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078693 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1078696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078715 */     // GIR_Coverage, 23707,
     /* 1078715 */     GIR_EraseRootFromParent_Done,
     /* 1078716 */   // Label 15915: @1078716
     /* 1078716 */   GIM_Try, /*On fail goto*//*Label 15916*/ GIMT_Encode4(1078793), // Rule ID 23798 //
     /* 1078721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1078732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1078735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1078738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078760 */     // MIs[0] policy
     /* 1078760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078770 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1078773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078792 */     // GIR_Coverage, 23798,
     /* 1078792 */     GIR_EraseRootFromParent_Done,
     /* 1078793 */   // Label 15916: @1078793
     /* 1078793 */   GIM_Try, /*On fail goto*//*Label 15917*/ GIMT_Encode4(1078870), // Rule ID 23799 //
     /* 1078798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1078809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1078812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1078815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078837 */     // MIs[0] policy
     /* 1078837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078847 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1078850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078869 */     // GIR_Coverage, 23799,
     /* 1078869 */     GIR_EraseRootFromParent_Done,
     /* 1078870 */   // Label 15917: @1078870
     /* 1078870 */   GIM_Try, /*On fail goto*//*Label 15918*/ GIMT_Encode4(1078947), // Rule ID 23802 //
     /* 1078875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1078886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1078889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1078892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078914 */     // MIs[0] policy
     /* 1078914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078924 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078946 */     // GIR_Coverage, 23802,
     /* 1078946 */     GIR_EraseRootFromParent_Done,
     /* 1078947 */   // Label 15918: @1078947
     /* 1078947 */   GIM_Try, /*On fail goto*//*Label 15919*/ GIMT_Encode4(1079024), // Rule ID 23803 //
     /* 1078952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1078963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1078966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1078969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078991 */     // MIs[0] policy
     /* 1078991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079001 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1079004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079023 */     // GIR_Coverage, 23803,
     /* 1079023 */     GIR_EraseRootFromParent_Done,
     /* 1079024 */   // Label 15919: @1079024
     /* 1079024 */   GIM_Try, /*On fail goto*//*Label 15920*/ GIMT_Encode4(1079101), // Rule ID 23806 //
     /* 1079029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1079040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1079043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1079046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079068 */     // MIs[0] policy
     /* 1079068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079078 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079100 */     // GIR_Coverage, 23806,
     /* 1079100 */     GIR_EraseRootFromParent_Done,
     /* 1079101 */   // Label 15920: @1079101
     /* 1079101 */   GIM_Try, /*On fail goto*//*Label 15921*/ GIMT_Encode4(1079178), // Rule ID 23807 //
     /* 1079106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1079117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1079120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1079123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079145 */     // MIs[0] policy
     /* 1079145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079155 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079177 */     // GIR_Coverage, 23807,
     /* 1079177 */     GIR_EraseRootFromParent_Done,
     /* 1079178 */   // Label 15921: @1079178
     /* 1079178 */   GIM_Try, /*On fail goto*//*Label 15922*/ GIMT_Encode4(1079255), // Rule ID 23810 //
     /* 1079183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1079194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1079197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1079200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079222 */     // MIs[0] policy
     /* 1079222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079232 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1079235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079254 */     // GIR_Coverage, 23810,
     /* 1079254 */     GIR_EraseRootFromParent_Done,
     /* 1079255 */   // Label 15922: @1079255
     /* 1079255 */   GIM_Try, /*On fail goto*//*Label 15923*/ GIMT_Encode4(1079332), // Rule ID 23811 //
     /* 1079260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1079271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1079274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1079277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079299 */     // MIs[0] policy
     /* 1079299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079309 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1079312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079331 */     // GIR_Coverage, 23811,
     /* 1079331 */     GIR_EraseRootFromParent_Done,
     /* 1079332 */   // Label 15923: @1079332
     /* 1079332 */   GIM_Try, /*On fail goto*//*Label 15924*/ GIMT_Encode4(1079409), // Rule ID 23814 //
     /* 1079337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1079348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1079351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1079354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079376 */     // MIs[0] policy
     /* 1079376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079408 */     // GIR_Coverage, 23814,
     /* 1079408 */     GIR_EraseRootFromParent_Done,
     /* 1079409 */   // Label 15924: @1079409
     /* 1079409 */   GIM_Try, /*On fail goto*//*Label 15925*/ GIMT_Encode4(1079486), // Rule ID 23815 //
     /* 1079414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1079425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1079428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1079431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079453 */     // MIs[0] policy
     /* 1079453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079463 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079485 */     // GIR_Coverage, 23815,
     /* 1079485 */     GIR_EraseRootFromParent_Done,
     /* 1079486 */   // Label 15925: @1079486
     /* 1079486 */   GIM_Try, /*On fail goto*//*Label 15926*/ GIMT_Encode4(1079563), // Rule ID 23818 //
     /* 1079491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1079502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1079505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1079508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079530 */     // MIs[0] policy
     /* 1079530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079540 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079562 */     // GIR_Coverage, 23818,
     /* 1079562 */     GIR_EraseRootFromParent_Done,
     /* 1079563 */   // Label 15926: @1079563
     /* 1079563 */   GIM_Try, /*On fail goto*//*Label 15927*/ GIMT_Encode4(1079640), // Rule ID 23819 //
     /* 1079568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1079579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1079582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1079585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079607 */     // MIs[0] policy
     /* 1079607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079617 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079639 */     // GIR_Coverage, 23819,
     /* 1079639 */     GIR_EraseRootFromParent_Done,
     /* 1079640 */   // Label 15927: @1079640
     /* 1079640 */   GIM_Try, /*On fail goto*//*Label 15928*/ GIMT_Encode4(1079717), // Rule ID 23822 //
     /* 1079645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1079656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1079659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1079662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079684 */     // MIs[0] policy
     /* 1079684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079694 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079716 */     // GIR_Coverage, 23822,
     /* 1079716 */     GIR_EraseRootFromParent_Done,
     /* 1079717 */   // Label 15928: @1079717
     /* 1079717 */   GIM_Try, /*On fail goto*//*Label 15929*/ GIMT_Encode4(1079794), // Rule ID 23823 //
     /* 1079722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1079733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1079736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1079739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079761 */     // MIs[0] policy
     /* 1079761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079771 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079793 */     // GIR_Coverage, 23823,
     /* 1079793 */     GIR_EraseRootFromParent_Done,
     /* 1079794 */   // Label 15929: @1079794
     /* 1079794 */   GIM_Try, /*On fail goto*//*Label 15930*/ GIMT_Encode4(1079871), // Rule ID 23826 //
     /* 1079799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1079810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1079813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079838 */     // MIs[0] policy
     /* 1079838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079848 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079870 */     // GIR_Coverage, 23826,
     /* 1079870 */     GIR_EraseRootFromParent_Done,
     /* 1079871 */   // Label 15930: @1079871
     /* 1079871 */   GIM_Try, /*On fail goto*//*Label 15931*/ GIMT_Encode4(1079948), // Rule ID 23827 //
     /* 1079876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1079887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1079890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079915 */     // MIs[0] policy
     /* 1079915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079925 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079947 */     // GIR_Coverage, 23827,
     /* 1079947 */     GIR_EraseRootFromParent_Done,
     /* 1079948 */   // Label 15931: @1079948
     /* 1079948 */   GIM_Try, /*On fail goto*//*Label 15932*/ GIMT_Encode4(1080025), // Rule ID 23830 //
     /* 1079953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1079964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1079967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1079970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079992 */     // MIs[0] policy
     /* 1079992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1080005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080024 */     // GIR_Coverage, 23830,
     /* 1080024 */     GIR_EraseRootFromParent_Done,
     /* 1080025 */   // Label 15932: @1080025
     /* 1080025 */   GIM_Try, /*On fail goto*//*Label 15933*/ GIMT_Encode4(1080102), // Rule ID 23831 //
     /* 1080030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1080041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1080044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1080047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080069 */     // MIs[0] policy
     /* 1080069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080079 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1080082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080101 */     // GIR_Coverage, 23831,
     /* 1080101 */     GIR_EraseRootFromParent_Done,
     /* 1080102 */   // Label 15933: @1080102
     /* 1080102 */   GIM_Try, /*On fail goto*//*Label 15934*/ GIMT_Encode4(1080179), // Rule ID 23834 //
     /* 1080107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1080110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1080118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1080121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1080124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080146 */     // MIs[0] policy
     /* 1080146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080156 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1080159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1080175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080178 */     // GIR_Coverage, 23834,
     /* 1080178 */     GIR_EraseRootFromParent_Done,
     /* 1080179 */   // Label 15934: @1080179
     /* 1080179 */   GIM_Try, /*On fail goto*//*Label 15935*/ GIMT_Encode4(1080256), // Rule ID 23835 //
     /* 1080184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1080187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1080195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1080198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1080201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080223 */     // MIs[0] policy
     /* 1080223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080233 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1080236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1080252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080255 */     // GIR_Coverage, 23835,
     /* 1080255 */     GIR_EraseRootFromParent_Done,
     /* 1080256 */   // Label 15935: @1080256
     /* 1080256 */   GIM_Try, /*On fail goto*//*Label 15936*/ GIMT_Encode4(1080333), // Rule ID 23838 //
     /* 1080261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1080272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1080275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1080278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080300 */     // MIs[0] policy
     /* 1080300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080310 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080332 */     // GIR_Coverage, 23838,
     /* 1080332 */     GIR_EraseRootFromParent_Done,
     /* 1080333 */   // Label 15936: @1080333
     /* 1080333 */   GIM_Try, /*On fail goto*//*Label 15937*/ GIMT_Encode4(1080410), // Rule ID 23839 //
     /* 1080338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1080349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1080352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1080355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080377 */     // MIs[0] policy
     /* 1080377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080387 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080409 */     // GIR_Coverage, 23839,
     /* 1080409 */     GIR_EraseRootFromParent_Done,
     /* 1080410 */   // Label 15937: @1080410
     /* 1080410 */   GIM_Try, /*On fail goto*//*Label 15938*/ GIMT_Encode4(1080487), // Rule ID 23842 //
     /* 1080415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1080426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1080429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1080432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080454 */     // MIs[0] policy
     /* 1080454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080464 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080486 */     // GIR_Coverage, 23842,
     /* 1080486 */     GIR_EraseRootFromParent_Done,
     /* 1080487 */   // Label 15938: @1080487
     /* 1080487 */   GIM_Try, /*On fail goto*//*Label 15939*/ GIMT_Encode4(1080564), // Rule ID 23843 //
     /* 1080492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1080503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1080506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1080509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080531 */     // MIs[0] policy
     /* 1080531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080541 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080563 */     // GIR_Coverage, 23843,
     /* 1080563 */     GIR_EraseRootFromParent_Done,
     /* 1080564 */   // Label 15939: @1080564
     /* 1080564 */   GIM_Try, /*On fail goto*//*Label 15940*/ GIMT_Encode4(1080641), // Rule ID 23846 //
     /* 1080569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1080580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1080583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1080586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080608 */     // MIs[0] policy
     /* 1080608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080618 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080640 */     // GIR_Coverage, 23846,
     /* 1080640 */     GIR_EraseRootFromParent_Done,
     /* 1080641 */   // Label 15940: @1080641
     /* 1080641 */   GIM_Try, /*On fail goto*//*Label 15941*/ GIMT_Encode4(1080718), // Rule ID 23847 //
     /* 1080646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1080657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1080660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1080663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080685 */     // MIs[0] policy
     /* 1080685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080695 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080717 */     // GIR_Coverage, 23847,
     /* 1080717 */     GIR_EraseRootFromParent_Done,
     /* 1080718 */   // Label 15941: @1080718
     /* 1080718 */   GIM_Try, /*On fail goto*//*Label 15942*/ GIMT_Encode4(1080795), // Rule ID 23850 //
     /* 1080723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1080734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1080737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080762 */     // MIs[0] policy
     /* 1080762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080772 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080794 */     // GIR_Coverage, 23850,
     /* 1080794 */     GIR_EraseRootFromParent_Done,
     /* 1080795 */   // Label 15942: @1080795
     /* 1080795 */   GIM_Try, /*On fail goto*//*Label 15943*/ GIMT_Encode4(1080872), // Rule ID 23851 //
     /* 1080800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1080811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1080814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080839 */     // MIs[0] policy
     /* 1080839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080849 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080871 */     // GIR_Coverage, 23851,
     /* 1080871 */     GIR_EraseRootFromParent_Done,
     /* 1080872 */   // Label 15943: @1080872
     /* 1080872 */   GIM_Try, /*On fail goto*//*Label 15944*/ GIMT_Encode4(1080949), // Rule ID 23854 //
     /* 1080877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1080888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1080891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080916 */     // MIs[0] policy
     /* 1080916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080948 */     // GIR_Coverage, 23854,
     /* 1080948 */     GIR_EraseRootFromParent_Done,
     /* 1080949 */   // Label 15944: @1080949
     /* 1080949 */   GIM_Try, /*On fail goto*//*Label 15945*/ GIMT_Encode4(1081026), // Rule ID 23855 //
     /* 1080954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1080965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1080968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080993 */     // MIs[0] policy
     /* 1080993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081003 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081025 */     // GIR_Coverage, 23855,
     /* 1081025 */     GIR_EraseRootFromParent_Done,
     /* 1081026 */   // Label 15945: @1081026
     /* 1081026 */   GIM_Try, /*On fail goto*//*Label 15946*/ GIMT_Encode4(1081103), // Rule ID 23858 //
     /* 1081031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1081042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1081045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1081048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081070 */     // MIs[0] policy
     /* 1081070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081080 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081102 */     // GIR_Coverage, 23858,
     /* 1081102 */     GIR_EraseRootFromParent_Done,
     /* 1081103 */   // Label 15946: @1081103
     /* 1081103 */   GIM_Try, /*On fail goto*//*Label 15947*/ GIMT_Encode4(1081180), // Rule ID 23859 //
     /* 1081108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1081119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1081122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1081125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081147 */     // MIs[0] policy
     /* 1081147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081157 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081179 */     // GIR_Coverage, 23859,
     /* 1081179 */     GIR_EraseRootFromParent_Done,
     /* 1081180 */   // Label 15947: @1081180
     /* 1081180 */   GIM_Try, /*On fail goto*//*Label 15948*/ GIMT_Encode4(1081257), // Rule ID 23862 //
     /* 1081185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1081196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1081199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1081202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081224 */     // MIs[0] policy
     /* 1081224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1081237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081256 */     // GIR_Coverage, 23862,
     /* 1081256 */     GIR_EraseRootFromParent_Done,
     /* 1081257 */   // Label 15948: @1081257
     /* 1081257 */   GIM_Try, /*On fail goto*//*Label 15949*/ GIMT_Encode4(1081334), // Rule ID 23863 //
     /* 1081262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1081273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1081276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1081279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081301 */     // MIs[0] policy
     /* 1081301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081311 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1081314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081333 */     // GIR_Coverage, 23863,
     /* 1081333 */     GIR_EraseRootFromParent_Done,
     /* 1081334 */   // Label 15949: @1081334
     /* 1081334 */   GIM_Try, /*On fail goto*//*Label 15950*/ GIMT_Encode4(1081411), // Rule ID 23866 //
     /* 1081339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1081350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1081353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1081356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081378 */     // MIs[0] policy
     /* 1081378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081388 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081410 */     // GIR_Coverage, 23866,
     /* 1081410 */     GIR_EraseRootFromParent_Done,
     /* 1081411 */   // Label 15950: @1081411
     /* 1081411 */   GIM_Try, /*On fail goto*//*Label 15951*/ GIMT_Encode4(1081488), // Rule ID 23867 //
     /* 1081416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1081427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1081430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1081433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081455 */     // MIs[0] policy
     /* 1081455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081465 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081487 */     // GIR_Coverage, 23867,
     /* 1081487 */     GIR_EraseRootFromParent_Done,
     /* 1081488 */   // Label 15951: @1081488
     /* 1081488 */   GIM_Try, /*On fail goto*//*Label 15952*/ GIMT_Encode4(1081565), // Rule ID 23870 //
     /* 1081493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1081504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1081507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081532 */     // MIs[0] policy
     /* 1081532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081542 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081564 */     // GIR_Coverage, 23870,
     /* 1081564 */     GIR_EraseRootFromParent_Done,
     /* 1081565 */   // Label 15952: @1081565
     /* 1081565 */   GIM_Try, /*On fail goto*//*Label 15953*/ GIMT_Encode4(1081642), // Rule ID 23871 //
     /* 1081570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1081581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1081584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081609 */     // MIs[0] policy
     /* 1081609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081619 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081641 */     // GIR_Coverage, 23871,
     /* 1081641 */     GIR_EraseRootFromParent_Done,
     /* 1081642 */   // Label 15953: @1081642
     /* 1081642 */   GIM_Try, /*On fail goto*//*Label 15954*/ GIMT_Encode4(1081719), // Rule ID 23874 //
     /* 1081647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1081658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1081661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081686 */     // MIs[0] policy
     /* 1081686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1081699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081718 */     // GIR_Coverage, 23874,
     /* 1081718 */     GIR_EraseRootFromParent_Done,
     /* 1081719 */   // Label 15954: @1081719
     /* 1081719 */   GIM_Try, /*On fail goto*//*Label 15955*/ GIMT_Encode4(1081796), // Rule ID 23875 //
     /* 1081724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1081735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1081738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081763 */     // MIs[0] policy
     /* 1081763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081773 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1081776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081795 */     // GIR_Coverage, 23875,
     /* 1081795 */     GIR_EraseRootFromParent_Done,
     /* 1081796 */   // Label 15955: @1081796
     /* 1081796 */   GIM_Try, /*On fail goto*//*Label 15956*/ GIMT_Encode4(1081873), // Rule ID 23878 //
     /* 1081801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1081812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1081815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081840 */     // MIs[0] policy
     /* 1081840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081872 */     // GIR_Coverage, 23878,
     /* 1081872 */     GIR_EraseRootFromParent_Done,
     /* 1081873 */   // Label 15956: @1081873
     /* 1081873 */   GIM_Try, /*On fail goto*//*Label 15957*/ GIMT_Encode4(1081950), // Rule ID 23879 //
     /* 1081878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1081889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1081892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081917 */     // MIs[0] policy
     /* 1081917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081927 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081949 */     // GIR_Coverage, 23879,
     /* 1081949 */     GIR_EraseRootFromParent_Done,
     /* 1081950 */   // Label 15957: @1081950
     /* 1081950 */   GIM_Try, /*On fail goto*//*Label 15958*/ GIMT_Encode4(1082027), // Rule ID 23882 //
     /* 1081955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1081966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1081969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1081972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081994 */     // MIs[0] policy
     /* 1081994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082004 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1082007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082026 */     // GIR_Coverage, 23882,
     /* 1082026 */     GIR_EraseRootFromParent_Done,
     /* 1082027 */   // Label 15958: @1082027
     /* 1082027 */   GIM_Try, /*On fail goto*//*Label 15959*/ GIMT_Encode4(1082104), // Rule ID 23883 //
     /* 1082032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1082035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1082043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1082046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1082049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082071 */     // MIs[0] policy
     /* 1082071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082081 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1082084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082103 */     // GIR_Coverage, 23883,
     /* 1082103 */     GIR_EraseRootFromParent_Done,
     /* 1082104 */   // Label 15959: @1082104
     /* 1082104 */   GIM_Try, /*On fail goto*//*Label 15960*/ GIMT_Encode4(1082181), // Rule ID 24150 //
     /* 1082109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1082120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1082123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1082126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082148 */     // MIs[0] policy
     /* 1082148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082158 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1082161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082180 */     // GIR_Coverage, 24150,
     /* 1082180 */     GIR_EraseRootFromParent_Done,
     /* 1082181 */   // Label 15960: @1082181
     /* 1082181 */   GIM_Try, /*On fail goto*//*Label 15961*/ GIMT_Encode4(1082258), // Rule ID 24151 //
     /* 1082186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1082197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1082200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1082203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082225 */     // MIs[0] policy
     /* 1082225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082235 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1082238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082257 */     // GIR_Coverage, 24151,
     /* 1082257 */     GIR_EraseRootFromParent_Done,
     /* 1082258 */   // Label 15961: @1082258
     /* 1082258 */   GIM_Try, /*On fail goto*//*Label 15962*/ GIMT_Encode4(1082335), // Rule ID 24154 //
     /* 1082263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1082274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1082277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1082280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082302 */     // MIs[0] policy
     /* 1082302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082312 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1082315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082334 */     // GIR_Coverage, 24154,
     /* 1082334 */     GIR_EraseRootFromParent_Done,
     /* 1082335 */   // Label 15962: @1082335
     /* 1082335 */   GIM_Try, /*On fail goto*//*Label 15963*/ GIMT_Encode4(1082412), // Rule ID 24155 //
     /* 1082340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1082351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1082354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1082357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082379 */     // MIs[0] policy
     /* 1082379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082389 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1082392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082411 */     // GIR_Coverage, 24155,
     /* 1082411 */     GIR_EraseRootFromParent_Done,
     /* 1082412 */   // Label 15963: @1082412
     /* 1082412 */   GIM_Try, /*On fail goto*//*Label 15964*/ GIMT_Encode4(1082489), // Rule ID 24158 //
     /* 1082417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1082428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1082431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1082434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082456 */     // MIs[0] policy
     /* 1082456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082466 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1082469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082488 */     // GIR_Coverage, 24158,
     /* 1082488 */     GIR_EraseRootFromParent_Done,
     /* 1082489 */   // Label 15964: @1082489
     /* 1082489 */   GIM_Try, /*On fail goto*//*Label 15965*/ GIMT_Encode4(1082566), // Rule ID 24159 //
     /* 1082494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1082505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1082508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1082511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082533 */     // MIs[0] policy
     /* 1082533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082543 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1082546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082565 */     // GIR_Coverage, 24159,
     /* 1082565 */     GIR_EraseRootFromParent_Done,
     /* 1082566 */   // Label 15965: @1082566
     /* 1082566 */   GIM_Try, /*On fail goto*//*Label 15966*/ GIMT_Encode4(1082643), // Rule ID 24162 //
     /* 1082571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1082582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1082585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1082588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082610 */     // MIs[0] policy
     /* 1082610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082620 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082642 */     // GIR_Coverage, 24162,
     /* 1082642 */     GIR_EraseRootFromParent_Done,
     /* 1082643 */   // Label 15966: @1082643
     /* 1082643 */   GIM_Try, /*On fail goto*//*Label 15967*/ GIMT_Encode4(1082720), // Rule ID 24163 //
     /* 1082648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1082659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1082662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1082665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082687 */     // MIs[0] policy
     /* 1082687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082697 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082719 */     // GIR_Coverage, 24163,
     /* 1082719 */     GIR_EraseRootFromParent_Done,
     /* 1082720 */   // Label 15967: @1082720
     /* 1082720 */   GIM_Try, /*On fail goto*//*Label 15968*/ GIMT_Encode4(1082797), // Rule ID 24166 //
     /* 1082725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1082736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1082739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1082742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082764 */     // MIs[0] policy
     /* 1082764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082774 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082796 */     // GIR_Coverage, 24166,
     /* 1082796 */     GIR_EraseRootFromParent_Done,
     /* 1082797 */   // Label 15968: @1082797
     /* 1082797 */   GIM_Try, /*On fail goto*//*Label 15969*/ GIMT_Encode4(1082874), // Rule ID 24167 //
     /* 1082802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1082813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1082816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1082819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082841 */     // MIs[0] policy
     /* 1082841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082851 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082873 */     // GIR_Coverage, 24167,
     /* 1082873 */     GIR_EraseRootFromParent_Done,
     /* 1082874 */   // Label 15969: @1082874
     /* 1082874 */   GIM_Try, /*On fail goto*//*Label 15970*/ GIMT_Encode4(1082951), // Rule ID 24170 //
     /* 1082879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1082882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1082890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1082893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1082896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082918 */     // MIs[0] policy
     /* 1082918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082928 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082950 */     // GIR_Coverage, 24170,
     /* 1082950 */     GIR_EraseRootFromParent_Done,
     /* 1082951 */   // Label 15970: @1082951
     /* 1082951 */   GIM_Try, /*On fail goto*//*Label 15971*/ GIMT_Encode4(1083028), // Rule ID 24171 //
     /* 1082956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1082959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1082967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1082970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1082973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082995 */     // MIs[0] policy
     /* 1082995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083005 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1083008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083027 */     // GIR_Coverage, 24171,
     /* 1083027 */     GIR_EraseRootFromParent_Done,
     /* 1083028 */   // Label 15971: @1083028
     /* 1083028 */   GIM_Try, /*On fail goto*//*Label 15972*/ GIMT_Encode4(1083105), // Rule ID 24174 //
     /* 1083033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1083044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1083047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1083050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083072 */     // MIs[0] policy
     /* 1083072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083082 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083104 */     // GIR_Coverage, 24174,
     /* 1083104 */     GIR_EraseRootFromParent_Done,
     /* 1083105 */   // Label 15972: @1083105
     /* 1083105 */   GIM_Try, /*On fail goto*//*Label 15973*/ GIMT_Encode4(1083182), // Rule ID 24175 //
     /* 1083110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1083121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1083124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1083127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083149 */     // MIs[0] policy
     /* 1083149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083159 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083181 */     // GIR_Coverage, 24175,
     /* 1083181 */     GIR_EraseRootFromParent_Done,
     /* 1083182 */   // Label 15973: @1083182
     /* 1083182 */   GIM_Try, /*On fail goto*//*Label 15974*/ GIMT_Encode4(1083259), // Rule ID 24178 //
     /* 1083187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1083198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1083201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1083204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083226 */     // MIs[0] policy
     /* 1083226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083236 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083258 */     // GIR_Coverage, 24178,
     /* 1083258 */     GIR_EraseRootFromParent_Done,
     /* 1083259 */   // Label 15974: @1083259
     /* 1083259 */   GIM_Try, /*On fail goto*//*Label 15975*/ GIMT_Encode4(1083336), // Rule ID 24179 //
     /* 1083264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1083275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1083278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1083281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083303 */     // MIs[0] policy
     /* 1083303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083313 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083335 */     // GIR_Coverage, 24179,
     /* 1083335 */     GIR_EraseRootFromParent_Done,
     /* 1083336 */   // Label 15975: @1083336
     /* 1083336 */   GIM_Try, /*On fail goto*//*Label 15976*/ GIMT_Encode4(1083413), // Rule ID 24182 //
     /* 1083341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1083352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1083355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1083358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083380 */     // MIs[0] policy
     /* 1083380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083390 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083412 */     // GIR_Coverage, 24182,
     /* 1083412 */     GIR_EraseRootFromParent_Done,
     /* 1083413 */   // Label 15976: @1083413
     /* 1083413 */   GIM_Try, /*On fail goto*//*Label 15977*/ GIMT_Encode4(1083490), // Rule ID 24183 //
     /* 1083418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1083429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1083432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1083435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083457 */     // MIs[0] policy
     /* 1083457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083467 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083489 */     // GIR_Coverage, 24183,
     /* 1083489 */     GIR_EraseRootFromParent_Done,
     /* 1083490 */   // Label 15977: @1083490
     /* 1083490 */   GIM_Try, /*On fail goto*//*Label 15978*/ GIMT_Encode4(1083567), // Rule ID 24186 //
     /* 1083495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1083506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1083509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1083512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083534 */     // MIs[0] policy
     /* 1083534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083544 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083566 */     // GIR_Coverage, 24186,
     /* 1083566 */     GIR_EraseRootFromParent_Done,
     /* 1083567 */   // Label 15978: @1083567
     /* 1083567 */   GIM_Try, /*On fail goto*//*Label 15979*/ GIMT_Encode4(1083644), // Rule ID 24187 //
     /* 1083572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1083583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1083586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1083589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083611 */     // MIs[0] policy
     /* 1083611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083621 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083643 */     // GIR_Coverage, 24187,
     /* 1083643 */     GIR_EraseRootFromParent_Done,
     /* 1083644 */   // Label 15979: @1083644
     /* 1083644 */   GIM_Try, /*On fail goto*//*Label 15980*/ GIMT_Encode4(1083721), // Rule ID 24190 //
     /* 1083649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1083660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1083663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1083666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083688 */     // MIs[0] policy
     /* 1083688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083698 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083720 */     // GIR_Coverage, 24190,
     /* 1083720 */     GIR_EraseRootFromParent_Done,
     /* 1083721 */   // Label 15980: @1083721
     /* 1083721 */   GIM_Try, /*On fail goto*//*Label 15981*/ GIMT_Encode4(1083798), // Rule ID 24191 //
     /* 1083726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1083737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1083740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1083743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083765 */     // MIs[0] policy
     /* 1083765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083775 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083797 */     // GIR_Coverage, 24191,
     /* 1083797 */     GIR_EraseRootFromParent_Done,
     /* 1083798 */   // Label 15981: @1083798
     /* 1083798 */   GIM_Try, /*On fail goto*//*Label 15982*/ GIMT_Encode4(1083875), // Rule ID 24194 //
     /* 1083803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1083814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1083817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1083820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083842 */     // MIs[0] policy
     /* 1083842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083852 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083874 */     // GIR_Coverage, 24194,
     /* 1083874 */     GIR_EraseRootFromParent_Done,
     /* 1083875 */   // Label 15982: @1083875
     /* 1083875 */   GIM_Try, /*On fail goto*//*Label 15983*/ GIMT_Encode4(1083952), // Rule ID 24195 //
     /* 1083880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1083891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1083894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1083897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083919 */     // MIs[0] policy
     /* 1083919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083929 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083951 */     // GIR_Coverage, 24195,
     /* 1083951 */     GIR_EraseRootFromParent_Done,
     /* 1083952 */   // Label 15983: @1083952
     /* 1083952 */   GIM_Try, /*On fail goto*//*Label 15984*/ GIMT_Encode4(1084029), // Rule ID 24198 //
     /* 1083957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1083960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1083968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1083971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1083974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083996 */     // MIs[0] policy
     /* 1083996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084006 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1084009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084028 */     // GIR_Coverage, 24198,
     /* 1084028 */     GIR_EraseRootFromParent_Done,
     /* 1084029 */   // Label 15984: @1084029
     /* 1084029 */   GIM_Try, /*On fail goto*//*Label 15985*/ GIMT_Encode4(1084106), // Rule ID 24199 //
     /* 1084034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1084037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1084042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1084045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1084048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1084051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084073 */     // MIs[0] policy
     /* 1084073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084083 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1084086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084105 */     // GIR_Coverage, 24199,
     /* 1084105 */     GIR_EraseRootFromParent_Done,
     /* 1084106 */   // Label 15985: @1084106
     /* 1084106 */   GIM_Try, /*On fail goto*//*Label 15986*/ GIMT_Encode4(1084183), // Rule ID 24202 //
     /* 1084111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1084114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1084119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1084122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1084125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1084128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084150 */     // MIs[0] policy
     /* 1084150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084160 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1084163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084182 */     // GIR_Coverage, 24202,
     /* 1084182 */     GIR_EraseRootFromParent_Done,
     /* 1084183 */   // Label 15986: @1084183
     /* 1084183 */   GIM_Try, /*On fail goto*//*Label 15987*/ GIMT_Encode4(1084260), // Rule ID 24203 //
     /* 1084188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1084191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1084196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1084199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1084202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1084205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084227 */     // MIs[0] policy
     /* 1084227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084237 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1084240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084259 */     // GIR_Coverage, 24203,
     /* 1084259 */     GIR_EraseRootFromParent_Done,
     /* 1084260 */   // Label 15987: @1084260
     /* 1084260 */   GIM_Try, /*On fail goto*//*Label 15988*/ GIMT_Encode4(1084337), // Rule ID 24206 //
     /* 1084265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1084268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1084273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1084276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1084279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1084282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084304 */     // MIs[0] policy
     /* 1084304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084314 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1084317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084336 */     // GIR_Coverage, 24206,
     /* 1084336 */     GIR_EraseRootFromParent_Done,
     /* 1084337 */   // Label 15988: @1084337
     /* 1084337 */   GIM_Try, /*On fail goto*//*Label 15989*/ GIMT_Encode4(1084414), // Rule ID 24207 //
     /* 1084342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1084345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1084350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1084353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1084356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1084359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084381 */     // MIs[0] policy
     /* 1084381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084391 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1084394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084413 */     // GIR_Coverage, 24207,
     /* 1084413 */     GIR_EraseRootFromParent_Done,
     /* 1084414 */   // Label 15989: @1084414
     /* 1084414 */   GIM_Try, /*On fail goto*//*Label 15990*/ GIMT_Encode4(1084491), // Rule ID 24270 //
     /* 1084419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1084430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1084433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1084436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084458 */     // MIs[0] policy
     /* 1084458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084468 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1084471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084490 */     // GIR_Coverage, 24270,
     /* 1084490 */     GIR_EraseRootFromParent_Done,
     /* 1084491 */   // Label 15990: @1084491
     /* 1084491 */   GIM_Try, /*On fail goto*//*Label 15991*/ GIMT_Encode4(1084568), // Rule ID 24271 //
     /* 1084496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1084507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1084510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1084513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084535 */     // MIs[0] policy
     /* 1084535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084545 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1084548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084567 */     // GIR_Coverage, 24271,
     /* 1084567 */     GIR_EraseRootFromParent_Done,
     /* 1084568 */   // Label 15991: @1084568
     /* 1084568 */   GIM_Try, /*On fail goto*//*Label 15992*/ GIMT_Encode4(1084645), // Rule ID 24274 //
     /* 1084573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1084584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1084587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1084590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084612 */     // MIs[0] policy
     /* 1084612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084622 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084644 */     // GIR_Coverage, 24274,
     /* 1084644 */     GIR_EraseRootFromParent_Done,
     /* 1084645 */   // Label 15992: @1084645
     /* 1084645 */   GIM_Try, /*On fail goto*//*Label 15993*/ GIMT_Encode4(1084722), // Rule ID 24275 //
     /* 1084650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1084661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1084664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1084667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084689 */     // MIs[0] policy
     /* 1084689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084699 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084721 */     // GIR_Coverage, 24275,
     /* 1084721 */     GIR_EraseRootFromParent_Done,
     /* 1084722 */   // Label 15993: @1084722
     /* 1084722 */   GIM_Try, /*On fail goto*//*Label 15994*/ GIMT_Encode4(1084799), // Rule ID 24278 //
     /* 1084727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1084738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1084741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1084744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084766 */     // MIs[0] policy
     /* 1084766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084776 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084798 */     // GIR_Coverage, 24278,
     /* 1084798 */     GIR_EraseRootFromParent_Done,
     /* 1084799 */   // Label 15994: @1084799
     /* 1084799 */   GIM_Try, /*On fail goto*//*Label 15995*/ GIMT_Encode4(1084876), // Rule ID 24279 //
     /* 1084804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1084815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1084818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1084821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084843 */     // MIs[0] policy
     /* 1084843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084853 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084875 */     // GIR_Coverage, 24279,
     /* 1084875 */     GIR_EraseRootFromParent_Done,
     /* 1084876 */   // Label 15995: @1084876
     /* 1084876 */   GIM_Try, /*On fail goto*//*Label 15996*/ GIMT_Encode4(1084953), // Rule ID 24282 //
     /* 1084881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1084892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1084895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1084898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084920 */     // MIs[0] policy
     /* 1084920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084930 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084952 */     // GIR_Coverage, 24282,
     /* 1084952 */     GIR_EraseRootFromParent_Done,
     /* 1084953 */   // Label 15996: @1084953
     /* 1084953 */   GIM_Try, /*On fail goto*//*Label 15997*/ GIMT_Encode4(1085030), // Rule ID 24283 //
     /* 1084958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1084969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1084972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1084975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084997 */     // MIs[0] policy
     /* 1084997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085007 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1085010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085029 */     // GIR_Coverage, 24283,
     /* 1085029 */     GIR_EraseRootFromParent_Done,
     /* 1085030 */   // Label 15997: @1085030
     /* 1085030 */   GIM_Try, /*On fail goto*//*Label 15998*/ GIMT_Encode4(1085107), // Rule ID 24286 //
     /* 1085035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1085046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1085049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1085052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085074 */     // MIs[0] policy
     /* 1085074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085084 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1085087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085106 */     // GIR_Coverage, 24286,
     /* 1085106 */     GIR_EraseRootFromParent_Done,
     /* 1085107 */   // Label 15998: @1085107
     /* 1085107 */   GIM_Try, /*On fail goto*//*Label 15999*/ GIMT_Encode4(1085184), // Rule ID 24287 //
     /* 1085112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1085123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1085126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1085129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085151 */     // MIs[0] policy
     /* 1085151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085161 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1085164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085183 */     // GIR_Coverage, 24287,
     /* 1085183 */     GIR_EraseRootFromParent_Done,
     /* 1085184 */   // Label 15999: @1085184
     /* 1085184 */   GIM_Try, /*On fail goto*//*Label 16000*/ GIMT_Encode4(1085261), // Rule ID 24290 //
     /* 1085189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1085192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1085200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1085203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1085206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085228 */     // MIs[0] policy
     /* 1085228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085238 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1085241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085260 */     // GIR_Coverage, 24290,
     /* 1085260 */     GIR_EraseRootFromParent_Done,
     /* 1085261 */   // Label 16000: @1085261
     /* 1085261 */   GIM_Try, /*On fail goto*//*Label 16001*/ GIMT_Encode4(1085338), // Rule ID 24291 //
     /* 1085266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1085269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1085277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1085280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1085283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085305 */     // MIs[0] policy
     /* 1085305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085315 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1085318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085337 */     // GIR_Coverage, 24291,
     /* 1085337 */     GIR_EraseRootFromParent_Done,
     /* 1085338 */   // Label 16001: @1085338
     /* 1085338 */   GIM_Try, /*On fail goto*//*Label 16002*/ GIMT_Encode4(1085415), // Rule ID 24294 //
     /* 1085343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1085354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1085357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1085360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085382 */     // MIs[0] policy
     /* 1085382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085392 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085414 */     // GIR_Coverage, 24294,
     /* 1085414 */     GIR_EraseRootFromParent_Done,
     /* 1085415 */   // Label 16002: @1085415
     /* 1085415 */   GIM_Try, /*On fail goto*//*Label 16003*/ GIMT_Encode4(1085492), // Rule ID 24295 //
     /* 1085420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1085431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1085434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1085437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085459 */     // MIs[0] policy
     /* 1085459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085469 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085491 */     // GIR_Coverage, 24295,
     /* 1085491 */     GIR_EraseRootFromParent_Done,
     /* 1085492 */   // Label 16003: @1085492
     /* 1085492 */   GIM_Try, /*On fail goto*//*Label 16004*/ GIMT_Encode4(1085569), // Rule ID 24298 //
     /* 1085497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1085508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1085511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1085514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085536 */     // MIs[0] policy
     /* 1085536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085546 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085568 */     // GIR_Coverage, 24298,
     /* 1085568 */     GIR_EraseRootFromParent_Done,
     /* 1085569 */   // Label 16004: @1085569
     /* 1085569 */   GIM_Try, /*On fail goto*//*Label 16005*/ GIMT_Encode4(1085646), // Rule ID 24299 //
     /* 1085574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1085585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1085588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1085591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085613 */     // MIs[0] policy
     /* 1085613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085623 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085645 */     // GIR_Coverage, 24299,
     /* 1085645 */     GIR_EraseRootFromParent_Done,
     /* 1085646 */   // Label 16005: @1085646
     /* 1085646 */   GIM_Try, /*On fail goto*//*Label 16006*/ GIMT_Encode4(1085723), // Rule ID 24302 //
     /* 1085651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1085662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1085665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1085668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085690 */     // MIs[0] policy
     /* 1085690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085700 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085722 */     // GIR_Coverage, 24302,
     /* 1085722 */     GIR_EraseRootFromParent_Done,
     /* 1085723 */   // Label 16006: @1085723
     /* 1085723 */   GIM_Try, /*On fail goto*//*Label 16007*/ GIMT_Encode4(1085800), // Rule ID 24303 //
     /* 1085728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1085739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1085742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1085745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085767 */     // MIs[0] policy
     /* 1085767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085777 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085799 */     // GIR_Coverage, 24303,
     /* 1085799 */     GIR_EraseRootFromParent_Done,
     /* 1085800 */   // Label 16007: @1085800
     /* 1085800 */   GIM_Try, /*On fail goto*//*Label 16008*/ GIMT_Encode4(1085877), // Rule ID 24306 //
     /* 1085805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1085816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1085819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1085822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085844 */     // MIs[0] policy
     /* 1085844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085854 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085876 */     // GIR_Coverage, 24306,
     /* 1085876 */     GIR_EraseRootFromParent_Done,
     /* 1085877 */   // Label 16008: @1085877
     /* 1085877 */   GIM_Try, /*On fail goto*//*Label 16009*/ GIMT_Encode4(1085954), // Rule ID 24307 //
     /* 1085882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1085893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1085896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1085899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085921 */     // MIs[0] policy
     /* 1085921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085931 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085953 */     // GIR_Coverage, 24307,
     /* 1085953 */     GIR_EraseRootFromParent_Done,
     /* 1085954 */   // Label 16009: @1085954
     /* 1085954 */   GIM_Try, /*On fail goto*//*Label 16010*/ GIMT_Encode4(1086031), // Rule ID 24310 //
     /* 1085959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1085970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1085973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1085976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085998 */     // MIs[0] policy
     /* 1085998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086008 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1086011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086030 */     // GIR_Coverage, 24310,
     /* 1086030 */     GIR_EraseRootFromParent_Done,
     /* 1086031 */   // Label 16010: @1086031
     /* 1086031 */   GIM_Try, /*On fail goto*//*Label 16011*/ GIMT_Encode4(1086108), // Rule ID 24311 //
     /* 1086036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1086039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1086047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1086050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1086053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086075 */     // MIs[0] policy
     /* 1086075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086085 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1086088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086107 */     // GIR_Coverage, 24311,
     /* 1086107 */     GIR_EraseRootFromParent_Done,
     /* 1086108 */   // Label 16011: @1086108
     /* 1086108 */   GIM_Try, /*On fail goto*//*Label 16012*/ GIMT_Encode4(1086185), // Rule ID 24314 //
     /* 1086113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1086116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1086124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1086127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1086130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086152 */     // MIs[0] policy
     /* 1086152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086162 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1086165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086184 */     // GIR_Coverage, 24314,
     /* 1086184 */     GIR_EraseRootFromParent_Done,
     /* 1086185 */   // Label 16012: @1086185
     /* 1086185 */   GIM_Try, /*On fail goto*//*Label 16013*/ GIMT_Encode4(1086262), // Rule ID 24315 //
     /* 1086190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1086193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1086201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1086204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1086207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086229 */     // MIs[0] policy
     /* 1086229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086239 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1086242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086261 */     // GIR_Coverage, 24315,
     /* 1086261 */     GIR_EraseRootFromParent_Done,
     /* 1086262 */   // Label 16013: @1086262
     /* 1086262 */   GIM_Try, /*On fail goto*//*Label 16014*/ GIMT_Encode4(1086339), // Rule ID 24318 //
     /* 1086267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1086270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1086278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1086281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1086284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086306 */     // MIs[0] policy
     /* 1086306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086316 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1086319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086338 */     // GIR_Coverage, 24318,
     /* 1086338 */     GIR_EraseRootFromParent_Done,
     /* 1086339 */   // Label 16014: @1086339
     /* 1086339 */   GIM_Try, /*On fail goto*//*Label 16015*/ GIMT_Encode4(1086416), // Rule ID 24319 //
     /* 1086344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1086347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1086355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1086358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1086361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086383 */     // MIs[0] policy
     /* 1086383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086393 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1086396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086415 */     // GIR_Coverage, 24319,
     /* 1086415 */     GIR_EraseRootFromParent_Done,
     /* 1086416 */   // Label 16015: @1086416
     /* 1086416 */   GIM_Try, /*On fail goto*//*Label 16016*/ GIMT_Encode4(1086493), // Rule ID 24322 //
     /* 1086421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1086424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1086432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1086435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1086438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086460 */     // MIs[0] policy
     /* 1086460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086470 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1086473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086492 */     // GIR_Coverage, 24322,
     /* 1086492 */     GIR_EraseRootFromParent_Done,
     /* 1086493 */   // Label 16016: @1086493
     /* 1086493 */   GIM_Try, /*On fail goto*//*Label 16017*/ GIMT_Encode4(1086570), // Rule ID 24323 //
     /* 1086498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1086501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1086509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1086512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1086515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086537 */     // MIs[0] policy
     /* 1086537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086547 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1086550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086569 */     // GIR_Coverage, 24323,
     /* 1086569 */     GIR_EraseRootFromParent_Done,
     /* 1086570 */   // Label 16017: @1086570
     /* 1086570 */   GIM_Try, /*On fail goto*//*Label 16018*/ GIMT_Encode4(1086647), // Rule ID 24326 //
     /* 1086575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1086578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1086586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1086589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1086592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086614 */     // MIs[0] policy
     /* 1086614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086624 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1086627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086646 */     // GIR_Coverage, 24326,
     /* 1086646 */     GIR_EraseRootFromParent_Done,
     /* 1086647 */   // Label 16018: @1086647
     /* 1086647 */   GIM_Try, /*On fail goto*//*Label 16019*/ GIMT_Encode4(1086724), // Rule ID 24327 //
     /* 1086652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1086655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1086663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1086666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1086669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086691 */     // MIs[0] policy
     /* 1086691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086701 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1086704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086723 */     // GIR_Coverage, 24327,
     /* 1086723 */     GIR_EraseRootFromParent_Done,
     /* 1086724 */   // Label 16019: @1086724
     /* 1086724 */   GIM_Try, /*On fail goto*//*Label 16020*/ GIMT_Encode4(1086801), // Rule ID 60618 //
     /* 1086729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1086732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1086737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1086740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1086743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1086746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1086749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086768 */     // MIs[0] policy
     /* 1086768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086778 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1086781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1086783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086800 */     // GIR_Coverage, 60618,
     /* 1086800 */     GIR_EraseRootFromParent_Done,
     /* 1086801 */   // Label 16020: @1086801
     /* 1086801 */   GIM_Try, /*On fail goto*//*Label 16021*/ GIMT_Encode4(1086878), // Rule ID 60619 //
     /* 1086806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1086809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1086814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1086817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1086820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1086823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1086826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086845 */     // MIs[0] policy
     /* 1086845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086855 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1086858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1086860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086877 */     // GIR_Coverage, 60619,
     /* 1086877 */     GIR_EraseRootFromParent_Done,
     /* 1086878 */   // Label 16021: @1086878
     /* 1086878 */   GIM_Try, /*On fail goto*//*Label 16022*/ GIMT_Encode4(1086955), // Rule ID 60632 //
     /* 1086883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1086894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1086897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1086900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086922 */     // MIs[0] policy
     /* 1086922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086932 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1086935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086954 */     // GIR_Coverage, 60632,
     /* 1086954 */     GIR_EraseRootFromParent_Done,
     /* 1086955 */   // Label 16022: @1086955
     /* 1086955 */   GIM_Try, /*On fail goto*//*Label 16023*/ GIMT_Encode4(1087032), // Rule ID 60633 //
     /* 1086960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1086971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1086974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1086977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086999 */     // MIs[0] policy
     /* 1086999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087009 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1087012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087031 */     // GIR_Coverage, 60633,
     /* 1087031 */     GIR_EraseRootFromParent_Done,
     /* 1087032 */   // Label 16023: @1087032
     /* 1087032 */   GIM_Try, /*On fail goto*//*Label 16024*/ GIMT_Encode4(1087109), // Rule ID 60636 //
     /* 1087037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1087048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1087051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1087054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087076 */     // MIs[0] policy
     /* 1087076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087086 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1087089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087108 */     // GIR_Coverage, 60636,
     /* 1087108 */     GIR_EraseRootFromParent_Done,
     /* 1087109 */   // Label 16024: @1087109
     /* 1087109 */   GIM_Try, /*On fail goto*//*Label 16025*/ GIMT_Encode4(1087186), // Rule ID 60637 //
     /* 1087114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1087125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1087128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1087131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087153 */     // MIs[0] policy
     /* 1087153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087163 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1087166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087185 */     // GIR_Coverage, 60637,
     /* 1087185 */     GIR_EraseRootFromParent_Done,
     /* 1087186 */   // Label 16025: @1087186
     /* 1087186 */   GIM_Try, /*On fail goto*//*Label 16026*/ GIMT_Encode4(1087263), // Rule ID 60640 //
     /* 1087191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1087202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1087205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1087208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1087211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087230 */     // MIs[0] policy
     /* 1087230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087240 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087262 */     // GIR_Coverage, 60640,
     /* 1087262 */     GIR_EraseRootFromParent_Done,
     /* 1087263 */   // Label 16026: @1087263
     /* 1087263 */   GIM_Try, /*On fail goto*//*Label 16027*/ GIMT_Encode4(1087340), // Rule ID 60641 //
     /* 1087268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1087279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1087282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1087285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1087288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087307 */     // MIs[0] policy
     /* 1087307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087317 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087326 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087339 */     // GIR_Coverage, 60641,
     /* 1087339 */     GIR_EraseRootFromParent_Done,
     /* 1087340 */   // Label 16027: @1087340
     /* 1087340 */   GIM_Try, /*On fail goto*//*Label 16028*/ GIMT_Encode4(1087417), // Rule ID 60644 //
     /* 1087345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1087356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1087359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1087362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087384 */     // MIs[0] policy
     /* 1087384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087394 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1087397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087416 */     // GIR_Coverage, 60644,
     /* 1087416 */     GIR_EraseRootFromParent_Done,
     /* 1087417 */   // Label 16028: @1087417
     /* 1087417 */   GIM_Try, /*On fail goto*//*Label 16029*/ GIMT_Encode4(1087494), // Rule ID 60645 //
     /* 1087422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1087433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1087436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1087439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087461 */     // MIs[0] policy
     /* 1087461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087471 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1087474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087480 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087493 */     // GIR_Coverage, 60645,
     /* 1087493 */     GIR_EraseRootFromParent_Done,
     /* 1087494 */   // Label 16029: @1087494
     /* 1087494 */   GIM_Try, /*On fail goto*//*Label 16030*/ GIMT_Encode4(1087571), // Rule ID 60648 //
     /* 1087499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1087510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1087513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1087516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087538 */     // MIs[0] policy
     /* 1087538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087570 */     // GIR_Coverage, 60648,
     /* 1087570 */     GIR_EraseRootFromParent_Done,
     /* 1087571 */   // Label 16030: @1087571
     /* 1087571 */   GIM_Try, /*On fail goto*//*Label 16031*/ GIMT_Encode4(1087648), // Rule ID 60649 //
     /* 1087576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1087587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1087590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1087593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087615 */     // MIs[0] policy
     /* 1087615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087625 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087634 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087647 */     // GIR_Coverage, 60649,
     /* 1087647 */     GIR_EraseRootFromParent_Done,
     /* 1087648 */   // Label 16031: @1087648
     /* 1087648 */   GIM_Try, /*On fail goto*//*Label 16032*/ GIMT_Encode4(1087725), // Rule ID 60652 //
     /* 1087653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1087664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1087667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1087670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087692 */     // MIs[0] policy
     /* 1087692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087724 */     // GIR_Coverage, 60652,
     /* 1087724 */     GIR_EraseRootFromParent_Done,
     /* 1087725 */   // Label 16032: @1087725
     /* 1087725 */   GIM_Try, /*On fail goto*//*Label 16033*/ GIMT_Encode4(1087802), // Rule ID 60653 //
     /* 1087730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1087741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1087744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1087747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087769 */     // MIs[0] policy
     /* 1087769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087779 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087801 */     // GIR_Coverage, 60653,
     /* 1087801 */     GIR_EraseRootFromParent_Done,
     /* 1087802 */   // Label 16033: @1087802
     /* 1087802 */   GIM_Try, /*On fail goto*//*Label 16034*/ GIMT_Encode4(1087879), // Rule ID 60656 //
     /* 1087807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1087818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1087821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1087824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1087827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087846 */     // MIs[0] policy
     /* 1087846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087856 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087878 */     // GIR_Coverage, 60656,
     /* 1087878 */     GIR_EraseRootFromParent_Done,
     /* 1087879 */   // Label 16034: @1087879
     /* 1087879 */   GIM_Try, /*On fail goto*//*Label 16035*/ GIMT_Encode4(1087956), // Rule ID 60657 //
     /* 1087884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1087895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1087898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1087901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1087904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087923 */     // MIs[0] policy
     /* 1087923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087933 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087942 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087955 */     // GIR_Coverage, 60657,
     /* 1087955 */     GIR_EraseRootFromParent_Done,
     /* 1087956 */   // Label 16035: @1087956
     /* 1087956 */   GIM_Try, /*On fail goto*//*Label 16036*/ GIMT_Encode4(1088033), // Rule ID 60660 //
     /* 1087961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1087972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1087975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1087978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1087981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088000 */     // MIs[0] policy
     /* 1088000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088010 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1088013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088019 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088032 */     // GIR_Coverage, 60660,
     /* 1088032 */     GIR_EraseRootFromParent_Done,
     /* 1088033 */   // Label 16036: @1088033
     /* 1088033 */   GIM_Try, /*On fail goto*//*Label 16037*/ GIMT_Encode4(1088110), // Rule ID 60661 //
     /* 1088038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1088049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1088052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1088055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1088058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1088065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088077 */     // MIs[0] policy
     /* 1088077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088087 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1088090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088096 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088109 */     // GIR_Coverage, 60661,
     /* 1088109 */     GIR_EraseRootFromParent_Done,
     /* 1088110 */   // Label 16037: @1088110
     /* 1088110 */   GIM_Try, /*On fail goto*//*Label 16038*/ GIMT_Encode4(1088187), // Rule ID 60664 //
     /* 1088115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1088126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1088129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1088132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1088135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1088142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088154 */     // MIs[0] policy
     /* 1088154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1088167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088186 */     // GIR_Coverage, 60664,
     /* 1088186 */     GIR_EraseRootFromParent_Done,
     /* 1088187 */   // Label 16038: @1088187
     /* 1088187 */   GIM_Try, /*On fail goto*//*Label 16039*/ GIMT_Encode4(1088264), // Rule ID 60665 //
     /* 1088192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1088203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1088206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1088209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1088212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1088219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088231 */     // MIs[0] policy
     /* 1088231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088241 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1088244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088250 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088263 */     // GIR_Coverage, 60665,
     /* 1088263 */     GIR_EraseRootFromParent_Done,
     /* 1088264 */   // Label 16039: @1088264
     /* 1088264 */   GIM_Try, /*On fail goto*//*Label 16040*/ GIMT_Encode4(1088341), // Rule ID 60668 //
     /* 1088269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1088280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1088283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1088286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1088289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1088296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088308 */     // MIs[0] policy
     /* 1088308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088318 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1088321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1088337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088340 */     // GIR_Coverage, 60668,
     /* 1088340 */     GIR_EraseRootFromParent_Done,
     /* 1088341 */   // Label 16040: @1088341
     /* 1088341 */   GIM_Try, /*On fail goto*//*Label 16041*/ GIMT_Encode4(1088418), // Rule ID 60669 //
     /* 1088346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1088357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1088360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1088363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1088366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1088373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088385 */     // MIs[0] policy
     /* 1088385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088395 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1088398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1088414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088417 */     // GIR_Coverage, 60669,
     /* 1088417 */     GIR_EraseRootFromParent_Done,
     /* 1088418 */   // Label 16041: @1088418
     /* 1088418 */   GIM_Try, /*On fail goto*//*Label 16042*/ GIMT_Encode4(1088495), // Rule ID 60672 //
     /* 1088423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1088434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1088437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1088440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088462 */     // MIs[0] policy
     /* 1088462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088472 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088494 */     // GIR_Coverage, 60672,
     /* 1088494 */     GIR_EraseRootFromParent_Done,
     /* 1088495 */   // Label 16042: @1088495
     /* 1088495 */   GIM_Try, /*On fail goto*//*Label 16043*/ GIMT_Encode4(1088572), // Rule ID 60673 //
     /* 1088500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1088511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1088514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1088517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088539 */     // MIs[0] policy
     /* 1088539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088549 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088571 */     // GIR_Coverage, 60673,
     /* 1088571 */     GIR_EraseRootFromParent_Done,
     /* 1088572 */   // Label 16043: @1088572
     /* 1088572 */   GIM_Try, /*On fail goto*//*Label 16044*/ GIMT_Encode4(1088649), // Rule ID 60676 //
     /* 1088577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1088588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1088591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1088594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088616 */     // MIs[0] policy
     /* 1088616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088626 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088648 */     // GIR_Coverage, 60676,
     /* 1088648 */     GIR_EraseRootFromParent_Done,
     /* 1088649 */   // Label 16044: @1088649
     /* 1088649 */   GIM_Try, /*On fail goto*//*Label 16045*/ GIMT_Encode4(1088726), // Rule ID 60677 //
     /* 1088654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1088665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1088668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1088671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088693 */     // MIs[0] policy
     /* 1088693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088703 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088712 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088725 */     // GIR_Coverage, 60677,
     /* 1088725 */     GIR_EraseRootFromParent_Done,
     /* 1088726 */   // Label 16045: @1088726
     /* 1088726 */   GIM_Try, /*On fail goto*//*Label 16046*/ GIMT_Encode4(1088803), // Rule ID 60680 //
     /* 1088731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1088742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1088745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1088748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1088751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088770 */     // MIs[0] policy
     /* 1088770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088780 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088802 */     // GIR_Coverage, 60680,
     /* 1088802 */     GIR_EraseRootFromParent_Done,
     /* 1088803 */   // Label 16046: @1088803
     /* 1088803 */   GIM_Try, /*On fail goto*//*Label 16047*/ GIMT_Encode4(1088880), // Rule ID 60681 //
     /* 1088808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1088819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1088822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1088825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1088828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088847 */     // MIs[0] policy
     /* 1088847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088857 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088866 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088879 */     // GIR_Coverage, 60681,
     /* 1088879 */     GIR_EraseRootFromParent_Done,
     /* 1088880 */   // Label 16047: @1088880
     /* 1088880 */   GIM_Try, /*On fail goto*//*Label 16048*/ GIMT_Encode4(1088957), // Rule ID 60684 //
     /* 1088885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1088902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1088905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088924 */     // MIs[0] policy
     /* 1088924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088934 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088956 */     // GIR_Coverage, 60684,
     /* 1088956 */     GIR_EraseRootFromParent_Done,
     /* 1088957 */   // Label 16048: @1088957
     /* 1088957 */   GIM_Try, /*On fail goto*//*Label 16049*/ GIMT_Encode4(1089034), // Rule ID 60685 //
     /* 1088962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1088979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1088982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089001 */     // MIs[0] policy
     /* 1089001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089011 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089033 */     // GIR_Coverage, 60685,
     /* 1089033 */     GIR_EraseRootFromParent_Done,
     /* 1089034 */   // Label 16049: @1089034
     /* 1089034 */   GIM_Try, /*On fail goto*//*Label 16050*/ GIMT_Encode4(1089111), // Rule ID 60688 //
     /* 1089039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1089050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1089053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1089056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1089059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089078 */     // MIs[0] policy
     /* 1089078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089088 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089110 */     // GIR_Coverage, 60688,
     /* 1089110 */     GIR_EraseRootFromParent_Done,
     /* 1089111 */   // Label 16050: @1089111
     /* 1089111 */   GIM_Try, /*On fail goto*//*Label 16051*/ GIMT_Encode4(1089188), // Rule ID 60689 //
     /* 1089116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1089127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1089130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1089133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1089136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089155 */     // MIs[0] policy
     /* 1089155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089165 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089174 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089187 */     // GIR_Coverage, 60689,
     /* 1089187 */     GIR_EraseRootFromParent_Done,
     /* 1089188 */   // Label 16051: @1089188
     /* 1089188 */   GIM_Try, /*On fail goto*//*Label 16052*/ GIMT_Encode4(1089265), // Rule ID 60692 //
     /* 1089193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1089204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1089207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1089210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1089213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089232 */     // MIs[0] policy
     /* 1089232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089242 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089264 */     // GIR_Coverage, 60692,
     /* 1089264 */     GIR_EraseRootFromParent_Done,
     /* 1089265 */   // Label 16052: @1089265
     /* 1089265 */   GIM_Try, /*On fail goto*//*Label 16053*/ GIMT_Encode4(1089342), // Rule ID 60693 //
     /* 1089270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1089281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1089284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1089287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1089290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089309 */     // MIs[0] policy
     /* 1089309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089319 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089328 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089341 */     // GIR_Coverage, 60693,
     /* 1089341 */     GIR_EraseRootFromParent_Done,
     /* 1089342 */   // Label 16053: @1089342
     /* 1089342 */   GIM_Try, /*On fail goto*//*Label 16054*/ GIMT_Encode4(1089419), // Rule ID 60696 //
     /* 1089347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1089358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1089361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1089364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1089374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089386 */     // MIs[0] policy
     /* 1089386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089418 */     // GIR_Coverage, 60696,
     /* 1089418 */     GIR_EraseRootFromParent_Done,
     /* 1089419 */   // Label 16054: @1089419
     /* 1089419 */   GIM_Try, /*On fail goto*//*Label 16055*/ GIMT_Encode4(1089496), // Rule ID 60697 //
     /* 1089424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1089435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1089438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1089441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1089451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089463 */     // MIs[0] policy
     /* 1089463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089473 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089495 */     // GIR_Coverage, 60697,
     /* 1089495 */     GIR_EraseRootFromParent_Done,
     /* 1089496 */   // Label 16055: @1089496
     /* 1089496 */   GIM_Try, /*On fail goto*//*Label 16056*/ GIMT_Encode4(1089573), // Rule ID 60700 //
     /* 1089501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1089518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089540 */     // MIs[0] policy
     /* 1089540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089550 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089572 */     // GIR_Coverage, 60700,
     /* 1089572 */     GIR_EraseRootFromParent_Done,
     /* 1089573 */   // Label 16056: @1089573
     /* 1089573 */   GIM_Try, /*On fail goto*//*Label 16057*/ GIMT_Encode4(1089650), // Rule ID 60701 //
     /* 1089578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1089595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089617 */     // MIs[0] policy
     /* 1089617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089627 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089649 */     // GIR_Coverage, 60701,
     /* 1089649 */     GIR_EraseRootFromParent_Done,
     /* 1089650 */   // Label 16057: @1089650
     /* 1089650 */   GIM_Try, /*On fail goto*//*Label 16058*/ GIMT_Encode4(1089727), // Rule ID 60704 //
     /* 1089655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1089666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1089669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1089672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1089675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089694 */     // MIs[0] policy
     /* 1089694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089704 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089726 */     // GIR_Coverage, 60704,
     /* 1089726 */     GIR_EraseRootFromParent_Done,
     /* 1089727 */   // Label 16058: @1089727
     /* 1089727 */   GIM_Try, /*On fail goto*//*Label 16059*/ GIMT_Encode4(1089804), // Rule ID 60705 //
     /* 1089732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1089743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1089746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1089749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1089752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089771 */     // MIs[0] policy
     /* 1089771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089781 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089790 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089803 */     // GIR_Coverage, 60705,
     /* 1089803 */     GIR_EraseRootFromParent_Done,
     /* 1089804 */   // Label 16059: @1089804
     /* 1089804 */   GIM_Try, /*On fail goto*//*Label 16060*/ GIMT_Encode4(1089881), // Rule ID 60708 //
     /* 1089809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1089820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1089823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1089836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089848 */     // MIs[0] policy
     /* 1089848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089858 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089880 */     // GIR_Coverage, 60708,
     /* 1089880 */     GIR_EraseRootFromParent_Done,
     /* 1089881 */   // Label 16060: @1089881
     /* 1089881 */   GIM_Try, /*On fail goto*//*Label 16061*/ GIMT_Encode4(1089958), // Rule ID 60709 //
     /* 1089886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1089897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1089900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1089913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089925 */     // MIs[0] policy
     /* 1089925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089935 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089944 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089957 */     // GIR_Coverage, 60709,
     /* 1089957 */     GIR_EraseRootFromParent_Done,
     /* 1089958 */   // Label 16061: @1089958
     /* 1089958 */   GIM_Try, /*On fail goto*//*Label 16062*/ GIMT_Encode4(1090035), // Rule ID 60712 //
     /* 1089963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1089974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1089977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090002 */     // MIs[0] policy
     /* 1090002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090012 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1090015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090034 */     // GIR_Coverage, 60712,
     /* 1090034 */     GIR_EraseRootFromParent_Done,
     /* 1090035 */   // Label 16062: @1090035
     /* 1090035 */   GIM_Try, /*On fail goto*//*Label 16063*/ GIMT_Encode4(1090112), // Rule ID 60713 //
     /* 1090040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1090051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1090054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1090057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1090067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1090071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1090075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090079 */     // MIs[0] policy
     /* 1090079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090089 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1090092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090098 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090111 */     // GIR_Coverage, 60713,
     /* 1090111 */     GIR_EraseRootFromParent_Done,
     /* 1090112 */   // Label 16063: @1090112
     /* 1090112 */   GIM_Try, /*On fail goto*//*Label 16064*/ GIMT_Encode4(1090189), // Rule ID 60716 //
     /* 1090117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1090128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1090131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1090134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1090137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1090144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090156 */     // MIs[0] policy
     /* 1090156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090166 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1090169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090188 */     // GIR_Coverage, 60716,
     /* 1090188 */     GIR_EraseRootFromParent_Done,
     /* 1090189 */   // Label 16064: @1090189
     /* 1090189 */   GIM_Try, /*On fail goto*//*Label 16065*/ GIMT_Encode4(1090266), // Rule ID 60717 //
     /* 1090194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1090205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1090208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1090211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1090214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1090221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090233 */     // MIs[0] policy
     /* 1090233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090243 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1090246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090252 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090265 */     // GIR_Coverage, 60717,
     /* 1090265 */     GIR_EraseRootFromParent_Done,
     /* 1090266 */   // Label 16065: @1090266
     /* 1090266 */   GIM_Try, /*On fail goto*//*Label 16066*/ GIMT_Encode4(1090343), // Rule ID 60720 //
     /* 1090271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1090282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1090285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1090288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090310 */     // MIs[0] policy
     /* 1090310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090320 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1090323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090342 */     // GIR_Coverage, 60720,
     /* 1090342 */     GIR_EraseRootFromParent_Done,
     /* 1090343 */   // Label 16066: @1090343
     /* 1090343 */   GIM_Try, /*On fail goto*//*Label 16067*/ GIMT_Encode4(1090420), // Rule ID 60721 //
     /* 1090348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1090359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1090362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1090365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090387 */     // MIs[0] policy
     /* 1090387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090397 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1090400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090406 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090419 */     // GIR_Coverage, 60721,
     /* 1090419 */     GIR_EraseRootFromParent_Done,
     /* 1090420 */   // Label 16067: @1090420
     /* 1090420 */   GIM_Try, /*On fail goto*//*Label 16068*/ GIMT_Encode4(1090497), // Rule ID 60724 //
     /* 1090425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1090436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1090439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1090442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090464 */     // MIs[0] policy
     /* 1090464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090474 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090496 */     // GIR_Coverage, 60724,
     /* 1090496 */     GIR_EraseRootFromParent_Done,
     /* 1090497 */   // Label 16068: @1090497
     /* 1090497 */   GIM_Try, /*On fail goto*//*Label 16069*/ GIMT_Encode4(1090574), // Rule ID 60725 //
     /* 1090502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1090513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1090516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1090519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090541 */     // MIs[0] policy
     /* 1090541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090551 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090560 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090573 */     // GIR_Coverage, 60725,
     /* 1090573 */     GIR_EraseRootFromParent_Done,
     /* 1090574 */   // Label 16069: @1090574
     /* 1090574 */   GIM_Try, /*On fail goto*//*Label 16070*/ GIMT_Encode4(1090651), // Rule ID 60728 //
     /* 1090579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1090590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1090593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1090596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090618 */     // MIs[0] policy
     /* 1090618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090628 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090650 */     // GIR_Coverage, 60728,
     /* 1090650 */     GIR_EraseRootFromParent_Done,
     /* 1090651 */   // Label 16070: @1090651
     /* 1090651 */   GIM_Try, /*On fail goto*//*Label 16071*/ GIMT_Encode4(1090728), // Rule ID 60729 //
     /* 1090656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1090667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1090670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1090673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090695 */     // MIs[0] policy
     /* 1090695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090705 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090714 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090727 */     // GIR_Coverage, 60729,
     /* 1090727 */     GIR_EraseRootFromParent_Done,
     /* 1090728 */   // Label 16071: @1090728
     /* 1090728 */   GIM_Try, /*On fail goto*//*Label 16072*/ GIMT_Encode4(1090805), // Rule ID 60732 //
     /* 1090733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1090744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1090747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1090750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090772 */     // MIs[0] policy
     /* 1090772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090782 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090804 */     // GIR_Coverage, 60732,
     /* 1090804 */     GIR_EraseRootFromParent_Done,
     /* 1090805 */   // Label 16072: @1090805
     /* 1090805 */   GIM_Try, /*On fail goto*//*Label 16073*/ GIMT_Encode4(1090882), // Rule ID 60733 //
     /* 1090810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1090821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1090824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1090827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090849 */     // MIs[0] policy
     /* 1090849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090859 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090881 */     // GIR_Coverage, 60733,
     /* 1090881 */     GIR_EraseRootFromParent_Done,
     /* 1090882 */   // Label 16073: @1090882
     /* 1090882 */   GIM_Try, /*On fail goto*//*Label 16074*/ GIMT_Encode4(1090959), // Rule ID 60736 //
     /* 1090887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1090898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1090901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1090904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090926 */     // MIs[0] policy
     /* 1090926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090936 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090958 */     // GIR_Coverage, 60736,
     /* 1090958 */     GIR_EraseRootFromParent_Done,
     /* 1090959 */   // Label 16074: @1090959
     /* 1090959 */   GIM_Try, /*On fail goto*//*Label 16075*/ GIMT_Encode4(1091036), // Rule ID 60737 //
     /* 1090964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1090975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1090978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1090981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091003 */     // MIs[0] policy
     /* 1091003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091013 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1091016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091022 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091035 */     // GIR_Coverage, 60737,
     /* 1091035 */     GIR_EraseRootFromParent_Done,
     /* 1091036 */   // Label 16075: @1091036
     /* 1091036 */   GIM_Try, /*On fail goto*//*Label 16076*/ GIMT_Encode4(1091113), // Rule ID 60740 //
     /* 1091041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1091052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1091055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1091058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091080 */     // MIs[0] policy
     /* 1091080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091090 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1091093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091112 */     // GIR_Coverage, 60740,
     /* 1091112 */     GIR_EraseRootFromParent_Done,
     /* 1091113 */   // Label 16076: @1091113
     /* 1091113 */   GIM_Try, /*On fail goto*//*Label 16077*/ GIMT_Encode4(1091190), // Rule ID 60741 //
     /* 1091118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1091129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1091132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1091135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091157 */     // MIs[0] policy
     /* 1091157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091167 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1091170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091176 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091189 */     // GIR_Coverage, 60741,
     /* 1091189 */     GIR_EraseRootFromParent_Done,
     /* 1091190 */   // Label 16077: @1091190
     /* 1091190 */   GIM_Try, /*On fail goto*//*Label 16078*/ GIMT_Encode4(1091267), // Rule ID 60744 //
     /* 1091195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1091206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1091209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1091212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091234 */     // MIs[0] policy
     /* 1091234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091244 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091266 */     // GIR_Coverage, 60744,
     /* 1091266 */     GIR_EraseRootFromParent_Done,
     /* 1091267 */   // Label 16078: @1091267
     /* 1091267 */   GIM_Try, /*On fail goto*//*Label 16079*/ GIMT_Encode4(1091344), // Rule ID 60745 //
     /* 1091272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1091283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1091286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1091289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091311 */     // MIs[0] policy
     /* 1091311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091321 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091330 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091343 */     // GIR_Coverage, 60745,
     /* 1091343 */     GIR_EraseRootFromParent_Done,
     /* 1091344 */   // Label 16079: @1091344
     /* 1091344 */   GIM_Try, /*On fail goto*//*Label 16080*/ GIMT_Encode4(1091421), // Rule ID 60748 //
     /* 1091349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1091360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1091363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1091366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1091369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091388 */     // MIs[0] policy
     /* 1091388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091420 */     // GIR_Coverage, 60748,
     /* 1091420 */     GIR_EraseRootFromParent_Done,
     /* 1091421 */   // Label 16080: @1091421
     /* 1091421 */   GIM_Try, /*On fail goto*//*Label 16081*/ GIMT_Encode4(1091498), // Rule ID 60749 //
     /* 1091426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1091437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1091440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1091443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1091446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091465 */     // MIs[0] policy
     /* 1091465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091475 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091484 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091497 */     // GIR_Coverage, 60749,
     /* 1091497 */     GIR_EraseRootFromParent_Done,
     /* 1091498 */   // Label 16081: @1091498
     /* 1091498 */   GIM_Try, /*On fail goto*//*Label 16082*/ GIMT_Encode4(1091575), // Rule ID 60752 //
     /* 1091503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1091514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1091517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1091520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1091523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091542 */     // MIs[0] policy
     /* 1091542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091574 */     // GIR_Coverage, 60752,
     /* 1091574 */     GIR_EraseRootFromParent_Done,
     /* 1091575 */   // Label 16082: @1091575
     /* 1091575 */   GIM_Try, /*On fail goto*//*Label 16083*/ GIMT_Encode4(1091652), // Rule ID 60753 //
     /* 1091580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1091591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1091594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1091597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1091600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091619 */     // MIs[0] policy
     /* 1091619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091629 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091638 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091651 */     // GIR_Coverage, 60753,
     /* 1091651 */     GIR_EraseRootFromParent_Done,
     /* 1091652 */   // Label 16083: @1091652
     /* 1091652 */   GIM_Try, /*On fail goto*//*Label 16084*/ GIMT_Encode4(1091729), // Rule ID 60756 //
     /* 1091657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1091668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1091671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1091674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091696 */     // MIs[0] policy
     /* 1091696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091728 */     // GIR_Coverage, 60756,
     /* 1091728 */     GIR_EraseRootFromParent_Done,
     /* 1091729 */   // Label 16084: @1091729
     /* 1091729 */   GIM_Try, /*On fail goto*//*Label 16085*/ GIMT_Encode4(1091806), // Rule ID 60757 //
     /* 1091734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1091745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1091748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1091751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091773 */     // MIs[0] policy
     /* 1091773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091783 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091792 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091805 */     // GIR_Coverage, 60757,
     /* 1091805 */     GIR_EraseRootFromParent_Done,
     /* 1091806 */   // Label 16085: @1091806
     /* 1091806 */   GIM_Try, /*On fail goto*//*Label 16086*/ GIMT_Encode4(1091883), // Rule ID 60760 //
     /* 1091811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1091822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1091825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1091828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091850 */     // MIs[0] policy
     /* 1091850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091860 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091882 */     // GIR_Coverage, 60760,
     /* 1091882 */     GIR_EraseRootFromParent_Done,
     /* 1091883 */   // Label 16086: @1091883
     /* 1091883 */   GIM_Try, /*On fail goto*//*Label 16087*/ GIMT_Encode4(1091960), // Rule ID 60761 //
     /* 1091888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1091899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1091902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1091905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091927 */     // MIs[0] policy
     /* 1091927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091937 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091946 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091959 */     // GIR_Coverage, 60761,
     /* 1091959 */     GIR_EraseRootFromParent_Done,
     /* 1091960 */   // Label 16087: @1091960
     /* 1091960 */   GIM_Try, /*On fail goto*//*Label 16088*/ GIMT_Encode4(1092037), // Rule ID 60764 //
     /* 1091965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1091976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1091979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1091982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1091985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092004 */     // MIs[0] policy
     /* 1092004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092014 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092036 */     // GIR_Coverage, 60764,
     /* 1092036 */     GIR_EraseRootFromParent_Done,
     /* 1092037 */   // Label 16088: @1092037
     /* 1092037 */   GIM_Try, /*On fail goto*//*Label 16089*/ GIMT_Encode4(1092114), // Rule ID 60765 //
     /* 1092042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1092053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1092056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1092059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092081 */     // MIs[0] policy
     /* 1092081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092091 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092113 */     // GIR_Coverage, 60765,
     /* 1092113 */     GIR_EraseRootFromParent_Done,
     /* 1092114 */   // Label 16089: @1092114
     /* 1092114 */   GIM_Try, /*On fail goto*//*Label 16090*/ GIMT_Encode4(1092191), // Rule ID 60768 //
     /* 1092119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1092130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1092133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1092136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1092139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092158 */     // MIs[0] policy
     /* 1092158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092168 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092190 */     // GIR_Coverage, 60768,
     /* 1092190 */     GIR_EraseRootFromParent_Done,
     /* 1092191 */   // Label 16090: @1092191
     /* 1092191 */   GIM_Try, /*On fail goto*//*Label 16091*/ GIMT_Encode4(1092268), // Rule ID 60769 //
     /* 1092196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1092207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1092210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1092213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1092216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092235 */     // MIs[0] policy
     /* 1092235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092245 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092254 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092267 */     // GIR_Coverage, 60769,
     /* 1092267 */     GIR_EraseRootFromParent_Done,
     /* 1092268 */   // Label 16091: @1092268
     /* 1092268 */   GIM_Try, /*On fail goto*//*Label 16092*/ GIMT_Encode4(1092345), // Rule ID 60772 //
     /* 1092273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1092284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1092287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1092290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092312 */     // MIs[0] policy
     /* 1092312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092322 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092344 */     // GIR_Coverage, 60772,
     /* 1092344 */     GIR_EraseRootFromParent_Done,
     /* 1092345 */   // Label 16092: @1092345
     /* 1092345 */   GIM_Try, /*On fail goto*//*Label 16093*/ GIMT_Encode4(1092422), // Rule ID 60773 //
     /* 1092350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1092361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1092364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1092367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092389 */     // MIs[0] policy
     /* 1092389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092399 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092421 */     // GIR_Coverage, 60773,
     /* 1092421 */     GIR_EraseRootFromParent_Done,
     /* 1092422 */   // Label 16093: @1092422
     /* 1092422 */   GIM_Try, /*On fail goto*//*Label 16094*/ GIMT_Encode4(1092499), // Rule ID 60776 //
     /* 1092427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1092438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1092441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1092444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092466 */     // MIs[0] policy
     /* 1092466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092476 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092498 */     // GIR_Coverage, 60776,
     /* 1092498 */     GIR_EraseRootFromParent_Done,
     /* 1092499 */   // Label 16094: @1092499
     /* 1092499 */   GIM_Try, /*On fail goto*//*Label 16095*/ GIMT_Encode4(1092576), // Rule ID 60777 //
     /* 1092504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1092515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1092518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1092521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092543 */     // MIs[0] policy
     /* 1092543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092553 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092562 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092575 */     // GIR_Coverage, 60777,
     /* 1092575 */     GIR_EraseRootFromParent_Done,
     /* 1092576 */   // Label 16095: @1092576
     /* 1092576 */   GIM_Try, /*On fail goto*//*Label 16096*/ GIMT_Encode4(1092653), // Rule ID 60780 //
     /* 1092581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1092592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1092595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1092598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092620 */     // MIs[0] policy
     /* 1092620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092630 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092652 */     // GIR_Coverage, 60780,
     /* 1092652 */     GIR_EraseRootFromParent_Done,
     /* 1092653 */   // Label 16096: @1092653
     /* 1092653 */   GIM_Try, /*On fail goto*//*Label 16097*/ GIMT_Encode4(1092730), // Rule ID 60781 //
     /* 1092658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1092669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1092672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1092675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092697 */     // MIs[0] policy
     /* 1092697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092707 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092729 */     // GIR_Coverage, 60781,
     /* 1092729 */     GIR_EraseRootFromParent_Done,
     /* 1092730 */   // Label 16097: @1092730
     /* 1092730 */   GIM_Try, /*On fail goto*//*Label 16098*/ GIMT_Encode4(1092807), // Rule ID 60784 //
     /* 1092735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1092746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1092749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1092752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092774 */     // MIs[0] policy
     /* 1092774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092806 */     // GIR_Coverage, 60784,
     /* 1092806 */     GIR_EraseRootFromParent_Done,
     /* 1092807 */   // Label 16098: @1092807
     /* 1092807 */   GIM_Try, /*On fail goto*//*Label 16099*/ GIMT_Encode4(1092884), // Rule ID 60785 //
     /* 1092812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1092823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1092826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1092829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092851 */     // MIs[0] policy
     /* 1092851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092861 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092870 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092883 */     // GIR_Coverage, 60785,
     /* 1092883 */     GIR_EraseRootFromParent_Done,
     /* 1092884 */   // Label 16099: @1092884
     /* 1092884 */   GIM_Try, /*On fail goto*//*Label 16100*/ GIMT_Encode4(1092961), // Rule ID 60788 //
     /* 1092889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1092900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1092903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092928 */     // MIs[0] policy
     /* 1092928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092938 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092960 */     // GIR_Coverage, 60788,
     /* 1092960 */     GIR_EraseRootFromParent_Done,
     /* 1092961 */   // Label 16100: @1092961
     /* 1092961 */   GIM_Try, /*On fail goto*//*Label 16101*/ GIMT_Encode4(1093038), // Rule ID 60789 //
     /* 1092966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1092977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1092980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093005 */     // MIs[0] policy
     /* 1093005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093015 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1093018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093024 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093037 */     // GIR_Coverage, 60789,
     /* 1093037 */     GIR_EraseRootFromParent_Done,
     /* 1093038 */   // Label 16101: @1093038
     /* 1093038 */   GIM_Try, /*On fail goto*//*Label 16102*/ GIMT_Encode4(1093115), // Rule ID 60792 //
     /* 1093043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1093054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1093057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1093060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1093063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093082 */     // MIs[0] policy
     /* 1093082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093092 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1093095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093114 */     // GIR_Coverage, 60792,
     /* 1093114 */     GIR_EraseRootFromParent_Done,
     /* 1093115 */   // Label 16102: @1093115
     /* 1093115 */   GIM_Try, /*On fail goto*//*Label 16103*/ GIMT_Encode4(1093192), // Rule ID 60793 //
     /* 1093120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1093131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1093134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1093137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1093140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093159 */     // MIs[0] policy
     /* 1093159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093169 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1093172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093178 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093191 */     // GIR_Coverage, 60793,
     /* 1093191 */     GIR_EraseRootFromParent_Done,
     /* 1093192 */   // Label 16103: @1093192
     /* 1093192 */   GIM_Try, /*On fail goto*//*Label 16104*/ GIMT_Encode4(1093269), // Rule ID 60796 //
     /* 1093197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1093208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1093211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1093214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1093224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093236 */     // MIs[0] policy
     /* 1093236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1093249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093268 */     // GIR_Coverage, 60796,
     /* 1093268 */     GIR_EraseRootFromParent_Done,
     /* 1093269 */   // Label 16104: @1093269
     /* 1093269 */   GIM_Try, /*On fail goto*//*Label 16105*/ GIMT_Encode4(1093346), // Rule ID 60797 //
     /* 1093274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1093285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1093288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1093291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1093301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093313 */     // MIs[0] policy
     /* 1093313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093323 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1093326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093345 */     // GIR_Coverage, 60797,
     /* 1093345 */     GIR_EraseRootFromParent_Done,
     /* 1093346 */   // Label 16105: @1093346
     /* 1093346 */   GIM_Try, /*On fail goto*//*Label 16106*/ GIMT_Encode4(1093423), // Rule ID 60800 //
     /* 1093351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1093362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1093365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1093368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1093378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093390 */     // MIs[0] policy
     /* 1093390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093400 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1093403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093422 */     // GIR_Coverage, 60800,
     /* 1093422 */     GIR_EraseRootFromParent_Done,
     /* 1093423 */   // Label 16106: @1093423
     /* 1093423 */   GIM_Try, /*On fail goto*//*Label 16107*/ GIMT_Encode4(1093500), // Rule ID 60801 //
     /* 1093428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1093439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1093442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1093445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1093455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093467 */     // MIs[0] policy
     /* 1093467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093477 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1093480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093486 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093499 */     // GIR_Coverage, 60801,
     /* 1093499 */     GIR_EraseRootFromParent_Done,
     /* 1093500 */   // Label 16107: @1093500
     /* 1093500 */   GIM_Try, /*On fail goto*//*Label 16108*/ GIMT_Encode4(1093577), // Rule ID 60804 //
     /* 1093505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1093516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1093519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1093522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093544 */     // MIs[0] policy
     /* 1093544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093554 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1093557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093576 */     // GIR_Coverage, 60804,
     /* 1093576 */     GIR_EraseRootFromParent_Done,
     /* 1093577 */   // Label 16108: @1093577
     /* 1093577 */   GIM_Try, /*On fail goto*//*Label 16109*/ GIMT_Encode4(1093654), // Rule ID 60805 //
     /* 1093582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1093593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1093596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1093599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093621 */     // MIs[0] policy
     /* 1093621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093631 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1093634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093640 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093653 */     // GIR_Coverage, 60805,
     /* 1093653 */     GIR_EraseRootFromParent_Done,
     /* 1093654 */   // Label 16109: @1093654
     /* 1093654 */   GIM_Try, /*On fail goto*//*Label 16110*/ GIMT_Encode4(1093731), // Rule ID 60808 //
     /* 1093659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1093670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1093673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1093676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093698 */     // MIs[0] policy
     /* 1093698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093708 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1093711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093730 */     // GIR_Coverage, 60808,
     /* 1093730 */     GIR_EraseRootFromParent_Done,
     /* 1093731 */   // Label 16110: @1093731
     /* 1093731 */   GIM_Try, /*On fail goto*//*Label 16111*/ GIMT_Encode4(1093808), // Rule ID 60809 //
     /* 1093736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1093747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1093750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1093753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093775 */     // MIs[0] policy
     /* 1093775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093785 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1093788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093794 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093807 */     // GIR_Coverage, 60809,
     /* 1093807 */     GIR_EraseRootFromParent_Done,
     /* 1093808 */   // Label 16111: @1093808
     /* 1093808 */   GIM_Try, /*On fail goto*//*Label 16112*/ GIMT_Encode4(1093885), // Rule ID 60812 //
     /* 1093813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1093824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1093827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1093830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093852 */     // MIs[0] policy
     /* 1093852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093862 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093884 */     // GIR_Coverage, 60812,
     /* 1093884 */     GIR_EraseRootFromParent_Done,
     /* 1093885 */   // Label 16112: @1093885
     /* 1093885 */   GIM_Try, /*On fail goto*//*Label 16113*/ GIMT_Encode4(1093962), // Rule ID 60813 //
     /* 1093890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1093901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1093904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1093907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093929 */     // MIs[0] policy
     /* 1093929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093939 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093948 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093961 */     // GIR_Coverage, 60813,
     /* 1093961 */     GIR_EraseRootFromParent_Done,
     /* 1093962 */   // Label 16113: @1093962
     /* 1093962 */   GIM_Try, /*On fail goto*//*Label 16114*/ GIMT_Encode4(1094039), // Rule ID 60816 //
     /* 1093967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1093978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1093981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1093984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094006 */     // MIs[0] policy
     /* 1094006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094016 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094038 */     // GIR_Coverage, 60816,
     /* 1094038 */     GIR_EraseRootFromParent_Done,
     /* 1094039 */   // Label 16114: @1094039
     /* 1094039 */   GIM_Try, /*On fail goto*//*Label 16115*/ GIMT_Encode4(1094116), // Rule ID 60817 //
     /* 1094044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1094055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1094058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1094061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094083 */     // MIs[0] policy
     /* 1094083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094093 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094102 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094115 */     // GIR_Coverage, 60817,
     /* 1094115 */     GIR_EraseRootFromParent_Done,
     /* 1094116 */   // Label 16115: @1094116
     /* 1094116 */   GIM_Try, /*On fail goto*//*Label 16116*/ GIMT_Encode4(1094193), // Rule ID 60820 //
     /* 1094121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1094132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1094135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1094138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094160 */     // MIs[0] policy
     /* 1094160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094170 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1094173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094192 */     // GIR_Coverage, 60820,
     /* 1094192 */     GIR_EraseRootFromParent_Done,
     /* 1094193 */   // Label 16116: @1094193
     /* 1094193 */   GIM_Try, /*On fail goto*//*Label 16117*/ GIMT_Encode4(1094270), // Rule ID 60821 //
     /* 1094198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1094209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1094212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1094215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094237 */     // MIs[0] policy
     /* 1094237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094247 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1094250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094256 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094269 */     // GIR_Coverage, 60821,
     /* 1094269 */     GIR_EraseRootFromParent_Done,
     /* 1094270 */   // Label 16117: @1094270
     /* 1094270 */   GIM_Try, /*On fail goto*//*Label 16118*/ GIMT_Encode4(1094347), // Rule ID 60824 //
     /* 1094275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1094286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1094289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1094292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094314 */     // MIs[0] policy
     /* 1094314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094324 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094346 */     // GIR_Coverage, 60824,
     /* 1094346 */     GIR_EraseRootFromParent_Done,
     /* 1094347 */   // Label 16118: @1094347
     /* 1094347 */   GIM_Try, /*On fail goto*//*Label 16119*/ GIMT_Encode4(1094424), // Rule ID 60825 //
     /* 1094352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1094363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1094366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1094369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094391 */     // MIs[0] policy
     /* 1094391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094401 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094410 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094423 */     // GIR_Coverage, 60825,
     /* 1094423 */     GIR_EraseRootFromParent_Done,
     /* 1094424 */   // Label 16119: @1094424
     /* 1094424 */   GIM_Try, /*On fail goto*//*Label 16120*/ GIMT_Encode4(1094501), // Rule ID 60828 //
     /* 1094429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1094440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1094443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1094446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094468 */     // MIs[0] policy
     /* 1094468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094500 */     // GIR_Coverage, 60828,
     /* 1094500 */     GIR_EraseRootFromParent_Done,
     /* 1094501 */   // Label 16120: @1094501
     /* 1094501 */   GIM_Try, /*On fail goto*//*Label 16121*/ GIMT_Encode4(1094578), // Rule ID 60829 //
     /* 1094506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1094517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1094520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1094523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094545 */     // MIs[0] policy
     /* 1094545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094555 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094564 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094577 */     // GIR_Coverage, 60829,
     /* 1094577 */     GIR_EraseRootFromParent_Done,
     /* 1094578 */   // Label 16121: @1094578
     /* 1094578 */   GIM_Try, /*On fail goto*//*Label 16122*/ GIMT_Encode4(1094655), // Rule ID 60832 //
     /* 1094583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1094594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1094597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1094600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094622 */     // MIs[0] policy
     /* 1094622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094632 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094654 */     // GIR_Coverage, 60832,
     /* 1094654 */     GIR_EraseRootFromParent_Done,
     /* 1094655 */   // Label 16122: @1094655
     /* 1094655 */   GIM_Try, /*On fail goto*//*Label 16123*/ GIMT_Encode4(1094732), // Rule ID 60833 //
     /* 1094660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1094671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1094674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1094677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094699 */     // MIs[0] policy
     /* 1094699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094709 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094718 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094731 */     // GIR_Coverage, 60833,
     /* 1094731 */     GIR_EraseRootFromParent_Done,
     /* 1094732 */   // Label 16123: @1094732
     /* 1094732 */   GIM_Try, /*On fail goto*//*Label 16124*/ GIMT_Encode4(1094809), // Rule ID 60836 //
     /* 1094737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094776 */     // MIs[0] policy
     /* 1094776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094808 */     // GIR_Coverage, 60836,
     /* 1094808 */     GIR_EraseRootFromParent_Done,
     /* 1094809 */   // Label 16124: @1094809
     /* 1094809 */   GIM_Try, /*On fail goto*//*Label 16125*/ GIMT_Encode4(1094886), // Rule ID 60837 //
     /* 1094814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094853 */     // MIs[0] policy
     /* 1094853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094863 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094872 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094885 */     // GIR_Coverage, 60837,
     /* 1094885 */     GIR_EraseRootFromParent_Done,
     /* 1094886 */   // Label 16125: @1094886
     /* 1094886 */   GIM_Try, /*On fail goto*//*Label 16126*/ GIMT_Encode4(1094963), // Rule ID 60840 //
     /* 1094891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1094902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094930 */     // MIs[0] policy
     /* 1094930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094962 */     // GIR_Coverage, 60840,
     /* 1094962 */     GIR_EraseRootFromParent_Done,
     /* 1094963 */   // Label 16126: @1094963
     /* 1094963 */   GIM_Try, /*On fail goto*//*Label 16127*/ GIMT_Encode4(1095040), // Rule ID 60841 //
     /* 1094968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1094979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095007 */     // MIs[0] policy
     /* 1095007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095017 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1095020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095026 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095039 */     // GIR_Coverage, 60841,
     /* 1095039 */     GIR_EraseRootFromParent_Done,
     /* 1095040 */   // Label 16127: @1095040
     /* 1095040 */   GIM_Try, /*On fail goto*//*Label 16128*/ GIMT_Encode4(1095117), // Rule ID 60844 //
     /* 1095045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1095056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1095059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1095062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1095065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1095072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095084 */     // MIs[0] policy
     /* 1095084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1095097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095116 */     // GIR_Coverage, 60844,
     /* 1095116 */     GIR_EraseRootFromParent_Done,
     /* 1095117 */   // Label 16128: @1095117
     /* 1095117 */   GIM_Try, /*On fail goto*//*Label 16129*/ GIMT_Encode4(1095194), // Rule ID 60845 //
     /* 1095122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1095133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1095136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1095139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1095142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1095149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095161 */     // MIs[0] policy
     /* 1095161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095171 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1095174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095180 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095193 */     // GIR_Coverage, 60845,
     /* 1095193 */     GIR_EraseRootFromParent_Done,
     /* 1095194 */   // Label 16129: @1095194
     /* 1095194 */   GIM_Try, /*On fail goto*//*Label 16130*/ GIMT_Encode4(1095271), // Rule ID 60848 //
     /* 1095199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1095210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1095213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1095216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095238 */     // MIs[0] policy
     /* 1095238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095270 */     // GIR_Coverage, 60848,
     /* 1095270 */     GIR_EraseRootFromParent_Done,
     /* 1095271 */   // Label 16130: @1095271
     /* 1095271 */   GIM_Try, /*On fail goto*//*Label 16131*/ GIMT_Encode4(1095348), // Rule ID 60849 //
     /* 1095276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1095287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1095290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1095293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095315 */     // MIs[0] policy
     /* 1095315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095325 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095334 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095347 */     // GIR_Coverage, 60849,
     /* 1095347 */     GIR_EraseRootFromParent_Done,
     /* 1095348 */   // Label 16131: @1095348
     /* 1095348 */   GIM_Try, /*On fail goto*//*Label 16132*/ GIMT_Encode4(1095425), // Rule ID 60852 //
     /* 1095353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1095364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1095367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1095370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095392 */     // MIs[0] policy
     /* 1095392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095402 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095424 */     // GIR_Coverage, 60852,
     /* 1095424 */     GIR_EraseRootFromParent_Done,
     /* 1095425 */   // Label 16132: @1095425
     /* 1095425 */   GIM_Try, /*On fail goto*//*Label 16133*/ GIMT_Encode4(1095502), // Rule ID 60853 //
     /* 1095430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1095441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1095444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1095447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095469 */     // MIs[0] policy
     /* 1095469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095479 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095488 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095501 */     // GIR_Coverage, 60853,
     /* 1095501 */     GIR_EraseRootFromParent_Done,
     /* 1095502 */   // Label 16133: @1095502
     /* 1095502 */   GIM_Try, /*On fail goto*//*Label 16134*/ GIMT_Encode4(1095579), // Rule ID 60856 //
     /* 1095507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1095518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1095521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1095524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1095527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095546 */     // MIs[0] policy
     /* 1095546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095556 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095565 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095578 */     // GIR_Coverage, 60856,
     /* 1095578 */     GIR_EraseRootFromParent_Done,
     /* 1095579 */   // Label 16134: @1095579
     /* 1095579 */   GIM_Try, /*On fail goto*//*Label 16135*/ GIMT_Encode4(1095656), // Rule ID 60857 //
     /* 1095584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1095595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1095598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1095601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1095604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095623 */     // MIs[0] policy
     /* 1095623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095633 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095642 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095655 */     // GIR_Coverage, 60857,
     /* 1095655 */     GIR_EraseRootFromParent_Done,
     /* 1095656 */   // Label 16135: @1095656
     /* 1095656 */   GIM_Try, /*On fail goto*//*Label 16136*/ GIMT_Encode4(1095733), // Rule ID 60860 //
     /* 1095661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095700 */     // MIs[0] policy
     /* 1095700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095710 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095732 */     // GIR_Coverage, 60860,
     /* 1095732 */     GIR_EraseRootFromParent_Done,
     /* 1095733 */   // Label 16136: @1095733
     /* 1095733 */   GIM_Try, /*On fail goto*//*Label 16137*/ GIMT_Encode4(1095810), // Rule ID 60861 //
     /* 1095738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095777 */     // MIs[0] policy
     /* 1095777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095787 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095796 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095809 */     // GIR_Coverage, 60861,
     /* 1095809 */     GIR_EraseRootFromParent_Done,
     /* 1095810 */   // Label 16137: @1095810
     /* 1095810 */   GIM_Try, /*On fail goto*//*Label 16138*/ GIMT_Encode4(1095887), // Rule ID 60864 //
     /* 1095815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095854 */     // MIs[0] policy
     /* 1095854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095864 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095886 */     // GIR_Coverage, 60864,
     /* 1095886 */     GIR_EraseRootFromParent_Done,
     /* 1095887 */   // Label 16138: @1095887
     /* 1095887 */   GIM_Try, /*On fail goto*//*Label 16139*/ GIMT_Encode4(1095964), // Rule ID 60865 //
     /* 1095892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095931 */     // MIs[0] policy
     /* 1095931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095941 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095950 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095963 */     // GIR_Coverage, 60865,
     /* 1095963 */     GIR_EraseRootFromParent_Done,
     /* 1095964 */   // Label 16139: @1095964
     /* 1095964 */   GIM_Try, /*On fail goto*//*Label 16140*/ GIMT_Encode4(1096041), // Rule ID 60868 //
     /* 1095969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1095980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1095983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1095986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096008 */     // MIs[0] policy
     /* 1096008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096018 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096040 */     // GIR_Coverage, 60868,
     /* 1096040 */     GIR_EraseRootFromParent_Done,
     /* 1096041 */   // Label 16140: @1096041
     /* 1096041 */   GIM_Try, /*On fail goto*//*Label 16141*/ GIMT_Encode4(1096118), // Rule ID 60869 //
     /* 1096046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1096057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1096060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1096063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1096066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096085 */     // MIs[0] policy
     /* 1096085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096095 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096104 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096117 */     // GIR_Coverage, 60869,
     /* 1096117 */     GIR_EraseRootFromParent_Done,
     /* 1096118 */   // Label 16141: @1096118
     /* 1096118 */   GIM_Try, /*On fail goto*//*Label 16142*/ GIMT_Encode4(1096195), // Rule ID 60872 //
     /* 1096123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1096134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1096137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1096140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096162 */     // MIs[0] policy
     /* 1096162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1096175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096194 */     // GIR_Coverage, 60872,
     /* 1096194 */     GIR_EraseRootFromParent_Done,
     /* 1096195 */   // Label 16142: @1096195
     /* 1096195 */   GIM_Try, /*On fail goto*//*Label 16143*/ GIMT_Encode4(1096272), // Rule ID 60873 //
     /* 1096200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1096211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1096214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1096217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096239 */     // MIs[0] policy
     /* 1096239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096249 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1096252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096258 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096271 */     // GIR_Coverage, 60873,
     /* 1096271 */     GIR_EraseRootFromParent_Done,
     /* 1096272 */   // Label 16143: @1096272
     /* 1096272 */   GIM_Try, /*On fail goto*//*Label 16144*/ GIMT_Encode4(1096349), // Rule ID 60876 //
     /* 1096277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1096288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1096291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1096294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096316 */     // MIs[0] policy
     /* 1096316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096326 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1096329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096348 */     // GIR_Coverage, 60876,
     /* 1096348 */     GIR_EraseRootFromParent_Done,
     /* 1096349 */   // Label 16144: @1096349
     /* 1096349 */   GIM_Try, /*On fail goto*//*Label 16145*/ GIMT_Encode4(1096426), // Rule ID 60877 //
     /* 1096354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1096365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1096368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1096371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096393 */     // MIs[0] policy
     /* 1096393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096403 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1096406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096412 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096425 */     // GIR_Coverage, 60877,
     /* 1096425 */     GIR_EraseRootFromParent_Done,
     /* 1096426 */   // Label 16145: @1096426
     /* 1096426 */   GIM_Try, /*On fail goto*//*Label 16146*/ GIMT_Encode4(1096503), // Rule ID 60880 //
     /* 1096431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1096442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1096445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1096448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1096451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096470 */     // MIs[0] policy
     /* 1096470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096480 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096502 */     // GIR_Coverage, 60880,
     /* 1096502 */     GIR_EraseRootFromParent_Done,
     /* 1096503 */   // Label 16146: @1096503
     /* 1096503 */   GIM_Try, /*On fail goto*//*Label 16147*/ GIMT_Encode4(1096580), // Rule ID 60881 //
     /* 1096508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1096519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1096522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1096525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1096528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096547 */     // MIs[0] policy
     /* 1096547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096557 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096566 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096579 */     // GIR_Coverage, 60881,
     /* 1096579 */     GIR_EraseRootFromParent_Done,
     /* 1096580 */   // Label 16147: @1096580
     /* 1096580 */   GIM_Try, /*On fail goto*//*Label 16148*/ GIMT_Encode4(1096657), // Rule ID 60884 //
     /* 1096585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096624 */     // MIs[0] policy
     /* 1096624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096634 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1096637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096643 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096656 */     // GIR_Coverage, 60884,
     /* 1096656 */     GIR_EraseRootFromParent_Done,
     /* 1096657 */   // Label 16148: @1096657
     /* 1096657 */   GIM_Try, /*On fail goto*//*Label 16149*/ GIMT_Encode4(1096734), // Rule ID 60885 //
     /* 1096662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096701 */     // MIs[0] policy
     /* 1096701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096711 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1096714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096720 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096733 */     // GIR_Coverage, 60885,
     /* 1096733 */     GIR_EraseRootFromParent_Done,
     /* 1096734 */   // Label 16149: @1096734
     /* 1096734 */   GIM_Try, /*On fail goto*//*Label 16150*/ GIMT_Encode4(1096811), // Rule ID 60888 //
     /* 1096739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096778 */     // MIs[0] policy
     /* 1096778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096788 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1096791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096810 */     // GIR_Coverage, 60888,
     /* 1096810 */     GIR_EraseRootFromParent_Done,
     /* 1096811 */   // Label 16150: @1096811
     /* 1096811 */   GIM_Try, /*On fail goto*//*Label 16151*/ GIMT_Encode4(1096888), // Rule ID 60889 //
     /* 1096816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096855 */     // MIs[0] policy
     /* 1096855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096865 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1096868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096874 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096887 */     // GIR_Coverage, 60889,
     /* 1096887 */     GIR_EraseRootFromParent_Done,
     /* 1096888 */   // Label 16151: @1096888
     /* 1096888 */   GIM_Try, /*On fail goto*//*Label 16152*/ GIMT_Encode4(1096965), // Rule ID 60892 //
     /* 1096893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096932 */     // MIs[0] policy
     /* 1096932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096964 */     // GIR_Coverage, 60892,
     /* 1096964 */     GIR_EraseRootFromParent_Done,
     /* 1096965 */   // Label 16152: @1096965
     /* 1096965 */   GIM_Try, /*On fail goto*//*Label 16153*/ GIMT_Encode4(1097042), // Rule ID 60893 //
     /* 1096970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1097001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1097005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097009 */     // MIs[0] policy
     /* 1097009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097019 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1097022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097028 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1097038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097041 */     // GIR_Coverage, 60893,
     /* 1097041 */     GIR_EraseRootFromParent_Done,
     /* 1097042 */   // Label 16153: @1097042
     /* 1097042 */   GIM_Try, /*On fail goto*//*Label 16154*/ GIMT_Encode4(1097119), // Rule ID 60896 //
     /* 1097047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1097058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1097061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1097064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097086 */     // MIs[0] policy
     /* 1097086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097096 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1097099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097118 */     // GIR_Coverage, 60896,
     /* 1097118 */     GIR_EraseRootFromParent_Done,
     /* 1097119 */   // Label 16154: @1097119
     /* 1097119 */   GIM_Try, /*On fail goto*//*Label 16155*/ GIMT_Encode4(1097196), // Rule ID 60897 //
     /* 1097124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1097135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1097138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1097141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097163 */     // MIs[0] policy
     /* 1097163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097173 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1097176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097182 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097195 */     // GIR_Coverage, 60897,
     /* 1097195 */     GIR_EraseRootFromParent_Done,
     /* 1097196 */   // Label 16155: @1097196
     /* 1097196 */   GIM_Try, /*On fail goto*//*Label 16156*/ GIMT_Encode4(1097273), // Rule ID 60900 //
     /* 1097201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1097212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1097215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1097218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097240 */     // MIs[0] policy
     /* 1097240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097250 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1097253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097272 */     // GIR_Coverage, 60900,
     /* 1097272 */     GIR_EraseRootFromParent_Done,
     /* 1097273 */   // Label 16156: @1097273
     /* 1097273 */   GIM_Try, /*On fail goto*//*Label 16157*/ GIMT_Encode4(1097350), // Rule ID 60901 //
     /* 1097278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1097289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1097292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1097295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097317 */     // MIs[0] policy
     /* 1097317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097327 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1097330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097336 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097349 */     // GIR_Coverage, 60901,
     /* 1097349 */     GIR_EraseRootFromParent_Done,
     /* 1097350 */   // Label 16157: @1097350
     /* 1097350 */   GIM_Try, /*On fail goto*//*Label 16158*/ GIMT_Encode4(1097427), // Rule ID 60904 //
     /* 1097355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1097366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1097369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1097372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097394 */     // MIs[0] policy
     /* 1097394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097404 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097426 */     // GIR_Coverage, 60904,
     /* 1097426 */     GIR_EraseRootFromParent_Done,
     /* 1097427 */   // Label 16158: @1097427
     /* 1097427 */   GIM_Try, /*On fail goto*//*Label 16159*/ GIMT_Encode4(1097504), // Rule ID 60905 //
     /* 1097432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1097443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1097446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1097449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097471 */     // MIs[0] policy
     /* 1097471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097481 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097490 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097503 */     // GIR_Coverage, 60905,
     /* 1097503 */     GIR_EraseRootFromParent_Done,
     /* 1097504 */   // Label 16159: @1097504
     /* 1097504 */   GIM_Try, /*On fail goto*//*Label 16160*/ GIMT_Encode4(1097581), // Rule ID 60908 //
     /* 1097509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1097520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1097523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1097526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097548 */     // MIs[0] policy
     /* 1097548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097558 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1097561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097580 */     // GIR_Coverage, 60908,
     /* 1097580 */     GIR_EraseRootFromParent_Done,
     /* 1097581 */   // Label 16160: @1097581
     /* 1097581 */   GIM_Try, /*On fail goto*//*Label 16161*/ GIMT_Encode4(1097658), // Rule ID 60909 //
     /* 1097586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1097597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1097600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1097603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097625 */     // MIs[0] policy
     /* 1097625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097635 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1097638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097644 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097657 */     // GIR_Coverage, 60909,
     /* 1097657 */     GIR_EraseRootFromParent_Done,
     /* 1097658 */   // Label 16161: @1097658
     /* 1097658 */   GIM_Try, /*On fail goto*//*Label 16162*/ GIMT_Encode4(1097735), // Rule ID 60912 //
     /* 1097663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097702 */     // MIs[0] policy
     /* 1097702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097712 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097734 */     // GIR_Coverage, 60912,
     /* 1097734 */     GIR_EraseRootFromParent_Done,
     /* 1097735 */   // Label 16162: @1097735
     /* 1097735 */   GIM_Try, /*On fail goto*//*Label 16163*/ GIMT_Encode4(1097812), // Rule ID 60913 //
     /* 1097740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097779 */     // MIs[0] policy
     /* 1097779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097789 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097798 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097811 */     // GIR_Coverage, 60913,
     /* 1097811 */     GIR_EraseRootFromParent_Done,
     /* 1097812 */   // Label 16163: @1097812
     /* 1097812 */   GIM_Try, /*On fail goto*//*Label 16164*/ GIMT_Encode4(1097889), // Rule ID 60916 //
     /* 1097817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097856 */     // MIs[0] policy
     /* 1097856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097866 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097875 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097888 */     // GIR_Coverage, 60916,
     /* 1097888 */     GIR_EraseRootFromParent_Done,
     /* 1097889 */   // Label 16164: @1097889
     /* 1097889 */   GIM_Try, /*On fail goto*//*Label 16165*/ GIMT_Encode4(1097966), // Rule ID 60917 //
     /* 1097894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097933 */     // MIs[0] policy
     /* 1097933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097943 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097952 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097965 */     // GIR_Coverage, 60917,
     /* 1097965 */     GIR_EraseRootFromParent_Done,
     /* 1097966 */   // Label 16165: @1097966
     /* 1097966 */   GIM_Try, /*On fail goto*//*Label 16166*/ GIMT_Encode4(1098043), // Rule ID 60920 //
     /* 1097971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1097982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1097985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1097988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1097991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098010 */     // MIs[0] policy
     /* 1098010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098020 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098042 */     // GIR_Coverage, 60920,
     /* 1098042 */     GIR_EraseRootFromParent_Done,
     /* 1098043 */   // Label 16166: @1098043
     /* 1098043 */   GIM_Try, /*On fail goto*//*Label 16167*/ GIMT_Encode4(1098120), // Rule ID 60921 //
     /* 1098048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1098059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1098062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1098065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1098068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098087 */     // MIs[0] policy
     /* 1098087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098097 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098106 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098119 */     // GIR_Coverage, 60921,
     /* 1098119 */     GIR_EraseRootFromParent_Done,
     /* 1098120 */   // Label 16167: @1098120
     /* 1098120 */   GIM_Try, /*On fail goto*//*Label 16168*/ GIMT_Encode4(1098197), // Rule ID 60924 //
     /* 1098125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1098136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1098139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1098142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1098145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098164 */     // MIs[0] policy
     /* 1098164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098196 */     // GIR_Coverage, 60924,
     /* 1098196 */     GIR_EraseRootFromParent_Done,
     /* 1098197 */   // Label 16168: @1098197
     /* 1098197 */   GIM_Try, /*On fail goto*//*Label 16169*/ GIMT_Encode4(1098274), // Rule ID 60925 //
     /* 1098202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1098213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1098216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1098219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1098222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098241 */     // MIs[0] policy
     /* 1098241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098251 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098260 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098273 */     // GIR_Coverage, 60925,
     /* 1098273 */     GIR_EraseRootFromParent_Done,
     /* 1098274 */   // Label 16169: @1098274
     /* 1098274 */   GIM_Try, /*On fail goto*//*Label 16170*/ GIMT_Encode4(1098351), // Rule ID 60928 //
     /* 1098279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1098290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1098293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1098296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1098299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098318 */     // MIs[0] policy
     /* 1098318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098328 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098350 */     // GIR_Coverage, 60928,
     /* 1098350 */     GIR_EraseRootFromParent_Done,
     /* 1098351 */   // Label 16170: @1098351
     /* 1098351 */   GIM_Try, /*On fail goto*//*Label 16171*/ GIMT_Encode4(1098428), // Rule ID 60929 //
     /* 1098356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1098367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1098370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1098373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1098376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098395 */     // MIs[0] policy
     /* 1098395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098405 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098414 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098427 */     // GIR_Coverage, 60929,
     /* 1098427 */     GIR_EraseRootFromParent_Done,
     /* 1098428 */   // Label 16171: @1098428
     /* 1098428 */   GIM_Try, /*On fail goto*//*Label 16172*/ GIMT_Encode4(1098505), // Rule ID 60932 //
     /* 1098433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1098444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1098447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1098450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1098453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098472 */     // MIs[0] policy
     /* 1098472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098504 */     // GIR_Coverage, 60932,
     /* 1098504 */     GIR_EraseRootFromParent_Done,
     /* 1098505 */   // Label 16172: @1098505
     /* 1098505 */   GIM_Try, /*On fail goto*//*Label 16173*/ GIMT_Encode4(1098582), // Rule ID 60933 //
     /* 1098510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1098521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1098524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1098527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1098530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098549 */     // MIs[0] policy
     /* 1098549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098559 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098568 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098581 */     // GIR_Coverage, 60933,
     /* 1098581 */     GIR_EraseRootFromParent_Done,
     /* 1098582 */   // Label 16173: @1098582
     /* 1098582 */   GIM_Try, /*On fail goto*//*Label 16174*/ GIMT_Encode4(1098659), // Rule ID 60936 //
     /* 1098587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1098598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1098601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1098604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098626 */     // MIs[0] policy
     /* 1098626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098636 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098658 */     // GIR_Coverage, 60936,
     /* 1098658 */     GIR_EraseRootFromParent_Done,
     /* 1098659 */   // Label 16174: @1098659
     /* 1098659 */   GIM_Try, /*On fail goto*//*Label 16175*/ GIMT_Encode4(1098736), // Rule ID 60937 //
     /* 1098664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1098675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1098678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1098681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098703 */     // MIs[0] policy
     /* 1098703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098713 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098722 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098735 */     // GIR_Coverage, 60937,
     /* 1098735 */     GIR_EraseRootFromParent_Done,
     /* 1098736 */   // Label 16175: @1098736
     /* 1098736 */   GIM_Try, /*On fail goto*//*Label 16176*/ GIMT_Encode4(1098813), // Rule ID 60940 //
     /* 1098741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1098752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1098755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1098758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098780 */     // MIs[0] policy
     /* 1098780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098790 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098812 */     // GIR_Coverage, 60940,
     /* 1098812 */     GIR_EraseRootFromParent_Done,
     /* 1098813 */   // Label 16176: @1098813
     /* 1098813 */   GIM_Try, /*On fail goto*//*Label 16177*/ GIMT_Encode4(1098890), // Rule ID 60941 //
     /* 1098818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1098829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1098832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1098835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098857 */     // MIs[0] policy
     /* 1098857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098867 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098876 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098889 */     // GIR_Coverage, 60941,
     /* 1098889 */     GIR_EraseRootFromParent_Done,
     /* 1098890 */   // Label 16177: @1098890
     /* 1098890 */   GIM_Try, /*On fail goto*//*Label 16178*/ GIMT_Encode4(1098967), // Rule ID 60944 //
     /* 1098895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098934 */     // MIs[0] policy
     /* 1098934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098944 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098966 */     // GIR_Coverage, 60944,
     /* 1098966 */     GIR_EraseRootFromParent_Done,
     /* 1098967 */   // Label 16178: @1098967
     /* 1098967 */   GIM_Try, /*On fail goto*//*Label 16179*/ GIMT_Encode4(1099044), // Rule ID 60945 //
     /* 1098972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099011 */     // MIs[0] policy
     /* 1099011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099021 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099030 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1099040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099043 */     // GIR_Coverage, 60945,
     /* 1099043 */     GIR_EraseRootFromParent_Done,
     /* 1099044 */   // Label 16179: @1099044
     /* 1099044 */   GIM_Try, /*On fail goto*//*Label 16180*/ GIMT_Encode4(1099121), // Rule ID 60948 //
     /* 1099049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1099060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1099063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1099066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099088 */     // MIs[0] policy
     /* 1099088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099120 */     // GIR_Coverage, 60948,
     /* 1099120 */     GIR_EraseRootFromParent_Done,
     /* 1099121 */   // Label 16180: @1099121
     /* 1099121 */   GIM_Try, /*On fail goto*//*Label 16181*/ GIMT_Encode4(1099198), // Rule ID 60949 //
     /* 1099126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1099137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1099140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1099143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099165 */     // MIs[0] policy
     /* 1099165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099175 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099184 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099197 */     // GIR_Coverage, 60949,
     /* 1099197 */     GIR_EraseRootFromParent_Done,
     /* 1099198 */   // Label 16181: @1099198
     /* 1099198 */   GIM_Try, /*On fail goto*//*Label 16182*/ GIMT_Encode4(1099275), // Rule ID 60952 //
     /* 1099203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1099214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1099217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1099220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099242 */     // MIs[0] policy
     /* 1099242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099252 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099274 */     // GIR_Coverage, 60952,
     /* 1099274 */     GIR_EraseRootFromParent_Done,
     /* 1099275 */   // Label 16182: @1099275
     /* 1099275 */   GIM_Try, /*On fail goto*//*Label 16183*/ GIMT_Encode4(1099352), // Rule ID 60953 //
     /* 1099280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1099291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1099294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1099297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099319 */     // MIs[0] policy
     /* 1099319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099329 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099338 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099351 */     // GIR_Coverage, 60953,
     /* 1099351 */     GIR_EraseRootFromParent_Done,
     /* 1099352 */   // Label 16183: @1099352
     /* 1099352 */   GIM_Try, /*On fail goto*//*Label 16184*/ GIMT_Encode4(1099429), // Rule ID 60956 //
     /* 1099357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1099368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1099371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1099374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1099377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099396 */     // MIs[0] policy
     /* 1099396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099406 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099428 */     // GIR_Coverage, 60956,
     /* 1099428 */     GIR_EraseRootFromParent_Done,
     /* 1099429 */   // Label 16184: @1099429
     /* 1099429 */   GIM_Try, /*On fail goto*//*Label 16185*/ GIMT_Encode4(1099506), // Rule ID 60957 //
     /* 1099434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1099445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1099448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1099451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1099454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099473 */     // MIs[0] policy
     /* 1099473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099483 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099492 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099505 */     // GIR_Coverage, 60957,
     /* 1099505 */     GIR_EraseRootFromParent_Done,
     /* 1099506 */   // Label 16185: @1099506
     /* 1099506 */   GIM_Try, /*On fail goto*//*Label 16186*/ GIMT_Encode4(1099583), // Rule ID 60960 //
     /* 1099511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1099522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1099525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1099528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099550 */     // MIs[0] policy
     /* 1099550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099582 */     // GIR_Coverage, 60960,
     /* 1099582 */     GIR_EraseRootFromParent_Done,
     /* 1099583 */   // Label 16186: @1099583
     /* 1099583 */   GIM_Try, /*On fail goto*//*Label 16187*/ GIMT_Encode4(1099660), // Rule ID 60961 //
     /* 1099588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1099599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1099602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1099605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099627 */     // MIs[0] policy
     /* 1099627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099637 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099646 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099659 */     // GIR_Coverage, 60961,
     /* 1099659 */     GIR_EraseRootFromParent_Done,
     /* 1099660 */   // Label 16187: @1099660
     /* 1099660 */   GIM_Try, /*On fail goto*//*Label 16188*/ GIMT_Encode4(1099737), // Rule ID 60964 //
     /* 1099665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1099676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1099679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1099682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099704 */     // MIs[0] policy
     /* 1099704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099714 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099723 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099736 */     // GIR_Coverage, 60964,
     /* 1099736 */     GIR_EraseRootFromParent_Done,
     /* 1099737 */   // Label 16188: @1099737
     /* 1099737 */   GIM_Try, /*On fail goto*//*Label 16189*/ GIMT_Encode4(1099814), // Rule ID 60965 //
     /* 1099742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1099753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1099756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1099759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099781 */     // MIs[0] policy
     /* 1099781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099791 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099800 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099813 */     // GIR_Coverage, 60965,
     /* 1099813 */     GIR_EraseRootFromParent_Done,
     /* 1099814 */   // Label 16189: @1099814
     /* 1099814 */   GIM_Try, /*On fail goto*//*Label 16190*/ GIMT_Encode4(1099891), // Rule ID 60968 //
     /* 1099819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1099830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1099833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1099836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099858 */     // MIs[0] policy
     /* 1099858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099868 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099890 */     // GIR_Coverage, 60968,
     /* 1099890 */     GIR_EraseRootFromParent_Done,
     /* 1099891 */   // Label 16190: @1099891
     /* 1099891 */   GIM_Try, /*On fail goto*//*Label 16191*/ GIMT_Encode4(1099968), // Rule ID 60969 //
     /* 1099896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1099907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1099910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1099913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099935 */     // MIs[0] policy
     /* 1099935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099945 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099954 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099967 */     // GIR_Coverage, 60969,
     /* 1099967 */     GIR_EraseRootFromParent_Done,
     /* 1099968 */   // Label 16191: @1099968
     /* 1099968 */   GIM_Try, /*On fail goto*//*Label 16192*/ GIMT_Encode4(1100045), // Rule ID 60972 //
     /* 1099973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1099984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1099987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1099990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1099993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1100000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100012 */     // MIs[0] policy
     /* 1100012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100022 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1100025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100044 */     // GIR_Coverage, 60972,
     /* 1100044 */     GIR_EraseRootFromParent_Done,
     /* 1100045 */   // Label 16192: @1100045
     /* 1100045 */   GIM_Try, /*On fail goto*//*Label 16193*/ GIMT_Encode4(1100122), // Rule ID 60973 //
     /* 1100050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1100061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1100064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1100067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1100077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100089 */     // MIs[0] policy
     /* 1100089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100099 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1100102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100108 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100121 */     // GIR_Coverage, 60973,
     /* 1100121 */     GIR_EraseRootFromParent_Done,
     /* 1100122 */   // Label 16193: @1100122
     /* 1100122 */   GIM_Try, /*On fail goto*//*Label 16194*/ GIMT_Encode4(1100199), // Rule ID 60976 //
     /* 1100127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1100138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1100141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1100144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1100154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100166 */     // MIs[0] policy
     /* 1100166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100176 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1100179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100198 */     // GIR_Coverage, 60976,
     /* 1100198 */     GIR_EraseRootFromParent_Done,
     /* 1100199 */   // Label 16194: @1100199
     /* 1100199 */   GIM_Try, /*On fail goto*//*Label 16195*/ GIMT_Encode4(1100276), // Rule ID 60977 //
     /* 1100204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1100215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1100218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1100221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1100231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100243 */     // MIs[0] policy
     /* 1100243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100253 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1100256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100262 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100275 */     // GIR_Coverage, 60977,
     /* 1100275 */     GIR_EraseRootFromParent_Done,
     /* 1100276 */   // Label 16195: @1100276
     /* 1100276 */   GIM_Try, /*On fail goto*//*Label 16196*/ GIMT_Encode4(1100353), // Rule ID 60980 //
     /* 1100281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1100292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1100295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1100298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1100308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100320 */     // MIs[0] policy
     /* 1100320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100330 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1100333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100339 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100352 */     // GIR_Coverage, 60980,
     /* 1100352 */     GIR_EraseRootFromParent_Done,
     /* 1100353 */   // Label 16196: @1100353
     /* 1100353 */   GIM_Try, /*On fail goto*//*Label 16197*/ GIMT_Encode4(1100430), // Rule ID 60981 //
     /* 1100358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1100369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1100372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1100375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1100385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100397 */     // MIs[0] policy
     /* 1100397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100407 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1100410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100416 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100429 */     // GIR_Coverage, 60981,
     /* 1100429 */     GIR_EraseRootFromParent_Done,
     /* 1100430 */   // Label 16197: @1100430
     /* 1100430 */   GIM_Try, /*On fail goto*//*Label 16198*/ GIMT_Encode4(1100507), // Rule ID 61404 //
     /* 1100435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1100446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1100449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1100452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100474 */     // MIs[0] policy
     /* 1100474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100484 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1100487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100493 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100506 */     // GIR_Coverage, 61404,
     /* 1100506 */     GIR_EraseRootFromParent_Done,
     /* 1100507 */   // Label 16198: @1100507
     /* 1100507 */   GIM_Try, /*On fail goto*//*Label 16199*/ GIMT_Encode4(1100584), // Rule ID 61405 //
     /* 1100512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1100523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1100526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1100529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100551 */     // MIs[0] policy
     /* 1100551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100561 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1100564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100570 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100583 */     // GIR_Coverage, 61405,
     /* 1100583 */     GIR_EraseRootFromParent_Done,
     /* 1100584 */   // Label 16199: @1100584
     /* 1100584 */   GIM_Try, /*On fail goto*//*Label 16200*/ GIMT_Encode4(1100661), // Rule ID 61408 //
     /* 1100589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1100600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1100603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1100606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100628 */     // MIs[0] policy
     /* 1100628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100638 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100660 */     // GIR_Coverage, 61408,
     /* 1100660 */     GIR_EraseRootFromParent_Done,
     /* 1100661 */   // Label 16200: @1100661
     /* 1100661 */   GIM_Try, /*On fail goto*//*Label 16201*/ GIMT_Encode4(1100738), // Rule ID 61409 //
     /* 1100666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1100677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1100680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1100683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100705 */     // MIs[0] policy
     /* 1100705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100715 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100724 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100737 */     // GIR_Coverage, 61409,
     /* 1100737 */     GIR_EraseRootFromParent_Done,
     /* 1100738 */   // Label 16201: @1100738
     /* 1100738 */   GIM_Try, /*On fail goto*//*Label 16202*/ GIMT_Encode4(1100815), // Rule ID 61412 //
     /* 1100743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1100754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1100757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1100760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100782 */     // MIs[0] policy
     /* 1100782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100792 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100814 */     // GIR_Coverage, 61412,
     /* 1100814 */     GIR_EraseRootFromParent_Done,
     /* 1100815 */   // Label 16202: @1100815
     /* 1100815 */   GIM_Try, /*On fail goto*//*Label 16203*/ GIMT_Encode4(1100892), // Rule ID 61413 //
     /* 1100820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1100831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1100834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1100837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100859 */     // MIs[0] policy
     /* 1100859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100869 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100878 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100891 */     // GIR_Coverage, 61413,
     /* 1100891 */     GIR_EraseRootFromParent_Done,
     /* 1100892 */   // Label 16203: @1100892
     /* 1100892 */   GIM_Try, /*On fail goto*//*Label 16204*/ GIMT_Encode4(1100969), // Rule ID 61416 //
     /* 1100897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100936 */     // MIs[0] policy
     /* 1100936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100955 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100968 */     // GIR_Coverage, 61416,
     /* 1100968 */     GIR_EraseRootFromParent_Done,
     /* 1100969 */   // Label 16204: @1100969
     /* 1100969 */   GIM_Try, /*On fail goto*//*Label 16205*/ GIMT_Encode4(1101046), // Rule ID 61417 //
     /* 1100974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101013 */     // MIs[0] policy
     /* 1101013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101023 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1101026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101032 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101045 */     // GIR_Coverage, 61417,
     /* 1101045 */     GIR_EraseRootFromParent_Done,
     /* 1101046 */   // Label 16205: @1101046
     /* 1101046 */   GIM_Try, /*On fail goto*//*Label 16206*/ GIMT_Encode4(1101123), // Rule ID 61420 //
     /* 1101051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1101062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1101065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1101068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101090 */     // MIs[0] policy
     /* 1101090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101100 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1101103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101122 */     // GIR_Coverage, 61420,
     /* 1101122 */     GIR_EraseRootFromParent_Done,
     /* 1101123 */   // Label 16206: @1101123
     /* 1101123 */   GIM_Try, /*On fail goto*//*Label 16207*/ GIMT_Encode4(1101200), // Rule ID 61421 //
     /* 1101128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1101139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1101142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1101145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101167 */     // MIs[0] policy
     /* 1101167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101177 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1101180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101186 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101199 */     // GIR_Coverage, 61421,
     /* 1101199 */     GIR_EraseRootFromParent_Done,
     /* 1101200 */   // Label 16207: @1101200
     /* 1101200 */   GIM_Try, /*On fail goto*//*Label 16208*/ GIMT_Encode4(1101277), // Rule ID 61424 //
     /* 1101205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1101216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1101219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1101222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101244 */     // MIs[0] policy
     /* 1101244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101254 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1101257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101276 */     // GIR_Coverage, 61424,
     /* 1101276 */     GIR_EraseRootFromParent_Done,
     /* 1101277 */   // Label 16208: @1101277
     /* 1101277 */   GIM_Try, /*On fail goto*//*Label 16209*/ GIMT_Encode4(1101354), // Rule ID 61425 //
     /* 1101282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1101293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1101296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1101299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101321 */     // MIs[0] policy
     /* 1101321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101331 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1101334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101340 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101353 */     // GIR_Coverage, 61425,
     /* 1101353 */     GIR_EraseRootFromParent_Done,
     /* 1101354 */   // Label 16209: @1101354
     /* 1101354 */   GIM_Try, /*On fail goto*//*Label 16210*/ GIMT_Encode4(1101431), // Rule ID 61428 //
     /* 1101359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1101370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1101373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1101376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1101379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101398 */     // MIs[0] policy
     /* 1101398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101408 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101430 */     // GIR_Coverage, 61428,
     /* 1101430 */     GIR_EraseRootFromParent_Done,
     /* 1101431 */   // Label 16210: @1101431
     /* 1101431 */   GIM_Try, /*On fail goto*//*Label 16211*/ GIMT_Encode4(1101508), // Rule ID 61429 //
     /* 1101436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1101447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1101450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1101453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1101456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101475 */     // MIs[0] policy
     /* 1101475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101485 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101494 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101507 */     // GIR_Coverage, 61429,
     /* 1101507 */     GIR_EraseRootFromParent_Done,
     /* 1101508 */   // Label 16211: @1101508
     /* 1101508 */   GIM_Try, /*On fail goto*//*Label 16212*/ GIMT_Encode4(1101585), // Rule ID 61432 //
     /* 1101513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1101524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1101527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101552 */     // MIs[0] policy
     /* 1101552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101562 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101571 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101584 */     // GIR_Coverage, 61432,
     /* 1101584 */     GIR_EraseRootFromParent_Done,
     /* 1101585 */   // Label 16212: @1101585
     /* 1101585 */   GIM_Try, /*On fail goto*//*Label 16213*/ GIMT_Encode4(1101662), // Rule ID 61433 //
     /* 1101590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1101601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1101604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101629 */     // MIs[0] policy
     /* 1101629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101639 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101648 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101661 */     // GIR_Coverage, 61433,
     /* 1101661 */     GIR_EraseRootFromParent_Done,
     /* 1101662 */   // Label 16213: @1101662
     /* 1101662 */   GIM_Try, /*On fail goto*//*Label 16214*/ GIMT_Encode4(1101739), // Rule ID 61436 //
     /* 1101667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1101684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101706 */     // MIs[0] policy
     /* 1101706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101725 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101738 */     // GIR_Coverage, 61436,
     /* 1101738 */     GIR_EraseRootFromParent_Done,
     /* 1101739 */   // Label 16214: @1101739
     /* 1101739 */   GIM_Try, /*On fail goto*//*Label 16215*/ GIMT_Encode4(1101816), // Rule ID 61437 //
     /* 1101744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1101761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101783 */     // MIs[0] policy
     /* 1101783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101793 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101802 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101815 */     // GIR_Coverage, 61437,
     /* 1101815 */     GIR_EraseRootFromParent_Done,
     /* 1101816 */   // Label 16215: @1101816
     /* 1101816 */   GIM_Try, /*On fail goto*//*Label 16216*/ GIMT_Encode4(1101893), // Rule ID 61440 //
     /* 1101821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1101832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1101835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1101838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101860 */     // MIs[0] policy
     /* 1101860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101870 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101892 */     // GIR_Coverage, 61440,
     /* 1101892 */     GIR_EraseRootFromParent_Done,
     /* 1101893 */   // Label 16216: @1101893
     /* 1101893 */   GIM_Try, /*On fail goto*//*Label 16217*/ GIMT_Encode4(1101970), // Rule ID 61441 //
     /* 1101898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1101909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1101912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1101915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101937 */     // MIs[0] policy
     /* 1101937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101947 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101956 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101969 */     // GIR_Coverage, 61441,
     /* 1101969 */     GIR_EraseRootFromParent_Done,
     /* 1101970 */   // Label 16217: @1101970
     /* 1101970 */   GIM_Try, /*On fail goto*//*Label 16218*/ GIMT_Encode4(1102047), // Rule ID 61444 //
     /* 1101975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1101986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1101989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1101992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1101995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102014 */     // MIs[0] policy
     /* 1102014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102024 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102046 */     // GIR_Coverage, 61444,
     /* 1102046 */     GIR_EraseRootFromParent_Done,
     /* 1102047 */   // Label 16218: @1102047
     /* 1102047 */   GIM_Try, /*On fail goto*//*Label 16219*/ GIMT_Encode4(1102124), // Rule ID 61445 //
     /* 1102052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1102063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1102066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1102069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102091 */     // MIs[0] policy
     /* 1102091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102110 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102123 */     // GIR_Coverage, 61445,
     /* 1102123 */     GIR_EraseRootFromParent_Done,
     /* 1102124 */   // Label 16219: @1102124
     /* 1102124 */   GIM_Try, /*On fail goto*//*Label 16220*/ GIMT_Encode4(1102201), // Rule ID 61448 //
     /* 1102129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1102140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1102143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1102146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102168 */     // MIs[0] policy
     /* 1102168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102178 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102187 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102200 */     // GIR_Coverage, 61448,
     /* 1102200 */     GIR_EraseRootFromParent_Done,
     /* 1102201 */   // Label 16220: @1102201
     /* 1102201 */   GIM_Try, /*On fail goto*//*Label 16221*/ GIMT_Encode4(1102278), // Rule ID 61449 //
     /* 1102206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1102217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1102220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1102223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102245 */     // MIs[0] policy
     /* 1102245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102255 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102264 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102277 */     // GIR_Coverage, 61449,
     /* 1102277 */     GIR_EraseRootFromParent_Done,
     /* 1102278 */   // Label 16221: @1102278
     /* 1102278 */   GIM_Try, /*On fail goto*//*Label 16222*/ GIMT_Encode4(1102355), // Rule ID 61452 //
     /* 1102283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1102294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1102297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1102300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1102303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102322 */     // MIs[0] policy
     /* 1102322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102332 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102354 */     // GIR_Coverage, 61452,
     /* 1102354 */     GIR_EraseRootFromParent_Done,
     /* 1102355 */   // Label 16222: @1102355
     /* 1102355 */   GIM_Try, /*On fail goto*//*Label 16223*/ GIMT_Encode4(1102432), // Rule ID 61453 //
     /* 1102360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1102371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1102374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1102377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1102380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102399 */     // MIs[0] policy
     /* 1102399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102409 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102418 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102431 */     // GIR_Coverage, 61453,
     /* 1102431 */     GIR_EraseRootFromParent_Done,
     /* 1102432 */   // Label 16223: @1102432
     /* 1102432 */   GIM_Try, /*On fail goto*//*Label 16224*/ GIMT_Encode4(1102509), // Rule ID 61456 //
     /* 1102437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1102448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1102451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1102454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102476 */     // MIs[0] policy
     /* 1102476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102486 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102495 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102508 */     // GIR_Coverage, 61456,
     /* 1102508 */     GIR_EraseRootFromParent_Done,
     /* 1102509 */   // Label 16224: @1102509
     /* 1102509 */   GIM_Try, /*On fail goto*//*Label 16225*/ GIMT_Encode4(1102586), // Rule ID 61457 //
     /* 1102514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1102525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1102528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1102531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102553 */     // MIs[0] policy
     /* 1102553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102563 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102572 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102585 */     // GIR_Coverage, 61457,
     /* 1102585 */     GIR_EraseRootFromParent_Done,
     /* 1102586 */   // Label 16225: @1102586
     /* 1102586 */   GIM_Try, /*On fail goto*//*Label 16226*/ GIMT_Encode4(1102663), // Rule ID 61460 //
     /* 1102591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1102602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1102605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102630 */     // MIs[0] policy
     /* 1102630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102640 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102662 */     // GIR_Coverage, 61460,
     /* 1102662 */     GIR_EraseRootFromParent_Done,
     /* 1102663 */   // Label 16226: @1102663
     /* 1102663 */   GIM_Try, /*On fail goto*//*Label 16227*/ GIMT_Encode4(1102740), // Rule ID 61461 //
     /* 1102668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1102679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1102682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102707 */     // MIs[0] policy
     /* 1102707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102717 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102726 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102739 */     // GIR_Coverage, 61461,
     /* 1102739 */     GIR_EraseRootFromParent_Done,
     /* 1102740 */   // Label 16227: @1102740
     /* 1102740 */   GIM_Try, /*On fail goto*//*Label 16228*/ GIMT_Encode4(1102817), // Rule ID 61464 //
     /* 1102745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1102756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1102759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1102762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102784 */     // MIs[0] policy
     /* 1102784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102794 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102803 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102816 */     // GIR_Coverage, 61464,
     /* 1102816 */     GIR_EraseRootFromParent_Done,
     /* 1102817 */   // Label 16228: @1102817
     /* 1102817 */   GIM_Try, /*On fail goto*//*Label 16229*/ GIMT_Encode4(1102894), // Rule ID 61465 //
     /* 1102822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1102833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1102836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1102839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102861 */     // MIs[0] policy
     /* 1102861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102871 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102880 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102893 */     // GIR_Coverage, 61465,
     /* 1102893 */     GIR_EraseRootFromParent_Done,
     /* 1102894 */   // Label 16229: @1102894
     /* 1102894 */   GIM_Try, /*On fail goto*//*Label 16230*/ GIMT_Encode4(1102971), // Rule ID 61468 //
     /* 1102899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102938 */     // MIs[0] policy
     /* 1102938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102957 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102970 */     // GIR_Coverage, 61468,
     /* 1102970 */     GIR_EraseRootFromParent_Done,
     /* 1102971 */   // Label 16230: @1102971
     /* 1102971 */   GIM_Try, /*On fail goto*//*Label 16231*/ GIMT_Encode4(1103048), // Rule ID 61469 //
     /* 1102976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1103003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103015 */     // MIs[0] policy
     /* 1103015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103025 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1103028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103034 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103047 */     // GIR_Coverage, 61469,
     /* 1103047 */     GIR_EraseRootFromParent_Done,
     /* 1103048 */   // Label 16231: @1103048
     /* 1103048 */   GIM_Try, /*On fail goto*//*Label 16232*/ GIMT_Encode4(1103125), // Rule ID 61472 //
     /* 1103053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1103064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1103067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1103070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103092 */     // MIs[0] policy
     /* 1103092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103102 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1103105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103124 */     // GIR_Coverage, 61472,
     /* 1103124 */     GIR_EraseRootFromParent_Done,
     /* 1103125 */   // Label 16232: @1103125
     /* 1103125 */   GIM_Try, /*On fail goto*//*Label 16233*/ GIMT_Encode4(1103202), // Rule ID 61473 //
     /* 1103130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1103141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1103144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1103147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103169 */     // MIs[0] policy
     /* 1103169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103179 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1103182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103188 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103201 */     // GIR_Coverage, 61473,
     /* 1103201 */     GIR_EraseRootFromParent_Done,
     /* 1103202 */   // Label 16233: @1103202
     /* 1103202 */   GIM_Try, /*On fail goto*//*Label 16234*/ GIMT_Encode4(1103279), // Rule ID 61476 //
     /* 1103207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1103218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1103221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1103224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1103227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103246 */     // MIs[0] policy
     /* 1103246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103256 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1103259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103278 */     // GIR_Coverage, 61476,
     /* 1103278 */     GIR_EraseRootFromParent_Done,
     /* 1103279 */   // Label 16234: @1103279
     /* 1103279 */   GIM_Try, /*On fail goto*//*Label 16235*/ GIMT_Encode4(1103356), // Rule ID 61477 //
     /* 1103284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1103295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1103298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1103301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1103304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103323 */     // MIs[0] policy
     /* 1103323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103333 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1103336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103342 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103355 */     // GIR_Coverage, 61477,
     /* 1103355 */     GIR_EraseRootFromParent_Done,
     /* 1103356 */   // Label 16235: @1103356
     /* 1103356 */   GIM_Try, /*On fail goto*//*Label 16236*/ GIMT_Encode4(1103433), // Rule ID 61480 //
     /* 1103361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1103372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1103375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1103378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1103388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103400 */     // MIs[0] policy
     /* 1103400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1103413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103419 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103432 */     // GIR_Coverage, 61480,
     /* 1103432 */     GIR_EraseRootFromParent_Done,
     /* 1103433 */   // Label 16236: @1103433
     /* 1103433 */   GIM_Try, /*On fail goto*//*Label 16237*/ GIMT_Encode4(1103510), // Rule ID 61481 //
     /* 1103438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1103449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1103452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1103455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1103465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103477 */     // MIs[0] policy
     /* 1103477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103487 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1103490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103496 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103509 */     // GIR_Coverage, 61481,
     /* 1103509 */     GIR_EraseRootFromParent_Done,
     /* 1103510 */   // Label 16237: @1103510
     /* 1103510 */   GIM_Try, /*On fail goto*//*Label 16238*/ GIMT_Encode4(1103587), // Rule ID 61484 //
     /* 1103515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1103526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1103529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1103532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103554 */     // MIs[0] policy
     /* 1103554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1103567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103586 */     // GIR_Coverage, 61484,
     /* 1103586 */     GIR_EraseRootFromParent_Done,
     /* 1103587 */   // Label 16238: @1103587
     /* 1103587 */   GIM_Try, /*On fail goto*//*Label 16239*/ GIMT_Encode4(1103664), // Rule ID 61485 //
     /* 1103592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1103603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1103606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1103609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103631 */     // MIs[0] policy
     /* 1103631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103641 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1103644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103650 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103663 */     // GIR_Coverage, 61485,
     /* 1103663 */     GIR_EraseRootFromParent_Done,
     /* 1103664 */   // Label 16239: @1103664
     /* 1103664 */   GIM_Try, /*On fail goto*//*Label 16240*/ GIMT_Encode4(1103741), // Rule ID 61488 //
     /* 1103669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1103680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1103683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1103686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103708 */     // MIs[0] policy
     /* 1103708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1103721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103740 */     // GIR_Coverage, 61488,
     /* 1103740 */     GIR_EraseRootFromParent_Done,
     /* 1103741 */   // Label 16240: @1103741
     /* 1103741 */   GIM_Try, /*On fail goto*//*Label 16241*/ GIMT_Encode4(1103818), // Rule ID 61489 //
     /* 1103746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1103757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1103760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1103763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103785 */     // MIs[0] policy
     /* 1103785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103795 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1103798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103804 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103817 */     // GIR_Coverage, 61489,
     /* 1103817 */     GIR_EraseRootFromParent_Done,
     /* 1103818 */   // Label 16241: @1103818
     /* 1103818 */   GIM_Try, /*On fail goto*//*Label 16242*/ GIMT_Encode4(1103895), // Rule ID 61492 //
     /* 1103823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1103834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1103837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1103840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103862 */     // MIs[0] policy
     /* 1103862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103872 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1103875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103894 */     // GIR_Coverage, 61492,
     /* 1103894 */     GIR_EraseRootFromParent_Done,
     /* 1103895 */   // Label 16242: @1103895
     /* 1103895 */   GIM_Try, /*On fail goto*//*Label 16243*/ GIMT_Encode4(1103972), // Rule ID 61493 //
     /* 1103900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1103911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1103914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1103917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103939 */     // MIs[0] policy
     /* 1103939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103949 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1103952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103958 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103971 */     // GIR_Coverage, 61493,
     /* 1103971 */     GIR_EraseRootFromParent_Done,
     /* 1103972 */   // Label 16243: @1103972
     /* 1103972 */   GIM_Try, /*On fail goto*//*Label 16244*/ GIMT_Encode4(1104049), // Rule ID 61496 //
     /* 1103977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1103988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1103991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1103994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104016 */     // MIs[0] policy
     /* 1104016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104026 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1104029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104035 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104048 */     // GIR_Coverage, 61496,
     /* 1104048 */     GIR_EraseRootFromParent_Done,
     /* 1104049 */   // Label 16244: @1104049
     /* 1104049 */   GIM_Try, /*On fail goto*//*Label 16245*/ GIMT_Encode4(1104126), // Rule ID 61497 //
     /* 1104054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1104065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1104068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1104071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104093 */     // MIs[0] policy
     /* 1104093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104103 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1104106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104112 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104125 */     // GIR_Coverage, 61497,
     /* 1104125 */     GIR_EraseRootFromParent_Done,
     /* 1104126 */   // Label 16245: @1104126
     /* 1104126 */   GIM_Try, /*On fail goto*//*Label 16246*/ GIMT_Encode4(1104203), // Rule ID 61500 //
     /* 1104131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1104142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1104145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1104148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104170 */     // MIs[0] policy
     /* 1104170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104180 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104202 */     // GIR_Coverage, 61500,
     /* 1104202 */     GIR_EraseRootFromParent_Done,
     /* 1104203 */   // Label 16246: @1104203
     /* 1104203 */   GIM_Try, /*On fail goto*//*Label 16247*/ GIMT_Encode4(1104280), // Rule ID 61501 //
     /* 1104208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1104219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1104222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1104225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104247 */     // MIs[0] policy
     /* 1104247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104257 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104266 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104279 */     // GIR_Coverage, 61501,
     /* 1104279 */     GIR_EraseRootFromParent_Done,
     /* 1104280 */   // Label 16247: @1104280
     /* 1104280 */   GIM_Try, /*On fail goto*//*Label 16248*/ GIMT_Encode4(1104357), // Rule ID 61504 //
     /* 1104285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1104296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1104299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1104302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104324 */     // MIs[0] policy
     /* 1104324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104334 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1104337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104343 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104356 */     // GIR_Coverage, 61504,
     /* 1104356 */     GIR_EraseRootFromParent_Done,
     /* 1104357 */   // Label 16248: @1104357
     /* 1104357 */   GIM_Try, /*On fail goto*//*Label 16249*/ GIMT_Encode4(1104434), // Rule ID 61505 //
     /* 1104362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1104373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1104376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1104379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104401 */     // MIs[0] policy
     /* 1104401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104411 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1104414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104420 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104433 */     // GIR_Coverage, 61505,
     /* 1104433 */     GIR_EraseRootFromParent_Done,
     /* 1104434 */   // Label 16249: @1104434
     /* 1104434 */   GIM_Try, /*On fail goto*//*Label 16250*/ GIMT_Encode4(1104511), // Rule ID 61508 //
     /* 1104439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1104450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1104453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1104456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104478 */     // MIs[0] policy
     /* 1104478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104488 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104510 */     // GIR_Coverage, 61508,
     /* 1104510 */     GIR_EraseRootFromParent_Done,
     /* 1104511 */   // Label 16250: @1104511
     /* 1104511 */   GIM_Try, /*On fail goto*//*Label 16251*/ GIMT_Encode4(1104588), // Rule ID 61509 //
     /* 1104516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1104527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1104530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1104533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104555 */     // MIs[0] policy
     /* 1104555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104565 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104574 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104587 */     // GIR_Coverage, 61509,
     /* 1104587 */     GIR_EraseRootFromParent_Done,
     /* 1104588 */   // Label 16251: @1104588
     /* 1104588 */   GIM_Try, /*On fail goto*//*Label 16252*/ GIMT_Encode4(1104665), // Rule ID 61512 //
     /* 1104593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1104610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104632 */     // MIs[0] policy
     /* 1104632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104642 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104651 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104664 */     // GIR_Coverage, 61512,
     /* 1104664 */     GIR_EraseRootFromParent_Done,
     /* 1104665 */   // Label 16252: @1104665
     /* 1104665 */   GIM_Try, /*On fail goto*//*Label 16253*/ GIMT_Encode4(1104742), // Rule ID 61513 //
     /* 1104670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1104687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104709 */     // MIs[0] policy
     /* 1104709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104719 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104728 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104741 */     // GIR_Coverage, 61513,
     /* 1104741 */     GIR_EraseRootFromParent_Done,
     /* 1104742 */   // Label 16253: @1104742
     /* 1104742 */   GIM_Try, /*On fail goto*//*Label 16254*/ GIMT_Encode4(1104819), // Rule ID 61516 //
     /* 1104747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1104758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1104761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1104764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104786 */     // MIs[0] policy
     /* 1104786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104818 */     // GIR_Coverage, 61516,
     /* 1104818 */     GIR_EraseRootFromParent_Done,
     /* 1104819 */   // Label 16254: @1104819
     /* 1104819 */   GIM_Try, /*On fail goto*//*Label 16255*/ GIMT_Encode4(1104896), // Rule ID 61517 //
     /* 1104824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1104835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1104838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1104841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104863 */     // MIs[0] policy
     /* 1104863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104873 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104882 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104895 */     // GIR_Coverage, 61517,
     /* 1104895 */     GIR_EraseRootFromParent_Done,
     /* 1104896 */   // Label 16255: @1104896
     /* 1104896 */   GIM_Try, /*On fail goto*//*Label 16256*/ GIMT_Encode4(1104973), // Rule ID 61520 //
     /* 1104901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104940 */     // MIs[0] policy
     /* 1104940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104972 */     // GIR_Coverage, 61520,
     /* 1104972 */     GIR_EraseRootFromParent_Done,
     /* 1104973 */   // Label 16256: @1104973
     /* 1104973 */   GIM_Try, /*On fail goto*//*Label 16257*/ GIMT_Encode4(1105050), // Rule ID 61521 //
     /* 1104978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105017 */     // MIs[0] policy
     /* 1105017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105027 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1105030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105049 */     // GIR_Coverage, 61521,
     /* 1105049 */     GIR_EraseRootFromParent_Done,
     /* 1105050 */   // Label 16257: @1105050
     /* 1105050 */   GIM_Try, /*On fail goto*//*Label 16258*/ GIMT_Encode4(1105127), // Rule ID 61524 //
     /* 1105055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1105066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1105069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1105072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1105075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105094 */     // MIs[0] policy
     /* 1105094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1105107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105126 */     // GIR_Coverage, 61524,
     /* 1105126 */     GIR_EraseRootFromParent_Done,
     /* 1105127 */   // Label 16258: @1105127
     /* 1105127 */   GIM_Try, /*On fail goto*//*Label 16259*/ GIMT_Encode4(1105204), // Rule ID 61525 //
     /* 1105132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1105143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1105146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1105149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1105152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105171 */     // MIs[0] policy
     /* 1105171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105181 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1105184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105190 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105203 */     // GIR_Coverage, 61525,
     /* 1105203 */     GIR_EraseRootFromParent_Done,
     /* 1105204 */   // Label 16259: @1105204
     /* 1105204 */   GIM_Try, /*On fail goto*//*Label 16260*/ GIMT_Encode4(1105281), // Rule ID 61528 //
     /* 1105209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1105220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1105223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1105226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1105229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105248 */     // MIs[0] policy
     /* 1105248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105258 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1105261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1105277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105280 */     // GIR_Coverage, 61528,
     /* 1105280 */     GIR_EraseRootFromParent_Done,
     /* 1105281 */   // Label 16260: @1105281
     /* 1105281 */   GIM_Try, /*On fail goto*//*Label 16261*/ GIMT_Encode4(1105358), // Rule ID 61529 //
     /* 1105286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1105297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1105300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1105303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1105306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105325 */     // MIs[0] policy
     /* 1105325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105335 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1105338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105344 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1105354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105357 */     // GIR_Coverage, 61529,
     /* 1105357 */     GIR_EraseRootFromParent_Done,
     /* 1105358 */   // Label 16261: @1105358
     /* 1105358 */   GIM_Try, /*On fail goto*//*Label 16262*/ GIMT_Encode4(1105435), // Rule ID 61532 //
     /* 1105363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1105374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1105377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1105380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105402 */     // MIs[0] policy
     /* 1105402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105412 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105434 */     // GIR_Coverage, 61532,
     /* 1105434 */     GIR_EraseRootFromParent_Done,
     /* 1105435 */   // Label 16262: @1105435
     /* 1105435 */   GIM_Try, /*On fail goto*//*Label 16263*/ GIMT_Encode4(1105512), // Rule ID 61533 //
     /* 1105440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1105451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1105454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1105457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105479 */     // MIs[0] policy
     /* 1105479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105489 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105498 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105511 */     // GIR_Coverage, 61533,
     /* 1105511 */     GIR_EraseRootFromParent_Done,
     /* 1105512 */   // Label 16263: @1105512
     /* 1105512 */   GIM_Try, /*On fail goto*//*Label 16264*/ GIMT_Encode4(1105589), // Rule ID 61536 //
     /* 1105517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1105528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1105531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1105534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105556 */     // MIs[0] policy
     /* 1105556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105566 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105588 */     // GIR_Coverage, 61536,
     /* 1105588 */     GIR_EraseRootFromParent_Done,
     /* 1105589 */   // Label 16264: @1105589
     /* 1105589 */   GIM_Try, /*On fail goto*//*Label 16265*/ GIMT_Encode4(1105666), // Rule ID 61537 //
     /* 1105594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1105605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1105608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1105611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105633 */     // MIs[0] policy
     /* 1105633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105643 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105652 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105665 */     // GIR_Coverage, 61537,
     /* 1105665 */     GIR_EraseRootFromParent_Done,
     /* 1105666 */   // Label 16265: @1105666
     /* 1105666 */   GIM_Try, /*On fail goto*//*Label 16266*/ GIMT_Encode4(1105743), // Rule ID 61540 //
     /* 1105671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1105682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1105685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1105688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1105691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105710 */     // MIs[0] policy
     /* 1105710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105720 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105742 */     // GIR_Coverage, 61540,
     /* 1105742 */     GIR_EraseRootFromParent_Done,
     /* 1105743 */   // Label 16266: @1105743
     /* 1105743 */   GIM_Try, /*On fail goto*//*Label 16267*/ GIMT_Encode4(1105820), // Rule ID 61541 //
     /* 1105748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1105759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1105762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1105765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1105768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105787 */     // MIs[0] policy
     /* 1105787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105797 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105806 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105819 */     // GIR_Coverage, 61541,
     /* 1105819 */     GIR_EraseRootFromParent_Done,
     /* 1105820 */   // Label 16267: @1105820
     /* 1105820 */   GIM_Try, /*On fail goto*//*Label 16268*/ GIMT_Encode4(1105897), // Rule ID 61544 //
     /* 1105825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1105836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1105839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105864 */     // MIs[0] policy
     /* 1105864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105874 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105896 */     // GIR_Coverage, 61544,
     /* 1105896 */     GIR_EraseRootFromParent_Done,
     /* 1105897 */   // Label 16268: @1105897
     /* 1105897 */   GIM_Try, /*On fail goto*//*Label 16269*/ GIMT_Encode4(1105974), // Rule ID 61545 //
     /* 1105902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1105913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1105916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105941 */     // MIs[0] policy
     /* 1105941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105951 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105960 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105973 */     // GIR_Coverage, 61545,
     /* 1105973 */     GIR_EraseRootFromParent_Done,
     /* 1105974 */   // Label 16269: @1105974
     /* 1105974 */   GIM_Try, /*On fail goto*//*Label 16270*/ GIMT_Encode4(1106051), // Rule ID 61548 //
     /* 1105979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1105990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1105993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1105996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106018 */     // MIs[0] policy
     /* 1106018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106028 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106050 */     // GIR_Coverage, 61548,
     /* 1106050 */     GIR_EraseRootFromParent_Done,
     /* 1106051 */   // Label 16270: @1106051
     /* 1106051 */   GIM_Try, /*On fail goto*//*Label 16271*/ GIMT_Encode4(1106128), // Rule ID 61549 //
     /* 1106056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1106067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1106070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1106073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106095 */     // MIs[0] policy
     /* 1106095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106105 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106114 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106127 */     // GIR_Coverage, 61549,
     /* 1106127 */     GIR_EraseRootFromParent_Done,
     /* 1106128 */   // Label 16271: @1106128
     /* 1106128 */   GIM_Try, /*On fail goto*//*Label 16272*/ GIMT_Encode4(1106205), // Rule ID 61552 //
     /* 1106133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1106144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1106147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1106150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1106153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106172 */     // MIs[0] policy
     /* 1106172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106182 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106204 */     // GIR_Coverage, 61552,
     /* 1106204 */     GIR_EraseRootFromParent_Done,
     /* 1106205 */   // Label 16272: @1106205
     /* 1106205 */   GIM_Try, /*On fail goto*//*Label 16273*/ GIMT_Encode4(1106282), // Rule ID 61553 //
     /* 1106210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1106221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1106224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1106227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1106230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106249 */     // MIs[0] policy
     /* 1106249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106259 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106268 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106281 */     // GIR_Coverage, 61553,
     /* 1106281 */     GIR_EraseRootFromParent_Done,
     /* 1106282 */   // Label 16273: @1106282
     /* 1106282 */   GIM_Try, /*On fail goto*//*Label 16274*/ GIMT_Encode4(1106359), // Rule ID 61556 //
     /* 1106287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106326 */     // MIs[0] policy
     /* 1106326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1106339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106358 */     // GIR_Coverage, 61556,
     /* 1106358 */     GIR_EraseRootFromParent_Done,
     /* 1106359 */   // Label 16274: @1106359
     /* 1106359 */   GIM_Try, /*On fail goto*//*Label 16275*/ GIMT_Encode4(1106436), // Rule ID 61557 //
     /* 1106364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106403 */     // MIs[0] policy
     /* 1106403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106413 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1106416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106422 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106435 */     // GIR_Coverage, 61557,
     /* 1106435 */     GIR_EraseRootFromParent_Done,
     /* 1106436 */   // Label 16275: @1106436
     /* 1106436 */   GIM_Try, /*On fail goto*//*Label 16276*/ GIMT_Encode4(1106513), // Rule ID 61560 //
     /* 1106441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1106458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106480 */     // MIs[0] policy
     /* 1106480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106499 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106512 */     // GIR_Coverage, 61560,
     /* 1106512 */     GIR_EraseRootFromParent_Done,
     /* 1106513 */   // Label 16276: @1106513
     /* 1106513 */   GIM_Try, /*On fail goto*//*Label 16277*/ GIMT_Encode4(1106590), // Rule ID 61561 //
     /* 1106518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1106535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106557 */     // MIs[0] policy
     /* 1106557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106567 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106576 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106589 */     // GIR_Coverage, 61561,
     /* 1106589 */     GIR_EraseRootFromParent_Done,
     /* 1106590 */   // Label 16277: @1106590
     /* 1106590 */   GIM_Try, /*On fail goto*//*Label 16278*/ GIMT_Encode4(1106667), // Rule ID 61564 //
     /* 1106595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106634 */     // MIs[0] policy
     /* 1106634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106644 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106666 */     // GIR_Coverage, 61564,
     /* 1106666 */     GIR_EraseRootFromParent_Done,
     /* 1106667 */   // Label 16278: @1106667
     /* 1106667 */   GIM_Try, /*On fail goto*//*Label 16279*/ GIMT_Encode4(1106744), // Rule ID 61565 //
     /* 1106672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106711 */     // MIs[0] policy
     /* 1106711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106721 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106730 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106743 */     // GIR_Coverage, 61565,
     /* 1106743 */     GIR_EraseRootFromParent_Done,
     /* 1106744 */   // Label 16279: @1106744
     /* 1106744 */   GIM_Try, /*On fail goto*//*Label 16280*/ GIMT_Encode4(1106821), // Rule ID 61568 //
     /* 1106749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1106766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1106769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106788 */     // MIs[0] policy
     /* 1106788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1106801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106820 */     // GIR_Coverage, 61568,
     /* 1106820 */     GIR_EraseRootFromParent_Done,
     /* 1106821 */   // Label 16280: @1106821
     /* 1106821 */   GIM_Try, /*On fail goto*//*Label 16281*/ GIMT_Encode4(1106898), // Rule ID 61569 //
     /* 1106826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1106843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1106846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106865 */     // MIs[0] policy
     /* 1106865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106875 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1106878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106884 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106897 */     // GIR_Coverage, 61569,
     /* 1106897 */     GIR_EraseRootFromParent_Done,
     /* 1106898 */   // Label 16281: @1106898
     /* 1106898 */   GIM_Try, /*On fail goto*//*Label 16282*/ GIMT_Encode4(1106975), // Rule ID 61572 //
     /* 1106903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106942 */     // MIs[0] policy
     /* 1106942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106952 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106974 */     // GIR_Coverage, 61572,
     /* 1106974 */     GIR_EraseRootFromParent_Done,
     /* 1106975 */   // Label 16282: @1106975
     /* 1106975 */   GIM_Try, /*On fail goto*//*Label 16283*/ GIMT_Encode4(1107052), // Rule ID 61573 //
     /* 1106980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1107000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1107007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107019 */     // MIs[0] policy
     /* 1107019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107029 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1107032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107038 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1107048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107051 */     // GIR_Coverage, 61573,
     /* 1107051 */     GIR_EraseRootFromParent_Done,
     /* 1107052 */   // Label 16283: @1107052
     /* 1107052 */   GIM_Try, /*On fail goto*//*Label 16284*/ GIMT_Encode4(1107129), // Rule ID 61576 //
     /* 1107057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1107068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1107071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1107074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1107077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1107084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107096 */     // MIs[0] policy
     /* 1107096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107106 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1107109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1107125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107128 */     // GIR_Coverage, 61576,
     /* 1107128 */     GIR_EraseRootFromParent_Done,
     /* 1107129 */   // Label 16284: @1107129
     /* 1107129 */   GIM_Try, /*On fail goto*//*Label 16285*/ GIMT_Encode4(1107206), // Rule ID 61577 //
     /* 1107134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1107145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1107148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1107151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1107154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1107161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107173 */     // MIs[0] policy
     /* 1107173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107183 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1107186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107192 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1107202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107205 */     // GIR_Coverage, 61577,
     /* 1107205 */     GIR_EraseRootFromParent_Done,
     /* 1107206 */   // Label 16285: @1107206
     /* 1107206 */   GIM_Try, /*On fail goto*//*Label 16286*/ GIMT_Encode4(1107283), // Rule ID 62102 //
     /* 1107211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1107214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107250 */     // MIs[0] policy
     /* 1107250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107260 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1107263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107282 */     // GIR_Coverage, 62102,
     /* 1107282 */     GIR_EraseRootFromParent_Done,
     /* 1107283 */   // Label 16286: @1107283
     /* 1107283 */   GIM_Try, /*On fail goto*//*Label 16287*/ GIMT_Encode4(1107360), // Rule ID 62103 //
     /* 1107288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1107291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107327 */     // MIs[0] policy
     /* 1107327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107337 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1107340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107359 */     // GIR_Coverage, 62103,
     /* 1107359 */     GIR_EraseRootFromParent_Done,
     /* 1107360 */   // Label 16287: @1107360
     /* 1107360 */   GIM_Try, /*On fail goto*//*Label 16288*/ GIMT_Encode4(1107437), // Rule ID 62104 //
     /* 1107365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1107368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1107385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107404 */     // MIs[0] policy
     /* 1107404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1107417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107436 */     // GIR_Coverage, 62104,
     /* 1107436 */     GIR_EraseRootFromParent_Done,
     /* 1107437 */   // Label 16288: @1107437
     /* 1107437 */   GIM_Try, /*On fail goto*//*Label 16289*/ GIMT_Encode4(1107514), // Rule ID 62105 //
     /* 1107442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1107445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1107462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107481 */     // MIs[0] policy
     /* 1107481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107491 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1107494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107513 */     // GIR_Coverage, 62105,
     /* 1107513 */     GIR_EraseRootFromParent_Done,
     /* 1107514 */   // Label 16289: @1107514
     /* 1107514 */   GIM_Try, /*On fail goto*//*Label 16290*/ GIMT_Encode4(1107591), // Rule ID 62106 //
     /* 1107519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1107522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107558 */     // MIs[0] policy
     /* 1107558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1107571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107590 */     // GIR_Coverage, 62106,
     /* 1107590 */     GIR_EraseRootFromParent_Done,
     /* 1107591 */   // Label 16290: @1107591
     /* 1107591 */   GIM_Try, /*On fail goto*//*Label 16291*/ GIMT_Encode4(1107668), // Rule ID 62107 //
     /* 1107596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1107599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107635 */     // MIs[0] policy
     /* 1107635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107645 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1107648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107667 */     // GIR_Coverage, 62107,
     /* 1107667 */     GIR_EraseRootFromParent_Done,
     /* 1107668 */   // Label 16291: @1107668
     /* 1107668 */   GIM_Try, /*On fail goto*//*Label 16292*/ GIMT_Encode4(1107745), // Rule ID 62108 //
     /* 1107673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1107676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1107693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107712 */     // MIs[0] policy
     /* 1107712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1107725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107744 */     // GIR_Coverage, 62108,
     /* 1107744 */     GIR_EraseRootFromParent_Done,
     /* 1107745 */   // Label 16292: @1107745
     /* 1107745 */   GIM_Try, /*On fail goto*//*Label 16293*/ GIMT_Encode4(1107822), // Rule ID 62109 //
     /* 1107750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1107753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1107770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107789 */     // MIs[0] policy
     /* 1107789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107799 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1107802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107821 */     // GIR_Coverage, 62109,
     /* 1107821 */     GIR_EraseRootFromParent_Done,
     /* 1107822 */   // Label 16293: @1107822
     /* 1107822 */   GIM_Try, /*On fail goto*//*Label 16294*/ GIMT_Encode4(1107899), // Rule ID 62312 //
     /* 1107827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1107838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1107841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1107844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1107847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107866 */     // MIs[0] policy
     /* 1107866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107876 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1107879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107898 */     // GIR_Coverage, 62312,
     /* 1107898 */     GIR_EraseRootFromParent_Done,
     /* 1107899 */   // Label 16294: @1107899
     /* 1107899 */   GIM_Try, /*On fail goto*//*Label 16295*/ GIMT_Encode4(1107976), // Rule ID 62313 //
     /* 1107904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1107915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1107918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1107921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1107924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107943 */     // MIs[0] policy
     /* 1107943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107953 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1107956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107975 */     // GIR_Coverage, 62313,
     /* 1107975 */     GIR_EraseRootFromParent_Done,
     /* 1107976 */   // Label 16295: @1107976
     /* 1107976 */   GIM_Try, /*On fail goto*//*Label 16296*/ GIMT_Encode4(1108053), // Rule ID 62314 //
     /* 1107981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108020 */     // MIs[0] policy
     /* 1108020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1108033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108052 */     // GIR_Coverage, 62314,
     /* 1108052 */     GIR_EraseRootFromParent_Done,
     /* 1108053 */   // Label 16296: @1108053
     /* 1108053 */   GIM_Try, /*On fail goto*//*Label 16297*/ GIMT_Encode4(1108130), // Rule ID 62315 //
     /* 1108058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108097 */     // MIs[0] policy
     /* 1108097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108107 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1108110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108129 */     // GIR_Coverage, 62315,
     /* 1108129 */     GIR_EraseRootFromParent_Done,
     /* 1108130 */   // Label 16297: @1108130
     /* 1108130 */   GIM_Try, /*On fail goto*//*Label 16298*/ GIMT_Encode4(1108207), // Rule ID 62316 //
     /* 1108135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108174 */     // MIs[0] policy
     /* 1108174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1108187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108206 */     // GIR_Coverage, 62316,
     /* 1108206 */     GIR_EraseRootFromParent_Done,
     /* 1108207 */   // Label 16298: @1108207
     /* 1108207 */   GIM_Try, /*On fail goto*//*Label 16299*/ GIMT_Encode4(1108284), // Rule ID 62317 //
     /* 1108212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108251 */     // MIs[0] policy
     /* 1108251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108261 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1108264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108283 */     // GIR_Coverage, 62317,
     /* 1108283 */     GIR_EraseRootFromParent_Done,
     /* 1108284 */   // Label 16299: @1108284
     /* 1108284 */   GIM_Try, /*On fail goto*//*Label 16300*/ GIMT_Encode4(1108361), // Rule ID 62318 //
     /* 1108289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1108300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1108303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1108306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108328 */     // MIs[0] policy
     /* 1108328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108338 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1108341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108360 */     // GIR_Coverage, 62318,
     /* 1108360 */     GIR_EraseRootFromParent_Done,
     /* 1108361 */   // Label 16300: @1108361
     /* 1108361 */   GIM_Try, /*On fail goto*//*Label 16301*/ GIMT_Encode4(1108438), // Rule ID 62319 //
     /* 1108366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1108377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1108380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1108383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108405 */     // MIs[0] policy
     /* 1108405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108415 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1108418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108437 */     // GIR_Coverage, 62319,
     /* 1108437 */     GIR_EraseRootFromParent_Done,
     /* 1108438 */   // Label 16301: @1108438
     /* 1108438 */   GIM_Try, /*On fail goto*//*Label 16302*/ GIMT_Encode4(1108515), // Rule ID 62320 //
     /* 1108443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1108454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1108457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1108460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108482 */     // MIs[0] policy
     /* 1108482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108492 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108514 */     // GIR_Coverage, 62320,
     /* 1108514 */     GIR_EraseRootFromParent_Done,
     /* 1108515 */   // Label 16302: @1108515
     /* 1108515 */   GIM_Try, /*On fail goto*//*Label 16303*/ GIMT_Encode4(1108592), // Rule ID 62321 //
     /* 1108520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1108531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1108534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1108537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108559 */     // MIs[0] policy
     /* 1108559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108569 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108591 */     // GIR_Coverage, 62321,
     /* 1108591 */     GIR_EraseRootFromParent_Done,
     /* 1108592 */   // Label 16303: @1108592
     /* 1108592 */   GIM_Try, /*On fail goto*//*Label 16304*/ GIMT_Encode4(1108669), // Rule ID 62322 //
     /* 1108597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108636 */     // MIs[0] policy
     /* 1108636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1108649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108668 */     // GIR_Coverage, 62322,
     /* 1108668 */     GIR_EraseRootFromParent_Done,
     /* 1108669 */   // Label 16304: @1108669
     /* 1108669 */   GIM_Try, /*On fail goto*//*Label 16305*/ GIMT_Encode4(1108746), // Rule ID 62323 //
     /* 1108674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108713 */     // MIs[0] policy
     /* 1108713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108723 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1108726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108745 */     // GIR_Coverage, 62323,
     /* 1108745 */     GIR_EraseRootFromParent_Done,
     /* 1108746 */   // Label 16305: @1108746
     /* 1108746 */   GIM_Try, /*On fail goto*//*Label 16306*/ GIMT_Encode4(1108823), // Rule ID 62324 //
     /* 1108751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108790 */     // MIs[0] policy
     /* 1108790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1108803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108822 */     // GIR_Coverage, 62324,
     /* 1108822 */     GIR_EraseRootFromParent_Done,
     /* 1108823 */   // Label 16306: @1108823
     /* 1108823 */   GIM_Try, /*On fail goto*//*Label 16307*/ GIMT_Encode4(1108900), // Rule ID 62325 //
     /* 1108828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108867 */     // MIs[0] policy
     /* 1108867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1108880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108899 */     // GIR_Coverage, 62325,
     /* 1108899 */     GIR_EraseRootFromParent_Done,
     /* 1108900 */   // Label 16307: @1108900
     /* 1108900 */   GIM_Try, /*On fail goto*//*Label 16308*/ GIMT_Encode4(1108977), // Rule ID 62326 //
     /* 1108905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108944 */     // MIs[0] policy
     /* 1108944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108954 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1108957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108976 */     // GIR_Coverage, 62326,
     /* 1108976 */     GIR_EraseRootFromParent_Done,
     /* 1108977 */   // Label 16308: @1108977
     /* 1108977 */   GIM_Try, /*On fail goto*//*Label 16309*/ GIMT_Encode4(1109054), // Rule ID 62327 //
     /* 1108982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1109002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109021 */     // MIs[0] policy
     /* 1109021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1109034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109053 */     // GIR_Coverage, 62327,
     /* 1109053 */     GIR_EraseRootFromParent_Done,
     /* 1109054 */   // Label 16309: @1109054
     /* 1109054 */   GIM_Try, /*On fail goto*//*Label 16310*/ GIMT_Encode4(1109131), // Rule ID 62328 //
     /* 1109059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1109067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109098 */     // MIs[0] policy
     /* 1109098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109108 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1109111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109130 */     // GIR_Coverage, 62328,
     /* 1109130 */     GIR_EraseRootFromParent_Done,
     /* 1109131 */   // Label 16310: @1109131
     /* 1109131 */   GIM_Try, /*On fail goto*//*Label 16311*/ GIMT_Encode4(1109208), // Rule ID 62329 //
     /* 1109136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1109144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109175 */     // MIs[0] policy
     /* 1109175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109185 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1109188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109207 */     // GIR_Coverage, 62329,
     /* 1109207 */     GIR_EraseRootFromParent_Done,
     /* 1109208 */   // Label 16311: @1109208
     /* 1109208 */   GIM_Try, /*On fail goto*//*Label 16312*/ GIMT_Encode4(1109285), // Rule ID 62330 //
     /* 1109213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1109221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1109233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109252 */     // MIs[0] policy
     /* 1109252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1109265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109284 */     // GIR_Coverage, 62330,
     /* 1109284 */     GIR_EraseRootFromParent_Done,
     /* 1109285 */   // Label 16312: @1109285
     /* 1109285 */   GIM_Try, /*On fail goto*//*Label 16313*/ GIMT_Encode4(1109362), // Rule ID 62331 //
     /* 1109290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1109298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1109310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109329 */     // MIs[0] policy
     /* 1109329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109339 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1109342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109361 */     // GIR_Coverage, 62331,
     /* 1109361 */     GIR_EraseRootFromParent_Done,
     /* 1109362 */   // Label 16313: @1109362
     /* 1109362 */   GIM_Try, /*On fail goto*//*Label 16314*/ GIMT_Encode4(1109439), // Rule ID 62332 //
     /* 1109367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1109378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1109381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1109384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1109387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109406 */     // MIs[0] policy
     /* 1109406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1109419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109438 */     // GIR_Coverage, 62332,
     /* 1109438 */     GIR_EraseRootFromParent_Done,
     /* 1109439 */   // Label 16314: @1109439
     /* 1109439 */   GIM_Try, /*On fail goto*//*Label 16315*/ GIMT_Encode4(1109516), // Rule ID 62333 //
     /* 1109444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1109455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1109458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1109461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1109464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109483 */     // MIs[0] policy
     /* 1109483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109493 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1109496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109515 */     // GIR_Coverage, 62333,
     /* 1109515 */     GIR_EraseRootFromParent_Done,
     /* 1109516 */   // Label 16315: @1109516
     /* 1109516 */   GIM_Try, /*On fail goto*//*Label 16316*/ GIMT_Encode4(1109593), // Rule ID 62334 //
     /* 1109521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109560 */     // MIs[0] policy
     /* 1109560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1109573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109592 */     // GIR_Coverage, 62334,
     /* 1109592 */     GIR_EraseRootFromParent_Done,
     /* 1109593 */   // Label 16316: @1109593
     /* 1109593 */   GIM_Try, /*On fail goto*//*Label 16317*/ GIMT_Encode4(1109670), // Rule ID 62335 //
     /* 1109598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109637 */     // MIs[0] policy
     /* 1109637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109647 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1109650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109669 */     // GIR_Coverage, 62335,
     /* 1109669 */     GIR_EraseRootFromParent_Done,
     /* 1109670 */   // Label 16317: @1109670
     /* 1109670 */   GIM_Try, /*On fail goto*//*Label 16318*/ GIMT_Encode4(1109747), // Rule ID 62336 //
     /* 1109675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1109695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109714 */     // MIs[0] policy
     /* 1109714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1109727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109746 */     // GIR_Coverage, 62336,
     /* 1109746 */     GIR_EraseRootFromParent_Done,
     /* 1109747 */   // Label 16318: @1109747
     /* 1109747 */   GIM_Try, /*On fail goto*//*Label 16319*/ GIMT_Encode4(1109824), // Rule ID 62337 //
     /* 1109752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1109772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109791 */     // MIs[0] policy
     /* 1109791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1109804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109823 */     // GIR_Coverage, 62337,
     /* 1109823 */     GIR_EraseRootFromParent_Done,
     /* 1109824 */   // Label 16319: @1109824
     /* 1109824 */   GIM_Try, /*On fail goto*//*Label 16320*/ GIMT_Encode4(1109901), // Rule ID 62338 //
     /* 1109829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109868 */     // MIs[0] policy
     /* 1109868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1109881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109900 */     // GIR_Coverage, 62338,
     /* 1109900 */     GIR_EraseRootFromParent_Done,
     /* 1109901 */   // Label 16320: @1109901
     /* 1109901 */   GIM_Try, /*On fail goto*//*Label 16321*/ GIMT_Encode4(1109978), // Rule ID 62339 //
     /* 1109906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109945 */     // MIs[0] policy
     /* 1109945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109955 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1109958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109977 */     // GIR_Coverage, 62339,
     /* 1109977 */     GIR_EraseRootFromParent_Done,
     /* 1109978 */   // Label 16321: @1109978
     /* 1109978 */   GIM_Try, /*On fail goto*//*Label 16322*/ GIMT_Encode4(1110055), // Rule ID 62340 //
     /* 1109983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1110003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110022 */     // MIs[0] policy
     /* 1110022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110032 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1110035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110054 */     // GIR_Coverage, 62340,
     /* 1110054 */     GIR_EraseRootFromParent_Done,
     /* 1110055 */   // Label 16322: @1110055
     /* 1110055 */   GIM_Try, /*On fail goto*//*Label 16323*/ GIMT_Encode4(1110132), // Rule ID 62341 //
     /* 1110060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1110063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1110068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1110080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110099 */     // MIs[0] policy
     /* 1110099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110109 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1110112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110131 */     // GIR_Coverage, 62341,
     /* 1110131 */     GIR_EraseRootFromParent_Done,
     /* 1110132 */   // Label 16323: @1110132
     /* 1110132 */   GIM_Try, /*On fail goto*//*Label 16324*/ GIMT_Encode4(1110209), // Rule ID 62342 //
     /* 1110137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1110148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1110151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1110154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1110157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110176 */     // MIs[0] policy
     /* 1110176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1110189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110208 */     // GIR_Coverage, 62342,
     /* 1110208 */     GIR_EraseRootFromParent_Done,
     /* 1110209 */   // Label 16324: @1110209
     /* 1110209 */   GIM_Try, /*On fail goto*//*Label 16325*/ GIMT_Encode4(1110286), // Rule ID 62343 //
     /* 1110214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1110225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1110228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1110231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1110234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110253 */     // MIs[0] policy
     /* 1110253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110263 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1110266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110285 */     // GIR_Coverage, 62343,
     /* 1110285 */     GIR_EraseRootFromParent_Done,
     /* 1110286 */   // Label 16325: @1110286
     /* 1110286 */   GIM_Try, /*On fail goto*//*Label 16326*/ GIMT_Encode4(1110363), // Rule ID 62344 //
     /* 1110291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1110302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1110305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1110308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1110311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110330 */     // MIs[0] policy
     /* 1110330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110362 */     // GIR_Coverage, 62344,
     /* 1110362 */     GIR_EraseRootFromParent_Done,
     /* 1110363 */   // Label 16326: @1110363
     /* 1110363 */   GIM_Try, /*On fail goto*//*Label 16327*/ GIMT_Encode4(1110440), // Rule ID 62345 //
     /* 1110368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1110379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1110382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1110385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1110388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110407 */     // MIs[0] policy
     /* 1110407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110417 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110439 */     // GIR_Coverage, 62345,
     /* 1110439 */     GIR_EraseRootFromParent_Done,
     /* 1110440 */   // Label 16327: @1110440
     /* 1110440 */   GIM_Try, /*On fail goto*//*Label 16328*/ GIMT_Encode4(1110517), // Rule ID 62346 //
     /* 1110445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1110456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1110459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1110462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1110465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110484 */     // MIs[0] policy
     /* 1110484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110516 */     // GIR_Coverage, 62346,
     /* 1110516 */     GIR_EraseRootFromParent_Done,
     /* 1110517 */   // Label 16328: @1110517
     /* 1110517 */   GIM_Try, /*On fail goto*//*Label 16329*/ GIMT_Encode4(1110594), // Rule ID 62347 //
     /* 1110522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1110533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1110536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1110539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1110542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110561 */     // MIs[0] policy
     /* 1110561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110571 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110593 */     // GIR_Coverage, 62347,
     /* 1110593 */     GIR_EraseRootFromParent_Done,
     /* 1110594 */   // Label 16329: @1110594
     /* 1110594 */   GIM_Try, /*On fail goto*//*Label 16330*/ GIMT_Encode4(1110671), // Rule ID 62348 //
     /* 1110599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1110619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110638 */     // MIs[0] policy
     /* 1110638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110670 */     // GIR_Coverage, 62348,
     /* 1110670 */     GIR_EraseRootFromParent_Done,
     /* 1110671 */   // Label 16330: @1110671
     /* 1110671 */   GIM_Try, /*On fail goto*//*Label 16331*/ GIMT_Encode4(1110748), // Rule ID 62349 //
     /* 1110676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1110696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110715 */     // MIs[0] policy
     /* 1110715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110725 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110747 */     // GIR_Coverage, 62349,
     /* 1110747 */     GIR_EraseRootFromParent_Done,
     /* 1110748 */   // Label 16331: @1110748
     /* 1110748 */   GIM_Try, /*On fail goto*//*Label 16332*/ GIMT_Encode4(1110825), // Rule ID 62350 //
     /* 1110753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1110773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110792 */     // MIs[0] policy
     /* 1110792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110802 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110824 */     // GIR_Coverage, 62350,
     /* 1110824 */     GIR_EraseRootFromParent_Done,
     /* 1110825 */   // Label 16332: @1110825
     /* 1110825 */   GIM_Try, /*On fail goto*//*Label 16333*/ GIMT_Encode4(1110902), // Rule ID 62351 //
     /* 1110830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1110850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110869 */     // MIs[0] policy
     /* 1110869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110879 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110901 */     // GIR_Coverage, 62351,
     /* 1110901 */     GIR_EraseRootFromParent_Done,
     /* 1110902 */   // Label 16333: @1110902
     /* 1110902 */   GIM_Try, /*On fail goto*//*Label 16334*/ GIMT_Encode4(1110979), // Rule ID 62352 //
     /* 1110907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1110927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110946 */     // MIs[0] policy
     /* 1110946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110956 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1110959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110978 */     // GIR_Coverage, 62352,
     /* 1110978 */     GIR_EraseRootFromParent_Done,
     /* 1110979 */   // Label 16334: @1110979
     /* 1110979 */   GIM_Try, /*On fail goto*//*Label 16335*/ GIMT_Encode4(1111056), // Rule ID 62353 //
     /* 1110984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111023 */     // MIs[0] policy
     /* 1111023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111033 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111055 */     // GIR_Coverage, 62353,
     /* 1111055 */     GIR_EraseRootFromParent_Done,
     /* 1111056 */   // Label 16335: @1111056
     /* 1111056 */   GIM_Try, /*On fail goto*//*Label 16336*/ GIMT_Encode4(1111133), // Rule ID 62354 //
     /* 1111061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1111072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1111075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1111078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1111081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111100 */     // MIs[0] policy
     /* 1111100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111132 */     // GIR_Coverage, 62354,
     /* 1111132 */     GIR_EraseRootFromParent_Done,
     /* 1111133 */   // Label 16336: @1111133
     /* 1111133 */   GIM_Try, /*On fail goto*//*Label 16337*/ GIMT_Encode4(1111210), // Rule ID 62355 //
     /* 1111138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1111149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1111152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1111155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1111158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111177 */     // MIs[0] policy
     /* 1111177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111187 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111209 */     // GIR_Coverage, 62355,
     /* 1111209 */     GIR_EraseRootFromParent_Done,
     /* 1111210 */   // Label 16337: @1111210
     /* 1111210 */   GIM_Try, /*On fail goto*//*Label 16338*/ GIMT_Encode4(1111287), // Rule ID 62356 //
     /* 1111215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1111226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1111229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1111232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1111235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111254 */     // MIs[0] policy
     /* 1111254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111286 */     // GIR_Coverage, 62356,
     /* 1111286 */     GIR_EraseRootFromParent_Done,
     /* 1111287 */   // Label 16338: @1111287
     /* 1111287 */   GIM_Try, /*On fail goto*//*Label 16339*/ GIMT_Encode4(1111364), // Rule ID 62357 //
     /* 1111292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1111303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1111306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1111309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1111312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111331 */     // MIs[0] policy
     /* 1111331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111341 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111363 */     // GIR_Coverage, 62357,
     /* 1111363 */     GIR_EraseRootFromParent_Done,
     /* 1111364 */   // Label 16339: @1111364
     /* 1111364 */   GIM_Try, /*On fail goto*//*Label 16340*/ GIMT_Encode4(1111441), // Rule ID 62358 //
     /* 1111369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1111380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1111383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1111386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1111389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111408 */     // MIs[0] policy
     /* 1111408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111418 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111440 */     // GIR_Coverage, 62358,
     /* 1111440 */     GIR_EraseRootFromParent_Done,
     /* 1111441 */   // Label 16340: @1111441
     /* 1111441 */   GIM_Try, /*On fail goto*//*Label 16341*/ GIMT_Encode4(1111518), // Rule ID 62359 //
     /* 1111446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1111457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1111460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1111463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1111466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111485 */     // MIs[0] policy
     /* 1111485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111495 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111517 */     // GIR_Coverage, 62359,
     /* 1111517 */     GIR_EraseRootFromParent_Done,
     /* 1111518 */   // Label 16341: @1111518
     /* 1111518 */   GIM_Try, /*On fail goto*//*Label 16342*/ GIMT_Encode4(1111595), // Rule ID 62360 //
     /* 1111523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111562 */     // MIs[0] policy
     /* 1111562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1111575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111594 */     // GIR_Coverage, 62360,
     /* 1111594 */     GIR_EraseRootFromParent_Done,
     /* 1111595 */   // Label 16342: @1111595
     /* 1111595 */   GIM_Try, /*On fail goto*//*Label 16343*/ GIMT_Encode4(1111672), // Rule ID 62361 //
     /* 1111600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111639 */     // MIs[0] policy
     /* 1111639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111649 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1111652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111671 */     // GIR_Coverage, 62361,
     /* 1111671 */     GIR_EraseRootFromParent_Done,
     /* 1111672 */   // Label 16343: @1111672
     /* 1111672 */   GIM_Try, /*On fail goto*//*Label 16344*/ GIMT_Encode4(1111749), // Rule ID 62362 //
     /* 1111677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111716 */     // MIs[0] policy
     /* 1111716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111748 */     // GIR_Coverage, 62362,
     /* 1111748 */     GIR_EraseRootFromParent_Done,
     /* 1111749 */   // Label 16344: @1111749
     /* 1111749 */   GIM_Try, /*On fail goto*//*Label 16345*/ GIMT_Encode4(1111826), // Rule ID 62363 //
     /* 1111754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111793 */     // MIs[0] policy
     /* 1111793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111803 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111825 */     // GIR_Coverage, 62363,
     /* 1111825 */     GIR_EraseRootFromParent_Done,
     /* 1111826 */   // Label 16345: @1111826
     /* 1111826 */   GIM_Try, /*On fail goto*//*Label 16346*/ GIMT_Encode4(1111903), // Rule ID 62364 //
     /* 1111831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1111842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1111845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1111848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1111851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111870 */     // MIs[0] policy
     /* 1111870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111880 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111902 */     // GIR_Coverage, 62364,
     /* 1111902 */     GIR_EraseRootFromParent_Done,
     /* 1111903 */   // Label 16346: @1111903
     /* 1111903 */   GIM_Try, /*On fail goto*//*Label 16347*/ GIMT_Encode4(1111980), // Rule ID 62365 //
     /* 1111908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1111919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1111922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1111925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1111928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111947 */     // MIs[0] policy
     /* 1111947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111957 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111979 */     // GIR_Coverage, 62365,
     /* 1111979 */     GIR_EraseRootFromParent_Done,
     /* 1111980 */   // Label 16347: @1111980
     /* 1111980 */   GIM_Try, /*On fail goto*//*Label 16348*/ GIMT_Encode4(1112057), // Rule ID 62366 //
     /* 1111985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1112002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1112005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112024 */     // MIs[0] policy
     /* 1112024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112056 */     // GIR_Coverage, 62366,
     /* 1112056 */     GIR_EraseRootFromParent_Done,
     /* 1112057 */   // Label 16348: @1112057
     /* 1112057 */   GIM_Try, /*On fail goto*//*Label 16349*/ GIMT_Encode4(1112134), // Rule ID 62367 //
     /* 1112062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1112073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1112076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1112079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1112082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112101 */     // MIs[0] policy
     /* 1112101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112111 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112133 */     // GIR_Coverage, 62367,
     /* 1112133 */     GIR_EraseRootFromParent_Done,
     /* 1112134 */   // Label 16349: @1112134
     /* 1112134 */   GIM_Try, /*On fail goto*//*Label 16350*/ GIMT_Encode4(1112211), // Rule ID 62368 //
     /* 1112139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1112150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1112153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1112156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1112159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112178 */     // MIs[0] policy
     /* 1112178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112188 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112210 */     // GIR_Coverage, 62368,
     /* 1112210 */     GIR_EraseRootFromParent_Done,
     /* 1112211 */   // Label 16350: @1112211
     /* 1112211 */   GIM_Try, /*On fail goto*//*Label 16351*/ GIMT_Encode4(1112288), // Rule ID 62369 //
     /* 1112216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1112227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1112230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1112233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1112236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112255 */     // MIs[0] policy
     /* 1112255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112265 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112287 */     // GIR_Coverage, 62369,
     /* 1112287 */     GIR_EraseRootFromParent_Done,
     /* 1112288 */   // Label 16351: @1112288
     /* 1112288 */   GIM_Try, /*On fail goto*//*Label 16352*/ GIMT_Encode4(1112365), // Rule ID 62370 //
     /* 1112293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1112304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1112307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1112310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1112313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112332 */     // MIs[0] policy
     /* 1112332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112342 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112364 */     // GIR_Coverage, 62370,
     /* 1112364 */     GIR_EraseRootFromParent_Done,
     /* 1112365 */   // Label 16352: @1112365
     /* 1112365 */   GIM_Try, /*On fail goto*//*Label 16353*/ GIMT_Encode4(1112442), // Rule ID 62371 //
     /* 1112370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1112381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1112384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1112387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1112390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112409 */     // MIs[0] policy
     /* 1112409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112419 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112441 */     // GIR_Coverage, 62371,
     /* 1112441 */     GIR_EraseRootFromParent_Done,
     /* 1112442 */   // Label 16353: @1112442
     /* 1112442 */   GIM_Try, /*On fail goto*//*Label 16354*/ GIMT_Encode4(1112519), // Rule ID 62372 //
     /* 1112447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1112458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1112461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1112464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1112467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112486 */     // MIs[0] policy
     /* 1112486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112518 */     // GIR_Coverage, 62372,
     /* 1112518 */     GIR_EraseRootFromParent_Done,
     /* 1112519 */   // Label 16354: @1112519
     /* 1112519 */   GIM_Try, /*On fail goto*//*Label 16355*/ GIMT_Encode4(1112596), // Rule ID 62373 //
     /* 1112524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1112535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1112538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1112541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1112544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112563 */     // MIs[0] policy
     /* 1112563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112573 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112595 */     // GIR_Coverage, 62373,
     /* 1112595 */     GIR_EraseRootFromParent_Done,
     /* 1112596 */   // Label 16355: @1112596
     /* 1112596 */   GIM_Try, /*On fail goto*//*Label 16356*/ GIMT_Encode4(1112673), // Rule ID 62374 //
     /* 1112601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1112612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1112615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1112618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1112621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112640 */     // MIs[0] policy
     /* 1112640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112650 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112672 */     // GIR_Coverage, 62374,
     /* 1112672 */     GIR_EraseRootFromParent_Done,
     /* 1112673 */   // Label 16356: @1112673
     /* 1112673 */   GIM_Try, /*On fail goto*//*Label 16357*/ GIMT_Encode4(1112750), // Rule ID 62375 //
     /* 1112678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1112689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1112692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1112695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1112698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112717 */     // MIs[0] policy
     /* 1112717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112727 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112749 */     // GIR_Coverage, 62375,
     /* 1112749 */     GIR_EraseRootFromParent_Done,
     /* 1112750 */   // Label 16357: @1112750
     /* 1112750 */   GIM_Try, /*On fail goto*//*Label 16358*/ GIMT_Encode4(1112827), // Rule ID 62376 //
     /* 1112755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1112766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1112769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1112772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1112775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112794 */     // MIs[0] policy
     /* 1112794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112804 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112826 */     // GIR_Coverage, 62376,
     /* 1112826 */     GIR_EraseRootFromParent_Done,
     /* 1112827 */   // Label 16358: @1112827
     /* 1112827 */   GIM_Try, /*On fail goto*//*Label 16359*/ GIMT_Encode4(1112904), // Rule ID 62377 //
     /* 1112832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1112843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1112846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1112849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1112852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112871 */     // MIs[0] policy
     /* 1112871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112881 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112903 */     // GIR_Coverage, 62377,
     /* 1112903 */     GIR_EraseRootFromParent_Done,
     /* 1112904 */   // Label 16359: @1112904
     /* 1112904 */   GIM_Try, /*On fail goto*//*Label 16360*/ GIMT_Encode4(1112981), // Rule ID 62378 //
     /* 1112909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112948 */     // MIs[0] policy
     /* 1112948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112958 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1112961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112980 */     // GIR_Coverage, 62378,
     /* 1112980 */     GIR_EraseRootFromParent_Done,
     /* 1112981 */   // Label 16360: @1112981
     /* 1112981 */   GIM_Try, /*On fail goto*//*Label 16361*/ GIMT_Encode4(1113058), // Rule ID 62379 //
     /* 1112986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1113003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1113006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113025 */     // MIs[0] policy
     /* 1113025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113035 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1113038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113057 */     // GIR_Coverage, 62379,
     /* 1113057 */     GIR_EraseRootFromParent_Done,
     /* 1113058 */   // Label 16361: @1113058
     /* 1113058 */   GIM_Try, /*On fail goto*//*Label 16362*/ GIMT_Encode4(1113135), // Rule ID 62380 //
     /* 1113063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1113080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1113083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113102 */     // MIs[0] policy
     /* 1113102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113112 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1113115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113134 */     // GIR_Coverage, 62380,
     /* 1113134 */     GIR_EraseRootFromParent_Done,
     /* 1113135 */   // Label 16362: @1113135
     /* 1113135 */   GIM_Try, /*On fail goto*//*Label 16363*/ GIMT_Encode4(1113212), // Rule ID 62381 //
     /* 1113140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1113157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1113160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113179 */     // MIs[0] policy
     /* 1113179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113189 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1113192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113211 */     // GIR_Coverage, 62381,
     /* 1113211 */     GIR_EraseRootFromParent_Done,
     /* 1113212 */   // Label 16363: @1113212
     /* 1113212 */   GIM_Try, /*On fail goto*//*Label 16364*/ GIMT_Encode4(1113289), // Rule ID 62382 //
     /* 1113217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1113228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1113231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1113234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1113237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113256 */     // MIs[0] policy
     /* 1113256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113266 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1113269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113288 */     // GIR_Coverage, 62382,
     /* 1113288 */     GIR_EraseRootFromParent_Done,
     /* 1113289 */   // Label 16364: @1113289
     /* 1113289 */   GIM_Try, /*On fail goto*//*Label 16365*/ GIMT_Encode4(1113366), // Rule ID 62383 //
     /* 1113294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1113305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1113308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1113311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1113314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113333 */     // MIs[0] policy
     /* 1113333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113343 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1113346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113365 */     // GIR_Coverage, 62383,
     /* 1113365 */     GIR_EraseRootFromParent_Done,
     /* 1113366 */   // Label 16365: @1113366
     /* 1113366 */   GIM_Try, /*On fail goto*//*Label 16366*/ GIMT_Encode4(1113443), // Rule ID 62384 //
     /* 1113371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1113382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1113388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1113391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113410 */     // MIs[0] policy
     /* 1113410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1113423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113442 */     // GIR_Coverage, 62384,
     /* 1113442 */     GIR_EraseRootFromParent_Done,
     /* 1113443 */   // Label 16366: @1113443
     /* 1113443 */   GIM_Try, /*On fail goto*//*Label 16367*/ GIMT_Encode4(1113520), // Rule ID 62385 //
     /* 1113448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1113459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1113465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1113468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113487 */     // MIs[0] policy
     /* 1113487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113497 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1113500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113519 */     // GIR_Coverage, 62385,
     /* 1113519 */     GIR_EraseRootFromParent_Done,
     /* 1113520 */   // Label 16367: @1113520
     /* 1113520 */   GIM_Try, /*On fail goto*//*Label 16368*/ GIMT_Encode4(1113597), // Rule ID 62386 //
     /* 1113525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1113542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1113545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113564 */     // MIs[0] policy
     /* 1113564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1113577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113596 */     // GIR_Coverage, 62386,
     /* 1113596 */     GIR_EraseRootFromParent_Done,
     /* 1113597 */   // Label 16368: @1113597
     /* 1113597 */   GIM_Try, /*On fail goto*//*Label 16369*/ GIMT_Encode4(1113674), // Rule ID 62387 //
     /* 1113602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1113619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1113622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113641 */     // MIs[0] policy
     /* 1113641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113651 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1113654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113673 */     // GIR_Coverage, 62387,
     /* 1113673 */     GIR_EraseRootFromParent_Done,
     /* 1113674 */   // Label 16369: @1113674
     /* 1113674 */   GIM_Try, /*On fail goto*//*Label 16370*/ GIMT_Encode4(1113751), // Rule ID 62388 //
     /* 1113679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1113696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1113699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113718 */     // MIs[0] policy
     /* 1113718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113728 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1113731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113750 */     // GIR_Coverage, 62388,
     /* 1113750 */     GIR_EraseRootFromParent_Done,
     /* 1113751 */   // Label 16370: @1113751
     /* 1113751 */   GIM_Try, /*On fail goto*//*Label 16371*/ GIMT_Encode4(1113828), // Rule ID 62389 //
     /* 1113756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1113773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1113776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113795 */     // MIs[0] policy
     /* 1113795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113805 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1113808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113827 */     // GIR_Coverage, 62389,
     /* 1113827 */     GIR_EraseRootFromParent_Done,
     /* 1113828 */   // Label 16371: @1113828
     /* 1113828 */   GIM_Try, /*On fail goto*//*Label 16372*/ GIMT_Encode4(1113905), // Rule ID 62390 //
     /* 1113833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1113844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1113847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1113850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1113853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113872 */     // MIs[0] policy
     /* 1113872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1113885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113904 */     // GIR_Coverage, 62390,
     /* 1113904 */     GIR_EraseRootFromParent_Done,
     /* 1113905 */   // Label 16372: @1113905
     /* 1113905 */   GIM_Try, /*On fail goto*//*Label 16373*/ GIMT_Encode4(1113982), // Rule ID 62391 //
     /* 1113910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1113921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1113924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1113927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1113930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113949 */     // MIs[0] policy
     /* 1113949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113959 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1113962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113981 */     // GIR_Coverage, 62391,
     /* 1113981 */     GIR_EraseRootFromParent_Done,
     /* 1113982 */   // Label 16373: @1113982
     /* 1113982 */   GIM_Try, /*On fail goto*//*Label 16374*/ GIMT_Encode4(1114059), // Rule ID 62392 //
     /* 1113987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1113998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1114001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1114004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1114007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114026 */     // MIs[0] policy
     /* 1114026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1114039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114058 */     // GIR_Coverage, 62392,
     /* 1114058 */     GIR_EraseRootFromParent_Done,
     /* 1114059 */   // Label 16374: @1114059
     /* 1114059 */   GIM_Try, /*On fail goto*//*Label 16375*/ GIMT_Encode4(1114136), // Rule ID 62393 //
     /* 1114064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1114072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1114075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1114078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1114081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1114084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114103 */     // MIs[0] policy
     /* 1114103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114113 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1114116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114135 */     // GIR_Coverage, 62393,
     /* 1114135 */     GIR_EraseRootFromParent_Done,
     /* 1114136 */   // Label 16375: @1114136
     /* 1114136 */   GIM_Try, /*On fail goto*//*Label 16376*/ GIMT_Encode4(1114213), // Rule ID 62394 //
     /* 1114141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1114149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1114152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1114155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1114158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1114161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114180 */     // MIs[0] policy
     /* 1114180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114190 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1114193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114212 */     // GIR_Coverage, 62394,
     /* 1114212 */     GIR_EraseRootFromParent_Done,
     /* 1114213 */   // Label 16376: @1114213
     /* 1114213 */   GIM_Try, /*On fail goto*//*Label 16377*/ GIMT_Encode4(1114290), // Rule ID 62395 //
     /* 1114218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1114226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1114229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1114232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1114235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1114238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114257 */     // MIs[0] policy
     /* 1114257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114267 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1114270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114289 */     // GIR_Coverage, 62395,
     /* 1114289 */     GIR_EraseRootFromParent_Done,
     /* 1114290 */   // Label 16377: @1114290
     /* 1114290 */   GIM_Try, /*On fail goto*//*Label 16378*/ GIMT_Encode4(1114367), // Rule ID 62616 //
     /* 1114295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1114312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1114315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114334 */     // MIs[0] policy
     /* 1114334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_MF2),
     /* 1114347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114366 */     // GIR_Coverage, 62616,
     /* 1114366 */     GIR_EraseRootFromParent_Done,
     /* 1114367 */   // Label 16378: @1114367
     /* 1114367 */   GIM_Try, /*On fail goto*//*Label 16379*/ GIMT_Encode4(1114444), // Rule ID 62617 //
     /* 1114372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1114389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1114392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114411 */     // MIs[0] policy
     /* 1114411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_MF2),
     /* 1114424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114443 */     // GIR_Coverage, 62617,
     /* 1114443 */     GIR_EraseRootFromParent_Done,
     /* 1114444 */   // Label 16379: @1114444
     /* 1114444 */   GIM_Try, /*On fail goto*//*Label 16380*/ GIMT_Encode4(1114521), // Rule ID 62620 //
     /* 1114449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1114460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1114466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114488 */     // MIs[0] policy
     /* 1114488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114498 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M1),
     /* 1114501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114520 */     // GIR_Coverage, 62620,
     /* 1114520 */     GIR_EraseRootFromParent_Done,
     /* 1114521 */   // Label 16380: @1114521
     /* 1114521 */   GIM_Try, /*On fail goto*//*Label 16381*/ GIMT_Encode4(1114598), // Rule ID 62621 //
     /* 1114526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1114537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1114543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114565 */     // MIs[0] policy
     /* 1114565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114575 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M1),
     /* 1114578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114597 */     // GIR_Coverage, 62621,
     /* 1114597 */     GIR_EraseRootFromParent_Done,
     /* 1114598 */   // Label 16381: @1114598
     /* 1114598 */   GIM_Try, /*On fail goto*//*Label 16382*/ GIMT_Encode4(1114675), // Rule ID 62624 //
     /* 1114603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1114620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114642 */     // MIs[0] policy
     /* 1114642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M2),
     /* 1114655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114674 */     // GIR_Coverage, 62624,
     /* 1114674 */     GIR_EraseRootFromParent_Done,
     /* 1114675 */   // Label 16382: @1114675
     /* 1114675 */   GIM_Try, /*On fail goto*//*Label 16383*/ GIMT_Encode4(1114752), // Rule ID 62625 //
     /* 1114680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1114697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114719 */     // MIs[0] policy
     /* 1114719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114729 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M2),
     /* 1114732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114751 */     // GIR_Coverage, 62625,
     /* 1114751 */     GIR_EraseRootFromParent_Done,
     /* 1114752 */   // Label 16383: @1114752
     /* 1114752 */   GIM_Try, /*On fail goto*//*Label 16384*/ GIMT_Encode4(1114829), // Rule ID 62628 //
     /* 1114757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1114774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1114777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114796 */     // MIs[0] policy
     /* 1114796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114806 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M4),
     /* 1114809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114828 */     // GIR_Coverage, 62628,
     /* 1114828 */     GIR_EraseRootFromParent_Done,
     /* 1114829 */   // Label 16384: @1114829
     /* 1114829 */   GIM_Try, /*On fail goto*//*Label 16385*/ GIMT_Encode4(1114906), // Rule ID 62629 //
     /* 1114834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1114851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1114854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114873 */     // MIs[0] policy
     /* 1114873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114883 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M4),
     /* 1114886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114905 */     // GIR_Coverage, 62629,
     /* 1114905 */     GIR_EraseRootFromParent_Done,
     /* 1114906 */   // Label 16385: @1114906
     /* 1114906 */   GIM_Try, /*On fail goto*//*Label 16386*/ GIMT_Encode4(1114983), // Rule ID 62632 //
     /* 1114911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1114928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1114931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114950 */     // MIs[0] policy
     /* 1114950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M8),
     /* 1114963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114982 */     // GIR_Coverage, 62632,
     /* 1114982 */     GIR_EraseRootFromParent_Done,
     /* 1114983 */   // Label 16386: @1114983
     /* 1114983 */   GIM_Try, /*On fail goto*//*Label 16387*/ GIMT_Encode4(1115060), // Rule ID 62633 //
     /* 1114988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1115005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115027 */     // MIs[0] policy
     /* 1115027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115037 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M8),
     /* 1115040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115059 */     // GIR_Coverage, 62633,
     /* 1115059 */     GIR_EraseRootFromParent_Done,
     /* 1115060 */   // Label 16387: @1115060
     /* 1115060 */   GIM_Try, /*On fail goto*//*Label 16388*/ GIMT_Encode4(1115137), // Rule ID 62636 //
     /* 1115065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115104 */     // MIs[0] policy
     /* 1115104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115114 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_MF2),
     /* 1115117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115136 */     // GIR_Coverage, 62636,
     /* 1115136 */     GIR_EraseRootFromParent_Done,
     /* 1115137 */   // Label 16388: @1115137
     /* 1115137 */   GIM_Try, /*On fail goto*//*Label 16389*/ GIMT_Encode4(1115214), // Rule ID 62637 //
     /* 1115142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115181 */     // MIs[0] policy
     /* 1115181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115191 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_MF2),
     /* 1115194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115213 */     // GIR_Coverage, 62637,
     /* 1115213 */     GIR_EraseRootFromParent_Done,
     /* 1115214 */   // Label 16389: @1115214
     /* 1115214 */   GIM_Try, /*On fail goto*//*Label 16390*/ GIMT_Encode4(1115291), // Rule ID 62640 //
     /* 1115219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1115239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115258 */     // MIs[0] policy
     /* 1115258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115268 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M1),
     /* 1115271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115290 */     // GIR_Coverage, 62640,
     /* 1115290 */     GIR_EraseRootFromParent_Done,
     /* 1115291 */   // Label 16390: @1115291
     /* 1115291 */   GIM_Try, /*On fail goto*//*Label 16391*/ GIMT_Encode4(1115368), // Rule ID 62641 //
     /* 1115296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1115316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115335 */     // MIs[0] policy
     /* 1115335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115345 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M1),
     /* 1115348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115367 */     // GIR_Coverage, 62641,
     /* 1115367 */     GIR_EraseRootFromParent_Done,
     /* 1115368 */   // Label 16391: @1115368
     /* 1115368 */   GIM_Try, /*On fail goto*//*Label 16392*/ GIMT_Encode4(1115445), // Rule ID 62644 //
     /* 1115373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1115393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115412 */     // MIs[0] policy
     /* 1115412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M2),
     /* 1115425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115444 */     // GIR_Coverage, 62644,
     /* 1115444 */     GIR_EraseRootFromParent_Done,
     /* 1115445 */   // Label 16392: @1115445
     /* 1115445 */   GIM_Try, /*On fail goto*//*Label 16393*/ GIMT_Encode4(1115522), // Rule ID 62645 //
     /* 1115450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1115470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115489 */     // MIs[0] policy
     /* 1115489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115499 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M2),
     /* 1115502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115521 */     // GIR_Coverage, 62645,
     /* 1115521 */     GIR_EraseRootFromParent_Done,
     /* 1115522 */   // Label 16393: @1115522
     /* 1115522 */   GIM_Try, /*On fail goto*//*Label 16394*/ GIMT_Encode4(1115599), // Rule ID 62648 //
     /* 1115527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115566 */     // MIs[0] policy
     /* 1115566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115576 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M4),
     /* 1115579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115598 */     // GIR_Coverage, 62648,
     /* 1115598 */     GIR_EraseRootFromParent_Done,
     /* 1115599 */   // Label 16394: @1115599
     /* 1115599 */   GIM_Try, /*On fail goto*//*Label 16395*/ GIMT_Encode4(1115676), // Rule ID 62649 //
     /* 1115604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115643 */     // MIs[0] policy
     /* 1115643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115653 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M4),
     /* 1115656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115675 */     // GIR_Coverage, 62649,
     /* 1115675 */     GIR_EraseRootFromParent_Done,
     /* 1115676 */   // Label 16395: @1115676
     /* 1115676 */   GIM_Try, /*On fail goto*//*Label 16396*/ GIMT_Encode4(1115753), // Rule ID 62652 //
     /* 1115681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115720 */     // MIs[0] policy
     /* 1115720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115730 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M8),
     /* 1115733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115752 */     // GIR_Coverage, 62652,
     /* 1115752 */     GIR_EraseRootFromParent_Done,
     /* 1115753 */   // Label 16396: @1115753
     /* 1115753 */   GIM_Try, /*On fail goto*//*Label 16397*/ GIMT_Encode4(1115830), // Rule ID 62653 //
     /* 1115758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115797 */     // MIs[0] policy
     /* 1115797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115807 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M8),
     /* 1115810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115829 */     // GIR_Coverage, 62653,
     /* 1115829 */     GIR_EraseRootFromParent_Done,
     /* 1115830 */   // Label 16397: @1115830
     /* 1115830 */   GIM_Try, /*On fail goto*//*Label 16398*/ GIMT_Encode4(1115907), // Rule ID 62656 //
     /* 1115835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1115852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115874 */     // MIs[0] policy
     /* 1115874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115884 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_MF2),
     /* 1115887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115906 */     // GIR_Coverage, 62656,
     /* 1115906 */     GIR_EraseRootFromParent_Done,
     /* 1115907 */   // Label 16398: @1115907
     /* 1115907 */   GIM_Try, /*On fail goto*//*Label 16399*/ GIMT_Encode4(1115984), // Rule ID 62657 //
     /* 1115912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1115929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115951 */     // MIs[0] policy
     /* 1115951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115961 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_MF2),
     /* 1115964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115983 */     // GIR_Coverage, 62657,
     /* 1115983 */     GIR_EraseRootFromParent_Done,
     /* 1115984 */   // Label 16399: @1115984
     /* 1115984 */   GIM_Try, /*On fail goto*//*Label 16400*/ GIMT_Encode4(1116061), // Rule ID 62660 //
     /* 1115989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1116006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116028 */     // MIs[0] policy
     /* 1116028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M1),
     /* 1116041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116060 */     // GIR_Coverage, 62660,
     /* 1116060 */     GIR_EraseRootFromParent_Done,
     /* 1116061 */   // Label 16400: @1116061
     /* 1116061 */   GIM_Try, /*On fail goto*//*Label 16401*/ GIMT_Encode4(1116138), // Rule ID 62661 //
     /* 1116066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1116083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116105 */     // MIs[0] policy
     /* 1116105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116115 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M1),
     /* 1116118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116137 */     // GIR_Coverage, 62661,
     /* 1116137 */     GIR_EraseRootFromParent_Done,
     /* 1116138 */   // Label 16401: @1116138
     /* 1116138 */   GIM_Try, /*On fail goto*//*Label 16402*/ GIMT_Encode4(1116215), // Rule ID 62664 //
     /* 1116143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1116160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116182 */     // MIs[0] policy
     /* 1116182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M2),
     /* 1116195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116214 */     // GIR_Coverage, 62664,
     /* 1116214 */     GIR_EraseRootFromParent_Done,
     /* 1116215 */   // Label 16402: @1116215
     /* 1116215 */   GIM_Try, /*On fail goto*//*Label 16403*/ GIMT_Encode4(1116292), // Rule ID 62665 //
     /* 1116220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1116237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116259 */     // MIs[0] policy
     /* 1116259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M2),
     /* 1116272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116291 */     // GIR_Coverage, 62665,
     /* 1116291 */     GIR_EraseRootFromParent_Done,
     /* 1116292 */   // Label 16403: @1116292
     /* 1116292 */   GIM_Try, /*On fail goto*//*Label 16404*/ GIMT_Encode4(1116369), // Rule ID 62668 //
     /* 1116297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1116314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1116317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116336 */     // MIs[0] policy
     /* 1116336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M4),
     /* 1116349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116368 */     // GIR_Coverage, 62668,
     /* 1116368 */     GIR_EraseRootFromParent_Done,
     /* 1116369 */   // Label 16404: @1116369
     /* 1116369 */   GIM_Try, /*On fail goto*//*Label 16405*/ GIMT_Encode4(1116446), // Rule ID 62669 //
     /* 1116374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1116391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1116394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116413 */     // MIs[0] policy
     /* 1116413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116423 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M4),
     /* 1116426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116445 */     // GIR_Coverage, 62669,
     /* 1116445 */     GIR_EraseRootFromParent_Done,
     /* 1116446 */   // Label 16405: @1116446
     /* 1116446 */   GIM_Try, /*On fail goto*//*Label 16406*/ GIMT_Encode4(1116523), // Rule ID 62672 //
     /* 1116451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1116468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116490 */     // MIs[0] policy
     /* 1116490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116500 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M8),
     /* 1116503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116522 */     // GIR_Coverage, 62672,
     /* 1116522 */     GIR_EraseRootFromParent_Done,
     /* 1116523 */   // Label 16406: @1116523
     /* 1116523 */   GIM_Try, /*On fail goto*//*Label 16407*/ GIMT_Encode4(1116600), // Rule ID 62673 //
     /* 1116528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1116545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116567 */     // MIs[0] policy
     /* 1116567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116577 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M8),
     /* 1116580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116599 */     // GIR_Coverage, 62673,
     /* 1116599 */     GIR_EraseRootFromParent_Done,
     /* 1116600 */   // Label 16407: @1116600
     /* 1116600 */   GIM_Try, /*On fail goto*//*Label 16408*/ GIMT_Encode4(1116677), // Rule ID 62676 //
     /* 1116605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116644 */     // MIs[0] policy
     /* 1116644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_MF2),
     /* 1116657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116676 */     // GIR_Coverage, 62676,
     /* 1116676 */     GIR_EraseRootFromParent_Done,
     /* 1116677 */   // Label 16408: @1116677
     /* 1116677 */   GIM_Try, /*On fail goto*//*Label 16409*/ GIMT_Encode4(1116754), // Rule ID 62677 //
     /* 1116682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116721 */     // MIs[0] policy
     /* 1116721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116731 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_MF2),
     /* 1116734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116753 */     // GIR_Coverage, 62677,
     /* 1116753 */     GIR_EraseRootFromParent_Done,
     /* 1116754 */   // Label 16409: @1116754
     /* 1116754 */   GIM_Try, /*On fail goto*//*Label 16410*/ GIMT_Encode4(1116831), // Rule ID 62680 //
     /* 1116759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116798 */     // MIs[0] policy
     /* 1116798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116808 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M1),
     /* 1116811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116830 */     // GIR_Coverage, 62680,
     /* 1116830 */     GIR_EraseRootFromParent_Done,
     /* 1116831 */   // Label 16410: @1116831
     /* 1116831 */   GIM_Try, /*On fail goto*//*Label 16411*/ GIMT_Encode4(1116908), // Rule ID 62681 //
     /* 1116836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116875 */     // MIs[0] policy
     /* 1116875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116885 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M1),
     /* 1116888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116907 */     // GIR_Coverage, 62681,
     /* 1116907 */     GIR_EraseRootFromParent_Done,
     /* 1116908 */   // Label 16411: @1116908
     /* 1116908 */   GIM_Try, /*On fail goto*//*Label 16412*/ GIMT_Encode4(1116985), // Rule ID 62684 //
     /* 1116913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116952 */     // MIs[0] policy
     /* 1116952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116962 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M2),
     /* 1116965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116984 */     // GIR_Coverage, 62684,
     /* 1116984 */     GIR_EraseRootFromParent_Done,
     /* 1116985 */   // Label 16412: @1116985
     /* 1116985 */   GIM_Try, /*On fail goto*//*Label 16413*/ GIMT_Encode4(1117062), // Rule ID 62685 //
     /* 1116990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117029 */     // MIs[0] policy
     /* 1117029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M2),
     /* 1117042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117058 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117061 */     // GIR_Coverage, 62685,
     /* 1117061 */     GIR_EraseRootFromParent_Done,
     /* 1117062 */   // Label 16413: @1117062
     /* 1117062 */   GIM_Try, /*On fail goto*//*Label 16414*/ GIMT_Encode4(1117139), // Rule ID 62688 //
     /* 1117067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1117075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117106 */     // MIs[0] policy
     /* 1117106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117116 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M4),
     /* 1117119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117138 */     // GIR_Coverage, 62688,
     /* 1117138 */     GIR_EraseRootFromParent_Done,
     /* 1117139 */   // Label 16414: @1117139
     /* 1117139 */   GIM_Try, /*On fail goto*//*Label 16415*/ GIMT_Encode4(1117216), // Rule ID 62689 //
     /* 1117144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1117152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117183 */     // MIs[0] policy
     /* 1117183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117193 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M4),
     /* 1117196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117215 */     // GIR_Coverage, 62689,
     /* 1117215 */     GIR_EraseRootFromParent_Done,
     /* 1117216 */   // Label 16415: @1117216
     /* 1117216 */   GIM_Try, /*On fail goto*//*Label 16416*/ GIMT_Encode4(1117293), // Rule ID 62692 //
     /* 1117221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1117229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1117241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117260 */     // MIs[0] policy
     /* 1117260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117270 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M8),
     /* 1117273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117292 */     // GIR_Coverage, 62692,
     /* 1117292 */     GIR_EraseRootFromParent_Done,
     /* 1117293 */   // Label 16416: @1117293
     /* 1117293 */   GIM_Try, /*On fail goto*//*Label 16417*/ GIMT_Encode4(1117370), // Rule ID 62693 //
     /* 1117298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1117306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1117318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117337 */     // MIs[0] policy
     /* 1117337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117347 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M8),
     /* 1117350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117369 */     // GIR_Coverage, 62693,
     /* 1117369 */     GIR_EraseRootFromParent_Done,
     /* 1117370 */   // Label 16417: @1117370
     /* 1117370 */   GIM_Try, /*On fail goto*//*Label 16418*/ GIMT_Encode4(1117447), // Rule ID 62696 //
     /* 1117375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1117392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117414 */     // MIs[0] policy
     /* 1117414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117424 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_MF2),
     /* 1117427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117446 */     // GIR_Coverage, 62696,
     /* 1117446 */     GIR_EraseRootFromParent_Done,
     /* 1117447 */   // Label 16418: @1117447
     /* 1117447 */   GIM_Try, /*On fail goto*//*Label 16419*/ GIMT_Encode4(1117524), // Rule ID 62697 //
     /* 1117452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1117469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117491 */     // MIs[0] policy
     /* 1117491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117501 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_MF2),
     /* 1117504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117523 */     // GIR_Coverage, 62697,
     /* 1117523 */     GIR_EraseRootFromParent_Done,
     /* 1117524 */   // Label 16419: @1117524
     /* 1117524 */   GIM_Try, /*On fail goto*//*Label 16420*/ GIMT_Encode4(1117601), // Rule ID 62700 //
     /* 1117529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1117546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117568 */     // MIs[0] policy
     /* 1117568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117578 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M1),
     /* 1117581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117600 */     // GIR_Coverage, 62700,
     /* 1117600 */     GIR_EraseRootFromParent_Done,
     /* 1117601 */   // Label 16420: @1117601
     /* 1117601 */   GIM_Try, /*On fail goto*//*Label 16421*/ GIMT_Encode4(1117678), // Rule ID 62701 //
     /* 1117606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1117623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117645 */     // MIs[0] policy
     /* 1117645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117655 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M1),
     /* 1117658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117677 */     // GIR_Coverage, 62701,
     /* 1117677 */     GIR_EraseRootFromParent_Done,
     /* 1117678 */   // Label 16421: @1117678
     /* 1117678 */   GIM_Try, /*On fail goto*//*Label 16422*/ GIMT_Encode4(1117755), // Rule ID 62704 //
     /* 1117683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1117700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117722 */     // MIs[0] policy
     /* 1117722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M2),
     /* 1117735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117751 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117754 */     // GIR_Coverage, 62704,
     /* 1117754 */     GIR_EraseRootFromParent_Done,
     /* 1117755 */   // Label 16422: @1117755
     /* 1117755 */   GIM_Try, /*On fail goto*//*Label 16423*/ GIMT_Encode4(1117832), // Rule ID 62705 //
     /* 1117760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1117777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117799 */     // MIs[0] policy
     /* 1117799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117809 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M2),
     /* 1117812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117831 */     // GIR_Coverage, 62705,
     /* 1117831 */     GIR_EraseRootFromParent_Done,
     /* 1117832 */   // Label 16423: @1117832
     /* 1117832 */   GIM_Try, /*On fail goto*//*Label 16424*/ GIMT_Encode4(1117909), // Rule ID 62708 //
     /* 1117837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1117854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117876 */     // MIs[0] policy
     /* 1117876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117886 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M4),
     /* 1117889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117905 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117908 */     // GIR_Coverage, 62708,
     /* 1117908 */     GIR_EraseRootFromParent_Done,
     /* 1117909 */   // Label 16424: @1117909
     /* 1117909 */   GIM_Try, /*On fail goto*//*Label 16425*/ GIMT_Encode4(1117986), // Rule ID 62709 //
     /* 1117914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1117931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117953 */     // MIs[0] policy
     /* 1117953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117963 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M4),
     /* 1117966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117985 */     // GIR_Coverage, 62709,
     /* 1117985 */     GIR_EraseRootFromParent_Done,
     /* 1117986 */   // Label 16425: @1117986
     /* 1117986 */   GIM_Try, /*On fail goto*//*Label 16426*/ GIMT_Encode4(1118063), // Rule ID 62712 //
     /* 1117991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1118008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118030 */     // MIs[0] policy
     /* 1118030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118040 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M8),
     /* 1118043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118062 */     // GIR_Coverage, 62712,
     /* 1118062 */     GIR_EraseRootFromParent_Done,
     /* 1118063 */   // Label 16426: @1118063
     /* 1118063 */   GIM_Try, /*On fail goto*//*Label 16427*/ GIMT_Encode4(1118140), // Rule ID 62713 //
     /* 1118068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1118085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118107 */     // MIs[0] policy
     /* 1118107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118117 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M8),
     /* 1118120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118139 */     // GIR_Coverage, 62713,
     /* 1118139 */     GIR_EraseRootFromParent_Done,
     /* 1118140 */   // Label 16427: @1118140
     /* 1118140 */   GIM_Try, /*On fail goto*//*Label 16428*/ GIMT_Encode4(1118217), // Rule ID 62716 //
     /* 1118145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118184 */     // MIs[0] policy
     /* 1118184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118194 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_MF2),
     /* 1118197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118213 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118216 */     // GIR_Coverage, 62716,
     /* 1118216 */     GIR_EraseRootFromParent_Done,
     /* 1118217 */   // Label 16428: @1118217
     /* 1118217 */   GIM_Try, /*On fail goto*//*Label 16429*/ GIMT_Encode4(1118294), // Rule ID 62717 //
     /* 1118222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118261 */     // MIs[0] policy
     /* 1118261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118271 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_MF2),
     /* 1118274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118293 */     // GIR_Coverage, 62717,
     /* 1118293 */     GIR_EraseRootFromParent_Done,
     /* 1118294 */   // Label 16429: @1118294
     /* 1118294 */   GIM_Try, /*On fail goto*//*Label 16430*/ GIMT_Encode4(1118371), // Rule ID 62720 //
     /* 1118299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118338 */     // MIs[0] policy
     /* 1118338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118348 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M1),
     /* 1118351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118370 */     // GIR_Coverage, 62720,
     /* 1118370 */     GIR_EraseRootFromParent_Done,
     /* 1118371 */   // Label 16430: @1118371
     /* 1118371 */   GIM_Try, /*On fail goto*//*Label 16431*/ GIMT_Encode4(1118448), // Rule ID 62721 //
     /* 1118376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118415 */     // MIs[0] policy
     /* 1118415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118425 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M1),
     /* 1118428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118447 */     // GIR_Coverage, 62721,
     /* 1118447 */     GIR_EraseRootFromParent_Done,
     /* 1118448 */   // Label 16431: @1118448
     /* 1118448 */   GIM_Try, /*On fail goto*//*Label 16432*/ GIMT_Encode4(1118525), // Rule ID 62724 //
     /* 1118453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118492 */     // MIs[0] policy
     /* 1118492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M2),
     /* 1118505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118524 */     // GIR_Coverage, 62724,
     /* 1118524 */     GIR_EraseRootFromParent_Done,
     /* 1118525 */   // Label 16432: @1118525
     /* 1118525 */   GIM_Try, /*On fail goto*//*Label 16433*/ GIMT_Encode4(1118602), // Rule ID 62725 //
     /* 1118530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118569 */     // MIs[0] policy
     /* 1118569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118579 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M2),
     /* 1118582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118601 */     // GIR_Coverage, 62725,
     /* 1118601 */     GIR_EraseRootFromParent_Done,
     /* 1118602 */   // Label 16433: @1118602
     /* 1118602 */   GIM_Try, /*On fail goto*//*Label 16434*/ GIMT_Encode4(1118679), // Rule ID 62728 //
     /* 1118607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118646 */     // MIs[0] policy
     /* 1118646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118656 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M4),
     /* 1118659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118678 */     // GIR_Coverage, 62728,
     /* 1118678 */     GIR_EraseRootFromParent_Done,
     /* 1118679 */   // Label 16434: @1118679
     /* 1118679 */   GIM_Try, /*On fail goto*//*Label 16435*/ GIMT_Encode4(1118756), // Rule ID 62729 //
     /* 1118684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118723 */     // MIs[0] policy
     /* 1118723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118733 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M4),
     /* 1118736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118755 */     // GIR_Coverage, 62729,
     /* 1118755 */     GIR_EraseRootFromParent_Done,
     /* 1118756 */   // Label 16435: @1118756
     /* 1118756 */   GIM_Try, /*On fail goto*//*Label 16436*/ GIMT_Encode4(1118833), // Rule ID 62732 //
     /* 1118761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118800 */     // MIs[0] policy
     /* 1118800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118810 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M8),
     /* 1118813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118832 */     // GIR_Coverage, 62732,
     /* 1118832 */     GIR_EraseRootFromParent_Done,
     /* 1118833 */   // Label 16436: @1118833
     /* 1118833 */   GIM_Try, /*On fail goto*//*Label 16437*/ GIMT_Encode4(1118910), // Rule ID 62733 //
     /* 1118838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118877 */     // MIs[0] policy
     /* 1118877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118887 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M8),
     /* 1118890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118909 */     // GIR_Coverage, 62733,
     /* 1118909 */     GIR_EraseRootFromParent_Done,
     /* 1118910 */   // Label 16437: @1118910
     /* 1118910 */   GIM_Try, /*On fail goto*//*Label 16438*/ GIMT_Encode4(1118987), // Rule ID 62736 //
     /* 1118915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118954 */     // MIs[0] policy
     /* 1118954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118964 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_MF2),
     /* 1118967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118986 */     // GIR_Coverage, 62736,
     /* 1118986 */     GIR_EraseRootFromParent_Done,
     /* 1118987 */   // Label 16438: @1118987
     /* 1118987 */   GIM_Try, /*On fail goto*//*Label 16439*/ GIMT_Encode4(1119064), // Rule ID 62737 //
     /* 1118992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1119003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1119006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1119012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119031 */     // MIs[0] policy
     /* 1119031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119041 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_MF2),
     /* 1119044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119063 */     // GIR_Coverage, 62737,
     /* 1119063 */     GIR_EraseRootFromParent_Done,
     /* 1119064 */   // Label 16439: @1119064
     /* 1119064 */   GIM_Try, /*On fail goto*//*Label 16440*/ GIMT_Encode4(1119141), // Rule ID 62740 //
     /* 1119069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119108 */     // MIs[0] policy
     /* 1119108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M1),
     /* 1119121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119140 */     // GIR_Coverage, 62740,
     /* 1119140 */     GIR_EraseRootFromParent_Done,
     /* 1119141 */   // Label 16440: @1119141
     /* 1119141 */   GIM_Try, /*On fail goto*//*Label 16441*/ GIMT_Encode4(1119218), // Rule ID 62741 //
     /* 1119146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119185 */     // MIs[0] policy
     /* 1119185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119195 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M1),
     /* 1119198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119217 */     // GIR_Coverage, 62741,
     /* 1119217 */     GIR_EraseRootFromParent_Done,
     /* 1119218 */   // Label 16441: @1119218
     /* 1119218 */   GIM_Try, /*On fail goto*//*Label 16442*/ GIMT_Encode4(1119295), // Rule ID 62744 //
     /* 1119223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119262 */     // MIs[0] policy
     /* 1119262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119272 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M2),
     /* 1119275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119294 */     // GIR_Coverage, 62744,
     /* 1119294 */     GIR_EraseRootFromParent_Done,
     /* 1119295 */   // Label 16442: @1119295
     /* 1119295 */   GIM_Try, /*On fail goto*//*Label 16443*/ GIMT_Encode4(1119372), // Rule ID 62745 //
     /* 1119300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119339 */     // MIs[0] policy
     /* 1119339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119349 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M2),
     /* 1119352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119371 */     // GIR_Coverage, 62745,
     /* 1119371 */     GIR_EraseRootFromParent_Done,
     /* 1119372 */   // Label 16443: @1119372
     /* 1119372 */   GIM_Try, /*On fail goto*//*Label 16444*/ GIMT_Encode4(1119449), // Rule ID 62748 //
     /* 1119377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119416 */     // MIs[0] policy
     /* 1119416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119426 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M4),
     /* 1119429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119448 */     // GIR_Coverage, 62748,
     /* 1119448 */     GIR_EraseRootFromParent_Done,
     /* 1119449 */   // Label 16444: @1119449
     /* 1119449 */   GIM_Try, /*On fail goto*//*Label 16445*/ GIMT_Encode4(1119526), // Rule ID 62749 //
     /* 1119454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119493 */     // MIs[0] policy
     /* 1119493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119503 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M4),
     /* 1119506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119525 */     // GIR_Coverage, 62749,
     /* 1119525 */     GIR_EraseRootFromParent_Done,
     /* 1119526 */   // Label 16445: @1119526
     /* 1119526 */   GIM_Try, /*On fail goto*//*Label 16446*/ GIMT_Encode4(1119603), // Rule ID 62752 //
     /* 1119531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119570 */     // MIs[0] policy
     /* 1119570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M8),
     /* 1119583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119602 */     // GIR_Coverage, 62752,
     /* 1119602 */     GIR_EraseRootFromParent_Done,
     /* 1119603 */   // Label 16446: @1119603
     /* 1119603 */   GIM_Try, /*On fail goto*//*Label 16447*/ GIMT_Encode4(1119680), // Rule ID 62753 //
     /* 1119608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119647 */     // MIs[0] policy
     /* 1119647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119657 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M8),
     /* 1119660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119679 */     // GIR_Coverage, 62753,
     /* 1119679 */     GIR_EraseRootFromParent_Done,
     /* 1119680 */   // Label 16447: @1119680
     /* 1119680 */   GIM_Try, /*On fail goto*//*Label 16448*/ GIMT_Encode4(1119757), // Rule ID 62847 //
     /* 1119685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119724 */     // MIs[0] policy
     /* 1119724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119734 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M1),
     /* 1119737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119756 */     // GIR_Coverage, 62847,
     /* 1119756 */     GIR_EraseRootFromParent_Done,
     /* 1119757 */   // Label 16448: @1119757
     /* 1119757 */   GIM_Try, /*On fail goto*//*Label 16449*/ GIMT_Encode4(1119834), // Rule ID 62848 //
     /* 1119762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119801 */     // MIs[0] policy
     /* 1119801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119811 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M1),
     /* 1119814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119833 */     // GIR_Coverage, 62848,
     /* 1119833 */     GIR_EraseRootFromParent_Done,
     /* 1119834 */   // Label 16449: @1119834
     /* 1119834 */   GIM_Try, /*On fail goto*//*Label 16450*/ GIMT_Encode4(1119911), // Rule ID 64305 //
     /* 1119839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119878 */     // MIs[0] policy
     /* 1119878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119888 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M2),
     /* 1119891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119910 */     // GIR_Coverage, 64305,
     /* 1119910 */     GIR_EraseRootFromParent_Done,
     /* 1119911 */   // Label 16450: @1119911
     /* 1119911 */   GIM_Try, /*On fail goto*//*Label 16451*/ GIMT_Encode4(1119988), // Rule ID 64306 //
     /* 1119916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119955 */     // MIs[0] policy
     /* 1119955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119965 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M2),
     /* 1119968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119987 */     // GIR_Coverage, 64306,
     /* 1119987 */     GIR_EraseRootFromParent_Done,
     /* 1119988 */   // Label 16451: @1119988
     /* 1119988 */   GIM_Try, /*On fail goto*//*Label 16452*/ GIMT_Encode4(1120065), // Rule ID 64307 //
     /* 1119993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1120001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120032 */     // MIs[0] policy
     /* 1120032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120042 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M4),
     /* 1120045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120064 */     // GIR_Coverage, 64307,
     /* 1120064 */     GIR_EraseRootFromParent_Done,
     /* 1120065 */   // Label 16452: @1120065
     /* 1120065 */   GIM_Try, /*On fail goto*//*Label 16453*/ GIMT_Encode4(1120142), // Rule ID 64308 //
     /* 1120070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1120078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120109 */     // MIs[0] policy
     /* 1120109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120119 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M4),
     /* 1120122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120141 */     // GIR_Coverage, 64308,
     /* 1120141 */     GIR_EraseRootFromParent_Done,
     /* 1120142 */   // Label 16453: @1120142
     /* 1120142 */   GIM_Try, /*On fail goto*//*Label 16454*/ GIMT_Encode4(1120219), // Rule ID 64309 //
     /* 1120147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1120155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120186 */     // MIs[0] policy
     /* 1120186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M8),
     /* 1120199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120218 */     // GIR_Coverage, 64309,
     /* 1120218 */     GIR_EraseRootFromParent_Done,
     /* 1120219 */   // Label 16454: @1120219
     /* 1120219 */   GIM_Try, /*On fail goto*//*Label 16455*/ GIMT_Encode4(1120296), // Rule ID 64310 //
     /* 1120224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1120232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120263 */     // MIs[0] policy
     /* 1120263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120273 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M8),
     /* 1120276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120295 */     // GIR_Coverage, 64310,
     /* 1120295 */     GIR_EraseRootFromParent_Done,
     /* 1120296 */   // Label 16455: @1120296
     /* 1120296 */   GIM_Try, /*On fail goto*//*Label 16456*/ GIMT_Encode4(1120373), // Rule ID 64311 //
     /* 1120301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120340 */     // MIs[0] policy
     /* 1120340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120350 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M1),
     /* 1120353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120372 */     // GIR_Coverage, 64311,
     /* 1120372 */     GIR_EraseRootFromParent_Done,
     /* 1120373 */   // Label 16456: @1120373
     /* 1120373 */   GIM_Try, /*On fail goto*//*Label 16457*/ GIMT_Encode4(1120450), // Rule ID 64312 //
     /* 1120378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120417 */     // MIs[0] policy
     /* 1120417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120427 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M1),
     /* 1120430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120449 */     // GIR_Coverage, 64312,
     /* 1120449 */     GIR_EraseRootFromParent_Done,
     /* 1120450 */   // Label 16457: @1120450
     /* 1120450 */   GIM_Try, /*On fail goto*//*Label 16458*/ GIMT_Encode4(1120527), // Rule ID 64313 //
     /* 1120455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120494 */     // MIs[0] policy
     /* 1120494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M2),
     /* 1120507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120526 */     // GIR_Coverage, 64313,
     /* 1120526 */     GIR_EraseRootFromParent_Done,
     /* 1120527 */   // Label 16458: @1120527
     /* 1120527 */   GIM_Try, /*On fail goto*//*Label 16459*/ GIMT_Encode4(1120604), // Rule ID 64314 //
     /* 1120532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120571 */     // MIs[0] policy
     /* 1120571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120581 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M2),
     /* 1120584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120603 */     // GIR_Coverage, 64314,
     /* 1120603 */     GIR_EraseRootFromParent_Done,
     /* 1120604 */   // Label 16459: @1120604
     /* 1120604 */   GIM_Try, /*On fail goto*//*Label 16460*/ GIMT_Encode4(1120681), // Rule ID 64315 //
     /* 1120609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120648 */     // MIs[0] policy
     /* 1120648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120658 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M4),
     /* 1120661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120680 */     // GIR_Coverage, 64315,
     /* 1120680 */     GIR_EraseRootFromParent_Done,
     /* 1120681 */   // Label 16460: @1120681
     /* 1120681 */   GIM_Try, /*On fail goto*//*Label 16461*/ GIMT_Encode4(1120758), // Rule ID 64316 //
     /* 1120686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120725 */     // MIs[0] policy
     /* 1120725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120735 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M4),
     /* 1120738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120757 */     // GIR_Coverage, 64316,
     /* 1120757 */     GIR_EraseRootFromParent_Done,
     /* 1120758 */   // Label 16461: @1120758
     /* 1120758 */   GIM_Try, /*On fail goto*//*Label 16462*/ GIMT_Encode4(1120835), // Rule ID 64317 //
     /* 1120763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120802 */     // MIs[0] policy
     /* 1120802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120812 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M8),
     /* 1120815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120834 */     // GIR_Coverage, 64317,
     /* 1120834 */     GIR_EraseRootFromParent_Done,
     /* 1120835 */   // Label 16462: @1120835
     /* 1120835 */   GIM_Try, /*On fail goto*//*Label 16463*/ GIMT_Encode4(1120912), // Rule ID 64318 //
     /* 1120840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120879 */     // MIs[0] policy
     /* 1120879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120889 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M8),
     /* 1120892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120911 */     // GIR_Coverage, 64318,
     /* 1120911 */     GIR_EraseRootFromParent_Done,
     /* 1120912 */   // Label 16463: @1120912
     /* 1120912 */   GIM_Try, /*On fail goto*//*Label 16464*/ GIMT_Encode4(1120989), // Rule ID 64319 //
     /* 1120917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120956 */     // MIs[0] policy
     /* 1120956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M1),
     /* 1120969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120988 */     // GIR_Coverage, 64319,
     /* 1120988 */     GIR_EraseRootFromParent_Done,
     /* 1120989 */   // Label 16464: @1120989
     /* 1120989 */   GIM_Try, /*On fail goto*//*Label 16465*/ GIMT_Encode4(1121066), // Rule ID 64320 //
     /* 1120994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121033 */     // MIs[0] policy
     /* 1121033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121043 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M1),
     /* 1121046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121065 */     // GIR_Coverage, 64320,
     /* 1121065 */     GIR_EraseRootFromParent_Done,
     /* 1121066 */   // Label 16465: @1121066
     /* 1121066 */   GIM_Try, /*On fail goto*//*Label 16466*/ GIMT_Encode4(1121143), // Rule ID 64321 //
     /* 1121071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121110 */     // MIs[0] policy
     /* 1121110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121120 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M2),
     /* 1121123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121142 */     // GIR_Coverage, 64321,
     /* 1121142 */     GIR_EraseRootFromParent_Done,
     /* 1121143 */   // Label 16466: @1121143
     /* 1121143 */   GIM_Try, /*On fail goto*//*Label 16467*/ GIMT_Encode4(1121220), // Rule ID 64322 //
     /* 1121148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121187 */     // MIs[0] policy
     /* 1121187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M2),
     /* 1121200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121219 */     // GIR_Coverage, 64322,
     /* 1121219 */     GIR_EraseRootFromParent_Done,
     /* 1121220 */   // Label 16467: @1121220
     /* 1121220 */   GIM_Try, /*On fail goto*//*Label 16468*/ GIMT_Encode4(1121297), // Rule ID 64323 //
     /* 1121225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121264 */     // MIs[0] policy
     /* 1121264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121274 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M4),
     /* 1121277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121293 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121296 */     // GIR_Coverage, 64323,
     /* 1121296 */     GIR_EraseRootFromParent_Done,
     /* 1121297 */   // Label 16468: @1121297
     /* 1121297 */   GIM_Try, /*On fail goto*//*Label 16469*/ GIMT_Encode4(1121374), // Rule ID 64324 //
     /* 1121302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121341 */     // MIs[0] policy
     /* 1121341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121351 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M4),
     /* 1121354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121373 */     // GIR_Coverage, 64324,
     /* 1121373 */     GIR_EraseRootFromParent_Done,
     /* 1121374 */   // Label 16469: @1121374
     /* 1121374 */   GIM_Try, /*On fail goto*//*Label 16470*/ GIMT_Encode4(1121451), // Rule ID 64325 //
     /* 1121379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121418 */     // MIs[0] policy
     /* 1121418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121428 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M8),
     /* 1121431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121450 */     // GIR_Coverage, 64325,
     /* 1121450 */     GIR_EraseRootFromParent_Done,
     /* 1121451 */   // Label 16470: @1121451
     /* 1121451 */   GIM_Try, /*On fail goto*//*Label 16471*/ GIMT_Encode4(1121528), // Rule ID 64326 //
     /* 1121456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121495 */     // MIs[0] policy
     /* 1121495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121505 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M8),
     /* 1121508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121527 */     // GIR_Coverage, 64326,
     /* 1121527 */     GIR_EraseRootFromParent_Done,
     /* 1121528 */   // Label 16471: @1121528
     /* 1121528 */   GIM_Try, /*On fail goto*//*Label 16472*/ GIMT_Encode4(1121605), // Rule ID 64327 //
     /* 1121533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121572 */     // MIs[0] policy
     /* 1121572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121582 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M1),
     /* 1121585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121601 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121604 */     // GIR_Coverage, 64327,
     /* 1121604 */     GIR_EraseRootFromParent_Done,
     /* 1121605 */   // Label 16472: @1121605
     /* 1121605 */   GIM_Try, /*On fail goto*//*Label 16473*/ GIMT_Encode4(1121682), // Rule ID 64328 //
     /* 1121610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121649 */     // MIs[0] policy
     /* 1121649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121659 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M1),
     /* 1121662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121681 */     // GIR_Coverage, 64328,
     /* 1121681 */     GIR_EraseRootFromParent_Done,
     /* 1121682 */   // Label 16473: @1121682
     /* 1121682 */   GIM_Try, /*On fail goto*//*Label 16474*/ GIMT_Encode4(1121759), // Rule ID 64329 //
     /* 1121687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121726 */     // MIs[0] policy
     /* 1121726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M2),
     /* 1121739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121758 */     // GIR_Coverage, 64329,
     /* 1121758 */     GIR_EraseRootFromParent_Done,
     /* 1121759 */   // Label 16474: @1121759
     /* 1121759 */   GIM_Try, /*On fail goto*//*Label 16475*/ GIMT_Encode4(1121836), // Rule ID 64330 //
     /* 1121764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121803 */     // MIs[0] policy
     /* 1121803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121813 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M2),
     /* 1121816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121835 */     // GIR_Coverage, 64330,
     /* 1121835 */     GIR_EraseRootFromParent_Done,
     /* 1121836 */   // Label 16475: @1121836
     /* 1121836 */   GIM_Try, /*On fail goto*//*Label 16476*/ GIMT_Encode4(1121913), // Rule ID 64331 //
     /* 1121841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121880 */     // MIs[0] policy
     /* 1121880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121890 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M4),
     /* 1121893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121909 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121912 */     // GIR_Coverage, 64331,
     /* 1121912 */     GIR_EraseRootFromParent_Done,
     /* 1121913 */   // Label 16476: @1121913
     /* 1121913 */   GIM_Try, /*On fail goto*//*Label 16477*/ GIMT_Encode4(1121990), // Rule ID 64332 //
     /* 1121918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121957 */     // MIs[0] policy
     /* 1121957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121967 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M4),
     /* 1121970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121986 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121989 */     // GIR_Coverage, 64332,
     /* 1121989 */     GIR_EraseRootFromParent_Done,
     /* 1121990 */   // Label 16477: @1121990
     /* 1121990 */   GIM_Try, /*On fail goto*//*Label 16478*/ GIMT_Encode4(1122067), // Rule ID 64333 //
     /* 1121995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1122003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1122015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122034 */     // MIs[0] policy
     /* 1122034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122044 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M8),
     /* 1122047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122066 */     // GIR_Coverage, 64333,
     /* 1122066 */     GIR_EraseRootFromParent_Done,
     /* 1122067 */   // Label 16478: @1122067
     /* 1122067 */   GIM_Try, /*On fail goto*//*Label 16479*/ GIMT_Encode4(1122144), // Rule ID 64334 //
     /* 1122072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1122075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1122080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1122092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122111 */     // MIs[0] policy
     /* 1122111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122121 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M8),
     /* 1122124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122143 */     // GIR_Coverage, 64334,
     /* 1122143 */     GIR_EraseRootFromParent_Done,
     /* 1122144 */   // Label 16479: @1122144
     /* 1122144 */   GIM_Try, /*On fail goto*//*Label 16480*/ GIMT_Encode4(1122221), // Rule ID 64335 //
     /* 1122149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122188 */     // MIs[0] policy
     /* 1122188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122198 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_MF2),
     /* 1122201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122217 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122220 */     // GIR_Coverage, 64335,
     /* 1122220 */     GIR_EraseRootFromParent_Done,
     /* 1122221 */   // Label 16480: @1122221
     /* 1122221 */   GIM_Try, /*On fail goto*//*Label 16481*/ GIMT_Encode4(1122298), // Rule ID 64336 //
     /* 1122226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122265 */     // MIs[0] policy
     /* 1122265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122275 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_MF2),
     /* 1122278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122297 */     // GIR_Coverage, 64336,
     /* 1122297 */     GIR_EraseRootFromParent_Done,
     /* 1122298 */   // Label 16481: @1122298
     /* 1122298 */   GIM_Try, /*On fail goto*//*Label 16482*/ GIMT_Encode4(1122375), // Rule ID 64337 //
     /* 1122303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122342 */     // MIs[0] policy
     /* 1122342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M1),
     /* 1122355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122374 */     // GIR_Coverage, 64337,
     /* 1122374 */     GIR_EraseRootFromParent_Done,
     /* 1122375 */   // Label 16482: @1122375
     /* 1122375 */   GIM_Try, /*On fail goto*//*Label 16483*/ GIMT_Encode4(1122452), // Rule ID 64338 //
     /* 1122380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122419 */     // MIs[0] policy
     /* 1122419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M1),
     /* 1122432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122451 */     // GIR_Coverage, 64338,
     /* 1122451 */     GIR_EraseRootFromParent_Done,
     /* 1122452 */   // Label 16483: @1122452
     /* 1122452 */   GIM_Try, /*On fail goto*//*Label 16484*/ GIMT_Encode4(1122529), // Rule ID 64339 //
     /* 1122457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122496 */     // MIs[0] policy
     /* 1122496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122506 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M2),
     /* 1122509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122528 */     // GIR_Coverage, 64339,
     /* 1122528 */     GIR_EraseRootFromParent_Done,
     /* 1122529 */   // Label 16484: @1122529
     /* 1122529 */   GIM_Try, /*On fail goto*//*Label 16485*/ GIMT_Encode4(1122606), // Rule ID 64340 //
     /* 1122534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122573 */     // MIs[0] policy
     /* 1122573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122583 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M2),
     /* 1122586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122602 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122605 */     // GIR_Coverage, 64340,
     /* 1122605 */     GIR_EraseRootFromParent_Done,
     /* 1122606 */   // Label 16485: @1122606
     /* 1122606 */   GIM_Try, /*On fail goto*//*Label 16486*/ GIMT_Encode4(1122683), // Rule ID 64341 //
     /* 1122611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122650 */     // MIs[0] policy
     /* 1122650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122660 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M4),
     /* 1122663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122682 */     // GIR_Coverage, 64341,
     /* 1122682 */     GIR_EraseRootFromParent_Done,
     /* 1122683 */   // Label 16486: @1122683
     /* 1122683 */   GIM_Try, /*On fail goto*//*Label 16487*/ GIMT_Encode4(1122760), // Rule ID 64342 //
     /* 1122688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122727 */     // MIs[0] policy
     /* 1122727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122737 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M4),
     /* 1122740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122759 */     // GIR_Coverage, 64342,
     /* 1122759 */     GIR_EraseRootFromParent_Done,
     /* 1122760 */   // Label 16487: @1122760
     /* 1122760 */   GIM_Try, /*On fail goto*//*Label 16488*/ GIMT_Encode4(1122837), // Rule ID 64343 //
     /* 1122765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122804 */     // MIs[0] policy
     /* 1122804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_MF2),
     /* 1122817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122836 */     // GIR_Coverage, 64343,
     /* 1122836 */     GIR_EraseRootFromParent_Done,
     /* 1122837 */   // Label 16488: @1122837
     /* 1122837 */   GIM_Try, /*On fail goto*//*Label 16489*/ GIMT_Encode4(1122914), // Rule ID 64344 //
     /* 1122842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122881 */     // MIs[0] policy
     /* 1122881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122891 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_MF2),
     /* 1122894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122913 */     // GIR_Coverage, 64344,
     /* 1122913 */     GIR_EraseRootFromParent_Done,
     /* 1122914 */   // Label 16489: @1122914
     /* 1122914 */   GIM_Try, /*On fail goto*//*Label 16490*/ GIMT_Encode4(1122991), // Rule ID 64345 //
     /* 1122919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122958 */     // MIs[0] policy
     /* 1122958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M1),
     /* 1122971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122990 */     // GIR_Coverage, 64345,
     /* 1122990 */     GIR_EraseRootFromParent_Done,
     /* 1122991 */   // Label 16490: @1122991
     /* 1122991 */   GIM_Try, /*On fail goto*//*Label 16491*/ GIMT_Encode4(1123068), // Rule ID 64346 //
     /* 1122996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1123004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123035 */     // MIs[0] policy
     /* 1123035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123045 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M1),
     /* 1123048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123067 */     // GIR_Coverage, 64346,
     /* 1123067 */     GIR_EraseRootFromParent_Done,
     /* 1123068 */   // Label 16491: @1123068
     /* 1123068 */   GIM_Try, /*On fail goto*//*Label 16492*/ GIMT_Encode4(1123145), // Rule ID 64347 //
     /* 1123073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1123081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123112 */     // MIs[0] policy
     /* 1123112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123122 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M2),
     /* 1123125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123141 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123144 */     // GIR_Coverage, 64347,
     /* 1123144 */     GIR_EraseRootFromParent_Done,
     /* 1123145 */   // Label 16492: @1123145
     /* 1123145 */   GIM_Try, /*On fail goto*//*Label 16493*/ GIMT_Encode4(1123222), // Rule ID 64348 //
     /* 1123150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1123158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123189 */     // MIs[0] policy
     /* 1123189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123199 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M2),
     /* 1123202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123218 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123221 */     // GIR_Coverage, 64348,
     /* 1123221 */     GIR_EraseRootFromParent_Done,
     /* 1123222 */   // Label 16493: @1123222
     /* 1123222 */   GIM_Try, /*On fail goto*//*Label 16494*/ GIMT_Encode4(1123299), // Rule ID 64349 //
     /* 1123227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1123235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123266 */     // MIs[0] policy
     /* 1123266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123276 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M4),
     /* 1123279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123298 */     // GIR_Coverage, 64349,
     /* 1123298 */     GIR_EraseRootFromParent_Done,
     /* 1123299 */   // Label 16494: @1123299
     /* 1123299 */   GIM_Try, /*On fail goto*//*Label 16495*/ GIMT_Encode4(1123376), // Rule ID 64350 //
     /* 1123304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1123312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123343 */     // MIs[0] policy
     /* 1123343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123353 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M4),
     /* 1123356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123375 */     // GIR_Coverage, 64350,
     /* 1123375 */     GIR_EraseRootFromParent_Done,
     /* 1123376 */   // Label 16495: @1123376
     /* 1123376 */   GIM_Try, /*On fail goto*//*Label 16496*/ GIMT_Encode4(1123453), // Rule ID 64351 //
     /* 1123381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1123401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123420 */     // MIs[0] policy
     /* 1123420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123430 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_MF2),
     /* 1123433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123452 */     // GIR_Coverage, 64351,
     /* 1123452 */     GIR_EraseRootFromParent_Done,
     /* 1123453 */   // Label 16496: @1123453
     /* 1123453 */   GIM_Try, /*On fail goto*//*Label 16497*/ GIMT_Encode4(1123530), // Rule ID 64352 //
     /* 1123458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1123478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123497 */     // MIs[0] policy
     /* 1123497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123507 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_MF2),
     /* 1123510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123529 */     // GIR_Coverage, 64352,
     /* 1123529 */     GIR_EraseRootFromParent_Done,
     /* 1123530 */   // Label 16497: @1123530
     /* 1123530 */   GIM_Try, /*On fail goto*//*Label 16498*/ GIMT_Encode4(1123607), // Rule ID 64353 //
     /* 1123535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123574 */     // MIs[0] policy
     /* 1123574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123584 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M1),
     /* 1123587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123606 */     // GIR_Coverage, 64353,
     /* 1123606 */     GIR_EraseRootFromParent_Done,
     /* 1123607 */   // Label 16498: @1123607
     /* 1123607 */   GIM_Try, /*On fail goto*//*Label 16499*/ GIMT_Encode4(1123684), // Rule ID 64354 //
     /* 1123612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123651 */     // MIs[0] policy
     /* 1123651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123661 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M1),
     /* 1123664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123683 */     // GIR_Coverage, 64354,
     /* 1123683 */     GIR_EraseRootFromParent_Done,
     /* 1123684 */   // Label 16499: @1123684
     /* 1123684 */   GIM_Try, /*On fail goto*//*Label 16500*/ GIMT_Encode4(1123761), // Rule ID 64355 //
     /* 1123689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123728 */     // MIs[0] policy
     /* 1123728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123738 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M2),
     /* 1123741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123760 */     // GIR_Coverage, 64355,
     /* 1123760 */     GIR_EraseRootFromParent_Done,
     /* 1123761 */   // Label 16500: @1123761
     /* 1123761 */   GIM_Try, /*On fail goto*//*Label 16501*/ GIMT_Encode4(1123838), // Rule ID 64356 //
     /* 1123766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123805 */     // MIs[0] policy
     /* 1123805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123815 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M2),
     /* 1123818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123837 */     // GIR_Coverage, 64356,
     /* 1123837 */     GIR_EraseRootFromParent_Done,
     /* 1123838 */   // Label 16501: @1123838
     /* 1123838 */   GIM_Try, /*On fail goto*//*Label 16502*/ GIMT_Encode4(1123915), // Rule ID 64357 //
     /* 1123843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123882 */     // MIs[0] policy
     /* 1123882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123892 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M4),
     /* 1123895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123914 */     // GIR_Coverage, 64357,
     /* 1123914 */     GIR_EraseRootFromParent_Done,
     /* 1123915 */   // Label 16502: @1123915
     /* 1123915 */   GIM_Try, /*On fail goto*//*Label 16503*/ GIMT_Encode4(1123992), // Rule ID 64358 //
     /* 1123920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123959 */     // MIs[0] policy
     /* 1123959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123969 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M4),
     /* 1123972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123991 */     // GIR_Coverage, 64358,
     /* 1123991 */     GIR_EraseRootFromParent_Done,
     /* 1123992 */   // Label 16503: @1123992
     /* 1123992 */   GIM_Try, /*On fail goto*//*Label 16504*/ GIMT_Encode4(1124069), // Rule ID 64359 //
     /* 1123997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1124000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124036 */     // MIs[0] policy
     /* 1124036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_MF2),
     /* 1124049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124068 */     // GIR_Coverage, 64359,
     /* 1124068 */     GIR_EraseRootFromParent_Done,
     /* 1124069 */   // Label 16504: @1124069
     /* 1124069 */   GIM_Try, /*On fail goto*//*Label 16505*/ GIMT_Encode4(1124146), // Rule ID 64360 //
     /* 1124074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1124077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124113 */     // MIs[0] policy
     /* 1124113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124123 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_MF2),
     /* 1124126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124145 */     // GIR_Coverage, 64360,
     /* 1124145 */     GIR_EraseRootFromParent_Done,
     /* 1124146 */   // Label 16505: @1124146
     /* 1124146 */   GIM_Try, /*On fail goto*//*Label 16506*/ GIMT_Encode4(1124223), // Rule ID 64361 //
     /* 1124151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1124154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124190 */     // MIs[0] policy
     /* 1124190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M1),
     /* 1124203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124222 */     // GIR_Coverage, 64361,
     /* 1124222 */     GIR_EraseRootFromParent_Done,
     /* 1124223 */   // Label 16506: @1124223
     /* 1124223 */   GIM_Try, /*On fail goto*//*Label 16507*/ GIMT_Encode4(1124300), // Rule ID 64362 //
     /* 1124228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1124231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124267 */     // MIs[0] policy
     /* 1124267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124277 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M1),
     /* 1124280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124299 */     // GIR_Coverage, 64362,
     /* 1124299 */     GIR_EraseRootFromParent_Done,
     /* 1124300 */   // Label 16507: @1124300
     /* 1124300 */   GIM_Try, /*On fail goto*//*Label 16508*/ GIMT_Encode4(1124377), // Rule ID 64363 //
     /* 1124305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1124308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124344 */     // MIs[0] policy
     /* 1124344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124354 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M2),
     /* 1124357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124373 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124376 */     // GIR_Coverage, 64363,
     /* 1124376 */     GIR_EraseRootFromParent_Done,
     /* 1124377 */   // Label 16508: @1124377
     /* 1124377 */   GIM_Try, /*On fail goto*//*Label 16509*/ GIMT_Encode4(1124454), // Rule ID 64364 //
     /* 1124382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1124385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124421 */     // MIs[0] policy
     /* 1124421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124431 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M2),
     /* 1124434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124450 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124453 */     // GIR_Coverage, 64364,
     /* 1124453 */     GIR_EraseRootFromParent_Done,
     /* 1124454 */   // Label 16509: @1124454
     /* 1124454 */   GIM_Try, /*On fail goto*//*Label 16510*/ GIMT_Encode4(1124531), // Rule ID 64365 //
     /* 1124459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1124462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124498 */     // MIs[0] policy
     /* 1124498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124508 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M4),
     /* 1124511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124530 */     // GIR_Coverage, 64365,
     /* 1124530 */     GIR_EraseRootFromParent_Done,
     /* 1124531 */   // Label 16510: @1124531
     /* 1124531 */   GIM_Try, /*On fail goto*//*Label 16511*/ GIMT_Encode4(1124608), // Rule ID 64366 //
     /* 1124536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1124539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124575 */     // MIs[0] policy
     /* 1124575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124585 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M4),
     /* 1124588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124604 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124607 */     // GIR_Coverage, 64366,
     /* 1124607 */     GIR_EraseRootFromParent_Done,
     /* 1124608 */   // Label 16511: @1124608
     /* 1124608 */   GIM_Try, /*On fail goto*//*Label 16512*/ GIMT_Encode4(1124685), // Rule ID 65240 //
     /* 1124613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1124624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1124627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1124630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124652 */     // MIs[0] policy
     /* 1124652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124662 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2),
     /* 1124665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124684 */     // GIR_Coverage, 65240,
     /* 1124684 */     GIR_EraseRootFromParent_Done,
     /* 1124685 */   // Label 16512: @1124685
     /* 1124685 */   GIM_Try, /*On fail goto*//*Label 16513*/ GIMT_Encode4(1124762), // Rule ID 65241 //
     /* 1124690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1124701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1124704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1124707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124729 */     // MIs[0] policy
     /* 1124729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124739 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2),
     /* 1124742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124761 */     // GIR_Coverage, 65241,
     /* 1124761 */     GIR_EraseRootFromParent_Done,
     /* 1124762 */   // Label 16513: @1124762
     /* 1124762 */   GIM_Try, /*On fail goto*//*Label 16514*/ GIMT_Encode4(1124839), // Rule ID 65244 //
     /* 1124767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124806 */     // MIs[0] policy
     /* 1124806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124816 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1124819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124838 */     // GIR_Coverage, 65244,
     /* 1124838 */     GIR_EraseRootFromParent_Done,
     /* 1124839 */   // Label 16514: @1124839
     /* 1124839 */   GIM_Try, /*On fail goto*//*Label 16515*/ GIMT_Encode4(1124916), // Rule ID 65245 //
     /* 1124844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124883 */     // MIs[0] policy
     /* 1124883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124893 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1124896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124915 */     // GIR_Coverage, 65245,
     /* 1124915 */     GIR_EraseRootFromParent_Done,
     /* 1124916 */   // Label 16515: @1124916
     /* 1124916 */   GIM_Try, /*On fail goto*//*Label 16516*/ GIMT_Encode4(1124993), // Rule ID 65248 //
     /* 1124921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1124938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124960 */     // MIs[0] policy
     /* 1124960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124970 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1124973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124992 */     // GIR_Coverage, 65248,
     /* 1124992 */     GIR_EraseRootFromParent_Done,
     /* 1124993 */   // Label 16516: @1124993
     /* 1124993 */   GIM_Try, /*On fail goto*//*Label 16517*/ GIMT_Encode4(1125070), // Rule ID 65249 //
     /* 1124998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1125015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125037 */     // MIs[0] policy
     /* 1125037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125047 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1125050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125069 */     // GIR_Coverage, 65249,
     /* 1125069 */     GIR_EraseRootFromParent_Done,
     /* 1125070 */   // Label 16517: @1125070
     /* 1125070 */   GIM_Try, /*On fail goto*//*Label 16518*/ GIMT_Encode4(1125147), // Rule ID 65252 //
     /* 1125075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1125092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1125095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125114 */     // MIs[0] policy
     /* 1125114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125124 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1125127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125146 */     // GIR_Coverage, 65252,
     /* 1125146 */     GIR_EraseRootFromParent_Done,
     /* 1125147 */   // Label 16518: @1125147
     /* 1125147 */   GIM_Try, /*On fail goto*//*Label 16519*/ GIMT_Encode4(1125224), // Rule ID 65253 //
     /* 1125152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1125169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1125172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125191 */     // MIs[0] policy
     /* 1125191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125201 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1125204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125223 */     // GIR_Coverage, 65253,
     /* 1125223 */     GIR_EraseRootFromParent_Done,
     /* 1125224 */   // Label 16519: @1125224
     /* 1125224 */   GIM_Try, /*On fail goto*//*Label 16520*/ GIMT_Encode4(1125301), // Rule ID 65256 //
     /* 1125229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1125240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1125243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1125246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1125249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125268 */     // MIs[0] policy
     /* 1125268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125278 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1125281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125300 */     // GIR_Coverage, 65256,
     /* 1125300 */     GIR_EraseRootFromParent_Done,
     /* 1125301 */   // Label 16520: @1125301
     /* 1125301 */   GIM_Try, /*On fail goto*//*Label 16521*/ GIMT_Encode4(1125378), // Rule ID 65257 //
     /* 1125306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1125317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1125320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1125323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1125326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125345 */     // MIs[0] policy
     /* 1125345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125355 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1125358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125377 */     // GIR_Coverage, 65257,
     /* 1125377 */     GIR_EraseRootFromParent_Done,
     /* 1125378 */   // Label 16521: @1125378
     /* 1125378 */   GIM_Try, /*On fail goto*//*Label 16522*/ GIMT_Encode4(1125455), // Rule ID 65260 //
     /* 1125383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1125394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1125397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1125400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1125403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125422 */     // MIs[0] policy
     /* 1125422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125432 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1125435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125454 */     // GIR_Coverage, 65260,
     /* 1125454 */     GIR_EraseRootFromParent_Done,
     /* 1125455 */   // Label 16522: @1125455
     /* 1125455 */   GIM_Try, /*On fail goto*//*Label 16523*/ GIMT_Encode4(1125532), // Rule ID 65261 //
     /* 1125460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1125471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1125474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1125477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1125480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125499 */     // MIs[0] policy
     /* 1125499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125509 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1125512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125531 */     // GIR_Coverage, 65261,
     /* 1125531 */     GIR_EraseRootFromParent_Done,
     /* 1125532 */   // Label 16523: @1125532
     /* 1125532 */   GIM_Try, /*On fail goto*//*Label 16524*/ GIMT_Encode4(1125609), // Rule ID 65264 //
     /* 1125537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1125548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1125551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1125554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1125557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125576 */     // MIs[0] policy
     /* 1125576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1125589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125605 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125608 */     // GIR_Coverage, 65264,
     /* 1125608 */     GIR_EraseRootFromParent_Done,
     /* 1125609 */   // Label 16524: @1125609
     /* 1125609 */   GIM_Try, /*On fail goto*//*Label 16525*/ GIMT_Encode4(1125686), // Rule ID 65265 //
     /* 1125614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1125625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1125628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1125631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1125634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125653 */     // MIs[0] policy
     /* 1125653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125663 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1125666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125685 */     // GIR_Coverage, 65265,
     /* 1125685 */     GIR_EraseRootFromParent_Done,
     /* 1125686 */   // Label 16525: @1125686
     /* 1125686 */   GIM_Try, /*On fail goto*//*Label 16526*/ GIMT_Encode4(1125763), // Rule ID 65268 //
     /* 1125691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1125702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1125705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1125708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1125711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125730 */     // MIs[0] policy
     /* 1125730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125740 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1125743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125762 */     // GIR_Coverage, 65268,
     /* 1125762 */     GIR_EraseRootFromParent_Done,
     /* 1125763 */   // Label 16526: @1125763
     /* 1125763 */   GIM_Try, /*On fail goto*//*Label 16527*/ GIMT_Encode4(1125840), // Rule ID 65269 //
     /* 1125768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1125779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1125782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1125785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1125788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125807 */     // MIs[0] policy
     /* 1125807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125817 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1125820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125839 */     // GIR_Coverage, 65269,
     /* 1125839 */     GIR_EraseRootFromParent_Done,
     /* 1125840 */   // Label 16527: @1125840
     /* 1125840 */   GIM_Try, /*On fail goto*//*Label 16528*/ GIMT_Encode4(1125917), // Rule ID 65272 //
     /* 1125845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1125856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1125859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1125862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1125865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125884 */     // MIs[0] policy
     /* 1125884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125894 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1125897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125916 */     // GIR_Coverage, 65272,
     /* 1125916 */     GIR_EraseRootFromParent_Done,
     /* 1125917 */   // Label 16528: @1125917
     /* 1125917 */   GIM_Try, /*On fail goto*//*Label 16529*/ GIMT_Encode4(1125994), // Rule ID 65273 //
     /* 1125922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1125933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1125936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1125939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1125942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125961 */     // MIs[0] policy
     /* 1125961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125971 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1125974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125993 */     // GIR_Coverage, 65273,
     /* 1125993 */     GIR_EraseRootFromParent_Done,
     /* 1125994 */   // Label 16529: @1125994
     /* 1125994 */   GIM_Try, /*On fail goto*//*Label 16530*/ GIMT_Encode4(1126071), // Rule ID 65276 //
     /* 1125999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1126010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1126013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1126016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126038 */     // MIs[0] policy
     /* 1126038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126048 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2),
     /* 1126051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126070 */     // GIR_Coverage, 65276,
     /* 1126070 */     GIR_EraseRootFromParent_Done,
     /* 1126071 */   // Label 16530: @1126071
     /* 1126071 */   GIM_Try, /*On fail goto*//*Label 16531*/ GIMT_Encode4(1126148), // Rule ID 65277 //
     /* 1126076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1126087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1126090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1126093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126115 */     // MIs[0] policy
     /* 1126115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126125 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2),
     /* 1126128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126147 */     // GIR_Coverage, 65277,
     /* 1126147 */     GIR_EraseRootFromParent_Done,
     /* 1126148 */   // Label 16531: @1126148
     /* 1126148 */   GIM_Try, /*On fail goto*//*Label 16532*/ GIMT_Encode4(1126225), // Rule ID 65280 //
     /* 1126153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1126173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126192 */     // MIs[0] policy
     /* 1126192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1126205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126224 */     // GIR_Coverage, 65280,
     /* 1126224 */     GIR_EraseRootFromParent_Done,
     /* 1126225 */   // Label 16532: @1126225
     /* 1126225 */   GIM_Try, /*On fail goto*//*Label 16533*/ GIMT_Encode4(1126302), // Rule ID 65281 //
     /* 1126230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1126250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126269 */     // MIs[0] policy
     /* 1126269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126279 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1126282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126301 */     // GIR_Coverage, 65281,
     /* 1126301 */     GIR_EraseRootFromParent_Done,
     /* 1126302 */   // Label 16533: @1126302
     /* 1126302 */   GIM_Try, /*On fail goto*//*Label 16534*/ GIMT_Encode4(1126379), // Rule ID 65284 //
     /* 1126307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1126324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1126327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126346 */     // MIs[0] policy
     /* 1126346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1126359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126378 */     // GIR_Coverage, 65284,
     /* 1126378 */     GIR_EraseRootFromParent_Done,
     /* 1126379 */   // Label 16534: @1126379
     /* 1126379 */   GIM_Try, /*On fail goto*//*Label 16535*/ GIMT_Encode4(1126456), // Rule ID 65285 //
     /* 1126384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1126401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1126404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126423 */     // MIs[0] policy
     /* 1126423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1126436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126455 */     // GIR_Coverage, 65285,
     /* 1126455 */     GIR_EraseRootFromParent_Done,
     /* 1126456 */   // Label 16535: @1126456
     /* 1126456 */   GIM_Try, /*On fail goto*//*Label 16536*/ GIMT_Encode4(1126533), // Rule ID 65288 //
     /* 1126461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1126478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126500 */     // MIs[0] policy
     /* 1126500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126510 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1126513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126529 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126532 */     // GIR_Coverage, 65288,
     /* 1126532 */     GIR_EraseRootFromParent_Done,
     /* 1126533 */   // Label 16536: @1126533
     /* 1126533 */   GIM_Try, /*On fail goto*//*Label 16537*/ GIMT_Encode4(1126610), // Rule ID 65289 //
     /* 1126538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1126555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126577 */     // MIs[0] policy
     /* 1126577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126587 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1126590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126609 */     // GIR_Coverage, 65289,
     /* 1126609 */     GIR_EraseRootFromParent_Done,
     /* 1126610 */   // Label 16537: @1126610
     /* 1126610 */   GIM_Try, /*On fail goto*//*Label 16538*/ GIMT_Encode4(1126687), // Rule ID 65292 //
     /* 1126615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1126632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1126635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126654 */     // MIs[0] policy
     /* 1126654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126664 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1126667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126683 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126686 */     // GIR_Coverage, 65292,
     /* 1126686 */     GIR_EraseRootFromParent_Done,
     /* 1126687 */   // Label 16538: @1126687
     /* 1126687 */   GIM_Try, /*On fail goto*//*Label 16539*/ GIMT_Encode4(1126764), // Rule ID 65293 //
     /* 1126692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1126709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1126712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126731 */     // MIs[0] policy
     /* 1126731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126741 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1126744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126763 */     // GIR_Coverage, 65293,
     /* 1126763 */     GIR_EraseRootFromParent_Done,
     /* 1126764 */   // Label 16539: @1126764
     /* 1126764 */   GIM_Try, /*On fail goto*//*Label 16540*/ GIMT_Encode4(1126841), // Rule ID 65296 //
     /* 1126769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1126780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1126783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1126786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1126789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126808 */     // MIs[0] policy
     /* 1126808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126818 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1126821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126840 */     // GIR_Coverage, 65296,
     /* 1126840 */     GIR_EraseRootFromParent_Done,
     /* 1126841 */   // Label 16540: @1126841
     /* 1126841 */   GIM_Try, /*On fail goto*//*Label 16541*/ GIMT_Encode4(1126918), // Rule ID 65297 //
     /* 1126846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1126849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1126857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1126860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1126863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1126866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126885 */     // MIs[0] policy
     /* 1126885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126895 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1126898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126917 */     // GIR_Coverage, 65297,
     /* 1126917 */     GIR_EraseRootFromParent_Done,
     /* 1126918 */   // Label 16541: @1126918
     /* 1126918 */   GIM_Try, /*On fail goto*//*Label 16542*/ GIMT_Encode4(1126995), // Rule ID 65300 //
     /* 1126923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1126934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1126937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1126940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1126943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126962 */     // MIs[0] policy
     /* 1126962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126972 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1126975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126991 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126994 */     // GIR_Coverage, 65300,
     /* 1126994 */     GIR_EraseRootFromParent_Done,
     /* 1126995 */   // Label 16542: @1126995
     /* 1126995 */   GIM_Try, /*On fail goto*//*Label 16543*/ GIMT_Encode4(1127072), // Rule ID 65301 //
     /* 1127000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1127003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1127008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1127011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1127014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1127017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1127020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127039 */     // MIs[0] policy
     /* 1127039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127049 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1127052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127071 */     // GIR_Coverage, 65301,
     /* 1127071 */     GIR_EraseRootFromParent_Done,
     /* 1127072 */   // Label 16543: @1127072
     /* 1127072 */   GIM_Try, /*On fail goto*//*Label 16544*/ GIMT_Encode4(1127149), // Rule ID 65304 //
     /* 1127077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1127080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1127085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1127088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1127091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1127094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1127097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127116 */     // MIs[0] policy
     /* 1127116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127126 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1127129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127148 */     // GIR_Coverage, 65304,
     /* 1127148 */     GIR_EraseRootFromParent_Done,
     /* 1127149 */   // Label 16544: @1127149
     /* 1127149 */   GIM_Try, /*On fail goto*//*Label 16545*/ GIMT_Encode4(1127226), // Rule ID 65305 //
     /* 1127154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1127157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1127162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1127165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1127168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1127171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1127174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127193 */     // MIs[0] policy
     /* 1127193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127203 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1127206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127225 */     // GIR_Coverage, 65305,
     /* 1127225 */     GIR_EraseRootFromParent_Done,
     /* 1127226 */   // Label 16545: @1127226
     /* 1127226 */   GIM_Try, /*On fail goto*//*Label 16546*/ GIMT_Encode4(1127303), // Rule ID 65308 //
     /* 1127231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1127234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1127239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1127242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1127245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1127248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1127251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127270 */     // MIs[0] policy
     /* 1127270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127280 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1127283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127302 */     // GIR_Coverage, 65308,
     /* 1127302 */     GIR_EraseRootFromParent_Done,
     /* 1127303 */   // Label 16546: @1127303
     /* 1127303 */   GIM_Try, /*On fail goto*//*Label 16547*/ GIMT_Encode4(1127380), // Rule ID 65309 //
     /* 1127308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1127311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1127316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1127319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1127322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1127325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1127328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127347 */     // MIs[0] policy
     /* 1127347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127357 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1127360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127379 */     // GIR_Coverage, 65309,
     /* 1127379 */     GIR_EraseRootFromParent_Done,
     /* 1127380 */   // Label 16547: @1127380
     /* 1127380 */   GIM_Try, /*On fail goto*//*Label 16548*/ GIMT_Encode4(1127457), // Rule ID 65312 //
     /* 1127385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1127396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1127399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1127402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1127405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127424 */     // MIs[0] policy
     /* 1127424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127434 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2),
     /* 1127437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127456 */     // GIR_Coverage, 65312,
     /* 1127456 */     GIR_EraseRootFromParent_Done,
     /* 1127457 */   // Label 16548: @1127457
     /* 1127457 */   GIM_Try, /*On fail goto*//*Label 16549*/ GIMT_Encode4(1127534), // Rule ID 65313 //
     /* 1127462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1127473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1127476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1127479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1127482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127501 */     // MIs[0] policy
     /* 1127501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127511 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2),
     /* 1127514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127530 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127533 */     // GIR_Coverage, 65313,
     /* 1127533 */     GIR_EraseRootFromParent_Done,
     /* 1127534 */   // Label 16549: @1127534
     /* 1127534 */   GIM_Try, /*On fail goto*//*Label 16550*/ GIMT_Encode4(1127611), // Rule ID 65316 //
     /* 1127539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127578 */     // MIs[0] policy
     /* 1127578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1127591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127610 */     // GIR_Coverage, 65316,
     /* 1127610 */     GIR_EraseRootFromParent_Done,
     /* 1127611 */   // Label 16550: @1127611
     /* 1127611 */   GIM_Try, /*On fail goto*//*Label 16551*/ GIMT_Encode4(1127688), // Rule ID 65317 //
     /* 1127616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127655 */     // MIs[0] policy
     /* 1127655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127665 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1127668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127687 */     // GIR_Coverage, 65317,
     /* 1127687 */     GIR_EraseRootFromParent_Done,
     /* 1127688 */   // Label 16551: @1127688
     /* 1127688 */   GIM_Try, /*On fail goto*//*Label 16552*/ GIMT_Encode4(1127765), // Rule ID 65320 //
     /* 1127693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1127704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1127707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1127710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127732 */     // MIs[0] policy
     /* 1127732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127742 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1127745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127764 */     // GIR_Coverage, 65320,
     /* 1127764 */     GIR_EraseRootFromParent_Done,
     /* 1127765 */   // Label 16552: @1127765
     /* 1127765 */   GIM_Try, /*On fail goto*//*Label 16553*/ GIMT_Encode4(1127842), // Rule ID 65321 //
     /* 1127770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1127781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1127784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1127787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127809 */     // MIs[0] policy
     /* 1127809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1127822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127841 */     // GIR_Coverage, 65321,
     /* 1127841 */     GIR_EraseRootFromParent_Done,
     /* 1127842 */   // Label 16553: @1127842
     /* 1127842 */   GIM_Try, /*On fail goto*//*Label 16554*/ GIMT_Encode4(1127919), // Rule ID 65324 //
     /* 1127847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1127864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127886 */     // MIs[0] policy
     /* 1127886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127896 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1127899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127918 */     // GIR_Coverage, 65324,
     /* 1127918 */     GIR_EraseRootFromParent_Done,
     /* 1127919 */   // Label 16554: @1127919
     /* 1127919 */   GIM_Try, /*On fail goto*//*Label 16555*/ GIMT_Encode4(1127996), // Rule ID 65325 //
     /* 1127924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1127941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127963 */     // MIs[0] policy
     /* 1127963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127973 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1127976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127995 */     // GIR_Coverage, 65325,
     /* 1127995 */     GIR_EraseRootFromParent_Done,
     /* 1127996 */   // Label 16555: @1127996
     /* 1127996 */   GIM_Try, /*On fail goto*//*Label 16556*/ GIMT_Encode4(1128073), // Rule ID 65328 //
     /* 1128001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1128012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1128015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1128018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1128021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128040 */     // MIs[0] policy
     /* 1128040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128050 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1128053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128069 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128072 */     // GIR_Coverage, 65328,
     /* 1128072 */     GIR_EraseRootFromParent_Done,
     /* 1128073 */   // Label 16556: @1128073
     /* 1128073 */   GIM_Try, /*On fail goto*//*Label 16557*/ GIMT_Encode4(1128150), // Rule ID 65329 //
     /* 1128078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1128089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1128092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1128095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1128098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128117 */     // MIs[0] policy
     /* 1128117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128127 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1128130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128146 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128149 */     // GIR_Coverage, 65329,
     /* 1128149 */     GIR_EraseRootFromParent_Done,
     /* 1128150 */   // Label 16557: @1128150
     /* 1128150 */   GIM_Try, /*On fail goto*//*Label 16558*/ GIMT_Encode4(1128227), // Rule ID 65332 //
     /* 1128155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1128166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1128169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1128172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128194 */     // MIs[0] policy
     /* 1128194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128204 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1128207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128223 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128226 */     // GIR_Coverage, 65332,
     /* 1128226 */     GIR_EraseRootFromParent_Done,
     /* 1128227 */   // Label 16558: @1128227
     /* 1128227 */   GIM_Try, /*On fail goto*//*Label 16559*/ GIMT_Encode4(1128304), // Rule ID 65333 //
     /* 1128232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1128243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1128246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1128249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128271 */     // MIs[0] policy
     /* 1128271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128281 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1128284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128303 */     // GIR_Coverage, 65333,
     /* 1128303 */     GIR_EraseRootFromParent_Done,
     /* 1128304 */   // Label 16559: @1128304
     /* 1128304 */   GIM_Try, /*On fail goto*//*Label 16560*/ GIMT_Encode4(1128381), // Rule ID 65336 //
     /* 1128309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1128320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1128323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1128326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1128329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128348 */     // MIs[0] policy
     /* 1128348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1128361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128377 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128380 */     // GIR_Coverage, 65336,
     /* 1128380 */     GIR_EraseRootFromParent_Done,
     /* 1128381 */   // Label 16560: @1128381
     /* 1128381 */   GIM_Try, /*On fail goto*//*Label 16561*/ GIMT_Encode4(1128458), // Rule ID 65337 //
     /* 1128386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1128397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1128400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1128403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1128406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128425 */     // MIs[0] policy
     /* 1128425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128435 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1128438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128457 */     // GIR_Coverage, 65337,
     /* 1128457 */     GIR_EraseRootFromParent_Done,
     /* 1128458 */   // Label 16561: @1128458
     /* 1128458 */   GIM_Try, /*On fail goto*//*Label 16562*/ GIMT_Encode4(1128535), // Rule ID 65340 //
     /* 1128463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1128474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1128477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1128480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1128483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128502 */     // MIs[0] policy
     /* 1128502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128512 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1128515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128534 */     // GIR_Coverage, 65340,
     /* 1128534 */     GIR_EraseRootFromParent_Done,
     /* 1128535 */   // Label 16562: @1128535
     /* 1128535 */   GIM_Try, /*On fail goto*//*Label 16563*/ GIMT_Encode4(1128612), // Rule ID 65341 //
     /* 1128540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1128551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1128554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1128557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1128560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128579 */     // MIs[0] policy
     /* 1128579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128589 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1128592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128611 */     // GIR_Coverage, 65341,
     /* 1128611 */     GIR_EraseRootFromParent_Done,
     /* 1128612 */   // Label 16563: @1128612
     /* 1128612 */   GIM_Try, /*On fail goto*//*Label 16564*/ GIMT_Encode4(1128689), // Rule ID 65344 //
     /* 1128617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1128628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1128631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1128634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1128637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128656 */     // MIs[0] policy
     /* 1128656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128666 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1128669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128688 */     // GIR_Coverage, 65344,
     /* 1128688 */     GIR_EraseRootFromParent_Done,
     /* 1128689 */   // Label 16564: @1128689
     /* 1128689 */   GIM_Try, /*On fail goto*//*Label 16565*/ GIMT_Encode4(1128766), // Rule ID 65345 //
     /* 1128694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1128705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1128708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1128711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1128714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128733 */     // MIs[0] policy
     /* 1128733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128743 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1128746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128765 */     // GIR_Coverage, 65345,
     /* 1128765 */     GIR_EraseRootFromParent_Done,
     /* 1128766 */   // Label 16565: @1128766
     /* 1128766 */   GIM_Try, /*On fail goto*//*Label 16566*/ GIMT_Encode4(1128846), // Rule ID 2736 //
     /* 1128771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1128782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1128785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1128788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1128791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128810 */     // MIs[0] round
     /* 1128810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128820 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1128823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128845 */     // GIR_Coverage, 2736,
     /* 1128845 */     GIR_EraseRootFromParent_Done,
     /* 1128846 */   // Label 16566: @1128846
     /* 1128846 */   GIM_Try, /*On fail goto*//*Label 16567*/ GIMT_Encode4(1128926), // Rule ID 2737 //
     /* 1128851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1128862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1128865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1128868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1128871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128890 */     // MIs[0] round
     /* 1128890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128900 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1128903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128925 */     // GIR_Coverage, 2737,
     /* 1128925 */     GIR_EraseRootFromParent_Done,
     /* 1128926 */   // Label 16567: @1128926
     /* 1128926 */   GIM_Try, /*On fail goto*//*Label 16568*/ GIMT_Encode4(1129006), // Rule ID 2776 //
     /* 1128931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1128934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1128939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1128942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1128945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1128948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1128951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128970 */     // MIs[0] round
     /* 1128970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128980 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1128983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129005 */     // GIR_Coverage, 2776,
     /* 1129005 */     GIR_EraseRootFromParent_Done,
     /* 1129006 */   // Label 16568: @1129006
     /* 1129006 */   GIM_Try, /*On fail goto*//*Label 16569*/ GIMT_Encode4(1129086), // Rule ID 2777 //
     /* 1129011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1129014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1129019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1129028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1129031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129050 */     // MIs[0] round
     /* 1129050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129060 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1129063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129085 */     // GIR_Coverage, 2777,
     /* 1129085 */     GIR_EraseRootFromParent_Done,
     /* 1129086 */   // Label 16569: @1129086
     /* 1129086 */   GIM_Try, /*On fail goto*//*Label 16570*/ GIMT_Encode4(1129166), // Rule ID 2796 //
     /* 1129091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1129094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1129102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1129105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1129108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1129111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129130 */     // MIs[0] round
     /* 1129130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129140 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1129143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129165 */     // GIR_Coverage, 2796,
     /* 1129165 */     GIR_EraseRootFromParent_Done,
     /* 1129166 */   // Label 16570: @1129166
     /* 1129166 */   GIM_Try, /*On fail goto*//*Label 16571*/ GIMT_Encode4(1129246), // Rule ID 2797 //
     /* 1129171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1129174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1129182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1129185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1129188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1129191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129210 */     // MIs[0] round
     /* 1129210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129220 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1129223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129245 */     // GIR_Coverage, 2797,
     /* 1129245 */     GIR_EraseRootFromParent_Done,
     /* 1129246 */   // Label 16571: @1129246
     /* 1129246 */   GIM_Try, /*On fail goto*//*Label 16572*/ GIMT_Encode4(1129326), // Rule ID 14946 //
     /* 1129251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1129262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1129265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1129268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1129271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129290 */     // MIs[0] round
     /* 1129290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129300 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1129303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129325 */     // GIR_Coverage, 14946,
     /* 1129325 */     GIR_EraseRootFromParent_Done,
     /* 1129326 */   // Label 16572: @1129326
     /* 1129326 */   GIM_Try, /*On fail goto*//*Label 16573*/ GIMT_Encode4(1129406), // Rule ID 14947 //
     /* 1129331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1129342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1129345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1129348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1129351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129370 */     // MIs[0] round
     /* 1129370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129380 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1129383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129405 */     // GIR_Coverage, 14947,
     /* 1129405 */     GIR_EraseRootFromParent_Done,
     /* 1129406 */   // Label 16573: @1129406
     /* 1129406 */   GIM_Try, /*On fail goto*//*Label 16574*/ GIMT_Encode4(1129486), // Rule ID 14950 //
     /* 1129411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1129422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1129425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1129428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1129431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129450 */     // MIs[0] round
     /* 1129450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129460 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129485 */     // GIR_Coverage, 14950,
     /* 1129485 */     GIR_EraseRootFromParent_Done,
     /* 1129486 */   // Label 16574: @1129486
     /* 1129486 */   GIM_Try, /*On fail goto*//*Label 16575*/ GIMT_Encode4(1129566), // Rule ID 14951 //
     /* 1129491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1129502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1129505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1129508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1129511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129530 */     // MIs[0] round
     /* 1129530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129540 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129565 */     // GIR_Coverage, 14951,
     /* 1129565 */     GIR_EraseRootFromParent_Done,
     /* 1129566 */   // Label 16575: @1129566
     /* 1129566 */   GIM_Try, /*On fail goto*//*Label 16576*/ GIMT_Encode4(1129646), // Rule ID 14954 //
     /* 1129571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1129582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1129585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1129588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1129591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129610 */     // MIs[0] round
     /* 1129610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129620 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1129623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129645 */     // GIR_Coverage, 14954,
     /* 1129645 */     GIR_EraseRootFromParent_Done,
     /* 1129646 */   // Label 16576: @1129646
     /* 1129646 */   GIM_Try, /*On fail goto*//*Label 16577*/ GIMT_Encode4(1129726), // Rule ID 14955 //
     /* 1129651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1129662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1129665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1129668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1129671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129690 */     // MIs[0] round
     /* 1129690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129700 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1129703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129725 */     // GIR_Coverage, 14955,
     /* 1129725 */     GIR_EraseRootFromParent_Done,
     /* 1129726 */   // Label 16577: @1129726
     /* 1129726 */   GIM_Try, /*On fail goto*//*Label 16578*/ GIMT_Encode4(1129806), // Rule ID 14958 //
     /* 1129731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1129742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1129745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1129748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1129751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129770 */     // MIs[0] round
     /* 1129770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129780 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129805 */     // GIR_Coverage, 14958,
     /* 1129805 */     GIR_EraseRootFromParent_Done,
     /* 1129806 */   // Label 16578: @1129806
     /* 1129806 */   GIM_Try, /*On fail goto*//*Label 16579*/ GIMT_Encode4(1129886), // Rule ID 14959 //
     /* 1129811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1129822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1129825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1129828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1129831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129850 */     // MIs[0] round
     /* 1129850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129885 */     // GIR_Coverage, 14959,
     /* 1129885 */     GIR_EraseRootFromParent_Done,
     /* 1129886 */   // Label 16579: @1129886
     /* 1129886 */   GIM_Try, /*On fail goto*//*Label 16580*/ GIMT_Encode4(1129966), // Rule ID 14962 //
     /* 1129891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1129908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1129911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129930 */     // MIs[0] round
     /* 1129930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129940 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129965 */     // GIR_Coverage, 14962,
     /* 1129965 */     GIR_EraseRootFromParent_Done,
     /* 1129966 */   // Label 16580: @1129966
     /* 1129966 */   GIM_Try, /*On fail goto*//*Label 16581*/ GIMT_Encode4(1130046), // Rule ID 14963 //
     /* 1129971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1129988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1129991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130010 */     // MIs[0] round
     /* 1130010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130020 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1130023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130045 */     // GIR_Coverage, 14963,
     /* 1130045 */     GIR_EraseRootFromParent_Done,
     /* 1130046 */   // Label 16581: @1130046
     /* 1130046 */   GIM_Try, /*On fail goto*//*Label 16582*/ GIMT_Encode4(1130126), // Rule ID 14966 //
     /* 1130051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1130062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1130065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1130068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1130071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130090 */     // MIs[0] round
     /* 1130090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130100 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130125 */     // GIR_Coverage, 14966,
     /* 1130125 */     GIR_EraseRootFromParent_Done,
     /* 1130126 */   // Label 16582: @1130126
     /* 1130126 */   GIM_Try, /*On fail goto*//*Label 16583*/ GIMT_Encode4(1130206), // Rule ID 14967 //
     /* 1130131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1130142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1130145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1130148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1130151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130170 */     // MIs[0] round
     /* 1130170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130180 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130205 */     // GIR_Coverage, 14967,
     /* 1130205 */     GIR_EraseRootFromParent_Done,
     /* 1130206 */   // Label 16583: @1130206
     /* 1130206 */   GIM_Try, /*On fail goto*//*Label 16584*/ GIMT_Encode4(1130286), // Rule ID 14970 //
     /* 1130211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1130222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1130225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1130228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1130231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130250 */     // MIs[0] round
     /* 1130250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130260 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130285 */     // GIR_Coverage, 14970,
     /* 1130285 */     GIR_EraseRootFromParent_Done,
     /* 1130286 */   // Label 16584: @1130286
     /* 1130286 */   GIM_Try, /*On fail goto*//*Label 16585*/ GIMT_Encode4(1130366), // Rule ID 14971 //
     /* 1130291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1130302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1130305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1130308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1130311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130330 */     // MIs[0] round
     /* 1130330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130340 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130365 */     // GIR_Coverage, 14971,
     /* 1130365 */     GIR_EraseRootFromParent_Done,
     /* 1130366 */   // Label 16585: @1130366
     /* 1130366 */   GIM_Try, /*On fail goto*//*Label 16586*/ GIMT_Encode4(1130446), // Rule ID 14974 //
     /* 1130371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1130382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1130385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1130388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1130391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130410 */     // MIs[0] round
     /* 1130410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130420 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130445 */     // GIR_Coverage, 14974,
     /* 1130445 */     GIR_EraseRootFromParent_Done,
     /* 1130446 */   // Label 16586: @1130446
     /* 1130446 */   GIM_Try, /*On fail goto*//*Label 16587*/ GIMT_Encode4(1130526), // Rule ID 14975 //
     /* 1130451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1130462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1130465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1130468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1130471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130490 */     // MIs[0] round
     /* 1130490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130525 */     // GIR_Coverage, 14975,
     /* 1130525 */     GIR_EraseRootFromParent_Done,
     /* 1130526 */   // Label 16587: @1130526
     /* 1130526 */   GIM_Try, /*On fail goto*//*Label 16588*/ GIMT_Encode4(1130606), // Rule ID 14978 //
     /* 1130531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1130534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1130542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1130545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1130548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1130551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130570 */     // MIs[0] round
     /* 1130570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130580 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130605 */     // GIR_Coverage, 14978,
     /* 1130605 */     GIR_EraseRootFromParent_Done,
     /* 1130606 */   // Label 16588: @1130606
     /* 1130606 */   GIM_Try, /*On fail goto*//*Label 16589*/ GIMT_Encode4(1130686), // Rule ID 14979 //
     /* 1130611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1130614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1130622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1130625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1130628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1130631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130650 */     // MIs[0] round
     /* 1130650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130685 */     // GIR_Coverage, 14979,
     /* 1130685 */     GIR_EraseRootFromParent_Done,
     /* 1130686 */   // Label 16589: @1130686
     /* 1130686 */   GIM_Try, /*On fail goto*//*Label 16590*/ GIMT_Encode4(1130766), // Rule ID 14982 //
     /* 1130691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1130702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1130705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1130708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1130711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130730 */     // MIs[0] round
     /* 1130730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130740 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130765 */     // GIR_Coverage, 14982,
     /* 1130765 */     GIR_EraseRootFromParent_Done,
     /* 1130766 */   // Label 16590: @1130766
     /* 1130766 */   GIM_Try, /*On fail goto*//*Label 16591*/ GIMT_Encode4(1130846), // Rule ID 14983 //
     /* 1130771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1130782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1130785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1130788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1130791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130810 */     // MIs[0] round
     /* 1130810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130820 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130845 */     // GIR_Coverage, 14983,
     /* 1130845 */     GIR_EraseRootFromParent_Done,
     /* 1130846 */   // Label 16591: @1130846
     /* 1130846 */   GIM_Try, /*On fail goto*//*Label 16592*/ GIMT_Encode4(1130926), // Rule ID 14986 //
     /* 1130851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1130862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1130865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1130868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1130871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130890 */     // MIs[0] round
     /* 1130890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130900 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130925 */     // GIR_Coverage, 14986,
     /* 1130925 */     GIR_EraseRootFromParent_Done,
     /* 1130926 */   // Label 16592: @1130926
     /* 1130926 */   GIM_Try, /*On fail goto*//*Label 16593*/ GIMT_Encode4(1131006), // Rule ID 14987 //
     /* 1130931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1130942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1130945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1130948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1130951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130970 */     // MIs[0] round
     /* 1130970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130980 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131005 */     // GIR_Coverage, 14987,
     /* 1131005 */     GIR_EraseRootFromParent_Done,
     /* 1131006 */   // Label 16593: @1131006
     /* 1131006 */   GIM_Try, /*On fail goto*//*Label 16594*/ GIMT_Encode4(1131086), // Rule ID 14990 //
     /* 1131011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1131022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1131025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1131028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1131031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131050 */     // MIs[0] round
     /* 1131050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131060 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131085 */     // GIR_Coverage, 14990,
     /* 1131085 */     GIR_EraseRootFromParent_Done,
     /* 1131086 */   // Label 16594: @1131086
     /* 1131086 */   GIM_Try, /*On fail goto*//*Label 16595*/ GIMT_Encode4(1131166), // Rule ID 14991 //
     /* 1131091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1131102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1131105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1131108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1131111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131130 */     // MIs[0] round
     /* 1131130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131140 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131165 */     // GIR_Coverage, 14991,
     /* 1131165 */     GIR_EraseRootFromParent_Done,
     /* 1131166 */   // Label 16595: @1131166
     /* 1131166 */   GIM_Try, /*On fail goto*//*Label 16596*/ GIMT_Encode4(1131246), // Rule ID 14994 //
     /* 1131171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1131182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1131185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1131188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1131191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131210 */     // MIs[0] round
     /* 1131210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131245 */     // GIR_Coverage, 14994,
     /* 1131245 */     GIR_EraseRootFromParent_Done,
     /* 1131246 */   // Label 16596: @1131246
     /* 1131246 */   GIM_Try, /*On fail goto*//*Label 16597*/ GIMT_Encode4(1131326), // Rule ID 14995 //
     /* 1131251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1131262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1131265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1131268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1131271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131290 */     // MIs[0] round
     /* 1131290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131300 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131325 */     // GIR_Coverage, 14995,
     /* 1131325 */     GIR_EraseRootFromParent_Done,
     /* 1131326 */   // Label 16597: @1131326
     /* 1131326 */   GIM_Try, /*On fail goto*//*Label 16598*/ GIMT_Encode4(1131406), // Rule ID 14998 //
     /* 1131331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1131342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1131345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1131348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1131351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131370 */     // MIs[0] round
     /* 1131370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131405 */     // GIR_Coverage, 14998,
     /* 1131405 */     GIR_EraseRootFromParent_Done,
     /* 1131406 */   // Label 16598: @1131406
     /* 1131406 */   GIM_Try, /*On fail goto*//*Label 16599*/ GIMT_Encode4(1131486), // Rule ID 14999 //
     /* 1131411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1131422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1131425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1131428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1131431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131450 */     // MIs[0] round
     /* 1131450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131485 */     // GIR_Coverage, 14999,
     /* 1131485 */     GIR_EraseRootFromParent_Done,
     /* 1131486 */   // Label 16599: @1131486
     /* 1131486 */   GIM_Try, /*On fail goto*//*Label 16600*/ GIMT_Encode4(1131566), // Rule ID 15002 //
     /* 1131491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1131502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1131505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1131508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1131511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131530 */     // MIs[0] round
     /* 1131530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131540 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131565 */     // GIR_Coverage, 15002,
     /* 1131565 */     GIR_EraseRootFromParent_Done,
     /* 1131566 */   // Label 16600: @1131566
     /* 1131566 */   GIM_Try, /*On fail goto*//*Label 16601*/ GIMT_Encode4(1131646), // Rule ID 15003 //
     /* 1131571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1131582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1131585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1131588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1131591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131610 */     // MIs[0] round
     /* 1131610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131620 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131645 */     // GIR_Coverage, 15003,
     /* 1131645 */     GIR_EraseRootFromParent_Done,
     /* 1131646 */   // Label 16601: @1131646
     /* 1131646 */   GIM_Try, /*On fail goto*//*Label 16602*/ GIMT_Encode4(1131726), // Rule ID 15006 //
     /* 1131651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1131662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1131665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1131668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1131671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131690 */     // MIs[0] round
     /* 1131690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131725 */     // GIR_Coverage, 15006,
     /* 1131725 */     GIR_EraseRootFromParent_Done,
     /* 1131726 */   // Label 16602: @1131726
     /* 1131726 */   GIM_Try, /*On fail goto*//*Label 16603*/ GIMT_Encode4(1131806), // Rule ID 15007 //
     /* 1131731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1131742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1131745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1131748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1131751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131770 */     // MIs[0] round
     /* 1131770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131805 */     // GIR_Coverage, 15007,
     /* 1131805 */     GIR_EraseRootFromParent_Done,
     /* 1131806 */   // Label 16603: @1131806
     /* 1131806 */   GIM_Try, /*On fail goto*//*Label 16604*/ GIMT_Encode4(1131886), // Rule ID 15010 //
     /* 1131811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1131822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1131825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1131828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1131831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131850 */     // MIs[0] round
     /* 1131850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131860 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131885 */     // GIR_Coverage, 15010,
     /* 1131885 */     GIR_EraseRootFromParent_Done,
     /* 1131886 */   // Label 16604: @1131886
     /* 1131886 */   GIM_Try, /*On fail goto*//*Label 16605*/ GIMT_Encode4(1131966), // Rule ID 15011 //
     /* 1131891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1131902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1131905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1131908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1131911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131930 */     // MIs[0] round
     /* 1131930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131940 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131965 */     // GIR_Coverage, 15011,
     /* 1131965 */     GIR_EraseRootFromParent_Done,
     /* 1131966 */   // Label 16605: @1131966
     /* 1131966 */   GIM_Try, /*On fail goto*//*Label 16606*/ GIMT_Encode4(1132046), // Rule ID 15014 //
     /* 1131971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1131982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1131985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1131988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1131991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132010 */     // MIs[0] round
     /* 1132010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132020 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1132023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1132041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132045 */     // GIR_Coverage, 15014,
     /* 1132045 */     GIR_EraseRootFromParent_Done,
     /* 1132046 */   // Label 16606: @1132046
     /* 1132046 */   GIM_Try, /*On fail goto*//*Label 16607*/ GIMT_Encode4(1132126), // Rule ID 15015 //
     /* 1132051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1132062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1132065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1132068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1132071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132090 */     // MIs[0] round
     /* 1132090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1132103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1132121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132125 */     // GIR_Coverage, 15015,
     /* 1132125 */     GIR_EraseRootFromParent_Done,
     /* 1132126 */   // Label 16607: @1132126
     /* 1132126 */   GIM_Try, /*On fail goto*//*Label 16608*/ GIMT_Encode4(1132206), // Rule ID 15018 //
     /* 1132131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1132134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1132142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1132145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1132148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1132151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132170 */     // MIs[0] round
     /* 1132170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132180 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1132183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132205 */     // GIR_Coverage, 15018,
     /* 1132205 */     GIR_EraseRootFromParent_Done,
     /* 1132206 */   // Label 16608: @1132206
     /* 1132206 */   GIM_Try, /*On fail goto*//*Label 16609*/ GIMT_Encode4(1132286), // Rule ID 15019 //
     /* 1132211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1132214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1132222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1132225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1132228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1132231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132250 */     // MIs[0] round
     /* 1132250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132260 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1132263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132285 */     // GIR_Coverage, 15019,
     /* 1132285 */     GIR_EraseRootFromParent_Done,
     /* 1132286 */   // Label 16609: @1132286
     /* 1132286 */   GIM_Try, /*On fail goto*//*Label 16610*/ GIMT_Encode4(1132366), // Rule ID 15022 //
     /* 1132291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1132294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1132302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1132305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1132308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1132311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132330 */     // MIs[0] round
     /* 1132330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132340 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1132343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132365 */     // GIR_Coverage, 15022,
     /* 1132365 */     GIR_EraseRootFromParent_Done,
     /* 1132366 */   // Label 16610: @1132366
     /* 1132366 */   GIM_Try, /*On fail goto*//*Label 16611*/ GIMT_Encode4(1132446), // Rule ID 15023 //
     /* 1132371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1132374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1132382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1132385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1132388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1132391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132410 */     // MIs[0] round
     /* 1132410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132420 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1132423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132445 */     // GIR_Coverage, 15023,
     /* 1132445 */     GIR_EraseRootFromParent_Done,
     /* 1132446 */   // Label 16611: @1132446
     /* 1132446 */   GIM_Try, /*On fail goto*//*Label 16612*/ GIMT_Encode4(1132526), // Rule ID 15026 //
     /* 1132451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1132454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1132462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1132465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1132468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1132471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132490 */     // MIs[0] round
     /* 1132490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132500 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1132503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132525 */     // GIR_Coverage, 15026,
     /* 1132525 */     GIR_EraseRootFromParent_Done,
     /* 1132526 */   // Label 16612: @1132526
     /* 1132526 */   GIM_Try, /*On fail goto*//*Label 16613*/ GIMT_Encode4(1132606), // Rule ID 15027 //
     /* 1132531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1132534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1132542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1132545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1132548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1132551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132570 */     // MIs[0] round
     /* 1132570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132580 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1132583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132605 */     // GIR_Coverage, 15027,
     /* 1132605 */     GIR_EraseRootFromParent_Done,
     /* 1132606 */   // Label 16613: @1132606
     /* 1132606 */   GIM_Try, /*On fail goto*//*Label 16614*/ GIMT_Encode4(1132686), // Rule ID 15030 //
     /* 1132611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1132622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1132625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1132628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132650 */     // MIs[0] round
     /* 1132650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132660 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1132663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132685 */     // GIR_Coverage, 15030,
     /* 1132685 */     GIR_EraseRootFromParent_Done,
     /* 1132686 */   // Label 16614: @1132686
     /* 1132686 */   GIM_Try, /*On fail goto*//*Label 16615*/ GIMT_Encode4(1132766), // Rule ID 15031 //
     /* 1132691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1132702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1132705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1132708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132730 */     // MIs[0] round
     /* 1132730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132740 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1132743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132765 */     // GIR_Coverage, 15031,
     /* 1132765 */     GIR_EraseRootFromParent_Done,
     /* 1132766 */   // Label 16615: @1132766
     /* 1132766 */   GIM_Try, /*On fail goto*//*Label 16616*/ GIMT_Encode4(1132846), // Rule ID 15034 //
     /* 1132771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1132782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1132785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1132788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132810 */     // MIs[0] round
     /* 1132810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132820 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132845 */     // GIR_Coverage, 15034,
     /* 1132845 */     GIR_EraseRootFromParent_Done,
     /* 1132846 */   // Label 16616: @1132846
     /* 1132846 */   GIM_Try, /*On fail goto*//*Label 16617*/ GIMT_Encode4(1132926), // Rule ID 15035 //
     /* 1132851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1132862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1132865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1132868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132890 */     // MIs[0] round
     /* 1132890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132900 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132925 */     // GIR_Coverage, 15035,
     /* 1132925 */     GIR_EraseRootFromParent_Done,
     /* 1132926 */   // Label 16617: @1132926
     /* 1132926 */   GIM_Try, /*On fail goto*//*Label 16618*/ GIMT_Encode4(1133006), // Rule ID 15038 //
     /* 1132931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1132942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1132945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1132948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132970 */     // MIs[0] round
     /* 1132970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132980 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133005 */     // GIR_Coverage, 15038,
     /* 1133005 */     GIR_EraseRootFromParent_Done,
     /* 1133006 */   // Label 16618: @1133006
     /* 1133006 */   GIM_Try, /*On fail goto*//*Label 16619*/ GIMT_Encode4(1133086), // Rule ID 15039 //
     /* 1133011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1133022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1133025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1133028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133050 */     // MIs[0] round
     /* 1133050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133060 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133085 */     // GIR_Coverage, 15039,
     /* 1133085 */     GIR_EraseRootFromParent_Done,
     /* 1133086 */   // Label 16619: @1133086
     /* 1133086 */   GIM_Try, /*On fail goto*//*Label 16620*/ GIMT_Encode4(1133166), // Rule ID 15042 //
     /* 1133091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1133102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1133105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1133108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133130 */     // MIs[0] round
     /* 1133130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133140 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1133143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133165 */     // GIR_Coverage, 15042,
     /* 1133165 */     GIR_EraseRootFromParent_Done,
     /* 1133166 */   // Label 16620: @1133166
     /* 1133166 */   GIM_Try, /*On fail goto*//*Label 16621*/ GIMT_Encode4(1133246), // Rule ID 15043 //
     /* 1133171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1133182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1133185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1133188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133210 */     // MIs[0] round
     /* 1133210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133220 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1133223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133245 */     // GIR_Coverage, 15043,
     /* 1133245 */     GIR_EraseRootFromParent_Done,
     /* 1133246 */   // Label 16621: @1133246
     /* 1133246 */   GIM_Try, /*On fail goto*//*Label 16622*/ GIMT_Encode4(1133326), // Rule ID 15046 //
     /* 1133251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1133262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1133265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1133268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133290 */     // MIs[0] round
     /* 1133290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133300 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133325 */     // GIR_Coverage, 15046,
     /* 1133325 */     GIR_EraseRootFromParent_Done,
     /* 1133326 */   // Label 16622: @1133326
     /* 1133326 */   GIM_Try, /*On fail goto*//*Label 16623*/ GIMT_Encode4(1133406), // Rule ID 15047 //
     /* 1133331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1133342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1133345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1133348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133370 */     // MIs[0] round
     /* 1133370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133380 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133405 */     // GIR_Coverage, 15047,
     /* 1133405 */     GIR_EraseRootFromParent_Done,
     /* 1133406 */   // Label 16623: @1133406
     /* 1133406 */   GIM_Try, /*On fail goto*//*Label 16624*/ GIMT_Encode4(1133486), // Rule ID 15050 //
     /* 1133411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1133422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1133425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1133428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133450 */     // MIs[0] round
     /* 1133450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133460 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133485 */     // GIR_Coverage, 15050,
     /* 1133485 */     GIR_EraseRootFromParent_Done,
     /* 1133486 */   // Label 16624: @1133486
     /* 1133486 */   GIM_Try, /*On fail goto*//*Label 16625*/ GIMT_Encode4(1133566), // Rule ID 15051 //
     /* 1133491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1133502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1133505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1133508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133530 */     // MIs[0] round
     /* 1133530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133540 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133565 */     // GIR_Coverage, 15051,
     /* 1133565 */     GIR_EraseRootFromParent_Done,
     /* 1133566 */   // Label 16625: @1133566
     /* 1133566 */   GIM_Try, /*On fail goto*//*Label 16626*/ GIMT_Encode4(1133646), // Rule ID 15054 //
     /* 1133571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1133582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1133585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1133588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133610 */     // MIs[0] round
     /* 1133610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133620 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133645 */     // GIR_Coverage, 15054,
     /* 1133645 */     GIR_EraseRootFromParent_Done,
     /* 1133646 */   // Label 16626: @1133646
     /* 1133646 */   GIM_Try, /*On fail goto*//*Label 16627*/ GIMT_Encode4(1133726), // Rule ID 15055 //
     /* 1133651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1133662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1133665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1133668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133690 */     // MIs[0] round
     /* 1133690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133700 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133725 */     // GIR_Coverage, 15055,
     /* 1133725 */     GIR_EraseRootFromParent_Done,
     /* 1133726 */   // Label 16627: @1133726
     /* 1133726 */   GIM_Try, /*On fail goto*//*Label 16628*/ GIMT_Encode4(1133806), // Rule ID 15058 //
     /* 1133731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1133742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1133745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1133748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133770 */     // MIs[0] round
     /* 1133770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133805 */     // GIR_Coverage, 15058,
     /* 1133805 */     GIR_EraseRootFromParent_Done,
     /* 1133806 */   // Label 16628: @1133806
     /* 1133806 */   GIM_Try, /*On fail goto*//*Label 16629*/ GIMT_Encode4(1133886), // Rule ID 15059 //
     /* 1133811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1133822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1133825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1133828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133850 */     // MIs[0] round
     /* 1133850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133885 */     // GIR_Coverage, 15059,
     /* 1133885 */     GIR_EraseRootFromParent_Done,
     /* 1133886 */   // Label 16629: @1133886
     /* 1133886 */   GIM_Try, /*On fail goto*//*Label 16630*/ GIMT_Encode4(1133966), // Rule ID 15062 //
     /* 1133891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133930 */     // MIs[0] round
     /* 1133930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133965 */     // GIR_Coverage, 15062,
     /* 1133965 */     GIR_EraseRootFromParent_Done,
     /* 1133966 */   // Label 16630: @1133966
     /* 1133966 */   GIM_Try, /*On fail goto*//*Label 16631*/ GIMT_Encode4(1134046), // Rule ID 15063 //
     /* 1133971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134010 */     // MIs[0] round
     /* 1134010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1134023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134045 */     // GIR_Coverage, 15063,
     /* 1134045 */     GIR_EraseRootFromParent_Done,
     /* 1134046 */   // Label 16631: @1134046
     /* 1134046 */   GIM_Try, /*On fail goto*//*Label 16632*/ GIMT_Encode4(1134126), // Rule ID 15066 //
     /* 1134051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1134054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1134062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1134065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1134068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134090 */     // MIs[0] round
     /* 1134090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134100 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1134103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1134121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134125 */     // GIR_Coverage, 15066,
     /* 1134125 */     GIR_EraseRootFromParent_Done,
     /* 1134126 */   // Label 16632: @1134126
     /* 1134126 */   GIM_Try, /*On fail goto*//*Label 16633*/ GIMT_Encode4(1134206), // Rule ID 15067 //
     /* 1134131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1134134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1134142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1134145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1134148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134170 */     // MIs[0] round
     /* 1134170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134180 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1134183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1134201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134205 */     // GIR_Coverage, 15067,
     /* 1134205 */     GIR_EraseRootFromParent_Done,
     /* 1134206 */   // Label 16633: @1134206
     /* 1134206 */   GIM_Try, /*On fail goto*//*Label 16634*/ GIMT_Encode4(1134286), // Rule ID 15070 //
     /* 1134211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1134222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1134225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1134228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134250 */     // MIs[0] round
     /* 1134250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134260 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134285 */     // GIR_Coverage, 15070,
     /* 1134285 */     GIR_EraseRootFromParent_Done,
     /* 1134286 */   // Label 16634: @1134286
     /* 1134286 */   GIM_Try, /*On fail goto*//*Label 16635*/ GIMT_Encode4(1134366), // Rule ID 15071 //
     /* 1134291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1134302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1134305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1134308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134330 */     // MIs[0] round
     /* 1134330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134340 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134365 */     // GIR_Coverage, 15071,
     /* 1134365 */     GIR_EraseRootFromParent_Done,
     /* 1134366 */   // Label 16635: @1134366
     /* 1134366 */   GIM_Try, /*On fail goto*//*Label 16636*/ GIMT_Encode4(1134446), // Rule ID 15074 //
     /* 1134371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1134382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1134385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1134388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134410 */     // MIs[0] round
     /* 1134410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134420 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134445 */     // GIR_Coverage, 15074,
     /* 1134445 */     GIR_EraseRootFromParent_Done,
     /* 1134446 */   // Label 16636: @1134446
     /* 1134446 */   GIM_Try, /*On fail goto*//*Label 16637*/ GIMT_Encode4(1134526), // Rule ID 15075 //
     /* 1134451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1134462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1134465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1134468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134490 */     // MIs[0] round
     /* 1134490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134500 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134525 */     // GIR_Coverage, 15075,
     /* 1134525 */     GIR_EraseRootFromParent_Done,
     /* 1134526 */   // Label 16637: @1134526
     /* 1134526 */   GIM_Try, /*On fail goto*//*Label 16638*/ GIMT_Encode4(1134606), // Rule ID 15078 //
     /* 1134531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1134542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1134545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1134548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134570 */     // MIs[0] round
     /* 1134570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134580 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134605 */     // GIR_Coverage, 15078,
     /* 1134605 */     GIR_EraseRootFromParent_Done,
     /* 1134606 */   // Label 16638: @1134606
     /* 1134606 */   GIM_Try, /*On fail goto*//*Label 16639*/ GIMT_Encode4(1134686), // Rule ID 15079 //
     /* 1134611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1134622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1134625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1134628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134650 */     // MIs[0] round
     /* 1134650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134660 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134685 */     // GIR_Coverage, 15079,
     /* 1134685 */     GIR_EraseRootFromParent_Done,
     /* 1134686 */   // Label 16639: @1134686
     /* 1134686 */   GIM_Try, /*On fail goto*//*Label 16640*/ GIMT_Encode4(1134766), // Rule ID 15082 //
     /* 1134691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1134702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1134705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1134708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134730 */     // MIs[0] round
     /* 1134730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134740 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134765 */     // GIR_Coverage, 15082,
     /* 1134765 */     GIR_EraseRootFromParent_Done,
     /* 1134766 */   // Label 16640: @1134766
     /* 1134766 */   GIM_Try, /*On fail goto*//*Label 16641*/ GIMT_Encode4(1134846), // Rule ID 15083 //
     /* 1134771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1134782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1134785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1134788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134810 */     // MIs[0] round
     /* 1134810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134820 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134845 */     // GIR_Coverage, 15083,
     /* 1134845 */     GIR_EraseRootFromParent_Done,
     /* 1134846 */   // Label 16641: @1134846
     /* 1134846 */   GIM_Try, /*On fail goto*//*Label 16642*/ GIMT_Encode4(1134926), // Rule ID 15086 //
     /* 1134851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1134862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1134865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1134868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134890 */     // MIs[0] round
     /* 1134890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134900 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134925 */     // GIR_Coverage, 15086,
     /* 1134925 */     GIR_EraseRootFromParent_Done,
     /* 1134926 */   // Label 16642: @1134926
     /* 1134926 */   GIM_Try, /*On fail goto*//*Label 16643*/ GIMT_Encode4(1135006), // Rule ID 15087 //
     /* 1134931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1134942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1134945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1134948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134970 */     // MIs[0] round
     /* 1134970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134980 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135005 */     // GIR_Coverage, 15087,
     /* 1135005 */     GIR_EraseRootFromParent_Done,
     /* 1135006 */   // Label 16643: @1135006
     /* 1135006 */   GIM_Try, /*On fail goto*//*Label 16644*/ GIMT_Encode4(1135086), // Rule ID 15090 //
     /* 1135011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1135022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1135025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1135028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135050 */     // MIs[0] round
     /* 1135050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135060 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135085 */     // GIR_Coverage, 15090,
     /* 1135085 */     GIR_EraseRootFromParent_Done,
     /* 1135086 */   // Label 16644: @1135086
     /* 1135086 */   GIM_Try, /*On fail goto*//*Label 16645*/ GIMT_Encode4(1135166), // Rule ID 15091 //
     /* 1135091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1135102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1135105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1135108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135130 */     // MIs[0] round
     /* 1135130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135140 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135165 */     // GIR_Coverage, 15091,
     /* 1135165 */     GIR_EraseRootFromParent_Done,
     /* 1135166 */   // Label 16645: @1135166
     /* 1135166 */   GIM_Try, /*On fail goto*//*Label 16646*/ GIMT_Encode4(1135246), // Rule ID 15094 //
     /* 1135171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1135182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1135185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1135188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135210 */     // MIs[0] round
     /* 1135210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1135223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135245 */     // GIR_Coverage, 15094,
     /* 1135245 */     GIR_EraseRootFromParent_Done,
     /* 1135246 */   // Label 16646: @1135246
     /* 1135246 */   GIM_Try, /*On fail goto*//*Label 16647*/ GIMT_Encode4(1135326), // Rule ID 15095 //
     /* 1135251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1135262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1135265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1135268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135290 */     // MIs[0] round
     /* 1135290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135300 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1135303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135325 */     // GIR_Coverage, 15095,
     /* 1135325 */     GIR_EraseRootFromParent_Done,
     /* 1135326 */   // Label 16647: @1135326
     /* 1135326 */   GIM_Try, /*On fail goto*//*Label 16648*/ GIMT_Encode4(1135406), // Rule ID 15098 //
     /* 1135331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1135342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1135345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1135348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135370 */     // MIs[0] round
     /* 1135370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135380 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135405 */     // GIR_Coverage, 15098,
     /* 1135405 */     GIR_EraseRootFromParent_Done,
     /* 1135406 */   // Label 16648: @1135406
     /* 1135406 */   GIM_Try, /*On fail goto*//*Label 16649*/ GIMT_Encode4(1135486), // Rule ID 15099 //
     /* 1135411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1135422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1135425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1135428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135450 */     // MIs[0] round
     /* 1135450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135485 */     // GIR_Coverage, 15099,
     /* 1135485 */     GIR_EraseRootFromParent_Done,
     /* 1135486 */   // Label 16649: @1135486
     /* 1135486 */   GIM_Try, /*On fail goto*//*Label 16650*/ GIMT_Encode4(1135566), // Rule ID 15102 //
     /* 1135491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1135502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1135505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1135508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135530 */     // MIs[0] round
     /* 1135530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135540 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135565 */     // GIR_Coverage, 15102,
     /* 1135565 */     GIR_EraseRootFromParent_Done,
     /* 1135566 */   // Label 16650: @1135566
     /* 1135566 */   GIM_Try, /*On fail goto*//*Label 16651*/ GIMT_Encode4(1135646), // Rule ID 15103 //
     /* 1135571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1135582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1135585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1135588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135610 */     // MIs[0] round
     /* 1135610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135620 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135645 */     // GIR_Coverage, 15103,
     /* 1135645 */     GIR_EraseRootFromParent_Done,
     /* 1135646 */   // Label 16651: @1135646
     /* 1135646 */   GIM_Try, /*On fail goto*//*Label 16652*/ GIMT_Encode4(1135726), // Rule ID 15106 //
     /* 1135651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1135662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1135665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1135668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135690 */     // MIs[0] round
     /* 1135690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135700 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1135703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135725 */     // GIR_Coverage, 15106,
     /* 1135725 */     GIR_EraseRootFromParent_Done,
     /* 1135726 */   // Label 16652: @1135726
     /* 1135726 */   GIM_Try, /*On fail goto*//*Label 16653*/ GIMT_Encode4(1135806), // Rule ID 15107 //
     /* 1135731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1135742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1135745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1135748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135770 */     // MIs[0] round
     /* 1135770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1135783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135805 */     // GIR_Coverage, 15107,
     /* 1135805 */     GIR_EraseRootFromParent_Done,
     /* 1135806 */   // Label 16653: @1135806
     /* 1135806 */   GIM_Try, /*On fail goto*//*Label 16654*/ GIMT_Encode4(1135886), // Rule ID 15110 //
     /* 1135811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1135822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1135825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1135828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135850 */     // MIs[0] round
     /* 1135850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135860 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135885 */     // GIR_Coverage, 15110,
     /* 1135885 */     GIR_EraseRootFromParent_Done,
     /* 1135886 */   // Label 16654: @1135886
     /* 1135886 */   GIM_Try, /*On fail goto*//*Label 16655*/ GIMT_Encode4(1135966), // Rule ID 15111 //
     /* 1135891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1135902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1135905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1135908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135930 */     // MIs[0] round
     /* 1135930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135940 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135965 */     // GIR_Coverage, 15111,
     /* 1135965 */     GIR_EraseRootFromParent_Done,
     /* 1135966 */   // Label 16655: @1135966
     /* 1135966 */   GIM_Try, /*On fail goto*//*Label 16656*/ GIMT_Encode4(1136046), // Rule ID 15114 //
     /* 1135971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1135982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1135985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1135988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136010 */     // MIs[0] round
     /* 1136010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136020 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1136023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1136041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136045 */     // GIR_Coverage, 15114,
     /* 1136045 */     GIR_EraseRootFromParent_Done,
     /* 1136046 */   // Label 16656: @1136046
     /* 1136046 */   GIM_Try, /*On fail goto*//*Label 16657*/ GIMT_Encode4(1136126), // Rule ID 15115 //
     /* 1136051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1136054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1136062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1136065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1136068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136090 */     // MIs[0] round
     /* 1136090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136100 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1136103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1136121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136125 */     // GIR_Coverage, 15115,
     /* 1136125 */     GIR_EraseRootFromParent_Done,
     /* 1136126 */   // Label 16657: @1136126
     /* 1136126 */   GIM_Try, /*On fail goto*//*Label 16658*/ GIMT_Encode4(1136206), // Rule ID 15118 //
     /* 1136131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1136142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1136145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1136148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1136151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136170 */     // MIs[0] round
     /* 1136170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136180 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1136183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136205 */     // GIR_Coverage, 15118,
     /* 1136205 */     GIR_EraseRootFromParent_Done,
     /* 1136206 */   // Label 16658: @1136206
     /* 1136206 */   GIM_Try, /*On fail goto*//*Label 16659*/ GIMT_Encode4(1136286), // Rule ID 15119 //
     /* 1136211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1136222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1136225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1136228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1136231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136250 */     // MIs[0] round
     /* 1136250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136260 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1136263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136285 */     // GIR_Coverage, 15119,
     /* 1136285 */     GIR_EraseRootFromParent_Done,
     /* 1136286 */   // Label 16659: @1136286
     /* 1136286 */   GIM_Try, /*On fail goto*//*Label 16660*/ GIMT_Encode4(1136366), // Rule ID 15122 //
     /* 1136291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1136302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1136305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1136308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1136311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136330 */     // MIs[0] round
     /* 1136330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136340 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1136343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136365 */     // GIR_Coverage, 15122,
     /* 1136365 */     GIR_EraseRootFromParent_Done,
     /* 1136366 */   // Label 16660: @1136366
     /* 1136366 */   GIM_Try, /*On fail goto*//*Label 16661*/ GIMT_Encode4(1136446), // Rule ID 15123 //
     /* 1136371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1136382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1136385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1136388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1136391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136410 */     // MIs[0] round
     /* 1136410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136420 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1136423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136445 */     // GIR_Coverage, 15123,
     /* 1136445 */     GIR_EraseRootFromParent_Done,
     /* 1136446 */   // Label 16661: @1136446
     /* 1136446 */   GIM_Try, /*On fail goto*//*Label 16662*/ GIMT_Encode4(1136526), // Rule ID 15126 //
     /* 1136451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1136462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1136465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1136468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1136471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136490 */     // MIs[0] round
     /* 1136490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136500 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136525 */     // GIR_Coverage, 15126,
     /* 1136525 */     GIR_EraseRootFromParent_Done,
     /* 1136526 */   // Label 16662: @1136526
     /* 1136526 */   GIM_Try, /*On fail goto*//*Label 16663*/ GIMT_Encode4(1136606), // Rule ID 15127 //
     /* 1136531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1136542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1136545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1136548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1136551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136570 */     // MIs[0] round
     /* 1136570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136580 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136605 */     // GIR_Coverage, 15127,
     /* 1136605 */     GIR_EraseRootFromParent_Done,
     /* 1136606 */   // Label 16663: @1136606
     /* 1136606 */   GIM_Try, /*On fail goto*//*Label 16664*/ GIMT_Encode4(1136686), // Rule ID 15130 //
     /* 1136611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1136622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1136625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1136628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1136631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136650 */     // MIs[0] round
     /* 1136650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136660 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1136663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136685 */     // GIR_Coverage, 15130,
     /* 1136685 */     GIR_EraseRootFromParent_Done,
     /* 1136686 */   // Label 16664: @1136686
     /* 1136686 */   GIM_Try, /*On fail goto*//*Label 16665*/ GIMT_Encode4(1136766), // Rule ID 15131 //
     /* 1136691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1136702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1136705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1136708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1136711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136730 */     // MIs[0] round
     /* 1136730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1136743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136765 */     // GIR_Coverage, 15131,
     /* 1136765 */     GIR_EraseRootFromParent_Done,
     /* 1136766 */   // Label 16665: @1136766
     /* 1136766 */   GIM_Try, /*On fail goto*//*Label 16666*/ GIMT_Encode4(1136846), // Rule ID 15134 //
     /* 1136771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1136782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1136785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1136788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1136791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136810 */     // MIs[0] round
     /* 1136810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136820 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136845 */     // GIR_Coverage, 15134,
     /* 1136845 */     GIR_EraseRootFromParent_Done,
     /* 1136846 */   // Label 16666: @1136846
     /* 1136846 */   GIM_Try, /*On fail goto*//*Label 16667*/ GIMT_Encode4(1136926), // Rule ID 15135 //
     /* 1136851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1136862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1136865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1136868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1136871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136890 */     // MIs[0] round
     /* 1136890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136900 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136925 */     // GIR_Coverage, 15135,
     /* 1136925 */     GIR_EraseRootFromParent_Done,
     /* 1136926 */   // Label 16667: @1136926
     /* 1136926 */   GIM_Try, /*On fail goto*//*Label 16668*/ GIMT_Encode4(1137006), // Rule ID 15138 //
     /* 1136931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1136942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1136945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1136951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136970 */     // MIs[0] round
     /* 1136970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136980 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137005 */     // GIR_Coverage, 15138,
     /* 1137005 */     GIR_EraseRootFromParent_Done,
     /* 1137006 */   // Label 16668: @1137006
     /* 1137006 */   GIM_Try, /*On fail goto*//*Label 16669*/ GIMT_Encode4(1137086), // Rule ID 15139 //
     /* 1137011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1137022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1137025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1137028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1137031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137050 */     // MIs[0] round
     /* 1137050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137060 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1137063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137085 */     // GIR_Coverage, 15139,
     /* 1137085 */     GIR_EraseRootFromParent_Done,
     /* 1137086 */   // Label 16669: @1137086
     /* 1137086 */   GIM_Try, /*On fail goto*//*Label 16670*/ GIMT_Encode4(1137166), // Rule ID 15142 //
     /* 1137091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1137102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1137105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1137108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1137111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137130 */     // MIs[0] round
     /* 1137130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137140 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137165 */     // GIR_Coverage, 15142,
     /* 1137165 */     GIR_EraseRootFromParent_Done,
     /* 1137166 */   // Label 16670: @1137166
     /* 1137166 */   GIM_Try, /*On fail goto*//*Label 16671*/ GIMT_Encode4(1137246), // Rule ID 15143 //
     /* 1137171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1137182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1137185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1137188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1137191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137210 */     // MIs[0] round
     /* 1137210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137245 */     // GIR_Coverage, 15143,
     /* 1137245 */     GIR_EraseRootFromParent_Done,
     /* 1137246 */   // Label 16671: @1137246
     /* 1137246 */   GIM_Try, /*On fail goto*//*Label 16672*/ GIMT_Encode4(1137326), // Rule ID 15146 //
     /* 1137251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1137262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1137265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1137268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1137271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137290 */     // MIs[0] round
     /* 1137290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137325 */     // GIR_Coverage, 15146,
     /* 1137325 */     GIR_EraseRootFromParent_Done,
     /* 1137326 */   // Label 16672: @1137326
     /* 1137326 */   GIM_Try, /*On fail goto*//*Label 16673*/ GIMT_Encode4(1137406), // Rule ID 15147 //
     /* 1137331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1137342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1137345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1137348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1137351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137370 */     // MIs[0] round
     /* 1137370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137380 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137405 */     // GIR_Coverage, 15147,
     /* 1137405 */     GIR_EraseRootFromParent_Done,
     /* 1137406 */   // Label 16673: @1137406
     /* 1137406 */   GIM_Try, /*On fail goto*//*Label 16674*/ GIMT_Encode4(1137486), // Rule ID 15150 //
     /* 1137411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1137422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1137425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1137428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1137431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137450 */     // MIs[0] round
     /* 1137450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137460 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137485 */     // GIR_Coverage, 15150,
     /* 1137485 */     GIR_EraseRootFromParent_Done,
     /* 1137486 */   // Label 16674: @1137486
     /* 1137486 */   GIM_Try, /*On fail goto*//*Label 16675*/ GIMT_Encode4(1137566), // Rule ID 15151 //
     /* 1137491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1137502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1137505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1137508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1137511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137530 */     // MIs[0] round
     /* 1137530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137565 */     // GIR_Coverage, 15151,
     /* 1137565 */     GIR_EraseRootFromParent_Done,
     /* 1137566 */   // Label 16675: @1137566
     /* 1137566 */   GIM_Try, /*On fail goto*//*Label 16676*/ GIMT_Encode4(1137646), // Rule ID 15154 //
     /* 1137571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1137574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1137582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1137585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1137588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1137591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137610 */     // MIs[0] round
     /* 1137610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137620 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137645 */     // GIR_Coverage, 15154,
     /* 1137645 */     GIR_EraseRootFromParent_Done,
     /* 1137646 */   // Label 16676: @1137646
     /* 1137646 */   GIM_Try, /*On fail goto*//*Label 16677*/ GIMT_Encode4(1137726), // Rule ID 15155 //
     /* 1137651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1137654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1137662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1137665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1137668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1137671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137690 */     // MIs[0] round
     /* 1137690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137700 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137725 */     // GIR_Coverage, 15155,
     /* 1137725 */     GIR_EraseRootFromParent_Done,
     /* 1137726 */   // Label 16677: @1137726
     /* 1137726 */   GIM_Try, /*On fail goto*//*Label 16678*/ GIMT_Encode4(1137806), // Rule ID 15158 //
     /* 1137731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1137748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1137751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137770 */     // MIs[0] round
     /* 1137770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137780 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137805 */     // GIR_Coverage, 15158,
     /* 1137805 */     GIR_EraseRootFromParent_Done,
     /* 1137806 */   // Label 16678: @1137806
     /* 1137806 */   GIM_Try, /*On fail goto*//*Label 16679*/ GIMT_Encode4(1137886), // Rule ID 15159 //
     /* 1137811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1137828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1137831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137850 */     // MIs[0] round
     /* 1137850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137860 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137885 */     // GIR_Coverage, 15159,
     /* 1137885 */     GIR_EraseRootFromParent_Done,
     /* 1137886 */   // Label 16679: @1137886
     /* 1137886 */   GIM_Try, /*On fail goto*//*Label 16680*/ GIMT_Encode4(1137966), // Rule ID 15162 //
     /* 1137891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1137902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1137905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1137908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1137911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137930 */     // MIs[0] round
     /* 1137930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137940 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1137943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137965 */     // GIR_Coverage, 15162,
     /* 1137965 */     GIR_EraseRootFromParent_Done,
     /* 1137966 */   // Label 16680: @1137966
     /* 1137966 */   GIM_Try, /*On fail goto*//*Label 16681*/ GIMT_Encode4(1138046), // Rule ID 15163 //
     /* 1137971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1137982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1137985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1137988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1137991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138010 */     // MIs[0] round
     /* 1138010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138020 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138045 */     // GIR_Coverage, 15163,
     /* 1138045 */     GIR_EraseRootFromParent_Done,
     /* 1138046 */   // Label 16681: @1138046
     /* 1138046 */   GIM_Try, /*On fail goto*//*Label 16682*/ GIMT_Encode4(1138126), // Rule ID 15166 //
     /* 1138051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1138062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1138065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1138068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1138071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138090 */     // MIs[0] round
     /* 1138090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138100 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138125 */     // GIR_Coverage, 15166,
     /* 1138125 */     GIR_EraseRootFromParent_Done,
     /* 1138126 */   // Label 16682: @1138126
     /* 1138126 */   GIM_Try, /*On fail goto*//*Label 16683*/ GIMT_Encode4(1138206), // Rule ID 15167 //
     /* 1138131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1138142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1138145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1138148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1138151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138170 */     // MIs[0] round
     /* 1138170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138180 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138205 */     // GIR_Coverage, 15167,
     /* 1138205 */     GIR_EraseRootFromParent_Done,
     /* 1138206 */   // Label 16683: @1138206
     /* 1138206 */   GIM_Try, /*On fail goto*//*Label 16684*/ GIMT_Encode4(1138286), // Rule ID 15170 //
     /* 1138211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1138222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1138225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1138228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1138231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138250 */     // MIs[0] round
     /* 1138250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138260 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138285 */     // GIR_Coverage, 15170,
     /* 1138285 */     GIR_EraseRootFromParent_Done,
     /* 1138286 */   // Label 16684: @1138286
     /* 1138286 */   GIM_Try, /*On fail goto*//*Label 16685*/ GIMT_Encode4(1138366), // Rule ID 15171 //
     /* 1138291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1138302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1138305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1138308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1138311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138330 */     // MIs[0] round
     /* 1138330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138365 */     // GIR_Coverage, 15171,
     /* 1138365 */     GIR_EraseRootFromParent_Done,
     /* 1138366 */   // Label 16685: @1138366
     /* 1138366 */   GIM_Try, /*On fail goto*//*Label 16686*/ GIMT_Encode4(1138446), // Rule ID 15174 //
     /* 1138371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1138382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1138385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1138388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1138391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138410 */     // MIs[0] round
     /* 1138410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138420 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138445 */     // GIR_Coverage, 15174,
     /* 1138445 */     GIR_EraseRootFromParent_Done,
     /* 1138446 */   // Label 16686: @1138446
     /* 1138446 */   GIM_Try, /*On fail goto*//*Label 16687*/ GIMT_Encode4(1138526), // Rule ID 15175 //
     /* 1138451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1138462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1138465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1138468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1138471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138490 */     // MIs[0] round
     /* 1138490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138500 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138525 */     // GIR_Coverage, 15175,
     /* 1138525 */     GIR_EraseRootFromParent_Done,
     /* 1138526 */   // Label 16687: @1138526
     /* 1138526 */   GIM_Try, /*On fail goto*//*Label 16688*/ GIMT_Encode4(1138606), // Rule ID 15178 //
     /* 1138531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1138542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1138545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1138548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1138551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138570 */     // MIs[0] round
     /* 1138570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138580 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138605 */     // GIR_Coverage, 15178,
     /* 1138605 */     GIR_EraseRootFromParent_Done,
     /* 1138606 */   // Label 16688: @1138606
     /* 1138606 */   GIM_Try, /*On fail goto*//*Label 16689*/ GIMT_Encode4(1138686), // Rule ID 15179 //
     /* 1138611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1138622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1138625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1138628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1138631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138650 */     // MIs[0] round
     /* 1138650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138660 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138685 */     // GIR_Coverage, 15179,
     /* 1138685 */     GIR_EraseRootFromParent_Done,
     /* 1138686 */   // Label 16689: @1138686
     /* 1138686 */   GIM_Try, /*On fail goto*//*Label 16690*/ GIMT_Encode4(1138766), // Rule ID 15182 //
     /* 1138691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1138702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1138705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1138708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1138711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138730 */     // MIs[0] round
     /* 1138730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138765 */     // GIR_Coverage, 15182,
     /* 1138765 */     GIR_EraseRootFromParent_Done,
     /* 1138766 */   // Label 16690: @1138766
     /* 1138766 */   GIM_Try, /*On fail goto*//*Label 16691*/ GIMT_Encode4(1138846), // Rule ID 15183 //
     /* 1138771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1138782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1138785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1138788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1138791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138810 */     // MIs[0] round
     /* 1138810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138820 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138845 */     // GIR_Coverage, 15183,
     /* 1138845 */     GIR_EraseRootFromParent_Done,
     /* 1138846 */   // Label 16691: @1138846
     /* 1138846 */   GIM_Try, /*On fail goto*//*Label 16692*/ GIMT_Encode4(1138926), // Rule ID 15186 //
     /* 1138851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1138862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1138865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1138868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1138871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138890 */     // MIs[0] round
     /* 1138890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138900 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138925 */     // GIR_Coverage, 15186,
     /* 1138925 */     GIR_EraseRootFromParent_Done,
     /* 1138926 */   // Label 16692: @1138926
     /* 1138926 */   GIM_Try, /*On fail goto*//*Label 16693*/ GIMT_Encode4(1139006), // Rule ID 15187 //
     /* 1138931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1138942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1138945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1138948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1138951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138970 */     // MIs[0] round
     /* 1138970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139005 */     // GIR_Coverage, 15187,
     /* 1139005 */     GIR_EraseRootFromParent_Done,
     /* 1139006 */   // Label 16693: @1139006
     /* 1139006 */   GIM_Try, /*On fail goto*//*Label 16694*/ GIMT_Encode4(1139086), // Rule ID 15190 //
     /* 1139011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1139022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1139025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1139028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1139031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139050 */     // MIs[0] round
     /* 1139050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139060 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1139063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139085 */     // GIR_Coverage, 15190,
     /* 1139085 */     GIR_EraseRootFromParent_Done,
     /* 1139086 */   // Label 16694: @1139086
     /* 1139086 */   GIM_Try, /*On fail goto*//*Label 16695*/ GIMT_Encode4(1139166), // Rule ID 15191 //
     /* 1139091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1139102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1139105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1139108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1139111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139130 */     // MIs[0] round
     /* 1139130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1139143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139165 */     // GIR_Coverage, 15191,
     /* 1139165 */     GIR_EraseRootFromParent_Done,
     /* 1139166 */   // Label 16695: @1139166
     /* 1139166 */   GIM_Try, /*On fail goto*//*Label 16696*/ GIMT_Encode4(1139246), // Rule ID 15194 //
     /* 1139171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1139182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1139185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1139188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1139191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139210 */     // MIs[0] round
     /* 1139210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1139223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139245 */     // GIR_Coverage, 15194,
     /* 1139245 */     GIR_EraseRootFromParent_Done,
     /* 1139246 */   // Label 16696: @1139246
     /* 1139246 */   GIM_Try, /*On fail goto*//*Label 16697*/ GIMT_Encode4(1139326), // Rule ID 15195 //
     /* 1139251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1139262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1139265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1139268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1139271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139290 */     // MIs[0] round
     /* 1139290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1139303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139325 */     // GIR_Coverage, 15195,
     /* 1139325 */     GIR_EraseRootFromParent_Done,
     /* 1139326 */   // Label 16697: @1139326
     /* 1139326 */   GIM_Try, /*On fail goto*//*Label 16698*/ GIMT_Encode4(1139406), // Rule ID 15198 //
     /* 1139331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1139342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1139345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1139348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1139351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139370 */     // MIs[0] round
     /* 1139370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139380 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1139383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139405 */     // GIR_Coverage, 15198,
     /* 1139405 */     GIR_EraseRootFromParent_Done,
     /* 1139406 */   // Label 16698: @1139406
     /* 1139406 */   GIM_Try, /*On fail goto*//*Label 16699*/ GIMT_Encode4(1139486), // Rule ID 15199 //
     /* 1139411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1139422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1139425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1139428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1139431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139450 */     // MIs[0] round
     /* 1139450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139460 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1139463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139485 */     // GIR_Coverage, 15199,
     /* 1139485 */     GIR_EraseRootFromParent_Done,
     /* 1139486 */   // Label 16699: @1139486
     /* 1139486 */   GIM_Try, /*On fail goto*//*Label 16700*/ GIMT_Encode4(1139566), // Rule ID 15202 //
     /* 1139491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1139502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1139505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1139508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1139511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139530 */     // MIs[0] round
     /* 1139530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139540 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1139543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139565 */     // GIR_Coverage, 15202,
     /* 1139565 */     GIR_EraseRootFromParent_Done,
     /* 1139566 */   // Label 16700: @1139566
     /* 1139566 */   GIM_Try, /*On fail goto*//*Label 16701*/ GIMT_Encode4(1139646), // Rule ID 15203 //
     /* 1139571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1139582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1139585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1139588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1139591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139610 */     // MIs[0] round
     /* 1139610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139620 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1139623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139645 */     // GIR_Coverage, 15203,
     /* 1139645 */     GIR_EraseRootFromParent_Done,
     /* 1139646 */   // Label 16701: @1139646
     /* 1139646 */   GIM_Try, /*On fail goto*//*Label 16702*/ GIMT_Encode4(1139726), // Rule ID 15206 //
     /* 1139651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1139662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1139665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1139668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139690 */     // MIs[0] round
     /* 1139690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139700 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1139703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139725 */     // GIR_Coverage, 15206,
     /* 1139725 */     GIR_EraseRootFromParent_Done,
     /* 1139726 */   // Label 16702: @1139726
     /* 1139726 */   GIM_Try, /*On fail goto*//*Label 16703*/ GIMT_Encode4(1139806), // Rule ID 15207 //
     /* 1139731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1139742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1139745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1139748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139770 */     // MIs[0] round
     /* 1139770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139780 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1139783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139805 */     // GIR_Coverage, 15207,
     /* 1139805 */     GIR_EraseRootFromParent_Done,
     /* 1139806 */   // Label 16703: @1139806
     /* 1139806 */   GIM_Try, /*On fail goto*//*Label 16704*/ GIMT_Encode4(1139886), // Rule ID 15210 //
     /* 1139811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1139822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1139825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1139828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139850 */     // MIs[0] round
     /* 1139850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139860 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139885 */     // GIR_Coverage, 15210,
     /* 1139885 */     GIR_EraseRootFromParent_Done,
     /* 1139886 */   // Label 16704: @1139886
     /* 1139886 */   GIM_Try, /*On fail goto*//*Label 16705*/ GIMT_Encode4(1139966), // Rule ID 15211 //
     /* 1139891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1139902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1139905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1139908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139930 */     // MIs[0] round
     /* 1139930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139940 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139965 */     // GIR_Coverage, 15211,
     /* 1139965 */     GIR_EraseRootFromParent_Done,
     /* 1139966 */   // Label 16705: @1139966
     /* 1139966 */   GIM_Try, /*On fail goto*//*Label 16706*/ GIMT_Encode4(1140046), // Rule ID 15214 //
     /* 1139971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1139982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1139985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1139988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140010 */     // MIs[0] round
     /* 1140010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140020 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140045 */     // GIR_Coverage, 15214,
     /* 1140045 */     GIR_EraseRootFromParent_Done,
     /* 1140046 */   // Label 16706: @1140046
     /* 1140046 */   GIM_Try, /*On fail goto*//*Label 16707*/ GIMT_Encode4(1140126), // Rule ID 15215 //
     /* 1140051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1140062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1140065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1140068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140090 */     // MIs[0] round
     /* 1140090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140100 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140125 */     // GIR_Coverage, 15215,
     /* 1140125 */     GIR_EraseRootFromParent_Done,
     /* 1140126 */   // Label 16707: @1140126
     /* 1140126 */   GIM_Try, /*On fail goto*//*Label 16708*/ GIMT_Encode4(1140206), // Rule ID 15218 //
     /* 1140131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1140142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1140145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1140148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140170 */     // MIs[0] round
     /* 1140170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140180 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1140183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140205 */     // GIR_Coverage, 15218,
     /* 1140205 */     GIR_EraseRootFromParent_Done,
     /* 1140206 */   // Label 16708: @1140206
     /* 1140206 */   GIM_Try, /*On fail goto*//*Label 16709*/ GIMT_Encode4(1140286), // Rule ID 15219 //
     /* 1140211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1140222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1140225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1140228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140250 */     // MIs[0] round
     /* 1140250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140260 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1140263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140285 */     // GIR_Coverage, 15219,
     /* 1140285 */     GIR_EraseRootFromParent_Done,
     /* 1140286 */   // Label 16709: @1140286
     /* 1140286 */   GIM_Try, /*On fail goto*//*Label 16710*/ GIMT_Encode4(1140366), // Rule ID 15222 //
     /* 1140291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1140302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1140305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1140308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140330 */     // MIs[0] round
     /* 1140330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140340 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140365 */     // GIR_Coverage, 15222,
     /* 1140365 */     GIR_EraseRootFromParent_Done,
     /* 1140366 */   // Label 16710: @1140366
     /* 1140366 */   GIM_Try, /*On fail goto*//*Label 16711*/ GIMT_Encode4(1140446), // Rule ID 15223 //
     /* 1140371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1140382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1140385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1140388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140410 */     // MIs[0] round
     /* 1140410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140420 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140445 */     // GIR_Coverage, 15223,
     /* 1140445 */     GIR_EraseRootFromParent_Done,
     /* 1140446 */   // Label 16711: @1140446
     /* 1140446 */   GIM_Try, /*On fail goto*//*Label 16712*/ GIMT_Encode4(1140526), // Rule ID 15226 //
     /* 1140451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1140462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1140465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1140468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140490 */     // MIs[0] round
     /* 1140490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140500 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140525 */     // GIR_Coverage, 15226,
     /* 1140525 */     GIR_EraseRootFromParent_Done,
     /* 1140526 */   // Label 16712: @1140526
     /* 1140526 */   GIM_Try, /*On fail goto*//*Label 16713*/ GIMT_Encode4(1140606), // Rule ID 15227 //
     /* 1140531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1140542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1140545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1140548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140570 */     // MIs[0] round
     /* 1140570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140580 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140605 */     // GIR_Coverage, 15227,
     /* 1140605 */     GIR_EraseRootFromParent_Done,
     /* 1140606 */   // Label 16713: @1140606
     /* 1140606 */   GIM_Try, /*On fail goto*//*Label 16714*/ GIMT_Encode4(1140686), // Rule ID 15230 //
     /* 1140611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1140622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1140625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1140628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140650 */     // MIs[0] round
     /* 1140650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140660 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140685 */     // GIR_Coverage, 15230,
     /* 1140685 */     GIR_EraseRootFromParent_Done,
     /* 1140686 */   // Label 16714: @1140686
     /* 1140686 */   GIM_Try, /*On fail goto*//*Label 16715*/ GIMT_Encode4(1140766), // Rule ID 15231 //
     /* 1140691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1140702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1140705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1140708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140730 */     // MIs[0] round
     /* 1140730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140765 */     // GIR_Coverage, 15231,
     /* 1140765 */     GIR_EraseRootFromParent_Done,
     /* 1140766 */   // Label 16715: @1140766
     /* 1140766 */   GIM_Try, /*On fail goto*//*Label 16716*/ GIMT_Encode4(1140846), // Rule ID 15234 //
     /* 1140771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1140782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1140785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1140788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140810 */     // MIs[0] round
     /* 1140810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140820 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140845 */     // GIR_Coverage, 15234,
     /* 1140845 */     GIR_EraseRootFromParent_Done,
     /* 1140846 */   // Label 16716: @1140846
     /* 1140846 */   GIM_Try, /*On fail goto*//*Label 16717*/ GIMT_Encode4(1140926), // Rule ID 15235 //
     /* 1140851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1140862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1140865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1140868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140890 */     // MIs[0] round
     /* 1140890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140925 */     // GIR_Coverage, 15235,
     /* 1140925 */     GIR_EraseRootFromParent_Done,
     /* 1140926 */   // Label 16717: @1140926
     /* 1140926 */   GIM_Try, /*On fail goto*//*Label 16718*/ GIMT_Encode4(1141006), // Rule ID 15238 //
     /* 1140931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1140942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1140945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1140948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140970 */     // MIs[0] round
     /* 1140970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140980 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141005 */     // GIR_Coverage, 15238,
     /* 1141005 */     GIR_EraseRootFromParent_Done,
     /* 1141006 */   // Label 16718: @1141006
     /* 1141006 */   GIM_Try, /*On fail goto*//*Label 16719*/ GIMT_Encode4(1141086), // Rule ID 15239 //
     /* 1141011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1141022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1141025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1141028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141050 */     // MIs[0] round
     /* 1141050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141060 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1141063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141085 */     // GIR_Coverage, 15239,
     /* 1141085 */     GIR_EraseRootFromParent_Done,
     /* 1141086 */   // Label 16719: @1141086
     /* 1141086 */   GIM_Try, /*On fail goto*//*Label 16720*/ GIMT_Encode4(1141166), // Rule ID 15242 //
     /* 1141091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1141094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1141102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1141105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1141108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141130 */     // MIs[0] round
     /* 1141130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1141143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141165 */     // GIR_Coverage, 15242,
     /* 1141165 */     GIR_EraseRootFromParent_Done,
     /* 1141166 */   // Label 16720: @1141166
     /* 1141166 */   GIM_Try, /*On fail goto*//*Label 16721*/ GIMT_Encode4(1141246), // Rule ID 15243 //
     /* 1141171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1141174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1141182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1141185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1141188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141210 */     // MIs[0] round
     /* 1141210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141220 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1141223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141245 */     // GIR_Coverage, 15243,
     /* 1141245 */     GIR_EraseRootFromParent_Done,
     /* 1141246 */   // Label 16721: @1141246
     /* 1141246 */   GIM_Try, /*On fail goto*//*Label 16722*/ GIMT_Encode4(1141326), // Rule ID 15246 //
     /* 1141251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1141262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1141265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1141268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141290 */     // MIs[0] round
     /* 1141290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141300 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141325 */     // GIR_Coverage, 15246,
     /* 1141325 */     GIR_EraseRootFromParent_Done,
     /* 1141326 */   // Label 16722: @1141326
     /* 1141326 */   GIM_Try, /*On fail goto*//*Label 16723*/ GIMT_Encode4(1141406), // Rule ID 15247 //
     /* 1141331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1141342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1141345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1141348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141370 */     // MIs[0] round
     /* 1141370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141380 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141405 */     // GIR_Coverage, 15247,
     /* 1141405 */     GIR_EraseRootFromParent_Done,
     /* 1141406 */   // Label 16723: @1141406
     /* 1141406 */   GIM_Try, /*On fail goto*//*Label 16724*/ GIMT_Encode4(1141486), // Rule ID 15250 //
     /* 1141411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1141422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1141425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1141428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141450 */     // MIs[0] round
     /* 1141450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141460 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141485 */     // GIR_Coverage, 15250,
     /* 1141485 */     GIR_EraseRootFromParent_Done,
     /* 1141486 */   // Label 16724: @1141486
     /* 1141486 */   GIM_Try, /*On fail goto*//*Label 16725*/ GIMT_Encode4(1141566), // Rule ID 15251 //
     /* 1141491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1141502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1141505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1141508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141530 */     // MIs[0] round
     /* 1141530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141565 */     // GIR_Coverage, 15251,
     /* 1141565 */     GIR_EraseRootFromParent_Done,
     /* 1141566 */   // Label 16725: @1141566
     /* 1141566 */   GIM_Try, /*On fail goto*//*Label 16726*/ GIMT_Encode4(1141646), // Rule ID 15254 //
     /* 1141571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1141582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1141585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1141588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141610 */     // MIs[0] round
     /* 1141610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141620 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141645 */     // GIR_Coverage, 15254,
     /* 1141645 */     GIR_EraseRootFromParent_Done,
     /* 1141646 */   // Label 16726: @1141646
     /* 1141646 */   GIM_Try, /*On fail goto*//*Label 16727*/ GIMT_Encode4(1141726), // Rule ID 15255 //
     /* 1141651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1141662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1141665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1141668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141690 */     // MIs[0] round
     /* 1141690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141700 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141725 */     // GIR_Coverage, 15255,
     /* 1141725 */     GIR_EraseRootFromParent_Done,
     /* 1141726 */   // Label 16727: @1141726
     /* 1141726 */   GIM_Try, /*On fail goto*//*Label 16728*/ GIMT_Encode4(1141806), // Rule ID 15258 //
     /* 1141731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1141742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1141745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1141748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141770 */     // MIs[0] round
     /* 1141770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141780 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141805 */     // GIR_Coverage, 15258,
     /* 1141805 */     GIR_EraseRootFromParent_Done,
     /* 1141806 */   // Label 16728: @1141806
     /* 1141806 */   GIM_Try, /*On fail goto*//*Label 16729*/ GIMT_Encode4(1141886), // Rule ID 15259 //
     /* 1141811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1141822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1141825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1141828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141850 */     // MIs[0] round
     /* 1141850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141860 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141885 */     // GIR_Coverage, 15259,
     /* 1141885 */     GIR_EraseRootFromParent_Done,
     /* 1141886 */   // Label 16729: @1141886
     /* 1141886 */   GIM_Try, /*On fail goto*//*Label 16730*/ GIMT_Encode4(1141966), // Rule ID 15262 //
     /* 1141891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1141902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1141905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1141908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141930 */     // MIs[0] round
     /* 1141930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141940 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141965 */     // GIR_Coverage, 15262,
     /* 1141965 */     GIR_EraseRootFromParent_Done,
     /* 1141966 */   // Label 16730: @1141966
     /* 1141966 */   GIM_Try, /*On fail goto*//*Label 16731*/ GIMT_Encode4(1142046), // Rule ID 15263 //
     /* 1141971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1141982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1141985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1141988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142010 */     // MIs[0] round
     /* 1142010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142020 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142045 */     // GIR_Coverage, 15263,
     /* 1142045 */     GIR_EraseRootFromParent_Done,
     /* 1142046 */   // Label 16731: @1142046
     /* 1142046 */   GIM_Try, /*On fail goto*//*Label 16732*/ GIMT_Encode4(1142126), // Rule ID 15266 //
     /* 1142051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1142062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1142065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1142068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142090 */     // MIs[0] round
     /* 1142090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142100 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142125 */     // GIR_Coverage, 15266,
     /* 1142125 */     GIR_EraseRootFromParent_Done,
     /* 1142126 */   // Label 16732: @1142126
     /* 1142126 */   GIM_Try, /*On fail goto*//*Label 16733*/ GIMT_Encode4(1142206), // Rule ID 15267 //
     /* 1142131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1142142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1142145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1142148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142170 */     // MIs[0] round
     /* 1142170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142180 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142205 */     // GIR_Coverage, 15267,
     /* 1142205 */     GIR_EraseRootFromParent_Done,
     /* 1142206 */   // Label 16733: @1142206
     /* 1142206 */   GIM_Try, /*On fail goto*//*Label 16734*/ GIMT_Encode4(1142286), // Rule ID 15270 //
     /* 1142211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1142222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1142225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1142228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142250 */     // MIs[0] round
     /* 1142250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142285 */     // GIR_Coverage, 15270,
     /* 1142285 */     GIR_EraseRootFromParent_Done,
     /* 1142286 */   // Label 16734: @1142286
     /* 1142286 */   GIM_Try, /*On fail goto*//*Label 16735*/ GIMT_Encode4(1142366), // Rule ID 15271 //
     /* 1142291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1142302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1142305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1142308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142330 */     // MIs[0] round
     /* 1142330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142365 */     // GIR_Coverage, 15271,
     /* 1142365 */     GIR_EraseRootFromParent_Done,
     /* 1142366 */   // Label 16735: @1142366
     /* 1142366 */   GIM_Try, /*On fail goto*//*Label 16736*/ GIMT_Encode4(1142446), // Rule ID 15274 //
     /* 1142371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1142382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1142385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1142388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142410 */     // MIs[0] round
     /* 1142410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142420 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142445 */     // GIR_Coverage, 15274,
     /* 1142445 */     GIR_EraseRootFromParent_Done,
     /* 1142446 */   // Label 16736: @1142446
     /* 1142446 */   GIM_Try, /*On fail goto*//*Label 16737*/ GIMT_Encode4(1142526), // Rule ID 15275 //
     /* 1142451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1142462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1142465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1142468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142490 */     // MIs[0] round
     /* 1142490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142525 */     // GIR_Coverage, 15275,
     /* 1142525 */     GIR_EraseRootFromParent_Done,
     /* 1142526 */   // Label 16737: @1142526
     /* 1142526 */   GIM_Try, /*On fail goto*//*Label 16738*/ GIMT_Encode4(1142606), // Rule ID 15278 //
     /* 1142531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1142542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1142545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1142548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142570 */     // MIs[0] round
     /* 1142570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142605 */     // GIR_Coverage, 15278,
     /* 1142605 */     GIR_EraseRootFromParent_Done,
     /* 1142606 */   // Label 16738: @1142606
     /* 1142606 */   GIM_Try, /*On fail goto*//*Label 16739*/ GIMT_Encode4(1142686), // Rule ID 15279 //
     /* 1142611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1142622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1142625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1142628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142650 */     // MIs[0] round
     /* 1142650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142660 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142685 */     // GIR_Coverage, 15279,
     /* 1142685 */     GIR_EraseRootFromParent_Done,
     /* 1142686 */   // Label 16739: @1142686
     /* 1142686 */   GIM_Try, /*On fail goto*//*Label 16740*/ GIMT_Encode4(1142766), // Rule ID 15282 //
     /* 1142691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1142702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1142705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1142708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142730 */     // MIs[0] round
     /* 1142730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142740 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142765 */     // GIR_Coverage, 15282,
     /* 1142765 */     GIR_EraseRootFromParent_Done,
     /* 1142766 */   // Label 16740: @1142766
     /* 1142766 */   GIM_Try, /*On fail goto*//*Label 16741*/ GIMT_Encode4(1142846), // Rule ID 15283 //
     /* 1142771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1142782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1142785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1142788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142810 */     // MIs[0] round
     /* 1142810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142820 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142845 */     // GIR_Coverage, 15283,
     /* 1142845 */     GIR_EraseRootFromParent_Done,
     /* 1142846 */   // Label 16741: @1142846
     /* 1142846 */   GIM_Try, /*On fail goto*//*Label 16742*/ GIMT_Encode4(1142926), // Rule ID 15286 //
     /* 1142851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1142862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1142865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1142868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142890 */     // MIs[0] round
     /* 1142890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142900 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142925 */     // GIR_Coverage, 15286,
     /* 1142925 */     GIR_EraseRootFromParent_Done,
     /* 1142926 */   // Label 16742: @1142926
     /* 1142926 */   GIM_Try, /*On fail goto*//*Label 16743*/ GIMT_Encode4(1143006), // Rule ID 15287 //
     /* 1142931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1142942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1142945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1142948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142970 */     // MIs[0] round
     /* 1142970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1143001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143005 */     // GIR_Coverage, 15287,
     /* 1143005 */     GIR_EraseRootFromParent_Done,
     /* 1143006 */   // Label 16743: @1143006
     /* 1143006 */   GIM_Try, /*On fail goto*//*Label 16744*/ GIMT_Encode4(1143086), // Rule ID 15290 //
     /* 1143011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1143014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1143022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1143025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1143028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143050 */     // MIs[0] round
     /* 1143050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143060 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1143063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1143081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143085 */     // GIR_Coverage, 15290,
     /* 1143085 */     GIR_EraseRootFromParent_Done,
     /* 1143086 */   // Label 16744: @1143086
     /* 1143086 */   GIM_Try, /*On fail goto*//*Label 16745*/ GIMT_Encode4(1143166), // Rule ID 15291 //
     /* 1143091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1143094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1143102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1143105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1143108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143130 */     // MIs[0] round
     /* 1143130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143140 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1143143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1143161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143165 */     // GIR_Coverage, 15291,
     /* 1143165 */     GIR_EraseRootFromParent_Done,
     /* 1143166 */   // Label 16745: @1143166
     /* 1143166 */   GIM_Try, /*On fail goto*//*Label 16746*/ GIMT_Encode4(1143246), // Rule ID 15294 //
     /* 1143171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1143182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1143185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1143188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1143191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143210 */     // MIs[0] round
     /* 1143210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143220 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1143223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143245 */     // GIR_Coverage, 15294,
     /* 1143245 */     GIR_EraseRootFromParent_Done,
     /* 1143246 */   // Label 16746: @1143246
     /* 1143246 */   GIM_Try, /*On fail goto*//*Label 16747*/ GIMT_Encode4(1143326), // Rule ID 15295 //
     /* 1143251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1143262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1143265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1143268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1143271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143290 */     // MIs[0] round
     /* 1143290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143300 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1143303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143325 */     // GIR_Coverage, 15295,
     /* 1143325 */     GIR_EraseRootFromParent_Done,
     /* 1143326 */   // Label 16747: @1143326
     /* 1143326 */   GIM_Try, /*On fail goto*//*Label 16748*/ GIMT_Encode4(1143406), // Rule ID 15298 //
     /* 1143331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1143342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1143345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1143348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1143351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143370 */     // MIs[0] round
     /* 1143370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143380 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143405 */     // GIR_Coverage, 15298,
     /* 1143405 */     GIR_EraseRootFromParent_Done,
     /* 1143406 */   // Label 16748: @1143406
     /* 1143406 */   GIM_Try, /*On fail goto*//*Label 16749*/ GIMT_Encode4(1143486), // Rule ID 15299 //
     /* 1143411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1143422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1143425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1143428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1143431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143450 */     // MIs[0] round
     /* 1143450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143460 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143485 */     // GIR_Coverage, 15299,
     /* 1143485 */     GIR_EraseRootFromParent_Done,
     /* 1143486 */   // Label 16749: @1143486
     /* 1143486 */   GIM_Try, /*On fail goto*//*Label 16750*/ GIMT_Encode4(1143566), // Rule ID 15302 //
     /* 1143491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1143502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1143505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1143508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1143511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143530 */     // MIs[0] round
     /* 1143530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143540 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143565 */     // GIR_Coverage, 15302,
     /* 1143565 */     GIR_EraseRootFromParent_Done,
     /* 1143566 */   // Label 16750: @1143566
     /* 1143566 */   GIM_Try, /*On fail goto*//*Label 16751*/ GIMT_Encode4(1143646), // Rule ID 15303 //
     /* 1143571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1143582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1143585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1143588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1143591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143610 */     // MIs[0] round
     /* 1143610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143620 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143645 */     // GIR_Coverage, 15303,
     /* 1143645 */     GIR_EraseRootFromParent_Done,
     /* 1143646 */   // Label 16751: @1143646
     /* 1143646 */   GIM_Try, /*On fail goto*//*Label 16752*/ GIMT_Encode4(1143726), // Rule ID 15306 //
     /* 1143651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1143662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1143665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1143668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1143671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143690 */     // MIs[0] round
     /* 1143690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143700 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143725 */     // GIR_Coverage, 15306,
     /* 1143725 */     GIR_EraseRootFromParent_Done,
     /* 1143726 */   // Label 16752: @1143726
     /* 1143726 */   GIM_Try, /*On fail goto*//*Label 16753*/ GIMT_Encode4(1143806), // Rule ID 15307 //
     /* 1143731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1143742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1143745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1143748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1143751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143770 */     // MIs[0] round
     /* 1143770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143780 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143805 */     // GIR_Coverage, 15307,
     /* 1143805 */     GIR_EraseRootFromParent_Done,
     /* 1143806 */   // Label 16753: @1143806
     /* 1143806 */   GIM_Try, /*On fail goto*//*Label 16754*/ GIMT_Encode4(1143886), // Rule ID 15310 //
     /* 1143811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1143822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1143825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1143828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1143831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143850 */     // MIs[0] round
     /* 1143850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143885 */     // GIR_Coverage, 15310,
     /* 1143885 */     GIR_EraseRootFromParent_Done,
     /* 1143886 */   // Label 16754: @1143886
     /* 1143886 */   GIM_Try, /*On fail goto*//*Label 16755*/ GIMT_Encode4(1143966), // Rule ID 15311 //
     /* 1143891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1143902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1143905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1143908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1143911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143930 */     // MIs[0] round
     /* 1143930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143940 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143965 */     // GIR_Coverage, 15311,
     /* 1143965 */     GIR_EraseRootFromParent_Done,
     /* 1143966 */   // Label 16755: @1143966
     /* 1143966 */   GIM_Try, /*On fail goto*//*Label 16756*/ GIMT_Encode4(1144046), // Rule ID 15314 //
     /* 1143971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1143982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1143985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1143988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1143991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144010 */     // MIs[0] round
     /* 1144010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144020 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1144023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144045 */     // GIR_Coverage, 15314,
     /* 1144045 */     GIR_EraseRootFromParent_Done,
     /* 1144046 */   // Label 16756: @1144046
     /* 1144046 */   GIM_Try, /*On fail goto*//*Label 16757*/ GIMT_Encode4(1144126), // Rule ID 15315 //
     /* 1144051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1144062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1144065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1144068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1144071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144090 */     // MIs[0] round
     /* 1144090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144100 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1144103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144125 */     // GIR_Coverage, 15315,
     /* 1144125 */     GIR_EraseRootFromParent_Done,
     /* 1144126 */   // Label 16757: @1144126
     /* 1144126 */   GIM_Try, /*On fail goto*//*Label 16758*/ GIMT_Encode4(1144206), // Rule ID 15318 //
     /* 1144131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1144142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1144145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1144148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1144151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144170 */     // MIs[0] round
     /* 1144170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144180 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144205 */     // GIR_Coverage, 15318,
     /* 1144205 */     GIR_EraseRootFromParent_Done,
     /* 1144206 */   // Label 16758: @1144206
     /* 1144206 */   GIM_Try, /*On fail goto*//*Label 16759*/ GIMT_Encode4(1144286), // Rule ID 15319 //
     /* 1144211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1144222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1144225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1144228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1144231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144250 */     // MIs[0] round
     /* 1144250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144260 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144285 */     // GIR_Coverage, 15319,
     /* 1144285 */     GIR_EraseRootFromParent_Done,
     /* 1144286 */   // Label 16759: @1144286
     /* 1144286 */   GIM_Try, /*On fail goto*//*Label 16760*/ GIMT_Encode4(1144366), // Rule ID 15322 //
     /* 1144291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1144302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1144305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1144308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1144311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144330 */     // MIs[0] round
     /* 1144330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144340 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144365 */     // GIR_Coverage, 15322,
     /* 1144365 */     GIR_EraseRootFromParent_Done,
     /* 1144366 */   // Label 16760: @1144366
     /* 1144366 */   GIM_Try, /*On fail goto*//*Label 16761*/ GIMT_Encode4(1144446), // Rule ID 15323 //
     /* 1144371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1144382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1144385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1144388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1144391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144410 */     // MIs[0] round
     /* 1144410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144445 */     // GIR_Coverage, 15323,
     /* 1144445 */     GIR_EraseRootFromParent_Done,
     /* 1144446 */   // Label 16761: @1144446
     /* 1144446 */   GIM_Try, /*On fail goto*//*Label 16762*/ GIMT_Encode4(1144526), // Rule ID 15326 //
     /* 1144451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1144462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1144465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1144468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1144471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144490 */     // MIs[0] round
     /* 1144490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144525 */     // GIR_Coverage, 15326,
     /* 1144525 */     GIR_EraseRootFromParent_Done,
     /* 1144526 */   // Label 16762: @1144526
     /* 1144526 */   GIM_Try, /*On fail goto*//*Label 16763*/ GIMT_Encode4(1144606), // Rule ID 15327 //
     /* 1144531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1144542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1144545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1144548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1144551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144570 */     // MIs[0] round
     /* 1144570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144580 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144605 */     // GIR_Coverage, 15327,
     /* 1144605 */     GIR_EraseRootFromParent_Done,
     /* 1144606 */   // Label 16763: @1144606
     /* 1144606 */   GIM_Try, /*On fail goto*//*Label 16764*/ GIMT_Encode4(1144686), // Rule ID 15330 //
     /* 1144611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1144614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1144622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1144625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1144628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1144631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144650 */     // MIs[0] round
     /* 1144650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144685 */     // GIR_Coverage, 15330,
     /* 1144685 */     GIR_EraseRootFromParent_Done,
     /* 1144686 */   // Label 16764: @1144686
     /* 1144686 */   GIM_Try, /*On fail goto*//*Label 16765*/ GIMT_Encode4(1144766), // Rule ID 15331 //
     /* 1144691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1144694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1144702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1144705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1144708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1144711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144730 */     // MIs[0] round
     /* 1144730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144740 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144765 */     // GIR_Coverage, 15331,
     /* 1144765 */     GIR_EraseRootFromParent_Done,
     /* 1144766 */   // Label 16765: @1144766
     /* 1144766 */   GIM_Try, /*On fail goto*//*Label 16766*/ GIMT_Encode4(1144846), // Rule ID 15334 //
     /* 1144771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1144782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1144785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1144788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1144791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144810 */     // MIs[0] round
     /* 1144810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144820 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144845 */     // GIR_Coverage, 15334,
     /* 1144845 */     GIR_EraseRootFromParent_Done,
     /* 1144846 */   // Label 16766: @1144846
     /* 1144846 */   GIM_Try, /*On fail goto*//*Label 16767*/ GIMT_Encode4(1144926), // Rule ID 15335 //
     /* 1144851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1144862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1144865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1144868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1144871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144890 */     // MIs[0] round
     /* 1144890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144900 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144925 */     // GIR_Coverage, 15335,
     /* 1144925 */     GIR_EraseRootFromParent_Done,
     /* 1144926 */   // Label 16767: @1144926
     /* 1144926 */   GIM_Try, /*On fail goto*//*Label 16768*/ GIMT_Encode4(1145006), // Rule ID 15338 //
     /* 1144931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1144942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1144945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1144948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1144951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144970 */     // MIs[0] round
     /* 1144970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144980 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1144983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145005 */     // GIR_Coverage, 15338,
     /* 1145005 */     GIR_EraseRootFromParent_Done,
     /* 1145006 */   // Label 16768: @1145006
     /* 1145006 */   GIM_Try, /*On fail goto*//*Label 16769*/ GIMT_Encode4(1145086), // Rule ID 15339 //
     /* 1145011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1145022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1145025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1145028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1145031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145050 */     // MIs[0] round
     /* 1145050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145060 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145085 */     // GIR_Coverage, 15339,
     /* 1145085 */     GIR_EraseRootFromParent_Done,
     /* 1145086 */   // Label 16769: @1145086
     /* 1145086 */   GIM_Try, /*On fail goto*//*Label 16770*/ GIMT_Encode4(1145166), // Rule ID 15342 //
     /* 1145091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1145102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1145105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1145108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1145111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145130 */     // MIs[0] round
     /* 1145130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145140 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145165 */     // GIR_Coverage, 15342,
     /* 1145165 */     GIR_EraseRootFromParent_Done,
     /* 1145166 */   // Label 16770: @1145166
     /* 1145166 */   GIM_Try, /*On fail goto*//*Label 16771*/ GIMT_Encode4(1145246), // Rule ID 15343 //
     /* 1145171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1145182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1145185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1145188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1145191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145210 */     // MIs[0] round
     /* 1145210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145220 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145245 */     // GIR_Coverage, 15343,
     /* 1145245 */     GIR_EraseRootFromParent_Done,
     /* 1145246 */   // Label 16771: @1145246
     /* 1145246 */   GIM_Try, /*On fail goto*//*Label 16772*/ GIMT_Encode4(1145326), // Rule ID 15346 //
     /* 1145251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1145262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1145265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1145268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1145271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145290 */     // MIs[0] round
     /* 1145290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145300 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145325 */     // GIR_Coverage, 15346,
     /* 1145325 */     GIR_EraseRootFromParent_Done,
     /* 1145326 */   // Label 16772: @1145326
     /* 1145326 */   GIM_Try, /*On fail goto*//*Label 16773*/ GIMT_Encode4(1145406), // Rule ID 15347 //
     /* 1145331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1145342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1145345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1145348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1145351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145370 */     // MIs[0] round
     /* 1145370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145380 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145405 */     // GIR_Coverage, 15347,
     /* 1145405 */     GIR_EraseRootFromParent_Done,
     /* 1145406 */   // Label 16773: @1145406
     /* 1145406 */   GIM_Try, /*On fail goto*//*Label 16774*/ GIMT_Encode4(1145486), // Rule ID 15350 //
     /* 1145411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1145422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1145425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1145428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1145431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145450 */     // MIs[0] round
     /* 1145450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145485 */     // GIR_Coverage, 15350,
     /* 1145485 */     GIR_EraseRootFromParent_Done,
     /* 1145486 */   // Label 16774: @1145486
     /* 1145486 */   GIM_Try, /*On fail goto*//*Label 16775*/ GIMT_Encode4(1145566), // Rule ID 15351 //
     /* 1145491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1145502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1145505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1145508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1145511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145530 */     // MIs[0] round
     /* 1145530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145540 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145565 */     // GIR_Coverage, 15351,
     /* 1145565 */     GIR_EraseRootFromParent_Done,
     /* 1145566 */   // Label 16775: @1145566
     /* 1145566 */   GIM_Try, /*On fail goto*//*Label 16776*/ GIMT_Encode4(1145646), // Rule ID 15354 //
     /* 1145571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1145582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1145585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1145588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1145591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145610 */     // MIs[0] round
     /* 1145610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145620 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145645 */     // GIR_Coverage, 15354,
     /* 1145645 */     GIR_EraseRootFromParent_Done,
     /* 1145646 */   // Label 16776: @1145646
     /* 1145646 */   GIM_Try, /*On fail goto*//*Label 16777*/ GIMT_Encode4(1145726), // Rule ID 15355 //
     /* 1145651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1145662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1145665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1145668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1145671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145690 */     // MIs[0] round
     /* 1145690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145700 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145725 */     // GIR_Coverage, 15355,
     /* 1145725 */     GIR_EraseRootFromParent_Done,
     /* 1145726 */   // Label 16777: @1145726
     /* 1145726 */   GIM_Try, /*On fail goto*//*Label 16778*/ GIMT_Encode4(1145806), // Rule ID 15358 //
     /* 1145731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1145742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1145745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1145748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1145751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145770 */     // MIs[0] round
     /* 1145770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145805 */     // GIR_Coverage, 15358,
     /* 1145805 */     GIR_EraseRootFromParent_Done,
     /* 1145806 */   // Label 16778: @1145806
     /* 1145806 */   GIM_Try, /*On fail goto*//*Label 16779*/ GIMT_Encode4(1145886), // Rule ID 15359 //
     /* 1145811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1145822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1145825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1145828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1145831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145850 */     // MIs[0] round
     /* 1145850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145885 */     // GIR_Coverage, 15359,
     /* 1145885 */     GIR_EraseRootFromParent_Done,
     /* 1145886 */   // Label 16779: @1145886
     /* 1145886 */   GIM_Try, /*On fail goto*//*Label 16780*/ GIMT_Encode4(1145966), // Rule ID 15362 //
     /* 1145891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1145902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1145905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1145908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1145911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145930 */     // MIs[0] round
     /* 1145930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145940 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145965 */     // GIR_Coverage, 15362,
     /* 1145965 */     GIR_EraseRootFromParent_Done,
     /* 1145966 */   // Label 16780: @1145966
     /* 1145966 */   GIM_Try, /*On fail goto*//*Label 16781*/ GIMT_Encode4(1146046), // Rule ID 15363 //
     /* 1145971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1145982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1145985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1145988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1145991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146010 */     // MIs[0] round
     /* 1146010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146020 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1146023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146045 */     // GIR_Coverage, 15363,
     /* 1146045 */     GIR_EraseRootFromParent_Done,
     /* 1146046 */   // Label 16781: @1146046
     /* 1146046 */   GIM_Try, /*On fail goto*//*Label 16782*/ GIMT_Encode4(1146126), // Rule ID 15366 //
     /* 1146051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1146062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1146065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1146068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1146071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146090 */     // MIs[0] round
     /* 1146090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1146103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146125 */     // GIR_Coverage, 15366,
     /* 1146125 */     GIR_EraseRootFromParent_Done,
     /* 1146126 */   // Label 16782: @1146126
     /* 1146126 */   GIM_Try, /*On fail goto*//*Label 16783*/ GIMT_Encode4(1146206), // Rule ID 15367 //
     /* 1146131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1146142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1146145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1146148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1146151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146170 */     // MIs[0] round
     /* 1146170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146180 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1146183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146205 */     // GIR_Coverage, 15367,
     /* 1146205 */     GIR_EraseRootFromParent_Done,
     /* 1146206 */   // Label 16783: @1146206
     /* 1146206 */   GIM_Try, /*On fail goto*//*Label 16784*/ GIMT_Encode4(1146286), // Rule ID 15370 //
     /* 1146211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1146222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1146225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1146228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1146231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146250 */     // MIs[0] round
     /* 1146250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146260 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1146263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146285 */     // GIR_Coverage, 15370,
     /* 1146285 */     GIR_EraseRootFromParent_Done,
     /* 1146286 */   // Label 16784: @1146286
     /* 1146286 */   GIM_Try, /*On fail goto*//*Label 16785*/ GIMT_Encode4(1146366), // Rule ID 15371 //
     /* 1146291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1146302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1146305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1146308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1146311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146330 */     // MIs[0] round
     /* 1146330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1146343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146365 */     // GIR_Coverage, 15371,
     /* 1146365 */     GIR_EraseRootFromParent_Done,
     /* 1146366 */   // Label 16785: @1146366
     /* 1146366 */   GIM_Try, /*On fail goto*//*Label 16786*/ GIMT_Encode4(1146446), // Rule ID 15374 //
     /* 1146371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1146382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1146385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1146388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1146391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146410 */     // MIs[0] round
     /* 1146410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146420 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1146423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146445 */     // GIR_Coverage, 15374,
     /* 1146445 */     GIR_EraseRootFromParent_Done,
     /* 1146446 */   // Label 16786: @1146446
     /* 1146446 */   GIM_Try, /*On fail goto*//*Label 16787*/ GIMT_Encode4(1146526), // Rule ID 15375 //
     /* 1146451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1146462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1146465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1146468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1146471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146490 */     // MIs[0] round
     /* 1146490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146500 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1146503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146525 */     // GIR_Coverage, 15375,
     /* 1146525 */     GIR_EraseRootFromParent_Done,
     /* 1146526 */   // Label 16787: @1146526
     /* 1146526 */   GIM_Try, /*On fail goto*//*Label 16788*/ GIMT_Encode4(1146606), // Rule ID 15378 //
     /* 1146531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1146542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1146545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1146548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1146551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146570 */     // MIs[0] round
     /* 1146570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146580 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1146583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146605 */     // GIR_Coverage, 15378,
     /* 1146605 */     GIR_EraseRootFromParent_Done,
     /* 1146606 */   // Label 16788: @1146606
     /* 1146606 */   GIM_Try, /*On fail goto*//*Label 16789*/ GIMT_Encode4(1146686), // Rule ID 15379 //
     /* 1146611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1146622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1146625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1146628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1146631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146650 */     // MIs[0] round
     /* 1146650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146660 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1146663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146685 */     // GIR_Coverage, 15379,
     /* 1146685 */     GIR_EraseRootFromParent_Done,
     /* 1146686 */   // Label 16789: @1146686
     /* 1146686 */   GIM_Try, /*On fail goto*//*Label 16790*/ GIMT_Encode4(1146766), // Rule ID 15382 //
     /* 1146691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1146702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1146705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1146708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146730 */     // MIs[0] round
     /* 1146730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146740 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1146743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146765 */     // GIR_Coverage, 15382,
     /* 1146765 */     GIR_EraseRootFromParent_Done,
     /* 1146766 */   // Label 16790: @1146766
     /* 1146766 */   GIM_Try, /*On fail goto*//*Label 16791*/ GIMT_Encode4(1146846), // Rule ID 15383 //
     /* 1146771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1146782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1146785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1146788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146810 */     // MIs[0] round
     /* 1146810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146820 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1146823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146845 */     // GIR_Coverage, 15383,
     /* 1146845 */     GIR_EraseRootFromParent_Done,
     /* 1146846 */   // Label 16791: @1146846
     /* 1146846 */   GIM_Try, /*On fail goto*//*Label 16792*/ GIMT_Encode4(1146926), // Rule ID 15386 //
     /* 1146851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1146862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1146865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1146868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146890 */     // MIs[0] round
     /* 1146890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146900 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146925 */     // GIR_Coverage, 15386,
     /* 1146925 */     GIR_EraseRootFromParent_Done,
     /* 1146926 */   // Label 16792: @1146926
     /* 1146926 */   GIM_Try, /*On fail goto*//*Label 16793*/ GIMT_Encode4(1147006), // Rule ID 15387 //
     /* 1146931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1146942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1146945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1146948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146970 */     // MIs[0] round
     /* 1146970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146980 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147005 */     // GIR_Coverage, 15387,
     /* 1147005 */     GIR_EraseRootFromParent_Done,
     /* 1147006 */   // Label 16793: @1147006
     /* 1147006 */   GIM_Try, /*On fail goto*//*Label 16794*/ GIMT_Encode4(1147086), // Rule ID 15390 //
     /* 1147011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1147022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1147025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1147028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147050 */     // MIs[0] round
     /* 1147050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147060 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147085 */     // GIR_Coverage, 15390,
     /* 1147085 */     GIR_EraseRootFromParent_Done,
     /* 1147086 */   // Label 16794: @1147086
     /* 1147086 */   GIM_Try, /*On fail goto*//*Label 16795*/ GIMT_Encode4(1147166), // Rule ID 15391 //
     /* 1147091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1147102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1147105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1147108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147130 */     // MIs[0] round
     /* 1147130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147140 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147165 */     // GIR_Coverage, 15391,
     /* 1147165 */     GIR_EraseRootFromParent_Done,
     /* 1147166 */   // Label 16795: @1147166
     /* 1147166 */   GIM_Try, /*On fail goto*//*Label 16796*/ GIMT_Encode4(1147246), // Rule ID 15394 //
     /* 1147171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1147182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1147185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1147188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147210 */     // MIs[0] round
     /* 1147210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147220 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1147223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147245 */     // GIR_Coverage, 15394,
     /* 1147245 */     GIR_EraseRootFromParent_Done,
     /* 1147246 */   // Label 16796: @1147246
     /* 1147246 */   GIM_Try, /*On fail goto*//*Label 16797*/ GIMT_Encode4(1147326), // Rule ID 15395 //
     /* 1147251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1147262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1147265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1147268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147290 */     // MIs[0] round
     /* 1147290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147300 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1147303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147325 */     // GIR_Coverage, 15395,
     /* 1147325 */     GIR_EraseRootFromParent_Done,
     /* 1147326 */   // Label 16797: @1147326
     /* 1147326 */   GIM_Try, /*On fail goto*//*Label 16798*/ GIMT_Encode4(1147406), // Rule ID 15398 //
     /* 1147331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1147342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1147345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1147348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147370 */     // MIs[0] round
     /* 1147370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147380 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147405 */     // GIR_Coverage, 15398,
     /* 1147405 */     GIR_EraseRootFromParent_Done,
     /* 1147406 */   // Label 16798: @1147406
     /* 1147406 */   GIM_Try, /*On fail goto*//*Label 16799*/ GIMT_Encode4(1147486), // Rule ID 15399 //
     /* 1147411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1147422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1147425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1147428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147450 */     // MIs[0] round
     /* 1147450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147460 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147485 */     // GIR_Coverage, 15399,
     /* 1147485 */     GIR_EraseRootFromParent_Done,
     /* 1147486 */   // Label 16799: @1147486
     /* 1147486 */   GIM_Try, /*On fail goto*//*Label 16800*/ GIMT_Encode4(1147566), // Rule ID 15402 //
     /* 1147491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1147502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1147505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1147508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147530 */     // MIs[0] round
     /* 1147530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147540 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147565 */     // GIR_Coverage, 15402,
     /* 1147565 */     GIR_EraseRootFromParent_Done,
     /* 1147566 */   // Label 16800: @1147566
     /* 1147566 */   GIM_Try, /*On fail goto*//*Label 16801*/ GIMT_Encode4(1147646), // Rule ID 15403 //
     /* 1147571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1147582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1147585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1147588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147610 */     // MIs[0] round
     /* 1147610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147620 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147645 */     // GIR_Coverage, 15403,
     /* 1147645 */     GIR_EraseRootFromParent_Done,
     /* 1147646 */   // Label 16801: @1147646
     /* 1147646 */   GIM_Try, /*On fail goto*//*Label 16802*/ GIMT_Encode4(1147726), // Rule ID 15406 //
     /* 1147651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1147662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1147665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1147668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147690 */     // MIs[0] round
     /* 1147690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147700 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147725 */     // GIR_Coverage, 15406,
     /* 1147725 */     GIR_EraseRootFromParent_Done,
     /* 1147726 */   // Label 16802: @1147726
     /* 1147726 */   GIM_Try, /*On fail goto*//*Label 16803*/ GIMT_Encode4(1147806), // Rule ID 15407 //
     /* 1147731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1147742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1147745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1147748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147770 */     // MIs[0] round
     /* 1147770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147780 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147805 */     // GIR_Coverage, 15407,
     /* 1147805 */     GIR_EraseRootFromParent_Done,
     /* 1147806 */   // Label 16803: @1147806
     /* 1147806 */   GIM_Try, /*On fail goto*//*Label 16804*/ GIMT_Encode4(1147886), // Rule ID 15410 //
     /* 1147811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1147822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1147825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1147828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147850 */     // MIs[0] round
     /* 1147850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147885 */     // GIR_Coverage, 15410,
     /* 1147885 */     GIR_EraseRootFromParent_Done,
     /* 1147886 */   // Label 16804: @1147886
     /* 1147886 */   GIM_Try, /*On fail goto*//*Label 16805*/ GIMT_Encode4(1147966), // Rule ID 15411 //
     /* 1147891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1147902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1147905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1147908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147930 */     // MIs[0] round
     /* 1147930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147965 */     // GIR_Coverage, 15411,
     /* 1147965 */     GIR_EraseRootFromParent_Done,
     /* 1147966 */   // Label 16805: @1147966
     /* 1147966 */   GIM_Try, /*On fail goto*//*Label 16806*/ GIMT_Encode4(1148046), // Rule ID 15414 //
     /* 1147971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1147982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1147985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1147988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148010 */     // MIs[0] round
     /* 1148010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1148023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148045 */     // GIR_Coverage, 15414,
     /* 1148045 */     GIR_EraseRootFromParent_Done,
     /* 1148046 */   // Label 16806: @1148046
     /* 1148046 */   GIM_Try, /*On fail goto*//*Label 16807*/ GIMT_Encode4(1148126), // Rule ID 15415 //
     /* 1148051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1148062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1148065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1148068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148090 */     // MIs[0] round
     /* 1148090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148100 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1148103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148125 */     // GIR_Coverage, 15415,
     /* 1148125 */     GIR_EraseRootFromParent_Done,
     /* 1148126 */   // Label 16807: @1148126
     /* 1148126 */   GIM_Try, /*On fail goto*//*Label 16808*/ GIMT_Encode4(1148206), // Rule ID 15418 //
     /* 1148131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1148134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1148142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1148145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1148148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148170 */     // MIs[0] round
     /* 1148170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148180 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1148183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148205 */     // GIR_Coverage, 15418,
     /* 1148205 */     GIR_EraseRootFromParent_Done,
     /* 1148206 */   // Label 16808: @1148206
     /* 1148206 */   GIM_Try, /*On fail goto*//*Label 16809*/ GIMT_Encode4(1148286), // Rule ID 15419 //
     /* 1148211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1148214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1148222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1148225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1148228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148250 */     // MIs[0] round
     /* 1148250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148260 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1148263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148285 */     // GIR_Coverage, 15419,
     /* 1148285 */     GIR_EraseRootFromParent_Done,
     /* 1148286 */   // Label 16809: @1148286
     /* 1148286 */   GIM_Try, /*On fail goto*//*Label 16810*/ GIMT_Encode4(1148366), // Rule ID 15422 //
     /* 1148291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1148302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1148305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1148308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148330 */     // MIs[0] round
     /* 1148330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148340 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148365 */     // GIR_Coverage, 15422,
     /* 1148365 */     GIR_EraseRootFromParent_Done,
     /* 1148366 */   // Label 16810: @1148366
     /* 1148366 */   GIM_Try, /*On fail goto*//*Label 16811*/ GIMT_Encode4(1148446), // Rule ID 15423 //
     /* 1148371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1148382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1148385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1148388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148410 */     // MIs[0] round
     /* 1148410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148420 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148445 */     // GIR_Coverage, 15423,
     /* 1148445 */     GIR_EraseRootFromParent_Done,
     /* 1148446 */   // Label 16811: @1148446
     /* 1148446 */   GIM_Try, /*On fail goto*//*Label 16812*/ GIMT_Encode4(1148526), // Rule ID 15426 //
     /* 1148451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1148462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1148465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1148468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148490 */     // MIs[0] round
     /* 1148490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148500 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148525 */     // GIR_Coverage, 15426,
     /* 1148525 */     GIR_EraseRootFromParent_Done,
     /* 1148526 */   // Label 16812: @1148526
     /* 1148526 */   GIM_Try, /*On fail goto*//*Label 16813*/ GIMT_Encode4(1148606), // Rule ID 15427 //
     /* 1148531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1148542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1148545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1148548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148570 */     // MIs[0] round
     /* 1148570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148580 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148605 */     // GIR_Coverage, 15427,
     /* 1148605 */     GIR_EraseRootFromParent_Done,
     /* 1148606 */   // Label 16813: @1148606
     /* 1148606 */   GIM_Try, /*On fail goto*//*Label 16814*/ GIMT_Encode4(1148686), // Rule ID 15430 //
     /* 1148611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1148622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1148625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1148628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148650 */     // MIs[0] round
     /* 1148650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148660 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148685 */     // GIR_Coverage, 15430,
     /* 1148685 */     GIR_EraseRootFromParent_Done,
     /* 1148686 */   // Label 16814: @1148686
     /* 1148686 */   GIM_Try, /*On fail goto*//*Label 16815*/ GIMT_Encode4(1148766), // Rule ID 15431 //
     /* 1148691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1148702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1148705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1148708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148730 */     // MIs[0] round
     /* 1148730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148740 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148765 */     // GIR_Coverage, 15431,
     /* 1148765 */     GIR_EraseRootFromParent_Done,
     /* 1148766 */   // Label 16815: @1148766
     /* 1148766 */   GIM_Try, /*On fail goto*//*Label 16816*/ GIMT_Encode4(1148846), // Rule ID 15434 //
     /* 1148771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1148782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1148785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1148788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148810 */     // MIs[0] round
     /* 1148810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148820 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148845 */     // GIR_Coverage, 15434,
     /* 1148845 */     GIR_EraseRootFromParent_Done,
     /* 1148846 */   // Label 16816: @1148846
     /* 1148846 */   GIM_Try, /*On fail goto*//*Label 16817*/ GIMT_Encode4(1148926), // Rule ID 15435 //
     /* 1148851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1148862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1148865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1148868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148890 */     // MIs[0] round
     /* 1148890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148900 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148925 */     // GIR_Coverage, 15435,
     /* 1148925 */     GIR_EraseRootFromParent_Done,
     /* 1148926 */   // Label 16817: @1148926
     /* 1148926 */   GIM_Try, /*On fail goto*//*Label 16818*/ GIMT_Encode4(1149006), // Rule ID 15438 //
     /* 1148931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1148942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1148945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1148948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148970 */     // MIs[0] round
     /* 1148970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148980 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149005 */     // GIR_Coverage, 15438,
     /* 1149005 */     GIR_EraseRootFromParent_Done,
     /* 1149006 */   // Label 16818: @1149006
     /* 1149006 */   GIM_Try, /*On fail goto*//*Label 16819*/ GIMT_Encode4(1149086), // Rule ID 15439 //
     /* 1149011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1149022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1149025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1149028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149050 */     // MIs[0] round
     /* 1149050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149060 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149085 */     // GIR_Coverage, 15439,
     /* 1149085 */     GIR_EraseRootFromParent_Done,
     /* 1149086 */   // Label 16819: @1149086
     /* 1149086 */   GIM_Try, /*On fail goto*//*Label 16820*/ GIMT_Encode4(1149166), // Rule ID 15442 //
     /* 1149091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1149102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1149105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1149108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149130 */     // MIs[0] round
     /* 1149130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149140 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149165 */     // GIR_Coverage, 15442,
     /* 1149165 */     GIR_EraseRootFromParent_Done,
     /* 1149166 */   // Label 16820: @1149166
     /* 1149166 */   GIM_Try, /*On fail goto*//*Label 16821*/ GIMT_Encode4(1149246), // Rule ID 15443 //
     /* 1149171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1149182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1149185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1149188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149210 */     // MIs[0] round
     /* 1149210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149245 */     // GIR_Coverage, 15443,
     /* 1149245 */     GIR_EraseRootFromParent_Done,
     /* 1149246 */   // Label 16821: @1149246
     /* 1149246 */   GIM_Try, /*On fail goto*//*Label 16822*/ GIMT_Encode4(1149326), // Rule ID 15446 //
     /* 1149251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1149262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1149265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1149268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149290 */     // MIs[0] round
     /* 1149290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149300 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149325 */     // GIR_Coverage, 15446,
     /* 1149325 */     GIR_EraseRootFromParent_Done,
     /* 1149326 */   // Label 16822: @1149326
     /* 1149326 */   GIM_Try, /*On fail goto*//*Label 16823*/ GIMT_Encode4(1149406), // Rule ID 15447 //
     /* 1149331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1149342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1149345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1149348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149370 */     // MIs[0] round
     /* 1149370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149380 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149405 */     // GIR_Coverage, 15447,
     /* 1149405 */     GIR_EraseRootFromParent_Done,
     /* 1149406 */   // Label 16823: @1149406
     /* 1149406 */   GIM_Try, /*On fail goto*//*Label 16824*/ GIMT_Encode4(1149486), // Rule ID 15450 //
     /* 1149411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1149422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1149425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1149428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149450 */     // MIs[0] round
     /* 1149450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149485 */     // GIR_Coverage, 15450,
     /* 1149485 */     GIR_EraseRootFromParent_Done,
     /* 1149486 */   // Label 16824: @1149486
     /* 1149486 */   GIM_Try, /*On fail goto*//*Label 16825*/ GIMT_Encode4(1149566), // Rule ID 15451 //
     /* 1149491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1149502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1149505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1149508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149530 */     // MIs[0] round
     /* 1149530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149540 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149565 */     // GIR_Coverage, 15451,
     /* 1149565 */     GIR_EraseRootFromParent_Done,
     /* 1149566 */   // Label 16825: @1149566
     /* 1149566 */   GIM_Try, /*On fail goto*//*Label 16826*/ GIMT_Encode4(1149646), // Rule ID 15454 //
     /* 1149571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1149582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1149585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1149588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149610 */     // MIs[0] round
     /* 1149610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149620 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149645 */     // GIR_Coverage, 15454,
     /* 1149645 */     GIR_EraseRootFromParent_Done,
     /* 1149646 */   // Label 16826: @1149646
     /* 1149646 */   GIM_Try, /*On fail goto*//*Label 16827*/ GIMT_Encode4(1149726), // Rule ID 15455 //
     /* 1149651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1149662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1149665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1149668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149690 */     // MIs[0] round
     /* 1149690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149700 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149725 */     // GIR_Coverage, 15455,
     /* 1149725 */     GIR_EraseRootFromParent_Done,
     /* 1149726 */   // Label 16827: @1149726
     /* 1149726 */   GIM_Try, /*On fail goto*//*Label 16828*/ GIMT_Encode4(1149806), // Rule ID 15458 //
     /* 1149731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1149742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1149745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1149748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149770 */     // MIs[0] round
     /* 1149770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149805 */     // GIR_Coverage, 15458,
     /* 1149805 */     GIR_EraseRootFromParent_Done,
     /* 1149806 */   // Label 16828: @1149806
     /* 1149806 */   GIM_Try, /*On fail goto*//*Label 16829*/ GIMT_Encode4(1149886), // Rule ID 15459 //
     /* 1149811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1149822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1149825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1149828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149850 */     // MIs[0] round
     /* 1149850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149885 */     // GIR_Coverage, 15459,
     /* 1149885 */     GIR_EraseRootFromParent_Done,
     /* 1149886 */   // Label 16829: @1149886
     /* 1149886 */   GIM_Try, /*On fail goto*//*Label 16830*/ GIMT_Encode4(1149966), // Rule ID 15462 //
     /* 1149891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1149902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1149905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1149908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149930 */     // MIs[0] round
     /* 1149930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149940 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149965 */     // GIR_Coverage, 15462,
     /* 1149965 */     GIR_EraseRootFromParent_Done,
     /* 1149966 */   // Label 16830: @1149966
     /* 1149966 */   GIM_Try, /*On fail goto*//*Label 16831*/ GIMT_Encode4(1150046), // Rule ID 15463 //
     /* 1149971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1149982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1149985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1149988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150010 */     // MIs[0] round
     /* 1150010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150020 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1150023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1150041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150045 */     // GIR_Coverage, 15463,
     /* 1150045 */     GIR_EraseRootFromParent_Done,
     /* 1150046 */   // Label 16831: @1150046
     /* 1150046 */   GIM_Try, /*On fail goto*//*Label 16832*/ GIMT_Encode4(1150126), // Rule ID 15466 //
     /* 1150051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1150054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1150062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1150065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1150068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150090 */     // MIs[0] round
     /* 1150090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150100 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1150103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1150121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150125 */     // GIR_Coverage, 15466,
     /* 1150125 */     GIR_EraseRootFromParent_Done,
     /* 1150126 */   // Label 16832: @1150126
     /* 1150126 */   GIM_Try, /*On fail goto*//*Label 16833*/ GIMT_Encode4(1150206), // Rule ID 15467 //
     /* 1150131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1150134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1150142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1150145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1150148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150170 */     // MIs[0] round
     /* 1150170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150180 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1150183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1150201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150205 */     // GIR_Coverage, 15467,
     /* 1150205 */     GIR_EraseRootFromParent_Done,
     /* 1150206 */   // Label 16833: @1150206
     /* 1150206 */   GIM_Try, /*On fail goto*//*Label 16834*/ GIMT_Encode4(1150286), // Rule ID 15470 //
     /* 1150211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1150222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1150225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1150228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1150231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150250 */     // MIs[0] round
     /* 1150250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150260 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1150263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150285 */     // GIR_Coverage, 15470,
     /* 1150285 */     GIR_EraseRootFromParent_Done,
     /* 1150286 */   // Label 16834: @1150286
     /* 1150286 */   GIM_Try, /*On fail goto*//*Label 16835*/ GIMT_Encode4(1150366), // Rule ID 15471 //
     /* 1150291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1150302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1150305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1150308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1150311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150330 */     // MIs[0] round
     /* 1150330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150340 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1150343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150365 */     // GIR_Coverage, 15471,
     /* 1150365 */     GIR_EraseRootFromParent_Done,
     /* 1150366 */   // Label 16835: @1150366
     /* 1150366 */   GIM_Try, /*On fail goto*//*Label 16836*/ GIMT_Encode4(1150446), // Rule ID 15474 //
     /* 1150371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1150382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1150385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1150388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1150391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150410 */     // MIs[0] round
     /* 1150410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150420 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150445 */     // GIR_Coverage, 15474,
     /* 1150445 */     GIR_EraseRootFromParent_Done,
     /* 1150446 */   // Label 16836: @1150446
     /* 1150446 */   GIM_Try, /*On fail goto*//*Label 16837*/ GIMT_Encode4(1150526), // Rule ID 15475 //
     /* 1150451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1150462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1150465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1150468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1150471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150490 */     // MIs[0] round
     /* 1150490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150500 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150525 */     // GIR_Coverage, 15475,
     /* 1150525 */     GIR_EraseRootFromParent_Done,
     /* 1150526 */   // Label 16837: @1150526
     /* 1150526 */   GIM_Try, /*On fail goto*//*Label 16838*/ GIMT_Encode4(1150606), // Rule ID 15478 //
     /* 1150531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1150542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1150545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1150548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1150551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150570 */     // MIs[0] round
     /* 1150570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150580 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150605 */     // GIR_Coverage, 15478,
     /* 1150605 */     GIR_EraseRootFromParent_Done,
     /* 1150606 */   // Label 16838: @1150606
     /* 1150606 */   GIM_Try, /*On fail goto*//*Label 16839*/ GIMT_Encode4(1150686), // Rule ID 15479 //
     /* 1150611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1150622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1150625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1150628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1150631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150650 */     // MIs[0] round
     /* 1150650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150660 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150685 */     // GIR_Coverage, 15479,
     /* 1150685 */     GIR_EraseRootFromParent_Done,
     /* 1150686 */   // Label 16839: @1150686
     /* 1150686 */   GIM_Try, /*On fail goto*//*Label 16840*/ GIMT_Encode4(1150766), // Rule ID 15482 //
     /* 1150691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1150702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1150705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1150708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1150711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150730 */     // MIs[0] round
     /* 1150730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150765 */     // GIR_Coverage, 15482,
     /* 1150765 */     GIR_EraseRootFromParent_Done,
     /* 1150766 */   // Label 16840: @1150766
     /* 1150766 */   GIM_Try, /*On fail goto*//*Label 16841*/ GIMT_Encode4(1150846), // Rule ID 15483 //
     /* 1150771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1150782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1150785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1150788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1150791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150810 */     // MIs[0] round
     /* 1150810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150820 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150845 */     // GIR_Coverage, 15483,
     /* 1150845 */     GIR_EraseRootFromParent_Done,
     /* 1150846 */   // Label 16841: @1150846
     /* 1150846 */   GIM_Try, /*On fail goto*//*Label 16842*/ GIMT_Encode4(1150926), // Rule ID 15486 //
     /* 1150851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1150862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1150865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1150868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1150871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150890 */     // MIs[0] round
     /* 1150890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150900 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150925 */     // GIR_Coverage, 15486,
     /* 1150925 */     GIR_EraseRootFromParent_Done,
     /* 1150926 */   // Label 16842: @1150926
     /* 1150926 */   GIM_Try, /*On fail goto*//*Label 16843*/ GIMT_Encode4(1151006), // Rule ID 15487 //
     /* 1150931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1150942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1150945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1150948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1150951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150970 */     // MIs[0] round
     /* 1150970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150980 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151005 */     // GIR_Coverage, 15487,
     /* 1151005 */     GIR_EraseRootFromParent_Done,
     /* 1151006 */   // Label 16843: @1151006
     /* 1151006 */   GIM_Try, /*On fail goto*//*Label 16844*/ GIMT_Encode4(1151086), // Rule ID 15490 //
     /* 1151011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1151022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1151025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1151028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1151031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151050 */     // MIs[0] round
     /* 1151050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151060 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1151063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151085 */     // GIR_Coverage, 15490,
     /* 1151085 */     GIR_EraseRootFromParent_Done,
     /* 1151086 */   // Label 16844: @1151086
     /* 1151086 */   GIM_Try, /*On fail goto*//*Label 16845*/ GIMT_Encode4(1151166), // Rule ID 15491 //
     /* 1151091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1151102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1151105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1151108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1151111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151130 */     // MIs[0] round
     /* 1151130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1151143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151165 */     // GIR_Coverage, 15491,
     /* 1151165 */     GIR_EraseRootFromParent_Done,
     /* 1151166 */   // Label 16845: @1151166
     /* 1151166 */   GIM_Try, /*On fail goto*//*Label 16846*/ GIMT_Encode4(1151246), // Rule ID 15494 //
     /* 1151171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1151182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1151185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1151188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1151191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151210 */     // MIs[0] round
     /* 1151210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151245 */     // GIR_Coverage, 15494,
     /* 1151245 */     GIR_EraseRootFromParent_Done,
     /* 1151246 */   // Label 16846: @1151246
     /* 1151246 */   GIM_Try, /*On fail goto*//*Label 16847*/ GIMT_Encode4(1151326), // Rule ID 15495 //
     /* 1151251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1151262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1151265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1151268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1151271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151290 */     // MIs[0] round
     /* 1151290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151325 */     // GIR_Coverage, 15495,
     /* 1151325 */     GIR_EraseRootFromParent_Done,
     /* 1151326 */   // Label 16847: @1151326
     /* 1151326 */   GIM_Try, /*On fail goto*//*Label 16848*/ GIMT_Encode4(1151406), // Rule ID 15498 //
     /* 1151331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1151342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1151345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1151348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1151351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151370 */     // MIs[0] round
     /* 1151370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151380 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151405 */     // GIR_Coverage, 15498,
     /* 1151405 */     GIR_EraseRootFromParent_Done,
     /* 1151406 */   // Label 16848: @1151406
     /* 1151406 */   GIM_Try, /*On fail goto*//*Label 16849*/ GIMT_Encode4(1151486), // Rule ID 15499 //
     /* 1151411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1151422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1151425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1151428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1151431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151450 */     // MIs[0] round
     /* 1151450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151460 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151485 */     // GIR_Coverage, 15499,
     /* 1151485 */     GIR_EraseRootFromParent_Done,
     /* 1151486 */   // Label 16849: @1151486
     /* 1151486 */   GIM_Try, /*On fail goto*//*Label 16850*/ GIMT_Encode4(1151566), // Rule ID 15502 //
     /* 1151491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1151502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1151505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1151508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1151511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151530 */     // MIs[0] round
     /* 1151530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151565 */     // GIR_Coverage, 15502,
     /* 1151565 */     GIR_EraseRootFromParent_Done,
     /* 1151566 */   // Label 16850: @1151566
     /* 1151566 */   GIM_Try, /*On fail goto*//*Label 16851*/ GIMT_Encode4(1151646), // Rule ID 15503 //
     /* 1151571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1151582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1151585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1151588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1151591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151610 */     // MIs[0] round
     /* 1151610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151645 */     // GIR_Coverage, 15503,
     /* 1151645 */     GIR_EraseRootFromParent_Done,
     /* 1151646 */   // Label 16851: @1151646
     /* 1151646 */   GIM_Try, /*On fail goto*//*Label 16852*/ GIMT_Encode4(1151726), // Rule ID 15506 //
     /* 1151651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1151654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1151662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1151665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1151668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1151671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151690 */     // MIs[0] round
     /* 1151690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151700 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151725 */     // GIR_Coverage, 15506,
     /* 1151725 */     GIR_EraseRootFromParent_Done,
     /* 1151726 */   // Label 16852: @1151726
     /* 1151726 */   GIM_Try, /*On fail goto*//*Label 16853*/ GIMT_Encode4(1151806), // Rule ID 15507 //
     /* 1151731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1151734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1151742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1151745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1151748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1151751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151770 */     // MIs[0] round
     /* 1151770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151780 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151805 */     // GIR_Coverage, 15507,
     /* 1151805 */     GIR_EraseRootFromParent_Done,
     /* 1151806 */   // Label 16853: @1151806
     /* 1151806 */   GIM_Try, /*On fail goto*//*Label 16854*/ GIMT_Encode4(1151886), // Rule ID 15510 //
     /* 1151811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1151822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1151825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1151828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1151831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151850 */     // MIs[0] round
     /* 1151850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151860 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151885 */     // GIR_Coverage, 15510,
     /* 1151885 */     GIR_EraseRootFromParent_Done,
     /* 1151886 */   // Label 16854: @1151886
     /* 1151886 */   GIM_Try, /*On fail goto*//*Label 16855*/ GIMT_Encode4(1151966), // Rule ID 15511 //
     /* 1151891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1151902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1151905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1151908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1151911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151930 */     // MIs[0] round
     /* 1151930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151940 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151965 */     // GIR_Coverage, 15511,
     /* 1151965 */     GIR_EraseRootFromParent_Done,
     /* 1151966 */   // Label 16855: @1151966
     /* 1151966 */   GIM_Try, /*On fail goto*//*Label 16856*/ GIMT_Encode4(1152046), // Rule ID 15514 //
     /* 1151971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1151982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1151985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1151988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1151991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152010 */     // MIs[0] round
     /* 1152010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152020 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152045 */     // GIR_Coverage, 15514,
     /* 1152045 */     GIR_EraseRootFromParent_Done,
     /* 1152046 */   // Label 16856: @1152046
     /* 1152046 */   GIM_Try, /*On fail goto*//*Label 16857*/ GIMT_Encode4(1152126), // Rule ID 15515 //
     /* 1152051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1152062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1152065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1152068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1152071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152090 */     // MIs[0] round
     /* 1152090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152100 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152125 */     // GIR_Coverage, 15515,
     /* 1152125 */     GIR_EraseRootFromParent_Done,
     /* 1152126 */   // Label 16857: @1152126
     /* 1152126 */   GIM_Try, /*On fail goto*//*Label 16858*/ GIMT_Encode4(1152206), // Rule ID 15518 //
     /* 1152131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1152142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1152145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1152148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1152151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152170 */     // MIs[0] round
     /* 1152170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152180 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152205 */     // GIR_Coverage, 15518,
     /* 1152205 */     GIR_EraseRootFromParent_Done,
     /* 1152206 */   // Label 16858: @1152206
     /* 1152206 */   GIM_Try, /*On fail goto*//*Label 16859*/ GIMT_Encode4(1152286), // Rule ID 15519 //
     /* 1152211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1152222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1152225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1152228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1152231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152250 */     // MIs[0] round
     /* 1152250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152260 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152285 */     // GIR_Coverage, 15519,
     /* 1152285 */     GIR_EraseRootFromParent_Done,
     /* 1152286 */   // Label 16859: @1152286
     /* 1152286 */   GIM_Try, /*On fail goto*//*Label 16860*/ GIMT_Encode4(1152366), // Rule ID 15522 //
     /* 1152291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1152302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1152305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1152308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1152311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152330 */     // MIs[0] round
     /* 1152330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152365 */     // GIR_Coverage, 15522,
     /* 1152365 */     GIR_EraseRootFromParent_Done,
     /* 1152366 */   // Label 16860: @1152366
     /* 1152366 */   GIM_Try, /*On fail goto*//*Label 16861*/ GIMT_Encode4(1152446), // Rule ID 15523 //
     /* 1152371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1152382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1152385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1152388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1152391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152410 */     // MIs[0] round
     /* 1152410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152420 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152445 */     // GIR_Coverage, 15523,
     /* 1152445 */     GIR_EraseRootFromParent_Done,
     /* 1152446 */   // Label 16861: @1152446
     /* 1152446 */   GIM_Try, /*On fail goto*//*Label 16862*/ GIMT_Encode4(1152526), // Rule ID 15526 //
     /* 1152451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1152462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1152465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1152468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1152471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152490 */     // MIs[0] round
     /* 1152490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152500 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152525 */     // GIR_Coverage, 15526,
     /* 1152525 */     GIR_EraseRootFromParent_Done,
     /* 1152526 */   // Label 16862: @1152526
     /* 1152526 */   GIM_Try, /*On fail goto*//*Label 16863*/ GIMT_Encode4(1152606), // Rule ID 15527 //
     /* 1152531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1152542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1152545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1152548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1152551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152570 */     // MIs[0] round
     /* 1152570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152580 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152605 */     // GIR_Coverage, 15527,
     /* 1152605 */     GIR_EraseRootFromParent_Done,
     /* 1152606 */   // Label 16863: @1152606
     /* 1152606 */   GIM_Try, /*On fail goto*//*Label 16864*/ GIMT_Encode4(1152686), // Rule ID 15530 //
     /* 1152611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1152622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1152625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1152628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1152631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152650 */     // MIs[0] round
     /* 1152650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152660 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152685 */     // GIR_Coverage, 15530,
     /* 1152685 */     GIR_EraseRootFromParent_Done,
     /* 1152686 */   // Label 16864: @1152686
     /* 1152686 */   GIM_Try, /*On fail goto*//*Label 16865*/ GIMT_Encode4(1152766), // Rule ID 15531 //
     /* 1152691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1152702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1152705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1152708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1152711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152730 */     // MIs[0] round
     /* 1152730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152740 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152765 */     // GIR_Coverage, 15531,
     /* 1152765 */     GIR_EraseRootFromParent_Done,
     /* 1152766 */   // Label 16865: @1152766
     /* 1152766 */   GIM_Try, /*On fail goto*//*Label 16866*/ GIMT_Encode4(1152846), // Rule ID 15534 //
     /* 1152771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1152782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1152785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1152788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1152791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152810 */     // MIs[0] round
     /* 1152810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152820 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152845 */     // GIR_Coverage, 15534,
     /* 1152845 */     GIR_EraseRootFromParent_Done,
     /* 1152846 */   // Label 16866: @1152846
     /* 1152846 */   GIM_Try, /*On fail goto*//*Label 16867*/ GIMT_Encode4(1152926), // Rule ID 15535 //
     /* 1152851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1152862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1152865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1152868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1152871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152890 */     // MIs[0] round
     /* 1152890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152925 */     // GIR_Coverage, 15535,
     /* 1152925 */     GIR_EraseRootFromParent_Done,
     /* 1152926 */   // Label 16867: @1152926
     /* 1152926 */   GIM_Try, /*On fail goto*//*Label 16868*/ GIMT_Encode4(1153006), // Rule ID 15538 //
     /* 1152931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1152942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1152945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1152948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1152951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152970 */     // MIs[0] round
     /* 1152970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153005 */     // GIR_Coverage, 15538,
     /* 1153005 */     GIR_EraseRootFromParent_Done,
     /* 1153006 */   // Label 16868: @1153006
     /* 1153006 */   GIM_Try, /*On fail goto*//*Label 16869*/ GIMT_Encode4(1153086), // Rule ID 15539 //
     /* 1153011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1153022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1153025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1153028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1153031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153050 */     // MIs[0] round
     /* 1153050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153060 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1153063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153085 */     // GIR_Coverage, 15539,
     /* 1153085 */     GIR_EraseRootFromParent_Done,
     /* 1153086 */   // Label 16869: @1153086
     /* 1153086 */   GIM_Try, /*On fail goto*//*Label 16870*/ GIMT_Encode4(1153166), // Rule ID 15542 //
     /* 1153091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1153102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1153105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1153108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1153111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153130 */     // MIs[0] round
     /* 1153130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1153143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153165 */     // GIR_Coverage, 15542,
     /* 1153165 */     GIR_EraseRootFromParent_Done,
     /* 1153166 */   // Label 16870: @1153166
     /* 1153166 */   GIM_Try, /*On fail goto*//*Label 16871*/ GIMT_Encode4(1153246), // Rule ID 15543 //
     /* 1153171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1153182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1153185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1153188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1153191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153210 */     // MIs[0] round
     /* 1153210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153220 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1153223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153245 */     // GIR_Coverage, 15543,
     /* 1153245 */     GIR_EraseRootFromParent_Done,
     /* 1153246 */   // Label 16871: @1153246
     /* 1153246 */   GIM_Try, /*On fail goto*//*Label 16872*/ GIMT_Encode4(1153326), // Rule ID 15546 //
     /* 1153251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1153254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1153262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1153265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1153268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1153271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153290 */     // MIs[0] round
     /* 1153290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1153303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153325 */     // GIR_Coverage, 15546,
     /* 1153325 */     GIR_EraseRootFromParent_Done,
     /* 1153326 */   // Label 16872: @1153326
     /* 1153326 */   GIM_Try, /*On fail goto*//*Label 16873*/ GIMT_Encode4(1153406), // Rule ID 15547 //
     /* 1153331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1153342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1153345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1153348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1153351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153370 */     // MIs[0] round
     /* 1153370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153380 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1153383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153405 */     // GIR_Coverage, 15547,
     /* 1153405 */     GIR_EraseRootFromParent_Done,
     /* 1153406 */   // Label 16873: @1153406
     /* 1153406 */   GIM_Try, /*On fail goto*//*Label 16874*/ GIMT_Encode4(1153486), // Rule ID 15550 //
     /* 1153411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1153414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1153422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1153425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1153428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1153431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153450 */     // MIs[0] round
     /* 1153450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153460 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1153463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153485 */     // GIR_Coverage, 15550,
     /* 1153485 */     GIR_EraseRootFromParent_Done,
     /* 1153486 */   // Label 16874: @1153486
     /* 1153486 */   GIM_Try, /*On fail goto*//*Label 16875*/ GIMT_Encode4(1153566), // Rule ID 15551 //
     /* 1153491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1153502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1153505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1153508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1153511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153530 */     // MIs[0] round
     /* 1153530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153540 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1153543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153565 */     // GIR_Coverage, 15551,
     /* 1153565 */     GIR_EraseRootFromParent_Done,
     /* 1153566 */   // Label 16875: @1153566
     /* 1153566 */   GIM_Try, /*On fail goto*//*Label 16876*/ GIMT_Encode4(1153646), // Rule ID 15554 //
     /* 1153571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1153574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1153582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1153585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1153588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1153591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153610 */     // MIs[0] round
     /* 1153610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153620 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1153623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153645 */     // GIR_Coverage, 15554,
     /* 1153645 */     GIR_EraseRootFromParent_Done,
     /* 1153646 */   // Label 16876: @1153646
     /* 1153646 */   GIM_Try, /*On fail goto*//*Label 16877*/ GIMT_Encode4(1153726), // Rule ID 15555 //
     /* 1153651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1153662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1153665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1153668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1153671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153690 */     // MIs[0] round
     /* 1153690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153700 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1153703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153725 */     // GIR_Coverage, 15555,
     /* 1153725 */     GIR_EraseRootFromParent_Done,
     /* 1153726 */   // Label 16877: @1153726
     /* 1153726 */   GIM_Try, /*On fail goto*//*Label 16878*/ GIMT_Encode4(1153806), // Rule ID 15558 //
     /* 1153731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1153742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1153745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1153748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153770 */     // MIs[0] round
     /* 1153770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153780 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1153783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153805 */     // GIR_Coverage, 15558,
     /* 1153805 */     GIR_EraseRootFromParent_Done,
     /* 1153806 */   // Label 16878: @1153806
     /* 1153806 */   GIM_Try, /*On fail goto*//*Label 16879*/ GIMT_Encode4(1153886), // Rule ID 15559 //
     /* 1153811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1153822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1153825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1153828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153850 */     // MIs[0] round
     /* 1153850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153860 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1153863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153885 */     // GIR_Coverage, 15559,
     /* 1153885 */     GIR_EraseRootFromParent_Done,
     /* 1153886 */   // Label 16879: @1153886
     /* 1153886 */   GIM_Try, /*On fail goto*//*Label 16880*/ GIMT_Encode4(1153966), // Rule ID 15562 //
     /* 1153891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1153902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1153905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1153908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153930 */     // MIs[0] round
     /* 1153930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153940 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153965 */     // GIR_Coverage, 15562,
     /* 1153965 */     GIR_EraseRootFromParent_Done,
     /* 1153966 */   // Label 16880: @1153966
     /* 1153966 */   GIM_Try, /*On fail goto*//*Label 16881*/ GIMT_Encode4(1154046), // Rule ID 15563 //
     /* 1153971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1153982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1153985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1153988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154010 */     // MIs[0] round
     /* 1154010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154020 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1154023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154045 */     // GIR_Coverage, 15563,
     /* 1154045 */     GIR_EraseRootFromParent_Done,
     /* 1154046 */   // Label 16881: @1154046
     /* 1154046 */   GIM_Try, /*On fail goto*//*Label 16882*/ GIMT_Encode4(1154126), // Rule ID 15566 //
     /* 1154051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1154062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1154065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1154068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154090 */     // MIs[0] round
     /* 1154090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154100 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154125 */     // GIR_Coverage, 15566,
     /* 1154125 */     GIR_EraseRootFromParent_Done,
     /* 1154126 */   // Label 16882: @1154126
     /* 1154126 */   GIM_Try, /*On fail goto*//*Label 16883*/ GIMT_Encode4(1154206), // Rule ID 15567 //
     /* 1154131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1154142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1154145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1154148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154170 */     // MIs[0] round
     /* 1154170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154180 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154205 */     // GIR_Coverage, 15567,
     /* 1154205 */     GIR_EraseRootFromParent_Done,
     /* 1154206 */   // Label 16883: @1154206
     /* 1154206 */   GIM_Try, /*On fail goto*//*Label 16884*/ GIMT_Encode4(1154286), // Rule ID 15570 //
     /* 1154211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1154222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1154225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1154228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154250 */     // MIs[0] round
     /* 1154250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154260 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1154263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154285 */     // GIR_Coverage, 15570,
     /* 1154285 */     GIR_EraseRootFromParent_Done,
     /* 1154286 */   // Label 16884: @1154286
     /* 1154286 */   GIM_Try, /*On fail goto*//*Label 16885*/ GIMT_Encode4(1154366), // Rule ID 15571 //
     /* 1154291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1154302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1154305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1154308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154330 */     // MIs[0] round
     /* 1154330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154340 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1154343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154365 */     // GIR_Coverage, 15571,
     /* 1154365 */     GIR_EraseRootFromParent_Done,
     /* 1154366 */   // Label 16885: @1154366
     /* 1154366 */   GIM_Try, /*On fail goto*//*Label 16886*/ GIMT_Encode4(1154446), // Rule ID 15574 //
     /* 1154371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1154382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1154385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1154388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154410 */     // MIs[0] round
     /* 1154410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154420 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154445 */     // GIR_Coverage, 15574,
     /* 1154445 */     GIR_EraseRootFromParent_Done,
     /* 1154446 */   // Label 16886: @1154446
     /* 1154446 */   GIM_Try, /*On fail goto*//*Label 16887*/ GIMT_Encode4(1154526), // Rule ID 15575 //
     /* 1154451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1154462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1154465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1154468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154490 */     // MIs[0] round
     /* 1154490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154500 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154525 */     // GIR_Coverage, 15575,
     /* 1154525 */     GIR_EraseRootFromParent_Done,
     /* 1154526 */   // Label 16887: @1154526
     /* 1154526 */   GIM_Try, /*On fail goto*//*Label 16888*/ GIMT_Encode4(1154606), // Rule ID 15578 //
     /* 1154531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1154542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1154545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1154548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154570 */     // MIs[0] round
     /* 1154570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154580 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154605 */     // GIR_Coverage, 15578,
     /* 1154605 */     GIR_EraseRootFromParent_Done,
     /* 1154606 */   // Label 16888: @1154606
     /* 1154606 */   GIM_Try, /*On fail goto*//*Label 16889*/ GIMT_Encode4(1154686), // Rule ID 15579 //
     /* 1154611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1154622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1154625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1154628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154650 */     // MIs[0] round
     /* 1154650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154660 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154685 */     // GIR_Coverage, 15579,
     /* 1154685 */     GIR_EraseRootFromParent_Done,
     /* 1154686 */   // Label 16889: @1154686
     /* 1154686 */   GIM_Try, /*On fail goto*//*Label 16890*/ GIMT_Encode4(1154766), // Rule ID 15582 //
     /* 1154691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1154702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1154705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1154708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154730 */     // MIs[0] round
     /* 1154730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154765 */     // GIR_Coverage, 15582,
     /* 1154765 */     GIR_EraseRootFromParent_Done,
     /* 1154766 */   // Label 16890: @1154766
     /* 1154766 */   GIM_Try, /*On fail goto*//*Label 16891*/ GIMT_Encode4(1154846), // Rule ID 15583 //
     /* 1154771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1154782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1154785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1154788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154810 */     // MIs[0] round
     /* 1154810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154820 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11193:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154845 */     // GIR_Coverage, 15583,
     /* 1154845 */     GIR_EraseRootFromParent_Done,
     /* 1154846 */   // Label 16891: @1154846
     /* 1154846 */   GIM_Try, /*On fail goto*//*Label 16892*/ GIMT_Encode4(1154926), // Rule ID 15586 //
     /* 1154851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1154862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1154865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1154868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154890 */     // MIs[0] round
     /* 1154890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154925 */     // GIR_Coverage, 15586,
     /* 1154925 */     GIR_EraseRootFromParent_Done,
     /* 1154926 */   // Label 16892: @1154926
     /* 1154926 */   GIM_Try, /*On fail goto*//*Label 16893*/ GIMT_Encode4(1155006), // Rule ID 15587 //
     /* 1154931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1154942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1154945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1154948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154970 */     // MIs[0] round
     /* 1154970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154980 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155005 */     // GIR_Coverage, 15587,
     /* 1155005 */     GIR_EraseRootFromParent_Done,
     /* 1155006 */   // Label 16893: @1155006
     /* 1155006 */   GIM_Try, /*On fail goto*//*Label 16894*/ GIMT_Encode4(1155086), // Rule ID 15590 //
     /* 1155011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1155022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1155025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1155028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155050 */     // MIs[0] round
     /* 1155050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155060 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1155063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155085 */     // GIR_Coverage, 15590,
     /* 1155085 */     GIR_EraseRootFromParent_Done,
     /* 1155086 */   // Label 16894: @1155086
     /* 1155086 */   GIM_Try, /*On fail goto*//*Label 16895*/ GIMT_Encode4(1155166), // Rule ID 15591 //
     /* 1155091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1155102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1155105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1155108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155130 */     // MIs[0] round
     /* 1155130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1155143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155165 */     // GIR_Coverage, 15591,
     /* 1155165 */     GIR_EraseRootFromParent_Done,
     /* 1155166 */   // Label 16895: @1155166
     /* 1155166 */   GIM_Try, /*On fail goto*//*Label 16896*/ GIMT_Encode4(1155246), // Rule ID 15594 //
     /* 1155171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1155174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1155182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1155185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1155188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155210 */     // MIs[0] round
     /* 1155210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155220 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1155223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1155241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155245 */     // GIR_Coverage, 15594,
     /* 1155245 */     GIR_EraseRootFromParent_Done,
     /* 1155246 */   // Label 16896: @1155246
     /* 1155246 */   GIM_Try, /*On fail goto*//*Label 16897*/ GIMT_Encode4(1155326), // Rule ID 15595 //
     /* 1155251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1155254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1155262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1155265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1155268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155290 */     // MIs[0] round
     /* 1155290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155300 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1155303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1155321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155325 */     // GIR_Coverage, 15595,
     /* 1155325 */     GIR_EraseRootFromParent_Done,
     /* 1155326 */   // Label 16897: @1155326
     /* 1155326 */   GIM_Try, /*On fail goto*//*Label 16898*/ GIMT_Encode4(1155406), // Rule ID 15598 //
     /* 1155331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1155342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1155345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1155348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155370 */     // MIs[0] round
     /* 1155370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155380 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155405 */     // GIR_Coverage, 15598,
     /* 1155405 */     GIR_EraseRootFromParent_Done,
     /* 1155406 */   // Label 16898: @1155406
     /* 1155406 */   GIM_Try, /*On fail goto*//*Label 16899*/ GIMT_Encode4(1155486), // Rule ID 15599 //
     /* 1155411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1155422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1155425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1155428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155450 */     // MIs[0] round
     /* 1155450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155460 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155485 */     // GIR_Coverage, 15599,
     /* 1155485 */     GIR_EraseRootFromParent_Done,
     /* 1155486 */   // Label 16899: @1155486
     /* 1155486 */   GIM_Try, /*On fail goto*//*Label 16900*/ GIMT_Encode4(1155566), // Rule ID 15602 //
     /* 1155491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1155502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1155505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1155508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155530 */     // MIs[0] round
     /* 1155530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155565 */     // GIR_Coverage, 15602,
     /* 1155565 */     GIR_EraseRootFromParent_Done,
     /* 1155566 */   // Label 16900: @1155566
     /* 1155566 */   GIM_Try, /*On fail goto*//*Label 16901*/ GIMT_Encode4(1155646), // Rule ID 15603 //
     /* 1155571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1155582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1155585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1155588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155610 */     // MIs[0] round
     /* 1155610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155620 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155645 */     // GIR_Coverage, 15603,
     /* 1155645 */     GIR_EraseRootFromParent_Done,
     /* 1155646 */   // Label 16901: @1155646
     /* 1155646 */   GIM_Try, /*On fail goto*//*Label 16902*/ GIMT_Encode4(1155726), // Rule ID 15606 //
     /* 1155651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1155662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1155665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1155668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155690 */     // MIs[0] round
     /* 1155690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155700 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155725 */     // GIR_Coverage, 15606,
     /* 1155725 */     GIR_EraseRootFromParent_Done,
     /* 1155726 */   // Label 16902: @1155726
     /* 1155726 */   GIM_Try, /*On fail goto*//*Label 16903*/ GIMT_Encode4(1155806), // Rule ID 15607 //
     /* 1155731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1155742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1155745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1155748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155770 */     // MIs[0] round
     /* 1155770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155780 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155805 */     // GIR_Coverage, 15607,
     /* 1155805 */     GIR_EraseRootFromParent_Done,
     /* 1155806 */   // Label 16903: @1155806
     /* 1155806 */   GIM_Try, /*On fail goto*//*Label 16904*/ GIMT_Encode4(1155886), // Rule ID 15610 //
     /* 1155811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1155822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1155825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1155828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155850 */     // MIs[0] round
     /* 1155850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155860 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155885 */     // GIR_Coverage, 15610,
     /* 1155885 */     GIR_EraseRootFromParent_Done,
     /* 1155886 */   // Label 16904: @1155886
     /* 1155886 */   GIM_Try, /*On fail goto*//*Label 16905*/ GIMT_Encode4(1155966), // Rule ID 15611 //
     /* 1155891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1155902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1155905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1155908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155930 */     // MIs[0] round
     /* 1155930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155965 */     // GIR_Coverage, 15611,
     /* 1155965 */     GIR_EraseRootFromParent_Done,
     /* 1155966 */   // Label 16905: @1155966
     /* 1155966 */   GIM_Try, /*On fail goto*//*Label 16906*/ GIMT_Encode4(1156046), // Rule ID 15614 //
     /* 1155971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1155982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1155985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1155988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156010 */     // MIs[0] round
     /* 1156010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156020 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156045 */     // GIR_Coverage, 15614,
     /* 1156045 */     GIR_EraseRootFromParent_Done,
     /* 1156046 */   // Label 16906: @1156046
     /* 1156046 */   GIM_Try, /*On fail goto*//*Label 16907*/ GIMT_Encode4(1156126), // Rule ID 15615 //
     /* 1156051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1156062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1156065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1156068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156090 */     // MIs[0] round
     /* 1156090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156100 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156125 */     // GIR_Coverage, 15615,
     /* 1156125 */     GIR_EraseRootFromParent_Done,
     /* 1156126 */   // Label 16907: @1156126
     /* 1156126 */   GIM_Try, /*On fail goto*//*Label 16908*/ GIMT_Encode4(1156206), // Rule ID 15618 //
     /* 1156131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1156142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1156145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1156148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156170 */     // MIs[0] round
     /* 1156170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156180 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156205 */     // GIR_Coverage, 15618,
     /* 1156205 */     GIR_EraseRootFromParent_Done,
     /* 1156206 */   // Label 16908: @1156206
     /* 1156206 */   GIM_Try, /*On fail goto*//*Label 16909*/ GIMT_Encode4(1156286), // Rule ID 15619 //
     /* 1156211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1156222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1156225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1156228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156250 */     // MIs[0] round
     /* 1156250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156260 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156285 */     // GIR_Coverage, 15619,
     /* 1156285 */     GIR_EraseRootFromParent_Done,
     /* 1156286 */   // Label 16909: @1156286
     /* 1156286 */   GIM_Try, /*On fail goto*//*Label 16910*/ GIMT_Encode4(1156366), // Rule ID 15622 //
     /* 1156291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1156302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1156305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1156308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156330 */     // MIs[0] round
     /* 1156330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156365 */     // GIR_Coverage, 15622,
     /* 1156365 */     GIR_EraseRootFromParent_Done,
     /* 1156366 */   // Label 16910: @1156366
     /* 1156366 */   GIM_Try, /*On fail goto*//*Label 16911*/ GIMT_Encode4(1156446), // Rule ID 15623 //
     /* 1156371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1156382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1156385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1156388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156410 */     // MIs[0] round
     /* 1156410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156445 */     // GIR_Coverage, 15623,
     /* 1156445 */     GIR_EraseRootFromParent_Done,
     /* 1156446 */   // Label 16911: @1156446
     /* 1156446 */   GIM_Try, /*On fail goto*//*Label 16912*/ GIMT_Encode4(1156526), // Rule ID 15626 //
     /* 1156451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1156462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1156465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1156468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156490 */     // MIs[0] round
     /* 1156490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156525 */     // GIR_Coverage, 15626,
     /* 1156525 */     GIR_EraseRootFromParent_Done,
     /* 1156526 */   // Label 16912: @1156526
     /* 1156526 */   GIM_Try, /*On fail goto*//*Label 16913*/ GIMT_Encode4(1156606), // Rule ID 15627 //
     /* 1156531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1156542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1156545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1156548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156570 */     // MIs[0] round
     /* 1156570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156580 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156605 */     // GIR_Coverage, 15627,
     /* 1156605 */     GIR_EraseRootFromParent_Done,
     /* 1156606 */   // Label 16913: @1156606
     /* 1156606 */   GIM_Try, /*On fail goto*//*Label 16914*/ GIMT_Encode4(1156686), // Rule ID 15630 //
     /* 1156611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1156622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1156625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1156628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156650 */     // MIs[0] round
     /* 1156650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156660 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156685 */     // GIR_Coverage, 15630,
     /* 1156685 */     GIR_EraseRootFromParent_Done,
     /* 1156686 */   // Label 16914: @1156686
     /* 1156686 */   GIM_Try, /*On fail goto*//*Label 16915*/ GIMT_Encode4(1156766), // Rule ID 15631 //
     /* 1156691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1156702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1156705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1156708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156730 */     // MIs[0] round
     /* 1156730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156740 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156765 */     // GIR_Coverage, 15631,
     /* 1156765 */     GIR_EraseRootFromParent_Done,
     /* 1156766 */   // Label 16915: @1156766
     /* 1156766 */   GIM_Try, /*On fail goto*//*Label 16916*/ GIMT_Encode4(1156846), // Rule ID 15634 //
     /* 1156771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1156782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1156785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1156788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156810 */     // MIs[0] round
     /* 1156810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156820 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156845 */     // GIR_Coverage, 15634,
     /* 1156845 */     GIR_EraseRootFromParent_Done,
     /* 1156846 */   // Label 16916: @1156846
     /* 1156846 */   GIM_Try, /*On fail goto*//*Label 16917*/ GIMT_Encode4(1156926), // Rule ID 15635 //
     /* 1156851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1156862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1156865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1156868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156890 */     // MIs[0] round
     /* 1156890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156925 */     // GIR_Coverage, 15635,
     /* 1156925 */     GIR_EraseRootFromParent_Done,
     /* 1156926 */   // Label 16917: @1156926
     /* 1156926 */   GIM_Try, /*On fail goto*//*Label 16918*/ GIMT_Encode4(1157006), // Rule ID 15638 //
     /* 1156931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1156942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1156945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1156948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156970 */     // MIs[0] round
     /* 1156970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1157001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157005 */     // GIR_Coverage, 15638,
     /* 1157005 */     GIR_EraseRootFromParent_Done,
     /* 1157006 */   // Label 16918: @1157006
     /* 1157006 */   GIM_Try, /*On fail goto*//*Label 16919*/ GIMT_Encode4(1157086), // Rule ID 15639 //
     /* 1157011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1157014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1157022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1157025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1157028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157050 */     // MIs[0] round
     /* 1157050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157060 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1157063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1157081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157085 */     // GIR_Coverage, 15639,
     /* 1157085 */     GIR_EraseRootFromParent_Done,
     /* 1157086 */   // Label 16919: @1157086
     /* 1157086 */   GIM_Try, /*On fail goto*//*Label 16920*/ GIMT_Encode4(1157166), // Rule ID 15642 //
     /* 1157091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1157094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1157102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1157105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1157108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157130 */     // MIs[0] round
     /* 1157130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157140 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1157143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1157161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157165 */     // GIR_Coverage, 15642,
     /* 1157165 */     GIR_EraseRootFromParent_Done,
     /* 1157166 */   // Label 16920: @1157166
     /* 1157166 */   GIM_Try, /*On fail goto*//*Label 16921*/ GIMT_Encode4(1157246), // Rule ID 15643 //
     /* 1157171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1157174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1157182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1157185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1157188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157210 */     // MIs[0] round
     /* 1157210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1157223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1157241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157245 */     // GIR_Coverage, 15643,
     /* 1157245 */     GIR_EraseRootFromParent_Done,
     /* 1157246 */   // Label 16921: @1157246
     /* 1157246 */   GIM_Try, /*On fail goto*//*Label 16922*/ GIMT_Encode4(1157329), // Rule ID 15646 //
     /* 1157251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1157262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1157265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1157268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1157271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157290 */     // MIs[0] round
     /* 1157290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157300 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1157303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157328 */     // GIR_Coverage, 15646,
     /* 1157328 */     GIR_EraseRootFromParent_Done,
     /* 1157329 */   // Label 16922: @1157329
     /* 1157329 */   GIM_Try, /*On fail goto*//*Label 16923*/ GIMT_Encode4(1157412), // Rule ID 15647 //
     /* 1157334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1157345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1157348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1157351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1157354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157373 */     // MIs[0] round
     /* 1157373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157383 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1157386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157394 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157411 */     // GIR_Coverage, 15647,
     /* 1157411 */     GIR_EraseRootFromParent_Done,
     /* 1157412 */   // Label 16923: @1157412
     /* 1157412 */   GIM_Try, /*On fail goto*//*Label 16924*/ GIMT_Encode4(1157495), // Rule ID 15650 //
     /* 1157417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1157428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1157431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1157434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1157437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157456 */     // MIs[0] round
     /* 1157456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157466 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157494 */     // GIR_Coverage, 15650,
     /* 1157494 */     GIR_EraseRootFromParent_Done,
     /* 1157495 */   // Label 16924: @1157495
     /* 1157495 */   GIM_Try, /*On fail goto*//*Label 16925*/ GIMT_Encode4(1157578), // Rule ID 15651 //
     /* 1157500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1157511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1157514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1157517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1157520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157539 */     // MIs[0] round
     /* 1157539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157549 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157560 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157577 */     // GIR_Coverage, 15651,
     /* 1157577 */     GIR_EraseRootFromParent_Done,
     /* 1157578 */   // Label 16925: @1157578
     /* 1157578 */   GIM_Try, /*On fail goto*//*Label 16926*/ GIMT_Encode4(1157661), // Rule ID 15654 //
     /* 1157583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1157594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1157597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1157600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1157603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157622 */     // MIs[0] round
     /* 1157622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157632 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157660 */     // GIR_Coverage, 15654,
     /* 1157660 */     GIR_EraseRootFromParent_Done,
     /* 1157661 */   // Label 16926: @1157661
     /* 1157661 */   GIM_Try, /*On fail goto*//*Label 16927*/ GIMT_Encode4(1157744), // Rule ID 15655 //
     /* 1157666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1157677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1157680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1157683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1157686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157705 */     // MIs[0] round
     /* 1157705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157715 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157743 */     // GIR_Coverage, 15655,
     /* 1157743 */     GIR_EraseRootFromParent_Done,
     /* 1157744 */   // Label 16927: @1157744
     /* 1157744 */   GIM_Try, /*On fail goto*//*Label 16928*/ GIMT_Encode4(1157827), // Rule ID 15658 //
     /* 1157749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1157760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1157763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1157766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1157769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157788 */     // MIs[0] round
     /* 1157788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157798 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157826 */     // GIR_Coverage, 15658,
     /* 1157826 */     GIR_EraseRootFromParent_Done,
     /* 1157827 */   // Label 16928: @1157827
     /* 1157827 */   GIM_Try, /*On fail goto*//*Label 16929*/ GIMT_Encode4(1157910), // Rule ID 15659 //
     /* 1157832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1157843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1157846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1157849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1157852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157871 */     // MIs[0] round
     /* 1157871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157881 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157892 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157909 */     // GIR_Coverage, 15659,
     /* 1157909 */     GIR_EraseRootFromParent_Done,
     /* 1157910 */   // Label 16929: @1157910
     /* 1157910 */   GIM_Try, /*On fail goto*//*Label 16930*/ GIMT_Encode4(1157993), // Rule ID 15662 //
     /* 1157915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1157926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1157929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1157932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1157935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157954 */     // MIs[0] round
     /* 1157954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157992 */     // GIR_Coverage, 15662,
     /* 1157992 */     GIR_EraseRootFromParent_Done,
     /* 1157993 */   // Label 16930: @1157993
     /* 1157993 */   GIM_Try, /*On fail goto*//*Label 16931*/ GIMT_Encode4(1158076), // Rule ID 15663 //
     /* 1157998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1158009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1158012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1158015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1158018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158037 */     // MIs[0] round
     /* 1158037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158047 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1158050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158058 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158075 */     // GIR_Coverage, 15663,
     /* 1158075 */     GIR_EraseRootFromParent_Done,
     /* 1158076 */   // Label 16931: @1158076
     /* 1158076 */   GIM_Try, /*On fail goto*//*Label 16932*/ GIMT_Encode4(1158159), // Rule ID 15666 //
     /* 1158081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1158092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1158095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1158098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1158101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158120 */     // MIs[0] round
     /* 1158120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158130 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1158133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158158 */     // GIR_Coverage, 15666,
     /* 1158158 */     GIR_EraseRootFromParent_Done,
     /* 1158159 */   // Label 16932: @1158159
     /* 1158159 */   GIM_Try, /*On fail goto*//*Label 16933*/ GIMT_Encode4(1158242), // Rule ID 15667 //
     /* 1158164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1158175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1158178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1158181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1158184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158203 */     // MIs[0] round
     /* 1158203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158213 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1158216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158224 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158241 */     // GIR_Coverage, 15667,
     /* 1158241 */     GIR_EraseRootFromParent_Done,
     /* 1158242 */   // Label 16933: @1158242
     /* 1158242 */   GIM_Try, /*On fail goto*//*Label 16934*/ GIMT_Encode4(1158325), // Rule ID 15670 //
     /* 1158247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1158258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1158261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1158264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1158267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158286 */     // MIs[0] round
     /* 1158286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158296 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158324 */     // GIR_Coverage, 15670,
     /* 1158324 */     GIR_EraseRootFromParent_Done,
     /* 1158325 */   // Label 16934: @1158325
     /* 1158325 */   GIM_Try, /*On fail goto*//*Label 16935*/ GIMT_Encode4(1158408), // Rule ID 15671 //
     /* 1158330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1158341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1158344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1158347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1158350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158369 */     // MIs[0] round
     /* 1158369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158379 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158407 */     // GIR_Coverage, 15671,
     /* 1158407 */     GIR_EraseRootFromParent_Done,
     /* 1158408 */   // Label 16935: @1158408
     /* 1158408 */   GIM_Try, /*On fail goto*//*Label 16936*/ GIMT_Encode4(1158491), // Rule ID 15674 //
     /* 1158413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1158424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1158427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1158430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1158433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158452 */     // MIs[0] round
     /* 1158452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158462 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158490 */     // GIR_Coverage, 15674,
     /* 1158490 */     GIR_EraseRootFromParent_Done,
     /* 1158491 */   // Label 16936: @1158491
     /* 1158491 */   GIM_Try, /*On fail goto*//*Label 16937*/ GIMT_Encode4(1158574), // Rule ID 15675 //
     /* 1158496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1158507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1158510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1158513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1158516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158535 */     // MIs[0] round
     /* 1158535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158545 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158556 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158573 */     // GIR_Coverage, 15675,
     /* 1158573 */     GIR_EraseRootFromParent_Done,
     /* 1158574 */   // Label 16937: @1158574
     /* 1158574 */   GIM_Try, /*On fail goto*//*Label 16938*/ GIMT_Encode4(1158657), // Rule ID 15678 //
     /* 1158579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1158590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1158593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1158596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1158599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158618 */     // MIs[0] round
     /* 1158618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158628 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158656 */     // GIR_Coverage, 15678,
     /* 1158656 */     GIR_EraseRootFromParent_Done,
     /* 1158657 */   // Label 16938: @1158657
     /* 1158657 */   GIM_Try, /*On fail goto*//*Label 16939*/ GIMT_Encode4(1158740), // Rule ID 15679 //
     /* 1158662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1158673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1158676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1158679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1158682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158701 */     // MIs[0] round
     /* 1158701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158711 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158722 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158739 */     // GIR_Coverage, 15679,
     /* 1158739 */     GIR_EraseRootFromParent_Done,
     /* 1158740 */   // Label 16939: @1158740
     /* 1158740 */   GIM_Try, /*On fail goto*//*Label 16940*/ GIMT_Encode4(1158823), // Rule ID 15682 //
     /* 1158745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1158756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1158759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1158762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1158765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158784 */     // MIs[0] round
     /* 1158784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158794 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158822 */     // GIR_Coverage, 15682,
     /* 1158822 */     GIR_EraseRootFromParent_Done,
     /* 1158823 */   // Label 16940: @1158823
     /* 1158823 */   GIM_Try, /*On fail goto*//*Label 16941*/ GIMT_Encode4(1158906), // Rule ID 15683 //
     /* 1158828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1158839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1158842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1158845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1158848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158867 */     // MIs[0] round
     /* 1158867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158877 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158888 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158905 */     // GIR_Coverage, 15683,
     /* 1158905 */     GIR_EraseRootFromParent_Done,
     /* 1158906 */   // Label 16941: @1158906
     /* 1158906 */   GIM_Try, /*On fail goto*//*Label 16942*/ GIMT_Encode4(1158989), // Rule ID 15686 //
     /* 1158911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1158922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1158925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1158928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1158931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158950 */     // MIs[0] round
     /* 1158950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158960 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158988 */     // GIR_Coverage, 15686,
     /* 1158988 */     GIR_EraseRootFromParent_Done,
     /* 1158989 */   // Label 16942: @1158989
     /* 1158989 */   GIM_Try, /*On fail goto*//*Label 16943*/ GIMT_Encode4(1159072), // Rule ID 15687 //
     /* 1158994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1159005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1159008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1159011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1159014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159033 */     // MIs[0] round
     /* 1159033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159043 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159054 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159071 */     // GIR_Coverage, 15687,
     /* 1159071 */     GIR_EraseRootFromParent_Done,
     /* 1159072 */   // Label 16943: @1159072
     /* 1159072 */   GIM_Try, /*On fail goto*//*Label 16944*/ GIMT_Encode4(1159155), // Rule ID 15690 //
     /* 1159077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1159088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1159091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1159094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1159097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159116 */     // MIs[0] round
     /* 1159116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159126 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159154 */     // GIR_Coverage, 15690,
     /* 1159154 */     GIR_EraseRootFromParent_Done,
     /* 1159155 */   // Label 16944: @1159155
     /* 1159155 */   GIM_Try, /*On fail goto*//*Label 16945*/ GIMT_Encode4(1159238), // Rule ID 15691 //
     /* 1159160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1159171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1159174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1159177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1159180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159199 */     // MIs[0] round
     /* 1159199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159209 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159220 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159237 */     // GIR_Coverage, 15691,
     /* 1159237 */     GIR_EraseRootFromParent_Done,
     /* 1159238 */   // Label 16945: @1159238
     /* 1159238 */   GIM_Try, /*On fail goto*//*Label 16946*/ GIMT_Encode4(1159321), // Rule ID 15694 //
     /* 1159243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1159254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1159257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1159260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1159263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159282 */     // MIs[0] round
     /* 1159282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159320 */     // GIR_Coverage, 15694,
     /* 1159320 */     GIR_EraseRootFromParent_Done,
     /* 1159321 */   // Label 16946: @1159321
     /* 1159321 */   GIM_Try, /*On fail goto*//*Label 16947*/ GIMT_Encode4(1159404), // Rule ID 15695 //
     /* 1159326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1159337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1159340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1159343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1159346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159365 */     // MIs[0] round
     /* 1159365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159375 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159386 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159403 */     // GIR_Coverage, 15695,
     /* 1159403 */     GIR_EraseRootFromParent_Done,
     /* 1159404 */   // Label 16947: @1159404
     /* 1159404 */   GIM_Try, /*On fail goto*//*Label 16948*/ GIMT_Encode4(1159487), // Rule ID 15698 //
     /* 1159409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1159420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1159423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1159426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1159429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159448 */     // MIs[0] round
     /* 1159448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159458 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159486 */     // GIR_Coverage, 15698,
     /* 1159486 */     GIR_EraseRootFromParent_Done,
     /* 1159487 */   // Label 16948: @1159487
     /* 1159487 */   GIM_Try, /*On fail goto*//*Label 16949*/ GIMT_Encode4(1159570), // Rule ID 15699 //
     /* 1159492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1159503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1159506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1159509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1159512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159531 */     // MIs[0] round
     /* 1159531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159541 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159552 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159569 */     // GIR_Coverage, 15699,
     /* 1159569 */     GIR_EraseRootFromParent_Done,
     /* 1159570 */   // Label 16949: @1159570
     /* 1159570 */   GIM_Try, /*On fail goto*//*Label 16950*/ GIMT_Encode4(1159653), // Rule ID 15702 //
     /* 1159575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1159586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1159589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1159592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1159595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159614 */     // MIs[0] round
     /* 1159614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159624 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159652 */     // GIR_Coverage, 15702,
     /* 1159652 */     GIR_EraseRootFromParent_Done,
     /* 1159653 */   // Label 16950: @1159653
     /* 1159653 */   GIM_Try, /*On fail goto*//*Label 16951*/ GIMT_Encode4(1159736), // Rule ID 15703 //
     /* 1159658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1159669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1159672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1159675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1159678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159697 */     // MIs[0] round
     /* 1159697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159707 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159718 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159735 */     // GIR_Coverage, 15703,
     /* 1159735 */     GIR_EraseRootFromParent_Done,
     /* 1159736 */   // Label 16951: @1159736
     /* 1159736 */   GIM_Try, /*On fail goto*//*Label 16952*/ GIMT_Encode4(1159819), // Rule ID 15706 //
     /* 1159741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1159752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1159755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1159758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1159761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159780 */     // MIs[0] round
     /* 1159780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159818 */     // GIR_Coverage, 15706,
     /* 1159818 */     GIR_EraseRootFromParent_Done,
     /* 1159819 */   // Label 16952: @1159819
     /* 1159819 */   GIM_Try, /*On fail goto*//*Label 16953*/ GIMT_Encode4(1159902), // Rule ID 15707 //
     /* 1159824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1159835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1159838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1159841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1159844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159863 */     // MIs[0] round
     /* 1159863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159873 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159884 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159901 */     // GIR_Coverage, 15707,
     /* 1159901 */     GIR_EraseRootFromParent_Done,
     /* 1159902 */   // Label 16953: @1159902
     /* 1159902 */   GIM_Try, /*On fail goto*//*Label 16954*/ GIMT_Encode4(1159985), // Rule ID 15710 //
     /* 1159907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1159918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1159921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1159924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1159927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159946 */     // MIs[0] round
     /* 1159946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159956 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159984 */     // GIR_Coverage, 15710,
     /* 1159984 */     GIR_EraseRootFromParent_Done,
     /* 1159985 */   // Label 16954: @1159985
     /* 1159985 */   GIM_Try, /*On fail goto*//*Label 16955*/ GIMT_Encode4(1160068), // Rule ID 15711 //
     /* 1159990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1160001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1160004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1160007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1160010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160029 */     // MIs[0] round
     /* 1160029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160039 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1160042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160050 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160067 */     // GIR_Coverage, 15711,
     /* 1160067 */     GIR_EraseRootFromParent_Done,
     /* 1160068 */   // Label 16955: @1160068
     /* 1160068 */   GIM_Try, /*On fail goto*//*Label 16956*/ GIMT_Encode4(1160151), // Rule ID 15714 //
     /* 1160073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1160084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1160087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1160090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1160093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160112 */     // MIs[0] round
     /* 1160112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160122 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1160125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160150 */     // GIR_Coverage, 15714,
     /* 1160150 */     GIR_EraseRootFromParent_Done,
     /* 1160151 */   // Label 16956: @1160151
     /* 1160151 */   GIM_Try, /*On fail goto*//*Label 16957*/ GIMT_Encode4(1160234), // Rule ID 15715 //
     /* 1160156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1160167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1160170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1160173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1160176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160195 */     // MIs[0] round
     /* 1160195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160205 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1160208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160216 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160233 */     // GIR_Coverage, 15715,
     /* 1160233 */     GIR_EraseRootFromParent_Done,
     /* 1160234 */   // Label 16957: @1160234
     /* 1160234 */   GIM_Try, /*On fail goto*//*Label 16958*/ GIMT_Encode4(1160317), // Rule ID 15718 //
     /* 1160239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1160250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1160253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1160256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160278 */     // MIs[0] round
     /* 1160278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160288 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1160291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160316 */     // GIR_Coverage, 15718,
     /* 1160316 */     GIR_EraseRootFromParent_Done,
     /* 1160317 */   // Label 16958: @1160317
     /* 1160317 */   GIM_Try, /*On fail goto*//*Label 16959*/ GIMT_Encode4(1160400), // Rule ID 15719 //
     /* 1160322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1160333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1160336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1160339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160361 */     // MIs[0] round
     /* 1160361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160371 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1160374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160382 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160399 */     // GIR_Coverage, 15719,
     /* 1160399 */     GIR_EraseRootFromParent_Done,
     /* 1160400 */   // Label 16959: @1160400
     /* 1160400 */   GIM_Try, /*On fail goto*//*Label 16960*/ GIMT_Encode4(1160483), // Rule ID 15722 //
     /* 1160405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1160416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1160419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1160422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160444 */     // MIs[0] round
     /* 1160444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160454 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160482 */     // GIR_Coverage, 15722,
     /* 1160482 */     GIR_EraseRootFromParent_Done,
     /* 1160483 */   // Label 16960: @1160483
     /* 1160483 */   GIM_Try, /*On fail goto*//*Label 16961*/ GIMT_Encode4(1160566), // Rule ID 15723 //
     /* 1160488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1160499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1160502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1160505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160527 */     // MIs[0] round
     /* 1160527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160537 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160548 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160565 */     // GIR_Coverage, 15723,
     /* 1160565 */     GIR_EraseRootFromParent_Done,
     /* 1160566 */   // Label 16961: @1160566
     /* 1160566 */   GIM_Try, /*On fail goto*//*Label 16962*/ GIMT_Encode4(1160649), // Rule ID 15726 //
     /* 1160571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1160582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1160585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1160588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160610 */     // MIs[0] round
     /* 1160610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160620 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160648 */     // GIR_Coverage, 15726,
     /* 1160648 */     GIR_EraseRootFromParent_Done,
     /* 1160649 */   // Label 16962: @1160649
     /* 1160649 */   GIM_Try, /*On fail goto*//*Label 16963*/ GIMT_Encode4(1160732), // Rule ID 15727 //
     /* 1160654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1160665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1160668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1160671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160693 */     // MIs[0] round
     /* 1160693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160703 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160714 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160731 */     // GIR_Coverage, 15727,
     /* 1160731 */     GIR_EraseRootFromParent_Done,
     /* 1160732 */   // Label 16963: @1160732
     /* 1160732 */   GIM_Try, /*On fail goto*//*Label 16964*/ GIMT_Encode4(1160815), // Rule ID 15730 //
     /* 1160737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1160748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1160751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1160754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160776 */     // MIs[0] round
     /* 1160776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160814 */     // GIR_Coverage, 15730,
     /* 1160814 */     GIR_EraseRootFromParent_Done,
     /* 1160815 */   // Label 16964: @1160815
     /* 1160815 */   GIM_Try, /*On fail goto*//*Label 16965*/ GIMT_Encode4(1160898), // Rule ID 15731 //
     /* 1160820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1160831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1160834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1160837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160859 */     // MIs[0] round
     /* 1160859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160869 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160880 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160897 */     // GIR_Coverage, 15731,
     /* 1160897 */     GIR_EraseRootFromParent_Done,
     /* 1160898 */   // Label 16965: @1160898
     /* 1160898 */   GIM_Try, /*On fail goto*//*Label 16966*/ GIMT_Encode4(1160981), // Rule ID 15734 //
     /* 1160903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1160914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1160917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160942 */     // MIs[0] round
     /* 1160942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160952 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160980 */     // GIR_Coverage, 15734,
     /* 1160980 */     GIR_EraseRootFromParent_Done,
     /* 1160981 */   // Label 16966: @1160981
     /* 1160981 */   GIM_Try, /*On fail goto*//*Label 16967*/ GIMT_Encode4(1161064), // Rule ID 15735 //
     /* 1160986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1160997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1161000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1161003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161025 */     // MIs[0] round
     /* 1161025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161035 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1161038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161063 */     // GIR_Coverage, 15735,
     /* 1161063 */     GIR_EraseRootFromParent_Done,
     /* 1161064 */   // Label 16967: @1161064
     /* 1161064 */   GIM_Try, /*On fail goto*//*Label 16968*/ GIMT_Encode4(1161147), // Rule ID 15738 //
     /* 1161069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1161080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1161083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1161086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161108 */     // MIs[0] round
     /* 1161108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161118 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1161121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161146 */     // GIR_Coverage, 15738,
     /* 1161146 */     GIR_EraseRootFromParent_Done,
     /* 1161147 */   // Label 16968: @1161147
     /* 1161147 */   GIM_Try, /*On fail goto*//*Label 16969*/ GIMT_Encode4(1161230), // Rule ID 15739 //
     /* 1161152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1161163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1161166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1161169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161191 */     // MIs[0] round
     /* 1161191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161201 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1161204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161212 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161229 */     // GIR_Coverage, 15739,
     /* 1161229 */     GIR_EraseRootFromParent_Done,
     /* 1161230 */   // Label 16969: @1161230
     /* 1161230 */   GIM_Try, /*On fail goto*//*Label 16970*/ GIMT_Encode4(1161313), // Rule ID 15742 //
     /* 1161235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1161246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1161249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1161252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161274 */     // MIs[0] round
     /* 1161274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161284 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161312 */     // GIR_Coverage, 15742,
     /* 1161312 */     GIR_EraseRootFromParent_Done,
     /* 1161313 */   // Label 16970: @1161313
     /* 1161313 */   GIM_Try, /*On fail goto*//*Label 16971*/ GIMT_Encode4(1161396), // Rule ID 15743 //
     /* 1161318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1161329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1161332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1161335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161357 */     // MIs[0] round
     /* 1161357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161367 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11616:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161378 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161395 */     // GIR_Coverage, 15743,
     /* 1161395 */     GIR_EraseRootFromParent_Done,
     /* 1161396 */   // Label 16971: @1161396
     /* 1161396 */   GIM_Try, /*On fail goto*//*Label 16972*/ GIMT_Encode4(1161479), // Rule ID 15746 //
     /* 1161401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1161412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1161415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1161418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161440 */     // MIs[0] round
     /* 1161440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161450 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161478 */     // GIR_Coverage, 15746,
     /* 1161478 */     GIR_EraseRootFromParent_Done,
     /* 1161479 */   // Label 16972: @1161479
     /* 1161479 */   GIM_Try, /*On fail goto*//*Label 16973*/ GIMT_Encode4(1161562), // Rule ID 15747 //
     /* 1161484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1161495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1161498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1161501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161523 */     // MIs[0] round
     /* 1161523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161533 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161544 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161561 */     // GIR_Coverage, 15747,
     /* 1161561 */     GIR_EraseRootFromParent_Done,
     /* 1161562 */   // Label 16973: @1161562
     /* 1161562 */   GIM_Try, /*On fail goto*//*Label 16974*/ GIMT_Encode4(1161645), // Rule ID 15750 //
     /* 1161567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1161578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1161581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1161584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161606 */     // MIs[0] round
     /* 1161606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161616 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161644 */     // GIR_Coverage, 15750,
     /* 1161644 */     GIR_EraseRootFromParent_Done,
     /* 1161645 */   // Label 16974: @1161645
     /* 1161645 */   GIM_Try, /*On fail goto*//*Label 16975*/ GIMT_Encode4(1161728), // Rule ID 15751 //
     /* 1161650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1161661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1161664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1161667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161689 */     // MIs[0] round
     /* 1161689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161699 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161727 */     // GIR_Coverage, 15751,
     /* 1161727 */     GIR_EraseRootFromParent_Done,
     /* 1161728 */   // Label 16975: @1161728
     /* 1161728 */   GIM_Try, /*On fail goto*//*Label 16976*/ GIMT_Encode4(1161811), // Rule ID 15754 //
     /* 1161733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1161744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1161747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161772 */     // MIs[0] round
     /* 1161772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161782 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161810 */     // GIR_Coverage, 15754,
     /* 1161810 */     GIR_EraseRootFromParent_Done,
     /* 1161811 */   // Label 16976: @1161811
     /* 1161811 */   GIM_Try, /*On fail goto*//*Label 16977*/ GIMT_Encode4(1161894), // Rule ID 15755 //
     /* 1161816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1161827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1161830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161855 */     // MIs[0] round
     /* 1161855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161865 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161876 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161893 */     // GIR_Coverage, 15755,
     /* 1161893 */     GIR_EraseRootFromParent_Done,
     /* 1161894 */   // Label 16977: @1161894
     /* 1161894 */   GIM_Try, /*On fail goto*//*Label 16978*/ GIMT_Encode4(1161977), // Rule ID 15758 //
     /* 1161899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1161910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1161913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161938 */     // MIs[0] round
     /* 1161938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161948 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1161951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161976 */     // GIR_Coverage, 15758,
     /* 1161976 */     GIR_EraseRootFromParent_Done,
     /* 1161977 */   // Label 16978: @1161977
     /* 1161977 */   GIM_Try, /*On fail goto*//*Label 16979*/ GIMT_Encode4(1162060), // Rule ID 15759 //
     /* 1161982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1161993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1161996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162021 */     // MIs[0] round
     /* 1162021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162031 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162042 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1162052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162059 */     // GIR_Coverage, 15759,
     /* 1162059 */     GIR_EraseRootFromParent_Done,
     /* 1162060 */   // Label 16979: @1162060
     /* 1162060 */   GIM_Try, /*On fail goto*//*Label 16980*/ GIMT_Encode4(1162143), // Rule ID 15762 //
     /* 1162065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1162076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1162079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1162082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162104 */     // MIs[0] round
     /* 1162104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162114 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1162135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162142 */     // GIR_Coverage, 15762,
     /* 1162142 */     GIR_EraseRootFromParent_Done,
     /* 1162143 */   // Label 16980: @1162143
     /* 1162143 */   GIM_Try, /*On fail goto*//*Label 16981*/ GIMT_Encode4(1162226), // Rule ID 15763 //
     /* 1162148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1162159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1162162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1162165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162187 */     // MIs[0] round
     /* 1162187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162197 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162208 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1162218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162221 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162225 */     // GIR_Coverage, 15763,
     /* 1162225 */     GIR_EraseRootFromParent_Done,
     /* 1162226 */   // Label 16981: @1162226
     /* 1162226 */   GIM_Try, /*On fail goto*//*Label 16982*/ GIMT_Encode4(1162309), // Rule ID 15766 //
     /* 1162231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1162242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1162245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1162248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162270 */     // MIs[0] round
     /* 1162270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162280 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162308 */     // GIR_Coverage, 15766,
     /* 1162308 */     GIR_EraseRootFromParent_Done,
     /* 1162309 */   // Label 16982: @1162309
     /* 1162309 */   GIM_Try, /*On fail goto*//*Label 16983*/ GIMT_Encode4(1162392), // Rule ID 15767 //
     /* 1162314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1162325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1162328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1162331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162353 */     // MIs[0] round
     /* 1162353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162363 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162374 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162391 */     // GIR_Coverage, 15767,
     /* 1162391 */     GIR_EraseRootFromParent_Done,
     /* 1162392 */   // Label 16983: @1162392
     /* 1162392 */   GIM_Try, /*On fail goto*//*Label 16984*/ GIMT_Encode4(1162475), // Rule ID 15770 //
     /* 1162397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1162408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1162411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1162414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162436 */     // MIs[0] round
     /* 1162436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162446 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162474 */     // GIR_Coverage, 15770,
     /* 1162474 */     GIR_EraseRootFromParent_Done,
     /* 1162475 */   // Label 16984: @1162475
     /* 1162475 */   GIM_Try, /*On fail goto*//*Label 16985*/ GIMT_Encode4(1162558), // Rule ID 15771 //
     /* 1162480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1162491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1162494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1162497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162519 */     // MIs[0] round
     /* 1162519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162529 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162540 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162557 */     // GIR_Coverage, 15771,
     /* 1162557 */     GIR_EraseRootFromParent_Done,
     /* 1162558 */   // Label 16985: @1162558
     /* 1162558 */   GIM_Try, /*On fail goto*//*Label 16986*/ GIMT_Encode4(1162641), // Rule ID 15774 //
     /* 1162563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1162574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1162577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1162580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162602 */     // MIs[0] round
     /* 1162602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162612 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162640 */     // GIR_Coverage, 15774,
     /* 1162640 */     GIR_EraseRootFromParent_Done,
     /* 1162641 */   // Label 16986: @1162641
     /* 1162641 */   GIM_Try, /*On fail goto*//*Label 16987*/ GIMT_Encode4(1162724), // Rule ID 15775 //
     /* 1162646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1162657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1162660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1162663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162685 */     // MIs[0] round
     /* 1162685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162695 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162706 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162719 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162723 */     // GIR_Coverage, 15775,
     /* 1162723 */     GIR_EraseRootFromParent_Done,
     /* 1162724 */   // Label 16987: @1162724
     /* 1162724 */   GIM_Try, /*On fail goto*//*Label 16988*/ GIMT_Encode4(1162807), // Rule ID 15778 //
     /* 1162729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1162740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1162743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1162746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162768 */     // MIs[0] round
     /* 1162768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162806 */     // GIR_Coverage, 15778,
     /* 1162806 */     GIR_EraseRootFromParent_Done,
     /* 1162807 */   // Label 16988: @1162807
     /* 1162807 */   GIM_Try, /*On fail goto*//*Label 16989*/ GIMT_Encode4(1162890), // Rule ID 15779 //
     /* 1162812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1162823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1162826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1162829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162851 */     // MIs[0] round
     /* 1162851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162861 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162872 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162889 */     // GIR_Coverage, 15779,
     /* 1162889 */     GIR_EraseRootFromParent_Done,
     /* 1162890 */   // Label 16989: @1162890
     /* 1162890 */   GIM_Try, /*On fail goto*//*Label 16990*/ GIMT_Encode4(1162973), // Rule ID 15782 //
     /* 1162895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1162906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1162909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162934 */     // MIs[0] round
     /* 1162934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162944 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162972 */     // GIR_Coverage, 15782,
     /* 1162972 */     GIR_EraseRootFromParent_Done,
     /* 1162973 */   // Label 16990: @1162973
     /* 1162973 */   GIM_Try, /*On fail goto*//*Label 16991*/ GIMT_Encode4(1163056), // Rule ID 15783 //
     /* 1162978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1162989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1162992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163017 */     // MIs[0] round
     /* 1163017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163027 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1163030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163038 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163055 */     // GIR_Coverage, 15783,
     /* 1163055 */     GIR_EraseRootFromParent_Done,
     /* 1163056 */   // Label 16991: @1163056
     /* 1163056 */   GIM_Try, /*On fail goto*//*Label 16992*/ GIMT_Encode4(1163139), // Rule ID 15786 //
     /* 1163061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1163072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1163075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1163078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163100 */     // MIs[0] round
     /* 1163100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163110 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1163113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163138 */     // GIR_Coverage, 15786,
     /* 1163138 */     GIR_EraseRootFromParent_Done,
     /* 1163139 */   // Label 16992: @1163139
     /* 1163139 */   GIM_Try, /*On fail goto*//*Label 16993*/ GIMT_Encode4(1163222), // Rule ID 15787 //
     /* 1163144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1163155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1163158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1163161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163183 */     // MIs[0] round
     /* 1163183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163193 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1163196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163204 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163221 */     // GIR_Coverage, 15787,
     /* 1163221 */     GIR_EraseRootFromParent_Done,
     /* 1163222 */   // Label 16993: @1163222
     /* 1163222 */   GIM_Try, /*On fail goto*//*Label 16994*/ GIMT_Encode4(1163305), // Rule ID 15790 //
     /* 1163227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1163247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163266 */     // MIs[0] round
     /* 1163266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1163279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163304 */     // GIR_Coverage, 15790,
     /* 1163304 */     GIR_EraseRootFromParent_Done,
     /* 1163305 */   // Label 16994: @1163305
     /* 1163305 */   GIM_Try, /*On fail goto*//*Label 16995*/ GIMT_Encode4(1163388), // Rule ID 15791 //
     /* 1163310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1163330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163349 */     // MIs[0] round
     /* 1163349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163359 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1163362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163370 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163387 */     // GIR_Coverage, 15791,
     /* 1163387 */     GIR_EraseRootFromParent_Done,
     /* 1163388 */   // Label 16995: @1163388
     /* 1163388 */   GIM_Try, /*On fail goto*//*Label 16996*/ GIMT_Encode4(1163471), // Rule ID 15794 //
     /* 1163393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1163404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1163407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1163410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1163413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163432 */     // MIs[0] round
     /* 1163432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163442 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1163445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163470 */     // GIR_Coverage, 15794,
     /* 1163470 */     GIR_EraseRootFromParent_Done,
     /* 1163471 */   // Label 16996: @1163471
     /* 1163471 */   GIM_Try, /*On fail goto*//*Label 16997*/ GIMT_Encode4(1163554), // Rule ID 15795 //
     /* 1163476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1163487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1163490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1163493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1163496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163515 */     // MIs[0] round
     /* 1163515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163525 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1163528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163536 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163553 */     // GIR_Coverage, 15795,
     /* 1163553 */     GIR_EraseRootFromParent_Done,
     /* 1163554 */   // Label 16997: @1163554
     /* 1163554 */   GIM_Try, /*On fail goto*//*Label 16998*/ GIMT_Encode4(1163637), // Rule ID 15798 //
     /* 1163559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1163579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163598 */     // MIs[0] round
     /* 1163598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163608 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1163611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163636 */     // GIR_Coverage, 15798,
     /* 1163636 */     GIR_EraseRootFromParent_Done,
     /* 1163637 */   // Label 16998: @1163637
     /* 1163637 */   GIM_Try, /*On fail goto*//*Label 16999*/ GIMT_Encode4(1163720), // Rule ID 15799 //
     /* 1163642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1163662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163681 */     // MIs[0] round
     /* 1163681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163691 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1163694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163702 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163719 */     // GIR_Coverage, 15799,
     /* 1163719 */     GIR_EraseRootFromParent_Done,
     /* 1163720 */   // Label 16999: @1163720
     /* 1163720 */   GIM_Try, /*On fail goto*//*Label 17000*/ GIMT_Encode4(1163803), // Rule ID 15802 //
     /* 1163725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1163745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163764 */     // MIs[0] round
     /* 1163764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163774 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1163777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163802 */     // GIR_Coverage, 15802,
     /* 1163802 */     GIR_EraseRootFromParent_Done,
     /* 1163803 */   // Label 17000: @1163803
     /* 1163803 */   GIM_Try, /*On fail goto*//*Label 17001*/ GIMT_Encode4(1163886), // Rule ID 15803 //
     /* 1163808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1163828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163847 */     // MIs[0] round
     /* 1163847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163857 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1163860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163868 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163885 */     // GIR_Coverage, 15803,
     /* 1163885 */     GIR_EraseRootFromParent_Done,
     /* 1163886 */   // Label 17001: @1163886
     /* 1163886 */   GIM_Try, /*On fail goto*//*Label 17002*/ GIMT_Encode4(1163969), // Rule ID 15806 //
     /* 1163891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163930 */     // MIs[0] round
     /* 1163930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163940 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1163943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163968 */     // GIR_Coverage, 15806,
     /* 1163968 */     GIR_EraseRootFromParent_Done,
     /* 1163969 */   // Label 17002: @1163969
     /* 1163969 */   GIM_Try, /*On fail goto*//*Label 17003*/ GIMT_Encode4(1164052), // Rule ID 15807 //
     /* 1163974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164013 */     // MIs[0] round
     /* 1164013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164023 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1164026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164034 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164051 */     // GIR_Coverage, 15807,
     /* 1164051 */     GIR_EraseRootFromParent_Done,
     /* 1164052 */   // Label 17003: @1164052
     /* 1164052 */   GIM_Try, /*On fail goto*//*Label 17004*/ GIMT_Encode4(1164135), // Rule ID 15810 //
     /* 1164057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1164060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1164068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1164071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1164074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164096 */     // MIs[0] round
     /* 1164096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164106 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1164109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164134 */     // GIR_Coverage, 15810,
     /* 1164134 */     GIR_EraseRootFromParent_Done,
     /* 1164135 */   // Label 17004: @1164135
     /* 1164135 */   GIM_Try, /*On fail goto*//*Label 17005*/ GIMT_Encode4(1164218), // Rule ID 15811 //
     /* 1164140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1164143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1164151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1164154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1164157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164179 */     // MIs[0] round
     /* 1164179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164189 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1164192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164200 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164217 */     // GIR_Coverage, 15811,
     /* 1164217 */     GIR_EraseRootFromParent_Done,
     /* 1164218 */   // Label 17005: @1164218
     /* 1164218 */   GIM_Try, /*On fail goto*//*Label 17006*/ GIMT_Encode4(1164301), // Rule ID 15814 //
     /* 1164223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1164226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1164234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1164237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1164240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164262 */     // MIs[0] round
     /* 1164262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164272 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1164275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164300 */     // GIR_Coverage, 15814,
     /* 1164300 */     GIR_EraseRootFromParent_Done,
     /* 1164301 */   // Label 17006: @1164301
     /* 1164301 */   GIM_Try, /*On fail goto*//*Label 17007*/ GIMT_Encode4(1164384), // Rule ID 15815 //
     /* 1164306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1164309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1164317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1164320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1164323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164345 */     // MIs[0] round
     /* 1164345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164355 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1164358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164383 */     // GIR_Coverage, 15815,
     /* 1164383 */     GIR_EraseRootFromParent_Done,
     /* 1164384 */   // Label 17007: @1164384
     /* 1164384 */   GIM_Try, /*On fail goto*//*Label 17008*/ GIMT_Encode4(1164467), // Rule ID 15818 //
     /* 1164389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1164392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1164400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1164403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1164406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164428 */     // MIs[0] round
     /* 1164428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164438 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1164441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164466 */     // GIR_Coverage, 15818,
     /* 1164466 */     GIR_EraseRootFromParent_Done,
     /* 1164467 */   // Label 17008: @1164467
     /* 1164467 */   GIM_Try, /*On fail goto*//*Label 17009*/ GIMT_Encode4(1164550), // Rule ID 15819 //
     /* 1164472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1164475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1164483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1164486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1164489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164511 */     // MIs[0] round
     /* 1164511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164521 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1164524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164532 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164549 */     // GIR_Coverage, 15819,
     /* 1164549 */     GIR_EraseRootFromParent_Done,
     /* 1164550 */   // Label 17009: @1164550
     /* 1164550 */   GIM_Try, /*On fail goto*//*Label 17010*/ GIMT_Encode4(1164630), // Rule ID 15822 //
     /* 1164555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1164566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1164569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1164572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1164575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164594 */     // MIs[0] round
     /* 1164594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164604 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1164607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164629 */     // GIR_Coverage, 15822,
     /* 1164629 */     GIR_EraseRootFromParent_Done,
     /* 1164630 */   // Label 17010: @1164630
     /* 1164630 */   GIM_Try, /*On fail goto*//*Label 17011*/ GIMT_Encode4(1164710), // Rule ID 15823 //
     /* 1164635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1164646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1164649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1164652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1164655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164674 */     // MIs[0] round
     /* 1164674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164684 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1164687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164709 */     // GIR_Coverage, 15823,
     /* 1164709 */     GIR_EraseRootFromParent_Done,
     /* 1164710 */   // Label 17011: @1164710
     /* 1164710 */   GIM_Try, /*On fail goto*//*Label 17012*/ GIMT_Encode4(1164790), // Rule ID 15826 //
     /* 1164715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1164726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1164729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1164732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1164735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164754 */     // MIs[0] round
     /* 1164754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164764 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164789 */     // GIR_Coverage, 15826,
     /* 1164789 */     GIR_EraseRootFromParent_Done,
     /* 1164790 */   // Label 17012: @1164790
     /* 1164790 */   GIM_Try, /*On fail goto*//*Label 17013*/ GIMT_Encode4(1164870), // Rule ID 15827 //
     /* 1164795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1164806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1164809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1164812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1164815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164834 */     // MIs[0] round
     /* 1164834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164844 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164869 */     // GIR_Coverage, 15827,
     /* 1164869 */     GIR_EraseRootFromParent_Done,
     /* 1164870 */   // Label 17013: @1164870
     /* 1164870 */   GIM_Try, /*On fail goto*//*Label 17014*/ GIMT_Encode4(1164950), // Rule ID 15830 //
     /* 1164875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1164886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1164889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1164892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1164895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164914 */     // MIs[0] round
     /* 1164914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164924 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164949 */     // GIR_Coverage, 15830,
     /* 1164949 */     GIR_EraseRootFromParent_Done,
     /* 1164950 */   // Label 17014: @1164950
     /* 1164950 */   GIM_Try, /*On fail goto*//*Label 17015*/ GIMT_Encode4(1165030), // Rule ID 15831 //
     /* 1164955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1164966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1164969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1164972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1164975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164994 */     // MIs[0] round
     /* 1164994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165004 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1165007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165029 */     // GIR_Coverage, 15831,
     /* 1165029 */     GIR_EraseRootFromParent_Done,
     /* 1165030 */   // Label 17015: @1165030
     /* 1165030 */   GIM_Try, /*On fail goto*//*Label 17016*/ GIMT_Encode4(1165110), // Rule ID 15834 //
     /* 1165035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1165046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1165049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1165052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1165055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165074 */     // MIs[0] round
     /* 1165074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1165087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165109 */     // GIR_Coverage, 15834,
     /* 1165109 */     GIR_EraseRootFromParent_Done,
     /* 1165110 */   // Label 17016: @1165110
     /* 1165110 */   GIM_Try, /*On fail goto*//*Label 17017*/ GIMT_Encode4(1165190), // Rule ID 15835 //
     /* 1165115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1165126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1165129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1165132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1165135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165154 */     // MIs[0] round
     /* 1165154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165164 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1165167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165189 */     // GIR_Coverage, 15835,
     /* 1165189 */     GIR_EraseRootFromParent_Done,
     /* 1165190 */   // Label 17017: @1165190
     /* 1165190 */   GIM_Try, /*On fail goto*//*Label 17018*/ GIMT_Encode4(1165270), // Rule ID 15838 //
     /* 1165195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1165206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1165209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1165212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1165215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165234 */     // MIs[0] round
     /* 1165234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165244 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1165247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165269 */     // GIR_Coverage, 15838,
     /* 1165269 */     GIR_EraseRootFromParent_Done,
     /* 1165270 */   // Label 17018: @1165270
     /* 1165270 */   GIM_Try, /*On fail goto*//*Label 17019*/ GIMT_Encode4(1165350), // Rule ID 15839 //
     /* 1165275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1165286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1165289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1165292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1165295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165314 */     // MIs[0] round
     /* 1165314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165324 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1165327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165349 */     // GIR_Coverage, 15839,
     /* 1165349 */     GIR_EraseRootFromParent_Done,
     /* 1165350 */   // Label 17019: @1165350
     /* 1165350 */   GIM_Try, /*On fail goto*//*Label 17020*/ GIMT_Encode4(1165430), // Rule ID 15842 //
     /* 1165355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1165366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1165369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1165372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1165375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165394 */     // MIs[0] round
     /* 1165394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1165407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165429 */     // GIR_Coverage, 15842,
     /* 1165429 */     GIR_EraseRootFromParent_Done,
     /* 1165430 */   // Label 17020: @1165430
     /* 1165430 */   GIM_Try, /*On fail goto*//*Label 17021*/ GIMT_Encode4(1165510), // Rule ID 15843 //
     /* 1165435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1165446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1165449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1165452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1165455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165474 */     // MIs[0] round
     /* 1165474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1165487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165509 */     // GIR_Coverage, 15843,
     /* 1165509 */     GIR_EraseRootFromParent_Done,
     /* 1165510 */   // Label 17021: @1165510
     /* 1165510 */   GIM_Try, /*On fail goto*//*Label 17022*/ GIMT_Encode4(1165590), // Rule ID 15846 //
     /* 1165515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1165526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1165529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1165532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1165535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165554 */     // MIs[0] round
     /* 1165554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165564 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165589 */     // GIR_Coverage, 15846,
     /* 1165589 */     GIR_EraseRootFromParent_Done,
     /* 1165590 */   // Label 17022: @1165590
     /* 1165590 */   GIM_Try, /*On fail goto*//*Label 17023*/ GIMT_Encode4(1165670), // Rule ID 15847 //
     /* 1165595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1165606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1165609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1165612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1165615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165634 */     // MIs[0] round
     /* 1165634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165669 */     // GIR_Coverage, 15847,
     /* 1165669 */     GIR_EraseRootFromParent_Done,
     /* 1165670 */   // Label 17023: @1165670
     /* 1165670 */   GIM_Try, /*On fail goto*//*Label 17024*/ GIMT_Encode4(1165750), // Rule ID 15850 //
     /* 1165675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1165686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1165689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1165692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1165695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165714 */     // MIs[0] round
     /* 1165714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165749 */     // GIR_Coverage, 15850,
     /* 1165749 */     GIR_EraseRootFromParent_Done,
     /* 1165750 */   // Label 17024: @1165750
     /* 1165750 */   GIM_Try, /*On fail goto*//*Label 17025*/ GIMT_Encode4(1165830), // Rule ID 15851 //
     /* 1165755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1165766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1165769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1165772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1165775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165794 */     // MIs[0] round
     /* 1165794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165829 */     // GIR_Coverage, 15851,
     /* 1165829 */     GIR_EraseRootFromParent_Done,
     /* 1165830 */   // Label 17025: @1165830
     /* 1165830 */   GIM_Try, /*On fail goto*//*Label 17026*/ GIMT_Encode4(1165910), // Rule ID 15854 //
     /* 1165835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1165846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1165849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1165852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1165855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165874 */     // MIs[0] round
     /* 1165874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165884 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165909 */     // GIR_Coverage, 15854,
     /* 1165909 */     GIR_EraseRootFromParent_Done,
     /* 1165910 */   // Label 17026: @1165910
     /* 1165910 */   GIM_Try, /*On fail goto*//*Label 17027*/ GIMT_Encode4(1165990), // Rule ID 15855 //
     /* 1165915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1165926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1165929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1165932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1165935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165954 */     // MIs[0] round
     /* 1165954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165964 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165989 */     // GIR_Coverage, 15855,
     /* 1165989 */     GIR_EraseRootFromParent_Done,
     /* 1165990 */   // Label 17027: @1165990
     /* 1165990 */   GIM_Try, /*On fail goto*//*Label 17028*/ GIMT_Encode4(1166070), // Rule ID 15858 //
     /* 1165995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1165998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1166006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1166009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1166012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1166015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166034 */     // MIs[0] round
     /* 1166034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166044 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1166047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166069 */     // GIR_Coverage, 15858,
     /* 1166069 */     GIR_EraseRootFromParent_Done,
     /* 1166070 */   // Label 17028: @1166070
     /* 1166070 */   GIM_Try, /*On fail goto*//*Label 17029*/ GIMT_Encode4(1166150), // Rule ID 15859 //
     /* 1166075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1166078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1166086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1166089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1166092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1166095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166114 */     // MIs[0] round
     /* 1166114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1166127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166149 */     // GIR_Coverage, 15859,
     /* 1166149 */     GIR_EraseRootFromParent_Done,
     /* 1166150 */   // Label 17029: @1166150
     /* 1166150 */   GIM_Try, /*On fail goto*//*Label 17030*/ GIMT_Encode4(1166230), // Rule ID 15862 //
     /* 1166155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1166166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1166169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1166172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1166175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166194 */     // MIs[0] round
     /* 1166194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166204 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166229 */     // GIR_Coverage, 15862,
     /* 1166229 */     GIR_EraseRootFromParent_Done,
     /* 1166230 */   // Label 17030: @1166230
     /* 1166230 */   GIM_Try, /*On fail goto*//*Label 17031*/ GIMT_Encode4(1166310), // Rule ID 15863 //
     /* 1166235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1166246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1166249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1166252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1166255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166274 */     // MIs[0] round
     /* 1166274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166284 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166309 */     // GIR_Coverage, 15863,
     /* 1166309 */     GIR_EraseRootFromParent_Done,
     /* 1166310 */   // Label 17031: @1166310
     /* 1166310 */   GIM_Try, /*On fail goto*//*Label 17032*/ GIMT_Encode4(1166390), // Rule ID 15866 //
     /* 1166315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1166326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1166329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1166332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1166335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166354 */     // MIs[0] round
     /* 1166354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166364 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166389 */     // GIR_Coverage, 15866,
     /* 1166389 */     GIR_EraseRootFromParent_Done,
     /* 1166390 */   // Label 17032: @1166390
     /* 1166390 */   GIM_Try, /*On fail goto*//*Label 17033*/ GIMT_Encode4(1166470), // Rule ID 15867 //
     /* 1166395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1166406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1166409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1166412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1166415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166434 */     // MIs[0] round
     /* 1166434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166444 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166469 */     // GIR_Coverage, 15867,
     /* 1166469 */     GIR_EraseRootFromParent_Done,
     /* 1166470 */   // Label 17033: @1166470
     /* 1166470 */   GIM_Try, /*On fail goto*//*Label 17034*/ GIMT_Encode4(1166550), // Rule ID 15870 //
     /* 1166475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1166486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1166489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1166492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1166495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166514 */     // MIs[0] round
     /* 1166514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166524 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166549 */     // GIR_Coverage, 15870,
     /* 1166549 */     GIR_EraseRootFromParent_Done,
     /* 1166550 */   // Label 17034: @1166550
     /* 1166550 */   GIM_Try, /*On fail goto*//*Label 17035*/ GIMT_Encode4(1166630), // Rule ID 15871 //
     /* 1166555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1166566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1166569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1166572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1166575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166594 */     // MIs[0] round
     /* 1166594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166604 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166629 */     // GIR_Coverage, 15871,
     /* 1166629 */     GIR_EraseRootFromParent_Done,
     /* 1166630 */   // Label 17035: @1166630
     /* 1166630 */   GIM_Try, /*On fail goto*//*Label 17036*/ GIMT_Encode4(1166710), // Rule ID 15874 //
     /* 1166635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1166646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1166649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1166652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1166655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166674 */     // MIs[0] round
     /* 1166674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166709 */     // GIR_Coverage, 15874,
     /* 1166709 */     GIR_EraseRootFromParent_Done,
     /* 1166710 */   // Label 17036: @1166710
     /* 1166710 */   GIM_Try, /*On fail goto*//*Label 17037*/ GIMT_Encode4(1166790), // Rule ID 15875 //
     /* 1166715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1166726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1166729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1166732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1166735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166754 */     // MIs[0] round
     /* 1166754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166764 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166789 */     // GIR_Coverage, 15875,
     /* 1166789 */     GIR_EraseRootFromParent_Done,
     /* 1166790 */   // Label 17037: @1166790
     /* 1166790 */   GIM_Try, /*On fail goto*//*Label 17038*/ GIMT_Encode4(1166870), // Rule ID 15878 //
     /* 1166795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1166806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1166809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1166812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1166815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166834 */     // MIs[0] round
     /* 1166834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166844 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166869 */     // GIR_Coverage, 15878,
     /* 1166869 */     GIR_EraseRootFromParent_Done,
     /* 1166870 */   // Label 17038: @1166870
     /* 1166870 */   GIM_Try, /*On fail goto*//*Label 17039*/ GIMT_Encode4(1166950), // Rule ID 15879 //
     /* 1166875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1166886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1166889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1166892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1166895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166914 */     // MIs[0] round
     /* 1166914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166924 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166949 */     // GIR_Coverage, 15879,
     /* 1166949 */     GIR_EraseRootFromParent_Done,
     /* 1166950 */   // Label 17039: @1166950
     /* 1166950 */   GIM_Try, /*On fail goto*//*Label 17040*/ GIMT_Encode4(1167030), // Rule ID 15882 //
     /* 1166955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1166966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1166969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1166972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1166975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166994 */     // MIs[0] round
     /* 1166994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167004 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167029 */     // GIR_Coverage, 15882,
     /* 1167029 */     GIR_EraseRootFromParent_Done,
     /* 1167030 */   // Label 17040: @1167030
     /* 1167030 */   GIM_Try, /*On fail goto*//*Label 17041*/ GIMT_Encode4(1167110), // Rule ID 15883 //
     /* 1167035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1167046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1167049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1167052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1167055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167074 */     // MIs[0] round
     /* 1167074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167084 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167109 */     // GIR_Coverage, 15883,
     /* 1167109 */     GIR_EraseRootFromParent_Done,
     /* 1167110 */   // Label 17041: @1167110
     /* 1167110 */   GIM_Try, /*On fail goto*//*Label 17042*/ GIMT_Encode4(1167190), // Rule ID 15886 //
     /* 1167115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1167126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1167129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1167132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1167135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167154 */     // MIs[0] round
     /* 1167154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1167167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167189 */     // GIR_Coverage, 15886,
     /* 1167189 */     GIR_EraseRootFromParent_Done,
     /* 1167190 */   // Label 17042: @1167190
     /* 1167190 */   GIM_Try, /*On fail goto*//*Label 17043*/ GIMT_Encode4(1167270), // Rule ID 15887 //
     /* 1167195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1167206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1167209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1167212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1167215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167234 */     // MIs[0] round
     /* 1167234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1167247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167269 */     // GIR_Coverage, 15887,
     /* 1167269 */     GIR_EraseRootFromParent_Done,
     /* 1167270 */   // Label 17043: @1167270
     /* 1167270 */   GIM_Try, /*On fail goto*//*Label 17044*/ GIMT_Encode4(1167350), // Rule ID 15890 //
     /* 1167275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1167286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1167289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1167292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1167295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167314 */     // MIs[0] round
     /* 1167314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167324 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167349 */     // GIR_Coverage, 15890,
     /* 1167349 */     GIR_EraseRootFromParent_Done,
     /* 1167350 */   // Label 17044: @1167350
     /* 1167350 */   GIM_Try, /*On fail goto*//*Label 17045*/ GIMT_Encode4(1167430), // Rule ID 15891 //
     /* 1167355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1167366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1167369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1167372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1167375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167394 */     // MIs[0] round
     /* 1167394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167404 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167429 */     // GIR_Coverage, 15891,
     /* 1167429 */     GIR_EraseRootFromParent_Done,
     /* 1167430 */   // Label 17045: @1167430
     /* 1167430 */   GIM_Try, /*On fail goto*//*Label 17046*/ GIMT_Encode4(1167510), // Rule ID 15894 //
     /* 1167435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1167446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1167449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1167452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1167455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167474 */     // MIs[0] round
     /* 1167474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167484 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167509 */     // GIR_Coverage, 15894,
     /* 1167509 */     GIR_EraseRootFromParent_Done,
     /* 1167510 */   // Label 17046: @1167510
     /* 1167510 */   GIM_Try, /*On fail goto*//*Label 17047*/ GIMT_Encode4(1167590), // Rule ID 15895 //
     /* 1167515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1167526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1167529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1167532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1167535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167554 */     // MIs[0] round
     /* 1167554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167564 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167589 */     // GIR_Coverage, 15895,
     /* 1167589 */     GIR_EraseRootFromParent_Done,
     /* 1167590 */   // Label 17047: @1167590
     /* 1167590 */   GIM_Try, /*On fail goto*//*Label 17048*/ GIMT_Encode4(1167670), // Rule ID 15898 //
     /* 1167595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1167606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1167609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1167612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1167615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167634 */     // MIs[0] round
     /* 1167634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1167647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167669 */     // GIR_Coverage, 15898,
     /* 1167669 */     GIR_EraseRootFromParent_Done,
     /* 1167670 */   // Label 17048: @1167670
     /* 1167670 */   GIM_Try, /*On fail goto*//*Label 17049*/ GIMT_Encode4(1167750), // Rule ID 15899 //
     /* 1167675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1167686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1167689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1167692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1167695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167714 */     // MIs[0] round
     /* 1167714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1167727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167749 */     // GIR_Coverage, 15899,
     /* 1167749 */     GIR_EraseRootFromParent_Done,
     /* 1167750 */   // Label 17049: @1167750
     /* 1167750 */   GIM_Try, /*On fail goto*//*Label 17050*/ GIMT_Encode4(1167830), // Rule ID 15902 //
     /* 1167755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1167766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1167769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1167772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1167775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167794 */     // MIs[0] round
     /* 1167794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167804 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167829 */     // GIR_Coverage, 15902,
     /* 1167829 */     GIR_EraseRootFromParent_Done,
     /* 1167830 */   // Label 17050: @1167830
     /* 1167830 */   GIM_Try, /*On fail goto*//*Label 17051*/ GIMT_Encode4(1167910), // Rule ID 15903 //
     /* 1167835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1167846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1167849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1167852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1167855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167874 */     // MIs[0] round
     /* 1167874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167909 */     // GIR_Coverage, 15903,
     /* 1167909 */     GIR_EraseRootFromParent_Done,
     /* 1167910 */   // Label 17051: @1167910
     /* 1167910 */   GIM_Try, /*On fail goto*//*Label 17052*/ GIMT_Encode4(1167990), // Rule ID 15906 //
     /* 1167915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1167929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1167932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1167935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167954 */     // MIs[0] round
     /* 1167954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167964 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167989 */     // GIR_Coverage, 15906,
     /* 1167989 */     GIR_EraseRootFromParent_Done,
     /* 1167990 */   // Label 17052: @1167990
     /* 1167990 */   GIM_Try, /*On fail goto*//*Label 17053*/ GIMT_Encode4(1168070), // Rule ID 15907 //
     /* 1167995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1168006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1168009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1168012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1168015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168034 */     // MIs[0] round
     /* 1168034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168044 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1168047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1168065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168069 */     // GIR_Coverage, 15907,
     /* 1168069 */     GIR_EraseRootFromParent_Done,
     /* 1168070 */   // Label 17053: @1168070
     /* 1168070 */   GIM_Try, /*On fail goto*//*Label 17054*/ GIMT_Encode4(1168150), // Rule ID 15910 //
     /* 1168075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1168086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1168089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1168092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168114 */     // MIs[0] round
     /* 1168114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168124 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1168127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168149 */     // GIR_Coverage, 15910,
     /* 1168149 */     GIR_EraseRootFromParent_Done,
     /* 1168150 */   // Label 17054: @1168150
     /* 1168150 */   GIM_Try, /*On fail goto*//*Label 17055*/ GIMT_Encode4(1168230), // Rule ID 15911 //
     /* 1168155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1168166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1168169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1168172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168194 */     // MIs[0] round
     /* 1168194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168204 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1168207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168229 */     // GIR_Coverage, 15911,
     /* 1168229 */     GIR_EraseRootFromParent_Done,
     /* 1168230 */   // Label 17055: @1168230
     /* 1168230 */   GIM_Try, /*On fail goto*//*Label 17056*/ GIMT_Encode4(1168310), // Rule ID 15914 //
     /* 1168235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1168246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1168249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1168252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168274 */     // MIs[0] round
     /* 1168274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168284 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1168287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168309 */     // GIR_Coverage, 15914,
     /* 1168309 */     GIR_EraseRootFromParent_Done,
     /* 1168310 */   // Label 17056: @1168310
     /* 1168310 */   GIM_Try, /*On fail goto*//*Label 17057*/ GIMT_Encode4(1168390), // Rule ID 15915 //
     /* 1168315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1168326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1168329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1168332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168354 */     // MIs[0] round
     /* 1168354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168364 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1168367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168389 */     // GIR_Coverage, 15915,
     /* 1168389 */     GIR_EraseRootFromParent_Done,
     /* 1168390 */   // Label 17057: @1168390
     /* 1168390 */   GIM_Try, /*On fail goto*//*Label 17058*/ GIMT_Encode4(1168470), // Rule ID 15918 //
     /* 1168395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1168406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1168409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1168412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168434 */     // MIs[0] round
     /* 1168434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168444 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168469 */     // GIR_Coverage, 15918,
     /* 1168469 */     GIR_EraseRootFromParent_Done,
     /* 1168470 */   // Label 17058: @1168470
     /* 1168470 */   GIM_Try, /*On fail goto*//*Label 17059*/ GIMT_Encode4(1168550), // Rule ID 15919 //
     /* 1168475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1168486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1168489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1168492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168514 */     // MIs[0] round
     /* 1168514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168524 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168549 */     // GIR_Coverage, 15919,
     /* 1168549 */     GIR_EraseRootFromParent_Done,
     /* 1168550 */   // Label 17059: @1168550
     /* 1168550 */   GIM_Try, /*On fail goto*//*Label 17060*/ GIMT_Encode4(1168630), // Rule ID 15922 //
     /* 1168555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1168566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1168569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1168572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168594 */     // MIs[0] round
     /* 1168594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168604 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1168607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168629 */     // GIR_Coverage, 15922,
     /* 1168629 */     GIR_EraseRootFromParent_Done,
     /* 1168630 */   // Label 17060: @1168630
     /* 1168630 */   GIM_Try, /*On fail goto*//*Label 17061*/ GIMT_Encode4(1168710), // Rule ID 15923 //
     /* 1168635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1168646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1168649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1168652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168674 */     // MIs[0] round
     /* 1168674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168684 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1168687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168709 */     // GIR_Coverage, 15923,
     /* 1168709 */     GIR_EraseRootFromParent_Done,
     /* 1168710 */   // Label 17061: @1168710
     /* 1168710 */   GIM_Try, /*On fail goto*//*Label 17062*/ GIMT_Encode4(1168790), // Rule ID 15926 //
     /* 1168715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1168726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1168729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1168732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168754 */     // MIs[0] round
     /* 1168754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168764 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168789 */     // GIR_Coverage, 15926,
     /* 1168789 */     GIR_EraseRootFromParent_Done,
     /* 1168790 */   // Label 17062: @1168790
     /* 1168790 */   GIM_Try, /*On fail goto*//*Label 17063*/ GIMT_Encode4(1168870), // Rule ID 15927 //
     /* 1168795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1168806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1168809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1168812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168834 */     // MIs[0] round
     /* 1168834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168869 */     // GIR_Coverage, 15927,
     /* 1168869 */     GIR_EraseRootFromParent_Done,
     /* 1168870 */   // Label 17063: @1168870
     /* 1168870 */   GIM_Try, /*On fail goto*//*Label 17064*/ GIMT_Encode4(1168950), // Rule ID 15930 //
     /* 1168875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1168886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1168889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1168892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168914 */     // MIs[0] round
     /* 1168914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168949 */     // GIR_Coverage, 15930,
     /* 1168949 */     GIR_EraseRootFromParent_Done,
     /* 1168950 */   // Label 17064: @1168950
     /* 1168950 */   GIM_Try, /*On fail goto*//*Label 17065*/ GIMT_Encode4(1169030), // Rule ID 15931 //
     /* 1168955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1168966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1168969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1168972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168994 */     // MIs[0] round
     /* 1168994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169004 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1169007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169029 */     // GIR_Coverage, 15931,
     /* 1169029 */     GIR_EraseRootFromParent_Done,
     /* 1169030 */   // Label 17065: @1169030
     /* 1169030 */   GIM_Try, /*On fail goto*//*Label 17066*/ GIMT_Encode4(1169110), // Rule ID 15934 //
     /* 1169035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1169046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1169049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1169052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169074 */     // MIs[0] round
     /* 1169074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169084 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169109 */     // GIR_Coverage, 15934,
     /* 1169109 */     GIR_EraseRootFromParent_Done,
     /* 1169110 */   // Label 17066: @1169110
     /* 1169110 */   GIM_Try, /*On fail goto*//*Label 17067*/ GIMT_Encode4(1169190), // Rule ID 15935 //
     /* 1169115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1169126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1169129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1169132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169154 */     // MIs[0] round
     /* 1169154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169164 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169189 */     // GIR_Coverage, 15935,
     /* 1169189 */     GIR_EraseRootFromParent_Done,
     /* 1169190 */   // Label 17067: @1169190
     /* 1169190 */   GIM_Try, /*On fail goto*//*Label 17068*/ GIMT_Encode4(1169270), // Rule ID 15938 //
     /* 1169195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1169206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1169209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1169212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169234 */     // MIs[0] round
     /* 1169234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169244 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169269 */     // GIR_Coverage, 15938,
     /* 1169269 */     GIR_EraseRootFromParent_Done,
     /* 1169270 */   // Label 17068: @1169270
     /* 1169270 */   GIM_Try, /*On fail goto*//*Label 17069*/ GIMT_Encode4(1169350), // Rule ID 15939 //
     /* 1169275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1169286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1169289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1169292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169314 */     // MIs[0] round
     /* 1169314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169324 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169349 */     // GIR_Coverage, 15939,
     /* 1169349 */     GIR_EraseRootFromParent_Done,
     /* 1169350 */   // Label 17069: @1169350
     /* 1169350 */   GIM_Try, /*On fail goto*//*Label 17070*/ GIMT_Encode4(1169430), // Rule ID 15942 //
     /* 1169355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1169366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1169369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1169372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169394 */     // MIs[0] round
     /* 1169394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169404 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169429 */     // GIR_Coverage, 15942,
     /* 1169429 */     GIR_EraseRootFromParent_Done,
     /* 1169430 */   // Label 17070: @1169430
     /* 1169430 */   GIM_Try, /*On fail goto*//*Label 17071*/ GIMT_Encode4(1169510), // Rule ID 15943 //
     /* 1169435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1169446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1169449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1169452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169474 */     // MIs[0] round
     /* 1169474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169509 */     // GIR_Coverage, 15943,
     /* 1169509 */     GIR_EraseRootFromParent_Done,
     /* 1169510 */   // Label 17071: @1169510
     /* 1169510 */   GIM_Try, /*On fail goto*//*Label 17072*/ GIMT_Encode4(1169590), // Rule ID 15946 //
     /* 1169515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1169518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1169526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1169529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1169532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169554 */     // MIs[0] round
     /* 1169554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169564 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169589 */     // GIR_Coverage, 15946,
     /* 1169589 */     GIR_EraseRootFromParent_Done,
     /* 1169590 */   // Label 17072: @1169590
     /* 1169590 */   GIM_Try, /*On fail goto*//*Label 17073*/ GIMT_Encode4(1169670), // Rule ID 15947 //
     /* 1169595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1169598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1169606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1169609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1169612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169634 */     // MIs[0] round
     /* 1169634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169669 */     // GIR_Coverage, 15947,
     /* 1169669 */     GIR_EraseRootFromParent_Done,
     /* 1169670 */   // Label 17073: @1169670
     /* 1169670 */   GIM_Try, /*On fail goto*//*Label 17074*/ GIMT_Encode4(1169750), // Rule ID 15950 //
     /* 1169675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1169686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1169689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1169692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169714 */     // MIs[0] round
     /* 1169714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169724 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169749 */     // GIR_Coverage, 15950,
     /* 1169749 */     GIR_EraseRootFromParent_Done,
     /* 1169750 */   // Label 17074: @1169750
     /* 1169750 */   GIM_Try, /*On fail goto*//*Label 17075*/ GIMT_Encode4(1169830), // Rule ID 15951 //
     /* 1169755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1169766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1169769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1169772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169794 */     // MIs[0] round
     /* 1169794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169804 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169829 */     // GIR_Coverage, 15951,
     /* 1169829 */     GIR_EraseRootFromParent_Done,
     /* 1169830 */   // Label 17075: @1169830
     /* 1169830 */   GIM_Try, /*On fail goto*//*Label 17076*/ GIMT_Encode4(1169910), // Rule ID 15954 //
     /* 1169835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1169846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1169849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1169852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169874 */     // MIs[0] round
     /* 1169874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169884 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169909 */     // GIR_Coverage, 15954,
     /* 1169909 */     GIR_EraseRootFromParent_Done,
     /* 1169910 */   // Label 17076: @1169910
     /* 1169910 */   GIM_Try, /*On fail goto*//*Label 17077*/ GIMT_Encode4(1169990), // Rule ID 15955 //
     /* 1169915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1169926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1169929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1169932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169954 */     // MIs[0] round
     /* 1169954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169964 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169989 */     // GIR_Coverage, 15955,
     /* 1169989 */     GIR_EraseRootFromParent_Done,
     /* 1169990 */   // Label 17077: @1169990
     /* 1169990 */   GIM_Try, /*On fail goto*//*Label 17078*/ GIMT_Encode4(1170070), // Rule ID 15958 //
     /* 1169995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1170006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1170009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1170012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170034 */     // MIs[0] round
     /* 1170034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170044 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170069 */     // GIR_Coverage, 15958,
     /* 1170069 */     GIR_EraseRootFromParent_Done,
     /* 1170070 */   // Label 17078: @1170070
     /* 1170070 */   GIM_Try, /*On fail goto*//*Label 17079*/ GIMT_Encode4(1170150), // Rule ID 15959 //
     /* 1170075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1170086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1170089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1170092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170114 */     // MIs[0] round
     /* 1170114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170124 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170149 */     // GIR_Coverage, 15959,
     /* 1170149 */     GIR_EraseRootFromParent_Done,
     /* 1170150 */   // Label 17079: @1170150
     /* 1170150 */   GIM_Try, /*On fail goto*//*Label 17080*/ GIMT_Encode4(1170230), // Rule ID 15962 //
     /* 1170155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1170166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1170169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1170172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170194 */     // MIs[0] round
     /* 1170194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170204 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170229 */     // GIR_Coverage, 15962,
     /* 1170229 */     GIR_EraseRootFromParent_Done,
     /* 1170230 */   // Label 17080: @1170230
     /* 1170230 */   GIM_Try, /*On fail goto*//*Label 17081*/ GIMT_Encode4(1170310), // Rule ID 15963 //
     /* 1170235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1170246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1170249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1170252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170274 */     // MIs[0] round
     /* 1170274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170284 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170309 */     // GIR_Coverage, 15963,
     /* 1170309 */     GIR_EraseRootFromParent_Done,
     /* 1170310 */   // Label 17081: @1170310
     /* 1170310 */   GIM_Try, /*On fail goto*//*Label 17082*/ GIMT_Encode4(1170390), // Rule ID 15966 //
     /* 1170315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1170326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1170329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1170332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170354 */     // MIs[0] round
     /* 1170354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170364 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170389 */     // GIR_Coverage, 15966,
     /* 1170389 */     GIR_EraseRootFromParent_Done,
     /* 1170390 */   // Label 17082: @1170390
     /* 1170390 */   GIM_Try, /*On fail goto*//*Label 17083*/ GIMT_Encode4(1170470), // Rule ID 15967 //
     /* 1170395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1170406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1170409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1170412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170434 */     // MIs[0] round
     /* 1170434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170444 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170469 */     // GIR_Coverage, 15967,
     /* 1170469 */     GIR_EraseRootFromParent_Done,
     /* 1170470 */   // Label 17083: @1170470
     /* 1170470 */   GIM_Try, /*On fail goto*//*Label 17084*/ GIMT_Encode4(1170550), // Rule ID 15970 //
     /* 1170475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1170486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1170489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1170492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170514 */     // MIs[0] round
     /* 1170514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170524 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170549 */     // GIR_Coverage, 15970,
     /* 1170549 */     GIR_EraseRootFromParent_Done,
     /* 1170550 */   // Label 17084: @1170550
     /* 1170550 */   GIM_Try, /*On fail goto*//*Label 17085*/ GIMT_Encode4(1170630), // Rule ID 15971 //
     /* 1170555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1170566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1170569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1170572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170594 */     // MIs[0] round
     /* 1170594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170604 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170629 */     // GIR_Coverage, 15971,
     /* 1170629 */     GIR_EraseRootFromParent_Done,
     /* 1170630 */   // Label 17085: @1170630
     /* 1170630 */   GIM_Try, /*On fail goto*//*Label 17086*/ GIMT_Encode4(1170710), // Rule ID 15974 //
     /* 1170635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1170646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1170649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1170652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170674 */     // MIs[0] round
     /* 1170674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170684 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170709 */     // GIR_Coverage, 15974,
     /* 1170709 */     GIR_EraseRootFromParent_Done,
     /* 1170710 */   // Label 17086: @1170710
     /* 1170710 */   GIM_Try, /*On fail goto*//*Label 17087*/ GIMT_Encode4(1170790), // Rule ID 15975 //
     /* 1170715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1170726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1170729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1170732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170754 */     // MIs[0] round
     /* 1170754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170789 */     // GIR_Coverage, 15975,
     /* 1170789 */     GIR_EraseRootFromParent_Done,
     /* 1170790 */   // Label 17087: @1170790
     /* 1170790 */   GIM_Try, /*On fail goto*//*Label 17088*/ GIMT_Encode4(1170870), // Rule ID 15978 //
     /* 1170795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1170806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1170809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1170812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170834 */     // MIs[0] round
     /* 1170834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170844 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170869 */     // GIR_Coverage, 15978,
     /* 1170869 */     GIR_EraseRootFromParent_Done,
     /* 1170870 */   // Label 17088: @1170870
     /* 1170870 */   GIM_Try, /*On fail goto*//*Label 17089*/ GIMT_Encode4(1170950), // Rule ID 15979 //
     /* 1170875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1170886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1170889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1170892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170914 */     // MIs[0] round
     /* 1170914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170924 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170949 */     // GIR_Coverage, 15979,
     /* 1170949 */     GIR_EraseRootFromParent_Done,
     /* 1170950 */   // Label 17089: @1170950
     /* 1170950 */   GIM_Try, /*On fail goto*//*Label 17090*/ GIMT_Encode4(1171030), // Rule ID 15982 //
     /* 1170955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1170966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1170969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1170972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170994 */     // MIs[0] round
     /* 1170994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171004 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1171007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1171025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171029 */     // GIR_Coverage, 15982,
     /* 1171029 */     GIR_EraseRootFromParent_Done,
     /* 1171030 */   // Label 17090: @1171030
     /* 1171030 */   GIM_Try, /*On fail goto*//*Label 17091*/ GIMT_Encode4(1171110), // Rule ID 15983 //
     /* 1171035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1171046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1171049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1171052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171074 */     // MIs[0] round
     /* 1171074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171084 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1171087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1171105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171109 */     // GIR_Coverage, 15983,
     /* 1171109 */     GIR_EraseRootFromParent_Done,
     /* 1171110 */   // Label 17091: @1171110
     /* 1171110 */   GIM_Try, /*On fail goto*//*Label 17092*/ GIMT_Encode4(1171190), // Rule ID 15986 //
     /* 1171115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1171118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1171126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1171129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1171132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171154 */     // MIs[0] round
     /* 1171154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1171167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171189 */     // GIR_Coverage, 15986,
     /* 1171189 */     GIR_EraseRootFromParent_Done,
     /* 1171190 */   // Label 17092: @1171190
     /* 1171190 */   GIM_Try, /*On fail goto*//*Label 17093*/ GIMT_Encode4(1171270), // Rule ID 15987 //
     /* 1171195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1171198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1171206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1171209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1171212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171234 */     // MIs[0] round
     /* 1171234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1171247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171269 */     // GIR_Coverage, 15987,
     /* 1171269 */     GIR_EraseRootFromParent_Done,
     /* 1171270 */   // Label 17093: @1171270
     /* 1171270 */   GIM_Try, /*On fail goto*//*Label 17094*/ GIMT_Encode4(1171350), // Rule ID 15990 //
     /* 1171275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1171278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1171286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1171289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1171292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171314 */     // MIs[0] round
     /* 1171314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171324 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1171327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171349 */     // GIR_Coverage, 15990,
     /* 1171349 */     GIR_EraseRootFromParent_Done,
     /* 1171350 */   // Label 17094: @1171350
     /* 1171350 */   GIM_Try, /*On fail goto*//*Label 17095*/ GIMT_Encode4(1171430), // Rule ID 15991 //
     /* 1171355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1171358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1171366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1171369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1171372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171394 */     // MIs[0] round
     /* 1171394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171404 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1171407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171429 */     // GIR_Coverage, 15991,
     /* 1171429 */     GIR_EraseRootFromParent_Done,
     /* 1171430 */   // Label 17095: @1171430
     /* 1171430 */   GIM_Try, /*On fail goto*//*Label 17096*/ GIMT_Encode4(1171510), // Rule ID 15994 //
     /* 1171435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1171438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1171446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1171449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1171452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171474 */     // MIs[0] round
     /* 1171474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1171487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171509 */     // GIR_Coverage, 15994,
     /* 1171509 */     GIR_EraseRootFromParent_Done,
     /* 1171510 */   // Label 17096: @1171510
     /* 1171510 */   GIM_Try, /*On fail goto*//*Label 17097*/ GIMT_Encode4(1171590), // Rule ID 15995 //
     /* 1171515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1171518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1171526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1171529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1171532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171554 */     // MIs[0] round
     /* 1171554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171564 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1171567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171589 */     // GIR_Coverage, 15995,
     /* 1171589 */     GIR_EraseRootFromParent_Done,
     /* 1171590 */   // Label 17097: @1171590
     /* 1171590 */   GIM_Try, /*On fail goto*//*Label 17098*/ GIMT_Encode4(1171670), // Rule ID 16086 //
     /* 1171595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1171606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1171609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1171612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1171615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171634 */     // MIs[0] round
     /* 1171634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171644 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1171647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171669 */     // GIR_Coverage, 16086,
     /* 1171669 */     GIR_EraseRootFromParent_Done,
     /* 1171670 */   // Label 17098: @1171670
     /* 1171670 */   GIM_Try, /*On fail goto*//*Label 17099*/ GIMT_Encode4(1171750), // Rule ID 16087 //
     /* 1171675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1171686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1171689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1171692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1171695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171714 */     // MIs[0] round
     /* 1171714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171724 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1171727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171749 */     // GIR_Coverage, 16087,
     /* 1171749 */     GIR_EraseRootFromParent_Done,
     /* 1171750 */   // Label 17099: @1171750
     /* 1171750 */   GIM_Try, /*On fail goto*//*Label 17100*/ GIMT_Encode4(1171830), // Rule ID 16090 //
     /* 1171755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1171766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1171769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1171772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1171775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171794 */     // MIs[0] round
     /* 1171794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171804 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171829 */     // GIR_Coverage, 16090,
     /* 1171829 */     GIR_EraseRootFromParent_Done,
     /* 1171830 */   // Label 17100: @1171830
     /* 1171830 */   GIM_Try, /*On fail goto*//*Label 17101*/ GIMT_Encode4(1171910), // Rule ID 16091 //
     /* 1171835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1171846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1171849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1171852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1171855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171874 */     // MIs[0] round
     /* 1171874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171884 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171909 */     // GIR_Coverage, 16091,
     /* 1171909 */     GIR_EraseRootFromParent_Done,
     /* 1171910 */   // Label 17101: @1171910
     /* 1171910 */   GIM_Try, /*On fail goto*//*Label 17102*/ GIMT_Encode4(1171990), // Rule ID 16094 //
     /* 1171915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1171926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1171929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1171932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1171935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171954 */     // MIs[0] round
     /* 1171954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171964 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171989 */     // GIR_Coverage, 16094,
     /* 1171989 */     GIR_EraseRootFromParent_Done,
     /* 1171990 */   // Label 17102: @1171990
     /* 1171990 */   GIM_Try, /*On fail goto*//*Label 17103*/ GIMT_Encode4(1172070), // Rule ID 16095 //
     /* 1171995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1172006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1172009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1172012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1172015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172034 */     // MIs[0] round
     /* 1172034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172044 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1172047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172069 */     // GIR_Coverage, 16095,
     /* 1172069 */     GIR_EraseRootFromParent_Done,
     /* 1172070 */   // Label 17103: @1172070
     /* 1172070 */   GIM_Try, /*On fail goto*//*Label 17104*/ GIMT_Encode4(1172150), // Rule ID 16098 //
     /* 1172075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1172086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1172089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1172092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1172095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172114 */     // MIs[0] round
     /* 1172114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172124 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1172127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172149 */     // GIR_Coverage, 16098,
     /* 1172149 */     GIR_EraseRootFromParent_Done,
     /* 1172150 */   // Label 17104: @1172150
     /* 1172150 */   GIM_Try, /*On fail goto*//*Label 17105*/ GIMT_Encode4(1172230), // Rule ID 16099 //
     /* 1172155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1172166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1172169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1172172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1172175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172194 */     // MIs[0] round
     /* 1172194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172204 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1172207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172229 */     // GIR_Coverage, 16099,
     /* 1172229 */     GIR_EraseRootFromParent_Done,
     /* 1172230 */   // Label 17105: @1172230
     /* 1172230 */   GIM_Try, /*On fail goto*//*Label 17106*/ GIMT_Encode4(1172310), // Rule ID 16102 //
     /* 1172235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1172246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1172249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1172252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1172255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172274 */     // MIs[0] round
     /* 1172274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1172287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172309 */     // GIR_Coverage, 16102,
     /* 1172309 */     GIR_EraseRootFromParent_Done,
     /* 1172310 */   // Label 17106: @1172310
     /* 1172310 */   GIM_Try, /*On fail goto*//*Label 17107*/ GIMT_Encode4(1172390), // Rule ID 16103 //
     /* 1172315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1172326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1172329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1172332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1172335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172354 */     // MIs[0] round
     /* 1172354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172364 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1172367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172389 */     // GIR_Coverage, 16103,
     /* 1172389 */     GIR_EraseRootFromParent_Done,
     /* 1172390 */   // Label 17107: @1172390
     /* 1172390 */   GIM_Try, /*On fail goto*//*Label 17108*/ GIMT_Encode4(1172470), // Rule ID 16106 //
     /* 1172395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1172406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1172409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1172412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1172415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172434 */     // MIs[0] round
     /* 1172434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172444 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1172447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172469 */     // GIR_Coverage, 16106,
     /* 1172469 */     GIR_EraseRootFromParent_Done,
     /* 1172470 */   // Label 17108: @1172470
     /* 1172470 */   GIM_Try, /*On fail goto*//*Label 17109*/ GIMT_Encode4(1172550), // Rule ID 16107 //
     /* 1172475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1172486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1172489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1172492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1172495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172514 */     // MIs[0] round
     /* 1172514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172524 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1172527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172549 */     // GIR_Coverage, 16107,
     /* 1172549 */     GIR_EraseRootFromParent_Done,
     /* 1172550 */   // Label 17109: @1172550
     /* 1172550 */   GIM_Try, /*On fail goto*//*Label 17110*/ GIMT_Encode4(1172630), // Rule ID 16110 //
     /* 1172555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1172566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1172569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1172572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1172575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172594 */     // MIs[0] round
     /* 1172594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172604 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172629 */     // GIR_Coverage, 16110,
     /* 1172629 */     GIR_EraseRootFromParent_Done,
     /* 1172630 */   // Label 17110: @1172630
     /* 1172630 */   GIM_Try, /*On fail goto*//*Label 17111*/ GIMT_Encode4(1172710), // Rule ID 16111 //
     /* 1172635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1172646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1172649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1172652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1172655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172674 */     // MIs[0] round
     /* 1172674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172684 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172709 */     // GIR_Coverage, 16111,
     /* 1172709 */     GIR_EraseRootFromParent_Done,
     /* 1172710 */   // Label 17111: @1172710
     /* 1172710 */   GIM_Try, /*On fail goto*//*Label 17112*/ GIMT_Encode4(1172790), // Rule ID 16114 //
     /* 1172715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1172726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1172729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1172732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1172735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172754 */     // MIs[0] round
     /* 1172754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172764 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172789 */     // GIR_Coverage, 16114,
     /* 1172789 */     GIR_EraseRootFromParent_Done,
     /* 1172790 */   // Label 17112: @1172790
     /* 1172790 */   GIM_Try, /*On fail goto*//*Label 17113*/ GIMT_Encode4(1172870), // Rule ID 16115 //
     /* 1172795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1172806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1172809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1172812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1172815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172834 */     // MIs[0] round
     /* 1172834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172844 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172869 */     // GIR_Coverage, 16115,
     /* 1172869 */     GIR_EraseRootFromParent_Done,
     /* 1172870 */   // Label 17113: @1172870
     /* 1172870 */   GIM_Try, /*On fail goto*//*Label 17114*/ GIMT_Encode4(1172950), // Rule ID 16118 //
     /* 1172875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1172886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1172889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1172895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172914 */     // MIs[0] round
     /* 1172914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172949 */     // GIR_Coverage, 16118,
     /* 1172949 */     GIR_EraseRootFromParent_Done,
     /* 1172950 */   // Label 17114: @1172950
     /* 1172950 */   GIM_Try, /*On fail goto*//*Label 17115*/ GIMT_Encode4(1173030), // Rule ID 16119 //
     /* 1172955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1172966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1172969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1172975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172994 */     // MIs[0] round
     /* 1172994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173004 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1173007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173029 */     // GIR_Coverage, 16119,
     /* 1173029 */     GIR_EraseRootFromParent_Done,
     /* 1173030 */   // Label 17115: @1173030
     /* 1173030 */   GIM_Try, /*On fail goto*//*Label 17116*/ GIMT_Encode4(1173110), // Rule ID 16122 //
     /* 1173035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1173038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1173046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1173049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1173052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1173055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173074 */     // MIs[0] round
     /* 1173074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173084 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1173087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173109 */     // GIR_Coverage, 16122,
     /* 1173109 */     GIR_EraseRootFromParent_Done,
     /* 1173110 */   // Label 17116: @1173110
     /* 1173110 */   GIM_Try, /*On fail goto*//*Label 17117*/ GIMT_Encode4(1173190), // Rule ID 16123 //
     /* 1173115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1173118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1173126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1173129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1173132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1173135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173154 */     // MIs[0] round
     /* 1173154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173164 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1173167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173189 */     // GIR_Coverage, 16123,
     /* 1173189 */     GIR_EraseRootFromParent_Done,
     /* 1173190 */   // Label 17117: @1173190
     /* 1173190 */   GIM_Try, /*On fail goto*//*Label 17118*/ GIMT_Encode4(1173270), // Rule ID 16126 //
     /* 1173195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1173206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1173209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1173212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1173215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173234 */     // MIs[0] round
     /* 1173234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173244 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173269 */     // GIR_Coverage, 16126,
     /* 1173269 */     GIR_EraseRootFromParent_Done,
     /* 1173270 */   // Label 17118: @1173270
     /* 1173270 */   GIM_Try, /*On fail goto*//*Label 17119*/ GIMT_Encode4(1173350), // Rule ID 16127 //
     /* 1173275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1173286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1173289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1173292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1173295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173314 */     // MIs[0] round
     /* 1173314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173324 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173349 */     // GIR_Coverage, 16127,
     /* 1173349 */     GIR_EraseRootFromParent_Done,
     /* 1173350 */   // Label 17119: @1173350
     /* 1173350 */   GIM_Try, /*On fail goto*//*Label 17120*/ GIMT_Encode4(1173430), // Rule ID 16130 //
     /* 1173355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1173366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1173369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1173372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1173375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173394 */     // MIs[0] round
     /* 1173394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173404 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173429 */     // GIR_Coverage, 16130,
     /* 1173429 */     GIR_EraseRootFromParent_Done,
     /* 1173430 */   // Label 17120: @1173430
     /* 1173430 */   GIM_Try, /*On fail goto*//*Label 17121*/ GIMT_Encode4(1173510), // Rule ID 16131 //
     /* 1173435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1173446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1173449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1173452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1173455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173474 */     // MIs[0] round
     /* 1173474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173484 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173509 */     // GIR_Coverage, 16131,
     /* 1173509 */     GIR_EraseRootFromParent_Done,
     /* 1173510 */   // Label 17121: @1173510
     /* 1173510 */   GIM_Try, /*On fail goto*//*Label 17122*/ GIMT_Encode4(1173590), // Rule ID 16134 //
     /* 1173515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1173526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1173529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1173532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1173535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173554 */     // MIs[0] round
     /* 1173554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173564 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173589 */     // GIR_Coverage, 16134,
     /* 1173589 */     GIR_EraseRootFromParent_Done,
     /* 1173590 */   // Label 17122: @1173590
     /* 1173590 */   GIM_Try, /*On fail goto*//*Label 17123*/ GIMT_Encode4(1173670), // Rule ID 16135 //
     /* 1173595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1173606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1173609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1173612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1173615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173634 */     // MIs[0] round
     /* 1173634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173644 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173669 */     // GIR_Coverage, 16135,
     /* 1173669 */     GIR_EraseRootFromParent_Done,
     /* 1173670 */   // Label 17123: @1173670
     /* 1173670 */   GIM_Try, /*On fail goto*//*Label 17124*/ GIMT_Encode4(1173750), // Rule ID 16138 //
     /* 1173675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1173686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1173689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1173692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1173695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173714 */     // MIs[0] round
     /* 1173714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173749 */     // GIR_Coverage, 16138,
     /* 1173749 */     GIR_EraseRootFromParent_Done,
     /* 1173750 */   // Label 17124: @1173750
     /* 1173750 */   GIM_Try, /*On fail goto*//*Label 17125*/ GIMT_Encode4(1173830), // Rule ID 16139 //
     /* 1173755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1173766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1173769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1173772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1173775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173794 */     // MIs[0] round
     /* 1173794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173804 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173829 */     // GIR_Coverage, 16139,
     /* 1173829 */     GIR_EraseRootFromParent_Done,
     /* 1173830 */   // Label 17125: @1173830
     /* 1173830 */   GIM_Try, /*On fail goto*//*Label 17126*/ GIMT_Encode4(1173910), // Rule ID 16142 //
     /* 1173835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1173846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1173849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1173855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173874 */     // MIs[0] round
     /* 1173874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173884 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173909 */     // GIR_Coverage, 16142,
     /* 1173909 */     GIR_EraseRootFromParent_Done,
     /* 1173910 */   // Label 17126: @1173910
     /* 1173910 */   GIM_Try, /*On fail goto*//*Label 17127*/ GIMT_Encode4(1173990), // Rule ID 16143 //
     /* 1173915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1173926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1173929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1173935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173954 */     // MIs[0] round
     /* 1173954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173964 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173989 */     // GIR_Coverage, 16143,
     /* 1173989 */     GIR_EraseRootFromParent_Done,
     /* 1173990 */   // Label 17127: @1173990
     /* 1173990 */   GIM_Try, /*On fail goto*//*Label 17128*/ GIMT_Encode4(1174070), // Rule ID 16146 //
     /* 1173995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1174006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1174009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1174012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1174015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174034 */     // MIs[0] round
     /* 1174034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174044 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174069 */     // GIR_Coverage, 16146,
     /* 1174069 */     GIR_EraseRootFromParent_Done,
     /* 1174070 */   // Label 17128: @1174070
     /* 1174070 */   GIM_Try, /*On fail goto*//*Label 17129*/ GIMT_Encode4(1174150), // Rule ID 16147 //
     /* 1174075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1174086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1174089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1174092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1174095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174114 */     // MIs[0] round
     /* 1174114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174124 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174149 */     // GIR_Coverage, 16147,
     /* 1174149 */     GIR_EraseRootFromParent_Done,
     /* 1174150 */   // Label 17129: @1174150
     /* 1174150 */   GIM_Try, /*On fail goto*//*Label 17130*/ GIMT_Encode4(1174230), // Rule ID 16150 //
     /* 1174155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1174166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1174169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1174172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1174175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174194 */     // MIs[0] round
     /* 1174194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174204 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1174207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174229 */     // GIR_Coverage, 16150,
     /* 1174229 */     GIR_EraseRootFromParent_Done,
     /* 1174230 */   // Label 17130: @1174230
     /* 1174230 */   GIM_Try, /*On fail goto*//*Label 17131*/ GIMT_Encode4(1174310), // Rule ID 16151 //
     /* 1174235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1174246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1174249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1174252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1174255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174274 */     // MIs[0] round
     /* 1174274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174284 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1174287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174309 */     // GIR_Coverage, 16151,
     /* 1174309 */     GIR_EraseRootFromParent_Done,
     /* 1174310 */   // Label 17131: @1174310
     /* 1174310 */   GIM_Try, /*On fail goto*//*Label 17132*/ GIMT_Encode4(1174390), // Rule ID 16154 //
     /* 1174315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1174326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1174329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1174332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1174335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174354 */     // MIs[0] round
     /* 1174354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174389 */     // GIR_Coverage, 16154,
     /* 1174389 */     GIR_EraseRootFromParent_Done,
     /* 1174390 */   // Label 17132: @1174390
     /* 1174390 */   GIM_Try, /*On fail goto*//*Label 17133*/ GIMT_Encode4(1174470), // Rule ID 16155 //
     /* 1174395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1174406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1174409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1174412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1174415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174434 */     // MIs[0] round
     /* 1174434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174444 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174469 */     // GIR_Coverage, 16155,
     /* 1174469 */     GIR_EraseRootFromParent_Done,
     /* 1174470 */   // Label 17133: @1174470
     /* 1174470 */   GIM_Try, /*On fail goto*//*Label 17134*/ GIMT_Encode4(1174550), // Rule ID 16158 //
     /* 1174475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1174486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1174489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1174492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1174495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174514 */     // MIs[0] round
     /* 1174514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174524 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174549 */     // GIR_Coverage, 16158,
     /* 1174549 */     GIR_EraseRootFromParent_Done,
     /* 1174550 */   // Label 17134: @1174550
     /* 1174550 */   GIM_Try, /*On fail goto*//*Label 17135*/ GIMT_Encode4(1174630), // Rule ID 16159 //
     /* 1174555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1174566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1174569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1174572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1174575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174594 */     // MIs[0] round
     /* 1174594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174604 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174629 */     // GIR_Coverage, 16159,
     /* 1174629 */     GIR_EraseRootFromParent_Done,
     /* 1174630 */   // Label 17135: @1174630
     /* 1174630 */   GIM_Try, /*On fail goto*//*Label 17136*/ GIMT_Encode4(1174710), // Rule ID 16162 //
     /* 1174635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1174646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1174649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1174652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1174655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174674 */     // MIs[0] round
     /* 1174674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1174687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174709 */     // GIR_Coverage, 16162,
     /* 1174709 */     GIR_EraseRootFromParent_Done,
     /* 1174710 */   // Label 17136: @1174710
     /* 1174710 */   GIM_Try, /*On fail goto*//*Label 17137*/ GIMT_Encode4(1174790), // Rule ID 16163 //
     /* 1174715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1174726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1174729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1174732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1174735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174754 */     // MIs[0] round
     /* 1174754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1174767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174789 */     // GIR_Coverage, 16163,
     /* 1174789 */     GIR_EraseRootFromParent_Done,
     /* 1174790 */   // Label 17137: @1174790
     /* 1174790 */   GIM_Try, /*On fail goto*//*Label 17138*/ GIMT_Encode4(1174870), // Rule ID 16166 //
     /* 1174795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1174806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1174809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1174815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174834 */     // MIs[0] round
     /* 1174834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174844 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174869 */     // GIR_Coverage, 16166,
     /* 1174869 */     GIR_EraseRootFromParent_Done,
     /* 1174870 */   // Label 17138: @1174870
     /* 1174870 */   GIM_Try, /*On fail goto*//*Label 17139*/ GIMT_Encode4(1174950), // Rule ID 16167 //
     /* 1174875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1174886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1174889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1174895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174914 */     // MIs[0] round
     /* 1174914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174924 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174949 */     // GIR_Coverage, 16167,
     /* 1174949 */     GIR_EraseRootFromParent_Done,
     /* 1174950 */   // Label 17139: @1174950
     /* 1174950 */   GIM_Try, /*On fail goto*//*Label 17140*/ GIMT_Encode4(1175030), // Rule ID 16170 //
     /* 1174955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1174966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1174969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1174972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1174975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174994 */     // MIs[0] round
     /* 1174994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175004 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1175007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1175025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175029 */     // GIR_Coverage, 16170,
     /* 1175029 */     GIR_EraseRootFromParent_Done,
     /* 1175030 */   // Label 17140: @1175030
     /* 1175030 */   GIM_Try, /*On fail goto*//*Label 17141*/ GIMT_Encode4(1175110), // Rule ID 16171 //
     /* 1175035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1175038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1175046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1175049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1175052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1175055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1175062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1175066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1175070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1175074 */     // MIs[0] round
     /* 1175074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175084 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1175087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1175105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175109 */     // GIR_Coverage, 16171,
     /* 1175109 */     GIR_EraseRootFromParent_Done,
     /* 1175110 */   // Label 17141: @1175110
     /* 1175110 */   GIM_Try, /*On fail goto*//*Label 17142*/ GIMT_Encode4(1175190), // Rule ID 16174 //
     /* 1175115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1175126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1175129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1175132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175154 */     // MIs[0] round
     /* 1175154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175164 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1175167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175189 */     // GIR_Coverage, 16174,
     /* 1175189 */     GIR_EraseRootFromParent_Done,
     /* 1175190 */   // Label 17142: @1175190
     /* 1175190 */   GIM_Try, /*On fail goto*//*Label 17143*/ GIMT_Encode4(1175270), // Rule ID 16175 //
     /* 1175195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1175206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1175209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1175212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175234 */     // MIs[0] round
     /* 1175234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175244 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1175247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175269 */     // GIR_Coverage, 16175,
     /* 1175269 */     GIR_EraseRootFromParent_Done,
     /* 1175270 */   // Label 17143: @1175270
     /* 1175270 */   GIM_Try, /*On fail goto*//*Label 17144*/ GIMT_Encode4(1175350), // Rule ID 16178 //
     /* 1175275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1175286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1175289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1175292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175314 */     // MIs[0] round
     /* 1175314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175324 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1175327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175349 */     // GIR_Coverage, 16178,
     /* 1175349 */     GIR_EraseRootFromParent_Done,
     /* 1175350 */   // Label 17144: @1175350
     /* 1175350 */   GIM_Try, /*On fail goto*//*Label 17145*/ GIMT_Encode4(1175430), // Rule ID 16179 //
     /* 1175355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1175366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1175369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1175372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175394 */     // MIs[0] round
     /* 1175394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175404 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1175407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175429 */     // GIR_Coverage, 16179,
     /* 1175429 */     GIR_EraseRootFromParent_Done,
     /* 1175430 */   // Label 17145: @1175430
     /* 1175430 */   GIM_Try, /*On fail goto*//*Label 17146*/ GIMT_Encode4(1175510), // Rule ID 16182 //
     /* 1175435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1175446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1175449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1175452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175474 */     // MIs[0] round
     /* 1175474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175484 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175509 */     // GIR_Coverage, 16182,
     /* 1175509 */     GIR_EraseRootFromParent_Done,
     /* 1175510 */   // Label 17146: @1175510
     /* 1175510 */   GIM_Try, /*On fail goto*//*Label 17147*/ GIMT_Encode4(1175590), // Rule ID 16183 //
     /* 1175515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1175526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1175529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1175532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175554 */     // MIs[0] round
     /* 1175554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175564 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175589 */     // GIR_Coverage, 16183,
     /* 1175589 */     GIR_EraseRootFromParent_Done,
     /* 1175590 */   // Label 17147: @1175590
     /* 1175590 */   GIM_Try, /*On fail goto*//*Label 17148*/ GIMT_Encode4(1175670), // Rule ID 16186 //
     /* 1175595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1175606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1175609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1175612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175634 */     // MIs[0] round
     /* 1175634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175644 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1175647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175669 */     // GIR_Coverage, 16186,
     /* 1175669 */     GIR_EraseRootFromParent_Done,
     /* 1175670 */   // Label 17148: @1175670
     /* 1175670 */   GIM_Try, /*On fail goto*//*Label 17149*/ GIMT_Encode4(1175750), // Rule ID 16187 //
     /* 1175675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1175686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1175689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1175692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175714 */     // MIs[0] round
     /* 1175714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1175727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175749 */     // GIR_Coverage, 16187,
     /* 1175749 */     GIR_EraseRootFromParent_Done,
     /* 1175750 */   // Label 17149: @1175750
     /* 1175750 */   GIM_Try, /*On fail goto*//*Label 17150*/ GIMT_Encode4(1175830), // Rule ID 16190 //
     /* 1175755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1175766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1175769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175794 */     // MIs[0] round
     /* 1175794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175804 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175829 */     // GIR_Coverage, 16190,
     /* 1175829 */     GIR_EraseRootFromParent_Done,
     /* 1175830 */   // Label 17150: @1175830
     /* 1175830 */   GIM_Try, /*On fail goto*//*Label 17151*/ GIMT_Encode4(1175910), // Rule ID 16191 //
     /* 1175835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1175846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1175849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175874 */     // MIs[0] round
     /* 1175874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175909 */     // GIR_Coverage, 16191,
     /* 1175909 */     GIR_EraseRootFromParent_Done,
     /* 1175910 */   // Label 17151: @1175910
     /* 1175910 */   GIM_Try, /*On fail goto*//*Label 17152*/ GIMT_Encode4(1175990), // Rule ID 16194 //
     /* 1175915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1175929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1175932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175954 */     // MIs[0] round
     /* 1175954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175964 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175989 */     // GIR_Coverage, 16194,
     /* 1175989 */     GIR_EraseRootFromParent_Done,
     /* 1175990 */   // Label 17152: @1175990
     /* 1175990 */   GIM_Try, /*On fail goto*//*Label 17153*/ GIMT_Encode4(1176070), // Rule ID 16195 //
     /* 1175995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1176006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1176009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1176012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176034 */     // MIs[0] round
     /* 1176034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176044 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1176047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1176065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176069 */     // GIR_Coverage, 16195,
     /* 1176069 */     GIR_EraseRootFromParent_Done,
     /* 1176070 */   // Label 17153: @1176070
     /* 1176070 */   GIM_Try, /*On fail goto*//*Label 17154*/ GIMT_Encode4(1176150), // Rule ID 16198 //
     /* 1176075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1176086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1176089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1176092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176114 */     // MIs[0] round
     /* 1176114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176149 */     // GIR_Coverage, 16198,
     /* 1176149 */     GIR_EraseRootFromParent_Done,
     /* 1176150 */   // Label 17154: @1176150
     /* 1176150 */   GIM_Try, /*On fail goto*//*Label 17155*/ GIMT_Encode4(1176230), // Rule ID 16199 //
     /* 1176155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1176166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1176169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1176172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176194 */     // MIs[0] round
     /* 1176194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176204 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11654:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176229 */     // GIR_Coverage, 16199,
     /* 1176229 */     GIR_EraseRootFromParent_Done,
     /* 1176230 */   // Label 17155: @1176230
     /* 1176230 */   GIM_Try, /*On fail goto*//*Label 17156*/ GIMT_Encode4(1176310), // Rule ID 16202 //
     /* 1176235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1176246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1176249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1176252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176274 */     // MIs[0] round
     /* 1176274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176309 */     // GIR_Coverage, 16202,
     /* 1176309 */     GIR_EraseRootFromParent_Done,
     /* 1176310 */   // Label 17156: @1176310
     /* 1176310 */   GIM_Try, /*On fail goto*//*Label 17157*/ GIMT_Encode4(1176390), // Rule ID 16203 //
     /* 1176315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1176326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1176329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1176332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176354 */     // MIs[0] round
     /* 1176354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176364 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176389 */     // GIR_Coverage, 16203,
     /* 1176389 */     GIR_EraseRootFromParent_Done,
     /* 1176390 */   // Label 17157: @1176390
     /* 1176390 */   GIM_Try, /*On fail goto*//*Label 17158*/ GIMT_Encode4(1176470), // Rule ID 16206 //
     /* 1176395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1176406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1176409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1176412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176434 */     // MIs[0] round
     /* 1176434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1176465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176469 */     // GIR_Coverage, 16206,
     /* 1176469 */     GIR_EraseRootFromParent_Done,
     /* 1176470 */   // Label 17158: @1176470
     /* 1176470 */   GIM_Try, /*On fail goto*//*Label 17159*/ GIMT_Encode4(1176550), // Rule ID 16207 //
     /* 1176475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1176486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1176489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1176492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176514 */     // MIs[0] round
     /* 1176514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1176545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176549 */     // GIR_Coverage, 16207,
     /* 1176549 */     GIR_EraseRootFromParent_Done,
     /* 1176550 */   // Label 17159: @1176550
     /* 1176550 */   GIM_Try, /*On fail goto*//*Label 17160*/ GIMT_Encode4(1176630), // Rule ID 16210 //
     /* 1176555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1176558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1176566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1176569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1176572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176594 */     // MIs[0] round
     /* 1176594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176604 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1176625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176629 */     // GIR_Coverage, 16210,
     /* 1176629 */     GIR_EraseRootFromParent_Done,
     /* 1176630 */   // Label 17160: @1176630
     /* 1176630 */   GIM_Try, /*On fail goto*//*Label 17161*/ GIMT_Encode4(1176710), // Rule ID 16211 //
     /* 1176635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1176638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1176646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1176649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1176652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176674 */     // MIs[0] round
     /* 1176674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176684 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1176705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176709 */     // GIR_Coverage, 16211,
     /* 1176709 */     GIR_EraseRootFromParent_Done,
     /* 1176710 */   // Label 17161: @1176710
     /* 1176710 */   GIM_Try, /*On fail goto*//*Label 17162*/ GIMT_Encode4(1176790), // Rule ID 16214 //
     /* 1176715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176754 */     // MIs[0] round
     /* 1176754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176764 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176789 */     // GIR_Coverage, 16214,
     /* 1176789 */     GIR_EraseRootFromParent_Done,
     /* 1176790 */   // Label 17162: @1176790
     /* 1176790 */   GIM_Try, /*On fail goto*//*Label 17163*/ GIMT_Encode4(1176870), // Rule ID 16215 //
     /* 1176795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176834 */     // MIs[0] round
     /* 1176834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176844 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176869 */     // GIR_Coverage, 16215,
     /* 1176869 */     GIR_EraseRootFromParent_Done,
     /* 1176870 */   // Label 17163: @1176870
     /* 1176870 */   GIM_Try, /*On fail goto*//*Label 17164*/ GIMT_Encode4(1176950), // Rule ID 16218 //
     /* 1176875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176914 */     // MIs[0] round
     /* 1176914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176924 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176949 */     // GIR_Coverage, 16218,
     /* 1176949 */     GIR_EraseRootFromParent_Done,
     /* 1176950 */   // Label 17164: @1176950
     /* 1176950 */   GIM_Try, /*On fail goto*//*Label 17165*/ GIMT_Encode4(1177030), // Rule ID 16219 //
     /* 1176955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176994 */     // MIs[0] round
     /* 1176994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177004 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1177025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177029 */     // GIR_Coverage, 16219,
     /* 1177029 */     GIR_EraseRootFromParent_Done,
     /* 1177030 */   // Label 17165: @1177030
     /* 1177030 */   GIM_Try, /*On fail goto*//*Label 17166*/ GIMT_Encode4(1177110), // Rule ID 16222 //
     /* 1177035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1177046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1177049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1177052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177074 */     // MIs[0] round
     /* 1177074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177084 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1177105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177109 */     // GIR_Coverage, 16222,
     /* 1177109 */     GIR_EraseRootFromParent_Done,
     /* 1177110 */   // Label 17166: @1177110
     /* 1177110 */   GIM_Try, /*On fail goto*//*Label 17167*/ GIMT_Encode4(1177190), // Rule ID 16223 //
     /* 1177115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1177126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1177129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1177132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177154 */     // MIs[0] round
     /* 1177154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177164 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1177185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177189 */     // GIR_Coverage, 16223,
     /* 1177189 */     GIR_EraseRootFromParent_Done,
     /* 1177190 */   // Label 17167: @1177190
     /* 1177190 */   GIM_Try, /*On fail goto*//*Label 17168*/ GIMT_Encode4(1177270), // Rule ID 16226 //
     /* 1177195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1177206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1177209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1177212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177234 */     // MIs[0] round
     /* 1177234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177244 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177269 */     // GIR_Coverage, 16226,
     /* 1177269 */     GIR_EraseRootFromParent_Done,
     /* 1177270 */   // Label 17168: @1177270
     /* 1177270 */   GIM_Try, /*On fail goto*//*Label 17169*/ GIMT_Encode4(1177350), // Rule ID 16227 //
     /* 1177275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1177286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1177289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1177292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177314 */     // MIs[0] round
     /* 1177314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177349 */     // GIR_Coverage, 16227,
     /* 1177349 */     GIR_EraseRootFromParent_Done,
     /* 1177350 */   // Label 17169: @1177350
     /* 1177350 */   GIM_Try, /*On fail goto*//*Label 17170*/ GIMT_Encode4(1177430), // Rule ID 16230 //
     /* 1177355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1177366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1177369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1177372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177394 */     // MIs[0] round
     /* 1177394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177429 */     // GIR_Coverage, 16230,
     /* 1177429 */     GIR_EraseRootFromParent_Done,
     /* 1177430 */   // Label 17170: @1177430
     /* 1177430 */   GIM_Try, /*On fail goto*//*Label 17171*/ GIMT_Encode4(1177510), // Rule ID 16231 //
     /* 1177435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1177446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1177449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1177452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177474 */     // MIs[0] round
     /* 1177474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177484 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177509 */     // GIR_Coverage, 16231,
     /* 1177509 */     GIR_EraseRootFromParent_Done,
     /* 1177510 */   // Label 17171: @1177510
     /* 1177510 */   GIM_Try, /*On fail goto*//*Label 17172*/ GIMT_Encode4(1177590), // Rule ID 16234 //
     /* 1177515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1177526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1177529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1177532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177554 */     // MIs[0] round
     /* 1177554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177564 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177589 */     // GIR_Coverage, 16234,
     /* 1177589 */     GIR_EraseRootFromParent_Done,
     /* 1177590 */   // Label 17172: @1177590
     /* 1177590 */   GIM_Try, /*On fail goto*//*Label 17173*/ GIMT_Encode4(1177670), // Rule ID 16235 //
     /* 1177595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1177606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1177609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1177612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177634 */     // MIs[0] round
     /* 1177634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177644 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177669 */     // GIR_Coverage, 16235,
     /* 1177669 */     GIR_EraseRootFromParent_Done,
     /* 1177670 */   // Label 17173: @1177670
     /* 1177670 */   GIM_Try, /*On fail goto*//*Label 17174*/ GIMT_Encode4(1177750), // Rule ID 16238 //
     /* 1177675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1177686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1177689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177714 */     // MIs[0] round
     /* 1177714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177749 */     // GIR_Coverage, 16238,
     /* 1177749 */     GIR_EraseRootFromParent_Done,
     /* 1177750 */   // Label 17174: @1177750
     /* 1177750 */   GIM_Try, /*On fail goto*//*Label 17175*/ GIMT_Encode4(1177830), // Rule ID 16239 //
     /* 1177755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1177766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1177769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177794 */     // MIs[0] round
     /* 1177794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177829 */     // GIR_Coverage, 16239,
     /* 1177829 */     GIR_EraseRootFromParent_Done,
     /* 1177830 */   // Label 17175: @1177830
     /* 1177830 */   GIM_Try, /*On fail goto*//*Label 17176*/ GIMT_Encode4(1177910), // Rule ID 16242 //
     /* 1177835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1177846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1177849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177874 */     // MIs[0] round
     /* 1177874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177909 */     // GIR_Coverage, 16242,
     /* 1177909 */     GIR_EraseRootFromParent_Done,
     /* 1177910 */   // Label 17176: @1177910
     /* 1177910 */   GIM_Try, /*On fail goto*//*Label 17177*/ GIMT_Encode4(1177990), // Rule ID 16243 //
     /* 1177915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1177926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1177929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177954 */     // MIs[0] round
     /* 1177954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177964 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177989 */     // GIR_Coverage, 16243,
     /* 1177989 */     GIR_EraseRootFromParent_Done,
     /* 1177990 */   // Label 17177: @1177990
     /* 1177990 */   GIM_Try, /*On fail goto*//*Label 17178*/ GIMT_Encode4(1178070), // Rule ID 16246 //
     /* 1177995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1178006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1178009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1178012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178034 */     // MIs[0] round
     /* 1178034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178044 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1178047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1178065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178069 */     // GIR_Coverage, 16246,
     /* 1178069 */     GIR_EraseRootFromParent_Done,
     /* 1178070 */   // Label 17178: @1178070
     /* 1178070 */   GIM_Try, /*On fail goto*//*Label 17179*/ GIMT_Encode4(1178150), // Rule ID 16247 //
     /* 1178075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1178086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1178089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1178092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178114 */     // MIs[0] round
     /* 1178114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178124 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1178127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1178145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178149 */     // GIR_Coverage, 16247,
     /* 1178149 */     GIR_EraseRootFromParent_Done,
     /* 1178150 */   // Label 17179: @1178150
     /* 1178150 */   GIM_Try, /*On fail goto*//*Label 17180*/ GIMT_Encode4(1178230), // Rule ID 16250 //
     /* 1178155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1178158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1178166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1178169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1178172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178194 */     // MIs[0] round
     /* 1178194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178204 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1178207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178229 */     // GIR_Coverage, 16250,
     /* 1178229 */     GIR_EraseRootFromParent_Done,
     /* 1178230 */   // Label 17180: @1178230
     /* 1178230 */   GIM_Try, /*On fail goto*//*Label 17181*/ GIMT_Encode4(1178310), // Rule ID 16251 //
     /* 1178235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1178238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1178246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1178249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1178252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178274 */     // MIs[0] round
     /* 1178274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1178287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178309 */     // GIR_Coverage, 16251,
     /* 1178309 */     GIR_EraseRootFromParent_Done,
     /* 1178310 */   // Label 17181: @1178310
     /* 1178310 */   GIM_Try, /*On fail goto*//*Label 17182*/ GIMT_Encode4(1178390), // Rule ID 16254 //
     /* 1178315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1178318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1178326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1178329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1178332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178354 */     // MIs[0] round
     /* 1178354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1178367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178389 */     // GIR_Coverage, 16254,
     /* 1178389 */     GIR_EraseRootFromParent_Done,
     /* 1178390 */   // Label 17182: @1178390
     /* 1178390 */   GIM_Try, /*On fail goto*//*Label 17183*/ GIMT_Encode4(1178470), // Rule ID 16255 //
     /* 1178395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1178398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1178406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1178409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1178412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178434 */     // MIs[0] round
     /* 1178434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178444 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1178447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178469 */     // GIR_Coverage, 16255,
     /* 1178469 */     GIR_EraseRootFromParent_Done,
     /* 1178470 */   // Label 17183: @1178470
     /* 1178470 */   GIM_Try, /*On fail goto*//*Label 17184*/ GIMT_Encode4(1178550), // Rule ID 16258 //
     /* 1178475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1178478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1178486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1178489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1178492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178514 */     // MIs[0] round
     /* 1178514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178524 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1178527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178549 */     // GIR_Coverage, 16258,
     /* 1178549 */     GIR_EraseRootFromParent_Done,
     /* 1178550 */   // Label 17184: @1178550
     /* 1178550 */   GIM_Try, /*On fail goto*//*Label 17185*/ GIMT_Encode4(1178630), // Rule ID 16259 //
     /* 1178555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1178558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1178566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1178569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1178572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178594 */     // MIs[0] round
     /* 1178594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178604 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1178607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178629 */     // GIR_Coverage, 16259,
     /* 1178629 */     GIR_EraseRootFromParent_Done,
     /* 1178630 */   // Label 17185: @1178630
     /* 1178630 */   GIM_Try, /*On fail goto*//*Label 17186*/ GIMT_Encode4(1178713), // Rule ID 16350 //
     /* 1178635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1178646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1178649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1178655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178674 */     // MIs[0] round
     /* 1178674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178684 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1178687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178712 */     // GIR_Coverage, 16350,
     /* 1178712 */     GIR_EraseRootFromParent_Done,
     /* 1178713 */   // Label 17186: @1178713
     /* 1178713 */   GIM_Try, /*On fail goto*//*Label 17187*/ GIMT_Encode4(1178796), // Rule ID 16351 //
     /* 1178718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1178729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1178732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1178738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178757 */     // MIs[0] round
     /* 1178757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178767 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1178770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178778 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178795 */     // GIR_Coverage, 16351,
     /* 1178795 */     GIR_EraseRootFromParent_Done,
     /* 1178796 */   // Label 17187: @1178796
     /* 1178796 */   GIM_Try, /*On fail goto*//*Label 17188*/ GIMT_Encode4(1178879), // Rule ID 16354 //
     /* 1178801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1178821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178840 */     // MIs[0] round
     /* 1178840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178850 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1178853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178878 */     // GIR_Coverage, 16354,
     /* 1178878 */     GIR_EraseRootFromParent_Done,
     /* 1178879 */   // Label 17188: @1178879
     /* 1178879 */   GIM_Try, /*On fail goto*//*Label 17189*/ GIMT_Encode4(1178962), // Rule ID 16355 //
     /* 1178884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1178904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178923 */     // MIs[0] round
     /* 1178923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178933 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1178936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178944 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178961 */     // GIR_Coverage, 16355,
     /* 1178961 */     GIR_EraseRootFromParent_Done,
     /* 1178962 */   // Label 17189: @1178962
     /* 1178962 */   GIM_Try, /*On fail goto*//*Label 17190*/ GIMT_Encode4(1179045), // Rule ID 16358 //
     /* 1178967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1178978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1178981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1178984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1178987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179006 */     // MIs[0] round
     /* 1179006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179016 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179044 */     // GIR_Coverage, 16358,
     /* 1179044 */     GIR_EraseRootFromParent_Done,
     /* 1179045 */   // Label 17190: @1179045
     /* 1179045 */   GIM_Try, /*On fail goto*//*Label 17191*/ GIMT_Encode4(1179128), // Rule ID 16359 //
     /* 1179050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1179061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1179064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1179067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1179070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179089 */     // MIs[0] round
     /* 1179089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179099 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179127 */     // GIR_Coverage, 16359,
     /* 1179127 */     GIR_EraseRootFromParent_Done,
     /* 1179128 */   // Label 17191: @1179128
     /* 1179128 */   GIM_Try, /*On fail goto*//*Label 17192*/ GIMT_Encode4(1179211), // Rule ID 16362 //
     /* 1179133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1179144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1179147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1179150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1179153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179172 */     // MIs[0] round
     /* 1179172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179182 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1179185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179210 */     // GIR_Coverage, 16362,
     /* 1179210 */     GIR_EraseRootFromParent_Done,
     /* 1179211 */   // Label 17192: @1179211
     /* 1179211 */   GIM_Try, /*On fail goto*//*Label 17193*/ GIMT_Encode4(1179294), // Rule ID 16363 //
     /* 1179216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1179227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1179230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1179233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1179236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179255 */     // MIs[0] round
     /* 1179255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179265 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1179268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179276 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179289 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179293 */     // GIR_Coverage, 16363,
     /* 1179293 */     GIR_EraseRootFromParent_Done,
     /* 1179294 */   // Label 17193: @1179294
     /* 1179294 */   GIM_Try, /*On fail goto*//*Label 17194*/ GIMT_Encode4(1179377), // Rule ID 16366 //
     /* 1179299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1179310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1179313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1179316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1179319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179338 */     // MIs[0] round
     /* 1179338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179348 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1179351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179376 */     // GIR_Coverage, 16366,
     /* 1179376 */     GIR_EraseRootFromParent_Done,
     /* 1179377 */   // Label 17194: @1179377
     /* 1179377 */   GIM_Try, /*On fail goto*//*Label 17195*/ GIMT_Encode4(1179460), // Rule ID 16367 //
     /* 1179382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1179393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1179396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1179399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1179402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179421 */     // MIs[0] round
     /* 1179421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179431 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1179434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179442 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179459 */     // GIR_Coverage, 16367,
     /* 1179459 */     GIR_EraseRootFromParent_Done,
     /* 1179460 */   // Label 17195: @1179460
     /* 1179460 */   GIM_Try, /*On fail goto*//*Label 17196*/ GIMT_Encode4(1179543), // Rule ID 16370 //
     /* 1179465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1179476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1179479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1179482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1179485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179504 */     // MIs[0] round
     /* 1179504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179514 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179542 */     // GIR_Coverage, 16370,
     /* 1179542 */     GIR_EraseRootFromParent_Done,
     /* 1179543 */   // Label 17196: @1179543
     /* 1179543 */   GIM_Try, /*On fail goto*//*Label 17197*/ GIMT_Encode4(1179626), // Rule ID 16371 //
     /* 1179548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1179559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1179562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1179565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1179568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179587 */     // MIs[0] round
     /* 1179587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179597 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179608 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179625 */     // GIR_Coverage, 16371,
     /* 1179625 */     GIR_EraseRootFromParent_Done,
     /* 1179626 */   // Label 17197: @1179626
     /* 1179626 */   GIM_Try, /*On fail goto*//*Label 17198*/ GIMT_Encode4(1179709), // Rule ID 16374 //
     /* 1179631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1179642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1179645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1179648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1179651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179670 */     // MIs[0] round
     /* 1179670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179680 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1179683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179708 */     // GIR_Coverage, 16374,
     /* 1179708 */     GIR_EraseRootFromParent_Done,
     /* 1179709 */   // Label 17198: @1179709
     /* 1179709 */   GIM_Try, /*On fail goto*//*Label 17199*/ GIMT_Encode4(1179792), // Rule ID 16375 //
     /* 1179714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1179725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1179728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1179731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1179734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179753 */     // MIs[0] round
     /* 1179753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179763 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1179766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179774 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179791 */     // GIR_Coverage, 16375,
     /* 1179791 */     GIR_EraseRootFromParent_Done,
     /* 1179792 */   // Label 17199: @1179792
     /* 1179792 */   GIM_Try, /*On fail goto*//*Label 17200*/ GIMT_Encode4(1179875), // Rule ID 16378 //
     /* 1179797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1179817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179836 */     // MIs[0] round
     /* 1179836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179846 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179870 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179874 */     // GIR_Coverage, 16378,
     /* 1179874 */     GIR_EraseRootFromParent_Done,
     /* 1179875 */   // Label 17200: @1179875
     /* 1179875 */   GIM_Try, /*On fail goto*//*Label 17201*/ GIMT_Encode4(1179958), // Rule ID 16379 //
     /* 1179880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1179900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179919 */     // MIs[0] round
     /* 1179919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179929 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179940 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179957 */     // GIR_Coverage, 16379,
     /* 1179957 */     GIR_EraseRootFromParent_Done,
     /* 1179958 */   // Label 17201: @1179958
     /* 1179958 */   GIM_Try, /*On fail goto*//*Label 17202*/ GIMT_Encode4(1180041), // Rule ID 16382 //
     /* 1179963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1179974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1179977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1179980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1179983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180002 */     // MIs[0] round
     /* 1180002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180012 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1180015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180040 */     // GIR_Coverage, 16382,
     /* 1180040 */     GIR_EraseRootFromParent_Done,
     /* 1180041 */   // Label 17202: @1180041
     /* 1180041 */   GIM_Try, /*On fail goto*//*Label 17203*/ GIMT_Encode4(1180124), // Rule ID 16383 //
     /* 1180046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1180057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1180060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1180063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1180066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180085 */     // MIs[0] round
     /* 1180085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180095 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1180098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180106 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180123 */     // GIR_Coverage, 16383,
     /* 1180123 */     GIR_EraseRootFromParent_Done,
     /* 1180124 */   // Label 17203: @1180124
     /* 1180124 */   GIM_Try, /*On fail goto*//*Label 17204*/ GIMT_Encode4(1180207), // Rule ID 16386 //
     /* 1180129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1180140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1180143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1180146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1180149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180168 */     // MIs[0] round
     /* 1180168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180178 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180206 */     // GIR_Coverage, 16386,
     /* 1180206 */     GIR_EraseRootFromParent_Done,
     /* 1180207 */   // Label 17204: @1180207
     /* 1180207 */   GIM_Try, /*On fail goto*//*Label 17205*/ GIMT_Encode4(1180290), // Rule ID 16387 //
     /* 1180212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1180223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1180226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1180229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1180232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180251 */     // MIs[0] round
     /* 1180251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180261 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180272 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180289 */     // GIR_Coverage, 16387,
     /* 1180289 */     GIR_EraseRootFromParent_Done,
     /* 1180290 */   // Label 17205: @1180290
     /* 1180290 */   GIM_Try, /*On fail goto*//*Label 17206*/ GIMT_Encode4(1180373), // Rule ID 16390 //
     /* 1180295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1180306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1180309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1180312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1180315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180334 */     // MIs[0] round
     /* 1180334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180344 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1180347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180372 */     // GIR_Coverage, 16390,
     /* 1180372 */     GIR_EraseRootFromParent_Done,
     /* 1180373 */   // Label 17206: @1180373
     /* 1180373 */   GIM_Try, /*On fail goto*//*Label 17207*/ GIMT_Encode4(1180456), // Rule ID 16391 //
     /* 1180378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1180389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1180392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1180395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1180398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180417 */     // MIs[0] round
     /* 1180417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180427 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1180430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180438 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180455 */     // GIR_Coverage, 16391,
     /* 1180455 */     GIR_EraseRootFromParent_Done,
     /* 1180456 */   // Label 17207: @1180456
     /* 1180456 */   GIM_Try, /*On fail goto*//*Label 17208*/ GIMT_Encode4(1180539), // Rule ID 16394 //
     /* 1180461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1180472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1180475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1180478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1180481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180500 */     // MIs[0] round
     /* 1180500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1180513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180538 */     // GIR_Coverage, 16394,
     /* 1180538 */     GIR_EraseRootFromParent_Done,
     /* 1180539 */   // Label 17208: @1180539
     /* 1180539 */   GIM_Try, /*On fail goto*//*Label 17209*/ GIMT_Encode4(1180622), // Rule ID 16395 //
     /* 1180544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1180555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1180558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1180561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1180564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180583 */     // MIs[0] round
     /* 1180583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180593 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1180596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180604 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180621 */     // GIR_Coverage, 16395,
     /* 1180621 */     GIR_EraseRootFromParent_Done,
     /* 1180622 */   // Label 17209: @1180622
     /* 1180622 */   GIM_Try, /*On fail goto*//*Label 17210*/ GIMT_Encode4(1180705), // Rule ID 16398 //
     /* 1180627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1180638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1180641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1180644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1180647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180666 */     // MIs[0] round
     /* 1180666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180676 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1180679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180704 */     // GIR_Coverage, 16398,
     /* 1180704 */     GIR_EraseRootFromParent_Done,
     /* 1180705 */   // Label 17210: @1180705
     /* 1180705 */   GIM_Try, /*On fail goto*//*Label 17211*/ GIMT_Encode4(1180788), // Rule ID 16399 //
     /* 1180710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1180721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1180724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1180727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1180730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180749 */     // MIs[0] round
     /* 1180749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180759 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1180762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180770 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180787 */     // GIR_Coverage, 16399,
     /* 1180787 */     GIR_EraseRootFromParent_Done,
     /* 1180788 */   // Label 17211: @1180788
     /* 1180788 */   GIM_Try, /*On fail goto*//*Label 17212*/ GIMT_Encode4(1180871), // Rule ID 16402 //
     /* 1180793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1180804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1180807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1180810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1180813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180832 */     // MIs[0] round
     /* 1180832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180842 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180870 */     // GIR_Coverage, 16402,
     /* 1180870 */     GIR_EraseRootFromParent_Done,
     /* 1180871 */   // Label 17212: @1180871
     /* 1180871 */   GIM_Try, /*On fail goto*//*Label 17213*/ GIMT_Encode4(1180954), // Rule ID 16403 //
     /* 1180876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1180887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1180890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1180893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1180896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180915 */     // MIs[0] round
     /* 1180915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180936 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180953 */     // GIR_Coverage, 16403,
     /* 1180953 */     GIR_EraseRootFromParent_Done,
     /* 1180954 */   // Label 17213: @1180954
     /* 1180954 */   GIM_Try, /*On fail goto*//*Label 17214*/ GIMT_Encode4(1181037), // Rule ID 16406 //
     /* 1180959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1180970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1180973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1180976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1180979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180998 */     // MIs[0] round
     /* 1180998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181008 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1181011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181036 */     // GIR_Coverage, 16406,
     /* 1181036 */     GIR_EraseRootFromParent_Done,
     /* 1181037 */   // Label 17214: @1181037
     /* 1181037 */   GIM_Try, /*On fail goto*//*Label 17215*/ GIMT_Encode4(1181120), // Rule ID 16407 //
     /* 1181042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1181045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1181053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1181056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1181059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1181062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181081 */     // MIs[0] round
     /* 1181081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181091 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1181094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181102 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181119 */     // GIR_Coverage, 16407,
     /* 1181119 */     GIR_EraseRootFromParent_Done,
     /* 1181120 */   // Label 17215: @1181120
     /* 1181120 */   GIM_Try, /*On fail goto*//*Label 17216*/ GIMT_Encode4(1181203), // Rule ID 16410 //
     /* 1181125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1181136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1181139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1181142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181164 */     // MIs[0] round
     /* 1181164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181174 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1181177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181202 */     // GIR_Coverage, 16410,
     /* 1181202 */     GIR_EraseRootFromParent_Done,
     /* 1181203 */   // Label 17216: @1181203
     /* 1181203 */   GIM_Try, /*On fail goto*//*Label 17217*/ GIMT_Encode4(1181286), // Rule ID 16411 //
     /* 1181208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1181219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1181222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1181225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181247 */     // MIs[0] round
     /* 1181247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181257 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1181260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181268 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181285 */     // GIR_Coverage, 16411,
     /* 1181285 */     GIR_EraseRootFromParent_Done,
     /* 1181286 */   // Label 17217: @1181286
     /* 1181286 */   GIM_Try, /*On fail goto*//*Label 17218*/ GIMT_Encode4(1181369), // Rule ID 16414 //
     /* 1181291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1181302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1181305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1181308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181330 */     // MIs[0] round
     /* 1181330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181340 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1181343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181368 */     // GIR_Coverage, 16414,
     /* 1181368 */     GIR_EraseRootFromParent_Done,
     /* 1181369 */   // Label 17218: @1181369
     /* 1181369 */   GIM_Try, /*On fail goto*//*Label 17219*/ GIMT_Encode4(1181452), // Rule ID 16415 //
     /* 1181374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1181385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1181388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1181391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181413 */     // MIs[0] round
     /* 1181413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181423 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1181426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181434 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181451 */     // GIR_Coverage, 16415,
     /* 1181451 */     GIR_EraseRootFromParent_Done,
     /* 1181452 */   // Label 17219: @1181452
     /* 1181452 */   GIM_Try, /*On fail goto*//*Label 17220*/ GIMT_Encode4(1181535), // Rule ID 16418 //
     /* 1181457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1181468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1181471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1181474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181496 */     // MIs[0] round
     /* 1181496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181506 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181534 */     // GIR_Coverage, 16418,
     /* 1181534 */     GIR_EraseRootFromParent_Done,
     /* 1181535 */   // Label 17220: @1181535
     /* 1181535 */   GIM_Try, /*On fail goto*//*Label 17221*/ GIMT_Encode4(1181618), // Rule ID 16419 //
     /* 1181540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1181551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1181554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1181557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181579 */     // MIs[0] round
     /* 1181579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181589 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181600 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181617 */     // GIR_Coverage, 16419,
     /* 1181617 */     GIR_EraseRootFromParent_Done,
     /* 1181618 */   // Label 17221: @1181618
     /* 1181618 */   GIM_Try, /*On fail goto*//*Label 17222*/ GIMT_Encode4(1181701), // Rule ID 16422 //
     /* 1181623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1181634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1181637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1181640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181662 */     // MIs[0] round
     /* 1181662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181672 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1181675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181700 */     // GIR_Coverage, 16422,
     /* 1181700 */     GIR_EraseRootFromParent_Done,
     /* 1181701 */   // Label 17222: @1181701
     /* 1181701 */   GIM_Try, /*On fail goto*//*Label 17223*/ GIMT_Encode4(1181784), // Rule ID 16423 //
     /* 1181706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1181717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1181720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1181723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181745 */     // MIs[0] round
     /* 1181745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181755 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1181758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181783 */     // GIR_Coverage, 16423,
     /* 1181783 */     GIR_EraseRootFromParent_Done,
     /* 1181784 */   // Label 17223: @1181784
     /* 1181784 */   GIM_Try, /*On fail goto*//*Label 17224*/ GIMT_Encode4(1181867), // Rule ID 16426 //
     /* 1181789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1181800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1181803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1181806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181828 */     // MIs[0] round
     /* 1181828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181838 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1181841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181866 */     // GIR_Coverage, 16426,
     /* 1181866 */     GIR_EraseRootFromParent_Done,
     /* 1181867 */   // Label 17224: @1181867
     /* 1181867 */   GIM_Try, /*On fail goto*//*Label 17225*/ GIMT_Encode4(1181950), // Rule ID 16427 //
     /* 1181872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1181883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1181886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1181889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181911 */     // MIs[0] round
     /* 1181911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181921 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1181924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181932 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181949 */     // GIR_Coverage, 16427,
     /* 1181949 */     GIR_EraseRootFromParent_Done,
     /* 1181950 */   // Label 17225: @1181950
     /* 1181950 */   GIM_Try, /*On fail goto*//*Label 17226*/ GIMT_Encode4(1182033), // Rule ID 16430 //
     /* 1181955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1181966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1181969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1181972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181994 */     // MIs[0] round
     /* 1181994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182004 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182032 */     // GIR_Coverage, 16430,
     /* 1182032 */     GIR_EraseRootFromParent_Done,
     /* 1182033 */   // Label 17226: @1182033
     /* 1182033 */   GIM_Try, /*On fail goto*//*Label 17227*/ GIMT_Encode4(1182116), // Rule ID 16431 //
     /* 1182038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1182049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1182052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1182055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182077 */     // MIs[0] round
     /* 1182077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182087 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182098 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182115 */     // GIR_Coverage, 16431,
     /* 1182115 */     GIR_EraseRootFromParent_Done,
     /* 1182116 */   // Label 17227: @1182116
     /* 1182116 */   GIM_Try, /*On fail goto*//*Label 17228*/ GIMT_Encode4(1182199), // Rule ID 16434 //
     /* 1182121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1182132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1182135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1182138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182160 */     // MIs[0] round
     /* 1182160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182170 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1182173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182198 */     // GIR_Coverage, 16434,
     /* 1182198 */     GIR_EraseRootFromParent_Done,
     /* 1182199 */   // Label 17228: @1182199
     /* 1182199 */   GIM_Try, /*On fail goto*//*Label 17229*/ GIMT_Encode4(1182282), // Rule ID 16435 //
     /* 1182204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1182215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1182218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1182221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182243 */     // MIs[0] round
     /* 1182243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182253 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1182256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182264 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182281 */     // GIR_Coverage, 16435,
     /* 1182281 */     GIR_EraseRootFromParent_Done,
     /* 1182282 */   // Label 17229: @1182282
     /* 1182282 */   GIM_Try, /*On fail goto*//*Label 17230*/ GIMT_Encode4(1182365), // Rule ID 16438 //
     /* 1182287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1182298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1182301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1182304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182326 */     // MIs[0] round
     /* 1182326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182336 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1182339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182364 */     // GIR_Coverage, 16438,
     /* 1182364 */     GIR_EraseRootFromParent_Done,
     /* 1182365 */   // Label 17230: @1182365
     /* 1182365 */   GIM_Try, /*On fail goto*//*Label 17231*/ GIMT_Encode4(1182448), // Rule ID 16439 //
     /* 1182370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1182381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1182384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1182387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182409 */     // MIs[0] round
     /* 1182409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182419 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1182422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182447 */     // GIR_Coverage, 16439,
     /* 1182447 */     GIR_EraseRootFromParent_Done,
     /* 1182448 */   // Label 17231: @1182448
     /* 1182448 */   GIM_Try, /*On fail goto*//*Label 17232*/ GIMT_Encode4(1182531), // Rule ID 16442 //
     /* 1182453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1182464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1182467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1182470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182492 */     // MIs[0] round
     /* 1182492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182502 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182530 */     // GIR_Coverage, 16442,
     /* 1182530 */     GIR_EraseRootFromParent_Done,
     /* 1182531 */   // Label 17232: @1182531
     /* 1182531 */   GIM_Try, /*On fail goto*//*Label 17233*/ GIMT_Encode4(1182614), // Rule ID 16443 //
     /* 1182536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1182547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1182550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1182553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182575 */     // MIs[0] round
     /* 1182575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182585 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182596 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182609 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182613 */     // GIR_Coverage, 16443,
     /* 1182613 */     GIR_EraseRootFromParent_Done,
     /* 1182614 */   // Label 17233: @1182614
     /* 1182614 */   GIM_Try, /*On fail goto*//*Label 17234*/ GIMT_Encode4(1182697), // Rule ID 16446 //
     /* 1182619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1182630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1182633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1182636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182658 */     // MIs[0] round
     /* 1182658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182668 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182696 */     // GIR_Coverage, 16446,
     /* 1182696 */     GIR_EraseRootFromParent_Done,
     /* 1182697 */   // Label 17234: @1182697
     /* 1182697 */   GIM_Try, /*On fail goto*//*Label 17235*/ GIMT_Encode4(1182780), // Rule ID 16447 //
     /* 1182702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1182713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1182716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1182719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182741 */     // MIs[0] round
     /* 1182741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182751 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182762 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182779 */     // GIR_Coverage, 16447,
     /* 1182779 */     GIR_EraseRootFromParent_Done,
     /* 1182780 */   // Label 17235: @1182780
     /* 1182780 */   GIM_Try, /*On fail goto*//*Label 17236*/ GIMT_Encode4(1182863), // Rule ID 16450 //
     /* 1182785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1182796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1182799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1182802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182824 */     // MIs[0] round
     /* 1182824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182834 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182862 */     // GIR_Coverage, 16450,
     /* 1182862 */     GIR_EraseRootFromParent_Done,
     /* 1182863 */   // Label 17236: @1182863
     /* 1182863 */   GIM_Try, /*On fail goto*//*Label 17237*/ GIMT_Encode4(1182946), // Rule ID 16451 //
     /* 1182868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1182879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1182882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1182885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182907 */     // MIs[0] round
     /* 1182907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182917 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182928 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182945 */     // GIR_Coverage, 16451,
     /* 1182945 */     GIR_EraseRootFromParent_Done,
     /* 1182946 */   // Label 17237: @1182946
     /* 1182946 */   GIM_Try, /*On fail goto*//*Label 17238*/ GIMT_Encode4(1183029), // Rule ID 16454 //
     /* 1182951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1182962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1182965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1182968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182990 */     // MIs[0] round
     /* 1182990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1183003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183028 */     // GIR_Coverage, 16454,
     /* 1183028 */     GIR_EraseRootFromParent_Done,
     /* 1183029 */   // Label 17238: @1183029
     /* 1183029 */   GIM_Try, /*On fail goto*//*Label 17239*/ GIMT_Encode4(1183112), // Rule ID 16455 //
     /* 1183034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1183045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1183048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1183051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183073 */     // MIs[0] round
     /* 1183073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183083 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1183086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183094 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183111 */     // GIR_Coverage, 16455,
     /* 1183111 */     GIR_EraseRootFromParent_Done,
     /* 1183112 */   // Label 17239: @1183112
     /* 1183112 */   GIM_Try, /*On fail goto*//*Label 17240*/ GIMT_Encode4(1183195), // Rule ID 16458 //
     /* 1183117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1183120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1183128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1183131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1183134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1183137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183156 */     // MIs[0] round
     /* 1183156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1183169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183194 */     // GIR_Coverage, 16458,
     /* 1183194 */     GIR_EraseRootFromParent_Done,
     /* 1183195 */   // Label 17240: @1183195
     /* 1183195 */   GIM_Try, /*On fail goto*//*Label 17241*/ GIMT_Encode4(1183278), // Rule ID 16459 //
     /* 1183200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1183211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1183214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1183217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183239 */     // MIs[0] round
     /* 1183239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183249 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1183252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183260 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183277 */     // GIR_Coverage, 16459,
     /* 1183277 */     GIR_EraseRootFromParent_Done,
     /* 1183278 */   // Label 17241: @1183278
     /* 1183278 */   GIM_Try, /*On fail goto*//*Label 17242*/ GIMT_Encode4(1183361), // Rule ID 16462 //
     /* 1183283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1183286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1183294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1183297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1183300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1183303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183322 */     // MIs[0] round
     /* 1183322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1183335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183360 */     // GIR_Coverage, 16462,
     /* 1183360 */     GIR_EraseRootFromParent_Done,
     /* 1183361 */   // Label 17242: @1183361
     /* 1183361 */   GIM_Try, /*On fail goto*//*Label 17243*/ GIMT_Encode4(1183444), // Rule ID 16463 //
     /* 1183366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1183377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1183380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1183383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183405 */     // MIs[0] round
     /* 1183405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1183418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183426 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183443 */     // GIR_Coverage, 16463,
     /* 1183443 */     GIR_EraseRootFromParent_Done,
     /* 1183444 */   // Label 17243: @1183444
     /* 1183444 */   GIM_Try, /*On fail goto*//*Label 17244*/ GIMT_Encode4(1183527), // Rule ID 16466 //
     /* 1183449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1183452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1183460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1183463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1183466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1183469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183488 */     // MIs[0] round
     /* 1183488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183498 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1183501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183526 */     // GIR_Coverage, 16466,
     /* 1183526 */     GIR_EraseRootFromParent_Done,
     /* 1183527 */   // Label 17244: @1183527
     /* 1183527 */   GIM_Try, /*On fail goto*//*Label 17245*/ GIMT_Encode4(1183610), // Rule ID 16467 //
     /* 1183532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1183543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1183546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1183549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183571 */     // MIs[0] round
     /* 1183571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183581 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1183584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183592 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183609 */     // GIR_Coverage, 16467,
     /* 1183609 */     GIR_EraseRootFromParent_Done,
     /* 1183610 */   // Label 17245: @1183610
     /* 1183610 */   GIM_Try, /*On fail goto*//*Label 17246*/ GIMT_Encode4(1183693), // Rule ID 16530 //
     /* 1183615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1183626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1183629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1183632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1183635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183654 */     // MIs[0] round
     /* 1183654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183664 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1183667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183692 */     // GIR_Coverage, 16530,
     /* 1183692 */     GIR_EraseRootFromParent_Done,
     /* 1183693 */   // Label 17246: @1183693
     /* 1183693 */   GIM_Try, /*On fail goto*//*Label 17247*/ GIMT_Encode4(1183776), // Rule ID 16531 //
     /* 1183698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1183709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1183712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1183715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1183718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183737 */     // MIs[0] round
     /* 1183737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183747 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1183750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183758 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183775 */     // GIR_Coverage, 16531,
     /* 1183775 */     GIR_EraseRootFromParent_Done,
     /* 1183776 */   // Label 17247: @1183776
     /* 1183776 */   GIM_Try, /*On fail goto*//*Label 17248*/ GIMT_Encode4(1183859), // Rule ID 16534 //
     /* 1183781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1183792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1183795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1183798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1183801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183820 */     // MIs[0] round
     /* 1183820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183830 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1183833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183858 */     // GIR_Coverage, 16534,
     /* 1183858 */     GIR_EraseRootFromParent_Done,
     /* 1183859 */   // Label 17248: @1183859
     /* 1183859 */   GIM_Try, /*On fail goto*//*Label 17249*/ GIMT_Encode4(1183942), // Rule ID 16535 //
     /* 1183864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1183875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1183878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1183881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1183884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183903 */     // MIs[0] round
     /* 1183903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183913 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1183916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183924 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183941 */     // GIR_Coverage, 16535,
     /* 1183941 */     GIR_EraseRootFromParent_Done,
     /* 1183942 */   // Label 17249: @1183942
     /* 1183942 */   GIM_Try, /*On fail goto*//*Label 17250*/ GIMT_Encode4(1184025), // Rule ID 16538 //
     /* 1183947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1183958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1183961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1183964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1183967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183986 */     // MIs[0] round
     /* 1183986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183996 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1183999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184024 */     // GIR_Coverage, 16538,
     /* 1184024 */     GIR_EraseRootFromParent_Done,
     /* 1184025 */   // Label 17250: @1184025
     /* 1184025 */   GIM_Try, /*On fail goto*//*Label 17251*/ GIMT_Encode4(1184108), // Rule ID 16539 //
     /* 1184030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1184041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1184044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1184047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1184050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184069 */     // MIs[0] round
     /* 1184069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184079 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184090 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184107 */     // GIR_Coverage, 16539,
     /* 1184107 */     GIR_EraseRootFromParent_Done,
     /* 1184108 */   // Label 17251: @1184108
     /* 1184108 */   GIM_Try, /*On fail goto*//*Label 17252*/ GIMT_Encode4(1184191), // Rule ID 16542 //
     /* 1184113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1184124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1184127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1184130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1184133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184152 */     // MIs[0] round
     /* 1184152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184162 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184190 */     // GIR_Coverage, 16542,
     /* 1184190 */     GIR_EraseRootFromParent_Done,
     /* 1184191 */   // Label 17252: @1184191
     /* 1184191 */   GIM_Try, /*On fail goto*//*Label 17253*/ GIMT_Encode4(1184274), // Rule ID 16543 //
     /* 1184196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1184207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1184210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1184213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1184216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184235 */     // MIs[0] round
     /* 1184235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184245 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184256 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184273 */     // GIR_Coverage, 16543,
     /* 1184273 */     GIR_EraseRootFromParent_Done,
     /* 1184274 */   // Label 17253: @1184274
     /* 1184274 */   GIM_Try, /*On fail goto*//*Label 17254*/ GIMT_Encode4(1184357), // Rule ID 16546 //
     /* 1184279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1184290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1184293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1184296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1184299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184318 */     // MIs[0] round
     /* 1184318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184328 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1184331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184356 */     // GIR_Coverage, 16546,
     /* 1184356 */     GIR_EraseRootFromParent_Done,
     /* 1184357 */   // Label 17254: @1184357
     /* 1184357 */   GIM_Try, /*On fail goto*//*Label 17255*/ GIMT_Encode4(1184440), // Rule ID 16547 //
     /* 1184362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1184373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1184376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1184379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1184382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184401 */     // MIs[0] round
     /* 1184401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184411 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1184414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184422 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184439 */     // GIR_Coverage, 16547,
     /* 1184439 */     GIR_EraseRootFromParent_Done,
     /* 1184440 */   // Label 17255: @1184440
     /* 1184440 */   GIM_Try, /*On fail goto*//*Label 17256*/ GIMT_Encode4(1184523), // Rule ID 16550 //
     /* 1184445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1184456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1184459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1184462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1184465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184484 */     // MIs[0] round
     /* 1184484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184494 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184522 */     // GIR_Coverage, 16550,
     /* 1184522 */     GIR_EraseRootFromParent_Done,
     /* 1184523 */   // Label 17256: @1184523
     /* 1184523 */   GIM_Try, /*On fail goto*//*Label 17257*/ GIMT_Encode4(1184606), // Rule ID 16551 //
     /* 1184528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1184539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1184542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1184545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1184548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184567 */     // MIs[0] round
     /* 1184567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184577 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184588 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184605 */     // GIR_Coverage, 16551,
     /* 1184605 */     GIR_EraseRootFromParent_Done,
     /* 1184606 */   // Label 17257: @1184606
     /* 1184606 */   GIM_Try, /*On fail goto*//*Label 17258*/ GIMT_Encode4(1184689), // Rule ID 16554 //
     /* 1184611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1184622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1184625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1184628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1184631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184650 */     // MIs[0] round
     /* 1184650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184660 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1184663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184688 */     // GIR_Coverage, 16554,
     /* 1184688 */     GIR_EraseRootFromParent_Done,
     /* 1184689 */   // Label 17258: @1184689
     /* 1184689 */   GIM_Try, /*On fail goto*//*Label 17259*/ GIMT_Encode4(1184772), // Rule ID 16555 //
     /* 1184694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1184705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1184708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1184711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1184714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184733 */     // MIs[0] round
     /* 1184733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184743 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1184746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184754 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184771 */     // GIR_Coverage, 16555,
     /* 1184771 */     GIR_EraseRootFromParent_Done,
     /* 1184772 */   // Label 17259: @1184772
     /* 1184772 */   GIM_Try, /*On fail goto*//*Label 17260*/ GIMT_Encode4(1184855), // Rule ID 16558 //
     /* 1184777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1184788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1184791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1184794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1184797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184816 */     // MIs[0] round
     /* 1184816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184854 */     // GIR_Coverage, 16558,
     /* 1184854 */     GIR_EraseRootFromParent_Done,
     /* 1184855 */   // Label 17260: @1184855
     /* 1184855 */   GIM_Try, /*On fail goto*//*Label 17261*/ GIMT_Encode4(1184938), // Rule ID 16559 //
     /* 1184860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1184871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1184874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1184877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1184880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184899 */     // MIs[0] round
     /* 1184899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184909 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184920 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184937 */     // GIR_Coverage, 16559,
     /* 1184937 */     GIR_EraseRootFromParent_Done,
     /* 1184938 */   // Label 17261: @1184938
     /* 1184938 */   GIM_Try, /*On fail goto*//*Label 17262*/ GIMT_Encode4(1185021), // Rule ID 16562 //
     /* 1184943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1184954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1184957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1184960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1184963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184982 */     // MIs[0] round
     /* 1184982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184992 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185020 */     // GIR_Coverage, 16562,
     /* 1185020 */     GIR_EraseRootFromParent_Done,
     /* 1185021 */   // Label 17262: @1185021
     /* 1185021 */   GIM_Try, /*On fail goto*//*Label 17263*/ GIMT_Encode4(1185104), // Rule ID 16563 //
     /* 1185026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1185037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1185040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1185043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1185046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185065 */     // MIs[0] round
     /* 1185065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1185078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185103 */     // GIR_Coverage, 16563,
     /* 1185103 */     GIR_EraseRootFromParent_Done,
     /* 1185104 */   // Label 17263: @1185104
     /* 1185104 */   GIM_Try, /*On fail goto*//*Label 17264*/ GIMT_Encode4(1185187), // Rule ID 16566 //
     /* 1185109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1185120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1185123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1185126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1185129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185148 */     // MIs[0] round
     /* 1185148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185158 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185186 */     // GIR_Coverage, 16566,
     /* 1185186 */     GIR_EraseRootFromParent_Done,
     /* 1185187 */   // Label 17264: @1185187
     /* 1185187 */   GIM_Try, /*On fail goto*//*Label 17265*/ GIMT_Encode4(1185270), // Rule ID 16567 //
     /* 1185192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1185203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1185206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1185209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1185212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185231 */     // MIs[0] round
     /* 1185231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185241 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185252 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185269 */     // GIR_Coverage, 16567,
     /* 1185269 */     GIR_EraseRootFromParent_Done,
     /* 1185270 */   // Label 17265: @1185270
     /* 1185270 */   GIM_Try, /*On fail goto*//*Label 17266*/ GIMT_Encode4(1185353), // Rule ID 16570 //
     /* 1185275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1185286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1185289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1185292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1185295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185314 */     // MIs[0] round
     /* 1185314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1185327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185352 */     // GIR_Coverage, 16570,
     /* 1185352 */     GIR_EraseRootFromParent_Done,
     /* 1185353 */   // Label 17266: @1185353
     /* 1185353 */   GIM_Try, /*On fail goto*//*Label 17267*/ GIMT_Encode4(1185436), // Rule ID 16571 //
     /* 1185358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1185369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1185372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1185375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1185378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185397 */     // MIs[0] round
     /* 1185397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185407 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1185410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185418 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185435 */     // GIR_Coverage, 16571,
     /* 1185435 */     GIR_EraseRootFromParent_Done,
     /* 1185436 */   // Label 17267: @1185436
     /* 1185436 */   GIM_Try, /*On fail goto*//*Label 17268*/ GIMT_Encode4(1185519), // Rule ID 16574 //
     /* 1185441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1185452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1185455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1185458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1185461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185480 */     // MIs[0] round
     /* 1185480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185490 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1185493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185518 */     // GIR_Coverage, 16574,
     /* 1185518 */     GIR_EraseRootFromParent_Done,
     /* 1185519 */   // Label 17268: @1185519
     /* 1185519 */   GIM_Try, /*On fail goto*//*Label 17269*/ GIMT_Encode4(1185602), // Rule ID 16575 //
     /* 1185524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1185535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1185538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1185541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1185544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185563 */     // MIs[0] round
     /* 1185563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185573 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1185576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185584 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185601 */     // GIR_Coverage, 16575,
     /* 1185601 */     GIR_EraseRootFromParent_Done,
     /* 1185602 */   // Label 17269: @1185602
     /* 1185602 */   GIM_Try, /*On fail goto*//*Label 17270*/ GIMT_Encode4(1185685), // Rule ID 16578 //
     /* 1185607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1185618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1185621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1185624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1185627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185646 */     // MIs[0] round
     /* 1185646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1185659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185684 */     // GIR_Coverage, 16578,
     /* 1185684 */     GIR_EraseRootFromParent_Done,
     /* 1185685 */   // Label 17270: @1185685
     /* 1185685 */   GIM_Try, /*On fail goto*//*Label 17271*/ GIMT_Encode4(1185768), // Rule ID 16579 //
     /* 1185690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1185701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1185704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1185707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1185710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185729 */     // MIs[0] round
     /* 1185729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185739 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1185742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185767 */     // GIR_Coverage, 16579,
     /* 1185767 */     GIR_EraseRootFromParent_Done,
     /* 1185768 */   // Label 17271: @1185768
     /* 1185768 */   GIM_Try, /*On fail goto*//*Label 17272*/ GIMT_Encode4(1185851), // Rule ID 16582 //
     /* 1185773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1185784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1185787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1185793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185812 */     // MIs[0] round
     /* 1185812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185850 */     // GIR_Coverage, 16582,
     /* 1185850 */     GIR_EraseRootFromParent_Done,
     /* 1185851 */   // Label 17272: @1185851
     /* 1185851 */   GIM_Try, /*On fail goto*//*Label 17273*/ GIMT_Encode4(1185934), // Rule ID 16583 //
     /* 1185856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1185867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1185870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1185876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185895 */     // MIs[0] round
     /* 1185895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185905 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185916 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185933 */     // GIR_Coverage, 16583,
     /* 1185933 */     GIR_EraseRootFromParent_Done,
     /* 1185934 */   // Label 17273: @1185934
     /* 1185934 */   GIM_Try, /*On fail goto*//*Label 17274*/ GIMT_Encode4(1186017), // Rule ID 16586 //
     /* 1185939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1185950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1185953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1185956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1185959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185978 */     // MIs[0] round
     /* 1185978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185988 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1185991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186016 */     // GIR_Coverage, 16586,
     /* 1186016 */     GIR_EraseRootFromParent_Done,
     /* 1186017 */   // Label 17274: @1186017
     /* 1186017 */   GIM_Try, /*On fail goto*//*Label 17275*/ GIMT_Encode4(1186100), // Rule ID 16587 //
     /* 1186022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1186025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1186033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1186036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1186039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1186042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186061 */     // MIs[0] round
     /* 1186061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186071 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1186074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186082 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186099 */     // GIR_Coverage, 16587,
     /* 1186099 */     GIR_EraseRootFromParent_Done,
     /* 1186100 */   // Label 17275: @1186100
     /* 1186100 */   GIM_Try, /*On fail goto*//*Label 17276*/ GIMT_Encode4(1186183), // Rule ID 16590 //
     /* 1186105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1186116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1186119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1186122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186144 */     // MIs[0] round
     /* 1186144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186154 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1186157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186182 */     // GIR_Coverage, 16590,
     /* 1186182 */     GIR_EraseRootFromParent_Done,
     /* 1186183 */   // Label 17276: @1186183
     /* 1186183 */   GIM_Try, /*On fail goto*//*Label 17277*/ GIMT_Encode4(1186266), // Rule ID 16591 //
     /* 1186188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1186199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1186202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1186205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186227 */     // MIs[0] round
     /* 1186227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186237 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1186240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186248 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186265 */     // GIR_Coverage, 16591,
     /* 1186265 */     GIR_EraseRootFromParent_Done,
     /* 1186266 */   // Label 17277: @1186266
     /* 1186266 */   GIM_Try, /*On fail goto*//*Label 17278*/ GIMT_Encode4(1186349), // Rule ID 16594 //
     /* 1186271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1186282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1186285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1186288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186310 */     // MIs[0] round
     /* 1186310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186320 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1186323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186348 */     // GIR_Coverage, 16594,
     /* 1186348 */     GIR_EraseRootFromParent_Done,
     /* 1186349 */   // Label 17278: @1186349
     /* 1186349 */   GIM_Try, /*On fail goto*//*Label 17279*/ GIMT_Encode4(1186432), // Rule ID 16595 //
     /* 1186354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1186365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1186368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1186371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186393 */     // MIs[0] round
     /* 1186393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186403 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1186406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186414 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186431 */     // GIR_Coverage, 16595,
     /* 1186431 */     GIR_EraseRootFromParent_Done,
     /* 1186432 */   // Label 17279: @1186432
     /* 1186432 */   GIM_Try, /*On fail goto*//*Label 17280*/ GIMT_Encode4(1186515), // Rule ID 16598 //
     /* 1186437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1186448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1186451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1186454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186476 */     // MIs[0] round
     /* 1186476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186486 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186514 */     // GIR_Coverage, 16598,
     /* 1186514 */     GIR_EraseRootFromParent_Done,
     /* 1186515 */   // Label 17280: @1186515
     /* 1186515 */   GIM_Try, /*On fail goto*//*Label 17281*/ GIMT_Encode4(1186598), // Rule ID 16599 //
     /* 1186520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1186531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1186534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1186537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186559 */     // MIs[0] round
     /* 1186559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186569 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186580 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186597 */     // GIR_Coverage, 16599,
     /* 1186597 */     GIR_EraseRootFromParent_Done,
     /* 1186598 */   // Label 17281: @1186598
     /* 1186598 */   GIM_Try, /*On fail goto*//*Label 17282*/ GIMT_Encode4(1186681), // Rule ID 16602 //
     /* 1186603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1186614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1186617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1186620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186642 */     // MIs[0] round
     /* 1186642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1186655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186680 */     // GIR_Coverage, 16602,
     /* 1186680 */     GIR_EraseRootFromParent_Done,
     /* 1186681 */   // Label 17282: @1186681
     /* 1186681 */   GIM_Try, /*On fail goto*//*Label 17283*/ GIMT_Encode4(1186764), // Rule ID 16603 //
     /* 1186686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1186697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1186700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1186703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186725 */     // MIs[0] round
     /* 1186725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186735 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1186738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186746 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186763 */     // GIR_Coverage, 16603,
     /* 1186763 */     GIR_EraseRootFromParent_Done,
     /* 1186764 */   // Label 17283: @1186764
     /* 1186764 */   GIM_Try, /*On fail goto*//*Label 17284*/ GIMT_Encode4(1186847), // Rule ID 16606 //
     /* 1186769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1186780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1186783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1186786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186808 */     // MIs[0] round
     /* 1186808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1186821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186846 */     // GIR_Coverage, 16606,
     /* 1186846 */     GIR_EraseRootFromParent_Done,
     /* 1186847 */   // Label 17284: @1186847
     /* 1186847 */   GIM_Try, /*On fail goto*//*Label 17285*/ GIMT_Encode4(1186930), // Rule ID 16607 //
     /* 1186852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1186863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1186866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1186869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186891 */     // MIs[0] round
     /* 1186891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186901 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1186904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186912 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186929 */     // GIR_Coverage, 16607,
     /* 1186929 */     GIR_EraseRootFromParent_Done,
     /* 1186930 */   // Label 17285: @1186930
     /* 1186930 */   GIM_Try, /*On fail goto*//*Label 17286*/ GIMT_Encode4(1187013), // Rule ID 16610 //
     /* 1186935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1186946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1186949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1186952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186974 */     // MIs[0] round
     /* 1186974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186984 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1186987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187012 */     // GIR_Coverage, 16610,
     /* 1187012 */     GIR_EraseRootFromParent_Done,
     /* 1187013 */   // Label 17286: @1187013
     /* 1187013 */   GIM_Try, /*On fail goto*//*Label 17287*/ GIMT_Encode4(1187096), // Rule ID 16611 //
     /* 1187018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1187029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1187032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1187035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187057 */     // MIs[0] round
     /* 1187057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187067 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187078 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187095 */     // GIR_Coverage, 16611,
     /* 1187095 */     GIR_EraseRootFromParent_Done,
     /* 1187096 */   // Label 17287: @1187096
     /* 1187096 */   GIM_Try, /*On fail goto*//*Label 17288*/ GIMT_Encode4(1187179), // Rule ID 16614 //
     /* 1187101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1187112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1187115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1187118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187140 */     // MIs[0] round
     /* 1187140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187150 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1187153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187178 */     // GIR_Coverage, 16614,
     /* 1187178 */     GIR_EraseRootFromParent_Done,
     /* 1187179 */   // Label 17288: @1187179
     /* 1187179 */   GIM_Try, /*On fail goto*//*Label 17289*/ GIMT_Encode4(1187262), // Rule ID 16615 //
     /* 1187184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1187195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1187198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1187201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187223 */     // MIs[0] round
     /* 1187223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187233 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1187236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187244 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187261 */     // GIR_Coverage, 16615,
     /* 1187261 */     GIR_EraseRootFromParent_Done,
     /* 1187262 */   // Label 17289: @1187262
     /* 1187262 */   GIM_Try, /*On fail goto*//*Label 17290*/ GIMT_Encode4(1187345), // Rule ID 16618 //
     /* 1187267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1187278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1187281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1187284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187306 */     // MIs[0] round
     /* 1187306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187316 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1187319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187344 */     // GIR_Coverage, 16618,
     /* 1187344 */     GIR_EraseRootFromParent_Done,
     /* 1187345 */   // Label 17290: @1187345
     /* 1187345 */   GIM_Try, /*On fail goto*//*Label 17291*/ GIMT_Encode4(1187428), // Rule ID 16619 //
     /* 1187350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1187361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1187364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1187367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187389 */     // MIs[0] round
     /* 1187389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187399 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1187402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187410 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187427 */     // GIR_Coverage, 16619,
     /* 1187427 */     GIR_EraseRootFromParent_Done,
     /* 1187428 */   // Label 17291: @1187428
     /* 1187428 */   GIM_Try, /*On fail goto*//*Label 17292*/ GIMT_Encode4(1187511), // Rule ID 16622 //
     /* 1187433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1187444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1187447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1187450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187472 */     // MIs[0] round
     /* 1187472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187482 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187510 */     // GIR_Coverage, 16622,
     /* 1187510 */     GIR_EraseRootFromParent_Done,
     /* 1187511 */   // Label 17292: @1187511
     /* 1187511 */   GIM_Try, /*On fail goto*//*Label 17293*/ GIMT_Encode4(1187594), // Rule ID 16623 //
     /* 1187516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1187527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1187530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1187533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187555 */     // MIs[0] round
     /* 1187555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187565 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187576 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187593 */     // GIR_Coverage, 16623,
     /* 1187593 */     GIR_EraseRootFromParent_Done,
     /* 1187594 */   // Label 17293: @1187594
     /* 1187594 */   GIM_Try, /*On fail goto*//*Label 17294*/ GIMT_Encode4(1187677), // Rule ID 16626 //
     /* 1187599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1187610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1187613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1187616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187638 */     // MIs[0] round
     /* 1187638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187648 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187676 */     // GIR_Coverage, 16626,
     /* 1187676 */     GIR_EraseRootFromParent_Done,
     /* 1187677 */   // Label 17294: @1187677
     /* 1187677 */   GIM_Try, /*On fail goto*//*Label 17295*/ GIMT_Encode4(1187760), // Rule ID 16627 //
     /* 1187682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1187693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1187696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1187699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187721 */     // MIs[0] round
     /* 1187721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187742 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187759 */     // GIR_Coverage, 16627,
     /* 1187759 */     GIR_EraseRootFromParent_Done,
     /* 1187760 */   // Label 17295: @1187760
     /* 1187760 */   GIM_Try, /*On fail goto*//*Label 17296*/ GIMT_Encode4(1187843), // Rule ID 16630 //
     /* 1187765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1187776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1187779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1187782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187804 */     // MIs[0] round
     /* 1187804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187814 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187842 */     // GIR_Coverage, 16630,
     /* 1187842 */     GIR_EraseRootFromParent_Done,
     /* 1187843 */   // Label 17296: @1187843
     /* 1187843 */   GIM_Try, /*On fail goto*//*Label 17297*/ GIMT_Encode4(1187926), // Rule ID 16631 //
     /* 1187848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1187859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1187862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1187865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187887 */     // MIs[0] round
     /* 1187887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187897 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187908 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187925 */     // GIR_Coverage, 16631,
     /* 1187925 */     GIR_EraseRootFromParent_Done,
     /* 1187926 */   // Label 17297: @1187926
     /* 1187926 */   GIM_Try, /*On fail goto*//*Label 17298*/ GIMT_Encode4(1188009), // Rule ID 16634 //
     /* 1187931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1187942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1187945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1187948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187970 */     // MIs[0] round
     /* 1187970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187980 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1187983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188008 */     // GIR_Coverage, 16634,
     /* 1188008 */     GIR_EraseRootFromParent_Done,
     /* 1188009 */   // Label 17298: @1188009
     /* 1188009 */   GIM_Try, /*On fail goto*//*Label 17299*/ GIMT_Encode4(1188092), // Rule ID 16635 //
     /* 1188014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1188017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1188031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188053 */     // MIs[0] round
     /* 1188053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188063 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1188066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188074 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188091 */     // GIR_Coverage, 16635,
     /* 1188091 */     GIR_EraseRootFromParent_Done,
     /* 1188092 */   // Label 17299: @1188092
     /* 1188092 */   GIM_Try, /*On fail goto*//*Label 17300*/ GIMT_Encode4(1188175), // Rule ID 16638 //
     /* 1188097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1188100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1188114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188136 */     // MIs[0] round
     /* 1188136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188146 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1188149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188174 */     // GIR_Coverage, 16638,
     /* 1188174 */     GIR_EraseRootFromParent_Done,
     /* 1188175 */   // Label 17300: @1188175
     /* 1188175 */   GIM_Try, /*On fail goto*//*Label 17301*/ GIMT_Encode4(1188258), // Rule ID 16639 //
     /* 1188180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1188183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1188197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188219 */     // MIs[0] round
     /* 1188219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188229 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1188232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188240 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188257 */     // GIR_Coverage, 16639,
     /* 1188257 */     GIR_EraseRootFromParent_Done,
     /* 1188258 */   // Label 17301: @1188258
     /* 1188258 */   GIM_Try, /*On fail goto*//*Label 17302*/ GIMT_Encode4(1188341), // Rule ID 16642 //
     /* 1188263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1188266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1188274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1188277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1188280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188302 */     // MIs[0] round
     /* 1188302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188312 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1188315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188340 */     // GIR_Coverage, 16642,
     /* 1188340 */     GIR_EraseRootFromParent_Done,
     /* 1188341 */   // Label 17302: @1188341
     /* 1188341 */   GIM_Try, /*On fail goto*//*Label 17303*/ GIMT_Encode4(1188424), // Rule ID 16643 //
     /* 1188346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1188349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1188357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1188360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1188363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188385 */     // MIs[0] round
     /* 1188385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1188398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188423 */     // GIR_Coverage, 16643,
     /* 1188423 */     GIR_EraseRootFromParent_Done,
     /* 1188424 */   // Label 17303: @1188424
     /* 1188424 */   GIM_Try, /*On fail goto*//*Label 17304*/ GIMT_Encode4(1188507), // Rule ID 16646 //
     /* 1188429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1188432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1188440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1188443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1188446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188468 */     // MIs[0] round
     /* 1188468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1188481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188506 */     // GIR_Coverage, 16646,
     /* 1188506 */     GIR_EraseRootFromParent_Done,
     /* 1188507 */   // Label 17304: @1188507
     /* 1188507 */   GIM_Try, /*On fail goto*//*Label 17305*/ GIMT_Encode4(1188590), // Rule ID 16647 //
     /* 1188512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1188515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1188523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1188526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1188529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188551 */     // MIs[0] round
     /* 1188551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188561 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1188564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188572 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188589 */     // GIR_Coverage, 16647,
     /* 1188589 */     GIR_EraseRootFromParent_Done,
     /* 1188590 */   // Label 17305: @1188590
     /* 1188590 */   GIM_Try, /*On fail goto*//*Label 17306*/ GIMT_Encode4(1188670), // Rule ID 16710 //
     /* 1188595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1188606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1188609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1188612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1188615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188634 */     // MIs[0] round
     /* 1188634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188644 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1188647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188669 */     // GIR_Coverage, 16710,
     /* 1188669 */     GIR_EraseRootFromParent_Done,
     /* 1188670 */   // Label 17306: @1188670
     /* 1188670 */   GIM_Try, /*On fail goto*//*Label 17307*/ GIMT_Encode4(1188750), // Rule ID 16711 //
     /* 1188675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1188686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1188689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1188692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1188695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188714 */     // MIs[0] round
     /* 1188714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188724 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1188727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188749 */     // GIR_Coverage, 16711,
     /* 1188749 */     GIR_EraseRootFromParent_Done,
     /* 1188750 */   // Label 17307: @1188750
     /* 1188750 */   GIM_Try, /*On fail goto*//*Label 17308*/ GIMT_Encode4(1188830), // Rule ID 16714 //
     /* 1188755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1188772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188794 */     // MIs[0] round
     /* 1188794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188804 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1188807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188829 */     // GIR_Coverage, 16714,
     /* 1188829 */     GIR_EraseRootFromParent_Done,
     /* 1188830 */   // Label 17308: @1188830
     /* 1188830 */   GIM_Try, /*On fail goto*//*Label 17309*/ GIMT_Encode4(1188910), // Rule ID 16715 //
     /* 1188835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1188852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188874 */     // MIs[0] round
     /* 1188874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188884 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1188887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188909 */     // GIR_Coverage, 16715,
     /* 1188909 */     GIR_EraseRootFromParent_Done,
     /* 1188910 */   // Label 17309: @1188910
     /* 1188910 */   GIM_Try, /*On fail goto*//*Label 17310*/ GIMT_Encode4(1188990), // Rule ID 16718 //
     /* 1188915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1188918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1188932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1188935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188954 */     // MIs[0] round
     /* 1188954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188964 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1188967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188989 */     // GIR_Coverage, 16718,
     /* 1188989 */     GIR_EraseRootFromParent_Done,
     /* 1188990 */   // Label 17310: @1188990
     /* 1188990 */   GIM_Try, /*On fail goto*//*Label 17311*/ GIMT_Encode4(1189070), // Rule ID 16719 //
     /* 1188995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1188998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1189006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1189009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1189012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1189015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189034 */     // MIs[0] round
     /* 1189034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189044 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1189047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189069 */     // GIR_Coverage, 16719,
     /* 1189069 */     GIR_EraseRootFromParent_Done,
     /* 1189070 */   // Label 17311: @1189070
     /* 1189070 */   GIM_Try, /*On fail goto*//*Label 17312*/ GIMT_Encode4(1189150), // Rule ID 16722 //
     /* 1189075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1189086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1189089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1189092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1189095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189114 */     // MIs[0] round
     /* 1189114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189124 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1189127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189149 */     // GIR_Coverage, 16722,
     /* 1189149 */     GIR_EraseRootFromParent_Done,
     /* 1189150 */   // Label 17312: @1189150
     /* 1189150 */   GIM_Try, /*On fail goto*//*Label 17313*/ GIMT_Encode4(1189230), // Rule ID 16723 //
     /* 1189155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1189166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1189169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1189172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1189175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189194 */     // MIs[0] round
     /* 1189194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189204 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1189207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189229 */     // GIR_Coverage, 16723,
     /* 1189229 */     GIR_EraseRootFromParent_Done,
     /* 1189230 */   // Label 17313: @1189230
     /* 1189230 */   GIM_Try, /*On fail goto*//*Label 17314*/ GIMT_Encode4(1189310), // Rule ID 16726 //
     /* 1189235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1189246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1189249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1189252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1189255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189274 */     // MIs[0] round
     /* 1189274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189284 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1189287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189309 */     // GIR_Coverage, 16726,
     /* 1189309 */     GIR_EraseRootFromParent_Done,
     /* 1189310 */   // Label 17314: @1189310
     /* 1189310 */   GIM_Try, /*On fail goto*//*Label 17315*/ GIMT_Encode4(1189390), // Rule ID 16727 //
     /* 1189315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1189326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1189329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1189332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1189335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189354 */     // MIs[0] round
     /* 1189354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189364 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1189367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189389 */     // GIR_Coverage, 16727,
     /* 1189389 */     GIR_EraseRootFromParent_Done,
     /* 1189390 */   // Label 17315: @1189390
     /* 1189390 */   GIM_Try, /*On fail goto*//*Label 17316*/ GIMT_Encode4(1189470), // Rule ID 16730 //
     /* 1189395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1189398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1189406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1189409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1189412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1189415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189434 */     // MIs[0] round
     /* 1189434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189444 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1189447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189469 */     // GIR_Coverage, 16730,
     /* 1189469 */     GIR_EraseRootFromParent_Done,
     /* 1189470 */   // Label 17316: @1189470
     /* 1189470 */   GIM_Try, /*On fail goto*//*Label 17317*/ GIMT_Encode4(1189550), // Rule ID 16731 //
     /* 1189475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1189478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1189486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1189489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1189492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1189495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189514 */     // MIs[0] round
     /* 1189514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189524 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1189527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189549 */     // GIR_Coverage, 16731,
     /* 1189549 */     GIR_EraseRootFromParent_Done,
     /* 1189550 */   // Label 17317: @1189550
     /* 1189550 */   GIM_Try, /*On fail goto*//*Label 17318*/ GIMT_Encode4(1189630), // Rule ID 16734 //
     /* 1189555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1189566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1189569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1189572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1189575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189594 */     // MIs[0] round
     /* 1189594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189604 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1189607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189629 */     // GIR_Coverage, 16734,
     /* 1189629 */     GIR_EraseRootFromParent_Done,
     /* 1189630 */   // Label 17318: @1189630
     /* 1189630 */   GIM_Try, /*On fail goto*//*Label 17319*/ GIMT_Encode4(1189710), // Rule ID 16735 //
     /* 1189635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1189646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1189649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1189652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1189655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189674 */     // MIs[0] round
     /* 1189674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189684 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1189687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189709 */     // GIR_Coverage, 16735,
     /* 1189709 */     GIR_EraseRootFromParent_Done,
     /* 1189710 */   // Label 17319: @1189710
     /* 1189710 */   GIM_Try, /*On fail goto*//*Label 17320*/ GIMT_Encode4(1189790), // Rule ID 16738 //
     /* 1189715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1189726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1189729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1189732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1189735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189754 */     // MIs[0] round
     /* 1189754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189764 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1189767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189789 */     // GIR_Coverage, 16738,
     /* 1189789 */     GIR_EraseRootFromParent_Done,
     /* 1189790 */   // Label 17320: @1189790
     /* 1189790 */   GIM_Try, /*On fail goto*//*Label 17321*/ GIMT_Encode4(1189870), // Rule ID 16739 //
     /* 1189795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1189806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1189809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1189812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1189815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189834 */     // MIs[0] round
     /* 1189834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189844 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1189847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189869 */     // GIR_Coverage, 16739,
     /* 1189869 */     GIR_EraseRootFromParent_Done,
     /* 1189870 */   // Label 17321: @1189870
     /* 1189870 */   GIM_Try, /*On fail goto*//*Label 17322*/ GIMT_Encode4(1189950), // Rule ID 16742 //
     /* 1189875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1189886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1189889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1189892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1189895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189914 */     // MIs[0] round
     /* 1189914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189924 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1189927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189949 */     // GIR_Coverage, 16742,
     /* 1189949 */     GIR_EraseRootFromParent_Done,
     /* 1189950 */   // Label 17322: @1189950
     /* 1189950 */   GIM_Try, /*On fail goto*//*Label 17323*/ GIMT_Encode4(1190030), // Rule ID 16743 //
     /* 1189955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1189966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1189969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1189972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1189975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189994 */     // MIs[0] round
     /* 1189994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190004 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1190007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190029 */     // GIR_Coverage, 16743,
     /* 1190029 */     GIR_EraseRootFromParent_Done,
     /* 1190030 */   // Label 17323: @1190030
     /* 1190030 */   GIM_Try, /*On fail goto*//*Label 17324*/ GIMT_Encode4(1190110), // Rule ID 16746 //
     /* 1190035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1190038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1190046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1190049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1190052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1190055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190074 */     // MIs[0] round
     /* 1190074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190084 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1190087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190109 */     // GIR_Coverage, 16746,
     /* 1190109 */     GIR_EraseRootFromParent_Done,
     /* 1190110 */   // Label 17324: @1190110
     /* 1190110 */   GIM_Try, /*On fail goto*//*Label 17325*/ GIMT_Encode4(1190190), // Rule ID 16747 //
     /* 1190115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1190118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1190126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1190129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1190132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1190135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190154 */     // MIs[0] round
     /* 1190154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190164 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1190167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190189 */     // GIR_Coverage, 16747,
     /* 1190189 */     GIR_EraseRootFromParent_Done,
     /* 1190190 */   // Label 17325: @1190190
     /* 1190190 */   GIM_Try, /*On fail goto*//*Label 17326*/ GIMT_Encode4(1190270), // Rule ID 16750 //
     /* 1190195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1190198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1190206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1190209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1190212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1190215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190234 */     // MIs[0] round
     /* 1190234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190244 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1190247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190269 */     // GIR_Coverage, 16750,
     /* 1190269 */     GIR_EraseRootFromParent_Done,
     /* 1190270 */   // Label 17326: @1190270
     /* 1190270 */   GIM_Try, /*On fail goto*//*Label 17327*/ GIMT_Encode4(1190350), // Rule ID 16751 //
     /* 1190275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1190278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1190286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1190289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1190292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1190295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190314 */     // MIs[0] round
     /* 1190314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190324 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1190327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190349 */     // GIR_Coverage, 16751,
     /* 1190349 */     GIR_EraseRootFromParent_Done,
     /* 1190350 */   // Label 17327: @1190350
     /* 1190350 */   GIM_Try, /*On fail goto*//*Label 17328*/ GIMT_Encode4(1190430), // Rule ID 16754 //
     /* 1190355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1190358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1190366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1190369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1190372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1190375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190394 */     // MIs[0] round
     /* 1190394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190404 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1190407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190429 */     // GIR_Coverage, 16754,
     /* 1190429 */     GIR_EraseRootFromParent_Done,
     /* 1190430 */   // Label 17328: @1190430
     /* 1190430 */   GIM_Try, /*On fail goto*//*Label 17329*/ GIMT_Encode4(1190510), // Rule ID 16755 //
     /* 1190435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1190438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1190446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1190449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1190452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1190455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190474 */     // MIs[0] round
     /* 1190474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190484 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1190487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190509 */     // GIR_Coverage, 16755,
     /* 1190509 */     GIR_EraseRootFromParent_Done,
     /* 1190510 */   // Label 17329: @1190510
     /* 1190510 */   GIM_Try, /*On fail goto*//*Label 17330*/ GIMT_Encode4(1190590), // Rule ID 16758 //
     /* 1190515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1190526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1190529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1190532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1190535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190554 */     // MIs[0] round
     /* 1190554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190564 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1190567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190589 */     // GIR_Coverage, 16758,
     /* 1190589 */     GIR_EraseRootFromParent_Done,
     /* 1190590 */   // Label 17330: @1190590
     /* 1190590 */   GIM_Try, /*On fail goto*//*Label 17331*/ GIMT_Encode4(1190670), // Rule ID 16759 //
     /* 1190595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1190606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1190609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1190612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1190615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190634 */     // MIs[0] round
     /* 1190634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190644 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1190647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190669 */     // GIR_Coverage, 16759,
     /* 1190669 */     GIR_EraseRootFromParent_Done,
     /* 1190670 */   // Label 17331: @1190670
     /* 1190670 */   GIM_Try, /*On fail goto*//*Label 17332*/ GIMT_Encode4(1190750), // Rule ID 16762 //
     /* 1190675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1190686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1190689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1190692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1190695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190714 */     // MIs[0] round
     /* 1190714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190724 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1190727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190749 */     // GIR_Coverage, 16762,
     /* 1190749 */     GIR_EraseRootFromParent_Done,
     /* 1190750 */   // Label 17332: @1190750
     /* 1190750 */   GIM_Try, /*On fail goto*//*Label 17333*/ GIMT_Encode4(1190830), // Rule ID 16763 //
     /* 1190755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1190766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1190769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1190772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1190775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190794 */     // MIs[0] round
     /* 1190794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190804 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1190807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190829 */     // GIR_Coverage, 16763,
     /* 1190829 */     GIR_EraseRootFromParent_Done,
     /* 1190830 */   // Label 17333: @1190830
     /* 1190830 */   GIM_Try, /*On fail goto*//*Label 17334*/ GIMT_Encode4(1190910), // Rule ID 16766 //
     /* 1190835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1190846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1190849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1190852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1190855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190874 */     // MIs[0] round
     /* 1190874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190884 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1190887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190909 */     // GIR_Coverage, 16766,
     /* 1190909 */     GIR_EraseRootFromParent_Done,
     /* 1190910 */   // Label 17334: @1190910
     /* 1190910 */   GIM_Try, /*On fail goto*//*Label 17335*/ GIMT_Encode4(1190990), // Rule ID 16767 //
     /* 1190915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1190926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1190929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1190932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1190935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190954 */     // MIs[0] round
     /* 1190954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190964 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1190967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190989 */     // GIR_Coverage, 16767,
     /* 1190989 */     GIR_EraseRootFromParent_Done,
     /* 1190990 */   // Label 17335: @1190990
     /* 1190990 */   GIM_Try, /*On fail goto*//*Label 17336*/ GIMT_Encode4(1191070), // Rule ID 16770 //
     /* 1190995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1190998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1191006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1191009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1191012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191034 */     // MIs[0] round
     /* 1191034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191044 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1191047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191069 */     // GIR_Coverage, 16770,
     /* 1191069 */     GIR_EraseRootFromParent_Done,
     /* 1191070 */   // Label 17336: @1191070
     /* 1191070 */   GIM_Try, /*On fail goto*//*Label 17337*/ GIMT_Encode4(1191150), // Rule ID 16771 //
     /* 1191075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1191086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1191089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1191092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191114 */     // MIs[0] round
     /* 1191114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191124 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1191127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191149 */     // GIR_Coverage, 16771,
     /* 1191149 */     GIR_EraseRootFromParent_Done,
     /* 1191150 */   // Label 17337: @1191150
     /* 1191150 */   GIM_Try, /*On fail goto*//*Label 17338*/ GIMT_Encode4(1191230), // Rule ID 16774 //
     /* 1191155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1191166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1191169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1191172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191194 */     // MIs[0] round
     /* 1191194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191204 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1191207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191229 */     // GIR_Coverage, 16774,
     /* 1191229 */     GIR_EraseRootFromParent_Done,
     /* 1191230 */   // Label 17338: @1191230
     /* 1191230 */   GIM_Try, /*On fail goto*//*Label 17339*/ GIMT_Encode4(1191310), // Rule ID 16775 //
     /* 1191235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1191246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1191249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1191252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191274 */     // MIs[0] round
     /* 1191274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191284 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1191287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191309 */     // GIR_Coverage, 16775,
     /* 1191309 */     GIR_EraseRootFromParent_Done,
     /* 1191310 */   // Label 17339: @1191310
     /* 1191310 */   GIM_Try, /*On fail goto*//*Label 17340*/ GIMT_Encode4(1191390), // Rule ID 16778 //
     /* 1191315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1191318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1191326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1191329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1191332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191354 */     // MIs[0] round
     /* 1191354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191364 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1191367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191389 */     // GIR_Coverage, 16778,
     /* 1191389 */     GIR_EraseRootFromParent_Done,
     /* 1191390 */   // Label 17340: @1191390
     /* 1191390 */   GIM_Try, /*On fail goto*//*Label 17341*/ GIMT_Encode4(1191470), // Rule ID 16779 //
     /* 1191395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1191398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1191406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1191409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1191412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191434 */     // MIs[0] round
     /* 1191434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191444 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1191447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191469 */     // GIR_Coverage, 16779,
     /* 1191469 */     GIR_EraseRootFromParent_Done,
     /* 1191470 */   // Label 17341: @1191470
     /* 1191470 */   GIM_Try, /*On fail goto*//*Label 17342*/ GIMT_Encode4(1191550), // Rule ID 16782 //
     /* 1191475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1191486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1191489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1191492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191514 */     // MIs[0] round
     /* 1191514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191524 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1191527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191549 */     // GIR_Coverage, 16782,
     /* 1191549 */     GIR_EraseRootFromParent_Done,
     /* 1191550 */   // Label 17342: @1191550
     /* 1191550 */   GIM_Try, /*On fail goto*//*Label 17343*/ GIMT_Encode4(1191630), // Rule ID 16783 //
     /* 1191555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1191566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1191569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1191572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191594 */     // MIs[0] round
     /* 1191594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191604 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1191607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191629 */     // GIR_Coverage, 16783,
     /* 1191629 */     GIR_EraseRootFromParent_Done,
     /* 1191630 */   // Label 17343: @1191630
     /* 1191630 */   GIM_Try, /*On fail goto*//*Label 17344*/ GIMT_Encode4(1191710), // Rule ID 16786 //
     /* 1191635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1191638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1191646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1191649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1191652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191674 */     // MIs[0] round
     /* 1191674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191684 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1191687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191709 */     // GIR_Coverage, 16786,
     /* 1191709 */     GIR_EraseRootFromParent_Done,
     /* 1191710 */   // Label 17344: @1191710
     /* 1191710 */   GIM_Try, /*On fail goto*//*Label 17345*/ GIMT_Encode4(1191790), // Rule ID 16787 //
     /* 1191715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1191718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1191726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1191729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1191732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191754 */     // MIs[0] round
     /* 1191754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191764 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1191767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191789 */     // GIR_Coverage, 16787,
     /* 1191789 */     GIR_EraseRootFromParent_Done,
     /* 1191790 */   // Label 17345: @1191790
     /* 1191790 */   GIM_Try, /*On fail goto*//*Label 17346*/ GIMT_Encode4(1191870), // Rule ID 16790 //
     /* 1191795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1191798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1191806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1191809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1191834 */     // MIs[0] round
     /* 1191834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191844 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1191847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1191865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191869 */     // GIR_Coverage, 16790,
     /* 1191869 */     GIR_EraseRootFromParent_Done,
     /* 1191870 */   // Label 17346: @1191870
     /* 1191870 */   GIM_Try, /*On fail goto*//*Label 17347*/ GIMT_Encode4(1191950), // Rule ID 16791 //
     /* 1191875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1191878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1191886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1191889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1191914 */     // MIs[0] round
     /* 1191914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191924 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1191927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1191945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191949 */     // GIR_Coverage, 16791,
     /* 1191949 */     GIR_EraseRootFromParent_Done,
     /* 1191950 */   // Label 17347: @1191950
     /* 1191950 */   GIM_Try, /*On fail goto*//*Label 17348*/ GIMT_Encode4(1192030), // Rule ID 16794 //
     /* 1191955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1191966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1191969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1191972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191994 */     // MIs[0] round
     /* 1191994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192004 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1192007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192029 */     // GIR_Coverage, 16794,
     /* 1192029 */     GIR_EraseRootFromParent_Done,
     /* 1192030 */   // Label 17348: @1192030
     /* 1192030 */   GIM_Try, /*On fail goto*//*Label 17349*/ GIMT_Encode4(1192110), // Rule ID 16795 //
     /* 1192035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1192038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1192046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1192049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1192052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1192055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1192074 */     // MIs[0] round
     /* 1192074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192084 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1192087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192109 */     // GIR_Coverage, 16795,
     /* 1192109 */     GIR_EraseRootFromParent_Done,
     /* 1192110 */   // Label 17349: @1192110
     /* 1192110 */   GIM_Try, /*On fail goto*//*Label 17350*/ GIMT_Encode4(1192190), // Rule ID 16798 //
     /* 1192115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1192118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1192126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1192129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1192132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1192135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1192154 */     // MIs[0] round
     /* 1192154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192164 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1192167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192189 */     // GIR_Coverage, 16798,
     /* 1192189 */     GIR_EraseRootFromParent_Done,
     /* 1192190 */   // Label 17350: @1192190
     /* 1192190 */   GIM_Try, /*On fail goto*//*Label 17351*/ GIMT_Encode4(1192270), // Rule ID 16799 //
     /* 1192195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1192198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1192206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1192209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1192212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1192215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1192234 */     // MIs[0] round
     /* 1192234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192244 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1192247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192269 */     // GIR_Coverage, 16799,
     /* 1192269 */     GIR_EraseRootFromParent_Done,
     /* 1192270 */   // Label 17351: @1192270
     /* 1192270 */   GIM_Try, /*On fail goto*//*Label 17352*/ GIMT_Encode4(1192350), // Rule ID 16802 //
     /* 1192275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1192278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1192286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1192289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1192292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1192295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1192314 */     // MIs[0] round
     /* 1192314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192324 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1192327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192349 */     // GIR_Coverage, 16802,
     /* 1192349 */     GIR_EraseRootFromParent_Done,
     /* 1192350 */   // Label 17352: @1192350
     /* 1192350 */   GIM_Try, /*On fail goto*//*Label 17353*/ GIMT_Encode4(1192430), // Rule ID 16803 //
     /* 1192355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1192358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1192366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1192369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1192372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1192375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1192394 */     // MIs[0] round
     /* 1192394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192404 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1192407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192429 */     // GIR_Coverage, 16803,
     /* 1192429 */     GIR_EraseRootFromParent_Done,
     /* 1192430 */   // Label 17353: @1192430
     /* 1192430 */   GIM_Try, /*On fail goto*//*Label 17354*/ GIMT_Encode4(1192510), // Rule ID 16806 //
     /* 1192435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1192446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1192449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1192452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192474 */     // MIs[0] round
     /* 1192474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192484 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1192487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192509 */     // GIR_Coverage, 16806,
     /* 1192509 */     GIR_EraseRootFromParent_Done,
     /* 1192510 */   // Label 17354: @1192510
     /* 1192510 */   GIM_Try, /*On fail goto*//*Label 17355*/ GIMT_Encode4(1192590), // Rule ID 16807 //
     /* 1192515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1192526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1192529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1192532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192554 */     // MIs[0] round
     /* 1192554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192564 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1192567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192589 */     // GIR_Coverage, 16807,
     /* 1192589 */     GIR_EraseRootFromParent_Done,
     /* 1192590 */   // Label 17355: @1192590
     /* 1192590 */   GIM_Try, /*On fail goto*//*Label 17356*/ GIMT_Encode4(1192670), // Rule ID 16810 //
     /* 1192595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1192606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1192609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1192612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192634 */     // MIs[0] round
     /* 1192634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192644 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1192647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192669 */     // GIR_Coverage, 16810,
     /* 1192669 */     GIR_EraseRootFromParent_Done,
     /* 1192670 */   // Label 17356: @1192670
     /* 1192670 */   GIM_Try, /*On fail goto*//*Label 17357*/ GIMT_Encode4(1192750), // Rule ID 16811 //
     /* 1192675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1192686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1192689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1192692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192714 */     // MIs[0] round
     /* 1192714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192724 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1192727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192749 */     // GIR_Coverage, 16811,
     /* 1192749 */     GIR_EraseRootFromParent_Done,
     /* 1192750 */   // Label 17357: @1192750
     /* 1192750 */   GIM_Try, /*On fail goto*//*Label 17358*/ GIMT_Encode4(1192830), // Rule ID 16814 //
     /* 1192755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1192766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1192769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192794 */     // MIs[0] round
     /* 1192794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192804 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1192807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192829 */     // GIR_Coverage, 16814,
     /* 1192829 */     GIR_EraseRootFromParent_Done,
     /* 1192830 */   // Label 17358: @1192830
     /* 1192830 */   GIM_Try, /*On fail goto*//*Label 17359*/ GIMT_Encode4(1192910), // Rule ID 16815 //
     /* 1192835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1192846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1192849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192874 */     // MIs[0] round
     /* 1192874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192884 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1192887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192909 */     // GIR_Coverage, 16815,
     /* 1192909 */     GIR_EraseRootFromParent_Done,
     /* 1192910 */   // Label 17359: @1192910
     /* 1192910 */   GIM_Try, /*On fail goto*//*Label 17360*/ GIMT_Encode4(1192990), // Rule ID 16818 //
     /* 1192915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1192926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1192929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1192932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192954 */     // MIs[0] round
     /* 1192954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192964 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1192967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192989 */     // GIR_Coverage, 16818,
     /* 1192989 */     GIR_EraseRootFromParent_Done,
     /* 1192990 */   // Label 17360: @1192990
     /* 1192990 */   GIM_Try, /*On fail goto*//*Label 17361*/ GIMT_Encode4(1193070), // Rule ID 16819 //
     /* 1192995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1193006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1193009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1193012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193034 */     // MIs[0] round
     /* 1193034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193044 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1193047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193069 */     // GIR_Coverage, 16819,
     /* 1193069 */     GIR_EraseRootFromParent_Done,
     /* 1193070 */   // Label 17361: @1193070
     /* 1193070 */   GIM_Try, /*On fail goto*//*Label 17362*/ GIMT_Encode4(1193150), // Rule ID 16822 //
     /* 1193075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1193078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1193086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1193089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1193092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193114 */     // MIs[0] round
     /* 1193114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193124 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1193127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193149 */     // GIR_Coverage, 16822,
     /* 1193149 */     GIR_EraseRootFromParent_Done,
     /* 1193150 */   // Label 17362: @1193150
     /* 1193150 */   GIM_Try, /*On fail goto*//*Label 17363*/ GIMT_Encode4(1193230), // Rule ID 16823 //
     /* 1193155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1193158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1193166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1193169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1193172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193194 */     // MIs[0] round
     /* 1193194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193204 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1193207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193229 */     // GIR_Coverage, 16823,
     /* 1193229 */     GIR_EraseRootFromParent_Done,
     /* 1193230 */   // Label 17363: @1193230
     /* 1193230 */   GIM_Try, /*On fail goto*//*Label 17364*/ GIMT_Encode4(1193310), // Rule ID 16826 //
     /* 1193235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1193238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1193246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1193249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1193252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193274 */     // MIs[0] round
     /* 1193274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193284 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1193287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193309 */     // GIR_Coverage, 16826,
     /* 1193309 */     GIR_EraseRootFromParent_Done,
     /* 1193310 */   // Label 17364: @1193310
     /* 1193310 */   GIM_Try, /*On fail goto*//*Label 17365*/ GIMT_Encode4(1193390), // Rule ID 16827 //
     /* 1193315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1193318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1193326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1193329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1193332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193354 */     // MIs[0] round
     /* 1193354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193364 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1193367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193389 */     // GIR_Coverage, 16827,
     /* 1193389 */     GIR_EraseRootFromParent_Done,
     /* 1193390 */   // Label 17365: @1193390
     /* 1193390 */   GIM_Try, /*On fail goto*//*Label 17366*/ GIMT_Encode4(1193470), // Rule ID 16830 //
     /* 1193395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1193406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1193409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1193412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1193415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193434 */     // MIs[0] round
     /* 1193434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193444 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1193447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193469 */     // GIR_Coverage, 16830,
     /* 1193469 */     GIR_EraseRootFromParent_Done,
     /* 1193470 */   // Label 17366: @1193470
     /* 1193470 */   GIM_Try, /*On fail goto*//*Label 17367*/ GIMT_Encode4(1193550), // Rule ID 16831 //
     /* 1193475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1193486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1193489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1193492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1193495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193514 */     // MIs[0] round
     /* 1193514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193524 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1193527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193549 */     // GIR_Coverage, 16831,
     /* 1193549 */     GIR_EraseRootFromParent_Done,
     /* 1193550 */   // Label 17367: @1193550
     /* 1193550 */   GIM_Try, /*On fail goto*//*Label 17368*/ GIMT_Encode4(1193630), // Rule ID 16834 //
     /* 1193555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1193566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1193569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1193572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1193575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193594 */     // MIs[0] round
     /* 1193594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193604 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1193607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193629 */     // GIR_Coverage, 16834,
     /* 1193629 */     GIR_EraseRootFromParent_Done,
     /* 1193630 */   // Label 17368: @1193630
     /* 1193630 */   GIM_Try, /*On fail goto*//*Label 17369*/ GIMT_Encode4(1193710), // Rule ID 16835 //
     /* 1193635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1193646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1193649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1193652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1193655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193674 */     // MIs[0] round
     /* 1193674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193684 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1193687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193709 */     // GIR_Coverage, 16835,
     /* 1193709 */     GIR_EraseRootFromParent_Done,
     /* 1193710 */   // Label 17369: @1193710
     /* 1193710 */   GIM_Try, /*On fail goto*//*Label 17370*/ GIMT_Encode4(1193790), // Rule ID 16838 //
     /* 1193715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1193718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1193726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1193729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1193735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193754 */     // MIs[0] round
     /* 1193754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193764 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1193767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193789 */     // GIR_Coverage, 16838,
     /* 1193789 */     GIR_EraseRootFromParent_Done,
     /* 1193790 */   // Label 17370: @1193790
     /* 1193790 */   GIM_Try, /*On fail goto*//*Label 17371*/ GIMT_Encode4(1193870), // Rule ID 16839 //
     /* 1193795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1193806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1193809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1193815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193834 */     // MIs[0] round
     /* 1193834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193844 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1193847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193869 */     // GIR_Coverage, 16839,
     /* 1193869 */     GIR_EraseRootFromParent_Done,
     /* 1193870 */   // Label 17371: @1193870
     /* 1193870 */   GIM_Try, /*On fail goto*//*Label 17372*/ GIMT_Encode4(1193950), // Rule ID 16842 //
     /* 1193875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1193886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1193889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1193892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1193895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193914 */     // MIs[0] round
     /* 1193914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193924 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1193927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193949 */     // GIR_Coverage, 16842,
     /* 1193949 */     GIR_EraseRootFromParent_Done,
     /* 1193950 */   // Label 17372: @1193950
     /* 1193950 */   GIM_Try, /*On fail goto*//*Label 17373*/ GIMT_Encode4(1194030), // Rule ID 16843 //
     /* 1193955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1193966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1193969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1193972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1193975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193994 */     // MIs[0] round
     /* 1193994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194004 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1194007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194029 */     // GIR_Coverage, 16843,
     /* 1194029 */     GIR_EraseRootFromParent_Done,
     /* 1194030 */   // Label 17373: @1194030
     /* 1194030 */   GIM_Try, /*On fail goto*//*Label 17374*/ GIMT_Encode4(1194110), // Rule ID 16846 //
     /* 1194035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1194046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1194049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1194052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1194055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194074 */     // MIs[0] round
     /* 1194074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194084 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1194087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194109 */     // GIR_Coverage, 16846,
     /* 1194109 */     GIR_EraseRootFromParent_Done,
     /* 1194110 */   // Label 17374: @1194110
     /* 1194110 */   GIM_Try, /*On fail goto*//*Label 17375*/ GIMT_Encode4(1194190), // Rule ID 16847 //
     /* 1194115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1194126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1194129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1194132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1194135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194154 */     // MIs[0] round
     /* 1194154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194164 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1194167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194189 */     // GIR_Coverage, 16847,
     /* 1194189 */     GIR_EraseRootFromParent_Done,
     /* 1194190 */   // Label 17375: @1194190
     /* 1194190 */   GIM_Try, /*On fail goto*//*Label 17376*/ GIMT_Encode4(1194270), // Rule ID 16850 //
     /* 1194195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1194198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1194206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1194209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1194212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1194215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194234 */     // MIs[0] round
     /* 1194234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194244 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1194247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194269 */     // GIR_Coverage, 16850,
     /* 1194269 */     GIR_EraseRootFromParent_Done,
     /* 1194270 */   // Label 17376: @1194270
     /* 1194270 */   GIM_Try, /*On fail goto*//*Label 17377*/ GIMT_Encode4(1194350), // Rule ID 16851 //
     /* 1194275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1194278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1194286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1194289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1194292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1194295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194314 */     // MIs[0] round
     /* 1194314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194324 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1194327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194349 */     // GIR_Coverage, 16851,
     /* 1194349 */     GIR_EraseRootFromParent_Done,
     /* 1194350 */   // Label 17377: @1194350
     /* 1194350 */   GIM_Try, /*On fail goto*//*Label 17378*/ GIMT_Encode4(1194430), // Rule ID 16854 //
     /* 1194355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1194366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1194369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1194372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1194375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194394 */     // MIs[0] round
     /* 1194394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194404 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1194407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194429 */     // GIR_Coverage, 16854,
     /* 1194429 */     GIR_EraseRootFromParent_Done,
     /* 1194430 */   // Label 17378: @1194430
     /* 1194430 */   GIM_Try, /*On fail goto*//*Label 17379*/ GIMT_Encode4(1194510), // Rule ID 16855 //
     /* 1194435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1194446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1194449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1194452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1194455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194474 */     // MIs[0] round
     /* 1194474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194484 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1194487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194509 */     // GIR_Coverage, 16855,
     /* 1194509 */     GIR_EraseRootFromParent_Done,
     /* 1194510 */   // Label 17379: @1194510
     /* 1194510 */   GIM_Try, /*On fail goto*//*Label 17380*/ GIMT_Encode4(1194590), // Rule ID 16858 //
     /* 1194515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1194526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1194529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1194532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1194535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194554 */     // MIs[0] round
     /* 1194554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194564 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1194567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194589 */     // GIR_Coverage, 16858,
     /* 1194589 */     GIR_EraseRootFromParent_Done,
     /* 1194590 */   // Label 17380: @1194590
     /* 1194590 */   GIM_Try, /*On fail goto*//*Label 17381*/ GIMT_Encode4(1194670), // Rule ID 16859 //
     /* 1194595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1194606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1194609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1194612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1194615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194634 */     // MIs[0] round
     /* 1194634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194644 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1194647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194669 */     // GIR_Coverage, 16859,
     /* 1194669 */     GIR_EraseRootFromParent_Done,
     /* 1194670 */   // Label 17381: @1194670
     /* 1194670 */   GIM_Try, /*On fail goto*//*Label 17382*/ GIMT_Encode4(1194750), // Rule ID 16862 //
     /* 1194675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1194686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1194689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1194692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1194695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194714 */     // MIs[0] round
     /* 1194714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194724 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1194727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194749 */     // GIR_Coverage, 16862,
     /* 1194749 */     GIR_EraseRootFromParent_Done,
     /* 1194750 */   // Label 17382: @1194750
     /* 1194750 */   GIM_Try, /*On fail goto*//*Label 17383*/ GIMT_Encode4(1194830), // Rule ID 16863 //
     /* 1194755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1194766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1194769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1194772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1194775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194794 */     // MIs[0] round
     /* 1194794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194804 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1194807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194829 */     // GIR_Coverage, 16863,
     /* 1194829 */     GIR_EraseRootFromParent_Done,
     /* 1194830 */   // Label 17383: @1194830
     /* 1194830 */   GIM_Try, /*On fail goto*//*Label 17384*/ GIMT_Encode4(1194910), // Rule ID 16866 //
     /* 1194835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1194846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1194849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1194852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1194855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194874 */     // MIs[0] round
     /* 1194874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194884 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1194887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194909 */     // GIR_Coverage, 16866,
     /* 1194909 */     GIR_EraseRootFromParent_Done,
     /* 1194910 */   // Label 17384: @1194910
     /* 1194910 */   GIM_Try, /*On fail goto*//*Label 17385*/ GIMT_Encode4(1194990), // Rule ID 16867 //
     /* 1194915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1194926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1194929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1194932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1194935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194954 */     // MIs[0] round
     /* 1194954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194964 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1194967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194989 */     // GIR_Coverage, 16867,
     /* 1194989 */     GIR_EraseRootFromParent_Done,
     /* 1194990 */   // Label 17385: @1194990
     /* 1194990 */   GIM_Try, /*On fail goto*//*Label 17386*/ GIMT_Encode4(1195070), // Rule ID 16870 //
     /* 1194995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1195006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1195009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1195012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1195015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195034 */     // MIs[0] round
     /* 1195034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195044 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1195047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195069 */     // GIR_Coverage, 16870,
     /* 1195069 */     GIR_EraseRootFromParent_Done,
     /* 1195070 */   // Label 17386: @1195070
     /* 1195070 */   GIM_Try, /*On fail goto*//*Label 17387*/ GIMT_Encode4(1195150), // Rule ID 16871 //
     /* 1195075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1195078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1195086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1195089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1195092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1195095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195114 */     // MIs[0] round
     /* 1195114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195124 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1195127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195149 */     // GIR_Coverage, 16871,
     /* 1195149 */     GIR_EraseRootFromParent_Done,
     /* 1195150 */   // Label 17387: @1195150
     /* 1195150 */   GIM_Try, /*On fail goto*//*Label 17388*/ GIMT_Encode4(1195230), // Rule ID 16874 //
     /* 1195155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1195158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1195166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1195169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1195172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1195175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195194 */     // MIs[0] round
     /* 1195194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195204 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1195207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195229 */     // GIR_Coverage, 16874,
     /* 1195229 */     GIR_EraseRootFromParent_Done,
     /* 1195230 */   // Label 17388: @1195230
     /* 1195230 */   GIM_Try, /*On fail goto*//*Label 17389*/ GIMT_Encode4(1195310), // Rule ID 16875 //
     /* 1195235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1195238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1195246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1195249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1195252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1195255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195274 */     // MIs[0] round
     /* 1195274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195284 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1195287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195309 */     // GIR_Coverage, 16875,
     /* 1195309 */     GIR_EraseRootFromParent_Done,
     /* 1195310 */   // Label 17389: @1195310
     /* 1195310 */   GIM_Try, /*On fail goto*//*Label 17390*/ GIMT_Encode4(1195390), // Rule ID 16878 //
     /* 1195315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1195326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1195329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1195332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1195335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195354 */     // MIs[0] round
     /* 1195354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195364 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1195367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195389 */     // GIR_Coverage, 16878,
     /* 1195389 */     GIR_EraseRootFromParent_Done,
     /* 1195390 */   // Label 17390: @1195390
     /* 1195390 */   GIM_Try, /*On fail goto*//*Label 17391*/ GIMT_Encode4(1195470), // Rule ID 16879 //
     /* 1195395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1195406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1195409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1195412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1195415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195434 */     // MIs[0] round
     /* 1195434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195444 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1195447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195469 */     // GIR_Coverage, 16879,
     /* 1195469 */     GIR_EraseRootFromParent_Done,
     /* 1195470 */   // Label 17391: @1195470
     /* 1195470 */   GIM_Try, /*On fail goto*//*Label 17392*/ GIMT_Encode4(1195550), // Rule ID 16882 //
     /* 1195475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1195486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1195489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1195492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1195495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195514 */     // MIs[0] round
     /* 1195514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195524 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1195527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195549 */     // GIR_Coverage, 16882,
     /* 1195549 */     GIR_EraseRootFromParent_Done,
     /* 1195550 */   // Label 17392: @1195550
     /* 1195550 */   GIM_Try, /*On fail goto*//*Label 17393*/ GIMT_Encode4(1195630), // Rule ID 16883 //
     /* 1195555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1195566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1195569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1195572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1195575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195594 */     // MIs[0] round
     /* 1195594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195604 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1195607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195629 */     // GIR_Coverage, 16883,
     /* 1195629 */     GIR_EraseRootFromParent_Done,
     /* 1195630 */   // Label 17393: @1195630
     /* 1195630 */   GIM_Try, /*On fail goto*//*Label 17394*/ GIMT_Encode4(1195710), // Rule ID 16886 //
     /* 1195635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1195646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1195649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1195652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1195655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195674 */     // MIs[0] round
     /* 1195674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195684 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1195687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195709 */     // GIR_Coverage, 16886,
     /* 1195709 */     GIR_EraseRootFromParent_Done,
     /* 1195710 */   // Label 17394: @1195710
     /* 1195710 */   GIM_Try, /*On fail goto*//*Label 17395*/ GIMT_Encode4(1195790), // Rule ID 16887 //
     /* 1195715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1195726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1195729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1195732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1195735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195754 */     // MIs[0] round
     /* 1195754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195764 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1195767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195789 */     // GIR_Coverage, 16887,
     /* 1195789 */     GIR_EraseRootFromParent_Done,
     /* 1195790 */   // Label 17395: @1195790
     /* 1195790 */   GIM_Try, /*On fail goto*//*Label 17396*/ GIMT_Encode4(1195870), // Rule ID 16890 //
     /* 1195795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1195806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1195809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1195812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195834 */     // MIs[0] round
     /* 1195834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195844 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1195847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195869 */     // GIR_Coverage, 16890,
     /* 1195869 */     GIR_EraseRootFromParent_Done,
     /* 1195870 */   // Label 17396: @1195870
     /* 1195870 */   GIM_Try, /*On fail goto*//*Label 17397*/ GIMT_Encode4(1195950), // Rule ID 16891 //
     /* 1195875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1195886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1195889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1195892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195914 */     // MIs[0] round
     /* 1195914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195924 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1195927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195949 */     // GIR_Coverage, 16891,
     /* 1195949 */     GIR_EraseRootFromParent_Done,
     /* 1195950 */   // Label 17397: @1195950
     /* 1195950 */   GIM_Try, /*On fail goto*//*Label 17398*/ GIMT_Encode4(1196030), // Rule ID 16894 //
     /* 1195955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1195966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1195969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1195972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195994 */     // MIs[0] round
     /* 1195994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196004 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1196007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196029 */     // GIR_Coverage, 16894,
     /* 1196029 */     GIR_EraseRootFromParent_Done,
     /* 1196030 */   // Label 17398: @1196030
     /* 1196030 */   GIM_Try, /*On fail goto*//*Label 17399*/ GIMT_Encode4(1196110), // Rule ID 16895 //
     /* 1196035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1196046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1196049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1196052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196074 */     // MIs[0] round
     /* 1196074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196084 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1196087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196109 */     // GIR_Coverage, 16895,
     /* 1196109 */     GIR_EraseRootFromParent_Done,
     /* 1196110 */   // Label 17399: @1196110
     /* 1196110 */   GIM_Try, /*On fail goto*//*Label 17400*/ GIMT_Encode4(1196190), // Rule ID 16898 //
     /* 1196115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1196118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1196126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1196129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1196132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196154 */     // MIs[0] round
     /* 1196154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196164 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1196167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196189 */     // GIR_Coverage, 16898,
     /* 1196189 */     GIR_EraseRootFromParent_Done,
     /* 1196190 */   // Label 17400: @1196190
     /* 1196190 */   GIM_Try, /*On fail goto*//*Label 17401*/ GIMT_Encode4(1196270), // Rule ID 16899 //
     /* 1196195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1196206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1196209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1196212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196234 */     // MIs[0] round
     /* 1196234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196244 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1196247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196269 */     // GIR_Coverage, 16899,
     /* 1196269 */     GIR_EraseRootFromParent_Done,
     /* 1196270 */   // Label 17401: @1196270
     /* 1196270 */   GIM_Try, /*On fail goto*//*Label 17402*/ GIMT_Encode4(1196350), // Rule ID 16902 //
     /* 1196275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1196286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1196289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1196292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196314 */     // MIs[0] round
     /* 1196314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196324 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1196327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196349 */     // GIR_Coverage, 16902,
     /* 1196349 */     GIR_EraseRootFromParent_Done,
     /* 1196350 */   // Label 17402: @1196350
     /* 1196350 */   GIM_Try, /*On fail goto*//*Label 17403*/ GIMT_Encode4(1196430), // Rule ID 16903 //
     /* 1196355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1196366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1196369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1196372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196394 */     // MIs[0] round
     /* 1196394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196404 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1196407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196429 */     // GIR_Coverage, 16903,
     /* 1196429 */     GIR_EraseRootFromParent_Done,
     /* 1196430 */   // Label 17403: @1196430
     /* 1196430 */   GIM_Try, /*On fail goto*//*Label 17404*/ GIMT_Encode4(1196510), // Rule ID 16906 //
     /* 1196435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1196438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1196446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1196449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1196452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196474 */     // MIs[0] round
     /* 1196474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196484 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1196487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196509 */     // GIR_Coverage, 16906,
     /* 1196509 */     GIR_EraseRootFromParent_Done,
     /* 1196510 */   // Label 17404: @1196510
     /* 1196510 */   GIM_Try, /*On fail goto*//*Label 17405*/ GIMT_Encode4(1196590), // Rule ID 16907 //
     /* 1196515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1196526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1196529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1196532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196554 */     // MIs[0] round
     /* 1196554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196564 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1196567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196589 */     // GIR_Coverage, 16907,
     /* 1196589 */     GIR_EraseRootFromParent_Done,
     /* 1196590 */   // Label 17405: @1196590
     /* 1196590 */   GIM_Try, /*On fail goto*//*Label 17406*/ GIMT_Encode4(1196670), // Rule ID 16910 //
     /* 1196595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1196598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1196606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1196609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1196612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196634 */     // MIs[0] round
     /* 1196634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196644 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1196647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196669 */     // GIR_Coverage, 16910,
     /* 1196669 */     GIR_EraseRootFromParent_Done,
     /* 1196670 */   // Label 17406: @1196670
     /* 1196670 */   GIM_Try, /*On fail goto*//*Label 17407*/ GIMT_Encode4(1196750), // Rule ID 16911 //
     /* 1196675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1196678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1196686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1196689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1196692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196714 */     // MIs[0] round
     /* 1196714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196724 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1196727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196749 */     // GIR_Coverage, 16911,
     /* 1196749 */     GIR_EraseRootFromParent_Done,
     /* 1196750 */   // Label 17407: @1196750
     /* 1196750 */   GIM_Try, /*On fail goto*//*Label 17408*/ GIMT_Encode4(1196830), // Rule ID 16914 //
     /* 1196755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1196766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1196769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1196772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196794 */     // MIs[0] round
     /* 1196794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196804 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1196807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196829 */     // GIR_Coverage, 16914,
     /* 1196829 */     GIR_EraseRootFromParent_Done,
     /* 1196830 */   // Label 17408: @1196830
     /* 1196830 */   GIM_Try, /*On fail goto*//*Label 17409*/ GIMT_Encode4(1196910), // Rule ID 16915 //
     /* 1196835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1196846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1196849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1196852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196874 */     // MIs[0] round
     /* 1196874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196884 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1196887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196909 */     // GIR_Coverage, 16915,
     /* 1196909 */     GIR_EraseRootFromParent_Done,
     /* 1196910 */   // Label 17409: @1196910
     /* 1196910 */   GIM_Try, /*On fail goto*//*Label 17410*/ GIMT_Encode4(1196990), // Rule ID 16918 //
     /* 1196915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1196926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1196929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1196932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196954 */     // MIs[0] round
     /* 1196954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196964 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1196967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196989 */     // GIR_Coverage, 16918,
     /* 1196989 */     GIR_EraseRootFromParent_Done,
     /* 1196990 */   // Label 17410: @1196990
     /* 1196990 */   GIM_Try, /*On fail goto*//*Label 17411*/ GIMT_Encode4(1197070), // Rule ID 16919 //
     /* 1196995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1197006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1197009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1197012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197034 */     // MIs[0] round
     /* 1197034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197044 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1197047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197069 */     // GIR_Coverage, 16919,
     /* 1197069 */     GIR_EraseRootFromParent_Done,
     /* 1197070 */   // Label 17411: @1197070
     /* 1197070 */   GIM_Try, /*On fail goto*//*Label 17412*/ GIMT_Encode4(1197150), // Rule ID 16922 //
     /* 1197075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1197078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1197086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1197089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1197092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197114 */     // MIs[0] round
     /* 1197114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197124 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1197127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197149 */     // GIR_Coverage, 16922,
     /* 1197149 */     GIR_EraseRootFromParent_Done,
     /* 1197150 */   // Label 17412: @1197150
     /* 1197150 */   GIM_Try, /*On fail goto*//*Label 17413*/ GIMT_Encode4(1197230), // Rule ID 16923 //
     /* 1197155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1197166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1197169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1197172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197194 */     // MIs[0] round
     /* 1197194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197204 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1197207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197229 */     // GIR_Coverage, 16923,
     /* 1197229 */     GIR_EraseRootFromParent_Done,
     /* 1197230 */   // Label 17413: @1197230
     /* 1197230 */   GIM_Try, /*On fail goto*//*Label 17414*/ GIMT_Encode4(1197310), // Rule ID 16926 //
     /* 1197235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1197238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1197246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1197249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1197252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197274 */     // MIs[0] round
     /* 1197274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197284 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1197287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197309 */     // GIR_Coverage, 16926,
     /* 1197309 */     GIR_EraseRootFromParent_Done,
     /* 1197310 */   // Label 17414: @1197310
     /* 1197310 */   GIM_Try, /*On fail goto*//*Label 17415*/ GIMT_Encode4(1197390), // Rule ID 16927 //
     /* 1197315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1197326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1197329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1197332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197354 */     // MIs[0] round
     /* 1197354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197364 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1197367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197389 */     // GIR_Coverage, 16927,
     /* 1197389 */     GIR_EraseRootFromParent_Done,
     /* 1197390 */   // Label 17415: @1197390
     /* 1197390 */   GIM_Try, /*On fail goto*//*Label 17416*/ GIMT_Encode4(1197470), // Rule ID 16930 //
     /* 1197395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1197398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1197406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1197409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1197412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197434 */     // MIs[0] round
     /* 1197434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197444 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1197447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197469 */     // GIR_Coverage, 16930,
     /* 1197469 */     GIR_EraseRootFromParent_Done,
     /* 1197470 */   // Label 17416: @1197470
     /* 1197470 */   GIM_Try, /*On fail goto*//*Label 17417*/ GIMT_Encode4(1197550), // Rule ID 16931 //
     /* 1197475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1197486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1197489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1197492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197514 */     // MIs[0] round
     /* 1197514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197524 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1197527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197549 */     // GIR_Coverage, 16931,
     /* 1197549 */     GIR_EraseRootFromParent_Done,
     /* 1197550 */   // Label 17417: @1197550
     /* 1197550 */   GIM_Try, /*On fail goto*//*Label 17418*/ GIMT_Encode4(1197630), // Rule ID 16934 //
     /* 1197555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1197558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1197566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1197569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1197572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197594 */     // MIs[0] round
     /* 1197594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197604 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1197607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197629 */     // GIR_Coverage, 16934,
     /* 1197629 */     GIR_EraseRootFromParent_Done,
     /* 1197630 */   // Label 17418: @1197630
     /* 1197630 */   GIM_Try, /*On fail goto*//*Label 17419*/ GIMT_Encode4(1197710), // Rule ID 16935 //
     /* 1197635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1197646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1197649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1197652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197674 */     // MIs[0] round
     /* 1197674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197684 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1197687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197709 */     // GIR_Coverage, 16935,
     /* 1197709 */     GIR_EraseRootFromParent_Done,
     /* 1197710 */   // Label 17419: @1197710
     /* 1197710 */   GIM_Try, /*On fail goto*//*Label 17420*/ GIMT_Encode4(1197790), // Rule ID 16938 //
     /* 1197715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1197726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1197729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1197732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197754 */     // MIs[0] round
     /* 1197754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197764 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1197767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197789 */     // GIR_Coverage, 16938,
     /* 1197789 */     GIR_EraseRootFromParent_Done,
     /* 1197790 */   // Label 17420: @1197790
     /* 1197790 */   GIM_Try, /*On fail goto*//*Label 17421*/ GIMT_Encode4(1197870), // Rule ID 16939 //
     /* 1197795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1197806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1197809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1197812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197834 */     // MIs[0] round
     /* 1197834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197844 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1197847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197869 */     // GIR_Coverage, 16939,
     /* 1197869 */     GIR_EraseRootFromParent_Done,
     /* 1197870 */   // Label 17421: @1197870
     /* 1197870 */   GIM_Try, /*On fail goto*//*Label 17422*/ GIMT_Encode4(1197950), // Rule ID 16942 //
     /* 1197875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1197886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1197889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1197892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197914 */     // MIs[0] round
     /* 1197914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197924 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1197927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197949 */     // GIR_Coverage, 16942,
     /* 1197949 */     GIR_EraseRootFromParent_Done,
     /* 1197950 */   // Label 17422: @1197950
     /* 1197950 */   GIM_Try, /*On fail goto*//*Label 17423*/ GIMT_Encode4(1198030), // Rule ID 16943 //
     /* 1197955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1197966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1197969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1197972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197994 */     // MIs[0] round
     /* 1197994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198004 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1198007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198029 */     // GIR_Coverage, 16943,
     /* 1198029 */     GIR_EraseRootFromParent_Done,
     /* 1198030 */   // Label 17423: @1198030
     /* 1198030 */   GIM_Try, /*On fail goto*//*Label 17424*/ GIMT_Encode4(1198110), // Rule ID 16946 //
     /* 1198035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1198038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1198046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1198049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1198052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1198074 */     // MIs[0] round
     /* 1198074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198084 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1198087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198109 */     // GIR_Coverage, 16946,
     /* 1198109 */     GIR_EraseRootFromParent_Done,
     /* 1198110 */   // Label 17424: @1198110
     /* 1198110 */   GIM_Try, /*On fail goto*//*Label 17425*/ GIMT_Encode4(1198190), // Rule ID 16947 //
     /* 1198115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1198118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1198126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1198129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1198132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1198154 */     // MIs[0] round
     /* 1198154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198164 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1198167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198189 */     // GIR_Coverage, 16947,
     /* 1198189 */     GIR_EraseRootFromParent_Done,
     /* 1198190 */   // Label 17425: @1198190
     /* 1198190 */   GIM_Try, /*On fail goto*//*Label 17426*/ GIMT_Encode4(1198270), // Rule ID 16950 //
     /* 1198195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1198206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1198209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1198212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198234 */     // MIs[0] round
     /* 1198234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198244 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1198247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198269 */     // GIR_Coverage, 16950,
     /* 1198269 */     GIR_EraseRootFromParent_Done,
     /* 1198270 */   // Label 17426: @1198270
     /* 1198270 */   GIM_Try, /*On fail goto*//*Label 17427*/ GIMT_Encode4(1198350), // Rule ID 16951 //
     /* 1198275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1198286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1198289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1198292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198314 */     // MIs[0] round
     /* 1198314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198324 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1198327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198349 */     // GIR_Coverage, 16951,
     /* 1198349 */     GIR_EraseRootFromParent_Done,
     /* 1198350 */   // Label 17427: @1198350
     /* 1198350 */   GIM_Try, /*On fail goto*//*Label 17428*/ GIMT_Encode4(1198430), // Rule ID 16954 //
     /* 1198355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1198366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1198369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1198372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198394 */     // MIs[0] round
     /* 1198394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198404 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1198407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198429 */     // GIR_Coverage, 16954,
     /* 1198429 */     GIR_EraseRootFromParent_Done,
     /* 1198430 */   // Label 17428: @1198430
     /* 1198430 */   GIM_Try, /*On fail goto*//*Label 17429*/ GIMT_Encode4(1198510), // Rule ID 16955 //
     /* 1198435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1198446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1198449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1198452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198474 */     // MIs[0] round
     /* 1198474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198484 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1198487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198509 */     // GIR_Coverage, 16955,
     /* 1198509 */     GIR_EraseRootFromParent_Done,
     /* 1198510 */   // Label 17429: @1198510
     /* 1198510 */   GIM_Try, /*On fail goto*//*Label 17430*/ GIMT_Encode4(1198590), // Rule ID 16958 //
     /* 1198515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1198526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1198529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1198532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198554 */     // MIs[0] round
     /* 1198554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198564 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1198567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198589 */     // GIR_Coverage, 16958,
     /* 1198589 */     GIR_EraseRootFromParent_Done,
     /* 1198590 */   // Label 17430: @1198590
     /* 1198590 */   GIM_Try, /*On fail goto*//*Label 17431*/ GIMT_Encode4(1198670), // Rule ID 16959 //
     /* 1198595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1198606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1198609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1198612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198634 */     // MIs[0] round
     /* 1198634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198644 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1198647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198669 */     // GIR_Coverage, 16959,
     /* 1198669 */     GIR_EraseRootFromParent_Done,
     /* 1198670 */   // Label 17431: @1198670
     /* 1198670 */   GIM_Try, /*On fail goto*//*Label 17432*/ GIMT_Encode4(1198750), // Rule ID 16962 //
     /* 1198675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1198686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1198689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1198692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198714 */     // MIs[0] round
     /* 1198714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198724 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11318:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1198727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198749 */     // GIR_Coverage, 16962,
     /* 1198749 */     GIR_EraseRootFromParent_Done,
     /* 1198750 */   // Label 17432: @1198750
     /* 1198750 */   GIM_Try, /*On fail goto*//*Label 17433*/ GIMT_Encode4(1198830), // Rule ID 16963 //
     /* 1198755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1198766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1198769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1198772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198794 */     // MIs[0] round
     /* 1198794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198804 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11318:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1198807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198829 */     // GIR_Coverage, 16963,
     /* 1198829 */     GIR_EraseRootFromParent_Done,
     /* 1198830 */   // Label 17433: @1198830
     /* 1198830 */   GIM_Try, /*On fail goto*//*Label 17434*/ GIMT_Encode4(1198910), // Rule ID 16966 //
     /* 1198835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1198846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1198849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1198852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198874 */     // MIs[0] round
     /* 1198874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198884 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1198887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198909 */     // GIR_Coverage, 16966,
     /* 1198909 */     GIR_EraseRootFromParent_Done,
     /* 1198910 */   // Label 17434: @1198910
     /* 1198910 */   GIM_Try, /*On fail goto*//*Label 17435*/ GIMT_Encode4(1198990), // Rule ID 16967 //
     /* 1198915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1198926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1198929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1198932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198954 */     // MIs[0] round
     /* 1198954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198964 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1198967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198989 */     // GIR_Coverage, 16967,
     /* 1198989 */     GIR_EraseRootFromParent_Done,
     /* 1198990 */   // Label 17435: @1198990
     /* 1198990 */   GIM_Try, /*On fail goto*//*Label 17436*/ GIMT_Encode4(1199070), // Rule ID 16970 //
     /* 1198995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1198998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1199006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1199009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1199012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199034 */     // MIs[0] round
     /* 1199034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199044 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1199047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199069 */     // GIR_Coverage, 16970,
     /* 1199069 */     GIR_EraseRootFromParent_Done,
     /* 1199070 */   // Label 17436: @1199070
     /* 1199070 */   GIM_Try, /*On fail goto*//*Label 17437*/ GIMT_Encode4(1199150), // Rule ID 16971 //
     /* 1199075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1199078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1199086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1199089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1199092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199114 */     // MIs[0] round
     /* 1199114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199124 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1199127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199149 */     // GIR_Coverage, 16971,
     /* 1199149 */     GIR_EraseRootFromParent_Done,
     /* 1199150 */   // Label 17437: @1199150
     /* 1199150 */   GIM_Try, /*On fail goto*//*Label 17438*/ GIMT_Encode4(1199230), // Rule ID 16974 //
     /* 1199155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1199158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1199166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1199169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1199172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199194 */     // MIs[0] round
     /* 1199194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199204 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1199207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199229 */     // GIR_Coverage, 16974,
     /* 1199229 */     GIR_EraseRootFromParent_Done,
     /* 1199230 */   // Label 17438: @1199230
     /* 1199230 */   GIM_Try, /*On fail goto*//*Label 17439*/ GIMT_Encode4(1199310), // Rule ID 16975 //
     /* 1199235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1199238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1199246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1199249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1199252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199274 */     // MIs[0] round
     /* 1199274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199284 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1199287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199309 */     // GIR_Coverage, 16975,
     /* 1199309 */     GIR_EraseRootFromParent_Done,
     /* 1199310 */   // Label 17439: @1199310
     /* 1199310 */   GIM_Try, /*On fail goto*//*Label 17440*/ GIMT_Encode4(1199390), // Rule ID 16978 //
     /* 1199315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1199318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1199326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1199329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1199332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199354 */     // MIs[0] round
     /* 1199354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199364 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1199367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199389 */     // GIR_Coverage, 16978,
     /* 1199389 */     GIR_EraseRootFromParent_Done,
     /* 1199390 */   // Label 17440: @1199390
     /* 1199390 */   GIM_Try, /*On fail goto*//*Label 17441*/ GIMT_Encode4(1199470), // Rule ID 16979 //
     /* 1199395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1199398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1199406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1199409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1199412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199434 */     // MIs[0] round
     /* 1199434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199444 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1199447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199469 */     // GIR_Coverage, 16979,
     /* 1199469 */     GIR_EraseRootFromParent_Done,
     /* 1199470 */   // Label 17441: @1199470
     /* 1199470 */   GIM_Try, /*On fail goto*//*Label 17442*/ GIMT_Encode4(1199550), // Rule ID 16982 //
     /* 1199475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1199478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1199486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1199489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1199492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199514 */     // MIs[0] round
     /* 1199514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199524 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1199527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199549 */     // GIR_Coverage, 16982,
     /* 1199549 */     GIR_EraseRootFromParent_Done,
     /* 1199550 */   // Label 17442: @1199550
     /* 1199550 */   GIM_Try, /*On fail goto*//*Label 17443*/ GIMT_Encode4(1199630), // Rule ID 16983 //
     /* 1199555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1199558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1199566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1199569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1199572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199594 */     // MIs[0] round
     /* 1199594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199604 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1199607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199629 */     // GIR_Coverage, 16983,
     /* 1199629 */     GIR_EraseRootFromParent_Done,
     /* 1199630 */   // Label 17443: @1199630
     /* 1199630 */   GIM_Try, /*On fail goto*//*Label 17444*/ GIMT_Encode4(1199710), // Rule ID 16986 //
     /* 1199635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1199646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1199649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1199652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199674 */     // MIs[0] round
     /* 1199674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199684 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1199687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199709 */     // GIR_Coverage, 16986,
     /* 1199709 */     GIR_EraseRootFromParent_Done,
     /* 1199710 */   // Label 17444: @1199710
     /* 1199710 */   GIM_Try, /*On fail goto*//*Label 17445*/ GIMT_Encode4(1199790), // Rule ID 16987 //
     /* 1199715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1199726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1199729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1199732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199754 */     // MIs[0] round
     /* 1199754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199764 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1199767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199789 */     // GIR_Coverage, 16987,
     /* 1199789 */     GIR_EraseRootFromParent_Done,
     /* 1199790 */   // Label 17445: @1199790
     /* 1199790 */   GIM_Try, /*On fail goto*//*Label 17446*/ GIMT_Encode4(1199870), // Rule ID 16990 //
     /* 1199795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1199806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1199809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199834 */     // MIs[0] round
     /* 1199834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199844 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1199847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199869 */     // GIR_Coverage, 16990,
     /* 1199869 */     GIR_EraseRootFromParent_Done,
     /* 1199870 */   // Label 17446: @1199870
     /* 1199870 */   GIM_Try, /*On fail goto*//*Label 17447*/ GIMT_Encode4(1199950), // Rule ID 16991 //
     /* 1199875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1199886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1199889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199914 */     // MIs[0] round
     /* 1199914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199924 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1199927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199949 */     // GIR_Coverage, 16991,
     /* 1199949 */     GIR_EraseRootFromParent_Done,
     /* 1199950 */   // Label 17447: @1199950
     /* 1199950 */   GIM_Try, /*On fail goto*//*Label 17448*/ GIMT_Encode4(1200030), // Rule ID 16994 //
     /* 1199955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1199966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1199969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1199972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199994 */     // MIs[0] round
     /* 1199994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200004 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1200007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200029 */     // GIR_Coverage, 16994,
     /* 1200029 */     GIR_EraseRootFromParent_Done,
     /* 1200030 */   // Label 17448: @1200030
     /* 1200030 */   GIM_Try, /*On fail goto*//*Label 17449*/ GIMT_Encode4(1200110), // Rule ID 16995 //
     /* 1200035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1200038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1200046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1200049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1200052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1200074 */     // MIs[0] round
     /* 1200074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200084 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1200087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200109 */     // GIR_Coverage, 16995,
     /* 1200109 */     GIR_EraseRootFromParent_Done,
     /* 1200110 */   // Label 17449: @1200110
     /* 1200110 */   GIM_Try, /*On fail goto*//*Label 17450*/ GIMT_Encode4(1200190), // Rule ID 16998 //
     /* 1200115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1200118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1200126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1200129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1200132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200154 */     // MIs[0] round
     /* 1200154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200164 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1200167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200189 */     // GIR_Coverage, 16998,
     /* 1200189 */     GIR_EraseRootFromParent_Done,
     /* 1200190 */   // Label 17450: @1200190
     /* 1200190 */   GIM_Try, /*On fail goto*//*Label 17451*/ GIMT_Encode4(1200270), // Rule ID 16999 //
     /* 1200195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1200198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1200206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1200209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1200212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200234 */     // MIs[0] round
     /* 1200234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200244 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1200247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200269 */     // GIR_Coverage, 16999,
     /* 1200269 */     GIR_EraseRootFromParent_Done,
     /* 1200270 */   // Label 17451: @1200270
     /* 1200270 */   GIM_Try, /*On fail goto*//*Label 17452*/ GIMT_Encode4(1200350), // Rule ID 17002 //
     /* 1200275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1200278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1200286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1200289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1200292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200314 */     // MIs[0] round
     /* 1200314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200324 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1200327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200349 */     // GIR_Coverage, 17002,
     /* 1200349 */     GIR_EraseRootFromParent_Done,
     /* 1200350 */   // Label 17452: @1200350
     /* 1200350 */   GIM_Try, /*On fail goto*//*Label 17453*/ GIMT_Encode4(1200430), // Rule ID 17003 //
     /* 1200355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1200358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1200366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1200369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1200372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200394 */     // MIs[0] round
     /* 1200394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200404 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1200407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200429 */     // GIR_Coverage, 17003,
     /* 1200429 */     GIR_EraseRootFromParent_Done,
     /* 1200430 */   // Label 17453: @1200430
     /* 1200430 */   GIM_Try, /*On fail goto*//*Label 17454*/ GIMT_Encode4(1200510), // Rule ID 17006 //
     /* 1200435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1200438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1200446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1200449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1200452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200474 */     // MIs[0] round
     /* 1200474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200484 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1200487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200509 */     // GIR_Coverage, 17006,
     /* 1200509 */     GIR_EraseRootFromParent_Done,
     /* 1200510 */   // Label 17454: @1200510
     /* 1200510 */   GIM_Try, /*On fail goto*//*Label 17455*/ GIMT_Encode4(1200590), // Rule ID 17007 //
     /* 1200515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1200518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1200526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1200529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1200532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200554 */     // MIs[0] round
     /* 1200554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200564 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1200567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200589 */     // GIR_Coverage, 17007,
     /* 1200589 */     GIR_EraseRootFromParent_Done,
     /* 1200590 */   // Label 17455: @1200590
     /* 1200590 */   GIM_Try, /*On fail goto*//*Label 17456*/ GIMT_Encode4(1200670), // Rule ID 17010 //
     /* 1200595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1200606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1200609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1200612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1200615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200634 */     // MIs[0] round
     /* 1200634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200644 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1200647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200669 */     // GIR_Coverage, 17010,
     /* 1200669 */     GIR_EraseRootFromParent_Done,
     /* 1200670 */   // Label 17456: @1200670
     /* 1200670 */   GIM_Try, /*On fail goto*//*Label 17457*/ GIMT_Encode4(1200750), // Rule ID 17011 //
     /* 1200675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1200686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1200689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1200692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1200695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200714 */     // MIs[0] round
     /* 1200714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200724 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1200727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200749 */     // GIR_Coverage, 17011,
     /* 1200749 */     GIR_EraseRootFromParent_Done,
     /* 1200750 */   // Label 17457: @1200750
     /* 1200750 */   GIM_Try, /*On fail goto*//*Label 17458*/ GIMT_Encode4(1200830), // Rule ID 17014 //
     /* 1200755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1200766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1200769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1200772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1200775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200794 */     // MIs[0] round
     /* 1200794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200804 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1200807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200829 */     // GIR_Coverage, 17014,
     /* 1200829 */     GIR_EraseRootFromParent_Done,
     /* 1200830 */   // Label 17458: @1200830
     /* 1200830 */   GIM_Try, /*On fail goto*//*Label 17459*/ GIMT_Encode4(1200910), // Rule ID 17015 //
     /* 1200835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1200846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1200849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1200852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1200855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200874 */     // MIs[0] round
     /* 1200874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200884 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1200887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200909 */     // GIR_Coverage, 17015,
     /* 1200909 */     GIR_EraseRootFromParent_Done,
     /* 1200910 */   // Label 17459: @1200910
     /* 1200910 */   GIM_Try, /*On fail goto*//*Label 17460*/ GIMT_Encode4(1200990), // Rule ID 17018 //
     /* 1200915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1200929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1200932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1200935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200954 */     // MIs[0] round
     /* 1200954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200964 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1200967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200989 */     // GIR_Coverage, 17018,
     /* 1200989 */     GIR_EraseRootFromParent_Done,
     /* 1200990 */   // Label 17460: @1200990
     /* 1200990 */   GIM_Try, /*On fail goto*//*Label 17461*/ GIMT_Encode4(1201070), // Rule ID 17019 //
     /* 1200995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1201006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1201009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1201012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1201015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201034 */     // MIs[0] round
     /* 1201034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201044 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1201047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201069 */     // GIR_Coverage, 17019,
     /* 1201069 */     GIR_EraseRootFromParent_Done,
     /* 1201070 */   // Label 17461: @1201070
     /* 1201070 */   GIM_Try, /*On fail goto*//*Label 17462*/ GIMT_Encode4(1201150), // Rule ID 17022 //
     /* 1201075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1201086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1201089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1201092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1201095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201114 */     // MIs[0] round
     /* 1201114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201124 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1201127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201149 */     // GIR_Coverage, 17022,
     /* 1201149 */     GIR_EraseRootFromParent_Done,
     /* 1201150 */   // Label 17462: @1201150
     /* 1201150 */   GIM_Try, /*On fail goto*//*Label 17463*/ GIMT_Encode4(1201230), // Rule ID 17023 //
     /* 1201155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1201166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1201169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1201172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1201175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201194 */     // MIs[0] round
     /* 1201194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201204 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1201207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201229 */     // GIR_Coverage, 17023,
     /* 1201229 */     GIR_EraseRootFromParent_Done,
     /* 1201230 */   // Label 17463: @1201230
     /* 1201230 */   GIM_Try, /*On fail goto*//*Label 17464*/ GIMT_Encode4(1201310), // Rule ID 17026 //
     /* 1201235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1201246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1201249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1201252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1201255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201274 */     // MIs[0] round
     /* 1201274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201284 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1201287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201309 */     // GIR_Coverage, 17026,
     /* 1201309 */     GIR_EraseRootFromParent_Done,
     /* 1201310 */   // Label 17464: @1201310
     /* 1201310 */   GIM_Try, /*On fail goto*//*Label 17465*/ GIMT_Encode4(1201390), // Rule ID 17027 //
     /* 1201315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1201326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1201329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1201332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1201335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201354 */     // MIs[0] round
     /* 1201354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201364 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1201367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201389 */     // GIR_Coverage, 17027,
     /* 1201389 */     GIR_EraseRootFromParent_Done,
     /* 1201390 */   // Label 17465: @1201390
     /* 1201390 */   GIM_Try, /*On fail goto*//*Label 17466*/ GIMT_Encode4(1201470), // Rule ID 17030 //
     /* 1201395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1201406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1201409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1201412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1201415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201434 */     // MIs[0] round
     /* 1201434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201444 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1201447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201469 */     // GIR_Coverage, 17030,
     /* 1201469 */     GIR_EraseRootFromParent_Done,
     /* 1201470 */   // Label 17466: @1201470
     /* 1201470 */   GIM_Try, /*On fail goto*//*Label 17467*/ GIMT_Encode4(1201550), // Rule ID 17031 //
     /* 1201475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1201486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1201489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1201492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1201495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201514 */     // MIs[0] round
     /* 1201514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201524 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1201527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201549 */     // GIR_Coverage, 17031,
     /* 1201549 */     GIR_EraseRootFromParent_Done,
     /* 1201550 */   // Label 17467: @1201550
     /* 1201550 */   GIM_Try, /*On fail goto*//*Label 17468*/ GIMT_Encode4(1201630), // Rule ID 17034 //
     /* 1201555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1201566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1201569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1201572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1201575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201594 */     // MIs[0] round
     /* 1201594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201604 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1201607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201629 */     // GIR_Coverage, 17034,
     /* 1201629 */     GIR_EraseRootFromParent_Done,
     /* 1201630 */   // Label 17468: @1201630
     /* 1201630 */   GIM_Try, /*On fail goto*//*Label 17469*/ GIMT_Encode4(1201710), // Rule ID 17035 //
     /* 1201635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1201646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1201649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1201652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1201655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201674 */     // MIs[0] round
     /* 1201674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201684 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1201687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201709 */     // GIR_Coverage, 17035,
     /* 1201709 */     GIR_EraseRootFromParent_Done,
     /* 1201710 */   // Label 17469: @1201710
     /* 1201710 */   GIM_Try, /*On fail goto*//*Label 17470*/ GIMT_Encode4(1201790), // Rule ID 17038 //
     /* 1201715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1201726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1201729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1201732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1201735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201754 */     // MIs[0] round
     /* 1201754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201764 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1201767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201789 */     // GIR_Coverage, 17038,
     /* 1201789 */     GIR_EraseRootFromParent_Done,
     /* 1201790 */   // Label 17470: @1201790
     /* 1201790 */   GIM_Try, /*On fail goto*//*Label 17471*/ GIMT_Encode4(1201870), // Rule ID 17039 //
     /* 1201795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1201806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1201809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1201812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1201815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201834 */     // MIs[0] round
     /* 1201834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201844 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1201847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201869 */     // GIR_Coverage, 17039,
     /* 1201869 */     GIR_EraseRootFromParent_Done,
     /* 1201870 */   // Label 17471: @1201870
     /* 1201870 */   GIM_Try, /*On fail goto*//*Label 17472*/ GIMT_Encode4(1201950), // Rule ID 17042 //
     /* 1201875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1201895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201914 */     // MIs[0] round
     /* 1201914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201924 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1201927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201949 */     // GIR_Coverage, 17042,
     /* 1201949 */     GIR_EraseRootFromParent_Done,
     /* 1201950 */   // Label 17472: @1201950
     /* 1201950 */   GIM_Try, /*On fail goto*//*Label 17473*/ GIMT_Encode4(1202030), // Rule ID 17043 //
     /* 1201955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1201975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201994 */     // MIs[0] round
     /* 1201994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202004 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1202007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202029 */     // GIR_Coverage, 17043,
     /* 1202029 */     GIR_EraseRootFromParent_Done,
     /* 1202030 */   // Label 17473: @1202030
     /* 1202030 */   GIM_Try, /*On fail goto*//*Label 17474*/ GIMT_Encode4(1202110), // Rule ID 17046 //
     /* 1202035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1202046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1202049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1202052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202074 */     // MIs[0] round
     /* 1202074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202084 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1202087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202109 */     // GIR_Coverage, 17046,
     /* 1202109 */     GIR_EraseRootFromParent_Done,
     /* 1202110 */   // Label 17474: @1202110
     /* 1202110 */   GIM_Try, /*On fail goto*//*Label 17475*/ GIMT_Encode4(1202190), // Rule ID 17047 //
     /* 1202115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1202126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1202129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1202132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202154 */     // MIs[0] round
     /* 1202154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202164 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1202167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202189 */     // GIR_Coverage, 17047,
     /* 1202189 */     GIR_EraseRootFromParent_Done,
     /* 1202190 */   // Label 17475: @1202190
     /* 1202190 */   GIM_Try, /*On fail goto*//*Label 17476*/ GIMT_Encode4(1202270), // Rule ID 17050 //
     /* 1202195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1202206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1202209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1202212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202234 */     // MIs[0] round
     /* 1202234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1202247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202269 */     // GIR_Coverage, 17050,
     /* 1202269 */     GIR_EraseRootFromParent_Done,
     /* 1202270 */   // Label 17476: @1202270
     /* 1202270 */   GIM_Try, /*On fail goto*//*Label 17477*/ GIMT_Encode4(1202350), // Rule ID 17051 //
     /* 1202275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1202286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1202289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1202292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202314 */     // MIs[0] round
     /* 1202314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202324 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1202327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202349 */     // GIR_Coverage, 17051,
     /* 1202349 */     GIR_EraseRootFromParent_Done,
     /* 1202350 */   // Label 17477: @1202350
     /* 1202350 */   GIM_Try, /*On fail goto*//*Label 17478*/ GIMT_Encode4(1202430), // Rule ID 17054 //
     /* 1202355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1202366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1202369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1202372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202394 */     // MIs[0] round
     /* 1202394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202404 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1202407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202429 */     // GIR_Coverage, 17054,
     /* 1202429 */     GIR_EraseRootFromParent_Done,
     /* 1202430 */   // Label 17478: @1202430
     /* 1202430 */   GIM_Try, /*On fail goto*//*Label 17479*/ GIMT_Encode4(1202510), // Rule ID 17055 //
     /* 1202435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1202446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1202449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1202452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202474 */     // MIs[0] round
     /* 1202474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202484 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1202487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202509 */     // GIR_Coverage, 17055,
     /* 1202509 */     GIR_EraseRootFromParent_Done,
     /* 1202510 */   // Label 17479: @1202510
     /* 1202510 */   GIM_Try, /*On fail goto*//*Label 17480*/ GIMT_Encode4(1202590), // Rule ID 17058 //
     /* 1202515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1202526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1202529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1202532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202554 */     // MIs[0] round
     /* 1202554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202564 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1202567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202589 */     // GIR_Coverage, 17058,
     /* 1202589 */     GIR_EraseRootFromParent_Done,
     /* 1202590 */   // Label 17480: @1202590
     /* 1202590 */   GIM_Try, /*On fail goto*//*Label 17481*/ GIMT_Encode4(1202670), // Rule ID 17059 //
     /* 1202595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1202606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1202609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1202612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202634 */     // MIs[0] round
     /* 1202634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202644 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1202647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202669 */     // GIR_Coverage, 17059,
     /* 1202669 */     GIR_EraseRootFromParent_Done,
     /* 1202670 */   // Label 17481: @1202670
     /* 1202670 */   GIM_Try, /*On fail goto*//*Label 17482*/ GIMT_Encode4(1202750), // Rule ID 17062 //
     /* 1202675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1202686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1202689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1202692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202714 */     // MIs[0] round
     /* 1202714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202724 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1202727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202749 */     // GIR_Coverage, 17062,
     /* 1202749 */     GIR_EraseRootFromParent_Done,
     /* 1202750 */   // Label 17482: @1202750
     /* 1202750 */   GIM_Try, /*On fail goto*//*Label 17483*/ GIMT_Encode4(1202830), // Rule ID 17063 //
     /* 1202755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1202766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1202769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1202772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202794 */     // MIs[0] round
     /* 1202794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202804 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1202807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202829 */     // GIR_Coverage, 17063,
     /* 1202829 */     GIR_EraseRootFromParent_Done,
     /* 1202830 */   // Label 17483: @1202830
     /* 1202830 */   GIM_Try, /*On fail goto*//*Label 17484*/ GIMT_Encode4(1202910), // Rule ID 17066 //
     /* 1202835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1202846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1202849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1202852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202874 */     // MIs[0] round
     /* 1202874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202884 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1202887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202909 */     // GIR_Coverage, 17066,
     /* 1202909 */     GIR_EraseRootFromParent_Done,
     /* 1202910 */   // Label 17484: @1202910
     /* 1202910 */   GIM_Try, /*On fail goto*//*Label 17485*/ GIMT_Encode4(1202990), // Rule ID 17067 //
     /* 1202915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1202926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1202929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1202932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202954 */     // MIs[0] round
     /* 1202954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202964 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1202967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202989 */     // GIR_Coverage, 17067,
     /* 1202989 */     GIR_EraseRootFromParent_Done,
     /* 1202990 */   // Label 17485: @1202990
     /* 1202990 */   GIM_Try, /*On fail goto*//*Label 17486*/ GIMT_Encode4(1203070), // Rule ID 17070 //
     /* 1202995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1203003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1203006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1203009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1203012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203034 */     // MIs[0] round
     /* 1203034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203044 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1203047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203069 */     // GIR_Coverage, 17070,
     /* 1203069 */     GIR_EraseRootFromParent_Done,
     /* 1203070 */   // Label 17486: @1203070
     /* 1203070 */   GIM_Try, /*On fail goto*//*Label 17487*/ GIMT_Encode4(1203150), // Rule ID 17071 //
     /* 1203075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1203083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1203086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1203089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1203092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203114 */     // MIs[0] round
     /* 1203114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203124 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1203127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203149 */     // GIR_Coverage, 17071,
     /* 1203149 */     GIR_EraseRootFromParent_Done,
     /* 1203150 */   // Label 17487: @1203150
     /* 1203150 */   GIM_Try, /*On fail goto*//*Label 17488*/ GIMT_Encode4(1203230), // Rule ID 17074 //
     /* 1203155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1203163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1203166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1203169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1203172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203194 */     // MIs[0] round
     /* 1203194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203204 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1203207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203229 */     // GIR_Coverage, 17074,
     /* 1203229 */     GIR_EraseRootFromParent_Done,
     /* 1203230 */   // Label 17488: @1203230
     /* 1203230 */   GIM_Try, /*On fail goto*//*Label 17489*/ GIMT_Encode4(1203310), // Rule ID 17075 //
     /* 1203235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1203243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1203246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1203249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1203252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203274 */     // MIs[0] round
     /* 1203274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203284 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1203287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203309 */     // GIR_Coverage, 17075,
     /* 1203309 */     GIR_EraseRootFromParent_Done,
     /* 1203310 */   // Label 17489: @1203310
     /* 1203310 */   GIM_Try, /*On fail goto*//*Label 17490*/ GIMT_Encode4(1203390), // Rule ID 17078 //
     /* 1203315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1203323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1203326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1203329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1203332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203354 */     // MIs[0] round
     /* 1203354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203364 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1203367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203389 */     // GIR_Coverage, 17078,
     /* 1203389 */     GIR_EraseRootFromParent_Done,
     /* 1203390 */   // Label 17490: @1203390
     /* 1203390 */   GIM_Try, /*On fail goto*//*Label 17491*/ GIMT_Encode4(1203470), // Rule ID 17079 //
     /* 1203395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1203403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1203406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1203409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1203412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203434 */     // MIs[0] round
     /* 1203434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203444 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1203447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203469 */     // GIR_Coverage, 17079,
     /* 1203469 */     GIR_EraseRootFromParent_Done,
     /* 1203470 */   // Label 17491: @1203470
     /* 1203470 */   GIM_Try, /*On fail goto*//*Label 17492*/ GIMT_Encode4(1203550), // Rule ID 17082 //
     /* 1203475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1203486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1203489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1203492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1203495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203514 */     // MIs[0] round
     /* 1203514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203524 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1203527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203549 */     // GIR_Coverage, 17082,
     /* 1203549 */     GIR_EraseRootFromParent_Done,
     /* 1203550 */   // Label 17492: @1203550
     /* 1203550 */   GIM_Try, /*On fail goto*//*Label 17493*/ GIMT_Encode4(1203630), // Rule ID 17083 //
     /* 1203555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1203566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1203569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1203572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1203575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203594 */     // MIs[0] round
     /* 1203594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203604 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1203607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203629 */     // GIR_Coverage, 17083,
     /* 1203629 */     GIR_EraseRootFromParent_Done,
     /* 1203630 */   // Label 17493: @1203630
     /* 1203630 */   GIM_Try, /*On fail goto*//*Label 17494*/ GIMT_Encode4(1203710), // Rule ID 17086 //
     /* 1203635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1203646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1203649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1203652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1203655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203674 */     // MIs[0] round
     /* 1203674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203684 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1203687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203709 */     // GIR_Coverage, 17086,
     /* 1203709 */     GIR_EraseRootFromParent_Done,
     /* 1203710 */   // Label 17494: @1203710
     /* 1203710 */   GIM_Try, /*On fail goto*//*Label 17495*/ GIMT_Encode4(1203790), // Rule ID 17087 //
     /* 1203715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1203726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1203729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1203732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1203735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203754 */     // MIs[0] round
     /* 1203754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203764 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1203767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203789 */     // GIR_Coverage, 17087,
     /* 1203789 */     GIR_EraseRootFromParent_Done,
     /* 1203790 */   // Label 17495: @1203790
     /* 1203790 */   GIM_Try, /*On fail goto*//*Label 17496*/ GIMT_Encode4(1203870), // Rule ID 17090 //
     /* 1203795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1203806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1203809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1203812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1203815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203834 */     // MIs[0] round
     /* 1203834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203844 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11370:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1203847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203869 */     // GIR_Coverage, 17090,
     /* 1203869 */     GIR_EraseRootFromParent_Done,
     /* 1203870 */   // Label 17496: @1203870
     /* 1203870 */   GIM_Try, /*On fail goto*//*Label 17497*/ GIMT_Encode4(1203950), // Rule ID 17091 //
     /* 1203875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1203886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1203889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1203892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1203895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203914 */     // MIs[0] round
     /* 1203914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203924 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11370:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1203927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203949 */     // GIR_Coverage, 17091,
     /* 1203949 */     GIR_EraseRootFromParent_Done,
     /* 1203950 */   // Label 17497: @1203950
     /* 1203950 */   GIM_Try, /*On fail goto*//*Label 17498*/ GIMT_Encode4(1204030), // Rule ID 17094 //
     /* 1203955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1203966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1203969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1203972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1203975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203994 */     // MIs[0] round
     /* 1203994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204004 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11370:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1204007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204029 */     // GIR_Coverage, 17094,
     /* 1204029 */     GIR_EraseRootFromParent_Done,
     /* 1204030 */   // Label 17498: @1204030
     /* 1204030 */   GIM_Try, /*On fail goto*//*Label 17499*/ GIMT_Encode4(1204110), // Rule ID 17095 //
     /* 1204035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1204046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1204049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1204052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1204055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204074 */     // MIs[0] round
     /* 1204074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204084 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11370:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1204087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204109 */     // GIR_Coverage, 17095,
     /* 1204109 */     GIR_EraseRootFromParent_Done,
     /* 1204110 */   // Label 17499: @1204110
     /* 1204110 */   GIM_Try, /*On fail goto*//*Label 17500*/ GIMT_Encode4(1204190), // Rule ID 17098 //
     /* 1204115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1204126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1204129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1204132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1204135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204154 */     // MIs[0] round
     /* 1204154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204164 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11370:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1204167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204189 */     // GIR_Coverage, 17098,
     /* 1204189 */     GIR_EraseRootFromParent_Done,
     /* 1204190 */   // Label 17500: @1204190
     /* 1204190 */   GIM_Try, /*On fail goto*//*Label 17501*/ GIMT_Encode4(1204270), // Rule ID 17099 //
     /* 1204195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1204206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1204209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1204212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1204215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204234 */     // MIs[0] round
     /* 1204234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204244 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11370:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1204247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204269 */     // GIR_Coverage, 17099,
     /* 1204269 */     GIR_EraseRootFromParent_Done,
     /* 1204270 */   // Label 17501: @1204270
     /* 1204270 */   GIM_Try, /*On fail goto*//*Label 17502*/ GIMT_Encode4(1204350), // Rule ID 17102 //
     /* 1204275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1204286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1204289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1204292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1204295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204314 */     // MIs[0] round
     /* 1204314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204324 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1204327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204349 */     // GIR_Coverage, 17102,
     /* 1204349 */     GIR_EraseRootFromParent_Done,
     /* 1204350 */   // Label 17502: @1204350
     /* 1204350 */   GIM_Try, /*On fail goto*//*Label 17503*/ GIMT_Encode4(1204430), // Rule ID 17103 //
     /* 1204355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1204366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1204369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1204372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1204375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204394 */     // MIs[0] round
     /* 1204394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204404 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1204407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204429 */     // GIR_Coverage, 17103,
     /* 1204429 */     GIR_EraseRootFromParent_Done,
     /* 1204430 */   // Label 17503: @1204430
     /* 1204430 */   GIM_Try, /*On fail goto*//*Label 17504*/ GIMT_Encode4(1204510), // Rule ID 17106 //
     /* 1204435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1204446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1204449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1204452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1204455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204474 */     // MIs[0] round
     /* 1204474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204484 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11370:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1204487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204509 */     // GIR_Coverage, 17106,
     /* 1204509 */     GIR_EraseRootFromParent_Done,
     /* 1204510 */   // Label 17504: @1204510
     /* 1204510 */   GIM_Try, /*On fail goto*//*Label 17505*/ GIMT_Encode4(1204590), // Rule ID 17107 //
     /* 1204515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1204526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1204529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1204532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1204535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204554 */     // MIs[0] round
     /* 1204554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204564 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11370:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1204567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204589 */     // GIR_Coverage, 17107,
     /* 1204589 */     GIR_EraseRootFromParent_Done,
     /* 1204590 */   // Label 17505: @1204590
     /* 1204590 */   GIM_Try, /*On fail goto*//*Label 17506*/ GIMT_Encode4(1204670), // Rule ID 17110 //
     /* 1204595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1204606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1204609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1204612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1204615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204634 */     // MIs[0] round
     /* 1204634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204644 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11370:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1204647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204669 */     // GIR_Coverage, 17110,
     /* 1204669 */     GIR_EraseRootFromParent_Done,
     /* 1204670 */   // Label 17506: @1204670
     /* 1204670 */   GIM_Try, /*On fail goto*//*Label 17507*/ GIMT_Encode4(1204750), // Rule ID 17111 //
     /* 1204675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1204686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1204689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1204692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1204695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204714 */     // MIs[0] round
     /* 1204714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204724 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11370:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1204727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204749 */     // GIR_Coverage, 17111,
     /* 1204749 */     GIR_EraseRootFromParent_Done,
     /* 1204750 */   // Label 17507: @1204750
     /* 1204750 */   GIM_Try, /*On fail goto*//*Label 17508*/ GIMT_Encode4(1204830), // Rule ID 17114 //
     /* 1204755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1204766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1204769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1204772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1204775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204794 */     // MIs[0] round
     /* 1204794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204804 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11370:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1204807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204829 */     // GIR_Coverage, 17114,
     /* 1204829 */     GIR_EraseRootFromParent_Done,
     /* 1204830 */   // Label 17508: @1204830
     /* 1204830 */   GIM_Try, /*On fail goto*//*Label 17509*/ GIMT_Encode4(1204910), // Rule ID 17115 //
     /* 1204835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1204846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1204849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1204852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1204855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204874 */     // MIs[0] round
     /* 1204874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204884 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11370:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1204887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204909 */     // GIR_Coverage, 17115,
     /* 1204909 */     GIR_EraseRootFromParent_Done,
     /* 1204910 */   // Label 17509: @1204910
     /* 1204910 */   GIM_Try, /*On fail goto*//*Label 17510*/ GIMT_Encode4(1204990), // Rule ID 17118 //
     /* 1204915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1204926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1204929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1204932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204954 */     // MIs[0] round
     /* 1204954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204964 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1204967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204989 */     // GIR_Coverage, 17118,
     /* 1204989 */     GIR_EraseRootFromParent_Done,
     /* 1204990 */   // Label 17510: @1204990
     /* 1204990 */   GIM_Try, /*On fail goto*//*Label 17511*/ GIMT_Encode4(1205070), // Rule ID 17119 //
     /* 1204995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1205006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1205009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1205012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205034 */     // MIs[0] round
     /* 1205034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205044 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1205047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205069 */     // GIR_Coverage, 17119,
     /* 1205069 */     GIR_EraseRootFromParent_Done,
     /* 1205070 */   // Label 17511: @1205070
     /* 1205070 */   GIM_Try, /*On fail goto*//*Label 17512*/ GIMT_Encode4(1205150), // Rule ID 17122 //
     /* 1205075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1205092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205114 */     // MIs[0] round
     /* 1205114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205124 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1205127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205149 */     // GIR_Coverage, 17122,
     /* 1205149 */     GIR_EraseRootFromParent_Done,
     /* 1205150 */   // Label 17512: @1205150
     /* 1205150 */   GIM_Try, /*On fail goto*//*Label 17513*/ GIMT_Encode4(1205230), // Rule ID 17123 //
     /* 1205155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1205172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205194 */     // MIs[0] round
     /* 1205194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205204 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1205207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205229 */     // GIR_Coverage, 17123,
     /* 1205229 */     GIR_EraseRootFromParent_Done,
     /* 1205230 */   // Label 17513: @1205230
     /* 1205230 */   GIM_Try, /*On fail goto*//*Label 17514*/ GIMT_Encode4(1205310), // Rule ID 17126 //
     /* 1205235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1205246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1205249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1205252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205274 */     // MIs[0] round
     /* 1205274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205284 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11370:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1205287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205309 */     // GIR_Coverage, 17126,
     /* 1205309 */     GIR_EraseRootFromParent_Done,
     /* 1205310 */   // Label 17514: @1205310
     /* 1205310 */   GIM_Try, /*On fail goto*//*Label 17515*/ GIMT_Encode4(1205390), // Rule ID 17127 //
     /* 1205315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1205326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1205329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1205332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205354 */     // MIs[0] round
     /* 1205354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205364 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11370:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1205367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205389 */     // GIR_Coverage, 17127,
     /* 1205389 */     GIR_EraseRootFromParent_Done,
     /* 1205390 */   // Label 17515: @1205390
     /* 1205390 */   GIM_Try, /*On fail goto*//*Label 17516*/ GIMT_Encode4(1205470), // Rule ID 17130 //
     /* 1205395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1205406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1205409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1205412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205434 */     // MIs[0] round
     /* 1205434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205444 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11370:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1205447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205469 */     // GIR_Coverage, 17130,
     /* 1205469 */     GIR_EraseRootFromParent_Done,
     /* 1205470 */   // Label 17516: @1205470
     /* 1205470 */   GIM_Try, /*On fail goto*//*Label 17517*/ GIMT_Encode4(1205550), // Rule ID 17131 //
     /* 1205475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1205486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1205489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1205492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205514 */     // MIs[0] round
     /* 1205514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205524 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11370:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1205527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205549 */     // GIR_Coverage, 17131,
     /* 1205549 */     GIR_EraseRootFromParent_Done,
     /* 1205550 */   // Label 17517: @1205550
     /* 1205550 */   GIM_Try, /*On fail goto*//*Label 17518*/ GIMT_Encode4(1205630), // Rule ID 17134 //
     /* 1205555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1205566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1205569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1205572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205594 */     // MIs[0] round
     /* 1205594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205604 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11370:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1205607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205629 */     // GIR_Coverage, 17134,
     /* 1205629 */     GIR_EraseRootFromParent_Done,
     /* 1205630 */   // Label 17518: @1205630
     /* 1205630 */   GIM_Try, /*On fail goto*//*Label 17519*/ GIMT_Encode4(1205710), // Rule ID 17135 //
     /* 1205635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1205646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1205649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1205652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205674 */     // MIs[0] round
     /* 1205674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205684 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11370:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1205687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205709 */     // GIR_Coverage, 17135,
     /* 1205709 */     GIR_EraseRootFromParent_Done,
     /* 1205710 */   // Label 17519: @1205710
     /* 1205710 */   GIM_Try, /*On fail goto*//*Label 17520*/ GIMT_Encode4(1205790), // Rule ID 17138 //
     /* 1205715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1205726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1205729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1205732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205754 */     // MIs[0] round
     /* 1205754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205764 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1205767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205789 */     // GIR_Coverage, 17138,
     /* 1205789 */     GIR_EraseRootFromParent_Done,
     /* 1205790 */   // Label 17520: @1205790
     /* 1205790 */   GIM_Try, /*On fail goto*//*Label 17521*/ GIMT_Encode4(1205870), // Rule ID 17139 //
     /* 1205795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1205806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1205809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1205812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205834 */     // MIs[0] round
     /* 1205834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205844 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1205847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205869 */     // GIR_Coverage, 17139,
     /* 1205869 */     GIR_EraseRootFromParent_Done,
     /* 1205870 */   // Label 17521: @1205870
     /* 1205870 */   GIM_Try, /*On fail goto*//*Label 17522*/ GIMT_Encode4(1205950), // Rule ID 17142 //
     /* 1205875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1205886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1205889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205914 */     // MIs[0] round
     /* 1205914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205924 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11370:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1205927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205949 */     // GIR_Coverage, 17142,
     /* 1205949 */     GIR_EraseRootFromParent_Done,
     /* 1205950 */   // Label 17522: @1205950
     /* 1205950 */   GIM_Try, /*On fail goto*//*Label 17523*/ GIMT_Encode4(1206030), // Rule ID 17143 //
     /* 1205955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1205966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1205969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205994 */     // MIs[0] round
     /* 1205994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206004 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11370:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1206007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206029 */     // GIR_Coverage, 17143,
     /* 1206029 */     GIR_EraseRootFromParent_Done,
     /* 1206030 */   // Label 17523: @1206030
     /* 1206030 */   GIM_Try, /*On fail goto*//*Label 17524*/ GIMT_Encode4(1206110), // Rule ID 17146 //
     /* 1206035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1206043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206074 */     // MIs[0] round
     /* 1206074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206084 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11370:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1206087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206109 */     // GIR_Coverage, 17146,
     /* 1206109 */     GIR_EraseRootFromParent_Done,
     /* 1206110 */   // Label 17524: @1206110
     /* 1206110 */   GIM_Try, /*On fail goto*//*Label 17525*/ GIMT_Encode4(1206190), // Rule ID 17147 //
     /* 1206115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1206123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206154 */     // MIs[0] round
     /* 1206154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206164 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11370:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1206167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206189 */     // GIR_Coverage, 17147,
     /* 1206189 */     GIR_EraseRootFromParent_Done,
     /* 1206190 */   // Label 17525: @1206190
     /* 1206190 */   GIM_Try, /*On fail goto*//*Label 17526*/ GIMT_Encode4(1206270), // Rule ID 17150 //
     /* 1206195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1206203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1206206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1206209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206234 */     // MIs[0] round
     /* 1206234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206244 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11370:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1206247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206269 */     // GIR_Coverage, 17150,
     /* 1206269 */     GIR_EraseRootFromParent_Done,
     /* 1206270 */   // Label 17526: @1206270
     /* 1206270 */   GIM_Try, /*On fail goto*//*Label 17527*/ GIMT_Encode4(1206350), // Rule ID 17151 //
     /* 1206275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1206283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1206286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1206289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206314 */     // MIs[0] round
     /* 1206314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206324 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11370:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1206327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206349 */     // GIR_Coverage, 17151,
     /* 1206349 */     GIR_EraseRootFromParent_Done,
     /* 1206350 */   // Label 17527: @1206350
     /* 1206350 */   GIM_Try, /*On fail goto*//*Label 17528*/ GIMT_Encode4(1206430), // Rule ID 17156 //
     /* 1206355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1206366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1206369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1206372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1206375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206394 */     // MIs[0] round
     /* 1206394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206404 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1206407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206429 */     // GIR_Coverage, 17156,
     /* 1206429 */     GIR_EraseRootFromParent_Done,
     /* 1206430 */   // Label 17528: @1206430
     /* 1206430 */   GIM_Try, /*On fail goto*//*Label 17529*/ GIMT_Encode4(1206510), // Rule ID 17157 //
     /* 1206435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1206446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1206449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1206452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1206455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206474 */     // MIs[0] round
     /* 1206474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206484 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1206487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206509 */     // GIR_Coverage, 17157,
     /* 1206509 */     GIR_EraseRootFromParent_Done,
     /* 1206510 */   // Label 17529: @1206510
     /* 1206510 */   GIM_Try, /*On fail goto*//*Label 17530*/ GIMT_Encode4(1206590), // Rule ID 17166 //
     /* 1206515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1206526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1206529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1206535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206554 */     // MIs[0] round
     /* 1206554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206564 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1206567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206589 */     // GIR_Coverage, 17166,
     /* 1206589 */     GIR_EraseRootFromParent_Done,
     /* 1206590 */   // Label 17530: @1206590
     /* 1206590 */   GIM_Try, /*On fail goto*//*Label 17531*/ GIMT_Encode4(1206670), // Rule ID 17167 //
     /* 1206595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1206606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1206609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1206615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206634 */     // MIs[0] round
     /* 1206634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206644 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1206647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206669 */     // GIR_Coverage, 17167,
     /* 1206669 */     GIR_EraseRootFromParent_Done,
     /* 1206670 */   // Label 17531: @1206670
     /* 1206670 */   GIM_Try, /*On fail goto*//*Label 17532*/ GIMT_Encode4(1206750), // Rule ID 17176 //
     /* 1206675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1206686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1206689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1206695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206714 */     // MIs[0] round
     /* 1206714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206724 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1206727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206749 */     // GIR_Coverage, 17176,
     /* 1206749 */     GIR_EraseRootFromParent_Done,
     /* 1206750 */   // Label 17532: @1206750
     /* 1206750 */   GIM_Try, /*On fail goto*//*Label 17533*/ GIMT_Encode4(1206830), // Rule ID 17177 //
     /* 1206755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1206766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1206769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1206775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206794 */     // MIs[0] round
     /* 1206794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206804 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1206807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206829 */     // GIR_Coverage, 17177,
     /* 1206829 */     GIR_EraseRootFromParent_Done,
     /* 1206830 */   // Label 17533: @1206830
     /* 1206830 */   GIM_Try, /*On fail goto*//*Label 17534*/ GIMT_Encode4(1206910), // Rule ID 17186 //
     /* 1206835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1206855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206874 */     // MIs[0] round
     /* 1206874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206884 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1206887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206909 */     // GIR_Coverage, 17186,
     /* 1206909 */     GIR_EraseRootFromParent_Done,
     /* 1206910 */   // Label 17534: @1206910
     /* 1206910 */   GIM_Try, /*On fail goto*//*Label 17535*/ GIMT_Encode4(1206990), // Rule ID 17187 //
     /* 1206915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1206935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206954 */     // MIs[0] round
     /* 1206954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206964 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1206967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206989 */     // GIR_Coverage, 17187,
     /* 1206989 */     GIR_EraseRootFromParent_Done,
     /* 1206990 */   // Label 17535: @1206990
     /* 1206990 */   GIM_Try, /*On fail goto*//*Label 17536*/ GIMT_Encode4(1207070), // Rule ID 17196 //
     /* 1206995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1207006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1207009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1207012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1207015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207034 */     // MIs[0] round
     /* 1207034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207044 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1207047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207069 */     // GIR_Coverage, 17196,
     /* 1207069 */     GIR_EraseRootFromParent_Done,
     /* 1207070 */   // Label 17536: @1207070
     /* 1207070 */   GIM_Try, /*On fail goto*//*Label 17537*/ GIMT_Encode4(1207150), // Rule ID 17197 //
     /* 1207075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1207086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1207089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1207092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1207095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207114 */     // MIs[0] round
     /* 1207114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207124 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1207127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207149 */     // GIR_Coverage, 17197,
     /* 1207149 */     GIR_EraseRootFromParent_Done,
     /* 1207150 */   // Label 17537: @1207150
     /* 1207150 */   GIM_Try, /*On fail goto*//*Label 17538*/ GIMT_Encode4(1207230), // Rule ID 17206 //
     /* 1207155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1207166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1207169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1207172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1207175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207194 */     // MIs[0] round
     /* 1207194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207204 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1207207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207229 */     // GIR_Coverage, 17206,
     /* 1207229 */     GIR_EraseRootFromParent_Done,
     /* 1207230 */   // Label 17538: @1207230
     /* 1207230 */   GIM_Try, /*On fail goto*//*Label 17539*/ GIMT_Encode4(1207310), // Rule ID 17207 //
     /* 1207235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1207246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1207249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1207252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1207255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207274 */     // MIs[0] round
     /* 1207274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207284 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1207287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207309 */     // GIR_Coverage, 17207,
     /* 1207309 */     GIR_EraseRootFromParent_Done,
     /* 1207310 */   // Label 17539: @1207310
     /* 1207310 */   GIM_Try, /*On fail goto*//*Label 17540*/ GIMT_Encode4(1207390), // Rule ID 17216 //
     /* 1207315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1207326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1207329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1207332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1207335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207354 */     // MIs[0] round
     /* 1207354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207364 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1207367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207389 */     // GIR_Coverage, 17216,
     /* 1207389 */     GIR_EraseRootFromParent_Done,
     /* 1207390 */   // Label 17540: @1207390
     /* 1207390 */   GIM_Try, /*On fail goto*//*Label 17541*/ GIMT_Encode4(1207470), // Rule ID 17217 //
     /* 1207395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1207406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1207409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1207412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1207415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207434 */     // MIs[0] round
     /* 1207434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207444 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1207447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207469 */     // GIR_Coverage, 17217,
     /* 1207469 */     GIR_EraseRootFromParent_Done,
     /* 1207470 */   // Label 17541: @1207470
     /* 1207470 */   GIM_Try, /*On fail goto*//*Label 17542*/ GIMT_Encode4(1207550), // Rule ID 17226 //
     /* 1207475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1207486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1207489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1207492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1207495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207514 */     // MIs[0] round
     /* 1207514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207524 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1207527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207549 */     // GIR_Coverage, 17226,
     /* 1207549 */     GIR_EraseRootFromParent_Done,
     /* 1207550 */   // Label 17542: @1207550
     /* 1207550 */   GIM_Try, /*On fail goto*//*Label 17543*/ GIMT_Encode4(1207630), // Rule ID 17227 //
     /* 1207555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1207566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1207569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1207572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1207575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207594 */     // MIs[0] round
     /* 1207594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207604 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1207607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207629 */     // GIR_Coverage, 17227,
     /* 1207629 */     GIR_EraseRootFromParent_Done,
     /* 1207630 */   // Label 17543: @1207630
     /* 1207630 */   GIM_Try, /*On fail goto*//*Label 17544*/ GIMT_Encode4(1207710), // Rule ID 17234 //
     /* 1207635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1207646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1207649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1207652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207674 */     // MIs[0] round
     /* 1207674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207684 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1207687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207709 */     // GIR_Coverage, 17234,
     /* 1207709 */     GIR_EraseRootFromParent_Done,
     /* 1207710 */   // Label 17544: @1207710
     /* 1207710 */   GIM_Try, /*On fail goto*//*Label 17545*/ GIMT_Encode4(1207790), // Rule ID 17235 //
     /* 1207715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1207726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1207729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1207732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207754 */     // MIs[0] round
     /* 1207754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207764 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1207767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207789 */     // GIR_Coverage, 17235,
     /* 1207789 */     GIR_EraseRootFromParent_Done,
     /* 1207790 */   // Label 17545: @1207790
     /* 1207790 */   GIM_Try, /*On fail goto*//*Label 17546*/ GIMT_Encode4(1207870), // Rule ID 17238 //
     /* 1207795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207834 */     // MIs[0] round
     /* 1207834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207844 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1207847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207869 */     // GIR_Coverage, 17238,
     /* 1207869 */     GIR_EraseRootFromParent_Done,
     /* 1207870 */   // Label 17546: @1207870
     /* 1207870 */   GIM_Try, /*On fail goto*//*Label 17547*/ GIMT_Encode4(1207950), // Rule ID 17239 //
     /* 1207875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207914 */     // MIs[0] round
     /* 1207914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207924 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1207927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207949 */     // GIR_Coverage, 17239,
     /* 1207949 */     GIR_EraseRootFromParent_Done,
     /* 1207950 */   // Label 17547: @1207950
     /* 1207950 */   GIM_Try, /*On fail goto*//*Label 17548*/ GIMT_Encode4(1208030), // Rule ID 17242 //
     /* 1207955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1207966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1207969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1207972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207994 */     // MIs[0] round
     /* 1207994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208004 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1208007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208029 */     // GIR_Coverage, 17242,
     /* 1208029 */     GIR_EraseRootFromParent_Done,
     /* 1208030 */   // Label 17548: @1208030
     /* 1208030 */   GIM_Try, /*On fail goto*//*Label 17549*/ GIMT_Encode4(1208110), // Rule ID 17243 //
     /* 1208035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1208046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1208049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1208052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208074 */     // MIs[0] round
     /* 1208074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208084 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1208087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208109 */     // GIR_Coverage, 17243,
     /* 1208109 */     GIR_EraseRootFromParent_Done,
     /* 1208110 */   // Label 17549: @1208110
     /* 1208110 */   GIM_Try, /*On fail goto*//*Label 17550*/ GIMT_Encode4(1208190), // Rule ID 17246 //
     /* 1208115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1208126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1208129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1208132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208154 */     // MIs[0] round
     /* 1208154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208164 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1208167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208189 */     // GIR_Coverage, 17246,
     /* 1208189 */     GIR_EraseRootFromParent_Done,
     /* 1208190 */   // Label 17550: @1208190
     /* 1208190 */   GIM_Try, /*On fail goto*//*Label 17551*/ GIMT_Encode4(1208270), // Rule ID 17247 //
     /* 1208195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1208206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1208209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1208212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208234 */     // MIs[0] round
     /* 1208234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208244 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1208247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208269 */     // GIR_Coverage, 17247,
     /* 1208269 */     GIR_EraseRootFromParent_Done,
     /* 1208270 */   // Label 17551: @1208270
     /* 1208270 */   GIM_Try, /*On fail goto*//*Label 17552*/ GIMT_Encode4(1208350), // Rule ID 17250 //
     /* 1208275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1208286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1208289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1208292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208314 */     // MIs[0] round
     /* 1208314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208324 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1208327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208349 */     // GIR_Coverage, 17250,
     /* 1208349 */     GIR_EraseRootFromParent_Done,
     /* 1208350 */   // Label 17552: @1208350
     /* 1208350 */   GIM_Try, /*On fail goto*//*Label 17553*/ GIMT_Encode4(1208430), // Rule ID 17251 //
     /* 1208355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1208366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1208369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1208372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208394 */     // MIs[0] round
     /* 1208394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208404 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1208407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208429 */     // GIR_Coverage, 17251,
     /* 1208429 */     GIR_EraseRootFromParent_Done,
     /* 1208430 */   // Label 17553: @1208430
     /* 1208430 */   GIM_Try, /*On fail goto*//*Label 17554*/ GIMT_Encode4(1208510), // Rule ID 17254 //
     /* 1208435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1208446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1208449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1208452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208474 */     // MIs[0] round
     /* 1208474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208484 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1208487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208509 */     // GIR_Coverage, 17254,
     /* 1208509 */     GIR_EraseRootFromParent_Done,
     /* 1208510 */   // Label 17554: @1208510
     /* 1208510 */   GIM_Try, /*On fail goto*//*Label 17555*/ GIMT_Encode4(1208590), // Rule ID 17255 //
     /* 1208515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1208526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1208529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1208532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208554 */     // MIs[0] round
     /* 1208554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208564 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1208567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208589 */     // GIR_Coverage, 17255,
     /* 1208589 */     GIR_EraseRootFromParent_Done,
     /* 1208590 */   // Label 17555: @1208590
     /* 1208590 */   GIM_Try, /*On fail goto*//*Label 17556*/ GIMT_Encode4(1208670), // Rule ID 17258 //
     /* 1208595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1208606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1208609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1208612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208634 */     // MIs[0] round
     /* 1208634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208644 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1208647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208669 */     // GIR_Coverage, 17258,
     /* 1208669 */     GIR_EraseRootFromParent_Done,
     /* 1208670 */   // Label 17556: @1208670
     /* 1208670 */   GIM_Try, /*On fail goto*//*Label 17557*/ GIMT_Encode4(1208750), // Rule ID 17259 //
     /* 1208675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1208686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1208689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1208692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208714 */     // MIs[0] round
     /* 1208714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208724 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1208727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208749 */     // GIR_Coverage, 17259,
     /* 1208749 */     GIR_EraseRootFromParent_Done,
     /* 1208750 */   // Label 17557: @1208750
     /* 1208750 */   GIM_Try, /*On fail goto*//*Label 17558*/ GIMT_Encode4(1208830), // Rule ID 17262 //
     /* 1208755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1208766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1208769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1208772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208794 */     // MIs[0] round
     /* 1208794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208804 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1208807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208829 */     // GIR_Coverage, 17262,
     /* 1208829 */     GIR_EraseRootFromParent_Done,
     /* 1208830 */   // Label 17558: @1208830
     /* 1208830 */   GIM_Try, /*On fail goto*//*Label 17559*/ GIMT_Encode4(1208910), // Rule ID 17263 //
     /* 1208835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1208846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1208849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1208852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208874 */     // MIs[0] round
     /* 1208874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208884 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1208887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208909 */     // GIR_Coverage, 17263,
     /* 1208909 */     GIR_EraseRootFromParent_Done,
     /* 1208910 */   // Label 17559: @1208910
     /* 1208910 */   GIM_Try, /*On fail goto*//*Label 17560*/ GIMT_Encode4(1208990), // Rule ID 17266 //
     /* 1208915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1208926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1208929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1208932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208954 */     // MIs[0] round
     /* 1208954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208964 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1208967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208989 */     // GIR_Coverage, 17266,
     /* 1208989 */     GIR_EraseRootFromParent_Done,
     /* 1208990 */   // Label 17560: @1208990
     /* 1208990 */   GIM_Try, /*On fail goto*//*Label 17561*/ GIMT_Encode4(1209070), // Rule ID 17267 //
     /* 1208995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1209003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1209006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1209009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1209012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209034 */     // MIs[0] round
     /* 1209034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209044 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1209047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209069 */     // GIR_Coverage, 17267,
     /* 1209069 */     GIR_EraseRootFromParent_Done,
     /* 1209070 */   // Label 17561: @1209070
     /* 1209070 */   GIM_Try, /*On fail goto*//*Label 17562*/ GIMT_Encode4(1209150), // Rule ID 17272 //
     /* 1209075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1209086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1209089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1209092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1209095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209114 */     // MIs[0] round
     /* 1209114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209124 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1209127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209149 */     // GIR_Coverage, 17272,
     /* 1209149 */     GIR_EraseRootFromParent_Done,
     /* 1209150 */   // Label 17562: @1209150
     /* 1209150 */   GIM_Try, /*On fail goto*//*Label 17563*/ GIMT_Encode4(1209230), // Rule ID 17273 //
     /* 1209155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1209166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1209169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1209172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1209175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209194 */     // MIs[0] round
     /* 1209194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209204 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1209207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209229 */     // GIR_Coverage, 17273,
     /* 1209229 */     GIR_EraseRootFromParent_Done,
     /* 1209230 */   // Label 17563: @1209230
     /* 1209230 */   GIM_Try, /*On fail goto*//*Label 17564*/ GIMT_Encode4(1209310), // Rule ID 17282 //
     /* 1209235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1209246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1209249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1209252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1209255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209274 */     // MIs[0] round
     /* 1209274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209284 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1209287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209309 */     // GIR_Coverage, 17282,
     /* 1209309 */     GIR_EraseRootFromParent_Done,
     /* 1209310 */   // Label 17564: @1209310
     /* 1209310 */   GIM_Try, /*On fail goto*//*Label 17565*/ GIMT_Encode4(1209390), // Rule ID 17283 //
     /* 1209315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1209326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1209329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1209332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1209335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209354 */     // MIs[0] round
     /* 1209354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209364 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1209367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209389 */     // GIR_Coverage, 17283,
     /* 1209389 */     GIR_EraseRootFromParent_Done,
     /* 1209390 */   // Label 17565: @1209390
     /* 1209390 */   GIM_Try, /*On fail goto*//*Label 17566*/ GIMT_Encode4(1209470), // Rule ID 17292 //
     /* 1209395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1209406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1209409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1209412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1209415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209434 */     // MIs[0] round
     /* 1209434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209444 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1209447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209469 */     // GIR_Coverage, 17292,
     /* 1209469 */     GIR_EraseRootFromParent_Done,
     /* 1209470 */   // Label 17566: @1209470
     /* 1209470 */   GIM_Try, /*On fail goto*//*Label 17567*/ GIMT_Encode4(1209550), // Rule ID 17293 //
     /* 1209475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1209486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1209489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1209492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1209495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209514 */     // MIs[0] round
     /* 1209514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209524 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1209527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209549 */     // GIR_Coverage, 17293,
     /* 1209549 */     GIR_EraseRootFromParent_Done,
     /* 1209550 */   // Label 17567: @1209550
     /* 1209550 */   GIM_Try, /*On fail goto*//*Label 17568*/ GIMT_Encode4(1209630), // Rule ID 17302 //
     /* 1209555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1209566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1209569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1209572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1209575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209594 */     // MIs[0] round
     /* 1209594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209604 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1209607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209629 */     // GIR_Coverage, 17302,
     /* 1209629 */     GIR_EraseRootFromParent_Done,
     /* 1209630 */   // Label 17568: @1209630
     /* 1209630 */   GIM_Try, /*On fail goto*//*Label 17569*/ GIMT_Encode4(1209710), // Rule ID 17303 //
     /* 1209635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1209646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1209649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1209652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1209655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209674 */     // MIs[0] round
     /* 1209674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209684 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1209687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209709 */     // GIR_Coverage, 17303,
     /* 1209709 */     GIR_EraseRootFromParent_Done,
     /* 1209710 */   // Label 17569: @1209710
     /* 1209710 */   GIM_Try, /*On fail goto*//*Label 17570*/ GIMT_Encode4(1209790), // Rule ID 17312 //
     /* 1209715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1209726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1209729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1209732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1209735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209754 */     // MIs[0] round
     /* 1209754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209764 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1209767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209789 */     // GIR_Coverage, 17312,
     /* 1209789 */     GIR_EraseRootFromParent_Done,
     /* 1209790 */   // Label 17570: @1209790
     /* 1209790 */   GIM_Try, /*On fail goto*//*Label 17571*/ GIMT_Encode4(1209870), // Rule ID 17313 //
     /* 1209795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1209806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1209809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1209812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1209815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209834 */     // MIs[0] round
     /* 1209834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209844 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1209847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209869 */     // GIR_Coverage, 17313,
     /* 1209869 */     GIR_EraseRootFromParent_Done,
     /* 1209870 */   // Label 17571: @1209870
     /* 1209870 */   GIM_Try, /*On fail goto*//*Label 17572*/ GIMT_Encode4(1209950), // Rule ID 17322 //
     /* 1209875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1209886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1209889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1209892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1209895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209914 */     // MIs[0] round
     /* 1209914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209924 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1209927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209949 */     // GIR_Coverage, 17322,
     /* 1209949 */     GIR_EraseRootFromParent_Done,
     /* 1209950 */   // Label 17572: @1209950
     /* 1209950 */   GIM_Try, /*On fail goto*//*Label 17573*/ GIMT_Encode4(1210030), // Rule ID 17323 //
     /* 1209955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1209966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1209969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1209972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1209975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209994 */     // MIs[0] round
     /* 1209994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210004 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1210007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210029 */     // GIR_Coverage, 17323,
     /* 1210029 */     GIR_EraseRootFromParent_Done,
     /* 1210030 */   // Label 17573: @1210030
     /* 1210030 */   GIM_Try, /*On fail goto*//*Label 17574*/ GIMT_Encode4(1210110), // Rule ID 17332 //
     /* 1210035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1210046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1210049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1210052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1210055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210074 */     // MIs[0] round
     /* 1210074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210084 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1210087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210109 */     // GIR_Coverage, 17332,
     /* 1210109 */     GIR_EraseRootFromParent_Done,
     /* 1210110 */   // Label 17574: @1210110
     /* 1210110 */   GIM_Try, /*On fail goto*//*Label 17575*/ GIMT_Encode4(1210190), // Rule ID 17333 //
     /* 1210115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1210126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1210129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1210132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1210135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210154 */     // MIs[0] round
     /* 1210154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210164 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1210167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210189 */     // GIR_Coverage, 17333,
     /* 1210189 */     GIR_EraseRootFromParent_Done,
     /* 1210190 */   // Label 17575: @1210190
     /* 1210190 */   GIM_Try, /*On fail goto*//*Label 17576*/ GIMT_Encode4(1210270), // Rule ID 17342 //
     /* 1210195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1210206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1210209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1210212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1210215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210234 */     // MIs[0] round
     /* 1210234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210244 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1210247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210269 */     // GIR_Coverage, 17342,
     /* 1210269 */     GIR_EraseRootFromParent_Done,
     /* 1210270 */   // Label 17576: @1210270
     /* 1210270 */   GIM_Try, /*On fail goto*//*Label 17577*/ GIMT_Encode4(1210350), // Rule ID 17343 //
     /* 1210275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1210286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1210289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1210292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1210295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210314 */     // MIs[0] round
     /* 1210314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210324 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1210327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210349 */     // GIR_Coverage, 17343,
     /* 1210349 */     GIR_EraseRootFromParent_Done,
     /* 1210350 */   // Label 17577: @1210350
     /* 1210350 */   GIM_Try, /*On fail goto*//*Label 17578*/ GIMT_Encode4(1210430), // Rule ID 17352 //
     /* 1210355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1210366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1210369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1210372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1210375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210394 */     // MIs[0] round
     /* 1210394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210404 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1210407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210429 */     // GIR_Coverage, 17352,
     /* 1210429 */     GIR_EraseRootFromParent_Done,
     /* 1210430 */   // Label 17578: @1210430
     /* 1210430 */   GIM_Try, /*On fail goto*//*Label 17579*/ GIMT_Encode4(1210510), // Rule ID 17353 //
     /* 1210435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1210446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1210449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1210452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1210455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210474 */     // MIs[0] round
     /* 1210474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210484 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1210487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210509 */     // GIR_Coverage, 17353,
     /* 1210509 */     GIR_EraseRootFromParent_Done,
     /* 1210510 */   // Label 17579: @1210510
     /* 1210510 */   GIM_Try, /*On fail goto*//*Label 17580*/ GIMT_Encode4(1210590), // Rule ID 17360 //
     /* 1210515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1210526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1210529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1210532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210554 */     // MIs[0] round
     /* 1210554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210564 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1210567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210589 */     // GIR_Coverage, 17360,
     /* 1210589 */     GIR_EraseRootFromParent_Done,
     /* 1210590 */   // Label 17580: @1210590
     /* 1210590 */   GIM_Try, /*On fail goto*//*Label 17581*/ GIMT_Encode4(1210670), // Rule ID 17361 //
     /* 1210595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1210606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1210609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1210612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210634 */     // MIs[0] round
     /* 1210634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210644 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1210647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210669 */     // GIR_Coverage, 17361,
     /* 1210669 */     GIR_EraseRootFromParent_Done,
     /* 1210670 */   // Label 17581: @1210670
     /* 1210670 */   GIM_Try, /*On fail goto*//*Label 17582*/ GIMT_Encode4(1210750), // Rule ID 17364 //
     /* 1210675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1210686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1210689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1210692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210714 */     // MIs[0] round
     /* 1210714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210724 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1210727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210749 */     // GIR_Coverage, 17364,
     /* 1210749 */     GIR_EraseRootFromParent_Done,
     /* 1210750 */   // Label 17582: @1210750
     /* 1210750 */   GIM_Try, /*On fail goto*//*Label 17583*/ GIMT_Encode4(1210830), // Rule ID 17365 //
     /* 1210755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1210766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1210769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1210772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210794 */     // MIs[0] round
     /* 1210794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210804 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1210807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210829 */     // GIR_Coverage, 17365,
     /* 1210829 */     GIR_EraseRootFromParent_Done,
     /* 1210830 */   // Label 17583: @1210830
     /* 1210830 */   GIM_Try, /*On fail goto*//*Label 17584*/ GIMT_Encode4(1210910), // Rule ID 17368 //
     /* 1210835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1210846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1210849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210874 */     // MIs[0] round
     /* 1210874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210884 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1210887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210909 */     // GIR_Coverage, 17368,
     /* 1210909 */     GIR_EraseRootFromParent_Done,
     /* 1210910 */   // Label 17584: @1210910
     /* 1210910 */   GIM_Try, /*On fail goto*//*Label 17585*/ GIMT_Encode4(1210990), // Rule ID 17369 //
     /* 1210915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1210926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1210929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210954 */     // MIs[0] round
     /* 1210954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210964 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1210967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210989 */     // GIR_Coverage, 17369,
     /* 1210989 */     GIR_EraseRootFromParent_Done,
     /* 1210990 */   // Label 17585: @1210990
     /* 1210990 */   GIM_Try, /*On fail goto*//*Label 17586*/ GIMT_Encode4(1211070), // Rule ID 17372 //
     /* 1210995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1211006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1211009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1211012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211034 */     // MIs[0] round
     /* 1211034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211044 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1211047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211069 */     // GIR_Coverage, 17372,
     /* 1211069 */     GIR_EraseRootFromParent_Done,
     /* 1211070 */   // Label 17586: @1211070
     /* 1211070 */   GIM_Try, /*On fail goto*//*Label 17587*/ GIMT_Encode4(1211150), // Rule ID 17373 //
     /* 1211075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1211078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1211086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1211089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1211092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211114 */     // MIs[0] round
     /* 1211114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211124 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1211127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211149 */     // GIR_Coverage, 17373,
     /* 1211149 */     GIR_EraseRootFromParent_Done,
     /* 1211150 */   // Label 17587: @1211150
     /* 1211150 */   GIM_Try, /*On fail goto*//*Label 17588*/ GIMT_Encode4(1211230), // Rule ID 17376 //
     /* 1211155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1211158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1211166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1211169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1211172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211194 */     // MIs[0] round
     /* 1211194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211204 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1211207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211229 */     // GIR_Coverage, 17376,
     /* 1211229 */     GIR_EraseRootFromParent_Done,
     /* 1211230 */   // Label 17588: @1211230
     /* 1211230 */   GIM_Try, /*On fail goto*//*Label 17589*/ GIMT_Encode4(1211310), // Rule ID 17377 //
     /* 1211235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1211238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1211246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1211249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1211252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211274 */     // MIs[0] round
     /* 1211274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211284 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1211287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211309 */     // GIR_Coverage, 17377,
     /* 1211309 */     GIR_EraseRootFromParent_Done,
     /* 1211310 */   // Label 17589: @1211310
     /* 1211310 */   GIM_Try, /*On fail goto*//*Label 17590*/ GIMT_Encode4(1211390), // Rule ID 17380 //
     /* 1211315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1211326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1211329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1211332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211354 */     // MIs[0] round
     /* 1211354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211364 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1211367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211389 */     // GIR_Coverage, 17380,
     /* 1211389 */     GIR_EraseRootFromParent_Done,
     /* 1211390 */   // Label 17590: @1211390
     /* 1211390 */   GIM_Try, /*On fail goto*//*Label 17591*/ GIMT_Encode4(1211470), // Rule ID 17381 //
     /* 1211395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1211406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1211409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1211412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211434 */     // MIs[0] round
     /* 1211434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211444 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1211447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211469 */     // GIR_Coverage, 17381,
     /* 1211469 */     GIR_EraseRootFromParent_Done,
     /* 1211470 */   // Label 17591: @1211470
     /* 1211470 */   GIM_Try, /*On fail goto*//*Label 17592*/ GIMT_Encode4(1211550), // Rule ID 17384 //
     /* 1211475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1211486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1211489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1211492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211514 */     // MIs[0] round
     /* 1211514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211524 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1211527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211549 */     // GIR_Coverage, 17384,
     /* 1211549 */     GIR_EraseRootFromParent_Done,
     /* 1211550 */   // Label 17592: @1211550
     /* 1211550 */   GIM_Try, /*On fail goto*//*Label 17593*/ GIMT_Encode4(1211630), // Rule ID 17385 //
     /* 1211555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1211566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1211569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1211572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211594 */     // MIs[0] round
     /* 1211594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211604 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1211607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211629 */     // GIR_Coverage, 17385,
     /* 1211629 */     GIR_EraseRootFromParent_Done,
     /* 1211630 */   // Label 17593: @1211630
     /* 1211630 */   GIM_Try, /*On fail goto*//*Label 17594*/ GIMT_Encode4(1211710), // Rule ID 17388 //
     /* 1211635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1211646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1211649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1211652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211674 */     // MIs[0] round
     /* 1211674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211684 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1211687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211709 */     // GIR_Coverage, 17388,
     /* 1211709 */     GIR_EraseRootFromParent_Done,
     /* 1211710 */   // Label 17594: @1211710
     /* 1211710 */   GIM_Try, /*On fail goto*//*Label 17595*/ GIMT_Encode4(1211790), // Rule ID 17389 //
     /* 1211715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1211726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1211729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1211732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211754 */     // MIs[0] round
     /* 1211754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211764 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1211767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211789 */     // GIR_Coverage, 17389,
     /* 1211789 */     GIR_EraseRootFromParent_Done,
     /* 1211790 */   // Label 17595: @1211790
     /* 1211790 */   GIM_Try, /*On fail goto*//*Label 17596*/ GIMT_Encode4(1211870), // Rule ID 17392 //
     /* 1211795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1211806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1211809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211834 */     // MIs[0] round
     /* 1211834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211844 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1211847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211869 */     // GIR_Coverage, 17392,
     /* 1211869 */     GIR_EraseRootFromParent_Done,
     /* 1211870 */   // Label 17596: @1211870
     /* 1211870 */   GIM_Try, /*On fail goto*//*Label 17597*/ GIMT_Encode4(1211950), // Rule ID 17393 //
     /* 1211875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1211886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1211889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211914 */     // MIs[0] round
     /* 1211914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211924 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1211927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211949 */     // GIR_Coverage, 17393,
     /* 1211949 */     GIR_EraseRootFromParent_Done,
     /* 1211950 */   // Label 17597: @1211950
     /* 1211950 */   GIM_Try, /*On fail goto*//*Label 17598*/ GIMT_Encode4(1212030), // Rule ID 17396 //
     /* 1211955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1211966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1211969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1211972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1211975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211994 */     // MIs[0] round
     /* 1211994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212004 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1212007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212029 */     // GIR_Coverage, 17396,
     /* 1212029 */     GIR_EraseRootFromParent_Done,
     /* 1212030 */   // Label 17598: @1212030
     /* 1212030 */   GIM_Try, /*On fail goto*//*Label 17599*/ GIMT_Encode4(1212110), // Rule ID 17397 //
     /* 1212035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1212046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1212049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1212052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1212055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212074 */     // MIs[0] round
     /* 1212074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212084 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1212087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212109 */     // GIR_Coverage, 17397,
     /* 1212109 */     GIR_EraseRootFromParent_Done,
     /* 1212110 */   // Label 17599: @1212110
     /* 1212110 */   GIM_Try, /*On fail goto*//*Label 17600*/ GIMT_Encode4(1212190), // Rule ID 17400 //
     /* 1212115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1212126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1212129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1212132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1212135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212154 */     // MIs[0] round
     /* 1212154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212164 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1212167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212189 */     // GIR_Coverage, 17400,
     /* 1212189 */     GIR_EraseRootFromParent_Done,
     /* 1212190 */   // Label 17600: @1212190
     /* 1212190 */   GIM_Try, /*On fail goto*//*Label 17601*/ GIMT_Encode4(1212270), // Rule ID 17401 //
     /* 1212195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1212206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1212209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1212212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1212215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212234 */     // MIs[0] round
     /* 1212234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212244 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1212247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212269 */     // GIR_Coverage, 17401,
     /* 1212269 */     GIR_EraseRootFromParent_Done,
     /* 1212270 */   // Label 17601: @1212270
     /* 1212270 */   GIM_Try, /*On fail goto*//*Label 17602*/ GIMT_Encode4(1212350), // Rule ID 17404 //
     /* 1212275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1212278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1212286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1212289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1212292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1212295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212314 */     // MIs[0] round
     /* 1212314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212324 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1212327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212349 */     // GIR_Coverage, 17404,
     /* 1212349 */     GIR_EraseRootFromParent_Done,
     /* 1212350 */   // Label 17602: @1212350
     /* 1212350 */   GIM_Try, /*On fail goto*//*Label 17603*/ GIMT_Encode4(1212430), // Rule ID 17405 //
     /* 1212355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1212358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1212366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1212369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1212372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1212375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212394 */     // MIs[0] round
     /* 1212394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212404 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1212407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212429 */     // GIR_Coverage, 17405,
     /* 1212429 */     GIR_EraseRootFromParent_Done,
     /* 1212430 */   // Label 17603: @1212430
     /* 1212430 */   GIM_Try, /*On fail goto*//*Label 17604*/ GIMT_Encode4(1212510), // Rule ID 17408 //
     /* 1212435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1212446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1212449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1212452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1212455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212474 */     // MIs[0] round
     /* 1212474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212484 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1212487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212509 */     // GIR_Coverage, 17408,
     /* 1212509 */     GIR_EraseRootFromParent_Done,
     /* 1212510 */   // Label 17604: @1212510
     /* 1212510 */   GIM_Try, /*On fail goto*//*Label 17605*/ GIMT_Encode4(1212590), // Rule ID 17409 //
     /* 1212515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1212526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1212529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1212532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1212535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212554 */     // MIs[0] round
     /* 1212554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212564 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1212567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212589 */     // GIR_Coverage, 17409,
     /* 1212589 */     GIR_EraseRootFromParent_Done,
     /* 1212590 */   // Label 17605: @1212590
     /* 1212590 */   GIM_Try, /*On fail goto*//*Label 17606*/ GIMT_Encode4(1212670), // Rule ID 17412 //
     /* 1212595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1212598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1212606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1212609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1212615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212634 */     // MIs[0] round
     /* 1212634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212644 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1212647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212669 */     // GIR_Coverage, 17412,
     /* 1212669 */     GIR_EraseRootFromParent_Done,
     /* 1212670 */   // Label 17606: @1212670
     /* 1212670 */   GIM_Try, /*On fail goto*//*Label 17607*/ GIMT_Encode4(1212750), // Rule ID 17413 //
     /* 1212675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1212678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1212686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1212689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1212695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212714 */     // MIs[0] round
     /* 1212714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212724 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1212727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212749 */     // GIR_Coverage, 17413,
     /* 1212749 */     GIR_EraseRootFromParent_Done,
     /* 1212750 */   // Label 17607: @1212750
     /* 1212750 */   GIM_Try, /*On fail goto*//*Label 17608*/ GIMT_Encode4(1212830), // Rule ID 17416 //
     /* 1212755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1212758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1212766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1212769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212794 */     // MIs[0] round
     /* 1212794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212804 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1212807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212829 */     // GIR_Coverage, 17416,
     /* 1212829 */     GIR_EraseRootFromParent_Done,
     /* 1212830 */   // Label 17608: @1212830
     /* 1212830 */   GIM_Try, /*On fail goto*//*Label 17609*/ GIMT_Encode4(1212910), // Rule ID 17417 //
     /* 1212835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1212838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1212846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1212849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212874 */     // MIs[0] round
     /* 1212874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212884 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1212887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212909 */     // GIR_Coverage, 17417,
     /* 1212909 */     GIR_EraseRootFromParent_Done,
     /* 1212910 */   // Label 17609: @1212910
     /* 1212910 */   GIM_Try, /*On fail goto*//*Label 17610*/ GIMT_Encode4(1212990), // Rule ID 17420 //
     /* 1212915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1212926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1212929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1212932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1212935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212954 */     // MIs[0] round
     /* 1212954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212964 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1212967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212989 */     // GIR_Coverage, 17420,
     /* 1212989 */     GIR_EraseRootFromParent_Done,
     /* 1212990 */   // Label 17610: @1212990
     /* 1212990 */   GIM_Try, /*On fail goto*//*Label 17611*/ GIMT_Encode4(1213070), // Rule ID 17421 //
     /* 1212995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1213006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1213009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1213012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1213015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213034 */     // MIs[0] round
     /* 1213034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213044 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1213047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213069 */     // GIR_Coverage, 17421,
     /* 1213069 */     GIR_EraseRootFromParent_Done,
     /* 1213070 */   // Label 17611: @1213070
     /* 1213070 */   GIM_Try, /*On fail goto*//*Label 17612*/ GIMT_Encode4(1213150), // Rule ID 17424 //
     /* 1213075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1213078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1213086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1213089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1213092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1213095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213114 */     // MIs[0] round
     /* 1213114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213124 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1213127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213149 */     // GIR_Coverage, 17424,
     /* 1213149 */     GIR_EraseRootFromParent_Done,
     /* 1213150 */   // Label 17612: @1213150
     /* 1213150 */   GIM_Try, /*On fail goto*//*Label 17613*/ GIMT_Encode4(1213230), // Rule ID 17425 //
     /* 1213155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1213158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1213166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1213169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1213172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1213175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213194 */     // MIs[0] round
     /* 1213194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213204 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1213207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213229 */     // GIR_Coverage, 17425,
     /* 1213229 */     GIR_EraseRootFromParent_Done,
     /* 1213230 */   // Label 17613: @1213230
     /* 1213230 */   GIM_Try, /*On fail goto*//*Label 17614*/ GIMT_Encode4(1213310), // Rule ID 17428 //
     /* 1213235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1213238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1213246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1213249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1213252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1213255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213274 */     // MIs[0] round
     /* 1213274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213284 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1213287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213309 */     // GIR_Coverage, 17428,
     /* 1213309 */     GIR_EraseRootFromParent_Done,
     /* 1213310 */   // Label 17614: @1213310
     /* 1213310 */   GIM_Try, /*On fail goto*//*Label 17615*/ GIMT_Encode4(1213390), // Rule ID 17429 //
     /* 1213315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1213318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1213326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1213329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1213332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1213335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213354 */     // MIs[0] round
     /* 1213354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213364 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1213367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213389 */     // GIR_Coverage, 17429,
     /* 1213389 */     GIR_EraseRootFromParent_Done,
     /* 1213390 */   // Label 17615: @1213390
     /* 1213390 */   GIM_Try, /*On fail goto*//*Label 17616*/ GIMT_Encode4(1213470), // Rule ID 17432 //
     /* 1213395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1213406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1213409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1213412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1213415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213434 */     // MIs[0] round
     /* 1213434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213444 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1213447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213469 */     // GIR_Coverage, 17432,
     /* 1213469 */     GIR_EraseRootFromParent_Done,
     /* 1213470 */   // Label 17616: @1213470
     /* 1213470 */   GIM_Try, /*On fail goto*//*Label 17617*/ GIMT_Encode4(1213550), // Rule ID 17433 //
     /* 1213475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1213486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1213489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1213492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1213495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213514 */     // MIs[0] round
     /* 1213514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213524 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1213527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213549 */     // GIR_Coverage, 17433,
     /* 1213549 */     GIR_EraseRootFromParent_Done,
     /* 1213550 */   // Label 17617: @1213550
     /* 1213550 */   GIM_Try, /*On fail goto*//*Label 17618*/ GIMT_Encode4(1213630), // Rule ID 17436 //
     /* 1213555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1213566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1213569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1213572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1213575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213594 */     // MIs[0] round
     /* 1213594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213604 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1213607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213629 */     // GIR_Coverage, 17436,
     /* 1213629 */     GIR_EraseRootFromParent_Done,
     /* 1213630 */   // Label 17618: @1213630
     /* 1213630 */   GIM_Try, /*On fail goto*//*Label 17619*/ GIMT_Encode4(1213710), // Rule ID 17437 //
     /* 1213635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1213646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1213649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1213652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1213655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213674 */     // MIs[0] round
     /* 1213674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213684 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1213687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213709 */     // GIR_Coverage, 17437,
     /* 1213709 */     GIR_EraseRootFromParent_Done,
     /* 1213710 */   // Label 17619: @1213710
     /* 1213710 */   GIM_Try, /*On fail goto*//*Label 17620*/ GIMT_Encode4(1213790), // Rule ID 17440 //
     /* 1213715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1213735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213754 */     // MIs[0] round
     /* 1213754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213764 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1213767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213789 */     // GIR_Coverage, 17440,
     /* 1213789 */     GIR_EraseRootFromParent_Done,
     /* 1213790 */   // Label 17620: @1213790
     /* 1213790 */   GIM_Try, /*On fail goto*//*Label 17621*/ GIMT_Encode4(1213870), // Rule ID 17441 //
     /* 1213795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1213815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213834 */     // MIs[0] round
     /* 1213834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213844 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1213847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213869 */     // GIR_Coverage, 17441,
     /* 1213869 */     GIR_EraseRootFromParent_Done,
     /* 1213870 */   // Label 17621: @1213870
     /* 1213870 */   GIM_Try, /*On fail goto*//*Label 17622*/ GIMT_Encode4(1213950), // Rule ID 17444 //
     /* 1213875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1213895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213914 */     // MIs[0] round
     /* 1213914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213924 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1213927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213949 */     // GIR_Coverage, 17444,
     /* 1213949 */     GIR_EraseRootFromParent_Done,
     /* 1213950 */   // Label 17622: @1213950
     /* 1213950 */   GIM_Try, /*On fail goto*//*Label 17623*/ GIMT_Encode4(1214030), // Rule ID 17445 //
     /* 1213955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1213975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213994 */     // MIs[0] round
     /* 1213994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214004 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1214007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214029 */     // GIR_Coverage, 17445,
     /* 1214029 */     GIR_EraseRootFromParent_Done,
     /* 1214030 */   // Label 17623: @1214030
     /* 1214030 */   GIM_Try, /*On fail goto*//*Label 17624*/ GIMT_Encode4(1214110), // Rule ID 17448 //
     /* 1214035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1214038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1214046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1214049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1214052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1214055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214074 */     // MIs[0] round
     /* 1214074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214084 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1214087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214109 */     // GIR_Coverage, 17448,
     /* 1214109 */     GIR_EraseRootFromParent_Done,
     /* 1214110 */   // Label 17624: @1214110
     /* 1214110 */   GIM_Try, /*On fail goto*//*Label 17625*/ GIMT_Encode4(1214190), // Rule ID 17449 //
     /* 1214115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1214118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1214126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1214129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1214132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1214135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214154 */     // MIs[0] round
     /* 1214154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214164 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1214167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214189 */     // GIR_Coverage, 17449,
     /* 1214189 */     GIR_EraseRootFromParent_Done,
     /* 1214190 */   // Label 17625: @1214190
     /* 1214190 */   GIM_Try, /*On fail goto*//*Label 17626*/ GIMT_Encode4(1214270), // Rule ID 17452 //
     /* 1214195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1214198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1214206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1214209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1214212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1214215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214234 */     // MIs[0] round
     /* 1214234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214244 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1214247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214269 */     // GIR_Coverage, 17452,
     /* 1214269 */     GIR_EraseRootFromParent_Done,
     /* 1214270 */   // Label 17626: @1214270
     /* 1214270 */   GIM_Try, /*On fail goto*//*Label 17627*/ GIMT_Encode4(1214350), // Rule ID 17453 //
     /* 1214275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1214278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1214286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1214289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1214292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1214295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214314 */     // MIs[0] round
     /* 1214314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214324 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1214327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214349 */     // GIR_Coverage, 17453,
     /* 1214349 */     GIR_EraseRootFromParent_Done,
     /* 1214350 */   // Label 17627: @1214350
     /* 1214350 */   GIM_Try, /*On fail goto*//*Label 17628*/ GIMT_Encode4(1214430), // Rule ID 17456 //
     /* 1214355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1214366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1214369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1214372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214394 */     // MIs[0] round
     /* 1214394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214404 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1214407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214429 */     // GIR_Coverage, 17456,
     /* 1214429 */     GIR_EraseRootFromParent_Done,
     /* 1214430 */   // Label 17628: @1214430
     /* 1214430 */   GIM_Try, /*On fail goto*//*Label 17629*/ GIMT_Encode4(1214510), // Rule ID 17457 //
     /* 1214435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1214446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1214449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1214452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214474 */     // MIs[0] round
     /* 1214474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214484 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1214487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214509 */     // GIR_Coverage, 17457,
     /* 1214509 */     GIR_EraseRootFromParent_Done,
     /* 1214510 */   // Label 17629: @1214510
     /* 1214510 */   GIM_Try, /*On fail goto*//*Label 17630*/ GIMT_Encode4(1214590), // Rule ID 17460 //
     /* 1214515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1214526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1214529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1214532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214554 */     // MIs[0] round
     /* 1214554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214564 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1214567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214589 */     // GIR_Coverage, 17460,
     /* 1214589 */     GIR_EraseRootFromParent_Done,
     /* 1214590 */   // Label 17630: @1214590
     /* 1214590 */   GIM_Try, /*On fail goto*//*Label 17631*/ GIMT_Encode4(1214670), // Rule ID 17461 //
     /* 1214595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1214606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1214609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1214612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214634 */     // MIs[0] round
     /* 1214634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214644 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1214647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214669 */     // GIR_Coverage, 17461,
     /* 1214669 */     GIR_EraseRootFromParent_Done,
     /* 1214670 */   // Label 17631: @1214670
     /* 1214670 */   GIM_Try, /*On fail goto*//*Label 17632*/ GIMT_Encode4(1214750), // Rule ID 17464 //
     /* 1214675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1214678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1214686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1214689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1214692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214714 */     // MIs[0] round
     /* 1214714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214724 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1214727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214749 */     // GIR_Coverage, 17464,
     /* 1214749 */     GIR_EraseRootFromParent_Done,
     /* 1214750 */   // Label 17632: @1214750
     /* 1214750 */   GIM_Try, /*On fail goto*//*Label 17633*/ GIMT_Encode4(1214830), // Rule ID 17465 //
     /* 1214755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1214758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1214766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1214769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1214772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214794 */     // MIs[0] round
     /* 1214794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214804 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1214807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214829 */     // GIR_Coverage, 17465,
     /* 1214829 */     GIR_EraseRootFromParent_Done,
     /* 1214830 */   // Label 17633: @1214830
     /* 1214830 */   GIM_Try, /*On fail goto*//*Label 17634*/ GIMT_Encode4(1214910), // Rule ID 17468 //
     /* 1214835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1214846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1214849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1214852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214874 */     // MIs[0] round
     /* 1214874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214884 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1214887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214909 */     // GIR_Coverage, 17468,
     /* 1214909 */     GIR_EraseRootFromParent_Done,
     /* 1214910 */   // Label 17634: @1214910
     /* 1214910 */   GIM_Try, /*On fail goto*//*Label 17635*/ GIMT_Encode4(1214990), // Rule ID 17469 //
     /* 1214915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1214926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1214929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1214932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214954 */     // MIs[0] round
     /* 1214954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214964 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1214967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214989 */     // GIR_Coverage, 17469,
     /* 1214989 */     GIR_EraseRootFromParent_Done,
     /* 1214990 */   // Label 17635: @1214990
     /* 1214990 */   GIM_Try, /*On fail goto*//*Label 17636*/ GIMT_Encode4(1215070), // Rule ID 17472 //
     /* 1214995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1214998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1215006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1215009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1215012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215034 */     // MIs[0] round
     /* 1215034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215044 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1215047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215069 */     // GIR_Coverage, 17472,
     /* 1215069 */     GIR_EraseRootFromParent_Done,
     /* 1215070 */   // Label 17636: @1215070
     /* 1215070 */   GIM_Try, /*On fail goto*//*Label 17637*/ GIMT_Encode4(1215150), // Rule ID 17473 //
     /* 1215075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1215086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1215089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1215092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215114 */     // MIs[0] round
     /* 1215114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215124 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1215127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215149 */     // GIR_Coverage, 17473,
     /* 1215149 */     GIR_EraseRootFromParent_Done,
     /* 1215150 */   // Label 17637: @1215150
     /* 1215150 */   GIM_Try, /*On fail goto*//*Label 17638*/ GIMT_Encode4(1215230), // Rule ID 17476 //
     /* 1215155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1215158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1215166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1215169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1215172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215194 */     // MIs[0] round
     /* 1215194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215204 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1215207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215229 */     // GIR_Coverage, 17476,
     /* 1215229 */     GIR_EraseRootFromParent_Done,
     /* 1215230 */   // Label 17638: @1215230
     /* 1215230 */   GIM_Try, /*On fail goto*//*Label 17639*/ GIMT_Encode4(1215310), // Rule ID 17477 //
     /* 1215235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1215238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1215246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1215249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1215252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215274 */     // MIs[0] round
     /* 1215274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215284 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1215287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215309 */     // GIR_Coverage, 17477,
     /* 1215309 */     GIR_EraseRootFromParent_Done,
     /* 1215310 */   // Label 17639: @1215310
     /* 1215310 */   GIM_Try, /*On fail goto*//*Label 17640*/ GIMT_Encode4(1215390), // Rule ID 17480 //
     /* 1215315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1215326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1215329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1215332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215354 */     // MIs[0] round
     /* 1215354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215364 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1215367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215389 */     // GIR_Coverage, 17480,
     /* 1215389 */     GIR_EraseRootFromParent_Done,
     /* 1215390 */   // Label 17640: @1215390
     /* 1215390 */   GIM_Try, /*On fail goto*//*Label 17641*/ GIMT_Encode4(1215470), // Rule ID 17481 //
     /* 1215395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1215406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1215409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1215412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215434 */     // MIs[0] round
     /* 1215434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215444 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1215447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215469 */     // GIR_Coverage, 17481,
     /* 1215469 */     GIR_EraseRootFromParent_Done,
     /* 1215470 */   // Label 17641: @1215470
     /* 1215470 */   GIM_Try, /*On fail goto*//*Label 17642*/ GIMT_Encode4(1215550), // Rule ID 17484 //
     /* 1215475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1215486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1215489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1215492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215514 */     // MIs[0] round
     /* 1215514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215524 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1215527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215549 */     // GIR_Coverage, 17484,
     /* 1215549 */     GIR_EraseRootFromParent_Done,
     /* 1215550 */   // Label 17642: @1215550
     /* 1215550 */   GIM_Try, /*On fail goto*//*Label 17643*/ GIMT_Encode4(1215630), // Rule ID 17485 //
     /* 1215555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1215566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1215569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1215572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215594 */     // MIs[0] round
     /* 1215594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215604 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1215607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215629 */     // GIR_Coverage, 17485,
     /* 1215629 */     GIR_EraseRootFromParent_Done,
     /* 1215630 */   // Label 17643: @1215630
     /* 1215630 */   GIM_Try, /*On fail goto*//*Label 17644*/ GIMT_Encode4(1215710), // Rule ID 17488 //
     /* 1215635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1215646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1215649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1215652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215674 */     // MIs[0] round
     /* 1215674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215684 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1215687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215709 */     // GIR_Coverage, 17488,
     /* 1215709 */     GIR_EraseRootFromParent_Done,
     /* 1215710 */   // Label 17644: @1215710
     /* 1215710 */   GIM_Try, /*On fail goto*//*Label 17645*/ GIMT_Encode4(1215790), // Rule ID 17489 //
     /* 1215715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1215726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1215729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1215732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215754 */     // MIs[0] round
     /* 1215754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215764 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1215767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215789 */     // GIR_Coverage, 17489,
     /* 1215789 */     GIR_EraseRootFromParent_Done,
     /* 1215790 */   // Label 17645: @1215790
     /* 1215790 */   GIM_Try, /*On fail goto*//*Label 17646*/ GIMT_Encode4(1215870), // Rule ID 17492 //
     /* 1215795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1215806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1215809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1215812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215834 */     // MIs[0] round
     /* 1215834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215844 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1215847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215869 */     // GIR_Coverage, 17492,
     /* 1215869 */     GIR_EraseRootFromParent_Done,
     /* 1215870 */   // Label 17646: @1215870
     /* 1215870 */   GIM_Try, /*On fail goto*//*Label 17647*/ GIMT_Encode4(1215950), // Rule ID 17493 //
     /* 1215875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1215886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1215889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1215892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215914 */     // MIs[0] round
     /* 1215914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215924 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1215927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215949 */     // GIR_Coverage, 17493,
     /* 1215949 */     GIR_EraseRootFromParent_Done,
     /* 1215950 */   // Label 17647: @1215950
     /* 1215950 */   GIM_Try, /*On fail goto*//*Label 17648*/ GIMT_Encode4(1216030), // Rule ID 17496 //
     /* 1215955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1215966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1215969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1215972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215994 */     // MIs[0] round
     /* 1215994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216004 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1216007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216029 */     // GIR_Coverage, 17496,
     /* 1216029 */     GIR_EraseRootFromParent_Done,
     /* 1216030 */   // Label 17648: @1216030
     /* 1216030 */   GIM_Try, /*On fail goto*//*Label 17649*/ GIMT_Encode4(1216110), // Rule ID 17497 //
     /* 1216035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1216038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1216046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1216049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1216052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1216055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1216074 */     // MIs[0] round
     /* 1216074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216084 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1216087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216109 */     // GIR_Coverage, 17497,
     /* 1216109 */     GIR_EraseRootFromParent_Done,
     /* 1216110 */   // Label 17649: @1216110
     /* 1216110 */   GIM_Try, /*On fail goto*//*Label 17650*/ GIMT_Encode4(1216190), // Rule ID 17500 //
     /* 1216115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1216118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1216126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1216129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1216132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1216135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1216154 */     // MIs[0] round
     /* 1216154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216164 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1216167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216189 */     // GIR_Coverage, 17500,
     /* 1216189 */     GIR_EraseRootFromParent_Done,
     /* 1216190 */   // Label 17650: @1216190
     /* 1216190 */   GIM_Try, /*On fail goto*//*Label 17651*/ GIMT_Encode4(1216270), // Rule ID 17501 //
     /* 1216195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1216198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1216206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1216209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1216212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1216215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1216234 */     // MIs[0] round
     /* 1216234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216244 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1216247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216269 */     // GIR_Coverage, 17501,
     /* 1216269 */     GIR_EraseRootFromParent_Done,
     /* 1216270 */   // Label 17651: @1216270
     /* 1216270 */   GIM_Try, /*On fail goto*//*Label 17652*/ GIMT_Encode4(1216350), // Rule ID 17504 //
     /* 1216275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1216278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1216286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1216289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1216292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216314 */     // MIs[0] round
     /* 1216314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216324 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1216327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216349 */     // GIR_Coverage, 17504,
     /* 1216349 */     GIR_EraseRootFromParent_Done,
     /* 1216350 */   // Label 17652: @1216350
     /* 1216350 */   GIM_Try, /*On fail goto*//*Label 17653*/ GIMT_Encode4(1216430), // Rule ID 17505 //
     /* 1216355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1216366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1216369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1216372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216394 */     // MIs[0] round
     /* 1216394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216404 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1216407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216429 */     // GIR_Coverage, 17505,
     /* 1216429 */     GIR_EraseRootFromParent_Done,
     /* 1216430 */   // Label 17653: @1216430
     /* 1216430 */   GIM_Try, /*On fail goto*//*Label 17654*/ GIMT_Encode4(1216510), // Rule ID 17508 //
     /* 1216435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1216438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1216446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1216449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1216452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216474 */     // MIs[0] round
     /* 1216474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216484 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1216487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216509 */     // GIR_Coverage, 17508,
     /* 1216509 */     GIR_EraseRootFromParent_Done,
     /* 1216510 */   // Label 17654: @1216510
     /* 1216510 */   GIM_Try, /*On fail goto*//*Label 17655*/ GIMT_Encode4(1216590), // Rule ID 17509 //
     /* 1216515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1216526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1216529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1216532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216554 */     // MIs[0] round
     /* 1216554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216564 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1216567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216589 */     // GIR_Coverage, 17509,
     /* 1216589 */     GIR_EraseRootFromParent_Done,
     /* 1216590 */   // Label 17655: @1216590
     /* 1216590 */   GIM_Try, /*On fail goto*//*Label 17656*/ GIMT_Encode4(1216670), // Rule ID 17512 //
     /* 1216595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1216598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1216606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1216609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1216612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216634 */     // MIs[0] round
     /* 1216634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216644 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1216647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216669 */     // GIR_Coverage, 17512,
     /* 1216669 */     GIR_EraseRootFromParent_Done,
     /* 1216670 */   // Label 17656: @1216670
     /* 1216670 */   GIM_Try, /*On fail goto*//*Label 17657*/ GIMT_Encode4(1216750), // Rule ID 17513 //
     /* 1216675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1216686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1216689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1216692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216714 */     // MIs[0] round
     /* 1216714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216724 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1216727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216749 */     // GIR_Coverage, 17513,
     /* 1216749 */     GIR_EraseRootFromParent_Done,
     /* 1216750 */   // Label 17657: @1216750
     /* 1216750 */   GIM_Try, /*On fail goto*//*Label 17658*/ GIMT_Encode4(1216830), // Rule ID 17516 //
     /* 1216755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1216766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1216769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1216772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1216775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216794 */     // MIs[0] round
     /* 1216794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216804 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1216807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216829 */     // GIR_Coverage, 17516,
     /* 1216829 */     GIR_EraseRootFromParent_Done,
     /* 1216830 */   // Label 17658: @1216830
     /* 1216830 */   GIM_Try, /*On fail goto*//*Label 17659*/ GIMT_Encode4(1216910), // Rule ID 17517 //
     /* 1216835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1216846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1216849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1216852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1216855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216874 */     // MIs[0] round
     /* 1216874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216884 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1216887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216909 */     // GIR_Coverage, 17517,
     /* 1216909 */     GIR_EraseRootFromParent_Done,
     /* 1216910 */   // Label 17659: @1216910
     /* 1216910 */   GIM_Try, /*On fail goto*//*Label 17660*/ GIMT_Encode4(1216990), // Rule ID 17520 //
     /* 1216915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1216926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1216929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1216932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1216935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216954 */     // MIs[0] round
     /* 1216954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216964 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1216967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216989 */     // GIR_Coverage, 17520,
     /* 1216989 */     GIR_EraseRootFromParent_Done,
     /* 1216990 */   // Label 17660: @1216990
     /* 1216990 */   GIM_Try, /*On fail goto*//*Label 17661*/ GIMT_Encode4(1217070), // Rule ID 17521 //
     /* 1216995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1217006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1217009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1217012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1217015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217034 */     // MIs[0] round
     /* 1217034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217044 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1217047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217069 */     // GIR_Coverage, 17521,
     /* 1217069 */     GIR_EraseRootFromParent_Done,
     /* 1217070 */   // Label 17661: @1217070
     /* 1217070 */   GIM_Try, /*On fail goto*//*Label 17662*/ GIMT_Encode4(1217150), // Rule ID 17524 //
     /* 1217075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1217086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1217089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1217092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1217095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217114 */     // MIs[0] round
     /* 1217114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217124 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1217127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217149 */     // GIR_Coverage, 17524,
     /* 1217149 */     GIR_EraseRootFromParent_Done,
     /* 1217150 */   // Label 17662: @1217150
     /* 1217150 */   GIM_Try, /*On fail goto*//*Label 17663*/ GIMT_Encode4(1217230), // Rule ID 17525 //
     /* 1217155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1217166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1217169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1217172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1217175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217194 */     // MIs[0] round
     /* 1217194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217204 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1217207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217229 */     // GIR_Coverage, 17525,
     /* 1217229 */     GIR_EraseRootFromParent_Done,
     /* 1217230 */   // Label 17663: @1217230
     /* 1217230 */   GIM_Try, /*On fail goto*//*Label 17664*/ GIMT_Encode4(1217310), // Rule ID 17528 //
     /* 1217235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1217246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1217249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1217252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1217255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217274 */     // MIs[0] round
     /* 1217274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217284 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1217287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217309 */     // GIR_Coverage, 17528,
     /* 1217309 */     GIR_EraseRootFromParent_Done,
     /* 1217310 */   // Label 17664: @1217310
     /* 1217310 */   GIM_Try, /*On fail goto*//*Label 17665*/ GIMT_Encode4(1217390), // Rule ID 17529 //
     /* 1217315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1217326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1217329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1217332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1217335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217354 */     // MIs[0] round
     /* 1217354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217364 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1217367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217389 */     // GIR_Coverage, 17529,
     /* 1217389 */     GIR_EraseRootFromParent_Done,
     /* 1217390 */   // Label 17665: @1217390
     /* 1217390 */   GIM_Try, /*On fail goto*//*Label 17666*/ GIMT_Encode4(1217470), // Rule ID 17532 //
     /* 1217395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1217406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1217409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1217412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1217415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217434 */     // MIs[0] round
     /* 1217434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217444 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1217447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217469 */     // GIR_Coverage, 17532,
     /* 1217469 */     GIR_EraseRootFromParent_Done,
     /* 1217470 */   // Label 17666: @1217470
     /* 1217470 */   GIM_Try, /*On fail goto*//*Label 17667*/ GIMT_Encode4(1217550), // Rule ID 17533 //
     /* 1217475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1217486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1217489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1217492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1217495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217514 */     // MIs[0] round
     /* 1217514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1217527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217549 */     // GIR_Coverage, 17533,
     /* 1217549 */     GIR_EraseRootFromParent_Done,
     /* 1217550 */   // Label 17667: @1217550
     /* 1217550 */   GIM_Try, /*On fail goto*//*Label 17668*/ GIMT_Encode4(1217630), // Rule ID 17536 //
     /* 1217555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1217558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1217566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1217569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1217572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1217575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217594 */     // MIs[0] round
     /* 1217594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217604 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1217607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217629 */     // GIR_Coverage, 17536,
     /* 1217629 */     GIR_EraseRootFromParent_Done,
     /* 1217630 */   // Label 17668: @1217630
     /* 1217630 */   GIM_Try, /*On fail goto*//*Label 17669*/ GIMT_Encode4(1217710), // Rule ID 17537 //
     /* 1217635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1217638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1217646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1217649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1217652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1217655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217674 */     // MIs[0] round
     /* 1217674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217684 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1217687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217709 */     // GIR_Coverage, 17537,
     /* 1217709 */     GIR_EraseRootFromParent_Done,
     /* 1217710 */   // Label 17669: @1217710
     /* 1217710 */   GIM_Try, /*On fail goto*//*Label 17670*/ GIMT_Encode4(1217790), // Rule ID 17540 //
     /* 1217715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1217726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1217729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1217735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217754 */     // MIs[0] round
     /* 1217754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217764 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1217767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217789 */     // GIR_Coverage, 17540,
     /* 1217789 */     GIR_EraseRootFromParent_Done,
     /* 1217790 */   // Label 17670: @1217790
     /* 1217790 */   GIM_Try, /*On fail goto*//*Label 17671*/ GIMT_Encode4(1217870), // Rule ID 17541 //
     /* 1217795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1217806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1217809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1217815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217834 */     // MIs[0] round
     /* 1217834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217844 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1217847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217869 */     // GIR_Coverage, 17541,
     /* 1217869 */     GIR_EraseRootFromParent_Done,
     /* 1217870 */   // Label 17671: @1217870
     /* 1217870 */   GIM_Try, /*On fail goto*//*Label 17672*/ GIMT_Encode4(1217950), // Rule ID 17544 //
     /* 1217875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1217886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1217889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1217895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217914 */     // MIs[0] round
     /* 1217914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217924 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1217927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217949 */     // GIR_Coverage, 17544,
     /* 1217949 */     GIR_EraseRootFromParent_Done,
     /* 1217950 */   // Label 17672: @1217950
     /* 1217950 */   GIM_Try, /*On fail goto*//*Label 17673*/ GIMT_Encode4(1218030), // Rule ID 17545 //
     /* 1217955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1217966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1217969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1217975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217994 */     // MIs[0] round
     /* 1217994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218004 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1218007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218029 */     // GIR_Coverage, 17545,
     /* 1218029 */     GIR_EraseRootFromParent_Done,
     /* 1218030 */   // Label 17673: @1218030
     /* 1218030 */   GIM_Try, /*On fail goto*//*Label 17674*/ GIMT_Encode4(1218110), // Rule ID 17548 //
     /* 1218035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1218038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1218046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1218049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1218052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1218055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218074 */     // MIs[0] round
     /* 1218074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218084 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1218087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218109 */     // GIR_Coverage, 17548,
     /* 1218109 */     GIR_EraseRootFromParent_Done,
     /* 1218110 */   // Label 17674: @1218110
     /* 1218110 */   GIM_Try, /*On fail goto*//*Label 17675*/ GIMT_Encode4(1218190), // Rule ID 17549 //
     /* 1218115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1218118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1218126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1218129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1218132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1218135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218154 */     // MIs[0] round
     /* 1218154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218164 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1218167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218189 */     // GIR_Coverage, 17549,
     /* 1218189 */     GIR_EraseRootFromParent_Done,
     /* 1218190 */   // Label 17675: @1218190
     /* 1218190 */   GIM_Try, /*On fail goto*//*Label 17676*/ GIMT_Encode4(1218270), // Rule ID 17552 //
     /* 1218195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1218206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1218209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1218212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1218215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218234 */     // MIs[0] round
     /* 1218234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218244 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1218247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218269 */     // GIR_Coverage, 17552,
     /* 1218269 */     GIR_EraseRootFromParent_Done,
     /* 1218270 */   // Label 17676: @1218270
     /* 1218270 */   GIM_Try, /*On fail goto*//*Label 17677*/ GIMT_Encode4(1218350), // Rule ID 17553 //
     /* 1218275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1218286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1218289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1218292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1218295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218314 */     // MIs[0] round
     /* 1218314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218324 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1218327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218349 */     // GIR_Coverage, 17553,
     /* 1218349 */     GIR_EraseRootFromParent_Done,
     /* 1218350 */   // Label 17677: @1218350
     /* 1218350 */   GIM_Try, /*On fail goto*//*Label 17678*/ GIMT_Encode4(1218430), // Rule ID 17556 //
     /* 1218355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1218366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1218369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1218372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1218375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218394 */     // MIs[0] round
     /* 1218394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218404 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1218407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218429 */     // GIR_Coverage, 17556,
     /* 1218429 */     GIR_EraseRootFromParent_Done,
     /* 1218430 */   // Label 17678: @1218430
     /* 1218430 */   GIM_Try, /*On fail goto*//*Label 17679*/ GIMT_Encode4(1218510), // Rule ID 17557 //
     /* 1218435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1218446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1218449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1218452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1218455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218474 */     // MIs[0] round
     /* 1218474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218484 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1218487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218509 */     // GIR_Coverage, 17557,
     /* 1218509 */     GIR_EraseRootFromParent_Done,
     /* 1218510 */   // Label 17679: @1218510
     /* 1218510 */   GIM_Try, /*On fail goto*//*Label 17680*/ GIMT_Encode4(1218590), // Rule ID 17560 //
     /* 1218515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1218526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1218529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1218532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1218535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218554 */     // MIs[0] round
     /* 1218554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218564 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1218567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218589 */     // GIR_Coverage, 17560,
     /* 1218589 */     GIR_EraseRootFromParent_Done,
     /* 1218590 */   // Label 17680: @1218590
     /* 1218590 */   GIM_Try, /*On fail goto*//*Label 17681*/ GIMT_Encode4(1218670), // Rule ID 17561 //
     /* 1218595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1218606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1218609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1218612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1218615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218634 */     // MIs[0] round
     /* 1218634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218644 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1218647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218669 */     // GIR_Coverage, 17561,
     /* 1218669 */     GIR_EraseRootFromParent_Done,
     /* 1218670 */   // Label 17681: @1218670
     /* 1218670 */   GIM_Try, /*On fail goto*//*Label 17682*/ GIMT_Encode4(1218750), // Rule ID 17564 //
     /* 1218675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1218686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1218689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1218692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1218695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218714 */     // MIs[0] round
     /* 1218714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218724 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1218727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218749 */     // GIR_Coverage, 17564,
     /* 1218749 */     GIR_EraseRootFromParent_Done,
     /* 1218750 */   // Label 17682: @1218750
     /* 1218750 */   GIM_Try, /*On fail goto*//*Label 17683*/ GIMT_Encode4(1218830), // Rule ID 17565 //
     /* 1218755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1218766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1218769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1218772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1218775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218794 */     // MIs[0] round
     /* 1218794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218804 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1218807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218829 */     // GIR_Coverage, 17565,
     /* 1218829 */     GIR_EraseRootFromParent_Done,
     /* 1218830 */   // Label 17683: @1218830
     /* 1218830 */   GIM_Try, /*On fail goto*//*Label 17684*/ GIMT_Encode4(1218910), // Rule ID 17568 //
     /* 1218835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1218846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1218849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1218855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218874 */     // MIs[0] round
     /* 1218874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218884 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1218887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218909 */     // GIR_Coverage, 17568,
     /* 1218909 */     GIR_EraseRootFromParent_Done,
     /* 1218910 */   // Label 17684: @1218910
     /* 1218910 */   GIM_Try, /*On fail goto*//*Label 17685*/ GIMT_Encode4(1218990), // Rule ID 17569 //
     /* 1218915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1218926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1218929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1218935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218954 */     // MIs[0] round
     /* 1218954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218964 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1218967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218989 */     // GIR_Coverage, 17569,
     /* 1218989 */     GIR_EraseRootFromParent_Done,
     /* 1218990 */   // Label 17685: @1218990
     /* 1218990 */   GIM_Try, /*On fail goto*//*Label 17686*/ GIMT_Encode4(1219070), // Rule ID 17572 //
     /* 1218995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1219006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1219009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1219012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1219015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219034 */     // MIs[0] round
     /* 1219034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219044 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1219047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219069 */     // GIR_Coverage, 17572,
     /* 1219069 */     GIR_EraseRootFromParent_Done,
     /* 1219070 */   // Label 17686: @1219070
     /* 1219070 */   GIM_Try, /*On fail goto*//*Label 17687*/ GIMT_Encode4(1219150), // Rule ID 17573 //
     /* 1219075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1219078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1219086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1219089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1219092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1219095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219114 */     // MIs[0] round
     /* 1219114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219124 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1219127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219149 */     // GIR_Coverage, 17573,
     /* 1219149 */     GIR_EraseRootFromParent_Done,
     /* 1219150 */   // Label 17687: @1219150
     /* 1219150 */   GIM_Try, /*On fail goto*//*Label 17688*/ GIMT_Encode4(1219230), // Rule ID 17576 //
     /* 1219155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1219166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1219169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1219172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219194 */     // MIs[0] round
     /* 1219194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219204 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1219207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219229 */     // GIR_Coverage, 17576,
     /* 1219229 */     GIR_EraseRootFromParent_Done,
     /* 1219230 */   // Label 17688: @1219230
     /* 1219230 */   GIM_Try, /*On fail goto*//*Label 17689*/ GIMT_Encode4(1219310), // Rule ID 17577 //
     /* 1219235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1219246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1219249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1219252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219274 */     // MIs[0] round
     /* 1219274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219284 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1219287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219309 */     // GIR_Coverage, 17577,
     /* 1219309 */     GIR_EraseRootFromParent_Done,
     /* 1219310 */   // Label 17689: @1219310
     /* 1219310 */   GIM_Try, /*On fail goto*//*Label 17690*/ GIMT_Encode4(1219390), // Rule ID 17580 //
     /* 1219315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1219326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1219329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1219332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219354 */     // MIs[0] round
     /* 1219354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219364 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1219367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219389 */     // GIR_Coverage, 17580,
     /* 1219389 */     GIR_EraseRootFromParent_Done,
     /* 1219390 */   // Label 17690: @1219390
     /* 1219390 */   GIM_Try, /*On fail goto*//*Label 17691*/ GIMT_Encode4(1219470), // Rule ID 17581 //
     /* 1219395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1219406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1219409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1219412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219434 */     // MIs[0] round
     /* 1219434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219444 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1219447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219469 */     // GIR_Coverage, 17581,
     /* 1219469 */     GIR_EraseRootFromParent_Done,
     /* 1219470 */   // Label 17691: @1219470
     /* 1219470 */   GIM_Try, /*On fail goto*//*Label 17692*/ GIMT_Encode4(1219550), // Rule ID 17584 //
     /* 1219475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1219486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1219489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1219492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219514 */     // MIs[0] round
     /* 1219514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219524 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1219527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219549 */     // GIR_Coverage, 17584,
     /* 1219549 */     GIR_EraseRootFromParent_Done,
     /* 1219550 */   // Label 17692: @1219550
     /* 1219550 */   GIM_Try, /*On fail goto*//*Label 17693*/ GIMT_Encode4(1219630), // Rule ID 17585 //
     /* 1219555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1219566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1219569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1219572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219594 */     // MIs[0] round
     /* 1219594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219604 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1219607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219629 */     // GIR_Coverage, 17585,
     /* 1219629 */     GIR_EraseRootFromParent_Done,
     /* 1219630 */   // Label 17693: @1219630
     /* 1219630 */   GIM_Try, /*On fail goto*//*Label 17694*/ GIMT_Encode4(1219710), // Rule ID 17588 //
     /* 1219635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1219646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1219649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1219652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219674 */     // MIs[0] round
     /* 1219674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219684 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1219687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219709 */     // GIR_Coverage, 17588,
     /* 1219709 */     GIR_EraseRootFromParent_Done,
     /* 1219710 */   // Label 17694: @1219710
     /* 1219710 */   GIM_Try, /*On fail goto*//*Label 17695*/ GIMT_Encode4(1219790), // Rule ID 17589 //
     /* 1219715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1219726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1219729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1219732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219754 */     // MIs[0] round
     /* 1219754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219764 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1219767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219789 */     // GIR_Coverage, 17589,
     /* 1219789 */     GIR_EraseRootFromParent_Done,
     /* 1219790 */   // Label 17695: @1219790
     /* 1219790 */   GIM_Try, /*On fail goto*//*Label 17696*/ GIMT_Encode4(1219870), // Rule ID 17592 //
     /* 1219795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219834 */     // MIs[0] round
     /* 1219834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219844 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1219847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219869 */     // GIR_Coverage, 17592,
     /* 1219869 */     GIR_EraseRootFromParent_Done,
     /* 1219870 */   // Label 17696: @1219870
     /* 1219870 */   GIM_Try, /*On fail goto*//*Label 17697*/ GIMT_Encode4(1219950), // Rule ID 17593 //
     /* 1219875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219914 */     // MIs[0] round
     /* 1219914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219924 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1219927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219949 */     // GIR_Coverage, 17593,
     /* 1219949 */     GIR_EraseRootFromParent_Done,
     /* 1219950 */   // Label 17697: @1219950
     /* 1219950 */   GIM_Try, /*On fail goto*//*Label 17698*/ GIMT_Encode4(1220030), // Rule ID 17596 //
     /* 1219955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1219958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1219966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1219969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1219972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1219994 */     // MIs[0] round
     /* 1219994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220004 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1220007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220029 */     // GIR_Coverage, 17596,
     /* 1220029 */     GIR_EraseRootFromParent_Done,
     /* 1220030 */   // Label 17698: @1220030
     /* 1220030 */   GIM_Try, /*On fail goto*//*Label 17699*/ GIMT_Encode4(1220110), // Rule ID 17597 //
     /* 1220035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1220038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1220046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1220049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1220052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220074 */     // MIs[0] round
     /* 1220074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220084 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1220087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220109 */     // GIR_Coverage, 17597,
     /* 1220109 */     GIR_EraseRootFromParent_Done,
     /* 1220110 */   // Label 17699: @1220110
     /* 1220110 */   GIM_Try, /*On fail goto*//*Label 17700*/ GIMT_Encode4(1220190), // Rule ID 17600 //
     /* 1220115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1220118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1220126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1220129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1220132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220154 */     // MIs[0] round
     /* 1220154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220164 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1220167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220189 */     // GIR_Coverage, 17600,
     /* 1220189 */     GIR_EraseRootFromParent_Done,
     /* 1220190 */   // Label 17700: @1220190
     /* 1220190 */   GIM_Try, /*On fail goto*//*Label 17701*/ GIMT_Encode4(1220270), // Rule ID 17601 //
     /* 1220195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1220198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1220206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1220209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1220212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220234 */     // MIs[0] round
     /* 1220234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220244 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1220247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220269 */     // GIR_Coverage, 17601,
     /* 1220269 */     GIR_EraseRootFromParent_Done,
     /* 1220270 */   // Label 17701: @1220270
     /* 1220270 */   GIM_Try, /*On fail goto*//*Label 17702*/ GIMT_Encode4(1220350), // Rule ID 17604 //
     /* 1220275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1220278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1220286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1220289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1220292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220314 */     // MIs[0] round
     /* 1220314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220324 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1220327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220349 */     // GIR_Coverage, 17604,
     /* 1220349 */     GIR_EraseRootFromParent_Done,
     /* 1220350 */   // Label 17702: @1220350
     /* 1220350 */   GIM_Try, /*On fail goto*//*Label 17703*/ GIMT_Encode4(1220430), // Rule ID 17605 //
     /* 1220355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1220358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1220366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1220369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1220372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220394 */     // MIs[0] round
     /* 1220394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220404 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1220407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220429 */     // GIR_Coverage, 17605,
     /* 1220429 */     GIR_EraseRootFromParent_Done,
     /* 1220430 */   // Label 17703: @1220430
     /* 1220430 */   GIM_Try, /*On fail goto*//*Label 17704*/ GIMT_Encode4(1220510), // Rule ID 17608 //
     /* 1220435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1220438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1220446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1220449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1220452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220474 */     // MIs[0] round
     /* 1220474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220484 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1220487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220509 */     // GIR_Coverage, 17608,
     /* 1220509 */     GIR_EraseRootFromParent_Done,
     /* 1220510 */   // Label 17704: @1220510
     /* 1220510 */   GIM_Try, /*On fail goto*//*Label 17705*/ GIMT_Encode4(1220590), // Rule ID 17609 //
     /* 1220515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1220518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1220526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1220529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1220532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220554 */     // MIs[0] round
     /* 1220554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220564 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1220567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220589 */     // GIR_Coverage, 17609,
     /* 1220589 */     GIR_EraseRootFromParent_Done,
     /* 1220590 */   // Label 17705: @1220590
     /* 1220590 */   GIM_Try, /*On fail goto*//*Label 17706*/ GIMT_Encode4(1220670), // Rule ID 17612 //
     /* 1220595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1220606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1220609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1220612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220634 */     // MIs[0] round
     /* 1220634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220644 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1220647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220669 */     // GIR_Coverage, 17612,
     /* 1220669 */     GIR_EraseRootFromParent_Done,
     /* 1220670 */   // Label 17706: @1220670
     /* 1220670 */   GIM_Try, /*On fail goto*//*Label 17707*/ GIMT_Encode4(1220750), // Rule ID 17613 //
     /* 1220675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1220686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1220689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1220692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220714 */     // MIs[0] round
     /* 1220714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220724 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1220727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220749 */     // GIR_Coverage, 17613,
     /* 1220749 */     GIR_EraseRootFromParent_Done,
     /* 1220750 */   // Label 17707: @1220750
     /* 1220750 */   GIM_Try, /*On fail goto*//*Label 17708*/ GIMT_Encode4(1220830), // Rule ID 17616 //
     /* 1220755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1220766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1220769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1220772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220794 */     // MIs[0] round
     /* 1220794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220804 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1220807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220829 */     // GIR_Coverage, 17616,
     /* 1220829 */     GIR_EraseRootFromParent_Done,
     /* 1220830 */   // Label 17708: @1220830
     /* 1220830 */   GIM_Try, /*On fail goto*//*Label 17709*/ GIMT_Encode4(1220910), // Rule ID 17617 //
     /* 1220835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1220846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1220849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1220852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220874 */     // MIs[0] round
     /* 1220874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220884 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1220887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220909 */     // GIR_Coverage, 17617,
     /* 1220909 */     GIR_EraseRootFromParent_Done,
     /* 1220910 */   // Label 17709: @1220910
     /* 1220910 */   GIM_Try, /*On fail goto*//*Label 17710*/ GIMT_Encode4(1220990), // Rule ID 17620 //
     /* 1220915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1220926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1220929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1220932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220954 */     // MIs[0] round
     /* 1220954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220964 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1220967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220989 */     // GIR_Coverage, 17620,
     /* 1220989 */     GIR_EraseRootFromParent_Done,
     /* 1220990 */   // Label 17710: @1220990
     /* 1220990 */   GIM_Try, /*On fail goto*//*Label 17711*/ GIMT_Encode4(1221070), // Rule ID 17621 //
     /* 1220995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1221006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1221009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1221012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221034 */     // MIs[0] round
     /* 1221034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221044 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1221047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221069 */     // GIR_Coverage, 17621,
     /* 1221069 */     GIR_EraseRootFromParent_Done,
     /* 1221070 */   // Label 17711: @1221070
     /* 1221070 */   GIM_Try, /*On fail goto*//*Label 17712*/ GIMT_Encode4(1221150), // Rule ID 17624 //
     /* 1221075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1221078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1221086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1221089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1221092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221114 */     // MIs[0] round
     /* 1221114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221124 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1221127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221149 */     // GIR_Coverage, 17624,
     /* 1221149 */     GIR_EraseRootFromParent_Done,
     /* 1221150 */   // Label 17712: @1221150
     /* 1221150 */   GIM_Try, /*On fail goto*//*Label 17713*/ GIMT_Encode4(1221230), // Rule ID 17625 //
     /* 1221155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1221158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1221166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1221169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1221172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221194 */     // MIs[0] round
     /* 1221194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221204 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1221207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221229 */     // GIR_Coverage, 17625,
     /* 1221229 */     GIR_EraseRootFromParent_Done,
     /* 1221230 */   // Label 17713: @1221230
     /* 1221230 */   GIM_Try, /*On fail goto*//*Label 17714*/ GIMT_Encode4(1221310), // Rule ID 17628 //
     /* 1221235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1221238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1221246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1221249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1221252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221274 */     // MIs[0] round
     /* 1221274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221284 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1221287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221309 */     // GIR_Coverage, 17628,
     /* 1221309 */     GIR_EraseRootFromParent_Done,
     /* 1221310 */   // Label 17714: @1221310
     /* 1221310 */   GIM_Try, /*On fail goto*//*Label 17715*/ GIMT_Encode4(1221390), // Rule ID 17629 //
     /* 1221315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1221318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1221326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1221329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1221332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221354 */     // MIs[0] round
     /* 1221354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221364 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1221367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221389 */     // GIR_Coverage, 17629,
     /* 1221389 */     GIR_EraseRootFromParent_Done,
     /* 1221390 */   // Label 17715: @1221390
     /* 1221390 */   GIM_Try, /*On fail goto*//*Label 17716*/ GIMT_Encode4(1221470), // Rule ID 17632 //
     /* 1221395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1221398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1221406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1221409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1221412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221434 */     // MIs[0] round
     /* 1221434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221444 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1221447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221469 */     // GIR_Coverage, 17632,
     /* 1221469 */     GIR_EraseRootFromParent_Done,
     /* 1221470 */   // Label 17716: @1221470
     /* 1221470 */   GIM_Try, /*On fail goto*//*Label 17717*/ GIMT_Encode4(1221550), // Rule ID 17633 //
     /* 1221475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1221478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1221486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1221489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1221492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221514 */     // MIs[0] round
     /* 1221514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221524 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1221527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221549 */     // GIR_Coverage, 17633,
     /* 1221549 */     GIR_EraseRootFromParent_Done,
     /* 1221550 */   // Label 17717: @1221550
     /* 1221550 */   GIM_Try, /*On fail goto*//*Label 17718*/ GIMT_Encode4(1221630), // Rule ID 17636 //
     /* 1221555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1221566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1221569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1221572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221594 */     // MIs[0] round
     /* 1221594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221604 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1221607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221629 */     // GIR_Coverage, 17636,
     /* 1221629 */     GIR_EraseRootFromParent_Done,
     /* 1221630 */   // Label 17718: @1221630
     /* 1221630 */   GIM_Try, /*On fail goto*//*Label 17719*/ GIMT_Encode4(1221710), // Rule ID 17637 //
     /* 1221635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1221646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1221649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1221652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221674 */     // MIs[0] round
     /* 1221674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221684 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1221687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221709 */     // GIR_Coverage, 17637,
     /* 1221709 */     GIR_EraseRootFromParent_Done,
     /* 1221710 */   // Label 17719: @1221710
     /* 1221710 */   GIM_Try, /*On fail goto*//*Label 17720*/ GIMT_Encode4(1221790), // Rule ID 17640 //
     /* 1221715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1221726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1221729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1221732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221754 */     // MIs[0] round
     /* 1221754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221764 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1221767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221789 */     // GIR_Coverage, 17640,
     /* 1221789 */     GIR_EraseRootFromParent_Done,
     /* 1221790 */   // Label 17720: @1221790
     /* 1221790 */   GIM_Try, /*On fail goto*//*Label 17721*/ GIMT_Encode4(1221870), // Rule ID 17641 //
     /* 1221795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1221806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1221809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1221812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221834 */     // MIs[0] round
     /* 1221834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221844 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1221847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221869 */     // GIR_Coverage, 17641,
     /* 1221869 */     GIR_EraseRootFromParent_Done,
     /* 1221870 */   // Label 17721: @1221870
     /* 1221870 */   GIM_Try, /*On fail goto*//*Label 17722*/ GIMT_Encode4(1221950), // Rule ID 17644 //
     /* 1221875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1221878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1221886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1221889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221914 */     // MIs[0] round
     /* 1221914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221924 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1221927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221949 */     // GIR_Coverage, 17644,
     /* 1221949 */     GIR_EraseRootFromParent_Done,
     /* 1221950 */   // Label 17722: @1221950
     /* 1221950 */   GIM_Try, /*On fail goto*//*Label 17723*/ GIMT_Encode4(1222030), // Rule ID 17645 //
     /* 1221955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1221958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1221966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1221969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221994 */     // MIs[0] round
     /* 1221994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222004 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1222007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222029 */     // GIR_Coverage, 17645,
     /* 1222029 */     GIR_EraseRootFromParent_Done,
     /* 1222030 */   // Label 17723: @1222030
     /* 1222030 */   GIM_Try, /*On fail goto*//*Label 17724*/ GIMT_Encode4(1222110), // Rule ID 17648 //
     /* 1222035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1222046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1222049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1222052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222074 */     // MIs[0] round
     /* 1222074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222084 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1222087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222109 */     // GIR_Coverage, 17648,
     /* 1222109 */     GIR_EraseRootFromParent_Done,
     /* 1222110 */   // Label 17724: @1222110
     /* 1222110 */   GIM_Try, /*On fail goto*//*Label 17725*/ GIMT_Encode4(1222190), // Rule ID 17649 //
     /* 1222115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1222126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1222129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1222132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222154 */     // MIs[0] round
     /* 1222154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222164 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1222167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222189 */     // GIR_Coverage, 17649,
     /* 1222189 */     GIR_EraseRootFromParent_Done,
     /* 1222190 */   // Label 17725: @1222190
     /* 1222190 */   GIM_Try, /*On fail goto*//*Label 17726*/ GIMT_Encode4(1222270), // Rule ID 17652 //
     /* 1222195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1222206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1222209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1222212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222234 */     // MIs[0] round
     /* 1222234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1222247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222269 */     // GIR_Coverage, 17652,
     /* 1222269 */     GIR_EraseRootFromParent_Done,
     /* 1222270 */   // Label 17726: @1222270
     /* 1222270 */   GIM_Try, /*On fail goto*//*Label 17727*/ GIMT_Encode4(1222350), // Rule ID 17653 //
     /* 1222275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1222286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1222289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1222292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222314 */     // MIs[0] round
     /* 1222314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222324 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1222327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222349 */     // GIR_Coverage, 17653,
     /* 1222349 */     GIR_EraseRootFromParent_Done,
     /* 1222350 */   // Label 17727: @1222350
     /* 1222350 */   GIM_Try, /*On fail goto*//*Label 17728*/ GIMT_Encode4(1222430), // Rule ID 17656 //
     /* 1222355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1222358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1222366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1222369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1222372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1222394 */     // MIs[0] round
     /* 1222394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222404 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1222407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222429 */     // GIR_Coverage, 17656,
     /* 1222429 */     GIR_EraseRootFromParent_Done,
     /* 1222430 */   // Label 17728: @1222430
     /* 1222430 */   GIM_Try, /*On fail goto*//*Label 17729*/ GIMT_Encode4(1222510), // Rule ID 17657 //
     /* 1222435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1222438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1222446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1222449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1222452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1222474 */     // MIs[0] round
     /* 1222474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222484 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1222487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222509 */     // GIR_Coverage, 17657,
     /* 1222509 */     GIR_EraseRootFromParent_Done,
     /* 1222510 */   // Label 17729: @1222510
     /* 1222510 */   GIM_Try, /*On fail goto*//*Label 17730*/ GIMT_Encode4(1222590), // Rule ID 17660 //
     /* 1222515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1222526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1222529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1222532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222554 */     // MIs[0] round
     /* 1222554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222564 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1222567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222589 */     // GIR_Coverage, 17660,
     /* 1222589 */     GIR_EraseRootFromParent_Done,
     /* 1222590 */   // Label 17730: @1222590
     /* 1222590 */   GIM_Try, /*On fail goto*//*Label 17731*/ GIMT_Encode4(1222670), // Rule ID 17661 //
     /* 1222595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1222606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1222609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1222612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222634 */     // MIs[0] round
     /* 1222634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222644 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1222647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222669 */     // GIR_Coverage, 17661,
     /* 1222669 */     GIR_EraseRootFromParent_Done,
     /* 1222670 */   // Label 17731: @1222670
     /* 1222670 */   GIM_Try, /*On fail goto*//*Label 17732*/ GIMT_Encode4(1222750), // Rule ID 17664 //
     /* 1222675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1222686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1222689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1222692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222714 */     // MIs[0] round
     /* 1222714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222724 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1222727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222749 */     // GIR_Coverage, 17664,
     /* 1222749 */     GIR_EraseRootFromParent_Done,
     /* 1222750 */   // Label 17732: @1222750
     /* 1222750 */   GIM_Try, /*On fail goto*//*Label 17733*/ GIMT_Encode4(1222830), // Rule ID 17665 //
     /* 1222755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1222766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1222769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1222772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222794 */     // MIs[0] round
     /* 1222794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222804 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1222807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222829 */     // GIR_Coverage, 17665,
     /* 1222829 */     GIR_EraseRootFromParent_Done,
     /* 1222830 */   // Label 17733: @1222830
     /* 1222830 */   GIM_Try, /*On fail goto*//*Label 17734*/ GIMT_Encode4(1222910), // Rule ID 17668 //
     /* 1222835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1222846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1222849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1222852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222874 */     // MIs[0] round
     /* 1222874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222884 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1222887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222909 */     // GIR_Coverage, 17668,
     /* 1222909 */     GIR_EraseRootFromParent_Done,
     /* 1222910 */   // Label 17734: @1222910
     /* 1222910 */   GIM_Try, /*On fail goto*//*Label 17735*/ GIMT_Encode4(1222990), // Rule ID 17669 //
     /* 1222915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1222926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1222929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1222932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222954 */     // MIs[0] round
     /* 1222954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222964 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1222967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222989 */     // GIR_Coverage, 17669,
     /* 1222989 */     GIR_EraseRootFromParent_Done,
     /* 1222990 */   // Label 17735: @1222990
     /* 1222990 */   GIM_Try, /*On fail goto*//*Label 17736*/ GIMT_Encode4(1223070), // Rule ID 17672 //
     /* 1222995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1223006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1223009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1223012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223034 */     // MIs[0] round
     /* 1223034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223044 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1223047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223069 */     // GIR_Coverage, 17672,
     /* 1223069 */     GIR_EraseRootFromParent_Done,
     /* 1223070 */   // Label 17736: @1223070
     /* 1223070 */   GIM_Try, /*On fail goto*//*Label 17737*/ GIMT_Encode4(1223150), // Rule ID 17673 //
     /* 1223075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1223078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1223086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1223089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1223092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223114 */     // MIs[0] round
     /* 1223114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223124 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1223127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223149 */     // GIR_Coverage, 17673,
     /* 1223149 */     GIR_EraseRootFromParent_Done,
     /* 1223150 */   // Label 17737: @1223150
     /* 1223150 */   GIM_Try, /*On fail goto*//*Label 17738*/ GIMT_Encode4(1223230), // Rule ID 17676 //
     /* 1223155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1223158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1223166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1223169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1223172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223194 */     // MIs[0] round
     /* 1223194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223204 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1223207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223229 */     // GIR_Coverage, 17676,
     /* 1223229 */     GIR_EraseRootFromParent_Done,
     /* 1223230 */   // Label 17738: @1223230
     /* 1223230 */   GIM_Try, /*On fail goto*//*Label 17739*/ GIMT_Encode4(1223310), // Rule ID 17677 //
     /* 1223235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1223238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1223246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1223249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1223252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223274 */     // MIs[0] round
     /* 1223274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223284 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1223287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223309 */     // GIR_Coverage, 17677,
     /* 1223309 */     GIR_EraseRootFromParent_Done,
     /* 1223310 */   // Label 17739: @1223310
     /* 1223310 */   GIM_Try, /*On fail goto*//*Label 17740*/ GIMT_Encode4(1223390), // Rule ID 17680 //
     /* 1223315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1223318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1223326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1223329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1223332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223354 */     // MIs[0] round
     /* 1223354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223364 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1223367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223389 */     // GIR_Coverage, 17680,
     /* 1223389 */     GIR_EraseRootFromParent_Done,
     /* 1223390 */   // Label 17740: @1223390
     /* 1223390 */   GIM_Try, /*On fail goto*//*Label 17741*/ GIMT_Encode4(1223470), // Rule ID 17681 //
     /* 1223395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1223398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1223406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1223409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1223412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223434 */     // MIs[0] round
     /* 1223434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223444 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1223447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223469 */     // GIR_Coverage, 17681,
     /* 1223469 */     GIR_EraseRootFromParent_Done,
     /* 1223470 */   // Label 17741: @1223470
     /* 1223470 */   GIM_Try, /*On fail goto*//*Label 17742*/ GIMT_Encode4(1223550), // Rule ID 17684 //
     /* 1223475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1223486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1223489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1223492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223514 */     // MIs[0] round
     /* 1223514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223524 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1223527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223549 */     // GIR_Coverage, 17684,
     /* 1223549 */     GIR_EraseRootFromParent_Done,
     /* 1223550 */   // Label 17742: @1223550
     /* 1223550 */   GIM_Try, /*On fail goto*//*Label 17743*/ GIMT_Encode4(1223630), // Rule ID 17685 //
     /* 1223555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1223566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1223569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1223572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223594 */     // MIs[0] round
     /* 1223594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223604 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1223607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223629 */     // GIR_Coverage, 17685,
     /* 1223629 */     GIR_EraseRootFromParent_Done,
     /* 1223630 */   // Label 17743: @1223630
     /* 1223630 */   GIM_Try, /*On fail goto*//*Label 17744*/ GIMT_Encode4(1223710), // Rule ID 17688 //
     /* 1223635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1223646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1223649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1223652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223674 */     // MIs[0] round
     /* 1223674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223684 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1223687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223709 */     // GIR_Coverage, 17688,
     /* 1223709 */     GIR_EraseRootFromParent_Done,
     /* 1223710 */   // Label 17744: @1223710
     /* 1223710 */   GIM_Try, /*On fail goto*//*Label 17745*/ GIMT_Encode4(1223790), // Rule ID 17689 //
     /* 1223715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1223726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1223729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1223732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223754 */     // MIs[0] round
     /* 1223754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223764 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1223767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223789 */     // GIR_Coverage, 17689,
     /* 1223789 */     GIR_EraseRootFromParent_Done,
     /* 1223790 */   // Label 17745: @1223790
     /* 1223790 */   GIM_Try, /*On fail goto*//*Label 17746*/ GIMT_Encode4(1223870), // Rule ID 17692 //
     /* 1223795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1223806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1223809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1223812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223834 */     // MIs[0] round
     /* 1223834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223844 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1223847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223869 */     // GIR_Coverage, 17692,
     /* 1223869 */     GIR_EraseRootFromParent_Done,
     /* 1223870 */   // Label 17746: @1223870
     /* 1223870 */   GIM_Try, /*On fail goto*//*Label 17747*/ GIMT_Encode4(1223950), // Rule ID 17693 //
     /* 1223875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1223886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1223889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1223892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223914 */     // MIs[0] round
     /* 1223914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223924 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1223927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223949 */     // GIR_Coverage, 17693,
     /* 1223949 */     GIR_EraseRootFromParent_Done,
     /* 1223950 */   // Label 17747: @1223950
     /* 1223950 */   GIM_Try, /*On fail goto*//*Label 17748*/ GIMT_Encode4(1224030), // Rule ID 17696 //
     /* 1223955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1223966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1223969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1223972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1223975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223994 */     // MIs[0] round
     /* 1223994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224004 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1224007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224029 */     // GIR_Coverage, 17696,
     /* 1224029 */     GIR_EraseRootFromParent_Done,
     /* 1224030 */   // Label 17748: @1224030
     /* 1224030 */   GIM_Try, /*On fail goto*//*Label 17749*/ GIMT_Encode4(1224110), // Rule ID 17697 //
     /* 1224035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1224046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1224049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1224052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1224055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224074 */     // MIs[0] round
     /* 1224074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224084 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1224087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224109 */     // GIR_Coverage, 17697,
     /* 1224109 */     GIR_EraseRootFromParent_Done,
     /* 1224110 */   // Label 17749: @1224110
     /* 1224110 */   GIM_Try, /*On fail goto*//*Label 17750*/ GIMT_Encode4(1224190), // Rule ID 17700 //
     /* 1224115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1224126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1224129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1224132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1224135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224154 */     // MIs[0] round
     /* 1224154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224164 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1224167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224189 */     // GIR_Coverage, 17700,
     /* 1224189 */     GIR_EraseRootFromParent_Done,
     /* 1224190 */   // Label 17750: @1224190
     /* 1224190 */   GIM_Try, /*On fail goto*//*Label 17751*/ GIMT_Encode4(1224270), // Rule ID 17701 //
     /* 1224195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1224206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1224209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1224212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1224215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224234 */     // MIs[0] round
     /* 1224234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1224247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224269 */     // GIR_Coverage, 17701,
     /* 1224269 */     GIR_EraseRootFromParent_Done,
     /* 1224270 */   // Label 17751: @1224270
     /* 1224270 */   GIM_Try, /*On fail goto*//*Label 17752*/ GIMT_Encode4(1224350), // Rule ID 17704 //
     /* 1224275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1224286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1224289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1224292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1224295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224314 */     // MIs[0] round
     /* 1224314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224324 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1224327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224349 */     // GIR_Coverage, 17704,
     /* 1224349 */     GIR_EraseRootFromParent_Done,
     /* 1224350 */   // Label 17752: @1224350
     /* 1224350 */   GIM_Try, /*On fail goto*//*Label 17753*/ GIMT_Encode4(1224430), // Rule ID 17705 //
     /* 1224355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1224366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1224369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1224372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1224375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224394 */     // MIs[0] round
     /* 1224394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224404 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1224407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224429 */     // GIR_Coverage, 17705,
     /* 1224429 */     GIR_EraseRootFromParent_Done,
     /* 1224430 */   // Label 17753: @1224430
     /* 1224430 */   GIM_Try, /*On fail goto*//*Label 17754*/ GIMT_Encode4(1224510), // Rule ID 17708 //
     /* 1224435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1224446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1224449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1224452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1224455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224474 */     // MIs[0] round
     /* 1224474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224484 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1224487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224509 */     // GIR_Coverage, 17708,
     /* 1224509 */     GIR_EraseRootFromParent_Done,
     /* 1224510 */   // Label 17754: @1224510
     /* 1224510 */   GIM_Try, /*On fail goto*//*Label 17755*/ GIMT_Encode4(1224590), // Rule ID 17709 //
     /* 1224515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1224526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1224529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1224532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1224535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224554 */     // MIs[0] round
     /* 1224554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224564 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1224567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224589 */     // GIR_Coverage, 17709,
     /* 1224589 */     GIR_EraseRootFromParent_Done,
     /* 1224590 */   // Label 17755: @1224590
     /* 1224590 */   GIM_Try, /*On fail goto*//*Label 17756*/ GIMT_Encode4(1224670), // Rule ID 17712 //
     /* 1224595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1224606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1224609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1224612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1224615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224634 */     // MIs[0] round
     /* 1224634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224644 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1224647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224669 */     // GIR_Coverage, 17712,
     /* 1224669 */     GIR_EraseRootFromParent_Done,
     /* 1224670 */   // Label 17756: @1224670
     /* 1224670 */   GIM_Try, /*On fail goto*//*Label 17757*/ GIMT_Encode4(1224750), // Rule ID 17713 //
     /* 1224675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1224686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1224689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1224692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1224695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224714 */     // MIs[0] round
     /* 1224714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224724 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1224727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224749 */     // GIR_Coverage, 17713,
     /* 1224749 */     GIR_EraseRootFromParent_Done,
     /* 1224750 */   // Label 17757: @1224750
     /* 1224750 */   GIM_Try, /*On fail goto*//*Label 17758*/ GIMT_Encode4(1224830), // Rule ID 17716 //
     /* 1224755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1224766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1224769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1224772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1224775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224794 */     // MIs[0] round
     /* 1224794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224804 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1224807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224829 */     // GIR_Coverage, 17716,
     /* 1224829 */     GIR_EraseRootFromParent_Done,
     /* 1224830 */   // Label 17758: @1224830
     /* 1224830 */   GIM_Try, /*On fail goto*//*Label 17759*/ GIMT_Encode4(1224910), // Rule ID 17717 //
     /* 1224835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1224846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1224849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1224852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1224855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224874 */     // MIs[0] round
     /* 1224874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224884 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1224887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224909 */     // GIR_Coverage, 17717,
     /* 1224909 */     GIR_EraseRootFromParent_Done,
     /* 1224910 */   // Label 17759: @1224910
     /* 1224910 */   GIM_Try, /*On fail goto*//*Label 17760*/ GIMT_Encode4(1224990), // Rule ID 17720 //
     /* 1224915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1224926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1224929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1224932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1224935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224954 */     // MIs[0] round
     /* 1224954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224964 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1224967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224989 */     // GIR_Coverage, 17720,
     /* 1224989 */     GIR_EraseRootFromParent_Done,
     /* 1224990 */   // Label 17760: @1224990
     /* 1224990 */   GIM_Try, /*On fail goto*//*Label 17761*/ GIMT_Encode4(1225070), // Rule ID 17721 //
     /* 1224995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1225006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1225009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1225012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1225015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225034 */     // MIs[0] round
     /* 1225034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225044 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1225047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225069 */     // GIR_Coverage, 17721,
     /* 1225069 */     GIR_EraseRootFromParent_Done,
     /* 1225070 */   // Label 17761: @1225070
     /* 1225070 */   GIM_Try, /*On fail goto*//*Label 17762*/ GIMT_Encode4(1225150), // Rule ID 17724 //
     /* 1225075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1225078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1225086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1225089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1225092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1225095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225114 */     // MIs[0] round
     /* 1225114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225124 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1225127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225149 */     // GIR_Coverage, 17724,
     /* 1225149 */     GIR_EraseRootFromParent_Done,
     /* 1225150 */   // Label 17762: @1225150
     /* 1225150 */   GIM_Try, /*On fail goto*//*Label 17763*/ GIMT_Encode4(1225230), // Rule ID 17725 //
     /* 1225155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1225158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1225166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1225169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1225172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1225175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225194 */     // MIs[0] round
     /* 1225194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225204 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1225207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225229 */     // GIR_Coverage, 17725,
     /* 1225229 */     GIR_EraseRootFromParent_Done,
     /* 1225230 */   // Label 17763: @1225230
     /* 1225230 */   GIM_Try, /*On fail goto*//*Label 17764*/ GIMT_Encode4(1225310), // Rule ID 17728 //
     /* 1225235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1225238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1225246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1225249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1225252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1225255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225274 */     // MIs[0] round
     /* 1225274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225284 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1225287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225309 */     // GIR_Coverage, 17728,
     /* 1225309 */     GIR_EraseRootFromParent_Done,
     /* 1225310 */   // Label 17764: @1225310
     /* 1225310 */   GIM_Try, /*On fail goto*//*Label 17765*/ GIMT_Encode4(1225390), // Rule ID 17729 //
     /* 1225315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1225318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1225326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1225329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1225332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1225335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225354 */     // MIs[0] round
     /* 1225354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225364 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1225367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225389 */     // GIR_Coverage, 17729,
     /* 1225389 */     GIR_EraseRootFromParent_Done,
     /* 1225390 */   // Label 17765: @1225390
     /* 1225390 */   GIM_Try, /*On fail goto*//*Label 17766*/ GIMT_Encode4(1225470), // Rule ID 17732 //
     /* 1225395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1225406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1225409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1225412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225434 */     // MIs[0] round
     /* 1225434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225444 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1225447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225469 */     // GIR_Coverage, 17732,
     /* 1225469 */     GIR_EraseRootFromParent_Done,
     /* 1225470 */   // Label 17766: @1225470
     /* 1225470 */   GIM_Try, /*On fail goto*//*Label 17767*/ GIMT_Encode4(1225550), // Rule ID 17733 //
     /* 1225475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1225486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1225489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1225492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225514 */     // MIs[0] round
     /* 1225514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225524 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1225527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225549 */     // GIR_Coverage, 17733,
     /* 1225549 */     GIR_EraseRootFromParent_Done,
     /* 1225550 */   // Label 17767: @1225550
     /* 1225550 */   GIM_Try, /*On fail goto*//*Label 17768*/ GIMT_Encode4(1225630), // Rule ID 17736 //
     /* 1225555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1225572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225594 */     // MIs[0] round
     /* 1225594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225604 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1225607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225629 */     // GIR_Coverage, 17736,
     /* 1225629 */     GIR_EraseRootFromParent_Done,
     /* 1225630 */   // Label 17768: @1225630
     /* 1225630 */   GIM_Try, /*On fail goto*//*Label 17769*/ GIMT_Encode4(1225710), // Rule ID 17737 //
     /* 1225635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1225652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225674 */     // MIs[0] round
     /* 1225674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225684 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1225687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225709 */     // GIR_Coverage, 17737,
     /* 1225709 */     GIR_EraseRootFromParent_Done,
     /* 1225710 */   // Label 17769: @1225710
     /* 1225710 */   GIM_Try, /*On fail goto*//*Label 17770*/ GIMT_Encode4(1225790), // Rule ID 17740 //
     /* 1225715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1225726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1225729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1225732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225754 */     // MIs[0] round
     /* 1225754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225764 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1225767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225789 */     // GIR_Coverage, 17740,
     /* 1225789 */     GIR_EraseRootFromParent_Done,
     /* 1225790 */   // Label 17770: @1225790
     /* 1225790 */   GIM_Try, /*On fail goto*//*Label 17771*/ GIMT_Encode4(1225870), // Rule ID 17741 //
     /* 1225795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1225806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1225809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1225812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225834 */     // MIs[0] round
     /* 1225834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225844 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1225847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225869 */     // GIR_Coverage, 17741,
     /* 1225869 */     GIR_EraseRootFromParent_Done,
     /* 1225870 */   // Label 17771: @1225870
     /* 1225870 */   GIM_Try, /*On fail goto*//*Label 17772*/ GIMT_Encode4(1225950), // Rule ID 17744 //
     /* 1225875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1225886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1225889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1225892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225914 */     // MIs[0] round
     /* 1225914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225924 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1225927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225949 */     // GIR_Coverage, 17744,
     /* 1225949 */     GIR_EraseRootFromParent_Done,
     /* 1225950 */   // Label 17772: @1225950
     /* 1225950 */   GIM_Try, /*On fail goto*//*Label 17773*/ GIMT_Encode4(1226030), // Rule ID 17745 //
     /* 1225955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1225966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1225969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1225972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225994 */     // MIs[0] round
     /* 1225994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226004 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1226007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226029 */     // GIR_Coverage, 17745,
     /* 1226029 */     GIR_EraseRootFromParent_Done,
     /* 1226030 */   // Label 17773: @1226030
     /* 1226030 */   GIM_Try, /*On fail goto*//*Label 17774*/ GIMT_Encode4(1226110), // Rule ID 17748 //
     /* 1226035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1226038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1226046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1226049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1226052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1226055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1226074 */     // MIs[0] round
     /* 1226074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226084 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1226087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226109 */     // GIR_Coverage, 17748,
     /* 1226109 */     GIR_EraseRootFromParent_Done,
     /* 1226110 */   // Label 17774: @1226110
     /* 1226110 */   GIM_Try, /*On fail goto*//*Label 17775*/ GIMT_Encode4(1226190), // Rule ID 17749 //
     /* 1226115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1226118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1226126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1226129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1226132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1226135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1226154 */     // MIs[0] round
     /* 1226154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226164 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1226167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226189 */     // GIR_Coverage, 17749,
     /* 1226189 */     GIR_EraseRootFromParent_Done,
     /* 1226190 */   // Label 17775: @1226190
     /* 1226190 */   GIM_Try, /*On fail goto*//*Label 17776*/ GIMT_Encode4(1226270), // Rule ID 17752 //
     /* 1226195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1226198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226234 */     // MIs[0] round
     /* 1226234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226244 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1226247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226269 */     // GIR_Coverage, 17752,
     /* 1226269 */     GIR_EraseRootFromParent_Done,
     /* 1226270 */   // Label 17776: @1226270
     /* 1226270 */   GIM_Try, /*On fail goto*//*Label 17777*/ GIMT_Encode4(1226350), // Rule ID 17753 //
     /* 1226275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1226278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226314 */     // MIs[0] round
     /* 1226314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226324 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1226327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226349 */     // GIR_Coverage, 17753,
     /* 1226349 */     GIR_EraseRootFromParent_Done,
     /* 1226350 */   // Label 17777: @1226350
     /* 1226350 */   GIM_Try, /*On fail goto*//*Label 17778*/ GIMT_Encode4(1226430), // Rule ID 17756 //
     /* 1226355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1226358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1226366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1226369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226394 */     // MIs[0] round
     /* 1226394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226404 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1226407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226429 */     // GIR_Coverage, 17756,
     /* 1226429 */     GIR_EraseRootFromParent_Done,
     /* 1226430 */   // Label 17778: @1226430
     /* 1226430 */   GIM_Try, /*On fail goto*//*Label 17779*/ GIMT_Encode4(1226510), // Rule ID 17757 //
     /* 1226435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1226438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1226446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1226449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226474 */     // MIs[0] round
     /* 1226474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226484 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1226487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226509 */     // GIR_Coverage, 17757,
     /* 1226509 */     GIR_EraseRootFromParent_Done,
     /* 1226510 */   // Label 17779: @1226510
     /* 1226510 */   GIM_Try, /*On fail goto*//*Label 17780*/ GIMT_Encode4(1226590), // Rule ID 17760 //
     /* 1226515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1226518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1226526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1226529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1226532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226554 */     // MIs[0] round
     /* 1226554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226564 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1226567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226589 */     // GIR_Coverage, 17760,
     /* 1226589 */     GIR_EraseRootFromParent_Done,
     /* 1226590 */   // Label 17780: @1226590
     /* 1226590 */   GIM_Try, /*On fail goto*//*Label 17781*/ GIMT_Encode4(1226670), // Rule ID 17761 //
     /* 1226595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1226598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1226606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1226609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1226612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226634 */     // MIs[0] round
     /* 1226634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226644 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1226647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226669 */     // GIR_Coverage, 17761,
     /* 1226669 */     GIR_EraseRootFromParent_Done,
     /* 1226670 */   // Label 17781: @1226670
     /* 1226670 */   GIM_Try, /*On fail goto*//*Label 17782*/ GIMT_Encode4(1226750), // Rule ID 17764 //
     /* 1226675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1226678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1226686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1226689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1226692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226714 */     // MIs[0] round
     /* 1226714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226724 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1226727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226749 */     // GIR_Coverage, 17764,
     /* 1226749 */     GIR_EraseRootFromParent_Done,
     /* 1226750 */   // Label 17782: @1226750
     /* 1226750 */   GIM_Try, /*On fail goto*//*Label 17783*/ GIMT_Encode4(1226830), // Rule ID 17765 //
     /* 1226755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1226758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1226766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1226769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1226772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226794 */     // MIs[0] round
     /* 1226794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226804 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1226807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226829 */     // GIR_Coverage, 17765,
     /* 1226829 */     GIR_EraseRootFromParent_Done,
     /* 1226830 */   // Label 17783: @1226830
     /* 1226830 */   GIM_Try, /*On fail goto*//*Label 17784*/ GIMT_Encode4(1226910), // Rule ID 22842 //
     /* 1226835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1226852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226874 */     // MIs[0] round
     /* 1226874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226884 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1226887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226909 */     // GIR_Coverage, 22842,
     /* 1226909 */     GIR_EraseRootFromParent_Done,
     /* 1226910 */   // Label 17784: @1226910
     /* 1226910 */   GIM_Try, /*On fail goto*//*Label 17785*/ GIMT_Encode4(1226990), // Rule ID 22843 //
     /* 1226915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1226932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226954 */     // MIs[0] round
     /* 1226954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226964 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1226967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226989 */     // GIR_Coverage, 22843,
     /* 1226989 */     GIR_EraseRootFromParent_Done,
     /* 1226990 */   // Label 17785: @1226990
     /* 1226990 */   GIM_Try, /*On fail goto*//*Label 17786*/ GIMT_Encode4(1227070), // Rule ID 22846 //
     /* 1226995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1227012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227034 */     // MIs[0] round
     /* 1227034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227044 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1227047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227069 */     // GIR_Coverage, 22846,
     /* 1227069 */     GIR_EraseRootFromParent_Done,
     /* 1227070 */   // Label 17786: @1227070
     /* 1227070 */   GIM_Try, /*On fail goto*//*Label 17787*/ GIMT_Encode4(1227150), // Rule ID 22847 //
     /* 1227075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1227092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227114 */     // MIs[0] round
     /* 1227114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227124 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1227127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227149 */     // GIR_Coverage, 22847,
     /* 1227149 */     GIR_EraseRootFromParent_Done,
     /* 1227150 */   // Label 17787: @1227150
     /* 1227150 */   GIM_Try, /*On fail goto*//*Label 17788*/ GIMT_Encode4(1227230), // Rule ID 22850 //
     /* 1227155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1227172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227194 */     // MIs[0] round
     /* 1227194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227204 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1227207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227229 */     // GIR_Coverage, 22850,
     /* 1227229 */     GIR_EraseRootFromParent_Done,
     /* 1227230 */   // Label 17788: @1227230
     /* 1227230 */   GIM_Try, /*On fail goto*//*Label 17789*/ GIMT_Encode4(1227310), // Rule ID 22851 //
     /* 1227235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1227252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227274 */     // MIs[0] round
     /* 1227274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227284 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1227287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227309 */     // GIR_Coverage, 22851,
     /* 1227309 */     GIR_EraseRootFromParent_Done,
     /* 1227310 */   // Label 17789: @1227310
     /* 1227310 */   GIM_Try, /*On fail goto*//*Label 17790*/ GIMT_Encode4(1227390), // Rule ID 22854 //
     /* 1227315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1227332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227354 */     // MIs[0] round
     /* 1227354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227364 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1227367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227389 */     // GIR_Coverage, 22854,
     /* 1227389 */     GIR_EraseRootFromParent_Done,
     /* 1227390 */   // Label 17790: @1227390
     /* 1227390 */   GIM_Try, /*On fail goto*//*Label 17791*/ GIMT_Encode4(1227470), // Rule ID 22855 //
     /* 1227395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1227412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227434 */     // MIs[0] round
     /* 1227434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227444 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1227447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227469 */     // GIR_Coverage, 22855,
     /* 1227469 */     GIR_EraseRootFromParent_Done,
     /* 1227470 */   // Label 17791: @1227470
     /* 1227470 */   GIM_Try, /*On fail goto*//*Label 17792*/ GIMT_Encode4(1227550), // Rule ID 22858 //
     /* 1227475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1227478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1227492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227514 */     // MIs[0] round
     /* 1227514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227524 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1227527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227549 */     // GIR_Coverage, 22858,
     /* 1227549 */     GIR_EraseRootFromParent_Done,
     /* 1227550 */   // Label 17792: @1227550
     /* 1227550 */   GIM_Try, /*On fail goto*//*Label 17793*/ GIMT_Encode4(1227630), // Rule ID 22859 //
     /* 1227555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1227558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1227572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227594 */     // MIs[0] round
     /* 1227594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227604 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1227607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227629 */     // GIR_Coverage, 22859,
     /* 1227629 */     GIR_EraseRootFromParent_Done,
     /* 1227630 */   // Label 17793: @1227630
     /* 1227630 */   GIM_Try, /*On fail goto*//*Label 17794*/ GIMT_Encode4(1227710), // Rule ID 22862 //
     /* 1227635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1227652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227674 */     // MIs[0] round
     /* 1227674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227684 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1227687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227709 */     // GIR_Coverage, 22862,
     /* 1227709 */     GIR_EraseRootFromParent_Done,
     /* 1227710 */   // Label 17794: @1227710
     /* 1227710 */   GIM_Try, /*On fail goto*//*Label 17795*/ GIMT_Encode4(1227790), // Rule ID 22863 //
     /* 1227715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1227732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227754 */     // MIs[0] round
     /* 1227754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227764 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1227767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227789 */     // GIR_Coverage, 22863,
     /* 1227789 */     GIR_EraseRootFromParent_Done,
     /* 1227790 */   // Label 17795: @1227790
     /* 1227790 */   GIM_Try, /*On fail goto*//*Label 17796*/ GIMT_Encode4(1227870), // Rule ID 22866 //
     /* 1227795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227834 */     // MIs[0] round
     /* 1227834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227844 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1227847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227869 */     // GIR_Coverage, 22866,
     /* 1227869 */     GIR_EraseRootFromParent_Done,
     /* 1227870 */   // Label 17796: @1227870
     /* 1227870 */   GIM_Try, /*On fail goto*//*Label 17797*/ GIMT_Encode4(1227950), // Rule ID 22867 //
     /* 1227875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227914 */     // MIs[0] round
     /* 1227914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227924 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1227927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227949 */     // GIR_Coverage, 22867,
     /* 1227949 */     GIR_EraseRootFromParent_Done,
     /* 1227950 */   // Label 17797: @1227950
     /* 1227950 */   GIM_Try, /*On fail goto*//*Label 17798*/ GIMT_Encode4(1228030), // Rule ID 22870 //
     /* 1227955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1227972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227994 */     // MIs[0] round
     /* 1227994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228004 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1228007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228029 */     // GIR_Coverage, 22870,
     /* 1228029 */     GIR_EraseRootFromParent_Done,
     /* 1228030 */   // Label 17798: @1228030
     /* 1228030 */   GIM_Try, /*On fail goto*//*Label 17799*/ GIMT_Encode4(1228110), // Rule ID 22871 //
     /* 1228035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1228052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228074 */     // MIs[0] round
     /* 1228074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228084 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1228087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228109 */     // GIR_Coverage, 22871,
     /* 1228109 */     GIR_EraseRootFromParent_Done,
     /* 1228110 */   // Label 17799: @1228110
     /* 1228110 */   GIM_Try, /*On fail goto*//*Label 17800*/ GIMT_Encode4(1228190), // Rule ID 22874 //
     /* 1228115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1228132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228154 */     // MIs[0] round
     /* 1228154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228164 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1228167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228189 */     // GIR_Coverage, 22874,
     /* 1228189 */     GIR_EraseRootFromParent_Done,
     /* 1228190 */   // Label 17800: @1228190
     /* 1228190 */   GIM_Try, /*On fail goto*//*Label 17801*/ GIMT_Encode4(1228270), // Rule ID 22875 //
     /* 1228195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1228212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228234 */     // MIs[0] round
     /* 1228234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1228247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228269 */     // GIR_Coverage, 22875,
     /* 1228269 */     GIR_EraseRootFromParent_Done,
     /* 1228270 */   // Label 17801: @1228270
     /* 1228270 */   GIM_Try, /*On fail goto*//*Label 17802*/ GIMT_Encode4(1228350), // Rule ID 22878 //
     /* 1228275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1228292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228314 */     // MIs[0] round
     /* 1228314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228324 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1228327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228349 */     // GIR_Coverage, 22878,
     /* 1228349 */     GIR_EraseRootFromParent_Done,
     /* 1228350 */   // Label 17802: @1228350
     /* 1228350 */   GIM_Try, /*On fail goto*//*Label 17803*/ GIMT_Encode4(1228430), // Rule ID 22879 //
     /* 1228355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1228372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228394 */     // MIs[0] round
     /* 1228394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228404 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1228407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228429 */     // GIR_Coverage, 22879,
     /* 1228429 */     GIR_EraseRootFromParent_Done,
     /* 1228430 */   // Label 17803: @1228430
     /* 1228430 */   GIM_Try, /*On fail goto*//*Label 17804*/ GIMT_Encode4(1228510), // Rule ID 22882 //
     /* 1228435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1228452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228474 */     // MIs[0] round
     /* 1228474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228484 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1228487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228509 */     // GIR_Coverage, 22882,
     /* 1228509 */     GIR_EraseRootFromParent_Done,
     /* 1228510 */   // Label 17804: @1228510
     /* 1228510 */   GIM_Try, /*On fail goto*//*Label 17805*/ GIMT_Encode4(1228590), // Rule ID 22883 //
     /* 1228515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1228532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228554 */     // MIs[0] round
     /* 1228554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228564 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1228567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228589 */     // GIR_Coverage, 22883,
     /* 1228589 */     GIR_EraseRootFromParent_Done,
     /* 1228590 */   // Label 17805: @1228590
     /* 1228590 */   GIM_Try, /*On fail goto*//*Label 17806*/ GIMT_Encode4(1228670), // Rule ID 22886 //
     /* 1228595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1228612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228634 */     // MIs[0] round
     /* 1228634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228644 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1228647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228669 */     // GIR_Coverage, 22886,
     /* 1228669 */     GIR_EraseRootFromParent_Done,
     /* 1228670 */   // Label 17806: @1228670
     /* 1228670 */   GIM_Try, /*On fail goto*//*Label 17807*/ GIMT_Encode4(1228750), // Rule ID 22887 //
     /* 1228675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1228692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228714 */     // MIs[0] round
     /* 1228714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228724 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1228727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228749 */     // GIR_Coverage, 22887,
     /* 1228749 */     GIR_EraseRootFromParent_Done,
     /* 1228750 */   // Label 17807: @1228750
     /* 1228750 */   GIM_Try, /*On fail goto*//*Label 17808*/ GIMT_Encode4(1228830), // Rule ID 22890 //
     /* 1228755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1228772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228794 */     // MIs[0] round
     /* 1228794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228804 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1228807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228829 */     // GIR_Coverage, 22890,
     /* 1228829 */     GIR_EraseRootFromParent_Done,
     /* 1228830 */   // Label 17808: @1228830
     /* 1228830 */   GIM_Try, /*On fail goto*//*Label 17809*/ GIMT_Encode4(1228910), // Rule ID 22891 //
     /* 1228835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1228852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228874 */     // MIs[0] round
     /* 1228874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228884 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1228887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228909 */     // GIR_Coverage, 22891,
     /* 1228909 */     GIR_EraseRootFromParent_Done,
     /* 1228910 */   // Label 17809: @1228910
     /* 1228910 */   GIM_Try, /*On fail goto*//*Label 17810*/ GIMT_Encode4(1228990), // Rule ID 22894 //
     /* 1228915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1228932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228954 */     // MIs[0] round
     /* 1228954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228964 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1228967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228989 */     // GIR_Coverage, 22894,
     /* 1228989 */     GIR_EraseRootFromParent_Done,
     /* 1228990 */   // Label 17810: @1228990
     /* 1228990 */   GIM_Try, /*On fail goto*//*Label 17811*/ GIMT_Encode4(1229070), // Rule ID 22895 //
     /* 1228995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1229003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1229012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229034 */     // MIs[0] round
     /* 1229034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229044 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1229047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1229065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229069 */     // GIR_Coverage, 22895,
     /* 1229069 */     GIR_EraseRootFromParent_Done,
     /* 1229070 */   // Label 17811: @1229070
     /* 1229070 */   GIM_Try, /*On fail goto*//*Label 17812*/ GIMT_Encode4(1229150), // Rule ID 22898 //
     /* 1229075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1229092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229114 */     // MIs[0] round
     /* 1229114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229124 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1229127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229149 */     // GIR_Coverage, 22898,
     /* 1229149 */     GIR_EraseRootFromParent_Done,
     /* 1229150 */   // Label 17812: @1229150
     /* 1229150 */   GIM_Try, /*On fail goto*//*Label 17813*/ GIMT_Encode4(1229230), // Rule ID 22899 //
     /* 1229155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1229172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229194 */     // MIs[0] round
     /* 1229194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229204 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1229207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229229 */     // GIR_Coverage, 22899,
     /* 1229229 */     GIR_EraseRootFromParent_Done,
     /* 1229230 */   // Label 17813: @1229230
     /* 1229230 */   GIM_Try, /*On fail goto*//*Label 17814*/ GIMT_Encode4(1229310), // Rule ID 22902 //
     /* 1229235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1229252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229274 */     // MIs[0] round
     /* 1229274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229284 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1229287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229309 */     // GIR_Coverage, 22902,
     /* 1229309 */     GIR_EraseRootFromParent_Done,
     /* 1229310 */   // Label 17814: @1229310
     /* 1229310 */   GIM_Try, /*On fail goto*//*Label 17815*/ GIMT_Encode4(1229390), // Rule ID 22903 //
     /* 1229315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1229332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229354 */     // MIs[0] round
     /* 1229354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229364 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1229367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229389 */     // GIR_Coverage, 22903,
     /* 1229389 */     GIR_EraseRootFromParent_Done,
     /* 1229390 */   // Label 17815: @1229390
     /* 1229390 */   GIM_Try, /*On fail goto*//*Label 17816*/ GIMT_Encode4(1229470), // Rule ID 22906 //
     /* 1229395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1229412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229434 */     // MIs[0] round
     /* 1229434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229444 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1229447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229469 */     // GIR_Coverage, 22906,
     /* 1229469 */     GIR_EraseRootFromParent_Done,
     /* 1229470 */   // Label 17816: @1229470
     /* 1229470 */   GIM_Try, /*On fail goto*//*Label 17817*/ GIMT_Encode4(1229550), // Rule ID 22907 //
     /* 1229475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1229492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229514 */     // MIs[0] round
     /* 1229514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1229527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229549 */     // GIR_Coverage, 22907,
     /* 1229549 */     GIR_EraseRootFromParent_Done,
     /* 1229550 */   // Label 17817: @1229550
     /* 1229550 */   GIM_Try, /*On fail goto*//*Label 17818*/ GIMT_Encode4(1229630), // Rule ID 22910 //
     /* 1229555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1229572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229594 */     // MIs[0] round
     /* 1229594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229604 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1229607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229629 */     // GIR_Coverage, 22910,
     /* 1229629 */     GIR_EraseRootFromParent_Done,
     /* 1229630 */   // Label 17818: @1229630
     /* 1229630 */   GIM_Try, /*On fail goto*//*Label 17819*/ GIMT_Encode4(1229710), // Rule ID 22911 //
     /* 1229635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1229652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229674 */     // MIs[0] round
     /* 1229674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229684 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1229687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229709 */     // GIR_Coverage, 22911,
     /* 1229709 */     GIR_EraseRootFromParent_Done,
     /* 1229710 */   // Label 17819: @1229710
     /* 1229710 */   GIM_Try, /*On fail goto*//*Label 17820*/ GIMT_Encode4(1229790), // Rule ID 22914 //
     /* 1229715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1229732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229754 */     // MIs[0] round
     /* 1229754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229764 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1229767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229789 */     // GIR_Coverage, 22914,
     /* 1229789 */     GIR_EraseRootFromParent_Done,
     /* 1229790 */   // Label 17820: @1229790
     /* 1229790 */   GIM_Try, /*On fail goto*//*Label 17821*/ GIMT_Encode4(1229870), // Rule ID 22915 //
     /* 1229795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1229812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229834 */     // MIs[0] round
     /* 1229834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229844 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1229847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229869 */     // GIR_Coverage, 22915,
     /* 1229869 */     GIR_EraseRootFromParent_Done,
     /* 1229870 */   // Label 17821: @1229870
     /* 1229870 */   GIM_Try, /*On fail goto*//*Label 17822*/ GIMT_Encode4(1229950), // Rule ID 22918 //
     /* 1229875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1229878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1229892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229914 */     // MIs[0] round
     /* 1229914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229924 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1229927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1229945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229949 */     // GIR_Coverage, 22918,
     /* 1229949 */     GIR_EraseRootFromParent_Done,
     /* 1229950 */   // Label 17822: @1229950
     /* 1229950 */   GIM_Try, /*On fail goto*//*Label 17823*/ GIMT_Encode4(1230030), // Rule ID 22919 //
     /* 1229955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1229958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1229972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229994 */     // MIs[0] round
     /* 1229994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230004 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1230007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230029 */     // GIR_Coverage, 22919,
     /* 1230029 */     GIR_EraseRootFromParent_Done,
     /* 1230030 */   // Label 17823: @1230030
     /* 1230030 */   GIM_Try, /*On fail goto*//*Label 17824*/ GIMT_Encode4(1230110), // Rule ID 22922 //
     /* 1230035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1230038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1230052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230074 */     // MIs[0] round
     /* 1230074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230084 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1230087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230109 */     // GIR_Coverage, 22922,
     /* 1230109 */     GIR_EraseRootFromParent_Done,
     /* 1230110 */   // Label 17824: @1230110
     /* 1230110 */   GIM_Try, /*On fail goto*//*Label 17825*/ GIMT_Encode4(1230190), // Rule ID 22923 //
     /* 1230115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1230118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1230132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230154 */     // MIs[0] round
     /* 1230154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230164 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1230167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230189 */     // GIR_Coverage, 22923,
     /* 1230189 */     GIR_EraseRootFromParent_Done,
     /* 1230190 */   // Label 17825: @1230190
     /* 1230190 */   GIM_Try, /*On fail goto*//*Label 17826*/ GIMT_Encode4(1230270), // Rule ID 22926 //
     /* 1230195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1230198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1230212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230234 */     // MIs[0] round
     /* 1230234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230244 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1230247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230269 */     // GIR_Coverage, 22926,
     /* 1230269 */     GIR_EraseRootFromParent_Done,
     /* 1230270 */   // Label 17826: @1230270
     /* 1230270 */   GIM_Try, /*On fail goto*//*Label 17827*/ GIMT_Encode4(1230350), // Rule ID 22927 //
     /* 1230275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1230278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1230292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230314 */     // MIs[0] round
     /* 1230314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230324 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1230327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230349 */     // GIR_Coverage, 22927,
     /* 1230349 */     GIR_EraseRootFromParent_Done,
     /* 1230350 */   // Label 17827: @1230350
     /* 1230350 */   GIM_Try, /*On fail goto*//*Label 17828*/ GIMT_Encode4(1230430), // Rule ID 22930 //
     /* 1230355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1230358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1230372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230394 */     // MIs[0] round
     /* 1230394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230404 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1230407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230429 */     // GIR_Coverage, 22930,
     /* 1230429 */     GIR_EraseRootFromParent_Done,
     /* 1230430 */   // Label 17828: @1230430
     /* 1230430 */   GIM_Try, /*On fail goto*//*Label 17829*/ GIMT_Encode4(1230510), // Rule ID 22931 //
     /* 1230435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1230438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1230452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230474 */     // MIs[0] round
     /* 1230474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230484 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1230487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230509 */     // GIR_Coverage, 22931,
     /* 1230509 */     GIR_EraseRootFromParent_Done,
     /* 1230510 */   // Label 17829: @1230510
     /* 1230510 */   GIM_Try, /*On fail goto*//*Label 17830*/ GIMT_Encode4(1230590), // Rule ID 22934 //
     /* 1230515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1230532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230554 */     // MIs[0] round
     /* 1230554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230564 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1230567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230589 */     // GIR_Coverage, 22934,
     /* 1230589 */     GIR_EraseRootFromParent_Done,
     /* 1230590 */   // Label 17830: @1230590
     /* 1230590 */   GIM_Try, /*On fail goto*//*Label 17831*/ GIMT_Encode4(1230670), // Rule ID 22935 //
     /* 1230595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1230612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230634 */     // MIs[0] round
     /* 1230634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230644 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1230647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230669 */     // GIR_Coverage, 22935,
     /* 1230669 */     GIR_EraseRootFromParent_Done,
     /* 1230670 */   // Label 17831: @1230670
     /* 1230670 */   GIM_Try, /*On fail goto*//*Label 17832*/ GIMT_Encode4(1230750), // Rule ID 22938 //
     /* 1230675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1230692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230714 */     // MIs[0] round
     /* 1230714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230724 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1230727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230749 */     // GIR_Coverage, 22938,
     /* 1230749 */     GIR_EraseRootFromParent_Done,
     /* 1230750 */   // Label 17832: @1230750
     /* 1230750 */   GIM_Try, /*On fail goto*//*Label 17833*/ GIMT_Encode4(1230830), // Rule ID 22939 //
     /* 1230755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1230772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230794 */     // MIs[0] round
     /* 1230794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230804 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1230807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230829 */     // GIR_Coverage, 22939,
     /* 1230829 */     GIR_EraseRootFromParent_Done,
     /* 1230830 */   // Label 17833: @1230830
     /* 1230830 */   GIM_Try, /*On fail goto*//*Label 17834*/ GIMT_Encode4(1230910), // Rule ID 22942 //
     /* 1230835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230874 */     // MIs[0] round
     /* 1230874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230884 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1230887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230909 */     // GIR_Coverage, 22942,
     /* 1230909 */     GIR_EraseRootFromParent_Done,
     /* 1230910 */   // Label 17834: @1230910
     /* 1230910 */   GIM_Try, /*On fail goto*//*Label 17835*/ GIMT_Encode4(1230990), // Rule ID 22943 //
     /* 1230915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230954 */     // MIs[0] round
     /* 1230954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230964 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1230967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230989 */     // GIR_Coverage, 22943,
     /* 1230989 */     GIR_EraseRootFromParent_Done,
     /* 1230990 */   // Label 17835: @1230990
     /* 1230990 */   GIM_Try, /*On fail goto*//*Label 17836*/ GIMT_Encode4(1231070), // Rule ID 22946 //
     /* 1230995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1231003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1231012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231034 */     // MIs[0] round
     /* 1231034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231044 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1231047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231069 */     // GIR_Coverage, 22946,
     /* 1231069 */     GIR_EraseRootFromParent_Done,
     /* 1231070 */   // Label 17836: @1231070
     /* 1231070 */   GIM_Try, /*On fail goto*//*Label 17837*/ GIMT_Encode4(1231150), // Rule ID 22947 //
     /* 1231075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1231078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1231083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1231092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231114 */     // MIs[0] round
     /* 1231114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231124 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1231127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231149 */     // GIR_Coverage, 22947,
     /* 1231149 */     GIR_EraseRootFromParent_Done,
     /* 1231150 */   // Label 17837: @1231150
     /* 1231150 */   GIM_Try, /*On fail goto*//*Label 17838*/ GIMT_Encode4(1231230), // Rule ID 22950 //
     /* 1231155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1231158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1231163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1231172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231194 */     // MIs[0] round
     /* 1231194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231204 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1231207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231229 */     // GIR_Coverage, 22950,
     /* 1231229 */     GIR_EraseRootFromParent_Done,
     /* 1231230 */   // Label 17838: @1231230
     /* 1231230 */   GIM_Try, /*On fail goto*//*Label 17839*/ GIMT_Encode4(1231310), // Rule ID 22951 //
     /* 1231235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1231238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1231243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1231252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231274 */     // MIs[0] round
     /* 1231274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231284 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1231287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231309 */     // GIR_Coverage, 22951,
     /* 1231309 */     GIR_EraseRootFromParent_Done,
     /* 1231310 */   // Label 17839: @1231310
     /* 1231310 */   GIM_Try, /*On fail goto*//*Label 17840*/ GIMT_Encode4(1231390), // Rule ID 22954 //
     /* 1231315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1231318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1231323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1231332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1231350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231354 */     // MIs[0] round
     /* 1231354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231364 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1231367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231389 */     // GIR_Coverage, 22954,
     /* 1231389 */     GIR_EraseRootFromParent_Done,
     /* 1231390 */   // Label 17840: @1231390
     /* 1231390 */   GIM_Try, /*On fail goto*//*Label 17841*/ GIMT_Encode4(1231470), // Rule ID 22955 //
     /* 1231395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1231398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1231403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1231412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1231430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231434 */     // MIs[0] round
     /* 1231434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231444 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1231447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231469 */     // GIR_Coverage, 22955,
     /* 1231469 */     GIR_EraseRootFromParent_Done,
     /* 1231470 */   // Label 17841: @1231470
     /* 1231470 */   GIM_Try, /*On fail goto*//*Label 17842*/ GIMT_Encode4(1231550), // Rule ID 23078 //
     /* 1231475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1231492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231514 */     // MIs[0] round
     /* 1231514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1231527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231549 */     // GIR_Coverage, 23078,
     /* 1231549 */     GIR_EraseRootFromParent_Done,
     /* 1231550 */   // Label 17842: @1231550
     /* 1231550 */   GIM_Try, /*On fail goto*//*Label 17843*/ GIMT_Encode4(1231630), // Rule ID 23079 //
     /* 1231555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1231572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231594 */     // MIs[0] round
     /* 1231594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231604 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1231607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231629 */     // GIR_Coverage, 23079,
     /* 1231629 */     GIR_EraseRootFromParent_Done,
     /* 1231630 */   // Label 17843: @1231630
     /* 1231630 */   GIM_Try, /*On fail goto*//*Label 17844*/ GIMT_Encode4(1231710), // Rule ID 23082 //
     /* 1231635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1231652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231674 */     // MIs[0] round
     /* 1231674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231684 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1231687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231709 */     // GIR_Coverage, 23082,
     /* 1231709 */     GIR_EraseRootFromParent_Done,
     /* 1231710 */   // Label 17844: @1231710
     /* 1231710 */   GIM_Try, /*On fail goto*//*Label 17845*/ GIMT_Encode4(1231790), // Rule ID 23083 //
     /* 1231715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1231732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231754 */     // MIs[0] round
     /* 1231754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231764 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1231767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231789 */     // GIR_Coverage, 23083,
     /* 1231789 */     GIR_EraseRootFromParent_Done,
     /* 1231790 */   // Label 17845: @1231790
     /* 1231790 */   GIM_Try, /*On fail goto*//*Label 17846*/ GIMT_Encode4(1231870), // Rule ID 23086 //
     /* 1231795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1231812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231834 */     // MIs[0] round
     /* 1231834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231844 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1231847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231869 */     // GIR_Coverage, 23086,
     /* 1231869 */     GIR_EraseRootFromParent_Done,
     /* 1231870 */   // Label 17846: @1231870
     /* 1231870 */   GIM_Try, /*On fail goto*//*Label 17847*/ GIMT_Encode4(1231950), // Rule ID 23087 //
     /* 1231875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1231892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231914 */     // MIs[0] round
     /* 1231914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231924 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1231927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231949 */     // GIR_Coverage, 23087,
     /* 1231949 */     GIR_EraseRootFromParent_Done,
     /* 1231950 */   // Label 17847: @1231950
     /* 1231950 */   GIM_Try, /*On fail goto*//*Label 17848*/ GIMT_Encode4(1232030), // Rule ID 23090 //
     /* 1231955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1231972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231994 */     // MIs[0] round
     /* 1231994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232004 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1232007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232029 */     // GIR_Coverage, 23090,
     /* 1232029 */     GIR_EraseRootFromParent_Done,
     /* 1232030 */   // Label 17848: @1232030
     /* 1232030 */   GIM_Try, /*On fail goto*//*Label 17849*/ GIMT_Encode4(1232110), // Rule ID 23091 //
     /* 1232035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1232052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232074 */     // MIs[0] round
     /* 1232074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232084 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1232087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232109 */     // GIR_Coverage, 23091,
     /* 1232109 */     GIR_EraseRootFromParent_Done,
     /* 1232110 */   // Label 17849: @1232110
     /* 1232110 */   GIM_Try, /*On fail goto*//*Label 17850*/ GIMT_Encode4(1232190), // Rule ID 23094 //
     /* 1232115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1232132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232154 */     // MIs[0] round
     /* 1232154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232164 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1232167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232189 */     // GIR_Coverage, 23094,
     /* 1232189 */     GIR_EraseRootFromParent_Done,
     /* 1232190 */   // Label 17850: @1232190
     /* 1232190 */   GIM_Try, /*On fail goto*//*Label 17851*/ GIMT_Encode4(1232270), // Rule ID 23095 //
     /* 1232195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1232212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232234 */     // MIs[0] round
     /* 1232234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232244 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1232247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232269 */     // GIR_Coverage, 23095,
     /* 1232269 */     GIR_EraseRootFromParent_Done,
     /* 1232270 */   // Label 17851: @1232270
     /* 1232270 */   GIM_Try, /*On fail goto*//*Label 17852*/ GIMT_Encode4(1232350), // Rule ID 23098 //
     /* 1232275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1232292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232314 */     // MIs[0] round
     /* 1232314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232324 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1232327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232349 */     // GIR_Coverage, 23098,
     /* 1232349 */     GIR_EraseRootFromParent_Done,
     /* 1232350 */   // Label 17852: @1232350
     /* 1232350 */   GIM_Try, /*On fail goto*//*Label 17853*/ GIMT_Encode4(1232430), // Rule ID 23099 //
     /* 1232355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1232372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232394 */     // MIs[0] round
     /* 1232394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232404 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1232407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232429 */     // GIR_Coverage, 23099,
     /* 1232429 */     GIR_EraseRootFromParent_Done,
     /* 1232430 */   // Label 17853: @1232430
     /* 1232430 */   GIM_Try, /*On fail goto*//*Label 17854*/ GIMT_Encode4(1232510), // Rule ID 23102 //
     /* 1232435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1232452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232474 */     // MIs[0] round
     /* 1232474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232484 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1232487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232509 */     // GIR_Coverage, 23102,
     /* 1232509 */     GIR_EraseRootFromParent_Done,
     /* 1232510 */   // Label 17854: @1232510
     /* 1232510 */   GIM_Try, /*On fail goto*//*Label 17855*/ GIMT_Encode4(1232590), // Rule ID 23103 //
     /* 1232515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1232532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232554 */     // MIs[0] round
     /* 1232554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232564 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1232567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232589 */     // GIR_Coverage, 23103,
     /* 1232589 */     GIR_EraseRootFromParent_Done,
     /* 1232590 */   // Label 17855: @1232590
     /* 1232590 */   GIM_Try, /*On fail goto*//*Label 17856*/ GIMT_Encode4(1232670), // Rule ID 23106 //
     /* 1232595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1232612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232634 */     // MIs[0] round
     /* 1232634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232644 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1232647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232669 */     // GIR_Coverage, 23106,
     /* 1232669 */     GIR_EraseRootFromParent_Done,
     /* 1232670 */   // Label 17856: @1232670
     /* 1232670 */   GIM_Try, /*On fail goto*//*Label 17857*/ GIMT_Encode4(1232750), // Rule ID 23107 //
     /* 1232675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1232692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232714 */     // MIs[0] round
     /* 1232714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232724 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1232727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232749 */     // GIR_Coverage, 23107,
     /* 1232749 */     GIR_EraseRootFromParent_Done,
     /* 1232750 */   // Label 17857: @1232750
     /* 1232750 */   GIM_Try, /*On fail goto*//*Label 17858*/ GIMT_Encode4(1232830), // Rule ID 23110 //
     /* 1232755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1232772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232794 */     // MIs[0] round
     /* 1232794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232804 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1232807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232829 */     // GIR_Coverage, 23110,
     /* 1232829 */     GIR_EraseRootFromParent_Done,
     /* 1232830 */   // Label 17858: @1232830
     /* 1232830 */   GIM_Try, /*On fail goto*//*Label 17859*/ GIMT_Encode4(1232910), // Rule ID 23111 //
     /* 1232835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1232852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232874 */     // MIs[0] round
     /* 1232874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232884 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1232887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232909 */     // GIR_Coverage, 23111,
     /* 1232909 */     GIR_EraseRootFromParent_Done,
     /* 1232910 */   // Label 17859: @1232910
     /* 1232910 */   GIM_Try, /*On fail goto*//*Label 17860*/ GIMT_Encode4(1232990), // Rule ID 23114 //
     /* 1232915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1232932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232954 */     // MIs[0] round
     /* 1232954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232964 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1232967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232989 */     // GIR_Coverage, 23114,
     /* 1232989 */     GIR_EraseRootFromParent_Done,
     /* 1232990 */   // Label 17860: @1232990
     /* 1232990 */   GIM_Try, /*On fail goto*//*Label 17861*/ GIMT_Encode4(1233070), // Rule ID 23115 //
     /* 1232995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1233003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1233012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233034 */     // MIs[0] round
     /* 1233034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233044 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1233047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233069 */     // GIR_Coverage, 23115,
     /* 1233069 */     GIR_EraseRootFromParent_Done,
     /* 1233070 */   // Label 17861: @1233070
     /* 1233070 */   GIM_Try, /*On fail goto*//*Label 17862*/ GIMT_Encode4(1233150), // Rule ID 23118 //
     /* 1233075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1233083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1233092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233114 */     // MIs[0] round
     /* 1233114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233124 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1233127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233149 */     // GIR_Coverage, 23118,
     /* 1233149 */     GIR_EraseRootFromParent_Done,
     /* 1233150 */   // Label 17862: @1233150
     /* 1233150 */   GIM_Try, /*On fail goto*//*Label 17863*/ GIMT_Encode4(1233230), // Rule ID 23119 //
     /* 1233155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1233163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1233172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233194 */     // MIs[0] round
     /* 1233194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233204 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1233207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233229 */     // GIR_Coverage, 23119,
     /* 1233229 */     GIR_EraseRootFromParent_Done,
     /* 1233230 */   // Label 17863: @1233230
     /* 1233230 */   GIM_Try, /*On fail goto*//*Label 17864*/ GIMT_Encode4(1233310), // Rule ID 23122 //
     /* 1233235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1233252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233274 */     // MIs[0] round
     /* 1233274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233284 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1233287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233309 */     // GIR_Coverage, 23122,
     /* 1233309 */     GIR_EraseRootFromParent_Done,
     /* 1233310 */   // Label 17864: @1233310
     /* 1233310 */   GIM_Try, /*On fail goto*//*Label 17865*/ GIMT_Encode4(1233390), // Rule ID 23123 //
     /* 1233315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1233332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233354 */     // MIs[0] round
     /* 1233354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233364 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1233367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233389 */     // GIR_Coverage, 23123,
     /* 1233389 */     GIR_EraseRootFromParent_Done,
     /* 1233390 */   // Label 17865: @1233390
     /* 1233390 */   GIM_Try, /*On fail goto*//*Label 17866*/ GIMT_Encode4(1233470), // Rule ID 23126 //
     /* 1233395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1233412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233434 */     // MIs[0] round
     /* 1233434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233444 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1233447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233469 */     // GIR_Coverage, 23126,
     /* 1233469 */     GIR_EraseRootFromParent_Done,
     /* 1233470 */   // Label 17866: @1233470
     /* 1233470 */   GIM_Try, /*On fail goto*//*Label 17867*/ GIMT_Encode4(1233550), // Rule ID 23127 //
     /* 1233475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1233492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233514 */     // MIs[0] round
     /* 1233514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1233527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233549 */     // GIR_Coverage, 23127,
     /* 1233549 */     GIR_EraseRootFromParent_Done,
     /* 1233550 */   // Label 17867: @1233550
     /* 1233550 */   GIM_Try, /*On fail goto*//*Label 17868*/ GIMT_Encode4(1233630), // Rule ID 23130 //
     /* 1233555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1233572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233594 */     // MIs[0] round
     /* 1233594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233604 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1233607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233629 */     // GIR_Coverage, 23130,
     /* 1233629 */     GIR_EraseRootFromParent_Done,
     /* 1233630 */   // Label 17868: @1233630
     /* 1233630 */   GIM_Try, /*On fail goto*//*Label 17869*/ GIMT_Encode4(1233710), // Rule ID 23131 //
     /* 1233635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1233652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233674 */     // MIs[0] round
     /* 1233674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233684 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1233687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233709 */     // GIR_Coverage, 23131,
     /* 1233709 */     GIR_EraseRootFromParent_Done,
     /* 1233710 */   // Label 17869: @1233710
     /* 1233710 */   GIM_Try, /*On fail goto*//*Label 17870*/ GIMT_Encode4(1233790), // Rule ID 23134 //
     /* 1233715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233754 */     // MIs[0] round
     /* 1233754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233764 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1233767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233789 */     // GIR_Coverage, 23134,
     /* 1233789 */     GIR_EraseRootFromParent_Done,
     /* 1233790 */   // Label 17870: @1233790
     /* 1233790 */   GIM_Try, /*On fail goto*//*Label 17871*/ GIMT_Encode4(1233870), // Rule ID 23135 //
     /* 1233795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233834 */     // MIs[0] round
     /* 1233834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233844 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1233847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233869 */     // GIR_Coverage, 23135,
     /* 1233869 */     GIR_EraseRootFromParent_Done,
     /* 1233870 */   // Label 17871: @1233870
     /* 1233870 */   GIM_Try, /*On fail goto*//*Label 17872*/ GIMT_Encode4(1233950), // Rule ID 23138 //
     /* 1233875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233914 */     // MIs[0] round
     /* 1233914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233924 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1233927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233949 */     // GIR_Coverage, 23138,
     /* 1233949 */     GIR_EraseRootFromParent_Done,
     /* 1233950 */   // Label 17872: @1233950
     /* 1233950 */   GIM_Try, /*On fail goto*//*Label 17873*/ GIMT_Encode4(1234030), // Rule ID 23139 //
     /* 1233955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233994 */     // MIs[0] round
     /* 1233994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234004 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1234007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234029 */     // GIR_Coverage, 23139,
     /* 1234029 */     GIR_EraseRootFromParent_Done,
     /* 1234030 */   // Label 17873: @1234030
     /* 1234030 */   GIM_Try, /*On fail goto*//*Label 17874*/ GIMT_Encode4(1234110), // Rule ID 23142 //
     /* 1234035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1234038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1234052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234074 */     // MIs[0] round
     /* 1234074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234084 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1234087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234109 */     // GIR_Coverage, 23142,
     /* 1234109 */     GIR_EraseRootFromParent_Done,
     /* 1234110 */   // Label 17874: @1234110
     /* 1234110 */   GIM_Try, /*On fail goto*//*Label 17875*/ GIMT_Encode4(1234190), // Rule ID 23143 //
     /* 1234115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1234118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1234132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234154 */     // MIs[0] round
     /* 1234154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234164 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1234167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234189 */     // GIR_Coverage, 23143,
     /* 1234189 */     GIR_EraseRootFromParent_Done,
     /* 1234190 */   // Label 17875: @1234190
     /* 1234190 */   GIM_Try, /*On fail goto*//*Label 17876*/ GIMT_Encode4(1234270), // Rule ID 23146 //
     /* 1234195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1234198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1234212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234234 */     // MIs[0] round
     /* 1234234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1234247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234269 */     // GIR_Coverage, 23146,
     /* 1234269 */     GIR_EraseRootFromParent_Done,
     /* 1234270 */   // Label 17876: @1234270
     /* 1234270 */   GIM_Try, /*On fail goto*//*Label 17877*/ GIMT_Encode4(1234350), // Rule ID 23147 //
     /* 1234275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1234278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1234292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234314 */     // MIs[0] round
     /* 1234314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234324 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1234327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234349 */     // GIR_Coverage, 23147,
     /* 1234349 */     GIR_EraseRootFromParent_Done,
     /* 1234350 */   // Label 17877: @1234350
     /* 1234350 */   GIM_Try, /*On fail goto*//*Label 17878*/ GIMT_Encode4(1234430), // Rule ID 23150 //
     /* 1234355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1234358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1234372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234394 */     // MIs[0] round
     /* 1234394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234404 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1234407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234429 */     // GIR_Coverage, 23150,
     /* 1234429 */     GIR_EraseRootFromParent_Done,
     /* 1234430 */   // Label 17878: @1234430
     /* 1234430 */   GIM_Try, /*On fail goto*//*Label 17879*/ GIMT_Encode4(1234510), // Rule ID 23151 //
     /* 1234435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1234438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1234452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234474 */     // MIs[0] round
     /* 1234474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234484 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1234487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234509 */     // GIR_Coverage, 23151,
     /* 1234509 */     GIR_EraseRootFromParent_Done,
     /* 1234510 */   // Label 17879: @1234510
     /* 1234510 */   GIM_Try, /*On fail goto*//*Label 17880*/ GIMT_Encode4(1234590), // Rule ID 23154 //
     /* 1234515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234554 */     // MIs[0] round
     /* 1234554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234564 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1234567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234589 */     // GIR_Coverage, 23154,
     /* 1234589 */     GIR_EraseRootFromParent_Done,
     /* 1234590 */   // Label 17880: @1234590
     /* 1234590 */   GIM_Try, /*On fail goto*//*Label 17881*/ GIMT_Encode4(1234670), // Rule ID 23155 //
     /* 1234595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234634 */     // MIs[0] round
     /* 1234634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234644 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1234647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234669 */     // GIR_Coverage, 23155,
     /* 1234669 */     GIR_EraseRootFromParent_Done,
     /* 1234670 */   // Label 17881: @1234670
     /* 1234670 */   GIM_Try, /*On fail goto*//*Label 17882*/ GIMT_Encode4(1234750), // Rule ID 23158 //
     /* 1234675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234714 */     // MIs[0] round
     /* 1234714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234724 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1234727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234749 */     // GIR_Coverage, 23158,
     /* 1234749 */     GIR_EraseRootFromParent_Done,
     /* 1234750 */   // Label 17882: @1234750
     /* 1234750 */   GIM_Try, /*On fail goto*//*Label 17883*/ GIMT_Encode4(1234830), // Rule ID 23159 //
     /* 1234755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234794 */     // MIs[0] round
     /* 1234794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234804 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1234807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234829 */     // GIR_Coverage, 23159,
     /* 1234829 */     GIR_EraseRootFromParent_Done,
     /* 1234830 */   // Label 17883: @1234830
     /* 1234830 */   GIM_Try, /*On fail goto*//*Label 17884*/ GIMT_Encode4(1234910), // Rule ID 23162 //
     /* 1234835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234874 */     // MIs[0] round
     /* 1234874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234884 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1234887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234909 */     // GIR_Coverage, 23162,
     /* 1234909 */     GIR_EraseRootFromParent_Done,
     /* 1234910 */   // Label 17884: @1234910
     /* 1234910 */   GIM_Try, /*On fail goto*//*Label 17885*/ GIMT_Encode4(1234990), // Rule ID 23163 //
     /* 1234915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234954 */     // MIs[0] round
     /* 1234954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234964 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1234967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234989 */     // GIR_Coverage, 23163,
     /* 1234989 */     GIR_EraseRootFromParent_Done,
     /* 1234990 */   // Label 17885: @1234990
     /* 1234990 */   GIM_Try, /*On fail goto*//*Label 17886*/ GIMT_Encode4(1235070), // Rule ID 64367 //
     /* 1234995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235034 */     // MIs[0] round
     /* 1235034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235044 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF8),
     /* 1235047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235069 */     // GIR_Coverage, 64367,
     /* 1235069 */     GIR_EraseRootFromParent_Done,
     /* 1235070 */   // Label 17886: @1235070
     /* 1235070 */   GIM_Try, /*On fail goto*//*Label 17887*/ GIMT_Encode4(1235150), // Rule ID 64368 //
     /* 1235075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235114 */     // MIs[0] round
     /* 1235114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235124 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF8),
     /* 1235127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235149 */     // GIR_Coverage, 64368,
     /* 1235149 */     GIR_EraseRootFromParent_Done,
     /* 1235150 */   // Label 17887: @1235150
     /* 1235150 */   GIM_Try, /*On fail goto*//*Label 17888*/ GIMT_Encode4(1235230), // Rule ID 64371 //
     /* 1235155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235194 */     // MIs[0] round
     /* 1235194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235204 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF4),
     /* 1235207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235229 */     // GIR_Coverage, 64371,
     /* 1235229 */     GIR_EraseRootFromParent_Done,
     /* 1235230 */   // Label 17888: @1235230
     /* 1235230 */   GIM_Try, /*On fail goto*//*Label 17889*/ GIMT_Encode4(1235310), // Rule ID 64372 //
     /* 1235235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235274 */     // MIs[0] round
     /* 1235274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235284 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF4),
     /* 1235287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235309 */     // GIR_Coverage, 64372,
     /* 1235309 */     GIR_EraseRootFromParent_Done,
     /* 1235310 */   // Label 17889: @1235310
     /* 1235310 */   GIM_Try, /*On fail goto*//*Label 17890*/ GIMT_Encode4(1235390), // Rule ID 64375 //
     /* 1235315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1235326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1235329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1235332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235354 */     // MIs[0] round
     /* 1235354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235364 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF2),
     /* 1235367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235389 */     // GIR_Coverage, 64375,
     /* 1235389 */     GIR_EraseRootFromParent_Done,
     /* 1235390 */   // Label 17890: @1235390
     /* 1235390 */   GIM_Try, /*On fail goto*//*Label 17891*/ GIMT_Encode4(1235470), // Rule ID 64376 //
     /* 1235395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1235406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1235409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1235412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235434 */     // MIs[0] round
     /* 1235434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235444 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF2),
     /* 1235447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235469 */     // GIR_Coverage, 64376,
     /* 1235469 */     GIR_EraseRootFromParent_Done,
     /* 1235470 */   // Label 17891: @1235470
     /* 1235470 */   GIM_Try, /*On fail goto*//*Label 17892*/ GIMT_Encode4(1235550), // Rule ID 64379 //
     /* 1235475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235514 */     // MIs[0] round
     /* 1235514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M1),
     /* 1235527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235549 */     // GIR_Coverage, 64379,
     /* 1235549 */     GIR_EraseRootFromParent_Done,
     /* 1235550 */   // Label 17892: @1235550
     /* 1235550 */   GIM_Try, /*On fail goto*//*Label 17893*/ GIMT_Encode4(1235630), // Rule ID 64380 //
     /* 1235555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235594 */     // MIs[0] round
     /* 1235594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235604 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M1),
     /* 1235607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235629 */     // GIR_Coverage, 64380,
     /* 1235629 */     GIR_EraseRootFromParent_Done,
     /* 1235630 */   // Label 17893: @1235630
     /* 1235630 */   GIM_Try, /*On fail goto*//*Label 17894*/ GIMT_Encode4(1235710), // Rule ID 64383 //
     /* 1235635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1235646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1235649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235674 */     // MIs[0] round
     /* 1235674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235684 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M2),
     /* 1235687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235709 */     // GIR_Coverage, 64383,
     /* 1235709 */     GIR_EraseRootFromParent_Done,
     /* 1235710 */   // Label 17894: @1235710
     /* 1235710 */   GIM_Try, /*On fail goto*//*Label 17895*/ GIMT_Encode4(1235790), // Rule ID 64384 //
     /* 1235715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1235726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1235729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235754 */     // MIs[0] round
     /* 1235754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235764 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M2),
     /* 1235767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235789 */     // GIR_Coverage, 64384,
     /* 1235789 */     GIR_EraseRootFromParent_Done,
     /* 1235790 */   // Label 17895: @1235790
     /* 1235790 */   GIM_Try, /*On fail goto*//*Label 17896*/ GIMT_Encode4(1235870), // Rule ID 64387 //
     /* 1235795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235834 */     // MIs[0] round
     /* 1235834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235844 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF8),
     /* 1235847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235869 */     // GIR_Coverage, 64387,
     /* 1235869 */     GIR_EraseRootFromParent_Done,
     /* 1235870 */   // Label 17896: @1235870
     /* 1235870 */   GIM_Try, /*On fail goto*//*Label 17897*/ GIMT_Encode4(1235950), // Rule ID 64388 //
     /* 1235875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235914 */     // MIs[0] round
     /* 1235914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235924 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF8),
     /* 1235927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235949 */     // GIR_Coverage, 64388,
     /* 1235949 */     GIR_EraseRootFromParent_Done,
     /* 1235950 */   // Label 17897: @1235950
     /* 1235950 */   GIM_Try, /*On fail goto*//*Label 17898*/ GIMT_Encode4(1236030), // Rule ID 64391 //
     /* 1235955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235994 */     // MIs[0] round
     /* 1235994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236004 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF4),
     /* 1236007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236029 */     // GIR_Coverage, 64391,
     /* 1236029 */     GIR_EraseRootFromParent_Done,
     /* 1236030 */   // Label 17898: @1236030
     /* 1236030 */   GIM_Try, /*On fail goto*//*Label 17899*/ GIMT_Encode4(1236110), // Rule ID 64392 //
     /* 1236035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1236038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1236046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1236049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1236052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236074 */     // MIs[0] round
     /* 1236074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236084 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF4),
     /* 1236087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236109 */     // GIR_Coverage, 64392,
     /* 1236109 */     GIR_EraseRootFromParent_Done,
     /* 1236110 */   // Label 17899: @1236110
     /* 1236110 */   GIM_Try, /*On fail goto*//*Label 17900*/ GIMT_Encode4(1236190), // Rule ID 64395 //
     /* 1236115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1236118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1236126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1236129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1236132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236154 */     // MIs[0] round
     /* 1236154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236164 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF2),
     /* 1236167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236189 */     // GIR_Coverage, 64395,
     /* 1236189 */     GIR_EraseRootFromParent_Done,
     /* 1236190 */   // Label 17900: @1236190
     /* 1236190 */   GIM_Try, /*On fail goto*//*Label 17901*/ GIMT_Encode4(1236270), // Rule ID 64396 //
     /* 1236195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1236198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1236206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1236209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1236212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236234 */     // MIs[0] round
     /* 1236234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236244 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF2),
     /* 1236247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236269 */     // GIR_Coverage, 64396,
     /* 1236269 */     GIR_EraseRootFromParent_Done,
     /* 1236270 */   // Label 17901: @1236270
     /* 1236270 */   GIM_Try, /*On fail goto*//*Label 17902*/ GIMT_Encode4(1236350), // Rule ID 64399 //
     /* 1236275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1236278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1236286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1236289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1236292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236314 */     // MIs[0] round
     /* 1236314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236324 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M1),
     /* 1236327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236349 */     // GIR_Coverage, 64399,
     /* 1236349 */     GIR_EraseRootFromParent_Done,
     /* 1236350 */   // Label 17902: @1236350
     /* 1236350 */   GIM_Try, /*On fail goto*//*Label 17903*/ GIMT_Encode4(1236430), // Rule ID 64400 //
     /* 1236355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1236358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1236366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1236369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1236372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236394 */     // MIs[0] round
     /* 1236394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236404 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M1),
     /* 1236407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236429 */     // GIR_Coverage, 64400,
     /* 1236429 */     GIR_EraseRootFromParent_Done,
     /* 1236430 */   // Label 17903: @1236430
     /* 1236430 */   GIM_Try, /*On fail goto*//*Label 17904*/ GIMT_Encode4(1236510), // Rule ID 64403 //
     /* 1236435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1236438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1236446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1236449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1236452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236474 */     // MIs[0] round
     /* 1236474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236484 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M2),
     /* 1236487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236509 */     // GIR_Coverage, 64403,
     /* 1236509 */     GIR_EraseRootFromParent_Done,
     /* 1236510 */   // Label 17904: @1236510
     /* 1236510 */   GIM_Try, /*On fail goto*//*Label 17905*/ GIMT_Encode4(1236590), // Rule ID 64404 //
     /* 1236515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1236518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1236526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1236529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1236532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236554 */     // MIs[0] round
     /* 1236554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M2),
     /* 1236567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236589 */     // GIR_Coverage, 64404,
     /* 1236589 */     GIR_EraseRootFromParent_Done,
     /* 1236590 */   // Label 17905: @1236590
     /* 1236590 */   GIM_Try, /*On fail goto*//*Label 17906*/ GIMT_Encode4(1236670), // Rule ID 65192 //
     /* 1236595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1236606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1236609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236634 */     // MIs[0] round
     /* 1236634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236644 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11086:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4),
     /* 1236647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236669 */     // GIR_Coverage, 65192,
     /* 1236669 */     GIR_EraseRootFromParent_Done,
     /* 1236670 */   // Label 17906: @1236670
     /* 1236670 */   GIM_Try, /*On fail goto*//*Label 17907*/ GIMT_Encode4(1236750), // Rule ID 65193 //
     /* 1236675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1236686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1236689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236714 */     // MIs[0] round
     /* 1236714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236724 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11086:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4),
     /* 1236727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236749 */     // GIR_Coverage, 65193,
     /* 1236749 */     GIR_EraseRootFromParent_Done,
     /* 1236750 */   // Label 17907: @1236750
     /* 1236750 */   GIM_Try, /*On fail goto*//*Label 17908*/ GIMT_Encode4(1236830), // Rule ID 65196 //
     /* 1236755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1236766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1236769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236794 */     // MIs[0] round
     /* 1236794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236804 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11086:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2),
     /* 1236807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236829 */     // GIR_Coverage, 65196,
     /* 1236829 */     GIR_EraseRootFromParent_Done,
     /* 1236830 */   // Label 17908: @1236830
     /* 1236830 */   GIM_Try, /*On fail goto*//*Label 17909*/ GIMT_Encode4(1236910), // Rule ID 65197 //
     /* 1236835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1236846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1236849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236874 */     // MIs[0] round
     /* 1236874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236884 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11086:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2),
     /* 1236887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236909 */     // GIR_Coverage, 65197,
     /* 1236909 */     GIR_EraseRootFromParent_Done,
     /* 1236910 */   // Label 17909: @1236910
     /* 1236910 */   GIM_Try, /*On fail goto*//*Label 17910*/ GIMT_Encode4(1236990), // Rule ID 65200 //
     /* 1236915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1236926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1236929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1236932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236954 */     // MIs[0] round
     /* 1236954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236964 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11086:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1),
     /* 1236967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236989 */     // GIR_Coverage, 65200,
     /* 1236989 */     GIR_EraseRootFromParent_Done,
     /* 1236990 */   // Label 17910: @1236990
     /* 1236990 */   GIM_Try, /*On fail goto*//*Label 17911*/ GIMT_Encode4(1237070), // Rule ID 65201 //
     /* 1236995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1237006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1237009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237034 */     // MIs[0] round
     /* 1237034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237044 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11086:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1),
     /* 1237047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237069 */     // GIR_Coverage, 65201,
     /* 1237069 */     GIR_EraseRootFromParent_Done,
     /* 1237070 */   // Label 17911: @1237070
     /* 1237070 */   GIM_Try, /*On fail goto*//*Label 17912*/ GIMT_Encode4(1237150), // Rule ID 65204 //
     /* 1237075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1237086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1237089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1237092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237114 */     // MIs[0] round
     /* 1237114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237124 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2),
     /* 1237127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237149 */     // GIR_Coverage, 65204,
     /* 1237149 */     GIR_EraseRootFromParent_Done,
     /* 1237150 */   // Label 17912: @1237150
     /* 1237150 */   GIM_Try, /*On fail goto*//*Label 17913*/ GIMT_Encode4(1237230), // Rule ID 65205 //
     /* 1237155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1237166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1237169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1237172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237194 */     // MIs[0] round
     /* 1237194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237204 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2),
     /* 1237207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237229 */     // GIR_Coverage, 65205,
     /* 1237229 */     GIR_EraseRootFromParent_Done,
     /* 1237230 */   // Label 17913: @1237230
     /* 1237230 */   GIM_Try, /*On fail goto*//*Label 17914*/ GIMT_Encode4(1237310), // Rule ID 65208 //
     /* 1237235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1237246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1237249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237274 */     // MIs[0] round
     /* 1237274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237284 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4),
     /* 1237287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237309 */     // GIR_Coverage, 65208,
     /* 1237309 */     GIR_EraseRootFromParent_Done,
     /* 1237310 */   // Label 17914: @1237310
     /* 1237310 */   GIM_Try, /*On fail goto*//*Label 17915*/ GIMT_Encode4(1237390), // Rule ID 65209 //
     /* 1237315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1237326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1237329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237354 */     // MIs[0] round
     /* 1237354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237364 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4),
     /* 1237367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237389 */     // GIR_Coverage, 65209,
     /* 1237389 */     GIR_EraseRootFromParent_Done,
     /* 1237390 */   // Label 17915: @1237390
     /* 1237390 */   GIM_Try, /*On fail goto*//*Label 17916*/ GIMT_Encode4(1237470), // Rule ID 65212 //
     /* 1237395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1237406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1237409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237434 */     // MIs[0] round
     /* 1237434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237444 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8),
     /* 1237447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237469 */     // GIR_Coverage, 65212,
     /* 1237469 */     GIR_EraseRootFromParent_Done,
     /* 1237470 */   // Label 17916: @1237470
     /* 1237470 */   GIM_Try, /*On fail goto*//*Label 17917*/ GIMT_Encode4(1237550), // Rule ID 65213 //
     /* 1237475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1237486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1237489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237514 */     // MIs[0] round
     /* 1237514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237524 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8),
     /* 1237527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237549 */     // GIR_Coverage, 65213,
     /* 1237549 */     GIR_EraseRootFromParent_Done,
     /* 1237550 */   // Label 17917: @1237550
     /* 1237550 */   GIM_Try, /*On fail goto*//*Label 17918*/ GIMT_Encode4(1237630), // Rule ID 65216 //
     /* 1237555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1237566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1237569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1237572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237594 */     // MIs[0] round
     /* 1237594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237604 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11084:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4),
     /* 1237607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237629 */     // GIR_Coverage, 65216,
     /* 1237629 */     GIR_EraseRootFromParent_Done,
     /* 1237630 */   // Label 17918: @1237630
     /* 1237630 */   GIM_Try, /*On fail goto*//*Label 17919*/ GIMT_Encode4(1237710), // Rule ID 65217 //
     /* 1237635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1237646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1237649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1237652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237674 */     // MIs[0] round
     /* 1237674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237684 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11084:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4),
     /* 1237687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237709 */     // GIR_Coverage, 65217,
     /* 1237709 */     GIR_EraseRootFromParent_Done,
     /* 1237710 */   // Label 17919: @1237710
     /* 1237710 */   GIM_Try, /*On fail goto*//*Label 17920*/ GIMT_Encode4(1237790), // Rule ID 65220 //
     /* 1237715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1237726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1237729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1237732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237754 */     // MIs[0] round
     /* 1237754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237764 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11084:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2),
     /* 1237767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237789 */     // GIR_Coverage, 65220,
     /* 1237789 */     GIR_EraseRootFromParent_Done,
     /* 1237790 */   // Label 17920: @1237790
     /* 1237790 */   GIM_Try, /*On fail goto*//*Label 17921*/ GIMT_Encode4(1237870), // Rule ID 65221 //
     /* 1237795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1237806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1237809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1237812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237834 */     // MIs[0] round
     /* 1237834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237844 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11084:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2),
     /* 1237847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237869 */     // GIR_Coverage, 65221,
     /* 1237869 */     GIR_EraseRootFromParent_Done,
     /* 1237870 */   // Label 17921: @1237870
     /* 1237870 */   GIM_Try, /*On fail goto*//*Label 17922*/ GIMT_Encode4(1237950), // Rule ID 65224 //
     /* 1237875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1237886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1237889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237914 */     // MIs[0] round
     /* 1237914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237924 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11084:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1),
     /* 1237927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237949 */     // GIR_Coverage, 65224,
     /* 1237949 */     GIR_EraseRootFromParent_Done,
     /* 1237950 */   // Label 17922: @1237950
     /* 1237950 */   GIM_Try, /*On fail goto*//*Label 17923*/ GIMT_Encode4(1238030), // Rule ID 65225 //
     /* 1237955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1237966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1237969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237994 */     // MIs[0] round
     /* 1237994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238004 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11084:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1),
     /* 1238007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238029 */     // GIR_Coverage, 65225,
     /* 1238029 */     GIR_EraseRootFromParent_Done,
     /* 1238030 */   // Label 17923: @1238030
     /* 1238030 */   GIM_Try, /*On fail goto*//*Label 17924*/ GIMT_Encode4(1238110), // Rule ID 65228 //
     /* 1238035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1238038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1238043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1238046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1238049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1238052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238074 */     // MIs[0] round
     /* 1238074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238084 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11084:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2),
     /* 1238087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238109 */     // GIR_Coverage, 65228,
     /* 1238109 */     GIR_EraseRootFromParent_Done,
     /* 1238110 */   // Label 17924: @1238110
     /* 1238110 */   GIM_Try, /*On fail goto*//*Label 17925*/ GIMT_Encode4(1238190), // Rule ID 65229 //
     /* 1238115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1238118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1238123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1238126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1238129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1238132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238154 */     // MIs[0] round
     /* 1238154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238164 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11084:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2),
     /* 1238167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238189 */     // GIR_Coverage, 65229,
     /* 1238189 */     GIR_EraseRootFromParent_Done,
     /* 1238190 */   // Label 17925: @1238190
     /* 1238190 */   GIM_Try, /*On fail goto*//*Label 17926*/ GIMT_Encode4(1238270), // Rule ID 65232 //
     /* 1238195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1238198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1238203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1238206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1238209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1238212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238234 */     // MIs[0] round
     /* 1238234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238244 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4),
     /* 1238247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238269 */     // GIR_Coverage, 65232,
     /* 1238269 */     GIR_EraseRootFromParent_Done,
     /* 1238270 */   // Label 17926: @1238270
     /* 1238270 */   GIM_Try, /*On fail goto*//*Label 17927*/ GIMT_Encode4(1238350), // Rule ID 65233 //
     /* 1238275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1238278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1238283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1238286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1238289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1238292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238314 */     // MIs[0] round
     /* 1238314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238324 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4),
     /* 1238327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238349 */     // GIR_Coverage, 65233,
     /* 1238349 */     GIR_EraseRootFromParent_Done,
     /* 1238350 */   // Label 17927: @1238350
     /* 1238350 */   GIM_Try, /*On fail goto*//*Label 17928*/ GIMT_Encode4(1238430), // Rule ID 65236 //
     /* 1238355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1238358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1238363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1238366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1238369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1238372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238394 */     // MIs[0] round
     /* 1238394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238404 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8),
     /* 1238407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238429 */     // GIR_Coverage, 65236,
     /* 1238429 */     GIR_EraseRootFromParent_Done,
     /* 1238430 */   // Label 17928: @1238430
     /* 1238430 */   GIM_Try, /*On fail goto*//*Label 17929*/ GIMT_Encode4(1238510), // Rule ID 65237 //
     /* 1238435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1238438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1238443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1238446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1238449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1238452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238474 */     // MIs[0] round
     /* 1238474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238484 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8),
     /* 1238487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238509 */     // GIR_Coverage, 65237,
     /* 1238509 */     GIR_EraseRootFromParent_Done,
     /* 1238510 */   // Label 17929: @1238510
     /* 1238510 */   GIM_Try, /*On fail goto*//*Label 17930*/ GIMT_Encode4(1238594), // Rule ID 2730 //
     /* 1238515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1238523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238568 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1238571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238593 */     // GIR_Coverage, 2730,
     /* 1238593 */     GIR_EraseRootFromParent_Done,
     /* 1238594 */   // Label 17930: @1238594
     /* 1238594 */   GIM_Try, /*On fail goto*//*Label 17931*/ GIMT_Encode4(1238678), // Rule ID 2731 //
     /* 1238599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1238607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238652 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1238655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238677 */     // GIR_Coverage, 2731,
     /* 1238677 */     GIR_EraseRootFromParent_Done,
     /* 1238678 */   // Label 17931: @1238678
     /* 1238678 */   GIM_Try, /*On fail goto*//*Label 17932*/ GIMT_Encode4(1238762), // Rule ID 2742 //
     /* 1238683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1238691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238736 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1238739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1238745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1238747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238761 */     // GIR_Coverage, 2742,
     /* 1238761 */     GIR_EraseRootFromParent_Done,
     /* 1238762 */   // Label 17932: @1238762
     /* 1238762 */   GIM_Try, /*On fail goto*//*Label 17933*/ GIMT_Encode4(1238846), // Rule ID 2743 //
     /* 1238767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1238775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238820 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1238823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1238829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1238831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238845 */     // GIR_Coverage, 2743,
     /* 1238845 */     GIR_EraseRootFromParent_Done,
     /* 1238846 */   // Label 17933: @1238846
     /* 1238846 */   GIM_Try, /*On fail goto*//*Label 17934*/ GIMT_Encode4(1238927), // Rule ID 2744 //
     /* 1238851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1238862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1238865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238904 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1238904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1238907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238926 */     // GIR_Coverage, 2744,
     /* 1238926 */     GIR_EraseRootFromParent_Done,
     /* 1238927 */   // Label 17934: @1238927
     /* 1238927 */   GIM_Try, /*On fail goto*//*Label 17935*/ GIMT_Encode4(1239008), // Rule ID 2745 //
     /* 1238932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1238943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1238946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238985 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1238985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1238988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239007 */     // GIR_Coverage, 2745,
     /* 1239007 */     GIR_EraseRootFromParent_Done,
     /* 1239008 */   // Label 17935: @1239008
     /* 1239008 */   GIM_Try, /*On fail goto*//*Label 17936*/ GIMT_Encode4(1239092), // Rule ID 2794 //
     /* 1239013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1239021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1239024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1239027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1239030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1239033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239066 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1239066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1239069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1239073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239091 */     // GIR_Coverage, 2794,
     /* 1239091 */     GIR_EraseRootFromParent_Done,
     /* 1239092 */   // Label 17936: @1239092
     /* 1239092 */   GIM_Try, /*On fail goto*//*Label 17937*/ GIMT_Encode4(1239176), // Rule ID 2795 //
     /* 1239097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1239105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1239108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1239111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1239114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1239117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239150 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1239150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1239153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1239157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239175 */     // GIR_Coverage, 2795,
     /* 1239175 */     GIR_EraseRootFromParent_Done,
     /* 1239176 */   // Label 17937: @1239176
     /* 1239176 */   GIM_Try, /*On fail goto*//*Label 17938*/ GIMT_Encode4(1239257), // Rule ID 5130 //
     /* 1239181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1239192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1239195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1239198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1239201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239234 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1239234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1239237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239256 */     // GIR_Coverage, 5130,
     /* 1239256 */     GIR_EraseRootFromParent_Done,
     /* 1239257 */   // Label 17938: @1239257
     /* 1239257 */   GIM_Try, /*On fail goto*//*Label 17939*/ GIMT_Encode4(1239338), // Rule ID 5131 //
     /* 1239262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1239273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1239276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1239279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1239282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239315 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1239315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1239318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239337 */     // GIR_Coverage, 5131,
     /* 1239337 */     GIR_EraseRootFromParent_Done,
     /* 1239338 */   // Label 17939: @1239338
     /* 1239338 */   GIM_Try, /*On fail goto*//*Label 17940*/ GIMT_Encode4(1239419), // Rule ID 5132 //
     /* 1239343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1239354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1239357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1239360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1239363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1239396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239418 */     // GIR_Coverage, 5132,
     /* 1239418 */     GIR_EraseRootFromParent_Done,
     /* 1239419 */   // Label 17940: @1239419
     /* 1239419 */   GIM_Try, /*On fail goto*//*Label 17941*/ GIMT_Encode4(1239500), // Rule ID 5133 //
     /* 1239424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1239435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1239438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1239441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1239444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239477 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1239477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239499 */     // GIR_Coverage, 5133,
     /* 1239499 */     GIR_EraseRootFromParent_Done,
     /* 1239500 */   // Label 17941: @1239500
     /* 1239500 */   GIM_Try, /*On fail goto*//*Label 17942*/ GIMT_Encode4(1239581), // Rule ID 5134 //
     /* 1239505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1239516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1239519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1239522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1239525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239558 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1239558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1239561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239580 */     // GIR_Coverage, 5134,
     /* 1239580 */     GIR_EraseRootFromParent_Done,
     /* 1239581 */   // Label 17942: @1239581
     /* 1239581 */   GIM_Try, /*On fail goto*//*Label 17943*/ GIMT_Encode4(1239662), // Rule ID 5135 //
     /* 1239586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1239597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1239600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1239603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1239606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239639 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1239639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1239642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239661 */     // GIR_Coverage, 5135,
     /* 1239661 */     GIR_EraseRootFromParent_Done,
     /* 1239662 */   // Label 17943: @1239662
     /* 1239662 */   GIM_Try, /*On fail goto*//*Label 17944*/ GIMT_Encode4(1239743), // Rule ID 5136 //
     /* 1239667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1239678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1239681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1239684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1239687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239720 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1239720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239742 */     // GIR_Coverage, 5136,
     /* 1239742 */     GIR_EraseRootFromParent_Done,
     /* 1239743 */   // Label 17944: @1239743
     /* 1239743 */   GIM_Try, /*On fail goto*//*Label 17945*/ GIMT_Encode4(1239824), // Rule ID 5137 //
     /* 1239748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1239759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1239762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1239765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1239768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239801 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1239801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239823 */     // GIR_Coverage, 5137,
     /* 1239823 */     GIR_EraseRootFromParent_Done,
     /* 1239824 */   // Label 17945: @1239824
     /* 1239824 */   GIM_Try, /*On fail goto*//*Label 17946*/ GIMT_Encode4(1239905), // Rule ID 5138 //
     /* 1239829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1239840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1239843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1239846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1239849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239882 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1239882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239904 */     // GIR_Coverage, 5138,
     /* 1239904 */     GIR_EraseRootFromParent_Done,
     /* 1239905 */   // Label 17946: @1239905
     /* 1239905 */   GIM_Try, /*On fail goto*//*Label 17947*/ GIMT_Encode4(1239986), // Rule ID 5139 //
     /* 1239910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1239921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1239924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1239927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1239930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239963 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1239963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239985 */     // GIR_Coverage, 5139,
     /* 1239985 */     GIR_EraseRootFromParent_Done,
     /* 1239986 */   // Label 17947: @1239986
     /* 1239986 */   GIM_Try, /*On fail goto*//*Label 17948*/ GIMT_Encode4(1240067), // Rule ID 5140 //
     /* 1239991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1240002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1240005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1240008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1240011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240044 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240066 */     // GIR_Coverage, 5140,
     /* 1240066 */     GIR_EraseRootFromParent_Done,
     /* 1240067 */   // Label 17948: @1240067
     /* 1240067 */   GIM_Try, /*On fail goto*//*Label 17949*/ GIMT_Encode4(1240148), // Rule ID 5141 //
     /* 1240072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1240083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1240086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1240089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1240092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240125 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240147 */     // GIR_Coverage, 5141,
     /* 1240147 */     GIR_EraseRootFromParent_Done,
     /* 1240148 */   // Label 17949: @1240148
     /* 1240148 */   GIM_Try, /*On fail goto*//*Label 17950*/ GIMT_Encode4(1240229), // Rule ID 5142 //
     /* 1240153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1240164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1240167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1240170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1240173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1240176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240206 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1240206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240228 */     // GIR_Coverage, 5142,
     /* 1240228 */     GIR_EraseRootFromParent_Done,
     /* 1240229 */   // Label 17950: @1240229
     /* 1240229 */   GIM_Try, /*On fail goto*//*Label 17951*/ GIMT_Encode4(1240310), // Rule ID 5143 //
     /* 1240234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1240245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1240248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1240251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1240254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1240257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240287 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1240287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240309 */     // GIR_Coverage, 5143,
     /* 1240309 */     GIR_EraseRootFromParent_Done,
     /* 1240310 */   // Label 17951: @1240310
     /* 1240310 */   GIM_Try, /*On fail goto*//*Label 17952*/ GIMT_Encode4(1240391), // Rule ID 5144 //
     /* 1240315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1240326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1240329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1240332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1240335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240368 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1240368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240390 */     // GIR_Coverage, 5144,
     /* 1240390 */     GIR_EraseRootFromParent_Done,
     /* 1240391 */   // Label 17952: @1240391
     /* 1240391 */   GIM_Try, /*On fail goto*//*Label 17953*/ GIMT_Encode4(1240472), // Rule ID 5145 //
     /* 1240396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1240407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1240410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1240413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1240416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240449 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1240449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240471 */     // GIR_Coverage, 5145,
     /* 1240471 */     GIR_EraseRootFromParent_Done,
     /* 1240472 */   // Label 17953: @1240472
     /* 1240472 */   GIM_Try, /*On fail goto*//*Label 17954*/ GIMT_Encode4(1240553), // Rule ID 5146 //
     /* 1240477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1240480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1240488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1240491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1240494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1240497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1240530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240552 */     // GIR_Coverage, 5146,
     /* 1240552 */     GIR_EraseRootFromParent_Done,
     /* 1240553 */   // Label 17954: @1240553
     /* 1240553 */   GIM_Try, /*On fail goto*//*Label 17955*/ GIMT_Encode4(1240634), // Rule ID 5147 //
     /* 1240558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1240561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1240569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1240572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1240575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1240578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240611 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1240611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240633 */     // GIR_Coverage, 5147,
     /* 1240633 */     GIR_EraseRootFromParent_Done,
     /* 1240634 */   // Label 17955: @1240634
     /* 1240634 */   GIM_Try, /*On fail goto*//*Label 17956*/ GIMT_Encode4(1240715), // Rule ID 5148 //
     /* 1240639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1240650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1240653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1240656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1240659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240692 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1240695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240714 */     // GIR_Coverage, 5148,
     /* 1240714 */     GIR_EraseRootFromParent_Done,
     /* 1240715 */   // Label 17956: @1240715
     /* 1240715 */   GIM_Try, /*On fail goto*//*Label 17957*/ GIMT_Encode4(1240796), // Rule ID 5149 //
     /* 1240720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1240731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1240734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1240737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1240740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240773 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1240776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240795 */     // GIR_Coverage, 5149,
     /* 1240795 */     GIR_EraseRootFromParent_Done,
     /* 1240796 */   // Label 17957: @1240796
     /* 1240796 */   GIM_Try, /*On fail goto*//*Label 17958*/ GIMT_Encode4(1240877), // Rule ID 5150 //
     /* 1240801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1240812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1240815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1240818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1240821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1240824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240854 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1240857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240876 */     // GIR_Coverage, 5150,
     /* 1240876 */     GIR_EraseRootFromParent_Done,
     /* 1240877 */   // Label 17958: @1240877
     /* 1240877 */   GIM_Try, /*On fail goto*//*Label 17959*/ GIMT_Encode4(1240958), // Rule ID 5151 //
     /* 1240882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1240893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1240896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1240899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1240902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1240905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240935 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1240938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240957 */     // GIR_Coverage, 5151,
     /* 1240957 */     GIR_EraseRootFromParent_Done,
     /* 1240958 */   // Label 17959: @1240958
     /* 1240958 */   GIM_Try, /*On fail goto*//*Label 17960*/ GIMT_Encode4(1241039), // Rule ID 5152 //
     /* 1240963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1240974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1240977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1240980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1240983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1240986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1240993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241016 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1241016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241038 */     // GIR_Coverage, 5152,
     /* 1241038 */     GIR_EraseRootFromParent_Done,
     /* 1241039 */   // Label 17960: @1241039
     /* 1241039 */   GIM_Try, /*On fail goto*//*Label 17961*/ GIMT_Encode4(1241120), // Rule ID 5153 //
     /* 1241044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1241055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1241058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1241061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1241064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1241067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241097 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1241097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241119 */     // GIR_Coverage, 5153,
     /* 1241119 */     GIR_EraseRootFromParent_Done,
     /* 1241120 */   // Label 17961: @1241120
     /* 1241120 */   GIM_Try, /*On fail goto*//*Label 17962*/ GIMT_Encode4(1241201), // Rule ID 5154 //
     /* 1241125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1241136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1241139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1241142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1241145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241178 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1241178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241200 */     // GIR_Coverage, 5154,
     /* 1241200 */     GIR_EraseRootFromParent_Done,
     /* 1241201 */   // Label 17962: @1241201
     /* 1241201 */   GIM_Try, /*On fail goto*//*Label 17963*/ GIMT_Encode4(1241282), // Rule ID 5155 //
     /* 1241206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1241217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1241220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1241223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1241226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241259 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1241259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241281 */     // GIR_Coverage, 5155,
     /* 1241281 */     GIR_EraseRootFromParent_Done,
     /* 1241282 */   // Label 17963: @1241282
     /* 1241282 */   GIM_Try, /*On fail goto*//*Label 17964*/ GIMT_Encode4(1241363), // Rule ID 5156 //
     /* 1241287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1241298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1241301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1241304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1241307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1241340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241362 */     // GIR_Coverage, 5156,
     /* 1241362 */     GIR_EraseRootFromParent_Done,
     /* 1241363 */   // Label 17964: @1241363
     /* 1241363 */   GIM_Try, /*On fail goto*//*Label 17965*/ GIMT_Encode4(1241444), // Rule ID 5157 //
     /* 1241368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1241379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1241382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1241385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1241388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241421 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1241421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241443 */     // GIR_Coverage, 5157,
     /* 1241443 */     GIR_EraseRootFromParent_Done,
     /* 1241444 */   // Label 17965: @1241444
     /* 1241444 */   GIM_Try, /*On fail goto*//*Label 17966*/ GIMT_Encode4(1241525), // Rule ID 5158 //
     /* 1241449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1241460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1241463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1241466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1241469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1241472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241502 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1241502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241524 */     // GIR_Coverage, 5158,
     /* 1241524 */     GIR_EraseRootFromParent_Done,
     /* 1241525 */   // Label 17966: @1241525
     /* 1241525 */   GIM_Try, /*On fail goto*//*Label 17967*/ GIMT_Encode4(1241606), // Rule ID 5159 //
     /* 1241530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1241541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1241544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1241547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1241550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1241553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241583 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1241583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241605 */     // GIR_Coverage, 5159,
     /* 1241605 */     GIR_EraseRootFromParent_Done,
     /* 1241606 */   // Label 17967: @1241606
     /* 1241606 */   GIM_Try, /*On fail goto*//*Label 17968*/ GIMT_Encode4(1241687), // Rule ID 5160 //
     /* 1241611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1241622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1241625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1241628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1241631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241686 */     // GIR_Coverage, 5160,
     /* 1241686 */     GIR_EraseRootFromParent_Done,
     /* 1241687 */   // Label 17968: @1241687
     /* 1241687 */   GIM_Try, /*On fail goto*//*Label 17969*/ GIMT_Encode4(1241768), // Rule ID 5161 //
     /* 1241692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1241703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1241706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1241709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1241712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241745 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241767 */     // GIR_Coverage, 5161,
     /* 1241767 */     GIR_EraseRootFromParent_Done,
     /* 1241768 */   // Label 17969: @1241768
     /* 1241768 */   GIM_Try, /*On fail goto*//*Label 17970*/ GIMT_Encode4(1241849), // Rule ID 5162 //
     /* 1241773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1241784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1241787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1241790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1241793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241826 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241848 */     // GIR_Coverage, 5162,
     /* 1241848 */     GIR_EraseRootFromParent_Done,
     /* 1241849 */   // Label 17970: @1241849
     /* 1241849 */   GIM_Try, /*On fail goto*//*Label 17971*/ GIMT_Encode4(1241930), // Rule ID 5163 //
     /* 1241854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1241865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1241868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1241871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1241874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241907 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241929 */     // GIR_Coverage, 5163,
     /* 1241929 */     GIR_EraseRootFromParent_Done,
     /* 1241930 */   // Label 17971: @1241930
     /* 1241930 */   GIM_Try, /*On fail goto*//*Label 17972*/ GIMT_Encode4(1242011), // Rule ID 5164 //
     /* 1241935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1241946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1241949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1241952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1241955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241988 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242010 */     // GIR_Coverage, 5164,
     /* 1242010 */     GIR_EraseRootFromParent_Done,
     /* 1242011 */   // Label 17972: @1242011
     /* 1242011 */   GIM_Try, /*On fail goto*//*Label 17973*/ GIMT_Encode4(1242092), // Rule ID 5165 //
     /* 1242016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1242027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1242030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1242033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1242036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1242039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242069 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1242069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1242072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242091 */     // GIR_Coverage, 5165,
     /* 1242091 */     GIR_EraseRootFromParent_Done,
     /* 1242092 */   // Label 17973: @1242092
     /* 1242092 */   GIM_Try, /*On fail goto*//*Label 17974*/ GIMT_Encode4(1242173), // Rule ID 5166 //
     /* 1242097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1242100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1242108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1242111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1242114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1242117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1242127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1242150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1242153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242172 */     // GIR_Coverage, 5166,
     /* 1242172 */     GIR_EraseRootFromParent_Done,
     /* 1242173 */   // Label 17974: @1242173
     /* 1242173 */   GIM_Try, /*On fail goto*//*Label 17975*/ GIMT_Encode4(1242254), // Rule ID 5167 //
     /* 1242178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1242181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1242189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1242192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1242195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1242198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1242208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242231 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1242231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1242234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242253 */     // GIR_Coverage, 5167,
     /* 1242253 */     GIR_EraseRootFromParent_Done,
     /* 1242254 */   // Label 17975: @1242254
     /* 1242254 */   GIM_Try, /*On fail goto*//*Label 17976*/ GIMT_Encode4(1242335), // Rule ID 5168 //
     /* 1242259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1242262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1242270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1242273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1242276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1242279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1242289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242312 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1242312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1242315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242334 */     // GIR_Coverage, 5168,
     /* 1242334 */     GIR_EraseRootFromParent_Done,
     /* 1242335 */   // Label 17976: @1242335
     /* 1242335 */   GIM_Try, /*On fail goto*//*Label 17977*/ GIMT_Encode4(1242416), // Rule ID 5169 //
     /* 1242340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1242343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1242351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1242354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1242357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1242360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1242370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1242393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1242396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242415 */     // GIR_Coverage, 5169,
     /* 1242415 */     GIR_EraseRootFromParent_Done,
     /* 1242416 */   // Label 17977: @1242416
     /* 1242416 */   GIM_Try, /*On fail goto*//*Label 17978*/ GIMT_Encode4(1242497), // Rule ID 5170 //
     /* 1242421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1242424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1242432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1242435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1242438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1242441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242474 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1242474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1242477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242496 */     // GIR_Coverage, 5170,
     /* 1242496 */     GIR_EraseRootFromParent_Done,
     /* 1242497 */   // Label 17978: @1242497
     /* 1242497 */   GIM_Try, /*On fail goto*//*Label 17979*/ GIMT_Encode4(1242578), // Rule ID 5171 //
     /* 1242502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1242505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1242513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1242516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1242519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1242522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242555 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1242555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1242558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242577 */     // GIR_Coverage, 5171,
     /* 1242577 */     GIR_EraseRootFromParent_Done,
     /* 1242578 */   // Label 17979: @1242578
     /* 1242578 */   GIM_Try, /*On fail goto*//*Label 17980*/ GIMT_Encode4(1242659), // Rule ID 5172 //
     /* 1242583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1242594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1242597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242636 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1242639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242658 */     // GIR_Coverage, 5172,
     /* 1242658 */     GIR_EraseRootFromParent_Done,
     /* 1242659 */   // Label 17980: @1242659
     /* 1242659 */   GIM_Try, /*On fail goto*//*Label 17981*/ GIMT_Encode4(1242740), // Rule ID 5173 //
     /* 1242664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1242675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1242678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242717 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1242720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242739 */     // GIR_Coverage, 5173,
     /* 1242739 */     GIR_EraseRootFromParent_Done,
     /* 1242740 */   // Label 17981: @1242740
     /* 1242740 */   GIM_Try, /*On fail goto*//*Label 17982*/ GIMT_Encode4(1242821), // Rule ID 5174 //
     /* 1242745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1242756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1242759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1242762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242798 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1242801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242820 */     // GIR_Coverage, 5174,
     /* 1242820 */     GIR_EraseRootFromParent_Done,
     /* 1242821 */   // Label 17982: @1242821
     /* 1242821 */   GIM_Try, /*On fail goto*//*Label 17983*/ GIMT_Encode4(1242902), // Rule ID 5175 //
     /* 1242826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1242837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1242840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1242843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242879 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1242882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242901 */     // GIR_Coverage, 5175,
     /* 1242901 */     GIR_EraseRootFromParent_Done,
     /* 1242902 */   // Label 17983: @1242902
     /* 1242902 */   GIM_Try, /*On fail goto*//*Label 17984*/ GIMT_Encode4(1242983), // Rule ID 5176 //
     /* 1242907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1242918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1242921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1242924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242960 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1242963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242982 */     // GIR_Coverage, 5176,
     /* 1242982 */     GIR_EraseRootFromParent_Done,
     /* 1242983 */   // Label 17984: @1242983
     /* 1242983 */   GIM_Try, /*On fail goto*//*Label 17985*/ GIMT_Encode4(1243064), // Rule ID 5177 //
     /* 1242988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1242999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1243002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1243005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243041 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1243044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243063 */     // GIR_Coverage, 5177,
     /* 1243063 */     GIR_EraseRootFromParent_Done,
     /* 1243064 */   // Label 17985: @1243064
     /* 1243064 */   GIM_Try, /*On fail goto*//*Label 17986*/ GIMT_Encode4(1243145), // Rule ID 5178 //
     /* 1243069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1243080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1243083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1243086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243122 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1243125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243144 */     // GIR_Coverage, 5178,
     /* 1243144 */     GIR_EraseRootFromParent_Done,
     /* 1243145 */   // Label 17986: @1243145
     /* 1243145 */   GIM_Try, /*On fail goto*//*Label 17987*/ GIMT_Encode4(1243226), // Rule ID 5179 //
     /* 1243150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1243161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1243164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1243167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243203 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1243206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243225 */     // GIR_Coverage, 5179,
     /* 1243225 */     GIR_EraseRootFromParent_Done,
     /* 1243226 */   // Label 17987: @1243226
     /* 1243226 */   GIM_Try, /*On fail goto*//*Label 17988*/ GIMT_Encode4(1243307), // Rule ID 5180 //
     /* 1243231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1243242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1243245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1243248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1243287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243306 */     // GIR_Coverage, 5180,
     /* 1243306 */     GIR_EraseRootFromParent_Done,
     /* 1243307 */   // Label 17988: @1243307
     /* 1243307 */   GIM_Try, /*On fail goto*//*Label 17989*/ GIMT_Encode4(1243388), // Rule ID 5181 //
     /* 1243312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1243323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1243326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1243329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243365 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1243368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243387 */     // GIR_Coverage, 5181,
     /* 1243387 */     GIR_EraseRootFromParent_Done,
     /* 1243388 */   // Label 17989: @1243388
     /* 1243388 */   GIM_Try, /*On fail goto*//*Label 17990*/ GIMT_Encode4(1243469), // Rule ID 5182 //
     /* 1243393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1243404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1243407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1243410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243446 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1243446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1243449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243468 */     // GIR_Coverage, 5182,
     /* 1243468 */     GIR_EraseRootFromParent_Done,
     /* 1243469 */   // Label 17990: @1243469
     /* 1243469 */   GIM_Try, /*On fail goto*//*Label 17991*/ GIMT_Encode4(1243550), // Rule ID 5183 //
     /* 1243474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1243485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1243488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1243491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243527 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1243527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1243530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243549 */     // GIR_Coverage, 5183,
     /* 1243549 */     GIR_EraseRootFromParent_Done,
     /* 1243550 */   // Label 17991: @1243550
     /* 1243550 */   GIM_Try, /*On fail goto*//*Label 17992*/ GIMT_Encode4(1243631), // Rule ID 5184 //
     /* 1243555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1243566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1243569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1243572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243608 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243630 */     // GIR_Coverage, 5184,
     /* 1243630 */     GIR_EraseRootFromParent_Done,
     /* 1243631 */   // Label 17992: @1243631
     /* 1243631 */   GIM_Try, /*On fail goto*//*Label 17993*/ GIMT_Encode4(1243712), // Rule ID 5185 //
     /* 1243636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1243647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1243650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1243653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243689 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243711 */     // GIR_Coverage, 5185,
     /* 1243711 */     GIR_EraseRootFromParent_Done,
     /* 1243712 */   // Label 17993: @1243712
     /* 1243712 */   GIM_Try, /*On fail goto*//*Label 17994*/ GIMT_Encode4(1243793), // Rule ID 5186 //
     /* 1243717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1243728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1243731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243792 */     // GIR_Coverage, 5186,
     /* 1243792 */     GIR_EraseRootFromParent_Done,
     /* 1243793 */   // Label 17994: @1243793
     /* 1243793 */   GIM_Try, /*On fail goto*//*Label 17995*/ GIMT_Encode4(1243874), // Rule ID 5187 //
     /* 1243798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1243809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1243812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243851 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243873 */     // GIR_Coverage, 5187,
     /* 1243873 */     GIR_EraseRootFromParent_Done,
     /* 1243874 */   // Label 17995: @1243874
     /* 1243874 */   GIM_Try, /*On fail goto*//*Label 17996*/ GIMT_Encode4(1243955), // Rule ID 5188 //
     /* 1243879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1243890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1243893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1243896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243932 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1243932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243954 */     // GIR_Coverage, 5188,
     /* 1243954 */     GIR_EraseRootFromParent_Done,
     /* 1243955 */   // Label 17996: @1243955
     /* 1243955 */   GIM_Try, /*On fail goto*//*Label 17997*/ GIMT_Encode4(1244036), // Rule ID 5189 //
     /* 1243960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1243971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1243974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1243977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244013 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1244013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1244016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244035 */     // GIR_Coverage, 5189,
     /* 1244035 */     GIR_EraseRootFromParent_Done,
     /* 1244036 */   // Label 17997: @1244036
     /* 1244036 */   GIM_Try, /*On fail goto*//*Label 17998*/ GIMT_Encode4(1244117), // Rule ID 5190 //
     /* 1244041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1244044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1244052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1244055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1244058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1244064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1244094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1244097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1244115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244116 */     // GIR_Coverage, 5190,
     /* 1244116 */     GIR_EraseRootFromParent_Done,
     /* 1244117 */   // Label 17998: @1244117
     /* 1244117 */   GIM_Try, /*On fail goto*//*Label 17999*/ GIMT_Encode4(1244198), // Rule ID 5191 //
     /* 1244122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1244125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1244133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1244136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1244139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1244145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244175 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1244175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1244178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1244196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244197 */     // GIR_Coverage, 5191,
     /* 1244197 */     GIR_EraseRootFromParent_Done,
     /* 1244198 */   // Label 17999: @1244198
     /* 1244198 */   GIM_Try, /*On fail goto*//*Label 18000*/ GIMT_Encode4(1244279), // Rule ID 5192 //
     /* 1244203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1244214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1244217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1244220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244278 */     // GIR_Coverage, 5192,
     /* 1244278 */     GIR_EraseRootFromParent_Done,
     /* 1244279 */   // Label 18000: @1244279
     /* 1244279 */   GIM_Try, /*On fail goto*//*Label 18001*/ GIMT_Encode4(1244360), // Rule ID 5193 //
     /* 1244284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1244295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1244298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1244301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244337 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244359 */     // GIR_Coverage, 5193,
     /* 1244359 */     GIR_EraseRootFromParent_Done,
     /* 1244360 */   // Label 18001: @1244360
     /* 1244360 */   GIM_Try, /*On fail goto*//*Label 18002*/ GIMT_Encode4(1244441), // Rule ID 5194 //
     /* 1244365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1244376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1244379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1244382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244418 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244440 */     // GIR_Coverage, 5194,
     /* 1244440 */     GIR_EraseRootFromParent_Done,
     /* 1244441 */   // Label 18002: @1244441
     /* 1244441 */   GIM_Try, /*On fail goto*//*Label 18003*/ GIMT_Encode4(1244522), // Rule ID 5195 //
     /* 1244446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1244457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1244460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1244463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244499 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244521 */     // GIR_Coverage, 5195,
     /* 1244521 */     GIR_EraseRootFromParent_Done,
     /* 1244522 */   // Label 18003: @1244522
     /* 1244522 */   GIM_Try, /*On fail goto*//*Label 18004*/ GIMT_Encode4(1244603), // Rule ID 5196 //
     /* 1244527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1244538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1244541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1244544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1244550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244580 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1244583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244602 */     // GIR_Coverage, 5196,
     /* 1244602 */     GIR_EraseRootFromParent_Done,
     /* 1244603 */   // Label 18004: @1244603
     /* 1244603 */   GIM_Try, /*On fail goto*//*Label 18005*/ GIMT_Encode4(1244684), // Rule ID 5197 //
     /* 1244608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1244619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1244622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1244625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1244631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244661 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1244664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244683 */     // GIR_Coverage, 5197,
     /* 1244683 */     GIR_EraseRootFromParent_Done,
     /* 1244684 */   // Label 18005: @1244684
     /* 1244684 */   GIM_Try, /*On fail goto*//*Label 18006*/ GIMT_Encode4(1244765), // Rule ID 5198 //
     /* 1244689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1244700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1244703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244742 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244764 */     // GIR_Coverage, 5198,
     /* 1244764 */     GIR_EraseRootFromParent_Done,
     /* 1244765 */   // Label 18006: @1244765
     /* 1244765 */   GIM_Try, /*On fail goto*//*Label 18007*/ GIMT_Encode4(1244846), // Rule ID 5199 //
     /* 1244770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1244781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1244784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244845 */     // GIR_Coverage, 5199,
     /* 1244845 */     GIR_EraseRootFromParent_Done,
     /* 1244846 */   // Label 18007: @1244846
     /* 1244846 */   GIM_Try, /*On fail goto*//*Label 18008*/ GIMT_Encode4(1244927), // Rule ID 5200 //
     /* 1244851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1244862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1244865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244904 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244926 */     // GIR_Coverage, 5200,
     /* 1244926 */     GIR_EraseRootFromParent_Done,
     /* 1244927 */   // Label 18008: @1244927
     /* 1244927 */   GIM_Try, /*On fail goto*//*Label 18009*/ GIMT_Encode4(1245008), // Rule ID 5201 //
     /* 1244932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1244943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1244946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244985 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245007 */     // GIR_Coverage, 5201,
     /* 1245007 */     GIR_EraseRootFromParent_Done,
     /* 1245008 */   // Label 18009: @1245008
     /* 1245008 */   GIM_Try, /*On fail goto*//*Label 18010*/ GIMT_Encode4(1245089), // Rule ID 5202 //
     /* 1245013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1245024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1245027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1245030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1245036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245066 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1245066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245088 */     // GIR_Coverage, 5202,
     /* 1245088 */     GIR_EraseRootFromParent_Done,
     /* 1245089 */   // Label 18010: @1245089
     /* 1245089 */   GIM_Try, /*On fail goto*//*Label 18011*/ GIMT_Encode4(1245170), // Rule ID 5203 //
     /* 1245094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1245105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1245108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1245111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1245117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245147 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1245147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245169 */     // GIR_Coverage, 5203,
     /* 1245169 */     GIR_EraseRootFromParent_Done,
     /* 1245170 */   // Label 18011: @1245170
     /* 1245170 */   GIM_Try, /*On fail goto*//*Label 18012*/ GIMT_Encode4(1245251), // Rule ID 5204 //
     /* 1245175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1245186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1245189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1245192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1245231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245250 */     // GIR_Coverage, 5204,
     /* 1245250 */     GIR_EraseRootFromParent_Done,
     /* 1245251 */   // Label 18012: @1245251
     /* 1245251 */   GIM_Try, /*On fail goto*//*Label 18013*/ GIMT_Encode4(1245332), // Rule ID 5205 //
     /* 1245256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1245267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1245270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1245273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245309 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1245312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245331 */     // GIR_Coverage, 5205,
     /* 1245331 */     GIR_EraseRootFromParent_Done,
     /* 1245332 */   // Label 18013: @1245332
     /* 1245332 */   GIM_Try, /*On fail goto*//*Label 18014*/ GIMT_Encode4(1245413), // Rule ID 5206 //
     /* 1245337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1245348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1245351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1245354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245390 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245412 */     // GIR_Coverage, 5206,
     /* 1245412 */     GIR_EraseRootFromParent_Done,
     /* 1245413 */   // Label 18014: @1245413
     /* 1245413 */   GIM_Try, /*On fail goto*//*Label 18015*/ GIMT_Encode4(1245494), // Rule ID 5207 //
     /* 1245418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1245429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1245432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1245435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245471 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245493 */     // GIR_Coverage, 5207,
     /* 1245493 */     GIR_EraseRootFromParent_Done,
     /* 1245494 */   // Label 18015: @1245494
     /* 1245494 */   GIM_Try, /*On fail goto*//*Label 18016*/ GIMT_Encode4(1245575), // Rule ID 5208 //
     /* 1245499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1245510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1245513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245552 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245574 */     // GIR_Coverage, 5208,
     /* 1245574 */     GIR_EraseRootFromParent_Done,
     /* 1245575 */   // Label 18016: @1245575
     /* 1245575 */   GIM_Try, /*On fail goto*//*Label 18017*/ GIMT_Encode4(1245656), // Rule ID 5209 //
     /* 1245580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1245591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1245594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245633 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245655 */     // GIR_Coverage, 5209,
     /* 1245655 */     GIR_EraseRootFromParent_Done,
     /* 1245656 */   // Label 18017: @1245656
     /* 1245656 */   GIM_Try, /*On fail goto*//*Label 18018*/ GIMT_Encode4(1245737), // Rule ID 5210 //
     /* 1245661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1245672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1245675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245714 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1245717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245736 */     // GIR_Coverage, 5210,
     /* 1245736 */     GIR_EraseRootFromParent_Done,
     /* 1245737 */   // Label 18018: @1245737
     /* 1245737 */   GIM_Try, /*On fail goto*//*Label 18019*/ GIMT_Encode4(1245818), // Rule ID 5211 //
     /* 1245742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1245753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1245756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245795 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1245798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245817 */     // GIR_Coverage, 5211,
     /* 1245817 */     GIR_EraseRootFromParent_Done,
     /* 1245818 */   // Label 18019: @1245818
     /* 1245818 */   GIM_Try, /*On fail goto*//*Label 18020*/ GIMT_Encode4(1245899), // Rule ID 5212 //
     /* 1245823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1245834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1245837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245876 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245898 */     // GIR_Coverage, 5212,
     /* 1245898 */     GIR_EraseRootFromParent_Done,
     /* 1245899 */   // Label 18020: @1245899
     /* 1245899 */   GIM_Try, /*On fail goto*//*Label 18021*/ GIMT_Encode4(1245980), // Rule ID 5213 //
     /* 1245904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1245915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1245918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245957 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245979 */     // GIR_Coverage, 5213,
     /* 1245979 */     GIR_EraseRootFromParent_Done,
     /* 1245980 */   // Label 18021: @1245980
     /* 1245980 */   GIM_Try, /*On fail goto*//*Label 18022*/ GIMT_Encode4(1246061), // Rule ID 5214 //
     /* 1245985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1245996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1245999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1246002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1246005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1246015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246038 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1246038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1246041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246060 */     // GIR_Coverage, 5214,
     /* 1246060 */     GIR_EraseRootFromParent_Done,
     /* 1246061 */   // Label 18022: @1246061
     /* 1246061 */   GIM_Try, /*On fail goto*//*Label 18023*/ GIMT_Encode4(1246142), // Rule ID 5215 //
     /* 1246066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1246069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1246077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1246080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1246083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1246096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246119 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1246119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1246122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246141 */     // GIR_Coverage, 5215,
     /* 1246141 */     GIR_EraseRootFromParent_Done,
     /* 1246142 */   // Label 18023: @1246142
     /* 1246142 */   GIM_Try, /*On fail goto*//*Label 18024*/ GIMT_Encode4(1246223), // Rule ID 5520 //
     /* 1246147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1246158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1246161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1246164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1246167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246200 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1246203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246222 */     // GIR_Coverage, 5520,
     /* 1246222 */     GIR_EraseRootFromParent_Done,
     /* 1246223 */   // Label 18024: @1246223
     /* 1246223 */   GIM_Try, /*On fail goto*//*Label 18025*/ GIMT_Encode4(1246304), // Rule ID 5521 //
     /* 1246228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1246239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1246242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1246245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1246248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246281 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1246284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246303 */     // GIR_Coverage, 5521,
     /* 1246303 */     GIR_EraseRootFromParent_Done,
     /* 1246304 */   // Label 18025: @1246304
     /* 1246304 */   GIM_Try, /*On fail goto*//*Label 18026*/ GIMT_Encode4(1246385), // Rule ID 5522 //
     /* 1246309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1246320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1246323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1246326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1246329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246362 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1246365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246384 */     // GIR_Coverage, 5522,
     /* 1246384 */     GIR_EraseRootFromParent_Done,
     /* 1246385 */   // Label 18026: @1246385
     /* 1246385 */   GIM_Try, /*On fail goto*//*Label 18027*/ GIMT_Encode4(1246466), // Rule ID 5523 //
     /* 1246390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1246401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1246404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1246407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1246410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246443 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1246446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246465 */     // GIR_Coverage, 5523,
     /* 1246465 */     GIR_EraseRootFromParent_Done,
     /* 1246466 */   // Label 18027: @1246466
     /* 1246466 */   GIM_Try, /*On fail goto*//*Label 18028*/ GIMT_Encode4(1246547), // Rule ID 5524 //
     /* 1246471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1246482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1246485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1246488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1246491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246524 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246546 */     // GIR_Coverage, 5524,
     /* 1246546 */     GIR_EraseRootFromParent_Done,
     /* 1246547 */   // Label 18028: @1246547
     /* 1246547 */   GIM_Try, /*On fail goto*//*Label 18029*/ GIMT_Encode4(1246628), // Rule ID 5525 //
     /* 1246552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1246563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1246566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1246569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1246572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246605 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246627 */     // GIR_Coverage, 5525,
     /* 1246627 */     GIR_EraseRootFromParent_Done,
     /* 1246628 */   // Label 18029: @1246628
     /* 1246628 */   GIM_Try, /*On fail goto*//*Label 18030*/ GIMT_Encode4(1246709), // Rule ID 5526 //
     /* 1246633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1246644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1246647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1246650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1246653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246686 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1246686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1246689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246708 */     // GIR_Coverage, 5526,
     /* 1246708 */     GIR_EraseRootFromParent_Done,
     /* 1246709 */   // Label 18030: @1246709
     /* 1246709 */   GIM_Try, /*On fail goto*//*Label 18031*/ GIMT_Encode4(1246790), // Rule ID 5527 //
     /* 1246714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1246725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1246728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1246731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1246734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246767 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1246770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246789 */     // GIR_Coverage, 5527,
     /* 1246789 */     GIR_EraseRootFromParent_Done,
     /* 1246790 */   // Label 18031: @1246790
     /* 1246790 */   GIM_Try, /*On fail goto*//*Label 18032*/ GIMT_Encode4(1246871), // Rule ID 5528 //
     /* 1246795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1246806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1246809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1246815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246848 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1246848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246870 */     // GIR_Coverage, 5528,
     /* 1246870 */     GIR_EraseRootFromParent_Done,
     /* 1246871 */   // Label 18032: @1246871
     /* 1246871 */   GIM_Try, /*On fail goto*//*Label 18033*/ GIMT_Encode4(1246952), // Rule ID 5529 //
     /* 1246876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1246887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1246890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1246896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246929 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246951 */     // GIR_Coverage, 5529,
     /* 1246951 */     GIR_EraseRootFromParent_Done,
     /* 1246952 */   // Label 18033: @1246952
     /* 1246952 */   GIM_Try, /*On fail goto*//*Label 18034*/ GIMT_Encode4(1247033), // Rule ID 5530 //
     /* 1246957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1246968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1246971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1246974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1246977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247010 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1247010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1247013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247032 */     // GIR_Coverage, 5530,
     /* 1247032 */     GIR_EraseRootFromParent_Done,
     /* 1247033 */   // Label 18034: @1247033
     /* 1247033 */   GIM_Try, /*On fail goto*//*Label 18035*/ GIMT_Encode4(1247114), // Rule ID 5531 //
     /* 1247038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1247049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1247052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1247055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1247058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247091 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1247091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1247094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247113 */     // GIR_Coverage, 5531,
     /* 1247113 */     GIR_EraseRootFromParent_Done,
     /* 1247114 */   // Label 18035: @1247114
     /* 1247114 */   GIM_Try, /*On fail goto*//*Label 18036*/ GIMT_Encode4(1247195), // Rule ID 5532 //
     /* 1247119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1247130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1247133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1247136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1247139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247172 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247194 */     // GIR_Coverage, 5532,
     /* 1247194 */     GIR_EraseRootFromParent_Done,
     /* 1247195 */   // Label 18036: @1247195
     /* 1247195 */   GIM_Try, /*On fail goto*//*Label 18037*/ GIMT_Encode4(1247276), // Rule ID 5533 //
     /* 1247200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1247211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1247214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1247217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1247220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247253 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247275 */     // GIR_Coverage, 5533,
     /* 1247275 */     GIR_EraseRootFromParent_Done,
     /* 1247276 */   // Label 18037: @1247276
     /* 1247276 */   GIM_Try, /*On fail goto*//*Label 18038*/ GIMT_Encode4(1247357), // Rule ID 5534 //
     /* 1247281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1247292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1247295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1247298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1247301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1247304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247334 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1247334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247356 */     // GIR_Coverage, 5534,
     /* 1247356 */     GIR_EraseRootFromParent_Done,
     /* 1247357 */   // Label 18038: @1247357
     /* 1247357 */   GIM_Try, /*On fail goto*//*Label 18039*/ GIMT_Encode4(1247438), // Rule ID 5535 //
     /* 1247362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1247373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1247376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1247379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1247382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1247385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247415 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1247415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247437 */     // GIR_Coverage, 5535,
     /* 1247437 */     GIR_EraseRootFromParent_Done,
     /* 1247438 */   // Label 18039: @1247438
     /* 1247438 */   GIM_Try, /*On fail goto*//*Label 18040*/ GIMT_Encode4(1247519), // Rule ID 5536 //
     /* 1247443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1247454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1247457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1247460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1247463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1247496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247518 */     // GIR_Coverage, 5536,
     /* 1247518 */     GIR_EraseRootFromParent_Done,
     /* 1247519 */   // Label 18040: @1247519
     /* 1247519 */   GIM_Try, /*On fail goto*//*Label 18041*/ GIMT_Encode4(1247600), // Rule ID 5537 //
     /* 1247524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1247535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1247538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1247541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1247544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247577 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1247577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247599 */     // GIR_Coverage, 5537,
     /* 1247599 */     GIR_EraseRootFromParent_Done,
     /* 1247600 */   // Label 18041: @1247600
     /* 1247600 */   GIM_Try, /*On fail goto*//*Label 18042*/ GIMT_Encode4(1247681), // Rule ID 5538 //
     /* 1247605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1247608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1247616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1247619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1247622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1247625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247658 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1247658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247680 */     // GIR_Coverage, 5538,
     /* 1247680 */     GIR_EraseRootFromParent_Done,
     /* 1247681 */   // Label 18042: @1247681
     /* 1247681 */   GIM_Try, /*On fail goto*//*Label 18043*/ GIMT_Encode4(1247762), // Rule ID 5539 //
     /* 1247686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1247689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1247697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1247700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1247703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1247706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247739 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1247739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247761 */     // GIR_Coverage, 5539,
     /* 1247761 */     GIR_EraseRootFromParent_Done,
     /* 1247762 */   // Label 18043: @1247762
     /* 1247762 */   GIM_Try, /*On fail goto*//*Label 18044*/ GIMT_Encode4(1247843), // Rule ID 5540 //
     /* 1247767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1247778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1247781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1247784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1247787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247820 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1247823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247842 */     // GIR_Coverage, 5540,
     /* 1247842 */     GIR_EraseRootFromParent_Done,
     /* 1247843 */   // Label 18044: @1247843
     /* 1247843 */   GIM_Try, /*On fail goto*//*Label 18045*/ GIMT_Encode4(1247924), // Rule ID 5541 //
     /* 1247848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1247859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1247862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1247865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1247868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247901 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1247904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247923 */     // GIR_Coverage, 5541,
     /* 1247923 */     GIR_EraseRootFromParent_Done,
     /* 1247924 */   // Label 18045: @1247924
     /* 1247924 */   GIM_Try, /*On fail goto*//*Label 18046*/ GIMT_Encode4(1248005), // Rule ID 5542 //
     /* 1247929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1247940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1247943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1247946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1247949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1247952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1247959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247982 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1247985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248004 */     // GIR_Coverage, 5542,
     /* 1248004 */     GIR_EraseRootFromParent_Done,
     /* 1248005 */   // Label 18046: @1248005
     /* 1248005 */   GIM_Try, /*On fail goto*//*Label 18047*/ GIMT_Encode4(1248086), // Rule ID 5543 //
     /* 1248010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1248021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1248024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1248027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1248030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248063 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1248063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248085 */     // GIR_Coverage, 5543,
     /* 1248085 */     GIR_EraseRootFromParent_Done,
     /* 1248086 */   // Label 18047: @1248086
     /* 1248086 */   GIM_Try, /*On fail goto*//*Label 18048*/ GIMT_Encode4(1248167), // Rule ID 5544 //
     /* 1248091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1248102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1248105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1248108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1248111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1248114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248144 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1248144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248166 */     // GIR_Coverage, 5544,
     /* 1248166 */     GIR_EraseRootFromParent_Done,
     /* 1248167 */   // Label 18048: @1248167
     /* 1248167 */   GIM_Try, /*On fail goto*//*Label 18049*/ GIMT_Encode4(1248248), // Rule ID 5545 //
     /* 1248172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1248183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1248186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1248189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1248192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1248195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248225 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1248225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248247 */     // GIR_Coverage, 5545,
     /* 1248247 */     GIR_EraseRootFromParent_Done,
     /* 1248248 */   // Label 18049: @1248248
     /* 1248248 */   GIM_Try, /*On fail goto*//*Label 18050*/ GIMT_Encode4(1248329), // Rule ID 5546 //
     /* 1248253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1248264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1248267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1248270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1248273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248328 */     // GIR_Coverage, 5546,
     /* 1248328 */     GIR_EraseRootFromParent_Done,
     /* 1248329 */   // Label 18050: @1248329
     /* 1248329 */   GIM_Try, /*On fail goto*//*Label 18051*/ GIMT_Encode4(1248410), // Rule ID 5547 //
     /* 1248334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1248345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1248348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1248351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1248354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248387 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248409 */     // GIR_Coverage, 5547,
     /* 1248409 */     GIR_EraseRootFromParent_Done,
     /* 1248410 */   // Label 18051: @1248410
     /* 1248410 */   GIM_Try, /*On fail goto*//*Label 18052*/ GIMT_Encode4(1248491), // Rule ID 5548 //
     /* 1248415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1248426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1248429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1248432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1248435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248468 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248490 */     // GIR_Coverage, 5548,
     /* 1248490 */     GIR_EraseRootFromParent_Done,
     /* 1248491 */   // Label 18052: @1248491
     /* 1248491 */   GIM_Try, /*On fail goto*//*Label 18053*/ GIMT_Encode4(1248572), // Rule ID 5549 //
     /* 1248496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1248507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1248510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1248513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1248516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248549 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248571 */     // GIR_Coverage, 5549,
     /* 1248571 */     GIR_EraseRootFromParent_Done,
     /* 1248572 */   // Label 18053: @1248572
     /* 1248572 */   GIM_Try, /*On fail goto*//*Label 18054*/ GIMT_Encode4(1248653), // Rule ID 5550 //
     /* 1248577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1248588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1248591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1248594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1248597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248630 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248652 */     // GIR_Coverage, 5550,
     /* 1248652 */     GIR_EraseRootFromParent_Done,
     /* 1248653 */   // Label 18054: @1248653
     /* 1248653 */   GIM_Try, /*On fail goto*//*Label 18055*/ GIMT_Encode4(1248734), // Rule ID 5551 //
     /* 1248658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1248669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1248672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1248675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1248678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248711 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248733 */     // GIR_Coverage, 5551,
     /* 1248733 */     GIR_EraseRootFromParent_Done,
     /* 1248734 */   // Label 18055: @1248734
     /* 1248734 */   GIM_Try, /*On fail goto*//*Label 18056*/ GIMT_Encode4(1248815), // Rule ID 5552 //
     /* 1248739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1248750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1248753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1248756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1248759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248792 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248814 */     // GIR_Coverage, 5552,
     /* 1248814 */     GIR_EraseRootFromParent_Done,
     /* 1248815 */   // Label 18056: @1248815
     /* 1248815 */   GIM_Try, /*On fail goto*//*Label 18057*/ GIMT_Encode4(1248896), // Rule ID 5553 //
     /* 1248820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1248831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1248834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1248837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1248840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248873 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1248873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248895 */     // GIR_Coverage, 5553,
     /* 1248895 */     GIR_EraseRootFromParent_Done,
     /* 1248896 */   // Label 18057: @1248896
     /* 1248896 */   GIM_Try, /*On fail goto*//*Label 18058*/ GIMT_Encode4(1248977), // Rule ID 5554 //
     /* 1248901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1248912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1248915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1248918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1248921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248954 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248976 */     // GIR_Coverage, 5554,
     /* 1248976 */     GIR_EraseRootFromParent_Done,
     /* 1248977 */   // Label 18058: @1248977
     /* 1248977 */   GIM_Try, /*On fail goto*//*Label 18059*/ GIMT_Encode4(1249058), // Rule ID 5555 //
     /* 1248982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1248993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1248996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1248999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1249002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249035 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1249035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1249038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249057 */     // GIR_Coverage, 5555,
     /* 1249057 */     GIR_EraseRootFromParent_Done,
     /* 1249058 */   // Label 18059: @1249058
     /* 1249058 */   GIM_Try, /*On fail goto*//*Label 18060*/ GIMT_Encode4(1249139), // Rule ID 5556 //
     /* 1249063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1249074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1249077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1249080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1249083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1249086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249116 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1249116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1249119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249138 */     // GIR_Coverage, 5556,
     /* 1249138 */     GIR_EraseRootFromParent_Done,
     /* 1249139 */   // Label 18060: @1249139
     /* 1249139 */   GIM_Try, /*On fail goto*//*Label 18061*/ GIMT_Encode4(1249220), // Rule ID 5557 //
     /* 1249144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1249155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1249158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1249161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1249164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1249167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249197 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1249197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1249200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249219 */     // GIR_Coverage, 5557,
     /* 1249219 */     GIR_EraseRootFromParent_Done,
     /* 1249220 */   // Label 18061: @1249220
     /* 1249220 */   GIM_Try, /*On fail goto*//*Label 18062*/ GIMT_Encode4(1249301), // Rule ID 5558 //
     /* 1249225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1249236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1249239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1249242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1249245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1249255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249278 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1249278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1249281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249300 */     // GIR_Coverage, 5558,
     /* 1249300 */     GIR_EraseRootFromParent_Done,
     /* 1249301 */   // Label 18062: @1249301
     /* 1249301 */   GIM_Try, /*On fail goto*//*Label 18063*/ GIMT_Encode4(1249382), // Rule ID 5559 //
     /* 1249306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1249317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1249320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1249323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1249326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1249336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249359 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1249362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249381 */     // GIR_Coverage, 5559,
     /* 1249381 */     GIR_EraseRootFromParent_Done,
     /* 1249382 */   // Label 18063: @1249382
     /* 1249382 */   GIM_Try, /*On fail goto*//*Label 18064*/ GIMT_Encode4(1249463), // Rule ID 5560 //
     /* 1249387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1249398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1249401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1249404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1249407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249440 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1249440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1249443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249462 */     // GIR_Coverage, 5560,
     /* 1249462 */     GIR_EraseRootFromParent_Done,
     /* 1249463 */   // Label 18064: @1249463
     /* 1249463 */   GIM_Try, /*On fail goto*//*Label 18065*/ GIMT_Encode4(1249544), // Rule ID 5561 //
     /* 1249468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1249479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1249482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1249485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1249488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249521 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1249524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249543 */     // GIR_Coverage, 5561,
     /* 1249543 */     GIR_EraseRootFromParent_Done,
     /* 1249544 */   // Label 18065: @1249544
     /* 1249544 */   GIM_Try, /*On fail goto*//*Label 18066*/ GIMT_Encode4(1249625), // Rule ID 5562 //
     /* 1249549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1249560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1249563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1249566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1249569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1249602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1249605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249624 */     // GIR_Coverage, 5562,
     /* 1249624 */     GIR_EraseRootFromParent_Done,
     /* 1249625 */   // Label 18066: @1249625
     /* 1249625 */   GIM_Try, /*On fail goto*//*Label 18067*/ GIMT_Encode4(1249706), // Rule ID 5563 //
     /* 1249630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1249641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1249644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1249647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1249650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249683 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1249686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249705 */     // GIR_Coverage, 5563,
     /* 1249705 */     GIR_EraseRootFromParent_Done,
     /* 1249706 */   // Label 18067: @1249706
     /* 1249706 */   GIM_Try, /*On fail goto*//*Label 18068*/ GIMT_Encode4(1249787), // Rule ID 5564 //
     /* 1249711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1249722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1249725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1249728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249764 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1249767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249786 */     // GIR_Coverage, 5564,
     /* 1249786 */     GIR_EraseRootFromParent_Done,
     /* 1249787 */   // Label 18068: @1249787
     /* 1249787 */   GIM_Try, /*On fail goto*//*Label 18069*/ GIMT_Encode4(1249868), // Rule ID 5565 //
     /* 1249792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1249803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1249806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1249809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249845 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1249848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249867 */     // GIR_Coverage, 5565,
     /* 1249867 */     GIR_EraseRootFromParent_Done,
     /* 1249868 */   // Label 18069: @1249868
     /* 1249868 */   GIM_Try, /*On fail goto*//*Label 18070*/ GIMT_Encode4(1249949), // Rule ID 5566 //
     /* 1249873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1249884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1249887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1249890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249926 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1249929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249948 */     // GIR_Coverage, 5566,
     /* 1249948 */     GIR_EraseRootFromParent_Done,
     /* 1249949 */   // Label 18070: @1249949
     /* 1249949 */   GIM_Try, /*On fail goto*//*Label 18071*/ GIMT_Encode4(1250030), // Rule ID 5567 //
     /* 1249954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1249965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1249968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1249971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250007 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1250007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1250010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250029 */     // GIR_Coverage, 5567,
     /* 1250029 */     GIR_EraseRootFromParent_Done,
     /* 1250030 */   // Label 18071: @1250030
     /* 1250030 */   GIM_Try, /*On fail goto*//*Label 18072*/ GIMT_Encode4(1250111), // Rule ID 5568 //
     /* 1250035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1250046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1250049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1250052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250088 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1250088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250110 */     // GIR_Coverage, 5568,
     /* 1250110 */     GIR_EraseRootFromParent_Done,
     /* 1250111 */   // Label 18072: @1250111
     /* 1250111 */   GIM_Try, /*On fail goto*//*Label 18073*/ GIMT_Encode4(1250192), // Rule ID 5569 //
     /* 1250116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1250127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1250130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1250133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250169 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1250169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250191 */     // GIR_Coverage, 5569,
     /* 1250191 */     GIR_EraseRootFromParent_Done,
     /* 1250192 */   // Label 18073: @1250192
     /* 1250192 */   GIM_Try, /*On fail goto*//*Label 18074*/ GIMT_Encode4(1250273), // Rule ID 5570 //
     /* 1250197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1250208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1250211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1250214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250250 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1250250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1250253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250272 */     // GIR_Coverage, 5570,
     /* 1250272 */     GIR_EraseRootFromParent_Done,
     /* 1250273 */   // Label 18074: @1250273
     /* 1250273 */   GIM_Try, /*On fail goto*//*Label 18075*/ GIMT_Encode4(1250354), // Rule ID 5571 //
     /* 1250278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1250289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1250292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1250295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250331 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1250334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250353 */     // GIR_Coverage, 5571,
     /* 1250353 */     GIR_EraseRootFromParent_Done,
     /* 1250354 */   // Label 18075: @1250354
     /* 1250354 */   GIM_Try, /*On fail goto*//*Label 18076*/ GIMT_Encode4(1250435), // Rule ID 5572 //
     /* 1250359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1250370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1250373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1250376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250412 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1250412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250434 */     // GIR_Coverage, 5572,
     /* 1250434 */     GIR_EraseRootFromParent_Done,
     /* 1250435 */   // Label 18076: @1250435
     /* 1250435 */   GIM_Try, /*On fail goto*//*Label 18077*/ GIMT_Encode4(1250516), // Rule ID 5573 //
     /* 1250440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1250451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1250454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1250457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250515 */     // GIR_Coverage, 5573,
     /* 1250515 */     GIR_EraseRootFromParent_Done,
     /* 1250516 */   // Label 18077: @1250516
     /* 1250516 */   GIM_Try, /*On fail goto*//*Label 18078*/ GIMT_Encode4(1250597), // Rule ID 5574 //
     /* 1250521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1250532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1250535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1250538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250574 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1250574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250596 */     // GIR_Coverage, 5574,
     /* 1250596 */     GIR_EraseRootFromParent_Done,
     /* 1250597 */   // Label 18078: @1250597
     /* 1250597 */   GIM_Try, /*On fail goto*//*Label 18079*/ GIMT_Encode4(1250678), // Rule ID 5575 //
     /* 1250602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1250613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1250616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1250619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250655 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1250655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250677 */     // GIR_Coverage, 5575,
     /* 1250677 */     GIR_EraseRootFromParent_Done,
     /* 1250678 */   // Label 18079: @1250678
     /* 1250678 */   GIM_Try, /*On fail goto*//*Label 18080*/ GIMT_Encode4(1250759), // Rule ID 5576 //
     /* 1250683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1250694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1250697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1250700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250736 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1250736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250758 */     // GIR_Coverage, 5576,
     /* 1250758 */     GIR_EraseRootFromParent_Done,
     /* 1250759 */   // Label 18080: @1250759
     /* 1250759 */   GIM_Try, /*On fail goto*//*Label 18081*/ GIMT_Encode4(1250840), // Rule ID 5577 //
     /* 1250764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1250775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1250778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1250781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250817 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1250817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250839 */     // GIR_Coverage, 5577,
     /* 1250839 */     GIR_EraseRootFromParent_Done,
     /* 1250840 */   // Label 18081: @1250840
     /* 1250840 */   GIM_Try, /*On fail goto*//*Label 18082*/ GIMT_Encode4(1250921), // Rule ID 5578 //
     /* 1250845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1250856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1250859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1250862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1250898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250920 */     // GIR_Coverage, 5578,
     /* 1250920 */     GIR_EraseRootFromParent_Done,
     /* 1250921 */   // Label 18082: @1250921
     /* 1250921 */   GIM_Try, /*On fail goto*//*Label 18083*/ GIMT_Encode4(1251002), // Rule ID 5579 //
     /* 1250926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1250937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1250940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1250943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250979 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251001 */     // GIR_Coverage, 5579,
     /* 1251001 */     GIR_EraseRootFromParent_Done,
     /* 1251002 */   // Label 18083: @1251002
     /* 1251002 */   GIM_Try, /*On fail goto*//*Label 18084*/ GIMT_Encode4(1251083), // Rule ID 5580 //
     /* 1251007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1251018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1251021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1251024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1251037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251060 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1251060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1251063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251082 */     // GIR_Coverage, 5580,
     /* 1251082 */     GIR_EraseRootFromParent_Done,
     /* 1251083 */   // Label 18084: @1251083
     /* 1251083 */   GIM_Try, /*On fail goto*//*Label 18085*/ GIMT_Encode4(1251164), // Rule ID 5581 //
     /* 1251088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1251099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1251102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1251105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1251118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251141 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1251141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1251144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251163 */     // GIR_Coverage, 5581,
     /* 1251163 */     GIR_EraseRootFromParent_Done,
     /* 1251164 */   // Label 18085: @1251164
     /* 1251164 */   GIM_Try, /*On fail goto*//*Label 18086*/ GIMT_Encode4(1251245), // Rule ID 5582 //
     /* 1251169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1251172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1251180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1251183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1251186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1251199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251222 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1251222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1251225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1251243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251244 */     // GIR_Coverage, 5582,
     /* 1251244 */     GIR_EraseRootFromParent_Done,
     /* 1251245 */   // Label 18086: @1251245
     /* 1251245 */   GIM_Try, /*On fail goto*//*Label 18087*/ GIMT_Encode4(1251326), // Rule ID 5583 //
     /* 1251250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1251253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1251261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1251264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1251267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1251280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251303 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1251303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1251306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1251324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251325 */     // GIR_Coverage, 5583,
     /* 1251325 */     GIR_EraseRootFromParent_Done,
     /* 1251326 */   // Label 18087: @1251326
     /* 1251326 */   GIM_Try, /*On fail goto*//*Label 18088*/ GIMT_Encode4(1251407), // Rule ID 5584 //
     /* 1251331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1251342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1251345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1251348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251384 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251406 */     // GIR_Coverage, 5584,
     /* 1251406 */     GIR_EraseRootFromParent_Done,
     /* 1251407 */   // Label 18088: @1251407
     /* 1251407 */   GIM_Try, /*On fail goto*//*Label 18089*/ GIMT_Encode4(1251488), // Rule ID 5585 //
     /* 1251412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1251423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1251426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1251429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251465 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251487 */     // GIR_Coverage, 5585,
     /* 1251487 */     GIR_EraseRootFromParent_Done,
     /* 1251488 */   // Label 18089: @1251488
     /* 1251488 */   GIM_Try, /*On fail goto*//*Label 18090*/ GIMT_Encode4(1251569), // Rule ID 5586 //
     /* 1251493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1251504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1251507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1251510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1251549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251568 */     // GIR_Coverage, 5586,
     /* 1251568 */     GIR_EraseRootFromParent_Done,
     /* 1251569 */   // Label 18090: @1251569
     /* 1251569 */   GIM_Try, /*On fail goto*//*Label 18091*/ GIMT_Encode4(1251650), // Rule ID 5587 //
     /* 1251574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1251585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1251588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1251591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251627 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1251630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251649 */     // GIR_Coverage, 5587,
     /* 1251649 */     GIR_EraseRootFromParent_Done,
     /* 1251650 */   // Label 18091: @1251650
     /* 1251650 */   GIM_Try, /*On fail goto*//*Label 18092*/ GIMT_Encode4(1251731), // Rule ID 5588 //
     /* 1251655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1251666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1251669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1251672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1251678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251708 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1251711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251730 */     // GIR_Coverage, 5588,
     /* 1251730 */     GIR_EraseRootFromParent_Done,
     /* 1251731 */   // Label 18092: @1251731
     /* 1251731 */   GIM_Try, /*On fail goto*//*Label 18093*/ GIMT_Encode4(1251812), // Rule ID 5589 //
     /* 1251736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1251747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1251750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1251753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1251759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251789 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1251792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251811 */     // GIR_Coverage, 5589,
     /* 1251811 */     GIR_EraseRootFromParent_Done,
     /* 1251812 */   // Label 18093: @1251812
     /* 1251812 */   GIM_Try, /*On fail goto*//*Label 18094*/ GIMT_Encode4(1251893), // Rule ID 5590 //
     /* 1251817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1251828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1251831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251870 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1251870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251892 */     // GIR_Coverage, 5590,
     /* 1251892 */     GIR_EraseRootFromParent_Done,
     /* 1251893 */   // Label 18094: @1251893
     /* 1251893 */   GIM_Try, /*On fail goto*//*Label 18095*/ GIMT_Encode4(1251974), // Rule ID 5591 //
     /* 1251898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1251909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1251912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251951 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1251951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251973 */     // GIR_Coverage, 5591,
     /* 1251973 */     GIR_EraseRootFromParent_Done,
     /* 1251974 */   // Label 18095: @1251974
     /* 1251974 */   GIM_Try, /*On fail goto*//*Label 18096*/ GIMT_Encode4(1252055), // Rule ID 5592 //
     /* 1251979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1251990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1251993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1251996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252032 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1252032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252054 */     // GIR_Coverage, 5592,
     /* 1252054 */     GIR_EraseRootFromParent_Done,
     /* 1252055 */   // Label 18096: @1252055
     /* 1252055 */   GIM_Try, /*On fail goto*//*Label 18097*/ GIMT_Encode4(1252136), // Rule ID 5593 //
     /* 1252060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1252071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1252074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1252077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252113 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1252113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252135 */     // GIR_Coverage, 5593,
     /* 1252135 */     GIR_EraseRootFromParent_Done,
     /* 1252136 */   // Label 18097: @1252136
     /* 1252136 */   GIM_Try, /*On fail goto*//*Label 18098*/ GIMT_Encode4(1252217), // Rule ID 5594 //
     /* 1252141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1252152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1252155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1252158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1252164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252194 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1252194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252216 */     // GIR_Coverage, 5594,
     /* 1252216 */     GIR_EraseRootFromParent_Done,
     /* 1252217 */   // Label 18098: @1252217
     /* 1252217 */   GIM_Try, /*On fail goto*//*Label 18099*/ GIMT_Encode4(1252298), // Rule ID 5595 //
     /* 1252222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1252233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1252236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1252239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1252245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252275 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1252275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252297 */     // GIR_Coverage, 5595,
     /* 1252297 */     GIR_EraseRootFromParent_Done,
     /* 1252298 */   // Label 18099: @1252298
     /* 1252298 */   GIM_Try, /*On fail goto*//*Label 18100*/ GIMT_Encode4(1252379), // Rule ID 5596 //
     /* 1252303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1252314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1252317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1252320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1252359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252378 */     // GIR_Coverage, 5596,
     /* 1252378 */     GIR_EraseRootFromParent_Done,
     /* 1252379 */   // Label 18100: @1252379
     /* 1252379 */   GIM_Try, /*On fail goto*//*Label 18101*/ GIMT_Encode4(1252460), // Rule ID 5597 //
     /* 1252384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1252395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1252398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1252401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252437 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1252440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252459 */     // GIR_Coverage, 5597,
     /* 1252459 */     GIR_EraseRootFromParent_Done,
     /* 1252460 */   // Label 18101: @1252460
     /* 1252460 */   GIM_Try, /*On fail goto*//*Label 18102*/ GIMT_Encode4(1252541), // Rule ID 5598 //
     /* 1252465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1252476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1252479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252540 */     // GIR_Coverage, 5598,
     /* 1252540 */     GIR_EraseRootFromParent_Done,
     /* 1252541 */   // Label 18102: @1252541
     /* 1252541 */   GIM_Try, /*On fail goto*//*Label 18103*/ GIMT_Encode4(1252622), // Rule ID 5599 //
     /* 1252546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1252557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1252560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252599 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252621 */     // GIR_Coverage, 5599,
     /* 1252621 */     GIR_EraseRootFromParent_Done,
     /* 1252622 */   // Label 18103: @1252622
     /* 1252622 */   GIM_Try, /*On fail goto*//*Label 18104*/ GIMT_Encode4(1252703), // Rule ID 5600 //
     /* 1252627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1252638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1252641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252680 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252702 */     // GIR_Coverage, 5600,
     /* 1252702 */     GIR_EraseRootFromParent_Done,
     /* 1252703 */   // Label 18104: @1252703
     /* 1252703 */   GIM_Try, /*On fail goto*//*Label 18105*/ GIMT_Encode4(1252784), // Rule ID 5601 //
     /* 1252708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1252719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1252722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252761 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252783 */     // GIR_Coverage, 5601,
     /* 1252783 */     GIR_EraseRootFromParent_Done,
     /* 1252784 */   // Label 18105: @1252784
     /* 1252784 */   GIM_Try, /*On fail goto*//*Label 18106*/ GIMT_Encode4(1252865), // Rule ID 5602 //
     /* 1252789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1252800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1252803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252842 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1252842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1252845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252864 */     // GIR_Coverage, 5602,
     /* 1252864 */     GIR_EraseRootFromParent_Done,
     /* 1252865 */   // Label 18106: @1252865
     /* 1252865 */   GIM_Try, /*On fail goto*//*Label 18107*/ GIMT_Encode4(1252946), // Rule ID 5603 //
     /* 1252870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1252873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1252881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1252884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252923 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1252923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1252926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252945 */     // GIR_Coverage, 5603,
     /* 1252945 */     GIR_EraseRootFromParent_Done,
     /* 1252946 */   // Label 18107: @1252946
     /* 1252946 */   GIM_Try, /*On fail goto*//*Label 18108*/ GIMT_Encode4(1253027), // Rule ID 5604 //
     /* 1252951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1252962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1252965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1252968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253004 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1253004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1253007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253026 */     // GIR_Coverage, 5604,
     /* 1253026 */     GIR_EraseRootFromParent_Done,
     /* 1253027 */   // Label 18108: @1253027
     /* 1253027 */   GIM_Try, /*On fail goto*//*Label 18109*/ GIMT_Encode4(1253108), // Rule ID 5605 //
     /* 1253032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1253035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1253043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1253046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1253049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1253062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253085 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1253085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1253088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253107 */     // GIR_Coverage, 5605,
     /* 1253107 */     GIR_EraseRootFromParent_Done,
     /* 1253108 */   // Label 18109: @1253108
     /* 1253108 */   GIM_Try, /*On fail goto*//*Label 18110*/ GIMT_Encode4(1253189), // Rule ID 5606 //
     /* 1253113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1253116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1253124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1253127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1253130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1253133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1253143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253166 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1253166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1253169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253188 */     // GIR_Coverage, 5606,
     /* 1253188 */     GIR_EraseRootFromParent_Done,
     /* 1253189 */   // Label 18110: @1253189
     /* 1253189 */   GIM_Try, /*On fail goto*//*Label 18111*/ GIMT_Encode4(1253270), // Rule ID 5607 //
     /* 1253194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1253197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1253205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1253208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1253211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1253224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253247 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1253247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1253250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253269 */     // GIR_Coverage, 5607,
     /* 1253269 */     GIR_EraseRootFromParent_Done,
     /* 1253270 */   // Label 18111: @1253270
     /* 1253270 */   GIM_Try, /*On fail goto*//*Label 18112*/ GIMT_Encode4(1253354), // Rule ID 7818 //
     /* 1253275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1253292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1253295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253328 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1253331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253353 */     // GIR_Coverage, 7818,
     /* 1253353 */     GIR_EraseRootFromParent_Done,
     /* 1253354 */   // Label 18112: @1253354
     /* 1253354 */   GIM_Try, /*On fail goto*//*Label 18113*/ GIMT_Encode4(1253438), // Rule ID 7819 //
     /* 1253359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1253376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1253379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253412 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1253415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253437 */     // GIR_Coverage, 7819,
     /* 1253437 */     GIR_EraseRootFromParent_Done,
     /* 1253438 */   // Label 18113: @1253438
     /* 1253438 */   GIM_Try, /*On fail goto*//*Label 18114*/ GIMT_Encode4(1253522), // Rule ID 7822 //
     /* 1253443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1253460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1253463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253496 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253521 */     // GIR_Coverage, 7822,
     /* 1253521 */     GIR_EraseRootFromParent_Done,
     /* 1253522 */   // Label 18114: @1253522
     /* 1253522 */   GIM_Try, /*On fail goto*//*Label 18115*/ GIMT_Encode4(1253606), // Rule ID 7823 //
     /* 1253527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1253544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1253547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253580 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253605 */     // GIR_Coverage, 7823,
     /* 1253605 */     GIR_EraseRootFromParent_Done,
     /* 1253606 */   // Label 18115: @1253606
     /* 1253606 */   GIM_Try, /*On fail goto*//*Label 18116*/ GIMT_Encode4(1253690), // Rule ID 7826 //
     /* 1253611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1253631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253664 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1253667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253689 */     // GIR_Coverage, 7826,
     /* 1253689 */     GIR_EraseRootFromParent_Done,
     /* 1253690 */   // Label 18116: @1253690
     /* 1253690 */   GIM_Try, /*On fail goto*//*Label 18117*/ GIMT_Encode4(1253774), // Rule ID 7827 //
     /* 1253695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1253715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253748 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1253751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253773 */     // GIR_Coverage, 7827,
     /* 1253773 */     GIR_EraseRootFromParent_Done,
     /* 1253774 */   // Label 18117: @1253774
     /* 1253774 */   GIM_Try, /*On fail goto*//*Label 18118*/ GIMT_Encode4(1253858), // Rule ID 7830 //
     /* 1253779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1253796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1253799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253832 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253857 */     // GIR_Coverage, 7830,
     /* 1253857 */     GIR_EraseRootFromParent_Done,
     /* 1253858 */   // Label 18118: @1253858
     /* 1253858 */   GIM_Try, /*On fail goto*//*Label 18119*/ GIMT_Encode4(1253942), // Rule ID 7831 //
     /* 1253863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1253880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1253883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253916 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253941 */     // GIR_Coverage, 7831,
     /* 1253941 */     GIR_EraseRootFromParent_Done,
     /* 1253942 */   // Label 18119: @1253942
     /* 1253942 */   GIM_Try, /*On fail goto*//*Label 18120*/ GIMT_Encode4(1254026), // Rule ID 7834 //
     /* 1253947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1253964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1253967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254000 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1254003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254025 */     // GIR_Coverage, 7834,
     /* 1254025 */     GIR_EraseRootFromParent_Done,
     /* 1254026 */   // Label 18120: @1254026
     /* 1254026 */   GIM_Try, /*On fail goto*//*Label 18121*/ GIMT_Encode4(1254110), // Rule ID 7835 //
     /* 1254031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1254048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1254051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254084 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1254087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254109 */     // GIR_Coverage, 7835,
     /* 1254109 */     GIR_EraseRootFromParent_Done,
     /* 1254110 */   // Label 18121: @1254110
     /* 1254110 */   GIM_Try, /*On fail goto*//*Label 18122*/ GIMT_Encode4(1254194), // Rule ID 7838 //
     /* 1254115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1254132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1254135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254168 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254193 */     // GIR_Coverage, 7838,
     /* 1254193 */     GIR_EraseRootFromParent_Done,
     /* 1254194 */   // Label 18122: @1254194
     /* 1254194 */   GIM_Try, /*On fail goto*//*Label 18123*/ GIMT_Encode4(1254278), // Rule ID 7839 //
     /* 1254199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1254216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1254219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254252 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254277 */     // GIR_Coverage, 7839,
     /* 1254277 */     GIR_EraseRootFromParent_Done,
     /* 1254278 */   // Label 18123: @1254278
     /* 1254278 */   GIM_Try, /*On fail goto*//*Label 18124*/ GIMT_Encode4(1254362), // Rule ID 7842 //
     /* 1254283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1254294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1254297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1254300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1254303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1254306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254336 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254361 */     // GIR_Coverage, 7842,
     /* 1254361 */     GIR_EraseRootFromParent_Done,
     /* 1254362 */   // Label 18124: @1254362
     /* 1254362 */   GIM_Try, /*On fail goto*//*Label 18125*/ GIMT_Encode4(1254446), // Rule ID 7843 //
     /* 1254367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1254378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1254381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1254384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1254387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1254390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254420 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254445 */     // GIR_Coverage, 7843,
     /* 1254445 */     GIR_EraseRootFromParent_Done,
     /* 1254446 */   // Label 18125: @1254446
     /* 1254446 */   GIM_Try, /*On fail goto*//*Label 18126*/ GIMT_Encode4(1254530), // Rule ID 7846 //
     /* 1254451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1254471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254504 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254529 */     // GIR_Coverage, 7846,
     /* 1254529 */     GIR_EraseRootFromParent_Done,
     /* 1254530 */   // Label 18126: @1254530
     /* 1254530 */   GIM_Try, /*On fail goto*//*Label 18127*/ GIMT_Encode4(1254614), // Rule ID 7847 //
     /* 1254535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1254555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254588 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254613 */     // GIR_Coverage, 7847,
     /* 1254613 */     GIR_EraseRootFromParent_Done,
     /* 1254614 */   // Label 18127: @1254614
     /* 1254614 */   GIM_Try, /*On fail goto*//*Label 18128*/ GIMT_Encode4(1254698), // Rule ID 7850 //
     /* 1254619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1254622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1254639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254672 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254697 */     // GIR_Coverage, 7850,
     /* 1254697 */     GIR_EraseRootFromParent_Done,
     /* 1254698 */   // Label 18128: @1254698
     /* 1254698 */   GIM_Try, /*On fail goto*//*Label 18129*/ GIMT_Encode4(1254782), // Rule ID 7851 //
     /* 1254703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1254706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1254723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254756 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254781 */     // GIR_Coverage, 7851,
     /* 1254781 */     GIR_EraseRootFromParent_Done,
     /* 1254782 */   // Label 18129: @1254782
     /* 1254782 */   GIM_Try, /*On fail goto*//*Label 18130*/ GIMT_Encode4(1254866), // Rule ID 7854 //
     /* 1254787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1254798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1254801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1254804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1254807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1254810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254840 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1254843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254865 */     // GIR_Coverage, 7854,
     /* 1254865 */     GIR_EraseRootFromParent_Done,
     /* 1254866 */   // Label 18130: @1254866
     /* 1254866 */   GIM_Try, /*On fail goto*//*Label 18131*/ GIMT_Encode4(1254950), // Rule ID 7855 //
     /* 1254871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1254882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1254885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1254888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1254891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1254894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254924 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1254927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254949 */     // GIR_Coverage, 7855,
     /* 1254949 */     GIR_EraseRootFromParent_Done,
     /* 1254950 */   // Label 18131: @1254950
     /* 1254950 */   GIM_Try, /*On fail goto*//*Label 18132*/ GIMT_Encode4(1255034), // Rule ID 7858 //
     /* 1254955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1254966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1254969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1254972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1254975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1254978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255008 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255033 */     // GIR_Coverage, 7858,
     /* 1255033 */     GIR_EraseRootFromParent_Done,
     /* 1255034 */   // Label 18132: @1255034
     /* 1255034 */   GIM_Try, /*On fail goto*//*Label 18133*/ GIMT_Encode4(1255118), // Rule ID 7859 //
     /* 1255039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1255056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1255059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255092 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255117 */     // GIR_Coverage, 7859,
     /* 1255117 */     GIR_EraseRootFromParent_Done,
     /* 1255118 */   // Label 18133: @1255118
     /* 1255118 */   GIM_Try, /*On fail goto*//*Label 18134*/ GIMT_Encode4(1255202), // Rule ID 7862 //
     /* 1255123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1255134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1255137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1255140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1255143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1255146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255176 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255201 */     // GIR_Coverage, 7862,
     /* 1255201 */     GIR_EraseRootFromParent_Done,
     /* 1255202 */   // Label 18134: @1255202
     /* 1255202 */   GIM_Try, /*On fail goto*//*Label 18135*/ GIMT_Encode4(1255286), // Rule ID 7863 //
     /* 1255207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1255218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1255221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1255224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1255227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1255230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255260 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255285 */     // GIR_Coverage, 7863,
     /* 1255285 */     GIR_EraseRootFromParent_Done,
     /* 1255286 */   // Label 18135: @1255286
     /* 1255286 */   GIM_Try, /*On fail goto*//*Label 18136*/ GIMT_Encode4(1255370), // Rule ID 7866 //
     /* 1255291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1255308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1255311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255344 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255369 */     // GIR_Coverage, 7866,
     /* 1255369 */     GIR_EraseRootFromParent_Done,
     /* 1255370 */   // Label 18136: @1255370
     /* 1255370 */   GIM_Try, /*On fail goto*//*Label 18137*/ GIMT_Encode4(1255454), // Rule ID 7867 //
     /* 1255375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1255392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1255395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255428 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255453 */     // GIR_Coverage, 7867,
     /* 1255453 */     GIR_EraseRootFromParent_Done,
     /* 1255454 */   // Label 18137: @1255454
     /* 1255454 */   GIM_Try, /*On fail goto*//*Label 18138*/ GIMT_Encode4(1255538), // Rule ID 7870 //
     /* 1255459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1255476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1255479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255512 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255537 */     // GIR_Coverage, 7870,
     /* 1255537 */     GIR_EraseRootFromParent_Done,
     /* 1255538 */   // Label 18138: @1255538
     /* 1255538 */   GIM_Try, /*On fail goto*//*Label 18139*/ GIMT_Encode4(1255622), // Rule ID 7871 //
     /* 1255543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1255560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1255563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255596 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255621 */     // GIR_Coverage, 7871,
     /* 1255621 */     GIR_EraseRootFromParent_Done,
     /* 1255622 */   // Label 18139: @1255622
     /* 1255622 */   GIM_Try, /*On fail goto*//*Label 18140*/ GIMT_Encode4(1255706), // Rule ID 7874 //
     /* 1255627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1255644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1255647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255680 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255705 */     // GIR_Coverage, 7874,
     /* 1255705 */     GIR_EraseRootFromParent_Done,
     /* 1255706 */   // Label 18140: @1255706
     /* 1255706 */   GIM_Try, /*On fail goto*//*Label 18141*/ GIMT_Encode4(1255790), // Rule ID 7875 //
     /* 1255711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1255728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1255731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255764 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255789 */     // GIR_Coverage, 7875,
     /* 1255789 */     GIR_EraseRootFromParent_Done,
     /* 1255790 */   // Label 18141: @1255790
     /* 1255790 */   GIM_Try, /*On fail goto*//*Label 18142*/ GIMT_Encode4(1255874), // Rule ID 7878 //
     /* 1255795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1255806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1255809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1255812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1255815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255848 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255873 */     // GIR_Coverage, 7878,
     /* 1255873 */     GIR_EraseRootFromParent_Done,
     /* 1255874 */   // Label 18142: @1255874
     /* 1255874 */   GIM_Try, /*On fail goto*//*Label 18143*/ GIMT_Encode4(1255958), // Rule ID 7879 //
     /* 1255879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1255890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1255893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1255896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1255899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255932 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255957 */     // GIR_Coverage, 7879,
     /* 1255957 */     GIR_EraseRootFromParent_Done,
     /* 1255958 */   // Label 18143: @1255958
     /* 1255958 */   GIM_Try, /*On fail goto*//*Label 18144*/ GIMT_Encode4(1256042), // Rule ID 7882 //
     /* 1255963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1255980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1255983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256016 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1256019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256041 */     // GIR_Coverage, 7882,
     /* 1256041 */     GIR_EraseRootFromParent_Done,
     /* 1256042 */   // Label 18144: @1256042
     /* 1256042 */   GIM_Try, /*On fail goto*//*Label 18145*/ GIMT_Encode4(1256126), // Rule ID 7883 //
     /* 1256047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1256064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1256067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256100 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1256103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256125 */     // GIR_Coverage, 7883,
     /* 1256125 */     GIR_EraseRootFromParent_Done,
     /* 1256126 */   // Label 18145: @1256126
     /* 1256126 */   GIM_Try, /*On fail goto*//*Label 18146*/ GIMT_Encode4(1256210), // Rule ID 7886 //
     /* 1256131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1256142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1256145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1256148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1256151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1256154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256184 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1256187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256209 */     // GIR_Coverage, 7886,
     /* 1256209 */     GIR_EraseRootFromParent_Done,
     /* 1256210 */   // Label 18146: @1256210
     /* 1256210 */   GIM_Try, /*On fail goto*//*Label 18147*/ GIMT_Encode4(1256294), // Rule ID 7887 //
     /* 1256215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1256226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1256229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1256232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1256235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1256238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256268 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1256271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256293 */     // GIR_Coverage, 7887,
     /* 1256293 */     GIR_EraseRootFromParent_Done,
     /* 1256294 */   // Label 18147: @1256294
     /* 1256294 */   GIM_Try, /*On fail goto*//*Label 18148*/ GIMT_Encode4(1256378), // Rule ID 7890 //
     /* 1256299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1256316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1256319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256352 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1256355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256377 */     // GIR_Coverage, 7890,
     /* 1256377 */     GIR_EraseRootFromParent_Done,
     /* 1256378 */   // Label 18148: @1256378
     /* 1256378 */   GIM_Try, /*On fail goto*//*Label 18149*/ GIMT_Encode4(1256462), // Rule ID 7891 //
     /* 1256383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1256400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1256403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256436 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1256439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256461 */     // GIR_Coverage, 7891,
     /* 1256461 */     GIR_EraseRootFromParent_Done,
     /* 1256462 */   // Label 18149: @1256462
     /* 1256462 */   GIM_Try, /*On fail goto*//*Label 18150*/ GIMT_Encode4(1256546), // Rule ID 7894 //
     /* 1256467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1256484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1256487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256520 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1256523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256545 */     // GIR_Coverage, 7894,
     /* 1256545 */     GIR_EraseRootFromParent_Done,
     /* 1256546 */   // Label 18150: @1256546
     /* 1256546 */   GIM_Try, /*On fail goto*//*Label 18151*/ GIMT_Encode4(1256630), // Rule ID 7895 //
     /* 1256551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1256568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1256571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256604 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1256607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256629 */     // GIR_Coverage, 7895,
     /* 1256629 */     GIR_EraseRootFromParent_Done,
     /* 1256630 */   // Label 18151: @1256630
     /* 1256630 */   GIM_Try, /*On fail goto*//*Label 18152*/ GIMT_Encode4(1256714), // Rule ID 7898 //
     /* 1256635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1256652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1256655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256688 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1256691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256713 */     // GIR_Coverage, 7898,
     /* 1256713 */     GIR_EraseRootFromParent_Done,
     /* 1256714 */   // Label 18152: @1256714
     /* 1256714 */   GIM_Try, /*On fail goto*//*Label 18153*/ GIMT_Encode4(1256798), // Rule ID 7899 //
     /* 1256719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1256736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1256739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256772 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1256775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256797 */     // GIR_Coverage, 7899,
     /* 1256797 */     GIR_EraseRootFromParent_Done,
     /* 1256798 */   // Label 18153: @1256798
     /* 1256798 */   GIM_Try, /*On fail goto*//*Label 18154*/ GIMT_Encode4(1256882), // Rule ID 7902 //
     /* 1256803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1256820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256856 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1256859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256881 */     // GIR_Coverage, 7902,
     /* 1256881 */     GIR_EraseRootFromParent_Done,
     /* 1256882 */   // Label 18154: @1256882
     /* 1256882 */   GIM_Try, /*On fail goto*//*Label 18155*/ GIMT_Encode4(1256966), // Rule ID 7903 //
     /* 1256887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1256904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256940 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1256943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256965 */     // GIR_Coverage, 7903,
     /* 1256965 */     GIR_EraseRootFromParent_Done,
     /* 1256966 */   // Label 18155: @1256966
     /* 1256966 */   GIM_Try, /*On fail goto*//*Label 18156*/ GIMT_Encode4(1257050), // Rule ID 7906 //
     /* 1256971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1256988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257024 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1257027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257049 */     // GIR_Coverage, 7906,
     /* 1257049 */     GIR_EraseRootFromParent_Done,
     /* 1257050 */   // Label 18156: @1257050
     /* 1257050 */   GIM_Try, /*On fail goto*//*Label 18157*/ GIMT_Encode4(1257134), // Rule ID 7907 //
     /* 1257055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1257072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257108 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1257111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257133 */     // GIR_Coverage, 7907,
     /* 1257133 */     GIR_EraseRootFromParent_Done,
     /* 1257134 */   // Label 18157: @1257134
     /* 1257134 */   GIM_Try, /*On fail goto*//*Label 18158*/ GIMT_Encode4(1257218), // Rule ID 7910 //
     /* 1257139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1257156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257192 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257217 */     // GIR_Coverage, 7910,
     /* 1257217 */     GIR_EraseRootFromParent_Done,
     /* 1257218 */   // Label 18158: @1257218
     /* 1257218 */   GIM_Try, /*On fail goto*//*Label 18159*/ GIMT_Encode4(1257302), // Rule ID 7911 //
     /* 1257223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1257240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257276 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257301 */     // GIR_Coverage, 7911,
     /* 1257301 */     GIR_EraseRootFromParent_Done,
     /* 1257302 */   // Label 18159: @1257302
     /* 1257302 */   GIM_Try, /*On fail goto*//*Label 18160*/ GIMT_Encode4(1257386), // Rule ID 7914 //
     /* 1257307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1257324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257360 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1257363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257385 */     // GIR_Coverage, 7914,
     /* 1257385 */     GIR_EraseRootFromParent_Done,
     /* 1257386 */   // Label 18160: @1257386
     /* 1257386 */   GIM_Try, /*On fail goto*//*Label 18161*/ GIMT_Encode4(1257470), // Rule ID 7915 //
     /* 1257391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1257408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257444 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1257447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257469 */     // GIR_Coverage, 7915,
     /* 1257469 */     GIR_EraseRootFromParent_Done,
     /* 1257470 */   // Label 18161: @1257470
     /* 1257470 */   GIM_Try, /*On fail goto*//*Label 18162*/ GIMT_Encode4(1257554), // Rule ID 7918 //
     /* 1257475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1257492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257528 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257553 */     // GIR_Coverage, 7918,
     /* 1257553 */     GIR_EraseRootFromParent_Done,
     /* 1257554 */   // Label 18162: @1257554
     /* 1257554 */   GIM_Try, /*On fail goto*//*Label 18163*/ GIMT_Encode4(1257638), // Rule ID 7919 //
     /* 1257559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1257576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257612 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257637 */     // GIR_Coverage, 7919,
     /* 1257637 */     GIR_EraseRootFromParent_Done,
     /* 1257638 */   // Label 18163: @1257638
     /* 1257638 */   GIM_Try, /*On fail goto*//*Label 18164*/ GIMT_Encode4(1257722), // Rule ID 7922 //
     /* 1257643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1257660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257696 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257721 */     // GIR_Coverage, 7922,
     /* 1257721 */     GIR_EraseRootFromParent_Done,
     /* 1257722 */   // Label 18164: @1257722
     /* 1257722 */   GIM_Try, /*On fail goto*//*Label 18165*/ GIMT_Encode4(1257806), // Rule ID 7923 //
     /* 1257727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1257744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257780 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257805 */     // GIR_Coverage, 7923,
     /* 1257805 */     GIR_EraseRootFromParent_Done,
     /* 1257806 */   // Label 18165: @1257806
     /* 1257806 */   GIM_Try, /*On fail goto*//*Label 18166*/ GIMT_Encode4(1257890), // Rule ID 7926 //
     /* 1257811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1257828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257864 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257889 */     // GIR_Coverage, 7926,
     /* 1257889 */     GIR_EraseRootFromParent_Done,
     /* 1257890 */   // Label 18166: @1257890
     /* 1257890 */   GIM_Try, /*On fail goto*//*Label 18167*/ GIMT_Encode4(1257974), // Rule ID 7927 //
     /* 1257895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1257912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257948 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257973 */     // GIR_Coverage, 7927,
     /* 1257973 */     GIR_EraseRootFromParent_Done,
     /* 1257974 */   // Label 18167: @1257974
     /* 1257974 */   GIM_Try, /*On fail goto*//*Label 18168*/ GIMT_Encode4(1258058), // Rule ID 7930 //
     /* 1257979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1257996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1258002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258032 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1258035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258057 */     // GIR_Coverage, 7930,
     /* 1258057 */     GIR_EraseRootFromParent_Done,
     /* 1258058 */   // Label 18168: @1258058
     /* 1258058 */   GIM_Try, /*On fail goto*//*Label 18169*/ GIMT_Encode4(1258142), // Rule ID 7931 //
     /* 1258063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1258074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1258077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1258080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1258086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258116 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1258119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258141 */     // GIR_Coverage, 7931,
     /* 1258141 */     GIR_EraseRootFromParent_Done,
     /* 1258142 */   // Label 18169: @1258142
     /* 1258142 */   GIM_Try, /*On fail goto*//*Label 18170*/ GIMT_Encode4(1258226), // Rule ID 7934 //
     /* 1258147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1258158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1258161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1258164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1258170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258200 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1258203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1258221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258225 */     // GIR_Coverage, 7934,
     /* 1258225 */     GIR_EraseRootFromParent_Done,
     /* 1258226 */   // Label 18170: @1258226
     /* 1258226 */   GIM_Try, /*On fail goto*//*Label 18171*/ GIMT_Encode4(1258310), // Rule ID 7935 //
     /* 1258231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1258242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1258245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1258248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1258254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258284 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1258287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1258305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258309 */     // GIR_Coverage, 7935,
     /* 1258309 */     GIR_EraseRootFromParent_Done,
     /* 1258310 */   // Label 18171: @1258310
     /* 1258310 */   GIM_Try, /*On fail goto*//*Label 18172*/ GIMT_Encode4(1258394), // Rule ID 7938 //
     /* 1258315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1258318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1258332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258368 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1258371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1258389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258393 */     // GIR_Coverage, 7938,
     /* 1258393 */     GIR_EraseRootFromParent_Done,
     /* 1258394 */   // Label 18172: @1258394
     /* 1258394 */   GIM_Try, /*On fail goto*//*Label 18173*/ GIMT_Encode4(1258478), // Rule ID 7939 //
     /* 1258399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1258402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1258416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258452 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1258455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1258473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258477 */     // GIR_Coverage, 7939,
     /* 1258477 */     GIR_EraseRootFromParent_Done,
     /* 1258478 */   // Label 18173: @1258478
     /* 1258478 */   GIM_Try, /*On fail goto*//*Label 18174*/ GIMT_Encode4(1258562), // Rule ID 7942 //
     /* 1258483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1258500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258536 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1258539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258561 */     // GIR_Coverage, 7942,
     /* 1258561 */     GIR_EraseRootFromParent_Done,
     /* 1258562 */   // Label 18174: @1258562
     /* 1258562 */   GIM_Try, /*On fail goto*//*Label 18175*/ GIMT_Encode4(1258646), // Rule ID 7943 //
     /* 1258567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1258584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258620 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1258623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258645 */     // GIR_Coverage, 7943,
     /* 1258645 */     GIR_EraseRootFromParent_Done,
     /* 1258646 */   // Label 18175: @1258646
     /* 1258646 */   GIM_Try, /*On fail goto*//*Label 18176*/ GIMT_Encode4(1258730), // Rule ID 7946 //
     /* 1258651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1258668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258704 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1258707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258729 */     // GIR_Coverage, 7946,
     /* 1258729 */     GIR_EraseRootFromParent_Done,
     /* 1258730 */   // Label 18176: @1258730
     /* 1258730 */   GIM_Try, /*On fail goto*//*Label 18177*/ GIMT_Encode4(1258814), // Rule ID 7947 //
     /* 1258735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1258752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258788 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1258791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258813 */     // GIR_Coverage, 7947,
     /* 1258813 */     GIR_EraseRootFromParent_Done,
     /* 1258814 */   // Label 18177: @1258814
     /* 1258814 */   GIM_Try, /*On fail goto*//*Label 18178*/ GIMT_Encode4(1258898), // Rule ID 7950 //
     /* 1258819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1258830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1258833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1258836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1258842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258872 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1258875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258897 */     // GIR_Coverage, 7950,
     /* 1258897 */     GIR_EraseRootFromParent_Done,
     /* 1258898 */   // Label 18178: @1258898
     /* 1258898 */   GIM_Try, /*On fail goto*//*Label 18179*/ GIMT_Encode4(1258982), // Rule ID 7951 //
     /* 1258903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1258914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1258917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1258920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1258926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258956 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1258959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258981 */     // GIR_Coverage, 7951,
     /* 1258981 */     GIR_EraseRootFromParent_Done,
     /* 1258982 */   // Label 18179: @1258982
     /* 1258982 */   GIM_Try, /*On fail goto*//*Label 18180*/ GIMT_Encode4(1259066), // Rule ID 7954 //
     /* 1258987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1258998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1259004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259040 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259065 */     // GIR_Coverage, 7954,
     /* 1259065 */     GIR_EraseRootFromParent_Done,
     /* 1259066 */   // Label 18180: @1259066
     /* 1259066 */   GIM_Try, /*On fail goto*//*Label 18181*/ GIMT_Encode4(1259150), // Rule ID 7955 //
     /* 1259071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1259088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259124 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259149 */     // GIR_Coverage, 7955,
     /* 1259149 */     GIR_EraseRootFromParent_Done,
     /* 1259150 */   // Label 18181: @1259150
     /* 1259150 */   GIM_Try, /*On fail goto*//*Label 18182*/ GIMT_Encode4(1259234), // Rule ID 7958 //
     /* 1259155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1259172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259208 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259233 */     // GIR_Coverage, 7958,
     /* 1259233 */     GIR_EraseRootFromParent_Done,
     /* 1259234 */   // Label 18182: @1259234
     /* 1259234 */   GIM_Try, /*On fail goto*//*Label 18183*/ GIMT_Encode4(1259318), // Rule ID 7959 //
     /* 1259239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1259256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259292 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259317 */     // GIR_Coverage, 7959,
     /* 1259317 */     GIR_EraseRootFromParent_Done,
     /* 1259318 */   // Label 18183: @1259318
     /* 1259318 */   GIM_Try, /*On fail goto*//*Label 18184*/ GIMT_Encode4(1259402), // Rule ID 7962 //
     /* 1259323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1259334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1259337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1259340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1259346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259376 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259401 */     // GIR_Coverage, 7962,
     /* 1259401 */     GIR_EraseRootFromParent_Done,
     /* 1259402 */   // Label 18184: @1259402
     /* 1259402 */   GIM_Try, /*On fail goto*//*Label 18185*/ GIMT_Encode4(1259486), // Rule ID 7963 //
     /* 1259407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1259418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1259421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1259424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1259430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259460 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259485 */     // GIR_Coverage, 7963,
     /* 1259485 */     GIR_EraseRootFromParent_Done,
     /* 1259486 */   // Label 18185: @1259486
     /* 1259486 */   GIM_Try, /*On fail goto*//*Label 18186*/ GIMT_Encode4(1259570), // Rule ID 7966 //
     /* 1259491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259544 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259569 */     // GIR_Coverage, 7966,
     /* 1259569 */     GIR_EraseRootFromParent_Done,
     /* 1259570 */   // Label 18186: @1259570
     /* 1259570 */   GIM_Try, /*On fail goto*//*Label 18187*/ GIMT_Encode4(1259654), // Rule ID 7967 //
     /* 1259575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259628 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259653 */     // GIR_Coverage, 7967,
     /* 1259653 */     GIR_EraseRootFromParent_Done,
     /* 1259654 */   // Label 18187: @1259654
     /* 1259654 */   GIM_Try, /*On fail goto*//*Label 18188*/ GIMT_Encode4(1259738), // Rule ID 7970 //
     /* 1259659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259712 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259737 */     // GIR_Coverage, 7970,
     /* 1259737 */     GIR_EraseRootFromParent_Done,
     /* 1259738 */   // Label 18188: @1259738
     /* 1259738 */   GIM_Try, /*On fail goto*//*Label 18189*/ GIMT_Encode4(1259822), // Rule ID 7971 //
     /* 1259743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259796 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259821 */     // GIR_Coverage, 7971,
     /* 1259821 */     GIR_EraseRootFromParent_Done,
     /* 1259822 */   // Label 18189: @1259822
     /* 1259822 */   GIM_Try, /*On fail goto*//*Label 18190*/ GIMT_Encode4(1259906), // Rule ID 7974 //
     /* 1259827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259880 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259905 */     // GIR_Coverage, 7974,
     /* 1259905 */     GIR_EraseRootFromParent_Done,
     /* 1259906 */   // Label 18190: @1259906
     /* 1259906 */   GIM_Try, /*On fail goto*//*Label 18191*/ GIMT_Encode4(1259990), // Rule ID 7975 //
     /* 1259911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259964 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259989 */     // GIR_Coverage, 7975,
     /* 1259989 */     GIR_EraseRootFromParent_Done,
     /* 1259990 */   // Label 18191: @1259990
     /* 1259990 */   GIM_Try, /*On fail goto*//*Label 18192*/ GIMT_Encode4(1260074), // Rule ID 7978 //
     /* 1259995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1259998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1260012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260048 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1260051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260073 */     // GIR_Coverage, 7978,
     /* 1260073 */     GIR_EraseRootFromParent_Done,
     /* 1260074 */   // Label 18192: @1260074
     /* 1260074 */   GIM_Try, /*On fail goto*//*Label 18193*/ GIMT_Encode4(1260158), // Rule ID 7979 //
     /* 1260079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1260082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1260096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260132 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1260135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260157 */     // GIR_Coverage, 7979,
     /* 1260157 */     GIR_EraseRootFromParent_Done,
     /* 1260158 */   // Label 18193: @1260158
     /* 1260158 */   GIM_Try, /*On fail goto*//*Label 18194*/ GIMT_Encode4(1260242), // Rule ID 7982 //
     /* 1260163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1260166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1260180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260216 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1260219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260241 */     // GIR_Coverage, 7982,
     /* 1260241 */     GIR_EraseRootFromParent_Done,
     /* 1260242 */   // Label 18194: @1260242
     /* 1260242 */   GIM_Try, /*On fail goto*//*Label 18195*/ GIMT_Encode4(1260326), // Rule ID 7983 //
     /* 1260247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1260250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1260264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260300 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1260303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260325 */     // GIR_Coverage, 7983,
     /* 1260325 */     GIR_EraseRootFromParent_Done,
     /* 1260326 */   // Label 18195: @1260326
     /* 1260326 */   GIM_Try, /*On fail goto*//*Label 18196*/ GIMT_Encode4(1260410), // Rule ID 7986 //
     /* 1260331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1260334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1260348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1260387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260409 */     // GIR_Coverage, 7986,
     /* 1260409 */     GIR_EraseRootFromParent_Done,
     /* 1260410 */   // Label 18196: @1260410
     /* 1260410 */   GIM_Try, /*On fail goto*//*Label 18197*/ GIMT_Encode4(1260494), // Rule ID 7987 //
     /* 1260415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1260418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1260432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260468 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1260471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260493 */     // GIR_Coverage, 7987,
     /* 1260493 */     GIR_EraseRootFromParent_Done,
     /* 1260494 */   // Label 18197: @1260494
     /* 1260494 */   GIM_Try, /*On fail goto*//*Label 18198*/ GIMT_Encode4(1260578), // Rule ID 8078 //
     /* 1260499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1260516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1260519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260552 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1260555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260577 */     // GIR_Coverage, 8078,
     /* 1260577 */     GIR_EraseRootFromParent_Done,
     /* 1260578 */   // Label 18198: @1260578
     /* 1260578 */   GIM_Try, /*On fail goto*//*Label 18199*/ GIMT_Encode4(1260662), // Rule ID 8079 //
     /* 1260583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1260600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1260603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260636 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1260639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260661 */     // GIR_Coverage, 8079,
     /* 1260661 */     GIR_EraseRootFromParent_Done,
     /* 1260662 */   // Label 18199: @1260662
     /* 1260662 */   GIM_Try, /*On fail goto*//*Label 18200*/ GIMT_Encode4(1260746), // Rule ID 8082 //
     /* 1260667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1260684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1260687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260720 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1260723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260745 */     // GIR_Coverage, 8082,
     /* 1260745 */     GIR_EraseRootFromParent_Done,
     /* 1260746 */   // Label 18200: @1260746
     /* 1260746 */   GIM_Try, /*On fail goto*//*Label 18201*/ GIMT_Encode4(1260830), // Rule ID 8083 //
     /* 1260751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1260768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1260771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260804 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1260807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260829 */     // GIR_Coverage, 8083,
     /* 1260829 */     GIR_EraseRootFromParent_Done,
     /* 1260830 */   // Label 18201: @1260830
     /* 1260830 */   GIM_Try, /*On fail goto*//*Label 18202*/ GIMT_Encode4(1260914), // Rule ID 8086 //
     /* 1260835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1260852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1260855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260888 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260913 */     // GIR_Coverage, 8086,
     /* 1260913 */     GIR_EraseRootFromParent_Done,
     /* 1260914 */   // Label 18202: @1260914
     /* 1260914 */   GIM_Try, /*On fail goto*//*Label 18203*/ GIMT_Encode4(1260998), // Rule ID 8087 //
     /* 1260919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1260936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1260939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260972 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260997 */     // GIR_Coverage, 8087,
     /* 1260997 */     GIR_EraseRootFromParent_Done,
     /* 1260998 */   // Label 18203: @1260998
     /* 1260998 */   GIM_Try, /*On fail goto*//*Label 18204*/ GIMT_Encode4(1261082), // Rule ID 8090 //
     /* 1261003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1261020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1261023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261056 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1261059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261081 */     // GIR_Coverage, 8090,
     /* 1261081 */     GIR_EraseRootFromParent_Done,
     /* 1261082 */   // Label 18204: @1261082
     /* 1261082 */   GIM_Try, /*On fail goto*//*Label 18205*/ GIMT_Encode4(1261166), // Rule ID 8091 //
     /* 1261087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1261104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1261107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261140 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1261143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261165 */     // GIR_Coverage, 8091,
     /* 1261165 */     GIR_EraseRootFromParent_Done,
     /* 1261166 */   // Label 18205: @1261166
     /* 1261166 */   GIM_Try, /*On fail goto*//*Label 18206*/ GIMT_Encode4(1261250), // Rule ID 8094 //
     /* 1261171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1261188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1261191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261224 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1261227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261249 */     // GIR_Coverage, 8094,
     /* 1261249 */     GIR_EraseRootFromParent_Done,
     /* 1261250 */   // Label 18206: @1261250
     /* 1261250 */   GIM_Try, /*On fail goto*//*Label 18207*/ GIMT_Encode4(1261334), // Rule ID 8095 //
     /* 1261255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1261272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1261275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261308 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1261311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261333 */     // GIR_Coverage, 8095,
     /* 1261333 */     GIR_EraseRootFromParent_Done,
     /* 1261334 */   // Label 18207: @1261334
     /* 1261334 */   GIM_Try, /*On fail goto*//*Label 18208*/ GIMT_Encode4(1261418), // Rule ID 8098 //
     /* 1261339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1261356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1261359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1261395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261417 */     // GIR_Coverage, 8098,
     /* 1261417 */     GIR_EraseRootFromParent_Done,
     /* 1261418 */   // Label 18208: @1261418
     /* 1261418 */   GIM_Try, /*On fail goto*//*Label 18209*/ GIMT_Encode4(1261502), // Rule ID 8099 //
     /* 1261423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1261440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1261443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261476 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1261479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261501 */     // GIR_Coverage, 8099,
     /* 1261501 */     GIR_EraseRootFromParent_Done,
     /* 1261502 */   // Label 18209: @1261502
     /* 1261502 */   GIM_Try, /*On fail goto*//*Label 18210*/ GIMT_Encode4(1261586), // Rule ID 8102 //
     /* 1261507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261560 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261585 */     // GIR_Coverage, 8102,
     /* 1261585 */     GIR_EraseRootFromParent_Done,
     /* 1261586 */   // Label 18210: @1261586
     /* 1261586 */   GIM_Try, /*On fail goto*//*Label 18211*/ GIMT_Encode4(1261670), // Rule ID 8103 //
     /* 1261591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261644 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261669 */     // GIR_Coverage, 8103,
     /* 1261669 */     GIR_EraseRootFromParent_Done,
     /* 1261670 */   // Label 18211: @1261670
     /* 1261670 */   GIM_Try, /*On fail goto*//*Label 18212*/ GIMT_Encode4(1261754), // Rule ID 8106 //
     /* 1261675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1261692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261728 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261753 */     // GIR_Coverage, 8106,
     /* 1261753 */     GIR_EraseRootFromParent_Done,
     /* 1261754 */   // Label 18212: @1261754
     /* 1261754 */   GIM_Try, /*On fail goto*//*Label 18213*/ GIMT_Encode4(1261838), // Rule ID 8107 //
     /* 1261759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1261776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261812 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261837 */     // GIR_Coverage, 8107,
     /* 1261837 */     GIR_EraseRootFromParent_Done,
     /* 1261838 */   // Label 18213: @1261838
     /* 1261838 */   GIM_Try, /*On fail goto*//*Label 18214*/ GIMT_Encode4(1261922), // Rule ID 8110 //
     /* 1261843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1261860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1261863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261896 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261921 */     // GIR_Coverage, 8110,
     /* 1261921 */     GIR_EraseRootFromParent_Done,
     /* 1261922 */   // Label 18214: @1261922
     /* 1261922 */   GIM_Try, /*On fail goto*//*Label 18215*/ GIMT_Encode4(1262006), // Rule ID 8111 //
     /* 1261927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1261944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1261947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261980 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262005 */     // GIR_Coverage, 8111,
     /* 1262005 */     GIR_EraseRootFromParent_Done,
     /* 1262006 */   // Label 18215: @1262006
     /* 1262006 */   GIM_Try, /*On fail goto*//*Label 18216*/ GIMT_Encode4(1262090), // Rule ID 8114 //
     /* 1262011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1262014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1262022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1262025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1262028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1262031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1262034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1262067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1262085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262089 */     // GIR_Coverage, 8114,
     /* 1262089 */     GIR_EraseRootFromParent_Done,
     /* 1262090 */   // Label 18216: @1262090
     /* 1262090 */   GIM_Try, /*On fail goto*//*Label 18217*/ GIMT_Encode4(1262174), // Rule ID 8115 //
     /* 1262095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1262098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1262106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1262109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1262112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1262115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1262118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262148 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1262151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1262169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262173 */     // GIR_Coverage, 8115,
     /* 1262173 */     GIR_EraseRootFromParent_Done,
     /* 1262174 */   // Label 18217: @1262174
     /* 1262174 */   GIM_Try, /*On fail goto*//*Label 18218*/ GIMT_Encode4(1262258), // Rule ID 8118 //
     /* 1262179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1262196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1262199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262232 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262257 */     // GIR_Coverage, 8118,
     /* 1262257 */     GIR_EraseRootFromParent_Done,
     /* 1262258 */   // Label 18218: @1262258
     /* 1262258 */   GIM_Try, /*On fail goto*//*Label 18219*/ GIMT_Encode4(1262342), // Rule ID 8119 //
     /* 1262263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1262280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1262283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262316 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262341 */     // GIR_Coverage, 8119,
     /* 1262341 */     GIR_EraseRootFromParent_Done,
     /* 1262342 */   // Label 18219: @1262342
     /* 1262342 */   GIM_Try, /*On fail goto*//*Label 18220*/ GIMT_Encode4(1262426), // Rule ID 8122 //
     /* 1262347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1262364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1262367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262400 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262425 */     // GIR_Coverage, 8122,
     /* 1262425 */     GIR_EraseRootFromParent_Done,
     /* 1262426 */   // Label 18220: @1262426
     /* 1262426 */   GIM_Try, /*On fail goto*//*Label 18221*/ GIMT_Encode4(1262510), // Rule ID 8123 //
     /* 1262431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1262448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1262451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262484 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262509 */     // GIR_Coverage, 8123,
     /* 1262509 */     GIR_EraseRootFromParent_Done,
     /* 1262510 */   // Label 18221: @1262510
     /* 1262510 */   GIM_Try, /*On fail goto*//*Label 18222*/ GIMT_Encode4(1262594), // Rule ID 8126 //
     /* 1262515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1262526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1262529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1262535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262568 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1262571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262593 */     // GIR_Coverage, 8126,
     /* 1262593 */     GIR_EraseRootFromParent_Done,
     /* 1262594 */   // Label 18222: @1262594
     /* 1262594 */   GIM_Try, /*On fail goto*//*Label 18223*/ GIMT_Encode4(1262678), // Rule ID 8127 //
     /* 1262599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1262610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1262613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1262619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262652 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1262655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262677 */     // GIR_Coverage, 8127,
     /* 1262677 */     GIR_EraseRootFromParent_Done,
     /* 1262678 */   // Label 18223: @1262678
     /* 1262678 */   GIM_Try, /*On fail goto*//*Label 18224*/ GIMT_Encode4(1262762), // Rule ID 8130 //
     /* 1262683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1262700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1262703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262761 */     // GIR_Coverage, 8130,
     /* 1262761 */     GIR_EraseRootFromParent_Done,
     /* 1262762 */   // Label 18224: @1262762
     /* 1262762 */   GIM_Try, /*On fail goto*//*Label 18225*/ GIMT_Encode4(1262846), // Rule ID 8131 //
     /* 1262767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1262784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1262787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262820 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262845 */     // GIR_Coverage, 8131,
     /* 1262845 */     GIR_EraseRootFromParent_Done,
     /* 1262846 */   // Label 18225: @1262846
     /* 1262846 */   GIM_Try, /*On fail goto*//*Label 18226*/ GIMT_Encode4(1262930), // Rule ID 8134 //
     /* 1262851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1262868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1262871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262904 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262929 */     // GIR_Coverage, 8134,
     /* 1262929 */     GIR_EraseRootFromParent_Done,
     /* 1262930 */   // Label 18226: @1262930
     /* 1262930 */   GIM_Try, /*On fail goto*//*Label 18227*/ GIMT_Encode4(1263014), // Rule ID 8135 //
     /* 1262935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1262952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1262955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262988 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263013 */     // GIR_Coverage, 8135,
     /* 1263013 */     GIR_EraseRootFromParent_Done,
     /* 1263014 */   // Label 18227: @1263014
     /* 1263014 */   GIM_Try, /*On fail goto*//*Label 18228*/ GIMT_Encode4(1263098), // Rule ID 8138 //
     /* 1263019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1263030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1263033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1263036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1263039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1263042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263072 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263097 */     // GIR_Coverage, 8138,
     /* 1263097 */     GIR_EraseRootFromParent_Done,
     /* 1263098 */   // Label 18228: @1263098
     /* 1263098 */   GIM_Try, /*On fail goto*//*Label 18229*/ GIMT_Encode4(1263182), // Rule ID 8139 //
     /* 1263103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1263114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1263117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1263120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1263123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1263126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263156 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263181 */     // GIR_Coverage, 8139,
     /* 1263181 */     GIR_EraseRootFromParent_Done,
     /* 1263182 */   // Label 18229: @1263182
     /* 1263182 */   GIM_Try, /*On fail goto*//*Label 18230*/ GIMT_Encode4(1263266), // Rule ID 8142 //
     /* 1263187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1263204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1263207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263240 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1263243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263265 */     // GIR_Coverage, 8142,
     /* 1263265 */     GIR_EraseRootFromParent_Done,
     /* 1263266 */   // Label 18230: @1263266
     /* 1263266 */   GIM_Try, /*On fail goto*//*Label 18231*/ GIMT_Encode4(1263350), // Rule ID 8143 //
     /* 1263271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1263288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1263291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263324 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1263327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263349 */     // GIR_Coverage, 8143,
     /* 1263349 */     GIR_EraseRootFromParent_Done,
     /* 1263350 */   // Label 18231: @1263350
     /* 1263350 */   GIM_Try, /*On fail goto*//*Label 18232*/ GIMT_Encode4(1263434), // Rule ID 8146 //
     /* 1263355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1263372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1263375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263408 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263433 */     // GIR_Coverage, 8146,
     /* 1263433 */     GIR_EraseRootFromParent_Done,
     /* 1263434 */   // Label 18232: @1263434
     /* 1263434 */   GIM_Try, /*On fail goto*//*Label 18233*/ GIMT_Encode4(1263518), // Rule ID 8147 //
     /* 1263439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1263456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1263459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263492 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263517 */     // GIR_Coverage, 8147,
     /* 1263517 */     GIR_EraseRootFromParent_Done,
     /* 1263518 */   // Label 18233: @1263518
     /* 1263518 */   GIM_Try, /*On fail goto*//*Label 18234*/ GIMT_Encode4(1263602), // Rule ID 8150 //
     /* 1263523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1263543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263576 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263601 */     // GIR_Coverage, 8150,
     /* 1263601 */     GIR_EraseRootFromParent_Done,
     /* 1263602 */   // Label 18234: @1263602
     /* 1263602 */   GIM_Try, /*On fail goto*//*Label 18235*/ GIMT_Encode4(1263686), // Rule ID 8151 //
     /* 1263607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1263627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263660 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263685 */     // GIR_Coverage, 8151,
     /* 1263685 */     GIR_EraseRootFromParent_Done,
     /* 1263686 */   // Label 18235: @1263686
     /* 1263686 */   GIM_Try, /*On fail goto*//*Label 18236*/ GIMT_Encode4(1263770), // Rule ID 8154 //
     /* 1263691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1263708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1263711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263744 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1263747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263769 */     // GIR_Coverage, 8154,
     /* 1263769 */     GIR_EraseRootFromParent_Done,
     /* 1263770 */   // Label 18236: @1263770
     /* 1263770 */   GIM_Try, /*On fail goto*//*Label 18237*/ GIMT_Encode4(1263854), // Rule ID 8155 //
     /* 1263775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1263792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1263795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263828 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1263831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263853 */     // GIR_Coverage, 8155,
     /* 1263853 */     GIR_EraseRootFromParent_Done,
     /* 1263854 */   // Label 18237: @1263854
     /* 1263854 */   GIM_Try, /*On fail goto*//*Label 18238*/ GIMT_Encode4(1263938), // Rule ID 8158 //
     /* 1263859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1263876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1263879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263912 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263937 */     // GIR_Coverage, 8158,
     /* 1263937 */     GIR_EraseRootFromParent_Done,
     /* 1263938 */   // Label 18238: @1263938
     /* 1263938 */   GIM_Try, /*On fail goto*//*Label 18239*/ GIMT_Encode4(1264022), // Rule ID 8159 //
     /* 1263943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1263960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1263963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263996 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264021 */     // GIR_Coverage, 8159,
     /* 1264021 */     GIR_EraseRootFromParent_Done,
     /* 1264022 */   // Label 18239: @1264022
     /* 1264022 */   GIM_Try, /*On fail goto*//*Label 18240*/ GIMT_Encode4(1264106), // Rule ID 8162 //
     /* 1264027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1264030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1264044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1264047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264080 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1264083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264105 */     // GIR_Coverage, 8162,
     /* 1264105 */     GIR_EraseRootFromParent_Done,
     /* 1264106 */   // Label 18240: @1264106
     /* 1264106 */   GIM_Try, /*On fail goto*//*Label 18241*/ GIMT_Encode4(1264190), // Rule ID 8163 //
     /* 1264111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1264114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1264128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1264131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264164 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1264167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264189 */     // GIR_Coverage, 8163,
     /* 1264189 */     GIR_EraseRootFromParent_Done,
     /* 1264190 */   // Label 18241: @1264190
     /* 1264190 */   GIM_Try, /*On fail goto*//*Label 18242*/ GIMT_Encode4(1264274), // Rule ID 8166 //
     /* 1264195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1264212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264248 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1264251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264273 */     // GIR_Coverage, 8166,
     /* 1264273 */     GIR_EraseRootFromParent_Done,
     /* 1264274 */   // Label 18242: @1264274
     /* 1264274 */   GIM_Try, /*On fail goto*//*Label 18243*/ GIMT_Encode4(1264358), // Rule ID 8167 //
     /* 1264279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1264296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264332 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1264335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264357 */     // GIR_Coverage, 8167,
     /* 1264357 */     GIR_EraseRootFromParent_Done,
     /* 1264358 */   // Label 18243: @1264358
     /* 1264358 */   GIM_Try, /*On fail goto*//*Label 18244*/ GIMT_Encode4(1264442), // Rule ID 8170 //
     /* 1264363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1264380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264416 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264441 */     // GIR_Coverage, 8170,
     /* 1264441 */     GIR_EraseRootFromParent_Done,
     /* 1264442 */   // Label 18244: @1264442
     /* 1264442 */   GIM_Try, /*On fail goto*//*Label 18245*/ GIMT_Encode4(1264526), // Rule ID 8171 //
     /* 1264447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1264464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264500 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264525 */     // GIR_Coverage, 8171,
     /* 1264525 */     GIR_EraseRootFromParent_Done,
     /* 1264526 */   // Label 18245: @1264526
     /* 1264526 */   GIM_Try, /*On fail goto*//*Label 18246*/ GIMT_Encode4(1264610), // Rule ID 8174 //
     /* 1264531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264584 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264609 */     // GIR_Coverage, 8174,
     /* 1264609 */     GIR_EraseRootFromParent_Done,
     /* 1264610 */   // Label 18246: @1264610
     /* 1264610 */   GIM_Try, /*On fail goto*//*Label 18247*/ GIMT_Encode4(1264694), // Rule ID 8175 //
     /* 1264615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264693 */     // GIR_Coverage, 8175,
     /* 1264693 */     GIR_EraseRootFromParent_Done,
     /* 1264694 */   // Label 18247: @1264694
     /* 1264694 */   GIM_Try, /*On fail goto*//*Label 18248*/ GIMT_Encode4(1264778), // Rule ID 8178 //
     /* 1264699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1264716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264752 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264777 */     // GIR_Coverage, 8178,
     /* 1264777 */     GIR_EraseRootFromParent_Done,
     /* 1264778 */   // Label 18248: @1264778
     /* 1264778 */   GIM_Try, /*On fail goto*//*Label 18249*/ GIMT_Encode4(1264862), // Rule ID 8179 //
     /* 1264783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1264800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264836 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264861 */     // GIR_Coverage, 8179,
     /* 1264861 */     GIR_EraseRootFromParent_Done,
     /* 1264862 */   // Label 18249: @1264862
     /* 1264862 */   GIM_Try, /*On fail goto*//*Label 18250*/ GIMT_Encode4(1264946), // Rule ID 8182 //
     /* 1264867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1264884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264920 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264945 */     // GIR_Coverage, 8182,
     /* 1264945 */     GIR_EraseRootFromParent_Done,
     /* 1264946 */   // Label 18250: @1264946
     /* 1264946 */   GIM_Try, /*On fail goto*//*Label 18251*/ GIMT_Encode4(1265030), // Rule ID 8183 //
     /* 1264951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1264968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265004 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1265007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265029 */     // GIR_Coverage, 8183,
     /* 1265029 */     GIR_EraseRootFromParent_Done,
     /* 1265030 */   // Label 18251: @1265030
     /* 1265030 */   GIM_Try, /*On fail goto*//*Label 18252*/ GIMT_Encode4(1265114), // Rule ID 8186 //
     /* 1265035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1265052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265088 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1265091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265113 */     // GIR_Coverage, 8186,
     /* 1265113 */     GIR_EraseRootFromParent_Done,
     /* 1265114 */   // Label 18252: @1265114
     /* 1265114 */   GIM_Try, /*On fail goto*//*Label 18253*/ GIMT_Encode4(1265198), // Rule ID 8187 //
     /* 1265119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1265136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265172 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1265175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265197 */     // GIR_Coverage, 8187,
     /* 1265197 */     GIR_EraseRootFromParent_Done,
     /* 1265198 */   // Label 18253: @1265198
     /* 1265198 */   GIM_Try, /*On fail goto*//*Label 18254*/ GIMT_Encode4(1265282), // Rule ID 8190 //
     /* 1265203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1265214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1265217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1265220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1265226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265256 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265281 */     // GIR_Coverage, 8190,
     /* 1265281 */     GIR_EraseRootFromParent_Done,
     /* 1265282 */   // Label 18254: @1265282
     /* 1265282 */   GIM_Try, /*On fail goto*//*Label 18255*/ GIMT_Encode4(1265366), // Rule ID 8191 //
     /* 1265287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1265298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1265301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1265304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1265310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265340 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265365 */     // GIR_Coverage, 8191,
     /* 1265365 */     GIR_EraseRootFromParent_Done,
     /* 1265366 */   // Label 18255: @1265366
     /* 1265366 */   GIM_Try, /*On fail goto*//*Label 18256*/ GIMT_Encode4(1265450), // Rule ID 8194 //
     /* 1265371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1265382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1265385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1265388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265424 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265449 */     // GIR_Coverage, 8194,
     /* 1265449 */     GIR_EraseRootFromParent_Done,
     /* 1265450 */   // Label 18256: @1265450
     /* 1265450 */   GIM_Try, /*On fail goto*//*Label 18257*/ GIMT_Encode4(1265534), // Rule ID 8195 //
     /* 1265455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1265466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1265469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1265472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265508 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265533 */     // GIR_Coverage, 8195,
     /* 1265533 */     GIR_EraseRootFromParent_Done,
     /* 1265534 */   // Label 18257: @1265534
     /* 1265534 */   GIM_Try, /*On fail goto*//*Label 18258*/ GIMT_Encode4(1265618), // Rule ID 8198 //
     /* 1265539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265592 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265617 */     // GIR_Coverage, 8198,
     /* 1265617 */     GIR_EraseRootFromParent_Done,
     /* 1265618 */   // Label 18258: @1265618
     /* 1265618 */   GIM_Try, /*On fail goto*//*Label 18259*/ GIMT_Encode4(1265702), // Rule ID 8199 //
     /* 1265623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265676 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265701 */     // GIR_Coverage, 8199,
     /* 1265701 */     GIR_EraseRootFromParent_Done,
     /* 1265702 */   // Label 18259: @1265702
     /* 1265702 */   GIM_Try, /*On fail goto*//*Label 18260*/ GIMT_Encode4(1265786), // Rule ID 8202 //
     /* 1265707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1265710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1265724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265785 */     // GIR_Coverage, 8202,
     /* 1265785 */     GIR_EraseRootFromParent_Done,
     /* 1265786 */   // Label 18260: @1265786
     /* 1265786 */   GIM_Try, /*On fail goto*//*Label 18261*/ GIMT_Encode4(1265870), // Rule ID 8203 //
     /* 1265791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1265794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1265808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265844 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265869 */     // GIR_Coverage, 8203,
     /* 1265869 */     GIR_EraseRootFromParent_Done,
     /* 1265870 */   // Label 18261: @1265870
     /* 1265870 */   GIM_Try, /*On fail goto*//*Label 18262*/ GIMT_Encode4(1265954), // Rule ID 8206 //
     /* 1265875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1265886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1265889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1265892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1265898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265928 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1265931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265953 */     // GIR_Coverage, 8206,
     /* 1265953 */     GIR_EraseRootFromParent_Done,
     /* 1265954 */   // Label 18262: @1265954
     /* 1265954 */   GIM_Try, /*On fail goto*//*Label 18263*/ GIMT_Encode4(1266038), // Rule ID 8207 //
     /* 1265959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1265970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1265973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1265976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1265982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266012 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266037 */     // GIR_Coverage, 8207,
     /* 1266037 */     GIR_EraseRootFromParent_Done,
     /* 1266038 */   // Label 18263: @1266038
     /* 1266038 */   GIM_Try, /*On fail goto*//*Label 18264*/ GIMT_Encode4(1266122), // Rule ID 8210 //
     /* 1266043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1266060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266096 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266121 */     // GIR_Coverage, 8210,
     /* 1266121 */     GIR_EraseRootFromParent_Done,
     /* 1266122 */   // Label 18264: @1266122
     /* 1266122 */   GIM_Try, /*On fail goto*//*Label 18265*/ GIMT_Encode4(1266206), // Rule ID 8211 //
     /* 1266127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1266144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266180 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266205 */     // GIR_Coverage, 8211,
     /* 1266205 */     GIR_EraseRootFromParent_Done,
     /* 1266206 */   // Label 18265: @1266206
     /* 1266206 */   GIM_Try, /*On fail goto*//*Label 18266*/ GIMT_Encode4(1266290), // Rule ID 8214 //
     /* 1266211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1266222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1266225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1266228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1266234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266264 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266289 */     // GIR_Coverage, 8214,
     /* 1266289 */     GIR_EraseRootFromParent_Done,
     /* 1266290 */   // Label 18266: @1266290
     /* 1266290 */   GIM_Try, /*On fail goto*//*Label 18267*/ GIMT_Encode4(1266374), // Rule ID 8215 //
     /* 1266295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1266306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1266309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1266312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1266318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266348 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266373 */     // GIR_Coverage, 8215,
     /* 1266373 */     GIR_EraseRootFromParent_Done,
     /* 1266374 */   // Label 18267: @1266374
     /* 1266374 */   GIM_Try, /*On fail goto*//*Label 18268*/ GIMT_Encode4(1266458), // Rule ID 8218 //
     /* 1266379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1266396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266457 */     // GIR_Coverage, 8218,
     /* 1266457 */     GIR_EraseRootFromParent_Done,
     /* 1266458 */   // Label 18268: @1266458
     /* 1266458 */   GIM_Try, /*On fail goto*//*Label 18269*/ GIMT_Encode4(1266542), // Rule ID 8219 //
     /* 1266463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1266480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266516 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266541 */     // GIR_Coverage, 8219,
     /* 1266541 */     GIR_EraseRootFromParent_Done,
     /* 1266542 */   // Label 18269: @1266542
     /* 1266542 */   GIM_Try, /*On fail goto*//*Label 18270*/ GIMT_Encode4(1266626), // Rule ID 8222 //
     /* 1266547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266600 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266625 */     // GIR_Coverage, 8222,
     /* 1266625 */     GIR_EraseRootFromParent_Done,
     /* 1266626 */   // Label 18270: @1266626
     /* 1266626 */   GIM_Try, /*On fail goto*//*Label 18271*/ GIMT_Encode4(1266710), // Rule ID 8223 //
     /* 1266631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266684 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266709 */     // GIR_Coverage, 8223,
     /* 1266709 */     GIR_EraseRootFromParent_Done,
     /* 1266710 */   // Label 18271: @1266710
     /* 1266710 */   GIM_Try, /*On fail goto*//*Label 18272*/ GIMT_Encode4(1266794), // Rule ID 8226 //
     /* 1266715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1266732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266768 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266793 */     // GIR_Coverage, 8226,
     /* 1266793 */     GIR_EraseRootFromParent_Done,
     /* 1266794 */   // Label 18272: @1266794
     /* 1266794 */   GIM_Try, /*On fail goto*//*Label 18273*/ GIMT_Encode4(1266878), // Rule ID 8227 //
     /* 1266799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1266816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266852 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266877 */     // GIR_Coverage, 8227,
     /* 1266877 */     GIR_EraseRootFromParent_Done,
     /* 1266878 */   // Label 18273: @1266878
     /* 1266878 */   GIM_Try, /*On fail goto*//*Label 18274*/ GIMT_Encode4(1266962), // Rule ID 8230 //
     /* 1266883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1266894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1266897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1266900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266936 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266961 */     // GIR_Coverage, 8230,
     /* 1266961 */     GIR_EraseRootFromParent_Done,
     /* 1266962 */   // Label 18274: @1266962
     /* 1266962 */   GIM_Try, /*On fail goto*//*Label 18275*/ GIMT_Encode4(1267046), // Rule ID 8231 //
     /* 1266967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1266978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1266981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1266984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267020 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1267023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267045 */     // GIR_Coverage, 8231,
     /* 1267045 */     GIR_EraseRootFromParent_Done,
     /* 1267046 */   // Label 18275: @1267046
     /* 1267046 */   GIM_Try, /*On fail goto*//*Label 18276*/ GIMT_Encode4(1267130), // Rule ID 8234 //
     /* 1267051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1267068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267104 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1267107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267129 */     // GIR_Coverage, 8234,
     /* 1267129 */     GIR_EraseRootFromParent_Done,
     /* 1267130 */   // Label 18276: @1267130
     /* 1267130 */   GIM_Try, /*On fail goto*//*Label 18277*/ GIMT_Encode4(1267214), // Rule ID 8235 //
     /* 1267135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1267152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267188 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1267191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267213 */     // GIR_Coverage, 8235,
     /* 1267213 */     GIR_EraseRootFromParent_Done,
     /* 1267214 */   // Label 18277: @1267214
     /* 1267214 */   GIM_Try, /*On fail goto*//*Label 18278*/ GIMT_Encode4(1267298), // Rule ID 8238 //
     /* 1267219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1267230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1267233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1267236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1267242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267272 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1267275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267297 */     // GIR_Coverage, 8238,
     /* 1267297 */     GIR_EraseRootFromParent_Done,
     /* 1267298 */   // Label 18278: @1267298
     /* 1267298 */   GIM_Try, /*On fail goto*//*Label 18279*/ GIMT_Encode4(1267382), // Rule ID 8239 //
     /* 1267303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1267314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1267317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1267320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1267326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267356 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1267359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267381 */     // GIR_Coverage, 8239,
     /* 1267381 */     GIR_EraseRootFromParent_Done,
     /* 1267382 */   // Label 18279: @1267382
     /* 1267382 */   GIM_Try, /*On fail goto*//*Label 18280*/ GIMT_Encode4(1267466), // Rule ID 8242 //
     /* 1267387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1267404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267440 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1267443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267465 */     // GIR_Coverage, 8242,
     /* 1267465 */     GIR_EraseRootFromParent_Done,
     /* 1267466 */   // Label 18280: @1267466
     /* 1267466 */   GIM_Try, /*On fail goto*//*Label 18281*/ GIMT_Encode4(1267550), // Rule ID 8243 //
     /* 1267471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1267488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267524 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1267527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267549 */     // GIR_Coverage, 8243,
     /* 1267549 */     GIR_EraseRootFromParent_Done,
     /* 1267550 */   // Label 18281: @1267550
     /* 1267550 */   GIM_Try, /*On fail goto*//*Label 18282*/ GIMT_Encode4(1267634), // Rule ID 8246 //
     /* 1267555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1267611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267633 */     // GIR_Coverage, 8246,
     /* 1267633 */     GIR_EraseRootFromParent_Done,
     /* 1267634 */   // Label 18282: @1267634
     /* 1267634 */   GIM_Try, /*On fail goto*//*Label 18283*/ GIMT_Encode4(1267718), // Rule ID 8247 //
     /* 1267639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267692 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1267695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267717 */     // GIR_Coverage, 8247,
     /* 1267717 */     GIR_EraseRootFromParent_Done,
     /* 1267718 */   // Label 18283: @1267718
     /* 1267718 */   GIM_Try, /*On fail goto*//*Label 18284*/ GIMT_Encode4(1267802), // Rule ID 8250 //
     /* 1267723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1267740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267776 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1267779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267801 */     // GIR_Coverage, 8250,
     /* 1267801 */     GIR_EraseRootFromParent_Done,
     /* 1267802 */   // Label 18284: @1267802
     /* 1267802 */   GIM_Try, /*On fail goto*//*Label 18285*/ GIMT_Encode4(1267886), // Rule ID 8251 //
     /* 1267807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1267824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267860 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1267863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267885 */     // GIR_Coverage, 8251,
     /* 1267885 */     GIR_EraseRootFromParent_Done,
     /* 1267886 */   // Label 18285: @1267886
     /* 1267886 */   GIM_Try, /*On fail goto*//*Label 18286*/ GIMT_Encode4(1267970), // Rule ID 8342 //
     /* 1267891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1267902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1267905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1267908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1267911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267944 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1267947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267969 */     // GIR_Coverage, 8342,
     /* 1267969 */     GIR_EraseRootFromParent_Done,
     /* 1267970 */   // Label 18286: @1267970
     /* 1267970 */   GIM_Try, /*On fail goto*//*Label 18287*/ GIMT_Encode4(1268054), // Rule ID 8343 //
     /* 1267975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1267986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1267989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1267992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1267995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1268031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268053 */     // GIR_Coverage, 8343,
     /* 1268053 */     GIR_EraseRootFromParent_Done,
     /* 1268054 */   // Label 18287: @1268054
     /* 1268054 */   GIM_Try, /*On fail goto*//*Label 18288*/ GIMT_Encode4(1268138), // Rule ID 8346 //
     /* 1268059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1268076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1268079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268112 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1268115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268137 */     // GIR_Coverage, 8346,
     /* 1268137 */     GIR_EraseRootFromParent_Done,
     /* 1268138 */   // Label 18288: @1268138
     /* 1268138 */   GIM_Try, /*On fail goto*//*Label 18289*/ GIMT_Encode4(1268222), // Rule ID 8347 //
     /* 1268143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1268160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1268163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268196 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1268199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268221 */     // GIR_Coverage, 8347,
     /* 1268221 */     GIR_EraseRootFromParent_Done,
     /* 1268222 */   // Label 18289: @1268222
     /* 1268222 */   GIM_Try, /*On fail goto*//*Label 18290*/ GIMT_Encode4(1268306), // Rule ID 8350 //
     /* 1268227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1268244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1268247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268280 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268305 */     // GIR_Coverage, 8350,
     /* 1268305 */     GIR_EraseRootFromParent_Done,
     /* 1268306 */   // Label 18290: @1268306
     /* 1268306 */   GIM_Try, /*On fail goto*//*Label 18291*/ GIMT_Encode4(1268390), // Rule ID 8351 //
     /* 1268311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1268328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1268331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268364 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268389 */     // GIR_Coverage, 8351,
     /* 1268389 */     GIR_EraseRootFromParent_Done,
     /* 1268390 */   // Label 18291: @1268390
     /* 1268390 */   GIM_Try, /*On fail goto*//*Label 18292*/ GIMT_Encode4(1268474), // Rule ID 8354 //
     /* 1268395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1268412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1268415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268448 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1268451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268473 */     // GIR_Coverage, 8354,
     /* 1268473 */     GIR_EraseRootFromParent_Done,
     /* 1268474 */   // Label 18292: @1268474
     /* 1268474 */   GIM_Try, /*On fail goto*//*Label 18293*/ GIMT_Encode4(1268558), // Rule ID 8355 //
     /* 1268479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1268496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1268499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268532 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1268535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268557 */     // GIR_Coverage, 8355,
     /* 1268557 */     GIR_EraseRootFromParent_Done,
     /* 1268558 */   // Label 18293: @1268558
     /* 1268558 */   GIM_Try, /*On fail goto*//*Label 18294*/ GIMT_Encode4(1268642), // Rule ID 8358 //
     /* 1268563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1268583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268616 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268641 */     // GIR_Coverage, 8358,
     /* 1268641 */     GIR_EraseRootFromParent_Done,
     /* 1268642 */   // Label 18294: @1268642
     /* 1268642 */   GIM_Try, /*On fail goto*//*Label 18295*/ GIMT_Encode4(1268726), // Rule ID 8359 //
     /* 1268647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1268667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268700 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268725 */     // GIR_Coverage, 8359,
     /* 1268725 */     GIR_EraseRootFromParent_Done,
     /* 1268726 */   // Label 18295: @1268726
     /* 1268726 */   GIM_Try, /*On fail goto*//*Label 18296*/ GIMT_Encode4(1268810), // Rule ID 8362 //
     /* 1268731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1268748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1268751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268784 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268809 */     // GIR_Coverage, 8362,
     /* 1268809 */     GIR_EraseRootFromParent_Done,
     /* 1268810 */   // Label 18296: @1268810
     /* 1268810 */   GIM_Try, /*On fail goto*//*Label 18297*/ GIMT_Encode4(1268894), // Rule ID 8363 //
     /* 1268815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1268832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1268835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268868 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268893 */     // GIR_Coverage, 8363,
     /* 1268893 */     GIR_EraseRootFromParent_Done,
     /* 1268894 */   // Label 18297: @1268894
     /* 1268894 */   GIM_Try, /*On fail goto*//*Label 18298*/ GIMT_Encode4(1268978), // Rule ID 8366 //
     /* 1268899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1268916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1268919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268952 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268977 */     // GIR_Coverage, 8366,
     /* 1268977 */     GIR_EraseRootFromParent_Done,
     /* 1268978 */   // Label 18298: @1268978
     /* 1268978 */   GIM_Try, /*On fail goto*//*Label 18299*/ GIMT_Encode4(1269062), // Rule ID 8367 //
     /* 1268983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1269000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1269003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269036 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269061 */     // GIR_Coverage, 8367,
     /* 1269061 */     GIR_EraseRootFromParent_Done,
     /* 1269062 */   // Label 18299: @1269062
     /* 1269062 */   GIM_Try, /*On fail goto*//*Label 18300*/ GIMT_Encode4(1269146), // Rule ID 8370 //
     /* 1269067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1269078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1269081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1269084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1269087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1269090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269120 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269145 */     // GIR_Coverage, 8370,
     /* 1269145 */     GIR_EraseRootFromParent_Done,
     /* 1269146 */   // Label 18300: @1269146
     /* 1269146 */   GIM_Try, /*On fail goto*//*Label 18301*/ GIMT_Encode4(1269230), // Rule ID 8371 //
     /* 1269151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1269162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1269165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1269168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1269171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1269174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269204 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269229 */     // GIR_Coverage, 8371,
     /* 1269229 */     GIR_EraseRootFromParent_Done,
     /* 1269230 */   // Label 18301: @1269230
     /* 1269230 */   GIM_Try, /*On fail goto*//*Label 18302*/ GIMT_Encode4(1269314), // Rule ID 8374 //
     /* 1269235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1269246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1269249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1269252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1269255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269288 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269313 */     // GIR_Coverage, 8374,
     /* 1269313 */     GIR_EraseRootFromParent_Done,
     /* 1269314 */   // Label 18302: @1269314
     /* 1269314 */   GIM_Try, /*On fail goto*//*Label 18303*/ GIMT_Encode4(1269398), // Rule ID 8375 //
     /* 1269319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1269330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1269333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1269336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1269339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269372 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269397 */     // GIR_Coverage, 8375,
     /* 1269397 */     GIR_EraseRootFromParent_Done,
     /* 1269398 */   // Label 18303: @1269398
     /* 1269398 */   GIM_Try, /*On fail goto*//*Label 18304*/ GIMT_Encode4(1269482), // Rule ID 8378 //
     /* 1269403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1269406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1269420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1269423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269456 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269481 */     // GIR_Coverage, 8378,
     /* 1269481 */     GIR_EraseRootFromParent_Done,
     /* 1269482 */   // Label 18304: @1269482
     /* 1269482 */   GIM_Try, /*On fail goto*//*Label 18305*/ GIMT_Encode4(1269566), // Rule ID 8379 //
     /* 1269487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1269490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1269504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1269507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269540 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269565 */     // GIR_Coverage, 8379,
     /* 1269565 */     GIR_EraseRootFromParent_Done,
     /* 1269566 */   // Label 18305: @1269566
     /* 1269566 */   GIM_Try, /*On fail goto*//*Label 18306*/ GIMT_Encode4(1269650), // Rule ID 8382 //
     /* 1269571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1269591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269624 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1269627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269649 */     // GIR_Coverage, 8382,
     /* 1269649 */     GIR_EraseRootFromParent_Done,
     /* 1269650 */   // Label 18306: @1269650
     /* 1269650 */   GIM_Try, /*On fail goto*//*Label 18307*/ GIMT_Encode4(1269734), // Rule ID 8383 //
     /* 1269655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1269675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269708 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1269711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269733 */     // GIR_Coverage, 8383,
     /* 1269733 */     GIR_EraseRootFromParent_Done,
     /* 1269734 */   // Label 18307: @1269734
     /* 1269734 */   GIM_Try, /*On fail goto*//*Label 18308*/ GIMT_Encode4(1269818), // Rule ID 8386 //
     /* 1269739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1269750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1269753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1269756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1269759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269792 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1269795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269817 */     // GIR_Coverage, 8386,
     /* 1269817 */     GIR_EraseRootFromParent_Done,
     /* 1269818 */   // Label 18308: @1269818
     /* 1269818 */   GIM_Try, /*On fail goto*//*Label 18309*/ GIMT_Encode4(1269902), // Rule ID 8387 //
     /* 1269823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1269834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1269837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1269840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1269843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269876 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1269879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269901 */     // GIR_Coverage, 8387,
     /* 1269901 */     GIR_EraseRootFromParent_Done,
     /* 1269902 */   // Label 18309: @1269902
     /* 1269902 */   GIM_Try, /*On fail goto*//*Label 18310*/ GIMT_Encode4(1269986), // Rule ID 8390 //
     /* 1269907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1269918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1269921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1269924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1269927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1269930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269960 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1269963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269985 */     // GIR_Coverage, 8390,
     /* 1269985 */     GIR_EraseRootFromParent_Done,
     /* 1269986 */   // Label 18310: @1269986
     /* 1269986 */   GIM_Try, /*On fail goto*//*Label 18311*/ GIMT_Encode4(1270070), // Rule ID 8391 //
     /* 1269991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1270002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1270005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1270008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1270011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1270014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270044 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270069 */     // GIR_Coverage, 8391,
     /* 1270069 */     GIR_EraseRootFromParent_Done,
     /* 1270070 */   // Label 18311: @1270070
     /* 1270070 */   GIM_Try, /*On fail goto*//*Label 18312*/ GIMT_Encode4(1270154), // Rule ID 8394 //
     /* 1270075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1270092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1270095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270128 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270153 */     // GIR_Coverage, 8394,
     /* 1270153 */     GIR_EraseRootFromParent_Done,
     /* 1270154 */   // Label 18312: @1270154
     /* 1270154 */   GIM_Try, /*On fail goto*//*Label 18313*/ GIMT_Encode4(1270238), // Rule ID 8395 //
     /* 1270159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1270176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1270179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270212 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270237 */     // GIR_Coverage, 8395,
     /* 1270237 */     GIR_EraseRootFromParent_Done,
     /* 1270238 */   // Label 18313: @1270238
     /* 1270238 */   GIM_Try, /*On fail goto*//*Label 18314*/ GIMT_Encode4(1270322), // Rule ID 8398 //
     /* 1270243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1270260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1270263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270296 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270321 */     // GIR_Coverage, 8398,
     /* 1270321 */     GIR_EraseRootFromParent_Done,
     /* 1270322 */   // Label 18314: @1270322
     /* 1270322 */   GIM_Try, /*On fail goto*//*Label 18315*/ GIMT_Encode4(1270406), // Rule ID 8399 //
     /* 1270327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1270344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1270347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270380 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270405 */     // GIR_Coverage, 8399,
     /* 1270405 */     GIR_EraseRootFromParent_Done,
     /* 1270406 */   // Label 18315: @1270406
     /* 1270406 */   GIM_Try, /*On fail goto*//*Label 18316*/ GIMT_Encode4(1270490), // Rule ID 8402 //
     /* 1270411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1270428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1270431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270464 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270489 */     // GIR_Coverage, 8402,
     /* 1270489 */     GIR_EraseRootFromParent_Done,
     /* 1270490 */   // Label 18316: @1270490
     /* 1270490 */   GIM_Try, /*On fail goto*//*Label 18317*/ GIMT_Encode4(1270574), // Rule ID 8403 //
     /* 1270495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1270512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1270515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270548 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270573 */     // GIR_Coverage, 8403,
     /* 1270573 */     GIR_EraseRootFromParent_Done,
     /* 1270574 */   // Label 18317: @1270574
     /* 1270574 */   GIM_Try, /*On fail goto*//*Label 18318*/ GIMT_Encode4(1270658), // Rule ID 8406 //
     /* 1270579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1270599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270632 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270657 */     // GIR_Coverage, 8406,
     /* 1270657 */     GIR_EraseRootFromParent_Done,
     /* 1270658 */   // Label 18318: @1270658
     /* 1270658 */   GIM_Try, /*On fail goto*//*Label 18319*/ GIMT_Encode4(1270742), // Rule ID 8407 //
     /* 1270663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1270683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270716 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270741 */     // GIR_Coverage, 8407,
     /* 1270741 */     GIR_EraseRootFromParent_Done,
     /* 1270742 */   // Label 18319: @1270742
     /* 1270742 */   GIM_Try, /*On fail goto*//*Label 18320*/ GIMT_Encode4(1270826), // Rule ID 8410 //
     /* 1270747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1270764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1270767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270800 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270825 */     // GIR_Coverage, 8410,
     /* 1270825 */     GIR_EraseRootFromParent_Done,
     /* 1270826 */   // Label 18320: @1270826
     /* 1270826 */   GIM_Try, /*On fail goto*//*Label 18321*/ GIMT_Encode4(1270910), // Rule ID 8411 //
     /* 1270831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1270848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1270851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270884 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270909 */     // GIR_Coverage, 8411,
     /* 1270909 */     GIR_EraseRootFromParent_Done,
     /* 1270910 */   // Label 18321: @1270910
     /* 1270910 */   GIM_Try, /*On fail goto*//*Label 18322*/ GIMT_Encode4(1270994), // Rule ID 8414 //
     /* 1270915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1270932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1270935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270968 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270993 */     // GIR_Coverage, 8414,
     /* 1270993 */     GIR_EraseRootFromParent_Done,
     /* 1270994 */   // Label 18322: @1270994
     /* 1270994 */   GIM_Try, /*On fail goto*//*Label 18323*/ GIMT_Encode4(1271078), // Rule ID 8415 //
     /* 1270999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1271010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1271013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1271016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1271019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1271022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271052 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1271055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271077 */     // GIR_Coverage, 8415,
     /* 1271077 */     GIR_EraseRootFromParent_Done,
     /* 1271078 */   // Label 18323: @1271078
     /* 1271078 */   GIM_Try, /*On fail goto*//*Label 18324*/ GIMT_Encode4(1271162), // Rule ID 8418 //
     /* 1271083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1271100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1271103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271136 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1271139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271161 */     // GIR_Coverage, 8418,
     /* 1271161 */     GIR_EraseRootFromParent_Done,
     /* 1271162 */   // Label 18324: @1271162
     /* 1271162 */   GIM_Try, /*On fail goto*//*Label 18325*/ GIMT_Encode4(1271246), // Rule ID 8419 //
     /* 1271167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1271184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1271187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271220 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1271223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271245 */     // GIR_Coverage, 8419,
     /* 1271245 */     GIR_EraseRootFromParent_Done,
     /* 1271246 */   // Label 18325: @1271246
     /* 1271246 */   GIM_Try, /*On fail goto*//*Label 18326*/ GIMT_Encode4(1271330), // Rule ID 8422 //
     /* 1271251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1271268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1271271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271304 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1271307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271329 */     // GIR_Coverage, 8422,
     /* 1271329 */     GIR_EraseRootFromParent_Done,
     /* 1271330 */   // Label 18326: @1271330
     /* 1271330 */   GIM_Try, /*On fail goto*//*Label 18327*/ GIMT_Encode4(1271414), // Rule ID 8423 //
     /* 1271335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1271352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1271355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271388 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1271391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271413 */     // GIR_Coverage, 8423,
     /* 1271413 */     GIR_EraseRootFromParent_Done,
     /* 1271414 */   // Label 18327: @1271414
     /* 1271414 */   GIM_Try, /*On fail goto*//*Label 18328*/ GIMT_Encode4(1271498), // Rule ID 8426 //
     /* 1271419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1271436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1271439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271472 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1271475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271497 */     // GIR_Coverage, 8426,
     /* 1271497 */     GIR_EraseRootFromParent_Done,
     /* 1271498 */   // Label 18328: @1271498
     /* 1271498 */   GIM_Try, /*On fail goto*//*Label 18329*/ GIMT_Encode4(1271582), // Rule ID 8427 //
     /* 1271503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1271520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1271523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271556 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1271559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271581 */     // GIR_Coverage, 8427,
     /* 1271581 */     GIR_EraseRootFromParent_Done,
     /* 1271582 */   // Label 18329: @1271582
     /* 1271582 */   GIM_Try, /*On fail goto*//*Label 18330*/ GIMT_Encode4(1271666), // Rule ID 8430 //
     /* 1271587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271640 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1271643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271665 */     // GIR_Coverage, 8430,
     /* 1271665 */     GIR_EraseRootFromParent_Done,
     /* 1271666 */   // Label 18330: @1271666
     /* 1271666 */   GIM_Try, /*On fail goto*//*Label 18331*/ GIMT_Encode4(1271750), // Rule ID 8431 //
     /* 1271671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271724 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1271727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271749 */     // GIR_Coverage, 8431,
     /* 1271749 */     GIR_EraseRootFromParent_Done,
     /* 1271750 */   // Label 18331: @1271750
     /* 1271750 */   GIM_Try, /*On fail goto*//*Label 18332*/ GIMT_Encode4(1271834), // Rule ID 8434 //
     /* 1271755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1271772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271808 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1271811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271833 */     // GIR_Coverage, 8434,
     /* 1271833 */     GIR_EraseRootFromParent_Done,
     /* 1271834 */   // Label 18332: @1271834
     /* 1271834 */   GIM_Try, /*On fail goto*//*Label 18333*/ GIMT_Encode4(1271918), // Rule ID 8435 //
     /* 1271839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1271856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271892 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1271895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271917 */     // GIR_Coverage, 8435,
     /* 1271917 */     GIR_EraseRootFromParent_Done,
     /* 1271918 */   // Label 18333: @1271918
     /* 1271918 */   GIM_Try, /*On fail goto*//*Label 18334*/ GIMT_Encode4(1272002), // Rule ID 8438 //
     /* 1271923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1271940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271976 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1271979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272001 */     // GIR_Coverage, 8438,
     /* 1272001 */     GIR_EraseRootFromParent_Done,
     /* 1272002 */   // Label 18334: @1272002
     /* 1272002 */   GIM_Try, /*On fail goto*//*Label 18335*/ GIMT_Encode4(1272086), // Rule ID 8439 //
     /* 1272007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1272024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272060 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272085 */     // GIR_Coverage, 8439,
     /* 1272085 */     GIR_EraseRootFromParent_Done,
     /* 1272086 */   // Label 18335: @1272086
     /* 1272086 */   GIM_Try, /*On fail goto*//*Label 18336*/ GIMT_Encode4(1272170), // Rule ID 8442 //
     /* 1272091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1272108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272144 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1272147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272169 */     // GIR_Coverage, 8442,
     /* 1272169 */     GIR_EraseRootFromParent_Done,
     /* 1272170 */   // Label 18336: @1272170
     /* 1272170 */   GIM_Try, /*On fail goto*//*Label 18337*/ GIMT_Encode4(1272254), // Rule ID 8443 //
     /* 1272175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1272192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272228 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1272231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272253 */     // GIR_Coverage, 8443,
     /* 1272253 */     GIR_EraseRootFromParent_Done,
     /* 1272254 */   // Label 18337: @1272254
     /* 1272254 */   GIM_Try, /*On fail goto*//*Label 18338*/ GIMT_Encode4(1272338), // Rule ID 8446 //
     /* 1272259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1272276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272312 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272337 */     // GIR_Coverage, 8446,
     /* 1272337 */     GIR_EraseRootFromParent_Done,
     /* 1272338 */   // Label 18338: @1272338
     /* 1272338 */   GIM_Try, /*On fail goto*//*Label 18339*/ GIMT_Encode4(1272422), // Rule ID 8447 //
     /* 1272343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1272360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272396 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272421 */     // GIR_Coverage, 8447,
     /* 1272421 */     GIR_EraseRootFromParent_Done,
     /* 1272422 */   // Label 18339: @1272422
     /* 1272422 */   GIM_Try, /*On fail goto*//*Label 18340*/ GIMT_Encode4(1272506), // Rule ID 8450 //
     /* 1272427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1272444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272480 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272505 */     // GIR_Coverage, 8450,
     /* 1272505 */     GIR_EraseRootFromParent_Done,
     /* 1272506 */   // Label 18340: @1272506
     /* 1272506 */   GIM_Try, /*On fail goto*//*Label 18341*/ GIMT_Encode4(1272590), // Rule ID 8451 //
     /* 1272511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1272528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272564 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272589 */     // GIR_Coverage, 8451,
     /* 1272589 */     GIR_EraseRootFromParent_Done,
     /* 1272590 */   // Label 18341: @1272590
     /* 1272590 */   GIM_Try, /*On fail goto*//*Label 18342*/ GIMT_Encode4(1272674), // Rule ID 8454 //
     /* 1272595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272648 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272673 */     // GIR_Coverage, 8454,
     /* 1272673 */     GIR_EraseRootFromParent_Done,
     /* 1272674 */   // Label 18342: @1272674
     /* 1272674 */   GIM_Try, /*On fail goto*//*Label 18343*/ GIMT_Encode4(1272758), // Rule ID 8455 //
     /* 1272679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272732 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272757 */     // GIR_Coverage, 8455,
     /* 1272757 */     GIR_EraseRootFromParent_Done,
     /* 1272758 */   // Label 18343: @1272758
     /* 1272758 */   GIM_Try, /*On fail goto*//*Label 18344*/ GIMT_Encode4(1272842), // Rule ID 8458 //
     /* 1272763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1272780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272816 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272841 */     // GIR_Coverage, 8458,
     /* 1272841 */     GIR_EraseRootFromParent_Done,
     /* 1272842 */   // Label 18344: @1272842
     /* 1272842 */   GIM_Try, /*On fail goto*//*Label 18345*/ GIMT_Encode4(1272926), // Rule ID 8459 //
     /* 1272847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1272864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272900 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272925 */     // GIR_Coverage, 8459,
     /* 1272925 */     GIR_EraseRootFromParent_Done,
     /* 1272926 */   // Label 18345: @1272926
     /* 1272926 */   GIM_Try, /*On fail goto*//*Label 18346*/ GIMT_Encode4(1273010), // Rule ID 8462 //
     /* 1272931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1272948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272984 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273009 */     // GIR_Coverage, 8462,
     /* 1273009 */     GIR_EraseRootFromParent_Done,
     /* 1273010 */   // Label 18346: @1273010
     /* 1273010 */   GIM_Try, /*On fail goto*//*Label 18347*/ GIMT_Encode4(1273094), // Rule ID 8463 //
     /* 1273015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1273026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1273029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1273032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1273038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1273071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273093 */     // GIR_Coverage, 8463,
     /* 1273093 */     GIR_EraseRootFromParent_Done,
     /* 1273094 */   // Label 18347: @1273094
     /* 1273094 */   GIM_Try, /*On fail goto*//*Label 18348*/ GIMT_Encode4(1273178), // Rule ID 8466 //
     /* 1273099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1273102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1273110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1273113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1273116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1273122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273152 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1273155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1273173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273177 */     // GIR_Coverage, 8466,
     /* 1273177 */     GIR_EraseRootFromParent_Done,
     /* 1273178 */   // Label 18348: @1273178
     /* 1273178 */   GIM_Try, /*On fail goto*//*Label 18349*/ GIMT_Encode4(1273262), // Rule ID 8467 //
     /* 1273183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1273186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1273194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1273197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1273200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1273206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273236 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1273239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1273257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273261 */     // GIR_Coverage, 8467,
     /* 1273261 */     GIR_EraseRootFromParent_Done,
     /* 1273262 */   // Label 18349: @1273262
     /* 1273262 */   GIM_Try, /*On fail goto*//*Label 18350*/ GIMT_Encode4(1273346), // Rule ID 8470 //
     /* 1273267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1273284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273320 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273345 */     // GIR_Coverage, 8470,
     /* 1273345 */     GIR_EraseRootFromParent_Done,
     /* 1273346 */   // Label 18350: @1273346
     /* 1273346 */   GIM_Try, /*On fail goto*//*Label 18351*/ GIMT_Encode4(1273430), // Rule ID 8471 //
     /* 1273351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1273368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273404 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273429 */     // GIR_Coverage, 8471,
     /* 1273429 */     GIR_EraseRootFromParent_Done,
     /* 1273430 */   // Label 18351: @1273430
     /* 1273430 */   GIM_Try, /*On fail goto*//*Label 18352*/ GIMT_Encode4(1273514), // Rule ID 8474 //
     /* 1273435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1273452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273488 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273513 */     // GIR_Coverage, 8474,
     /* 1273513 */     GIR_EraseRootFromParent_Done,
     /* 1273514 */   // Label 18352: @1273514
     /* 1273514 */   GIM_Try, /*On fail goto*//*Label 18353*/ GIMT_Encode4(1273598), // Rule ID 8475 //
     /* 1273519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1273536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273572 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273597 */     // GIR_Coverage, 8475,
     /* 1273597 */     GIR_EraseRootFromParent_Done,
     /* 1273598 */   // Label 18353: @1273598
     /* 1273598 */   GIM_Try, /*On fail goto*//*Label 18354*/ GIMT_Encode4(1273682), // Rule ID 8478 //
     /* 1273603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1273614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1273617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273656 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1273659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273681 */     // GIR_Coverage, 8478,
     /* 1273681 */     GIR_EraseRootFromParent_Done,
     /* 1273682 */   // Label 18354: @1273682
     /* 1273682 */   GIM_Try, /*On fail goto*//*Label 18355*/ GIMT_Encode4(1273766), // Rule ID 8479 //
     /* 1273687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1273698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1273701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273740 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1273743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273765 */     // GIR_Coverage, 8479,
     /* 1273765 */     GIR_EraseRootFromParent_Done,
     /* 1273766 */   // Label 18355: @1273766
     /* 1273766 */   GIM_Try, /*On fail goto*//*Label 18356*/ GIMT_Encode4(1273850), // Rule ID 8482 //
     /* 1273771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1273788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273849 */     // GIR_Coverage, 8482,
     /* 1273849 */     GIR_EraseRootFromParent_Done,
     /* 1273850 */   // Label 18356: @1273850
     /* 1273850 */   GIM_Try, /*On fail goto*//*Label 18357*/ GIMT_Encode4(1273934), // Rule ID 8483 //
     /* 1273855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1273872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273908 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273933 */     // GIR_Coverage, 8483,
     /* 1273933 */     GIR_EraseRootFromParent_Done,
     /* 1273934 */   // Label 18357: @1273934
     /* 1273934 */   GIM_Try, /*On fail goto*//*Label 18358*/ GIMT_Encode4(1274018), // Rule ID 8486 //
     /* 1273939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1273956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273992 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274017 */     // GIR_Coverage, 8486,
     /* 1274017 */     GIR_EraseRootFromParent_Done,
     /* 1274018 */   // Label 18358: @1274018
     /* 1274018 */   GIM_Try, /*On fail goto*//*Label 18359*/ GIMT_Encode4(1274102), // Rule ID 8487 //
     /* 1274023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1274040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274076 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274101 */     // GIR_Coverage, 8487,
     /* 1274101 */     GIR_EraseRootFromParent_Done,
     /* 1274102 */   // Label 18359: @1274102
     /* 1274102 */   GIM_Try, /*On fail goto*//*Label 18360*/ GIMT_Encode4(1274186), // Rule ID 8490 //
     /* 1274107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1274118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1274121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1274124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1274130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274160 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274185 */     // GIR_Coverage, 8490,
     /* 1274185 */     GIR_EraseRootFromParent_Done,
     /* 1274186 */   // Label 18360: @1274186
     /* 1274186 */   GIM_Try, /*On fail goto*//*Label 18361*/ GIMT_Encode4(1274270), // Rule ID 8491 //
     /* 1274191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1274202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1274205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1274208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1274214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274244 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274269 */     // GIR_Coverage, 8491,
     /* 1274269 */     GIR_EraseRootFromParent_Done,
     /* 1274270 */   // Label 18361: @1274270
     /* 1274270 */   GIM_Try, /*On fail goto*//*Label 18362*/ GIMT_Encode4(1274354), // Rule ID 8494 //
     /* 1274275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1274292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274328 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1274331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274353 */     // GIR_Coverage, 8494,
     /* 1274353 */     GIR_EraseRootFromParent_Done,
     /* 1274354 */   // Label 18362: @1274354
     /* 1274354 */   GIM_Try, /*On fail goto*//*Label 18363*/ GIMT_Encode4(1274438), // Rule ID 8495 //
     /* 1274359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1274376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274412 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1274415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274437 */     // GIR_Coverage, 8495,
     /* 1274437 */     GIR_EraseRootFromParent_Done,
     /* 1274438 */   // Label 18363: @1274438
     /* 1274438 */   GIM_Try, /*On fail goto*//*Label 18364*/ GIMT_Encode4(1274522), // Rule ID 8498 //
     /* 1274443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1274460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274496 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274521 */     // GIR_Coverage, 8498,
     /* 1274521 */     GIR_EraseRootFromParent_Done,
     /* 1274522 */   // Label 18364: @1274522
     /* 1274522 */   GIM_Try, /*On fail goto*//*Label 18365*/ GIMT_Encode4(1274606), // Rule ID 8499 //
     /* 1274527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1274544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274580 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274605 */     // GIR_Coverage, 8499,
     /* 1274605 */     GIR_EraseRootFromParent_Done,
     /* 1274606 */   // Label 18365: @1274606
     /* 1274606 */   GIM_Try, /*On fail goto*//*Label 18366*/ GIMT_Encode4(1274690), // Rule ID 8502 //
     /* 1274611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274664 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274689 */     // GIR_Coverage, 8502,
     /* 1274689 */     GIR_EraseRootFromParent_Done,
     /* 1274690 */   // Label 18366: @1274690
     /* 1274690 */   GIM_Try, /*On fail goto*//*Label 18367*/ GIMT_Encode4(1274774), // Rule ID 8503 //
     /* 1274695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274748 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274773 */     // GIR_Coverage, 8503,
     /* 1274773 */     GIR_EraseRootFromParent_Done,
     /* 1274774 */   // Label 18367: @1274774
     /* 1274774 */   GIM_Try, /*On fail goto*//*Label 18368*/ GIMT_Encode4(1274858), // Rule ID 8506 //
     /* 1274779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1274790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1274793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1274796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274832 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1274835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274857 */     // GIR_Coverage, 8506,
     /* 1274857 */     GIR_EraseRootFromParent_Done,
     /* 1274858 */   // Label 18368: @1274858
     /* 1274858 */   GIM_Try, /*On fail goto*//*Label 18369*/ GIMT_Encode4(1274942), // Rule ID 8507 //
     /* 1274863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1274874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1274877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1274880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274916 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1274919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274941 */     // GIR_Coverage, 8507,
     /* 1274941 */     GIR_EraseRootFromParent_Done,
     /* 1274942 */   // Label 18369: @1274942
     /* 1274942 */   GIM_Try, /*On fail goto*//*Label 18370*/ GIMT_Encode4(1275026), // Rule ID 8510 //
     /* 1274947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1274964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275000 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1275003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275025 */     // GIR_Coverage, 8510,
     /* 1275025 */     GIR_EraseRootFromParent_Done,
     /* 1275026 */   // Label 18370: @1275026
     /* 1275026 */   GIM_Try, /*On fail goto*//*Label 18371*/ GIMT_Encode4(1275110), // Rule ID 8511 //
     /* 1275031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1275034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1275048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275084 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1275087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275109 */     // GIR_Coverage, 8511,
     /* 1275109 */     GIR_EraseRootFromParent_Done,
     /* 1275110 */   // Label 18371: @1275110
     /* 1275110 */   GIM_Try, /*On fail goto*//*Label 18372*/ GIMT_Encode4(1275194), // Rule ID 8514 //
     /* 1275115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1275118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1275132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1275135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275168 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1275171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275193 */     // GIR_Coverage, 8514,
     /* 1275193 */     GIR_EraseRootFromParent_Done,
     /* 1275194 */   // Label 18372: @1275194
     /* 1275194 */   GIM_Try, /*On fail goto*//*Label 18373*/ GIMT_Encode4(1275278), // Rule ID 8515 //
     /* 1275199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1275202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1275216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275252 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1275255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275277 */     // GIR_Coverage, 8515,
     /* 1275277 */     GIR_EraseRootFromParent_Done,
     /* 1275278 */   // Label 18373: @1275278
     /* 1275278 */   GIM_Try, /*On fail goto*//*Label 18374*/ GIMT_Encode4(1275362), // Rule ID 8518 //
     /* 1275283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1275300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1275303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275336 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1275339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275361 */     // GIR_Coverage, 8518,
     /* 1275361 */     GIR_EraseRootFromParent_Done,
     /* 1275362 */   // Label 18374: @1275362
     /* 1275362 */   GIM_Try, /*On fail goto*//*Label 18375*/ GIMT_Encode4(1275446), // Rule ID 8519 //
     /* 1275367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1275384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1275387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275420 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1275423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275445 */     // GIR_Coverage, 8519,
     /* 1275445 */     GIR_EraseRootFromParent_Done,
     /* 1275446 */   // Label 18375: @1275446
     /* 1275446 */   GIM_Try, /*On fail goto*//*Label 18376*/ GIMT_Encode4(1275530), // Rule ID 8522 //
     /* 1275451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1275471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275504 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275529 */     // GIR_Coverage, 8522,
     /* 1275529 */     GIR_EraseRootFromParent_Done,
     /* 1275530 */   // Label 18376: @1275530
     /* 1275530 */   GIM_Try, /*On fail goto*//*Label 18377*/ GIMT_Encode4(1275614), // Rule ID 8523 //
     /* 1275535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1275555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275588 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275613 */     // GIR_Coverage, 8523,
     /* 1275613 */     GIR_EraseRootFromParent_Done,
     /* 1275614 */   // Label 18377: @1275614
     /* 1275614 */   GIM_Try, /*On fail goto*//*Label 18378*/ GIMT_Encode4(1275698), // Rule ID 8526 //
     /* 1275619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1275639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275672 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275697 */     // GIR_Coverage, 8526,
     /* 1275697 */     GIR_EraseRootFromParent_Done,
     /* 1275698 */   // Label 18378: @1275698
     /* 1275698 */   GIM_Try, /*On fail goto*//*Label 18379*/ GIMT_Encode4(1275782), // Rule ID 8527 //
     /* 1275703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1275723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275756 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275781 */     // GIR_Coverage, 8527,
     /* 1275781 */     GIR_EraseRootFromParent_Done,
     /* 1275782 */   // Label 18379: @1275782
     /* 1275782 */   GIM_Try, /*On fail goto*//*Label 18380*/ GIMT_Encode4(1275866), // Rule ID 8530 //
     /* 1275787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1275804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1275807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275840 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275865 */     // GIR_Coverage, 8530,
     /* 1275865 */     GIR_EraseRootFromParent_Done,
     /* 1275866 */   // Label 18380: @1275866
     /* 1275866 */   GIM_Try, /*On fail goto*//*Label 18381*/ GIMT_Encode4(1275950), // Rule ID 8531 //
     /* 1275871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1275888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1275891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275924 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275949 */     // GIR_Coverage, 8531,
     /* 1275949 */     GIR_EraseRootFromParent_Done,
     /* 1275950 */   // Label 18381: @1275950
     /* 1275950 */   GIM_Try, /*On fail goto*//*Label 18382*/ GIMT_Encode4(1276034), // Rule ID 8534 //
     /* 1275955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1275972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1275975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276008 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1276011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276033 */     // GIR_Coverage, 8534,
     /* 1276033 */     GIR_EraseRootFromParent_Done,
     /* 1276034 */   // Label 18382: @1276034
     /* 1276034 */   GIM_Try, /*On fail goto*//*Label 18383*/ GIMT_Encode4(1276118), // Rule ID 8535 //
     /* 1276039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1276056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1276059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276092 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1276095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276117 */     // GIR_Coverage, 8535,
     /* 1276117 */     GIR_EraseRootFromParent_Done,
     /* 1276118 */   // Label 18383: @1276118
     /* 1276118 */   GIM_Try, /*On fail goto*//*Label 18384*/ GIMT_Encode4(1276202), // Rule ID 8538 //
     /* 1276123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1276140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1276143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276176 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1276179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276201 */     // GIR_Coverage, 8538,
     /* 1276201 */     GIR_EraseRootFromParent_Done,
     /* 1276202 */   // Label 18384: @1276202
     /* 1276202 */   GIM_Try, /*On fail goto*//*Label 18385*/ GIMT_Encode4(1276286), // Rule ID 8539 //
     /* 1276207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1276224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1276227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276260 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1276263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276285 */     // GIR_Coverage, 8539,
     /* 1276285 */     GIR_EraseRootFromParent_Done,
     /* 1276286 */   // Label 18385: @1276286
     /* 1276286 */   GIM_Try, /*On fail goto*//*Label 18386*/ GIMT_Encode4(1276370), // Rule ID 8542 //
     /* 1276291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1276302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1276305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1276308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1276311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1276314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276344 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276369 */     // GIR_Coverage, 8542,
     /* 1276369 */     GIR_EraseRootFromParent_Done,
     /* 1276370 */   // Label 18386: @1276370
     /* 1276370 */   GIM_Try, /*On fail goto*//*Label 18387*/ GIMT_Encode4(1276454), // Rule ID 8543 //
     /* 1276375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1276386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1276389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1276392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1276395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1276398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276428 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276453 */     // GIR_Coverage, 8543,
     /* 1276453 */     GIR_EraseRootFromParent_Done,
     /* 1276454 */   // Label 18387: @1276454
     /* 1276454 */   GIM_Try, /*On fail goto*//*Label 18388*/ GIMT_Encode4(1276538), // Rule ID 8546 //
     /* 1276459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276537 */     // GIR_Coverage, 8546,
     /* 1276537 */     GIR_EraseRootFromParent_Done,
     /* 1276538 */   // Label 18388: @1276538
     /* 1276538 */   GIM_Try, /*On fail goto*//*Label 18389*/ GIMT_Encode4(1276622), // Rule ID 8547 //
     /* 1276543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276596 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276621 */     // GIR_Coverage, 8547,
     /* 1276621 */     GIR_EraseRootFromParent_Done,
     /* 1276622 */   // Label 18389: @1276622
     /* 1276622 */   GIM_Try, /*On fail goto*//*Label 18390*/ GIMT_Encode4(1276706), // Rule ID 8550 //
     /* 1276627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276680 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276705 */     // GIR_Coverage, 8550,
     /* 1276705 */     GIR_EraseRootFromParent_Done,
     /* 1276706 */   // Label 18390: @1276706
     /* 1276706 */   GIM_Try, /*On fail goto*//*Label 18391*/ GIMT_Encode4(1276790), // Rule ID 8551 //
     /* 1276711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276764 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276789 */     // GIR_Coverage, 8551,
     /* 1276789 */     GIR_EraseRootFromParent_Done,
     /* 1276790 */   // Label 18391: @1276790
     /* 1276790 */   GIM_Try, /*On fail goto*//*Label 18392*/ GIMT_Encode4(1276874), // Rule ID 8554 //
     /* 1276795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1276798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1276812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1276815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276848 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276873 */     // GIR_Coverage, 8554,
     /* 1276873 */     GIR_EraseRootFromParent_Done,
     /* 1276874 */   // Label 18392: @1276874
     /* 1276874 */   GIM_Try, /*On fail goto*//*Label 18393*/ GIMT_Encode4(1276958), // Rule ID 8555 //
     /* 1276879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1276882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1276896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1276899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276932 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276957 */     // GIR_Coverage, 8555,
     /* 1276957 */     GIR_EraseRootFromParent_Done,
     /* 1276958 */   // Label 18393: @1276958
     /* 1276958 */   GIM_Try, /*On fail goto*//*Label 18394*/ GIMT_Encode4(1277042), // Rule ID 8558 //
     /* 1276963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1276974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1276977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1276980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1276983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1276986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277016 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277041 */     // GIR_Coverage, 8558,
     /* 1277041 */     GIR_EraseRootFromParent_Done,
     /* 1277042 */   // Label 18394: @1277042
     /* 1277042 */   GIM_Try, /*On fail goto*//*Label 18395*/ GIMT_Encode4(1277126), // Rule ID 8559 //
     /* 1277047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1277064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1277067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277100 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277125 */     // GIR_Coverage, 8559,
     /* 1277125 */     GIR_EraseRootFromParent_Done,
     /* 1277126 */   // Label 18395: @1277126
     /* 1277126 */   GIM_Try, /*On fail goto*//*Label 18396*/ GIMT_Encode4(1277210), // Rule ID 8562 //
     /* 1277131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1277148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1277151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277184 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277209 */     // GIR_Coverage, 8562,
     /* 1277209 */     GIR_EraseRootFromParent_Done,
     /* 1277210 */   // Label 18396: @1277210
     /* 1277210 */   GIM_Try, /*On fail goto*//*Label 18397*/ GIMT_Encode4(1277294), // Rule ID 8563 //
     /* 1277215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1277232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1277235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277268 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277293 */     // GIR_Coverage, 8563,
     /* 1277293 */     GIR_EraseRootFromParent_Done,
     /* 1277294 */   // Label 18397: @1277294
     /* 1277294 */   GIM_Try, /*On fail goto*//*Label 18398*/ GIMT_Encode4(1277378), // Rule ID 8566 //
     /* 1277299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1277310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1277313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1277316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1277319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1277322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277352 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277377 */     // GIR_Coverage, 8566,
     /* 1277377 */     GIR_EraseRootFromParent_Done,
     /* 1277378 */   // Label 18398: @1277378
     /* 1277378 */   GIM_Try, /*On fail goto*//*Label 18399*/ GIMT_Encode4(1277462), // Rule ID 8567 //
     /* 1277383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1277394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1277397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1277400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1277403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1277406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277436 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277461 */     // GIR_Coverage, 8567,
     /* 1277461 */     GIR_EraseRootFromParent_Done,
     /* 1277462 */   // Label 18399: @1277462
     /* 1277462 */   GIM_Try, /*On fail goto*//*Label 18400*/ GIMT_Encode4(1277546), // Rule ID 8570 //
     /* 1277467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1277487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277520 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277545 */     // GIR_Coverage, 8570,
     /* 1277545 */     GIR_EraseRootFromParent_Done,
     /* 1277546 */   // Label 18400: @1277546
     /* 1277546 */   GIM_Try, /*On fail goto*//*Label 18401*/ GIMT_Encode4(1277630), // Rule ID 8571 //
     /* 1277551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1277571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277604 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277629 */     // GIR_Coverage, 8571,
     /* 1277629 */     GIR_EraseRootFromParent_Done,
     /* 1277630 */   // Label 18401: @1277630
     /* 1277630 */   GIM_Try, /*On fail goto*//*Label 18402*/ GIMT_Encode4(1277714), // Rule ID 8574 //
     /* 1277635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1277655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277688 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277713 */     // GIR_Coverage, 8574,
     /* 1277713 */     GIR_EraseRootFromParent_Done,
     /* 1277714 */   // Label 18402: @1277714
     /* 1277714 */   GIM_Try, /*On fail goto*//*Label 18403*/ GIMT_Encode4(1277798), // Rule ID 8575 //
     /* 1277719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1277739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277772 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277797 */     // GIR_Coverage, 8575,
     /* 1277797 */     GIR_EraseRootFromParent_Done,
     /* 1277798 */   // Label 18403: @1277798
     /* 1277798 */   GIM_Try, /*On fail goto*//*Label 18404*/ GIMT_Encode4(1277882), // Rule ID 8578 //
     /* 1277803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1277820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1277823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277856 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277881 */     // GIR_Coverage, 8578,
     /* 1277881 */     GIR_EraseRootFromParent_Done,
     /* 1277882 */   // Label 18404: @1277882
     /* 1277882 */   GIM_Try, /*On fail goto*//*Label 18405*/ GIMT_Encode4(1277966), // Rule ID 8579 //
     /* 1277887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1277904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1277907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277940 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277965 */     // GIR_Coverage, 8579,
     /* 1277965 */     GIR_EraseRootFromParent_Done,
     /* 1277966 */   // Label 18405: @1277966
     /* 1277966 */   GIM_Try, /*On fail goto*//*Label 18406*/ GIMT_Encode4(1278050), // Rule ID 8582 //
     /* 1277971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1277982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1277985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1277988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1277991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1277994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278024 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1278027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278049 */     // GIR_Coverage, 8582,
     /* 1278049 */     GIR_EraseRootFromParent_Done,
     /* 1278050 */   // Label 18406: @1278050
     /* 1278050 */   GIM_Try, /*On fail goto*//*Label 18407*/ GIMT_Encode4(1278134), // Rule ID 8583 //
     /* 1278055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1278072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1278075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278108 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1278111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278133 */     // GIR_Coverage, 8583,
     /* 1278133 */     GIR_EraseRootFromParent_Done,
     /* 1278134 */   // Label 18407: @1278134
     /* 1278134 */   GIM_Try, /*On fail goto*//*Label 18408*/ GIMT_Encode4(1278218), // Rule ID 8586 //
     /* 1278139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1278156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1278159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278192 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1278195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278217 */     // GIR_Coverage, 8586,
     /* 1278217 */     GIR_EraseRootFromParent_Done,
     /* 1278218 */   // Label 18408: @1278218
     /* 1278218 */   GIM_Try, /*On fail goto*//*Label 18409*/ GIMT_Encode4(1278302), // Rule ID 8587 //
     /* 1278223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1278240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1278243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278276 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1278279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278301 */     // GIR_Coverage, 8587,
     /* 1278301 */     GIR_EraseRootFromParent_Done,
     /* 1278302 */   // Label 18409: @1278302
     /* 1278302 */   GIM_Try, /*On fail goto*//*Label 18410*/ GIMT_Encode4(1278386), // Rule ID 8590 //
     /* 1278307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1278318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1278321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1278324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1278327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278360 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1278363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278385 */     // GIR_Coverage, 8590,
     /* 1278385 */     GIR_EraseRootFromParent_Done,
     /* 1278386 */   // Label 18410: @1278386
     /* 1278386 */   GIM_Try, /*On fail goto*//*Label 18411*/ GIMT_Encode4(1278470), // Rule ID 8591 //
     /* 1278391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1278402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1278405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1278408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1278411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278444 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1278447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278469 */     // GIR_Coverage, 8591,
     /* 1278469 */     GIR_EraseRootFromParent_Done,
     /* 1278470 */   // Label 18411: @1278470
     /* 1278470 */   GIM_Try, /*On fail goto*//*Label 18412*/ GIMT_Encode4(1278554), // Rule ID 8594 //
     /* 1278475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1278495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278528 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1278531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278553 */     // GIR_Coverage, 8594,
     /* 1278553 */     GIR_EraseRootFromParent_Done,
     /* 1278554 */   // Label 18412: @1278554
     /* 1278554 */   GIM_Try, /*On fail goto*//*Label 18413*/ GIMT_Encode4(1278638), // Rule ID 8595 //
     /* 1278559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1278579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278612 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1278615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278637 */     // GIR_Coverage, 8595,
     /* 1278637 */     GIR_EraseRootFromParent_Done,
     /* 1278638 */   // Label 18413: @1278638
     /* 1278638 */   GIM_Try, /*On fail goto*//*Label 18414*/ GIMT_Encode4(1278722), // Rule ID 8598 //
     /* 1278643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1278663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278696 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1278699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278721 */     // GIR_Coverage, 8598,
     /* 1278721 */     GIR_EraseRootFromParent_Done,
     /* 1278722 */   // Label 18414: @1278722
     /* 1278722 */   GIM_Try, /*On fail goto*//*Label 18415*/ GIMT_Encode4(1278806), // Rule ID 8599 //
     /* 1278727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1278747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278780 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1278783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278805 */     // GIR_Coverage, 8599,
     /* 1278805 */     GIR_EraseRootFromParent_Done,
     /* 1278806 */   // Label 18415: @1278806
     /* 1278806 */   GIM_Try, /*On fail goto*//*Label 18416*/ GIMT_Encode4(1278890), // Rule ID 8602 //
     /* 1278811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1278828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1278831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278864 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1278867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278889 */     // GIR_Coverage, 8602,
     /* 1278889 */     GIR_EraseRootFromParent_Done,
     /* 1278890 */   // Label 18416: @1278890
     /* 1278890 */   GIM_Try, /*On fail goto*//*Label 18417*/ GIMT_Encode4(1278974), // Rule ID 8603 //
     /* 1278895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1278912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1278915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278948 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1278951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278973 */     // GIR_Coverage, 8603,
     /* 1278973 */     GIR_EraseRootFromParent_Done,
     /* 1278974 */   // Label 18417: @1278974
     /* 1278974 */   GIM_Try, /*On fail goto*//*Label 18418*/ GIMT_Encode4(1279058), // Rule ID 8606 //
     /* 1278979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1278990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1278993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1278996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279032 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1279035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279057 */     // GIR_Coverage, 8606,
     /* 1279057 */     GIR_EraseRootFromParent_Done,
     /* 1279058 */   // Label 18418: @1279058
     /* 1279058 */   GIM_Try, /*On fail goto*//*Label 18419*/ GIMT_Encode4(1279142), // Rule ID 8607 //
     /* 1279063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1279080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279116 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1279119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279141 */     // GIR_Coverage, 8607,
     /* 1279141 */     GIR_EraseRootFromParent_Done,
     /* 1279142 */   // Label 18419: @1279142
     /* 1279142 */   GIM_Try, /*On fail goto*//*Label 18420*/ GIMT_Encode4(1279226), // Rule ID 8610 //
     /* 1279147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1279164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279200 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1279203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279225 */     // GIR_Coverage, 8610,
     /* 1279225 */     GIR_EraseRootFromParent_Done,
     /* 1279226 */   // Label 18420: @1279226
     /* 1279226 */   GIM_Try, /*On fail goto*//*Label 18421*/ GIMT_Encode4(1279310), // Rule ID 8611 //
     /* 1279231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1279248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279284 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1279287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279309 */     // GIR_Coverage, 8611,
     /* 1279309 */     GIR_EraseRootFromParent_Done,
     /* 1279310 */   // Label 18421: @1279310
     /* 1279310 */   GIM_Try, /*On fail goto*//*Label 18422*/ GIMT_Encode4(1279394), // Rule ID 8614 //
     /* 1279315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1279332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279368 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279393 */     // GIR_Coverage, 8614,
     /* 1279393 */     GIR_EraseRootFromParent_Done,
     /* 1279394 */   // Label 18422: @1279394
     /* 1279394 */   GIM_Try, /*On fail goto*//*Label 18423*/ GIMT_Encode4(1279478), // Rule ID 8615 //
     /* 1279399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1279416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279452 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279477 */     // GIR_Coverage, 8615,
     /* 1279477 */     GIR_EraseRootFromParent_Done,
     /* 1279478 */   // Label 18423: @1279478
     /* 1279478 */   GIM_Try, /*On fail goto*//*Label 18424*/ GIMT_Encode4(1279562), // Rule ID 8618 //
     /* 1279483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279536 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1279539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279561 */     // GIR_Coverage, 8618,
     /* 1279561 */     GIR_EraseRootFromParent_Done,
     /* 1279562 */   // Label 18424: @1279562
     /* 1279562 */   GIM_Try, /*On fail goto*//*Label 18425*/ GIMT_Encode4(1279646), // Rule ID 8619 //
     /* 1279567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1279623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279645 */     // GIR_Coverage, 8619,
     /* 1279645 */     GIR_EraseRootFromParent_Done,
     /* 1279646 */   // Label 18425: @1279646
     /* 1279646 */   GIM_Try, /*On fail goto*//*Label 18426*/ GIMT_Encode4(1279730), // Rule ID 8622 //
     /* 1279651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1279668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279729 */     // GIR_Coverage, 8622,
     /* 1279729 */     GIR_EraseRootFromParent_Done,
     /* 1279730 */   // Label 18426: @1279730
     /* 1279730 */   GIM_Try, /*On fail goto*//*Label 18427*/ GIMT_Encode4(1279814), // Rule ID 8623 //
     /* 1279735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1279752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279788 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279813 */     // GIR_Coverage, 8623,
     /* 1279813 */     GIR_EraseRootFromParent_Done,
     /* 1279814 */   // Label 18427: @1279814
     /* 1279814 */   GIM_Try, /*On fail goto*//*Label 18428*/ GIMT_Encode4(1279898), // Rule ID 8626 //
     /* 1279819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1279836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279872 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279897 */     // GIR_Coverage, 8626,
     /* 1279897 */     GIR_EraseRootFromParent_Done,
     /* 1279898 */   // Label 18428: @1279898
     /* 1279898 */   GIM_Try, /*On fail goto*//*Label 18429*/ GIMT_Encode4(1279982), // Rule ID 8627 //
     /* 1279903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1279920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279956 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279981 */     // GIR_Coverage, 8627,
     /* 1279981 */     GIR_EraseRootFromParent_Done,
     /* 1279982 */   // Label 18429: @1279982
     /* 1279982 */   GIM_Try, /*On fail goto*//*Label 18430*/ GIMT_Encode4(1280066), // Rule ID 8630 //
     /* 1279987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1280001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1280004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280040 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280065 */     // GIR_Coverage, 8630,
     /* 1280065 */     GIR_EraseRootFromParent_Done,
     /* 1280066 */   // Label 18430: @1280066
     /* 1280066 */   GIM_Try, /*On fail goto*//*Label 18431*/ GIMT_Encode4(1280150), // Rule ID 8631 //
     /* 1280071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1280082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1280085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1280088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280124 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280149 */     // GIR_Coverage, 8631,
     /* 1280149 */     GIR_EraseRootFromParent_Done,
     /* 1280150 */   // Label 18431: @1280150
     /* 1280150 */   GIM_Try, /*On fail goto*//*Label 18432*/ GIMT_Encode4(1280234), // Rule ID 8634 //
     /* 1280155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1280166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1280169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1280172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1280178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280208 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280233 */     // GIR_Coverage, 8634,
     /* 1280233 */     GIR_EraseRootFromParent_Done,
     /* 1280234 */   // Label 18432: @1280234
     /* 1280234 */   GIM_Try, /*On fail goto*//*Label 18433*/ GIMT_Encode4(1280318), // Rule ID 8635 //
     /* 1280239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1280250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1280253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1280256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1280262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280292 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280317 */     // GIR_Coverage, 8635,
     /* 1280317 */     GIR_EraseRootFromParent_Done,
     /* 1280318 */   // Label 18433: @1280318
     /* 1280318 */   GIM_Try, /*On fail goto*//*Label 18434*/ GIMT_Encode4(1280402), // Rule ID 8638 //
     /* 1280323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1280340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280401 */     // GIR_Coverage, 8638,
     /* 1280401 */     GIR_EraseRootFromParent_Done,
     /* 1280402 */   // Label 18434: @1280402
     /* 1280402 */   GIM_Try, /*On fail goto*//*Label 18435*/ GIMT_Encode4(1280486), // Rule ID 8639 //
     /* 1280407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1280424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280460 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280485 */     // GIR_Coverage, 8639,
     /* 1280485 */     GIR_EraseRootFromParent_Done,
     /* 1280486 */   // Label 18435: @1280486
     /* 1280486 */   GIM_Try, /*On fail goto*//*Label 18436*/ GIMT_Encode4(1280570), // Rule ID 8642 //
     /* 1280491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1280494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280544 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280569 */     // GIR_Coverage, 8642,
     /* 1280569 */     GIR_EraseRootFromParent_Done,
     /* 1280570 */   // Label 18436: @1280570
     /* 1280570 */   GIM_Try, /*On fail goto*//*Label 18437*/ GIMT_Encode4(1280654), // Rule ID 8643 //
     /* 1280575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1280578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280628 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280653 */     // GIR_Coverage, 8643,
     /* 1280653 */     GIR_EraseRootFromParent_Done,
     /* 1280654 */   // Label 18437: @1280654
     /* 1280654 */   GIM_Try, /*On fail goto*//*Label 18438*/ GIMT_Encode4(1280738), // Rule ID 8646 //
     /* 1280659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1280676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280712 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1280715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280737 */     // GIR_Coverage, 8646,
     /* 1280737 */     GIR_EraseRootFromParent_Done,
     /* 1280738 */   // Label 18438: @1280738
     /* 1280738 */   GIM_Try, /*On fail goto*//*Label 18439*/ GIMT_Encode4(1280822), // Rule ID 8647 //
     /* 1280743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1280760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280796 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1280799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280821 */     // GIR_Coverage, 8647,
     /* 1280821 */     GIR_EraseRootFromParent_Done,
     /* 1280822 */   // Label 18439: @1280822
     /* 1280822 */   GIM_Try, /*On fail goto*//*Label 18440*/ GIMT_Encode4(1280906), // Rule ID 8650 //
     /* 1280827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1280838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1280841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1280844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1280850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280880 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1280883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280905 */     // GIR_Coverage, 8650,
     /* 1280905 */     GIR_EraseRootFromParent_Done,
     /* 1280906 */   // Label 18440: @1280906
     /* 1280906 */   GIM_Try, /*On fail goto*//*Label 18441*/ GIMT_Encode4(1280990), // Rule ID 8651 //
     /* 1280911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1280922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1280925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1280928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1280934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280964 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1280967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280989 */     // GIR_Coverage, 8651,
     /* 1280989 */     GIR_EraseRootFromParent_Done,
     /* 1280990 */   // Label 18441: @1280990
     /* 1280990 */   GIM_Try, /*On fail goto*//*Label 18442*/ GIMT_Encode4(1281074), // Rule ID 8654 //
     /* 1280995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1281006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1281009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1281012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1281018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281048 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281073 */     // GIR_Coverage, 8654,
     /* 1281073 */     GIR_EraseRootFromParent_Done,
     /* 1281074 */   // Label 18442: @1281074
     /* 1281074 */   GIM_Try, /*On fail goto*//*Label 18443*/ GIMT_Encode4(1281158), // Rule ID 8655 //
     /* 1281079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1281090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1281093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1281096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1281102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281132 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281157 */     // GIR_Coverage, 8655,
     /* 1281157 */     GIR_EraseRootFromParent_Done,
     /* 1281158 */   // Label 18443: @1281158
     /* 1281158 */   GIM_Try, /*On fail goto*//*Label 18444*/ GIMT_Encode4(1281242), // Rule ID 8658 //
     /* 1281163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1281180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281216 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281241 */     // GIR_Coverage, 8658,
     /* 1281241 */     GIR_EraseRootFromParent_Done,
     /* 1281242 */   // Label 18444: @1281242
     /* 1281242 */   GIM_Try, /*On fail goto*//*Label 18445*/ GIMT_Encode4(1281326), // Rule ID 8659 //
     /* 1281247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1281264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281300 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281325 */     // GIR_Coverage, 8659,
     /* 1281325 */     GIR_EraseRootFromParent_Done,
     /* 1281326 */   // Label 18445: @1281326
     /* 1281326 */   GIM_Try, /*On fail goto*//*Label 18446*/ GIMT_Encode4(1281410), // Rule ID 8662 //
     /* 1281331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1281348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281384 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281409 */     // GIR_Coverage, 8662,
     /* 1281409 */     GIR_EraseRootFromParent_Done,
     /* 1281410 */   // Label 18446: @1281410
     /* 1281410 */   GIM_Try, /*On fail goto*//*Label 18447*/ GIMT_Encode4(1281494), // Rule ID 8663 //
     /* 1281415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1281432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281468 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281493 */     // GIR_Coverage, 8663,
     /* 1281493 */     GIR_EraseRootFromParent_Done,
     /* 1281494 */   // Label 18447: @1281494
     /* 1281494 */   GIM_Try, /*On fail goto*//*Label 18448*/ GIMT_Encode4(1281578), // Rule ID 8666 //
     /* 1281499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281552 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281577 */     // GIR_Coverage, 8666,
     /* 1281577 */     GIR_EraseRootFromParent_Done,
     /* 1281578 */   // Label 18448: @1281578
     /* 1281578 */   GIM_Try, /*On fail goto*//*Label 18449*/ GIMT_Encode4(1281662), // Rule ID 8667 //
     /* 1281583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281636 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281661 */     // GIR_Coverage, 8667,
     /* 1281661 */     GIR_EraseRootFromParent_Done,
     /* 1281662 */   // Label 18449: @1281662
     /* 1281662 */   GIM_Try, /*On fail goto*//*Label 18450*/ GIMT_Encode4(1281746), // Rule ID 8670 //
     /* 1281667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1281684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281720 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281745 */     // GIR_Coverage, 8670,
     /* 1281745 */     GIR_EraseRootFromParent_Done,
     /* 1281746 */   // Label 18450: @1281746
     /* 1281746 */   GIM_Try, /*On fail goto*//*Label 18451*/ GIMT_Encode4(1281830), // Rule ID 8671 //
     /* 1281751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1281768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281804 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281829 */     // GIR_Coverage, 8671,
     /* 1281829 */     GIR_EraseRootFromParent_Done,
     /* 1281830 */   // Label 18451: @1281830
     /* 1281830 */   GIM_Try, /*On fail goto*//*Label 18452*/ GIMT_Encode4(1281914), // Rule ID 8674 //
     /* 1281835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1281852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281913 */     // GIR_Coverage, 8674,
     /* 1281913 */     GIR_EraseRootFromParent_Done,
     /* 1281914 */   // Label 18452: @1281914
     /* 1281914 */   GIM_Try, /*On fail goto*//*Label 18453*/ GIMT_Encode4(1281998), // Rule ID 8675 //
     /* 1281919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1281936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281972 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281997 */     // GIR_Coverage, 8675,
     /* 1281997 */     GIR_EraseRootFromParent_Done,
     /* 1281998 */   // Label 18453: @1281998
     /* 1281998 */   GIM_Try, /*On fail goto*//*Label 18454*/ GIMT_Encode4(1282082), // Rule ID 8678 //
     /* 1282003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1282014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1282017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1282020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1282026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1282059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282081 */     // GIR_Coverage, 8678,
     /* 1282081 */     GIR_EraseRootFromParent_Done,
     /* 1282082 */   // Label 18454: @1282082
     /* 1282082 */   GIM_Try, /*On fail goto*//*Label 18455*/ GIMT_Encode4(1282166), // Rule ID 8679 //
     /* 1282087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1282098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1282101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1282104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1282110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282140 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1282143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282165 */     // GIR_Coverage, 8679,
     /* 1282165 */     GIR_EraseRootFromParent_Done,
     /* 1282166 */   // Label 18455: @1282166
     /* 1282166 */   GIM_Try, /*On fail goto*//*Label 18456*/ GIMT_Encode4(1282250), // Rule ID 8682 //
     /* 1282171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1282188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282224 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1282227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282249 */     // GIR_Coverage, 8682,
     /* 1282249 */     GIR_EraseRootFromParent_Done,
     /* 1282250 */   // Label 18456: @1282250
     /* 1282250 */   GIM_Try, /*On fail goto*//*Label 18457*/ GIMT_Encode4(1282334), // Rule ID 8683 //
     /* 1282255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1282272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282308 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1282311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282333 */     // GIR_Coverage, 8683,
     /* 1282333 */     GIR_EraseRootFromParent_Done,
     /* 1282334 */   // Label 18457: @1282334
     /* 1282334 */   GIM_Try, /*On fail goto*//*Label 18458*/ GIMT_Encode4(1282418), // Rule ID 8686 //
     /* 1282339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1282356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282392 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1282395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282417 */     // GIR_Coverage, 8686,
     /* 1282417 */     GIR_EraseRootFromParent_Done,
     /* 1282418 */   // Label 18458: @1282418
     /* 1282418 */   GIM_Try, /*On fail goto*//*Label 18459*/ GIMT_Encode4(1282502), // Rule ID 8687 //
     /* 1282423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1282440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282476 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1282479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282501 */     // GIR_Coverage, 8687,
     /* 1282501 */     GIR_EraseRootFromParent_Done,
     /* 1282502 */   // Label 18459: @1282502
     /* 1282502 */   GIM_Try, /*On fail goto*//*Label 18460*/ GIMT_Encode4(1282586), // Rule ID 8690 //
     /* 1282507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282560 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1282563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282585 */     // GIR_Coverage, 8690,
     /* 1282585 */     GIR_EraseRootFromParent_Done,
     /* 1282586 */   // Label 18460: @1282586
     /* 1282586 */   GIM_Try, /*On fail goto*//*Label 18461*/ GIMT_Encode4(1282670), // Rule ID 8691 //
     /* 1282591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282644 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1282647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282669 */     // GIR_Coverage, 8691,
     /* 1282669 */     GIR_EraseRootFromParent_Done,
     /* 1282670 */   // Label 18461: @1282670
     /* 1282670 */   GIM_Try, /*On fail goto*//*Label 18462*/ GIMT_Encode4(1282754), // Rule ID 8694 //
     /* 1282675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1282692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1282695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1282731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282753 */     // GIR_Coverage, 8694,
     /* 1282753 */     GIR_EraseRootFromParent_Done,
     /* 1282754 */   // Label 18462: @1282754
     /* 1282754 */   GIM_Try, /*On fail goto*//*Label 18463*/ GIMT_Encode4(1282838), // Rule ID 8695 //
     /* 1282759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1282776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1282779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282812 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1282815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282837 */     // GIR_Coverage, 8695,
     /* 1282837 */     GIR_EraseRootFromParent_Done,
     /* 1282838 */   // Label 18463: @1282838
     /* 1282838 */   GIM_Try, /*On fail goto*//*Label 18464*/ GIMT_Encode4(1282922), // Rule ID 8698 //
     /* 1282843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1282860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1282863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282896 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1282899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282921 */     // GIR_Coverage, 8698,
     /* 1282921 */     GIR_EraseRootFromParent_Done,
     /* 1282922 */   // Label 18464: @1282922
     /* 1282922 */   GIM_Try, /*On fail goto*//*Label 18465*/ GIMT_Encode4(1283006), // Rule ID 8699 //
     /* 1282927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1282944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1282947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282980 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1282983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283005 */     // GIR_Coverage, 8699,
     /* 1283005 */     GIR_EraseRootFromParent_Done,
     /* 1283006 */   // Label 18465: @1283006
     /* 1283006 */   GIM_Try, /*On fail goto*//*Label 18466*/ GIMT_Encode4(1283090), // Rule ID 8702 //
     /* 1283011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1283028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1283031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283064 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283089 */     // GIR_Coverage, 8702,
     /* 1283089 */     GIR_EraseRootFromParent_Done,
     /* 1283090 */   // Label 18466: @1283090
     /* 1283090 */   GIM_Try, /*On fail goto*//*Label 18467*/ GIMT_Encode4(1283174), // Rule ID 8703 //
     /* 1283095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1283112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1283115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283148 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283173 */     // GIR_Coverage, 8703,
     /* 1283173 */     GIR_EraseRootFromParent_Done,
     /* 1283174 */   // Label 18467: @1283174
     /* 1283174 */   GIM_Try, /*On fail goto*//*Label 18468*/ GIMT_Encode4(1283258), // Rule ID 8706 //
     /* 1283179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1283196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1283199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1283235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283257 */     // GIR_Coverage, 8706,
     /* 1283257 */     GIR_EraseRootFromParent_Done,
     /* 1283258 */   // Label 18468: @1283258
     /* 1283258 */   GIM_Try, /*On fail goto*//*Label 18469*/ GIMT_Encode4(1283342), // Rule ID 8707 //
     /* 1283263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1283280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1283283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283316 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1283319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283341 */     // GIR_Coverage, 8707,
     /* 1283341 */     GIR_EraseRootFromParent_Done,
     /* 1283342 */   // Label 18469: @1283342
     /* 1283342 */   GIM_Try, /*On fail goto*//*Label 18470*/ GIMT_Encode4(1283426), // Rule ID 8710 //
     /* 1283347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1283364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1283367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283400 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283425 */     // GIR_Coverage, 8710,
     /* 1283425 */     GIR_EraseRootFromParent_Done,
     /* 1283426 */   // Label 18470: @1283426
     /* 1283426 */   GIM_Try, /*On fail goto*//*Label 18471*/ GIMT_Encode4(1283510), // Rule ID 8711 //
     /* 1283431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1283448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1283451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283484 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283509 */     // GIR_Coverage, 8711,
     /* 1283509 */     GIR_EraseRootFromParent_Done,
     /* 1283510 */   // Label 18471: @1283510
     /* 1283510 */   GIM_Try, /*On fail goto*//*Label 18472*/ GIMT_Encode4(1283594), // Rule ID 8714 //
     /* 1283515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1283535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283568 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283593 */     // GIR_Coverage, 8714,
     /* 1283593 */     GIR_EraseRootFromParent_Done,
     /* 1283594 */   // Label 18472: @1283594
     /* 1283594 */   GIM_Try, /*On fail goto*//*Label 18473*/ GIMT_Encode4(1283678), // Rule ID 8715 //
     /* 1283599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1283619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283652 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283677 */     // GIR_Coverage, 8715,
     /* 1283677 */     GIR_EraseRootFromParent_Done,
     /* 1283678 */   // Label 18473: @1283678
     /* 1283678 */   GIM_Try, /*On fail goto*//*Label 18474*/ GIMT_Encode4(1283762), // Rule ID 8718 //
     /* 1283683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1283694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1283697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1283700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283761 */     // GIR_Coverage, 8718,
     /* 1283761 */     GIR_EraseRootFromParent_Done,
     /* 1283762 */   // Label 18474: @1283762
     /* 1283762 */   GIM_Try, /*On fail goto*//*Label 18475*/ GIMT_Encode4(1283846), // Rule ID 8719 //
     /* 1283767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1283778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1283781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1283784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283820 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283845 */     // GIR_Coverage, 8719,
     /* 1283845 */     GIR_EraseRootFromParent_Done,
     /* 1283846 */   // Label 18475: @1283846
     /* 1283846 */   GIM_Try, /*On fail goto*//*Label 18476*/ GIMT_Encode4(1283930), // Rule ID 8722 //
     /* 1283851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1283868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283929 */     // GIR_Coverage, 8722,
     /* 1283929 */     GIR_EraseRootFromParent_Done,
     /* 1283930 */   // Label 18476: @1283930
     /* 1283930 */   GIM_Try, /*On fail goto*//*Label 18477*/ GIMT_Encode4(1284014), // Rule ID 8723 //
     /* 1283935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1283952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283988 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284013 */     // GIR_Coverage, 8723,
     /* 1284013 */     GIR_EraseRootFromParent_Done,
     /* 1284014 */   // Label 18477: @1284014
     /* 1284014 */   GIM_Try, /*On fail goto*//*Label 18478*/ GIMT_Encode4(1284098), // Rule ID 8726 //
     /* 1284019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1284030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1284033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1284036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1284039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1284042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284072 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1284075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284097 */     // GIR_Coverage, 8726,
     /* 1284097 */     GIR_EraseRootFromParent_Done,
     /* 1284098 */   // Label 18478: @1284098
     /* 1284098 */   GIM_Try, /*On fail goto*//*Label 18479*/ GIMT_Encode4(1284182), // Rule ID 8727 //
     /* 1284103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1284114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1284117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1284120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1284123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1284126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284156 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1284159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284181 */     // GIR_Coverage, 8727,
     /* 1284181 */     GIR_EraseRootFromParent_Done,
     /* 1284182 */   // Label 18479: @1284182
     /* 1284182 */   GIM_Try, /*On fail goto*//*Label 18480*/ GIMT_Encode4(1284266), // Rule ID 8730 //
     /* 1284187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1284190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1284198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1284201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1284204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1284207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1284210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284240 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1284243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1284261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284265 */     // GIR_Coverage, 8730,
     /* 1284265 */     GIR_EraseRootFromParent_Done,
     /* 1284266 */   // Label 18480: @1284266
     /* 1284266 */   GIM_Try, /*On fail goto*//*Label 18481*/ GIMT_Encode4(1284350), // Rule ID 8731 //
     /* 1284271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1284274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1284282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1284285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1284288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1284291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1284294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284324 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1284327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1284345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284349 */     // GIR_Coverage, 8731,
     /* 1284349 */     GIR_EraseRootFromParent_Done,
     /* 1284350 */   // Label 18481: @1284350
     /* 1284350 */   GIM_Try, /*On fail goto*//*Label 18482*/ GIMT_Encode4(1284434), // Rule ID 8734 //
     /* 1284355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1284372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1284375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284408 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284433 */     // GIR_Coverage, 8734,
     /* 1284433 */     GIR_EraseRootFromParent_Done,
     /* 1284434 */   // Label 18482: @1284434
     /* 1284434 */   GIM_Try, /*On fail goto*//*Label 18483*/ GIMT_Encode4(1284518), // Rule ID 8735 //
     /* 1284439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1284456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1284459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284492 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284517 */     // GIR_Coverage, 8735,
     /* 1284517 */     GIR_EraseRootFromParent_Done,
     /* 1284518 */   // Label 18483: @1284518
     /* 1284518 */   GIM_Try, /*On fail goto*//*Label 18484*/ GIMT_Encode4(1284602), // Rule ID 8738 //
     /* 1284523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1284543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284576 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1284579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284601 */     // GIR_Coverage, 8738,
     /* 1284601 */     GIR_EraseRootFromParent_Done,
     /* 1284602 */   // Label 18484: @1284602
     /* 1284602 */   GIM_Try, /*On fail goto*//*Label 18485*/ GIMT_Encode4(1284686), // Rule ID 8739 //
     /* 1284607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1284627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284660 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1284663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284685 */     // GIR_Coverage, 8739,
     /* 1284685 */     GIR_EraseRootFromParent_Done,
     /* 1284686 */   // Label 18485: @1284686
     /* 1284686 */   GIM_Try, /*On fail goto*//*Label 18486*/ GIMT_Encode4(1284770), // Rule ID 8742 //
     /* 1284691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1284702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1284705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1284708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1284711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1284714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284744 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1284747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284769 */     // GIR_Coverage, 8742,
     /* 1284769 */     GIR_EraseRootFromParent_Done,
     /* 1284770 */   // Label 18486: @1284770
     /* 1284770 */   GIM_Try, /*On fail goto*//*Label 18487*/ GIMT_Encode4(1284854), // Rule ID 8743 //
     /* 1284775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1284786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1284789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1284792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1284795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1284798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284828 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1284831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284853 */     // GIR_Coverage, 8743,
     /* 1284853 */     GIR_EraseRootFromParent_Done,
     /* 1284854 */   // Label 18487: @1284854
     /* 1284854 */   GIM_Try, /*On fail goto*//*Label 18488*/ GIMT_Encode4(1284938), // Rule ID 8746 //
     /* 1284859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1284876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1284879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284937 */     // GIR_Coverage, 8746,
     /* 1284937 */     GIR_EraseRootFromParent_Done,
     /* 1284938 */   // Label 18488: @1284938
     /* 1284938 */   GIM_Try, /*On fail goto*//*Label 18489*/ GIMT_Encode4(1285022), // Rule ID 8747 //
     /* 1284943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1284960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1284963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284996 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285021 */     // GIR_Coverage, 8747,
     /* 1285021 */     GIR_EraseRootFromParent_Done,
     /* 1285022 */   // Label 18489: @1285022
     /* 1285022 */   GIM_Try, /*On fail goto*//*Label 18490*/ GIMT_Encode4(1285106), // Rule ID 8750 //
     /* 1285027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1285044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1285047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285080 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285105 */     // GIR_Coverage, 8750,
     /* 1285105 */     GIR_EraseRootFromParent_Done,
     /* 1285106 */   // Label 18490: @1285106
     /* 1285106 */   GIM_Try, /*On fail goto*//*Label 18491*/ GIMT_Encode4(1285190), // Rule ID 8751 //
     /* 1285111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1285128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1285131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285164 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285189 */     // GIR_Coverage, 8751,
     /* 1285189 */     GIR_EraseRootFromParent_Done,
     /* 1285190 */   // Label 18491: @1285190
     /* 1285190 */   GIM_Try, /*On fail goto*//*Label 18492*/ GIMT_Encode4(1285274), // Rule ID 8754 //
     /* 1285195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1285206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1285209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1285212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1285215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1285218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285248 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285273 */     // GIR_Coverage, 8754,
     /* 1285273 */     GIR_EraseRootFromParent_Done,
     /* 1285274 */   // Label 18492: @1285274
     /* 1285274 */   GIM_Try, /*On fail goto*//*Label 18493*/ GIMT_Encode4(1285358), // Rule ID 8755 //
     /* 1285279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1285290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1285293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1285296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1285299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1285302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285332 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285357 */     // GIR_Coverage, 8755,
     /* 1285357 */     GIR_EraseRootFromParent_Done,
     /* 1285358 */   // Label 18493: @1285358
     /* 1285358 */   GIM_Try, /*On fail goto*//*Label 18494*/ GIMT_Encode4(1285442), // Rule ID 8758 //
     /* 1285363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1285380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1285383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285416 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285441 */     // GIR_Coverage, 8758,
     /* 1285441 */     GIR_EraseRootFromParent_Done,
     /* 1285442 */   // Label 18494: @1285442
     /* 1285442 */   GIM_Try, /*On fail goto*//*Label 18495*/ GIMT_Encode4(1285526), // Rule ID 8759 //
     /* 1285447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1285464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1285467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285500 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285525 */     // GIR_Coverage, 8759,
     /* 1285525 */     GIR_EraseRootFromParent_Done,
     /* 1285526 */   // Label 18495: @1285526
     /* 1285526 */   GIM_Try, /*On fail goto*//*Label 18496*/ GIMT_Encode4(1285610), // Rule ID 8762 //
     /* 1285531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1285551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285609 */     // GIR_Coverage, 8762,
     /* 1285609 */     GIR_EraseRootFromParent_Done,
     /* 1285610 */   // Label 18496: @1285610
     /* 1285610 */   GIM_Try, /*On fail goto*//*Label 18497*/ GIMT_Encode4(1285694), // Rule ID 8763 //
     /* 1285615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1285635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285668 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285693 */     // GIR_Coverage, 8763,
     /* 1285693 */     GIR_EraseRootFromParent_Done,
     /* 1285694 */   // Label 18497: @1285694
     /* 1285694 */   GIM_Try, /*On fail goto*//*Label 18498*/ GIMT_Encode4(1285778), // Rule ID 8766 //
     /* 1285699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1285716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1285719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285752 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285777 */     // GIR_Coverage, 8766,
     /* 1285777 */     GIR_EraseRootFromParent_Done,
     /* 1285778 */   // Label 18498: @1285778
     /* 1285778 */   GIM_Try, /*On fail goto*//*Label 18499*/ GIMT_Encode4(1285862), // Rule ID 8767 //
     /* 1285783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1285800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1285803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285836 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285861 */     // GIR_Coverage, 8767,
     /* 1285861 */     GIR_EraseRootFromParent_Done,
     /* 1285862 */   // Label 18499: @1285862
     /* 1285862 */   GIM_Try, /*On fail goto*//*Label 18500*/ GIMT_Encode4(1285946), // Rule ID 8770 //
     /* 1285867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1285878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1285881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1285884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1285887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285920 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285945 */     // GIR_Coverage, 8770,
     /* 1285945 */     GIR_EraseRootFromParent_Done,
     /* 1285946 */   // Label 18500: @1285946
     /* 1285946 */   GIM_Try, /*On fail goto*//*Label 18501*/ GIMT_Encode4(1286030), // Rule ID 8771 //
     /* 1285951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1285954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1285962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1285965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1285968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1285971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286004 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1286007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286029 */     // GIR_Coverage, 8771,
     /* 1286029 */     GIR_EraseRootFromParent_Done,
     /* 1286030 */   // Label 18501: @1286030
     /* 1286030 */   GIM_Try, /*On fail goto*//*Label 18502*/ GIMT_Encode4(1286114), // Rule ID 8774 //
     /* 1286035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1286038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1286052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1286055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286088 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1286091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286113 */     // GIR_Coverage, 8774,
     /* 1286113 */     GIR_EraseRootFromParent_Done,
     /* 1286114 */   // Label 18502: @1286114
     /* 1286114 */   GIM_Try, /*On fail goto*//*Label 18503*/ GIMT_Encode4(1286198), // Rule ID 8775 //
     /* 1286119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1286122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1286136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1286139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1286175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286197 */     // GIR_Coverage, 8775,
     /* 1286197 */     GIR_EraseRootFromParent_Done,
     /* 1286198 */   // Label 18503: @1286198
     /* 1286198 */   GIM_Try, /*On fail goto*//*Label 18504*/ GIMT_Encode4(1286282), // Rule ID 8778 //
     /* 1286203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1286206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1286214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1286217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1286220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1286223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1286226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286256 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1286259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286281 */     // GIR_Coverage, 8778,
     /* 1286281 */     GIR_EraseRootFromParent_Done,
     /* 1286282 */   // Label 18504: @1286282
     /* 1286282 */   GIM_Try, /*On fail goto*//*Label 18505*/ GIMT_Encode4(1286366), // Rule ID 8779 //
     /* 1286287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1286290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1286298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1286301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1286304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1286307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1286310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286340 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1286343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286365 */     // GIR_Coverage, 8779,
     /* 1286365 */     GIR_EraseRootFromParent_Done,
     /* 1286366 */   // Label 18505: @1286366
     /* 1286366 */   GIM_Try, /*On fail goto*//*Label 18506*/ GIMT_Encode4(1286450), // Rule ID 8782 //
     /* 1286371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1286388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286424 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1286427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286449 */     // GIR_Coverage, 8782,
     /* 1286449 */     GIR_EraseRootFromParent_Done,
     /* 1286450 */   // Label 18506: @1286450
     /* 1286450 */   GIM_Try, /*On fail goto*//*Label 18507*/ GIMT_Encode4(1286534), // Rule ID 8783 //
     /* 1286455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1286472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286508 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1286511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286533 */     // GIR_Coverage, 8783,
     /* 1286533 */     GIR_EraseRootFromParent_Done,
     /* 1286534 */   // Label 18507: @1286534
     /* 1286534 */   GIM_Try, /*On fail goto*//*Label 18508*/ GIMT_Encode4(1286618), // Rule ID 8786 //
     /* 1286539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286592 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286617 */     // GIR_Coverage, 8786,
     /* 1286617 */     GIR_EraseRootFromParent_Done,
     /* 1286618 */   // Label 18508: @1286618
     /* 1286618 */   GIM_Try, /*On fail goto*//*Label 18509*/ GIMT_Encode4(1286702), // Rule ID 8787 //
     /* 1286623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286676 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286701 */     // GIR_Coverage, 8787,
     /* 1286701 */     GIR_EraseRootFromParent_Done,
     /* 1286702 */   // Label 18509: @1286702
     /* 1286702 */   GIM_Try, /*On fail goto*//*Label 18510*/ GIMT_Encode4(1286786), // Rule ID 8790 //
     /* 1286707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1286724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286760 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286785 */     // GIR_Coverage, 8790,
     /* 1286785 */     GIR_EraseRootFromParent_Done,
     /* 1286786 */   // Label 18510: @1286786
     /* 1286786 */   GIM_Try, /*On fail goto*//*Label 18511*/ GIMT_Encode4(1286870), // Rule ID 8791 //
     /* 1286791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1286808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286869 */     // GIR_Coverage, 8791,
     /* 1286869 */     GIR_EraseRootFromParent_Done,
     /* 1286870 */   // Label 18511: @1286870
     /* 1286870 */   GIM_Try, /*On fail goto*//*Label 18512*/ GIMT_Encode4(1286954), // Rule ID 8794 //
     /* 1286875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1286892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286928 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286953 */     // GIR_Coverage, 8794,
     /* 1286953 */     GIR_EraseRootFromParent_Done,
     /* 1286954 */   // Label 18512: @1286954
     /* 1286954 */   GIM_Try, /*On fail goto*//*Label 18513*/ GIMT_Encode4(1287038), // Rule ID 8795 //
     /* 1286959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1286976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287012 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1287015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287037 */     // GIR_Coverage, 8795,
     /* 1287037 */     GIR_EraseRootFromParent_Done,
     /* 1287038 */   // Label 18513: @1287038
     /* 1287038 */   GIM_Try, /*On fail goto*//*Label 18514*/ GIMT_Encode4(1287122), // Rule ID 8798 //
     /* 1287043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1287060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287096 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1287099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287121 */     // GIR_Coverage, 8798,
     /* 1287121 */     GIR_EraseRootFromParent_Done,
     /* 1287122 */   // Label 18514: @1287122
     /* 1287122 */   GIM_Try, /*On fail goto*//*Label 18515*/ GIMT_Encode4(1287206), // Rule ID 8799 //
     /* 1287127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1287144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287180 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1287183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287205 */     // GIR_Coverage, 8799,
     /* 1287205 */     GIR_EraseRootFromParent_Done,
     /* 1287206 */   // Label 18515: @1287206
     /* 1287206 */   GIM_Try, /*On fail goto*//*Label 18516*/ GIMT_Encode4(1287290), // Rule ID 8802 //
     /* 1287211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1287228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287264 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1287267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287289 */     // GIR_Coverage, 8802,
     /* 1287289 */     GIR_EraseRootFromParent_Done,
     /* 1287290 */   // Label 18516: @1287290
     /* 1287290 */   GIM_Try, /*On fail goto*//*Label 18517*/ GIMT_Encode4(1287374), // Rule ID 8803 //
     /* 1287295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1287312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287348 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1287351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287373 */     // GIR_Coverage, 8803,
     /* 1287373 */     GIR_EraseRootFromParent_Done,
     /* 1287374 */   // Label 18517: @1287374
     /* 1287374 */   GIM_Try, /*On fail goto*//*Label 18518*/ GIMT_Encode4(1287458), // Rule ID 8806 //
     /* 1287379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1287390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1287393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1287396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287457 */     // GIR_Coverage, 8806,
     /* 1287457 */     GIR_EraseRootFromParent_Done,
     /* 1287458 */   // Label 18518: @1287458
     /* 1287458 */   GIM_Try, /*On fail goto*//*Label 18519*/ GIMT_Encode4(1287542), // Rule ID 8807 //
     /* 1287463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1287474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1287477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1287480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287516 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287541 */     // GIR_Coverage, 8807,
     /* 1287541 */     GIR_EraseRootFromParent_Done,
     /* 1287542 */   // Label 18519: @1287542
     /* 1287542 */   GIM_Try, /*On fail goto*//*Label 18520*/ GIMT_Encode4(1287626), // Rule ID 8810 //
     /* 1287547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287600 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287625 */     // GIR_Coverage, 8810,
     /* 1287625 */     GIR_EraseRootFromParent_Done,
     /* 1287626 */   // Label 18520: @1287626
     /* 1287626 */   GIM_Try, /*On fail goto*//*Label 18521*/ GIMT_Encode4(1287710), // Rule ID 8811 //
     /* 1287631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287709 */     // GIR_Coverage, 8811,
     /* 1287709 */     GIR_EraseRootFromParent_Done,
     /* 1287710 */   // Label 18521: @1287710
     /* 1287710 */   GIM_Try, /*On fail goto*//*Label 18522*/ GIMT_Encode4(1287794), // Rule ID 8814 //
     /* 1287715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1287732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287768 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287793 */     // GIR_Coverage, 8814,
     /* 1287793 */     GIR_EraseRootFromParent_Done,
     /* 1287794 */   // Label 18522: @1287794
     /* 1287794 */   GIM_Try, /*On fail goto*//*Label 18523*/ GIMT_Encode4(1287878), // Rule ID 8815 //
     /* 1287799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1287816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287852 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287877 */     // GIR_Coverage, 8815,
     /* 1287877 */     GIR_EraseRootFromParent_Done,
     /* 1287878 */   // Label 18523: @1287878
     /* 1287878 */   GIM_Try, /*On fail goto*//*Label 18524*/ GIMT_Encode4(1287962), // Rule ID 8818 //
     /* 1287883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1287886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1287900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287936 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287961 */     // GIR_Coverage, 8818,
     /* 1287961 */     GIR_EraseRootFromParent_Done,
     /* 1287962 */   // Label 18524: @1287962
     /* 1287962 */   GIM_Try, /*On fail goto*//*Label 18525*/ GIMT_Encode4(1288046), // Rule ID 8819 //
     /* 1287967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1287970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1287984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288020 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1288023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1288041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288045 */     // GIR_Coverage, 8819,
     /* 1288045 */     GIR_EraseRootFromParent_Done,
     /* 1288046 */   // Label 18525: @1288046
     /* 1288046 */   GIM_Try, /*On fail goto*//*Label 18526*/ GIMT_Encode4(1288130), // Rule ID 8822 //
     /* 1288051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1288068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288104 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288129 */     // GIR_Coverage, 8822,
     /* 1288129 */     GIR_EraseRootFromParent_Done,
     /* 1288130 */   // Label 18526: @1288130
     /* 1288130 */   GIM_Try, /*On fail goto*//*Label 18527*/ GIMT_Encode4(1288214), // Rule ID 8823 //
     /* 1288135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1288152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288188 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288213 */     // GIR_Coverage, 8823,
     /* 1288213 */     GIR_EraseRootFromParent_Done,
     /* 1288214 */   // Label 18527: @1288214
     /* 1288214 */   GIM_Try, /*On fail goto*//*Label 18528*/ GIMT_Encode4(1288298), // Rule ID 8826 //
     /* 1288219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1288236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288272 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288297 */     // GIR_Coverage, 8826,
     /* 1288297 */     GIR_EraseRootFromParent_Done,
     /* 1288298 */   // Label 18528: @1288298
     /* 1288298 */   GIM_Try, /*On fail goto*//*Label 18529*/ GIMT_Encode4(1288382), // Rule ID 8827 //
     /* 1288303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1288320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288356 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288381 */     // GIR_Coverage, 8827,
     /* 1288381 */     GIR_EraseRootFromParent_Done,
     /* 1288382 */   // Label 18529: @1288382
     /* 1288382 */   GIM_Try, /*On fail goto*//*Label 18530*/ GIMT_Encode4(1288466), // Rule ID 8830 //
     /* 1288387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1288398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1288401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1288404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1288410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288440 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288465 */     // GIR_Coverage, 8830,
     /* 1288465 */     GIR_EraseRootFromParent_Done,
     /* 1288466 */   // Label 18530: @1288466
     /* 1288466 */   GIM_Try, /*On fail goto*//*Label 18531*/ GIMT_Encode4(1288550), // Rule ID 8831 //
     /* 1288471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1288482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1288485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1288488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1288494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288524 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288549 */     // GIR_Coverage, 8831,
     /* 1288549 */     GIR_EraseRootFromParent_Done,
     /* 1288550 */   // Label 18531: @1288550
     /* 1288550 */   GIM_Try, /*On fail goto*//*Label 18532*/ GIMT_Encode4(1288634), // Rule ID 8834 //
     /* 1288555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288608 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288633 */     // GIR_Coverage, 8834,
     /* 1288633 */     GIR_EraseRootFromParent_Done,
     /* 1288634 */   // Label 18532: @1288634
     /* 1288634 */   GIM_Try, /*On fail goto*//*Label 18533*/ GIMT_Encode4(1288718), // Rule ID 8835 //
     /* 1288639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288692 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288717 */     // GIR_Coverage, 8835,
     /* 1288717 */     GIR_EraseRootFromParent_Done,
     /* 1288718 */   // Label 18533: @1288718
     /* 1288718 */   GIM_Try, /*On fail goto*//*Label 18534*/ GIMT_Encode4(1288802), // Rule ID 8838 //
     /* 1288723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1288740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288776 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288801 */     // GIR_Coverage, 8838,
     /* 1288801 */     GIR_EraseRootFromParent_Done,
     /* 1288802 */   // Label 18534: @1288802
     /* 1288802 */   GIM_Try, /*On fail goto*//*Label 18535*/ GIMT_Encode4(1288886), // Rule ID 8839 //
     /* 1288807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1288824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288860 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288885 */     // GIR_Coverage, 8839,
     /* 1288885 */     GIR_EraseRootFromParent_Done,
     /* 1288886 */   // Label 18535: @1288886
     /* 1288886 */   GIM_Try, /*On fail goto*//*Label 18536*/ GIMT_Encode4(1288970), // Rule ID 8842 //
     /* 1288891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1288908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288944 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288969 */     // GIR_Coverage, 8842,
     /* 1288969 */     GIR_EraseRootFromParent_Done,
     /* 1288970 */   // Label 18536: @1288970
     /* 1288970 */   GIM_Try, /*On fail goto*//*Label 18537*/ GIMT_Encode4(1289054), // Rule ID 8843 //
     /* 1288975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1288992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289028 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289053 */     // GIR_Coverage, 8843,
     /* 1289053 */     GIR_EraseRootFromParent_Done,
     /* 1289054 */   // Label 18537: @1289054
     /* 1289054 */   GIM_Try, /*On fail goto*//*Label 18538*/ GIMT_Encode4(1289138), // Rule ID 8846 //
     /* 1289059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1289076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289112 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1289115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289137 */     // GIR_Coverage, 8846,
     /* 1289137 */     GIR_EraseRootFromParent_Done,
     /* 1289138 */   // Label 18538: @1289138
     /* 1289138 */   GIM_Try, /*On fail goto*//*Label 18539*/ GIMT_Encode4(1289222), // Rule ID 8847 //
     /* 1289143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1289160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289196 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1289199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289221 */     // GIR_Coverage, 8847,
     /* 1289221 */     GIR_EraseRootFromParent_Done,
     /* 1289222 */   // Label 18539: @1289222
     /* 1289222 */   GIM_Try, /*On fail goto*//*Label 18540*/ GIMT_Encode4(1289306), // Rule ID 8850 //
     /* 1289227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1289244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289280 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1289283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289305 */     // GIR_Coverage, 8850,
     /* 1289305 */     GIR_EraseRootFromParent_Done,
     /* 1289306 */   // Label 18540: @1289306
     /* 1289306 */   GIM_Try, /*On fail goto*//*Label 18541*/ GIMT_Encode4(1289390), // Rule ID 8851 //
     /* 1289311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1289328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289364 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1289367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289389 */     // GIR_Coverage, 8851,
     /* 1289389 */     GIR_EraseRootFromParent_Done,
     /* 1289390 */   // Label 18541: @1289390
     /* 1289390 */   GIM_Try, /*On fail goto*//*Label 18542*/ GIMT_Encode4(1289474), // Rule ID 8854 //
     /* 1289395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1289412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289448 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289473 */     // GIR_Coverage, 8854,
     /* 1289473 */     GIR_EraseRootFromParent_Done,
     /* 1289474 */   // Label 18542: @1289474
     /* 1289474 */   GIM_Try, /*On fail goto*//*Label 18543*/ GIMT_Encode4(1289558), // Rule ID 8855 //
     /* 1289479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1289496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289532 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289557 */     // GIR_Coverage, 8855,
     /* 1289557 */     GIR_EraseRootFromParent_Done,
     /* 1289558 */   // Label 18543: @1289558
     /* 1289558 */   GIM_Try, /*On fail goto*//*Label 18544*/ GIMT_Encode4(1289642), // Rule ID 8858 //
     /* 1289563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289616 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1289619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289641 */     // GIR_Coverage, 8858,
     /* 1289641 */     GIR_EraseRootFromParent_Done,
     /* 1289642 */   // Label 18544: @1289642
     /* 1289642 */   GIM_Try, /*On fail goto*//*Label 18545*/ GIMT_Encode4(1289726), // Rule ID 8859 //
     /* 1289647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289700 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1289703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289725 */     // GIR_Coverage, 8859,
     /* 1289725 */     GIR_EraseRootFromParent_Done,
     /* 1289726 */   // Label 18545: @1289726
     /* 1289726 */   GIM_Try, /*On fail goto*//*Label 18546*/ GIMT_Encode4(1289810), // Rule ID 8862 //
     /* 1289731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1289748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289784 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1289787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289809 */     // GIR_Coverage, 8862,
     /* 1289809 */     GIR_EraseRootFromParent_Done,
     /* 1289810 */   // Label 18546: @1289810
     /* 1289810 */   GIM_Try, /*On fail goto*//*Label 18547*/ GIMT_Encode4(1289894), // Rule ID 8863 //
     /* 1289815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1289832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289868 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1289871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289893 */     // GIR_Coverage, 8863,
     /* 1289893 */     GIR_EraseRootFromParent_Done,
     /* 1289894 */   // Label 18547: @1289894
     /* 1289894 */   GIM_Try, /*On fail goto*//*Label 18548*/ GIMT_Encode4(1289978), // Rule ID 8866 //
     /* 1289899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1289916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289952 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289977 */     // GIR_Coverage, 8866,
     /* 1289977 */     GIR_EraseRootFromParent_Done,
     /* 1289978 */   // Label 18548: @1289978
     /* 1289978 */   GIM_Try, /*On fail goto*//*Label 18549*/ GIMT_Encode4(1290062), // Rule ID 8867 //
     /* 1289983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1290000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1290003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290036 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1290039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290061 */     // GIR_Coverage, 8867,
     /* 1290061 */     GIR_EraseRootFromParent_Done,
     /* 1290062 */   // Label 18549: @1290062
     /* 1290062 */   GIM_Try, /*On fail goto*//*Label 18550*/ GIMT_Encode4(1290146), // Rule ID 8958 //
     /* 1290067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1290084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1290087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290120 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1290123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290145 */     // GIR_Coverage, 8958,
     /* 1290145 */     GIR_EraseRootFromParent_Done,
     /* 1290146 */   // Label 18550: @1290146
     /* 1290146 */   GIM_Try, /*On fail goto*//*Label 18551*/ GIMT_Encode4(1290230), // Rule ID 8959 //
     /* 1290151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1290168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1290171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290204 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1290207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290229 */     // GIR_Coverage, 8959,
     /* 1290229 */     GIR_EraseRootFromParent_Done,
     /* 1290230 */   // Label 18551: @1290230
     /* 1290230 */   GIM_Try, /*On fail goto*//*Label 18552*/ GIMT_Encode4(1290314), // Rule ID 8962 //
     /* 1290235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1290252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1290255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290288 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1290291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290313 */     // GIR_Coverage, 8962,
     /* 1290313 */     GIR_EraseRootFromParent_Done,
     /* 1290314 */   // Label 18552: @1290314
     /* 1290314 */   GIM_Try, /*On fail goto*//*Label 18553*/ GIMT_Encode4(1290398), // Rule ID 8963 //
     /* 1290319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1290336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1290339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290372 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1290375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290397 */     // GIR_Coverage, 8963,
     /* 1290397 */     GIR_EraseRootFromParent_Done,
     /* 1290398 */   // Label 18553: @1290398
     /* 1290398 */   GIM_Try, /*On fail goto*//*Label 18554*/ GIMT_Encode4(1290482), // Rule ID 8966 //
     /* 1290403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1290420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1290423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290456 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290481 */     // GIR_Coverage, 8966,
     /* 1290481 */     GIR_EraseRootFromParent_Done,
     /* 1290482 */   // Label 18554: @1290482
     /* 1290482 */   GIM_Try, /*On fail goto*//*Label 18555*/ GIMT_Encode4(1290566), // Rule ID 8967 //
     /* 1290487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1290504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1290507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290540 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290565 */     // GIR_Coverage, 8967,
     /* 1290565 */     GIR_EraseRootFromParent_Done,
     /* 1290566 */   // Label 18555: @1290566
     /* 1290566 */   GIM_Try, /*On fail goto*//*Label 18556*/ GIMT_Encode4(1290650), // Rule ID 8970 //
     /* 1290571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1290591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290624 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1290627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290649 */     // GIR_Coverage, 8970,
     /* 1290649 */     GIR_EraseRootFromParent_Done,
     /* 1290650 */   // Label 18556: @1290650
     /* 1290650 */   GIM_Try, /*On fail goto*//*Label 18557*/ GIMT_Encode4(1290734), // Rule ID 8971 //
     /* 1290655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1290675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1290711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290733 */     // GIR_Coverage, 8971,
     /* 1290733 */     GIR_EraseRootFromParent_Done,
     /* 1290734 */   // Label 18557: @1290734
     /* 1290734 */   GIM_Try, /*On fail goto*//*Label 18558*/ GIMT_Encode4(1290818), // Rule ID 8974 //
     /* 1290739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1290756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1290759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290792 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290817 */     // GIR_Coverage, 8974,
     /* 1290817 */     GIR_EraseRootFromParent_Done,
     /* 1290818 */   // Label 18558: @1290818
     /* 1290818 */   GIM_Try, /*On fail goto*//*Label 18559*/ GIMT_Encode4(1290902), // Rule ID 8975 //
     /* 1290823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1290840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1290843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290876 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290901 */     // GIR_Coverage, 8975,
     /* 1290901 */     GIR_EraseRootFromParent_Done,
     /* 1290902 */   // Label 18559: @1290902
     /* 1290902 */   GIM_Try, /*On fail goto*//*Label 18560*/ GIMT_Encode4(1290986), // Rule ID 8978 //
     /* 1290907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1290924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1290927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290960 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290985 */     // GIR_Coverage, 8978,
     /* 1290985 */     GIR_EraseRootFromParent_Done,
     /* 1290986 */   // Label 18560: @1290986
     /* 1290986 */   GIM_Try, /*On fail goto*//*Label 18561*/ GIMT_Encode4(1291070), // Rule ID 8979 //
     /* 1290991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1291008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1291011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291044 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1291047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291069 */     // GIR_Coverage, 8979,
     /* 1291069 */     GIR_EraseRootFromParent_Done,
     /* 1291070 */   // Label 18561: @1291070
     /* 1291070 */   GIM_Try, /*On fail goto*//*Label 18562*/ GIMT_Encode4(1291154), // Rule ID 8982 //
     /* 1291075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1291086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1291089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1291092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1291095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291128 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291153 */     // GIR_Coverage, 8982,
     /* 1291153 */     GIR_EraseRootFromParent_Done,
     /* 1291154 */   // Label 18562: @1291154
     /* 1291154 */   GIM_Try, /*On fail goto*//*Label 18563*/ GIMT_Encode4(1291238), // Rule ID 8983 //
     /* 1291159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1291170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1291173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1291176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1291179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291212 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291237 */     // GIR_Coverage, 8983,
     /* 1291237 */     GIR_EraseRootFromParent_Done,
     /* 1291238 */   // Label 18563: @1291238
     /* 1291238 */   GIM_Try, /*On fail goto*//*Label 18564*/ GIMT_Encode4(1291322), // Rule ID 8986 //
     /* 1291243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1291254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1291257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1291260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1291263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1291266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291296 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291321 */     // GIR_Coverage, 8986,
     /* 1291321 */     GIR_EraseRootFromParent_Done,
     /* 1291322 */   // Label 18564: @1291322
     /* 1291322 */   GIM_Try, /*On fail goto*//*Label 18565*/ GIMT_Encode4(1291406), // Rule ID 8987 //
     /* 1291327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1291338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1291341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1291344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1291347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1291350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291380 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291405 */     // GIR_Coverage, 8987,
     /* 1291405 */     GIR_EraseRootFromParent_Done,
     /* 1291406 */   // Label 18565: @1291406
     /* 1291406 */   GIM_Try, /*On fail goto*//*Label 18566*/ GIMT_Encode4(1291490), // Rule ID 8990 //
     /* 1291411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1291428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1291431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291464 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291489 */     // GIR_Coverage, 8990,
     /* 1291489 */     GIR_EraseRootFromParent_Done,
     /* 1291490 */   // Label 18566: @1291490
     /* 1291490 */   GIM_Try, /*On fail goto*//*Label 18567*/ GIMT_Encode4(1291574), // Rule ID 8991 //
     /* 1291495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1291512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1291515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291548 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291573 */     // GIR_Coverage, 8991,
     /* 1291573 */     GIR_EraseRootFromParent_Done,
     /* 1291574 */   // Label 18567: @1291574
     /* 1291574 */   GIM_Try, /*On fail goto*//*Label 18568*/ GIMT_Encode4(1291658), // Rule ID 8994 //
     /* 1291579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1291582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1291596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1291599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291632 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1291653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291657 */     // GIR_Coverage, 8994,
     /* 1291657 */     GIR_EraseRootFromParent_Done,
     /* 1291658 */   // Label 18568: @1291658
     /* 1291658 */   GIM_Try, /*On fail goto*//*Label 18569*/ GIMT_Encode4(1291742), // Rule ID 8995 //
     /* 1291663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1291666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1291680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1291683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291716 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1291737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291741 */     // GIR_Coverage, 8995,
     /* 1291741 */     GIR_EraseRootFromParent_Done,
     /* 1291742 */   // Label 18569: @1291742
     /* 1291742 */   GIM_Try, /*On fail goto*//*Label 18570*/ GIMT_Encode4(1291826), // Rule ID 8998 //
     /* 1291747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1291758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1291761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1291764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1291767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291800 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1291803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291825 */     // GIR_Coverage, 8998,
     /* 1291825 */     GIR_EraseRootFromParent_Done,
     /* 1291826 */   // Label 18570: @1291826
     /* 1291826 */   GIM_Try, /*On fail goto*//*Label 18571*/ GIMT_Encode4(1291910), // Rule ID 8999 //
     /* 1291831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1291842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1291845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1291848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1291851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291884 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1291887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291909 */     // GIR_Coverage, 8999,
     /* 1291909 */     GIR_EraseRootFromParent_Done,
     /* 1291910 */   // Label 18571: @1291910
     /* 1291910 */   GIM_Try, /*On fail goto*//*Label 18572*/ GIMT_Encode4(1291994), // Rule ID 9002 //
     /* 1291915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1291926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1291929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1291932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1291935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1291938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291968 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1291971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291993 */     // GIR_Coverage, 9002,
     /* 1291993 */     GIR_EraseRootFromParent_Done,
     /* 1291994 */   // Label 18572: @1291994
     /* 1291994 */   GIM_Try, /*On fail goto*//*Label 18573*/ GIMT_Encode4(1292078), // Rule ID 9003 //
     /* 1291999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1292016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1292019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292052 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292077 */     // GIR_Coverage, 9003,
     /* 1292077 */     GIR_EraseRootFromParent_Done,
     /* 1292078 */   // Label 18573: @1292078
     /* 1292078 */   GIM_Try, /*On fail goto*//*Label 18574*/ GIMT_Encode4(1292162), // Rule ID 9006 //
     /* 1292083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1292094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1292097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1292100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1292103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1292106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292136 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292161 */     // GIR_Coverage, 9006,
     /* 1292161 */     GIR_EraseRootFromParent_Done,
     /* 1292162 */   // Label 18574: @1292162
     /* 1292162 */   GIM_Try, /*On fail goto*//*Label 18575*/ GIMT_Encode4(1292246), // Rule ID 9007 //
     /* 1292167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1292178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1292181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1292184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1292187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1292190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292220 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292245 */     // GIR_Coverage, 9007,
     /* 1292245 */     GIR_EraseRootFromParent_Done,
     /* 1292246 */   // Label 18575: @1292246
     /* 1292246 */   GIM_Try, /*On fail goto*//*Label 18576*/ GIMT_Encode4(1292330), // Rule ID 9010 //
     /* 1292251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1292268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1292271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292304 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292329 */     // GIR_Coverage, 9010,
     /* 1292329 */     GIR_EraseRootFromParent_Done,
     /* 1292330 */   // Label 18576: @1292330
     /* 1292330 */   GIM_Try, /*On fail goto*//*Label 18577*/ GIMT_Encode4(1292414), // Rule ID 9011 //
     /* 1292335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1292352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1292355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292388 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292413 */     // GIR_Coverage, 9011,
     /* 1292413 */     GIR_EraseRootFromParent_Done,
     /* 1292414 */   // Label 18577: @1292414
     /* 1292414 */   GIM_Try, /*On fail goto*//*Label 18578*/ GIMT_Encode4(1292498), // Rule ID 9014 //
     /* 1292419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1292436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1292439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292472 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292497 */     // GIR_Coverage, 9014,
     /* 1292497 */     GIR_EraseRootFromParent_Done,
     /* 1292498 */   // Label 18578: @1292498
     /* 1292498 */   GIM_Try, /*On fail goto*//*Label 18579*/ GIMT_Encode4(1292582), // Rule ID 9015 //
     /* 1292503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1292520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1292523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292556 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292581 */     // GIR_Coverage, 9015,
     /* 1292581 */     GIR_EraseRootFromParent_Done,
     /* 1292582 */   // Label 18579: @1292582
     /* 1292582 */   GIM_Try, /*On fail goto*//*Label 18580*/ GIMT_Encode4(1292666), // Rule ID 9018 //
     /* 1292587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1292607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292640 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292665 */     // GIR_Coverage, 9018,
     /* 1292665 */     GIR_EraseRootFromParent_Done,
     /* 1292666 */   // Label 18580: @1292666
     /* 1292666 */   GIM_Try, /*On fail goto*//*Label 18581*/ GIMT_Encode4(1292750), // Rule ID 9019 //
     /* 1292671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1292691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292724 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292749 */     // GIR_Coverage, 9019,
     /* 1292749 */     GIR_EraseRootFromParent_Done,
     /* 1292750 */   // Label 18581: @1292750
     /* 1292750 */   GIM_Try, /*On fail goto*//*Label 18582*/ GIMT_Encode4(1292834), // Rule ID 9022 //
     /* 1292755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1292772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1292775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292808 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292833 */     // GIR_Coverage, 9022,
     /* 1292833 */     GIR_EraseRootFromParent_Done,
     /* 1292834 */   // Label 18582: @1292834
     /* 1292834 */   GIM_Try, /*On fail goto*//*Label 18583*/ GIMT_Encode4(1292918), // Rule ID 9023 //
     /* 1292839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1292856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1292859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292892 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292917 */     // GIR_Coverage, 9023,
     /* 1292917 */     GIR_EraseRootFromParent_Done,
     /* 1292918 */   // Label 18583: @1292918
     /* 1292918 */   GIM_Try, /*On fail goto*//*Label 18584*/ GIMT_Encode4(1293002), // Rule ID 9026 //
     /* 1292923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1292940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1292943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292976 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293001 */     // GIR_Coverage, 9026,
     /* 1293001 */     GIR_EraseRootFromParent_Done,
     /* 1293002 */   // Label 18584: @1293002
     /* 1293002 */   GIM_Try, /*On fail goto*//*Label 18585*/ GIMT_Encode4(1293086), // Rule ID 9027 //
     /* 1293007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1293024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1293027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293060 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1293063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293085 */     // GIR_Coverage, 9027,
     /* 1293085 */     GIR_EraseRootFromParent_Done,
     /* 1293086 */   // Label 18585: @1293086
     /* 1293086 */   GIM_Try, /*On fail goto*//*Label 18586*/ GIMT_Encode4(1293170), // Rule ID 9030 //
     /* 1293091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1293102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1293105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1293108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1293111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1293114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293144 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1293147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293169 */     // GIR_Coverage, 9030,
     /* 1293169 */     GIR_EraseRootFromParent_Done,
     /* 1293170 */   // Label 18586: @1293170
     /* 1293170 */   GIM_Try, /*On fail goto*//*Label 18587*/ GIMT_Encode4(1293254), // Rule ID 9031 //
     /* 1293175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1293186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1293189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1293192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1293195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1293198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293228 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1293231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293253 */     // GIR_Coverage, 9031,
     /* 1293253 */     GIR_EraseRootFromParent_Done,
     /* 1293254 */   // Label 18587: @1293254
     /* 1293254 */   GIM_Try, /*On fail goto*//*Label 18588*/ GIMT_Encode4(1293338), // Rule ID 9034 //
     /* 1293259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1293276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1293279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293312 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1293315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293337 */     // GIR_Coverage, 9034,
     /* 1293337 */     GIR_EraseRootFromParent_Done,
     /* 1293338 */   // Label 18588: @1293338
     /* 1293338 */   GIM_Try, /*On fail goto*//*Label 18589*/ GIMT_Encode4(1293422), // Rule ID 9035 //
     /* 1293343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1293360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1293363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293396 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1293399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293421 */     // GIR_Coverage, 9035,
     /* 1293421 */     GIR_EraseRootFromParent_Done,
     /* 1293422 */   // Label 18589: @1293422
     /* 1293422 */   GIM_Try, /*On fail goto*//*Label 18590*/ GIMT_Encode4(1293506), // Rule ID 9038 //
     /* 1293427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1293444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1293447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293480 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1293483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293505 */     // GIR_Coverage, 9038,
     /* 1293505 */     GIR_EraseRootFromParent_Done,
     /* 1293506 */   // Label 18590: @1293506
     /* 1293506 */   GIM_Try, /*On fail goto*//*Label 18591*/ GIMT_Encode4(1293590), // Rule ID 9039 //
     /* 1293511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1293528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1293531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293564 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1293567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293589 */     // GIR_Coverage, 9039,
     /* 1293589 */     GIR_EraseRootFromParent_Done,
     /* 1293590 */   // Label 18591: @1293590
     /* 1293590 */   GIM_Try, /*On fail goto*//*Label 18592*/ GIMT_Encode4(1293674), // Rule ID 9042 //
     /* 1293595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1293612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1293615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293648 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1293651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293673 */     // GIR_Coverage, 9042,
     /* 1293673 */     GIR_EraseRootFromParent_Done,
     /* 1293674 */   // Label 18592: @1293674
     /* 1293674 */   GIM_Try, /*On fail goto*//*Label 18593*/ GIMT_Encode4(1293758), // Rule ID 9043 //
     /* 1293679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1293696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1293699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293732 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1293735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293757 */     // GIR_Coverage, 9043,
     /* 1293757 */     GIR_EraseRootFromParent_Done,
     /* 1293758 */   // Label 18593: @1293758
     /* 1293758 */   GIM_Try, /*On fail goto*//*Label 18594*/ GIMT_Encode4(1293842), // Rule ID 9046 //
     /* 1293763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1293780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293816 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1293819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293841 */     // GIR_Coverage, 9046,
     /* 1293841 */     GIR_EraseRootFromParent_Done,
     /* 1293842 */   // Label 18594: @1293842
     /* 1293842 */   GIM_Try, /*On fail goto*//*Label 18595*/ GIMT_Encode4(1293926), // Rule ID 9047 //
     /* 1293847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1293864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293900 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1293903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293925 */     // GIR_Coverage, 9047,
     /* 1293925 */     GIR_EraseRootFromParent_Done,
     /* 1293926 */   // Label 18595: @1293926
     /* 1293926 */   GIM_Try, /*On fail goto*//*Label 18596*/ GIMT_Encode4(1294010), // Rule ID 9050 //
     /* 1293931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1293948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293984 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1293987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294009 */     // GIR_Coverage, 9050,
     /* 1294009 */     GIR_EraseRootFromParent_Done,
     /* 1294010 */   // Label 18596: @1294010
     /* 1294010 */   GIM_Try, /*On fail goto*//*Label 18597*/ GIMT_Encode4(1294094), // Rule ID 9051 //
     /* 1294015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1294032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1294071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294093 */     // GIR_Coverage, 9051,
     /* 1294093 */     GIR_EraseRootFromParent_Done,
     /* 1294094 */   // Label 18597: @1294094
     /* 1294094 */   GIM_Try, /*On fail goto*//*Label 18598*/ GIMT_Encode4(1294178), // Rule ID 9054 //
     /* 1294099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1294116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294152 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294177 */     // GIR_Coverage, 9054,
     /* 1294177 */     GIR_EraseRootFromParent_Done,
     /* 1294178 */   // Label 18598: @1294178
     /* 1294178 */   GIM_Try, /*On fail goto*//*Label 18599*/ GIMT_Encode4(1294262), // Rule ID 9055 //
     /* 1294183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1294200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294236 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294261 */     // GIR_Coverage, 9055,
     /* 1294261 */     GIR_EraseRootFromParent_Done,
     /* 1294262 */   // Label 18599: @1294262
     /* 1294262 */   GIM_Try, /*On fail goto*//*Label 18600*/ GIMT_Encode4(1294346), // Rule ID 9058 //
     /* 1294267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1294284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294320 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1294323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294345 */     // GIR_Coverage, 9058,
     /* 1294345 */     GIR_EraseRootFromParent_Done,
     /* 1294346 */   // Label 18600: @1294346
     /* 1294346 */   GIM_Try, /*On fail goto*//*Label 18601*/ GIMT_Encode4(1294430), // Rule ID 9059 //
     /* 1294351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1294368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294404 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1294407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294429 */     // GIR_Coverage, 9059,
     /* 1294429 */     GIR_EraseRootFromParent_Done,
     /* 1294430 */   // Label 18601: @1294430
     /* 1294430 */   GIM_Try, /*On fail goto*//*Label 18602*/ GIMT_Encode4(1294514), // Rule ID 9062 //
     /* 1294435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1294452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294488 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294513 */     // GIR_Coverage, 9062,
     /* 1294513 */     GIR_EraseRootFromParent_Done,
     /* 1294514 */   // Label 18602: @1294514
     /* 1294514 */   GIM_Try, /*On fail goto*//*Label 18603*/ GIMT_Encode4(1294598), // Rule ID 9063 //
     /* 1294519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1294536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294572 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294597 */     // GIR_Coverage, 9063,
     /* 1294597 */     GIR_EraseRootFromParent_Done,
     /* 1294598 */   // Label 18603: @1294598
     /* 1294598 */   GIM_Try, /*On fail goto*//*Label 18604*/ GIMT_Encode4(1294682), // Rule ID 9066 //
     /* 1294603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294656 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294681 */     // GIR_Coverage, 9066,
     /* 1294681 */     GIR_EraseRootFromParent_Done,
     /* 1294682 */   // Label 18604: @1294682
     /* 1294682 */   GIM_Try, /*On fail goto*//*Label 18605*/ GIMT_Encode4(1294766), // Rule ID 9067 //
     /* 1294687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294740 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294765 */     // GIR_Coverage, 9067,
     /* 1294765 */     GIR_EraseRootFromParent_Done,
     /* 1294766 */   // Label 18605: @1294766
     /* 1294766 */   GIM_Try, /*On fail goto*//*Label 18606*/ GIMT_Encode4(1294850), // Rule ID 9070 //
     /* 1294771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1294788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294849 */     // GIR_Coverage, 9070,
     /* 1294849 */     GIR_EraseRootFromParent_Done,
     /* 1294850 */   // Label 18606: @1294850
     /* 1294850 */   GIM_Try, /*On fail goto*//*Label 18607*/ GIMT_Encode4(1294934), // Rule ID 9071 //
     /* 1294855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1294872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294908 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294933 */     // GIR_Coverage, 9071,
     /* 1294933 */     GIR_EraseRootFromParent_Done,
     /* 1294934 */   // Label 18607: @1294934
     /* 1294934 */   GIM_Try, /*On fail goto*//*Label 18608*/ GIMT_Encode4(1295018), // Rule ID 9074 //
     /* 1294939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1294956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294992 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295017 */     // GIR_Coverage, 9074,
     /* 1295017 */     GIR_EraseRootFromParent_Done,
     /* 1295018 */   // Label 18608: @1295018
     /* 1295018 */   GIM_Try, /*On fail goto*//*Label 18609*/ GIMT_Encode4(1295102), // Rule ID 9075 //
     /* 1295023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1295034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1295037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1295040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1295046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1295079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295101 */     // GIR_Coverage, 9075,
     /* 1295101 */     GIR_EraseRootFromParent_Done,
     /* 1295102 */   // Label 18609: @1295102
     /* 1295102 */   GIM_Try, /*On fail goto*//*Label 18610*/ GIMT_Encode4(1295186), // Rule ID 9078 //
     /* 1295107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1295118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1295121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1295124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1295130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295160 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1295163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295185 */     // GIR_Coverage, 9078,
     /* 1295185 */     GIR_EraseRootFromParent_Done,
     /* 1295186 */   // Label 18610: @1295186
     /* 1295186 */   GIM_Try, /*On fail goto*//*Label 18611*/ GIMT_Encode4(1295270), // Rule ID 9079 //
     /* 1295191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1295202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1295205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1295208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1295214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295244 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1295247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295269 */     // GIR_Coverage, 9079,
     /* 1295269 */     GIR_EraseRootFromParent_Done,
     /* 1295270 */   // Label 18611: @1295270
     /* 1295270 */   GIM_Try, /*On fail goto*//*Label 18612*/ GIMT_Encode4(1295354), // Rule ID 9082 //
     /* 1295275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1295278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1295286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1295289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1295292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1295298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295328 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1295331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1295349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295353 */     // GIR_Coverage, 9082,
     /* 1295353 */     GIR_EraseRootFromParent_Done,
     /* 1295354 */   // Label 18612: @1295354
     /* 1295354 */   GIM_Try, /*On fail goto*//*Label 18613*/ GIMT_Encode4(1295438), // Rule ID 9083 //
     /* 1295359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1295362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1295370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1295373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1295376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1295382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295412 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1295415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1295433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295437 */     // GIR_Coverage, 9083,
     /* 1295437 */     GIR_EraseRootFromParent_Done,
     /* 1295438 */   // Label 18613: @1295438
     /* 1295438 */   GIM_Try, /*On fail goto*//*Label 18614*/ GIMT_Encode4(1295522), // Rule ID 9086 //
     /* 1295443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1295460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295496 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295521 */     // GIR_Coverage, 9086,
     /* 1295521 */     GIR_EraseRootFromParent_Done,
     /* 1295522 */   // Label 18614: @1295522
     /* 1295522 */   GIM_Try, /*On fail goto*//*Label 18615*/ GIMT_Encode4(1295606), // Rule ID 9087 //
     /* 1295527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1295544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295580 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295605 */     // GIR_Coverage, 9087,
     /* 1295605 */     GIR_EraseRootFromParent_Done,
     /* 1295606 */   // Label 18615: @1295606
     /* 1295606 */   GIM_Try, /*On fail goto*//*Label 18616*/ GIMT_Encode4(1295690), // Rule ID 9090 //
     /* 1295611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1295628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295664 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1295667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295689 */     // GIR_Coverage, 9090,
     /* 1295689 */     GIR_EraseRootFromParent_Done,
     /* 1295690 */   // Label 18616: @1295690
     /* 1295690 */   GIM_Try, /*On fail goto*//*Label 18617*/ GIMT_Encode4(1295774), // Rule ID 9091 //
     /* 1295695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1295712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295748 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1295751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295773 */     // GIR_Coverage, 9091,
     /* 1295773 */     GIR_EraseRootFromParent_Done,
     /* 1295774 */   // Label 18617: @1295774
     /* 1295774 */   GIM_Try, /*On fail goto*//*Label 18618*/ GIMT_Encode4(1295858), // Rule ID 9094 //
     /* 1295779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1295790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1295793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1295796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1295802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295832 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1295835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295857 */     // GIR_Coverage, 9094,
     /* 1295857 */     GIR_EraseRootFromParent_Done,
     /* 1295858 */   // Label 18618: @1295858
     /* 1295858 */   GIM_Try, /*On fail goto*//*Label 18619*/ GIMT_Encode4(1295942), // Rule ID 9095 //
     /* 1295863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1295874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1295877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1295880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1295886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295916 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1295919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295941 */     // GIR_Coverage, 9095,
     /* 1295941 */     GIR_EraseRootFromParent_Done,
     /* 1295942 */   // Label 18619: @1295942
     /* 1295942 */   GIM_Try, /*On fail goto*//*Label 18620*/ GIMT_Encode4(1296026), // Rule ID 9098 //
     /* 1295947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1295958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1295961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1295964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296000 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296025 */     // GIR_Coverage, 9098,
     /* 1296025 */     GIR_EraseRootFromParent_Done,
     /* 1296026 */   // Label 18620: @1296026
     /* 1296026 */   GIM_Try, /*On fail goto*//*Label 18621*/ GIMT_Encode4(1296110), // Rule ID 9099 //
     /* 1296031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1296048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296084 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296109 */     // GIR_Coverage, 9099,
     /* 1296109 */     GIR_EraseRootFromParent_Done,
     /* 1296110 */   // Label 18621: @1296110
     /* 1296110 */   GIM_Try, /*On fail goto*//*Label 18622*/ GIMT_Encode4(1296194), // Rule ID 9102 //
     /* 1296115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1296132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296168 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296193 */     // GIR_Coverage, 9102,
     /* 1296193 */     GIR_EraseRootFromParent_Done,
     /* 1296194 */   // Label 18622: @1296194
     /* 1296194 */   GIM_Try, /*On fail goto*//*Label 18623*/ GIMT_Encode4(1296278), // Rule ID 9103 //
     /* 1296199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1296216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296252 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296277 */     // GIR_Coverage, 9103,
     /* 1296277 */     GIR_EraseRootFromParent_Done,
     /* 1296278 */   // Label 18623: @1296278
     /* 1296278 */   GIM_Try, /*On fail goto*//*Label 18624*/ GIMT_Encode4(1296362), // Rule ID 9106 //
     /* 1296283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1296294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1296297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1296300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1296306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296336 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296361 */     // GIR_Coverage, 9106,
     /* 1296361 */     GIR_EraseRootFromParent_Done,
     /* 1296362 */   // Label 18624: @1296362
     /* 1296362 */   GIM_Try, /*On fail goto*//*Label 18625*/ GIMT_Encode4(1296446), // Rule ID 9107 //
     /* 1296367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1296378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1296381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1296384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1296390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296420 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296445 */     // GIR_Coverage, 9107,
     /* 1296445 */     GIR_EraseRootFromParent_Done,
     /* 1296446 */   // Label 18625: @1296446
     /* 1296446 */   GIM_Try, /*On fail goto*//*Label 18626*/ GIMT_Encode4(1296530), // Rule ID 9110 //
     /* 1296451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1296468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296504 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296529 */     // GIR_Coverage, 9110,
     /* 1296529 */     GIR_EraseRootFromParent_Done,
     /* 1296530 */   // Label 18626: @1296530
     /* 1296530 */   GIM_Try, /*On fail goto*//*Label 18627*/ GIMT_Encode4(1296614), // Rule ID 9111 //
     /* 1296535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1296552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296588 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296613 */     // GIR_Coverage, 9111,
     /* 1296613 */     GIR_EraseRootFromParent_Done,
     /* 1296614 */   // Label 18627: @1296614
     /* 1296614 */   GIM_Try, /*On fail goto*//*Label 18628*/ GIMT_Encode4(1296698), // Rule ID 9114 //
     /* 1296619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1296636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296697 */     // GIR_Coverage, 9114,
     /* 1296697 */     GIR_EraseRootFromParent_Done,
     /* 1296698 */   // Label 18628: @1296698
     /* 1296698 */   GIM_Try, /*On fail goto*//*Label 18629*/ GIMT_Encode4(1296782), // Rule ID 9115 //
     /* 1296703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1296720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296756 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296781 */     // GIR_Coverage, 9115,
     /* 1296781 */     GIR_EraseRootFromParent_Done,
     /* 1296782 */   // Label 18629: @1296782
     /* 1296782 */   GIM_Try, /*On fail goto*//*Label 18630*/ GIMT_Encode4(1296866), // Rule ID 9118 //
     /* 1296787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1296804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296840 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296865 */     // GIR_Coverage, 9118,
     /* 1296865 */     GIR_EraseRootFromParent_Done,
     /* 1296866 */   // Label 18630: @1296866
     /* 1296866 */   GIM_Try, /*On fail goto*//*Label 18631*/ GIMT_Encode4(1296950), // Rule ID 9119 //
     /* 1296871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1296888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296924 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296949 */     // GIR_Coverage, 9119,
     /* 1296949 */     GIR_EraseRootFromParent_Done,
     /* 1296950 */   // Label 18631: @1296950
     /* 1296950 */   GIM_Try, /*On fail goto*//*Label 18632*/ GIMT_Encode4(1297034), // Rule ID 9122 //
     /* 1296955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1296958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1296966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1296969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1296972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297008 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1297011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297033 */     // GIR_Coverage, 9122,
     /* 1297033 */     GIR_EraseRootFromParent_Done,
     /* 1297034 */   // Label 18632: @1297034
     /* 1297034 */   GIM_Try, /*On fail goto*//*Label 18633*/ GIMT_Encode4(1297118), // Rule ID 9123 //
     /* 1297039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1297042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1297056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1297077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297092 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1297095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297117 */     // GIR_Coverage, 9123,
     /* 1297117 */     GIR_EraseRootFromParent_Done,
     /* 1297118 */   // Label 18633: @1297118
     /* 1297118 */   GIM_Try, /*On fail goto*//*Label 18634*/ GIMT_Encode4(1297202), // Rule ID 9126 //
     /* 1297123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1297126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1297140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1297179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297201 */     // GIR_Coverage, 9126,
     /* 1297201 */     GIR_EraseRootFromParent_Done,
     /* 1297202 */   // Label 18634: @1297202
     /* 1297202 */   GIM_Try, /*On fail goto*//*Label 18635*/ GIMT_Encode4(1297286), // Rule ID 9127 //
     /* 1297207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1297210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1297224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297260 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1297263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297285 */     // GIR_Coverage, 9127,
     /* 1297285 */     GIR_EraseRootFromParent_Done,
     /* 1297286 */   // Label 18635: @1297286
     /* 1297286 */   GIM_Try, /*On fail goto*//*Label 18636*/ GIMT_Encode4(1297370), // Rule ID 9130 //
     /* 1297291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1297294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1297302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1297305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1297308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297344 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1297347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297369 */     // GIR_Coverage, 9130,
     /* 1297369 */     GIR_EraseRootFromParent_Done,
     /* 1297370 */   // Label 18636: @1297370
     /* 1297370 */   GIM_Try, /*On fail goto*//*Label 18637*/ GIMT_Encode4(1297454), // Rule ID 9131 //
     /* 1297375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1297378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1297386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1297389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1297392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297428 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1297431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297453 */     // GIR_Coverage, 9131,
     /* 1297453 */     GIR_EraseRootFromParent_Done,
     /* 1297454 */   // Label 18637: @1297454
     /* 1297454 */   GIM_Try, /*On fail goto*//*Label 18638*/ GIMT_Encode4(1297538), // Rule ID 9222 //
     /* 1297459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1297476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297512 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1297515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297537 */     // GIR_Coverage, 9222,
     /* 1297537 */     GIR_EraseRootFromParent_Done,
     /* 1297538 */   // Label 18638: @1297538
     /* 1297538 */   GIM_Try, /*On fail goto*//*Label 18639*/ GIMT_Encode4(1297622), // Rule ID 9223 //
     /* 1297543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1297560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297596 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1297599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297621 */     // GIR_Coverage, 9223,
     /* 1297621 */     GIR_EraseRootFromParent_Done,
     /* 1297622 */   // Label 18639: @1297622
     /* 1297622 */   GIM_Try, /*On fail goto*//*Label 18640*/ GIMT_Encode4(1297706), // Rule ID 9226 //
     /* 1297627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1297644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297680 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1297683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297705 */     // GIR_Coverage, 9226,
     /* 1297705 */     GIR_EraseRootFromParent_Done,
     /* 1297706 */   // Label 18640: @1297706
     /* 1297706 */   GIM_Try, /*On fail goto*//*Label 18641*/ GIMT_Encode4(1297790), // Rule ID 9227 //
     /* 1297711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1297728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297764 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1297767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297789 */     // GIR_Coverage, 9227,
     /* 1297789 */     GIR_EraseRootFromParent_Done,
     /* 1297790 */   // Label 18641: @1297790
     /* 1297790 */   GIM_Try, /*On fail goto*//*Label 18642*/ GIMT_Encode4(1297874), // Rule ID 9230 //
     /* 1297795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1297812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297848 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297873 */     // GIR_Coverage, 9230,
     /* 1297873 */     GIR_EraseRootFromParent_Done,
     /* 1297874 */   // Label 18642: @1297874
     /* 1297874 */   GIM_Try, /*On fail goto*//*Label 18643*/ GIMT_Encode4(1297958), // Rule ID 9231 //
     /* 1297879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1297896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297932 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297957 */     // GIR_Coverage, 9231,
     /* 1297957 */     GIR_EraseRootFromParent_Done,
     /* 1297958 */   // Label 18643: @1297958
     /* 1297958 */   GIM_Try, /*On fail goto*//*Label 18644*/ GIMT_Encode4(1298042), // Rule ID 9234 //
     /* 1297963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1297980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298016 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1298019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298041 */     // GIR_Coverage, 9234,
     /* 1298041 */     GIR_EraseRootFromParent_Done,
     /* 1298042 */   // Label 18644: @1298042
     /* 1298042 */   GIM_Try, /*On fail goto*//*Label 18645*/ GIMT_Encode4(1298126), // Rule ID 9235 //
     /* 1298047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1298064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298100 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1298103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298125 */     // GIR_Coverage, 9235,
     /* 1298125 */     GIR_EraseRootFromParent_Done,
     /* 1298126 */   // Label 18645: @1298126
     /* 1298126 */   GIM_Try, /*On fail goto*//*Label 18646*/ GIMT_Encode4(1298210), // Rule ID 9238 //
     /* 1298131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1298148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298184 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1298187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298209 */     // GIR_Coverage, 9238,
     /* 1298209 */     GIR_EraseRootFromParent_Done,
     /* 1298210 */   // Label 18646: @1298210
     /* 1298210 */   GIM_Try, /*On fail goto*//*Label 18647*/ GIMT_Encode4(1298294), // Rule ID 9239 //
     /* 1298215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1298232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298268 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1298271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298293 */     // GIR_Coverage, 9239,
     /* 1298293 */     GIR_EraseRootFromParent_Done,
     /* 1298294 */   // Label 18647: @1298294
     /* 1298294 */   GIM_Try, /*On fail goto*//*Label 18648*/ GIMT_Encode4(1298378), // Rule ID 9242 //
     /* 1298299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1298316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298352 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1298355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298377 */     // GIR_Coverage, 9242,
     /* 1298377 */     GIR_EraseRootFromParent_Done,
     /* 1298378 */   // Label 18648: @1298378
     /* 1298378 */   GIM_Try, /*On fail goto*//*Label 18649*/ GIMT_Encode4(1298462), // Rule ID 9243 //
     /* 1298383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1298400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298436 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1298439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298461 */     // GIR_Coverage, 9243,
     /* 1298461 */     GIR_EraseRootFromParent_Done,
     /* 1298462 */   // Label 18649: @1298462
     /* 1298462 */   GIM_Try, /*On fail goto*//*Label 18650*/ GIMT_Encode4(1298546), // Rule ID 9246 //
     /* 1298467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1298484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298520 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298545 */     // GIR_Coverage, 9246,
     /* 1298545 */     GIR_EraseRootFromParent_Done,
     /* 1298546 */   // Label 18650: @1298546
     /* 1298546 */   GIM_Try, /*On fail goto*//*Label 18651*/ GIMT_Encode4(1298630), // Rule ID 9247 //
     /* 1298551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1298568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298604 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298629 */     // GIR_Coverage, 9247,
     /* 1298629 */     GIR_EraseRootFromParent_Done,
     /* 1298630 */   // Label 18651: @1298630
     /* 1298630 */   GIM_Try, /*On fail goto*//*Label 18652*/ GIMT_Encode4(1298714), // Rule ID 9250 //
     /* 1298635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1298652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298688 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298713 */     // GIR_Coverage, 9250,
     /* 1298713 */     GIR_EraseRootFromParent_Done,
     /* 1298714 */   // Label 18652: @1298714
     /* 1298714 */   GIM_Try, /*On fail goto*//*Label 18653*/ GIMT_Encode4(1298798), // Rule ID 9251 //
     /* 1298719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1298736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298772 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298797 */     // GIR_Coverage, 9251,
     /* 1298797 */     GIR_EraseRootFromParent_Done,
     /* 1298798 */   // Label 18653: @1298798
     /* 1298798 */   GIM_Try, /*On fail goto*//*Label 18654*/ GIMT_Encode4(1298882), // Rule ID 9254 //
     /* 1298803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1298820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298856 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298881 */     // GIR_Coverage, 9254,
     /* 1298881 */     GIR_EraseRootFromParent_Done,
     /* 1298882 */   // Label 18654: @1298882
     /* 1298882 */   GIM_Try, /*On fail goto*//*Label 18655*/ GIMT_Encode4(1298966), // Rule ID 9255 //
     /* 1298887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1298904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298940 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298965 */     // GIR_Coverage, 9255,
     /* 1298965 */     GIR_EraseRootFromParent_Done,
     /* 1298966 */   // Label 18655: @1298966
     /* 1298966 */   GIM_Try, /*On fail goto*//*Label 18656*/ GIMT_Encode4(1299050), // Rule ID 9258 //
     /* 1298971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1298974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1298988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1299027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1299045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299049 */     // GIR_Coverage, 9258,
     /* 1299049 */     GIR_EraseRootFromParent_Done,
     /* 1299050 */   // Label 18656: @1299050
     /* 1299050 */   GIM_Try, /*On fail goto*//*Label 18657*/ GIMT_Encode4(1299134), // Rule ID 9259 //
     /* 1299055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1299058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1299066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1299069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1299072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1299078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299108 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1299111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1299129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299133 */     // GIR_Coverage, 9259,
     /* 1299133 */     GIR_EraseRootFromParent_Done,
     /* 1299134 */   // Label 18657: @1299134
     /* 1299134 */   GIM_Try, /*On fail goto*//*Label 18658*/ GIMT_Encode4(1299218), // Rule ID 9262 //
     /* 1299139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1299156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299192 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299217 */     // GIR_Coverage, 9262,
     /* 1299217 */     GIR_EraseRootFromParent_Done,
     /* 1299218 */   // Label 18658: @1299218
     /* 1299218 */   GIM_Try, /*On fail goto*//*Label 18659*/ GIMT_Encode4(1299302), // Rule ID 9263 //
     /* 1299223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1299240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299276 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299301 */     // GIR_Coverage, 9263,
     /* 1299301 */     GIR_EraseRootFromParent_Done,
     /* 1299302 */   // Label 18659: @1299302
     /* 1299302 */   GIM_Try, /*On fail goto*//*Label 18660*/ GIMT_Encode4(1299386), // Rule ID 9266 //
     /* 1299307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1299324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299360 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299385 */     // GIR_Coverage, 9266,
     /* 1299385 */     GIR_EraseRootFromParent_Done,
     /* 1299386 */   // Label 18660: @1299386
     /* 1299386 */   GIM_Try, /*On fail goto*//*Label 18661*/ GIMT_Encode4(1299470), // Rule ID 9267 //
     /* 1299391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1299408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299444 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299469 */     // GIR_Coverage, 9267,
     /* 1299469 */     GIR_EraseRootFromParent_Done,
     /* 1299470 */   // Label 18661: @1299470
     /* 1299470 */   GIM_Try, /*On fail goto*//*Label 18662*/ GIMT_Encode4(1299554), // Rule ID 9270 //
     /* 1299475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1299486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1299489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1299492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1299498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299528 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1299531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299553 */     // GIR_Coverage, 9270,
     /* 1299553 */     GIR_EraseRootFromParent_Done,
     /* 1299554 */   // Label 18662: @1299554
     /* 1299554 */   GIM_Try, /*On fail goto*//*Label 18663*/ GIMT_Encode4(1299638), // Rule ID 9271 //
     /* 1299559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1299570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1299573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1299576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1299582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299612 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1299615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299637 */     // GIR_Coverage, 9271,
     /* 1299637 */     GIR_EraseRootFromParent_Done,
     /* 1299638 */   // Label 18663: @1299638
     /* 1299638 */   GIM_Try, /*On fail goto*//*Label 18664*/ GIMT_Encode4(1299722), // Rule ID 9274 //
     /* 1299643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299696 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299721 */     // GIR_Coverage, 9274,
     /* 1299721 */     GIR_EraseRootFromParent_Done,
     /* 1299722 */   // Label 18664: @1299722
     /* 1299722 */   GIM_Try, /*On fail goto*//*Label 18665*/ GIMT_Encode4(1299806), // Rule ID 9275 //
     /* 1299727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299780 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299805 */     // GIR_Coverage, 9275,
     /* 1299805 */     GIR_EraseRootFromParent_Done,
     /* 1299806 */   // Label 18665: @1299806
     /* 1299806 */   GIM_Try, /*On fail goto*//*Label 18666*/ GIMT_Encode4(1299890), // Rule ID 9278 //
     /* 1299811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299864 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299889 */     // GIR_Coverage, 9278,
     /* 1299889 */     GIR_EraseRootFromParent_Done,
     /* 1299890 */   // Label 18666: @1299890
     /* 1299890 */   GIM_Try, /*On fail goto*//*Label 18667*/ GIMT_Encode4(1299974), // Rule ID 9279 //
     /* 1299895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299948 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299973 */     // GIR_Coverage, 9279,
     /* 1299973 */     GIR_EraseRootFromParent_Done,
     /* 1299974 */   // Label 18667: @1299974
     /* 1299974 */   GIM_Try, /*On fail goto*//*Label 18668*/ GIMT_Encode4(1300058), // Rule ID 9282 //
     /* 1299979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1299996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1300002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300032 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300057 */     // GIR_Coverage, 9282,
     /* 1300057 */     GIR_EraseRootFromParent_Done,
     /* 1300058 */   // Label 18668: @1300058
     /* 1300058 */   GIM_Try, /*On fail goto*//*Label 18669*/ GIMT_Encode4(1300142), // Rule ID 9283 //
     /* 1300063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1300074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1300077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1300080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1300086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300116 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300141 */     // GIR_Coverage, 9283,
     /* 1300141 */     GIR_EraseRootFromParent_Done,
     /* 1300142 */   // Label 18669: @1300142
     /* 1300142 */   GIM_Try, /*On fail goto*//*Label 18670*/ GIMT_Encode4(1300226), // Rule ID 9286 //
     /* 1300147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1300164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300200 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1300203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300225 */     // GIR_Coverage, 9286,
     /* 1300225 */     GIR_EraseRootFromParent_Done,
     /* 1300226 */   // Label 18670: @1300226
     /* 1300226 */   GIM_Try, /*On fail goto*//*Label 18671*/ GIMT_Encode4(1300310), // Rule ID 9287 //
     /* 1300231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1300248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300284 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1300287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300309 */     // GIR_Coverage, 9287,
     /* 1300309 */     GIR_EraseRootFromParent_Done,
     /* 1300310 */   // Label 18671: @1300310
     /* 1300310 */   GIM_Try, /*On fail goto*//*Label 18672*/ GIMT_Encode4(1300394), // Rule ID 9290 //
     /* 1300315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1300332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300368 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1300371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300393 */     // GIR_Coverage, 9290,
     /* 1300393 */     GIR_EraseRootFromParent_Done,
     /* 1300394 */   // Label 18672: @1300394
     /* 1300394 */   GIM_Try, /*On fail goto*//*Label 18673*/ GIMT_Encode4(1300478), // Rule ID 9291 //
     /* 1300399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1300416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1300455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300477 */     // GIR_Coverage, 9291,
     /* 1300477 */     GIR_EraseRootFromParent_Done,
     /* 1300478 */   // Label 18673: @1300478
     /* 1300478 */   GIM_Try, /*On fail goto*//*Label 18674*/ GIMT_Encode4(1300562), // Rule ID 9294 //
     /* 1300483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300536 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300561 */     // GIR_Coverage, 9294,
     /* 1300561 */     GIR_EraseRootFromParent_Done,
     /* 1300562 */   // Label 18674: @1300562
     /* 1300562 */   GIM_Try, /*On fail goto*//*Label 18675*/ GIMT_Encode4(1300646), // Rule ID 9295 //
     /* 1300567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300620 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300645 */     // GIR_Coverage, 9295,
     /* 1300645 */     GIR_EraseRootFromParent_Done,
     /* 1300646 */   // Label 18675: @1300646
     /* 1300646 */   GIM_Try, /*On fail goto*//*Label 18676*/ GIMT_Encode4(1300730), // Rule ID 9298 //
     /* 1300651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1300707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300729 */     // GIR_Coverage, 9298,
     /* 1300729 */     GIR_EraseRootFromParent_Done,
     /* 1300730 */   // Label 18676: @1300730
     /* 1300730 */   GIM_Try, /*On fail goto*//*Label 18677*/ GIMT_Encode4(1300814), // Rule ID 9299 //
     /* 1300735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300788 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1300791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300813 */     // GIR_Coverage, 9299,
     /* 1300813 */     GIR_EraseRootFromParent_Done,
     /* 1300814 */   // Label 18677: @1300814
     /* 1300814 */   GIM_Try, /*On fail goto*//*Label 18678*/ GIMT_Encode4(1300898), // Rule ID 9302 //
     /* 1300819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1300836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300872 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1300875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300897 */     // GIR_Coverage, 9302,
     /* 1300897 */     GIR_EraseRootFromParent_Done,
     /* 1300898 */   // Label 18678: @1300898
     /* 1300898 */   GIM_Try, /*On fail goto*//*Label 18679*/ GIMT_Encode4(1300982), // Rule ID 9303 //
     /* 1300903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1300920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300956 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1300959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300981 */     // GIR_Coverage, 9303,
     /* 1300981 */     GIR_EraseRootFromParent_Done,
     /* 1300982 */   // Label 18679: @1300982
     /* 1300982 */   GIM_Try, /*On fail goto*//*Label 18680*/ GIMT_Encode4(1301066), // Rule ID 9306 //
     /* 1300987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1301004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301040 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1301043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301065 */     // GIR_Coverage, 9306,
     /* 1301065 */     GIR_EraseRootFromParent_Done,
     /* 1301066 */   // Label 18680: @1301066
     /* 1301066 */   GIM_Try, /*On fail goto*//*Label 18681*/ GIMT_Encode4(1301150), // Rule ID 9307 //
     /* 1301071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1301074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1301088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301124 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1301127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301149 */     // GIR_Coverage, 9307,
     /* 1301149 */     GIR_EraseRootFromParent_Done,
     /* 1301150 */   // Label 18681: @1301150
     /* 1301150 */   GIM_Try, /*On fail goto*//*Label 18682*/ GIMT_Encode4(1301234), // Rule ID 9398 //
     /* 1301155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1301172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301208 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1301211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301233 */     // GIR_Coverage, 9398,
     /* 1301233 */     GIR_EraseRootFromParent_Done,
     /* 1301234 */   // Label 18682: @1301234
     /* 1301234 */   GIM_Try, /*On fail goto*//*Label 18683*/ GIMT_Encode4(1301318), // Rule ID 9399 //
     /* 1301239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1301256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301292 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1301295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301317 */     // GIR_Coverage, 9399,
     /* 1301317 */     GIR_EraseRootFromParent_Done,
     /* 1301318 */   // Label 18683: @1301318
     /* 1301318 */   GIM_Try, /*On fail goto*//*Label 18684*/ GIMT_Encode4(1301402), // Rule ID 9402 //
     /* 1301323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1301340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301401 */     // GIR_Coverage, 9402,
     /* 1301401 */     GIR_EraseRootFromParent_Done,
     /* 1301402 */   // Label 18684: @1301402
     /* 1301402 */   GIM_Try, /*On fail goto*//*Label 18685*/ GIMT_Encode4(1301486), // Rule ID 9403 //
     /* 1301407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1301424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301460 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301485 */     // GIR_Coverage, 9403,
     /* 1301485 */     GIR_EraseRootFromParent_Done,
     /* 1301486 */   // Label 18685: @1301486
     /* 1301486 */   GIM_Try, /*On fail goto*//*Label 18686*/ GIMT_Encode4(1301570), // Rule ID 9406 //
     /* 1301491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301544 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301569 */     // GIR_Coverage, 9406,
     /* 1301569 */     GIR_EraseRootFromParent_Done,
     /* 1301570 */   // Label 18686: @1301570
     /* 1301570 */   GIM_Try, /*On fail goto*//*Label 18687*/ GIMT_Encode4(1301654), // Rule ID 9407 //
     /* 1301575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301628 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301653 */     // GIR_Coverage, 9407,
     /* 1301653 */     GIR_EraseRootFromParent_Done,
     /* 1301654 */   // Label 18687: @1301654
     /* 1301654 */   GIM_Try, /*On fail goto*//*Label 18688*/ GIMT_Encode4(1301738), // Rule ID 9410 //
     /* 1301659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301712 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301737 */     // GIR_Coverage, 9410,
     /* 1301737 */     GIR_EraseRootFromParent_Done,
     /* 1301738 */   // Label 18688: @1301738
     /* 1301738 */   GIM_Try, /*On fail goto*//*Label 18689*/ GIMT_Encode4(1301822), // Rule ID 9411 //
     /* 1301743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301796 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301821 */     // GIR_Coverage, 9411,
     /* 1301821 */     GIR_EraseRootFromParent_Done,
     /* 1301822 */   // Label 18689: @1301822
     /* 1301822 */   GIM_Try, /*On fail goto*//*Label 18690*/ GIMT_Encode4(1301906), // Rule ID 9414 //
     /* 1301827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1301844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301905 */     // GIR_Coverage, 9414,
     /* 1301905 */     GIR_EraseRootFromParent_Done,
     /* 1301906 */   // Label 18690: @1301906
     /* 1301906 */   GIM_Try, /*On fail goto*//*Label 18691*/ GIMT_Encode4(1301990), // Rule ID 9415 //
     /* 1301911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1301928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301964 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301989 */     // GIR_Coverage, 9415,
     /* 1301989 */     GIR_EraseRootFromParent_Done,
     /* 1301990 */   // Label 18691: @1301990
     /* 1301990 */   GIM_Try, /*On fail goto*//*Label 18692*/ GIMT_Encode4(1302074), // Rule ID 9418 //
     /* 1301995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1302012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302048 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1302051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302073 */     // GIR_Coverage, 9418,
     /* 1302073 */     GIR_EraseRootFromParent_Done,
     /* 1302074 */   // Label 18692: @1302074
     /* 1302074 */   GIM_Try, /*On fail goto*//*Label 18693*/ GIMT_Encode4(1302158), // Rule ID 9419 //
     /* 1302079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1302096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302132 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1302135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302157 */     // GIR_Coverage, 9419,
     /* 1302157 */     GIR_EraseRootFromParent_Done,
     /* 1302158 */   // Label 18693: @1302158
     /* 1302158 */   GIM_Try, /*On fail goto*//*Label 18694*/ GIMT_Encode4(1302242), // Rule ID 9422 //
     /* 1302163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1302174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1302177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1302180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302216 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302241 */     // GIR_Coverage, 9422,
     /* 1302241 */     GIR_EraseRootFromParent_Done,
     /* 1302242 */   // Label 18694: @1302242
     /* 1302242 */   GIM_Try, /*On fail goto*//*Label 18695*/ GIMT_Encode4(1302326), // Rule ID 9423 //
     /* 1302247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1302258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1302261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1302264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302300 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302325 */     // GIR_Coverage, 9423,
     /* 1302325 */     GIR_EraseRootFromParent_Done,
     /* 1302326 */   // Label 18695: @1302326
     /* 1302326 */   GIM_Try, /*On fail goto*//*Label 18696*/ GIMT_Encode4(1302410), // Rule ID 9426 //
     /* 1302331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1302342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1302345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1302348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1302354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302384 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302409 */     // GIR_Coverage, 9426,
     /* 1302409 */     GIR_EraseRootFromParent_Done,
     /* 1302410 */   // Label 18696: @1302410
     /* 1302410 */   GIM_Try, /*On fail goto*//*Label 18697*/ GIMT_Encode4(1302494), // Rule ID 9427 //
     /* 1302415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1302426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1302429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1302432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1302438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302468 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302493 */     // GIR_Coverage, 9427,
     /* 1302493 */     GIR_EraseRootFromParent_Done,
     /* 1302494 */   // Label 18697: @1302494
     /* 1302494 */   GIM_Try, /*On fail goto*//*Label 18698*/ GIMT_Encode4(1302578), // Rule ID 9430 //
     /* 1302499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302552 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302577 */     // GIR_Coverage, 9430,
     /* 1302577 */     GIR_EraseRootFromParent_Done,
     /* 1302578 */   // Label 18698: @1302578
     /* 1302578 */   GIM_Try, /*On fail goto*//*Label 18699*/ GIMT_Encode4(1302662), // Rule ID 9431 //
     /* 1302583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302636 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302661 */     // GIR_Coverage, 9431,
     /* 1302661 */     GIR_EraseRootFromParent_Done,
     /* 1302662 */   // Label 18699: @1302662
     /* 1302662 */   GIM_Try, /*On fail goto*//*Label 18700*/ GIMT_Encode4(1302746), // Rule ID 9434 //
     /* 1302667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1302670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302720 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302745 */     // GIR_Coverage, 9434,
     /* 1302745 */     GIR_EraseRootFromParent_Done,
     /* 1302746 */   // Label 18700: @1302746
     /* 1302746 */   GIM_Try, /*On fail goto*//*Label 18701*/ GIMT_Encode4(1302830), // Rule ID 9435 //
     /* 1302751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1302754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302804 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302829 */     // GIR_Coverage, 9435,
     /* 1302829 */     GIR_EraseRootFromParent_Done,
     /* 1302830 */   // Label 18701: @1302830
     /* 1302830 */   GIM_Try, /*On fail goto*//*Label 18702*/ GIMT_Encode4(1302914), // Rule ID 9438 //
     /* 1302835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1302846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1302849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1302852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1302858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302888 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1302891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302913 */     // GIR_Coverage, 9438,
     /* 1302913 */     GIR_EraseRootFromParent_Done,
     /* 1302914 */   // Label 18702: @1302914
     /* 1302914 */   GIM_Try, /*On fail goto*//*Label 18703*/ GIMT_Encode4(1302998), // Rule ID 9439 //
     /* 1302919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1302930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1302933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1302936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1302942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302972 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1302975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302997 */     // GIR_Coverage, 9439,
     /* 1302997 */     GIR_EraseRootFromParent_Done,
     /* 1302998 */   // Label 18703: @1302998
     /* 1302998 */   GIM_Try, /*On fail goto*//*Label 18704*/ GIMT_Encode4(1303082), // Rule ID 9442 //
     /* 1303003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1303020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303056 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303081 */     // GIR_Coverage, 9442,
     /* 1303081 */     GIR_EraseRootFromParent_Done,
     /* 1303082 */   // Label 18704: @1303082
     /* 1303082 */   GIM_Try, /*On fail goto*//*Label 18705*/ GIMT_Encode4(1303166), // Rule ID 9443 //
     /* 1303087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1303104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303140 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303165 */     // GIR_Coverage, 9443,
     /* 1303165 */     GIR_EraseRootFromParent_Done,
     /* 1303166 */   // Label 18705: @1303166
     /* 1303166 */   GIM_Try, /*On fail goto*//*Label 18706*/ GIMT_Encode4(1303250), // Rule ID 9446 //
     /* 1303171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1303182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1303185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1303188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1303194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303224 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303249 */     // GIR_Coverage, 9446,
     /* 1303249 */     GIR_EraseRootFromParent_Done,
     /* 1303250 */   // Label 18706: @1303250
     /* 1303250 */   GIM_Try, /*On fail goto*//*Label 18707*/ GIMT_Encode4(1303334), // Rule ID 9447 //
     /* 1303255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1303266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1303269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1303272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1303278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303308 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303333 */     // GIR_Coverage, 9447,
     /* 1303333 */     GIR_EraseRootFromParent_Done,
     /* 1303334 */   // Label 18707: @1303334
     /* 1303334 */   GIM_Try, /*On fail goto*//*Label 18708*/ GIMT_Encode4(1303418), // Rule ID 9450 //
     /* 1303339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1303356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303392 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303417 */     // GIR_Coverage, 9450,
     /* 1303417 */     GIR_EraseRootFromParent_Done,
     /* 1303418 */   // Label 18708: @1303418
     /* 1303418 */   GIM_Try, /*On fail goto*//*Label 18709*/ GIMT_Encode4(1303502), // Rule ID 9451 //
     /* 1303423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1303440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303476 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303501 */     // GIR_Coverage, 9451,
     /* 1303501 */     GIR_EraseRootFromParent_Done,
     /* 1303502 */   // Label 18709: @1303502
     /* 1303502 */   GIM_Try, /*On fail goto*//*Label 18710*/ GIMT_Encode4(1303586), // Rule ID 9454 //
     /* 1303507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303560 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303585 */     // GIR_Coverage, 9454,
     /* 1303585 */     GIR_EraseRootFromParent_Done,
     /* 1303586 */   // Label 18710: @1303586
     /* 1303586 */   GIM_Try, /*On fail goto*//*Label 18711*/ GIMT_Encode4(1303670), // Rule ID 9455 //
     /* 1303591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303644 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303669 */     // GIR_Coverage, 9455,
     /* 1303669 */     GIR_EraseRootFromParent_Done,
     /* 1303670 */   // Label 18711: @1303670
     /* 1303670 */   GIM_Try, /*On fail goto*//*Label 18712*/ GIMT_Encode4(1303754), // Rule ID 9458 //
     /* 1303675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303728 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303753 */     // GIR_Coverage, 9458,
     /* 1303753 */     GIR_EraseRootFromParent_Done,
     /* 1303754 */   // Label 18712: @1303754
     /* 1303754 */   GIM_Try, /*On fail goto*//*Label 18713*/ GIMT_Encode4(1303838), // Rule ID 9459 //
     /* 1303759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303812 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303837 */     // GIR_Coverage, 9459,
     /* 1303837 */     GIR_EraseRootFromParent_Done,
     /* 1303838 */   // Label 18713: @1303838
     /* 1303838 */   GIM_Try, /*On fail goto*//*Label 18714*/ GIMT_Encode4(1303922), // Rule ID 9462 //
     /* 1303843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1303854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1303857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1303860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1303866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303896 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303921 */     // GIR_Coverage, 9462,
     /* 1303921 */     GIR_EraseRootFromParent_Done,
     /* 1303922 */   // Label 18714: @1303922
     /* 1303922 */   GIM_Try, /*On fail goto*//*Label 18715*/ GIMT_Encode4(1304006), // Rule ID 9463 //
     /* 1303927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1303938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1303941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1303944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1303950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303980 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304005 */     // GIR_Coverage, 9463,
     /* 1304005 */     GIR_EraseRootFromParent_Done,
     /* 1304006 */   // Label 18715: @1304006
     /* 1304006 */   GIM_Try, /*On fail goto*//*Label 18716*/ GIMT_Encode4(1304090), // Rule ID 9466 //
     /* 1304011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1304028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304064 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1304067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304089 */     // GIR_Coverage, 9466,
     /* 1304089 */     GIR_EraseRootFromParent_Done,
     /* 1304090 */   // Label 18716: @1304090
     /* 1304090 */   GIM_Try, /*On fail goto*//*Label 18717*/ GIMT_Encode4(1304174), // Rule ID 9467 //
     /* 1304095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1304112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304148 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1304151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304173 */     // GIR_Coverage, 9467,
     /* 1304173 */     GIR_EraseRootFromParent_Done,
     /* 1304174 */   // Label 18717: @1304174
     /* 1304174 */   GIM_Try, /*On fail goto*//*Label 18718*/ GIMT_Encode4(1304258), // Rule ID 9470 //
     /* 1304179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1304190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1304193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1304196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1304202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304232 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1304235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304257 */     // GIR_Coverage, 9470,
     /* 1304257 */     GIR_EraseRootFromParent_Done,
     /* 1304258 */   // Label 18718: @1304258
     /* 1304258 */   GIM_Try, /*On fail goto*//*Label 18719*/ GIMT_Encode4(1304342), // Rule ID 9471 //
     /* 1304263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1304274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1304277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1304280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1304286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304316 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1304319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304341 */     // GIR_Coverage, 9471,
     /* 1304341 */     GIR_EraseRootFromParent_Done,
     /* 1304342 */   // Label 18719: @1304342
     /* 1304342 */   GIM_Try, /*On fail goto*//*Label 18720*/ GIMT_Encode4(1304426), // Rule ID 9474 //
     /* 1304347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1304364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304400 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1304403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304425 */     // GIR_Coverage, 9474,
     /* 1304425 */     GIR_EraseRootFromParent_Done,
     /* 1304426 */   // Label 18720: @1304426
     /* 1304426 */   GIM_Try, /*On fail goto*//*Label 18721*/ GIMT_Encode4(1304510), // Rule ID 9475 //
     /* 1304431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1304448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304484 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1304487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304509 */     // GIR_Coverage, 9475,
     /* 1304509 */     GIR_EraseRootFromParent_Done,
     /* 1304510 */   // Label 18721: @1304510
     /* 1304510 */   GIM_Try, /*On fail goto*//*Label 18722*/ GIMT_Encode4(1304594), // Rule ID 9478 //
     /* 1304515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304568 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1304571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304593 */     // GIR_Coverage, 9478,
     /* 1304593 */     GIR_EraseRootFromParent_Done,
     /* 1304594 */   // Label 18722: @1304594
     /* 1304594 */   GIM_Try, /*On fail goto*//*Label 18723*/ GIMT_Encode4(1304678), // Rule ID 9479 //
     /* 1304599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304652 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1304655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304677 */     // GIR_Coverage, 9479,
     /* 1304677 */     GIR_EraseRootFromParent_Done,
     /* 1304678 */   // Label 18723: @1304678
     /* 1304678 */   GIM_Try, /*On fail goto*//*Label 18724*/ GIMT_Encode4(1304762), // Rule ID 9482 //
     /* 1304683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1304739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304761 */     // GIR_Coverage, 9482,
     /* 1304761 */     GIR_EraseRootFromParent_Done,
     /* 1304762 */   // Label 18724: @1304762
     /* 1304762 */   GIM_Try, /*On fail goto*//*Label 18725*/ GIMT_Encode4(1304846), // Rule ID 9483 //
     /* 1304767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304820 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1304823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304845 */     // GIR_Coverage, 9483,
     /* 1304845 */     GIR_EraseRootFromParent_Done,
     /* 1304846 */   // Label 18725: @1304846
     /* 1304846 */   GIM_Try, /*On fail goto*//*Label 18726*/ GIMT_Encode4(1304930), // Rule ID 9574 //
     /* 1304851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1304868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1304871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304904 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1304907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304929 */     // GIR_Coverage, 9574,
     /* 1304929 */     GIR_EraseRootFromParent_Done,
     /* 1304930 */   // Label 18726: @1304930
     /* 1304930 */   GIM_Try, /*On fail goto*//*Label 18727*/ GIMT_Encode4(1305014), // Rule ID 9575 //
     /* 1304935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1304952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1304955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304988 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1304991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305013 */     // GIR_Coverage, 9575,
     /* 1305013 */     GIR_EraseRootFromParent_Done,
     /* 1305014 */   // Label 18727: @1305014
     /* 1305014 */   GIM_Try, /*On fail goto*//*Label 18728*/ GIMT_Encode4(1305098), // Rule ID 9578 //
     /* 1305019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1305036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1305039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305072 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305097 */     // GIR_Coverage, 9578,
     /* 1305097 */     GIR_EraseRootFromParent_Done,
     /* 1305098 */   // Label 18728: @1305098
     /* 1305098 */   GIM_Try, /*On fail goto*//*Label 18729*/ GIMT_Encode4(1305182), // Rule ID 9579 //
     /* 1305103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1305120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1305123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305156 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305181 */     // GIR_Coverage, 9579,
     /* 1305181 */     GIR_EraseRootFromParent_Done,
     /* 1305182 */   // Label 18729: @1305182
     /* 1305182 */   GIM_Try, /*On fail goto*//*Label 18730*/ GIMT_Encode4(1305266), // Rule ID 9582 //
     /* 1305187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1305204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1305207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305240 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1305243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305265 */     // GIR_Coverage, 9582,
     /* 1305265 */     GIR_EraseRootFromParent_Done,
     /* 1305266 */   // Label 18730: @1305266
     /* 1305266 */   GIM_Try, /*On fail goto*//*Label 18731*/ GIMT_Encode4(1305350), // Rule ID 9583 //
     /* 1305271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1305288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1305291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305324 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1305327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305349 */     // GIR_Coverage, 9583,
     /* 1305349 */     GIR_EraseRootFromParent_Done,
     /* 1305350 */   // Label 18731: @1305350
     /* 1305350 */   GIM_Try, /*On fail goto*//*Label 18732*/ GIMT_Encode4(1305434), // Rule ID 9586 //
     /* 1305355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1305372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1305375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305408 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305433 */     // GIR_Coverage, 9586,
     /* 1305433 */     GIR_EraseRootFromParent_Done,
     /* 1305434 */   // Label 18732: @1305434
     /* 1305434 */   GIM_Try, /*On fail goto*//*Label 18733*/ GIMT_Encode4(1305518), // Rule ID 9587 //
     /* 1305439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1305456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1305459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305492 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305517 */     // GIR_Coverage, 9587,
     /* 1305517 */     GIR_EraseRootFromParent_Done,
     /* 1305518 */   // Label 18733: @1305518
     /* 1305518 */   GIM_Try, /*On fail goto*//*Label 18734*/ GIMT_Encode4(1305602), // Rule ID 9590 //
     /* 1305523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1305543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305576 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305601 */     // GIR_Coverage, 9590,
     /* 1305601 */     GIR_EraseRootFromParent_Done,
     /* 1305602 */   // Label 18734: @1305602
     /* 1305602 */   GIM_Try, /*On fail goto*//*Label 18735*/ GIMT_Encode4(1305686), // Rule ID 9591 //
     /* 1305607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1305627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305660 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305685 */     // GIR_Coverage, 9591,
     /* 1305685 */     GIR_EraseRootFromParent_Done,
     /* 1305686 */   // Label 18735: @1305686
     /* 1305686 */   GIM_Try, /*On fail goto*//*Label 18736*/ GIMT_Encode4(1305770), // Rule ID 9594 //
     /* 1305691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1305702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1305705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1305708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1305711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1305714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305744 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305769 */     // GIR_Coverage, 9594,
     /* 1305769 */     GIR_EraseRootFromParent_Done,
     /* 1305770 */   // Label 18736: @1305770
     /* 1305770 */   GIM_Try, /*On fail goto*//*Label 18737*/ GIMT_Encode4(1305854), // Rule ID 9595 //
     /* 1305775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1305786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1305789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1305792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1305795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1305798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305828 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305853 */     // GIR_Coverage, 9595,
     /* 1305853 */     GIR_EraseRootFromParent_Done,
     /* 1305854 */   // Label 18737: @1305854
     /* 1305854 */   GIM_Try, /*On fail goto*//*Label 18738*/ GIMT_Encode4(1305938), // Rule ID 9598 //
     /* 1305859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1305876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1305879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305912 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305937 */     // GIR_Coverage, 9598,
     /* 1305937 */     GIR_EraseRootFromParent_Done,
     /* 1305938 */   // Label 18738: @1305938
     /* 1305938 */   GIM_Try, /*On fail goto*//*Label 18739*/ GIMT_Encode4(1306022), // Rule ID 9599 //
     /* 1305943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1305960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1305963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305996 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306021 */     // GIR_Coverage, 9599,
     /* 1306021 */     GIR_EraseRootFromParent_Done,
     /* 1306022 */   // Label 18739: @1306022
     /* 1306022 */   GIM_Try, /*On fail goto*//*Label 18740*/ GIMT_Encode4(1306106), // Rule ID 9602 //
     /* 1306027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1306038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1306041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1306044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1306047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1306050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306080 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1306083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306105 */     // GIR_Coverage, 9602,
     /* 1306105 */     GIR_EraseRootFromParent_Done,
     /* 1306106 */   // Label 18740: @1306106
     /* 1306106 */   GIM_Try, /*On fail goto*//*Label 18741*/ GIMT_Encode4(1306190), // Rule ID 9603 //
     /* 1306111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1306122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1306125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1306128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1306131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1306134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306164 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1306167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306189 */     // GIR_Coverage, 9603,
     /* 1306189 */     GIR_EraseRootFromParent_Done,
     /* 1306190 */   // Label 18741: @1306190
     /* 1306190 */   GIM_Try, /*On fail goto*//*Label 18742*/ GIMT_Encode4(1306274), // Rule ID 9606 //
     /* 1306195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1306198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1306206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1306209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1306212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1306215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1306218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306248 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1306251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1306269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306273 */     // GIR_Coverage, 9606,
     /* 1306273 */     GIR_EraseRootFromParent_Done,
     /* 1306274 */   // Label 18742: @1306274
     /* 1306274 */   GIM_Try, /*On fail goto*//*Label 18743*/ GIMT_Encode4(1306358), // Rule ID 9607 //
     /* 1306279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1306282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1306290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1306293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1306296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1306299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1306302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306332 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1306335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1306353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306357 */     // GIR_Coverage, 9607,
     /* 1306357 */     GIR_EraseRootFromParent_Done,
     /* 1306358 */   // Label 18743: @1306358
     /* 1306358 */   GIM_Try, /*On fail goto*//*Label 18744*/ GIMT_Encode4(1306442), // Rule ID 9610 //
     /* 1306363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1306380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1306383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306416 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306441 */     // GIR_Coverage, 9610,
     /* 1306441 */     GIR_EraseRootFromParent_Done,
     /* 1306442 */   // Label 18744: @1306442
     /* 1306442 */   GIM_Try, /*On fail goto*//*Label 18745*/ GIMT_Encode4(1306526), // Rule ID 9611 //
     /* 1306447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1306464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1306467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306500 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306525 */     // GIR_Coverage, 9611,
     /* 1306525 */     GIR_EraseRootFromParent_Done,
     /* 1306526 */   // Label 18745: @1306526
     /* 1306526 */   GIM_Try, /*On fail goto*//*Label 18746*/ GIMT_Encode4(1306610), // Rule ID 9614 //
     /* 1306531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1306548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1306551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306584 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1306587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306609 */     // GIR_Coverage, 9614,
     /* 1306609 */     GIR_EraseRootFromParent_Done,
     /* 1306610 */   // Label 18746: @1306610
     /* 1306610 */   GIM_Try, /*On fail goto*//*Label 18747*/ GIMT_Encode4(1306694), // Rule ID 9615 //
     /* 1306615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1306632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1306635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306668 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1306671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306693 */     // GIR_Coverage, 9615,
     /* 1306693 */     GIR_EraseRootFromParent_Done,
     /* 1306694 */   // Label 18747: @1306694
     /* 1306694 */   GIM_Try, /*On fail goto*//*Label 18748*/ GIMT_Encode4(1306778), // Rule ID 9618 //
     /* 1306699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1306710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1306713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1306716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1306719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1306722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306752 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1306755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306777 */     // GIR_Coverage, 9618,
     /* 1306777 */     GIR_EraseRootFromParent_Done,
     /* 1306778 */   // Label 18748: @1306778
     /* 1306778 */   GIM_Try, /*On fail goto*//*Label 18749*/ GIMT_Encode4(1306862), // Rule ID 9619 //
     /* 1306783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1306794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1306797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1306800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1306803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1306806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306836 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1306839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306861 */     // GIR_Coverage, 9619,
     /* 1306861 */     GIR_EraseRootFromParent_Done,
     /* 1306862 */   // Label 18749: @1306862
     /* 1306862 */   GIM_Try, /*On fail goto*//*Label 18750*/ GIMT_Encode4(1306946), // Rule ID 9622 //
     /* 1306867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1306884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1306887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306920 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306945 */     // GIR_Coverage, 9622,
     /* 1306945 */     GIR_EraseRootFromParent_Done,
     /* 1306946 */   // Label 18750: @1306946
     /* 1306946 */   GIM_Try, /*On fail goto*//*Label 18751*/ GIMT_Encode4(1307030), // Rule ID 9623 //
     /* 1306951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1306968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1306971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307004 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307029 */     // GIR_Coverage, 9623,
     /* 1307029 */     GIR_EraseRootFromParent_Done,
     /* 1307030 */   // Label 18751: @1307030
     /* 1307030 */   GIM_Try, /*On fail goto*//*Label 18752*/ GIMT_Encode4(1307114), // Rule ID 9626 //
     /* 1307035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1307052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1307055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307088 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307113 */     // GIR_Coverage, 9626,
     /* 1307113 */     GIR_EraseRootFromParent_Done,
     /* 1307114 */   // Label 18752: @1307114
     /* 1307114 */   GIM_Try, /*On fail goto*//*Label 18753*/ GIMT_Encode4(1307198), // Rule ID 9627 //
     /* 1307119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1307136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1307139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307172 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307197 */     // GIR_Coverage, 9627,
     /* 1307197 */     GIR_EraseRootFromParent_Done,
     /* 1307198 */   // Label 18753: @1307198
     /* 1307198 */   GIM_Try, /*On fail goto*//*Label 18754*/ GIMT_Encode4(1307282), // Rule ID 9630 //
     /* 1307203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1307214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1307217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1307220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1307223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1307226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307256 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307281 */     // GIR_Coverage, 9630,
     /* 1307281 */     GIR_EraseRootFromParent_Done,
     /* 1307282 */   // Label 18754: @1307282
     /* 1307282 */   GIM_Try, /*On fail goto*//*Label 18755*/ GIMT_Encode4(1307366), // Rule ID 9631 //
     /* 1307287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1307298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1307301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1307304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1307307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1307310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307340 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307365 */     // GIR_Coverage, 9631,
     /* 1307365 */     GIR_EraseRootFromParent_Done,
     /* 1307366 */   // Label 18755: @1307366
     /* 1307366 */   GIM_Try, /*On fail goto*//*Label 18756*/ GIMT_Encode4(1307450), // Rule ID 9634 //
     /* 1307371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1307388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1307391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307424 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307449 */     // GIR_Coverage, 9634,
     /* 1307449 */     GIR_EraseRootFromParent_Done,
     /* 1307450 */   // Label 18756: @1307450
     /* 1307450 */   GIM_Try, /*On fail goto*//*Label 18757*/ GIMT_Encode4(1307534), // Rule ID 9635 //
     /* 1307455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1307472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1307475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307508 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307533 */     // GIR_Coverage, 9635,
     /* 1307533 */     GIR_EraseRootFromParent_Done,
     /* 1307534 */   // Label 18757: @1307534
     /* 1307534 */   GIM_Try, /*On fail goto*//*Label 18758*/ GIMT_Encode4(1307618), // Rule ID 9638 //
     /* 1307539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1307556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1307559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307592 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307617 */     // GIR_Coverage, 9638,
     /* 1307617 */     GIR_EraseRootFromParent_Done,
     /* 1307618 */   // Label 18758: @1307618
     /* 1307618 */   GIM_Try, /*On fail goto*//*Label 18759*/ GIMT_Encode4(1307702), // Rule ID 9639 //
     /* 1307623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1307640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1307643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307676 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307701 */     // GIR_Coverage, 9639,
     /* 1307701 */     GIR_EraseRootFromParent_Done,
     /* 1307702 */   // Label 18759: @1307702
     /* 1307702 */   GIM_Try, /*On fail goto*//*Label 18760*/ GIMT_Encode4(1307786), // Rule ID 9642 //
     /* 1307707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1307724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1307727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307760 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307785 */     // GIR_Coverage, 9642,
     /* 1307785 */     GIR_EraseRootFromParent_Done,
     /* 1307786 */   // Label 18760: @1307786
     /* 1307786 */   GIM_Try, /*On fail goto*//*Label 18761*/ GIMT_Encode4(1307870), // Rule ID 9643 //
     /* 1307791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1307808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1307811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307844 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307869 */     // GIR_Coverage, 9643,
     /* 1307869 */     GIR_EraseRootFromParent_Done,
     /* 1307870 */   // Label 18761: @1307870
     /* 1307870 */   GIM_Try, /*On fail goto*//*Label 18762*/ GIMT_Encode4(1307954), // Rule ID 9646 //
     /* 1307875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1307878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1307886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1307889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1307892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1307895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1307898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307928 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307953 */     // GIR_Coverage, 9646,
     /* 1307953 */     GIR_EraseRootFromParent_Done,
     /* 1307954 */   // Label 18762: @1307954
     /* 1307954 */   GIM_Try, /*On fail goto*//*Label 18763*/ GIMT_Encode4(1308038), // Rule ID 9647 //
     /* 1307959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1307962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1307970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1307973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1307976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1307979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1307982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308012 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1308015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308037 */     // GIR_Coverage, 9647,
     /* 1308037 */     GIR_EraseRootFromParent_Done,
     /* 1308038 */   // Label 18763: @1308038
     /* 1308038 */   GIM_Try, /*On fail goto*//*Label 18764*/ GIMT_Encode4(1308122), // Rule ID 9650 //
     /* 1308043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1308046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1308060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1308063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308096 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1308099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308121 */     // GIR_Coverage, 9650,
     /* 1308121 */     GIR_EraseRootFromParent_Done,
     /* 1308122 */   // Label 18764: @1308122
     /* 1308122 */   GIM_Try, /*On fail goto*//*Label 18765*/ GIMT_Encode4(1308206), // Rule ID 9651 //
     /* 1308127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1308130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1308144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1308147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1308183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308205 */     // GIR_Coverage, 9651,
     /* 1308205 */     GIR_EraseRootFromParent_Done,
     /* 1308206 */   // Label 18765: @1308206
     /* 1308206 */   GIM_Try, /*On fail goto*//*Label 18766*/ GIMT_Encode4(1308290), // Rule ID 9654 //
     /* 1308211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1308214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1308222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1308225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1308228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1308231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1308234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1308267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308289 */     // GIR_Coverage, 9654,
     /* 1308289 */     GIR_EraseRootFromParent_Done,
     /* 1308290 */   // Label 18766: @1308290
     /* 1308290 */   GIM_Try, /*On fail goto*//*Label 18767*/ GIMT_Encode4(1308374), // Rule ID 9655 //
     /* 1308295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1308298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1308306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1308309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1308312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1308315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1308318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308348 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1308351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308373 */     // GIR_Coverage, 9655,
     /* 1308373 */     GIR_EraseRootFromParent_Done,
     /* 1308374 */   // Label 18767: @1308374
     /* 1308374 */   GIM_Try, /*On fail goto*//*Label 18768*/ GIMT_Encode4(1308458), // Rule ID 9658 //
     /* 1308379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1308396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1308399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308432 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1308435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308457 */     // GIR_Coverage, 9658,
     /* 1308457 */     GIR_EraseRootFromParent_Done,
     /* 1308458 */   // Label 18768: @1308458
     /* 1308458 */   GIM_Try, /*On fail goto*//*Label 18769*/ GIMT_Encode4(1308542), // Rule ID 9659 //
     /* 1308463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1308480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1308483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308516 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1308519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308541 */     // GIR_Coverage, 9659,
     /* 1308541 */     GIR_EraseRootFromParent_Done,
     /* 1308542 */   // Label 18769: @1308542
     /* 1308542 */   GIM_Try, /*On fail goto*//*Label 18770*/ GIMT_Encode4(1308626), // Rule ID 9662 //
     /* 1308547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1308564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1308567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308600 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308625 */     // GIR_Coverage, 9662,
     /* 1308625 */     GIR_EraseRootFromParent_Done,
     /* 1308626 */   // Label 18770: @1308626
     /* 1308626 */   GIM_Try, /*On fail goto*//*Label 18771*/ GIMT_Encode4(1308710), // Rule ID 9663 //
     /* 1308631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1308648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1308651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308684 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308709 */     // GIR_Coverage, 9663,
     /* 1308709 */     GIR_EraseRootFromParent_Done,
     /* 1308710 */   // Label 18771: @1308710
     /* 1308710 */   GIM_Try, /*On fail goto*//*Label 18772*/ GIMT_Encode4(1308794), // Rule ID 9666 //
     /* 1308715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1308732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1308735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308768 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308793 */     // GIR_Coverage, 9666,
     /* 1308793 */     GIR_EraseRootFromParent_Done,
     /* 1308794 */   // Label 18772: @1308794
     /* 1308794 */   GIM_Try, /*On fail goto*//*Label 18773*/ GIMT_Encode4(1308878), // Rule ID 9667 //
     /* 1308799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1308816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1308819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308852 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308877 */     // GIR_Coverage, 9667,
     /* 1308877 */     GIR_EraseRootFromParent_Done,
     /* 1308878 */   // Label 18773: @1308878
     /* 1308878 */   GIM_Try, /*On fail goto*//*Label 18774*/ GIMT_Encode4(1308962), // Rule ID 9670 //
     /* 1308883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1308900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1308903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308936 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308961 */     // GIR_Coverage, 9670,
     /* 1308961 */     GIR_EraseRootFromParent_Done,
     /* 1308962 */   // Label 18774: @1308962
     /* 1308962 */   GIM_Try, /*On fail goto*//*Label 18775*/ GIMT_Encode4(1309046), // Rule ID 9671 //
     /* 1308967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1308984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1308987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309020 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1309023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309045 */     // GIR_Coverage, 9671,
     /* 1309045 */     GIR_EraseRootFromParent_Done,
     /* 1309046 */   // Label 18775: @1309046
     /* 1309046 */   GIM_Try, /*On fail goto*//*Label 18776*/ GIMT_Encode4(1309130), // Rule ID 9674 //
     /* 1309051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1309068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1309071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309104 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1309107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309129 */     // GIR_Coverage, 9674,
     /* 1309129 */     GIR_EraseRootFromParent_Done,
     /* 1309130 */   // Label 18776: @1309130
     /* 1309130 */   GIM_Try, /*On fail goto*//*Label 18777*/ GIMT_Encode4(1309214), // Rule ID 9675 //
     /* 1309135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1309152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1309155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309188 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1309191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309213 */     // GIR_Coverage, 9675,
     /* 1309213 */     GIR_EraseRootFromParent_Done,
     /* 1309214 */   // Label 18777: @1309214
     /* 1309214 */   GIM_Try, /*On fail goto*//*Label 18778*/ GIMT_Encode4(1309298), // Rule ID 9678 //
     /* 1309219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1309236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1309239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309272 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1309275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309297 */     // GIR_Coverage, 9678,
     /* 1309297 */     GIR_EraseRootFromParent_Done,
     /* 1309298 */   // Label 18778: @1309298
     /* 1309298 */   GIM_Try, /*On fail goto*//*Label 18779*/ GIMT_Encode4(1309382), // Rule ID 9679 //
     /* 1309303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1309320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1309323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309356 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1309359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309381 */     // GIR_Coverage, 9679,
     /* 1309381 */     GIR_EraseRootFromParent_Done,
     /* 1309382 */   // Label 18779: @1309382
     /* 1309382 */   GIM_Try, /*On fail goto*//*Label 18780*/ GIMT_Encode4(1309466), // Rule ID 9682 //
     /* 1309387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1309398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1309401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1309404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1309407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1309410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309440 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309465 */     // GIR_Coverage, 9682,
     /* 1309465 */     GIR_EraseRootFromParent_Done,
     /* 1309466 */   // Label 18780: @1309466
     /* 1309466 */   GIM_Try, /*On fail goto*//*Label 18781*/ GIMT_Encode4(1309550), // Rule ID 9683 //
     /* 1309471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1309482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1309485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1309488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1309491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1309494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309524 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309549 */     // GIR_Coverage, 9683,
     /* 1309549 */     GIR_EraseRootFromParent_Done,
     /* 1309550 */   // Label 18781: @1309550
     /* 1309550 */   GIM_Try, /*On fail goto*//*Label 18782*/ GIMT_Encode4(1309634), // Rule ID 9686 //
     /* 1309555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1309572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1309575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309633 */     // GIR_Coverage, 9686,
     /* 1309633 */     GIR_EraseRootFromParent_Done,
     /* 1309634 */   // Label 18782: @1309634
     /* 1309634 */   GIM_Try, /*On fail goto*//*Label 18783*/ GIMT_Encode4(1309718), // Rule ID 9687 //
     /* 1309639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1309656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1309659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309692 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309717 */     // GIR_Coverage, 9687,
     /* 1309717 */     GIR_EraseRootFromParent_Done,
     /* 1309718 */   // Label 18783: @1309718
     /* 1309718 */   GIM_Try, /*On fail goto*//*Label 18784*/ GIMT_Encode4(1309802), // Rule ID 9690 //
     /* 1309723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1309740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1309743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309801 */     // GIR_Coverage, 9690,
     /* 1309801 */     GIR_EraseRootFromParent_Done,
     /* 1309802 */   // Label 18784: @1309802
     /* 1309802 */   GIM_Try, /*On fail goto*//*Label 18785*/ GIMT_Encode4(1309886), // Rule ID 9691 //
     /* 1309807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1309824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1309827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309885 */     // GIR_Coverage, 9691,
     /* 1309885 */     GIR_EraseRootFromParent_Done,
     /* 1309886 */   // Label 18785: @1309886
     /* 1309886 */   GIM_Try, /*On fail goto*//*Label 18786*/ GIMT_Encode4(1309970), // Rule ID 9694 //
     /* 1309891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1309894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1309908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1309911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309944 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309969 */     // GIR_Coverage, 9694,
     /* 1309969 */     GIR_EraseRootFromParent_Done,
     /* 1309970 */   // Label 18786: @1309970
     /* 1309970 */   GIM_Try, /*On fail goto*//*Label 18787*/ GIMT_Encode4(1310054), // Rule ID 9695 //
     /* 1309975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1309978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1309992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1309995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1310031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1310049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310053 */     // GIR_Coverage, 9695,
     /* 1310053 */     GIR_EraseRootFromParent_Done,
     /* 1310054 */   // Label 18787: @1310054
     /* 1310054 */   GIM_Try, /*On fail goto*//*Label 18788*/ GIMT_Encode4(1310138), // Rule ID 9698 //
     /* 1310059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1310076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1310079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310112 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310137 */     // GIR_Coverage, 9698,
     /* 1310137 */     GIR_EraseRootFromParent_Done,
     /* 1310138 */   // Label 18788: @1310138
     /* 1310138 */   GIM_Try, /*On fail goto*//*Label 18789*/ GIMT_Encode4(1310222), // Rule ID 9699 //
     /* 1310143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1310160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1310163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310196 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310221 */     // GIR_Coverage, 9699,
     /* 1310221 */     GIR_EraseRootFromParent_Done,
     /* 1310222 */   // Label 18789: @1310222
     /* 1310222 */   GIM_Try, /*On fail goto*//*Label 18790*/ GIMT_Encode4(1310306), // Rule ID 9702 //
     /* 1310227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1310244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1310247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310280 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310305 */     // GIR_Coverage, 9702,
     /* 1310305 */     GIR_EraseRootFromParent_Done,
     /* 1310306 */   // Label 18790: @1310306
     /* 1310306 */   GIM_Try, /*On fail goto*//*Label 18791*/ GIMT_Encode4(1310390), // Rule ID 9703 //
     /* 1310311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1310328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1310331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310364 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310389 */     // GIR_Coverage, 9703,
     /* 1310389 */     GIR_EraseRootFromParent_Done,
     /* 1310390 */   // Label 18791: @1310390
     /* 1310390 */   GIM_Try, /*On fail goto*//*Label 18792*/ GIMT_Encode4(1310474), // Rule ID 9706 //
     /* 1310395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1310406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1310409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1310412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1310415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1310418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310448 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310473 */     // GIR_Coverage, 9706,
     /* 1310473 */     GIR_EraseRootFromParent_Done,
     /* 1310474 */   // Label 18792: @1310474
     /* 1310474 */   GIM_Try, /*On fail goto*//*Label 18793*/ GIMT_Encode4(1310558), // Rule ID 9707 //
     /* 1310479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1310490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1310493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1310496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1310499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1310502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310532 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310557 */     // GIR_Coverage, 9707,
     /* 1310557 */     GIR_EraseRootFromParent_Done,
     /* 1310558 */   // Label 18793: @1310558
     /* 1310558 */   GIM_Try, /*On fail goto*//*Label 18794*/ GIMT_Encode4(1310642), // Rule ID 9710 //
     /* 1310563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1310583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310616 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310641 */     // GIR_Coverage, 9710,
     /* 1310641 */     GIR_EraseRootFromParent_Done,
     /* 1310642 */   // Label 18794: @1310642
     /* 1310642 */   GIM_Try, /*On fail goto*//*Label 18795*/ GIMT_Encode4(1310726), // Rule ID 9711 //
     /* 1310647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1310667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310700 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310725 */     // GIR_Coverage, 9711,
     /* 1310725 */     GIR_EraseRootFromParent_Done,
     /* 1310726 */   // Label 18795: @1310726
     /* 1310726 */   GIM_Try, /*On fail goto*//*Label 18796*/ GIMT_Encode4(1310810), // Rule ID 9714 //
     /* 1310731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1310748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1310751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310784 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310809 */     // GIR_Coverage, 9714,
     /* 1310809 */     GIR_EraseRootFromParent_Done,
     /* 1310810 */   // Label 18796: @1310810
     /* 1310810 */   GIM_Try, /*On fail goto*//*Label 18797*/ GIMT_Encode4(1310894), // Rule ID 9715 //
     /* 1310815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1310832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1310835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310868 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310893 */     // GIR_Coverage, 9715,
     /* 1310893 */     GIR_EraseRootFromParent_Done,
     /* 1310894 */   // Label 18797: @1310894
     /* 1310894 */   GIM_Try, /*On fail goto*//*Label 18798*/ GIMT_Encode4(1310978), // Rule ID 9718 //
     /* 1310899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1310916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1310919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310952 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310977 */     // GIR_Coverage, 9718,
     /* 1310977 */     GIR_EraseRootFromParent_Done,
     /* 1310978 */   // Label 18798: @1310978
     /* 1310978 */   GIM_Try, /*On fail goto*//*Label 18799*/ GIMT_Encode4(1311062), // Rule ID 9719 //
     /* 1310983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1311000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1311003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1311006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311036 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311061 */     // GIR_Coverage, 9719,
     /* 1311061 */     GIR_EraseRootFromParent_Done,
     /* 1311062 */   // Label 18799: @1311062
     /* 1311062 */   GIM_Try, /*On fail goto*//*Label 18800*/ GIMT_Encode4(1311146), // Rule ID 9722 //
     /* 1311067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1311084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1311087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311120 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1311123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311145 */     // GIR_Coverage, 9722,
     /* 1311145 */     GIR_EraseRootFromParent_Done,
     /* 1311146 */   // Label 18800: @1311146
     /* 1311146 */   GIM_Try, /*On fail goto*//*Label 18801*/ GIMT_Encode4(1311230), // Rule ID 9723 //
     /* 1311151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1311168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1311171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311204 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1311207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311229 */     // GIR_Coverage, 9723,
     /* 1311229 */     GIR_EraseRootFromParent_Done,
     /* 1311230 */   // Label 18801: @1311230
     /* 1311230 */   GIM_Try, /*On fail goto*//*Label 18802*/ GIMT_Encode4(1311314), // Rule ID 9726 //
     /* 1311235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1311252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1311255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311288 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1311291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311313 */     // GIR_Coverage, 9726,
     /* 1311313 */     GIR_EraseRootFromParent_Done,
     /* 1311314 */   // Label 18802: @1311314
     /* 1311314 */   GIM_Try, /*On fail goto*//*Label 18803*/ GIMT_Encode4(1311398), // Rule ID 9727 //
     /* 1311319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1311336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1311339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311372 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1311375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311397 */     // GIR_Coverage, 9727,
     /* 1311397 */     GIR_EraseRootFromParent_Done,
     /* 1311398 */   // Label 18803: @1311398
     /* 1311398 */   GIM_Try, /*On fail goto*//*Label 18804*/ GIMT_Encode4(1311482), // Rule ID 9730 //
     /* 1311403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1311420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1311423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311456 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311481 */     // GIR_Coverage, 9730,
     /* 1311481 */     GIR_EraseRootFromParent_Done,
     /* 1311482 */   // Label 18804: @1311482
     /* 1311482 */   GIM_Try, /*On fail goto*//*Label 18805*/ GIMT_Encode4(1311566), // Rule ID 9731 //
     /* 1311487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1311504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1311507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311540 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311565 */     // GIR_Coverage, 9731,
     /* 1311565 */     GIR_EraseRootFromParent_Done,
     /* 1311566 */   // Label 18805: @1311566
     /* 1311566 */   GIM_Try, /*On fail goto*//*Label 18806*/ GIMT_Encode4(1311650), // Rule ID 9734 //
     /* 1311571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1311588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1311591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311624 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1311627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311649 */     // GIR_Coverage, 9734,
     /* 1311649 */     GIR_EraseRootFromParent_Done,
     /* 1311650 */   // Label 18806: @1311650
     /* 1311650 */   GIM_Try, /*On fail goto*//*Label 18807*/ GIMT_Encode4(1311734), // Rule ID 9735 //
     /* 1311655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1311672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1311675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311708 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1311711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311733 */     // GIR_Coverage, 9735,
     /* 1311733 */     GIR_EraseRootFromParent_Done,
     /* 1311734 */   // Label 18807: @1311734
     /* 1311734 */   GIM_Try, /*On fail goto*//*Label 18808*/ GIMT_Encode4(1311818), // Rule ID 9738 //
     /* 1311739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1311756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1311759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311792 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1311795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311817 */     // GIR_Coverage, 9738,
     /* 1311817 */     GIR_EraseRootFromParent_Done,
     /* 1311818 */   // Label 18808: @1311818
     /* 1311818 */   GIM_Try, /*On fail goto*//*Label 18809*/ GIMT_Encode4(1311902), // Rule ID 9739 //
     /* 1311823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1311840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1311843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311876 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1311879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311901 */     // GIR_Coverage, 9739,
     /* 1311901 */     GIR_EraseRootFromParent_Done,
     /* 1311902 */   // Label 18809: @1311902
     /* 1311902 */   GIM_Try, /*On fail goto*//*Label 18810*/ GIMT_Encode4(1311986), // Rule ID 9742 //
     /* 1311907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1311924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1311927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311960 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311985 */     // GIR_Coverage, 9742,
     /* 1311985 */     GIR_EraseRootFromParent_Done,
     /* 1311986 */   // Label 18810: @1311986
     /* 1311986 */   GIM_Try, /*On fail goto*//*Label 18811*/ GIMT_Encode4(1312070), // Rule ID 9743 //
     /* 1311991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1312008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1312011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312044 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1312047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1312065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312069 */     // GIR_Coverage, 9743,
     /* 1312069 */     GIR_EraseRootFromParent_Done,
     /* 1312070 */   // Label 18811: @1312070
     /* 1312070 */   GIM_Try, /*On fail goto*//*Label 18812*/ GIMT_Encode4(1312154), // Rule ID 9746 //
     /* 1312075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1312092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1312095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312128 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1312131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312153 */     // GIR_Coverage, 9746,
     /* 1312153 */     GIR_EraseRootFromParent_Done,
     /* 1312154 */   // Label 18812: @1312154
     /* 1312154 */   GIM_Try, /*On fail goto*//*Label 18813*/ GIMT_Encode4(1312238), // Rule ID 9747 //
     /* 1312159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1312176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1312179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312212 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1312215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312237 */     // GIR_Coverage, 9747,
     /* 1312237 */     GIR_EraseRootFromParent_Done,
     /* 1312238 */   // Label 18813: @1312238
     /* 1312238 */   GIM_Try, /*On fail goto*//*Label 18814*/ GIMT_Encode4(1312322), // Rule ID 9750 //
     /* 1312243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1312260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1312263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312296 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1312299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312321 */     // GIR_Coverage, 9750,
     /* 1312321 */     GIR_EraseRootFromParent_Done,
     /* 1312322 */   // Label 18814: @1312322
     /* 1312322 */   GIM_Try, /*On fail goto*//*Label 18815*/ GIMT_Encode4(1312406), // Rule ID 9751 //
     /* 1312327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1312344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1312347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312380 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1312383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312405 */     // GIR_Coverage, 9751,
     /* 1312405 */     GIR_EraseRootFromParent_Done,
     /* 1312406 */   // Label 18815: @1312406
     /* 1312406 */   GIM_Try, /*On fail goto*//*Label 18816*/ GIMT_Encode4(1312490), // Rule ID 9754 //
     /* 1312411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1312428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1312431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312464 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312489 */     // GIR_Coverage, 9754,
     /* 1312489 */     GIR_EraseRootFromParent_Done,
     /* 1312490 */   // Label 18816: @1312490
     /* 1312490 */   GIM_Try, /*On fail goto*//*Label 18817*/ GIMT_Encode4(1312574), // Rule ID 9755 //
     /* 1312495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1312512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1312515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312548 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312573 */     // GIR_Coverage, 9755,
     /* 1312573 */     GIR_EraseRootFromParent_Done,
     /* 1312574 */   // Label 18817: @1312574
     /* 1312574 */   GIM_Try, /*On fail goto*//*Label 18818*/ GIMT_Encode4(1312658), // Rule ID 9758 //
     /* 1312579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1312599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312632 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1312635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312657 */     // GIR_Coverage, 9758,
     /* 1312657 */     GIR_EraseRootFromParent_Done,
     /* 1312658 */   // Label 18818: @1312658
     /* 1312658 */   GIM_Try, /*On fail goto*//*Label 18819*/ GIMT_Encode4(1312742), // Rule ID 9759 //
     /* 1312663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1312683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312716 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1312719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312741 */     // GIR_Coverage, 9759,
     /* 1312741 */     GIR_EraseRootFromParent_Done,
     /* 1312742 */   // Label 18819: @1312742
     /* 1312742 */   GIM_Try, /*On fail goto*//*Label 18820*/ GIMT_Encode4(1312826), // Rule ID 9762 //
     /* 1312747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1312764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1312767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312800 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312825 */     // GIR_Coverage, 9762,
     /* 1312825 */     GIR_EraseRootFromParent_Done,
     /* 1312826 */   // Label 18820: @1312826
     /* 1312826 */   GIM_Try, /*On fail goto*//*Label 18821*/ GIMT_Encode4(1312910), // Rule ID 9763 //
     /* 1312831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1312848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1312851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312884 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312909 */     // GIR_Coverage, 9763,
     /* 1312909 */     GIR_EraseRootFromParent_Done,
     /* 1312910 */   // Label 18821: @1312910
     /* 1312910 */   GIM_Try, /*On fail goto*//*Label 18822*/ GIMT_Encode4(1312994), // Rule ID 9766 //
     /* 1312915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1312932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1312935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312968 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312993 */     // GIR_Coverage, 9766,
     /* 1312993 */     GIR_EraseRootFromParent_Done,
     /* 1312994 */   // Label 18822: @1312994
     /* 1312994 */   GIM_Try, /*On fail goto*//*Label 18823*/ GIMT_Encode4(1313078), // Rule ID 9767 //
     /* 1312999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1313016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1313019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313052 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1313055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313077 */     // GIR_Coverage, 9767,
     /* 1313077 */     GIR_EraseRootFromParent_Done,
     /* 1313078 */   // Label 18823: @1313078
     /* 1313078 */   GIM_Try, /*On fail goto*//*Label 18824*/ GIMT_Encode4(1313162), // Rule ID 9770 //
     /* 1313083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1313094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1313097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1313100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1313103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1313106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313136 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313161 */     // GIR_Coverage, 9770,
     /* 1313161 */     GIR_EraseRootFromParent_Done,
     /* 1313162 */   // Label 18824: @1313162
     /* 1313162 */   GIM_Try, /*On fail goto*//*Label 18825*/ GIMT_Encode4(1313246), // Rule ID 9771 //
     /* 1313167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1313178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1313181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1313184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1313187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1313190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313220 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313245 */     // GIR_Coverage, 9771,
     /* 1313245 */     GIR_EraseRootFromParent_Done,
     /* 1313246 */   // Label 18825: @1313246
     /* 1313246 */   GIM_Try, /*On fail goto*//*Label 18826*/ GIMT_Encode4(1313330), // Rule ID 9774 //
     /* 1313251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1313262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1313265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1313268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1313271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1313274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313304 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313329 */     // GIR_Coverage, 9774,
     /* 1313329 */     GIR_EraseRootFromParent_Done,
     /* 1313330 */   // Label 18826: @1313330
     /* 1313330 */   GIM_Try, /*On fail goto*//*Label 18827*/ GIMT_Encode4(1313414), // Rule ID 9775 //
     /* 1313335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1313346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1313349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1313352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1313355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1313358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313388 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313413 */     // GIR_Coverage, 9775,
     /* 1313413 */     GIR_EraseRootFromParent_Done,
     /* 1313414 */   // Label 18827: @1313414
     /* 1313414 */   GIM_Try, /*On fail goto*//*Label 18828*/ GIMT_Encode4(1313498), // Rule ID 9778 //
     /* 1313419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1313430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1313433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1313436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1313439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313472 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313497 */     // GIR_Coverage, 9778,
     /* 1313497 */     GIR_EraseRootFromParent_Done,
     /* 1313498 */   // Label 18828: @1313498
     /* 1313498 */   GIM_Try, /*On fail goto*//*Label 18829*/ GIMT_Encode4(1313582), // Rule ID 9779 //
     /* 1313503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1313514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1313517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1313520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1313523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313556 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313581 */     // GIR_Coverage, 9779,
     /* 1313581 */     GIR_EraseRootFromParent_Done,
     /* 1313582 */   // Label 18829: @1313582
     /* 1313582 */   GIM_Try, /*On fail goto*//*Label 18830*/ GIMT_Encode4(1313666), // Rule ID 9782 //
     /* 1313587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1313590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1313604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1313607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313640 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1313661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313665 */     // GIR_Coverage, 9782,
     /* 1313665 */     GIR_EraseRootFromParent_Done,
     /* 1313666 */   // Label 18830: @1313666
     /* 1313666 */   GIM_Try, /*On fail goto*//*Label 18831*/ GIMT_Encode4(1313750), // Rule ID 9783 //
     /* 1313671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1313674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1313688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1313691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313724 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1313745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313749 */     // GIR_Coverage, 9783,
     /* 1313749 */     GIR_EraseRootFromParent_Done,
     /* 1313750 */   // Label 18831: @1313750
     /* 1313750 */   GIM_Try, /*On fail goto*//*Label 18832*/ GIMT_Encode4(1313834), // Rule ID 9786 //
     /* 1313755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1313766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1313769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1313772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1313775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1313778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313808 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1313811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313833 */     // GIR_Coverage, 9786,
     /* 1313833 */     GIR_EraseRootFromParent_Done,
     /* 1313834 */   // Label 18832: @1313834
     /* 1313834 */   GIM_Try, /*On fail goto*//*Label 18833*/ GIMT_Encode4(1313918), // Rule ID 9787 //
     /* 1313839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1313850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1313853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1313856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1313859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1313862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313892 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1313895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313917 */     // GIR_Coverage, 9787,
     /* 1313917 */     GIR_EraseRootFromParent_Done,
     /* 1313918 */   // Label 18833: @1313918
     /* 1313918 */   GIM_Try, /*On fail goto*//*Label 18834*/ GIMT_Encode4(1314002), // Rule ID 9790 //
     /* 1313923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1313934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1313937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1313940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1313943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1313946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313976 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1313979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314001 */     // GIR_Coverage, 9790,
     /* 1314001 */     GIR_EraseRootFromParent_Done,
     /* 1314002 */   // Label 18834: @1314002
     /* 1314002 */   GIM_Try, /*On fail goto*//*Label 18835*/ GIMT_Encode4(1314086), // Rule ID 9791 //
     /* 1314007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1314024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1314027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314060 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314085 */     // GIR_Coverage, 9791,
     /* 1314085 */     GIR_EraseRootFromParent_Done,
     /* 1314086 */   // Label 18835: @1314086
     /* 1314086 */   GIM_Try, /*On fail goto*//*Label 18836*/ GIMT_Encode4(1314170), // Rule ID 9794 //
     /* 1314091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1314102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1314105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1314108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1314111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1314114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314144 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314169 */     // GIR_Coverage, 9794,
     /* 1314169 */     GIR_EraseRootFromParent_Done,
     /* 1314170 */   // Label 18836: @1314170
     /* 1314170 */   GIM_Try, /*On fail goto*//*Label 18837*/ GIMT_Encode4(1314254), // Rule ID 9795 //
     /* 1314175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1314186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1314189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1314192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1314195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1314198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314228 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314253 */     // GIR_Coverage, 9795,
     /* 1314253 */     GIR_EraseRootFromParent_Done,
     /* 1314254 */   // Label 18837: @1314254
     /* 1314254 */   GIM_Try, /*On fail goto*//*Label 18838*/ GIMT_Encode4(1314338), // Rule ID 9798 //
     /* 1314259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1314276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1314279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314312 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314337 */     // GIR_Coverage, 9798,
     /* 1314337 */     GIR_EraseRootFromParent_Done,
     /* 1314338 */   // Label 18838: @1314338
     /* 1314338 */   GIM_Try, /*On fail goto*//*Label 18839*/ GIMT_Encode4(1314422), // Rule ID 9799 //
     /* 1314343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1314360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1314363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314396 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314421 */     // GIR_Coverage, 9799,
     /* 1314421 */     GIR_EraseRootFromParent_Done,
     /* 1314422 */   // Label 18839: @1314422
     /* 1314422 */   GIM_Try, /*On fail goto*//*Label 18840*/ GIMT_Encode4(1314506), // Rule ID 9802 //
     /* 1314427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1314444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1314447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314480 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314505 */     // GIR_Coverage, 9802,
     /* 1314505 */     GIR_EraseRootFromParent_Done,
     /* 1314506 */   // Label 18840: @1314506
     /* 1314506 */   GIM_Try, /*On fail goto*//*Label 18841*/ GIMT_Encode4(1314590), // Rule ID 9803 //
     /* 1314511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1314528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1314531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314564 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314589 */     // GIR_Coverage, 9803,
     /* 1314589 */     GIR_EraseRootFromParent_Done,
     /* 1314590 */   // Label 18841: @1314590
     /* 1314590 */   GIM_Try, /*On fail goto*//*Label 18842*/ GIMT_Encode4(1314674), // Rule ID 9806 //
     /* 1314595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1314615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314648 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314673 */     // GIR_Coverage, 9806,
     /* 1314673 */     GIR_EraseRootFromParent_Done,
     /* 1314674 */   // Label 18842: @1314674
     /* 1314674 */   GIM_Try, /*On fail goto*//*Label 18843*/ GIMT_Encode4(1314758), // Rule ID 9807 //
     /* 1314679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1314699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314732 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314757 */     // GIR_Coverage, 9807,
     /* 1314757 */     GIR_EraseRootFromParent_Done,
     /* 1314758 */   // Label 18843: @1314758
     /* 1314758 */   GIM_Try, /*On fail goto*//*Label 18844*/ GIMT_Encode4(1314842), // Rule ID 9810 //
     /* 1314763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1314780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1314783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314816 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314841 */     // GIR_Coverage, 9810,
     /* 1314841 */     GIR_EraseRootFromParent_Done,
     /* 1314842 */   // Label 18844: @1314842
     /* 1314842 */   GIM_Try, /*On fail goto*//*Label 18845*/ GIMT_Encode4(1314926), // Rule ID 9811 //
     /* 1314847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1314864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1314867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314900 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314925 */     // GIR_Coverage, 9811,
     /* 1314925 */     GIR_EraseRootFromParent_Done,
     /* 1314926 */   // Label 18845: @1314926
     /* 1314926 */   GIM_Try, /*On fail goto*//*Label 18846*/ GIMT_Encode4(1315010), // Rule ID 9814 //
     /* 1314931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1314948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1314951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314984 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315009 */     // GIR_Coverage, 9814,
     /* 1315009 */     GIR_EraseRootFromParent_Done,
     /* 1315010 */   // Label 18846: @1315010
     /* 1315010 */   GIM_Try, /*On fail goto*//*Label 18847*/ GIMT_Encode4(1315094), // Rule ID 9815 //
     /* 1315015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1315032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1315035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315068 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1315071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315093 */     // GIR_Coverage, 9815,
     /* 1315093 */     GIR_EraseRootFromParent_Done,
     /* 1315094 */   // Label 18847: @1315094
     /* 1315094 */   GIM_Try, /*On fail goto*//*Label 18848*/ GIMT_Encode4(1315178), // Rule ID 9818 //
     /* 1315099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1315110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1315113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1315116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1315119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1315122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315152 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1315155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315177 */     // GIR_Coverage, 9818,
     /* 1315177 */     GIR_EraseRootFromParent_Done,
     /* 1315178 */   // Label 18848: @1315178
     /* 1315178 */   GIM_Try, /*On fail goto*//*Label 18849*/ GIMT_Encode4(1315262), // Rule ID 9819 //
     /* 1315183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1315194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1315197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1315200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1315203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1315206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315236 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1315239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315261 */     // GIR_Coverage, 9819,
     /* 1315261 */     GIR_EraseRootFromParent_Done,
     /* 1315262 */   // Label 18849: @1315262
     /* 1315262 */   GIM_Try, /*On fail goto*//*Label 18850*/ GIMT_Encode4(1315346), // Rule ID 9822 //
     /* 1315267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1315284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1315287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315320 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1315323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315345 */     // GIR_Coverage, 9822,
     /* 1315345 */     GIR_EraseRootFromParent_Done,
     /* 1315346 */   // Label 18850: @1315346
     /* 1315346 */   GIM_Try, /*On fail goto*//*Label 18851*/ GIMT_Encode4(1315430), // Rule ID 9823 //
     /* 1315351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1315368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1315371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315404 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1315407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315429 */     // GIR_Coverage, 9823,
     /* 1315429 */     GIR_EraseRootFromParent_Done,
     /* 1315430 */   // Label 18851: @1315430
     /* 1315430 */   GIM_Try, /*On fail goto*//*Label 18852*/ GIMT_Encode4(1315514), // Rule ID 9826 //
     /* 1315435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1315452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1315455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315488 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1315491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315513 */     // GIR_Coverage, 9826,
     /* 1315513 */     GIR_EraseRootFromParent_Done,
     /* 1315514 */   // Label 18852: @1315514
     /* 1315514 */   GIM_Try, /*On fail goto*//*Label 18853*/ GIMT_Encode4(1315598), // Rule ID 9827 //
     /* 1315519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1315536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1315539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1315575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315597 */     // GIR_Coverage, 9827,
     /* 1315597 */     GIR_EraseRootFromParent_Done,
     /* 1315598 */   // Label 18853: @1315598
     /* 1315598 */   GIM_Try, /*On fail goto*//*Label 18854*/ GIMT_Encode4(1315682), // Rule ID 9830 //
     /* 1315603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1315623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315656 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1315659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315681 */     // GIR_Coverage, 9830,
     /* 1315681 */     GIR_EraseRootFromParent_Done,
     /* 1315682 */   // Label 18854: @1315682
     /* 1315682 */   GIM_Try, /*On fail goto*//*Label 18855*/ GIMT_Encode4(1315766), // Rule ID 9831 //
     /* 1315687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1315707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1315743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315765 */     // GIR_Coverage, 9831,
     /* 1315765 */     GIR_EraseRootFromParent_Done,
     /* 1315766 */   // Label 18855: @1315766
     /* 1315766 */   GIM_Try, /*On fail goto*//*Label 18856*/ GIMT_Encode4(1315850), // Rule ID 9834 //
     /* 1315771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1315788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1315791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315824 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1315827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315849 */     // GIR_Coverage, 9834,
     /* 1315849 */     GIR_EraseRootFromParent_Done,
     /* 1315850 */   // Label 18856: @1315850
     /* 1315850 */   GIM_Try, /*On fail goto*//*Label 18857*/ GIMT_Encode4(1315934), // Rule ID 9835 //
     /* 1315855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1315872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1315875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315908 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1315911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315933 */     // GIR_Coverage, 9835,
     /* 1315933 */     GIR_EraseRootFromParent_Done,
     /* 1315934 */   // Label 18857: @1315934
     /* 1315934 */   GIM_Try, /*On fail goto*//*Label 18858*/ GIMT_Encode4(1316018), // Rule ID 9838 //
     /* 1315939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1315956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1315959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315992 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1315995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316017 */     // GIR_Coverage, 9838,
     /* 1316017 */     GIR_EraseRootFromParent_Done,
     /* 1316018 */   // Label 18858: @1316018
     /* 1316018 */   GIM_Try, /*On fail goto*//*Label 18859*/ GIMT_Encode4(1316102), // Rule ID 9839 //
     /* 1316023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1316040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1316043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316076 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1316079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316101 */     // GIR_Coverage, 9839,
     /* 1316101 */     GIR_EraseRootFromParent_Done,
     /* 1316102 */   // Label 18859: @1316102
     /* 1316102 */   GIM_Try, /*On fail goto*//*Label 18860*/ GIMT_Encode4(1316186), // Rule ID 9842 //
     /* 1316107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1316124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1316127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316160 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316185 */     // GIR_Coverage, 9842,
     /* 1316185 */     GIR_EraseRootFromParent_Done,
     /* 1316186 */   // Label 18860: @1316186
     /* 1316186 */   GIM_Try, /*On fail goto*//*Label 18861*/ GIMT_Encode4(1316270), // Rule ID 9843 //
     /* 1316191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1316208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1316211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316269 */     // GIR_Coverage, 9843,
     /* 1316269 */     GIR_EraseRootFromParent_Done,
     /* 1316270 */   // Label 18861: @1316270
     /* 1316270 */   GIM_Try, /*On fail goto*//*Label 18862*/ GIMT_Encode4(1316354), // Rule ID 9846 //
     /* 1316275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1316292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1316295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316328 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1316331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316353 */     // GIR_Coverage, 9846,
     /* 1316353 */     GIR_EraseRootFromParent_Done,
     /* 1316354 */   // Label 18862: @1316354
     /* 1316354 */   GIM_Try, /*On fail goto*//*Label 18863*/ GIMT_Encode4(1316438), // Rule ID 9847 //
     /* 1316359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1316376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1316379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316412 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1316415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316437 */     // GIR_Coverage, 9847,
     /* 1316437 */     GIR_EraseRootFromParent_Done,
     /* 1316438 */   // Label 18863: @1316438
     /* 1316438 */   GIM_Try, /*On fail goto*//*Label 18864*/ GIMT_Encode4(1316522), // Rule ID 9850 //
     /* 1316443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1316460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1316463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316496 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316521 */     // GIR_Coverage, 9850,
     /* 1316521 */     GIR_EraseRootFromParent_Done,
     /* 1316522 */   // Label 18864: @1316522
     /* 1316522 */   GIM_Try, /*On fail goto*//*Label 18865*/ GIMT_Encode4(1316606), // Rule ID 9851 //
     /* 1316527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1316544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1316547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316605 */     // GIR_Coverage, 9851,
     /* 1316605 */     GIR_EraseRootFromParent_Done,
     /* 1316606 */   // Label 18865: @1316606
     /* 1316606 */   GIM_Try, /*On fail goto*//*Label 18866*/ GIMT_Encode4(1316690), // Rule ID 9854 //
     /* 1316611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1316628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1316631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316664 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316689 */     // GIR_Coverage, 9854,
     /* 1316689 */     GIR_EraseRootFromParent_Done,
     /* 1316690 */   // Label 18866: @1316690
     /* 1316690 */   GIM_Try, /*On fail goto*//*Label 18867*/ GIMT_Encode4(1316774), // Rule ID 9855 //
     /* 1316695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1316712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1316715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316748 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316773 */     // GIR_Coverage, 9855,
     /* 1316773 */     GIR_EraseRootFromParent_Done,
     /* 1316774 */   // Label 18867: @1316774
     /* 1316774 */   GIM_Try, /*On fail goto*//*Label 18868*/ GIMT_Encode4(1316858), // Rule ID 9858 //
     /* 1316779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1316796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1316799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316832 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316857 */     // GIR_Coverage, 9858,
     /* 1316857 */     GIR_EraseRootFromParent_Done,
     /* 1316858 */   // Label 18868: @1316858
     /* 1316858 */   GIM_Try, /*On fail goto*//*Label 18869*/ GIMT_Encode4(1316942), // Rule ID 9859 //
     /* 1316863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1316880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1316883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316916 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316941 */     // GIR_Coverage, 9859,
     /* 1316941 */     GIR_EraseRootFromParent_Done,
     /* 1316942 */   // Label 18869: @1316942
     /* 1316942 */   GIM_Try, /*On fail goto*//*Label 18870*/ GIMT_Encode4(1317026), // Rule ID 9862 //
     /* 1316947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1316964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1316967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317000 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1317003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317025 */     // GIR_Coverage, 9862,
     /* 1317025 */     GIR_EraseRootFromParent_Done,
     /* 1317026 */   // Label 18870: @1317026
     /* 1317026 */   GIM_Try, /*On fail goto*//*Label 18871*/ GIMT_Encode4(1317110), // Rule ID 9863 //
     /* 1317031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1317042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1317045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1317048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1317051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1317054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317084 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1317087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317109 */     // GIR_Coverage, 9863,
     /* 1317109 */     GIR_EraseRootFromParent_Done,
     /* 1317110 */   // Label 18871: @1317110
     /* 1317110 */   GIM_Try, /*On fail goto*//*Label 18872*/ GIMT_Encode4(1317194), // Rule ID 9866 //
     /* 1317115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1317126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1317129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1317132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1317135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1317138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317168 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1317171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1317189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317193 */     // GIR_Coverage, 9866,
     /* 1317193 */     GIR_EraseRootFromParent_Done,
     /* 1317194 */   // Label 18872: @1317194
     /* 1317194 */   GIM_Try, /*On fail goto*//*Label 18873*/ GIMT_Encode4(1317278), // Rule ID 9867 //
     /* 1317199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1317210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1317213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1317216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1317219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1317222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317252 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1317255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1317273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317277 */     // GIR_Coverage, 9867,
     /* 1317277 */     GIR_EraseRootFromParent_Done,
     /* 1317278 */   // Label 18873: @1317278
     /* 1317278 */   GIM_Try, /*On fail goto*//*Label 18874*/ GIMT_Encode4(1317362), // Rule ID 9870 //
     /* 1317283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1317286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1317294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1317297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1317300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1317303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1317306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317336 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1317339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1317357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317361 */     // GIR_Coverage, 9870,
     /* 1317361 */     GIR_EraseRootFromParent_Done,
     /* 1317362 */   // Label 18874: @1317362
     /* 1317362 */   GIM_Try, /*On fail goto*//*Label 18875*/ GIMT_Encode4(1317446), // Rule ID 9871 //
     /* 1317367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1317370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1317378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1317381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1317384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1317387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1317390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317420 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1317423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1317441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317445 */     // GIR_Coverage, 9871,
     /* 1317445 */     GIR_EraseRootFromParent_Done,
     /* 1317446 */   // Label 18875: @1317446
     /* 1317446 */   GIM_Try, /*On fail goto*//*Label 18876*/ GIMT_Encode4(1317530), // Rule ID 9874 //
     /* 1317451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1317468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1317471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317504 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1317507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317529 */     // GIR_Coverage, 9874,
     /* 1317529 */     GIR_EraseRootFromParent_Done,
     /* 1317530 */   // Label 18876: @1317530
     /* 1317530 */   GIM_Try, /*On fail goto*//*Label 18877*/ GIMT_Encode4(1317614), // Rule ID 9875 //
     /* 1317535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1317552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1317555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317588 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1317591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317613 */     // GIR_Coverage, 9875,
     /* 1317613 */     GIR_EraseRootFromParent_Done,
     /* 1317614 */   // Label 18877: @1317614
     /* 1317614 */   GIM_Try, /*On fail goto*//*Label 18878*/ GIMT_Encode4(1317698), // Rule ID 9878 //
     /* 1317619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1317636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1317639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317672 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1317675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317697 */     // GIR_Coverage, 9878,
     /* 1317697 */     GIR_EraseRootFromParent_Done,
     /* 1317698 */   // Label 18878: @1317698
     /* 1317698 */   GIM_Try, /*On fail goto*//*Label 18879*/ GIMT_Encode4(1317782), // Rule ID 9879 //
     /* 1317703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1317720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1317723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317756 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1317759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317781 */     // GIR_Coverage, 9879,
     /* 1317781 */     GIR_EraseRootFromParent_Done,
     /* 1317782 */   // Label 18879: @1317782
     /* 1317782 */   GIM_Try, /*On fail goto*//*Label 18880*/ GIMT_Encode4(1317866), // Rule ID 9882 //
     /* 1317787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1317798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1317801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1317804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1317807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1317810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317840 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1317843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317865 */     // GIR_Coverage, 9882,
     /* 1317865 */     GIR_EraseRootFromParent_Done,
     /* 1317866 */   // Label 18880: @1317866
     /* 1317866 */   GIM_Try, /*On fail goto*//*Label 18881*/ GIMT_Encode4(1317950), // Rule ID 9883 //
     /* 1317871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1317882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1317885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1317888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1317891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1317894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317924 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1317927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317949 */     // GIR_Coverage, 9883,
     /* 1317949 */     GIR_EraseRootFromParent_Done,
     /* 1317950 */   // Label 18881: @1317950
     /* 1317950 */   GIM_Try, /*On fail goto*//*Label 18882*/ GIMT_Encode4(1318034), // Rule ID 9886 //
     /* 1317955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1317966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1317969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1317972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1317975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1317978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318008 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318033 */     // GIR_Coverage, 9886,
     /* 1318033 */     GIR_EraseRootFromParent_Done,
     /* 1318034 */   // Label 18882: @1318034
     /* 1318034 */   GIM_Try, /*On fail goto*//*Label 18883*/ GIMT_Encode4(1318118), // Rule ID 9887 //
     /* 1318039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1318056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1318059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318092 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318117 */     // GIR_Coverage, 9887,
     /* 1318117 */     GIR_EraseRootFromParent_Done,
     /* 1318118 */   // Label 18883: @1318118
     /* 1318118 */   GIM_Try, /*On fail goto*//*Label 18884*/ GIMT_Encode4(1318202), // Rule ID 9890 //
     /* 1318123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1318140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1318143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318176 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318201 */     // GIR_Coverage, 9890,
     /* 1318201 */     GIR_EraseRootFromParent_Done,
     /* 1318202 */   // Label 18884: @1318202
     /* 1318202 */   GIM_Try, /*On fail goto*//*Label 18885*/ GIMT_Encode4(1318286), // Rule ID 9891 //
     /* 1318207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1318224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1318227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318260 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318285 */     // GIR_Coverage, 9891,
     /* 1318285 */     GIR_EraseRootFromParent_Done,
     /* 1318286 */   // Label 18885: @1318286
     /* 1318286 */   GIM_Try, /*On fail goto*//*Label 18886*/ GIMT_Encode4(1318370), // Rule ID 9894 //
     /* 1318291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1318302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1318305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1318308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1318311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1318314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318344 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318369 */     // GIR_Coverage, 9894,
     /* 1318369 */     GIR_EraseRootFromParent_Done,
     /* 1318370 */   // Label 18886: @1318370
     /* 1318370 */   GIM_Try, /*On fail goto*//*Label 18887*/ GIMT_Encode4(1318454), // Rule ID 9895 //
     /* 1318375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1318386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1318389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1318392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1318395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1318398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318428 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318453 */     // GIR_Coverage, 9895,
     /* 1318453 */     GIR_EraseRootFromParent_Done,
     /* 1318454 */   // Label 18887: @1318454
     /* 1318454 */   GIM_Try, /*On fail goto*//*Label 18888*/ GIMT_Encode4(1318538), // Rule ID 9898 //
     /* 1318459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1318476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1318479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318537 */     // GIR_Coverage, 9898,
     /* 1318537 */     GIR_EraseRootFromParent_Done,
     /* 1318538 */   // Label 18888: @1318538
     /* 1318538 */   GIM_Try, /*On fail goto*//*Label 18889*/ GIMT_Encode4(1318622), // Rule ID 9899 //
     /* 1318543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1318560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1318563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318596 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318621 */     // GIR_Coverage, 9899,
     /* 1318621 */     GIR_EraseRootFromParent_Done,
     /* 1318622 */   // Label 18889: @1318622
     /* 1318622 */   GIM_Try, /*On fail goto*//*Label 18890*/ GIMT_Encode4(1318706), // Rule ID 9902 //
     /* 1318627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1318644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1318647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318680 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318705 */     // GIR_Coverage, 9902,
     /* 1318705 */     GIR_EraseRootFromParent_Done,
     /* 1318706 */   // Label 18890: @1318706
     /* 1318706 */   GIM_Try, /*On fail goto*//*Label 18891*/ GIMT_Encode4(1318790), // Rule ID 9903 //
     /* 1318711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1318728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1318731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318764 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318789 */     // GIR_Coverage, 9903,
     /* 1318789 */     GIR_EraseRootFromParent_Done,
     /* 1318790 */   // Label 18891: @1318790
     /* 1318790 */   GIM_Try, /*On fail goto*//*Label 18892*/ GIMT_Encode4(1318874), // Rule ID 9906 //
     /* 1318795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1318812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1318815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318848 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318873 */     // GIR_Coverage, 9906,
     /* 1318873 */     GIR_EraseRootFromParent_Done,
     /* 1318874 */   // Label 18892: @1318874
     /* 1318874 */   GIM_Try, /*On fail goto*//*Label 18893*/ GIMT_Encode4(1318958), // Rule ID 9907 //
     /* 1318879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1318896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1318899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318932 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318957 */     // GIR_Coverage, 9907,
     /* 1318957 */     GIR_EraseRootFromParent_Done,
     /* 1318958 */   // Label 18893: @1318958
     /* 1318958 */   GIM_Try, /*On fail goto*//*Label 18894*/ GIMT_Encode4(1319042), // Rule ID 9910 //
     /* 1318963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1318966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1318974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1318977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1318980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1318983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1318986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319016 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1319019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319041 */     // GIR_Coverage, 9910,
     /* 1319041 */     GIR_EraseRootFromParent_Done,
     /* 1319042 */   // Label 18894: @1319042
     /* 1319042 */   GIM_Try, /*On fail goto*//*Label 18895*/ GIMT_Encode4(1319126), // Rule ID 9911 //
     /* 1319047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1319050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1319058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1319061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1319064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1319067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319100 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1319103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319125 */     // GIR_Coverage, 9911,
     /* 1319125 */     GIR_EraseRootFromParent_Done,
     /* 1319126 */   // Label 18895: @1319126
     /* 1319126 */   GIM_Try, /*On fail goto*//*Label 18896*/ GIMT_Encode4(1319210), // Rule ID 9914 //
     /* 1319131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1319134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1319142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1319145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1319148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1319151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319184 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1319187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319209 */     // GIR_Coverage, 9914,
     /* 1319209 */     GIR_EraseRootFromParent_Done,
     /* 1319210 */   // Label 18896: @1319210
     /* 1319210 */   GIM_Try, /*On fail goto*//*Label 18897*/ GIMT_Encode4(1319294), // Rule ID 9915 //
     /* 1319215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1319218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1319226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1319229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1319232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1319235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319268 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1319271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319293 */     // GIR_Coverage, 9915,
     /* 1319293 */     GIR_EraseRootFromParent_Done,
     /* 1319294 */   // Label 18897: @1319294
     /* 1319294 */   GIM_Try, /*On fail goto*//*Label 18898*/ GIMT_Encode4(1319378), // Rule ID 9918 //
     /* 1319299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1319302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1319310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1319313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1319316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1319319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1319322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319352 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1319355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319377 */     // GIR_Coverage, 9918,
     /* 1319377 */     GIR_EraseRootFromParent_Done,
     /* 1319378 */   // Label 18898: @1319378
     /* 1319378 */   GIM_Try, /*On fail goto*//*Label 18899*/ GIMT_Encode4(1319462), // Rule ID 9919 //
     /* 1319383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1319386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1319394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1319397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1319400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1319403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1319406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319436 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1319439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319461 */     // GIR_Coverage, 9919,
     /* 1319461 */     GIR_EraseRootFromParent_Done,
     /* 1319462 */   // Label 18899: @1319462
     /* 1319462 */   GIM_Try, /*On fail goto*//*Label 18900*/ GIMT_Encode4(1319543), // Rule ID 13860 //
     /* 1319467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1319478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1319481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1319484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1319487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319520 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1319520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1319523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319542 */     // GIR_Coverage, 13860,
     /* 1319542 */     GIR_EraseRootFromParent_Done,
     /* 1319543 */   // Label 18900: @1319543
     /* 1319543 */   GIM_Try, /*On fail goto*//*Label 18901*/ GIMT_Encode4(1319624), // Rule ID 13861 //
     /* 1319548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1319559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1319562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1319565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1319568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319601 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1319601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1319604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319623 */     // GIR_Coverage, 13861,
     /* 1319623 */     GIR_EraseRootFromParent_Done,
     /* 1319624 */   // Label 18901: @1319624
     /* 1319624 */   GIM_Try, /*On fail goto*//*Label 18902*/ GIMT_Encode4(1319705), // Rule ID 13862 //
     /* 1319629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1319640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1319643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1319646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1319649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1319682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1319685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319704 */     // GIR_Coverage, 13862,
     /* 1319704 */     GIR_EraseRootFromParent_Done,
     /* 1319705 */   // Label 18902: @1319705
     /* 1319705 */   GIM_Try, /*On fail goto*//*Label 18903*/ GIMT_Encode4(1319786), // Rule ID 13863 //
     /* 1319710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1319721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1319724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1319727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1319730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319763 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1319763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1319766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319785 */     // GIR_Coverage, 13863,
     /* 1319785 */     GIR_EraseRootFromParent_Done,
     /* 1319786 */   // Label 18903: @1319786
     /* 1319786 */   GIM_Try, /*On fail goto*//*Label 18904*/ GIMT_Encode4(1319867), // Rule ID 13864 //
     /* 1319791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1319802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1319805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1319808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1319811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319844 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1319844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319866 */     // GIR_Coverage, 13864,
     /* 1319866 */     GIR_EraseRootFromParent_Done,
     /* 1319867 */   // Label 18904: @1319867
     /* 1319867 */   GIM_Try, /*On fail goto*//*Label 18905*/ GIMT_Encode4(1319948), // Rule ID 13865 //
     /* 1319872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1319883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1319886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1319889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1319892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319925 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1319925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319947 */     // GIR_Coverage, 13865,
     /* 1319947 */     GIR_EraseRootFromParent_Done,
     /* 1319948 */   // Label 18905: @1319948
     /* 1319948 */   GIM_Try, /*On fail goto*//*Label 18906*/ GIMT_Encode4(1320029), // Rule ID 13866 //
     /* 1319953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1319964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1319967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1319970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1319973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320006 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1320006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1320009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320028 */     // GIR_Coverage, 13866,
     /* 1320028 */     GIR_EraseRootFromParent_Done,
     /* 1320029 */   // Label 18906: @1320029
     /* 1320029 */   GIM_Try, /*On fail goto*//*Label 18907*/ GIMT_Encode4(1320110), // Rule ID 13867 //
     /* 1320034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1320045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1320048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1320051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1320054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320087 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1320087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1320090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320109 */     // GIR_Coverage, 13867,
     /* 1320109 */     GIR_EraseRootFromParent_Done,
     /* 1320110 */   // Label 18907: @1320110
     /* 1320110 */   GIM_Try, /*On fail goto*//*Label 18908*/ GIMT_Encode4(1320191), // Rule ID 13868 //
     /* 1320115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1320126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1320129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1320132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1320135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320168 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1320168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1320171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320190 */     // GIR_Coverage, 13868,
     /* 1320190 */     GIR_EraseRootFromParent_Done,
     /* 1320191 */   // Label 18908: @1320191
     /* 1320191 */   GIM_Try, /*On fail goto*//*Label 18909*/ GIMT_Encode4(1320272), // Rule ID 13869 //
     /* 1320196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1320207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1320210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1320213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1320216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320249 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1320249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1320252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320271 */     // GIR_Coverage, 13869,
     /* 1320271 */     GIR_EraseRootFromParent_Done,
     /* 1320272 */   // Label 18909: @1320272
     /* 1320272 */   GIM_Try, /*On fail goto*//*Label 18910*/ GIMT_Encode4(1320353), // Rule ID 13870 //
     /* 1320277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1320288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1320291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1320294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1320297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320330 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1320330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1320333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320352 */     // GIR_Coverage, 13870,
     /* 1320352 */     GIR_EraseRootFromParent_Done,
     /* 1320353 */   // Label 18910: @1320353
     /* 1320353 */   GIM_Try, /*On fail goto*//*Label 18911*/ GIMT_Encode4(1320434), // Rule ID 13871 //
     /* 1320358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1320369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1320372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1320375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1320378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320411 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1320411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1320414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320433 */     // GIR_Coverage, 13871,
     /* 1320433 */     GIR_EraseRootFromParent_Done,
     /* 1320434 */   // Label 18911: @1320434
     /* 1320434 */   GIM_Try, /*On fail goto*//*Label 18912*/ GIMT_Encode4(1320515), // Rule ID 13872 //
     /* 1320439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1320450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1320453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1320456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1320459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320492 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1320492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320514 */     // GIR_Coverage, 13872,
     /* 1320514 */     GIR_EraseRootFromParent_Done,
     /* 1320515 */   // Label 18912: @1320515
     /* 1320515 */   GIM_Try, /*On fail goto*//*Label 18913*/ GIMT_Encode4(1320596), // Rule ID 13873 //
     /* 1320520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1320531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1320534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1320537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1320540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320573 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1320573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320595 */     // GIR_Coverage, 13873,
     /* 1320595 */     GIR_EraseRootFromParent_Done,
     /* 1320596 */   // Label 18913: @1320596
     /* 1320596 */   GIM_Try, /*On fail goto*//*Label 18914*/ GIMT_Encode4(1320677), // Rule ID 13874 //
     /* 1320601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1320612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1320615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1320621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320654 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1320654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320676 */     // GIR_Coverage, 13874,
     /* 1320676 */     GIR_EraseRootFromParent_Done,
     /* 1320677 */   // Label 18914: @1320677
     /* 1320677 */   GIM_Try, /*On fail goto*//*Label 18915*/ GIMT_Encode4(1320758), // Rule ID 13875 //
     /* 1320682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1320693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1320696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1320702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320735 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1320735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320757 */     // GIR_Coverage, 13875,
     /* 1320757 */     GIR_EraseRootFromParent_Done,
     /* 1320758 */   // Label 18915: @1320758
     /* 1320758 */   GIM_Try, /*On fail goto*//*Label 18916*/ GIMT_Encode4(1320839), // Rule ID 13876 //
     /* 1320763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1320774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1320777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1320783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320816 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1320816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320838 */     // GIR_Coverage, 13876,
     /* 1320838 */     GIR_EraseRootFromParent_Done,
     /* 1320839 */   // Label 18916: @1320839
     /* 1320839 */   GIM_Try, /*On fail goto*//*Label 18917*/ GIMT_Encode4(1320920), // Rule ID 13877 //
     /* 1320844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1320855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1320858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1320864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320897 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1320897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320919 */     // GIR_Coverage, 13877,
     /* 1320919 */     GIR_EraseRootFromParent_Done,
     /* 1320920 */   // Label 18917: @1320920
     /* 1320920 */   GIM_Try, /*On fail goto*//*Label 18918*/ GIMT_Encode4(1321001), // Rule ID 13878 //
     /* 1320925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1320928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1320936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1320939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1320942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1320945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320978 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1320978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321000 */     // GIR_Coverage, 13878,
     /* 1321000 */     GIR_EraseRootFromParent_Done,
     /* 1321001 */   // Label 18918: @1321001
     /* 1321001 */   GIM_Try, /*On fail goto*//*Label 18919*/ GIMT_Encode4(1321082), // Rule ID 13879 //
     /* 1321006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1321009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1321017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1321020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1321023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1321026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1321029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321059 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1321059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1321062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1321080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321081 */     // GIR_Coverage, 13879,
     /* 1321081 */     GIR_EraseRootFromParent_Done,
     /* 1321082 */   // Label 18919: @1321082
     /* 1321082 */   GIM_Try, /*On fail goto*//*Label 18920*/ GIMT_Encode4(1321163), // Rule ID 13880 //
     /* 1321087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1321098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1321101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1321104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1321107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321140 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1321140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321162 */     // GIR_Coverage, 13880,
     /* 1321162 */     GIR_EraseRootFromParent_Done,
     /* 1321163 */   // Label 18920: @1321163
     /* 1321163 */   GIM_Try, /*On fail goto*//*Label 18921*/ GIMT_Encode4(1321244), // Rule ID 13881 //
     /* 1321168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1321179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1321182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1321185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1321188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321221 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1321221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321243 */     // GIR_Coverage, 13881,
     /* 1321243 */     GIR_EraseRootFromParent_Done,
     /* 1321244 */   // Label 18921: @1321244
     /* 1321244 */   GIM_Try, /*On fail goto*//*Label 18922*/ GIMT_Encode4(1321325), // Rule ID 13882 //
     /* 1321249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1321260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1321263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1321266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1321269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321302 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1321302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321324 */     // GIR_Coverage, 13882,
     /* 1321324 */     GIR_EraseRootFromParent_Done,
     /* 1321325 */   // Label 18922: @1321325
     /* 1321325 */   GIM_Try, /*On fail goto*//*Label 18923*/ GIMT_Encode4(1321406), // Rule ID 13883 //
     /* 1321330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1321341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1321344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1321347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1321350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321383 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1321383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321405 */     // GIR_Coverage, 13883,
     /* 1321405 */     GIR_EraseRootFromParent_Done,
     /* 1321406 */   // Label 18923: @1321406
     /* 1321406 */   GIM_Try, /*On fail goto*//*Label 18924*/ GIMT_Encode4(1321487), // Rule ID 13884 //
     /* 1321411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1321422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1321425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1321428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1321431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1321434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321464 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1321464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321486 */     // GIR_Coverage, 13884,
     /* 1321486 */     GIR_EraseRootFromParent_Done,
     /* 1321487 */   // Label 18924: @1321487
     /* 1321487 */   GIM_Try, /*On fail goto*//*Label 18925*/ GIMT_Encode4(1321568), // Rule ID 13885 //
     /* 1321492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1321503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1321506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1321509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1321512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1321515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321545 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1321545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321567 */     // GIR_Coverage, 13885,
     /* 1321567 */     GIR_EraseRootFromParent_Done,
     /* 1321568 */   // Label 18925: @1321568
     /* 1321568 */   GIM_Try, /*On fail goto*//*Label 18926*/ GIMT_Encode4(1321649), // Rule ID 13886 //
     /* 1321573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1321584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1321587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1321590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1321593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321648 */     // GIR_Coverage, 13886,
     /* 1321648 */     GIR_EraseRootFromParent_Done,
     /* 1321649 */   // Label 18926: @1321649
     /* 1321649 */   GIM_Try, /*On fail goto*//*Label 18927*/ GIMT_Encode4(1321730), // Rule ID 13887 //
     /* 1321654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1321665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1321668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1321671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1321674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1321707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321729 */     // GIR_Coverage, 13887,
     /* 1321729 */     GIR_EraseRootFromParent_Done,
     /* 1321730 */   // Label 18927: @1321730
     /* 1321730 */   GIM_Try, /*On fail goto*//*Label 18928*/ GIMT_Encode4(1321811), // Rule ID 13888 //
     /* 1321735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1321746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1321749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1321752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1321755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321788 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321810 */     // GIR_Coverage, 13888,
     /* 1321810 */     GIR_EraseRootFromParent_Done,
     /* 1321811 */   // Label 18928: @1321811
     /* 1321811 */   GIM_Try, /*On fail goto*//*Label 18929*/ GIMT_Encode4(1321892), // Rule ID 13889 //
     /* 1321816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1321827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1321830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1321833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1321836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321869 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1321869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321891 */     // GIR_Coverage, 13889,
     /* 1321891 */     GIR_EraseRootFromParent_Done,
     /* 1321892 */   // Label 18929: @1321892
     /* 1321892 */   GIM_Try, /*On fail goto*//*Label 18930*/ GIMT_Encode4(1321973), // Rule ID 13890 //
     /* 1321897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1321908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1321911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1321914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1321917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321950 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321972 */     // GIR_Coverage, 13890,
     /* 1321972 */     GIR_EraseRootFromParent_Done,
     /* 1321973 */   // Label 18930: @1321973
     /* 1321973 */   GIM_Try, /*On fail goto*//*Label 18931*/ GIMT_Encode4(1322054), // Rule ID 13891 //
     /* 1321978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1321989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1321992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1321995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1321998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1322001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322031 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1322031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322053 */     // GIR_Coverage, 13891,
     /* 1322053 */     GIR_EraseRootFromParent_Done,
     /* 1322054 */   // Label 18931: @1322054
     /* 1322054 */   GIM_Try, /*On fail goto*//*Label 18932*/ GIMT_Encode4(1322135), // Rule ID 13892 //
     /* 1322059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1322070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1322073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1322076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1322079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1322112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1322115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322134 */     // GIR_Coverage, 13892,
     /* 1322134 */     GIR_EraseRootFromParent_Done,
     /* 1322135 */   // Label 18932: @1322135
     /* 1322135 */   GIM_Try, /*On fail goto*//*Label 18933*/ GIMT_Encode4(1322216), // Rule ID 13893 //
     /* 1322140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1322151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1322154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1322157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1322160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322193 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1322193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1322196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322215 */     // GIR_Coverage, 13893,
     /* 1322215 */     GIR_EraseRootFromParent_Done,
     /* 1322216 */   // Label 18933: @1322216
     /* 1322216 */   GIM_Try, /*On fail goto*//*Label 18934*/ GIMT_Encode4(1322297), // Rule ID 13894 //
     /* 1322221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1322232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1322235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1322238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1322241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322274 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1322274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1322277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322296 */     // GIR_Coverage, 13894,
     /* 1322296 */     GIR_EraseRootFromParent_Done,
     /* 1322297 */   // Label 18934: @1322297
     /* 1322297 */   GIM_Try, /*On fail goto*//*Label 18935*/ GIMT_Encode4(1322378), // Rule ID 13895 //
     /* 1322302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1322313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1322316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1322319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1322322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322355 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1322355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1322358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322377 */     // GIR_Coverage, 13895,
     /* 1322377 */     GIR_EraseRootFromParent_Done,
     /* 1322378 */   // Label 18935: @1322378
     /* 1322378 */   GIM_Try, /*On fail goto*//*Label 18936*/ GIMT_Encode4(1322459), // Rule ID 13896 //
     /* 1322383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1322394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1322397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1322400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1322403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322436 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1322436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322458 */     // GIR_Coverage, 13896,
     /* 1322458 */     GIR_EraseRootFromParent_Done,
     /* 1322459 */   // Label 18936: @1322459
     /* 1322459 */   GIM_Try, /*On fail goto*//*Label 18937*/ GIMT_Encode4(1322540), // Rule ID 13897 //
     /* 1322464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1322475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1322478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1322481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1322484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322517 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1322517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322539 */     // GIR_Coverage, 13897,
     /* 1322539 */     GIR_EraseRootFromParent_Done,
     /* 1322540 */   // Label 18937: @1322540
     /* 1322540 */   GIM_Try, /*On fail goto*//*Label 18938*/ GIMT_Encode4(1322621), // Rule ID 13898 //
     /* 1322545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1322556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1322559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1322562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1322565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1322598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1322601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322620 */     // GIR_Coverage, 13898,
     /* 1322620 */     GIR_EraseRootFromParent_Done,
     /* 1322621 */   // Label 18938: @1322621
     /* 1322621 */   GIM_Try, /*On fail goto*//*Label 18939*/ GIMT_Encode4(1322702), // Rule ID 13899 //
     /* 1322626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1322637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1322640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1322643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1322646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322679 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1322679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1322682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322701 */     // GIR_Coverage, 13899,
     /* 1322701 */     GIR_EraseRootFromParent_Done,
     /* 1322702 */   // Label 18939: @1322702
     /* 1322702 */   GIM_Try, /*On fail goto*//*Label 18940*/ GIMT_Encode4(1322783), // Rule ID 13900 //
     /* 1322707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1322718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1322721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1322724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1322727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322760 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1322760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1322763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322782 */     // GIR_Coverage, 13900,
     /* 1322782 */     GIR_EraseRootFromParent_Done,
     /* 1322783 */   // Label 18940: @1322783
     /* 1322783 */   GIM_Try, /*On fail goto*//*Label 18941*/ GIMT_Encode4(1322864), // Rule ID 13901 //
     /* 1322788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1322799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1322802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1322805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1322808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322841 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1322841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1322844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322863 */     // GIR_Coverage, 13901,
     /* 1322863 */     GIR_EraseRootFromParent_Done,
     /* 1322864 */   // Label 18941: @1322864
     /* 1322864 */   GIM_Try, /*On fail goto*//*Label 18942*/ GIMT_Encode4(1322945), // Rule ID 13902 //
     /* 1322869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1322880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1322883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1322886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1322889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322922 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1322922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322944 */     // GIR_Coverage, 13902,
     /* 1322944 */     GIR_EraseRootFromParent_Done,
     /* 1322945 */   // Label 18942: @1322945
     /* 1322945 */   GIM_Try, /*On fail goto*//*Label 18943*/ GIMT_Encode4(1323026), // Rule ID 13903 //
     /* 1322950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1322961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1322964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1322967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1322970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323003 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1323003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1323006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1323024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323025 */     // GIR_Coverage, 13903,
     /* 1323025 */     GIR_EraseRootFromParent_Done,
     /* 1323026 */   // Label 18943: @1323026
     /* 1323026 */   GIM_Try, /*On fail goto*//*Label 18944*/ GIMT_Encode4(1323107), // Rule ID 13904 //
     /* 1323031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1323042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1323045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1323048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323084 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1323084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1323087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323106 */     // GIR_Coverage, 13904,
     /* 1323106 */     GIR_EraseRootFromParent_Done,
     /* 1323107 */   // Label 18944: @1323107
     /* 1323107 */   GIM_Try, /*On fail goto*//*Label 18945*/ GIMT_Encode4(1323188), // Rule ID 13905 //
     /* 1323112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1323123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1323126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1323129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323165 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1323168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323187 */     // GIR_Coverage, 13905,
     /* 1323187 */     GIR_EraseRootFromParent_Done,
     /* 1323188 */   // Label 18945: @1323188
     /* 1323188 */   GIM_Try, /*On fail goto*//*Label 18946*/ GIMT_Encode4(1323269), // Rule ID 13906 //
     /* 1323193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1323204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1323207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1323210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323246 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1323246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1323249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323268 */     // GIR_Coverage, 13906,
     /* 1323268 */     GIR_EraseRootFromParent_Done,
     /* 1323269 */   // Label 18946: @1323269
     /* 1323269 */   GIM_Try, /*On fail goto*//*Label 18947*/ GIMT_Encode4(1323350), // Rule ID 13907 //
     /* 1323274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1323285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1323288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1323291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323327 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1323330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323349 */     // GIR_Coverage, 13907,
     /* 1323349 */     GIR_EraseRootFromParent_Done,
     /* 1323350 */   // Label 18947: @1323350
     /* 1323350 */   GIM_Try, /*On fail goto*//*Label 18948*/ GIMT_Encode4(1323431), // Rule ID 13908 //
     /* 1323355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1323366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1323369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1323372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323408 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1323408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323430 */     // GIR_Coverage, 13908,
     /* 1323430 */     GIR_EraseRootFromParent_Done,
     /* 1323431 */   // Label 18948: @1323431
     /* 1323431 */   GIM_Try, /*On fail goto*//*Label 18949*/ GIMT_Encode4(1323512), // Rule ID 13909 //
     /* 1323436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1323447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1323450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1323453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323489 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323511 */     // GIR_Coverage, 13909,
     /* 1323511 */     GIR_EraseRootFromParent_Done,
     /* 1323512 */   // Label 18949: @1323512
     /* 1323512 */   GIM_Try, /*On fail goto*//*Label 18950*/ GIMT_Encode4(1323593), // Rule ID 13910 //
     /* 1323517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1323528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1323531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323570 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1323570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1323573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323592 */     // GIR_Coverage, 13910,
     /* 1323592 */     GIR_EraseRootFromParent_Done,
     /* 1323593 */   // Label 18950: @1323593
     /* 1323593 */   GIM_Try, /*On fail goto*//*Label 18951*/ GIMT_Encode4(1323674), // Rule ID 13911 //
     /* 1323598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1323609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1323612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323651 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1323651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1323654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323673 */     // GIR_Coverage, 13911,
     /* 1323673 */     GIR_EraseRootFromParent_Done,
     /* 1323674 */   // Label 18951: @1323674
     /* 1323674 */   GIM_Try, /*On fail goto*//*Label 18952*/ GIMT_Encode4(1323755), // Rule ID 13912 //
     /* 1323679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1323690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1323693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1323696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323732 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1323732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323754 */     // GIR_Coverage, 13912,
     /* 1323754 */     GIR_EraseRootFromParent_Done,
     /* 1323755 */   // Label 18952: @1323755
     /* 1323755 */   GIM_Try, /*On fail goto*//*Label 18953*/ GIMT_Encode4(1323836), // Rule ID 13913 //
     /* 1323760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1323771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1323774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1323777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323813 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1323813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323835 */     // GIR_Coverage, 13913,
     /* 1323835 */     GIR_EraseRootFromParent_Done,
     /* 1323836 */   // Label 18953: @1323836
     /* 1323836 */   GIM_Try, /*On fail goto*//*Label 18954*/ GIMT_Encode4(1323917), // Rule ID 13914 //
     /* 1323841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1323852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1323855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1323858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1323894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323916 */     // GIR_Coverage, 13914,
     /* 1323916 */     GIR_EraseRootFromParent_Done,
     /* 1323917 */   // Label 18954: @1323917
     /* 1323917 */   GIM_Try, /*On fail goto*//*Label 18955*/ GIMT_Encode4(1323998), // Rule ID 13915 //
     /* 1323922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1323933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1323936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1323939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323975 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1323975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323997 */     // GIR_Coverage, 13915,
     /* 1323997 */     GIR_EraseRootFromParent_Done,
     /* 1323998 */   // Label 18955: @1323998
     /* 1323998 */   GIM_Try, /*On fail goto*//*Label 18956*/ GIMT_Encode4(1324079), // Rule ID 13916 //
     /* 1324003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1324014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1324017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1324020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324056 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324078 */     // GIR_Coverage, 13916,
     /* 1324078 */     GIR_EraseRootFromParent_Done,
     /* 1324079 */   // Label 18956: @1324079
     /* 1324079 */   GIM_Try, /*On fail goto*//*Label 18957*/ GIMT_Encode4(1324160), // Rule ID 13917 //
     /* 1324084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1324095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1324098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1324101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324137 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324159 */     // GIR_Coverage, 13917,
     /* 1324159 */     GIR_EraseRootFromParent_Done,
     /* 1324160 */   // Label 18957: @1324160
     /* 1324160 */   GIM_Try, /*On fail goto*//*Label 18958*/ GIMT_Encode4(1324241), // Rule ID 13918 //
     /* 1324165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1324176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1324179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1324182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1324188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324218 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1324218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324240 */     // GIR_Coverage, 13918,
     /* 1324240 */     GIR_EraseRootFromParent_Done,
     /* 1324241 */   // Label 18958: @1324241
     /* 1324241 */   GIM_Try, /*On fail goto*//*Label 18959*/ GIMT_Encode4(1324322), // Rule ID 13919 //
     /* 1324246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1324257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1324260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1324263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1324269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324299 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1324299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324321 */     // GIR_Coverage, 13919,
     /* 1324321 */     GIR_EraseRootFromParent_Done,
     /* 1324322 */   // Label 18959: @1324322
     /* 1324322 */   GIM_Try, /*On fail goto*//*Label 18960*/ GIMT_Encode4(1324403), // Rule ID 13920 //
     /* 1324327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1324338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1324341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1324344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324380 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1324380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324402 */     // GIR_Coverage, 13920,
     /* 1324402 */     GIR_EraseRootFromParent_Done,
     /* 1324403 */   // Label 18960: @1324403
     /* 1324403 */   GIM_Try, /*On fail goto*//*Label 18961*/ GIMT_Encode4(1324484), // Rule ID 13921 //
     /* 1324408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1324419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1324422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1324425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324461 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1324461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324483 */     // GIR_Coverage, 13921,
     /* 1324483 */     GIR_EraseRootFromParent_Done,
     /* 1324484 */   // Label 18961: @1324484
     /* 1324484 */   GIM_Try, /*On fail goto*//*Label 18962*/ GIMT_Encode4(1324565), // Rule ID 13922 //
     /* 1324489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1324492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1324500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1324503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324542 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1324542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324564 */     // GIR_Coverage, 13922,
     /* 1324564 */     GIR_EraseRootFromParent_Done,
     /* 1324565 */   // Label 18962: @1324565
     /* 1324565 */   GIM_Try, /*On fail goto*//*Label 18963*/ GIMT_Encode4(1324646), // Rule ID 13923 //
     /* 1324570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1324573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1324581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1324584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324623 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1324623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324645 */     // GIR_Coverage, 13923,
     /* 1324645 */     GIR_EraseRootFromParent_Done,
     /* 1324646 */   // Label 18963: @1324646
     /* 1324646 */   GIM_Try, /*On fail goto*//*Label 18964*/ GIMT_Encode4(1324727), // Rule ID 13924 //
     /* 1324651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1324662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1324665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1324668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1324707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324726 */     // GIR_Coverage, 13924,
     /* 1324726 */     GIR_EraseRootFromParent_Done,
     /* 1324727 */   // Label 18964: @1324727
     /* 1324727 */   GIM_Try, /*On fail goto*//*Label 18965*/ GIMT_Encode4(1324808), // Rule ID 13925 //
     /* 1324732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1324743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1324746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1324749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324785 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1324788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324807 */     // GIR_Coverage, 13925,
     /* 1324807 */     GIR_EraseRootFromParent_Done,
     /* 1324808 */   // Label 18965: @1324808
     /* 1324808 */   GIM_Try, /*On fail goto*//*Label 18966*/ GIMT_Encode4(1324889), // Rule ID 13926 //
     /* 1324813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1324824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1324827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1324830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1324836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324866 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1324869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324888 */     // GIR_Coverage, 13926,
     /* 1324888 */     GIR_EraseRootFromParent_Done,
     /* 1324889 */   // Label 18966: @1324889
     /* 1324889 */   GIM_Try, /*On fail goto*//*Label 18967*/ GIMT_Encode4(1324970), // Rule ID 13927 //
     /* 1324894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1324905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1324908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1324911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1324917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324947 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1324950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324969 */     // GIR_Coverage, 13927,
     /* 1324969 */     GIR_EraseRootFromParent_Done,
     /* 1324970 */   // Label 18967: @1324970
     /* 1324970 */   GIM_Try, /*On fail goto*//*Label 18968*/ GIMT_Encode4(1325051), // Rule ID 13928 //
     /* 1324975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1324986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1324989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1324992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1324998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325028 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1325028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1325049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325050 */     // GIR_Coverage, 13928,
     /* 1325050 */     GIR_EraseRootFromParent_Done,
     /* 1325051 */   // Label 18968: @1325051
     /* 1325051 */   GIM_Try, /*On fail goto*//*Label 18969*/ GIMT_Encode4(1325132), // Rule ID 13929 //
     /* 1325056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1325067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1325070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1325073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1325079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325109 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1325109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1325130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325131 */     // GIR_Coverage, 13929,
     /* 1325131 */     GIR_EraseRootFromParent_Done,
     /* 1325132 */   // Label 18969: @1325132
     /* 1325132 */   GIM_Try, /*On fail goto*//*Label 18970*/ GIMT_Encode4(1325213), // Rule ID 13930 //
     /* 1325137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1325148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1325151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1325154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1325190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325212 */     // GIR_Coverage, 13930,
     /* 1325212 */     GIR_EraseRootFromParent_Done,
     /* 1325213 */   // Label 18970: @1325213
     /* 1325213 */   GIM_Try, /*On fail goto*//*Label 18971*/ GIMT_Encode4(1325294), // Rule ID 13931 //
     /* 1325218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1325229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1325232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1325235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325271 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1325271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325293 */     // GIR_Coverage, 13931,
     /* 1325293 */     GIR_EraseRootFromParent_Done,
     /* 1325294 */   // Label 18971: @1325294
     /* 1325294 */   GIM_Try, /*On fail goto*//*Label 18972*/ GIMT_Encode4(1325375), // Rule ID 13932 //
     /* 1325299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1325310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1325313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1325316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325352 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1325352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325374 */     // GIR_Coverage, 13932,
     /* 1325374 */     GIR_EraseRootFromParent_Done,
     /* 1325375 */   // Label 18972: @1325375
     /* 1325375 */   GIM_Try, /*On fail goto*//*Label 18973*/ GIMT_Encode4(1325456), // Rule ID 13933 //
     /* 1325380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1325391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1325394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1325397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325433 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1325433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325455 */     // GIR_Coverage, 13933,
     /* 1325455 */     GIR_EraseRootFromParent_Done,
     /* 1325456 */   // Label 18973: @1325456
     /* 1325456 */   GIM_Try, /*On fail goto*//*Label 18974*/ GIMT_Encode4(1325537), // Rule ID 13934 //
     /* 1325461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1325472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1325475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325514 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1325514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325536 */     // GIR_Coverage, 13934,
     /* 1325536 */     GIR_EraseRootFromParent_Done,
     /* 1325537 */   // Label 18974: @1325537
     /* 1325537 */   GIM_Try, /*On fail goto*//*Label 18975*/ GIMT_Encode4(1325618), // Rule ID 13935 //
     /* 1325542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1325553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1325556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325595 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1325595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325617 */     // GIR_Coverage, 13935,
     /* 1325617 */     GIR_EraseRootFromParent_Done,
     /* 1325618 */   // Label 18975: @1325618
     /* 1325618 */   GIM_Try, /*On fail goto*//*Label 18976*/ GIMT_Encode4(1325699), // Rule ID 13936 //
     /* 1325623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1325634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1325637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1325640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325698 */     // GIR_Coverage, 13936,
     /* 1325698 */     GIR_EraseRootFromParent_Done,
     /* 1325699 */   // Label 18976: @1325699
     /* 1325699 */   GIM_Try, /*On fail goto*//*Label 18977*/ GIMT_Encode4(1325780), // Rule ID 13937 //
     /* 1325704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1325715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1325718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1325721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325757 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325779 */     // GIR_Coverage, 13937,
     /* 1325779 */     GIR_EraseRootFromParent_Done,
     /* 1325780 */   // Label 18977: @1325780
     /* 1325780 */   GIM_Try, /*On fail goto*//*Label 18978*/ GIMT_Encode4(1325861), // Rule ID 13938 //
     /* 1325785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1325796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1325799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1325802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325838 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325860 */     // GIR_Coverage, 13938,
     /* 1325860 */     GIR_EraseRootFromParent_Done,
     /* 1325861 */   // Label 18978: @1325861
     /* 1325861 */   GIM_Try, /*On fail goto*//*Label 18979*/ GIMT_Encode4(1325942), // Rule ID 13939 //
     /* 1325866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1325877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1325880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1325883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325919 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325941 */     // GIR_Coverage, 13939,
     /* 1325941 */     GIR_EraseRootFromParent_Done,
     /* 1325942 */   // Label 18979: @1325942
     /* 1325942 */   GIM_Try, /*On fail goto*//*Label 18980*/ GIMT_Encode4(1326023), // Rule ID 13940 //
     /* 1325947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1325958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1325961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1325964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1326000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1326003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326022 */     // GIR_Coverage, 13940,
     /* 1326022 */     GIR_EraseRootFromParent_Done,
     /* 1326023 */   // Label 18980: @1326023
     /* 1326023 */   GIM_Try, /*On fail goto*//*Label 18981*/ GIMT_Encode4(1326104), // Rule ID 13941 //
     /* 1326028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1326031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1326039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1326042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1326045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1326051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326081 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1326081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1326084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326103 */     // GIR_Coverage, 13941,
     /* 1326103 */     GIR_EraseRootFromParent_Done,
     /* 1326104 */   // Label 18981: @1326104
     /* 1326104 */   GIM_Try, /*On fail goto*//*Label 18982*/ GIMT_Encode4(1326185), // Rule ID 13942 //
     /* 1326109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1326112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1326120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1326123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1326126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1326139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326162 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1326162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1326165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326184 */     // GIR_Coverage, 13942,
     /* 1326184 */     GIR_EraseRootFromParent_Done,
     /* 1326185 */   // Label 18982: @1326185
     /* 1326185 */   GIM_Try, /*On fail goto*//*Label 18983*/ GIMT_Encode4(1326266), // Rule ID 13943 //
     /* 1326190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1326193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1326201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1326204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1326207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1326220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1326243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1326246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326265 */     // GIR_Coverage, 13943,
     /* 1326265 */     GIR_EraseRootFromParent_Done,
     /* 1326266 */   // Label 18983: @1326266
     /* 1326266 */   GIM_Try, /*On fail goto*//*Label 18984*/ GIMT_Encode4(1326347), // Rule ID 13944 //
     /* 1326271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1326274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1326282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1326285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1326288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1326301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326324 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1326324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1326327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326346 */     // GIR_Coverage, 13944,
     /* 1326346 */     GIR_EraseRootFromParent_Done,
     /* 1326347 */   // Label 18984: @1326347
     /* 1326347 */   GIM_Try, /*On fail goto*//*Label 18985*/ GIMT_Encode4(1326428), // Rule ID 13945 //
     /* 1326352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1326355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1326363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1326366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1326369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1326382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326405 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1326405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1326408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326427 */     // GIR_Coverage, 13945,
     /* 1326427 */     GIR_EraseRootFromParent_Done,
     /* 1326428 */   // Label 18985: @1326428
     /* 1326428 */   GIM_Try, /*On fail goto*//*Label 18986*/ GIMT_Encode4(1326509), // Rule ID 13946 //
     /* 1326433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1326436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1326444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1326447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1326450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326486 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1326486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1326489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326508 */     // GIR_Coverage, 13946,
     /* 1326508 */     GIR_EraseRootFromParent_Done,
     /* 1326509 */   // Label 18986: @1326509
     /* 1326509 */   GIM_Try, /*On fail goto*//*Label 18987*/ GIMT_Encode4(1326590), // Rule ID 13947 //
     /* 1326514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1326517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1326525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1326528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1326531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326567 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1326567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1326570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326589 */     // GIR_Coverage, 13947,
     /* 1326589 */     GIR_EraseRootFromParent_Done,
     /* 1326590 */   // Label 18987: @1326590
     /* 1326590 */   GIM_Try, /*On fail goto*//*Label 18988*/ GIMT_Encode4(1326674), // Rule ID 19786 //
     /* 1326595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1326612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1326615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326648 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1326651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326673 */     // GIR_Coverage, 19786,
     /* 1326673 */     GIR_EraseRootFromParent_Done,
     /* 1326674 */   // Label 18988: @1326674
     /* 1326674 */   GIM_Try, /*On fail goto*//*Label 18989*/ GIMT_Encode4(1326758), // Rule ID 19787 //
     /* 1326679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1326696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1326699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326732 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1326735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326757 */     // GIR_Coverage, 19787,
     /* 1326757 */     GIR_EraseRootFromParent_Done,
     /* 1326758 */   // Label 18989: @1326758
     /* 1326758 */   GIM_Try, /*On fail goto*//*Label 18990*/ GIMT_Encode4(1326842), // Rule ID 19790 //
     /* 1326763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1326780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1326783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326816 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326841 */     // GIR_Coverage, 19790,
     /* 1326841 */     GIR_EraseRootFromParent_Done,
     /* 1326842 */   // Label 18990: @1326842
     /* 1326842 */   GIM_Try, /*On fail goto*//*Label 18991*/ GIMT_Encode4(1326926), // Rule ID 19791 //
     /* 1326847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1326864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1326867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326900 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326925 */     // GIR_Coverage, 19791,
     /* 1326925 */     GIR_EraseRootFromParent_Done,
     /* 1326926 */   // Label 18991: @1326926
     /* 1326926 */   GIM_Try, /*On fail goto*//*Label 18992*/ GIMT_Encode4(1327010), // Rule ID 19794 //
     /* 1326931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1326934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1326948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1326951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326984 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327009 */     // GIR_Coverage, 19794,
     /* 1327009 */     GIR_EraseRootFromParent_Done,
     /* 1327010 */   // Label 18992: @1327010
     /* 1327010 */   GIM_Try, /*On fail goto*//*Label 18993*/ GIMT_Encode4(1327094), // Rule ID 19795 //
     /* 1327015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1327018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1327032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1327035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327068 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1327071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327093 */     // GIR_Coverage, 19795,
     /* 1327093 */     GIR_EraseRootFromParent_Done,
     /* 1327094 */   // Label 18993: @1327094
     /* 1327094 */   GIM_Try, /*On fail goto*//*Label 18994*/ GIMT_Encode4(1327178), // Rule ID 19798 //
     /* 1327099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1327110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1327113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1327116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1327119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327152 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327177 */     // GIR_Coverage, 19798,
     /* 1327177 */     GIR_EraseRootFromParent_Done,
     /* 1327178 */   // Label 18994: @1327178
     /* 1327178 */   GIM_Try, /*On fail goto*//*Label 18995*/ GIMT_Encode4(1327262), // Rule ID 19799 //
     /* 1327183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1327194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1327197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1327200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1327203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327236 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327261 */     // GIR_Coverage, 19799,
     /* 1327261 */     GIR_EraseRootFromParent_Done,
     /* 1327262 */   // Label 18995: @1327262
     /* 1327262 */   GIM_Try, /*On fail goto*//*Label 18996*/ GIMT_Encode4(1327346), // Rule ID 19802 //
     /* 1327267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1327270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1327278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1327281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1327284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1327287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327320 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327345 */     // GIR_Coverage, 19802,
     /* 1327345 */     GIR_EraseRootFromParent_Done,
     /* 1327346 */   // Label 18996: @1327346
     /* 1327346 */   GIM_Try, /*On fail goto*//*Label 18997*/ GIMT_Encode4(1327430), // Rule ID 19803 //
     /* 1327351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1327354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1327362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1327365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1327368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1327371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327404 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327429 */     // GIR_Coverage, 19803,
     /* 1327429 */     GIR_EraseRootFromParent_Done,
     /* 1327430 */   // Label 18997: @1327430
     /* 1327430 */   GIM_Try, /*On fail goto*//*Label 18998*/ GIMT_Encode4(1327514), // Rule ID 19806 //
     /* 1327435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1327438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1327452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1327455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327488 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327513 */     // GIR_Coverage, 19806,
     /* 1327513 */     GIR_EraseRootFromParent_Done,
     /* 1327514 */   // Label 18998: @1327514
     /* 1327514 */   GIM_Try, /*On fail goto*//*Label 18999*/ GIMT_Encode4(1327598), // Rule ID 19807 //
     /* 1327519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1327522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1327536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1327539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327572 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327597 */     // GIR_Coverage, 19807,
     /* 1327597 */     GIR_EraseRootFromParent_Done,
     /* 1327598 */   // Label 18999: @1327598
     /* 1327598 */   GIM_Try, /*On fail goto*//*Label 19000*/ GIMT_Encode4(1327682), // Rule ID 19810 //
     /* 1327603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1327620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1327623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327656 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1327659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327681 */     // GIR_Coverage, 19810,
     /* 1327681 */     GIR_EraseRootFromParent_Done,
     /* 1327682 */   // Label 19000: @1327682
     /* 1327682 */   GIM_Try, /*On fail goto*//*Label 19001*/ GIMT_Encode4(1327766), // Rule ID 19811 //
     /* 1327687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1327704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1327707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1327743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327765 */     // GIR_Coverage, 19811,
     /* 1327765 */     GIR_EraseRootFromParent_Done,
     /* 1327766 */   // Label 19001: @1327766
     /* 1327766 */   GIM_Try, /*On fail goto*//*Label 19002*/ GIMT_Encode4(1327850), // Rule ID 19814 //
     /* 1327771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1327782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1327785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1327788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1327791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1327794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327824 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1327827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327849 */     // GIR_Coverage, 19814,
     /* 1327849 */     GIR_EraseRootFromParent_Done,
     /* 1327850 */   // Label 19002: @1327850
     /* 1327850 */   GIM_Try, /*On fail goto*//*Label 19003*/ GIMT_Encode4(1327934), // Rule ID 19815 //
     /* 1327855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1327866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1327869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1327872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1327875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1327878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327908 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1327911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327933 */     // GIR_Coverage, 19815,
     /* 1327933 */     GIR_EraseRootFromParent_Done,
     /* 1327934 */   // Label 19003: @1327934
     /* 1327934 */   GIM_Try, /*On fail goto*//*Label 19004*/ GIMT_Encode4(1328018), // Rule ID 19818 //
     /* 1327939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1327950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1327953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1327956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1327959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1327962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327992 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1327995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328017 */     // GIR_Coverage, 19818,
     /* 1328017 */     GIR_EraseRootFromParent_Done,
     /* 1328018 */   // Label 19004: @1328018
     /* 1328018 */   GIM_Try, /*On fail goto*//*Label 19005*/ GIMT_Encode4(1328102), // Rule ID 19819 //
     /* 1328023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1328026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1328034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1328037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1328040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1328043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1328046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328076 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328101 */     // GIR_Coverage, 19819,
     /* 1328101 */     GIR_EraseRootFromParent_Done,
     /* 1328102 */   // Label 19005: @1328102
     /* 1328102 */   GIM_Try, /*On fail goto*//*Label 19006*/ GIMT_Encode4(1328186), // Rule ID 19822 //
     /* 1328107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1328124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1328127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328160 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1328163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328185 */     // GIR_Coverage, 19822,
     /* 1328185 */     GIR_EraseRootFromParent_Done,
     /* 1328186 */   // Label 19006: @1328186
     /* 1328186 */   GIM_Try, /*On fail goto*//*Label 19007*/ GIMT_Encode4(1328270), // Rule ID 19823 //
     /* 1328191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1328208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1328211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1328247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328269 */     // GIR_Coverage, 19823,
     /* 1328269 */     GIR_EraseRootFromParent_Done,
     /* 1328270 */   // Label 19007: @1328270
     /* 1328270 */   GIM_Try, /*On fail goto*//*Label 19008*/ GIMT_Encode4(1328354), // Rule ID 19826 //
     /* 1328275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1328292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1328295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1328331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328353 */     // GIR_Coverage, 19826,
     /* 1328353 */     GIR_EraseRootFromParent_Done,
     /* 1328354 */   // Label 19008: @1328354
     /* 1328354 */   GIM_Try, /*On fail goto*//*Label 19009*/ GIMT_Encode4(1328438), // Rule ID 19827 //
     /* 1328359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1328376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1328379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328412 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1328415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328437 */     // GIR_Coverage, 19827,
     /* 1328437 */     GIR_EraseRootFromParent_Done,
     /* 1328438 */   // Label 19009: @1328438
     /* 1328438 */   GIM_Try, /*On fail goto*//*Label 19010*/ GIMT_Encode4(1328522), // Rule ID 19830 //
     /* 1328443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1328454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1328457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1328460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1328463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328496 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328521 */     // GIR_Coverage, 19830,
     /* 1328521 */     GIR_EraseRootFromParent_Done,
     /* 1328522 */   // Label 19010: @1328522
     /* 1328522 */   GIM_Try, /*On fail goto*//*Label 19011*/ GIMT_Encode4(1328606), // Rule ID 19831 //
     /* 1328527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1328538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1328541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1328544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1328547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328580 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328605 */     // GIR_Coverage, 19831,
     /* 1328605 */     GIR_EraseRootFromParent_Done,
     /* 1328606 */   // Label 19011: @1328606
     /* 1328606 */   GIM_Try, /*On fail goto*//*Label 19012*/ GIMT_Encode4(1328690), // Rule ID 19834 //
     /* 1328611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1328628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1328631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328664 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1328667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328689 */     // GIR_Coverage, 19834,
     /* 1328689 */     GIR_EraseRootFromParent_Done,
     /* 1328690 */   // Label 19012: @1328690
     /* 1328690 */   GIM_Try, /*On fail goto*//*Label 19013*/ GIMT_Encode4(1328774), // Rule ID 19835 //
     /* 1328695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1328712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1328715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328748 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1328751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328773 */     // GIR_Coverage, 19835,
     /* 1328773 */     GIR_EraseRootFromParent_Done,
     /* 1328774 */   // Label 19013: @1328774
     /* 1328774 */   GIM_Try, /*On fail goto*//*Label 19014*/ GIMT_Encode4(1328858), // Rule ID 19838 //
     /* 1328779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1328796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1328799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328832 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1328835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328857 */     // GIR_Coverage, 19838,
     /* 1328857 */     GIR_EraseRootFromParent_Done,
     /* 1328858 */   // Label 19014: @1328858
     /* 1328858 */   GIM_Try, /*On fail goto*//*Label 19015*/ GIMT_Encode4(1328942), // Rule ID 19839 //
     /* 1328863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1328880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1328883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328916 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1328919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328941 */     // GIR_Coverage, 19839,
     /* 1328941 */     GIR_EraseRootFromParent_Done,
     /* 1328942 */   // Label 19015: @1328942
     /* 1328942 */   GIM_Try, /*On fail goto*//*Label 19016*/ GIMT_Encode4(1329026), // Rule ID 19842 //
     /* 1328947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1328964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1328967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329000 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1329003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329025 */     // GIR_Coverage, 19842,
     /* 1329025 */     GIR_EraseRootFromParent_Done,
     /* 1329026 */   // Label 19016: @1329026
     /* 1329026 */   GIM_Try, /*On fail goto*//*Label 19017*/ GIMT_Encode4(1329110), // Rule ID 19843 //
     /* 1329031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1329034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1329042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1329045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1329048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1329051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329084 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1329087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329109 */     // GIR_Coverage, 19843,
     /* 1329109 */     GIR_EraseRootFromParent_Done,
     /* 1329110 */   // Label 19017: @1329110
     /* 1329110 */   GIM_Try, /*On fail goto*//*Label 19018*/ GIMT_Encode4(1329194), // Rule ID 19846 //
     /* 1329115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1329132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329168 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1329171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329193 */     // GIR_Coverage, 19846,
     /* 1329193 */     GIR_EraseRootFromParent_Done,
     /* 1329194 */   // Label 19018: @1329194
     /* 1329194 */   GIM_Try, /*On fail goto*//*Label 19019*/ GIMT_Encode4(1329278), // Rule ID 19847 //
     /* 1329199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1329216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329252 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1329255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329277 */     // GIR_Coverage, 19847,
     /* 1329277 */     GIR_EraseRootFromParent_Done,
     /* 1329278 */   // Label 19019: @1329278
     /* 1329278 */   GIM_Try, /*On fail goto*//*Label 19020*/ GIMT_Encode4(1329362), // Rule ID 19850 //
     /* 1329283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1329300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329336 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1329339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329361 */     // GIR_Coverage, 19850,
     /* 1329361 */     GIR_EraseRootFromParent_Done,
     /* 1329362 */   // Label 19020: @1329362
     /* 1329362 */   GIM_Try, /*On fail goto*//*Label 19021*/ GIMT_Encode4(1329446), // Rule ID 19851 //
     /* 1329367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1329384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329420 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1329423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329445 */     // GIR_Coverage, 19851,
     /* 1329445 */     GIR_EraseRootFromParent_Done,
     /* 1329446 */   // Label 19021: @1329446
     /* 1329446 */   GIM_Try, /*On fail goto*//*Label 19022*/ GIMT_Encode4(1329530), // Rule ID 19854 //
     /* 1329451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1329454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1329468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329504 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1329507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329529 */     // GIR_Coverage, 19854,
     /* 1329529 */     GIR_EraseRootFromParent_Done,
     /* 1329530 */   // Label 19022: @1329530
     /* 1329530 */   GIM_Try, /*On fail goto*//*Label 19023*/ GIMT_Encode4(1329614), // Rule ID 19855 //
     /* 1329535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1329538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1329552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329588 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1329591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329613 */     // GIR_Coverage, 19855,
     /* 1329613 */     GIR_EraseRootFromParent_Done,
     /* 1329614 */   // Label 19023: @1329614
     /* 1329614 */   GIM_Try, /*On fail goto*//*Label 19024*/ GIMT_Encode4(1329698), // Rule ID 19858 //
     /* 1329619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1329630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1329633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1329636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329672 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1329675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329697 */     // GIR_Coverage, 19858,
     /* 1329697 */     GIR_EraseRootFromParent_Done,
     /* 1329698 */   // Label 19024: @1329698
     /* 1329698 */   GIM_Try, /*On fail goto*//*Label 19025*/ GIMT_Encode4(1329782), // Rule ID 19859 //
     /* 1329703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1329714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1329717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1329720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329756 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1329759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329781 */     // GIR_Coverage, 19859,
     /* 1329781 */     GIR_EraseRootFromParent_Done,
     /* 1329782 */   // Label 19025: @1329782
     /* 1329782 */   GIM_Try, /*On fail goto*//*Label 19026*/ GIMT_Encode4(1329866), // Rule ID 19862 //
     /* 1329787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1329790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1329804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329840 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1329843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329865 */     // GIR_Coverage, 19862,
     /* 1329865 */     GIR_EraseRootFromParent_Done,
     /* 1329866 */   // Label 19026: @1329866
     /* 1329866 */   GIM_Try, /*On fail goto*//*Label 19027*/ GIMT_Encode4(1329950), // Rule ID 19863 //
     /* 1329871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1329874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1329888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329924 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1329927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329949 */     // GIR_Coverage, 19863,
     /* 1329949 */     GIR_EraseRootFromParent_Done,
     /* 1329950 */   // Label 19027: @1329950
     /* 1329950 */   GIM_Try, /*On fail goto*//*Label 19028*/ GIMT_Encode4(1330034), // Rule ID 19866 //
     /* 1329955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1329958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1329972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1329997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330008 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1330011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330033 */     // GIR_Coverage, 19866,
     /* 1330033 */     GIR_EraseRootFromParent_Done,
     /* 1330034 */   // Label 19028: @1330034
     /* 1330034 */   GIM_Try, /*On fail goto*//*Label 19029*/ GIMT_Encode4(1330118), // Rule ID 19867 //
     /* 1330039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1330042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1330050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1330053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1330056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1330062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1330081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330092 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1330095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330117 */     // GIR_Coverage, 19867,
     /* 1330117 */     GIR_EraseRootFromParent_Done,
     /* 1330118 */   // Label 19029: @1330118
     /* 1330118 */   GIM_Try, /*On fail goto*//*Label 19030*/ GIMT_Encode4(1330202), // Rule ID 19870 //
     /* 1330123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1330140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330176 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1330179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330201 */     // GIR_Coverage, 19870,
     /* 1330201 */     GIR_EraseRootFromParent_Done,
     /* 1330202 */   // Label 19030: @1330202
     /* 1330202 */   GIM_Try, /*On fail goto*//*Label 19031*/ GIMT_Encode4(1330286), // Rule ID 19871 //
     /* 1330207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1330224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330260 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1330263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330285 */     // GIR_Coverage, 19871,
     /* 1330285 */     GIR_EraseRootFromParent_Done,
     /* 1330286 */   // Label 19031: @1330286
     /* 1330286 */   GIM_Try, /*On fail goto*//*Label 19032*/ GIMT_Encode4(1330370), // Rule ID 19874 //
     /* 1330291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1330308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330344 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1330347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330369 */     // GIR_Coverage, 19874,
     /* 1330369 */     GIR_EraseRootFromParent_Done,
     /* 1330370 */   // Label 19032: @1330370
     /* 1330370 */   GIM_Try, /*On fail goto*//*Label 19033*/ GIMT_Encode4(1330454), // Rule ID 19875 //
     /* 1330375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1330392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330428 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1330431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330453 */     // GIR_Coverage, 19875,
     /* 1330453 */     GIR_EraseRootFromParent_Done,
     /* 1330454 */   // Label 19033: @1330454
     /* 1330454 */   GIM_Try, /*On fail goto*//*Label 19034*/ GIMT_Encode4(1330538), // Rule ID 19878 //
     /* 1330459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1330470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1330473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330512 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1330515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330537 */     // GIR_Coverage, 19878,
     /* 1330537 */     GIR_EraseRootFromParent_Done,
     /* 1330538 */   // Label 19034: @1330538
     /* 1330538 */   GIM_Try, /*On fail goto*//*Label 19035*/ GIMT_Encode4(1330622), // Rule ID 19879 //
     /* 1330543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1330554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1330557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330596 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1330599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330621 */     // GIR_Coverage, 19879,
     /* 1330621 */     GIR_EraseRootFromParent_Done,
     /* 1330622 */   // Label 19035: @1330622
     /* 1330622 */   GIM_Try, /*On fail goto*//*Label 19036*/ GIMT_Encode4(1330706), // Rule ID 19882 //
     /* 1330627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1330644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1330683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330705 */     // GIR_Coverage, 19882,
     /* 1330705 */     GIR_EraseRootFromParent_Done,
     /* 1330706 */   // Label 19036: @1330706
     /* 1330706 */   GIM_Try, /*On fail goto*//*Label 19037*/ GIMT_Encode4(1330790), // Rule ID 19883 //
     /* 1330711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1330728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330764 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1330767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330789 */     // GIR_Coverage, 19883,
     /* 1330789 */     GIR_EraseRootFromParent_Done,
     /* 1330790 */   // Label 19037: @1330790
     /* 1330790 */   GIM_Try, /*On fail goto*//*Label 19038*/ GIMT_Encode4(1330874), // Rule ID 19886 //
     /* 1330795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1330812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330848 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1330851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330873 */     // GIR_Coverage, 19886,
     /* 1330873 */     GIR_EraseRootFromParent_Done,
     /* 1330874 */   // Label 19038: @1330874
     /* 1330874 */   GIM_Try, /*On fail goto*//*Label 19039*/ GIMT_Encode4(1330958), // Rule ID 19887 //
     /* 1330879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1330896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330932 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1330935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330957 */     // GIR_Coverage, 19887,
     /* 1330957 */     GIR_EraseRootFromParent_Done,
     /* 1330958 */   // Label 19039: @1330958
     /* 1330958 */   GIM_Try, /*On fail goto*//*Label 19040*/ GIMT_Encode4(1331042), // Rule ID 19890 //
     /* 1330963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1330980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1331005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331016 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1331019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331041 */     // GIR_Coverage, 19890,
     /* 1331041 */     GIR_EraseRootFromParent_Done,
     /* 1331042 */   // Label 19040: @1331042
     /* 1331042 */   GIM_Try, /*On fail goto*//*Label 19041*/ GIMT_Encode4(1331126), // Rule ID 19891 //
     /* 1331047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1331058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1331061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1331064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1331067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1331070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1331089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331100 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1331103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331125 */     // GIR_Coverage, 19891,
     /* 1331125 */     GIR_EraseRootFromParent_Done,
     /* 1331126 */   // Label 19041: @1331126
     /* 1331126 */   GIM_Try, /*On fail goto*//*Label 19042*/ GIMT_Encode4(1331210), // Rule ID 19894 //
     /* 1331131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1331148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331184 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1331187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331209 */     // GIR_Coverage, 19894,
     /* 1331209 */     GIR_EraseRootFromParent_Done,
     /* 1331210 */   // Label 19042: @1331210
     /* 1331210 */   GIM_Try, /*On fail goto*//*Label 19043*/ GIMT_Encode4(1331294), // Rule ID 19895 //
     /* 1331215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1331232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331268 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1331271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331293 */     // GIR_Coverage, 19895,
     /* 1331293 */     GIR_EraseRootFromParent_Done,
     /* 1331294 */   // Label 19043: @1331294
     /* 1331294 */   GIM_Try, /*On fail goto*//*Label 19044*/ GIMT_Encode4(1331378), // Rule ID 19898 //
     /* 1331299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1331316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331352 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1331355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331377 */     // GIR_Coverage, 19898,
     /* 1331377 */     GIR_EraseRootFromParent_Done,
     /* 1331378 */   // Label 19044: @1331378
     /* 1331378 */   GIM_Try, /*On fail goto*//*Label 19045*/ GIMT_Encode4(1331462), // Rule ID 19899 //
     /* 1331383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1331400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331436 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1331439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331461 */     // GIR_Coverage, 19899,
     /* 1331461 */     GIR_EraseRootFromParent_Done,
     /* 1331462 */   // Label 19045: @1331462
     /* 1331462 */   GIM_Try, /*On fail goto*//*Label 19046*/ GIMT_Encode4(1331546), // Rule ID 19902 //
     /* 1331467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331520 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1331523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331545 */     // GIR_Coverage, 19902,
     /* 1331545 */     GIR_EraseRootFromParent_Done,
     /* 1331546 */   // Label 19046: @1331546
     /* 1331546 */   GIM_Try, /*On fail goto*//*Label 19047*/ GIMT_Encode4(1331630), // Rule ID 19903 //
     /* 1331551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331604 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1331607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331629 */     // GIR_Coverage, 19903,
     /* 1331629 */     GIR_EraseRootFromParent_Done,
     /* 1331630 */   // Label 19047: @1331630
     /* 1331630 */   GIM_Try, /*On fail goto*//*Label 19048*/ GIMT_Encode4(1331714), // Rule ID 19906 //
     /* 1331635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1331652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1331655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1331691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331713 */     // GIR_Coverage, 19906,
     /* 1331713 */     GIR_EraseRootFromParent_Done,
     /* 1331714 */   // Label 19048: @1331714
     /* 1331714 */   GIM_Try, /*On fail goto*//*Label 19049*/ GIMT_Encode4(1331798), // Rule ID 19907 //
     /* 1331719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1331736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1331739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331772 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1331775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331797 */     // GIR_Coverage, 19907,
     /* 1331797 */     GIR_EraseRootFromParent_Done,
     /* 1331798 */   // Label 19049: @1331798
     /* 1331798 */   GIM_Try, /*On fail goto*//*Label 19050*/ GIMT_Encode4(1331882), // Rule ID 19910 //
     /* 1331803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1331820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1331823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331856 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1331859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331881 */     // GIR_Coverage, 19910,
     /* 1331881 */     GIR_EraseRootFromParent_Done,
     /* 1331882 */   // Label 19050: @1331882
     /* 1331882 */   GIM_Try, /*On fail goto*//*Label 19051*/ GIMT_Encode4(1331966), // Rule ID 19911 //
     /* 1331887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1331904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1331907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331940 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1331943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331965 */     // GIR_Coverage, 19911,
     /* 1331965 */     GIR_EraseRootFromParent_Done,
     /* 1331966 */   // Label 19051: @1331966
     /* 1331966 */   GIM_Try, /*On fail goto*//*Label 19052*/ GIMT_Encode4(1332050), // Rule ID 19914 //
     /* 1331971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1331988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1331991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1332027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332049 */     // GIR_Coverage, 19914,
     /* 1332049 */     GIR_EraseRootFromParent_Done,
     /* 1332050 */   // Label 19052: @1332050
     /* 1332050 */   GIM_Try, /*On fail goto*//*Label 19053*/ GIMT_Encode4(1332134), // Rule ID 19915 //
     /* 1332055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1332058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1332072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1332075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332108 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1332111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332133 */     // GIR_Coverage, 19915,
     /* 1332133 */     GIR_EraseRootFromParent_Done,
     /* 1332134 */   // Label 19053: @1332134
     /* 1332134 */   GIM_Try, /*On fail goto*//*Label 19054*/ GIMT_Encode4(1332218), // Rule ID 19918 //
     /* 1332139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1332156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1332159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332192 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332217 */     // GIR_Coverage, 19918,
     /* 1332217 */     GIR_EraseRootFromParent_Done,
     /* 1332218 */   // Label 19054: @1332218
     /* 1332218 */   GIM_Try, /*On fail goto*//*Label 19055*/ GIMT_Encode4(1332302), // Rule ID 19919 //
     /* 1332223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1332240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1332243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332276 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332301 */     // GIR_Coverage, 19919,
     /* 1332301 */     GIR_EraseRootFromParent_Done,
     /* 1332302 */   // Label 19055: @1332302
     /* 1332302 */   GIM_Try, /*On fail goto*//*Label 19056*/ GIMT_Encode4(1332386), // Rule ID 19922 //
     /* 1332307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1332310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1332324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1332327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332360 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332385 */     // GIR_Coverage, 19922,
     /* 1332385 */     GIR_EraseRootFromParent_Done,
     /* 1332386 */   // Label 19056: @1332386
     /* 1332386 */   GIM_Try, /*On fail goto*//*Label 19057*/ GIMT_Encode4(1332470), // Rule ID 19923 //
     /* 1332391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1332394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1332408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1332411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332444 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332469 */     // GIR_Coverage, 19923,
     /* 1332469 */     GIR_EraseRootFromParent_Done,
     /* 1332470 */   // Label 19057: @1332470
     /* 1332470 */   GIM_Try, /*On fail goto*//*Label 19058*/ GIMT_Encode4(1332554), // Rule ID 19926 //
     /* 1332475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1332478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1332492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1332495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332528 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332553 */     // GIR_Coverage, 19926,
     /* 1332553 */     GIR_EraseRootFromParent_Done,
     /* 1332554 */   // Label 19058: @1332554
     /* 1332554 */   GIM_Try, /*On fail goto*//*Label 19059*/ GIMT_Encode4(1332638), // Rule ID 19927 //
     /* 1332559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1332562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1332576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1332579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332612 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332637 */     // GIR_Coverage, 19927,
     /* 1332637 */     GIR_EraseRootFromParent_Done,
     /* 1332638 */   // Label 19059: @1332638
     /* 1332638 */   GIM_Try, /*On fail goto*//*Label 19060*/ GIMT_Encode4(1332722), // Rule ID 19930 //
     /* 1332643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1332660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1332663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332696 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1332699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332721 */     // GIR_Coverage, 19930,
     /* 1332721 */     GIR_EraseRootFromParent_Done,
     /* 1332722 */   // Label 19060: @1332722
     /* 1332722 */   GIM_Try, /*On fail goto*//*Label 19061*/ GIMT_Encode4(1332806), // Rule ID 19931 //
     /* 1332727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1332744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1332747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332780 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1332783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332805 */     // GIR_Coverage, 19931,
     /* 1332805 */     GIR_EraseRootFromParent_Done,
     /* 1332806 */   // Label 19061: @1332806
     /* 1332806 */   GIM_Try, /*On fail goto*//*Label 19062*/ GIMT_Encode4(1332890), // Rule ID 19934 //
     /* 1332811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1332822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1332825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1332828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1332831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1332834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332864 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1332867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332889 */     // GIR_Coverage, 19934,
     /* 1332889 */     GIR_EraseRootFromParent_Done,
     /* 1332890 */   // Label 19062: @1332890
     /* 1332890 */   GIM_Try, /*On fail goto*//*Label 19063*/ GIMT_Encode4(1332974), // Rule ID 19935 //
     /* 1332895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1332906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1332909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1332912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1332915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1332918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332948 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1332951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332973 */     // GIR_Coverage, 19935,
     /* 1332973 */     GIR_EraseRootFromParent_Done,
     /* 1332974 */   // Label 19063: @1332974
     /* 1332974 */   GIM_Try, /*On fail goto*//*Label 19064*/ GIMT_Encode4(1333058), // Rule ID 19938 //
     /* 1332979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1332990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1332993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1332996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1332999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1333002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333032 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333057 */     // GIR_Coverage, 19938,
     /* 1333057 */     GIR_EraseRootFromParent_Done,
     /* 1333058 */   // Label 19064: @1333058
     /* 1333058 */   GIM_Try, /*On fail goto*//*Label 19065*/ GIMT_Encode4(1333142), // Rule ID 19939 //
     /* 1333063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1333074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1333077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1333080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1333083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1333086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333116 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333141 */     // GIR_Coverage, 19939,
     /* 1333141 */     GIR_EraseRootFromParent_Done,
     /* 1333142 */   // Label 19065: @1333142
     /* 1333142 */   GIM_Try, /*On fail goto*//*Label 19066*/ GIMT_Encode4(1333226), // Rule ID 19942 //
     /* 1333147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1333164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1333167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333200 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1333203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333225 */     // GIR_Coverage, 19942,
     /* 1333225 */     GIR_EraseRootFromParent_Done,
     /* 1333226 */   // Label 19066: @1333226
     /* 1333226 */   GIM_Try, /*On fail goto*//*Label 19067*/ GIMT_Encode4(1333310), // Rule ID 19943 //
     /* 1333231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1333248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1333251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333284 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1333287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333309 */     // GIR_Coverage, 19943,
     /* 1333309 */     GIR_EraseRootFromParent_Done,
     /* 1333310 */   // Label 19067: @1333310
     /* 1333310 */   GIM_Try, /*On fail goto*//*Label 19068*/ GIMT_Encode4(1333394), // Rule ID 19946 //
     /* 1333315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1333332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1333335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333368 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1333371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333393 */     // GIR_Coverage, 19946,
     /* 1333393 */     GIR_EraseRootFromParent_Done,
     /* 1333394 */   // Label 19068: @1333394
     /* 1333394 */   GIM_Try, /*On fail goto*//*Label 19069*/ GIMT_Encode4(1333478), // Rule ID 19947 //
     /* 1333399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1333416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1333419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1333455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333477 */     // GIR_Coverage, 19947,
     /* 1333477 */     GIR_EraseRootFromParent_Done,
     /* 1333478 */   // Label 19069: @1333478
     /* 1333478 */   GIM_Try, /*On fail goto*//*Label 19070*/ GIMT_Encode4(1333562), // Rule ID 19950 //
     /* 1333483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1333500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1333503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333536 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333561 */     // GIR_Coverage, 19950,
     /* 1333561 */     GIR_EraseRootFromParent_Done,
     /* 1333562 */   // Label 19070: @1333562
     /* 1333562 */   GIM_Try, /*On fail goto*//*Label 19071*/ GIMT_Encode4(1333646), // Rule ID 19951 //
     /* 1333567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1333584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1333587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333620 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333645 */     // GIR_Coverage, 19951,
     /* 1333645 */     GIR_EraseRootFromParent_Done,
     /* 1333646 */   // Label 19071: @1333646
     /* 1333646 */   GIM_Try, /*On fail goto*//*Label 19072*/ GIMT_Encode4(1333730), // Rule ID 19954 //
     /* 1333651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1333668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1333671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1333707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333729 */     // GIR_Coverage, 19954,
     /* 1333729 */     GIR_EraseRootFromParent_Done,
     /* 1333730 */   // Label 19072: @1333730
     /* 1333730 */   GIM_Try, /*On fail goto*//*Label 19073*/ GIMT_Encode4(1333814), // Rule ID 19955 //
     /* 1333735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1333752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1333755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333788 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1333791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333813 */     // GIR_Coverage, 19955,
     /* 1333813 */     GIR_EraseRootFromParent_Done,
     /* 1333814 */   // Label 19073: @1333814
     /* 1333814 */   GIM_Try, /*On fail goto*//*Label 19074*/ GIMT_Encode4(1333898), // Rule ID 19958 //
     /* 1333819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1333836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1333839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333872 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1333875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333897 */     // GIR_Coverage, 19958,
     /* 1333897 */     GIR_EraseRootFromParent_Done,
     /* 1333898 */   // Label 19074: @1333898
     /* 1333898 */   GIM_Try, /*On fail goto*//*Label 19075*/ GIMT_Encode4(1333982), // Rule ID 19959 //
     /* 1333903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1333920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1333923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333956 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1333959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333981 */     // GIR_Coverage, 19959,
     /* 1333981 */     GIR_EraseRootFromParent_Done,
     /* 1333982 */   // Label 19075: @1333982
     /* 1333982 */   GIM_Try, /*On fail goto*//*Label 19076*/ GIMT_Encode4(1334066), // Rule ID 19962 //
     /* 1333987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1334004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1334007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334040 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1334043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334065 */     // GIR_Coverage, 19962,
     /* 1334065 */     GIR_EraseRootFromParent_Done,
     /* 1334066 */   // Label 19076: @1334066
     /* 1334066 */   GIM_Try, /*On fail goto*//*Label 19077*/ GIMT_Encode4(1334150), // Rule ID 19963 //
     /* 1334071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1334074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1334088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1334091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334124 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1334127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334149 */     // GIR_Coverage, 19963,
     /* 1334149 */     GIR_EraseRootFromParent_Done,
     /* 1334150 */   // Label 19077: @1334150
     /* 1334150 */   GIM_Try, /*On fail goto*//*Label 19078*/ GIMT_Encode4(1334234), // Rule ID 19966 //
     /* 1334155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1334172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334208 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1334211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334233 */     // GIR_Coverage, 19966,
     /* 1334233 */     GIR_EraseRootFromParent_Done,
     /* 1334234 */   // Label 19078: @1334234
     /* 1334234 */   GIM_Try, /*On fail goto*//*Label 19079*/ GIMT_Encode4(1334318), // Rule ID 19967 //
     /* 1334239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1334256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334292 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1334295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334317 */     // GIR_Coverage, 19967,
     /* 1334317 */     GIR_EraseRootFromParent_Done,
     /* 1334318 */   // Label 19079: @1334318
     /* 1334318 */   GIM_Try, /*On fail goto*//*Label 19080*/ GIMT_Encode4(1334402), // Rule ID 19970 //
     /* 1334323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1334340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1334379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334401 */     // GIR_Coverage, 19970,
     /* 1334401 */     GIR_EraseRootFromParent_Done,
     /* 1334402 */   // Label 19080: @1334402
     /* 1334402 */   GIM_Try, /*On fail goto*//*Label 19081*/ GIMT_Encode4(1334486), // Rule ID 19971 //
     /* 1334407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1334424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334460 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1334463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334485 */     // GIR_Coverage, 19971,
     /* 1334485 */     GIR_EraseRootFromParent_Done,
     /* 1334486 */   // Label 19081: @1334486
     /* 1334486 */   GIM_Try, /*On fail goto*//*Label 19082*/ GIMT_Encode4(1334570), // Rule ID 19974 //
     /* 1334491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1334508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334544 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1334547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334569 */     // GIR_Coverage, 19974,
     /* 1334569 */     GIR_EraseRootFromParent_Done,
     /* 1334570 */   // Label 19082: @1334570
     /* 1334570 */   GIM_Try, /*On fail goto*//*Label 19083*/ GIMT_Encode4(1334654), // Rule ID 19975 //
     /* 1334575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1334592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334628 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1334631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334653 */     // GIR_Coverage, 19975,
     /* 1334653 */     GIR_EraseRootFromParent_Done,
     /* 1334654 */   // Label 19083: @1334654
     /* 1334654 */   GIM_Try, /*On fail goto*//*Label 19084*/ GIMT_Encode4(1334738), // Rule ID 19978 //
     /* 1334659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1334676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334712 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1334715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334737 */     // GIR_Coverage, 19978,
     /* 1334737 */     GIR_EraseRootFromParent_Done,
     /* 1334738 */   // Label 19084: @1334738
     /* 1334738 */   GIM_Try, /*On fail goto*//*Label 19085*/ GIMT_Encode4(1334822), // Rule ID 19979 //
     /* 1334743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1334760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334796 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1334799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334821 */     // GIR_Coverage, 19979,
     /* 1334821 */     GIR_EraseRootFromParent_Done,
     /* 1334822 */   // Label 19085: @1334822
     /* 1334822 */   GIM_Try, /*On fail goto*//*Label 19086*/ GIMT_Encode4(1334906), // Rule ID 19982 //
     /* 1334827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1334844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1334883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334905 */     // GIR_Coverage, 19982,
     /* 1334905 */     GIR_EraseRootFromParent_Done,
     /* 1334906 */   // Label 19086: @1334906
     /* 1334906 */   GIM_Try, /*On fail goto*//*Label 19087*/ GIMT_Encode4(1334990), // Rule ID 19983 //
     /* 1334911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1334928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334964 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1334967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334989 */     // GIR_Coverage, 19983,
     /* 1334989 */     GIR_EraseRootFromParent_Done,
     /* 1334990 */   // Label 19087: @1334990
     /* 1334990 */   GIM_Try, /*On fail goto*//*Label 19088*/ GIMT_Encode4(1335074), // Rule ID 19986 //
     /* 1334995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1334998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1335012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1335037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335048 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1335051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335073 */     // GIR_Coverage, 19986,
     /* 1335073 */     GIR_EraseRootFromParent_Done,
     /* 1335074 */   // Label 19088: @1335074
     /* 1335074 */   GIM_Try, /*On fail goto*//*Label 19089*/ GIMT_Encode4(1335158), // Rule ID 19987 //
     /* 1335079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1335082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1335096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1335121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335132 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1335135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335157 */     // GIR_Coverage, 19987,
     /* 1335157 */     GIR_EraseRootFromParent_Done,
     /* 1335158 */   // Label 19089: @1335158
     /* 1335158 */   GIM_Try, /*On fail goto*//*Label 19090*/ GIMT_Encode4(1335242), // Rule ID 19990 //
     /* 1335163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1335180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335216 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1335219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335241 */     // GIR_Coverage, 19990,
     /* 1335241 */     GIR_EraseRootFromParent_Done,
     /* 1335242 */   // Label 19090: @1335242
     /* 1335242 */   GIM_Try, /*On fail goto*//*Label 19091*/ GIMT_Encode4(1335326), // Rule ID 19991 //
     /* 1335247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1335264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335300 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1335303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335325 */     // GIR_Coverage, 19991,
     /* 1335325 */     GIR_EraseRootFromParent_Done,
     /* 1335326 */   // Label 19091: @1335326
     /* 1335326 */   GIM_Try, /*On fail goto*//*Label 19092*/ GIMT_Encode4(1335410), // Rule ID 19994 //
     /* 1335331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1335348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335384 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1335387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335409 */     // GIR_Coverage, 19994,
     /* 1335409 */     GIR_EraseRootFromParent_Done,
     /* 1335410 */   // Label 19092: @1335410
     /* 1335410 */   GIM_Try, /*On fail goto*//*Label 19093*/ GIMT_Encode4(1335494), // Rule ID 19995 //
     /* 1335415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1335432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335468 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1335471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335493 */     // GIR_Coverage, 19995,
     /* 1335493 */     GIR_EraseRootFromParent_Done,
     /* 1335494 */   // Label 19093: @1335494
     /* 1335494 */   GIM_Try, /*On fail goto*//*Label 19094*/ GIMT_Encode4(1335578), // Rule ID 19998 //
     /* 1335499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1335510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1335513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1335516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1335522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335552 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1335555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335577 */     // GIR_Coverage, 19998,
     /* 1335577 */     GIR_EraseRootFromParent_Done,
     /* 1335578 */   // Label 19094: @1335578
     /* 1335578 */   GIM_Try, /*On fail goto*//*Label 19095*/ GIMT_Encode4(1335662), // Rule ID 19999 //
     /* 1335583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1335594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1335597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1335600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1335606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335636 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1335639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335661 */     // GIR_Coverage, 19999,
     /* 1335661 */     GIR_EraseRootFromParent_Done,
     /* 1335662 */   // Label 19095: @1335662
     /* 1335662 */   GIM_Try, /*On fail goto*//*Label 19096*/ GIMT_Encode4(1335746), // Rule ID 20002 //
     /* 1335667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1335684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335720 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1335723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335745 */     // GIR_Coverage, 20002,
     /* 1335745 */     GIR_EraseRootFromParent_Done,
     /* 1335746 */   // Label 19096: @1335746
     /* 1335746 */   GIM_Try, /*On fail goto*//*Label 19097*/ GIMT_Encode4(1335830), // Rule ID 20003 //
     /* 1335751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1335768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335804 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1335807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335829 */     // GIR_Coverage, 20003,
     /* 1335829 */     GIR_EraseRootFromParent_Done,
     /* 1335830 */   // Label 19097: @1335830
     /* 1335830 */   GIM_Try, /*On fail goto*//*Label 19098*/ GIMT_Encode4(1335914), // Rule ID 20006 //
     /* 1335835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1335852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1335891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335913 */     // GIR_Coverage, 20006,
     /* 1335913 */     GIR_EraseRootFromParent_Done,
     /* 1335914 */   // Label 19098: @1335914
     /* 1335914 */   GIM_Try, /*On fail goto*//*Label 19099*/ GIMT_Encode4(1335998), // Rule ID 20007 //
     /* 1335919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1335936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335972 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1335975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335997 */     // GIR_Coverage, 20007,
     /* 1335997 */     GIR_EraseRootFromParent_Done,
     /* 1335998 */   // Label 19099: @1335998
     /* 1335998 */   GIM_Try, /*On fail goto*//*Label 19100*/ GIMT_Encode4(1336082), // Rule ID 20010 //
     /* 1336003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1336006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1336014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1336017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1336020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1336023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1336026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1336045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1336059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336081 */     // GIR_Coverage, 20010,
     /* 1336081 */     GIR_EraseRootFromParent_Done,
     /* 1336082 */   // Label 19100: @1336082
     /* 1336082 */   GIM_Try, /*On fail goto*//*Label 19101*/ GIMT_Encode4(1336166), // Rule ID 20011 //
     /* 1336087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1336098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1336101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1336104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1336107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1336110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1336129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336140 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1336143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336165 */     // GIR_Coverage, 20011,
     /* 1336165 */     GIR_EraseRootFromParent_Done,
     /* 1336166 */   // Label 19101: @1336166
     /* 1336166 */   GIM_Try, /*On fail goto*//*Label 19102*/ GIMT_Encode4(1336250), // Rule ID 20014 //
     /* 1336171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1336174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1336188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336224 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1336227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336249 */     // GIR_Coverage, 20014,
     /* 1336249 */     GIR_EraseRootFromParent_Done,
     /* 1336250 */   // Label 19102: @1336250
     /* 1336250 */   GIM_Try, /*On fail goto*//*Label 19103*/ GIMT_Encode4(1336334), // Rule ID 20015 //
     /* 1336255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1336272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336308 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1336311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336333 */     // GIR_Coverage, 20015,
     /* 1336333 */     GIR_EraseRootFromParent_Done,
     /* 1336334 */   // Label 19103: @1336334
     /* 1336334 */   GIM_Try, /*On fail goto*//*Label 19104*/ GIMT_Encode4(1336418), // Rule ID 20018 //
     /* 1336339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1336342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1336356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336392 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1336395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336417 */     // GIR_Coverage, 20018,
     /* 1336417 */     GIR_EraseRootFromParent_Done,
     /* 1336418 */   // Label 19104: @1336418
     /* 1336418 */   GIM_Try, /*On fail goto*//*Label 19105*/ GIMT_Encode4(1336502), // Rule ID 20019 //
     /* 1336423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1336440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336476 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1336479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336501 */     // GIR_Coverage, 20019,
     /* 1336501 */     GIR_EraseRootFromParent_Done,
     /* 1336502 */   // Label 19105: @1336502
     /* 1336502 */   GIM_Try, /*On fail goto*//*Label 19106*/ GIMT_Encode4(1336586), // Rule ID 20022 //
     /* 1336507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1336510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1336524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336560 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1336563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336585 */     // GIR_Coverage, 20022,
     /* 1336585 */     GIR_EraseRootFromParent_Done,
     /* 1336586 */   // Label 19106: @1336586
     /* 1336586 */   GIM_Try, /*On fail goto*//*Label 19107*/ GIMT_Encode4(1336670), // Rule ID 20023 //
     /* 1336591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1336608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336644 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1336647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336669 */     // GIR_Coverage, 20023,
     /* 1336669 */     GIR_EraseRootFromParent_Done,
     /* 1336670 */   // Label 19107: @1336670
     /* 1336670 */   GIM_Try, /*On fail goto*//*Label 19108*/ GIMT_Encode4(1336754), // Rule ID 20026 //
     /* 1336675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1336692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1336695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1336731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336753 */     // GIR_Coverage, 20026,
     /* 1336753 */     GIR_EraseRootFromParent_Done,
     /* 1336754 */   // Label 19108: @1336754
     /* 1336754 */   GIM_Try, /*On fail goto*//*Label 19109*/ GIMT_Encode4(1336838), // Rule ID 20027 //
     /* 1336759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1336776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1336779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336812 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1336815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336837 */     // GIR_Coverage, 20027,
     /* 1336837 */     GIR_EraseRootFromParent_Done,
     /* 1336838 */   // Label 19109: @1336838
     /* 1336838 */   GIM_Try, /*On fail goto*//*Label 19110*/ GIMT_Encode4(1336922), // Rule ID 20030 //
     /* 1336843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1336860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1336863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336896 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1336899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336921 */     // GIR_Coverage, 20030,
     /* 1336921 */     GIR_EraseRootFromParent_Done,
     /* 1336922 */   // Label 19110: @1336922
     /* 1336922 */   GIM_Try, /*On fail goto*//*Label 19111*/ GIMT_Encode4(1337006), // Rule ID 20031 //
     /* 1336927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1336944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1336947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336980 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1336983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337005 */     // GIR_Coverage, 20031,
     /* 1337005 */     GIR_EraseRootFromParent_Done,
     /* 1337006 */   // Label 19111: @1337006
     /* 1337006 */   GIM_Try, /*On fail goto*//*Label 19112*/ GIMT_Encode4(1337090), // Rule ID 20034 //
     /* 1337011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1337014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1337028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1337031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1337067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337089 */     // GIR_Coverage, 20034,
     /* 1337089 */     GIR_EraseRootFromParent_Done,
     /* 1337090 */   // Label 19112: @1337090
     /* 1337090 */   GIM_Try, /*On fail goto*//*Label 19113*/ GIMT_Encode4(1337174), // Rule ID 20035 //
     /* 1337095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1337098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1337112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1337115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337148 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1337151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337173 */     // GIR_Coverage, 20035,
     /* 1337173 */     GIR_EraseRootFromParent_Done,
     /* 1337174 */   // Label 19113: @1337174
     /* 1337174 */   GIM_Try, /*On fail goto*//*Label 19114*/ GIMT_Encode4(1337258), // Rule ID 20038 //
     /* 1337179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1337196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1337199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337232 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337257 */     // GIR_Coverage, 20038,
     /* 1337257 */     GIR_EraseRootFromParent_Done,
     /* 1337258 */   // Label 19114: @1337258
     /* 1337258 */   GIM_Try, /*On fail goto*//*Label 19115*/ GIMT_Encode4(1337342), // Rule ID 20039 //
     /* 1337263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1337280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1337283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337316 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337341 */     // GIR_Coverage, 20039,
     /* 1337341 */     GIR_EraseRootFromParent_Done,
     /* 1337342 */   // Label 19115: @1337342
     /* 1337342 */   GIM_Try, /*On fail goto*//*Label 19116*/ GIMT_Encode4(1337426), // Rule ID 20042 //
     /* 1337347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1337350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1337364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1337367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337400 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337425 */     // GIR_Coverage, 20042,
     /* 1337425 */     GIR_EraseRootFromParent_Done,
     /* 1337426 */   // Label 19116: @1337426
     /* 1337426 */   GIM_Try, /*On fail goto*//*Label 19117*/ GIMT_Encode4(1337510), // Rule ID 20043 //
     /* 1337431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1337434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1337448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1337451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337484 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337509 */     // GIR_Coverage, 20043,
     /* 1337509 */     GIR_EraseRootFromParent_Done,
     /* 1337510 */   // Label 19117: @1337510
     /* 1337510 */   GIM_Try, /*On fail goto*//*Label 19118*/ GIMT_Encode4(1337594), // Rule ID 20046 //
     /* 1337515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1337518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1337532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1337535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337568 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337593 */     // GIR_Coverage, 20046,
     /* 1337593 */     GIR_EraseRootFromParent_Done,
     /* 1337594 */   // Label 19118: @1337594
     /* 1337594 */   GIM_Try, /*On fail goto*//*Label 19119*/ GIMT_Encode4(1337678), // Rule ID 20047 //
     /* 1337599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1337602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1337616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1337619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337652 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337677 */     // GIR_Coverage, 20047,
     /* 1337677 */     GIR_EraseRootFromParent_Done,
     /* 1337678 */   // Label 19119: @1337678
     /* 1337678 */   GIM_Try, /*On fail goto*//*Label 19120*/ GIMT_Encode4(1337762), // Rule ID 20050 //
     /* 1337683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1337700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1337703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1337739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337761 */     // GIR_Coverage, 20050,
     /* 1337761 */     GIR_EraseRootFromParent_Done,
     /* 1337762 */   // Label 19120: @1337762
     /* 1337762 */   GIM_Try, /*On fail goto*//*Label 19121*/ GIMT_Encode4(1337846), // Rule ID 20051 //
     /* 1337767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1337784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1337787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337820 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1337823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337845 */     // GIR_Coverage, 20051,
     /* 1337845 */     GIR_EraseRootFromParent_Done,
     /* 1337846 */   // Label 19121: @1337846
     /* 1337846 */   GIM_Try, /*On fail goto*//*Label 19122*/ GIMT_Encode4(1337930), // Rule ID 20054 //
     /* 1337851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1337862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1337865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1337868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1337871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1337874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337904 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1337907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337929 */     // GIR_Coverage, 20054,
     /* 1337929 */     GIR_EraseRootFromParent_Done,
     /* 1337930 */   // Label 19122: @1337930
     /* 1337930 */   GIM_Try, /*On fail goto*//*Label 19123*/ GIMT_Encode4(1338014), // Rule ID 20055 //
     /* 1337935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1337946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1337949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1337952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1337955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1337958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337988 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1337991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338013 */     // GIR_Coverage, 20055,
     /* 1338013 */     GIR_EraseRootFromParent_Done,
     /* 1338014 */   // Label 19123: @1338014
     /* 1338014 */   GIM_Try, /*On fail goto*//*Label 19124*/ GIMT_Encode4(1338098), // Rule ID 20058 //
     /* 1338019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1338030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1338033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1338036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1338039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1338042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338072 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338097 */     // GIR_Coverage, 20058,
     /* 1338097 */     GIR_EraseRootFromParent_Done,
     /* 1338098 */   // Label 19124: @1338098
     /* 1338098 */   GIM_Try, /*On fail goto*//*Label 19125*/ GIMT_Encode4(1338182), // Rule ID 20059 //
     /* 1338103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1338114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1338117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1338120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1338123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1338126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338156 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338181 */     // GIR_Coverage, 20059,
     /* 1338181 */     GIR_EraseRootFromParent_Done,
     /* 1338182 */   // Label 19125: @1338182
     /* 1338182 */   GIM_Try, /*On fail goto*//*Label 19126*/ GIMT_Encode4(1338266), // Rule ID 20062 //
     /* 1338187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1338204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1338207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338240 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1338243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338265 */     // GIR_Coverage, 20062,
     /* 1338265 */     GIR_EraseRootFromParent_Done,
     /* 1338266 */   // Label 19126: @1338266
     /* 1338266 */   GIM_Try, /*On fail goto*//*Label 19127*/ GIMT_Encode4(1338350), // Rule ID 20063 //
     /* 1338271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1338288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1338291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338324 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1338327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338349 */     // GIR_Coverage, 20063,
     /* 1338349 */     GIR_EraseRootFromParent_Done,
     /* 1338350 */   // Label 19127: @1338350
     /* 1338350 */   GIM_Try, /*On fail goto*//*Label 19128*/ GIMT_Encode4(1338434), // Rule ID 20066 //
     /* 1338355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1338372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1338375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338408 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338433 */     // GIR_Coverage, 20066,
     /* 1338433 */     GIR_EraseRootFromParent_Done,
     /* 1338434 */   // Label 19128: @1338434
     /* 1338434 */   GIM_Try, /*On fail goto*//*Label 19129*/ GIMT_Encode4(1338518), // Rule ID 20067 //
     /* 1338439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1338456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1338459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338492 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338517 */     // GIR_Coverage, 20067,
     /* 1338517 */     GIR_EraseRootFromParent_Done,
     /* 1338518 */   // Label 19129: @1338518
     /* 1338518 */   GIM_Try, /*On fail goto*//*Label 19130*/ GIMT_Encode4(1338602), // Rule ID 20070 //
     /* 1338523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1338540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1338543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338576 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338601 */     // GIR_Coverage, 20070,
     /* 1338601 */     GIR_EraseRootFromParent_Done,
     /* 1338602 */   // Label 19130: @1338602
     /* 1338602 */   GIM_Try, /*On fail goto*//*Label 19131*/ GIMT_Encode4(1338686), // Rule ID 20071 //
     /* 1338607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1338624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1338627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338660 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338685 */     // GIR_Coverage, 20071,
     /* 1338685 */     GIR_EraseRootFromParent_Done,
     /* 1338686 */   // Label 19131: @1338686
     /* 1338686 */   GIM_Try, /*On fail goto*//*Label 19132*/ GIMT_Encode4(1338770), // Rule ID 20074 //
     /* 1338691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1338708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1338711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338744 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1338747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338769 */     // GIR_Coverage, 20074,
     /* 1338769 */     GIR_EraseRootFromParent_Done,
     /* 1338770 */   // Label 19132: @1338770
     /* 1338770 */   GIM_Try, /*On fail goto*//*Label 19133*/ GIMT_Encode4(1338854), // Rule ID 20075 //
     /* 1338775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1338792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1338795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338828 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1338831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338853 */     // GIR_Coverage, 20075,
     /* 1338853 */     GIR_EraseRootFromParent_Done,
     /* 1338854 */   // Label 19133: @1338854
     /* 1338854 */   GIM_Try, /*On fail goto*//*Label 19134*/ GIMT_Encode4(1338938), // Rule ID 20078 //
     /* 1338859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1338876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1338879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338912 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338937 */     // GIR_Coverage, 20078,
     /* 1338937 */     GIR_EraseRootFromParent_Done,
     /* 1338938 */   // Label 19134: @1338938
     /* 1338938 */   GIM_Try, /*On fail goto*//*Label 19135*/ GIMT_Encode4(1339022), // Rule ID 20079 //
     /* 1338943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1338960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1338963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338996 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339021 */     // GIR_Coverage, 20079,
     /* 1339021 */     GIR_EraseRootFromParent_Done,
     /* 1339022 */   // Label 19135: @1339022
     /* 1339022 */   GIM_Try, /*On fail goto*//*Label 19136*/ GIMT_Encode4(1339106), // Rule ID 20082 //
     /* 1339027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1339030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1339044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1339047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339080 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1339083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339105 */     // GIR_Coverage, 20082,
     /* 1339105 */     GIR_EraseRootFromParent_Done,
     /* 1339106 */   // Label 19136: @1339106
     /* 1339106 */   GIM_Try, /*On fail goto*//*Label 19137*/ GIMT_Encode4(1339190), // Rule ID 20083 //
     /* 1339111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1339114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1339128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1339131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339164 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1339167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339189 */     // GIR_Coverage, 20083,
     /* 1339189 */     GIR_EraseRootFromParent_Done,
     /* 1339190 */   // Label 19137: @1339190
     /* 1339190 */   GIM_Try, /*On fail goto*//*Label 19138*/ GIMT_Encode4(1339274), // Rule ID 20086 //
     /* 1339195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1339212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339248 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1339251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339273 */     // GIR_Coverage, 20086,
     /* 1339273 */     GIR_EraseRootFromParent_Done,
     /* 1339274 */   // Label 19138: @1339274
     /* 1339274 */   GIM_Try, /*On fail goto*//*Label 19139*/ GIMT_Encode4(1339358), // Rule ID 20087 //
     /* 1339279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1339296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339332 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1339335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339357 */     // GIR_Coverage, 20087,
     /* 1339357 */     GIR_EraseRootFromParent_Done,
     /* 1339358 */   // Label 19139: @1339358
     /* 1339358 */   GIM_Try, /*On fail goto*//*Label 19140*/ GIMT_Encode4(1339442), // Rule ID 20090 //
     /* 1339363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1339380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339416 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1339419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339441 */     // GIR_Coverage, 20090,
     /* 1339441 */     GIR_EraseRootFromParent_Done,
     /* 1339442 */   // Label 19140: @1339442
     /* 1339442 */   GIM_Try, /*On fail goto*//*Label 19141*/ GIMT_Encode4(1339526), // Rule ID 20091 //
     /* 1339447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1339464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339500 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1339503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339525 */     // GIR_Coverage, 20091,
     /* 1339525 */     GIR_EraseRootFromParent_Done,
     /* 1339526 */   // Label 19141: @1339526
     /* 1339526 */   GIM_Try, /*On fail goto*//*Label 19142*/ GIMT_Encode4(1339610), // Rule ID 20094 //
     /* 1339531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1339548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339584 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1339587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339609 */     // GIR_Coverage, 20094,
     /* 1339609 */     GIR_EraseRootFromParent_Done,
     /* 1339610 */   // Label 19142: @1339610
     /* 1339610 */   GIM_Try, /*On fail goto*//*Label 19143*/ GIMT_Encode4(1339694), // Rule ID 20095 //
     /* 1339615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1339632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339668 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1339671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339693 */     // GIR_Coverage, 20095,
     /* 1339693 */     GIR_EraseRootFromParent_Done,
     /* 1339694 */   // Label 19143: @1339694
     /* 1339694 */   GIM_Try, /*On fail goto*//*Label 19144*/ GIMT_Encode4(1339778), // Rule ID 20098 //
     /* 1339699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1339716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339752 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1339755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339777 */     // GIR_Coverage, 20098,
     /* 1339777 */     GIR_EraseRootFromParent_Done,
     /* 1339778 */   // Label 19144: @1339778
     /* 1339778 */   GIM_Try, /*On fail goto*//*Label 19145*/ GIMT_Encode4(1339862), // Rule ID 20099 //
     /* 1339783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1339800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1339839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339861 */     // GIR_Coverage, 20099,
     /* 1339861 */     GIR_EraseRootFromParent_Done,
     /* 1339862 */   // Label 19145: @1339862
     /* 1339862 */   GIM_Try, /*On fail goto*//*Label 19146*/ GIMT_Encode4(1339946), // Rule ID 20102 //
     /* 1339867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1339884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339920 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1339923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339945 */     // GIR_Coverage, 20102,
     /* 1339945 */     GIR_EraseRootFromParent_Done,
     /* 1339946 */   // Label 19146: @1339946
     /* 1339946 */   GIM_Try, /*On fail goto*//*Label 19147*/ GIMT_Encode4(1340030), // Rule ID 20103 //
     /* 1339951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1339968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340004 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1340007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340029 */     // GIR_Coverage, 20103,
     /* 1340029 */     GIR_EraseRootFromParent_Done,
     /* 1340030 */   // Label 19147: @1340030
     /* 1340030 */   GIM_Try, /*On fail goto*//*Label 19148*/ GIMT_Encode4(1340114), // Rule ID 20106 //
     /* 1340035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1340038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1340052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340088 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1340091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340113 */     // GIR_Coverage, 20106,
     /* 1340113 */     GIR_EraseRootFromParent_Done,
     /* 1340114 */   // Label 19148: @1340114
     /* 1340114 */   GIM_Try, /*On fail goto*//*Label 19149*/ GIMT_Encode4(1340198), // Rule ID 20107 //
     /* 1340119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1340122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1340136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340172 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1340175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340197 */     // GIR_Coverage, 20107,
     /* 1340197 */     GIR_EraseRootFromParent_Done,
     /* 1340198 */   // Label 19149: @1340198
     /* 1340198 */   GIM_Try, /*On fail goto*//*Label 19150*/ GIMT_Encode4(1340282), // Rule ID 20110 //
     /* 1340203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1340220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340256 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1340259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340281 */     // GIR_Coverage, 20110,
     /* 1340281 */     GIR_EraseRootFromParent_Done,
     /* 1340282 */   // Label 19150: @1340282
     /* 1340282 */   GIM_Try, /*On fail goto*//*Label 19151*/ GIMT_Encode4(1340366), // Rule ID 20111 //
     /* 1340287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1340304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340340 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1340343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340365 */     // GIR_Coverage, 20111,
     /* 1340365 */     GIR_EraseRootFromParent_Done,
     /* 1340366 */   // Label 19151: @1340366
     /* 1340366 */   GIM_Try, /*On fail goto*//*Label 19152*/ GIMT_Encode4(1340450), // Rule ID 20114 //
     /* 1340371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1340388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340424 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1340427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340449 */     // GIR_Coverage, 20114,
     /* 1340449 */     GIR_EraseRootFromParent_Done,
     /* 1340450 */   // Label 19152: @1340450
     /* 1340450 */   GIM_Try, /*On fail goto*//*Label 19153*/ GIMT_Encode4(1340534), // Rule ID 20115 //
     /* 1340455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1340472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340508 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1340511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340533 */     // GIR_Coverage, 20115,
     /* 1340533 */     GIR_EraseRootFromParent_Done,
     /* 1340534 */   // Label 19153: @1340534
     /* 1340534 */   GIM_Try, /*On fail goto*//*Label 19154*/ GIMT_Encode4(1340618), // Rule ID 20118 //
     /* 1340539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1340550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1340553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1340556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1340562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340592 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1340595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340617 */     // GIR_Coverage, 20118,
     /* 1340617 */     GIR_EraseRootFromParent_Done,
     /* 1340618 */   // Label 19154: @1340618
     /* 1340618 */   GIM_Try, /*On fail goto*//*Label 19155*/ GIMT_Encode4(1340702), // Rule ID 20119 //
     /* 1340623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1340634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1340637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1340640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1340646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340676 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1340679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340701 */     // GIR_Coverage, 20119,
     /* 1340701 */     GIR_EraseRootFromParent_Done,
     /* 1340702 */   // Label 19155: @1340702
     /* 1340702 */   GIM_Try, /*On fail goto*//*Label 19156*/ GIMT_Encode4(1340786), // Rule ID 20122 //
     /* 1340707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1340724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340760 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1340763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340785 */     // GIR_Coverage, 20122,
     /* 1340785 */     GIR_EraseRootFromParent_Done,
     /* 1340786 */   // Label 19156: @1340786
     /* 1340786 */   GIM_Try, /*On fail goto*//*Label 19157*/ GIMT_Encode4(1340870), // Rule ID 20123 //
     /* 1340791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1340808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1340847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340869 */     // GIR_Coverage, 20123,
     /* 1340869 */     GIR_EraseRootFromParent_Done,
     /* 1340870 */   // Label 19157: @1340870
     /* 1340870 */   GIM_Try, /*On fail goto*//*Label 19158*/ GIMT_Encode4(1340954), // Rule ID 20126 //
     /* 1340875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1340892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340928 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1340931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340953 */     // GIR_Coverage, 20126,
     /* 1340953 */     GIR_EraseRootFromParent_Done,
     /* 1340954 */   // Label 19158: @1340954
     /* 1340954 */   GIM_Try, /*On fail goto*//*Label 19159*/ GIMT_Encode4(1341038), // Rule ID 20127 //
     /* 1340959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1340976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341012 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1341015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341037 */     // GIR_Coverage, 20127,
     /* 1341037 */     GIR_EraseRootFromParent_Done,
     /* 1341038 */   // Label 19159: @1341038
     /* 1341038 */   GIM_Try, /*On fail goto*//*Label 19160*/ GIMT_Encode4(1341122), // Rule ID 20130 //
     /* 1341043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1341054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1341057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1341060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1341066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341096 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1341099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341121 */     // GIR_Coverage, 20130,
     /* 1341121 */     GIR_EraseRootFromParent_Done,
     /* 1341122 */   // Label 19160: @1341122
     /* 1341122 */   GIM_Try, /*On fail goto*//*Label 19161*/ GIMT_Encode4(1341206), // Rule ID 20131 //
     /* 1341127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1341130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1341138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1341141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1341144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1341150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341180 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1341183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341205 */     // GIR_Coverage, 20131,
     /* 1341205 */     GIR_EraseRootFromParent_Done,
     /* 1341206 */   // Label 19161: @1341206
     /* 1341206 */   GIM_Try, /*On fail goto*//*Label 19162*/ GIMT_Encode4(1341290), // Rule ID 20134 //
     /* 1341211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1341228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341264 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1341267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341289 */     // GIR_Coverage, 20134,
     /* 1341289 */     GIR_EraseRootFromParent_Done,
     /* 1341290 */   // Label 19162: @1341290
     /* 1341290 */   GIM_Try, /*On fail goto*//*Label 19163*/ GIMT_Encode4(1341374), // Rule ID 20135 //
     /* 1341295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1341312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341348 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1341351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341373 */     // GIR_Coverage, 20135,
     /* 1341373 */     GIR_EraseRootFromParent_Done,
     /* 1341374 */   // Label 19163: @1341374
     /* 1341374 */   GIM_Try, /*On fail goto*//*Label 19164*/ GIMT_Encode4(1341458), // Rule ID 20138 //
     /* 1341379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1341396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341432 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1341435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341457 */     // GIR_Coverage, 20138,
     /* 1341457 */     GIR_EraseRootFromParent_Done,
     /* 1341458 */   // Label 19164: @1341458
     /* 1341458 */   GIM_Try, /*On fail goto*//*Label 19165*/ GIMT_Encode4(1341542), // Rule ID 20139 //
     /* 1341463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1341480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341516 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1341519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341541 */     // GIR_Coverage, 20139,
     /* 1341541 */     GIR_EraseRootFromParent_Done,
     /* 1341542 */   // Label 19165: @1341542
     /* 1341542 */   GIM_Try, /*On fail goto*//*Label 19166*/ GIMT_Encode4(1341626), // Rule ID 20142 //
     /* 1341547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1341564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341600 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1341603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341625 */     // GIR_Coverage, 20142,
     /* 1341625 */     GIR_EraseRootFromParent_Done,
     /* 1341626 */   // Label 19166: @1341626
     /* 1341626 */   GIM_Try, /*On fail goto*//*Label 19167*/ GIMT_Encode4(1341710), // Rule ID 20143 //
     /* 1341631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1341648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341684 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1341687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341709 */     // GIR_Coverage, 20143,
     /* 1341709 */     GIR_EraseRootFromParent_Done,
     /* 1341710 */   // Label 19167: @1341710
     /* 1341710 */   GIM_Try, /*On fail goto*//*Label 19168*/ GIMT_Encode4(1341794), // Rule ID 20146 //
     /* 1341715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1341732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1341735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341768 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1341771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341793 */     // GIR_Coverage, 20146,
     /* 1341793 */     GIR_EraseRootFromParent_Done,
     /* 1341794 */   // Label 19168: @1341794
     /* 1341794 */   GIM_Try, /*On fail goto*//*Label 19169*/ GIMT_Encode4(1341878), // Rule ID 20147 //
     /* 1341799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1341816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1341819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341852 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1341855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341877 */     // GIR_Coverage, 20147,
     /* 1341877 */     GIR_EraseRootFromParent_Done,
     /* 1341878 */   // Label 19169: @1341878
     /* 1341878 */   GIM_Try, /*On fail goto*//*Label 19170*/ GIMT_Encode4(1341962), // Rule ID 20150 //
     /* 1341883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1341900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1341903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341936 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1341939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341961 */     // GIR_Coverage, 20150,
     /* 1341961 */     GIR_EraseRootFromParent_Done,
     /* 1341962 */   // Label 19170: @1341962
     /* 1341962 */   GIM_Try, /*On fail goto*//*Label 19171*/ GIMT_Encode4(1342046), // Rule ID 20151 //
     /* 1341967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1341984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1341987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342020 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1342023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342045 */     // GIR_Coverage, 20151,
     /* 1342045 */     GIR_EraseRootFromParent_Done,
     /* 1342046 */   // Label 19171: @1342046
     /* 1342046 */   GIM_Try, /*On fail goto*//*Label 19172*/ GIMT_Encode4(1342130), // Rule ID 20154 //
     /* 1342051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1342054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1342068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1342071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342104 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1342107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342129 */     // GIR_Coverage, 20154,
     /* 1342129 */     GIR_EraseRootFromParent_Done,
     /* 1342130 */   // Label 19172: @1342130
     /* 1342130 */   GIM_Try, /*On fail goto*//*Label 19173*/ GIMT_Encode4(1342214), // Rule ID 20155 //
     /* 1342135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1342138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1342152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1342155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342188 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1342191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342213 */     // GIR_Coverage, 20155,
     /* 1342213 */     GIR_EraseRootFromParent_Done,
     /* 1342214 */   // Label 19173: @1342214
     /* 1342214 */   GIM_Try, /*On fail goto*//*Label 19174*/ GIMT_Encode4(1342298), // Rule ID 20158 //
     /* 1342219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1342236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1342239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342272 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342297 */     // GIR_Coverage, 20158,
     /* 1342297 */     GIR_EraseRootFromParent_Done,
     /* 1342298 */   // Label 19174: @1342298
     /* 1342298 */   GIM_Try, /*On fail goto*//*Label 19175*/ GIMT_Encode4(1342382), // Rule ID 20159 //
     /* 1342303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1342320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1342323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342356 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342381 */     // GIR_Coverage, 20159,
     /* 1342381 */     GIR_EraseRootFromParent_Done,
     /* 1342382 */   // Label 19175: @1342382
     /* 1342382 */   GIM_Try, /*On fail goto*//*Label 19176*/ GIMT_Encode4(1342466), // Rule ID 20162 //
     /* 1342387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1342390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1342404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1342407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342440 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342465 */     // GIR_Coverage, 20162,
     /* 1342465 */     GIR_EraseRootFromParent_Done,
     /* 1342466 */   // Label 19176: @1342466
     /* 1342466 */   GIM_Try, /*On fail goto*//*Label 19177*/ GIMT_Encode4(1342550), // Rule ID 20163 //
     /* 1342471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1342474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1342488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1342491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342524 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342549 */     // GIR_Coverage, 20163,
     /* 1342549 */     GIR_EraseRootFromParent_Done,
     /* 1342550 */   // Label 19177: @1342550
     /* 1342550 */   GIM_Try, /*On fail goto*//*Label 19178*/ GIMT_Encode4(1342634), // Rule ID 20166 //
     /* 1342555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1342558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1342572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1342575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342608 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342633 */     // GIR_Coverage, 20166,
     /* 1342633 */     GIR_EraseRootFromParent_Done,
     /* 1342634 */   // Label 19178: @1342634
     /* 1342634 */   GIM_Try, /*On fail goto*//*Label 19179*/ GIMT_Encode4(1342718), // Rule ID 20167 //
     /* 1342639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1342642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1342656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1342659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342692 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342717 */     // GIR_Coverage, 20167,
     /* 1342717 */     GIR_EraseRootFromParent_Done,
     /* 1342718 */   // Label 19179: @1342718
     /* 1342718 */   GIM_Try, /*On fail goto*//*Label 19180*/ GIMT_Encode4(1342802), // Rule ID 20170 //
     /* 1342723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1342740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1342743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342776 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1342779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342801 */     // GIR_Coverage, 20170,
     /* 1342801 */     GIR_EraseRootFromParent_Done,
     /* 1342802 */   // Label 19180: @1342802
     /* 1342802 */   GIM_Try, /*On fail goto*//*Label 19181*/ GIMT_Encode4(1342886), // Rule ID 20171 //
     /* 1342807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1342824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1342827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342860 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1342863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342885 */     // GIR_Coverage, 20171,
     /* 1342885 */     GIR_EraseRootFromParent_Done,
     /* 1342886 */   // Label 19181: @1342886
     /* 1342886 */   GIM_Try, /*On fail goto*//*Label 19182*/ GIMT_Encode4(1342970), // Rule ID 20174 //
     /* 1342891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1342902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1342905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1342908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1342911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342944 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1342947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342969 */     // GIR_Coverage, 20174,
     /* 1342969 */     GIR_EraseRootFromParent_Done,
     /* 1342970 */   // Label 19182: @1342970
     /* 1342970 */   GIM_Try, /*On fail goto*//*Label 19183*/ GIMT_Encode4(1343054), // Rule ID 20175 //
     /* 1342975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1342986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1342989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1342992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1342995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343028 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343053 */     // GIR_Coverage, 20175,
     /* 1343053 */     GIR_EraseRootFromParent_Done,
     /* 1343054 */   // Label 19183: @1343054
     /* 1343054 */   GIM_Try, /*On fail goto*//*Label 19184*/ GIMT_Encode4(1343138), // Rule ID 20178 //
     /* 1343059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1343070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1343073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1343076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1343079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1343082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343112 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343137 */     // GIR_Coverage, 20178,
     /* 1343137 */     GIR_EraseRootFromParent_Done,
     /* 1343138 */   // Label 19184: @1343138
     /* 1343138 */   GIM_Try, /*On fail goto*//*Label 19185*/ GIMT_Encode4(1343222), // Rule ID 20179 //
     /* 1343143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1343146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1343154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1343157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1343160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1343163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1343166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343196 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343221 */     // GIR_Coverage, 20179,
     /* 1343221 */     GIR_EraseRootFromParent_Done,
     /* 1343222 */   // Label 19185: @1343222
     /* 1343222 */   GIM_Try, /*On fail goto*//*Label 19186*/ GIMT_Encode4(1343306), // Rule ID 20182 //
     /* 1343227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1343244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1343247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343280 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1343283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343305 */     // GIR_Coverage, 20182,
     /* 1343305 */     GIR_EraseRootFromParent_Done,
     /* 1343306 */   // Label 19186: @1343306
     /* 1343306 */   GIM_Try, /*On fail goto*//*Label 19187*/ GIMT_Encode4(1343390), // Rule ID 20183 //
     /* 1343311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1343328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1343331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343364 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1343367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343389 */     // GIR_Coverage, 20183,
     /* 1343389 */     GIR_EraseRootFromParent_Done,
     /* 1343390 */   // Label 19187: @1343390
     /* 1343390 */   GIM_Try, /*On fail goto*//*Label 19188*/ GIMT_Encode4(1343474), // Rule ID 20186 //
     /* 1343395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1343412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1343415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343448 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343473 */     // GIR_Coverage, 20186,
     /* 1343473 */     GIR_EraseRootFromParent_Done,
     /* 1343474 */   // Label 19188: @1343474
     /* 1343474 */   GIM_Try, /*On fail goto*//*Label 19189*/ GIMT_Encode4(1343558), // Rule ID 20187 //
     /* 1343479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1343496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1343499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343532 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343557 */     // GIR_Coverage, 20187,
     /* 1343557 */     GIR_EraseRootFromParent_Done,
     /* 1343558 */   // Label 19189: @1343558
     /* 1343558 */   GIM_Try, /*On fail goto*//*Label 19190*/ GIMT_Encode4(1343642), // Rule ID 20190 //
     /* 1343563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1343580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1343583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343616 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343641 */     // GIR_Coverage, 20190,
     /* 1343641 */     GIR_EraseRootFromParent_Done,
     /* 1343642 */   // Label 19190: @1343642
     /* 1343642 */   GIM_Try, /*On fail goto*//*Label 19191*/ GIMT_Encode4(1343726), // Rule ID 20191 //
     /* 1343647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1343664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1343667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343700 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343725 */     // GIR_Coverage, 20191,
     /* 1343725 */     GIR_EraseRootFromParent_Done,
     /* 1343726 */   // Label 19191: @1343726
     /* 1343726 */   GIM_Try, /*On fail goto*//*Label 19192*/ GIMT_Encode4(1343810), // Rule ID 20194 //
     /* 1343731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1343748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1343751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343784 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1343787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343809 */     // GIR_Coverage, 20194,
     /* 1343809 */     GIR_EraseRootFromParent_Done,
     /* 1343810 */   // Label 19192: @1343810
     /* 1343810 */   GIM_Try, /*On fail goto*//*Label 19193*/ GIMT_Encode4(1343894), // Rule ID 20195 //
     /* 1343815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1343832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1343835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343868 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1343871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343893 */     // GIR_Coverage, 20195,
     /* 1343893 */     GIR_EraseRootFromParent_Done,
     /* 1343894 */   // Label 19193: @1343894
     /* 1343894 */   GIM_Try, /*On fail goto*//*Label 19194*/ GIMT_Encode4(1343978), // Rule ID 20198 //
     /* 1343899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1343916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1343919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343952 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343977 */     // GIR_Coverage, 20198,
     /* 1343977 */     GIR_EraseRootFromParent_Done,
     /* 1343978 */   // Label 19194: @1343978
     /* 1343978 */   GIM_Try, /*On fail goto*//*Label 19195*/ GIMT_Encode4(1344062), // Rule ID 20199 //
     /* 1343983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1344000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1344003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344036 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1344039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344061 */     // GIR_Coverage, 20199,
     /* 1344061 */     GIR_EraseRootFromParent_Done,
     /* 1344062 */   // Label 19195: @1344062
     /* 1344062 */   GIM_Try, /*On fail goto*//*Label 19196*/ GIMT_Encode4(1344146), // Rule ID 20202 //
     /* 1344067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1344070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1344084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1344087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344120 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1344123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344145 */     // GIR_Coverage, 20202,
     /* 1344145 */     GIR_EraseRootFromParent_Done,
     /* 1344146 */   // Label 19196: @1344146
     /* 1344146 */   GIM_Try, /*On fail goto*//*Label 19197*/ GIMT_Encode4(1344230), // Rule ID 20203 //
     /* 1344151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1344154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1344168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1344171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1344207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344229 */     // GIR_Coverage, 20203,
     /* 1344229 */     GIR_EraseRootFromParent_Done,
     /* 1344230 */   // Label 19197: @1344230
     /* 1344230 */   GIM_Try, /*On fail goto*//*Label 19198*/ GIMT_Encode4(1344314), // Rule ID 20206 //
     /* 1344235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1344252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344288 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1344291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344313 */     // GIR_Coverage, 20206,
     /* 1344313 */     GIR_EraseRootFromParent_Done,
     /* 1344314 */   // Label 19198: @1344314
     /* 1344314 */   GIM_Try, /*On fail goto*//*Label 19199*/ GIMT_Encode4(1344398), // Rule ID 20207 //
     /* 1344319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1344336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344372 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1344375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344397 */     // GIR_Coverage, 20207,
     /* 1344397 */     GIR_EraseRootFromParent_Done,
     /* 1344398 */   // Label 19199: @1344398
     /* 1344398 */   GIM_Try, /*On fail goto*//*Label 19200*/ GIMT_Encode4(1344482), // Rule ID 20210 //
     /* 1344403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1344420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344456 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1344459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344481 */     // GIR_Coverage, 20210,
     /* 1344481 */     GIR_EraseRootFromParent_Done,
     /* 1344482 */   // Label 19200: @1344482
     /* 1344482 */   GIM_Try, /*On fail goto*//*Label 19201*/ GIMT_Encode4(1344566), // Rule ID 20211 //
     /* 1344487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1344504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344540 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1344543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344565 */     // GIR_Coverage, 20211,
     /* 1344565 */     GIR_EraseRootFromParent_Done,
     /* 1344566 */   // Label 19201: @1344566
     /* 1344566 */   GIM_Try, /*On fail goto*//*Label 19202*/ GIMT_Encode4(1344650), // Rule ID 20214 //
     /* 1344571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1344588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344624 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1344627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344649 */     // GIR_Coverage, 20214,
     /* 1344649 */     GIR_EraseRootFromParent_Done,
     /* 1344650 */   // Label 19202: @1344650
     /* 1344650 */   GIM_Try, /*On fail goto*//*Label 19203*/ GIMT_Encode4(1344734), // Rule ID 20215 //
     /* 1344655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1344672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1344711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344733 */     // GIR_Coverage, 20215,
     /* 1344733 */     GIR_EraseRootFromParent_Done,
     /* 1344734 */   // Label 19203: @1344734
     /* 1344734 */   GIM_Try, /*On fail goto*//*Label 19204*/ GIMT_Encode4(1344818), // Rule ID 20218 //
     /* 1344739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1344756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344792 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1344795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344817 */     // GIR_Coverage, 20218,
     /* 1344817 */     GIR_EraseRootFromParent_Done,
     /* 1344818 */   // Label 19204: @1344818
     /* 1344818 */   GIM_Try, /*On fail goto*//*Label 19205*/ GIMT_Encode4(1344902), // Rule ID 20219 //
     /* 1344823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1344840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344876 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1344879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344901 */     // GIR_Coverage, 20219,
     /* 1344901 */     GIR_EraseRootFromParent_Done,
     /* 1344902 */   // Label 19205: @1344902
     /* 1344902 */   GIM_Try, /*On fail goto*//*Label 19206*/ GIMT_Encode4(1344986), // Rule ID 20222 //
     /* 1344907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1344924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344960 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1344963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344985 */     // GIR_Coverage, 20222,
     /* 1344985 */     GIR_EraseRootFromParent_Done,
     /* 1344986 */   // Label 19206: @1344986
     /* 1344986 */   GIM_Try, /*On fail goto*//*Label 19207*/ GIMT_Encode4(1345070), // Rule ID 20223 //
     /* 1344991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1345002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1345005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1345008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345044 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1345047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345069 */     // GIR_Coverage, 20223,
     /* 1345069 */     GIR_EraseRootFromParent_Done,
     /* 1345070 */   // Label 19207: @1345070
     /* 1345070 */   GIM_Try, /*On fail goto*//*Label 19208*/ GIMT_Encode4(1345154), // Rule ID 20226 //
     /* 1345075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1345078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1345092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1345117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345128 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1345131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345153 */     // GIR_Coverage, 20226,
     /* 1345153 */     GIR_EraseRootFromParent_Done,
     /* 1345154 */   // Label 19208: @1345154
     /* 1345154 */   GIM_Try, /*On fail goto*//*Label 19209*/ GIMT_Encode4(1345238), // Rule ID 20227 //
     /* 1345159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1345162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1345176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1345201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345212 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1345215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345237 */     // GIR_Coverage, 20227,
     /* 1345237 */     GIR_EraseRootFromParent_Done,
     /* 1345238 */   // Label 19209: @1345238
     /* 1345238 */   GIM_Try, /*On fail goto*//*Label 19210*/ GIMT_Encode4(1345322), // Rule ID 20230 //
     /* 1345243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1345260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345296 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1345299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345321 */     // GIR_Coverage, 20230,
     /* 1345321 */     GIR_EraseRootFromParent_Done,
     /* 1345322 */   // Label 19210: @1345322
     /* 1345322 */   GIM_Try, /*On fail goto*//*Label 19211*/ GIMT_Encode4(1345406), // Rule ID 20231 //
     /* 1345327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1345344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345380 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1345383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345405 */     // GIR_Coverage, 20231,
     /* 1345405 */     GIR_EraseRootFromParent_Done,
     /* 1345406 */   // Label 19211: @1345406
     /* 1345406 */   GIM_Try, /*On fail goto*//*Label 19212*/ GIMT_Encode4(1345490), // Rule ID 20234 //
     /* 1345411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1345428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345464 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1345467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345489 */     // GIR_Coverage, 20234,
     /* 1345489 */     GIR_EraseRootFromParent_Done,
     /* 1345490 */   // Label 19212: @1345490
     /* 1345490 */   GIM_Try, /*On fail goto*//*Label 19213*/ GIMT_Encode4(1345574), // Rule ID 20235 //
     /* 1345495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1345512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345548 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1345551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345573 */     // GIR_Coverage, 20235,
     /* 1345573 */     GIR_EraseRootFromParent_Done,
     /* 1345574 */   // Label 19213: @1345574
     /* 1345574 */   GIM_Try, /*On fail goto*//*Label 19214*/ GIMT_Encode4(1345658), // Rule ID 20238 //
     /* 1345579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1345590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1345593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1345596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1345602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345632 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1345635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345657 */     // GIR_Coverage, 20238,
     /* 1345657 */     GIR_EraseRootFromParent_Done,
     /* 1345658 */   // Label 19214: @1345658
     /* 1345658 */   GIM_Try, /*On fail goto*//*Label 19215*/ GIMT_Encode4(1345742), // Rule ID 20239 //
     /* 1345663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1345674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1345677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1345680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1345686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345716 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1345719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345741 */     // GIR_Coverage, 20239,
     /* 1345741 */     GIR_EraseRootFromParent_Done,
     /* 1345742 */   // Label 19215: @1345742
     /* 1345742 */   GIM_Try, /*On fail goto*//*Label 19216*/ GIMT_Encode4(1345826), // Rule ID 20242 //
     /* 1345747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1345764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345800 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1345803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345825 */     // GIR_Coverage, 20242,
     /* 1345825 */     GIR_EraseRootFromParent_Done,
     /* 1345826 */   // Label 19216: @1345826
     /* 1345826 */   GIM_Try, /*On fail goto*//*Label 19217*/ GIMT_Encode4(1345910), // Rule ID 20243 //
     /* 1345831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1345848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345884 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1345887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345909 */     // GIR_Coverage, 20243,
     /* 1345909 */     GIR_EraseRootFromParent_Done,
     /* 1345910 */   // Label 19217: @1345910
     /* 1345910 */   GIM_Try, /*On fail goto*//*Label 19218*/ GIMT_Encode4(1345994), // Rule ID 20246 //
     /* 1345915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1345932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345968 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1345971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345993 */     // GIR_Coverage, 20246,
     /* 1345993 */     GIR_EraseRootFromParent_Done,
     /* 1345994 */   // Label 19218: @1345994
     /* 1345994 */   GIM_Try, /*On fail goto*//*Label 19219*/ GIMT_Encode4(1346078), // Rule ID 20247 //
     /* 1345999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1346002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1346016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346052 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1346055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346077 */     // GIR_Coverage, 20247,
     /* 1346077 */     GIR_EraseRootFromParent_Done,
     /* 1346078 */   // Label 19219: @1346078
     /* 1346078 */   GIM_Try, /*On fail goto*//*Label 19220*/ GIMT_Encode4(1346162), // Rule ID 20250 //
     /* 1346083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1346094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1346097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1346100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346136 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1346139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346161 */     // GIR_Coverage, 20250,
     /* 1346161 */     GIR_EraseRootFromParent_Done,
     /* 1346162 */   // Label 19220: @1346162
     /* 1346162 */   GIM_Try, /*On fail goto*//*Label 19221*/ GIMT_Encode4(1346246), // Rule ID 20251 //
     /* 1346167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1346170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1346178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1346181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1346184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346220 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1346223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346245 */     // GIR_Coverage, 20251,
     /* 1346245 */     GIR_EraseRootFromParent_Done,
     /* 1346246 */   // Label 19221: @1346246
     /* 1346246 */   GIM_Try, /*On fail goto*//*Label 19222*/ GIMT_Encode4(1346330), // Rule ID 20254 //
     /* 1346251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1346268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1346307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346329 */     // GIR_Coverage, 20254,
     /* 1346329 */     GIR_EraseRootFromParent_Done,
     /* 1346330 */   // Label 19222: @1346330
     /* 1346330 */   GIM_Try, /*On fail goto*//*Label 19223*/ GIMT_Encode4(1346414), // Rule ID 20255 //
     /* 1346335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1346352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346388 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1346391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346413 */     // GIR_Coverage, 20255,
     /* 1346413 */     GIR_EraseRootFromParent_Done,
     /* 1346414 */   // Label 19223: @1346414
     /* 1346414 */   GIM_Try, /*On fail goto*//*Label 19224*/ GIMT_Encode4(1346498), // Rule ID 20258 //
     /* 1346419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1346436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346472 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1346475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346497 */     // GIR_Coverage, 20258,
     /* 1346497 */     GIR_EraseRootFromParent_Done,
     /* 1346498 */   // Label 19224: @1346498
     /* 1346498 */   GIM_Try, /*On fail goto*//*Label 19225*/ GIMT_Encode4(1346582), // Rule ID 20259 //
     /* 1346503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1346520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346556 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1346559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346581 */     // GIR_Coverage, 20259,
     /* 1346581 */     GIR_EraseRootFromParent_Done,
     /* 1346582 */   // Label 19225: @1346582
     /* 1346582 */   GIM_Try, /*On fail goto*//*Label 19226*/ GIMT_Encode4(1346666), // Rule ID 20262 //
     /* 1346587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1346604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346640 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1346643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346665 */     // GIR_Coverage, 20262,
     /* 1346665 */     GIR_EraseRootFromParent_Done,
     /* 1346666 */   // Label 19226: @1346666
     /* 1346666 */   GIM_Try, /*On fail goto*//*Label 19227*/ GIMT_Encode4(1346750), // Rule ID 20263 //
     /* 1346671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1346688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346724 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1346727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346749 */     // GIR_Coverage, 20263,
     /* 1346749 */     GIR_EraseRootFromParent_Done,
     /* 1346750 */   // Label 19227: @1346750
     /* 1346750 */   GIM_Try, /*On fail goto*//*Label 19228*/ GIMT_Encode4(1346834), // Rule ID 20266 //
     /* 1346755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1346772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346808 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1346811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346833 */     // GIR_Coverage, 20266,
     /* 1346833 */     GIR_EraseRootFromParent_Done,
     /* 1346834 */   // Label 19228: @1346834
     /* 1346834 */   GIM_Try, /*On fail goto*//*Label 19229*/ GIMT_Encode4(1346918), // Rule ID 20267 //
     /* 1346839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1346856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346892 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1346895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346917 */     // GIR_Coverage, 20267,
     /* 1346917 */     GIR_EraseRootFromParent_Done,
     /* 1346918 */   // Label 19229: @1346918
     /* 1346918 */   GIM_Try, /*On fail goto*//*Label 19230*/ GIMT_Encode4(1347002), // Rule ID 20270 //
     /* 1346923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1346940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346976 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1346979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347001 */     // GIR_Coverage, 20270,
     /* 1347001 */     GIR_EraseRootFromParent_Done,
     /* 1347002 */   // Label 19230: @1347002
     /* 1347002 */   GIM_Try, /*On fail goto*//*Label 19231*/ GIMT_Encode4(1347086), // Rule ID 20271 //
     /* 1347007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1347024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347060 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1347063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347085 */     // GIR_Coverage, 20271,
     /* 1347085 */     GIR_EraseRootFromParent_Done,
     /* 1347086 */   // Label 19231: @1347086
     /* 1347086 */   GIM_Try, /*On fail goto*//*Label 19232*/ GIMT_Encode4(1347170), // Rule ID 20274 //
     /* 1347091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1347094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1347108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347144 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1347147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347169 */     // GIR_Coverage, 20274,
     /* 1347169 */     GIR_EraseRootFromParent_Done,
     /* 1347170 */   // Label 19232: @1347170
     /* 1347170 */   GIM_Try, /*On fail goto*//*Label 19233*/ GIMT_Encode4(1347254), // Rule ID 20275 //
     /* 1347175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1347178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1347192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347228 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1347231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347253 */     // GIR_Coverage, 20275,
     /* 1347253 */     GIR_EraseRootFromParent_Done,
     /* 1347254 */   // Label 19233: @1347254
     /* 1347254 */   GIM_Try, /*On fail goto*//*Label 19234*/ GIMT_Encode4(1347338), // Rule ID 20278 //
     /* 1347259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1347276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347312 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1347315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347337 */     // GIR_Coverage, 20278,
     /* 1347337 */     GIR_EraseRootFromParent_Done,
     /* 1347338 */   // Label 19234: @1347338
     /* 1347338 */   GIM_Try, /*On fail goto*//*Label 19235*/ GIMT_Encode4(1347422), // Rule ID 20279 //
     /* 1347343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1347360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347396 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1347399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347421 */     // GIR_Coverage, 20279,
     /* 1347421 */     GIR_EraseRootFromParent_Done,
     /* 1347422 */   // Label 19235: @1347422
     /* 1347422 */   GIM_Try, /*On fail goto*//*Label 19236*/ GIMT_Encode4(1347506), // Rule ID 20282 //
     /* 1347427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1347430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1347444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347480 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1347483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347505 */     // GIR_Coverage, 20282,
     /* 1347505 */     GIR_EraseRootFromParent_Done,
     /* 1347506 */   // Label 19236: @1347506
     /* 1347506 */   GIM_Try, /*On fail goto*//*Label 19237*/ GIMT_Encode4(1347590), // Rule ID 20283 //
     /* 1347511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1347514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1347528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347564 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1347567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347589 */     // GIR_Coverage, 20283,
     /* 1347589 */     GIR_EraseRootFromParent_Done,
     /* 1347590 */   // Label 19237: @1347590
     /* 1347590 */   GIM_Try, /*On fail goto*//*Label 19238*/ GIMT_Encode4(1347674), // Rule ID 20286 //
     /* 1347595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1347598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1347612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1347637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347648 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1347651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347673 */     // GIR_Coverage, 20286,
     /* 1347673 */     GIR_EraseRootFromParent_Done,
     /* 1347674 */   // Label 19238: @1347674
     /* 1347674 */   GIM_Try, /*On fail goto*//*Label 19239*/ GIMT_Encode4(1347758), // Rule ID 20287 //
     /* 1347679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1347682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1347696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1347721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347732 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1347735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347757 */     // GIR_Coverage, 20287,
     /* 1347757 */     GIR_EraseRootFromParent_Done,
     /* 1347758 */   // Label 19239: @1347758
     /* 1347758 */   GIM_Try, /*On fail goto*//*Label 19240*/ GIMT_Encode4(1347842), // Rule ID 20290 //
     /* 1347763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1347780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1347819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347841 */     // GIR_Coverage, 20290,
     /* 1347841 */     GIR_EraseRootFromParent_Done,
     /* 1347842 */   // Label 19240: @1347842
     /* 1347842 */   GIM_Try, /*On fail goto*//*Label 19241*/ GIMT_Encode4(1347926), // Rule ID 20291 //
     /* 1347847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1347864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347900 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1347903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347925 */     // GIR_Coverage, 20291,
     /* 1347925 */     GIR_EraseRootFromParent_Done,
     /* 1347926 */   // Label 19241: @1347926
     /* 1347926 */   GIM_Try, /*On fail goto*//*Label 19242*/ GIMT_Encode4(1348010), // Rule ID 20294 //
     /* 1347931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1347942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1347945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1347948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1347954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347984 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1347987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348009 */     // GIR_Coverage, 20294,
     /* 1348009 */     GIR_EraseRootFromParent_Done,
     /* 1348010 */   // Label 19242: @1348010
     /* 1348010 */   GIM_Try, /*On fail goto*//*Label 19243*/ GIMT_Encode4(1348094), // Rule ID 20295 //
     /* 1348015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1348018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1348032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348068 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1348071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348093 */     // GIR_Coverage, 20295,
     /* 1348093 */     GIR_EraseRootFromParent_Done,
     /* 1348094 */   // Label 19243: @1348094
     /* 1348094 */   GIM_Try, /*On fail goto*//*Label 19244*/ GIMT_Encode4(1348178), // Rule ID 20298 //
     /* 1348099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1348110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1348113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1348116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1348122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348152 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1348155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348177 */     // GIR_Coverage, 20298,
     /* 1348177 */     GIR_EraseRootFromParent_Done,
     /* 1348178 */   // Label 19244: @1348178
     /* 1348178 */   GIM_Try, /*On fail goto*//*Label 19245*/ GIMT_Encode4(1348262), // Rule ID 20299 //
     /* 1348183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1348186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1348194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1348197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1348200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1348206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348236 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1348239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348261 */     // GIR_Coverage, 20299,
     /* 1348261 */     GIR_EraseRootFromParent_Done,
     /* 1348262 */   // Label 19245: @1348262
     /* 1348262 */   GIM_Try, /*On fail goto*//*Label 19246*/ GIMT_Encode4(1348346), // Rule ID 20302 //
     /* 1348267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1348284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348320 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1348323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348345 */     // GIR_Coverage, 20302,
     /* 1348345 */     GIR_EraseRootFromParent_Done,
     /* 1348346 */   // Label 19246: @1348346
     /* 1348346 */   GIM_Try, /*On fail goto*//*Label 19247*/ GIMT_Encode4(1348430), // Rule ID 20303 //
     /* 1348351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1348368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348404 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1348407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348429 */     // GIR_Coverage, 20303,
     /* 1348429 */     GIR_EraseRootFromParent_Done,
     /* 1348430 */   // Label 19247: @1348430
     /* 1348430 */   GIM_Try, /*On fail goto*//*Label 19248*/ GIMT_Encode4(1348514), // Rule ID 20306 //
     /* 1348435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1348452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348488 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1348491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348513 */     // GIR_Coverage, 20306,
     /* 1348513 */     GIR_EraseRootFromParent_Done,
     /* 1348514 */   // Label 19248: @1348514
     /* 1348514 */   GIM_Try, /*On fail goto*//*Label 19249*/ GIMT_Encode4(1348598), // Rule ID 20307 //
     /* 1348519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1348536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348572 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1348575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348597 */     // GIR_Coverage, 20307,
     /* 1348597 */     GIR_EraseRootFromParent_Done,
     /* 1348598 */   // Label 19249: @1348598
     /* 1348598 */   GIM_Try, /*On fail goto*//*Label 19250*/ GIMT_Encode4(1348682), // Rule ID 20310 //
     /* 1348603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1348620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348656 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1348659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348681 */     // GIR_Coverage, 20310,
     /* 1348681 */     GIR_EraseRootFromParent_Done,
     /* 1348682 */   // Label 19250: @1348682
     /* 1348682 */   GIM_Try, /*On fail goto*//*Label 19251*/ GIMT_Encode4(1348766), // Rule ID 20311 //
     /* 1348687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1348704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348740 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1348743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348765 */     // GIR_Coverage, 20311,
     /* 1348765 */     GIR_EraseRootFromParent_Done,
     /* 1348766 */   // Label 19251: @1348766
     /* 1348766 */   GIM_Try, /*On fail goto*//*Label 19252*/ GIMT_Encode4(1348850), // Rule ID 20314 //
     /* 1348771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1348788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348824 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1348827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348849 */     // GIR_Coverage, 20314,
     /* 1348849 */     GIR_EraseRootFromParent_Done,
     /* 1348850 */   // Label 19252: @1348850
     /* 1348850 */   GIM_Try, /*On fail goto*//*Label 19253*/ GIMT_Encode4(1348934), // Rule ID 20315 //
     /* 1348855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1348858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1348872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348908 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1348911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348933 */     // GIR_Coverage, 20315,
     /* 1348933 */     GIR_EraseRootFromParent_Done,
     /* 1348934 */   // Label 19253: @1348934
     /* 1348934 */   GIM_Try, /*On fail goto*//*Label 19254*/ GIMT_Encode4(1349018), // Rule ID 20318 //
     /* 1348939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1348956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348992 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1348995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349017 */     // GIR_Coverage, 20318,
     /* 1349017 */     GIR_EraseRootFromParent_Done,
     /* 1349018 */   // Label 19254: @1349018
     /* 1349018 */   GIM_Try, /*On fail goto*//*Label 19255*/ GIMT_Encode4(1349102), // Rule ID 20319 //
     /* 1349023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1349026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1349040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1349061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1349079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349101 */     // GIR_Coverage, 20319,
     /* 1349101 */     GIR_EraseRootFromParent_Done,
     /* 1349102 */   // Label 19255: @1349102
     /* 1349102 */   GIM_Try, /*On fail goto*//*Label 19256*/ GIMT_Encode4(1349186), // Rule ID 20322 //
     /* 1349107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1349110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1349124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349160 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1349163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349185 */     // GIR_Coverage, 20322,
     /* 1349185 */     GIR_EraseRootFromParent_Done,
     /* 1349186 */   // Label 19256: @1349186
     /* 1349186 */   GIM_Try, /*On fail goto*//*Label 19257*/ GIMT_Encode4(1349270), // Rule ID 20323 //
     /* 1349191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1349194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1349208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349244 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1349247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349269 */     // GIR_Coverage, 20323,
     /* 1349269 */     GIR_EraseRootFromParent_Done,
     /* 1349270 */   // Label 19257: @1349270
     /* 1349270 */   GIM_Try, /*On fail goto*//*Label 19258*/ GIMT_Encode4(1349354), // Rule ID 20326 //
     /* 1349275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1349292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349328 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1349331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349353 */     // GIR_Coverage, 20326,
     /* 1349353 */     GIR_EraseRootFromParent_Done,
     /* 1349354 */   // Label 19258: @1349354
     /* 1349354 */   GIM_Try, /*On fail goto*//*Label 19259*/ GIMT_Encode4(1349438), // Rule ID 20327 //
     /* 1349359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1349376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349412 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1349415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349437 */     // GIR_Coverage, 20327,
     /* 1349437 */     GIR_EraseRootFromParent_Done,
     /* 1349438 */   // Label 19259: @1349438
     /* 1349438 */   GIM_Try, /*On fail goto*//*Label 19260*/ GIMT_Encode4(1349522), // Rule ID 20330 //
     /* 1349443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1349460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349496 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1349499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349521 */     // GIR_Coverage, 20330,
     /* 1349521 */     GIR_EraseRootFromParent_Done,
     /* 1349522 */   // Label 19260: @1349522
     /* 1349522 */   GIM_Try, /*On fail goto*//*Label 19261*/ GIMT_Encode4(1349606), // Rule ID 20331 //
     /* 1349527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1349544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1349583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349605 */     // GIR_Coverage, 20331,
     /* 1349605 */     GIR_EraseRootFromParent_Done,
     /* 1349606 */   // Label 19261: @1349606
     /* 1349606 */   GIM_Try, /*On fail goto*//*Label 19262*/ GIMT_Encode4(1349690), // Rule ID 20334 //
     /* 1349611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1349628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349664 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1349667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349689 */     // GIR_Coverage, 20334,
     /* 1349689 */     GIR_EraseRootFromParent_Done,
     /* 1349690 */   // Label 19262: @1349690
     /* 1349690 */   GIM_Try, /*On fail goto*//*Label 19263*/ GIMT_Encode4(1349774), // Rule ID 20335 //
     /* 1349695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1349712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349748 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1349751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349773 */     // GIR_Coverage, 20335,
     /* 1349773 */     GIR_EraseRootFromParent_Done,
     /* 1349774 */   // Label 19263: @1349774
     /* 1349774 */   GIM_Try, /*On fail goto*//*Label 19264*/ GIMT_Encode4(1349858), // Rule ID 20338 //
     /* 1349779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1349796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349832 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1349835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349857 */     // GIR_Coverage, 20338,
     /* 1349857 */     GIR_EraseRootFromParent_Done,
     /* 1349858 */   // Label 19264: @1349858
     /* 1349858 */   GIM_Try, /*On fail goto*//*Label 19265*/ GIMT_Encode4(1349942), // Rule ID 20339 //
     /* 1349863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1349880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349916 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1349919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349941 */     // GIR_Coverage, 20339,
     /* 1349941 */     GIR_EraseRootFromParent_Done,
     /* 1349942 */   // Label 19265: @1349942
     /* 1349942 */   GIM_Try, /*On fail goto*//*Label 19266*/ GIMT_Encode4(1350026), // Rule ID 20342 //
     /* 1349947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1349964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1350003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350025 */     // GIR_Coverage, 20342,
     /* 1350025 */     GIR_EraseRootFromParent_Done,
     /* 1350026 */   // Label 19266: @1350026
     /* 1350026 */   GIM_Try, /*On fail goto*//*Label 19267*/ GIMT_Encode4(1350110), // Rule ID 20343 //
     /* 1350031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1350042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1350045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1350048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350084 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1350087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350109 */     // GIR_Coverage, 20343,
     /* 1350109 */     GIR_EraseRootFromParent_Done,
     /* 1350110 */   // Label 19267: @1350110
     /* 1350110 */   GIM_Try, /*On fail goto*//*Label 19268*/ GIMT_Encode4(1350194), // Rule ID 20346 //
     /* 1350115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1350118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1350126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1350129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1350132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1350157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350168 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1350171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350193 */     // GIR_Coverage, 20346,
     /* 1350193 */     GIR_EraseRootFromParent_Done,
     /* 1350194 */   // Label 19268: @1350194
     /* 1350194 */   GIM_Try, /*On fail goto*//*Label 19269*/ GIMT_Encode4(1350278), // Rule ID 20347 //
     /* 1350199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1350202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1350210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1350213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1350216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1350241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350252 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1350255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350277 */     // GIR_Coverage, 20347,
     /* 1350277 */     GIR_EraseRootFromParent_Done,
     /* 1350278 */   // Label 19269: @1350278
     /* 1350278 */   GIM_Try, /*On fail goto*//*Label 19270*/ GIMT_Encode4(1350362), // Rule ID 20350 //
     /* 1350283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1350300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350336 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1350339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350361 */     // GIR_Coverage, 20350,
     /* 1350361 */     GIR_EraseRootFromParent_Done,
     /* 1350362 */   // Label 19270: @1350362
     /* 1350362 */   GIM_Try, /*On fail goto*//*Label 19271*/ GIMT_Encode4(1350446), // Rule ID 20351 //
     /* 1350367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1350384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350420 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1350423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350445 */     // GIR_Coverage, 20351,
     /* 1350445 */     GIR_EraseRootFromParent_Done,
     /* 1350446 */   // Label 19271: @1350446
     /* 1350446 */   GIM_Try, /*On fail goto*//*Label 19272*/ GIMT_Encode4(1350530), // Rule ID 20354 //
     /* 1350451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1350468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350504 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1350507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350529 */     // GIR_Coverage, 20354,
     /* 1350529 */     GIR_EraseRootFromParent_Done,
     /* 1350530 */   // Label 19272: @1350530
     /* 1350530 */   GIM_Try, /*On fail goto*//*Label 19273*/ GIMT_Encode4(1350614), // Rule ID 20355 //
     /* 1350535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1350552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350588 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1350591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350613 */     // GIR_Coverage, 20355,
     /* 1350613 */     GIR_EraseRootFromParent_Done,
     /* 1350614 */   // Label 19273: @1350614
     /* 1350614 */   GIM_Try, /*On fail goto*//*Label 19274*/ GIMT_Encode4(1350698), // Rule ID 20358 //
     /* 1350619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1350630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1350633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1350636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1350642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350672 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1350675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350697 */     // GIR_Coverage, 20358,
     /* 1350697 */     GIR_EraseRootFromParent_Done,
     /* 1350698 */   // Label 19274: @1350698
     /* 1350698 */   GIM_Try, /*On fail goto*//*Label 19275*/ GIMT_Encode4(1350782), // Rule ID 20359 //
     /* 1350703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1350714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1350717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1350720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1350726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350756 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1350759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350781 */     // GIR_Coverage, 20359,
     /* 1350781 */     GIR_EraseRootFromParent_Done,
     /* 1350782 */   // Label 19275: @1350782
     /* 1350782 */   GIM_Try, /*On fail goto*//*Label 19276*/ GIMT_Encode4(1350866), // Rule ID 20362 //
     /* 1350787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1350804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1350843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350865 */     // GIR_Coverage, 20362,
     /* 1350865 */     GIR_EraseRootFromParent_Done,
     /* 1350866 */   // Label 19276: @1350866
     /* 1350866 */   GIM_Try, /*On fail goto*//*Label 19277*/ GIMT_Encode4(1350950), // Rule ID 20363 //
     /* 1350871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1350888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350924 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1350927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350949 */     // GIR_Coverage, 20363,
     /* 1350949 */     GIR_EraseRootFromParent_Done,
     /* 1350950 */   // Label 19277: @1350950
     /* 1350950 */   GIM_Try, /*On fail goto*//*Label 19278*/ GIMT_Encode4(1351034), // Rule ID 20366 //
     /* 1350955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1350972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351008 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1351011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351033 */     // GIR_Coverage, 20366,
     /* 1351033 */     GIR_EraseRootFromParent_Done,
     /* 1351034 */   // Label 19278: @1351034
     /* 1351034 */   GIM_Try, /*On fail goto*//*Label 19279*/ GIMT_Encode4(1351118), // Rule ID 20367 //
     /* 1351039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1351042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1351056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1351081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351092 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1351095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351117 */     // GIR_Coverage, 20367,
     /* 1351117 */     GIR_EraseRootFromParent_Done,
     /* 1351118 */   // Label 19279: @1351118
     /* 1351118 */   GIM_Try, /*On fail goto*//*Label 19280*/ GIMT_Encode4(1351202), // Rule ID 20370 //
     /* 1351123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1351126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1351134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1351137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1351140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1351146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1351165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351176 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1351179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351201 */     // GIR_Coverage, 20370,
     /* 1351201 */     GIR_EraseRootFromParent_Done,
     /* 1351202 */   // Label 19280: @1351202
     /* 1351202 */   GIM_Try, /*On fail goto*//*Label 19281*/ GIMT_Encode4(1351286), // Rule ID 20371 //
     /* 1351207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1351210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1351218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1351221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1351224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1351230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1351249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351260 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1351263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351285 */     // GIR_Coverage, 20371,
     /* 1351285 */     GIR_EraseRootFromParent_Done,
     /* 1351286 */   // Label 19281: @1351286
     /* 1351286 */   GIM_Try, /*On fail goto*//*Label 19282*/ GIMT_Encode4(1351370), // Rule ID 20374 //
     /* 1351291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1351308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351344 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1351347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351369 */     // GIR_Coverage, 20374,
     /* 1351369 */     GIR_EraseRootFromParent_Done,
     /* 1351370 */   // Label 19282: @1351370
     /* 1351370 */   GIM_Try, /*On fail goto*//*Label 19283*/ GIMT_Encode4(1351454), // Rule ID 20375 //
     /* 1351375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1351392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351428 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1351431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351453 */     // GIR_Coverage, 20375,
     /* 1351453 */     GIR_EraseRootFromParent_Done,
     /* 1351454 */   // Label 19283: @1351454
     /* 1351454 */   GIM_Try, /*On fail goto*//*Label 19284*/ GIMT_Encode4(1351538), // Rule ID 20378 //
     /* 1351459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1351476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1351515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351537 */     // GIR_Coverage, 20378,
     /* 1351537 */     GIR_EraseRootFromParent_Done,
     /* 1351538 */   // Label 19284: @1351538
     /* 1351538 */   GIM_Try, /*On fail goto*//*Label 19285*/ GIMT_Encode4(1351622), // Rule ID 20379 //
     /* 1351543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1351560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351596 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1351599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351621 */     // GIR_Coverage, 20379,
     /* 1351621 */     GIR_EraseRootFromParent_Done,
     /* 1351622 */   // Label 19285: @1351622
     /* 1351622 */   GIM_Try, /*On fail goto*//*Label 19286*/ GIMT_Encode4(1351706), // Rule ID 20382 //
     /* 1351627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1351644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351680 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1351683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351705 */     // GIR_Coverage, 20382,
     /* 1351705 */     GIR_EraseRootFromParent_Done,
     /* 1351706 */   // Label 19286: @1351706
     /* 1351706 */   GIM_Try, /*On fail goto*//*Label 19287*/ GIMT_Encode4(1351790), // Rule ID 20383 //
     /* 1351711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1351728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351764 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1351767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351789 */     // GIR_Coverage, 20383,
     /* 1351789 */     GIR_EraseRootFromParent_Done,
     /* 1351790 */   // Label 19287: @1351790
     /* 1351790 */   GIM_Try, /*On fail goto*//*Label 19288*/ GIMT_Encode4(1351874), // Rule ID 20386 //
     /* 1351795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1351812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1351815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351848 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1351851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351873 */     // GIR_Coverage, 20386,
     /* 1351873 */     GIR_EraseRootFromParent_Done,
     /* 1351874 */   // Label 19288: @1351874
     /* 1351874 */   GIM_Try, /*On fail goto*//*Label 19289*/ GIMT_Encode4(1351958), // Rule ID 20387 //
     /* 1351879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1351896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1351899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351932 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1351935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351957 */     // GIR_Coverage, 20387,
     /* 1351957 */     GIR_EraseRootFromParent_Done,
     /* 1351958 */   // Label 19289: @1351958
     /* 1351958 */   GIM_Try, /*On fail goto*//*Label 19290*/ GIMT_Encode4(1352042), // Rule ID 20390 //
     /* 1351963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1351980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1351983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352016 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1352019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352041 */     // GIR_Coverage, 20390,
     /* 1352041 */     GIR_EraseRootFromParent_Done,
     /* 1352042 */   // Label 19290: @1352042
     /* 1352042 */   GIM_Try, /*On fail goto*//*Label 19291*/ GIMT_Encode4(1352126), // Rule ID 20391 //
     /* 1352047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1352064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1352067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352100 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1352103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352125 */     // GIR_Coverage, 20391,
     /* 1352125 */     GIR_EraseRootFromParent_Done,
     /* 1352126 */   // Label 19291: @1352126
     /* 1352126 */   GIM_Try, /*On fail goto*//*Label 19292*/ GIMT_Encode4(1352210), // Rule ID 20394 //
     /* 1352131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1352134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1352148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1352151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352184 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1352187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352209 */     // GIR_Coverage, 20394,
     /* 1352209 */     GIR_EraseRootFromParent_Done,
     /* 1352210 */   // Label 19292: @1352210
     /* 1352210 */   GIM_Try, /*On fail goto*//*Label 19293*/ GIMT_Encode4(1352294), // Rule ID 20395 //
     /* 1352215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1352232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1352235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352268 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1352271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352293 */     // GIR_Coverage, 20395,
     /* 1352293 */     GIR_EraseRootFromParent_Done,
     /* 1352294 */   // Label 19293: @1352294
     /* 1352294 */   GIM_Try, /*On fail goto*//*Label 19294*/ GIMT_Encode4(1352378), // Rule ID 20398 //
     /* 1352299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1352310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1352313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1352316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1352319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352352 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352377 */     // GIR_Coverage, 20398,
     /* 1352377 */     GIR_EraseRootFromParent_Done,
     /* 1352378 */   // Label 19294: @1352378
     /* 1352378 */   GIM_Try, /*On fail goto*//*Label 19295*/ GIMT_Encode4(1352462), // Rule ID 20399 //
     /* 1352383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1352394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1352397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1352400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1352403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352436 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352461 */     // GIR_Coverage, 20399,
     /* 1352461 */     GIR_EraseRootFromParent_Done,
     /* 1352462 */   // Label 19295: @1352462
     /* 1352462 */   GIM_Try, /*On fail goto*//*Label 19296*/ GIMT_Encode4(1352546), // Rule ID 20402 //
     /* 1352467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1352470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1352484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1352487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352520 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352545 */     // GIR_Coverage, 20402,
     /* 1352545 */     GIR_EraseRootFromParent_Done,
     /* 1352546 */   // Label 19296: @1352546
     /* 1352546 */   GIM_Try, /*On fail goto*//*Label 19297*/ GIMT_Encode4(1352630), // Rule ID 20403 //
     /* 1352551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1352568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1352571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352604 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352629 */     // GIR_Coverage, 20403,
     /* 1352629 */     GIR_EraseRootFromParent_Done,
     /* 1352630 */   // Label 19297: @1352630
     /* 1352630 */   GIM_Try, /*On fail goto*//*Label 19298*/ GIMT_Encode4(1352714), // Rule ID 20406 //
     /* 1352635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1352638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1352652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1352655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352713 */     // GIR_Coverage, 20406,
     /* 1352713 */     GIR_EraseRootFromParent_Done,
     /* 1352714 */   // Label 19298: @1352714
     /* 1352714 */   GIM_Try, /*On fail goto*//*Label 19299*/ GIMT_Encode4(1352798), // Rule ID 20407 //
     /* 1352719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1352722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1352736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1352739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352772 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352797 */     // GIR_Coverage, 20407,
     /* 1352797 */     GIR_EraseRootFromParent_Done,
     /* 1352798 */   // Label 19299: @1352798
     /* 1352798 */   GIM_Try, /*On fail goto*//*Label 19300*/ GIMT_Encode4(1352882), // Rule ID 20410 //
     /* 1352803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1352814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1352817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1352820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1352823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352856 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1352859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352881 */     // GIR_Coverage, 20410,
     /* 1352881 */     GIR_EraseRootFromParent_Done,
     /* 1352882 */   // Label 19300: @1352882
     /* 1352882 */   GIM_Try, /*On fail goto*//*Label 19301*/ GIMT_Encode4(1352966), // Rule ID 20411 //
     /* 1352887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1352898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1352901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1352904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1352907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352940 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1352943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352965 */     // GIR_Coverage, 20411,
     /* 1352965 */     GIR_EraseRootFromParent_Done,
     /* 1352966 */   // Label 19301: @1352966
     /* 1352966 */   GIM_Try, /*On fail goto*//*Label 19302*/ GIMT_Encode4(1353050), // Rule ID 20414 //
     /* 1352971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1352982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1352985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1352988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1352991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353024 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353049 */     // GIR_Coverage, 20414,
     /* 1353049 */     GIR_EraseRootFromParent_Done,
     /* 1353050 */   // Label 19302: @1353050
     /* 1353050 */   GIM_Try, /*On fail goto*//*Label 19303*/ GIMT_Encode4(1353134), // Rule ID 20415 //
     /* 1353055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1353058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1353072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1353075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353108 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353133 */     // GIR_Coverage, 20415,
     /* 1353133 */     GIR_EraseRootFromParent_Done,
     /* 1353134 */   // Label 19303: @1353134
     /* 1353134 */   GIM_Try, /*On fail goto*//*Label 19304*/ GIMT_Encode4(1353218), // Rule ID 20418 //
     /* 1353139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1353142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1353150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1353153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1353156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1353159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1353162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353192 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353217 */     // GIR_Coverage, 20418,
     /* 1353217 */     GIR_EraseRootFromParent_Done,
     /* 1353218 */   // Label 19304: @1353218
     /* 1353218 */   GIM_Try, /*On fail goto*//*Label 19305*/ GIMT_Encode4(1353302), // Rule ID 20419 //
     /* 1353223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1353226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1353234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1353237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1353240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1353243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1353246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353276 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353301 */     // GIR_Coverage, 20419,
     /* 1353301 */     GIR_EraseRootFromParent_Done,
     /* 1353302 */   // Label 19305: @1353302
     /* 1353302 */   GIM_Try, /*On fail goto*//*Label 19306*/ GIMT_Encode4(1353386), // Rule ID 20422 //
     /* 1353307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1353324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1353327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353360 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1353363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353385 */     // GIR_Coverage, 20422,
     /* 1353385 */     GIR_EraseRootFromParent_Done,
     /* 1353386 */   // Label 19306: @1353386
     /* 1353386 */   GIM_Try, /*On fail goto*//*Label 19307*/ GIMT_Encode4(1353470), // Rule ID 20423 //
     /* 1353391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1353408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1353411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353444 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1353447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353469 */     // GIR_Coverage, 20423,
     /* 1353469 */     GIR_EraseRootFromParent_Done,
     /* 1353470 */   // Label 19307: @1353470
     /* 1353470 */   GIM_Try, /*On fail goto*//*Label 19308*/ GIMT_Encode4(1353554), // Rule ID 20426 //
     /* 1353475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1353495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353528 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353553 */     // GIR_Coverage, 20426,
     /* 1353553 */     GIR_EraseRootFromParent_Done,
     /* 1353554 */   // Label 19308: @1353554
     /* 1353554 */   GIM_Try, /*On fail goto*//*Label 19309*/ GIMT_Encode4(1353638), // Rule ID 20427 //
     /* 1353559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1353579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353612 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353637 */     // GIR_Coverage, 20427,
     /* 1353637 */     GIR_EraseRootFromParent_Done,
     /* 1353638 */   // Label 19309: @1353638
     /* 1353638 */   GIM_Try, /*On fail goto*//*Label 19310*/ GIMT_Encode4(1353722), // Rule ID 20430 //
     /* 1353643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1353663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353696 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353721 */     // GIR_Coverage, 20430,
     /* 1353721 */     GIR_EraseRootFromParent_Done,
     /* 1353722 */   // Label 19310: @1353722
     /* 1353722 */   GIM_Try, /*On fail goto*//*Label 19311*/ GIMT_Encode4(1353806), // Rule ID 20431 //
     /* 1353727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1353747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353780 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353805 */     // GIR_Coverage, 20431,
     /* 1353805 */     GIR_EraseRootFromParent_Done,
     /* 1353806 */   // Label 19311: @1353806
     /* 1353806 */   GIM_Try, /*On fail goto*//*Label 19312*/ GIMT_Encode4(1353890), // Rule ID 20434 //
     /* 1353811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1353822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1353825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1353831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353864 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1353867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353889 */     // GIR_Coverage, 20434,
     /* 1353889 */     GIR_EraseRootFromParent_Done,
     /* 1353890 */   // Label 19312: @1353890
     /* 1353890 */   GIM_Try, /*On fail goto*//*Label 19313*/ GIMT_Encode4(1353974), // Rule ID 20435 //
     /* 1353895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1353906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1353909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1353915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353948 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1353951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353973 */     // GIR_Coverage, 20435,
     /* 1353973 */     GIR_EraseRootFromParent_Done,
     /* 1353974 */   // Label 19313: @1353974
     /* 1353974 */   GIM_Try, /*On fail goto*//*Label 19314*/ GIMT_Encode4(1354058), // Rule ID 20438 //
     /* 1353979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1353996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1353999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354032 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1354035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354057 */     // GIR_Coverage, 20438,
     /* 1354057 */     GIR_EraseRootFromParent_Done,
     /* 1354058 */   // Label 19314: @1354058
     /* 1354058 */   GIM_Try, /*On fail goto*//*Label 19315*/ GIMT_Encode4(1354142), // Rule ID 20439 //
     /* 1354063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1354071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1354080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1354083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354116 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1354119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354141 */     // GIR_Coverage, 20439,
     /* 1354141 */     GIR_EraseRootFromParent_Done,
     /* 1354142 */   // Label 19315: @1354142
     /* 1354142 */   GIM_Try, /*On fail goto*//*Label 19316*/ GIMT_Encode4(1354226), // Rule ID 20442 //
     /* 1354147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1354150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1354155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1354158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1354161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1354164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1354167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354200 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1354203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354225 */     // GIR_Coverage, 20442,
     /* 1354225 */     GIR_EraseRootFromParent_Done,
     /* 1354226 */   // Label 19316: @1354226
     /* 1354226 */   GIM_Try, /*On fail goto*//*Label 19317*/ GIMT_Encode4(1354310), // Rule ID 20443 //
     /* 1354231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1354239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1354242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1354245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1354248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1354251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354284 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1354287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354309 */     // GIR_Coverage, 20443,
     /* 1354309 */     GIR_EraseRootFromParent_Done,
     /* 1354310 */   // Label 19317: @1354310
     /* 1354310 */   GIM_Try, /*On fail goto*//*Label 19318*/ GIMT_Encode4(1354394), // Rule ID 20446 //
     /* 1354315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1354332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1354335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354368 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1354371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354393 */     // GIR_Coverage, 20446,
     /* 1354393 */     GIR_EraseRootFromParent_Done,
     /* 1354394 */   // Label 19318: @1354394
     /* 1354394 */   GIM_Try, /*On fail goto*//*Label 19319*/ GIMT_Encode4(1354478), // Rule ID 20447 //
     /* 1354399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1354416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1354419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354452 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1354455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354477 */     // GIR_Coverage, 20447,
     /* 1354477 */     GIR_EraseRootFromParent_Done,
     /* 1354478 */   // Label 19319: @1354478
     /* 1354478 */   GIM_Try, /*On fail goto*//*Label 19320*/ GIMT_Encode4(1354562), // Rule ID 20450 //
     /* 1354483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1354500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1354503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354536 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354561 */     // GIR_Coverage, 20450,
     /* 1354561 */     GIR_EraseRootFromParent_Done,
     /* 1354562 */   // Label 19320: @1354562
     /* 1354562 */   GIM_Try, /*On fail goto*//*Label 19321*/ GIMT_Encode4(1354646), // Rule ID 20451 //
     /* 1354567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1354584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1354587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354620 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354645 */     // GIR_Coverage, 20451,
     /* 1354645 */     GIR_EraseRootFromParent_Done,
     /* 1354646 */   // Label 19321: @1354646
     /* 1354646 */   GIM_Try, /*On fail goto*//*Label 19322*/ GIMT_Encode4(1354730), // Rule ID 20454 //
     /* 1354651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1354668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1354671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354704 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354729 */     // GIR_Coverage, 20454,
     /* 1354729 */     GIR_EraseRootFromParent_Done,
     /* 1354730 */   // Label 19322: @1354730
     /* 1354730 */   GIM_Try, /*On fail goto*//*Label 19323*/ GIMT_Encode4(1354814), // Rule ID 20455 //
     /* 1354735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1354738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1354752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1354755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354788 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354813 */     // GIR_Coverage, 20455,
     /* 1354813 */     GIR_EraseRootFromParent_Done,
     /* 1354814 */   // Label 19323: @1354814
     /* 1354814 */   GIM_Try, /*On fail goto*//*Label 19324*/ GIMT_Encode4(1354898), // Rule ID 20458 //
     /* 1354819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1354836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1354839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354872 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354897 */     // GIR_Coverage, 20458,
     /* 1354897 */     GIR_EraseRootFromParent_Done,
     /* 1354898 */   // Label 19324: @1354898
     /* 1354898 */   GIM_Try, /*On fail goto*//*Label 19325*/ GIMT_Encode4(1354982), // Rule ID 20459 //
     /* 1354903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1354920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1354923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354956 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354981 */     // GIR_Coverage, 20459,
     /* 1354981 */     GIR_EraseRootFromParent_Done,
     /* 1354982 */   // Label 19325: @1354982
     /* 1354982 */   GIM_Try, /*On fail goto*//*Label 19326*/ GIMT_Encode4(1355066), // Rule ID 20462 //
     /* 1354987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1355001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1355004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1355007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355040 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1355043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355065 */     // GIR_Coverage, 20462,
     /* 1355065 */     GIR_EraseRootFromParent_Done,
     /* 1355066 */   // Label 19326: @1355066
     /* 1355066 */   GIM_Try, /*On fail goto*//*Label 19327*/ GIMT_Encode4(1355150), // Rule ID 20463 //
     /* 1355071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1355082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1355085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1355088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1355091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355124 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1355127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355149 */     // GIR_Coverage, 20463,
     /* 1355149 */     GIR_EraseRootFromParent_Done,
     /* 1355150 */   // Label 19327: @1355150
     /* 1355150 */   GIM_Try, /*On fail goto*//*Label 19328*/ GIMT_Encode4(1355234), // Rule ID 20466 //
     /* 1355155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1355158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1355166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1355169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1355172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1355175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355208 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1355211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1355229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355233 */     // GIR_Coverage, 20466,
     /* 1355233 */     GIR_EraseRootFromParent_Done,
     /* 1355234 */   // Label 19328: @1355234
     /* 1355234 */   GIM_Try, /*On fail goto*//*Label 19329*/ GIMT_Encode4(1355318), // Rule ID 20467 //
     /* 1355239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1355242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1355250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1355253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1355256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1355259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355292 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1355295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1355313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355317 */     // GIR_Coverage, 20467,
     /* 1355317 */     GIR_EraseRootFromParent_Done,
     /* 1355318 */   // Label 19329: @1355318
     /* 1355318 */   GIM_Try, /*On fail goto*//*Label 19330*/ GIMT_Encode4(1355402), // Rule ID 20470 //
     /* 1355323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1355334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1355337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1355340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1355343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355376 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355401 */     // GIR_Coverage, 20470,
     /* 1355401 */     GIR_EraseRootFromParent_Done,
     /* 1355402 */   // Label 19330: @1355402
     /* 1355402 */   GIM_Try, /*On fail goto*//*Label 19331*/ GIMT_Encode4(1355486), // Rule ID 20471 //
     /* 1355407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1355418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1355421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1355424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1355427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355460 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355485 */     // GIR_Coverage, 20471,
     /* 1355485 */     GIR_EraseRootFromParent_Done,
     /* 1355486 */   // Label 19331: @1355486
     /* 1355486 */   GIM_Try, /*On fail goto*//*Label 19332*/ GIMT_Encode4(1355570), // Rule ID 20474 //
     /* 1355491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1355502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1355505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1355508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1355511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355544 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1355547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355569 */     // GIR_Coverage, 20474,
     /* 1355569 */     GIR_EraseRootFromParent_Done,
     /* 1355570 */   // Label 19332: @1355570
     /* 1355570 */   GIM_Try, /*On fail goto*//*Label 19333*/ GIMT_Encode4(1355654), // Rule ID 20475 //
     /* 1355575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1355586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1355589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1355592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1355595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355628 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1355631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355653 */     // GIR_Coverage, 20475,
     /* 1355653 */     GIR_EraseRootFromParent_Done,
     /* 1355654 */   // Label 19333: @1355654
     /* 1355654 */   GIM_Try, /*On fail goto*//*Label 19334*/ GIMT_Encode4(1355738), // Rule ID 20478 //
     /* 1355659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1355670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1355673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1355676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1355679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1355682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355712 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1355715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355737 */     // GIR_Coverage, 20478,
     /* 1355737 */     GIR_EraseRootFromParent_Done,
     /* 1355738 */   // Label 19334: @1355738
     /* 1355738 */   GIM_Try, /*On fail goto*//*Label 19335*/ GIMT_Encode4(1355822), // Rule ID 20479 //
     /* 1355743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1355754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1355757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1355760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1355763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1355766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355796 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1355799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355821 */     // GIR_Coverage, 20479,
     /* 1355821 */     GIR_EraseRootFromParent_Done,
     /* 1355822 */   // Label 19335: @1355822
     /* 1355822 */   GIM_Try, /*On fail goto*//*Label 19336*/ GIMT_Encode4(1355906), // Rule ID 20482 //
     /* 1355827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1355838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1355841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1355844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1355847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355880 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355905 */     // GIR_Coverage, 20482,
     /* 1355905 */     GIR_EraseRootFromParent_Done,
     /* 1355906 */   // Label 19336: @1355906
     /* 1355906 */   GIM_Try, /*On fail goto*//*Label 19337*/ GIMT_Encode4(1355990), // Rule ID 20483 //
     /* 1355911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1355922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1355925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1355928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1355931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355964 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355989 */     // GIR_Coverage, 20483,
     /* 1355989 */     GIR_EraseRootFromParent_Done,
     /* 1355990 */   // Label 19337: @1355990
     /* 1355990 */   GIM_Try, /*On fail goto*//*Label 19338*/ GIMT_Encode4(1356074), // Rule ID 20486 //
     /* 1355995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1356012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1356015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356048 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1356051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356073 */     // GIR_Coverage, 20486,
     /* 1356073 */     GIR_EraseRootFromParent_Done,
     /* 1356074 */   // Label 19338: @1356074
     /* 1356074 */   GIM_Try, /*On fail goto*//*Label 19339*/ GIMT_Encode4(1356158), // Rule ID 20487 //
     /* 1356079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1356082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1356096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1356099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356132 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1356135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356157 */     // GIR_Coverage, 20487,
     /* 1356157 */     GIR_EraseRootFromParent_Done,
     /* 1356158 */   // Label 19339: @1356158
     /* 1356158 */   GIM_Try, /*On fail goto*//*Label 19340*/ GIMT_Encode4(1356242), // Rule ID 20490 //
     /* 1356163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1356166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1356174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1356177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1356180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1356183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356216 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1356219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356241 */     // GIR_Coverage, 20490,
     /* 1356241 */     GIR_EraseRootFromParent_Done,
     /* 1356242 */   // Label 19340: @1356242
     /* 1356242 */   GIM_Try, /*On fail goto*//*Label 19341*/ GIMT_Encode4(1356326), // Rule ID 20491 //
     /* 1356247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1356250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1356258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1356261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1356264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1356267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356300 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1356303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356325 */     // GIR_Coverage, 20491,
     /* 1356325 */     GIR_EraseRootFromParent_Done,
     /* 1356326 */   // Label 19341: @1356326
     /* 1356326 */   GIM_Try, /*On fail goto*//*Label 19342*/ GIMT_Encode4(1356410), // Rule ID 20494 //
     /* 1356331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1356334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1356342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1356345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1356348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1356351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356384 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1356387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356409 */     // GIR_Coverage, 20494,
     /* 1356409 */     GIR_EraseRootFromParent_Done,
     /* 1356410 */   // Label 19342: @1356410
     /* 1356410 */   GIM_Try, /*On fail goto*//*Label 19343*/ GIMT_Encode4(1356494), // Rule ID 20495 //
     /* 1356415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1356418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1356426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1356429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1356432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1356435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356468 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1356471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356493 */     // GIR_Coverage, 20495,
     /* 1356493 */     GIR_EraseRootFromParent_Done,
     /* 1356494 */   // Label 19343: @1356494
     /* 1356494 */   GIM_Try, /*On fail goto*//*Label 19344*/ GIMT_Encode4(1356578), // Rule ID 20498 //
     /* 1356499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1356502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1356510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1356513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1356516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1356519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356552 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1356555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356577 */     // GIR_Coverage, 20498,
     /* 1356577 */     GIR_EraseRootFromParent_Done,
     /* 1356578 */   // Label 19344: @1356578
     /* 1356578 */   GIM_Try, /*On fail goto*//*Label 19345*/ GIMT_Encode4(1356662), // Rule ID 20499 //
     /* 1356583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1356586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1356594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1356597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1356600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1356603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356636 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1356639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356661 */     // GIR_Coverage, 20499,
     /* 1356661 */     GIR_EraseRootFromParent_Done,
     /* 1356662 */   // Label 19345: @1356662
     /* 1356662 */   GIM_Try, /*On fail goto*//*Label 19346*/ GIMT_Encode4(1356746), // Rule ID 20502 //
     /* 1356667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1356670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1356684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1356687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356720 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1356723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356745 */     // GIR_Coverage, 20502,
     /* 1356745 */     GIR_EraseRootFromParent_Done,
     /* 1356746 */   // Label 19346: @1356746
     /* 1356746 */   GIM_Try, /*On fail goto*//*Label 19347*/ GIMT_Encode4(1356830), // Rule ID 20503 //
     /* 1356751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1356754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1356768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1356771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356804 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1356807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356829 */     // GIR_Coverage, 20503,
     /* 1356829 */     GIR_EraseRootFromParent_Done,
     /* 1356830 */   // Label 19347: @1356830
     /* 1356830 */   GIM_Try, /*On fail goto*//*Label 19348*/ GIMT_Encode4(1356911), // Rule ID 20560 //
     /* 1356835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1356838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1356846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1356849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1356852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1356855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356888 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1356891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356910 */     // GIR_Coverage, 20560,
     /* 1356910 */     GIR_EraseRootFromParent_Done,
     /* 1356911 */   // Label 19348: @1356911
     /* 1356911 */   GIM_Try, /*On fail goto*//*Label 19349*/ GIMT_Encode4(1356992), // Rule ID 20561 //
     /* 1356916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1356919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1356927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1356930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1356933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1356936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356969 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1356972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356991 */     // GIR_Coverage, 20561,
     /* 1356991 */     GIR_EraseRootFromParent_Done,
     /* 1356992 */   // Label 19349: @1356992
     /* 1356992 */   GIM_Try, /*On fail goto*//*Label 19350*/ GIMT_Encode4(1357073), // Rule ID 20562 //
     /* 1356997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1357000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1357008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1357011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1357014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357050 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1357050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1357053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357072 */     // GIR_Coverage, 20562,
     /* 1357072 */     GIR_EraseRootFromParent_Done,
     /* 1357073 */   // Label 19350: @1357073
     /* 1357073 */   GIM_Try, /*On fail goto*//*Label 19351*/ GIMT_Encode4(1357154), // Rule ID 20563 //
     /* 1357078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1357081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1357089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1357092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1357095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357131 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1357134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357153 */     // GIR_Coverage, 20563,
     /* 1357153 */     GIR_EraseRootFromParent_Done,
     /* 1357154 */   // Label 19351: @1357154
     /* 1357154 */   GIM_Try, /*On fail goto*//*Label 19352*/ GIMT_Encode4(1357235), // Rule ID 20564 //
     /* 1357159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1357162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1357170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1357173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1357176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1357179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357212 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1357212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1357215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357234 */     // GIR_Coverage, 20564,
     /* 1357234 */     GIR_EraseRootFromParent_Done,
     /* 1357235 */   // Label 19352: @1357235
     /* 1357235 */   GIM_Try, /*On fail goto*//*Label 19353*/ GIMT_Encode4(1357316), // Rule ID 20565 //
     /* 1357240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1357243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1357251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1357254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1357257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1357260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357293 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1357296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357315 */     // GIR_Coverage, 20565,
     /* 1357315 */     GIR_EraseRootFromParent_Done,
     /* 1357316 */   // Label 19353: @1357316
     /* 1357316 */   GIM_Try, /*On fail goto*//*Label 19354*/ GIMT_Encode4(1357397), // Rule ID 20566 //
     /* 1357321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1357324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1357332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1357335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1357338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357374 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1357374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1357377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357396 */     // GIR_Coverage, 20566,
     /* 1357396 */     GIR_EraseRootFromParent_Done,
     /* 1357397 */   // Label 19354: @1357397
     /* 1357397 */   GIM_Try, /*On fail goto*//*Label 19355*/ GIMT_Encode4(1357478), // Rule ID 20567 //
     /* 1357402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1357405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1357413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1357416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1357419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357455 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1357458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357477 */     // GIR_Coverage, 20567,
     /* 1357477 */     GIR_EraseRootFromParent_Done,
     /* 1357478 */   // Label 19355: @1357478
     /* 1357478 */   GIM_Try, /*On fail goto*//*Label 19356*/ GIMT_Encode4(1357559), // Rule ID 20568 //
     /* 1357483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1357503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357536 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1357539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357558 */     // GIR_Coverage, 20568,
     /* 1357558 */     GIR_EraseRootFromParent_Done,
     /* 1357559 */   // Label 19356: @1357559
     /* 1357559 */   GIM_Try, /*On fail goto*//*Label 19357*/ GIMT_Encode4(1357640), // Rule ID 20569 //
     /* 1357564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1357584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357617 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1357620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357639 */     // GIR_Coverage, 20569,
     /* 1357639 */     GIR_EraseRootFromParent_Done,
     /* 1357640 */   // Label 19357: @1357640
     /* 1357640 */   GIM_Try, /*On fail goto*//*Label 19358*/ GIMT_Encode4(1357721), // Rule ID 20570 //
     /* 1357645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357698 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1357701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357720 */     // GIR_Coverage, 20570,
     /* 1357720 */     GIR_EraseRootFromParent_Done,
     /* 1357721 */   // Label 19358: @1357721
     /* 1357721 */   GIM_Try, /*On fail goto*//*Label 19359*/ GIMT_Encode4(1357802), // Rule ID 20571 //
     /* 1357726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357779 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1357782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357801 */     // GIR_Coverage, 20571,
     /* 1357801 */     GIR_EraseRootFromParent_Done,
     /* 1357802 */   // Label 19359: @1357802
     /* 1357802 */   GIM_Try, /*On fail goto*//*Label 19360*/ GIMT_Encode4(1357883), // Rule ID 20572 //
     /* 1357807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1357810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1357827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357860 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1357860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1357863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357882 */     // GIR_Coverage, 20572,
     /* 1357882 */     GIR_EraseRootFromParent_Done,
     /* 1357883 */   // Label 19360: @1357883
     /* 1357883 */   GIM_Try, /*On fail goto*//*Label 19361*/ GIMT_Encode4(1357964), // Rule ID 20573 //
     /* 1357888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1357891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1357908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357941 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1357944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357963 */     // GIR_Coverage, 20573,
     /* 1357963 */     GIR_EraseRootFromParent_Done,
     /* 1357964 */   // Label 19361: @1357964
     /* 1357964 */   GIM_Try, /*On fail goto*//*Label 19362*/ GIMT_Encode4(1358045), // Rule ID 20574 //
     /* 1357969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1357972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358022 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1358025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358044 */     // GIR_Coverage, 20574,
     /* 1358044 */     GIR_EraseRootFromParent_Done,
     /* 1358045 */   // Label 19362: @1358045
     /* 1358045 */   GIM_Try, /*On fail goto*//*Label 19363*/ GIMT_Encode4(1358126), // Rule ID 20575 //
     /* 1358050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1358053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1358061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1358064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1358067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1358070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1358073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358103 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1358103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1358106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358125 */     // GIR_Coverage, 20575,
     /* 1358125 */     GIR_EraseRootFromParent_Done,
     /* 1358126 */   // Label 19363: @1358126
     /* 1358126 */   GIM_Try, /*On fail goto*//*Label 19364*/ GIMT_Encode4(1358207), // Rule ID 20576 //
     /* 1358131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1358134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1358142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1358145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1358148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1358151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358184 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1358184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1358187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358206 */     // GIR_Coverage, 20576,
     /* 1358206 */     GIR_EraseRootFromParent_Done,
     /* 1358207 */   // Label 19364: @1358207
     /* 1358207 */   GIM_Try, /*On fail goto*//*Label 19365*/ GIMT_Encode4(1358288), // Rule ID 20577 //
     /* 1358212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1358215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1358223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1358226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1358229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1358232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358265 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1358265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1358268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358287 */     // GIR_Coverage, 20577,
     /* 1358287 */     GIR_EraseRootFromParent_Done,
     /* 1358288 */   // Label 19365: @1358288
     /* 1358288 */   GIM_Try, /*On fail goto*//*Label 19366*/ GIMT_Encode4(1358369), // Rule ID 20578 //
     /* 1358293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1358296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1358304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1358307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1358310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1358313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1358335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358346 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1358346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1358349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358368 */     // GIR_Coverage, 20578,
     /* 1358368 */     GIR_EraseRootFromParent_Done,
     /* 1358369 */   // Label 19366: @1358369
     /* 1358369 */   GIM_Try, /*On fail goto*//*Label 19367*/ GIMT_Encode4(1358450), // Rule ID 20579 //
     /* 1358374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1358377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1358385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1358388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1358391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1358394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1358416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358427 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1358427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1358430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358449 */     // GIR_Coverage, 20579,
     /* 1358449 */     GIR_EraseRootFromParent_Done,
     /* 1358450 */   // Label 19367: @1358450
     /* 1358450 */   GIM_Try, /*On fail goto*//*Label 19368*/ GIMT_Encode4(1358531), // Rule ID 20580 //
     /* 1358455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1358475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358508 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1358511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358530 */     // GIR_Coverage, 20580,
     /* 1358530 */     GIR_EraseRootFromParent_Done,
     /* 1358531 */   // Label 19368: @1358531
     /* 1358531 */   GIM_Try, /*On fail goto*//*Label 19369*/ GIMT_Encode4(1358612), // Rule ID 20581 //
     /* 1358536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1358556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358589 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1358592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358611 */     // GIR_Coverage, 20581,
     /* 1358611 */     GIR_EraseRootFromParent_Done,
     /* 1358612 */   // Label 19369: @1358612
     /* 1358612 */   GIM_Try, /*On fail goto*//*Label 19370*/ GIMT_Encode4(1358693), // Rule ID 20582 //
     /* 1358617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358670 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1358673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358692 */     // GIR_Coverage, 20582,
     /* 1358692 */     GIR_EraseRootFromParent_Done,
     /* 1358693 */   // Label 19370: @1358693
     /* 1358693 */   GIM_Try, /*On fail goto*//*Label 19371*/ GIMT_Encode4(1358774), // Rule ID 20583 //
     /* 1358698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358751 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1358754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358773 */     // GIR_Coverage, 20583,
     /* 1358773 */     GIR_EraseRootFromParent_Done,
     /* 1358774 */   // Label 19371: @1358774
     /* 1358774 */   GIM_Try, /*On fail goto*//*Label 19372*/ GIMT_Encode4(1358855), // Rule ID 20584 //
     /* 1358779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1358782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1358799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358832 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1358835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358854 */     // GIR_Coverage, 20584,
     /* 1358854 */     GIR_EraseRootFromParent_Done,
     /* 1358855 */   // Label 19372: @1358855
     /* 1358855 */   GIM_Try, /*On fail goto*//*Label 19373*/ GIMT_Encode4(1358936), // Rule ID 20585 //
     /* 1358860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1358863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1358880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358913 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1358913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1358916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358935 */     // GIR_Coverage, 20585,
     /* 1358935 */     GIR_EraseRootFromParent_Done,
     /* 1358936 */   // Label 19373: @1358936
     /* 1358936 */   GIM_Try, /*On fail goto*//*Label 19374*/ GIMT_Encode4(1359017), // Rule ID 20586 //
     /* 1358941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1358944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1358961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358994 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1358997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359016 */     // GIR_Coverage, 20586,
     /* 1359016 */     GIR_EraseRootFromParent_Done,
     /* 1359017 */   // Label 19374: @1359017
     /* 1359017 */   GIM_Try, /*On fail goto*//*Label 19375*/ GIMT_Encode4(1359098), // Rule ID 20587 //
     /* 1359022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1359025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1359033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1359036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1359039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359075 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1359078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359097 */     // GIR_Coverage, 20587,
     /* 1359097 */     GIR_EraseRootFromParent_Done,
     /* 1359098 */   // Label 19375: @1359098
     /* 1359098 */   GIM_Try, /*On fail goto*//*Label 19376*/ GIMT_Encode4(1359179), // Rule ID 20588 //
     /* 1359103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1359106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1359114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1359117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1359120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1359123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359156 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1359156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1359159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359178 */     // GIR_Coverage, 20588,
     /* 1359178 */     GIR_EraseRootFromParent_Done,
     /* 1359179 */   // Label 19376: @1359179
     /* 1359179 */   GIM_Try, /*On fail goto*//*Label 19377*/ GIMT_Encode4(1359260), // Rule ID 20589 //
     /* 1359184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1359187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1359195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1359198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1359201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1359204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359237 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1359240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359259 */     // GIR_Coverage, 20589,
     /* 1359259 */     GIR_EraseRootFromParent_Done,
     /* 1359260 */   // Label 19377: @1359260
     /* 1359260 */   GIM_Try, /*On fail goto*//*Label 19378*/ GIMT_Encode4(1359341), // Rule ID 20590 //
     /* 1359265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1359268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1359276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1359279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1359282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359318 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1359318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1359321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359340 */     // GIR_Coverage, 20590,
     /* 1359340 */     GIR_EraseRootFromParent_Done,
     /* 1359341 */   // Label 19378: @1359341
     /* 1359341 */   GIM_Try, /*On fail goto*//*Label 19379*/ GIMT_Encode4(1359422), // Rule ID 20591 //
     /* 1359346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1359349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1359357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1359360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1359363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359399 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1359402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359421 */     // GIR_Coverage, 20591,
     /* 1359421 */     GIR_EraseRootFromParent_Done,
     /* 1359422 */   // Label 19379: @1359422
     /* 1359422 */   GIM_Try, /*On fail goto*//*Label 19380*/ GIMT_Encode4(1359503), // Rule ID 20592 //
     /* 1359427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1359430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1359447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359480 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1359480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1359483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359502 */     // GIR_Coverage, 20592,
     /* 1359502 */     GIR_EraseRootFromParent_Done,
     /* 1359503 */   // Label 19380: @1359503
     /* 1359503 */   GIM_Try, /*On fail goto*//*Label 19381*/ GIMT_Encode4(1359584), // Rule ID 20593 //
     /* 1359508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1359511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1359528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359561 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1359564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359583 */     // GIR_Coverage, 20593,
     /* 1359583 */     GIR_EraseRootFromParent_Done,
     /* 1359584 */   // Label 19381: @1359584
     /* 1359584 */   GIM_Try, /*On fail goto*//*Label 19382*/ GIMT_Encode4(1359665), // Rule ID 20594 //
     /* 1359589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1359592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359642 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1359642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1359645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359664 */     // GIR_Coverage, 20594,
     /* 1359664 */     GIR_EraseRootFromParent_Done,
     /* 1359665 */   // Label 19382: @1359665
     /* 1359665 */   GIM_Try, /*On fail goto*//*Label 19383*/ GIMT_Encode4(1359746), // Rule ID 20595 //
     /* 1359670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1359673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359723 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1359726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359745 */     // GIR_Coverage, 20595,
     /* 1359745 */     GIR_EraseRootFromParent_Done,
     /* 1359746 */   // Label 19383: @1359746
     /* 1359746 */   GIM_Try, /*On fail goto*//*Label 19384*/ GIMT_Encode4(1359827), // Rule ID 20596 //
     /* 1359751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1359771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359804 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1359807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359826 */     // GIR_Coverage, 20596,
     /* 1359826 */     GIR_EraseRootFromParent_Done,
     /* 1359827 */   // Label 19384: @1359827
     /* 1359827 */   GIM_Try, /*On fail goto*//*Label 19385*/ GIMT_Encode4(1359908), // Rule ID 20597 //
     /* 1359832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1359852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359885 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1359885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1359888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359907 */     // GIR_Coverage, 20597,
     /* 1359907 */     GIR_EraseRootFromParent_Done,
     /* 1359908 */   // Label 19385: @1359908
     /* 1359908 */   GIM_Try, /*On fail goto*//*Label 19386*/ GIMT_Encode4(1359989), // Rule ID 20598 //
     /* 1359913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1359955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359966 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1359969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359988 */     // GIR_Coverage, 20598,
     /* 1359988 */     GIR_EraseRootFromParent_Done,
     /* 1359989 */   // Label 19386: @1359989
     /* 1359989 */   GIM_Try, /*On fail goto*//*Label 19387*/ GIMT_Encode4(1360070), // Rule ID 20599 //
     /* 1359994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1360005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1360008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1360011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360047 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1360050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360069 */     // GIR_Coverage, 20599,
     /* 1360069 */     GIR_EraseRootFromParent_Done,
     /* 1360070 */   // Label 19387: @1360070
     /* 1360070 */   GIM_Try, /*On fail goto*//*Label 19388*/ GIMT_Encode4(1360151), // Rule ID 20600 //
     /* 1360075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1360078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1360086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1360089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1360092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1360095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360128 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1360128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1360131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360150 */     // GIR_Coverage, 20600,
     /* 1360150 */     GIR_EraseRootFromParent_Done,
     /* 1360151 */   // Label 19388: @1360151
     /* 1360151 */   GIM_Try, /*On fail goto*//*Label 19389*/ GIMT_Encode4(1360232), // Rule ID 20601 //
     /* 1360156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1360167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1360170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1360173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1360176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360209 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1360212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360231 */     // GIR_Coverage, 20601,
     /* 1360231 */     GIR_EraseRootFromParent_Done,
     /* 1360232 */   // Label 19389: @1360232
     /* 1360232 */   GIM_Try, /*On fail goto*//*Label 19390*/ GIMT_Encode4(1360313), // Rule ID 20602 //
     /* 1360237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1360240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1360248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1360251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1360254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360290 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1360290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1360293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360312 */     // GIR_Coverage, 20602,
     /* 1360312 */     GIR_EraseRootFromParent_Done,
     /* 1360313 */   // Label 19390: @1360313
     /* 1360313 */   GIM_Try, /*On fail goto*//*Label 19391*/ GIMT_Encode4(1360394), // Rule ID 20603 //
     /* 1360318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1360329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1360332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1360335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360371 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1360374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360393 */     // GIR_Coverage, 20603,
     /* 1360393 */     GIR_EraseRootFromParent_Done,
     /* 1360394 */   // Label 19391: @1360394
     /* 1360394 */   GIM_Try, /*On fail goto*//*Label 19392*/ GIMT_Encode4(1360475), // Rule ID 20604 //
     /* 1360399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1360402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1360419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360452 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1360452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1360455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360474 */     // GIR_Coverage, 20604,
     /* 1360474 */     GIR_EraseRootFromParent_Done,
     /* 1360475 */   // Label 19392: @1360475
     /* 1360475 */   GIM_Try, /*On fail goto*//*Label 19393*/ GIMT_Encode4(1360556), // Rule ID 20605 //
     /* 1360480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1360500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360533 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1360536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360555 */     // GIR_Coverage, 20605,
     /* 1360555 */     GIR_EraseRootFromParent_Done,
     /* 1360556 */   // Label 19393: @1360556
     /* 1360556 */   GIM_Try, /*On fail goto*//*Label 19394*/ GIMT_Encode4(1360637), // Rule ID 20606 //
     /* 1360561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1360564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360614 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1360614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1360617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360636 */     // GIR_Coverage, 20606,
     /* 1360636 */     GIR_EraseRootFromParent_Done,
     /* 1360637 */   // Label 19394: @1360637
     /* 1360637 */   GIM_Try, /*On fail goto*//*Label 19395*/ GIMT_Encode4(1360718), // Rule ID 20607 //
     /* 1360642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360695 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1360698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360717 */     // GIR_Coverage, 20607,
     /* 1360717 */     GIR_EraseRootFromParent_Done,
     /* 1360718 */   // Label 19395: @1360718
     /* 1360718 */   GIM_Try, /*On fail goto*//*Label 19396*/ GIMT_Encode4(1360799), // Rule ID 20608 //
     /* 1360723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1360743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360776 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1360779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360798 */     // GIR_Coverage, 20608,
     /* 1360798 */     GIR_EraseRootFromParent_Done,
     /* 1360799 */   // Label 19396: @1360799
     /* 1360799 */   GIM_Try, /*On fail goto*//*Label 19397*/ GIMT_Encode4(1360880), // Rule ID 20609 //
     /* 1360804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1360824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360857 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1360857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1360860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360879 */     // GIR_Coverage, 20609,
     /* 1360879 */     GIR_EraseRootFromParent_Done,
     /* 1360880 */   // Label 19397: @1360880
     /* 1360880 */   GIM_Try, /*On fail goto*//*Label 19398*/ GIMT_Encode4(1360961), // Rule ID 20610 //
     /* 1360885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1360927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360938 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1360941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360960 */     // GIR_Coverage, 20610,
     /* 1360960 */     GIR_EraseRootFromParent_Done,
     /* 1360961 */   // Label 19398: @1360961
     /* 1360961 */   GIM_Try, /*On fail goto*//*Label 19399*/ GIMT_Encode4(1361042), // Rule ID 20611 //
     /* 1360966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1361000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1361004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361019 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1361022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361041 */     // GIR_Coverage, 20611,
     /* 1361041 */     GIR_EraseRootFromParent_Done,
     /* 1361042 */   // Label 19399: @1361042
     /* 1361042 */   GIM_Try, /*On fail goto*//*Label 19400*/ GIMT_Encode4(1361123), // Rule ID 20612 //
     /* 1361047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1361050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1361058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1361061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1361064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1361067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1361077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361100 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1361100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1361103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361122 */     // GIR_Coverage, 20612,
     /* 1361122 */     GIR_EraseRootFromParent_Done,
     /* 1361123 */   // Label 19400: @1361123
     /* 1361123 */   GIM_Try, /*On fail goto*//*Label 19401*/ GIMT_Encode4(1361204), // Rule ID 20613 //
     /* 1361128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1361131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1361139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1361142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1361145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1361148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1361158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361181 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1361184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361203 */     // GIR_Coverage, 20613,
     /* 1361203 */     GIR_EraseRootFromParent_Done,
     /* 1361204 */   // Label 19401: @1361204
     /* 1361204 */   GIM_Try, /*On fail goto*//*Label 19402*/ GIMT_Encode4(1361285), // Rule ID 20614 //
     /* 1361209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1361212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1361220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1361223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1361226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1361239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361262 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1361262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1361265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361284 */     // GIR_Coverage, 20614,
     /* 1361284 */     GIR_EraseRootFromParent_Done,
     /* 1361285 */   // Label 19402: @1361285
     /* 1361285 */   GIM_Try, /*On fail goto*//*Label 19403*/ GIMT_Encode4(1361366), // Rule ID 20615 //
     /* 1361290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1361293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1361301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1361304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1361307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1361320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361343 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1361346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361365 */     // GIR_Coverage, 20615,
     /* 1361365 */     GIR_EraseRootFromParent_Done,
     /* 1361366 */   // Label 19403: @1361366
     /* 1361366 */   GIM_Try, /*On fail goto*//*Label 19404*/ GIMT_Encode4(1361447), // Rule ID 20616 //
     /* 1361371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1361374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1361391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361424 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1361424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1361427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361446 */     // GIR_Coverage, 20616,
     /* 1361446 */     GIR_EraseRootFromParent_Done,
     /* 1361447 */   // Label 19404: @1361447
     /* 1361447 */   GIM_Try, /*On fail goto*//*Label 19405*/ GIMT_Encode4(1361528), // Rule ID 20617 //
     /* 1361452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1361455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1361472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361505 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1361508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361527 */     // GIR_Coverage, 20617,
     /* 1361527 */     GIR_EraseRootFromParent_Done,
     /* 1361528 */   // Label 19405: @1361528
     /* 1361528 */   GIM_Try, /*On fail goto*//*Label 19406*/ GIMT_Encode4(1361609), // Rule ID 20618 //
     /* 1361533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1361536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361586 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1361586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1361589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361608 */     // GIR_Coverage, 20618,
     /* 1361608 */     GIR_EraseRootFromParent_Done,
     /* 1361609 */   // Label 19406: @1361609
     /* 1361609 */   GIM_Try, /*On fail goto*//*Label 19407*/ GIMT_Encode4(1361690), // Rule ID 20619 //
     /* 1361614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1361617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361667 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1361670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361689 */     // GIR_Coverage, 20619,
     /* 1361689 */     GIR_EraseRootFromParent_Done,
     /* 1361690 */   // Label 19407: @1361690
     /* 1361690 */   GIM_Try, /*On fail goto*//*Label 19408*/ GIMT_Encode4(1361774), // Rule ID 22000 //
     /* 1361695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1361712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361748 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1361751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361773 */     // GIR_Coverage, 22000,
     /* 1361773 */     GIR_EraseRootFromParent_Done,
     /* 1361774 */   // Label 19408: @1361774
     /* 1361774 */   GIM_Try, /*On fail goto*//*Label 19409*/ GIMT_Encode4(1361858), // Rule ID 22001 //
     /* 1361779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1361796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361832 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1361835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361857 */     // GIR_Coverage, 22001,
     /* 1361857 */     GIR_EraseRootFromParent_Done,
     /* 1361858 */   // Label 19409: @1361858
     /* 1361858 */   GIM_Try, /*On fail goto*//*Label 19410*/ GIMT_Encode4(1361942), // Rule ID 22004 //
     /* 1361863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1361880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361916 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1361919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361941 */     // GIR_Coverage, 22004,
     /* 1361941 */     GIR_EraseRootFromParent_Done,
     /* 1361942 */   // Label 19410: @1361942
     /* 1361942 */   GIM_Try, /*On fail goto*//*Label 19411*/ GIMT_Encode4(1362026), // Rule ID 22005 //
     /* 1361947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1361964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362000 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1362003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362025 */     // GIR_Coverage, 22005,
     /* 1362025 */     GIR_EraseRootFromParent_Done,
     /* 1362026 */   // Label 19411: @1362026
     /* 1362026 */   GIM_Try, /*On fail goto*//*Label 19412*/ GIMT_Encode4(1362110), // Rule ID 22008 //
     /* 1362031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1362048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1362087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362109 */     // GIR_Coverage, 22008,
     /* 1362109 */     GIR_EraseRootFromParent_Done,
     /* 1362110 */   // Label 19412: @1362110
     /* 1362110 */   GIM_Try, /*On fail goto*//*Label 19413*/ GIMT_Encode4(1362194), // Rule ID 22009 //
     /* 1362115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1362132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1362171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362193 */     // GIR_Coverage, 22009,
     /* 1362193 */     GIR_EraseRootFromParent_Done,
     /* 1362194 */   // Label 19413: @1362194
     /* 1362194 */   GIM_Try, /*On fail goto*//*Label 19414*/ GIMT_Encode4(1362278), // Rule ID 22012 //
     /* 1362199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1362216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1362255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362277 */     // GIR_Coverage, 22012,
     /* 1362277 */     GIR_EraseRootFromParent_Done,
     /* 1362278 */   // Label 19414: @1362278
     /* 1362278 */   GIM_Try, /*On fail goto*//*Label 19415*/ GIMT_Encode4(1362362), // Rule ID 22013 //
     /* 1362283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1362300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362336 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1362339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362361 */     // GIR_Coverage, 22013,
     /* 1362361 */     GIR_EraseRootFromParent_Done,
     /* 1362362 */   // Label 19415: @1362362
     /* 1362362 */   GIM_Try, /*On fail goto*//*Label 19416*/ GIMT_Encode4(1362446), // Rule ID 22016 //
     /* 1362367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1362384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362420 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1362423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362445 */     // GIR_Coverage, 22016,
     /* 1362445 */     GIR_EraseRootFromParent_Done,
     /* 1362446 */   // Label 19416: @1362446
     /* 1362446 */   GIM_Try, /*On fail goto*//*Label 19417*/ GIMT_Encode4(1362530), // Rule ID 22017 //
     /* 1362451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1362468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362504 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1362507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362529 */     // GIR_Coverage, 22017,
     /* 1362529 */     GIR_EraseRootFromParent_Done,
     /* 1362530 */   // Label 19417: @1362530
     /* 1362530 */   GIM_Try, /*On fail goto*//*Label 19418*/ GIMT_Encode4(1362614), // Rule ID 22020 //
     /* 1362535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1362552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362588 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1362591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362613 */     // GIR_Coverage, 22020,
     /* 1362613 */     GIR_EraseRootFromParent_Done,
     /* 1362614 */   // Label 19418: @1362614
     /* 1362614 */   GIM_Try, /*On fail goto*//*Label 19419*/ GIMT_Encode4(1362698), // Rule ID 22021 //
     /* 1362619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1362636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362672 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1362675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362697 */     // GIR_Coverage, 22021,
     /* 1362697 */     GIR_EraseRootFromParent_Done,
     /* 1362698 */   // Label 19419: @1362698
     /* 1362698 */   GIM_Try, /*On fail goto*//*Label 19420*/ GIMT_Encode4(1362782), // Rule ID 22024 //
     /* 1362703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1362720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1362759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362781 */     // GIR_Coverage, 22024,
     /* 1362781 */     GIR_EraseRootFromParent_Done,
     /* 1362782 */   // Label 19420: @1362782
     /* 1362782 */   GIM_Try, /*On fail goto*//*Label 19421*/ GIMT_Encode4(1362866), // Rule ID 22025 //
     /* 1362787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1362804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362840 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1362843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362865 */     // GIR_Coverage, 22025,
     /* 1362865 */     GIR_EraseRootFromParent_Done,
     /* 1362866 */   // Label 19421: @1362866
     /* 1362866 */   GIM_Try, /*On fail goto*//*Label 19422*/ GIMT_Encode4(1362950), // Rule ID 22028 //
     /* 1362871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1362888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1362927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362949 */     // GIR_Coverage, 22028,
     /* 1362949 */     GIR_EraseRootFromParent_Done,
     /* 1362950 */   // Label 19422: @1362950
     /* 1362950 */   GIM_Try, /*On fail goto*//*Label 19423*/ GIMT_Encode4(1363034), // Rule ID 22029 //
     /* 1362955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1362972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1363011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363033 */     // GIR_Coverage, 22029,
     /* 1363033 */     GIR_EraseRootFromParent_Done,
     /* 1363034 */   // Label 19423: @1363034
     /* 1363034 */   GIM_Try, /*On fail goto*//*Label 19424*/ GIMT_Encode4(1363118), // Rule ID 22032 //
     /* 1363039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1363042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1363050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1363053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1363056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1363059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363092 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1363095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1363113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363117 */     // GIR_Coverage, 22032,
     /* 1363117 */     GIR_EraseRootFromParent_Done,
     /* 1363118 */   // Label 19424: @1363118
     /* 1363118 */   GIM_Try, /*On fail goto*//*Label 19425*/ GIMT_Encode4(1363202), // Rule ID 22033 //
     /* 1363123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1363126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1363134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1363137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1363140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1363143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363176 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1363179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1363197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363201 */     // GIR_Coverage, 22033,
     /* 1363201 */     GIR_EraseRootFromParent_Done,
     /* 1363202 */   // Label 19425: @1363202
     /* 1363202 */   GIM_Try, /*On fail goto*//*Label 19426*/ GIMT_Encode4(1363286), // Rule ID 22036 //
     /* 1363207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1363224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363260 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1363263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363285 */     // GIR_Coverage, 22036,
     /* 1363285 */     GIR_EraseRootFromParent_Done,
     /* 1363286 */   // Label 19426: @1363286
     /* 1363286 */   GIM_Try, /*On fail goto*//*Label 19427*/ GIMT_Encode4(1363370), // Rule ID 22037 //
     /* 1363291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1363308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363344 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1363347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363369 */     // GIR_Coverage, 22037,
     /* 1363369 */     GIR_EraseRootFromParent_Done,
     /* 1363370 */   // Label 19427: @1363370
     /* 1363370 */   GIM_Try, /*On fail goto*//*Label 19428*/ GIMT_Encode4(1363454), // Rule ID 22040 //
     /* 1363375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1363392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363428 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1363431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363453 */     // GIR_Coverage, 22040,
     /* 1363453 */     GIR_EraseRootFromParent_Done,
     /* 1363454 */   // Label 19428: @1363454
     /* 1363454 */   GIM_Try, /*On fail goto*//*Label 19429*/ GIMT_Encode4(1363538), // Rule ID 22041 //
     /* 1363459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1363476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363512 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1363515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363537 */     // GIR_Coverage, 22041,
     /* 1363537 */     GIR_EraseRootFromParent_Done,
     /* 1363538 */   // Label 19429: @1363538
     /* 1363538 */   GIM_Try, /*On fail goto*//*Label 19430*/ GIMT_Encode4(1363622), // Rule ID 22044 //
     /* 1363543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1363560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1363566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1363599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363621 */     // GIR_Coverage, 22044,
     /* 1363621 */     GIR_EraseRootFromParent_Done,
     /* 1363622 */   // Label 19430: @1363622
     /* 1363622 */   GIM_Try, /*On fail goto*//*Label 19431*/ GIMT_Encode4(1363706), // Rule ID 22045 //
     /* 1363627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1363644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1363650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363680 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1363683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363705 */     // GIR_Coverage, 22045,
     /* 1363705 */     GIR_EraseRootFromParent_Done,
     /* 1363706 */   // Label 19431: @1363706
     /* 1363706 */   GIM_Try, /*On fail goto*//*Label 19432*/ GIMT_Encode4(1363790), // Rule ID 22048 //
     /* 1363711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1363728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363764 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1363767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363789 */     // GIR_Coverage, 22048,
     /* 1363789 */     GIR_EraseRootFromParent_Done,
     /* 1363790 */   // Label 19432: @1363790
     /* 1363790 */   GIM_Try, /*On fail goto*//*Label 19433*/ GIMT_Encode4(1363874), // Rule ID 22049 //
     /* 1363795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1363812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363848 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1363851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363873 */     // GIR_Coverage, 22049,
     /* 1363873 */     GIR_EraseRootFromParent_Done,
     /* 1363874 */   // Label 19433: @1363874
     /* 1363874 */   GIM_Try, /*On fail goto*//*Label 19434*/ GIMT_Encode4(1363958), // Rule ID 22052 //
     /* 1363879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1363896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1363935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363957 */     // GIR_Coverage, 22052,
     /* 1363957 */     GIR_EraseRootFromParent_Done,
     /* 1363958 */   // Label 19434: @1363958
     /* 1363958 */   GIM_Try, /*On fail goto*//*Label 19435*/ GIMT_Encode4(1364042), // Rule ID 22053 //
     /* 1363963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1363980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1364019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364041 */     // GIR_Coverage, 22053,
     /* 1364041 */     GIR_EraseRootFromParent_Done,
     /* 1364042 */   // Label 19435: @1364042
     /* 1364042 */   GIM_Try, /*On fail goto*//*Label 19436*/ GIMT_Encode4(1364126), // Rule ID 22056 //
     /* 1364047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1364064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1364070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1364103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364125 */     // GIR_Coverage, 22056,
     /* 1364125 */     GIR_EraseRootFromParent_Done,
     /* 1364126 */   // Label 19436: @1364126
     /* 1364126 */   GIM_Try, /*On fail goto*//*Label 19437*/ GIMT_Encode4(1364210), // Rule ID 22057 //
     /* 1364131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1364148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1364154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1364187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364209 */     // GIR_Coverage, 22057,
     /* 1364209 */     GIR_EraseRootFromParent_Done,
     /* 1364210 */   // Label 19437: @1364210
     /* 1364210 */   GIM_Try, /*On fail goto*//*Label 19438*/ GIMT_Encode4(1364294), // Rule ID 22060 //
     /* 1364215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1364232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364268 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1364271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364293 */     // GIR_Coverage, 22060,
     /* 1364293 */     GIR_EraseRootFromParent_Done,
     /* 1364294 */   // Label 19438: @1364294
     /* 1364294 */   GIM_Try, /*On fail goto*//*Label 19439*/ GIMT_Encode4(1364378), // Rule ID 22061 //
     /* 1364299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1364316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1364355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364377 */     // GIR_Coverage, 22061,
     /* 1364377 */     GIR_EraseRootFromParent_Done,
     /* 1364378 */   // Label 19439: @1364378
     /* 1364378 */   GIM_Try, /*On fail goto*//*Label 19440*/ GIMT_Encode4(1364462), // Rule ID 22064 //
     /* 1364383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1364400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1364439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364461 */     // GIR_Coverage, 22064,
     /* 1364461 */     GIR_EraseRootFromParent_Done,
     /* 1364462 */   // Label 19440: @1364462
     /* 1364462 */   GIM_Try, /*On fail goto*//*Label 19441*/ GIMT_Encode4(1364546), // Rule ID 22065 //
     /* 1364467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1364484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364520 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1364523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364545 */     // GIR_Coverage, 22065,
     /* 1364545 */     GIR_EraseRootFromParent_Done,
     /* 1364546 */   // Label 19441: @1364546
     /* 1364546 */   GIM_Try, /*On fail goto*//*Label 19442*/ GIMT_Encode4(1364630), // Rule ID 22068 //
     /* 1364551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1364568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364604 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1364607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364629 */     // GIR_Coverage, 22068,
     /* 1364629 */     GIR_EraseRootFromParent_Done,
     /* 1364630 */   // Label 19442: @1364630
     /* 1364630 */   GIM_Try, /*On fail goto*//*Label 19443*/ GIMT_Encode4(1364714), // Rule ID 22069 //
     /* 1364635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1364652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364688 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1364691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364713 */     // GIR_Coverage, 22069,
     /* 1364713 */     GIR_EraseRootFromParent_Done,
     /* 1364714 */   // Label 19443: @1364714
     /* 1364714 */   GIM_Try, /*On fail goto*//*Label 19444*/ GIMT_Encode4(1364798), // Rule ID 22072 //
     /* 1364719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1364722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1364736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364772 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1364775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364797 */     // GIR_Coverage, 22072,
     /* 1364797 */     GIR_EraseRootFromParent_Done,
     /* 1364798 */   // Label 19444: @1364798
     /* 1364798 */   GIM_Try, /*On fail goto*//*Label 19445*/ GIMT_Encode4(1364882), // Rule ID 22073 //
     /* 1364803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1364806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1364820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364856 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1364859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364881 */     // GIR_Coverage, 22073,
     /* 1364881 */     GIR_EraseRootFromParent_Done,
     /* 1364882 */   // Label 19445: @1364882
     /* 1364882 */   GIM_Try, /*On fail goto*//*Label 19446*/ GIMT_Encode4(1364966), // Rule ID 22076 //
     /* 1364887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1364890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1364904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364940 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1364943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364965 */     // GIR_Coverage, 22076,
     /* 1364965 */     GIR_EraseRootFromParent_Done,
     /* 1364966 */   // Label 19446: @1364966
     /* 1364966 */   GIM_Try, /*On fail goto*//*Label 19447*/ GIMT_Encode4(1365050), // Rule ID 22077 //
     /* 1364971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1364974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1364988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1365027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365049 */     // GIR_Coverage, 22077,
     /* 1365049 */     GIR_EraseRootFromParent_Done,
     /* 1365050 */   // Label 19447: @1365050
     /* 1365050 */   GIM_Try, /*On fail goto*//*Label 19448*/ GIMT_Encode4(1365134), // Rule ID 22080 //
     /* 1365055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1365058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1365072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365108 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1365111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365133 */     // GIR_Coverage, 22080,
     /* 1365133 */     GIR_EraseRootFromParent_Done,
     /* 1365134 */   // Label 19448: @1365134
     /* 1365134 */   GIM_Try, /*On fail goto*//*Label 19449*/ GIMT_Encode4(1365218), // Rule ID 22081 //
     /* 1365139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1365142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1365156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365192 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1365195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365217 */     // GIR_Coverage, 22081,
     /* 1365217 */     GIR_EraseRootFromParent_Done,
     /* 1365218 */   // Label 19449: @1365218
     /* 1365218 */   GIM_Try, /*On fail goto*//*Label 19450*/ GIMT_Encode4(1365302), // Rule ID 22084 //
     /* 1365223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1365240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365276 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1365279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365301 */     // GIR_Coverage, 22084,
     /* 1365301 */     GIR_EraseRootFromParent_Done,
     /* 1365302 */   // Label 19450: @1365302
     /* 1365302 */   GIM_Try, /*On fail goto*//*Label 19451*/ GIMT_Encode4(1365386), // Rule ID 22085 //
     /* 1365307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1365324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1365363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365385 */     // GIR_Coverage, 22085,
     /* 1365385 */     GIR_EraseRootFromParent_Done,
     /* 1365386 */   // Label 19451: @1365386
     /* 1365386 */   GIM_Try, /*On fail goto*//*Label 19452*/ GIMT_Encode4(1365470), // Rule ID 22088 //
     /* 1365391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1365408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365444 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1365447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365469 */     // GIR_Coverage, 22088,
     /* 1365469 */     GIR_EraseRootFromParent_Done,
     /* 1365470 */   // Label 19452: @1365470
     /* 1365470 */   GIM_Try, /*On fail goto*//*Label 19453*/ GIMT_Encode4(1365554), // Rule ID 22089 //
     /* 1365475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1365492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365528 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1365531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365553 */     // GIR_Coverage, 22089,
     /* 1365553 */     GIR_EraseRootFromParent_Done,
     /* 1365554 */   // Label 19453: @1365554
     /* 1365554 */   GIM_Try, /*On fail goto*//*Label 19454*/ GIMT_Encode4(1365638), // Rule ID 22092 //
     /* 1365559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1365576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365612 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1365615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365637 */     // GIR_Coverage, 22092,
     /* 1365637 */     GIR_EraseRootFromParent_Done,
     /* 1365638 */   // Label 19454: @1365638
     /* 1365638 */   GIM_Try, /*On fail goto*//*Label 19455*/ GIMT_Encode4(1365722), // Rule ID 22093 //
     /* 1365643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1365660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1365699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365721 */     // GIR_Coverage, 22093,
     /* 1365721 */     GIR_EraseRootFromParent_Done,
     /* 1365722 */   // Label 19455: @1365722
     /* 1365722 */   GIM_Try, /*On fail goto*//*Label 19456*/ GIMT_Encode4(1365806), // Rule ID 22096 //
     /* 1365727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1365744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1365783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365805 */     // GIR_Coverage, 22096,
     /* 1365805 */     GIR_EraseRootFromParent_Done,
     /* 1365806 */   // Label 19456: @1365806
     /* 1365806 */   GIM_Try, /*On fail goto*//*Label 19457*/ GIMT_Encode4(1365890), // Rule ID 22097 //
     /* 1365811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1365828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365864 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1365867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365889 */     // GIR_Coverage, 22097,
     /* 1365889 */     GIR_EraseRootFromParent_Done,
     /* 1365890 */   // Label 19457: @1365890
     /* 1365890 */   GIM_Try, /*On fail goto*//*Label 19458*/ GIMT_Encode4(1365974), // Rule ID 22100 //
     /* 1365895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1365912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365948 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1365951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365973 */     // GIR_Coverage, 22100,
     /* 1365973 */     GIR_EraseRootFromParent_Done,
     /* 1365974 */   // Label 19458: @1365974
     /* 1365974 */   GIM_Try, /*On fail goto*//*Label 19459*/ GIMT_Encode4(1366058), // Rule ID 22101 //
     /* 1365979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1365996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1366035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366057 */     // GIR_Coverage, 22101,
     /* 1366057 */     GIR_EraseRootFromParent_Done,
     /* 1366058 */   // Label 19459: @1366058
     /* 1366058 */   GIM_Try, /*On fail goto*//*Label 19460*/ GIMT_Encode4(1366142), // Rule ID 22104 //
     /* 1366063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1366080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366116 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1366119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366141 */     // GIR_Coverage, 22104,
     /* 1366141 */     GIR_EraseRootFromParent_Done,
     /* 1366142 */   // Label 19460: @1366142
     /* 1366142 */   GIM_Try, /*On fail goto*//*Label 19461*/ GIMT_Encode4(1366226), // Rule ID 22105 //
     /* 1366147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1366164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366200 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1366203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366225 */     // GIR_Coverage, 22105,
     /* 1366225 */     GIR_EraseRootFromParent_Done,
     /* 1366226 */   // Label 19461: @1366226
     /* 1366226 */   GIM_Try, /*On fail goto*//*Label 19462*/ GIMT_Encode4(1366310), // Rule ID 22108 //
     /* 1366231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1366248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366284 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1366287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366309 */     // GIR_Coverage, 22108,
     /* 1366309 */     GIR_EraseRootFromParent_Done,
     /* 1366310 */   // Label 19462: @1366310
     /* 1366310 */   GIM_Try, /*On fail goto*//*Label 19463*/ GIMT_Encode4(1366394), // Rule ID 22109 //
     /* 1366315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1366332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366368 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1366371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366393 */     // GIR_Coverage, 22109,
     /* 1366393 */     GIR_EraseRootFromParent_Done,
     /* 1366394 */   // Label 19463: @1366394
     /* 1366394 */   GIM_Try, /*On fail goto*//*Label 19464*/ GIMT_Encode4(1366478), // Rule ID 22112 //
     /* 1366399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1366416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1366455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366477 */     // GIR_Coverage, 22112,
     /* 1366477 */     GIR_EraseRootFromParent_Done,
     /* 1366478 */   // Label 19464: @1366478
     /* 1366478 */   GIM_Try, /*On fail goto*//*Label 19465*/ GIMT_Encode4(1366562), // Rule ID 22113 //
     /* 1366483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1366500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366536 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1366539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366561 */     // GIR_Coverage, 22113,
     /* 1366561 */     GIR_EraseRootFromParent_Done,
     /* 1366562 */   // Label 19465: @1366562
     /* 1366562 */   GIM_Try, /*On fail goto*//*Label 19466*/ GIMT_Encode4(1366646), // Rule ID 22116 //
     /* 1366567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1366584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1366623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366645 */     // GIR_Coverage, 22116,
     /* 1366645 */     GIR_EraseRootFromParent_Done,
     /* 1366646 */   // Label 19466: @1366646
     /* 1366646 */   GIM_Try, /*On fail goto*//*Label 19467*/ GIMT_Encode4(1366730), // Rule ID 22117 //
     /* 1366651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1366668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1366707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366729 */     // GIR_Coverage, 22117,
     /* 1366729 */     GIR_EraseRootFromParent_Done,
     /* 1366730 */   // Label 19467: @1366730
     /* 1366730 */   GIM_Try, /*On fail goto*//*Label 19468*/ GIMT_Encode4(1366814), // Rule ID 22120 //
     /* 1366735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1366738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1366746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1366749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1366752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1366755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366788 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1366791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366813 */     // GIR_Coverage, 22120,
     /* 1366813 */     GIR_EraseRootFromParent_Done,
     /* 1366814 */   // Label 19468: @1366814
     /* 1366814 */   GIM_Try, /*On fail goto*//*Label 19469*/ GIMT_Encode4(1366898), // Rule ID 22121 //
     /* 1366819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1366822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1366830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1366833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1366836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1366839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366872 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1366875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366897 */     // GIR_Coverage, 22121,
     /* 1366897 */     GIR_EraseRootFromParent_Done,
     /* 1366898 */   // Label 19469: @1366898
     /* 1366898 */   GIM_Try, /*On fail goto*//*Label 19470*/ GIMT_Encode4(1366982), // Rule ID 22124 //
     /* 1366903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1366920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1366926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366956 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1366959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366981 */     // GIR_Coverage, 22124,
     /* 1366981 */     GIR_EraseRootFromParent_Done,
     /* 1366982 */   // Label 19470: @1366982
     /* 1366982 */   GIM_Try, /*On fail goto*//*Label 19471*/ GIMT_Encode4(1367066), // Rule ID 22125 //
     /* 1366987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1367004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1367043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367065 */     // GIR_Coverage, 22125,
     /* 1367065 */     GIR_EraseRootFromParent_Done,
     /* 1367066 */   // Label 19471: @1367066
     /* 1367066 */   GIM_Try, /*On fail goto*//*Label 19472*/ GIMT_Encode4(1367150), // Rule ID 22128 //
     /* 1367071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1367088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1367127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367149 */     // GIR_Coverage, 22128,
     /* 1367149 */     GIR_EraseRootFromParent_Done,
     /* 1367150 */   // Label 19472: @1367150
     /* 1367150 */   GIM_Try, /*On fail goto*//*Label 19473*/ GIMT_Encode4(1367234), // Rule ID 22129 //
     /* 1367155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1367172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367208 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1367211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367233 */     // GIR_Coverage, 22129,
     /* 1367233 */     GIR_EraseRootFromParent_Done,
     /* 1367234 */   // Label 19473: @1367234
     /* 1367234 */   GIM_Try, /*On fail goto*//*Label 19474*/ GIMT_Encode4(1367318), // Rule ID 22132 //
     /* 1367239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1367256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1367262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367292 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1367295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367317 */     // GIR_Coverage, 22132,
     /* 1367317 */     GIR_EraseRootFromParent_Done,
     /* 1367318 */   // Label 19474: @1367318
     /* 1367318 */   GIM_Try, /*On fail goto*//*Label 19475*/ GIMT_Encode4(1367402), // Rule ID 22133 //
     /* 1367323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1367340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1367346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367376 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1367379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367401 */     // GIR_Coverage, 22133,
     /* 1367401 */     GIR_EraseRootFromParent_Done,
     /* 1367402 */   // Label 19475: @1367402
     /* 1367402 */   GIM_Try, /*On fail goto*//*Label 19476*/ GIMT_Encode4(1367486), // Rule ID 22136 //
     /* 1367407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1367424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367460 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1367463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367485 */     // GIR_Coverage, 22136,
     /* 1367485 */     GIR_EraseRootFromParent_Done,
     /* 1367486 */   // Label 19476: @1367486
     /* 1367486 */   GIM_Try, /*On fail goto*//*Label 19477*/ GIMT_Encode4(1367570), // Rule ID 22137 //
     /* 1367491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1367508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367544 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1367547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367569 */     // GIR_Coverage, 22137,
     /* 1367569 */     GIR_EraseRootFromParent_Done,
     /* 1367570 */   // Label 19477: @1367570
     /* 1367570 */   GIM_Try, /*On fail goto*//*Label 19478*/ GIMT_Encode4(1367654), // Rule ID 22140 //
     /* 1367575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1367592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1367631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367653 */     // GIR_Coverage, 22140,
     /* 1367653 */     GIR_EraseRootFromParent_Done,
     /* 1367654 */   // Label 19478: @1367654
     /* 1367654 */   GIM_Try, /*On fail goto*//*Label 19479*/ GIMT_Encode4(1367738), // Rule ID 22141 //
     /* 1367659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1367676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367712 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1367715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367737 */     // GIR_Coverage, 22141,
     /* 1367737 */     GIR_EraseRootFromParent_Done,
     /* 1367738 */   // Label 19479: @1367738
     /* 1367738 */   GIM_Try, /*On fail goto*//*Label 19480*/ GIMT_Encode4(1367822), // Rule ID 22144 //
     /* 1367743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1367760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367796 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1367799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367821 */     // GIR_Coverage, 22144,
     /* 1367821 */     GIR_EraseRootFromParent_Done,
     /* 1367822 */   // Label 19480: @1367822
     /* 1367822 */   GIM_Try, /*On fail goto*//*Label 19481*/ GIMT_Encode4(1367906), // Rule ID 22145 //
     /* 1367827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1367844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367880 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1367883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367905 */     // GIR_Coverage, 22145,
     /* 1367905 */     GIR_EraseRootFromParent_Done,
     /* 1367906 */   // Label 19481: @1367906
     /* 1367906 */   GIM_Try, /*On fail goto*//*Label 19482*/ GIMT_Encode4(1367990), // Rule ID 22148 //
     /* 1367911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1367928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367964 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1367967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367989 */     // GIR_Coverage, 22148,
     /* 1367989 */     GIR_EraseRootFromParent_Done,
     /* 1367990 */   // Label 19482: @1367990
     /* 1367990 */   GIM_Try, /*On fail goto*//*Label 19483*/ GIMT_Encode4(1368074), // Rule ID 22149 //
     /* 1367995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1368012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1368051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368073 */     // GIR_Coverage, 22149,
     /* 1368073 */     GIR_EraseRootFromParent_Done,
     /* 1368074 */   // Label 19483: @1368074
     /* 1368074 */   GIM_Try, /*On fail goto*//*Label 19484*/ GIMT_Encode4(1368158), // Rule ID 22152 //
     /* 1368079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1368096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368132 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1368135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368157 */     // GIR_Coverage, 22152,
     /* 1368157 */     GIR_EraseRootFromParent_Done,
     /* 1368158 */   // Label 19484: @1368158
     /* 1368158 */   GIM_Try, /*On fail goto*//*Label 19485*/ GIMT_Encode4(1368242), // Rule ID 22153 //
     /* 1368163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1368180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1368219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368241 */     // GIR_Coverage, 22153,
     /* 1368241 */     GIR_EraseRootFromParent_Done,
     /* 1368242 */   // Label 19485: @1368242
     /* 1368242 */   GIM_Try, /*On fail goto*//*Label 19486*/ GIMT_Encode4(1368326), // Rule ID 22156 //
     /* 1368247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1368264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1368270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1368303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368325 */     // GIR_Coverage, 22156,
     /* 1368325 */     GIR_EraseRootFromParent_Done,
     /* 1368326 */   // Label 19486: @1368326
     /* 1368326 */   GIM_Try, /*On fail goto*//*Label 19487*/ GIMT_Encode4(1368410), // Rule ID 22157 //
     /* 1368331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1368348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1368354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368384 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1368387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368409 */     // GIR_Coverage, 22157,
     /* 1368409 */     GIR_EraseRootFromParent_Done,
     /* 1368410 */   // Label 19487: @1368410
     /* 1368410 */   GIM_Try, /*On fail goto*//*Label 19488*/ GIMT_Encode4(1368494), // Rule ID 22160 //
     /* 1368415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1368432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368468 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1368471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368493 */     // GIR_Coverage, 22160,
     /* 1368493 */     GIR_EraseRootFromParent_Done,
     /* 1368494 */   // Label 19488: @1368494
     /* 1368494 */   GIM_Try, /*On fail goto*//*Label 19489*/ GIMT_Encode4(1368578), // Rule ID 22161 //
     /* 1368499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1368516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368552 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1368555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368577 */     // GIR_Coverage, 22161,
     /* 1368577 */     GIR_EraseRootFromParent_Done,
     /* 1368578 */   // Label 19489: @1368578
     /* 1368578 */   GIM_Try, /*On fail goto*//*Label 19490*/ GIMT_Encode4(1368662), // Rule ID 22164 //
     /* 1368583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1368600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1368639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368661 */     // GIR_Coverage, 22164,
     /* 1368661 */     GIR_EraseRootFromParent_Done,
     /* 1368662 */   // Label 19490: @1368662
     /* 1368662 */   GIM_Try, /*On fail goto*//*Label 19491*/ GIMT_Encode4(1368746), // Rule ID 22165 //
     /* 1368667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1368684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368720 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1368723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368745 */     // GIR_Coverage, 22165,
     /* 1368745 */     GIR_EraseRootFromParent_Done,
     /* 1368746 */   // Label 19491: @1368746
     /* 1368746 */   GIM_Try, /*On fail goto*//*Label 19492*/ GIMT_Encode4(1368830), // Rule ID 22168 //
     /* 1368751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1368768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368804 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1368807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368829 */     // GIR_Coverage, 22168,
     /* 1368829 */     GIR_EraseRootFromParent_Done,
     /* 1368830 */   // Label 19492: @1368830
     /* 1368830 */   GIM_Try, /*On fail goto*//*Label 19493*/ GIMT_Encode4(1368914), // Rule ID 22169 //
     /* 1368835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1368852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368888 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1368891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368913 */     // GIR_Coverage, 22169,
     /* 1368913 */     GIR_EraseRootFromParent_Done,
     /* 1368914 */   // Label 19493: @1368914
     /* 1368914 */   GIM_Try, /*On fail goto*//*Label 19494*/ GIMT_Encode4(1368998), // Rule ID 22172 //
     /* 1368919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1368936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368972 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1368975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368997 */     // GIR_Coverage, 22172,
     /* 1368997 */     GIR_EraseRootFromParent_Done,
     /* 1368998 */   // Label 19494: @1368998
     /* 1368998 */   GIM_Try, /*On fail goto*//*Label 19495*/ GIMT_Encode4(1369082), // Rule ID 22173 //
     /* 1369003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1369020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369056 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1369059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369081 */     // GIR_Coverage, 22173,
     /* 1369081 */     GIR_EraseRootFromParent_Done,
     /* 1369082 */   // Label 19495: @1369082
     /* 1369082 */   GIM_Try, /*On fail goto*//*Label 19496*/ GIMT_Encode4(1369166), // Rule ID 22176 //
     /* 1369087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1369104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369140 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1369143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369165 */     // GIR_Coverage, 22176,
     /* 1369165 */     GIR_EraseRootFromParent_Done,
     /* 1369166 */   // Label 19496: @1369166
     /* 1369166 */   GIM_Try, /*On fail goto*//*Label 19497*/ GIMT_Encode4(1369250), // Rule ID 22177 //
     /* 1369171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1369188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1369227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369249 */     // GIR_Coverage, 22177,
     /* 1369249 */     GIR_EraseRootFromParent_Done,
     /* 1369250 */   // Label 19497: @1369250
     /* 1369250 */   GIM_Try, /*On fail goto*//*Label 19498*/ GIMT_Encode4(1369334), // Rule ID 22180 //
     /* 1369255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1369272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369308 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1369311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369333 */     // GIR_Coverage, 22180,
     /* 1369333 */     GIR_EraseRootFromParent_Done,
     /* 1369334 */   // Label 19498: @1369334
     /* 1369334 */   GIM_Try, /*On fail goto*//*Label 19499*/ GIMT_Encode4(1369418), // Rule ID 22181 //
     /* 1369339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1369356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369392 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1369395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369417 */     // GIR_Coverage, 22181,
     /* 1369417 */     GIR_EraseRootFromParent_Done,
     /* 1369418 */   // Label 19499: @1369418
     /* 1369418 */   GIM_Try, /*On fail goto*//*Label 19500*/ GIMT_Encode4(1369502), // Rule ID 22184 //
     /* 1369423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1369440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1369479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369501 */     // GIR_Coverage, 22184,
     /* 1369501 */     GIR_EraseRootFromParent_Done,
     /* 1369502 */   // Label 19500: @1369502
     /* 1369502 */   GIM_Try, /*On fail goto*//*Label 19501*/ GIMT_Encode4(1369586), // Rule ID 22185 //
     /* 1369507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1369524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369560 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1369563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369585 */     // GIR_Coverage, 22185,
     /* 1369585 */     GIR_EraseRootFromParent_Done,
     /* 1369586 */   // Label 19501: @1369586
     /* 1369586 */   GIM_Try, /*On fail goto*//*Label 19502*/ GIMT_Encode4(1369670), // Rule ID 22188 //
     /* 1369591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1369608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369644 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1369647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369669 */     // GIR_Coverage, 22188,
     /* 1369669 */     GIR_EraseRootFromParent_Done,
     /* 1369670 */   // Label 19502: @1369670
     /* 1369670 */   GIM_Try, /*On fail goto*//*Label 19503*/ GIMT_Encode4(1369754), // Rule ID 22189 //
     /* 1369675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1369692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369728 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1369731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369753 */     // GIR_Coverage, 22189,
     /* 1369753 */     GIR_EraseRootFromParent_Done,
     /* 1369754 */   // Label 19503: @1369754
     /* 1369754 */   GIM_Try, /*On fail goto*//*Label 19504*/ GIMT_Encode4(1369838), // Rule ID 22192 //
     /* 1369759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1369776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369812 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1369815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369837 */     // GIR_Coverage, 22192,
     /* 1369837 */     GIR_EraseRootFromParent_Done,
     /* 1369838 */   // Label 19504: @1369838
     /* 1369838 */   GIM_Try, /*On fail goto*//*Label 19505*/ GIMT_Encode4(1369922), // Rule ID 22193 //
     /* 1369843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1369860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1369899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369921 */     // GIR_Coverage, 22193,
     /* 1369921 */     GIR_EraseRootFromParent_Done,
     /* 1369922 */   // Label 19505: @1369922
     /* 1369922 */   GIM_Try, /*On fail goto*//*Label 19506*/ GIMT_Encode4(1370006), // Rule ID 22196 //
     /* 1369927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1369944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369980 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1369983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370005 */     // GIR_Coverage, 22196,
     /* 1370005 */     GIR_EraseRootFromParent_Done,
     /* 1370006 */   // Label 19506: @1370006
     /* 1370006 */   GIM_Try, /*On fail goto*//*Label 19507*/ GIMT_Encode4(1370090), // Rule ID 22197 //
     /* 1370011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1370028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1370067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370089 */     // GIR_Coverage, 22197,
     /* 1370089 */     GIR_EraseRootFromParent_Done,
     /* 1370090 */   // Label 19507: @1370090
     /* 1370090 */   GIM_Try, /*On fail goto*//*Label 19508*/ GIMT_Encode4(1370174), // Rule ID 22200 //
     /* 1370095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1370112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1370118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370148 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1370151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370173 */     // GIR_Coverage, 22200,
     /* 1370173 */     GIR_EraseRootFromParent_Done,
     /* 1370174 */   // Label 19508: @1370174
     /* 1370174 */   GIM_Try, /*On fail goto*//*Label 19509*/ GIMT_Encode4(1370258), // Rule ID 22201 //
     /* 1370179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1370196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1370202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1370235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370257 */     // GIR_Coverage, 22201,
     /* 1370257 */     GIR_EraseRootFromParent_Done,
     /* 1370258 */   // Label 19509: @1370258
     /* 1370258 */   GIM_Try, /*On fail goto*//*Label 19510*/ GIMT_Encode4(1370342), // Rule ID 22204 //
     /* 1370263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1370274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1370277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1370280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1370283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1370286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1370319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370341 */     // GIR_Coverage, 22204,
     /* 1370341 */     GIR_EraseRootFromParent_Done,
     /* 1370342 */   // Label 19510: @1370342
     /* 1370342 */   GIM_Try, /*On fail goto*//*Label 19511*/ GIMT_Encode4(1370426), // Rule ID 22205 //
     /* 1370347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1370358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1370361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1370364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1370367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1370370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1370403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370425 */     // GIR_Coverage, 22205,
     /* 1370425 */     GIR_EraseRootFromParent_Done,
     /* 1370426 */   // Label 19511: @1370426
     /* 1370426 */   GIM_Try, /*On fail goto*//*Label 19512*/ GIMT_Encode4(1370510), // Rule ID 22208 //
     /* 1370431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1370434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1370442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1370445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1370448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1370451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370484 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1370487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1370505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370509 */     // GIR_Coverage, 22208,
     /* 1370509 */     GIR_EraseRootFromParent_Done,
     /* 1370510 */   // Label 19512: @1370510
     /* 1370510 */   GIM_Try, /*On fail goto*//*Label 19513*/ GIMT_Encode4(1370594), // Rule ID 22209 //
     /* 1370515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1370518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1370526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1370529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1370532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1370535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370568 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1370571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1370589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370593 */     // GIR_Coverage, 22209,
     /* 1370593 */     GIR_EraseRootFromParent_Done,
     /* 1370594 */   // Label 19513: @1370594
     /* 1370594 */   GIM_Try, /*On fail goto*//*Label 19514*/ GIMT_Encode4(1370678), // Rule ID 22212 //
     /* 1370599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1370616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1370655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370677 */     // GIR_Coverage, 22212,
     /* 1370677 */     GIR_EraseRootFromParent_Done,
     /* 1370678 */   // Label 19514: @1370678
     /* 1370678 */   GIM_Try, /*On fail goto*//*Label 19515*/ GIMT_Encode4(1370762), // Rule ID 22213 //
     /* 1370683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1370700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370736 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1370739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370761 */     // GIR_Coverage, 22213,
     /* 1370761 */     GIR_EraseRootFromParent_Done,
     /* 1370762 */   // Label 19515: @1370762
     /* 1370762 */   GIM_Try, /*On fail goto*//*Label 19516*/ GIMT_Encode4(1370846), // Rule ID 22216 //
     /* 1370767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1370784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370820 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1370823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370845 */     // GIR_Coverage, 22216,
     /* 1370845 */     GIR_EraseRootFromParent_Done,
     /* 1370846 */   // Label 19516: @1370846
     /* 1370846 */   GIM_Try, /*On fail goto*//*Label 19517*/ GIMT_Encode4(1370930), // Rule ID 22217 //
     /* 1370851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1370868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370904 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1370907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370929 */     // GIR_Coverage, 22217,
     /* 1370929 */     GIR_EraseRootFromParent_Done,
     /* 1370930 */   // Label 19517: @1370930
     /* 1370930 */   GIM_Try, /*On fail goto*//*Label 19518*/ GIMT_Encode4(1371014), // Rule ID 22220 //
     /* 1370935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1370952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1370958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370988 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1370991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371013 */     // GIR_Coverage, 22220,
     /* 1371013 */     GIR_EraseRootFromParent_Done,
     /* 1371014 */   // Label 19518: @1371014
     /* 1371014 */   GIM_Try, /*On fail goto*//*Label 19519*/ GIMT_Encode4(1371098), // Rule ID 22221 //
     /* 1371019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1371036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1371042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371072 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1371075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371097 */     // GIR_Coverage, 22221,
     /* 1371097 */     GIR_EraseRootFromParent_Done,
     /* 1371098 */   // Label 19519: @1371098
     /* 1371098 */   GIM_Try, /*On fail goto*//*Label 19520*/ GIMT_Encode4(1371182), // Rule ID 22224 //
     /* 1371103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1371120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1371159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371181 */     // GIR_Coverage, 22224,
     /* 1371181 */     GIR_EraseRootFromParent_Done,
     /* 1371182 */   // Label 19520: @1371182
     /* 1371182 */   GIM_Try, /*On fail goto*//*Label 19521*/ GIMT_Encode4(1371266), // Rule ID 22225 //
     /* 1371187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1371204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1371243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371265 */     // GIR_Coverage, 22225,
     /* 1371265 */     GIR_EraseRootFromParent_Done,
     /* 1371266 */   // Label 19521: @1371266
     /* 1371266 */   GIM_Try, /*On fail goto*//*Label 19522*/ GIMT_Encode4(1371350), // Rule ID 22228 //
     /* 1371271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1371288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371324 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1371327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371349 */     // GIR_Coverage, 22228,
     /* 1371349 */     GIR_EraseRootFromParent_Done,
     /* 1371350 */   // Label 19522: @1371350
     /* 1371350 */   GIM_Try, /*On fail goto*//*Label 19523*/ GIMT_Encode4(1371434), // Rule ID 22229 //
     /* 1371355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1371372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1371411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371433 */     // GIR_Coverage, 22229,
     /* 1371433 */     GIR_EraseRootFromParent_Done,
     /* 1371434 */   // Label 19523: @1371434
     /* 1371434 */   GIM_Try, /*On fail goto*//*Label 19524*/ GIMT_Encode4(1371518), // Rule ID 22232 //
     /* 1371439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1371456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371492 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1371495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371517 */     // GIR_Coverage, 22232,
     /* 1371517 */     GIR_EraseRootFromParent_Done,
     /* 1371518 */   // Label 19524: @1371518
     /* 1371518 */   GIM_Try, /*On fail goto*//*Label 19525*/ GIMT_Encode4(1371602), // Rule ID 22233 //
     /* 1371523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1371540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1371579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371601 */     // GIR_Coverage, 22233,
     /* 1371601 */     GIR_EraseRootFromParent_Done,
     /* 1371602 */   // Label 19525: @1371602
     /* 1371602 */   GIM_Try, /*On fail goto*//*Label 19526*/ GIMT_Encode4(1371686), // Rule ID 22236 //
     /* 1371607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1371624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371660 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1371663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371685 */     // GIR_Coverage, 22236,
     /* 1371685 */     GIR_EraseRootFromParent_Done,
     /* 1371686 */   // Label 19526: @1371686
     /* 1371686 */   GIM_Try, /*On fail goto*//*Label 19527*/ GIMT_Encode4(1371770), // Rule ID 22237 //
     /* 1371691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1371708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1371747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371769 */     // GIR_Coverage, 22237,
     /* 1371769 */     GIR_EraseRootFromParent_Done,
     /* 1371770 */   // Label 19527: @1371770
     /* 1371770 */   GIM_Try, /*On fail goto*//*Label 19528*/ GIMT_Encode4(1371854), // Rule ID 22240 //
     /* 1371775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1371792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371828 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1371831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371853 */     // GIR_Coverage, 22240,
     /* 1371853 */     GIR_EraseRootFromParent_Done,
     /* 1371854 */   // Label 19528: @1371854
     /* 1371854 */   GIM_Try, /*On fail goto*//*Label 19529*/ GIMT_Encode4(1371938), // Rule ID 22241 //
     /* 1371859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1371876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371912 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1371915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371937 */     // GIR_Coverage, 22241,
     /* 1371937 */     GIR_EraseRootFromParent_Done,
     /* 1371938 */   // Label 19529: @1371938
     /* 1371938 */   GIM_Try, /*On fail goto*//*Label 19530*/ GIMT_Encode4(1372022), // Rule ID 22244 //
     /* 1371943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1371960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1371999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372021 */     // GIR_Coverage, 22244,
     /* 1372021 */     GIR_EraseRootFromParent_Done,
     /* 1372022 */   // Label 19530: @1372022
     /* 1372022 */   GIM_Try, /*On fail goto*//*Label 19531*/ GIMT_Encode4(1372106), // Rule ID 22245 //
     /* 1372027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1372044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1372047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1372050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372080 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1372083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372105 */     // GIR_Coverage, 22245,
     /* 1372105 */     GIR_EraseRootFromParent_Done,
     /* 1372106 */   // Label 19531: @1372106
     /* 1372106 */   GIM_Try, /*On fail goto*//*Label 19532*/ GIMT_Encode4(1372190), // Rule ID 22248 //
     /* 1372111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1372114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1372128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1372149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372164 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1372167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372189 */     // GIR_Coverage, 22248,
     /* 1372189 */     GIR_EraseRootFromParent_Done,
     /* 1372190 */   // Label 19532: @1372190
     /* 1372190 */   GIM_Try, /*On fail goto*//*Label 19533*/ GIMT_Encode4(1372274), // Rule ID 22249 //
     /* 1372195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1372212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1372233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372248 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1372251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372273 */     // GIR_Coverage, 22249,
     /* 1372273 */     GIR_EraseRootFromParent_Done,
     /* 1372274 */   // Label 19533: @1372274
     /* 1372274 */   GIM_Try, /*On fail goto*//*Label 19534*/ GIMT_Encode4(1372358), // Rule ID 22252 //
     /* 1372279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1372282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1372296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372332 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1372335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372357 */     // GIR_Coverage, 22252,
     /* 1372357 */     GIR_EraseRootFromParent_Done,
     /* 1372358 */   // Label 19534: @1372358
     /* 1372358 */   GIM_Try, /*On fail goto*//*Label 19535*/ GIMT_Encode4(1372442), // Rule ID 22253 //
     /* 1372363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1372380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372416 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1372419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372441 */     // GIR_Coverage, 22253,
     /* 1372441 */     GIR_EraseRootFromParent_Done,
     /* 1372442 */   // Label 19535: @1372442
     /* 1372442 */   GIM_Try, /*On fail goto*//*Label 19536*/ GIMT_Encode4(1372526), // Rule ID 22256 //
     /* 1372447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1372450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1372464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372500 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1372503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372525 */     // GIR_Coverage, 22256,
     /* 1372525 */     GIR_EraseRootFromParent_Done,
     /* 1372526 */   // Label 19536: @1372526
     /* 1372526 */   GIM_Try, /*On fail goto*//*Label 19537*/ GIMT_Encode4(1372610), // Rule ID 22257 //
     /* 1372531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1372548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372584 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1372587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372609 */     // GIR_Coverage, 22257,
     /* 1372609 */     GIR_EraseRootFromParent_Done,
     /* 1372610 */   // Label 19537: @1372610
     /* 1372610 */   GIM_Try, /*On fail goto*//*Label 19538*/ GIMT_Encode4(1372694), // Rule ID 22260 //
     /* 1372615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1372632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372668 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1372671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372693 */     // GIR_Coverage, 22260,
     /* 1372693 */     GIR_EraseRootFromParent_Done,
     /* 1372694 */   // Label 19538: @1372694
     /* 1372694 */   GIM_Try, /*On fail goto*//*Label 19539*/ GIMT_Encode4(1372778), // Rule ID 22261 //
     /* 1372699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1372716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372752 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1372755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372777 */     // GIR_Coverage, 22261,
     /* 1372777 */     GIR_EraseRootFromParent_Done,
     /* 1372778 */   // Label 19539: @1372778
     /* 1372778 */   GIM_Try, /*On fail goto*//*Label 19540*/ GIMT_Encode4(1372862), // Rule ID 22264 //
     /* 1372783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1372800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372836 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1372839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372861 */     // GIR_Coverage, 22264,
     /* 1372861 */     GIR_EraseRootFromParent_Done,
     /* 1372862 */   // Label 19540: @1372862
     /* 1372862 */   GIM_Try, /*On fail goto*//*Label 19541*/ GIMT_Encode4(1372946), // Rule ID 22265 //
     /* 1372867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1372884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372920 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1372923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372945 */     // GIR_Coverage, 22265,
     /* 1372945 */     GIR_EraseRootFromParent_Done,
     /* 1372946 */   // Label 19541: @1372946
     /* 1372946 */   GIM_Try, /*On fail goto*//*Label 19542*/ GIMT_Encode4(1373030), // Rule ID 22268 //
     /* 1372951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1372968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373004 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1373007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373029 */     // GIR_Coverage, 22268,
     /* 1373029 */     GIR_EraseRootFromParent_Done,
     /* 1373030 */   // Label 19542: @1373030
     /* 1373030 */   GIM_Try, /*On fail goto*//*Label 19543*/ GIMT_Encode4(1373114), // Rule ID 22269 //
     /* 1373035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1373052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373088 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1373091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373113 */     // GIR_Coverage, 22269,
     /* 1373113 */     GIR_EraseRootFromParent_Done,
     /* 1373114 */   // Label 19543: @1373114
     /* 1373114 */   GIM_Try, /*On fail goto*//*Label 19544*/ GIMT_Encode4(1373198), // Rule ID 22272 //
     /* 1373119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1373136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1373175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373197 */     // GIR_Coverage, 22272,
     /* 1373197 */     GIR_EraseRootFromParent_Done,
     /* 1373198 */   // Label 19544: @1373198
     /* 1373198 */   GIM_Try, /*On fail goto*//*Label 19545*/ GIMT_Encode4(1373282), // Rule ID 22273 //
     /* 1373203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1373220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373256 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1373259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373281 */     // GIR_Coverage, 22273,
     /* 1373281 */     GIR_EraseRootFromParent_Done,
     /* 1373282 */   // Label 19545: @1373282
     /* 1373282 */   GIM_Try, /*On fail goto*//*Label 19546*/ GIMT_Encode4(1373366), // Rule ID 22276 //
     /* 1373287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1373304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373340 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1373343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373365 */     // GIR_Coverage, 22276,
     /* 1373365 */     GIR_EraseRootFromParent_Done,
     /* 1373366 */   // Label 19546: @1373366
     /* 1373366 */   GIM_Try, /*On fail goto*//*Label 19547*/ GIMT_Encode4(1373450), // Rule ID 22277 //
     /* 1373371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1373388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373424 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1373427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373449 */     // GIR_Coverage, 22277,
     /* 1373449 */     GIR_EraseRootFromParent_Done,
     /* 1373450 */   // Label 19547: @1373450
     /* 1373450 */   GIM_Try, /*On fail goto*//*Label 19548*/ GIMT_Encode4(1373534), // Rule ID 22280 //
     /* 1373455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1373472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1373511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373533 */     // GIR_Coverage, 22280,
     /* 1373533 */     GIR_EraseRootFromParent_Done,
     /* 1373534 */   // Label 19548: @1373534
     /* 1373534 */   GIM_Try, /*On fail goto*//*Label 19549*/ GIMT_Encode4(1373618), // Rule ID 22281 //
     /* 1373539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1373556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373592 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1373595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373617 */     // GIR_Coverage, 22281,
     /* 1373617 */     GIR_EraseRootFromParent_Done,
     /* 1373618 */   // Label 19549: @1373618
     /* 1373618 */   GIM_Try, /*On fail goto*//*Label 19550*/ GIMT_Encode4(1373702), // Rule ID 22284 //
     /* 1373623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373676 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1373679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373701 */     // GIR_Coverage, 22284,
     /* 1373701 */     GIR_EraseRootFromParent_Done,
     /* 1373702 */   // Label 19550: @1373702
     /* 1373702 */   GIM_Try, /*On fail goto*//*Label 19551*/ GIMT_Encode4(1373786), // Rule ID 22285 //
     /* 1373707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373760 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1373763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373785 */     // GIR_Coverage, 22285,
     /* 1373785 */     GIR_EraseRootFromParent_Done,
     /* 1373786 */   // Label 19551: @1373786
     /* 1373786 */   GIM_Try, /*On fail goto*//*Label 19552*/ GIMT_Encode4(1373870), // Rule ID 22288 //
     /* 1373791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1373808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373844 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1373847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373869 */     // GIR_Coverage, 22288,
     /* 1373869 */     GIR_EraseRootFromParent_Done,
     /* 1373870 */   // Label 19552: @1373870
     /* 1373870 */   GIM_Try, /*On fail goto*//*Label 19553*/ GIMT_Encode4(1373954), // Rule ID 22289 //
     /* 1373875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1373892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373928 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1373931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373953 */     // GIR_Coverage, 22289,
     /* 1373953 */     GIR_EraseRootFromParent_Done,
     /* 1373954 */   // Label 19553: @1373954
     /* 1373954 */   GIM_Try, /*On fail goto*//*Label 19554*/ GIMT_Encode4(1374038), // Rule ID 22292 //
     /* 1373959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1373976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374012 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1374015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1374033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374037 */     // GIR_Coverage, 22292,
     /* 1374037 */     GIR_EraseRootFromParent_Done,
     /* 1374038 */   // Label 19554: @1374038
     /* 1374038 */   GIM_Try, /*On fail goto*//*Label 19555*/ GIMT_Encode4(1374122), // Rule ID 22293 //
     /* 1374043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1374054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1374057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1374060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1374063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1374066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1374099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1374117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374121 */     // GIR_Coverage, 22293,
     /* 1374121 */     GIR_EraseRootFromParent_Done,
     /* 1374122 */   // Label 19555: @1374122
     /* 1374122 */   GIM_Try, /*On fail goto*//*Label 19556*/ GIMT_Encode4(1374206), // Rule ID 22296 //
     /* 1374127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1374130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1374138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1374141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1374144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1374147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1374150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374180 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1374183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1374201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374205 */     // GIR_Coverage, 22296,
     /* 1374205 */     GIR_EraseRootFromParent_Done,
     /* 1374206 */   // Label 19556: @1374206
     /* 1374206 */   GIM_Try, /*On fail goto*//*Label 19557*/ GIMT_Encode4(1374290), // Rule ID 22297 //
     /* 1374211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1374214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1374222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1374225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1374228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1374231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1374234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374264 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1374267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1374285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374289 */     // GIR_Coverage, 22297,
     /* 1374289 */     GIR_EraseRootFromParent_Done,
     /* 1374290 */   // Label 19557: @1374290
     /* 1374290 */   GIM_Try, /*On fail goto*//*Label 19558*/ GIMT_Encode4(1374374), // Rule ID 22300 //
     /* 1374295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1374312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374348 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1374351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374373 */     // GIR_Coverage, 22300,
     /* 1374373 */     GIR_EraseRootFromParent_Done,
     /* 1374374 */   // Label 19558: @1374374
     /* 1374374 */   GIM_Try, /*On fail goto*//*Label 19559*/ GIMT_Encode4(1374458), // Rule ID 22301 //
     /* 1374379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1374396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1374435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374457 */     // GIR_Coverage, 22301,
     /* 1374457 */     GIR_EraseRootFromParent_Done,
     /* 1374458 */   // Label 19559: @1374458
     /* 1374458 */   GIM_Try, /*On fail goto*//*Label 19560*/ GIMT_Encode4(1374542), // Rule ID 22304 //
     /* 1374463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374516 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1374519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374541 */     // GIR_Coverage, 22304,
     /* 1374541 */     GIR_EraseRootFromParent_Done,
     /* 1374542 */   // Label 19560: @1374542
     /* 1374542 */   GIM_Try, /*On fail goto*//*Label 19561*/ GIMT_Encode4(1374626), // Rule ID 22305 //
     /* 1374547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374600 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1374603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374625 */     // GIR_Coverage, 22305,
     /* 1374625 */     GIR_EraseRootFromParent_Done,
     /* 1374626 */   // Label 19561: @1374626
     /* 1374626 */   GIM_Try, /*On fail goto*//*Label 19562*/ GIMT_Encode4(1374710), // Rule ID 22308 //
     /* 1374631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374684 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1374687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374709 */     // GIR_Coverage, 22308,
     /* 1374709 */     GIR_EraseRootFromParent_Done,
     /* 1374710 */   // Label 19562: @1374710
     /* 1374710 */   GIM_Try, /*On fail goto*//*Label 19563*/ GIMT_Encode4(1374794), // Rule ID 22309 //
     /* 1374715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374768 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1374771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374793 */     // GIR_Coverage, 22309,
     /* 1374793 */     GIR_EraseRootFromParent_Done,
     /* 1374794 */   // Label 19563: @1374794
     /* 1374794 */   GIM_Try, /*On fail goto*//*Label 19564*/ GIMT_Encode4(1374878), // Rule ID 22312 //
     /* 1374799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1374816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1374855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374877 */     // GIR_Coverage, 22312,
     /* 1374877 */     GIR_EraseRootFromParent_Done,
     /* 1374878 */   // Label 19564: @1374878
     /* 1374878 */   GIM_Try, /*On fail goto*//*Label 19565*/ GIMT_Encode4(1374962), // Rule ID 22313 //
     /* 1374883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1374900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374936 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1374939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374961 */     // GIR_Coverage, 22313,
     /* 1374961 */     GIR_EraseRootFromParent_Done,
     /* 1374962 */   // Label 19565: @1374962
     /* 1374962 */   GIM_Try, /*On fail goto*//*Label 19566*/ GIMT_Encode4(1375046), // Rule ID 22316 //
     /* 1374967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1374984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1375023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375045 */     // GIR_Coverage, 22316,
     /* 1375045 */     GIR_EraseRootFromParent_Done,
     /* 1375046 */   // Label 19566: @1375046
     /* 1375046 */   GIM_Try, /*On fail goto*//*Label 19567*/ GIMT_Encode4(1375130), // Rule ID 22317 //
     /* 1375051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1375068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375104 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1375107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375129 */     // GIR_Coverage, 22317,
     /* 1375129 */     GIR_EraseRootFromParent_Done,
     /* 1375130 */   // Label 19567: @1375130
     /* 1375130 */   GIM_Try, /*On fail goto*//*Label 19568*/ GIMT_Encode4(1375214), // Rule ID 22320 //
     /* 1375135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1375152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1375158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375188 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1375191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375213 */     // GIR_Coverage, 22320,
     /* 1375213 */     GIR_EraseRootFromParent_Done,
     /* 1375214 */   // Label 19568: @1375214
     /* 1375214 */   GIM_Try, /*On fail goto*//*Label 19569*/ GIMT_Encode4(1375298), // Rule ID 22321 //
     /* 1375219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1375236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1375242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375272 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1375275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375297 */     // GIR_Coverage, 22321,
     /* 1375297 */     GIR_EraseRootFromParent_Done,
     /* 1375298 */   // Label 19569: @1375298
     /* 1375298 */   GIM_Try, /*On fail goto*//*Label 19570*/ GIMT_Encode4(1375382), // Rule ID 22324 //
     /* 1375303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1375320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375356 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1375359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375381 */     // GIR_Coverage, 22324,
     /* 1375381 */     GIR_EraseRootFromParent_Done,
     /* 1375382 */   // Label 19570: @1375382
     /* 1375382 */   GIM_Try, /*On fail goto*//*Label 19571*/ GIMT_Encode4(1375466), // Rule ID 22325 //
     /* 1375387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1375404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1375443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375465 */     // GIR_Coverage, 22325,
     /* 1375465 */     GIR_EraseRootFromParent_Done,
     /* 1375466 */   // Label 19571: @1375466
     /* 1375466 */   GIM_Try, /*On fail goto*//*Label 19572*/ GIMT_Encode4(1375550), // Rule ID 22328 //
     /* 1375471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1375527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375549 */     // GIR_Coverage, 22328,
     /* 1375549 */     GIR_EraseRootFromParent_Done,
     /* 1375550 */   // Label 19572: @1375550
     /* 1375550 */   GIM_Try, /*On fail goto*//*Label 19573*/ GIMT_Encode4(1375634), // Rule ID 22329 //
     /* 1375555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375608 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1375611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375633 */     // GIR_Coverage, 22329,
     /* 1375633 */     GIR_EraseRootFromParent_Done,
     /* 1375634 */   // Label 19573: @1375634
     /* 1375634 */   GIM_Try, /*On fail goto*//*Label 19574*/ GIMT_Encode4(1375718), // Rule ID 22332 //
     /* 1375639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375692 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1375695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375717 */     // GIR_Coverage, 22332,
     /* 1375717 */     GIR_EraseRootFromParent_Done,
     /* 1375718 */   // Label 19574: @1375718
     /* 1375718 */   GIM_Try, /*On fail goto*//*Label 19575*/ GIMT_Encode4(1375802), // Rule ID 22333 //
     /* 1375723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375776 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1375779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375801 */     // GIR_Coverage, 22333,
     /* 1375801 */     GIR_EraseRootFromParent_Done,
     /* 1375802 */   // Label 19575: @1375802
     /* 1375802 */   GIM_Try, /*On fail goto*//*Label 19576*/ GIMT_Encode4(1375886), // Rule ID 22336 //
     /* 1375807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1375824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375860 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1375863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375885 */     // GIR_Coverage, 22336,
     /* 1375885 */     GIR_EraseRootFromParent_Done,
     /* 1375886 */   // Label 19576: @1375886
     /* 1375886 */   GIM_Try, /*On fail goto*//*Label 19577*/ GIMT_Encode4(1375970), // Rule ID 22337 //
     /* 1375891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1375908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375944 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1375947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375969 */     // GIR_Coverage, 22337,
     /* 1375969 */     GIR_EraseRootFromParent_Done,
     /* 1375970 */   // Label 19577: @1375970
     /* 1375970 */   GIM_Try, /*On fail goto*//*Label 19578*/ GIMT_Encode4(1376054), // Rule ID 22340 //
     /* 1375975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1375992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1376013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376028 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1376031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376053 */     // GIR_Coverage, 22340,
     /* 1376053 */     GIR_EraseRootFromParent_Done,
     /* 1376054 */   // Label 19578: @1376054
     /* 1376054 */   GIM_Try, /*On fail goto*//*Label 19579*/ GIMT_Encode4(1376138), // Rule ID 22341 //
     /* 1376059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1376062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1376076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1376097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376112 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1376115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376137 */     // GIR_Coverage, 22341,
     /* 1376137 */     GIR_EraseRootFromParent_Done,
     /* 1376138 */   // Label 19579: @1376138
     /* 1376138 */   GIM_Try, /*On fail goto*//*Label 19580*/ GIMT_Encode4(1376222), // Rule ID 22344 //
     /* 1376143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1376146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1376160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376196 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1376199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376221 */     // GIR_Coverage, 22344,
     /* 1376221 */     GIR_EraseRootFromParent_Done,
     /* 1376222 */   // Label 19580: @1376222
     /* 1376222 */   GIM_Try, /*On fail goto*//*Label 19581*/ GIMT_Encode4(1376306), // Rule ID 22345 //
     /* 1376227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1376230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1376244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376280 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1376283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376305 */     // GIR_Coverage, 22345,
     /* 1376305 */     GIR_EraseRootFromParent_Done,
     /* 1376306 */   // Label 19581: @1376306
     /* 1376306 */   GIM_Try, /*On fail goto*//*Label 19582*/ GIMT_Encode4(1376390), // Rule ID 22348 //
     /* 1376311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1376328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376364 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1376367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376389 */     // GIR_Coverage, 22348,
     /* 1376389 */     GIR_EraseRootFromParent_Done,
     /* 1376390 */   // Label 19582: @1376390
     /* 1376390 */   GIM_Try, /*On fail goto*//*Label 19583*/ GIMT_Encode4(1376474), // Rule ID 22349 //
     /* 1376395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1376412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376448 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1376451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376473 */     // GIR_Coverage, 22349,
     /* 1376473 */     GIR_EraseRootFromParent_Done,
     /* 1376474 */   // Label 19583: @1376474
     /* 1376474 */   GIM_Try, /*On fail goto*//*Label 19584*/ GIMT_Encode4(1376558), // Rule ID 22352 //
     /* 1376479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376532 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1376535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376557 */     // GIR_Coverage, 22352,
     /* 1376557 */     GIR_EraseRootFromParent_Done,
     /* 1376558 */   // Label 19584: @1376558
     /* 1376558 */   GIM_Try, /*On fail goto*//*Label 19585*/ GIMT_Encode4(1376642), // Rule ID 22353 //
     /* 1376563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376616 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1376619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376641 */     // GIR_Coverage, 22353,
     /* 1376641 */     GIR_EraseRootFromParent_Done,
     /* 1376642 */   // Label 19585: @1376642
     /* 1376642 */   GIM_Try, /*On fail goto*//*Label 19586*/ GIMT_Encode4(1376726), // Rule ID 22356 //
     /* 1376647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376700 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1376703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376725 */     // GIR_Coverage, 22356,
     /* 1376725 */     GIR_EraseRootFromParent_Done,
     /* 1376726 */   // Label 19586: @1376726
     /* 1376726 */   GIM_Try, /*On fail goto*//*Label 19587*/ GIMT_Encode4(1376810), // Rule ID 22357 //
     /* 1376731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376784 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1376787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376809 */     // GIR_Coverage, 22357,
     /* 1376809 */     GIR_EraseRootFromParent_Done,
     /* 1376810 */   // Label 19587: @1376810
     /* 1376810 */   GIM_Try, /*On fail goto*//*Label 19588*/ GIMT_Encode4(1376894), // Rule ID 22360 //
     /* 1376815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1376832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1376871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376893 */     // GIR_Coverage, 22360,
     /* 1376893 */     GIR_EraseRootFromParent_Done,
     /* 1376894 */   // Label 19588: @1376894
     /* 1376894 */   GIM_Try, /*On fail goto*//*Label 19589*/ GIMT_Encode4(1376978), // Rule ID 22361 //
     /* 1376899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1376916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1376955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376977 */     // GIR_Coverage, 22361,
     /* 1376977 */     GIR_EraseRootFromParent_Done,
     /* 1376978 */   // Label 19589: @1376978
     /* 1376978 */   GIM_Try, /*On fail goto*//*Label 19590*/ GIMT_Encode4(1377062), // Rule ID 22364 //
     /* 1376983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1377000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377036 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1377039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377061 */     // GIR_Coverage, 22364,
     /* 1377061 */     GIR_EraseRootFromParent_Done,
     /* 1377062 */   // Label 19590: @1377062
     /* 1377062 */   GIM_Try, /*On fail goto*//*Label 19591*/ GIMT_Encode4(1377146), // Rule ID 22365 //
     /* 1377067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1377084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1377123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377145 */     // GIR_Coverage, 22365,
     /* 1377145 */     GIR_EraseRootFromParent_Done,
     /* 1377146 */   // Label 19591: @1377146
     /* 1377146 */   GIM_Try, /*On fail goto*//*Label 19592*/ GIMT_Encode4(1377230), // Rule ID 22368 //
     /* 1377151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1377168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1377207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377229 */     // GIR_Coverage, 22368,
     /* 1377229 */     GIR_EraseRootFromParent_Done,
     /* 1377230 */   // Label 19592: @1377230
     /* 1377230 */   GIM_Try, /*On fail goto*//*Label 19593*/ GIMT_Encode4(1377314), // Rule ID 22369 //
     /* 1377235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1377252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1377291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377313 */     // GIR_Coverage, 22369,
     /* 1377313 */     GIR_EraseRootFromParent_Done,
     /* 1377314 */   // Label 19593: @1377314
     /* 1377314 */   GIM_Try, /*On fail goto*//*Label 19594*/ GIMT_Encode4(1377398), // Rule ID 22372 //
     /* 1377319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1377336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1377342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377372 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1377375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377397 */     // GIR_Coverage, 22372,
     /* 1377397 */     GIR_EraseRootFromParent_Done,
     /* 1377398 */   // Label 19594: @1377398
     /* 1377398 */   GIM_Try, /*On fail goto*//*Label 19595*/ GIMT_Encode4(1377482), // Rule ID 22373 //
     /* 1377403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1377420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1377426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377456 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1377459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377481 */     // GIR_Coverage, 22373,
     /* 1377481 */     GIR_EraseRootFromParent_Done,
     /* 1377482 */   // Label 19595: @1377482
     /* 1377482 */   GIM_Try, /*On fail goto*//*Label 19596*/ GIMT_Encode4(1377566), // Rule ID 22376 //
     /* 1377487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1377543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377565 */     // GIR_Coverage, 22376,
     /* 1377565 */     GIR_EraseRootFromParent_Done,
     /* 1377566 */   // Label 19596: @1377566
     /* 1377566 */   GIM_Try, /*On fail goto*//*Label 19597*/ GIMT_Encode4(1377650), // Rule ID 22377 //
     /* 1377571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1377627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377649 */     // GIR_Coverage, 22377,
     /* 1377649 */     GIR_EraseRootFromParent_Done,
     /* 1377650 */   // Label 19597: @1377650
     /* 1377650 */   GIM_Try, /*On fail goto*//*Label 19598*/ GIMT_Encode4(1377734), // Rule ID 22380 //
     /* 1377655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1377672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377708 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1377711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377733 */     // GIR_Coverage, 22380,
     /* 1377733 */     GIR_EraseRootFromParent_Done,
     /* 1377734 */   // Label 19598: @1377734
     /* 1377734 */   GIM_Try, /*On fail goto*//*Label 19599*/ GIMT_Encode4(1377818), // Rule ID 22381 //
     /* 1377739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1377756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1377795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377817 */     // GIR_Coverage, 22381,
     /* 1377817 */     GIR_EraseRootFromParent_Done,
     /* 1377818 */   // Label 19599: @1377818
     /* 1377818 */   GIM_Try, /*On fail goto*//*Label 19600*/ GIMT_Encode4(1377902), // Rule ID 22384 //
     /* 1377823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1377826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1377840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1377879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377901 */     // GIR_Coverage, 22384,
     /* 1377901 */     GIR_EraseRootFromParent_Done,
     /* 1377902 */   // Label 19600: @1377902
     /* 1377902 */   GIM_Try, /*On fail goto*//*Label 19601*/ GIMT_Encode4(1377986), // Rule ID 22385 //
     /* 1377907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1377910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1377924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377960 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1377963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377985 */     // GIR_Coverage, 22385,
     /* 1377985 */     GIR_EraseRootFromParent_Done,
     /* 1377986 */   // Label 19601: @1377986
     /* 1377986 */   GIM_Try, /*On fail goto*//*Label 19602*/ GIMT_Encode4(1378070), // Rule ID 22388 //
     /* 1377991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1378008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378044 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1378047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378069 */     // GIR_Coverage, 22388,
     /* 1378069 */     GIR_EraseRootFromParent_Done,
     /* 1378070 */   // Label 19602: @1378070
     /* 1378070 */   GIM_Try, /*On fail goto*//*Label 19603*/ GIMT_Encode4(1378154), // Rule ID 22389 //
     /* 1378075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1378092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378128 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1378131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378153 */     // GIR_Coverage, 22389,
     /* 1378153 */     GIR_EraseRootFromParent_Done,
     /* 1378154 */   // Label 19603: @1378154
     /* 1378154 */   GIM_Try, /*On fail goto*//*Label 19604*/ GIMT_Encode4(1378238), // Rule ID 22392 //
     /* 1378159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1378176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378212 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1378215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378237 */     // GIR_Coverage, 22392,
     /* 1378237 */     GIR_EraseRootFromParent_Done,
     /* 1378238 */   // Label 19604: @1378238
     /* 1378238 */   GIM_Try, /*On fail goto*//*Label 19605*/ GIMT_Encode4(1378322), // Rule ID 22393 //
     /* 1378243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1378260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378296 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1378299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378321 */     // GIR_Coverage, 22393,
     /* 1378321 */     GIR_EraseRootFromParent_Done,
     /* 1378322 */   // Label 19605: @1378322
     /* 1378322 */   GIM_Try, /*On fail goto*//*Label 19606*/ GIMT_Encode4(1378406), // Rule ID 22396 //
     /* 1378327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1378344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1378350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378380 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1378383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378405 */     // GIR_Coverage, 22396,
     /* 1378405 */     GIR_EraseRootFromParent_Done,
     /* 1378406 */   // Label 19606: @1378406
     /* 1378406 */   GIM_Try, /*On fail goto*//*Label 19607*/ GIMT_Encode4(1378490), // Rule ID 22397 //
     /* 1378411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1378428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1378434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378464 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1378467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378489 */     // GIR_Coverage, 22397,
     /* 1378489 */     GIR_EraseRootFromParent_Done,
     /* 1378490 */   // Label 19607: @1378490
     /* 1378490 */   GIM_Try, /*On fail goto*//*Label 19608*/ GIMT_Encode4(1378574), // Rule ID 22400 //
     /* 1378495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378548 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1378551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378573 */     // GIR_Coverage, 22400,
     /* 1378573 */     GIR_EraseRootFromParent_Done,
     /* 1378574 */   // Label 19608: @1378574
     /* 1378574 */   GIM_Try, /*On fail goto*//*Label 19609*/ GIMT_Encode4(1378658), // Rule ID 22401 //
     /* 1378579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1378635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378657 */     // GIR_Coverage, 22401,
     /* 1378657 */     GIR_EraseRootFromParent_Done,
     /* 1378658 */   // Label 19609: @1378658
     /* 1378658 */   GIM_Try, /*On fail goto*//*Label 19610*/ GIMT_Encode4(1378742), // Rule ID 22404 //
     /* 1378663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1378680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1378719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378741 */     // GIR_Coverage, 22404,
     /* 1378741 */     GIR_EraseRootFromParent_Done,
     /* 1378742 */   // Label 19610: @1378742
     /* 1378742 */   GIM_Try, /*On fail goto*//*Label 19611*/ GIMT_Encode4(1378826), // Rule ID 22405 //
     /* 1378747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1378764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1378803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378825 */     // GIR_Coverage, 22405,
     /* 1378825 */     GIR_EraseRootFromParent_Done,
     /* 1378826 */   // Label 19611: @1378826
     /* 1378826 */   GIM_Try, /*On fail goto*//*Label 19612*/ GIMT_Encode4(1378910), // Rule ID 22408 //
     /* 1378831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1378848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378884 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1378887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378909 */     // GIR_Coverage, 22408,
     /* 1378909 */     GIR_EraseRootFromParent_Done,
     /* 1378910 */   // Label 19612: @1378910
     /* 1378910 */   GIM_Try, /*On fail goto*//*Label 19613*/ GIMT_Encode4(1378994), // Rule ID 22409 //
     /* 1378915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1378932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378968 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1378971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378993 */     // GIR_Coverage, 22409,
     /* 1378993 */     GIR_EraseRootFromParent_Done,
     /* 1378994 */   // Label 19613: @1378994
     /* 1378994 */   GIM_Try, /*On fail goto*//*Label 19614*/ GIMT_Encode4(1379078), // Rule ID 22412 //
     /* 1378999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1379016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1379055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379077 */     // GIR_Coverage, 22412,
     /* 1379077 */     GIR_EraseRootFromParent_Done,
     /* 1379078 */   // Label 19614: @1379078
     /* 1379078 */   GIM_Try, /*On fail goto*//*Label 19615*/ GIMT_Encode4(1379162), // Rule ID 22413 //
     /* 1379083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1379100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1379139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379161 */     // GIR_Coverage, 22413,
     /* 1379161 */     GIR_EraseRootFromParent_Done,
     /* 1379162 */   // Label 19615: @1379162
     /* 1379162 */   GIM_Try, /*On fail goto*//*Label 19616*/ GIMT_Encode4(1379246), // Rule ID 22416 //
     /* 1379167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1379184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379220 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1379223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379245 */     // GIR_Coverage, 22416,
     /* 1379245 */     GIR_EraseRootFromParent_Done,
     /* 1379246 */   // Label 19616: @1379246
     /* 1379246 */   GIM_Try, /*On fail goto*//*Label 19617*/ GIMT_Encode4(1379330), // Rule ID 22417 //
     /* 1379251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1379268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1379307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379329 */     // GIR_Coverage, 22417,
     /* 1379329 */     GIR_EraseRootFromParent_Done,
     /* 1379330 */   // Label 19617: @1379330
     /* 1379330 */   GIM_Try, /*On fail goto*//*Label 19618*/ GIMT_Encode4(1379414), // Rule ID 22420 //
     /* 1379335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1379352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379388 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1379391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379413 */     // GIR_Coverage, 22420,
     /* 1379413 */     GIR_EraseRootFromParent_Done,
     /* 1379414 */   // Label 19618: @1379414
     /* 1379414 */   GIM_Try, /*On fail goto*//*Label 19619*/ GIMT_Encode4(1379498), // Rule ID 22421 //
     /* 1379419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1379436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379472 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1379475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379497 */     // GIR_Coverage, 22421,
     /* 1379497 */     GIR_EraseRootFromParent_Done,
     /* 1379498 */   // Label 19619: @1379498
     /* 1379498 */   GIM_Try, /*On fail goto*//*Label 19620*/ GIMT_Encode4(1379582), // Rule ID 22424 //
     /* 1379503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379556 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1379559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379581 */     // GIR_Coverage, 22424,
     /* 1379581 */     GIR_EraseRootFromParent_Done,
     /* 1379582 */   // Label 19620: @1379582
     /* 1379582 */   GIM_Try, /*On fail goto*//*Label 19621*/ GIMT_Encode4(1379666), // Rule ID 22425 //
     /* 1379587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379640 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1379643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379665 */     // GIR_Coverage, 22425,
     /* 1379665 */     GIR_EraseRootFromParent_Done,
     /* 1379666 */   // Label 19621: @1379666
     /* 1379666 */   GIM_Try, /*On fail goto*//*Label 19622*/ GIMT_Encode4(1379750), // Rule ID 22428 //
     /* 1379671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1379688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379724 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1379727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379749 */     // GIR_Coverage, 22428,
     /* 1379749 */     GIR_EraseRootFromParent_Done,
     /* 1379750 */   // Label 19622: @1379750
     /* 1379750 */   GIM_Try, /*On fail goto*//*Label 19623*/ GIMT_Encode4(1379834), // Rule ID 22429 //
     /* 1379755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1379772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1379811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379833 */     // GIR_Coverage, 22429,
     /* 1379833 */     GIR_EraseRootFromParent_Done,
     /* 1379834 */   // Label 19623: @1379834
     /* 1379834 */   GIM_Try, /*On fail goto*//*Label 19624*/ GIMT_Encode4(1379918), // Rule ID 22432 //
     /* 1379839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1379856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379892 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1379895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379917 */     // GIR_Coverage, 22432,
     /* 1379917 */     GIR_EraseRootFromParent_Done,
     /* 1379918 */   // Label 19624: @1379918
     /* 1379918 */   GIM_Try, /*On fail goto*//*Label 19625*/ GIMT_Encode4(1380002), // Rule ID 22433 //
     /* 1379923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1379940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1379979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380001 */     // GIR_Coverage, 22433,
     /* 1380001 */     GIR_EraseRootFromParent_Done,
     /* 1380002 */   // Label 19625: @1380002
     /* 1380002 */   GIM_Try, /*On fail goto*//*Label 19626*/ GIMT_Encode4(1380086), // Rule ID 22436 //
     /* 1380007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1380024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380060 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1380063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380085 */     // GIR_Coverage, 22436,
     /* 1380085 */     GIR_EraseRootFromParent_Done,
     /* 1380086 */   // Label 19626: @1380086
     /* 1380086 */   GIM_Try, /*On fail goto*//*Label 19627*/ GIMT_Encode4(1380170), // Rule ID 22437 //
     /* 1380091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1380108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1380147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380169 */     // GIR_Coverage, 22437,
     /* 1380169 */     GIR_EraseRootFromParent_Done,
     /* 1380170 */   // Label 19627: @1380170
     /* 1380170 */   GIM_Try, /*On fail goto*//*Label 19628*/ GIMT_Encode4(1380254), // Rule ID 22440 //
     /* 1380175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1380192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380228 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1380231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380253 */     // GIR_Coverage, 22440,
     /* 1380253 */     GIR_EraseRootFromParent_Done,
     /* 1380254 */   // Label 19628: @1380254
     /* 1380254 */   GIM_Try, /*On fail goto*//*Label 19629*/ GIMT_Encode4(1380338), // Rule ID 22441 //
     /* 1380259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1380276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380312 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1380315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380337 */     // GIR_Coverage, 22441,
     /* 1380337 */     GIR_EraseRootFromParent_Done,
     /* 1380338 */   // Label 19629: @1380338
     /* 1380338 */   GIM_Try, /*On fail goto*//*Label 19630*/ GIMT_Encode4(1380422), // Rule ID 22444 //
     /* 1380343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1380360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1380399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380421 */     // GIR_Coverage, 22444,
     /* 1380421 */     GIR_EraseRootFromParent_Done,
     /* 1380422 */   // Label 19630: @1380422
     /* 1380422 */   GIM_Try, /*On fail goto*//*Label 19631*/ GIMT_Encode4(1380506), // Rule ID 22445 //
     /* 1380427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1380444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380480 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1380483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380505 */     // GIR_Coverage, 22445,
     /* 1380505 */     GIR_EraseRootFromParent_Done,
     /* 1380506 */   // Label 19631: @1380506
     /* 1380506 */   GIM_Try, /*On fail goto*//*Label 19632*/ GIMT_Encode4(1380590), // Rule ID 22448 //
     /* 1380511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1380567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380589 */     // GIR_Coverage, 22448,
     /* 1380589 */     GIR_EraseRootFromParent_Done,
     /* 1380590 */   // Label 19632: @1380590
     /* 1380590 */   GIM_Try, /*On fail goto*//*Label 19633*/ GIMT_Encode4(1380674), // Rule ID 22449 //
     /* 1380595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380648 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1380651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380673 */     // GIR_Coverage, 22449,
     /* 1380673 */     GIR_EraseRootFromParent_Done,
     /* 1380674 */   // Label 19633: @1380674
     /* 1380674 */   GIM_Try, /*On fail goto*//*Label 19634*/ GIMT_Encode4(1380758), // Rule ID 22452 //
     /* 1380679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1380696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380732 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1380735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380757 */     // GIR_Coverage, 22452,
     /* 1380757 */     GIR_EraseRootFromParent_Done,
     /* 1380758 */   // Label 19634: @1380758
     /* 1380758 */   GIM_Try, /*On fail goto*//*Label 19635*/ GIMT_Encode4(1380842), // Rule ID 22453 //
     /* 1380763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1380780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380816 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1380819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380841 */     // GIR_Coverage, 22453,
     /* 1380841 */     GIR_EraseRootFromParent_Done,
     /* 1380842 */   // Label 19635: @1380842
     /* 1380842 */   GIM_Try, /*On fail goto*//*Label 19636*/ GIMT_Encode4(1380926), // Rule ID 22456 //
     /* 1380847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1380864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380900 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1380903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380925 */     // GIR_Coverage, 22456,
     /* 1380925 */     GIR_EraseRootFromParent_Done,
     /* 1380926 */   // Label 19636: @1380926
     /* 1380926 */   GIM_Try, /*On fail goto*//*Label 19637*/ GIMT_Encode4(1381010), // Rule ID 22457 //
     /* 1380931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1380948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1380987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381009 */     // GIR_Coverage, 22457,
     /* 1381009 */     GIR_EraseRootFromParent_Done,
     /* 1381010 */   // Label 19637: @1381010
     /* 1381010 */   GIM_Try, /*On fail goto*//*Label 19638*/ GIMT_Encode4(1381094), // Rule ID 22460 //
     /* 1381015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1381032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381068 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1381071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381093 */     // GIR_Coverage, 22460,
     /* 1381093 */     GIR_EraseRootFromParent_Done,
     /* 1381094 */   // Label 19638: @1381094
     /* 1381094 */   GIM_Try, /*On fail goto*//*Label 19639*/ GIMT_Encode4(1381178), // Rule ID 22461 //
     /* 1381099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1381116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381152 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1381155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381177 */     // GIR_Coverage, 22461,
     /* 1381177 */     GIR_EraseRootFromParent_Done,
     /* 1381178 */   // Label 19639: @1381178
     /* 1381178 */   GIM_Try, /*On fail goto*//*Label 19640*/ GIMT_Encode4(1381262), // Rule ID 22464 //
     /* 1381183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1381200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1381206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381236 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1381239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381261 */     // GIR_Coverage, 22464,
     /* 1381261 */     GIR_EraseRootFromParent_Done,
     /* 1381262 */   // Label 19640: @1381262
     /* 1381262 */   GIM_Try, /*On fail goto*//*Label 19641*/ GIMT_Encode4(1381346), // Rule ID 22465 //
     /* 1381267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1381284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1381290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1381323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381345 */     // GIR_Coverage, 22465,
     /* 1381345 */     GIR_EraseRootFromParent_Done,
     /* 1381346 */   // Label 19641: @1381346
     /* 1381346 */   GIM_Try, /*On fail goto*//*Label 19642*/ GIMT_Encode4(1381430), // Rule ID 22468 //
     /* 1381351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1381368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1381371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381404 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1381407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381429 */     // GIR_Coverage, 22468,
     /* 1381429 */     GIR_EraseRootFromParent_Done,
     /* 1381430 */   // Label 19642: @1381430
     /* 1381430 */   GIM_Try, /*On fail goto*//*Label 19643*/ GIMT_Encode4(1381514), // Rule ID 22469 //
     /* 1381435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1381452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1381455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381488 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1381491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381513 */     // GIR_Coverage, 22469,
     /* 1381513 */     GIR_EraseRootFromParent_Done,
     /* 1381514 */   // Label 19643: @1381514
     /* 1381514 */   GIM_Try, /*On fail goto*//*Label 19644*/ GIMT_Encode4(1381598), // Rule ID 22472 //
     /* 1381519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1381522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1381539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381572 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1381575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381597 */     // GIR_Coverage, 22472,
     /* 1381597 */     GIR_EraseRootFromParent_Done,
     /* 1381598 */   // Label 19644: @1381598
     /* 1381598 */   GIM_Try, /*On fail goto*//*Label 19645*/ GIMT_Encode4(1381682), // Rule ID 22473 //
     /* 1381603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1381606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1381623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381656 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1381659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381681 */     // GIR_Coverage, 22473,
     /* 1381681 */     GIR_EraseRootFromParent_Done,
     /* 1381682 */   // Label 19645: @1381682
     /* 1381682 */   GIM_Try, /*On fail goto*//*Label 19646*/ GIMT_Encode4(1381766), // Rule ID 22476 //
     /* 1381687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1381704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1381743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381765 */     // GIR_Coverage, 22476,
     /* 1381765 */     GIR_EraseRootFromParent_Done,
     /* 1381766 */   // Label 19646: @1381766
     /* 1381766 */   GIM_Try, /*On fail goto*//*Label 19647*/ GIMT_Encode4(1381850), // Rule ID 22477 //
     /* 1381771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1381788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1381827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381849 */     // GIR_Coverage, 22477,
     /* 1381849 */     GIR_EraseRootFromParent_Done,
     /* 1381850 */   // Label 19647: @1381850
     /* 1381850 */   GIM_Try, /*On fail goto*//*Label 19648*/ GIMT_Encode4(1381934), // Rule ID 22480 //
     /* 1381855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1381872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1381878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381908 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1381911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381933 */     // GIR_Coverage, 22480,
     /* 1381933 */     GIR_EraseRootFromParent_Done,
     /* 1381934 */   // Label 19648: @1381934
     /* 1381934 */   GIM_Try, /*On fail goto*//*Label 19649*/ GIMT_Encode4(1382018), // Rule ID 22481 //
     /* 1381939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1381956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1381962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381992 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1381995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382017 */     // GIR_Coverage, 22481,
     /* 1382017 */     GIR_EraseRootFromParent_Done,
     /* 1382018 */   // Label 19649: @1382018
     /* 1382018 */   GIM_Try, /*On fail goto*//*Label 19650*/ GIMT_Encode4(1382102), // Rule ID 22484 //
     /* 1382023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1382040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1382046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382076 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1382079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382101 */     // GIR_Coverage, 22484,
     /* 1382101 */     GIR_EraseRootFromParent_Done,
     /* 1382102 */   // Label 19650: @1382102
     /* 1382102 */   GIM_Try, /*On fail goto*//*Label 19651*/ GIMT_Encode4(1382186), // Rule ID 22485 //
     /* 1382107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1382124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1382130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382160 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1382163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382185 */     // GIR_Coverage, 22485,
     /* 1382185 */     GIR_EraseRootFromParent_Done,
     /* 1382186 */   // Label 19651: @1382186
     /* 1382186 */   GIM_Try, /*On fail goto*//*Label 19652*/ GIMT_Encode4(1382270), // Rule ID 22488 //
     /* 1382191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1382208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382244 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1382247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382269 */     // GIR_Coverage, 22488,
     /* 1382269 */     GIR_EraseRootFromParent_Done,
     /* 1382270 */   // Label 19652: @1382270
     /* 1382270 */   GIM_Try, /*On fail goto*//*Label 19653*/ GIMT_Encode4(1382354), // Rule ID 22489 //
     /* 1382275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1382292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382328 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1382331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382353 */     // GIR_Coverage, 22489,
     /* 1382353 */     GIR_EraseRootFromParent_Done,
     /* 1382354 */   // Label 19653: @1382354
     /* 1382354 */   GIM_Try, /*On fail goto*//*Label 19654*/ GIMT_Encode4(1382438), // Rule ID 22492 //
     /* 1382359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1382376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382412 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1382415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382437 */     // GIR_Coverage, 22492,
     /* 1382437 */     GIR_EraseRootFromParent_Done,
     /* 1382438 */   // Label 19654: @1382438
     /* 1382438 */   GIM_Try, /*On fail goto*//*Label 19655*/ GIMT_Encode4(1382522), // Rule ID 22493 //
     /* 1382443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1382460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382496 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1382499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382521 */     // GIR_Coverage, 22493,
     /* 1382521 */     GIR_EraseRootFromParent_Done,
     /* 1382522 */   // Label 19655: @1382522
     /* 1382522 */   GIM_Try, /*On fail goto*//*Label 19656*/ GIMT_Encode4(1382606), // Rule ID 22496 //
     /* 1382527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382580 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1382583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382605 */     // GIR_Coverage, 22496,
     /* 1382605 */     GIR_EraseRootFromParent_Done,
     /* 1382606 */   // Label 19656: @1382606
     /* 1382606 */   GIM_Try, /*On fail goto*//*Label 19657*/ GIMT_Encode4(1382690), // Rule ID 22497 //
     /* 1382611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382664 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1382667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382689 */     // GIR_Coverage, 22497,
     /* 1382689 */     GIR_EraseRootFromParent_Done,
     /* 1382690 */   // Label 19657: @1382690
     /* 1382690 */   GIM_Try, /*On fail goto*//*Label 19658*/ GIMT_Encode4(1382774), // Rule ID 22500 //
     /* 1382695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1382712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382748 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1382751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382773 */     // GIR_Coverage, 22500,
     /* 1382773 */     GIR_EraseRootFromParent_Done,
     /* 1382774 */   // Label 19658: @1382774
     /* 1382774 */   GIM_Try, /*On fail goto*//*Label 19659*/ GIMT_Encode4(1382858), // Rule ID 22501 //
     /* 1382779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1382796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382832 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1382835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382857 */     // GIR_Coverage, 22501,
     /* 1382857 */     GIR_EraseRootFromParent_Done,
     /* 1382858 */   // Label 19659: @1382858
     /* 1382858 */   GIM_Try, /*On fail goto*//*Label 19660*/ GIMT_Encode4(1382942), // Rule ID 22504 //
     /* 1382863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1382880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1382919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382941 */     // GIR_Coverage, 22504,
     /* 1382941 */     GIR_EraseRootFromParent_Done,
     /* 1382942 */   // Label 19660: @1382942
     /* 1382942 */   GIM_Try, /*On fail goto*//*Label 19661*/ GIMT_Encode4(1383026), // Rule ID 22505 //
     /* 1382947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1382964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383000 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1383003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383025 */     // GIR_Coverage, 22505,
     /* 1383025 */     GIR_EraseRootFromParent_Done,
     /* 1383026 */   // Label 19661: @1383026
     /* 1383026 */   GIM_Try, /*On fail goto*//*Label 19662*/ GIMT_Encode4(1383110), // Rule ID 22508 //
     /* 1383031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1383048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1383054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1383087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383109 */     // GIR_Coverage, 22508,
     /* 1383109 */     GIR_EraseRootFromParent_Done,
     /* 1383110 */   // Label 19662: @1383110
     /* 1383110 */   GIM_Try, /*On fail goto*//*Label 19663*/ GIMT_Encode4(1383194), // Rule ID 22509 //
     /* 1383115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1383132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1383138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383168 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1383171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383193 */     // GIR_Coverage, 22509,
     /* 1383193 */     GIR_EraseRootFromParent_Done,
     /* 1383194 */   // Label 19663: @1383194
     /* 1383194 */   GIM_Try, /*On fail goto*//*Label 19664*/ GIMT_Encode4(1383278), // Rule ID 22512 //
     /* 1383199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1383216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1383237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1383255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383277 */     // GIR_Coverage, 22512,
     /* 1383277 */     GIR_EraseRootFromParent_Done,
     /* 1383278 */   // Label 19664: @1383278
     /* 1383278 */   GIM_Try, /*On fail goto*//*Label 19665*/ GIMT_Encode4(1383362), // Rule ID 22513 //
     /* 1383283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1383300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1383321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1383339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383361 */     // GIR_Coverage, 22513,
     /* 1383361 */     GIR_EraseRootFromParent_Done,
     /* 1383362 */   // Label 19665: @1383362
     /* 1383362 */   GIM_Try, /*On fail goto*//*Label 19666*/ GIMT_Encode4(1383446), // Rule ID 22516 //
     /* 1383367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1383384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1383423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383445 */     // GIR_Coverage, 22516,
     /* 1383445 */     GIR_EraseRootFromParent_Done,
     /* 1383446 */   // Label 19666: @1383446
     /* 1383446 */   GIM_Try, /*On fail goto*//*Label 19667*/ GIMT_Encode4(1383530), // Rule ID 22517 //
     /* 1383451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1383468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383504 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1383507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383529 */     // GIR_Coverage, 22517,
     /* 1383529 */     GIR_EraseRootFromParent_Done,
     /* 1383530 */   // Label 19667: @1383530
     /* 1383530 */   GIM_Try, /*On fail goto*//*Label 19668*/ GIMT_Encode4(1383614), // Rule ID 22520 //
     /* 1383535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383588 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1383591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383613 */     // GIR_Coverage, 22520,
     /* 1383613 */     GIR_EraseRootFromParent_Done,
     /* 1383614 */   // Label 19668: @1383614
     /* 1383614 */   GIM_Try, /*On fail goto*//*Label 19669*/ GIMT_Encode4(1383698), // Rule ID 22521 //
     /* 1383619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383672 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1383675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383697 */     // GIR_Coverage, 22521,
     /* 1383697 */     GIR_EraseRootFromParent_Done,
     /* 1383698 */   // Label 19669: @1383698
     /* 1383698 */   GIM_Try, /*On fail goto*//*Label 19670*/ GIMT_Encode4(1383782), // Rule ID 22524 //
     /* 1383703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1383720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383756 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1383759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383781 */     // GIR_Coverage, 22524,
     /* 1383781 */     GIR_EraseRootFromParent_Done,
     /* 1383782 */   // Label 19670: @1383782
     /* 1383782 */   GIM_Try, /*On fail goto*//*Label 19671*/ GIMT_Encode4(1383866), // Rule ID 22525 //
     /* 1383787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1383804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1383843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383865 */     // GIR_Coverage, 22525,
     /* 1383865 */     GIR_EraseRootFromParent_Done,
     /* 1383866 */   // Label 19671: @1383866
     /* 1383866 */   GIM_Try, /*On fail goto*//*Label 19672*/ GIMT_Encode4(1383950), // Rule ID 22528 //
     /* 1383871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1383888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1383927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383949 */     // GIR_Coverage, 22528,
     /* 1383949 */     GIR_EraseRootFromParent_Done,
     /* 1383950 */   // Label 19672: @1383950
     /* 1383950 */   GIM_Try, /*On fail goto*//*Label 19673*/ GIMT_Encode4(1384034), // Rule ID 22529 //
     /* 1383955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1383972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384008 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1384011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384033 */     // GIR_Coverage, 22529,
     /* 1384033 */     GIR_EraseRootFromParent_Done,
     /* 1384034 */   // Label 19673: @1384034
     /* 1384034 */   GIM_Try, /*On fail goto*//*Label 19674*/ GIMT_Encode4(1384118), // Rule ID 22532 //
     /* 1384039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1384056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384092 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1384095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384117 */     // GIR_Coverage, 22532,
     /* 1384117 */     GIR_EraseRootFromParent_Done,
     /* 1384118 */   // Label 19674: @1384118
     /* 1384118 */   GIM_Try, /*On fail goto*//*Label 19675*/ GIMT_Encode4(1384202), // Rule ID 22533 //
     /* 1384123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1384140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384176 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1384179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384201 */     // GIR_Coverage, 22533,
     /* 1384201 */     GIR_EraseRootFromParent_Done,
     /* 1384202 */   // Label 19675: @1384202
     /* 1384202 */   GIM_Try, /*On fail goto*//*Label 19676*/ GIMT_Encode4(1384286), // Rule ID 22536 //
     /* 1384207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1384224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384260 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1384263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384285 */     // GIR_Coverage, 22536,
     /* 1384285 */     GIR_EraseRootFromParent_Done,
     /* 1384286 */   // Label 19676: @1384286
     /* 1384286 */   GIM_Try, /*On fail goto*//*Label 19677*/ GIMT_Encode4(1384370), // Rule ID 22537 //
     /* 1384291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1384308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384344 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1384347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384369 */     // GIR_Coverage, 22537,
     /* 1384369 */     GIR_EraseRootFromParent_Done,
     /* 1384370 */   // Label 19677: @1384370
     /* 1384370 */   GIM_Try, /*On fail goto*//*Label 19678*/ GIMT_Encode4(1384454), // Rule ID 22540 //
     /* 1384375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1384392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384428 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1384431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384453 */     // GIR_Coverage, 22540,
     /* 1384453 */     GIR_EraseRootFromParent_Done,
     /* 1384454 */   // Label 19678: @1384454
     /* 1384454 */   GIM_Try, /*On fail goto*//*Label 19679*/ GIMT_Encode4(1384538), // Rule ID 22541 //
     /* 1384459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1384476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384512 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1384515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384537 */     // GIR_Coverage, 22541,
     /* 1384537 */     GIR_EraseRootFromParent_Done,
     /* 1384538 */   // Label 19679: @1384538
     /* 1384538 */   GIM_Try, /*On fail goto*//*Label 19680*/ GIMT_Encode4(1384622), // Rule ID 22544 //
     /* 1384543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1384560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1384599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384621 */     // GIR_Coverage, 22544,
     /* 1384621 */     GIR_EraseRootFromParent_Done,
     /* 1384622 */   // Label 19680: @1384622
     /* 1384622 */   GIM_Try, /*On fail goto*//*Label 19681*/ GIMT_Encode4(1384706), // Rule ID 22545 //
     /* 1384627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1384644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384680 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1384683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384705 */     // GIR_Coverage, 22545,
     /* 1384705 */     GIR_EraseRootFromParent_Done,
     /* 1384706 */   // Label 19681: @1384706
     /* 1384706 */   GIM_Try, /*On fail goto*//*Label 19682*/ GIMT_Encode4(1384790), // Rule ID 22548 //
     /* 1384711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1384728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384764 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1384767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384789 */     // GIR_Coverage, 22548,
     /* 1384789 */     GIR_EraseRootFromParent_Done,
     /* 1384790 */   // Label 19682: @1384790
     /* 1384790 */   GIM_Try, /*On fail goto*//*Label 19683*/ GIMT_Encode4(1384874), // Rule ID 22549 //
     /* 1384795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1384812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384848 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1384851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384873 */     // GIR_Coverage, 22549,
     /* 1384873 */     GIR_EraseRootFromParent_Done,
     /* 1384874 */   // Label 19683: @1384874
     /* 1384874 */   GIM_Try, /*On fail goto*//*Label 19684*/ GIMT_Encode4(1384958), // Rule ID 22552 //
     /* 1384879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1384896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1384935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384957 */     // GIR_Coverage, 22552,
     /* 1384957 */     GIR_EraseRootFromParent_Done,
     /* 1384958 */   // Label 19684: @1384958
     /* 1384958 */   GIM_Try, /*On fail goto*//*Label 19685*/ GIMT_Encode4(1385042), // Rule ID 22553 //
     /* 1384963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1384980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1385019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385041 */     // GIR_Coverage, 22553,
     /* 1385041 */     GIR_EraseRootFromParent_Done,
     /* 1385042 */   // Label 19685: @1385042
     /* 1385042 */   GIM_Try, /*On fail goto*//*Label 19686*/ GIMT_Encode4(1385126), // Rule ID 22556 //
     /* 1385047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1385058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1385061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1385064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1385067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1385070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385100 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1385103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385125 */     // GIR_Coverage, 22556,
     /* 1385125 */     GIR_EraseRootFromParent_Done,
     /* 1385126 */   // Label 19686: @1385126
     /* 1385126 */   GIM_Try, /*On fail goto*//*Label 19687*/ GIMT_Encode4(1385210), // Rule ID 22557 //
     /* 1385131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1385142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1385145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1385148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1385151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1385154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385184 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1385187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385209 */     // GIR_Coverage, 22557,
     /* 1385209 */     GIR_EraseRootFromParent_Done,
     /* 1385210 */   // Label 19687: @1385210
     /* 1385210 */   GIM_Try, /*On fail goto*//*Label 19688*/ GIMT_Encode4(1385294), // Rule ID 22560 //
     /* 1385215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1385218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1385226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1385229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1385232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1385235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1385238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1385271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1385289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385293 */     // GIR_Coverage, 22560,
     /* 1385293 */     GIR_EraseRootFromParent_Done,
     /* 1385294 */   // Label 19688: @1385294
     /* 1385294 */   GIM_Try, /*On fail goto*//*Label 19689*/ GIMT_Encode4(1385378), // Rule ID 22561 //
     /* 1385299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1385302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1385310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1385313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1385316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1385319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1385322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1385355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1385373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385377 */     // GIR_Coverage, 22561,
     /* 1385377 */     GIR_EraseRootFromParent_Done,
     /* 1385378 */   // Label 19689: @1385378
     /* 1385378 */   GIM_Try, /*On fail goto*//*Label 19690*/ GIMT_Encode4(1385462), // Rule ID 22564 //
     /* 1385383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1385400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385436 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1385439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385461 */     // GIR_Coverage, 22564,
     /* 1385461 */     GIR_EraseRootFromParent_Done,
     /* 1385462 */   // Label 19690: @1385462
     /* 1385462 */   GIM_Try, /*On fail goto*//*Label 19691*/ GIMT_Encode4(1385546), // Rule ID 22565 //
     /* 1385467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1385484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385520 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1385523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385545 */     // GIR_Coverage, 22565,
     /* 1385545 */     GIR_EraseRootFromParent_Done,
     /* 1385546 */   // Label 19691: @1385546
     /* 1385546 */   GIM_Try, /*On fail goto*//*Label 19692*/ GIMT_Encode4(1385630), // Rule ID 22568 //
     /* 1385551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1385568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385604 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1385607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385629 */     // GIR_Coverage, 22568,
     /* 1385629 */     GIR_EraseRootFromParent_Done,
     /* 1385630 */   // Label 19692: @1385630
     /* 1385630 */   GIM_Try, /*On fail goto*//*Label 19693*/ GIMT_Encode4(1385714), // Rule ID 22569 //
     /* 1385635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1385652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385688 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1385691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385713 */     // GIR_Coverage, 22569,
     /* 1385713 */     GIR_EraseRootFromParent_Done,
     /* 1385714 */   // Label 19693: @1385714
     /* 1385714 */   GIM_Try, /*On fail goto*//*Label 19694*/ GIMT_Encode4(1385798), // Rule ID 22572 //
     /* 1385719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1385736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1385742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385772 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1385775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385797 */     // GIR_Coverage, 22572,
     /* 1385797 */     GIR_EraseRootFromParent_Done,
     /* 1385798 */   // Label 19694: @1385798
     /* 1385798 */   GIM_Try, /*On fail goto*//*Label 19695*/ GIMT_Encode4(1385882), // Rule ID 22573 //
     /* 1385803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1385820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1385826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385856 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1385859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385881 */     // GIR_Coverage, 22573,
     /* 1385881 */     GIR_EraseRootFromParent_Done,
     /* 1385882 */   // Label 19695: @1385882
     /* 1385882 */   GIM_Try, /*On fail goto*//*Label 19696*/ GIMT_Encode4(1385966), // Rule ID 22576 //
     /* 1385887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1385904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1385943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385965 */     // GIR_Coverage, 22576,
     /* 1385965 */     GIR_EraseRootFromParent_Done,
     /* 1385966 */   // Label 19696: @1385966
     /* 1385966 */   GIM_Try, /*On fail goto*//*Label 19697*/ GIMT_Encode4(1386050), // Rule ID 22577 //
     /* 1385971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1385988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1386027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386049 */     // GIR_Coverage, 22577,
     /* 1386049 */     GIR_EraseRootFromParent_Done,
     /* 1386050 */   // Label 19697: @1386050
     /* 1386050 */   GIM_Try, /*On fail goto*//*Label 19698*/ GIMT_Encode4(1386134), // Rule ID 22580 //
     /* 1386055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1386066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1386069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1386072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1386075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1386111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386133 */     // GIR_Coverage, 22580,
     /* 1386133 */     GIR_EraseRootFromParent_Done,
     /* 1386134 */   // Label 19698: @1386134
     /* 1386134 */   GIM_Try, /*On fail goto*//*Label 19699*/ GIMT_Encode4(1386218), // Rule ID 22581 //
     /* 1386139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1386150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1386153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1386156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1386159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386192 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1386195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386217 */     // GIR_Coverage, 22581,
     /* 1386217 */     GIR_EraseRootFromParent_Done,
     /* 1386218 */   // Label 19699: @1386218
     /* 1386218 */   GIM_Try, /*On fail goto*//*Label 19700*/ GIMT_Encode4(1386302), // Rule ID 22584 //
     /* 1386223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1386234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1386237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1386240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1386243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1386246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1386279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386301 */     // GIR_Coverage, 22584,
     /* 1386301 */     GIR_EraseRootFromParent_Done,
     /* 1386302 */   // Label 19700: @1386302
     /* 1386302 */   GIM_Try, /*On fail goto*//*Label 19701*/ GIMT_Encode4(1386386), // Rule ID 22585 //
     /* 1386307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1386318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1386321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1386324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1386327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1386330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386360 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1386363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386385 */     // GIR_Coverage, 22585,
     /* 1386385 */     GIR_EraseRootFromParent_Done,
     /* 1386386 */   // Label 19701: @1386386
     /* 1386386 */   GIM_Try, /*On fail goto*//*Label 19702*/ GIMT_Encode4(1386470), // Rule ID 22588 //
     /* 1386391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1386408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1386447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386469 */     // GIR_Coverage, 22588,
     /* 1386469 */     GIR_EraseRootFromParent_Done,
     /* 1386470 */   // Label 19702: @1386470
     /* 1386470 */   GIM_Try, /*On fail goto*//*Label 19703*/ GIMT_Encode4(1386554), // Rule ID 22589 //
     /* 1386475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1386492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1386531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386553 */     // GIR_Coverage, 22589,
     /* 1386553 */     GIR_EraseRootFromParent_Done,
     /* 1386554 */   // Label 19703: @1386554
     /* 1386554 */   GIM_Try, /*On fail goto*//*Label 19704*/ GIMT_Encode4(1386638), // Rule ID 22592 //
     /* 1386559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1386576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386612 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1386615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386637 */     // GIR_Coverage, 22592,
     /* 1386637 */     GIR_EraseRootFromParent_Done,
     /* 1386638 */   // Label 19704: @1386638
     /* 1386638 */   GIM_Try, /*On fail goto*//*Label 19705*/ GIMT_Encode4(1386722), // Rule ID 22593 //
     /* 1386643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1386660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1386699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386721 */     // GIR_Coverage, 22593,
     /* 1386721 */     GIR_EraseRootFromParent_Done,
     /* 1386722 */   // Label 19705: @1386722
     /* 1386722 */   GIM_Try, /*On fail goto*//*Label 19706*/ GIMT_Encode4(1386806), // Rule ID 22596 //
     /* 1386727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1386744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386780 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1386783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386805 */     // GIR_Coverage, 22596,
     /* 1386805 */     GIR_EraseRootFromParent_Done,
     /* 1386806 */   // Label 19706: @1386806
     /* 1386806 */   GIM_Try, /*On fail goto*//*Label 19707*/ GIMT_Encode4(1386890), // Rule ID 22597 //
     /* 1386811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1386828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1386867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386889 */     // GIR_Coverage, 22597,
     /* 1386889 */     GIR_EraseRootFromParent_Done,
     /* 1386890 */   // Label 19707: @1386890
     /* 1386890 */   GIM_Try, /*On fail goto*//*Label 19708*/ GIMT_Encode4(1386974), // Rule ID 22600 //
     /* 1386895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1386898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1386912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386948 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1386951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386973 */     // GIR_Coverage, 22600,
     /* 1386973 */     GIR_EraseRootFromParent_Done,
     /* 1386974 */   // Label 19708: @1386974
     /* 1386974 */   GIM_Try, /*On fail goto*//*Label 19709*/ GIMT_Encode4(1387058), // Rule ID 22601 //
     /* 1386979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1386982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1386996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1387017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1387035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1387053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387057 */     // GIR_Coverage, 22601,
     /* 1387057 */     GIR_EraseRootFromParent_Done,
     /* 1387058 */   // Label 19709: @1387058
     /* 1387058 */   GIM_Try, /*On fail goto*//*Label 19710*/ GIMT_Encode4(1387142), // Rule ID 22604 //
     /* 1387063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1387066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1387080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1387083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1387101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387116 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1387119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1387137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387141 */     // GIR_Coverage, 22604,
     /* 1387141 */     GIR_EraseRootFromParent_Done,
     /* 1387142 */   // Label 19710: @1387142
     /* 1387142 */   GIM_Try, /*On fail goto*//*Label 19711*/ GIMT_Encode4(1387226), // Rule ID 22605 //
     /* 1387147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1387150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1387164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1387167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1387185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387200 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1387203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1387221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387225 */     // GIR_Coverage, 22605,
     /* 1387225 */     GIR_EraseRootFromParent_Done,
     /* 1387226 */   // Label 19711: @1387226
     /* 1387226 */   GIM_Try, /*On fail goto*//*Label 19712*/ GIMT_Encode4(1387310), // Rule ID 22608 //
     /* 1387231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1387234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1387248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1387251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1387254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1387269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1387287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1387305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387309 */     // GIR_Coverage, 22608,
     /* 1387309 */     GIR_EraseRootFromParent_Done,
     /* 1387310 */   // Label 19712: @1387310
     /* 1387310 */   GIM_Try, /*On fail goto*//*Label 19713*/ GIMT_Encode4(1387394), // Rule ID 22609 //
     /* 1387315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1387318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1387332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1387335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1387338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1387353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387368 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1387371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1387389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387393 */     // GIR_Coverage, 22609,
     /* 1387393 */     GIR_EraseRootFromParent_Done,
     /* 1387394 */   // Label 19713: @1387394
     /* 1387394 */   GIM_Try, /*On fail goto*//*Label 19714*/ GIMT_Encode4(1387478), // Rule ID 22612 //
     /* 1387399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1387416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1387455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387477 */     // GIR_Coverage, 22612,
     /* 1387477 */     GIR_EraseRootFromParent_Done,
     /* 1387478 */   // Label 19714: @1387478
     /* 1387478 */   GIM_Try, /*On fail goto*//*Label 19715*/ GIMT_Encode4(1387562), // Rule ID 22613 //
     /* 1387483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1387500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387536 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1387539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387561 */     // GIR_Coverage, 22613,
     /* 1387561 */     GIR_EraseRootFromParent_Done,
     /* 1387562 */   // Label 19715: @1387562
     /* 1387562 */   GIM_Try, /*On fail goto*//*Label 19716*/ GIMT_Encode4(1387646), // Rule ID 22616 //
     /* 1387567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1387584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387620 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1387623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387645 */     // GIR_Coverage, 22616,
     /* 1387645 */     GIR_EraseRootFromParent_Done,
     /* 1387646 */   // Label 19716: @1387646
     /* 1387646 */   GIM_Try, /*On fail goto*//*Label 19717*/ GIMT_Encode4(1387730), // Rule ID 22617 //
     /* 1387651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1387668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387704 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1387707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387729 */     // GIR_Coverage, 22617,
     /* 1387729 */     GIR_EraseRootFromParent_Done,
     /* 1387730 */   // Label 19717: @1387730
     /* 1387730 */   GIM_Try, /*On fail goto*//*Label 19718*/ GIMT_Encode4(1387814), // Rule ID 22620 //
     /* 1387735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1387752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387788 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1387791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387813 */     // GIR_Coverage, 22620,
     /* 1387813 */     GIR_EraseRootFromParent_Done,
     /* 1387814 */   // Label 19718: @1387814
     /* 1387814 */   GIM_Try, /*On fail goto*//*Label 19719*/ GIMT_Encode4(1387898), // Rule ID 22621 //
     /* 1387819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1387836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387872 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1387875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387897 */     // GIR_Coverage, 22621,
     /* 1387897 */     GIR_EraseRootFromParent_Done,
     /* 1387898 */   // Label 19719: @1387898
     /* 1387898 */   GIM_Try, /*On fail goto*//*Label 19720*/ GIMT_Encode4(1387982), // Rule ID 22624 //
     /* 1387903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1387920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387956 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1387959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387981 */     // GIR_Coverage, 22624,
     /* 1387981 */     GIR_EraseRootFromParent_Done,
     /* 1387982 */   // Label 19720: @1387982
     /* 1387982 */   GIM_Try, /*On fail goto*//*Label 19721*/ GIMT_Encode4(1388066), // Rule ID 22625 //
     /* 1387987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1388004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1388043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388065 */     // GIR_Coverage, 22625,
     /* 1388065 */     GIR_EraseRootFromParent_Done,
     /* 1388066 */   // Label 19721: @1388066
     /* 1388066 */   GIM_Try, /*On fail goto*//*Label 19722*/ GIMT_Encode4(1388150), // Rule ID 22628 //
     /* 1388071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1388088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388124 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1388127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388149 */     // GIR_Coverage, 22628,
     /* 1388149 */     GIR_EraseRootFromParent_Done,
     /* 1388150 */   // Label 19722: @1388150
     /* 1388150 */   GIM_Try, /*On fail goto*//*Label 19723*/ GIMT_Encode4(1388234), // Rule ID 22629 //
     /* 1388155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1388172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388208 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1388211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388233 */     // GIR_Coverage, 22629,
     /* 1388233 */     GIR_EraseRootFromParent_Done,
     /* 1388234 */   // Label 19723: @1388234
     /* 1388234 */   GIM_Try, /*On fail goto*//*Label 19724*/ GIMT_Encode4(1388318), // Rule ID 22632 //
     /* 1388239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1388256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1388295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388317 */     // GIR_Coverage, 22632,
     /* 1388317 */     GIR_EraseRootFromParent_Done,
     /* 1388318 */   // Label 19724: @1388318
     /* 1388318 */   GIM_Try, /*On fail goto*//*Label 19725*/ GIMT_Encode4(1388402), // Rule ID 22633 //
     /* 1388323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1388340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388376 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1388379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388401 */     // GIR_Coverage, 22633,
     /* 1388401 */     GIR_EraseRootFromParent_Done,
     /* 1388402 */   // Label 19725: @1388402
     /* 1388402 */   GIM_Try, /*On fail goto*//*Label 19726*/ GIMT_Encode4(1388486), // Rule ID 22636 //
     /* 1388407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1388424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388460 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1388463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388485 */     // GIR_Coverage, 22636,
     /* 1388485 */     GIR_EraseRootFromParent_Done,
     /* 1388486 */   // Label 19726: @1388486
     /* 1388486 */   GIM_Try, /*On fail goto*//*Label 19727*/ GIMT_Encode4(1388570), // Rule ID 22637 //
     /* 1388491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1388508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388544 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1388547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388569 */     // GIR_Coverage, 22637,
     /* 1388569 */     GIR_EraseRootFromParent_Done,
     /* 1388570 */   // Label 19727: @1388570
     /* 1388570 */   GIM_Try, /*On fail goto*//*Label 19728*/ GIMT_Encode4(1388654), // Rule ID 22640 //
     /* 1388575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1388592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1388631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388653 */     // GIR_Coverage, 22640,
     /* 1388653 */     GIR_EraseRootFromParent_Done,
     /* 1388654 */   // Label 19728: @1388654
     /* 1388654 */   GIM_Try, /*On fail goto*//*Label 19729*/ GIMT_Encode4(1388738), // Rule ID 22641 //
     /* 1388659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1388676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388712 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1388715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388737 */     // GIR_Coverage, 22641,
     /* 1388737 */     GIR_EraseRootFromParent_Done,
     /* 1388738 */   // Label 19729: @1388738
     /* 1388738 */   GIM_Try, /*On fail goto*//*Label 19730*/ GIMT_Encode4(1388822), // Rule ID 22644 //
     /* 1388743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1388760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1388799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388821 */     // GIR_Coverage, 22644,
     /* 1388821 */     GIR_EraseRootFromParent_Done,
     /* 1388822 */   // Label 19730: @1388822
     /* 1388822 */   GIM_Try, /*On fail goto*//*Label 19731*/ GIMT_Encode4(1388906), // Rule ID 22645 //
     /* 1388827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1388844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1388883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388905 */     // GIR_Coverage, 22645,
     /* 1388905 */     GIR_EraseRootFromParent_Done,
     /* 1388906 */   // Label 19731: @1388906
     /* 1388906 */   GIM_Try, /*On fail goto*//*Label 19732*/ GIMT_Encode4(1388990), // Rule ID 22648 //
     /* 1388911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1388914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1388928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388964 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1388967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388989 */     // GIR_Coverage, 22648,
     /* 1388989 */     GIR_EraseRootFromParent_Done,
     /* 1388990 */   // Label 19732: @1388990
     /* 1388990 */   GIM_Try, /*On fail goto*//*Label 19733*/ GIMT_Encode4(1389074), // Rule ID 22649 //
     /* 1388995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1388998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1389006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1389009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1389012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1389015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1389018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389048 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1389051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1389069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389073 */     // GIR_Coverage, 22649,
     /* 1389073 */     GIR_EraseRootFromParent_Done,
     /* 1389074 */   // Label 19733: @1389074
     /* 1389074 */   GIM_Try, /*On fail goto*//*Label 19734*/ GIMT_Encode4(1389158), // Rule ID 22652 //
     /* 1389079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1389096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1389135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389157 */     // GIR_Coverage, 22652,
     /* 1389157 */     GIR_EraseRootFromParent_Done,
     /* 1389158 */   // Label 19734: @1389158
     /* 1389158 */   GIM_Try, /*On fail goto*//*Label 19735*/ GIMT_Encode4(1389242), // Rule ID 22653 //
     /* 1389163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1389180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389216 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1389219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389241 */     // GIR_Coverage, 22653,
     /* 1389241 */     GIR_EraseRootFromParent_Done,
     /* 1389242 */   // Label 19735: @1389242
     /* 1389242 */   GIM_Try, /*On fail goto*//*Label 19736*/ GIMT_Encode4(1389326), // Rule ID 22656 //
     /* 1389247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1389264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1389303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389325 */     // GIR_Coverage, 22656,
     /* 1389325 */     GIR_EraseRootFromParent_Done,
     /* 1389326 */   // Label 19736: @1389326
     /* 1389326 */   GIM_Try, /*On fail goto*//*Label 19737*/ GIMT_Encode4(1389410), // Rule ID 22657 //
     /* 1389331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1389348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389384 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1389387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389409 */     // GIR_Coverage, 22657,
     /* 1389409 */     GIR_EraseRootFromParent_Done,
     /* 1389410 */   // Label 19737: @1389410
     /* 1389410 */   GIM_Try, /*On fail goto*//*Label 19738*/ GIMT_Encode4(1389494), // Rule ID 22660 //
     /* 1389415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1389432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1389438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389468 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1389471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389493 */     // GIR_Coverage, 22660,
     /* 1389493 */     GIR_EraseRootFromParent_Done,
     /* 1389494 */   // Label 19738: @1389494
     /* 1389494 */   GIM_Try, /*On fail goto*//*Label 19739*/ GIMT_Encode4(1389578), // Rule ID 22661 //
     /* 1389499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1389516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1389522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389552 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1389555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389577 */     // GIR_Coverage, 22661,
     /* 1389577 */     GIR_EraseRootFromParent_Done,
     /* 1389578 */   // Label 19739: @1389578
     /* 1389578 */   GIM_Try, /*On fail goto*//*Label 19740*/ GIMT_Encode4(1389662), // Rule ID 22664 //
     /* 1389583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1389600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1389639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389661 */     // GIR_Coverage, 22664,
     /* 1389661 */     GIR_EraseRootFromParent_Done,
     /* 1389662 */   // Label 19740: @1389662
     /* 1389662 */   GIM_Try, /*On fail goto*//*Label 19741*/ GIMT_Encode4(1389746), // Rule ID 22665 //
     /* 1389667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1389684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1389723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389745 */     // GIR_Coverage, 22665,
     /* 1389745 */     GIR_EraseRootFromParent_Done,
     /* 1389746 */   // Label 19741: @1389746
     /* 1389746 */   GIM_Try, /*On fail goto*//*Label 19742*/ GIMT_Encode4(1389830), // Rule ID 22668 //
     /* 1389751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1389807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389829 */     // GIR_Coverage, 22668,
     /* 1389829 */     GIR_EraseRootFromParent_Done,
     /* 1389830 */   // Label 19742: @1389830
     /* 1389830 */   GIM_Try, /*On fail goto*//*Label 19743*/ GIMT_Encode4(1389914), // Rule ID 22669 //
     /* 1389835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389888 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1389891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389913 */     // GIR_Coverage, 22669,
     /* 1389913 */     GIR_EraseRootFromParent_Done,
     /* 1389914 */   // Label 19743: @1389914
     /* 1389914 */   GIM_Try, /*On fail goto*//*Label 19744*/ GIMT_Encode4(1389998), // Rule ID 22672 //
     /* 1389919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1389936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389972 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1389975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389997 */     // GIR_Coverage, 22672,
     /* 1389997 */     GIR_EraseRootFromParent_Done,
     /* 1389998 */   // Label 19744: @1389998
     /* 1389998 */   GIM_Try, /*On fail goto*//*Label 19745*/ GIMT_Encode4(1390082), // Rule ID 22673 //
     /* 1390003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1390020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1390026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390056 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1390059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390081 */     // GIR_Coverage, 22673,
     /* 1390081 */     GIR_EraseRootFromParent_Done,
     /* 1390082 */   // Label 19745: @1390082
     /* 1390082 */   GIM_Try, /*On fail goto*//*Label 19746*/ GIMT_Encode4(1390166), // Rule ID 22676 //
     /* 1390087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1390104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1390143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390165 */     // GIR_Coverage, 22676,
     /* 1390165 */     GIR_EraseRootFromParent_Done,
     /* 1390166 */   // Label 19746: @1390166
     /* 1390166 */   GIM_Try, /*On fail goto*//*Label 19747*/ GIMT_Encode4(1390250), // Rule ID 22677 //
     /* 1390171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1390188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1390227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390249 */     // GIR_Coverage, 22677,
     /* 1390249 */     GIR_EraseRootFromParent_Done,
     /* 1390250 */   // Label 19747: @1390250
     /* 1390250 */   GIM_Try, /*On fail goto*//*Label 19748*/ GIMT_Encode4(1390334), // Rule ID 22680 //
     /* 1390255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1390272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390308 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1390311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390333 */     // GIR_Coverage, 22680,
     /* 1390333 */     GIR_EraseRootFromParent_Done,
     /* 1390334 */   // Label 19748: @1390334
     /* 1390334 */   GIM_Try, /*On fail goto*//*Label 19749*/ GIMT_Encode4(1390418), // Rule ID 22681 //
     /* 1390339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1390356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390392 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1390395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390417 */     // GIR_Coverage, 22681,
     /* 1390417 */     GIR_EraseRootFromParent_Done,
     /* 1390418 */   // Label 19749: @1390418
     /* 1390418 */   GIM_Try, /*On fail goto*//*Label 19750*/ GIMT_Encode4(1390502), // Rule ID 22684 //
     /* 1390423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1390440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1390446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390476 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1390479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390501 */     // GIR_Coverage, 22684,
     /* 1390501 */     GIR_EraseRootFromParent_Done,
     /* 1390502 */   // Label 19750: @1390502
     /* 1390502 */   GIM_Try, /*On fail goto*//*Label 19751*/ GIMT_Encode4(1390586), // Rule ID 22685 //
     /* 1390507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1390524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1390530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390560 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1390563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390585 */     // GIR_Coverage, 22685,
     /* 1390585 */     GIR_EraseRootFromParent_Done,
     /* 1390586 */   // Label 19751: @1390586
     /* 1390586 */   GIM_Try, /*On fail goto*//*Label 19752*/ GIMT_Encode4(1390670), // Rule ID 22688 //
     /* 1390591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1390608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1390647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390669 */     // GIR_Coverage, 22688,
     /* 1390669 */     GIR_EraseRootFromParent_Done,
     /* 1390670 */   // Label 19752: @1390670
     /* 1390670 */   GIM_Try, /*On fail goto*//*Label 19753*/ GIMT_Encode4(1390754), // Rule ID 22689 //
     /* 1390675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1390692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390728 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1390731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390753 */     // GIR_Coverage, 22689,
     /* 1390753 */     GIR_EraseRootFromParent_Done,
     /* 1390754 */   // Label 19753: @1390754
     /* 1390754 */   GIM_Try, /*On fail goto*//*Label 19754*/ GIMT_Encode4(1390838), // Rule ID 22692 //
     /* 1390759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1390776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390812 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1390815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390837 */     // GIR_Coverage, 22692,
     /* 1390837 */     GIR_EraseRootFromParent_Done,
     /* 1390838 */   // Label 19754: @1390838
     /* 1390838 */   GIM_Try, /*On fail goto*//*Label 19755*/ GIMT_Encode4(1390922), // Rule ID 22693 //
     /* 1390843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1390860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390896 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1390899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390921 */     // GIR_Coverage, 22693,
     /* 1390921 */     GIR_EraseRootFromParent_Done,
     /* 1390922 */   // Label 19755: @1390922
     /* 1390922 */   GIM_Try, /*On fail goto*//*Label 19756*/ GIMT_Encode4(1391006), // Rule ID 22696 //
     /* 1390927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1390944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390980 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1390983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1391001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391005 */     // GIR_Coverage, 22696,
     /* 1391005 */     GIR_EraseRootFromParent_Done,
     /* 1391006 */   // Label 19756: @1391006
     /* 1391006 */   GIM_Try, /*On fail goto*//*Label 19757*/ GIMT_Encode4(1391090), // Rule ID 22697 //
     /* 1391011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1391014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1391028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1391049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391064 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1391067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1391085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391089 */     // GIR_Coverage, 22697,
     /* 1391089 */     GIR_EraseRootFromParent_Done,
     /* 1391090 */   // Label 19757: @1391090
     /* 1391090 */   GIM_Try, /*On fail goto*//*Label 19758*/ GIMT_Encode4(1391174), // Rule ID 22700 //
     /* 1391095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1391112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391148 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1391151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391173 */     // GIR_Coverage, 22700,
     /* 1391173 */     GIR_EraseRootFromParent_Done,
     /* 1391174 */   // Label 19758: @1391174
     /* 1391174 */   GIM_Try, /*On fail goto*//*Label 19759*/ GIMT_Encode4(1391258), // Rule ID 22701 //
     /* 1391179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1391196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1391235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391257 */     // GIR_Coverage, 22701,
     /* 1391257 */     GIR_EraseRootFromParent_Done,
     /* 1391258 */   // Label 19759: @1391258
     /* 1391258 */   GIM_Try, /*On fail goto*//*Label 19760*/ GIMT_Encode4(1391342), // Rule ID 22704 //
     /* 1391263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1391280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1391319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391341 */     // GIR_Coverage, 22704,
     /* 1391341 */     GIR_EraseRootFromParent_Done,
     /* 1391342 */   // Label 19760: @1391342
     /* 1391342 */   GIM_Try, /*On fail goto*//*Label 19761*/ GIMT_Encode4(1391426), // Rule ID 22705 //
     /* 1391347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1391364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1391403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391425 */     // GIR_Coverage, 22705,
     /* 1391425 */     GIR_EraseRootFromParent_Done,
     /* 1391426 */   // Label 19761: @1391426
     /* 1391426 */   GIM_Try, /*On fail goto*//*Label 19762*/ GIMT_Encode4(1391510), // Rule ID 22708 //
     /* 1391431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1391448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1391487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391509 */     // GIR_Coverage, 22708,
     /* 1391509 */     GIR_EraseRootFromParent_Done,
     /* 1391510 */   // Label 19762: @1391510
     /* 1391510 */   GIM_Try, /*On fail goto*//*Label 19763*/ GIMT_Encode4(1391594), // Rule ID 22709 //
     /* 1391515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1391532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1391571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391593 */     // GIR_Coverage, 22709,
     /* 1391593 */     GIR_EraseRootFromParent_Done,
     /* 1391594 */   // Label 19763: @1391594
     /* 1391594 */   GIM_Try, /*On fail goto*//*Label 19764*/ GIMT_Encode4(1391678), // Rule ID 22712 //
     /* 1391599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1391616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1391655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391677 */     // GIR_Coverage, 22712,
     /* 1391677 */     GIR_EraseRootFromParent_Done,
     /* 1391678 */   // Label 19764: @1391678
     /* 1391678 */   GIM_Try, /*On fail goto*//*Label 19765*/ GIMT_Encode4(1391762), // Rule ID 22713 //
     /* 1391683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1391700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1391739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391761 */     // GIR_Coverage, 22713,
     /* 1391761 */     GIR_EraseRootFromParent_Done,
     /* 1391762 */   // Label 19765: @1391762
     /* 1391762 */   GIM_Try, /*On fail goto*//*Label 19766*/ GIMT_Encode4(1391846), // Rule ID 22716 //
     /* 1391767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1391784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391820 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1391823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391845 */     // GIR_Coverage, 22716,
     /* 1391845 */     GIR_EraseRootFromParent_Done,
     /* 1391846 */   // Label 19766: @1391846
     /* 1391846 */   GIM_Try, /*On fail goto*//*Label 19767*/ GIMT_Encode4(1391930), // Rule ID 22717 //
     /* 1391851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1391868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1391907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391929 */     // GIR_Coverage, 22717,
     /* 1391929 */     GIR_EraseRootFromParent_Done,
     /* 1391930 */   // Label 19767: @1391930
     /* 1391930 */   GIM_Try, /*On fail goto*//*Label 19768*/ GIMT_Encode4(1392014), // Rule ID 22720 //
     /* 1391935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1391952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391988 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1391991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392013 */     // GIR_Coverage, 22720,
     /* 1392013 */     GIR_EraseRootFromParent_Done,
     /* 1392014 */   // Label 19768: @1392014
     /* 1392014 */   GIM_Try, /*On fail goto*//*Label 19769*/ GIMT_Encode4(1392098), // Rule ID 22721 //
     /* 1392019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1392036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1392042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392072 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1392075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392097 */     // GIR_Coverage, 22721,
     /* 1392097 */     GIR_EraseRootFromParent_Done,
     /* 1392098 */   // Label 19769: @1392098
     /* 1392098 */   GIM_Try, /*On fail goto*//*Label 19770*/ GIMT_Encode4(1392182), // Rule ID 22724 //
     /* 1392103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1392120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1392159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392181 */     // GIR_Coverage, 22724,
     /* 1392181 */     GIR_EraseRootFromParent_Done,
     /* 1392182 */   // Label 19770: @1392182
     /* 1392182 */   GIM_Try, /*On fail goto*//*Label 19771*/ GIMT_Encode4(1392266), // Rule ID 22725 //
     /* 1392187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1392204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1392243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392265 */     // GIR_Coverage, 22725,
     /* 1392265 */     GIR_EraseRootFromParent_Done,
     /* 1392266 */   // Label 19771: @1392266
     /* 1392266 */   GIM_Try, /*On fail goto*//*Label 19772*/ GIMT_Encode4(1392350), // Rule ID 22728 //
     /* 1392271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1392288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1392294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1392327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392349 */     // GIR_Coverage, 22728,
     /* 1392349 */     GIR_EraseRootFromParent_Done,
     /* 1392350 */   // Label 19772: @1392350
     /* 1392350 */   GIM_Try, /*On fail goto*//*Label 19773*/ GIMT_Encode4(1392434), // Rule ID 22729 //
     /* 1392355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1392372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1392378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1392411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392433 */     // GIR_Coverage, 22729,
     /* 1392433 */     GIR_EraseRootFromParent_Done,
     /* 1392434 */   // Label 19773: @1392434
     /* 1392434 */   GIM_Try, /*On fail goto*//*Label 19774*/ GIMT_Encode4(1392518), // Rule ID 22732 //
     /* 1392439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1392456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392492 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1392495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392517 */     // GIR_Coverage, 22732,
     /* 1392517 */     GIR_EraseRootFromParent_Done,
     /* 1392518 */   // Label 19774: @1392518
     /* 1392518 */   GIM_Try, /*On fail goto*//*Label 19775*/ GIMT_Encode4(1392602), // Rule ID 22733 //
     /* 1392523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1392540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1392579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392601 */     // GIR_Coverage, 22733,
     /* 1392601 */     GIR_EraseRootFromParent_Done,
     /* 1392602 */   // Label 19775: @1392602
     /* 1392602 */   GIM_Try, /*On fail goto*//*Label 19776*/ GIMT_Encode4(1392686), // Rule ID 22736 //
     /* 1392607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1392624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392660 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1392663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392685 */     // GIR_Coverage, 22736,
     /* 1392685 */     GIR_EraseRootFromParent_Done,
     /* 1392686 */   // Label 19776: @1392686
     /* 1392686 */   GIM_Try, /*On fail goto*//*Label 19777*/ GIMT_Encode4(1392770), // Rule ID 22737 //
     /* 1392691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1392708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1392747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392769 */     // GIR_Coverage, 22737,
     /* 1392769 */     GIR_EraseRootFromParent_Done,
     /* 1392770 */   // Label 19777: @1392770
     /* 1392770 */   GIM_Try, /*On fail goto*//*Label 19778*/ GIMT_Encode4(1392854), // Rule ID 22740 //
     /* 1392775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1392792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1392798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392828 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1392831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392853 */     // GIR_Coverage, 22740,
     /* 1392853 */     GIR_EraseRootFromParent_Done,
     /* 1392854 */   // Label 19778: @1392854
     /* 1392854 */   GIM_Try, /*On fail goto*//*Label 19779*/ GIMT_Encode4(1392938), // Rule ID 22741 //
     /* 1392859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1392876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1392882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392912 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1392915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392937 */     // GIR_Coverage, 22741,
     /* 1392937 */     GIR_EraseRootFromParent_Done,
     /* 1392938 */   // Label 19779: @1392938
     /* 1392938 */   GIM_Try, /*On fail goto*//*Label 19780*/ GIMT_Encode4(1393022), // Rule ID 22744 //
     /* 1392943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1392960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1392966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1392999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393021 */     // GIR_Coverage, 22744,
     /* 1393021 */     GIR_EraseRootFromParent_Done,
     /* 1393022 */   // Label 19780: @1393022
     /* 1393022 */   GIM_Try, /*On fail goto*//*Label 19781*/ GIMT_Encode4(1393106), // Rule ID 22745 //
     /* 1393027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1393044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1393050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393080 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1393083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393105 */     // GIR_Coverage, 22745,
     /* 1393105 */     GIR_EraseRootFromParent_Done,
     /* 1393106 */   // Label 19781: @1393106
     /* 1393106 */   GIM_Try, /*On fail goto*//*Label 19782*/ GIMT_Encode4(1393190), // Rule ID 22748 //
     /* 1393111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1393128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1393167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393189 */     // GIR_Coverage, 22748,
     /* 1393189 */     GIR_EraseRootFromParent_Done,
     /* 1393190 */   // Label 19782: @1393190
     /* 1393190 */   GIM_Try, /*On fail goto*//*Label 19783*/ GIMT_Encode4(1393274), // Rule ID 22749 //
     /* 1393195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1393212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393248 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1393251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393273 */     // GIR_Coverage, 22749,
     /* 1393273 */     GIR_EraseRootFromParent_Done,
     /* 1393274 */   // Label 19783: @1393274
     /* 1393274 */   GIM_Try, /*On fail goto*//*Label 19784*/ GIMT_Encode4(1393358), // Rule ID 22752 //
     /* 1393279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1393296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393332 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1393335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393357 */     // GIR_Coverage, 22752,
     /* 1393357 */     GIR_EraseRootFromParent_Done,
     /* 1393358 */   // Label 19784: @1393358
     /* 1393358 */   GIM_Try, /*On fail goto*//*Label 19785*/ GIMT_Encode4(1393442), // Rule ID 22753 //
     /* 1393363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1393380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393416 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1393419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393441 */     // GIR_Coverage, 22753,
     /* 1393441 */     GIR_EraseRootFromParent_Done,
     /* 1393442 */   // Label 19785: @1393442
     /* 1393442 */   GIM_Try, /*On fail goto*//*Label 19786*/ GIMT_Encode4(1393526), // Rule ID 22756 //
     /* 1393447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1393503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393525 */     // GIR_Coverage, 22756,
     /* 1393525 */     GIR_EraseRootFromParent_Done,
     /* 1393526 */   // Label 19786: @1393526
     /* 1393526 */   GIM_Try, /*On fail goto*//*Label 19787*/ GIMT_Encode4(1393610), // Rule ID 22757 //
     /* 1393531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1393587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393609 */     // GIR_Coverage, 22757,
     /* 1393609 */     GIR_EraseRootFromParent_Done,
     /* 1393610 */   // Label 19787: @1393610
     /* 1393610 */   GIM_Try, /*On fail goto*//*Label 19788*/ GIMT_Encode4(1393694), // Rule ID 22760 //
     /* 1393615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1393632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1393671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393693 */     // GIR_Coverage, 22760,
     /* 1393693 */     GIR_EraseRootFromParent_Done,
     /* 1393694 */   // Label 19788: @1393694
     /* 1393694 */   GIM_Try, /*On fail goto*//*Label 19789*/ GIMT_Encode4(1393778), // Rule ID 22761 //
     /* 1393699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1393716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1393755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393777 */     // GIR_Coverage, 22761,
     /* 1393777 */     GIR_EraseRootFromParent_Done,
     /* 1393778 */   // Label 19789: @1393778
     /* 1393778 */   GIM_Try, /*On fail goto*//*Label 19790*/ GIMT_Encode4(1393862), // Rule ID 22764 //
     /* 1393783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1393800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393836 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1393839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393861 */     // GIR_Coverage, 22764,
     /* 1393861 */     GIR_EraseRootFromParent_Done,
     /* 1393862 */   // Label 19790: @1393862
     /* 1393862 */   GIM_Try, /*On fail goto*//*Label 19791*/ GIMT_Encode4(1393946), // Rule ID 22765 //
     /* 1393867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1393884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393920 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1393923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393945 */     // GIR_Coverage, 22765,
     /* 1393945 */     GIR_EraseRootFromParent_Done,
     /* 1393946 */   // Label 19791: @1393946
     /* 1393946 */   GIM_Try, /*On fail goto*//*Label 19792*/ GIMT_Encode4(1394030), // Rule ID 22768 //
     /* 1393951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1393968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1394007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394029 */     // GIR_Coverage, 22768,
     /* 1394029 */     GIR_EraseRootFromParent_Done,
     /* 1394030 */   // Label 19792: @1394030
     /* 1394030 */   GIM_Try, /*On fail goto*//*Label 19793*/ GIMT_Encode4(1394114), // Rule ID 22769 //
     /* 1394035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1394043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1394052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1394058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1394073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394088 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1394091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394113 */     // GIR_Coverage, 22769,
     /* 1394113 */     GIR_EraseRootFromParent_Done,
     /* 1394114 */   // Label 19793: @1394114
     /* 1394114 */   GIM_Try, /*On fail goto*//*Label 19794*/ GIMT_Encode4(1394198), // Rule ID 22772 //
     /* 1394119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1394136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1394175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394197 */     // GIR_Coverage, 22772,
     /* 1394197 */     GIR_EraseRootFromParent_Done,
     /* 1394198 */   // Label 19794: @1394198
     /* 1394198 */   GIM_Try, /*On fail goto*//*Label 19795*/ GIMT_Encode4(1394282), // Rule ID 22773 //
     /* 1394203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1394220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394256 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1394259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394281 */     // GIR_Coverage, 22773,
     /* 1394281 */     GIR_EraseRootFromParent_Done,
     /* 1394282 */   // Label 19795: @1394282
     /* 1394282 */   GIM_Try, /*On fail goto*//*Label 19796*/ GIMT_Encode4(1394366), // Rule ID 22776 //
     /* 1394287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1394304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394340 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1394343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394365 */     // GIR_Coverage, 22776,
     /* 1394365 */     GIR_EraseRootFromParent_Done,
     /* 1394366 */   // Label 19796: @1394366
     /* 1394366 */   GIM_Try, /*On fail goto*//*Label 19797*/ GIMT_Encode4(1394450), // Rule ID 22777 //
     /* 1394371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1394388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394424 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1394427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394449 */     // GIR_Coverage, 22777,
     /* 1394449 */     GIR_EraseRootFromParent_Done,
     /* 1394450 */   // Label 19797: @1394450
     /* 1394450 */   GIM_Try, /*On fail goto*//*Label 19798*/ GIMT_Encode4(1394534), // Rule ID 22780 //
     /* 1394455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1394472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394508 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1394511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394533 */     // GIR_Coverage, 22780,
     /* 1394533 */     GIR_EraseRootFromParent_Done,
     /* 1394534 */   // Label 19798: @1394534
     /* 1394534 */   GIM_Try, /*On fail goto*//*Label 19799*/ GIMT_Encode4(1394618), // Rule ID 22781 //
     /* 1394539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1394556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394592 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1394595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394617 */     // GIR_Coverage, 22781,
     /* 1394617 */     GIR_EraseRootFromParent_Done,
     /* 1394618 */   // Label 19799: @1394618
     /* 1394618 */   GIM_Try, /*On fail goto*//*Label 19800*/ GIMT_Encode4(1394702), // Rule ID 22784 //
     /* 1394623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394676 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1394679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394701 */     // GIR_Coverage, 22784,
     /* 1394701 */     GIR_EraseRootFromParent_Done,
     /* 1394702 */   // Label 19800: @1394702
     /* 1394702 */   GIM_Try, /*On fail goto*//*Label 19801*/ GIMT_Encode4(1394786), // Rule ID 22785 //
     /* 1394707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394760 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1394763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394785 */     // GIR_Coverage, 22785,
     /* 1394785 */     GIR_EraseRootFromParent_Done,
     /* 1394786 */   // Label 19801: @1394786
     /* 1394786 */   GIM_Try, /*On fail goto*//*Label 19802*/ GIMT_Encode4(1394870), // Rule ID 22788 //
     /* 1394791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1394808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394844 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1394847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394869 */     // GIR_Coverage, 22788,
     /* 1394869 */     GIR_EraseRootFromParent_Done,
     /* 1394870 */   // Label 19802: @1394870
     /* 1394870 */   GIM_Try, /*On fail goto*//*Label 19803*/ GIMT_Encode4(1394954), // Rule ID 22789 //
     /* 1394875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1394892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1394931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394953 */     // GIR_Coverage, 22789,
     /* 1394953 */     GIR_EraseRootFromParent_Done,
     /* 1394954 */   // Label 19803: @1394954
     /* 1394954 */   GIM_Try, /*On fail goto*//*Label 19804*/ GIMT_Encode4(1395038), // Rule ID 22792 //
     /* 1394959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1394976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395012 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1395015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395037 */     // GIR_Coverage, 22792,
     /* 1395037 */     GIR_EraseRootFromParent_Done,
     /* 1395038 */   // Label 19804: @1395038
     /* 1395038 */   GIM_Try, /*On fail goto*//*Label 19805*/ GIMT_Encode4(1395122), // Rule ID 22793 //
     /* 1395043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1395060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395096 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1395099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395121 */     // GIR_Coverage, 22793,
     /* 1395121 */     GIR_EraseRootFromParent_Done,
     /* 1395122 */   // Label 19805: @1395122
     /* 1395122 */   GIM_Try, /*On fail goto*//*Label 19806*/ GIMT_Encode4(1395206), // Rule ID 22796 //
     /* 1395127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1395144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1395183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395205 */     // GIR_Coverage, 22796,
     /* 1395205 */     GIR_EraseRootFromParent_Done,
     /* 1395206 */   // Label 19806: @1395206
     /* 1395206 */   GIM_Try, /*On fail goto*//*Label 19807*/ GIMT_Encode4(1395290), // Rule ID 22797 //
     /* 1395211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1395228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395264 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1395267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395289 */     // GIR_Coverage, 22797,
     /* 1395289 */     GIR_EraseRootFromParent_Done,
     /* 1395290 */   // Label 19807: @1395290
     /* 1395290 */   GIM_Try, /*On fail goto*//*Label 19808*/ GIMT_Encode4(1395374), // Rule ID 22800 //
     /* 1395295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1395312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1395318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395348 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1395351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395373 */     // GIR_Coverage, 22800,
     /* 1395373 */     GIR_EraseRootFromParent_Done,
     /* 1395374 */   // Label 19808: @1395374
     /* 1395374 */   GIM_Try, /*On fail goto*//*Label 19809*/ GIMT_Encode4(1395458), // Rule ID 22801 //
     /* 1395379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1395396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1395402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1395435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395457 */     // GIR_Coverage, 22801,
     /* 1395457 */     GIR_EraseRootFromParent_Done,
     /* 1395458 */   // Label 19809: @1395458
     /* 1395458 */   GIM_Try, /*On fail goto*//*Label 19810*/ GIMT_Encode4(1395542), // Rule ID 22804 //
     /* 1395463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395516 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1395519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395541 */     // GIR_Coverage, 22804,
     /* 1395541 */     GIR_EraseRootFromParent_Done,
     /* 1395542 */   // Label 19810: @1395542
     /* 1395542 */   GIM_Try, /*On fail goto*//*Label 19811*/ GIMT_Encode4(1395626), // Rule ID 22805 //
     /* 1395547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1395603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395625 */     // GIR_Coverage, 22805,
     /* 1395625 */     GIR_EraseRootFromParent_Done,
     /* 1395626 */   // Label 19811: @1395626
     /* 1395626 */   GIM_Try, /*On fail goto*//*Label 19812*/ GIMT_Encode4(1395710), // Rule ID 22808 //
     /* 1395631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1395648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395684 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1395687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395709 */     // GIR_Coverage, 22808,
     /* 1395709 */     GIR_EraseRootFromParent_Done,
     /* 1395710 */   // Label 19812: @1395710
     /* 1395710 */   GIM_Try, /*On fail goto*//*Label 19813*/ GIMT_Encode4(1395794), // Rule ID 22809 //
     /* 1395715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1395732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395768 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1395771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395793 */     // GIR_Coverage, 22809,
     /* 1395793 */     GIR_EraseRootFromParent_Done,
     /* 1395794 */   // Label 19813: @1395794
     /* 1395794 */   GIM_Try, /*On fail goto*//*Label 19814*/ GIMT_Encode4(1395878), // Rule ID 22812 //
     /* 1395799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1395816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1395822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1395855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395877 */     // GIR_Coverage, 22812,
     /* 1395877 */     GIR_EraseRootFromParent_Done,
     /* 1395878 */   // Label 19814: @1395878
     /* 1395878 */   GIM_Try, /*On fail goto*//*Label 19815*/ GIMT_Encode4(1395962), // Rule ID 22813 //
     /* 1395883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1395900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1395906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395936 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1395939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395961 */     // GIR_Coverage, 22813,
     /* 1395961 */     GIR_EraseRootFromParent_Done,
     /* 1395962 */   // Label 19815: @1395962
     /* 1395962 */   GIM_Try, /*On fail goto*//*Label 19816*/ GIMT_Encode4(1396046), // Rule ID 22816 //
     /* 1395967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1395984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1395990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1396023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396045 */     // GIR_Coverage, 22816,
     /* 1396045 */     GIR_EraseRootFromParent_Done,
     /* 1396046 */   // Label 19816: @1396046
     /* 1396046 */   GIM_Try, /*On fail goto*//*Label 19817*/ GIMT_Encode4(1396130), // Rule ID 22817 //
     /* 1396051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1396068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1396074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396104 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1396107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396129 */     // GIR_Coverage, 22817,
     /* 1396129 */     GIR_EraseRootFromParent_Done,
     /* 1396130 */   // Label 19817: @1396130
     /* 1396130 */   GIM_Try, /*On fail goto*//*Label 19818*/ GIMT_Encode4(1396214), // Rule ID 22820 //
     /* 1396135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1396152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1396191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396213 */     // GIR_Coverage, 22820,
     /* 1396213 */     GIR_EraseRootFromParent_Done,
     /* 1396214 */   // Label 19818: @1396214
     /* 1396214 */   GIM_Try, /*On fail goto*//*Label 19819*/ GIMT_Encode4(1396298), // Rule ID 22821 //
     /* 1396219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1396236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1396275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396297 */     // GIR_Coverage, 22821,
     /* 1396297 */     GIR_EraseRootFromParent_Done,
     /* 1396298 */   // Label 19819: @1396298
     /* 1396298 */   GIM_Try, /*On fail goto*//*Label 19820*/ GIMT_Encode4(1396382), // Rule ID 22824 //
     /* 1396303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1396320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396356 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1396359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396381 */     // GIR_Coverage, 22824,
     /* 1396381 */     GIR_EraseRootFromParent_Done,
     /* 1396382 */   // Label 19820: @1396382
     /* 1396382 */   GIM_Try, /*On fail goto*//*Label 19821*/ GIMT_Encode4(1396466), // Rule ID 22825 //
     /* 1396387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1396404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1396443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396465 */     // GIR_Coverage, 22825,
     /* 1396465 */     GIR_EraseRootFromParent_Done,
     /* 1396466 */   // Label 19821: @1396466
     /* 1396466 */   GIM_Try, /*On fail goto*//*Label 19822*/ GIMT_Encode4(1396550), // Rule ID 22828 //
     /* 1396471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1396488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1396494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1396527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396549 */     // GIR_Coverage, 22828,
     /* 1396549 */     GIR_EraseRootFromParent_Done,
     /* 1396550 */   // Label 19822: @1396550
     /* 1396550 */   GIM_Try, /*On fail goto*//*Label 19823*/ GIMT_Encode4(1396634), // Rule ID 22829 //
     /* 1396555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1396572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1396578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396608 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1396611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396633 */     // GIR_Coverage, 22829,
     /* 1396633 */     GIR_EraseRootFromParent_Done,
     /* 1396634 */   // Label 19823: @1396634
     /* 1396634 */   GIM_Try, /*On fail goto*//*Label 19824*/ GIMT_Encode4(1396718), // Rule ID 22832 //
     /* 1396639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1396656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396692 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1396695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396717 */     // GIR_Coverage, 22832,
     /* 1396717 */     GIR_EraseRootFromParent_Done,
     /* 1396718 */   // Label 19824: @1396718
     /* 1396718 */   GIM_Try, /*On fail goto*//*Label 19825*/ GIMT_Encode4(1396802), // Rule ID 22833 //
     /* 1396723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1396740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396776 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1396779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396801 */     // GIR_Coverage, 22833,
     /* 1396801 */     GIR_EraseRootFromParent_Done,
     /* 1396802 */   // Label 19825: @1396802
     /* 1396802 */   GIM_Try, /*On fail goto*//*Label 19826*/ GIMT_Encode4(1396886), // Rule ID 22836 //
     /* 1396807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1396824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396860 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1396863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396885 */     // GIR_Coverage, 22836,
     /* 1396885 */     GIR_EraseRootFromParent_Done,
     /* 1396886 */   // Label 19826: @1396886
     /* 1396886 */   GIM_Try, /*On fail goto*//*Label 19827*/ GIMT_Encode4(1396970), // Rule ID 22837 //
     /* 1396891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1396908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396944 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1396947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396969 */     // GIR_Coverage, 22837,
     /* 1396969 */     GIR_EraseRootFromParent_Done,
     /* 1396970 */   // Label 19827: @1396970
     /* 1396970 */   GIM_Try, /*On fail goto*//*Label 19828*/ GIMT_Encode4(1397054), // Rule ID 22840 //
     /* 1396975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1396992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397028 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1397031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397053 */     // GIR_Coverage, 22840,
     /* 1397053 */     GIR_EraseRootFromParent_Done,
     /* 1397054 */   // Label 19828: @1397054
     /* 1397054 */   GIM_Try, /*On fail goto*//*Label 19829*/ GIMT_Encode4(1397138), // Rule ID 22841 //
     /* 1397059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1397067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1397076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1397082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397112 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1397115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397137 */     // GIR_Coverage, 22841,
     /* 1397137 */     GIR_EraseRootFromParent_Done,
     /* 1397138 */   // Label 19829: @1397138
     /* 1397138 */   GIM_Try, /*On fail goto*//*Label 19830*/ GIMT_Encode4(1397222), // Rule ID 22960 //
     /* 1397143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1397160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397196 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1397199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397221 */     // GIR_Coverage, 22960,
     /* 1397221 */     GIR_EraseRootFromParent_Done,
     /* 1397222 */   // Label 19830: @1397222
     /* 1397222 */   GIM_Try, /*On fail goto*//*Label 19831*/ GIMT_Encode4(1397306), // Rule ID 22961 //
     /* 1397227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1397244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397280 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1397283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397305 */     // GIR_Coverage, 22961,
     /* 1397305 */     GIR_EraseRootFromParent_Done,
     /* 1397306 */   // Label 19831: @1397306
     /* 1397306 */   GIM_Try, /*On fail goto*//*Label 19832*/ GIMT_Encode4(1397390), // Rule ID 22964 //
     /* 1397311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1397328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397364 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1397367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397389 */     // GIR_Coverage, 22964,
     /* 1397389 */     GIR_EraseRootFromParent_Done,
     /* 1397390 */   // Label 19832: @1397390
     /* 1397390 */   GIM_Try, /*On fail goto*//*Label 19833*/ GIMT_Encode4(1397474), // Rule ID 22965 //
     /* 1397395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1397412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397448 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1397451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397473 */     // GIR_Coverage, 22965,
     /* 1397473 */     GIR_EraseRootFromParent_Done,
     /* 1397474 */   // Label 19833: @1397474
     /* 1397474 */   GIM_Try, /*On fail goto*//*Label 19834*/ GIMT_Encode4(1397558), // Rule ID 22968 //
     /* 1397479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1397482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1397496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397532 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1397535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397557 */     // GIR_Coverage, 22968,
     /* 1397557 */     GIR_EraseRootFromParent_Done,
     /* 1397558 */   // Label 19834: @1397558
     /* 1397558 */   GIM_Try, /*On fail goto*//*Label 19835*/ GIMT_Encode4(1397642), // Rule ID 22969 //
     /* 1397563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1397566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1397580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397616 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1397619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397641 */     // GIR_Coverage, 22969,
     /* 1397641 */     GIR_EraseRootFromParent_Done,
     /* 1397642 */   // Label 19835: @1397642
     /* 1397642 */   GIM_Try, /*On fail goto*//*Label 19836*/ GIMT_Encode4(1397726), // Rule ID 22972 //
     /* 1397647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1397664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397700 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1397703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397725 */     // GIR_Coverage, 22972,
     /* 1397725 */     GIR_EraseRootFromParent_Done,
     /* 1397726 */   // Label 19836: @1397726
     /* 1397726 */   GIM_Try, /*On fail goto*//*Label 19837*/ GIMT_Encode4(1397810), // Rule ID 22973 //
     /* 1397731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1397748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397784 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1397787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397809 */     // GIR_Coverage, 22973,
     /* 1397809 */     GIR_EraseRootFromParent_Done,
     /* 1397810 */   // Label 19837: @1397810
     /* 1397810 */   GIM_Try, /*On fail goto*//*Label 19838*/ GIMT_Encode4(1397894), // Rule ID 22976 //
     /* 1397815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1397818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1397832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397868 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1397871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397893 */     // GIR_Coverage, 22976,
     /* 1397893 */     GIR_EraseRootFromParent_Done,
     /* 1397894 */   // Label 19838: @1397894
     /* 1397894 */   GIM_Try, /*On fail goto*//*Label 19839*/ GIMT_Encode4(1397978), // Rule ID 22977 //
     /* 1397899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1397902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1397916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397952 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1397955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397977 */     // GIR_Coverage, 22977,
     /* 1397977 */     GIR_EraseRootFromParent_Done,
     /* 1397978 */   // Label 19839: @1397978
     /* 1397978 */   GIM_Try, /*On fail goto*//*Label 19840*/ GIMT_Encode4(1398062), // Rule ID 22980 //
     /* 1397983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1397986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1398000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1398006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1398039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398061 */     // GIR_Coverage, 22980,
     /* 1398061 */     GIR_EraseRootFromParent_Done,
     /* 1398062 */   // Label 19840: @1398062
     /* 1398062 */   GIM_Try, /*On fail goto*//*Label 19841*/ GIMT_Encode4(1398146), // Rule ID 22981 //
     /* 1398067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1398070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1398084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1398090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398120 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1398123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398145 */     // GIR_Coverage, 22981,
     /* 1398145 */     GIR_EraseRootFromParent_Done,
     /* 1398146 */   // Label 19841: @1398146
     /* 1398146 */   GIM_Try, /*On fail goto*//*Label 19842*/ GIMT_Encode4(1398230), // Rule ID 22984 //
     /* 1398151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1398154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1398168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398204 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1398207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398229 */     // GIR_Coverage, 22984,
     /* 1398229 */     GIR_EraseRootFromParent_Done,
     /* 1398230 */   // Label 19842: @1398230
     /* 1398230 */   GIM_Try, /*On fail goto*//*Label 19843*/ GIMT_Encode4(1398314), // Rule ID 22985 //
     /* 1398235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1398238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1398252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398288 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1398291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398313 */     // GIR_Coverage, 22985,
     /* 1398313 */     GIR_EraseRootFromParent_Done,
     /* 1398314 */   // Label 19843: @1398314
     /* 1398314 */   GIM_Try, /*On fail goto*//*Label 19844*/ GIMT_Encode4(1398398), // Rule ID 22988 //
     /* 1398319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1398322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1398336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398372 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1398375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398397 */     // GIR_Coverage, 22988,
     /* 1398397 */     GIR_EraseRootFromParent_Done,
     /* 1398398 */   // Label 19844: @1398398
     /* 1398398 */   GIM_Try, /*On fail goto*//*Label 19845*/ GIMT_Encode4(1398482), // Rule ID 22989 //
     /* 1398403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1398406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1398420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398456 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1398459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398481 */     // GIR_Coverage, 22989,
     /* 1398481 */     GIR_EraseRootFromParent_Done,
     /* 1398482 */   // Label 19845: @1398482
     /* 1398482 */   GIM_Try, /*On fail goto*//*Label 19846*/ GIMT_Encode4(1398566), // Rule ID 22992 //
     /* 1398487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1398490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1398504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1398510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398540 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1398543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398565 */     // GIR_Coverage, 22992,
     /* 1398565 */     GIR_EraseRootFromParent_Done,
     /* 1398566 */   // Label 19846: @1398566
     /* 1398566 */   GIM_Try, /*On fail goto*//*Label 19847*/ GIMT_Encode4(1398650), // Rule ID 22993 //
     /* 1398571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1398574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1398588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1398594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398624 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1398627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398649 */     // GIR_Coverage, 22993,
     /* 1398649 */     GIR_EraseRootFromParent_Done,
     /* 1398650 */   // Label 19847: @1398650
     /* 1398650 */   GIM_Try, /*On fail goto*//*Label 19848*/ GIMT_Encode4(1398734), // Rule ID 22996 //
     /* 1398655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1398672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398708 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1398711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398733 */     // GIR_Coverage, 22996,
     /* 1398733 */     GIR_EraseRootFromParent_Done,
     /* 1398734 */   // Label 19848: @1398734
     /* 1398734 */   GIM_Try, /*On fail goto*//*Label 19849*/ GIMT_Encode4(1398818), // Rule ID 22997 //
     /* 1398739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1398756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398792 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1398795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398817 */     // GIR_Coverage, 22997,
     /* 1398817 */     GIR_EraseRootFromParent_Done,
     /* 1398818 */   // Label 19849: @1398818
     /* 1398818 */   GIM_Try, /*On fail goto*//*Label 19850*/ GIMT_Encode4(1398902), // Rule ID 23000 //
     /* 1398823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1398840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398876 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1398879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398901 */     // GIR_Coverage, 23000,
     /* 1398901 */     GIR_EraseRootFromParent_Done,
     /* 1398902 */   // Label 19850: @1398902
     /* 1398902 */   GIM_Try, /*On fail goto*//*Label 19851*/ GIMT_Encode4(1398986), // Rule ID 23001 //
     /* 1398907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1398924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398960 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1398963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398985 */     // GIR_Coverage, 23001,
     /* 1398985 */     GIR_EraseRootFromParent_Done,
     /* 1398986 */   // Label 19851: @1398986
     /* 1398986 */   GIM_Try, /*On fail goto*//*Label 19852*/ GIMT_Encode4(1399070), // Rule ID 23004 //
     /* 1398991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1399008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1399014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399044 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1399047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399069 */     // GIR_Coverage, 23004,
     /* 1399069 */     GIR_EraseRootFromParent_Done,
     /* 1399070 */   // Label 19852: @1399070
     /* 1399070 */   GIM_Try, /*On fail goto*//*Label 19853*/ GIMT_Encode4(1399154), // Rule ID 23005 //
     /* 1399075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1399078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1399092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1399098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399128 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1399131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399153 */     // GIR_Coverage, 23005,
     /* 1399153 */     GIR_EraseRootFromParent_Done,
     /* 1399154 */   // Label 19853: @1399154
     /* 1399154 */   GIM_Try, /*On fail goto*//*Label 19854*/ GIMT_Encode4(1399238), // Rule ID 23008 //
     /* 1399159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1399162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1399176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399212 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1399215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399237 */     // GIR_Coverage, 23008,
     /* 1399237 */     GIR_EraseRootFromParent_Done,
     /* 1399238 */   // Label 19854: @1399238
     /* 1399238 */   GIM_Try, /*On fail goto*//*Label 19855*/ GIMT_Encode4(1399322), // Rule ID 23009 //
     /* 1399243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1399246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1399260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399296 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1399299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399321 */     // GIR_Coverage, 23009,
     /* 1399321 */     GIR_EraseRootFromParent_Done,
     /* 1399322 */   // Label 19855: @1399322
     /* 1399322 */   GIM_Try, /*On fail goto*//*Label 19856*/ GIMT_Encode4(1399406), // Rule ID 23012 //
     /* 1399327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1399330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1399344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399380 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1399383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399405 */     // GIR_Coverage, 23012,
     /* 1399405 */     GIR_EraseRootFromParent_Done,
     /* 1399406 */   // Label 19856: @1399406
     /* 1399406 */   GIM_Try, /*On fail goto*//*Label 19857*/ GIMT_Encode4(1399490), // Rule ID 23013 //
     /* 1399411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1399414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1399428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399464 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1399467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399489 */     // GIR_Coverage, 23013,
     /* 1399489 */     GIR_EraseRootFromParent_Done,
     /* 1399490 */   // Label 19857: @1399490
     /* 1399490 */   GIM_Try, /*On fail goto*//*Label 19858*/ GIMT_Encode4(1399574), // Rule ID 23016 //
     /* 1399495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1399498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1399512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399548 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1399551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399573 */     // GIR_Coverage, 23016,
     /* 1399573 */     GIR_EraseRootFromParent_Done,
     /* 1399574 */   // Label 19858: @1399574
     /* 1399574 */   GIM_Try, /*On fail goto*//*Label 19859*/ GIMT_Encode4(1399658), // Rule ID 23017 //
     /* 1399579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1399582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1399596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399632 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1399635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399657 */     // GIR_Coverage, 23017,
     /* 1399657 */     GIR_EraseRootFromParent_Done,
     /* 1399658 */   // Label 19859: @1399658
     /* 1399658 */   GIM_Try, /*On fail goto*//*Label 19860*/ GIMT_Encode4(1399742), // Rule ID 23020 //
     /* 1399663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1399666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1399680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399716 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1399719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399741 */     // GIR_Coverage, 23020,
     /* 1399741 */     GIR_EraseRootFromParent_Done,
     /* 1399742 */   // Label 19860: @1399742
     /* 1399742 */   GIM_Try, /*On fail goto*//*Label 19861*/ GIMT_Encode4(1399826), // Rule ID 23021 //
     /* 1399747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1399750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1399764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399800 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1399803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399825 */     // GIR_Coverage, 23021,
     /* 1399825 */     GIR_EraseRootFromParent_Done,
     /* 1399826 */   // Label 19861: @1399826
     /* 1399826 */   GIM_Try, /*On fail goto*//*Label 19862*/ GIMT_Encode4(1399910), // Rule ID 23024 //
     /* 1399831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1399834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1399848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399884 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1399887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399909 */     // GIR_Coverage, 23024,
     /* 1399909 */     GIR_EraseRootFromParent_Done,
     /* 1399910 */   // Label 19862: @1399910
     /* 1399910 */   GIM_Try, /*On fail goto*//*Label 19863*/ GIMT_Encode4(1399994), // Rule ID 23025 //
     /* 1399915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1399918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1399932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399968 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1399971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399993 */     // GIR_Coverage, 23025,
     /* 1399993 */     GIR_EraseRootFromParent_Done,
     /* 1399994 */   // Label 19863: @1399994
     /* 1399994 */   GIM_Try, /*On fail goto*//*Label 19864*/ GIMT_Encode4(1400078), // Rule ID 23028 //
     /* 1399999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1400002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1400016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400052 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1400055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400077 */     // GIR_Coverage, 23028,
     /* 1400077 */     GIR_EraseRootFromParent_Done,
     /* 1400078 */   // Label 19864: @1400078
     /* 1400078 */   GIM_Try, /*On fail goto*//*Label 19865*/ GIMT_Encode4(1400162), // Rule ID 23029 //
     /* 1400083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1400086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1400100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400136 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1400139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400161 */     // GIR_Coverage, 23029,
     /* 1400161 */     GIR_EraseRootFromParent_Done,
     /* 1400162 */   // Label 19865: @1400162
     /* 1400162 */   GIM_Try, /*On fail goto*//*Label 19866*/ GIMT_Encode4(1400246), // Rule ID 23032 //
     /* 1400167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1400184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400220 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1400223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400245 */     // GIR_Coverage, 23032,
     /* 1400245 */     GIR_EraseRootFromParent_Done,
     /* 1400246 */   // Label 19866: @1400246
     /* 1400246 */   GIM_Try, /*On fail goto*//*Label 19867*/ GIMT_Encode4(1400330), // Rule ID 23033 //
     /* 1400251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1400268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400304 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1400307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400329 */     // GIR_Coverage, 23033,
     /* 1400329 */     GIR_EraseRootFromParent_Done,
     /* 1400330 */   // Label 19867: @1400330
     /* 1400330 */   GIM_Try, /*On fail goto*//*Label 19868*/ GIMT_Encode4(1400414), // Rule ID 23036 //
     /* 1400335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1400338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1400352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1400358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400388 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1400391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400413 */     // GIR_Coverage, 23036,
     /* 1400413 */     GIR_EraseRootFromParent_Done,
     /* 1400414 */   // Label 19868: @1400414
     /* 1400414 */   GIM_Try, /*On fail goto*//*Label 19869*/ GIMT_Encode4(1400498), // Rule ID 23037 //
     /* 1400419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1400422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1400436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1400442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400472 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1400475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400497 */     // GIR_Coverage, 23037,
     /* 1400497 */     GIR_EraseRootFromParent_Done,
     /* 1400498 */   // Label 19869: @1400498
     /* 1400498 */   GIM_Try, /*On fail goto*//*Label 19870*/ GIMT_Encode4(1400582), // Rule ID 23040 //
     /* 1400503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1400506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1400520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400556 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1400559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400581 */     // GIR_Coverage, 23040,
     /* 1400581 */     GIR_EraseRootFromParent_Done,
     /* 1400582 */   // Label 19870: @1400582
     /* 1400582 */   GIM_Try, /*On fail goto*//*Label 19871*/ GIMT_Encode4(1400666), // Rule ID 23041 //
     /* 1400587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1400590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1400604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400640 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1400643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400665 */     // GIR_Coverage, 23041,
     /* 1400665 */     GIR_EraseRootFromParent_Done,
     /* 1400666 */   // Label 19871: @1400666
     /* 1400666 */   GIM_Try, /*On fail goto*//*Label 19872*/ GIMT_Encode4(1400750), // Rule ID 23044 //
     /* 1400671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1400688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400724 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1400727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400749 */     // GIR_Coverage, 23044,
     /* 1400749 */     GIR_EraseRootFromParent_Done,
     /* 1400750 */   // Label 19872: @1400750
     /* 1400750 */   GIM_Try, /*On fail goto*//*Label 19873*/ GIMT_Encode4(1400834), // Rule ID 23045 //
     /* 1400755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1400772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400808 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1400811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400833 */     // GIR_Coverage, 23045,
     /* 1400833 */     GIR_EraseRootFromParent_Done,
     /* 1400834 */   // Label 19873: @1400834
     /* 1400834 */   GIM_Try, /*On fail goto*//*Label 19874*/ GIMT_Encode4(1400918), // Rule ID 23048 //
     /* 1400839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1400856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1400862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400892 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1400895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400917 */     // GIR_Coverage, 23048,
     /* 1400917 */     GIR_EraseRootFromParent_Done,
     /* 1400918 */   // Label 19874: @1400918
     /* 1400918 */   GIM_Try, /*On fail goto*//*Label 19875*/ GIMT_Encode4(1401002), // Rule ID 23049 //
     /* 1400923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1400940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1400946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400976 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1400979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401001 */     // GIR_Coverage, 23049,
     /* 1401001 */     GIR_EraseRootFromParent_Done,
     /* 1401002 */   // Label 19875: @1401002
     /* 1401002 */   GIM_Try, /*On fail goto*//*Label 19876*/ GIMT_Encode4(1401086), // Rule ID 23052 //
     /* 1401007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1401010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1401024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1401030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401060 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1401063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401085 */     // GIR_Coverage, 23052,
     /* 1401085 */     GIR_EraseRootFromParent_Done,
     /* 1401086 */   // Label 19876: @1401086
     /* 1401086 */   GIM_Try, /*On fail goto*//*Label 19877*/ GIMT_Encode4(1401170), // Rule ID 23053 //
     /* 1401091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1401094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1401108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1401114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401144 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1401147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401169 */     // GIR_Coverage, 23053,
     /* 1401169 */     GIR_EraseRootFromParent_Done,
     /* 1401170 */   // Label 19877: @1401170
     /* 1401170 */   GIM_Try, /*On fail goto*//*Label 19878*/ GIMT_Encode4(1401254), // Rule ID 23056 //
     /* 1401175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1401178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1401192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401228 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1401231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401253 */     // GIR_Coverage, 23056,
     /* 1401253 */     GIR_EraseRootFromParent_Done,
     /* 1401254 */   // Label 19878: @1401254
     /* 1401254 */   GIM_Try, /*On fail goto*//*Label 19879*/ GIMT_Encode4(1401338), // Rule ID 23057 //
     /* 1401259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1401262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1401276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401312 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1401315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401337 */     // GIR_Coverage, 23057,
     /* 1401337 */     GIR_EraseRootFromParent_Done,
     /* 1401338 */   // Label 19879: @1401338
     /* 1401338 */   GIM_Try, /*On fail goto*//*Label 19880*/ GIMT_Encode4(1401422), // Rule ID 23060 //
     /* 1401343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1401346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1401360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1401366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401396 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1401399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401421 */     // GIR_Coverage, 23060,
     /* 1401421 */     GIR_EraseRootFromParent_Done,
     /* 1401422 */   // Label 19880: @1401422
     /* 1401422 */   GIM_Try, /*On fail goto*//*Label 19881*/ GIMT_Encode4(1401506), // Rule ID 23061 //
     /* 1401427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1401430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1401444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1401450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401480 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1401483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401505 */     // GIR_Coverage, 23061,
     /* 1401505 */     GIR_EraseRootFromParent_Done,
     /* 1401506 */   // Label 19881: @1401506
     /* 1401506 */   GIM_Try, /*On fail goto*//*Label 19882*/ GIMT_Encode4(1401590), // Rule ID 23064 //
     /* 1401511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1401514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1401528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401564 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1401567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401589 */     // GIR_Coverage, 23064,
     /* 1401589 */     GIR_EraseRootFromParent_Done,
     /* 1401590 */   // Label 19882: @1401590
     /* 1401590 */   GIM_Try, /*On fail goto*//*Label 19883*/ GIMT_Encode4(1401674), // Rule ID 23065 //
     /* 1401595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1401598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1401612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401648 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1401651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401673 */     // GIR_Coverage, 23065,
     /* 1401673 */     GIR_EraseRootFromParent_Done,
     /* 1401674 */   // Label 19883: @1401674
     /* 1401674 */   GIM_Try, /*On fail goto*//*Label 19884*/ GIMT_Encode4(1401758), // Rule ID 23068 //
     /* 1401679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1401682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1401696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401732 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1401735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401757 */     // GIR_Coverage, 23068,
     /* 1401757 */     GIR_EraseRootFromParent_Done,
     /* 1401758 */   // Label 19884: @1401758
     /* 1401758 */   GIM_Try, /*On fail goto*//*Label 19885*/ GIMT_Encode4(1401842), // Rule ID 23069 //
     /* 1401763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1401766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1401780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401816 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1401819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401841 */     // GIR_Coverage, 23069,
     /* 1401841 */     GIR_EraseRootFromParent_Done,
     /* 1401842 */   // Label 19885: @1401842
     /* 1401842 */   GIM_Try, /*On fail goto*//*Label 19886*/ GIMT_Encode4(1401926), // Rule ID 23072 //
     /* 1401847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1401850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1401864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401900 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1401903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401925 */     // GIR_Coverage, 23072,
     /* 1401925 */     GIR_EraseRootFromParent_Done,
     /* 1401926 */   // Label 19886: @1401926
     /* 1401926 */   GIM_Try, /*On fail goto*//*Label 19887*/ GIMT_Encode4(1402010), // Rule ID 23073 //
     /* 1401931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1401934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1401948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401984 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1401987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402009 */     // GIR_Coverage, 23073,
     /* 1402009 */     GIR_EraseRootFromParent_Done,
     /* 1402010 */   // Label 19887: @1402010
     /* 1402010 */   GIM_Try, /*On fail goto*//*Label 19888*/ GIMT_Encode4(1402094), // Rule ID 23076 //
     /* 1402015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1402018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1402023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1402026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1402029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1402032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1402035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402068 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1402068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1402071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402093 */     // GIR_Coverage, 23076,
     /* 1402093 */     GIR_EraseRootFromParent_Done,
     /* 1402094 */   // Label 19888: @1402094
     /* 1402094 */   GIM_Try, /*On fail goto*//*Label 19889*/ GIMT_Encode4(1402178), // Rule ID 23077 //
     /* 1402099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1402102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1402107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1402110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1402113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1402116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1402119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402152 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1402152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1402155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402177 */     // GIR_Coverage, 23077,
     /* 1402177 */     GIR_EraseRootFromParent_Done,
     /* 1402178 */   // Label 19889: @1402178
     /* 1402178 */   GIM_Reject,
     /* 1402179 */ // Label 13831: @1402179
     /* 1402179 */ GIM_Try, /*On fail goto*//*Label 19890*/ GIMT_Encode4(2015980),
     /* 1402184 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 1402187 */   GIM_Try, /*On fail goto*//*Label 19891*/ GIMT_Encode4(1402273), // Rule ID 7370 //
     /* 1402192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1402203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1402206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1402209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402238 */     // MIs[0] policy
     /* 1402238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402248 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1402251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402272 */     // GIR_Coverage, 7370,
     /* 1402272 */     GIR_EraseRootFromParent_Done,
     /* 1402273 */   // Label 19891: @1402273
     /* 1402273 */   GIM_Try, /*On fail goto*//*Label 19892*/ GIMT_Encode4(1402359), // Rule ID 7371 //
     /* 1402278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1402289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1402292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1402295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402324 */     // MIs[0] policy
     /* 1402324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1402337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402358 */     // GIR_Coverage, 7371,
     /* 1402358 */     GIR_EraseRootFromParent_Done,
     /* 1402359 */   // Label 19892: @1402359
     /* 1402359 */   GIM_Try, /*On fail goto*//*Label 19893*/ GIMT_Encode4(1402445), // Rule ID 7374 //
     /* 1402364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1402375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1402378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1402381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402410 */     // MIs[0] policy
     /* 1402410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402420 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402444 */     // GIR_Coverage, 7374,
     /* 1402444 */     GIR_EraseRootFromParent_Done,
     /* 1402445 */   // Label 19893: @1402445
     /* 1402445 */   GIM_Try, /*On fail goto*//*Label 19894*/ GIMT_Encode4(1402531), // Rule ID 7375 //
     /* 1402450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1402461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1402464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1402467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402496 */     // MIs[0] policy
     /* 1402496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402506 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402530 */     // GIR_Coverage, 7375,
     /* 1402530 */     GIR_EraseRootFromParent_Done,
     /* 1402531 */   // Label 19894: @1402531
     /* 1402531 */   GIM_Try, /*On fail goto*//*Label 19895*/ GIMT_Encode4(1402617), // Rule ID 7378 //
     /* 1402536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1402547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1402550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1402553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402582 */     // MIs[0] policy
     /* 1402582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402592 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402616 */     // GIR_Coverage, 7378,
     /* 1402616 */     GIR_EraseRootFromParent_Done,
     /* 1402617 */   // Label 19895: @1402617
     /* 1402617 */   GIM_Try, /*On fail goto*//*Label 19896*/ GIMT_Encode4(1402703), // Rule ID 7379 //
     /* 1402622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1402633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1402636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1402639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402668 */     // MIs[0] policy
     /* 1402668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402678 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402702 */     // GIR_Coverage, 7379,
     /* 1402702 */     GIR_EraseRootFromParent_Done,
     /* 1402703 */   // Label 19896: @1402703
     /* 1402703 */   GIM_Try, /*On fail goto*//*Label 19897*/ GIMT_Encode4(1402789), // Rule ID 7382 //
     /* 1402708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1402719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1402722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1402725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402754 */     // MIs[0] policy
     /* 1402754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402764 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402788 */     // GIR_Coverage, 7382,
     /* 1402788 */     GIR_EraseRootFromParent_Done,
     /* 1402789 */   // Label 19897: @1402789
     /* 1402789 */   GIM_Try, /*On fail goto*//*Label 19898*/ GIMT_Encode4(1402875), // Rule ID 7383 //
     /* 1402794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1402805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1402808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1402811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402840 */     // MIs[0] policy
     /* 1402840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402850 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402874 */     // GIR_Coverage, 7383,
     /* 1402874 */     GIR_EraseRootFromParent_Done,
     /* 1402875 */   // Label 19898: @1402875
     /* 1402875 */   GIM_Try, /*On fail goto*//*Label 19899*/ GIMT_Encode4(1402961), // Rule ID 7386 //
     /* 1402880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1402891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1402894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1402897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402926 */     // MIs[0] policy
     /* 1402926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402936 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402960 */     // GIR_Coverage, 7386,
     /* 1402960 */     GIR_EraseRootFromParent_Done,
     /* 1402961 */   // Label 19899: @1402961
     /* 1402961 */   GIM_Try, /*On fail goto*//*Label 19900*/ GIMT_Encode4(1403047), // Rule ID 7387 //
     /* 1402966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1402977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1402980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1402983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403012 */     // MIs[0] policy
     /* 1403012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403022 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1403025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403046 */     // GIR_Coverage, 7387,
     /* 1403046 */     GIR_EraseRootFromParent_Done,
     /* 1403047 */   // Label 19900: @1403047
     /* 1403047 */   GIM_Try, /*On fail goto*//*Label 19901*/ GIMT_Encode4(1403133), // Rule ID 7390 //
     /* 1403052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1403063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1403066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1403069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403098 */     // MIs[0] policy
     /* 1403098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1403111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403132 */     // GIR_Coverage, 7390,
     /* 1403132 */     GIR_EraseRootFromParent_Done,
     /* 1403133 */   // Label 19901: @1403133
     /* 1403133 */   GIM_Try, /*On fail goto*//*Label 19902*/ GIMT_Encode4(1403219), // Rule ID 7391 //
     /* 1403138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1403149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1403152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1403155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403184 */     // MIs[0] policy
     /* 1403184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403194 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1403197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403218 */     // GIR_Coverage, 7391,
     /* 1403218 */     GIR_EraseRootFromParent_Done,
     /* 1403219 */   // Label 19902: @1403219
     /* 1403219 */   GIM_Try, /*On fail goto*//*Label 19903*/ GIMT_Encode4(1403305), // Rule ID 7394 //
     /* 1403224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1403235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1403238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1403241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1403247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403270 */     // MIs[0] policy
     /* 1403270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403280 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403304 */     // GIR_Coverage, 7394,
     /* 1403304 */     GIR_EraseRootFromParent_Done,
     /* 1403305 */   // Label 19903: @1403305
     /* 1403305 */   GIM_Try, /*On fail goto*//*Label 19904*/ GIMT_Encode4(1403391), // Rule ID 7395 //
     /* 1403310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1403321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1403324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1403327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1403333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403356 */     // MIs[0] policy
     /* 1403356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403366 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403390 */     // GIR_Coverage, 7395,
     /* 1403390 */     GIR_EraseRootFromParent_Done,
     /* 1403391 */   // Label 19904: @1403391
     /* 1403391 */   GIM_Try, /*On fail goto*//*Label 19905*/ GIMT_Encode4(1403477), // Rule ID 7398 //
     /* 1403396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1403413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1403419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403442 */     // MIs[0] policy
     /* 1403442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403476 */     // GIR_Coverage, 7398,
     /* 1403476 */     GIR_EraseRootFromParent_Done,
     /* 1403477 */   // Label 19905: @1403477
     /* 1403477 */   GIM_Try, /*On fail goto*//*Label 19906*/ GIMT_Encode4(1403563), // Rule ID 7399 //
     /* 1403482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1403499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1403505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403528 */     // MIs[0] policy
     /* 1403528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403538 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403562 */     // GIR_Coverage, 7399,
     /* 1403562 */     GIR_EraseRootFromParent_Done,
     /* 1403563 */   // Label 19906: @1403563
     /* 1403563 */   GIM_Try, /*On fail goto*//*Label 19907*/ GIMT_Encode4(1403649), // Rule ID 7402 //
     /* 1403568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1403585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1403591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403614 */     // MIs[0] policy
     /* 1403614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403648 */     // GIR_Coverage, 7402,
     /* 1403648 */     GIR_EraseRootFromParent_Done,
     /* 1403649 */   // Label 19907: @1403649
     /* 1403649 */   GIM_Try, /*On fail goto*//*Label 19908*/ GIMT_Encode4(1403735), // Rule ID 7403 //
     /* 1403654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1403671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1403677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403700 */     // MIs[0] policy
     /* 1403700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403734 */     // GIR_Coverage, 7403,
     /* 1403734 */     GIR_EraseRootFromParent_Done,
     /* 1403735 */   // Label 19908: @1403735
     /* 1403735 */   GIM_Try, /*On fail goto*//*Label 19909*/ GIMT_Encode4(1403821), // Rule ID 7406 //
     /* 1403740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1403743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1403751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1403754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1403757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403786 */     // MIs[0] policy
     /* 1403786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403796 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403820 */     // GIR_Coverage, 7406,
     /* 1403820 */     GIR_EraseRootFromParent_Done,
     /* 1403821 */   // Label 19909: @1403821
     /* 1403821 */   GIM_Try, /*On fail goto*//*Label 19910*/ GIMT_Encode4(1403907), // Rule ID 7407 //
     /* 1403826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1403829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1403837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1403840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1403843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403872 */     // MIs[0] policy
     /* 1403872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403882 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403906 */     // GIR_Coverage, 7407,
     /* 1403906 */     GIR_EraseRootFromParent_Done,
     /* 1403907 */   // Label 19910: @1403907
     /* 1403907 */   GIM_Try, /*On fail goto*//*Label 19911*/ GIMT_Encode4(1403993), // Rule ID 7410 //
     /* 1403912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1403923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1403926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1403929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1403935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1403942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403958 */     // MIs[0] policy
     /* 1403958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403968 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1403971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403992 */     // GIR_Coverage, 7410,
     /* 1403992 */     GIR_EraseRootFromParent_Done,
     /* 1403993 */   // Label 19911: @1403993
     /* 1403993 */   GIM_Try, /*On fail goto*//*Label 19912*/ GIMT_Encode4(1404079), // Rule ID 7411 //
     /* 1403998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1404009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1404012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1404015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404044 */     // MIs[0] policy
     /* 1404044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404054 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1404075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404078 */     // GIR_Coverage, 7411,
     /* 1404078 */     GIR_EraseRootFromParent_Done,
     /* 1404079 */   // Label 19912: @1404079
     /* 1404079 */   GIM_Try, /*On fail goto*//*Label 19913*/ GIMT_Encode4(1404165), // Rule ID 7414 //
     /* 1404084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1404095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1404098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1404101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404130 */     // MIs[0] policy
     /* 1404130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404140 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1404161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404164 */     // GIR_Coverage, 7414,
     /* 1404164 */     GIR_EraseRootFromParent_Done,
     /* 1404165 */   // Label 19913: @1404165
     /* 1404165 */   GIM_Try, /*On fail goto*//*Label 19914*/ GIMT_Encode4(1404251), // Rule ID 7415 //
     /* 1404170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1404181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1404184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1404187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404216 */     // MIs[0] policy
     /* 1404216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404226 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1404247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404250 */     // GIR_Coverage, 7415,
     /* 1404250 */     GIR_EraseRootFromParent_Done,
     /* 1404251 */   // Label 19914: @1404251
     /* 1404251 */   GIM_Try, /*On fail goto*//*Label 19915*/ GIMT_Encode4(1404337), // Rule ID 7418 //
     /* 1404256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1404267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1404270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1404273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1404279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404302 */     // MIs[0] policy
     /* 1404302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404312 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1404333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404336 */     // GIR_Coverage, 7418,
     /* 1404336 */     GIR_EraseRootFromParent_Done,
     /* 1404337 */   // Label 19915: @1404337
     /* 1404337 */   GIM_Try, /*On fail goto*//*Label 19916*/ GIMT_Encode4(1404423), // Rule ID 7419 //
     /* 1404342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1404353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1404356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1404359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1404365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404388 */     // MIs[0] policy
     /* 1404388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404398 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1404419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404422 */     // GIR_Coverage, 7419,
     /* 1404422 */     GIR_EraseRootFromParent_Done,
     /* 1404423 */   // Label 19916: @1404423
     /* 1404423 */   GIM_Try, /*On fail goto*//*Label 19917*/ GIMT_Encode4(1404509), // Rule ID 7422 //
     /* 1404428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1404439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1404442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1404445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404474 */     // MIs[0] policy
     /* 1404474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404508 */     // GIR_Coverage, 7422,
     /* 1404508 */     GIR_EraseRootFromParent_Done,
     /* 1404509 */   // Label 19917: @1404509
     /* 1404509 */   GIM_Try, /*On fail goto*//*Label 19918*/ GIMT_Encode4(1404595), // Rule ID 7423 //
     /* 1404514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1404525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1404528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1404531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404560 */     // MIs[0] policy
     /* 1404560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404570 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404594 */     // GIR_Coverage, 7423,
     /* 1404594 */     GIR_EraseRootFromParent_Done,
     /* 1404595 */   // Label 19918: @1404595
     /* 1404595 */   GIM_Try, /*On fail goto*//*Label 19919*/ GIMT_Encode4(1404681), // Rule ID 7426 //
     /* 1404600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1404611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1404614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404646 */     // MIs[0] policy
     /* 1404646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404656 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404680 */     // GIR_Coverage, 7426,
     /* 1404680 */     GIR_EraseRootFromParent_Done,
     /* 1404681 */   // Label 19919: @1404681
     /* 1404681 */   GIM_Try, /*On fail goto*//*Label 19920*/ GIMT_Encode4(1404767), // Rule ID 7427 //
     /* 1404686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1404697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1404700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404732 */     // MIs[0] policy
     /* 1404732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404742 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404766 */     // GIR_Coverage, 7427,
     /* 1404766 */     GIR_EraseRootFromParent_Done,
     /* 1404767 */   // Label 19920: @1404767
     /* 1404767 */   GIM_Try, /*On fail goto*//*Label 19921*/ GIMT_Encode4(1404853), // Rule ID 7430 //
     /* 1404772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1404783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1404786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1404789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404818 */     // MIs[0] policy
     /* 1404818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404828 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404852 */     // GIR_Coverage, 7430,
     /* 1404852 */     GIR_EraseRootFromParent_Done,
     /* 1404853 */   // Label 19921: @1404853
     /* 1404853 */   GIM_Try, /*On fail goto*//*Label 19922*/ GIMT_Encode4(1404939), // Rule ID 7431 //
     /* 1404858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1404869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1404872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1404875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404904 */     // MIs[0] policy
     /* 1404904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404914 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404938 */     // GIR_Coverage, 7431,
     /* 1404938 */     GIR_EraseRootFromParent_Done,
     /* 1404939 */   // Label 19922: @1404939
     /* 1404939 */   GIM_Try, /*On fail goto*//*Label 19923*/ GIMT_Encode4(1405025), // Rule ID 7434 //
     /* 1404944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1404955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1404958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1404961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1404967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404990 */     // MIs[0] policy
     /* 1404990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405000 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1405003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405024 */     // GIR_Coverage, 7434,
     /* 1405024 */     GIR_EraseRootFromParent_Done,
     /* 1405025 */   // Label 19923: @1405025
     /* 1405025 */   GIM_Try, /*On fail goto*//*Label 19924*/ GIMT_Encode4(1405111), // Rule ID 7435 //
     /* 1405030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1405033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1405041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1405044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1405047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405076 */     // MIs[0] policy
     /* 1405076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1405089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405110 */     // GIR_Coverage, 7435,
     /* 1405110 */     GIR_EraseRootFromParent_Done,
     /* 1405111 */   // Label 19924: @1405111
     /* 1405111 */   GIM_Try, /*On fail goto*//*Label 19925*/ GIMT_Encode4(1405197), // Rule ID 7438 //
     /* 1405116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1405119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1405127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1405130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1405133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405162 */     // MIs[0] policy
     /* 1405162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405172 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1405175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405196 */     // GIR_Coverage, 7438,
     /* 1405196 */     GIR_EraseRootFromParent_Done,
     /* 1405197 */   // Label 19925: @1405197
     /* 1405197 */   GIM_Try, /*On fail goto*//*Label 19926*/ GIMT_Encode4(1405283), // Rule ID 7439 //
     /* 1405202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1405205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1405213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1405216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1405219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405248 */     // MIs[0] policy
     /* 1405248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405258 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1405261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405282 */     // GIR_Coverage, 7439,
     /* 1405282 */     GIR_EraseRootFromParent_Done,
     /* 1405283 */   // Label 19926: @1405283
     /* 1405283 */   GIM_Try, /*On fail goto*//*Label 19927*/ GIMT_Encode4(1405369), // Rule ID 7442 //
     /* 1405288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1405291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1405299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1405302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1405305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1405311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405334 */     // MIs[0] policy
     /* 1405334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405344 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1405347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405368 */     // GIR_Coverage, 7442,
     /* 1405368 */     GIR_EraseRootFromParent_Done,
     /* 1405369 */   // Label 19927: @1405369
     /* 1405369 */   GIM_Try, /*On fail goto*//*Label 19928*/ GIMT_Encode4(1405455), // Rule ID 7443 //
     /* 1405374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1405377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1405385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1405388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1405391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1405397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405420 */     // MIs[0] policy
     /* 1405420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405430 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1405433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405454 */     // GIR_Coverage, 7443,
     /* 1405454 */     GIR_EraseRootFromParent_Done,
     /* 1405455 */   // Label 19928: @1405455
     /* 1405455 */   GIM_Try, /*On fail goto*//*Label 19929*/ GIMT_Encode4(1405541), // Rule ID 7446 //
     /* 1405460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1405463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1405477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1405483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405506 */     // MIs[0] policy
     /* 1405506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1405519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405540 */     // GIR_Coverage, 7446,
     /* 1405540 */     GIR_EraseRootFromParent_Done,
     /* 1405541 */   // Label 19929: @1405541
     /* 1405541 */   GIM_Try, /*On fail goto*//*Label 19930*/ GIMT_Encode4(1405627), // Rule ID 7447 //
     /* 1405546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1405549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1405563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1405569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405592 */     // MIs[0] policy
     /* 1405592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405602 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1405605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405626 */     // GIR_Coverage, 7447,
     /* 1405626 */     GIR_EraseRootFromParent_Done,
     /* 1405627 */   // Label 19930: @1405627
     /* 1405627 */   GIM_Try, /*On fail goto*//*Label 19931*/ GIMT_Encode4(1405713), // Rule ID 7450 //
     /* 1405632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1405635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1405649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405678 */     // MIs[0] policy
     /* 1405678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405688 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1405691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405712 */     // GIR_Coverage, 7450,
     /* 1405712 */     GIR_EraseRootFromParent_Done,
     /* 1405713 */   // Label 19931: @1405713
     /* 1405713 */   GIM_Try, /*On fail goto*//*Label 19932*/ GIMT_Encode4(1405799), // Rule ID 7451 //
     /* 1405718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1405721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1405735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405764 */     // MIs[0] policy
     /* 1405764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405774 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1405777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405798 */     // GIR_Coverage, 7451,
     /* 1405798 */     GIR_EraseRootFromParent_Done,
     /* 1405799 */   // Label 19932: @1405799
     /* 1405799 */   GIM_Try, /*On fail goto*//*Label 19933*/ GIMT_Encode4(1405885), // Rule ID 7454 //
     /* 1405804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1405807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1405821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405850 */     // MIs[0] policy
     /* 1405850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405860 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1405863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405884 */     // GIR_Coverage, 7454,
     /* 1405884 */     GIR_EraseRootFromParent_Done,
     /* 1405885 */   // Label 19933: @1405885
     /* 1405885 */   GIM_Try, /*On fail goto*//*Label 19934*/ GIMT_Encode4(1405971), // Rule ID 7455 //
     /* 1405890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1405893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1405907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405936 */     // MIs[0] policy
     /* 1405936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1405949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405970 */     // GIR_Coverage, 7455,
     /* 1405970 */     GIR_EraseRootFromParent_Done,
     /* 1405971 */   // Label 19934: @1405971
     /* 1405971 */   GIM_Try, /*On fail goto*//*Label 19935*/ GIMT_Encode4(1406059), // Rule ID 2760 //
     /* 1405976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1405979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1405987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1405990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1405993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406015 */     // MIs[0] Operand 5
     /* 1406015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406026 */     // MIs[0] policy
     /* 1406026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406036 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1406039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406058 */     // GIR_Coverage, 2760,
     /* 1406058 */     GIR_EraseRootFromParent_Done,
     /* 1406059 */   // Label 19935: @1406059
     /* 1406059 */   GIM_Try, /*On fail goto*//*Label 19936*/ GIMT_Encode4(1406147), // Rule ID 2761 //
     /* 1406064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1406075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1406078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1406081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406103 */     // MIs[0] Operand 5
     /* 1406103 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406114 */     // MIs[0] policy
     /* 1406114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406124 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1406127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406146 */     // GIR_Coverage, 2761,
     /* 1406146 */     GIR_EraseRootFromParent_Done,
     /* 1406147 */   // Label 19936: @1406147
     /* 1406147 */   GIM_Try, /*On fail goto*//*Label 19937*/ GIMT_Encode4(1406235), // Rule ID 20652 //
     /* 1406152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1406163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1406166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1406169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406191 */     // MIs[0] Operand 5
     /* 1406191 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406202 */     // MIs[0] policy
     /* 1406202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406212 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406234 */     // GIR_Coverage, 20652,
     /* 1406234 */     GIR_EraseRootFromParent_Done,
     /* 1406235 */   // Label 19937: @1406235
     /* 1406235 */   GIM_Try, /*On fail goto*//*Label 19938*/ GIMT_Encode4(1406323), // Rule ID 20653 //
     /* 1406240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1406251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1406254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1406257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406279 */     // MIs[0] Operand 5
     /* 1406279 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406290 */     // MIs[0] policy
     /* 1406290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406300 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406322 */     // GIR_Coverage, 20653,
     /* 1406322 */     GIR_EraseRootFromParent_Done,
     /* 1406323 */   // Label 19938: @1406323
     /* 1406323 */   GIM_Try, /*On fail goto*//*Label 19939*/ GIMT_Encode4(1406411), // Rule ID 20656 //
     /* 1406328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1406331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1406339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1406342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1406345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406367 */     // MIs[0] Operand 5
     /* 1406367 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406378 */     // MIs[0] policy
     /* 1406378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406388 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406410 */     // GIR_Coverage, 20656,
     /* 1406410 */     GIR_EraseRootFromParent_Done,
     /* 1406411 */   // Label 19939: @1406411
     /* 1406411 */   GIM_Try, /*On fail goto*//*Label 19940*/ GIMT_Encode4(1406499), // Rule ID 20657 //
     /* 1406416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1406419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1406427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1406430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1406433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406455 */     // MIs[0] Operand 5
     /* 1406455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406466 */     // MIs[0] policy
     /* 1406466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406476 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406498 */     // GIR_Coverage, 20657,
     /* 1406498 */     GIR_EraseRootFromParent_Done,
     /* 1406499 */   // Label 19940: @1406499
     /* 1406499 */   GIM_Try, /*On fail goto*//*Label 19941*/ GIMT_Encode4(1406587), // Rule ID 20660 //
     /* 1406504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1406524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406543 */     // MIs[0] Operand 5
     /* 1406543 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406554 */     // MIs[0] policy
     /* 1406554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406586 */     // GIR_Coverage, 20660,
     /* 1406586 */     GIR_EraseRootFromParent_Done,
     /* 1406587 */   // Label 19941: @1406587
     /* 1406587 */   GIM_Try, /*On fail goto*//*Label 19942*/ GIMT_Encode4(1406675), // Rule ID 20661 //
     /* 1406592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1406612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406631 */     // MIs[0] Operand 5
     /* 1406631 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406642 */     // MIs[0] policy
     /* 1406642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406674 */     // GIR_Coverage, 20661,
     /* 1406674 */     GIR_EraseRootFromParent_Done,
     /* 1406675 */   // Label 19942: @1406675
     /* 1406675 */   GIM_Try, /*On fail goto*//*Label 19943*/ GIMT_Encode4(1406763), // Rule ID 20664 //
     /* 1406680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1406683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406719 */     // MIs[0] Operand 5
     /* 1406719 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406730 */     // MIs[0] policy
     /* 1406730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406762 */     // GIR_Coverage, 20664,
     /* 1406762 */     GIR_EraseRootFromParent_Done,
     /* 1406763 */   // Label 19943: @1406763
     /* 1406763 */   GIM_Try, /*On fail goto*//*Label 19944*/ GIMT_Encode4(1406851), // Rule ID 20665 //
     /* 1406768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1406771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406807 */     // MIs[0] Operand 5
     /* 1406807 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406818 */     // MIs[0] policy
     /* 1406818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406828 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406850 */     // GIR_Coverage, 20665,
     /* 1406850 */     GIR_EraseRootFromParent_Done,
     /* 1406851 */   // Label 19944: @1406851
     /* 1406851 */   GIM_Try, /*On fail goto*//*Label 19945*/ GIMT_Encode4(1406939), // Rule ID 20668 //
     /* 1406856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1406859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1406873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406895 */     // MIs[0] Operand 5
     /* 1406895 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406906 */     // MIs[0] policy
     /* 1406906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1406935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406938 */     // GIR_Coverage, 20668,
     /* 1406938 */     GIR_EraseRootFromParent_Done,
     /* 1406939 */   // Label 19945: @1406939
     /* 1406939 */   GIM_Try, /*On fail goto*//*Label 19946*/ GIMT_Encode4(1407027), // Rule ID 20669 //
     /* 1406944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1406947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1406961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406983 */     // MIs[0] Operand 5
     /* 1406983 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406994 */     // MIs[0] policy
     /* 1406994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1407007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407026 */     // GIR_Coverage, 20669,
     /* 1407026 */     GIR_EraseRootFromParent_Done,
     /* 1407027 */   // Label 19946: @1407027
     /* 1407027 */   GIM_Try, /*On fail goto*//*Label 19947*/ GIMT_Encode4(1407115), // Rule ID 20672 //
     /* 1407032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1407035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1407043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1407046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1407049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407071 */     // MIs[0] Operand 5
     /* 1407071 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407082 */     // MIs[0] policy
     /* 1407082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407092 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407114 */     // GIR_Coverage, 20672,
     /* 1407114 */     GIR_EraseRootFromParent_Done,
     /* 1407115 */   // Label 19947: @1407115
     /* 1407115 */   GIM_Try, /*On fail goto*//*Label 19948*/ GIMT_Encode4(1407203), // Rule ID 20673 //
     /* 1407120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1407131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1407134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1407137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407159 */     // MIs[0] Operand 5
     /* 1407159 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407170 */     // MIs[0] policy
     /* 1407170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407202 */     // GIR_Coverage, 20673,
     /* 1407202 */     GIR_EraseRootFromParent_Done,
     /* 1407203 */   // Label 19948: @1407203
     /* 1407203 */   GIM_Try, /*On fail goto*//*Label 19949*/ GIMT_Encode4(1407291), // Rule ID 20676 //
     /* 1407208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1407211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1407219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1407222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1407225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407247 */     // MIs[0] Operand 5
     /* 1407247 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407258 */     // MIs[0] policy
     /* 1407258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407268 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407290 */     // GIR_Coverage, 20676,
     /* 1407290 */     GIR_EraseRootFromParent_Done,
     /* 1407291 */   // Label 19949: @1407291
     /* 1407291 */   GIM_Try, /*On fail goto*//*Label 19950*/ GIMT_Encode4(1407379), // Rule ID 20677 //
     /* 1407296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1407307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1407310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1407313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407335 */     // MIs[0] Operand 5
     /* 1407335 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407346 */     // MIs[0] policy
     /* 1407346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407356 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407378 */     // GIR_Coverage, 20677,
     /* 1407378 */     GIR_EraseRootFromParent_Done,
     /* 1407379 */   // Label 19950: @1407379
     /* 1407379 */   GIM_Try, /*On fail goto*//*Label 19951*/ GIMT_Encode4(1407467), // Rule ID 20680 //
     /* 1407384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1407387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1407395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1407398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1407401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1407404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407423 */     // MIs[0] Operand 5
     /* 1407423 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407434 */     // MIs[0] policy
     /* 1407434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407444 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1407447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407466 */     // GIR_Coverage, 20680,
     /* 1407466 */     GIR_EraseRootFromParent_Done,
     /* 1407467 */   // Label 19951: @1407467
     /* 1407467 */   GIM_Try, /*On fail goto*//*Label 19952*/ GIMT_Encode4(1407555), // Rule ID 20681 //
     /* 1407472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1407483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1407486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1407489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1407492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407511 */     // MIs[0] Operand 5
     /* 1407511 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407522 */     // MIs[0] policy
     /* 1407522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407532 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1407535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407554 */     // GIR_Coverage, 20681,
     /* 1407554 */     GIR_EraseRootFromParent_Done,
     /* 1407555 */   // Label 19952: @1407555
     /* 1407555 */   GIM_Try, /*On fail goto*//*Label 19953*/ GIMT_Encode4(1407643), // Rule ID 20684 //
     /* 1407560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1407571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1407574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407599 */     // MIs[0] Operand 5
     /* 1407599 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407610 */     // MIs[0] policy
     /* 1407610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407620 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407642 */     // GIR_Coverage, 20684,
     /* 1407642 */     GIR_EraseRootFromParent_Done,
     /* 1407643 */   // Label 19953: @1407643
     /* 1407643 */   GIM_Try, /*On fail goto*//*Label 19954*/ GIMT_Encode4(1407731), // Rule ID 20685 //
     /* 1407648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1407659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1407662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407687 */     // MIs[0] Operand 5
     /* 1407687 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407698 */     // MIs[0] policy
     /* 1407698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407730 */     // GIR_Coverage, 20685,
     /* 1407730 */     GIR_EraseRootFromParent_Done,
     /* 1407731 */   // Label 19954: @1407731
     /* 1407731 */   GIM_Try, /*On fail goto*//*Label 19955*/ GIMT_Encode4(1407819), // Rule ID 20688 //
     /* 1407736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1407747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1407750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407775 */     // MIs[0] Operand 5
     /* 1407775 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407786 */     // MIs[0] policy
     /* 1407786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407796 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407818 */     // GIR_Coverage, 20688,
     /* 1407818 */     GIR_EraseRootFromParent_Done,
     /* 1407819 */   // Label 19955: @1407819
     /* 1407819 */   GIM_Try, /*On fail goto*//*Label 19956*/ GIMT_Encode4(1407907), // Rule ID 20689 //
     /* 1407824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1407835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1407838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407863 */     // MIs[0] Operand 5
     /* 1407863 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407874 */     // MIs[0] policy
     /* 1407874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407906 */     // GIR_Coverage, 20689,
     /* 1407906 */     GIR_EraseRootFromParent_Done,
     /* 1407907 */   // Label 19956: @1407907
     /* 1407907 */   GIM_Try, /*On fail goto*//*Label 19957*/ GIMT_Encode4(1407995), // Rule ID 20692 //
     /* 1407912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1407923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1407926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1407929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407951 */     // MIs[0] Operand 5
     /* 1407951 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407962 */     // MIs[0] policy
     /* 1407962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1407975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407994 */     // GIR_Coverage, 20692,
     /* 1407994 */     GIR_EraseRootFromParent_Done,
     /* 1407995 */   // Label 19957: @1407995
     /* 1407995 */   GIM_Try, /*On fail goto*//*Label 19958*/ GIMT_Encode4(1408083), // Rule ID 20693 //
     /* 1408000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1408003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1408011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1408014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1408017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1408020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408039 */     // MIs[0] Operand 5
     /* 1408039 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408050 */     // MIs[0] policy
     /* 1408050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408060 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1408063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408082 */     // GIR_Coverage, 20693,
     /* 1408082 */     GIR_EraseRootFromParent_Done,
     /* 1408083 */   // Label 19958: @1408083
     /* 1408083 */   GIM_Try, /*On fail goto*//*Label 19959*/ GIMT_Encode4(1408171), // Rule ID 20696 //
     /* 1408088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1408091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1408099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1408102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1408105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408127 */     // MIs[0] Operand 5
     /* 1408127 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408138 */     // MIs[0] policy
     /* 1408138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408148 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1408151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408170 */     // GIR_Coverage, 20696,
     /* 1408170 */     GIR_EraseRootFromParent_Done,
     /* 1408171 */   // Label 19959: @1408171
     /* 1408171 */   GIM_Try, /*On fail goto*//*Label 19960*/ GIMT_Encode4(1408259), // Rule ID 20697 //
     /* 1408176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1408179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1408187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1408190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1408193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408215 */     // MIs[0] Operand 5
     /* 1408215 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408226 */     // MIs[0] policy
     /* 1408226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408236 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1408239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408258 */     // GIR_Coverage, 20697,
     /* 1408258 */     GIR_EraseRootFromParent_Done,
     /* 1408259 */   // Label 19960: @1408259
     /* 1408259 */   GIM_Try, /*On fail goto*//*Label 19961*/ GIMT_Encode4(1408347), // Rule ID 20700 //
     /* 1408264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1408267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1408275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1408278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1408281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1408291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408303 */     // MIs[0] Operand 5
     /* 1408303 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408314 */     // MIs[0] policy
     /* 1408314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408324 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1408327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408346 */     // GIR_Coverage, 20700,
     /* 1408346 */     GIR_EraseRootFromParent_Done,
     /* 1408347 */   // Label 19961: @1408347
     /* 1408347 */   GIM_Try, /*On fail goto*//*Label 19962*/ GIMT_Encode4(1408435), // Rule ID 20701 //
     /* 1408352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1408355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1408363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1408366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1408369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1408379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408391 */     // MIs[0] Operand 5
     /* 1408391 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408402 */     // MIs[0] policy
     /* 1408402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408412 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1408415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408434 */     // GIR_Coverage, 20701,
     /* 1408434 */     GIR_EraseRootFromParent_Done,
     /* 1408435 */   // Label 19962: @1408435
     /* 1408435 */   GIM_Try, /*On fail goto*//*Label 19963*/ GIMT_Encode4(1408523), // Rule ID 20704 //
     /* 1408440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1408443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1408451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1408454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1408457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1408460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408479 */     // MIs[0] Operand 5
     /* 1408479 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408490 */     // MIs[0] policy
     /* 1408490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408500 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1408503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408522 */     // GIR_Coverage, 20704,
     /* 1408522 */     GIR_EraseRootFromParent_Done,
     /* 1408523 */   // Label 19963: @1408523
     /* 1408523 */   GIM_Try, /*On fail goto*//*Label 19964*/ GIMT_Encode4(1408611), // Rule ID 20705 //
     /* 1408528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1408531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1408539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1408542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1408545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1408548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408567 */     // MIs[0] Operand 5
     /* 1408567 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408578 */     // MIs[0] policy
     /* 1408578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408588 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1408591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408610 */     // GIR_Coverage, 20705,
     /* 1408610 */     GIR_EraseRootFromParent_Done,
     /* 1408611 */   // Label 19964: @1408611
     /* 1408611 */   GIM_Try, /*On fail goto*//*Label 19965*/ GIMT_Encode4(1408699), // Rule ID 20708 //
     /* 1408616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1408627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1408630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1408633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408655 */     // MIs[0] Operand 5
     /* 1408655 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408666 */     // MIs[0] policy
     /* 1408666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408676 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1408679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408698 */     // GIR_Coverage, 20708,
     /* 1408698 */     GIR_EraseRootFromParent_Done,
     /* 1408699 */   // Label 19965: @1408699
     /* 1408699 */   GIM_Try, /*On fail goto*//*Label 19966*/ GIMT_Encode4(1408787), // Rule ID 20709 //
     /* 1408704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1408715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1408718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1408721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408743 */     // MIs[0] Operand 5
     /* 1408743 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408754 */     // MIs[0] policy
     /* 1408754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408764 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1408767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408786 */     // GIR_Coverage, 20709,
     /* 1408786 */     GIR_EraseRootFromParent_Done,
     /* 1408787 */   // Label 19966: @1408787
     /* 1408787 */   GIM_Try, /*On fail goto*//*Label 19967*/ GIMT_Encode4(1408875), // Rule ID 20712 //
     /* 1408792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1408803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1408806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1408809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408831 */     // MIs[0] Operand 5
     /* 1408831 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408842 */     // MIs[0] policy
     /* 1408842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408874 */     // GIR_Coverage, 20712,
     /* 1408874 */     GIR_EraseRootFromParent_Done,
     /* 1408875 */   // Label 19967: @1408875
     /* 1408875 */   GIM_Try, /*On fail goto*//*Label 19968*/ GIMT_Encode4(1408963), // Rule ID 20713 //
     /* 1408880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1408891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1408894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1408897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408919 */     // MIs[0] Operand 5
     /* 1408919 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408930 */     // MIs[0] policy
     /* 1408930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408940 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408962 */     // GIR_Coverage, 20713,
     /* 1408962 */     GIR_EraseRootFromParent_Done,
     /* 1408963 */   // Label 19968: @1408963
     /* 1408963 */   GIM_Try, /*On fail goto*//*Label 19969*/ GIMT_Encode4(1409051), // Rule ID 20716 //
     /* 1408968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1408971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1408979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1408982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1408985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409007 */     // MIs[0] Operand 5
     /* 1409007 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409018 */     // MIs[0] policy
     /* 1409018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409028 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1409031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409050 */     // GIR_Coverage, 20716,
     /* 1409050 */     GIR_EraseRootFromParent_Done,
     /* 1409051 */   // Label 19969: @1409051
     /* 1409051 */   GIM_Try, /*On fail goto*//*Label 19970*/ GIMT_Encode4(1409139), // Rule ID 20717 //
     /* 1409056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1409059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1409067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1409070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1409073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409095 */     // MIs[0] Operand 5
     /* 1409095 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409106 */     // MIs[0] policy
     /* 1409106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409116 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1409119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409138 */     // GIR_Coverage, 20717,
     /* 1409138 */     GIR_EraseRootFromParent_Done,
     /* 1409139 */   // Label 19970: @1409139
     /* 1409139 */   GIM_Try, /*On fail goto*//*Label 19971*/ GIMT_Encode4(1409227), // Rule ID 20720 //
     /* 1409144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1409155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1409158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1409161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409183 */     // MIs[0] Operand 5
     /* 1409183 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409194 */     // MIs[0] policy
     /* 1409194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409204 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409226 */     // GIR_Coverage, 20720,
     /* 1409226 */     GIR_EraseRootFromParent_Done,
     /* 1409227 */   // Label 19971: @1409227
     /* 1409227 */   GIM_Try, /*On fail goto*//*Label 19972*/ GIMT_Encode4(1409315), // Rule ID 20721 //
     /* 1409232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1409243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1409246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1409249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409271 */     // MIs[0] Operand 5
     /* 1409271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409282 */     // MIs[0] policy
     /* 1409282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409292 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409314 */     // GIR_Coverage, 20721,
     /* 1409314 */     GIR_EraseRootFromParent_Done,
     /* 1409315 */   // Label 19972: @1409315
     /* 1409315 */   GIM_Try, /*On fail goto*//*Label 19973*/ GIMT_Encode4(1409403), // Rule ID 20724 //
     /* 1409320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1409323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1409331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1409334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1409337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1409340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409359 */     // MIs[0] Operand 5
     /* 1409359 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409370 */     // MIs[0] policy
     /* 1409370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409380 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409402 */     // GIR_Coverage, 20724,
     /* 1409402 */     GIR_EraseRootFromParent_Done,
     /* 1409403 */   // Label 19973: @1409403
     /* 1409403 */   GIM_Try, /*On fail goto*//*Label 19974*/ GIMT_Encode4(1409491), // Rule ID 20725 //
     /* 1409408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1409411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1409419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1409422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1409425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1409428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409447 */     // MIs[0] Operand 5
     /* 1409447 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409458 */     // MIs[0] policy
     /* 1409458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409468 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409490 */     // GIR_Coverage, 20725,
     /* 1409490 */     GIR_EraseRootFromParent_Done,
     /* 1409491 */   // Label 19974: @1409491
     /* 1409491 */   GIM_Try, /*On fail goto*//*Label 19975*/ GIMT_Encode4(1409579), // Rule ID 20728 //
     /* 1409496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1409499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1409507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1409510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1409513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409535 */     // MIs[0] Operand 5
     /* 1409535 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409546 */     // MIs[0] policy
     /* 1409546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409556 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409565 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409578 */     // GIR_Coverage, 20728,
     /* 1409578 */     GIR_EraseRootFromParent_Done,
     /* 1409579 */   // Label 19975: @1409579
     /* 1409579 */   GIM_Try, /*On fail goto*//*Label 19976*/ GIMT_Encode4(1409667), // Rule ID 20729 //
     /* 1409584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1409587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1409595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1409598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1409601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409623 */     // MIs[0] Operand 5
     /* 1409623 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409634 */     // MIs[0] policy
     /* 1409634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409666 */     // GIR_Coverage, 20729,
     /* 1409666 */     GIR_EraseRootFromParent_Done,
     /* 1409667 */   // Label 19976: @1409667
     /* 1409667 */   GIM_Try, /*On fail goto*//*Label 19977*/ GIMT_Encode4(1409755), // Rule ID 20732 //
     /* 1409672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1409683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1409686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1409689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409711 */     // MIs[0] Operand 5
     /* 1409711 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409722 */     // MIs[0] policy
     /* 1409722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409754 */     // GIR_Coverage, 20732,
     /* 1409754 */     GIR_EraseRootFromParent_Done,
     /* 1409755 */   // Label 19977: @1409755
     /* 1409755 */   GIM_Try, /*On fail goto*//*Label 19978*/ GIMT_Encode4(1409843), // Rule ID 20733 //
     /* 1409760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1409771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1409774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1409777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409799 */     // MIs[0] Operand 5
     /* 1409799 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409810 */     // MIs[0] policy
     /* 1409810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409820 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409842 */     // GIR_Coverage, 20733,
     /* 1409842 */     GIR_EraseRootFromParent_Done,
     /* 1409843 */   // Label 19978: @1409843
     /* 1409843 */   GIM_Try, /*On fail goto*//*Label 19979*/ GIMT_Encode4(1409931), // Rule ID 20736 //
     /* 1409848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1409859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1409862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1409865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1409868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409887 */     // MIs[0] Operand 5
     /* 1409887 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409898 */     // MIs[0] policy
     /* 1409898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409908 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1409911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409930 */     // GIR_Coverage, 20736,
     /* 1409930 */     GIR_EraseRootFromParent_Done,
     /* 1409931 */   // Label 19979: @1409931
     /* 1409931 */   GIM_Try, /*On fail goto*//*Label 19980*/ GIMT_Encode4(1410019), // Rule ID 20737 //
     /* 1409936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1409947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1409950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1409953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1409956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409975 */     // MIs[0] Operand 5
     /* 1409975 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409986 */     // MIs[0] policy
     /* 1409986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1409999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410018 */     // GIR_Coverage, 20737,
     /* 1410018 */     GIR_EraseRootFromParent_Done,
     /* 1410019 */   // Label 19980: @1410019
     /* 1410019 */   GIM_Try, /*On fail goto*//*Label 19981*/ GIMT_Encode4(1410107), // Rule ID 20740 //
     /* 1410024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1410035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1410038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1410041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1410044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410063 */     // MIs[0] Operand 5
     /* 1410063 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410074 */     // MIs[0] policy
     /* 1410074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410084 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410106 */     // GIR_Coverage, 20740,
     /* 1410106 */     GIR_EraseRootFromParent_Done,
     /* 1410107 */   // Label 19981: @1410107
     /* 1410107 */   GIM_Try, /*On fail goto*//*Label 19982*/ GIMT_Encode4(1410195), // Rule ID 20741 //
     /* 1410112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1410123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1410126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1410129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1410132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410151 */     // MIs[0] Operand 5
     /* 1410151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410162 */     // MIs[0] policy
     /* 1410162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410172 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410194 */     // GIR_Coverage, 20741,
     /* 1410194 */     GIR_EraseRootFromParent_Done,
     /* 1410195 */   // Label 19982: @1410195
     /* 1410195 */   GIM_Try, /*On fail goto*//*Label 19983*/ GIMT_Encode4(1410283), // Rule ID 20744 //
     /* 1410200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1410203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1410211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1410214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1410217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410239 */     // MIs[0] Operand 5
     /* 1410239 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410250 */     // MIs[0] policy
     /* 1410250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1410263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410282 */     // GIR_Coverage, 20744,
     /* 1410282 */     GIR_EraseRootFromParent_Done,
     /* 1410283 */   // Label 19983: @1410283
     /* 1410283 */   GIM_Try, /*On fail goto*//*Label 19984*/ GIMT_Encode4(1410371), // Rule ID 20745 //
     /* 1410288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1410291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1410299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1410302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1410305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410327 */     // MIs[0] Operand 5
     /* 1410327 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410338 */     // MIs[0] policy
     /* 1410338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1410351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410370 */     // GIR_Coverage, 20745,
     /* 1410370 */     GIR_EraseRootFromParent_Done,
     /* 1410371 */   // Label 19984: @1410371
     /* 1410371 */   GIM_Try, /*On fail goto*//*Label 19985*/ GIMT_Encode4(1410459), // Rule ID 20748 //
     /* 1410376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1410379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1410387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1410390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1410393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410415 */     // MIs[0] Operand 5
     /* 1410415 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410426 */     // MIs[0] policy
     /* 1410426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410436 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410458 */     // GIR_Coverage, 20748,
     /* 1410458 */     GIR_EraseRootFromParent_Done,
     /* 1410459 */   // Label 19985: @1410459
     /* 1410459 */   GIM_Try, /*On fail goto*//*Label 19986*/ GIMT_Encode4(1410547), // Rule ID 20749 //
     /* 1410464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1410467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1410475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1410478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1410481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410503 */     // MIs[0] Operand 5
     /* 1410503 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410514 */     // MIs[0] policy
     /* 1410514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410546 */     // GIR_Coverage, 20749,
     /* 1410546 */     GIR_EraseRootFromParent_Done,
     /* 1410547 */   // Label 19986: @1410547
     /* 1410547 */   GIM_Try, /*On fail goto*//*Label 19987*/ GIMT_Encode4(1410635), // Rule ID 20752 //
     /* 1410552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1410555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1410563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1410566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1410569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410591 */     // MIs[0] Operand 5
     /* 1410591 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410602 */     // MIs[0] policy
     /* 1410602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410612 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410634 */     // GIR_Coverage, 20752,
     /* 1410634 */     GIR_EraseRootFromParent_Done,
     /* 1410635 */   // Label 19987: @1410635
     /* 1410635 */   GIM_Try, /*On fail goto*//*Label 19988*/ GIMT_Encode4(1410723), // Rule ID 20753 //
     /* 1410640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1410643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1410651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1410654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1410657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410679 */     // MIs[0] Operand 5
     /* 1410679 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410690 */     // MIs[0] policy
     /* 1410690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410700 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410722 */     // GIR_Coverage, 20753,
     /* 1410722 */     GIR_EraseRootFromParent_Done,
     /* 1410723 */   // Label 19988: @1410723
     /* 1410723 */   GIM_Try, /*On fail goto*//*Label 19989*/ GIMT_Encode4(1410811), // Rule ID 20756 //
     /* 1410728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1410731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1410739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1410742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1410745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410767 */     // MIs[0] Operand 5
     /* 1410767 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410778 */     // MIs[0] policy
     /* 1410778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1410791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410810 */     // GIR_Coverage, 20756,
     /* 1410810 */     GIR_EraseRootFromParent_Done,
     /* 1410811 */   // Label 19989: @1410811
     /* 1410811 */   GIM_Try, /*On fail goto*//*Label 19990*/ GIMT_Encode4(1410899), // Rule ID 20757 //
     /* 1410816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1410819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1410827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1410830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1410833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410855 */     // MIs[0] Operand 5
     /* 1410855 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410866 */     // MIs[0] policy
     /* 1410866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1410879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410885 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410898 */     // GIR_Coverage, 20757,
     /* 1410898 */     GIR_EraseRootFromParent_Done,
     /* 1410899 */   // Label 19990: @1410899
     /* 1410899 */   GIM_Try, /*On fail goto*//*Label 19991*/ GIMT_Encode4(1410987), // Rule ID 20760 //
     /* 1410904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1410907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1410915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1410918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1410921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410943 */     // MIs[0] Operand 5
     /* 1410943 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410954 */     // MIs[0] policy
     /* 1410954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410964 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410986 */     // GIR_Coverage, 20760,
     /* 1410986 */     GIR_EraseRootFromParent_Done,
     /* 1410987 */   // Label 19991: @1410987
     /* 1410987 */   GIM_Try, /*On fail goto*//*Label 19992*/ GIMT_Encode4(1411075), // Rule ID 20761 //
     /* 1410992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1410995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1411000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1411003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1411006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1411009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411031 */     // MIs[0] Operand 5
     /* 1411031 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411042 */     // MIs[0] policy
     /* 1411042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1411055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411074 */     // GIR_Coverage, 20761,
     /* 1411074 */     GIR_EraseRootFromParent_Done,
     /* 1411075 */   // Label 19992: @1411075
     /* 1411075 */   GIM_Try, /*On fail goto*//*Label 19993*/ GIMT_Encode4(1411163), // Rule ID 20764 //
     /* 1411080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1411083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1411088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1411091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1411094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1411097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411119 */     // MIs[0] Operand 5
     /* 1411119 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411130 */     // MIs[0] policy
     /* 1411130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411140 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1411143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411162 */     // GIR_Coverage, 20764,
     /* 1411162 */     GIR_EraseRootFromParent_Done,
     /* 1411163 */   // Label 19993: @1411163
     /* 1411163 */   GIM_Try, /*On fail goto*//*Label 19994*/ GIMT_Encode4(1411251), // Rule ID 20765 //
     /* 1411168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1411171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1411176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1411179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1411182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1411185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411207 */     // MIs[0] Operand 5
     /* 1411207 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411218 */     // MIs[0] policy
     /* 1411218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411228 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1411231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411250 */     // GIR_Coverage, 20765,
     /* 1411250 */     GIR_EraseRootFromParent_Done,
     /* 1411251 */   // Label 19994: @1411251
     /* 1411251 */   GIM_Try, /*On fail goto*//*Label 19995*/ GIMT_Encode4(1411339), // Rule ID 21124 //
     /* 1411256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1411267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1411270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1411273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411295 */     // MIs[0] Operand 5
     /* 1411295 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411306 */     // MIs[0] policy
     /* 1411306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411316 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1411319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411338 */     // GIR_Coverage, 21124,
     /* 1411338 */     GIR_EraseRootFromParent_Done,
     /* 1411339 */   // Label 19995: @1411339
     /* 1411339 */   GIM_Try, /*On fail goto*//*Label 19996*/ GIMT_Encode4(1411427), // Rule ID 21125 //
     /* 1411344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1411355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1411358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1411361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411383 */     // MIs[0] Operand 5
     /* 1411383 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411394 */     // MIs[0] policy
     /* 1411394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1411407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411426 */     // GIR_Coverage, 21125,
     /* 1411426 */     GIR_EraseRootFromParent_Done,
     /* 1411427 */   // Label 19996: @1411427
     /* 1411427 */   GIM_Try, /*On fail goto*//*Label 19997*/ GIMT_Encode4(1411515), // Rule ID 21128 //
     /* 1411432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1411443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1411446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1411449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411471 */     // MIs[0] Operand 5
     /* 1411471 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411482 */     // MIs[0] policy
     /* 1411482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1411495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411514 */     // GIR_Coverage, 21128,
     /* 1411514 */     GIR_EraseRootFromParent_Done,
     /* 1411515 */   // Label 19997: @1411515
     /* 1411515 */   GIM_Try, /*On fail goto*//*Label 19998*/ GIMT_Encode4(1411603), // Rule ID 21129 //
     /* 1411520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1411531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1411534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1411537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411559 */     // MIs[0] Operand 5
     /* 1411559 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411570 */     // MIs[0] policy
     /* 1411570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411580 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1411583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411602 */     // GIR_Coverage, 21129,
     /* 1411602 */     GIR_EraseRootFromParent_Done,
     /* 1411603 */   // Label 19998: @1411603
     /* 1411603 */   GIM_Try, /*On fail goto*//*Label 19999*/ GIMT_Encode4(1411691), // Rule ID 21132 //
     /* 1411608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1411619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1411622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1411625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411647 */     // MIs[0] Operand 5
     /* 1411647 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411658 */     // MIs[0] policy
     /* 1411658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1411671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411690 */     // GIR_Coverage, 21132,
     /* 1411690 */     GIR_EraseRootFromParent_Done,
     /* 1411691 */   // Label 19999: @1411691
     /* 1411691 */   GIM_Try, /*On fail goto*//*Label 20000*/ GIMT_Encode4(1411779), // Rule ID 21133 //
     /* 1411696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1411707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1411710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1411713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411735 */     // MIs[0] Operand 5
     /* 1411735 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411746 */     // MIs[0] policy
     /* 1411746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1411759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411778 */     // GIR_Coverage, 21133,
     /* 1411778 */     GIR_EraseRootFromParent_Done,
     /* 1411779 */   // Label 20000: @1411779
     /* 1411779 */   GIM_Try, /*On fail goto*//*Label 20001*/ GIMT_Encode4(1411867), // Rule ID 21136 //
     /* 1411784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1411795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1411798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1411801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411823 */     // MIs[0] Operand 5
     /* 1411823 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411834 */     // MIs[0] policy
     /* 1411834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411844 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1411847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411866 */     // GIR_Coverage, 21136,
     /* 1411866 */     GIR_EraseRootFromParent_Done,
     /* 1411867 */   // Label 20001: @1411867
     /* 1411867 */   GIM_Try, /*On fail goto*//*Label 20002*/ GIMT_Encode4(1411955), // Rule ID 21137 //
     /* 1411872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1411883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1411886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1411889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411911 */     // MIs[0] Operand 5
     /* 1411911 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411922 */     // MIs[0] policy
     /* 1411922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411932 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1411935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411954 */     // GIR_Coverage, 21137,
     /* 1411954 */     GIR_EraseRootFromParent_Done,
     /* 1411955 */   // Label 20002: @1411955
     /* 1411955 */   GIM_Try, /*On fail goto*//*Label 20003*/ GIMT_Encode4(1412043), // Rule ID 21140 //
     /* 1411960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1411971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1411974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1411977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1411980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411999 */     // MIs[0] Operand 5
     /* 1411999 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412010 */     // MIs[0] policy
     /* 1412010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412020 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1412023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412042 */     // GIR_Coverage, 21140,
     /* 1412042 */     GIR_EraseRootFromParent_Done,
     /* 1412043 */   // Label 20003: @1412043
     /* 1412043 */   GIM_Try, /*On fail goto*//*Label 20004*/ GIMT_Encode4(1412131), // Rule ID 21141 //
     /* 1412048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1412059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1412062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1412065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1412068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1412075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412087 */     // MIs[0] Operand 5
     /* 1412087 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412098 */     // MIs[0] policy
     /* 1412098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1412111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412130 */     // GIR_Coverage, 21141,
     /* 1412130 */     GIR_EraseRootFromParent_Done,
     /* 1412131 */   // Label 20004: @1412131
     /* 1412131 */   GIM_Try, /*On fail goto*//*Label 20005*/ GIMT_Encode4(1412219), // Rule ID 21144 //
     /* 1412136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1412139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1412147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1412150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1412153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412175 */     // MIs[0] Operand 5
     /* 1412175 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412186 */     // MIs[0] policy
     /* 1412186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412196 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1412199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412218 */     // GIR_Coverage, 21144,
     /* 1412218 */     GIR_EraseRootFromParent_Done,
     /* 1412219 */   // Label 20005: @1412219
     /* 1412219 */   GIM_Try, /*On fail goto*//*Label 20006*/ GIMT_Encode4(1412307), // Rule ID 21145 //
     /* 1412224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1412227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1412235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1412238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1412241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412263 */     // MIs[0] Operand 5
     /* 1412263 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412274 */     // MIs[0] policy
     /* 1412274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1412287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412306 */     // GIR_Coverage, 21145,
     /* 1412306 */     GIR_EraseRootFromParent_Done,
     /* 1412307 */   // Label 20006: @1412307
     /* 1412307 */   GIM_Try, /*On fail goto*//*Label 20007*/ GIMT_Encode4(1412395), // Rule ID 21148 //
     /* 1412312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1412315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1412323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1412326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1412329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1412339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412351 */     // MIs[0] Operand 5
     /* 1412351 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412362 */     // MIs[0] policy
     /* 1412362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412372 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1412375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412394 */     // GIR_Coverage, 21148,
     /* 1412394 */     GIR_EraseRootFromParent_Done,
     /* 1412395 */   // Label 20007: @1412395
     /* 1412395 */   GIM_Try, /*On fail goto*//*Label 20008*/ GIMT_Encode4(1412483), // Rule ID 21149 //
     /* 1412400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1412403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1412411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1412414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1412417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1412427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412439 */     // MIs[0] Operand 5
     /* 1412439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412450 */     // MIs[0] policy
     /* 1412450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1412463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412482 */     // GIR_Coverage, 21149,
     /* 1412482 */     GIR_EraseRootFromParent_Done,
     /* 1412483 */   // Label 20008: @1412483
     /* 1412483 */   GIM_Try, /*On fail goto*//*Label 20009*/ GIMT_Encode4(1412571), // Rule ID 21152 //
     /* 1412488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1412491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1412499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1412502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1412505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412527 */     // MIs[0] Operand 5
     /* 1412527 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412538 */     // MIs[0] policy
     /* 1412538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412548 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1412551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412570 */     // GIR_Coverage, 21152,
     /* 1412570 */     GIR_EraseRootFromParent_Done,
     /* 1412571 */   // Label 20009: @1412571
     /* 1412571 */   GIM_Try, /*On fail goto*//*Label 20010*/ GIMT_Encode4(1412659), // Rule ID 21153 //
     /* 1412576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1412579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1412587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1412590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1412593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412615 */     // MIs[0] Operand 5
     /* 1412615 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412626 */     // MIs[0] policy
     /* 1412626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412636 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1412639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412658 */     // GIR_Coverage, 21153,
     /* 1412658 */     GIR_EraseRootFromParent_Done,
     /* 1412659 */   // Label 20010: @1412659
     /* 1412659 */   GIM_Try, /*On fail goto*//*Label 20011*/ GIMT_Encode4(1412747), // Rule ID 21156 //
     /* 1412664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1412667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1412675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1412678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1412681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1412691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412703 */     // MIs[0] Operand 5
     /* 1412703 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412714 */     // MIs[0] policy
     /* 1412714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412724 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1412727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412746 */     // GIR_Coverage, 21156,
     /* 1412746 */     GIR_EraseRootFromParent_Done,
     /* 1412747 */   // Label 20011: @1412747
     /* 1412747 */   GIM_Try, /*On fail goto*//*Label 20012*/ GIMT_Encode4(1412835), // Rule ID 21157 //
     /* 1412752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1412755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1412763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1412766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1412769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1412779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412791 */     // MIs[0] Operand 5
     /* 1412791 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412802 */     // MIs[0] policy
     /* 1412802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412812 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1412815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412834 */     // GIR_Coverage, 21157,
     /* 1412834 */     GIR_EraseRootFromParent_Done,
     /* 1412835 */   // Label 20012: @1412835
     /* 1412835 */   GIM_Try, /*On fail goto*//*Label 20013*/ GIMT_Encode4(1412923), // Rule ID 21160 //
     /* 1412840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1412851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1412854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1412857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412879 */     // MIs[0] Operand 5
     /* 1412879 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412890 */     // MIs[0] policy
     /* 1412890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412900 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1412903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412922 */     // GIR_Coverage, 21160,
     /* 1412922 */     GIR_EraseRootFromParent_Done,
     /* 1412923 */   // Label 20013: @1412923
     /* 1412923 */   GIM_Try, /*On fail goto*//*Label 20014*/ GIMT_Encode4(1413011), // Rule ID 21161 //
     /* 1412928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1412939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1412942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1412945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412967 */     // MIs[0] Operand 5
     /* 1412967 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412978 */     // MIs[0] policy
     /* 1412978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412988 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1412991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413010 */     // GIR_Coverage, 21161,
     /* 1413010 */     GIR_EraseRootFromParent_Done,
     /* 1413011 */   // Label 20014: @1413011
     /* 1413011 */   GIM_Try, /*On fail goto*//*Label 20015*/ GIMT_Encode4(1413099), // Rule ID 21164 //
     /* 1413016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1413027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1413030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1413033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413055 */     // MIs[0] Operand 5
     /* 1413055 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413066 */     // MIs[0] policy
     /* 1413066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413076 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1413079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413098 */     // GIR_Coverage, 21164,
     /* 1413098 */     GIR_EraseRootFromParent_Done,
     /* 1413099 */   // Label 20015: @1413099
     /* 1413099 */   GIM_Try, /*On fail goto*//*Label 20016*/ GIMT_Encode4(1413187), // Rule ID 21165 //
     /* 1413104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1413115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1413118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1413121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413143 */     // MIs[0] Operand 5
     /* 1413143 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413154 */     // MIs[0] policy
     /* 1413154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1413167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413186 */     // GIR_Coverage, 21165,
     /* 1413186 */     GIR_EraseRootFromParent_Done,
     /* 1413187 */   // Label 20016: @1413187
     /* 1413187 */   GIM_Try, /*On fail goto*//*Label 20017*/ GIMT_Encode4(1413275), // Rule ID 21168 //
     /* 1413192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1413203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1413206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1413209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1413212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413231 */     // MIs[0] Operand 5
     /* 1413231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413242 */     // MIs[0] policy
     /* 1413242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1413255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413274 */     // GIR_Coverage, 21168,
     /* 1413274 */     GIR_EraseRootFromParent_Done,
     /* 1413275 */   // Label 20017: @1413275
     /* 1413275 */   GIM_Try, /*On fail goto*//*Label 20018*/ GIMT_Encode4(1413363), // Rule ID 21169 //
     /* 1413280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1413291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1413294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1413297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1413300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413319 */     // MIs[0] Operand 5
     /* 1413319 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413330 */     // MIs[0] policy
     /* 1413330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1413343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413349 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413362 */     // GIR_Coverage, 21169,
     /* 1413362 */     GIR_EraseRootFromParent_Done,
     /* 1413363 */   // Label 20018: @1413363
     /* 1413363 */   GIM_Try, /*On fail goto*//*Label 20019*/ GIMT_Encode4(1413451), // Rule ID 21172 //
     /* 1413368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1413379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1413382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1413385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413407 */     // MIs[0] Operand 5
     /* 1413407 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413418 */     // MIs[0] policy
     /* 1413418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1413431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413450 */     // GIR_Coverage, 21172,
     /* 1413450 */     GIR_EraseRootFromParent_Done,
     /* 1413451 */   // Label 20019: @1413451
     /* 1413451 */   GIM_Try, /*On fail goto*//*Label 20020*/ GIMT_Encode4(1413539), // Rule ID 21173 //
     /* 1413456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1413467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1413470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1413473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413495 */     // MIs[0] Operand 5
     /* 1413495 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413506 */     // MIs[0] policy
     /* 1413506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1413519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413538 */     // GIR_Coverage, 21173,
     /* 1413538 */     GIR_EraseRootFromParent_Done,
     /* 1413539 */   // Label 20020: @1413539
     /* 1413539 */   GIM_Try, /*On fail goto*//*Label 20021*/ GIMT_Encode4(1413627), // Rule ID 21176 //
     /* 1413544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1413555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1413558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1413561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413583 */     // MIs[0] Operand 5
     /* 1413583 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413594 */     // MIs[0] policy
     /* 1413594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413604 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1413607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413626 */     // GIR_Coverage, 21176,
     /* 1413626 */     GIR_EraseRootFromParent_Done,
     /* 1413627 */   // Label 20021: @1413627
     /* 1413627 */   GIM_Try, /*On fail goto*//*Label 20022*/ GIMT_Encode4(1413715), // Rule ID 21177 //
     /* 1413632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1413643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1413646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1413649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413671 */     // MIs[0] Operand 5
     /* 1413671 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413682 */     // MIs[0] policy
     /* 1413682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1413695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413714 */     // GIR_Coverage, 21177,
     /* 1413714 */     GIR_EraseRootFromParent_Done,
     /* 1413715 */   // Label 20022: @1413715
     /* 1413715 */   GIM_Try, /*On fail goto*//*Label 20023*/ GIMT_Encode4(1413803), // Rule ID 21180 //
     /* 1413720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1413723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1413731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1413734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1413737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1413740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413759 */     // MIs[0] Operand 5
     /* 1413759 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413770 */     // MIs[0] policy
     /* 1413770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413780 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1413783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413802 */     // GIR_Coverage, 21180,
     /* 1413802 */     GIR_EraseRootFromParent_Done,
     /* 1413803 */   // Label 20023: @1413803
     /* 1413803 */   GIM_Try, /*On fail goto*//*Label 20024*/ GIMT_Encode4(1413891), // Rule ID 21181 //
     /* 1413808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1413811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1413819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1413822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1413825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1413828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413847 */     // MIs[0] Operand 5
     /* 1413847 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413858 */     // MIs[0] policy
     /* 1413858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1413871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413890 */     // GIR_Coverage, 21181,
     /* 1413890 */     GIR_EraseRootFromParent_Done,
     /* 1413891 */   // Label 20024: @1413891
     /* 1413891 */   GIM_Try, /*On fail goto*//*Label 20025*/ GIMT_Encode4(1413979), // Rule ID 21184 //
     /* 1413896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1413899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1413907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1413910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1413913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413935 */     // MIs[0] Operand 5
     /* 1413935 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413946 */     // MIs[0] policy
     /* 1413946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413956 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1413959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413978 */     // GIR_Coverage, 21184,
     /* 1413978 */     GIR_EraseRootFromParent_Done,
     /* 1413979 */   // Label 20025: @1413979
     /* 1413979 */   GIM_Try, /*On fail goto*//*Label 20026*/ GIMT_Encode4(1414067), // Rule ID 21185 //
     /* 1413984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1413987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1413995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1413998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1414001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1414011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414023 */     // MIs[0] Operand 5
     /* 1414023 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414034 */     // MIs[0] policy
     /* 1414034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414044 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1414047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414066 */     // GIR_Coverage, 21185,
     /* 1414066 */     GIR_EraseRootFromParent_Done,
     /* 1414067 */   // Label 20026: @1414067
     /* 1414067 */   GIM_Try, /*On fail goto*//*Label 20027*/ GIMT_Encode4(1414155), // Rule ID 21188 //
     /* 1414072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1414075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1414080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1414083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1414086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1414089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414111 */     // MIs[0] Operand 5
     /* 1414111 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414122 */     // MIs[0] policy
     /* 1414122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414132 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1414135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414154 */     // GIR_Coverage, 21188,
     /* 1414154 */     GIR_EraseRootFromParent_Done,
     /* 1414155 */   // Label 20027: @1414155
     /* 1414155 */   GIM_Try, /*On fail goto*//*Label 20028*/ GIMT_Encode4(1414243), // Rule ID 21189 //
     /* 1414160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1414163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1414168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1414171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1414174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1414177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414199 */     // MIs[0] Operand 5
     /* 1414199 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414210 */     // MIs[0] policy
     /* 1414210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414220 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1414223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414242 */     // GIR_Coverage, 21189,
     /* 1414242 */     GIR_EraseRootFromParent_Done,
     /* 1414243 */   // Label 20028: @1414243
     /* 1414243 */   GIM_Try, /*On fail goto*//*Label 20029*/ GIMT_Encode4(1414331), // Rule ID 21192 //
     /* 1414248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1414251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1414256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1414259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1414262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1414265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1414275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414287 */     // MIs[0] Operand 5
     /* 1414287 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414298 */     // MIs[0] policy
     /* 1414298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414308 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1414311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414330 */     // GIR_Coverage, 21192,
     /* 1414330 */     GIR_EraseRootFromParent_Done,
     /* 1414331 */   // Label 20029: @1414331
     /* 1414331 */   GIM_Try, /*On fail goto*//*Label 20030*/ GIMT_Encode4(1414419), // Rule ID 21193 //
     /* 1414336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1414339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1414344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1414347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1414350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1414353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1414363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414375 */     // MIs[0] Operand 5
     /* 1414375 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414386 */     // MIs[0] policy
     /* 1414386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414396 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1414399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414418 */     // GIR_Coverage, 21193,
     /* 1414418 */     GIR_EraseRootFromParent_Done,
     /* 1414419 */   // Label 20030: @1414419
     /* 1414419 */   GIM_Try, /*On fail goto*//*Label 20031*/ GIMT_Encode4(1414507), // Rule ID 21496 //
     /* 1414424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1414435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1414438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1414441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1414444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414463 */     // MIs[0] Operand 5
     /* 1414463 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414474 */     // MIs[0] policy
     /* 1414474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414484 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1414487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414493 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414506 */     // GIR_Coverage, 21496,
     /* 1414506 */     GIR_EraseRootFromParent_Done,
     /* 1414507 */   // Label 20031: @1414507
     /* 1414507 */   GIM_Try, /*On fail goto*//*Label 20032*/ GIMT_Encode4(1414595), // Rule ID 21497 //
     /* 1414512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1414523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1414526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1414529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1414532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414551 */     // MIs[0] Operand 5
     /* 1414551 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414562 */     // MIs[0] policy
     /* 1414562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414572 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1414575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414594 */     // GIR_Coverage, 21497,
     /* 1414594 */     GIR_EraseRootFromParent_Done,
     /* 1414595 */   // Label 20032: @1414595
     /* 1414595 */   GIM_Try, /*On fail goto*//*Label 20033*/ GIMT_Encode4(1414683), // Rule ID 21500 //
     /* 1414600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1414611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1414614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1414617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414639 */     // MIs[0] Operand 5
     /* 1414639 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414650 */     // MIs[0] policy
     /* 1414650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414660 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1414663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414682 */     // GIR_Coverage, 21500,
     /* 1414682 */     GIR_EraseRootFromParent_Done,
     /* 1414683 */   // Label 20033: @1414683
     /* 1414683 */   GIM_Try, /*On fail goto*//*Label 20034*/ GIMT_Encode4(1414771), // Rule ID 21501 //
     /* 1414688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1414699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1414702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1414705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414727 */     // MIs[0] Operand 5
     /* 1414727 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414738 */     // MIs[0] policy
     /* 1414738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414748 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1414751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414770 */     // GIR_Coverage, 21501,
     /* 1414770 */     GIR_EraseRootFromParent_Done,
     /* 1414771 */   // Label 20034: @1414771
     /* 1414771 */   GIM_Try, /*On fail goto*//*Label 20035*/ GIMT_Encode4(1414859), // Rule ID 21504 //
     /* 1414776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1414787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1414790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414815 */     // MIs[0] Operand 5
     /* 1414815 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414826 */     // MIs[0] policy
     /* 1414826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414836 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1414839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414858 */     // GIR_Coverage, 21504,
     /* 1414858 */     GIR_EraseRootFromParent_Done,
     /* 1414859 */   // Label 20035: @1414859
     /* 1414859 */   GIM_Try, /*On fail goto*//*Label 20036*/ GIMT_Encode4(1414947), // Rule ID 21505 //
     /* 1414864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1414875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1414878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414903 */     // MIs[0] Operand 5
     /* 1414903 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414914 */     // MIs[0] policy
     /* 1414914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414924 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1414927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414946 */     // GIR_Coverage, 21505,
     /* 1414946 */     GIR_EraseRootFromParent_Done,
     /* 1414947 */   // Label 20036: @1414947
     /* 1414947 */   GIM_Try, /*On fail goto*//*Label 20037*/ GIMT_Encode4(1415035), // Rule ID 21508 //
     /* 1414952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1414963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1414966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1414969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414991 */     // MIs[0] Operand 5
     /* 1414991 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415002 */     // MIs[0] policy
     /* 1415002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415012 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1415015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415034 */     // GIR_Coverage, 21508,
     /* 1415034 */     GIR_EraseRootFromParent_Done,
     /* 1415035 */   // Label 20037: @1415035
     /* 1415035 */   GIM_Try, /*On fail goto*//*Label 20038*/ GIMT_Encode4(1415123), // Rule ID 21509 //
     /* 1415040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1415043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1415051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1415054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1415057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1415060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415079 */     // MIs[0] Operand 5
     /* 1415079 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415090 */     // MIs[0] policy
     /* 1415090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415100 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1415103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415122 */     // GIR_Coverage, 21509,
     /* 1415122 */     GIR_EraseRootFromParent_Done,
     /* 1415123 */   // Label 20038: @1415123
     /* 1415123 */   GIM_Try, /*On fail goto*//*Label 20039*/ GIMT_Encode4(1415211), // Rule ID 21512 //
     /* 1415128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1415131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1415139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1415142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1415145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1415148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415167 */     // MIs[0] Operand 5
     /* 1415167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415178 */     // MIs[0] policy
     /* 1415178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415188 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1415191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415210 */     // GIR_Coverage, 21512,
     /* 1415210 */     GIR_EraseRootFromParent_Done,
     /* 1415211 */   // Label 20039: @1415211
     /* 1415211 */   GIM_Try, /*On fail goto*//*Label 20040*/ GIMT_Encode4(1415299), // Rule ID 21513 //
     /* 1415216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1415219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1415227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1415230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1415233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1415236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415255 */     // MIs[0] Operand 5
     /* 1415255 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415266 */     // MIs[0] policy
     /* 1415266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415276 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1415279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415298 */     // GIR_Coverage, 21513,
     /* 1415298 */     GIR_EraseRootFromParent_Done,
     /* 1415299 */   // Label 20040: @1415299
     /* 1415299 */   GIM_Try, /*On fail goto*//*Label 20041*/ GIMT_Encode4(1415387), // Rule ID 21516 //
     /* 1415304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1415307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1415315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1415318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1415321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1415324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415343 */     // MIs[0] Operand 5
     /* 1415343 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415354 */     // MIs[0] policy
     /* 1415354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415364 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1415367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415386 */     // GIR_Coverage, 21516,
     /* 1415386 */     GIR_EraseRootFromParent_Done,
     /* 1415387 */   // Label 20041: @1415387
     /* 1415387 */   GIM_Try, /*On fail goto*//*Label 20042*/ GIMT_Encode4(1415475), // Rule ID 21517 //
     /* 1415392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1415395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1415403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1415406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1415409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1415412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415431 */     // MIs[0] Operand 5
     /* 1415431 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415442 */     // MIs[0] policy
     /* 1415442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415452 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1415455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415474 */     // GIR_Coverage, 21517,
     /* 1415474 */     GIR_EraseRootFromParent_Done,
     /* 1415475 */   // Label 20042: @1415475
     /* 1415475 */   GIM_Try, /*On fail goto*//*Label 20043*/ GIMT_Encode4(1415563), // Rule ID 21520 //
     /* 1415480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1415491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1415494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1415497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415519 */     // MIs[0] Operand 5
     /* 1415519 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415530 */     // MIs[0] policy
     /* 1415530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415540 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1415543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415562 */     // GIR_Coverage, 21520,
     /* 1415562 */     GIR_EraseRootFromParent_Done,
     /* 1415563 */   // Label 20043: @1415563
     /* 1415563 */   GIM_Try, /*On fail goto*//*Label 20044*/ GIMT_Encode4(1415651), // Rule ID 21521 //
     /* 1415568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1415579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1415582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1415585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415607 */     // MIs[0] Operand 5
     /* 1415607 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415618 */     // MIs[0] policy
     /* 1415618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415628 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1415631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415650 */     // GIR_Coverage, 21521,
     /* 1415650 */     GIR_EraseRootFromParent_Done,
     /* 1415651 */   // Label 20044: @1415651
     /* 1415651 */   GIM_Try, /*On fail goto*//*Label 20045*/ GIMT_Encode4(1415739), // Rule ID 21524 //
     /* 1415656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1415667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1415670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1415673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1415676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415695 */     // MIs[0] Operand 5
     /* 1415695 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415706 */     // MIs[0] policy
     /* 1415706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415716 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1415719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415725 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415738 */     // GIR_Coverage, 21524,
     /* 1415738 */     GIR_EraseRootFromParent_Done,
     /* 1415739 */   // Label 20045: @1415739
     /* 1415739 */   GIM_Try, /*On fail goto*//*Label 20046*/ GIMT_Encode4(1415827), // Rule ID 21525 //
     /* 1415744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1415755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1415758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1415761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1415764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415783 */     // MIs[0] Operand 5
     /* 1415783 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415794 */     // MIs[0] policy
     /* 1415794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415804 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1415807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415826 */     // GIR_Coverage, 21525,
     /* 1415826 */     GIR_EraseRootFromParent_Done,
     /* 1415827 */   // Label 20046: @1415827
     /* 1415827 */   GIM_Try, /*On fail goto*//*Label 20047*/ GIMT_Encode4(1415915), // Rule ID 21528 //
     /* 1415832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1415843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1415846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415871 */     // MIs[0] Operand 5
     /* 1415871 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415882 */     // MIs[0] policy
     /* 1415882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415892 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1415895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415914 */     // GIR_Coverage, 21528,
     /* 1415914 */     GIR_EraseRootFromParent_Done,
     /* 1415915 */   // Label 20047: @1415915
     /* 1415915 */   GIM_Try, /*On fail goto*//*Label 20048*/ GIMT_Encode4(1416003), // Rule ID 21529 //
     /* 1415920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1415931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1415934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415959 */     // MIs[0] Operand 5
     /* 1415959 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415970 */     // MIs[0] policy
     /* 1415970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415980 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1415983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416002 */     // GIR_Coverage, 21529,
     /* 1416002 */     GIR_EraseRootFromParent_Done,
     /* 1416003 */   // Label 20048: @1416003
     /* 1416003 */   GIM_Try, /*On fail goto*//*Label 20049*/ GIMT_Encode4(1416091), // Rule ID 21532 //
     /* 1416008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1416011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1416019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1416022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1416025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416047 */     // MIs[0] Operand 5
     /* 1416047 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416058 */     // MIs[0] policy
     /* 1416058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1416071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416090 */     // GIR_Coverage, 21532,
     /* 1416090 */     GIR_EraseRootFromParent_Done,
     /* 1416091 */   // Label 20049: @1416091
     /* 1416091 */   GIM_Try, /*On fail goto*//*Label 20050*/ GIMT_Encode4(1416179), // Rule ID 21533 //
     /* 1416096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1416099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1416107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1416110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1416113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416135 */     // MIs[0] Operand 5
     /* 1416135 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416146 */     // MIs[0] policy
     /* 1416146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1416159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416178 */     // GIR_Coverage, 21533,
     /* 1416178 */     GIR_EraseRootFromParent_Done,
     /* 1416179 */   // Label 20050: @1416179
     /* 1416179 */   GIM_Try, /*On fail goto*//*Label 20051*/ GIMT_Encode4(1416267), // Rule ID 21536 //
     /* 1416184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1416187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1416195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1416198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1416201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1416204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416223 */     // MIs[0] Operand 5
     /* 1416223 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416234 */     // MIs[0] policy
     /* 1416234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1416247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416266 */     // GIR_Coverage, 21536,
     /* 1416266 */     GIR_EraseRootFromParent_Done,
     /* 1416267 */   // Label 20051: @1416267
     /* 1416267 */   GIM_Try, /*On fail goto*//*Label 20052*/ GIMT_Encode4(1416355), // Rule ID 21537 //
     /* 1416272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1416275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1416283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1416286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1416289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1416292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416311 */     // MIs[0] Operand 5
     /* 1416311 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416322 */     // MIs[0] policy
     /* 1416322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416332 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1416335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416354 */     // GIR_Coverage, 21537,
     /* 1416354 */     GIR_EraseRootFromParent_Done,
     /* 1416355 */   // Label 20052: @1416355
     /* 1416355 */   GIM_Try, /*On fail goto*//*Label 20053*/ GIMT_Encode4(1416443), // Rule ID 21540 //
     /* 1416360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1416371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1416374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1416377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416399 */     // MIs[0] Operand 5
     /* 1416399 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416410 */     // MIs[0] policy
     /* 1416410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416420 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1416423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416442 */     // GIR_Coverage, 21540,
     /* 1416442 */     GIR_EraseRootFromParent_Done,
     /* 1416443 */   // Label 20053: @1416443
     /* 1416443 */   GIM_Try, /*On fail goto*//*Label 20054*/ GIMT_Encode4(1416531), // Rule ID 21541 //
     /* 1416448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1416459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1416462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1416465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416487 */     // MIs[0] Operand 5
     /* 1416487 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416498 */     // MIs[0] policy
     /* 1416498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416508 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1416511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416530 */     // GIR_Coverage, 21541,
     /* 1416530 */     GIR_EraseRootFromParent_Done,
     /* 1416531 */   // Label 20054: @1416531
     /* 1416531 */   GIM_Try, /*On fail goto*//*Label 20055*/ GIMT_Encode4(1416619), // Rule ID 21544 //
     /* 1416536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1416553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416575 */     // MIs[0] Operand 5
     /* 1416575 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416586 */     // MIs[0] policy
     /* 1416586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1416599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416618 */     // GIR_Coverage, 21544,
     /* 1416618 */     GIR_EraseRootFromParent_Done,
     /* 1416619 */   // Label 20055: @1416619
     /* 1416619 */   GIM_Try, /*On fail goto*//*Label 20056*/ GIMT_Encode4(1416707), // Rule ID 21545 //
     /* 1416624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1416641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416663 */     // MIs[0] Operand 5
     /* 1416663 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416674 */     // MIs[0] policy
     /* 1416674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416684 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1416687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416706 */     // GIR_Coverage, 21545,
     /* 1416706 */     GIR_EraseRootFromParent_Done,
     /* 1416707 */   // Label 20056: @1416707
     /* 1416707 */   GIM_Try, /*On fail goto*//*Label 20057*/ GIMT_Encode4(1416795), // Rule ID 21548 //
     /* 1416712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1416723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1416726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1416729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416751 */     // MIs[0] Operand 5
     /* 1416751 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416762 */     // MIs[0] policy
     /* 1416762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1416775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416794 */     // GIR_Coverage, 21548,
     /* 1416794 */     GIR_EraseRootFromParent_Done,
     /* 1416795 */   // Label 20057: @1416795
     /* 1416795 */   GIM_Try, /*On fail goto*//*Label 20058*/ GIMT_Encode4(1416883), // Rule ID 21549 //
     /* 1416800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1416811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1416814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1416817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416839 */     // MIs[0] Operand 5
     /* 1416839 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416850 */     // MIs[0] policy
     /* 1416850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1416863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416882 */     // GIR_Coverage, 21549,
     /* 1416882 */     GIR_EraseRootFromParent_Done,
     /* 1416883 */   // Label 20058: @1416883
     /* 1416883 */   GIM_Try, /*On fail goto*//*Label 20059*/ GIMT_Encode4(1416971), // Rule ID 21552 //
     /* 1416888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1416905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416927 */     // MIs[0] Operand 5
     /* 1416927 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416938 */     // MIs[0] policy
     /* 1416938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416948 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1416951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416957 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416970 */     // GIR_Coverage, 21552,
     /* 1416970 */     GIR_EraseRootFromParent_Done,
     /* 1416971 */   // Label 20059: @1416971
     /* 1416971 */   GIM_Try, /*On fail goto*//*Label 20060*/ GIMT_Encode4(1417059), // Rule ID 21553 //
     /* 1416976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1416993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1417003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417015 */     // MIs[0] Operand 5
     /* 1417015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417026 */     // MIs[0] policy
     /* 1417026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1417039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417058 */     // GIR_Coverage, 21553,
     /* 1417058 */     GIR_EraseRootFromParent_Done,
     /* 1417059 */   // Label 20060: @1417059
     /* 1417059 */   GIM_Try, /*On fail goto*//*Label 20061*/ GIMT_Encode4(1417147), // Rule ID 21556 //
     /* 1417064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1417075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1417078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1417081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1417084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417103 */     // MIs[0] Operand 5
     /* 1417103 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417114 */     // MIs[0] policy
     /* 1417114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417124 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1417127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417146 */     // GIR_Coverage, 21556,
     /* 1417146 */     GIR_EraseRootFromParent_Done,
     /* 1417147 */   // Label 20061: @1417147
     /* 1417147 */   GIM_Try, /*On fail goto*//*Label 20062*/ GIMT_Encode4(1417235), // Rule ID 21557 //
     /* 1417152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1417163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1417166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1417169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1417172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417191 */     // MIs[0] Operand 5
     /* 1417191 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417202 */     // MIs[0] policy
     /* 1417202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417212 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1417215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417234 */     // GIR_Coverage, 21557,
     /* 1417234 */     GIR_EraseRootFromParent_Done,
     /* 1417235 */   // Label 20062: @1417235
     /* 1417235 */   GIM_Try, /*On fail goto*//*Label 20063*/ GIMT_Encode4(1417323), // Rule ID 21560 //
     /* 1417240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1417251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1417254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1417257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1417260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417279 */     // MIs[0] Operand 5
     /* 1417279 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417290 */     // MIs[0] policy
     /* 1417290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417300 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1417303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417322 */     // GIR_Coverage, 21560,
     /* 1417322 */     GIR_EraseRootFromParent_Done,
     /* 1417323 */   // Label 20063: @1417323
     /* 1417323 */   GIM_Try, /*On fail goto*//*Label 20064*/ GIMT_Encode4(1417411), // Rule ID 21561 //
     /* 1417328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1417339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1417342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1417345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1417348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417367 */     // MIs[0] Operand 5
     /* 1417367 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417378 */     // MIs[0] policy
     /* 1417378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417388 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1417391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417410 */     // GIR_Coverage, 21561,
     /* 1417410 */     GIR_EraseRootFromParent_Done,
     /* 1417411 */   // Label 20064: @1417411
     /* 1417411 */   GIM_Try, /*On fail goto*//*Label 20065*/ GIMT_Encode4(1417499), // Rule ID 21564 //
     /* 1417416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1417427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1417430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1417433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1417436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417455 */     // MIs[0] Operand 5
     /* 1417455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417466 */     // MIs[0] policy
     /* 1417466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417476 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1417479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417498 */     // GIR_Coverage, 21564,
     /* 1417498 */     GIR_EraseRootFromParent_Done,
     /* 1417499 */   // Label 20065: @1417499
     /* 1417499 */   GIM_Try, /*On fail goto*//*Label 20066*/ GIMT_Encode4(1417587), // Rule ID 21565 //
     /* 1417504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1417515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1417518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1417521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1417524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417543 */     // MIs[0] Operand 5
     /* 1417543 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417554 */     // MIs[0] policy
     /* 1417554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417564 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1417567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417586 */     // GIR_Coverage, 21565,
     /* 1417586 */     GIR_EraseRootFromParent_Done,
     /* 1417587 */   // Label 20066: @1417587
     /* 1417587 */   GIM_Try, /*On fail goto*//*Label 20067*/ GIMT_Encode4(1417675), // Rule ID 21568 //
     /* 1417592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1417603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1417606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1417609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1417612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417631 */     // MIs[0] Operand 5
     /* 1417631 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417642 */     // MIs[0] policy
     /* 1417642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1417655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417674 */     // GIR_Coverage, 21568,
     /* 1417674 */     GIR_EraseRootFromParent_Done,
     /* 1417675 */   // Label 20067: @1417675
     /* 1417675 */   GIM_Try, /*On fail goto*//*Label 20068*/ GIMT_Encode4(1417763), // Rule ID 21569 //
     /* 1417680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1417691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1417694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1417697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1417700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417719 */     // MIs[0] Operand 5
     /* 1417719 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417730 */     // MIs[0] policy
     /* 1417730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1417743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417762 */     // GIR_Coverage, 21569,
     /* 1417762 */     GIR_EraseRootFromParent_Done,
     /* 1417763 */   // Label 20068: @1417763
     /* 1417763 */   GIM_Try, /*On fail goto*//*Label 20069*/ GIMT_Encode4(1417851), // Rule ID 21572 //
     /* 1417768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1417779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1417782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1417785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1417788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1417795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417807 */     // MIs[0] Operand 5
     /* 1417807 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417818 */     // MIs[0] policy
     /* 1417818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417828 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1417831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417850 */     // GIR_Coverage, 21572,
     /* 1417850 */     GIR_EraseRootFromParent_Done,
     /* 1417851 */   // Label 20069: @1417851
     /* 1417851 */   GIM_Try, /*On fail goto*//*Label 20070*/ GIMT_Encode4(1417939), // Rule ID 21573 //
     /* 1417856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1417867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1417870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1417873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1417876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1417883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417895 */     // MIs[0] Operand 5
     /* 1417895 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417906 */     // MIs[0] policy
     /* 1417906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417916 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1417919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417938 */     // GIR_Coverage, 21573,
     /* 1417938 */     GIR_EraseRootFromParent_Done,
     /* 1417939 */   // Label 20070: @1417939
     /* 1417939 */   GIM_Try, /*On fail goto*//*Label 20071*/ GIMT_Encode4(1418027), // Rule ID 21576 //
     /* 1417944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1417955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1417958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1417961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1417964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1417971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417983 */     // MIs[0] Operand 5
     /* 1417983 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417994 */     // MIs[0] policy
     /* 1417994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418004 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1418007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418026 */     // GIR_Coverage, 21576,
     /* 1418026 */     GIR_EraseRootFromParent_Done,
     /* 1418027 */   // Label 20071: @1418027
     /* 1418027 */   GIM_Try, /*On fail goto*//*Label 20072*/ GIMT_Encode4(1418115), // Rule ID 21577 //
     /* 1418032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1418035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1418043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1418046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1418049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1418052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1418059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418071 */     // MIs[0] Operand 5
     /* 1418071 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418082 */     // MIs[0] policy
     /* 1418082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418092 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1418095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418114 */     // GIR_Coverage, 21577,
     /* 1418114 */     GIR_EraseRootFromParent_Done,
     /* 1418115 */   // Label 20072: @1418115
     /* 1418115 */   GIM_Try, /*On fail goto*//*Label 20073*/ GIMT_Encode4(1418203), // Rule ID 21580 //
     /* 1418120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1418131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1418134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1418137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1418140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418159 */     // MIs[0] Operand 5
     /* 1418159 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418170 */     // MIs[0] policy
     /* 1418170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418180 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1418183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418202 */     // GIR_Coverage, 21580,
     /* 1418202 */     GIR_EraseRootFromParent_Done,
     /* 1418203 */   // Label 20073: @1418203
     /* 1418203 */   GIM_Try, /*On fail goto*//*Label 20074*/ GIMT_Encode4(1418291), // Rule ID 21581 //
     /* 1418208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1418219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1418222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1418225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1418228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418247 */     // MIs[0] Operand 5
     /* 1418247 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418258 */     // MIs[0] policy
     /* 1418258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1418271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418290 */     // GIR_Coverage, 21581,
     /* 1418290 */     GIR_EraseRootFromParent_Done,
     /* 1418291 */   // Label 20074: @1418291
     /* 1418291 */   GIM_Try, /*On fail goto*//*Label 20075*/ GIMT_Encode4(1418379), // Rule ID 21584 //
     /* 1418296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1418307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1418310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1418313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1418316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418335 */     // MIs[0] Operand 5
     /* 1418335 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418346 */     // MIs[0] policy
     /* 1418346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418356 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1418359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418378 */     // GIR_Coverage, 21584,
     /* 1418378 */     GIR_EraseRootFromParent_Done,
     /* 1418379 */   // Label 20075: @1418379
     /* 1418379 */   GIM_Try, /*On fail goto*//*Label 20076*/ GIMT_Encode4(1418467), // Rule ID 21585 //
     /* 1418384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1418395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1418398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1418401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1418404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418423 */     // MIs[0] Operand 5
     /* 1418423 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418434 */     // MIs[0] policy
     /* 1418434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418444 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1418447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418466 */     // GIR_Coverage, 21585,
     /* 1418466 */     GIR_EraseRootFromParent_Done,
     /* 1418467 */   // Label 20076: @1418467
     /* 1418467 */   GIM_Try, /*On fail goto*//*Label 20077*/ GIMT_Encode4(1418555), // Rule ID 21588 //
     /* 1418472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1418489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418511 */     // MIs[0] Operand 5
     /* 1418511 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418522 */     // MIs[0] policy
     /* 1418522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1418535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418554 */     // GIR_Coverage, 21588,
     /* 1418554 */     GIR_EraseRootFromParent_Done,
     /* 1418555 */   // Label 20077: @1418555
     /* 1418555 */   GIM_Try, /*On fail goto*//*Label 20078*/ GIMT_Encode4(1418643), // Rule ID 21589 //
     /* 1418560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1418577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418599 */     // MIs[0] Operand 5
     /* 1418599 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418610 */     // MIs[0] policy
     /* 1418610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1418623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418642 */     // GIR_Coverage, 21589,
     /* 1418642 */     GIR_EraseRootFromParent_Done,
     /* 1418643 */   // Label 20078: @1418643
     /* 1418643 */   GIM_Try, /*On fail goto*//*Label 20079*/ GIMT_Encode4(1418731), // Rule ID 21592 //
     /* 1418648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1418659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1418662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1418665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1418668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418687 */     // MIs[0] Operand 5
     /* 1418687 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418698 */     // MIs[0] policy
     /* 1418698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418708 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1418711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418730 */     // GIR_Coverage, 21592,
     /* 1418730 */     GIR_EraseRootFromParent_Done,
     /* 1418731 */   // Label 20079: @1418731
     /* 1418731 */   GIM_Try, /*On fail goto*//*Label 20080*/ GIMT_Encode4(1418819), // Rule ID 21593 //
     /* 1418736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1418747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1418750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1418753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1418756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418775 */     // MIs[0] Operand 5
     /* 1418775 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418786 */     // MIs[0] policy
     /* 1418786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1418799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418818 */     // GIR_Coverage, 21593,
     /* 1418818 */     GIR_EraseRootFromParent_Done,
     /* 1418819 */   // Label 20080: @1418819
     /* 1418819 */   GIM_Try, /*On fail goto*//*Label 20081*/ GIMT_Encode4(1418907), // Rule ID 21596 //
     /* 1418824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1418835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1418838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1418841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1418844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1418851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418863 */     // MIs[0] Operand 5
     /* 1418863 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418874 */     // MIs[0] policy
     /* 1418874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418884 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1418887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418906 */     // GIR_Coverage, 21596,
     /* 1418906 */     GIR_EraseRootFromParent_Done,
     /* 1418907 */   // Label 20081: @1418907
     /* 1418907 */   GIM_Try, /*On fail goto*//*Label 20082*/ GIMT_Encode4(1418995), // Rule ID 21597 //
     /* 1418912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1418923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1418926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1418929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1418932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1418939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418951 */     // MIs[0] Operand 5
     /* 1418951 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418962 */     // MIs[0] policy
     /* 1418962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1418975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418994 */     // GIR_Coverage, 21597,
     /* 1418994 */     GIR_EraseRootFromParent_Done,
     /* 1418995 */   // Label 20082: @1418995
     /* 1418995 */   GIM_Try, /*On fail goto*//*Label 20083*/ GIMT_Encode4(1419083), // Rule ID 21600 //
     /* 1419000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1419003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1419011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1419014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1419017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1419020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419039 */     // MIs[0] Operand 5
     /* 1419039 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419050 */     // MIs[0] policy
     /* 1419050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419060 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1419063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419082 */     // GIR_Coverage, 21600,
     /* 1419082 */     GIR_EraseRootFromParent_Done,
     /* 1419083 */   // Label 20083: @1419083
     /* 1419083 */   GIM_Try, /*On fail goto*//*Label 20084*/ GIMT_Encode4(1419171), // Rule ID 21601 //
     /* 1419088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1419091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1419099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1419102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1419105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1419108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419127 */     // MIs[0] Operand 5
     /* 1419127 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419138 */     // MIs[0] policy
     /* 1419138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419148 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1419151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419170 */     // GIR_Coverage, 21601,
     /* 1419170 */     GIR_EraseRootFromParent_Done,
     /* 1419171 */   // Label 20084: @1419171
     /* 1419171 */   GIM_Try, /*On fail goto*//*Label 20085*/ GIMT_Encode4(1419259), // Rule ID 21604 //
     /* 1419176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1419179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1419187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1419190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1419193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1419196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419215 */     // MIs[0] Operand 5
     /* 1419215 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419226 */     // MIs[0] policy
     /* 1419226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1419239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419258 */     // GIR_Coverage, 21604,
     /* 1419258 */     GIR_EraseRootFromParent_Done,
     /* 1419259 */   // Label 20085: @1419259
     /* 1419259 */   GIM_Try, /*On fail goto*//*Label 20086*/ GIMT_Encode4(1419347), // Rule ID 21605 //
     /* 1419264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1419267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1419275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1419278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1419281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1419284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419303 */     // MIs[0] Operand 5
     /* 1419303 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419314 */     // MIs[0] policy
     /* 1419314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1419327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419346 */     // GIR_Coverage, 21605,
     /* 1419346 */     GIR_EraseRootFromParent_Done,
     /* 1419347 */   // Label 20086: @1419347
     /* 1419347 */   GIM_Try, /*On fail goto*//*Label 20087*/ GIMT_Encode4(1419435), // Rule ID 21608 //
     /* 1419352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1419355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1419363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1419366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1419369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1419372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419391 */     // MIs[0] Operand 5
     /* 1419391 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419402 */     // MIs[0] policy
     /* 1419402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1419415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419434 */     // GIR_Coverage, 21608,
     /* 1419434 */     GIR_EraseRootFromParent_Done,
     /* 1419435 */   // Label 20087: @1419435
     /* 1419435 */   GIM_Try, /*On fail goto*//*Label 20088*/ GIMT_Encode4(1419523), // Rule ID 21609 //
     /* 1419440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1419443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1419451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1419454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1419457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1419460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419479 */     // MIs[0] Operand 5
     /* 1419479 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419490 */     // MIs[0] policy
     /* 1419490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1419503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419522 */     // GIR_Coverage, 21609,
     /* 1419522 */     GIR_EraseRootFromParent_Done,
     /* 1419523 */   // Label 20088: @1419523
     /* 1419523 */   GIM_Try, /*On fail goto*//*Label 20089*/ GIMT_Encode4(1419611), // Rule ID 21612 //
     /* 1419528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1419531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1419539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1419542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1419545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1419548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419567 */     // MIs[0] Operand 5
     /* 1419567 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419578 */     // MIs[0] policy
     /* 1419578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419588 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1419591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419610 */     // GIR_Coverage, 21612,
     /* 1419610 */     GIR_EraseRootFromParent_Done,
     /* 1419611 */   // Label 20089: @1419611
     /* 1419611 */   GIM_Try, /*On fail goto*//*Label 20090*/ GIMT_Encode4(1419699), // Rule ID 21613 //
     /* 1419616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1419619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1419627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1419630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1419633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1419636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419655 */     // MIs[0] Operand 5
     /* 1419655 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419666 */     // MIs[0] policy
     /* 1419666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419676 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1419679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419698 */     // GIR_Coverage, 21613,
     /* 1419698 */     GIR_EraseRootFromParent_Done,
     /* 1419699 */   // Label 20090: @1419699
     /* 1419699 */   GIM_Try, /*On fail goto*//*Label 20091*/ GIMT_Encode4(1419798), // Rule ID 2810 //
     /* 1419704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1419715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1419718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1419721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1419727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419754 */     // MIs[1] Operand 1
     /* 1419754 */     // No operand predicates
     /* 1419754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419758 */     // MIs[0] policy
     /* 1419758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419770 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1419773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419779 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419797 */     // GIR_Coverage, 2810,
     /* 1419797 */     GIR_EraseRootFromParent_Done,
     /* 1419798 */   // Label 20091: @1419798
     /* 1419798 */   GIM_Try, /*On fail goto*//*Label 20092*/ GIMT_Encode4(1419897), // Rule ID 2811 //
     /* 1419803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1419814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1419817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1419820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1419826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419853 */     // MIs[1] Operand 1
     /* 1419853 */     // No operand predicates
     /* 1419853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419857 */     // MIs[0] policy
     /* 1419857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419869 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1419872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419878 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419896 */     // GIR_Coverage, 2811,
     /* 1419896 */     GIR_EraseRootFromParent_Done,
     /* 1419897 */   // Label 20092: @1419897
     /* 1419897 */   GIM_Try, /*On fail goto*//*Label 20093*/ GIMT_Encode4(1419996), // Rule ID 2818 //
     /* 1419902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1419913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1419916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1419919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1419925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419952 */     // MIs[1] Operand 1
     /* 1419952 */     // No operand predicates
     /* 1419952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419956 */     // MIs[0] policy
     /* 1419956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419968 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1419971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419977 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419995 */     // GIR_Coverage, 2818,
     /* 1419995 */     GIR_EraseRootFromParent_Done,
     /* 1419996 */   // Label 20093: @1419996
     /* 1419996 */   GIM_Try, /*On fail goto*//*Label 20094*/ GIMT_Encode4(1420095), // Rule ID 2819 //
     /* 1420001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1420012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1420015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1420018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420051 */     // MIs[1] Operand 1
     /* 1420051 */     // No operand predicates
     /* 1420051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420055 */     // MIs[0] policy
     /* 1420055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420067 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1420070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420076 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420094 */     // GIR_Coverage, 2819,
     /* 1420094 */     GIR_EraseRootFromParent_Done,
     /* 1420095 */   // Label 20094: @1420095
     /* 1420095 */   GIM_Try, /*On fail goto*//*Label 20095*/ GIMT_Encode4(1420194), // Rule ID 2826 //
     /* 1420100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1420111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1420114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1420117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420150 */     // MIs[1] Operand 1
     /* 1420150 */     // No operand predicates
     /* 1420150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420154 */     // MIs[0] policy
     /* 1420154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420166 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420175 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420193 */     // GIR_Coverage, 2826,
     /* 1420193 */     GIR_EraseRootFromParent_Done,
     /* 1420194 */   // Label 20095: @1420194
     /* 1420194 */   GIM_Try, /*On fail goto*//*Label 20096*/ GIMT_Encode4(1420293), // Rule ID 2827 //
     /* 1420199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1420210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1420213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1420216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420249 */     // MIs[1] Operand 1
     /* 1420249 */     // No operand predicates
     /* 1420249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420253 */     // MIs[0] policy
     /* 1420253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420265 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420274 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420292 */     // GIR_Coverage, 2827,
     /* 1420292 */     GIR_EraseRootFromParent_Done,
     /* 1420293 */   // Label 20096: @1420293
     /* 1420293 */   GIM_Try, /*On fail goto*//*Label 20097*/ GIMT_Encode4(1420392), // Rule ID 2834 //
     /* 1420298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1420309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1420312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1420315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1420321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420348 */     // MIs[1] Operand 1
     /* 1420348 */     // No operand predicates
     /* 1420348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420352 */     // MIs[0] policy
     /* 1420352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420364 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1420367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420373 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420391 */     // GIR_Coverage, 2834,
     /* 1420391 */     GIR_EraseRootFromParent_Done,
     /* 1420392 */   // Label 20097: @1420392
     /* 1420392 */   GIM_Try, /*On fail goto*//*Label 20098*/ GIMT_Encode4(1420491), // Rule ID 2835 //
     /* 1420397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1420408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1420411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1420414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1420420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420447 */     // MIs[1] Operand 1
     /* 1420447 */     // No operand predicates
     /* 1420447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420451 */     // MIs[0] policy
     /* 1420451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420463 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1420466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420472 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420490 */     // GIR_Coverage, 2835,
     /* 1420490 */     GIR_EraseRootFromParent_Done,
     /* 1420491 */   // Label 20098: @1420491
     /* 1420491 */   GIM_Try, /*On fail goto*//*Label 20099*/ GIMT_Encode4(1420590), // Rule ID 2842 //
     /* 1420496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1420507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1420510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1420513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420546 */     // MIs[1] Operand 1
     /* 1420546 */     // No operand predicates
     /* 1420546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420550 */     // MIs[0] policy
     /* 1420550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420562 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420571 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420589 */     // GIR_Coverage, 2842,
     /* 1420589 */     GIR_EraseRootFromParent_Done,
     /* 1420590 */   // Label 20099: @1420590
     /* 1420590 */   GIM_Try, /*On fail goto*//*Label 20100*/ GIMT_Encode4(1420689), // Rule ID 2843 //
     /* 1420595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1420606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1420609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1420612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420645 */     // MIs[1] Operand 1
     /* 1420645 */     // No operand predicates
     /* 1420645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420649 */     // MIs[0] policy
     /* 1420649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420661 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420670 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420688 */     // GIR_Coverage, 2843,
     /* 1420688 */     GIR_EraseRootFromParent_Done,
     /* 1420689 */   // Label 20100: @1420689
     /* 1420689 */   GIM_Try, /*On fail goto*//*Label 20101*/ GIMT_Encode4(1420788), // Rule ID 2850 //
     /* 1420694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1420705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1420708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1420711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1420717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420744 */     // MIs[1] Operand 1
     /* 1420744 */     // No operand predicates
     /* 1420744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420748 */     // MIs[0] policy
     /* 1420748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420760 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420769 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420787 */     // GIR_Coverage, 2850,
     /* 1420787 */     GIR_EraseRootFromParent_Done,
     /* 1420788 */   // Label 20101: @1420788
     /* 1420788 */   GIM_Try, /*On fail goto*//*Label 20102*/ GIMT_Encode4(1420887), // Rule ID 2851 //
     /* 1420793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1420804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1420807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1420810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1420816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420843 */     // MIs[1] Operand 1
     /* 1420843 */     // No operand predicates
     /* 1420843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420847 */     // MIs[0] policy
     /* 1420847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420859 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420868 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420886 */     // GIR_Coverage, 2851,
     /* 1420886 */     GIR_EraseRootFromParent_Done,
     /* 1420887 */   // Label 20102: @1420887
     /* 1420887 */   GIM_Try, /*On fail goto*//*Label 20103*/ GIMT_Encode4(1420986), // Rule ID 2858 //
     /* 1420892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1420903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1420906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1420909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1420915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420942 */     // MIs[1] Operand 1
     /* 1420942 */     // No operand predicates
     /* 1420942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420946 */     // MIs[0] policy
     /* 1420946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420958 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420967 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420985 */     // GIR_Coverage, 2858,
     /* 1420985 */     GIR_EraseRootFromParent_Done,
     /* 1420986 */   // Label 20103: @1420986
     /* 1420986 */   GIM_Try, /*On fail goto*//*Label 20104*/ GIMT_Encode4(1421085), // Rule ID 2859 //
     /* 1420991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1421002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1421005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1421008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1421014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421041 */     // MIs[1] Operand 1
     /* 1421041 */     // No operand predicates
     /* 1421041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421045 */     // MIs[0] policy
     /* 1421045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421057 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421066 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421084 */     // GIR_Coverage, 2859,
     /* 1421084 */     GIR_EraseRootFromParent_Done,
     /* 1421085 */   // Label 20104: @1421085
     /* 1421085 */   GIM_Try, /*On fail goto*//*Label 20105*/ GIMT_Encode4(1421184), // Rule ID 2866 //
     /* 1421090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1421101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1421104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1421107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1421113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421140 */     // MIs[1] Operand 1
     /* 1421140 */     // No operand predicates
     /* 1421140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421144 */     // MIs[0] policy
     /* 1421144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421165 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421183 */     // GIR_Coverage, 2866,
     /* 1421183 */     GIR_EraseRootFromParent_Done,
     /* 1421184 */   // Label 20105: @1421184
     /* 1421184 */   GIM_Try, /*On fail goto*//*Label 20106*/ GIMT_Encode4(1421283), // Rule ID 2867 //
     /* 1421189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1421200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1421203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1421206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1421212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421239 */     // MIs[1] Operand 1
     /* 1421239 */     // No operand predicates
     /* 1421239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421243 */     // MIs[0] policy
     /* 1421243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421255 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421264 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421282 */     // GIR_Coverage, 2867,
     /* 1421282 */     GIR_EraseRootFromParent_Done,
     /* 1421283 */   // Label 20106: @1421283
     /* 1421283 */   GIM_Try, /*On fail goto*//*Label 20107*/ GIMT_Encode4(1421382), // Rule ID 2874 //
     /* 1421288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1421299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1421302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1421305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1421311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421338 */     // MIs[1] Operand 1
     /* 1421338 */     // No operand predicates
     /* 1421338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421342 */     // MIs[0] policy
     /* 1421342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421363 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1421378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421381 */     // GIR_Coverage, 2874,
     /* 1421381 */     GIR_EraseRootFromParent_Done,
     /* 1421382 */   // Label 20107: @1421382
     /* 1421382 */   GIM_Try, /*On fail goto*//*Label 20108*/ GIMT_Encode4(1421481), // Rule ID 2875 //
     /* 1421387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1421398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1421401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1421404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1421410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421437 */     // MIs[1] Operand 1
     /* 1421437 */     // No operand predicates
     /* 1421437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421441 */     // MIs[0] policy
     /* 1421441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421453 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421462 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1421477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421480 */     // GIR_Coverage, 2875,
     /* 1421480 */     GIR_EraseRootFromParent_Done,
     /* 1421481 */   // Label 20108: @1421481
     /* 1421481 */   GIM_Try, /*On fail goto*//*Label 20109*/ GIMT_Encode4(1421580), // Rule ID 2882 //
     /* 1421486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1421489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1421497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1421500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1421503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421536 */     // MIs[1] Operand 1
     /* 1421536 */     // No operand predicates
     /* 1421536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421540 */     // MIs[0] policy
     /* 1421540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421552 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421561 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421579 */     // GIR_Coverage, 2882,
     /* 1421579 */     GIR_EraseRootFromParent_Done,
     /* 1421580 */   // Label 20109: @1421580
     /* 1421580 */   GIM_Try, /*On fail goto*//*Label 20110*/ GIMT_Encode4(1421679), // Rule ID 2883 //
     /* 1421585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1421588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1421596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1421599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1421602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421635 */     // MIs[1] Operand 1
     /* 1421635 */     // No operand predicates
     /* 1421635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421639 */     // MIs[0] policy
     /* 1421639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421651 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421660 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421678 */     // GIR_Coverage, 2883,
     /* 1421678 */     GIR_EraseRootFromParent_Done,
     /* 1421679 */   // Label 20110: @1421679
     /* 1421679 */   GIM_Try, /*On fail goto*//*Label 20111*/ GIMT_Encode4(1421778), // Rule ID 2890 //
     /* 1421684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1421695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1421698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1421701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1421707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421734 */     // MIs[1] Operand 1
     /* 1421734 */     // No operand predicates
     /* 1421734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421738 */     // MIs[0] policy
     /* 1421738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421750 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1421753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421759 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421777 */     // GIR_Coverage, 2890,
     /* 1421777 */     GIR_EraseRootFromParent_Done,
     /* 1421778 */   // Label 20111: @1421778
     /* 1421778 */   GIM_Try, /*On fail goto*//*Label 20112*/ GIMT_Encode4(1421877), // Rule ID 2891 //
     /* 1421783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1421794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1421797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1421800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1421806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421833 */     // MIs[1] Operand 1
     /* 1421833 */     // No operand predicates
     /* 1421833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421837 */     // MIs[0] policy
     /* 1421837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421849 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1421852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421858 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421876 */     // GIR_Coverage, 2891,
     /* 1421876 */     GIR_EraseRootFromParent_Done,
     /* 1421877 */   // Label 20112: @1421877
     /* 1421877 */   GIM_Try, /*On fail goto*//*Label 20113*/ GIMT_Encode4(1421976), // Rule ID 2898 //
     /* 1421882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1421893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1421896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1421899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1421905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1421912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421932 */     // MIs[1] Operand 1
     /* 1421932 */     // No operand predicates
     /* 1421932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421936 */     // MIs[0] policy
     /* 1421936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421948 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1421951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421957 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421975 */     // GIR_Coverage, 2898,
     /* 1421975 */     GIR_EraseRootFromParent_Done,
     /* 1421976 */   // Label 20113: @1421976
     /* 1421976 */   GIM_Try, /*On fail goto*//*Label 20114*/ GIMT_Encode4(1422075), // Rule ID 2899 //
     /* 1421981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1421992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1421995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1421998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1422004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422031 */     // MIs[1] Operand 1
     /* 1422031 */     // No operand predicates
     /* 1422031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422035 */     // MIs[0] policy
     /* 1422035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422047 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422056 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1422071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422074 */     // GIR_Coverage, 2899,
     /* 1422074 */     GIR_EraseRootFromParent_Done,
     /* 1422075 */   // Label 20114: @1422075
     /* 1422075 */   GIM_Try, /*On fail goto*//*Label 20115*/ GIMT_Encode4(1422174), // Rule ID 2906 //
     /* 1422080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1422091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1422094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1422097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1422103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422130 */     // MIs[1] Operand 1
     /* 1422130 */     // No operand predicates
     /* 1422130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422134 */     // MIs[0] policy
     /* 1422134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422146 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422155 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1422170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422173 */     // GIR_Coverage, 2906,
     /* 1422173 */     GIR_EraseRootFromParent_Done,
     /* 1422174 */   // Label 20115: @1422174
     /* 1422174 */   GIM_Try, /*On fail goto*//*Label 20116*/ GIMT_Encode4(1422273), // Rule ID 2907 //
     /* 1422179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1422190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1422193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1422196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1422202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422229 */     // MIs[1] Operand 1
     /* 1422229 */     // No operand predicates
     /* 1422229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422233 */     // MIs[0] policy
     /* 1422233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422245 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422254 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1422269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422272 */     // GIR_Coverage, 2907,
     /* 1422272 */     GIR_EraseRootFromParent_Done,
     /* 1422273 */   // Label 20116: @1422273
     /* 1422273 */   GIM_Try, /*On fail goto*//*Label 20117*/ GIMT_Encode4(1422372), // Rule ID 2914 //
     /* 1422278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1422289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1422292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1422295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1422301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422328 */     // MIs[1] Operand 1
     /* 1422328 */     // No operand predicates
     /* 1422328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422332 */     // MIs[0] policy
     /* 1422332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1422347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422353 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422371 */     // GIR_Coverage, 2914,
     /* 1422371 */     GIR_EraseRootFromParent_Done,
     /* 1422372 */   // Label 20117: @1422372
     /* 1422372 */   GIM_Try, /*On fail goto*//*Label 20118*/ GIMT_Encode4(1422471), // Rule ID 2915 //
     /* 1422377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1422388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1422391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1422394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1422400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422427 */     // MIs[1] Operand 1
     /* 1422427 */     // No operand predicates
     /* 1422427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422431 */     // MIs[0] policy
     /* 1422431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422443 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1422446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422452 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422470 */     // GIR_Coverage, 2915,
     /* 1422470 */     GIR_EraseRootFromParent_Done,
     /* 1422471 */   // Label 20118: @1422471
     /* 1422471 */   GIM_Try, /*On fail goto*//*Label 20119*/ GIMT_Encode4(1422570), // Rule ID 2922 //
     /* 1422476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1422487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1422490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1422493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1422499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422526 */     // MIs[1] Operand 1
     /* 1422526 */     // No operand predicates
     /* 1422526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422530 */     // MIs[0] policy
     /* 1422530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422542 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422551 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422569 */     // GIR_Coverage, 2922,
     /* 1422569 */     GIR_EraseRootFromParent_Done,
     /* 1422570 */   // Label 20119: @1422570
     /* 1422570 */   GIM_Try, /*On fail goto*//*Label 20120*/ GIMT_Encode4(1422669), // Rule ID 2923 //
     /* 1422575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1422586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1422589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1422592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1422598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422625 */     // MIs[1] Operand 1
     /* 1422625 */     // No operand predicates
     /* 1422625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422629 */     // MIs[0] policy
     /* 1422629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422641 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422650 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422668 */     // GIR_Coverage, 2923,
     /* 1422668 */     GIR_EraseRootFromParent_Done,
     /* 1422669 */   // Label 20120: @1422669
     /* 1422669 */   GIM_Try, /*On fail goto*//*Label 20121*/ GIMT_Encode4(1422768), // Rule ID 2930 //
     /* 1422674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1422685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1422688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1422691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1422697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422724 */     // MIs[1] Operand 1
     /* 1422724 */     // No operand predicates
     /* 1422724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422728 */     // MIs[0] policy
     /* 1422728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422740 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422749 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422767 */     // GIR_Coverage, 2930,
     /* 1422767 */     GIR_EraseRootFromParent_Done,
     /* 1422768 */   // Label 20121: @1422768
     /* 1422768 */   GIM_Try, /*On fail goto*//*Label 20122*/ GIMT_Encode4(1422867), // Rule ID 2931 //
     /* 1422773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1422784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1422787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1422790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1422796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422823 */     // MIs[1] Operand 1
     /* 1422823 */     // No operand predicates
     /* 1422823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422827 */     // MIs[0] policy
     /* 1422827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422839 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422848 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422866 */     // GIR_Coverage, 2931,
     /* 1422866 */     GIR_EraseRootFromParent_Done,
     /* 1422867 */   // Label 20122: @1422867
     /* 1422867 */   GIM_Try, /*On fail goto*//*Label 20123*/ GIMT_Encode4(1422966), // Rule ID 2938 //
     /* 1422872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1422883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1422886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1422889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1422895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422922 */     // MIs[1] Operand 1
     /* 1422922 */     // No operand predicates
     /* 1422922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422926 */     // MIs[0] policy
     /* 1422926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1422941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422947 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422965 */     // GIR_Coverage, 2938,
     /* 1422965 */     GIR_EraseRootFromParent_Done,
     /* 1422966 */   // Label 20123: @1422966
     /* 1422966 */   GIM_Try, /*On fail goto*//*Label 20124*/ GIMT_Encode4(1423065), // Rule ID 2939 //
     /* 1422971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1422982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1422985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1422988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1422994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423021 */     // MIs[1] Operand 1
     /* 1423021 */     // No operand predicates
     /* 1423021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423025 */     // MIs[0] policy
     /* 1423025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423046 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423064 */     // GIR_Coverage, 2939,
     /* 1423064 */     GIR_EraseRootFromParent_Done,
     /* 1423065 */   // Label 20124: @1423065
     /* 1423065 */   GIM_Try, /*On fail goto*//*Label 20125*/ GIMT_Encode4(1423164), // Rule ID 2946 //
     /* 1423070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1423081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1423084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1423087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423120 */     // MIs[1] Operand 1
     /* 1423120 */     // No operand predicates
     /* 1423120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423124 */     // MIs[0] policy
     /* 1423124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423136 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423145 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423163 */     // GIR_Coverage, 2946,
     /* 1423163 */     GIR_EraseRootFromParent_Done,
     /* 1423164 */   // Label 20125: @1423164
     /* 1423164 */   GIM_Try, /*On fail goto*//*Label 20126*/ GIMT_Encode4(1423263), // Rule ID 2947 //
     /* 1423169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1423180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1423183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1423186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423219 */     // MIs[1] Operand 1
     /* 1423219 */     // No operand predicates
     /* 1423219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423223 */     // MIs[0] policy
     /* 1423223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423235 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423244 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423262 */     // GIR_Coverage, 2947,
     /* 1423262 */     GIR_EraseRootFromParent_Done,
     /* 1423263 */   // Label 20126: @1423263
     /* 1423263 */   GIM_Try, /*On fail goto*//*Label 20127*/ GIMT_Encode4(1423362), // Rule ID 2954 //
     /* 1423268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1423279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1423282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1423285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1423291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423318 */     // MIs[1] Operand 1
     /* 1423318 */     // No operand predicates
     /* 1423318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423322 */     // MIs[0] policy
     /* 1423322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1423337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423343 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423361 */     // GIR_Coverage, 2954,
     /* 1423361 */     GIR_EraseRootFromParent_Done,
     /* 1423362 */   // Label 20127: @1423362
     /* 1423362 */   GIM_Try, /*On fail goto*//*Label 20128*/ GIMT_Encode4(1423461), // Rule ID 2955 //
     /* 1423367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1423378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1423381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1423384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1423390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423417 */     // MIs[1] Operand 1
     /* 1423417 */     // No operand predicates
     /* 1423417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423421 */     // MIs[0] policy
     /* 1423421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423433 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1423436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423442 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423460 */     // GIR_Coverage, 2955,
     /* 1423460 */     GIR_EraseRootFromParent_Done,
     /* 1423461 */   // Label 20128: @1423461
     /* 1423461 */   GIM_Try, /*On fail goto*//*Label 20129*/ GIMT_Encode4(1423560), // Rule ID 2962 //
     /* 1423466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1423477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1423480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1423483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423516 */     // MIs[1] Operand 1
     /* 1423516 */     // No operand predicates
     /* 1423516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423520 */     // MIs[0] policy
     /* 1423520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423532 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423541 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423559 */     // GIR_Coverage, 2962,
     /* 1423559 */     GIR_EraseRootFromParent_Done,
     /* 1423560 */   // Label 20129: @1423560
     /* 1423560 */   GIM_Try, /*On fail goto*//*Label 20130*/ GIMT_Encode4(1423659), // Rule ID 2963 //
     /* 1423565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1423576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1423579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1423582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423615 */     // MIs[1] Operand 1
     /* 1423615 */     // No operand predicates
     /* 1423615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423619 */     // MIs[0] policy
     /* 1423619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423640 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423658 */     // GIR_Coverage, 2963,
     /* 1423658 */     GIR_EraseRootFromParent_Done,
     /* 1423659 */   // Label 20130: @1423659
     /* 1423659 */   GIM_Try, /*On fail goto*//*Label 20131*/ GIMT_Encode4(1423758), // Rule ID 2970 //
     /* 1423664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1423675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1423678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1423681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1423687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423714 */     // MIs[1] Operand 1
     /* 1423714 */     // No operand predicates
     /* 1423714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423718 */     // MIs[0] policy
     /* 1423718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423730 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423739 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423757 */     // GIR_Coverage, 2970,
     /* 1423757 */     GIR_EraseRootFromParent_Done,
     /* 1423758 */   // Label 20131: @1423758
     /* 1423758 */   GIM_Try, /*On fail goto*//*Label 20132*/ GIMT_Encode4(1423857), // Rule ID 2971 //
     /* 1423763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1423774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1423777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1423780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1423786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423813 */     // MIs[1] Operand 1
     /* 1423813 */     // No operand predicates
     /* 1423813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423817 */     // MIs[0] policy
     /* 1423817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423829 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423838 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423856 */     // GIR_Coverage, 2971,
     /* 1423856 */     GIR_EraseRootFromParent_Done,
     /* 1423857 */   // Label 20132: @1423857
     /* 1423857 */   GIM_Try, /*On fail goto*//*Label 20133*/ GIMT_Encode4(1423956), // Rule ID 2978 //
     /* 1423862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1423873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1423876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1423879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423912 */     // MIs[1] Operand 1
     /* 1423912 */     // No operand predicates
     /* 1423912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423916 */     // MIs[0] policy
     /* 1423916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423928 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1423931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423937 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423955 */     // GIR_Coverage, 2978,
     /* 1423955 */     GIR_EraseRootFromParent_Done,
     /* 1423956 */   // Label 20133: @1423956
     /* 1423956 */   GIM_Try, /*On fail goto*//*Label 20134*/ GIMT_Encode4(1424055), // Rule ID 2979 //
     /* 1423961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1423972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1423975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1423978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1424011 */     // MIs[1] Operand 1
     /* 1424011 */     // No operand predicates
     /* 1424011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424015 */     // MIs[0] policy
     /* 1424015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424027 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1424030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424036 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1424041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1424051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424054 */     // GIR_Coverage, 2979,
     /* 1424054 */     GIR_EraseRootFromParent_Done,
     /* 1424055 */   // Label 20134: @1424055
     /* 1424055 */   GIM_Try, /*On fail goto*//*Label 20135*/ GIMT_Encode4(1424152), // Rule ID 3162 //
     /* 1424060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1424071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1424074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1424077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424110 */     // MIs[1] Operand 1
     /* 1424110 */     // No operand predicates
     /* 1424110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424114 */     // MIs[0] policy
     /* 1424114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424126 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1424129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424151 */     // GIR_Coverage, 3162,
     /* 1424151 */     GIR_EraseRootFromParent_Done,
     /* 1424152 */   // Label 20135: @1424152
     /* 1424152 */   GIM_Try, /*On fail goto*//*Label 20136*/ GIMT_Encode4(1424249), // Rule ID 3163 //
     /* 1424157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1424168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1424171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1424174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424207 */     // MIs[1] Operand 1
     /* 1424207 */     // No operand predicates
     /* 1424207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424211 */     // MIs[0] policy
     /* 1424211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424223 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1424226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424248 */     // GIR_Coverage, 3163,
     /* 1424248 */     GIR_EraseRootFromParent_Done,
     /* 1424249 */   // Label 20136: @1424249
     /* 1424249 */   GIM_Try, /*On fail goto*//*Label 20137*/ GIMT_Encode4(1424346), // Rule ID 3166 //
     /* 1424254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1424265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1424268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1424271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424304 */     // MIs[1] Operand 1
     /* 1424304 */     // No operand predicates
     /* 1424304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424308 */     // MIs[0] policy
     /* 1424308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424320 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1424323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424345 */     // GIR_Coverage, 3166,
     /* 1424345 */     GIR_EraseRootFromParent_Done,
     /* 1424346 */   // Label 20137: @1424346
     /* 1424346 */   GIM_Try, /*On fail goto*//*Label 20138*/ GIMT_Encode4(1424443), // Rule ID 3167 //
     /* 1424351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1424362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1424365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1424368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424401 */     // MIs[1] Operand 1
     /* 1424401 */     // No operand predicates
     /* 1424401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424405 */     // MIs[0] policy
     /* 1424405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424417 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1424420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424442 */     // GIR_Coverage, 3167,
     /* 1424442 */     GIR_EraseRootFromParent_Done,
     /* 1424443 */   // Label 20138: @1424443
     /* 1424443 */   GIM_Try, /*On fail goto*//*Label 20139*/ GIMT_Encode4(1424540), // Rule ID 3170 //
     /* 1424448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1424459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1424462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1424465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424498 */     // MIs[1] Operand 1
     /* 1424498 */     // No operand predicates
     /* 1424498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424502 */     // MIs[0] policy
     /* 1424502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424514 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424539 */     // GIR_Coverage, 3170,
     /* 1424539 */     GIR_EraseRootFromParent_Done,
     /* 1424540 */   // Label 20139: @1424540
     /* 1424540 */   GIM_Try, /*On fail goto*//*Label 20140*/ GIMT_Encode4(1424637), // Rule ID 3171 //
     /* 1424545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1424556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1424559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1424562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424595 */     // MIs[1] Operand 1
     /* 1424595 */     // No operand predicates
     /* 1424595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424599 */     // MIs[0] policy
     /* 1424599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424611 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424636 */     // GIR_Coverage, 3171,
     /* 1424636 */     GIR_EraseRootFromParent_Done,
     /* 1424637 */   // Label 20140: @1424637
     /* 1424637 */   GIM_Try, /*On fail goto*//*Label 20141*/ GIMT_Encode4(1424734), // Rule ID 3174 //
     /* 1424642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1424653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1424656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1424659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424692 */     // MIs[1] Operand 1
     /* 1424692 */     // No operand predicates
     /* 1424692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424696 */     // MIs[0] policy
     /* 1424696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424708 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1424711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424733 */     // GIR_Coverage, 3174,
     /* 1424733 */     GIR_EraseRootFromParent_Done,
     /* 1424734 */   // Label 20141: @1424734
     /* 1424734 */   GIM_Try, /*On fail goto*//*Label 20142*/ GIMT_Encode4(1424831), // Rule ID 3175 //
     /* 1424739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1424750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1424753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1424756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424789 */     // MIs[1] Operand 1
     /* 1424789 */     // No operand predicates
     /* 1424789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424793 */     // MIs[0] policy
     /* 1424793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424805 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1424808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424830 */     // GIR_Coverage, 3175,
     /* 1424830 */     GIR_EraseRootFromParent_Done,
     /* 1424831 */   // Label 20142: @1424831
     /* 1424831 */   GIM_Try, /*On fail goto*//*Label 20143*/ GIMT_Encode4(1424928), // Rule ID 3178 //
     /* 1424836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1424847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1424850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1424853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424886 */     // MIs[1] Operand 1
     /* 1424886 */     // No operand predicates
     /* 1424886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424890 */     // MIs[0] policy
     /* 1424890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424902 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424927 */     // GIR_Coverage, 3178,
     /* 1424927 */     GIR_EraseRootFromParent_Done,
     /* 1424928 */   // Label 20143: @1424928
     /* 1424928 */   GIM_Try, /*On fail goto*//*Label 20144*/ GIMT_Encode4(1425025), // Rule ID 3179 //
     /* 1424933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1424944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1424947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1424950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424983 */     // MIs[1] Operand 1
     /* 1424983 */     // No operand predicates
     /* 1424983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424987 */     // MIs[0] policy
     /* 1424987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424999 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1425002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425024 */     // GIR_Coverage, 3179,
     /* 1425024 */     GIR_EraseRootFromParent_Done,
     /* 1425025 */   // Label 20144: @1425025
     /* 1425025 */   GIM_Try, /*On fail goto*//*Label 20145*/ GIMT_Encode4(1425122), // Rule ID 3182 //
     /* 1425030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1425041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1425044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1425047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425080 */     // MIs[1] Operand 1
     /* 1425080 */     // No operand predicates
     /* 1425080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425084 */     // MIs[0] policy
     /* 1425084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425096 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1425099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425121 */     // GIR_Coverage, 3182,
     /* 1425121 */     GIR_EraseRootFromParent_Done,
     /* 1425122 */   // Label 20145: @1425122
     /* 1425122 */   GIM_Try, /*On fail goto*//*Label 20146*/ GIMT_Encode4(1425219), // Rule ID 3183 //
     /* 1425127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1425138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1425141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1425144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425177 */     // MIs[1] Operand 1
     /* 1425177 */     // No operand predicates
     /* 1425177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425181 */     // MIs[0] policy
     /* 1425181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425193 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1425196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425218 */     // GIR_Coverage, 3183,
     /* 1425218 */     GIR_EraseRootFromParent_Done,
     /* 1425219 */   // Label 20146: @1425219
     /* 1425219 */   GIM_Try, /*On fail goto*//*Label 20147*/ GIMT_Encode4(1425316), // Rule ID 3186 //
     /* 1425224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1425235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1425238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1425241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1425247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425274 */     // MIs[1] Operand 1
     /* 1425274 */     // No operand predicates
     /* 1425274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425278 */     // MIs[0] policy
     /* 1425278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425290 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425315 */     // GIR_Coverage, 3186,
     /* 1425315 */     GIR_EraseRootFromParent_Done,
     /* 1425316 */   // Label 20147: @1425316
     /* 1425316 */   GIM_Try, /*On fail goto*//*Label 20148*/ GIMT_Encode4(1425413), // Rule ID 3187 //
     /* 1425321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1425332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1425335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1425338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1425344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425371 */     // MIs[1] Operand 1
     /* 1425371 */     // No operand predicates
     /* 1425371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425375 */     // MIs[0] policy
     /* 1425375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425387 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425412 */     // GIR_Coverage, 3187,
     /* 1425412 */     GIR_EraseRootFromParent_Done,
     /* 1425413 */   // Label 20148: @1425413
     /* 1425413 */   GIM_Try, /*On fail goto*//*Label 20149*/ GIMT_Encode4(1425510), // Rule ID 3190 //
     /* 1425418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1425429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1425432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1425435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1425441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425464 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425468 */     // MIs[1] Operand 1
     /* 1425468 */     // No operand predicates
     /* 1425468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425472 */     // MIs[0] policy
     /* 1425472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425509 */     // GIR_Coverage, 3190,
     /* 1425509 */     GIR_EraseRootFromParent_Done,
     /* 1425510 */   // Label 20149: @1425510
     /* 1425510 */   GIM_Try, /*On fail goto*//*Label 20150*/ GIMT_Encode4(1425607), // Rule ID 3191 //
     /* 1425515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1425526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1425529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1425532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1425538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425565 */     // MIs[1] Operand 1
     /* 1425565 */     // No operand predicates
     /* 1425565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425569 */     // MIs[0] policy
     /* 1425569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425581 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425606 */     // GIR_Coverage, 3191,
     /* 1425606 */     GIR_EraseRootFromParent_Done,
     /* 1425607 */   // Label 20150: @1425607
     /* 1425607 */   GIM_Try, /*On fail goto*//*Label 20151*/ GIMT_Encode4(1425704), // Rule ID 3194 //
     /* 1425612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1425623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1425626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1425629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425662 */     // MIs[1] Operand 1
     /* 1425662 */     // No operand predicates
     /* 1425662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425666 */     // MIs[0] policy
     /* 1425666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425703 */     // GIR_Coverage, 3194,
     /* 1425703 */     GIR_EraseRootFromParent_Done,
     /* 1425704 */   // Label 20151: @1425704
     /* 1425704 */   GIM_Try, /*On fail goto*//*Label 20152*/ GIMT_Encode4(1425801), // Rule ID 3195 //
     /* 1425709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1425720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1425723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1425726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425759 */     // MIs[1] Operand 1
     /* 1425759 */     // No operand predicates
     /* 1425759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425763 */     // MIs[0] policy
     /* 1425763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425775 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425800 */     // GIR_Coverage, 3195,
     /* 1425800 */     GIR_EraseRootFromParent_Done,
     /* 1425801 */   // Label 20152: @1425801
     /* 1425801 */   GIM_Try, /*On fail goto*//*Label 20153*/ GIMT_Encode4(1425898), // Rule ID 3198 //
     /* 1425806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1425809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1425817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1425820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1425823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425856 */     // MIs[1] Operand 1
     /* 1425856 */     // No operand predicates
     /* 1425856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425860 */     // MIs[0] policy
     /* 1425860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425872 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425897 */     // GIR_Coverage, 3198,
     /* 1425897 */     GIR_EraseRootFromParent_Done,
     /* 1425898 */   // Label 20153: @1425898
     /* 1425898 */   GIM_Try, /*On fail goto*//*Label 20154*/ GIMT_Encode4(1425995), // Rule ID 3199 //
     /* 1425903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1425906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1425914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1425917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1425920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425953 */     // MIs[1] Operand 1
     /* 1425953 */     // No operand predicates
     /* 1425953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425957 */     // MIs[0] policy
     /* 1425957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425969 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425994 */     // GIR_Coverage, 3199,
     /* 1425994 */     GIR_EraseRootFromParent_Done,
     /* 1425995 */   // Label 20154: @1425995
     /* 1425995 */   GIM_Try, /*On fail goto*//*Label 20155*/ GIMT_Encode4(1426092), // Rule ID 3202 //
     /* 1426000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1426011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1426014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1426017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426050 */     // MIs[1] Operand 1
     /* 1426050 */     // No operand predicates
     /* 1426050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426054 */     // MIs[0] policy
     /* 1426054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426066 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426091 */     // GIR_Coverage, 3202,
     /* 1426091 */     GIR_EraseRootFromParent_Done,
     /* 1426092 */   // Label 20155: @1426092
     /* 1426092 */   GIM_Try, /*On fail goto*//*Label 20156*/ GIMT_Encode4(1426189), // Rule ID 3203 //
     /* 1426097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1426108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1426111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1426114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426147 */     // MIs[1] Operand 1
     /* 1426147 */     // No operand predicates
     /* 1426147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426151 */     // MIs[0] policy
     /* 1426151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426163 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426188 */     // GIR_Coverage, 3203,
     /* 1426188 */     GIR_EraseRootFromParent_Done,
     /* 1426189 */   // Label 20156: @1426189
     /* 1426189 */   GIM_Try, /*On fail goto*//*Label 20157*/ GIMT_Encode4(1426286), // Rule ID 3206 //
     /* 1426194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1426205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1426208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1426211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1426217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426244 */     // MIs[1] Operand 1
     /* 1426244 */     // No operand predicates
     /* 1426244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426248 */     // MIs[0] policy
     /* 1426248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426260 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426285 */     // GIR_Coverage, 3206,
     /* 1426285 */     GIR_EraseRootFromParent_Done,
     /* 1426286 */   // Label 20157: @1426286
     /* 1426286 */   GIM_Try, /*On fail goto*//*Label 20158*/ GIMT_Encode4(1426383), // Rule ID 3207 //
     /* 1426291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1426302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1426305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1426308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1426314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426341 */     // MIs[1] Operand 1
     /* 1426341 */     // No operand predicates
     /* 1426341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426345 */     // MIs[0] policy
     /* 1426345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426357 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426382 */     // GIR_Coverage, 3207,
     /* 1426382 */     GIR_EraseRootFromParent_Done,
     /* 1426383 */   // Label 20158: @1426383
     /* 1426383 */   GIM_Try, /*On fail goto*//*Label 20159*/ GIMT_Encode4(1426480), // Rule ID 3210 //
     /* 1426388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1426399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1426402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1426405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1426411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426438 */     // MIs[1] Operand 1
     /* 1426438 */     // No operand predicates
     /* 1426438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426442 */     // MIs[0] policy
     /* 1426442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426454 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426479 */     // GIR_Coverage, 3210,
     /* 1426479 */     GIR_EraseRootFromParent_Done,
     /* 1426480 */   // Label 20159: @1426480
     /* 1426480 */   GIM_Try, /*On fail goto*//*Label 20160*/ GIMT_Encode4(1426577), // Rule ID 3211 //
     /* 1426485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1426496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1426499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1426502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1426508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426535 */     // MIs[1] Operand 1
     /* 1426535 */     // No operand predicates
     /* 1426535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426539 */     // MIs[0] policy
     /* 1426539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426551 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426576 */     // GIR_Coverage, 3211,
     /* 1426576 */     GIR_EraseRootFromParent_Done,
     /* 1426577 */   // Label 20160: @1426577
     /* 1426577 */   GIM_Try, /*On fail goto*//*Label 20161*/ GIMT_Encode4(1426674), // Rule ID 3214 //
     /* 1426582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1426593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1426596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1426599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426632 */     // MIs[1] Operand 1
     /* 1426632 */     // No operand predicates
     /* 1426632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426636 */     // MIs[0] policy
     /* 1426636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426648 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426673 */     // GIR_Coverage, 3214,
     /* 1426673 */     GIR_EraseRootFromParent_Done,
     /* 1426674 */   // Label 20161: @1426674
     /* 1426674 */   GIM_Try, /*On fail goto*//*Label 20162*/ GIMT_Encode4(1426771), // Rule ID 3215 //
     /* 1426679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1426690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1426693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1426696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426729 */     // MIs[1] Operand 1
     /* 1426729 */     // No operand predicates
     /* 1426729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426733 */     // MIs[0] policy
     /* 1426733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426745 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426770 */     // GIR_Coverage, 3215,
     /* 1426770 */     GIR_EraseRootFromParent_Done,
     /* 1426771 */   // Label 20162: @1426771
     /* 1426771 */   GIM_Try, /*On fail goto*//*Label 20163*/ GIMT_Encode4(1426868), // Rule ID 3218 //
     /* 1426776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1426787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1426790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1426793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426826 */     // MIs[1] Operand 1
     /* 1426826 */     // No operand predicates
     /* 1426826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426830 */     // MIs[0] policy
     /* 1426830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426842 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426867 */     // GIR_Coverage, 3218,
     /* 1426867 */     GIR_EraseRootFromParent_Done,
     /* 1426868 */   // Label 20163: @1426868
     /* 1426868 */   GIM_Try, /*On fail goto*//*Label 20164*/ GIMT_Encode4(1426965), // Rule ID 3219 //
     /* 1426873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1426884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1426887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1426890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426923 */     // MIs[1] Operand 1
     /* 1426923 */     // No operand predicates
     /* 1426923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426927 */     // MIs[0] policy
     /* 1426927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426939 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426964 */     // GIR_Coverage, 3219,
     /* 1426964 */     GIR_EraseRootFromParent_Done,
     /* 1426965 */   // Label 20164: @1426965
     /* 1426965 */   GIM_Try, /*On fail goto*//*Label 20165*/ GIMT_Encode4(1427062), // Rule ID 3222 //
     /* 1426970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1426981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1426984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1426987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1426993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427020 */     // MIs[1] Operand 1
     /* 1427020 */     // No operand predicates
     /* 1427020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427024 */     // MIs[0] policy
     /* 1427024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427036 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1427058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427061 */     // GIR_Coverage, 3222,
     /* 1427061 */     GIR_EraseRootFromParent_Done,
     /* 1427062 */   // Label 20165: @1427062
     /* 1427062 */   GIM_Try, /*On fail goto*//*Label 20166*/ GIMT_Encode4(1427159), // Rule ID 3223 //
     /* 1427067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1427078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1427081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1427084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1427090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427117 */     // MIs[1] Operand 1
     /* 1427117 */     // No operand predicates
     /* 1427117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427121 */     // MIs[0] policy
     /* 1427121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427133 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1427155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427158 */     // GIR_Coverage, 3223,
     /* 1427158 */     GIR_EraseRootFromParent_Done,
     /* 1427159 */   // Label 20166: @1427159
     /* 1427159 */   GIM_Try, /*On fail goto*//*Label 20167*/ GIMT_Encode4(1427256), // Rule ID 3226 //
     /* 1427164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1427175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1427178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1427181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427214 */     // MIs[1] Operand 1
     /* 1427214 */     // No operand predicates
     /* 1427214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427218 */     // MIs[0] policy
     /* 1427218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427255 */     // GIR_Coverage, 3226,
     /* 1427255 */     GIR_EraseRootFromParent_Done,
     /* 1427256 */   // Label 20167: @1427256
     /* 1427256 */   GIM_Try, /*On fail goto*//*Label 20168*/ GIMT_Encode4(1427353), // Rule ID 3227 //
     /* 1427261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1427272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1427275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1427278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427311 */     // MIs[1] Operand 1
     /* 1427311 */     // No operand predicates
     /* 1427311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427315 */     // MIs[0] policy
     /* 1427315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427327 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427352 */     // GIR_Coverage, 3227,
     /* 1427352 */     GIR_EraseRootFromParent_Done,
     /* 1427353 */   // Label 20168: @1427353
     /* 1427353 */   GIM_Try, /*On fail goto*//*Label 20169*/ GIMT_Encode4(1427450), // Rule ID 3230 //
     /* 1427358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1427369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1427372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1427375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1427381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427408 */     // MIs[1] Operand 1
     /* 1427408 */     // No operand predicates
     /* 1427408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427412 */     // MIs[0] policy
     /* 1427412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427424 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1427427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427449 */     // GIR_Coverage, 3230,
     /* 1427449 */     GIR_EraseRootFromParent_Done,
     /* 1427450 */   // Label 20169: @1427450
     /* 1427450 */   GIM_Try, /*On fail goto*//*Label 20170*/ GIMT_Encode4(1427547), // Rule ID 3231 //
     /* 1427455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1427466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1427469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1427472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1427478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427505 */     // MIs[1] Operand 1
     /* 1427505 */     // No operand predicates
     /* 1427505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427509 */     // MIs[0] policy
     /* 1427509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1427524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427546 */     // GIR_Coverage, 3231,
     /* 1427546 */     GIR_EraseRootFromParent_Done,
     /* 1427547 */   // Label 20170: @1427547
     /* 1427547 */   GIM_Try, /*On fail goto*//*Label 20171*/ GIMT_Encode4(1427644), // Rule ID 3234 //
     /* 1427552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1427563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1427566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1427569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1427575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427602 */     // MIs[1] Operand 1
     /* 1427602 */     // No operand predicates
     /* 1427602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427606 */     // MIs[0] policy
     /* 1427606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427643 */     // GIR_Coverage, 3234,
     /* 1427643 */     GIR_EraseRootFromParent_Done,
     /* 1427644 */   // Label 20171: @1427644
     /* 1427644 */   GIM_Try, /*On fail goto*//*Label 20172*/ GIMT_Encode4(1427741), // Rule ID 3235 //
     /* 1427649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1427660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1427663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1427666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1427672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427699 */     // MIs[1] Operand 1
     /* 1427699 */     // No operand predicates
     /* 1427699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427703 */     // MIs[0] policy
     /* 1427703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427715 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427740 */     // GIR_Coverage, 3235,
     /* 1427740 */     GIR_EraseRootFromParent_Done,
     /* 1427741 */   // Label 20172: @1427741
     /* 1427741 */   GIM_Try, /*On fail goto*//*Label 20173*/ GIMT_Encode4(1427838), // Rule ID 3238 //
     /* 1427746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1427757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1427760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1427763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427796 */     // MIs[1] Operand 1
     /* 1427796 */     // No operand predicates
     /* 1427796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427800 */     // MIs[0] policy
     /* 1427800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427837 */     // GIR_Coverage, 3238,
     /* 1427837 */     GIR_EraseRootFromParent_Done,
     /* 1427838 */   // Label 20173: @1427838
     /* 1427838 */   GIM_Try, /*On fail goto*//*Label 20174*/ GIMT_Encode4(1427935), // Rule ID 3239 //
     /* 1427843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1427846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1427854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1427857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1427860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427893 */     // MIs[1] Operand 1
     /* 1427893 */     // No operand predicates
     /* 1427893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427897 */     // MIs[0] policy
     /* 1427897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427934 */     // GIR_Coverage, 3239,
     /* 1427934 */     GIR_EraseRootFromParent_Done,
     /* 1427935 */   // Label 20174: @1427935
     /* 1427935 */   GIM_Try, /*On fail goto*//*Label 20175*/ GIMT_Encode4(1428032), // Rule ID 3242 //
     /* 1427940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1427951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1427954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1427957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427990 */     // MIs[1] Operand 1
     /* 1427990 */     // No operand predicates
     /* 1427990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427994 */     // MIs[0] policy
     /* 1427994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428006 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1428009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1428028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428031 */     // GIR_Coverage, 3242,
     /* 1428031 */     GIR_EraseRootFromParent_Done,
     /* 1428032 */   // Label 20175: @1428032
     /* 1428032 */   GIM_Try, /*On fail goto*//*Label 20176*/ GIMT_Encode4(1428129), // Rule ID 3243 //
     /* 1428037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1428040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1428048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1428051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1428054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1428067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428087 */     // MIs[1] Operand 1
     /* 1428087 */     // No operand predicates
     /* 1428087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428091 */     // MIs[0] policy
     /* 1428091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428103 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1428106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1428125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428128 */     // GIR_Coverage, 3243,
     /* 1428128 */     GIR_EraseRootFromParent_Done,
     /* 1428129 */   // Label 20176: @1428129
     /* 1428129 */   GIM_Try, /*On fail goto*//*Label 20177*/ GIMT_Encode4(1428226), // Rule ID 3246 //
     /* 1428134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1428137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1428145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1428148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1428151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1428164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428184 */     // MIs[1] Operand 1
     /* 1428184 */     // No operand predicates
     /* 1428184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428188 */     // MIs[0] policy
     /* 1428188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428200 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1428203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1428222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428225 */     // GIR_Coverage, 3246,
     /* 1428225 */     GIR_EraseRootFromParent_Done,
     /* 1428226 */   // Label 20177: @1428226
     /* 1428226 */   GIM_Try, /*On fail goto*//*Label 20178*/ GIMT_Encode4(1428323), // Rule ID 3247 //
     /* 1428231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1428234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1428242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1428245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1428248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1428261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428281 */     // MIs[1] Operand 1
     /* 1428281 */     // No operand predicates
     /* 1428281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428285 */     // MIs[0] policy
     /* 1428285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428297 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1428300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1428319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428322 */     // GIR_Coverage, 3247,
     /* 1428322 */     GIR_EraseRootFromParent_Done,
     /* 1428323 */   // Label 20178: @1428323
     /* 1428323 */   GIM_Try, /*On fail goto*//*Label 20179*/ GIMT_Encode4(1428420), // Rule ID 3514 //
     /* 1428328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1428339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1428342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1428345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428378 */     // MIs[1] Operand 1
     /* 1428378 */     // No operand predicates
     /* 1428378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428382 */     // MIs[0] policy
     /* 1428382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428394 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1428397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428419 */     // GIR_Coverage, 3514,
     /* 1428419 */     GIR_EraseRootFromParent_Done,
     /* 1428420 */   // Label 20179: @1428420
     /* 1428420 */   GIM_Try, /*On fail goto*//*Label 20180*/ GIMT_Encode4(1428517), // Rule ID 3515 //
     /* 1428425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1428436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1428439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1428442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428475 */     // MIs[1] Operand 1
     /* 1428475 */     // No operand predicates
     /* 1428475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428479 */     // MIs[0] policy
     /* 1428479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428491 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1428494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428516 */     // GIR_Coverage, 3515,
     /* 1428516 */     GIR_EraseRootFromParent_Done,
     /* 1428517 */   // Label 20180: @1428517
     /* 1428517 */   GIM_Try, /*On fail goto*//*Label 20181*/ GIMT_Encode4(1428614), // Rule ID 3518 //
     /* 1428522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1428533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1428536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1428539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428572 */     // MIs[1] Operand 1
     /* 1428572 */     // No operand predicates
     /* 1428572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428576 */     // MIs[0] policy
     /* 1428576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428588 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428613 */     // GIR_Coverage, 3518,
     /* 1428613 */     GIR_EraseRootFromParent_Done,
     /* 1428614 */   // Label 20181: @1428614
     /* 1428614 */   GIM_Try, /*On fail goto*//*Label 20182*/ GIMT_Encode4(1428711), // Rule ID 3519 //
     /* 1428619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1428630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1428633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1428636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428669 */     // MIs[1] Operand 1
     /* 1428669 */     // No operand predicates
     /* 1428669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428673 */     // MIs[0] policy
     /* 1428673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428685 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428710 */     // GIR_Coverage, 3519,
     /* 1428710 */     GIR_EraseRootFromParent_Done,
     /* 1428711 */   // Label 20182: @1428711
     /* 1428711 */   GIM_Try, /*On fail goto*//*Label 20183*/ GIMT_Encode4(1428808), // Rule ID 3522 //
     /* 1428716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1428727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1428730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1428733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428766 */     // MIs[1] Operand 1
     /* 1428766 */     // No operand predicates
     /* 1428766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428770 */     // MIs[0] policy
     /* 1428770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428782 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428807 */     // GIR_Coverage, 3522,
     /* 1428807 */     GIR_EraseRootFromParent_Done,
     /* 1428808 */   // Label 20183: @1428808
     /* 1428808 */   GIM_Try, /*On fail goto*//*Label 20184*/ GIMT_Encode4(1428905), // Rule ID 3523 //
     /* 1428813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1428824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1428827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1428830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428863 */     // MIs[1] Operand 1
     /* 1428863 */     // No operand predicates
     /* 1428863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428867 */     // MIs[0] policy
     /* 1428867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428879 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428904 */     // GIR_Coverage, 3523,
     /* 1428904 */     GIR_EraseRootFromParent_Done,
     /* 1428905 */   // Label 20184: @1428905
     /* 1428905 */   GIM_Try, /*On fail goto*//*Label 20185*/ GIMT_Encode4(1429002), // Rule ID 3526 //
     /* 1428910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1428921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1428924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1428927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428960 */     // MIs[1] Operand 1
     /* 1428960 */     // No operand predicates
     /* 1428960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428964 */     // MIs[0] policy
     /* 1428964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429001 */     // GIR_Coverage, 3526,
     /* 1429001 */     GIR_EraseRootFromParent_Done,
     /* 1429002 */   // Label 20185: @1429002
     /* 1429002 */   GIM_Try, /*On fail goto*//*Label 20186*/ GIMT_Encode4(1429099), // Rule ID 3527 //
     /* 1429007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1429018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1429021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1429024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429057 */     // MIs[1] Operand 1
     /* 1429057 */     // No operand predicates
     /* 1429057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429061 */     // MIs[0] policy
     /* 1429061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429073 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1429076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429098 */     // GIR_Coverage, 3527,
     /* 1429098 */     GIR_EraseRootFromParent_Done,
     /* 1429099 */   // Label 20186: @1429099
     /* 1429099 */   GIM_Try, /*On fail goto*//*Label 20187*/ GIMT_Encode4(1429196), // Rule ID 3530 //
     /* 1429104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1429115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1429118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1429121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429154 */     // MIs[1] Operand 1
     /* 1429154 */     // No operand predicates
     /* 1429154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429158 */     // MIs[0] policy
     /* 1429158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429170 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1429173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429195 */     // GIR_Coverage, 3530,
     /* 1429195 */     GIR_EraseRootFromParent_Done,
     /* 1429196 */   // Label 20187: @1429196
     /* 1429196 */   GIM_Try, /*On fail goto*//*Label 20188*/ GIMT_Encode4(1429293), // Rule ID 3531 //
     /* 1429201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1429212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1429215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1429218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429251 */     // MIs[1] Operand 1
     /* 1429251 */     // No operand predicates
     /* 1429251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429255 */     // MIs[0] policy
     /* 1429255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429267 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1429270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429292 */     // GIR_Coverage, 3531,
     /* 1429292 */     GIR_EraseRootFromParent_Done,
     /* 1429293 */   // Label 20188: @1429293
     /* 1429293 */   GIM_Try, /*On fail goto*//*Label 20189*/ GIMT_Encode4(1429390), // Rule ID 3534 //
     /* 1429298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1429309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1429312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1429315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429348 */     // MIs[1] Operand 1
     /* 1429348 */     // No operand predicates
     /* 1429348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429352 */     // MIs[0] policy
     /* 1429352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429364 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1429367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429389 */     // GIR_Coverage, 3534,
     /* 1429389 */     GIR_EraseRootFromParent_Done,
     /* 1429390 */   // Label 20189: @1429390
     /* 1429390 */   GIM_Try, /*On fail goto*//*Label 20190*/ GIMT_Encode4(1429487), // Rule ID 3535 //
     /* 1429395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1429406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1429409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1429412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429445 */     // MIs[1] Operand 1
     /* 1429445 */     // No operand predicates
     /* 1429445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429449 */     // MIs[0] policy
     /* 1429449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429461 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1429464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429486 */     // GIR_Coverage, 3535,
     /* 1429486 */     GIR_EraseRootFromParent_Done,
     /* 1429487 */   // Label 20190: @1429487
     /* 1429487 */   GIM_Try, /*On fail goto*//*Label 20191*/ GIMT_Encode4(1429584), // Rule ID 3538 //
     /* 1429492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1429503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1429506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1429509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429542 */     // MIs[1] Operand 1
     /* 1429542 */     // No operand predicates
     /* 1429542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429546 */     // MIs[0] policy
     /* 1429546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429558 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429583 */     // GIR_Coverage, 3538,
     /* 1429583 */     GIR_EraseRootFromParent_Done,
     /* 1429584 */   // Label 20191: @1429584
     /* 1429584 */   GIM_Try, /*On fail goto*//*Label 20192*/ GIMT_Encode4(1429681), // Rule ID 3539 //
     /* 1429589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1429600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1429603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1429606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429639 */     // MIs[1] Operand 1
     /* 1429639 */     // No operand predicates
     /* 1429639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429643 */     // MIs[0] policy
     /* 1429643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429655 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429680 */     // GIR_Coverage, 3539,
     /* 1429680 */     GIR_EraseRootFromParent_Done,
     /* 1429681 */   // Label 20192: @1429681
     /* 1429681 */   GIM_Try, /*On fail goto*//*Label 20193*/ GIMT_Encode4(1429778), // Rule ID 3542 //
     /* 1429686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1429697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1429700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1429703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1429709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429736 */     // MIs[1] Operand 1
     /* 1429736 */     // No operand predicates
     /* 1429736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429740 */     // MIs[0] policy
     /* 1429740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429777 */     // GIR_Coverage, 3542,
     /* 1429777 */     GIR_EraseRootFromParent_Done,
     /* 1429778 */   // Label 20193: @1429778
     /* 1429778 */   GIM_Try, /*On fail goto*//*Label 20194*/ GIMT_Encode4(1429875), // Rule ID 3543 //
     /* 1429783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1429794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1429797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1429800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1429806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429833 */     // MIs[1] Operand 1
     /* 1429833 */     // No operand predicates
     /* 1429833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429837 */     // MIs[0] policy
     /* 1429837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429849 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429874 */     // GIR_Coverage, 3543,
     /* 1429874 */     GIR_EraseRootFromParent_Done,
     /* 1429875 */   // Label 20194: @1429875
     /* 1429875 */   GIM_Try, /*On fail goto*//*Label 20195*/ GIMT_Encode4(1429972), // Rule ID 3546 //
     /* 1429880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1429891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1429894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1429897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429930 */     // MIs[1] Operand 1
     /* 1429930 */     // No operand predicates
     /* 1429930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429934 */     // MIs[0] policy
     /* 1429934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429971 */     // GIR_Coverage, 3546,
     /* 1429971 */     GIR_EraseRootFromParent_Done,
     /* 1429972 */   // Label 20195: @1429972
     /* 1429972 */   GIM_Try, /*On fail goto*//*Label 20196*/ GIMT_Encode4(1430069), // Rule ID 3547 //
     /* 1429977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1429988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1429991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1429994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1430000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430027 */     // MIs[1] Operand 1
     /* 1430027 */     // No operand predicates
     /* 1430027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430031 */     // MIs[0] policy
     /* 1430031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430043 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1430046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1430065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430068 */     // GIR_Coverage, 3547,
     /* 1430068 */     GIR_EraseRootFromParent_Done,
     /* 1430069 */   // Label 20196: @1430069
     /* 1430069 */   GIM_Try, /*On fail goto*//*Label 20197*/ GIMT_Encode4(1430166), // Rule ID 3550 //
     /* 1430074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1430077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1430085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1430088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1430091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430124 */     // MIs[1] Operand 1
     /* 1430124 */     // No operand predicates
     /* 1430124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430128 */     // MIs[0] policy
     /* 1430128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1430143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1430162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430165 */     // GIR_Coverage, 3550,
     /* 1430165 */     GIR_EraseRootFromParent_Done,
     /* 1430166 */   // Label 20197: @1430166
     /* 1430166 */   GIM_Try, /*On fail goto*//*Label 20198*/ GIMT_Encode4(1430263), // Rule ID 3551 //
     /* 1430171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1430174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1430182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1430185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1430188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430221 */     // MIs[1] Operand 1
     /* 1430221 */     // No operand predicates
     /* 1430221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430225 */     // MIs[0] policy
     /* 1430225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430237 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1430240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1430259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430262 */     // GIR_Coverage, 3551,
     /* 1430262 */     GIR_EraseRootFromParent_Done,
     /* 1430263 */   // Label 20198: @1430263
     /* 1430263 */   GIM_Try, /*On fail goto*//*Label 20199*/ GIMT_Encode4(1430360), // Rule ID 3554 //
     /* 1430268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1430279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1430282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1430285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1430291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430318 */     // MIs[1] Operand 1
     /* 1430318 */     // No operand predicates
     /* 1430318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430322 */     // MIs[0] policy
     /* 1430322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430334 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1430337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430359 */     // GIR_Coverage, 3554,
     /* 1430359 */     GIR_EraseRootFromParent_Done,
     /* 1430360 */   // Label 20199: @1430360
     /* 1430360 */   GIM_Try, /*On fail goto*//*Label 20200*/ GIMT_Encode4(1430457), // Rule ID 3555 //
     /* 1430365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1430376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1430379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1430382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1430388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430415 */     // MIs[1] Operand 1
     /* 1430415 */     // No operand predicates
     /* 1430415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430419 */     // MIs[0] policy
     /* 1430419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430431 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1430434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430456 */     // GIR_Coverage, 3555,
     /* 1430456 */     GIR_EraseRootFromParent_Done,
     /* 1430457 */   // Label 20200: @1430457
     /* 1430457 */   GIM_Try, /*On fail goto*//*Label 20201*/ GIMT_Encode4(1430554), // Rule ID 3558 //
     /* 1430462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1430473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1430476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1430479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430512 */     // MIs[1] Operand 1
     /* 1430512 */     // No operand predicates
     /* 1430512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430516 */     // MIs[0] policy
     /* 1430516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430528 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1430531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430553 */     // GIR_Coverage, 3558,
     /* 1430553 */     GIR_EraseRootFromParent_Done,
     /* 1430554 */   // Label 20201: @1430554
     /* 1430554 */   GIM_Try, /*On fail goto*//*Label 20202*/ GIMT_Encode4(1430651), // Rule ID 3559 //
     /* 1430559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1430570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1430573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1430576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430609 */     // MIs[1] Operand 1
     /* 1430609 */     // No operand predicates
     /* 1430609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430613 */     // MIs[0] policy
     /* 1430613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430625 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1430628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430650 */     // GIR_Coverage, 3559,
     /* 1430650 */     GIR_EraseRootFromParent_Done,
     /* 1430651 */   // Label 20202: @1430651
     /* 1430651 */   GIM_Try, /*On fail goto*//*Label 20203*/ GIMT_Encode4(1430748), // Rule ID 3562 //
     /* 1430656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1430667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1430670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1430673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1430679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430706 */     // MIs[1] Operand 1
     /* 1430706 */     // No operand predicates
     /* 1430706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430710 */     // MIs[0] policy
     /* 1430710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430722 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1430725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430747 */     // GIR_Coverage, 3562,
     /* 1430747 */     GIR_EraseRootFromParent_Done,
     /* 1430748 */   // Label 20203: @1430748
     /* 1430748 */   GIM_Try, /*On fail goto*//*Label 20204*/ GIMT_Encode4(1430845), // Rule ID 3563 //
     /* 1430753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1430764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1430767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1430770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1430776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430803 */     // MIs[1] Operand 1
     /* 1430803 */     // No operand predicates
     /* 1430803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430807 */     // MIs[0] policy
     /* 1430807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430819 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1430822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430844 */     // GIR_Coverage, 3563,
     /* 1430844 */     GIR_EraseRootFromParent_Done,
     /* 1430845 */   // Label 20204: @1430845
     /* 1430845 */   GIM_Try, /*On fail goto*//*Label 20205*/ GIMT_Encode4(1430942), // Rule ID 3566 //
     /* 1430850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1430861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1430864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1430867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1430873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430900 */     // MIs[1] Operand 1
     /* 1430900 */     // No operand predicates
     /* 1430900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430904 */     // MIs[0] policy
     /* 1430904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1430919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430941 */     // GIR_Coverage, 3566,
     /* 1430941 */     GIR_EraseRootFromParent_Done,
     /* 1430942 */   // Label 20205: @1430942
     /* 1430942 */   GIM_Try, /*On fail goto*//*Label 20206*/ GIMT_Encode4(1431039), // Rule ID 3567 //
     /* 1430947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1430958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1430961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1430964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1430970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430997 */     // MIs[1] Operand 1
     /* 1430997 */     // No operand predicates
     /* 1430997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431001 */     // MIs[0] policy
     /* 1431001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431013 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431038 */     // GIR_Coverage, 3567,
     /* 1431038 */     GIR_EraseRootFromParent_Done,
     /* 1431039 */   // Label 20206: @1431039
     /* 1431039 */   GIM_Try, /*On fail goto*//*Label 20207*/ GIMT_Encode4(1431136), // Rule ID 3570 //
     /* 1431044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1431055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1431058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1431061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431094 */     // MIs[1] Operand 1
     /* 1431094 */     // No operand predicates
     /* 1431094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431098 */     // MIs[0] policy
     /* 1431098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431110 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431135 */     // GIR_Coverage, 3570,
     /* 1431135 */     GIR_EraseRootFromParent_Done,
     /* 1431136 */   // Label 20207: @1431136
     /* 1431136 */   GIM_Try, /*On fail goto*//*Label 20208*/ GIMT_Encode4(1431233), // Rule ID 3571 //
     /* 1431141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1431152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1431155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1431158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431191 */     // MIs[1] Operand 1
     /* 1431191 */     // No operand predicates
     /* 1431191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431195 */     // MIs[0] policy
     /* 1431195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431207 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431232 */     // GIR_Coverage, 3571,
     /* 1431232 */     GIR_EraseRootFromParent_Done,
     /* 1431233 */   // Label 20208: @1431233
     /* 1431233 */   GIM_Try, /*On fail goto*//*Label 20209*/ GIMT_Encode4(1431330), // Rule ID 3574 //
     /* 1431238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1431249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1431252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1431255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1431261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431288 */     // MIs[1] Operand 1
     /* 1431288 */     // No operand predicates
     /* 1431288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431292 */     // MIs[0] policy
     /* 1431292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431304 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431329 */     // GIR_Coverage, 3574,
     /* 1431329 */     GIR_EraseRootFromParent_Done,
     /* 1431330 */   // Label 20209: @1431330
     /* 1431330 */   GIM_Try, /*On fail goto*//*Label 20210*/ GIMT_Encode4(1431427), // Rule ID 3575 //
     /* 1431335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1431346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1431349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1431352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1431358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431385 */     // MIs[1] Operand 1
     /* 1431385 */     // No operand predicates
     /* 1431385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431389 */     // MIs[0] policy
     /* 1431389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431401 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431426 */     // GIR_Coverage, 3575,
     /* 1431426 */     GIR_EraseRootFromParent_Done,
     /* 1431427 */   // Label 20210: @1431427
     /* 1431427 */   GIM_Try, /*On fail goto*//*Label 20211*/ GIMT_Encode4(1431524), // Rule ID 3578 //
     /* 1431432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1431443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1431446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1431449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431482 */     // MIs[1] Operand 1
     /* 1431482 */     // No operand predicates
     /* 1431482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431486 */     // MIs[0] policy
     /* 1431486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431498 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431523 */     // GIR_Coverage, 3578,
     /* 1431523 */     GIR_EraseRootFromParent_Done,
     /* 1431524 */   // Label 20211: @1431524
     /* 1431524 */   GIM_Try, /*On fail goto*//*Label 20212*/ GIMT_Encode4(1431621), // Rule ID 3579 //
     /* 1431529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1431540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1431543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1431546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431579 */     // MIs[1] Operand 1
     /* 1431579 */     // No operand predicates
     /* 1431579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431583 */     // MIs[0] policy
     /* 1431583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431595 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431620 */     // GIR_Coverage, 3579,
     /* 1431620 */     GIR_EraseRootFromParent_Done,
     /* 1431621 */   // Label 20212: @1431621
     /* 1431621 */   GIM_Try, /*On fail goto*//*Label 20213*/ GIMT_Encode4(1431718), // Rule ID 3582 //
     /* 1431626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1431637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1431640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1431643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431676 */     // MIs[1] Operand 1
     /* 1431676 */     // No operand predicates
     /* 1431676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431680 */     // MIs[0] policy
     /* 1431680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431692 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431717 */     // GIR_Coverage, 3582,
     /* 1431717 */     GIR_EraseRootFromParent_Done,
     /* 1431718 */   // Label 20213: @1431718
     /* 1431718 */   GIM_Try, /*On fail goto*//*Label 20214*/ GIMT_Encode4(1431815), // Rule ID 3583 //
     /* 1431723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1431734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1431737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1431740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431773 */     // MIs[1] Operand 1
     /* 1431773 */     // No operand predicates
     /* 1431773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431777 */     // MIs[0] policy
     /* 1431777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431789 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431814 */     // GIR_Coverage, 3583,
     /* 1431814 */     GIR_EraseRootFromParent_Done,
     /* 1431815 */   // Label 20214: @1431815
     /* 1431815 */   GIM_Try, /*On fail goto*//*Label 20215*/ GIMT_Encode4(1431912), // Rule ID 3586 //
     /* 1431820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1431831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1431834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1431837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431870 */     // MIs[1] Operand 1
     /* 1431870 */     // No operand predicates
     /* 1431870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431874 */     // MIs[0] policy
     /* 1431874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431886 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431911 */     // GIR_Coverage, 3586,
     /* 1431911 */     GIR_EraseRootFromParent_Done,
     /* 1431912 */   // Label 20215: @1431912
     /* 1431912 */   GIM_Try, /*On fail goto*//*Label 20216*/ GIMT_Encode4(1432009), // Rule ID 3587 //
     /* 1431917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1431928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1431931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1431934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431967 */     // MIs[1] Operand 1
     /* 1431967 */     // No operand predicates
     /* 1431967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431971 */     // MIs[0] policy
     /* 1431971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431983 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1432005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432008 */     // GIR_Coverage, 3587,
     /* 1432008 */     GIR_EraseRootFromParent_Done,
     /* 1432009 */   // Label 20216: @1432009
     /* 1432009 */   GIM_Try, /*On fail goto*//*Label 20217*/ GIMT_Encode4(1432106), // Rule ID 3590 //
     /* 1432014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1432017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1432025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1432028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1432031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1432044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432064 */     // MIs[1] Operand 1
     /* 1432064 */     // No operand predicates
     /* 1432064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432068 */     // MIs[0] policy
     /* 1432068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1432083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432105 */     // GIR_Coverage, 3590,
     /* 1432105 */     GIR_EraseRootFromParent_Done,
     /* 1432106 */   // Label 20217: @1432106
     /* 1432106 */   GIM_Try, /*On fail goto*//*Label 20218*/ GIMT_Encode4(1432203), // Rule ID 3591 //
     /* 1432111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1432114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1432122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1432125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1432128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1432141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432161 */     // MIs[1] Operand 1
     /* 1432161 */     // No operand predicates
     /* 1432161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432165 */     // MIs[0] policy
     /* 1432165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1432180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432202 */     // GIR_Coverage, 3591,
     /* 1432202 */     GIR_EraseRootFromParent_Done,
     /* 1432203 */   // Label 20218: @1432203
     /* 1432203 */   GIM_Try, /*On fail goto*//*Label 20219*/ GIMT_Encode4(1432300), // Rule ID 3594 //
     /* 1432208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1432211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1432219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1432222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1432225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1432231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1432238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432258 */     // MIs[1] Operand 1
     /* 1432258 */     // No operand predicates
     /* 1432258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432262 */     // MIs[0] policy
     /* 1432262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432274 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1432277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432299 */     // GIR_Coverage, 3594,
     /* 1432299 */     GIR_EraseRootFromParent_Done,
     /* 1432300 */   // Label 20219: @1432300
     /* 1432300 */   GIM_Try, /*On fail goto*//*Label 20220*/ GIMT_Encode4(1432397), // Rule ID 3595 //
     /* 1432305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1432308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1432316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1432319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1432322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1432328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1432335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432355 */     // MIs[1] Operand 1
     /* 1432355 */     // No operand predicates
     /* 1432355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432359 */     // MIs[0] policy
     /* 1432359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432371 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1432374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432396 */     // GIR_Coverage, 3595,
     /* 1432396 */     GIR_EraseRootFromParent_Done,
     /* 1432397 */   // Label 20220: @1432397
     /* 1432397 */   GIM_Try, /*On fail goto*//*Label 20221*/ GIMT_Encode4(1432494), // Rule ID 3598 //
     /* 1432402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1432405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1432413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1432416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1432419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1432425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432452 */     // MIs[1] Operand 1
     /* 1432452 */     // No operand predicates
     /* 1432452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432456 */     // MIs[0] policy
     /* 1432456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1432471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432493 */     // GIR_Coverage, 3598,
     /* 1432493 */     GIR_EraseRootFromParent_Done,
     /* 1432494 */   // Label 20221: @1432494
     /* 1432494 */   GIM_Try, /*On fail goto*//*Label 20222*/ GIMT_Encode4(1432591), // Rule ID 3599 //
     /* 1432499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1432502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1432510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1432513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1432516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1432522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432549 */     // MIs[1] Operand 1
     /* 1432549 */     // No operand predicates
     /* 1432549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432553 */     // MIs[0] policy
     /* 1432553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432565 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1432568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432590 */     // GIR_Coverage, 3599,
     /* 1432590 */     GIR_EraseRootFromParent_Done,
     /* 1432591 */   // Label 20222: @1432591
     /* 1432591 */   GIM_Try, /*On fail goto*//*Label 20223*/ GIMT_Encode4(1432688), // Rule ID 5962 //
     /* 1432596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1432607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1432610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1432613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432646 */     // MIs[1] Operand 1
     /* 1432646 */     // No operand predicates
     /* 1432646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432650 */     // MIs[0] policy
     /* 1432650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432662 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1432665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432687 */     // GIR_Coverage, 5962,
     /* 1432687 */     GIR_EraseRootFromParent_Done,
     /* 1432688 */   // Label 20223: @1432688
     /* 1432688 */   GIM_Try, /*On fail goto*//*Label 20224*/ GIMT_Encode4(1432785), // Rule ID 5963 //
     /* 1432693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1432704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1432707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1432710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432743 */     // MIs[1] Operand 1
     /* 1432743 */     // No operand predicates
     /* 1432743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432747 */     // MIs[0] policy
     /* 1432747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432759 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1432762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432784 */     // GIR_Coverage, 5963,
     /* 1432784 */     GIR_EraseRootFromParent_Done,
     /* 1432785 */   // Label 20224: @1432785
     /* 1432785 */   GIM_Try, /*On fail goto*//*Label 20225*/ GIMT_Encode4(1432882), // Rule ID 5966 //
     /* 1432790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1432801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1432804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1432807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432840 */     // MIs[1] Operand 1
     /* 1432840 */     // No operand predicates
     /* 1432840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432844 */     // MIs[0] policy
     /* 1432844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432856 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1432859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432881 */     // GIR_Coverage, 5966,
     /* 1432881 */     GIR_EraseRootFromParent_Done,
     /* 1432882 */   // Label 20225: @1432882
     /* 1432882 */   GIM_Try, /*On fail goto*//*Label 20226*/ GIMT_Encode4(1432979), // Rule ID 5967 //
     /* 1432887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1432898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1432901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1432904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432937 */     // MIs[1] Operand 1
     /* 1432937 */     // No operand predicates
     /* 1432937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432941 */     // MIs[0] policy
     /* 1432941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432953 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1432956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432978 */     // GIR_Coverage, 5967,
     /* 1432978 */     GIR_EraseRootFromParent_Done,
     /* 1432979 */   // Label 20226: @1432979
     /* 1432979 */   GIM_Try, /*On fail goto*//*Label 20227*/ GIMT_Encode4(1433076), // Rule ID 5970 //
     /* 1432984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1432995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1432998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1433001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433034 */     // MIs[1] Operand 1
     /* 1433034 */     // No operand predicates
     /* 1433034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433038 */     // MIs[0] policy
     /* 1433038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433050 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433075 */     // GIR_Coverage, 5970,
     /* 1433075 */     GIR_EraseRootFromParent_Done,
     /* 1433076 */   // Label 20227: @1433076
     /* 1433076 */   GIM_Try, /*On fail goto*//*Label 20228*/ GIMT_Encode4(1433173), // Rule ID 5971 //
     /* 1433081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1433092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1433095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1433098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433131 */     // MIs[1] Operand 1
     /* 1433131 */     // No operand predicates
     /* 1433131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433135 */     // MIs[0] policy
     /* 1433135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433147 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433172 */     // GIR_Coverage, 5971,
     /* 1433172 */     GIR_EraseRootFromParent_Done,
     /* 1433173 */   // Label 20228: @1433173
     /* 1433173 */   GIM_Try, /*On fail goto*//*Label 20229*/ GIMT_Encode4(1433270), // Rule ID 5974 //
     /* 1433178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1433189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1433192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1433195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433228 */     // MIs[1] Operand 1
     /* 1433228 */     // No operand predicates
     /* 1433228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433232 */     // MIs[0] policy
     /* 1433232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433244 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1433247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433269 */     // GIR_Coverage, 5974,
     /* 1433269 */     GIR_EraseRootFromParent_Done,
     /* 1433270 */   // Label 20229: @1433270
     /* 1433270 */   GIM_Try, /*On fail goto*//*Label 20230*/ GIMT_Encode4(1433367), // Rule ID 5975 //
     /* 1433275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1433286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1433289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1433292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433325 */     // MIs[1] Operand 1
     /* 1433325 */     // No operand predicates
     /* 1433325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433329 */     // MIs[0] policy
     /* 1433329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433341 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1433344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433366 */     // GIR_Coverage, 5975,
     /* 1433366 */     GIR_EraseRootFromParent_Done,
     /* 1433367 */   // Label 20230: @1433367
     /* 1433367 */   GIM_Try, /*On fail goto*//*Label 20231*/ GIMT_Encode4(1433464), // Rule ID 5978 //
     /* 1433372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1433383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1433386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1433389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433422 */     // MIs[1] Operand 1
     /* 1433422 */     // No operand predicates
     /* 1433422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433426 */     // MIs[0] policy
     /* 1433426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433438 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433463 */     // GIR_Coverage, 5978,
     /* 1433463 */     GIR_EraseRootFromParent_Done,
     /* 1433464 */   // Label 20231: @1433464
     /* 1433464 */   GIM_Try, /*On fail goto*//*Label 20232*/ GIMT_Encode4(1433561), // Rule ID 5979 //
     /* 1433469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1433480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1433483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1433486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433519 */     // MIs[1] Operand 1
     /* 1433519 */     // No operand predicates
     /* 1433519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433523 */     // MIs[0] policy
     /* 1433523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433535 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433560 */     // GIR_Coverage, 5979,
     /* 1433560 */     GIR_EraseRootFromParent_Done,
     /* 1433561 */   // Label 20232: @1433561
     /* 1433561 */   GIM_Try, /*On fail goto*//*Label 20233*/ GIMT_Encode4(1433658), // Rule ID 5982 //
     /* 1433566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1433577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1433580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1433583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433616 */     // MIs[1] Operand 1
     /* 1433616 */     // No operand predicates
     /* 1433616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433620 */     // MIs[0] policy
     /* 1433620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433632 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433657 */     // GIR_Coverage, 5982,
     /* 1433657 */     GIR_EraseRootFromParent_Done,
     /* 1433658 */   // Label 20233: @1433658
     /* 1433658 */   GIM_Try, /*On fail goto*//*Label 20234*/ GIMT_Encode4(1433755), // Rule ID 5983 //
     /* 1433663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1433674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1433677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1433680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433713 */     // MIs[1] Operand 1
     /* 1433713 */     // No operand predicates
     /* 1433713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433717 */     // MIs[0] policy
     /* 1433717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433729 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433754 */     // GIR_Coverage, 5983,
     /* 1433754 */     GIR_EraseRootFromParent_Done,
     /* 1433755 */   // Label 20234: @1433755
     /* 1433755 */   GIM_Try, /*On fail goto*//*Label 20235*/ GIMT_Encode4(1433852), // Rule ID 5986 //
     /* 1433760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1433771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1433774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1433777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433810 */     // MIs[1] Operand 1
     /* 1433810 */     // No operand predicates
     /* 1433810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433814 */     // MIs[0] policy
     /* 1433814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433851 */     // GIR_Coverage, 5986,
     /* 1433851 */     GIR_EraseRootFromParent_Done,
     /* 1433852 */   // Label 20235: @1433852
     /* 1433852 */   GIM_Try, /*On fail goto*//*Label 20236*/ GIMT_Encode4(1433949), // Rule ID 5987 //
     /* 1433857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1433868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1433871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1433874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433907 */     // MIs[1] Operand 1
     /* 1433907 */     // No operand predicates
     /* 1433907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433911 */     // MIs[0] policy
     /* 1433911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433923 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433948 */     // GIR_Coverage, 5987,
     /* 1433948 */     GIR_EraseRootFromParent_Done,
     /* 1433949 */   // Label 20236: @1433949
     /* 1433949 */   GIM_Try, /*On fail goto*//*Label 20237*/ GIMT_Encode4(1434046), // Rule ID 5990 //
     /* 1433954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1433965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1433968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1433971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434004 */     // MIs[1] Operand 1
     /* 1434004 */     // No operand predicates
     /* 1434004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434008 */     // MIs[0] policy
     /* 1434008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434045 */     // GIR_Coverage, 5990,
     /* 1434045 */     GIR_EraseRootFromParent_Done,
     /* 1434046 */   // Label 20237: @1434046
     /* 1434046 */   GIM_Try, /*On fail goto*//*Label 20238*/ GIMT_Encode4(1434143), // Rule ID 5991 //
     /* 1434051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1434062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1434065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1434068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1434074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434101 */     // MIs[1] Operand 1
     /* 1434101 */     // No operand predicates
     /* 1434101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434105 */     // MIs[0] policy
     /* 1434105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434117 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434142 */     // GIR_Coverage, 5991,
     /* 1434142 */     GIR_EraseRootFromParent_Done,
     /* 1434143 */   // Label 20238: @1434143
     /* 1434143 */   GIM_Try, /*On fail goto*//*Label 20239*/ GIMT_Encode4(1434240), // Rule ID 5994 //
     /* 1434148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1434159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1434162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1434165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1434171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434198 */     // MIs[1] Operand 1
     /* 1434198 */     // No operand predicates
     /* 1434198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434202 */     // MIs[0] policy
     /* 1434202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434214 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1434236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434239 */     // GIR_Coverage, 5994,
     /* 1434239 */     GIR_EraseRootFromParent_Done,
     /* 1434240 */   // Label 20239: @1434240
     /* 1434240 */   GIM_Try, /*On fail goto*//*Label 20240*/ GIMT_Encode4(1434337), // Rule ID 5995 //
     /* 1434245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1434256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1434259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1434262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1434268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434295 */     // MIs[1] Operand 1
     /* 1434295 */     // No operand predicates
     /* 1434295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434299 */     // MIs[0] policy
     /* 1434299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434311 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1434333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434336 */     // GIR_Coverage, 5995,
     /* 1434336 */     GIR_EraseRootFromParent_Done,
     /* 1434337 */   // Label 20240: @1434337
     /* 1434337 */   GIM_Try, /*On fail goto*//*Label 20241*/ GIMT_Encode4(1434434), // Rule ID 5998 //
     /* 1434342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1434345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1434353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1434356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1434359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434392 */     // MIs[1] Operand 1
     /* 1434392 */     // No operand predicates
     /* 1434392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434396 */     // MIs[0] policy
     /* 1434396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1434430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434433 */     // GIR_Coverage, 5998,
     /* 1434433 */     GIR_EraseRootFromParent_Done,
     /* 1434434 */   // Label 20241: @1434434
     /* 1434434 */   GIM_Try, /*On fail goto*//*Label 20242*/ GIMT_Encode4(1434531), // Rule ID 5999 //
     /* 1434439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1434442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1434450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1434453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1434456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434489 */     // MIs[1] Operand 1
     /* 1434489 */     // No operand predicates
     /* 1434489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434493 */     // MIs[0] policy
     /* 1434493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434505 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1434527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434530 */     // GIR_Coverage, 5999,
     /* 1434530 */     GIR_EraseRootFromParent_Done,
     /* 1434531 */   // Label 20242: @1434531
     /* 1434531 */   GIM_Try, /*On fail goto*//*Label 20243*/ GIMT_Encode4(1434628), // Rule ID 6002 //
     /* 1434536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1434547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1434550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1434553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434586 */     // MIs[1] Operand 1
     /* 1434586 */     // No operand predicates
     /* 1434586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434590 */     // MIs[0] policy
     /* 1434590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434602 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1434605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434627 */     // GIR_Coverage, 6002,
     /* 1434627 */     GIR_EraseRootFromParent_Done,
     /* 1434628 */   // Label 20243: @1434628
     /* 1434628 */   GIM_Try, /*On fail goto*//*Label 20244*/ GIMT_Encode4(1434725), // Rule ID 6003 //
     /* 1434633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1434644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1434647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1434650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434683 */     // MIs[1] Operand 1
     /* 1434683 */     // No operand predicates
     /* 1434683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434687 */     // MIs[0] policy
     /* 1434687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434699 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1434702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434724 */     // GIR_Coverage, 6003,
     /* 1434724 */     GIR_EraseRootFromParent_Done,
     /* 1434725 */   // Label 20244: @1434725
     /* 1434725 */   GIM_Try, /*On fail goto*//*Label 20245*/ GIMT_Encode4(1434822), // Rule ID 6006 //
     /* 1434730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1434741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1434744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1434747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1434753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434780 */     // MIs[1] Operand 1
     /* 1434780 */     // No operand predicates
     /* 1434780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434784 */     // MIs[0] policy
     /* 1434784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434796 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1434799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434821 */     // GIR_Coverage, 6006,
     /* 1434821 */     GIR_EraseRootFromParent_Done,
     /* 1434822 */   // Label 20245: @1434822
     /* 1434822 */   GIM_Try, /*On fail goto*//*Label 20246*/ GIMT_Encode4(1434919), // Rule ID 6007 //
     /* 1434827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1434838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1434841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1434844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1434850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434877 */     // MIs[1] Operand 1
     /* 1434877 */     // No operand predicates
     /* 1434877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434881 */     // MIs[0] policy
     /* 1434881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434893 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1434896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434918 */     // GIR_Coverage, 6007,
     /* 1434918 */     GIR_EraseRootFromParent_Done,
     /* 1434919 */   // Label 20246: @1434919
     /* 1434919 */   GIM_Try, /*On fail goto*//*Label 20247*/ GIMT_Encode4(1435016), // Rule ID 6010 //
     /* 1434924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1434935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1434938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1434941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1434947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1434954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434974 */     // MIs[1] Operand 1
     /* 1434974 */     // No operand predicates
     /* 1434974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434978 */     // MIs[0] policy
     /* 1434978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434990 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1434993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1435012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435015 */     // GIR_Coverage, 6010,
     /* 1435015 */     GIR_EraseRootFromParent_Done,
     /* 1435016 */   // Label 20247: @1435016
     /* 1435016 */   GIM_Try, /*On fail goto*//*Label 20248*/ GIMT_Encode4(1435113), // Rule ID 6011 //
     /* 1435021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1435032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1435035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1435038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1435044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435071 */     // MIs[1] Operand 1
     /* 1435071 */     // No operand predicates
     /* 1435071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435075 */     // MIs[0] policy
     /* 1435075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435087 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1435109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435112 */     // GIR_Coverage, 6011,
     /* 1435112 */     GIR_EraseRootFromParent_Done,
     /* 1435113 */   // Label 20248: @1435113
     /* 1435113 */   GIM_Try, /*On fail goto*//*Label 20249*/ GIMT_Encode4(1435210), // Rule ID 6014 //
     /* 1435118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1435129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1435132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1435135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435168 */     // MIs[1] Operand 1
     /* 1435168 */     // No operand predicates
     /* 1435168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435172 */     // MIs[0] policy
     /* 1435172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435209 */     // GIR_Coverage, 6014,
     /* 1435209 */     GIR_EraseRootFromParent_Done,
     /* 1435210 */   // Label 20249: @1435210
     /* 1435210 */   GIM_Try, /*On fail goto*//*Label 20250*/ GIMT_Encode4(1435307), // Rule ID 6015 //
     /* 1435215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1435226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1435229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1435232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435265 */     // MIs[1] Operand 1
     /* 1435265 */     // No operand predicates
     /* 1435265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435269 */     // MIs[0] policy
     /* 1435269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435281 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435306 */     // GIR_Coverage, 6015,
     /* 1435306 */     GIR_EraseRootFromParent_Done,
     /* 1435307 */   // Label 20250: @1435307
     /* 1435307 */   GIM_Try, /*On fail goto*//*Label 20251*/ GIMT_Encode4(1435404), // Rule ID 6018 //
     /* 1435312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1435323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1435326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1435329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1435335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435362 */     // MIs[1] Operand 1
     /* 1435362 */     // No operand predicates
     /* 1435362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435366 */     // MIs[0] policy
     /* 1435366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435378 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1435381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435403 */     // GIR_Coverage, 6018,
     /* 1435403 */     GIR_EraseRootFromParent_Done,
     /* 1435404 */   // Label 20251: @1435404
     /* 1435404 */   GIM_Try, /*On fail goto*//*Label 20252*/ GIMT_Encode4(1435501), // Rule ID 6019 //
     /* 1435409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1435420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1435423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1435426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1435432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435459 */     // MIs[1] Operand 1
     /* 1435459 */     // No operand predicates
     /* 1435459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435463 */     // MIs[0] policy
     /* 1435463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435475 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1435478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435500 */     // GIR_Coverage, 6019,
     /* 1435500 */     GIR_EraseRootFromParent_Done,
     /* 1435501 */   // Label 20252: @1435501
     /* 1435501 */   GIM_Try, /*On fail goto*//*Label 20253*/ GIMT_Encode4(1435598), // Rule ID 6022 //
     /* 1435506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1435517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1435520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1435523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1435529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435556 */     // MIs[1] Operand 1
     /* 1435556 */     // No operand predicates
     /* 1435556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435560 */     // MIs[0] policy
     /* 1435560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435572 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435597 */     // GIR_Coverage, 6022,
     /* 1435597 */     GIR_EraseRootFromParent_Done,
     /* 1435598 */   // Label 20253: @1435598
     /* 1435598 */   GIM_Try, /*On fail goto*//*Label 20254*/ GIMT_Encode4(1435695), // Rule ID 6023 //
     /* 1435603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1435614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1435617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1435620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1435626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435653 */     // MIs[1] Operand 1
     /* 1435653 */     // No operand predicates
     /* 1435653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435657 */     // MIs[0] policy
     /* 1435657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435669 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435694 */     // GIR_Coverage, 6023,
     /* 1435694 */     GIR_EraseRootFromParent_Done,
     /* 1435695 */   // Label 20254: @1435695
     /* 1435695 */   GIM_Try, /*On fail goto*//*Label 20255*/ GIMT_Encode4(1435792), // Rule ID 6026 //
     /* 1435700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1435711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1435714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1435717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435750 */     // MIs[1] Operand 1
     /* 1435750 */     // No operand predicates
     /* 1435750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435754 */     // MIs[0] policy
     /* 1435754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435791 */     // GIR_Coverage, 6026,
     /* 1435791 */     GIR_EraseRootFromParent_Done,
     /* 1435792 */   // Label 20255: @1435792
     /* 1435792 */   GIM_Try, /*On fail goto*//*Label 20256*/ GIMT_Encode4(1435889), // Rule ID 6027 //
     /* 1435797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1435808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1435811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1435814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435847 */     // MIs[1] Operand 1
     /* 1435847 */     // No operand predicates
     /* 1435847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435851 */     // MIs[0] policy
     /* 1435851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435863 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435888 */     // GIR_Coverage, 6027,
     /* 1435888 */     GIR_EraseRootFromParent_Done,
     /* 1435889 */   // Label 20256: @1435889
     /* 1435889 */   GIM_Try, /*On fail goto*//*Label 20257*/ GIMT_Encode4(1435986), // Rule ID 6030 //
     /* 1435894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1435905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1435908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1435911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435944 */     // MIs[1] Operand 1
     /* 1435944 */     // No operand predicates
     /* 1435944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435948 */     // MIs[0] policy
     /* 1435948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435960 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1435963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435985 */     // GIR_Coverage, 6030,
     /* 1435985 */     GIR_EraseRootFromParent_Done,
     /* 1435986 */   // Label 20257: @1435986
     /* 1435986 */   GIM_Try, /*On fail goto*//*Label 20258*/ GIMT_Encode4(1436083), // Rule ID 6031 //
     /* 1435991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1436002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1436005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1436008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436041 */     // MIs[1] Operand 1
     /* 1436041 */     // No operand predicates
     /* 1436041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436045 */     // MIs[0] policy
     /* 1436045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436057 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1436060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1436079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436082 */     // GIR_Coverage, 6031,
     /* 1436082 */     GIR_EraseRootFromParent_Done,
     /* 1436083 */   // Label 20258: @1436083
     /* 1436083 */   GIM_Try, /*On fail goto*//*Label 20259*/ GIMT_Encode4(1436180), // Rule ID 6034 //
     /* 1436088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1436099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1436102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1436105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1436111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436138 */     // MIs[1] Operand 1
     /* 1436138 */     // No operand predicates
     /* 1436138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436142 */     // MIs[0] policy
     /* 1436142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436154 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1436157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1436176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436179 */     // GIR_Coverage, 6034,
     /* 1436179 */     GIR_EraseRootFromParent_Done,
     /* 1436180 */   // Label 20259: @1436180
     /* 1436180 */   GIM_Try, /*On fail goto*//*Label 20260*/ GIMT_Encode4(1436277), // Rule ID 6035 //
     /* 1436185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1436196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1436199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1436202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1436208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436235 */     // MIs[1] Operand 1
     /* 1436235 */     // No operand predicates
     /* 1436235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436239 */     // MIs[0] policy
     /* 1436239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436251 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1436254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1436273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436276 */     // GIR_Coverage, 6035,
     /* 1436276 */     GIR_EraseRootFromParent_Done,
     /* 1436277 */   // Label 20260: @1436277
     /* 1436277 */   GIM_Try, /*On fail goto*//*Label 20261*/ GIMT_Encode4(1436374), // Rule ID 6038 //
     /* 1436282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1436285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1436293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1436296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1436299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1436305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1436312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436332 */     // MIs[1] Operand 1
     /* 1436332 */     // No operand predicates
     /* 1436332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436336 */     // MIs[0] policy
     /* 1436336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436348 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1436351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436373 */     // GIR_Coverage, 6038,
     /* 1436373 */     GIR_EraseRootFromParent_Done,
     /* 1436374 */   // Label 20261: @1436374
     /* 1436374 */   GIM_Try, /*On fail goto*//*Label 20262*/ GIMT_Encode4(1436471), // Rule ID 6039 //
     /* 1436379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1436382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1436390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1436393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1436396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1436402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1436409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436429 */     // MIs[1] Operand 1
     /* 1436429 */     // No operand predicates
     /* 1436429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436433 */     // MIs[0] policy
     /* 1436433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436445 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1436448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436470 */     // GIR_Coverage, 6039,
     /* 1436470 */     GIR_EraseRootFromParent_Done,
     /* 1436471 */   // Label 20262: @1436471
     /* 1436471 */   GIM_Try, /*On fail goto*//*Label 20263*/ GIMT_Encode4(1436568), // Rule ID 6042 //
     /* 1436476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1436479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1436487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1436490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1436493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436526 */     // MIs[1] Operand 1
     /* 1436526 */     // No operand predicates
     /* 1436526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436530 */     // MIs[0] policy
     /* 1436530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436542 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1436545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436567 */     // GIR_Coverage, 6042,
     /* 1436567 */     GIR_EraseRootFromParent_Done,
     /* 1436568 */   // Label 20263: @1436568
     /* 1436568 */   GIM_Try, /*On fail goto*//*Label 20264*/ GIMT_Encode4(1436665), // Rule ID 6043 //
     /* 1436573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1436576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1436584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1436587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1436590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436623 */     // MIs[1] Operand 1
     /* 1436623 */     // No operand predicates
     /* 1436623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436627 */     // MIs[0] policy
     /* 1436627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436639 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1436642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436664 */     // GIR_Coverage, 6043,
     /* 1436664 */     GIR_EraseRootFromParent_Done,
     /* 1436665 */   // Label 20264: @1436665
     /* 1436665 */   GIM_Try, /*On fail goto*//*Label 20265*/ GIMT_Encode4(1436762), // Rule ID 6046 //
     /* 1436670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1436673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1436681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1436684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1436687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436720 */     // MIs[1] Operand 1
     /* 1436720 */     // No operand predicates
     /* 1436720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436724 */     // MIs[0] policy
     /* 1436724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436736 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1436739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436761 */     // GIR_Coverage, 6046,
     /* 1436761 */     GIR_EraseRootFromParent_Done,
     /* 1436762 */   // Label 20265: @1436762
     /* 1436762 */   GIM_Try, /*On fail goto*//*Label 20266*/ GIMT_Encode4(1436859), // Rule ID 6047 //
     /* 1436767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1436770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1436778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1436781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1436784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436817 */     // MIs[1] Operand 1
     /* 1436817 */     // No operand predicates
     /* 1436817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436821 */     // MIs[0] policy
     /* 1436821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436833 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1436836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436858 */     // GIR_Coverage, 6047,
     /* 1436858 */     GIR_EraseRootFromParent_Done,
     /* 1436859 */   // Label 20266: @1436859
     /* 1436859 */   GIM_Try, /*On fail goto*//*Label 20267*/ GIMT_Encode4(1436956), // Rule ID 6226 //
     /* 1436864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1436875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1436878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1436881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436914 */     // MIs[1] Operand 1
     /* 1436914 */     // No operand predicates
     /* 1436914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436918 */     // MIs[0] policy
     /* 1436918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436930 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1436933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436955 */     // GIR_Coverage, 6226,
     /* 1436955 */     GIR_EraseRootFromParent_Done,
     /* 1436956 */   // Label 20267: @1436956
     /* 1436956 */   GIM_Try, /*On fail goto*//*Label 20268*/ GIMT_Encode4(1437053), // Rule ID 6227 //
     /* 1436961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1436972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1436975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1436978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437011 */     // MIs[1] Operand 1
     /* 1437011 */     // No operand predicates
     /* 1437011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437015 */     // MIs[0] policy
     /* 1437015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437027 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1437030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437052 */     // GIR_Coverage, 6227,
     /* 1437052 */     GIR_EraseRootFromParent_Done,
     /* 1437053 */   // Label 20268: @1437053
     /* 1437053 */   GIM_Try, /*On fail goto*//*Label 20269*/ GIMT_Encode4(1437150), // Rule ID 6230 //
     /* 1437058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1437069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1437072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1437075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437108 */     // MIs[1] Operand 1
     /* 1437108 */     // No operand predicates
     /* 1437108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437112 */     // MIs[0] policy
     /* 1437112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437124 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1437127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437149 */     // GIR_Coverage, 6230,
     /* 1437149 */     GIR_EraseRootFromParent_Done,
     /* 1437150 */   // Label 20269: @1437150
     /* 1437150 */   GIM_Try, /*On fail goto*//*Label 20270*/ GIMT_Encode4(1437247), // Rule ID 6231 //
     /* 1437155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1437166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1437169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1437172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437205 */     // MIs[1] Operand 1
     /* 1437205 */     // No operand predicates
     /* 1437205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437209 */     // MIs[0] policy
     /* 1437209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437221 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1437224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437246 */     // GIR_Coverage, 6231,
     /* 1437246 */     GIR_EraseRootFromParent_Done,
     /* 1437247 */   // Label 20270: @1437247
     /* 1437247 */   GIM_Try, /*On fail goto*//*Label 20271*/ GIMT_Encode4(1437344), // Rule ID 6234 //
     /* 1437252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1437263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1437266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1437269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437302 */     // MIs[1] Operand 1
     /* 1437302 */     // No operand predicates
     /* 1437302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437306 */     // MIs[0] policy
     /* 1437306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437318 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437343 */     // GIR_Coverage, 6234,
     /* 1437343 */     GIR_EraseRootFromParent_Done,
     /* 1437344 */   // Label 20271: @1437344
     /* 1437344 */   GIM_Try, /*On fail goto*//*Label 20272*/ GIMT_Encode4(1437441), // Rule ID 6235 //
     /* 1437349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1437360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1437363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1437366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437399 */     // MIs[1] Operand 1
     /* 1437399 */     // No operand predicates
     /* 1437399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437403 */     // MIs[0] policy
     /* 1437403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437415 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437440 */     // GIR_Coverage, 6235,
     /* 1437440 */     GIR_EraseRootFromParent_Done,
     /* 1437441 */   // Label 20272: @1437441
     /* 1437441 */   GIM_Try, /*On fail goto*//*Label 20273*/ GIMT_Encode4(1437538), // Rule ID 6238 //
     /* 1437446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1437457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1437460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1437463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437496 */     // MIs[1] Operand 1
     /* 1437496 */     // No operand predicates
     /* 1437496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437500 */     // MIs[0] policy
     /* 1437500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437512 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1437515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437537 */     // GIR_Coverage, 6238,
     /* 1437537 */     GIR_EraseRootFromParent_Done,
     /* 1437538 */   // Label 20273: @1437538
     /* 1437538 */   GIM_Try, /*On fail goto*//*Label 20274*/ GIMT_Encode4(1437635), // Rule ID 6239 //
     /* 1437543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1437554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1437557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1437560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437593 */     // MIs[1] Operand 1
     /* 1437593 */     // No operand predicates
     /* 1437593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437597 */     // MIs[0] policy
     /* 1437597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437609 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1437612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437634 */     // GIR_Coverage, 6239,
     /* 1437634 */     GIR_EraseRootFromParent_Done,
     /* 1437635 */   // Label 20274: @1437635
     /* 1437635 */   GIM_Try, /*On fail goto*//*Label 20275*/ GIMT_Encode4(1437732), // Rule ID 6242 //
     /* 1437640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1437651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1437654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1437657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437690 */     // MIs[1] Operand 1
     /* 1437690 */     // No operand predicates
     /* 1437690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437694 */     // MIs[0] policy
     /* 1437694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437731 */     // GIR_Coverage, 6242,
     /* 1437731 */     GIR_EraseRootFromParent_Done,
     /* 1437732 */   // Label 20275: @1437732
     /* 1437732 */   GIM_Try, /*On fail goto*//*Label 20276*/ GIMT_Encode4(1437829), // Rule ID 6243 //
     /* 1437737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1437748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1437751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1437754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437787 */     // MIs[1] Operand 1
     /* 1437787 */     // No operand predicates
     /* 1437787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437791 */     // MIs[0] policy
     /* 1437791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437803 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437828 */     // GIR_Coverage, 6243,
     /* 1437828 */     GIR_EraseRootFromParent_Done,
     /* 1437829 */   // Label 20276: @1437829
     /* 1437829 */   GIM_Try, /*On fail goto*//*Label 20277*/ GIMT_Encode4(1437926), // Rule ID 6246 //
     /* 1437834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1437845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1437848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1437851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437884 */     // MIs[1] Operand 1
     /* 1437884 */     // No operand predicates
     /* 1437884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437888 */     // MIs[0] policy
     /* 1437888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437900 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437925 */     // GIR_Coverage, 6246,
     /* 1437925 */     GIR_EraseRootFromParent_Done,
     /* 1437926 */   // Label 20277: @1437926
     /* 1437926 */   GIM_Try, /*On fail goto*//*Label 20278*/ GIMT_Encode4(1438023), // Rule ID 6247 //
     /* 1437931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1437942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1437945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1437948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437981 */     // MIs[1] Operand 1
     /* 1437981 */     // No operand predicates
     /* 1437981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437985 */     // MIs[0] policy
     /* 1437985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437997 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1438000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438022 */     // GIR_Coverage, 6247,
     /* 1438022 */     GIR_EraseRootFromParent_Done,
     /* 1438023 */   // Label 20278: @1438023
     /* 1438023 */   GIM_Try, /*On fail goto*//*Label 20279*/ GIMT_Encode4(1438120), // Rule ID 6250 //
     /* 1438028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1438039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1438042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1438045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1438051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438078 */     // MIs[1] Operand 1
     /* 1438078 */     // No operand predicates
     /* 1438078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438082 */     // MIs[0] policy
     /* 1438082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438094 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438119 */     // GIR_Coverage, 6250,
     /* 1438119 */     GIR_EraseRootFromParent_Done,
     /* 1438120 */   // Label 20279: @1438120
     /* 1438120 */   GIM_Try, /*On fail goto*//*Label 20280*/ GIMT_Encode4(1438217), // Rule ID 6251 //
     /* 1438125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1438136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1438139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1438142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1438148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438175 */     // MIs[1] Operand 1
     /* 1438175 */     // No operand predicates
     /* 1438175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438179 */     // MIs[0] policy
     /* 1438179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438191 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438216 */     // GIR_Coverage, 6251,
     /* 1438216 */     GIR_EraseRootFromParent_Done,
     /* 1438217 */   // Label 20280: @1438217
     /* 1438217 */   GIM_Try, /*On fail goto*//*Label 20281*/ GIMT_Encode4(1438314), // Rule ID 6254 //
     /* 1438222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1438233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1438236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1438239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1438245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438272 */     // MIs[1] Operand 1
     /* 1438272 */     // No operand predicates
     /* 1438272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438276 */     // MIs[0] policy
     /* 1438276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438288 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438313 */     // GIR_Coverage, 6254,
     /* 1438313 */     GIR_EraseRootFromParent_Done,
     /* 1438314 */   // Label 20281: @1438314
     /* 1438314 */   GIM_Try, /*On fail goto*//*Label 20282*/ GIMT_Encode4(1438411), // Rule ID 6255 //
     /* 1438319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1438330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1438333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1438336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1438342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438369 */     // MIs[1] Operand 1
     /* 1438369 */     // No operand predicates
     /* 1438369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438373 */     // MIs[0] policy
     /* 1438373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438385 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438410 */     // GIR_Coverage, 6255,
     /* 1438410 */     GIR_EraseRootFromParent_Done,
     /* 1438411 */   // Label 20282: @1438411
     /* 1438411 */   GIM_Try, /*On fail goto*//*Label 20283*/ GIMT_Encode4(1438508), // Rule ID 6258 //
     /* 1438416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1438427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1438430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1438433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1438439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438466 */     // MIs[1] Operand 1
     /* 1438466 */     // No operand predicates
     /* 1438466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438470 */     // MIs[0] policy
     /* 1438470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438482 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438507 */     // GIR_Coverage, 6258,
     /* 1438507 */     GIR_EraseRootFromParent_Done,
     /* 1438508 */   // Label 20283: @1438508
     /* 1438508 */   GIM_Try, /*On fail goto*//*Label 20284*/ GIMT_Encode4(1438605), // Rule ID 6259 //
     /* 1438513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1438524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1438527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1438530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1438536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438563 */     // MIs[1] Operand 1
     /* 1438563 */     // No operand predicates
     /* 1438563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438567 */     // MIs[0] policy
     /* 1438567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438579 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438604 */     // GIR_Coverage, 6259,
     /* 1438604 */     GIR_EraseRootFromParent_Done,
     /* 1438605 */   // Label 20284: @1438605
     /* 1438605 */   GIM_Try, /*On fail goto*//*Label 20285*/ GIMT_Encode4(1438702), // Rule ID 6262 //
     /* 1438610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1438613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1438621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1438624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1438627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438660 */     // MIs[1] Operand 1
     /* 1438660 */     // No operand predicates
     /* 1438660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438664 */     // MIs[0] policy
     /* 1438664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438676 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438701 */     // GIR_Coverage, 6262,
     /* 1438701 */     GIR_EraseRootFromParent_Done,
     /* 1438702 */   // Label 20285: @1438702
     /* 1438702 */   GIM_Try, /*On fail goto*//*Label 20286*/ GIMT_Encode4(1438799), // Rule ID 6263 //
     /* 1438707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1438710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1438718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1438721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1438724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438757 */     // MIs[1] Operand 1
     /* 1438757 */     // No operand predicates
     /* 1438757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438761 */     // MIs[0] policy
     /* 1438761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438773 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438798 */     // GIR_Coverage, 6263,
     /* 1438798 */     GIR_EraseRootFromParent_Done,
     /* 1438799 */   // Label 20286: @1438799
     /* 1438799 */   GIM_Try, /*On fail goto*//*Label 20287*/ GIMT_Encode4(1438896), // Rule ID 6266 //
     /* 1438804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1438815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1438818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1438821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1438827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438854 */     // MIs[1] Operand 1
     /* 1438854 */     // No operand predicates
     /* 1438854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438858 */     // MIs[0] policy
     /* 1438858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438870 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1438873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438895 */     // GIR_Coverage, 6266,
     /* 1438895 */     GIR_EraseRootFromParent_Done,
     /* 1438896 */   // Label 20287: @1438896
     /* 1438896 */   GIM_Try, /*On fail goto*//*Label 20288*/ GIMT_Encode4(1438993), // Rule ID 6267 //
     /* 1438901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1438912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1438915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1438918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1438924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438951 */     // MIs[1] Operand 1
     /* 1438951 */     // No operand predicates
     /* 1438951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438955 */     // MIs[0] policy
     /* 1438955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438967 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1438970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438992 */     // GIR_Coverage, 6267,
     /* 1438992 */     GIR_EraseRootFromParent_Done,
     /* 1438993 */   // Label 20288: @1438993
     /* 1438993 */   GIM_Try, /*On fail goto*//*Label 20289*/ GIMT_Encode4(1439090), // Rule ID 6270 //
     /* 1438998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1439009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1439012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1439015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1439021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439048 */     // MIs[1] Operand 1
     /* 1439048 */     // No operand predicates
     /* 1439048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439052 */     // MIs[0] policy
     /* 1439052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439064 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1439086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439089 */     // GIR_Coverage, 6270,
     /* 1439089 */     GIR_EraseRootFromParent_Done,
     /* 1439090 */   // Label 20289: @1439090
     /* 1439090 */   GIM_Try, /*On fail goto*//*Label 20290*/ GIMT_Encode4(1439187), // Rule ID 6271 //
     /* 1439095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1439106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1439109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1439112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1439118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439145 */     // MIs[1] Operand 1
     /* 1439145 */     // No operand predicates
     /* 1439145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439149 */     // MIs[0] policy
     /* 1439149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439161 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1439183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439186 */     // GIR_Coverage, 6271,
     /* 1439186 */     GIR_EraseRootFromParent_Done,
     /* 1439187 */   // Label 20290: @1439187
     /* 1439187 */   GIM_Try, /*On fail goto*//*Label 20291*/ GIMT_Encode4(1439284), // Rule ID 6274 //
     /* 1439192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1439203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1439206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1439209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1439215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439242 */     // MIs[1] Operand 1
     /* 1439242 */     // No operand predicates
     /* 1439242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439246 */     // MIs[0] policy
     /* 1439246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439258 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1439280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439283 */     // GIR_Coverage, 6274,
     /* 1439283 */     GIR_EraseRootFromParent_Done,
     /* 1439284 */   // Label 20291: @1439284
     /* 1439284 */   GIM_Try, /*On fail goto*//*Label 20292*/ GIMT_Encode4(1439381), // Rule ID 6275 //
     /* 1439289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1439300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1439303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1439306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1439312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439339 */     // MIs[1] Operand 1
     /* 1439339 */     // No operand predicates
     /* 1439339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439343 */     // MIs[0] policy
     /* 1439343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439355 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1439377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439380 */     // GIR_Coverage, 6275,
     /* 1439380 */     GIR_EraseRootFromParent_Done,
     /* 1439381 */   // Label 20292: @1439381
     /* 1439381 */   GIM_Try, /*On fail goto*//*Label 20293*/ GIMT_Encode4(1439478), // Rule ID 6278 //
     /* 1439386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1439397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1439400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1439403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439436 */     // MIs[1] Operand 1
     /* 1439436 */     // No operand predicates
     /* 1439436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439440 */     // MIs[0] policy
     /* 1439440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1439455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439477 */     // GIR_Coverage, 6278,
     /* 1439477 */     GIR_EraseRootFromParent_Done,
     /* 1439478 */   // Label 20293: @1439478
     /* 1439478 */   GIM_Try, /*On fail goto*//*Label 20294*/ GIMT_Encode4(1439575), // Rule ID 6279 //
     /* 1439483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1439494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1439497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1439500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439533 */     // MIs[1] Operand 1
     /* 1439533 */     // No operand predicates
     /* 1439533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439537 */     // MIs[0] policy
     /* 1439537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439549 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1439552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439574 */     // GIR_Coverage, 6279,
     /* 1439574 */     GIR_EraseRootFromParent_Done,
     /* 1439575 */   // Label 20294: @1439575
     /* 1439575 */   GIM_Try, /*On fail goto*//*Label 20295*/ GIMT_Encode4(1439672), // Rule ID 6282 //
     /* 1439580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1439591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1439594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1439597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1439603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439630 */     // MIs[1] Operand 1
     /* 1439630 */     // No operand predicates
     /* 1439630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439634 */     // MIs[0] policy
     /* 1439634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439646 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439671 */     // GIR_Coverage, 6282,
     /* 1439671 */     GIR_EraseRootFromParent_Done,
     /* 1439672 */   // Label 20295: @1439672
     /* 1439672 */   GIM_Try, /*On fail goto*//*Label 20296*/ GIMT_Encode4(1439769), // Rule ID 6283 //
     /* 1439677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1439688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1439691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1439694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1439700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439727 */     // MIs[1] Operand 1
     /* 1439727 */     // No operand predicates
     /* 1439727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439731 */     // MIs[0] policy
     /* 1439731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439743 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439768 */     // GIR_Coverage, 6283,
     /* 1439768 */     GIR_EraseRootFromParent_Done,
     /* 1439769 */   // Label 20296: @1439769
     /* 1439769 */   GIM_Try, /*On fail goto*//*Label 20297*/ GIMT_Encode4(1439866), // Rule ID 6286 //
     /* 1439774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1439785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1439788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1439791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1439797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439824 */     // MIs[1] Operand 1
     /* 1439824 */     // No operand predicates
     /* 1439824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439828 */     // MIs[0] policy
     /* 1439828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439840 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439865 */     // GIR_Coverage, 6286,
     /* 1439865 */     GIR_EraseRootFromParent_Done,
     /* 1439866 */   // Label 20297: @1439866
     /* 1439866 */   GIM_Try, /*On fail goto*//*Label 20298*/ GIMT_Encode4(1439963), // Rule ID 6287 //
     /* 1439871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1439882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1439885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1439888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1439894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439921 */     // MIs[1] Operand 1
     /* 1439921 */     // No operand predicates
     /* 1439921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439925 */     // MIs[0] policy
     /* 1439925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439937 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439962 */     // GIR_Coverage, 6287,
     /* 1439962 */     GIR_EraseRootFromParent_Done,
     /* 1439963 */   // Label 20298: @1439963
     /* 1439963 */   GIM_Try, /*On fail goto*//*Label 20299*/ GIMT_Encode4(1440060), // Rule ID 6290 //
     /* 1439968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1439979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1439982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1439985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440018 */     // MIs[1] Operand 1
     /* 1440018 */     // No operand predicates
     /* 1440018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440022 */     // MIs[0] policy
     /* 1440022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1440037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440059 */     // GIR_Coverage, 6290,
     /* 1440059 */     GIR_EraseRootFromParent_Done,
     /* 1440060 */   // Label 20299: @1440060
     /* 1440060 */   GIM_Try, /*On fail goto*//*Label 20300*/ GIMT_Encode4(1440157), // Rule ID 6291 //
     /* 1440065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1440076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1440079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1440082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1440088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440115 */     // MIs[1] Operand 1
     /* 1440115 */     // No operand predicates
     /* 1440115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440119 */     // MIs[0] policy
     /* 1440119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440131 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1440134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440156 */     // GIR_Coverage, 6291,
     /* 1440156 */     GIR_EraseRootFromParent_Done,
     /* 1440157 */   // Label 20300: @1440157
     /* 1440157 */   GIM_Try, /*On fail goto*//*Label 20301*/ GIMT_Encode4(1440254), // Rule ID 6294 //
     /* 1440162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1440173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1440176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1440179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440212 */     // MIs[1] Operand 1
     /* 1440212 */     // No operand predicates
     /* 1440212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440216 */     // MIs[0] policy
     /* 1440216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440228 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1440231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440253 */     // GIR_Coverage, 6294,
     /* 1440253 */     GIR_EraseRootFromParent_Done,
     /* 1440254 */   // Label 20301: @1440254
     /* 1440254 */   GIM_Try, /*On fail goto*//*Label 20302*/ GIMT_Encode4(1440351), // Rule ID 6295 //
     /* 1440259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1440270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1440273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1440276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440309 */     // MIs[1] Operand 1
     /* 1440309 */     // No operand predicates
     /* 1440309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440313 */     // MIs[0] policy
     /* 1440313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440325 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1440328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440350 */     // GIR_Coverage, 6295,
     /* 1440350 */     GIR_EraseRootFromParent_Done,
     /* 1440351 */   // Label 20302: @1440351
     /* 1440351 */   GIM_Try, /*On fail goto*//*Label 20303*/ GIMT_Encode4(1440448), // Rule ID 6298 //
     /* 1440356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1440367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1440370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1440373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1440379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440406 */     // MIs[1] Operand 1
     /* 1440406 */     // No operand predicates
     /* 1440406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440410 */     // MIs[0] policy
     /* 1440410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440422 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1440425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440447 */     // GIR_Coverage, 6298,
     /* 1440447 */     GIR_EraseRootFromParent_Done,
     /* 1440448 */   // Label 20303: @1440448
     /* 1440448 */   GIM_Try, /*On fail goto*//*Label 20304*/ GIMT_Encode4(1440545), // Rule ID 6299 //
     /* 1440453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1440464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1440467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1440470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1440476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440503 */     // MIs[1] Operand 1
     /* 1440503 */     // No operand predicates
     /* 1440503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440507 */     // MIs[0] policy
     /* 1440507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440519 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1440522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440544 */     // GIR_Coverage, 6299,
     /* 1440544 */     GIR_EraseRootFromParent_Done,
     /* 1440545 */   // Label 20304: @1440545
     /* 1440545 */   GIM_Try, /*On fail goto*//*Label 20305*/ GIMT_Encode4(1440642), // Rule ID 6302 //
     /* 1440550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1440561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1440564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1440567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440600 */     // MIs[1] Operand 1
     /* 1440600 */     // No operand predicates
     /* 1440600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440604 */     // MIs[0] policy
     /* 1440604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1440619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440641 */     // GIR_Coverage, 6302,
     /* 1440641 */     GIR_EraseRootFromParent_Done,
     /* 1440642 */   // Label 20305: @1440642
     /* 1440642 */   GIM_Try, /*On fail goto*//*Label 20306*/ GIMT_Encode4(1440739), // Rule ID 6303 //
     /* 1440647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1440658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1440661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1440664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440697 */     // MIs[1] Operand 1
     /* 1440697 */     // No operand predicates
     /* 1440697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440701 */     // MIs[0] policy
     /* 1440701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440713 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1440716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440738 */     // GIR_Coverage, 6303,
     /* 1440738 */     GIR_EraseRootFromParent_Done,
     /* 1440739 */   // Label 20306: @1440739
     /* 1440739 */   GIM_Try, /*On fail goto*//*Label 20307*/ GIMT_Encode4(1440836), // Rule ID 6306 //
     /* 1440744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1440755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1440758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1440761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1440767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440794 */     // MIs[1] Operand 1
     /* 1440794 */     // No operand predicates
     /* 1440794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440798 */     // MIs[0] policy
     /* 1440798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440810 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1440813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440835 */     // GIR_Coverage, 6306,
     /* 1440835 */     GIR_EraseRootFromParent_Done,
     /* 1440836 */   // Label 20307: @1440836
     /* 1440836 */   GIM_Try, /*On fail goto*//*Label 20308*/ GIMT_Encode4(1440933), // Rule ID 6307 //
     /* 1440841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1440852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1440855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1440858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1440864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440891 */     // MIs[1] Operand 1
     /* 1440891 */     // No operand predicates
     /* 1440891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440895 */     // MIs[0] policy
     /* 1440895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440907 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1440910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440932 */     // GIR_Coverage, 6307,
     /* 1440932 */     GIR_EraseRootFromParent_Done,
     /* 1440933 */   // Label 20308: @1440933
     /* 1440933 */   GIM_Try, /*On fail goto*//*Label 20309*/ GIMT_Encode4(1441030), // Rule ID 6310 //
     /* 1440938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1440949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1440952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1440955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440988 */     // MIs[1] Operand 1
     /* 1440988 */     // No operand predicates
     /* 1440988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440992 */     // MIs[0] policy
     /* 1440992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441004 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1441007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1441026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441029 */     // GIR_Coverage, 6310,
     /* 1441029 */     GIR_EraseRootFromParent_Done,
     /* 1441030 */   // Label 20309: @1441030
     /* 1441030 */   GIM_Try, /*On fail goto*//*Label 20310*/ GIMT_Encode4(1441127), // Rule ID 6311 //
     /* 1441035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1441038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1441046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1441049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1441052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1441065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441085 */     // MIs[1] Operand 1
     /* 1441085 */     // No operand predicates
     /* 1441085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441089 */     // MIs[0] policy
     /* 1441089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441101 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1441104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1441123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441126 */     // GIR_Coverage, 6311,
     /* 1441126 */     GIR_EraseRootFromParent_Done,
     /* 1441127 */   // Label 20310: @1441127
     /* 1441127 */   GIM_Try, /*On fail goto*//*Label 20311*/ GIMT_Encode4(1441224), // Rule ID 6490 //
     /* 1441132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1441143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1441146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1441149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441182 */     // MIs[1] Operand 1
     /* 1441182 */     // No operand predicates
     /* 1441182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441186 */     // MIs[0] policy
     /* 1441186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441198 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1441201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441223 */     // GIR_Coverage, 6490,
     /* 1441223 */     GIR_EraseRootFromParent_Done,
     /* 1441224 */   // Label 20311: @1441224
     /* 1441224 */   GIM_Try, /*On fail goto*//*Label 20312*/ GIMT_Encode4(1441321), // Rule ID 6491 //
     /* 1441229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1441240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1441243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1441246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441279 */     // MIs[1] Operand 1
     /* 1441279 */     // No operand predicates
     /* 1441279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441283 */     // MIs[0] policy
     /* 1441283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441295 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1441298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441320 */     // GIR_Coverage, 6491,
     /* 1441320 */     GIR_EraseRootFromParent_Done,
     /* 1441321 */   // Label 20312: @1441321
     /* 1441321 */   GIM_Try, /*On fail goto*//*Label 20313*/ GIMT_Encode4(1441418), // Rule ID 6494 //
     /* 1441326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1441337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1441340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1441343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441376 */     // MIs[1] Operand 1
     /* 1441376 */     // No operand predicates
     /* 1441376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441380 */     // MIs[0] policy
     /* 1441380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441392 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441417 */     // GIR_Coverage, 6494,
     /* 1441417 */     GIR_EraseRootFromParent_Done,
     /* 1441418 */   // Label 20313: @1441418
     /* 1441418 */   GIM_Try, /*On fail goto*//*Label 20314*/ GIMT_Encode4(1441515), // Rule ID 6495 //
     /* 1441423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1441434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1441437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1441440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441473 */     // MIs[1] Operand 1
     /* 1441473 */     // No operand predicates
     /* 1441473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441477 */     // MIs[0] policy
     /* 1441477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441489 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441514 */     // GIR_Coverage, 6495,
     /* 1441514 */     GIR_EraseRootFromParent_Done,
     /* 1441515 */   // Label 20314: @1441515
     /* 1441515 */   GIM_Try, /*On fail goto*//*Label 20315*/ GIMT_Encode4(1441612), // Rule ID 6498 //
     /* 1441520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1441531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1441534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1441537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441570 */     // MIs[1] Operand 1
     /* 1441570 */     // No operand predicates
     /* 1441570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441574 */     // MIs[0] policy
     /* 1441574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441586 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441611 */     // GIR_Coverage, 6498,
     /* 1441611 */     GIR_EraseRootFromParent_Done,
     /* 1441612 */   // Label 20315: @1441612
     /* 1441612 */   GIM_Try, /*On fail goto*//*Label 20316*/ GIMT_Encode4(1441709), // Rule ID 6499 //
     /* 1441617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1441628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1441631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1441634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441667 */     // MIs[1] Operand 1
     /* 1441667 */     // No operand predicates
     /* 1441667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441671 */     // MIs[0] policy
     /* 1441671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441683 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441708 */     // GIR_Coverage, 6499,
     /* 1441708 */     GIR_EraseRootFromParent_Done,
     /* 1441709 */   // Label 20316: @1441709
     /* 1441709 */   GIM_Try, /*On fail goto*//*Label 20317*/ GIMT_Encode4(1441806), // Rule ID 6502 //
     /* 1441714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1441725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1441728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1441731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441764 */     // MIs[1] Operand 1
     /* 1441764 */     // No operand predicates
     /* 1441764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441768 */     // MIs[0] policy
     /* 1441768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441780 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441805 */     // GIR_Coverage, 6502,
     /* 1441805 */     GIR_EraseRootFromParent_Done,
     /* 1441806 */   // Label 20317: @1441806
     /* 1441806 */   GIM_Try, /*On fail goto*//*Label 20318*/ GIMT_Encode4(1441903), // Rule ID 6503 //
     /* 1441811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1441822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1441825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1441828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441861 */     // MIs[1] Operand 1
     /* 1441861 */     // No operand predicates
     /* 1441861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441865 */     // MIs[0] policy
     /* 1441865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441877 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441902 */     // GIR_Coverage, 6503,
     /* 1441902 */     GIR_EraseRootFromParent_Done,
     /* 1441903 */   // Label 20318: @1441903
     /* 1441903 */   GIM_Try, /*On fail goto*//*Label 20319*/ GIMT_Encode4(1442000), // Rule ID 6506 //
     /* 1441908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1441919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1441922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1441925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441958 */     // MIs[1] Operand 1
     /* 1441958 */     // No operand predicates
     /* 1441958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441962 */     // MIs[0] policy
     /* 1441962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441974 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441999 */     // GIR_Coverage, 6506,
     /* 1441999 */     GIR_EraseRootFromParent_Done,
     /* 1442000 */   // Label 20319: @1442000
     /* 1442000 */   GIM_Try, /*On fail goto*//*Label 20320*/ GIMT_Encode4(1442097), // Rule ID 6507 //
     /* 1442005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1442016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1442019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1442022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442055 */     // MIs[1] Operand 1
     /* 1442055 */     // No operand predicates
     /* 1442055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442059 */     // MIs[0] policy
     /* 1442059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442071 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1442074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442096 */     // GIR_Coverage, 6507,
     /* 1442096 */     GIR_EraseRootFromParent_Done,
     /* 1442097 */   // Label 20320: @1442097
     /* 1442097 */   GIM_Try, /*On fail goto*//*Label 20321*/ GIMT_Encode4(1442194), // Rule ID 6510 //
     /* 1442102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1442113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1442116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1442119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442152 */     // MIs[1] Operand 1
     /* 1442152 */     // No operand predicates
     /* 1442152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442156 */     // MIs[0] policy
     /* 1442156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1442171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442193 */     // GIR_Coverage, 6510,
     /* 1442193 */     GIR_EraseRootFromParent_Done,
     /* 1442194 */   // Label 20321: @1442194
     /* 1442194 */   GIM_Try, /*On fail goto*//*Label 20322*/ GIMT_Encode4(1442291), // Rule ID 6511 //
     /* 1442199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1442210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1442213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1442216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442249 */     // MIs[1] Operand 1
     /* 1442249 */     // No operand predicates
     /* 1442249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442253 */     // MIs[0] policy
     /* 1442253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442265 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1442268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442290 */     // GIR_Coverage, 6511,
     /* 1442290 */     GIR_EraseRootFromParent_Done,
     /* 1442291 */   // Label 20322: @1442291
     /* 1442291 */   GIM_Try, /*On fail goto*//*Label 20323*/ GIMT_Encode4(1442388), // Rule ID 6514 //
     /* 1442296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1442307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1442310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1442313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1442319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442346 */     // MIs[1] Operand 1
     /* 1442346 */     // No operand predicates
     /* 1442346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442350 */     // MIs[0] policy
     /* 1442350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442362 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442387 */     // GIR_Coverage, 6514,
     /* 1442387 */     GIR_EraseRootFromParent_Done,
     /* 1442388 */   // Label 20323: @1442388
     /* 1442388 */   GIM_Try, /*On fail goto*//*Label 20324*/ GIMT_Encode4(1442485), // Rule ID 6515 //
     /* 1442393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1442404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1442407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1442410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1442416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442443 */     // MIs[1] Operand 1
     /* 1442443 */     // No operand predicates
     /* 1442443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442447 */     // MIs[0] policy
     /* 1442447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442459 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442484 */     // GIR_Coverage, 6515,
     /* 1442484 */     GIR_EraseRootFromParent_Done,
     /* 1442485 */   // Label 20324: @1442485
     /* 1442485 */   GIM_Try, /*On fail goto*//*Label 20325*/ GIMT_Encode4(1442582), // Rule ID 6518 //
     /* 1442490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1442501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1442504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1442507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1442513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442540 */     // MIs[1] Operand 1
     /* 1442540 */     // No operand predicates
     /* 1442540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442544 */     // MIs[0] policy
     /* 1442544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442556 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442581 */     // GIR_Coverage, 6518,
     /* 1442581 */     GIR_EraseRootFromParent_Done,
     /* 1442582 */   // Label 20325: @1442582
     /* 1442582 */   GIM_Try, /*On fail goto*//*Label 20326*/ GIMT_Encode4(1442679), // Rule ID 6519 //
     /* 1442587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1442598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1442601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1442604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1442610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442637 */     // MIs[1] Operand 1
     /* 1442637 */     // No operand predicates
     /* 1442637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442641 */     // MIs[0] policy
     /* 1442641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442653 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442678 */     // GIR_Coverage, 6519,
     /* 1442678 */     GIR_EraseRootFromParent_Done,
     /* 1442679 */   // Label 20326: @1442679
     /* 1442679 */   GIM_Try, /*On fail goto*//*Label 20327*/ GIMT_Encode4(1442776), // Rule ID 6522 //
     /* 1442684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1442695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1442698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1442701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442734 */     // MIs[1] Operand 1
     /* 1442734 */     // No operand predicates
     /* 1442734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442738 */     // MIs[0] policy
     /* 1442738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442775 */     // GIR_Coverage, 6522,
     /* 1442775 */     GIR_EraseRootFromParent_Done,
     /* 1442776 */   // Label 20327: @1442776
     /* 1442776 */   GIM_Try, /*On fail goto*//*Label 20328*/ GIMT_Encode4(1442873), // Rule ID 6523 //
     /* 1442781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1442792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1442795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1442798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442831 */     // MIs[1] Operand 1
     /* 1442831 */     // No operand predicates
     /* 1442831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442835 */     // MIs[0] policy
     /* 1442835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442847 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442872 */     // GIR_Coverage, 6523,
     /* 1442872 */     GIR_EraseRootFromParent_Done,
     /* 1442873 */   // Label 20328: @1442873
     /* 1442873 */   GIM_Try, /*On fail goto*//*Label 20329*/ GIMT_Encode4(1442970), // Rule ID 6526 //
     /* 1442878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1442881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1442889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1442892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1442895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442928 */     // MIs[1] Operand 1
     /* 1442928 */     // No operand predicates
     /* 1442928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442932 */     // MIs[0] policy
     /* 1442932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442944 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442969 */     // GIR_Coverage, 6526,
     /* 1442969 */     GIR_EraseRootFromParent_Done,
     /* 1442970 */   // Label 20329: @1442970
     /* 1442970 */   GIM_Try, /*On fail goto*//*Label 20330*/ GIMT_Encode4(1443067), // Rule ID 6527 //
     /* 1442975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1442978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1442986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1442989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1442992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443025 */     // MIs[1] Operand 1
     /* 1443025 */     // No operand predicates
     /* 1443025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443029 */     // MIs[0] policy
     /* 1443029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443041 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1443044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1443063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443066 */     // GIR_Coverage, 6527,
     /* 1443066 */     GIR_EraseRootFromParent_Done,
     /* 1443067 */   // Label 20330: @1443067
     /* 1443067 */   GIM_Try, /*On fail goto*//*Label 20331*/ GIMT_Encode4(1443164), // Rule ID 6530 //
     /* 1443072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1443083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1443086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1443089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443122 */     // MIs[1] Operand 1
     /* 1443122 */     // No operand predicates
     /* 1443122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443126 */     // MIs[0] policy
     /* 1443126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443138 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443163 */     // GIR_Coverage, 6530,
     /* 1443163 */     GIR_EraseRootFromParent_Done,
     /* 1443164 */   // Label 20331: @1443164
     /* 1443164 */   GIM_Try, /*On fail goto*//*Label 20332*/ GIMT_Encode4(1443261), // Rule ID 6531 //
     /* 1443169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1443180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1443183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1443186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443219 */     // MIs[1] Operand 1
     /* 1443219 */     // No operand predicates
     /* 1443219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443223 */     // MIs[0] policy
     /* 1443223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443235 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443260 */     // GIR_Coverage, 6531,
     /* 1443260 */     GIR_EraseRootFromParent_Done,
     /* 1443261 */   // Label 20332: @1443261
     /* 1443261 */   GIM_Try, /*On fail goto*//*Label 20333*/ GIMT_Encode4(1443358), // Rule ID 6534 //
     /* 1443266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1443277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1443280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1443283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1443289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443316 */     // MIs[1] Operand 1
     /* 1443316 */     // No operand predicates
     /* 1443316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443320 */     // MIs[0] policy
     /* 1443320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443332 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1443335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443357 */     // GIR_Coverage, 6534,
     /* 1443357 */     GIR_EraseRootFromParent_Done,
     /* 1443358 */   // Label 20333: @1443358
     /* 1443358 */   GIM_Try, /*On fail goto*//*Label 20334*/ GIMT_Encode4(1443455), // Rule ID 6535 //
     /* 1443363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1443374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1443377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1443380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1443386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443413 */     // MIs[1] Operand 1
     /* 1443413 */     // No operand predicates
     /* 1443413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443417 */     // MIs[0] policy
     /* 1443417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443429 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1443432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443454 */     // GIR_Coverage, 6535,
     /* 1443454 */     GIR_EraseRootFromParent_Done,
     /* 1443455 */   // Label 20334: @1443455
     /* 1443455 */   GIM_Try, /*On fail goto*//*Label 20335*/ GIMT_Encode4(1443552), // Rule ID 6538 //
     /* 1443460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1443471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1443474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1443477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1443483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443510 */     // MIs[1] Operand 1
     /* 1443510 */     // No operand predicates
     /* 1443510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443514 */     // MIs[0] policy
     /* 1443514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443526 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1443529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443551 */     // GIR_Coverage, 6538,
     /* 1443551 */     GIR_EraseRootFromParent_Done,
     /* 1443552 */   // Label 20335: @1443552
     /* 1443552 */   GIM_Try, /*On fail goto*//*Label 20336*/ GIMT_Encode4(1443649), // Rule ID 6539 //
     /* 1443557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1443568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1443571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1443574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1443580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443607 */     // MIs[1] Operand 1
     /* 1443607 */     // No operand predicates
     /* 1443607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443611 */     // MIs[0] policy
     /* 1443611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443623 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1443626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443648 */     // GIR_Coverage, 6539,
     /* 1443648 */     GIR_EraseRootFromParent_Done,
     /* 1443649 */   // Label 20336: @1443649
     /* 1443649 */   GIM_Try, /*On fail goto*//*Label 20337*/ GIMT_Encode4(1443746), // Rule ID 6542 //
     /* 1443654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1443665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1443668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1443671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443704 */     // MIs[1] Operand 1
     /* 1443704 */     // No operand predicates
     /* 1443704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443708 */     // MIs[0] policy
     /* 1443708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443745 */     // GIR_Coverage, 6542,
     /* 1443745 */     GIR_EraseRootFromParent_Done,
     /* 1443746 */   // Label 20337: @1443746
     /* 1443746 */   GIM_Try, /*On fail goto*//*Label 20338*/ GIMT_Encode4(1443843), // Rule ID 6543 //
     /* 1443751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1443762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1443765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1443768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443801 */     // MIs[1] Operand 1
     /* 1443801 */     // No operand predicates
     /* 1443801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443805 */     // MIs[0] policy
     /* 1443805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443817 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443842 */     // GIR_Coverage, 6543,
     /* 1443842 */     GIR_EraseRootFromParent_Done,
     /* 1443843 */   // Label 20338: @1443843
     /* 1443843 */   GIM_Try, /*On fail goto*//*Label 20339*/ GIMT_Encode4(1443940), // Rule ID 6546 //
     /* 1443848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1443859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1443862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1443865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443898 */     // MIs[1] Operand 1
     /* 1443898 */     // No operand predicates
     /* 1443898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443902 */     // MIs[0] policy
     /* 1443902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443914 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1443917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443939 */     // GIR_Coverage, 6546,
     /* 1443939 */     GIR_EraseRootFromParent_Done,
     /* 1443940 */   // Label 20339: @1443940
     /* 1443940 */   GIM_Try, /*On fail goto*//*Label 20340*/ GIMT_Encode4(1444037), // Rule ID 6547 //
     /* 1443945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1443956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1443959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1443962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443995 */     // MIs[1] Operand 1
     /* 1443995 */     // No operand predicates
     /* 1443995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443999 */     // MIs[0] policy
     /* 1443999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444011 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444036 */     // GIR_Coverage, 6547,
     /* 1444036 */     GIR_EraseRootFromParent_Done,
     /* 1444037 */   // Label 20340: @1444037
     /* 1444037 */   GIM_Try, /*On fail goto*//*Label 20341*/ GIMT_Encode4(1444134), // Rule ID 6550 //
     /* 1444042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1444053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1444056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1444059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1444065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444092 */     // MIs[1] Operand 1
     /* 1444092 */     // No operand predicates
     /* 1444092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444096 */     // MIs[0] policy
     /* 1444096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444108 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444133 */     // GIR_Coverage, 6550,
     /* 1444133 */     GIR_EraseRootFromParent_Done,
     /* 1444134 */   // Label 20341: @1444134
     /* 1444134 */   GIM_Try, /*On fail goto*//*Label 20342*/ GIMT_Encode4(1444231), // Rule ID 6551 //
     /* 1444139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1444150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1444153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1444156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1444162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444189 */     // MIs[1] Operand 1
     /* 1444189 */     // No operand predicates
     /* 1444189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444193 */     // MIs[0] policy
     /* 1444193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444205 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444230 */     // GIR_Coverage, 6551,
     /* 1444230 */     GIR_EraseRootFromParent_Done,
     /* 1444231 */   // Label 20342: @1444231
     /* 1444231 */   GIM_Try, /*On fail goto*//*Label 20343*/ GIMT_Encode4(1444328), // Rule ID 6554 //
     /* 1444236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1444247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1444250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1444253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444286 */     // MIs[1] Operand 1
     /* 1444286 */     // No operand predicates
     /* 1444286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444290 */     // MIs[0] policy
     /* 1444290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1444305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444327 */     // GIR_Coverage, 6554,
     /* 1444327 */     GIR_EraseRootFromParent_Done,
     /* 1444328 */   // Label 20343: @1444328
     /* 1444328 */   GIM_Try, /*On fail goto*//*Label 20344*/ GIMT_Encode4(1444425), // Rule ID 6555 //
     /* 1444333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1444344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1444347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1444350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444383 */     // MIs[1] Operand 1
     /* 1444383 */     // No operand predicates
     /* 1444383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444387 */     // MIs[0] policy
     /* 1444387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1444402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444424 */     // GIR_Coverage, 6555,
     /* 1444424 */     GIR_EraseRootFromParent_Done,
     /* 1444425 */   // Label 20344: @1444425
     /* 1444425 */   GIM_Try, /*On fail goto*//*Label 20345*/ GIMT_Encode4(1444522), // Rule ID 6558 //
     /* 1444430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1444441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1444444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1444447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1444453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444480 */     // MIs[1] Operand 1
     /* 1444480 */     // No operand predicates
     /* 1444480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444484 */     // MIs[0] policy
     /* 1444484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444521 */     // GIR_Coverage, 6558,
     /* 1444521 */     GIR_EraseRootFromParent_Done,
     /* 1444522 */   // Label 20345: @1444522
     /* 1444522 */   GIM_Try, /*On fail goto*//*Label 20346*/ GIMT_Encode4(1444619), // Rule ID 6559 //
     /* 1444527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1444538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1444541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1444544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1444550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444577 */     // MIs[1] Operand 1
     /* 1444577 */     // No operand predicates
     /* 1444577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444581 */     // MIs[0] policy
     /* 1444581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444593 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444618 */     // GIR_Coverage, 6559,
     /* 1444618 */     GIR_EraseRootFromParent_Done,
     /* 1444619 */   // Label 20346: @1444619
     /* 1444619 */   GIM_Try, /*On fail goto*//*Label 20347*/ GIMT_Encode4(1444716), // Rule ID 6562 //
     /* 1444624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1444635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1444638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1444641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1444647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444674 */     // MIs[1] Operand 1
     /* 1444674 */     // No operand predicates
     /* 1444674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444678 */     // MIs[0] policy
     /* 1444678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444690 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444715 */     // GIR_Coverage, 6562,
     /* 1444715 */     GIR_EraseRootFromParent_Done,
     /* 1444716 */   // Label 20347: @1444716
     /* 1444716 */   GIM_Try, /*On fail goto*//*Label 20348*/ GIMT_Encode4(1444813), // Rule ID 6563 //
     /* 1444721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1444732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1444735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1444738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1444744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444771 */     // MIs[1] Operand 1
     /* 1444771 */     // No operand predicates
     /* 1444771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444775 */     // MIs[0] policy
     /* 1444775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444787 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444812 */     // GIR_Coverage, 6563,
     /* 1444812 */     GIR_EraseRootFromParent_Done,
     /* 1444813 */   // Label 20348: @1444813
     /* 1444813 */   GIM_Try, /*On fail goto*//*Label 20349*/ GIMT_Encode4(1444910), // Rule ID 6566 //
     /* 1444818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1444821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1444829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1444832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1444835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444868 */     // MIs[1] Operand 1
     /* 1444868 */     // No operand predicates
     /* 1444868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444872 */     // MIs[0] policy
     /* 1444872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1444887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444909 */     // GIR_Coverage, 6566,
     /* 1444909 */     GIR_EraseRootFromParent_Done,
     /* 1444910 */   // Label 20349: @1444910
     /* 1444910 */   GIM_Try, /*On fail goto*//*Label 20350*/ GIMT_Encode4(1445007), // Rule ID 6567 //
     /* 1444915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1444926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1444929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1444932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444965 */     // MIs[1] Operand 1
     /* 1444965 */     // No operand predicates
     /* 1444965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444969 */     // MIs[0] policy
     /* 1444969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444981 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1444984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1445003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445006 */     // GIR_Coverage, 6567,
     /* 1445006 */     GIR_EraseRootFromParent_Done,
     /* 1445007 */   // Label 20350: @1445007
     /* 1445007 */   GIM_Try, /*On fail goto*//*Label 20351*/ GIMT_Encode4(1445104), // Rule ID 6570 //
     /* 1445012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1445015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1445023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1445026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1445029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1445042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445062 */     // MIs[1] Operand 1
     /* 1445062 */     // No operand predicates
     /* 1445062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445066 */     // MIs[0] policy
     /* 1445066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445078 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1445081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1445100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445103 */     // GIR_Coverage, 6570,
     /* 1445103 */     GIR_EraseRootFromParent_Done,
     /* 1445104 */   // Label 20351: @1445104
     /* 1445104 */   GIM_Try, /*On fail goto*//*Label 20352*/ GIMT_Encode4(1445201), // Rule ID 6571 //
     /* 1445109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1445112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1445120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1445123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1445126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1445139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445159 */     // MIs[1] Operand 1
     /* 1445159 */     // No operand predicates
     /* 1445159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445163 */     // MIs[0] policy
     /* 1445163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445175 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1445178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1445197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445200 */     // GIR_Coverage, 6571,
     /* 1445200 */     GIR_EraseRootFromParent_Done,
     /* 1445201 */   // Label 20352: @1445201
     /* 1445201 */   GIM_Try, /*On fail goto*//*Label 20353*/ GIMT_Encode4(1445298), // Rule ID 6574 //
     /* 1445206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1445209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1445217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1445220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1445223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1445229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1445236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445256 */     // MIs[1] Operand 1
     /* 1445256 */     // No operand predicates
     /* 1445256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445260 */     // MIs[0] policy
     /* 1445260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445272 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1445275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1445294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445297 */     // GIR_Coverage, 6574,
     /* 1445297 */     GIR_EraseRootFromParent_Done,
     /* 1445298 */   // Label 20353: @1445298
     /* 1445298 */   GIM_Try, /*On fail goto*//*Label 20354*/ GIMT_Encode4(1445395), // Rule ID 6575 //
     /* 1445303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1445306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1445314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1445317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1445320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1445326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1445333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445353 */     // MIs[1] Operand 1
     /* 1445353 */     // No operand predicates
     /* 1445353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445357 */     // MIs[0] policy
     /* 1445357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445369 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1445372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1445391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445394 */     // GIR_Coverage, 6575,
     /* 1445394 */     GIR_EraseRootFromParent_Done,
     /* 1445395 */   // Label 20354: @1445395
     /* 1445395 */   GIM_Try, /*On fail goto*//*Label 20355*/ GIMT_Encode4(1445492), // Rule ID 6754 //
     /* 1445400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1445411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1445414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1445417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445450 */     // MIs[1] Operand 1
     /* 1445450 */     // No operand predicates
     /* 1445450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445454 */     // MIs[0] policy
     /* 1445454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445466 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1445469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445491 */     // GIR_Coverage, 6754,
     /* 1445491 */     GIR_EraseRootFromParent_Done,
     /* 1445492 */   // Label 20355: @1445492
     /* 1445492 */   GIM_Try, /*On fail goto*//*Label 20356*/ GIMT_Encode4(1445589), // Rule ID 6755 //
     /* 1445497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1445508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1445511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1445514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445547 */     // MIs[1] Operand 1
     /* 1445547 */     // No operand predicates
     /* 1445547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445551 */     // MIs[0] policy
     /* 1445551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445563 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1445566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445588 */     // GIR_Coverage, 6755,
     /* 1445588 */     GIR_EraseRootFromParent_Done,
     /* 1445589 */   // Label 20356: @1445589
     /* 1445589 */   GIM_Try, /*On fail goto*//*Label 20357*/ GIMT_Encode4(1445686), // Rule ID 6758 //
     /* 1445594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1445605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1445608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1445611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445644 */     // MIs[1] Operand 1
     /* 1445644 */     // No operand predicates
     /* 1445644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445648 */     // MIs[0] policy
     /* 1445648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445660 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1445663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445685 */     // GIR_Coverage, 6758,
     /* 1445685 */     GIR_EraseRootFromParent_Done,
     /* 1445686 */   // Label 20357: @1445686
     /* 1445686 */   GIM_Try, /*On fail goto*//*Label 20358*/ GIMT_Encode4(1445783), // Rule ID 6759 //
     /* 1445691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1445702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1445705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1445708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445741 */     // MIs[1] Operand 1
     /* 1445741 */     // No operand predicates
     /* 1445741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445745 */     // MIs[0] policy
     /* 1445745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445757 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1445760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445782 */     // GIR_Coverage, 6759,
     /* 1445782 */     GIR_EraseRootFromParent_Done,
     /* 1445783 */   // Label 20358: @1445783
     /* 1445783 */   GIM_Try, /*On fail goto*//*Label 20359*/ GIMT_Encode4(1445880), // Rule ID 6762 //
     /* 1445788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1445799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1445802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1445805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445838 */     // MIs[1] Operand 1
     /* 1445838 */     // No operand predicates
     /* 1445838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445842 */     // MIs[0] policy
     /* 1445842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445854 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445879 */     // GIR_Coverage, 6762,
     /* 1445879 */     GIR_EraseRootFromParent_Done,
     /* 1445880 */   // Label 20359: @1445880
     /* 1445880 */   GIM_Try, /*On fail goto*//*Label 20360*/ GIMT_Encode4(1445977), // Rule ID 6763 //
     /* 1445885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1445896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1445899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1445902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445935 */     // MIs[1] Operand 1
     /* 1445935 */     // No operand predicates
     /* 1445935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445939 */     // MIs[0] policy
     /* 1445939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445951 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445976 */     // GIR_Coverage, 6763,
     /* 1445976 */     GIR_EraseRootFromParent_Done,
     /* 1445977 */   // Label 20360: @1445977
     /* 1445977 */   GIM_Try, /*On fail goto*//*Label 20361*/ GIMT_Encode4(1446074), // Rule ID 6766 //
     /* 1445982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1445993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1445996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1445999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446032 */     // MIs[1] Operand 1
     /* 1446032 */     // No operand predicates
     /* 1446032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446036 */     // MIs[0] policy
     /* 1446036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446048 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1446051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446073 */     // GIR_Coverage, 6766,
     /* 1446073 */     GIR_EraseRootFromParent_Done,
     /* 1446074 */   // Label 20361: @1446074
     /* 1446074 */   GIM_Try, /*On fail goto*//*Label 20362*/ GIMT_Encode4(1446171), // Rule ID 6767 //
     /* 1446079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1446090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1446093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1446096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446129 */     // MIs[1] Operand 1
     /* 1446129 */     // No operand predicates
     /* 1446129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446133 */     // MIs[0] policy
     /* 1446133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446145 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1446148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446170 */     // GIR_Coverage, 6767,
     /* 1446170 */     GIR_EraseRootFromParent_Done,
     /* 1446171 */   // Label 20362: @1446171
     /* 1446171 */   GIM_Try, /*On fail goto*//*Label 20363*/ GIMT_Encode4(1446268), // Rule ID 6770 //
     /* 1446176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1446187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1446190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1446193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446226 */     // MIs[1] Operand 1
     /* 1446226 */     // No operand predicates
     /* 1446226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446230 */     // MIs[0] policy
     /* 1446230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446242 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1446245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446267 */     // GIR_Coverage, 6770,
     /* 1446267 */     GIR_EraseRootFromParent_Done,
     /* 1446268 */   // Label 20363: @1446268
     /* 1446268 */   GIM_Try, /*On fail goto*//*Label 20364*/ GIMT_Encode4(1446365), // Rule ID 6771 //
     /* 1446273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1446284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1446287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1446290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446323 */     // MIs[1] Operand 1
     /* 1446323 */     // No operand predicates
     /* 1446323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446327 */     // MIs[0] policy
     /* 1446327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446339 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1446342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446364 */     // GIR_Coverage, 6771,
     /* 1446364 */     GIR_EraseRootFromParent_Done,
     /* 1446365 */   // Label 20364: @1446365
     /* 1446365 */   GIM_Try, /*On fail goto*//*Label 20365*/ GIMT_Encode4(1446462), // Rule ID 6774 //
     /* 1446370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1446381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1446384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1446387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446420 */     // MIs[1] Operand 1
     /* 1446420 */     // No operand predicates
     /* 1446420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446424 */     // MIs[0] policy
     /* 1446424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1446439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446461 */     // GIR_Coverage, 6774,
     /* 1446461 */     GIR_EraseRootFromParent_Done,
     /* 1446462 */   // Label 20365: @1446462
     /* 1446462 */   GIM_Try, /*On fail goto*//*Label 20366*/ GIMT_Encode4(1446559), // Rule ID 6775 //
     /* 1446467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1446478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1446481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1446484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446517 */     // MIs[1] Operand 1
     /* 1446517 */     // No operand predicates
     /* 1446517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446521 */     // MIs[0] policy
     /* 1446521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446533 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1446536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446558 */     // GIR_Coverage, 6775,
     /* 1446558 */     GIR_EraseRootFromParent_Done,
     /* 1446559 */   // Label 20366: @1446559
     /* 1446559 */   GIM_Try, /*On fail goto*//*Label 20367*/ GIMT_Encode4(1446656), // Rule ID 6778 //
     /* 1446564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1446575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1446578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1446581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446614 */     // MIs[1] Operand 1
     /* 1446614 */     // No operand predicates
     /* 1446614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446618 */     // MIs[0] policy
     /* 1446618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446630 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446655 */     // GIR_Coverage, 6778,
     /* 1446655 */     GIR_EraseRootFromParent_Done,
     /* 1446656 */   // Label 20367: @1446656
     /* 1446656 */   GIM_Try, /*On fail goto*//*Label 20368*/ GIMT_Encode4(1446753), // Rule ID 6779 //
     /* 1446661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1446672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1446675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1446678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446711 */     // MIs[1] Operand 1
     /* 1446711 */     // No operand predicates
     /* 1446711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446715 */     // MIs[0] policy
     /* 1446715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446727 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446752 */     // GIR_Coverage, 6779,
     /* 1446752 */     GIR_EraseRootFromParent_Done,
     /* 1446753 */   // Label 20368: @1446753
     /* 1446753 */   GIM_Try, /*On fail goto*//*Label 20369*/ GIMT_Encode4(1446850), // Rule ID 6782 //
     /* 1446758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1446769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1446772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1446775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1446781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446808 */     // MIs[1] Operand 1
     /* 1446808 */     // No operand predicates
     /* 1446808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446812 */     // MIs[0] policy
     /* 1446812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446849 */     // GIR_Coverage, 6782,
     /* 1446849 */     GIR_EraseRootFromParent_Done,
     /* 1446850 */   // Label 20369: @1446850
     /* 1446850 */   GIM_Try, /*On fail goto*//*Label 20370*/ GIMT_Encode4(1446947), // Rule ID 6783 //
     /* 1446855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1446866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1446869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1446872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1446878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446905 */     // MIs[1] Operand 1
     /* 1446905 */     // No operand predicates
     /* 1446905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446909 */     // MIs[0] policy
     /* 1446909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446921 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446946 */     // GIR_Coverage, 6783,
     /* 1446946 */     GIR_EraseRootFromParent_Done,
     /* 1446947 */   // Label 20370: @1446947
     /* 1446947 */   GIM_Try, /*On fail goto*//*Label 20371*/ GIMT_Encode4(1447044), // Rule ID 6786 //
     /* 1446952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1446963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1446966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1446969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447002 */     // MIs[1] Operand 1
     /* 1447002 */     // No operand predicates
     /* 1447002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447006 */     // MIs[0] policy
     /* 1447006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1447021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447043 */     // GIR_Coverage, 6786,
     /* 1447043 */     GIR_EraseRootFromParent_Done,
     /* 1447044 */   // Label 20371: @1447044
     /* 1447044 */   GIM_Try, /*On fail goto*//*Label 20372*/ GIMT_Encode4(1447141), // Rule ID 6787 //
     /* 1447049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1447060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1447063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1447066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1447072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447099 */     // MIs[1] Operand 1
     /* 1447099 */     // No operand predicates
     /* 1447099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447103 */     // MIs[0] policy
     /* 1447103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447115 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1447118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447140 */     // GIR_Coverage, 6787,
     /* 1447140 */     GIR_EraseRootFromParent_Done,
     /* 1447141 */   // Label 20372: @1447141
     /* 1447141 */   GIM_Try, /*On fail goto*//*Label 20373*/ GIMT_Encode4(1447238), // Rule ID 6790 //
     /* 1447146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1447149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1447157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1447160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1447163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1447169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447196 */     // MIs[1] Operand 1
     /* 1447196 */     // No operand predicates
     /* 1447196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447200 */     // MIs[0] policy
     /* 1447200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447212 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1447215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1447234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447237 */     // GIR_Coverage, 6790,
     /* 1447237 */     GIR_EraseRootFromParent_Done,
     /* 1447238 */   // Label 20373: @1447238
     /* 1447238 */   GIM_Try, /*On fail goto*//*Label 20374*/ GIMT_Encode4(1447335), // Rule ID 6791 //
     /* 1447243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1447246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1447254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1447257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1447260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1447266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447293 */     // MIs[1] Operand 1
     /* 1447293 */     // No operand predicates
     /* 1447293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447297 */     // MIs[0] policy
     /* 1447297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447309 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1447312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1447331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447334 */     // GIR_Coverage, 6791,
     /* 1447334 */     GIR_EraseRootFromParent_Done,
     /* 1447335 */   // Label 20374: @1447335
     /* 1447335 */   GIM_Try, /*On fail goto*//*Label 20375*/ GIMT_Encode4(1447432), // Rule ID 6794 //
     /* 1447340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1447351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1447354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1447357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1447363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447390 */     // MIs[1] Operand 1
     /* 1447390 */     // No operand predicates
     /* 1447390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447394 */     // MIs[0] policy
     /* 1447394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447406 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1447409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447431 */     // GIR_Coverage, 6794,
     /* 1447431 */     GIR_EraseRootFromParent_Done,
     /* 1447432 */   // Label 20375: @1447432
     /* 1447432 */   GIM_Try, /*On fail goto*//*Label 20376*/ GIMT_Encode4(1447529), // Rule ID 6795 //
     /* 1447437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1447448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1447451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1447454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1447460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447487 */     // MIs[1] Operand 1
     /* 1447487 */     // No operand predicates
     /* 1447487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447491 */     // MIs[0] policy
     /* 1447491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447503 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1447506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447528 */     // GIR_Coverage, 6795,
     /* 1447528 */     GIR_EraseRootFromParent_Done,
     /* 1447529 */   // Label 20376: @1447529
     /* 1447529 */   GIM_Try, /*On fail goto*//*Label 20377*/ GIMT_Encode4(1447626), // Rule ID 6798 //
     /* 1447534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1447545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1447548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1447551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447584 */     // MIs[1] Operand 1
     /* 1447584 */     // No operand predicates
     /* 1447584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447588 */     // MIs[0] policy
     /* 1447588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447600 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1447603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447625 */     // GIR_Coverage, 6798,
     /* 1447625 */     GIR_EraseRootFromParent_Done,
     /* 1447626 */   // Label 20377: @1447626
     /* 1447626 */   GIM_Try, /*On fail goto*//*Label 20378*/ GIMT_Encode4(1447723), // Rule ID 6799 //
     /* 1447631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1447642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1447645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1447648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447681 */     // MIs[1] Operand 1
     /* 1447681 */     // No operand predicates
     /* 1447681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447685 */     // MIs[0] policy
     /* 1447685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447697 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1447700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447722 */     // GIR_Coverage, 6799,
     /* 1447722 */     GIR_EraseRootFromParent_Done,
     /* 1447723 */   // Label 20378: @1447723
     /* 1447723 */   GIM_Try, /*On fail goto*//*Label 20379*/ GIMT_Encode4(1447820), // Rule ID 6802 //
     /* 1447728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1447739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1447742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1447745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1447751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447778 */     // MIs[1] Operand 1
     /* 1447778 */     // No operand predicates
     /* 1447778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447782 */     // MIs[0] policy
     /* 1447782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447794 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1447797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447819 */     // GIR_Coverage, 6802,
     /* 1447819 */     GIR_EraseRootFromParent_Done,
     /* 1447820 */   // Label 20379: @1447820
     /* 1447820 */   GIM_Try, /*On fail goto*//*Label 20380*/ GIMT_Encode4(1447917), // Rule ID 6803 //
     /* 1447825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1447836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1447839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1447842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1447848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447875 */     // MIs[1] Operand 1
     /* 1447875 */     // No operand predicates
     /* 1447875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447879 */     // MIs[0] policy
     /* 1447879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447891 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1447894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447916 */     // GIR_Coverage, 6803,
     /* 1447916 */     GIR_EraseRootFromParent_Done,
     /* 1447917 */   // Label 20380: @1447917
     /* 1447917 */   GIM_Try, /*On fail goto*//*Label 20381*/ GIMT_Encode4(1448014), // Rule ID 6806 //
     /* 1447922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1447933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1447936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1447939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1447945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447972 */     // MIs[1] Operand 1
     /* 1447972 */     // No operand predicates
     /* 1447972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447976 */     // MIs[0] policy
     /* 1447976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447988 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1447991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448013 */     // GIR_Coverage, 6806,
     /* 1448013 */     GIR_EraseRootFromParent_Done,
     /* 1448014 */   // Label 20381: @1448014
     /* 1448014 */   GIM_Try, /*On fail goto*//*Label 20382*/ GIMT_Encode4(1448111), // Rule ID 6807 //
     /* 1448019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1448030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1448033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1448036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448069 */     // MIs[1] Operand 1
     /* 1448069 */     // No operand predicates
     /* 1448069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448073 */     // MIs[0] policy
     /* 1448073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448085 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448110 */     // GIR_Coverage, 6807,
     /* 1448110 */     GIR_EraseRootFromParent_Done,
     /* 1448111 */   // Label 20382: @1448111
     /* 1448111 */   GIM_Try, /*On fail goto*//*Label 20383*/ GIMT_Encode4(1448208), // Rule ID 6810 //
     /* 1448116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1448127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1448130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1448133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448166 */     // MIs[1] Operand 1
     /* 1448166 */     // No operand predicates
     /* 1448166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448170 */     // MIs[0] policy
     /* 1448170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448182 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448207 */     // GIR_Coverage, 6810,
     /* 1448207 */     GIR_EraseRootFromParent_Done,
     /* 1448208 */   // Label 20383: @1448208
     /* 1448208 */   GIM_Try, /*On fail goto*//*Label 20384*/ GIMT_Encode4(1448305), // Rule ID 6811 //
     /* 1448213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1448224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1448227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1448230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448263 */     // MIs[1] Operand 1
     /* 1448263 */     // No operand predicates
     /* 1448263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448267 */     // MIs[0] policy
     /* 1448267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448279 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448304 */     // GIR_Coverage, 6811,
     /* 1448304 */     GIR_EraseRootFromParent_Done,
     /* 1448305 */   // Label 20384: @1448305
     /* 1448305 */   GIM_Try, /*On fail goto*//*Label 20385*/ GIMT_Encode4(1448402), // Rule ID 6814 //
     /* 1448310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1448321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1448324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1448327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1448333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448360 */     // MIs[1] Operand 1
     /* 1448360 */     // No operand predicates
     /* 1448360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448364 */     // MIs[0] policy
     /* 1448364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448376 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1448379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448401 */     // GIR_Coverage, 6814,
     /* 1448401 */     GIR_EraseRootFromParent_Done,
     /* 1448402 */   // Label 20385: @1448402
     /* 1448402 */   GIM_Try, /*On fail goto*//*Label 20386*/ GIMT_Encode4(1448499), // Rule ID 6815 //
     /* 1448407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1448418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1448421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1448424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1448430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448457 */     // MIs[1] Operand 1
     /* 1448457 */     // No operand predicates
     /* 1448457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448461 */     // MIs[0] policy
     /* 1448461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448473 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1448476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448498 */     // GIR_Coverage, 6815,
     /* 1448498 */     GIR_EraseRootFromParent_Done,
     /* 1448499 */   // Label 20386: @1448499
     /* 1448499 */   GIM_Try, /*On fail goto*//*Label 20387*/ GIMT_Encode4(1448596), // Rule ID 6818 //
     /* 1448504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1448515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1448518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1448521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448554 */     // MIs[1] Operand 1
     /* 1448554 */     // No operand predicates
     /* 1448554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448558 */     // MIs[0] policy
     /* 1448558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448595 */     // GIR_Coverage, 6818,
     /* 1448595 */     GIR_EraseRootFromParent_Done,
     /* 1448596 */   // Label 20387: @1448596
     /* 1448596 */   GIM_Try, /*On fail goto*//*Label 20388*/ GIMT_Encode4(1448693), // Rule ID 6819 //
     /* 1448601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1448612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1448615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1448618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448651 */     // MIs[1] Operand 1
     /* 1448651 */     // No operand predicates
     /* 1448651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448655 */     // MIs[0] policy
     /* 1448655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448692 */     // GIR_Coverage, 6819,
     /* 1448692 */     GIR_EraseRootFromParent_Done,
     /* 1448693 */   // Label 20388: @1448693
     /* 1448693 */   GIM_Try, /*On fail goto*//*Label 20389*/ GIMT_Encode4(1448790), // Rule ID 6822 //
     /* 1448698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1448709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1448712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1448715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448748 */     // MIs[1] Operand 1
     /* 1448748 */     // No operand predicates
     /* 1448748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448752 */     // MIs[0] policy
     /* 1448752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448789 */     // GIR_Coverage, 6822,
     /* 1448789 */     GIR_EraseRootFromParent_Done,
     /* 1448790 */   // Label 20389: @1448790
     /* 1448790 */   GIM_Try, /*On fail goto*//*Label 20390*/ GIMT_Encode4(1448887), // Rule ID 6823 //
     /* 1448795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1448806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1448809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1448812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448845 */     // MIs[1] Operand 1
     /* 1448845 */     // No operand predicates
     /* 1448845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448849 */     // MIs[0] policy
     /* 1448849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448861 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448886 */     // GIR_Coverage, 6823,
     /* 1448886 */     GIR_EraseRootFromParent_Done,
     /* 1448887 */   // Label 20390: @1448887
     /* 1448887 */   GIM_Try, /*On fail goto*//*Label 20391*/ GIMT_Encode4(1448984), // Rule ID 6826 //
     /* 1448892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1448903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1448906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1448909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448942 */     // MIs[1] Operand 1
     /* 1448942 */     // No operand predicates
     /* 1448942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448946 */     // MIs[0] policy
     /* 1448946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448958 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1448961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448983 */     // GIR_Coverage, 6826,
     /* 1448983 */     GIR_EraseRootFromParent_Done,
     /* 1448984 */   // Label 20391: @1448984
     /* 1448984 */   GIM_Try, /*On fail goto*//*Label 20392*/ GIMT_Encode4(1449081), // Rule ID 6827 //
     /* 1448989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1449000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1449003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1449006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1449012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449039 */     // MIs[1] Operand 1
     /* 1449039 */     // No operand predicates
     /* 1449039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449043 */     // MIs[0] policy
     /* 1449043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449055 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1449058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1449077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449080 */     // GIR_Coverage, 6827,
     /* 1449080 */     GIR_EraseRootFromParent_Done,
     /* 1449081 */   // Label 20392: @1449081
     /* 1449081 */   GIM_Try, /*On fail goto*//*Label 20393*/ GIMT_Encode4(1449178), // Rule ID 6830 //
     /* 1449086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1449089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1449097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1449100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1449103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1449116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449136 */     // MIs[1] Operand 1
     /* 1449136 */     // No operand predicates
     /* 1449136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449140 */     // MIs[0] policy
     /* 1449140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449152 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1449155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449177 */     // GIR_Coverage, 6830,
     /* 1449177 */     GIR_EraseRootFromParent_Done,
     /* 1449178 */   // Label 20393: @1449178
     /* 1449178 */   GIM_Try, /*On fail goto*//*Label 20394*/ GIMT_Encode4(1449275), // Rule ID 6831 //
     /* 1449183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1449186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1449194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1449197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1449200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1449213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449233 */     // MIs[1] Operand 1
     /* 1449233 */     // No operand predicates
     /* 1449233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449237 */     // MIs[0] policy
     /* 1449237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449249 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1449252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449274 */     // GIR_Coverage, 6831,
     /* 1449274 */     GIR_EraseRootFromParent_Done,
     /* 1449275 */   // Label 20394: @1449275
     /* 1449275 */   GIM_Try, /*On fail goto*//*Label 20395*/ GIMT_Encode4(1449372), // Rule ID 6834 //
     /* 1449280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1449283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1449291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1449294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1449297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1449303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1449310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449330 */     // MIs[1] Operand 1
     /* 1449330 */     // No operand predicates
     /* 1449330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449334 */     // MIs[0] policy
     /* 1449334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449346 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1449349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449371 */     // GIR_Coverage, 6834,
     /* 1449371 */     GIR_EraseRootFromParent_Done,
     /* 1449372 */   // Label 20395: @1449372
     /* 1449372 */   GIM_Try, /*On fail goto*//*Label 20396*/ GIMT_Encode4(1449469), // Rule ID 6835 //
     /* 1449377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1449380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1449388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1449391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1449394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1449400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1449407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449427 */     // MIs[1] Operand 1
     /* 1449427 */     // No operand predicates
     /* 1449427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449431 */     // MIs[0] policy
     /* 1449431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449443 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1449446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449468 */     // GIR_Coverage, 6835,
     /* 1449468 */     GIR_EraseRootFromParent_Done,
     /* 1449469 */   // Label 20396: @1449469
     /* 1449469 */   GIM_Try, /*On fail goto*//*Label 20397*/ GIMT_Encode4(1449566), // Rule ID 6838 //
     /* 1449474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1449477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1449485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1449488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1449491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449524 */     // MIs[1] Operand 1
     /* 1449524 */     // No operand predicates
     /* 1449524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449528 */     // MIs[0] policy
     /* 1449528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449540 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1449543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449565 */     // GIR_Coverage, 6838,
     /* 1449565 */     GIR_EraseRootFromParent_Done,
     /* 1449566 */   // Label 20397: @1449566
     /* 1449566 */   GIM_Try, /*On fail goto*//*Label 20398*/ GIMT_Encode4(1449663), // Rule ID 6839 //
     /* 1449571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1449574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1449582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1449585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1449588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449621 */     // MIs[1] Operand 1
     /* 1449621 */     // No operand predicates
     /* 1449621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449625 */     // MIs[0] policy
     /* 1449625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449637 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1449640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449662 */     // GIR_Coverage, 6839,
     /* 1449662 */     GIR_EraseRootFromParent_Done,
     /* 1449663 */   // Label 20398: @1449663
     /* 1449663 */   GIM_Try, /*On fail goto*//*Label 20399*/ GIMT_Encode4(1449760), // Rule ID 7018 //
     /* 1449668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1449679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1449682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1449685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449718 */     // MIs[1] Operand 1
     /* 1449718 */     // No operand predicates
     /* 1449718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449722 */     // MIs[0] policy
     /* 1449722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449734 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1449737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449759 */     // GIR_Coverage, 7018,
     /* 1449759 */     GIR_EraseRootFromParent_Done,
     /* 1449760 */   // Label 20399: @1449760
     /* 1449760 */   GIM_Try, /*On fail goto*//*Label 20400*/ GIMT_Encode4(1449857), // Rule ID 7019 //
     /* 1449765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1449776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1449779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1449782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449815 */     // MIs[1] Operand 1
     /* 1449815 */     // No operand predicates
     /* 1449815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449819 */     // MIs[0] policy
     /* 1449819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449831 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1449834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449856 */     // GIR_Coverage, 7019,
     /* 1449856 */     GIR_EraseRootFromParent_Done,
     /* 1449857 */   // Label 20400: @1449857
     /* 1449857 */   GIM_Try, /*On fail goto*//*Label 20401*/ GIMT_Encode4(1449954), // Rule ID 7022 //
     /* 1449862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1449873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1449876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1449879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449912 */     // MIs[1] Operand 1
     /* 1449912 */     // No operand predicates
     /* 1449912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449916 */     // MIs[0] policy
     /* 1449916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449928 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1449931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449953 */     // GIR_Coverage, 7022,
     /* 1449953 */     GIR_EraseRootFromParent_Done,
     /* 1449954 */   // Label 20401: @1449954
     /* 1449954 */   GIM_Try, /*On fail goto*//*Label 20402*/ GIMT_Encode4(1450051), // Rule ID 7023 //
     /* 1449959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1449970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1449973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1449976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450009 */     // MIs[1] Operand 1
     /* 1450009 */     // No operand predicates
     /* 1450009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450013 */     // MIs[0] policy
     /* 1450013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450025 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1450028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450050 */     // GIR_Coverage, 7023,
     /* 1450050 */     GIR_EraseRootFromParent_Done,
     /* 1450051 */   // Label 20402: @1450051
     /* 1450051 */   GIM_Try, /*On fail goto*//*Label 20403*/ GIMT_Encode4(1450148), // Rule ID 7026 //
     /* 1450056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1450067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1450070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1450073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450106 */     // MIs[1] Operand 1
     /* 1450106 */     // No operand predicates
     /* 1450106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450110 */     // MIs[0] policy
     /* 1450110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450122 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450147 */     // GIR_Coverage, 7026,
     /* 1450147 */     GIR_EraseRootFromParent_Done,
     /* 1450148 */   // Label 20403: @1450148
     /* 1450148 */   GIM_Try, /*On fail goto*//*Label 20404*/ GIMT_Encode4(1450245), // Rule ID 7027 //
     /* 1450153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1450164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1450167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1450170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450203 */     // MIs[1] Operand 1
     /* 1450203 */     // No operand predicates
     /* 1450203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450207 */     // MIs[0] policy
     /* 1450207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450219 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450244 */     // GIR_Coverage, 7027,
     /* 1450244 */     GIR_EraseRootFromParent_Done,
     /* 1450245 */   // Label 20404: @1450245
     /* 1450245 */   GIM_Try, /*On fail goto*//*Label 20405*/ GIMT_Encode4(1450342), // Rule ID 7030 //
     /* 1450250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1450261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1450264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1450267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450300 */     // MIs[1] Operand 1
     /* 1450300 */     // No operand predicates
     /* 1450300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450304 */     // MIs[0] policy
     /* 1450304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450316 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1450319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450341 */     // GIR_Coverage, 7030,
     /* 1450341 */     GIR_EraseRootFromParent_Done,
     /* 1450342 */   // Label 20405: @1450342
     /* 1450342 */   GIM_Try, /*On fail goto*//*Label 20406*/ GIMT_Encode4(1450439), // Rule ID 7031 //
     /* 1450347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1450358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1450361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1450364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450397 */     // MIs[1] Operand 1
     /* 1450397 */     // No operand predicates
     /* 1450397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450401 */     // MIs[0] policy
     /* 1450401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450413 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1450416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450438 */     // GIR_Coverage, 7031,
     /* 1450438 */     GIR_EraseRootFromParent_Done,
     /* 1450439 */   // Label 20406: @1450439
     /* 1450439 */   GIM_Try, /*On fail goto*//*Label 20407*/ GIMT_Encode4(1450536), // Rule ID 7034 //
     /* 1450444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1450455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1450458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1450461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450494 */     // MIs[1] Operand 1
     /* 1450494 */     // No operand predicates
     /* 1450494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450498 */     // MIs[0] policy
     /* 1450498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450510 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450535 */     // GIR_Coverage, 7034,
     /* 1450535 */     GIR_EraseRootFromParent_Done,
     /* 1450536 */   // Label 20407: @1450536
     /* 1450536 */   GIM_Try, /*On fail goto*//*Label 20408*/ GIMT_Encode4(1450633), // Rule ID 7035 //
     /* 1450541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1450552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1450555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1450558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450591 */     // MIs[1] Operand 1
     /* 1450591 */     // No operand predicates
     /* 1450591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450595 */     // MIs[0] policy
     /* 1450595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450607 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450632 */     // GIR_Coverage, 7035,
     /* 1450632 */     GIR_EraseRootFromParent_Done,
     /* 1450633 */   // Label 20408: @1450633
     /* 1450633 */   GIM_Try, /*On fail goto*//*Label 20409*/ GIMT_Encode4(1450730), // Rule ID 7038 //
     /* 1450638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1450649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1450652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1450655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450688 */     // MIs[1] Operand 1
     /* 1450688 */     // No operand predicates
     /* 1450688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450692 */     // MIs[0] policy
     /* 1450692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450704 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450729 */     // GIR_Coverage, 7038,
     /* 1450729 */     GIR_EraseRootFromParent_Done,
     /* 1450730 */   // Label 20409: @1450730
     /* 1450730 */   GIM_Try, /*On fail goto*//*Label 20410*/ GIMT_Encode4(1450827), // Rule ID 7039 //
     /* 1450735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1450746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1450749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1450752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450785 */     // MIs[1] Operand 1
     /* 1450785 */     // No operand predicates
     /* 1450785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450789 */     // MIs[0] policy
     /* 1450789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450801 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450826 */     // GIR_Coverage, 7039,
     /* 1450826 */     GIR_EraseRootFromParent_Done,
     /* 1450827 */   // Label 20410: @1450827
     /* 1450827 */   GIM_Try, /*On fail goto*//*Label 20411*/ GIMT_Encode4(1450924), // Rule ID 7042 //
     /* 1450832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1450843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1450846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1450849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450882 */     // MIs[1] Operand 1
     /* 1450882 */     // No operand predicates
     /* 1450882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450886 */     // MIs[0] policy
     /* 1450886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450898 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450923 */     // GIR_Coverage, 7042,
     /* 1450923 */     GIR_EraseRootFromParent_Done,
     /* 1450924 */   // Label 20411: @1450924
     /* 1450924 */   GIM_Try, /*On fail goto*//*Label 20412*/ GIMT_Encode4(1451021), // Rule ID 7043 //
     /* 1450929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1450940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1450943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1450946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450979 */     // MIs[1] Operand 1
     /* 1450979 */     // No operand predicates
     /* 1450979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450983 */     // MIs[0] policy
     /* 1450983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450995 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451020 */     // GIR_Coverage, 7043,
     /* 1451020 */     GIR_EraseRootFromParent_Done,
     /* 1451021 */   // Label 20412: @1451021
     /* 1451021 */   GIM_Try, /*On fail goto*//*Label 20413*/ GIMT_Encode4(1451118), // Rule ID 7046 //
     /* 1451026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1451037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1451040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1451043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1451049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451076 */     // MIs[1] Operand 1
     /* 1451076 */     // No operand predicates
     /* 1451076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451080 */     // MIs[0] policy
     /* 1451080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451092 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451117 */     // GIR_Coverage, 7046,
     /* 1451117 */     GIR_EraseRootFromParent_Done,
     /* 1451118 */   // Label 20413: @1451118
     /* 1451118 */   GIM_Try, /*On fail goto*//*Label 20414*/ GIMT_Encode4(1451215), // Rule ID 7047 //
     /* 1451123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1451134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1451137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1451140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1451146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451173 */     // MIs[1] Operand 1
     /* 1451173 */     // No operand predicates
     /* 1451173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451177 */     // MIs[0] policy
     /* 1451177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451189 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451214 */     // GIR_Coverage, 7047,
     /* 1451214 */     GIR_EraseRootFromParent_Done,
     /* 1451215 */   // Label 20414: @1451215
     /* 1451215 */   GIM_Try, /*On fail goto*//*Label 20415*/ GIMT_Encode4(1451312), // Rule ID 7050 //
     /* 1451220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1451231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1451234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1451237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1451243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451270 */     // MIs[1] Operand 1
     /* 1451270 */     // No operand predicates
     /* 1451270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451274 */     // MIs[0] policy
     /* 1451274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1451308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451311 */     // GIR_Coverage, 7050,
     /* 1451311 */     GIR_EraseRootFromParent_Done,
     /* 1451312 */   // Label 20415: @1451312
     /* 1451312 */   GIM_Try, /*On fail goto*//*Label 20416*/ GIMT_Encode4(1451409), // Rule ID 7051 //
     /* 1451317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1451328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1451331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1451334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1451340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451367 */     // MIs[1] Operand 1
     /* 1451367 */     // No operand predicates
     /* 1451367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451371 */     // MIs[0] policy
     /* 1451371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451383 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1451405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451408 */     // GIR_Coverage, 7051,
     /* 1451408 */     GIR_EraseRootFromParent_Done,
     /* 1451409 */   // Label 20416: @1451409
     /* 1451409 */   GIM_Try, /*On fail goto*//*Label 20417*/ GIMT_Encode4(1451506), // Rule ID 7054 //
     /* 1451414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1451417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1451425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1451428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1451431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1451437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451464 */     // MIs[1] Operand 1
     /* 1451464 */     // No operand predicates
     /* 1451464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451468 */     // MIs[0] policy
     /* 1451468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451480 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451505 */     // GIR_Coverage, 7054,
     /* 1451505 */     GIR_EraseRootFromParent_Done,
     /* 1451506 */   // Label 20417: @1451506
     /* 1451506 */   GIM_Try, /*On fail goto*//*Label 20418*/ GIMT_Encode4(1451603), // Rule ID 7055 //
     /* 1451511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1451514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1451522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1451525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1451528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1451534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451561 */     // MIs[1] Operand 1
     /* 1451561 */     // No operand predicates
     /* 1451561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451565 */     // MIs[0] policy
     /* 1451565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451577 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451602 */     // GIR_Coverage, 7055,
     /* 1451602 */     GIR_EraseRootFromParent_Done,
     /* 1451603 */   // Label 20418: @1451603
     /* 1451603 */   GIM_Try, /*On fail goto*//*Label 20419*/ GIMT_Encode4(1451700), // Rule ID 7058 //
     /* 1451608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1451619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1451622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1451625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451658 */     // MIs[1] Operand 1
     /* 1451658 */     // No operand predicates
     /* 1451658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451662 */     // MIs[0] policy
     /* 1451662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451674 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1451677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451699 */     // GIR_Coverage, 7058,
     /* 1451699 */     GIR_EraseRootFromParent_Done,
     /* 1451700 */   // Label 20419: @1451700
     /* 1451700 */   GIM_Try, /*On fail goto*//*Label 20420*/ GIMT_Encode4(1451797), // Rule ID 7059 //
     /* 1451705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1451716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1451719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1451722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451755 */     // MIs[1] Operand 1
     /* 1451755 */     // No operand predicates
     /* 1451755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451759 */     // MIs[0] policy
     /* 1451759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451771 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1451774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451796 */     // GIR_Coverage, 7059,
     /* 1451796 */     GIR_EraseRootFromParent_Done,
     /* 1451797 */   // Label 20420: @1451797
     /* 1451797 */   GIM_Try, /*On fail goto*//*Label 20421*/ GIMT_Encode4(1451894), // Rule ID 7062 //
     /* 1451802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1451813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1451816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1451819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1451825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451852 */     // MIs[1] Operand 1
     /* 1451852 */     // No operand predicates
     /* 1451852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451856 */     // MIs[0] policy
     /* 1451856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1451871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451893 */     // GIR_Coverage, 7062,
     /* 1451893 */     GIR_EraseRootFromParent_Done,
     /* 1451894 */   // Label 20421: @1451894
     /* 1451894 */   GIM_Try, /*On fail goto*//*Label 20422*/ GIMT_Encode4(1451991), // Rule ID 7063 //
     /* 1451899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1451910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1451913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1451916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1451922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451949 */     // MIs[1] Operand 1
     /* 1451949 */     // No operand predicates
     /* 1451949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451953 */     // MIs[0] policy
     /* 1451953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451965 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1451968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451990 */     // GIR_Coverage, 7063,
     /* 1451990 */     GIR_EraseRootFromParent_Done,
     /* 1451991 */   // Label 20422: @1451991
     /* 1451991 */   GIM_Try, /*On fail goto*//*Label 20423*/ GIMT_Encode4(1452088), // Rule ID 7066 //
     /* 1451996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1452007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1452010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1452013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1452019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452046 */     // MIs[1] Operand 1
     /* 1452046 */     // No operand predicates
     /* 1452046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452050 */     // MIs[0] policy
     /* 1452050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452062 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1452084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452087 */     // GIR_Coverage, 7066,
     /* 1452087 */     GIR_EraseRootFromParent_Done,
     /* 1452088 */   // Label 20423: @1452088
     /* 1452088 */   GIM_Try, /*On fail goto*//*Label 20424*/ GIMT_Encode4(1452185), // Rule ID 7067 //
     /* 1452093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1452104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1452107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1452110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1452116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452143 */     // MIs[1] Operand 1
     /* 1452143 */     // No operand predicates
     /* 1452143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452147 */     // MIs[0] policy
     /* 1452147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452159 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1452181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452184 */     // GIR_Coverage, 7067,
     /* 1452184 */     GIR_EraseRootFromParent_Done,
     /* 1452185 */   // Label 20424: @1452185
     /* 1452185 */   GIM_Try, /*On fail goto*//*Label 20425*/ GIMT_Encode4(1452282), // Rule ID 7070 //
     /* 1452190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1452201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1452204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1452207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452240 */     // MIs[1] Operand 1
     /* 1452240 */     // No operand predicates
     /* 1452240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452244 */     // MIs[0] policy
     /* 1452244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452256 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452281 */     // GIR_Coverage, 7070,
     /* 1452281 */     GIR_EraseRootFromParent_Done,
     /* 1452282 */   // Label 20425: @1452282
     /* 1452282 */   GIM_Try, /*On fail goto*//*Label 20426*/ GIMT_Encode4(1452379), // Rule ID 7071 //
     /* 1452287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1452298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1452301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1452304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452337 */     // MIs[1] Operand 1
     /* 1452337 */     // No operand predicates
     /* 1452337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452341 */     // MIs[0] policy
     /* 1452341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452378 */     // GIR_Coverage, 7071,
     /* 1452378 */     GIR_EraseRootFromParent_Done,
     /* 1452379 */   // Label 20426: @1452379
     /* 1452379 */   GIM_Try, /*On fail goto*//*Label 20427*/ GIMT_Encode4(1452476), // Rule ID 7074 //
     /* 1452384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1452395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1452398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1452401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452434 */     // MIs[1] Operand 1
     /* 1452434 */     // No operand predicates
     /* 1452434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452438 */     // MIs[0] policy
     /* 1452438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452450 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1452453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452475 */     // GIR_Coverage, 7074,
     /* 1452475 */     GIR_EraseRootFromParent_Done,
     /* 1452476 */   // Label 20427: @1452476
     /* 1452476 */   GIM_Try, /*On fail goto*//*Label 20428*/ GIMT_Encode4(1452573), // Rule ID 7075 //
     /* 1452481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1452492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1452495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1452498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452531 */     // MIs[1] Operand 1
     /* 1452531 */     // No operand predicates
     /* 1452531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452535 */     // MIs[0] policy
     /* 1452535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452547 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1452550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452572 */     // GIR_Coverage, 7075,
     /* 1452572 */     GIR_EraseRootFromParent_Done,
     /* 1452573 */   // Label 20428: @1452573
     /* 1452573 */   GIM_Try, /*On fail goto*//*Label 20429*/ GIMT_Encode4(1452670), // Rule ID 7078 //
     /* 1452578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1452589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1452592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1452595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1452601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452628 */     // MIs[1] Operand 1
     /* 1452628 */     // No operand predicates
     /* 1452628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452632 */     // MIs[0] policy
     /* 1452632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452644 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452669 */     // GIR_Coverage, 7078,
     /* 1452669 */     GIR_EraseRootFromParent_Done,
     /* 1452670 */   // Label 20429: @1452670
     /* 1452670 */   GIM_Try, /*On fail goto*//*Label 20430*/ GIMT_Encode4(1452767), // Rule ID 7079 //
     /* 1452675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1452686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1452689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1452692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1452698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452725 */     // MIs[1] Operand 1
     /* 1452725 */     // No operand predicates
     /* 1452725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452729 */     // MIs[0] policy
     /* 1452729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452741 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452766 */     // GIR_Coverage, 7079,
     /* 1452766 */     GIR_EraseRootFromParent_Done,
     /* 1452767 */   // Label 20430: @1452767
     /* 1452767 */   GIM_Try, /*On fail goto*//*Label 20431*/ GIMT_Encode4(1452864), // Rule ID 7082 //
     /* 1452772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1452783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1452786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1452789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452822 */     // MIs[1] Operand 1
     /* 1452822 */     // No operand predicates
     /* 1452822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452826 */     // MIs[0] policy
     /* 1452826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452863 */     // GIR_Coverage, 7082,
     /* 1452863 */     GIR_EraseRootFromParent_Done,
     /* 1452864 */   // Label 20431: @1452864
     /* 1452864 */   GIM_Try, /*On fail goto*//*Label 20432*/ GIMT_Encode4(1452961), // Rule ID 7083 //
     /* 1452869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1452880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1452883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1452886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452919 */     // MIs[1] Operand 1
     /* 1452919 */     // No operand predicates
     /* 1452919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452923 */     // MIs[0] policy
     /* 1452923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452935 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452960 */     // GIR_Coverage, 7083,
     /* 1452960 */     GIR_EraseRootFromParent_Done,
     /* 1452961 */   // Label 20432: @1452961
     /* 1452961 */   GIM_Try, /*On fail goto*//*Label 20433*/ GIMT_Encode4(1453058), // Rule ID 7086 //
     /* 1452966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1452977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1452980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1452983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453016 */     // MIs[1] Operand 1
     /* 1453016 */     // No operand predicates
     /* 1453016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453020 */     // MIs[0] policy
     /* 1453020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453032 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1453035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453057 */     // GIR_Coverage, 7086,
     /* 1453057 */     GIR_EraseRootFromParent_Done,
     /* 1453058 */   // Label 20433: @1453058
     /* 1453058 */   GIM_Try, /*On fail goto*//*Label 20434*/ GIMT_Encode4(1453155), // Rule ID 7087 //
     /* 1453063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1453074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1453077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1453080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453113 */     // MIs[1] Operand 1
     /* 1453113 */     // No operand predicates
     /* 1453113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453117 */     // MIs[0] policy
     /* 1453117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453129 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1453132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453154 */     // GIR_Coverage, 7087,
     /* 1453154 */     GIR_EraseRootFromParent_Done,
     /* 1453155 */   // Label 20434: @1453155
     /* 1453155 */   GIM_Try, /*On fail goto*//*Label 20435*/ GIMT_Encode4(1453252), // Rule ID 7090 //
     /* 1453160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1453171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1453174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1453177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1453183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453210 */     // MIs[1] Operand 1
     /* 1453210 */     // No operand predicates
     /* 1453210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453214 */     // MIs[0] policy
     /* 1453214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453226 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1453229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453251 */     // GIR_Coverage, 7090,
     /* 1453251 */     GIR_EraseRootFromParent_Done,
     /* 1453252 */   // Label 20435: @1453252
     /* 1453252 */   GIM_Try, /*On fail goto*//*Label 20436*/ GIMT_Encode4(1453349), // Rule ID 7091 //
     /* 1453257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1453268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1453271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1453274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1453280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453307 */     // MIs[1] Operand 1
     /* 1453307 */     // No operand predicates
     /* 1453307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453311 */     // MIs[0] policy
     /* 1453311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453323 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1453326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453348 */     // GIR_Coverage, 7091,
     /* 1453348 */     GIR_EraseRootFromParent_Done,
     /* 1453349 */   // Label 20436: @1453349
     /* 1453349 */   GIM_Try, /*On fail goto*//*Label 20437*/ GIMT_Encode4(1453446), // Rule ID 7094 //
     /* 1453354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1453357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1453365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1453368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1453371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453404 */     // MIs[1] Operand 1
     /* 1453404 */     // No operand predicates
     /* 1453404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453408 */     // MIs[0] policy
     /* 1453408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453420 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1453423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453445 */     // GIR_Coverage, 7094,
     /* 1453445 */     GIR_EraseRootFromParent_Done,
     /* 1453446 */   // Label 20437: @1453446
     /* 1453446 */   GIM_Try, /*On fail goto*//*Label 20438*/ GIMT_Encode4(1453543), // Rule ID 7095 //
     /* 1453451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1453454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1453462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1453465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1453468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453501 */     // MIs[1] Operand 1
     /* 1453501 */     // No operand predicates
     /* 1453501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453505 */     // MIs[0] policy
     /* 1453505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453517 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1453520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453542 */     // GIR_Coverage, 7095,
     /* 1453542 */     GIR_EraseRootFromParent_Done,
     /* 1453543 */   // Label 20438: @1453543
     /* 1453543 */   GIM_Try, /*On fail goto*//*Label 20439*/ GIMT_Encode4(1453640), // Rule ID 7098 //
     /* 1453548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1453551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1453559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1453562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1453565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453598 */     // MIs[1] Operand 1
     /* 1453598 */     // No operand predicates
     /* 1453598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453602 */     // MIs[0] policy
     /* 1453602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453614 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1453617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453639 */     // GIR_Coverage, 7098,
     /* 1453639 */     GIR_EraseRootFromParent_Done,
     /* 1453640 */   // Label 20439: @1453640
     /* 1453640 */   GIM_Try, /*On fail goto*//*Label 20440*/ GIMT_Encode4(1453737), // Rule ID 7099 //
     /* 1453645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1453648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1453656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1453659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1453662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453695 */     // MIs[1] Operand 1
     /* 1453695 */     // No operand predicates
     /* 1453695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453699 */     // MIs[0] policy
     /* 1453699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453711 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1453714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453736 */     // GIR_Coverage, 7099,
     /* 1453736 */     GIR_EraseRootFromParent_Done,
     /* 1453737 */   // Label 20440: @1453737
     /* 1453737 */   GIM_Try, /*On fail goto*//*Label 20441*/ GIMT_Encode4(1453834), // Rule ID 7102 //
     /* 1453742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1453745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1453753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1453756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1453759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453792 */     // MIs[1] Operand 1
     /* 1453792 */     // No operand predicates
     /* 1453792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453796 */     // MIs[0] policy
     /* 1453796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453808 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1453811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453833 */     // GIR_Coverage, 7102,
     /* 1453833 */     GIR_EraseRootFromParent_Done,
     /* 1453834 */   // Label 20441: @1453834
     /* 1453834 */   GIM_Try, /*On fail goto*//*Label 20442*/ GIMT_Encode4(1453931), // Rule ID 7103 //
     /* 1453839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1453842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1453850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1453853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1453856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453889 */     // MIs[1] Operand 1
     /* 1453889 */     // No operand predicates
     /* 1453889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453893 */     // MIs[0] policy
     /* 1453893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453905 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1453908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453930 */     // GIR_Coverage, 7103,
     /* 1453930 */     GIR_EraseRootFromParent_Done,
     /* 1453931 */   // Label 20442: @1453931
     /* 1453931 */   GIM_Try, /*On fail goto*//*Label 20443*/ GIMT_Encode4(1454028), // Rule ID 7282 //
     /* 1453936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1453947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1453950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1453953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453986 */     // MIs[1] Operand 1
     /* 1453986 */     // No operand predicates
     /* 1453986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453990 */     // MIs[0] policy
     /* 1453990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454002 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1454005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454027 */     // GIR_Coverage, 7282,
     /* 1454027 */     GIR_EraseRootFromParent_Done,
     /* 1454028 */   // Label 20443: @1454028
     /* 1454028 */   GIM_Try, /*On fail goto*//*Label 20444*/ GIMT_Encode4(1454125), // Rule ID 7283 //
     /* 1454033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1454044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1454047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1454050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454083 */     // MIs[1] Operand 1
     /* 1454083 */     // No operand predicates
     /* 1454083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454087 */     // MIs[0] policy
     /* 1454087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454099 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1454102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454124 */     // GIR_Coverage, 7283,
     /* 1454124 */     GIR_EraseRootFromParent_Done,
     /* 1454125 */   // Label 20444: @1454125
     /* 1454125 */   GIM_Try, /*On fail goto*//*Label 20445*/ GIMT_Encode4(1454222), // Rule ID 7286 //
     /* 1454130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1454141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1454144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1454147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454176 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454180 */     // MIs[1] Operand 1
     /* 1454180 */     // No operand predicates
     /* 1454180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454184 */     // MIs[0] policy
     /* 1454184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454196 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1454199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454221 */     // GIR_Coverage, 7286,
     /* 1454221 */     GIR_EraseRootFromParent_Done,
     /* 1454222 */   // Label 20445: @1454222
     /* 1454222 */   GIM_Try, /*On fail goto*//*Label 20446*/ GIMT_Encode4(1454319), // Rule ID 7287 //
     /* 1454227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1454238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1454241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1454244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454277 */     // MIs[1] Operand 1
     /* 1454277 */     // No operand predicates
     /* 1454277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454281 */     // MIs[0] policy
     /* 1454281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454293 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1454296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454318 */     // GIR_Coverage, 7287,
     /* 1454318 */     GIR_EraseRootFromParent_Done,
     /* 1454319 */   // Label 20446: @1454319
     /* 1454319 */   GIM_Try, /*On fail goto*//*Label 20447*/ GIMT_Encode4(1454416), // Rule ID 7290 //
     /* 1454324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1454335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1454338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1454341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454374 */     // MIs[1] Operand 1
     /* 1454374 */     // No operand predicates
     /* 1454374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454378 */     // MIs[0] policy
     /* 1454378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454390 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454415 */     // GIR_Coverage, 7290,
     /* 1454415 */     GIR_EraseRootFromParent_Done,
     /* 1454416 */   // Label 20447: @1454416
     /* 1454416 */   GIM_Try, /*On fail goto*//*Label 20448*/ GIMT_Encode4(1454513), // Rule ID 7291 //
     /* 1454421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1454432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1454435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1454438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454471 */     // MIs[1] Operand 1
     /* 1454471 */     // No operand predicates
     /* 1454471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454475 */     // MIs[0] policy
     /* 1454475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454487 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454512 */     // GIR_Coverage, 7291,
     /* 1454512 */     GIR_EraseRootFromParent_Done,
     /* 1454513 */   // Label 20448: @1454513
     /* 1454513 */   GIM_Try, /*On fail goto*//*Label 20449*/ GIMT_Encode4(1454610), // Rule ID 7294 //
     /* 1454518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1454529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1454532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1454535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454568 */     // MIs[1] Operand 1
     /* 1454568 */     // No operand predicates
     /* 1454568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454572 */     // MIs[0] policy
     /* 1454572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454584 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1454587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454609 */     // GIR_Coverage, 7294,
     /* 1454609 */     GIR_EraseRootFromParent_Done,
     /* 1454610 */   // Label 20449: @1454610
     /* 1454610 */   GIM_Try, /*On fail goto*//*Label 20450*/ GIMT_Encode4(1454707), // Rule ID 7295 //
     /* 1454615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1454626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1454629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1454632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454665 */     // MIs[1] Operand 1
     /* 1454665 */     // No operand predicates
     /* 1454665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454669 */     // MIs[0] policy
     /* 1454669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454681 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1454684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454706 */     // GIR_Coverage, 7295,
     /* 1454706 */     GIR_EraseRootFromParent_Done,
     /* 1454707 */   // Label 20450: @1454707
     /* 1454707 */   GIM_Try, /*On fail goto*//*Label 20451*/ GIMT_Encode4(1454804), // Rule ID 7298 //
     /* 1454712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1454723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1454726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1454729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454762 */     // MIs[1] Operand 1
     /* 1454762 */     // No operand predicates
     /* 1454762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454766 */     // MIs[0] policy
     /* 1454766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454778 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454803 */     // GIR_Coverage, 7298,
     /* 1454803 */     GIR_EraseRootFromParent_Done,
     /* 1454804 */   // Label 20451: @1454804
     /* 1454804 */   GIM_Try, /*On fail goto*//*Label 20452*/ GIMT_Encode4(1454901), // Rule ID 7299 //
     /* 1454809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1454820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1454823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1454826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454859 */     // MIs[1] Operand 1
     /* 1454859 */     // No operand predicates
     /* 1454859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454863 */     // MIs[0] policy
     /* 1454863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454875 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454900 */     // GIR_Coverage, 7299,
     /* 1454900 */     GIR_EraseRootFromParent_Done,
     /* 1454901 */   // Label 20452: @1454901
     /* 1454901 */   GIM_Try, /*On fail goto*//*Label 20453*/ GIMT_Encode4(1454998), // Rule ID 7302 //
     /* 1454906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1454917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1454920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1454923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454956 */     // MIs[1] Operand 1
     /* 1454956 */     // No operand predicates
     /* 1454956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454960 */     // MIs[0] policy
     /* 1454960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454997 */     // GIR_Coverage, 7302,
     /* 1454997 */     GIR_EraseRootFromParent_Done,
     /* 1454998 */   // Label 20453: @1454998
     /* 1454998 */   GIM_Try, /*On fail goto*//*Label 20454*/ GIMT_Encode4(1455095), // Rule ID 7303 //
     /* 1455003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1455014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1455017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1455020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455053 */     // MIs[1] Operand 1
     /* 1455053 */     // No operand predicates
     /* 1455053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455057 */     // MIs[0] policy
     /* 1455057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455069 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1455072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455094 */     // GIR_Coverage, 7303,
     /* 1455094 */     GIR_EraseRootFromParent_Done,
     /* 1455095 */   // Label 20454: @1455095
     /* 1455095 */   GIM_Try, /*On fail goto*//*Label 20455*/ GIMT_Encode4(1455192), // Rule ID 7306 //
     /* 1455100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1455111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1455114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1455117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1455123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455150 */     // MIs[1] Operand 1
     /* 1455150 */     // No operand predicates
     /* 1455150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455154 */     // MIs[0] policy
     /* 1455154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455166 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455191 */     // GIR_Coverage, 7306,
     /* 1455191 */     GIR_EraseRootFromParent_Done,
     /* 1455192 */   // Label 20455: @1455192
     /* 1455192 */   GIM_Try, /*On fail goto*//*Label 20456*/ GIMT_Encode4(1455289), // Rule ID 7307 //
     /* 1455197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1455208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1455211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1455214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1455220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455247 */     // MIs[1] Operand 1
     /* 1455247 */     // No operand predicates
     /* 1455247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455251 */     // MIs[0] policy
     /* 1455251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455263 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455288 */     // GIR_Coverage, 7307,
     /* 1455288 */     GIR_EraseRootFromParent_Done,
     /* 1455289 */   // Label 20456: @1455289
     /* 1455289 */   GIM_Try, /*On fail goto*//*Label 20457*/ GIMT_Encode4(1455386), // Rule ID 7310 //
     /* 1455294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1455305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1455308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1455311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1455317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455344 */     // MIs[1] Operand 1
     /* 1455344 */     // No operand predicates
     /* 1455344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455348 */     // MIs[0] policy
     /* 1455348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455360 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455385 */     // GIR_Coverage, 7310,
     /* 1455385 */     GIR_EraseRootFromParent_Done,
     /* 1455386 */   // Label 20457: @1455386
     /* 1455386 */   GIM_Try, /*On fail goto*//*Label 20458*/ GIMT_Encode4(1455483), // Rule ID 7311 //
     /* 1455391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1455402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1455405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1455408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1455414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455441 */     // MIs[1] Operand 1
     /* 1455441 */     // No operand predicates
     /* 1455441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455445 */     // MIs[0] policy
     /* 1455445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455457 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455482 */     // GIR_Coverage, 7311,
     /* 1455482 */     GIR_EraseRootFromParent_Done,
     /* 1455483 */   // Label 20458: @1455483
     /* 1455483 */   GIM_Try, /*On fail goto*//*Label 20459*/ GIMT_Encode4(1455580), // Rule ID 7314 //
     /* 1455488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1455499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1455502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1455505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455538 */     // MIs[1] Operand 1
     /* 1455538 */     // No operand predicates
     /* 1455538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455542 */     // MIs[0] policy
     /* 1455542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455554 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455579 */     // GIR_Coverage, 7314,
     /* 1455579 */     GIR_EraseRootFromParent_Done,
     /* 1455580 */   // Label 20459: @1455580
     /* 1455580 */   GIM_Try, /*On fail goto*//*Label 20460*/ GIMT_Encode4(1455677), // Rule ID 7315 //
     /* 1455585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1455596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1455599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1455602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455635 */     // MIs[1] Operand 1
     /* 1455635 */     // No operand predicates
     /* 1455635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455639 */     // MIs[0] policy
     /* 1455639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455651 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455676 */     // GIR_Coverage, 7315,
     /* 1455676 */     GIR_EraseRootFromParent_Done,
     /* 1455677 */   // Label 20460: @1455677
     /* 1455677 */   GIM_Try, /*On fail goto*//*Label 20461*/ GIMT_Encode4(1455774), // Rule ID 7318 //
     /* 1455682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1455685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1455693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1455696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1455699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455732 */     // MIs[1] Operand 1
     /* 1455732 */     // No operand predicates
     /* 1455732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455736 */     // MIs[0] policy
     /* 1455736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455748 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455773 */     // GIR_Coverage, 7318,
     /* 1455773 */     GIR_EraseRootFromParent_Done,
     /* 1455774 */   // Label 20461: @1455774
     /* 1455774 */   GIM_Try, /*On fail goto*//*Label 20462*/ GIMT_Encode4(1455871), // Rule ID 7319 //
     /* 1455779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1455782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1455790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1455793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1455796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455829 */     // MIs[1] Operand 1
     /* 1455829 */     // No operand predicates
     /* 1455829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455833 */     // MIs[0] policy
     /* 1455833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455845 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455870 */     // GIR_Coverage, 7319,
     /* 1455870 */     GIR_EraseRootFromParent_Done,
     /* 1455871 */   // Label 20462: @1455871
     /* 1455871 */   GIM_Try, /*On fail goto*//*Label 20463*/ GIMT_Encode4(1455968), // Rule ID 7322 //
     /* 1455876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1455887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1455890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1455893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1455899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455926 */     // MIs[1] Operand 1
     /* 1455926 */     // No operand predicates
     /* 1455926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455930 */     // MIs[0] policy
     /* 1455930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455942 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1455945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455967 */     // GIR_Coverage, 7322,
     /* 1455967 */     GIR_EraseRootFromParent_Done,
     /* 1455968 */   // Label 20463: @1455968
     /* 1455968 */   GIM_Try, /*On fail goto*//*Label 20464*/ GIMT_Encode4(1456065), // Rule ID 7323 //
     /* 1455973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1455984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1455987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1455990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1455996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456023 */     // MIs[1] Operand 1
     /* 1456023 */     // No operand predicates
     /* 1456023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456027 */     // MIs[0] policy
     /* 1456027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456039 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456064 */     // GIR_Coverage, 7323,
     /* 1456064 */     GIR_EraseRootFromParent_Done,
     /* 1456065 */   // Label 20464: @1456065
     /* 1456065 */   GIM_Try, /*On fail goto*//*Label 20465*/ GIMT_Encode4(1456162), // Rule ID 7326 //
     /* 1456070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1456081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1456084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1456087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456120 */     // MIs[1] Operand 1
     /* 1456120 */     // No operand predicates
     /* 1456120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456124 */     // MIs[0] policy
     /* 1456124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456136 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456161 */     // GIR_Coverage, 7326,
     /* 1456161 */     GIR_EraseRootFromParent_Done,
     /* 1456162 */   // Label 20465: @1456162
     /* 1456162 */   GIM_Try, /*On fail goto*//*Label 20466*/ GIMT_Encode4(1456259), // Rule ID 7327 //
     /* 1456167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1456178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1456181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1456184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456217 */     // MIs[1] Operand 1
     /* 1456217 */     // No operand predicates
     /* 1456217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456221 */     // MIs[0] policy
     /* 1456221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456233 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456258 */     // GIR_Coverage, 7327,
     /* 1456258 */     GIR_EraseRootFromParent_Done,
     /* 1456259 */   // Label 20466: @1456259
     /* 1456259 */   GIM_Try, /*On fail goto*//*Label 20467*/ GIMT_Encode4(1456356), // Rule ID 7330 //
     /* 1456264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1456275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1456278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1456281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1456287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456314 */     // MIs[1] Operand 1
     /* 1456314 */     // No operand predicates
     /* 1456314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456318 */     // MIs[0] policy
     /* 1456318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456330 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1456333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456355 */     // GIR_Coverage, 7330,
     /* 1456355 */     GIR_EraseRootFromParent_Done,
     /* 1456356 */   // Label 20467: @1456356
     /* 1456356 */   GIM_Try, /*On fail goto*//*Label 20468*/ GIMT_Encode4(1456453), // Rule ID 7331 //
     /* 1456361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1456372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1456375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1456378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1456384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456411 */     // MIs[1] Operand 1
     /* 1456411 */     // No operand predicates
     /* 1456411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456415 */     // MIs[0] policy
     /* 1456415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456427 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1456430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456452 */     // GIR_Coverage, 7331,
     /* 1456452 */     GIR_EraseRootFromParent_Done,
     /* 1456453 */   // Label 20468: @1456453
     /* 1456453 */   GIM_Try, /*On fail goto*//*Label 20469*/ GIMT_Encode4(1456550), // Rule ID 7334 //
     /* 1456458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1456469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1456472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1456475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456508 */     // MIs[1] Operand 1
     /* 1456508 */     // No operand predicates
     /* 1456508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456512 */     // MIs[0] policy
     /* 1456512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456524 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456549 */     // GIR_Coverage, 7334,
     /* 1456549 */     GIR_EraseRootFromParent_Done,
     /* 1456550 */   // Label 20469: @1456550
     /* 1456550 */   GIM_Try, /*On fail goto*//*Label 20470*/ GIMT_Encode4(1456647), // Rule ID 7335 //
     /* 1456555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1456566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1456569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1456572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456605 */     // MIs[1] Operand 1
     /* 1456605 */     // No operand predicates
     /* 1456605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456609 */     // MIs[0] policy
     /* 1456609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456646 */     // GIR_Coverage, 7335,
     /* 1456646 */     GIR_EraseRootFromParent_Done,
     /* 1456647 */   // Label 20470: @1456647
     /* 1456647 */   GIM_Try, /*On fail goto*//*Label 20471*/ GIMT_Encode4(1456744), // Rule ID 7338 //
     /* 1456652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1456663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1456666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1456669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456702 */     // MIs[1] Operand 1
     /* 1456702 */     // No operand predicates
     /* 1456702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456706 */     // MIs[0] policy
     /* 1456706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456718 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456743 */     // GIR_Coverage, 7338,
     /* 1456743 */     GIR_EraseRootFromParent_Done,
     /* 1456744 */   // Label 20471: @1456744
     /* 1456744 */   GIM_Try, /*On fail goto*//*Label 20472*/ GIMT_Encode4(1456841), // Rule ID 7339 //
     /* 1456749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1456760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1456763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1456766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456799 */     // MIs[1] Operand 1
     /* 1456799 */     // No operand predicates
     /* 1456799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456803 */     // MIs[0] policy
     /* 1456803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456815 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456840 */     // GIR_Coverage, 7339,
     /* 1456840 */     GIR_EraseRootFromParent_Done,
     /* 1456841 */   // Label 20472: @1456841
     /* 1456841 */   GIM_Try, /*On fail goto*//*Label 20473*/ GIMT_Encode4(1456938), // Rule ID 7342 //
     /* 1456846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1456857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1456860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1456863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456896 */     // MIs[1] Operand 1
     /* 1456896 */     // No operand predicates
     /* 1456896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456900 */     // MIs[0] policy
     /* 1456900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456912 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1456915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456937 */     // GIR_Coverage, 7342,
     /* 1456937 */     GIR_EraseRootFromParent_Done,
     /* 1456938 */   // Label 20473: @1456938
     /* 1456938 */   GIM_Try, /*On fail goto*//*Label 20474*/ GIMT_Encode4(1457035), // Rule ID 7343 //
     /* 1456943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1456954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1456957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1456960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456993 */     // MIs[1] Operand 1
     /* 1456993 */     // No operand predicates
     /* 1456993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456997 */     // MIs[0] policy
     /* 1456997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457009 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457034 */     // GIR_Coverage, 7343,
     /* 1457034 */     GIR_EraseRootFromParent_Done,
     /* 1457035 */   // Label 20474: @1457035
     /* 1457035 */   GIM_Try, /*On fail goto*//*Label 20475*/ GIMT_Encode4(1457132), // Rule ID 7346 //
     /* 1457040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1457051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1457054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1457057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457090 */     // MIs[1] Operand 1
     /* 1457090 */     // No operand predicates
     /* 1457090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457094 */     // MIs[0] policy
     /* 1457094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1457109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457131 */     // GIR_Coverage, 7346,
     /* 1457131 */     GIR_EraseRootFromParent_Done,
     /* 1457132 */   // Label 20475: @1457132
     /* 1457132 */   GIM_Try, /*On fail goto*//*Label 20476*/ GIMT_Encode4(1457229), // Rule ID 7347 //
     /* 1457137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1457148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1457151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1457154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457187 */     // MIs[1] Operand 1
     /* 1457187 */     // No operand predicates
     /* 1457187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457191 */     // MIs[0] policy
     /* 1457191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457203 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1457206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457228 */     // GIR_Coverage, 7347,
     /* 1457228 */     GIR_EraseRootFromParent_Done,
     /* 1457229 */   // Label 20476: @1457229
     /* 1457229 */   GIM_Try, /*On fail goto*//*Label 20477*/ GIMT_Encode4(1457326), // Rule ID 7350 //
     /* 1457234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1457245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1457248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1457251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1457257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457284 */     // MIs[1] Operand 1
     /* 1457284 */     // No operand predicates
     /* 1457284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457288 */     // MIs[0] policy
     /* 1457288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457300 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1457303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457325 */     // GIR_Coverage, 7350,
     /* 1457325 */     GIR_EraseRootFromParent_Done,
     /* 1457326 */   // Label 20477: @1457326
     /* 1457326 */   GIM_Try, /*On fail goto*//*Label 20478*/ GIMT_Encode4(1457423), // Rule ID 7351 //
     /* 1457331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1457342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1457345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1457348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1457354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457381 */     // MIs[1] Operand 1
     /* 1457381 */     // No operand predicates
     /* 1457381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457385 */     // MIs[0] policy
     /* 1457385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457397 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1457400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457422 */     // GIR_Coverage, 7351,
     /* 1457422 */     GIR_EraseRootFromParent_Done,
     /* 1457423 */   // Label 20478: @1457423
     /* 1457423 */   GIM_Try, /*On fail goto*//*Label 20479*/ GIMT_Encode4(1457520), // Rule ID 7354 //
     /* 1457428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1457439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1457442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1457445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1457451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1457458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457478 */     // MIs[1] Operand 1
     /* 1457478 */     // No operand predicates
     /* 1457478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457482 */     // MIs[0] policy
     /* 1457482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457494 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457519 */     // GIR_Coverage, 7354,
     /* 1457519 */     GIR_EraseRootFromParent_Done,
     /* 1457520 */   // Label 20479: @1457520
     /* 1457520 */   GIM_Try, /*On fail goto*//*Label 20480*/ GIMT_Encode4(1457617), // Rule ID 7355 //
     /* 1457525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1457536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1457539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1457542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1457548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1457555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457575 */     // MIs[1] Operand 1
     /* 1457575 */     // No operand predicates
     /* 1457575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457579 */     // MIs[0] policy
     /* 1457579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457591 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457616 */     // GIR_Coverage, 7355,
     /* 1457616 */     GIR_EraseRootFromParent_Done,
     /* 1457617 */   // Label 20480: @1457617
     /* 1457617 */   GIM_Try, /*On fail goto*//*Label 20481*/ GIMT_Encode4(1457714), // Rule ID 7358 //
     /* 1457622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1457625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1457633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1457636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1457639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457672 */     // MIs[1] Operand 1
     /* 1457672 */     // No operand predicates
     /* 1457672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457676 */     // MIs[0] policy
     /* 1457676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1457691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457713 */     // GIR_Coverage, 7358,
     /* 1457713 */     GIR_EraseRootFromParent_Done,
     /* 1457714 */   // Label 20481: @1457714
     /* 1457714 */   GIM_Try, /*On fail goto*//*Label 20482*/ GIMT_Encode4(1457811), // Rule ID 7359 //
     /* 1457719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1457722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1457730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1457733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1457736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457769 */     // MIs[1] Operand 1
     /* 1457769 */     // No operand predicates
     /* 1457769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457773 */     // MIs[0] policy
     /* 1457773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457785 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1457788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457810 */     // GIR_Coverage, 7359,
     /* 1457810 */     GIR_EraseRootFromParent_Done,
     /* 1457811 */   // Label 20482: @1457811
     /* 1457811 */   GIM_Try, /*On fail goto*//*Label 20483*/ GIMT_Encode4(1457908), // Rule ID 7362 //
     /* 1457816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1457819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1457827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1457830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1457833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457866 */     // MIs[1] Operand 1
     /* 1457866 */     // No operand predicates
     /* 1457866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457870 */     // MIs[0] policy
     /* 1457870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457882 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1457885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457907 */     // GIR_Coverage, 7362,
     /* 1457907 */     GIR_EraseRootFromParent_Done,
     /* 1457908 */   // Label 20483: @1457908
     /* 1457908 */   GIM_Try, /*On fail goto*//*Label 20484*/ GIMT_Encode4(1458005), // Rule ID 7363 //
     /* 1457913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1457916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1457924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1457927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1457930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457963 */     // MIs[1] Operand 1
     /* 1457963 */     // No operand predicates
     /* 1457963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457967 */     // MIs[0] policy
     /* 1457967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457979 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1457982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1458001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458004 */     // GIR_Coverage, 7363,
     /* 1458004 */     GIR_EraseRootFromParent_Done,
     /* 1458005 */   // Label 20484: @1458005
     /* 1458005 */   GIM_Try, /*On fail goto*//*Label 20485*/ GIMT_Encode4(1458102), // Rule ID 7366 //
     /* 1458010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1458013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1458021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1458024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1458027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1458040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458060 */     // MIs[1] Operand 1
     /* 1458060 */     // No operand predicates
     /* 1458060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458064 */     // MIs[0] policy
     /* 1458064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458076 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1458079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1458098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458101 */     // GIR_Coverage, 7366,
     /* 1458101 */     GIR_EraseRootFromParent_Done,
     /* 1458102 */   // Label 20485: @1458102
     /* 1458102 */   GIM_Try, /*On fail goto*//*Label 20486*/ GIMT_Encode4(1458199), // Rule ID 7367 //
     /* 1458107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1458110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1458118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1458121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1458124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1458137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458157 */     // MIs[1] Operand 1
     /* 1458157 */     // No operand predicates
     /* 1458157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458161 */     // MIs[0] policy
     /* 1458161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458173 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1458176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1458195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458198 */     // GIR_Coverage, 7367,
     /* 1458198 */     GIR_EraseRootFromParent_Done,
     /* 1458199 */   // Label 20486: @1458199
     /* 1458199 */   GIM_Try, /*On fail goto*//*Label 20487*/ GIMT_Encode4(1458296), // Rule ID 7578 //
     /* 1458204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1458215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1458218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1458221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458254 */     // MIs[1] Operand 1
     /* 1458254 */     // No operand predicates
     /* 1458254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458258 */     // MIs[0] policy
     /* 1458258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458270 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1458273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458295 */     // GIR_Coverage, 7578,
     /* 1458295 */     GIR_EraseRootFromParent_Done,
     /* 1458296 */   // Label 20487: @1458296
     /* 1458296 */   GIM_Try, /*On fail goto*//*Label 20488*/ GIMT_Encode4(1458393), // Rule ID 7579 //
     /* 1458301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1458312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1458315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1458318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458351 */     // MIs[1] Operand 1
     /* 1458351 */     // No operand predicates
     /* 1458351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458355 */     // MIs[0] policy
     /* 1458355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458367 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1458370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458392 */     // GIR_Coverage, 7579,
     /* 1458392 */     GIR_EraseRootFromParent_Done,
     /* 1458393 */   // Label 20488: @1458393
     /* 1458393 */   GIM_Try, /*On fail goto*//*Label 20489*/ GIMT_Encode4(1458490), // Rule ID 7582 //
     /* 1458398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1458409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1458412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1458415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458448 */     // MIs[1] Operand 1
     /* 1458448 */     // No operand predicates
     /* 1458448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458452 */     // MIs[0] policy
     /* 1458452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458464 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1458467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458489 */     // GIR_Coverage, 7582,
     /* 1458489 */     GIR_EraseRootFromParent_Done,
     /* 1458490 */   // Label 20489: @1458490
     /* 1458490 */   GIM_Try, /*On fail goto*//*Label 20490*/ GIMT_Encode4(1458587), // Rule ID 7583 //
     /* 1458495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1458506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1458509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1458512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458545 */     // MIs[1] Operand 1
     /* 1458545 */     // No operand predicates
     /* 1458545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458549 */     // MIs[0] policy
     /* 1458549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458561 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1458564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458586 */     // GIR_Coverage, 7583,
     /* 1458586 */     GIR_EraseRootFromParent_Done,
     /* 1458587 */   // Label 20490: @1458587
     /* 1458587 */   GIM_Try, /*On fail goto*//*Label 20491*/ GIMT_Encode4(1458684), // Rule ID 7586 //
     /* 1458592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1458603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1458606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458642 */     // MIs[1] Operand 1
     /* 1458642 */     // No operand predicates
     /* 1458642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458646 */     // MIs[0] policy
     /* 1458646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458658 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1458661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458683 */     // GIR_Coverage, 7586,
     /* 1458683 */     GIR_EraseRootFromParent_Done,
     /* 1458684 */   // Label 20491: @1458684
     /* 1458684 */   GIM_Try, /*On fail goto*//*Label 20492*/ GIMT_Encode4(1458781), // Rule ID 7587 //
     /* 1458689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1458700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1458703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458739 */     // MIs[1] Operand 1
     /* 1458739 */     // No operand predicates
     /* 1458739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458743 */     // MIs[0] policy
     /* 1458743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458755 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1458758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458780 */     // GIR_Coverage, 7587,
     /* 1458780 */     GIR_EraseRootFromParent_Done,
     /* 1458781 */   // Label 20492: @1458781
     /* 1458781 */   GIM_Try, /*On fail goto*//*Label 20493*/ GIMT_Encode4(1458878), // Rule ID 7590 //
     /* 1458786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1458800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1458803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458836 */     // MIs[1] Operand 1
     /* 1458836 */     // No operand predicates
     /* 1458836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458840 */     // MIs[0] policy
     /* 1458840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458852 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1458855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458877 */     // GIR_Coverage, 7590,
     /* 1458877 */     GIR_EraseRootFromParent_Done,
     /* 1458878 */   // Label 20493: @1458878
     /* 1458878 */   GIM_Try, /*On fail goto*//*Label 20494*/ GIMT_Encode4(1458975), // Rule ID 7591 //
     /* 1458883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1458897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1458900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458933 */     // MIs[1] Operand 1
     /* 1458933 */     // No operand predicates
     /* 1458933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458937 */     // MIs[0] policy
     /* 1458937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458949 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1458952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458974 */     // GIR_Coverage, 7591,
     /* 1458974 */     GIR_EraseRootFromParent_Done,
     /* 1458975 */   // Label 20494: @1458975
     /* 1458975 */   GIM_Try, /*On fail goto*//*Label 20495*/ GIMT_Encode4(1459072), // Rule ID 7594 //
     /* 1458980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1458991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1458994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1458997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459030 */     // MIs[1] Operand 1
     /* 1459030 */     // No operand predicates
     /* 1459030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459034 */     // MIs[0] policy
     /* 1459034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459046 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1459049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459071 */     // GIR_Coverage, 7594,
     /* 1459071 */     GIR_EraseRootFromParent_Done,
     /* 1459072 */   // Label 20495: @1459072
     /* 1459072 */   GIM_Try, /*On fail goto*//*Label 20496*/ GIMT_Encode4(1459169), // Rule ID 7595 //
     /* 1459077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1459088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1459091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1459094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459127 */     // MIs[1] Operand 1
     /* 1459127 */     // No operand predicates
     /* 1459127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459131 */     // MIs[0] policy
     /* 1459131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459143 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1459146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459168 */     // GIR_Coverage, 7595,
     /* 1459168 */     GIR_EraseRootFromParent_Done,
     /* 1459169 */   // Label 20496: @1459169
     /* 1459169 */   GIM_Try, /*On fail goto*//*Label 20497*/ GIMT_Encode4(1459266), // Rule ID 7598 //
     /* 1459174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1459185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1459188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1459191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1459197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459224 */     // MIs[1] Operand 1
     /* 1459224 */     // No operand predicates
     /* 1459224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459228 */     // MIs[0] policy
     /* 1459228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459240 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1459243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459265 */     // GIR_Coverage, 7598,
     /* 1459265 */     GIR_EraseRootFromParent_Done,
     /* 1459266 */   // Label 20497: @1459266
     /* 1459266 */   GIM_Try, /*On fail goto*//*Label 20498*/ GIMT_Encode4(1459363), // Rule ID 7599 //
     /* 1459271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1459282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1459285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1459288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1459294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459321 */     // MIs[1] Operand 1
     /* 1459321 */     // No operand predicates
     /* 1459321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459325 */     // MIs[0] policy
     /* 1459325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459337 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1459340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459362 */     // GIR_Coverage, 7599,
     /* 1459362 */     GIR_EraseRootFromParent_Done,
     /* 1459363 */   // Label 20498: @1459363
     /* 1459363 */   GIM_Try, /*On fail goto*//*Label 20499*/ GIMT_Encode4(1459460), // Rule ID 7602 //
     /* 1459368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1459379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1459382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1459385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459418 */     // MIs[1] Operand 1
     /* 1459418 */     // No operand predicates
     /* 1459418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459422 */     // MIs[0] policy
     /* 1459422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459434 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1459437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459459 */     // GIR_Coverage, 7602,
     /* 1459459 */     GIR_EraseRootFromParent_Done,
     /* 1459460 */   // Label 20499: @1459460
     /* 1459460 */   GIM_Try, /*On fail goto*//*Label 20500*/ GIMT_Encode4(1459557), // Rule ID 7603 //
     /* 1459465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1459476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1459479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1459482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459515 */     // MIs[1] Operand 1
     /* 1459515 */     // No operand predicates
     /* 1459515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459519 */     // MIs[0] policy
     /* 1459519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459531 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1459534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459556 */     // GIR_Coverage, 7603,
     /* 1459556 */     GIR_EraseRootFromParent_Done,
     /* 1459557 */   // Label 20500: @1459557
     /* 1459557 */   GIM_Try, /*On fail goto*//*Label 20501*/ GIMT_Encode4(1459654), // Rule ID 7606 //
     /* 1459562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1459573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1459576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1459579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1459585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459612 */     // MIs[1] Operand 1
     /* 1459612 */     // No operand predicates
     /* 1459612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459616 */     // MIs[0] policy
     /* 1459616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459628 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1459631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459653 */     // GIR_Coverage, 7606,
     /* 1459653 */     GIR_EraseRootFromParent_Done,
     /* 1459654 */   // Label 20501: @1459654
     /* 1459654 */   GIM_Try, /*On fail goto*//*Label 20502*/ GIMT_Encode4(1459751), // Rule ID 7607 //
     /* 1459659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1459670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1459673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1459676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1459682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459709 */     // MIs[1] Operand 1
     /* 1459709 */     // No operand predicates
     /* 1459709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459713 */     // MIs[0] policy
     /* 1459713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459725 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1459728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459750 */     // GIR_Coverage, 7607,
     /* 1459750 */     GIR_EraseRootFromParent_Done,
     /* 1459751 */   // Label 20502: @1459751
     /* 1459751 */   GIM_Try, /*On fail goto*//*Label 20503*/ GIMT_Encode4(1459848), // Rule ID 7610 //
     /* 1459756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1459767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1459770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1459773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1459779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459806 */     // MIs[1] Operand 1
     /* 1459806 */     // No operand predicates
     /* 1459806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459810 */     // MIs[0] policy
     /* 1459810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459822 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1459825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459847 */     // GIR_Coverage, 7610,
     /* 1459847 */     GIR_EraseRootFromParent_Done,
     /* 1459848 */   // Label 20503: @1459848
     /* 1459848 */   GIM_Try, /*On fail goto*//*Label 20504*/ GIMT_Encode4(1459945), // Rule ID 7611 //
     /* 1459853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1459864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1459867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1459870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1459876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459903 */     // MIs[1] Operand 1
     /* 1459903 */     // No operand predicates
     /* 1459903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459907 */     // MIs[0] policy
     /* 1459907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459919 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1459922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459944 */     // GIR_Coverage, 7611,
     /* 1459944 */     GIR_EraseRootFromParent_Done,
     /* 1459945 */   // Label 20504: @1459945
     /* 1459945 */   GIM_Try, /*On fail goto*//*Label 20505*/ GIMT_Encode4(1460042), // Rule ID 7614 //
     /* 1459950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1459961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1459964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1459967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1459973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460000 */     // MIs[1] Operand 1
     /* 1460000 */     // No operand predicates
     /* 1460000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460004 */     // MIs[0] policy
     /* 1460004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460016 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1460019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460041 */     // GIR_Coverage, 7614,
     /* 1460041 */     GIR_EraseRootFromParent_Done,
     /* 1460042 */   // Label 20505: @1460042
     /* 1460042 */   GIM_Try, /*On fail goto*//*Label 20506*/ GIMT_Encode4(1460139), // Rule ID 7615 //
     /* 1460047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1460058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1460061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1460064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460097 */     // MIs[1] Operand 1
     /* 1460097 */     // No operand predicates
     /* 1460097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460101 */     // MIs[0] policy
     /* 1460101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460113 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1460116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460138 */     // GIR_Coverage, 7615,
     /* 1460138 */     GIR_EraseRootFromParent_Done,
     /* 1460139 */   // Label 20506: @1460139
     /* 1460139 */   GIM_Try, /*On fail goto*//*Label 20507*/ GIMT_Encode4(1460236), // Rule ID 7618 //
     /* 1460144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1460155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1460158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1460161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1460167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460194 */     // MIs[1] Operand 1
     /* 1460194 */     // No operand predicates
     /* 1460194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460198 */     // MIs[0] policy
     /* 1460198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460210 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1460213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460235 */     // GIR_Coverage, 7618,
     /* 1460235 */     GIR_EraseRootFromParent_Done,
     /* 1460236 */   // Label 20507: @1460236
     /* 1460236 */   GIM_Try, /*On fail goto*//*Label 20508*/ GIMT_Encode4(1460333), // Rule ID 7619 //
     /* 1460241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1460252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1460255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1460258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1460264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460291 */     // MIs[1] Operand 1
     /* 1460291 */     // No operand predicates
     /* 1460291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460295 */     // MIs[0] policy
     /* 1460295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460307 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1460310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460332 */     // GIR_Coverage, 7619,
     /* 1460332 */     GIR_EraseRootFromParent_Done,
     /* 1460333 */   // Label 20508: @1460333
     /* 1460333 */   GIM_Try, /*On fail goto*//*Label 20509*/ GIMT_Encode4(1460430), // Rule ID 7622 //
     /* 1460338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1460349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1460352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1460355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1460361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460388 */     // MIs[1] Operand 1
     /* 1460388 */     // No operand predicates
     /* 1460388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460392 */     // MIs[0] policy
     /* 1460392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1460407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460429 */     // GIR_Coverage, 7622,
     /* 1460429 */     GIR_EraseRootFromParent_Done,
     /* 1460430 */   // Label 20509: @1460430
     /* 1460430 */   GIM_Try, /*On fail goto*//*Label 20510*/ GIMT_Encode4(1460527), // Rule ID 7623 //
     /* 1460435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1460446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1460449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1460452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1460458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460485 */     // MIs[1] Operand 1
     /* 1460485 */     // No operand predicates
     /* 1460485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460489 */     // MIs[0] policy
     /* 1460489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460501 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1460504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460526 */     // GIR_Coverage, 7623,
     /* 1460526 */     GIR_EraseRootFromParent_Done,
     /* 1460527 */   // Label 20510: @1460527
     /* 1460527 */   GIM_Try, /*On fail goto*//*Label 20511*/ GIMT_Encode4(1460624), // Rule ID 7626 //
     /* 1460532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1460543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1460546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1460549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460582 */     // MIs[1] Operand 1
     /* 1460582 */     // No operand predicates
     /* 1460582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460586 */     // MIs[0] policy
     /* 1460586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460598 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1460601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460623 */     // GIR_Coverage, 7626,
     /* 1460623 */     GIR_EraseRootFromParent_Done,
     /* 1460624 */   // Label 20511: @1460624
     /* 1460624 */   GIM_Try, /*On fail goto*//*Label 20512*/ GIMT_Encode4(1460721), // Rule ID 7627 //
     /* 1460629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1460640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1460643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1460646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460679 */     // MIs[1] Operand 1
     /* 1460679 */     // No operand predicates
     /* 1460679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460683 */     // MIs[0] policy
     /* 1460683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460695 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1460698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460720 */     // GIR_Coverage, 7627,
     /* 1460720 */     GIR_EraseRootFromParent_Done,
     /* 1460721 */   // Label 20512: @1460721
     /* 1460721 */   GIM_Try, /*On fail goto*//*Label 20513*/ GIMT_Encode4(1460818), // Rule ID 7630 //
     /* 1460726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1460743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460776 */     // MIs[1] Operand 1
     /* 1460776 */     // No operand predicates
     /* 1460776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460780 */     // MIs[0] policy
     /* 1460780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460792 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1460795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460817 */     // GIR_Coverage, 7630,
     /* 1460817 */     GIR_EraseRootFromParent_Done,
     /* 1460818 */   // Label 20513: @1460818
     /* 1460818 */   GIM_Try, /*On fail goto*//*Label 20514*/ GIMT_Encode4(1460915), // Rule ID 7631 //
     /* 1460823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1460840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460873 */     // MIs[1] Operand 1
     /* 1460873 */     // No operand predicates
     /* 1460873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460877 */     // MIs[0] policy
     /* 1460877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460889 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1460892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460914 */     // GIR_Coverage, 7631,
     /* 1460914 */     GIR_EraseRootFromParent_Done,
     /* 1460915 */   // Label 20514: @1460915
     /* 1460915 */   GIM_Try, /*On fail goto*//*Label 20515*/ GIMT_Encode4(1461012), // Rule ID 7634 //
     /* 1460920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1460931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1460934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1460937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460970 */     // MIs[1] Operand 1
     /* 1460970 */     // No operand predicates
     /* 1460970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460974 */     // MIs[0] policy
     /* 1460974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460986 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1460989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1461008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461011 */     // GIR_Coverage, 7634,
     /* 1461011 */     GIR_EraseRootFromParent_Done,
     /* 1461012 */   // Label 20515: @1461012
     /* 1461012 */   GIM_Try, /*On fail goto*//*Label 20516*/ GIMT_Encode4(1461109), // Rule ID 7635 //
     /* 1461017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1461020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1461025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1461028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1461031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1461034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461067 */     // MIs[1] Operand 1
     /* 1461067 */     // No operand predicates
     /* 1461067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461071 */     // MIs[0] policy
     /* 1461071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461083 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1461086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1461105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461108 */     // GIR_Coverage, 7635,
     /* 1461108 */     GIR_EraseRootFromParent_Done,
     /* 1461109 */   // Label 20516: @1461109
     /* 1461109 */   GIM_Try, /*On fail goto*//*Label 20517*/ GIMT_Encode4(1461206), // Rule ID 7758 //
     /* 1461114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1461125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1461128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1461131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461164 */     // MIs[1] Operand 1
     /* 1461164 */     // No operand predicates
     /* 1461164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461168 */     // MIs[0] policy
     /* 1461168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461180 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1461183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461205 */     // GIR_Coverage, 7758,
     /* 1461205 */     GIR_EraseRootFromParent_Done,
     /* 1461206 */   // Label 20517: @1461206
     /* 1461206 */   GIM_Try, /*On fail goto*//*Label 20518*/ GIMT_Encode4(1461303), // Rule ID 7759 //
     /* 1461211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1461222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1461225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1461228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461261 */     // MIs[1] Operand 1
     /* 1461261 */     // No operand predicates
     /* 1461261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461265 */     // MIs[0] policy
     /* 1461265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461277 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1461280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461302 */     // GIR_Coverage, 7759,
     /* 1461302 */     GIR_EraseRootFromParent_Done,
     /* 1461303 */   // Label 20518: @1461303
     /* 1461303 */   GIM_Try, /*On fail goto*//*Label 20519*/ GIMT_Encode4(1461400), // Rule ID 7762 //
     /* 1461308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1461319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1461322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1461325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1461331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461358 */     // MIs[1] Operand 1
     /* 1461358 */     // No operand predicates
     /* 1461358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461362 */     // MIs[0] policy
     /* 1461362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461374 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1461377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461399 */     // GIR_Coverage, 7762,
     /* 1461399 */     GIR_EraseRootFromParent_Done,
     /* 1461400 */   // Label 20519: @1461400
     /* 1461400 */   GIM_Try, /*On fail goto*//*Label 20520*/ GIMT_Encode4(1461497), // Rule ID 7763 //
     /* 1461405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1461416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1461419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1461422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1461428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461455 */     // MIs[1] Operand 1
     /* 1461455 */     // No operand predicates
     /* 1461455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461459 */     // MIs[0] policy
     /* 1461459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461471 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1461474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461496 */     // GIR_Coverage, 7763,
     /* 1461496 */     GIR_EraseRootFromParent_Done,
     /* 1461497 */   // Label 20520: @1461497
     /* 1461497 */   GIM_Try, /*On fail goto*//*Label 20521*/ GIMT_Encode4(1461594), // Rule ID 7766 //
     /* 1461502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1461519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461552 */     // MIs[1] Operand 1
     /* 1461552 */     // No operand predicates
     /* 1461552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461556 */     // MIs[0] policy
     /* 1461556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461568 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1461571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461593 */     // GIR_Coverage, 7766,
     /* 1461593 */     GIR_EraseRootFromParent_Done,
     /* 1461594 */   // Label 20521: @1461594
     /* 1461594 */   GIM_Try, /*On fail goto*//*Label 20522*/ GIMT_Encode4(1461691), // Rule ID 7767 //
     /* 1461599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1461616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461649 */     // MIs[1] Operand 1
     /* 1461649 */     // No operand predicates
     /* 1461649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461653 */     // MIs[0] policy
     /* 1461653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461665 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1461668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461690 */     // GIR_Coverage, 7767,
     /* 1461690 */     GIR_EraseRootFromParent_Done,
     /* 1461691 */   // Label 20522: @1461691
     /* 1461691 */   GIM_Try, /*On fail goto*//*Label 20523*/ GIMT_Encode4(1461788), // Rule ID 7770 //
     /* 1461696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1461707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1461710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1461713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461746 */     // MIs[1] Operand 1
     /* 1461746 */     // No operand predicates
     /* 1461746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461750 */     // MIs[0] policy
     /* 1461750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461762 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1461765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461787 */     // GIR_Coverage, 7770,
     /* 1461787 */     GIR_EraseRootFromParent_Done,
     /* 1461788 */   // Label 20523: @1461788
     /* 1461788 */   GIM_Try, /*On fail goto*//*Label 20524*/ GIMT_Encode4(1461885), // Rule ID 7771 //
     /* 1461793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1461804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1461807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1461810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461843 */     // MIs[1] Operand 1
     /* 1461843 */     // No operand predicates
     /* 1461843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461847 */     // MIs[0] policy
     /* 1461847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461859 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1461862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461884 */     // GIR_Coverage, 7771,
     /* 1461884 */     GIR_EraseRootFromParent_Done,
     /* 1461885 */   // Label 20524: @1461885
     /* 1461885 */   GIM_Try, /*On fail goto*//*Label 20525*/ GIMT_Encode4(1461982), // Rule ID 7774 //
     /* 1461890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1461901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1461904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1461907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1461913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1461920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461940 */     // MIs[1] Operand 1
     /* 1461940 */     // No operand predicates
     /* 1461940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461944 */     // MIs[0] policy
     /* 1461944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461956 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1461959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461981 */     // GIR_Coverage, 7774,
     /* 1461981 */     GIR_EraseRootFromParent_Done,
     /* 1461982 */   // Label 20525: @1461982
     /* 1461982 */   GIM_Try, /*On fail goto*//*Label 20526*/ GIMT_Encode4(1462079), // Rule ID 7775 //
     /* 1461987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1461998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1462001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1462004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1462010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462037 */     // MIs[1] Operand 1
     /* 1462037 */     // No operand predicates
     /* 1462037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462041 */     // MIs[0] policy
     /* 1462041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462053 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1462056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462078 */     // GIR_Coverage, 7775,
     /* 1462078 */     GIR_EraseRootFromParent_Done,
     /* 1462079 */   // Label 20526: @1462079
     /* 1462079 */   GIM_Try, /*On fail goto*//*Label 20527*/ GIMT_Encode4(1462176), // Rule ID 7778 //
     /* 1462084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1462095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1462098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1462101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1462107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1462114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1462122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462134 */     // MIs[1] Operand 1
     /* 1462134 */     // No operand predicates
     /* 1462134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462138 */     // MIs[0] policy
     /* 1462138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462150 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1462153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462175 */     // GIR_Coverage, 7778,
     /* 1462175 */     GIR_EraseRootFromParent_Done,
     /* 1462176 */   // Label 20527: @1462176
     /* 1462176 */   GIM_Try, /*On fail goto*//*Label 20528*/ GIMT_Encode4(1462273), // Rule ID 7779 //
     /* 1462181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1462192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1462195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1462198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1462204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1462211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1462219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462231 */     // MIs[1] Operand 1
     /* 1462231 */     // No operand predicates
     /* 1462231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462235 */     // MIs[0] policy
     /* 1462235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462247 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1462250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462272 */     // GIR_Coverage, 7779,
     /* 1462272 */     GIR_EraseRootFromParent_Done,
     /* 1462273 */   // Label 20528: @1462273
     /* 1462273 */   GIM_Try, /*On fail goto*//*Label 20529*/ GIMT_Encode4(1462370), // Rule ID 7782 //
     /* 1462278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1462289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1462292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1462295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462328 */     // MIs[1] Operand 1
     /* 1462328 */     // No operand predicates
     /* 1462328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462332 */     // MIs[0] policy
     /* 1462332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462344 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1462347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462369 */     // GIR_Coverage, 7782,
     /* 1462369 */     GIR_EraseRootFromParent_Done,
     /* 1462370 */   // Label 20529: @1462370
     /* 1462370 */   GIM_Try, /*On fail goto*//*Label 20530*/ GIMT_Encode4(1462467), // Rule ID 7783 //
     /* 1462375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1462386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1462389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1462392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462425 */     // MIs[1] Operand 1
     /* 1462425 */     // No operand predicates
     /* 1462425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462429 */     // MIs[0] policy
     /* 1462429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462441 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1462444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462466 */     // GIR_Coverage, 7783,
     /* 1462466 */     GIR_EraseRootFromParent_Done,
     /* 1462467 */   // Label 20530: @1462467
     /* 1462467 */   GIM_Try, /*On fail goto*//*Label 20531*/ GIMT_Encode4(1462564), // Rule ID 7786 //
     /* 1462472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462522 */     // MIs[1] Operand 1
     /* 1462522 */     // No operand predicates
     /* 1462522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462526 */     // MIs[0] policy
     /* 1462526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462538 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1462541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462563 */     // GIR_Coverage, 7786,
     /* 1462563 */     GIR_EraseRootFromParent_Done,
     /* 1462564 */   // Label 20531: @1462564
     /* 1462564 */   GIM_Try, /*On fail goto*//*Label 20532*/ GIMT_Encode4(1462661), // Rule ID 7787 //
     /* 1462569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462619 */     // MIs[1] Operand 1
     /* 1462619 */     // No operand predicates
     /* 1462619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462623 */     // MIs[0] policy
     /* 1462623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462635 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1462638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462660 */     // GIR_Coverage, 7787,
     /* 1462660 */     GIR_EraseRootFromParent_Done,
     /* 1462661 */   // Label 20532: @1462661
     /* 1462661 */   GIM_Try, /*On fail goto*//*Label 20533*/ GIMT_Encode4(1462758), // Rule ID 7790 //
     /* 1462666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1462683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462716 */     // MIs[1] Operand 1
     /* 1462716 */     // No operand predicates
     /* 1462716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462720 */     // MIs[0] policy
     /* 1462720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462732 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1462735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462757 */     // GIR_Coverage, 7790,
     /* 1462757 */     GIR_EraseRootFromParent_Done,
     /* 1462758 */   // Label 20533: @1462758
     /* 1462758 */   GIM_Try, /*On fail goto*//*Label 20534*/ GIMT_Encode4(1462855), // Rule ID 7791 //
     /* 1462763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1462780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462813 */     // MIs[1] Operand 1
     /* 1462813 */     // No operand predicates
     /* 1462813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462817 */     // MIs[0] policy
     /* 1462817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462829 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1462832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462854 */     // GIR_Coverage, 7791,
     /* 1462854 */     GIR_EraseRootFromParent_Done,
     /* 1462855 */   // Label 20534: @1462855
     /* 1462855 */   GIM_Try, /*On fail goto*//*Label 20535*/ GIMT_Encode4(1462952), // Rule ID 7794 //
     /* 1462860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1462871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1462874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1462877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462910 */     // MIs[1] Operand 1
     /* 1462910 */     // No operand predicates
     /* 1462910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462914 */     // MIs[0] policy
     /* 1462914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462926 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1462929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462951 */     // GIR_Coverage, 7794,
     /* 1462951 */     GIR_EraseRootFromParent_Done,
     /* 1462952 */   // Label 20535: @1462952
     /* 1462952 */   GIM_Try, /*On fail goto*//*Label 20536*/ GIMT_Encode4(1463049), // Rule ID 7795 //
     /* 1462957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1462968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1462971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1462974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463007 */     // MIs[1] Operand 1
     /* 1463007 */     // No operand predicates
     /* 1463007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463011 */     // MIs[0] policy
     /* 1463011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463023 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1463026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463048 */     // GIR_Coverage, 7795,
     /* 1463048 */     GIR_EraseRootFromParent_Done,
     /* 1463049 */   // Label 20536: @1463049
     /* 1463049 */   GIM_Try, /*On fail goto*//*Label 20537*/ GIMT_Encode4(1463146), // Rule ID 7798 //
     /* 1463054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1463065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1463068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1463071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1463077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463104 */     // MIs[1] Operand 1
     /* 1463104 */     // No operand predicates
     /* 1463104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463108 */     // MIs[0] policy
     /* 1463108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463120 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1463123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463145 */     // GIR_Coverage, 7798,
     /* 1463145 */     GIR_EraseRootFromParent_Done,
     /* 1463146 */   // Label 20537: @1463146
     /* 1463146 */   GIM_Try, /*On fail goto*//*Label 20538*/ GIMT_Encode4(1463243), // Rule ID 7799 //
     /* 1463151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1463162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1463165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1463168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1463174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463201 */     // MIs[1] Operand 1
     /* 1463201 */     // No operand predicates
     /* 1463201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463205 */     // MIs[0] policy
     /* 1463205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463217 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1463220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463242 */     // GIR_Coverage, 7799,
     /* 1463242 */     GIR_EraseRootFromParent_Done,
     /* 1463243 */   // Label 20538: @1463243
     /* 1463243 */   GIM_Try, /*On fail goto*//*Label 20539*/ GIMT_Encode4(1463340), // Rule ID 7802 //
     /* 1463248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1463259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1463262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1463265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463294 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463298 */     // MIs[1] Operand 1
     /* 1463298 */     // No operand predicates
     /* 1463298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463302 */     // MIs[0] policy
     /* 1463302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463314 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1463317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463339 */     // GIR_Coverage, 7802,
     /* 1463339 */     GIR_EraseRootFromParent_Done,
     /* 1463340 */   // Label 20539: @1463340
     /* 1463340 */   GIM_Try, /*On fail goto*//*Label 20540*/ GIMT_Encode4(1463437), // Rule ID 7803 //
     /* 1463345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1463356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1463359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1463362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463395 */     // MIs[1] Operand 1
     /* 1463395 */     // No operand predicates
     /* 1463395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463399 */     // MIs[0] policy
     /* 1463399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463411 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1463414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463436 */     // GIR_Coverage, 7803,
     /* 1463436 */     GIR_EraseRootFromParent_Done,
     /* 1463437 */   // Label 20540: @1463437
     /* 1463437 */   GIM_Try, /*On fail goto*//*Label 20541*/ GIMT_Encode4(1463534), // Rule ID 7806 //
     /* 1463442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1463453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1463456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1463459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463492 */     // MIs[1] Operand 1
     /* 1463492 */     // No operand predicates
     /* 1463492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463496 */     // MIs[0] policy
     /* 1463496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1463511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463533 */     // GIR_Coverage, 7806,
     /* 1463533 */     GIR_EraseRootFromParent_Done,
     /* 1463534 */   // Label 20541: @1463534
     /* 1463534 */   GIM_Try, /*On fail goto*//*Label 20542*/ GIMT_Encode4(1463631), // Rule ID 7807 //
     /* 1463539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1463550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1463553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1463556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463589 */     // MIs[1] Operand 1
     /* 1463589 */     // No operand predicates
     /* 1463589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463593 */     // MIs[0] policy
     /* 1463593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463605 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1463608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463630 */     // GIR_Coverage, 7807,
     /* 1463630 */     GIR_EraseRootFromParent_Done,
     /* 1463631 */   // Label 20542: @1463631
     /* 1463631 */   GIM_Try, /*On fail goto*//*Label 20543*/ GIMT_Encode4(1463728), // Rule ID 7810 //
     /* 1463636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1463647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1463650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1463653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1463659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463686 */     // MIs[1] Operand 1
     /* 1463686 */     // No operand predicates
     /* 1463686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463690 */     // MIs[0] policy
     /* 1463690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1463705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463727 */     // GIR_Coverage, 7810,
     /* 1463727 */     GIR_EraseRootFromParent_Done,
     /* 1463728 */   // Label 20543: @1463728
     /* 1463728 */   GIM_Try, /*On fail goto*//*Label 20544*/ GIMT_Encode4(1463825), // Rule ID 7811 //
     /* 1463733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1463744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1463747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1463750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1463756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463783 */     // MIs[1] Operand 1
     /* 1463783 */     // No operand predicates
     /* 1463783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463787 */     // MIs[0] policy
     /* 1463787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1463802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463824 */     // GIR_Coverage, 7811,
     /* 1463824 */     GIR_EraseRootFromParent_Done,
     /* 1463825 */   // Label 20544: @1463825
     /* 1463825 */   GIM_Try, /*On fail goto*//*Label 20545*/ GIMT_Encode4(1463922), // Rule ID 7814 //
     /* 1463830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1463841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1463844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1463847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1463853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463880 */     // MIs[1] Operand 1
     /* 1463880 */     // No operand predicates
     /* 1463880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463884 */     // MIs[0] policy
     /* 1463884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463896 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1463899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463921 */     // GIR_Coverage, 7814,
     /* 1463921 */     GIR_EraseRootFromParent_Done,
     /* 1463922 */   // Label 20545: @1463922
     /* 1463922 */   GIM_Try, /*On fail goto*//*Label 20546*/ GIMT_Encode4(1464019), // Rule ID 7815 //
     /* 1463927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1463938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1463941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1463944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1463950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463977 */     // MIs[1] Operand 1
     /* 1463977 */     // No operand predicates
     /* 1463977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463981 */     // MIs[0] policy
     /* 1463981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463993 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1463996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464018 */     // GIR_Coverage, 7815,
     /* 1464018 */     GIR_EraseRootFromParent_Done,
     /* 1464019 */   // Label 20546: @1464019
     /* 1464019 */   GIM_Try, /*On fail goto*//*Label 20547*/ GIMT_Encode4(1464119), // Rule ID 14244 //
     /* 1464024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1464035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1464038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1464041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464074 */     // MIs[1] Operand 1
     /* 1464074 */     // No operand predicates
     /* 1464074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464078 */     // MIs[0] policy
     /* 1464078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464090 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1464093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464118 */     // GIR_Coverage, 14244,
     /* 1464118 */     GIR_EraseRootFromParent_Done,
     /* 1464119 */   // Label 20547: @1464119
     /* 1464119 */   GIM_Try, /*On fail goto*//*Label 20548*/ GIMT_Encode4(1464219), // Rule ID 14245 //
     /* 1464124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1464135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1464138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1464141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464174 */     // MIs[1] Operand 1
     /* 1464174 */     // No operand predicates
     /* 1464174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464178 */     // MIs[0] policy
     /* 1464178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464190 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1464193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464218 */     // GIR_Coverage, 14245,
     /* 1464218 */     GIR_EraseRootFromParent_Done,
     /* 1464219 */   // Label 20548: @1464219
     /* 1464219 */   GIM_Try, /*On fail goto*//*Label 20549*/ GIMT_Encode4(1464319), // Rule ID 14248 //
     /* 1464224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1464235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1464238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1464241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464274 */     // MIs[1] Operand 1
     /* 1464274 */     // No operand predicates
     /* 1464274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464278 */     // MIs[0] policy
     /* 1464278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464290 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1464293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464318 */     // GIR_Coverage, 14248,
     /* 1464318 */     GIR_EraseRootFromParent_Done,
     /* 1464319 */   // Label 20549: @1464319
     /* 1464319 */   GIM_Try, /*On fail goto*//*Label 20550*/ GIMT_Encode4(1464419), // Rule ID 14249 //
     /* 1464324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1464335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1464338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1464341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464374 */     // MIs[1] Operand 1
     /* 1464374 */     // No operand predicates
     /* 1464374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464378 */     // MIs[0] policy
     /* 1464378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464390 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1464393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464418 */     // GIR_Coverage, 14249,
     /* 1464418 */     GIR_EraseRootFromParent_Done,
     /* 1464419 */   // Label 20550: @1464419
     /* 1464419 */   GIM_Try, /*On fail goto*//*Label 20551*/ GIMT_Encode4(1464519), // Rule ID 14252 //
     /* 1464424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1464435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1464438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1464441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464474 */     // MIs[1] Operand 1
     /* 1464474 */     // No operand predicates
     /* 1464474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464478 */     // MIs[0] policy
     /* 1464478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464490 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464518 */     // GIR_Coverage, 14252,
     /* 1464518 */     GIR_EraseRootFromParent_Done,
     /* 1464519 */   // Label 20551: @1464519
     /* 1464519 */   GIM_Try, /*On fail goto*//*Label 20552*/ GIMT_Encode4(1464619), // Rule ID 14253 //
     /* 1464524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1464535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1464538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1464541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464574 */     // MIs[1] Operand 1
     /* 1464574 */     // No operand predicates
     /* 1464574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464578 */     // MIs[0] policy
     /* 1464578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464590 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464618 */     // GIR_Coverage, 14253,
     /* 1464618 */     GIR_EraseRootFromParent_Done,
     /* 1464619 */   // Label 20552: @1464619
     /* 1464619 */   GIM_Try, /*On fail goto*//*Label 20553*/ GIMT_Encode4(1464719), // Rule ID 14256 //
     /* 1464624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1464635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1464638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1464641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464674 */     // MIs[1] Operand 1
     /* 1464674 */     // No operand predicates
     /* 1464674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464678 */     // MIs[0] policy
     /* 1464678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464690 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1464693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464718 */     // GIR_Coverage, 14256,
     /* 1464718 */     GIR_EraseRootFromParent_Done,
     /* 1464719 */   // Label 20553: @1464719
     /* 1464719 */   GIM_Try, /*On fail goto*//*Label 20554*/ GIMT_Encode4(1464819), // Rule ID 14257 //
     /* 1464724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1464735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1464738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1464741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464774 */     // MIs[1] Operand 1
     /* 1464774 */     // No operand predicates
     /* 1464774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464778 */     // MIs[0] policy
     /* 1464778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464790 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1464793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464818 */     // GIR_Coverage, 14257,
     /* 1464818 */     GIR_EraseRootFromParent_Done,
     /* 1464819 */   // Label 20554: @1464819
     /* 1464819 */   GIM_Try, /*On fail goto*//*Label 20555*/ GIMT_Encode4(1464919), // Rule ID 14260 //
     /* 1464824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1464835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1464838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1464841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464874 */     // MIs[1] Operand 1
     /* 1464874 */     // No operand predicates
     /* 1464874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464878 */     // MIs[0] policy
     /* 1464878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464890 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464918 */     // GIR_Coverage, 14260,
     /* 1464918 */     GIR_EraseRootFromParent_Done,
     /* 1464919 */   // Label 20555: @1464919
     /* 1464919 */   GIM_Try, /*On fail goto*//*Label 20556*/ GIMT_Encode4(1465019), // Rule ID 14261 //
     /* 1464924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1464935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1464938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1464941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464974 */     // MIs[1] Operand 1
     /* 1464974 */     // No operand predicates
     /* 1464974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464978 */     // MIs[0] policy
     /* 1464978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464990 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465018 */     // GIR_Coverage, 14261,
     /* 1465018 */     GIR_EraseRootFromParent_Done,
     /* 1465019 */   // Label 20556: @1465019
     /* 1465019 */   GIM_Try, /*On fail goto*//*Label 20557*/ GIMT_Encode4(1465119), // Rule ID 14264 //
     /* 1465024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1465035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1465038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1465041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465074 */     // MIs[1] Operand 1
     /* 1465074 */     // No operand predicates
     /* 1465074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465078 */     // MIs[0] policy
     /* 1465078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465090 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1465093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465118 */     // GIR_Coverage, 14264,
     /* 1465118 */     GIR_EraseRootFromParent_Done,
     /* 1465119 */   // Label 20557: @1465119
     /* 1465119 */   GIM_Try, /*On fail goto*//*Label 20558*/ GIMT_Encode4(1465219), // Rule ID 14265 //
     /* 1465124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1465135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1465138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1465141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465174 */     // MIs[1] Operand 1
     /* 1465174 */     // No operand predicates
     /* 1465174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465178 */     // MIs[0] policy
     /* 1465178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465190 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1465193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465218 */     // GIR_Coverage, 14265,
     /* 1465218 */     GIR_EraseRootFromParent_Done,
     /* 1465219 */   // Label 20558: @1465219
     /* 1465219 */   GIM_Try, /*On fail goto*//*Label 20559*/ GIMT_Encode4(1465319), // Rule ID 14268 //
     /* 1465224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1465235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1465238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1465241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1465247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465274 */     // MIs[1] Operand 1
     /* 1465274 */     // No operand predicates
     /* 1465274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465278 */     // MIs[0] policy
     /* 1465278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465290 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465318 */     // GIR_Coverage, 14268,
     /* 1465318 */     GIR_EraseRootFromParent_Done,
     /* 1465319 */   // Label 20559: @1465319
     /* 1465319 */   GIM_Try, /*On fail goto*//*Label 20560*/ GIMT_Encode4(1465419), // Rule ID 14269 //
     /* 1465324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1465335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1465338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1465341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1465347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465374 */     // MIs[1] Operand 1
     /* 1465374 */     // No operand predicates
     /* 1465374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465378 */     // MIs[0] policy
     /* 1465378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465390 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465418 */     // GIR_Coverage, 14269,
     /* 1465418 */     GIR_EraseRootFromParent_Done,
     /* 1465419 */   // Label 20560: @1465419
     /* 1465419 */   GIM_Try, /*On fail goto*//*Label 20561*/ GIMT_Encode4(1465519), // Rule ID 14272 //
     /* 1465424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1465435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1465438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1465441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1465447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465474 */     // MIs[1] Operand 1
     /* 1465474 */     // No operand predicates
     /* 1465474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465478 */     // MIs[0] policy
     /* 1465478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465518 */     // GIR_Coverage, 14272,
     /* 1465518 */     GIR_EraseRootFromParent_Done,
     /* 1465519 */   // Label 20561: @1465519
     /* 1465519 */   GIM_Try, /*On fail goto*//*Label 20562*/ GIMT_Encode4(1465619), // Rule ID 14273 //
     /* 1465524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1465535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1465538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1465541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1465547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465574 */     // MIs[1] Operand 1
     /* 1465574 */     // No operand predicates
     /* 1465574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465578 */     // MIs[0] policy
     /* 1465578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465618 */     // GIR_Coverage, 14273,
     /* 1465618 */     GIR_EraseRootFromParent_Done,
     /* 1465619 */   // Label 20562: @1465619
     /* 1465619 */   GIM_Try, /*On fail goto*//*Label 20563*/ GIMT_Encode4(1465719), // Rule ID 14276 //
     /* 1465624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1465635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1465638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1465641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465674 */     // MIs[1] Operand 1
     /* 1465674 */     // No operand predicates
     /* 1465674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465678 */     // MIs[0] policy
     /* 1465678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465718 */     // GIR_Coverage, 14276,
     /* 1465718 */     GIR_EraseRootFromParent_Done,
     /* 1465719 */   // Label 20563: @1465719
     /* 1465719 */   GIM_Try, /*On fail goto*//*Label 20564*/ GIMT_Encode4(1465819), // Rule ID 14277 //
     /* 1465724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1465735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1465738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1465741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465774 */     // MIs[1] Operand 1
     /* 1465774 */     // No operand predicates
     /* 1465774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465778 */     // MIs[0] policy
     /* 1465778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465818 */     // GIR_Coverage, 14277,
     /* 1465818 */     GIR_EraseRootFromParent_Done,
     /* 1465819 */   // Label 20564: @1465819
     /* 1465819 */   GIM_Try, /*On fail goto*//*Label 20565*/ GIMT_Encode4(1465919), // Rule ID 14280 //
     /* 1465824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1465827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1465835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1465838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1465841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465874 */     // MIs[1] Operand 1
     /* 1465874 */     // No operand predicates
     /* 1465874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465878 */     // MIs[0] policy
     /* 1465878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465918 */     // GIR_Coverage, 14280,
     /* 1465918 */     GIR_EraseRootFromParent_Done,
     /* 1465919 */   // Label 20565: @1465919
     /* 1465919 */   GIM_Try, /*On fail goto*//*Label 20566*/ GIMT_Encode4(1466019), // Rule ID 14281 //
     /* 1465924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1465927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1465935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1465938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1465941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465974 */     // MIs[1] Operand 1
     /* 1465974 */     // No operand predicates
     /* 1465974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465978 */     // MIs[0] policy
     /* 1465978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465990 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1466012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466018 */     // GIR_Coverage, 14281,
     /* 1466018 */     GIR_EraseRootFromParent_Done,
     /* 1466019 */   // Label 20566: @1466019
     /* 1466019 */   GIM_Try, /*On fail goto*//*Label 20567*/ GIMT_Encode4(1466119), // Rule ID 14284 //
     /* 1466024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1466035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1466038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1466041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466074 */     // MIs[1] Operand 1
     /* 1466074 */     // No operand predicates
     /* 1466074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466078 */     // MIs[0] policy
     /* 1466078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466090 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466118 */     // GIR_Coverage, 14284,
     /* 1466118 */     GIR_EraseRootFromParent_Done,
     /* 1466119 */   // Label 20567: @1466119
     /* 1466119 */   GIM_Try, /*On fail goto*//*Label 20568*/ GIMT_Encode4(1466219), // Rule ID 14285 //
     /* 1466124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1466135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1466138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1466141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466174 */     // MIs[1] Operand 1
     /* 1466174 */     // No operand predicates
     /* 1466174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466178 */     // MIs[0] policy
     /* 1466178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466218 */     // GIR_Coverage, 14285,
     /* 1466218 */     GIR_EraseRootFromParent_Done,
     /* 1466219 */   // Label 20568: @1466219
     /* 1466219 */   GIM_Try, /*On fail goto*//*Label 20569*/ GIMT_Encode4(1466319), // Rule ID 14288 //
     /* 1466224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1466235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1466238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1466241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1466247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466274 */     // MIs[1] Operand 1
     /* 1466274 */     // No operand predicates
     /* 1466274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466278 */     // MIs[0] policy
     /* 1466278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466290 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1466293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466318 */     // GIR_Coverage, 14288,
     /* 1466318 */     GIR_EraseRootFromParent_Done,
     /* 1466319 */   // Label 20569: @1466319
     /* 1466319 */   GIM_Try, /*On fail goto*//*Label 20570*/ GIMT_Encode4(1466419), // Rule ID 14289 //
     /* 1466324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1466335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1466338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1466341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1466347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466374 */     // MIs[1] Operand 1
     /* 1466374 */     // No operand predicates
     /* 1466374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466378 */     // MIs[0] policy
     /* 1466378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466390 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1466393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466418 */     // GIR_Coverage, 14289,
     /* 1466418 */     GIR_EraseRootFromParent_Done,
     /* 1466419 */   // Label 20570: @1466419
     /* 1466419 */   GIM_Try, /*On fail goto*//*Label 20571*/ GIMT_Encode4(1466519), // Rule ID 14292 //
     /* 1466424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1466435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1466438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1466441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1466447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1466454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466474 */     // MIs[1] Operand 1
     /* 1466474 */     // No operand predicates
     /* 1466474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466478 */     // MIs[0] policy
     /* 1466478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466490 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1466493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466518 */     // GIR_Coverage, 14292,
     /* 1466518 */     GIR_EraseRootFromParent_Done,
     /* 1466519 */   // Label 20571: @1466519
     /* 1466519 */   GIM_Try, /*On fail goto*//*Label 20572*/ GIMT_Encode4(1466619), // Rule ID 14293 //
     /* 1466524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1466535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1466538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1466541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1466547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1466554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466574 */     // MIs[1] Operand 1
     /* 1466574 */     // No operand predicates
     /* 1466574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466578 */     // MIs[0] policy
     /* 1466578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466590 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1466593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466618 */     // GIR_Coverage, 14293,
     /* 1466618 */     GIR_EraseRootFromParent_Done,
     /* 1466619 */   // Label 20572: @1466619
     /* 1466619 */   GIM_Try, /*On fail goto*//*Label 20573*/ GIMT_Encode4(1466719), // Rule ID 14296 //
     /* 1466624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1466635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1466638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1466641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466674 */     // MIs[1] Operand 1
     /* 1466674 */     // No operand predicates
     /* 1466674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466678 */     // MIs[0] policy
     /* 1466678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466690 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466718 */     // GIR_Coverage, 14296,
     /* 1466718 */     GIR_EraseRootFromParent_Done,
     /* 1466719 */   // Label 20573: @1466719
     /* 1466719 */   GIM_Try, /*On fail goto*//*Label 20574*/ GIMT_Encode4(1466819), // Rule ID 14297 //
     /* 1466724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1466735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1466738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1466741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466774 */     // MIs[1] Operand 1
     /* 1466774 */     // No operand predicates
     /* 1466774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466778 */     // MIs[0] policy
     /* 1466778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466818 */     // GIR_Coverage, 14297,
     /* 1466818 */     GIR_EraseRootFromParent_Done,
     /* 1466819 */   // Label 20574: @1466819
     /* 1466819 */   GIM_Try, /*On fail goto*//*Label 20575*/ GIMT_Encode4(1466919), // Rule ID 14300 //
     /* 1466824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1466835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1466838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1466841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466874 */     // MIs[1] Operand 1
     /* 1466874 */     // No operand predicates
     /* 1466874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466878 */     // MIs[0] policy
     /* 1466878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466890 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1466893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466918 */     // GIR_Coverage, 14300,
     /* 1466918 */     GIR_EraseRootFromParent_Done,
     /* 1466919 */   // Label 20575: @1466919
     /* 1466919 */   GIM_Try, /*On fail goto*//*Label 20576*/ GIMT_Encode4(1467019), // Rule ID 14301 //
     /* 1466924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1466935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1466938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1466941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466974 */     // MIs[1] Operand 1
     /* 1466974 */     // No operand predicates
     /* 1466974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466978 */     // MIs[0] policy
     /* 1466978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466990 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1466993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467018 */     // GIR_Coverage, 14301,
     /* 1467018 */     GIR_EraseRootFromParent_Done,
     /* 1467019 */   // Label 20576: @1467019
     /* 1467019 */   GIM_Try, /*On fail goto*//*Label 20577*/ GIMT_Encode4(1467119), // Rule ID 14304 //
     /* 1467024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1467035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1467038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1467041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1467047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467074 */     // MIs[1] Operand 1
     /* 1467074 */     // No operand predicates
     /* 1467074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467078 */     // MIs[0] policy
     /* 1467078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467090 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467118 */     // GIR_Coverage, 14304,
     /* 1467118 */     GIR_EraseRootFromParent_Done,
     /* 1467119 */   // Label 20577: @1467119
     /* 1467119 */   GIM_Try, /*On fail goto*//*Label 20578*/ GIMT_Encode4(1467219), // Rule ID 14305 //
     /* 1467124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1467135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1467138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1467141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1467147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467174 */     // MIs[1] Operand 1
     /* 1467174 */     // No operand predicates
     /* 1467174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467178 */     // MIs[0] policy
     /* 1467178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467190 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467218 */     // GIR_Coverage, 14305,
     /* 1467218 */     GIR_EraseRootFromParent_Done,
     /* 1467219 */   // Label 20578: @1467219
     /* 1467219 */   GIM_Try, /*On fail goto*//*Label 20579*/ GIMT_Encode4(1467319), // Rule ID 14308 //
     /* 1467224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1467235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1467238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1467241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467274 */     // MIs[1] Operand 1
     /* 1467274 */     // No operand predicates
     /* 1467274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467278 */     // MIs[0] policy
     /* 1467278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1467293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467318 */     // GIR_Coverage, 14308,
     /* 1467318 */     GIR_EraseRootFromParent_Done,
     /* 1467319 */   // Label 20579: @1467319
     /* 1467319 */   GIM_Try, /*On fail goto*//*Label 20580*/ GIMT_Encode4(1467419), // Rule ID 14309 //
     /* 1467324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1467335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1467338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1467341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467374 */     // MIs[1] Operand 1
     /* 1467374 */     // No operand predicates
     /* 1467374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467378 */     // MIs[0] policy
     /* 1467378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1467393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467418 */     // GIR_Coverage, 14309,
     /* 1467418 */     GIR_EraseRootFromParent_Done,
     /* 1467419 */   // Label 20580: @1467419
     /* 1467419 */   GIM_Try, /*On fail goto*//*Label 20581*/ GIMT_Encode4(1467519), // Rule ID 14312 //
     /* 1467424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1467435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1467438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1467441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467474 */     // MIs[1] Operand 1
     /* 1467474 */     // No operand predicates
     /* 1467474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467478 */     // MIs[0] policy
     /* 1467478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1467493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467518 */     // GIR_Coverage, 14312,
     /* 1467518 */     GIR_EraseRootFromParent_Done,
     /* 1467519 */   // Label 20581: @1467519
     /* 1467519 */   GIM_Try, /*On fail goto*//*Label 20582*/ GIMT_Encode4(1467619), // Rule ID 14313 //
     /* 1467524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1467535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1467538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1467541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467574 */     // MIs[1] Operand 1
     /* 1467574 */     // No operand predicates
     /* 1467574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467578 */     // MIs[0] policy
     /* 1467578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1467593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467618 */     // GIR_Coverage, 14313,
     /* 1467618 */     GIR_EraseRootFromParent_Done,
     /* 1467619 */   // Label 20582: @1467619
     /* 1467619 */   GIM_Try, /*On fail goto*//*Label 20583*/ GIMT_Encode4(1467719), // Rule ID 14316 //
     /* 1467624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1467635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1467638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1467641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1467647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467674 */     // MIs[1] Operand 1
     /* 1467674 */     // No operand predicates
     /* 1467674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467678 */     // MIs[0] policy
     /* 1467678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467690 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467718 */     // GIR_Coverage, 14316,
     /* 1467718 */     GIR_EraseRootFromParent_Done,
     /* 1467719 */   // Label 20583: @1467719
     /* 1467719 */   GIM_Try, /*On fail goto*//*Label 20584*/ GIMT_Encode4(1467819), // Rule ID 14317 //
     /* 1467724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1467735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1467738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1467741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1467747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467774 */     // MIs[1] Operand 1
     /* 1467774 */     // No operand predicates
     /* 1467774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467778 */     // MIs[0] policy
     /* 1467778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467790 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467818 */     // GIR_Coverage, 14317,
     /* 1467818 */     GIR_EraseRootFromParent_Done,
     /* 1467819 */   // Label 20584: @1467819
     /* 1467819 */   GIM_Try, /*On fail goto*//*Label 20585*/ GIMT_Encode4(1467919), // Rule ID 14320 //
     /* 1467824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1467827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1467835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1467838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1467841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467874 */     // MIs[1] Operand 1
     /* 1467874 */     // No operand predicates
     /* 1467874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467878 */     // MIs[0] policy
     /* 1467878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467890 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1467893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467918 */     // GIR_Coverage, 14320,
     /* 1467918 */     GIR_EraseRootFromParent_Done,
     /* 1467919 */   // Label 20585: @1467919
     /* 1467919 */   GIM_Try, /*On fail goto*//*Label 20586*/ GIMT_Encode4(1468019), // Rule ID 14321 //
     /* 1467924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1467927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1467935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1467938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1467941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467974 */     // MIs[1] Operand 1
     /* 1467974 */     // No operand predicates
     /* 1467974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467978 */     // MIs[0] policy
     /* 1467978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467990 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1467993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1468012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468018 */     // GIR_Coverage, 14321,
     /* 1468018 */     GIR_EraseRootFromParent_Done,
     /* 1468019 */   // Label 20586: @1468019
     /* 1468019 */   GIM_Try, /*On fail goto*//*Label 20587*/ GIMT_Encode4(1468119), // Rule ID 14324 //
     /* 1468024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1468027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1468035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1468038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1468041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1468054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468074 */     // MIs[1] Operand 1
     /* 1468074 */     // No operand predicates
     /* 1468074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468078 */     // MIs[0] policy
     /* 1468078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468090 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1468093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1468112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468118 */     // GIR_Coverage, 14324,
     /* 1468118 */     GIR_EraseRootFromParent_Done,
     /* 1468119 */   // Label 20587: @1468119
     /* 1468119 */   GIM_Try, /*On fail goto*//*Label 20588*/ GIMT_Encode4(1468219), // Rule ID 14325 //
     /* 1468124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1468127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1468135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1468138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1468141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1468154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468174 */     // MIs[1] Operand 1
     /* 1468174 */     // No operand predicates
     /* 1468174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468178 */     // MIs[0] policy
     /* 1468178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468190 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1468193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1468212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468218 */     // GIR_Coverage, 14325,
     /* 1468218 */     GIR_EraseRootFromParent_Done,
     /* 1468219 */   // Label 20588: @1468219
     /* 1468219 */   GIM_Try, /*On fail goto*//*Label 20589*/ GIMT_Encode4(1468319), // Rule ID 14328 //
     /* 1468224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1468227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1468235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1468238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1468241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1468247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468274 */     // MIs[1] Operand 1
     /* 1468274 */     // No operand predicates
     /* 1468274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468278 */     // MIs[0] policy
     /* 1468278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468290 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1468293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1468312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468318 */     // GIR_Coverage, 14328,
     /* 1468318 */     GIR_EraseRootFromParent_Done,
     /* 1468319 */   // Label 20589: @1468319
     /* 1468319 */   GIM_Try, /*On fail goto*//*Label 20590*/ GIMT_Encode4(1468419), // Rule ID 14329 //
     /* 1468324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1468327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1468335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1468338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1468341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1468347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468374 */     // MIs[1] Operand 1
     /* 1468374 */     // No operand predicates
     /* 1468374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468378 */     // MIs[0] policy
     /* 1468378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468390 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1468393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1468412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468418 */     // GIR_Coverage, 14329,
     /* 1468418 */     GIR_EraseRootFromParent_Done,
     /* 1468419 */   // Label 20590: @1468419
     /* 1468419 */   GIM_Try, /*On fail goto*//*Label 20591*/ GIMT_Encode4(1468519), // Rule ID 14508 //
     /* 1468424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1468435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1468438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1468441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468474 */     // MIs[1] Operand 1
     /* 1468474 */     // No operand predicates
     /* 1468474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468478 */     // MIs[0] policy
     /* 1468478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468490 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1468493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468518 */     // GIR_Coverage, 14508,
     /* 1468518 */     GIR_EraseRootFromParent_Done,
     /* 1468519 */   // Label 20591: @1468519
     /* 1468519 */   GIM_Try, /*On fail goto*//*Label 20592*/ GIMT_Encode4(1468619), // Rule ID 14509 //
     /* 1468524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1468535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1468538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1468541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468574 */     // MIs[1] Operand 1
     /* 1468574 */     // No operand predicates
     /* 1468574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468578 */     // MIs[0] policy
     /* 1468578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468590 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1468593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468618 */     // GIR_Coverage, 14509,
     /* 1468618 */     GIR_EraseRootFromParent_Done,
     /* 1468619 */   // Label 20592: @1468619
     /* 1468619 */   GIM_Try, /*On fail goto*//*Label 20593*/ GIMT_Encode4(1468719), // Rule ID 14512 //
     /* 1468624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1468635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1468638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1468641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468674 */     // MIs[1] Operand 1
     /* 1468674 */     // No operand predicates
     /* 1468674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468678 */     // MIs[0] policy
     /* 1468678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468690 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1468693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468718 */     // GIR_Coverage, 14512,
     /* 1468718 */     GIR_EraseRootFromParent_Done,
     /* 1468719 */   // Label 20593: @1468719
     /* 1468719 */   GIM_Try, /*On fail goto*//*Label 20594*/ GIMT_Encode4(1468819), // Rule ID 14513 //
     /* 1468724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1468735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1468738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1468741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468774 */     // MIs[1] Operand 1
     /* 1468774 */     // No operand predicates
     /* 1468774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468778 */     // MIs[0] policy
     /* 1468778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468790 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1468793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468818 */     // GIR_Coverage, 14513,
     /* 1468818 */     GIR_EraseRootFromParent_Done,
     /* 1468819 */   // Label 20594: @1468819
     /* 1468819 */   GIM_Try, /*On fail goto*//*Label 20595*/ GIMT_Encode4(1468919), // Rule ID 14516 //
     /* 1468824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1468835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1468838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1468841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468874 */     // MIs[1] Operand 1
     /* 1468874 */     // No operand predicates
     /* 1468874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468878 */     // MIs[0] policy
     /* 1468878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468890 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1468893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468918 */     // GIR_Coverage, 14516,
     /* 1468918 */     GIR_EraseRootFromParent_Done,
     /* 1468919 */   // Label 20595: @1468919
     /* 1468919 */   GIM_Try, /*On fail goto*//*Label 20596*/ GIMT_Encode4(1469019), // Rule ID 14517 //
     /* 1468924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1468935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1468938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1468941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468974 */     // MIs[1] Operand 1
     /* 1468974 */     // No operand predicates
     /* 1468974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468978 */     // MIs[0] policy
     /* 1468978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468990 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1468993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469018 */     // GIR_Coverage, 14517,
     /* 1469018 */     GIR_EraseRootFromParent_Done,
     /* 1469019 */   // Label 20596: @1469019
     /* 1469019 */   GIM_Try, /*On fail goto*//*Label 20597*/ GIMT_Encode4(1469119), // Rule ID 14520 //
     /* 1469024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1469035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1469038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1469041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469074 */     // MIs[1] Operand 1
     /* 1469074 */     // No operand predicates
     /* 1469074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469078 */     // MIs[0] policy
     /* 1469078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469090 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1469093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469118 */     // GIR_Coverage, 14520,
     /* 1469118 */     GIR_EraseRootFromParent_Done,
     /* 1469119 */   // Label 20597: @1469119
     /* 1469119 */   GIM_Try, /*On fail goto*//*Label 20598*/ GIMT_Encode4(1469219), // Rule ID 14521 //
     /* 1469124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1469135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1469138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1469141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469174 */     // MIs[1] Operand 1
     /* 1469174 */     // No operand predicates
     /* 1469174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469178 */     // MIs[0] policy
     /* 1469178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1469193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469218 */     // GIR_Coverage, 14521,
     /* 1469218 */     GIR_EraseRootFromParent_Done,
     /* 1469219 */   // Label 20598: @1469219
     /* 1469219 */   GIM_Try, /*On fail goto*//*Label 20599*/ GIMT_Encode4(1469319), // Rule ID 14524 //
     /* 1469224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1469235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1469238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1469241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469274 */     // MIs[1] Operand 1
     /* 1469274 */     // No operand predicates
     /* 1469274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469278 */     // MIs[0] policy
     /* 1469278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469290 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1469293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469318 */     // GIR_Coverage, 14524,
     /* 1469318 */     GIR_EraseRootFromParent_Done,
     /* 1469319 */   // Label 20599: @1469319
     /* 1469319 */   GIM_Try, /*On fail goto*//*Label 20600*/ GIMT_Encode4(1469419), // Rule ID 14525 //
     /* 1469324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1469335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1469338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1469341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469374 */     // MIs[1] Operand 1
     /* 1469374 */     // No operand predicates
     /* 1469374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469378 */     // MIs[0] policy
     /* 1469378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469390 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1469393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469418 */     // GIR_Coverage, 14525,
     /* 1469418 */     GIR_EraseRootFromParent_Done,
     /* 1469419 */   // Label 20600: @1469419
     /* 1469419 */   GIM_Try, /*On fail goto*//*Label 20601*/ GIMT_Encode4(1469519), // Rule ID 14528 //
     /* 1469424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1469435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1469438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1469441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469474 */     // MIs[1] Operand 1
     /* 1469474 */     // No operand predicates
     /* 1469474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469478 */     // MIs[0] policy
     /* 1469478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469490 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1469493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469518 */     // GIR_Coverage, 14528,
     /* 1469518 */     GIR_EraseRootFromParent_Done,
     /* 1469519 */   // Label 20601: @1469519
     /* 1469519 */   GIM_Try, /*On fail goto*//*Label 20602*/ GIMT_Encode4(1469619), // Rule ID 14529 //
     /* 1469524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1469535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1469538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1469541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469574 */     // MIs[1] Operand 1
     /* 1469574 */     // No operand predicates
     /* 1469574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469578 */     // MIs[0] policy
     /* 1469578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469590 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1469593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469618 */     // GIR_Coverage, 14529,
     /* 1469618 */     GIR_EraseRootFromParent_Done,
     /* 1469619 */   // Label 20602: @1469619
     /* 1469619 */   GIM_Try, /*On fail goto*//*Label 20603*/ GIMT_Encode4(1469719), // Rule ID 14532 //
     /* 1469624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1469635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1469638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1469641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469674 */     // MIs[1] Operand 1
     /* 1469674 */     // No operand predicates
     /* 1469674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469678 */     // MIs[0] policy
     /* 1469678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469690 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469718 */     // GIR_Coverage, 14532,
     /* 1469718 */     GIR_EraseRootFromParent_Done,
     /* 1469719 */   // Label 20603: @1469719
     /* 1469719 */   GIM_Try, /*On fail goto*//*Label 20604*/ GIMT_Encode4(1469819), // Rule ID 14533 //
     /* 1469724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1469735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1469738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1469741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469774 */     // MIs[1] Operand 1
     /* 1469774 */     // No operand predicates
     /* 1469774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469778 */     // MIs[0] policy
     /* 1469778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469790 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469818 */     // GIR_Coverage, 14533,
     /* 1469818 */     GIR_EraseRootFromParent_Done,
     /* 1469819 */   // Label 20604: @1469819
     /* 1469819 */   GIM_Try, /*On fail goto*//*Label 20605*/ GIMT_Encode4(1469919), // Rule ID 14536 //
     /* 1469824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1469835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1469838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1469841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469874 */     // MIs[1] Operand 1
     /* 1469874 */     // No operand predicates
     /* 1469874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469878 */     // MIs[0] policy
     /* 1469878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469918 */     // GIR_Coverage, 14536,
     /* 1469918 */     GIR_EraseRootFromParent_Done,
     /* 1469919 */   // Label 20605: @1469919
     /* 1469919 */   GIM_Try, /*On fail goto*//*Label 20606*/ GIMT_Encode4(1470019), // Rule ID 14537 //
     /* 1469924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1469935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1469938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1469941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469974 */     // MIs[1] Operand 1
     /* 1469974 */     // No operand predicates
     /* 1469974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469978 */     // MIs[0] policy
     /* 1469978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469990 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470018 */     // GIR_Coverage, 14537,
     /* 1470018 */     GIR_EraseRootFromParent_Done,
     /* 1470019 */   // Label 20606: @1470019
     /* 1470019 */   GIM_Try, /*On fail goto*//*Label 20607*/ GIMT_Encode4(1470119), // Rule ID 14540 //
     /* 1470024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1470035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1470038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1470041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1470047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470074 */     // MIs[1] Operand 1
     /* 1470074 */     // No operand predicates
     /* 1470074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470078 */     // MIs[0] policy
     /* 1470078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1470093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1470112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470118 */     // GIR_Coverage, 14540,
     /* 1470118 */     GIR_EraseRootFromParent_Done,
     /* 1470119 */   // Label 20607: @1470119
     /* 1470119 */   GIM_Try, /*On fail goto*//*Label 20608*/ GIMT_Encode4(1470219), // Rule ID 14541 //
     /* 1470124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1470135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1470138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1470141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1470147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470174 */     // MIs[1] Operand 1
     /* 1470174 */     // No operand predicates
     /* 1470174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470178 */     // MIs[0] policy
     /* 1470178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1470193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1470212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470218 */     // GIR_Coverage, 14541,
     /* 1470218 */     GIR_EraseRootFromParent_Done,
     /* 1470219 */   // Label 20608: @1470219
     /* 1470219 */   GIM_Try, /*On fail goto*//*Label 20609*/ GIMT_Encode4(1470319), // Rule ID 14544 //
     /* 1470224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1470227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1470235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1470238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1470241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1470247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470274 */     // MIs[1] Operand 1
     /* 1470274 */     // No operand predicates
     /* 1470274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470278 */     // MIs[0] policy
     /* 1470278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1470293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1470312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470318 */     // GIR_Coverage, 14544,
     /* 1470318 */     GIR_EraseRootFromParent_Done,
     /* 1470319 */   // Label 20609: @1470319
     /* 1470319 */   GIM_Try, /*On fail goto*//*Label 20610*/ GIMT_Encode4(1470419), // Rule ID 14545 //
     /* 1470324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1470327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1470335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1470338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1470341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1470347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470374 */     // MIs[1] Operand 1
     /* 1470374 */     // No operand predicates
     /* 1470374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470378 */     // MIs[0] policy
     /* 1470378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1470393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1470412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470418 */     // GIR_Coverage, 14545,
     /* 1470418 */     GIR_EraseRootFromParent_Done,
     /* 1470419 */   // Label 20610: @1470419
     /* 1470419 */   GIM_Try, /*On fail goto*//*Label 20611*/ GIMT_Encode4(1470519), // Rule ID 14548 //
     /* 1470424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1470435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1470438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1470441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1470447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470474 */     // MIs[1] Operand 1
     /* 1470474 */     // No operand predicates
     /* 1470474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470478 */     // MIs[0] policy
     /* 1470478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470490 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1470493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470518 */     // GIR_Coverage, 14548,
     /* 1470518 */     GIR_EraseRootFromParent_Done,
     /* 1470519 */   // Label 20611: @1470519
     /* 1470519 */   GIM_Try, /*On fail goto*//*Label 20612*/ GIMT_Encode4(1470619), // Rule ID 14549 //
     /* 1470524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1470535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1470538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1470541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1470547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470574 */     // MIs[1] Operand 1
     /* 1470574 */     // No operand predicates
     /* 1470574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470578 */     // MIs[0] policy
     /* 1470578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470590 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1470593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470618 */     // GIR_Coverage, 14549,
     /* 1470618 */     GIR_EraseRootFromParent_Done,
     /* 1470619 */   // Label 20612: @1470619
     /* 1470619 */   GIM_Try, /*On fail goto*//*Label 20613*/ GIMT_Encode4(1470719), // Rule ID 14552 //
     /* 1470624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1470635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1470638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1470641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1470647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470674 */     // MIs[1] Operand 1
     /* 1470674 */     // No operand predicates
     /* 1470674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470678 */     // MIs[0] policy
     /* 1470678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470690 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1470693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470718 */     // GIR_Coverage, 14552,
     /* 1470718 */     GIR_EraseRootFromParent_Done,
     /* 1470719 */   // Label 20613: @1470719
     /* 1470719 */   GIM_Try, /*On fail goto*//*Label 20614*/ GIMT_Encode4(1470819), // Rule ID 14553 //
     /* 1470724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1470735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1470738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1470741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1470747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470774 */     // MIs[1] Operand 1
     /* 1470774 */     // No operand predicates
     /* 1470774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470778 */     // MIs[0] policy
     /* 1470778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470790 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1470793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470818 */     // GIR_Coverage, 14553,
     /* 1470818 */     GIR_EraseRootFromParent_Done,
     /* 1470819 */   // Label 20614: @1470819
     /* 1470819 */   GIM_Try, /*On fail goto*//*Label 20615*/ GIMT_Encode4(1470919), // Rule ID 14556 //
     /* 1470824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1470835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1470838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1470841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1470847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470874 */     // MIs[1] Operand 1
     /* 1470874 */     // No operand predicates
     /* 1470874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470878 */     // MIs[0] policy
     /* 1470878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470890 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1470893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470918 */     // GIR_Coverage, 14556,
     /* 1470918 */     GIR_EraseRootFromParent_Done,
     /* 1470919 */   // Label 20615: @1470919
     /* 1470919 */   GIM_Try, /*On fail goto*//*Label 20616*/ GIMT_Encode4(1471019), // Rule ID 14557 //
     /* 1470924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1470935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1470938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1470941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1470947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470974 */     // MIs[1] Operand 1
     /* 1470974 */     // No operand predicates
     /* 1470974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470978 */     // MIs[0] policy
     /* 1470978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470990 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1470993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1471012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471018 */     // GIR_Coverage, 14557,
     /* 1471018 */     GIR_EraseRootFromParent_Done,
     /* 1471019 */   // Label 20616: @1471019
     /* 1471019 */   GIM_Try, /*On fail goto*//*Label 20617*/ GIMT_Encode4(1471119), // Rule ID 14560 //
     /* 1471024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1471035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1471038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1471041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471074 */     // MIs[1] Operand 1
     /* 1471074 */     // No operand predicates
     /* 1471074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471078 */     // MIs[0] policy
     /* 1471078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471118 */     // GIR_Coverage, 14560,
     /* 1471118 */     GIR_EraseRootFromParent_Done,
     /* 1471119 */   // Label 20617: @1471119
     /* 1471119 */   GIM_Try, /*On fail goto*//*Label 20618*/ GIMT_Encode4(1471219), // Rule ID 14561 //
     /* 1471124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1471135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1471138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1471141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471174 */     // MIs[1] Operand 1
     /* 1471174 */     // No operand predicates
     /* 1471174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471178 */     // MIs[0] policy
     /* 1471178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471218 */     // GIR_Coverage, 14561,
     /* 1471218 */     GIR_EraseRootFromParent_Done,
     /* 1471219 */   // Label 20618: @1471219
     /* 1471219 */   GIM_Try, /*On fail goto*//*Label 20619*/ GIMT_Encode4(1471319), // Rule ID 14564 //
     /* 1471224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1471235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1471238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1471241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1471247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471274 */     // MIs[1] Operand 1
     /* 1471274 */     // No operand predicates
     /* 1471274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471278 */     // MIs[0] policy
     /* 1471278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471290 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1471293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471318 */     // GIR_Coverage, 14564,
     /* 1471318 */     GIR_EraseRootFromParent_Done,
     /* 1471319 */   // Label 20619: @1471319
     /* 1471319 */   GIM_Try, /*On fail goto*//*Label 20620*/ GIMT_Encode4(1471419), // Rule ID 14565 //
     /* 1471324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1471335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1471338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1471341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1471347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471374 */     // MIs[1] Operand 1
     /* 1471374 */     // No operand predicates
     /* 1471374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471378 */     // MIs[0] policy
     /* 1471378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471390 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1471393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471418 */     // GIR_Coverage, 14565,
     /* 1471418 */     GIR_EraseRootFromParent_Done,
     /* 1471419 */   // Label 20620: @1471419
     /* 1471419 */   GIM_Try, /*On fail goto*//*Label 20621*/ GIMT_Encode4(1471519), // Rule ID 14568 //
     /* 1471424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1471435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1471438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1471441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1471447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471474 */     // MIs[1] Operand 1
     /* 1471474 */     // No operand predicates
     /* 1471474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471478 */     // MIs[0] policy
     /* 1471478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471490 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1471493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471518 */     // GIR_Coverage, 14568,
     /* 1471518 */     GIR_EraseRootFromParent_Done,
     /* 1471519 */   // Label 20621: @1471519
     /* 1471519 */   GIM_Try, /*On fail goto*//*Label 20622*/ GIMT_Encode4(1471619), // Rule ID 14569 //
     /* 1471524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1471535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1471538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1471541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1471547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471574 */     // MIs[1] Operand 1
     /* 1471574 */     // No operand predicates
     /* 1471574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471578 */     // MIs[0] policy
     /* 1471578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471590 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1471593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471618 */     // GIR_Coverage, 14569,
     /* 1471618 */     GIR_EraseRootFromParent_Done,
     /* 1471619 */   // Label 20622: @1471619
     /* 1471619 */   GIM_Try, /*On fail goto*//*Label 20623*/ GIMT_Encode4(1471719), // Rule ID 14572 //
     /* 1471624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1471635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1471638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1471641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471674 */     // MIs[1] Operand 1
     /* 1471674 */     // No operand predicates
     /* 1471674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471678 */     // MIs[0] policy
     /* 1471678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471718 */     // GIR_Coverage, 14572,
     /* 1471718 */     GIR_EraseRootFromParent_Done,
     /* 1471719 */   // Label 20623: @1471719
     /* 1471719 */   GIM_Try, /*On fail goto*//*Label 20624*/ GIMT_Encode4(1471819), // Rule ID 14573 //
     /* 1471724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1471735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1471738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1471741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471774 */     // MIs[1] Operand 1
     /* 1471774 */     // No operand predicates
     /* 1471774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471778 */     // MIs[0] policy
     /* 1471778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471818 */     // GIR_Coverage, 14573,
     /* 1471818 */     GIR_EraseRootFromParent_Done,
     /* 1471819 */   // Label 20624: @1471819
     /* 1471819 */   GIM_Try, /*On fail goto*//*Label 20625*/ GIMT_Encode4(1471919), // Rule ID 14576 //
     /* 1471824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1471835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1471838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1471841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471874 */     // MIs[1] Operand 1
     /* 1471874 */     // No operand predicates
     /* 1471874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471878 */     // MIs[0] policy
     /* 1471878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471890 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1471893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471918 */     // GIR_Coverage, 14576,
     /* 1471918 */     GIR_EraseRootFromParent_Done,
     /* 1471919 */   // Label 20625: @1471919
     /* 1471919 */   GIM_Try, /*On fail goto*//*Label 20626*/ GIMT_Encode4(1472019), // Rule ID 14577 //
     /* 1471924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1471935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1471938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1471941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471974 */     // MIs[1] Operand 1
     /* 1471974 */     // No operand predicates
     /* 1471974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471978 */     // MIs[0] policy
     /* 1471978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471990 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1471993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1472012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472018 */     // GIR_Coverage, 14577,
     /* 1472018 */     GIR_EraseRootFromParent_Done,
     /* 1472019 */   // Label 20626: @1472019
     /* 1472019 */   GIM_Try, /*On fail goto*//*Label 20627*/ GIMT_Encode4(1472119), // Rule ID 14580 //
     /* 1472024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1472035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1472038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1472041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1472047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472074 */     // MIs[1] Operand 1
     /* 1472074 */     // No operand predicates
     /* 1472074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472078 */     // MIs[0] policy
     /* 1472078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472090 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1472093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1472112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472118 */     // GIR_Coverage, 14580,
     /* 1472118 */     GIR_EraseRootFromParent_Done,
     /* 1472119 */   // Label 20627: @1472119
     /* 1472119 */   GIM_Try, /*On fail goto*//*Label 20628*/ GIMT_Encode4(1472219), // Rule ID 14581 //
     /* 1472124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1472135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1472138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1472141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1472147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472174 */     // MIs[1] Operand 1
     /* 1472174 */     // No operand predicates
     /* 1472174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472178 */     // MIs[0] policy
     /* 1472178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472190 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1472193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1472212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472218 */     // GIR_Coverage, 14581,
     /* 1472218 */     GIR_EraseRootFromParent_Done,
     /* 1472219 */   // Label 20628: @1472219
     /* 1472219 */   GIM_Try, /*On fail goto*//*Label 20629*/ GIMT_Encode4(1472319), // Rule ID 14584 //
     /* 1472224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1472227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1472235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1472238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1472241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1472247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472274 */     // MIs[1] Operand 1
     /* 1472274 */     // No operand predicates
     /* 1472274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472278 */     // MIs[0] policy
     /* 1472278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1472293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472318 */     // GIR_Coverage, 14584,
     /* 1472318 */     GIR_EraseRootFromParent_Done,
     /* 1472319 */   // Label 20629: @1472319
     /* 1472319 */   GIM_Try, /*On fail goto*//*Label 20630*/ GIMT_Encode4(1472419), // Rule ID 14585 //
     /* 1472324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1472327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1472335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1472338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1472341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1472347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472374 */     // MIs[1] Operand 1
     /* 1472374 */     // No operand predicates
     /* 1472374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472378 */     // MIs[0] policy
     /* 1472378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472390 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1472393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472418 */     // GIR_Coverage, 14585,
     /* 1472418 */     GIR_EraseRootFromParent_Done,
     /* 1472419 */   // Label 20630: @1472419
     /* 1472419 */   GIM_Try, /*On fail goto*//*Label 20631*/ GIMT_Encode4(1472519), // Rule ID 14588 //
     /* 1472424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1472427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1472435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1472438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1472441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1472447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472474 */     // MIs[1] Operand 1
     /* 1472474 */     // No operand predicates
     /* 1472474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472478 */     // MIs[0] policy
     /* 1472478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472490 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1472493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472518 */     // GIR_Coverage, 14588,
     /* 1472518 */     GIR_EraseRootFromParent_Done,
     /* 1472519 */   // Label 20631: @1472519
     /* 1472519 */   GIM_Try, /*On fail goto*//*Label 20632*/ GIMT_Encode4(1472619), // Rule ID 14589 //
     /* 1472524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1472527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1472535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1472538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1472541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1472547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472574 */     // MIs[1] Operand 1
     /* 1472574 */     // No operand predicates
     /* 1472574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472578 */     // MIs[0] policy
     /* 1472578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472590 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1472593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472618 */     // GIR_Coverage, 14589,
     /* 1472618 */     GIR_EraseRootFromParent_Done,
     /* 1472619 */   // Label 20632: @1472619
     /* 1472619 */   GIM_Try, /*On fail goto*//*Label 20633*/ GIMT_Encode4(1472719), // Rule ID 14592 //
     /* 1472624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1472627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1472635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1472638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1472641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1472647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472674 */     // MIs[1] Operand 1
     /* 1472674 */     // No operand predicates
     /* 1472674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472678 */     // MIs[0] policy
     /* 1472678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1472693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472718 */     // GIR_Coverage, 14592,
     /* 1472718 */     GIR_EraseRootFromParent_Done,
     /* 1472719 */   // Label 20633: @1472719
     /* 1472719 */   GIM_Try, /*On fail goto*//*Label 20634*/ GIMT_Encode4(1472819), // Rule ID 14593 //
     /* 1472724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1472727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1472735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1472738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1472741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1472747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472774 */     // MIs[1] Operand 1
     /* 1472774 */     // No operand predicates
     /* 1472774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472778 */     // MIs[0] policy
     /* 1472778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472790 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1472793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472818 */     // GIR_Coverage, 14593,
     /* 1472818 */     GIR_EraseRootFromParent_Done,
     /* 1472819 */   // Label 20634: @1472819
     /* 1472819 */   GIM_Try, /*On fail goto*//*Label 20635*/ GIMT_Encode4(1472916), // Rule ID 23712 //
     /* 1472824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1472835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1472838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1472841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472874 */     // MIs[1] Operand 1
     /* 1472874 */     // No operand predicates
     /* 1472874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472878 */     // MIs[0] policy
     /* 1472878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472890 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1472893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472915 */     // GIR_Coverage, 23712,
     /* 1472915 */     GIR_EraseRootFromParent_Done,
     /* 1472916 */   // Label 20635: @1472916
     /* 1472916 */   GIM_Try, /*On fail goto*//*Label 20636*/ GIMT_Encode4(1473013), // Rule ID 23713 //
     /* 1472921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1472932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1472935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1472938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472971 */     // MIs[1] Operand 1
     /* 1472971 */     // No operand predicates
     /* 1472971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472975 */     // MIs[0] policy
     /* 1472975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472987 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1472990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473012 */     // GIR_Coverage, 23713,
     /* 1473012 */     GIR_EraseRootFromParent_Done,
     /* 1473013 */   // Label 20636: @1473013
     /* 1473013 */   GIM_Try, /*On fail goto*//*Label 20637*/ GIMT_Encode4(1473110), // Rule ID 23716 //
     /* 1473018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1473029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1473032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1473035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473068 */     // MIs[1] Operand 1
     /* 1473068 */     // No operand predicates
     /* 1473068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473072 */     // MIs[0] policy
     /* 1473072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473084 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1473087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473109 */     // GIR_Coverage, 23716,
     /* 1473109 */     GIR_EraseRootFromParent_Done,
     /* 1473110 */   // Label 20637: @1473110
     /* 1473110 */   GIM_Try, /*On fail goto*//*Label 20638*/ GIMT_Encode4(1473207), // Rule ID 23717 //
     /* 1473115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1473126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1473129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1473132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473165 */     // MIs[1] Operand 1
     /* 1473165 */     // No operand predicates
     /* 1473165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473169 */     // MIs[0] policy
     /* 1473169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473181 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1473184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473206 */     // GIR_Coverage, 23717,
     /* 1473206 */     GIR_EraseRootFromParent_Done,
     /* 1473207 */   // Label 20638: @1473207
     /* 1473207 */   GIM_Try, /*On fail goto*//*Label 20639*/ GIMT_Encode4(1473304), // Rule ID 23720 //
     /* 1473212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1473223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1473226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1473229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473262 */     // MIs[1] Operand 1
     /* 1473262 */     // No operand predicates
     /* 1473262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473266 */     // MIs[0] policy
     /* 1473266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473278 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473303 */     // GIR_Coverage, 23720,
     /* 1473303 */     GIR_EraseRootFromParent_Done,
     /* 1473304 */   // Label 20639: @1473304
     /* 1473304 */   GIM_Try, /*On fail goto*//*Label 20640*/ GIMT_Encode4(1473401), // Rule ID 23721 //
     /* 1473309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1473320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1473323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1473326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473359 */     // MIs[1] Operand 1
     /* 1473359 */     // No operand predicates
     /* 1473359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473363 */     // MIs[0] policy
     /* 1473363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473375 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473400 */     // GIR_Coverage, 23721,
     /* 1473400 */     GIR_EraseRootFromParent_Done,
     /* 1473401 */   // Label 20640: @1473401
     /* 1473401 */   GIM_Try, /*On fail goto*//*Label 20641*/ GIMT_Encode4(1473498), // Rule ID 23724 //
     /* 1473406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1473417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1473420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1473423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473456 */     // MIs[1] Operand 1
     /* 1473456 */     // No operand predicates
     /* 1473456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473460 */     // MIs[0] policy
     /* 1473460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473472 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1473475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473497 */     // GIR_Coverage, 23724,
     /* 1473497 */     GIR_EraseRootFromParent_Done,
     /* 1473498 */   // Label 20641: @1473498
     /* 1473498 */   GIM_Try, /*On fail goto*//*Label 20642*/ GIMT_Encode4(1473595), // Rule ID 23725 //
     /* 1473503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1473514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1473517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1473520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473553 */     // MIs[1] Operand 1
     /* 1473553 */     // No operand predicates
     /* 1473553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473557 */     // MIs[0] policy
     /* 1473557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473569 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1473572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473594 */     // GIR_Coverage, 23725,
     /* 1473594 */     GIR_EraseRootFromParent_Done,
     /* 1473595 */   // Label 20642: @1473595
     /* 1473595 */   GIM_Try, /*On fail goto*//*Label 20643*/ GIMT_Encode4(1473692), // Rule ID 23728 //
     /* 1473600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1473611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1473614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1473617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473650 */     // MIs[1] Operand 1
     /* 1473650 */     // No operand predicates
     /* 1473650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473654 */     // MIs[0] policy
     /* 1473654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473666 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473691 */     // GIR_Coverage, 23728,
     /* 1473691 */     GIR_EraseRootFromParent_Done,
     /* 1473692 */   // Label 20643: @1473692
     /* 1473692 */   GIM_Try, /*On fail goto*//*Label 20644*/ GIMT_Encode4(1473789), // Rule ID 23729 //
     /* 1473697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1473708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1473711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1473714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473747 */     // MIs[1] Operand 1
     /* 1473747 */     // No operand predicates
     /* 1473747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473751 */     // MIs[0] policy
     /* 1473751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473763 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473788 */     // GIR_Coverage, 23729,
     /* 1473788 */     GIR_EraseRootFromParent_Done,
     /* 1473789 */   // Label 20644: @1473789
     /* 1473789 */   GIM_Try, /*On fail goto*//*Label 20645*/ GIMT_Encode4(1473886), // Rule ID 23732 //
     /* 1473794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1473805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1473808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1473811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473844 */     // MIs[1] Operand 1
     /* 1473844 */     // No operand predicates
     /* 1473844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473848 */     // MIs[0] policy
     /* 1473848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473885 */     // GIR_Coverage, 23732,
     /* 1473885 */     GIR_EraseRootFromParent_Done,
     /* 1473886 */   // Label 20645: @1473886
     /* 1473886 */   GIM_Try, /*On fail goto*//*Label 20646*/ GIMT_Encode4(1473983), // Rule ID 23733 //
     /* 1473891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1473902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1473905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1473908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473941 */     // MIs[1] Operand 1
     /* 1473941 */     // No operand predicates
     /* 1473941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473945 */     // MIs[0] policy
     /* 1473945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473957 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473982 */     // GIR_Coverage, 23733,
     /* 1473982 */     GIR_EraseRootFromParent_Done,
     /* 1473983 */   // Label 20646: @1473983
     /* 1473983 */   GIM_Try, /*On fail goto*//*Label 20647*/ GIMT_Encode4(1474080), // Rule ID 23736 //
     /* 1473988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1473999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1474002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1474005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474038 */     // MIs[1] Operand 1
     /* 1474038 */     // No operand predicates
     /* 1474038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474042 */     // MIs[0] policy
     /* 1474042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474054 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474079 */     // GIR_Coverage, 23736,
     /* 1474079 */     GIR_EraseRootFromParent_Done,
     /* 1474080 */   // Label 20647: @1474080
     /* 1474080 */   GIM_Try, /*On fail goto*//*Label 20648*/ GIMT_Encode4(1474177), // Rule ID 23737 //
     /* 1474085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1474096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1474099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1474102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474135 */     // MIs[1] Operand 1
     /* 1474135 */     // No operand predicates
     /* 1474135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474139 */     // MIs[0] policy
     /* 1474139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474151 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474176 */     // GIR_Coverage, 23737,
     /* 1474176 */     GIR_EraseRootFromParent_Done,
     /* 1474177 */   // Label 20648: @1474177
     /* 1474177 */   GIM_Try, /*On fail goto*//*Label 20649*/ GIMT_Encode4(1474274), // Rule ID 23740 //
     /* 1474182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1474193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1474196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1474199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1474205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474232 */     // MIs[1] Operand 1
     /* 1474232 */     // No operand predicates
     /* 1474232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474236 */     // MIs[0] policy
     /* 1474236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474248 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474273 */     // GIR_Coverage, 23740,
     /* 1474273 */     GIR_EraseRootFromParent_Done,
     /* 1474274 */   // Label 20649: @1474274
     /* 1474274 */   GIM_Try, /*On fail goto*//*Label 20650*/ GIMT_Encode4(1474371), // Rule ID 23741 //
     /* 1474279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1474290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1474293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1474296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1474302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474329 */     // MIs[1] Operand 1
     /* 1474329 */     // No operand predicates
     /* 1474329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474333 */     // MIs[0] policy
     /* 1474333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474345 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474370 */     // GIR_Coverage, 23741,
     /* 1474370 */     GIR_EraseRootFromParent_Done,
     /* 1474371 */   // Label 20650: @1474371
     /* 1474371 */   GIM_Try, /*On fail goto*//*Label 20651*/ GIMT_Encode4(1474468), // Rule ID 23744 //
     /* 1474376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1474387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1474390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1474393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1474399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474426 */     // MIs[1] Operand 1
     /* 1474426 */     // No operand predicates
     /* 1474426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474430 */     // MIs[0] policy
     /* 1474430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474442 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474467 */     // GIR_Coverage, 23744,
     /* 1474467 */     GIR_EraseRootFromParent_Done,
     /* 1474468 */   // Label 20651: @1474468
     /* 1474468 */   GIM_Try, /*On fail goto*//*Label 20652*/ GIMT_Encode4(1474565), // Rule ID 23745 //
     /* 1474473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1474484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1474487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1474490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1474496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474523 */     // MIs[1] Operand 1
     /* 1474523 */     // No operand predicates
     /* 1474523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474527 */     // MIs[0] policy
     /* 1474527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474539 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474564 */     // GIR_Coverage, 23745,
     /* 1474564 */     GIR_EraseRootFromParent_Done,
     /* 1474565 */   // Label 20652: @1474565
     /* 1474565 */   GIM_Try, /*On fail goto*//*Label 20653*/ GIMT_Encode4(1474662), // Rule ID 23748 //
     /* 1474570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1474573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1474581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1474584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1474587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474620 */     // MIs[1] Operand 1
     /* 1474620 */     // No operand predicates
     /* 1474620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474624 */     // MIs[0] policy
     /* 1474624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474661 */     // GIR_Coverage, 23748,
     /* 1474661 */     GIR_EraseRootFromParent_Done,
     /* 1474662 */   // Label 20653: @1474662
     /* 1474662 */   GIM_Try, /*On fail goto*//*Label 20654*/ GIMT_Encode4(1474759), // Rule ID 23749 //
     /* 1474667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1474670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1474678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1474681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1474684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474717 */     // MIs[1] Operand 1
     /* 1474717 */     // No operand predicates
     /* 1474717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474721 */     // MIs[0] policy
     /* 1474721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474733 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474758 */     // GIR_Coverage, 23749,
     /* 1474758 */     GIR_EraseRootFromParent_Done,
     /* 1474759 */   // Label 20654: @1474759
     /* 1474759 */   GIM_Try, /*On fail goto*//*Label 20655*/ GIMT_Encode4(1474856), // Rule ID 23752 //
     /* 1474764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1474775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1474778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1474781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1474787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474814 */     // MIs[1] Operand 1
     /* 1474814 */     // No operand predicates
     /* 1474814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474818 */     // MIs[0] policy
     /* 1474818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474830 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1474833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474855 */     // GIR_Coverage, 23752,
     /* 1474855 */     GIR_EraseRootFromParent_Done,
     /* 1474856 */   // Label 20655: @1474856
     /* 1474856 */   GIM_Try, /*On fail goto*//*Label 20656*/ GIMT_Encode4(1474953), // Rule ID 23753 //
     /* 1474861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1474872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1474875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1474878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1474884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474911 */     // MIs[1] Operand 1
     /* 1474911 */     // No operand predicates
     /* 1474911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474915 */     // MIs[0] policy
     /* 1474915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474927 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1474930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474952 */     // GIR_Coverage, 23753,
     /* 1474952 */     GIR_EraseRootFromParent_Done,
     /* 1474953 */   // Label 20656: @1474953
     /* 1474953 */   GIM_Try, /*On fail goto*//*Label 20657*/ GIMT_Encode4(1475050), // Rule ID 23756 //
     /* 1474958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1474969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1474972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1474975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1474981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475008 */     // MIs[1] Operand 1
     /* 1475008 */     // No operand predicates
     /* 1475008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475012 */     // MIs[0] policy
     /* 1475012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475024 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1475046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475049 */     // GIR_Coverage, 23756,
     /* 1475049 */     GIR_EraseRootFromParent_Done,
     /* 1475050 */   // Label 20657: @1475050
     /* 1475050 */   GIM_Try, /*On fail goto*//*Label 20658*/ GIMT_Encode4(1475147), // Rule ID 23757 //
     /* 1475055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1475066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1475069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1475072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1475078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475105 */     // MIs[1] Operand 1
     /* 1475105 */     // No operand predicates
     /* 1475105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475109 */     // MIs[0] policy
     /* 1475109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475121 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1475143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475146 */     // GIR_Coverage, 23757,
     /* 1475146 */     GIR_EraseRootFromParent_Done,
     /* 1475147 */   // Label 20658: @1475147
     /* 1475147 */   GIM_Try, /*On fail goto*//*Label 20659*/ GIMT_Encode4(1475244), // Rule ID 23760 //
     /* 1475152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1475163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1475166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1475169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1475175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475202 */     // MIs[1] Operand 1
     /* 1475202 */     // No operand predicates
     /* 1475202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475206 */     // MIs[0] policy
     /* 1475206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475218 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1475240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475243 */     // GIR_Coverage, 23760,
     /* 1475243 */     GIR_EraseRootFromParent_Done,
     /* 1475244 */   // Label 20659: @1475244
     /* 1475244 */   GIM_Try, /*On fail goto*//*Label 20660*/ GIMT_Encode4(1475341), // Rule ID 23761 //
     /* 1475249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1475260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1475263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1475266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1475272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475299 */     // MIs[1] Operand 1
     /* 1475299 */     // No operand predicates
     /* 1475299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475303 */     // MIs[0] policy
     /* 1475303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475315 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1475337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475340 */     // GIR_Coverage, 23761,
     /* 1475340 */     GIR_EraseRootFromParent_Done,
     /* 1475341 */   // Label 20660: @1475341
     /* 1475341 */   GIM_Try, /*On fail goto*//*Label 20661*/ GIMT_Encode4(1475438), // Rule ID 23764 //
     /* 1475346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1475357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1475360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1475363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475396 */     // MIs[1] Operand 1
     /* 1475396 */     // No operand predicates
     /* 1475396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475400 */     // MIs[0] policy
     /* 1475400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475412 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475437 */     // GIR_Coverage, 23764,
     /* 1475437 */     GIR_EraseRootFromParent_Done,
     /* 1475438 */   // Label 20661: @1475438
     /* 1475438 */   GIM_Try, /*On fail goto*//*Label 20662*/ GIMT_Encode4(1475535), // Rule ID 23765 //
     /* 1475443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1475454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1475457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1475460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475493 */     // MIs[1] Operand 1
     /* 1475493 */     // No operand predicates
     /* 1475493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475497 */     // MIs[0] policy
     /* 1475497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475509 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475534 */     // GIR_Coverage, 23765,
     /* 1475534 */     GIR_EraseRootFromParent_Done,
     /* 1475535 */   // Label 20662: @1475535
     /* 1475535 */   GIM_Try, /*On fail goto*//*Label 20663*/ GIMT_Encode4(1475632), // Rule ID 23768 //
     /* 1475540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1475551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1475554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1475557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475590 */     // MIs[1] Operand 1
     /* 1475590 */     // No operand predicates
     /* 1475590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475594 */     // MIs[0] policy
     /* 1475594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475606 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475631 */     // GIR_Coverage, 23768,
     /* 1475631 */     GIR_EraseRootFromParent_Done,
     /* 1475632 */   // Label 20663: @1475632
     /* 1475632 */   GIM_Try, /*On fail goto*//*Label 20664*/ GIMT_Encode4(1475729), // Rule ID 23769 //
     /* 1475637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1475648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1475651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1475654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475687 */     // MIs[1] Operand 1
     /* 1475687 */     // No operand predicates
     /* 1475687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475691 */     // MIs[0] policy
     /* 1475691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475703 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475728 */     // GIR_Coverage, 23769,
     /* 1475728 */     GIR_EraseRootFromParent_Done,
     /* 1475729 */   // Label 20664: @1475729
     /* 1475729 */   GIM_Try, /*On fail goto*//*Label 20665*/ GIMT_Encode4(1475826), // Rule ID 23772 //
     /* 1475734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1475745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1475748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1475751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1475757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475784 */     // MIs[1] Operand 1
     /* 1475784 */     // No operand predicates
     /* 1475784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475788 */     // MIs[0] policy
     /* 1475788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475800 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475825 */     // GIR_Coverage, 23772,
     /* 1475825 */     GIR_EraseRootFromParent_Done,
     /* 1475826 */   // Label 20665: @1475826
     /* 1475826 */   GIM_Try, /*On fail goto*//*Label 20666*/ GIMT_Encode4(1475923), // Rule ID 23773 //
     /* 1475831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1475842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1475845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1475848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1475854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475881 */     // MIs[1] Operand 1
     /* 1475881 */     // No operand predicates
     /* 1475881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475885 */     // MIs[0] policy
     /* 1475885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475897 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475922 */     // GIR_Coverage, 23773,
     /* 1475922 */     GIR_EraseRootFromParent_Done,
     /* 1475923 */   // Label 20666: @1475923
     /* 1475923 */   GIM_Try, /*On fail goto*//*Label 20667*/ GIMT_Encode4(1476020), // Rule ID 23776 //
     /* 1475928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1475939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1475942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1475945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475978 */     // MIs[1] Operand 1
     /* 1475978 */     // No operand predicates
     /* 1475978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475982 */     // MIs[0] policy
     /* 1475982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476019 */     // GIR_Coverage, 23776,
     /* 1476019 */     GIR_EraseRootFromParent_Done,
     /* 1476020 */   // Label 20667: @1476020
     /* 1476020 */   GIM_Try, /*On fail goto*//*Label 20668*/ GIMT_Encode4(1476117), // Rule ID 23777 //
     /* 1476025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1476036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1476039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1476042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476075 */     // MIs[1] Operand 1
     /* 1476075 */     // No operand predicates
     /* 1476075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476079 */     // MIs[0] policy
     /* 1476079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476091 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476116 */     // GIR_Coverage, 23777,
     /* 1476116 */     GIR_EraseRootFromParent_Done,
     /* 1476117 */   // Label 20668: @1476117
     /* 1476117 */   GIM_Try, /*On fail goto*//*Label 20669*/ GIMT_Encode4(1476214), // Rule ID 23780 //
     /* 1476122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1476133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1476136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1476139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476172 */     // MIs[1] Operand 1
     /* 1476172 */     // No operand predicates
     /* 1476172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476176 */     // MIs[0] policy
     /* 1476176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476188 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476213 */     // GIR_Coverage, 23780,
     /* 1476213 */     GIR_EraseRootFromParent_Done,
     /* 1476214 */   // Label 20669: @1476214
     /* 1476214 */   GIM_Try, /*On fail goto*//*Label 20670*/ GIMT_Encode4(1476311), // Rule ID 23781 //
     /* 1476219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1476230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1476233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1476236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476269 */     // MIs[1] Operand 1
     /* 1476269 */     // No operand predicates
     /* 1476269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476273 */     // MIs[0] policy
     /* 1476273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476285 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476310 */     // GIR_Coverage, 23781,
     /* 1476310 */     GIR_EraseRootFromParent_Done,
     /* 1476311 */   // Label 20670: @1476311
     /* 1476311 */   GIM_Try, /*On fail goto*//*Label 20671*/ GIMT_Encode4(1476408), // Rule ID 23784 //
     /* 1476316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1476327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1476330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1476333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1476339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476366 */     // MIs[1] Operand 1
     /* 1476366 */     // No operand predicates
     /* 1476366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476370 */     // MIs[0] policy
     /* 1476370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476382 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476407 */     // GIR_Coverage, 23784,
     /* 1476407 */     GIR_EraseRootFromParent_Done,
     /* 1476408 */   // Label 20671: @1476408
     /* 1476408 */   GIM_Try, /*On fail goto*//*Label 20672*/ GIMT_Encode4(1476505), // Rule ID 23785 //
     /* 1476413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1476424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1476427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1476430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1476436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476463 */     // MIs[1] Operand 1
     /* 1476463 */     // No operand predicates
     /* 1476463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476467 */     // MIs[0] policy
     /* 1476467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476479 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476504 */     // GIR_Coverage, 23785,
     /* 1476504 */     GIR_EraseRootFromParent_Done,
     /* 1476505 */   // Label 20672: @1476505
     /* 1476505 */   GIM_Try, /*On fail goto*//*Label 20673*/ GIMT_Encode4(1476602), // Rule ID 23788 //
     /* 1476510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1476521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1476524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1476527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476560 */     // MIs[1] Operand 1
     /* 1476560 */     // No operand predicates
     /* 1476560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476564 */     // MIs[0] policy
     /* 1476564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476601 */     // GIR_Coverage, 23788,
     /* 1476601 */     GIR_EraseRootFromParent_Done,
     /* 1476602 */   // Label 20673: @1476602
     /* 1476602 */   GIM_Try, /*On fail goto*//*Label 20674*/ GIMT_Encode4(1476699), // Rule ID 23789 //
     /* 1476607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1476618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1476621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1476624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476657 */     // MIs[1] Operand 1
     /* 1476657 */     // No operand predicates
     /* 1476657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476661 */     // MIs[0] policy
     /* 1476661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476673 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476698 */     // GIR_Coverage, 23789,
     /* 1476698 */     GIR_EraseRootFromParent_Done,
     /* 1476699 */   // Label 20674: @1476699
     /* 1476699 */   GIM_Try, /*On fail goto*//*Label 20675*/ GIMT_Encode4(1476796), // Rule ID 23792 //
     /* 1476704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1476715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1476718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1476721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476754 */     // MIs[1] Operand 1
     /* 1476754 */     // No operand predicates
     /* 1476754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476758 */     // MIs[0] policy
     /* 1476758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476770 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476795 */     // GIR_Coverage, 23792,
     /* 1476795 */     GIR_EraseRootFromParent_Done,
     /* 1476796 */   // Label 20675: @1476796
     /* 1476796 */   GIM_Try, /*On fail goto*//*Label 20676*/ GIMT_Encode4(1476893), // Rule ID 23793 //
     /* 1476801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1476812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1476815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1476818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476851 */     // MIs[1] Operand 1
     /* 1476851 */     // No operand predicates
     /* 1476851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476855 */     // MIs[0] policy
     /* 1476855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476867 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476892 */     // GIR_Coverage, 23793,
     /* 1476892 */     GIR_EraseRootFromParent_Done,
     /* 1476893 */   // Label 20676: @1476893
     /* 1476893 */   GIM_Try, /*On fail goto*//*Label 20677*/ GIMT_Encode4(1476990), // Rule ID 23796 //
     /* 1476898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1476909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1476912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1476915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476948 */     // MIs[1] Operand 1
     /* 1476948 */     // No operand predicates
     /* 1476948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476952 */     // MIs[0] policy
     /* 1476952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476964 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476989 */     // GIR_Coverage, 23796,
     /* 1476989 */     GIR_EraseRootFromParent_Done,
     /* 1476990 */   // Label 20677: @1476990
     /* 1476990 */   GIM_Try, /*On fail goto*//*Label 20678*/ GIMT_Encode4(1477087), // Rule ID 23797 //
     /* 1476995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1477006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1477009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1477012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1477025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477045 */     // MIs[1] Operand 1
     /* 1477045 */     // No operand predicates
     /* 1477045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477049 */     // MIs[0] policy
     /* 1477049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477061 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1477064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1477083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477086 */     // GIR_Coverage, 23797,
     /* 1477086 */     GIR_EraseRootFromParent_Done,
     /* 1477087 */   // Label 20678: @1477087
     /* 1477087 */   GIM_Try, /*On fail goto*//*Label 20679*/ GIMT_Encode4(1477184), // Rule ID 23888 //
     /* 1477092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1477103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1477106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1477109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477142 */     // MIs[1] Operand 1
     /* 1477142 */     // No operand predicates
     /* 1477142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477146 */     // MIs[0] policy
     /* 1477146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477158 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1477161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477183 */     // GIR_Coverage, 23888,
     /* 1477183 */     GIR_EraseRootFromParent_Done,
     /* 1477184 */   // Label 20679: @1477184
     /* 1477184 */   GIM_Try, /*On fail goto*//*Label 20680*/ GIMT_Encode4(1477281), // Rule ID 23889 //
     /* 1477189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1477200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1477203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1477206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477239 */     // MIs[1] Operand 1
     /* 1477239 */     // No operand predicates
     /* 1477239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477243 */     // MIs[0] policy
     /* 1477243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477255 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1477258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477280 */     // GIR_Coverage, 23889,
     /* 1477280 */     GIR_EraseRootFromParent_Done,
     /* 1477281 */   // Label 20680: @1477281
     /* 1477281 */   GIM_Try, /*On fail goto*//*Label 20681*/ GIMT_Encode4(1477378), // Rule ID 23892 //
     /* 1477286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1477297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1477300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1477303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477336 */     // MIs[1] Operand 1
     /* 1477336 */     // No operand predicates
     /* 1477336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477340 */     // MIs[0] policy
     /* 1477340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477352 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477377 */     // GIR_Coverage, 23892,
     /* 1477377 */     GIR_EraseRootFromParent_Done,
     /* 1477378 */   // Label 20681: @1477378
     /* 1477378 */   GIM_Try, /*On fail goto*//*Label 20682*/ GIMT_Encode4(1477475), // Rule ID 23893 //
     /* 1477383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1477394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1477397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1477400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477433 */     // MIs[1] Operand 1
     /* 1477433 */     // No operand predicates
     /* 1477433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477437 */     // MIs[0] policy
     /* 1477437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477449 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477474 */     // GIR_Coverage, 23893,
     /* 1477474 */     GIR_EraseRootFromParent_Done,
     /* 1477475 */   // Label 20682: @1477475
     /* 1477475 */   GIM_Try, /*On fail goto*//*Label 20683*/ GIMT_Encode4(1477572), // Rule ID 23896 //
     /* 1477480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1477491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1477494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1477497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477530 */     // MIs[1] Operand 1
     /* 1477530 */     // No operand predicates
     /* 1477530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477534 */     // MIs[0] policy
     /* 1477534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477546 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477571 */     // GIR_Coverage, 23896,
     /* 1477571 */     GIR_EraseRootFromParent_Done,
     /* 1477572 */   // Label 20683: @1477572
     /* 1477572 */   GIM_Try, /*On fail goto*//*Label 20684*/ GIMT_Encode4(1477669), // Rule ID 23897 //
     /* 1477577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1477588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1477591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1477594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477627 */     // MIs[1] Operand 1
     /* 1477627 */     // No operand predicates
     /* 1477627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477631 */     // MIs[0] policy
     /* 1477631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477643 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477668 */     // GIR_Coverage, 23897,
     /* 1477668 */     GIR_EraseRootFromParent_Done,
     /* 1477669 */   // Label 20684: @1477669
     /* 1477669 */   GIM_Try, /*On fail goto*//*Label 20685*/ GIMT_Encode4(1477766), // Rule ID 23900 //
     /* 1477674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1477685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1477688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1477691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477724 */     // MIs[1] Operand 1
     /* 1477724 */     // No operand predicates
     /* 1477724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477728 */     // MIs[0] policy
     /* 1477728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477765 */     // GIR_Coverage, 23900,
     /* 1477765 */     GIR_EraseRootFromParent_Done,
     /* 1477766 */   // Label 20685: @1477766
     /* 1477766 */   GIM_Try, /*On fail goto*//*Label 20686*/ GIMT_Encode4(1477863), // Rule ID 23901 //
     /* 1477771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1477782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1477785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1477788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477821 */     // MIs[1] Operand 1
     /* 1477821 */     // No operand predicates
     /* 1477821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477825 */     // MIs[0] policy
     /* 1477825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477837 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477862 */     // GIR_Coverage, 23901,
     /* 1477862 */     GIR_EraseRootFromParent_Done,
     /* 1477863 */   // Label 20686: @1477863
     /* 1477863 */   GIM_Try, /*On fail goto*//*Label 20687*/ GIMT_Encode4(1477960), // Rule ID 23904 //
     /* 1477868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1477879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1477882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1477885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477918 */     // MIs[1] Operand 1
     /* 1477918 */     // No operand predicates
     /* 1477918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477922 */     // MIs[0] policy
     /* 1477922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477934 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477959 */     // GIR_Coverage, 23904,
     /* 1477959 */     GIR_EraseRootFromParent_Done,
     /* 1477960 */   // Label 20687: @1477960
     /* 1477960 */   GIM_Try, /*On fail goto*//*Label 20688*/ GIMT_Encode4(1478057), // Rule ID 23905 //
     /* 1477965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1477976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1477979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1477982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478015 */     // MIs[1] Operand 1
     /* 1478015 */     // No operand predicates
     /* 1478015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478019 */     // MIs[0] policy
     /* 1478019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478031 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1478034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478056 */     // GIR_Coverage, 23905,
     /* 1478056 */     GIR_EraseRootFromParent_Done,
     /* 1478057 */   // Label 20688: @1478057
     /* 1478057 */   GIM_Try, /*On fail goto*//*Label 20689*/ GIMT_Encode4(1478154), // Rule ID 23908 //
     /* 1478062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1478073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1478076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1478079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478112 */     // MIs[1] Operand 1
     /* 1478112 */     // No operand predicates
     /* 1478112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478116 */     // MIs[0] policy
     /* 1478116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478128 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1478131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478153 */     // GIR_Coverage, 23908,
     /* 1478153 */     GIR_EraseRootFromParent_Done,
     /* 1478154 */   // Label 20689: @1478154
     /* 1478154 */   GIM_Try, /*On fail goto*//*Label 20690*/ GIMT_Encode4(1478251), // Rule ID 23909 //
     /* 1478159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1478170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1478173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1478176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478209 */     // MIs[1] Operand 1
     /* 1478209 */     // No operand predicates
     /* 1478209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478213 */     // MIs[0] policy
     /* 1478213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478225 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1478228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478250 */     // GIR_Coverage, 23909,
     /* 1478250 */     GIR_EraseRootFromParent_Done,
     /* 1478251 */   // Label 20690: @1478251
     /* 1478251 */   GIM_Try, /*On fail goto*//*Label 20691*/ GIMT_Encode4(1478348), // Rule ID 23912 //
     /* 1478256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1478267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1478270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1478273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1478279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478306 */     // MIs[1] Operand 1
     /* 1478306 */     // No operand predicates
     /* 1478306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478310 */     // MIs[0] policy
     /* 1478310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478322 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478347 */     // GIR_Coverage, 23912,
     /* 1478347 */     GIR_EraseRootFromParent_Done,
     /* 1478348 */   // Label 20691: @1478348
     /* 1478348 */   GIM_Try, /*On fail goto*//*Label 20692*/ GIMT_Encode4(1478445), // Rule ID 23913 //
     /* 1478353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1478364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1478367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1478370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1478376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478403 */     // MIs[1] Operand 1
     /* 1478403 */     // No operand predicates
     /* 1478403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478407 */     // MIs[0] policy
     /* 1478407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478419 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478444 */     // GIR_Coverage, 23913,
     /* 1478444 */     GIR_EraseRootFromParent_Done,
     /* 1478445 */   // Label 20692: @1478445
     /* 1478445 */   GIM_Try, /*On fail goto*//*Label 20693*/ GIMT_Encode4(1478542), // Rule ID 23916 //
     /* 1478450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1478461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1478464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1478467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1478473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478500 */     // MIs[1] Operand 1
     /* 1478500 */     // No operand predicates
     /* 1478500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478504 */     // MIs[0] policy
     /* 1478504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478516 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478541 */     // GIR_Coverage, 23916,
     /* 1478541 */     GIR_EraseRootFromParent_Done,
     /* 1478542 */   // Label 20693: @1478542
     /* 1478542 */   GIM_Try, /*On fail goto*//*Label 20694*/ GIMT_Encode4(1478639), // Rule ID 23917 //
     /* 1478547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1478558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1478561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1478564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1478570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478597 */     // MIs[1] Operand 1
     /* 1478597 */     // No operand predicates
     /* 1478597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478601 */     // MIs[0] policy
     /* 1478601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478613 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478638 */     // GIR_Coverage, 23917,
     /* 1478638 */     GIR_EraseRootFromParent_Done,
     /* 1478639 */   // Label 20694: @1478639
     /* 1478639 */   GIM_Try, /*On fail goto*//*Label 20695*/ GIMT_Encode4(1478736), // Rule ID 23920 //
     /* 1478644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1478655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1478658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1478661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478694 */     // MIs[1] Operand 1
     /* 1478694 */     // No operand predicates
     /* 1478694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478698 */     // MIs[0] policy
     /* 1478698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478735 */     // GIR_Coverage, 23920,
     /* 1478735 */     GIR_EraseRootFromParent_Done,
     /* 1478736 */   // Label 20695: @1478736
     /* 1478736 */   GIM_Try, /*On fail goto*//*Label 20696*/ GIMT_Encode4(1478833), // Rule ID 23921 //
     /* 1478741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1478752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1478755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1478758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478791 */     // MIs[1] Operand 1
     /* 1478791 */     // No operand predicates
     /* 1478791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478795 */     // MIs[0] policy
     /* 1478795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478807 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478832 */     // GIR_Coverage, 23921,
     /* 1478832 */     GIR_EraseRootFromParent_Done,
     /* 1478833 */   // Label 20696: @1478833
     /* 1478833 */   GIM_Try, /*On fail goto*//*Label 20697*/ GIMT_Encode4(1478930), // Rule ID 23924 //
     /* 1478838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1478841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1478849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1478852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1478855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478888 */     // MIs[1] Operand 1
     /* 1478888 */     // No operand predicates
     /* 1478888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478892 */     // MIs[0] policy
     /* 1478892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478904 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478929 */     // GIR_Coverage, 23924,
     /* 1478929 */     GIR_EraseRootFromParent_Done,
     /* 1478930 */   // Label 20697: @1478930
     /* 1478930 */   GIM_Try, /*On fail goto*//*Label 20698*/ GIMT_Encode4(1479027), // Rule ID 23925 //
     /* 1478935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1478938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1478946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1478949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1478952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478985 */     // MIs[1] Operand 1
     /* 1478985 */     // No operand predicates
     /* 1478985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478989 */     // MIs[0] policy
     /* 1478989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479001 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1479004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1479023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479026 */     // GIR_Coverage, 23925,
     /* 1479026 */     GIR_EraseRootFromParent_Done,
     /* 1479027 */   // Label 20698: @1479027
     /* 1479027 */   GIM_Try, /*On fail goto*//*Label 20699*/ GIMT_Encode4(1479124), // Rule ID 23928 //
     /* 1479032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1479043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1479046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1479049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479082 */     // MIs[1] Operand 1
     /* 1479082 */     // No operand predicates
     /* 1479082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479086 */     // MIs[0] policy
     /* 1479086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479098 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479123 */     // GIR_Coverage, 23928,
     /* 1479123 */     GIR_EraseRootFromParent_Done,
     /* 1479124 */   // Label 20699: @1479124
     /* 1479124 */   GIM_Try, /*On fail goto*//*Label 20700*/ GIMT_Encode4(1479221), // Rule ID 23929 //
     /* 1479129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1479140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1479143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1479146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479179 */     // MIs[1] Operand 1
     /* 1479179 */     // No operand predicates
     /* 1479179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479183 */     // MIs[0] policy
     /* 1479183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479195 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479220 */     // GIR_Coverage, 23929,
     /* 1479220 */     GIR_EraseRootFromParent_Done,
     /* 1479221 */   // Label 20700: @1479221
     /* 1479221 */   GIM_Try, /*On fail goto*//*Label 20701*/ GIMT_Encode4(1479318), // Rule ID 23932 //
     /* 1479226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1479237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1479240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1479243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1479249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479276 */     // MIs[1] Operand 1
     /* 1479276 */     // No operand predicates
     /* 1479276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479280 */     // MIs[0] policy
     /* 1479280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479292 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479317 */     // GIR_Coverage, 23932,
     /* 1479317 */     GIR_EraseRootFromParent_Done,
     /* 1479318 */   // Label 20701: @1479318
     /* 1479318 */   GIM_Try, /*On fail goto*//*Label 20702*/ GIMT_Encode4(1479415), // Rule ID 23933 //
     /* 1479323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1479334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1479337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1479340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1479346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479373 */     // MIs[1] Operand 1
     /* 1479373 */     // No operand predicates
     /* 1479373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479377 */     // MIs[0] policy
     /* 1479377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479389 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479414 */     // GIR_Coverage, 23933,
     /* 1479414 */     GIR_EraseRootFromParent_Done,
     /* 1479415 */   // Label 20702: @1479415
     /* 1479415 */   GIM_Try, /*On fail goto*//*Label 20703*/ GIMT_Encode4(1479512), // Rule ID 23936 //
     /* 1479420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1479431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1479434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1479437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1479443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479470 */     // MIs[1] Operand 1
     /* 1479470 */     // No operand predicates
     /* 1479470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479474 */     // MIs[0] policy
     /* 1479474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479486 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479511 */     // GIR_Coverage, 23936,
     /* 1479511 */     GIR_EraseRootFromParent_Done,
     /* 1479512 */   // Label 20703: @1479512
     /* 1479512 */   GIM_Try, /*On fail goto*//*Label 20704*/ GIMT_Encode4(1479609), // Rule ID 23937 //
     /* 1479517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1479528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1479531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1479534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1479540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479567 */     // MIs[1] Operand 1
     /* 1479567 */     // No operand predicates
     /* 1479567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479571 */     // MIs[0] policy
     /* 1479571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479583 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479608 */     // GIR_Coverage, 23937,
     /* 1479608 */     GIR_EraseRootFromParent_Done,
     /* 1479609 */   // Label 20704: @1479609
     /* 1479609 */   GIM_Try, /*On fail goto*//*Label 20705*/ GIMT_Encode4(1479706), // Rule ID 23940 //
     /* 1479614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1479625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1479628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1479631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479664 */     // MIs[1] Operand 1
     /* 1479664 */     // No operand predicates
     /* 1479664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479668 */     // MIs[0] policy
     /* 1479668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479680 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479705 */     // GIR_Coverage, 23940,
     /* 1479705 */     GIR_EraseRootFromParent_Done,
     /* 1479706 */   // Label 20705: @1479706
     /* 1479706 */   GIM_Try, /*On fail goto*//*Label 20706*/ GIMT_Encode4(1479803), // Rule ID 23941 //
     /* 1479711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1479722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1479725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1479728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479761 */     // MIs[1] Operand 1
     /* 1479761 */     // No operand predicates
     /* 1479761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479765 */     // MIs[0] policy
     /* 1479765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479777 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479802 */     // GIR_Coverage, 23941,
     /* 1479802 */     GIR_EraseRootFromParent_Done,
     /* 1479803 */   // Label 20706: @1479803
     /* 1479803 */   GIM_Try, /*On fail goto*//*Label 20707*/ GIMT_Encode4(1479900), // Rule ID 23944 //
     /* 1479808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1479819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1479822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1479825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479858 */     // MIs[1] Operand 1
     /* 1479858 */     // No operand predicates
     /* 1479858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479862 */     // MIs[0] policy
     /* 1479862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479899 */     // GIR_Coverage, 23944,
     /* 1479899 */     GIR_EraseRootFromParent_Done,
     /* 1479900 */   // Label 20707: @1479900
     /* 1479900 */   GIM_Try, /*On fail goto*//*Label 20708*/ GIMT_Encode4(1479997), // Rule ID 23945 //
     /* 1479905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1479916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1479919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1479922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479955 */     // MIs[1] Operand 1
     /* 1479955 */     // No operand predicates
     /* 1479955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479959 */     // MIs[0] policy
     /* 1479959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479971 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479996 */     // GIR_Coverage, 23945,
     /* 1479996 */     GIR_EraseRootFromParent_Done,
     /* 1479997 */   // Label 20708: @1479997
     /* 1479997 */   GIM_Try, /*On fail goto*//*Label 20709*/ GIMT_Encode4(1480094), // Rule ID 23948 //
     /* 1480002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1480013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1480016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1480019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1480025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480052 */     // MIs[1] Operand 1
     /* 1480052 */     // No operand predicates
     /* 1480052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480056 */     // MIs[0] policy
     /* 1480056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480093 */     // GIR_Coverage, 23948,
     /* 1480093 */     GIR_EraseRootFromParent_Done,
     /* 1480094 */   // Label 20709: @1480094
     /* 1480094 */   GIM_Try, /*On fail goto*//*Label 20710*/ GIMT_Encode4(1480191), // Rule ID 23949 //
     /* 1480099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1480110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1480113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1480116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1480122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480149 */     // MIs[1] Operand 1
     /* 1480149 */     // No operand predicates
     /* 1480149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480153 */     // MIs[0] policy
     /* 1480153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480165 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480190 */     // GIR_Coverage, 23949,
     /* 1480190 */     GIR_EraseRootFromParent_Done,
     /* 1480191 */   // Label 20710: @1480191
     /* 1480191 */   GIM_Try, /*On fail goto*//*Label 20711*/ GIMT_Encode4(1480288), // Rule ID 23952 //
     /* 1480196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1480207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1480210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1480213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480246 */     // MIs[1] Operand 1
     /* 1480246 */     // No operand predicates
     /* 1480246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480250 */     // MIs[0] policy
     /* 1480250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1480265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480287 */     // GIR_Coverage, 23952,
     /* 1480287 */     GIR_EraseRootFromParent_Done,
     /* 1480288 */   // Label 20711: @1480288
     /* 1480288 */   GIM_Try, /*On fail goto*//*Label 20712*/ GIMT_Encode4(1480385), // Rule ID 23953 //
     /* 1480293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1480304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1480307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1480310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480343 */     // MIs[1] Operand 1
     /* 1480343 */     // No operand predicates
     /* 1480343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480347 */     // MIs[0] policy
     /* 1480347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480359 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1480362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480384 */     // GIR_Coverage, 23953,
     /* 1480384 */     GIR_EraseRootFromParent_Done,
     /* 1480385 */   // Label 20712: @1480385
     /* 1480385 */   GIM_Try, /*On fail goto*//*Label 20713*/ GIMT_Encode4(1480482), // Rule ID 23956 //
     /* 1480390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1480401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1480404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1480407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480440 */     // MIs[1] Operand 1
     /* 1480440 */     // No operand predicates
     /* 1480440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480444 */     // MIs[0] policy
     /* 1480444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480456 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1480459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480481 */     // GIR_Coverage, 23956,
     /* 1480481 */     GIR_EraseRootFromParent_Done,
     /* 1480482 */   // Label 20713: @1480482
     /* 1480482 */   GIM_Try, /*On fail goto*//*Label 20714*/ GIMT_Encode4(1480579), // Rule ID 23957 //
     /* 1480487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1480498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1480501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1480504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480537 */     // MIs[1] Operand 1
     /* 1480537 */     // No operand predicates
     /* 1480537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480541 */     // MIs[0] policy
     /* 1480541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480553 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1480556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480578 */     // GIR_Coverage, 23957,
     /* 1480578 */     GIR_EraseRootFromParent_Done,
     /* 1480579 */   // Label 20714: @1480579
     /* 1480579 */   GIM_Try, /*On fail goto*//*Label 20715*/ GIMT_Encode4(1480676), // Rule ID 23960 //
     /* 1480584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1480595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1480598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1480601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480634 */     // MIs[1] Operand 1
     /* 1480634 */     // No operand predicates
     /* 1480634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480638 */     // MIs[0] policy
     /* 1480638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480650 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480675 */     // GIR_Coverage, 23960,
     /* 1480675 */     GIR_EraseRootFromParent_Done,
     /* 1480676 */   // Label 20715: @1480676
     /* 1480676 */   GIM_Try, /*On fail goto*//*Label 20716*/ GIMT_Encode4(1480773), // Rule ID 23961 //
     /* 1480681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1480692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1480695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1480698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480731 */     // MIs[1] Operand 1
     /* 1480731 */     // No operand predicates
     /* 1480731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480735 */     // MIs[0] policy
     /* 1480735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480747 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480772 */     // GIR_Coverage, 23961,
     /* 1480772 */     GIR_EraseRootFromParent_Done,
     /* 1480773 */   // Label 20716: @1480773
     /* 1480773 */   GIM_Try, /*On fail goto*//*Label 20717*/ GIMT_Encode4(1480870), // Rule ID 23964 //
     /* 1480778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1480781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1480789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1480792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1480795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480828 */     // MIs[1] Operand 1
     /* 1480828 */     // No operand predicates
     /* 1480828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480832 */     // MIs[0] policy
     /* 1480832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480844 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1480847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480869 */     // GIR_Coverage, 23964,
     /* 1480869 */     GIR_EraseRootFromParent_Done,
     /* 1480870 */   // Label 20717: @1480870
     /* 1480870 */   GIM_Try, /*On fail goto*//*Label 20718*/ GIMT_Encode4(1480967), // Rule ID 23965 //
     /* 1480875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1480878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1480886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1480889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1480892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480925 */     // MIs[1] Operand 1
     /* 1480925 */     // No operand predicates
     /* 1480925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480929 */     // MIs[0] policy
     /* 1480929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480941 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1480944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480966 */     // GIR_Coverage, 23965,
     /* 1480966 */     GIR_EraseRootFromParent_Done,
     /* 1480967 */   // Label 20718: @1480967
     /* 1480967 */   GIM_Try, /*On fail goto*//*Label 20719*/ GIMT_Encode4(1481064), // Rule ID 23968 //
     /* 1480972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1480975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1480983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1480986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1480989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1481002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481022 */     // MIs[1] Operand 1
     /* 1481022 */     // No operand predicates
     /* 1481022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481026 */     // MIs[0] policy
     /* 1481026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481038 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1481041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481063 */     // GIR_Coverage, 23968,
     /* 1481063 */     GIR_EraseRootFromParent_Done,
     /* 1481064 */   // Label 20719: @1481064
     /* 1481064 */   GIM_Try, /*On fail goto*//*Label 20720*/ GIMT_Encode4(1481161), // Rule ID 23969 //
     /* 1481069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1481072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1481080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1481083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1481086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1481099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481119 */     // MIs[1] Operand 1
     /* 1481119 */     // No operand predicates
     /* 1481119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481123 */     // MIs[0] policy
     /* 1481123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481135 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1481138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481160 */     // GIR_Coverage, 23969,
     /* 1481160 */     GIR_EraseRootFromParent_Done,
     /* 1481161 */   // Label 20720: @1481161
     /* 1481161 */   GIM_Try, /*On fail goto*//*Label 20721*/ GIMT_Encode4(1481258), // Rule ID 23972 //
     /* 1481166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1481169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1481177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1481180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1481183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1481196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481216 */     // MIs[1] Operand 1
     /* 1481216 */     // No operand predicates
     /* 1481216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481220 */     // MIs[0] policy
     /* 1481220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481232 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1481235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481257 */     // GIR_Coverage, 23972,
     /* 1481257 */     GIR_EraseRootFromParent_Done,
     /* 1481258 */   // Label 20721: @1481258
     /* 1481258 */   GIM_Try, /*On fail goto*//*Label 20722*/ GIMT_Encode4(1481355), // Rule ID 23973 //
     /* 1481263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1481266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1481274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1481277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1481280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1481293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481313 */     // MIs[1] Operand 1
     /* 1481313 */     // No operand predicates
     /* 1481313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481317 */     // MIs[0] policy
     /* 1481317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481329 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1481332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481354 */     // GIR_Coverage, 23973,
     /* 1481354 */     GIR_EraseRootFromParent_Done,
     /* 1481355 */   // Label 20722: @1481355
     /* 1481355 */   GIM_Try, /*On fail goto*//*Label 20723*/ GIMT_Encode4(1481452), // Rule ID 24212 //
     /* 1481360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1481371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1481374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1481377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481410 */     // MIs[1] Operand 1
     /* 1481410 */     // No operand predicates
     /* 1481410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481414 */     // MIs[0] policy
     /* 1481414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481426 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1481429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481451 */     // GIR_Coverage, 24212,
     /* 1481451 */     GIR_EraseRootFromParent_Done,
     /* 1481452 */   // Label 20723: @1481452
     /* 1481452 */   GIM_Try, /*On fail goto*//*Label 20724*/ GIMT_Encode4(1481549), // Rule ID 24213 //
     /* 1481457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1481468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1481471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1481474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481507 */     // MIs[1] Operand 1
     /* 1481507 */     // No operand predicates
     /* 1481507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481511 */     // MIs[0] policy
     /* 1481511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481523 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1481526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481548 */     // GIR_Coverage, 24213,
     /* 1481548 */     GIR_EraseRootFromParent_Done,
     /* 1481549 */   // Label 20724: @1481549
     /* 1481549 */   GIM_Try, /*On fail goto*//*Label 20725*/ GIMT_Encode4(1481646), // Rule ID 24216 //
     /* 1481554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481604 */     // MIs[1] Operand 1
     /* 1481604 */     // No operand predicates
     /* 1481604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481608 */     // MIs[0] policy
     /* 1481608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481620 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481645 */     // GIR_Coverage, 24216,
     /* 1481645 */     GIR_EraseRootFromParent_Done,
     /* 1481646 */   // Label 20725: @1481646
     /* 1481646 */   GIM_Try, /*On fail goto*//*Label 20726*/ GIMT_Encode4(1481743), // Rule ID 24217 //
     /* 1481651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481701 */     // MIs[1] Operand 1
     /* 1481701 */     // No operand predicates
     /* 1481701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481705 */     // MIs[0] policy
     /* 1481705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481717 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481742 */     // GIR_Coverage, 24217,
     /* 1481742 */     GIR_EraseRootFromParent_Done,
     /* 1481743 */   // Label 20726: @1481743
     /* 1481743 */   GIM_Try, /*On fail goto*//*Label 20727*/ GIMT_Encode4(1481840), // Rule ID 24220 //
     /* 1481748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481798 */     // MIs[1] Operand 1
     /* 1481798 */     // No operand predicates
     /* 1481798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481802 */     // MIs[0] policy
     /* 1481802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481814 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481839 */     // GIR_Coverage, 24220,
     /* 1481839 */     GIR_EraseRootFromParent_Done,
     /* 1481840 */   // Label 20727: @1481840
     /* 1481840 */   GIM_Try, /*On fail goto*//*Label 20728*/ GIMT_Encode4(1481937), // Rule ID 24221 //
     /* 1481845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481895 */     // MIs[1] Operand 1
     /* 1481895 */     // No operand predicates
     /* 1481895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481899 */     // MIs[0] policy
     /* 1481899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481911 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481936 */     // GIR_Coverage, 24221,
     /* 1481936 */     GIR_EraseRootFromParent_Done,
     /* 1481937 */   // Label 20728: @1481937
     /* 1481937 */   GIM_Try, /*On fail goto*//*Label 20729*/ GIMT_Encode4(1482034), // Rule ID 24224 //
     /* 1481942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1481953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1481956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1481959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481992 */     // MIs[1] Operand 1
     /* 1481992 */     // No operand predicates
     /* 1481992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481996 */     // MIs[0] policy
     /* 1481996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482008 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482033 */     // GIR_Coverage, 24224,
     /* 1482033 */     GIR_EraseRootFromParent_Done,
     /* 1482034 */   // Label 20729: @1482034
     /* 1482034 */   GIM_Try, /*On fail goto*//*Label 20730*/ GIMT_Encode4(1482131), // Rule ID 24225 //
     /* 1482039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1482050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1482053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1482056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1482062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482089 */     // MIs[1] Operand 1
     /* 1482089 */     // No operand predicates
     /* 1482089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482093 */     // MIs[0] policy
     /* 1482093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482105 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482130 */     // GIR_Coverage, 24225,
     /* 1482130 */     GIR_EraseRootFromParent_Done,
     /* 1482131 */   // Label 20730: @1482131
     /* 1482131 */   GIM_Try, /*On fail goto*//*Label 20731*/ GIMT_Encode4(1482228), // Rule ID 24228 //
     /* 1482136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1482147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1482150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1482153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1482159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482186 */     // MIs[1] Operand 1
     /* 1482186 */     // No operand predicates
     /* 1482186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482190 */     // MIs[0] policy
     /* 1482190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482202 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482227 */     // GIR_Coverage, 24228,
     /* 1482227 */     GIR_EraseRootFromParent_Done,
     /* 1482228 */   // Label 20731: @1482228
     /* 1482228 */   GIM_Try, /*On fail goto*//*Label 20732*/ GIMT_Encode4(1482325), // Rule ID 24229 //
     /* 1482233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1482244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1482247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1482250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1482256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482283 */     // MIs[1] Operand 1
     /* 1482283 */     // No operand predicates
     /* 1482283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482287 */     // MIs[0] policy
     /* 1482287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482299 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482324 */     // GIR_Coverage, 24229,
     /* 1482324 */     GIR_EraseRootFromParent_Done,
     /* 1482325 */   // Label 20732: @1482325
     /* 1482325 */   GIM_Try, /*On fail goto*//*Label 20733*/ GIMT_Encode4(1482422), // Rule ID 24232 //
     /* 1482330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1482333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1482341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1482344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1482347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1482353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482380 */     // MIs[1] Operand 1
     /* 1482380 */     // No operand predicates
     /* 1482380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482384 */     // MIs[0] policy
     /* 1482384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482396 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1482418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482421 */     // GIR_Coverage, 24232,
     /* 1482421 */     GIR_EraseRootFromParent_Done,
     /* 1482422 */   // Label 20733: @1482422
     /* 1482422 */   GIM_Try, /*On fail goto*//*Label 20734*/ GIMT_Encode4(1482519), // Rule ID 24233 //
     /* 1482427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1482430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1482438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1482441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1482444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1482450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482477 */     // MIs[1] Operand 1
     /* 1482477 */     // No operand predicates
     /* 1482477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482481 */     // MIs[0] policy
     /* 1482481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482493 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1482515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482518 */     // GIR_Coverage, 24233,
     /* 1482518 */     GIR_EraseRootFromParent_Done,
     /* 1482519 */   // Label 20734: @1482519
     /* 1482519 */   GIM_Try, /*On fail goto*//*Label 20735*/ GIMT_Encode4(1482616), // Rule ID 24236 //
     /* 1482524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1482541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482574 */     // MIs[1] Operand 1
     /* 1482574 */     // No operand predicates
     /* 1482574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482578 */     // MIs[0] policy
     /* 1482578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482590 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1482593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482615 */     // GIR_Coverage, 24236,
     /* 1482615 */     GIR_EraseRootFromParent_Done,
     /* 1482616 */   // Label 20735: @1482616
     /* 1482616 */   GIM_Try, /*On fail goto*//*Label 20736*/ GIMT_Encode4(1482713), // Rule ID 24237 //
     /* 1482621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1482638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482671 */     // MIs[1] Operand 1
     /* 1482671 */     // No operand predicates
     /* 1482671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482675 */     // MIs[0] policy
     /* 1482675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482687 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1482690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482712 */     // GIR_Coverage, 24237,
     /* 1482712 */     GIR_EraseRootFromParent_Done,
     /* 1482713 */   // Label 20736: @1482713
     /* 1482713 */   GIM_Try, /*On fail goto*//*Label 20737*/ GIMT_Encode4(1482810), // Rule ID 24240 //
     /* 1482718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1482729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1482732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1482735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482768 */     // MIs[1] Operand 1
     /* 1482768 */     // No operand predicates
     /* 1482768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482772 */     // MIs[0] policy
     /* 1482772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482784 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1482787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482809 */     // GIR_Coverage, 24240,
     /* 1482809 */     GIR_EraseRootFromParent_Done,
     /* 1482810 */   // Label 20737: @1482810
     /* 1482810 */   GIM_Try, /*On fail goto*//*Label 20738*/ GIMT_Encode4(1482907), // Rule ID 24241 //
     /* 1482815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1482826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1482829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1482832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482865 */     // MIs[1] Operand 1
     /* 1482865 */     // No operand predicates
     /* 1482865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482869 */     // MIs[0] policy
     /* 1482869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482881 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1482884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482906 */     // GIR_Coverage, 24241,
     /* 1482906 */     GIR_EraseRootFromParent_Done,
     /* 1482907 */   // Label 20738: @1482907
     /* 1482907 */   GIM_Try, /*On fail goto*//*Label 20739*/ GIMT_Encode4(1483004), // Rule ID 24244 //
     /* 1482912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1482923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1482926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1482929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1482935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482962 */     // MIs[1] Operand 1
     /* 1482962 */     // No operand predicates
     /* 1482962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482966 */     // MIs[0] policy
     /* 1482966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482978 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1482981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483003 */     // GIR_Coverage, 24244,
     /* 1483003 */     GIR_EraseRootFromParent_Done,
     /* 1483004 */   // Label 20739: @1483004
     /* 1483004 */   GIM_Try, /*On fail goto*//*Label 20740*/ GIMT_Encode4(1483101), // Rule ID 24245 //
     /* 1483009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1483020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1483023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1483026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1483032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483059 */     // MIs[1] Operand 1
     /* 1483059 */     // No operand predicates
     /* 1483059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483063 */     // MIs[0] policy
     /* 1483063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483075 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483100 */     // GIR_Coverage, 24245,
     /* 1483100 */     GIR_EraseRootFromParent_Done,
     /* 1483101 */   // Label 20740: @1483101
     /* 1483101 */   GIM_Try, /*On fail goto*//*Label 20741*/ GIMT_Encode4(1483198), // Rule ID 24248 //
     /* 1483106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1483117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1483120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1483123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483156 */     // MIs[1] Operand 1
     /* 1483156 */     // No operand predicates
     /* 1483156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483160 */     // MIs[0] policy
     /* 1483160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483172 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1483175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483197 */     // GIR_Coverage, 24248,
     /* 1483197 */     GIR_EraseRootFromParent_Done,
     /* 1483198 */   // Label 20741: @1483198
     /* 1483198 */   GIM_Try, /*On fail goto*//*Label 20742*/ GIMT_Encode4(1483295), // Rule ID 24249 //
     /* 1483203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1483214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1483217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1483220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483253 */     // MIs[1] Operand 1
     /* 1483253 */     // No operand predicates
     /* 1483253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483257 */     // MIs[0] policy
     /* 1483257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483269 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1483272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483294 */     // GIR_Coverage, 24249,
     /* 1483294 */     GIR_EraseRootFromParent_Done,
     /* 1483295 */   // Label 20742: @1483295
     /* 1483295 */   GIM_Try, /*On fail goto*//*Label 20743*/ GIMT_Encode4(1483392), // Rule ID 24252 //
     /* 1483300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1483311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1483314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1483317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483350 */     // MIs[1] Operand 1
     /* 1483350 */     // No operand predicates
     /* 1483350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483354 */     // MIs[0] policy
     /* 1483354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483366 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1483369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483391 */     // GIR_Coverage, 24252,
     /* 1483391 */     GIR_EraseRootFromParent_Done,
     /* 1483392 */   // Label 20743: @1483392
     /* 1483392 */   GIM_Try, /*On fail goto*//*Label 20744*/ GIMT_Encode4(1483489), // Rule ID 24253 //
     /* 1483397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1483408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1483411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1483414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483447 */     // MIs[1] Operand 1
     /* 1483447 */     // No operand predicates
     /* 1483447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483451 */     // MIs[0] policy
     /* 1483451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483463 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1483466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483488 */     // GIR_Coverage, 24253,
     /* 1483488 */     GIR_EraseRootFromParent_Done,
     /* 1483489 */   // Label 20744: @1483489
     /* 1483489 */   GIM_Try, /*On fail goto*//*Label 20745*/ GIMT_Encode4(1483586), // Rule ID 24256 //
     /* 1483494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483544 */     // MIs[1] Operand 1
     /* 1483544 */     // No operand predicates
     /* 1483544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483548 */     // MIs[0] policy
     /* 1483548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483560 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483585 */     // GIR_Coverage, 24256,
     /* 1483585 */     GIR_EraseRootFromParent_Done,
     /* 1483586 */   // Label 20745: @1483586
     /* 1483586 */   GIM_Try, /*On fail goto*//*Label 20746*/ GIMT_Encode4(1483683), // Rule ID 24257 //
     /* 1483591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483641 */     // MIs[1] Operand 1
     /* 1483641 */     // No operand predicates
     /* 1483641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483645 */     // MIs[0] policy
     /* 1483645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483657 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483682 */     // GIR_Coverage, 24257,
     /* 1483682 */     GIR_EraseRootFromParent_Done,
     /* 1483683 */   // Label 20746: @1483683
     /* 1483683 */   GIM_Try, /*On fail goto*//*Label 20747*/ GIMT_Encode4(1483780), // Rule ID 24260 //
     /* 1483688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1483691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1483705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483738 */     // MIs[1] Operand 1
     /* 1483738 */     // No operand predicates
     /* 1483738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483742 */     // MIs[0] policy
     /* 1483742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483754 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1483757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483779 */     // GIR_Coverage, 24260,
     /* 1483779 */     GIR_EraseRootFromParent_Done,
     /* 1483780 */   // Label 20747: @1483780
     /* 1483780 */   GIM_Try, /*On fail goto*//*Label 20748*/ GIMT_Encode4(1483877), // Rule ID 24261 //
     /* 1483785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1483788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1483802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483835 */     // MIs[1] Operand 1
     /* 1483835 */     // No operand predicates
     /* 1483835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483839 */     // MIs[0] policy
     /* 1483839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483851 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1483854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483876 */     // GIR_Coverage, 24261,
     /* 1483876 */     GIR_EraseRootFromParent_Done,
     /* 1483877 */   // Label 20748: @1483877
     /* 1483877 */   GIM_Try, /*On fail goto*//*Label 20749*/ GIMT_Encode4(1483974), // Rule ID 24264 //
     /* 1483882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1483885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1483893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1483896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1483899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483932 */     // MIs[1] Operand 1
     /* 1483932 */     // No operand predicates
     /* 1483932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483936 */     // MIs[0] policy
     /* 1483936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483948 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1483951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483973 */     // GIR_Coverage, 24264,
     /* 1483973 */     GIR_EraseRootFromParent_Done,
     /* 1483974 */   // Label 20749: @1483974
     /* 1483974 */   GIM_Try, /*On fail goto*//*Label 20750*/ GIMT_Encode4(1484071), // Rule ID 24265 //
     /* 1483979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1483982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1483990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1483993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1483996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1484009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484029 */     // MIs[1] Operand 1
     /* 1484029 */     // No operand predicates
     /* 1484029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484033 */     // MIs[0] policy
     /* 1484033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484045 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1484048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484070 */     // GIR_Coverage, 24265,
     /* 1484070 */     GIR_EraseRootFromParent_Done,
     /* 1484071 */   // Label 20750: @1484071
     /* 1484071 */   GIM_Try, /*On fail goto*//*Label 20751*/ GIMT_Encode4(1484168), // Rule ID 24268 //
     /* 1484076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1484079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1484084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1484087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1484090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1484093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484126 */     // MIs[1] Operand 1
     /* 1484126 */     // No operand predicates
     /* 1484126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484130 */     // MIs[0] policy
     /* 1484130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484142 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1484145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484167 */     // GIR_Coverage, 24268,
     /* 1484167 */     GIR_EraseRootFromParent_Done,
     /* 1484168 */   // Label 20751: @1484168
     /* 1484168 */   GIM_Try, /*On fail goto*//*Label 20752*/ GIMT_Encode4(1484265), // Rule ID 24269 //
     /* 1484173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1484176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1484181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1484184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1484187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1484190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484223 */     // MIs[1] Operand 1
     /* 1484223 */     // No operand predicates
     /* 1484223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484227 */     // MIs[0] policy
     /* 1484227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484239 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1484242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484264 */     // GIR_Coverage, 24269,
     /* 1484264 */     GIR_EraseRootFromParent_Done,
     /* 1484265 */   // Label 20752: @1484265
     /* 1484265 */   GIM_Try, /*On fail goto*//*Label 20753*/ GIMT_Encode4(1484362), // Rule ID 24332 //
     /* 1484270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1484281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1484284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1484287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484320 */     // MIs[1] Operand 1
     /* 1484320 */     // No operand predicates
     /* 1484320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484324 */     // MIs[0] policy
     /* 1484324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484336 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1484339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484361 */     // GIR_Coverage, 24332,
     /* 1484361 */     GIR_EraseRootFromParent_Done,
     /* 1484362 */   // Label 20753: @1484362
     /* 1484362 */   GIM_Try, /*On fail goto*//*Label 20754*/ GIMT_Encode4(1484459), // Rule ID 24333 //
     /* 1484367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1484378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1484381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1484384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484417 */     // MIs[1] Operand 1
     /* 1484417 */     // No operand predicates
     /* 1484417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484421 */     // MIs[0] policy
     /* 1484421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484433 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1484436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484458 */     // GIR_Coverage, 24333,
     /* 1484458 */     GIR_EraseRootFromParent_Done,
     /* 1484459 */   // Label 20754: @1484459
     /* 1484459 */   GIM_Try, /*On fail goto*//*Label 20755*/ GIMT_Encode4(1484556), // Rule ID 24336 //
     /* 1484464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1484475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1484478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1484481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484514 */     // MIs[1] Operand 1
     /* 1484514 */     // No operand predicates
     /* 1484514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484518 */     // MIs[0] policy
     /* 1484518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484530 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484555 */     // GIR_Coverage, 24336,
     /* 1484555 */     GIR_EraseRootFromParent_Done,
     /* 1484556 */   // Label 20755: @1484556
     /* 1484556 */   GIM_Try, /*On fail goto*//*Label 20756*/ GIMT_Encode4(1484653), // Rule ID 24337 //
     /* 1484561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1484572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1484575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1484578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484611 */     // MIs[1] Operand 1
     /* 1484611 */     // No operand predicates
     /* 1484611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484615 */     // MIs[0] policy
     /* 1484615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484627 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484652 */     // GIR_Coverage, 24337,
     /* 1484652 */     GIR_EraseRootFromParent_Done,
     /* 1484653 */   // Label 20756: @1484653
     /* 1484653 */   GIM_Try, /*On fail goto*//*Label 20757*/ GIMT_Encode4(1484750), // Rule ID 24340 //
     /* 1484658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1484669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1484672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1484675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484708 */     // MIs[1] Operand 1
     /* 1484708 */     // No operand predicates
     /* 1484708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484712 */     // MIs[0] policy
     /* 1484712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484724 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484749 */     // GIR_Coverage, 24340,
     /* 1484749 */     GIR_EraseRootFromParent_Done,
     /* 1484750 */   // Label 20757: @1484750
     /* 1484750 */   GIM_Try, /*On fail goto*//*Label 20758*/ GIMT_Encode4(1484847), // Rule ID 24341 //
     /* 1484755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1484766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1484769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1484772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484805 */     // MIs[1] Operand 1
     /* 1484805 */     // No operand predicates
     /* 1484805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484809 */     // MIs[0] policy
     /* 1484809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484821 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484846 */     // GIR_Coverage, 24341,
     /* 1484846 */     GIR_EraseRootFromParent_Done,
     /* 1484847 */   // Label 20758: @1484847
     /* 1484847 */   GIM_Try, /*On fail goto*//*Label 20759*/ GIMT_Encode4(1484944), // Rule ID 24344 //
     /* 1484852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1484863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1484866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1484869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484902 */     // MIs[1] Operand 1
     /* 1484902 */     // No operand predicates
     /* 1484902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484906 */     // MIs[0] policy
     /* 1484906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484918 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484943 */     // GIR_Coverage, 24344,
     /* 1484943 */     GIR_EraseRootFromParent_Done,
     /* 1484944 */   // Label 20759: @1484944
     /* 1484944 */   GIM_Try, /*On fail goto*//*Label 20760*/ GIMT_Encode4(1485041), // Rule ID 24345 //
     /* 1484949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1484960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1484963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1484966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484999 */     // MIs[1] Operand 1
     /* 1484999 */     // No operand predicates
     /* 1484999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485003 */     // MIs[0] policy
     /* 1485003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485015 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1485018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485040 */     // GIR_Coverage, 24345,
     /* 1485040 */     GIR_EraseRootFromParent_Done,
     /* 1485041 */   // Label 20760: @1485041
     /* 1485041 */   GIM_Try, /*On fail goto*//*Label 20761*/ GIMT_Encode4(1485138), // Rule ID 24348 //
     /* 1485046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1485057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1485060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1485063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485096 */     // MIs[1] Operand 1
     /* 1485096 */     // No operand predicates
     /* 1485096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485100 */     // MIs[0] policy
     /* 1485100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485112 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1485115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485137 */     // GIR_Coverage, 24348,
     /* 1485137 */     GIR_EraseRootFromParent_Done,
     /* 1485138 */   // Label 20761: @1485138
     /* 1485138 */   GIM_Try, /*On fail goto*//*Label 20762*/ GIMT_Encode4(1485235), // Rule ID 24349 //
     /* 1485143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1485154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1485157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1485160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485193 */     // MIs[1] Operand 1
     /* 1485193 */     // No operand predicates
     /* 1485193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485197 */     // MIs[0] policy
     /* 1485197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485209 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1485212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485234 */     // GIR_Coverage, 24349,
     /* 1485234 */     GIR_EraseRootFromParent_Done,
     /* 1485235 */   // Label 20762: @1485235
     /* 1485235 */   GIM_Try, /*On fail goto*//*Label 20763*/ GIMT_Encode4(1485332), // Rule ID 24352 //
     /* 1485240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1485243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1485251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1485254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1485257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485286 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485290 */     // MIs[1] Operand 1
     /* 1485290 */     // No operand predicates
     /* 1485290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485294 */     // MIs[0] policy
     /* 1485294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485306 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1485309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1485328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485331 */     // GIR_Coverage, 24352,
     /* 1485331 */     GIR_EraseRootFromParent_Done,
     /* 1485332 */   // Label 20763: @1485332
     /* 1485332 */   GIM_Try, /*On fail goto*//*Label 20764*/ GIMT_Encode4(1485429), // Rule ID 24353 //
     /* 1485337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1485340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1485348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1485351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1485354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485387 */     // MIs[1] Operand 1
     /* 1485387 */     // No operand predicates
     /* 1485387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485391 */     // MIs[0] policy
     /* 1485391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485403 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1485406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1485425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485428 */     // GIR_Coverage, 24353,
     /* 1485428 */     GIR_EraseRootFromParent_Done,
     /* 1485429 */   // Label 20764: @1485429
     /* 1485429 */   GIM_Try, /*On fail goto*//*Label 20765*/ GIMT_Encode4(1485526), // Rule ID 24356 //
     /* 1485434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1485445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1485448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1485451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485484 */     // MIs[1] Operand 1
     /* 1485484 */     // No operand predicates
     /* 1485484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485488 */     // MIs[0] policy
     /* 1485488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485500 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1485503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485525 */     // GIR_Coverage, 24356,
     /* 1485525 */     GIR_EraseRootFromParent_Done,
     /* 1485526 */   // Label 20765: @1485526
     /* 1485526 */   GIM_Try, /*On fail goto*//*Label 20766*/ GIMT_Encode4(1485623), // Rule ID 24357 //
     /* 1485531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1485542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1485545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1485548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485581 */     // MIs[1] Operand 1
     /* 1485581 */     // No operand predicates
     /* 1485581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485585 */     // MIs[0] policy
     /* 1485585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485597 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1485600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485622 */     // GIR_Coverage, 24357,
     /* 1485622 */     GIR_EraseRootFromParent_Done,
     /* 1485623 */   // Label 20766: @1485623
     /* 1485623 */   GIM_Try, /*On fail goto*//*Label 20767*/ GIMT_Encode4(1485720), // Rule ID 24360 //
     /* 1485628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1485639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1485642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1485645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485678 */     // MIs[1] Operand 1
     /* 1485678 */     // No operand predicates
     /* 1485678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485682 */     // MIs[0] policy
     /* 1485682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485694 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1485697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485719 */     // GIR_Coverage, 24360,
     /* 1485719 */     GIR_EraseRootFromParent_Done,
     /* 1485720 */   // Label 20767: @1485720
     /* 1485720 */   GIM_Try, /*On fail goto*//*Label 20768*/ GIMT_Encode4(1485817), // Rule ID 24361 //
     /* 1485725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1485736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1485739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1485742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485775 */     // MIs[1] Operand 1
     /* 1485775 */     // No operand predicates
     /* 1485775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485779 */     // MIs[0] policy
     /* 1485779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485791 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1485794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485816 */     // GIR_Coverage, 24361,
     /* 1485816 */     GIR_EraseRootFromParent_Done,
     /* 1485817 */   // Label 20768: @1485817
     /* 1485817 */   GIM_Try, /*On fail goto*//*Label 20769*/ GIMT_Encode4(1485914), // Rule ID 24364 //
     /* 1485822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1485833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1485836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1485839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1485845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485872 */     // MIs[1] Operand 1
     /* 1485872 */     // No operand predicates
     /* 1485872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485876 */     // MIs[0] policy
     /* 1485876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485888 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1485891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485913 */     // GIR_Coverage, 24364,
     /* 1485913 */     GIR_EraseRootFromParent_Done,
     /* 1485914 */   // Label 20769: @1485914
     /* 1485914 */   GIM_Try, /*On fail goto*//*Label 20770*/ GIMT_Encode4(1486011), // Rule ID 24365 //
     /* 1485919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1485930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1485933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1485936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1485942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485969 */     // MIs[1] Operand 1
     /* 1485969 */     // No operand predicates
     /* 1485969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485973 */     // MIs[0] policy
     /* 1485973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485985 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1485988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486010 */     // GIR_Coverage, 24365,
     /* 1486010 */     GIR_EraseRootFromParent_Done,
     /* 1486011 */   // Label 20770: @1486011
     /* 1486011 */   GIM_Try, /*On fail goto*//*Label 20771*/ GIMT_Encode4(1486108), // Rule ID 24368 //
     /* 1486016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1486027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1486030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1486033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486066 */     // MIs[1] Operand 1
     /* 1486066 */     // No operand predicates
     /* 1486066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486070 */     // MIs[0] policy
     /* 1486070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486082 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1486085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486107 */     // GIR_Coverage, 24368,
     /* 1486107 */     GIR_EraseRootFromParent_Done,
     /* 1486108 */   // Label 20771: @1486108
     /* 1486108 */   GIM_Try, /*On fail goto*//*Label 20772*/ GIMT_Encode4(1486205), // Rule ID 24369 //
     /* 1486113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1486124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1486127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1486130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486163 */     // MIs[1] Operand 1
     /* 1486163 */     // No operand predicates
     /* 1486163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486167 */     // MIs[0] policy
     /* 1486167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486179 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1486182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486204 */     // GIR_Coverage, 24369,
     /* 1486204 */     GIR_EraseRootFromParent_Done,
     /* 1486205 */   // Label 20772: @1486205
     /* 1486205 */   GIM_Try, /*On fail goto*//*Label 20773*/ GIMT_Encode4(1486302), // Rule ID 24372 //
     /* 1486210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1486221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1486224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1486227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486260 */     // MIs[1] Operand 1
     /* 1486260 */     // No operand predicates
     /* 1486260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486264 */     // MIs[0] policy
     /* 1486264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486276 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1486279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486301 */     // GIR_Coverage, 24372,
     /* 1486301 */     GIR_EraseRootFromParent_Done,
     /* 1486302 */   // Label 20773: @1486302
     /* 1486302 */   GIM_Try, /*On fail goto*//*Label 20774*/ GIMT_Encode4(1486399), // Rule ID 24373 //
     /* 1486307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1486318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1486321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1486324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486357 */     // MIs[1] Operand 1
     /* 1486357 */     // No operand predicates
     /* 1486357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486361 */     // MIs[0] policy
     /* 1486361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486373 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1486376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486398 */     // GIR_Coverage, 24373,
     /* 1486398 */     GIR_EraseRootFromParent_Done,
     /* 1486399 */   // Label 20774: @1486399
     /* 1486399 */   GIM_Try, /*On fail goto*//*Label 20775*/ GIMT_Encode4(1486496), // Rule ID 24376 //
     /* 1486404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1486415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1486418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1486421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486454 */     // MIs[1] Operand 1
     /* 1486454 */     // No operand predicates
     /* 1486454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486458 */     // MIs[0] policy
     /* 1486458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486470 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1486473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486495 */     // GIR_Coverage, 24376,
     /* 1486495 */     GIR_EraseRootFromParent_Done,
     /* 1486496 */   // Label 20775: @1486496
     /* 1486496 */   GIM_Try, /*On fail goto*//*Label 20776*/ GIMT_Encode4(1486593), // Rule ID 24377 //
     /* 1486501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1486512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1486515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1486518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486551 */     // MIs[1] Operand 1
     /* 1486551 */     // No operand predicates
     /* 1486551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486555 */     // MIs[0] policy
     /* 1486555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486567 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1486570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486592 */     // GIR_Coverage, 24377,
     /* 1486592 */     GIR_EraseRootFromParent_Done,
     /* 1486593 */   // Label 20776: @1486593
     /* 1486593 */   GIM_Try, /*On fail goto*//*Label 20777*/ GIMT_Encode4(1486690), // Rule ID 24380 //
     /* 1486598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1486601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1486609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1486612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1486615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486648 */     // MIs[1] Operand 1
     /* 1486648 */     // No operand predicates
     /* 1486648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486652 */     // MIs[0] policy
     /* 1486652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486664 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1486667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486689 */     // GIR_Coverage, 24380,
     /* 1486689 */     GIR_EraseRootFromParent_Done,
     /* 1486690 */   // Label 20777: @1486690
     /* 1486690 */   GIM_Try, /*On fail goto*//*Label 20778*/ GIMT_Encode4(1486787), // Rule ID 24381 //
     /* 1486695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1486698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1486706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1486709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1486712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486745 */     // MIs[1] Operand 1
     /* 1486745 */     // No operand predicates
     /* 1486745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486749 */     // MIs[0] policy
     /* 1486749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486761 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1486764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486786 */     // GIR_Coverage, 24381,
     /* 1486786 */     GIR_EraseRootFromParent_Done,
     /* 1486787 */   // Label 20778: @1486787
     /* 1486787 */   GIM_Try, /*On fail goto*//*Label 20779*/ GIMT_Encode4(1486884), // Rule ID 24384 //
     /* 1486792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1486795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1486803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1486806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1486809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486842 */     // MIs[1] Operand 1
     /* 1486842 */     // No operand predicates
     /* 1486842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486846 */     // MIs[0] policy
     /* 1486846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486858 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1486861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486883 */     // GIR_Coverage, 24384,
     /* 1486883 */     GIR_EraseRootFromParent_Done,
     /* 1486884 */   // Label 20779: @1486884
     /* 1486884 */   GIM_Try, /*On fail goto*//*Label 20780*/ GIMT_Encode4(1486981), // Rule ID 24385 //
     /* 1486889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1486892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1486900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1486903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1486906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486939 */     // MIs[1] Operand 1
     /* 1486939 */     // No operand predicates
     /* 1486939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486943 */     // MIs[0] policy
     /* 1486943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486955 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1486958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486980 */     // GIR_Coverage, 24385,
     /* 1486980 */     GIR_EraseRootFromParent_Done,
     /* 1486981 */   // Label 20780: @1486981
     /* 1486981 */   GIM_Try, /*On fail goto*//*Label 20781*/ GIMT_Encode4(1487078), // Rule ID 24388 //
     /* 1486986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1486989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1486997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1487000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1487003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487036 */     // MIs[1] Operand 1
     /* 1487036 */     // No operand predicates
     /* 1487036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487040 */     // MIs[0] policy
     /* 1487040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487052 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1487055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1487074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487077 */     // GIR_Coverage, 24388,
     /* 1487077 */     GIR_EraseRootFromParent_Done,
     /* 1487078 */   // Label 20781: @1487078
     /* 1487078 */   GIM_Try, /*On fail goto*//*Label 20782*/ GIMT_Encode4(1487175), // Rule ID 24389 //
     /* 1487083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1487086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1487091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1487094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1487097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1487100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487133 */     // MIs[1] Operand 1
     /* 1487133 */     // No operand predicates
     /* 1487133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487137 */     // MIs[0] policy
     /* 1487137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487149 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1487152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1487171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487174 */     // GIR_Coverage, 24389,
     /* 1487174 */     GIR_EraseRootFromParent_Done,
     /* 1487175 */   // Label 20782: @1487175
     /* 1487175 */   GIM_Try, /*On fail goto*//*Label 20783*/ GIMT_Encode4(1487272), // Rule ID 24688 //
     /* 1487180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1487191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1487194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1487197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487230 */     // MIs[1] Operand 1
     /* 1487230 */     // No operand predicates
     /* 1487230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487234 */     // MIs[0] policy
     /* 1487234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487246 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1487249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487271 */     // GIR_Coverage, 24688,
     /* 1487271 */     GIR_EraseRootFromParent_Done,
     /* 1487272 */   // Label 20783: @1487272
     /* 1487272 */   GIM_Try, /*On fail goto*//*Label 20784*/ GIMT_Encode4(1487369), // Rule ID 24689 //
     /* 1487277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1487288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1487291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1487294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487327 */     // MIs[1] Operand 1
     /* 1487327 */     // No operand predicates
     /* 1487327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487331 */     // MIs[0] policy
     /* 1487331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487343 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1487346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487368 */     // GIR_Coverage, 24689,
     /* 1487368 */     GIR_EraseRootFromParent_Done,
     /* 1487369 */   // Label 20784: @1487369
     /* 1487369 */   GIM_Try, /*On fail goto*//*Label 20785*/ GIMT_Encode4(1487466), // Rule ID 24692 //
     /* 1487374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1487385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1487388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1487391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487424 */     // MIs[1] Operand 1
     /* 1487424 */     // No operand predicates
     /* 1487424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487428 */     // MIs[0] policy
     /* 1487428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487440 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487465 */     // GIR_Coverage, 24692,
     /* 1487465 */     GIR_EraseRootFromParent_Done,
     /* 1487466 */   // Label 20785: @1487466
     /* 1487466 */   GIM_Try, /*On fail goto*//*Label 20786*/ GIMT_Encode4(1487563), // Rule ID 24693 //
     /* 1487471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1487482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1487485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1487488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487521 */     // MIs[1] Operand 1
     /* 1487521 */     // No operand predicates
     /* 1487521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487525 */     // MIs[0] policy
     /* 1487525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487537 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487562 */     // GIR_Coverage, 24693,
     /* 1487562 */     GIR_EraseRootFromParent_Done,
     /* 1487563 */   // Label 20786: @1487563
     /* 1487563 */   GIM_Try, /*On fail goto*//*Label 20787*/ GIMT_Encode4(1487660), // Rule ID 24696 //
     /* 1487568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1487579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1487582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1487585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487618 */     // MIs[1] Operand 1
     /* 1487618 */     // No operand predicates
     /* 1487618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487622 */     // MIs[0] policy
     /* 1487622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487634 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487659 */     // GIR_Coverage, 24696,
     /* 1487659 */     GIR_EraseRootFromParent_Done,
     /* 1487660 */   // Label 20787: @1487660
     /* 1487660 */   GIM_Try, /*On fail goto*//*Label 20788*/ GIMT_Encode4(1487757), // Rule ID 24697 //
     /* 1487665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1487676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1487679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1487682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487715 */     // MIs[1] Operand 1
     /* 1487715 */     // No operand predicates
     /* 1487715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487719 */     // MIs[0] policy
     /* 1487719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487731 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487756 */     // GIR_Coverage, 24697,
     /* 1487756 */     GIR_EraseRootFromParent_Done,
     /* 1487757 */   // Label 20788: @1487757
     /* 1487757 */   GIM_Try, /*On fail goto*//*Label 20789*/ GIMT_Encode4(1487854), // Rule ID 24700 //
     /* 1487762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1487773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1487776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1487779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487812 */     // MIs[1] Operand 1
     /* 1487812 */     // No operand predicates
     /* 1487812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487816 */     // MIs[0] policy
     /* 1487816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487828 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487853 */     // GIR_Coverage, 24700,
     /* 1487853 */     GIR_EraseRootFromParent_Done,
     /* 1487854 */   // Label 20789: @1487854
     /* 1487854 */   GIM_Try, /*On fail goto*//*Label 20790*/ GIMT_Encode4(1487951), // Rule ID 24701 //
     /* 1487859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1487870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1487873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1487876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487909 */     // MIs[1] Operand 1
     /* 1487909 */     // No operand predicates
     /* 1487909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487913 */     // MIs[0] policy
     /* 1487913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487925 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487950 */     // GIR_Coverage, 24701,
     /* 1487950 */     GIR_EraseRootFromParent_Done,
     /* 1487951 */   // Label 20790: @1487951
     /* 1487951 */   GIM_Try, /*On fail goto*//*Label 20791*/ GIMT_Encode4(1488048), // Rule ID 24704 //
     /* 1487956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1487967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1487970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1487973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488006 */     // MIs[1] Operand 1
     /* 1488006 */     // No operand predicates
     /* 1488006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488010 */     // MIs[0] policy
     /* 1488010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488022 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1488025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488047 */     // GIR_Coverage, 24704,
     /* 1488047 */     GIR_EraseRootFromParent_Done,
     /* 1488048 */   // Label 20791: @1488048
     /* 1488048 */   GIM_Try, /*On fail goto*//*Label 20792*/ GIMT_Encode4(1488145), // Rule ID 24705 //
     /* 1488053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1488064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1488067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1488070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488103 */     // MIs[1] Operand 1
     /* 1488103 */     // No operand predicates
     /* 1488103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488107 */     // MIs[0] policy
     /* 1488107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488119 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1488122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488144 */     // GIR_Coverage, 24705,
     /* 1488144 */     GIR_EraseRootFromParent_Done,
     /* 1488145 */   // Label 20792: @1488145
     /* 1488145 */   GIM_Try, /*On fail goto*//*Label 20793*/ GIMT_Encode4(1488242), // Rule ID 24708 //
     /* 1488150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1488161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1488164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1488167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488200 */     // MIs[1] Operand 1
     /* 1488200 */     // No operand predicates
     /* 1488200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488204 */     // MIs[0] policy
     /* 1488204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488216 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1488219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488241 */     // GIR_Coverage, 24708,
     /* 1488241 */     GIR_EraseRootFromParent_Done,
     /* 1488242 */   // Label 20793: @1488242
     /* 1488242 */   GIM_Try, /*On fail goto*//*Label 20794*/ GIMT_Encode4(1488339), // Rule ID 24709 //
     /* 1488247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1488258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1488261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1488264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488297 */     // MIs[1] Operand 1
     /* 1488297 */     // No operand predicates
     /* 1488297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488301 */     // MIs[0] policy
     /* 1488301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488313 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1488316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488338 */     // GIR_Coverage, 24709,
     /* 1488338 */     GIR_EraseRootFromParent_Done,
     /* 1488339 */   // Label 20794: @1488339
     /* 1488339 */   GIM_Try, /*On fail goto*//*Label 20795*/ GIMT_Encode4(1488436), // Rule ID 24712 //
     /* 1488344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1488355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1488358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1488361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1488367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488394 */     // MIs[1] Operand 1
     /* 1488394 */     // No operand predicates
     /* 1488394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488398 */     // MIs[0] policy
     /* 1488398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488410 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488435 */     // GIR_Coverage, 24712,
     /* 1488435 */     GIR_EraseRootFromParent_Done,
     /* 1488436 */   // Label 20795: @1488436
     /* 1488436 */   GIM_Try, /*On fail goto*//*Label 20796*/ GIMT_Encode4(1488533), // Rule ID 24713 //
     /* 1488441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1488452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1488455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1488458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1488464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488491 */     // MIs[1] Operand 1
     /* 1488491 */     // No operand predicates
     /* 1488491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488495 */     // MIs[0] policy
     /* 1488495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488507 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488532 */     // GIR_Coverage, 24713,
     /* 1488532 */     GIR_EraseRootFromParent_Done,
     /* 1488533 */   // Label 20796: @1488533
     /* 1488533 */   GIM_Try, /*On fail goto*//*Label 20797*/ GIMT_Encode4(1488630), // Rule ID 24716 //
     /* 1488538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1488549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1488552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1488555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488588 */     // MIs[1] Operand 1
     /* 1488588 */     // No operand predicates
     /* 1488588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488592 */     // MIs[0] policy
     /* 1488592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488604 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488629 */     // GIR_Coverage, 24716,
     /* 1488629 */     GIR_EraseRootFromParent_Done,
     /* 1488630 */   // Label 20797: @1488630
     /* 1488630 */   GIM_Try, /*On fail goto*//*Label 20798*/ GIMT_Encode4(1488727), // Rule ID 24717 //
     /* 1488635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1488646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1488649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1488652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488685 */     // MIs[1] Operand 1
     /* 1488685 */     // No operand predicates
     /* 1488685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488689 */     // MIs[0] policy
     /* 1488689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488701 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488726 */     // GIR_Coverage, 24717,
     /* 1488726 */     GIR_EraseRootFromParent_Done,
     /* 1488727 */   // Label 20798: @1488727
     /* 1488727 */   GIM_Try, /*On fail goto*//*Label 20799*/ GIMT_Encode4(1488824), // Rule ID 24720 //
     /* 1488732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1488749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488782 */     // MIs[1] Operand 1
     /* 1488782 */     // No operand predicates
     /* 1488782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488786 */     // MIs[0] policy
     /* 1488786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488798 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488823 */     // GIR_Coverage, 24720,
     /* 1488823 */     GIR_EraseRootFromParent_Done,
     /* 1488824 */   // Label 20799: @1488824
     /* 1488824 */   GIM_Try, /*On fail goto*//*Label 20800*/ GIMT_Encode4(1488921), // Rule ID 24721 //
     /* 1488829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1488846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488879 */     // MIs[1] Operand 1
     /* 1488879 */     // No operand predicates
     /* 1488879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488883 */     // MIs[0] policy
     /* 1488883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488895 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488920 */     // GIR_Coverage, 24721,
     /* 1488920 */     GIR_EraseRootFromParent_Done,
     /* 1488921 */   // Label 20800: @1488921
     /* 1488921 */   GIM_Try, /*On fail goto*//*Label 20801*/ GIMT_Encode4(1489018), // Rule ID 24724 //
     /* 1488926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1488929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1488937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1488940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1488943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488976 */     // MIs[1] Operand 1
     /* 1488976 */     // No operand predicates
     /* 1488976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488980 */     // MIs[0] policy
     /* 1488980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488992 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1489014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489017 */     // GIR_Coverage, 24724,
     /* 1489017 */     GIR_EraseRootFromParent_Done,
     /* 1489018 */   // Label 20801: @1489018
     /* 1489018 */   GIM_Try, /*On fail goto*//*Label 20802*/ GIMT_Encode4(1489115), // Rule ID 24725 //
     /* 1489023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1489026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1489034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1489037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1489040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1489046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489073 */     // MIs[1] Operand 1
     /* 1489073 */     // No operand predicates
     /* 1489073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489077 */     // MIs[0] policy
     /* 1489077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489089 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1489092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1489111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489114 */     // GIR_Coverage, 24725,
     /* 1489114 */     GIR_EraseRootFromParent_Done,
     /* 1489115 */   // Label 20802: @1489115
     /* 1489115 */   GIM_Try, /*On fail goto*//*Label 20803*/ GIMT_Encode4(1489212), // Rule ID 24728 //
     /* 1489120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1489131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1489134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1489137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489170 */     // MIs[1] Operand 1
     /* 1489170 */     // No operand predicates
     /* 1489170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489174 */     // MIs[0] policy
     /* 1489174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489186 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489211 */     // GIR_Coverage, 24728,
     /* 1489211 */     GIR_EraseRootFromParent_Done,
     /* 1489212 */   // Label 20803: @1489212
     /* 1489212 */   GIM_Try, /*On fail goto*//*Label 20804*/ GIMT_Encode4(1489309), // Rule ID 24729 //
     /* 1489217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1489228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1489231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1489234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489267 */     // MIs[1] Operand 1
     /* 1489267 */     // No operand predicates
     /* 1489267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489271 */     // MIs[0] policy
     /* 1489271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489283 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489308 */     // GIR_Coverage, 24729,
     /* 1489308 */     GIR_EraseRootFromParent_Done,
     /* 1489309 */   // Label 20804: @1489309
     /* 1489309 */   GIM_Try, /*On fail goto*//*Label 20805*/ GIMT_Encode4(1489406), // Rule ID 24732 //
     /* 1489314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1489325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1489328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1489331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1489337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489364 */     // MIs[1] Operand 1
     /* 1489364 */     // No operand predicates
     /* 1489364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489368 */     // MIs[0] policy
     /* 1489368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489380 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489405 */     // GIR_Coverage, 24732,
     /* 1489405 */     GIR_EraseRootFromParent_Done,
     /* 1489406 */   // Label 20805: @1489406
     /* 1489406 */   GIM_Try, /*On fail goto*//*Label 20806*/ GIMT_Encode4(1489503), // Rule ID 24733 //
     /* 1489411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1489422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1489425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1489428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1489434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489461 */     // MIs[1] Operand 1
     /* 1489461 */     // No operand predicates
     /* 1489461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489465 */     // MIs[0] policy
     /* 1489465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489477 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489502 */     // GIR_Coverage, 24733,
     /* 1489502 */     GIR_EraseRootFromParent_Done,
     /* 1489503 */   // Label 20806: @1489503
     /* 1489503 */   GIM_Try, /*On fail goto*//*Label 20807*/ GIMT_Encode4(1489600), // Rule ID 24736 //
     /* 1489508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1489519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1489522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1489525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1489531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489558 */     // MIs[1] Operand 1
     /* 1489558 */     // No operand predicates
     /* 1489558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489562 */     // MIs[0] policy
     /* 1489562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489574 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489599 */     // GIR_Coverage, 24736,
     /* 1489599 */     GIR_EraseRootFromParent_Done,
     /* 1489600 */   // Label 20807: @1489600
     /* 1489600 */   GIM_Try, /*On fail goto*//*Label 20808*/ GIMT_Encode4(1489697), // Rule ID 24737 //
     /* 1489605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1489616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1489619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1489622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1489628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489655 */     // MIs[1] Operand 1
     /* 1489655 */     // No operand predicates
     /* 1489655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489659 */     // MIs[0] policy
     /* 1489659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489671 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489696 */     // GIR_Coverage, 24737,
     /* 1489696 */     GIR_EraseRootFromParent_Done,
     /* 1489697 */   // Label 20808: @1489697
     /* 1489697 */   GIM_Try, /*On fail goto*//*Label 20809*/ GIMT_Encode4(1489794), // Rule ID 24740 //
     /* 1489702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1489713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1489716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1489719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489752 */     // MIs[1] Operand 1
     /* 1489752 */     // No operand predicates
     /* 1489752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489756 */     // MIs[0] policy
     /* 1489756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489793 */     // GIR_Coverage, 24740,
     /* 1489793 */     GIR_EraseRootFromParent_Done,
     /* 1489794 */   // Label 20809: @1489794
     /* 1489794 */   GIM_Try, /*On fail goto*//*Label 20810*/ GIMT_Encode4(1489891), // Rule ID 24741 //
     /* 1489799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1489810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1489813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1489816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489849 */     // MIs[1] Operand 1
     /* 1489849 */     // No operand predicates
     /* 1489849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489853 */     // MIs[0] policy
     /* 1489853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489865 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489890 */     // GIR_Coverage, 24741,
     /* 1489890 */     GIR_EraseRootFromParent_Done,
     /* 1489891 */   // Label 20810: @1489891
     /* 1489891 */   GIM_Try, /*On fail goto*//*Label 20811*/ GIMT_Encode4(1489988), // Rule ID 24744 //
     /* 1489896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1489907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1489910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1489913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489946 */     // MIs[1] Operand 1
     /* 1489946 */     // No operand predicates
     /* 1489946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489950 */     // MIs[0] policy
     /* 1489950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489962 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489987 */     // GIR_Coverage, 24744,
     /* 1489987 */     GIR_EraseRootFromParent_Done,
     /* 1489988 */   // Label 20811: @1489988
     /* 1489988 */   GIM_Try, /*On fail goto*//*Label 20812*/ GIMT_Encode4(1490085), // Rule ID 24745 //
     /* 1489993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1490004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1490007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1490010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1490016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490043 */     // MIs[1] Operand 1
     /* 1490043 */     // No operand predicates
     /* 1490043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490047 */     // MIs[0] policy
     /* 1490047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490059 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490084 */     // GIR_Coverage, 24745,
     /* 1490084 */     GIR_EraseRootFromParent_Done,
     /* 1490085 */   // Label 20812: @1490085
     /* 1490085 */   GIM_Try, /*On fail goto*//*Label 20813*/ GIMT_Encode4(1490182), // Rule ID 24748 //
     /* 1490090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1490101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1490104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1490107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1490113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490140 */     // MIs[1] Operand 1
     /* 1490140 */     // No operand predicates
     /* 1490140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490144 */     // MIs[0] policy
     /* 1490144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490156 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490181 */     // GIR_Coverage, 24748,
     /* 1490181 */     GIR_EraseRootFromParent_Done,
     /* 1490182 */   // Label 20813: @1490182
     /* 1490182 */   GIM_Try, /*On fail goto*//*Label 20814*/ GIMT_Encode4(1490279), // Rule ID 24749 //
     /* 1490187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1490198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1490201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1490204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1490210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490237 */     // MIs[1] Operand 1
     /* 1490237 */     // No operand predicates
     /* 1490237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490241 */     // MIs[0] policy
     /* 1490241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490253 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490278 */     // GIR_Coverage, 24749,
     /* 1490278 */     GIR_EraseRootFromParent_Done,
     /* 1490279 */   // Label 20814: @1490279
     /* 1490279 */   GIM_Try, /*On fail goto*//*Label 20815*/ GIMT_Encode4(1490376), // Rule ID 24752 //
     /* 1490284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1490295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1490298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1490301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490334 */     // MIs[1] Operand 1
     /* 1490334 */     // No operand predicates
     /* 1490334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490338 */     // MIs[0] policy
     /* 1490338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490350 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1490353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490375 */     // GIR_Coverage, 24752,
     /* 1490375 */     GIR_EraseRootFromParent_Done,
     /* 1490376 */   // Label 20815: @1490376
     /* 1490376 */   GIM_Try, /*On fail goto*//*Label 20816*/ GIMT_Encode4(1490473), // Rule ID 24753 //
     /* 1490381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1490392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1490395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1490398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490431 */     // MIs[1] Operand 1
     /* 1490431 */     // No operand predicates
     /* 1490431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490435 */     // MIs[0] policy
     /* 1490435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490447 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1490450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490472 */     // GIR_Coverage, 24753,
     /* 1490472 */     GIR_EraseRootFromParent_Done,
     /* 1490473 */   // Label 20816: @1490473
     /* 1490473 */   GIM_Try, /*On fail goto*//*Label 20817*/ GIMT_Encode4(1490570), // Rule ID 24756 //
     /* 1490478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1490489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1490492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1490495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490528 */     // MIs[1] Operand 1
     /* 1490528 */     // No operand predicates
     /* 1490528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490532 */     // MIs[0] policy
     /* 1490532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490544 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490569 */     // GIR_Coverage, 24756,
     /* 1490569 */     GIR_EraseRootFromParent_Done,
     /* 1490570 */   // Label 20817: @1490570
     /* 1490570 */   GIM_Try, /*On fail goto*//*Label 20818*/ GIMT_Encode4(1490667), // Rule ID 24757 //
     /* 1490575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1490586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1490589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1490592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490625 */     // MIs[1] Operand 1
     /* 1490625 */     // No operand predicates
     /* 1490625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490629 */     // MIs[0] policy
     /* 1490629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490641 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490666 */     // GIR_Coverage, 24757,
     /* 1490666 */     GIR_EraseRootFromParent_Done,
     /* 1490667 */   // Label 20818: @1490667
     /* 1490667 */   GIM_Try, /*On fail goto*//*Label 20819*/ GIMT_Encode4(1490764), // Rule ID 24760 //
     /* 1490672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1490683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1490686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1490689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1490695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490722 */     // MIs[1] Operand 1
     /* 1490722 */     // No operand predicates
     /* 1490722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490726 */     // MIs[0] policy
     /* 1490726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490738 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490763 */     // GIR_Coverage, 24760,
     /* 1490763 */     GIR_EraseRootFromParent_Done,
     /* 1490764 */   // Label 20819: @1490764
     /* 1490764 */   GIM_Try, /*On fail goto*//*Label 20820*/ GIMT_Encode4(1490861), // Rule ID 24761 //
     /* 1490769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1490780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1490783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1490786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1490792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490819 */     // MIs[1] Operand 1
     /* 1490819 */     // No operand predicates
     /* 1490819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490823 */     // MIs[0] policy
     /* 1490823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490835 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490860 */     // GIR_Coverage, 24761,
     /* 1490860 */     GIR_EraseRootFromParent_Done,
     /* 1490861 */   // Label 20820: @1490861
     /* 1490861 */   GIM_Try, /*On fail goto*//*Label 20821*/ GIMT_Encode4(1490958), // Rule ID 24764 //
     /* 1490866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1490869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1490877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1490880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1490883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490916 */     // MIs[1] Operand 1
     /* 1490916 */     // No operand predicates
     /* 1490916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490920 */     // MIs[0] policy
     /* 1490920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490932 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1490935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490957 */     // GIR_Coverage, 24764,
     /* 1490957 */     GIR_EraseRootFromParent_Done,
     /* 1490958 */   // Label 20821: @1490958
     /* 1490958 */   GIM_Try, /*On fail goto*//*Label 20822*/ GIMT_Encode4(1491055), // Rule ID 24765 //
     /* 1490963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1490966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1490974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1490977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1490980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491013 */     // MIs[1] Operand 1
     /* 1491013 */     // No operand predicates
     /* 1491013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491017 */     // MIs[0] policy
     /* 1491017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491029 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1491032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1491051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491054 */     // GIR_Coverage, 24765,
     /* 1491054 */     GIR_EraseRootFromParent_Done,
     /* 1491055 */   // Label 20822: @1491055
     /* 1491055 */   GIM_Try, /*On fail goto*//*Label 20823*/ GIMT_Encode4(1491152), // Rule ID 24768 //
     /* 1491060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1491063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1491071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1491074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1491077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1491090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491110 */     // MIs[1] Operand 1
     /* 1491110 */     // No operand predicates
     /* 1491110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491114 */     // MIs[0] policy
     /* 1491114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491126 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1491129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1491148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491151 */     // GIR_Coverage, 24768,
     /* 1491151 */     GIR_EraseRootFromParent_Done,
     /* 1491152 */   // Label 20823: @1491152
     /* 1491152 */   GIM_Try, /*On fail goto*//*Label 20824*/ GIMT_Encode4(1491249), // Rule ID 24769 //
     /* 1491157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1491160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1491168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1491171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1491174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1491187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491207 */     // MIs[1] Operand 1
     /* 1491207 */     // No operand predicates
     /* 1491207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491211 */     // MIs[0] policy
     /* 1491211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491223 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1491226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1491245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491248 */     // GIR_Coverage, 24769,
     /* 1491248 */     GIR_EraseRootFromParent_Done,
     /* 1491249 */   // Label 20824: @1491249
     /* 1491249 */   GIM_Try, /*On fail goto*//*Label 20825*/ GIMT_Encode4(1491346), // Rule ID 24772 //
     /* 1491254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1491257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1491265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1491268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1491271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1491277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1491284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491304 */     // MIs[1] Operand 1
     /* 1491304 */     // No operand predicates
     /* 1491304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491308 */     // MIs[0] policy
     /* 1491308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491320 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1491323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1491342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491345 */     // GIR_Coverage, 24772,
     /* 1491345 */     GIR_EraseRootFromParent_Done,
     /* 1491346 */   // Label 20825: @1491346
     /* 1491346 */   GIM_Try, /*On fail goto*//*Label 20826*/ GIMT_Encode4(1491443), // Rule ID 24773 //
     /* 1491351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1491354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1491362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1491365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1491368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1491374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1491381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491401 */     // MIs[1] Operand 1
     /* 1491401 */     // No operand predicates
     /* 1491401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491405 */     // MIs[0] policy
     /* 1491405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491417 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1491420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1491439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491442 */     // GIR_Coverage, 24773,
     /* 1491442 */     GIR_EraseRootFromParent_Done,
     /* 1491443 */   // Label 20826: @1491443
     /* 1491443 */   GIM_Try, /*On fail goto*//*Label 20827*/ GIMT_Encode4(1491540), // Rule ID 24980 //
     /* 1491448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1491459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1491462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1491465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491498 */     // MIs[1] Operand 1
     /* 1491498 */     // No operand predicates
     /* 1491498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491502 */     // MIs[0] policy
     /* 1491502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491514 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1491517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491539 */     // GIR_Coverage, 24980,
     /* 1491539 */     GIR_EraseRootFromParent_Done,
     /* 1491540 */   // Label 20827: @1491540
     /* 1491540 */   GIM_Try, /*On fail goto*//*Label 20828*/ GIMT_Encode4(1491637), // Rule ID 24981 //
     /* 1491545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1491556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1491559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1491562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491595 */     // MIs[1] Operand 1
     /* 1491595 */     // No operand predicates
     /* 1491595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491599 */     // MIs[0] policy
     /* 1491599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491611 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1491614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491636 */     // GIR_Coverage, 24981,
     /* 1491636 */     GIR_EraseRootFromParent_Done,
     /* 1491637 */   // Label 20828: @1491637
     /* 1491637 */   GIM_Try, /*On fail goto*//*Label 20829*/ GIMT_Encode4(1491734), // Rule ID 24984 //
     /* 1491642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1491659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491692 */     // MIs[1] Operand 1
     /* 1491692 */     // No operand predicates
     /* 1491692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491696 */     // MIs[0] policy
     /* 1491696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491708 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491733 */     // GIR_Coverage, 24984,
     /* 1491733 */     GIR_EraseRootFromParent_Done,
     /* 1491734 */   // Label 20829: @1491734
     /* 1491734 */   GIM_Try, /*On fail goto*//*Label 20830*/ GIMT_Encode4(1491831), // Rule ID 24985 //
     /* 1491739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1491756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491789 */     // MIs[1] Operand 1
     /* 1491789 */     // No operand predicates
     /* 1491789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491793 */     // MIs[0] policy
     /* 1491793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491805 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491830 */     // GIR_Coverage, 24985,
     /* 1491830 */     GIR_EraseRootFromParent_Done,
     /* 1491831 */   // Label 20830: @1491831
     /* 1491831 */   GIM_Try, /*On fail goto*//*Label 20831*/ GIMT_Encode4(1491928), // Rule ID 24988 //
     /* 1491836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1491847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1491850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1491853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491886 */     // MIs[1] Operand 1
     /* 1491886 */     // No operand predicates
     /* 1491886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491890 */     // MIs[0] policy
     /* 1491890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491902 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491927 */     // GIR_Coverage, 24988,
     /* 1491927 */     GIR_EraseRootFromParent_Done,
     /* 1491928 */   // Label 20831: @1491928
     /* 1491928 */   GIM_Try, /*On fail goto*//*Label 20832*/ GIMT_Encode4(1492025), // Rule ID 24989 //
     /* 1491933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1491944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1491947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1491950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491983 */     // MIs[1] Operand 1
     /* 1491983 */     // No operand predicates
     /* 1491983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491987 */     // MIs[0] policy
     /* 1491987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491999 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1492002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492024 */     // GIR_Coverage, 24989,
     /* 1492024 */     GIR_EraseRootFromParent_Done,
     /* 1492025 */   // Label 20832: @1492025
     /* 1492025 */   GIM_Try, /*On fail goto*//*Label 20833*/ GIMT_Encode4(1492122), // Rule ID 24992 //
     /* 1492030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1492041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1492044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1492047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492080 */     // MIs[1] Operand 1
     /* 1492080 */     // No operand predicates
     /* 1492080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492084 */     // MIs[0] policy
     /* 1492084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492096 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492121 */     // GIR_Coverage, 24992,
     /* 1492121 */     GIR_EraseRootFromParent_Done,
     /* 1492122 */   // Label 20833: @1492122
     /* 1492122 */   GIM_Try, /*On fail goto*//*Label 20834*/ GIMT_Encode4(1492219), // Rule ID 24993 //
     /* 1492127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1492138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1492141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1492144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492177 */     // MIs[1] Operand 1
     /* 1492177 */     // No operand predicates
     /* 1492177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492181 */     // MIs[0] policy
     /* 1492181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492193 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492218 */     // GIR_Coverage, 24993,
     /* 1492218 */     GIR_EraseRootFromParent_Done,
     /* 1492219 */   // Label 20834: @1492219
     /* 1492219 */   GIM_Try, /*On fail goto*//*Label 20835*/ GIMT_Encode4(1492316), // Rule ID 24996 //
     /* 1492224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1492235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1492238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1492241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1492247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492274 */     // MIs[1] Operand 1
     /* 1492274 */     // No operand predicates
     /* 1492274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492278 */     // MIs[0] policy
     /* 1492278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492290 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492315 */     // GIR_Coverage, 24996,
     /* 1492315 */     GIR_EraseRootFromParent_Done,
     /* 1492316 */   // Label 20835: @1492316
     /* 1492316 */   GIM_Try, /*On fail goto*//*Label 20836*/ GIMT_Encode4(1492413), // Rule ID 24997 //
     /* 1492321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1492332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1492335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1492338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1492344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492371 */     // MIs[1] Operand 1
     /* 1492371 */     // No operand predicates
     /* 1492371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492375 */     // MIs[0] policy
     /* 1492375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492387 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492412 */     // GIR_Coverage, 24997,
     /* 1492412 */     GIR_EraseRootFromParent_Done,
     /* 1492413 */   // Label 20836: @1492413
     /* 1492413 */   GIM_Try, /*On fail goto*//*Label 20837*/ GIMT_Encode4(1492510), // Rule ID 25000 //
     /* 1492418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1492421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1492429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1492432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1492435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1492441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492464 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492468 */     // MIs[1] Operand 1
     /* 1492468 */     // No operand predicates
     /* 1492468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492472 */     // MIs[0] policy
     /* 1492472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492484 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492509 */     // GIR_Coverage, 25000,
     /* 1492509 */     GIR_EraseRootFromParent_Done,
     /* 1492510 */   // Label 20837: @1492510
     /* 1492510 */   GIM_Try, /*On fail goto*//*Label 20838*/ GIMT_Encode4(1492607), // Rule ID 25001 //
     /* 1492515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1492518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1492526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1492529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1492532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1492538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492565 */     // MIs[1] Operand 1
     /* 1492565 */     // No operand predicates
     /* 1492565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492569 */     // MIs[0] policy
     /* 1492569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492581 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492606 */     // GIR_Coverage, 25001,
     /* 1492606 */     GIR_EraseRootFromParent_Done,
     /* 1492607 */   // Label 20838: @1492607
     /* 1492607 */   GIM_Try, /*On fail goto*//*Label 20839*/ GIMT_Encode4(1492704), // Rule ID 25004 //
     /* 1492612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1492623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1492626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1492629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492662 */     // MIs[1] Operand 1
     /* 1492662 */     // No operand predicates
     /* 1492662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492666 */     // MIs[0] policy
     /* 1492666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492678 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492703 */     // GIR_Coverage, 25004,
     /* 1492703 */     GIR_EraseRootFromParent_Done,
     /* 1492704 */   // Label 20839: @1492704
     /* 1492704 */   GIM_Try, /*On fail goto*//*Label 20840*/ GIMT_Encode4(1492801), // Rule ID 25005 //
     /* 1492709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1492720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1492723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1492726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492759 */     // MIs[1] Operand 1
     /* 1492759 */     // No operand predicates
     /* 1492759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492763 */     // MIs[0] policy
     /* 1492763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492775 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492800 */     // GIR_Coverage, 25005,
     /* 1492800 */     GIR_EraseRootFromParent_Done,
     /* 1492801 */   // Label 20840: @1492801
     /* 1492801 */   GIM_Try, /*On fail goto*//*Label 20841*/ GIMT_Encode4(1492898), // Rule ID 25008 //
     /* 1492806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1492817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1492820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1492823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492856 */     // MIs[1] Operand 1
     /* 1492856 */     // No operand predicates
     /* 1492856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492860 */     // MIs[0] policy
     /* 1492860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492872 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1492875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492897 */     // GIR_Coverage, 25008,
     /* 1492897 */     GIR_EraseRootFromParent_Done,
     /* 1492898 */   // Label 20841: @1492898
     /* 1492898 */   GIM_Try, /*On fail goto*//*Label 20842*/ GIMT_Encode4(1492995), // Rule ID 25009 //
     /* 1492903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1492914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1492917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1492920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492953 */     // MIs[1] Operand 1
     /* 1492953 */     // No operand predicates
     /* 1492953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492957 */     // MIs[0] policy
     /* 1492957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492969 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1492972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492994 */     // GIR_Coverage, 25009,
     /* 1492994 */     GIR_EraseRootFromParent_Done,
     /* 1492995 */   // Label 20842: @1492995
     /* 1492995 */   GIM_Try, /*On fail goto*//*Label 20843*/ GIMT_Encode4(1493092), // Rule ID 25012 //
     /* 1493000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1493011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1493014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1493017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1493023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493050 */     // MIs[1] Operand 1
     /* 1493050 */     // No operand predicates
     /* 1493050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493054 */     // MIs[0] policy
     /* 1493054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493066 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493091 */     // GIR_Coverage, 25012,
     /* 1493091 */     GIR_EraseRootFromParent_Done,
     /* 1493092 */   // Label 20843: @1493092
     /* 1493092 */   GIM_Try, /*On fail goto*//*Label 20844*/ GIMT_Encode4(1493189), // Rule ID 25013 //
     /* 1493097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1493108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1493111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1493114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1493120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493147 */     // MIs[1] Operand 1
     /* 1493147 */     // No operand predicates
     /* 1493147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493151 */     // MIs[0] policy
     /* 1493151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493163 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493188 */     // GIR_Coverage, 25013,
     /* 1493188 */     GIR_EraseRootFromParent_Done,
     /* 1493189 */   // Label 20844: @1493189
     /* 1493189 */   GIM_Try, /*On fail goto*//*Label 20845*/ GIMT_Encode4(1493286), // Rule ID 25016 //
     /* 1493194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1493205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1493208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1493211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493244 */     // MIs[1] Operand 1
     /* 1493244 */     // No operand predicates
     /* 1493244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493248 */     // MIs[0] policy
     /* 1493248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493260 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493285 */     // GIR_Coverage, 25016,
     /* 1493285 */     GIR_EraseRootFromParent_Done,
     /* 1493286 */   // Label 20845: @1493286
     /* 1493286 */   GIM_Try, /*On fail goto*//*Label 20846*/ GIMT_Encode4(1493383), // Rule ID 25017 //
     /* 1493291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1493302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1493305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1493308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493341 */     // MIs[1] Operand 1
     /* 1493341 */     // No operand predicates
     /* 1493341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493345 */     // MIs[0] policy
     /* 1493345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493357 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493382 */     // GIR_Coverage, 25017,
     /* 1493382 */     GIR_EraseRootFromParent_Done,
     /* 1493383 */   // Label 20846: @1493383
     /* 1493383 */   GIM_Try, /*On fail goto*//*Label 20847*/ GIMT_Encode4(1493480), // Rule ID 25020 //
     /* 1493388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1493399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1493402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1493405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493438 */     // MIs[1] Operand 1
     /* 1493438 */     // No operand predicates
     /* 1493438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493442 */     // MIs[0] policy
     /* 1493442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493454 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493479 */     // GIR_Coverage, 25020,
     /* 1493479 */     GIR_EraseRootFromParent_Done,
     /* 1493480 */   // Label 20847: @1493480
     /* 1493480 */   GIM_Try, /*On fail goto*//*Label 20848*/ GIMT_Encode4(1493577), // Rule ID 25021 //
     /* 1493485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1493496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1493499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1493502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493535 */     // MIs[1] Operand 1
     /* 1493535 */     // No operand predicates
     /* 1493535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493539 */     // MIs[0] policy
     /* 1493539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493551 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493576 */     // GIR_Coverage, 25021,
     /* 1493576 */     GIR_EraseRootFromParent_Done,
     /* 1493577 */   // Label 20848: @1493577
     /* 1493577 */   GIM_Try, /*On fail goto*//*Label 20849*/ GIMT_Encode4(1493674), // Rule ID 25024 //
     /* 1493582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1493593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1493596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1493599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493632 */     // MIs[1] Operand 1
     /* 1493632 */     // No operand predicates
     /* 1493632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493636 */     // MIs[0] policy
     /* 1493636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493648 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493673 */     // GIR_Coverage, 25024,
     /* 1493673 */     GIR_EraseRootFromParent_Done,
     /* 1493674 */   // Label 20849: @1493674
     /* 1493674 */   GIM_Try, /*On fail goto*//*Label 20850*/ GIMT_Encode4(1493771), // Rule ID 25025 //
     /* 1493679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1493690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1493693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1493696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493729 */     // MIs[1] Operand 1
     /* 1493729 */     // No operand predicates
     /* 1493729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493733 */     // MIs[0] policy
     /* 1493733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493745 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493770 */     // GIR_Coverage, 25025,
     /* 1493770 */     GIR_EraseRootFromParent_Done,
     /* 1493771 */   // Label 20850: @1493771
     /* 1493771 */   GIM_Try, /*On fail goto*//*Label 20851*/ GIMT_Encode4(1493868), // Rule ID 25028 //
     /* 1493776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1493779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1493787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1493790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1493793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493826 */     // MIs[1] Operand 1
     /* 1493826 */     // No operand predicates
     /* 1493826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493830 */     // MIs[0] policy
     /* 1493830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493842 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493867 */     // GIR_Coverage, 25028,
     /* 1493867 */     GIR_EraseRootFromParent_Done,
     /* 1493868 */   // Label 20851: @1493868
     /* 1493868 */   GIM_Try, /*On fail goto*//*Label 20852*/ GIMT_Encode4(1493965), // Rule ID 25029 //
     /* 1493873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1493876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1493884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1493887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1493890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493923 */     // MIs[1] Operand 1
     /* 1493923 */     // No operand predicates
     /* 1493923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493927 */     // MIs[0] policy
     /* 1493927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493939 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493964 */     // GIR_Coverage, 25029,
     /* 1493964 */     GIR_EraseRootFromParent_Done,
     /* 1493965 */   // Label 20852: @1493965
     /* 1493965 */   GIM_Try, /*On fail goto*//*Label 20853*/ GIMT_Encode4(1494062), // Rule ID 25032 //
     /* 1493970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1493973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1493981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1493984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1493987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494020 */     // MIs[1] Operand 1
     /* 1494020 */     // No operand predicates
     /* 1494020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494024 */     // MIs[0] policy
     /* 1494024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494036 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1494039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494061 */     // GIR_Coverage, 25032,
     /* 1494061 */     GIR_EraseRootFromParent_Done,
     /* 1494062 */   // Label 20853: @1494062
     /* 1494062 */   GIM_Try, /*On fail goto*//*Label 20854*/ GIMT_Encode4(1494159), // Rule ID 25033 //
     /* 1494067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1494070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1494078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1494081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1494084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494117 */     // MIs[1] Operand 1
     /* 1494117 */     // No operand predicates
     /* 1494117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494121 */     // MIs[0] policy
     /* 1494121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494133 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1494136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494158 */     // GIR_Coverage, 25033,
     /* 1494158 */     GIR_EraseRootFromParent_Done,
     /* 1494159 */   // Label 20854: @1494159
     /* 1494159 */   GIM_Try, /*On fail goto*//*Label 20855*/ GIMT_Encode4(1494256), // Rule ID 25036 //
     /* 1494164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1494167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1494175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1494178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1494181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494214 */     // MIs[1] Operand 1
     /* 1494214 */     // No operand predicates
     /* 1494214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494218 */     // MIs[0] policy
     /* 1494218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494230 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1494233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494255 */     // GIR_Coverage, 25036,
     /* 1494255 */     GIR_EraseRootFromParent_Done,
     /* 1494256 */   // Label 20855: @1494256
     /* 1494256 */   GIM_Try, /*On fail goto*//*Label 20856*/ GIMT_Encode4(1494353), // Rule ID 25037 //
     /* 1494261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1494264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1494272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1494275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1494278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494311 */     // MIs[1] Operand 1
     /* 1494311 */     // No operand predicates
     /* 1494311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494315 */     // MIs[0] policy
     /* 1494315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494327 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1494330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494352 */     // GIR_Coverage, 25037,
     /* 1494352 */     GIR_EraseRootFromParent_Done,
     /* 1494353 */   // Label 20856: @1494353
     /* 1494353 */   GIM_Try, /*On fail goto*//*Label 20857*/ GIMT_Encode4(1494450), // Rule ID 61048 //
     /* 1494358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1494369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1494372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1494375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1494381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494408 */     // MIs[1] Operand 1
     /* 1494408 */     // No operand predicates
     /* 1494408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494412 */     // MIs[0] policy
     /* 1494412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494424 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1494427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494449 */     // GIR_Coverage, 61048,
     /* 1494449 */     GIR_EraseRootFromParent_Done,
     /* 1494450 */   // Label 20857: @1494450
     /* 1494450 */   GIM_Try, /*On fail goto*//*Label 20858*/ GIMT_Encode4(1494547), // Rule ID 61049 //
     /* 1494455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1494466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1494469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1494472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1494478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494505 */     // MIs[1] Operand 1
     /* 1494505 */     // No operand predicates
     /* 1494505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494509 */     // MIs[0] policy
     /* 1494509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494521 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1494524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494546 */     // GIR_Coverage, 61049,
     /* 1494546 */     GIR_EraseRootFromParent_Done,
     /* 1494547 */   // Label 20858: @1494547
     /* 1494547 */   GIM_Try, /*On fail goto*//*Label 20859*/ GIMT_Encode4(1494644), // Rule ID 61056 //
     /* 1494552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1494563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1494566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1494569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494602 */     // MIs[1] Operand 1
     /* 1494602 */     // No operand predicates
     /* 1494602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494606 */     // MIs[0] policy
     /* 1494606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494618 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1494621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494643 */     // GIR_Coverage, 61056,
     /* 1494643 */     GIR_EraseRootFromParent_Done,
     /* 1494644 */   // Label 20859: @1494644
     /* 1494644 */   GIM_Try, /*On fail goto*//*Label 20860*/ GIMT_Encode4(1494741), // Rule ID 61057 //
     /* 1494649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1494660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1494663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1494666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494699 */     // MIs[1] Operand 1
     /* 1494699 */     // No operand predicates
     /* 1494699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494703 */     // MIs[0] policy
     /* 1494703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494715 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1494718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494740 */     // GIR_Coverage, 61057,
     /* 1494740 */     GIR_EraseRootFromParent_Done,
     /* 1494741 */   // Label 20860: @1494741
     /* 1494741 */   GIM_Try, /*On fail goto*//*Label 20861*/ GIMT_Encode4(1494838), // Rule ID 61064 //
     /* 1494746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1494757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1494760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1494763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494796 */     // MIs[1] Operand 1
     /* 1494796 */     // No operand predicates
     /* 1494796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494800 */     // MIs[0] policy
     /* 1494800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494812 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1494815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494837 */     // GIR_Coverage, 61064,
     /* 1494837 */     GIR_EraseRootFromParent_Done,
     /* 1494838 */   // Label 20861: @1494838
     /* 1494838 */   GIM_Try, /*On fail goto*//*Label 20862*/ GIMT_Encode4(1494935), // Rule ID 61065 //
     /* 1494843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1494854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1494857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1494860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494893 */     // MIs[1] Operand 1
     /* 1494893 */     // No operand predicates
     /* 1494893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494897 */     // MIs[0] policy
     /* 1494897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494909 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1494912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494934 */     // GIR_Coverage, 61065,
     /* 1494934 */     GIR_EraseRootFromParent_Done,
     /* 1494935 */   // Label 20862: @1494935
     /* 1494935 */   GIM_Try, /*On fail goto*//*Label 20863*/ GIMT_Encode4(1495032), // Rule ID 61072 //
     /* 1494940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1494951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1494954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1494957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494990 */     // MIs[1] Operand 1
     /* 1494990 */     // No operand predicates
     /* 1494990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494994 */     // MIs[0] policy
     /* 1494994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495006 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1495009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495031 */     // GIR_Coverage, 61072,
     /* 1495031 */     GIR_EraseRootFromParent_Done,
     /* 1495032 */   // Label 20863: @1495032
     /* 1495032 */   GIM_Try, /*On fail goto*//*Label 20864*/ GIMT_Encode4(1495129), // Rule ID 61073 //
     /* 1495037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1495048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1495051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1495054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495087 */     // MIs[1] Operand 1
     /* 1495087 */     // No operand predicates
     /* 1495087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495091 */     // MIs[0] policy
     /* 1495091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495103 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1495106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495128 */     // GIR_Coverage, 61073,
     /* 1495128 */     GIR_EraseRootFromParent_Done,
     /* 1495129 */   // Label 20864: @1495129
     /* 1495129 */   GIM_Try, /*On fail goto*//*Label 20865*/ GIMT_Encode4(1495226), // Rule ID 61080 //
     /* 1495134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1495145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1495148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1495151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495184 */     // MIs[1] Operand 1
     /* 1495184 */     // No operand predicates
     /* 1495184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495188 */     // MIs[0] policy
     /* 1495188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495200 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1495203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495225 */     // GIR_Coverage, 61080,
     /* 1495225 */     GIR_EraseRootFromParent_Done,
     /* 1495226 */   // Label 20865: @1495226
     /* 1495226 */   GIM_Try, /*On fail goto*//*Label 20866*/ GIMT_Encode4(1495323), // Rule ID 61081 //
     /* 1495231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1495242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1495245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1495248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495281 */     // MIs[1] Operand 1
     /* 1495281 */     // No operand predicates
     /* 1495281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495285 */     // MIs[0] policy
     /* 1495285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495297 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1495300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495322 */     // GIR_Coverage, 61081,
     /* 1495322 */     GIR_EraseRootFromParent_Done,
     /* 1495323 */   // Label 20866: @1495323
     /* 1495323 */   GIM_Try, /*On fail goto*//*Label 20867*/ GIMT_Encode4(1495420), // Rule ID 61088 //
     /* 1495328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1495339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1495342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1495345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1495351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495378 */     // MIs[1] Operand 1
     /* 1495378 */     // No operand predicates
     /* 1495378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495382 */     // MIs[0] policy
     /* 1495382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495394 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1495397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495419 */     // GIR_Coverage, 61088,
     /* 1495419 */     GIR_EraseRootFromParent_Done,
     /* 1495420 */   // Label 20867: @1495420
     /* 1495420 */   GIM_Try, /*On fail goto*//*Label 20868*/ GIMT_Encode4(1495517), // Rule ID 61089 //
     /* 1495425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1495436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1495439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1495442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1495448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495475 */     // MIs[1] Operand 1
     /* 1495475 */     // No operand predicates
     /* 1495475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495479 */     // MIs[0] policy
     /* 1495479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495491 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1495494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495516 */     // GIR_Coverage, 61089,
     /* 1495516 */     GIR_EraseRootFromParent_Done,
     /* 1495517 */   // Label 20868: @1495517
     /* 1495517 */   GIM_Try, /*On fail goto*//*Label 20869*/ GIMT_Encode4(1495614), // Rule ID 61096 //
     /* 1495522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1495533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1495536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1495539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495572 */     // MIs[1] Operand 1
     /* 1495572 */     // No operand predicates
     /* 1495572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495576 */     // MIs[0] policy
     /* 1495576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495588 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1495591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495613 */     // GIR_Coverage, 61096,
     /* 1495613 */     GIR_EraseRootFromParent_Done,
     /* 1495614 */   // Label 20869: @1495614
     /* 1495614 */   GIM_Try, /*On fail goto*//*Label 20870*/ GIMT_Encode4(1495711), // Rule ID 61097 //
     /* 1495619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1495630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1495633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1495636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495669 */     // MIs[1] Operand 1
     /* 1495669 */     // No operand predicates
     /* 1495669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495673 */     // MIs[0] policy
     /* 1495673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495685 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1495688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495710 */     // GIR_Coverage, 61097,
     /* 1495710 */     GIR_EraseRootFromParent_Done,
     /* 1495711 */   // Label 20870: @1495711
     /* 1495711 */   GIM_Try, /*On fail goto*//*Label 20871*/ GIMT_Encode4(1495808), // Rule ID 61104 //
     /* 1495716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1495727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1495730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1495733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1495739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495766 */     // MIs[1] Operand 1
     /* 1495766 */     // No operand predicates
     /* 1495766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495770 */     // MIs[0] policy
     /* 1495770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495782 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1495785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495807 */     // GIR_Coverage, 61104,
     /* 1495807 */     GIR_EraseRootFromParent_Done,
     /* 1495808 */   // Label 20871: @1495808
     /* 1495808 */   GIM_Try, /*On fail goto*//*Label 20872*/ GIMT_Encode4(1495905), // Rule ID 61105 //
     /* 1495813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1495824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1495827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1495830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1495836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495863 */     // MIs[1] Operand 1
     /* 1495863 */     // No operand predicates
     /* 1495863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495867 */     // MIs[0] policy
     /* 1495867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495879 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1495882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495904 */     // GIR_Coverage, 61105,
     /* 1495904 */     GIR_EraseRootFromParent_Done,
     /* 1495905 */   // Label 20872: @1495905
     /* 1495905 */   GIM_Try, /*On fail goto*//*Label 20873*/ GIMT_Encode4(1496002), // Rule ID 61112 //
     /* 1495910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1495921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1495924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1495927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1495933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495960 */     // MIs[1] Operand 1
     /* 1495960 */     // No operand predicates
     /* 1495960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495964 */     // MIs[0] policy
     /* 1495964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495976 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1495979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496001 */     // GIR_Coverage, 61112,
     /* 1496001 */     GIR_EraseRootFromParent_Done,
     /* 1496002 */   // Label 20873: @1496002
     /* 1496002 */   GIM_Try, /*On fail goto*//*Label 20874*/ GIMT_Encode4(1496099), // Rule ID 61113 //
     /* 1496007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1496018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1496021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1496024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496057 */     // MIs[1] Operand 1
     /* 1496057 */     // No operand predicates
     /* 1496057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496061 */     // MIs[0] policy
     /* 1496061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496073 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1496076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496098 */     // GIR_Coverage, 61113,
     /* 1496098 */     GIR_EraseRootFromParent_Done,
     /* 1496099 */   // Label 20874: @1496099
     /* 1496099 */   GIM_Try, /*On fail goto*//*Label 20875*/ GIMT_Encode4(1496196), // Rule ID 61120 //
     /* 1496104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1496115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1496118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1496121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1496127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496154 */     // MIs[1] Operand 1
     /* 1496154 */     // No operand predicates
     /* 1496154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496158 */     // MIs[0] policy
     /* 1496158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496170 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1496173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496195 */     // GIR_Coverage, 61120,
     /* 1496195 */     GIR_EraseRootFromParent_Done,
     /* 1496196 */   // Label 20875: @1496196
     /* 1496196 */   GIM_Try, /*On fail goto*//*Label 20876*/ GIMT_Encode4(1496293), // Rule ID 61121 //
     /* 1496201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1496212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1496215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1496218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1496224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496251 */     // MIs[1] Operand 1
     /* 1496251 */     // No operand predicates
     /* 1496251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496255 */     // MIs[0] policy
     /* 1496255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496267 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1496270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496292 */     // GIR_Coverage, 61121,
     /* 1496292 */     GIR_EraseRootFromParent_Done,
     /* 1496293 */   // Label 20876: @1496293
     /* 1496293 */   GIM_Try, /*On fail goto*//*Label 20877*/ GIMT_Encode4(1496390), // Rule ID 61128 //
     /* 1496298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1496309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1496312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1496315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1496321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496348 */     // MIs[1] Operand 1
     /* 1496348 */     // No operand predicates
     /* 1496348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496352 */     // MIs[0] policy
     /* 1496352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1496367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496389 */     // GIR_Coverage, 61128,
     /* 1496389 */     GIR_EraseRootFromParent_Done,
     /* 1496390 */   // Label 20877: @1496390
     /* 1496390 */   GIM_Try, /*On fail goto*//*Label 20878*/ GIMT_Encode4(1496487), // Rule ID 61129 //
     /* 1496395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1496406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1496409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1496412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1496418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496445 */     // MIs[1] Operand 1
     /* 1496445 */     // No operand predicates
     /* 1496445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496449 */     // MIs[0] policy
     /* 1496449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496461 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1496464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496486 */     // GIR_Coverage, 61129,
     /* 1496486 */     GIR_EraseRootFromParent_Done,
     /* 1496487 */   // Label 20878: @1496487
     /* 1496487 */   GIM_Try, /*On fail goto*//*Label 20879*/ GIMT_Encode4(1496584), // Rule ID 61136 //
     /* 1496492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1496503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1496506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1496509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496542 */     // MIs[1] Operand 1
     /* 1496542 */     // No operand predicates
     /* 1496542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496546 */     // MIs[0] policy
     /* 1496546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496558 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1496561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496583 */     // GIR_Coverage, 61136,
     /* 1496583 */     GIR_EraseRootFromParent_Done,
     /* 1496584 */   // Label 20879: @1496584
     /* 1496584 */   GIM_Try, /*On fail goto*//*Label 20880*/ GIMT_Encode4(1496681), // Rule ID 61137 //
     /* 1496589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1496600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1496603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1496606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496639 */     // MIs[1] Operand 1
     /* 1496639 */     // No operand predicates
     /* 1496639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496643 */     // MIs[0] policy
     /* 1496643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496655 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1496658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496680 */     // GIR_Coverage, 61137,
     /* 1496680 */     GIR_EraseRootFromParent_Done,
     /* 1496681 */   // Label 20880: @1496681
     /* 1496681 */   GIM_Try, /*On fail goto*//*Label 20881*/ GIMT_Encode4(1496778), // Rule ID 61144 //
     /* 1496686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1496703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496736 */     // MIs[1] Operand 1
     /* 1496736 */     // No operand predicates
     /* 1496736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496740 */     // MIs[0] policy
     /* 1496740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1496755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496777 */     // GIR_Coverage, 61144,
     /* 1496777 */     GIR_EraseRootFromParent_Done,
     /* 1496778 */   // Label 20881: @1496778
     /* 1496778 */   GIM_Try, /*On fail goto*//*Label 20882*/ GIMT_Encode4(1496875), // Rule ID 61145 //
     /* 1496783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1496800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496833 */     // MIs[1] Operand 1
     /* 1496833 */     // No operand predicates
     /* 1496833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496837 */     // MIs[0] policy
     /* 1496837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1496852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496874 */     // GIR_Coverage, 61145,
     /* 1496874 */     GIR_EraseRootFromParent_Done,
     /* 1496875 */   // Label 20882: @1496875
     /* 1496875 */   GIM_Try, /*On fail goto*//*Label 20883*/ GIMT_Encode4(1496972), // Rule ID 61152 //
     /* 1496880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1496897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496930 */     // MIs[1] Operand 1
     /* 1496930 */     // No operand predicates
     /* 1496930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496934 */     // MIs[0] policy
     /* 1496934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496946 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1496949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496971 */     // GIR_Coverage, 61152,
     /* 1496971 */     GIR_EraseRootFromParent_Done,
     /* 1496972 */   // Label 20883: @1496972
     /* 1496972 */   GIM_Try, /*On fail goto*//*Label 20884*/ GIMT_Encode4(1497069), // Rule ID 61153 //
     /* 1496977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1496994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1497007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497027 */     // MIs[1] Operand 1
     /* 1497027 */     // No operand predicates
     /* 1497027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497031 */     // MIs[0] policy
     /* 1497031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497043 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1497046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497068 */     // GIR_Coverage, 61153,
     /* 1497068 */     GIR_EraseRootFromParent_Done,
     /* 1497069 */   // Label 20884: @1497069
     /* 1497069 */   GIM_Try, /*On fail goto*//*Label 20885*/ GIMT_Encode4(1497166), // Rule ID 61160 //
     /* 1497074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1497077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1497082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1497085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1497088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1497091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1497104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497124 */     // MIs[1] Operand 1
     /* 1497124 */     // No operand predicates
     /* 1497124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497128 */     // MIs[0] policy
     /* 1497128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497140 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1497143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497165 */     // GIR_Coverage, 61160,
     /* 1497165 */     GIR_EraseRootFromParent_Done,
     /* 1497166 */   // Label 20885: @1497166
     /* 1497166 */   GIM_Try, /*On fail goto*//*Label 20886*/ GIMT_Encode4(1497263), // Rule ID 61161 //
     /* 1497171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1497174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1497179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1497182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1497185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1497188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1497201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497221 */     // MIs[1] Operand 1
     /* 1497221 */     // No operand predicates
     /* 1497221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497225 */     // MIs[0] policy
     /* 1497225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497237 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1497240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497262 */     // GIR_Coverage, 61161,
     /* 1497262 */     GIR_EraseRootFromParent_Done,
     /* 1497263 */   // Label 20886: @1497263
     /* 1497263 */   GIM_Try, /*On fail goto*//*Label 20887*/ GIMT_Encode4(1497360), // Rule ID 62016 //
     /* 1497268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1497279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1497282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1497285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497318 */     // MIs[1] Operand 1
     /* 1497318 */     // No operand predicates
     /* 1497318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497322 */     // MIs[0] policy
     /* 1497322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1497337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497359 */     // GIR_Coverage, 62016,
     /* 1497359 */     GIR_EraseRootFromParent_Done,
     /* 1497360 */   // Label 20887: @1497360
     /* 1497360 */   GIM_Try, /*On fail goto*//*Label 20888*/ GIMT_Encode4(1497457), // Rule ID 62017 //
     /* 1497365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1497376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1497379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1497382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497415 */     // MIs[1] Operand 1
     /* 1497415 */     // No operand predicates
     /* 1497415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497419 */     // MIs[0] policy
     /* 1497419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497431 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1497434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497456 */     // GIR_Coverage, 62017,
     /* 1497456 */     GIR_EraseRootFromParent_Done,
     /* 1497457 */   // Label 20888: @1497457
     /* 1497457 */   GIM_Try, /*On fail goto*//*Label 20889*/ GIMT_Encode4(1497554), // Rule ID 62020 //
     /* 1497462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1497473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1497476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1497479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497512 */     // MIs[1] Operand 1
     /* 1497512 */     // No operand predicates
     /* 1497512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497516 */     // MIs[0] policy
     /* 1497516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497528 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497553 */     // GIR_Coverage, 62020,
     /* 1497553 */     GIR_EraseRootFromParent_Done,
     /* 1497554 */   // Label 20889: @1497554
     /* 1497554 */   GIM_Try, /*On fail goto*//*Label 20890*/ GIMT_Encode4(1497651), // Rule ID 62021 //
     /* 1497559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1497570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1497573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1497576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497609 */     // MIs[1] Operand 1
     /* 1497609 */     // No operand predicates
     /* 1497609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497613 */     // MIs[0] policy
     /* 1497613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497625 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497650 */     // GIR_Coverage, 62021,
     /* 1497650 */     GIR_EraseRootFromParent_Done,
     /* 1497651 */   // Label 20890: @1497651
     /* 1497651 */   GIM_Try, /*On fail goto*//*Label 20891*/ GIMT_Encode4(1497748), // Rule ID 62024 //
     /* 1497656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1497667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1497670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1497673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497706 */     // MIs[1] Operand 1
     /* 1497706 */     // No operand predicates
     /* 1497706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497710 */     // MIs[0] policy
     /* 1497710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497722 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497747 */     // GIR_Coverage, 62024,
     /* 1497747 */     GIR_EraseRootFromParent_Done,
     /* 1497748 */   // Label 20891: @1497748
     /* 1497748 */   GIM_Try, /*On fail goto*//*Label 20892*/ GIMT_Encode4(1497845), // Rule ID 62025 //
     /* 1497753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1497764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1497767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1497770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497803 */     // MIs[1] Operand 1
     /* 1497803 */     // No operand predicates
     /* 1497803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497807 */     // MIs[0] policy
     /* 1497807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497819 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497844 */     // GIR_Coverage, 62025,
     /* 1497844 */     GIR_EraseRootFromParent_Done,
     /* 1497845 */   // Label 20892: @1497845
     /* 1497845 */   GIM_Try, /*On fail goto*//*Label 20893*/ GIMT_Encode4(1497942), // Rule ID 62028 //
     /* 1497850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1497867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497900 */     // MIs[1] Operand 1
     /* 1497900 */     // No operand predicates
     /* 1497900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497904 */     // MIs[0] policy
     /* 1497904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497916 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497941 */     // GIR_Coverage, 62028,
     /* 1497941 */     GIR_EraseRootFromParent_Done,
     /* 1497942 */   // Label 20893: @1497942
     /* 1497942 */   GIM_Try, /*On fail goto*//*Label 20894*/ GIMT_Encode4(1498039), // Rule ID 62029 //
     /* 1497947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1497964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497997 */     // MIs[1] Operand 1
     /* 1497997 */     // No operand predicates
     /* 1497997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498001 */     // MIs[0] policy
     /* 1498001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498013 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1498016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498038 */     // GIR_Coverage, 62029,
     /* 1498038 */     GIR_EraseRootFromParent_Done,
     /* 1498039 */   // Label 20894: @1498039
     /* 1498039 */   GIM_Try, /*On fail goto*//*Label 20895*/ GIMT_Encode4(1498136), // Rule ID 62032 //
     /* 1498044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1498055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1498058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1498061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498094 */     // MIs[1] Operand 1
     /* 1498094 */     // No operand predicates
     /* 1498094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498098 */     // MIs[0] policy
     /* 1498098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498110 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1498113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498135 */     // GIR_Coverage, 62032,
     /* 1498135 */     GIR_EraseRootFromParent_Done,
     /* 1498136 */   // Label 20895: @1498136
     /* 1498136 */   GIM_Try, /*On fail goto*//*Label 20896*/ GIMT_Encode4(1498233), // Rule ID 62033 //
     /* 1498141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1498152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1498155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1498158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498191 */     // MIs[1] Operand 1
     /* 1498191 */     // No operand predicates
     /* 1498191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498195 */     // MIs[0] policy
     /* 1498195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498207 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1498210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498232 */     // GIR_Coverage, 62033,
     /* 1498232 */     GIR_EraseRootFromParent_Done,
     /* 1498233 */   // Label 20896: @1498233
     /* 1498233 */   GIM_Try, /*On fail goto*//*Label 20897*/ GIMT_Encode4(1498330), // Rule ID 62036 //
     /* 1498238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1498249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1498252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1498255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1498261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498288 */     // MIs[1] Operand 1
     /* 1498288 */     // No operand predicates
     /* 1498288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498292 */     // MIs[0] policy
     /* 1498292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498304 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1498307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498329 */     // GIR_Coverage, 62036,
     /* 1498329 */     GIR_EraseRootFromParent_Done,
     /* 1498330 */   // Label 20897: @1498330
     /* 1498330 */   GIM_Try, /*On fail goto*//*Label 20898*/ GIMT_Encode4(1498427), // Rule ID 62037 //
     /* 1498335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1498346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1498349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1498352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1498358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498385 */     // MIs[1] Operand 1
     /* 1498385 */     // No operand predicates
     /* 1498385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498389 */     // MIs[0] policy
     /* 1498389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498401 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1498404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498426 */     // GIR_Coverage, 62037,
     /* 1498426 */     GIR_EraseRootFromParent_Done,
     /* 1498427 */   // Label 20898: @1498427
     /* 1498427 */   GIM_Try, /*On fail goto*//*Label 20899*/ GIMT_Encode4(1498524), // Rule ID 62040 //
     /* 1498432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1498443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1498446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1498449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1498455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498482 */     // MIs[1] Operand 1
     /* 1498482 */     // No operand predicates
     /* 1498482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498486 */     // MIs[0] policy
     /* 1498486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498498 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498523 */     // GIR_Coverage, 62040,
     /* 1498523 */     GIR_EraseRootFromParent_Done,
     /* 1498524 */   // Label 20899: @1498524
     /* 1498524 */   GIM_Try, /*On fail goto*//*Label 20900*/ GIMT_Encode4(1498621), // Rule ID 62041 //
     /* 1498529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1498540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1498543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1498546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1498552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498579 */     // MIs[1] Operand 1
     /* 1498579 */     // No operand predicates
     /* 1498579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498583 */     // MIs[0] policy
     /* 1498583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498595 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498620 */     // GIR_Coverage, 62041,
     /* 1498620 */     GIR_EraseRootFromParent_Done,
     /* 1498621 */   // Label 20900: @1498621
     /* 1498621 */   GIM_Try, /*On fail goto*//*Label 20901*/ GIMT_Encode4(1498718), // Rule ID 62044 //
     /* 1498626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1498637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1498640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1498643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1498649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498676 */     // MIs[1] Operand 1
     /* 1498676 */     // No operand predicates
     /* 1498676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498680 */     // MIs[0] policy
     /* 1498680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498692 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498717 */     // GIR_Coverage, 62044,
     /* 1498717 */     GIR_EraseRootFromParent_Done,
     /* 1498718 */   // Label 20901: @1498718
     /* 1498718 */   GIM_Try, /*On fail goto*//*Label 20902*/ GIMT_Encode4(1498815), // Rule ID 62045 //
     /* 1498723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1498734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1498737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1498740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1498746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498773 */     // MIs[1] Operand 1
     /* 1498773 */     // No operand predicates
     /* 1498773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498777 */     // MIs[0] policy
     /* 1498777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498789 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498814 */     // GIR_Coverage, 62045,
     /* 1498814 */     GIR_EraseRootFromParent_Done,
     /* 1498815 */   // Label 20902: @1498815
     /* 1498815 */   GIM_Try, /*On fail goto*//*Label 20903*/ GIMT_Encode4(1498912), // Rule ID 62048 //
     /* 1498820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1498831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1498834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1498837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498870 */     // MIs[1] Operand 1
     /* 1498870 */     // No operand predicates
     /* 1498870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498874 */     // MIs[0] policy
     /* 1498874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498911 */     // GIR_Coverage, 62048,
     /* 1498911 */     GIR_EraseRootFromParent_Done,
     /* 1498912 */   // Label 20903: @1498912
     /* 1498912 */   GIM_Try, /*On fail goto*//*Label 20904*/ GIMT_Encode4(1499009), // Rule ID 62049 //
     /* 1498917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1498928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1498931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1498934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498967 */     // MIs[1] Operand 1
     /* 1498967 */     // No operand predicates
     /* 1498967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498971 */     // MIs[0] policy
     /* 1498971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498983 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499008 */     // GIR_Coverage, 62049,
     /* 1499008 */     GIR_EraseRootFromParent_Done,
     /* 1499009 */   // Label 20904: @1499009
     /* 1499009 */   GIM_Try, /*On fail goto*//*Label 20905*/ GIMT_Encode4(1499106), // Rule ID 62052 //
     /* 1499014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1499025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1499028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1499031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1499037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1499044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499064 */     // MIs[1] Operand 1
     /* 1499064 */     // No operand predicates
     /* 1499064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499068 */     // MIs[0] policy
     /* 1499068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499080 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1499083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1499102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499105 */     // GIR_Coverage, 62052,
     /* 1499105 */     GIR_EraseRootFromParent_Done,
     /* 1499106 */   // Label 20905: @1499106
     /* 1499106 */   GIM_Try, /*On fail goto*//*Label 20906*/ GIMT_Encode4(1499203), // Rule ID 62053 //
     /* 1499111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1499122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1499125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1499128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1499134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1499141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499161 */     // MIs[1] Operand 1
     /* 1499161 */     // No operand predicates
     /* 1499161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499165 */     // MIs[0] policy
     /* 1499165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499177 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1499180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1499199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499202 */     // GIR_Coverage, 62053,
     /* 1499202 */     GIR_EraseRootFromParent_Done,
     /* 1499203 */   // Label 20906: @1499203
     /* 1499203 */   GIM_Try, /*On fail goto*//*Label 20907*/ GIMT_Encode4(1499300), // Rule ID 62056 //
     /* 1499208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1499219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1499222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1499225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499258 */     // MIs[1] Operand 1
     /* 1499258 */     // No operand predicates
     /* 1499258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499262 */     // MIs[0] policy
     /* 1499262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499274 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499299 */     // GIR_Coverage, 62056,
     /* 1499299 */     GIR_EraseRootFromParent_Done,
     /* 1499300 */   // Label 20907: @1499300
     /* 1499300 */   GIM_Try, /*On fail goto*//*Label 20908*/ GIMT_Encode4(1499397), // Rule ID 62057 //
     /* 1499305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1499316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1499319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1499322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499355 */     // MIs[1] Operand 1
     /* 1499355 */     // No operand predicates
     /* 1499355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499359 */     // MIs[0] policy
     /* 1499359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499396 */     // GIR_Coverage, 62057,
     /* 1499396 */     GIR_EraseRootFromParent_Done,
     /* 1499397 */   // Label 20908: @1499397
     /* 1499397 */   GIM_Try, /*On fail goto*//*Label 20909*/ GIMT_Encode4(1499494), // Rule ID 62060 //
     /* 1499402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1499413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1499416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1499419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1499425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499452 */     // MIs[1] Operand 1
     /* 1499452 */     // No operand predicates
     /* 1499452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499456 */     // MIs[0] policy
     /* 1499456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499468 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1499471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499493 */     // GIR_Coverage, 62060,
     /* 1499493 */     GIR_EraseRootFromParent_Done,
     /* 1499494 */   // Label 20909: @1499494
     /* 1499494 */   GIM_Try, /*On fail goto*//*Label 20910*/ GIMT_Encode4(1499591), // Rule ID 62061 //
     /* 1499499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1499510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1499513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1499516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1499522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499549 */     // MIs[1] Operand 1
     /* 1499549 */     // No operand predicates
     /* 1499549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499553 */     // MIs[0] policy
     /* 1499553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499565 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1499568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499590 */     // GIR_Coverage, 62061,
     /* 1499590 */     GIR_EraseRootFromParent_Done,
     /* 1499591 */   // Label 20910: @1499591
     /* 1499591 */   GIM_Try, /*On fail goto*//*Label 20911*/ GIMT_Encode4(1499688), // Rule ID 62064 //
     /* 1499596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1499607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1499610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1499613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1499619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499646 */     // MIs[1] Operand 1
     /* 1499646 */     // No operand predicates
     /* 1499646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499650 */     // MIs[0] policy
     /* 1499650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499662 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1499665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499687 */     // GIR_Coverage, 62064,
     /* 1499687 */     GIR_EraseRootFromParent_Done,
     /* 1499688 */   // Label 20911: @1499688
     /* 1499688 */   GIM_Try, /*On fail goto*//*Label 20912*/ GIMT_Encode4(1499785), // Rule ID 62065 //
     /* 1499693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1499704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1499707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1499710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1499716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499743 */     // MIs[1] Operand 1
     /* 1499743 */     // No operand predicates
     /* 1499743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499747 */     // MIs[0] policy
     /* 1499747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499759 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1499762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499784 */     // GIR_Coverage, 62065,
     /* 1499784 */     GIR_EraseRootFromParent_Done,
     /* 1499785 */   // Label 20912: @1499785
     /* 1499785 */   GIM_Try, /*On fail goto*//*Label 20913*/ GIMT_Encode4(1499882), // Rule ID 62068 //
     /* 1499790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1499801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1499804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1499807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1499813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499840 */     // MIs[1] Operand 1
     /* 1499840 */     // No operand predicates
     /* 1499840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499844 */     // MIs[0] policy
     /* 1499844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499856 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499881 */     // GIR_Coverage, 62068,
     /* 1499881 */     GIR_EraseRootFromParent_Done,
     /* 1499882 */   // Label 20913: @1499882
     /* 1499882 */   GIM_Try, /*On fail goto*//*Label 20914*/ GIMT_Encode4(1499979), // Rule ID 62069 //
     /* 1499887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1499898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1499901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1499904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1499910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499937 */     // MIs[1] Operand 1
     /* 1499937 */     // No operand predicates
     /* 1499937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499941 */     // MIs[0] policy
     /* 1499941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499953 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499978 */     // GIR_Coverage, 62069,
     /* 1499978 */     GIR_EraseRootFromParent_Done,
     /* 1499979 */   // Label 20914: @1499979
     /* 1499979 */   GIM_Try, /*On fail goto*//*Label 20915*/ GIMT_Encode4(1500076), // Rule ID 62072 //
     /* 1499984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1499995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1499998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1500001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1500007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500034 */     // MIs[1] Operand 1
     /* 1500034 */     // No operand predicates
     /* 1500034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500038 */     // MIs[0] policy
     /* 1500038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500050 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500075 */     // GIR_Coverage, 62072,
     /* 1500075 */     GIR_EraseRootFromParent_Done,
     /* 1500076 */   // Label 20915: @1500076
     /* 1500076 */   GIM_Try, /*On fail goto*//*Label 20916*/ GIMT_Encode4(1500173), // Rule ID 62073 //
     /* 1500081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1500092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1500095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1500098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1500104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500131 */     // MIs[1] Operand 1
     /* 1500131 */     // No operand predicates
     /* 1500131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500135 */     // MIs[0] policy
     /* 1500135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500147 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500172 */     // GIR_Coverage, 62073,
     /* 1500172 */     GIR_EraseRootFromParent_Done,
     /* 1500173 */   // Label 20916: @1500173
     /* 1500173 */   GIM_Try, /*On fail goto*//*Label 20917*/ GIMT_Encode4(1500270), // Rule ID 62076 //
     /* 1500178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1500189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1500192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1500195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1500201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500228 */     // MIs[1] Operand 1
     /* 1500228 */     // No operand predicates
     /* 1500228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500232 */     // MIs[0] policy
     /* 1500232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500244 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500269 */     // GIR_Coverage, 62076,
     /* 1500269 */     GIR_EraseRootFromParent_Done,
     /* 1500270 */   // Label 20917: @1500270
     /* 1500270 */   GIM_Try, /*On fail goto*//*Label 20918*/ GIMT_Encode4(1500367), // Rule ID 62077 //
     /* 1500275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1500286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1500289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1500292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1500298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500325 */     // MIs[1] Operand 1
     /* 1500325 */     // No operand predicates
     /* 1500325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500329 */     // MIs[0] policy
     /* 1500329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500341 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500366 */     // GIR_Coverage, 62077,
     /* 1500366 */     GIR_EraseRootFromParent_Done,
     /* 1500367 */   // Label 20918: @1500367
     /* 1500367 */   GIM_Try, /*On fail goto*//*Label 20919*/ GIMT_Encode4(1500464), // Rule ID 62080 //
     /* 1500372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1500383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1500386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1500389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500422 */     // MIs[1] Operand 1
     /* 1500422 */     // No operand predicates
     /* 1500422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500426 */     // MIs[0] policy
     /* 1500426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1500441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500463 */     // GIR_Coverage, 62080,
     /* 1500463 */     GIR_EraseRootFromParent_Done,
     /* 1500464 */   // Label 20919: @1500464
     /* 1500464 */   GIM_Try, /*On fail goto*//*Label 20920*/ GIMT_Encode4(1500561), // Rule ID 62081 //
     /* 1500469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1500480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1500483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1500486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500519 */     // MIs[1] Operand 1
     /* 1500519 */     // No operand predicates
     /* 1500519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500523 */     // MIs[0] policy
     /* 1500523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500535 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1500538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500560 */     // GIR_Coverage, 62081,
     /* 1500560 */     GIR_EraseRootFromParent_Done,
     /* 1500561 */   // Label 20920: @1500561
     /* 1500561 */   GIM_Try, /*On fail goto*//*Label 20921*/ GIMT_Encode4(1500658), // Rule ID 62084 //
     /* 1500566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1500577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1500580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1500583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500616 */     // MIs[1] Operand 1
     /* 1500616 */     // No operand predicates
     /* 1500616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500620 */     // MIs[0] policy
     /* 1500620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500632 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500657 */     // GIR_Coverage, 62084,
     /* 1500657 */     GIR_EraseRootFromParent_Done,
     /* 1500658 */   // Label 20921: @1500658
     /* 1500658 */   GIM_Try, /*On fail goto*//*Label 20922*/ GIMT_Encode4(1500755), // Rule ID 62085 //
     /* 1500663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1500674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1500677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1500680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500713 */     // MIs[1] Operand 1
     /* 1500713 */     // No operand predicates
     /* 1500713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500717 */     // MIs[0] policy
     /* 1500717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500729 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500754 */     // GIR_Coverage, 62085,
     /* 1500754 */     GIR_EraseRootFromParent_Done,
     /* 1500755 */   // Label 20922: @1500755
     /* 1500755 */   GIM_Try, /*On fail goto*//*Label 20923*/ GIMT_Encode4(1500852), // Rule ID 62088 //
     /* 1500760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1500771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1500774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1500777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1500783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500810 */     // MIs[1] Operand 1
     /* 1500810 */     // No operand predicates
     /* 1500810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500814 */     // MIs[0] policy
     /* 1500814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500826 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500851 */     // GIR_Coverage, 62088,
     /* 1500851 */     GIR_EraseRootFromParent_Done,
     /* 1500852 */   // Label 20923: @1500852
     /* 1500852 */   GIM_Try, /*On fail goto*//*Label 20924*/ GIMT_Encode4(1500949), // Rule ID 62089 //
     /* 1500857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1500868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1500871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1500874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1500880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500907 */     // MIs[1] Operand 1
     /* 1500907 */     // No operand predicates
     /* 1500907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500911 */     // MIs[0] policy
     /* 1500911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500923 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500948 */     // GIR_Coverage, 62089,
     /* 1500948 */     GIR_EraseRootFromParent_Done,
     /* 1500949 */   // Label 20924: @1500949
     /* 1500949 */   GIM_Try, /*On fail goto*//*Label 20925*/ GIMT_Encode4(1501046), // Rule ID 62092 //
     /* 1500954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1500965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1500968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1500971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1500977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501004 */     // MIs[1] Operand 1
     /* 1501004 */     // No operand predicates
     /* 1501004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501008 */     // MIs[0] policy
     /* 1501008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501020 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1501023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501045 */     // GIR_Coverage, 62092,
     /* 1501045 */     GIR_EraseRootFromParent_Done,
     /* 1501046 */   // Label 20925: @1501046
     /* 1501046 */   GIM_Try, /*On fail goto*//*Label 20926*/ GIMT_Encode4(1501143), // Rule ID 62093 //
     /* 1501051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1501054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1501062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1501065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1501068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1501071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1501074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1501081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501101 */     // MIs[1] Operand 1
     /* 1501101 */     // No operand predicates
     /* 1501101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501105 */     // MIs[0] policy
     /* 1501105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501117 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1501120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501142 */     // GIR_Coverage, 62093,
     /* 1501142 */     GIR_EraseRootFromParent_Done,
     /* 1501143 */   // Label 20926: @1501143
     /* 1501143 */   GIM_Try, /*On fail goto*//*Label 20927*/ GIMT_Encode4(1501240), // Rule ID 62096 //
     /* 1501148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1501151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1501159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1501162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1501165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1501168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1501171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1501178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501198 */     // MIs[1] Operand 1
     /* 1501198 */     // No operand predicates
     /* 1501198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501202 */     // MIs[0] policy
     /* 1501202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501214 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1501217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501239 */     // GIR_Coverage, 62096,
     /* 1501239 */     GIR_EraseRootFromParent_Done,
     /* 1501240 */   // Label 20927: @1501240
     /* 1501240 */   GIM_Try, /*On fail goto*//*Label 20928*/ GIMT_Encode4(1501337), // Rule ID 62097 //
     /* 1501245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1501248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1501256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1501259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1501262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1501265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1501268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1501275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501295 */     // MIs[1] Operand 1
     /* 1501295 */     // No operand predicates
     /* 1501295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501299 */     // MIs[0] policy
     /* 1501299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501311 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1501314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501336 */     // GIR_Coverage, 62097,
     /* 1501336 */     GIR_EraseRootFromParent_Done,
     /* 1501337 */   // Label 20928: @1501337
     /* 1501337 */   GIM_Try, /*On fail goto*//*Label 20929*/ GIMT_Encode4(1501434), // Rule ID 62100 //
     /* 1501342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1501345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1501353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1501356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1501359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1501362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1501365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1501372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501392 */     // MIs[1] Operand 1
     /* 1501392 */     // No operand predicates
     /* 1501392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501396 */     // MIs[0] policy
     /* 1501396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1501411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501433 */     // GIR_Coverage, 62100,
     /* 1501433 */     GIR_EraseRootFromParent_Done,
     /* 1501434 */   // Label 20929: @1501434
     /* 1501434 */   GIM_Try, /*On fail goto*//*Label 20930*/ GIMT_Encode4(1501531), // Rule ID 62101 //
     /* 1501439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1501442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1501450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1501453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1501456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1501459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1501462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1501469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501489 */     // MIs[1] Operand 1
     /* 1501489 */     // No operand predicates
     /* 1501489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501493 */     // MIs[0] policy
     /* 1501493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501505 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1501508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501530 */     // GIR_Coverage, 62101,
     /* 1501530 */     GIR_EraseRootFromParent_Done,
     /* 1501531 */   // Label 20930: @1501531
     /* 1501531 */   GIM_Try, /*On fail goto*//*Label 20931*/ GIMT_Encode4(1501613), // Rule ID 2720 //
     /* 1501536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1501544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501575 */     // MIs[0] round
     /* 1501575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501578 */     // MIs[0] policy
     /* 1501578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501588 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1501591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501612 */     // GIR_Coverage, 2720,
     /* 1501612 */     GIR_EraseRootFromParent_Done,
     /* 1501613 */   // Label 20931: @1501613
     /* 1501613 */   GIM_Try, /*On fail goto*//*Label 20932*/ GIMT_Encode4(1501695), // Rule ID 2721 //
     /* 1501618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1501626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501657 */     // MIs[0] round
     /* 1501657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501660 */     // MIs[0] policy
     /* 1501660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501670 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1501673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501694 */     // GIR_Coverage, 2721,
     /* 1501694 */     GIR_EraseRootFromParent_Done,
     /* 1501695 */   // Label 20932: @1501695
     /* 1501695 */   GIM_Try, /*On fail goto*//*Label 20933*/ GIMT_Encode4(1501777), // Rule ID 2756 //
     /* 1501700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1501703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1501708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501739 */     // MIs[0] round
     /* 1501739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501742 */     // MIs[0] policy
     /* 1501742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501752 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1501755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501776 */     // GIR_Coverage, 2756,
     /* 1501776 */     GIR_EraseRootFromParent_Done,
     /* 1501777 */   // Label 20933: @1501777
     /* 1501777 */   GIM_Try, /*On fail goto*//*Label 20934*/ GIMT_Encode4(1501859), // Rule ID 2757 //
     /* 1501782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1501785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1501790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501821 */     // MIs[0] round
     /* 1501821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501824 */     // MIs[0] policy
     /* 1501824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501834 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1501837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501858 */     // GIR_Coverage, 2757,
     /* 1501858 */     GIR_EraseRootFromParent_Done,
     /* 1501859 */   // Label 20934: @1501859
     /* 1501859 */   GIM_Try, /*On fail goto*//*Label 20935*/ GIMT_Encode4(1501941), // Rule ID 2788 //
     /* 1501864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1501884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501903 */     // MIs[0] round
     /* 1501903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501906 */     // MIs[0] policy
     /* 1501906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501916 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1501919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501940 */     // GIR_Coverage, 2788,
     /* 1501940 */     GIR_EraseRootFromParent_Done,
     /* 1501941 */   // Label 20935: @1501941
     /* 1501941 */   GIM_Try, /*On fail goto*//*Label 20936*/ GIMT_Encode4(1502023), // Rule ID 2789 //
     /* 1501946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1501966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501985 */     // MIs[0] round
     /* 1501985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501988 */     // MIs[0] policy
     /* 1501988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501998 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1502001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502022 */     // GIR_Coverage, 2789,
     /* 1502022 */     GIR_EraseRootFromParent_Done,
     /* 1502023 */   // Label 20936: @1502023
     /* 1502023 */   GIM_Try, /*On fail goto*//*Label 20937*/ GIMT_Encode4(1502105), // Rule ID 17768 //
     /* 1502028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1502039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1502042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1502045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1502048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502067 */     // MIs[0] round
     /* 1502067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502070 */     // MIs[0] policy
     /* 1502070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502080 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1502083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502104 */     // GIR_Coverage, 17768,
     /* 1502104 */     GIR_EraseRootFromParent_Done,
     /* 1502105 */   // Label 20937: @1502105
     /* 1502105 */   GIM_Try, /*On fail goto*//*Label 20938*/ GIMT_Encode4(1502187), // Rule ID 17769 //
     /* 1502110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1502121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1502124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1502127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1502130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502149 */     // MIs[0] round
     /* 1502149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502152 */     // MIs[0] policy
     /* 1502152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502162 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1502165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502186 */     // GIR_Coverage, 17769,
     /* 1502186 */     GIR_EraseRootFromParent_Done,
     /* 1502187 */   // Label 20938: @1502187
     /* 1502187 */   GIM_Try, /*On fail goto*//*Label 20939*/ GIMT_Encode4(1502269), // Rule ID 17772 //
     /* 1502192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1502195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1502203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1502206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1502209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1502212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502231 */     // MIs[0] round
     /* 1502231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502234 */     // MIs[0] policy
     /* 1502234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502244 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1502247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502268 */     // GIR_Coverage, 17772,
     /* 1502268 */     GIR_EraseRootFromParent_Done,
     /* 1502269 */   // Label 20939: @1502269
     /* 1502269 */   GIM_Try, /*On fail goto*//*Label 20940*/ GIMT_Encode4(1502351), // Rule ID 17773 //
     /* 1502274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1502277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1502285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1502288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1502291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1502294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502313 */     // MIs[0] round
     /* 1502313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502316 */     // MIs[0] policy
     /* 1502316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502326 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1502329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502350 */     // GIR_Coverage, 17773,
     /* 1502350 */     GIR_EraseRootFromParent_Done,
     /* 1502351 */   // Label 20940: @1502351
     /* 1502351 */   GIM_Try, /*On fail goto*//*Label 20941*/ GIMT_Encode4(1502433), // Rule ID 17776 //
     /* 1502356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1502367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1502370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1502373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1502376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502395 */     // MIs[0] round
     /* 1502395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502398 */     // MIs[0] policy
     /* 1502398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502408 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1502411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502432 */     // GIR_Coverage, 17776,
     /* 1502432 */     GIR_EraseRootFromParent_Done,
     /* 1502433 */   // Label 20941: @1502433
     /* 1502433 */   GIM_Try, /*On fail goto*//*Label 20942*/ GIMT_Encode4(1502515), // Rule ID 17777 //
     /* 1502438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1502449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1502452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1502455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1502458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502477 */     // MIs[0] round
     /* 1502477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502480 */     // MIs[0] policy
     /* 1502480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502490 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1502493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502514 */     // GIR_Coverage, 17777,
     /* 1502514 */     GIR_EraseRootFromParent_Done,
     /* 1502515 */   // Label 20942: @1502515
     /* 1502515 */   GIM_Try, /*On fail goto*//*Label 20943*/ GIMT_Encode4(1502597), // Rule ID 17780 //
     /* 1502520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1502523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1502537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1502540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502559 */     // MIs[0] round
     /* 1502559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502562 */     // MIs[0] policy
     /* 1502562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502572 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1502575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502596 */     // GIR_Coverage, 17780,
     /* 1502596 */     GIR_EraseRootFromParent_Done,
     /* 1502597 */   // Label 20943: @1502597
     /* 1502597 */   GIM_Try, /*On fail goto*//*Label 20944*/ GIMT_Encode4(1502679), // Rule ID 17781 //
     /* 1502602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1502605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1502619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1502622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502641 */     // MIs[0] round
     /* 1502641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502644 */     // MIs[0] policy
     /* 1502644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502654 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1502657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502678 */     // GIR_Coverage, 17781,
     /* 1502678 */     GIR_EraseRootFromParent_Done,
     /* 1502679 */   // Label 20944: @1502679
     /* 1502679 */   GIM_Try, /*On fail goto*//*Label 20945*/ GIMT_Encode4(1502761), // Rule ID 17784 //
     /* 1502684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1502687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1502701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1502704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502723 */     // MIs[0] round
     /* 1502723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502726 */     // MIs[0] policy
     /* 1502726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502736 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1502739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502760 */     // GIR_Coverage, 17784,
     /* 1502760 */     GIR_EraseRootFromParent_Done,
     /* 1502761 */   // Label 20945: @1502761
     /* 1502761 */   GIM_Try, /*On fail goto*//*Label 20946*/ GIMT_Encode4(1502843), // Rule ID 17785 //
     /* 1502766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1502769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1502783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1502786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502805 */     // MIs[0] round
     /* 1502805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502808 */     // MIs[0] policy
     /* 1502808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502818 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1502821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502842 */     // GIR_Coverage, 17785,
     /* 1502842 */     GIR_EraseRootFromParent_Done,
     /* 1502843 */   // Label 20946: @1502843
     /* 1502843 */   GIM_Try, /*On fail goto*//*Label 20947*/ GIMT_Encode4(1502925), // Rule ID 17788 //
     /* 1502848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1502859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1502862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1502865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1502868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502887 */     // MIs[0] round
     /* 1502887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502890 */     // MIs[0] policy
     /* 1502890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502900 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1502903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502924 */     // GIR_Coverage, 17788,
     /* 1502924 */     GIR_EraseRootFromParent_Done,
     /* 1502925 */   // Label 20947: @1502925
     /* 1502925 */   GIM_Try, /*On fail goto*//*Label 20948*/ GIMT_Encode4(1503007), // Rule ID 17789 //
     /* 1502930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1502941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1502944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1502947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1502950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502969 */     // MIs[0] round
     /* 1502969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502972 */     // MIs[0] policy
     /* 1502972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502982 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1502985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503006 */     // GIR_Coverage, 17789,
     /* 1503006 */     GIR_EraseRootFromParent_Done,
     /* 1503007 */   // Label 20948: @1503007
     /* 1503007 */   GIM_Try, /*On fail goto*//*Label 20949*/ GIMT_Encode4(1503089), // Rule ID 17792 //
     /* 1503012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1503015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1503023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1503026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1503029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1503032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503051 */     // MIs[0] round
     /* 1503051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503054 */     // MIs[0] policy
     /* 1503054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503064 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1503067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503088 */     // GIR_Coverage, 17792,
     /* 1503088 */     GIR_EraseRootFromParent_Done,
     /* 1503089 */   // Label 20949: @1503089
     /* 1503089 */   GIM_Try, /*On fail goto*//*Label 20950*/ GIMT_Encode4(1503171), // Rule ID 17793 //
     /* 1503094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1503097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1503105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1503108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1503111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1503114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503133 */     // MIs[0] round
     /* 1503133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503136 */     // MIs[0] policy
     /* 1503136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503146 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1503149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503170 */     // GIR_Coverage, 17793,
     /* 1503170 */     GIR_EraseRootFromParent_Done,
     /* 1503171 */   // Label 20950: @1503171
     /* 1503171 */   GIM_Try, /*On fail goto*//*Label 20951*/ GIMT_Encode4(1503253), // Rule ID 17796 //
     /* 1503176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1503179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1503187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1503190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1503193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1503196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503215 */     // MIs[0] round
     /* 1503215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503218 */     // MIs[0] policy
     /* 1503218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503228 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1503231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503252 */     // GIR_Coverage, 17796,
     /* 1503252 */     GIR_EraseRootFromParent_Done,
     /* 1503253 */   // Label 20951: @1503253
     /* 1503253 */   GIM_Try, /*On fail goto*//*Label 20952*/ GIMT_Encode4(1503335), // Rule ID 17797 //
     /* 1503258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1503261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1503269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1503272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1503275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1503278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503297 */     // MIs[0] round
     /* 1503297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503300 */     // MIs[0] policy
     /* 1503300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503310 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1503313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503334 */     // GIR_Coverage, 17797,
     /* 1503334 */     GIR_EraseRootFromParent_Done,
     /* 1503335 */   // Label 20952: @1503335
     /* 1503335 */   GIM_Try, /*On fail goto*//*Label 20953*/ GIMT_Encode4(1503417), // Rule ID 17800 //
     /* 1503340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1503351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1503354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1503357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1503360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503379 */     // MIs[0] round
     /* 1503379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503382 */     // MIs[0] policy
     /* 1503382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503392 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1503395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503416 */     // GIR_Coverage, 17800,
     /* 1503416 */     GIR_EraseRootFromParent_Done,
     /* 1503417 */   // Label 20953: @1503417
     /* 1503417 */   GIM_Try, /*On fail goto*//*Label 20954*/ GIMT_Encode4(1503499), // Rule ID 17801 //
     /* 1503422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1503433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1503436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1503439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1503442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503461 */     // MIs[0] round
     /* 1503461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503464 */     // MIs[0] policy
     /* 1503464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503474 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1503477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503498 */     // GIR_Coverage, 17801,
     /* 1503498 */     GIR_EraseRootFromParent_Done,
     /* 1503499 */   // Label 20954: @1503499
     /* 1503499 */   GIM_Try, /*On fail goto*//*Label 20955*/ GIMT_Encode4(1503581), // Rule ID 17804 //
     /* 1503504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1503521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503543 */     // MIs[0] round
     /* 1503543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503546 */     // MIs[0] policy
     /* 1503546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503556 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1503559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503580 */     // GIR_Coverage, 17804,
     /* 1503580 */     GIR_EraseRootFromParent_Done,
     /* 1503581 */   // Label 20955: @1503581
     /* 1503581 */   GIM_Try, /*On fail goto*//*Label 20956*/ GIMT_Encode4(1503663), // Rule ID 17805 //
     /* 1503586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1503603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503625 */     // MIs[0] round
     /* 1503625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503628 */     // MIs[0] policy
     /* 1503628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503638 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1503641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503662 */     // GIR_Coverage, 17805,
     /* 1503662 */     GIR_EraseRootFromParent_Done,
     /* 1503663 */   // Label 20956: @1503663
     /* 1503663 */   GIM_Try, /*On fail goto*//*Label 20957*/ GIMT_Encode4(1503745), // Rule ID 17808 //
     /* 1503668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1503682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1503685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1503688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503707 */     // MIs[0] round
     /* 1503707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503710 */     // MIs[0] policy
     /* 1503710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503720 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1503723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503744 */     // GIR_Coverage, 17808,
     /* 1503744 */     GIR_EraseRootFromParent_Done,
     /* 1503745 */   // Label 20957: @1503745
     /* 1503745 */   GIM_Try, /*On fail goto*//*Label 20958*/ GIMT_Encode4(1503827), // Rule ID 17809 //
     /* 1503750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1503764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1503767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1503770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503789 */     // MIs[0] round
     /* 1503789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503792 */     // MIs[0] policy
     /* 1503792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503802 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1503805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503826 */     // GIR_Coverage, 17809,
     /* 1503826 */     GIR_EraseRootFromParent_Done,
     /* 1503827 */   // Label 20958: @1503827
     /* 1503827 */   GIM_Try, /*On fail goto*//*Label 20959*/ GIMT_Encode4(1503909), // Rule ID 17812 //
     /* 1503832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1503843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1503846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1503849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1503852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503871 */     // MIs[0] round
     /* 1503871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503874 */     // MIs[0] policy
     /* 1503874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503884 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1503887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503908 */     // GIR_Coverage, 17812,
     /* 1503908 */     GIR_EraseRootFromParent_Done,
     /* 1503909 */   // Label 20959: @1503909
     /* 1503909 */   GIM_Try, /*On fail goto*//*Label 20960*/ GIMT_Encode4(1503991), // Rule ID 17813 //
     /* 1503914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1503917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1503925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1503928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1503931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1503934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503953 */     // MIs[0] round
     /* 1503953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503956 */     // MIs[0] policy
     /* 1503956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503966 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1503969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503990 */     // GIR_Coverage, 17813,
     /* 1503990 */     GIR_EraseRootFromParent_Done,
     /* 1503991 */   // Label 20960: @1503991
     /* 1503991 */   GIM_Try, /*On fail goto*//*Label 20961*/ GIMT_Encode4(1504073), // Rule ID 17816 //
     /* 1503996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1504007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1504010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1504013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1504016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504035 */     // MIs[0] round
     /* 1504035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504038 */     // MIs[0] policy
     /* 1504038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504048 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1504051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504072 */     // GIR_Coverage, 17816,
     /* 1504072 */     GIR_EraseRootFromParent_Done,
     /* 1504073 */   // Label 20961: @1504073
     /* 1504073 */   GIM_Try, /*On fail goto*//*Label 20962*/ GIMT_Encode4(1504155), // Rule ID 17817 //
     /* 1504078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1504081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1504089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1504092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1504095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1504098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504117 */     // MIs[0] round
     /* 1504117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504120 */     // MIs[0] policy
     /* 1504120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504130 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1504133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504154 */     // GIR_Coverage, 17817,
     /* 1504154 */     GIR_EraseRootFromParent_Done,
     /* 1504155 */   // Label 20962: @1504155
     /* 1504155 */   GIM_Try, /*On fail goto*//*Label 20963*/ GIMT_Encode4(1504237), // Rule ID 17820 //
     /* 1504160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1504163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1504171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1504174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1504177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1504180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504199 */     // MIs[0] round
     /* 1504199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504202 */     // MIs[0] policy
     /* 1504202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504212 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1504215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504236 */     // GIR_Coverage, 17820,
     /* 1504236 */     GIR_EraseRootFromParent_Done,
     /* 1504237 */   // Label 20963: @1504237
     /* 1504237 */   GIM_Try, /*On fail goto*//*Label 20964*/ GIMT_Encode4(1504319), // Rule ID 17821 //
     /* 1504242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1504245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1504253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1504256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1504259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1504262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504281 */     // MIs[0] round
     /* 1504281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504284 */     // MIs[0] policy
     /* 1504284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504294 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1504297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504318 */     // GIR_Coverage, 17821,
     /* 1504318 */     GIR_EraseRootFromParent_Done,
     /* 1504319 */   // Label 20964: @1504319
     /* 1504319 */   GIM_Try, /*On fail goto*//*Label 20965*/ GIMT_Encode4(1504401), // Rule ID 17824 //
     /* 1504324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1504335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1504338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1504344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504363 */     // MIs[0] round
     /* 1504363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504366 */     // MIs[0] policy
     /* 1504366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504376 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1504379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504400 */     // GIR_Coverage, 17824,
     /* 1504400 */     GIR_EraseRootFromParent_Done,
     /* 1504401 */   // Label 20965: @1504401
     /* 1504401 */   GIM_Try, /*On fail goto*//*Label 20966*/ GIMT_Encode4(1504483), // Rule ID 17825 //
     /* 1504406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1504417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1504420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1504426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504445 */     // MIs[0] round
     /* 1504445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504448 */     // MIs[0] policy
     /* 1504448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504458 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1504461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504482 */     // GIR_Coverage, 17825,
     /* 1504482 */     GIR_EraseRootFromParent_Done,
     /* 1504483 */   // Label 20966: @1504483
     /* 1504483 */   GIM_Try, /*On fail goto*//*Label 20967*/ GIMT_Encode4(1504565), // Rule ID 17828 //
     /* 1504488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1504508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504527 */     // MIs[0] round
     /* 1504527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504530 */     // MIs[0] policy
     /* 1504530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504540 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1504543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504564 */     // GIR_Coverage, 17828,
     /* 1504564 */     GIR_EraseRootFromParent_Done,
     /* 1504565 */   // Label 20967: @1504565
     /* 1504565 */   GIM_Try, /*On fail goto*//*Label 20968*/ GIMT_Encode4(1504647), // Rule ID 17829 //
     /* 1504570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1504590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504609 */     // MIs[0] round
     /* 1504609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504612 */     // MIs[0] policy
     /* 1504612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504622 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1504625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504646 */     // GIR_Coverage, 17829,
     /* 1504646 */     GIR_EraseRootFromParent_Done,
     /* 1504647 */   // Label 20968: @1504647
     /* 1504647 */   GIM_Try, /*On fail goto*//*Label 20969*/ GIMT_Encode4(1504729), // Rule ID 17832 //
     /* 1504652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1504655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1504663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1504666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1504672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504691 */     // MIs[0] round
     /* 1504691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504694 */     // MIs[0] policy
     /* 1504694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504704 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1504707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504728 */     // GIR_Coverage, 17832,
     /* 1504728 */     GIR_EraseRootFromParent_Done,
     /* 1504729 */   // Label 20969: @1504729
     /* 1504729 */   GIM_Try, /*On fail goto*//*Label 20970*/ GIMT_Encode4(1504811), // Rule ID 17833 //
     /* 1504734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1504737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1504745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1504748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1504754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504773 */     // MIs[0] round
     /* 1504773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504776 */     // MIs[0] policy
     /* 1504776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504786 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1504789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504810 */     // GIR_Coverage, 17833,
     /* 1504810 */     GIR_EraseRootFromParent_Done,
     /* 1504811 */   // Label 20970: @1504811
     /* 1504811 */   GIM_Try, /*On fail goto*//*Label 20971*/ GIMT_Encode4(1504893), // Rule ID 17836 //
     /* 1504816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1504827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1504830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1504836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504855 */     // MIs[0] round
     /* 1504855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504858 */     // MIs[0] policy
     /* 1504858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504868 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1504871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504892 */     // GIR_Coverage, 17836,
     /* 1504892 */     GIR_EraseRootFromParent_Done,
     /* 1504893 */   // Label 20971: @1504893
     /* 1504893 */   GIM_Try, /*On fail goto*//*Label 20972*/ GIMT_Encode4(1504975), // Rule ID 17837 //
     /* 1504898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1504909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1504912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1504918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504937 */     // MIs[0] round
     /* 1504937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504940 */     // MIs[0] policy
     /* 1504940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504950 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1504953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504974 */     // GIR_Coverage, 17837,
     /* 1504974 */     GIR_EraseRootFromParent_Done,
     /* 1504975 */   // Label 20972: @1504975
     /* 1504975 */   GIM_Try, /*On fail goto*//*Label 20973*/ GIMT_Encode4(1505057), // Rule ID 17840 //
     /* 1504980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1504983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1504991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1504994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1505000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505019 */     // MIs[0] round
     /* 1505019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505022 */     // MIs[0] policy
     /* 1505022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505032 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1505035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505056 */     // GIR_Coverage, 17840,
     /* 1505056 */     GIR_EraseRootFromParent_Done,
     /* 1505057 */   // Label 20973: @1505057
     /* 1505057 */   GIM_Try, /*On fail goto*//*Label 20974*/ GIMT_Encode4(1505139), // Rule ID 17841 //
     /* 1505062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1505073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1505076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1505082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505101 */     // MIs[0] round
     /* 1505101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505104 */     // MIs[0] policy
     /* 1505104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505114 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1505117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505138 */     // GIR_Coverage, 17841,
     /* 1505138 */     GIR_EraseRootFromParent_Done,
     /* 1505139 */   // Label 20974: @1505139
     /* 1505139 */   GIM_Try, /*On fail goto*//*Label 20975*/ GIMT_Encode4(1505221), // Rule ID 17844 //
     /* 1505144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1505147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1505155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1505158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1505161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1505164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1505179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505183 */     // MIs[0] round
     /* 1505183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505186 */     // MIs[0] policy
     /* 1505186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505196 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1505199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505220 */     // GIR_Coverage, 17844,
     /* 1505220 */     GIR_EraseRootFromParent_Done,
     /* 1505221 */   // Label 20975: @1505221
     /* 1505221 */   GIM_Try, /*On fail goto*//*Label 20976*/ GIMT_Encode4(1505303), // Rule ID 17845 //
     /* 1505226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1505229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1505237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1505240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1505243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1505246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1505261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505265 */     // MIs[0] round
     /* 1505265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505268 */     // MIs[0] policy
     /* 1505268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505278 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1505281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505302 */     // GIR_Coverage, 17845,
     /* 1505302 */     GIR_EraseRootFromParent_Done,
     /* 1505303 */   // Label 20976: @1505303
     /* 1505303 */   GIM_Try, /*On fail goto*//*Label 20977*/ GIMT_Encode4(1505385), // Rule ID 17848 //
     /* 1505308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1505319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1505322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1505328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505347 */     // MIs[0] round
     /* 1505347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505350 */     // MIs[0] policy
     /* 1505350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505360 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1505363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505384 */     // GIR_Coverage, 17848,
     /* 1505384 */     GIR_EraseRootFromParent_Done,
     /* 1505385 */   // Label 20977: @1505385
     /* 1505385 */   GIM_Try, /*On fail goto*//*Label 20978*/ GIMT_Encode4(1505467), // Rule ID 17849 //
     /* 1505390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1505401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1505404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1505410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505429 */     // MIs[0] round
     /* 1505429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505432 */     // MIs[0] policy
     /* 1505432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505442 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1505445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505466 */     // GIR_Coverage, 17849,
     /* 1505466 */     GIR_EraseRootFromParent_Done,
     /* 1505467 */   // Label 20978: @1505467
     /* 1505467 */   GIM_Try, /*On fail goto*//*Label 20979*/ GIMT_Encode4(1505549), // Rule ID 17852 //
     /* 1505472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1505483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1505486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1505492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505511 */     // MIs[0] round
     /* 1505511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505514 */     // MIs[0] policy
     /* 1505514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505524 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1505527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505548 */     // GIR_Coverage, 17852,
     /* 1505548 */     GIR_EraseRootFromParent_Done,
     /* 1505549 */   // Label 20979: @1505549
     /* 1505549 */   GIM_Try, /*On fail goto*//*Label 20980*/ GIMT_Encode4(1505631), // Rule ID 17853 //
     /* 1505554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1505565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1505568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1505574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505593 */     // MIs[0] round
     /* 1505593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505596 */     // MIs[0] policy
     /* 1505596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505606 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1505609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505630 */     // GIR_Coverage, 17853,
     /* 1505630 */     GIR_EraseRootFromParent_Done,
     /* 1505631 */   // Label 20980: @1505631
     /* 1505631 */   GIM_Try, /*On fail goto*//*Label 20981*/ GIMT_Encode4(1505713), // Rule ID 17856 //
     /* 1505636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1505647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1505650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1505656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505675 */     // MIs[0] round
     /* 1505675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505678 */     // MIs[0] policy
     /* 1505678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505688 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1505691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505712 */     // GIR_Coverage, 17856,
     /* 1505712 */     GIR_EraseRootFromParent_Done,
     /* 1505713 */   // Label 20981: @1505713
     /* 1505713 */   GIM_Try, /*On fail goto*//*Label 20982*/ GIMT_Encode4(1505795), // Rule ID 17857 //
     /* 1505718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1505729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1505732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1505738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505757 */     // MIs[0] round
     /* 1505757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505760 */     // MIs[0] policy
     /* 1505760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505770 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1505773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505794 */     // GIR_Coverage, 17857,
     /* 1505794 */     GIR_EraseRootFromParent_Done,
     /* 1505795 */   // Label 20982: @1505795
     /* 1505795 */   GIM_Try, /*On fail goto*//*Label 20983*/ GIMT_Encode4(1505877), // Rule ID 17860 //
     /* 1505800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1505811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1505814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1505820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505839 */     // MIs[0] round
     /* 1505839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505842 */     // MIs[0] policy
     /* 1505842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505852 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1505855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505876 */     // GIR_Coverage, 17860,
     /* 1505876 */     GIR_EraseRootFromParent_Done,
     /* 1505877 */   // Label 20983: @1505877
     /* 1505877 */   GIM_Try, /*On fail goto*//*Label 20984*/ GIMT_Encode4(1505959), // Rule ID 17861 //
     /* 1505882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1505893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1505896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1505902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505921 */     // MIs[0] round
     /* 1505921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505924 */     // MIs[0] policy
     /* 1505924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505934 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1505937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505958 */     // GIR_Coverage, 17861,
     /* 1505958 */     GIR_EraseRootFromParent_Done,
     /* 1505959 */   // Label 20984: @1505959
     /* 1505959 */   GIM_Try, /*On fail goto*//*Label 20985*/ GIMT_Encode4(1506041), // Rule ID 17864 //
     /* 1505964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1505975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1505978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1505984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506003 */     // MIs[0] round
     /* 1506003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506006 */     // MIs[0] policy
     /* 1506006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506016 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1506019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506040 */     // GIR_Coverage, 17864,
     /* 1506040 */     GIR_EraseRootFromParent_Done,
     /* 1506041 */   // Label 20985: @1506041
     /* 1506041 */   GIM_Try, /*On fail goto*//*Label 20986*/ GIMT_Encode4(1506123), // Rule ID 17865 //
     /* 1506046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1506049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1506057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1506060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1506063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1506066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1506081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506085 */     // MIs[0] round
     /* 1506085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506088 */     // MIs[0] policy
     /* 1506088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506098 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1506101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506122 */     // GIR_Coverage, 17865,
     /* 1506122 */     GIR_EraseRootFromParent_Done,
     /* 1506123 */   // Label 20986: @1506123
     /* 1506123 */   GIM_Try, /*On fail goto*//*Label 20987*/ GIMT_Encode4(1506205), // Rule ID 17868 //
     /* 1506128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1506131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1506139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1506142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1506145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1506148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1506163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506167 */     // MIs[0] round
     /* 1506167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506170 */     // MIs[0] policy
     /* 1506170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506180 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1506183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506204 */     // GIR_Coverage, 17868,
     /* 1506204 */     GIR_EraseRootFromParent_Done,
     /* 1506205 */   // Label 20987: @1506205
     /* 1506205 */   GIM_Try, /*On fail goto*//*Label 20988*/ GIMT_Encode4(1506287), // Rule ID 17869 //
     /* 1506210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1506213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1506221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1506224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1506227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1506230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1506245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506249 */     // MIs[0] round
     /* 1506249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506252 */     // MIs[0] policy
     /* 1506252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506262 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1506265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506286 */     // GIR_Coverage, 17869,
     /* 1506286 */     GIR_EraseRootFromParent_Done,
     /* 1506287 */   // Label 20988: @1506287
     /* 1506287 */   GIM_Try, /*On fail goto*//*Label 20989*/ GIMT_Encode4(1506369), // Rule ID 17872 //
     /* 1506292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1506303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1506306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1506312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506331 */     // MIs[0] round
     /* 1506331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506334 */     // MIs[0] policy
     /* 1506334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506344 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1506347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506368 */     // GIR_Coverage, 17872,
     /* 1506368 */     GIR_EraseRootFromParent_Done,
     /* 1506369 */   // Label 20989: @1506369
     /* 1506369 */   GIM_Try, /*On fail goto*//*Label 20990*/ GIMT_Encode4(1506451), // Rule ID 17873 //
     /* 1506374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1506385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1506388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1506394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506413 */     // MIs[0] round
     /* 1506413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506416 */     // MIs[0] policy
     /* 1506416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506426 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1506429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506450 */     // GIR_Coverage, 17873,
     /* 1506450 */     GIR_EraseRootFromParent_Done,
     /* 1506451 */   // Label 20990: @1506451
     /* 1506451 */   GIM_Try, /*On fail goto*//*Label 20991*/ GIMT_Encode4(1506533), // Rule ID 17876 //
     /* 1506456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1506467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1506470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1506476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506495 */     // MIs[0] round
     /* 1506495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506498 */     // MIs[0] policy
     /* 1506498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506508 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1506511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506532 */     // GIR_Coverage, 17876,
     /* 1506532 */     GIR_EraseRootFromParent_Done,
     /* 1506533 */   // Label 20991: @1506533
     /* 1506533 */   GIM_Try, /*On fail goto*//*Label 20992*/ GIMT_Encode4(1506615), // Rule ID 17877 //
     /* 1506538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1506549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1506552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1506558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506577 */     // MIs[0] round
     /* 1506577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506580 */     // MIs[0] policy
     /* 1506580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506590 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1506593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506614 */     // GIR_Coverage, 17877,
     /* 1506614 */     GIR_EraseRootFromParent_Done,
     /* 1506615 */   // Label 20992: @1506615
     /* 1506615 */   GIM_Try, /*On fail goto*//*Label 20993*/ GIMT_Encode4(1506697), // Rule ID 17880 //
     /* 1506620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1506631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1506634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1506640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506659 */     // MIs[0] round
     /* 1506659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506662 */     // MIs[0] policy
     /* 1506662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506672 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1506675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506696 */     // GIR_Coverage, 17880,
     /* 1506696 */     GIR_EraseRootFromParent_Done,
     /* 1506697 */   // Label 20993: @1506697
     /* 1506697 */   GIM_Try, /*On fail goto*//*Label 20994*/ GIMT_Encode4(1506779), // Rule ID 17881 //
     /* 1506702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1506713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1506716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1506722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506741 */     // MIs[0] round
     /* 1506741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506744 */     // MIs[0] policy
     /* 1506744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506754 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1506757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506778 */     // GIR_Coverage, 17881,
     /* 1506778 */     GIR_EraseRootFromParent_Done,
     /* 1506779 */   // Label 20994: @1506779
     /* 1506779 */   GIM_Try, /*On fail goto*//*Label 20995*/ GIMT_Encode4(1506861), // Rule ID 17884 //
     /* 1506784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1506795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1506798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1506801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1506804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506823 */     // MIs[0] round
     /* 1506823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506826 */     // MIs[0] policy
     /* 1506826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506836 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1506839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506860 */     // GIR_Coverage, 17884,
     /* 1506860 */     GIR_EraseRootFromParent_Done,
     /* 1506861 */   // Label 20995: @1506861
     /* 1506861 */   GIM_Try, /*On fail goto*//*Label 20996*/ GIMT_Encode4(1506943), // Rule ID 17885 //
     /* 1506866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1506877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1506880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1506883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1506886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506905 */     // MIs[0] round
     /* 1506905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506908 */     // MIs[0] policy
     /* 1506908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506918 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1506921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506942 */     // GIR_Coverage, 17885,
     /* 1506942 */     GIR_EraseRootFromParent_Done,
     /* 1506943 */   // Label 20996: @1506943
     /* 1506943 */   GIM_Try, /*On fail goto*//*Label 20997*/ GIMT_Encode4(1507025), // Rule ID 17888 //
     /* 1506948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1506959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1506962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1506965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1506968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506987 */     // MIs[0] round
     /* 1506987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506990 */     // MIs[0] policy
     /* 1506990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507000 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1507003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507024 */     // GIR_Coverage, 17888,
     /* 1507024 */     GIR_EraseRootFromParent_Done,
     /* 1507025 */   // Label 20997: @1507025
     /* 1507025 */   GIM_Try, /*On fail goto*//*Label 20998*/ GIMT_Encode4(1507107), // Rule ID 17889 //
     /* 1507030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1507041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1507044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1507047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1507050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507069 */     // MIs[0] round
     /* 1507069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507072 */     // MIs[0] policy
     /* 1507072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507082 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1507085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507106 */     // GIR_Coverage, 17889,
     /* 1507106 */     GIR_EraseRootFromParent_Done,
     /* 1507107 */   // Label 20998: @1507107
     /* 1507107 */   GIM_Try, /*On fail goto*//*Label 20999*/ GIMT_Encode4(1507189), // Rule ID 17892 //
     /* 1507112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1507115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1507123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1507126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1507129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1507132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507151 */     // MIs[0] round
     /* 1507151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507154 */     // MIs[0] policy
     /* 1507154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507164 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1507167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507188 */     // GIR_Coverage, 17892,
     /* 1507188 */     GIR_EraseRootFromParent_Done,
     /* 1507189 */   // Label 20999: @1507189
     /* 1507189 */   GIM_Try, /*On fail goto*//*Label 21000*/ GIMT_Encode4(1507271), // Rule ID 17893 //
     /* 1507194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1507197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1507205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1507208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1507211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1507214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507233 */     // MIs[0] round
     /* 1507233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507236 */     // MIs[0] policy
     /* 1507236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507246 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1507249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507270 */     // GIR_Coverage, 17893,
     /* 1507270 */     GIR_EraseRootFromParent_Done,
     /* 1507271 */   // Label 21000: @1507271
     /* 1507271 */   GIM_Try, /*On fail goto*//*Label 21001*/ GIMT_Encode4(1507353), // Rule ID 17896 //
     /* 1507276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1507287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1507290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1507293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1507296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507315 */     // MIs[0] round
     /* 1507315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507318 */     // MIs[0] policy
     /* 1507318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507328 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11296:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1507331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507352 */     // GIR_Coverage, 17896,
     /* 1507352 */     GIR_EraseRootFromParent_Done,
     /* 1507353 */   // Label 21001: @1507353
     /* 1507353 */   GIM_Try, /*On fail goto*//*Label 21002*/ GIMT_Encode4(1507435), // Rule ID 17897 //
     /* 1507358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1507369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1507372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1507375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1507378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507397 */     // MIs[0] round
     /* 1507397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507400 */     // MIs[0] policy
     /* 1507400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507410 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11296:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1507413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507434 */     // GIR_Coverage, 17897,
     /* 1507434 */     GIR_EraseRootFromParent_Done,
     /* 1507435 */   // Label 21002: @1507435
     /* 1507435 */   GIM_Try, /*On fail goto*//*Label 21003*/ GIMT_Encode4(1507517), // Rule ID 17900 //
     /* 1507440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1507443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1507451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1507454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1507457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1507460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507479 */     // MIs[0] round
     /* 1507479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507482 */     // MIs[0] policy
     /* 1507482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507492 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1507495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507516 */     // GIR_Coverage, 17900,
     /* 1507516 */     GIR_EraseRootFromParent_Done,
     /* 1507517 */   // Label 21003: @1507517
     /* 1507517 */   GIM_Try, /*On fail goto*//*Label 21004*/ GIMT_Encode4(1507599), // Rule ID 17901 //
     /* 1507522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1507525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1507533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1507536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1507539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1507542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507561 */     // MIs[0] round
     /* 1507561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507564 */     // MIs[0] policy
     /* 1507564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507574 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1507577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507598 */     // GIR_Coverage, 17901,
     /* 1507598 */     GIR_EraseRootFromParent_Done,
     /* 1507599 */   // Label 21004: @1507599
     /* 1507599 */   GIM_Try, /*On fail goto*//*Label 21005*/ GIMT_Encode4(1507681), // Rule ID 17904 //
     /* 1507604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1507607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1507615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1507618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1507621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1507624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507643 */     // MIs[0] round
     /* 1507643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507646 */     // MIs[0] policy
     /* 1507646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507656 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1507659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507680 */     // GIR_Coverage, 17904,
     /* 1507680 */     GIR_EraseRootFromParent_Done,
     /* 1507681 */   // Label 21005: @1507681
     /* 1507681 */   GIM_Try, /*On fail goto*//*Label 21006*/ GIMT_Encode4(1507763), // Rule ID 17905 //
     /* 1507686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1507689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1507697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1507700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1507703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1507706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507725 */     // MIs[0] round
     /* 1507725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507728 */     // MIs[0] policy
     /* 1507728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507738 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1507741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507762 */     // GIR_Coverage, 17905,
     /* 1507762 */     GIR_EraseRootFromParent_Done,
     /* 1507763 */   // Label 21006: @1507763
     /* 1507763 */   GIM_Try, /*On fail goto*//*Label 21007*/ GIMT_Encode4(1507845), // Rule ID 17908 //
     /* 1507768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1507779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1507782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1507785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1507788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507807 */     // MIs[0] round
     /* 1507807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507810 */     // MIs[0] policy
     /* 1507810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507820 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1507823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507844 */     // GIR_Coverage, 17908,
     /* 1507844 */     GIR_EraseRootFromParent_Done,
     /* 1507845 */   // Label 21007: @1507845
     /* 1507845 */   GIM_Try, /*On fail goto*//*Label 21008*/ GIMT_Encode4(1507927), // Rule ID 17909 //
     /* 1507850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1507861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1507864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1507867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1507870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507889 */     // MIs[0] round
     /* 1507889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507892 */     // MIs[0] policy
     /* 1507892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507902 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1507905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507926 */     // GIR_Coverage, 17909,
     /* 1507926 */     GIR_EraseRootFromParent_Done,
     /* 1507927 */   // Label 21008: @1507927
     /* 1507927 */   GIM_Try, /*On fail goto*//*Label 21009*/ GIMT_Encode4(1508009), // Rule ID 17912 //
     /* 1507932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1507943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1507946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1507949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1507952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507971 */     // MIs[0] round
     /* 1507971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507974 */     // MIs[0] policy
     /* 1507974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507984 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1507987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508008 */     // GIR_Coverage, 17912,
     /* 1508008 */     GIR_EraseRootFromParent_Done,
     /* 1508009 */   // Label 21009: @1508009
     /* 1508009 */   GIM_Try, /*On fail goto*//*Label 21010*/ GIMT_Encode4(1508091), // Rule ID 17913 //
     /* 1508014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1508017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1508025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1508028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1508031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1508034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508053 */     // MIs[0] round
     /* 1508053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508056 */     // MIs[0] policy
     /* 1508056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508066 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1508069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508090 */     // GIR_Coverage, 17913,
     /* 1508090 */     GIR_EraseRootFromParent_Done,
     /* 1508091 */   // Label 21010: @1508091
     /* 1508091 */   GIM_Try, /*On fail goto*//*Label 21011*/ GIMT_Encode4(1508173), // Rule ID 17916 //
     /* 1508096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1508107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1508110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1508113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1508116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508135 */     // MIs[0] round
     /* 1508135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508138 */     // MIs[0] policy
     /* 1508138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508148 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1508151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508172 */     // GIR_Coverage, 17916,
     /* 1508172 */     GIR_EraseRootFromParent_Done,
     /* 1508173 */   // Label 21011: @1508173
     /* 1508173 */   GIM_Try, /*On fail goto*//*Label 21012*/ GIMT_Encode4(1508255), // Rule ID 17917 //
     /* 1508178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1508181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1508189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1508192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1508195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1508198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508217 */     // MIs[0] round
     /* 1508217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508220 */     // MIs[0] policy
     /* 1508220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508230 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1508233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508254 */     // GIR_Coverage, 17917,
     /* 1508254 */     GIR_EraseRootFromParent_Done,
     /* 1508255 */   // Label 21012: @1508255
     /* 1508255 */   GIM_Try, /*On fail goto*//*Label 21013*/ GIMT_Encode4(1508337), // Rule ID 17920 //
     /* 1508260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1508271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1508274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1508277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1508280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508299 */     // MIs[0] round
     /* 1508299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508302 */     // MIs[0] policy
     /* 1508302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508312 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1508315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508336 */     // GIR_Coverage, 17920,
     /* 1508336 */     GIR_EraseRootFromParent_Done,
     /* 1508337 */   // Label 21013: @1508337
     /* 1508337 */   GIM_Try, /*On fail goto*//*Label 21014*/ GIMT_Encode4(1508419), // Rule ID 17921 //
     /* 1508342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1508353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1508356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1508359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1508362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508381 */     // MIs[0] round
     /* 1508381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508384 */     // MIs[0] policy
     /* 1508384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508394 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1508397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508418 */     // GIR_Coverage, 17921,
     /* 1508418 */     GIR_EraseRootFromParent_Done,
     /* 1508419 */   // Label 21014: @1508419
     /* 1508419 */   GIM_Try, /*On fail goto*//*Label 21015*/ GIMT_Encode4(1508501), // Rule ID 17924 //
     /* 1508424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1508435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1508438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1508441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1508444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508463 */     // MIs[0] round
     /* 1508463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508466 */     // MIs[0] policy
     /* 1508466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508476 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1508479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508500 */     // GIR_Coverage, 17924,
     /* 1508500 */     GIR_EraseRootFromParent_Done,
     /* 1508501 */   // Label 21015: @1508501
     /* 1508501 */   GIM_Try, /*On fail goto*//*Label 21016*/ GIMT_Encode4(1508583), // Rule ID 17925 //
     /* 1508506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1508517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1508520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1508523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1508526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508545 */     // MIs[0] round
     /* 1508545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508548 */     // MIs[0] policy
     /* 1508548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508558 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1508561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508582 */     // GIR_Coverage, 17925,
     /* 1508582 */     GIR_EraseRootFromParent_Done,
     /* 1508583 */   // Label 21016: @1508583
     /* 1508583 */   GIM_Try, /*On fail goto*//*Label 21017*/ GIMT_Encode4(1508665), // Rule ID 17928 //
     /* 1508588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1508599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1508602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1508605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1508608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508627 */     // MIs[0] round
     /* 1508627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508630 */     // MIs[0] policy
     /* 1508630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508640 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1508643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508664 */     // GIR_Coverage, 17928,
     /* 1508664 */     GIR_EraseRootFromParent_Done,
     /* 1508665 */   // Label 21017: @1508665
     /* 1508665 */   GIM_Try, /*On fail goto*//*Label 21018*/ GIMT_Encode4(1508747), // Rule ID 17929 //
     /* 1508670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1508681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1508684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1508687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1508690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508709 */     // MIs[0] round
     /* 1508709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508712 */     // MIs[0] policy
     /* 1508712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508722 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1508725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508746 */     // GIR_Coverage, 17929,
     /* 1508746 */     GIR_EraseRootFromParent_Done,
     /* 1508747 */   // Label 21018: @1508747
     /* 1508747 */   GIM_Try, /*On fail goto*//*Label 21019*/ GIMT_Encode4(1508829), // Rule ID 17932 //
     /* 1508752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1508763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1508766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1508769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1508772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508791 */     // MIs[0] round
     /* 1508791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508794 */     // MIs[0] policy
     /* 1508794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508804 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1508807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508828 */     // GIR_Coverage, 17932,
     /* 1508828 */     GIR_EraseRootFromParent_Done,
     /* 1508829 */   // Label 21019: @1508829
     /* 1508829 */   GIM_Try, /*On fail goto*//*Label 21020*/ GIMT_Encode4(1508911), // Rule ID 17933 //
     /* 1508834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1508845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1508848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1508851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1508854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508873 */     // MIs[0] round
     /* 1508873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508876 */     // MIs[0] policy
     /* 1508876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508886 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1508889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508910 */     // GIR_Coverage, 17933,
     /* 1508910 */     GIR_EraseRootFromParent_Done,
     /* 1508911 */   // Label 21020: @1508911
     /* 1508911 */   GIM_Try, /*On fail goto*//*Label 21021*/ GIMT_Encode4(1508993), // Rule ID 17936 //
     /* 1508916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1508927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1508930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1508933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1508936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508955 */     // MIs[0] round
     /* 1508955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508958 */     // MIs[0] policy
     /* 1508958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508968 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1508971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508992 */     // GIR_Coverage, 17936,
     /* 1508992 */     GIR_EraseRootFromParent_Done,
     /* 1508993 */   // Label 21021: @1508993
     /* 1508993 */   GIM_Try, /*On fail goto*//*Label 21022*/ GIMT_Encode4(1509075), // Rule ID 17937 //
     /* 1508998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1509001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1509009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1509012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1509015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1509018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509037 */     // MIs[0] round
     /* 1509037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509040 */     // MIs[0] policy
     /* 1509040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509050 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1509053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509074 */     // GIR_Coverage, 17937,
     /* 1509074 */     GIR_EraseRootFromParent_Done,
     /* 1509075 */   // Label 21022: @1509075
     /* 1509075 */   GIM_Try, /*On fail goto*//*Label 21023*/ GIMT_Encode4(1509157), // Rule ID 17940 //
     /* 1509080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1509083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1509091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1509094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1509097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1509100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509119 */     // MIs[0] round
     /* 1509119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509122 */     // MIs[0] policy
     /* 1509122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509132 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1509135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509156 */     // GIR_Coverage, 17940,
     /* 1509156 */     GIR_EraseRootFromParent_Done,
     /* 1509157 */   // Label 21023: @1509157
     /* 1509157 */   GIM_Try, /*On fail goto*//*Label 21024*/ GIMT_Encode4(1509239), // Rule ID 17941 //
     /* 1509162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1509165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1509173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1509176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1509179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1509182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509201 */     // MIs[0] round
     /* 1509201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509204 */     // MIs[0] policy
     /* 1509204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509214 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1509217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509238 */     // GIR_Coverage, 17941,
     /* 1509238 */     GIR_EraseRootFromParent_Done,
     /* 1509239 */   // Label 21024: @1509239
     /* 1509239 */   GIM_Try, /*On fail goto*//*Label 21025*/ GIMT_Encode4(1509321), // Rule ID 17944 //
     /* 1509244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1509255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1509258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1509264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509283 */     // MIs[0] round
     /* 1509283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509286 */     // MIs[0] policy
     /* 1509286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509296 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1509299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509320 */     // GIR_Coverage, 17944,
     /* 1509320 */     GIR_EraseRootFromParent_Done,
     /* 1509321 */   // Label 21025: @1509321
     /* 1509321 */   GIM_Try, /*On fail goto*//*Label 21026*/ GIMT_Encode4(1509403), // Rule ID 17945 //
     /* 1509326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1509337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1509340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1509346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509365 */     // MIs[0] round
     /* 1509365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509368 */     // MIs[0] policy
     /* 1509368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509378 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1509381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509402 */     // GIR_Coverage, 17945,
     /* 1509402 */     GIR_EraseRootFromParent_Done,
     /* 1509403 */   // Label 21026: @1509403
     /* 1509403 */   GIM_Try, /*On fail goto*//*Label 21027*/ GIMT_Encode4(1509485), // Rule ID 17948 //
     /* 1509408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1509419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1509422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1509428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509447 */     // MIs[0] round
     /* 1509447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509450 */     // MIs[0] policy
     /* 1509450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509460 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1509463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509484 */     // GIR_Coverage, 17948,
     /* 1509484 */     GIR_EraseRootFromParent_Done,
     /* 1509485 */   // Label 21027: @1509485
     /* 1509485 */   GIM_Try, /*On fail goto*//*Label 21028*/ GIMT_Encode4(1509567), // Rule ID 17949 //
     /* 1509490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1509501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1509504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1509510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509529 */     // MIs[0] round
     /* 1509529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509532 */     // MIs[0] policy
     /* 1509532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509542 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1509545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509566 */     // GIR_Coverage, 17949,
     /* 1509566 */     GIR_EraseRootFromParent_Done,
     /* 1509567 */   // Label 21028: @1509567
     /* 1509567 */   GIM_Try, /*On fail goto*//*Label 21029*/ GIMT_Encode4(1509649), // Rule ID 17952 //
     /* 1509572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1509583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1509586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1509592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509611 */     // MIs[0] round
     /* 1509611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509614 */     // MIs[0] policy
     /* 1509614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509624 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1509627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509648 */     // GIR_Coverage, 17952,
     /* 1509648 */     GIR_EraseRootFromParent_Done,
     /* 1509649 */   // Label 21029: @1509649
     /* 1509649 */   GIM_Try, /*On fail goto*//*Label 21030*/ GIMT_Encode4(1509731), // Rule ID 17953 //
     /* 1509654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1509665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1509668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1509674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509693 */     // MIs[0] round
     /* 1509693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509696 */     // MIs[0] policy
     /* 1509696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509706 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1509709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509730 */     // GIR_Coverage, 17953,
     /* 1509730 */     GIR_EraseRootFromParent_Done,
     /* 1509731 */   // Label 21030: @1509731
     /* 1509731 */   GIM_Try, /*On fail goto*//*Label 21031*/ GIMT_Encode4(1509813), // Rule ID 17956 //
     /* 1509736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1509747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1509750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1509756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509775 */     // MIs[0] round
     /* 1509775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509778 */     // MIs[0] policy
     /* 1509778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509788 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11296:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1509791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509812 */     // GIR_Coverage, 17956,
     /* 1509812 */     GIR_EraseRootFromParent_Done,
     /* 1509813 */   // Label 21031: @1509813
     /* 1509813 */   GIM_Try, /*On fail goto*//*Label 21032*/ GIMT_Encode4(1509895), // Rule ID 17957 //
     /* 1509818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1509829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1509832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1509838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509857 */     // MIs[0] round
     /* 1509857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509860 */     // MIs[0] policy
     /* 1509860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509870 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11296:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1509873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509894 */     // GIR_Coverage, 17957,
     /* 1509894 */     GIR_EraseRootFromParent_Done,
     /* 1509895 */   // Label 21032: @1509895
     /* 1509895 */   GIM_Try, /*On fail goto*//*Label 21033*/ GIMT_Encode4(1509977), // Rule ID 17960 //
     /* 1509900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1509911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1509914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1509920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509939 */     // MIs[0] round
     /* 1509939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509942 */     // MIs[0] policy
     /* 1509942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509952 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1509955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509976 */     // GIR_Coverage, 17960,
     /* 1509976 */     GIR_EraseRootFromParent_Done,
     /* 1509977 */   // Label 21033: @1509977
     /* 1509977 */   GIM_Try, /*On fail goto*//*Label 21034*/ GIMT_Encode4(1510059), // Rule ID 17961 //
     /* 1509982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1509993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1509996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1510002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510021 */     // MIs[0] round
     /* 1510021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510024 */     // MIs[0] policy
     /* 1510024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510034 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1510037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510058 */     // GIR_Coverage, 17961,
     /* 1510058 */     GIR_EraseRootFromParent_Done,
     /* 1510059 */   // Label 21034: @1510059
     /* 1510059 */   GIM_Try, /*On fail goto*//*Label 21035*/ GIMT_Encode4(1510141), // Rule ID 17964 //
     /* 1510064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1510067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1510075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1510078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1510081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1510084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1510099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510103 */     // MIs[0] round
     /* 1510103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510106 */     // MIs[0] policy
     /* 1510106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510116 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1510119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510140 */     // GIR_Coverage, 17964,
     /* 1510140 */     GIR_EraseRootFromParent_Done,
     /* 1510141 */   // Label 21035: @1510141
     /* 1510141 */   GIM_Try, /*On fail goto*//*Label 21036*/ GIMT_Encode4(1510223), // Rule ID 17965 //
     /* 1510146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1510149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1510157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1510160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1510163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1510166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1510181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510185 */     // MIs[0] round
     /* 1510185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510188 */     // MIs[0] policy
     /* 1510188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510198 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1510201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510222 */     // GIR_Coverage, 17965,
     /* 1510222 */     GIR_EraseRootFromParent_Done,
     /* 1510223 */   // Label 21036: @1510223
     /* 1510223 */   GIM_Try, /*On fail goto*//*Label 21037*/ GIMT_Encode4(1510305), // Rule ID 17968 //
     /* 1510228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1510239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1510242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1510248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510267 */     // MIs[0] round
     /* 1510267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510270 */     // MIs[0] policy
     /* 1510270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510280 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1510283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510304 */     // GIR_Coverage, 17968,
     /* 1510304 */     GIR_EraseRootFromParent_Done,
     /* 1510305 */   // Label 21037: @1510305
     /* 1510305 */   GIM_Try, /*On fail goto*//*Label 21038*/ GIMT_Encode4(1510387), // Rule ID 17969 //
     /* 1510310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1510321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1510324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1510330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510349 */     // MIs[0] round
     /* 1510349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510352 */     // MIs[0] policy
     /* 1510352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510362 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1510365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510386 */     // GIR_Coverage, 17969,
     /* 1510386 */     GIR_EraseRootFromParent_Done,
     /* 1510387 */   // Label 21038: @1510387
     /* 1510387 */   GIM_Try, /*On fail goto*//*Label 21039*/ GIMT_Encode4(1510469), // Rule ID 17972 //
     /* 1510392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1510403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1510406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1510412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510431 */     // MIs[0] round
     /* 1510431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510434 */     // MIs[0] policy
     /* 1510434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510444 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1510447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510468 */     // GIR_Coverage, 17972,
     /* 1510468 */     GIR_EraseRootFromParent_Done,
     /* 1510469 */   // Label 21039: @1510469
     /* 1510469 */   GIM_Try, /*On fail goto*//*Label 21040*/ GIMT_Encode4(1510551), // Rule ID 17973 //
     /* 1510474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1510485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1510488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1510494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510513 */     // MIs[0] round
     /* 1510513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510516 */     // MIs[0] policy
     /* 1510516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510526 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1510529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510550 */     // GIR_Coverage, 17973,
     /* 1510550 */     GIR_EraseRootFromParent_Done,
     /* 1510551 */   // Label 21040: @1510551
     /* 1510551 */   GIM_Try, /*On fail goto*//*Label 21041*/ GIMT_Encode4(1510633), // Rule ID 17976 //
     /* 1510556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1510576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510595 */     // MIs[0] round
     /* 1510595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510598 */     // MIs[0] policy
     /* 1510598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510608 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1510611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510632 */     // GIR_Coverage, 17976,
     /* 1510632 */     GIR_EraseRootFromParent_Done,
     /* 1510633 */   // Label 21041: @1510633
     /* 1510633 */   GIM_Try, /*On fail goto*//*Label 21042*/ GIMT_Encode4(1510715), // Rule ID 17977 //
     /* 1510638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1510658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510677 */     // MIs[0] round
     /* 1510677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510680 */     // MIs[0] policy
     /* 1510680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510690 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1510693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510714 */     // GIR_Coverage, 17977,
     /* 1510714 */     GIR_EraseRootFromParent_Done,
     /* 1510715 */   // Label 21042: @1510715
     /* 1510715 */   GIM_Try, /*On fail goto*//*Label 21043*/ GIMT_Encode4(1510797), // Rule ID 17980 //
     /* 1510720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1510731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1510734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1510740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510759 */     // MIs[0] round
     /* 1510759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510762 */     // MIs[0] policy
     /* 1510762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510772 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1510775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510796 */     // GIR_Coverage, 17980,
     /* 1510796 */     GIR_EraseRootFromParent_Done,
     /* 1510797 */   // Label 21043: @1510797
     /* 1510797 */   GIM_Try, /*On fail goto*//*Label 21044*/ GIMT_Encode4(1510879), // Rule ID 17981 //
     /* 1510802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1510813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1510816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1510822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510841 */     // MIs[0] round
     /* 1510841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510844 */     // MIs[0] policy
     /* 1510844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510854 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1510857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510878 */     // GIR_Coverage, 17981,
     /* 1510878 */     GIR_EraseRootFromParent_Done,
     /* 1510879 */   // Label 21044: @1510879
     /* 1510879 */   GIM_Try, /*On fail goto*//*Label 21045*/ GIMT_Encode4(1510961), // Rule ID 17984 //
     /* 1510884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1510895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1510898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1510904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510923 */     // MIs[0] round
     /* 1510923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510926 */     // MIs[0] policy
     /* 1510926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510936 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1510939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510960 */     // GIR_Coverage, 17984,
     /* 1510960 */     GIR_EraseRootFromParent_Done,
     /* 1510961 */   // Label 21045: @1510961
     /* 1510961 */   GIM_Try, /*On fail goto*//*Label 21046*/ GIMT_Encode4(1511043), // Rule ID 17985 //
     /* 1510966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1510977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1510980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1510986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1511001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511005 */     // MIs[0] round
     /* 1511005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511008 */     // MIs[0] policy
     /* 1511008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511018 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1511021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511042 */     // GIR_Coverage, 17985,
     /* 1511042 */     GIR_EraseRootFromParent_Done,
     /* 1511043 */   // Label 21046: @1511043
     /* 1511043 */   GIM_Try, /*On fail goto*//*Label 21047*/ GIMT_Encode4(1511125), // Rule ID 17988 //
     /* 1511048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1511059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1511062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1511065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1511068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1511083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511087 */     // MIs[0] round
     /* 1511087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511090 */     // MIs[0] policy
     /* 1511090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511100 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1511103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511124 */     // GIR_Coverage, 17988,
     /* 1511124 */     GIR_EraseRootFromParent_Done,
     /* 1511125 */   // Label 21047: @1511125
     /* 1511125 */   GIM_Try, /*On fail goto*//*Label 21048*/ GIMT_Encode4(1511207), // Rule ID 17989 //
     /* 1511130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1511133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1511141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1511144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1511147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1511150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1511165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511169 */     // MIs[0] round
     /* 1511169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511172 */     // MIs[0] policy
     /* 1511172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511182 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1511185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511206 */     // GIR_Coverage, 17989,
     /* 1511206 */     GIR_EraseRootFromParent_Done,
     /* 1511207 */   // Label 21048: @1511207
     /* 1511207 */   GIM_Try, /*On fail goto*//*Label 21049*/ GIMT_Encode4(1511289), // Rule ID 17992 //
     /* 1511212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1511223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1511226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1511232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511251 */     // MIs[0] round
     /* 1511251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511254 */     // MIs[0] policy
     /* 1511254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511264 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1511267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511288 */     // GIR_Coverage, 17992,
     /* 1511288 */     GIR_EraseRootFromParent_Done,
     /* 1511289 */   // Label 21049: @1511289
     /* 1511289 */   GIM_Try, /*On fail goto*//*Label 21050*/ GIMT_Encode4(1511371), // Rule ID 17993 //
     /* 1511294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1511305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1511308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1511314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511333 */     // MIs[0] round
     /* 1511333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511336 */     // MIs[0] policy
     /* 1511336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511346 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1511349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511370 */     // GIR_Coverage, 17993,
     /* 1511370 */     GIR_EraseRootFromParent_Done,
     /* 1511371 */   // Label 21050: @1511371
     /* 1511371 */   GIM_Try, /*On fail goto*//*Label 21051*/ GIMT_Encode4(1511453), // Rule ID 17996 //
     /* 1511376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1511387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1511390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1511396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511415 */     // MIs[0] round
     /* 1511415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511418 */     // MIs[0] policy
     /* 1511418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511428 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1511431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511452 */     // GIR_Coverage, 17996,
     /* 1511452 */     GIR_EraseRootFromParent_Done,
     /* 1511453 */   // Label 21051: @1511453
     /* 1511453 */   GIM_Try, /*On fail goto*//*Label 21052*/ GIMT_Encode4(1511535), // Rule ID 17997 //
     /* 1511458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1511469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1511472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1511478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511497 */     // MIs[0] round
     /* 1511497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511500 */     // MIs[0] policy
     /* 1511500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511510 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1511513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511534 */     // GIR_Coverage, 17997,
     /* 1511534 */     GIR_EraseRootFromParent_Done,
     /* 1511535 */   // Label 21052: @1511535
     /* 1511535 */   GIM_Try, /*On fail goto*//*Label 21053*/ GIMT_Encode4(1511617), // Rule ID 18000 //
     /* 1511540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1511560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511579 */     // MIs[0] round
     /* 1511579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511582 */     // MIs[0] policy
     /* 1511582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511592 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1511595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511616 */     // GIR_Coverage, 18000,
     /* 1511616 */     GIR_EraseRootFromParent_Done,
     /* 1511617 */   // Label 21053: @1511617
     /* 1511617 */   GIM_Try, /*On fail goto*//*Label 21054*/ GIMT_Encode4(1511699), // Rule ID 18001 //
     /* 1511622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1511642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511661 */     // MIs[0] round
     /* 1511661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511664 */     // MIs[0] policy
     /* 1511664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511674 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1511677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511698 */     // GIR_Coverage, 18001,
     /* 1511698 */     GIR_EraseRootFromParent_Done,
     /* 1511699 */   // Label 21054: @1511699
     /* 1511699 */   GIM_Try, /*On fail goto*//*Label 21055*/ GIMT_Encode4(1511781), // Rule ID 18004 //
     /* 1511704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1511715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1511718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1511721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1511724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511743 */     // MIs[0] round
     /* 1511743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511746 */     // MIs[0] policy
     /* 1511746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511756 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1511759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511780 */     // GIR_Coverage, 18004,
     /* 1511780 */     GIR_EraseRootFromParent_Done,
     /* 1511781 */   // Label 21055: @1511781
     /* 1511781 */   GIM_Try, /*On fail goto*//*Label 21056*/ GIMT_Encode4(1511863), // Rule ID 18005 //
     /* 1511786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1511797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1511800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1511803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1511806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511825 */     // MIs[0] round
     /* 1511825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511828 */     // MIs[0] policy
     /* 1511828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511838 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1511841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511862 */     // GIR_Coverage, 18005,
     /* 1511862 */     GIR_EraseRootFromParent_Done,
     /* 1511863 */   // Label 21056: @1511863
     /* 1511863 */   GIM_Try, /*On fail goto*//*Label 21057*/ GIMT_Encode4(1511945), // Rule ID 18008 //
     /* 1511868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1511879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1511882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1511885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1511888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511907 */     // MIs[0] round
     /* 1511907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511910 */     // MIs[0] policy
     /* 1511910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511920 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1511923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511944 */     // GIR_Coverage, 18008,
     /* 1511944 */     GIR_EraseRootFromParent_Done,
     /* 1511945 */   // Label 21057: @1511945
     /* 1511945 */   GIM_Try, /*On fail goto*//*Label 21058*/ GIMT_Encode4(1512027), // Rule ID 18009 //
     /* 1511950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1511961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1511964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1511967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1511970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511989 */     // MIs[0] round
     /* 1511989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511992 */     // MIs[0] policy
     /* 1511992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512002 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1512005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512026 */     // GIR_Coverage, 18009,
     /* 1512026 */     GIR_EraseRootFromParent_Done,
     /* 1512027 */   // Label 21058: @1512027
     /* 1512027 */   GIM_Try, /*On fail goto*//*Label 21059*/ GIMT_Encode4(1512109), // Rule ID 18012 //
     /* 1512032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1512043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1512046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1512049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1512052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512071 */     // MIs[0] round
     /* 1512071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512074 */     // MIs[0] policy
     /* 1512074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512084 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1512087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512108 */     // GIR_Coverage, 18012,
     /* 1512108 */     GIR_EraseRootFromParent_Done,
     /* 1512109 */   // Label 21059: @1512109
     /* 1512109 */   GIM_Try, /*On fail goto*//*Label 21060*/ GIMT_Encode4(1512191), // Rule ID 18013 //
     /* 1512114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1512117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1512125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1512128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1512131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1512134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512153 */     // MIs[0] round
     /* 1512153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512156 */     // MIs[0] policy
     /* 1512156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512166 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1512169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512190 */     // GIR_Coverage, 18013,
     /* 1512190 */     GIR_EraseRootFromParent_Done,
     /* 1512191 */   // Label 21060: @1512191
     /* 1512191 */   GIM_Try, /*On fail goto*//*Label 21061*/ GIMT_Encode4(1512273), // Rule ID 18016 //
     /* 1512196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1512207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1512210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1512213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1512216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512235 */     // MIs[0] round
     /* 1512235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512238 */     // MIs[0] policy
     /* 1512238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512248 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1512251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512272 */     // GIR_Coverage, 18016,
     /* 1512272 */     GIR_EraseRootFromParent_Done,
     /* 1512273 */   // Label 21061: @1512273
     /* 1512273 */   GIM_Try, /*On fail goto*//*Label 21062*/ GIMT_Encode4(1512355), // Rule ID 18017 //
     /* 1512278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1512289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1512292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1512295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1512298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512317 */     // MIs[0] round
     /* 1512317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512320 */     // MIs[0] policy
     /* 1512320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512330 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1512333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512354 */     // GIR_Coverage, 18017,
     /* 1512354 */     GIR_EraseRootFromParent_Done,
     /* 1512355 */   // Label 21062: @1512355
     /* 1512355 */   GIM_Try, /*On fail goto*//*Label 21063*/ GIMT_Encode4(1512437), // Rule ID 18020 //
     /* 1512360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1512371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1512374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1512377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1512380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512399 */     // MIs[0] round
     /* 1512399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512402 */     // MIs[0] policy
     /* 1512402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512412 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1512415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512436 */     // GIR_Coverage, 18020,
     /* 1512436 */     GIR_EraseRootFromParent_Done,
     /* 1512437 */   // Label 21063: @1512437
     /* 1512437 */   GIM_Try, /*On fail goto*//*Label 21064*/ GIMT_Encode4(1512519), // Rule ID 18021 //
     /* 1512442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1512445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1512453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1512456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1512459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1512462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512481 */     // MIs[0] round
     /* 1512481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512484 */     // MIs[0] policy
     /* 1512484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512494 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1512497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512518 */     // GIR_Coverage, 18021,
     /* 1512518 */     GIR_EraseRootFromParent_Done,
     /* 1512519 */   // Label 21064: @1512519
     /* 1512519 */   GIM_Try, /*On fail goto*//*Label 21065*/ GIMT_Encode4(1512601), // Rule ID 18024 //
     /* 1512524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1512527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1512535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1512538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1512541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1512544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512563 */     // MIs[0] round
     /* 1512563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512566 */     // MIs[0] policy
     /* 1512566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512576 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1512579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512600 */     // GIR_Coverage, 18024,
     /* 1512600 */     GIR_EraseRootFromParent_Done,
     /* 1512601 */   // Label 21065: @1512601
     /* 1512601 */   GIM_Try, /*On fail goto*//*Label 21066*/ GIMT_Encode4(1512683), // Rule ID 18025 //
     /* 1512606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1512609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1512617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1512620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1512623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1512626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512645 */     // MIs[0] round
     /* 1512645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512648 */     // MIs[0] policy
     /* 1512648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512658 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1512661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512682 */     // GIR_Coverage, 18025,
     /* 1512682 */     GIR_EraseRootFromParent_Done,
     /* 1512683 */   // Label 21066: @1512683
     /* 1512683 */   GIM_Try, /*On fail goto*//*Label 21067*/ GIMT_Encode4(1512765), // Rule ID 18028 //
     /* 1512688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1512699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1512702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1512705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1512708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512727 */     // MIs[0] round
     /* 1512727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512730 */     // MIs[0] policy
     /* 1512730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512740 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1512743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512764 */     // GIR_Coverage, 18028,
     /* 1512764 */     GIR_EraseRootFromParent_Done,
     /* 1512765 */   // Label 21067: @1512765
     /* 1512765 */   GIM_Try, /*On fail goto*//*Label 21068*/ GIMT_Encode4(1512847), // Rule ID 18029 //
     /* 1512770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1512781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1512784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1512787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1512790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512809 */     // MIs[0] round
     /* 1512809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512812 */     // MIs[0] policy
     /* 1512812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512822 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1512825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512846 */     // GIR_Coverage, 18029,
     /* 1512846 */     GIR_EraseRootFromParent_Done,
     /* 1512847 */   // Label 21068: @1512847
     /* 1512847 */   GIM_Try, /*On fail goto*//*Label 21069*/ GIMT_Encode4(1512929), // Rule ID 18032 //
     /* 1512852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1512863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1512866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1512869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1512872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512891 */     // MIs[0] round
     /* 1512891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512894 */     // MIs[0] policy
     /* 1512894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512904 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1512907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512928 */     // GIR_Coverage, 18032,
     /* 1512928 */     GIR_EraseRootFromParent_Done,
     /* 1512929 */   // Label 21069: @1512929
     /* 1512929 */   GIM_Try, /*On fail goto*//*Label 21070*/ GIMT_Encode4(1513011), // Rule ID 18033 //
     /* 1512934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1512945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1512948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1512951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1512954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512973 */     // MIs[0] round
     /* 1512973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512976 */     // MIs[0] policy
     /* 1512976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512986 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1512989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513010 */     // GIR_Coverage, 18033,
     /* 1513010 */     GIR_EraseRootFromParent_Done,
     /* 1513011 */   // Label 21070: @1513011
     /* 1513011 */   GIM_Try, /*On fail goto*//*Label 21071*/ GIMT_Encode4(1513093), // Rule ID 18036 //
     /* 1513016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1513027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1513030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1513033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1513036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513055 */     // MIs[0] round
     /* 1513055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513058 */     // MIs[0] policy
     /* 1513058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513068 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1513071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513092 */     // GIR_Coverage, 18036,
     /* 1513092 */     GIR_EraseRootFromParent_Done,
     /* 1513093 */   // Label 21071: @1513093
     /* 1513093 */   GIM_Try, /*On fail goto*//*Label 21072*/ GIMT_Encode4(1513175), // Rule ID 18037 //
     /* 1513098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1513101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1513109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1513112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1513115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1513118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513137 */     // MIs[0] round
     /* 1513137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513140 */     // MIs[0] policy
     /* 1513140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513150 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1513153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513174 */     // GIR_Coverage, 18037,
     /* 1513174 */     GIR_EraseRootFromParent_Done,
     /* 1513175 */   // Label 21072: @1513175
     /* 1513175 */   GIM_Try, /*On fail goto*//*Label 21073*/ GIMT_Encode4(1513257), // Rule ID 18040 //
     /* 1513180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1513191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1513194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1513197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1513200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513219 */     // MIs[0] round
     /* 1513219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513222 */     // MIs[0] policy
     /* 1513222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513232 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1513235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513256 */     // GIR_Coverage, 18040,
     /* 1513256 */     GIR_EraseRootFromParent_Done,
     /* 1513257 */   // Label 21073: @1513257
     /* 1513257 */   GIM_Try, /*On fail goto*//*Label 21074*/ GIMT_Encode4(1513339), // Rule ID 18041 //
     /* 1513262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1513273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1513276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1513279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1513282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513301 */     // MIs[0] round
     /* 1513301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513304 */     // MIs[0] policy
     /* 1513304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513314 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1513317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513338 */     // GIR_Coverage, 18041,
     /* 1513338 */     GIR_EraseRootFromParent_Done,
     /* 1513339 */   // Label 21074: @1513339
     /* 1513339 */   GIM_Try, /*On fail goto*//*Label 21075*/ GIMT_Encode4(1513421), // Rule ID 18044 //
     /* 1513344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1513355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1513358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1513361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1513364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513383 */     // MIs[0] round
     /* 1513383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513386 */     // MIs[0] policy
     /* 1513386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513396 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1513399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513420 */     // GIR_Coverage, 18044,
     /* 1513420 */     GIR_EraseRootFromParent_Done,
     /* 1513421 */   // Label 21075: @1513421
     /* 1513421 */   GIM_Try, /*On fail goto*//*Label 21076*/ GIMT_Encode4(1513503), // Rule ID 18045 //
     /* 1513426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1513437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1513440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1513443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1513446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513465 */     // MIs[0] round
     /* 1513465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513468 */     // MIs[0] policy
     /* 1513468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513478 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1513481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513502 */     // GIR_Coverage, 18045,
     /* 1513502 */     GIR_EraseRootFromParent_Done,
     /* 1513503 */   // Label 21076: @1513503
     /* 1513503 */   GIM_Try, /*On fail goto*//*Label 21077*/ GIMT_Encode4(1513585), // Rule ID 18048 //
     /* 1513508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1513525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1513528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513547 */     // MIs[0] round
     /* 1513547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513550 */     // MIs[0] policy
     /* 1513550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513560 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1513563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513584 */     // GIR_Coverage, 18048,
     /* 1513584 */     GIR_EraseRootFromParent_Done,
     /* 1513585 */   // Label 21077: @1513585
     /* 1513585 */   GIM_Try, /*On fail goto*//*Label 21078*/ GIMT_Encode4(1513667), // Rule ID 18049 //
     /* 1513590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1513607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1513610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513629 */     // MIs[0] round
     /* 1513629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513632 */     // MIs[0] policy
     /* 1513632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513642 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1513645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513666 */     // GIR_Coverage, 18049,
     /* 1513666 */     GIR_EraseRootFromParent_Done,
     /* 1513667 */   // Label 21078: @1513667
     /* 1513667 */   GIM_Try, /*On fail goto*//*Label 21079*/ GIMT_Encode4(1513749), // Rule ID 18052 //
     /* 1513672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1513683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1513686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1513689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1513692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513711 */     // MIs[0] round
     /* 1513711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513714 */     // MIs[0] policy
     /* 1513714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513724 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1513727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513748 */     // GIR_Coverage, 18052,
     /* 1513748 */     GIR_EraseRootFromParent_Done,
     /* 1513749 */   // Label 21079: @1513749
     /* 1513749 */   GIM_Try, /*On fail goto*//*Label 21080*/ GIMT_Encode4(1513831), // Rule ID 18053 //
     /* 1513754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1513765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1513768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1513771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1513774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513793 */     // MIs[0] round
     /* 1513793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513796 */     // MIs[0] policy
     /* 1513796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513806 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1513809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513830 */     // GIR_Coverage, 18053,
     /* 1513830 */     GIR_EraseRootFromParent_Done,
     /* 1513831 */   // Label 21080: @1513831
     /* 1513831 */   GIM_Try, /*On fail goto*//*Label 21081*/ GIMT_Encode4(1513913), // Rule ID 18056 //
     /* 1513836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1513847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1513850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1513853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1513856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513875 */     // MIs[0] round
     /* 1513875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513878 */     // MIs[0] policy
     /* 1513878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513888 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1513891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513912 */     // GIR_Coverage, 18056,
     /* 1513912 */     GIR_EraseRootFromParent_Done,
     /* 1513913 */   // Label 21081: @1513913
     /* 1513913 */   GIM_Try, /*On fail goto*//*Label 21082*/ GIMT_Encode4(1513995), // Rule ID 18057 //
     /* 1513918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1513929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1513932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1513935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1513938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513957 */     // MIs[0] round
     /* 1513957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513960 */     // MIs[0] policy
     /* 1513960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513970 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1513973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513994 */     // GIR_Coverage, 18057,
     /* 1513994 */     GIR_EraseRootFromParent_Done,
     /* 1513995 */   // Label 21082: @1513995
     /* 1513995 */   GIM_Try, /*On fail goto*//*Label 21083*/ GIMT_Encode4(1514077), // Rule ID 18060 //
     /* 1514000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1514003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1514011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1514014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1514017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1514020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514039 */     // MIs[0] round
     /* 1514039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514042 */     // MIs[0] policy
     /* 1514042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514052 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1514055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514076 */     // GIR_Coverage, 18060,
     /* 1514076 */     GIR_EraseRootFromParent_Done,
     /* 1514077 */   // Label 21083: @1514077
     /* 1514077 */   GIM_Try, /*On fail goto*//*Label 21084*/ GIMT_Encode4(1514159), // Rule ID 18061 //
     /* 1514082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1514085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1514093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1514096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1514099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1514102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514121 */     // MIs[0] round
     /* 1514121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514124 */     // MIs[0] policy
     /* 1514124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514134 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1514137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514158 */     // GIR_Coverage, 18061,
     /* 1514158 */     GIR_EraseRootFromParent_Done,
     /* 1514159 */   // Label 21084: @1514159
     /* 1514159 */   GIM_Try, /*On fail goto*//*Label 21085*/ GIMT_Encode4(1514241), // Rule ID 18064 //
     /* 1514164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1514175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1514178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1514184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514203 */     // MIs[0] round
     /* 1514203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514206 */     // MIs[0] policy
     /* 1514206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514216 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1514219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514240 */     // GIR_Coverage, 18064,
     /* 1514240 */     GIR_EraseRootFromParent_Done,
     /* 1514241 */   // Label 21085: @1514241
     /* 1514241 */   GIM_Try, /*On fail goto*//*Label 21086*/ GIMT_Encode4(1514323), // Rule ID 18065 //
     /* 1514246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1514257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1514260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1514266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514285 */     // MIs[0] round
     /* 1514285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514288 */     // MIs[0] policy
     /* 1514288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514298 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1514301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514322 */     // GIR_Coverage, 18065,
     /* 1514322 */     GIR_EraseRootFromParent_Done,
     /* 1514323 */   // Label 21086: @1514323
     /* 1514323 */   GIM_Try, /*On fail goto*//*Label 21087*/ GIMT_Encode4(1514405), // Rule ID 18068 //
     /* 1514328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1514339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1514342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1514348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514367 */     // MIs[0] round
     /* 1514367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514370 */     // MIs[0] policy
     /* 1514370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514380 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1514383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514404 */     // GIR_Coverage, 18068,
     /* 1514404 */     GIR_EraseRootFromParent_Done,
     /* 1514405 */   // Label 21087: @1514405
     /* 1514405 */   GIM_Try, /*On fail goto*//*Label 21088*/ GIMT_Encode4(1514487), // Rule ID 18069 //
     /* 1514410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1514421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1514424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1514430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514449 */     // MIs[0] round
     /* 1514449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514452 */     // MIs[0] policy
     /* 1514452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514462 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1514465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514486 */     // GIR_Coverage, 18069,
     /* 1514486 */     GIR_EraseRootFromParent_Done,
     /* 1514487 */   // Label 21088: @1514487
     /* 1514487 */   GIM_Try, /*On fail goto*//*Label 21089*/ GIMT_Encode4(1514569), // Rule ID 18072 //
     /* 1514492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1514503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1514506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1514512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514531 */     // MIs[0] round
     /* 1514531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514534 */     // MIs[0] policy
     /* 1514534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514544 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1514547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514568 */     // GIR_Coverage, 18072,
     /* 1514568 */     GIR_EraseRootFromParent_Done,
     /* 1514569 */   // Label 21089: @1514569
     /* 1514569 */   GIM_Try, /*On fail goto*//*Label 21090*/ GIMT_Encode4(1514651), // Rule ID 18073 //
     /* 1514574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1514585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1514588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1514594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514613 */     // MIs[0] round
     /* 1514613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514616 */     // MIs[0] policy
     /* 1514616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514626 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1514629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514650 */     // GIR_Coverage, 18073,
     /* 1514650 */     GIR_EraseRootFromParent_Done,
     /* 1514651 */   // Label 21090: @1514651
     /* 1514651 */   GIM_Try, /*On fail goto*//*Label 21091*/ GIMT_Encode4(1514733), // Rule ID 18076 //
     /* 1514656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1514676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514695 */     // MIs[0] round
     /* 1514695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514698 */     // MIs[0] policy
     /* 1514698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514708 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1514711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514732 */     // GIR_Coverage, 18076,
     /* 1514732 */     GIR_EraseRootFromParent_Done,
     /* 1514733 */   // Label 21091: @1514733
     /* 1514733 */   GIM_Try, /*On fail goto*//*Label 21092*/ GIMT_Encode4(1514815), // Rule ID 18077 //
     /* 1514738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1514758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514777 */     // MIs[0] round
     /* 1514777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514780 */     // MIs[0] policy
     /* 1514780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514790 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1514793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514814 */     // GIR_Coverage, 18077,
     /* 1514814 */     GIR_EraseRootFromParent_Done,
     /* 1514815 */   // Label 21092: @1514815
     /* 1514815 */   GIM_Try, /*On fail goto*//*Label 21093*/ GIMT_Encode4(1514897), // Rule ID 18080 //
     /* 1514820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1514831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1514834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1514840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514859 */     // MIs[0] round
     /* 1514859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514862 */     // MIs[0] policy
     /* 1514862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514872 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1514875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514896 */     // GIR_Coverage, 18080,
     /* 1514896 */     GIR_EraseRootFromParent_Done,
     /* 1514897 */   // Label 21093: @1514897
     /* 1514897 */   GIM_Try, /*On fail goto*//*Label 21094*/ GIMT_Encode4(1514979), // Rule ID 18081 //
     /* 1514902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1514913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1514916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1514922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514941 */     // MIs[0] round
     /* 1514941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514944 */     // MIs[0] policy
     /* 1514944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514954 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1514957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514978 */     // GIR_Coverage, 18081,
     /* 1514978 */     GIR_EraseRootFromParent_Done,
     /* 1514979 */   // Label 21094: @1514979
     /* 1514979 */   GIM_Try, /*On fail goto*//*Label 21095*/ GIMT_Encode4(1515061), // Rule ID 18084 //
     /* 1514984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1514987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1514995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1514998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1515001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1515004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515023 */     // MIs[0] round
     /* 1515023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515026 */     // MIs[0] policy
     /* 1515026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1515039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515060 */     // GIR_Coverage, 18084,
     /* 1515060 */     GIR_EraseRootFromParent_Done,
     /* 1515061 */   // Label 21095: @1515061
     /* 1515061 */   GIM_Try, /*On fail goto*//*Label 21096*/ GIMT_Encode4(1515143), // Rule ID 18085 //
     /* 1515066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1515069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1515077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1515080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1515083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1515086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515105 */     // MIs[0] round
     /* 1515105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515108 */     // MIs[0] policy
     /* 1515108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515118 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1515121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515142 */     // GIR_Coverage, 18085,
     /* 1515142 */     GIR_EraseRootFromParent_Done,
     /* 1515143 */   // Label 21096: @1515143
     /* 1515143 */   GIM_Try, /*On fail goto*//*Label 21097*/ GIMT_Encode4(1515225), // Rule ID 18088 //
     /* 1515148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1515159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1515162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1515168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515187 */     // MIs[0] round
     /* 1515187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515190 */     // MIs[0] policy
     /* 1515190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515200 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1515203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515224 */     // GIR_Coverage, 18088,
     /* 1515224 */     GIR_EraseRootFromParent_Done,
     /* 1515225 */   // Label 21097: @1515225
     /* 1515225 */   GIM_Try, /*On fail goto*//*Label 21098*/ GIMT_Encode4(1515307), // Rule ID 18089 //
     /* 1515230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1515241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1515244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1515250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515269 */     // MIs[0] round
     /* 1515269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515272 */     // MIs[0] policy
     /* 1515272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515282 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1515285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515306 */     // GIR_Coverage, 18089,
     /* 1515306 */     GIR_EraseRootFromParent_Done,
     /* 1515307 */   // Label 21098: @1515307
     /* 1515307 */   GIM_Try, /*On fail goto*//*Label 21099*/ GIMT_Encode4(1515389), // Rule ID 18092 //
     /* 1515312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1515323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1515326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1515332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515351 */     // MIs[0] round
     /* 1515351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515354 */     // MIs[0] policy
     /* 1515354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515364 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1515367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515388 */     // GIR_Coverage, 18092,
     /* 1515388 */     GIR_EraseRootFromParent_Done,
     /* 1515389 */   // Label 21099: @1515389
     /* 1515389 */   GIM_Try, /*On fail goto*//*Label 21100*/ GIMT_Encode4(1515471), // Rule ID 18093 //
     /* 1515394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1515405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1515408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1515414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515433 */     // MIs[0] round
     /* 1515433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515436 */     // MIs[0] policy
     /* 1515436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515446 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1515449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515470 */     // GIR_Coverage, 18093,
     /* 1515470 */     GIR_EraseRootFromParent_Done,
     /* 1515471 */   // Label 21100: @1515471
     /* 1515471 */   GIM_Try, /*On fail goto*//*Label 21101*/ GIMT_Encode4(1515553), // Rule ID 18096 //
     /* 1515476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1515496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515515 */     // MIs[0] round
     /* 1515515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515518 */     // MIs[0] policy
     /* 1515518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515528 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1515531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515552 */     // GIR_Coverage, 18096,
     /* 1515552 */     GIR_EraseRootFromParent_Done,
     /* 1515553 */   // Label 21101: @1515553
     /* 1515553 */   GIM_Try, /*On fail goto*//*Label 21102*/ GIMT_Encode4(1515635), // Rule ID 18097 //
     /* 1515558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1515578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515597 */     // MIs[0] round
     /* 1515597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515600 */     // MIs[0] policy
     /* 1515600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515610 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1515613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515634 */     // GIR_Coverage, 18097,
     /* 1515634 */     GIR_EraseRootFromParent_Done,
     /* 1515635 */   // Label 21102: @1515635
     /* 1515635 */   GIM_Try, /*On fail goto*//*Label 21103*/ GIMT_Encode4(1515717), // Rule ID 18100 //
     /* 1515640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1515660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515679 */     // MIs[0] round
     /* 1515679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515682 */     // MIs[0] policy
     /* 1515682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515692 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1515695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515716 */     // GIR_Coverage, 18100,
     /* 1515716 */     GIR_EraseRootFromParent_Done,
     /* 1515717 */   // Label 21103: @1515717
     /* 1515717 */   GIM_Try, /*On fail goto*//*Label 21104*/ GIMT_Encode4(1515799), // Rule ID 18101 //
     /* 1515722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1515742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515761 */     // MIs[0] round
     /* 1515761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515764 */     // MIs[0] policy
     /* 1515764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515774 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1515777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515798 */     // GIR_Coverage, 18101,
     /* 1515798 */     GIR_EraseRootFromParent_Done,
     /* 1515799 */   // Label 21104: @1515799
     /* 1515799 */   GIM_Try, /*On fail goto*//*Label 21105*/ GIMT_Encode4(1515881), // Rule ID 18104 //
     /* 1515804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1515815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1515818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1515824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515843 */     // MIs[0] round
     /* 1515843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515846 */     // MIs[0] policy
     /* 1515846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515856 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1515859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515880 */     // GIR_Coverage, 18104,
     /* 1515880 */     GIR_EraseRootFromParent_Done,
     /* 1515881 */   // Label 21105: @1515881
     /* 1515881 */   GIM_Try, /*On fail goto*//*Label 21106*/ GIMT_Encode4(1515963), // Rule ID 18105 //
     /* 1515886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1515897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1515900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1515906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515925 */     // MIs[0] round
     /* 1515925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515928 */     // MIs[0] policy
     /* 1515928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515938 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1515941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515962 */     // GIR_Coverage, 18105,
     /* 1515962 */     GIR_EraseRootFromParent_Done,
     /* 1515963 */   // Label 21106: @1515963
     /* 1515963 */   GIM_Try, /*On fail goto*//*Label 21107*/ GIMT_Encode4(1516045), // Rule ID 18108 //
     /* 1515968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1515979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1515982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1515988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1516003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516007 */     // MIs[0] round
     /* 1516007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516010 */     // MIs[0] policy
     /* 1516010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516020 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1516023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516044 */     // GIR_Coverage, 18108,
     /* 1516044 */     GIR_EraseRootFromParent_Done,
     /* 1516045 */   // Label 21107: @1516045
     /* 1516045 */   GIM_Try, /*On fail goto*//*Label 21108*/ GIMT_Encode4(1516127), // Rule ID 18109 //
     /* 1516050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1516061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1516064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1516067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1516070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1516085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516089 */     // MIs[0] round
     /* 1516089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516092 */     // MIs[0] policy
     /* 1516092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516102 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1516105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516126 */     // GIR_Coverage, 18109,
     /* 1516126 */     GIR_EraseRootFromParent_Done,
     /* 1516127 */   // Label 21108: @1516127
     /* 1516127 */   GIM_Try, /*On fail goto*//*Label 21109*/ GIMT_Encode4(1516209), // Rule ID 18112 //
     /* 1516132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1516143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1516146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1516152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516171 */     // MIs[0] round
     /* 1516171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516174 */     // MIs[0] policy
     /* 1516174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516184 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1516187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516208 */     // GIR_Coverage, 18112,
     /* 1516208 */     GIR_EraseRootFromParent_Done,
     /* 1516209 */   // Label 21109: @1516209
     /* 1516209 */   GIM_Try, /*On fail goto*//*Label 21110*/ GIMT_Encode4(1516291), // Rule ID 18113 //
     /* 1516214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1516225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1516228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1516234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516253 */     // MIs[0] round
     /* 1516253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516256 */     // MIs[0] policy
     /* 1516256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516266 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1516269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516290 */     // GIR_Coverage, 18113,
     /* 1516290 */     GIR_EraseRootFromParent_Done,
     /* 1516291 */   // Label 21110: @1516291
     /* 1516291 */   GIM_Try, /*On fail goto*//*Label 21111*/ GIMT_Encode4(1516373), // Rule ID 18116 //
     /* 1516296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1516307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1516310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1516316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516335 */     // MIs[0] round
     /* 1516335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516338 */     // MIs[0] policy
     /* 1516338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516348 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1516351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516372 */     // GIR_Coverage, 18116,
     /* 1516372 */     GIR_EraseRootFromParent_Done,
     /* 1516373 */   // Label 21111: @1516373
     /* 1516373 */   GIM_Try, /*On fail goto*//*Label 21112*/ GIMT_Encode4(1516455), // Rule ID 18117 //
     /* 1516378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1516389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1516392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1516398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516417 */     // MIs[0] round
     /* 1516417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516420 */     // MIs[0] policy
     /* 1516420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516430 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1516433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516454 */     // GIR_Coverage, 18117,
     /* 1516454 */     GIR_EraseRootFromParent_Done,
     /* 1516455 */   // Label 21112: @1516455
     /* 1516455 */   GIM_Try, /*On fail goto*//*Label 21113*/ GIMT_Encode4(1516537), // Rule ID 18120 //
     /* 1516460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1516480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516499 */     // MIs[0] round
     /* 1516499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516502 */     // MIs[0] policy
     /* 1516502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516512 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1516515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516536 */     // GIR_Coverage, 18120,
     /* 1516536 */     GIR_EraseRootFromParent_Done,
     /* 1516537 */   // Label 21113: @1516537
     /* 1516537 */   GIM_Try, /*On fail goto*//*Label 21114*/ GIMT_Encode4(1516619), // Rule ID 18121 //
     /* 1516542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1516562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516581 */     // MIs[0] round
     /* 1516581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516584 */     // MIs[0] policy
     /* 1516584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516594 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1516597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516618 */     // GIR_Coverage, 18121,
     /* 1516618 */     GIR_EraseRootFromParent_Done,
     /* 1516619 */   // Label 21114: @1516619
     /* 1516619 */   GIM_Try, /*On fail goto*//*Label 21115*/ GIMT_Encode4(1516701), // Rule ID 18124 //
     /* 1516624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1516641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1516644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516663 */     // MIs[0] round
     /* 1516663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516666 */     // MIs[0] policy
     /* 1516666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516676 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1516679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516700 */     // GIR_Coverage, 18124,
     /* 1516700 */     GIR_EraseRootFromParent_Done,
     /* 1516701 */   // Label 21115: @1516701
     /* 1516701 */   GIM_Try, /*On fail goto*//*Label 21116*/ GIMT_Encode4(1516783), // Rule ID 18125 //
     /* 1516706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1516723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1516726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516745 */     // MIs[0] round
     /* 1516745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516748 */     // MIs[0] policy
     /* 1516748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516758 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1516761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516782 */     // GIR_Coverage, 18125,
     /* 1516782 */     GIR_EraseRootFromParent_Done,
     /* 1516783 */   // Label 21116: @1516783
     /* 1516783 */   GIM_Try, /*On fail goto*//*Label 21117*/ GIMT_Encode4(1516865), // Rule ID 18128 //
     /* 1516788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1516799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1516802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1516805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1516808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516827 */     // MIs[0] round
     /* 1516827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516830 */     // MIs[0] policy
     /* 1516830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516840 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1516843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516864 */     // GIR_Coverage, 18128,
     /* 1516864 */     GIR_EraseRootFromParent_Done,
     /* 1516865 */   // Label 21117: @1516865
     /* 1516865 */   GIM_Try, /*On fail goto*//*Label 21118*/ GIMT_Encode4(1516947), // Rule ID 18129 //
     /* 1516870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1516881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1516884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1516887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1516890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516909 */     // MIs[0] round
     /* 1516909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516912 */     // MIs[0] policy
     /* 1516912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516922 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1516925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516946 */     // GIR_Coverage, 18129,
     /* 1516946 */     GIR_EraseRootFromParent_Done,
     /* 1516947 */   // Label 21118: @1516947
     /* 1516947 */   GIM_Try, /*On fail goto*//*Label 21119*/ GIMT_Encode4(1517029), // Rule ID 18132 //
     /* 1516952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1516955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1516963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1516966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1516969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1516972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516991 */     // MIs[0] round
     /* 1516991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516994 */     // MIs[0] policy
     /* 1516994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517004 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1517007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517028 */     // GIR_Coverage, 18132,
     /* 1517028 */     GIR_EraseRootFromParent_Done,
     /* 1517029 */   // Label 21119: @1517029
     /* 1517029 */   GIM_Try, /*On fail goto*//*Label 21120*/ GIMT_Encode4(1517111), // Rule ID 18133 //
     /* 1517034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1517045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1517048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1517051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1517054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517073 */     // MIs[0] round
     /* 1517073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517076 */     // MIs[0] policy
     /* 1517076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517086 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1517089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517110 */     // GIR_Coverage, 18133,
     /* 1517110 */     GIR_EraseRootFromParent_Done,
     /* 1517111 */   // Label 21120: @1517111
     /* 1517111 */   GIM_Try, /*On fail goto*//*Label 21121*/ GIMT_Encode4(1517193), // Rule ID 18136 //
     /* 1517116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1517127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1517130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1517133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1517136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517155 */     // MIs[0] round
     /* 1517155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517158 */     // MIs[0] policy
     /* 1517158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517168 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1517171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517192 */     // GIR_Coverage, 18136,
     /* 1517192 */     GIR_EraseRootFromParent_Done,
     /* 1517193 */   // Label 21121: @1517193
     /* 1517193 */   GIM_Try, /*On fail goto*//*Label 21122*/ GIMT_Encode4(1517275), // Rule ID 18137 //
     /* 1517198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1517209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1517212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1517215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1517218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517237 */     // MIs[0] round
     /* 1517237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517240 */     // MIs[0] policy
     /* 1517240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517250 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1517253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517274 */     // GIR_Coverage, 18137,
     /* 1517274 */     GIR_EraseRootFromParent_Done,
     /* 1517275 */   // Label 21122: @1517275
     /* 1517275 */   GIM_Try, /*On fail goto*//*Label 21123*/ GIMT_Encode4(1517357), // Rule ID 18140 //
     /* 1517280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1517291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1517294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1517297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1517300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517319 */     // MIs[0] round
     /* 1517319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517322 */     // MIs[0] policy
     /* 1517322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517332 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1517335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517356 */     // GIR_Coverage, 18140,
     /* 1517356 */     GIR_EraseRootFromParent_Done,
     /* 1517357 */   // Label 21123: @1517357
     /* 1517357 */   GIM_Try, /*On fail goto*//*Label 21124*/ GIMT_Encode4(1517439), // Rule ID 18141 //
     /* 1517362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1517373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1517376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1517379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1517382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517401 */     // MIs[0] round
     /* 1517401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517404 */     // MIs[0] policy
     /* 1517404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517414 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1517417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517438 */     // GIR_Coverage, 18141,
     /* 1517438 */     GIR_EraseRootFromParent_Done,
     /* 1517439 */   // Label 21124: @1517439
     /* 1517439 */   GIM_Try, /*On fail goto*//*Label 21125*/ GIMT_Encode4(1517521), // Rule ID 18144 //
     /* 1517444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1517447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1517455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1517458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1517461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1517464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517483 */     // MIs[0] round
     /* 1517483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517486 */     // MIs[0] policy
     /* 1517486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517496 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1517499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517520 */     // GIR_Coverage, 18144,
     /* 1517520 */     GIR_EraseRootFromParent_Done,
     /* 1517521 */   // Label 21125: @1517521
     /* 1517521 */   GIM_Try, /*On fail goto*//*Label 21126*/ GIMT_Encode4(1517603), // Rule ID 18145 //
     /* 1517526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1517529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1517537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1517540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1517543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1517546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517565 */     // MIs[0] round
     /* 1517565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517568 */     // MIs[0] policy
     /* 1517568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517578 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1517581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517602 */     // GIR_Coverage, 18145,
     /* 1517602 */     GIR_EraseRootFromParent_Done,
     /* 1517603 */   // Label 21126: @1517603
     /* 1517603 */   GIM_Try, /*On fail goto*//*Label 21127*/ GIMT_Encode4(1517685), // Rule ID 18148 //
     /* 1517608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1517625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1517628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517647 */     // MIs[0] round
     /* 1517647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517650 */     // MIs[0] policy
     /* 1517650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517660 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1517663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517684 */     // GIR_Coverage, 18148,
     /* 1517684 */     GIR_EraseRootFromParent_Done,
     /* 1517685 */   // Label 21127: @1517685
     /* 1517685 */   GIM_Try, /*On fail goto*//*Label 21128*/ GIMT_Encode4(1517767), // Rule ID 18149 //
     /* 1517690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1517707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1517710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517729 */     // MIs[0] round
     /* 1517729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517732 */     // MIs[0] policy
     /* 1517732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517742 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1517745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517766 */     // GIR_Coverage, 18149,
     /* 1517766 */     GIR_EraseRootFromParent_Done,
     /* 1517767 */   // Label 21128: @1517767
     /* 1517767 */   GIM_Try, /*On fail goto*//*Label 21129*/ GIMT_Encode4(1517849), // Rule ID 18152 //
     /* 1517772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1517783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1517786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1517789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1517792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517811 */     // MIs[0] round
     /* 1517811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517814 */     // MIs[0] policy
     /* 1517814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517824 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1517827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517848 */     // GIR_Coverage, 18152,
     /* 1517848 */     GIR_EraseRootFromParent_Done,
     /* 1517849 */   // Label 21129: @1517849
     /* 1517849 */   GIM_Try, /*On fail goto*//*Label 21130*/ GIMT_Encode4(1517931), // Rule ID 18153 //
     /* 1517854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1517865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1517868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1517871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1517874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517893 */     // MIs[0] round
     /* 1517893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517896 */     // MIs[0] policy
     /* 1517896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517906 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1517909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517930 */     // GIR_Coverage, 18153,
     /* 1517930 */     GIR_EraseRootFromParent_Done,
     /* 1517931 */   // Label 21130: @1517931
     /* 1517931 */   GIM_Try, /*On fail goto*//*Label 21131*/ GIMT_Encode4(1518013), // Rule ID 18156 //
     /* 1517936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1517947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1517950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1517953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1517956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517975 */     // MIs[0] round
     /* 1517975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517978 */     // MIs[0] policy
     /* 1517978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517988 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1517991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518012 */     // GIR_Coverage, 18156,
     /* 1518012 */     GIR_EraseRootFromParent_Done,
     /* 1518013 */   // Label 21131: @1518013
     /* 1518013 */   GIM_Try, /*On fail goto*//*Label 21132*/ GIMT_Encode4(1518095), // Rule ID 18157 //
     /* 1518018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1518029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1518032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1518035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1518038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518057 */     // MIs[0] round
     /* 1518057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518060 */     // MIs[0] policy
     /* 1518060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518070 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1518073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518094 */     // GIR_Coverage, 18157,
     /* 1518094 */     GIR_EraseRootFromParent_Done,
     /* 1518095 */   // Label 21132: @1518095
     /* 1518095 */   GIM_Try, /*On fail goto*//*Label 21133*/ GIMT_Encode4(1518177), // Rule ID 18160 //
     /* 1518100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1518111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1518114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1518117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1518120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518139 */     // MIs[0] round
     /* 1518139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518142 */     // MIs[0] policy
     /* 1518142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518152 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1518155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518176 */     // GIR_Coverage, 18160,
     /* 1518176 */     GIR_EraseRootFromParent_Done,
     /* 1518177 */   // Label 21133: @1518177
     /* 1518177 */   GIM_Try, /*On fail goto*//*Label 21134*/ GIMT_Encode4(1518259), // Rule ID 18161 //
     /* 1518182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1518193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1518196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1518199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1518202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518221 */     // MIs[0] round
     /* 1518221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518224 */     // MIs[0] policy
     /* 1518224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518234 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1518237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518258 */     // GIR_Coverage, 18161,
     /* 1518258 */     GIR_EraseRootFromParent_Done,
     /* 1518259 */   // Label 21134: @1518259
     /* 1518259 */   GIM_Try, /*On fail goto*//*Label 21135*/ GIMT_Encode4(1518341), // Rule ID 18164 //
     /* 1518264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1518275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1518278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1518281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1518284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518303 */     // MIs[0] round
     /* 1518303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518306 */     // MIs[0] policy
     /* 1518306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518316 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1518319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518340 */     // GIR_Coverage, 18164,
     /* 1518340 */     GIR_EraseRootFromParent_Done,
     /* 1518341 */   // Label 21135: @1518341
     /* 1518341 */   GIM_Try, /*On fail goto*//*Label 21136*/ GIMT_Encode4(1518423), // Rule ID 18165 //
     /* 1518346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1518357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1518360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1518363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1518366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518385 */     // MIs[0] round
     /* 1518385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518388 */     // MIs[0] policy
     /* 1518388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518398 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1518401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518422 */     // GIR_Coverage, 18165,
     /* 1518422 */     GIR_EraseRootFromParent_Done,
     /* 1518423 */   // Label 21136: @1518423
     /* 1518423 */   GIM_Try, /*On fail goto*//*Label 21137*/ GIMT_Encode4(1518505), // Rule ID 18168 //
     /* 1518428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1518439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1518442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1518445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1518448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518467 */     // MIs[0] round
     /* 1518467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518470 */     // MIs[0] policy
     /* 1518470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518480 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1518483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518504 */     // GIR_Coverage, 18168,
     /* 1518504 */     GIR_EraseRootFromParent_Done,
     /* 1518505 */   // Label 21137: @1518505
     /* 1518505 */   GIM_Try, /*On fail goto*//*Label 21138*/ GIMT_Encode4(1518587), // Rule ID 18169 //
     /* 1518510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1518521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1518524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1518527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1518530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518549 */     // MIs[0] round
     /* 1518549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518552 */     // MIs[0] policy
     /* 1518552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518562 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1518565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518586 */     // GIR_Coverage, 18169,
     /* 1518586 */     GIR_EraseRootFromParent_Done,
     /* 1518587 */   // Label 21138: @1518587
     /* 1518587 */   GIM_Try, /*On fail goto*//*Label 21139*/ GIMT_Encode4(1518669), // Rule ID 18172 //
     /* 1518592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1518603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1518606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1518609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1518612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518631 */     // MIs[0] round
     /* 1518631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518634 */     // MIs[0] policy
     /* 1518634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518644 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1518647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518668 */     // GIR_Coverage, 18172,
     /* 1518668 */     GIR_EraseRootFromParent_Done,
     /* 1518669 */   // Label 21139: @1518669
     /* 1518669 */   GIM_Try, /*On fail goto*//*Label 21140*/ GIMT_Encode4(1518751), // Rule ID 18173 //
     /* 1518674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1518685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1518688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1518691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1518694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518713 */     // MIs[0] round
     /* 1518713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518716 */     // MIs[0] policy
     /* 1518716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518726 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1518729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518750 */     // GIR_Coverage, 18173,
     /* 1518750 */     GIR_EraseRootFromParent_Done,
     /* 1518751 */   // Label 21140: @1518751
     /* 1518751 */   GIM_Try, /*On fail goto*//*Label 21141*/ GIMT_Encode4(1518833), // Rule ID 18176 //
     /* 1518756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1518767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1518770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1518773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1518776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518795 */     // MIs[0] round
     /* 1518795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518798 */     // MIs[0] policy
     /* 1518798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518808 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1518811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518832 */     // GIR_Coverage, 18176,
     /* 1518832 */     GIR_EraseRootFromParent_Done,
     /* 1518833 */   // Label 21141: @1518833
     /* 1518833 */   GIM_Try, /*On fail goto*//*Label 21142*/ GIMT_Encode4(1518915), // Rule ID 18177 //
     /* 1518838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1518849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1518852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1518855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1518858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518877 */     // MIs[0] round
     /* 1518877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518880 */     // MIs[0] policy
     /* 1518880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518890 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1518893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518914 */     // GIR_Coverage, 18177,
     /* 1518914 */     GIR_EraseRootFromParent_Done,
     /* 1518915 */   // Label 21142: @1518915
     /* 1518915 */   GIM_Try, /*On fail goto*//*Label 21143*/ GIMT_Encode4(1518997), // Rule ID 18180 //
     /* 1518920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1518931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1518934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1518937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1518940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518959 */     // MIs[0] round
     /* 1518959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518962 */     // MIs[0] policy
     /* 1518962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518972 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1518975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518996 */     // GIR_Coverage, 18180,
     /* 1518996 */     GIR_EraseRootFromParent_Done,
     /* 1518997 */   // Label 21143: @1518997
     /* 1518997 */   GIM_Try, /*On fail goto*//*Label 21144*/ GIMT_Encode4(1519079), // Rule ID 18181 //
     /* 1519002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1519005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1519013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1519016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1519019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1519022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519041 */     // MIs[0] round
     /* 1519041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519044 */     // MIs[0] policy
     /* 1519044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519054 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1519057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519078 */     // GIR_Coverage, 18181,
     /* 1519078 */     GIR_EraseRootFromParent_Done,
     /* 1519079 */   // Label 21144: @1519079
     /* 1519079 */   GIM_Try, /*On fail goto*//*Label 21145*/ GIMT_Encode4(1519161), // Rule ID 18184 //
     /* 1519084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1519095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1519098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1519104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519123 */     // MIs[0] round
     /* 1519123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519126 */     // MIs[0] policy
     /* 1519126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519136 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1519139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519160 */     // GIR_Coverage, 18184,
     /* 1519160 */     GIR_EraseRootFromParent_Done,
     /* 1519161 */   // Label 21145: @1519161
     /* 1519161 */   GIM_Try, /*On fail goto*//*Label 21146*/ GIMT_Encode4(1519243), // Rule ID 18185 //
     /* 1519166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1519177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1519180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1519186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519205 */     // MIs[0] round
     /* 1519205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519208 */     // MIs[0] policy
     /* 1519208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519218 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1519221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519242 */     // GIR_Coverage, 18185,
     /* 1519242 */     GIR_EraseRootFromParent_Done,
     /* 1519243 */   // Label 21146: @1519243
     /* 1519243 */   GIM_Try, /*On fail goto*//*Label 21147*/ GIMT_Encode4(1519325), // Rule ID 18188 //
     /* 1519248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1519259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1519262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1519268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519287 */     // MIs[0] round
     /* 1519287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519290 */     // MIs[0] policy
     /* 1519290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519300 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1519303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519324 */     // GIR_Coverage, 18188,
     /* 1519324 */     GIR_EraseRootFromParent_Done,
     /* 1519325 */   // Label 21147: @1519325
     /* 1519325 */   GIM_Try, /*On fail goto*//*Label 21148*/ GIMT_Encode4(1519407), // Rule ID 18189 //
     /* 1519330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1519341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1519344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1519350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519369 */     // MIs[0] round
     /* 1519369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519372 */     // MIs[0] policy
     /* 1519372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519382 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1519385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519406 */     // GIR_Coverage, 18189,
     /* 1519406 */     GIR_EraseRootFromParent_Done,
     /* 1519407 */   // Label 21148: @1519407
     /* 1519407 */   GIM_Try, /*On fail goto*//*Label 21149*/ GIMT_Encode4(1519489), // Rule ID 18192 //
     /* 1519412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1519415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1519423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1519426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1519432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519451 */     // MIs[0] round
     /* 1519451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519454 */     // MIs[0] policy
     /* 1519454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519464 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1519467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519488 */     // GIR_Coverage, 18192,
     /* 1519488 */     GIR_EraseRootFromParent_Done,
     /* 1519489 */   // Label 21149: @1519489
     /* 1519489 */   GIM_Try, /*On fail goto*//*Label 21150*/ GIMT_Encode4(1519571), // Rule ID 18193 //
     /* 1519494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1519505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1519508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1519514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519533 */     // MIs[0] round
     /* 1519533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519536 */     // MIs[0] policy
     /* 1519536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519546 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1519549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519570 */     // GIR_Coverage, 18193,
     /* 1519570 */     GIR_EraseRootFromParent_Done,
     /* 1519571 */   // Label 21150: @1519571
     /* 1519571 */   GIM_Try, /*On fail goto*//*Label 21151*/ GIMT_Encode4(1519653), // Rule ID 18196 //
     /* 1519576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1519596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519615 */     // MIs[0] round
     /* 1519615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519618 */     // MIs[0] policy
     /* 1519618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519628 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1519631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519652 */     // GIR_Coverage, 18196,
     /* 1519652 */     GIR_EraseRootFromParent_Done,
     /* 1519653 */   // Label 21151: @1519653
     /* 1519653 */   GIM_Try, /*On fail goto*//*Label 21152*/ GIMT_Encode4(1519735), // Rule ID 18197 //
     /* 1519658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1519678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519697 */     // MIs[0] round
     /* 1519697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519700 */     // MIs[0] policy
     /* 1519700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519710 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1519713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519734 */     // GIR_Coverage, 18197,
     /* 1519734 */     GIR_EraseRootFromParent_Done,
     /* 1519735 */   // Label 21152: @1519735
     /* 1519735 */   GIM_Try, /*On fail goto*//*Label 21153*/ GIMT_Encode4(1519817), // Rule ID 18200 //
     /* 1519740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1519743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1519751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1519754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1519760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519779 */     // MIs[0] round
     /* 1519779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519782 */     // MIs[0] policy
     /* 1519782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519792 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1519795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519816 */     // GIR_Coverage, 18200,
     /* 1519816 */     GIR_EraseRootFromParent_Done,
     /* 1519817 */   // Label 21153: @1519817
     /* 1519817 */   GIM_Try, /*On fail goto*//*Label 21154*/ GIMT_Encode4(1519899), // Rule ID 18201 //
     /* 1519822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1519833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1519836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1519842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519861 */     // MIs[0] round
     /* 1519861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519864 */     // MIs[0] policy
     /* 1519864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519874 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1519877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519898 */     // GIR_Coverage, 18201,
     /* 1519898 */     GIR_EraseRootFromParent_Done,
     /* 1519899 */   // Label 21154: @1519899
     /* 1519899 */   GIM_Try, /*On fail goto*//*Label 21155*/ GIMT_Encode4(1519981), // Rule ID 18204 //
     /* 1519904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1519907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1519915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1519918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1519924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519943 */     // MIs[0] round
     /* 1519943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519946 */     // MIs[0] policy
     /* 1519946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519956 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1519959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519980 */     // GIR_Coverage, 18204,
     /* 1519980 */     GIR_EraseRootFromParent_Done,
     /* 1519981 */   // Label 21155: @1519981
     /* 1519981 */   GIM_Try, /*On fail goto*//*Label 21156*/ GIMT_Encode4(1520063), // Rule ID 18205 //
     /* 1519986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1519989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1519997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1520000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1520003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1520006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1520021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520025 */     // MIs[0] round
     /* 1520025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520028 */     // MIs[0] policy
     /* 1520028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520038 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1520041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520062 */     // GIR_Coverage, 18205,
     /* 1520062 */     GIR_EraseRootFromParent_Done,
     /* 1520063 */   // Label 21156: @1520063
     /* 1520063 */   GIM_Try, /*On fail goto*//*Label 21157*/ GIMT_Encode4(1520145), // Rule ID 18208 //
     /* 1520068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1520079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1520082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1520088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520107 */     // MIs[0] round
     /* 1520107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520110 */     // MIs[0] policy
     /* 1520110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520120 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1520123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520144 */     // GIR_Coverage, 18208,
     /* 1520144 */     GIR_EraseRootFromParent_Done,
     /* 1520145 */   // Label 21157: @1520145
     /* 1520145 */   GIM_Try, /*On fail goto*//*Label 21158*/ GIMT_Encode4(1520227), // Rule ID 18209 //
     /* 1520150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1520161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1520164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1520170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520189 */     // MIs[0] round
     /* 1520189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520192 */     // MIs[0] policy
     /* 1520192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520202 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1520205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520226 */     // GIR_Coverage, 18209,
     /* 1520226 */     GIR_EraseRootFromParent_Done,
     /* 1520227 */   // Label 21158: @1520227
     /* 1520227 */   GIM_Try, /*On fail goto*//*Label 21159*/ GIMT_Encode4(1520309), // Rule ID 18212 //
     /* 1520232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1520243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1520246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1520252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520271 */     // MIs[0] round
     /* 1520271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520274 */     // MIs[0] policy
     /* 1520274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520284 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1520287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520308 */     // GIR_Coverage, 18212,
     /* 1520308 */     GIR_EraseRootFromParent_Done,
     /* 1520309 */   // Label 21159: @1520309
     /* 1520309 */   GIM_Try, /*On fail goto*//*Label 21160*/ GIMT_Encode4(1520391), // Rule ID 18213 //
     /* 1520314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1520325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1520328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1520334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520353 */     // MIs[0] round
     /* 1520353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520356 */     // MIs[0] policy
     /* 1520356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520366 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1520369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520390 */     // GIR_Coverage, 18213,
     /* 1520390 */     GIR_EraseRootFromParent_Done,
     /* 1520391 */   // Label 21160: @1520391
     /* 1520391 */   GIM_Try, /*On fail goto*//*Label 21161*/ GIMT_Encode4(1520473), // Rule ID 18216 //
     /* 1520396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1520407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1520410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1520416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520435 */     // MIs[0] round
     /* 1520435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520438 */     // MIs[0] policy
     /* 1520438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520448 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1520451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520472 */     // GIR_Coverage, 18216,
     /* 1520472 */     GIR_EraseRootFromParent_Done,
     /* 1520473 */   // Label 21161: @1520473
     /* 1520473 */   GIM_Try, /*On fail goto*//*Label 21162*/ GIMT_Encode4(1520555), // Rule ID 18217 //
     /* 1520478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1520489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1520492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1520498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520517 */     // MIs[0] round
     /* 1520517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520520 */     // MIs[0] policy
     /* 1520520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520530 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1520533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520554 */     // GIR_Coverage, 18217,
     /* 1520554 */     GIR_EraseRootFromParent_Done,
     /* 1520555 */   // Label 21162: @1520555
     /* 1520555 */   GIM_Try, /*On fail goto*//*Label 21163*/ GIMT_Encode4(1520637), // Rule ID 18220 //
     /* 1520560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1520580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520599 */     // MIs[0] round
     /* 1520599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520602 */     // MIs[0] policy
     /* 1520602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520612 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1520615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520636 */     // GIR_Coverage, 18220,
     /* 1520636 */     GIR_EraseRootFromParent_Done,
     /* 1520637 */   // Label 21163: @1520637
     /* 1520637 */   GIM_Try, /*On fail goto*//*Label 21164*/ GIMT_Encode4(1520719), // Rule ID 18221 //
     /* 1520642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1520662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520681 */     // MIs[0] round
     /* 1520681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520684 */     // MIs[0] policy
     /* 1520684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520694 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1520697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520718 */     // GIR_Coverage, 18221,
     /* 1520718 */     GIR_EraseRootFromParent_Done,
     /* 1520719 */   // Label 21164: @1520719
     /* 1520719 */   GIM_Try, /*On fail goto*//*Label 21165*/ GIMT_Encode4(1520801), // Rule ID 18224 //
     /* 1520724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1520735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1520738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1520744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520763 */     // MIs[0] round
     /* 1520763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520766 */     // MIs[0] policy
     /* 1520766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520776 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1520779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520800 */     // GIR_Coverage, 18224,
     /* 1520800 */     GIR_EraseRootFromParent_Done,
     /* 1520801 */   // Label 21165: @1520801
     /* 1520801 */   GIM_Try, /*On fail goto*//*Label 21166*/ GIMT_Encode4(1520883), // Rule ID 18225 //
     /* 1520806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1520817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1520820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1520826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520845 */     // MIs[0] round
     /* 1520845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520848 */     // MIs[0] policy
     /* 1520848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520858 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1520861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520882 */     // GIR_Coverage, 18225,
     /* 1520882 */     GIR_EraseRootFromParent_Done,
     /* 1520883 */   // Label 21166: @1520883
     /* 1520883 */   GIM_Try, /*On fail goto*//*Label 21167*/ GIMT_Encode4(1520965), // Rule ID 18228 //
     /* 1520888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1520899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1520902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1520908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520927 */     // MIs[0] round
     /* 1520927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520930 */     // MIs[0] policy
     /* 1520930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520940 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1520943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520964 */     // GIR_Coverage, 18228,
     /* 1520964 */     GIR_EraseRootFromParent_Done,
     /* 1520965 */   // Label 21167: @1520965
     /* 1520965 */   GIM_Try, /*On fail goto*//*Label 21168*/ GIMT_Encode4(1521047), // Rule ID 18229 //
     /* 1520970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1520981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1520984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1520990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1521005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521009 */     // MIs[0] round
     /* 1521009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521012 */     // MIs[0] policy
     /* 1521012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521022 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1521025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521046 */     // GIR_Coverage, 18229,
     /* 1521046 */     GIR_EraseRootFromParent_Done,
     /* 1521047 */   // Label 21168: @1521047
     /* 1521047 */   GIM_Try, /*On fail goto*//*Label 21169*/ GIMT_Encode4(1521129), // Rule ID 18232 //
     /* 1521052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1521063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1521066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1521072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521091 */     // MIs[0] round
     /* 1521091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521094 */     // MIs[0] policy
     /* 1521094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521104 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1521107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521128 */     // GIR_Coverage, 18232,
     /* 1521128 */     GIR_EraseRootFromParent_Done,
     /* 1521129 */   // Label 21169: @1521129
     /* 1521129 */   GIM_Try, /*On fail goto*//*Label 21170*/ GIMT_Encode4(1521211), // Rule ID 18233 //
     /* 1521134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1521145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1521148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1521154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521173 */     // MIs[0] round
     /* 1521173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521176 */     // MIs[0] policy
     /* 1521176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521186 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1521189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521210 */     // GIR_Coverage, 18233,
     /* 1521210 */     GIR_EraseRootFromParent_Done,
     /* 1521211 */   // Label 21170: @1521211
     /* 1521211 */   GIM_Try, /*On fail goto*//*Label 21171*/ GIMT_Encode4(1521293), // Rule ID 18236 //
     /* 1521216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1521227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1521230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1521236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521255 */     // MIs[0] round
     /* 1521255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521258 */     // MIs[0] policy
     /* 1521258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521268 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1521271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521292 */     // GIR_Coverage, 18236,
     /* 1521292 */     GIR_EraseRootFromParent_Done,
     /* 1521293 */   // Label 21171: @1521293
     /* 1521293 */   GIM_Try, /*On fail goto*//*Label 21172*/ GIMT_Encode4(1521375), // Rule ID 18237 //
     /* 1521298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1521309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1521312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1521318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521337 */     // MIs[0] round
     /* 1521337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521340 */     // MIs[0] policy
     /* 1521340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521350 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1521353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521374 */     // GIR_Coverage, 18237,
     /* 1521374 */     GIR_EraseRootFromParent_Done,
     /* 1521375 */   // Label 21172: @1521375
     /* 1521375 */   GIM_Try, /*On fail goto*//*Label 21173*/ GIMT_Encode4(1521457), // Rule ID 18240 //
     /* 1521380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1521391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1521394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1521400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521419 */     // MIs[0] round
     /* 1521419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521422 */     // MIs[0] policy
     /* 1521422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521432 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1521435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521456 */     // GIR_Coverage, 18240,
     /* 1521456 */     GIR_EraseRootFromParent_Done,
     /* 1521457 */   // Label 21173: @1521457
     /* 1521457 */   GIM_Try, /*On fail goto*//*Label 21174*/ GIMT_Encode4(1521539), // Rule ID 18241 //
     /* 1521462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1521473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1521476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1521482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521501 */     // MIs[0] round
     /* 1521501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521504 */     // MIs[0] policy
     /* 1521504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521514 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1521517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521538 */     // GIR_Coverage, 18241,
     /* 1521538 */     GIR_EraseRootFromParent_Done,
     /* 1521539 */   // Label 21174: @1521539
     /* 1521539 */   GIM_Try, /*On fail goto*//*Label 21175*/ GIMT_Encode4(1521621), // Rule ID 18244 //
     /* 1521544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1521555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1521558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1521561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1521564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521583 */     // MIs[0] round
     /* 1521583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521586 */     // MIs[0] policy
     /* 1521586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521596 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1521599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521620 */     // GIR_Coverage, 18244,
     /* 1521620 */     GIR_EraseRootFromParent_Done,
     /* 1521621 */   // Label 21175: @1521621
     /* 1521621 */   GIM_Try, /*On fail goto*//*Label 21176*/ GIMT_Encode4(1521703), // Rule ID 18245 //
     /* 1521626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1521637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1521640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1521643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1521646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521665 */     // MIs[0] round
     /* 1521665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521668 */     // MIs[0] policy
     /* 1521668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521678 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1521681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521702 */     // GIR_Coverage, 18245,
     /* 1521702 */     GIR_EraseRootFromParent_Done,
     /* 1521703 */   // Label 21176: @1521703
     /* 1521703 */   GIM_Try, /*On fail goto*//*Label 21177*/ GIMT_Encode4(1521785), // Rule ID 18248 //
     /* 1521708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1521719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1521722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1521725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1521728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521747 */     // MIs[0] round
     /* 1521747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521750 */     // MIs[0] policy
     /* 1521750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521760 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1521763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521784 */     // GIR_Coverage, 18248,
     /* 1521784 */     GIR_EraseRootFromParent_Done,
     /* 1521785 */   // Label 21177: @1521785
     /* 1521785 */   GIM_Try, /*On fail goto*//*Label 21178*/ GIMT_Encode4(1521867), // Rule ID 18249 //
     /* 1521790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1521801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1521804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1521807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1521810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521829 */     // MIs[0] round
     /* 1521829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521832 */     // MIs[0] policy
     /* 1521832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521842 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1521845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521866 */     // GIR_Coverage, 18249,
     /* 1521866 */     GIR_EraseRootFromParent_Done,
     /* 1521867 */   // Label 21178: @1521867
     /* 1521867 */   GIM_Try, /*On fail goto*//*Label 21179*/ GIMT_Encode4(1521949), // Rule ID 18252 //
     /* 1521872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1521883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1521886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1521889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1521892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521911 */     // MIs[0] round
     /* 1521911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521914 */     // MIs[0] policy
     /* 1521914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521924 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1521927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521948 */     // GIR_Coverage, 18252,
     /* 1521948 */     GIR_EraseRootFromParent_Done,
     /* 1521949 */   // Label 21179: @1521949
     /* 1521949 */   GIM_Try, /*On fail goto*//*Label 21180*/ GIMT_Encode4(1522031), // Rule ID 18253 //
     /* 1521954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1521957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1521965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1521968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1521971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1521974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521993 */     // MIs[0] round
     /* 1521993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521996 */     // MIs[0] policy
     /* 1521996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522006 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1522009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522030 */     // GIR_Coverage, 18253,
     /* 1522030 */     GIR_EraseRootFromParent_Done,
     /* 1522031 */   // Label 21180: @1522031
     /* 1522031 */   GIM_Try, /*On fail goto*//*Label 21181*/ GIMT_Encode4(1522113), // Rule ID 18256 //
     /* 1522036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1522047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1522050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1522053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1522056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522075 */     // MIs[0] round
     /* 1522075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522078 */     // MIs[0] policy
     /* 1522078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522088 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1522091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522112 */     // GIR_Coverage, 18256,
     /* 1522112 */     GIR_EraseRootFromParent_Done,
     /* 1522113 */   // Label 21181: @1522113
     /* 1522113 */   GIM_Try, /*On fail goto*//*Label 21182*/ GIMT_Encode4(1522195), // Rule ID 18257 //
     /* 1522118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1522129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1522132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1522135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1522138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522157 */     // MIs[0] round
     /* 1522157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522160 */     // MIs[0] policy
     /* 1522160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522170 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1522173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522194 */     // GIR_Coverage, 18257,
     /* 1522194 */     GIR_EraseRootFromParent_Done,
     /* 1522195 */   // Label 21182: @1522195
     /* 1522195 */   GIM_Try, /*On fail goto*//*Label 21183*/ GIMT_Encode4(1522277), // Rule ID 18260 //
     /* 1522200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1522211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1522214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1522217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1522220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522239 */     // MIs[0] round
     /* 1522239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522242 */     // MIs[0] policy
     /* 1522242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1522255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522276 */     // GIR_Coverage, 18260,
     /* 1522276 */     GIR_EraseRootFromParent_Done,
     /* 1522277 */   // Label 21183: @1522277
     /* 1522277 */   GIM_Try, /*On fail goto*//*Label 21184*/ GIMT_Encode4(1522359), // Rule ID 18261 //
     /* 1522282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1522293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1522296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1522299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1522302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522321 */     // MIs[0] round
     /* 1522321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522324 */     // MIs[0] policy
     /* 1522324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522334 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1522337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522358 */     // GIR_Coverage, 18261,
     /* 1522358 */     GIR_EraseRootFromParent_Done,
     /* 1522359 */   // Label 21184: @1522359
     /* 1522359 */   GIM_Try, /*On fail goto*//*Label 21185*/ GIMT_Encode4(1522441), // Rule ID 18264 //
     /* 1522364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1522367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1522375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1522378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1522381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1522384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522403 */     // MIs[0] round
     /* 1522403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522406 */     // MIs[0] policy
     /* 1522406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522416 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1522419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522440 */     // GIR_Coverage, 18264,
     /* 1522440 */     GIR_EraseRootFromParent_Done,
     /* 1522441 */   // Label 21185: @1522441
     /* 1522441 */   GIM_Try, /*On fail goto*//*Label 21186*/ GIMT_Encode4(1522523), // Rule ID 18265 //
     /* 1522446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1522449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1522457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1522460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1522463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1522466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522485 */     // MIs[0] round
     /* 1522485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522488 */     // MIs[0] policy
     /* 1522488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522498 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1522501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522522 */     // GIR_Coverage, 18265,
     /* 1522522 */     GIR_EraseRootFromParent_Done,
     /* 1522523 */   // Label 21186: @1522523
     /* 1522523 */   GIM_Try, /*On fail goto*//*Label 21187*/ GIMT_Encode4(1522605), // Rule ID 18268 //
     /* 1522528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1522545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1522548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522567 */     // MIs[0] round
     /* 1522567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522570 */     // MIs[0] policy
     /* 1522570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522580 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1522583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522604 */     // GIR_Coverage, 18268,
     /* 1522604 */     GIR_EraseRootFromParent_Done,
     /* 1522605 */   // Label 21187: @1522605
     /* 1522605 */   GIM_Try, /*On fail goto*//*Label 21188*/ GIMT_Encode4(1522687), // Rule ID 18269 //
     /* 1522610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1522627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1522630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522649 */     // MIs[0] round
     /* 1522649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522652 */     // MIs[0] policy
     /* 1522652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522662 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1522665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522686 */     // GIR_Coverage, 18269,
     /* 1522686 */     GIR_EraseRootFromParent_Done,
     /* 1522687 */   // Label 21188: @1522687
     /* 1522687 */   GIM_Try, /*On fail goto*//*Label 21189*/ GIMT_Encode4(1522769), // Rule ID 18272 //
     /* 1522692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1522703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1522706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1522709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1522712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522731 */     // MIs[0] round
     /* 1522731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522734 */     // MIs[0] policy
     /* 1522734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522744 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1522747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522768 */     // GIR_Coverage, 18272,
     /* 1522768 */     GIR_EraseRootFromParent_Done,
     /* 1522769 */   // Label 21189: @1522769
     /* 1522769 */   GIM_Try, /*On fail goto*//*Label 21190*/ GIMT_Encode4(1522851), // Rule ID 18273 //
     /* 1522774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1522785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1522788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1522791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1522794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522813 */     // MIs[0] round
     /* 1522813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522816 */     // MIs[0] policy
     /* 1522816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522826 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1522829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522850 */     // GIR_Coverage, 18273,
     /* 1522850 */     GIR_EraseRootFromParent_Done,
     /* 1522851 */   // Label 21190: @1522851
     /* 1522851 */   GIM_Try, /*On fail goto*//*Label 21191*/ GIMT_Encode4(1522933), // Rule ID 18276 //
     /* 1522856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1522867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1522870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1522873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1522876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522895 */     // MIs[0] round
     /* 1522895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522898 */     // MIs[0] policy
     /* 1522898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522908 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1522911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522932 */     // GIR_Coverage, 18276,
     /* 1522932 */     GIR_EraseRootFromParent_Done,
     /* 1522933 */   // Label 21191: @1522933
     /* 1522933 */   GIM_Try, /*On fail goto*//*Label 21192*/ GIMT_Encode4(1523015), // Rule ID 18277 //
     /* 1522938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1522949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1522952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1522955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1522958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522977 */     // MIs[0] round
     /* 1522977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522980 */     // MIs[0] policy
     /* 1522980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522990 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1522993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523014 */     // GIR_Coverage, 18277,
     /* 1523014 */     GIR_EraseRootFromParent_Done,
     /* 1523015 */   // Label 21192: @1523015
     /* 1523015 */   GIM_Try, /*On fail goto*//*Label 21193*/ GIMT_Encode4(1523097), // Rule ID 18280 //
     /* 1523020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1523031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1523034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1523037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1523040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523059 */     // MIs[0] round
     /* 1523059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523062 */     // MIs[0] policy
     /* 1523062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523072 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1523075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523096 */     // GIR_Coverage, 18280,
     /* 1523096 */     GIR_EraseRootFromParent_Done,
     /* 1523097 */   // Label 21193: @1523097
     /* 1523097 */   GIM_Try, /*On fail goto*//*Label 21194*/ GIMT_Encode4(1523179), // Rule ID 18281 //
     /* 1523102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1523113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1523116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1523119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1523122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523141 */     // MIs[0] round
     /* 1523141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523144 */     // MIs[0] policy
     /* 1523144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523154 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1523157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523178 */     // GIR_Coverage, 18281,
     /* 1523178 */     GIR_EraseRootFromParent_Done,
     /* 1523179 */   // Label 21194: @1523179
     /* 1523179 */   GIM_Try, /*On fail goto*//*Label 21195*/ GIMT_Encode4(1523261), // Rule ID 18284 //
     /* 1523184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1523195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1523198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1523201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1523204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523223 */     // MIs[0] round
     /* 1523223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523226 */     // MIs[0] policy
     /* 1523226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1523239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523260 */     // GIR_Coverage, 18284,
     /* 1523260 */     GIR_EraseRootFromParent_Done,
     /* 1523261 */   // Label 21195: @1523261
     /* 1523261 */   GIM_Try, /*On fail goto*//*Label 21196*/ GIMT_Encode4(1523343), // Rule ID 18285 //
     /* 1523266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1523277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1523280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1523283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1523286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523305 */     // MIs[0] round
     /* 1523305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523308 */     // MIs[0] policy
     /* 1523308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523318 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1523321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523342 */     // GIR_Coverage, 18285,
     /* 1523342 */     GIR_EraseRootFromParent_Done,
     /* 1523343 */   // Label 21196: @1523343
     /* 1523343 */   GIM_Try, /*On fail goto*//*Label 21197*/ GIMT_Encode4(1523425), // Rule ID 18288 //
     /* 1523348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1523359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1523362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1523365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1523368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523387 */     // MIs[0] round
     /* 1523387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523390 */     // MIs[0] policy
     /* 1523390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523400 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1523403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523424 */     // GIR_Coverage, 18288,
     /* 1523424 */     GIR_EraseRootFromParent_Done,
     /* 1523425 */   // Label 21197: @1523425
     /* 1523425 */   GIM_Try, /*On fail goto*//*Label 21198*/ GIMT_Encode4(1523507), // Rule ID 18289 //
     /* 1523430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1523441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1523444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1523447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1523450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523469 */     // MIs[0] round
     /* 1523469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523472 */     // MIs[0] policy
     /* 1523472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523482 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1523485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523506 */     // GIR_Coverage, 18289,
     /* 1523506 */     GIR_EraseRootFromParent_Done,
     /* 1523507 */   // Label 21198: @1523507
     /* 1523507 */   GIM_Try, /*On fail goto*//*Label 21199*/ GIMT_Encode4(1523589), // Rule ID 18292 //
     /* 1523512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1523523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1523526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1523529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1523532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523551 */     // MIs[0] round
     /* 1523551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523554 */     // MIs[0] policy
     /* 1523554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523564 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1523567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523588 */     // GIR_Coverage, 18292,
     /* 1523588 */     GIR_EraseRootFromParent_Done,
     /* 1523589 */   // Label 21199: @1523589
     /* 1523589 */   GIM_Try, /*On fail goto*//*Label 21200*/ GIMT_Encode4(1523671), // Rule ID 18293 //
     /* 1523594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1523605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1523608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1523611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1523614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523633 */     // MIs[0] round
     /* 1523633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523636 */     // MIs[0] policy
     /* 1523636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523646 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1523649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523670 */     // GIR_Coverage, 18293,
     /* 1523670 */     GIR_EraseRootFromParent_Done,
     /* 1523671 */   // Label 21200: @1523671
     /* 1523671 */   GIM_Try, /*On fail goto*//*Label 21201*/ GIMT_Encode4(1523753), // Rule ID 18296 //
     /* 1523676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1523687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1523690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1523693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1523696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523715 */     // MIs[0] round
     /* 1523715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523718 */     // MIs[0] policy
     /* 1523718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523728 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1523731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523752 */     // GIR_Coverage, 18296,
     /* 1523752 */     GIR_EraseRootFromParent_Done,
     /* 1523753 */   // Label 21201: @1523753
     /* 1523753 */   GIM_Try, /*On fail goto*//*Label 21202*/ GIMT_Encode4(1523835), // Rule ID 18297 //
     /* 1523758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1523769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1523772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1523775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1523778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523797 */     // MIs[0] round
     /* 1523797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523800 */     // MIs[0] policy
     /* 1523800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523810 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1523813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523834 */     // GIR_Coverage, 18297,
     /* 1523834 */     GIR_EraseRootFromParent_Done,
     /* 1523835 */   // Label 21202: @1523835
     /* 1523835 */   GIM_Try, /*On fail goto*//*Label 21203*/ GIMT_Encode4(1523917), // Rule ID 18300 //
     /* 1523840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1523851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1523854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1523857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1523860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523879 */     // MIs[0] round
     /* 1523879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523882 */     // MIs[0] policy
     /* 1523882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523892 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1523895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523916 */     // GIR_Coverage, 18300,
     /* 1523916 */     GIR_EraseRootFromParent_Done,
     /* 1523917 */   // Label 21203: @1523917
     /* 1523917 */   GIM_Try, /*On fail goto*//*Label 21204*/ GIMT_Encode4(1523999), // Rule ID 18301 //
     /* 1523922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1523933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1523936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1523939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1523942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523961 */     // MIs[0] round
     /* 1523961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523964 */     // MIs[0] policy
     /* 1523964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523974 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1523977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523998 */     // GIR_Coverage, 18301,
     /* 1523998 */     GIR_EraseRootFromParent_Done,
     /* 1523999 */   // Label 21204: @1523999
     /* 1523999 */   GIM_Try, /*On fail goto*//*Label 21205*/ GIMT_Encode4(1524081), // Rule ID 18304 //
     /* 1524004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1524015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1524018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1524024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524043 */     // MIs[0] round
     /* 1524043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524046 */     // MIs[0] policy
     /* 1524046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524056 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1524059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524080 */     // GIR_Coverage, 18304,
     /* 1524080 */     GIR_EraseRootFromParent_Done,
     /* 1524081 */   // Label 21205: @1524081
     /* 1524081 */   GIM_Try, /*On fail goto*//*Label 21206*/ GIMT_Encode4(1524163), // Rule ID 18305 //
     /* 1524086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1524097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1524100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1524106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524125 */     // MIs[0] round
     /* 1524125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524128 */     // MIs[0] policy
     /* 1524128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524138 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1524141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524162 */     // GIR_Coverage, 18305,
     /* 1524162 */     GIR_EraseRootFromParent_Done,
     /* 1524163 */   // Label 21206: @1524163
     /* 1524163 */   GIM_Try, /*On fail goto*//*Label 21207*/ GIMT_Encode4(1524245), // Rule ID 18308 //
     /* 1524168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1524179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1524182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1524188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524207 */     // MIs[0] round
     /* 1524207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524210 */     // MIs[0] policy
     /* 1524210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524220 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1524223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524244 */     // GIR_Coverage, 18308,
     /* 1524244 */     GIR_EraseRootFromParent_Done,
     /* 1524245 */   // Label 21207: @1524245
     /* 1524245 */   GIM_Try, /*On fail goto*//*Label 21208*/ GIMT_Encode4(1524327), // Rule ID 18309 //
     /* 1524250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1524261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1524264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1524270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524289 */     // MIs[0] round
     /* 1524289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524292 */     // MIs[0] policy
     /* 1524292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524302 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1524305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524326 */     // GIR_Coverage, 18309,
     /* 1524326 */     GIR_EraseRootFromParent_Done,
     /* 1524327 */   // Label 21208: @1524327
     /* 1524327 */   GIM_Try, /*On fail goto*//*Label 21209*/ GIMT_Encode4(1524409), // Rule ID 18312 //
     /* 1524332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1524335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1524343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1524346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1524352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524371 */     // MIs[0] round
     /* 1524371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524374 */     // MIs[0] policy
     /* 1524374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524384 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1524387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524408 */     // GIR_Coverage, 18312,
     /* 1524408 */     GIR_EraseRootFromParent_Done,
     /* 1524409 */   // Label 21209: @1524409
     /* 1524409 */   GIM_Try, /*On fail goto*//*Label 21210*/ GIMT_Encode4(1524491), // Rule ID 18313 //
     /* 1524414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1524417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1524425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1524428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1524434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524453 */     // MIs[0] round
     /* 1524453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524456 */     // MIs[0] policy
     /* 1524456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524466 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1524469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524490 */     // GIR_Coverage, 18313,
     /* 1524490 */     GIR_EraseRootFromParent_Done,
     /* 1524491 */   // Label 21210: @1524491
     /* 1524491 */   GIM_Try, /*On fail goto*//*Label 21211*/ GIMT_Encode4(1524573), // Rule ID 18316 //
     /* 1524496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1524516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524535 */     // MIs[0] round
     /* 1524535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524538 */     // MIs[0] policy
     /* 1524538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524548 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1524551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524572 */     // GIR_Coverage, 18316,
     /* 1524572 */     GIR_EraseRootFromParent_Done,
     /* 1524573 */   // Label 21211: @1524573
     /* 1524573 */   GIM_Try, /*On fail goto*//*Label 21212*/ GIMT_Encode4(1524655), // Rule ID 18317 //
     /* 1524578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1524598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524617 */     // MIs[0] round
     /* 1524617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524620 */     // MIs[0] policy
     /* 1524620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524630 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1524633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524654 */     // GIR_Coverage, 18317,
     /* 1524654 */     GIR_EraseRootFromParent_Done,
     /* 1524655 */   // Label 21212: @1524655
     /* 1524655 */   GIM_Try, /*On fail goto*//*Label 21213*/ GIMT_Encode4(1524737), // Rule ID 18320 //
     /* 1524660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1524663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1524671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1524674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1524680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524699 */     // MIs[0] round
     /* 1524699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524702 */     // MIs[0] policy
     /* 1524702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524712 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1524715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524736 */     // GIR_Coverage, 18320,
     /* 1524736 */     GIR_EraseRootFromParent_Done,
     /* 1524737 */   // Label 21213: @1524737
     /* 1524737 */   GIM_Try, /*On fail goto*//*Label 21214*/ GIMT_Encode4(1524819), // Rule ID 18321 //
     /* 1524742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1524745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1524753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1524756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1524762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524781 */     // MIs[0] round
     /* 1524781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524784 */     // MIs[0] policy
     /* 1524784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524794 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1524797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524818 */     // GIR_Coverage, 18321,
     /* 1524818 */     GIR_EraseRootFromParent_Done,
     /* 1524819 */   // Label 21214: @1524819
     /* 1524819 */   GIM_Try, /*On fail goto*//*Label 21215*/ GIMT_Encode4(1524901), // Rule ID 18324 //
     /* 1524824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1524827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1524835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1524838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1524844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524863 */     // MIs[0] round
     /* 1524863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524866 */     // MIs[0] policy
     /* 1524866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524876 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1524879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524900 */     // GIR_Coverage, 18324,
     /* 1524900 */     GIR_EraseRootFromParent_Done,
     /* 1524901 */   // Label 21215: @1524901
     /* 1524901 */   GIM_Try, /*On fail goto*//*Label 21216*/ GIMT_Encode4(1524983), // Rule ID 18325 //
     /* 1524906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1524909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1524917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1524920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1524926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524945 */     // MIs[0] round
     /* 1524945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524948 */     // MIs[0] policy
     /* 1524948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524958 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1524961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524982 */     // GIR_Coverage, 18325,
     /* 1524982 */     GIR_EraseRootFromParent_Done,
     /* 1524983 */   // Label 21216: @1524983
     /* 1524983 */   GIM_Try, /*On fail goto*//*Label 21217*/ GIMT_Encode4(1525065), // Rule ID 18328 //
     /* 1524988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1524999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1525002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1525005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1525008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1525023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525027 */     // MIs[0] round
     /* 1525027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525030 */     // MIs[0] policy
     /* 1525030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525040 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1525043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525064 */     // GIR_Coverage, 18328,
     /* 1525064 */     GIR_EraseRootFromParent_Done,
     /* 1525065 */   // Label 21217: @1525065
     /* 1525065 */   GIM_Try, /*On fail goto*//*Label 21218*/ GIMT_Encode4(1525147), // Rule ID 18329 //
     /* 1525070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1525081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1525084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1525087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1525090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1525105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525109 */     // MIs[0] round
     /* 1525109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525112 */     // MIs[0] policy
     /* 1525112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525122 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1525125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525146 */     // GIR_Coverage, 18329,
     /* 1525146 */     GIR_EraseRootFromParent_Done,
     /* 1525147 */   // Label 21218: @1525147
     /* 1525147 */   GIM_Try, /*On fail goto*//*Label 21219*/ GIMT_Encode4(1525229), // Rule ID 18332 //
     /* 1525152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1525155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1525163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1525166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1525169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1525172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1525187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525191 */     // MIs[0] round
     /* 1525191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525194 */     // MIs[0] policy
     /* 1525194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525204 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1525207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525228 */     // GIR_Coverage, 18332,
     /* 1525228 */     GIR_EraseRootFromParent_Done,
     /* 1525229 */   // Label 21219: @1525229
     /* 1525229 */   GIM_Try, /*On fail goto*//*Label 21220*/ GIMT_Encode4(1525311), // Rule ID 18333 //
     /* 1525234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1525245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1525248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1525251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1525254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1525269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525273 */     // MIs[0] round
     /* 1525273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525276 */     // MIs[0] policy
     /* 1525276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525286 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1525289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525310 */     // GIR_Coverage, 18333,
     /* 1525310 */     GIR_EraseRootFromParent_Done,
     /* 1525311 */   // Label 21220: @1525311
     /* 1525311 */   GIM_Try, /*On fail goto*//*Label 21221*/ GIMT_Encode4(1525393), // Rule ID 18336 //
     /* 1525316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1525319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1525327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1525330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1525333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1525336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1525351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525355 */     // MIs[0] round
     /* 1525355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525358 */     // MIs[0] policy
     /* 1525358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525368 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1525371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525392 */     // GIR_Coverage, 18336,
     /* 1525392 */     GIR_EraseRootFromParent_Done,
     /* 1525393 */   // Label 21221: @1525393
     /* 1525393 */   GIM_Try, /*On fail goto*//*Label 21222*/ GIMT_Encode4(1525475), // Rule ID 18337 //
     /* 1525398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1525409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1525412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1525415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1525418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1525433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525437 */     // MIs[0] round
     /* 1525437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525440 */     // MIs[0] policy
     /* 1525440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525450 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1525453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525474 */     // GIR_Coverage, 18337,
     /* 1525474 */     GIR_EraseRootFromParent_Done,
     /* 1525475 */   // Label 21222: @1525475
     /* 1525475 */   GIM_Try, /*On fail goto*//*Label 21223*/ GIMT_Encode4(1525557), // Rule ID 18340 //
     /* 1525480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1525500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525519 */     // MIs[0] round
     /* 1525519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525522 */     // MIs[0] policy
     /* 1525522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525532 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1525535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525556 */     // GIR_Coverage, 18340,
     /* 1525556 */     GIR_EraseRootFromParent_Done,
     /* 1525557 */   // Label 21223: @1525557
     /* 1525557 */   GIM_Try, /*On fail goto*//*Label 21224*/ GIMT_Encode4(1525639), // Rule ID 18341 //
     /* 1525562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1525582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525601 */     // MIs[0] round
     /* 1525601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525604 */     // MIs[0] policy
     /* 1525604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525614 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1525617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525638 */     // GIR_Coverage, 18341,
     /* 1525638 */     GIR_EraseRootFromParent_Done,
     /* 1525639 */   // Label 21224: @1525639
     /* 1525639 */   GIM_Try, /*On fail goto*//*Label 21225*/ GIMT_Encode4(1525721), // Rule ID 18344 //
     /* 1525644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1525655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1525658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1525664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525683 */     // MIs[0] round
     /* 1525683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525686 */     // MIs[0] policy
     /* 1525686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525696 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1525699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525720 */     // GIR_Coverage, 18344,
     /* 1525720 */     GIR_EraseRootFromParent_Done,
     /* 1525721 */   // Label 21225: @1525721
     /* 1525721 */   GIM_Try, /*On fail goto*//*Label 21226*/ GIMT_Encode4(1525803), // Rule ID 18345 //
     /* 1525726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1525737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1525740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1525746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525765 */     // MIs[0] round
     /* 1525765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525768 */     // MIs[0] policy
     /* 1525768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525778 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1525781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525802 */     // GIR_Coverage, 18345,
     /* 1525802 */     GIR_EraseRootFromParent_Done,
     /* 1525803 */   // Label 21226: @1525803
     /* 1525803 */   GIM_Try, /*On fail goto*//*Label 21227*/ GIMT_Encode4(1525885), // Rule ID 18348 //
     /* 1525808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1525819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1525822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1525828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525847 */     // MIs[0] round
     /* 1525847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525850 */     // MIs[0] policy
     /* 1525850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525860 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1525863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525884 */     // GIR_Coverage, 18348,
     /* 1525884 */     GIR_EraseRootFromParent_Done,
     /* 1525885 */   // Label 21227: @1525885
     /* 1525885 */   GIM_Try, /*On fail goto*//*Label 21228*/ GIMT_Encode4(1525967), // Rule ID 18349 //
     /* 1525890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1525901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1525904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1525910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525929 */     // MIs[0] round
     /* 1525929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525932 */     // MIs[0] policy
     /* 1525932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525942 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1525945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525966 */     // GIR_Coverage, 18349,
     /* 1525966 */     GIR_EraseRootFromParent_Done,
     /* 1525967 */   // Label 21228: @1525967
     /* 1525967 */   GIM_Try, /*On fail goto*//*Label 21229*/ GIMT_Encode4(1526049), // Rule ID 18352 //
     /* 1525972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1525975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1525983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1525986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1525992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1526007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526011 */     // MIs[0] round
     /* 1526011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526014 */     // MIs[0] policy
     /* 1526014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526024 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1526027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526048 */     // GIR_Coverage, 18352,
     /* 1526048 */     GIR_EraseRootFromParent_Done,
     /* 1526049 */   // Label 21229: @1526049
     /* 1526049 */   GIM_Try, /*On fail goto*//*Label 21230*/ GIMT_Encode4(1526131), // Rule ID 18353 //
     /* 1526054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1526065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1526068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1526071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1526074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1526089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526093 */     // MIs[0] round
     /* 1526093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526096 */     // MIs[0] policy
     /* 1526096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526106 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1526109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526130 */     // GIR_Coverage, 18353,
     /* 1526130 */     GIR_EraseRootFromParent_Done,
     /* 1526131 */   // Label 21230: @1526131
     /* 1526131 */   GIM_Try, /*On fail goto*//*Label 21231*/ GIMT_Encode4(1526213), // Rule ID 18356 //
     /* 1526136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1526139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1526147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1526150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1526153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1526156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1526171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526175 */     // MIs[0] round
     /* 1526175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526178 */     // MIs[0] policy
     /* 1526178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526188 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1526191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526212 */     // GIR_Coverage, 18356,
     /* 1526212 */     GIR_EraseRootFromParent_Done,
     /* 1526213 */   // Label 21231: @1526213
     /* 1526213 */   GIM_Try, /*On fail goto*//*Label 21232*/ GIMT_Encode4(1526295), // Rule ID 18357 //
     /* 1526218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1526229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1526232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1526235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1526238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1526253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526257 */     // MIs[0] round
     /* 1526257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526260 */     // MIs[0] policy
     /* 1526260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526270 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1526273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526294 */     // GIR_Coverage, 18357,
     /* 1526294 */     GIR_EraseRootFromParent_Done,
     /* 1526295 */   // Label 21232: @1526295
     /* 1526295 */   GIM_Try, /*On fail goto*//*Label 21233*/ GIMT_Encode4(1526377), // Rule ID 18360 //
     /* 1526300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1526303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1526311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1526314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1526317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1526320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1526335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526339 */     // MIs[0] round
     /* 1526339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526342 */     // MIs[0] policy
     /* 1526342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526352 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1526355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526376 */     // GIR_Coverage, 18360,
     /* 1526376 */     GIR_EraseRootFromParent_Done,
     /* 1526377 */   // Label 21233: @1526377
     /* 1526377 */   GIM_Try, /*On fail goto*//*Label 21234*/ GIMT_Encode4(1526459), // Rule ID 18361 //
     /* 1526382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1526393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1526396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1526399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1526402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1526417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526421 */     // MIs[0] round
     /* 1526421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526424 */     // MIs[0] policy
     /* 1526424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526434 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1526437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526458 */     // GIR_Coverage, 18361,
     /* 1526458 */     GIR_EraseRootFromParent_Done,
     /* 1526459 */   // Label 21234: @1526459
     /* 1526459 */   GIM_Try, /*On fail goto*//*Label 21235*/ GIMT_Encode4(1526541), // Rule ID 18364 //
     /* 1526464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1526475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1526478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1526481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1526484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526503 */     // MIs[0] round
     /* 1526503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526506 */     // MIs[0] policy
     /* 1526506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526516 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1526519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526540 */     // GIR_Coverage, 18364,
     /* 1526540 */     GIR_EraseRootFromParent_Done,
     /* 1526541 */   // Label 21235: @1526541
     /* 1526541 */   GIM_Try, /*On fail goto*//*Label 21236*/ GIMT_Encode4(1526623), // Rule ID 18365 //
     /* 1526546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1526557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1526560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1526563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1526566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526585 */     // MIs[0] round
     /* 1526585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526588 */     // MIs[0] policy
     /* 1526588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526598 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1526601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526622 */     // GIR_Coverage, 18365,
     /* 1526622 */     GIR_EraseRootFromParent_Done,
     /* 1526623 */   // Label 21236: @1526623
     /* 1526623 */   GIM_Try, /*On fail goto*//*Label 21237*/ GIMT_Encode4(1526705), // Rule ID 18368 //
     /* 1526628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1526639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1526642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1526645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1526648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526667 */     // MIs[0] round
     /* 1526667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526670 */     // MIs[0] policy
     /* 1526670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526680 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1526683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526704 */     // GIR_Coverage, 18368,
     /* 1526704 */     GIR_EraseRootFromParent_Done,
     /* 1526705 */   // Label 21237: @1526705
     /* 1526705 */   GIM_Try, /*On fail goto*//*Label 21238*/ GIMT_Encode4(1526787), // Rule ID 18369 //
     /* 1526710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1526721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1526724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1526727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1526730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526749 */     // MIs[0] round
     /* 1526749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526752 */     // MIs[0] policy
     /* 1526752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526762 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1526765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526786 */     // GIR_Coverage, 18369,
     /* 1526786 */     GIR_EraseRootFromParent_Done,
     /* 1526787 */   // Label 21238: @1526787
     /* 1526787 */   GIM_Try, /*On fail goto*//*Label 21239*/ GIMT_Encode4(1526869), // Rule ID 18372 //
     /* 1526792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1526795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1526803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1526806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1526809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1526812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526831 */     // MIs[0] round
     /* 1526831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526834 */     // MIs[0] policy
     /* 1526834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526844 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1526847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526868 */     // GIR_Coverage, 18372,
     /* 1526868 */     GIR_EraseRootFromParent_Done,
     /* 1526869 */   // Label 21239: @1526869
     /* 1526869 */   GIM_Try, /*On fail goto*//*Label 21240*/ GIMT_Encode4(1526951), // Rule ID 18373 //
     /* 1526874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1526885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1526888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1526891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1526894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526913 */     // MIs[0] round
     /* 1526913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526916 */     // MIs[0] policy
     /* 1526916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526926 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1526929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526950 */     // GIR_Coverage, 18373,
     /* 1526950 */     GIR_EraseRootFromParent_Done,
     /* 1526951 */   // Label 21240: @1526951
     /* 1526951 */   GIM_Try, /*On fail goto*//*Label 21241*/ GIMT_Encode4(1527033), // Rule ID 18376 //
     /* 1526956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1526967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1526970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1526973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1526976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526995 */     // MIs[0] round
     /* 1526995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526998 */     // MIs[0] policy
     /* 1526998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527008 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1527011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527032 */     // GIR_Coverage, 18376,
     /* 1527032 */     GIR_EraseRootFromParent_Done,
     /* 1527033 */   // Label 21241: @1527033
     /* 1527033 */   GIM_Try, /*On fail goto*//*Label 21242*/ GIMT_Encode4(1527115), // Rule ID 18377 //
     /* 1527038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1527049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1527052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1527055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1527058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527077 */     // MIs[0] round
     /* 1527077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527080 */     // MIs[0] policy
     /* 1527080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527090 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1527093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527114 */     // GIR_Coverage, 18377,
     /* 1527114 */     GIR_EraseRootFromParent_Done,
     /* 1527115 */   // Label 21242: @1527115
     /* 1527115 */   GIM_Try, /*On fail goto*//*Label 21243*/ GIMT_Encode4(1527197), // Rule ID 18380 //
     /* 1527120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1527131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1527134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1527137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1527140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527159 */     // MIs[0] round
     /* 1527159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527162 */     // MIs[0] policy
     /* 1527162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527172 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1527175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527196 */     // GIR_Coverage, 18380,
     /* 1527196 */     GIR_EraseRootFromParent_Done,
     /* 1527197 */   // Label 21243: @1527197
     /* 1527197 */   GIM_Try, /*On fail goto*//*Label 21244*/ GIMT_Encode4(1527279), // Rule ID 18381 //
     /* 1527202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1527213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1527216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1527219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1527222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527241 */     // MIs[0] round
     /* 1527241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527244 */     // MIs[0] policy
     /* 1527244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527254 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1527257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527278 */     // GIR_Coverage, 18381,
     /* 1527278 */     GIR_EraseRootFromParent_Done,
     /* 1527279 */   // Label 21244: @1527279
     /* 1527279 */   GIM_Try, /*On fail goto*//*Label 21245*/ GIMT_Encode4(1527361), // Rule ID 18384 //
     /* 1527284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1527287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1527295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1527298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1527301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1527304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527323 */     // MIs[0] round
     /* 1527323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527326 */     // MIs[0] policy
     /* 1527326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527336 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1527339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527360 */     // GIR_Coverage, 18384,
     /* 1527360 */     GIR_EraseRootFromParent_Done,
     /* 1527361 */   // Label 21245: @1527361
     /* 1527361 */   GIM_Try, /*On fail goto*//*Label 21246*/ GIMT_Encode4(1527443), // Rule ID 18385 //
     /* 1527366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1527369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1527377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1527380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1527383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1527386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527405 */     // MIs[0] round
     /* 1527405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527408 */     // MIs[0] policy
     /* 1527408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527418 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1527421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527442 */     // GIR_Coverage, 18385,
     /* 1527442 */     GIR_EraseRootFromParent_Done,
     /* 1527443 */   // Label 21246: @1527443
     /* 1527443 */   GIM_Try, /*On fail goto*//*Label 21247*/ GIMT_Encode4(1527525), // Rule ID 18388 //
     /* 1527448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1527459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1527465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1527468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527487 */     // MIs[0] round
     /* 1527487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527490 */     // MIs[0] policy
     /* 1527490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527500 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1527503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527524 */     // GIR_Coverage, 18388,
     /* 1527524 */     GIR_EraseRootFromParent_Done,
     /* 1527525 */   // Label 21247: @1527525
     /* 1527525 */   GIM_Try, /*On fail goto*//*Label 21248*/ GIMT_Encode4(1527607), // Rule ID 18389 //
     /* 1527530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1527541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1527547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1527550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527569 */     // MIs[0] round
     /* 1527569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527572 */     // MIs[0] policy
     /* 1527572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527582 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1527585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527606 */     // GIR_Coverage, 18389,
     /* 1527606 */     GIR_EraseRootFromParent_Done,
     /* 1527607 */   // Label 21248: @1527607
     /* 1527607 */   GIM_Try, /*On fail goto*//*Label 21249*/ GIMT_Encode4(1527689), // Rule ID 18392 //
     /* 1527612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1527629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1527632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527651 */     // MIs[0] round
     /* 1527651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527654 */     // MIs[0] policy
     /* 1527654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527664 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1527667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527688 */     // GIR_Coverage, 18392,
     /* 1527688 */     GIR_EraseRootFromParent_Done,
     /* 1527689 */   // Label 21249: @1527689
     /* 1527689 */   GIM_Try, /*On fail goto*//*Label 21250*/ GIMT_Encode4(1527771), // Rule ID 18393 //
     /* 1527694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1527711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1527714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527733 */     // MIs[0] round
     /* 1527733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527736 */     // MIs[0] policy
     /* 1527736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527746 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1527749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527770 */     // GIR_Coverage, 18393,
     /* 1527770 */     GIR_EraseRootFromParent_Done,
     /* 1527771 */   // Label 21250: @1527771
     /* 1527771 */   GIM_Try, /*On fail goto*//*Label 21251*/ GIMT_Encode4(1527853), // Rule ID 18396 //
     /* 1527776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1527787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1527790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1527793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1527796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527815 */     // MIs[0] round
     /* 1527815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527818 */     // MIs[0] policy
     /* 1527818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527828 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1527831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527852 */     // GIR_Coverage, 18396,
     /* 1527852 */     GIR_EraseRootFromParent_Done,
     /* 1527853 */   // Label 21251: @1527853
     /* 1527853 */   GIM_Try, /*On fail goto*//*Label 21252*/ GIMT_Encode4(1527935), // Rule ID 18397 //
     /* 1527858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1527869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1527872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1527875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1527878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527897 */     // MIs[0] round
     /* 1527897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527900 */     // MIs[0] policy
     /* 1527900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527910 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1527913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527934 */     // GIR_Coverage, 18397,
     /* 1527934 */     GIR_EraseRootFromParent_Done,
     /* 1527935 */   // Label 21252: @1527935
     /* 1527935 */   GIM_Try, /*On fail goto*//*Label 21253*/ GIMT_Encode4(1528017), // Rule ID 18400 //
     /* 1527940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1527951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1527954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1527957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1527960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527979 */     // MIs[0] round
     /* 1527979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527982 */     // MIs[0] policy
     /* 1527982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527992 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1527995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528016 */     // GIR_Coverage, 18400,
     /* 1528016 */     GIR_EraseRootFromParent_Done,
     /* 1528017 */   // Label 21253: @1528017
     /* 1528017 */   GIM_Try, /*On fail goto*//*Label 21254*/ GIMT_Encode4(1528099), // Rule ID 18401 //
     /* 1528022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1528033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1528036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1528039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1528042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528061 */     // MIs[0] round
     /* 1528061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528064 */     // MIs[0] policy
     /* 1528064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528074 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1528077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528098 */     // GIR_Coverage, 18401,
     /* 1528098 */     GIR_EraseRootFromParent_Done,
     /* 1528099 */   // Label 21254: @1528099
     /* 1528099 */   GIM_Try, /*On fail goto*//*Label 21255*/ GIMT_Encode4(1528181), // Rule ID 18404 //
     /* 1528104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1528107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1528115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1528118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1528121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1528124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528143 */     // MIs[0] round
     /* 1528143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528146 */     // MIs[0] policy
     /* 1528146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528156 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1528159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528180 */     // GIR_Coverage, 18404,
     /* 1528180 */     GIR_EraseRootFromParent_Done,
     /* 1528181 */   // Label 21255: @1528181
     /* 1528181 */   GIM_Try, /*On fail goto*//*Label 21256*/ GIMT_Encode4(1528263), // Rule ID 18405 //
     /* 1528186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1528197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1528200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1528203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1528206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528225 */     // MIs[0] round
     /* 1528225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528228 */     // MIs[0] policy
     /* 1528228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528238 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1528241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528262 */     // GIR_Coverage, 18405,
     /* 1528262 */     GIR_EraseRootFromParent_Done,
     /* 1528263 */   // Label 21256: @1528263
     /* 1528263 */   GIM_Try, /*On fail goto*//*Label 21257*/ GIMT_Encode4(1528345), // Rule ID 18408 //
     /* 1528268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1528271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1528279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1528282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1528285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1528288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528307 */     // MIs[0] round
     /* 1528307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528310 */     // MIs[0] policy
     /* 1528310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528320 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1528323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528344 */     // GIR_Coverage, 18408,
     /* 1528344 */     GIR_EraseRootFromParent_Done,
     /* 1528345 */   // Label 21257: @1528345
     /* 1528345 */   GIM_Try, /*On fail goto*//*Label 21258*/ GIMT_Encode4(1528427), // Rule ID 18409 //
     /* 1528350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1528361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1528364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1528367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1528370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528389 */     // MIs[0] round
     /* 1528389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528392 */     // MIs[0] policy
     /* 1528392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528402 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1528405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528426 */     // GIR_Coverage, 18409,
     /* 1528426 */     GIR_EraseRootFromParent_Done,
     /* 1528427 */   // Label 21258: @1528427
     /* 1528427 */   GIM_Try, /*On fail goto*//*Label 21259*/ GIMT_Encode4(1528509), // Rule ID 18412 //
     /* 1528432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1528443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1528446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1528449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1528452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528471 */     // MIs[0] round
     /* 1528471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528474 */     // MIs[0] policy
     /* 1528474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528484 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1528487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528508 */     // GIR_Coverage, 18412,
     /* 1528508 */     GIR_EraseRootFromParent_Done,
     /* 1528509 */   // Label 21259: @1528509
     /* 1528509 */   GIM_Try, /*On fail goto*//*Label 21260*/ GIMT_Encode4(1528591), // Rule ID 18413 //
     /* 1528514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1528525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1528528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1528531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1528534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528553 */     // MIs[0] round
     /* 1528553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528556 */     // MIs[0] policy
     /* 1528556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528566 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1528569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528590 */     // GIR_Coverage, 18413,
     /* 1528590 */     GIR_EraseRootFromParent_Done,
     /* 1528591 */   // Label 21260: @1528591
     /* 1528591 */   GIM_Try, /*On fail goto*//*Label 21261*/ GIMT_Encode4(1528673), // Rule ID 18416 //
     /* 1528596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1528607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1528610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1528613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1528616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528635 */     // MIs[0] round
     /* 1528635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528638 */     // MIs[0] policy
     /* 1528638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528648 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1528651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528672 */     // GIR_Coverage, 18416,
     /* 1528672 */     GIR_EraseRootFromParent_Done,
     /* 1528673 */   // Label 21261: @1528673
     /* 1528673 */   GIM_Try, /*On fail goto*//*Label 21262*/ GIMT_Encode4(1528755), // Rule ID 18417 //
     /* 1528678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1528689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1528692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1528695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1528698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528717 */     // MIs[0] round
     /* 1528717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528720 */     // MIs[0] policy
     /* 1528720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528730 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1528733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528754 */     // GIR_Coverage, 18417,
     /* 1528754 */     GIR_EraseRootFromParent_Done,
     /* 1528755 */   // Label 21262: @1528755
     /* 1528755 */   GIM_Try, /*On fail goto*//*Label 21263*/ GIMT_Encode4(1528837), // Rule ID 18420 //
     /* 1528760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1528771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1528774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1528777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1528780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528799 */     // MIs[0] round
     /* 1528799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528802 */     // MIs[0] policy
     /* 1528802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528812 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1528815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528836 */     // GIR_Coverage, 18420,
     /* 1528836 */     GIR_EraseRootFromParent_Done,
     /* 1528837 */   // Label 21263: @1528837
     /* 1528837 */   GIM_Try, /*On fail goto*//*Label 21264*/ GIMT_Encode4(1528919), // Rule ID 18421 //
     /* 1528842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1528853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1528856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1528859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1528862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528881 */     // MIs[0] round
     /* 1528881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528884 */     // MIs[0] policy
     /* 1528884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528894 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1528897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528918 */     // GIR_Coverage, 18421,
     /* 1528918 */     GIR_EraseRootFromParent_Done,
     /* 1528919 */   // Label 21264: @1528919
     /* 1528919 */   GIM_Try, /*On fail goto*//*Label 21265*/ GIMT_Encode4(1529001), // Rule ID 18424 //
     /* 1528924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1528935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1528938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1528944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528963 */     // MIs[0] round
     /* 1528963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528966 */     // MIs[0] policy
     /* 1528966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528976 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1528979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529000 */     // GIR_Coverage, 18424,
     /* 1529000 */     GIR_EraseRootFromParent_Done,
     /* 1529001 */   // Label 21265: @1529001
     /* 1529001 */   GIM_Try, /*On fail goto*//*Label 21266*/ GIMT_Encode4(1529083), // Rule ID 18425 //
     /* 1529006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1529017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1529020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1529026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529045 */     // MIs[0] round
     /* 1529045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529048 */     // MIs[0] policy
     /* 1529048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529058 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1529061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529082 */     // GIR_Coverage, 18425,
     /* 1529082 */     GIR_EraseRootFromParent_Done,
     /* 1529083 */   // Label 21266: @1529083
     /* 1529083 */   GIM_Try, /*On fail goto*//*Label 21267*/ GIMT_Encode4(1529165), // Rule ID 18428 //
     /* 1529088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1529099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1529102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1529108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529127 */     // MIs[0] round
     /* 1529127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529130 */     // MIs[0] policy
     /* 1529130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529140 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1529143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529164 */     // GIR_Coverage, 18428,
     /* 1529164 */     GIR_EraseRootFromParent_Done,
     /* 1529165 */   // Label 21267: @1529165
     /* 1529165 */   GIM_Try, /*On fail goto*//*Label 21268*/ GIMT_Encode4(1529247), // Rule ID 18429 //
     /* 1529170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1529181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1529184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1529190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529209 */     // MIs[0] round
     /* 1529209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529212 */     // MIs[0] policy
     /* 1529212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529222 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1529225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529246 */     // GIR_Coverage, 18429,
     /* 1529246 */     GIR_EraseRootFromParent_Done,
     /* 1529247 */   // Label 21268: @1529247
     /* 1529247 */   GIM_Try, /*On fail goto*//*Label 21269*/ GIMT_Encode4(1529329), // Rule ID 18432 //
     /* 1529252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1529263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1529266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1529272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529291 */     // MIs[0] round
     /* 1529291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529294 */     // MIs[0] policy
     /* 1529294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529304 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1529307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529328 */     // GIR_Coverage, 18432,
     /* 1529328 */     GIR_EraseRootFromParent_Done,
     /* 1529329 */   // Label 21269: @1529329
     /* 1529329 */   GIM_Try, /*On fail goto*//*Label 21270*/ GIMT_Encode4(1529411), // Rule ID 18433 //
     /* 1529334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1529337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1529345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1529348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1529354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529373 */     // MIs[0] round
     /* 1529373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529376 */     // MIs[0] policy
     /* 1529376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529386 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1529389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529410 */     // GIR_Coverage, 18433,
     /* 1529410 */     GIR_EraseRootFromParent_Done,
     /* 1529411 */   // Label 21270: @1529411
     /* 1529411 */   GIM_Try, /*On fail goto*//*Label 21271*/ GIMT_Encode4(1529493), // Rule ID 18436 //
     /* 1529416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1529427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1529430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1529436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529455 */     // MIs[0] round
     /* 1529455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529458 */     // MIs[0] policy
     /* 1529458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529468 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1529471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529492 */     // GIR_Coverage, 18436,
     /* 1529492 */     GIR_EraseRootFromParent_Done,
     /* 1529493 */   // Label 21271: @1529493
     /* 1529493 */   GIM_Try, /*On fail goto*//*Label 21272*/ GIMT_Encode4(1529575), // Rule ID 18437 //
     /* 1529498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1529509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1529512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1529518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529537 */     // MIs[0] round
     /* 1529537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529540 */     // MIs[0] policy
     /* 1529540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529550 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1529553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529574 */     // GIR_Coverage, 18437,
     /* 1529574 */     GIR_EraseRootFromParent_Done,
     /* 1529575 */   // Label 21272: @1529575
     /* 1529575 */   GIM_Try, /*On fail goto*//*Label 21273*/ GIMT_Encode4(1529657), // Rule ID 18440 //
     /* 1529580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1529591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1529594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529619 */     // MIs[0] round
     /* 1529619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529622 */     // MIs[0] policy
     /* 1529622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529632 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1529635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529656 */     // GIR_Coverage, 18440,
     /* 1529656 */     GIR_EraseRootFromParent_Done,
     /* 1529657 */   // Label 21273: @1529657
     /* 1529657 */   GIM_Try, /*On fail goto*//*Label 21274*/ GIMT_Encode4(1529739), // Rule ID 18441 //
     /* 1529662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1529665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1529673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1529676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529701 */     // MIs[0] round
     /* 1529701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529704 */     // MIs[0] policy
     /* 1529704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529714 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1529717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529738 */     // GIR_Coverage, 18441,
     /* 1529738 */     GIR_EraseRootFromParent_Done,
     /* 1529739 */   // Label 21274: @1529739
     /* 1529739 */   GIM_Try, /*On fail goto*//*Label 21275*/ GIMT_Encode4(1529821), // Rule ID 18444 //
     /* 1529744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1529747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1529755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1529758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1529764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529783 */     // MIs[0] round
     /* 1529783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529786 */     // MIs[0] policy
     /* 1529786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529796 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1529799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529820 */     // GIR_Coverage, 18444,
     /* 1529820 */     GIR_EraseRootFromParent_Done,
     /* 1529821 */   // Label 21275: @1529821
     /* 1529821 */   GIM_Try, /*On fail goto*//*Label 21276*/ GIMT_Encode4(1529903), // Rule ID 18445 //
     /* 1529826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1529829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1529837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1529840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1529846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529865 */     // MIs[0] round
     /* 1529865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529868 */     // MIs[0] policy
     /* 1529868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529878 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1529881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529902 */     // GIR_Coverage, 18445,
     /* 1529902 */     GIR_EraseRootFromParent_Done,
     /* 1529903 */   // Label 21276: @1529903
     /* 1529903 */   GIM_Try, /*On fail goto*//*Label 21277*/ GIMT_Encode4(1529985), // Rule ID 18448 //
     /* 1529908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1529919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1529922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1529928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529947 */     // MIs[0] round
     /* 1529947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529950 */     // MIs[0] policy
     /* 1529950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529960 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1529963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529984 */     // GIR_Coverage, 18448,
     /* 1529984 */     GIR_EraseRootFromParent_Done,
     /* 1529985 */   // Label 21277: @1529985
     /* 1529985 */   GIM_Try, /*On fail goto*//*Label 21278*/ GIMT_Encode4(1530067), // Rule ID 18449 //
     /* 1529990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1530001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1530004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1530007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1530010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1530025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530029 */     // MIs[0] round
     /* 1530029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530032 */     // MIs[0] policy
     /* 1530032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530042 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1530045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530066 */     // GIR_Coverage, 18449,
     /* 1530066 */     GIR_EraseRootFromParent_Done,
     /* 1530067 */   // Label 21278: @1530067
     /* 1530067 */   GIM_Try, /*On fail goto*//*Label 21279*/ GIMT_Encode4(1530149), // Rule ID 18452 //
     /* 1530072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1530083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1530086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1530089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1530092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1530107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530111 */     // MIs[0] round
     /* 1530111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530114 */     // MIs[0] policy
     /* 1530114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530124 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1530127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530148 */     // GIR_Coverage, 18452,
     /* 1530148 */     GIR_EraseRootFromParent_Done,
     /* 1530149 */   // Label 21279: @1530149
     /* 1530149 */   GIM_Try, /*On fail goto*//*Label 21280*/ GIMT_Encode4(1530231), // Rule ID 18453 //
     /* 1530154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1530157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1530165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1530168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1530171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1530174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1530189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530193 */     // MIs[0] round
     /* 1530193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530196 */     // MIs[0] policy
     /* 1530196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530206 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1530209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530230 */     // GIR_Coverage, 18453,
     /* 1530230 */     GIR_EraseRootFromParent_Done,
     /* 1530231 */   // Label 21280: @1530231
     /* 1530231 */   GIM_Try, /*On fail goto*//*Label 21281*/ GIMT_Encode4(1530313), // Rule ID 18456 //
     /* 1530236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1530247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1530250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1530253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1530256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1530271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530275 */     // MIs[0] round
     /* 1530275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530278 */     // MIs[0] policy
     /* 1530278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530288 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1530291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530312 */     // GIR_Coverage, 18456,
     /* 1530312 */     GIR_EraseRootFromParent_Done,
     /* 1530313 */   // Label 21281: @1530313
     /* 1530313 */   GIM_Try, /*On fail goto*//*Label 21282*/ GIMT_Encode4(1530395), // Rule ID 18457 //
     /* 1530318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1530321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1530329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1530332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1530335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1530338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1530353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530357 */     // MIs[0] round
     /* 1530357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530360 */     // MIs[0] policy
     /* 1530360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530370 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1530373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530394 */     // GIR_Coverage, 18457,
     /* 1530394 */     GIR_EraseRootFromParent_Done,
     /* 1530395 */   // Label 21282: @1530395
     /* 1530395 */   GIM_Try, /*On fail goto*//*Label 21283*/ GIMT_Encode4(1530477), // Rule ID 18460 //
     /* 1530400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1530411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1530414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1530420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530439 */     // MIs[0] round
     /* 1530439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530442 */     // MIs[0] policy
     /* 1530442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530452 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1530455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530476 */     // GIR_Coverage, 18460,
     /* 1530476 */     GIR_EraseRootFromParent_Done,
     /* 1530477 */   // Label 21283: @1530477
     /* 1530477 */   GIM_Try, /*On fail goto*//*Label 21284*/ GIMT_Encode4(1530559), // Rule ID 18461 //
     /* 1530482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1530493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1530496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1530502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530521 */     // MIs[0] round
     /* 1530521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530524 */     // MIs[0] policy
     /* 1530524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530534 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1530537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530558 */     // GIR_Coverage, 18461,
     /* 1530558 */     GIR_EraseRootFromParent_Done,
     /* 1530559 */   // Label 21284: @1530559
     /* 1530559 */   GIM_Try, /*On fail goto*//*Label 21285*/ GIMT_Encode4(1530641), // Rule ID 18464 //
     /* 1530564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1530575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1530578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1530584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530603 */     // MIs[0] round
     /* 1530603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530606 */     // MIs[0] policy
     /* 1530606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530616 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1530619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530640 */     // GIR_Coverage, 18464,
     /* 1530640 */     GIR_EraseRootFromParent_Done,
     /* 1530641 */   // Label 21285: @1530641
     /* 1530641 */   GIM_Try, /*On fail goto*//*Label 21286*/ GIMT_Encode4(1530723), // Rule ID 18465 //
     /* 1530646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1530657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1530660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1530666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530685 */     // MIs[0] round
     /* 1530685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530688 */     // MIs[0] policy
     /* 1530688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530698 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1530701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530722 */     // GIR_Coverage, 18465,
     /* 1530722 */     GIR_EraseRootFromParent_Done,
     /* 1530723 */   // Label 21286: @1530723
     /* 1530723 */   GIM_Try, /*On fail goto*//*Label 21287*/ GIMT_Encode4(1530805), // Rule ID 18468 //
     /* 1530728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1530739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1530742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1530748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530767 */     // MIs[0] round
     /* 1530767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530770 */     // MIs[0] policy
     /* 1530770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530780 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1530783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530804 */     // GIR_Coverage, 18468,
     /* 1530804 */     GIR_EraseRootFromParent_Done,
     /* 1530805 */   // Label 21287: @1530805
     /* 1530805 */   GIM_Try, /*On fail goto*//*Label 21288*/ GIMT_Encode4(1530887), // Rule ID 18469 //
     /* 1530810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1530821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1530824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1530830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530849 */     // MIs[0] round
     /* 1530849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530852 */     // MIs[0] policy
     /* 1530852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530862 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1530865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530886 */     // GIR_Coverage, 18469,
     /* 1530886 */     GIR_EraseRootFromParent_Done,
     /* 1530887 */   // Label 21288: @1530887
     /* 1530887 */   GIM_Try, /*On fail goto*//*Label 21289*/ GIMT_Encode4(1530969), // Rule ID 18472 //
     /* 1530892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1530903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1530906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1530912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530931 */     // MIs[0] round
     /* 1530931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530934 */     // MIs[0] policy
     /* 1530934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530944 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1530947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530968 */     // GIR_Coverage, 18472,
     /* 1530968 */     GIR_EraseRootFromParent_Done,
     /* 1530969 */   // Label 21289: @1530969
     /* 1530969 */   GIM_Try, /*On fail goto*//*Label 21290*/ GIMT_Encode4(1531051), // Rule ID 18473 //
     /* 1530974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1530977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1530985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1530988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1530994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1531009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531013 */     // MIs[0] round
     /* 1531013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531016 */     // MIs[0] policy
     /* 1531016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531026 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1531029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531050 */     // GIR_Coverage, 18473,
     /* 1531050 */     GIR_EraseRootFromParent_Done,
     /* 1531051 */   // Label 21290: @1531051
     /* 1531051 */   GIM_Try, /*On fail goto*//*Label 21291*/ GIMT_Encode4(1531133), // Rule ID 18476 //
     /* 1531056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1531059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1531067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1531070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1531073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1531076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1531091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531095 */     // MIs[0] round
     /* 1531095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531098 */     // MIs[0] policy
     /* 1531098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531108 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1531111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531132 */     // GIR_Coverage, 18476,
     /* 1531132 */     GIR_EraseRootFromParent_Done,
     /* 1531133 */   // Label 21291: @1531133
     /* 1531133 */   GIM_Try, /*On fail goto*//*Label 21292*/ GIMT_Encode4(1531215), // Rule ID 18477 //
     /* 1531138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1531141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1531149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1531152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1531155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1531158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1531173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531177 */     // MIs[0] round
     /* 1531177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531180 */     // MIs[0] policy
     /* 1531180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531190 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1531193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531214 */     // GIR_Coverage, 18477,
     /* 1531214 */     GIR_EraseRootFromParent_Done,
     /* 1531215 */   // Label 21292: @1531215
     /* 1531215 */   GIM_Try, /*On fail goto*//*Label 21293*/ GIMT_Encode4(1531297), // Rule ID 18480 //
     /* 1531220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1531223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1531231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1531234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1531237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1531240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1531255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531259 */     // MIs[0] round
     /* 1531259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531262 */     // MIs[0] policy
     /* 1531262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531272 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1531275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531296 */     // GIR_Coverage, 18480,
     /* 1531296 */     GIR_EraseRootFromParent_Done,
     /* 1531297 */   // Label 21293: @1531297
     /* 1531297 */   GIM_Try, /*On fail goto*//*Label 21294*/ GIMT_Encode4(1531379), // Rule ID 18481 //
     /* 1531302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1531305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1531313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1531316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1531319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1531322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1531337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531341 */     // MIs[0] round
     /* 1531341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531344 */     // MIs[0] policy
     /* 1531344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531354 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1531357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531378 */     // GIR_Coverage, 18481,
     /* 1531378 */     GIR_EraseRootFromParent_Done,
     /* 1531379 */   // Label 21294: @1531379
     /* 1531379 */   GIM_Try, /*On fail goto*//*Label 21295*/ GIMT_Encode4(1531461), // Rule ID 18484 //
     /* 1531384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1531395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1531398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1531401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1531404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531423 */     // MIs[0] round
     /* 1531423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531426 */     // MIs[0] policy
     /* 1531426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531436 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1531439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531460 */     // GIR_Coverage, 18484,
     /* 1531460 */     GIR_EraseRootFromParent_Done,
     /* 1531461 */   // Label 21295: @1531461
     /* 1531461 */   GIM_Try, /*On fail goto*//*Label 21296*/ GIMT_Encode4(1531543), // Rule ID 18485 //
     /* 1531466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1531477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1531480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1531483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1531486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531505 */     // MIs[0] round
     /* 1531505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531508 */     // MIs[0] policy
     /* 1531508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531518 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1531521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531542 */     // GIR_Coverage, 18485,
     /* 1531542 */     GIR_EraseRootFromParent_Done,
     /* 1531543 */   // Label 21296: @1531543
     /* 1531543 */   GIM_Try, /*On fail goto*//*Label 21297*/ GIMT_Encode4(1531625), // Rule ID 18488 //
     /* 1531548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1531559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1531562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1531565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1531568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531587 */     // MIs[0] round
     /* 1531587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531590 */     // MIs[0] policy
     /* 1531590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531600 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1531603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531624 */     // GIR_Coverage, 18488,
     /* 1531624 */     GIR_EraseRootFromParent_Done,
     /* 1531625 */   // Label 21297: @1531625
     /* 1531625 */   GIM_Try, /*On fail goto*//*Label 21298*/ GIMT_Encode4(1531707), // Rule ID 18489 //
     /* 1531630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1531641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1531644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1531647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1531650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531669 */     // MIs[0] round
     /* 1531669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531672 */     // MIs[0] policy
     /* 1531672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531682 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1531685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531706 */     // GIR_Coverage, 18489,
     /* 1531706 */     GIR_EraseRootFromParent_Done,
     /* 1531707 */   // Label 21298: @1531707
     /* 1531707 */   GIM_Try, /*On fail goto*//*Label 21299*/ GIMT_Encode4(1531789), // Rule ID 18492 //
     /* 1531712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1531715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1531723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1531726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1531729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1531732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531751 */     // MIs[0] round
     /* 1531751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531754 */     // MIs[0] policy
     /* 1531754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531764 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1531767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531788 */     // GIR_Coverage, 18492,
     /* 1531788 */     GIR_EraseRootFromParent_Done,
     /* 1531789 */   // Label 21299: @1531789
     /* 1531789 */   GIM_Try, /*On fail goto*//*Label 21300*/ GIMT_Encode4(1531871), // Rule ID 18493 //
     /* 1531794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1531797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1531805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1531808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1531811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1531814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531833 */     // MIs[0] round
     /* 1531833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531836 */     // MIs[0] policy
     /* 1531836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531846 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1531849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531870 */     // GIR_Coverage, 18493,
     /* 1531870 */     GIR_EraseRootFromParent_Done,
     /* 1531871 */   // Label 21300: @1531871
     /* 1531871 */   GIM_Try, /*On fail goto*//*Label 21301*/ GIMT_Encode4(1531953), // Rule ID 18496 //
     /* 1531876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1531887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1531890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1531893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1531896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531915 */     // MIs[0] round
     /* 1531915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531918 */     // MIs[0] policy
     /* 1531918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531928 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1531931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531952 */     // GIR_Coverage, 18496,
     /* 1531952 */     GIR_EraseRootFromParent_Done,
     /* 1531953 */   // Label 21301: @1531953
     /* 1531953 */   GIM_Try, /*On fail goto*//*Label 21302*/ GIMT_Encode4(1532035), // Rule ID 18497 //
     /* 1531958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1531969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1531972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1531975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1531978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531997 */     // MIs[0] round
     /* 1531997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532000 */     // MIs[0] policy
     /* 1532000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532010 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1532013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532034 */     // GIR_Coverage, 18497,
     /* 1532034 */     GIR_EraseRootFromParent_Done,
     /* 1532035 */   // Label 21302: @1532035
     /* 1532035 */   GIM_Try, /*On fail goto*//*Label 21303*/ GIMT_Encode4(1532117), // Rule ID 18500 //
     /* 1532040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1532051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1532054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1532057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1532060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532079 */     // MIs[0] round
     /* 1532079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532082 */     // MIs[0] policy
     /* 1532082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532092 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1532095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532116 */     // GIR_Coverage, 18500,
     /* 1532116 */     GIR_EraseRootFromParent_Done,
     /* 1532117 */   // Label 21303: @1532117
     /* 1532117 */   GIM_Try, /*On fail goto*//*Label 21304*/ GIMT_Encode4(1532199), // Rule ID 18501 //
     /* 1532122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1532133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1532136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1532139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1532142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532161 */     // MIs[0] round
     /* 1532161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532164 */     // MIs[0] policy
     /* 1532164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532174 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1532177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532198 */     // GIR_Coverage, 18501,
     /* 1532198 */     GIR_EraseRootFromParent_Done,
     /* 1532199 */   // Label 21304: @1532199
     /* 1532199 */   GIM_Try, /*On fail goto*//*Label 21305*/ GIMT_Encode4(1532281), // Rule ID 18504 //
     /* 1532204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1532207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1532215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1532218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1532221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1532224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532243 */     // MIs[0] round
     /* 1532243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532246 */     // MIs[0] policy
     /* 1532246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532256 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1532259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532280 */     // GIR_Coverage, 18504,
     /* 1532280 */     GIR_EraseRootFromParent_Done,
     /* 1532281 */   // Label 21305: @1532281
     /* 1532281 */   GIM_Try, /*On fail goto*//*Label 21306*/ GIMT_Encode4(1532363), // Rule ID 18505 //
     /* 1532286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1532289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1532297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1532300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1532303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1532306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532325 */     // MIs[0] round
     /* 1532325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532328 */     // MIs[0] policy
     /* 1532328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532338 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1532341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532362 */     // GIR_Coverage, 18505,
     /* 1532362 */     GIR_EraseRootFromParent_Done,
     /* 1532363 */   // Label 21306: @1532363
     /* 1532363 */   GIM_Try, /*On fail goto*//*Label 21307*/ GIMT_Encode4(1532445), // Rule ID 18508 //
     /* 1532368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1532379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1532382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1532385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1532388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532407 */     // MIs[0] round
     /* 1532407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532410 */     // MIs[0] policy
     /* 1532410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532420 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1532423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532444 */     // GIR_Coverage, 18508,
     /* 1532444 */     GIR_EraseRootFromParent_Done,
     /* 1532445 */   // Label 21307: @1532445
     /* 1532445 */   GIM_Try, /*On fail goto*//*Label 21308*/ GIMT_Encode4(1532527), // Rule ID 18509 //
     /* 1532450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1532461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1532464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1532467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1532470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532489 */     // MIs[0] round
     /* 1532489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532492 */     // MIs[0] policy
     /* 1532492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532502 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1532505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532526 */     // GIR_Coverage, 18509,
     /* 1532526 */     GIR_EraseRootFromParent_Done,
     /* 1532527 */   // Label 21308: @1532527
     /* 1532527 */   GIM_Try, /*On fail goto*//*Label 21309*/ GIMT_Encode4(1532609), // Rule ID 18512 //
     /* 1532532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1532549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1532552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532571 */     // MIs[0] round
     /* 1532571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532574 */     // MIs[0] policy
     /* 1532574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532584 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1532587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532608 */     // GIR_Coverage, 18512,
     /* 1532608 */     GIR_EraseRootFromParent_Done,
     /* 1532609 */   // Label 21309: @1532609
     /* 1532609 */   GIM_Try, /*On fail goto*//*Label 21310*/ GIMT_Encode4(1532691), // Rule ID 18513 //
     /* 1532614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1532631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1532634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532653 */     // MIs[0] round
     /* 1532653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532656 */     // MIs[0] policy
     /* 1532656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532666 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1532669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532690 */     // GIR_Coverage, 18513,
     /* 1532690 */     GIR_EraseRootFromParent_Done,
     /* 1532691 */   // Label 21310: @1532691
     /* 1532691 */   GIM_Try, /*On fail goto*//*Label 21311*/ GIMT_Encode4(1532773), // Rule ID 18516 //
     /* 1532696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1532707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1532710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1532713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1532716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532735 */     // MIs[0] round
     /* 1532735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532738 */     // MIs[0] policy
     /* 1532738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532748 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1532751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532772 */     // GIR_Coverage, 18516,
     /* 1532772 */     GIR_EraseRootFromParent_Done,
     /* 1532773 */   // Label 21311: @1532773
     /* 1532773 */   GIM_Try, /*On fail goto*//*Label 21312*/ GIMT_Encode4(1532855), // Rule ID 18517 //
     /* 1532778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1532789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1532792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1532795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1532798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532817 */     // MIs[0] round
     /* 1532817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532820 */     // MIs[0] policy
     /* 1532820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532830 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1532833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532854 */     // GIR_Coverage, 18517,
     /* 1532854 */     GIR_EraseRootFromParent_Done,
     /* 1532855 */   // Label 21312: @1532855
     /* 1532855 */   GIM_Try, /*On fail goto*//*Label 21313*/ GIMT_Encode4(1532937), // Rule ID 18520 //
     /* 1532860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1532871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1532874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1532877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1532880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532899 */     // MIs[0] round
     /* 1532899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532902 */     // MIs[0] policy
     /* 1532902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532912 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1532915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532936 */     // GIR_Coverage, 18520,
     /* 1532936 */     GIR_EraseRootFromParent_Done,
     /* 1532937 */   // Label 21313: @1532937
     /* 1532937 */   GIM_Try, /*On fail goto*//*Label 21314*/ GIMT_Encode4(1533019), // Rule ID 18521 //
     /* 1532942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1532953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1532956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1532959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1532962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532981 */     // MIs[0] round
     /* 1532981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532984 */     // MIs[0] policy
     /* 1532984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532994 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1532997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533018 */     // GIR_Coverage, 18521,
     /* 1533018 */     GIR_EraseRootFromParent_Done,
     /* 1533019 */   // Label 21314: @1533019
     /* 1533019 */   GIM_Try, /*On fail goto*//*Label 21315*/ GIMT_Encode4(1533101), // Rule ID 18524 //
     /* 1533024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1533027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1533035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1533038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1533041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1533044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533063 */     // MIs[0] round
     /* 1533063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533066 */     // MIs[0] policy
     /* 1533066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533076 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1533079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533100 */     // GIR_Coverage, 18524,
     /* 1533100 */     GIR_EraseRootFromParent_Done,
     /* 1533101 */   // Label 21315: @1533101
     /* 1533101 */   GIM_Try, /*On fail goto*//*Label 21316*/ GIMT_Encode4(1533183), // Rule ID 18525 //
     /* 1533106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1533109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1533117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1533120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1533123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1533126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533145 */     // MIs[0] round
     /* 1533145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533148 */     // MIs[0] policy
     /* 1533148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533158 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1533161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533182 */     // GIR_Coverage, 18525,
     /* 1533182 */     GIR_EraseRootFromParent_Done,
     /* 1533183 */   // Label 21316: @1533183
     /* 1533183 */   GIM_Try, /*On fail goto*//*Label 21317*/ GIMT_Encode4(1533265), // Rule ID 18528 //
     /* 1533188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1533191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1533199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1533202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1533205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1533208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533227 */     // MIs[0] round
     /* 1533227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533230 */     // MIs[0] policy
     /* 1533230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533240 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1533243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533264 */     // GIR_Coverage, 18528,
     /* 1533264 */     GIR_EraseRootFromParent_Done,
     /* 1533265 */   // Label 21317: @1533265
     /* 1533265 */   GIM_Try, /*On fail goto*//*Label 21318*/ GIMT_Encode4(1533347), // Rule ID 18529 //
     /* 1533270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1533273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1533281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1533284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1533287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1533290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533309 */     // MIs[0] round
     /* 1533309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533312 */     // MIs[0] policy
     /* 1533312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533322 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1533325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533346 */     // GIR_Coverage, 18529,
     /* 1533346 */     GIR_EraseRootFromParent_Done,
     /* 1533347 */   // Label 21318: @1533347
     /* 1533347 */   GIM_Try, /*On fail goto*//*Label 21319*/ GIMT_Encode4(1533429), // Rule ID 18532 //
     /* 1533352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1533363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1533366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1533369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1533372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533391 */     // MIs[0] round
     /* 1533391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533394 */     // MIs[0] policy
     /* 1533394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533404 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1533407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533428 */     // GIR_Coverage, 18532,
     /* 1533428 */     GIR_EraseRootFromParent_Done,
     /* 1533429 */   // Label 21319: @1533429
     /* 1533429 */   GIM_Try, /*On fail goto*//*Label 21320*/ GIMT_Encode4(1533511), // Rule ID 18533 //
     /* 1533434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1533445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1533448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1533451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1533454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533473 */     // MIs[0] round
     /* 1533473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533476 */     // MIs[0] policy
     /* 1533476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533486 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1533489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533510 */     // GIR_Coverage, 18533,
     /* 1533510 */     GIR_EraseRootFromParent_Done,
     /* 1533511 */   // Label 21320: @1533511
     /* 1533511 */   GIM_Try, /*On fail goto*//*Label 21321*/ GIMT_Encode4(1533593), // Rule ID 18536 //
     /* 1533516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1533527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1533530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1533533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1533536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533555 */     // MIs[0] round
     /* 1533555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533558 */     // MIs[0] policy
     /* 1533558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533568 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1533571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533592 */     // GIR_Coverage, 18536,
     /* 1533592 */     GIR_EraseRootFromParent_Done,
     /* 1533593 */   // Label 21321: @1533593
     /* 1533593 */   GIM_Try, /*On fail goto*//*Label 21322*/ GIMT_Encode4(1533675), // Rule ID 18537 //
     /* 1533598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1533609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1533612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1533615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1533618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533637 */     // MIs[0] round
     /* 1533637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533640 */     // MIs[0] policy
     /* 1533640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533650 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1533653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533674 */     // GIR_Coverage, 18537,
     /* 1533674 */     GIR_EraseRootFromParent_Done,
     /* 1533675 */   // Label 21322: @1533675
     /* 1533675 */   GIM_Try, /*On fail goto*//*Label 21323*/ GIMT_Encode4(1533757), // Rule ID 18540 //
     /* 1533680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1533691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1533694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1533697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1533700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533719 */     // MIs[0] round
     /* 1533719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533722 */     // MIs[0] policy
     /* 1533722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533732 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1533735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533756 */     // GIR_Coverage, 18540,
     /* 1533756 */     GIR_EraseRootFromParent_Done,
     /* 1533757 */   // Label 21323: @1533757
     /* 1533757 */   GIM_Try, /*On fail goto*//*Label 21324*/ GIMT_Encode4(1533839), // Rule ID 18541 //
     /* 1533762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1533773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1533776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1533779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1533782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533801 */     // MIs[0] round
     /* 1533801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533804 */     // MIs[0] policy
     /* 1533804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533814 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1533817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533838 */     // GIR_Coverage, 18541,
     /* 1533838 */     GIR_EraseRootFromParent_Done,
     /* 1533839 */   // Label 21324: @1533839
     /* 1533839 */   GIM_Try, /*On fail goto*//*Label 21325*/ GIMT_Encode4(1533921), // Rule ID 18544 //
     /* 1533844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1533855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1533858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1533864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533883 */     // MIs[0] round
     /* 1533883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533886 */     // MIs[0] policy
     /* 1533886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533896 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1533899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533920 */     // GIR_Coverage, 18544,
     /* 1533920 */     GIR_EraseRootFromParent_Done,
     /* 1533921 */   // Label 21325: @1533921
     /* 1533921 */   GIM_Try, /*On fail goto*//*Label 21326*/ GIMT_Encode4(1534003), // Rule ID 18545 //
     /* 1533926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1533937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1533940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1533946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533965 */     // MIs[0] round
     /* 1533965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533968 */     // MIs[0] policy
     /* 1533968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533978 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1533981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534002 */     // GIR_Coverage, 18545,
     /* 1534002 */     GIR_EraseRootFromParent_Done,
     /* 1534003 */   // Label 21326: @1534003
     /* 1534003 */   GIM_Try, /*On fail goto*//*Label 21327*/ GIMT_Encode4(1534085), // Rule ID 18548 //
     /* 1534008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1534019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1534022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1534028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534047 */     // MIs[0] round
     /* 1534047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534050 */     // MIs[0] policy
     /* 1534050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534060 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1534063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534084 */     // GIR_Coverage, 18548,
     /* 1534084 */     GIR_EraseRootFromParent_Done,
     /* 1534085 */   // Label 21327: @1534085
     /* 1534085 */   GIM_Try, /*On fail goto*//*Label 21328*/ GIMT_Encode4(1534167), // Rule ID 18549 //
     /* 1534090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1534101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1534104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1534110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534129 */     // MIs[0] round
     /* 1534129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534132 */     // MIs[0] policy
     /* 1534132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534142 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1534145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534166 */     // GIR_Coverage, 18549,
     /* 1534166 */     GIR_EraseRootFromParent_Done,
     /* 1534167 */   // Label 21328: @1534167
     /* 1534167 */   GIM_Try, /*On fail goto*//*Label 21329*/ GIMT_Encode4(1534249), // Rule ID 18552 //
     /* 1534172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1534175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1534183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1534186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1534192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534211 */     // MIs[0] round
     /* 1534211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534214 */     // MIs[0] policy
     /* 1534214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534224 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1534227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534248 */     // GIR_Coverage, 18552,
     /* 1534248 */     GIR_EraseRootFromParent_Done,
     /* 1534249 */   // Label 21329: @1534249
     /* 1534249 */   GIM_Try, /*On fail goto*//*Label 21330*/ GIMT_Encode4(1534331), // Rule ID 18553 //
     /* 1534254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1534257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1534265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1534268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1534274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534293 */     // MIs[0] round
     /* 1534293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534296 */     // MIs[0] policy
     /* 1534296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534306 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1534309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534330 */     // GIR_Coverage, 18553,
     /* 1534330 */     GIR_EraseRootFromParent_Done,
     /* 1534331 */   // Label 21330: @1534331
     /* 1534331 */   GIM_Try, /*On fail goto*//*Label 21331*/ GIMT_Encode4(1534413), // Rule ID 18556 //
     /* 1534336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1534347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1534350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1534356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534375 */     // MIs[0] round
     /* 1534375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534378 */     // MIs[0] policy
     /* 1534378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534388 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1534391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534412 */     // GIR_Coverage, 18556,
     /* 1534412 */     GIR_EraseRootFromParent_Done,
     /* 1534413 */   // Label 21331: @1534413
     /* 1534413 */   GIM_Try, /*On fail goto*//*Label 21332*/ GIMT_Encode4(1534495), // Rule ID 18557 //
     /* 1534418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1534429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1534432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1534438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534457 */     // MIs[0] round
     /* 1534457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534460 */     // MIs[0] policy
     /* 1534460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534470 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1534473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534494 */     // GIR_Coverage, 18557,
     /* 1534494 */     GIR_EraseRootFromParent_Done,
     /* 1534495 */   // Label 21332: @1534495
     /* 1534495 */   GIM_Try, /*On fail goto*//*Label 21333*/ GIMT_Encode4(1534577), // Rule ID 18560 //
     /* 1534500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1534503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1534511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1534514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1534520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534539 */     // MIs[0] round
     /* 1534539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534542 */     // MIs[0] policy
     /* 1534542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534552 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1534555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534576 */     // GIR_Coverage, 18560,
     /* 1534576 */     GIR_EraseRootFromParent_Done,
     /* 1534577 */   // Label 21333: @1534577
     /* 1534577 */   GIM_Try, /*On fail goto*//*Label 21334*/ GIMT_Encode4(1534659), // Rule ID 18561 //
     /* 1534582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1534585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1534593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1534596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1534602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534621 */     // MIs[0] round
     /* 1534621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534624 */     // MIs[0] policy
     /* 1534624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534634 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1534637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534658 */     // GIR_Coverage, 18561,
     /* 1534658 */     GIR_EraseRootFromParent_Done,
     /* 1534659 */   // Label 21334: @1534659
     /* 1534659 */   GIM_Try, /*On fail goto*//*Label 21335*/ GIMT_Encode4(1534741), // Rule ID 18564 //
     /* 1534664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1534667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1534684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534703 */     // MIs[0] round
     /* 1534703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534706 */     // MIs[0] policy
     /* 1534706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534716 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1534719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534740 */     // GIR_Coverage, 18564,
     /* 1534740 */     GIR_EraseRootFromParent_Done,
     /* 1534741 */   // Label 21335: @1534741
     /* 1534741 */   GIM_Try, /*On fail goto*//*Label 21336*/ GIMT_Encode4(1534823), // Rule ID 18565 //
     /* 1534746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1534749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1534766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534785 */     // MIs[0] round
     /* 1534785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534788 */     // MIs[0] policy
     /* 1534788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534798 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1534801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534822 */     // GIR_Coverage, 18565,
     /* 1534822 */     GIR_EraseRootFromParent_Done,
     /* 1534823 */   // Label 21336: @1534823
     /* 1534823 */   GIM_Try, /*On fail goto*//*Label 21337*/ GIMT_Encode4(1534905), // Rule ID 18568 //
     /* 1534828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1534839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1534842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1534848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534867 */     // MIs[0] round
     /* 1534867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534870 */     // MIs[0] policy
     /* 1534870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534880 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1534883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534904 */     // GIR_Coverage, 18568,
     /* 1534904 */     GIR_EraseRootFromParent_Done,
     /* 1534905 */   // Label 21337: @1534905
     /* 1534905 */   GIM_Try, /*On fail goto*//*Label 21338*/ GIMT_Encode4(1534987), // Rule ID 18569 //
     /* 1534910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1534921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1534924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1534930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534949 */     // MIs[0] round
     /* 1534949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534952 */     // MIs[0] policy
     /* 1534952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534962 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1534965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534986 */     // GIR_Coverage, 18569,
     /* 1534986 */     GIR_EraseRootFromParent_Done,
     /* 1534987 */   // Label 21338: @1534987
     /* 1534987 */   GIM_Try, /*On fail goto*//*Label 21339*/ GIMT_Encode4(1535069), // Rule ID 18572 //
     /* 1534992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1535003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1535006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1535012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1535027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535031 */     // MIs[0] round
     /* 1535031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535034 */     // MIs[0] policy
     /* 1535034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535044 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1535047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535068 */     // GIR_Coverage, 18572,
     /* 1535068 */     GIR_EraseRootFromParent_Done,
     /* 1535069 */   // Label 21339: @1535069
     /* 1535069 */   GIM_Try, /*On fail goto*//*Label 21340*/ GIMT_Encode4(1535151), // Rule ID 18573 //
     /* 1535074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1535077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1535085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1535088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1535094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1535109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535113 */     // MIs[0] round
     /* 1535113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535116 */     // MIs[0] policy
     /* 1535116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535126 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1535129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535150 */     // GIR_Coverage, 18573,
     /* 1535150 */     GIR_EraseRootFromParent_Done,
     /* 1535151 */   // Label 21340: @1535151
     /* 1535151 */   GIM_Try, /*On fail goto*//*Label 21341*/ GIMT_Encode4(1535233), // Rule ID 18576 //
     /* 1535156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1535159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1535167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1535170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1535176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1535191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535195 */     // MIs[0] round
     /* 1535195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535198 */     // MIs[0] policy
     /* 1535198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535208 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1535211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535232 */     // GIR_Coverage, 18576,
     /* 1535232 */     GIR_EraseRootFromParent_Done,
     /* 1535233 */   // Label 21341: @1535233
     /* 1535233 */   GIM_Try, /*On fail goto*//*Label 21342*/ GIMT_Encode4(1535315), // Rule ID 18577 //
     /* 1535238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1535241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1535249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1535252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1535258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1535273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535277 */     // MIs[0] round
     /* 1535277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535280 */     // MIs[0] policy
     /* 1535280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535290 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1535293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535314 */     // GIR_Coverage, 18577,
     /* 1535314 */     GIR_EraseRootFromParent_Done,
     /* 1535315 */   // Label 21342: @1535315
     /* 1535315 */   GIM_Try, /*On fail goto*//*Label 21343*/ GIMT_Encode4(1535397), // Rule ID 18580 //
     /* 1535320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1535331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1535334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1535340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535359 */     // MIs[0] round
     /* 1535359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535362 */     // MIs[0] policy
     /* 1535362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535372 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1535375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535396 */     // GIR_Coverage, 18580,
     /* 1535396 */     GIR_EraseRootFromParent_Done,
     /* 1535397 */   // Label 21343: @1535397
     /* 1535397 */   GIM_Try, /*On fail goto*//*Label 21344*/ GIMT_Encode4(1535479), // Rule ID 18581 //
     /* 1535402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1535413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1535416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1535422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535441 */     // MIs[0] round
     /* 1535441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535444 */     // MIs[0] policy
     /* 1535444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535454 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1535457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535478 */     // GIR_Coverage, 18581,
     /* 1535478 */     GIR_EraseRootFromParent_Done,
     /* 1535479 */   // Label 21344: @1535479
     /* 1535479 */   GIM_Try, /*On fail goto*//*Label 21345*/ GIMT_Encode4(1535561), // Rule ID 18584 //
     /* 1535484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1535495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1535498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1535504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535523 */     // MIs[0] round
     /* 1535523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535526 */     // MIs[0] policy
     /* 1535526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535536 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1535539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535560 */     // GIR_Coverage, 18584,
     /* 1535560 */     GIR_EraseRootFromParent_Done,
     /* 1535561 */   // Label 21345: @1535561
     /* 1535561 */   GIM_Try, /*On fail goto*//*Label 21346*/ GIMT_Encode4(1535643), // Rule ID 18585 //
     /* 1535566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1535577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1535580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1535586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535605 */     // MIs[0] round
     /* 1535605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535608 */     // MIs[0] policy
     /* 1535608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535618 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1535621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535642 */     // GIR_Coverage, 18585,
     /* 1535642 */     GIR_EraseRootFromParent_Done,
     /* 1535643 */   // Label 21346: @1535643
     /* 1535643 */   GIM_Try, /*On fail goto*//*Label 21347*/ GIMT_Encode4(1535725), // Rule ID 18588 //
     /* 1535648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1535659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1535662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1535668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535687 */     // MIs[0] round
     /* 1535687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535690 */     // MIs[0] policy
     /* 1535690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535700 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1535703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535724 */     // GIR_Coverage, 18588,
     /* 1535724 */     GIR_EraseRootFromParent_Done,
     /* 1535725 */   // Label 21347: @1535725
     /* 1535725 */   GIM_Try, /*On fail goto*//*Label 21348*/ GIMT_Encode4(1535807), // Rule ID 18589 //
     /* 1535730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1535741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1535744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1535750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535769 */     // MIs[0] round
     /* 1535769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535772 */     // MIs[0] policy
     /* 1535772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535782 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1535785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535806 */     // GIR_Coverage, 18589,
     /* 1535806 */     GIR_EraseRootFromParent_Done,
     /* 1535807 */   // Label 21348: @1535807
     /* 1535807 */   GIM_Try, /*On fail goto*//*Label 21349*/ GIMT_Encode4(1535889), // Rule ID 18592 //
     /* 1535812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1535823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1535826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1535832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535851 */     // MIs[0] round
     /* 1535851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535854 */     // MIs[0] policy
     /* 1535854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535864 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1535867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535888 */     // GIR_Coverage, 18592,
     /* 1535888 */     GIR_EraseRootFromParent_Done,
     /* 1535889 */   // Label 21349: @1535889
     /* 1535889 */   GIM_Try, /*On fail goto*//*Label 21350*/ GIMT_Encode4(1535971), // Rule ID 18593 //
     /* 1535894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1535897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1535905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1535908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1535914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535933 */     // MIs[0] round
     /* 1535933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535936 */     // MIs[0] policy
     /* 1535936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535946 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1535949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535970 */     // GIR_Coverage, 18593,
     /* 1535970 */     GIR_EraseRootFromParent_Done,
     /* 1535971 */   // Label 21350: @1535971
     /* 1535971 */   GIM_Try, /*On fail goto*//*Label 21351*/ GIMT_Encode4(1536053), // Rule ID 18596 //
     /* 1535976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1535987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1535990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1535996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1536011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536015 */     // MIs[0] round
     /* 1536015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536018 */     // MIs[0] policy
     /* 1536018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536028 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1536031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536052 */     // GIR_Coverage, 18596,
     /* 1536052 */     GIR_EraseRootFromParent_Done,
     /* 1536053 */   // Label 21351: @1536053
     /* 1536053 */   GIM_Try, /*On fail goto*//*Label 21352*/ GIMT_Encode4(1536135), // Rule ID 18597 //
     /* 1536058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1536061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1536069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1536072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1536075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1536078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1536093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536097 */     // MIs[0] round
     /* 1536097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536100 */     // MIs[0] policy
     /* 1536100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536110 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1536113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536134 */     // GIR_Coverage, 18597,
     /* 1536134 */     GIR_EraseRootFromParent_Done,
     /* 1536135 */   // Label 21352: @1536135
     /* 1536135 */   GIM_Try, /*On fail goto*//*Label 21353*/ GIMT_Encode4(1536217), // Rule ID 18600 //
     /* 1536140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1536143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1536151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1536154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1536157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1536160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1536175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536179 */     // MIs[0] round
     /* 1536179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536182 */     // MIs[0] policy
     /* 1536182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536192 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1536195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536216 */     // GIR_Coverage, 18600,
     /* 1536216 */     GIR_EraseRootFromParent_Done,
     /* 1536217 */   // Label 21353: @1536217
     /* 1536217 */   GIM_Try, /*On fail goto*//*Label 21354*/ GIMT_Encode4(1536299), // Rule ID 18601 //
     /* 1536222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1536225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1536233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1536236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1536239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1536242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1536257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536261 */     // MIs[0] round
     /* 1536261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536264 */     // MIs[0] policy
     /* 1536264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536274 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1536277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536298 */     // GIR_Coverage, 18601,
     /* 1536298 */     GIR_EraseRootFromParent_Done,
     /* 1536299 */   // Label 21354: @1536299
     /* 1536299 */   GIM_Try, /*On fail goto*//*Label 21355*/ GIMT_Encode4(1536381), // Rule ID 18604 //
     /* 1536304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1536315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1536318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1536321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1536324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536343 */     // MIs[0] round
     /* 1536343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536346 */     // MIs[0] policy
     /* 1536346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536356 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1536359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536380 */     // GIR_Coverage, 18604,
     /* 1536380 */     GIR_EraseRootFromParent_Done,
     /* 1536381 */   // Label 21355: @1536381
     /* 1536381 */   GIM_Try, /*On fail goto*//*Label 21356*/ GIMT_Encode4(1536463), // Rule ID 18605 //
     /* 1536386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1536397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1536400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1536403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1536406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536425 */     // MIs[0] round
     /* 1536425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536428 */     // MIs[0] policy
     /* 1536428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536438 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1536441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536462 */     // GIR_Coverage, 18605,
     /* 1536462 */     GIR_EraseRootFromParent_Done,
     /* 1536463 */   // Label 21356: @1536463
     /* 1536463 */   GIM_Try, /*On fail goto*//*Label 21357*/ GIMT_Encode4(1536545), // Rule ID 18608 //
     /* 1536468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1536479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1536482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1536485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1536488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536507 */     // MIs[0] round
     /* 1536507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536510 */     // MIs[0] policy
     /* 1536510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536520 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1536523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536544 */     // GIR_Coverage, 18608,
     /* 1536544 */     GIR_EraseRootFromParent_Done,
     /* 1536545 */   // Label 21357: @1536545
     /* 1536545 */   GIM_Try, /*On fail goto*//*Label 21358*/ GIMT_Encode4(1536627), // Rule ID 18609 //
     /* 1536550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1536561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1536564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1536567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1536570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536589 */     // MIs[0] round
     /* 1536589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536592 */     // MIs[0] policy
     /* 1536592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536602 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1536605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536626 */     // GIR_Coverage, 18609,
     /* 1536626 */     GIR_EraseRootFromParent_Done,
     /* 1536627 */   // Label 21358: @1536627
     /* 1536627 */   GIM_Try, /*On fail goto*//*Label 21359*/ GIMT_Encode4(1536709), // Rule ID 18612 //
     /* 1536632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1536643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1536646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1536649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1536652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536671 */     // MIs[0] round
     /* 1536671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536674 */     // MIs[0] policy
     /* 1536674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536684 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1536687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536708 */     // GIR_Coverage, 18612,
     /* 1536708 */     GIR_EraseRootFromParent_Done,
     /* 1536709 */   // Label 21359: @1536709
     /* 1536709 */   GIM_Try, /*On fail goto*//*Label 21360*/ GIMT_Encode4(1536791), // Rule ID 18613 //
     /* 1536714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1536717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1536725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1536728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1536731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1536734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536753 */     // MIs[0] round
     /* 1536753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536756 */     // MIs[0] policy
     /* 1536756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536766 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1536769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536790 */     // GIR_Coverage, 18613,
     /* 1536790 */     GIR_EraseRootFromParent_Done,
     /* 1536791 */   // Label 21360: @1536791
     /* 1536791 */   GIM_Try, /*On fail goto*//*Label 21361*/ GIMT_Encode4(1536873), // Rule ID 18616 //
     /* 1536796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1536807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1536810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1536813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1536816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536835 */     // MIs[0] round
     /* 1536835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536838 */     // MIs[0] policy
     /* 1536838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536848 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1536851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536872 */     // GIR_Coverage, 18616,
     /* 1536872 */     GIR_EraseRootFromParent_Done,
     /* 1536873 */   // Label 21361: @1536873
     /* 1536873 */   GIM_Try, /*On fail goto*//*Label 21362*/ GIMT_Encode4(1536955), // Rule ID 18617 //
     /* 1536878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1536889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1536892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1536895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1536898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536917 */     // MIs[0] round
     /* 1536917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536920 */     // MIs[0] policy
     /* 1536920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536930 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1536933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536954 */     // GIR_Coverage, 18617,
     /* 1536954 */     GIR_EraseRootFromParent_Done,
     /* 1536955 */   // Label 21362: @1536955
     /* 1536955 */   GIM_Try, /*On fail goto*//*Label 21363*/ GIMT_Encode4(1537037), // Rule ID 18620 //
     /* 1536960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1536971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1536974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1536977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1536980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536999 */     // MIs[0] round
     /* 1536999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537002 */     // MIs[0] policy
     /* 1537002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537012 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1537015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537036 */     // GIR_Coverage, 18620,
     /* 1537036 */     GIR_EraseRootFromParent_Done,
     /* 1537037 */   // Label 21363: @1537037
     /* 1537037 */   GIM_Try, /*On fail goto*//*Label 21364*/ GIMT_Encode4(1537119), // Rule ID 18621 //
     /* 1537042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1537053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1537056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1537059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1537062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537081 */     // MIs[0] round
     /* 1537081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537084 */     // MIs[0] policy
     /* 1537084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537094 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1537097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537118 */     // GIR_Coverage, 18621,
     /* 1537118 */     GIR_EraseRootFromParent_Done,
     /* 1537119 */   // Label 21364: @1537119
     /* 1537119 */   GIM_Try, /*On fail goto*//*Label 21365*/ GIMT_Encode4(1537201), // Rule ID 18624 //
     /* 1537124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1537127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1537135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1537138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1537141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1537144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537163 */     // MIs[0] round
     /* 1537163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537166 */     // MIs[0] policy
     /* 1537166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537176 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1537179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1537197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537200 */     // GIR_Coverage, 18624,
     /* 1537200 */     GIR_EraseRootFromParent_Done,
     /* 1537201 */   // Label 21365: @1537201
     /* 1537201 */   GIM_Try, /*On fail goto*//*Label 21366*/ GIMT_Encode4(1537283), // Rule ID 18625 //
     /* 1537206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1537209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1537217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1537220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1537223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1537226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537245 */     // MIs[0] round
     /* 1537245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537248 */     // MIs[0] policy
     /* 1537248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537258 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1537261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1537279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537282 */     // GIR_Coverage, 18625,
     /* 1537282 */     GIR_EraseRootFromParent_Done,
     /* 1537283 */   // Label 21366: @1537283
     /* 1537283 */   GIM_Try, /*On fail goto*//*Label 21367*/ GIMT_Encode4(1537365), // Rule ID 18628 //
     /* 1537288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1537299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1537302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1537305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1537308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537327 */     // MIs[0] round
     /* 1537327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537330 */     // MIs[0] policy
     /* 1537330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537340 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1537343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537364 */     // GIR_Coverage, 18628,
     /* 1537364 */     GIR_EraseRootFromParent_Done,
     /* 1537365 */   // Label 21367: @1537365
     /* 1537365 */   GIM_Try, /*On fail goto*//*Label 21368*/ GIMT_Encode4(1537447), // Rule ID 18629 //
     /* 1537370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1537381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1537384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1537387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1537390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537409 */     // MIs[0] round
     /* 1537409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537412 */     // MIs[0] policy
     /* 1537412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537422 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1537425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537446 */     // GIR_Coverage, 18629,
     /* 1537446 */     GIR_EraseRootFromParent_Done,
     /* 1537447 */   // Label 21368: @1537447
     /* 1537447 */   GIM_Try, /*On fail goto*//*Label 21369*/ GIMT_Encode4(1537529), // Rule ID 18632 //
     /* 1537452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1537463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1537466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1537469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1537472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537491 */     // MIs[0] round
     /* 1537491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537494 */     // MIs[0] policy
     /* 1537494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537504 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1537507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537528 */     // GIR_Coverage, 18632,
     /* 1537528 */     GIR_EraseRootFromParent_Done,
     /* 1537529 */   // Label 21369: @1537529
     /* 1537529 */   GIM_Try, /*On fail goto*//*Label 21370*/ GIMT_Encode4(1537611), // Rule ID 18633 //
     /* 1537534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1537545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1537548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1537551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1537554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537573 */     // MIs[0] round
     /* 1537573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537576 */     // MIs[0] policy
     /* 1537576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537586 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1537589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537610 */     // GIR_Coverage, 18633,
     /* 1537610 */     GIR_EraseRootFromParent_Done,
     /* 1537611 */   // Label 21370: @1537611
     /* 1537611 */   GIM_Try, /*On fail goto*//*Label 21371*/ GIMT_Encode4(1537693), // Rule ID 18636 //
     /* 1537616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1537627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1537630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1537633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1537636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537655 */     // MIs[0] round
     /* 1537655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537658 */     // MIs[0] policy
     /* 1537658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537668 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1537671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537692 */     // GIR_Coverage, 18636,
     /* 1537692 */     GIR_EraseRootFromParent_Done,
     /* 1537693 */   // Label 21371: @1537693
     /* 1537693 */   GIM_Try, /*On fail goto*//*Label 21372*/ GIMT_Encode4(1537775), // Rule ID 18637 //
     /* 1537698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1537709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1537712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1537715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1537718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537737 */     // MIs[0] round
     /* 1537737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537740 */     // MIs[0] policy
     /* 1537740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537750 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1537753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537774 */     // GIR_Coverage, 18637,
     /* 1537774 */     GIR_EraseRootFromParent_Done,
     /* 1537775 */   // Label 21372: @1537775
     /* 1537775 */   GIM_Try, /*On fail goto*//*Label 21373*/ GIMT_Encode4(1537857), // Rule ID 18640 //
     /* 1537780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1537791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1537794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1537797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1537800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537819 */     // MIs[0] round
     /* 1537819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537822 */     // MIs[0] policy
     /* 1537822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537832 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1537835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537856 */     // GIR_Coverage, 18640,
     /* 1537856 */     GIR_EraseRootFromParent_Done,
     /* 1537857 */   // Label 21373: @1537857
     /* 1537857 */   GIM_Try, /*On fail goto*//*Label 21374*/ GIMT_Encode4(1537939), // Rule ID 18641 //
     /* 1537862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1537873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1537876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1537879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1537882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537901 */     // MIs[0] round
     /* 1537901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537904 */     // MIs[0] policy
     /* 1537904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537914 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1537917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537938 */     // GIR_Coverage, 18641,
     /* 1537938 */     GIR_EraseRootFromParent_Done,
     /* 1537939 */   // Label 21374: @1537939
     /* 1537939 */   GIM_Try, /*On fail goto*//*Label 21375*/ GIMT_Encode4(1538021), // Rule ID 18644 //
     /* 1537944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1537955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1537958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1537961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1537964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537983 */     // MIs[0] round
     /* 1537983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537986 */     // MIs[0] policy
     /* 1537986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537996 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1537999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538020 */     // GIR_Coverage, 18644,
     /* 1538020 */     GIR_EraseRootFromParent_Done,
     /* 1538021 */   // Label 21375: @1538021
     /* 1538021 */   GIM_Try, /*On fail goto*//*Label 21376*/ GIMT_Encode4(1538103), // Rule ID 18645 //
     /* 1538026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1538029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1538037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1538040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1538043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1538046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538065 */     // MIs[0] round
     /* 1538065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538068 */     // MIs[0] policy
     /* 1538068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538078 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1538081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538102 */     // GIR_Coverage, 18645,
     /* 1538102 */     GIR_EraseRootFromParent_Done,
     /* 1538103 */   // Label 21376: @1538103
     /* 1538103 */   GIM_Try, /*On fail goto*//*Label 21377*/ GIMT_Encode4(1538185), // Rule ID 18648 //
     /* 1538108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1538111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1538119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1538122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1538125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1538128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538147 */     // MIs[0] round
     /* 1538147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538150 */     // MIs[0] policy
     /* 1538150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538160 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1538163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538184 */     // GIR_Coverage, 18648,
     /* 1538184 */     GIR_EraseRootFromParent_Done,
     /* 1538185 */   // Label 21377: @1538185
     /* 1538185 */   GIM_Try, /*On fail goto*//*Label 21378*/ GIMT_Encode4(1538267), // Rule ID 18649 //
     /* 1538190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1538193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1538201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1538204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1538207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1538210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538229 */     // MIs[0] round
     /* 1538229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538232 */     // MIs[0] policy
     /* 1538232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538242 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1538245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538266 */     // GIR_Coverage, 18649,
     /* 1538266 */     GIR_EraseRootFromParent_Done,
     /* 1538267 */   // Label 21378: @1538267
     /* 1538267 */   GIM_Try, /*On fail goto*//*Label 21379*/ GIMT_Encode4(1538349), // Rule ID 18652 //
     /* 1538272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1538275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1538283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1538286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1538289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1538292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538311 */     // MIs[0] round
     /* 1538311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538314 */     // MIs[0] policy
     /* 1538314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538324 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1538327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538348 */     // GIR_Coverage, 18652,
     /* 1538348 */     GIR_EraseRootFromParent_Done,
     /* 1538349 */   // Label 21379: @1538349
     /* 1538349 */   GIM_Try, /*On fail goto*//*Label 21380*/ GIMT_Encode4(1538431), // Rule ID 18653 //
     /* 1538354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1538365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1538368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1538371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1538374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538393 */     // MIs[0] round
     /* 1538393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538396 */     // MIs[0] policy
     /* 1538396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538406 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1538409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538430 */     // GIR_Coverage, 18653,
     /* 1538430 */     GIR_EraseRootFromParent_Done,
     /* 1538431 */   // Label 21380: @1538431
     /* 1538431 */   GIM_Try, /*On fail goto*//*Label 21381*/ GIMT_Encode4(1538513), // Rule ID 18656 //
     /* 1538436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1538439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1538447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1538450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1538453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1538456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538475 */     // MIs[0] round
     /* 1538475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538478 */     // MIs[0] policy
     /* 1538478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538488 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1538491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538512 */     // GIR_Coverage, 18656,
     /* 1538512 */     GIR_EraseRootFromParent_Done,
     /* 1538513 */   // Label 21381: @1538513
     /* 1538513 */   GIM_Try, /*On fail goto*//*Label 21382*/ GIMT_Encode4(1538595), // Rule ID 18657 //
     /* 1538518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1538529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1538532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1538535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1538538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538557 */     // MIs[0] round
     /* 1538557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538560 */     // MIs[0] policy
     /* 1538560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538570 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1538573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538594 */     // GIR_Coverage, 18657,
     /* 1538594 */     GIR_EraseRootFromParent_Done,
     /* 1538595 */   // Label 21382: @1538595
     /* 1538595 */   GIM_Try, /*On fail goto*//*Label 21383*/ GIMT_Encode4(1538677), // Rule ID 18660 //
     /* 1538600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1538603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1538611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1538614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1538617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1538620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538639 */     // MIs[0] round
     /* 1538639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538642 */     // MIs[0] policy
     /* 1538642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538652 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1538655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538676 */     // GIR_Coverage, 18660,
     /* 1538676 */     GIR_EraseRootFromParent_Done,
     /* 1538677 */   // Label 21383: @1538677
     /* 1538677 */   GIM_Try, /*On fail goto*//*Label 21384*/ GIMT_Encode4(1538759), // Rule ID 18661 //
     /* 1538682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1538693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1538696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1538699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1538702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538721 */     // MIs[0] round
     /* 1538721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538724 */     // MIs[0] policy
     /* 1538724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538734 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1538737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538758 */     // GIR_Coverage, 18661,
     /* 1538758 */     GIR_EraseRootFromParent_Done,
     /* 1538759 */   // Label 21384: @1538759
     /* 1538759 */   GIM_Try, /*On fail goto*//*Label 21385*/ GIMT_Encode4(1538841), // Rule ID 18664 //
     /* 1538764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1538775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1538778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538803 */     // MIs[0] round
     /* 1538803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538806 */     // MIs[0] policy
     /* 1538806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538816 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1538819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538840 */     // GIR_Coverage, 18664,
     /* 1538840 */     GIR_EraseRootFromParent_Done,
     /* 1538841 */   // Label 21385: @1538841
     /* 1538841 */   GIM_Try, /*On fail goto*//*Label 21386*/ GIMT_Encode4(1538923), // Rule ID 18665 //
     /* 1538846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1538849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1538857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1538860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538885 */     // MIs[0] round
     /* 1538885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538888 */     // MIs[0] policy
     /* 1538888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538898 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1538901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538922 */     // GIR_Coverage, 18665,
     /* 1538922 */     GIR_EraseRootFromParent_Done,
     /* 1538923 */   // Label 21386: @1538923
     /* 1538923 */   GIM_Try, /*On fail goto*//*Label 21387*/ GIMT_Encode4(1539005), // Rule ID 18668 //
     /* 1538928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1538939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1538942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1538948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538967 */     // MIs[0] round
     /* 1538967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538970 */     // MIs[0] policy
     /* 1538970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538980 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1538983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539004 */     // GIR_Coverage, 18668,
     /* 1539004 */     GIR_EraseRootFromParent_Done,
     /* 1539005 */   // Label 21387: @1539005
     /* 1539005 */   GIM_Try, /*On fail goto*//*Label 21388*/ GIMT_Encode4(1539087), // Rule ID 18669 //
     /* 1539010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1539021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1539024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1539030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539049 */     // MIs[0] round
     /* 1539049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539052 */     // MIs[0] policy
     /* 1539052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539062 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1539065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539086 */     // GIR_Coverage, 18669,
     /* 1539086 */     GIR_EraseRootFromParent_Done,
     /* 1539087 */   // Label 21388: @1539087
     /* 1539087 */   GIM_Try, /*On fail goto*//*Label 21389*/ GIMT_Encode4(1539169), // Rule ID 18672 //
     /* 1539092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1539095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1539103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1539106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1539112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539131 */     // MIs[0] round
     /* 1539131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539134 */     // MIs[0] policy
     /* 1539134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539144 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1539147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539168 */     // GIR_Coverage, 18672,
     /* 1539168 */     GIR_EraseRootFromParent_Done,
     /* 1539169 */   // Label 21389: @1539169
     /* 1539169 */   GIM_Try, /*On fail goto*//*Label 21390*/ GIMT_Encode4(1539251), // Rule ID 18673 //
     /* 1539174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1539177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1539185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1539188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1539194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539213 */     // MIs[0] round
     /* 1539213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539216 */     // MIs[0] policy
     /* 1539216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539226 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1539229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539250 */     // GIR_Coverage, 18673,
     /* 1539250 */     GIR_EraseRootFromParent_Done,
     /* 1539251 */   // Label 21390: @1539251
     /* 1539251 */   GIM_Try, /*On fail goto*//*Label 21391*/ GIMT_Encode4(1539333), // Rule ID 18676 //
     /* 1539256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1539267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1539270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1539276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539295 */     // MIs[0] round
     /* 1539295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539298 */     // MIs[0] policy
     /* 1539298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539308 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1539311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539332 */     // GIR_Coverage, 18676,
     /* 1539332 */     GIR_EraseRootFromParent_Done,
     /* 1539333 */   // Label 21391: @1539333
     /* 1539333 */   GIM_Try, /*On fail goto*//*Label 21392*/ GIMT_Encode4(1539415), // Rule ID 18677 //
     /* 1539338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1539349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1539352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1539358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539377 */     // MIs[0] round
     /* 1539377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539380 */     // MIs[0] policy
     /* 1539380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539390 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1539393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539414 */     // GIR_Coverage, 18677,
     /* 1539414 */     GIR_EraseRootFromParent_Done,
     /* 1539415 */   // Label 21392: @1539415
     /* 1539415 */   GIM_Try, /*On fail goto*//*Label 21393*/ GIMT_Encode4(1539497), // Rule ID 18680 //
     /* 1539420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1539423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1539431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1539434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1539440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539459 */     // MIs[0] round
     /* 1539459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539462 */     // MIs[0] policy
     /* 1539462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539472 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1539475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539496 */     // GIR_Coverage, 18680,
     /* 1539496 */     GIR_EraseRootFromParent_Done,
     /* 1539497 */   // Label 21393: @1539497
     /* 1539497 */   GIM_Try, /*On fail goto*//*Label 21394*/ GIMT_Encode4(1539579), // Rule ID 18681 //
     /* 1539502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1539505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1539513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1539516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1539522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539541 */     // MIs[0] round
     /* 1539541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539544 */     // MIs[0] policy
     /* 1539544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539554 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1539557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539578 */     // GIR_Coverage, 18681,
     /* 1539578 */     GIR_EraseRootFromParent_Done,
     /* 1539579 */   // Label 21394: @1539579
     /* 1539579 */   GIM_Try, /*On fail goto*//*Label 21395*/ GIMT_Encode4(1539661), // Rule ID 18684 //
     /* 1539584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1539587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1539604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539623 */     // MIs[0] round
     /* 1539623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539626 */     // MIs[0] policy
     /* 1539626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539636 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1539639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539660 */     // GIR_Coverage, 18684,
     /* 1539660 */     GIR_EraseRootFromParent_Done,
     /* 1539661 */   // Label 21395: @1539661
     /* 1539661 */   GIM_Try, /*On fail goto*//*Label 21396*/ GIMT_Encode4(1539743), // Rule ID 18685 //
     /* 1539666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1539669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1539686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539705 */     // MIs[0] round
     /* 1539705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539708 */     // MIs[0] policy
     /* 1539708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539718 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1539721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539742 */     // GIR_Coverage, 18685,
     /* 1539742 */     GIR_EraseRootFromParent_Done,
     /* 1539743 */   // Label 21396: @1539743
     /* 1539743 */   GIM_Try, /*On fail goto*//*Label 21397*/ GIMT_Encode4(1539825), // Rule ID 18688 //
     /* 1539748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1539759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1539762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1539768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539787 */     // MIs[0] round
     /* 1539787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539790 */     // MIs[0] policy
     /* 1539790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539800 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1539803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539824 */     // GIR_Coverage, 18688,
     /* 1539824 */     GIR_EraseRootFromParent_Done,
     /* 1539825 */   // Label 21397: @1539825
     /* 1539825 */   GIM_Try, /*On fail goto*//*Label 21398*/ GIMT_Encode4(1539907), // Rule ID 18689 //
     /* 1539830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1539841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1539844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1539850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539869 */     // MIs[0] round
     /* 1539869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539872 */     // MIs[0] policy
     /* 1539872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539882 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1539885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539906 */     // GIR_Coverage, 18689,
     /* 1539906 */     GIR_EraseRootFromParent_Done,
     /* 1539907 */   // Label 21398: @1539907
     /* 1539907 */   GIM_Try, /*On fail goto*//*Label 21399*/ GIMT_Encode4(1539989), // Rule ID 18692 //
     /* 1539912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1539923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1539926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1539932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539951 */     // MIs[0] round
     /* 1539951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539954 */     // MIs[0] policy
     /* 1539954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539964 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1539967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539988 */     // GIR_Coverage, 18692,
     /* 1539988 */     GIR_EraseRootFromParent_Done,
     /* 1539989 */   // Label 21399: @1539989
     /* 1539989 */   GIM_Try, /*On fail goto*//*Label 21400*/ GIMT_Encode4(1540071), // Rule ID 18693 //
     /* 1539994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1540005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1540008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1540014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540033 */     // MIs[0] round
     /* 1540033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540036 */     // MIs[0] policy
     /* 1540036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540046 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1540049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540070 */     // GIR_Coverage, 18693,
     /* 1540070 */     GIR_EraseRootFromParent_Done,
     /* 1540071 */   // Label 21400: @1540071
     /* 1540071 */   GIM_Try, /*On fail goto*//*Label 21401*/ GIMT_Encode4(1540153), // Rule ID 18696 //
     /* 1540076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1540079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1540087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1540090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1540096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540115 */     // MIs[0] round
     /* 1540115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540118 */     // MIs[0] policy
     /* 1540118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540128 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1540131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540152 */     // GIR_Coverage, 18696,
     /* 1540152 */     GIR_EraseRootFromParent_Done,
     /* 1540153 */   // Label 21401: @1540153
     /* 1540153 */   GIM_Try, /*On fail goto*//*Label 21402*/ GIMT_Encode4(1540235), // Rule ID 18697 //
     /* 1540158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1540161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1540169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1540172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1540178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540197 */     // MIs[0] round
     /* 1540197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540200 */     // MIs[0] policy
     /* 1540200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540210 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1540213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540234 */     // GIR_Coverage, 18697,
     /* 1540234 */     GIR_EraseRootFromParent_Done,
     /* 1540235 */   // Label 21402: @1540235
     /* 1540235 */   GIM_Try, /*On fail goto*//*Label 21403*/ GIMT_Encode4(1540317), // Rule ID 18700 //
     /* 1540240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1540243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1540251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1540254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1540260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540279 */     // MIs[0] round
     /* 1540279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540282 */     // MIs[0] policy
     /* 1540282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540292 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1540295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540316 */     // GIR_Coverage, 18700,
     /* 1540316 */     GIR_EraseRootFromParent_Done,
     /* 1540317 */   // Label 21403: @1540317
     /* 1540317 */   GIM_Try, /*On fail goto*//*Label 21404*/ GIMT_Encode4(1540399), // Rule ID 18701 //
     /* 1540322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1540325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1540333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1540336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1540342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540361 */     // MIs[0] round
     /* 1540361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540364 */     // MIs[0] policy
     /* 1540364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540374 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1540377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540398 */     // GIR_Coverage, 18701,
     /* 1540398 */     GIR_EraseRootFromParent_Done,
     /* 1540399 */   // Label 21404: @1540399
     /* 1540399 */   GIM_Try, /*On fail goto*//*Label 21405*/ GIMT_Encode4(1540481), // Rule ID 18704 //
     /* 1540404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1540407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1540415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1540418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1540424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540443 */     // MIs[0] round
     /* 1540443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540446 */     // MIs[0] policy
     /* 1540446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540456 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1540459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540480 */     // GIR_Coverage, 18704,
     /* 1540480 */     GIR_EraseRootFromParent_Done,
     /* 1540481 */   // Label 21405: @1540481
     /* 1540481 */   GIM_Try, /*On fail goto*//*Label 21406*/ GIMT_Encode4(1540563), // Rule ID 18705 //
     /* 1540486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1540489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1540497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1540500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1540506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540525 */     // MIs[0] round
     /* 1540525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540528 */     // MIs[0] policy
     /* 1540528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540538 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1540541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540562 */     // GIR_Coverage, 18705,
     /* 1540562 */     GIR_EraseRootFromParent_Done,
     /* 1540563 */   // Label 21406: @1540563
     /* 1540563 */   GIM_Try, /*On fail goto*//*Label 21407*/ GIMT_Encode4(1540645), // Rule ID 18708 //
     /* 1540568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1540571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1540579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1540582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1540588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540607 */     // MIs[0] round
     /* 1540607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540610 */     // MIs[0] policy
     /* 1540610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540620 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1540623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540644 */     // GIR_Coverage, 18708,
     /* 1540644 */     GIR_EraseRootFromParent_Done,
     /* 1540645 */   // Label 21407: @1540645
     /* 1540645 */   GIM_Try, /*On fail goto*//*Label 21408*/ GIMT_Encode4(1540727), // Rule ID 18709 //
     /* 1540650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1540653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1540661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1540664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1540670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540689 */     // MIs[0] round
     /* 1540689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540692 */     // MIs[0] policy
     /* 1540692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540702 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1540705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540726 */     // GIR_Coverage, 18709,
     /* 1540726 */     GIR_EraseRootFromParent_Done,
     /* 1540727 */   // Label 21408: @1540727
     /* 1540727 */   GIM_Try, /*On fail goto*//*Label 21409*/ GIMT_Encode4(1540809), // Rule ID 18712 //
     /* 1540732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1540735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1540743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1540746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1540752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540771 */     // MIs[0] round
     /* 1540771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540774 */     // MIs[0] policy
     /* 1540774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1540787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540808 */     // GIR_Coverage, 18712,
     /* 1540808 */     GIR_EraseRootFromParent_Done,
     /* 1540809 */   // Label 21409: @1540809
     /* 1540809 */   GIM_Try, /*On fail goto*//*Label 21410*/ GIMT_Encode4(1540891), // Rule ID 18713 //
     /* 1540814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1540817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1540825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1540828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1540834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540853 */     // MIs[0] round
     /* 1540853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540856 */     // MIs[0] policy
     /* 1540856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540866 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1540869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540890 */     // GIR_Coverage, 18713,
     /* 1540890 */     GIR_EraseRootFromParent_Done,
     /* 1540891 */   // Label 21410: @1540891
     /* 1540891 */   GIM_Try, /*On fail goto*//*Label 21411*/ GIMT_Encode4(1540973), // Rule ID 18716 //
     /* 1540896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1540899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1540907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1540910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1540916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540935 */     // MIs[0] round
     /* 1540935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540938 */     // MIs[0] policy
     /* 1540938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540948 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1540951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540972 */     // GIR_Coverage, 18716,
     /* 1540972 */     GIR_EraseRootFromParent_Done,
     /* 1540973 */   // Label 21411: @1540973
     /* 1540973 */   GIM_Try, /*On fail goto*//*Label 21412*/ GIMT_Encode4(1541055), // Rule ID 18717 //
     /* 1540978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1540981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1540989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1540992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1540998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1541013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541017 */     // MIs[0] round
     /* 1541017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541020 */     // MIs[0] policy
     /* 1541020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541030 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1541033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1541051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541054 */     // GIR_Coverage, 18717,
     /* 1541054 */     GIR_EraseRootFromParent_Done,
     /* 1541055 */   // Label 21412: @1541055
     /* 1541055 */   GIM_Try, /*On fail goto*//*Label 21413*/ GIMT_Encode4(1541137), // Rule ID 18720 //
     /* 1541060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1541063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1541071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1541074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1541077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1541080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1541095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541099 */     // MIs[0] round
     /* 1541099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541102 */     // MIs[0] policy
     /* 1541102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541112 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1541115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1541133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541136 */     // GIR_Coverage, 18720,
     /* 1541136 */     GIR_EraseRootFromParent_Done,
     /* 1541137 */   // Label 21413: @1541137
     /* 1541137 */   GIM_Try, /*On fail goto*//*Label 21414*/ GIMT_Encode4(1541219), // Rule ID 18721 //
     /* 1541142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1541145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1541153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1541156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1541159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1541162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1541177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541181 */     // MIs[0] round
     /* 1541181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541184 */     // MIs[0] policy
     /* 1541184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541194 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1541197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1541215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541218 */     // GIR_Coverage, 18721,
     /* 1541218 */     GIR_EraseRootFromParent_Done,
     /* 1541219 */   // Label 21414: @1541219
     /* 1541219 */   GIM_Try, /*On fail goto*//*Label 21415*/ GIMT_Encode4(1541301), // Rule ID 18724 //
     /* 1541224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1541235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1541238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1541241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1541244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541263 */     // MIs[0] round
     /* 1541263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541266 */     // MIs[0] policy
     /* 1541266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541276 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1541279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541300 */     // GIR_Coverage, 18724,
     /* 1541300 */     GIR_EraseRootFromParent_Done,
     /* 1541301 */   // Label 21415: @1541301
     /* 1541301 */   GIM_Try, /*On fail goto*//*Label 21416*/ GIMT_Encode4(1541383), // Rule ID 18725 //
     /* 1541306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1541317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1541320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1541323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1541326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541345 */     // MIs[0] round
     /* 1541345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541348 */     // MIs[0] policy
     /* 1541348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541358 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1541361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541382 */     // GIR_Coverage, 18725,
     /* 1541382 */     GIR_EraseRootFromParent_Done,
     /* 1541383 */   // Label 21416: @1541383
     /* 1541383 */   GIM_Try, /*On fail goto*//*Label 21417*/ GIMT_Encode4(1541465), // Rule ID 18728 //
     /* 1541388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1541399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1541402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1541405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1541408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541427 */     // MIs[0] round
     /* 1541427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541430 */     // MIs[0] policy
     /* 1541430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541440 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1541443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541464 */     // GIR_Coverage, 18728,
     /* 1541464 */     GIR_EraseRootFromParent_Done,
     /* 1541465 */   // Label 21417: @1541465
     /* 1541465 */   GIM_Try, /*On fail goto*//*Label 21418*/ GIMT_Encode4(1541547), // Rule ID 18729 //
     /* 1541470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1541481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1541484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1541487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1541490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541509 */     // MIs[0] round
     /* 1541509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541512 */     // MIs[0] policy
     /* 1541512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541522 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1541525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541546 */     // GIR_Coverage, 18729,
     /* 1541546 */     GIR_EraseRootFromParent_Done,
     /* 1541547 */   // Label 21418: @1541547
     /* 1541547 */   GIM_Try, /*On fail goto*//*Label 21419*/ GIMT_Encode4(1541629), // Rule ID 18732 //
     /* 1541552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1541569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1541572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541591 */     // MIs[0] round
     /* 1541591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541594 */     // MIs[0] policy
     /* 1541594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541604 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1541607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541628 */     // GIR_Coverage, 18732,
     /* 1541628 */     GIR_EraseRootFromParent_Done,
     /* 1541629 */   // Label 21419: @1541629
     /* 1541629 */   GIM_Try, /*On fail goto*//*Label 21420*/ GIMT_Encode4(1541711), // Rule ID 18733 //
     /* 1541634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1541651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1541654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541673 */     // MIs[0] round
     /* 1541673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541676 */     // MIs[0] policy
     /* 1541676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541686 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1541689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541710 */     // GIR_Coverage, 18733,
     /* 1541710 */     GIR_EraseRootFromParent_Done,
     /* 1541711 */   // Label 21420: @1541711
     /* 1541711 */   GIM_Try, /*On fail goto*//*Label 21421*/ GIMT_Encode4(1541793), // Rule ID 18736 //
     /* 1541716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1541733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1541736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541755 */     // MIs[0] round
     /* 1541755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541758 */     // MIs[0] policy
     /* 1541758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541768 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1541771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541792 */     // GIR_Coverage, 18736,
     /* 1541792 */     GIR_EraseRootFromParent_Done,
     /* 1541793 */   // Label 21421: @1541793
     /* 1541793 */   GIM_Try, /*On fail goto*//*Label 21422*/ GIMT_Encode4(1541875), // Rule ID 18737 //
     /* 1541798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1541815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1541818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541837 */     // MIs[0] round
     /* 1541837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541840 */     // MIs[0] policy
     /* 1541840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541850 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1541853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541874 */     // GIR_Coverage, 18737,
     /* 1541874 */     GIR_EraseRootFromParent_Done,
     /* 1541875 */   // Label 21422: @1541875
     /* 1541875 */   GIM_Try, /*On fail goto*//*Label 21423*/ GIMT_Encode4(1541957), // Rule ID 18740 //
     /* 1541880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1541891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1541894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1541897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1541900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541919 */     // MIs[0] round
     /* 1541919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541922 */     // MIs[0] policy
     /* 1541922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541932 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1541935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541956 */     // GIR_Coverage, 18740,
     /* 1541956 */     GIR_EraseRootFromParent_Done,
     /* 1541957 */   // Label 21423: @1541957
     /* 1541957 */   GIM_Try, /*On fail goto*//*Label 21424*/ GIMT_Encode4(1542039), // Rule ID 18741 //
     /* 1541962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1541973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1541976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1541979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1541982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542001 */     // MIs[0] round
     /* 1542001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542004 */     // MIs[0] policy
     /* 1542004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542014 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1542017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542038 */     // GIR_Coverage, 18741,
     /* 1542038 */     GIR_EraseRootFromParent_Done,
     /* 1542039 */   // Label 21424: @1542039
     /* 1542039 */   GIM_Try, /*On fail goto*//*Label 21425*/ GIMT_Encode4(1542121), // Rule ID 18744 //
     /* 1542044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1542055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1542058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1542061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1542064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542083 */     // MIs[0] round
     /* 1542083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542086 */     // MIs[0] policy
     /* 1542086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542096 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1542099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542120 */     // GIR_Coverage, 18744,
     /* 1542120 */     GIR_EraseRootFromParent_Done,
     /* 1542121 */   // Label 21425: @1542121
     /* 1542121 */   GIM_Try, /*On fail goto*//*Label 21426*/ GIMT_Encode4(1542203), // Rule ID 18745 //
     /* 1542126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1542137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1542140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1542143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1542146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542165 */     // MIs[0] round
     /* 1542165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542168 */     // MIs[0] policy
     /* 1542168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542178 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1542181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542202 */     // GIR_Coverage, 18745,
     /* 1542202 */     GIR_EraseRootFromParent_Done,
     /* 1542203 */   // Label 21426: @1542203
     /* 1542203 */   GIM_Try, /*On fail goto*//*Label 21427*/ GIMT_Encode4(1542285), // Rule ID 18748 //
     /* 1542208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1542219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1542222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1542225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1542228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542247 */     // MIs[0] round
     /* 1542247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542250 */     // MIs[0] policy
     /* 1542250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542260 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1542263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542284 */     // GIR_Coverage, 18748,
     /* 1542284 */     GIR_EraseRootFromParent_Done,
     /* 1542285 */   // Label 21427: @1542285
     /* 1542285 */   GIM_Try, /*On fail goto*//*Label 21428*/ GIMT_Encode4(1542367), // Rule ID 18749 //
     /* 1542290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1542301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1542304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1542307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1542310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542329 */     // MIs[0] round
     /* 1542329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542332 */     // MIs[0] policy
     /* 1542332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542342 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1542345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542366 */     // GIR_Coverage, 18749,
     /* 1542366 */     GIR_EraseRootFromParent_Done,
     /* 1542367 */   // Label 21428: @1542367
     /* 1542367 */   GIM_Try, /*On fail goto*//*Label 21429*/ GIMT_Encode4(1542449), // Rule ID 18752 //
     /* 1542372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1542383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1542386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1542389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1542392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542411 */     // MIs[0] round
     /* 1542411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542414 */     // MIs[0] policy
     /* 1542414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542424 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1542427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542448 */     // GIR_Coverage, 18752,
     /* 1542448 */     GIR_EraseRootFromParent_Done,
     /* 1542449 */   // Label 21429: @1542449
     /* 1542449 */   GIM_Try, /*On fail goto*//*Label 21430*/ GIMT_Encode4(1542531), // Rule ID 18753 //
     /* 1542454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1542465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1542468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1542471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1542474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542493 */     // MIs[0] round
     /* 1542493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542496 */     // MIs[0] policy
     /* 1542496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542506 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1542509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542530 */     // GIR_Coverage, 18753,
     /* 1542530 */     GIR_EraseRootFromParent_Done,
     /* 1542531 */   // Label 21430: @1542531
     /* 1542531 */   GIM_Try, /*On fail goto*//*Label 21431*/ GIMT_Encode4(1542613), // Rule ID 18756 //
     /* 1542536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1542553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1542556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542575 */     // MIs[0] round
     /* 1542575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542578 */     // MIs[0] policy
     /* 1542578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542588 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1542591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542612 */     // GIR_Coverage, 18756,
     /* 1542612 */     GIR_EraseRootFromParent_Done,
     /* 1542613 */   // Label 21431: @1542613
     /* 1542613 */   GIM_Try, /*On fail goto*//*Label 21432*/ GIMT_Encode4(1542695), // Rule ID 18757 //
     /* 1542618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1542635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1542638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542657 */     // MIs[0] round
     /* 1542657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542660 */     // MIs[0] policy
     /* 1542660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542670 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1542673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542694 */     // GIR_Coverage, 18757,
     /* 1542694 */     GIR_EraseRootFromParent_Done,
     /* 1542695 */   // Label 21432: @1542695
     /* 1542695 */   GIM_Try, /*On fail goto*//*Label 21433*/ GIMT_Encode4(1542777), // Rule ID 18760 //
     /* 1542700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1542711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1542714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1542720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542739 */     // MIs[0] round
     /* 1542739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542742 */     // MIs[0] policy
     /* 1542742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542752 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1542755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542776 */     // GIR_Coverage, 18760,
     /* 1542776 */     GIR_EraseRootFromParent_Done,
     /* 1542777 */   // Label 21433: @1542777
     /* 1542777 */   GIM_Try, /*On fail goto*//*Label 21434*/ GIMT_Encode4(1542859), // Rule ID 18761 //
     /* 1542782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1542793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1542796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1542802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542821 */     // MIs[0] round
     /* 1542821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542824 */     // MIs[0] policy
     /* 1542824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542834 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1542837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542858 */     // GIR_Coverage, 18761,
     /* 1542858 */     GIR_EraseRootFromParent_Done,
     /* 1542859 */   // Label 21434: @1542859
     /* 1542859 */   GIM_Try, /*On fail goto*//*Label 21435*/ GIMT_Encode4(1542941), // Rule ID 18764 //
     /* 1542864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1542875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1542878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1542884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542903 */     // MIs[0] round
     /* 1542903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542906 */     // MIs[0] policy
     /* 1542906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542916 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1542919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542940 */     // GIR_Coverage, 18764,
     /* 1542940 */     GIR_EraseRootFromParent_Done,
     /* 1542941 */   // Label 21435: @1542941
     /* 1542941 */   GIM_Try, /*On fail goto*//*Label 21436*/ GIMT_Encode4(1543023), // Rule ID 18765 //
     /* 1542946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1542957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1542960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1542966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542985 */     // MIs[0] round
     /* 1542985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542988 */     // MIs[0] policy
     /* 1542988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542998 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1543001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543022 */     // GIR_Coverage, 18765,
     /* 1543022 */     GIR_EraseRootFromParent_Done,
     /* 1543023 */   // Label 21436: @1543023
     /* 1543023 */   GIM_Try, /*On fail goto*//*Label 21437*/ GIMT_Encode4(1543105), // Rule ID 18768 //
     /* 1543028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1543039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1543042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1543048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543067 */     // MIs[0] round
     /* 1543067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543070 */     // MIs[0] policy
     /* 1543070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543080 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1543083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543104 */     // GIR_Coverage, 18768,
     /* 1543104 */     GIR_EraseRootFromParent_Done,
     /* 1543105 */   // Label 21437: @1543105
     /* 1543105 */   GIM_Try, /*On fail goto*//*Label 21438*/ GIMT_Encode4(1543187), // Rule ID 18769 //
     /* 1543110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1543121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1543124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1543130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543149 */     // MIs[0] round
     /* 1543149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543152 */     // MIs[0] policy
     /* 1543152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543162 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1543165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543186 */     // GIR_Coverage, 18769,
     /* 1543186 */     GIR_EraseRootFromParent_Done,
     /* 1543187 */   // Label 21438: @1543187
     /* 1543187 */   GIM_Try, /*On fail goto*//*Label 21439*/ GIMT_Encode4(1543269), // Rule ID 18772 //
     /* 1543192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1543203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1543206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1543212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543231 */     // MIs[0] round
     /* 1543231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543234 */     // MIs[0] policy
     /* 1543234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543244 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1543247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543268 */     // GIR_Coverage, 18772,
     /* 1543268 */     GIR_EraseRootFromParent_Done,
     /* 1543269 */   // Label 21439: @1543269
     /* 1543269 */   GIM_Try, /*On fail goto*//*Label 21440*/ GIMT_Encode4(1543351), // Rule ID 18773 //
     /* 1543274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1543285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1543288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1543294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543313 */     // MIs[0] round
     /* 1543313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543316 */     // MIs[0] policy
     /* 1543316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543326 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1543329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543350 */     // GIR_Coverage, 18773,
     /* 1543350 */     GIR_EraseRootFromParent_Done,
     /* 1543351 */   // Label 21440: @1543351
     /* 1543351 */   GIM_Try, /*On fail goto*//*Label 21441*/ GIMT_Encode4(1543433), // Rule ID 18776 //
     /* 1543356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1543367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1543370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1543376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543395 */     // MIs[0] round
     /* 1543395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543398 */     // MIs[0] policy
     /* 1543398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543408 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1543411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543432 */     // GIR_Coverage, 18776,
     /* 1543432 */     GIR_EraseRootFromParent_Done,
     /* 1543433 */   // Label 21441: @1543433
     /* 1543433 */   GIM_Try, /*On fail goto*//*Label 21442*/ GIMT_Encode4(1543515), // Rule ID 18777 //
     /* 1543438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1543449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1543452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1543458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543477 */     // MIs[0] round
     /* 1543477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543480 */     // MIs[0] policy
     /* 1543480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543490 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1543493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543514 */     // GIR_Coverage, 18777,
     /* 1543514 */     GIR_EraseRootFromParent_Done,
     /* 1543515 */   // Label 21442: @1543515
     /* 1543515 */   GIM_Try, /*On fail goto*//*Label 21443*/ GIMT_Encode4(1543597), // Rule ID 18780 //
     /* 1543520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1543540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543559 */     // MIs[0] round
     /* 1543559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543562 */     // MIs[0] policy
     /* 1543562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543572 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1543575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543596 */     // GIR_Coverage, 18780,
     /* 1543596 */     GIR_EraseRootFromParent_Done,
     /* 1543597 */   // Label 21443: @1543597
     /* 1543597 */   GIM_Try, /*On fail goto*//*Label 21444*/ GIMT_Encode4(1543679), // Rule ID 18781 //
     /* 1543602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1543622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543641 */     // MIs[0] round
     /* 1543641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543644 */     // MIs[0] policy
     /* 1543644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543654 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1543657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543678 */     // GIR_Coverage, 18781,
     /* 1543678 */     GIR_EraseRootFromParent_Done,
     /* 1543679 */   // Label 21444: @1543679
     /* 1543679 */   GIM_Try, /*On fail goto*//*Label 21445*/ GIMT_Encode4(1543761), // Rule ID 18784 //
     /* 1543684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1543695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1543698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1543704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543723 */     // MIs[0] round
     /* 1543723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543726 */     // MIs[0] policy
     /* 1543726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543736 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1543739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543760 */     // GIR_Coverage, 18784,
     /* 1543760 */     GIR_EraseRootFromParent_Done,
     /* 1543761 */   // Label 21445: @1543761
     /* 1543761 */   GIM_Try, /*On fail goto*//*Label 21446*/ GIMT_Encode4(1543843), // Rule ID 18785 //
     /* 1543766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1543777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1543780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1543786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543805 */     // MIs[0] round
     /* 1543805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543808 */     // MIs[0] policy
     /* 1543808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543818 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1543821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543842 */     // GIR_Coverage, 18785,
     /* 1543842 */     GIR_EraseRootFromParent_Done,
     /* 1543843 */   // Label 21446: @1543843
     /* 1543843 */   GIM_Try, /*On fail goto*//*Label 21447*/ GIMT_Encode4(1543925), // Rule ID 18788 //
     /* 1543848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1543859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1543862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1543868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543887 */     // MIs[0] round
     /* 1543887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543890 */     // MIs[0] policy
     /* 1543890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543900 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1543903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543924 */     // GIR_Coverage, 18788,
     /* 1543924 */     GIR_EraseRootFromParent_Done,
     /* 1543925 */   // Label 21447: @1543925
     /* 1543925 */   GIM_Try, /*On fail goto*//*Label 21448*/ GIMT_Encode4(1544007), // Rule ID 18789 //
     /* 1543930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1543941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1543944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1543950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543969 */     // MIs[0] round
     /* 1543969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543972 */     // MIs[0] policy
     /* 1543972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543982 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1543985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544006 */     // GIR_Coverage, 18789,
     /* 1544006 */     GIR_EraseRootFromParent_Done,
     /* 1544007 */   // Label 21448: @1544007
     /* 1544007 */   GIM_Try, /*On fail goto*//*Label 21449*/ GIMT_Encode4(1544089), // Rule ID 18792 //
     /* 1544012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1544020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1544023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1544026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1544029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1544032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1544047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544051 */     // MIs[0] round
     /* 1544051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544054 */     // MIs[0] policy
     /* 1544054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544064 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1544067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544088 */     // GIR_Coverage, 18792,
     /* 1544088 */     GIR_EraseRootFromParent_Done,
     /* 1544089 */   // Label 21449: @1544089
     /* 1544089 */   GIM_Try, /*On fail goto*//*Label 21450*/ GIMT_Encode4(1544171), // Rule ID 18793 //
     /* 1544094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1544102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1544105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1544108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1544111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1544114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1544129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544133 */     // MIs[0] round
     /* 1544133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544136 */     // MIs[0] policy
     /* 1544136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544146 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1544149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544170 */     // GIR_Coverage, 18793,
     /* 1544170 */     GIR_EraseRootFromParent_Done,
     /* 1544171 */   // Label 21450: @1544171
     /* 1544171 */   GIM_Try, /*On fail goto*//*Label 21451*/ GIMT_Encode4(1544253), // Rule ID 18796 //
     /* 1544176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1544187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1544190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1544193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1544196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544215 */     // MIs[0] round
     /* 1544215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544218 */     // MIs[0] policy
     /* 1544218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544228 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1544231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544252 */     // GIR_Coverage, 18796,
     /* 1544252 */     GIR_EraseRootFromParent_Done,
     /* 1544253 */   // Label 21451: @1544253
     /* 1544253 */   GIM_Try, /*On fail goto*//*Label 21452*/ GIMT_Encode4(1544335), // Rule ID 18797 //
     /* 1544258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1544269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1544272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1544275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1544278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544297 */     // MIs[0] round
     /* 1544297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544300 */     // MIs[0] policy
     /* 1544300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544310 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1544313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544334 */     // GIR_Coverage, 18797,
     /* 1544334 */     GIR_EraseRootFromParent_Done,
     /* 1544335 */   // Label 21452: @1544335
     /* 1544335 */   GIM_Try, /*On fail goto*//*Label 21453*/ GIMT_Encode4(1544417), // Rule ID 18800 //
     /* 1544340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1544351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1544354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1544357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1544360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544379 */     // MIs[0] round
     /* 1544379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544382 */     // MIs[0] policy
     /* 1544382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544392 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1544395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544416 */     // GIR_Coverage, 18800,
     /* 1544416 */     GIR_EraseRootFromParent_Done,
     /* 1544417 */   // Label 21453: @1544417
     /* 1544417 */   GIM_Try, /*On fail goto*//*Label 21454*/ GIMT_Encode4(1544499), // Rule ID 18801 //
     /* 1544422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1544433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1544436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1544439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1544442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544461 */     // MIs[0] round
     /* 1544461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544464 */     // MIs[0] policy
     /* 1544464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544474 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1544477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544498 */     // GIR_Coverage, 18801,
     /* 1544498 */     GIR_EraseRootFromParent_Done,
     /* 1544499 */   // Label 21454: @1544499
     /* 1544499 */   GIM_Try, /*On fail goto*//*Label 21455*/ GIMT_Encode4(1544581), // Rule ID 18804 //
     /* 1544504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1544521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544543 */     // MIs[0] round
     /* 1544543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544546 */     // MIs[0] policy
     /* 1544546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544556 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1544559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544580 */     // GIR_Coverage, 18804,
     /* 1544580 */     GIR_EraseRootFromParent_Done,
     /* 1544581 */   // Label 21455: @1544581
     /* 1544581 */   GIM_Try, /*On fail goto*//*Label 21456*/ GIMT_Encode4(1544663), // Rule ID 18805 //
     /* 1544586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1544603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544625 */     // MIs[0] round
     /* 1544625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544628 */     // MIs[0] policy
     /* 1544628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544638 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1544641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544662 */     // GIR_Coverage, 18805,
     /* 1544662 */     GIR_EraseRootFromParent_Done,
     /* 1544663 */   // Label 21456: @1544663
     /* 1544663 */   GIM_Try, /*On fail goto*//*Label 21457*/ GIMT_Encode4(1544745), // Rule ID 18808 //
     /* 1544668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1544679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1544682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1544685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1544688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544707 */     // MIs[0] round
     /* 1544707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544710 */     // MIs[0] policy
     /* 1544710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544720 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1544723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544744 */     // GIR_Coverage, 18808,
     /* 1544744 */     GIR_EraseRootFromParent_Done,
     /* 1544745 */   // Label 21457: @1544745
     /* 1544745 */   GIM_Try, /*On fail goto*//*Label 21458*/ GIMT_Encode4(1544827), // Rule ID 18809 //
     /* 1544750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1544761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1544764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1544767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1544770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544789 */     // MIs[0] round
     /* 1544789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544792 */     // MIs[0] policy
     /* 1544792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544802 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1544805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544826 */     // GIR_Coverage, 18809,
     /* 1544826 */     GIR_EraseRootFromParent_Done,
     /* 1544827 */   // Label 21458: @1544827
     /* 1544827 */   GIM_Try, /*On fail goto*//*Label 21459*/ GIMT_Encode4(1544909), // Rule ID 18812 //
     /* 1544832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1544843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1544846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1544849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1544852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544871 */     // MIs[0] round
     /* 1544871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544874 */     // MIs[0] policy
     /* 1544874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544884 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1544887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544908 */     // GIR_Coverage, 18812,
     /* 1544908 */     GIR_EraseRootFromParent_Done,
     /* 1544909 */   // Label 21459: @1544909
     /* 1544909 */   GIM_Try, /*On fail goto*//*Label 21460*/ GIMT_Encode4(1544991), // Rule ID 18813 //
     /* 1544914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1544925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1544928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1544931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1544934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544953 */     // MIs[0] round
     /* 1544953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544956 */     // MIs[0] policy
     /* 1544956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544966 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1544969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544990 */     // GIR_Coverage, 18813,
     /* 1544990 */     GIR_EraseRootFromParent_Done,
     /* 1544991 */   // Label 21460: @1544991
     /* 1544991 */   GIM_Try, /*On fail goto*//*Label 21461*/ GIMT_Encode4(1545073), // Rule ID 18816 //
     /* 1544996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1545007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1545010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1545013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1545016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545035 */     // MIs[0] round
     /* 1545035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545038 */     // MIs[0] policy
     /* 1545038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545048 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1545051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545072 */     // GIR_Coverage, 18816,
     /* 1545072 */     GIR_EraseRootFromParent_Done,
     /* 1545073 */   // Label 21461: @1545073
     /* 1545073 */   GIM_Try, /*On fail goto*//*Label 21462*/ GIMT_Encode4(1545155), // Rule ID 18817 //
     /* 1545078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1545089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1545092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1545095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1545098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545117 */     // MIs[0] round
     /* 1545117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545120 */     // MIs[0] policy
     /* 1545120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545130 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1545133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545154 */     // GIR_Coverage, 18817,
     /* 1545154 */     GIR_EraseRootFromParent_Done,
     /* 1545155 */   // Label 21462: @1545155
     /* 1545155 */   GIM_Try, /*On fail goto*//*Label 21463*/ GIMT_Encode4(1545237), // Rule ID 18820 //
     /* 1545160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1545171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1545174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1545177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1545180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545199 */     // MIs[0] round
     /* 1545199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545202 */     // MIs[0] policy
     /* 1545202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545212 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1545215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545236 */     // GIR_Coverage, 18820,
     /* 1545236 */     GIR_EraseRootFromParent_Done,
     /* 1545237 */   // Label 21463: @1545237
     /* 1545237 */   GIM_Try, /*On fail goto*//*Label 21464*/ GIMT_Encode4(1545319), // Rule ID 18821 //
     /* 1545242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1545253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1545256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1545259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1545262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545281 */     // MIs[0] round
     /* 1545281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545284 */     // MIs[0] policy
     /* 1545284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545294 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1545297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545318 */     // GIR_Coverage, 18821,
     /* 1545318 */     GIR_EraseRootFromParent_Done,
     /* 1545319 */   // Label 21464: @1545319
     /* 1545319 */   GIM_Try, /*On fail goto*//*Label 21465*/ GIMT_Encode4(1545401), // Rule ID 18824 //
     /* 1545324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1545335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1545338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1545341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1545344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545363 */     // MIs[0] round
     /* 1545363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545366 */     // MIs[0] policy
     /* 1545366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545376 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1545379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545400 */     // GIR_Coverage, 18824,
     /* 1545400 */     GIR_EraseRootFromParent_Done,
     /* 1545401 */   // Label 21465: @1545401
     /* 1545401 */   GIM_Try, /*On fail goto*//*Label 21466*/ GIMT_Encode4(1545483), // Rule ID 18825 //
     /* 1545406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1545417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1545420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1545423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1545426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545445 */     // MIs[0] round
     /* 1545445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545448 */     // MIs[0] policy
     /* 1545448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545458 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1545461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545482 */     // GIR_Coverage, 18825,
     /* 1545482 */     GIR_EraseRootFromParent_Done,
     /* 1545483 */   // Label 21466: @1545483
     /* 1545483 */   GIM_Try, /*On fail goto*//*Label 21467*/ GIMT_Encode4(1545565), // Rule ID 18828 //
     /* 1545488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1545505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545527 */     // MIs[0] round
     /* 1545527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545530 */     // MIs[0] policy
     /* 1545530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545540 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1545543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545564 */     // GIR_Coverage, 18828,
     /* 1545564 */     GIR_EraseRootFromParent_Done,
     /* 1545565 */   // Label 21467: @1545565
     /* 1545565 */   GIM_Try, /*On fail goto*//*Label 21468*/ GIMT_Encode4(1545647), // Rule ID 18829 //
     /* 1545570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1545587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545609 */     // MIs[0] round
     /* 1545609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545612 */     // MIs[0] policy
     /* 1545612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545622 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1545625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545646 */     // GIR_Coverage, 18829,
     /* 1545646 */     GIR_EraseRootFromParent_Done,
     /* 1545647 */   // Label 21468: @1545647
     /* 1545647 */   GIM_Try, /*On fail goto*//*Label 21469*/ GIMT_Encode4(1545729), // Rule ID 18832 //
     /* 1545652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1545663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1545666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1545672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545691 */     // MIs[0] round
     /* 1545691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545694 */     // MIs[0] policy
     /* 1545694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545704 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1545707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545728 */     // GIR_Coverage, 18832,
     /* 1545728 */     GIR_EraseRootFromParent_Done,
     /* 1545729 */   // Label 21469: @1545729
     /* 1545729 */   GIM_Try, /*On fail goto*//*Label 21470*/ GIMT_Encode4(1545811), // Rule ID 18833 //
     /* 1545734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1545745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1545748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1545754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545773 */     // MIs[0] round
     /* 1545773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545776 */     // MIs[0] policy
     /* 1545776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545786 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1545789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545810 */     // GIR_Coverage, 18833,
     /* 1545810 */     GIR_EraseRootFromParent_Done,
     /* 1545811 */   // Label 21470: @1545811
     /* 1545811 */   GIM_Try, /*On fail goto*//*Label 21471*/ GIMT_Encode4(1545893), // Rule ID 18836 //
     /* 1545816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1545827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1545830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1545836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545855 */     // MIs[0] round
     /* 1545855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545858 */     // MIs[0] policy
     /* 1545858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545868 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1545871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545892 */     // GIR_Coverage, 18836,
     /* 1545892 */     GIR_EraseRootFromParent_Done,
     /* 1545893 */   // Label 21471: @1545893
     /* 1545893 */   GIM_Try, /*On fail goto*//*Label 21472*/ GIMT_Encode4(1545975), // Rule ID 18837 //
     /* 1545898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1545909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1545912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1545918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545937 */     // MIs[0] round
     /* 1545937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545940 */     // MIs[0] policy
     /* 1545940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545950 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1545953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545974 */     // GIR_Coverage, 18837,
     /* 1545974 */     GIR_EraseRootFromParent_Done,
     /* 1545975 */   // Label 21472: @1545975
     /* 1545975 */   GIM_Try, /*On fail goto*//*Label 21473*/ GIMT_Encode4(1546057), // Rule ID 18840 //
     /* 1545980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1545991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1545994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1546000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546019 */     // MIs[0] round
     /* 1546019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546022 */     // MIs[0] policy
     /* 1546022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546032 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1546035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546056 */     // GIR_Coverage, 18840,
     /* 1546056 */     GIR_EraseRootFromParent_Done,
     /* 1546057 */   // Label 21473: @1546057
     /* 1546057 */   GIM_Try, /*On fail goto*//*Label 21474*/ GIMT_Encode4(1546139), // Rule ID 18841 //
     /* 1546062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1546073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1546076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1546082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546101 */     // MIs[0] round
     /* 1546101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546104 */     // MIs[0] policy
     /* 1546104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546114 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1546117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546138 */     // GIR_Coverage, 18841,
     /* 1546138 */     GIR_EraseRootFromParent_Done,
     /* 1546139 */   // Label 21474: @1546139
     /* 1546139 */   GIM_Try, /*On fail goto*//*Label 21475*/ GIMT_Encode4(1546221), // Rule ID 18844 //
     /* 1546144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1546155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1546158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1546164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546183 */     // MIs[0] round
     /* 1546183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546186 */     // MIs[0] policy
     /* 1546186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546196 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1546199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546220 */     // GIR_Coverage, 18844,
     /* 1546220 */     GIR_EraseRootFromParent_Done,
     /* 1546221 */   // Label 21475: @1546221
     /* 1546221 */   GIM_Try, /*On fail goto*//*Label 21476*/ GIMT_Encode4(1546303), // Rule ID 18845 //
     /* 1546226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1546237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1546240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1546246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546265 */     // MIs[0] round
     /* 1546265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546268 */     // MIs[0] policy
     /* 1546268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546278 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1546281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546302 */     // GIR_Coverage, 18845,
     /* 1546302 */     GIR_EraseRootFromParent_Done,
     /* 1546303 */   // Label 21476: @1546303
     /* 1546303 */   GIM_Try, /*On fail goto*//*Label 21477*/ GIMT_Encode4(1546385), // Rule ID 18848 //
     /* 1546308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1546319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1546322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1546328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546347 */     // MIs[0] round
     /* 1546347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546350 */     // MIs[0] policy
     /* 1546350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546360 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1546363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546384 */     // GIR_Coverage, 18848,
     /* 1546384 */     GIR_EraseRootFromParent_Done,
     /* 1546385 */   // Label 21477: @1546385
     /* 1546385 */   GIM_Try, /*On fail goto*//*Label 21478*/ GIMT_Encode4(1546467), // Rule ID 18849 //
     /* 1546390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1546401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1546404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1546410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546429 */     // MIs[0] round
     /* 1546429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546432 */     // MIs[0] policy
     /* 1546432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546442 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1546445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546466 */     // GIR_Coverage, 18849,
     /* 1546466 */     GIR_EraseRootFromParent_Done,
     /* 1546467 */   // Label 21478: @1546467
     /* 1546467 */   GIM_Try, /*On fail goto*//*Label 21479*/ GIMT_Encode4(1546549), // Rule ID 18852 //
     /* 1546472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1546492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546511 */     // MIs[0] round
     /* 1546511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546514 */     // MIs[0] policy
     /* 1546514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546524 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1546527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546548 */     // GIR_Coverage, 18852,
     /* 1546548 */     GIR_EraseRootFromParent_Done,
     /* 1546549 */   // Label 21479: @1546549
     /* 1546549 */   GIM_Try, /*On fail goto*//*Label 21480*/ GIMT_Encode4(1546631), // Rule ID 18853 //
     /* 1546554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1546574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546593 */     // MIs[0] round
     /* 1546593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546596 */     // MIs[0] policy
     /* 1546596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546606 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1546609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546630 */     // GIR_Coverage, 18853,
     /* 1546630 */     GIR_EraseRootFromParent_Done,
     /* 1546631 */   // Label 21480: @1546631
     /* 1546631 */   GIM_Try, /*On fail goto*//*Label 21481*/ GIMT_Encode4(1546713), // Rule ID 18856 //
     /* 1546636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1546647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1546650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1546656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546675 */     // MIs[0] round
     /* 1546675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546678 */     // MIs[0] policy
     /* 1546678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546688 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1546691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546712 */     // GIR_Coverage, 18856,
     /* 1546712 */     GIR_EraseRootFromParent_Done,
     /* 1546713 */   // Label 21481: @1546713
     /* 1546713 */   GIM_Try, /*On fail goto*//*Label 21482*/ GIMT_Encode4(1546795), // Rule ID 18857 //
     /* 1546718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1546729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1546732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1546738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546757 */     // MIs[0] round
     /* 1546757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546760 */     // MIs[0] policy
     /* 1546760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546770 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1546773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546794 */     // GIR_Coverage, 18857,
     /* 1546794 */     GIR_EraseRootFromParent_Done,
     /* 1546795 */   // Label 21482: @1546795
     /* 1546795 */   GIM_Try, /*On fail goto*//*Label 21483*/ GIMT_Encode4(1546877), // Rule ID 18860 //
     /* 1546800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1546811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1546814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1546820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546839 */     // MIs[0] round
     /* 1546839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546842 */     // MIs[0] policy
     /* 1546842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546852 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1546855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546876 */     // GIR_Coverage, 18860,
     /* 1546876 */     GIR_EraseRootFromParent_Done,
     /* 1546877 */   // Label 21483: @1546877
     /* 1546877 */   GIM_Try, /*On fail goto*//*Label 21484*/ GIMT_Encode4(1546959), // Rule ID 18861 //
     /* 1546882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1546893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1546896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1546902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546921 */     // MIs[0] round
     /* 1546921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546924 */     // MIs[0] policy
     /* 1546924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546934 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1546937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546958 */     // GIR_Coverage, 18861,
     /* 1546958 */     GIR_EraseRootFromParent_Done,
     /* 1546959 */   // Label 21484: @1546959
     /* 1546959 */   GIM_Try, /*On fail goto*//*Label 21485*/ GIMT_Encode4(1547041), // Rule ID 18864 //
     /* 1546964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1546975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1546978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1546984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547003 */     // MIs[0] round
     /* 1547003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547006 */     // MIs[0] policy
     /* 1547006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547016 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1547019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547040 */     // GIR_Coverage, 18864,
     /* 1547040 */     GIR_EraseRootFromParent_Done,
     /* 1547041 */   // Label 21485: @1547041
     /* 1547041 */   GIM_Try, /*On fail goto*//*Label 21486*/ GIMT_Encode4(1547123), // Rule ID 18865 //
     /* 1547046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1547054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1547057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1547060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1547063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1547066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547085 */     // MIs[0] round
     /* 1547085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547088 */     // MIs[0] policy
     /* 1547088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547098 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1547101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547122 */     // GIR_Coverage, 18865,
     /* 1547122 */     GIR_EraseRootFromParent_Done,
     /* 1547123 */   // Label 21486: @1547123
     /* 1547123 */   GIM_Try, /*On fail goto*//*Label 21487*/ GIMT_Encode4(1547205), // Rule ID 18868 //
     /* 1547128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1547139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1547142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1547145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1547148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547167 */     // MIs[0] round
     /* 1547167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547170 */     // MIs[0] policy
     /* 1547170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547180 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1547183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547204 */     // GIR_Coverage, 18868,
     /* 1547204 */     GIR_EraseRootFromParent_Done,
     /* 1547205 */   // Label 21487: @1547205
     /* 1547205 */   GIM_Try, /*On fail goto*//*Label 21488*/ GIMT_Encode4(1547287), // Rule ID 18869 //
     /* 1547210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1547221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1547224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1547227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1547230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547249 */     // MIs[0] round
     /* 1547249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547252 */     // MIs[0] policy
     /* 1547252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547262 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1547265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547286 */     // GIR_Coverage, 18869,
     /* 1547286 */     GIR_EraseRootFromParent_Done,
     /* 1547287 */   // Label 21488: @1547287
     /* 1547287 */   GIM_Try, /*On fail goto*//*Label 21489*/ GIMT_Encode4(1547369), // Rule ID 18872 //
     /* 1547292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1547303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1547306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1547309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1547312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547331 */     // MIs[0] round
     /* 1547331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547334 */     // MIs[0] policy
     /* 1547334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547344 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1547347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547368 */     // GIR_Coverage, 18872,
     /* 1547368 */     GIR_EraseRootFromParent_Done,
     /* 1547369 */   // Label 21489: @1547369
     /* 1547369 */   GIM_Try, /*On fail goto*//*Label 21490*/ GIMT_Encode4(1547451), // Rule ID 18873 //
     /* 1547374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1547385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1547388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1547391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1547394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547413 */     // MIs[0] round
     /* 1547413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547416 */     // MIs[0] policy
     /* 1547416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547426 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1547429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547450 */     // GIR_Coverage, 18873,
     /* 1547450 */     GIR_EraseRootFromParent_Done,
     /* 1547451 */   // Label 21490: @1547451
     /* 1547451 */   GIM_Try, /*On fail goto*//*Label 21491*/ GIMT_Encode4(1547533), // Rule ID 18876 //
     /* 1547456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1547473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1547476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547495 */     // MIs[0] round
     /* 1547495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547498 */     // MIs[0] policy
     /* 1547498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547508 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1547511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547532 */     // GIR_Coverage, 18876,
     /* 1547532 */     GIR_EraseRootFromParent_Done,
     /* 1547533 */   // Label 21491: @1547533
     /* 1547533 */   GIM_Try, /*On fail goto*//*Label 21492*/ GIMT_Encode4(1547615), // Rule ID 18877 //
     /* 1547538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1547555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1547558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547577 */     // MIs[0] round
     /* 1547577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547580 */     // MIs[0] policy
     /* 1547580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547590 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1547593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547614 */     // GIR_Coverage, 18877,
     /* 1547614 */     GIR_EraseRootFromParent_Done,
     /* 1547615 */   // Label 21492: @1547615
     /* 1547615 */   GIM_Try, /*On fail goto*//*Label 21493*/ GIMT_Encode4(1547697), // Rule ID 18880 //
     /* 1547620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1547631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1547634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1547637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1547640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547659 */     // MIs[0] round
     /* 1547659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547662 */     // MIs[0] policy
     /* 1547662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547672 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1547675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547696 */     // GIR_Coverage, 18880,
     /* 1547696 */     GIR_EraseRootFromParent_Done,
     /* 1547697 */   // Label 21493: @1547697
     /* 1547697 */   GIM_Try, /*On fail goto*//*Label 21494*/ GIMT_Encode4(1547779), // Rule ID 18881 //
     /* 1547702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1547713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1547716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1547719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1547722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547741 */     // MIs[0] round
     /* 1547741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547744 */     // MIs[0] policy
     /* 1547744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547754 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1547757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547778 */     // GIR_Coverage, 18881,
     /* 1547778 */     GIR_EraseRootFromParent_Done,
     /* 1547779 */   // Label 21494: @1547779
     /* 1547779 */   GIM_Try, /*On fail goto*//*Label 21495*/ GIMT_Encode4(1547861), // Rule ID 18884 //
     /* 1547784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1547795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1547798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1547801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1547804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547823 */     // MIs[0] round
     /* 1547823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547826 */     // MIs[0] policy
     /* 1547826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547836 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1547839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547860 */     // GIR_Coverage, 18884,
     /* 1547860 */     GIR_EraseRootFromParent_Done,
     /* 1547861 */   // Label 21495: @1547861
     /* 1547861 */   GIM_Try, /*On fail goto*//*Label 21496*/ GIMT_Encode4(1547943), // Rule ID 18885 //
     /* 1547866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1547877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1547880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1547883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1547886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547905 */     // MIs[0] round
     /* 1547905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547908 */     // MIs[0] policy
     /* 1547908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547918 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1547921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547942 */     // GIR_Coverage, 18885,
     /* 1547942 */     GIR_EraseRootFromParent_Done,
     /* 1547943 */   // Label 21496: @1547943
     /* 1547943 */   GIM_Try, /*On fail goto*//*Label 21497*/ GIMT_Encode4(1548025), // Rule ID 18888 //
     /* 1547948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1547959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1547962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1547965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1547968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547987 */     // MIs[0] round
     /* 1547987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547990 */     // MIs[0] policy
     /* 1547990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548000 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1548003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548024 */     // GIR_Coverage, 18888,
     /* 1548024 */     GIR_EraseRootFromParent_Done,
     /* 1548025 */   // Label 21497: @1548025
     /* 1548025 */   GIM_Try, /*On fail goto*//*Label 21498*/ GIMT_Encode4(1548107), // Rule ID 18889 //
     /* 1548030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1548041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1548044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1548047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1548050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548069 */     // MIs[0] round
     /* 1548069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548072 */     // MIs[0] policy
     /* 1548072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548082 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1548085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548106 */     // GIR_Coverage, 18889,
     /* 1548106 */     GIR_EraseRootFromParent_Done,
     /* 1548107 */   // Label 21498: @1548107
     /* 1548107 */   GIM_Try, /*On fail goto*//*Label 21499*/ GIMT_Encode4(1548189), // Rule ID 18892 //
     /* 1548112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1548123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1548126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1548129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1548132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548151 */     // MIs[0] round
     /* 1548151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548154 */     // MIs[0] policy
     /* 1548154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548164 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1548167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548188 */     // GIR_Coverage, 18892,
     /* 1548188 */     GIR_EraseRootFromParent_Done,
     /* 1548189 */   // Label 21499: @1548189
     /* 1548189 */   GIM_Try, /*On fail goto*//*Label 21500*/ GIMT_Encode4(1548271), // Rule ID 18893 //
     /* 1548194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1548205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1548208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1548211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1548214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548233 */     // MIs[0] round
     /* 1548233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548236 */     // MIs[0] policy
     /* 1548236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548246 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1548249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548270 */     // GIR_Coverage, 18893,
     /* 1548270 */     GIR_EraseRootFromParent_Done,
     /* 1548271 */   // Label 21500: @1548271
     /* 1548271 */   GIM_Try, /*On fail goto*//*Label 21501*/ GIMT_Encode4(1548353), // Rule ID 18896 //
     /* 1548276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1548287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1548290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1548293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1548296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548315 */     // MIs[0] round
     /* 1548315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548318 */     // MIs[0] policy
     /* 1548318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548328 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1548331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548352 */     // GIR_Coverage, 18896,
     /* 1548352 */     GIR_EraseRootFromParent_Done,
     /* 1548353 */   // Label 21501: @1548353
     /* 1548353 */   GIM_Try, /*On fail goto*//*Label 21502*/ GIMT_Encode4(1548435), // Rule ID 18897 //
     /* 1548358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1548369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1548372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1548375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1548378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548397 */     // MIs[0] round
     /* 1548397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548400 */     // MIs[0] policy
     /* 1548400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548410 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1548413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548434 */     // GIR_Coverage, 18897,
     /* 1548434 */     GIR_EraseRootFromParent_Done,
     /* 1548435 */   // Label 21502: @1548435
     /* 1548435 */   GIM_Try, /*On fail goto*//*Label 21503*/ GIMT_Encode4(1548517), // Rule ID 18900 //
     /* 1548440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1548451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1548454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1548457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1548460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548479 */     // MIs[0] round
     /* 1548479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548482 */     // MIs[0] policy
     /* 1548482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548492 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1548495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548516 */     // GIR_Coverage, 18900,
     /* 1548516 */     GIR_EraseRootFromParent_Done,
     /* 1548517 */   // Label 21503: @1548517
     /* 1548517 */   GIM_Try, /*On fail goto*//*Label 21504*/ GIMT_Encode4(1548599), // Rule ID 18901 //
     /* 1548522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1548533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1548536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1548539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1548542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548561 */     // MIs[0] round
     /* 1548561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548564 */     // MIs[0] policy
     /* 1548564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548574 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1548577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548598 */     // GIR_Coverage, 18901,
     /* 1548598 */     GIR_EraseRootFromParent_Done,
     /* 1548599 */   // Label 21504: @1548599
     /* 1548599 */   GIM_Try, /*On fail goto*//*Label 21505*/ GIMT_Encode4(1548681), // Rule ID 18904 //
     /* 1548604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1548624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548643 */     // MIs[0] round
     /* 1548643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548646 */     // MIs[0] policy
     /* 1548646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548656 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1548659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548680 */     // GIR_Coverage, 18904,
     /* 1548680 */     GIR_EraseRootFromParent_Done,
     /* 1548681 */   // Label 21505: @1548681
     /* 1548681 */   GIM_Try, /*On fail goto*//*Label 21506*/ GIMT_Encode4(1548763), // Rule ID 18905 //
     /* 1548686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1548706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548725 */     // MIs[0] round
     /* 1548725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548728 */     // MIs[0] policy
     /* 1548728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548738 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1548741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548762 */     // GIR_Coverage, 18905,
     /* 1548762 */     GIR_EraseRootFromParent_Done,
     /* 1548763 */   // Label 21506: @1548763
     /* 1548763 */   GIM_Try, /*On fail goto*//*Label 21507*/ GIMT_Encode4(1548845), // Rule ID 18908 //
     /* 1548768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1548779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1548782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1548788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548807 */     // MIs[0] round
     /* 1548807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548810 */     // MIs[0] policy
     /* 1548810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548820 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1548823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548844 */     // GIR_Coverage, 18908,
     /* 1548844 */     GIR_EraseRootFromParent_Done,
     /* 1548845 */   // Label 21507: @1548845
     /* 1548845 */   GIM_Try, /*On fail goto*//*Label 21508*/ GIMT_Encode4(1548927), // Rule ID 18909 //
     /* 1548850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1548861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1548864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1548870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548889 */     // MIs[0] round
     /* 1548889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548892 */     // MIs[0] policy
     /* 1548892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548902 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1548905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548926 */     // GIR_Coverage, 18909,
     /* 1548926 */     GIR_EraseRootFromParent_Done,
     /* 1548927 */   // Label 21508: @1548927
     /* 1548927 */   GIM_Try, /*On fail goto*//*Label 21509*/ GIMT_Encode4(1549009), // Rule ID 18912 //
     /* 1548932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1548943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1548946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1548952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548971 */     // MIs[0] round
     /* 1548971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548974 */     // MIs[0] policy
     /* 1548974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548984 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1548987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549008 */     // GIR_Coverage, 18912,
     /* 1549008 */     GIR_EraseRootFromParent_Done,
     /* 1549009 */   // Label 21509: @1549009
     /* 1549009 */   GIM_Try, /*On fail goto*//*Label 21510*/ GIMT_Encode4(1549091), // Rule ID 18913 //
     /* 1549014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1549025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1549028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1549034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549053 */     // MIs[0] round
     /* 1549053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549056 */     // MIs[0] policy
     /* 1549056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549066 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1549069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549090 */     // GIR_Coverage, 18913,
     /* 1549090 */     GIR_EraseRootFromParent_Done,
     /* 1549091 */   // Label 21510: @1549091
     /* 1549091 */   GIM_Try, /*On fail goto*//*Label 21511*/ GIMT_Encode4(1549173), // Rule ID 18916 //
     /* 1549096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1549107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1549110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1549116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549135 */     // MIs[0] round
     /* 1549135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549138 */     // MIs[0] policy
     /* 1549138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549148 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1549151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549172 */     // GIR_Coverage, 18916,
     /* 1549172 */     GIR_EraseRootFromParent_Done,
     /* 1549173 */   // Label 21511: @1549173
     /* 1549173 */   GIM_Try, /*On fail goto*//*Label 21512*/ GIMT_Encode4(1549255), // Rule ID 18917 //
     /* 1549178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1549189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1549192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1549198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549217 */     // MIs[0] round
     /* 1549217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549220 */     // MIs[0] policy
     /* 1549220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549230 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1549233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549254 */     // GIR_Coverage, 18917,
     /* 1549254 */     GIR_EraseRootFromParent_Done,
     /* 1549255 */   // Label 21512: @1549255
     /* 1549255 */   GIM_Try, /*On fail goto*//*Label 21513*/ GIMT_Encode4(1549337), // Rule ID 18920 //
     /* 1549260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1549271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1549274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1549280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549299 */     // MIs[0] round
     /* 1549299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549302 */     // MIs[0] policy
     /* 1549302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549312 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1549315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549336 */     // GIR_Coverage, 18920,
     /* 1549336 */     GIR_EraseRootFromParent_Done,
     /* 1549337 */   // Label 21513: @1549337
     /* 1549337 */   GIM_Try, /*On fail goto*//*Label 21514*/ GIMT_Encode4(1549419), // Rule ID 18921 //
     /* 1549342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1549353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1549356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1549362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549381 */     // MIs[0] round
     /* 1549381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549384 */     // MIs[0] policy
     /* 1549384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549394 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1549397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549418 */     // GIR_Coverage, 18921,
     /* 1549418 */     GIR_EraseRootFromParent_Done,
     /* 1549419 */   // Label 21514: @1549419
     /* 1549419 */   GIM_Try, /*On fail goto*//*Label 21515*/ GIMT_Encode4(1549501), // Rule ID 18924 //
     /* 1549424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1549444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549463 */     // MIs[0] round
     /* 1549463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549466 */     // MIs[0] policy
     /* 1549466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549476 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1549479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549500 */     // GIR_Coverage, 18924,
     /* 1549500 */     GIR_EraseRootFromParent_Done,
     /* 1549501 */   // Label 21515: @1549501
     /* 1549501 */   GIM_Try, /*On fail goto*//*Label 21516*/ GIMT_Encode4(1549583), // Rule ID 18925 //
     /* 1549506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1549526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549545 */     // MIs[0] round
     /* 1549545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549548 */     // MIs[0] policy
     /* 1549548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549558 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1549561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549582 */     // GIR_Coverage, 18925,
     /* 1549582 */     GIR_EraseRootFromParent_Done,
     /* 1549583 */   // Label 21516: @1549583
     /* 1549583 */   GIM_Try, /*On fail goto*//*Label 21517*/ GIMT_Encode4(1549665), // Rule ID 18928 //
     /* 1549588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1549599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1549602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1549608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549627 */     // MIs[0] round
     /* 1549627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549630 */     // MIs[0] policy
     /* 1549630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549640 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1549643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549664 */     // GIR_Coverage, 18928,
     /* 1549664 */     GIR_EraseRootFromParent_Done,
     /* 1549665 */   // Label 21517: @1549665
     /* 1549665 */   GIM_Try, /*On fail goto*//*Label 21518*/ GIMT_Encode4(1549747), // Rule ID 18929 //
     /* 1549670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1549681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1549684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1549690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549709 */     // MIs[0] round
     /* 1549709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549712 */     // MIs[0] policy
     /* 1549712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549722 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1549725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549746 */     // GIR_Coverage, 18929,
     /* 1549746 */     GIR_EraseRootFromParent_Done,
     /* 1549747 */   // Label 21518: @1549747
     /* 1549747 */   GIM_Try, /*On fail goto*//*Label 21519*/ GIMT_Encode4(1549829), // Rule ID 18932 //
     /* 1549752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1549763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1549766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1549772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549791 */     // MIs[0] round
     /* 1549791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549794 */     // MIs[0] policy
     /* 1549794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549804 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1549807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549828 */     // GIR_Coverage, 18932,
     /* 1549828 */     GIR_EraseRootFromParent_Done,
     /* 1549829 */   // Label 21519: @1549829
     /* 1549829 */   GIM_Try, /*On fail goto*//*Label 21520*/ GIMT_Encode4(1549911), // Rule ID 18933 //
     /* 1549834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1549845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1549848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1549854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549873 */     // MIs[0] round
     /* 1549873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549876 */     // MIs[0] policy
     /* 1549876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549886 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1549889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549910 */     // GIR_Coverage, 18933,
     /* 1549910 */     GIR_EraseRootFromParent_Done,
     /* 1549911 */   // Label 21520: @1549911
     /* 1549911 */   GIM_Try, /*On fail goto*//*Label 21521*/ GIMT_Encode4(1549993), // Rule ID 18936 //
     /* 1549916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1549927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1549930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1549936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549955 */     // MIs[0] round
     /* 1549955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549958 */     // MIs[0] policy
     /* 1549958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549968 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1549971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549992 */     // GIR_Coverage, 18936,
     /* 1549992 */     GIR_EraseRootFromParent_Done,
     /* 1549993 */   // Label 21521: @1549993
     /* 1549993 */   GIM_Try, /*On fail goto*//*Label 21522*/ GIMT_Encode4(1550075), // Rule ID 18937 //
     /* 1549998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1550006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1550009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1550012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1550015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1550018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1550033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550037 */     // MIs[0] round
     /* 1550037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550040 */     // MIs[0] policy
     /* 1550040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550050 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1550053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550074 */     // GIR_Coverage, 18937,
     /* 1550074 */     GIR_EraseRootFromParent_Done,
     /* 1550075 */   // Label 21522: @1550075
     /* 1550075 */   GIM_Try, /*On fail goto*//*Label 21523*/ GIMT_Encode4(1550157), // Rule ID 18940 //
     /* 1550080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1550091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1550094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1550097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1550100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550119 */     // MIs[0] round
     /* 1550119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550122 */     // MIs[0] policy
     /* 1550122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550132 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1550135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550156 */     // GIR_Coverage, 18940,
     /* 1550156 */     GIR_EraseRootFromParent_Done,
     /* 1550157 */   // Label 21523: @1550157
     /* 1550157 */   GIM_Try, /*On fail goto*//*Label 21524*/ GIMT_Encode4(1550239), // Rule ID 18941 //
     /* 1550162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1550173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1550176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1550179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1550182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550201 */     // MIs[0] round
     /* 1550201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550204 */     // MIs[0] policy
     /* 1550204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550214 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1550217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550238 */     // GIR_Coverage, 18941,
     /* 1550238 */     GIR_EraseRootFromParent_Done,
     /* 1550239 */   // Label 21524: @1550239
     /* 1550239 */   GIM_Try, /*On fail goto*//*Label 21525*/ GIMT_Encode4(1550321), // Rule ID 18944 //
     /* 1550244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1550255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1550258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1550261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1550264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550283 */     // MIs[0] round
     /* 1550283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550286 */     // MIs[0] policy
     /* 1550286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550296 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1550299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550320 */     // GIR_Coverage, 18944,
     /* 1550320 */     GIR_EraseRootFromParent_Done,
     /* 1550321 */   // Label 21525: @1550321
     /* 1550321 */   GIM_Try, /*On fail goto*//*Label 21526*/ GIMT_Encode4(1550403), // Rule ID 18945 //
     /* 1550326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1550337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1550340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1550343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1550346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550365 */     // MIs[0] round
     /* 1550365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550368 */     // MIs[0] policy
     /* 1550368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550378 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1550381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550402 */     // GIR_Coverage, 18945,
     /* 1550402 */     GIR_EraseRootFromParent_Done,
     /* 1550403 */   // Label 21526: @1550403
     /* 1550403 */   GIM_Try, /*On fail goto*//*Label 21527*/ GIMT_Encode4(1550485), // Rule ID 18948 //
     /* 1550408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1550419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1550422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1550425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1550428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550447 */     // MIs[0] round
     /* 1550447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550450 */     // MIs[0] policy
     /* 1550450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550460 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1550463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550484 */     // GIR_Coverage, 18948,
     /* 1550484 */     GIR_EraseRootFromParent_Done,
     /* 1550485 */   // Label 21527: @1550485
     /* 1550485 */   GIM_Try, /*On fail goto*//*Label 21528*/ GIMT_Encode4(1550567), // Rule ID 18949 //
     /* 1550490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1550501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1550504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1550507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1550510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550529 */     // MIs[0] round
     /* 1550529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550532 */     // MIs[0] policy
     /* 1550532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550542 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1550545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550566 */     // GIR_Coverage, 18949,
     /* 1550566 */     GIR_EraseRootFromParent_Done,
     /* 1550567 */   // Label 21528: @1550567
     /* 1550567 */   GIM_Try, /*On fail goto*//*Label 21529*/ GIMT_Encode4(1550649), // Rule ID 18952 //
     /* 1550572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1550583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1550586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1550589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1550592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550611 */     // MIs[0] round
     /* 1550611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550614 */     // MIs[0] policy
     /* 1550614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550624 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1550627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550648 */     // GIR_Coverage, 18952,
     /* 1550648 */     GIR_EraseRootFromParent_Done,
     /* 1550649 */   // Label 21529: @1550649
     /* 1550649 */   GIM_Try, /*On fail goto*//*Label 21530*/ GIMT_Encode4(1550731), // Rule ID 18953 //
     /* 1550654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1550665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1550668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1550671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1550674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550693 */     // MIs[0] round
     /* 1550693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550696 */     // MIs[0] policy
     /* 1550696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550706 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1550709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550730 */     // GIR_Coverage, 18953,
     /* 1550730 */     GIR_EraseRootFromParent_Done,
     /* 1550731 */   // Label 21530: @1550731
     /* 1550731 */   GIM_Try, /*On fail goto*//*Label 21531*/ GIMT_Encode4(1550813), // Rule ID 18956 //
     /* 1550736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1550747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1550750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1550753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1550756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550775 */     // MIs[0] round
     /* 1550775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550778 */     // MIs[0] policy
     /* 1550778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550788 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1550791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550812 */     // GIR_Coverage, 18956,
     /* 1550812 */     GIR_EraseRootFromParent_Done,
     /* 1550813 */   // Label 21531: @1550813
     /* 1550813 */   GIM_Try, /*On fail goto*//*Label 21532*/ GIMT_Encode4(1550895), // Rule ID 18957 //
     /* 1550818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1550829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1550832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1550835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1550838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550857 */     // MIs[0] round
     /* 1550857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550860 */     // MIs[0] policy
     /* 1550860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550870 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1550873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550894 */     // GIR_Coverage, 18957,
     /* 1550894 */     GIR_EraseRootFromParent_Done,
     /* 1550895 */   // Label 21532: @1550895
     /* 1550895 */   GIM_Try, /*On fail goto*//*Label 21533*/ GIMT_Encode4(1550977), // Rule ID 18960 //
     /* 1550900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1550911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1550914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1550917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1550920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550939 */     // MIs[0] round
     /* 1550939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550942 */     // MIs[0] policy
     /* 1550942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550952 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1550955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550976 */     // GIR_Coverage, 18960,
     /* 1550976 */     GIR_EraseRootFromParent_Done,
     /* 1550977 */   // Label 21533: @1550977
     /* 1550977 */   GIM_Try, /*On fail goto*//*Label 21534*/ GIMT_Encode4(1551059), // Rule ID 18961 //
     /* 1550982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1550993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1550996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1550999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1551002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551021 */     // MIs[0] round
     /* 1551021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551024 */     // MIs[0] policy
     /* 1551024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551034 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1551037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551058 */     // GIR_Coverage, 18961,
     /* 1551058 */     GIR_EraseRootFromParent_Done,
     /* 1551059 */   // Label 21534: @1551059
     /* 1551059 */   GIM_Try, /*On fail goto*//*Label 21535*/ GIMT_Encode4(1551141), // Rule ID 18964 //
     /* 1551064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1551067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1551075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1551078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1551081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1551084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551103 */     // MIs[0] round
     /* 1551103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551106 */     // MIs[0] policy
     /* 1551106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551116 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1551119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551140 */     // GIR_Coverage, 18964,
     /* 1551140 */     GIR_EraseRootFromParent_Done,
     /* 1551141 */   // Label 21535: @1551141
     /* 1551141 */   GIM_Try, /*On fail goto*//*Label 21536*/ GIMT_Encode4(1551223), // Rule ID 18965 //
     /* 1551146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1551157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1551160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1551163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1551166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551185 */     // MIs[0] round
     /* 1551185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551188 */     // MIs[0] policy
     /* 1551188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551198 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1551201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551222 */     // GIR_Coverage, 18965,
     /* 1551222 */     GIR_EraseRootFromParent_Done,
     /* 1551223 */   // Label 21536: @1551223
     /* 1551223 */   GIM_Try, /*On fail goto*//*Label 21537*/ GIMT_Encode4(1551305), // Rule ID 18968 //
     /* 1551228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1551231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1551239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1551242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1551245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1551248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551267 */     // MIs[0] round
     /* 1551267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551270 */     // MIs[0] policy
     /* 1551270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551280 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1551283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551304 */     // GIR_Coverage, 18968,
     /* 1551304 */     GIR_EraseRootFromParent_Done,
     /* 1551305 */   // Label 21537: @1551305
     /* 1551305 */   GIM_Try, /*On fail goto*//*Label 21538*/ GIMT_Encode4(1551387), // Rule ID 18969 //
     /* 1551310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1551321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1551324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1551327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1551330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551349 */     // MIs[0] round
     /* 1551349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551352 */     // MIs[0] policy
     /* 1551352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551362 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1551365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551386 */     // GIR_Coverage, 18969,
     /* 1551386 */     GIR_EraseRootFromParent_Done,
     /* 1551387 */   // Label 21538: @1551387
     /* 1551387 */   GIM_Try, /*On fail goto*//*Label 21539*/ GIMT_Encode4(1551469), // Rule ID 18972 //
     /* 1551392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1551395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1551403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1551406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1551409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1551412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551431 */     // MIs[0] round
     /* 1551431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551434 */     // MIs[0] policy
     /* 1551434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551444 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1551447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551468 */     // GIR_Coverage, 18972,
     /* 1551468 */     GIR_EraseRootFromParent_Done,
     /* 1551469 */   // Label 21539: @1551469
     /* 1551469 */   GIM_Try, /*On fail goto*//*Label 21540*/ GIMT_Encode4(1551551), // Rule ID 18973 //
     /* 1551474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1551485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1551488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1551491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1551494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551513 */     // MIs[0] round
     /* 1551513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551516 */     // MIs[0] policy
     /* 1551516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551526 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1551529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551550 */     // GIR_Coverage, 18973,
     /* 1551550 */     GIR_EraseRootFromParent_Done,
     /* 1551551 */   // Label 21540: @1551551
     /* 1551551 */   GIM_Try, /*On fail goto*//*Label 21541*/ GIMT_Encode4(1551633), // Rule ID 18976 //
     /* 1551556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1551567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1551570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1551576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551595 */     // MIs[0] round
     /* 1551595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551598 */     // MIs[0] policy
     /* 1551598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1551611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551632 */     // GIR_Coverage, 18976,
     /* 1551632 */     GIR_EraseRootFromParent_Done,
     /* 1551633 */   // Label 21541: @1551633
     /* 1551633 */   GIM_Try, /*On fail goto*//*Label 21542*/ GIMT_Encode4(1551715), // Rule ID 18977 //
     /* 1551638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1551649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1551652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1551658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551677 */     // MIs[0] round
     /* 1551677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551680 */     // MIs[0] policy
     /* 1551680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551690 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1551693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551714 */     // GIR_Coverage, 18977,
     /* 1551714 */     GIR_EraseRootFromParent_Done,
     /* 1551715 */   // Label 21542: @1551715
     /* 1551715 */   GIM_Try, /*On fail goto*//*Label 21543*/ GIMT_Encode4(1551797), // Rule ID 18980 //
     /* 1551720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1551731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1551734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1551740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551759 */     // MIs[0] round
     /* 1551759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551762 */     // MIs[0] policy
     /* 1551762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551772 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1551775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551796 */     // GIR_Coverage, 18980,
     /* 1551796 */     GIR_EraseRootFromParent_Done,
     /* 1551797 */   // Label 21543: @1551797
     /* 1551797 */   GIM_Try, /*On fail goto*//*Label 21544*/ GIMT_Encode4(1551879), // Rule ID 18981 //
     /* 1551802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1551813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1551816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1551822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551841 */     // MIs[0] round
     /* 1551841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551844 */     // MIs[0] policy
     /* 1551844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551854 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1551857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551878 */     // GIR_Coverage, 18981,
     /* 1551878 */     GIR_EraseRootFromParent_Done,
     /* 1551879 */   // Label 21544: @1551879
     /* 1551879 */   GIM_Try, /*On fail goto*//*Label 21545*/ GIMT_Encode4(1551961), // Rule ID 18984 //
     /* 1551884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1551895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1551898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1551904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551923 */     // MIs[0] round
     /* 1551923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551926 */     // MIs[0] policy
     /* 1551926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551936 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1551939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551960 */     // GIR_Coverage, 18984,
     /* 1551960 */     GIR_EraseRootFromParent_Done,
     /* 1551961 */   // Label 21545: @1551961
     /* 1551961 */   GIM_Try, /*On fail goto*//*Label 21546*/ GIMT_Encode4(1552043), // Rule ID 18985 //
     /* 1551966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1551977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1551980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1551986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552005 */     // MIs[0] round
     /* 1552005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552008 */     // MIs[0] policy
     /* 1552008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552018 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1552021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552042 */     // GIR_Coverage, 18985,
     /* 1552042 */     GIR_EraseRootFromParent_Done,
     /* 1552043 */   // Label 21546: @1552043
     /* 1552043 */   GIM_Try, /*On fail goto*//*Label 21547*/ GIMT_Encode4(1552125), // Rule ID 18988 //
     /* 1552048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1552051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1552059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1552062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1552068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552087 */     // MIs[0] round
     /* 1552087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552090 */     // MIs[0] policy
     /* 1552090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552100 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1552103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552124 */     // GIR_Coverage, 18988,
     /* 1552124 */     GIR_EraseRootFromParent_Done,
     /* 1552125 */   // Label 21547: @1552125
     /* 1552125 */   GIM_Try, /*On fail goto*//*Label 21548*/ GIMT_Encode4(1552207), // Rule ID 18989 //
     /* 1552130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1552133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1552141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1552144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1552150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552169 */     // MIs[0] round
     /* 1552169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552172 */     // MIs[0] policy
     /* 1552172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552182 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1552185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552206 */     // GIR_Coverage, 18989,
     /* 1552206 */     GIR_EraseRootFromParent_Done,
     /* 1552207 */   // Label 21548: @1552207
     /* 1552207 */   GIM_Try, /*On fail goto*//*Label 21549*/ GIMT_Encode4(1552289), // Rule ID 18992 //
     /* 1552212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1552215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1552223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1552226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1552232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552251 */     // MIs[0] round
     /* 1552251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552254 */     // MIs[0] policy
     /* 1552254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552264 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1552267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552288 */     // GIR_Coverage, 18992,
     /* 1552288 */     GIR_EraseRootFromParent_Done,
     /* 1552289 */   // Label 21549: @1552289
     /* 1552289 */   GIM_Try, /*On fail goto*//*Label 21550*/ GIMT_Encode4(1552371), // Rule ID 18993 //
     /* 1552294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1552297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1552305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1552308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1552314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552333 */     // MIs[0] round
     /* 1552333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552336 */     // MIs[0] policy
     /* 1552336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552346 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1552349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552370 */     // GIR_Coverage, 18993,
     /* 1552370 */     GIR_EraseRootFromParent_Done,
     /* 1552371 */   // Label 21550: @1552371
     /* 1552371 */   GIM_Try, /*On fail goto*//*Label 21551*/ GIMT_Encode4(1552453), // Rule ID 18996 //
     /* 1552376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1552387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1552390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1552396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552415 */     // MIs[0] round
     /* 1552415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552418 */     // MIs[0] policy
     /* 1552418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552428 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1552431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552452 */     // GIR_Coverage, 18996,
     /* 1552452 */     GIR_EraseRootFromParent_Done,
     /* 1552453 */   // Label 21551: @1552453
     /* 1552453 */   GIM_Try, /*On fail goto*//*Label 21552*/ GIMT_Encode4(1552535), // Rule ID 18997 //
     /* 1552458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1552469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1552472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1552478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552497 */     // MIs[0] round
     /* 1552497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552500 */     // MIs[0] policy
     /* 1552500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552510 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1552513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552534 */     // GIR_Coverage, 18997,
     /* 1552534 */     GIR_EraseRootFromParent_Done,
     /* 1552535 */   // Label 21552: @1552535
     /* 1552535 */   GIM_Try, /*On fail goto*//*Label 21553*/ GIMT_Encode4(1552617), // Rule ID 19000 //
     /* 1552540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1552560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552579 */     // MIs[0] round
     /* 1552579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552582 */     // MIs[0] policy
     /* 1552582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552592 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1552595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552616 */     // GIR_Coverage, 19000,
     /* 1552616 */     GIR_EraseRootFromParent_Done,
     /* 1552617 */   // Label 21553: @1552617
     /* 1552617 */   GIM_Try, /*On fail goto*//*Label 21554*/ GIMT_Encode4(1552699), // Rule ID 19001 //
     /* 1552622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1552642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552661 */     // MIs[0] round
     /* 1552661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552664 */     // MIs[0] policy
     /* 1552664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552674 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1552677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552698 */     // GIR_Coverage, 19001,
     /* 1552698 */     GIR_EraseRootFromParent_Done,
     /* 1552699 */   // Label 21554: @1552699
     /* 1552699 */   GIM_Try, /*On fail goto*//*Label 21555*/ GIMT_Encode4(1552781), // Rule ID 19004 //
     /* 1552704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1552724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552743 */     // MIs[0] round
     /* 1552743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552746 */     // MIs[0] policy
     /* 1552746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552756 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1552759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552780 */     // GIR_Coverage, 19004,
     /* 1552780 */     GIR_EraseRootFromParent_Done,
     /* 1552781 */   // Label 21555: @1552781
     /* 1552781 */   GIM_Try, /*On fail goto*//*Label 21556*/ GIMT_Encode4(1552863), // Rule ID 19005 //
     /* 1552786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1552806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552825 */     // MIs[0] round
     /* 1552825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552828 */     // MIs[0] policy
     /* 1552828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552838 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1552841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552862 */     // GIR_Coverage, 19005,
     /* 1552862 */     GIR_EraseRootFromParent_Done,
     /* 1552863 */   // Label 21556: @1552863
     /* 1552863 */   GIM_Try, /*On fail goto*//*Label 21557*/ GIMT_Encode4(1552945), // Rule ID 19008 //
     /* 1552868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1552888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552907 */     // MIs[0] round
     /* 1552907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552910 */     // MIs[0] policy
     /* 1552910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552920 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1552923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552944 */     // GIR_Coverage, 19008,
     /* 1552944 */     GIR_EraseRootFromParent_Done,
     /* 1552945 */   // Label 21557: @1552945
     /* 1552945 */   GIM_Try, /*On fail goto*//*Label 21558*/ GIMT_Encode4(1553027), // Rule ID 19009 //
     /* 1552950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1552970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552989 */     // MIs[0] round
     /* 1552989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552992 */     // MIs[0] policy
     /* 1552992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553002 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1553005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553026 */     // GIR_Coverage, 19009,
     /* 1553026 */     GIR_EraseRootFromParent_Done,
     /* 1553027 */   // Label 21558: @1553027
     /* 1553027 */   GIM_Try, /*On fail goto*//*Label 21559*/ GIMT_Encode4(1553109), // Rule ID 19014 //
     /* 1553032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1553043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1553046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1553049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553071 */     // MIs[0] round
     /* 1553071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553074 */     // MIs[0] policy
     /* 1553074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553084 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1553087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553108 */     // GIR_Coverage, 19014,
     /* 1553108 */     GIR_EraseRootFromParent_Done,
     /* 1553109 */   // Label 21559: @1553109
     /* 1553109 */   GIM_Try, /*On fail goto*//*Label 21560*/ GIMT_Encode4(1553191), // Rule ID 19015 //
     /* 1553114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1553125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1553128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1553131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553153 */     // MIs[0] round
     /* 1553153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553156 */     // MIs[0] policy
     /* 1553156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553166 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1553169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553190 */     // GIR_Coverage, 19015,
     /* 1553190 */     GIR_EraseRootFromParent_Done,
     /* 1553191 */   // Label 21560: @1553191
     /* 1553191 */   GIM_Try, /*On fail goto*//*Label 21561*/ GIMT_Encode4(1553273), // Rule ID 19018 //
     /* 1553196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1553199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1553207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1553210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1553213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553235 */     // MIs[0] round
     /* 1553235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553238 */     // MIs[0] policy
     /* 1553238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553248 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1553251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553272 */     // GIR_Coverage, 19018,
     /* 1553272 */     GIR_EraseRootFromParent_Done,
     /* 1553273 */   // Label 21561: @1553273
     /* 1553273 */   GIM_Try, /*On fail goto*//*Label 21562*/ GIMT_Encode4(1553355), // Rule ID 19019 //
     /* 1553278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1553281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1553289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1553292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1553295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553317 */     // MIs[0] round
     /* 1553317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553320 */     // MIs[0] policy
     /* 1553320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553330 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1553333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553339 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553354 */     // GIR_Coverage, 19019,
     /* 1553354 */     GIR_EraseRootFromParent_Done,
     /* 1553355 */   // Label 21562: @1553355
     /* 1553355 */   GIM_Try, /*On fail goto*//*Label 21563*/ GIMT_Encode4(1553437), // Rule ID 19022 //
     /* 1553360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1553371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1553374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1553377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553399 */     // MIs[0] round
     /* 1553399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553402 */     // MIs[0] policy
     /* 1553402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553412 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1553415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553436 */     // GIR_Coverage, 19022,
     /* 1553436 */     GIR_EraseRootFromParent_Done,
     /* 1553437 */   // Label 21563: @1553437
     /* 1553437 */   GIM_Try, /*On fail goto*//*Label 21564*/ GIMT_Encode4(1553519), // Rule ID 19023 //
     /* 1553442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1553453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1553456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1553459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553481 */     // MIs[0] round
     /* 1553481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553484 */     // MIs[0] policy
     /* 1553484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553494 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1553497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553518 */     // GIR_Coverage, 19023,
     /* 1553518 */     GIR_EraseRootFromParent_Done,
     /* 1553519 */   // Label 21564: @1553519
     /* 1553519 */   GIM_Try, /*On fail goto*//*Label 21565*/ GIMT_Encode4(1553601), // Rule ID 19026 //
     /* 1553524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1553527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1553541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553563 */     // MIs[0] round
     /* 1553563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553566 */     // MIs[0] policy
     /* 1553566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553576 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1553579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553600 */     // GIR_Coverage, 19026,
     /* 1553600 */     GIR_EraseRootFromParent_Done,
     /* 1553601 */   // Label 21565: @1553601
     /* 1553601 */   GIM_Try, /*On fail goto*//*Label 21566*/ GIMT_Encode4(1553683), // Rule ID 19027 //
     /* 1553606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1553609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1553623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553645 */     // MIs[0] round
     /* 1553645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553648 */     // MIs[0] policy
     /* 1553648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553658 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1553661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553682 */     // GIR_Coverage, 19027,
     /* 1553682 */     GIR_EraseRootFromParent_Done,
     /* 1553683 */   // Label 21566: @1553683
     /* 1553683 */   GIM_Try, /*On fail goto*//*Label 21567*/ GIMT_Encode4(1553765), // Rule ID 19030 //
     /* 1553688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1553691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1553699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1553702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1553705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553727 */     // MIs[0] round
     /* 1553727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553730 */     // MIs[0] policy
     /* 1553730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553740 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1553743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553764 */     // GIR_Coverage, 19030,
     /* 1553764 */     GIR_EraseRootFromParent_Done,
     /* 1553765 */   // Label 21567: @1553765
     /* 1553765 */   GIM_Try, /*On fail goto*//*Label 21568*/ GIMT_Encode4(1553847), // Rule ID 19031 //
     /* 1553770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1553773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1553781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1553784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1553787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553809 */     // MIs[0] round
     /* 1553809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553812 */     // MIs[0] policy
     /* 1553812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553822 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1553825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553846 */     // GIR_Coverage, 19031,
     /* 1553846 */     GIR_EraseRootFromParent_Done,
     /* 1553847 */   // Label 21568: @1553847
     /* 1553847 */   GIM_Try, /*On fail goto*//*Label 21569*/ GIMT_Encode4(1553929), // Rule ID 19034 //
     /* 1553852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1553863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1553866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1553869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1553872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553891 */     // MIs[0] round
     /* 1553891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553894 */     // MIs[0] policy
     /* 1553894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553904 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1553907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553928 */     // GIR_Coverage, 19034,
     /* 1553928 */     GIR_EraseRootFromParent_Done,
     /* 1553929 */   // Label 21569: @1553929
     /* 1553929 */   GIM_Try, /*On fail goto*//*Label 21570*/ GIMT_Encode4(1554011), // Rule ID 19035 //
     /* 1553934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1553945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1553948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1553951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1553954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553973 */     // MIs[0] round
     /* 1553973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553976 */     // MIs[0] policy
     /* 1553976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553986 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1553989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554010 */     // GIR_Coverage, 19035,
     /* 1554010 */     GIR_EraseRootFromParent_Done,
     /* 1554011 */   // Label 21570: @1554011
     /* 1554011 */   GIM_Try, /*On fail goto*//*Label 21571*/ GIMT_Encode4(1554093), // Rule ID 19038 //
     /* 1554016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1554019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1554027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1554030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1554033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554055 */     // MIs[0] round
     /* 1554055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554058 */     // MIs[0] policy
     /* 1554058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554068 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1554071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554092 */     // GIR_Coverage, 19038,
     /* 1554092 */     GIR_EraseRootFromParent_Done,
     /* 1554093 */   // Label 21571: @1554093
     /* 1554093 */   GIM_Try, /*On fail goto*//*Label 21572*/ GIMT_Encode4(1554175), // Rule ID 19039 //
     /* 1554098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1554101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1554109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1554112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1554115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554137 */     // MIs[0] round
     /* 1554137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554140 */     // MIs[0] policy
     /* 1554140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554150 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1554153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554174 */     // GIR_Coverage, 19039,
     /* 1554174 */     GIR_EraseRootFromParent_Done,
     /* 1554175 */   // Label 21572: @1554175
     /* 1554175 */   GIM_Try, /*On fail goto*//*Label 21573*/ GIMT_Encode4(1554257), // Rule ID 19042 //
     /* 1554180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1554183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1554191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1554194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1554197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1554200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554219 */     // MIs[0] round
     /* 1554219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554222 */     // MIs[0] policy
     /* 1554222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554232 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1554235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554256 */     // GIR_Coverage, 19042,
     /* 1554256 */     GIR_EraseRootFromParent_Done,
     /* 1554257 */   // Label 21573: @1554257
     /* 1554257 */   GIM_Try, /*On fail goto*//*Label 21574*/ GIMT_Encode4(1554339), // Rule ID 19043 //
     /* 1554262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1554265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1554273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1554276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1554279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1554282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554301 */     // MIs[0] round
     /* 1554301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554304 */     // MIs[0] policy
     /* 1554304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554314 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1554317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554338 */     // GIR_Coverage, 19043,
     /* 1554338 */     GIR_EraseRootFromParent_Done,
     /* 1554339 */   // Label 21574: @1554339
     /* 1554339 */   GIM_Try, /*On fail goto*//*Label 21575*/ GIMT_Encode4(1554421), // Rule ID 19046 //
     /* 1554344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1554355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1554358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1554361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554383 */     // MIs[0] round
     /* 1554383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554386 */     // MIs[0] policy
     /* 1554386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554396 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1554399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554420 */     // GIR_Coverage, 19046,
     /* 1554420 */     GIR_EraseRootFromParent_Done,
     /* 1554421 */   // Label 21575: @1554421
     /* 1554421 */   GIM_Try, /*On fail goto*//*Label 21576*/ GIMT_Encode4(1554503), // Rule ID 19047 //
     /* 1554426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1554437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1554440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1554443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554465 */     // MIs[0] round
     /* 1554465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554468 */     // MIs[0] policy
     /* 1554468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554478 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1554481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554502 */     // GIR_Coverage, 19047,
     /* 1554502 */     GIR_EraseRootFromParent_Done,
     /* 1554503 */   // Label 21576: @1554503
     /* 1554503 */   GIM_Try, /*On fail goto*//*Label 21577*/ GIMT_Encode4(1554585), // Rule ID 19050 //
     /* 1554508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554547 */     // MIs[0] round
     /* 1554547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554550 */     // MIs[0] policy
     /* 1554550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554560 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1554563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554584 */     // GIR_Coverage, 19050,
     /* 1554584 */     GIR_EraseRootFromParent_Done,
     /* 1554585 */   // Label 21577: @1554585
     /* 1554585 */   GIM_Try, /*On fail goto*//*Label 21578*/ GIMT_Encode4(1554667), // Rule ID 19051 //
     /* 1554590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554629 */     // MIs[0] round
     /* 1554629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554632 */     // MIs[0] policy
     /* 1554632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554642 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1554645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554651 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554666 */     // GIR_Coverage, 19051,
     /* 1554666 */     GIR_EraseRootFromParent_Done,
     /* 1554667 */   // Label 21578: @1554667
     /* 1554667 */   GIM_Try, /*On fail goto*//*Label 21579*/ GIMT_Encode4(1554749), // Rule ID 19054 //
     /* 1554672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1554689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554711 */     // MIs[0] round
     /* 1554711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554714 */     // MIs[0] policy
     /* 1554714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554724 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1554727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554748 */     // GIR_Coverage, 19054,
     /* 1554748 */     GIR_EraseRootFromParent_Done,
     /* 1554749 */   // Label 21579: @1554749
     /* 1554749 */   GIM_Try, /*On fail goto*//*Label 21580*/ GIMT_Encode4(1554831), // Rule ID 19055 //
     /* 1554754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1554771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554793 */     // MIs[0] round
     /* 1554793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554796 */     // MIs[0] policy
     /* 1554796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554806 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1554809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554830 */     // GIR_Coverage, 19055,
     /* 1554830 */     GIR_EraseRootFromParent_Done,
     /* 1554831 */   // Label 21580: @1554831
     /* 1554831 */   GIM_Try, /*On fail goto*//*Label 21581*/ GIMT_Encode4(1554913), // Rule ID 19058 //
     /* 1554836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1554839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1554847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1554850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1554853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1554856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554875 */     // MIs[0] round
     /* 1554875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554878 */     // MIs[0] policy
     /* 1554878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554888 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1554891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554912 */     // GIR_Coverage, 19058,
     /* 1554912 */     GIR_EraseRootFromParent_Done,
     /* 1554913 */   // Label 21581: @1554913
     /* 1554913 */   GIM_Try, /*On fail goto*//*Label 21582*/ GIMT_Encode4(1554995), // Rule ID 19059 //
     /* 1554918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1554921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1554929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1554932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1554935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1554938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554957 */     // MIs[0] round
     /* 1554957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554960 */     // MIs[0] policy
     /* 1554960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554970 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1554973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554994 */     // GIR_Coverage, 19059,
     /* 1554994 */     GIR_EraseRootFromParent_Done,
     /* 1554995 */   // Label 21582: @1554995
     /* 1554995 */   GIM_Try, /*On fail goto*//*Label 21583*/ GIMT_Encode4(1555077), // Rule ID 19062 //
     /* 1555000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1555003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1555008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1555011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1555014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1555017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1555027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555039 */     // MIs[0] round
     /* 1555039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555042 */     // MIs[0] policy
     /* 1555042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555052 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1555055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555076 */     // GIR_Coverage, 19062,
     /* 1555076 */     GIR_EraseRootFromParent_Done,
     /* 1555077 */   // Label 21583: @1555077
     /* 1555077 */   GIM_Try, /*On fail goto*//*Label 21584*/ GIMT_Encode4(1555159), // Rule ID 19063 //
     /* 1555082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1555085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1555090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1555093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1555096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1555099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1555109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555121 */     // MIs[0] round
     /* 1555121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555124 */     // MIs[0] policy
     /* 1555124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555134 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1555137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555158 */     // GIR_Coverage, 19063,
     /* 1555158 */     GIR_EraseRootFromParent_Done,
     /* 1555159 */   // Label 21584: @1555159
     /* 1555159 */   GIM_Try, /*On fail goto*//*Label 21585*/ GIMT_Encode4(1555241), // Rule ID 19066 //
     /* 1555164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1555167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1555172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1555175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1555178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1555181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1555184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1555191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555203 */     // MIs[0] round
     /* 1555203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555206 */     // MIs[0] policy
     /* 1555206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555216 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1555219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555240 */     // GIR_Coverage, 19066,
     /* 1555240 */     GIR_EraseRootFromParent_Done,
     /* 1555241 */   // Label 21585: @1555241
     /* 1555241 */   GIM_Try, /*On fail goto*//*Label 21586*/ GIMT_Encode4(1555323), // Rule ID 19067 //
     /* 1555246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1555249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1555254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1555257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1555260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1555263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1555266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1555273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555285 */     // MIs[0] round
     /* 1555285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555288 */     // MIs[0] policy
     /* 1555288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555298 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1555301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555322 */     // GIR_Coverage, 19067,
     /* 1555322 */     GIR_EraseRootFromParent_Done,
     /* 1555323 */   // Label 21586: @1555323
     /* 1555323 */   GIM_Try, /*On fail goto*//*Label 21587*/ GIMT_Encode4(1555405), // Rule ID 19126 //
     /* 1555328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1555331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1555339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1555342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1555345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555367 */     // MIs[0] round
     /* 1555367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555370 */     // MIs[0] policy
     /* 1555370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555380 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1555383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555404 */     // GIR_Coverage, 19126,
     /* 1555404 */     GIR_EraseRootFromParent_Done,
     /* 1555405 */   // Label 21587: @1555405
     /* 1555405 */   GIM_Try, /*On fail goto*//*Label 21588*/ GIMT_Encode4(1555487), // Rule ID 19127 //
     /* 1555410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1555413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1555421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1555424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1555427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555449 */     // MIs[0] round
     /* 1555449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555452 */     // MIs[0] policy
     /* 1555452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555462 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1555465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555486 */     // GIR_Coverage, 19127,
     /* 1555486 */     GIR_EraseRootFromParent_Done,
     /* 1555487 */   // Label 21588: @1555487
     /* 1555487 */   GIM_Try, /*On fail goto*//*Label 21589*/ GIMT_Encode4(1555569), // Rule ID 19130 //
     /* 1555492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1555495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1555503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1555506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1555509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555531 */     // MIs[0] round
     /* 1555531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555534 */     // MIs[0] policy
     /* 1555534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555544 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1555547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555568 */     // GIR_Coverage, 19130,
     /* 1555568 */     GIR_EraseRootFromParent_Done,
     /* 1555569 */   // Label 21589: @1555569
     /* 1555569 */   GIM_Try, /*On fail goto*//*Label 21590*/ GIMT_Encode4(1555651), // Rule ID 19131 //
     /* 1555574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1555577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1555585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1555588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1555591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555613 */     // MIs[0] round
     /* 1555613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555616 */     // MIs[0] policy
     /* 1555616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555626 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1555629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555650 */     // GIR_Coverage, 19131,
     /* 1555650 */     GIR_EraseRootFromParent_Done,
     /* 1555651 */   // Label 21590: @1555651
     /* 1555651 */   GIM_Try, /*On fail goto*//*Label 21591*/ GIMT_Encode4(1555733), // Rule ID 19134 //
     /* 1555656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1555659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1555673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555695 */     // MIs[0] round
     /* 1555695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555698 */     // MIs[0] policy
     /* 1555698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555708 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1555711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555732 */     // GIR_Coverage, 19134,
     /* 1555732 */     GIR_EraseRootFromParent_Done,
     /* 1555733 */   // Label 21591: @1555733
     /* 1555733 */   GIM_Try, /*On fail goto*//*Label 21592*/ GIMT_Encode4(1555815), // Rule ID 19135 //
     /* 1555738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1555741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1555755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555777 */     // MIs[0] round
     /* 1555777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555780 */     // MIs[0] policy
     /* 1555780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555790 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1555793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555814 */     // GIR_Coverage, 19135,
     /* 1555814 */     GIR_EraseRootFromParent_Done,
     /* 1555815 */   // Label 21592: @1555815
     /* 1555815 */   GIM_Try, /*On fail goto*//*Label 21593*/ GIMT_Encode4(1555897), // Rule ID 19138 //
     /* 1555820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1555823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1555831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1555834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1555837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555859 */     // MIs[0] round
     /* 1555859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555862 */     // MIs[0] policy
     /* 1555862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555872 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11307:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1555875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555896 */     // GIR_Coverage, 19138,
     /* 1555896 */     GIR_EraseRootFromParent_Done,
     /* 1555897 */   // Label 21593: @1555897
     /* 1555897 */   GIM_Try, /*On fail goto*//*Label 21594*/ GIMT_Encode4(1555979), // Rule ID 19139 //
     /* 1555902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1555905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1555913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1555916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1555919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555941 */     // MIs[0] round
     /* 1555941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555944 */     // MIs[0] policy
     /* 1555944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555954 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11307:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1555957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555963 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555978 */     // GIR_Coverage, 19139,
     /* 1555978 */     GIR_EraseRootFromParent_Done,
     /* 1555979 */   // Label 21594: @1555979
     /* 1555979 */   GIM_Try, /*On fail goto*//*Label 21595*/ GIMT_Encode4(1556061), // Rule ID 19142 //
     /* 1555984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1555987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1555995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1555998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1556001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556023 */     // MIs[0] round
     /* 1556023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556026 */     // MIs[0] policy
     /* 1556026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556036 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1556039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556060 */     // GIR_Coverage, 19142,
     /* 1556060 */     GIR_EraseRootFromParent_Done,
     /* 1556061 */   // Label 21595: @1556061
     /* 1556061 */   GIM_Try, /*On fail goto*//*Label 21596*/ GIMT_Encode4(1556143), // Rule ID 19143 //
     /* 1556066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1556069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1556077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1556080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1556083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556105 */     // MIs[0] round
     /* 1556105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556108 */     // MIs[0] policy
     /* 1556108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556118 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1556121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556142 */     // GIR_Coverage, 19143,
     /* 1556142 */     GIR_EraseRootFromParent_Done,
     /* 1556143 */   // Label 21596: @1556143
     /* 1556143 */   GIM_Try, /*On fail goto*//*Label 21597*/ GIMT_Encode4(1556225), // Rule ID 19146 //
     /* 1556148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1556151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1556159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1556162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1556165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1556168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556187 */     // MIs[0] round
     /* 1556187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556190 */     // MIs[0] policy
     /* 1556190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556200 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1556203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556224 */     // GIR_Coverage, 19146,
     /* 1556224 */     GIR_EraseRootFromParent_Done,
     /* 1556225 */   // Label 21597: @1556225
     /* 1556225 */   GIM_Try, /*On fail goto*//*Label 21598*/ GIMT_Encode4(1556307), // Rule ID 19147 //
     /* 1556230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1556233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1556241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1556244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1556247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1556250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556269 */     // MIs[0] round
     /* 1556269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556272 */     // MIs[0] policy
     /* 1556272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556282 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1556285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556306 */     // GIR_Coverage, 19147,
     /* 1556306 */     GIR_EraseRootFromParent_Done,
     /* 1556307 */   // Label 21598: @1556307
     /* 1556307 */   GIM_Try, /*On fail goto*//*Label 21599*/ GIMT_Encode4(1556389), // Rule ID 19150 //
     /* 1556312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1556315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1556323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1556326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1556329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556351 */     // MIs[0] round
     /* 1556351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556354 */     // MIs[0] policy
     /* 1556354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556364 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1556367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556388 */     // GIR_Coverage, 19150,
     /* 1556388 */     GIR_EraseRootFromParent_Done,
     /* 1556389 */   // Label 21599: @1556389
     /* 1556389 */   GIM_Try, /*On fail goto*//*Label 21600*/ GIMT_Encode4(1556471), // Rule ID 19151 //
     /* 1556394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1556397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1556405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1556408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1556411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556433 */     // MIs[0] round
     /* 1556433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556436 */     // MIs[0] policy
     /* 1556436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556446 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1556449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556470 */     // GIR_Coverage, 19151,
     /* 1556470 */     GIR_EraseRootFromParent_Done,
     /* 1556471 */   // Label 21600: @1556471
     /* 1556471 */   GIM_Try, /*On fail goto*//*Label 21601*/ GIMT_Encode4(1556553), // Rule ID 19154 //
     /* 1556476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1556479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1556487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1556490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1556493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556515 */     // MIs[0] round
     /* 1556515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556518 */     // MIs[0] policy
     /* 1556518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556528 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1556531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556552 */     // GIR_Coverage, 19154,
     /* 1556552 */     GIR_EraseRootFromParent_Done,
     /* 1556553 */   // Label 21601: @1556553
     /* 1556553 */   GIM_Try, /*On fail goto*//*Label 21602*/ GIMT_Encode4(1556635), // Rule ID 19155 //
     /* 1556558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1556561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1556569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1556572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1556575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556597 */     // MIs[0] round
     /* 1556597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556600 */     // MIs[0] policy
     /* 1556600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556610 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1556613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556634 */     // GIR_Coverage, 19155,
     /* 1556634 */     GIR_EraseRootFromParent_Done,
     /* 1556635 */   // Label 21602: @1556635
     /* 1556635 */   GIM_Try, /*On fail goto*//*Label 21603*/ GIMT_Encode4(1556717), // Rule ID 19158 //
     /* 1556640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1556643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1556651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1556654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1556657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1556660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556679 */     // MIs[0] round
     /* 1556679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556682 */     // MIs[0] policy
     /* 1556682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556692 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1556695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556716 */     // GIR_Coverage, 19158,
     /* 1556716 */     GIR_EraseRootFromParent_Done,
     /* 1556717 */   // Label 21603: @1556717
     /* 1556717 */   GIM_Try, /*On fail goto*//*Label 21604*/ GIMT_Encode4(1556799), // Rule ID 19159 //
     /* 1556722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1556725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1556733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1556736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1556739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1556742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556761 */     // MIs[0] round
     /* 1556761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556764 */     // MIs[0] policy
     /* 1556764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556774 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1556777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556798 */     // GIR_Coverage, 19159,
     /* 1556798 */     GIR_EraseRootFromParent_Done,
     /* 1556799 */   // Label 21604: @1556799
     /* 1556799 */   GIM_Try, /*On fail goto*//*Label 21605*/ GIMT_Encode4(1556881), // Rule ID 19162 //
     /* 1556804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1556807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1556815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1556818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1556821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556843 */     // MIs[0] round
     /* 1556843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556846 */     // MIs[0] policy
     /* 1556846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556856 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1556859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556880 */     // GIR_Coverage, 19162,
     /* 1556880 */     GIR_EraseRootFromParent_Done,
     /* 1556881 */   // Label 21605: @1556881
     /* 1556881 */   GIM_Try, /*On fail goto*//*Label 21606*/ GIMT_Encode4(1556963), // Rule ID 19163 //
     /* 1556886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1556889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1556897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1556900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1556903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556925 */     // MIs[0] round
     /* 1556925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556928 */     // MIs[0] policy
     /* 1556928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556938 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1556941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556962 */     // GIR_Coverage, 19163,
     /* 1556962 */     GIR_EraseRootFromParent_Done,
     /* 1556963 */   // Label 21606: @1556963
     /* 1556963 */   GIM_Try, /*On fail goto*//*Label 21607*/ GIMT_Encode4(1557045), // Rule ID 19166 //
     /* 1556968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1556971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1556979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1556982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1556985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557007 */     // MIs[0] round
     /* 1557007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557010 */     // MIs[0] policy
     /* 1557010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557020 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1557023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557044 */     // GIR_Coverage, 19166,
     /* 1557044 */     GIR_EraseRootFromParent_Done,
     /* 1557045 */   // Label 21607: @1557045
     /* 1557045 */   GIM_Try, /*On fail goto*//*Label 21608*/ GIMT_Encode4(1557127), // Rule ID 19167 //
     /* 1557050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1557053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1557061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1557064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1557067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557089 */     // MIs[0] round
     /* 1557089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557092 */     // MIs[0] policy
     /* 1557092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557102 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1557105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557126 */     // GIR_Coverage, 19167,
     /* 1557126 */     GIR_EraseRootFromParent_Done,
     /* 1557127 */   // Label 21608: @1557127
     /* 1557127 */   GIM_Try, /*On fail goto*//*Label 21609*/ GIMT_Encode4(1557209), // Rule ID 19170 //
     /* 1557132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1557135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1557143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1557146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1557149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1557152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557171 */     // MIs[0] round
     /* 1557171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557174 */     // MIs[0] policy
     /* 1557174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557184 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1557187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557208 */     // GIR_Coverage, 19170,
     /* 1557208 */     GIR_EraseRootFromParent_Done,
     /* 1557209 */   // Label 21609: @1557209
     /* 1557209 */   GIM_Try, /*On fail goto*//*Label 21610*/ GIMT_Encode4(1557291), // Rule ID 19171 //
     /* 1557214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1557217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1557225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1557228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1557231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1557234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557253 */     // MIs[0] round
     /* 1557253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557256 */     // MIs[0] policy
     /* 1557256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557266 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1557269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557290 */     // GIR_Coverage, 19171,
     /* 1557290 */     GIR_EraseRootFromParent_Done,
     /* 1557291 */   // Label 21610: @1557291
     /* 1557291 */   GIM_Try, /*On fail goto*//*Label 21611*/ GIMT_Encode4(1557373), // Rule ID 19174 //
     /* 1557296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1557299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1557307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1557310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1557313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1557323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557335 */     // MIs[0] round
     /* 1557335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557338 */     // MIs[0] policy
     /* 1557338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557348 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1557351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557372 */     // GIR_Coverage, 19174,
     /* 1557372 */     GIR_EraseRootFromParent_Done,
     /* 1557373 */   // Label 21611: @1557373
     /* 1557373 */   GIM_Try, /*On fail goto*//*Label 21612*/ GIMT_Encode4(1557455), // Rule ID 19175 //
     /* 1557378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1557381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1557389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1557392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1557395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1557405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557417 */     // MIs[0] round
     /* 1557417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557420 */     // MIs[0] policy
     /* 1557420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557430 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1557433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557454 */     // GIR_Coverage, 19175,
     /* 1557454 */     GIR_EraseRootFromParent_Done,
     /* 1557455 */   // Label 21612: @1557455
     /* 1557455 */   GIM_Try, /*On fail goto*//*Label 21613*/ GIMT_Encode4(1557537), // Rule ID 19178 //
     /* 1557460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1557463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1557471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1557474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1557477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557499 */     // MIs[0] round
     /* 1557499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557502 */     // MIs[0] policy
     /* 1557502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557512 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1557515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557536 */     // GIR_Coverage, 19178,
     /* 1557536 */     GIR_EraseRootFromParent_Done,
     /* 1557537 */   // Label 21613: @1557537
     /* 1557537 */   GIM_Try, /*On fail goto*//*Label 21614*/ GIMT_Encode4(1557619), // Rule ID 19179 //
     /* 1557542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1557545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1557553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1557556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1557559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557581 */     // MIs[0] round
     /* 1557581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557584 */     // MIs[0] policy
     /* 1557584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557594 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1557597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557618 */     // GIR_Coverage, 19179,
     /* 1557618 */     GIR_EraseRootFromParent_Done,
     /* 1557619 */   // Label 21614: @1557619
     /* 1557619 */   GIM_Try, /*On fail goto*//*Label 21615*/ GIMT_Encode4(1557701), // Rule ID 19182 //
     /* 1557624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1557627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1557635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1557638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1557641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557663 */     // MIs[0] round
     /* 1557663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557666 */     // MIs[0] policy
     /* 1557666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557676 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1557679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557700 */     // GIR_Coverage, 19182,
     /* 1557700 */     GIR_EraseRootFromParent_Done,
     /* 1557701 */   // Label 21615: @1557701
     /* 1557701 */   GIM_Try, /*On fail goto*//*Label 21616*/ GIMT_Encode4(1557783), // Rule ID 19183 //
     /* 1557706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1557709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1557717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1557720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1557723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557745 */     // MIs[0] round
     /* 1557745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557748 */     // MIs[0] policy
     /* 1557748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557758 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1557761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557782 */     // GIR_Coverage, 19183,
     /* 1557782 */     GIR_EraseRootFromParent_Done,
     /* 1557783 */   // Label 21616: @1557783
     /* 1557783 */   GIM_Try, /*On fail goto*//*Label 21617*/ GIMT_Encode4(1557865), // Rule ID 20768 //
     /* 1557788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1557791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1557799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1557802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1557805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557827 */     // MIs[0] round
     /* 1557827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557830 */     // MIs[0] policy
     /* 1557830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557840 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557864 */     // GIR_Coverage, 20768,
     /* 1557864 */     GIR_EraseRootFromParent_Done,
     /* 1557865 */   // Label 21617: @1557865
     /* 1557865 */   GIM_Try, /*On fail goto*//*Label 21618*/ GIMT_Encode4(1557947), // Rule ID 20769 //
     /* 1557870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1557873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1557881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1557884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1557887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557909 */     // MIs[0] round
     /* 1557909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557912 */     // MIs[0] policy
     /* 1557912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557922 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557946 */     // GIR_Coverage, 20769,
     /* 1557946 */     GIR_EraseRootFromParent_Done,
     /* 1557947 */   // Label 21618: @1557947
     /* 1557947 */   GIM_Try, /*On fail goto*//*Label 21619*/ GIMT_Encode4(1558029), // Rule ID 20772 //
     /* 1557952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1557955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1557963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1557966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1557969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557991 */     // MIs[0] round
     /* 1557991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557994 */     // MIs[0] policy
     /* 1557994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558004 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1558007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558028 */     // GIR_Coverage, 20772,
     /* 1558028 */     GIR_EraseRootFromParent_Done,
     /* 1558029 */   // Label 21619: @1558029
     /* 1558029 */   GIM_Try, /*On fail goto*//*Label 21620*/ GIMT_Encode4(1558111), // Rule ID 20773 //
     /* 1558034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1558037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1558045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1558048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1558051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558073 */     // MIs[0] round
     /* 1558073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558076 */     // MIs[0] policy
     /* 1558076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1558089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558110 */     // GIR_Coverage, 20773,
     /* 1558110 */     GIR_EraseRootFromParent_Done,
     /* 1558111 */   // Label 21620: @1558111
     /* 1558111 */   GIM_Try, /*On fail goto*//*Label 21621*/ GIMT_Encode4(1558193), // Rule ID 20776 //
     /* 1558116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1558127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1558130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1558133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558155 */     // MIs[0] round
     /* 1558155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558158 */     // MIs[0] policy
     /* 1558158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558192 */     // GIR_Coverage, 20776,
     /* 1558192 */     GIR_EraseRootFromParent_Done,
     /* 1558193 */   // Label 21621: @1558193
     /* 1558193 */   GIM_Try, /*On fail goto*//*Label 21622*/ GIMT_Encode4(1558275), // Rule ID 20777 //
     /* 1558198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1558209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1558212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1558215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558237 */     // MIs[0] round
     /* 1558237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558240 */     // MIs[0] policy
     /* 1558240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558274 */     // GIR_Coverage, 20777,
     /* 1558274 */     GIR_EraseRootFromParent_Done,
     /* 1558275 */   // Label 21622: @1558275
     /* 1558275 */   GIM_Try, /*On fail goto*//*Label 21623*/ GIMT_Encode4(1558357), // Rule ID 20780 //
     /* 1558280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1558283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1558291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1558294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1558297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558319 */     // MIs[0] round
     /* 1558319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558322 */     // MIs[0] policy
     /* 1558322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558332 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558356 */     // GIR_Coverage, 20780,
     /* 1558356 */     GIR_EraseRootFromParent_Done,
     /* 1558357 */   // Label 21623: @1558357
     /* 1558357 */   GIM_Try, /*On fail goto*//*Label 21624*/ GIMT_Encode4(1558439), // Rule ID 20781 //
     /* 1558362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1558365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1558373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1558376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1558379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558401 */     // MIs[0] round
     /* 1558401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558404 */     // MIs[0] policy
     /* 1558404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558414 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558438 */     // GIR_Coverage, 20781,
     /* 1558438 */     GIR_EraseRootFromParent_Done,
     /* 1558439 */   // Label 21624: @1558439
     /* 1558439 */   GIM_Try, /*On fail goto*//*Label 21625*/ GIMT_Encode4(1558521), // Rule ID 20784 //
     /* 1558444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1558447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1558455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1558458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1558461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558483 */     // MIs[0] round
     /* 1558483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558486 */     // MIs[0] policy
     /* 1558486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558520 */     // GIR_Coverage, 20784,
     /* 1558520 */     GIR_EraseRootFromParent_Done,
     /* 1558521 */   // Label 21625: @1558521
     /* 1558521 */   GIM_Try, /*On fail goto*//*Label 21626*/ GIMT_Encode4(1558603), // Rule ID 20785 //
     /* 1558526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1558529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1558537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1558540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1558543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558565 */     // MIs[0] round
     /* 1558565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558568 */     // MIs[0] policy
     /* 1558568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558578 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558602 */     // GIR_Coverage, 20785,
     /* 1558602 */     GIR_EraseRootFromParent_Done,
     /* 1558603 */   // Label 21626: @1558603
     /* 1558603 */   GIM_Try, /*On fail goto*//*Label 21627*/ GIMT_Encode4(1558685), // Rule ID 20788 //
     /* 1558608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558647 */     // MIs[0] round
     /* 1558647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558650 */     // MIs[0] policy
     /* 1558650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1558663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558684 */     // GIR_Coverage, 20788,
     /* 1558684 */     GIR_EraseRootFromParent_Done,
     /* 1558685 */   // Label 21627: @1558685
     /* 1558685 */   GIM_Try, /*On fail goto*//*Label 21628*/ GIMT_Encode4(1558767), // Rule ID 20789 //
     /* 1558690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558729 */     // MIs[0] round
     /* 1558729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558732 */     // MIs[0] policy
     /* 1558732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558742 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1558745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558766 */     // GIR_Coverage, 20789,
     /* 1558766 */     GIR_EraseRootFromParent_Done,
     /* 1558767 */   // Label 21628: @1558767
     /* 1558767 */   GIM_Try, /*On fail goto*//*Label 21629*/ GIMT_Encode4(1558849), // Rule ID 20792 //
     /* 1558772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1558783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1558786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1558789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558811 */     // MIs[0] round
     /* 1558811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558814 */     // MIs[0] policy
     /* 1558814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558824 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1558827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558848 */     // GIR_Coverage, 20792,
     /* 1558848 */     GIR_EraseRootFromParent_Done,
     /* 1558849 */   // Label 21629: @1558849
     /* 1558849 */   GIM_Try, /*On fail goto*//*Label 21630*/ GIMT_Encode4(1558931), // Rule ID 20793 //
     /* 1558854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1558865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1558868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1558871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558893 */     // MIs[0] round
     /* 1558893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558896 */     // MIs[0] policy
     /* 1558896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558906 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1558909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558930 */     // GIR_Coverage, 20793,
     /* 1558930 */     GIR_EraseRootFromParent_Done,
     /* 1558931 */   // Label 21630: @1558931
     /* 1558931 */   GIM_Try, /*On fail goto*//*Label 21631*/ GIMT_Encode4(1559013), // Rule ID 20796 //
     /* 1558936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1558947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1558950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1558953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1558956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558975 */     // MIs[0] round
     /* 1558975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558978 */     // MIs[0] policy
     /* 1558978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558988 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1558991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559012 */     // GIR_Coverage, 20796,
     /* 1559012 */     GIR_EraseRootFromParent_Done,
     /* 1559013 */   // Label 21631: @1559013
     /* 1559013 */   GIM_Try, /*On fail goto*//*Label 21632*/ GIMT_Encode4(1559095), // Rule ID 20797 //
     /* 1559018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1559021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1559029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1559032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1559035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1559038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559057 */     // MIs[0] round
     /* 1559057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559060 */     // MIs[0] policy
     /* 1559060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559070 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559094 */     // GIR_Coverage, 20797,
     /* 1559094 */     GIR_EraseRootFromParent_Done,
     /* 1559095 */   // Label 21632: @1559095
     /* 1559095 */   GIM_Try, /*On fail goto*//*Label 21633*/ GIMT_Encode4(1559177), // Rule ID 20800 //
     /* 1559100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1559111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1559114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1559117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559139 */     // MIs[0] round
     /* 1559139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559142 */     // MIs[0] policy
     /* 1559142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1559155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559176 */     // GIR_Coverage, 20800,
     /* 1559176 */     GIR_EraseRootFromParent_Done,
     /* 1559177 */   // Label 21633: @1559177
     /* 1559177 */   GIM_Try, /*On fail goto*//*Label 21634*/ GIMT_Encode4(1559259), // Rule ID 20801 //
     /* 1559182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1559193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1559196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1559199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559221 */     // MIs[0] round
     /* 1559221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559224 */     // MIs[0] policy
     /* 1559224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1559237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559258 */     // GIR_Coverage, 20801,
     /* 1559258 */     GIR_EraseRootFromParent_Done,
     /* 1559259 */   // Label 21634: @1559259
     /* 1559259 */   GIM_Try, /*On fail goto*//*Label 21635*/ GIMT_Encode4(1559341), // Rule ID 20804 //
     /* 1559264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1559275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1559278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1559281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559303 */     // MIs[0] round
     /* 1559303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559306 */     // MIs[0] policy
     /* 1559306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559316 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1559319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559340 */     // GIR_Coverage, 20804,
     /* 1559340 */     GIR_EraseRootFromParent_Done,
     /* 1559341 */   // Label 21635: @1559341
     /* 1559341 */   GIM_Try, /*On fail goto*//*Label 21636*/ GIMT_Encode4(1559423), // Rule ID 20805 //
     /* 1559346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1559357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1559360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1559363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559385 */     // MIs[0] round
     /* 1559385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559388 */     // MIs[0] policy
     /* 1559388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559398 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1559401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559422 */     // GIR_Coverage, 20805,
     /* 1559422 */     GIR_EraseRootFromParent_Done,
     /* 1559423 */   // Label 21636: @1559423
     /* 1559423 */   GIM_Try, /*On fail goto*//*Label 21637*/ GIMT_Encode4(1559505), // Rule ID 20808 //
     /* 1559428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1559439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1559442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1559445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559467 */     // MIs[0] round
     /* 1559467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559470 */     // MIs[0] policy
     /* 1559470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559480 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559504 */     // GIR_Coverage, 20808,
     /* 1559504 */     GIR_EraseRootFromParent_Done,
     /* 1559505 */   // Label 21637: @1559505
     /* 1559505 */   GIM_Try, /*On fail goto*//*Label 21638*/ GIMT_Encode4(1559587), // Rule ID 20809 //
     /* 1559510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1559521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1559524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1559527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559549 */     // MIs[0] round
     /* 1559549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559552 */     // MIs[0] policy
     /* 1559552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559571 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559586 */     // GIR_Coverage, 20809,
     /* 1559586 */     GIR_EraseRootFromParent_Done,
     /* 1559587 */   // Label 21638: @1559587
     /* 1559587 */   GIM_Try, /*On fail goto*//*Label 21639*/ GIMT_Encode4(1559669), // Rule ID 20812 //
     /* 1559592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559631 */     // MIs[0] round
     /* 1559631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559634 */     // MIs[0] policy
     /* 1559634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1559647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559668 */     // GIR_Coverage, 20812,
     /* 1559668 */     GIR_EraseRootFromParent_Done,
     /* 1559669 */   // Label 21639: @1559669
     /* 1559669 */   GIM_Try, /*On fail goto*//*Label 21640*/ GIMT_Encode4(1559751), // Rule ID 20813 //
     /* 1559674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559713 */     // MIs[0] round
     /* 1559713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559716 */     // MIs[0] policy
     /* 1559716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559726 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1559729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559750 */     // GIR_Coverage, 20813,
     /* 1559750 */     GIR_EraseRootFromParent_Done,
     /* 1559751 */   // Label 21640: @1559751
     /* 1559751 */   GIM_Try, /*On fail goto*//*Label 21641*/ GIMT_Encode4(1559833), // Rule ID 20816 //
     /* 1559756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1559767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1559770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1559773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559795 */     // MIs[0] round
     /* 1559795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559798 */     // MIs[0] policy
     /* 1559798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559808 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1559811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559832 */     // GIR_Coverage, 20816,
     /* 1559832 */     GIR_EraseRootFromParent_Done,
     /* 1559833 */   // Label 21641: @1559833
     /* 1559833 */   GIM_Try, /*On fail goto*//*Label 21642*/ GIMT_Encode4(1559915), // Rule ID 20817 //
     /* 1559838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1559849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1559852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1559855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559877 */     // MIs[0] round
     /* 1559877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559880 */     // MIs[0] policy
     /* 1559880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559890 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1559893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559914 */     // GIR_Coverage, 20817,
     /* 1559914 */     GIR_EraseRootFromParent_Done,
     /* 1559915 */   // Label 21642: @1559915
     /* 1559915 */   GIM_Try, /*On fail goto*//*Label 21643*/ GIMT_Encode4(1559997), // Rule ID 20820 //
     /* 1559920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1559931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1559934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1559937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559959 */     // MIs[0] round
     /* 1559959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559962 */     // MIs[0] policy
     /* 1559962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559972 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559996 */     // GIR_Coverage, 20820,
     /* 1559996 */     GIR_EraseRootFromParent_Done,
     /* 1559997 */   // Label 21643: @1559997
     /* 1559997 */   GIM_Try, /*On fail goto*//*Label 21644*/ GIMT_Encode4(1560079), // Rule ID 20821 //
     /* 1560002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1560005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1560010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1560013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1560016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1560019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1560029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560041 */     // MIs[0] round
     /* 1560041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560044 */     // MIs[0] policy
     /* 1560044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560054 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1560057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560078 */     // GIR_Coverage, 20821,
     /* 1560078 */     GIR_EraseRootFromParent_Done,
     /* 1560079 */   // Label 21644: @1560079
     /* 1560079 */   GIM_Try, /*On fail goto*//*Label 21645*/ GIMT_Encode4(1560161), // Rule ID 20824 //
     /* 1560084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1560095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1560098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1560101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560123 */     // MIs[0] round
     /* 1560123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560126 */     // MIs[0] policy
     /* 1560126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560136 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1560139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560160 */     // GIR_Coverage, 20824,
     /* 1560160 */     GIR_EraseRootFromParent_Done,
     /* 1560161 */   // Label 21645: @1560161
     /* 1560161 */   GIM_Try, /*On fail goto*//*Label 21646*/ GIMT_Encode4(1560243), // Rule ID 20825 //
     /* 1560166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1560177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1560180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1560183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560205 */     // MIs[0] round
     /* 1560205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560208 */     // MIs[0] policy
     /* 1560208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560218 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1560221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560242 */     // GIR_Coverage, 20825,
     /* 1560242 */     GIR_EraseRootFromParent_Done,
     /* 1560243 */   // Label 21646: @1560243
     /* 1560243 */   GIM_Try, /*On fail goto*//*Label 21647*/ GIMT_Encode4(1560325), // Rule ID 20828 //
     /* 1560248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1560259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1560262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1560265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560287 */     // MIs[0] round
     /* 1560287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560290 */     // MIs[0] policy
     /* 1560290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560300 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1560303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560324 */     // GIR_Coverage, 20828,
     /* 1560324 */     GIR_EraseRootFromParent_Done,
     /* 1560325 */   // Label 21647: @1560325
     /* 1560325 */   GIM_Try, /*On fail goto*//*Label 21648*/ GIMT_Encode4(1560407), // Rule ID 20829 //
     /* 1560330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1560341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1560344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1560347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560369 */     // MIs[0] round
     /* 1560369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560372 */     // MIs[0] policy
     /* 1560372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1560385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560406 */     // GIR_Coverage, 20829,
     /* 1560406 */     GIR_EraseRootFromParent_Done,
     /* 1560407 */   // Label 21648: @1560407
     /* 1560407 */   GIM_Try, /*On fail goto*//*Label 21649*/ GIMT_Encode4(1560489), // Rule ID 20832 //
     /* 1560412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1560415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1560423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1560426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1560429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560451 */     // MIs[0] round
     /* 1560451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560454 */     // MIs[0] policy
     /* 1560454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560464 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1560467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560488 */     // GIR_Coverage, 20832,
     /* 1560488 */     GIR_EraseRootFromParent_Done,
     /* 1560489 */   // Label 21649: @1560489
     /* 1560489 */   GIM_Try, /*On fail goto*//*Label 21650*/ GIMT_Encode4(1560571), // Rule ID 20833 //
     /* 1560494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1560497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1560505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1560508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1560511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560533 */     // MIs[0] round
     /* 1560533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560536 */     // MIs[0] policy
     /* 1560536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1560549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560570 */     // GIR_Coverage, 20833,
     /* 1560570 */     GIR_EraseRootFromParent_Done,
     /* 1560571 */   // Label 21650: @1560571
     /* 1560571 */   GIM_Try, /*On fail goto*//*Label 21651*/ GIMT_Encode4(1560653), // Rule ID 20836 //
     /* 1560576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1560587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1560590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1560593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560615 */     // MIs[0] round
     /* 1560615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560618 */     // MIs[0] policy
     /* 1560618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560652 */     // GIR_Coverage, 20836,
     /* 1560652 */     GIR_EraseRootFromParent_Done,
     /* 1560653 */   // Label 21651: @1560653
     /* 1560653 */   GIM_Try, /*On fail goto*//*Label 21652*/ GIMT_Encode4(1560735), // Rule ID 20837 //
     /* 1560658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1560669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1560672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1560675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560697 */     // MIs[0] round
     /* 1560697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560700 */     // MIs[0] policy
     /* 1560700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560734 */     // GIR_Coverage, 20837,
     /* 1560734 */     GIR_EraseRootFromParent_Done,
     /* 1560735 */   // Label 21652: @1560735
     /* 1560735 */   GIM_Try, /*On fail goto*//*Label 21653*/ GIMT_Encode4(1560817), // Rule ID 20840 //
     /* 1560740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1560743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1560751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1560754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1560757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560779 */     // MIs[0] round
     /* 1560779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560782 */     // MIs[0] policy
     /* 1560782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560816 */     // GIR_Coverage, 20840,
     /* 1560816 */     GIR_EraseRootFromParent_Done,
     /* 1560817 */   // Label 21653: @1560817
     /* 1560817 */   GIM_Try, /*On fail goto*//*Label 21654*/ GIMT_Encode4(1560899), // Rule ID 20841 //
     /* 1560822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1560825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1560833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1560836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1560839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560861 */     // MIs[0] round
     /* 1560861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560864 */     // MIs[0] policy
     /* 1560864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560874 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560898 */     // GIR_Coverage, 20841,
     /* 1560898 */     GIR_EraseRootFromParent_Done,
     /* 1560899 */   // Label 21654: @1560899
     /* 1560899 */   GIM_Try, /*On fail goto*//*Label 21655*/ GIMT_Encode4(1560981), // Rule ID 20844 //
     /* 1560904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1560907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1560915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1560918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1560921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560943 */     // MIs[0] round
     /* 1560943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560946 */     // MIs[0] policy
     /* 1560946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560956 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560980 */     // GIR_Coverage, 20844,
     /* 1560980 */     GIR_EraseRootFromParent_Done,
     /* 1560981 */   // Label 21655: @1560981
     /* 1560981 */   GIM_Try, /*On fail goto*//*Label 21656*/ GIMT_Encode4(1561063), // Rule ID 20845 //
     /* 1560986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1560989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1560997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1561000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1561003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1561006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561025 */     // MIs[0] round
     /* 1561025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561028 */     // MIs[0] policy
     /* 1561028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561038 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1561041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561062 */     // GIR_Coverage, 20845,
     /* 1561062 */     GIR_EraseRootFromParent_Done,
     /* 1561063 */   // Label 21656: @1561063
     /* 1561063 */   GIM_Try, /*On fail goto*//*Label 21657*/ GIMT_Encode4(1561145), // Rule ID 20848 //
     /* 1561068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1561071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1561079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1561082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1561085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561107 */     // MIs[0] round
     /* 1561107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561110 */     // MIs[0] policy
     /* 1561110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561120 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561144 */     // GIR_Coverage, 20848,
     /* 1561144 */     GIR_EraseRootFromParent_Done,
     /* 1561145 */   // Label 21657: @1561145
     /* 1561145 */   GIM_Try, /*On fail goto*//*Label 21658*/ GIMT_Encode4(1561227), // Rule ID 20849 //
     /* 1561150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1561161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1561164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1561167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561189 */     // MIs[0] round
     /* 1561189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561192 */     // MIs[0] policy
     /* 1561192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561226 */     // GIR_Coverage, 20849,
     /* 1561226 */     GIR_EraseRootFromParent_Done,
     /* 1561227 */   // Label 21658: @1561227
     /* 1561227 */   GIM_Try, /*On fail goto*//*Label 21659*/ GIMT_Encode4(1561309), // Rule ID 20852 //
     /* 1561232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1561235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1561243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1561246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1561249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561271 */     // MIs[0] round
     /* 1561271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561274 */     // MIs[0] policy
     /* 1561274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561284 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561308 */     // GIR_Coverage, 20852,
     /* 1561308 */     GIR_EraseRootFromParent_Done,
     /* 1561309 */   // Label 21659: @1561309
     /* 1561309 */   GIM_Try, /*On fail goto*//*Label 21660*/ GIMT_Encode4(1561391), // Rule ID 20853 //
     /* 1561314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1561325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1561328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1561331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561353 */     // MIs[0] round
     /* 1561353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561356 */     // MIs[0] policy
     /* 1561356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561366 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561390 */     // GIR_Coverage, 20853,
     /* 1561390 */     GIR_EraseRootFromParent_Done,
     /* 1561391 */   // Label 21660: @1561391
     /* 1561391 */   GIM_Try, /*On fail goto*//*Label 21661*/ GIMT_Encode4(1561473), // Rule ID 20856 //
     /* 1561396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1561399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1561407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1561410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1561413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1561416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561435 */     // MIs[0] round
     /* 1561435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561438 */     // MIs[0] policy
     /* 1561438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561448 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561472 */     // GIR_Coverage, 20856,
     /* 1561472 */     GIR_EraseRootFromParent_Done,
     /* 1561473 */   // Label 21661: @1561473
     /* 1561473 */   GIM_Try, /*On fail goto*//*Label 21662*/ GIMT_Encode4(1561555), // Rule ID 20857 //
     /* 1561478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1561489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1561492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1561495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1561498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561517 */     // MIs[0] round
     /* 1561517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561520 */     // MIs[0] policy
     /* 1561520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561530 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561554 */     // GIR_Coverage, 20857,
     /* 1561554 */     GIR_EraseRootFromParent_Done,
     /* 1561555 */   // Label 21662: @1561555
     /* 1561555 */   GIM_Try, /*On fail goto*//*Label 21663*/ GIMT_Encode4(1561637), // Rule ID 20860 //
     /* 1561560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1561571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1561574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1561577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561599 */     // MIs[0] round
     /* 1561599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561602 */     // MIs[0] policy
     /* 1561602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561636 */     // GIR_Coverage, 20860,
     /* 1561636 */     GIR_EraseRootFromParent_Done,
     /* 1561637 */   // Label 21663: @1561637
     /* 1561637 */   GIM_Try, /*On fail goto*//*Label 21664*/ GIMT_Encode4(1561719), // Rule ID 20861 //
     /* 1561642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1561653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1561656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1561659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561681 */     // MIs[0] round
     /* 1561681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561684 */     // MIs[0] policy
     /* 1561684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561718 */     // GIR_Coverage, 20861,
     /* 1561718 */     GIR_EraseRootFromParent_Done,
     /* 1561719 */   // Label 21664: @1561719
     /* 1561719 */   GIM_Try, /*On fail goto*//*Label 21665*/ GIMT_Encode4(1561801), // Rule ID 20864 //
     /* 1561724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1561735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1561738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1561741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561763 */     // MIs[0] round
     /* 1561763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561766 */     // MIs[0] policy
     /* 1561766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561800 */     // GIR_Coverage, 20864,
     /* 1561800 */     GIR_EraseRootFromParent_Done,
     /* 1561801 */   // Label 21665: @1561801
     /* 1561801 */   GIM_Try, /*On fail goto*//*Label 21666*/ GIMT_Encode4(1561883), // Rule ID 20865 //
     /* 1561806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1561817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1561820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1561823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561845 */     // MIs[0] round
     /* 1561845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561848 */     // MIs[0] policy
     /* 1561848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561858 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561882 */     // GIR_Coverage, 20865,
     /* 1561882 */     GIR_EraseRootFromParent_Done,
     /* 1561883 */   // Label 21666: @1561883
     /* 1561883 */   GIM_Try, /*On fail goto*//*Label 21667*/ GIMT_Encode4(1561965), // Rule ID 20868 //
     /* 1561888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1561899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1561902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1561905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561927 */     // MIs[0] round
     /* 1561927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561930 */     // MIs[0] policy
     /* 1561930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561940 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561964 */     // GIR_Coverage, 20868,
     /* 1561964 */     GIR_EraseRootFromParent_Done,
     /* 1561965 */   // Label 21667: @1561965
     /* 1561965 */   GIM_Try, /*On fail goto*//*Label 21668*/ GIMT_Encode4(1562047), // Rule ID 20869 //
     /* 1561970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1561981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1561984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1561987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562009 */     // MIs[0] round
     /* 1562009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562012 */     // MIs[0] policy
     /* 1562012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562022 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1562025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562046 */     // GIR_Coverage, 20869,
     /* 1562046 */     GIR_EraseRootFromParent_Done,
     /* 1562047 */   // Label 21668: @1562047
     /* 1562047 */   GIM_Try, /*On fail goto*//*Label 21669*/ GIMT_Encode4(1562129), // Rule ID 20872 //
     /* 1562052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1562055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1562063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1562066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1562069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562091 */     // MIs[0] round
     /* 1562091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562094 */     // MIs[0] policy
     /* 1562094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1562107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562128 */     // GIR_Coverage, 20872,
     /* 1562128 */     GIR_EraseRootFromParent_Done,
     /* 1562129 */   // Label 21669: @1562129
     /* 1562129 */   GIM_Try, /*On fail goto*//*Label 21670*/ GIMT_Encode4(1562211), // Rule ID 20873 //
     /* 1562134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1562137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1562145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1562148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1562151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562173 */     // MIs[0] round
     /* 1562173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562176 */     // MIs[0] policy
     /* 1562176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562186 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1562189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562195 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562210 */     // GIR_Coverage, 20873,
     /* 1562210 */     GIR_EraseRootFromParent_Done,
     /* 1562211 */   // Label 21670: @1562211
     /* 1562211 */   GIM_Try, /*On fail goto*//*Label 21671*/ GIMT_Encode4(1562293), // Rule ID 20876 //
     /* 1562216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1562219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1562227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1562230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1562233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562255 */     // MIs[0] round
     /* 1562255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562258 */     // MIs[0] policy
     /* 1562258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562268 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1562271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562292 */     // GIR_Coverage, 20876,
     /* 1562292 */     GIR_EraseRootFromParent_Done,
     /* 1562293 */   // Label 21671: @1562293
     /* 1562293 */   GIM_Try, /*On fail goto*//*Label 21672*/ GIMT_Encode4(1562375), // Rule ID 20877 //
     /* 1562298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1562301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1562309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1562312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1562315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562337 */     // MIs[0] round
     /* 1562337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562340 */     // MIs[0] policy
     /* 1562340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562350 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1562353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562374 */     // GIR_Coverage, 20877,
     /* 1562374 */     GIR_EraseRootFromParent_Done,
     /* 1562375 */   // Label 21672: @1562375
     /* 1562375 */   GIM_Try, /*On fail goto*//*Label 21673*/ GIMT_Encode4(1562457), // Rule ID 20880 //
     /* 1562380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1562383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1562391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1562394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1562397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562419 */     // MIs[0] round
     /* 1562419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562422 */     // MIs[0] policy
     /* 1562422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562432 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1562435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562456 */     // GIR_Coverage, 20880,
     /* 1562456 */     GIR_EraseRootFromParent_Done,
     /* 1562457 */   // Label 21673: @1562457
     /* 1562457 */   GIM_Try, /*On fail goto*//*Label 21674*/ GIMT_Encode4(1562539), // Rule ID 20881 //
     /* 1562462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1562465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1562473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1562476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1562479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562501 */     // MIs[0] round
     /* 1562501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562504 */     // MIs[0] policy
     /* 1562504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562514 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1562517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562538 */     // GIR_Coverage, 20881,
     /* 1562538 */     GIR_EraseRootFromParent_Done,
     /* 1562539 */   // Label 21674: @1562539
     /* 1562539 */   GIM_Try, /*On fail goto*//*Label 21675*/ GIMT_Encode4(1562621), // Rule ID 21004 //
     /* 1562544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1562555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1562558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1562561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562583 */     // MIs[0] round
     /* 1562583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562586 */     // MIs[0] policy
     /* 1562586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562596 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1562599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562620 */     // GIR_Coverage, 21004,
     /* 1562620 */     GIR_EraseRootFromParent_Done,
     /* 1562621 */   // Label 21675: @1562621
     /* 1562621 */   GIM_Try, /*On fail goto*//*Label 21676*/ GIMT_Encode4(1562703), // Rule ID 21005 //
     /* 1562626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1562637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1562640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1562643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562665 */     // MIs[0] round
     /* 1562665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562668 */     // MIs[0] policy
     /* 1562668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562678 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1562681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562702 */     // GIR_Coverage, 21005,
     /* 1562702 */     GIR_EraseRootFromParent_Done,
     /* 1562703 */   // Label 21676: @1562703
     /* 1562703 */   GIM_Try, /*On fail goto*//*Label 21677*/ GIMT_Encode4(1562785), // Rule ID 21008 //
     /* 1562708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1562719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1562722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1562725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562747 */     // MIs[0] round
     /* 1562747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562750 */     // MIs[0] policy
     /* 1562750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562760 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1562763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562784 */     // GIR_Coverage, 21008,
     /* 1562784 */     GIR_EraseRootFromParent_Done,
     /* 1562785 */   // Label 21677: @1562785
     /* 1562785 */   GIM_Try, /*On fail goto*//*Label 21678*/ GIMT_Encode4(1562867), // Rule ID 21009 //
     /* 1562790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1562801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1562804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1562807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562829 */     // MIs[0] round
     /* 1562829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562832 */     // MIs[0] policy
     /* 1562832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562842 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1562845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562866 */     // GIR_Coverage, 21009,
     /* 1562866 */     GIR_EraseRootFromParent_Done,
     /* 1562867 */   // Label 21678: @1562867
     /* 1562867 */   GIM_Try, /*On fail goto*//*Label 21679*/ GIMT_Encode4(1562949), // Rule ID 21012 //
     /* 1562872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1562875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1562883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1562886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1562889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562911 */     // MIs[0] round
     /* 1562911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562914 */     // MIs[0] policy
     /* 1562914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562924 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1562927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562948 */     // GIR_Coverage, 21012,
     /* 1562948 */     GIR_EraseRootFromParent_Done,
     /* 1562949 */   // Label 21679: @1562949
     /* 1562949 */   GIM_Try, /*On fail goto*//*Label 21680*/ GIMT_Encode4(1563031), // Rule ID 21013 //
     /* 1562954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1562957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1562965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1562968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1562971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562993 */     // MIs[0] round
     /* 1562993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562996 */     // MIs[0] policy
     /* 1562996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563006 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1563009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563030 */     // GIR_Coverage, 21013,
     /* 1563030 */     GIR_EraseRootFromParent_Done,
     /* 1563031 */   // Label 21680: @1563031
     /* 1563031 */   GIM_Try, /*On fail goto*//*Label 21681*/ GIMT_Encode4(1563113), // Rule ID 21016 //
     /* 1563036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1563047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1563050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1563053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563075 */     // MIs[0] round
     /* 1563075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563078 */     // MIs[0] policy
     /* 1563078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563088 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1563091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563112 */     // GIR_Coverage, 21016,
     /* 1563112 */     GIR_EraseRootFromParent_Done,
     /* 1563113 */   // Label 21681: @1563113
     /* 1563113 */   GIM_Try, /*On fail goto*//*Label 21682*/ GIMT_Encode4(1563195), // Rule ID 21017 //
     /* 1563118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1563129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1563132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1563135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563157 */     // MIs[0] round
     /* 1563157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563160 */     // MIs[0] policy
     /* 1563160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563170 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1563173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563194 */     // GIR_Coverage, 21017,
     /* 1563194 */     GIR_EraseRootFromParent_Done,
     /* 1563195 */   // Label 21682: @1563195
     /* 1563195 */   GIM_Try, /*On fail goto*//*Label 21683*/ GIMT_Encode4(1563277), // Rule ID 21020 //
     /* 1563200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1563203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1563211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1563214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1563217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1563220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563239 */     // MIs[0] round
     /* 1563239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563242 */     // MIs[0] policy
     /* 1563242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1563255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563276 */     // GIR_Coverage, 21020,
     /* 1563276 */     GIR_EraseRootFromParent_Done,
     /* 1563277 */   // Label 21683: @1563277
     /* 1563277 */   GIM_Try, /*On fail goto*//*Label 21684*/ GIMT_Encode4(1563359), // Rule ID 21021 //
     /* 1563282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1563285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1563293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1563296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1563299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1563302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563321 */     // MIs[0] round
     /* 1563321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563324 */     // MIs[0] policy
     /* 1563324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563334 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1563337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563343 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563358 */     // GIR_Coverage, 21021,
     /* 1563358 */     GIR_EraseRootFromParent_Done,
     /* 1563359 */   // Label 21684: @1563359
     /* 1563359 */   GIM_Try, /*On fail goto*//*Label 21685*/ GIMT_Encode4(1563441), // Rule ID 21024 //
     /* 1563364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1563367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1563375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1563378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1563381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563403 */     // MIs[0] round
     /* 1563403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563406 */     // MIs[0] policy
     /* 1563406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563416 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1563419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563440 */     // GIR_Coverage, 21024,
     /* 1563440 */     GIR_EraseRootFromParent_Done,
     /* 1563441 */   // Label 21685: @1563441
     /* 1563441 */   GIM_Try, /*On fail goto*//*Label 21686*/ GIMT_Encode4(1563523), // Rule ID 21025 //
     /* 1563446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1563449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1563457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1563460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1563463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563485 */     // MIs[0] round
     /* 1563485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563488 */     // MIs[0] policy
     /* 1563488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563498 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1563501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563522 */     // GIR_Coverage, 21025,
     /* 1563522 */     GIR_EraseRootFromParent_Done,
     /* 1563523 */   // Label 21686: @1563523
     /* 1563523 */   GIM_Try, /*On fail goto*//*Label 21687*/ GIMT_Encode4(1563605), // Rule ID 21028 //
     /* 1563528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1563539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1563542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1563545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563567 */     // MIs[0] round
     /* 1563567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563570 */     // MIs[0] policy
     /* 1563570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563580 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1563583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563604 */     // GIR_Coverage, 21028,
     /* 1563604 */     GIR_EraseRootFromParent_Done,
     /* 1563605 */   // Label 21687: @1563605
     /* 1563605 */   GIM_Try, /*On fail goto*//*Label 21688*/ GIMT_Encode4(1563687), // Rule ID 21029 //
     /* 1563610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1563621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1563624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1563627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563649 */     // MIs[0] round
     /* 1563649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563652 */     // MIs[0] policy
     /* 1563652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563662 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1563665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563686 */     // GIR_Coverage, 21029,
     /* 1563686 */     GIR_EraseRootFromParent_Done,
     /* 1563687 */   // Label 21688: @1563687
     /* 1563687 */   GIM_Try, /*On fail goto*//*Label 21689*/ GIMT_Encode4(1563769), // Rule ID 21032 //
     /* 1563692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1563703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1563706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1563709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563731 */     // MIs[0] round
     /* 1563731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563734 */     // MIs[0] policy
     /* 1563734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563744 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1563747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563768 */     // GIR_Coverage, 21032,
     /* 1563768 */     GIR_EraseRootFromParent_Done,
     /* 1563769 */   // Label 21689: @1563769
     /* 1563769 */   GIM_Try, /*On fail goto*//*Label 21690*/ GIMT_Encode4(1563851), // Rule ID 21033 //
     /* 1563774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1563785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1563788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1563791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563813 */     // MIs[0] round
     /* 1563813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563816 */     // MIs[0] policy
     /* 1563816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563826 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1563829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563850 */     // GIR_Coverage, 21033,
     /* 1563850 */     GIR_EraseRootFromParent_Done,
     /* 1563851 */   // Label 21690: @1563851
     /* 1563851 */   GIM_Try, /*On fail goto*//*Label 21691*/ GIMT_Encode4(1563933), // Rule ID 21036 //
     /* 1563856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1563867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1563870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1563873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1563876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563895 */     // MIs[0] round
     /* 1563895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563898 */     // MIs[0] policy
     /* 1563898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563908 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1563911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563932 */     // GIR_Coverage, 21036,
     /* 1563932 */     GIR_EraseRootFromParent_Done,
     /* 1563933 */   // Label 21691: @1563933
     /* 1563933 */   GIM_Try, /*On fail goto*//*Label 21692*/ GIMT_Encode4(1564015), // Rule ID 21037 //
     /* 1563938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1563949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1563952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1563955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1563958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563977 */     // MIs[0] round
     /* 1563977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563980 */     // MIs[0] policy
     /* 1563980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563990 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1563993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564014 */     // GIR_Coverage, 21037,
     /* 1564014 */     GIR_EraseRootFromParent_Done,
     /* 1564015 */   // Label 21692: @1564015
     /* 1564015 */   GIM_Try, /*On fail goto*//*Label 21693*/ GIMT_Encode4(1564097), // Rule ID 21040 //
     /* 1564020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1564031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1564034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1564037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564059 */     // MIs[0] round
     /* 1564059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564062 */     // MIs[0] policy
     /* 1564062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564072 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1564075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564096 */     // GIR_Coverage, 21040,
     /* 1564096 */     GIR_EraseRootFromParent_Done,
     /* 1564097 */   // Label 21693: @1564097
     /* 1564097 */   GIM_Try, /*On fail goto*//*Label 21694*/ GIMT_Encode4(1564179), // Rule ID 21041 //
     /* 1564102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1564113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1564116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1564119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564141 */     // MIs[0] round
     /* 1564141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564144 */     // MIs[0] policy
     /* 1564144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564154 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1564157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564178 */     // GIR_Coverage, 21041,
     /* 1564178 */     GIR_EraseRootFromParent_Done,
     /* 1564179 */   // Label 21694: @1564179
     /* 1564179 */   GIM_Try, /*On fail goto*//*Label 21695*/ GIMT_Encode4(1564261), // Rule ID 21044 //
     /* 1564184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1564195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1564198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1564201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564223 */     // MIs[0] round
     /* 1564223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564226 */     // MIs[0] policy
     /* 1564226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1564239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564260 */     // GIR_Coverage, 21044,
     /* 1564260 */     GIR_EraseRootFromParent_Done,
     /* 1564261 */   // Label 21695: @1564261
     /* 1564261 */   GIM_Try, /*On fail goto*//*Label 21696*/ GIMT_Encode4(1564343), // Rule ID 21045 //
     /* 1564266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1564277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1564280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1564283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564305 */     // MIs[0] round
     /* 1564305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564308 */     // MIs[0] policy
     /* 1564308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564318 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1564321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564342 */     // GIR_Coverage, 21045,
     /* 1564342 */     GIR_EraseRootFromParent_Done,
     /* 1564343 */   // Label 21696: @1564343
     /* 1564343 */   GIM_Try, /*On fail goto*//*Label 21697*/ GIMT_Encode4(1564425), // Rule ID 21048 //
     /* 1564348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1564359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1564362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1564365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1564368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564387 */     // MIs[0] round
     /* 1564387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564390 */     // MIs[0] policy
     /* 1564390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564400 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1564403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564424 */     // GIR_Coverage, 21048,
     /* 1564424 */     GIR_EraseRootFromParent_Done,
     /* 1564425 */   // Label 21697: @1564425
     /* 1564425 */   GIM_Try, /*On fail goto*//*Label 21698*/ GIMT_Encode4(1564507), // Rule ID 21049 //
     /* 1564430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1564441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1564444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1564447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1564450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564469 */     // MIs[0] round
     /* 1564469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564472 */     // MIs[0] policy
     /* 1564472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564482 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1564485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564506 */     // GIR_Coverage, 21049,
     /* 1564506 */     GIR_EraseRootFromParent_Done,
     /* 1564507 */   // Label 21698: @1564507
     /* 1564507 */   GIM_Try, /*On fail goto*//*Label 21699*/ GIMT_Encode4(1564589), // Rule ID 21052 //
     /* 1564512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1564523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1564526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1564529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564551 */     // MIs[0] round
     /* 1564551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564554 */     // MIs[0] policy
     /* 1564554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564564 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1564567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564588 */     // GIR_Coverage, 21052,
     /* 1564588 */     GIR_EraseRootFromParent_Done,
     /* 1564589 */   // Label 21699: @1564589
     /* 1564589 */   GIM_Try, /*On fail goto*//*Label 21700*/ GIMT_Encode4(1564671), // Rule ID 21053 //
     /* 1564594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1564605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1564608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1564611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564633 */     // MIs[0] round
     /* 1564633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564636 */     // MIs[0] policy
     /* 1564636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564646 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1564649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564670 */     // GIR_Coverage, 21053,
     /* 1564670 */     GIR_EraseRootFromParent_Done,
     /* 1564671 */   // Label 21700: @1564671
     /* 1564671 */   GIM_Try, /*On fail goto*//*Label 21701*/ GIMT_Encode4(1564753), // Rule ID 21056 //
     /* 1564676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1564687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1564690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1564693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564715 */     // MIs[0] round
     /* 1564715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564718 */     // MIs[0] policy
     /* 1564718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564728 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1564731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564752 */     // GIR_Coverage, 21056,
     /* 1564752 */     GIR_EraseRootFromParent_Done,
     /* 1564753 */   // Label 21701: @1564753
     /* 1564753 */   GIM_Try, /*On fail goto*//*Label 21702*/ GIMT_Encode4(1564835), // Rule ID 21057 //
     /* 1564758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1564769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1564772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1564775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564797 */     // MIs[0] round
     /* 1564797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564800 */     // MIs[0] policy
     /* 1564800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564810 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1564813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564834 */     // GIR_Coverage, 21057,
     /* 1564834 */     GIR_EraseRootFromParent_Done,
     /* 1564835 */   // Label 21702: @1564835
     /* 1564835 */   GIM_Try, /*On fail goto*//*Label 21703*/ GIMT_Encode4(1564917), // Rule ID 21060 //
     /* 1564840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1564851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1564854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1564857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564879 */     // MIs[0] round
     /* 1564879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564882 */     // MIs[0] policy
     /* 1564882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564892 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1564895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564916 */     // GIR_Coverage, 21060,
     /* 1564916 */     GIR_EraseRootFromParent_Done,
     /* 1564917 */   // Label 21703: @1564917
     /* 1564917 */   GIM_Try, /*On fail goto*//*Label 21704*/ GIMT_Encode4(1564999), // Rule ID 21061 //
     /* 1564922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1564933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1564936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1564939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564961 */     // MIs[0] round
     /* 1564961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564964 */     // MIs[0] policy
     /* 1564964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564974 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1564977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564998 */     // GIR_Coverage, 21061,
     /* 1564998 */     GIR_EraseRootFromParent_Done,
     /* 1564999 */   // Label 21704: @1564999
     /* 1564999 */   GIM_Try, /*On fail goto*//*Label 21705*/ GIMT_Encode4(1565081), // Rule ID 21064 //
     /* 1565004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1565015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1565018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1565021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565043 */     // MIs[0] round
     /* 1565043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565046 */     // MIs[0] policy
     /* 1565046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565056 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1565059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565080 */     // GIR_Coverage, 21064,
     /* 1565080 */     GIR_EraseRootFromParent_Done,
     /* 1565081 */   // Label 21705: @1565081
     /* 1565081 */   GIM_Try, /*On fail goto*//*Label 21706*/ GIMT_Encode4(1565163), // Rule ID 21065 //
     /* 1565086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1565097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1565100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1565103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565125 */     // MIs[0] round
     /* 1565125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565128 */     // MIs[0] policy
     /* 1565128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565138 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1565141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565162 */     // GIR_Coverage, 21065,
     /* 1565162 */     GIR_EraseRootFromParent_Done,
     /* 1565163 */   // Label 21706: @1565163
     /* 1565163 */   GIM_Try, /*On fail goto*//*Label 21707*/ GIMT_Encode4(1565245), // Rule ID 21068 //
     /* 1565168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1565179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1565182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1565185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565207 */     // MIs[0] round
     /* 1565207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565210 */     // MIs[0] policy
     /* 1565210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565220 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1565223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565244 */     // GIR_Coverage, 21068,
     /* 1565244 */     GIR_EraseRootFromParent_Done,
     /* 1565245 */   // Label 21707: @1565245
     /* 1565245 */   GIM_Try, /*On fail goto*//*Label 21708*/ GIMT_Encode4(1565327), // Rule ID 21069 //
     /* 1565250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1565261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1565264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1565267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565289 */     // MIs[0] round
     /* 1565289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565292 */     // MIs[0] policy
     /* 1565292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565302 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1565305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565326 */     // GIR_Coverage, 21069,
     /* 1565326 */     GIR_EraseRootFromParent_Done,
     /* 1565327 */   // Label 21708: @1565327
     /* 1565327 */   GIM_Try, /*On fail goto*//*Label 21709*/ GIMT_Encode4(1565409), // Rule ID 21072 //
     /* 1565332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1565335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1565343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1565346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1565349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565371 */     // MIs[0] round
     /* 1565371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565374 */     // MIs[0] policy
     /* 1565374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565384 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1565387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565408 */     // GIR_Coverage, 21072,
     /* 1565408 */     GIR_EraseRootFromParent_Done,
     /* 1565409 */   // Label 21709: @1565409
     /* 1565409 */   GIM_Try, /*On fail goto*//*Label 21710*/ GIMT_Encode4(1565491), // Rule ID 21073 //
     /* 1565414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1565417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1565425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1565428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1565431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565453 */     // MIs[0] round
     /* 1565453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565456 */     // MIs[0] policy
     /* 1565456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565466 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1565469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565490 */     // GIR_Coverage, 21073,
     /* 1565490 */     GIR_EraseRootFromParent_Done,
     /* 1565491 */   // Label 21710: @1565491
     /* 1565491 */   GIM_Try, /*On fail goto*//*Label 21711*/ GIMT_Encode4(1565573), // Rule ID 21076 //
     /* 1565496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1565507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1565510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1565513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565535 */     // MIs[0] round
     /* 1565535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565538 */     // MIs[0] policy
     /* 1565538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565548 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1565551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565572 */     // GIR_Coverage, 21076,
     /* 1565572 */     GIR_EraseRootFromParent_Done,
     /* 1565573 */   // Label 21711: @1565573
     /* 1565573 */   GIM_Try, /*On fail goto*//*Label 21712*/ GIMT_Encode4(1565655), // Rule ID 21077 //
     /* 1565578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1565589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1565592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1565595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565617 */     // MIs[0] round
     /* 1565617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565620 */     // MIs[0] policy
     /* 1565620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565630 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1565633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565654 */     // GIR_Coverage, 21077,
     /* 1565654 */     GIR_EraseRootFromParent_Done,
     /* 1565655 */   // Label 21712: @1565655
     /* 1565655 */   GIM_Try, /*On fail goto*//*Label 21713*/ GIMT_Encode4(1565737), // Rule ID 21080 //
     /* 1565660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1565663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1565677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565699 */     // MIs[0] round
     /* 1565699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565702 */     // MIs[0] policy
     /* 1565702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565712 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1565715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565736 */     // GIR_Coverage, 21080,
     /* 1565736 */     GIR_EraseRootFromParent_Done,
     /* 1565737 */   // Label 21713: @1565737
     /* 1565737 */   GIM_Try, /*On fail goto*//*Label 21714*/ GIMT_Encode4(1565819), // Rule ID 21081 //
     /* 1565742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1565745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1565759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565781 */     // MIs[0] round
     /* 1565781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565784 */     // MIs[0] policy
     /* 1565784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565794 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1565797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565803 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565818 */     // GIR_Coverage, 21081,
     /* 1565818 */     GIR_EraseRootFromParent_Done,
     /* 1565819 */   // Label 21714: @1565819
     /* 1565819 */   GIM_Try, /*On fail goto*//*Label 21715*/ GIMT_Encode4(1565901), // Rule ID 21084 //
     /* 1565824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1565827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1565835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1565838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1565841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565863 */     // MIs[0] round
     /* 1565863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565866 */     // MIs[0] policy
     /* 1565866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565876 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1565879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565885 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565900 */     // GIR_Coverage, 21084,
     /* 1565900 */     GIR_EraseRootFromParent_Done,
     /* 1565901 */   // Label 21715: @1565901
     /* 1565901 */   GIM_Try, /*On fail goto*//*Label 21716*/ GIMT_Encode4(1565983), // Rule ID 21085 //
     /* 1565906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1565909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1565917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1565920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1565923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565945 */     // MIs[0] round
     /* 1565945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565948 */     // MIs[0] policy
     /* 1565948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565958 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1565961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565982 */     // GIR_Coverage, 21085,
     /* 1565982 */     GIR_EraseRootFromParent_Done,
     /* 1565983 */   // Label 21716: @1565983
     /* 1565983 */   GIM_Try, /*On fail goto*//*Label 21717*/ GIMT_Encode4(1566065), // Rule ID 21088 //
     /* 1565988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1565999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1566002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1566005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566027 */     // MIs[0] round
     /* 1566027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566030 */     // MIs[0] policy
     /* 1566030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566040 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1566043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566064 */     // GIR_Coverage, 21088,
     /* 1566064 */     GIR_EraseRootFromParent_Done,
     /* 1566065 */   // Label 21717: @1566065
     /* 1566065 */   GIM_Try, /*On fail goto*//*Label 21718*/ GIMT_Encode4(1566147), // Rule ID 21089 //
     /* 1566070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1566081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1566084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1566087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566109 */     // MIs[0] round
     /* 1566109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566112 */     // MIs[0] policy
     /* 1566112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566122 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1566125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566131 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566146 */     // GIR_Coverage, 21089,
     /* 1566146 */     GIR_EraseRootFromParent_Done,
     /* 1566147 */   // Label 21718: @1566147
     /* 1566147 */   GIM_Try, /*On fail goto*//*Label 21719*/ GIMT_Encode4(1566229), // Rule ID 21092 //
     /* 1566152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1566163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1566166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1566169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566191 */     // MIs[0] round
     /* 1566191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566194 */     // MIs[0] policy
     /* 1566194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566204 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1566207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566228 */     // GIR_Coverage, 21092,
     /* 1566228 */     GIR_EraseRootFromParent_Done,
     /* 1566229 */   // Label 21719: @1566229
     /* 1566229 */   GIM_Try, /*On fail goto*//*Label 21720*/ GIMT_Encode4(1566311), // Rule ID 21093 //
     /* 1566234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1566245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1566248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1566251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566273 */     // MIs[0] round
     /* 1566273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566276 */     // MIs[0] policy
     /* 1566276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566286 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1566289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566310 */     // GIR_Coverage, 21093,
     /* 1566310 */     GIR_EraseRootFromParent_Done,
     /* 1566311 */   // Label 21720: @1566311
     /* 1566311 */   GIM_Try, /*On fail goto*//*Label 21721*/ GIMT_Encode4(1566393), // Rule ID 21096 //
     /* 1566316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1566327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1566330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1566333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1566336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566355 */     // MIs[0] round
     /* 1566355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566358 */     // MIs[0] policy
     /* 1566358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566368 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1566371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566392 */     // GIR_Coverage, 21096,
     /* 1566392 */     GIR_EraseRootFromParent_Done,
     /* 1566393 */   // Label 21721: @1566393
     /* 1566393 */   GIM_Try, /*On fail goto*//*Label 21722*/ GIMT_Encode4(1566475), // Rule ID 21097 //
     /* 1566398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1566409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1566412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1566415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1566418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566437 */     // MIs[0] round
     /* 1566437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566440 */     // MIs[0] policy
     /* 1566440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566450 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1566453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566474 */     // GIR_Coverage, 21097,
     /* 1566474 */     GIR_EraseRootFromParent_Done,
     /* 1566475 */   // Label 21722: @1566475
     /* 1566475 */   GIM_Try, /*On fail goto*//*Label 21723*/ GIMT_Encode4(1566557), // Rule ID 21100 //
     /* 1566480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1566491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1566494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1566497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566519 */     // MIs[0] round
     /* 1566519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566522 */     // MIs[0] policy
     /* 1566522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566532 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1566535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566556 */     // GIR_Coverage, 21100,
     /* 1566556 */     GIR_EraseRootFromParent_Done,
     /* 1566557 */   // Label 21723: @1566557
     /* 1566557 */   GIM_Try, /*On fail goto*//*Label 21724*/ GIMT_Encode4(1566639), // Rule ID 21101 //
     /* 1566562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1566573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1566576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1566579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566601 */     // MIs[0] round
     /* 1566601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566604 */     // MIs[0] policy
     /* 1566604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566614 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1566617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566638 */     // GIR_Coverage, 21101,
     /* 1566638 */     GIR_EraseRootFromParent_Done,
     /* 1566639 */   // Label 21724: @1566639
     /* 1566639 */   GIM_Try, /*On fail goto*//*Label 21725*/ GIMT_Encode4(1566721), // Rule ID 21104 //
     /* 1566644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1566655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1566658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1566661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566683 */     // MIs[0] round
     /* 1566683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566686 */     // MIs[0] policy
     /* 1566686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566696 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1566699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566720 */     // GIR_Coverage, 21104,
     /* 1566720 */     GIR_EraseRootFromParent_Done,
     /* 1566721 */   // Label 21725: @1566721
     /* 1566721 */   GIM_Try, /*On fail goto*//*Label 21726*/ GIMT_Encode4(1566803), // Rule ID 21105 //
     /* 1566726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1566737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1566740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1566743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566765 */     // MIs[0] round
     /* 1566765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566768 */     // MIs[0] policy
     /* 1566768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566778 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1566781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566802 */     // GIR_Coverage, 21105,
     /* 1566802 */     GIR_EraseRootFromParent_Done,
     /* 1566803 */   // Label 21726: @1566803
     /* 1566803 */   GIM_Try, /*On fail goto*//*Label 21727*/ GIMT_Encode4(1566885), // Rule ID 21108 //
     /* 1566808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1566819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1566822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1566825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566847 */     // MIs[0] round
     /* 1566847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566850 */     // MIs[0] policy
     /* 1566850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566860 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1566863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566884 */     // GIR_Coverage, 21108,
     /* 1566884 */     GIR_EraseRootFromParent_Done,
     /* 1566885 */   // Label 21727: @1566885
     /* 1566885 */   GIM_Try, /*On fail goto*//*Label 21728*/ GIMT_Encode4(1566967), // Rule ID 21109 //
     /* 1566890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1566901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1566904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1566907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566929 */     // MIs[0] round
     /* 1566929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566932 */     // MIs[0] policy
     /* 1566932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566942 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1566945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566966 */     // GIR_Coverage, 21109,
     /* 1566966 */     GIR_EraseRootFromParent_Done,
     /* 1566967 */   // Label 21728: @1566967
     /* 1566967 */   GIM_Try, /*On fail goto*//*Label 21729*/ GIMT_Encode4(1567049), // Rule ID 21112 //
     /* 1566972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1566975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1566983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1566986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1566989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567011 */     // MIs[0] round
     /* 1567011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567014 */     // MIs[0] policy
     /* 1567014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567024 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1567027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567048 */     // GIR_Coverage, 21112,
     /* 1567048 */     GIR_EraseRootFromParent_Done,
     /* 1567049 */   // Label 21729: @1567049
     /* 1567049 */   GIM_Try, /*On fail goto*//*Label 21730*/ GIMT_Encode4(1567131), // Rule ID 21113 //
     /* 1567054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1567057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1567062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1567065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1567068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1567071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567093 */     // MIs[0] round
     /* 1567093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567096 */     // MIs[0] policy
     /* 1567096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567106 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1567109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567130 */     // GIR_Coverage, 21113,
     /* 1567130 */     GIR_EraseRootFromParent_Done,
     /* 1567131 */   // Label 21730: @1567131
     /* 1567131 */   GIM_Try, /*On fail goto*//*Label 21731*/ GIMT_Encode4(1567213), // Rule ID 21116 //
     /* 1567136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1567139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1567144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1567147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1567150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1567153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567175 */     // MIs[0] round
     /* 1567175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567178 */     // MIs[0] policy
     /* 1567178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567188 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1567191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567212 */     // GIR_Coverage, 21116,
     /* 1567212 */     GIR_EraseRootFromParent_Done,
     /* 1567213 */   // Label 21731: @1567213
     /* 1567213 */   GIM_Try, /*On fail goto*//*Label 21732*/ GIMT_Encode4(1567295), // Rule ID 21117 //
     /* 1567218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1567221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1567226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1567229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1567232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1567235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567257 */     // MIs[0] round
     /* 1567257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567260 */     // MIs[0] policy
     /* 1567260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567270 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1567273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567294 */     // GIR_Coverage, 21117,
     /* 1567294 */     GIR_EraseRootFromParent_Done,
     /* 1567295 */   // Label 21732: @1567295
     /* 1567295 */   GIM_Try, /*On fail goto*//*Label 21733*/ GIMT_Encode4(1567377), // Rule ID 21120 //
     /* 1567300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1567303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1567308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1567311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1567314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1567317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567339 */     // MIs[0] round
     /* 1567339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567342 */     // MIs[0] policy
     /* 1567342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567352 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1567355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567376 */     // GIR_Coverage, 21120,
     /* 1567376 */     GIR_EraseRootFromParent_Done,
     /* 1567377 */   // Label 21733: @1567377
     /* 1567377 */   GIM_Try, /*On fail goto*//*Label 21734*/ GIMT_Encode4(1567459), // Rule ID 21121 //
     /* 1567382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1567385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1567390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1567393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1567396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1567399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567421 */     // MIs[0] round
     /* 1567421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567424 */     // MIs[0] policy
     /* 1567424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567434 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1567437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567458 */     // GIR_Coverage, 21121,
     /* 1567458 */     GIR_EraseRootFromParent_Done,
     /* 1567459 */   // Label 21734: @1567459
     /* 1567459 */   GIM_Try, /*On fail goto*//*Label 21735*/ GIMT_Encode4(1567541), // Rule ID 21196 //
     /* 1567464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1567475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1567478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1567481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567503 */     // MIs[0] round
     /* 1567503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567506 */     // MIs[0] policy
     /* 1567506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567516 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1567519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567540 */     // GIR_Coverage, 21196,
     /* 1567540 */     GIR_EraseRootFromParent_Done,
     /* 1567541 */   // Label 21735: @1567541
     /* 1567541 */   GIM_Try, /*On fail goto*//*Label 21736*/ GIMT_Encode4(1567623), // Rule ID 21197 //
     /* 1567546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1567557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1567560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1567563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567585 */     // MIs[0] round
     /* 1567585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567588 */     // MIs[0] policy
     /* 1567588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567598 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1567601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567622 */     // GIR_Coverage, 21197,
     /* 1567622 */     GIR_EraseRootFromParent_Done,
     /* 1567623 */   // Label 21736: @1567623
     /* 1567623 */   GIM_Try, /*On fail goto*//*Label 21737*/ GIMT_Encode4(1567705), // Rule ID 21200 //
     /* 1567628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1567639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1567642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1567645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567667 */     // MIs[0] round
     /* 1567667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567670 */     // MIs[0] policy
     /* 1567670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567680 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1567683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567704 */     // GIR_Coverage, 21200,
     /* 1567704 */     GIR_EraseRootFromParent_Done,
     /* 1567705 */   // Label 21737: @1567705
     /* 1567705 */   GIM_Try, /*On fail goto*//*Label 21738*/ GIMT_Encode4(1567787), // Rule ID 21201 //
     /* 1567710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1567721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1567724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1567727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567749 */     // MIs[0] round
     /* 1567749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567752 */     // MIs[0] policy
     /* 1567752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567762 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1567765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567786 */     // GIR_Coverage, 21201,
     /* 1567786 */     GIR_EraseRootFromParent_Done,
     /* 1567787 */   // Label 21738: @1567787
     /* 1567787 */   GIM_Try, /*On fail goto*//*Label 21739*/ GIMT_Encode4(1567869), // Rule ID 21204 //
     /* 1567792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1567803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1567806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1567809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567831 */     // MIs[0] round
     /* 1567831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567834 */     // MIs[0] policy
     /* 1567834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1567847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567868 */     // GIR_Coverage, 21204,
     /* 1567868 */     GIR_EraseRootFromParent_Done,
     /* 1567869 */   // Label 21739: @1567869
     /* 1567869 */   GIM_Try, /*On fail goto*//*Label 21740*/ GIMT_Encode4(1567951), // Rule ID 21205 //
     /* 1567874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1567885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1567888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1567891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567913 */     // MIs[0] round
     /* 1567913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567916 */     // MIs[0] policy
     /* 1567916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1567929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567950 */     // GIR_Coverage, 21205,
     /* 1567950 */     GIR_EraseRootFromParent_Done,
     /* 1567951 */   // Label 21740: @1567951
     /* 1567951 */   GIM_Try, /*On fail goto*//*Label 21741*/ GIMT_Encode4(1568033), // Rule ID 21208 //
     /* 1567956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1567967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1567970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1567973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567995 */     // MIs[0] round
     /* 1567995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567998 */     // MIs[0] policy
     /* 1567998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568008 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1568011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568032 */     // GIR_Coverage, 21208,
     /* 1568032 */     GIR_EraseRootFromParent_Done,
     /* 1568033 */   // Label 21741: @1568033
     /* 1568033 */   GIM_Try, /*On fail goto*//*Label 21742*/ GIMT_Encode4(1568115), // Rule ID 21209 //
     /* 1568038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1568049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1568052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1568055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568077 */     // MIs[0] round
     /* 1568077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568080 */     // MIs[0] policy
     /* 1568080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1568093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568114 */     // GIR_Coverage, 21209,
     /* 1568114 */     GIR_EraseRootFromParent_Done,
     /* 1568115 */   // Label 21742: @1568115
     /* 1568115 */   GIM_Try, /*On fail goto*//*Label 21743*/ GIMT_Encode4(1568197), // Rule ID 21212 //
     /* 1568120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1568131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1568134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1568137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1568140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568159 */     // MIs[0] round
     /* 1568159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568162 */     // MIs[0] policy
     /* 1568162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568172 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1568175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568196 */     // GIR_Coverage, 21212,
     /* 1568196 */     GIR_EraseRootFromParent_Done,
     /* 1568197 */   // Label 21743: @1568197
     /* 1568197 */   GIM_Try, /*On fail goto*//*Label 21744*/ GIMT_Encode4(1568279), // Rule ID 21213 //
     /* 1568202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1568213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1568216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1568219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1568222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568241 */     // MIs[0] round
     /* 1568241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568244 */     // MIs[0] policy
     /* 1568244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1568257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568278 */     // GIR_Coverage, 21213,
     /* 1568278 */     GIR_EraseRootFromParent_Done,
     /* 1568279 */   // Label 21744: @1568279
     /* 1568279 */   GIM_Try, /*On fail goto*//*Label 21745*/ GIMT_Encode4(1568361), // Rule ID 21216 //
     /* 1568284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1568287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1568295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1568298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1568301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568323 */     // MIs[0] round
     /* 1568323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568326 */     // MIs[0] policy
     /* 1568326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1568339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568360 */     // GIR_Coverage, 21216,
     /* 1568360 */     GIR_EraseRootFromParent_Done,
     /* 1568361 */   // Label 21745: @1568361
     /* 1568361 */   GIM_Try, /*On fail goto*//*Label 21746*/ GIMT_Encode4(1568443), // Rule ID 21217 //
     /* 1568366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1568377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1568380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1568383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568405 */     // MIs[0] round
     /* 1568405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568408 */     // MIs[0] policy
     /* 1568408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568418 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1568421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568442 */     // GIR_Coverage, 21217,
     /* 1568442 */     GIR_EraseRootFromParent_Done,
     /* 1568443 */   // Label 21746: @1568443
     /* 1568443 */   GIM_Try, /*On fail goto*//*Label 21747*/ GIMT_Encode4(1568525), // Rule ID 21220 //
     /* 1568448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1568451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1568459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1568462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1568465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568487 */     // MIs[0] round
     /* 1568487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568490 */     // MIs[0] policy
     /* 1568490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568500 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1568503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568524 */     // GIR_Coverage, 21220,
     /* 1568524 */     GIR_EraseRootFromParent_Done,
     /* 1568525 */   // Label 21747: @1568525
     /* 1568525 */   GIM_Try, /*On fail goto*//*Label 21748*/ GIMT_Encode4(1568607), // Rule ID 21221 //
     /* 1568530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1568541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1568544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1568547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568569 */     // MIs[0] round
     /* 1568569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568572 */     // MIs[0] policy
     /* 1568572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568582 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1568585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568606 */     // GIR_Coverage, 21221,
     /* 1568606 */     GIR_EraseRootFromParent_Done,
     /* 1568607 */   // Label 21748: @1568607
     /* 1568607 */   GIM_Try, /*On fail goto*//*Label 21749*/ GIMT_Encode4(1568689), // Rule ID 21224 //
     /* 1568612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1568615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1568623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1568626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1568629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568651 */     // MIs[0] round
     /* 1568651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568654 */     // MIs[0] policy
     /* 1568654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1568667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568688 */     // GIR_Coverage, 21224,
     /* 1568688 */     GIR_EraseRootFromParent_Done,
     /* 1568689 */   // Label 21749: @1568689
     /* 1568689 */   GIM_Try, /*On fail goto*//*Label 21750*/ GIMT_Encode4(1568771), // Rule ID 21225 //
     /* 1568694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1568705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1568708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1568711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568733 */     // MIs[0] round
     /* 1568733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568736 */     // MIs[0] policy
     /* 1568736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568746 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1568749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568770 */     // GIR_Coverage, 21225,
     /* 1568770 */     GIR_EraseRootFromParent_Done,
     /* 1568771 */   // Label 21750: @1568771
     /* 1568771 */   GIM_Try, /*On fail goto*//*Label 21751*/ GIMT_Encode4(1568853), // Rule ID 21228 //
     /* 1568776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1568779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1568787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1568790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1568793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568815 */     // MIs[0] round
     /* 1568815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568818 */     // MIs[0] policy
     /* 1568818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568828 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1568831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568852 */     // GIR_Coverage, 21228,
     /* 1568852 */     GIR_EraseRootFromParent_Done,
     /* 1568853 */   // Label 21751: @1568853
     /* 1568853 */   GIM_Try, /*On fail goto*//*Label 21752*/ GIMT_Encode4(1568935), // Rule ID 21229 //
     /* 1568858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1568869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1568872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1568875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568897 */     // MIs[0] round
     /* 1568897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568900 */     // MIs[0] policy
     /* 1568900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568910 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1568913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568934 */     // GIR_Coverage, 21229,
     /* 1568934 */     GIR_EraseRootFromParent_Done,
     /* 1568935 */   // Label 21752: @1568935
     /* 1568935 */   GIM_Try, /*On fail goto*//*Label 21753*/ GIMT_Encode4(1569017), // Rule ID 21232 //
     /* 1568940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1568951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1568954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1568957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568979 */     // MIs[0] round
     /* 1568979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568982 */     // MIs[0] policy
     /* 1568982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568992 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1568995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569016 */     // GIR_Coverage, 21232,
     /* 1569016 */     GIR_EraseRootFromParent_Done,
     /* 1569017 */   // Label 21753: @1569017
     /* 1569017 */   GIM_Try, /*On fail goto*//*Label 21754*/ GIMT_Encode4(1569099), // Rule ID 21233 //
     /* 1569022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1569033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1569036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1569039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569061 */     // MIs[0] round
     /* 1569061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569064 */     // MIs[0] policy
     /* 1569064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1569077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569098 */     // GIR_Coverage, 21233,
     /* 1569098 */     GIR_EraseRootFromParent_Done,
     /* 1569099 */   // Label 21754: @1569099
     /* 1569099 */   GIM_Try, /*On fail goto*//*Label 21755*/ GIMT_Encode4(1569181), // Rule ID 21236 //
     /* 1569104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1569115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1569118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1569121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569143 */     // MIs[0] round
     /* 1569143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569146 */     // MIs[0] policy
     /* 1569146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1569159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569180 */     // GIR_Coverage, 21236,
     /* 1569180 */     GIR_EraseRootFromParent_Done,
     /* 1569181 */   // Label 21755: @1569181
     /* 1569181 */   GIM_Try, /*On fail goto*//*Label 21756*/ GIMT_Encode4(1569263), // Rule ID 21237 //
     /* 1569186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1569197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1569200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1569203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569225 */     // MIs[0] round
     /* 1569225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569228 */     // MIs[0] policy
     /* 1569228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569238 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1569241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569262 */     // GIR_Coverage, 21237,
     /* 1569262 */     GIR_EraseRootFromParent_Done,
     /* 1569263 */   // Label 21756: @1569263
     /* 1569263 */   GIM_Try, /*On fail goto*//*Label 21757*/ GIMT_Encode4(1569345), // Rule ID 21240 //
     /* 1569268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1569279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1569282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1569285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569307 */     // MIs[0] round
     /* 1569307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569310 */     // MIs[0] policy
     /* 1569310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569320 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1569323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569344 */     // GIR_Coverage, 21240,
     /* 1569344 */     GIR_EraseRootFromParent_Done,
     /* 1569345 */   // Label 21757: @1569345
     /* 1569345 */   GIM_Try, /*On fail goto*//*Label 21758*/ GIMT_Encode4(1569427), // Rule ID 21241 //
     /* 1569350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1569361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1569364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1569367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569389 */     // MIs[0] round
     /* 1569389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569392 */     // MIs[0] policy
     /* 1569392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1569405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569426 */     // GIR_Coverage, 21241,
     /* 1569426 */     GIR_EraseRootFromParent_Done,
     /* 1569427 */   // Label 21758: @1569427
     /* 1569427 */   GIM_Try, /*On fail goto*//*Label 21759*/ GIMT_Encode4(1569509), // Rule ID 21244 //
     /* 1569432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1569443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1569446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1569449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569471 */     // MIs[0] round
     /* 1569471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569474 */     // MIs[0] policy
     /* 1569474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1569487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569493 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569508 */     // GIR_Coverage, 21244,
     /* 1569508 */     GIR_EraseRootFromParent_Done,
     /* 1569509 */   // Label 21759: @1569509
     /* 1569509 */   GIM_Try, /*On fail goto*//*Label 21760*/ GIMT_Encode4(1569591), // Rule ID 21245 //
     /* 1569514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1569525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1569528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1569531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569553 */     // MIs[0] round
     /* 1569553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569556 */     // MIs[0] policy
     /* 1569556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569566 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1569569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569590 */     // GIR_Coverage, 21245,
     /* 1569590 */     GIR_EraseRootFromParent_Done,
     /* 1569591 */   // Label 21760: @1569591
     /* 1569591 */   GIM_Try, /*On fail goto*//*Label 21761*/ GIMT_Encode4(1569673), // Rule ID 21248 //
     /* 1569596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1569607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1569610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1569613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569635 */     // MIs[0] round
     /* 1569635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569638 */     // MIs[0] policy
     /* 1569638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569648 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1569651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569672 */     // GIR_Coverage, 21248,
     /* 1569672 */     GIR_EraseRootFromParent_Done,
     /* 1569673 */   // Label 21761: @1569673
     /* 1569673 */   GIM_Try, /*On fail goto*//*Label 21762*/ GIMT_Encode4(1569755), // Rule ID 21249 //
     /* 1569678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1569689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1569692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1569695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569717 */     // MIs[0] round
     /* 1569717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569720 */     // MIs[0] policy
     /* 1569720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569730 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1569733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569754 */     // GIR_Coverage, 21249,
     /* 1569754 */     GIR_EraseRootFromParent_Done,
     /* 1569755 */   // Label 21762: @1569755
     /* 1569755 */   GIM_Try, /*On fail goto*//*Label 21763*/ GIMT_Encode4(1569837), // Rule ID 21252 //
     /* 1569760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1569771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1569774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1569777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569799 */     // MIs[0] round
     /* 1569799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569802 */     // MIs[0] policy
     /* 1569802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569812 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1569815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569836 */     // GIR_Coverage, 21252,
     /* 1569836 */     GIR_EraseRootFromParent_Done,
     /* 1569837 */   // Label 21763: @1569837
     /* 1569837 */   GIM_Try, /*On fail goto*//*Label 21764*/ GIMT_Encode4(1569919), // Rule ID 21253 //
     /* 1569842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1569853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1569856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1569859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569881 */     // MIs[0] round
     /* 1569881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569884 */     // MIs[0] policy
     /* 1569884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569894 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1569897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569918 */     // GIR_Coverage, 21253,
     /* 1569918 */     GIR_EraseRootFromParent_Done,
     /* 1569919 */   // Label 21764: @1569919
     /* 1569919 */   GIM_Try, /*On fail goto*//*Label 21765*/ GIMT_Encode4(1570001), // Rule ID 21256 //
     /* 1569924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1569935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1569938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1569941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569963 */     // MIs[0] round
     /* 1569963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569966 */     // MIs[0] policy
     /* 1569966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1569979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570000 */     // GIR_Coverage, 21256,
     /* 1570000 */     GIR_EraseRootFromParent_Done,
     /* 1570001 */   // Label 21765: @1570001
     /* 1570001 */   GIM_Try, /*On fail goto*//*Label 21766*/ GIMT_Encode4(1570083), // Rule ID 21257 //
     /* 1570006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1570009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1570014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1570017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1570020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1570023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570045 */     // MIs[0] round
     /* 1570045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570048 */     // MIs[0] policy
     /* 1570048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570058 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1570061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570082 */     // GIR_Coverage, 21257,
     /* 1570082 */     GIR_EraseRootFromParent_Done,
     /* 1570083 */   // Label 21766: @1570083
     /* 1570083 */   GIM_Try, /*On fail goto*//*Label 21767*/ GIMT_Encode4(1570165), // Rule ID 21260 //
     /* 1570088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1570091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1570096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1570099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1570102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1570105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570127 */     // MIs[0] round
     /* 1570127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570130 */     // MIs[0] policy
     /* 1570130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570140 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1570143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570164 */     // GIR_Coverage, 21260,
     /* 1570164 */     GIR_EraseRootFromParent_Done,
     /* 1570165 */   // Label 21767: @1570165
     /* 1570165 */   GIM_Try, /*On fail goto*//*Label 21768*/ GIMT_Encode4(1570247), // Rule ID 21261 //
     /* 1570170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1570173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1570178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1570181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1570184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1570187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570209 */     // MIs[0] round
     /* 1570209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570212 */     // MIs[0] policy
     /* 1570212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570222 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1570225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570246 */     // GIR_Coverage, 21261,
     /* 1570246 */     GIR_EraseRootFromParent_Done,
     /* 1570247 */   // Label 21768: @1570247
     /* 1570247 */   GIM_Try, /*On fail goto*//*Label 21769*/ GIMT_Encode4(1570329), // Rule ID 21264 //
     /* 1570252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1570255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1570260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1570263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1570266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1570269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1570279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570291 */     // MIs[0] round
     /* 1570291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570294 */     // MIs[0] policy
     /* 1570294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570304 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1570307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570328 */     // GIR_Coverage, 21264,
     /* 1570328 */     GIR_EraseRootFromParent_Done,
     /* 1570329 */   // Label 21769: @1570329
     /* 1570329 */   GIM_Try, /*On fail goto*//*Label 21770*/ GIMT_Encode4(1570411), // Rule ID 21265 //
     /* 1570334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1570337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1570342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1570345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1570348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1570351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1570361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570373 */     // MIs[0] round
     /* 1570373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570376 */     // MIs[0] policy
     /* 1570376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1570389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570410 */     // GIR_Coverage, 21265,
     /* 1570410 */     GIR_EraseRootFromParent_Done,
     /* 1570411 */   // Label 21770: @1570411
     /* 1570411 */   GIM_Try, /*On fail goto*//*Label 21771*/ GIMT_Encode4(1570493), // Rule ID 21616 //
     /* 1570416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1570427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1570430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1570433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570455 */     // MIs[0] round
     /* 1570455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570458 */     // MIs[0] policy
     /* 1570458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570468 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1570471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570492 */     // GIR_Coverage, 21616,
     /* 1570492 */     GIR_EraseRootFromParent_Done,
     /* 1570493 */   // Label 21771: @1570493
     /* 1570493 */   GIM_Try, /*On fail goto*//*Label 21772*/ GIMT_Encode4(1570575), // Rule ID 21617 //
     /* 1570498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1570509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1570512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1570515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570537 */     // MIs[0] round
     /* 1570537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570540 */     // MIs[0] policy
     /* 1570540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570550 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1570553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570574 */     // GIR_Coverage, 21617,
     /* 1570574 */     GIR_EraseRootFromParent_Done,
     /* 1570575 */   // Label 21772: @1570575
     /* 1570575 */   GIM_Try, /*On fail goto*//*Label 21773*/ GIMT_Encode4(1570657), // Rule ID 21620 //
     /* 1570580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1570591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1570594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1570597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570619 */     // MIs[0] round
     /* 1570619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570622 */     // MIs[0] policy
     /* 1570622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570632 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1570635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570656 */     // GIR_Coverage, 21620,
     /* 1570656 */     GIR_EraseRootFromParent_Done,
     /* 1570657 */   // Label 21773: @1570657
     /* 1570657 */   GIM_Try, /*On fail goto*//*Label 21774*/ GIMT_Encode4(1570739), // Rule ID 21621 //
     /* 1570662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1570673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1570676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1570679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570701 */     // MIs[0] round
     /* 1570701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570704 */     // MIs[0] policy
     /* 1570704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570714 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1570717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570723 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570738 */     // GIR_Coverage, 21621,
     /* 1570738 */     GIR_EraseRootFromParent_Done,
     /* 1570739 */   // Label 21774: @1570739
     /* 1570739 */   GIM_Try, /*On fail goto*//*Label 21775*/ GIMT_Encode4(1570821), // Rule ID 21624 //
     /* 1570744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1570755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1570758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1570761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570783 */     // MIs[0] round
     /* 1570783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570786 */     // MIs[0] policy
     /* 1570786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1570799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570820 */     // GIR_Coverage, 21624,
     /* 1570820 */     GIR_EraseRootFromParent_Done,
     /* 1570821 */   // Label 21775: @1570821
     /* 1570821 */   GIM_Try, /*On fail goto*//*Label 21776*/ GIMT_Encode4(1570903), // Rule ID 21625 //
     /* 1570826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1570837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1570840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1570843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570865 */     // MIs[0] round
     /* 1570865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570868 */     // MIs[0] policy
     /* 1570868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570878 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1570881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570887 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570902 */     // GIR_Coverage, 21625,
     /* 1570902 */     GIR_EraseRootFromParent_Done,
     /* 1570903 */   // Label 21776: @1570903
     /* 1570903 */   GIM_Try, /*On fail goto*//*Label 21777*/ GIMT_Encode4(1570985), // Rule ID 21628 //
     /* 1570908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1570919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1570922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1570925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570947 */     // MIs[0] round
     /* 1570947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570950 */     // MIs[0] policy
     /* 1570950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570960 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1570963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570984 */     // GIR_Coverage, 21628,
     /* 1570984 */     GIR_EraseRootFromParent_Done,
     /* 1570985 */   // Label 21777: @1570985
     /* 1570985 */   GIM_Try, /*On fail goto*//*Label 21778*/ GIMT_Encode4(1571067), // Rule ID 21629 //
     /* 1570990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1571001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1571004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1571007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571029 */     // MIs[0] round
     /* 1571029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571032 */     // MIs[0] policy
     /* 1571032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571042 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1571045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571066 */     // GIR_Coverage, 21629,
     /* 1571066 */     GIR_EraseRootFromParent_Done,
     /* 1571067 */   // Label 21778: @1571067
     /* 1571067 */   GIM_Try, /*On fail goto*//*Label 21779*/ GIMT_Encode4(1571149), // Rule ID 21632 //
     /* 1571072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1571075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1571083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1571086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1571089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1571092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571111 */     // MIs[0] round
     /* 1571111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571114 */     // MIs[0] policy
     /* 1571114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571124 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1571127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571148 */     // GIR_Coverage, 21632,
     /* 1571148 */     GIR_EraseRootFromParent_Done,
     /* 1571149 */   // Label 21779: @1571149
     /* 1571149 */   GIM_Try, /*On fail goto*//*Label 21780*/ GIMT_Encode4(1571231), // Rule ID 21633 //
     /* 1571154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1571157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1571165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1571168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1571171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1571174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571193 */     // MIs[0] round
     /* 1571193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571196 */     // MIs[0] policy
     /* 1571196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571206 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1571209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571230 */     // GIR_Coverage, 21633,
     /* 1571230 */     GIR_EraseRootFromParent_Done,
     /* 1571231 */   // Label 21780: @1571231
     /* 1571231 */   GIM_Try, /*On fail goto*//*Label 21781*/ GIMT_Encode4(1571313), // Rule ID 21636 //
     /* 1571236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1571239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1571247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1571250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1571253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1571256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571275 */     // MIs[0] round
     /* 1571275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571278 */     // MIs[0] policy
     /* 1571278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571288 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1571291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571312 */     // GIR_Coverage, 21636,
     /* 1571312 */     GIR_EraseRootFromParent_Done,
     /* 1571313 */   // Label 21781: @1571313
     /* 1571313 */   GIM_Try, /*On fail goto*//*Label 21782*/ GIMT_Encode4(1571395), // Rule ID 21637 //
     /* 1571318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1571321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1571329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1571332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1571335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1571338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571357 */     // MIs[0] round
     /* 1571357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571360 */     // MIs[0] policy
     /* 1571360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571370 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1571373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571394 */     // GIR_Coverage, 21637,
     /* 1571394 */     GIR_EraseRootFromParent_Done,
     /* 1571395 */   // Label 21782: @1571395
     /* 1571395 */   GIM_Try, /*On fail goto*//*Label 21783*/ GIMT_Encode4(1571477), // Rule ID 21640 //
     /* 1571400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1571411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1571414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1571417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571439 */     // MIs[0] round
     /* 1571439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571442 */     // MIs[0] policy
     /* 1571442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571452 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1571455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571476 */     // GIR_Coverage, 21640,
     /* 1571476 */     GIR_EraseRootFromParent_Done,
     /* 1571477 */   // Label 21783: @1571477
     /* 1571477 */   GIM_Try, /*On fail goto*//*Label 21784*/ GIMT_Encode4(1571559), // Rule ID 21641 //
     /* 1571482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1571493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1571496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1571499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571521 */     // MIs[0] round
     /* 1571521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571524 */     // MIs[0] policy
     /* 1571524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1571537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571558 */     // GIR_Coverage, 21641,
     /* 1571558 */     GIR_EraseRootFromParent_Done,
     /* 1571559 */   // Label 21784: @1571559
     /* 1571559 */   GIM_Try, /*On fail goto*//*Label 21785*/ GIMT_Encode4(1571641), // Rule ID 21644 //
     /* 1571564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1571575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1571578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1571581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571603 */     // MIs[0] round
     /* 1571603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571606 */     // MIs[0] policy
     /* 1571606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571616 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1571619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571640 */     // GIR_Coverage, 21644,
     /* 1571640 */     GIR_EraseRootFromParent_Done,
     /* 1571641 */   // Label 21785: @1571641
     /* 1571641 */   GIM_Try, /*On fail goto*//*Label 21786*/ GIMT_Encode4(1571723), // Rule ID 21645 //
     /* 1571646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1571657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1571660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1571663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571685 */     // MIs[0] round
     /* 1571685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571688 */     // MIs[0] policy
     /* 1571688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571698 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1571701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571722 */     // GIR_Coverage, 21645,
     /* 1571722 */     GIR_EraseRootFromParent_Done,
     /* 1571723 */   // Label 21786: @1571723
     /* 1571723 */   GIM_Try, /*On fail goto*//*Label 21787*/ GIMT_Encode4(1571805), // Rule ID 21648 //
     /* 1571728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1571739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1571742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1571745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571767 */     // MIs[0] round
     /* 1571767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571770 */     // MIs[0] policy
     /* 1571770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1571783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571804 */     // GIR_Coverage, 21648,
     /* 1571804 */     GIR_EraseRootFromParent_Done,
     /* 1571805 */   // Label 21787: @1571805
     /* 1571805 */   GIM_Try, /*On fail goto*//*Label 21788*/ GIMT_Encode4(1571887), // Rule ID 21649 //
     /* 1571810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1571821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1571824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1571827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571849 */     // MIs[0] round
     /* 1571849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571852 */     // MIs[0] policy
     /* 1571852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571862 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1571865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571886 */     // GIR_Coverage, 21649,
     /* 1571886 */     GIR_EraseRootFromParent_Done,
     /* 1571887 */   // Label 21788: @1571887
     /* 1571887 */   GIM_Try, /*On fail goto*//*Label 21789*/ GIMT_Encode4(1571969), // Rule ID 21652 //
     /* 1571892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1571903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1571906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1571909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571931 */     // MIs[0] round
     /* 1571931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571934 */     // MIs[0] policy
     /* 1571934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571944 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1571947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571968 */     // GIR_Coverage, 21652,
     /* 1571968 */     GIR_EraseRootFromParent_Done,
     /* 1571969 */   // Label 21789: @1571969
     /* 1571969 */   GIM_Try, /*On fail goto*//*Label 21790*/ GIMT_Encode4(1572051), // Rule ID 21653 //
     /* 1571974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1571985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1571988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1571991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572013 */     // MIs[0] round
     /* 1572013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572016 */     // MIs[0] policy
     /* 1572016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572026 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1572029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572035 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572050 */     // GIR_Coverage, 21653,
     /* 1572050 */     GIR_EraseRootFromParent_Done,
     /* 1572051 */   // Label 21790: @1572051
     /* 1572051 */   GIM_Try, /*On fail goto*//*Label 21791*/ GIMT_Encode4(1572133), // Rule ID 21656 //
     /* 1572056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1572059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1572067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1572070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1572073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1572076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572095 */     // MIs[0] round
     /* 1572095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572098 */     // MIs[0] policy
     /* 1572098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1572111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572132 */     // GIR_Coverage, 21656,
     /* 1572132 */     GIR_EraseRootFromParent_Done,
     /* 1572133 */   // Label 21791: @1572133
     /* 1572133 */   GIM_Try, /*On fail goto*//*Label 21792*/ GIMT_Encode4(1572215), // Rule ID 21657 //
     /* 1572138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1572141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1572149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1572152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1572155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1572158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572177 */     // MIs[0] round
     /* 1572177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572180 */     // MIs[0] policy
     /* 1572180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572190 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1572193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572214 */     // GIR_Coverage, 21657,
     /* 1572214 */     GIR_EraseRootFromParent_Done,
     /* 1572215 */   // Label 21792: @1572215
     /* 1572215 */   GIM_Try, /*On fail goto*//*Label 21793*/ GIMT_Encode4(1572297), // Rule ID 21660 //
     /* 1572220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1572231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1572234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1572237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572259 */     // MIs[0] round
     /* 1572259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572262 */     // MIs[0] policy
     /* 1572262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572272 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1572275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572296 */     // GIR_Coverage, 21660,
     /* 1572296 */     GIR_EraseRootFromParent_Done,
     /* 1572297 */   // Label 21793: @1572297
     /* 1572297 */   GIM_Try, /*On fail goto*//*Label 21794*/ GIMT_Encode4(1572379), // Rule ID 21661 //
     /* 1572302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1572313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1572316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1572319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572341 */     // MIs[0] round
     /* 1572341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572344 */     // MIs[0] policy
     /* 1572344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572354 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1572357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572363 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572378 */     // GIR_Coverage, 21661,
     /* 1572378 */     GIR_EraseRootFromParent_Done,
     /* 1572379 */   // Label 21794: @1572379
     /* 1572379 */   GIM_Try, /*On fail goto*//*Label 21795*/ GIMT_Encode4(1572461), // Rule ID 21664 //
     /* 1572384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1572395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1572398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1572401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572423 */     // MIs[0] round
     /* 1572423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572426 */     // MIs[0] policy
     /* 1572426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1572439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572460 */     // GIR_Coverage, 21664,
     /* 1572460 */     GIR_EraseRootFromParent_Done,
     /* 1572461 */   // Label 21795: @1572461
     /* 1572461 */   GIM_Try, /*On fail goto*//*Label 21796*/ GIMT_Encode4(1572543), // Rule ID 21665 //
     /* 1572466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1572477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1572480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1572483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572505 */     // MIs[0] round
     /* 1572505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572508 */     // MIs[0] policy
     /* 1572508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572518 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1572521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572542 */     // GIR_Coverage, 21665,
     /* 1572542 */     GIR_EraseRootFromParent_Done,
     /* 1572543 */   // Label 21796: @1572543
     /* 1572543 */   GIM_Try, /*On fail goto*//*Label 21797*/ GIMT_Encode4(1572625), // Rule ID 21668 //
     /* 1572548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1572559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1572562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1572565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572587 */     // MIs[0] round
     /* 1572587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572590 */     // MIs[0] policy
     /* 1572590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1572603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572624 */     // GIR_Coverage, 21668,
     /* 1572624 */     GIR_EraseRootFromParent_Done,
     /* 1572625 */   // Label 21797: @1572625
     /* 1572625 */   GIM_Try, /*On fail goto*//*Label 21798*/ GIMT_Encode4(1572707), // Rule ID 21669 //
     /* 1572630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1572641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1572644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1572647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572669 */     // MIs[0] round
     /* 1572669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572672 */     // MIs[0] policy
     /* 1572672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1572685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572691 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572706 */     // GIR_Coverage, 21669,
     /* 1572706 */     GIR_EraseRootFromParent_Done,
     /* 1572707 */   // Label 21798: @1572707
     /* 1572707 */   GIM_Try, /*On fail goto*//*Label 21799*/ GIMT_Encode4(1572789), // Rule ID 21672 //
     /* 1572712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1572723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1572726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1572729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572751 */     // MIs[0] round
     /* 1572751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572754 */     // MIs[0] policy
     /* 1572754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1572767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572788 */     // GIR_Coverage, 21672,
     /* 1572788 */     GIR_EraseRootFromParent_Done,
     /* 1572789 */   // Label 21799: @1572789
     /* 1572789 */   GIM_Try, /*On fail goto*//*Label 21800*/ GIMT_Encode4(1572871), // Rule ID 21673 //
     /* 1572794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1572805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1572808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1572811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572833 */     // MIs[0] round
     /* 1572833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572836 */     // MIs[0] policy
     /* 1572836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1572849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572870 */     // GIR_Coverage, 21673,
     /* 1572870 */     GIR_EraseRootFromParent_Done,
     /* 1572871 */   // Label 21800: @1572871
     /* 1572871 */   GIM_Try, /*On fail goto*//*Label 21801*/ GIMT_Encode4(1572953), // Rule ID 21676 //
     /* 1572876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1572887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1572890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1572893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572915 */     // MIs[0] round
     /* 1572915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572918 */     // MIs[0] policy
     /* 1572918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572928 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1572931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572952 */     // GIR_Coverage, 21676,
     /* 1572952 */     GIR_EraseRootFromParent_Done,
     /* 1572953 */   // Label 21801: @1572953
     /* 1572953 */   GIM_Try, /*On fail goto*//*Label 21802*/ GIMT_Encode4(1573035), // Rule ID 21677 //
     /* 1572958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1572969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1572972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1572975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572997 */     // MIs[0] round
     /* 1572997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573000 */     // MIs[0] policy
     /* 1573000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573010 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1573013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573019 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573034 */     // GIR_Coverage, 21677,
     /* 1573034 */     GIR_EraseRootFromParent_Done,
     /* 1573035 */   // Label 21802: @1573035
     /* 1573035 */   GIM_Try, /*On fail goto*//*Label 21803*/ GIMT_Encode4(1573117), // Rule ID 21680 //
     /* 1573040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1573051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1573054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1573057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573079 */     // MIs[0] round
     /* 1573079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573082 */     // MIs[0] policy
     /* 1573082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573092 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1573095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573116 */     // GIR_Coverage, 21680,
     /* 1573116 */     GIR_EraseRootFromParent_Done,
     /* 1573117 */   // Label 21803: @1573117
     /* 1573117 */   GIM_Try, /*On fail goto*//*Label 21804*/ GIMT_Encode4(1573199), // Rule ID 21681 //
     /* 1573122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1573133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1573136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1573139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573161 */     // MIs[0] round
     /* 1573161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573164 */     // MIs[0] policy
     /* 1573164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573174 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1573177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573198 */     // GIR_Coverage, 21681,
     /* 1573198 */     GIR_EraseRootFromParent_Done,
     /* 1573199 */   // Label 21804: @1573199
     /* 1573199 */   GIM_Try, /*On fail goto*//*Label 21805*/ GIMT_Encode4(1573281), // Rule ID 21684 //
     /* 1573204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1573215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1573218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1573221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573243 */     // MIs[0] round
     /* 1573243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573246 */     // MIs[0] policy
     /* 1573246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573256 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1573259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573280 */     // GIR_Coverage, 21684,
     /* 1573280 */     GIR_EraseRootFromParent_Done,
     /* 1573281 */   // Label 21805: @1573281
     /* 1573281 */   GIM_Try, /*On fail goto*//*Label 21806*/ GIMT_Encode4(1573363), // Rule ID 21685 //
     /* 1573286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1573297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1573300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1573303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573325 */     // MIs[0] round
     /* 1573325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573328 */     // MIs[0] policy
     /* 1573328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573338 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1573341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573347 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573362 */     // GIR_Coverage, 21685,
     /* 1573362 */     GIR_EraseRootFromParent_Done,
     /* 1573363 */   // Label 21806: @1573363
     /* 1573363 */   GIM_Try, /*On fail goto*//*Label 21807*/ GIMT_Encode4(1573445), // Rule ID 21688 //
     /* 1573368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1573379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1573382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1573385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573407 */     // MIs[0] round
     /* 1573407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573410 */     // MIs[0] policy
     /* 1573410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573420 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1573423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573444 */     // GIR_Coverage, 21688,
     /* 1573444 */     GIR_EraseRootFromParent_Done,
     /* 1573445 */   // Label 21807: @1573445
     /* 1573445 */   GIM_Try, /*On fail goto*//*Label 21808*/ GIMT_Encode4(1573527), // Rule ID 21689 //
     /* 1573450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1573461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1573464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1573467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573489 */     // MIs[0] round
     /* 1573489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573492 */     // MIs[0] policy
     /* 1573492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1573505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573526 */     // GIR_Coverage, 21689,
     /* 1573526 */     GIR_EraseRootFromParent_Done,
     /* 1573527 */   // Label 21808: @1573527
     /* 1573527 */   GIM_Try, /*On fail goto*//*Label 21809*/ GIMT_Encode4(1573609), // Rule ID 21692 //
     /* 1573532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1573543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1573546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1573549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1573552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573571 */     // MIs[0] round
     /* 1573571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573574 */     // MIs[0] policy
     /* 1573574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1573587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573608 */     // GIR_Coverage, 21692,
     /* 1573608 */     GIR_EraseRootFromParent_Done,
     /* 1573609 */   // Label 21809: @1573609
     /* 1573609 */   GIM_Try, /*On fail goto*//*Label 21810*/ GIMT_Encode4(1573691), // Rule ID 21693 //
     /* 1573614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1573625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1573628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1573631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1573634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573653 */     // MIs[0] round
     /* 1573653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573656 */     // MIs[0] policy
     /* 1573656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573666 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1573669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573690 */     // GIR_Coverage, 21693,
     /* 1573690 */     GIR_EraseRootFromParent_Done,
     /* 1573691 */   // Label 21810: @1573691
     /* 1573691 */   GIM_Try, /*On fail goto*//*Label 21811*/ GIMT_Encode4(1573773), // Rule ID 21696 //
     /* 1573696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1573707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1573710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1573713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1573716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573735 */     // MIs[0] round
     /* 1573735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573738 */     // MIs[0] policy
     /* 1573738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573748 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1573751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573772 */     // GIR_Coverage, 21696,
     /* 1573772 */     GIR_EraseRootFromParent_Done,
     /* 1573773 */   // Label 21811: @1573773
     /* 1573773 */   GIM_Try, /*On fail goto*//*Label 21812*/ GIMT_Encode4(1573855), // Rule ID 21697 //
     /* 1573778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1573789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1573792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1573795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1573798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573817 */     // MIs[0] round
     /* 1573817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573820 */     // MIs[0] policy
     /* 1573820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573830 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1573833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573854 */     // GIR_Coverage, 21697,
     /* 1573854 */     GIR_EraseRootFromParent_Done,
     /* 1573855 */   // Label 21812: @1573855
     /* 1573855 */   GIM_Try, /*On fail goto*//*Label 21813*/ GIMT_Encode4(1573937), // Rule ID 21700 //
     /* 1573860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1573863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1573871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1573874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1573877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573899 */     // MIs[0] round
     /* 1573899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573902 */     // MIs[0] policy
     /* 1573902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573912 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1573915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573936 */     // GIR_Coverage, 21700,
     /* 1573936 */     GIR_EraseRootFromParent_Done,
     /* 1573937 */   // Label 21813: @1573937
     /* 1573937 */   GIM_Try, /*On fail goto*//*Label 21814*/ GIMT_Encode4(1574019), // Rule ID 21701 //
     /* 1573942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1573945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1573953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1573956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1573959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573981 */     // MIs[0] round
     /* 1573981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573984 */     // MIs[0] policy
     /* 1573984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1573997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574003 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574018 */     // GIR_Coverage, 21701,
     /* 1574018 */     GIR_EraseRootFromParent_Done,
     /* 1574019 */   // Label 21814: @1574019
     /* 1574019 */   GIM_Try, /*On fail goto*//*Label 21815*/ GIMT_Encode4(1574101), // Rule ID 21704 //
     /* 1574024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1574027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1574035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1574038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1574041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574063 */     // MIs[0] round
     /* 1574063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574066 */     // MIs[0] policy
     /* 1574066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574076 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1574079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574100 */     // GIR_Coverage, 21704,
     /* 1574100 */     GIR_EraseRootFromParent_Done,
     /* 1574101 */   // Label 21815: @1574101
     /* 1574101 */   GIM_Try, /*On fail goto*//*Label 21816*/ GIMT_Encode4(1574183), // Rule ID 21705 //
     /* 1574106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1574109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1574117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1574120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1574123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574145 */     // MIs[0] round
     /* 1574145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574148 */     // MIs[0] policy
     /* 1574148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574158 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1574161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574182 */     // GIR_Coverage, 21705,
     /* 1574182 */     GIR_EraseRootFromParent_Done,
     /* 1574183 */   // Label 21816: @1574183
     /* 1574183 */   GIM_Try, /*On fail goto*//*Label 21817*/ GIMT_Encode4(1574265), // Rule ID 21708 //
     /* 1574188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1574191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1574199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1574202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1574205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1574208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574227 */     // MIs[0] round
     /* 1574227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574230 */     // MIs[0] policy
     /* 1574230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1574243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574264 */     // GIR_Coverage, 21708,
     /* 1574264 */     GIR_EraseRootFromParent_Done,
     /* 1574265 */   // Label 21817: @1574265
     /* 1574265 */   GIM_Try, /*On fail goto*//*Label 21818*/ GIMT_Encode4(1574347), // Rule ID 21709 //
     /* 1574270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1574273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1574281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1574284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1574287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1574290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574309 */     // MIs[0] round
     /* 1574309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574312 */     // MIs[0] policy
     /* 1574312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574322 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1574325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574346 */     // GIR_Coverage, 21709,
     /* 1574346 */     GIR_EraseRootFromParent_Done,
     /* 1574347 */   // Label 21818: @1574347
     /* 1574347 */   GIM_Try, /*On fail goto*//*Label 21819*/ GIMT_Encode4(1574429), // Rule ID 21712 //
     /* 1574352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1574355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1574363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1574366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1574369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574391 */     // MIs[0] round
     /* 1574391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574394 */     // MIs[0] policy
     /* 1574394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1574407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574428 */     // GIR_Coverage, 21712,
     /* 1574428 */     GIR_EraseRootFromParent_Done,
     /* 1574429 */   // Label 21819: @1574429
     /* 1574429 */   GIM_Try, /*On fail goto*//*Label 21820*/ GIMT_Encode4(1574511), // Rule ID 21713 //
     /* 1574434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1574437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1574445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1574448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1574451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574473 */     // MIs[0] round
     /* 1574473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574476 */     // MIs[0] policy
     /* 1574476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574486 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1574489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574495 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574510 */     // GIR_Coverage, 21713,
     /* 1574510 */     GIR_EraseRootFromParent_Done,
     /* 1574511 */   // Label 21820: @1574511
     /* 1574511 */   GIM_Try, /*On fail goto*//*Label 21821*/ GIMT_Encode4(1574593), // Rule ID 21716 //
     /* 1574516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1574519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1574527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1574530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1574533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1574536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574555 */     // MIs[0] round
     /* 1574555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574558 */     // MIs[0] policy
     /* 1574558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574568 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1574571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574592 */     // GIR_Coverage, 21716,
     /* 1574592 */     GIR_EraseRootFromParent_Done,
     /* 1574593 */   // Label 21821: @1574593
     /* 1574593 */   GIM_Try, /*On fail goto*//*Label 21822*/ GIMT_Encode4(1574675), // Rule ID 21717 //
     /* 1574598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1574601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1574609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1574612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1574615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1574618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574637 */     // MIs[0] round
     /* 1574637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574640 */     // MIs[0] policy
     /* 1574640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574650 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1574653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574674 */     // GIR_Coverage, 21717,
     /* 1574674 */     GIR_EraseRootFromParent_Done,
     /* 1574675 */   // Label 21822: @1574675
     /* 1574675 */   GIM_Try, /*On fail goto*//*Label 21823*/ GIMT_Encode4(1574757), // Rule ID 21720 //
     /* 1574680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1574683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1574691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1574694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1574697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574719 */     // MIs[0] round
     /* 1574719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574722 */     // MIs[0] policy
     /* 1574722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1574735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574756 */     // GIR_Coverage, 21720,
     /* 1574756 */     GIR_EraseRootFromParent_Done,
     /* 1574757 */   // Label 21823: @1574757
     /* 1574757 */   GIM_Try, /*On fail goto*//*Label 21824*/ GIMT_Encode4(1574839), // Rule ID 21721 //
     /* 1574762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1574765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1574773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1574776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1574779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574801 */     // MIs[0] round
     /* 1574801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574804 */     // MIs[0] policy
     /* 1574804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1574817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574838 */     // GIR_Coverage, 21721,
     /* 1574838 */     GIR_EraseRootFromParent_Done,
     /* 1574839 */   // Label 21824: @1574839
     /* 1574839 */   GIM_Try, /*On fail goto*//*Label 21825*/ GIMT_Encode4(1574921), // Rule ID 21724 //
     /* 1574844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1574847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1574855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1574858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1574861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574883 */     // MIs[0] round
     /* 1574883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574886 */     // MIs[0] policy
     /* 1574886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1574899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574920 */     // GIR_Coverage, 21724,
     /* 1574920 */     GIR_EraseRootFromParent_Done,
     /* 1574921 */   // Label 21825: @1574921
     /* 1574921 */   GIM_Try, /*On fail goto*//*Label 21826*/ GIMT_Encode4(1575003), // Rule ID 21725 //
     /* 1574926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1574929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1574937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1574940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1574943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574965 */     // MIs[0] round
     /* 1574965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574968 */     // MIs[0] policy
     /* 1574968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1574981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575002 */     // GIR_Coverage, 21725,
     /* 1575002 */     GIR_EraseRootFromParent_Done,
     /* 1575003 */   // Label 21826: @1575003
     /* 1575003 */   GIM_Try, /*On fail goto*//*Label 21827*/ GIMT_Encode4(1575085), // Rule ID 21728 //
     /* 1575008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1575011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1575016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1575019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1575022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1575025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575047 */     // MIs[0] round
     /* 1575047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575050 */     // MIs[0] policy
     /* 1575050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1575063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575084 */     // GIR_Coverage, 21728,
     /* 1575084 */     GIR_EraseRootFromParent_Done,
     /* 1575085 */   // Label 21827: @1575085
     /* 1575085 */   GIM_Try, /*On fail goto*//*Label 21828*/ GIMT_Encode4(1575167), // Rule ID 21729 //
     /* 1575090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1575093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1575098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1575101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1575104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1575107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575129 */     // MIs[0] round
     /* 1575129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575132 */     // MIs[0] policy
     /* 1575132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575142 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1575145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575166 */     // GIR_Coverage, 21729,
     /* 1575166 */     GIR_EraseRootFromParent_Done,
     /* 1575167 */   // Label 21828: @1575167
     /* 1575167 */   GIM_Try, /*On fail goto*//*Label 21829*/ GIMT_Encode4(1575249), // Rule ID 21732 //
     /* 1575172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1575175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1575180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1575183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1575186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1575189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575211 */     // MIs[0] round
     /* 1575211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575214 */     // MIs[0] policy
     /* 1575214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575224 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1575227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575248 */     // GIR_Coverage, 21732,
     /* 1575248 */     GIR_EraseRootFromParent_Done,
     /* 1575249 */   // Label 21829: @1575249
     /* 1575249 */   GIM_Try, /*On fail goto*//*Label 21830*/ GIMT_Encode4(1575331), // Rule ID 21733 //
     /* 1575254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1575257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1575262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1575265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1575268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1575271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575293 */     // MIs[0] round
     /* 1575293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575296 */     // MIs[0] policy
     /* 1575296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575306 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1575309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575330 */     // GIR_Coverage, 21733,
     /* 1575330 */     GIR_EraseRootFromParent_Done,
     /* 1575331 */   // Label 21830: @1575331
     /* 1575331 */   GIM_Try, /*On fail goto*//*Label 21831*/ GIMT_Encode4(1575413), // Rule ID 21856 //
     /* 1575336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1575347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1575350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1575353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575375 */     // MIs[0] round
     /* 1575375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575378 */     // MIs[0] policy
     /* 1575378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575388 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1575391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575412 */     // GIR_Coverage, 21856,
     /* 1575412 */     GIR_EraseRootFromParent_Done,
     /* 1575413 */   // Label 21831: @1575413
     /* 1575413 */   GIM_Try, /*On fail goto*//*Label 21832*/ GIMT_Encode4(1575495), // Rule ID 21857 //
     /* 1575418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1575429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1575432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1575435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575457 */     // MIs[0] round
     /* 1575457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575460 */     // MIs[0] policy
     /* 1575460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575470 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1575473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575494 */     // GIR_Coverage, 21857,
     /* 1575494 */     GIR_EraseRootFromParent_Done,
     /* 1575495 */   // Label 21832: @1575495
     /* 1575495 */   GIM_Try, /*On fail goto*//*Label 21833*/ GIMT_Encode4(1575577), // Rule ID 21860 //
     /* 1575500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1575511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1575514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1575517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575539 */     // MIs[0] round
     /* 1575539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575542 */     // MIs[0] policy
     /* 1575542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575552 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1575555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575576 */     // GIR_Coverage, 21860,
     /* 1575576 */     GIR_EraseRootFromParent_Done,
     /* 1575577 */   // Label 21833: @1575577
     /* 1575577 */   GIM_Try, /*On fail goto*//*Label 21834*/ GIMT_Encode4(1575659), // Rule ID 21861 //
     /* 1575582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1575593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1575596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1575599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575621 */     // MIs[0] round
     /* 1575621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575624 */     // MIs[0] policy
     /* 1575624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575634 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1575637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575643 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575658 */     // GIR_Coverage, 21861,
     /* 1575658 */     GIR_EraseRootFromParent_Done,
     /* 1575659 */   // Label 21834: @1575659
     /* 1575659 */   GIM_Try, /*On fail goto*//*Label 21835*/ GIMT_Encode4(1575741), // Rule ID 21864 //
     /* 1575664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1575675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1575678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1575681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575703 */     // MIs[0] round
     /* 1575703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575706 */     // MIs[0] policy
     /* 1575706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575716 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1575719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575725 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575740 */     // GIR_Coverage, 21864,
     /* 1575740 */     GIR_EraseRootFromParent_Done,
     /* 1575741 */   // Label 21835: @1575741
     /* 1575741 */   GIM_Try, /*On fail goto*//*Label 21836*/ GIMT_Encode4(1575823), // Rule ID 21865 //
     /* 1575746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1575757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1575760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1575763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575785 */     // MIs[0] round
     /* 1575785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575788 */     // MIs[0] policy
     /* 1575788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575798 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1575801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575822 */     // GIR_Coverage, 21865,
     /* 1575822 */     GIR_EraseRootFromParent_Done,
     /* 1575823 */   // Label 21836: @1575823
     /* 1575823 */   GIM_Try, /*On fail goto*//*Label 21837*/ GIMT_Encode4(1575905), // Rule ID 21868 //
     /* 1575828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1575839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1575842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1575845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575867 */     // MIs[0] round
     /* 1575867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575870 */     // MIs[0] policy
     /* 1575870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575880 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1575883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575904 */     // GIR_Coverage, 21868,
     /* 1575904 */     GIR_EraseRootFromParent_Done,
     /* 1575905 */   // Label 21837: @1575905
     /* 1575905 */   GIM_Try, /*On fail goto*//*Label 21838*/ GIMT_Encode4(1575987), // Rule ID 21869 //
     /* 1575910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1575921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1575924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1575927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575949 */     // MIs[0] round
     /* 1575949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575952 */     // MIs[0] policy
     /* 1575952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575962 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1575965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575986 */     // GIR_Coverage, 21869,
     /* 1575986 */     GIR_EraseRootFromParent_Done,
     /* 1575987 */   // Label 21838: @1575987
     /* 1575987 */   GIM_Try, /*On fail goto*//*Label 21839*/ GIMT_Encode4(1576069), // Rule ID 21872 //
     /* 1575992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1576003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1576006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1576009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1576012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576031 */     // MIs[0] round
     /* 1576031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576034 */     // MIs[0] policy
     /* 1576034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576044 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1576047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576068 */     // GIR_Coverage, 21872,
     /* 1576068 */     GIR_EraseRootFromParent_Done,
     /* 1576069 */   // Label 21839: @1576069
     /* 1576069 */   GIM_Try, /*On fail goto*//*Label 21840*/ GIMT_Encode4(1576151), // Rule ID 21873 //
     /* 1576074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1576085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1576088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1576091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1576094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576113 */     // MIs[0] round
     /* 1576113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576116 */     // MIs[0] policy
     /* 1576116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576126 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1576129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576150 */     // GIR_Coverage, 21873,
     /* 1576150 */     GIR_EraseRootFromParent_Done,
     /* 1576151 */   // Label 21840: @1576151
     /* 1576151 */   GIM_Try, /*On fail goto*//*Label 21841*/ GIMT_Encode4(1576233), // Rule ID 21876 //
     /* 1576156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1576159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1576167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1576170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1576173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576195 */     // MIs[0] round
     /* 1576195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576198 */     // MIs[0] policy
     /* 1576198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576208 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1576211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576232 */     // GIR_Coverage, 21876,
     /* 1576232 */     GIR_EraseRootFromParent_Done,
     /* 1576233 */   // Label 21841: @1576233
     /* 1576233 */   GIM_Try, /*On fail goto*//*Label 21842*/ GIMT_Encode4(1576315), // Rule ID 21877 //
     /* 1576238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1576241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1576249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1576252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1576255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576277 */     // MIs[0] round
     /* 1576277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576280 */     // MIs[0] policy
     /* 1576280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576290 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1576293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576314 */     // GIR_Coverage, 21877,
     /* 1576314 */     GIR_EraseRootFromParent_Done,
     /* 1576315 */   // Label 21842: @1576315
     /* 1576315 */   GIM_Try, /*On fail goto*//*Label 21843*/ GIMT_Encode4(1576397), // Rule ID 21880 //
     /* 1576320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1576323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1576331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1576334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1576337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576359 */     // MIs[0] round
     /* 1576359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576362 */     // MIs[0] policy
     /* 1576362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576372 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1576375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576396 */     // GIR_Coverage, 21880,
     /* 1576396 */     GIR_EraseRootFromParent_Done,
     /* 1576397 */   // Label 21843: @1576397
     /* 1576397 */   GIM_Try, /*On fail goto*//*Label 21844*/ GIMT_Encode4(1576479), // Rule ID 21881 //
     /* 1576402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1576405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1576413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1576416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1576419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576441 */     // MIs[0] round
     /* 1576441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576444 */     // MIs[0] policy
     /* 1576444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1576457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576478 */     // GIR_Coverage, 21881,
     /* 1576478 */     GIR_EraseRootFromParent_Done,
     /* 1576479 */   // Label 21844: @1576479
     /* 1576479 */   GIM_Try, /*On fail goto*//*Label 21845*/ GIMT_Encode4(1576561), // Rule ID 21884 //
     /* 1576484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1576487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1576495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1576498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1576501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576523 */     // MIs[0] round
     /* 1576523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576526 */     // MIs[0] policy
     /* 1576526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576536 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1576539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576560 */     // GIR_Coverage, 21884,
     /* 1576560 */     GIR_EraseRootFromParent_Done,
     /* 1576561 */   // Label 21845: @1576561
     /* 1576561 */   GIM_Try, /*On fail goto*//*Label 21846*/ GIMT_Encode4(1576643), // Rule ID 21885 //
     /* 1576566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1576569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1576577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1576580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1576583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576605 */     // MIs[0] round
     /* 1576605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576608 */     // MIs[0] policy
     /* 1576608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576618 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1576621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576642 */     // GIR_Coverage, 21885,
     /* 1576642 */     GIR_EraseRootFromParent_Done,
     /* 1576643 */   // Label 21846: @1576643
     /* 1576643 */   GIM_Try, /*On fail goto*//*Label 21847*/ GIMT_Encode4(1576725), // Rule ID 21888 //
     /* 1576648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1576651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1576665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576687 */     // MIs[0] round
     /* 1576687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576690 */     // MIs[0] policy
     /* 1576690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576700 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1576703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576724 */     // GIR_Coverage, 21888,
     /* 1576724 */     GIR_EraseRootFromParent_Done,
     /* 1576725 */   // Label 21847: @1576725
     /* 1576725 */   GIM_Try, /*On fail goto*//*Label 21848*/ GIMT_Encode4(1576807), // Rule ID 21889 //
     /* 1576730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1576733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1576747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576769 */     // MIs[0] round
     /* 1576769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576772 */     // MIs[0] policy
     /* 1576772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576782 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1576785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576806 */     // GIR_Coverage, 21889,
     /* 1576806 */     GIR_EraseRootFromParent_Done,
     /* 1576807 */   // Label 21848: @1576807
     /* 1576807 */   GIM_Try, /*On fail goto*//*Label 21849*/ GIMT_Encode4(1576889), // Rule ID 21892 //
     /* 1576812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1576823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1576826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1576829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576851 */     // MIs[0] round
     /* 1576851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576854 */     // MIs[0] policy
     /* 1576854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576864 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1576867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576888 */     // GIR_Coverage, 21892,
     /* 1576888 */     GIR_EraseRootFromParent_Done,
     /* 1576889 */   // Label 21849: @1576889
     /* 1576889 */   GIM_Try, /*On fail goto*//*Label 21850*/ GIMT_Encode4(1576971), // Rule ID 21893 //
     /* 1576894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1576905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1576908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1576911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576933 */     // MIs[0] round
     /* 1576933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576936 */     // MIs[0] policy
     /* 1576936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576946 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1576949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576955 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576970 */     // GIR_Coverage, 21893,
     /* 1576970 */     GIR_EraseRootFromParent_Done,
     /* 1576971 */   // Label 21850: @1576971
     /* 1576971 */   GIM_Try, /*On fail goto*//*Label 21851*/ GIMT_Encode4(1577053), // Rule ID 21896 //
     /* 1576976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1576987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1576990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1576993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577015 */     // MIs[0] round
     /* 1577015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577018 */     // MIs[0] policy
     /* 1577018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577028 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1577031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577052 */     // GIR_Coverage, 21896,
     /* 1577052 */     GIR_EraseRootFromParent_Done,
     /* 1577053 */   // Label 21851: @1577053
     /* 1577053 */   GIM_Try, /*On fail goto*//*Label 21852*/ GIMT_Encode4(1577135), // Rule ID 21897 //
     /* 1577058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1577061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1577069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1577072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1577075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577097 */     // MIs[0] round
     /* 1577097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577100 */     // MIs[0] policy
     /* 1577100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577110 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1577113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577134 */     // GIR_Coverage, 21897,
     /* 1577134 */     GIR_EraseRootFromParent_Done,
     /* 1577135 */   // Label 21852: @1577135
     /* 1577135 */   GIM_Try, /*On fail goto*//*Label 21853*/ GIMT_Encode4(1577217), // Rule ID 21900 //
     /* 1577140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1577143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1577151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1577154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1577157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1577160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577179 */     // MIs[0] round
     /* 1577179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577182 */     // MIs[0] policy
     /* 1577182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577192 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1577195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577216 */     // GIR_Coverage, 21900,
     /* 1577216 */     GIR_EraseRootFromParent_Done,
     /* 1577217 */   // Label 21853: @1577217
     /* 1577217 */   GIM_Try, /*On fail goto*//*Label 21854*/ GIMT_Encode4(1577299), // Rule ID 21901 //
     /* 1577222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1577225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1577233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1577236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1577239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1577242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577261 */     // MIs[0] round
     /* 1577261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577264 */     // MIs[0] policy
     /* 1577264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577274 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1577277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577298 */     // GIR_Coverage, 21901,
     /* 1577298 */     GIR_EraseRootFromParent_Done,
     /* 1577299 */   // Label 21854: @1577299
     /* 1577299 */   GIM_Try, /*On fail goto*//*Label 21855*/ GIMT_Encode4(1577381), // Rule ID 21904 //
     /* 1577304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1577307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1577315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1577318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1577321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1577324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577343 */     // MIs[0] round
     /* 1577343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577346 */     // MIs[0] policy
     /* 1577346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577356 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1577359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577380 */     // GIR_Coverage, 21904,
     /* 1577380 */     GIR_EraseRootFromParent_Done,
     /* 1577381 */   // Label 21855: @1577381
     /* 1577381 */   GIM_Try, /*On fail goto*//*Label 21856*/ GIMT_Encode4(1577463), // Rule ID 21905 //
     /* 1577386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1577389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1577397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1577400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1577403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1577406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577425 */     // MIs[0] round
     /* 1577425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577428 */     // MIs[0] policy
     /* 1577428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577438 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1577441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577462 */     // GIR_Coverage, 21905,
     /* 1577462 */     GIR_EraseRootFromParent_Done,
     /* 1577463 */   // Label 21856: @1577463
     /* 1577463 */   GIM_Try, /*On fail goto*//*Label 21857*/ GIMT_Encode4(1577545), // Rule ID 21908 //
     /* 1577468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1577471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1577485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1577488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577507 */     // MIs[0] round
     /* 1577507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577510 */     // MIs[0] policy
     /* 1577510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577520 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1577523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577544 */     // GIR_Coverage, 21908,
     /* 1577544 */     GIR_EraseRootFromParent_Done,
     /* 1577545 */   // Label 21857: @1577545
     /* 1577545 */   GIM_Try, /*On fail goto*//*Label 21858*/ GIMT_Encode4(1577627), // Rule ID 21909 //
     /* 1577550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1577553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1577567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1577570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577589 */     // MIs[0] round
     /* 1577589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577592 */     // MIs[0] policy
     /* 1577592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577602 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1577605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577626 */     // GIR_Coverage, 21909,
     /* 1577626 */     GIR_EraseRootFromParent_Done,
     /* 1577627 */   // Label 21858: @1577627
     /* 1577627 */   GIM_Try, /*On fail goto*//*Label 21859*/ GIMT_Encode4(1577709), // Rule ID 21912 //
     /* 1577632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1577643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1577646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1577649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577671 */     // MIs[0] round
     /* 1577671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577674 */     // MIs[0] policy
     /* 1577674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577684 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1577687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577708 */     // GIR_Coverage, 21912,
     /* 1577708 */     GIR_EraseRootFromParent_Done,
     /* 1577709 */   // Label 21859: @1577709
     /* 1577709 */   GIM_Try, /*On fail goto*//*Label 21860*/ GIMT_Encode4(1577791), // Rule ID 21913 //
     /* 1577714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1577717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1577725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1577728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1577731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577753 */     // MIs[0] round
     /* 1577753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577756 */     // MIs[0] policy
     /* 1577756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577766 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1577769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577790 */     // GIR_Coverage, 21913,
     /* 1577790 */     GIR_EraseRootFromParent_Done,
     /* 1577791 */   // Label 21860: @1577791
     /* 1577791 */   GIM_Try, /*On fail goto*//*Label 21861*/ GIMT_Encode4(1577873), // Rule ID 21916 //
     /* 1577796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1577807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1577810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1577813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577835 */     // MIs[0] round
     /* 1577835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577838 */     // MIs[0] policy
     /* 1577838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577848 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1577851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577872 */     // GIR_Coverage, 21916,
     /* 1577872 */     GIR_EraseRootFromParent_Done,
     /* 1577873 */   // Label 21861: @1577873
     /* 1577873 */   GIM_Try, /*On fail goto*//*Label 21862*/ GIMT_Encode4(1577955), // Rule ID 21917 //
     /* 1577878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1577881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1577889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1577892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1577895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577917 */     // MIs[0] round
     /* 1577917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577920 */     // MIs[0] policy
     /* 1577920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577930 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1577933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577954 */     // GIR_Coverage, 21917,
     /* 1577954 */     GIR_EraseRootFromParent_Done,
     /* 1577955 */   // Label 21862: @1577955
     /* 1577955 */   GIM_Try, /*On fail goto*//*Label 21863*/ GIMT_Encode4(1578037), // Rule ID 21920 //
     /* 1577960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1577971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1577974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1577977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1577980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577999 */     // MIs[0] round
     /* 1577999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578002 */     // MIs[0] policy
     /* 1578002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578012 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1578015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578036 */     // GIR_Coverage, 21920,
     /* 1578036 */     GIR_EraseRootFromParent_Done,
     /* 1578037 */   // Label 21863: @1578037
     /* 1578037 */   GIM_Try, /*On fail goto*//*Label 21864*/ GIMT_Encode4(1578119), // Rule ID 21921 //
     /* 1578042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1578045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1578050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1578053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1578056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1578059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578081 */     // MIs[0] round
     /* 1578081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578084 */     // MIs[0] policy
     /* 1578084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1578097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578118 */     // GIR_Coverage, 21921,
     /* 1578118 */     GIR_EraseRootFromParent_Done,
     /* 1578119 */   // Label 21864: @1578119
     /* 1578119 */   GIM_Try, /*On fail goto*//*Label 21865*/ GIMT_Encode4(1578201), // Rule ID 21924 //
     /* 1578124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1578127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1578132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1578135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1578138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1578141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578163 */     // MIs[0] round
     /* 1578163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578166 */     // MIs[0] policy
     /* 1578166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578176 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1578179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578200 */     // GIR_Coverage, 21924,
     /* 1578200 */     GIR_EraseRootFromParent_Done,
     /* 1578201 */   // Label 21865: @1578201
     /* 1578201 */   GIM_Try, /*On fail goto*//*Label 21866*/ GIMT_Encode4(1578283), // Rule ID 21925 //
     /* 1578206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1578209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1578214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1578217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1578220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1578223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578245 */     // MIs[0] round
     /* 1578245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578248 */     // MIs[0] policy
     /* 1578248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578258 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1578261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578282 */     // GIR_Coverage, 21925,
     /* 1578282 */     GIR_EraseRootFromParent_Done,
     /* 1578283 */   // Label 21866: @1578283
     /* 1578283 */   GIM_Try, /*On fail goto*//*Label 21867*/ GIMT_Encode4(1578365), // Rule ID 21928 //
     /* 1578288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1578299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1578302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1578305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1578308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578327 */     // MIs[0] round
     /* 1578327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578330 */     // MIs[0] policy
     /* 1578330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578340 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1578343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578349 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578364 */     // GIR_Coverage, 21928,
     /* 1578364 */     GIR_EraseRootFromParent_Done,
     /* 1578365 */   // Label 21867: @1578365
     /* 1578365 */   GIM_Try, /*On fail goto*//*Label 21868*/ GIMT_Encode4(1578447), // Rule ID 21929 //
     /* 1578370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1578381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1578384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1578387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1578390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578409 */     // MIs[0] round
     /* 1578409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578412 */     // MIs[0] policy
     /* 1578412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578422 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1578425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578446 */     // GIR_Coverage, 21929,
     /* 1578446 */     GIR_EraseRootFromParent_Done,
     /* 1578447 */   // Label 21868: @1578447
     /* 1578447 */   GIM_Try, /*On fail goto*//*Label 21869*/ GIMT_Encode4(1578529), // Rule ID 21932 //
     /* 1578452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1578463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1578466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1578469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578491 */     // MIs[0] round
     /* 1578491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578494 */     // MIs[0] policy
     /* 1578494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578504 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1578507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578528 */     // GIR_Coverage, 21932,
     /* 1578528 */     GIR_EraseRootFromParent_Done,
     /* 1578529 */   // Label 21869: @1578529
     /* 1578529 */   GIM_Try, /*On fail goto*//*Label 21870*/ GIMT_Encode4(1578611), // Rule ID 21933 //
     /* 1578534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1578545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1578548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1578551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578573 */     // MIs[0] round
     /* 1578573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578576 */     // MIs[0] policy
     /* 1578576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578586 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1578589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578610 */     // GIR_Coverage, 21933,
     /* 1578610 */     GIR_EraseRootFromParent_Done,
     /* 1578611 */   // Label 21870: @1578611
     /* 1578611 */   GIM_Try, /*On fail goto*//*Label 21871*/ GIMT_Encode4(1578693), // Rule ID 21936 //
     /* 1578616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1578627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1578630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1578633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578655 */     // MIs[0] round
     /* 1578655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578658 */     // MIs[0] policy
     /* 1578658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578668 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1578671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578692 */     // GIR_Coverage, 21936,
     /* 1578692 */     GIR_EraseRootFromParent_Done,
     /* 1578693 */   // Label 21871: @1578693
     /* 1578693 */   GIM_Try, /*On fail goto*//*Label 21872*/ GIMT_Encode4(1578775), // Rule ID 21937 //
     /* 1578698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1578709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1578712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1578715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578737 */     // MIs[0] round
     /* 1578737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578740 */     // MIs[0] policy
     /* 1578740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578750 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1578753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578774 */     // GIR_Coverage, 21937,
     /* 1578774 */     GIR_EraseRootFromParent_Done,
     /* 1578775 */   // Label 21872: @1578775
     /* 1578775 */   GIM_Try, /*On fail goto*//*Label 21873*/ GIMT_Encode4(1578857), // Rule ID 21940 //
     /* 1578780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1578791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1578794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1578797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578819 */     // MIs[0] round
     /* 1578819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578822 */     // MIs[0] policy
     /* 1578822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578832 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1578835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578856 */     // GIR_Coverage, 21940,
     /* 1578856 */     GIR_EraseRootFromParent_Done,
     /* 1578857 */   // Label 21873: @1578857
     /* 1578857 */   GIM_Try, /*On fail goto*//*Label 21874*/ GIMT_Encode4(1578939), // Rule ID 21941 //
     /* 1578862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1578873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1578876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1578879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578901 */     // MIs[0] round
     /* 1578901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578904 */     // MIs[0] policy
     /* 1578904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578914 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1578917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578938 */     // GIR_Coverage, 21941,
     /* 1578938 */     GIR_EraseRootFromParent_Done,
     /* 1578939 */   // Label 21874: @1578939
     /* 1578939 */   GIM_Try, /*On fail goto*//*Label 21875*/ GIMT_Encode4(1579021), // Rule ID 21944 //
     /* 1578944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1578955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1578958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1578961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1578964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578983 */     // MIs[0] round
     /* 1578983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578986 */     // MIs[0] policy
     /* 1578986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578996 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1578999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579020 */     // GIR_Coverage, 21944,
     /* 1579020 */     GIR_EraseRootFromParent_Done,
     /* 1579021 */   // Label 21875: @1579021
     /* 1579021 */   GIM_Try, /*On fail goto*//*Label 21876*/ GIMT_Encode4(1579103), // Rule ID 21945 //
     /* 1579026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1579029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1579037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1579040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1579043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1579046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579065 */     // MIs[0] round
     /* 1579065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579068 */     // MIs[0] policy
     /* 1579068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579078 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1579081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579102 */     // GIR_Coverage, 21945,
     /* 1579102 */     GIR_EraseRootFromParent_Done,
     /* 1579103 */   // Label 21876: @1579103
     /* 1579103 */   GIM_Try, /*On fail goto*//*Label 21877*/ GIMT_Encode4(1579185), // Rule ID 21948 //
     /* 1579108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1579111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1579119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1579122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1579125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1579128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579147 */     // MIs[0] round
     /* 1579147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579150 */     // MIs[0] policy
     /* 1579150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579160 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1579163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579184 */     // GIR_Coverage, 21948,
     /* 1579184 */     GIR_EraseRootFromParent_Done,
     /* 1579185 */   // Label 21877: @1579185
     /* 1579185 */   GIM_Try, /*On fail goto*//*Label 21878*/ GIMT_Encode4(1579267), // Rule ID 21949 //
     /* 1579190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1579193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1579201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1579204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1579207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1579210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579229 */     // MIs[0] round
     /* 1579229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579232 */     // MIs[0] policy
     /* 1579232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579242 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1579245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579266 */     // GIR_Coverage, 21949,
     /* 1579266 */     GIR_EraseRootFromParent_Done,
     /* 1579267 */   // Label 21878: @1579267
     /* 1579267 */   GIM_Try, /*On fail goto*//*Label 21879*/ GIMT_Encode4(1579349), // Rule ID 21952 //
     /* 1579272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1579275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1579283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1579286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1579289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1579292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579311 */     // MIs[0] round
     /* 1579311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579314 */     // MIs[0] policy
     /* 1579314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579324 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1579327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579348 */     // GIR_Coverage, 21952,
     /* 1579348 */     GIR_EraseRootFromParent_Done,
     /* 1579349 */   // Label 21879: @1579349
     /* 1579349 */   GIM_Try, /*On fail goto*//*Label 21880*/ GIMT_Encode4(1579431), // Rule ID 21953 //
     /* 1579354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1579357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1579365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1579368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1579371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1579374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579393 */     // MIs[0] round
     /* 1579393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579396 */     // MIs[0] policy
     /* 1579396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579406 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1579409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579430 */     // GIR_Coverage, 21953,
     /* 1579430 */     GIR_EraseRootFromParent_Done,
     /* 1579431 */   // Label 21880: @1579431
     /* 1579431 */   GIM_Try, /*On fail goto*//*Label 21881*/ GIMT_Encode4(1579513), // Rule ID 21956 //
     /* 1579436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1579439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1579447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1579450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1579453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1579456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579475 */     // MIs[0] round
     /* 1579475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579478 */     // MIs[0] policy
     /* 1579478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579488 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1579491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579512 */     // GIR_Coverage, 21956,
     /* 1579512 */     GIR_EraseRootFromParent_Done,
     /* 1579513 */   // Label 21881: @1579513
     /* 1579513 */   GIM_Try, /*On fail goto*//*Label 21882*/ GIMT_Encode4(1579595), // Rule ID 21957 //
     /* 1579518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1579521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1579529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1579532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1579535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1579538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579557 */     // MIs[0] round
     /* 1579557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579560 */     // MIs[0] policy
     /* 1579560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579570 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1579573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579594 */     // GIR_Coverage, 21957,
     /* 1579594 */     GIR_EraseRootFromParent_Done,
     /* 1579595 */   // Label 21882: @1579595
     /* 1579595 */   GIM_Try, /*On fail goto*//*Label 21883*/ GIMT_Encode4(1579677), // Rule ID 21960 //
     /* 1579600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1579603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1579611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1579614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1579617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1579620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579639 */     // MIs[0] round
     /* 1579639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579642 */     // MIs[0] policy
     /* 1579642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579652 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1579655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579676 */     // GIR_Coverage, 21960,
     /* 1579676 */     GIR_EraseRootFromParent_Done,
     /* 1579677 */   // Label 21883: @1579677
     /* 1579677 */   GIM_Try, /*On fail goto*//*Label 21884*/ GIMT_Encode4(1579759), // Rule ID 21961 //
     /* 1579682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1579685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1579693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1579696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1579699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1579702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579721 */     // MIs[0] round
     /* 1579721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579724 */     // MIs[0] policy
     /* 1579724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579734 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1579737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579758 */     // GIR_Coverage, 21961,
     /* 1579758 */     GIR_EraseRootFromParent_Done,
     /* 1579759 */   // Label 21884: @1579759
     /* 1579759 */   GIM_Try, /*On fail goto*//*Label 21885*/ GIMT_Encode4(1579841), // Rule ID 2770 //
     /* 1579764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1579775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1579778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1579781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579795 */     // MIs[0] passthru
     /* 1579795 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579808 */     // MIs[0] policy
     /* 1579808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579818 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1579821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579840 */     // GIR_Coverage, 2770,
     /* 1579840 */     GIR_EraseRootFromParent_Done,
     /* 1579841 */   // Label 21885: @1579841
     /* 1579841 */   GIM_Try, /*On fail goto*//*Label 21886*/ GIMT_Encode4(1579923), // Rule ID 2771 //
     /* 1579846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1579857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1579860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1579863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579877 */     // MIs[0] passthru
     /* 1579877 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579890 */     // MIs[0] policy
     /* 1579890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579900 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1579903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579922 */     // GIR_Coverage, 2771,
     /* 1579922 */     GIR_EraseRootFromParent_Done,
     /* 1579923 */   // Label 21886: @1579923
     /* 1579923 */   GIM_Try, /*On fail goto*//*Label 21887*/ GIMT_Encode4(1580005), // Rule ID 4086 //
     /* 1579928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1579939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1579942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1579945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579959 */     // MIs[0] passthru
     /* 1579959 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579972 */     // MIs[0] policy
     /* 1579972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579982 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1579985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580004 */     // GIR_Coverage, 4086,
     /* 1580004 */     GIR_EraseRootFromParent_Done,
     /* 1580005 */   // Label 21887: @1580005
     /* 1580005 */   GIM_Try, /*On fail goto*//*Label 21888*/ GIMT_Encode4(1580087), // Rule ID 4087 //
     /* 1580010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1580021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1580024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1580027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580041 */     // MIs[0] passthru
     /* 1580041 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580054 */     // MIs[0] policy
     /* 1580054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580064 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1580067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580086 */     // GIR_Coverage, 4087,
     /* 1580086 */     GIR_EraseRootFromParent_Done,
     /* 1580087 */   // Label 21888: @1580087
     /* 1580087 */   GIM_Try, /*On fail goto*//*Label 21889*/ GIMT_Encode4(1580169), // Rule ID 4096 //
     /* 1580092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1580103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1580106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1580109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580123 */     // MIs[0] passthru
     /* 1580123 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580136 */     // MIs[0] policy
     /* 1580136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1580149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580168 */     // GIR_Coverage, 4096,
     /* 1580168 */     GIR_EraseRootFromParent_Done,
     /* 1580169 */   // Label 21889: @1580169
     /* 1580169 */   GIM_Try, /*On fail goto*//*Label 21890*/ GIMT_Encode4(1580251), // Rule ID 4097 //
     /* 1580174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1580185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1580188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1580191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580205 */     // MIs[0] passthru
     /* 1580205 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580218 */     // MIs[0] policy
     /* 1580218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580228 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1580231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580250 */     // GIR_Coverage, 4097,
     /* 1580250 */     GIR_EraseRootFromParent_Done,
     /* 1580251 */   // Label 21890: @1580251
     /* 1580251 */   GIM_Try, /*On fail goto*//*Label 21891*/ GIMT_Encode4(1580333), // Rule ID 4106 //
     /* 1580256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1580267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1580270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1580273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580287 */     // MIs[0] passthru
     /* 1580287 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580300 */     // MIs[0] policy
     /* 1580300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580310 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1580313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580332 */     // GIR_Coverage, 4106,
     /* 1580332 */     GIR_EraseRootFromParent_Done,
     /* 1580333 */   // Label 21891: @1580333
     /* 1580333 */   GIM_Try, /*On fail goto*//*Label 21892*/ GIMT_Encode4(1580415), // Rule ID 4107 //
     /* 1580338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1580349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1580352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1580355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580369 */     // MIs[0] passthru
     /* 1580369 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580382 */     // MIs[0] policy
     /* 1580382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1580395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580414 */     // GIR_Coverage, 4107,
     /* 1580414 */     GIR_EraseRootFromParent_Done,
     /* 1580415 */   // Label 21892: @1580415
     /* 1580415 */   GIM_Try, /*On fail goto*//*Label 21893*/ GIMT_Encode4(1580497), // Rule ID 4116 //
     /* 1580420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1580431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1580434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1580437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1580440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580451 */     // MIs[0] passthru
     /* 1580451 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580464 */     // MIs[0] policy
     /* 1580464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1580477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580496 */     // GIR_Coverage, 4116,
     /* 1580496 */     GIR_EraseRootFromParent_Done,
     /* 1580497 */   // Label 21893: @1580497
     /* 1580497 */   GIM_Try, /*On fail goto*//*Label 21894*/ GIMT_Encode4(1580579), // Rule ID 4117 //
     /* 1580502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1580513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1580516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1580519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1580522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580533 */     // MIs[0] passthru
     /* 1580533 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580546 */     // MIs[0] policy
     /* 1580546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1580559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580578 */     // GIR_Coverage, 4117,
     /* 1580578 */     GIR_EraseRootFromParent_Done,
     /* 1580579 */   // Label 21894: @1580579
     /* 1580579 */   GIM_Try, /*On fail goto*//*Label 21895*/ GIMT_Encode4(1580661), // Rule ID 4126 //
     /* 1580584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1580595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1580598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1580601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1580604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580615 */     // MIs[0] passthru
     /* 1580615 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580628 */     // MIs[0] policy
     /* 1580628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1580641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580660 */     // GIR_Coverage, 4126,
     /* 1580660 */     GIR_EraseRootFromParent_Done,
     /* 1580661 */   // Label 21895: @1580661
     /* 1580661 */   GIM_Try, /*On fail goto*//*Label 21896*/ GIMT_Encode4(1580743), // Rule ID 4127 //
     /* 1580666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1580677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1580680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1580683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1580686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580697 */     // MIs[0] passthru
     /* 1580697 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580710 */     // MIs[0] policy
     /* 1580710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580720 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1580723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580742 */     // GIR_Coverage, 4127,
     /* 1580742 */     GIR_EraseRootFromParent_Done,
     /* 1580743 */   // Label 21896: @1580743
     /* 1580743 */   GIM_Try, /*On fail goto*//*Label 21897*/ GIMT_Encode4(1580825), // Rule ID 4136 //
     /* 1580748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1580759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1580762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1580765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580779 */     // MIs[0] passthru
     /* 1580779 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580792 */     // MIs[0] policy
     /* 1580792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1580805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580824 */     // GIR_Coverage, 4136,
     /* 1580824 */     GIR_EraseRootFromParent_Done,
     /* 1580825 */   // Label 21897: @1580825
     /* 1580825 */   GIM_Try, /*On fail goto*//*Label 21898*/ GIMT_Encode4(1580907), // Rule ID 4137 //
     /* 1580830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1580841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1580844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1580847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580861 */     // MIs[0] passthru
     /* 1580861 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580874 */     // MIs[0] policy
     /* 1580874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580884 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1580887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580906 */     // GIR_Coverage, 4137,
     /* 1580906 */     GIR_EraseRootFromParent_Done,
     /* 1580907 */   // Label 21898: @1580907
     /* 1580907 */   GIM_Try, /*On fail goto*//*Label 21899*/ GIMT_Encode4(1580989), // Rule ID 4146 //
     /* 1580912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1580923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1580926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1580929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580943 */     // MIs[0] passthru
     /* 1580943 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580956 */     // MIs[0] policy
     /* 1580956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1580969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580988 */     // GIR_Coverage, 4146,
     /* 1580988 */     GIR_EraseRootFromParent_Done,
     /* 1580989 */   // Label 21899: @1580989
     /* 1580989 */   GIM_Try, /*On fail goto*//*Label 21900*/ GIMT_Encode4(1581071), // Rule ID 4147 //
     /* 1580994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1581005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1581008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1581011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581025 */     // MIs[0] passthru
     /* 1581025 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581038 */     // MIs[0] policy
     /* 1581038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1581051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581070 */     // GIR_Coverage, 4147,
     /* 1581070 */     GIR_EraseRootFromParent_Done,
     /* 1581071 */   // Label 21900: @1581071
     /* 1581071 */   GIM_Try, /*On fail goto*//*Label 21901*/ GIMT_Encode4(1581153), // Rule ID 4156 //
     /* 1581076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1581087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1581090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1581093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581107 */     // MIs[0] passthru
     /* 1581107 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581120 */     // MIs[0] policy
     /* 1581120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581130 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1581133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581152 */     // GIR_Coverage, 4156,
     /* 1581152 */     GIR_EraseRootFromParent_Done,
     /* 1581153 */   // Label 21901: @1581153
     /* 1581153 */   GIM_Try, /*On fail goto*//*Label 21902*/ GIMT_Encode4(1581235), // Rule ID 4157 //
     /* 1581158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1581169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1581172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1581175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581189 */     // MIs[0] passthru
     /* 1581189 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581202 */     // MIs[0] policy
     /* 1581202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581212 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1581215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581234 */     // GIR_Coverage, 4157,
     /* 1581234 */     GIR_EraseRootFromParent_Done,
     /* 1581235 */   // Label 21902: @1581235
     /* 1581235 */   GIM_Try, /*On fail goto*//*Label 21903*/ GIMT_Encode4(1581317), // Rule ID 4166 //
     /* 1581240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1581251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1581254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1581257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581271 */     // MIs[0] passthru
     /* 1581271 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581284 */     // MIs[0] policy
     /* 1581284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581294 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1581297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581316 */     // GIR_Coverage, 4166,
     /* 1581316 */     GIR_EraseRootFromParent_Done,
     /* 1581317 */   // Label 21903: @1581317
     /* 1581317 */   GIM_Try, /*On fail goto*//*Label 21904*/ GIMT_Encode4(1581399), // Rule ID 4167 //
     /* 1581322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1581333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1581336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1581339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581353 */     // MIs[0] passthru
     /* 1581353 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581366 */     // MIs[0] policy
     /* 1581366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581376 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1581379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581398 */     // GIR_Coverage, 4167,
     /* 1581398 */     GIR_EraseRootFromParent_Done,
     /* 1581399 */   // Label 21904: @1581399
     /* 1581399 */   GIM_Try, /*On fail goto*//*Label 21905*/ GIMT_Encode4(1581481), // Rule ID 4176 //
     /* 1581404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1581415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1581418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1581421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581435 */     // MIs[0] passthru
     /* 1581435 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581448 */     // MIs[0] policy
     /* 1581448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581458 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1581461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581480 */     // GIR_Coverage, 4176,
     /* 1581480 */     GIR_EraseRootFromParent_Done,
     /* 1581481 */   // Label 21905: @1581481
     /* 1581481 */   GIM_Try, /*On fail goto*//*Label 21906*/ GIMT_Encode4(1581563), // Rule ID 4177 //
     /* 1581486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1581497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1581500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1581503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581517 */     // MIs[0] passthru
     /* 1581517 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581530 */     // MIs[0] policy
     /* 1581530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581540 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1581543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581562 */     // GIR_Coverage, 4177,
     /* 1581562 */     GIR_EraseRootFromParent_Done,
     /* 1581563 */   // Label 21906: @1581563
     /* 1581563 */   GIM_Try, /*On fail goto*//*Label 21907*/ GIMT_Encode4(1581645), // Rule ID 4186 //
     /* 1581568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1581579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1581582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1581585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581599 */     // MIs[0] passthru
     /* 1581599 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581612 */     // MIs[0] policy
     /* 1581612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581622 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1581625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581644 */     // GIR_Coverage, 4186,
     /* 1581644 */     GIR_EraseRootFromParent_Done,
     /* 1581645 */   // Label 21907: @1581645
     /* 1581645 */   GIM_Try, /*On fail goto*//*Label 21908*/ GIMT_Encode4(1581727), // Rule ID 4187 //
     /* 1581650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1581661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1581664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1581667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581681 */     // MIs[0] passthru
     /* 1581681 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581694 */     // MIs[0] policy
     /* 1581694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581704 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1581707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581726 */     // GIR_Coverage, 4187,
     /* 1581726 */     GIR_EraseRootFromParent_Done,
     /* 1581727 */   // Label 21908: @1581727
     /* 1581727 */   GIM_Try, /*On fail goto*//*Label 21909*/ GIMT_Encode4(1581809), // Rule ID 4196 //
     /* 1581732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1581743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1581746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1581749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581763 */     // MIs[0] passthru
     /* 1581763 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581776 */     // MIs[0] policy
     /* 1581776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1581789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581808 */     // GIR_Coverage, 4196,
     /* 1581808 */     GIR_EraseRootFromParent_Done,
     /* 1581809 */   // Label 21909: @1581809
     /* 1581809 */   GIM_Try, /*On fail goto*//*Label 21910*/ GIMT_Encode4(1581891), // Rule ID 4197 //
     /* 1581814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1581825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1581828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1581831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581845 */     // MIs[0] passthru
     /* 1581845 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581858 */     // MIs[0] policy
     /* 1581858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1581871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581890 */     // GIR_Coverage, 4197,
     /* 1581890 */     GIR_EraseRootFromParent_Done,
     /* 1581891 */   // Label 21910: @1581891
     /* 1581891 */   GIM_Try, /*On fail goto*//*Label 21911*/ GIMT_Encode4(1581973), // Rule ID 4206 //
     /* 1581896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1581907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1581910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1581913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581927 */     // MIs[0] passthru
     /* 1581927 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581940 */     // MIs[0] policy
     /* 1581940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1581953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581972 */     // GIR_Coverage, 4206,
     /* 1581972 */     GIR_EraseRootFromParent_Done,
     /* 1581973 */   // Label 21911: @1581973
     /* 1581973 */   GIM_Try, /*On fail goto*//*Label 21912*/ GIMT_Encode4(1582055), // Rule ID 4207 //
     /* 1581978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1581989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1581992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1581995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582009 */     // MIs[0] passthru
     /* 1582009 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582022 */     // MIs[0] policy
     /* 1582022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582032 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1582035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582054 */     // GIR_Coverage, 4207,
     /* 1582054 */     GIR_EraseRootFromParent_Done,
     /* 1582055 */   // Label 21912: @1582055
     /* 1582055 */   GIM_Try, /*On fail goto*//*Label 21913*/ GIMT_Encode4(1582137), // Rule ID 4216 //
     /* 1582060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1582063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1582068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1582071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1582074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1582077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582091 */     // MIs[0] passthru
     /* 1582091 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582104 */     // MIs[0] policy
     /* 1582104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1582117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582136 */     // GIR_Coverage, 4216,
     /* 1582136 */     GIR_EraseRootFromParent_Done,
     /* 1582137 */   // Label 21913: @1582137
     /* 1582137 */   GIM_Try, /*On fail goto*//*Label 21914*/ GIMT_Encode4(1582219), // Rule ID 4217 //
     /* 1582142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1582145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1582150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1582153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1582156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1582159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582173 */     // MIs[0] passthru
     /* 1582173 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582186 */     // MIs[0] policy
     /* 1582186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582196 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1582199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582218 */     // GIR_Coverage, 4217,
     /* 1582218 */     GIR_EraseRootFromParent_Done,
     /* 1582219 */   // Label 21914: @1582219
     /* 1582219 */   GIM_Try, /*On fail goto*//*Label 21915*/ GIMT_Encode4(1582301), // Rule ID 4286 //
     /* 1582224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1582235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1582238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1582241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582255 */     // MIs[0] passthru
     /* 1582255 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582268 */     // MIs[0] policy
     /* 1582268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582278 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1582281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582300 */     // GIR_Coverage, 4286,
     /* 1582300 */     GIR_EraseRootFromParent_Done,
     /* 1582301 */   // Label 21915: @1582301
     /* 1582301 */   GIM_Try, /*On fail goto*//*Label 21916*/ GIMT_Encode4(1582383), // Rule ID 4287 //
     /* 1582306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1582317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1582320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1582323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582337 */     // MIs[0] passthru
     /* 1582337 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582350 */     // MIs[0] policy
     /* 1582350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582360 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1582363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582382 */     // GIR_Coverage, 4287,
     /* 1582382 */     GIR_EraseRootFromParent_Done,
     /* 1582383 */   // Label 21916: @1582383
     /* 1582383 */   GIM_Try, /*On fail goto*//*Label 21917*/ GIMT_Encode4(1582465), // Rule ID 4296 //
     /* 1582388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1582399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1582402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1582405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582419 */     // MIs[0] passthru
     /* 1582419 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582432 */     // MIs[0] policy
     /* 1582432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582442 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1582445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582464 */     // GIR_Coverage, 4296,
     /* 1582464 */     GIR_EraseRootFromParent_Done,
     /* 1582465 */   // Label 21917: @1582465
     /* 1582465 */   GIM_Try, /*On fail goto*//*Label 21918*/ GIMT_Encode4(1582547), // Rule ID 4297 //
     /* 1582470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1582481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1582484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1582487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582501 */     // MIs[0] passthru
     /* 1582501 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582514 */     // MIs[0] policy
     /* 1582514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582524 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1582527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582546 */     // GIR_Coverage, 4297,
     /* 1582546 */     GIR_EraseRootFromParent_Done,
     /* 1582547 */   // Label 21918: @1582547
     /* 1582547 */   GIM_Try, /*On fail goto*//*Label 21919*/ GIMT_Encode4(1582629), // Rule ID 4306 //
     /* 1582552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1582563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1582566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1582569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582583 */     // MIs[0] passthru
     /* 1582583 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582596 */     // MIs[0] policy
     /* 1582596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582606 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1582609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582628 */     // GIR_Coverage, 4306,
     /* 1582628 */     GIR_EraseRootFromParent_Done,
     /* 1582629 */   // Label 21919: @1582629
     /* 1582629 */   GIM_Try, /*On fail goto*//*Label 21920*/ GIMT_Encode4(1582711), // Rule ID 4307 //
     /* 1582634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1582645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1582648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1582651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582665 */     // MIs[0] passthru
     /* 1582665 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582678 */     // MIs[0] policy
     /* 1582678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582688 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1582691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582710 */     // GIR_Coverage, 4307,
     /* 1582710 */     GIR_EraseRootFromParent_Done,
     /* 1582711 */   // Label 21920: @1582711
     /* 1582711 */   GIM_Try, /*On fail goto*//*Label 21921*/ GIMT_Encode4(1582793), // Rule ID 4316 //
     /* 1582716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1582727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1582730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1582733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582747 */     // MIs[0] passthru
     /* 1582747 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582760 */     // MIs[0] policy
     /* 1582760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582770 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1582773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582792 */     // GIR_Coverage, 4316,
     /* 1582792 */     GIR_EraseRootFromParent_Done,
     /* 1582793 */   // Label 21921: @1582793
     /* 1582793 */   GIM_Try, /*On fail goto*//*Label 21922*/ GIMT_Encode4(1582875), // Rule ID 4317 //
     /* 1582798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1582809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1582812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1582815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582829 */     // MIs[0] passthru
     /* 1582829 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582842 */     // MIs[0] policy
     /* 1582842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1582855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582874 */     // GIR_Coverage, 4317,
     /* 1582874 */     GIR_EraseRootFromParent_Done,
     /* 1582875 */   // Label 21922: @1582875
     /* 1582875 */   GIM_Try, /*On fail goto*//*Label 21923*/ GIMT_Encode4(1582957), // Rule ID 4326 //
     /* 1582880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1582891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1582894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1582897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1582900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582911 */     // MIs[0] passthru
     /* 1582911 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582924 */     // MIs[0] policy
     /* 1582924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1582937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582956 */     // GIR_Coverage, 4326,
     /* 1582956 */     GIR_EraseRootFromParent_Done,
     /* 1582957 */   // Label 21923: @1582957
     /* 1582957 */   GIM_Try, /*On fail goto*//*Label 21924*/ GIMT_Encode4(1583039), // Rule ID 4327 //
     /* 1582962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1582973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1582976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1582979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1582982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582993 */     // MIs[0] passthru
     /* 1582993 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583006 */     // MIs[0] policy
     /* 1583006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583016 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1583019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583038 */     // GIR_Coverage, 4327,
     /* 1583038 */     GIR_EraseRootFromParent_Done,
     /* 1583039 */   // Label 21924: @1583039
     /* 1583039 */   GIM_Try, /*On fail goto*//*Label 21925*/ GIMT_Encode4(1583121), // Rule ID 4336 //
     /* 1583044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1583055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1583058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1583061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1583064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583075 */     // MIs[0] passthru
     /* 1583075 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583088 */     // MIs[0] policy
     /* 1583088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583098 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1583101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583120 */     // GIR_Coverage, 4336,
     /* 1583120 */     GIR_EraseRootFromParent_Done,
     /* 1583121 */   // Label 21925: @1583121
     /* 1583121 */   GIM_Try, /*On fail goto*//*Label 21926*/ GIMT_Encode4(1583203), // Rule ID 4337 //
     /* 1583126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1583137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1583140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1583143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1583146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583157 */     // MIs[0] passthru
     /* 1583157 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583170 */     // MIs[0] policy
     /* 1583170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583180 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1583183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583202 */     // GIR_Coverage, 4337,
     /* 1583202 */     GIR_EraseRootFromParent_Done,
     /* 1583203 */   // Label 21926: @1583203
     /* 1583203 */   GIM_Try, /*On fail goto*//*Label 21927*/ GIMT_Encode4(1583285), // Rule ID 4346 //
     /* 1583208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1583219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1583222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1583225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583239 */     // MIs[0] passthru
     /* 1583239 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583252 */     // MIs[0] policy
     /* 1583252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583262 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1583265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583284 */     // GIR_Coverage, 4346,
     /* 1583284 */     GIR_EraseRootFromParent_Done,
     /* 1583285 */   // Label 21927: @1583285
     /* 1583285 */   GIM_Try, /*On fail goto*//*Label 21928*/ GIMT_Encode4(1583367), // Rule ID 4347 //
     /* 1583290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1583301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1583304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1583307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583321 */     // MIs[0] passthru
     /* 1583321 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583334 */     // MIs[0] policy
     /* 1583334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1583347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583366 */     // GIR_Coverage, 4347,
     /* 1583366 */     GIR_EraseRootFromParent_Done,
     /* 1583367 */   // Label 21928: @1583367
     /* 1583367 */   GIM_Try, /*On fail goto*//*Label 21929*/ GIMT_Encode4(1583449), // Rule ID 4356 //
     /* 1583372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1583383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1583386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1583389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583403 */     // MIs[0] passthru
     /* 1583403 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583416 */     // MIs[0] policy
     /* 1583416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583426 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1583429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583448 */     // GIR_Coverage, 4356,
     /* 1583448 */     GIR_EraseRootFromParent_Done,
     /* 1583449 */   // Label 21929: @1583449
     /* 1583449 */   GIM_Try, /*On fail goto*//*Label 21930*/ GIMT_Encode4(1583531), // Rule ID 4357 //
     /* 1583454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1583465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1583468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1583471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583485 */     // MIs[0] passthru
     /* 1583485 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583498 */     // MIs[0] policy
     /* 1583498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1583511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583530 */     // GIR_Coverage, 4357,
     /* 1583530 */     GIR_EraseRootFromParent_Done,
     /* 1583531 */   // Label 21930: @1583531
     /* 1583531 */   GIM_Try, /*On fail goto*//*Label 21931*/ GIMT_Encode4(1583613), // Rule ID 4366 //
     /* 1583536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1583547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1583550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1583553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583567 */     // MIs[0] passthru
     /* 1583567 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583580 */     // MIs[0] policy
     /* 1583580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1583593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583612 */     // GIR_Coverage, 4366,
     /* 1583612 */     GIR_EraseRootFromParent_Done,
     /* 1583613 */   // Label 21931: @1583613
     /* 1583613 */   GIM_Try, /*On fail goto*//*Label 21932*/ GIMT_Encode4(1583695), // Rule ID 4367 //
     /* 1583618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1583629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1583632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1583635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583649 */     // MIs[0] passthru
     /* 1583649 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583662 */     // MIs[0] policy
     /* 1583662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1583675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583694 */     // GIR_Coverage, 4367,
     /* 1583694 */     GIR_EraseRootFromParent_Done,
     /* 1583695 */   // Label 21932: @1583695
     /* 1583695 */   GIM_Try, /*On fail goto*//*Label 21933*/ GIMT_Encode4(1583777), // Rule ID 4376 //
     /* 1583700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1583711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1583714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1583717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583731 */     // MIs[0] passthru
     /* 1583731 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583744 */     // MIs[0] policy
     /* 1583744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1583757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583776 */     // GIR_Coverage, 4376,
     /* 1583776 */     GIR_EraseRootFromParent_Done,
     /* 1583777 */   // Label 21933: @1583777
     /* 1583777 */   GIM_Try, /*On fail goto*//*Label 21934*/ GIMT_Encode4(1583859), // Rule ID 4377 //
     /* 1583782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1583793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1583796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1583799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583813 */     // MIs[0] passthru
     /* 1583813 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583826 */     // MIs[0] policy
     /* 1583826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1583839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583858 */     // GIR_Coverage, 4377,
     /* 1583858 */     GIR_EraseRootFromParent_Done,
     /* 1583859 */   // Label 21934: @1583859
     /* 1583859 */   GIM_Try, /*On fail goto*//*Label 21935*/ GIMT_Encode4(1583941), // Rule ID 4386 //
     /* 1583864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1583875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1583878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1583881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1583884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583895 */     // MIs[0] passthru
     /* 1583895 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583908 */     // MIs[0] policy
     /* 1583908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1583921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583940 */     // GIR_Coverage, 4386,
     /* 1583940 */     GIR_EraseRootFromParent_Done,
     /* 1583941 */   // Label 21935: @1583941
     /* 1583941 */   GIM_Try, /*On fail goto*//*Label 21936*/ GIMT_Encode4(1584023), // Rule ID 4387 //
     /* 1583946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1583957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1583960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1583963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1583966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583977 */     // MIs[0] passthru
     /* 1583977 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583990 */     // MIs[0] policy
     /* 1583990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1584003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584022 */     // GIR_Coverage, 4387,
     /* 1584022 */     GIR_EraseRootFromParent_Done,
     /* 1584023 */   // Label 21936: @1584023
     /* 1584023 */   GIM_Try, /*On fail goto*//*Label 21937*/ GIMT_Encode4(1584105), // Rule ID 4396 //
     /* 1584028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1584039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1584042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1584045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584059 */     // MIs[0] passthru
     /* 1584059 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584072 */     // MIs[0] policy
     /* 1584072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1584085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584104 */     // GIR_Coverage, 4396,
     /* 1584104 */     GIR_EraseRootFromParent_Done,
     /* 1584105 */   // Label 21937: @1584105
     /* 1584105 */   GIM_Try, /*On fail goto*//*Label 21938*/ GIMT_Encode4(1584187), // Rule ID 4397 //
     /* 1584110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1584121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1584124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1584127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584141 */     // MIs[0] passthru
     /* 1584141 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584154 */     // MIs[0] policy
     /* 1584154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584164 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1584167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584186 */     // GIR_Coverage, 4397,
     /* 1584186 */     GIR_EraseRootFromParent_Done,
     /* 1584187 */   // Label 21938: @1584187
     /* 1584187 */   GIM_Try, /*On fail goto*//*Label 21939*/ GIMT_Encode4(1584269), // Rule ID 4406 //
     /* 1584192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1584203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1584206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1584209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584223 */     // MIs[0] passthru
     /* 1584223 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584236 */     // MIs[0] policy
     /* 1584236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1584249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584268 */     // GIR_Coverage, 4406,
     /* 1584268 */     GIR_EraseRootFromParent_Done,
     /* 1584269 */   // Label 21939: @1584269
     /* 1584269 */   GIM_Try, /*On fail goto*//*Label 21940*/ GIMT_Encode4(1584351), // Rule ID 4407 //
     /* 1584274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1584285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1584288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1584291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584305 */     // MIs[0] passthru
     /* 1584305 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584318 */     // MIs[0] policy
     /* 1584318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584328 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1584331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584350 */     // GIR_Coverage, 4407,
     /* 1584350 */     GIR_EraseRootFromParent_Done,
     /* 1584351 */   // Label 21940: @1584351
     /* 1584351 */   GIM_Try, /*On fail goto*//*Label 21941*/ GIMT_Encode4(1584433), // Rule ID 4416 //
     /* 1584356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1584367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1584370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1584373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584387 */     // MIs[0] passthru
     /* 1584387 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584400 */     // MIs[0] policy
     /* 1584400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584410 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1584413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584432 */     // GIR_Coverage, 4416,
     /* 1584432 */     GIR_EraseRootFromParent_Done,
     /* 1584433 */   // Label 21941: @1584433
     /* 1584433 */   GIM_Try, /*On fail goto*//*Label 21942*/ GIMT_Encode4(1584515), // Rule ID 4417 //
     /* 1584438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1584449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1584452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1584455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584469 */     // MIs[0] passthru
     /* 1584469 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584482 */     // MIs[0] policy
     /* 1584482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584492 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1584495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584514 */     // GIR_Coverage, 4417,
     /* 1584514 */     GIR_EraseRootFromParent_Done,
     /* 1584515 */   // Label 21942: @1584515
     /* 1584515 */   GIM_Try, /*On fail goto*//*Label 21943*/ GIMT_Encode4(1584597), // Rule ID 4426 //
     /* 1584520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1584531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1584534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1584537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584551 */     // MIs[0] passthru
     /* 1584551 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584564 */     // MIs[0] policy
     /* 1584564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584574 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1584577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584596 */     // GIR_Coverage, 4426,
     /* 1584596 */     GIR_EraseRootFromParent_Done,
     /* 1584597 */   // Label 21943: @1584597
     /* 1584597 */   GIM_Try, /*On fail goto*//*Label 21944*/ GIMT_Encode4(1584679), // Rule ID 4427 //
     /* 1584602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1584613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1584616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1584619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584633 */     // MIs[0] passthru
     /* 1584633 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584646 */     // MIs[0] policy
     /* 1584646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584656 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1584659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584678 */     // GIR_Coverage, 4427,
     /* 1584678 */     GIR_EraseRootFromParent_Done,
     /* 1584679 */   // Label 21944: @1584679
     /* 1584679 */   GIM_Try, /*On fail goto*//*Label 21945*/ GIMT_Encode4(1584761), // Rule ID 4496 //
     /* 1584684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1584695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1584698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1584701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584715 */     // MIs[0] passthru
     /* 1584715 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584728 */     // MIs[0] policy
     /* 1584728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584738 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1584741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584760 */     // GIR_Coverage, 4496,
     /* 1584760 */     GIR_EraseRootFromParent_Done,
     /* 1584761 */   // Label 21945: @1584761
     /* 1584761 */   GIM_Try, /*On fail goto*//*Label 21946*/ GIMT_Encode4(1584843), // Rule ID 4497 //
     /* 1584766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1584777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1584780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1584783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584797 */     // MIs[0] passthru
     /* 1584797 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584810 */     // MIs[0] policy
     /* 1584810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584820 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1584823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584842 */     // GIR_Coverage, 4497,
     /* 1584842 */     GIR_EraseRootFromParent_Done,
     /* 1584843 */   // Label 21946: @1584843
     /* 1584843 */   GIM_Try, /*On fail goto*//*Label 21947*/ GIMT_Encode4(1584925), // Rule ID 4506 //
     /* 1584848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1584859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1584862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1584865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584879 */     // MIs[0] passthru
     /* 1584879 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584892 */     // MIs[0] policy
     /* 1584892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584902 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1584905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584924 */     // GIR_Coverage, 4506,
     /* 1584924 */     GIR_EraseRootFromParent_Done,
     /* 1584925 */   // Label 21947: @1584925
     /* 1584925 */   GIM_Try, /*On fail goto*//*Label 21948*/ GIMT_Encode4(1585007), // Rule ID 4507 //
     /* 1584930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1584941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1584944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1584947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584961 */     // MIs[0] passthru
     /* 1584961 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584974 */     // MIs[0] policy
     /* 1584974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1584987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585006 */     // GIR_Coverage, 4507,
     /* 1585006 */     GIR_EraseRootFromParent_Done,
     /* 1585007 */   // Label 21948: @1585007
     /* 1585007 */   GIM_Try, /*On fail goto*//*Label 21949*/ GIMT_Encode4(1585089), // Rule ID 4516 //
     /* 1585012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1585023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1585026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1585029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585043 */     // MIs[0] passthru
     /* 1585043 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585056 */     // MIs[0] policy
     /* 1585056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585066 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1585069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585088 */     // GIR_Coverage, 4516,
     /* 1585088 */     GIR_EraseRootFromParent_Done,
     /* 1585089 */   // Label 21949: @1585089
     /* 1585089 */   GIM_Try, /*On fail goto*//*Label 21950*/ GIMT_Encode4(1585171), // Rule ID 4517 //
     /* 1585094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1585105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1585108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1585111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585125 */     // MIs[0] passthru
     /* 1585125 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585138 */     // MIs[0] policy
     /* 1585138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585148 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1585151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585170 */     // GIR_Coverage, 4517,
     /* 1585170 */     GIR_EraseRootFromParent_Done,
     /* 1585171 */   // Label 21950: @1585171
     /* 1585171 */   GIM_Try, /*On fail goto*//*Label 21951*/ GIMT_Encode4(1585253), // Rule ID 4526 //
     /* 1585176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1585187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1585190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1585193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585207 */     // MIs[0] passthru
     /* 1585207 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585220 */     // MIs[0] policy
     /* 1585220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585230 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1585233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585252 */     // GIR_Coverage, 4526,
     /* 1585252 */     GIR_EraseRootFromParent_Done,
     /* 1585253 */   // Label 21951: @1585253
     /* 1585253 */   GIM_Try, /*On fail goto*//*Label 21952*/ GIMT_Encode4(1585335), // Rule ID 4527 //
     /* 1585258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1585269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1585272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1585275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585289 */     // MIs[0] passthru
     /* 1585289 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585302 */     // MIs[0] policy
     /* 1585302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585312 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1585315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585334 */     // GIR_Coverage, 4527,
     /* 1585334 */     GIR_EraseRootFromParent_Done,
     /* 1585335 */   // Label 21952: @1585335
     /* 1585335 */   GIM_Try, /*On fail goto*//*Label 21953*/ GIMT_Encode4(1585417), // Rule ID 4536 //
     /* 1585340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1585351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1585354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1585357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585371 */     // MIs[0] passthru
     /* 1585371 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585384 */     // MIs[0] policy
     /* 1585384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585394 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1585397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585416 */     // GIR_Coverage, 4536,
     /* 1585416 */     GIR_EraseRootFromParent_Done,
     /* 1585417 */   // Label 21953: @1585417
     /* 1585417 */   GIM_Try, /*On fail goto*//*Label 21954*/ GIMT_Encode4(1585499), // Rule ID 4537 //
     /* 1585422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1585433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1585436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1585439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585453 */     // MIs[0] passthru
     /* 1585453 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585466 */     // MIs[0] policy
     /* 1585466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585476 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1585479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585498 */     // GIR_Coverage, 4537,
     /* 1585498 */     GIR_EraseRootFromParent_Done,
     /* 1585499 */   // Label 21954: @1585499
     /* 1585499 */   GIM_Try, /*On fail goto*//*Label 21955*/ GIMT_Encode4(1585581), // Rule ID 4546 //
     /* 1585504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1585521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585535 */     // MIs[0] passthru
     /* 1585535 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585548 */     // MIs[0] policy
     /* 1585548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1585561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585580 */     // GIR_Coverage, 4546,
     /* 1585580 */     GIR_EraseRootFromParent_Done,
     /* 1585581 */   // Label 21955: @1585581
     /* 1585581 */   GIM_Try, /*On fail goto*//*Label 21956*/ GIMT_Encode4(1585663), // Rule ID 4547 //
     /* 1585586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1585603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585617 */     // MIs[0] passthru
     /* 1585617 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585630 */     // MIs[0] policy
     /* 1585630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585640 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1585643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585662 */     // GIR_Coverage, 4547,
     /* 1585662 */     GIR_EraseRootFromParent_Done,
     /* 1585663 */   // Label 21956: @1585663
     /* 1585663 */   GIM_Try, /*On fail goto*//*Label 21957*/ GIMT_Encode4(1585745), // Rule ID 4556 //
     /* 1585668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1585679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1585682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1585685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585699 */     // MIs[0] passthru
     /* 1585699 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585712 */     // MIs[0] policy
     /* 1585712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585722 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1585725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585744 */     // GIR_Coverage, 4556,
     /* 1585744 */     GIR_EraseRootFromParent_Done,
     /* 1585745 */   // Label 21957: @1585745
     /* 1585745 */   GIM_Try, /*On fail goto*//*Label 21958*/ GIMT_Encode4(1585827), // Rule ID 4557 //
     /* 1585750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1585761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1585764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1585767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585781 */     // MIs[0] passthru
     /* 1585781 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585794 */     // MIs[0] policy
     /* 1585794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585804 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1585807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585826 */     // GIR_Coverage, 4557,
     /* 1585826 */     GIR_EraseRootFromParent_Done,
     /* 1585827 */   // Label 21958: @1585827
     /* 1585827 */   GIM_Try, /*On fail goto*//*Label 21959*/ GIMT_Encode4(1585909), // Rule ID 4566 //
     /* 1585832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1585843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1585846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1585849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585863 */     // MIs[0] passthru
     /* 1585863 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585876 */     // MIs[0] policy
     /* 1585876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1585889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585908 */     // GIR_Coverage, 4566,
     /* 1585908 */     GIR_EraseRootFromParent_Done,
     /* 1585909 */   // Label 21959: @1585909
     /* 1585909 */   GIM_Try, /*On fail goto*//*Label 21960*/ GIMT_Encode4(1585991), // Rule ID 4567 //
     /* 1585914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1585925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1585928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1585931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585945 */     // MIs[0] passthru
     /* 1585945 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585958 */     // MIs[0] policy
     /* 1585958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585968 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1585971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585990 */     // GIR_Coverage, 4567,
     /* 1585990 */     GIR_EraseRootFromParent_Done,
     /* 1585991 */   // Label 21960: @1585991
     /* 1585991 */   GIM_Try, /*On fail goto*//*Label 21961*/ GIMT_Encode4(1586073), // Rule ID 4576 //
     /* 1585996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1586007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1586010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1586013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586027 */     // MIs[0] passthru
     /* 1586027 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586040 */     // MIs[0] policy
     /* 1586040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586050 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1586053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586072 */     // GIR_Coverage, 4576,
     /* 1586072 */     GIR_EraseRootFromParent_Done,
     /* 1586073 */   // Label 21961: @1586073
     /* 1586073 */   GIM_Try, /*On fail goto*//*Label 21962*/ GIMT_Encode4(1586155), // Rule ID 4577 //
     /* 1586078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1586089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1586092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1586095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586109 */     // MIs[0] passthru
     /* 1586109 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586122 */     // MIs[0] policy
     /* 1586122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586132 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1586135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586154 */     // GIR_Coverage, 4577,
     /* 1586154 */     GIR_EraseRootFromParent_Done,
     /* 1586155 */   // Label 21962: @1586155
     /* 1586155 */   GIM_Try, /*On fail goto*//*Label 21963*/ GIMT_Encode4(1586237), // Rule ID 4586 //
     /* 1586160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1586171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1586174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1586177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586191 */     // MIs[0] passthru
     /* 1586191 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586204 */     // MIs[0] policy
     /* 1586204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1586217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586236 */     // GIR_Coverage, 4586,
     /* 1586236 */     GIR_EraseRootFromParent_Done,
     /* 1586237 */   // Label 21963: @1586237
     /* 1586237 */   GIM_Try, /*On fail goto*//*Label 21964*/ GIMT_Encode4(1586319), // Rule ID 4587 //
     /* 1586242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1586253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1586256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1586259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586273 */     // MIs[0] passthru
     /* 1586273 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586286 */     // MIs[0] policy
     /* 1586286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586296 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1586299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586318 */     // GIR_Coverage, 4587,
     /* 1586318 */     GIR_EraseRootFromParent_Done,
     /* 1586319 */   // Label 21964: @1586319
     /* 1586319 */   GIM_Try, /*On fail goto*//*Label 21965*/ GIMT_Encode4(1586401), // Rule ID 4596 //
     /* 1586324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1586335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1586338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1586341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1586344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586355 */     // MIs[0] passthru
     /* 1586355 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586368 */     // MIs[0] policy
     /* 1586368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586378 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1586381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586400 */     // GIR_Coverage, 4596,
     /* 1586400 */     GIR_EraseRootFromParent_Done,
     /* 1586401 */   // Label 21965: @1586401
     /* 1586401 */   GIM_Try, /*On fail goto*//*Label 21966*/ GIMT_Encode4(1586483), // Rule ID 4597 //
     /* 1586406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1586417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1586420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1586423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1586426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586437 */     // MIs[0] passthru
     /* 1586437 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586450 */     // MIs[0] policy
     /* 1586450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586460 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1586463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586482 */     // GIR_Coverage, 4597,
     /* 1586482 */     GIR_EraseRootFromParent_Done,
     /* 1586483 */   // Label 21966: @1586483
     /* 1586483 */   GIM_Try, /*On fail goto*//*Label 21967*/ GIMT_Encode4(1586565), // Rule ID 4606 //
     /* 1586488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1586499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1586502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1586505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586519 */     // MIs[0] passthru
     /* 1586519 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586532 */     // MIs[0] policy
     /* 1586532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586542 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1586545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586564 */     // GIR_Coverage, 4606,
     /* 1586564 */     GIR_EraseRootFromParent_Done,
     /* 1586565 */   // Label 21967: @1586565
     /* 1586565 */   GIM_Try, /*On fail goto*//*Label 21968*/ GIMT_Encode4(1586647), // Rule ID 4607 //
     /* 1586570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1586581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1586584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1586587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586601 */     // MIs[0] passthru
     /* 1586601 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586614 */     // MIs[0] policy
     /* 1586614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1586627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586646 */     // GIR_Coverage, 4607,
     /* 1586646 */     GIR_EraseRootFromParent_Done,
     /* 1586647 */   // Label 21968: @1586647
     /* 1586647 */   GIM_Try, /*On fail goto*//*Label 21969*/ GIMT_Encode4(1586729), // Rule ID 4616 //
     /* 1586652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1586669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586683 */     // MIs[0] passthru
     /* 1586683 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586696 */     // MIs[0] policy
     /* 1586696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586706 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1586709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586728 */     // GIR_Coverage, 4616,
     /* 1586728 */     GIR_EraseRootFromParent_Done,
     /* 1586729 */   // Label 21969: @1586729
     /* 1586729 */   GIM_Try, /*On fail goto*//*Label 21970*/ GIMT_Encode4(1586811), // Rule ID 4617 //
     /* 1586734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1586751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586765 */     // MIs[0] passthru
     /* 1586765 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586778 */     // MIs[0] policy
     /* 1586778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1586791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586810 */     // GIR_Coverage, 4617,
     /* 1586810 */     GIR_EraseRootFromParent_Done,
     /* 1586811 */   // Label 21970: @1586811
     /* 1586811 */   GIM_Try, /*On fail goto*//*Label 21971*/ GIMT_Encode4(1586893), // Rule ID 4626 //
     /* 1586816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1586833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586847 */     // MIs[0] passthru
     /* 1586847 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586860 */     // MIs[0] policy
     /* 1586860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586870 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1586873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586892 */     // GIR_Coverage, 4626,
     /* 1586892 */     GIR_EraseRootFromParent_Done,
     /* 1586893 */   // Label 21971: @1586893
     /* 1586893 */   GIM_Try, /*On fail goto*//*Label 21972*/ GIMT_Encode4(1586975), // Rule ID 4627 //
     /* 1586898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1586915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586929 */     // MIs[0] passthru
     /* 1586929 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586942 */     // MIs[0] policy
     /* 1586942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586952 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1586955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586974 */     // GIR_Coverage, 4627,
     /* 1586974 */     GIR_EraseRootFromParent_Done,
     /* 1586975 */   // Label 21972: @1586975
     /* 1586975 */   GIM_Try, /*On fail goto*//*Label 21973*/ GIMT_Encode4(1587057), // Rule ID 4636 //
     /* 1586980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1586991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1586994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1586997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587011 */     // MIs[0] passthru
     /* 1587011 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587024 */     // MIs[0] policy
     /* 1587024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587034 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1587037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587056 */     // GIR_Coverage, 4636,
     /* 1587056 */     GIR_EraseRootFromParent_Done,
     /* 1587057 */   // Label 21973: @1587057
     /* 1587057 */   GIM_Try, /*On fail goto*//*Label 21974*/ GIMT_Encode4(1587139), // Rule ID 4637 //
     /* 1587062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1587065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1587070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1587073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1587076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1587079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587093 */     // MIs[0] passthru
     /* 1587093 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587106 */     // MIs[0] policy
     /* 1587106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1587119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587138 */     // GIR_Coverage, 4637,
     /* 1587138 */     GIR_EraseRootFromParent_Done,
     /* 1587139 */   // Label 21974: @1587139
     /* 1587139 */   GIM_Try, /*On fail goto*//*Label 21975*/ GIMT_Encode4(1587221), // Rule ID 4706 //
     /* 1587144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1587155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1587158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1587161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587175 */     // MIs[0] passthru
     /* 1587175 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587188 */     // MIs[0] policy
     /* 1587188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1587201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587220 */     // GIR_Coverage, 4706,
     /* 1587220 */     GIR_EraseRootFromParent_Done,
     /* 1587221 */   // Label 21975: @1587221
     /* 1587221 */   GIM_Try, /*On fail goto*//*Label 21976*/ GIMT_Encode4(1587303), // Rule ID 4707 //
     /* 1587226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1587237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1587240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1587243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587257 */     // MIs[0] passthru
     /* 1587257 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587270 */     // MIs[0] policy
     /* 1587270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587280 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1587283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587302 */     // GIR_Coverage, 4707,
     /* 1587302 */     GIR_EraseRootFromParent_Done,
     /* 1587303 */   // Label 21976: @1587303
     /* 1587303 */   GIM_Try, /*On fail goto*//*Label 21977*/ GIMT_Encode4(1587385), // Rule ID 4716 //
     /* 1587308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1587319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1587322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1587325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587339 */     // MIs[0] passthru
     /* 1587339 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587352 */     // MIs[0] policy
     /* 1587352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587362 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1587365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587384 */     // GIR_Coverage, 4716,
     /* 1587384 */     GIR_EraseRootFromParent_Done,
     /* 1587385 */   // Label 21977: @1587385
     /* 1587385 */   GIM_Try, /*On fail goto*//*Label 21978*/ GIMT_Encode4(1587467), // Rule ID 4717 //
     /* 1587390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1587401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1587404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1587407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587421 */     // MIs[0] passthru
     /* 1587421 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587434 */     // MIs[0] policy
     /* 1587434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587444 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1587447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587466 */     // GIR_Coverage, 4717,
     /* 1587466 */     GIR_EraseRootFromParent_Done,
     /* 1587467 */   // Label 21978: @1587467
     /* 1587467 */   GIM_Try, /*On fail goto*//*Label 21979*/ GIMT_Encode4(1587549), // Rule ID 4726 //
     /* 1587472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1587483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1587486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1587489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587503 */     // MIs[0] passthru
     /* 1587503 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587516 */     // MIs[0] policy
     /* 1587516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587526 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1587529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587548 */     // GIR_Coverage, 4726,
     /* 1587548 */     GIR_EraseRootFromParent_Done,
     /* 1587549 */   // Label 21979: @1587549
     /* 1587549 */   GIM_Try, /*On fail goto*//*Label 21980*/ GIMT_Encode4(1587631), // Rule ID 4727 //
     /* 1587554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1587565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1587568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1587571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587585 */     // MIs[0] passthru
     /* 1587585 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587598 */     // MIs[0] policy
     /* 1587598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1587611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587630 */     // GIR_Coverage, 4727,
     /* 1587630 */     GIR_EraseRootFromParent_Done,
     /* 1587631 */   // Label 21980: @1587631
     /* 1587631 */   GIM_Try, /*On fail goto*//*Label 21981*/ GIMT_Encode4(1587713), // Rule ID 4736 //
     /* 1587636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1587647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1587650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1587653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1587663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587667 */     // MIs[0] passthru
     /* 1587667 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587680 */     // MIs[0] policy
     /* 1587680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587690 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1587693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587712 */     // GIR_Coverage, 4736,
     /* 1587712 */     GIR_EraseRootFromParent_Done,
     /* 1587713 */   // Label 21981: @1587713
     /* 1587713 */   GIM_Try, /*On fail goto*//*Label 21982*/ GIMT_Encode4(1587795), // Rule ID 4737 //
     /* 1587718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1587729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1587732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1587735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1587745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587749 */     // MIs[0] passthru
     /* 1587749 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587762 */     // MIs[0] policy
     /* 1587762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587772 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1587775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587794 */     // GIR_Coverage, 4737,
     /* 1587794 */     GIR_EraseRootFromParent_Done,
     /* 1587795 */   // Label 21982: @1587795
     /* 1587795 */   GIM_Try, /*On fail goto*//*Label 21983*/ GIMT_Encode4(1587877), // Rule ID 4746 //
     /* 1587800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1587811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1587814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1587817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1587820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1587827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587831 */     // MIs[0] passthru
     /* 1587831 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587844 */     // MIs[0] policy
     /* 1587844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587854 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1587857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587876 */     // GIR_Coverage, 4746,
     /* 1587876 */     GIR_EraseRootFromParent_Done,
     /* 1587877 */   // Label 21983: @1587877
     /* 1587877 */   GIM_Try, /*On fail goto*//*Label 21984*/ GIMT_Encode4(1587959), // Rule ID 4747 //
     /* 1587882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1587893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1587896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1587899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1587902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1587909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587913 */     // MIs[0] passthru
     /* 1587913 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587926 */     // MIs[0] policy
     /* 1587926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587936 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1587939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587958 */     // GIR_Coverage, 4747,
     /* 1587958 */     GIR_EraseRootFromParent_Done,
     /* 1587959 */   // Label 21984: @1587959
     /* 1587959 */   GIM_Try, /*On fail goto*//*Label 21985*/ GIMT_Encode4(1588041), // Rule ID 4756 //
     /* 1587964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1587975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1587978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1587981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1587984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587995 */     // MIs[0] passthru
     /* 1587995 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588008 */     // MIs[0] policy
     /* 1588008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588018 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1588021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588040 */     // GIR_Coverage, 4756,
     /* 1588040 */     GIR_EraseRootFromParent_Done,
     /* 1588041 */   // Label 21985: @1588041
     /* 1588041 */   GIM_Try, /*On fail goto*//*Label 21986*/ GIMT_Encode4(1588123), // Rule ID 4757 //
     /* 1588046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1588057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1588060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1588063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1588066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588077 */     // MIs[0] passthru
     /* 1588077 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588090 */     // MIs[0] policy
     /* 1588090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588100 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1588103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588122 */     // GIR_Coverage, 4757,
     /* 1588122 */     GIR_EraseRootFromParent_Done,
     /* 1588123 */   // Label 21986: @1588123
     /* 1588123 */   GIM_Try, /*On fail goto*//*Label 21987*/ GIMT_Encode4(1588205), // Rule ID 4766 //
     /* 1588128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1588139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1588142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1588145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588159 */     // MIs[0] passthru
     /* 1588159 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588172 */     // MIs[0] policy
     /* 1588172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588182 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1588185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588204 */     // GIR_Coverage, 4766,
     /* 1588204 */     GIR_EraseRootFromParent_Done,
     /* 1588205 */   // Label 21987: @1588205
     /* 1588205 */   GIM_Try, /*On fail goto*//*Label 21988*/ GIMT_Encode4(1588287), // Rule ID 4767 //
     /* 1588210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1588221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1588224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1588227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588241 */     // MIs[0] passthru
     /* 1588241 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588254 */     // MIs[0] policy
     /* 1588254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1588267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588286 */     // GIR_Coverage, 4767,
     /* 1588286 */     GIR_EraseRootFromParent_Done,
     /* 1588287 */   // Label 21988: @1588287
     /* 1588287 */   GIM_Try, /*On fail goto*//*Label 21989*/ GIMT_Encode4(1588369), // Rule ID 4776 //
     /* 1588292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1588303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1588306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1588309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588323 */     // MIs[0] passthru
     /* 1588323 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588336 */     // MIs[0] policy
     /* 1588336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588346 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1588349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588368 */     // GIR_Coverage, 4776,
     /* 1588368 */     GIR_EraseRootFromParent_Done,
     /* 1588369 */   // Label 21989: @1588369
     /* 1588369 */   GIM_Try, /*On fail goto*//*Label 21990*/ GIMT_Encode4(1588451), // Rule ID 4777 //
     /* 1588374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1588385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1588388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1588391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588405 */     // MIs[0] passthru
     /* 1588405 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588418 */     // MIs[0] policy
     /* 1588418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1588431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588450 */     // GIR_Coverage, 4777,
     /* 1588450 */     GIR_EraseRootFromParent_Done,
     /* 1588451 */   // Label 21990: @1588451
     /* 1588451 */   GIM_Try, /*On fail goto*//*Label 21991*/ GIMT_Encode4(1588533), // Rule ID 4786 //
     /* 1588456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1588467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1588470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1588473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588487 */     // MIs[0] passthru
     /* 1588487 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588500 */     // MIs[0] policy
     /* 1588500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588510 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1588513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588532 */     // GIR_Coverage, 4786,
     /* 1588532 */     GIR_EraseRootFromParent_Done,
     /* 1588533 */   // Label 21991: @1588533
     /* 1588533 */   GIM_Try, /*On fail goto*//*Label 21992*/ GIMT_Encode4(1588615), // Rule ID 4787 //
     /* 1588538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1588549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1588552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1588555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588569 */     // MIs[0] passthru
     /* 1588569 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588582 */     // MIs[0] policy
     /* 1588582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588592 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1588595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588614 */     // GIR_Coverage, 4787,
     /* 1588614 */     GIR_EraseRootFromParent_Done,
     /* 1588615 */   // Label 21992: @1588615
     /* 1588615 */   GIM_Try, /*On fail goto*//*Label 21993*/ GIMT_Encode4(1588697), // Rule ID 4796 //
     /* 1588620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1588631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1588634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1588637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588651 */     // MIs[0] passthru
     /* 1588651 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588664 */     // MIs[0] policy
     /* 1588664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1588677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588696 */     // GIR_Coverage, 4796,
     /* 1588696 */     GIR_EraseRootFromParent_Done,
     /* 1588697 */   // Label 21993: @1588697
     /* 1588697 */   GIM_Try, /*On fail goto*//*Label 21994*/ GIMT_Encode4(1588779), // Rule ID 4797 //
     /* 1588702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1588713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1588716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1588719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588733 */     // MIs[0] passthru
     /* 1588733 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588746 */     // MIs[0] policy
     /* 1588746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588756 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1588759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588778 */     // GIR_Coverage, 4797,
     /* 1588778 */     GIR_EraseRootFromParent_Done,
     /* 1588779 */   // Label 21994: @1588779
     /* 1588779 */   GIM_Try, /*On fail goto*//*Label 21995*/ GIMT_Encode4(1588861), // Rule ID 4806 //
     /* 1588784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1588795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1588798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1588801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588815 */     // MIs[0] passthru
     /* 1588815 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588828 */     // MIs[0] policy
     /* 1588828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588838 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1588841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588860 */     // GIR_Coverage, 4806,
     /* 1588860 */     GIR_EraseRootFromParent_Done,
     /* 1588861 */   // Label 21995: @1588861
     /* 1588861 */   GIM_Try, /*On fail goto*//*Label 21996*/ GIMT_Encode4(1588943), // Rule ID 4807 //
     /* 1588866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1588877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1588880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1588883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588897 */     // MIs[0] passthru
     /* 1588897 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588910 */     // MIs[0] policy
     /* 1588910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588920 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1588923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588942 */     // GIR_Coverage, 4807,
     /* 1588942 */     GIR_EraseRootFromParent_Done,
     /* 1588943 */   // Label 21996: @1588943
     /* 1588943 */   GIM_Try, /*On fail goto*//*Label 21997*/ GIMT_Encode4(1589025), // Rule ID 4816 //
     /* 1588948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1588951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1588959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1588962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1588965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588979 */     // MIs[0] passthru
     /* 1588979 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588992 */     // MIs[0] policy
     /* 1588992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589002 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1589005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589024 */     // GIR_Coverage, 4816,
     /* 1589024 */     GIR_EraseRootFromParent_Done,
     /* 1589025 */   // Label 21997: @1589025
     /* 1589025 */   GIM_Try, /*On fail goto*//*Label 21998*/ GIMT_Encode4(1589107), // Rule ID 4817 //
     /* 1589030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1589033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1589041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1589044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1589047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589061 */     // MIs[0] passthru
     /* 1589061 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589074 */     // MIs[0] policy
     /* 1589074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589084 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1589087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589106 */     // GIR_Coverage, 4817,
     /* 1589106 */     GIR_EraseRootFromParent_Done,
     /* 1589107 */   // Label 21998: @1589107
     /* 1589107 */   GIM_Try, /*On fail goto*//*Label 21999*/ GIMT_Encode4(1589189), // Rule ID 4826 //
     /* 1589112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1589115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1589123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1589126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1589129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1589132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589143 */     // MIs[0] passthru
     /* 1589143 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589156 */     // MIs[0] policy
     /* 1589156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589166 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1589169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589188 */     // GIR_Coverage, 4826,
     /* 1589188 */     GIR_EraseRootFromParent_Done,
     /* 1589189 */   // Label 21999: @1589189
     /* 1589189 */   GIM_Try, /*On fail goto*//*Label 22000*/ GIMT_Encode4(1589271), // Rule ID 4827 //
     /* 1589194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1589197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1589205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1589208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1589211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1589214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589225 */     // MIs[0] passthru
     /* 1589225 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589238 */     // MIs[0] policy
     /* 1589238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589248 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1589251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589270 */     // GIR_Coverage, 4827,
     /* 1589270 */     GIR_EraseRootFromParent_Done,
     /* 1589271 */   // Label 22000: @1589271
     /* 1589271 */   GIM_Try, /*On fail goto*//*Label 22001*/ GIMT_Encode4(1589353), // Rule ID 4836 //
     /* 1589276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1589279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1589287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1589290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1589293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1589296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589307 */     // MIs[0] passthru
     /* 1589307 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589320 */     // MIs[0] policy
     /* 1589320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589330 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1589333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589352 */     // GIR_Coverage, 4836,
     /* 1589352 */     GIR_EraseRootFromParent_Done,
     /* 1589353 */   // Label 22001: @1589353
     /* 1589353 */   GIM_Try, /*On fail goto*//*Label 22002*/ GIMT_Encode4(1589435), // Rule ID 4837 //
     /* 1589358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1589361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1589369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1589372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1589375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1589378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589389 */     // MIs[0] passthru
     /* 1589389 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589402 */     // MIs[0] policy
     /* 1589402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589412 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1589415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589434 */     // GIR_Coverage, 4837,
     /* 1589434 */     GIR_EraseRootFromParent_Done,
     /* 1589435 */   // Label 22002: @1589435
     /* 1589435 */   GIM_Try, /*On fail goto*//*Label 22003*/ GIMT_Encode4(1589517), // Rule ID 4846 //
     /* 1589440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1589443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1589451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1589454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1589457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589471 */     // MIs[0] passthru
     /* 1589471 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589484 */     // MIs[0] policy
     /* 1589484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589494 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1589497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589516 */     // GIR_Coverage, 4846,
     /* 1589516 */     GIR_EraseRootFromParent_Done,
     /* 1589517 */   // Label 22003: @1589517
     /* 1589517 */   GIM_Try, /*On fail goto*//*Label 22004*/ GIMT_Encode4(1589599), // Rule ID 4847 //
     /* 1589522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1589525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1589533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1589536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1589539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589553 */     // MIs[0] passthru
     /* 1589553 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589566 */     // MIs[0] policy
     /* 1589566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1589579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589598 */     // GIR_Coverage, 4847,
     /* 1589598 */     GIR_EraseRootFromParent_Done,
     /* 1589599 */   // Label 22004: @1589599
     /* 1589599 */   GIM_Try, /*On fail goto*//*Label 22005*/ GIMT_Encode4(1589685), // Rule ID 2734 //
     /* 1589604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589650 */     // MIs[0] policy
     /* 1589650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589660 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1589663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589684 */     // GIR_Coverage, 2734,
     /* 1589684 */     GIR_EraseRootFromParent_Done,
     /* 1589685 */   // Label 22005: @1589685
     /* 1589685 */   GIM_Try, /*On fail goto*//*Label 22006*/ GIMT_Encode4(1589771), // Rule ID 2735 //
     /* 1589690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589736 */     // MIs[0] policy
     /* 1589736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589746 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1589749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589770 */     // GIR_Coverage, 2735,
     /* 1589770 */     GIR_EraseRootFromParent_Done,
     /* 1589771 */   // Label 22006: @1589771
     /* 1589771 */   GIM_Try, /*On fail goto*//*Label 22007*/ GIMT_Encode4(1589857), // Rule ID 2772 //
     /* 1589776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1589784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1589787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1589790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1589793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589822 */     // MIs[0] policy
     /* 1589822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589832 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1589835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589856 */     // GIR_Coverage, 2772,
     /* 1589856 */     GIR_EraseRootFromParent_Done,
     /* 1589857 */   // Label 22007: @1589857
     /* 1589857 */   GIM_Try, /*On fail goto*//*Label 22008*/ GIMT_Encode4(1589943), // Rule ID 2773 //
     /* 1589862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1589870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1589873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1589876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1589879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589908 */     // MIs[0] policy
     /* 1589908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589918 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1589921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589942 */     // GIR_Coverage, 2773,
     /* 1589942 */     GIR_EraseRootFromParent_Done,
     /* 1589943 */   // Label 22008: @1589943
     /* 1589943 */   GIM_Try, /*On fail goto*//*Label 22009*/ GIMT_Encode4(1590029), // Rule ID 2786 //
     /* 1589948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1589956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589994 */     // MIs[0] policy
     /* 1589994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590004 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1590007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1590011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590028 */     // GIR_Coverage, 2786,
     /* 1590028 */     GIR_EraseRootFromParent_Done,
     /* 1590029 */   // Label 22009: @1590029
     /* 1590029 */   GIM_Try, /*On fail goto*//*Label 22010*/ GIMT_Encode4(1590115), // Rule ID 2787 //
     /* 1590034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1590042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1590045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1590048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1590051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1590054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590080 */     // MIs[0] policy
     /* 1590080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590090 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1590093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1590097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590114 */     // GIR_Coverage, 2787,
     /* 1590114 */     GIR_EraseRootFromParent_Done,
     /* 1590115 */   // Label 22010: @1590115
     /* 1590115 */   GIM_Try, /*On fail goto*//*Label 22011*/ GIMT_Encode4(1590201), // Rule ID 2806 //
     /* 1590120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1590131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1590134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1590137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1590140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590166 */     // MIs[0] policy
     /* 1590166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590176 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1590179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590200 */     // GIR_Coverage, 2806,
     /* 1590200 */     GIR_EraseRootFromParent_Done,
     /* 1590201 */   // Label 22011: @1590201
     /* 1590201 */   GIM_Try, /*On fail goto*//*Label 22012*/ GIMT_Encode4(1590287), // Rule ID 2807 //
     /* 1590206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1590217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1590220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1590223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1590226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590252 */     // MIs[0] policy
     /* 1590252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590262 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1590265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590286 */     // GIR_Coverage, 2807,
     /* 1590286 */     GIR_EraseRootFromParent_Done,
     /* 1590287 */   // Label 22012: @1590287
     /* 1590287 */   GIM_Try, /*On fail goto*//*Label 22013*/ GIMT_Encode4(1590373), // Rule ID 2814 //
     /* 1590292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1590303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1590306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1590309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1590312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590338 */     // MIs[0] policy
     /* 1590338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590348 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1590351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590372 */     // GIR_Coverage, 2814,
     /* 1590372 */     GIR_EraseRootFromParent_Done,
     /* 1590373 */   // Label 22013: @1590373
     /* 1590373 */   GIM_Try, /*On fail goto*//*Label 22014*/ GIMT_Encode4(1590459), // Rule ID 2815 //
     /* 1590378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1590389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1590392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1590395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1590398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590424 */     // MIs[0] policy
     /* 1590424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590434 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1590437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590458 */     // GIR_Coverage, 2815,
     /* 1590458 */     GIR_EraseRootFromParent_Done,
     /* 1590459 */   // Label 22014: @1590459
     /* 1590459 */   GIM_Try, /*On fail goto*//*Label 22015*/ GIMT_Encode4(1590545), // Rule ID 2822 //
     /* 1590464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1590475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1590478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1590481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1590484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590510 */     // MIs[0] policy
     /* 1590510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590520 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590544 */     // GIR_Coverage, 2822,
     /* 1590544 */     GIR_EraseRootFromParent_Done,
     /* 1590545 */   // Label 22015: @1590545
     /* 1590545 */   GIM_Try, /*On fail goto*//*Label 22016*/ GIMT_Encode4(1590631), // Rule ID 2823 //
     /* 1590550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1590561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1590564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1590567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1590570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590596 */     // MIs[0] policy
     /* 1590596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590606 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590630 */     // GIR_Coverage, 2823,
     /* 1590630 */     GIR_EraseRootFromParent_Done,
     /* 1590631 */   // Label 22016: @1590631
     /* 1590631 */   GIM_Try, /*On fail goto*//*Label 22017*/ GIMT_Encode4(1590717), // Rule ID 2830 //
     /* 1590636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1590647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1590650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1590653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1590656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590682 */     // MIs[0] policy
     /* 1590682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590692 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1590695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590716 */     // GIR_Coverage, 2830,
     /* 1590716 */     GIR_EraseRootFromParent_Done,
     /* 1590717 */   // Label 22017: @1590717
     /* 1590717 */   GIM_Try, /*On fail goto*//*Label 22018*/ GIMT_Encode4(1590803), // Rule ID 2831 //
     /* 1590722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1590733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1590736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1590739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1590742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590768 */     // MIs[0] policy
     /* 1590768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590778 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1590781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590802 */     // GIR_Coverage, 2831,
     /* 1590802 */     GIR_EraseRootFromParent_Done,
     /* 1590803 */   // Label 22018: @1590803
     /* 1590803 */   GIM_Try, /*On fail goto*//*Label 22019*/ GIMT_Encode4(1590889), // Rule ID 2838 //
     /* 1590808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1590819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1590822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1590825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1590828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590854 */     // MIs[0] policy
     /* 1590854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590864 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590888 */     // GIR_Coverage, 2838,
     /* 1590888 */     GIR_EraseRootFromParent_Done,
     /* 1590889 */   // Label 22019: @1590889
     /* 1590889 */   GIM_Try, /*On fail goto*//*Label 22020*/ GIMT_Encode4(1590975), // Rule ID 2839 //
     /* 1590894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1590905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1590908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1590911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1590914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590940 */     // MIs[0] policy
     /* 1590940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590950 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590974 */     // GIR_Coverage, 2839,
     /* 1590974 */     GIR_EraseRootFromParent_Done,
     /* 1590975 */   // Label 22020: @1590975
     /* 1590975 */   GIM_Try, /*On fail goto*//*Label 22021*/ GIMT_Encode4(1591061), // Rule ID 2846 //
     /* 1590980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1590991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1590994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1590997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1591000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591026 */     // MIs[0] policy
     /* 1591026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591036 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1591039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591060 */     // GIR_Coverage, 2846,
     /* 1591060 */     GIR_EraseRootFromParent_Done,
     /* 1591061 */   // Label 22021: @1591061
     /* 1591061 */   GIM_Try, /*On fail goto*//*Label 22022*/ GIMT_Encode4(1591147), // Rule ID 2847 //
     /* 1591066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1591077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1591080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1591083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1591086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591112 */     // MIs[0] policy
     /* 1591112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591122 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1591125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591146 */     // GIR_Coverage, 2847,
     /* 1591146 */     GIR_EraseRootFromParent_Done,
     /* 1591147 */   // Label 22022: @1591147
     /* 1591147 */   GIM_Try, /*On fail goto*//*Label 22023*/ GIMT_Encode4(1591233), // Rule ID 2854 //
     /* 1591152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1591163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1591166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1591169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1591172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591198 */     // MIs[0] policy
     /* 1591198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591208 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591232 */     // GIR_Coverage, 2854,
     /* 1591232 */     GIR_EraseRootFromParent_Done,
     /* 1591233 */   // Label 22023: @1591233
     /* 1591233 */   GIM_Try, /*On fail goto*//*Label 22024*/ GIMT_Encode4(1591319), // Rule ID 2855 //
     /* 1591238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1591249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1591252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1591255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1591258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591284 */     // MIs[0] policy
     /* 1591284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591294 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591318 */     // GIR_Coverage, 2855,
     /* 1591318 */     GIR_EraseRootFromParent_Done,
     /* 1591319 */   // Label 22024: @1591319
     /* 1591319 */   GIM_Try, /*On fail goto*//*Label 22025*/ GIMT_Encode4(1591405), // Rule ID 2862 //
     /* 1591324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1591335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1591338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1591341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1591344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591370 */     // MIs[0] policy
     /* 1591370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591380 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591404 */     // GIR_Coverage, 2862,
     /* 1591404 */     GIR_EraseRootFromParent_Done,
     /* 1591405 */   // Label 22025: @1591405
     /* 1591405 */   GIM_Try, /*On fail goto*//*Label 22026*/ GIMT_Encode4(1591491), // Rule ID 2863 //
     /* 1591410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1591421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1591424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1591427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1591430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591456 */     // MIs[0] policy
     /* 1591456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591466 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591490 */     // GIR_Coverage, 2863,
     /* 1591490 */     GIR_EraseRootFromParent_Done,
     /* 1591491 */   // Label 22026: @1591491
     /* 1591491 */   GIM_Try, /*On fail goto*//*Label 22027*/ GIMT_Encode4(1591577), // Rule ID 2870 //
     /* 1591496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1591507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1591510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1591513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1591516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591542 */     // MIs[0] policy
     /* 1591542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591576 */     // GIR_Coverage, 2870,
     /* 1591576 */     GIR_EraseRootFromParent_Done,
     /* 1591577 */   // Label 22027: @1591577
     /* 1591577 */   GIM_Try, /*On fail goto*//*Label 22028*/ GIMT_Encode4(1591663), // Rule ID 2871 //
     /* 1591582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1591593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1591596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1591599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1591602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591628 */     // MIs[0] policy
     /* 1591628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591662 */     // GIR_Coverage, 2871,
     /* 1591662 */     GIR_EraseRootFromParent_Done,
     /* 1591663 */   // Label 22028: @1591663
     /* 1591663 */   GIM_Try, /*On fail goto*//*Label 22029*/ GIMT_Encode4(1591749), // Rule ID 2878 //
     /* 1591668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1591671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1591679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1591682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1591685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1591688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591714 */     // MIs[0] policy
     /* 1591714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591724 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1591745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591748 */     // GIR_Coverage, 2878,
     /* 1591748 */     GIR_EraseRootFromParent_Done,
     /* 1591749 */   // Label 22029: @1591749
     /* 1591749 */   GIM_Try, /*On fail goto*//*Label 22030*/ GIMT_Encode4(1591835), // Rule ID 2879 //
     /* 1591754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1591757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1591765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1591768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1591771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1591774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591800 */     // MIs[0] policy
     /* 1591800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591810 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1591831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591834 */     // GIR_Coverage, 2879,
     /* 1591834 */     GIR_EraseRootFromParent_Done,
     /* 1591835 */   // Label 22030: @1591835
     /* 1591835 */   GIM_Try, /*On fail goto*//*Label 22031*/ GIMT_Encode4(1591921), // Rule ID 2886 //
     /* 1591840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1591851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1591854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1591857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1591860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1591863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591886 */     // MIs[0] policy
     /* 1591886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1591899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591920 */     // GIR_Coverage, 2886,
     /* 1591920 */     GIR_EraseRootFromParent_Done,
     /* 1591921 */   // Label 22031: @1591921
     /* 1591921 */   GIM_Try, /*On fail goto*//*Label 22032*/ GIMT_Encode4(1592007), // Rule ID 2887 //
     /* 1591926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1591937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1591940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1591943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1591946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1591949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591972 */     // MIs[0] policy
     /* 1591972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591982 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1591985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592006 */     // GIR_Coverage, 2887,
     /* 1592006 */     GIR_EraseRootFromParent_Done,
     /* 1592007 */   // Label 22032: @1592007
     /* 1592007 */   GIM_Try, /*On fail goto*//*Label 22033*/ GIMT_Encode4(1592093), // Rule ID 2894 //
     /* 1592012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1592023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1592026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1592029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1592032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592058 */     // MIs[0] policy
     /* 1592058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592068 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592092 */     // GIR_Coverage, 2894,
     /* 1592092 */     GIR_EraseRootFromParent_Done,
     /* 1592093 */   // Label 22033: @1592093
     /* 1592093 */   GIM_Try, /*On fail goto*//*Label 22034*/ GIMT_Encode4(1592179), // Rule ID 2895 //
     /* 1592098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1592109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1592112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1592115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1592118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592144 */     // MIs[0] policy
     /* 1592144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592154 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592178 */     // GIR_Coverage, 2895,
     /* 1592178 */     GIR_EraseRootFromParent_Done,
     /* 1592179 */   // Label 22034: @1592179
     /* 1592179 */   GIM_Try, /*On fail goto*//*Label 22035*/ GIMT_Encode4(1592265), // Rule ID 2902 //
     /* 1592184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1592195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1592198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1592201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1592204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1592207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592230 */     // MIs[0] policy
     /* 1592230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592240 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592264 */     // GIR_Coverage, 2902,
     /* 1592264 */     GIR_EraseRootFromParent_Done,
     /* 1592265 */   // Label 22035: @1592265
     /* 1592265 */   GIM_Try, /*On fail goto*//*Label 22036*/ GIMT_Encode4(1592351), // Rule ID 2903 //
     /* 1592270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1592281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1592284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1592287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1592290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1592293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592316 */     // MIs[0] policy
     /* 1592316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592350 */     // GIR_Coverage, 2903,
     /* 1592350 */     GIR_EraseRootFromParent_Done,
     /* 1592351 */   // Label 22036: @1592351
     /* 1592351 */   GIM_Try, /*On fail goto*//*Label 22037*/ GIMT_Encode4(1592437), // Rule ID 2910 //
     /* 1592356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1592367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1592370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1592373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1592376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592402 */     // MIs[0] policy
     /* 1592402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592412 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592436 */     // GIR_Coverage, 2910,
     /* 1592436 */     GIR_EraseRootFromParent_Done,
     /* 1592437 */   // Label 22037: @1592437
     /* 1592437 */   GIM_Try, /*On fail goto*//*Label 22038*/ GIMT_Encode4(1592523), // Rule ID 2911 //
     /* 1592442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1592453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1592456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1592459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1592462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592488 */     // MIs[0] policy
     /* 1592488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592498 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592522 */     // GIR_Coverage, 2911,
     /* 1592522 */     GIR_EraseRootFromParent_Done,
     /* 1592523 */   // Label 22038: @1592523
     /* 1592523 */   GIM_Try, /*On fail goto*//*Label 22039*/ GIMT_Encode4(1592609), // Rule ID 2918 //
     /* 1592528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1592539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1592542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1592545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1592548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592574 */     // MIs[0] policy
     /* 1592574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592584 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592608 */     // GIR_Coverage, 2918,
     /* 1592608 */     GIR_EraseRootFromParent_Done,
     /* 1592609 */   // Label 22039: @1592609
     /* 1592609 */   GIM_Try, /*On fail goto*//*Label 22040*/ GIMT_Encode4(1592695), // Rule ID 2919 //
     /* 1592614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1592625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1592628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1592631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1592634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592660 */     // MIs[0] policy
     /* 1592660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592670 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592694 */     // GIR_Coverage, 2919,
     /* 1592694 */     GIR_EraseRootFromParent_Done,
     /* 1592695 */   // Label 22040: @1592695
     /* 1592695 */   GIM_Try, /*On fail goto*//*Label 22041*/ GIMT_Encode4(1592781), // Rule ID 2926 //
     /* 1592700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1592711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1592714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1592717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1592720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592746 */     // MIs[0] policy
     /* 1592746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592756 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592780 */     // GIR_Coverage, 2926,
     /* 1592780 */     GIR_EraseRootFromParent_Done,
     /* 1592781 */   // Label 22041: @1592781
     /* 1592781 */   GIM_Try, /*On fail goto*//*Label 22042*/ GIMT_Encode4(1592867), // Rule ID 2927 //
     /* 1592786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1592797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1592800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1592803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1592806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592832 */     // MIs[0] policy
     /* 1592832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592842 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592866 */     // GIR_Coverage, 2927,
     /* 1592866 */     GIR_EraseRootFromParent_Done,
     /* 1592867 */   // Label 22042: @1592867
     /* 1592867 */   GIM_Try, /*On fail goto*//*Label 22043*/ GIMT_Encode4(1592953), // Rule ID 2934 //
     /* 1592872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1592883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1592886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1592889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1592892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1592895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592918 */     // MIs[0] policy
     /* 1592918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592952 */     // GIR_Coverage, 2934,
     /* 1592952 */     GIR_EraseRootFromParent_Done,
     /* 1592953 */   // Label 22043: @1592953
     /* 1592953 */   GIM_Try, /*On fail goto*//*Label 22044*/ GIMT_Encode4(1593039), // Rule ID 2935 //
     /* 1592958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1592969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1592972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1592975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1592978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1592981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593004 */     // MIs[0] policy
     /* 1593004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1593017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593038 */     // GIR_Coverage, 2935,
     /* 1593038 */     GIR_EraseRootFromParent_Done,
     /* 1593039 */   // Label 22044: @1593039
     /* 1593039 */   GIM_Try, /*On fail goto*//*Label 22045*/ GIMT_Encode4(1593125), // Rule ID 2942 //
     /* 1593044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1593055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1593058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1593061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1593064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593090 */     // MIs[0] policy
     /* 1593090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593100 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1593103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593124 */     // GIR_Coverage, 2942,
     /* 1593124 */     GIR_EraseRootFromParent_Done,
     /* 1593125 */   // Label 22045: @1593125
     /* 1593125 */   GIM_Try, /*On fail goto*//*Label 22046*/ GIMT_Encode4(1593211), // Rule ID 2943 //
     /* 1593130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1593141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1593144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1593147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1593150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593176 */     // MIs[0] policy
     /* 1593176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593186 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1593189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593210 */     // GIR_Coverage, 2943,
     /* 1593210 */     GIR_EraseRootFromParent_Done,
     /* 1593211 */   // Label 22046: @1593211
     /* 1593211 */   GIM_Try, /*On fail goto*//*Label 22047*/ GIMT_Encode4(1593297), // Rule ID 2950 //
     /* 1593216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1593227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1593230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1593233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1593236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1593239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593262 */     // MIs[0] policy
     /* 1593262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593272 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1593275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593296 */     // GIR_Coverage, 2950,
     /* 1593296 */     GIR_EraseRootFromParent_Done,
     /* 1593297 */   // Label 22047: @1593297
     /* 1593297 */   GIM_Try, /*On fail goto*//*Label 22048*/ GIMT_Encode4(1593383), // Rule ID 2951 //
     /* 1593302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1593313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1593316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1593319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1593322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1593325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593348 */     // MIs[0] policy
     /* 1593348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1593361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593382 */     // GIR_Coverage, 2951,
     /* 1593382 */     GIR_EraseRootFromParent_Done,
     /* 1593383 */   // Label 22048: @1593383
     /* 1593383 */   GIM_Try, /*On fail goto*//*Label 22049*/ GIMT_Encode4(1593469), // Rule ID 2958 //
     /* 1593388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1593399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1593402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1593405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1593408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593434 */     // MIs[0] policy
     /* 1593434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1593447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593468 */     // GIR_Coverage, 2958,
     /* 1593468 */     GIR_EraseRootFromParent_Done,
     /* 1593469 */   // Label 22049: @1593469
     /* 1593469 */   GIM_Try, /*On fail goto*//*Label 22050*/ GIMT_Encode4(1593555), // Rule ID 2959 //
     /* 1593474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1593485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1593488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1593491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1593494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593520 */     // MIs[0] policy
     /* 1593520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593530 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1593533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593554 */     // GIR_Coverage, 2959,
     /* 1593554 */     GIR_EraseRootFromParent_Done,
     /* 1593555 */   // Label 22050: @1593555
     /* 1593555 */   GIM_Try, /*On fail goto*//*Label 22051*/ GIMT_Encode4(1593641), // Rule ID 2966 //
     /* 1593560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1593571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1593574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1593577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1593580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593606 */     // MIs[0] policy
     /* 1593606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1593619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593640 */     // GIR_Coverage, 2966,
     /* 1593640 */     GIR_EraseRootFromParent_Done,
     /* 1593641 */   // Label 22051: @1593641
     /* 1593641 */   GIM_Try, /*On fail goto*//*Label 22052*/ GIMT_Encode4(1593727), // Rule ID 2967 //
     /* 1593646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1593657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1593660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1593663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1593666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593692 */     // MIs[0] policy
     /* 1593692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593702 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1593705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593726 */     // GIR_Coverage, 2967,
     /* 1593726 */     GIR_EraseRootFromParent_Done,
     /* 1593727 */   // Label 22052: @1593727
     /* 1593727 */   GIM_Try, /*On fail goto*//*Label 22053*/ GIMT_Encode4(1593813), // Rule ID 2974 //
     /* 1593732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1593743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1593746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1593749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1593752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593778 */     // MIs[0] policy
     /* 1593778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593788 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1593791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593812 */     // GIR_Coverage, 2974,
     /* 1593812 */     GIR_EraseRootFromParent_Done,
     /* 1593813 */   // Label 22053: @1593813
     /* 1593813 */   GIM_Try, /*On fail goto*//*Label 22054*/ GIMT_Encode4(1593899), // Rule ID 2975 //
     /* 1593818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1593829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1593832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1593835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1593838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593864 */     // MIs[0] policy
     /* 1593864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593874 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1593877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593898 */     // GIR_Coverage, 2975,
     /* 1593898 */     GIR_EraseRootFromParent_Done,
     /* 1593899 */   // Label 22054: @1593899
     /* 1593899 */   GIM_Try, /*On fail goto*//*Label 22055*/ GIMT_Encode4(1593985), // Rule ID 2990 //
     /* 1593904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1593915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1593918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1593921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1593924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593950 */     // MIs[0] policy
     /* 1593950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593960 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1593963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593984 */     // GIR_Coverage, 2990,
     /* 1593984 */     GIR_EraseRootFromParent_Done,
     /* 1593985 */   // Label 22055: @1593985
     /* 1593985 */   GIM_Try, /*On fail goto*//*Label 22056*/ GIMT_Encode4(1594071), // Rule ID 2991 //
     /* 1593990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1594001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1594004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1594007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1594010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594036 */     // MIs[0] policy
     /* 1594036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1594049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594070 */     // GIR_Coverage, 2991,
     /* 1594070 */     GIR_EraseRootFromParent_Done,
     /* 1594071 */   // Label 22056: @1594071
     /* 1594071 */   GIM_Try, /*On fail goto*//*Label 22057*/ GIMT_Encode4(1594157), // Rule ID 2994 //
     /* 1594076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1594087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1594090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1594093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1594096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594122 */     // MIs[0] policy
     /* 1594122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594132 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594156 */     // GIR_Coverage, 2994,
     /* 1594156 */     GIR_EraseRootFromParent_Done,
     /* 1594157 */   // Label 22057: @1594157
     /* 1594157 */   GIM_Try, /*On fail goto*//*Label 22058*/ GIMT_Encode4(1594243), // Rule ID 2995 //
     /* 1594162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1594173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1594176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1594179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1594182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594208 */     // MIs[0] policy
     /* 1594208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594218 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594242 */     // GIR_Coverage, 2995,
     /* 1594242 */     GIR_EraseRootFromParent_Done,
     /* 1594243 */   // Label 22058: @1594243
     /* 1594243 */   GIM_Try, /*On fail goto*//*Label 22059*/ GIMT_Encode4(1594329), // Rule ID 2998 //
     /* 1594248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1594259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1594262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1594265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1594268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594294 */     // MIs[0] policy
     /* 1594294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594304 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1594307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594328 */     // GIR_Coverage, 2998,
     /* 1594328 */     GIR_EraseRootFromParent_Done,
     /* 1594329 */   // Label 22059: @1594329
     /* 1594329 */   GIM_Try, /*On fail goto*//*Label 22060*/ GIMT_Encode4(1594415), // Rule ID 2999 //
     /* 1594334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1594345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1594348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1594351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1594354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594380 */     // MIs[0] policy
     /* 1594380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594390 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1594393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594414 */     // GIR_Coverage, 2999,
     /* 1594414 */     GIR_EraseRootFromParent_Done,
     /* 1594415 */   // Label 22060: @1594415
     /* 1594415 */   GIM_Try, /*On fail goto*//*Label 22061*/ GIMT_Encode4(1594501), // Rule ID 3002 //
     /* 1594420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1594431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1594434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1594437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1594440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594466 */     // MIs[0] policy
     /* 1594466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594476 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594500 */     // GIR_Coverage, 3002,
     /* 1594500 */     GIR_EraseRootFromParent_Done,
     /* 1594501 */   // Label 22061: @1594501
     /* 1594501 */   GIM_Try, /*On fail goto*//*Label 22062*/ GIMT_Encode4(1594587), // Rule ID 3003 //
     /* 1594506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1594517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1594520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1594523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1594526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594552 */     // MIs[0] policy
     /* 1594552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594562 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594586 */     // GIR_Coverage, 3003,
     /* 1594586 */     GIR_EraseRootFromParent_Done,
     /* 1594587 */   // Label 22062: @1594587
     /* 1594587 */   GIM_Try, /*On fail goto*//*Label 22063*/ GIMT_Encode4(1594673), // Rule ID 3006 //
     /* 1594592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1594603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1594606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1594609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1594612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594638 */     // MIs[0] policy
     /* 1594638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594648 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594672 */     // GIR_Coverage, 3006,
     /* 1594672 */     GIR_EraseRootFromParent_Done,
     /* 1594673 */   // Label 22063: @1594673
     /* 1594673 */   GIM_Try, /*On fail goto*//*Label 22064*/ GIMT_Encode4(1594759), // Rule ID 3007 //
     /* 1594678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1594689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1594692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1594695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1594698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594724 */     // MIs[0] policy
     /* 1594724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594758 */     // GIR_Coverage, 3007,
     /* 1594758 */     GIR_EraseRootFromParent_Done,
     /* 1594759 */   // Label 22064: @1594759
     /* 1594759 */   GIM_Try, /*On fail goto*//*Label 22065*/ GIMT_Encode4(1594845), // Rule ID 3010 //
     /* 1594764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1594775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1594778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1594781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1594784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594810 */     // MIs[0] policy
     /* 1594810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594820 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594844 */     // GIR_Coverage, 3010,
     /* 1594844 */     GIR_EraseRootFromParent_Done,
     /* 1594845 */   // Label 22065: @1594845
     /* 1594845 */   GIM_Try, /*On fail goto*//*Label 22066*/ GIMT_Encode4(1594931), // Rule ID 3011 //
     /* 1594850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1594861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1594864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1594867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1594870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594896 */     // MIs[0] policy
     /* 1594896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594906 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594930 */     // GIR_Coverage, 3011,
     /* 1594930 */     GIR_EraseRootFromParent_Done,
     /* 1594931 */   // Label 22066: @1594931
     /* 1594931 */   GIM_Try, /*On fail goto*//*Label 22067*/ GIMT_Encode4(1595017), // Rule ID 3014 //
     /* 1594936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1594947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1594950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1594953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1594956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594982 */     // MIs[0] policy
     /* 1594982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594992 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595016 */     // GIR_Coverage, 3014,
     /* 1595016 */     GIR_EraseRootFromParent_Done,
     /* 1595017 */   // Label 22067: @1595017
     /* 1595017 */   GIM_Try, /*On fail goto*//*Label 22068*/ GIMT_Encode4(1595103), // Rule ID 3015 //
     /* 1595022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1595033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1595036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1595039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1595042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1595045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595068 */     // MIs[0] policy
     /* 1595068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595078 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1595081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595102 */     // GIR_Coverage, 3015,
     /* 1595102 */     GIR_EraseRootFromParent_Done,
     /* 1595103 */   // Label 22068: @1595103
     /* 1595103 */   GIM_Try, /*On fail goto*//*Label 22069*/ GIMT_Encode4(1595189), // Rule ID 3018 //
     /* 1595108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1595119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1595122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1595125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1595128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595154 */     // MIs[0] policy
     /* 1595154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1595167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595188 */     // GIR_Coverage, 3018,
     /* 1595188 */     GIR_EraseRootFromParent_Done,
     /* 1595189 */   // Label 22069: @1595189
     /* 1595189 */   GIM_Try, /*On fail goto*//*Label 22070*/ GIMT_Encode4(1595275), // Rule ID 3019 //
     /* 1595194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1595205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1595208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1595211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1595214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595240 */     // MIs[0] policy
     /* 1595240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1595253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595274 */     // GIR_Coverage, 3019,
     /* 1595274 */     GIR_EraseRootFromParent_Done,
     /* 1595275 */   // Label 22070: @1595275
     /* 1595275 */   GIM_Try, /*On fail goto*//*Label 22071*/ GIMT_Encode4(1595361), // Rule ID 3022 //
     /* 1595280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1595283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1595291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1595294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1595297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1595300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595326 */     // MIs[0] policy
     /* 1595326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1595339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1595357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595360 */     // GIR_Coverage, 3022,
     /* 1595360 */     GIR_EraseRootFromParent_Done,
     /* 1595361 */   // Label 22071: @1595361
     /* 1595361 */   GIM_Try, /*On fail goto*//*Label 22072*/ GIMT_Encode4(1595447), // Rule ID 3023 //
     /* 1595366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1595369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1595377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1595380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1595383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1595386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595412 */     // MIs[0] policy
     /* 1595412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595422 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1595425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1595443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595446 */     // GIR_Coverage, 3023,
     /* 1595446 */     GIR_EraseRootFromParent_Done,
     /* 1595447 */   // Label 22072: @1595447
     /* 1595447 */   GIM_Try, /*On fail goto*//*Label 22073*/ GIMT_Encode4(1595533), // Rule ID 3026 //
     /* 1595452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1595463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1595466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1595469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1595472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595498 */     // MIs[0] policy
     /* 1595498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595508 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1595511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595532 */     // GIR_Coverage, 3026,
     /* 1595532 */     GIR_EraseRootFromParent_Done,
     /* 1595533 */   // Label 22073: @1595533
     /* 1595533 */   GIM_Try, /*On fail goto*//*Label 22074*/ GIMT_Encode4(1595619), // Rule ID 3027 //
     /* 1595538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1595549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1595552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1595555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1595558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595584 */     // MIs[0] policy
     /* 1595584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595594 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1595597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595618 */     // GIR_Coverage, 3027,
     /* 1595618 */     GIR_EraseRootFromParent_Done,
     /* 1595619 */   // Label 22074: @1595619
     /* 1595619 */   GIM_Try, /*On fail goto*//*Label 22075*/ GIMT_Encode4(1595705), // Rule ID 3030 //
     /* 1595624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1595635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1595638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1595641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1595644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595670 */     // MIs[0] policy
     /* 1595670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595680 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1595683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595704 */     // GIR_Coverage, 3030,
     /* 1595704 */     GIR_EraseRootFromParent_Done,
     /* 1595705 */   // Label 22075: @1595705
     /* 1595705 */   GIM_Try, /*On fail goto*//*Label 22076*/ GIMT_Encode4(1595791), // Rule ID 3031 //
     /* 1595710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1595721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1595724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1595727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1595730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595756 */     // MIs[0] policy
     /* 1595756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595766 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1595769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595790 */     // GIR_Coverage, 3031,
     /* 1595790 */     GIR_EraseRootFromParent_Done,
     /* 1595791 */   // Label 22076: @1595791
     /* 1595791 */   GIM_Try, /*On fail goto*//*Label 22077*/ GIMT_Encode4(1595877), // Rule ID 3034 //
     /* 1595796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1595807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1595810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1595813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1595816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1595819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595842 */     // MIs[0] policy
     /* 1595842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595852 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1595855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595876 */     // GIR_Coverage, 3034,
     /* 1595876 */     GIR_EraseRootFromParent_Done,
     /* 1595877 */   // Label 22077: @1595877
     /* 1595877 */   GIM_Try, /*On fail goto*//*Label 22078*/ GIMT_Encode4(1595963), // Rule ID 3035 //
     /* 1595882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1595893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1595896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1595899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1595902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1595905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595928 */     // MIs[0] policy
     /* 1595928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595938 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1595941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595962 */     // GIR_Coverage, 3035,
     /* 1595962 */     GIR_EraseRootFromParent_Done,
     /* 1595963 */   // Label 22078: @1595963
     /* 1595963 */   GIM_Try, /*On fail goto*//*Label 22079*/ GIMT_Encode4(1596049), // Rule ID 3038 //
     /* 1595968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1595979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1595982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1595985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1595988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596014 */     // MIs[0] policy
     /* 1596014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596048 */     // GIR_Coverage, 3038,
     /* 1596048 */     GIR_EraseRootFromParent_Done,
     /* 1596049 */   // Label 22079: @1596049
     /* 1596049 */   GIM_Try, /*On fail goto*//*Label 22080*/ GIMT_Encode4(1596135), // Rule ID 3039 //
     /* 1596054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1596065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1596068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1596071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1596074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596100 */     // MIs[0] policy
     /* 1596100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596110 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596134 */     // GIR_Coverage, 3039,
     /* 1596134 */     GIR_EraseRootFromParent_Done,
     /* 1596135 */   // Label 22080: @1596135
     /* 1596135 */   GIM_Try, /*On fail goto*//*Label 22081*/ GIMT_Encode4(1596221), // Rule ID 3042 //
     /* 1596140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1596151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1596154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1596157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1596160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596186 */     // MIs[0] policy
     /* 1596186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596220 */     // GIR_Coverage, 3042,
     /* 1596220 */     GIR_EraseRootFromParent_Done,
     /* 1596221 */   // Label 22081: @1596221
     /* 1596221 */   GIM_Try, /*On fail goto*//*Label 22082*/ GIMT_Encode4(1596307), // Rule ID 3043 //
     /* 1596226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1596237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1596240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1596243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1596246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596272 */     // MIs[0] policy
     /* 1596272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596282 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596306 */     // GIR_Coverage, 3043,
     /* 1596306 */     GIR_EraseRootFromParent_Done,
     /* 1596307 */   // Label 22082: @1596307
     /* 1596307 */   GIM_Try, /*On fail goto*//*Label 22083*/ GIMT_Encode4(1596393), // Rule ID 3046 //
     /* 1596312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1596323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1596326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1596329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1596332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596358 */     // MIs[0] policy
     /* 1596358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596368 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596392 */     // GIR_Coverage, 3046,
     /* 1596392 */     GIR_EraseRootFromParent_Done,
     /* 1596393 */   // Label 22083: @1596393
     /* 1596393 */   GIM_Try, /*On fail goto*//*Label 22084*/ GIMT_Encode4(1596479), // Rule ID 3047 //
     /* 1596398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1596409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1596412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1596415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1596418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596444 */     // MIs[0] policy
     /* 1596444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596454 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596478 */     // GIR_Coverage, 3047,
     /* 1596478 */     GIR_EraseRootFromParent_Done,
     /* 1596479 */   // Label 22084: @1596479
     /* 1596479 */   GIM_Try, /*On fail goto*//*Label 22085*/ GIMT_Encode4(1596565), // Rule ID 3050 //
     /* 1596484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1596495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1596498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1596501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1596504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596530 */     // MIs[0] policy
     /* 1596530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596540 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596564 */     // GIR_Coverage, 3050,
     /* 1596564 */     GIR_EraseRootFromParent_Done,
     /* 1596565 */   // Label 22085: @1596565
     /* 1596565 */   GIM_Try, /*On fail goto*//*Label 22086*/ GIMT_Encode4(1596651), // Rule ID 3051 //
     /* 1596570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1596581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1596584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1596587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1596590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596616 */     // MIs[0] policy
     /* 1596616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596650 */     // GIR_Coverage, 3051,
     /* 1596650 */     GIR_EraseRootFromParent_Done,
     /* 1596651 */   // Label 22086: @1596651
     /* 1596651 */   GIM_Try, /*On fail goto*//*Label 22087*/ GIMT_Encode4(1596737), // Rule ID 3054 //
     /* 1596656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1596667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1596670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1596673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1596676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596702 */     // MIs[0] policy
     /* 1596702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596712 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596736 */     // GIR_Coverage, 3054,
     /* 1596736 */     GIR_EraseRootFromParent_Done,
     /* 1596737 */   // Label 22087: @1596737
     /* 1596737 */   GIM_Try, /*On fail goto*//*Label 22088*/ GIMT_Encode4(1596823), // Rule ID 3055 //
     /* 1596742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1596753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1596756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1596759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1596762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596788 */     // MIs[0] policy
     /* 1596788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596798 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596822 */     // GIR_Coverage, 3055,
     /* 1596822 */     GIR_EraseRootFromParent_Done,
     /* 1596823 */   // Label 22088: @1596823
     /* 1596823 */   GIM_Try, /*On fail goto*//*Label 22089*/ GIMT_Encode4(1596909), // Rule ID 3058 //
     /* 1596828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1596839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1596842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1596845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1596848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596874 */     // MIs[0] policy
     /* 1596874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596884 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596908 */     // GIR_Coverage, 3058,
     /* 1596908 */     GIR_EraseRootFromParent_Done,
     /* 1596909 */   // Label 22089: @1596909
     /* 1596909 */   GIM_Try, /*On fail goto*//*Label 22090*/ GIMT_Encode4(1596995), // Rule ID 3059 //
     /* 1596914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1596925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1596928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1596931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1596934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596960 */     // MIs[0] policy
     /* 1596960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596970 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596994 */     // GIR_Coverage, 3059,
     /* 1596994 */     GIR_EraseRootFromParent_Done,
     /* 1596995 */   // Label 22090: @1596995
     /* 1596995 */   GIM_Try, /*On fail goto*//*Label 22091*/ GIMT_Encode4(1597081), // Rule ID 3062 //
     /* 1597000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1597003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1597011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1597014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1597017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1597020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597046 */     // MIs[0] policy
     /* 1597046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597056 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1597059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597080 */     // GIR_Coverage, 3062,
     /* 1597080 */     GIR_EraseRootFromParent_Done,
     /* 1597081 */   // Label 22091: @1597081
     /* 1597081 */   GIM_Try, /*On fail goto*//*Label 22092*/ GIMT_Encode4(1597167), // Rule ID 3063 //
     /* 1597086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1597097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1597100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1597103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1597106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597132 */     // MIs[0] policy
     /* 1597132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597142 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1597145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597166 */     // GIR_Coverage, 3063,
     /* 1597166 */     GIR_EraseRootFromParent_Done,
     /* 1597167 */   // Label 22092: @1597167
     /* 1597167 */   GIM_Try, /*On fail goto*//*Label 22093*/ GIMT_Encode4(1597253), // Rule ID 3066 //
     /* 1597172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1597175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1597183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1597186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1597189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1597192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597218 */     // MIs[0] policy
     /* 1597218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597228 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1597231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597252 */     // GIR_Coverage, 3066,
     /* 1597252 */     GIR_EraseRootFromParent_Done,
     /* 1597253 */   // Label 22093: @1597253
     /* 1597253 */   GIM_Try, /*On fail goto*//*Label 22094*/ GIMT_Encode4(1597339), // Rule ID 3067 //
     /* 1597258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1597269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1597272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1597275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1597278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597304 */     // MIs[0] policy
     /* 1597304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597314 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1597317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597338 */     // GIR_Coverage, 3067,
     /* 1597338 */     GIR_EraseRootFromParent_Done,
     /* 1597339 */   // Label 22094: @1597339
     /* 1597339 */   GIM_Try, /*On fail goto*//*Label 22095*/ GIMT_Encode4(1597425), // Rule ID 3070 //
     /* 1597344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1597347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1597355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1597358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1597361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1597364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597390 */     // MIs[0] policy
     /* 1597390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597400 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1597403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597424 */     // GIR_Coverage, 3070,
     /* 1597424 */     GIR_EraseRootFromParent_Done,
     /* 1597425 */   // Label 22095: @1597425
     /* 1597425 */   GIM_Try, /*On fail goto*//*Label 22096*/ GIMT_Encode4(1597511), // Rule ID 3071 //
     /* 1597430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1597441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1597444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1597447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1597450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597476 */     // MIs[0] policy
     /* 1597476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597486 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1597489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597510 */     // GIR_Coverage, 3071,
     /* 1597510 */     GIR_EraseRootFromParent_Done,
     /* 1597511 */   // Label 22096: @1597511
     /* 1597511 */   GIM_Try, /*On fail goto*//*Label 22097*/ GIMT_Encode4(1597597), // Rule ID 3074 //
     /* 1597516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1597527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1597530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1597533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597562 */     // MIs[0] policy
     /* 1597562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597572 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1597575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597596 */     // GIR_Coverage, 3074,
     /* 1597596 */     GIR_EraseRootFromParent_Done,
     /* 1597597 */   // Label 22097: @1597597
     /* 1597597 */   GIM_Try, /*On fail goto*//*Label 22098*/ GIMT_Encode4(1597683), // Rule ID 3075 //
     /* 1597602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1597613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1597616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1597619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597648 */     // MIs[0] policy
     /* 1597648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597658 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1597661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597682 */     // GIR_Coverage, 3075,
     /* 1597682 */     GIR_EraseRootFromParent_Done,
     /* 1597683 */   // Label 22098: @1597683
     /* 1597683 */   GIM_Try, /*On fail goto*//*Label 22099*/ GIMT_Encode4(1597769), // Rule ID 3078 //
     /* 1597688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1597699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1597702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1597705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597734 */     // MIs[0] policy
     /* 1597734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597744 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1597747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597768 */     // GIR_Coverage, 3078,
     /* 1597768 */     GIR_EraseRootFromParent_Done,
     /* 1597769 */   // Label 22099: @1597769
     /* 1597769 */   GIM_Try, /*On fail goto*//*Label 22100*/ GIMT_Encode4(1597855), // Rule ID 3079 //
     /* 1597774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1597785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1597788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1597791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597820 */     // MIs[0] policy
     /* 1597820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597830 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1597833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597854 */     // GIR_Coverage, 3079,
     /* 1597854 */     GIR_EraseRootFromParent_Done,
     /* 1597855 */   // Label 22100: @1597855
     /* 1597855 */   GIM_Try, /*On fail goto*//*Label 22101*/ GIMT_Encode4(1597941), // Rule ID 3082 //
     /* 1597860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1597871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1597874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1597877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597906 */     // MIs[0] policy
     /* 1597906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597916 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597940 */     // GIR_Coverage, 3082,
     /* 1597940 */     GIR_EraseRootFromParent_Done,
     /* 1597941 */   // Label 22101: @1597941
     /* 1597941 */   GIM_Try, /*On fail goto*//*Label 22102*/ GIMT_Encode4(1598027), // Rule ID 3083 //
     /* 1597946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1597957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1597960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1597963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597992 */     // MIs[0] policy
     /* 1597992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598002 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1598005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598026 */     // GIR_Coverage, 3083,
     /* 1598026 */     GIR_EraseRootFromParent_Done,
     /* 1598027 */   // Label 22102: @1598027
     /* 1598027 */   GIM_Try, /*On fail goto*//*Label 22103*/ GIMT_Encode4(1598113), // Rule ID 3086 //
     /* 1598032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1598043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1598046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1598049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598078 */     // MIs[0] policy
     /* 1598078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598088 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1598091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598112 */     // GIR_Coverage, 3086,
     /* 1598112 */     GIR_EraseRootFromParent_Done,
     /* 1598113 */   // Label 22103: @1598113
     /* 1598113 */   GIM_Try, /*On fail goto*//*Label 22104*/ GIMT_Encode4(1598199), // Rule ID 3087 //
     /* 1598118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1598129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1598132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1598135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598164 */     // MIs[0] policy
     /* 1598164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598174 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1598177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598198 */     // GIR_Coverage, 3087,
     /* 1598198 */     GIR_EraseRootFromParent_Done,
     /* 1598199 */   // Label 22104: @1598199
     /* 1598199 */   GIM_Try, /*On fail goto*//*Label 22105*/ GIMT_Encode4(1598285), // Rule ID 3090 //
     /* 1598204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1598215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1598218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1598221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598250 */     // MIs[0] policy
     /* 1598250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598260 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1598263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598284 */     // GIR_Coverage, 3090,
     /* 1598284 */     GIR_EraseRootFromParent_Done,
     /* 1598285 */   // Label 22105: @1598285
     /* 1598285 */   GIM_Try, /*On fail goto*//*Label 22106*/ GIMT_Encode4(1598371), // Rule ID 3091 //
     /* 1598290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1598301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1598304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1598307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598336 */     // MIs[0] policy
     /* 1598336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598346 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1598349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598370 */     // GIR_Coverage, 3091,
     /* 1598370 */     GIR_EraseRootFromParent_Done,
     /* 1598371 */   // Label 22106: @1598371
     /* 1598371 */   GIM_Try, /*On fail goto*//*Label 22107*/ GIMT_Encode4(1598457), // Rule ID 3094 //
     /* 1598376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1598387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1598390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1598393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598422 */     // MIs[0] policy
     /* 1598422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598432 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1598435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598456 */     // GIR_Coverage, 3094,
     /* 1598456 */     GIR_EraseRootFromParent_Done,
     /* 1598457 */   // Label 22107: @1598457
     /* 1598457 */   GIM_Try, /*On fail goto*//*Label 22108*/ GIMT_Encode4(1598543), // Rule ID 3095 //
     /* 1598462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1598473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1598476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1598479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598508 */     // MIs[0] policy
     /* 1598508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1598521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598542 */     // GIR_Coverage, 3095,
     /* 1598542 */     GIR_EraseRootFromParent_Done,
     /* 1598543 */   // Label 22108: @1598543
     /* 1598543 */   GIM_Try, /*On fail goto*//*Label 22109*/ GIMT_Encode4(1598629), // Rule ID 3098 //
     /* 1598548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1598559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1598562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1598565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598594 */     // MIs[0] policy
     /* 1598594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598604 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598628 */     // GIR_Coverage, 3098,
     /* 1598628 */     GIR_EraseRootFromParent_Done,
     /* 1598629 */   // Label 22109: @1598629
     /* 1598629 */   GIM_Try, /*On fail goto*//*Label 22110*/ GIMT_Encode4(1598715), // Rule ID 3099 //
     /* 1598634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1598645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1598648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1598651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598680 */     // MIs[0] policy
     /* 1598680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598690 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598714 */     // GIR_Coverage, 3099,
     /* 1598714 */     GIR_EraseRootFromParent_Done,
     /* 1598715 */   // Label 22110: @1598715
     /* 1598715 */   GIM_Try, /*On fail goto*//*Label 22111*/ GIMT_Encode4(1598801), // Rule ID 3102 //
     /* 1598720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1598731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1598734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1598737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598766 */     // MIs[0] policy
     /* 1598766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598776 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598800 */     // GIR_Coverage, 3102,
     /* 1598800 */     GIR_EraseRootFromParent_Done,
     /* 1598801 */   // Label 22111: @1598801
     /* 1598801 */   GIM_Try, /*On fail goto*//*Label 22112*/ GIMT_Encode4(1598887), // Rule ID 3103 //
     /* 1598806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1598817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1598820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1598823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598852 */     // MIs[0] policy
     /* 1598852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598862 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598886 */     // GIR_Coverage, 3103,
     /* 1598886 */     GIR_EraseRootFromParent_Done,
     /* 1598887 */   // Label 22112: @1598887
     /* 1598887 */   GIM_Try, /*On fail goto*//*Label 22113*/ GIMT_Encode4(1598973), // Rule ID 3106 //
     /* 1598892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1598903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1598906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1598909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598938 */     // MIs[0] policy
     /* 1598938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598972 */     // GIR_Coverage, 3106,
     /* 1598972 */     GIR_EraseRootFromParent_Done,
     /* 1598973 */   // Label 22113: @1598973
     /* 1598973 */   GIM_Try, /*On fail goto*//*Label 22114*/ GIMT_Encode4(1599059), // Rule ID 3107 //
     /* 1598978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1598989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1598992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1598995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1599001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599024 */     // MIs[0] policy
     /* 1599024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599034 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1599037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1599055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599058 */     // GIR_Coverage, 3107,
     /* 1599058 */     GIR_EraseRootFromParent_Done,
     /* 1599059 */   // Label 22114: @1599059
     /* 1599059 */   GIM_Try, /*On fail goto*//*Label 22115*/ GIMT_Encode4(1599145), // Rule ID 3110 //
     /* 1599064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1599067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1599075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1599078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1599081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1599087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599110 */     // MIs[0] policy
     /* 1599110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1599123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1599141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599144 */     // GIR_Coverage, 3110,
     /* 1599144 */     GIR_EraseRootFromParent_Done,
     /* 1599145 */   // Label 22115: @1599145
     /* 1599145 */   GIM_Try, /*On fail goto*//*Label 22116*/ GIMT_Encode4(1599231), // Rule ID 3111 //
     /* 1599150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1599153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1599161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1599164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1599167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1599173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599196 */     // MIs[0] policy
     /* 1599196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599206 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1599209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1599227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599230 */     // GIR_Coverage, 3111,
     /* 1599230 */     GIR_EraseRootFromParent_Done,
     /* 1599231 */   // Label 22116: @1599231
     /* 1599231 */   GIM_Try, /*On fail goto*//*Label 22117*/ GIMT_Encode4(1599317), // Rule ID 3114 //
     /* 1599236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1599247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1599250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1599253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599282 */     // MIs[0] policy
     /* 1599282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599292 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599316 */     // GIR_Coverage, 3114,
     /* 1599316 */     GIR_EraseRootFromParent_Done,
     /* 1599317 */   // Label 22117: @1599317
     /* 1599317 */   GIM_Try, /*On fail goto*//*Label 22118*/ GIMT_Encode4(1599403), // Rule ID 3115 //
     /* 1599322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1599333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1599336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1599339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599368 */     // MIs[0] policy
     /* 1599368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599378 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599402 */     // GIR_Coverage, 3115,
     /* 1599402 */     GIR_EraseRootFromParent_Done,
     /* 1599403 */   // Label 22118: @1599403
     /* 1599403 */   GIM_Try, /*On fail goto*//*Label 22119*/ GIMT_Encode4(1599489), // Rule ID 3118 //
     /* 1599408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1599419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1599422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1599425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599454 */     // MIs[0] policy
     /* 1599454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599464 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599488 */     // GIR_Coverage, 3118,
     /* 1599488 */     GIR_EraseRootFromParent_Done,
     /* 1599489 */   // Label 22119: @1599489
     /* 1599489 */   GIM_Try, /*On fail goto*//*Label 22120*/ GIMT_Encode4(1599575), // Rule ID 3119 //
     /* 1599494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1599505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1599508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1599511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599540 */     // MIs[0] policy
     /* 1599540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599550 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599574 */     // GIR_Coverage, 3119,
     /* 1599574 */     GIR_EraseRootFromParent_Done,
     /* 1599575 */   // Label 22120: @1599575
     /* 1599575 */   GIM_Try, /*On fail goto*//*Label 22121*/ GIMT_Encode4(1599661), // Rule ID 3122 //
     /* 1599580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1599591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1599594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1599597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1599603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599626 */     // MIs[0] policy
     /* 1599626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599636 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1599639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599660 */     // GIR_Coverage, 3122,
     /* 1599660 */     GIR_EraseRootFromParent_Done,
     /* 1599661 */   // Label 22121: @1599661
     /* 1599661 */   GIM_Try, /*On fail goto*//*Label 22122*/ GIMT_Encode4(1599747), // Rule ID 3123 //
     /* 1599666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1599677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1599680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1599683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1599689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599712 */     // MIs[0] policy
     /* 1599712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599722 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1599725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599746 */     // GIR_Coverage, 3123,
     /* 1599746 */     GIR_EraseRootFromParent_Done,
     /* 1599747 */   // Label 22122: @1599747
     /* 1599747 */   GIM_Try, /*On fail goto*//*Label 22123*/ GIMT_Encode4(1599833), // Rule ID 3126 //
     /* 1599752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1599763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1599766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1599769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599798 */     // MIs[0] policy
     /* 1599798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599808 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599832 */     // GIR_Coverage, 3126,
     /* 1599832 */     GIR_EraseRootFromParent_Done,
     /* 1599833 */   // Label 22123: @1599833
     /* 1599833 */   GIM_Try, /*On fail goto*//*Label 22124*/ GIMT_Encode4(1599919), // Rule ID 3127 //
     /* 1599838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1599849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1599852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1599855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599884 */     // MIs[0] policy
     /* 1599884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599918 */     // GIR_Coverage, 3127,
     /* 1599918 */     GIR_EraseRootFromParent_Done,
     /* 1599919 */   // Label 22124: @1599919
     /* 1599919 */   GIM_Try, /*On fail goto*//*Label 22125*/ GIMT_Encode4(1600005), // Rule ID 3130 //
     /* 1599924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1599935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1599938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1599941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599970 */     // MIs[0] policy
     /* 1599970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599980 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600004 */     // GIR_Coverage, 3130,
     /* 1600004 */     GIR_EraseRootFromParent_Done,
     /* 1600005 */   // Label 22125: @1600005
     /* 1600005 */   GIM_Try, /*On fail goto*//*Label 22126*/ GIMT_Encode4(1600091), // Rule ID 3131 //
     /* 1600010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1600021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1600024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1600027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600056 */     // MIs[0] policy
     /* 1600056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600066 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600090 */     // GIR_Coverage, 3131,
     /* 1600090 */     GIR_EraseRootFromParent_Done,
     /* 1600091 */   // Label 22126: @1600091
     /* 1600091 */   GIM_Try, /*On fail goto*//*Label 22127*/ GIMT_Encode4(1600177), // Rule ID 3134 //
     /* 1600096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1600107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1600110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1600113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1600119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600142 */     // MIs[0] policy
     /* 1600142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600152 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600176 */     // GIR_Coverage, 3134,
     /* 1600176 */     GIR_EraseRootFromParent_Done,
     /* 1600177 */   // Label 22127: @1600177
     /* 1600177 */   GIM_Try, /*On fail goto*//*Label 22128*/ GIMT_Encode4(1600263), // Rule ID 3135 //
     /* 1600182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1600193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1600196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1600199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1600205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600228 */     // MIs[0] policy
     /* 1600228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600238 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600262 */     // GIR_Coverage, 3135,
     /* 1600262 */     GIR_EraseRootFromParent_Done,
     /* 1600263 */   // Label 22128: @1600263
     /* 1600263 */   GIM_Try, /*On fail goto*//*Label 22129*/ GIMT_Encode4(1600349), // Rule ID 3138 //
     /* 1600268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1600279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1600282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1600285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600314 */     // MIs[0] policy
     /* 1600314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1600327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600348 */     // GIR_Coverage, 3138,
     /* 1600348 */     GIR_EraseRootFromParent_Done,
     /* 1600349 */   // Label 22129: @1600349
     /* 1600349 */   GIM_Try, /*On fail goto*//*Label 22130*/ GIMT_Encode4(1600435), // Rule ID 3139 //
     /* 1600354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1600365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1600368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1600371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600400 */     // MIs[0] policy
     /* 1600400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1600413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600434 */     // GIR_Coverage, 3139,
     /* 1600434 */     GIR_EraseRootFromParent_Done,
     /* 1600435 */   // Label 22130: @1600435
     /* 1600435 */   GIM_Try, /*On fail goto*//*Label 22131*/ GIMT_Encode4(1600521), // Rule ID 3142 //
     /* 1600440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1600451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1600454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1600457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600486 */     // MIs[0] policy
     /* 1600486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600520 */     // GIR_Coverage, 3142,
     /* 1600520 */     GIR_EraseRootFromParent_Done,
     /* 1600521 */   // Label 22131: @1600521
     /* 1600521 */   GIM_Try, /*On fail goto*//*Label 22132*/ GIMT_Encode4(1600607), // Rule ID 3143 //
     /* 1600526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1600537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1600540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1600543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600572 */     // MIs[0] policy
     /* 1600572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600606 */     // GIR_Coverage, 3143,
     /* 1600606 */     GIR_EraseRootFromParent_Done,
     /* 1600607 */   // Label 22132: @1600607
     /* 1600607 */   GIM_Try, /*On fail goto*//*Label 22133*/ GIMT_Encode4(1600693), // Rule ID 3146 //
     /* 1600612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1600623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1600626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1600629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600658 */     // MIs[0] policy
     /* 1600658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600668 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600692 */     // GIR_Coverage, 3146,
     /* 1600692 */     GIR_EraseRootFromParent_Done,
     /* 1600693 */   // Label 22133: @1600693
     /* 1600693 */   GIM_Try, /*On fail goto*//*Label 22134*/ GIMT_Encode4(1600779), // Rule ID 3147 //
     /* 1600698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1600709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1600712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1600715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600744 */     // MIs[0] policy
     /* 1600744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600754 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600778 */     // GIR_Coverage, 3147,
     /* 1600778 */     GIR_EraseRootFromParent_Done,
     /* 1600779 */   // Label 22134: @1600779
     /* 1600779 */   GIM_Try, /*On fail goto*//*Label 22135*/ GIMT_Encode4(1600865), // Rule ID 3150 //
     /* 1600784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1600795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1600798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1600801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600830 */     // MIs[0] policy
     /* 1600830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600840 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1600843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600864 */     // GIR_Coverage, 3150,
     /* 1600864 */     GIR_EraseRootFromParent_Done,
     /* 1600865 */   // Label 22135: @1600865
     /* 1600865 */   GIM_Try, /*On fail goto*//*Label 22136*/ GIMT_Encode4(1600951), // Rule ID 3151 //
     /* 1600870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1600873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1600881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1600884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1600887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600916 */     // MIs[0] policy
     /* 1600916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600926 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1600929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600950 */     // GIR_Coverage, 3151,
     /* 1600950 */     GIR_EraseRootFromParent_Done,
     /* 1600951 */   // Label 22136: @1600951
     /* 1600951 */   GIM_Try, /*On fail goto*//*Label 22137*/ GIMT_Encode4(1601037), // Rule ID 3154 //
     /* 1600956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1600967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1600970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1600973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601002 */     // MIs[0] policy
     /* 1601002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601012 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1601015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601036 */     // GIR_Coverage, 3154,
     /* 1601036 */     GIR_EraseRootFromParent_Done,
     /* 1601037 */   // Label 22137: @1601037
     /* 1601037 */   GIM_Try, /*On fail goto*//*Label 22138*/ GIMT_Encode4(1601123), // Rule ID 3155 //
     /* 1601042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1601045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1601053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1601056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1601059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1601072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601088 */     // MIs[0] policy
     /* 1601088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601098 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1601101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601122 */     // GIR_Coverage, 3155,
     /* 1601122 */     GIR_EraseRootFromParent_Done,
     /* 1601123 */   // Label 22138: @1601123
     /* 1601123 */   GIM_Try, /*On fail goto*//*Label 22139*/ GIMT_Encode4(1601209), // Rule ID 3158 //
     /* 1601128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1601131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1601139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1601142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1601145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1601158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601174 */     // MIs[0] policy
     /* 1601174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1601187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601208 */     // GIR_Coverage, 3158,
     /* 1601208 */     GIR_EraseRootFromParent_Done,
     /* 1601209 */   // Label 22139: @1601209
     /* 1601209 */   GIM_Try, /*On fail goto*//*Label 22140*/ GIMT_Encode4(1601295), // Rule ID 3159 //
     /* 1601214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1601217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1601225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1601228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1601231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1601244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601260 */     // MIs[0] policy
     /* 1601260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601270 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1601273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601294 */     // GIR_Coverage, 3159,
     /* 1601294 */     GIR_EraseRootFromParent_Done,
     /* 1601295 */   // Label 22140: @1601295
     /* 1601295 */   GIM_Try, /*On fail goto*//*Label 22141*/ GIMT_Encode4(1601381), // Rule ID 3250 //
     /* 1601300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1601311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1601314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1601317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1601320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601346 */     // MIs[0] policy
     /* 1601346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601356 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1601359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601380 */     // GIR_Coverage, 3250,
     /* 1601380 */     GIR_EraseRootFromParent_Done,
     /* 1601381 */   // Label 22141: @1601381
     /* 1601381 */   GIM_Try, /*On fail goto*//*Label 22142*/ GIMT_Encode4(1601467), // Rule ID 3251 //
     /* 1601386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1601397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1601400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1601403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1601406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601432 */     // MIs[0] policy
     /* 1601432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601442 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1601445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601466 */     // GIR_Coverage, 3251,
     /* 1601466 */     GIR_EraseRootFromParent_Done,
     /* 1601467 */   // Label 22142: @1601467
     /* 1601467 */   GIM_Try, /*On fail goto*//*Label 22143*/ GIMT_Encode4(1601553), // Rule ID 3254 //
     /* 1601472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1601483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1601486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1601489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1601492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601518 */     // MIs[0] policy
     /* 1601518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601528 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601552 */     // GIR_Coverage, 3254,
     /* 1601552 */     GIR_EraseRootFromParent_Done,
     /* 1601553 */   // Label 22143: @1601553
     /* 1601553 */   GIM_Try, /*On fail goto*//*Label 22144*/ GIMT_Encode4(1601639), // Rule ID 3255 //
     /* 1601558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1601569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1601572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1601575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1601578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601604 */     // MIs[0] policy
     /* 1601604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601614 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601638 */     // GIR_Coverage, 3255,
     /* 1601638 */     GIR_EraseRootFromParent_Done,
     /* 1601639 */   // Label 22144: @1601639
     /* 1601639 */   GIM_Try, /*On fail goto*//*Label 22145*/ GIMT_Encode4(1601725), // Rule ID 3258 //
     /* 1601644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1601655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1601658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1601661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1601664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601690 */     // MIs[0] policy
     /* 1601690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601700 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601724 */     // GIR_Coverage, 3258,
     /* 1601724 */     GIR_EraseRootFromParent_Done,
     /* 1601725 */   // Label 22145: @1601725
     /* 1601725 */   GIM_Try, /*On fail goto*//*Label 22146*/ GIMT_Encode4(1601811), // Rule ID 3259 //
     /* 1601730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1601741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1601744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1601747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1601750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601776 */     // MIs[0] policy
     /* 1601776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601786 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601810 */     // GIR_Coverage, 3259,
     /* 1601810 */     GIR_EraseRootFromParent_Done,
     /* 1601811 */   // Label 22146: @1601811
     /* 1601811 */   GIM_Try, /*On fail goto*//*Label 22147*/ GIMT_Encode4(1601897), // Rule ID 3262 //
     /* 1601816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1601827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1601830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1601833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1601836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601862 */     // MIs[0] policy
     /* 1601862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601896 */     // GIR_Coverage, 3262,
     /* 1601896 */     GIR_EraseRootFromParent_Done,
     /* 1601897 */   // Label 22147: @1601897
     /* 1601897 */   GIM_Try, /*On fail goto*//*Label 22148*/ GIMT_Encode4(1601983), // Rule ID 3263 //
     /* 1601902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1601913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1601916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1601919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1601922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601948 */     // MIs[0] policy
     /* 1601948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601958 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601982 */     // GIR_Coverage, 3263,
     /* 1601982 */     GIR_EraseRootFromParent_Done,
     /* 1601983 */   // Label 22148: @1601983
     /* 1601983 */   GIM_Try, /*On fail goto*//*Label 22149*/ GIMT_Encode4(1602069), // Rule ID 3266 //
     /* 1601988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1601999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1602002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1602005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1602008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602034 */     // MIs[0] policy
     /* 1602034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602044 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1602047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602068 */     // GIR_Coverage, 3266,
     /* 1602068 */     GIR_EraseRootFromParent_Done,
     /* 1602069 */   // Label 22149: @1602069
     /* 1602069 */   GIM_Try, /*On fail goto*//*Label 22150*/ GIMT_Encode4(1602155), // Rule ID 3267 //
     /* 1602074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1602085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1602088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1602091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1602094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602120 */     // MIs[0] policy
     /* 1602120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602130 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1602133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602154 */     // GIR_Coverage, 3267,
     /* 1602154 */     GIR_EraseRootFromParent_Done,
     /* 1602155 */   // Label 22150: @1602155
     /* 1602155 */   GIM_Try, /*On fail goto*//*Label 22151*/ GIMT_Encode4(1602241), // Rule ID 3270 //
     /* 1602160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1602171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1602174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1602177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1602180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602206 */     // MIs[0] policy
     /* 1602206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602216 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1602219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602240 */     // GIR_Coverage, 3270,
     /* 1602240 */     GIR_EraseRootFromParent_Done,
     /* 1602241 */   // Label 22151: @1602241
     /* 1602241 */   GIM_Try, /*On fail goto*//*Label 22152*/ GIMT_Encode4(1602327), // Rule ID 3271 //
     /* 1602246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1602257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1602260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1602263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1602266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602292 */     // MIs[0] policy
     /* 1602292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602302 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1602305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602326 */     // GIR_Coverage, 3271,
     /* 1602326 */     GIR_EraseRootFromParent_Done,
     /* 1602327 */   // Label 22152: @1602327
     /* 1602327 */   GIM_Try, /*On fail goto*//*Label 22153*/ GIMT_Encode4(1602413), // Rule ID 3274 //
     /* 1602332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1602343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1602346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1602349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1602352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1602355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602378 */     // MIs[0] policy
     /* 1602378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602388 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602412 */     // GIR_Coverage, 3274,
     /* 1602412 */     GIR_EraseRootFromParent_Done,
     /* 1602413 */   // Label 22153: @1602413
     /* 1602413 */   GIM_Try, /*On fail goto*//*Label 22154*/ GIMT_Encode4(1602499), // Rule ID 3275 //
     /* 1602418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1602429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1602432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1602435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1602438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1602441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602464 */     // MIs[0] policy
     /* 1602464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602474 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602498 */     // GIR_Coverage, 3275,
     /* 1602498 */     GIR_EraseRootFromParent_Done,
     /* 1602499 */   // Label 22154: @1602499
     /* 1602499 */   GIM_Try, /*On fail goto*//*Label 22155*/ GIMT_Encode4(1602585), // Rule ID 3278 //
     /* 1602504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1602515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1602518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1602521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1602524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602550 */     // MIs[0] policy
     /* 1602550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602560 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602584 */     // GIR_Coverage, 3278,
     /* 1602584 */     GIR_EraseRootFromParent_Done,
     /* 1602585 */   // Label 22155: @1602585
     /* 1602585 */   GIM_Try, /*On fail goto*//*Label 22156*/ GIMT_Encode4(1602671), // Rule ID 3279 //
     /* 1602590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1602601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1602604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1602607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1602610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602636 */     // MIs[0] policy
     /* 1602636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602670 */     // GIR_Coverage, 3279,
     /* 1602670 */     GIR_EraseRootFromParent_Done,
     /* 1602671 */   // Label 22156: @1602671
     /* 1602671 */   GIM_Try, /*On fail goto*//*Label 22157*/ GIMT_Encode4(1602757), // Rule ID 3282 //
     /* 1602676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1602687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1602690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1602693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1602696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602722 */     // MIs[0] policy
     /* 1602722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602732 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602756 */     // GIR_Coverage, 3282,
     /* 1602756 */     GIR_EraseRootFromParent_Done,
     /* 1602757 */   // Label 22157: @1602757
     /* 1602757 */   GIM_Try, /*On fail goto*//*Label 22158*/ GIMT_Encode4(1602843), // Rule ID 3283 //
     /* 1602762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1602773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1602776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1602779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1602782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602808 */     // MIs[0] policy
     /* 1602808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602842 */     // GIR_Coverage, 3283,
     /* 1602842 */     GIR_EraseRootFromParent_Done,
     /* 1602843 */   // Label 22158: @1602843
     /* 1602843 */   GIM_Try, /*On fail goto*//*Label 22159*/ GIMT_Encode4(1602929), // Rule ID 3286 //
     /* 1602848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1602851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1602859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1602862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1602865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1602868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602894 */     // MIs[0] policy
     /* 1602894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602904 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602928 */     // GIR_Coverage, 3286,
     /* 1602928 */     GIR_EraseRootFromParent_Done,
     /* 1602929 */   // Label 22159: @1602929
     /* 1602929 */   GIM_Try, /*On fail goto*//*Label 22160*/ GIMT_Encode4(1603015), // Rule ID 3287 //
     /* 1602934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1602937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1602945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1602948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1602951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1602954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602980 */     // MIs[0] policy
     /* 1602980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602990 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1603011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603014 */     // GIR_Coverage, 3287,
     /* 1603014 */     GIR_EraseRootFromParent_Done,
     /* 1603015 */   // Label 22160: @1603015
     /* 1603015 */   GIM_Try, /*On fail goto*//*Label 22161*/ GIMT_Encode4(1603101), // Rule ID 3290 //
     /* 1603020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1603031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1603034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1603037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1603040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603066 */     // MIs[0] policy
     /* 1603066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603076 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603100 */     // GIR_Coverage, 3290,
     /* 1603100 */     GIR_EraseRootFromParent_Done,
     /* 1603101 */   // Label 22161: @1603101
     /* 1603101 */   GIM_Try, /*On fail goto*//*Label 22162*/ GIMT_Encode4(1603187), // Rule ID 3291 //
     /* 1603106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1603117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1603120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1603123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1603126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603152 */     // MIs[0] policy
     /* 1603152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603162 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603186 */     // GIR_Coverage, 3291,
     /* 1603186 */     GIR_EraseRootFromParent_Done,
     /* 1603187 */   // Label 22162: @1603187
     /* 1603187 */   GIM_Try, /*On fail goto*//*Label 22163*/ GIMT_Encode4(1603273), // Rule ID 3294 //
     /* 1603192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1603203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1603206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1603209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1603212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603238 */     // MIs[0] policy
     /* 1603238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603248 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603272 */     // GIR_Coverage, 3294,
     /* 1603272 */     GIR_EraseRootFromParent_Done,
     /* 1603273 */   // Label 22163: @1603273
     /* 1603273 */   GIM_Try, /*On fail goto*//*Label 22164*/ GIMT_Encode4(1603359), // Rule ID 3295 //
     /* 1603278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1603289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1603292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1603295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1603298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603324 */     // MIs[0] policy
     /* 1603324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603334 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603358 */     // GIR_Coverage, 3295,
     /* 1603358 */     GIR_EraseRootFromParent_Done,
     /* 1603359 */   // Label 22164: @1603359
     /* 1603359 */   GIM_Try, /*On fail goto*//*Label 22165*/ GIMT_Encode4(1603445), // Rule ID 3298 //
     /* 1603364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1603375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1603378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1603381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1603384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1603387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603410 */     // MIs[0] policy
     /* 1603410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603420 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603444 */     // GIR_Coverage, 3298,
     /* 1603444 */     GIR_EraseRootFromParent_Done,
     /* 1603445 */   // Label 22165: @1603445
     /* 1603445 */   GIM_Try, /*On fail goto*//*Label 22166*/ GIMT_Encode4(1603531), // Rule ID 3299 //
     /* 1603450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1603461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1603464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1603467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1603470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1603473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603496 */     // MIs[0] policy
     /* 1603496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603506 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603530 */     // GIR_Coverage, 3299,
     /* 1603530 */     GIR_EraseRootFromParent_Done,
     /* 1603531 */   // Label 22166: @1603531
     /* 1603531 */   GIM_Try, /*On fail goto*//*Label 22167*/ GIMT_Encode4(1603617), // Rule ID 3302 //
     /* 1603536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1603547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1603550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1603553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1603556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603582 */     // MIs[0] policy
     /* 1603582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603592 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603616 */     // GIR_Coverage, 3302,
     /* 1603616 */     GIR_EraseRootFromParent_Done,
     /* 1603617 */   // Label 22167: @1603617
     /* 1603617 */   GIM_Try, /*On fail goto*//*Label 22168*/ GIMT_Encode4(1603703), // Rule ID 3303 //
     /* 1603622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1603633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1603636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1603639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1603642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603668 */     // MIs[0] policy
     /* 1603668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603678 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603702 */     // GIR_Coverage, 3303,
     /* 1603702 */     GIR_EraseRootFromParent_Done,
     /* 1603703 */   // Label 22168: @1603703
     /* 1603703 */   GIM_Try, /*On fail goto*//*Label 22169*/ GIMT_Encode4(1603789), // Rule ID 3306 //
     /* 1603708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1603719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1603722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1603725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1603728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603754 */     // MIs[0] policy
     /* 1603754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603764 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603788 */     // GIR_Coverage, 3306,
     /* 1603788 */     GIR_EraseRootFromParent_Done,
     /* 1603789 */   // Label 22169: @1603789
     /* 1603789 */   GIM_Try, /*On fail goto*//*Label 22170*/ GIMT_Encode4(1603875), // Rule ID 3307 //
     /* 1603794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1603805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1603808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1603811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1603814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603840 */     // MIs[0] policy
     /* 1603840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603850 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603874 */     // GIR_Coverage, 3307,
     /* 1603874 */     GIR_EraseRootFromParent_Done,
     /* 1603875 */   // Label 22170: @1603875
     /* 1603875 */   GIM_Try, /*On fail goto*//*Label 22171*/ GIMT_Encode4(1603961), // Rule ID 3310 //
     /* 1603880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1603891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1603894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1603897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1603900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603926 */     // MIs[0] policy
     /* 1603926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603936 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603960 */     // GIR_Coverage, 3310,
     /* 1603960 */     GIR_EraseRootFromParent_Done,
     /* 1603961 */   // Label 22171: @1603961
     /* 1603961 */   GIM_Try, /*On fail goto*//*Label 22172*/ GIMT_Encode4(1604047), // Rule ID 3311 //
     /* 1603966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1603977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1603980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1603983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1603986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604012 */     // MIs[0] policy
     /* 1604012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604022 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604046 */     // GIR_Coverage, 3311,
     /* 1604046 */     GIR_EraseRootFromParent_Done,
     /* 1604047 */   // Label 22172: @1604047
     /* 1604047 */   GIM_Try, /*On fail goto*//*Label 22173*/ GIMT_Encode4(1604133), // Rule ID 3314 //
     /* 1604052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1604063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1604066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1604069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1604072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604098 */     // MIs[0] policy
     /* 1604098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604108 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1604111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604132 */     // GIR_Coverage, 3314,
     /* 1604132 */     GIR_EraseRootFromParent_Done,
     /* 1604133 */   // Label 22173: @1604133
     /* 1604133 */   GIM_Try, /*On fail goto*//*Label 22174*/ GIMT_Encode4(1604219), // Rule ID 3315 //
     /* 1604138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1604149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1604152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1604155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1604158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604184 */     // MIs[0] policy
     /* 1604184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604194 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1604197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604218 */     // GIR_Coverage, 3315,
     /* 1604218 */     GIR_EraseRootFromParent_Done,
     /* 1604219 */   // Label 22174: @1604219
     /* 1604219 */   GIM_Try, /*On fail goto*//*Label 22175*/ GIMT_Encode4(1604305), // Rule ID 3318 //
     /* 1604224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1604235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1604238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1604241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1604244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604270 */     // MIs[0] policy
     /* 1604270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604280 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1604283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604304 */     // GIR_Coverage, 3318,
     /* 1604304 */     GIR_EraseRootFromParent_Done,
     /* 1604305 */   // Label 22175: @1604305
     /* 1604305 */   GIM_Try, /*On fail goto*//*Label 22176*/ GIMT_Encode4(1604391), // Rule ID 3319 //
     /* 1604310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1604321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1604324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1604327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1604330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604356 */     // MIs[0] policy
     /* 1604356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604366 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1604369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604390 */     // GIR_Coverage, 3319,
     /* 1604390 */     GIR_EraseRootFromParent_Done,
     /* 1604391 */   // Label 22176: @1604391
     /* 1604391 */   GIM_Try, /*On fail goto*//*Label 22177*/ GIMT_Encode4(1604477), // Rule ID 3322 //
     /* 1604396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1604407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1604410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1604413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1604416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604442 */     // MIs[0] policy
     /* 1604442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604452 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604476 */     // GIR_Coverage, 3322,
     /* 1604476 */     GIR_EraseRootFromParent_Done,
     /* 1604477 */   // Label 22177: @1604477
     /* 1604477 */   GIM_Try, /*On fail goto*//*Label 22178*/ GIMT_Encode4(1604563), // Rule ID 3323 //
     /* 1604482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1604493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1604496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1604499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1604502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604528 */     // MIs[0] policy
     /* 1604528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604538 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604562 */     // GIR_Coverage, 3323,
     /* 1604562 */     GIR_EraseRootFromParent_Done,
     /* 1604563 */   // Label 22178: @1604563
     /* 1604563 */   GIM_Try, /*On fail goto*//*Label 22179*/ GIMT_Encode4(1604649), // Rule ID 3326 //
     /* 1604568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1604579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1604582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1604585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1604588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604614 */     // MIs[0] policy
     /* 1604614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604624 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1604627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604648 */     // GIR_Coverage, 3326,
     /* 1604648 */     GIR_EraseRootFromParent_Done,
     /* 1604649 */   // Label 22179: @1604649
     /* 1604649 */   GIM_Try, /*On fail goto*//*Label 22180*/ GIMT_Encode4(1604735), // Rule ID 3327 //
     /* 1604654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1604665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1604668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1604671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1604674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604700 */     // MIs[0] policy
     /* 1604700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1604713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604734 */     // GIR_Coverage, 3327,
     /* 1604734 */     GIR_EraseRootFromParent_Done,
     /* 1604735 */   // Label 22180: @1604735
     /* 1604735 */   GIM_Try, /*On fail goto*//*Label 22181*/ GIMT_Encode4(1604821), // Rule ID 3330 //
     /* 1604740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1604751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1604754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1604757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1604760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604786 */     // MIs[0] policy
     /* 1604786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604796 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1604799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604820 */     // GIR_Coverage, 3330,
     /* 1604820 */     GIR_EraseRootFromParent_Done,
     /* 1604821 */   // Label 22181: @1604821
     /* 1604821 */   GIM_Try, /*On fail goto*//*Label 22182*/ GIMT_Encode4(1604907), // Rule ID 3331 //
     /* 1604826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1604837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1604840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1604843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1604846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604872 */     // MIs[0] policy
     /* 1604872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604882 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1604885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604906 */     // GIR_Coverage, 3331,
     /* 1604906 */     GIR_EraseRootFromParent_Done,
     /* 1604907 */   // Label 22182: @1604907
     /* 1604907 */   GIM_Try, /*On fail goto*//*Label 22183*/ GIMT_Encode4(1604993), // Rule ID 3334 //
     /* 1604912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1604923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1604926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1604929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1604932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604958 */     // MIs[0] policy
     /* 1604958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604992 */     // GIR_Coverage, 3334,
     /* 1604992 */     GIR_EraseRootFromParent_Done,
     /* 1604993 */   // Label 22183: @1604993
     /* 1604993 */   GIM_Try, /*On fail goto*//*Label 22184*/ GIMT_Encode4(1605079), // Rule ID 3335 //
     /* 1604998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1605001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1605009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1605012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1605015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1605018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1605028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605044 */     // MIs[0] policy
     /* 1605044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605054 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1605057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1605075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605078 */     // GIR_Coverage, 3335,
     /* 1605078 */     GIR_EraseRootFromParent_Done,
     /* 1605079 */   // Label 22184: @1605079
     /* 1605079 */   GIM_Try, /*On fail goto*//*Label 22185*/ GIMT_Encode4(1605165), // Rule ID 3338 //
     /* 1605084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1605095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1605098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1605101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605130 */     // MIs[0] policy
     /* 1605130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1605143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605164 */     // GIR_Coverage, 3338,
     /* 1605164 */     GIR_EraseRootFromParent_Done,
     /* 1605165 */   // Label 22185: @1605165
     /* 1605165 */   GIM_Try, /*On fail goto*//*Label 22186*/ GIMT_Encode4(1605251), // Rule ID 3339 //
     /* 1605170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1605181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1605184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1605187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605216 */     // MIs[0] policy
     /* 1605216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605226 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1605229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605250 */     // GIR_Coverage, 3339,
     /* 1605250 */     GIR_EraseRootFromParent_Done,
     /* 1605251 */   // Label 22186: @1605251
     /* 1605251 */   GIM_Try, /*On fail goto*//*Label 22187*/ GIMT_Encode4(1605337), // Rule ID 3342 //
     /* 1605256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1605267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1605270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1605273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605302 */     // MIs[0] policy
     /* 1605302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605312 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1605315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605336 */     // GIR_Coverage, 3342,
     /* 1605336 */     GIR_EraseRootFromParent_Done,
     /* 1605337 */   // Label 22187: @1605337
     /* 1605337 */   GIM_Try, /*On fail goto*//*Label 22188*/ GIMT_Encode4(1605423), // Rule ID 3343 //
     /* 1605342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1605353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1605356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1605359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605388 */     // MIs[0] policy
     /* 1605388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605398 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1605401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605422 */     // GIR_Coverage, 3343,
     /* 1605422 */     GIR_EraseRootFromParent_Done,
     /* 1605423 */   // Label 22188: @1605423
     /* 1605423 */   GIM_Try, /*On fail goto*//*Label 22189*/ GIMT_Encode4(1605509), // Rule ID 3346 //
     /* 1605428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1605439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1605442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1605445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605474 */     // MIs[0] policy
     /* 1605474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605484 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605508 */     // GIR_Coverage, 3346,
     /* 1605508 */     GIR_EraseRootFromParent_Done,
     /* 1605509 */   // Label 22189: @1605509
     /* 1605509 */   GIM_Try, /*On fail goto*//*Label 22190*/ GIMT_Encode4(1605595), // Rule ID 3347 //
     /* 1605514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1605525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1605528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1605531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605560 */     // MIs[0] policy
     /* 1605560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605570 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605594 */     // GIR_Coverage, 3347,
     /* 1605594 */     GIR_EraseRootFromParent_Done,
     /* 1605595 */   // Label 22190: @1605595
     /* 1605595 */   GIM_Try, /*On fail goto*//*Label 22191*/ GIMT_Encode4(1605681), // Rule ID 3350 //
     /* 1605600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1605611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1605614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1605617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605646 */     // MIs[0] policy
     /* 1605646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605656 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1605659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605680 */     // GIR_Coverage, 3350,
     /* 1605680 */     GIR_EraseRootFromParent_Done,
     /* 1605681 */   // Label 22191: @1605681
     /* 1605681 */   GIM_Try, /*On fail goto*//*Label 22192*/ GIMT_Encode4(1605767), // Rule ID 3351 //
     /* 1605686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1605697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1605700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1605703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605732 */     // MIs[0] policy
     /* 1605732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605742 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1605745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605766 */     // GIR_Coverage, 3351,
     /* 1605766 */     GIR_EraseRootFromParent_Done,
     /* 1605767 */   // Label 22192: @1605767
     /* 1605767 */   GIM_Try, /*On fail goto*//*Label 22193*/ GIMT_Encode4(1605853), // Rule ID 3354 //
     /* 1605772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1605783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1605786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1605789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605818 */     // MIs[0] policy
     /* 1605818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605828 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605852 */     // GIR_Coverage, 3354,
     /* 1605852 */     GIR_EraseRootFromParent_Done,
     /* 1605853 */   // Label 22193: @1605853
     /* 1605853 */   GIM_Try, /*On fail goto*//*Label 22194*/ GIMT_Encode4(1605939), // Rule ID 3355 //
     /* 1605858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1605869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1605872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1605875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605904 */     // MIs[0] policy
     /* 1605904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605914 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605938 */     // GIR_Coverage, 3355,
     /* 1605938 */     GIR_EraseRootFromParent_Done,
     /* 1605939 */   // Label 22194: @1605939
     /* 1605939 */   GIM_Try, /*On fail goto*//*Label 22195*/ GIMT_Encode4(1606025), // Rule ID 3358 //
     /* 1605944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1605955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1605958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1605961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605990 */     // MIs[0] policy
     /* 1605990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1606003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606024 */     // GIR_Coverage, 3358,
     /* 1606024 */     GIR_EraseRootFromParent_Done,
     /* 1606025 */   // Label 22195: @1606025
     /* 1606025 */   GIM_Try, /*On fail goto*//*Label 22196*/ GIMT_Encode4(1606111), // Rule ID 3359 //
     /* 1606030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1606041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1606044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1606047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606076 */     // MIs[0] policy
     /* 1606076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1606089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606110 */     // GIR_Coverage, 3359,
     /* 1606110 */     GIR_EraseRootFromParent_Done,
     /* 1606111 */   // Label 22196: @1606111
     /* 1606111 */   GIM_Try, /*On fail goto*//*Label 22197*/ GIMT_Encode4(1606197), // Rule ID 3362 //
     /* 1606116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1606127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1606130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1606133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606162 */     // MIs[0] policy
     /* 1606162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606172 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606196 */     // GIR_Coverage, 3362,
     /* 1606196 */     GIR_EraseRootFromParent_Done,
     /* 1606197 */   // Label 22197: @1606197
     /* 1606197 */   GIM_Try, /*On fail goto*//*Label 22198*/ GIMT_Encode4(1606283), // Rule ID 3363 //
     /* 1606202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1606213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1606216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1606219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606248 */     // MIs[0] policy
     /* 1606248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606258 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606282 */     // GIR_Coverage, 3363,
     /* 1606282 */     GIR_EraseRootFromParent_Done,
     /* 1606283 */   // Label 22198: @1606283
     /* 1606283 */   GIM_Try, /*On fail goto*//*Label 22199*/ GIMT_Encode4(1606369), // Rule ID 3366 //
     /* 1606288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1606299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1606302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1606305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1606311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606334 */     // MIs[0] policy
     /* 1606334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606344 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606368 */     // GIR_Coverage, 3366,
     /* 1606368 */     GIR_EraseRootFromParent_Done,
     /* 1606369 */   // Label 22199: @1606369
     /* 1606369 */   GIM_Try, /*On fail goto*//*Label 22200*/ GIMT_Encode4(1606455), // Rule ID 3367 //
     /* 1606374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1606385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1606388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1606391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1606397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606420 */     // MIs[0] policy
     /* 1606420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606430 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606454 */     // GIR_Coverage, 3367,
     /* 1606454 */     GIR_EraseRootFromParent_Done,
     /* 1606455 */   // Label 22200: @1606455
     /* 1606455 */   GIM_Try, /*On fail goto*//*Label 22201*/ GIMT_Encode4(1606541), // Rule ID 3370 //
     /* 1606460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1606471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1606474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1606477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606506 */     // MIs[0] policy
     /* 1606506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606540 */     // GIR_Coverage, 3370,
     /* 1606540 */     GIR_EraseRootFromParent_Done,
     /* 1606541 */   // Label 22201: @1606541
     /* 1606541 */   GIM_Try, /*On fail goto*//*Label 22202*/ GIMT_Encode4(1606627), // Rule ID 3371 //
     /* 1606546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1606557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1606560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1606563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606592 */     // MIs[0] policy
     /* 1606592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606626 */     // GIR_Coverage, 3371,
     /* 1606626 */     GIR_EraseRootFromParent_Done,
     /* 1606627 */   // Label 22202: @1606627
     /* 1606627 */   GIM_Try, /*On fail goto*//*Label 22203*/ GIMT_Encode4(1606713), // Rule ID 3374 //
     /* 1606632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1606635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1606643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1606646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1606649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606678 */     // MIs[0] policy
     /* 1606678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606688 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1606709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606712 */     // GIR_Coverage, 3374,
     /* 1606712 */     GIR_EraseRootFromParent_Done,
     /* 1606713 */   // Label 22203: @1606713
     /* 1606713 */   GIM_Try, /*On fail goto*//*Label 22204*/ GIMT_Encode4(1606799), // Rule ID 3375 //
     /* 1606718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1606721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1606729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1606732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1606735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606764 */     // MIs[0] policy
     /* 1606764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1606795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606798 */     // GIR_Coverage, 3375,
     /* 1606798 */     GIR_EraseRootFromParent_Done,
     /* 1606799 */   // Label 22204: @1606799
     /* 1606799 */   GIM_Try, /*On fail goto*//*Label 22205*/ GIMT_Encode4(1606885), // Rule ID 3378 //
     /* 1606804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1606815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1606818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1606821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606850 */     // MIs[0] policy
     /* 1606850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606860 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1606863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606884 */     // GIR_Coverage, 3378,
     /* 1606884 */     GIR_EraseRootFromParent_Done,
     /* 1606885 */   // Label 22205: @1606885
     /* 1606885 */   GIM_Try, /*On fail goto*//*Label 22206*/ GIMT_Encode4(1606971), // Rule ID 3379 //
     /* 1606890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1606901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1606904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1606907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606936 */     // MIs[0] policy
     /* 1606936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606946 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1606949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606970 */     // GIR_Coverage, 3379,
     /* 1606970 */     GIR_EraseRootFromParent_Done,
     /* 1606971 */   // Label 22206: @1606971
     /* 1606971 */   GIM_Try, /*On fail goto*//*Label 22207*/ GIMT_Encode4(1607057), // Rule ID 3382 //
     /* 1606976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1606987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1606990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1606993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1606999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607022 */     // MIs[0] policy
     /* 1607022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607032 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1607053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607056 */     // GIR_Coverage, 3382,
     /* 1607056 */     GIR_EraseRootFromParent_Done,
     /* 1607057 */   // Label 22207: @1607057
     /* 1607057 */   GIM_Try, /*On fail goto*//*Label 22208*/ GIMT_Encode4(1607143), // Rule ID 3383 //
     /* 1607062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1607073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1607076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1607079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1607085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607108 */     // MIs[0] policy
     /* 1607108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607118 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1607139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607142 */     // GIR_Coverage, 3383,
     /* 1607142 */     GIR_EraseRootFromParent_Done,
     /* 1607143 */   // Label 22208: @1607143
     /* 1607143 */   GIM_Try, /*On fail goto*//*Label 22209*/ GIMT_Encode4(1607229), // Rule ID 3386 //
     /* 1607148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1607159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1607162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1607165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1607171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607194 */     // MIs[0] policy
     /* 1607194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607204 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1607225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607228 */     // GIR_Coverage, 3386,
     /* 1607228 */     GIR_EraseRootFromParent_Done,
     /* 1607229 */   // Label 22209: @1607229
     /* 1607229 */   GIM_Try, /*On fail goto*//*Label 22210*/ GIMT_Encode4(1607315), // Rule ID 3387 //
     /* 1607234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1607245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1607248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1607251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1607257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607280 */     // MIs[0] policy
     /* 1607280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607290 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1607311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607314 */     // GIR_Coverage, 3387,
     /* 1607314 */     GIR_EraseRootFromParent_Done,
     /* 1607315 */   // Label 22210: @1607315
     /* 1607315 */   GIM_Try, /*On fail goto*//*Label 22211*/ GIMT_Encode4(1607401), // Rule ID 3390 //
     /* 1607320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1607331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1607334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1607337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607366 */     // MIs[0] policy
     /* 1607366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607400 */     // GIR_Coverage, 3390,
     /* 1607400 */     GIR_EraseRootFromParent_Done,
     /* 1607401 */   // Label 22211: @1607401
     /* 1607401 */   GIM_Try, /*On fail goto*//*Label 22212*/ GIMT_Encode4(1607487), // Rule ID 3391 //
     /* 1607406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1607417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1607420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1607423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607452 */     // MIs[0] policy
     /* 1607452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607462 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607486 */     // GIR_Coverage, 3391,
     /* 1607486 */     GIR_EraseRootFromParent_Done,
     /* 1607487 */   // Label 22212: @1607487
     /* 1607487 */   GIM_Try, /*On fail goto*//*Label 22213*/ GIMT_Encode4(1607573), // Rule ID 3394 //
     /* 1607492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1607503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1607506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1607509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607538 */     // MIs[0] policy
     /* 1607538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607548 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607572 */     // GIR_Coverage, 3394,
     /* 1607572 */     GIR_EraseRootFromParent_Done,
     /* 1607573 */   // Label 22213: @1607573
     /* 1607573 */   GIM_Try, /*On fail goto*//*Label 22214*/ GIMT_Encode4(1607659), // Rule ID 3395 //
     /* 1607578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1607589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1607592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1607595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607624 */     // MIs[0] policy
     /* 1607624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607634 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607658 */     // GIR_Coverage, 3395,
     /* 1607658 */     GIR_EraseRootFromParent_Done,
     /* 1607659 */   // Label 22214: @1607659
     /* 1607659 */   GIM_Try, /*On fail goto*//*Label 22215*/ GIMT_Encode4(1607745), // Rule ID 3398 //
     /* 1607664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1607675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1607678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1607681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1607687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607710 */     // MIs[0] policy
     /* 1607710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607720 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607744 */     // GIR_Coverage, 3398,
     /* 1607744 */     GIR_EraseRootFromParent_Done,
     /* 1607745 */   // Label 22215: @1607745
     /* 1607745 */   GIM_Try, /*On fail goto*//*Label 22216*/ GIMT_Encode4(1607831), // Rule ID 3399 //
     /* 1607750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1607761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1607764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1607767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1607773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607796 */     // MIs[0] policy
     /* 1607796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607806 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607830 */     // GIR_Coverage, 3399,
     /* 1607830 */     GIR_EraseRootFromParent_Done,
     /* 1607831 */   // Label 22216: @1607831
     /* 1607831 */   GIM_Try, /*On fail goto*//*Label 22217*/ GIMT_Encode4(1607917), // Rule ID 3402 //
     /* 1607836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1607847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1607850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607882 */     // MIs[0] policy
     /* 1607882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607916 */     // GIR_Coverage, 3402,
     /* 1607916 */     GIR_EraseRootFromParent_Done,
     /* 1607917 */   // Label 22217: @1607917
     /* 1607917 */   GIM_Try, /*On fail goto*//*Label 22218*/ GIMT_Encode4(1608003), // Rule ID 3403 //
     /* 1607922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1607933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1607936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607968 */     // MIs[0] policy
     /* 1607968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607978 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608002 */     // GIR_Coverage, 3403,
     /* 1608002 */     GIR_EraseRootFromParent_Done,
     /* 1608003 */   // Label 22218: @1608003
     /* 1608003 */   GIM_Try, /*On fail goto*//*Label 22219*/ GIMT_Encode4(1608089), // Rule ID 3406 //
     /* 1608008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1608019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1608022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1608025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608054 */     // MIs[0] policy
     /* 1608054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608064 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1608067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608088 */     // GIR_Coverage, 3406,
     /* 1608088 */     GIR_EraseRootFromParent_Done,
     /* 1608089 */   // Label 22219: @1608089
     /* 1608089 */   GIM_Try, /*On fail goto*//*Label 22220*/ GIMT_Encode4(1608175), // Rule ID 3407 //
     /* 1608094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1608105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1608108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1608111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608140 */     // MIs[0] policy
     /* 1608140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608150 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1608153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608174 */     // GIR_Coverage, 3407,
     /* 1608174 */     GIR_EraseRootFromParent_Done,
     /* 1608175 */   // Label 22220: @1608175
     /* 1608175 */   GIM_Try, /*On fail goto*//*Label 22221*/ GIMT_Encode4(1608261), // Rule ID 3410 //
     /* 1608180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1608191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1608194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1608197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1608203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608226 */     // MIs[0] policy
     /* 1608226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608236 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1608239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608260 */     // GIR_Coverage, 3410,
     /* 1608260 */     GIR_EraseRootFromParent_Done,
     /* 1608261 */   // Label 22221: @1608261
     /* 1608261 */   GIM_Try, /*On fail goto*//*Label 22222*/ GIMT_Encode4(1608347), // Rule ID 3411 //
     /* 1608266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1608277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1608280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1608283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1608289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608312 */     // MIs[0] policy
     /* 1608312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608322 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1608325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608346 */     // GIR_Coverage, 3411,
     /* 1608346 */     GIR_EraseRootFromParent_Done,
     /* 1608347 */   // Label 22222: @1608347
     /* 1608347 */   GIM_Try, /*On fail goto*//*Label 22223*/ GIMT_Encode4(1608433), // Rule ID 3414 //
     /* 1608352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1608355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1608363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1608366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1608369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608398 */     // MIs[0] policy
     /* 1608398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1608411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608432 */     // GIR_Coverage, 3414,
     /* 1608432 */     GIR_EraseRootFromParent_Done,
     /* 1608433 */   // Label 22223: @1608433
     /* 1608433 */   GIM_Try, /*On fail goto*//*Label 22224*/ GIMT_Encode4(1608519), // Rule ID 3415 //
     /* 1608438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1608449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1608452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1608455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608484 */     // MIs[0] policy
     /* 1608484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1608497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608518 */     // GIR_Coverage, 3415,
     /* 1608518 */     GIR_EraseRootFromParent_Done,
     /* 1608519 */   // Label 22224: @1608519
     /* 1608519 */   GIM_Try, /*On fail goto*//*Label 22225*/ GIMT_Encode4(1608605), // Rule ID 3418 //
     /* 1608524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1608527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1608535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1608538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1608541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608570 */     // MIs[0] policy
     /* 1608570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608580 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1608583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608604 */     // GIR_Coverage, 3418,
     /* 1608604 */     GIR_EraseRootFromParent_Done,
     /* 1608605 */   // Label 22225: @1608605
     /* 1608605 */   GIM_Try, /*On fail goto*//*Label 22226*/ GIMT_Encode4(1608691), // Rule ID 3419 //
     /* 1608610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1608621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1608624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1608627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608656 */     // MIs[0] policy
     /* 1608656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608666 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1608669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608690 */     // GIR_Coverage, 3419,
     /* 1608690 */     GIR_EraseRootFromParent_Done,
     /* 1608691 */   // Label 22226: @1608691
     /* 1608691 */   GIM_Try, /*On fail goto*//*Label 22227*/ GIMT_Encode4(1608777), // Rule ID 3422 //
     /* 1608696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1608699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1608707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1608710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1608713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608742 */     // MIs[0] policy
     /* 1608742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608752 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1608755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608776 */     // GIR_Coverage, 3422,
     /* 1608776 */     GIR_EraseRootFromParent_Done,
     /* 1608777 */   // Label 22227: @1608777
     /* 1608777 */   GIM_Try, /*On fail goto*//*Label 22228*/ GIMT_Encode4(1608863), // Rule ID 3423 //
     /* 1608782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1608793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1608796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1608799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608828 */     // MIs[0] policy
     /* 1608828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608838 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1608841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608862 */     // GIR_Coverage, 3423,
     /* 1608862 */     GIR_EraseRootFromParent_Done,
     /* 1608863 */   // Label 22228: @1608863
     /* 1608863 */   GIM_Try, /*On fail goto*//*Label 22229*/ GIMT_Encode4(1608949), // Rule ID 3426 //
     /* 1608868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1608879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1608882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608914 */     // MIs[0] policy
     /* 1608914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608924 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1608927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608948 */     // GIR_Coverage, 3426,
     /* 1608948 */     GIR_EraseRootFromParent_Done,
     /* 1608949 */   // Label 22229: @1608949
     /* 1608949 */   GIM_Try, /*On fail goto*//*Label 22230*/ GIMT_Encode4(1609035), // Rule ID 3427 //
     /* 1608954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1608965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1608968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609000 */     // MIs[0] policy
     /* 1609000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609010 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1609013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609034 */     // GIR_Coverage, 3427,
     /* 1609034 */     GIR_EraseRootFromParent_Done,
     /* 1609035 */   // Label 22230: @1609035
     /* 1609035 */   GIM_Try, /*On fail goto*//*Label 22231*/ GIMT_Encode4(1609121), // Rule ID 3430 //
     /* 1609040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1609051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1609054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1609057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609086 */     // MIs[0] policy
     /* 1609086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609096 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1609099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609120 */     // GIR_Coverage, 3430,
     /* 1609120 */     GIR_EraseRootFromParent_Done,
     /* 1609121 */   // Label 22231: @1609121
     /* 1609121 */   GIM_Try, /*On fail goto*//*Label 22232*/ GIMT_Encode4(1609207), // Rule ID 3431 //
     /* 1609126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1609137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1609140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1609143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609172 */     // MIs[0] policy
     /* 1609172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609182 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1609185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609206 */     // GIR_Coverage, 3431,
     /* 1609206 */     GIR_EraseRootFromParent_Done,
     /* 1609207 */   // Label 22232: @1609207
     /* 1609207 */   GIM_Try, /*On fail goto*//*Label 22233*/ GIMT_Encode4(1609293), // Rule ID 3434 //
     /* 1609212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1609223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1609226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1609229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609258 */     // MIs[0] policy
     /* 1609258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609268 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609292 */     // GIR_Coverage, 3434,
     /* 1609292 */     GIR_EraseRootFromParent_Done,
     /* 1609293 */   // Label 22233: @1609293
     /* 1609293 */   GIM_Try, /*On fail goto*//*Label 22234*/ GIMT_Encode4(1609379), // Rule ID 3435 //
     /* 1609298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1609309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1609312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1609315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609344 */     // MIs[0] policy
     /* 1609344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609354 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609378 */     // GIR_Coverage, 3435,
     /* 1609378 */     GIR_EraseRootFromParent_Done,
     /* 1609379 */   // Label 22234: @1609379
     /* 1609379 */   GIM_Try, /*On fail goto*//*Label 22235*/ GIMT_Encode4(1609465), // Rule ID 3438 //
     /* 1609384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1609395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1609398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1609401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609430 */     // MIs[0] policy
     /* 1609430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609440 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1609443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609464 */     // GIR_Coverage, 3438,
     /* 1609464 */     GIR_EraseRootFromParent_Done,
     /* 1609465 */   // Label 22235: @1609465
     /* 1609465 */   GIM_Try, /*On fail goto*//*Label 22236*/ GIMT_Encode4(1609551), // Rule ID 3439 //
     /* 1609470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1609481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1609484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1609487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609516 */     // MIs[0] policy
     /* 1609516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609526 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1609529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609550 */     // GIR_Coverage, 3439,
     /* 1609550 */     GIR_EraseRootFromParent_Done,
     /* 1609551 */   // Label 22236: @1609551
     /* 1609551 */   GIM_Try, /*On fail goto*//*Label 22237*/ GIMT_Encode4(1609637), // Rule ID 3442 //
     /* 1609556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1609567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1609570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609602 */     // MIs[0] policy
     /* 1609602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609612 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609636 */     // GIR_Coverage, 3442,
     /* 1609636 */     GIR_EraseRootFromParent_Done,
     /* 1609637 */   // Label 22237: @1609637
     /* 1609637 */   GIM_Try, /*On fail goto*//*Label 22238*/ GIMT_Encode4(1609723), // Rule ID 3443 //
     /* 1609642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1609653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1609656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609688 */     // MIs[0] policy
     /* 1609688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609698 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609722 */     // GIR_Coverage, 3443,
     /* 1609722 */     GIR_EraseRootFromParent_Done,
     /* 1609723 */   // Label 22238: @1609723
     /* 1609723 */   GIM_Try, /*On fail goto*//*Label 22239*/ GIMT_Encode4(1609809), // Rule ID 3446 //
     /* 1609728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1609745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609774 */     // MIs[0] policy
     /* 1609774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609808 */     // GIR_Coverage, 3446,
     /* 1609808 */     GIR_EraseRootFromParent_Done,
     /* 1609809 */   // Label 22239: @1609809
     /* 1609809 */   GIM_Try, /*On fail goto*//*Label 22240*/ GIMT_Encode4(1609895), // Rule ID 3447 //
     /* 1609814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1609831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609860 */     // MIs[0] policy
     /* 1609860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609870 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609894 */     // GIR_Coverage, 3447,
     /* 1609894 */     GIR_EraseRootFromParent_Done,
     /* 1609895 */   // Label 22240: @1609895
     /* 1609895 */   GIM_Try, /*On fail goto*//*Label 22241*/ GIMT_Encode4(1609981), // Rule ID 3450 //
     /* 1609900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1609911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1609914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1609917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609946 */     // MIs[0] policy
     /* 1609946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609956 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609980 */     // GIR_Coverage, 3450,
     /* 1609980 */     GIR_EraseRootFromParent_Done,
     /* 1609981 */   // Label 22241: @1609981
     /* 1609981 */   GIM_Try, /*On fail goto*//*Label 22242*/ GIMT_Encode4(1610067), // Rule ID 3451 //
     /* 1609986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1609997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1610000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1610003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610032 */     // MIs[0] policy
     /* 1610032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610042 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610066 */     // GIR_Coverage, 3451,
     /* 1610066 */     GIR_EraseRootFromParent_Done,
     /* 1610067 */   // Label 22242: @1610067
     /* 1610067 */   GIM_Try, /*On fail goto*//*Label 22243*/ GIMT_Encode4(1610153), // Rule ID 3454 //
     /* 1610072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1610083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1610086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1610089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1610095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610118 */     // MIs[0] policy
     /* 1610118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610128 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610152 */     // GIR_Coverage, 3454,
     /* 1610152 */     GIR_EraseRootFromParent_Done,
     /* 1610153 */   // Label 22243: @1610153
     /* 1610153 */   GIM_Try, /*On fail goto*//*Label 22244*/ GIMT_Encode4(1610239), // Rule ID 3455 //
     /* 1610158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1610169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1610172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1610175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1610181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610204 */     // MIs[0] policy
     /* 1610204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610214 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610238 */     // GIR_Coverage, 3455,
     /* 1610238 */     GIR_EraseRootFromParent_Done,
     /* 1610239 */   // Label 22244: @1610239
     /* 1610239 */   GIM_Try, /*On fail goto*//*Label 22245*/ GIMT_Encode4(1610325), // Rule ID 3458 //
     /* 1610244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1610255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1610258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1610261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1610267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610290 */     // MIs[0] policy
     /* 1610290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610324 */     // GIR_Coverage, 3458,
     /* 1610324 */     GIR_EraseRootFromParent_Done,
     /* 1610325 */   // Label 22245: @1610325
     /* 1610325 */   GIM_Try, /*On fail goto*//*Label 22246*/ GIMT_Encode4(1610411), // Rule ID 3459 //
     /* 1610330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1610341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1610344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1610347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1610353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610376 */     // MIs[0] policy
     /* 1610376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610386 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610410 */     // GIR_Coverage, 3459,
     /* 1610410 */     GIR_EraseRootFromParent_Done,
     /* 1610411 */   // Label 22246: @1610411
     /* 1610411 */   GIM_Try, /*On fail goto*//*Label 22247*/ GIMT_Encode4(1610497), // Rule ID 3462 //
     /* 1610416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1610419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1610427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1610430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1610433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610462 */     // MIs[0] policy
     /* 1610462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610472 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1610493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610496 */     // GIR_Coverage, 3462,
     /* 1610496 */     GIR_EraseRootFromParent_Done,
     /* 1610497 */   // Label 22247: @1610497
     /* 1610497 */   GIM_Try, /*On fail goto*//*Label 22248*/ GIMT_Encode4(1610583), // Rule ID 3463 //
     /* 1610502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1610505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1610513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1610516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1610519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610548 */     // MIs[0] policy
     /* 1610548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610558 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1610579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610582 */     // GIR_Coverage, 3463,
     /* 1610582 */     GIR_EraseRootFromParent_Done,
     /* 1610583 */   // Label 22248: @1610583
     /* 1610583 */   GIM_Try, /*On fail goto*//*Label 22249*/ GIMT_Encode4(1610669), // Rule ID 3466 //
     /* 1610588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1610599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1610602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610634 */     // MIs[0] policy
     /* 1610634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1610647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610668 */     // GIR_Coverage, 3466,
     /* 1610668 */     GIR_EraseRootFromParent_Done,
     /* 1610669 */   // Label 22249: @1610669
     /* 1610669 */   GIM_Try, /*On fail goto*//*Label 22250*/ GIMT_Encode4(1610755), // Rule ID 3467 //
     /* 1610674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1610685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1610688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610720 */     // MIs[0] policy
     /* 1610720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1610733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610754 */     // GIR_Coverage, 3467,
     /* 1610754 */     GIR_EraseRootFromParent_Done,
     /* 1610755 */   // Label 22250: @1610755
     /* 1610755 */   GIM_Try, /*On fail goto*//*Label 22251*/ GIMT_Encode4(1610841), // Rule ID 3470 //
     /* 1610760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1610771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1610774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610806 */     // MIs[0] policy
     /* 1610806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610816 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1610819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610840 */     // GIR_Coverage, 3470,
     /* 1610840 */     GIR_EraseRootFromParent_Done,
     /* 1610841 */   // Label 22251: @1610841
     /* 1610841 */   GIM_Try, /*On fail goto*//*Label 22252*/ GIMT_Encode4(1610927), // Rule ID 3471 //
     /* 1610846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1610857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1610860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610892 */     // MIs[0] policy
     /* 1610892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610902 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1610905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610926 */     // GIR_Coverage, 3471,
     /* 1610926 */     GIR_EraseRootFromParent_Done,
     /* 1610927 */   // Label 22252: @1610927
     /* 1610927 */   GIM_Try, /*On fail goto*//*Label 22253*/ GIMT_Encode4(1611013), // Rule ID 3474 //
     /* 1610932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1610943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1610946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1610949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1610955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610978 */     // MIs[0] policy
     /* 1610978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610988 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1610991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611012 */     // GIR_Coverage, 3474,
     /* 1611012 */     GIR_EraseRootFromParent_Done,
     /* 1611013 */   // Label 22253: @1611013
     /* 1611013 */   GIM_Try, /*On fail goto*//*Label 22254*/ GIMT_Encode4(1611099), // Rule ID 3475 //
     /* 1611018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1611029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1611032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1611035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1611041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611064 */     // MIs[0] policy
     /* 1611064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611074 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611098 */     // GIR_Coverage, 3475,
     /* 1611098 */     GIR_EraseRootFromParent_Done,
     /* 1611099 */   // Label 22254: @1611099
     /* 1611099 */   GIM_Try, /*On fail goto*//*Label 22255*/ GIMT_Encode4(1611185), // Rule ID 3478 //
     /* 1611104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1611115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1611118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1611121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611150 */     // MIs[0] policy
     /* 1611150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611184 */     // GIR_Coverage, 3478,
     /* 1611184 */     GIR_EraseRootFromParent_Done,
     /* 1611185 */   // Label 22255: @1611185
     /* 1611185 */   GIM_Try, /*On fail goto*//*Label 22256*/ GIMT_Encode4(1611271), // Rule ID 3479 //
     /* 1611190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1611201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1611204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1611207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611236 */     // MIs[0] policy
     /* 1611236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611270 */     // GIR_Coverage, 3479,
     /* 1611270 */     GIR_EraseRootFromParent_Done,
     /* 1611271 */   // Label 22256: @1611271
     /* 1611271 */   GIM_Try, /*On fail goto*//*Label 22257*/ GIMT_Encode4(1611357), // Rule ID 3482 //
     /* 1611276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1611287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1611290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1611293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611322 */     // MIs[0] policy
     /* 1611322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611332 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611356 */     // GIR_Coverage, 3482,
     /* 1611356 */     GIR_EraseRootFromParent_Done,
     /* 1611357 */   // Label 22257: @1611357
     /* 1611357 */   GIM_Try, /*On fail goto*//*Label 22258*/ GIMT_Encode4(1611443), // Rule ID 3483 //
     /* 1611362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1611373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1611376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1611379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611408 */     // MIs[0] policy
     /* 1611408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611418 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611442 */     // GIR_Coverage, 3483,
     /* 1611442 */     GIR_EraseRootFromParent_Done,
     /* 1611443 */   // Label 22258: @1611443
     /* 1611443 */   GIM_Try, /*On fail goto*//*Label 22259*/ GIMT_Encode4(1611529), // Rule ID 3486 //
     /* 1611448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1611459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1611465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611494 */     // MIs[0] policy
     /* 1611494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611504 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611528 */     // GIR_Coverage, 3486,
     /* 1611528 */     GIR_EraseRootFromParent_Done,
     /* 1611529 */   // Label 22259: @1611529
     /* 1611529 */   GIM_Try, /*On fail goto*//*Label 22260*/ GIMT_Encode4(1611615), // Rule ID 3487 //
     /* 1611534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1611545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1611551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611580 */     // MIs[0] policy
     /* 1611580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611590 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611614 */     // GIR_Coverage, 3487,
     /* 1611614 */     GIR_EraseRootFromParent_Done,
     /* 1611615 */   // Label 22260: @1611615
     /* 1611615 */   GIM_Try, /*On fail goto*//*Label 22261*/ GIMT_Encode4(1611701), // Rule ID 3490 //
     /* 1611620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1611637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611666 */     // MIs[0] policy
     /* 1611666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611700 */     // GIR_Coverage, 3490,
     /* 1611700 */     GIR_EraseRootFromParent_Done,
     /* 1611701 */   // Label 22261: @1611701
     /* 1611701 */   GIM_Try, /*On fail goto*//*Label 22262*/ GIMT_Encode4(1611787), // Rule ID 3491 //
     /* 1611706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1611723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611752 */     // MIs[0] policy
     /* 1611752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611786 */     // GIR_Coverage, 3491,
     /* 1611786 */     GIR_EraseRootFromParent_Done,
     /* 1611787 */   // Label 22262: @1611787
     /* 1611787 */   GIM_Try, /*On fail goto*//*Label 22263*/ GIMT_Encode4(1611873), // Rule ID 3494 //
     /* 1611792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1611809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611838 */     // MIs[0] policy
     /* 1611838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611848 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611872 */     // GIR_Coverage, 3494,
     /* 1611872 */     GIR_EraseRootFromParent_Done,
     /* 1611873 */   // Label 22263: @1611873
     /* 1611873 */   GIM_Try, /*On fail goto*//*Label 22264*/ GIMT_Encode4(1611959), // Rule ID 3495 //
     /* 1611878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1611895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611924 */     // MIs[0] policy
     /* 1611924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611934 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611958 */     // GIR_Coverage, 3495,
     /* 1611958 */     GIR_EraseRootFromParent_Done,
     /* 1611959 */   // Label 22264: @1611959
     /* 1611959 */   GIM_Try, /*On fail goto*//*Label 22265*/ GIMT_Encode4(1612045), // Rule ID 3498 //
     /* 1611964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1611975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1611978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1611981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612010 */     // MIs[0] policy
     /* 1612010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612020 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1612023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612044 */     // GIR_Coverage, 3498,
     /* 1612044 */     GIR_EraseRootFromParent_Done,
     /* 1612045 */   // Label 22265: @1612045
     /* 1612045 */   GIM_Try, /*On fail goto*//*Label 22266*/ GIMT_Encode4(1612131), // Rule ID 3499 //
     /* 1612050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1612061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1612064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1612067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1612073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612096 */     // MIs[0] policy
     /* 1612096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612106 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1612109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612130 */     // GIR_Coverage, 3499,
     /* 1612130 */     GIR_EraseRootFromParent_Done,
     /* 1612131 */   // Label 22266: @1612131
     /* 1612131 */   GIM_Try, /*On fail goto*//*Label 22267*/ GIMT_Encode4(1612217), // Rule ID 3502 //
     /* 1612136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1612139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1612147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1612150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1612153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612182 */     // MIs[0] policy
     /* 1612182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1612195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612216 */     // GIR_Coverage, 3502,
     /* 1612216 */     GIR_EraseRootFromParent_Done,
     /* 1612217 */   // Label 22267: @1612217
     /* 1612217 */   GIM_Try, /*On fail goto*//*Label 22268*/ GIMT_Encode4(1612303), // Rule ID 3503 //
     /* 1612222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1612225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1612233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1612236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1612239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612268 */     // MIs[0] policy
     /* 1612268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612278 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1612281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612302 */     // GIR_Coverage, 3503,
     /* 1612302 */     GIR_EraseRootFromParent_Done,
     /* 1612303 */   // Label 22268: @1612303
     /* 1612303 */   GIM_Try, /*On fail goto*//*Label 22269*/ GIMT_Encode4(1612389), // Rule ID 3506 //
     /* 1612308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1612311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1612319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1612322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1612325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612354 */     // MIs[0] policy
     /* 1612354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1612367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612388 */     // GIR_Coverage, 3506,
     /* 1612388 */     GIR_EraseRootFromParent_Done,
     /* 1612389 */   // Label 22269: @1612389
     /* 1612389 */   GIM_Try, /*On fail goto*//*Label 22270*/ GIMT_Encode4(1612475), // Rule ID 3507 //
     /* 1612394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1612397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1612405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1612408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1612411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612440 */     // MIs[0] policy
     /* 1612440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612450 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1612453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612474 */     // GIR_Coverage, 3507,
     /* 1612474 */     GIR_EraseRootFromParent_Done,
     /* 1612475 */   // Label 22270: @1612475
     /* 1612475 */   GIM_Try, /*On fail goto*//*Label 22271*/ GIMT_Encode4(1612561), // Rule ID 3510 //
     /* 1612480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1612483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1612497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612526 */     // MIs[0] policy
     /* 1612526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1612539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612560 */     // GIR_Coverage, 3510,
     /* 1612560 */     GIR_EraseRootFromParent_Done,
     /* 1612561 */   // Label 22271: @1612561
     /* 1612561 */   GIM_Try, /*On fail goto*//*Label 22272*/ GIMT_Encode4(1612647), // Rule ID 3511 //
     /* 1612566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1612569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1612583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612612 */     // MIs[0] policy
     /* 1612612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612622 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1612625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612646 */     // GIR_Coverage, 3511,
     /* 1612646 */     GIR_EraseRootFromParent_Done,
     /* 1612647 */   // Label 22272: @1612647
     /* 1612647 */   GIM_Try, /*On fail goto*//*Label 22273*/ GIMT_Encode4(1612733), // Rule ID 3602 //
     /* 1612652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1612672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612698 */     // MIs[0] policy
     /* 1612698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612708 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1612711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612732 */     // GIR_Coverage, 3602,
     /* 1612732 */     GIR_EraseRootFromParent_Done,
     /* 1612733 */   // Label 22273: @1612733
     /* 1612733 */   GIM_Try, /*On fail goto*//*Label 22274*/ GIMT_Encode4(1612819), // Rule ID 3603 //
     /* 1612738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1612758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612784 */     // MIs[0] policy
     /* 1612784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612794 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1612797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612818 */     // GIR_Coverage, 3603,
     /* 1612818 */     GIR_EraseRootFromParent_Done,
     /* 1612819 */   // Label 22274: @1612819
     /* 1612819 */   GIM_Try, /*On fail goto*//*Label 22275*/ GIMT_Encode4(1612905), // Rule ID 3606 //
     /* 1612824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1612835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1612838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1612844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612870 */     // MIs[0] policy
     /* 1612870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612880 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1612883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612904 */     // GIR_Coverage, 3606,
     /* 1612904 */     GIR_EraseRootFromParent_Done,
     /* 1612905 */   // Label 22275: @1612905
     /* 1612905 */   GIM_Try, /*On fail goto*//*Label 22276*/ GIMT_Encode4(1612991), // Rule ID 3607 //
     /* 1612910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1612921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1612924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1612930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612956 */     // MIs[0] policy
     /* 1612956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612966 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1612969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612990 */     // GIR_Coverage, 3607,
     /* 1612990 */     GIR_EraseRootFromParent_Done,
     /* 1612991 */   // Label 22276: @1612991
     /* 1612991 */   GIM_Try, /*On fail goto*//*Label 22277*/ GIMT_Encode4(1613077), // Rule ID 3610 //
     /* 1612996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1613007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1613010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1613013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1613016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613042 */     // MIs[0] policy
     /* 1613042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1613055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613076 */     // GIR_Coverage, 3610,
     /* 1613076 */     GIR_EraseRootFromParent_Done,
     /* 1613077 */   // Label 22277: @1613077
     /* 1613077 */   GIM_Try, /*On fail goto*//*Label 22278*/ GIMT_Encode4(1613163), // Rule ID 3611 //
     /* 1613082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1613093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1613096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1613099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1613102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613128 */     // MIs[0] policy
     /* 1613128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613138 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1613141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613162 */     // GIR_Coverage, 3611,
     /* 1613162 */     GIR_EraseRootFromParent_Done,
     /* 1613163 */   // Label 22278: @1613163
     /* 1613163 */   GIM_Try, /*On fail goto*//*Label 22279*/ GIMT_Encode4(1613249), // Rule ID 3614 //
     /* 1613168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1613179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1613182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1613185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1613188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613214 */     // MIs[0] policy
     /* 1613214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1613227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613248 */     // GIR_Coverage, 3614,
     /* 1613248 */     GIR_EraseRootFromParent_Done,
     /* 1613249 */   // Label 22279: @1613249
     /* 1613249 */   GIM_Try, /*On fail goto*//*Label 22280*/ GIMT_Encode4(1613335), // Rule ID 3615 //
     /* 1613254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1613265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1613268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1613271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1613274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613300 */     // MIs[0] policy
     /* 1613300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613310 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1613313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613334 */     // GIR_Coverage, 3615,
     /* 1613334 */     GIR_EraseRootFromParent_Done,
     /* 1613335 */   // Label 22280: @1613335
     /* 1613335 */   GIM_Try, /*On fail goto*//*Label 22281*/ GIMT_Encode4(1613421), // Rule ID 3618 //
     /* 1613340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1613351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1613354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1613357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1613360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1613363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1613370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613386 */     // MIs[0] policy
     /* 1613386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1613399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613420 */     // GIR_Coverage, 3618,
     /* 1613420 */     GIR_EraseRootFromParent_Done,
     /* 1613421 */   // Label 22281: @1613421
     /* 1613421 */   GIM_Try, /*On fail goto*//*Label 22282*/ GIMT_Encode4(1613507), // Rule ID 3619 //
     /* 1613426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1613437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1613440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1613443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1613446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1613449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1613456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613472 */     // MIs[0] policy
     /* 1613472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613482 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1613485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613506 */     // GIR_Coverage, 3619,
     /* 1613506 */     GIR_EraseRootFromParent_Done,
     /* 1613507 */   // Label 22282: @1613507
     /* 1613507 */   GIM_Try, /*On fail goto*//*Label 22283*/ GIMT_Encode4(1613593), // Rule ID 3622 //
     /* 1613512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1613523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1613526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1613529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1613532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1613535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613558 */     // MIs[0] policy
     /* 1613558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1613571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613592 */     // GIR_Coverage, 3622,
     /* 1613592 */     GIR_EraseRootFromParent_Done,
     /* 1613593 */   // Label 22283: @1613593
     /* 1613593 */   GIM_Try, /*On fail goto*//*Label 22284*/ GIMT_Encode4(1613679), // Rule ID 3623 //
     /* 1613598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1613609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1613612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1613615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1613618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1613621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613644 */     // MIs[0] policy
     /* 1613644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613654 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1613657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613678 */     // GIR_Coverage, 3623,
     /* 1613678 */     GIR_EraseRootFromParent_Done,
     /* 1613679 */   // Label 22284: @1613679
     /* 1613679 */   GIM_Try, /*On fail goto*//*Label 22285*/ GIMT_Encode4(1613765), // Rule ID 3626 //
     /* 1613684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1613701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1613704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613730 */     // MIs[0] policy
     /* 1613730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613740 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1613743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613764 */     // GIR_Coverage, 3626,
     /* 1613764 */     GIR_EraseRootFromParent_Done,
     /* 1613765 */   // Label 22285: @1613765
     /* 1613765 */   GIM_Try, /*On fail goto*//*Label 22286*/ GIMT_Encode4(1613851), // Rule ID 3627 //
     /* 1613770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1613787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1613790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613816 */     // MIs[0] policy
     /* 1613816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613826 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1613829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613850 */     // GIR_Coverage, 3627,
     /* 1613850 */     GIR_EraseRootFromParent_Done,
     /* 1613851 */   // Label 22286: @1613851
     /* 1613851 */   GIM_Try, /*On fail goto*//*Label 22287*/ GIMT_Encode4(1613937), // Rule ID 3630 //
     /* 1613856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1613876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613902 */     // MIs[0] policy
     /* 1613902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613912 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1613915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613936 */     // GIR_Coverage, 3630,
     /* 1613936 */     GIR_EraseRootFromParent_Done,
     /* 1613937 */   // Label 22287: @1613937
     /* 1613937 */   GIM_Try, /*On fail goto*//*Label 22288*/ GIMT_Encode4(1614023), // Rule ID 3631 //
     /* 1613942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1613962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613988 */     // MIs[0] policy
     /* 1613988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613998 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1614001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614022 */     // GIR_Coverage, 3631,
     /* 1614022 */     GIR_EraseRootFromParent_Done,
     /* 1614023 */   // Label 22288: @1614023
     /* 1614023 */   GIM_Try, /*On fail goto*//*Label 22289*/ GIMT_Encode4(1614109), // Rule ID 3634 //
     /* 1614028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1614039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1614042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1614045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1614048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614074 */     // MIs[0] policy
     /* 1614074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1614087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614108 */     // GIR_Coverage, 3634,
     /* 1614108 */     GIR_EraseRootFromParent_Done,
     /* 1614109 */   // Label 22289: @1614109
     /* 1614109 */   GIM_Try, /*On fail goto*//*Label 22290*/ GIMT_Encode4(1614195), // Rule ID 3635 //
     /* 1614114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1614125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1614128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1614131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1614134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614160 */     // MIs[0] policy
     /* 1614160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614170 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1614173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614194 */     // GIR_Coverage, 3635,
     /* 1614194 */     GIR_EraseRootFromParent_Done,
     /* 1614195 */   // Label 22290: @1614195
     /* 1614195 */   GIM_Try, /*On fail goto*//*Label 22291*/ GIMT_Encode4(1614281), // Rule ID 3638 //
     /* 1614200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1614211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1614214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1614217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1614220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614246 */     // MIs[0] policy
     /* 1614246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614256 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1614259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614280 */     // GIR_Coverage, 3638,
     /* 1614280 */     GIR_EraseRootFromParent_Done,
     /* 1614281 */   // Label 22291: @1614281
     /* 1614281 */   GIM_Try, /*On fail goto*//*Label 22292*/ GIMT_Encode4(1614367), // Rule ID 3639 //
     /* 1614286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1614297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1614300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1614303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1614306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614332 */     // MIs[0] policy
     /* 1614332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614342 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1614345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614366 */     // GIR_Coverage, 3639,
     /* 1614366 */     GIR_EraseRootFromParent_Done,
     /* 1614367 */   // Label 22292: @1614367
     /* 1614367 */   GIM_Try, /*On fail goto*//*Label 22293*/ GIMT_Encode4(1614453), // Rule ID 3642 //
     /* 1614372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1614383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1614386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1614389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1614392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614418 */     // MIs[0] policy
     /* 1614418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614428 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1614431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614452 */     // GIR_Coverage, 3642,
     /* 1614452 */     GIR_EraseRootFromParent_Done,
     /* 1614453 */   // Label 22293: @1614453
     /* 1614453 */   GIM_Try, /*On fail goto*//*Label 22294*/ GIMT_Encode4(1614539), // Rule ID 3643 //
     /* 1614458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1614469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1614472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1614475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1614478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614504 */     // MIs[0] policy
     /* 1614504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614514 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1614517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614538 */     // GIR_Coverage, 3643,
     /* 1614538 */     GIR_EraseRootFromParent_Done,
     /* 1614539 */   // Label 22294: @1614539
     /* 1614539 */   GIM_Try, /*On fail goto*//*Label 22295*/ GIMT_Encode4(1614625), // Rule ID 3646 //
     /* 1614544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1614555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1614558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1614561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1614564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614590 */     // MIs[0] policy
     /* 1614590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1614603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614624 */     // GIR_Coverage, 3646,
     /* 1614624 */     GIR_EraseRootFromParent_Done,
     /* 1614625 */   // Label 22295: @1614625
     /* 1614625 */   GIM_Try, /*On fail goto*//*Label 22296*/ GIMT_Encode4(1614711), // Rule ID 3647 //
     /* 1614630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1614641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1614644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1614647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1614650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614676 */     // MIs[0] policy
     /* 1614676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614686 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1614689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614710 */     // GIR_Coverage, 3647,
     /* 1614710 */     GIR_EraseRootFromParent_Done,
     /* 1614711 */   // Label 22296: @1614711
     /* 1614711 */   GIM_Try, /*On fail goto*//*Label 22297*/ GIMT_Encode4(1614797), // Rule ID 3650 //
     /* 1614716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1614727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1614730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1614733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1614736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614762 */     // MIs[0] policy
     /* 1614762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614772 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1614775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614796 */     // GIR_Coverage, 3650,
     /* 1614796 */     GIR_EraseRootFromParent_Done,
     /* 1614797 */   // Label 22297: @1614797
     /* 1614797 */   GIM_Try, /*On fail goto*//*Label 22298*/ GIMT_Encode4(1614883), // Rule ID 3651 //
     /* 1614802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1614813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1614816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1614819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1614822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614848 */     // MIs[0] policy
     /* 1614848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614858 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1614861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614882 */     // GIR_Coverage, 3651,
     /* 1614882 */     GIR_EraseRootFromParent_Done,
     /* 1614883 */   // Label 22298: @1614883
     /* 1614883 */   GIM_Try, /*On fail goto*//*Label 22299*/ GIMT_Encode4(1614969), // Rule ID 3654 //
     /* 1614888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1614899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1614902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1614905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1614908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614934 */     // MIs[0] policy
     /* 1614934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1614947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614968 */     // GIR_Coverage, 3654,
     /* 1614968 */     GIR_EraseRootFromParent_Done,
     /* 1614969 */   // Label 22299: @1614969
     /* 1614969 */   GIM_Try, /*On fail goto*//*Label 22300*/ GIMT_Encode4(1615055), // Rule ID 3655 //
     /* 1614974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1614985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1614988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1614991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1614994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615020 */     // MIs[0] policy
     /* 1615020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615030 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1615033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615054 */     // GIR_Coverage, 3655,
     /* 1615054 */     GIR_EraseRootFromParent_Done,
     /* 1615055 */   // Label 22300: @1615055
     /* 1615055 */   GIM_Try, /*On fail goto*//*Label 22301*/ GIMT_Encode4(1615141), // Rule ID 3658 //
     /* 1615060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1615063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1615071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1615074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1615077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1615080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615106 */     // MIs[0] policy
     /* 1615106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1615119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615140 */     // GIR_Coverage, 3658,
     /* 1615140 */     GIR_EraseRootFromParent_Done,
     /* 1615141 */   // Label 22301: @1615141
     /* 1615141 */   GIM_Try, /*On fail goto*//*Label 22302*/ GIMT_Encode4(1615227), // Rule ID 3659 //
     /* 1615146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1615149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1615157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1615160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1615163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1615166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615192 */     // MIs[0] policy
     /* 1615192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615202 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1615205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615226 */     // GIR_Coverage, 3659,
     /* 1615226 */     GIR_EraseRootFromParent_Done,
     /* 1615227 */   // Label 22302: @1615227
     /* 1615227 */   GIM_Try, /*On fail goto*//*Label 22303*/ GIMT_Encode4(1615313), // Rule ID 3662 //
     /* 1615232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1615243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1615246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1615249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615278 */     // MIs[0] policy
     /* 1615278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615288 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1615291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615312 */     // GIR_Coverage, 3662,
     /* 1615312 */     GIR_EraseRootFromParent_Done,
     /* 1615313 */   // Label 22303: @1615313
     /* 1615313 */   GIM_Try, /*On fail goto*//*Label 22304*/ GIMT_Encode4(1615399), // Rule ID 3663 //
     /* 1615318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1615329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1615332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1615335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615364 */     // MIs[0] policy
     /* 1615364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615374 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1615377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615398 */     // GIR_Coverage, 3663,
     /* 1615398 */     GIR_EraseRootFromParent_Done,
     /* 1615399 */   // Label 22304: @1615399
     /* 1615399 */   GIM_Try, /*On fail goto*//*Label 22305*/ GIMT_Encode4(1615485), // Rule ID 3666 //
     /* 1615404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1615415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1615418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1615421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615450 */     // MIs[0] policy
     /* 1615450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615460 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1615463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615484 */     // GIR_Coverage, 3666,
     /* 1615484 */     GIR_EraseRootFromParent_Done,
     /* 1615485 */   // Label 22305: @1615485
     /* 1615485 */   GIM_Try, /*On fail goto*//*Label 22306*/ GIMT_Encode4(1615571), // Rule ID 3667 //
     /* 1615490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1615501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1615504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1615507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615536 */     // MIs[0] policy
     /* 1615536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615546 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1615549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615570 */     // GIR_Coverage, 3667,
     /* 1615570 */     GIR_EraseRootFromParent_Done,
     /* 1615571 */   // Label 22306: @1615571
     /* 1615571 */   GIM_Try, /*On fail goto*//*Label 22307*/ GIMT_Encode4(1615657), // Rule ID 3670 //
     /* 1615576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1615587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1615590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1615593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615622 */     // MIs[0] policy
     /* 1615622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1615635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615656 */     // GIR_Coverage, 3670,
     /* 1615656 */     GIR_EraseRootFromParent_Done,
     /* 1615657 */   // Label 22307: @1615657
     /* 1615657 */   GIM_Try, /*On fail goto*//*Label 22308*/ GIMT_Encode4(1615743), // Rule ID 3671 //
     /* 1615662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1615673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1615676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1615679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615708 */     // MIs[0] policy
     /* 1615708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615718 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1615721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615742 */     // GIR_Coverage, 3671,
     /* 1615742 */     GIR_EraseRootFromParent_Done,
     /* 1615743 */   // Label 22308: @1615743
     /* 1615743 */   GIM_Try, /*On fail goto*//*Label 22309*/ GIMT_Encode4(1615829), // Rule ID 3674 //
     /* 1615748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1615759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1615762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1615765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615794 */     // MIs[0] policy
     /* 1615794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615804 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1615807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615828 */     // GIR_Coverage, 3674,
     /* 1615828 */     GIR_EraseRootFromParent_Done,
     /* 1615829 */   // Label 22309: @1615829
     /* 1615829 */   GIM_Try, /*On fail goto*//*Label 22310*/ GIMT_Encode4(1615915), // Rule ID 3675 //
     /* 1615834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1615845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1615848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1615851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615880 */     // MIs[0] policy
     /* 1615880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615890 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1615893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615914 */     // GIR_Coverage, 3675,
     /* 1615914 */     GIR_EraseRootFromParent_Done,
     /* 1615915 */   // Label 22310: @1615915
     /* 1615915 */   GIM_Try, /*On fail goto*//*Label 22311*/ GIMT_Encode4(1616001), // Rule ID 3678 //
     /* 1615920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1615931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1615934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1615937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615966 */     // MIs[0] policy
     /* 1615966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615976 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1615979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616000 */     // GIR_Coverage, 3678,
     /* 1616000 */     GIR_EraseRootFromParent_Done,
     /* 1616001 */   // Label 22311: @1616001
     /* 1616001 */   GIM_Try, /*On fail goto*//*Label 22312*/ GIMT_Encode4(1616087), // Rule ID 3679 //
     /* 1616006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1616017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1616020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1616023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616052 */     // MIs[0] policy
     /* 1616052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616062 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1616065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616086 */     // GIR_Coverage, 3679,
     /* 1616086 */     GIR_EraseRootFromParent_Done,
     /* 1616087 */   // Label 22312: @1616087
     /* 1616087 */   GIM_Try, /*On fail goto*//*Label 22313*/ GIMT_Encode4(1616173), // Rule ID 3682 //
     /* 1616092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1616103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1616106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1616109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1616115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616138 */     // MIs[0] policy
     /* 1616138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616148 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1616151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616172 */     // GIR_Coverage, 3682,
     /* 1616172 */     GIR_EraseRootFromParent_Done,
     /* 1616173 */   // Label 22313: @1616173
     /* 1616173 */   GIM_Try, /*On fail goto*//*Label 22314*/ GIMT_Encode4(1616259), // Rule ID 3683 //
     /* 1616178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1616189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1616192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1616195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1616201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616224 */     // MIs[0] policy
     /* 1616224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616234 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1616237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616258 */     // GIR_Coverage, 3683,
     /* 1616258 */     GIR_EraseRootFromParent_Done,
     /* 1616259 */   // Label 22314: @1616259
     /* 1616259 */   GIM_Try, /*On fail goto*//*Label 22315*/ GIMT_Encode4(1616345), // Rule ID 3686 //
     /* 1616264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1616275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1616278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1616281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616310 */     // MIs[0] policy
     /* 1616310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616320 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1616323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616344 */     // GIR_Coverage, 3686,
     /* 1616344 */     GIR_EraseRootFromParent_Done,
     /* 1616345 */   // Label 22315: @1616345
     /* 1616345 */   GIM_Try, /*On fail goto*//*Label 22316*/ GIMT_Encode4(1616431), // Rule ID 3687 //
     /* 1616350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1616361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1616364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1616367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616396 */     // MIs[0] policy
     /* 1616396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616406 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1616409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616430 */     // GIR_Coverage, 3687,
     /* 1616430 */     GIR_EraseRootFromParent_Done,
     /* 1616431 */   // Label 22316: @1616431
     /* 1616431 */   GIM_Try, /*On fail goto*//*Label 22317*/ GIMT_Encode4(1616517), // Rule ID 3690 //
     /* 1616436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1616447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1616450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1616453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616482 */     // MIs[0] policy
     /* 1616482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1616495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616516 */     // GIR_Coverage, 3690,
     /* 1616516 */     GIR_EraseRootFromParent_Done,
     /* 1616517 */   // Label 22317: @1616517
     /* 1616517 */   GIM_Try, /*On fail goto*//*Label 22318*/ GIMT_Encode4(1616603), // Rule ID 3691 //
     /* 1616522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1616533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1616536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1616539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616568 */     // MIs[0] policy
     /* 1616568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616578 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1616581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616602 */     // GIR_Coverage, 3691,
     /* 1616602 */     GIR_EraseRootFromParent_Done,
     /* 1616603 */   // Label 22318: @1616603
     /* 1616603 */   GIM_Try, /*On fail goto*//*Label 22319*/ GIMT_Encode4(1616689), // Rule ID 3694 //
     /* 1616608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1616619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1616622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1616625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616654 */     // MIs[0] policy
     /* 1616654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1616667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616688 */     // GIR_Coverage, 3694,
     /* 1616688 */     GIR_EraseRootFromParent_Done,
     /* 1616689 */   // Label 22319: @1616689
     /* 1616689 */   GIM_Try, /*On fail goto*//*Label 22320*/ GIMT_Encode4(1616775), // Rule ID 3695 //
     /* 1616694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1616705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1616708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1616711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616740 */     // MIs[0] policy
     /* 1616740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616750 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1616753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616774 */     // GIR_Coverage, 3695,
     /* 1616774 */     GIR_EraseRootFromParent_Done,
     /* 1616775 */   // Label 22320: @1616775
     /* 1616775 */   GIM_Try, /*On fail goto*//*Label 22321*/ GIMT_Encode4(1616861), // Rule ID 3698 //
     /* 1616780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1616791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1616794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1616797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616826 */     // MIs[0] policy
     /* 1616826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1616839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616860 */     // GIR_Coverage, 3698,
     /* 1616860 */     GIR_EraseRootFromParent_Done,
     /* 1616861 */   // Label 22321: @1616861
     /* 1616861 */   GIM_Try, /*On fail goto*//*Label 22322*/ GIMT_Encode4(1616947), // Rule ID 3699 //
     /* 1616866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1616877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1616880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1616883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616912 */     // MIs[0] policy
     /* 1616912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616922 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1616925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616946 */     // GIR_Coverage, 3699,
     /* 1616946 */     GIR_EraseRootFromParent_Done,
     /* 1616947 */   // Label 22322: @1616947
     /* 1616947 */   GIM_Try, /*On fail goto*//*Label 22323*/ GIMT_Encode4(1617033), // Rule ID 3702 //
     /* 1616952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1616963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1616966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1616969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616998 */     // MIs[0] policy
     /* 1616998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617008 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1617011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617032 */     // GIR_Coverage, 3702,
     /* 1617032 */     GIR_EraseRootFromParent_Done,
     /* 1617033 */   // Label 22323: @1617033
     /* 1617033 */   GIM_Try, /*On fail goto*//*Label 22324*/ GIMT_Encode4(1617119), // Rule ID 3703 //
     /* 1617038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1617049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1617052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1617055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1617061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617084 */     // MIs[0] policy
     /* 1617084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617094 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1617097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617118 */     // GIR_Coverage, 3703,
     /* 1617118 */     GIR_EraseRootFromParent_Done,
     /* 1617119 */   // Label 22324: @1617119
     /* 1617119 */   GIM_Try, /*On fail goto*//*Label 22325*/ GIMT_Encode4(1617205), // Rule ID 3706 //
     /* 1617124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1617135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1617138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1617141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617170 */     // MIs[0] policy
     /* 1617170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617180 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1617183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617204 */     // GIR_Coverage, 3706,
     /* 1617204 */     GIR_EraseRootFromParent_Done,
     /* 1617205 */   // Label 22325: @1617205
     /* 1617205 */   GIM_Try, /*On fail goto*//*Label 22326*/ GIMT_Encode4(1617291), // Rule ID 3707 //
     /* 1617210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1617221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1617224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1617227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617256 */     // MIs[0] policy
     /* 1617256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617266 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1617269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617290 */     // GIR_Coverage, 3707,
     /* 1617290 */     GIR_EraseRootFromParent_Done,
     /* 1617291 */   // Label 22326: @1617291
     /* 1617291 */   GIM_Try, /*On fail goto*//*Label 22327*/ GIMT_Encode4(1617377), // Rule ID 3710 //
     /* 1617296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1617307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1617310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1617313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617342 */     // MIs[0] policy
     /* 1617342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617352 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1617355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617376 */     // GIR_Coverage, 3710,
     /* 1617376 */     GIR_EraseRootFromParent_Done,
     /* 1617377 */   // Label 22327: @1617377
     /* 1617377 */   GIM_Try, /*On fail goto*//*Label 22328*/ GIMT_Encode4(1617463), // Rule ID 3711 //
     /* 1617382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1617393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1617396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1617399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617428 */     // MIs[0] policy
     /* 1617428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617438 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1617441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617462 */     // GIR_Coverage, 3711,
     /* 1617462 */     GIR_EraseRootFromParent_Done,
     /* 1617463 */   // Label 22328: @1617463
     /* 1617463 */   GIM_Try, /*On fail goto*//*Label 22329*/ GIMT_Encode4(1617549), // Rule ID 3714 //
     /* 1617468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1617479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1617482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1617485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617514 */     // MIs[0] policy
     /* 1617514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617524 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1617527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617548 */     // GIR_Coverage, 3714,
     /* 1617548 */     GIR_EraseRootFromParent_Done,
     /* 1617549 */   // Label 22329: @1617549
     /* 1617549 */   GIM_Try, /*On fail goto*//*Label 22330*/ GIMT_Encode4(1617635), // Rule ID 3715 //
     /* 1617554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1617565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1617568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1617571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617600 */     // MIs[0] policy
     /* 1617600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617610 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1617613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617634 */     // GIR_Coverage, 3715,
     /* 1617634 */     GIR_EraseRootFromParent_Done,
     /* 1617635 */   // Label 22330: @1617635
     /* 1617635 */   GIM_Try, /*On fail goto*//*Label 22331*/ GIMT_Encode4(1617721), // Rule ID 3718 //
     /* 1617640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1617651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1617654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1617657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617686 */     // MIs[0] policy
     /* 1617686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617696 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1617699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617720 */     // GIR_Coverage, 3718,
     /* 1617720 */     GIR_EraseRootFromParent_Done,
     /* 1617721 */   // Label 22331: @1617721
     /* 1617721 */   GIM_Try, /*On fail goto*//*Label 22332*/ GIMT_Encode4(1617807), // Rule ID 3719 //
     /* 1617726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1617737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1617740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1617743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617772 */     // MIs[0] policy
     /* 1617772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617782 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1617785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617806 */     // GIR_Coverage, 3719,
     /* 1617806 */     GIR_EraseRootFromParent_Done,
     /* 1617807 */   // Label 22332: @1617807
     /* 1617807 */   GIM_Try, /*On fail goto*//*Label 22333*/ GIMT_Encode4(1617893), // Rule ID 3722 //
     /* 1617812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1617823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1617826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1617829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1617832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617858 */     // MIs[0] policy
     /* 1617858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1617871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617892 */     // GIR_Coverage, 3722,
     /* 1617892 */     GIR_EraseRootFromParent_Done,
     /* 1617893 */   // Label 22333: @1617893
     /* 1617893 */   GIM_Try, /*On fail goto*//*Label 22334*/ GIMT_Encode4(1617979), // Rule ID 3723 //
     /* 1617898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1617909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1617912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1617915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1617918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617944 */     // MIs[0] policy
     /* 1617944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617954 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1617957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617978 */     // GIR_Coverage, 3723,
     /* 1617978 */     GIR_EraseRootFromParent_Done,
     /* 1617979 */   // Label 22334: @1617979
     /* 1617979 */   GIM_Try, /*On fail goto*//*Label 22335*/ GIMT_Encode4(1618065), // Rule ID 3726 //
     /* 1617984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1617995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1617998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1618001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1618004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618030 */     // MIs[0] policy
     /* 1618030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618040 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1618043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618064 */     // GIR_Coverage, 3726,
     /* 1618064 */     GIR_EraseRootFromParent_Done,
     /* 1618065 */   // Label 22335: @1618065
     /* 1618065 */   GIM_Try, /*On fail goto*//*Label 22336*/ GIMT_Encode4(1618151), // Rule ID 3727 //
     /* 1618070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1618081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1618084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1618087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1618090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618116 */     // MIs[0] policy
     /* 1618116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1618129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618150 */     // GIR_Coverage, 3727,
     /* 1618150 */     GIR_EraseRootFromParent_Done,
     /* 1618151 */   // Label 22336: @1618151
     /* 1618151 */   GIM_Try, /*On fail goto*//*Label 22337*/ GIMT_Encode4(1618237), // Rule ID 3730 //
     /* 1618156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1618167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1618170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1618173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1618176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618202 */     // MIs[0] policy
     /* 1618202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618212 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1618215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618236 */     // GIR_Coverage, 3730,
     /* 1618236 */     GIR_EraseRootFromParent_Done,
     /* 1618237 */   // Label 22337: @1618237
     /* 1618237 */   GIM_Try, /*On fail goto*//*Label 22338*/ GIMT_Encode4(1618323), // Rule ID 3731 //
     /* 1618242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1618253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1618256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1618259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1618262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618288 */     // MIs[0] policy
     /* 1618288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618298 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1618301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618322 */     // GIR_Coverage, 3731,
     /* 1618322 */     GIR_EraseRootFromParent_Done,
     /* 1618323 */   // Label 22338: @1618323
     /* 1618323 */   GIM_Try, /*On fail goto*//*Label 22339*/ GIMT_Encode4(1618409), // Rule ID 3734 //
     /* 1618328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1618339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1618342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1618345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1618348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618374 */     // MIs[0] policy
     /* 1618374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1618387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618408 */     // GIR_Coverage, 3734,
     /* 1618408 */     GIR_EraseRootFromParent_Done,
     /* 1618409 */   // Label 22339: @1618409
     /* 1618409 */   GIM_Try, /*On fail goto*//*Label 22340*/ GIMT_Encode4(1618495), // Rule ID 3735 //
     /* 1618414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1618425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1618428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1618431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1618434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618460 */     // MIs[0] policy
     /* 1618460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1618473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618494 */     // GIR_Coverage, 3735,
     /* 1618494 */     GIR_EraseRootFromParent_Done,
     /* 1618495 */   // Label 22340: @1618495
     /* 1618495 */   GIM_Try, /*On fail goto*//*Label 22341*/ GIMT_Encode4(1618581), // Rule ID 3738 //
     /* 1618500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1618511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1618514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1618517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1618520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1618523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618546 */     // MIs[0] policy
     /* 1618546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1618559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618580 */     // GIR_Coverage, 3738,
     /* 1618580 */     GIR_EraseRootFromParent_Done,
     /* 1618581 */   // Label 22341: @1618581
     /* 1618581 */   GIM_Try, /*On fail goto*//*Label 22342*/ GIMT_Encode4(1618667), // Rule ID 3739 //
     /* 1618586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1618597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1618600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1618603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1618606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1618609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618632 */     // MIs[0] policy
     /* 1618632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618642 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1618645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618666 */     // GIR_Coverage, 3739,
     /* 1618666 */     GIR_EraseRootFromParent_Done,
     /* 1618667 */   // Label 22342: @1618667
     /* 1618667 */   GIM_Try, /*On fail goto*//*Label 22343*/ GIMT_Encode4(1618753), // Rule ID 3742 //
     /* 1618672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1618683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1618686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1618689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1618692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618718 */     // MIs[0] policy
     /* 1618718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618728 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1618731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618752 */     // GIR_Coverage, 3742,
     /* 1618752 */     GIR_EraseRootFromParent_Done,
     /* 1618753 */   // Label 22343: @1618753
     /* 1618753 */   GIM_Try, /*On fail goto*//*Label 22344*/ GIMT_Encode4(1618839), // Rule ID 3743 //
     /* 1618758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1618769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1618772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1618775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1618778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618804 */     // MIs[0] policy
     /* 1618804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618814 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1618817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618838 */     // GIR_Coverage, 3743,
     /* 1618838 */     GIR_EraseRootFromParent_Done,
     /* 1618839 */   // Label 22344: @1618839
     /* 1618839 */   GIM_Try, /*On fail goto*//*Label 22345*/ GIMT_Encode4(1618925), // Rule ID 3746 //
     /* 1618844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1618855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1618858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1618861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1618864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618890 */     // MIs[0] policy
     /* 1618890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618900 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1618903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618924 */     // GIR_Coverage, 3746,
     /* 1618924 */     GIR_EraseRootFromParent_Done,
     /* 1618925 */   // Label 22345: @1618925
     /* 1618925 */   GIM_Try, /*On fail goto*//*Label 22346*/ GIMT_Encode4(1619011), // Rule ID 3747 //
     /* 1618930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1618941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1618944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1618947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1618950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618976 */     // MIs[0] policy
     /* 1618976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618986 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1618989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619010 */     // GIR_Coverage, 3747,
     /* 1619010 */     GIR_EraseRootFromParent_Done,
     /* 1619011 */   // Label 22346: @1619011
     /* 1619011 */   GIM_Try, /*On fail goto*//*Label 22347*/ GIMT_Encode4(1619097), // Rule ID 3750 //
     /* 1619016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1619027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1619030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1619033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1619036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619062 */     // MIs[0] policy
     /* 1619062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619072 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1619075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619096 */     // GIR_Coverage, 3750,
     /* 1619096 */     GIR_EraseRootFromParent_Done,
     /* 1619097 */   // Label 22347: @1619097
     /* 1619097 */   GIM_Try, /*On fail goto*//*Label 22348*/ GIMT_Encode4(1619183), // Rule ID 3751 //
     /* 1619102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1619113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1619116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1619119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1619122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619148 */     // MIs[0] policy
     /* 1619148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1619161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619182 */     // GIR_Coverage, 3751,
     /* 1619182 */     GIR_EraseRootFromParent_Done,
     /* 1619183 */   // Label 22348: @1619183
     /* 1619183 */   GIM_Try, /*On fail goto*//*Label 22349*/ GIMT_Encode4(1619269), // Rule ID 3754 //
     /* 1619188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1619199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1619202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1619205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1619208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619234 */     // MIs[0] policy
     /* 1619234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1619247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619268 */     // GIR_Coverage, 3754,
     /* 1619268 */     GIR_EraseRootFromParent_Done,
     /* 1619269 */   // Label 22349: @1619269
     /* 1619269 */   GIM_Try, /*On fail goto*//*Label 22350*/ GIMT_Encode4(1619355), // Rule ID 3755 //
     /* 1619274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1619285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1619288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1619291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1619294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619320 */     // MIs[0] policy
     /* 1619320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1619333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619354 */     // GIR_Coverage, 3755,
     /* 1619354 */     GIR_EraseRootFromParent_Done,
     /* 1619355 */   // Label 22350: @1619355
     /* 1619355 */   GIM_Try, /*On fail goto*//*Label 22351*/ GIMT_Encode4(1619441), // Rule ID 3758 //
     /* 1619360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1619371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1619374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1619377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1619380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619406 */     // MIs[0] policy
     /* 1619406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1619419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619440 */     // GIR_Coverage, 3758,
     /* 1619440 */     GIR_EraseRootFromParent_Done,
     /* 1619441 */   // Label 22351: @1619441
     /* 1619441 */   GIM_Try, /*On fail goto*//*Label 22352*/ GIMT_Encode4(1619527), // Rule ID 3759 //
     /* 1619446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1619457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1619460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1619463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1619466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619492 */     // MIs[0] policy
     /* 1619492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1619505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619526 */     // GIR_Coverage, 3759,
     /* 1619526 */     GIR_EraseRootFromParent_Done,
     /* 1619527 */   // Label 22352: @1619527
     /* 1619527 */   GIM_Try, /*On fail goto*//*Label 22353*/ GIMT_Encode4(1619613), // Rule ID 3762 //
     /* 1619532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1619543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1619546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1619549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1619552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619578 */     // MIs[0] policy
     /* 1619578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619588 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1619591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619612 */     // GIR_Coverage, 3762,
     /* 1619612 */     GIR_EraseRootFromParent_Done,
     /* 1619613 */   // Label 22353: @1619613
     /* 1619613 */   GIM_Try, /*On fail goto*//*Label 22354*/ GIMT_Encode4(1619699), // Rule ID 3763 //
     /* 1619618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1619629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1619632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1619635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1619638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619664 */     // MIs[0] policy
     /* 1619664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619674 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1619677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619698 */     // GIR_Coverage, 3763,
     /* 1619698 */     GIR_EraseRootFromParent_Done,
     /* 1619699 */   // Label 22354: @1619699
     /* 1619699 */   GIM_Try, /*On fail goto*//*Label 22355*/ GIMT_Encode4(1619785), // Rule ID 3766 //
     /* 1619704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1619715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1619718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1619721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1619724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619750 */     // MIs[0] policy
     /* 1619750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1619763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619784 */     // GIR_Coverage, 3766,
     /* 1619784 */     GIR_EraseRootFromParent_Done,
     /* 1619785 */   // Label 22355: @1619785
     /* 1619785 */   GIM_Try, /*On fail goto*//*Label 22356*/ GIMT_Encode4(1619871), // Rule ID 3767 //
     /* 1619790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1619801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1619804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1619807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1619810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619836 */     // MIs[0] policy
     /* 1619836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619846 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1619849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619870 */     // GIR_Coverage, 3767,
     /* 1619870 */     GIR_EraseRootFromParent_Done,
     /* 1619871 */   // Label 22356: @1619871
     /* 1619871 */   GIM_Try, /*On fail goto*//*Label 22357*/ GIMT_Encode4(1619957), // Rule ID 3770 //
     /* 1619876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1619887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1619890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1619893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1619896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619922 */     // MIs[0] policy
     /* 1619922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619932 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1619935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619956 */     // GIR_Coverage, 3770,
     /* 1619956 */     GIR_EraseRootFromParent_Done,
     /* 1619957 */   // Label 22357: @1619957
     /* 1619957 */   GIM_Try, /*On fail goto*//*Label 22358*/ GIMT_Encode4(1620043), // Rule ID 3771 //
     /* 1619962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1619973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1619976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1619979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1619982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620008 */     // MIs[0] policy
     /* 1620008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620018 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1620021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620042 */     // GIR_Coverage, 3771,
     /* 1620042 */     GIR_EraseRootFromParent_Done,
     /* 1620043 */   // Label 22358: @1620043
     /* 1620043 */   GIM_Try, /*On fail goto*//*Label 22359*/ GIMT_Encode4(1620129), // Rule ID 3774 //
     /* 1620048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1620051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1620059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1620062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1620065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1620068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620094 */     // MIs[0] policy
     /* 1620094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620104 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1620107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620128 */     // GIR_Coverage, 3774,
     /* 1620128 */     GIR_EraseRootFromParent_Done,
     /* 1620129 */   // Label 22359: @1620129
     /* 1620129 */   GIM_Try, /*On fail goto*//*Label 22360*/ GIMT_Encode4(1620215), // Rule ID 3775 //
     /* 1620134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1620145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1620148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1620151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1620154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620180 */     // MIs[0] policy
     /* 1620180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620190 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1620193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620214 */     // GIR_Coverage, 3775,
     /* 1620214 */     GIR_EraseRootFromParent_Done,
     /* 1620215 */   // Label 22360: @1620215
     /* 1620215 */   GIM_Try, /*On fail goto*//*Label 22361*/ GIMT_Encode4(1620301), // Rule ID 3778 //
     /* 1620220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1620223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1620231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1620234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1620237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1620240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620266 */     // MIs[0] policy
     /* 1620266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620276 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1620279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620300 */     // GIR_Coverage, 3778,
     /* 1620300 */     GIR_EraseRootFromParent_Done,
     /* 1620301 */   // Label 22361: @1620301
     /* 1620301 */   GIM_Try, /*On fail goto*//*Label 22362*/ GIMT_Encode4(1620387), // Rule ID 3779 //
     /* 1620306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1620317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1620320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1620323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1620326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620352 */     // MIs[0] policy
     /* 1620352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620362 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1620365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620386 */     // GIR_Coverage, 3779,
     /* 1620386 */     GIR_EraseRootFromParent_Done,
     /* 1620387 */   // Label 22362: @1620387
     /* 1620387 */   GIM_Try, /*On fail goto*//*Label 22363*/ GIMT_Encode4(1620473), // Rule ID 3782 //
     /* 1620392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1620403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1620406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1620409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620438 */     // MIs[0] policy
     /* 1620438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620448 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1620451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620472 */     // GIR_Coverage, 3782,
     /* 1620472 */     GIR_EraseRootFromParent_Done,
     /* 1620473 */   // Label 22363: @1620473
     /* 1620473 */   GIM_Try, /*On fail goto*//*Label 22364*/ GIMT_Encode4(1620559), // Rule ID 3783 //
     /* 1620478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1620489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1620492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1620495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620524 */     // MIs[0] policy
     /* 1620524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1620537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620558 */     // GIR_Coverage, 3783,
     /* 1620558 */     GIR_EraseRootFromParent_Done,
     /* 1620559 */   // Label 22364: @1620559
     /* 1620559 */   GIM_Try, /*On fail goto*//*Label 22365*/ GIMT_Encode4(1620645), // Rule ID 3786 //
     /* 1620564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1620575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1620578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1620581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620610 */     // MIs[0] policy
     /* 1620610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620620 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1620623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620644 */     // GIR_Coverage, 3786,
     /* 1620644 */     GIR_EraseRootFromParent_Done,
     /* 1620645 */   // Label 22365: @1620645
     /* 1620645 */   GIM_Try, /*On fail goto*//*Label 22366*/ GIMT_Encode4(1620731), // Rule ID 3787 //
     /* 1620650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1620661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1620664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1620667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620696 */     // MIs[0] policy
     /* 1620696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1620709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620730 */     // GIR_Coverage, 3787,
     /* 1620730 */     GIR_EraseRootFromParent_Done,
     /* 1620731 */   // Label 22366: @1620731
     /* 1620731 */   GIM_Try, /*On fail goto*//*Label 22367*/ GIMT_Encode4(1620817), // Rule ID 3790 //
     /* 1620736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1620747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1620750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1620753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620782 */     // MIs[0] policy
     /* 1620782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620792 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1620795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620816 */     // GIR_Coverage, 3790,
     /* 1620816 */     GIR_EraseRootFromParent_Done,
     /* 1620817 */   // Label 22367: @1620817
     /* 1620817 */   GIM_Try, /*On fail goto*//*Label 22368*/ GIMT_Encode4(1620903), // Rule ID 3791 //
     /* 1620822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1620833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1620836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1620839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620868 */     // MIs[0] policy
     /* 1620868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620878 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1620881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620902 */     // GIR_Coverage, 3791,
     /* 1620902 */     GIR_EraseRootFromParent_Done,
     /* 1620903 */   // Label 22368: @1620903
     /* 1620903 */   GIM_Try, /*On fail goto*//*Label 22369*/ GIMT_Encode4(1620989), // Rule ID 3794 //
     /* 1620908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1620919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1620922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1620925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620954 */     // MIs[0] policy
     /* 1620954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1620967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620988 */     // GIR_Coverage, 3794,
     /* 1620988 */     GIR_EraseRootFromParent_Done,
     /* 1620989 */   // Label 22369: @1620989
     /* 1620989 */   GIM_Try, /*On fail goto*//*Label 22370*/ GIMT_Encode4(1621075), // Rule ID 3795 //
     /* 1620994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1621005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1621008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1621011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621040 */     // MIs[0] policy
     /* 1621040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621050 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1621053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621074 */     // GIR_Coverage, 3795,
     /* 1621074 */     GIR_EraseRootFromParent_Done,
     /* 1621075 */   // Label 22370: @1621075
     /* 1621075 */   GIM_Try, /*On fail goto*//*Label 22371*/ GIMT_Encode4(1621161), // Rule ID 3798 //
     /* 1621080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1621091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1621094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1621097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621126 */     // MIs[0] policy
     /* 1621126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1621139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621160 */     // GIR_Coverage, 3798,
     /* 1621160 */     GIR_EraseRootFromParent_Done,
     /* 1621161 */   // Label 22371: @1621161
     /* 1621161 */   GIM_Try, /*On fail goto*//*Label 22372*/ GIMT_Encode4(1621247), // Rule ID 3799 //
     /* 1621166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1621177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1621180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1621183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621212 */     // MIs[0] policy
     /* 1621212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621222 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1621225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621246 */     // GIR_Coverage, 3799,
     /* 1621246 */     GIR_EraseRootFromParent_Done,
     /* 1621247 */   // Label 22372: @1621247
     /* 1621247 */   GIM_Try, /*On fail goto*//*Label 22373*/ GIMT_Encode4(1621333), // Rule ID 3802 //
     /* 1621252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1621263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1621266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1621269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1621275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621298 */     // MIs[0] policy
     /* 1621298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621308 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1621311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621332 */     // GIR_Coverage, 3802,
     /* 1621332 */     GIR_EraseRootFromParent_Done,
     /* 1621333 */   // Label 22373: @1621333
     /* 1621333 */   GIM_Try, /*On fail goto*//*Label 22374*/ GIMT_Encode4(1621419), // Rule ID 3803 //
     /* 1621338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1621349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1621352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1621355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1621361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621384 */     // MIs[0] policy
     /* 1621384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621394 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1621397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621418 */     // GIR_Coverage, 3803,
     /* 1621418 */     GIR_EraseRootFromParent_Done,
     /* 1621419 */   // Label 22374: @1621419
     /* 1621419 */   GIM_Try, /*On fail goto*//*Label 22375*/ GIMT_Encode4(1621505), // Rule ID 3806 //
     /* 1621424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1621435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1621438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1621441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621470 */     // MIs[0] policy
     /* 1621470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621480 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1621483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621504 */     // GIR_Coverage, 3806,
     /* 1621504 */     GIR_EraseRootFromParent_Done,
     /* 1621505 */   // Label 22375: @1621505
     /* 1621505 */   GIM_Try, /*On fail goto*//*Label 22376*/ GIMT_Encode4(1621591), // Rule ID 3807 //
     /* 1621510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1621521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1621524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1621527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621556 */     // MIs[0] policy
     /* 1621556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621566 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1621569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621590 */     // GIR_Coverage, 3807,
     /* 1621590 */     GIR_EraseRootFromParent_Done,
     /* 1621591 */   // Label 22376: @1621591
     /* 1621591 */   GIM_Try, /*On fail goto*//*Label 22377*/ GIMT_Encode4(1621677), // Rule ID 3810 //
     /* 1621596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1621607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1621610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1621613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621642 */     // MIs[0] policy
     /* 1621642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1621655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621676 */     // GIR_Coverage, 3810,
     /* 1621676 */     GIR_EraseRootFromParent_Done,
     /* 1621677 */   // Label 22377: @1621677
     /* 1621677 */   GIM_Try, /*On fail goto*//*Label 22378*/ GIMT_Encode4(1621763), // Rule ID 3811 //
     /* 1621682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1621693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1621696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1621699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621728 */     // MIs[0] policy
     /* 1621728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1621741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621762 */     // GIR_Coverage, 3811,
     /* 1621762 */     GIR_EraseRootFromParent_Done,
     /* 1621763 */   // Label 22378: @1621763
     /* 1621763 */   GIM_Try, /*On fail goto*//*Label 22379*/ GIMT_Encode4(1621849), // Rule ID 3814 //
     /* 1621768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1621779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1621782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1621785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621814 */     // MIs[0] policy
     /* 1621814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1621827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621848 */     // GIR_Coverage, 3814,
     /* 1621848 */     GIR_EraseRootFromParent_Done,
     /* 1621849 */   // Label 22379: @1621849
     /* 1621849 */   GIM_Try, /*On fail goto*//*Label 22380*/ GIMT_Encode4(1621935), // Rule ID 3815 //
     /* 1621854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1621865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1621868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1621871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621900 */     // MIs[0] policy
     /* 1621900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621910 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1621913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621934 */     // GIR_Coverage, 3815,
     /* 1621934 */     GIR_EraseRootFromParent_Done,
     /* 1621935 */   // Label 22380: @1621935
     /* 1621935 */   GIM_Try, /*On fail goto*//*Label 22381*/ GIMT_Encode4(1622021), // Rule ID 3818 //
     /* 1621940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1621951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1621954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1621957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621986 */     // MIs[0] policy
     /* 1621986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621996 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1621999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622020 */     // GIR_Coverage, 3818,
     /* 1622020 */     GIR_EraseRootFromParent_Done,
     /* 1622021 */   // Label 22381: @1622021
     /* 1622021 */   GIM_Try, /*On fail goto*//*Label 22382*/ GIMT_Encode4(1622107), // Rule ID 3819 //
     /* 1622026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1622037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1622040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1622043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622072 */     // MIs[0] policy
     /* 1622072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622082 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1622085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622106 */     // GIR_Coverage, 3819,
     /* 1622106 */     GIR_EraseRootFromParent_Done,
     /* 1622107 */   // Label 22382: @1622107
     /* 1622107 */   GIM_Try, /*On fail goto*//*Label 22383*/ GIMT_Encode4(1622193), // Rule ID 3822 //
     /* 1622112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1622123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1622126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1622129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1622135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622158 */     // MIs[0] policy
     /* 1622158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622168 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1622171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622192 */     // GIR_Coverage, 3822,
     /* 1622192 */     GIR_EraseRootFromParent_Done,
     /* 1622193 */   // Label 22383: @1622193
     /* 1622193 */   GIM_Try, /*On fail goto*//*Label 22384*/ GIMT_Encode4(1622279), // Rule ID 3823 //
     /* 1622198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1622209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1622212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1622215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1622221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622244 */     // MIs[0] policy
     /* 1622244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1622257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622278 */     // GIR_Coverage, 3823,
     /* 1622278 */     GIR_EraseRootFromParent_Done,
     /* 1622279 */   // Label 22384: @1622279
     /* 1622279 */   GIM_Try, /*On fail goto*//*Label 22385*/ GIMT_Encode4(1622365), // Rule ID 3826 //
     /* 1622284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1622295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1622298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1622301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622330 */     // MIs[0] policy
     /* 1622330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622340 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1622343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622364 */     // GIR_Coverage, 3826,
     /* 1622364 */     GIR_EraseRootFromParent_Done,
     /* 1622365 */   // Label 22385: @1622365
     /* 1622365 */   GIM_Try, /*On fail goto*//*Label 22386*/ GIMT_Encode4(1622451), // Rule ID 3827 //
     /* 1622370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1622381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1622384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1622387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622416 */     // MIs[0] policy
     /* 1622416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622426 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1622429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622450 */     // GIR_Coverage, 3827,
     /* 1622450 */     GIR_EraseRootFromParent_Done,
     /* 1622451 */   // Label 22386: @1622451
     /* 1622451 */   GIM_Try, /*On fail goto*//*Label 22387*/ GIMT_Encode4(1622537), // Rule ID 3830 //
     /* 1622456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1622467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1622470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1622473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622502 */     // MIs[0] policy
     /* 1622502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622512 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1622515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622536 */     // GIR_Coverage, 3830,
     /* 1622536 */     GIR_EraseRootFromParent_Done,
     /* 1622537 */   // Label 22387: @1622537
     /* 1622537 */   GIM_Try, /*On fail goto*//*Label 22388*/ GIMT_Encode4(1622623), // Rule ID 3831 //
     /* 1622542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1622553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1622556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1622559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622588 */     // MIs[0] policy
     /* 1622588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1622601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622622 */     // GIR_Coverage, 3831,
     /* 1622622 */     GIR_EraseRootFromParent_Done,
     /* 1622623 */   // Label 22388: @1622623
     /* 1622623 */   GIM_Try, /*On fail goto*//*Label 22389*/ GIMT_Encode4(1622709), // Rule ID 3834 //
     /* 1622628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1622639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1622642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1622645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622674 */     // MIs[0] policy
     /* 1622674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622684 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1622687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622708 */     // GIR_Coverage, 3834,
     /* 1622708 */     GIR_EraseRootFromParent_Done,
     /* 1622709 */   // Label 22389: @1622709
     /* 1622709 */   GIM_Try, /*On fail goto*//*Label 22390*/ GIMT_Encode4(1622795), // Rule ID 3835 //
     /* 1622714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1622725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1622728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1622731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622760 */     // MIs[0] policy
     /* 1622760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622770 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1622773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622794 */     // GIR_Coverage, 3835,
     /* 1622794 */     GIR_EraseRootFromParent_Done,
     /* 1622795 */   // Label 22390: @1622795
     /* 1622795 */   GIM_Try, /*On fail goto*//*Label 22391*/ GIMT_Encode4(1622881), // Rule ID 3838 //
     /* 1622800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1622811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1622814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1622817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622846 */     // MIs[0] policy
     /* 1622846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622856 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1622859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622880 */     // GIR_Coverage, 3838,
     /* 1622880 */     GIR_EraseRootFromParent_Done,
     /* 1622881 */   // Label 22391: @1622881
     /* 1622881 */   GIM_Try, /*On fail goto*//*Label 22392*/ GIMT_Encode4(1622967), // Rule ID 3839 //
     /* 1622886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1622897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1622900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1622903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622932 */     // MIs[0] policy
     /* 1622932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1622945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622966 */     // GIR_Coverage, 3839,
     /* 1622966 */     GIR_EraseRootFromParent_Done,
     /* 1622967 */   // Label 22392: @1622967
     /* 1622967 */   GIM_Try, /*On fail goto*//*Label 22393*/ GIMT_Encode4(1623053), // Rule ID 3842 //
     /* 1622972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1622983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1622986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1622989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1622992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623018 */     // MIs[0] policy
     /* 1623018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623028 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1623031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623052 */     // GIR_Coverage, 3842,
     /* 1623052 */     GIR_EraseRootFromParent_Done,
     /* 1623053 */   // Label 22393: @1623053
     /* 1623053 */   GIM_Try, /*On fail goto*//*Label 22394*/ GIMT_Encode4(1623139), // Rule ID 3843 //
     /* 1623058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1623069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1623072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1623075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1623078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623104 */     // MIs[0] policy
     /* 1623104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1623117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623138 */     // GIR_Coverage, 3843,
     /* 1623138 */     GIR_EraseRootFromParent_Done,
     /* 1623139 */   // Label 22394: @1623139
     /* 1623139 */   GIM_Try, /*On fail goto*//*Label 22395*/ GIMT_Encode4(1623225), // Rule ID 3846 //
     /* 1623144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1623155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1623158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1623161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1623164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623190 */     // MIs[0] policy
     /* 1623190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623200 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1623203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623224 */     // GIR_Coverage, 3846,
     /* 1623224 */     GIR_EraseRootFromParent_Done,
     /* 1623225 */   // Label 22395: @1623225
     /* 1623225 */   GIM_Try, /*On fail goto*//*Label 22396*/ GIMT_Encode4(1623311), // Rule ID 3847 //
     /* 1623230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1623241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1623244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1623247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1623250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623276 */     // MIs[0] policy
     /* 1623276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623286 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1623289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623310 */     // GIR_Coverage, 3847,
     /* 1623310 */     GIR_EraseRootFromParent_Done,
     /* 1623311 */   // Label 22396: @1623311
     /* 1623311 */   GIM_Try, /*On fail goto*//*Label 22397*/ GIMT_Encode4(1623397), // Rule ID 3850 //
     /* 1623316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1623327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1623330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1623333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1623336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623362 */     // MIs[0] policy
     /* 1623362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623372 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1623375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623396 */     // GIR_Coverage, 3850,
     /* 1623396 */     GIR_EraseRootFromParent_Done,
     /* 1623397 */   // Label 22397: @1623397
     /* 1623397 */   GIM_Try, /*On fail goto*//*Label 22398*/ GIMT_Encode4(1623483), // Rule ID 3851 //
     /* 1623402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1623413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1623416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1623419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1623422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623448 */     // MIs[0] policy
     /* 1623448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623458 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1623461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623482 */     // GIR_Coverage, 3851,
     /* 1623482 */     GIR_EraseRootFromParent_Done,
     /* 1623483 */   // Label 22398: @1623483
     /* 1623483 */   GIM_Try, /*On fail goto*//*Label 22399*/ GIMT_Encode4(1623569), // Rule ID 3854 //
     /* 1623488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1623499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1623502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1623505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1623508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623534 */     // MIs[0] policy
     /* 1623534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1623547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623568 */     // GIR_Coverage, 3854,
     /* 1623568 */     GIR_EraseRootFromParent_Done,
     /* 1623569 */   // Label 22399: @1623569
     /* 1623569 */   GIM_Try, /*On fail goto*//*Label 22400*/ GIMT_Encode4(1623655), // Rule ID 3855 //
     /* 1623574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1623585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1623588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1623591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1623594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623620 */     // MIs[0] policy
     /* 1623620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1623633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623654 */     // GIR_Coverage, 3855,
     /* 1623654 */     GIR_EraseRootFromParent_Done,
     /* 1623655 */   // Label 22400: @1623655
     /* 1623655 */   GIM_Try, /*On fail goto*//*Label 22401*/ GIMT_Encode4(1623741), // Rule ID 3858 //
     /* 1623660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1623671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1623674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1623677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1623680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623706 */     // MIs[0] policy
     /* 1623706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623716 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1623719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623740 */     // GIR_Coverage, 3858,
     /* 1623740 */     GIR_EraseRootFromParent_Done,
     /* 1623741 */   // Label 22401: @1623741
     /* 1623741 */   GIM_Try, /*On fail goto*//*Label 22402*/ GIMT_Encode4(1623827), // Rule ID 3859 //
     /* 1623746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1623757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1623760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1623763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1623766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623792 */     // MIs[0] policy
     /* 1623792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623802 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1623805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623826 */     // GIR_Coverage, 3859,
     /* 1623826 */     GIR_EraseRootFromParent_Done,
     /* 1623827 */   // Label 22402: @1623827
     /* 1623827 */   GIM_Try, /*On fail goto*//*Label 22403*/ GIMT_Encode4(1623913), // Rule ID 3862 //
     /* 1623832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1623843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1623846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1623849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1623852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1623855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623878 */     // MIs[0] policy
     /* 1623878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623888 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1623891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623912 */     // GIR_Coverage, 3862,
     /* 1623912 */     GIR_EraseRootFromParent_Done,
     /* 1623913 */   // Label 22403: @1623913
     /* 1623913 */   GIM_Try, /*On fail goto*//*Label 22404*/ GIMT_Encode4(1623999), // Rule ID 3863 //
     /* 1623918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1623929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1623932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1623935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1623938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1623941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623964 */     // MIs[0] policy
     /* 1623964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623974 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1623977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623998 */     // GIR_Coverage, 3863,
     /* 1623998 */     GIR_EraseRootFromParent_Done,
     /* 1623999 */   // Label 22404: @1623999
     /* 1623999 */   GIM_Try, /*On fail goto*//*Label 22405*/ GIMT_Encode4(1624085), // Rule ID 3866 //
     /* 1624004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1624015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1624018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1624021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1624024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624050 */     // MIs[0] policy
     /* 1624050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624060 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1624063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624084 */     // GIR_Coverage, 3866,
     /* 1624084 */     GIR_EraseRootFromParent_Done,
     /* 1624085 */   // Label 22405: @1624085
     /* 1624085 */   GIM_Try, /*On fail goto*//*Label 22406*/ GIMT_Encode4(1624171), // Rule ID 3867 //
     /* 1624090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1624101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1624104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1624107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1624110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624136 */     // MIs[0] policy
     /* 1624136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1624149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624170 */     // GIR_Coverage, 3867,
     /* 1624170 */     GIR_EraseRootFromParent_Done,
     /* 1624171 */   // Label 22406: @1624171
     /* 1624171 */   GIM_Try, /*On fail goto*//*Label 22407*/ GIMT_Encode4(1624257), // Rule ID 3870 //
     /* 1624176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1624187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1624190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1624193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1624196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624222 */     // MIs[0] policy
     /* 1624222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1624235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624256 */     // GIR_Coverage, 3870,
     /* 1624256 */     GIR_EraseRootFromParent_Done,
     /* 1624257 */   // Label 22407: @1624257
     /* 1624257 */   GIM_Try, /*On fail goto*//*Label 22408*/ GIMT_Encode4(1624343), // Rule ID 3871 //
     /* 1624262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1624273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1624276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1624279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1624282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624308 */     // MIs[0] policy
     /* 1624308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1624321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624342 */     // GIR_Coverage, 3871,
     /* 1624342 */     GIR_EraseRootFromParent_Done,
     /* 1624343 */   // Label 22408: @1624343
     /* 1624343 */   GIM_Try, /*On fail goto*//*Label 22409*/ GIMT_Encode4(1624429), // Rule ID 3874 //
     /* 1624348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1624359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1624362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1624365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1624368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624394 */     // MIs[0] policy
     /* 1624394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1624407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624428 */     // GIR_Coverage, 3874,
     /* 1624428 */     GIR_EraseRootFromParent_Done,
     /* 1624429 */   // Label 22409: @1624429
     /* 1624429 */   GIM_Try, /*On fail goto*//*Label 22410*/ GIMT_Encode4(1624515), // Rule ID 3875 //
     /* 1624434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1624445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1624448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1624451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1624454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624480 */     // MIs[0] policy
     /* 1624480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624490 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1624493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624514 */     // GIR_Coverage, 3875,
     /* 1624514 */     GIR_EraseRootFromParent_Done,
     /* 1624515 */   // Label 22410: @1624515
     /* 1624515 */   GIM_Try, /*On fail goto*//*Label 22411*/ GIMT_Encode4(1624601), // Rule ID 3878 //
     /* 1624520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1624531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1624534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1624537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1624540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624566 */     // MIs[0] policy
     /* 1624566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624576 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1624579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624600 */     // GIR_Coverage, 3878,
     /* 1624600 */     GIR_EraseRootFromParent_Done,
     /* 1624601 */   // Label 22411: @1624601
     /* 1624601 */   GIM_Try, /*On fail goto*//*Label 22412*/ GIMT_Encode4(1624687), // Rule ID 3879 //
     /* 1624606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1624617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1624620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1624623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1624626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624652 */     // MIs[0] policy
     /* 1624652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624662 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1624665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624686 */     // GIR_Coverage, 3879,
     /* 1624686 */     GIR_EraseRootFromParent_Done,
     /* 1624687 */   // Label 22412: @1624687
     /* 1624687 */   GIM_Try, /*On fail goto*//*Label 22413*/ GIMT_Encode4(1624773), // Rule ID 3882 //
     /* 1624692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1624703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1624706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1624709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1624712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624738 */     // MIs[0] policy
     /* 1624738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624748 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1624751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624772 */     // GIR_Coverage, 3882,
     /* 1624772 */     GIR_EraseRootFromParent_Done,
     /* 1624773 */   // Label 22413: @1624773
     /* 1624773 */   GIM_Try, /*On fail goto*//*Label 22414*/ GIMT_Encode4(1624859), // Rule ID 3883 //
     /* 1624778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1624789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1624792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1624795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1624798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624824 */     // MIs[0] policy
     /* 1624824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624834 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1624837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624858 */     // GIR_Coverage, 3883,
     /* 1624858 */     GIR_EraseRootFromParent_Done,
     /* 1624859 */   // Label 22414: @1624859
     /* 1624859 */   GIM_Try, /*On fail goto*//*Label 22415*/ GIMT_Encode4(1624945), // Rule ID 3886 //
     /* 1624864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1624867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1624875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1624878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1624881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1624884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624910 */     // MIs[0] policy
     /* 1624910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624920 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1624923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624944 */     // GIR_Coverage, 3886,
     /* 1624944 */     GIR_EraseRootFromParent_Done,
     /* 1624945 */   // Label 22415: @1624945
     /* 1624945 */   GIM_Try, /*On fail goto*//*Label 22416*/ GIMT_Encode4(1625031), // Rule ID 3887 //
     /* 1624950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1624953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1624961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1624964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1624967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1624970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624996 */     // MIs[0] policy
     /* 1624996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1625009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625030 */     // GIR_Coverage, 3887,
     /* 1625030 */     GIR_EraseRootFromParent_Done,
     /* 1625031 */   // Label 22416: @1625031
     /* 1625031 */   GIM_Try, /*On fail goto*//*Label 22417*/ GIMT_Encode4(1625117), // Rule ID 3890 //
     /* 1625036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1625047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1625050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1625053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1625056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625082 */     // MIs[0] policy
     /* 1625082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625092 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1625095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625116 */     // GIR_Coverage, 3890,
     /* 1625116 */     GIR_EraseRootFromParent_Done,
     /* 1625117 */   // Label 22417: @1625117
     /* 1625117 */   GIM_Try, /*On fail goto*//*Label 22418*/ GIMT_Encode4(1625203), // Rule ID 3891 //
     /* 1625122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1625133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1625136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1625139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1625142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625168 */     // MIs[0] policy
     /* 1625168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625178 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1625181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625202 */     // GIR_Coverage, 3891,
     /* 1625202 */     GIR_EraseRootFromParent_Done,
     /* 1625203 */   // Label 22418: @1625203
     /* 1625203 */   GIM_Try, /*On fail goto*//*Label 22419*/ GIMT_Encode4(1625289), // Rule ID 3894 //
     /* 1625208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1625219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1625222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1625225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1625228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625254 */     // MIs[0] policy
     /* 1625254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1625267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625288 */     // GIR_Coverage, 3894,
     /* 1625288 */     GIR_EraseRootFromParent_Done,
     /* 1625289 */   // Label 22419: @1625289
     /* 1625289 */   GIM_Try, /*On fail goto*//*Label 22420*/ GIMT_Encode4(1625375), // Rule ID 3895 //
     /* 1625294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1625305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1625308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1625311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1625314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625340 */     // MIs[0] policy
     /* 1625340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625350 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1625353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625374 */     // GIR_Coverage, 3895,
     /* 1625374 */     GIR_EraseRootFromParent_Done,
     /* 1625375 */   // Label 22420: @1625375
     /* 1625375 */   GIM_Try, /*On fail goto*//*Label 22421*/ GIMT_Encode4(1625461), // Rule ID 3898 //
     /* 1625380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1625391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1625394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1625397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1625400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625426 */     // MIs[0] policy
     /* 1625426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625436 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1625439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625460 */     // GIR_Coverage, 3898,
     /* 1625460 */     GIR_EraseRootFromParent_Done,
     /* 1625461 */   // Label 22421: @1625461
     /* 1625461 */   GIM_Try, /*On fail goto*//*Label 22422*/ GIMT_Encode4(1625547), // Rule ID 3899 //
     /* 1625466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1625477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1625480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1625483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1625486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625512 */     // MIs[0] policy
     /* 1625512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625522 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1625525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625546 */     // GIR_Coverage, 3899,
     /* 1625546 */     GIR_EraseRootFromParent_Done,
     /* 1625547 */   // Label 22422: @1625547
     /* 1625547 */   GIM_Try, /*On fail goto*//*Label 22423*/ GIMT_Encode4(1625633), // Rule ID 3902 //
     /* 1625552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1625563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1625566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1625569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625598 */     // MIs[0] policy
     /* 1625598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625608 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1625611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625632 */     // GIR_Coverage, 3902,
     /* 1625632 */     GIR_EraseRootFromParent_Done,
     /* 1625633 */   // Label 22423: @1625633
     /* 1625633 */   GIM_Try, /*On fail goto*//*Label 22424*/ GIMT_Encode4(1625719), // Rule ID 3903 //
     /* 1625638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1625649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1625652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1625655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625684 */     // MIs[0] policy
     /* 1625684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625694 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1625697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625718 */     // GIR_Coverage, 3903,
     /* 1625718 */     GIR_EraseRootFromParent_Done,
     /* 1625719 */   // Label 22424: @1625719
     /* 1625719 */   GIM_Try, /*On fail goto*//*Label 22425*/ GIMT_Encode4(1625805), // Rule ID 3906 //
     /* 1625724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1625735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1625738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1625741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625770 */     // MIs[0] policy
     /* 1625770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625780 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1625783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625804 */     // GIR_Coverage, 3906,
     /* 1625804 */     GIR_EraseRootFromParent_Done,
     /* 1625805 */   // Label 22425: @1625805
     /* 1625805 */   GIM_Try, /*On fail goto*//*Label 22426*/ GIMT_Encode4(1625891), // Rule ID 3907 //
     /* 1625810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1625821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1625824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1625827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625856 */     // MIs[0] policy
     /* 1625856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625866 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1625869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625890 */     // GIR_Coverage, 3907,
     /* 1625890 */     GIR_EraseRootFromParent_Done,
     /* 1625891 */   // Label 22426: @1625891
     /* 1625891 */   GIM_Try, /*On fail goto*//*Label 22427*/ GIMT_Encode4(1625977), // Rule ID 3910 //
     /* 1625896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1625907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1625910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1625913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625942 */     // MIs[0] policy
     /* 1625942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1625955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625976 */     // GIR_Coverage, 3910,
     /* 1625976 */     GIR_EraseRootFromParent_Done,
     /* 1625977 */   // Label 22427: @1625977
     /* 1625977 */   GIM_Try, /*On fail goto*//*Label 22428*/ GIMT_Encode4(1626063), // Rule ID 3911 //
     /* 1625982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1625993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1625996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1625999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626028 */     // MIs[0] policy
     /* 1626028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626038 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1626041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626062 */     // GIR_Coverage, 3911,
     /* 1626062 */     GIR_EraseRootFromParent_Done,
     /* 1626063 */   // Label 22428: @1626063
     /* 1626063 */   GIM_Try, /*On fail goto*//*Label 22429*/ GIMT_Encode4(1626149), // Rule ID 3914 //
     /* 1626068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1626079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1626082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1626085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626114 */     // MIs[0] policy
     /* 1626114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1626127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626148 */     // GIR_Coverage, 3914,
     /* 1626148 */     GIR_EraseRootFromParent_Done,
     /* 1626149 */   // Label 22429: @1626149
     /* 1626149 */   GIM_Try, /*On fail goto*//*Label 22430*/ GIMT_Encode4(1626235), // Rule ID 3915 //
     /* 1626154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1626165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1626168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1626171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626200 */     // MIs[0] policy
     /* 1626200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1626213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626234 */     // GIR_Coverage, 3915,
     /* 1626234 */     GIR_EraseRootFromParent_Done,
     /* 1626235 */   // Label 22430: @1626235
     /* 1626235 */   GIM_Try, /*On fail goto*//*Label 22431*/ GIMT_Encode4(1626321), // Rule ID 3918 //
     /* 1626240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1626251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1626254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1626257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626286 */     // MIs[0] policy
     /* 1626286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1626299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626320 */     // GIR_Coverage, 3918,
     /* 1626320 */     GIR_EraseRootFromParent_Done,
     /* 1626321 */   // Label 22431: @1626321
     /* 1626321 */   GIM_Try, /*On fail goto*//*Label 22432*/ GIMT_Encode4(1626407), // Rule ID 3919 //
     /* 1626326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1626337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1626340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1626343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626372 */     // MIs[0] policy
     /* 1626372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626382 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1626385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626406 */     // GIR_Coverage, 3919,
     /* 1626406 */     GIR_EraseRootFromParent_Done,
     /* 1626407 */   // Label 22432: @1626407
     /* 1626407 */   GIM_Try, /*On fail goto*//*Label 22433*/ GIMT_Encode4(1626493), // Rule ID 3922 //
     /* 1626412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1626423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1626426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1626429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1626435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626458 */     // MIs[0] policy
     /* 1626458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626468 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1626471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626492 */     // GIR_Coverage, 3922,
     /* 1626492 */     GIR_EraseRootFromParent_Done,
     /* 1626493 */   // Label 22433: @1626493
     /* 1626493 */   GIM_Try, /*On fail goto*//*Label 22434*/ GIMT_Encode4(1626579), // Rule ID 3923 //
     /* 1626498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1626509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1626512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1626515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1626521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626544 */     // MIs[0] policy
     /* 1626544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626554 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1626557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626578 */     // GIR_Coverage, 3923,
     /* 1626578 */     GIR_EraseRootFromParent_Done,
     /* 1626579 */   // Label 22434: @1626579
     /* 1626579 */   GIM_Try, /*On fail goto*//*Label 22435*/ GIMT_Encode4(1626665), // Rule ID 3926 //
     /* 1626584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1626595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1626598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1626601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626630 */     // MIs[0] policy
     /* 1626630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626640 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1626643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626664 */     // GIR_Coverage, 3926,
     /* 1626664 */     GIR_EraseRootFromParent_Done,
     /* 1626665 */   // Label 22435: @1626665
     /* 1626665 */   GIM_Try, /*On fail goto*//*Label 22436*/ GIMT_Encode4(1626751), // Rule ID 3927 //
     /* 1626670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1626681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1626684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1626687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626716 */     // MIs[0] policy
     /* 1626716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626726 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1626729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626750 */     // GIR_Coverage, 3927,
     /* 1626750 */     GIR_EraseRootFromParent_Done,
     /* 1626751 */   // Label 22436: @1626751
     /* 1626751 */   GIM_Try, /*On fail goto*//*Label 22437*/ GIMT_Encode4(1626837), // Rule ID 3930 //
     /* 1626756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1626767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1626770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1626773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626802 */     // MIs[0] policy
     /* 1626802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626812 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1626815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626836 */     // GIR_Coverage, 3930,
     /* 1626836 */     GIR_EraseRootFromParent_Done,
     /* 1626837 */   // Label 22437: @1626837
     /* 1626837 */   GIM_Try, /*On fail goto*//*Label 22438*/ GIMT_Encode4(1626923), // Rule ID 3931 //
     /* 1626842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1626853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1626856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1626859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626888 */     // MIs[0] policy
     /* 1626888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626898 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1626901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626922 */     // GIR_Coverage, 3931,
     /* 1626922 */     GIR_EraseRootFromParent_Done,
     /* 1626923 */   // Label 22438: @1626923
     /* 1626923 */   GIM_Try, /*On fail goto*//*Label 22439*/ GIMT_Encode4(1627009), // Rule ID 3934 //
     /* 1626928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1626939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1626942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1626945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626974 */     // MIs[0] policy
     /* 1626974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1626987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627008 */     // GIR_Coverage, 3934,
     /* 1627008 */     GIR_EraseRootFromParent_Done,
     /* 1627009 */   // Label 22439: @1627009
     /* 1627009 */   GIM_Try, /*On fail goto*//*Label 22440*/ GIMT_Encode4(1627095), // Rule ID 3935 //
     /* 1627014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1627025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1627028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1627031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627060 */     // MIs[0] policy
     /* 1627060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627070 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1627073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627094 */     // GIR_Coverage, 3935,
     /* 1627094 */     GIR_EraseRootFromParent_Done,
     /* 1627095 */   // Label 22440: @1627095
     /* 1627095 */   GIM_Try, /*On fail goto*//*Label 22441*/ GIMT_Encode4(1627181), // Rule ID 3938 //
     /* 1627100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1627111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1627114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1627117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627146 */     // MIs[0] policy
     /* 1627146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627156 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1627159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627180 */     // GIR_Coverage, 3938,
     /* 1627180 */     GIR_EraseRootFromParent_Done,
     /* 1627181 */   // Label 22441: @1627181
     /* 1627181 */   GIM_Try, /*On fail goto*//*Label 22442*/ GIMT_Encode4(1627267), // Rule ID 3939 //
     /* 1627186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1627197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1627200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1627203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627232 */     // MIs[0] policy
     /* 1627232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627242 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1627245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627266 */     // GIR_Coverage, 3939,
     /* 1627266 */     GIR_EraseRootFromParent_Done,
     /* 1627267 */   // Label 22442: @1627267
     /* 1627267 */   GIM_Try, /*On fail goto*//*Label 22443*/ GIMT_Encode4(1627353), // Rule ID 3942 //
     /* 1627272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1627283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1627286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1627289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1627295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627318 */     // MIs[0] policy
     /* 1627318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627328 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1627331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627352 */     // GIR_Coverage, 3942,
     /* 1627352 */     GIR_EraseRootFromParent_Done,
     /* 1627353 */   // Label 22443: @1627353
     /* 1627353 */   GIM_Try, /*On fail goto*//*Label 22444*/ GIMT_Encode4(1627439), // Rule ID 3943 //
     /* 1627358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1627369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1627372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1627375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1627381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627404 */     // MIs[0] policy
     /* 1627404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627414 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1627417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627438 */     // GIR_Coverage, 3943,
     /* 1627438 */     GIR_EraseRootFromParent_Done,
     /* 1627439 */   // Label 22444: @1627439
     /* 1627439 */   GIM_Try, /*On fail goto*//*Label 22445*/ GIMT_Encode4(1627525), // Rule ID 3946 //
     /* 1627444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1627455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1627458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1627461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627490 */     // MIs[0] policy
     /* 1627490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627500 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1627503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627524 */     // GIR_Coverage, 3946,
     /* 1627524 */     GIR_EraseRootFromParent_Done,
     /* 1627525 */   // Label 22445: @1627525
     /* 1627525 */   GIM_Try, /*On fail goto*//*Label 22446*/ GIMT_Encode4(1627611), // Rule ID 3947 //
     /* 1627530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1627541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1627544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1627547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627576 */     // MIs[0] policy
     /* 1627576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627586 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1627589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627610 */     // GIR_Coverage, 3947,
     /* 1627610 */     GIR_EraseRootFromParent_Done,
     /* 1627611 */   // Label 22446: @1627611
     /* 1627611 */   GIM_Try, /*On fail goto*//*Label 22447*/ GIMT_Encode4(1627697), // Rule ID 3950 //
     /* 1627616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1627627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1627630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1627633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627662 */     // MIs[0] policy
     /* 1627662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627672 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1627675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627696 */     // GIR_Coverage, 3950,
     /* 1627696 */     GIR_EraseRootFromParent_Done,
     /* 1627697 */   // Label 22447: @1627697
     /* 1627697 */   GIM_Try, /*On fail goto*//*Label 22448*/ GIMT_Encode4(1627783), // Rule ID 3951 //
     /* 1627702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1627713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1627716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1627719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627748 */     // MIs[0] policy
     /* 1627748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627758 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1627761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627782 */     // GIR_Coverage, 3951,
     /* 1627782 */     GIR_EraseRootFromParent_Done,
     /* 1627783 */   // Label 22448: @1627783
     /* 1627783 */   GIM_Try, /*On fail goto*//*Label 22449*/ GIMT_Encode4(1627869), // Rule ID 3954 //
     /* 1627788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1627799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1627802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1627805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627834 */     // MIs[0] policy
     /* 1627834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627844 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1627847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627868 */     // GIR_Coverage, 3954,
     /* 1627868 */     GIR_EraseRootFromParent_Done,
     /* 1627869 */   // Label 22449: @1627869
     /* 1627869 */   GIM_Try, /*On fail goto*//*Label 22450*/ GIMT_Encode4(1627955), // Rule ID 3955 //
     /* 1627874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1627885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1627888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1627891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627920 */     // MIs[0] policy
     /* 1627920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627930 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1627933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627954 */     // GIR_Coverage, 3955,
     /* 1627954 */     GIR_EraseRootFromParent_Done,
     /* 1627955 */   // Label 22450: @1627955
     /* 1627955 */   GIM_Try, /*On fail goto*//*Label 22451*/ GIMT_Encode4(1628041), // Rule ID 3958 //
     /* 1627960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1627971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1627974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1627977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628006 */     // MIs[0] policy
     /* 1628006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1628019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628040 */     // GIR_Coverage, 3958,
     /* 1628040 */     GIR_EraseRootFromParent_Done,
     /* 1628041 */   // Label 22451: @1628041
     /* 1628041 */   GIM_Try, /*On fail goto*//*Label 22452*/ GIMT_Encode4(1628127), // Rule ID 3959 //
     /* 1628046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1628049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1628057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1628060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1628063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628092 */     // MIs[0] policy
     /* 1628092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1628105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628126 */     // GIR_Coverage, 3959,
     /* 1628126 */     GIR_EraseRootFromParent_Done,
     /* 1628127 */   // Label 22452: @1628127
     /* 1628127 */   GIM_Try, /*On fail goto*//*Label 22453*/ GIMT_Encode4(1628213), // Rule ID 3962 //
     /* 1628132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1628143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1628146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1628149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1628152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628178 */     // MIs[0] policy
     /* 1628178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628188 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1628191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628212 */     // GIR_Coverage, 3962,
     /* 1628212 */     GIR_EraseRootFromParent_Done,
     /* 1628213 */   // Label 22453: @1628213
     /* 1628213 */   GIM_Try, /*On fail goto*//*Label 22454*/ GIMT_Encode4(1628299), // Rule ID 3963 //
     /* 1628218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1628229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1628232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1628235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1628238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628264 */     // MIs[0] policy
     /* 1628264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628274 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1628277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628298 */     // GIR_Coverage, 3963,
     /* 1628298 */     GIR_EraseRootFromParent_Done,
     /* 1628299 */   // Label 22454: @1628299
     /* 1628299 */   GIM_Try, /*On fail goto*//*Label 22455*/ GIMT_Encode4(1628385), // Rule ID 3966 //
     /* 1628304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1628315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1628318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1628321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1628324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628350 */     // MIs[0] policy
     /* 1628350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628360 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1628363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628384 */     // GIR_Coverage, 3966,
     /* 1628384 */     GIR_EraseRootFromParent_Done,
     /* 1628385 */   // Label 22455: @1628385
     /* 1628385 */   GIM_Try, /*On fail goto*//*Label 22456*/ GIMT_Encode4(1628471), // Rule ID 3967 //
     /* 1628390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1628401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1628404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1628407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1628410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628436 */     // MIs[0] policy
     /* 1628436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628446 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1628449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628470 */     // GIR_Coverage, 3967,
     /* 1628470 */     GIR_EraseRootFromParent_Done,
     /* 1628471 */   // Label 22456: @1628471
     /* 1628471 */   GIM_Try, /*On fail goto*//*Label 22457*/ GIMT_Encode4(1628557), // Rule ID 3970 //
     /* 1628476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1628493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1628496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628522 */     // MIs[0] policy
     /* 1628522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1628535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628556 */     // GIR_Coverage, 3970,
     /* 1628556 */     GIR_EraseRootFromParent_Done,
     /* 1628557 */   // Label 22457: @1628557
     /* 1628557 */   GIM_Try, /*On fail goto*//*Label 22458*/ GIMT_Encode4(1628643), // Rule ID 3971 //
     /* 1628562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1628579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1628582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628608 */     // MIs[0] policy
     /* 1628608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628618 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1628621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628642 */     // GIR_Coverage, 3971,
     /* 1628642 */     GIR_EraseRootFromParent_Done,
     /* 1628643 */   // Label 22458: @1628643
     /* 1628643 */   GIM_Try, /*On fail goto*//*Label 22459*/ GIMT_Encode4(1628729), // Rule ID 3974 //
     /* 1628648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1628659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1628662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1628665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1628668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628694 */     // MIs[0] policy
     /* 1628694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1628707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628728 */     // GIR_Coverage, 3974,
     /* 1628728 */     GIR_EraseRootFromParent_Done,
     /* 1628729 */   // Label 22459: @1628729
     /* 1628729 */   GIM_Try, /*On fail goto*//*Label 22460*/ GIMT_Encode4(1628815), // Rule ID 3975 //
     /* 1628734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1628745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1628748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1628751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1628754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628780 */     // MIs[0] policy
     /* 1628780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1628793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628814 */     // GIR_Coverage, 3975,
     /* 1628814 */     GIR_EraseRootFromParent_Done,
     /* 1628815 */   // Label 22460: @1628815
     /* 1628815 */   GIM_Try, /*On fail goto*//*Label 22461*/ GIMT_Encode4(1628901), // Rule ID 3978 //
     /* 1628820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1628831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1628834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1628837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1628840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1628843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628866 */     // MIs[0] policy
     /* 1628866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628876 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1628879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628900 */     // GIR_Coverage, 3978,
     /* 1628900 */     GIR_EraseRootFromParent_Done,
     /* 1628901 */   // Label 22461: @1628901
     /* 1628901 */   GIM_Try, /*On fail goto*//*Label 22462*/ GIMT_Encode4(1628987), // Rule ID 3979 //
     /* 1628906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1628917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1628920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1628923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1628926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1628929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628952 */     // MIs[0] policy
     /* 1628952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628962 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1628965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628986 */     // GIR_Coverage, 3979,
     /* 1628986 */     GIR_EraseRootFromParent_Done,
     /* 1628987 */   // Label 22462: @1628987
     /* 1628987 */   GIM_Try, /*On fail goto*//*Label 22463*/ GIMT_Encode4(1629073), // Rule ID 3982 //
     /* 1628992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1629003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1629006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1629009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1629012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1629015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629038 */     // MIs[0] policy
     /* 1629038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629048 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1629051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629072 */     // GIR_Coverage, 3982,
     /* 1629072 */     GIR_EraseRootFromParent_Done,
     /* 1629073 */   // Label 22463: @1629073
     /* 1629073 */   GIM_Try, /*On fail goto*//*Label 22464*/ GIMT_Encode4(1629159), // Rule ID 3983 //
     /* 1629078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1629089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1629092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1629095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1629098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1629101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629124 */     // MIs[0] policy
     /* 1629124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629134 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1629137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629158 */     // GIR_Coverage, 3983,
     /* 1629158 */     GIR_EraseRootFromParent_Done,
     /* 1629159 */   // Label 22464: @1629159
     /* 1629159 */   GIM_Try, /*On fail goto*//*Label 22465*/ GIMT_Encode4(1629245), // Rule ID 3986 //
     /* 1629164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1629175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1629178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1629181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1629184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629210 */     // MIs[0] policy
     /* 1629210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629220 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1629223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629244 */     // GIR_Coverage, 3986,
     /* 1629244 */     GIR_EraseRootFromParent_Done,
     /* 1629245 */   // Label 22465: @1629245
     /* 1629245 */   GIM_Try, /*On fail goto*//*Label 22466*/ GIMT_Encode4(1629331), // Rule ID 3987 //
     /* 1629250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1629261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1629264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1629267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1629270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629296 */     // MIs[0] policy
     /* 1629296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629306 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1629309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629330 */     // GIR_Coverage, 3987,
     /* 1629330 */     GIR_EraseRootFromParent_Done,
     /* 1629331 */   // Label 22466: @1629331
     /* 1629331 */   GIM_Try, /*On fail goto*//*Label 22467*/ GIMT_Encode4(1629417), // Rule ID 3990 //
     /* 1629336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1629347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1629350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1629353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1629356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629382 */     // MIs[0] policy
     /* 1629382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629392 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1629395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629416 */     // GIR_Coverage, 3990,
     /* 1629416 */     GIR_EraseRootFromParent_Done,
     /* 1629417 */   // Label 22467: @1629417
     /* 1629417 */   GIM_Try, /*On fail goto*//*Label 22468*/ GIMT_Encode4(1629503), // Rule ID 3991 //
     /* 1629422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1629433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1629436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1629439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1629442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629468 */     // MIs[0] policy
     /* 1629468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629478 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1629481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629502 */     // GIR_Coverage, 3991,
     /* 1629502 */     GIR_EraseRootFromParent_Done,
     /* 1629503 */   // Label 22468: @1629503
     /* 1629503 */   GIM_Try, /*On fail goto*//*Label 22469*/ GIMT_Encode4(1629589), // Rule ID 3994 //
     /* 1629508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1629519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1629522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1629525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1629528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629554 */     // MIs[0] policy
     /* 1629554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1629567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629588 */     // GIR_Coverage, 3994,
     /* 1629588 */     GIR_EraseRootFromParent_Done,
     /* 1629589 */   // Label 22469: @1629589
     /* 1629589 */   GIM_Try, /*On fail goto*//*Label 22470*/ GIMT_Encode4(1629675), // Rule ID 3995 //
     /* 1629594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1629605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1629608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1629611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1629614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629640 */     // MIs[0] policy
     /* 1629640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1629653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629674 */     // GIR_Coverage, 3995,
     /* 1629674 */     GIR_EraseRootFromParent_Done,
     /* 1629675 */   // Label 22470: @1629675
     /* 1629675 */   GIM_Try, /*On fail goto*//*Label 22471*/ GIMT_Encode4(1629761), // Rule ID 3998 //
     /* 1629680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1629691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1629694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1629700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629726 */     // MIs[0] policy
     /* 1629726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1629739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629760 */     // GIR_Coverage, 3998,
     /* 1629760 */     GIR_EraseRootFromParent_Done,
     /* 1629761 */   // Label 22471: @1629761
     /* 1629761 */   GIM_Try, /*On fail goto*//*Label 22472*/ GIMT_Encode4(1629847), // Rule ID 3999 //
     /* 1629766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1629777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1629780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1629786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629812 */     // MIs[0] policy
     /* 1629812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1629825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629846 */     // GIR_Coverage, 3999,
     /* 1629846 */     GIR_EraseRootFromParent_Done,
     /* 1629847 */   // Label 22472: @1629847
     /* 1629847 */   GIM_Try, /*On fail goto*//*Label 22473*/ GIMT_Encode4(1629933), // Rule ID 4002 //
     /* 1629852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1629863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1629866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1629872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629898 */     // MIs[0] policy
     /* 1629898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629908 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1629911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629932 */     // GIR_Coverage, 4002,
     /* 1629932 */     GIR_EraseRootFromParent_Done,
     /* 1629933 */   // Label 22473: @1629933
     /* 1629933 */   GIM_Try, /*On fail goto*//*Label 22474*/ GIMT_Encode4(1630019), // Rule ID 4003 //
     /* 1629938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1629949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1629952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1629958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629984 */     // MIs[0] policy
     /* 1629984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629994 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1629997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630018 */     // GIR_Coverage, 4003,
     /* 1630018 */     GIR_EraseRootFromParent_Done,
     /* 1630019 */   // Label 22474: @1630019
     /* 1630019 */   GIM_Try, /*On fail goto*//*Label 22475*/ GIMT_Encode4(1630105), // Rule ID 4006 //
     /* 1630024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1630035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1630038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1630041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1630044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630070 */     // MIs[0] policy
     /* 1630070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630080 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1630083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630104 */     // GIR_Coverage, 4006,
     /* 1630104 */     GIR_EraseRootFromParent_Done,
     /* 1630105 */   // Label 22475: @1630105
     /* 1630105 */   GIM_Try, /*On fail goto*//*Label 22476*/ GIMT_Encode4(1630191), // Rule ID 4007 //
     /* 1630110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1630121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1630124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1630127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1630130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630156 */     // MIs[0] policy
     /* 1630156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630166 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1630169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630190 */     // GIR_Coverage, 4007,
     /* 1630190 */     GIR_EraseRootFromParent_Done,
     /* 1630191 */   // Label 22476: @1630191
     /* 1630191 */   GIM_Try, /*On fail goto*//*Label 22477*/ GIMT_Encode4(1630277), // Rule ID 4010 //
     /* 1630196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1630207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1630210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1630213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1630216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630242 */     // MIs[0] policy
     /* 1630242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1630255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630276 */     // GIR_Coverage, 4010,
     /* 1630276 */     GIR_EraseRootFromParent_Done,
     /* 1630277 */   // Label 22477: @1630277
     /* 1630277 */   GIM_Try, /*On fail goto*//*Label 22478*/ GIMT_Encode4(1630363), // Rule ID 4011 //
     /* 1630282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1630293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1630296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1630299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1630302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630328 */     // MIs[0] policy
     /* 1630328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630338 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1630341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630362 */     // GIR_Coverage, 4011,
     /* 1630362 */     GIR_EraseRootFromParent_Done,
     /* 1630363 */   // Label 22478: @1630363
     /* 1630363 */   GIM_Try, /*On fail goto*//*Label 22479*/ GIMT_Encode4(1630449), // Rule ID 4014 //
     /* 1630368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1630379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1630382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1630385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1630388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630414 */     // MIs[0] policy
     /* 1630414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630424 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1630427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630448 */     // GIR_Coverage, 4014,
     /* 1630448 */     GIR_EraseRootFromParent_Done,
     /* 1630449 */   // Label 22479: @1630449
     /* 1630449 */   GIM_Try, /*On fail goto*//*Label 22480*/ GIMT_Encode4(1630535), // Rule ID 4015 //
     /* 1630454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1630465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1630468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1630471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1630474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630500 */     // MIs[0] policy
     /* 1630500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630510 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1630513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630534 */     // GIR_Coverage, 4015,
     /* 1630534 */     GIR_EraseRootFromParent_Done,
     /* 1630535 */   // Label 22480: @1630535
     /* 1630535 */   GIM_Try, /*On fail goto*//*Label 22481*/ GIMT_Encode4(1630621), // Rule ID 4018 //
     /* 1630540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1630551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1630554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1630560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630586 */     // MIs[0] policy
     /* 1630586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630596 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1630599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630620 */     // GIR_Coverage, 4018,
     /* 1630620 */     GIR_EraseRootFromParent_Done,
     /* 1630621 */   // Label 22481: @1630621
     /* 1630621 */   GIM_Try, /*On fail goto*//*Label 22482*/ GIMT_Encode4(1630707), // Rule ID 4019 //
     /* 1630626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1630637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1630640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1630646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630672 */     // MIs[0] policy
     /* 1630672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630682 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1630685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630706 */     // GIR_Coverage, 4019,
     /* 1630706 */     GIR_EraseRootFromParent_Done,
     /* 1630707 */   // Label 22482: @1630707
     /* 1630707 */   GIM_Try, /*On fail goto*//*Label 22483*/ GIMT_Encode4(1630793), // Rule ID 4022 //
     /* 1630712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1630723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1630726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1630729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630758 */     // MIs[0] policy
     /* 1630758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1630771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630792 */     // GIR_Coverage, 4022,
     /* 1630792 */     GIR_EraseRootFromParent_Done,
     /* 1630793 */   // Label 22483: @1630793
     /* 1630793 */   GIM_Try, /*On fail goto*//*Label 22484*/ GIMT_Encode4(1630879), // Rule ID 4023 //
     /* 1630798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1630809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1630812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1630815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630844 */     // MIs[0] policy
     /* 1630844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630854 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1630857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630878 */     // GIR_Coverage, 4023,
     /* 1630878 */     GIR_EraseRootFromParent_Done,
     /* 1630879 */   // Label 22484: @1630879
     /* 1630879 */   GIM_Try, /*On fail goto*//*Label 22485*/ GIMT_Encode4(1630965), // Rule ID 4026 //
     /* 1630884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1630895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1630898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1630901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630930 */     // MIs[0] policy
     /* 1630930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630940 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1630943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630964 */     // GIR_Coverage, 4026,
     /* 1630964 */     GIR_EraseRootFromParent_Done,
     /* 1630965 */   // Label 22485: @1630965
     /* 1630965 */   GIM_Try, /*On fail goto*//*Label 22486*/ GIMT_Encode4(1631051), // Rule ID 4027 //
     /* 1630970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1630981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1630984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1630987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631016 */     // MIs[0] policy
     /* 1631016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631026 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1631029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631050 */     // GIR_Coverage, 4027,
     /* 1631050 */     GIR_EraseRootFromParent_Done,
     /* 1631051 */   // Label 22486: @1631051
     /* 1631051 */   GIM_Try, /*On fail goto*//*Label 22487*/ GIMT_Encode4(1631137), // Rule ID 4030 //
     /* 1631056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1631067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1631070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1631073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631102 */     // MIs[0] policy
     /* 1631102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631112 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1631115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631136 */     // GIR_Coverage, 4030,
     /* 1631136 */     GIR_EraseRootFromParent_Done,
     /* 1631137 */   // Label 22487: @1631137
     /* 1631137 */   GIM_Try, /*On fail goto*//*Label 22488*/ GIMT_Encode4(1631223), // Rule ID 4031 //
     /* 1631142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1631153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1631156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1631159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631188 */     // MIs[0] policy
     /* 1631188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631198 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1631201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631222 */     // GIR_Coverage, 4031,
     /* 1631222 */     GIR_EraseRootFromParent_Done,
     /* 1631223 */   // Label 22488: @1631223
     /* 1631223 */   GIM_Try, /*On fail goto*//*Label 22489*/ GIMT_Encode4(1631309), // Rule ID 4034 //
     /* 1631228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1631239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1631242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1631245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631274 */     // MIs[0] policy
     /* 1631274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631284 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1631287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631308 */     // GIR_Coverage, 4034,
     /* 1631308 */     GIR_EraseRootFromParent_Done,
     /* 1631309 */   // Label 22489: @1631309
     /* 1631309 */   GIM_Try, /*On fail goto*//*Label 22490*/ GIMT_Encode4(1631395), // Rule ID 4035 //
     /* 1631314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1631325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1631328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1631331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631360 */     // MIs[0] policy
     /* 1631360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631370 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1631373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631394 */     // GIR_Coverage, 4035,
     /* 1631394 */     GIR_EraseRootFromParent_Done,
     /* 1631395 */   // Label 22490: @1631395
     /* 1631395 */   GIM_Try, /*On fail goto*//*Label 22491*/ GIMT_Encode4(1631481), // Rule ID 4038 //
     /* 1631400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1631411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1631414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1631417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1631423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631446 */     // MIs[0] policy
     /* 1631446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631456 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1631459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631480 */     // GIR_Coverage, 4038,
     /* 1631480 */     GIR_EraseRootFromParent_Done,
     /* 1631481 */   // Label 22491: @1631481
     /* 1631481 */   GIM_Try, /*On fail goto*//*Label 22492*/ GIMT_Encode4(1631567), // Rule ID 4039 //
     /* 1631486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1631497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1631500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1631503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1631509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631532 */     // MIs[0] policy
     /* 1631532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631542 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1631545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631566 */     // GIR_Coverage, 4039,
     /* 1631566 */     GIR_EraseRootFromParent_Done,
     /* 1631567 */   // Label 22492: @1631567
     /* 1631567 */   GIM_Try, /*On fail goto*//*Label 22493*/ GIMT_Encode4(1631653), // Rule ID 4042 //
     /* 1631572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1631583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1631586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1631589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1631595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631618 */     // MIs[0] policy
     /* 1631618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631628 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1631631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631652 */     // GIR_Coverage, 4042,
     /* 1631652 */     GIR_EraseRootFromParent_Done,
     /* 1631653 */   // Label 22493: @1631653
     /* 1631653 */   GIM_Try, /*On fail goto*//*Label 22494*/ GIMT_Encode4(1631739), // Rule ID 4043 //
     /* 1631658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1631669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1631672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1631675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1631681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631704 */     // MIs[0] policy
     /* 1631704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631714 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1631717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631738 */     // GIR_Coverage, 4043,
     /* 1631738 */     GIR_EraseRootFromParent_Done,
     /* 1631739 */   // Label 22494: @1631739
     /* 1631739 */   GIM_Try, /*On fail goto*//*Label 22495*/ GIMT_Encode4(1631825), // Rule ID 4046 //
     /* 1631744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1631755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1631758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1631761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631790 */     // MIs[0] policy
     /* 1631790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631800 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1631803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631824 */     // GIR_Coverage, 4046,
     /* 1631824 */     GIR_EraseRootFromParent_Done,
     /* 1631825 */   // Label 22495: @1631825
     /* 1631825 */   GIM_Try, /*On fail goto*//*Label 22496*/ GIMT_Encode4(1631911), // Rule ID 4047 //
     /* 1631830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1631841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1631844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1631847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631876 */     // MIs[0] policy
     /* 1631876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631886 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1631889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631910 */     // GIR_Coverage, 4047,
     /* 1631910 */     GIR_EraseRootFromParent_Done,
     /* 1631911 */   // Label 22496: @1631911
     /* 1631911 */   GIM_Try, /*On fail goto*//*Label 22497*/ GIMT_Encode4(1631997), // Rule ID 4050 //
     /* 1631916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1631927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1631930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1631933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631962 */     // MIs[0] policy
     /* 1631962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631972 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1631975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631996 */     // GIR_Coverage, 4050,
     /* 1631996 */     GIR_EraseRootFromParent_Done,
     /* 1631997 */   // Label 22497: @1631997
     /* 1631997 */   GIM_Try, /*On fail goto*//*Label 22498*/ GIMT_Encode4(1632083), // Rule ID 4051 //
     /* 1632002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1632013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1632016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1632019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632048 */     // MIs[0] policy
     /* 1632048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632058 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1632061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632082 */     // GIR_Coverage, 4051,
     /* 1632082 */     GIR_EraseRootFromParent_Done,
     /* 1632083 */   // Label 22498: @1632083
     /* 1632083 */   GIM_Try, /*On fail goto*//*Label 22499*/ GIMT_Encode4(1632169), // Rule ID 4054 //
     /* 1632088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1632099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1632102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1632105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632134 */     // MIs[0] policy
     /* 1632134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632144 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1632147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632168 */     // GIR_Coverage, 4054,
     /* 1632168 */     GIR_EraseRootFromParent_Done,
     /* 1632169 */   // Label 22499: @1632169
     /* 1632169 */   GIM_Try, /*On fail goto*//*Label 22500*/ GIMT_Encode4(1632255), // Rule ID 4055 //
     /* 1632174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1632185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1632188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1632191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632220 */     // MIs[0] policy
     /* 1632220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1632233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632254 */     // GIR_Coverage, 4055,
     /* 1632254 */     GIR_EraseRootFromParent_Done,
     /* 1632255 */   // Label 22500: @1632255
     /* 1632255 */   GIM_Try, /*On fail goto*//*Label 22501*/ GIMT_Encode4(1632341), // Rule ID 4058 //
     /* 1632260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1632271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1632274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1632277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632306 */     // MIs[0] policy
     /* 1632306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632316 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1632319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632340 */     // GIR_Coverage, 4058,
     /* 1632340 */     GIR_EraseRootFromParent_Done,
     /* 1632341 */   // Label 22501: @1632341
     /* 1632341 */   GIM_Try, /*On fail goto*//*Label 22502*/ GIMT_Encode4(1632427), // Rule ID 4059 //
     /* 1632346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1632357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1632360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1632363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632392 */     // MIs[0] policy
     /* 1632392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632402 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1632405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632426 */     // GIR_Coverage, 4059,
     /* 1632426 */     GIR_EraseRootFromParent_Done,
     /* 1632427 */   // Label 22502: @1632427
     /* 1632427 */   GIM_Try, /*On fail goto*//*Label 22503*/ GIMT_Encode4(1632513), // Rule ID 4062 //
     /* 1632432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1632443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1632446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1632449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632478 */     // MIs[0] policy
     /* 1632478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632488 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1632491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632512 */     // GIR_Coverage, 4062,
     /* 1632512 */     GIR_EraseRootFromParent_Done,
     /* 1632513 */   // Label 22503: @1632513
     /* 1632513 */   GIM_Try, /*On fail goto*//*Label 22504*/ GIMT_Encode4(1632599), // Rule ID 4063 //
     /* 1632518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1632529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1632532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1632535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632564 */     // MIs[0] policy
     /* 1632564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632574 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1632577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632598 */     // GIR_Coverage, 4063,
     /* 1632598 */     GIR_EraseRootFromParent_Done,
     /* 1632599 */   // Label 22504: @1632599
     /* 1632599 */   GIM_Try, /*On fail goto*//*Label 22505*/ GIMT_Encode4(1632685), // Rule ID 4066 //
     /* 1632604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1632615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1632618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1632621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632650 */     // MIs[0] policy
     /* 1632650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1632663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632684 */     // GIR_Coverage, 4066,
     /* 1632684 */     GIR_EraseRootFromParent_Done,
     /* 1632685 */   // Label 22505: @1632685
     /* 1632685 */   GIM_Try, /*On fail goto*//*Label 22506*/ GIMT_Encode4(1632771), // Rule ID 4067 //
     /* 1632690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1632701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1632704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1632707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632736 */     // MIs[0] policy
     /* 1632736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1632749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632770 */     // GIR_Coverage, 4067,
     /* 1632770 */     GIR_EraseRootFromParent_Done,
     /* 1632771 */   // Label 22506: @1632771
     /* 1632771 */   GIM_Try, /*On fail goto*//*Label 22507*/ GIMT_Encode4(1632857), // Rule ID 4070 //
     /* 1632776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1632787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1632790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1632793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632822 */     // MIs[0] policy
     /* 1632822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632832 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1632835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632856 */     // GIR_Coverage, 4070,
     /* 1632856 */     GIR_EraseRootFromParent_Done,
     /* 1632857 */   // Label 22507: @1632857
     /* 1632857 */   GIM_Try, /*On fail goto*//*Label 22508*/ GIMT_Encode4(1632943), // Rule ID 4071 //
     /* 1632862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1632873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1632876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1632879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632908 */     // MIs[0] policy
     /* 1632908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632918 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1632921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632942 */     // GIR_Coverage, 4071,
     /* 1632942 */     GIR_EraseRootFromParent_Done,
     /* 1632943 */   // Label 22508: @1632943
     /* 1632943 */   GIM_Try, /*On fail goto*//*Label 22509*/ GIMT_Encode4(1633029), // Rule ID 4074 //
     /* 1632948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1632959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1632962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1632965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632994 */     // MIs[0] policy
     /* 1632994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633004 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1633007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633028 */     // GIR_Coverage, 4074,
     /* 1633028 */     GIR_EraseRootFromParent_Done,
     /* 1633029 */   // Label 22509: @1633029
     /* 1633029 */   GIM_Try, /*On fail goto*//*Label 22510*/ GIMT_Encode4(1633115), // Rule ID 4075 //
     /* 1633034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1633037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1633045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1633048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1633051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1633054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633080 */     // MIs[0] policy
     /* 1633080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633090 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1633093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633114 */     // GIR_Coverage, 4075,
     /* 1633114 */     GIR_EraseRootFromParent_Done,
     /* 1633115 */   // Label 22510: @1633115
     /* 1633115 */   GIM_Try, /*On fail goto*//*Label 22511*/ GIMT_Encode4(1633201), // Rule ID 4078 //
     /* 1633120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1633123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1633131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1633134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1633137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1633140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633166 */     // MIs[0] policy
     /* 1633166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1633179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633200 */     // GIR_Coverage, 4078,
     /* 1633200 */     GIR_EraseRootFromParent_Done,
     /* 1633201 */   // Label 22511: @1633201
     /* 1633201 */   GIM_Try, /*On fail goto*//*Label 22512*/ GIMT_Encode4(1633287), // Rule ID 4079 //
     /* 1633206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1633209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1633217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1633220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1633223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1633226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633252 */     // MIs[0] policy
     /* 1633252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633262 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1633265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633286 */     // GIR_Coverage, 4079,
     /* 1633286 */     GIR_EraseRootFromParent_Done,
     /* 1633287 */   // Label 22512: @1633287
     /* 1633287 */   GIM_Try, /*On fail goto*//*Label 22513*/ GIMT_Encode4(1633373), // Rule ID 4088 //
     /* 1633292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1633303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1633306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1633309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1633312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633338 */     // MIs[0] policy
     /* 1633338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633348 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1633351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633372 */     // GIR_Coverage, 4088,
     /* 1633372 */     GIR_EraseRootFromParent_Done,
     /* 1633373 */   // Label 22513: @1633373
     /* 1633373 */   GIM_Try, /*On fail goto*//*Label 22514*/ GIMT_Encode4(1633459), // Rule ID 4089 //
     /* 1633378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1633389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1633392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1633395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1633398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633424 */     // MIs[0] policy
     /* 1633424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633434 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1633437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633458 */     // GIR_Coverage, 4089,
     /* 1633458 */     GIR_EraseRootFromParent_Done,
     /* 1633459 */   // Label 22514: @1633459
     /* 1633459 */   GIM_Try, /*On fail goto*//*Label 22515*/ GIMT_Encode4(1633545), // Rule ID 4098 //
     /* 1633464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1633475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1633478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1633481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1633484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633510 */     // MIs[0] policy
     /* 1633510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1633523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633544 */     // GIR_Coverage, 4098,
     /* 1633544 */     GIR_EraseRootFromParent_Done,
     /* 1633545 */   // Label 22515: @1633545
     /* 1633545 */   GIM_Try, /*On fail goto*//*Label 22516*/ GIMT_Encode4(1633631), // Rule ID 4099 //
     /* 1633550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1633561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1633564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1633567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1633570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633596 */     // MIs[0] policy
     /* 1633596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633606 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1633609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633630 */     // GIR_Coverage, 4099,
     /* 1633630 */     GIR_EraseRootFromParent_Done,
     /* 1633631 */   // Label 22516: @1633631
     /* 1633631 */   GIM_Try, /*On fail goto*//*Label 22517*/ GIMT_Encode4(1633717), // Rule ID 4108 //
     /* 1633636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1633647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1633650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1633656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633682 */     // MIs[0] policy
     /* 1633682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1633695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633716 */     // GIR_Coverage, 4108,
     /* 1633716 */     GIR_EraseRootFromParent_Done,
     /* 1633717 */   // Label 22517: @1633717
     /* 1633717 */   GIM_Try, /*On fail goto*//*Label 22518*/ GIMT_Encode4(1633803), // Rule ID 4109 //
     /* 1633722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1633733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1633736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1633742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633768 */     // MIs[0] policy
     /* 1633768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633778 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1633781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633802 */     // GIR_Coverage, 4109,
     /* 1633802 */     GIR_EraseRootFromParent_Done,
     /* 1633803 */   // Label 22518: @1633803
     /* 1633803 */   GIM_Try, /*On fail goto*//*Label 22519*/ GIMT_Encode4(1633889), // Rule ID 4118 //
     /* 1633808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1633819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1633822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1633828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633854 */     // MIs[0] policy
     /* 1633854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633864 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1633867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633888 */     // GIR_Coverage, 4118,
     /* 1633888 */     GIR_EraseRootFromParent_Done,
     /* 1633889 */   // Label 22519: @1633889
     /* 1633889 */   GIM_Try, /*On fail goto*//*Label 22520*/ GIMT_Encode4(1633975), // Rule ID 4119 //
     /* 1633894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1633905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1633908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1633914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633940 */     // MIs[0] policy
     /* 1633940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633950 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1633953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633974 */     // GIR_Coverage, 4119,
     /* 1633974 */     GIR_EraseRootFromParent_Done,
     /* 1633975 */   // Label 22520: @1633975
     /* 1633975 */   GIM_Try, /*On fail goto*//*Label 22521*/ GIMT_Encode4(1634061), // Rule ID 4128 //
     /* 1633980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1633991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1633994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1633997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1634000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1634003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634026 */     // MIs[0] policy
     /* 1634026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634036 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1634039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634060 */     // GIR_Coverage, 4128,
     /* 1634060 */     GIR_EraseRootFromParent_Done,
     /* 1634061 */   // Label 22521: @1634061
     /* 1634061 */   GIM_Try, /*On fail goto*//*Label 22522*/ GIMT_Encode4(1634147), // Rule ID 4129 //
     /* 1634066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1634077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1634080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1634083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1634086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1634089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634112 */     // MIs[0] policy
     /* 1634112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634122 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1634125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634146 */     // GIR_Coverage, 4129,
     /* 1634146 */     GIR_EraseRootFromParent_Done,
     /* 1634147 */   // Label 22522: @1634147
     /* 1634147 */   GIM_Try, /*On fail goto*//*Label 22523*/ GIMT_Encode4(1634233), // Rule ID 4138 //
     /* 1634152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1634163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1634166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1634169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1634172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634198 */     // MIs[0] policy
     /* 1634198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634208 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1634211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634232 */     // GIR_Coverage, 4138,
     /* 1634232 */     GIR_EraseRootFromParent_Done,
     /* 1634233 */   // Label 22523: @1634233
     /* 1634233 */   GIM_Try, /*On fail goto*//*Label 22524*/ GIMT_Encode4(1634319), // Rule ID 4139 //
     /* 1634238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1634249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1634252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1634255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1634258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634284 */     // MIs[0] policy
     /* 1634284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1634297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634318 */     // GIR_Coverage, 4139,
     /* 1634318 */     GIR_EraseRootFromParent_Done,
     /* 1634319 */   // Label 22524: @1634319
     /* 1634319 */   GIM_Try, /*On fail goto*//*Label 22525*/ GIMT_Encode4(1634405), // Rule ID 4148 //
     /* 1634324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1634335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1634338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1634341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1634344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634370 */     // MIs[0] policy
     /* 1634370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634380 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1634383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634404 */     // GIR_Coverage, 4148,
     /* 1634404 */     GIR_EraseRootFromParent_Done,
     /* 1634405 */   // Label 22525: @1634405
     /* 1634405 */   GIM_Try, /*On fail goto*//*Label 22526*/ GIMT_Encode4(1634491), // Rule ID 4149 //
     /* 1634410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1634421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1634424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1634427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1634430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634456 */     // MIs[0] policy
     /* 1634456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1634469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634490 */     // GIR_Coverage, 4149,
     /* 1634490 */     GIR_EraseRootFromParent_Done,
     /* 1634491 */   // Label 22526: @1634491
     /* 1634491 */   GIM_Try, /*On fail goto*//*Label 22527*/ GIMT_Encode4(1634577), // Rule ID 4158 //
     /* 1634496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1634507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1634510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1634513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1634516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634542 */     // MIs[0] policy
     /* 1634542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1634555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634576 */     // GIR_Coverage, 4158,
     /* 1634576 */     GIR_EraseRootFromParent_Done,
     /* 1634577 */   // Label 22527: @1634577
     /* 1634577 */   GIM_Try, /*On fail goto*//*Label 22528*/ GIMT_Encode4(1634663), // Rule ID 4159 //
     /* 1634582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1634593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1634596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1634599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1634602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634628 */     // MIs[0] policy
     /* 1634628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634638 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1634641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634662 */     // GIR_Coverage, 4159,
     /* 1634662 */     GIR_EraseRootFromParent_Done,
     /* 1634663 */   // Label 22528: @1634663
     /* 1634663 */   GIM_Try, /*On fail goto*//*Label 22529*/ GIMT_Encode4(1634749), // Rule ID 4168 //
     /* 1634668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1634679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1634682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1634688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634714 */     // MIs[0] policy
     /* 1634714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634724 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1634727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634748 */     // GIR_Coverage, 4168,
     /* 1634748 */     GIR_EraseRootFromParent_Done,
     /* 1634749 */   // Label 22529: @1634749
     /* 1634749 */   GIM_Try, /*On fail goto*//*Label 22530*/ GIMT_Encode4(1634835), // Rule ID 4169 //
     /* 1634754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1634765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1634768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1634774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634800 */     // MIs[0] policy
     /* 1634800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634810 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1634813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634834 */     // GIR_Coverage, 4169,
     /* 1634834 */     GIR_EraseRootFromParent_Done,
     /* 1634835 */   // Label 22530: @1634835
     /* 1634835 */   GIM_Try, /*On fail goto*//*Label 22531*/ GIMT_Encode4(1634921), // Rule ID 4178 //
     /* 1634840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1634851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1634854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1634857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1634860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634886 */     // MIs[0] policy
     /* 1634886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1634899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634920 */     // GIR_Coverage, 4178,
     /* 1634920 */     GIR_EraseRootFromParent_Done,
     /* 1634921 */   // Label 22531: @1634921
     /* 1634921 */   GIM_Try, /*On fail goto*//*Label 22532*/ GIMT_Encode4(1635007), // Rule ID 4179 //
     /* 1634926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1634937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1634940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1634943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1634946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634972 */     // MIs[0] policy
     /* 1634972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634982 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1634985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635006 */     // GIR_Coverage, 4179,
     /* 1635006 */     GIR_EraseRootFromParent_Done,
     /* 1635007 */   // Label 22532: @1635007
     /* 1635007 */   GIM_Try, /*On fail goto*//*Label 22533*/ GIMT_Encode4(1635093), // Rule ID 4188 //
     /* 1635012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1635023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1635026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1635029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1635032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635058 */     // MIs[0] policy
     /* 1635058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1635071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635092 */     // GIR_Coverage, 4188,
     /* 1635092 */     GIR_EraseRootFromParent_Done,
     /* 1635093 */   // Label 22533: @1635093
     /* 1635093 */   GIM_Try, /*On fail goto*//*Label 22534*/ GIMT_Encode4(1635179), // Rule ID 4189 //
     /* 1635098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1635109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1635112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1635115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1635118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635144 */     // MIs[0] policy
     /* 1635144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635154 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1635157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635178 */     // GIR_Coverage, 4189,
     /* 1635178 */     GIR_EraseRootFromParent_Done,
     /* 1635179 */   // Label 22534: @1635179
     /* 1635179 */   GIM_Try, /*On fail goto*//*Label 22535*/ GIMT_Encode4(1635265), // Rule ID 4198 //
     /* 1635184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1635195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1635198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1635201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1635204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635230 */     // MIs[0] policy
     /* 1635230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1635243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635264 */     // GIR_Coverage, 4198,
     /* 1635264 */     GIR_EraseRootFromParent_Done,
     /* 1635265 */   // Label 22535: @1635265
     /* 1635265 */   GIM_Try, /*On fail goto*//*Label 22536*/ GIMT_Encode4(1635351), // Rule ID 4199 //
     /* 1635270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1635281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1635284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1635287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1635290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635316 */     // MIs[0] policy
     /* 1635316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1635329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635350 */     // GIR_Coverage, 4199,
     /* 1635350 */     GIR_EraseRootFromParent_Done,
     /* 1635351 */   // Label 22536: @1635351
     /* 1635351 */   GIM_Try, /*On fail goto*//*Label 22537*/ GIMT_Encode4(1635437), // Rule ID 4208 //
     /* 1635356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1635367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1635370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1635373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1635376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635402 */     // MIs[0] policy
     /* 1635402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635412 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1635415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635436 */     // GIR_Coverage, 4208,
     /* 1635436 */     GIR_EraseRootFromParent_Done,
     /* 1635437 */   // Label 22537: @1635437
     /* 1635437 */   GIM_Try, /*On fail goto*//*Label 22538*/ GIMT_Encode4(1635523), // Rule ID 4209 //
     /* 1635442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1635453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1635456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1635459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1635462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635488 */     // MIs[0] policy
     /* 1635488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635498 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1635501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635522 */     // GIR_Coverage, 4209,
     /* 1635522 */     GIR_EraseRootFromParent_Done,
     /* 1635523 */   // Label 22538: @1635523
     /* 1635523 */   GIM_Try, /*On fail goto*//*Label 22539*/ GIMT_Encode4(1635609), // Rule ID 4218 //
     /* 1635528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1635539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1635542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1635545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1635548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635574 */     // MIs[0] policy
     /* 1635574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635584 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1635587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635608 */     // GIR_Coverage, 4218,
     /* 1635608 */     GIR_EraseRootFromParent_Done,
     /* 1635609 */   // Label 22539: @1635609
     /* 1635609 */   GIM_Try, /*On fail goto*//*Label 22540*/ GIMT_Encode4(1635695), // Rule ID 4219 //
     /* 1635614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1635625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1635628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1635631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1635634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635660 */     // MIs[0] policy
     /* 1635660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635670 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1635673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635694 */     // GIR_Coverage, 4219,
     /* 1635694 */     GIR_EraseRootFromParent_Done,
     /* 1635695 */   // Label 22540: @1635695
     /* 1635695 */   GIM_Try, /*On fail goto*//*Label 22541*/ GIMT_Encode4(1635781), // Rule ID 4222 //
     /* 1635700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1635711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1635714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635746 */     // MIs[0] policy
     /* 1635746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635756 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1635759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635780 */     // GIR_Coverage, 4222,
     /* 1635780 */     GIR_EraseRootFromParent_Done,
     /* 1635781 */   // Label 22541: @1635781
     /* 1635781 */   GIM_Try, /*On fail goto*//*Label 22542*/ GIMT_Encode4(1635867), // Rule ID 4223 //
     /* 1635786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1635797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1635800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635832 */     // MIs[0] policy
     /* 1635832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635842 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1635845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635866 */     // GIR_Coverage, 4223,
     /* 1635866 */     GIR_EraseRootFromParent_Done,
     /* 1635867 */   // Label 22542: @1635867
     /* 1635867 */   GIM_Try, /*On fail goto*//*Label 22543*/ GIMT_Encode4(1635953), // Rule ID 4226 //
     /* 1635872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1635883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1635886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635918 */     // MIs[0] policy
     /* 1635918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635928 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1635931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635952 */     // GIR_Coverage, 4226,
     /* 1635952 */     GIR_EraseRootFromParent_Done,
     /* 1635953 */   // Label 22543: @1635953
     /* 1635953 */   GIM_Try, /*On fail goto*//*Label 22544*/ GIMT_Encode4(1636039), // Rule ID 4227 //
     /* 1635958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1635969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1635972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636004 */     // MIs[0] policy
     /* 1636004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636014 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1636017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636038 */     // GIR_Coverage, 4227,
     /* 1636038 */     GIR_EraseRootFromParent_Done,
     /* 1636039 */   // Label 22544: @1636039
     /* 1636039 */   GIM_Try, /*On fail goto*//*Label 22545*/ GIMT_Encode4(1636125), // Rule ID 4230 //
     /* 1636044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1636055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1636058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1636061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636090 */     // MIs[0] policy
     /* 1636090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1636103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636124 */     // GIR_Coverage, 4230,
     /* 1636124 */     GIR_EraseRootFromParent_Done,
     /* 1636125 */   // Label 22545: @1636125
     /* 1636125 */   GIM_Try, /*On fail goto*//*Label 22546*/ GIMT_Encode4(1636211), // Rule ID 4231 //
     /* 1636130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1636141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1636144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1636147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636176 */     // MIs[0] policy
     /* 1636176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636186 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1636189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636210 */     // GIR_Coverage, 4231,
     /* 1636210 */     GIR_EraseRootFromParent_Done,
     /* 1636211 */   // Label 22546: @1636211
     /* 1636211 */   GIM_Try, /*On fail goto*//*Label 22547*/ GIMT_Encode4(1636297), // Rule ID 4234 //
     /* 1636216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1636227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1636230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1636233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636262 */     // MIs[0] policy
     /* 1636262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636272 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1636275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636296 */     // GIR_Coverage, 4234,
     /* 1636296 */     GIR_EraseRootFromParent_Done,
     /* 1636297 */   // Label 22547: @1636297
     /* 1636297 */   GIM_Try, /*On fail goto*//*Label 22548*/ GIMT_Encode4(1636383), // Rule ID 4235 //
     /* 1636302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1636313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1636316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1636319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636348 */     // MIs[0] policy
     /* 1636348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636358 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1636361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636382 */     // GIR_Coverage, 4235,
     /* 1636382 */     GIR_EraseRootFromParent_Done,
     /* 1636383 */   // Label 22548: @1636383
     /* 1636383 */   GIM_Try, /*On fail goto*//*Label 22549*/ GIMT_Encode4(1636469), // Rule ID 4238 //
     /* 1636388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1636399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1636402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1636405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1636411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636434 */     // MIs[0] policy
     /* 1636434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636444 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1636447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636468 */     // GIR_Coverage, 4238,
     /* 1636468 */     GIR_EraseRootFromParent_Done,
     /* 1636469 */   // Label 22549: @1636469
     /* 1636469 */   GIM_Try, /*On fail goto*//*Label 22550*/ GIMT_Encode4(1636555), // Rule ID 4239 //
     /* 1636474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1636485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1636488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1636491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1636497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636520 */     // MIs[0] policy
     /* 1636520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636530 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1636533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636554 */     // GIR_Coverage, 4239,
     /* 1636554 */     GIR_EraseRootFromParent_Done,
     /* 1636555 */   // Label 22550: @1636555
     /* 1636555 */   GIM_Try, /*On fail goto*//*Label 22551*/ GIMT_Encode4(1636641), // Rule ID 4242 //
     /* 1636560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1636571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1636574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1636577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1636583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636606 */     // MIs[0] policy
     /* 1636606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636616 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1636619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636640 */     // GIR_Coverage, 4242,
     /* 1636640 */     GIR_EraseRootFromParent_Done,
     /* 1636641 */   // Label 22551: @1636641
     /* 1636641 */   GIM_Try, /*On fail goto*//*Label 22552*/ GIMT_Encode4(1636727), // Rule ID 4243 //
     /* 1636646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1636657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1636660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1636663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1636669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636692 */     // MIs[0] policy
     /* 1636692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636702 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1636705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636726 */     // GIR_Coverage, 4243,
     /* 1636726 */     GIR_EraseRootFromParent_Done,
     /* 1636727 */   // Label 22552: @1636727
     /* 1636727 */   GIM_Try, /*On fail goto*//*Label 22553*/ GIMT_Encode4(1636813), // Rule ID 4246 //
     /* 1636732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1636743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1636746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1636749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636778 */     // MIs[0] policy
     /* 1636778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636788 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1636791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636812 */     // GIR_Coverage, 4246,
     /* 1636812 */     GIR_EraseRootFromParent_Done,
     /* 1636813 */   // Label 22553: @1636813
     /* 1636813 */   GIM_Try, /*On fail goto*//*Label 22554*/ GIMT_Encode4(1636899), // Rule ID 4247 //
     /* 1636818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1636829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1636832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1636835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636864 */     // MIs[0] policy
     /* 1636864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636874 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1636877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636898 */     // GIR_Coverage, 4247,
     /* 1636898 */     GIR_EraseRootFromParent_Done,
     /* 1636899 */   // Label 22554: @1636899
     /* 1636899 */   GIM_Try, /*On fail goto*//*Label 22555*/ GIMT_Encode4(1636985), // Rule ID 4250 //
     /* 1636904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1636915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1636918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636950 */     // MIs[0] policy
     /* 1636950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636960 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1636963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636984 */     // GIR_Coverage, 4250,
     /* 1636984 */     GIR_EraseRootFromParent_Done,
     /* 1636985 */   // Label 22555: @1636985
     /* 1636985 */   GIM_Try, /*On fail goto*//*Label 22556*/ GIMT_Encode4(1637071), // Rule ID 4251 //
     /* 1636990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1637001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1637004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1637007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637036 */     // MIs[0] policy
     /* 1637036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1637049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637070 */     // GIR_Coverage, 4251,
     /* 1637070 */     GIR_EraseRootFromParent_Done,
     /* 1637071 */   // Label 22556: @1637071
     /* 1637071 */   GIM_Try, /*On fail goto*//*Label 22557*/ GIMT_Encode4(1637157), // Rule ID 4254 //
     /* 1637076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1637087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1637090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1637093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637122 */     // MIs[0] policy
     /* 1637122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637132 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1637135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637156 */     // GIR_Coverage, 4254,
     /* 1637156 */     GIR_EraseRootFromParent_Done,
     /* 1637157 */   // Label 22557: @1637157
     /* 1637157 */   GIM_Try, /*On fail goto*//*Label 22558*/ GIMT_Encode4(1637243), // Rule ID 4255 //
     /* 1637162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1637173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1637176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1637179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637208 */     // MIs[0] policy
     /* 1637208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1637221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637242 */     // GIR_Coverage, 4255,
     /* 1637242 */     GIR_EraseRootFromParent_Done,
     /* 1637243 */   // Label 22558: @1637243
     /* 1637243 */   GIM_Try, /*On fail goto*//*Label 22559*/ GIMT_Encode4(1637329), // Rule ID 4258 //
     /* 1637248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1637259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1637262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1637265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637294 */     // MIs[0] policy
     /* 1637294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637304 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1637307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637328 */     // GIR_Coverage, 4258,
     /* 1637328 */     GIR_EraseRootFromParent_Done,
     /* 1637329 */   // Label 22559: @1637329
     /* 1637329 */   GIM_Try, /*On fail goto*//*Label 22560*/ GIMT_Encode4(1637415), // Rule ID 4259 //
     /* 1637334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1637345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1637348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1637351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637380 */     // MIs[0] policy
     /* 1637380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637390 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1637393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637414 */     // GIR_Coverage, 4259,
     /* 1637414 */     GIR_EraseRootFromParent_Done,
     /* 1637415 */   // Label 22560: @1637415
     /* 1637415 */   GIM_Try, /*On fail goto*//*Label 22561*/ GIMT_Encode4(1637501), // Rule ID 4262 //
     /* 1637420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1637431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1637434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1637437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637466 */     // MIs[0] policy
     /* 1637466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637476 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1637479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637500 */     // GIR_Coverage, 4262,
     /* 1637500 */     GIR_EraseRootFromParent_Done,
     /* 1637501 */   // Label 22561: @1637501
     /* 1637501 */   GIM_Try, /*On fail goto*//*Label 22562*/ GIMT_Encode4(1637587), // Rule ID 4263 //
     /* 1637506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1637517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1637520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1637523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637552 */     // MIs[0] policy
     /* 1637552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1637565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637586 */     // GIR_Coverage, 4263,
     /* 1637586 */     GIR_EraseRootFromParent_Done,
     /* 1637587 */   // Label 22562: @1637587
     /* 1637587 */   GIM_Try, /*On fail goto*//*Label 22563*/ GIMT_Encode4(1637673), // Rule ID 4266 //
     /* 1637592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1637603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1637606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1637609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637638 */     // MIs[0] policy
     /* 1637638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637648 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1637651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637672 */     // GIR_Coverage, 4266,
     /* 1637672 */     GIR_EraseRootFromParent_Done,
     /* 1637673 */   // Label 22563: @1637673
     /* 1637673 */   GIM_Try, /*On fail goto*//*Label 22564*/ GIMT_Encode4(1637759), // Rule ID 4267 //
     /* 1637678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1637689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1637692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1637695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637724 */     // MIs[0] policy
     /* 1637724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637734 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1637737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637758 */     // GIR_Coverage, 4267,
     /* 1637758 */     GIR_EraseRootFromParent_Done,
     /* 1637759 */   // Label 22564: @1637759
     /* 1637759 */   GIM_Try, /*On fail goto*//*Label 22565*/ GIMT_Encode4(1637845), // Rule ID 4270 //
     /* 1637764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1637775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1637778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1637781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637810 */     // MIs[0] policy
     /* 1637810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637820 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1637823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637844 */     // GIR_Coverage, 4270,
     /* 1637844 */     GIR_EraseRootFromParent_Done,
     /* 1637845 */   // Label 22565: @1637845
     /* 1637845 */   GIM_Try, /*On fail goto*//*Label 22566*/ GIMT_Encode4(1637931), // Rule ID 4271 //
     /* 1637850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1637861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1637864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1637867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637896 */     // MIs[0] policy
     /* 1637896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1637909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637930 */     // GIR_Coverage, 4271,
     /* 1637930 */     GIR_EraseRootFromParent_Done,
     /* 1637931 */   // Label 22566: @1637931
     /* 1637931 */   GIM_Try, /*On fail goto*//*Label 22567*/ GIMT_Encode4(1638017), // Rule ID 4274 //
     /* 1637936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1637947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1637950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1637953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637982 */     // MIs[0] policy
     /* 1637982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637992 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1637995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638016 */     // GIR_Coverage, 4274,
     /* 1638016 */     GIR_EraseRootFromParent_Done,
     /* 1638017 */   // Label 22567: @1638017
     /* 1638017 */   GIM_Try, /*On fail goto*//*Label 22568*/ GIMT_Encode4(1638103), // Rule ID 4275 //
     /* 1638022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1638033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1638036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1638039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638068 */     // MIs[0] policy
     /* 1638068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638078 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1638081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638102 */     // GIR_Coverage, 4275,
     /* 1638102 */     GIR_EraseRootFromParent_Done,
     /* 1638103 */   // Label 22568: @1638103
     /* 1638103 */   GIM_Try, /*On fail goto*//*Label 22569*/ GIMT_Encode4(1638189), // Rule ID 4278 //
     /* 1638108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1638111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1638119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1638122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1638125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1638128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638154 */     // MIs[0] policy
     /* 1638154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638164 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1638167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638188 */     // GIR_Coverage, 4278,
     /* 1638188 */     GIR_EraseRootFromParent_Done,
     /* 1638189 */   // Label 22569: @1638189
     /* 1638189 */   GIM_Try, /*On fail goto*//*Label 22570*/ GIMT_Encode4(1638275), // Rule ID 4279 //
     /* 1638194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1638205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1638208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1638211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638240 */     // MIs[0] policy
     /* 1638240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638250 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1638253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638274 */     // GIR_Coverage, 4279,
     /* 1638274 */     GIR_EraseRootFromParent_Done,
     /* 1638275 */   // Label 22570: @1638275
     /* 1638275 */   GIM_Try, /*On fail goto*//*Label 22571*/ GIMT_Encode4(1638361), // Rule ID 4288 //
     /* 1638280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1638291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1638294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1638297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1638300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638326 */     // MIs[0] policy
     /* 1638326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638336 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1638339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638360 */     // GIR_Coverage, 4288,
     /* 1638360 */     GIR_EraseRootFromParent_Done,
     /* 1638361 */   // Label 22571: @1638361
     /* 1638361 */   GIM_Try, /*On fail goto*//*Label 22572*/ GIMT_Encode4(1638447), // Rule ID 4289 //
     /* 1638366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1638377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1638380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1638383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1638386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638412 */     // MIs[0] policy
     /* 1638412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638422 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1638425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638446 */     // GIR_Coverage, 4289,
     /* 1638446 */     GIR_EraseRootFromParent_Done,
     /* 1638447 */   // Label 22572: @1638447
     /* 1638447 */   GIM_Try, /*On fail goto*//*Label 22573*/ GIMT_Encode4(1638533), // Rule ID 4298 //
     /* 1638452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1638463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1638466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1638469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1638472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638498 */     // MIs[0] policy
     /* 1638498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638508 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1638511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638532 */     // GIR_Coverage, 4298,
     /* 1638532 */     GIR_EraseRootFromParent_Done,
     /* 1638533 */   // Label 22573: @1638533
     /* 1638533 */   GIM_Try, /*On fail goto*//*Label 22574*/ GIMT_Encode4(1638619), // Rule ID 4299 //
     /* 1638538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1638549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1638552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1638555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1638558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638584 */     // MIs[0] policy
     /* 1638584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638594 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1638597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638618 */     // GIR_Coverage, 4299,
     /* 1638618 */     GIR_EraseRootFromParent_Done,
     /* 1638619 */   // Label 22574: @1638619
     /* 1638619 */   GIM_Try, /*On fail goto*//*Label 22575*/ GIMT_Encode4(1638705), // Rule ID 4308 //
     /* 1638624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1638635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1638638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1638641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1638644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638670 */     // MIs[0] policy
     /* 1638670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638680 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1638683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638704 */     // GIR_Coverage, 4308,
     /* 1638704 */     GIR_EraseRootFromParent_Done,
     /* 1638705 */   // Label 22575: @1638705
     /* 1638705 */   GIM_Try, /*On fail goto*//*Label 22576*/ GIMT_Encode4(1638791), // Rule ID 4309 //
     /* 1638710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1638721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1638724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1638727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1638730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638756 */     // MIs[0] policy
     /* 1638756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638766 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1638769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638790 */     // GIR_Coverage, 4309,
     /* 1638790 */     GIR_EraseRootFromParent_Done,
     /* 1638791 */   // Label 22576: @1638791
     /* 1638791 */   GIM_Try, /*On fail goto*//*Label 22577*/ GIMT_Encode4(1638877), // Rule ID 4318 //
     /* 1638796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1638807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1638810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1638813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1638816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638842 */     // MIs[0] policy
     /* 1638842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1638855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638876 */     // GIR_Coverage, 4318,
     /* 1638876 */     GIR_EraseRootFromParent_Done,
     /* 1638877 */   // Label 22577: @1638877
     /* 1638877 */   GIM_Try, /*On fail goto*//*Label 22578*/ GIMT_Encode4(1638963), // Rule ID 4319 //
     /* 1638882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1638893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1638896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1638899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1638902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638928 */     // MIs[0] policy
     /* 1638928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638938 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1638941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638962 */     // GIR_Coverage, 4319,
     /* 1638962 */     GIR_EraseRootFromParent_Done,
     /* 1638963 */   // Label 22578: @1638963
     /* 1638963 */   GIM_Try, /*On fail goto*//*Label 22579*/ GIMT_Encode4(1639049), // Rule ID 4328 //
     /* 1638968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1638979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1638982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1638985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1638988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639014 */     // MIs[0] policy
     /* 1639014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639024 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1639027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639048 */     // GIR_Coverage, 4328,
     /* 1639048 */     GIR_EraseRootFromParent_Done,
     /* 1639049 */   // Label 22579: @1639049
     /* 1639049 */   GIM_Try, /*On fail goto*//*Label 22580*/ GIMT_Encode4(1639135), // Rule ID 4329 //
     /* 1639054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1639065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1639068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1639071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1639074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1639077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639100 */     // MIs[0] policy
     /* 1639100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639110 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1639113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639134 */     // GIR_Coverage, 4329,
     /* 1639134 */     GIR_EraseRootFromParent_Done,
     /* 1639135 */   // Label 22580: @1639135
     /* 1639135 */   GIM_Try, /*On fail goto*//*Label 22581*/ GIMT_Encode4(1639221), // Rule ID 4338 //
     /* 1639140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1639151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1639154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1639157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1639160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1639163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639186 */     // MIs[0] policy
     /* 1639186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639196 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1639199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639220 */     // GIR_Coverage, 4338,
     /* 1639220 */     GIR_EraseRootFromParent_Done,
     /* 1639221 */   // Label 22581: @1639221
     /* 1639221 */   GIM_Try, /*On fail goto*//*Label 22582*/ GIMT_Encode4(1639307), // Rule ID 4339 //
     /* 1639226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1639237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1639240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1639243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1639246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1639249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639272 */     // MIs[0] policy
     /* 1639272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639282 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1639285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639306 */     // GIR_Coverage, 4339,
     /* 1639306 */     GIR_EraseRootFromParent_Done,
     /* 1639307 */   // Label 22582: @1639307
     /* 1639307 */   GIM_Try, /*On fail goto*//*Label 22583*/ GIMT_Encode4(1639393), // Rule ID 4348 //
     /* 1639312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1639323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1639326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1639329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1639332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639358 */     // MIs[0] policy
     /* 1639358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639368 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1639371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639392 */     // GIR_Coverage, 4348,
     /* 1639392 */     GIR_EraseRootFromParent_Done,
     /* 1639393 */   // Label 22583: @1639393
     /* 1639393 */   GIM_Try, /*On fail goto*//*Label 22584*/ GIMT_Encode4(1639479), // Rule ID 4349 //
     /* 1639398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1639409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1639412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1639415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1639418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639444 */     // MIs[0] policy
     /* 1639444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639454 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1639457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639478 */     // GIR_Coverage, 4349,
     /* 1639478 */     GIR_EraseRootFromParent_Done,
     /* 1639479 */   // Label 22584: @1639479
     /* 1639479 */   GIM_Try, /*On fail goto*//*Label 22585*/ GIMT_Encode4(1639565), // Rule ID 4358 //
     /* 1639484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1639495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1639498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1639501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1639504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639530 */     // MIs[0] policy
     /* 1639530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1639543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639564 */     // GIR_Coverage, 4358,
     /* 1639564 */     GIR_EraseRootFromParent_Done,
     /* 1639565 */   // Label 22585: @1639565
     /* 1639565 */   GIM_Try, /*On fail goto*//*Label 22586*/ GIMT_Encode4(1639651), // Rule ID 4359 //
     /* 1639570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1639581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1639584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1639587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1639590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639616 */     // MIs[0] policy
     /* 1639616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1639629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639650 */     // GIR_Coverage, 4359,
     /* 1639650 */     GIR_EraseRootFromParent_Done,
     /* 1639651 */   // Label 22586: @1639651
     /* 1639651 */   GIM_Try, /*On fail goto*//*Label 22587*/ GIMT_Encode4(1639737), // Rule ID 4368 //
     /* 1639656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1639667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1639670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1639673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1639676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639702 */     // MIs[0] policy
     /* 1639702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1639715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639736 */     // GIR_Coverage, 4368,
     /* 1639736 */     GIR_EraseRootFromParent_Done,
     /* 1639737 */   // Label 22587: @1639737
     /* 1639737 */   GIM_Try, /*On fail goto*//*Label 22588*/ GIMT_Encode4(1639823), // Rule ID 4369 //
     /* 1639742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1639753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1639756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1639759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1639762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639788 */     // MIs[0] policy
     /* 1639788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1639801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639822 */     // GIR_Coverage, 4369,
     /* 1639822 */     GIR_EraseRootFromParent_Done,
     /* 1639823 */   // Label 22588: @1639823
     /* 1639823 */   GIM_Try, /*On fail goto*//*Label 22589*/ GIMT_Encode4(1639909), // Rule ID 4378 //
     /* 1639828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1639839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1639842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1639845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1639848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639874 */     // MIs[0] policy
     /* 1639874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1639887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639908 */     // GIR_Coverage, 4378,
     /* 1639908 */     GIR_EraseRootFromParent_Done,
     /* 1639909 */   // Label 22589: @1639909
     /* 1639909 */   GIM_Try, /*On fail goto*//*Label 22590*/ GIMT_Encode4(1639995), // Rule ID 4379 //
     /* 1639914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1639925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1639928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1639931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1639934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639960 */     // MIs[0] policy
     /* 1639960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639970 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1639973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639994 */     // GIR_Coverage, 4379,
     /* 1639994 */     GIR_EraseRootFromParent_Done,
     /* 1639995 */   // Label 22590: @1639995
     /* 1639995 */   GIM_Try, /*On fail goto*//*Label 22591*/ GIMT_Encode4(1640081), // Rule ID 4388 //
     /* 1640000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1640011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1640014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1640017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1640020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1640023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640046 */     // MIs[0] policy
     /* 1640046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640056 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1640059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640080 */     // GIR_Coverage, 4388,
     /* 1640080 */     GIR_EraseRootFromParent_Done,
     /* 1640081 */   // Label 22591: @1640081
     /* 1640081 */   GIM_Try, /*On fail goto*//*Label 22592*/ GIMT_Encode4(1640167), // Rule ID 4389 //
     /* 1640086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1640097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1640100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1640103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1640106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1640109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640132 */     // MIs[0] policy
     /* 1640132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640142 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1640145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640166 */     // GIR_Coverage, 4389,
     /* 1640166 */     GIR_EraseRootFromParent_Done,
     /* 1640167 */   // Label 22592: @1640167
     /* 1640167 */   GIM_Try, /*On fail goto*//*Label 22593*/ GIMT_Encode4(1640253), // Rule ID 4398 //
     /* 1640172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1640183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1640186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1640189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1640192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640218 */     // MIs[0] policy
     /* 1640218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640228 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1640231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640252 */     // GIR_Coverage, 4398,
     /* 1640252 */     GIR_EraseRootFromParent_Done,
     /* 1640253 */   // Label 22593: @1640253
     /* 1640253 */   GIM_Try, /*On fail goto*//*Label 22594*/ GIMT_Encode4(1640339), // Rule ID 4399 //
     /* 1640258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1640269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1640272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1640275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1640278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640304 */     // MIs[0] policy
     /* 1640304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640314 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1640317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640338 */     // GIR_Coverage, 4399,
     /* 1640338 */     GIR_EraseRootFromParent_Done,
     /* 1640339 */   // Label 22594: @1640339
     /* 1640339 */   GIM_Try, /*On fail goto*//*Label 22595*/ GIMT_Encode4(1640425), // Rule ID 4408 //
     /* 1640344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1640355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1640358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1640361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1640364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640390 */     // MIs[0] policy
     /* 1640390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1640403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640424 */     // GIR_Coverage, 4408,
     /* 1640424 */     GIR_EraseRootFromParent_Done,
     /* 1640425 */   // Label 22595: @1640425
     /* 1640425 */   GIM_Try, /*On fail goto*//*Label 22596*/ GIMT_Encode4(1640511), // Rule ID 4409 //
     /* 1640430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1640441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1640444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1640447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1640450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640476 */     // MIs[0] policy
     /* 1640476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1640489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640510 */     // GIR_Coverage, 4409,
     /* 1640510 */     GIR_EraseRootFromParent_Done,
     /* 1640511 */   // Label 22596: @1640511
     /* 1640511 */   GIM_Try, /*On fail goto*//*Label 22597*/ GIMT_Encode4(1640597), // Rule ID 4418 //
     /* 1640516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1640527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1640530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1640533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1640536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640562 */     // MIs[0] policy
     /* 1640562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640572 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1640575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640596 */     // GIR_Coverage, 4418,
     /* 1640596 */     GIR_EraseRootFromParent_Done,
     /* 1640597 */   // Label 22597: @1640597
     /* 1640597 */   GIM_Try, /*On fail goto*//*Label 22598*/ GIMT_Encode4(1640683), // Rule ID 4419 //
     /* 1640602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1640613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1640616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1640619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1640622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640648 */     // MIs[0] policy
     /* 1640648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640658 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1640661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640682 */     // GIR_Coverage, 4419,
     /* 1640682 */     GIR_EraseRootFromParent_Done,
     /* 1640683 */   // Label 22598: @1640683
     /* 1640683 */   GIM_Try, /*On fail goto*//*Label 22599*/ GIMT_Encode4(1640769), // Rule ID 4428 //
     /* 1640688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1640699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1640702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1640705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1640708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640734 */     // MIs[0] policy
     /* 1640734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640744 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1640747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640768 */     // GIR_Coverage, 4428,
     /* 1640768 */     GIR_EraseRootFromParent_Done,
     /* 1640769 */   // Label 22599: @1640769
     /* 1640769 */   GIM_Try, /*On fail goto*//*Label 22600*/ GIMT_Encode4(1640855), // Rule ID 4429 //
     /* 1640774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1640785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1640788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1640791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1640794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640820 */     // MIs[0] policy
     /* 1640820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640830 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1640833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640854 */     // GIR_Coverage, 4429,
     /* 1640854 */     GIR_EraseRootFromParent_Done,
     /* 1640855 */   // Label 22600: @1640855
     /* 1640855 */   GIM_Try, /*On fail goto*//*Label 22601*/ GIMT_Encode4(1640941), // Rule ID 4432 //
     /* 1640860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1640871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1640874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1640877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640906 */     // MIs[0] policy
     /* 1640906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640916 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1640919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640940 */     // GIR_Coverage, 4432,
     /* 1640940 */     GIR_EraseRootFromParent_Done,
     /* 1640941 */   // Label 22601: @1640941
     /* 1640941 */   GIM_Try, /*On fail goto*//*Label 22602*/ GIMT_Encode4(1641027), // Rule ID 4433 //
     /* 1640946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1640957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1640960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1640963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640992 */     // MIs[0] policy
     /* 1640992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641002 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1641005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641026 */     // GIR_Coverage, 4433,
     /* 1641026 */     GIR_EraseRootFromParent_Done,
     /* 1641027 */   // Label 22602: @1641027
     /* 1641027 */   GIM_Try, /*On fail goto*//*Label 22603*/ GIMT_Encode4(1641113), // Rule ID 4436 //
     /* 1641032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1641043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1641046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1641049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641078 */     // MIs[0] policy
     /* 1641078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641088 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1641091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641112 */     // GIR_Coverage, 4436,
     /* 1641112 */     GIR_EraseRootFromParent_Done,
     /* 1641113 */   // Label 22603: @1641113
     /* 1641113 */   GIM_Try, /*On fail goto*//*Label 22604*/ GIMT_Encode4(1641199), // Rule ID 4437 //
     /* 1641118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1641129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1641132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1641135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641164 */     // MIs[0] policy
     /* 1641164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641174 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1641177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641198 */     // GIR_Coverage, 4437,
     /* 1641198 */     GIR_EraseRootFromParent_Done,
     /* 1641199 */   // Label 22604: @1641199
     /* 1641199 */   GIM_Try, /*On fail goto*//*Label 22605*/ GIMT_Encode4(1641285), // Rule ID 4440 //
     /* 1641204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1641215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1641218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1641221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641250 */     // MIs[0] policy
     /* 1641250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641260 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1641263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641284 */     // GIR_Coverage, 4440,
     /* 1641284 */     GIR_EraseRootFromParent_Done,
     /* 1641285 */   // Label 22605: @1641285
     /* 1641285 */   GIM_Try, /*On fail goto*//*Label 22606*/ GIMT_Encode4(1641371), // Rule ID 4441 //
     /* 1641290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1641301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1641304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1641307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641336 */     // MIs[0] policy
     /* 1641336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641346 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1641349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641370 */     // GIR_Coverage, 4441,
     /* 1641370 */     GIR_EraseRootFromParent_Done,
     /* 1641371 */   // Label 22606: @1641371
     /* 1641371 */   GIM_Try, /*On fail goto*//*Label 22607*/ GIMT_Encode4(1641457), // Rule ID 4444 //
     /* 1641376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1641387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1641390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1641393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641422 */     // MIs[0] policy
     /* 1641422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641432 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1641435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641456 */     // GIR_Coverage, 4444,
     /* 1641456 */     GIR_EraseRootFromParent_Done,
     /* 1641457 */   // Label 22607: @1641457
     /* 1641457 */   GIM_Try, /*On fail goto*//*Label 22608*/ GIMT_Encode4(1641543), // Rule ID 4445 //
     /* 1641462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1641473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1641476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1641479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641508 */     // MIs[0] policy
     /* 1641508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641518 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1641521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641542 */     // GIR_Coverage, 4445,
     /* 1641542 */     GIR_EraseRootFromParent_Done,
     /* 1641543 */   // Label 22608: @1641543
     /* 1641543 */   GIM_Try, /*On fail goto*//*Label 22609*/ GIMT_Encode4(1641629), // Rule ID 4448 //
     /* 1641548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1641559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1641562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1641565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641594 */     // MIs[0] policy
     /* 1641594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641604 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1641607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641628 */     // GIR_Coverage, 4448,
     /* 1641628 */     GIR_EraseRootFromParent_Done,
     /* 1641629 */   // Label 22609: @1641629
     /* 1641629 */   GIM_Try, /*On fail goto*//*Label 22610*/ GIMT_Encode4(1641715), // Rule ID 4449 //
     /* 1641634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1641645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1641648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1641651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641680 */     // MIs[0] policy
     /* 1641680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641690 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1641693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641714 */     // GIR_Coverage, 4449,
     /* 1641714 */     GIR_EraseRootFromParent_Done,
     /* 1641715 */   // Label 22610: @1641715
     /* 1641715 */   GIM_Try, /*On fail goto*//*Label 22611*/ GIMT_Encode4(1641801), // Rule ID 4452 //
     /* 1641720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1641731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1641734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1641737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1641743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641766 */     // MIs[0] policy
     /* 1641766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1641779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641800 */     // GIR_Coverage, 4452,
     /* 1641800 */     GIR_EraseRootFromParent_Done,
     /* 1641801 */   // Label 22611: @1641801
     /* 1641801 */   GIM_Try, /*On fail goto*//*Label 22612*/ GIMT_Encode4(1641887), // Rule ID 4453 //
     /* 1641806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1641817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1641820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1641823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1641829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641852 */     // MIs[0] policy
     /* 1641852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641862 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1641865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641886 */     // GIR_Coverage, 4453,
     /* 1641886 */     GIR_EraseRootFromParent_Done,
     /* 1641887 */   // Label 22612: @1641887
     /* 1641887 */   GIM_Try, /*On fail goto*//*Label 22613*/ GIMT_Encode4(1641973), // Rule ID 4456 //
     /* 1641892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1641903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1641906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1641909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641938 */     // MIs[0] policy
     /* 1641938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641948 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1641951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641972 */     // GIR_Coverage, 4456,
     /* 1641972 */     GIR_EraseRootFromParent_Done,
     /* 1641973 */   // Label 22613: @1641973
     /* 1641973 */   GIM_Try, /*On fail goto*//*Label 22614*/ GIMT_Encode4(1642059), // Rule ID 4457 //
     /* 1641978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1641989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1641992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1641995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642024 */     // MIs[0] policy
     /* 1642024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1642037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642058 */     // GIR_Coverage, 4457,
     /* 1642058 */     GIR_EraseRootFromParent_Done,
     /* 1642059 */   // Label 22614: @1642059
     /* 1642059 */   GIM_Try, /*On fail goto*//*Label 22615*/ GIMT_Encode4(1642145), // Rule ID 4460 //
     /* 1642064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1642075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1642078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1642081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642110 */     // MIs[0] policy
     /* 1642110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642120 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1642123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642144 */     // GIR_Coverage, 4460,
     /* 1642144 */     GIR_EraseRootFromParent_Done,
     /* 1642145 */   // Label 22615: @1642145
     /* 1642145 */   GIM_Try, /*On fail goto*//*Label 22616*/ GIMT_Encode4(1642231), // Rule ID 4461 //
     /* 1642150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1642161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1642164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1642167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642196 */     // MIs[0] policy
     /* 1642196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642206 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1642209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642230 */     // GIR_Coverage, 4461,
     /* 1642230 */     GIR_EraseRootFromParent_Done,
     /* 1642231 */   // Label 22616: @1642231
     /* 1642231 */   GIM_Try, /*On fail goto*//*Label 22617*/ GIMT_Encode4(1642317), // Rule ID 4464 //
     /* 1642236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1642247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1642250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1642253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642282 */     // MIs[0] policy
     /* 1642282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1642295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642316 */     // GIR_Coverage, 4464,
     /* 1642316 */     GIR_EraseRootFromParent_Done,
     /* 1642317 */   // Label 22617: @1642317
     /* 1642317 */   GIM_Try, /*On fail goto*//*Label 22618*/ GIMT_Encode4(1642403), // Rule ID 4465 //
     /* 1642322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1642333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1642336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1642339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642368 */     // MIs[0] policy
     /* 1642368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642378 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1642381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642402 */     // GIR_Coverage, 4465,
     /* 1642402 */     GIR_EraseRootFromParent_Done,
     /* 1642403 */   // Label 22618: @1642403
     /* 1642403 */   GIM_Try, /*On fail goto*//*Label 22619*/ GIMT_Encode4(1642489), // Rule ID 4468 //
     /* 1642408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1642419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1642422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1642425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642454 */     // MIs[0] policy
     /* 1642454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1642467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642488 */     // GIR_Coverage, 4468,
     /* 1642488 */     GIR_EraseRootFromParent_Done,
     /* 1642489 */   // Label 22619: @1642489
     /* 1642489 */   GIM_Try, /*On fail goto*//*Label 22620*/ GIMT_Encode4(1642575), // Rule ID 4469 //
     /* 1642494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1642505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1642508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1642511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642540 */     // MIs[0] policy
     /* 1642540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642550 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1642553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642574 */     // GIR_Coverage, 4469,
     /* 1642574 */     GIR_EraseRootFromParent_Done,
     /* 1642575 */   // Label 22620: @1642575
     /* 1642575 */   GIM_Try, /*On fail goto*//*Label 22621*/ GIMT_Encode4(1642661), // Rule ID 4472 //
     /* 1642580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1642591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1642594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1642597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642626 */     // MIs[0] policy
     /* 1642626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642636 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1642639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642660 */     // GIR_Coverage, 4472,
     /* 1642660 */     GIR_EraseRootFromParent_Done,
     /* 1642661 */   // Label 22621: @1642661
     /* 1642661 */   GIM_Try, /*On fail goto*//*Label 22622*/ GIMT_Encode4(1642747), // Rule ID 4473 //
     /* 1642666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1642677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1642680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1642683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642712 */     // MIs[0] policy
     /* 1642712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1642725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642746 */     // GIR_Coverage, 4473,
     /* 1642746 */     GIR_EraseRootFromParent_Done,
     /* 1642747 */   // Label 22622: @1642747
     /* 1642747 */   GIM_Try, /*On fail goto*//*Label 22623*/ GIMT_Encode4(1642833), // Rule ID 4476 //
     /* 1642752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1642763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1642766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1642769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642798 */     // MIs[0] policy
     /* 1642798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1642811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642832 */     // GIR_Coverage, 4476,
     /* 1642832 */     GIR_EraseRootFromParent_Done,
     /* 1642833 */   // Label 22623: @1642833
     /* 1642833 */   GIM_Try, /*On fail goto*//*Label 22624*/ GIMT_Encode4(1642919), // Rule ID 4477 //
     /* 1642838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1642841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1642849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1642852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1642855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642884 */     // MIs[0] policy
     /* 1642884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642894 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1642897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642918 */     // GIR_Coverage, 4477,
     /* 1642918 */     GIR_EraseRootFromParent_Done,
     /* 1642919 */   // Label 22624: @1642919
     /* 1642919 */   GIM_Try, /*On fail goto*//*Label 22625*/ GIMT_Encode4(1643005), // Rule ID 4480 //
     /* 1642924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1642935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1642938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1642941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642970 */     // MIs[0] policy
     /* 1642970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1642983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643004 */     // GIR_Coverage, 4480,
     /* 1643004 */     GIR_EraseRootFromParent_Done,
     /* 1643005 */   // Label 22625: @1643005
     /* 1643005 */   GIM_Try, /*On fail goto*//*Label 22626*/ GIMT_Encode4(1643091), // Rule ID 4481 //
     /* 1643010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1643021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1643024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1643027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643056 */     // MIs[0] policy
     /* 1643056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643066 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1643069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643090 */     // GIR_Coverage, 4481,
     /* 1643090 */     GIR_EraseRootFromParent_Done,
     /* 1643091 */   // Label 22626: @1643091
     /* 1643091 */   GIM_Try, /*On fail goto*//*Label 22627*/ GIMT_Encode4(1643177), // Rule ID 4484 //
     /* 1643096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1643099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1643107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1643110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1643113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643142 */     // MIs[0] policy
     /* 1643142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643152 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1643155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643176 */     // GIR_Coverage, 4484,
     /* 1643176 */     GIR_EraseRootFromParent_Done,
     /* 1643177 */   // Label 22627: @1643177
     /* 1643177 */   GIM_Try, /*On fail goto*//*Label 22628*/ GIMT_Encode4(1643263), // Rule ID 4485 //
     /* 1643182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1643193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1643196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1643199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643228 */     // MIs[0] policy
     /* 1643228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643238 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1643241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643262 */     // GIR_Coverage, 4485,
     /* 1643262 */     GIR_EraseRootFromParent_Done,
     /* 1643263 */   // Label 22628: @1643263
     /* 1643263 */   GIM_Try, /*On fail goto*//*Label 22629*/ GIMT_Encode4(1643349), // Rule ID 4488 //
     /* 1643268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1643271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1643279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1643282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1643285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643314 */     // MIs[0] policy
     /* 1643314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643324 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1643327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643348 */     // GIR_Coverage, 4488,
     /* 1643348 */     GIR_EraseRootFromParent_Done,
     /* 1643349 */   // Label 22629: @1643349
     /* 1643349 */   GIM_Try, /*On fail goto*//*Label 22630*/ GIMT_Encode4(1643435), // Rule ID 4489 //
     /* 1643354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1643365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1643368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1643371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643400 */     // MIs[0] policy
     /* 1643400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643410 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1643413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643434 */     // GIR_Coverage, 4489,
     /* 1643434 */     GIR_EraseRootFromParent_Done,
     /* 1643435 */   // Label 22630: @1643435
     /* 1643435 */   GIM_Try, /*On fail goto*//*Label 22631*/ GIMT_Encode4(1643521), // Rule ID 4498 //
     /* 1643440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1643451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1643454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1643457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1643460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643486 */     // MIs[0] policy
     /* 1643486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643496 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1643499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643520 */     // GIR_Coverage, 4498,
     /* 1643520 */     GIR_EraseRootFromParent_Done,
     /* 1643521 */   // Label 22631: @1643521
     /* 1643521 */   GIM_Try, /*On fail goto*//*Label 22632*/ GIMT_Encode4(1643607), // Rule ID 4499 //
     /* 1643526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1643537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1643540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1643543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1643546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643572 */     // MIs[0] policy
     /* 1643572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643582 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1643585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643606 */     // GIR_Coverage, 4499,
     /* 1643606 */     GIR_EraseRootFromParent_Done,
     /* 1643607 */   // Label 22632: @1643607
     /* 1643607 */   GIM_Try, /*On fail goto*//*Label 22633*/ GIMT_Encode4(1643693), // Rule ID 4508 //
     /* 1643612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1643623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1643626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1643629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1643632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643658 */     // MIs[0] policy
     /* 1643658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643668 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1643671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643692 */     // GIR_Coverage, 4508,
     /* 1643692 */     GIR_EraseRootFromParent_Done,
     /* 1643693 */   // Label 22633: @1643693
     /* 1643693 */   GIM_Try, /*On fail goto*//*Label 22634*/ GIMT_Encode4(1643779), // Rule ID 4509 //
     /* 1643698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1643709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1643712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1643715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1643718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643744 */     // MIs[0] policy
     /* 1643744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643754 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1643757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643778 */     // GIR_Coverage, 4509,
     /* 1643778 */     GIR_EraseRootFromParent_Done,
     /* 1643779 */   // Label 22634: @1643779
     /* 1643779 */   GIM_Try, /*On fail goto*//*Label 22635*/ GIMT_Encode4(1643865), // Rule ID 4518 //
     /* 1643784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1643795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1643798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1643801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1643804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643830 */     // MIs[0] policy
     /* 1643830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643840 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1643843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643864 */     // GIR_Coverage, 4518,
     /* 1643864 */     GIR_EraseRootFromParent_Done,
     /* 1643865 */   // Label 22635: @1643865
     /* 1643865 */   GIM_Try, /*On fail goto*//*Label 22636*/ GIMT_Encode4(1643951), // Rule ID 4519 //
     /* 1643870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1643881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1643884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1643887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1643890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643916 */     // MIs[0] policy
     /* 1643916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643926 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1643929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643950 */     // GIR_Coverage, 4519,
     /* 1643950 */     GIR_EraseRootFromParent_Done,
     /* 1643951 */   // Label 22636: @1643951
     /* 1643951 */   GIM_Try, /*On fail goto*//*Label 22637*/ GIMT_Encode4(1644037), // Rule ID 4528 //
     /* 1643956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1643967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1643970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1643973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1643976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644002 */     // MIs[0] policy
     /* 1644002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644012 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1644015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644036 */     // GIR_Coverage, 4528,
     /* 1644036 */     GIR_EraseRootFromParent_Done,
     /* 1644037 */   // Label 22637: @1644037
     /* 1644037 */   GIM_Try, /*On fail goto*//*Label 22638*/ GIMT_Encode4(1644123), // Rule ID 4529 //
     /* 1644042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1644053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1644056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1644059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1644062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644088 */     // MIs[0] policy
     /* 1644088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1644101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644122 */     // GIR_Coverage, 4529,
     /* 1644122 */     GIR_EraseRootFromParent_Done,
     /* 1644123 */   // Label 22638: @1644123
     /* 1644123 */   GIM_Try, /*On fail goto*//*Label 22639*/ GIMT_Encode4(1644209), // Rule ID 4538 //
     /* 1644128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1644139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1644142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1644145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1644148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644174 */     // MIs[0] policy
     /* 1644174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644184 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1644187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644208 */     // GIR_Coverage, 4538,
     /* 1644208 */     GIR_EraseRootFromParent_Done,
     /* 1644209 */   // Label 22639: @1644209
     /* 1644209 */   GIM_Try, /*On fail goto*//*Label 22640*/ GIMT_Encode4(1644295), // Rule ID 4539 //
     /* 1644214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1644225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1644228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1644231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1644234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644260 */     // MIs[0] policy
     /* 1644260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644270 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1644273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644294 */     // GIR_Coverage, 4539,
     /* 1644294 */     GIR_EraseRootFromParent_Done,
     /* 1644295 */   // Label 22640: @1644295
     /* 1644295 */   GIM_Try, /*On fail goto*//*Label 22641*/ GIMT_Encode4(1644381), // Rule ID 4548 //
     /* 1644300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1644311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1644314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1644317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1644320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1644323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644346 */     // MIs[0] policy
     /* 1644346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644356 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1644359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644380 */     // GIR_Coverage, 4548,
     /* 1644380 */     GIR_EraseRootFromParent_Done,
     /* 1644381 */   // Label 22641: @1644381
     /* 1644381 */   GIM_Try, /*On fail goto*//*Label 22642*/ GIMT_Encode4(1644467), // Rule ID 4549 //
     /* 1644386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1644397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1644400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1644403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1644406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1644409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644432 */     // MIs[0] policy
     /* 1644432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644442 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1644445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644466 */     // GIR_Coverage, 4549,
     /* 1644466 */     GIR_EraseRootFromParent_Done,
     /* 1644467 */   // Label 22642: @1644467
     /* 1644467 */   GIM_Try, /*On fail goto*//*Label 22643*/ GIMT_Encode4(1644553), // Rule ID 4558 //
     /* 1644472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1644483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1644486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1644489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1644492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644518 */     // MIs[0] policy
     /* 1644518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644528 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1644531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644552 */     // GIR_Coverage, 4558,
     /* 1644552 */     GIR_EraseRootFromParent_Done,
     /* 1644553 */   // Label 22643: @1644553
     /* 1644553 */   GIM_Try, /*On fail goto*//*Label 22644*/ GIMT_Encode4(1644639), // Rule ID 4559 //
     /* 1644558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1644569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1644572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1644575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1644578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644604 */     // MIs[0] policy
     /* 1644604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644614 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1644617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644638 */     // GIR_Coverage, 4559,
     /* 1644638 */     GIR_EraseRootFromParent_Done,
     /* 1644639 */   // Label 22644: @1644639
     /* 1644639 */   GIM_Try, /*On fail goto*//*Label 22645*/ GIMT_Encode4(1644725), // Rule ID 4568 //
     /* 1644644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1644655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1644658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1644661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1644664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644690 */     // MIs[0] policy
     /* 1644690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1644703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644724 */     // GIR_Coverage, 4568,
     /* 1644724 */     GIR_EraseRootFromParent_Done,
     /* 1644725 */   // Label 22645: @1644725
     /* 1644725 */   GIM_Try, /*On fail goto*//*Label 22646*/ GIMT_Encode4(1644811), // Rule ID 4569 //
     /* 1644730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1644741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1644744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1644747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1644750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644776 */     // MIs[0] policy
     /* 1644776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1644789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644810 */     // GIR_Coverage, 4569,
     /* 1644810 */     GIR_EraseRootFromParent_Done,
     /* 1644811 */   // Label 22646: @1644811
     /* 1644811 */   GIM_Try, /*On fail goto*//*Label 22647*/ GIMT_Encode4(1644897), // Rule ID 4578 //
     /* 1644816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1644827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1644830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1644833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1644836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644862 */     // MIs[0] policy
     /* 1644862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1644875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644896 */     // GIR_Coverage, 4578,
     /* 1644896 */     GIR_EraseRootFromParent_Done,
     /* 1644897 */   // Label 22647: @1644897
     /* 1644897 */   GIM_Try, /*On fail goto*//*Label 22648*/ GIMT_Encode4(1644983), // Rule ID 4579 //
     /* 1644902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1644913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1644916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1644919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1644922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644948 */     // MIs[0] policy
     /* 1644948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1644961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644982 */     // GIR_Coverage, 4579,
     /* 1644982 */     GIR_EraseRootFromParent_Done,
     /* 1644983 */   // Label 22648: @1644983
     /* 1644983 */   GIM_Try, /*On fail goto*//*Label 22649*/ GIMT_Encode4(1645069), // Rule ID 4588 //
     /* 1644988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1644999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1645002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1645005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1645008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645034 */     // MIs[0] policy
     /* 1645034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645044 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1645047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645068 */     // GIR_Coverage, 4588,
     /* 1645068 */     GIR_EraseRootFromParent_Done,
     /* 1645069 */   // Label 22649: @1645069
     /* 1645069 */   GIM_Try, /*On fail goto*//*Label 22650*/ GIMT_Encode4(1645155), // Rule ID 4589 //
     /* 1645074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1645085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1645088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1645091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1645094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645120 */     // MIs[0] policy
     /* 1645120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645130 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1645133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645154 */     // GIR_Coverage, 4589,
     /* 1645154 */     GIR_EraseRootFromParent_Done,
     /* 1645155 */   // Label 22650: @1645155
     /* 1645155 */   GIM_Try, /*On fail goto*//*Label 22651*/ GIMT_Encode4(1645241), // Rule ID 4598 //
     /* 1645160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1645171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1645174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1645177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1645180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645206 */     // MIs[0] policy
     /* 1645206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645216 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1645219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645240 */     // GIR_Coverage, 4598,
     /* 1645240 */     GIR_EraseRootFromParent_Done,
     /* 1645241 */   // Label 22651: @1645241
     /* 1645241 */   GIM_Try, /*On fail goto*//*Label 22652*/ GIMT_Encode4(1645327), // Rule ID 4599 //
     /* 1645246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1645257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1645260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1645263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1645266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645292 */     // MIs[0] policy
     /* 1645292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645302 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1645305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645326 */     // GIR_Coverage, 4599,
     /* 1645326 */     GIR_EraseRootFromParent_Done,
     /* 1645327 */   // Label 22652: @1645327
     /* 1645327 */   GIM_Try, /*On fail goto*//*Label 22653*/ GIMT_Encode4(1645413), // Rule ID 4608 //
     /* 1645332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1645343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1645346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1645349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1645352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645378 */     // MIs[0] policy
     /* 1645378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645388 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1645391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645412 */     // GIR_Coverage, 4608,
     /* 1645412 */     GIR_EraseRootFromParent_Done,
     /* 1645413 */   // Label 22653: @1645413
     /* 1645413 */   GIM_Try, /*On fail goto*//*Label 22654*/ GIMT_Encode4(1645499), // Rule ID 4609 //
     /* 1645418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1645429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1645432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1645435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1645438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645464 */     // MIs[0] policy
     /* 1645464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645474 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1645477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645498 */     // GIR_Coverage, 4609,
     /* 1645498 */     GIR_EraseRootFromParent_Done,
     /* 1645499 */   // Label 22654: @1645499
     /* 1645499 */   GIM_Try, /*On fail goto*//*Label 22655*/ GIMT_Encode4(1645585), // Rule ID 4618 //
     /* 1645504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1645515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1645518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1645521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1645524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645550 */     // MIs[0] policy
     /* 1645550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645560 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1645563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645584 */     // GIR_Coverage, 4618,
     /* 1645584 */     GIR_EraseRootFromParent_Done,
     /* 1645585 */   // Label 22655: @1645585
     /* 1645585 */   GIM_Try, /*On fail goto*//*Label 22656*/ GIMT_Encode4(1645671), // Rule ID 4619 //
     /* 1645590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1645601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1645604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1645607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1645610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645636 */     // MIs[0] policy
     /* 1645636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1645649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645670 */     // GIR_Coverage, 4619,
     /* 1645670 */     GIR_EraseRootFromParent_Done,
     /* 1645671 */   // Label 22656: @1645671
     /* 1645671 */   GIM_Try, /*On fail goto*//*Label 22657*/ GIMT_Encode4(1645757), // Rule ID 4628 //
     /* 1645676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1645687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1645690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1645693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1645696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645722 */     // MIs[0] policy
     /* 1645722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645732 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1645735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645756 */     // GIR_Coverage, 4628,
     /* 1645756 */     GIR_EraseRootFromParent_Done,
     /* 1645757 */   // Label 22657: @1645757
     /* 1645757 */   GIM_Try, /*On fail goto*//*Label 22658*/ GIMT_Encode4(1645843), // Rule ID 4629 //
     /* 1645762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1645773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1645776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1645779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1645782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645808 */     // MIs[0] policy
     /* 1645808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1645821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645842 */     // GIR_Coverage, 4629,
     /* 1645842 */     GIR_EraseRootFromParent_Done,
     /* 1645843 */   // Label 22658: @1645843
     /* 1645843 */   GIM_Try, /*On fail goto*//*Label 22659*/ GIMT_Encode4(1645929), // Rule ID 4638 //
     /* 1645848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1645859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1645862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1645865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1645868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645894 */     // MIs[0] policy
     /* 1645894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645904 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1645907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645928 */     // GIR_Coverage, 4638,
     /* 1645928 */     GIR_EraseRootFromParent_Done,
     /* 1645929 */   // Label 22659: @1645929
     /* 1645929 */   GIM_Try, /*On fail goto*//*Label 22660*/ GIMT_Encode4(1646015), // Rule ID 4639 //
     /* 1645934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1645945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1645948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1645951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1645954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645980 */     // MIs[0] policy
     /* 1645980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645990 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1645993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646014 */     // GIR_Coverage, 4639,
     /* 1646014 */     GIR_EraseRootFromParent_Done,
     /* 1646015 */   // Label 22660: @1646015
     /* 1646015 */   GIM_Try, /*On fail goto*//*Label 22661*/ GIMT_Encode4(1646101), // Rule ID 4642 //
     /* 1646020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1646031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1646034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1646037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646066 */     // MIs[0] policy
     /* 1646066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646076 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1646079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646100 */     // GIR_Coverage, 4642,
     /* 1646100 */     GIR_EraseRootFromParent_Done,
     /* 1646101 */   // Label 22661: @1646101
     /* 1646101 */   GIM_Try, /*On fail goto*//*Label 22662*/ GIMT_Encode4(1646187), // Rule ID 4643 //
     /* 1646106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1646117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1646120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1646123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646152 */     // MIs[0] policy
     /* 1646152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646162 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1646165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646186 */     // GIR_Coverage, 4643,
     /* 1646186 */     GIR_EraseRootFromParent_Done,
     /* 1646187 */   // Label 22662: @1646187
     /* 1646187 */   GIM_Try, /*On fail goto*//*Label 22663*/ GIMT_Encode4(1646273), // Rule ID 4646 //
     /* 1646192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1646203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1646206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1646209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646238 */     // MIs[0] policy
     /* 1646238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646248 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1646251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646272 */     // GIR_Coverage, 4646,
     /* 1646272 */     GIR_EraseRootFromParent_Done,
     /* 1646273 */   // Label 22663: @1646273
     /* 1646273 */   GIM_Try, /*On fail goto*//*Label 22664*/ GIMT_Encode4(1646359), // Rule ID 4647 //
     /* 1646278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1646289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1646292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1646295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646324 */     // MIs[0] policy
     /* 1646324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1646337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646358 */     // GIR_Coverage, 4647,
     /* 1646358 */     GIR_EraseRootFromParent_Done,
     /* 1646359 */   // Label 22664: @1646359
     /* 1646359 */   GIM_Try, /*On fail goto*//*Label 22665*/ GIMT_Encode4(1646445), // Rule ID 4650 //
     /* 1646364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1646375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1646378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1646381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646410 */     // MIs[0] policy
     /* 1646410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1646423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646444 */     // GIR_Coverage, 4650,
     /* 1646444 */     GIR_EraseRootFromParent_Done,
     /* 1646445 */   // Label 22665: @1646445
     /* 1646445 */   GIM_Try, /*On fail goto*//*Label 22666*/ GIMT_Encode4(1646531), // Rule ID 4651 //
     /* 1646450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1646461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1646464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1646467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646496 */     // MIs[0] policy
     /* 1646496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1646509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646530 */     // GIR_Coverage, 4651,
     /* 1646530 */     GIR_EraseRootFromParent_Done,
     /* 1646531 */   // Label 22666: @1646531
     /* 1646531 */   GIM_Try, /*On fail goto*//*Label 22667*/ GIMT_Encode4(1646617), // Rule ID 4654 //
     /* 1646536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1646547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1646550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1646553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646582 */     // MIs[0] policy
     /* 1646582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646592 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1646595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646616 */     // GIR_Coverage, 4654,
     /* 1646616 */     GIR_EraseRootFromParent_Done,
     /* 1646617 */   // Label 22667: @1646617
     /* 1646617 */   GIM_Try, /*On fail goto*//*Label 22668*/ GIMT_Encode4(1646703), // Rule ID 4655 //
     /* 1646622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1646633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1646636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1646639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646668 */     // MIs[0] policy
     /* 1646668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646678 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1646681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646702 */     // GIR_Coverage, 4655,
     /* 1646702 */     GIR_EraseRootFromParent_Done,
     /* 1646703 */   // Label 22668: @1646703
     /* 1646703 */   GIM_Try, /*On fail goto*//*Label 22669*/ GIMT_Encode4(1646789), // Rule ID 4658 //
     /* 1646708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1646719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1646722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1646725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1646731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646754 */     // MIs[0] policy
     /* 1646754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646764 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1646767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646788 */     // GIR_Coverage, 4658,
     /* 1646788 */     GIR_EraseRootFromParent_Done,
     /* 1646789 */   // Label 22669: @1646789
     /* 1646789 */   GIM_Try, /*On fail goto*//*Label 22670*/ GIMT_Encode4(1646875), // Rule ID 4659 //
     /* 1646794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1646805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1646808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1646811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1646817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646840 */     // MIs[0] policy
     /* 1646840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646850 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1646853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646874 */     // GIR_Coverage, 4659,
     /* 1646874 */     GIR_EraseRootFromParent_Done,
     /* 1646875 */   // Label 22670: @1646875
     /* 1646875 */   GIM_Try, /*On fail goto*//*Label 22671*/ GIMT_Encode4(1646961), // Rule ID 4662 //
     /* 1646880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1646891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1646894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1646897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1646903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646926 */     // MIs[0] policy
     /* 1646926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646936 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1646939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646960 */     // GIR_Coverage, 4662,
     /* 1646960 */     GIR_EraseRootFromParent_Done,
     /* 1646961 */   // Label 22671: @1646961
     /* 1646961 */   GIM_Try, /*On fail goto*//*Label 22672*/ GIMT_Encode4(1647047), // Rule ID 4663 //
     /* 1646966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1646977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1646980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1646983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1646989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647012 */     // MIs[0] policy
     /* 1647012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647022 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1647025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647046 */     // GIR_Coverage, 4663,
     /* 1647046 */     GIR_EraseRootFromParent_Done,
     /* 1647047 */   // Label 22672: @1647047
     /* 1647047 */   GIM_Try, /*On fail goto*//*Label 22673*/ GIMT_Encode4(1647133), // Rule ID 4666 //
     /* 1647052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1647063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1647066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1647069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647098 */     // MIs[0] policy
     /* 1647098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1647111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647132 */     // GIR_Coverage, 4666,
     /* 1647132 */     GIR_EraseRootFromParent_Done,
     /* 1647133 */   // Label 22673: @1647133
     /* 1647133 */   GIM_Try, /*On fail goto*//*Label 22674*/ GIMT_Encode4(1647219), // Rule ID 4667 //
     /* 1647138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1647149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1647152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1647155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647184 */     // MIs[0] policy
     /* 1647184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647194 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1647197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647218 */     // GIR_Coverage, 4667,
     /* 1647218 */     GIR_EraseRootFromParent_Done,
     /* 1647219 */   // Label 22674: @1647219
     /* 1647219 */   GIM_Try, /*On fail goto*//*Label 22675*/ GIMT_Encode4(1647305), // Rule ID 4670 //
     /* 1647224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1647235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1647238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1647241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647270 */     // MIs[0] policy
     /* 1647270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647280 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1647283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647304 */     // GIR_Coverage, 4670,
     /* 1647304 */     GIR_EraseRootFromParent_Done,
     /* 1647305 */   // Label 22675: @1647305
     /* 1647305 */   GIM_Try, /*On fail goto*//*Label 22676*/ GIMT_Encode4(1647391), // Rule ID 4671 //
     /* 1647310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1647321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1647324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1647327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647356 */     // MIs[0] policy
     /* 1647356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1647369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647390 */     // GIR_Coverage, 4671,
     /* 1647390 */     GIR_EraseRootFromParent_Done,
     /* 1647391 */   // Label 22676: @1647391
     /* 1647391 */   GIM_Try, /*On fail goto*//*Label 22677*/ GIMT_Encode4(1647477), // Rule ID 4674 //
     /* 1647396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1647407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1647410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1647413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647442 */     // MIs[0] policy
     /* 1647442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1647455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647476 */     // GIR_Coverage, 4674,
     /* 1647476 */     GIR_EraseRootFromParent_Done,
     /* 1647477 */   // Label 22677: @1647477
     /* 1647477 */   GIM_Try, /*On fail goto*//*Label 22678*/ GIMT_Encode4(1647563), // Rule ID 4675 //
     /* 1647482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1647493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1647496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1647499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647528 */     // MIs[0] policy
     /* 1647528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647538 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1647541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647562 */     // GIR_Coverage, 4675,
     /* 1647562 */     GIR_EraseRootFromParent_Done,
     /* 1647563 */   // Label 22678: @1647563
     /* 1647563 */   GIM_Try, /*On fail goto*//*Label 22679*/ GIMT_Encode4(1647649), // Rule ID 4678 //
     /* 1647568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1647579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1647582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1647585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647614 */     // MIs[0] policy
     /* 1647614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647624 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1647627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647648 */     // GIR_Coverage, 4678,
     /* 1647648 */     GIR_EraseRootFromParent_Done,
     /* 1647649 */   // Label 22679: @1647649
     /* 1647649 */   GIM_Try, /*On fail goto*//*Label 22680*/ GIMT_Encode4(1647735), // Rule ID 4679 //
     /* 1647654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1647665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1647668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1647671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647700 */     // MIs[0] policy
     /* 1647700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647710 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1647713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647734 */     // GIR_Coverage, 4679,
     /* 1647734 */     GIR_EraseRootFromParent_Done,
     /* 1647735 */   // Label 22680: @1647735
     /* 1647735 */   GIM_Try, /*On fail goto*//*Label 22681*/ GIMT_Encode4(1647821), // Rule ID 4682 //
     /* 1647740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1647751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1647754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1647757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647786 */     // MIs[0] policy
     /* 1647786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1647799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647820 */     // GIR_Coverage, 4682,
     /* 1647820 */     GIR_EraseRootFromParent_Done,
     /* 1647821 */   // Label 22681: @1647821
     /* 1647821 */   GIM_Try, /*On fail goto*//*Label 22682*/ GIMT_Encode4(1647907), // Rule ID 4683 //
     /* 1647826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1647837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1647840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1647843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647872 */     // MIs[0] policy
     /* 1647872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647882 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1647885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647906 */     // GIR_Coverage, 4683,
     /* 1647906 */     GIR_EraseRootFromParent_Done,
     /* 1647907 */   // Label 22682: @1647907
     /* 1647907 */   GIM_Try, /*On fail goto*//*Label 22683*/ GIMT_Encode4(1647993), // Rule ID 4686 //
     /* 1647912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1647915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1647923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1647926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1647929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647958 */     // MIs[0] policy
     /* 1647958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1647971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647992 */     // GIR_Coverage, 4686,
     /* 1647992 */     GIR_EraseRootFromParent_Done,
     /* 1647993 */   // Label 22683: @1647993
     /* 1647993 */   GIM_Try, /*On fail goto*//*Label 22684*/ GIMT_Encode4(1648079), // Rule ID 4687 //
     /* 1647998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1648009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1648012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1648015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648044 */     // MIs[0] policy
     /* 1648044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648054 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1648057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648078 */     // GIR_Coverage, 4687,
     /* 1648078 */     GIR_EraseRootFromParent_Done,
     /* 1648079 */   // Label 22684: @1648079
     /* 1648079 */   GIM_Try, /*On fail goto*//*Label 22685*/ GIMT_Encode4(1648165), // Rule ID 4690 //
     /* 1648084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1648087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1648095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1648098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1648101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1648104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648130 */     // MIs[0] policy
     /* 1648130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1648143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648164 */     // GIR_Coverage, 4690,
     /* 1648164 */     GIR_EraseRootFromParent_Done,
     /* 1648165 */   // Label 22685: @1648165
     /* 1648165 */   GIM_Try, /*On fail goto*//*Label 22686*/ GIMT_Encode4(1648251), // Rule ID 4691 //
     /* 1648170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1648181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1648184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1648187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648216 */     // MIs[0] policy
     /* 1648216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1648229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648250 */     // GIR_Coverage, 4691,
     /* 1648250 */     GIR_EraseRootFromParent_Done,
     /* 1648251 */   // Label 22686: @1648251
     /* 1648251 */   GIM_Try, /*On fail goto*//*Label 22687*/ GIMT_Encode4(1648337), // Rule ID 4694 //
     /* 1648256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1648259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1648267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1648270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1648273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1648276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648302 */     // MIs[0] policy
     /* 1648302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648312 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1648315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648336 */     // GIR_Coverage, 4694,
     /* 1648336 */     GIR_EraseRootFromParent_Done,
     /* 1648337 */   // Label 22687: @1648337
     /* 1648337 */   GIM_Try, /*On fail goto*//*Label 22688*/ GIMT_Encode4(1648423), // Rule ID 4695 //
     /* 1648342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1648353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1648356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1648359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648388 */     // MIs[0] policy
     /* 1648388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648398 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1648401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648422 */     // GIR_Coverage, 4695,
     /* 1648422 */     GIR_EraseRootFromParent_Done,
     /* 1648423 */   // Label 22688: @1648423
     /* 1648423 */   GIM_Try, /*On fail goto*//*Label 22689*/ GIMT_Encode4(1648509), // Rule ID 4698 //
     /* 1648428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1648431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1648439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1648442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1648445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1648448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648474 */     // MIs[0] policy
     /* 1648474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1648487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648508 */     // GIR_Coverage, 4698,
     /* 1648508 */     GIR_EraseRootFromParent_Done,
     /* 1648509 */   // Label 22689: @1648509
     /* 1648509 */   GIM_Try, /*On fail goto*//*Label 22690*/ GIMT_Encode4(1648595), // Rule ID 4699 //
     /* 1648514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1648525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1648528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1648531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648560 */     // MIs[0] policy
     /* 1648560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648570 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1648573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648594 */     // GIR_Coverage, 4699,
     /* 1648594 */     GIR_EraseRootFromParent_Done,
     /* 1648595 */   // Label 22690: @1648595
     /* 1648595 */   GIM_Try, /*On fail goto*//*Label 22691*/ GIMT_Encode4(1648681), // Rule ID 4708 //
     /* 1648600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1648611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1648614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1648617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1648620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648646 */     // MIs[0] policy
     /* 1648646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648656 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1648659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648680 */     // GIR_Coverage, 4708,
     /* 1648680 */     GIR_EraseRootFromParent_Done,
     /* 1648681 */   // Label 22691: @1648681
     /* 1648681 */   GIM_Try, /*On fail goto*//*Label 22692*/ GIMT_Encode4(1648767), // Rule ID 4709 //
     /* 1648686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1648697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1648700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1648703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1648706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648732 */     // MIs[0] policy
     /* 1648732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648742 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1648745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648766 */     // GIR_Coverage, 4709,
     /* 1648766 */     GIR_EraseRootFromParent_Done,
     /* 1648767 */   // Label 22692: @1648767
     /* 1648767 */   GIM_Try, /*On fail goto*//*Label 22693*/ GIMT_Encode4(1648853), // Rule ID 4718 //
     /* 1648772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1648783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1648786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1648789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1648792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648818 */     // MIs[0] policy
     /* 1648818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648828 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1648831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648852 */     // GIR_Coverage, 4718,
     /* 1648852 */     GIR_EraseRootFromParent_Done,
     /* 1648853 */   // Label 22693: @1648853
     /* 1648853 */   GIM_Try, /*On fail goto*//*Label 22694*/ GIMT_Encode4(1648939), // Rule ID 4719 //
     /* 1648858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1648869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1648872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1648875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1648878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648904 */     // MIs[0] policy
     /* 1648904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648914 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1648917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648938 */     // GIR_Coverage, 4719,
     /* 1648938 */     GIR_EraseRootFromParent_Done,
     /* 1648939 */   // Label 22694: @1648939
     /* 1648939 */   GIM_Try, /*On fail goto*//*Label 22695*/ GIMT_Encode4(1649025), // Rule ID 4728 //
     /* 1648944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1648955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1648958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1648961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1648964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648990 */     // MIs[0] policy
     /* 1648990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649000 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1649003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649024 */     // GIR_Coverage, 4728,
     /* 1649024 */     GIR_EraseRootFromParent_Done,
     /* 1649025 */   // Label 22695: @1649025
     /* 1649025 */   GIM_Try, /*On fail goto*//*Label 22696*/ GIMT_Encode4(1649111), // Rule ID 4729 //
     /* 1649030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1649041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1649044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1649047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1649050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649076 */     // MIs[0] policy
     /* 1649076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1649089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649110 */     // GIR_Coverage, 4729,
     /* 1649110 */     GIR_EraseRootFromParent_Done,
     /* 1649111 */   // Label 22696: @1649111
     /* 1649111 */   GIM_Try, /*On fail goto*//*Label 22697*/ GIMT_Encode4(1649197), // Rule ID 4738 //
     /* 1649116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1649127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1649130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1649133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1649136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649162 */     // MIs[0] policy
     /* 1649162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649172 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1649175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649196 */     // GIR_Coverage, 4738,
     /* 1649196 */     GIR_EraseRootFromParent_Done,
     /* 1649197 */   // Label 22697: @1649197
     /* 1649197 */   GIM_Try, /*On fail goto*//*Label 22698*/ GIMT_Encode4(1649283), // Rule ID 4739 //
     /* 1649202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1649213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1649216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1649219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1649222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649248 */     // MIs[0] policy
     /* 1649248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649258 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1649261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649282 */     // GIR_Coverage, 4739,
     /* 1649282 */     GIR_EraseRootFromParent_Done,
     /* 1649283 */   // Label 22698: @1649283
     /* 1649283 */   GIM_Try, /*On fail goto*//*Label 22699*/ GIMT_Encode4(1649369), // Rule ID 4748 //
     /* 1649288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1649299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1649302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1649305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1649308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649334 */     // MIs[0] policy
     /* 1649334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649344 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1649347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649368 */     // GIR_Coverage, 4748,
     /* 1649368 */     GIR_EraseRootFromParent_Done,
     /* 1649369 */   // Label 22699: @1649369
     /* 1649369 */   GIM_Try, /*On fail goto*//*Label 22700*/ GIMT_Encode4(1649455), // Rule ID 4749 //
     /* 1649374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1649385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1649388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1649391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1649394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649420 */     // MIs[0] policy
     /* 1649420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649430 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1649433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649454 */     // GIR_Coverage, 4749,
     /* 1649454 */     GIR_EraseRootFromParent_Done,
     /* 1649455 */   // Label 22700: @1649455
     /* 1649455 */   GIM_Try, /*On fail goto*//*Label 22701*/ GIMT_Encode4(1649541), // Rule ID 4758 //
     /* 1649460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1649471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1649474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1649477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1649480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1649483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649506 */     // MIs[0] policy
     /* 1649506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649516 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1649519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649540 */     // GIR_Coverage, 4758,
     /* 1649540 */     GIR_EraseRootFromParent_Done,
     /* 1649541 */   // Label 22701: @1649541
     /* 1649541 */   GIM_Try, /*On fail goto*//*Label 22702*/ GIMT_Encode4(1649627), // Rule ID 4759 //
     /* 1649546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1649557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1649560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1649563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1649566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1649569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649592 */     // MIs[0] policy
     /* 1649592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649602 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1649605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649626 */     // GIR_Coverage, 4759,
     /* 1649626 */     GIR_EraseRootFromParent_Done,
     /* 1649627 */   // Label 22702: @1649627
     /* 1649627 */   GIM_Try, /*On fail goto*//*Label 22703*/ GIMT_Encode4(1649713), // Rule ID 4768 //
     /* 1649632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1649643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1649646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1649649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1649652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649678 */     // MIs[0] policy
     /* 1649678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649688 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1649691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649712 */     // GIR_Coverage, 4768,
     /* 1649712 */     GIR_EraseRootFromParent_Done,
     /* 1649713 */   // Label 22703: @1649713
     /* 1649713 */   GIM_Try, /*On fail goto*//*Label 22704*/ GIMT_Encode4(1649799), // Rule ID 4769 //
     /* 1649718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1649729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1649732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1649735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1649738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649764 */     // MIs[0] policy
     /* 1649764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649774 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1649777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649798 */     // GIR_Coverage, 4769,
     /* 1649798 */     GIR_EraseRootFromParent_Done,
     /* 1649799 */   // Label 22704: @1649799
     /* 1649799 */   GIM_Try, /*On fail goto*//*Label 22705*/ GIMT_Encode4(1649885), // Rule ID 4778 //
     /* 1649804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1649815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1649818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1649821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1649824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649850 */     // MIs[0] policy
     /* 1649850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649860 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1649863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649884 */     // GIR_Coverage, 4778,
     /* 1649884 */     GIR_EraseRootFromParent_Done,
     /* 1649885 */   // Label 22705: @1649885
     /* 1649885 */   GIM_Try, /*On fail goto*//*Label 22706*/ GIMT_Encode4(1649971), // Rule ID 4779 //
     /* 1649890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1649901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1649904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1649907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1649910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649936 */     // MIs[0] policy
     /* 1649936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1649949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649970 */     // GIR_Coverage, 4779,
     /* 1649970 */     GIR_EraseRootFromParent_Done,
     /* 1649971 */   // Label 22706: @1649971
     /* 1649971 */   GIM_Try, /*On fail goto*//*Label 22707*/ GIMT_Encode4(1650057), // Rule ID 4788 //
     /* 1649976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1649987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1649990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1649993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1649996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650022 */     // MIs[0] policy
     /* 1650022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1650035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650056 */     // GIR_Coverage, 4788,
     /* 1650056 */     GIR_EraseRootFromParent_Done,
     /* 1650057 */   // Label 22707: @1650057
     /* 1650057 */   GIM_Try, /*On fail goto*//*Label 22708*/ GIMT_Encode4(1650143), // Rule ID 4789 //
     /* 1650062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1650073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1650076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1650079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1650082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650108 */     // MIs[0] policy
     /* 1650108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1650121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650142 */     // GIR_Coverage, 4789,
     /* 1650142 */     GIR_EraseRootFromParent_Done,
     /* 1650143 */   // Label 22708: @1650143
     /* 1650143 */   GIM_Try, /*On fail goto*//*Label 22709*/ GIMT_Encode4(1650229), // Rule ID 4798 //
     /* 1650148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1650159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1650162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1650165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1650168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650194 */     // MIs[0] policy
     /* 1650194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650204 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1650207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650228 */     // GIR_Coverage, 4798,
     /* 1650228 */     GIR_EraseRootFromParent_Done,
     /* 1650229 */   // Label 22709: @1650229
     /* 1650229 */   GIM_Try, /*On fail goto*//*Label 22710*/ GIMT_Encode4(1650315), // Rule ID 4799 //
     /* 1650234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1650245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1650248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1650251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1650254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650280 */     // MIs[0] policy
     /* 1650280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650290 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1650293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650314 */     // GIR_Coverage, 4799,
     /* 1650314 */     GIR_EraseRootFromParent_Done,
     /* 1650315 */   // Label 22710: @1650315
     /* 1650315 */   GIM_Try, /*On fail goto*//*Label 22711*/ GIMT_Encode4(1650401), // Rule ID 4808 //
     /* 1650320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1650331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1650334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1650337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1650340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1650343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650366 */     // MIs[0] policy
     /* 1650366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650376 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1650379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650400 */     // GIR_Coverage, 4808,
     /* 1650400 */     GIR_EraseRootFromParent_Done,
     /* 1650401 */   // Label 22711: @1650401
     /* 1650401 */   GIM_Try, /*On fail goto*//*Label 22712*/ GIMT_Encode4(1650487), // Rule ID 4809 //
     /* 1650406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1650417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1650420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1650423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1650426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1650429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650452 */     // MIs[0] policy
     /* 1650452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650462 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1650465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650486 */     // GIR_Coverage, 4809,
     /* 1650486 */     GIR_EraseRootFromParent_Done,
     /* 1650487 */   // Label 22712: @1650487
     /* 1650487 */   GIM_Try, /*On fail goto*//*Label 22713*/ GIMT_Encode4(1650573), // Rule ID 4818 //
     /* 1650492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1650503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1650506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1650509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1650512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650538 */     // MIs[0] policy
     /* 1650538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650548 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1650551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650572 */     // GIR_Coverage, 4818,
     /* 1650572 */     GIR_EraseRootFromParent_Done,
     /* 1650573 */   // Label 22713: @1650573
     /* 1650573 */   GIM_Try, /*On fail goto*//*Label 22714*/ GIMT_Encode4(1650659), // Rule ID 4819 //
     /* 1650578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1650589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1650592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1650595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1650598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650624 */     // MIs[0] policy
     /* 1650624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650634 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1650637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650658 */     // GIR_Coverage, 4819,
     /* 1650658 */     GIR_EraseRootFromParent_Done,
     /* 1650659 */   // Label 22714: @1650659
     /* 1650659 */   GIM_Try, /*On fail goto*//*Label 22715*/ GIMT_Encode4(1650745), // Rule ID 4828 //
     /* 1650664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1650675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1650678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1650681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1650684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650710 */     // MIs[0] policy
     /* 1650710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650720 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1650723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650744 */     // GIR_Coverage, 4828,
     /* 1650744 */     GIR_EraseRootFromParent_Done,
     /* 1650745 */   // Label 22715: @1650745
     /* 1650745 */   GIM_Try, /*On fail goto*//*Label 22716*/ GIMT_Encode4(1650831), // Rule ID 4829 //
     /* 1650750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1650761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1650764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1650767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1650770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650796 */     // MIs[0] policy
     /* 1650796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650806 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1650809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650830 */     // GIR_Coverage, 4829,
     /* 1650830 */     GIR_EraseRootFromParent_Done,
     /* 1650831 */   // Label 22716: @1650831
     /* 1650831 */   GIM_Try, /*On fail goto*//*Label 22717*/ GIMT_Encode4(1650917), // Rule ID 4838 //
     /* 1650836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1650847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1650850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1650853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1650856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650882 */     // MIs[0] policy
     /* 1650882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650892 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1650895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650916 */     // GIR_Coverage, 4838,
     /* 1650916 */     GIR_EraseRootFromParent_Done,
     /* 1650917 */   // Label 22717: @1650917
     /* 1650917 */   GIM_Try, /*On fail goto*//*Label 22718*/ GIMT_Encode4(1651003), // Rule ID 4839 //
     /* 1650922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1650933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1650936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1650939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1650942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650968 */     // MIs[0] policy
     /* 1650968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650978 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1650981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651002 */     // GIR_Coverage, 4839,
     /* 1651002 */     GIR_EraseRootFromParent_Done,
     /* 1651003 */   // Label 22718: @1651003
     /* 1651003 */   GIM_Try, /*On fail goto*//*Label 22719*/ GIMT_Encode4(1651089), // Rule ID 4848 //
     /* 1651008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1651011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1651019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1651022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1651025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1651028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651054 */     // MIs[0] policy
     /* 1651054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651064 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1651067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651088 */     // GIR_Coverage, 4848,
     /* 1651088 */     GIR_EraseRootFromParent_Done,
     /* 1651089 */   // Label 22719: @1651089
     /* 1651089 */   GIM_Try, /*On fail goto*//*Label 22720*/ GIMT_Encode4(1651175), // Rule ID 4849 //
     /* 1651094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1651097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1651105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1651108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1651111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1651114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651140 */     // MIs[0] policy
     /* 1651140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651150 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1651153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651174 */     // GIR_Coverage, 4849,
     /* 1651174 */     GIR_EraseRootFromParent_Done,
     /* 1651175 */   // Label 22720: @1651175
     /* 1651175 */   GIM_Try, /*On fail goto*//*Label 22721*/ GIMT_Encode4(1651261), // Rule ID 4852 //
     /* 1651180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1651191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1651194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1651197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651226 */     // MIs[0] policy
     /* 1651226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651236 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1651239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651260 */     // GIR_Coverage, 4852,
     /* 1651260 */     GIR_EraseRootFromParent_Done,
     /* 1651261 */   // Label 22721: @1651261
     /* 1651261 */   GIM_Try, /*On fail goto*//*Label 22722*/ GIMT_Encode4(1651347), // Rule ID 4853 //
     /* 1651266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1651277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1651280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1651283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651312 */     // MIs[0] policy
     /* 1651312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651322 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1651325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651346 */     // GIR_Coverage, 4853,
     /* 1651346 */     GIR_EraseRootFromParent_Done,
     /* 1651347 */   // Label 22722: @1651347
     /* 1651347 */   GIM_Try, /*On fail goto*//*Label 22723*/ GIMT_Encode4(1651433), // Rule ID 4856 //
     /* 1651352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1651363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1651366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1651369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651398 */     // MIs[0] policy
     /* 1651398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651408 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1651411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651432 */     // GIR_Coverage, 4856,
     /* 1651432 */     GIR_EraseRootFromParent_Done,
     /* 1651433 */   // Label 22723: @1651433
     /* 1651433 */   GIM_Try, /*On fail goto*//*Label 22724*/ GIMT_Encode4(1651519), // Rule ID 4857 //
     /* 1651438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1651449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1651452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1651455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651484 */     // MIs[0] policy
     /* 1651484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651494 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1651497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651518 */     // GIR_Coverage, 4857,
     /* 1651518 */     GIR_EraseRootFromParent_Done,
     /* 1651519 */   // Label 22724: @1651519
     /* 1651519 */   GIM_Try, /*On fail goto*//*Label 22725*/ GIMT_Encode4(1651605), // Rule ID 4860 //
     /* 1651524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1651535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1651538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1651541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651570 */     // MIs[0] policy
     /* 1651570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651580 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1651583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651604 */     // GIR_Coverage, 4860,
     /* 1651604 */     GIR_EraseRootFromParent_Done,
     /* 1651605 */   // Label 22725: @1651605
     /* 1651605 */   GIM_Try, /*On fail goto*//*Label 22726*/ GIMT_Encode4(1651691), // Rule ID 4861 //
     /* 1651610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1651621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1651624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1651627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651656 */     // MIs[0] policy
     /* 1651656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651666 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1651669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651690 */     // GIR_Coverage, 4861,
     /* 1651690 */     GIR_EraseRootFromParent_Done,
     /* 1651691 */   // Label 22726: @1651691
     /* 1651691 */   GIM_Try, /*On fail goto*//*Label 22727*/ GIMT_Encode4(1651777), // Rule ID 4864 //
     /* 1651696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1651707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1651710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1651713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651742 */     // MIs[0] policy
     /* 1651742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651752 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1651755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651776 */     // GIR_Coverage, 4864,
     /* 1651776 */     GIR_EraseRootFromParent_Done,
     /* 1651777 */   // Label 22727: @1651777
     /* 1651777 */   GIM_Try, /*On fail goto*//*Label 22728*/ GIMT_Encode4(1651863), // Rule ID 4865 //
     /* 1651782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1651793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1651796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1651799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651828 */     // MIs[0] policy
     /* 1651828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1651841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651862 */     // GIR_Coverage, 4865,
     /* 1651862 */     GIR_EraseRootFromParent_Done,
     /* 1651863 */   // Label 22728: @1651863
     /* 1651863 */   GIM_Try, /*On fail goto*//*Label 22729*/ GIMT_Encode4(1651949), // Rule ID 4868 //
     /* 1651868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1651879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1651882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1651885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651914 */     // MIs[0] policy
     /* 1651914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651924 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1651927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651948 */     // GIR_Coverage, 4868,
     /* 1651948 */     GIR_EraseRootFromParent_Done,
     /* 1651949 */   // Label 22729: @1651949
     /* 1651949 */   GIM_Try, /*On fail goto*//*Label 22730*/ GIMT_Encode4(1652035), // Rule ID 4869 //
     /* 1651954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1651965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1651968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1651971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652000 */     // MIs[0] policy
     /* 1652000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652010 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1652013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652034 */     // GIR_Coverage, 4869,
     /* 1652034 */     GIR_EraseRootFromParent_Done,
     /* 1652035 */   // Label 22730: @1652035
     /* 1652035 */   GIM_Try, /*On fail goto*//*Label 22731*/ GIMT_Encode4(1652121), // Rule ID 4872 //
     /* 1652040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1652051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1652054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1652057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1652063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652086 */     // MIs[0] policy
     /* 1652086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652096 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1652099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652120 */     // GIR_Coverage, 4872,
     /* 1652120 */     GIR_EraseRootFromParent_Done,
     /* 1652121 */   // Label 22731: @1652121
     /* 1652121 */   GIM_Try, /*On fail goto*//*Label 22732*/ GIMT_Encode4(1652207), // Rule ID 4873 //
     /* 1652126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1652137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1652140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1652143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1652149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652172 */     // MIs[0] policy
     /* 1652172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652182 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1652185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652206 */     // GIR_Coverage, 4873,
     /* 1652206 */     GIR_EraseRootFromParent_Done,
     /* 1652207 */   // Label 22732: @1652207
     /* 1652207 */   GIM_Try, /*On fail goto*//*Label 22733*/ GIMT_Encode4(1652293), // Rule ID 4876 //
     /* 1652212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1652223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1652226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1652229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652258 */     // MIs[0] policy
     /* 1652258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1652271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652292 */     // GIR_Coverage, 4876,
     /* 1652292 */     GIR_EraseRootFromParent_Done,
     /* 1652293 */   // Label 22733: @1652293
     /* 1652293 */   GIM_Try, /*On fail goto*//*Label 22734*/ GIMT_Encode4(1652379), // Rule ID 4877 //
     /* 1652298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1652309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1652312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1652315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652344 */     // MIs[0] policy
     /* 1652344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652354 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1652357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652378 */     // GIR_Coverage, 4877,
     /* 1652378 */     GIR_EraseRootFromParent_Done,
     /* 1652379 */   // Label 22734: @1652379
     /* 1652379 */   GIM_Try, /*On fail goto*//*Label 22735*/ GIMT_Encode4(1652465), // Rule ID 4880 //
     /* 1652384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1652395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1652398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1652401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652430 */     // MIs[0] policy
     /* 1652430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1652443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652464 */     // GIR_Coverage, 4880,
     /* 1652464 */     GIR_EraseRootFromParent_Done,
     /* 1652465 */   // Label 22735: @1652465
     /* 1652465 */   GIM_Try, /*On fail goto*//*Label 22736*/ GIMT_Encode4(1652551), // Rule ID 4881 //
     /* 1652470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1652481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1652484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1652487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652516 */     // MIs[0] policy
     /* 1652516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652526 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1652529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652550 */     // GIR_Coverage, 4881,
     /* 1652550 */     GIR_EraseRootFromParent_Done,
     /* 1652551 */   // Label 22736: @1652551
     /* 1652551 */   GIM_Try, /*On fail goto*//*Label 22737*/ GIMT_Encode4(1652637), // Rule ID 4884 //
     /* 1652556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1652567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1652570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1652573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652602 */     // MIs[0] policy
     /* 1652602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1652615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652636 */     // GIR_Coverage, 4884,
     /* 1652636 */     GIR_EraseRootFromParent_Done,
     /* 1652637 */   // Label 22737: @1652637
     /* 1652637 */   GIM_Try, /*On fail goto*//*Label 22738*/ GIMT_Encode4(1652723), // Rule ID 4885 //
     /* 1652642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1652653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1652656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1652659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652688 */     // MIs[0] policy
     /* 1652688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1652701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652722 */     // GIR_Coverage, 4885,
     /* 1652722 */     GIR_EraseRootFromParent_Done,
     /* 1652723 */   // Label 22738: @1652723
     /* 1652723 */   GIM_Try, /*On fail goto*//*Label 22739*/ GIMT_Encode4(1652809), // Rule ID 4888 //
     /* 1652728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1652739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1652742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1652745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652774 */     // MIs[0] policy
     /* 1652774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1652787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652808 */     // GIR_Coverage, 4888,
     /* 1652808 */     GIR_EraseRootFromParent_Done,
     /* 1652809 */   // Label 22739: @1652809
     /* 1652809 */   GIM_Try, /*On fail goto*//*Label 22740*/ GIMT_Encode4(1652895), // Rule ID 4889 //
     /* 1652814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1652825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1652828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1652831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652860 */     // MIs[0] policy
     /* 1652860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652870 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1652873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652894 */     // GIR_Coverage, 4889,
     /* 1652894 */     GIR_EraseRootFromParent_Done,
     /* 1652895 */   // Label 22740: @1652895
     /* 1652895 */   GIM_Try, /*On fail goto*//*Label 22741*/ GIMT_Encode4(1652981), // Rule ID 4892 //
     /* 1652900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1652911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1652914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1652917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652946 */     // MIs[0] policy
     /* 1652946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652956 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1652959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652980 */     // GIR_Coverage, 4892,
     /* 1652980 */     GIR_EraseRootFromParent_Done,
     /* 1652981 */   // Label 22741: @1652981
     /* 1652981 */   GIM_Try, /*On fail goto*//*Label 22742*/ GIMT_Encode4(1653067), // Rule ID 4893 //
     /* 1652986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1652997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1653000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1653003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1653009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653032 */     // MIs[0] policy
     /* 1653032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653042 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1653045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653066 */     // GIR_Coverage, 4893,
     /* 1653066 */     GIR_EraseRootFromParent_Done,
     /* 1653067 */   // Label 22742: @1653067
     /* 1653067 */   GIM_Try, /*On fail goto*//*Label 22743*/ GIMT_Encode4(1653153), // Rule ID 4896 //
     /* 1653072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1653075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1653083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1653086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1653089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653118 */     // MIs[0] policy
     /* 1653118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653128 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1653131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653152 */     // GIR_Coverage, 4896,
     /* 1653152 */     GIR_EraseRootFromParent_Done,
     /* 1653153 */   // Label 22743: @1653153
     /* 1653153 */   GIM_Try, /*On fail goto*//*Label 22744*/ GIMT_Encode4(1653239), // Rule ID 4897 //
     /* 1653158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1653169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1653172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1653175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653204 */     // MIs[0] policy
     /* 1653204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653214 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1653217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653238 */     // GIR_Coverage, 4897,
     /* 1653238 */     GIR_EraseRootFromParent_Done,
     /* 1653239 */   // Label 22744: @1653239
     /* 1653239 */   GIM_Try, /*On fail goto*//*Label 22745*/ GIMT_Encode4(1653325), // Rule ID 4900 //
     /* 1653244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1653247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1653255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1653258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1653261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653290 */     // MIs[0] policy
     /* 1653290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1653303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653324 */     // GIR_Coverage, 4900,
     /* 1653324 */     GIR_EraseRootFromParent_Done,
     /* 1653325 */   // Label 22745: @1653325
     /* 1653325 */   GIM_Try, /*On fail goto*//*Label 22746*/ GIMT_Encode4(1653411), // Rule ID 4901 //
     /* 1653330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1653341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1653344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1653347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653376 */     // MIs[0] policy
     /* 1653376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1653389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653410 */     // GIR_Coverage, 4901,
     /* 1653410 */     GIR_EraseRootFromParent_Done,
     /* 1653411 */   // Label 22746: @1653411
     /* 1653411 */   GIM_Try, /*On fail goto*//*Label 22747*/ GIMT_Encode4(1653497), // Rule ID 4904 //
     /* 1653416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1653419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1653427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1653430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1653433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653462 */     // MIs[0] policy
     /* 1653462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653472 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1653475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653496 */     // GIR_Coverage, 4904,
     /* 1653496 */     GIR_EraseRootFromParent_Done,
     /* 1653497 */   // Label 22747: @1653497
     /* 1653497 */   GIM_Try, /*On fail goto*//*Label 22748*/ GIMT_Encode4(1653583), // Rule ID 4905 //
     /* 1653502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1653513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1653516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1653519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653548 */     // MIs[0] policy
     /* 1653548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653558 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1653561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653582 */     // GIR_Coverage, 4905,
     /* 1653582 */     GIR_EraseRootFromParent_Done,
     /* 1653583 */   // Label 22748: @1653583
     /* 1653583 */   GIM_Try, /*On fail goto*//*Label 22749*/ GIMT_Encode4(1653669), // Rule ID 4908 //
     /* 1653588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1653591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1653599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1653602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1653605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653634 */     // MIs[0] policy
     /* 1653634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653644 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1653647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653668 */     // GIR_Coverage, 4908,
     /* 1653668 */     GIR_EraseRootFromParent_Done,
     /* 1653669 */   // Label 22749: @1653669
     /* 1653669 */   GIM_Try, /*On fail goto*//*Label 22750*/ GIMT_Encode4(1653755), // Rule ID 4909 //
     /* 1653674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1653685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1653688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1653691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653720 */     // MIs[0] policy
     /* 1653720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653730 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1653733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653754 */     // GIR_Coverage, 4909,
     /* 1653754 */     GIR_EraseRootFromParent_Done,
     /* 1653755 */   // Label 22750: @1653755
     /* 1653755 */   GIM_Try, /*On fail goto*//*Label 22751*/ GIMT_Encode4(1653841), // Rule ID 5786 //
     /* 1653760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1653771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1653774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1653777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1653780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653806 */     // MIs[0] policy
     /* 1653806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653816 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1653819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653840 */     // GIR_Coverage, 5786,
     /* 1653840 */     GIR_EraseRootFromParent_Done,
     /* 1653841 */   // Label 22751: @1653841
     /* 1653841 */   GIM_Try, /*On fail goto*//*Label 22752*/ GIMT_Encode4(1653927), // Rule ID 5787 //
     /* 1653846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1653857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1653860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1653863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1653866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653892 */     // MIs[0] policy
     /* 1653892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653902 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1653905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653926 */     // GIR_Coverage, 5787,
     /* 1653926 */     GIR_EraseRootFromParent_Done,
     /* 1653927 */   // Label 22752: @1653927
     /* 1653927 */   GIM_Try, /*On fail goto*//*Label 22753*/ GIMT_Encode4(1654013), // Rule ID 5790 //
     /* 1653932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1653943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1653946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1653949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1653952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653978 */     // MIs[0] policy
     /* 1653978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653988 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1653991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654012 */     // GIR_Coverage, 5790,
     /* 1654012 */     GIR_EraseRootFromParent_Done,
     /* 1654013 */   // Label 22753: @1654013
     /* 1654013 */   GIM_Try, /*On fail goto*//*Label 22754*/ GIMT_Encode4(1654099), // Rule ID 5791 //
     /* 1654018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1654029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1654032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1654035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1654038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654064 */     // MIs[0] policy
     /* 1654064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654074 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1654077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654098 */     // GIR_Coverage, 5791,
     /* 1654098 */     GIR_EraseRootFromParent_Done,
     /* 1654099 */   // Label 22754: @1654099
     /* 1654099 */   GIM_Try, /*On fail goto*//*Label 22755*/ GIMT_Encode4(1654185), // Rule ID 5794 //
     /* 1654104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1654115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1654118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1654121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1654124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654150 */     // MIs[0] policy
     /* 1654150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654160 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654184 */     // GIR_Coverage, 5794,
     /* 1654184 */     GIR_EraseRootFromParent_Done,
     /* 1654185 */   // Label 22755: @1654185
     /* 1654185 */   GIM_Try, /*On fail goto*//*Label 22756*/ GIMT_Encode4(1654271), // Rule ID 5795 //
     /* 1654190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1654201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1654204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1654207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1654210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654236 */     // MIs[0] policy
     /* 1654236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654246 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654270 */     // GIR_Coverage, 5795,
     /* 1654270 */     GIR_EraseRootFromParent_Done,
     /* 1654271 */   // Label 22756: @1654271
     /* 1654271 */   GIM_Try, /*On fail goto*//*Label 22757*/ GIMT_Encode4(1654357), // Rule ID 5798 //
     /* 1654276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1654287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1654290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1654293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1654296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654322 */     // MIs[0] policy
     /* 1654322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654332 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1654335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654356 */     // GIR_Coverage, 5798,
     /* 1654356 */     GIR_EraseRootFromParent_Done,
     /* 1654357 */   // Label 22757: @1654357
     /* 1654357 */   GIM_Try, /*On fail goto*//*Label 22758*/ GIMT_Encode4(1654443), // Rule ID 5799 //
     /* 1654362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1654373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1654376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1654379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1654382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654408 */     // MIs[0] policy
     /* 1654408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654418 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1654421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654442 */     // GIR_Coverage, 5799,
     /* 1654442 */     GIR_EraseRootFromParent_Done,
     /* 1654443 */   // Label 22758: @1654443
     /* 1654443 */   GIM_Try, /*On fail goto*//*Label 22759*/ GIMT_Encode4(1654529), // Rule ID 5802 //
     /* 1654448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1654459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1654462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1654465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1654468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654494 */     // MIs[0] policy
     /* 1654494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654504 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654528 */     // GIR_Coverage, 5802,
     /* 1654528 */     GIR_EraseRootFromParent_Done,
     /* 1654529 */   // Label 22759: @1654529
     /* 1654529 */   GIM_Try, /*On fail goto*//*Label 22760*/ GIMT_Encode4(1654615), // Rule ID 5803 //
     /* 1654534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1654545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1654548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1654551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1654554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654580 */     // MIs[0] policy
     /* 1654580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654590 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654614 */     // GIR_Coverage, 5803,
     /* 1654614 */     GIR_EraseRootFromParent_Done,
     /* 1654615 */   // Label 22760: @1654615
     /* 1654615 */   GIM_Try, /*On fail goto*//*Label 22761*/ GIMT_Encode4(1654701), // Rule ID 5806 //
     /* 1654620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1654631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1654634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1654637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1654640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654666 */     // MIs[0] policy
     /* 1654666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654676 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654700 */     // GIR_Coverage, 5806,
     /* 1654700 */     GIR_EraseRootFromParent_Done,
     /* 1654701 */   // Label 22761: @1654701
     /* 1654701 */   GIM_Try, /*On fail goto*//*Label 22762*/ GIMT_Encode4(1654787), // Rule ID 5807 //
     /* 1654706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1654717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1654720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1654723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1654726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654752 */     // MIs[0] policy
     /* 1654752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654762 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654786 */     // GIR_Coverage, 5807,
     /* 1654786 */     GIR_EraseRootFromParent_Done,
     /* 1654787 */   // Label 22762: @1654787
     /* 1654787 */   GIM_Try, /*On fail goto*//*Label 22763*/ GIMT_Encode4(1654873), // Rule ID 5810 //
     /* 1654792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1654803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1654806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1654809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1654812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654838 */     // MIs[0] policy
     /* 1654838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654848 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654872 */     // GIR_Coverage, 5810,
     /* 1654872 */     GIR_EraseRootFromParent_Done,
     /* 1654873 */   // Label 22763: @1654873
     /* 1654873 */   GIM_Try, /*On fail goto*//*Label 22764*/ GIMT_Encode4(1654959), // Rule ID 5811 //
     /* 1654878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1654889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1654892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1654895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1654898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654924 */     // MIs[0] policy
     /* 1654924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654958 */     // GIR_Coverage, 5811,
     /* 1654958 */     GIR_EraseRootFromParent_Done,
     /* 1654959 */   // Label 22764: @1654959
     /* 1654959 */   GIM_Try, /*On fail goto*//*Label 22765*/ GIMT_Encode4(1655045), // Rule ID 5814 //
     /* 1654964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1654975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1654978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1654981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1654984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655010 */     // MIs[0] policy
     /* 1655010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1655023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655044 */     // GIR_Coverage, 5814,
     /* 1655044 */     GIR_EraseRootFromParent_Done,
     /* 1655045 */   // Label 22765: @1655045
     /* 1655045 */   GIM_Try, /*On fail goto*//*Label 22766*/ GIMT_Encode4(1655131), // Rule ID 5815 //
     /* 1655050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1655061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1655064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1655067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1655070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1655073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655096 */     // MIs[0] policy
     /* 1655096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1655109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655130 */     // GIR_Coverage, 5815,
     /* 1655130 */     GIR_EraseRootFromParent_Done,
     /* 1655131 */   // Label 22766: @1655131
     /* 1655131 */   GIM_Try, /*On fail goto*//*Label 22767*/ GIMT_Encode4(1655217), // Rule ID 5818 //
     /* 1655136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1655147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1655150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1655153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1655156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655182 */     // MIs[0] policy
     /* 1655182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655192 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1655195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655216 */     // GIR_Coverage, 5818,
     /* 1655216 */     GIR_EraseRootFromParent_Done,
     /* 1655217 */   // Label 22767: @1655217
     /* 1655217 */   GIM_Try, /*On fail goto*//*Label 22768*/ GIMT_Encode4(1655303), // Rule ID 5819 //
     /* 1655222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1655233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1655236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1655239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1655242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655268 */     // MIs[0] policy
     /* 1655268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655278 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1655281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655302 */     // GIR_Coverage, 5819,
     /* 1655302 */     GIR_EraseRootFromParent_Done,
     /* 1655303 */   // Label 22768: @1655303
     /* 1655303 */   GIM_Try, /*On fail goto*//*Label 22769*/ GIMT_Encode4(1655389), // Rule ID 5822 //
     /* 1655308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1655311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1655319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1655322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1655325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1655328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655354 */     // MIs[0] policy
     /* 1655354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655364 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1655367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1655385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655388 */     // GIR_Coverage, 5822,
     /* 1655388 */     GIR_EraseRootFromParent_Done,
     /* 1655389 */   // Label 22769: @1655389
     /* 1655389 */   GIM_Try, /*On fail goto*//*Label 22770*/ GIMT_Encode4(1655475), // Rule ID 5823 //
     /* 1655394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1655397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1655405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1655408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1655411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1655414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655440 */     // MIs[0] policy
     /* 1655440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655450 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1655453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1655471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655474 */     // GIR_Coverage, 5823,
     /* 1655474 */     GIR_EraseRootFromParent_Done,
     /* 1655475 */   // Label 22770: @1655475
     /* 1655475 */   GIM_Try, /*On fail goto*//*Label 22771*/ GIMT_Encode4(1655561), // Rule ID 5826 //
     /* 1655480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1655491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1655494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1655497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1655500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655526 */     // MIs[0] policy
     /* 1655526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1655539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655560 */     // GIR_Coverage, 5826,
     /* 1655560 */     GIR_EraseRootFromParent_Done,
     /* 1655561 */   // Label 22771: @1655561
     /* 1655561 */   GIM_Try, /*On fail goto*//*Label 22772*/ GIMT_Encode4(1655647), // Rule ID 5827 //
     /* 1655566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1655577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1655580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1655583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1655586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655612 */     // MIs[0] policy
     /* 1655612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655622 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1655625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655646 */     // GIR_Coverage, 5827,
     /* 1655646 */     GIR_EraseRootFromParent_Done,
     /* 1655647 */   // Label 22772: @1655647
     /* 1655647 */   GIM_Try, /*On fail goto*//*Label 22773*/ GIMT_Encode4(1655733), // Rule ID 5830 //
     /* 1655652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1655663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1655666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1655669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1655672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655698 */     // MIs[0] policy
     /* 1655698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655708 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1655711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655732 */     // GIR_Coverage, 5830,
     /* 1655732 */     GIR_EraseRootFromParent_Done,
     /* 1655733 */   // Label 22773: @1655733
     /* 1655733 */   GIM_Try, /*On fail goto*//*Label 22774*/ GIMT_Encode4(1655819), // Rule ID 5831 //
     /* 1655738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1655749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1655752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1655755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1655758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655784 */     // MIs[0] policy
     /* 1655784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655794 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1655797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655818 */     // GIR_Coverage, 5831,
     /* 1655818 */     GIR_EraseRootFromParent_Done,
     /* 1655819 */   // Label 22774: @1655819
     /* 1655819 */   GIM_Try, /*On fail goto*//*Label 22775*/ GIMT_Encode4(1655905), // Rule ID 5834 //
     /* 1655824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1655835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1655838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1655841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1655844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1655847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655870 */     // MIs[0] policy
     /* 1655870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655880 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1655883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655904 */     // GIR_Coverage, 5834,
     /* 1655904 */     GIR_EraseRootFromParent_Done,
     /* 1655905 */   // Label 22775: @1655905
     /* 1655905 */   GIM_Try, /*On fail goto*//*Label 22776*/ GIMT_Encode4(1655991), // Rule ID 5835 //
     /* 1655910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1655921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1655924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1655927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1655930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1655933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655956 */     // MIs[0] policy
     /* 1655956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655966 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1655969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655990 */     // GIR_Coverage, 5835,
     /* 1655990 */     GIR_EraseRootFromParent_Done,
     /* 1655991 */   // Label 22776: @1655991
     /* 1655991 */   GIM_Try, /*On fail goto*//*Label 22777*/ GIMT_Encode4(1656077), // Rule ID 5838 //
     /* 1655996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1656007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1656010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1656013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1656016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656042 */     // MIs[0] policy
     /* 1656042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656052 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656076 */     // GIR_Coverage, 5838,
     /* 1656076 */     GIR_EraseRootFromParent_Done,
     /* 1656077 */   // Label 22777: @1656077
     /* 1656077 */   GIM_Try, /*On fail goto*//*Label 22778*/ GIMT_Encode4(1656163), // Rule ID 5839 //
     /* 1656082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1656093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1656096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1656099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1656102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656128 */     // MIs[0] policy
     /* 1656128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656162 */     // GIR_Coverage, 5839,
     /* 1656162 */     GIR_EraseRootFromParent_Done,
     /* 1656163 */   // Label 22778: @1656163
     /* 1656163 */   GIM_Try, /*On fail goto*//*Label 22779*/ GIMT_Encode4(1656249), // Rule ID 5842 //
     /* 1656168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1656179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1656182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1656185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1656188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656214 */     // MIs[0] policy
     /* 1656214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656224 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656248 */     // GIR_Coverage, 5842,
     /* 1656248 */     GIR_EraseRootFromParent_Done,
     /* 1656249 */   // Label 22779: @1656249
     /* 1656249 */   GIM_Try, /*On fail goto*//*Label 22780*/ GIMT_Encode4(1656335), // Rule ID 5843 //
     /* 1656254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1656265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1656268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1656271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1656274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656300 */     // MIs[0] policy
     /* 1656300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656310 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656334 */     // GIR_Coverage, 5843,
     /* 1656334 */     GIR_EraseRootFromParent_Done,
     /* 1656335 */   // Label 22780: @1656335
     /* 1656335 */   GIM_Try, /*On fail goto*//*Label 22781*/ GIMT_Encode4(1656421), // Rule ID 5846 //
     /* 1656340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1656351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1656354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1656357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1656360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1656363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656386 */     // MIs[0] policy
     /* 1656386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656396 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656420 */     // GIR_Coverage, 5846,
     /* 1656420 */     GIR_EraseRootFromParent_Done,
     /* 1656421 */   // Label 22781: @1656421
     /* 1656421 */   GIM_Try, /*On fail goto*//*Label 22782*/ GIMT_Encode4(1656507), // Rule ID 5847 //
     /* 1656426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1656437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1656440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1656443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1656446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1656449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656472 */     // MIs[0] policy
     /* 1656472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656482 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656506 */     // GIR_Coverage, 5847,
     /* 1656506 */     GIR_EraseRootFromParent_Done,
     /* 1656507 */   // Label 22782: @1656507
     /* 1656507 */   GIM_Try, /*On fail goto*//*Label 22783*/ GIMT_Encode4(1656593), // Rule ID 5850 //
     /* 1656512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1656523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1656526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1656529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1656532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656558 */     // MIs[0] policy
     /* 1656558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656592 */     // GIR_Coverage, 5850,
     /* 1656592 */     GIR_EraseRootFromParent_Done,
     /* 1656593 */   // Label 22783: @1656593
     /* 1656593 */   GIM_Try, /*On fail goto*//*Label 22784*/ GIMT_Encode4(1656679), // Rule ID 5851 //
     /* 1656598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1656609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1656612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1656615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1656618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656644 */     // MIs[0] policy
     /* 1656644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656678 */     // GIR_Coverage, 5851,
     /* 1656678 */     GIR_EraseRootFromParent_Done,
     /* 1656679 */   // Label 22784: @1656679
     /* 1656679 */   GIM_Try, /*On fail goto*//*Label 22785*/ GIMT_Encode4(1656765), // Rule ID 5854 //
     /* 1656684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1656695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1656698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1656701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1656704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656730 */     // MIs[0] policy
     /* 1656730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656740 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656764 */     // GIR_Coverage, 5854,
     /* 1656764 */     GIR_EraseRootFromParent_Done,
     /* 1656765 */   // Label 22785: @1656765
     /* 1656765 */   GIM_Try, /*On fail goto*//*Label 22786*/ GIMT_Encode4(1656851), // Rule ID 5855 //
     /* 1656770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1656781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1656784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1656787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1656790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656816 */     // MIs[0] policy
     /* 1656816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656826 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656850 */     // GIR_Coverage, 5855,
     /* 1656850 */     GIR_EraseRootFromParent_Done,
     /* 1656851 */   // Label 22786: @1656851
     /* 1656851 */   GIM_Try, /*On fail goto*//*Label 22787*/ GIMT_Encode4(1656937), // Rule ID 5858 //
     /* 1656856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1656867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1656870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1656873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1656876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656902 */     // MIs[0] policy
     /* 1656902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656912 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656936 */     // GIR_Coverage, 5858,
     /* 1656936 */     GIR_EraseRootFromParent_Done,
     /* 1656937 */   // Label 22787: @1656937
     /* 1656937 */   GIM_Try, /*On fail goto*//*Label 22788*/ GIMT_Encode4(1657023), // Rule ID 5859 //
     /* 1656942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1656953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1656956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1656959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1656962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656988 */     // MIs[0] policy
     /* 1656988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656998 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1657001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657022 */     // GIR_Coverage, 5859,
     /* 1657022 */     GIR_EraseRootFromParent_Done,
     /* 1657023 */   // Label 22788: @1657023
     /* 1657023 */   GIM_Try, /*On fail goto*//*Label 22789*/ GIMT_Encode4(1657109), // Rule ID 5862 //
     /* 1657028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1657031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1657039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1657042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1657045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1657048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657074 */     // MIs[0] policy
     /* 1657074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1657087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657108 */     // GIR_Coverage, 5862,
     /* 1657108 */     GIR_EraseRootFromParent_Done,
     /* 1657109 */   // Label 22789: @1657109
     /* 1657109 */   GIM_Try, /*On fail goto*//*Label 22790*/ GIMT_Encode4(1657195), // Rule ID 5863 //
     /* 1657114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1657117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1657125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1657128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1657131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1657134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657160 */     // MIs[0] policy
     /* 1657160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1657173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657194 */     // GIR_Coverage, 5863,
     /* 1657194 */     GIR_EraseRootFromParent_Done,
     /* 1657195 */   // Label 22790: @1657195
     /* 1657195 */   GIM_Try, /*On fail goto*//*Label 22791*/ GIMT_Encode4(1657281), // Rule ID 5866 //
     /* 1657200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1657203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1657211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1657214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1657217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1657220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657246 */     // MIs[0] policy
     /* 1657246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657256 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1657259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657280 */     // GIR_Coverage, 5866,
     /* 1657280 */     GIR_EraseRootFromParent_Done,
     /* 1657281 */   // Label 22791: @1657281
     /* 1657281 */   GIM_Try, /*On fail goto*//*Label 22792*/ GIMT_Encode4(1657367), // Rule ID 5867 //
     /* 1657286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1657289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1657297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1657300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1657303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1657306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657332 */     // MIs[0] policy
     /* 1657332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657342 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1657345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657366 */     // GIR_Coverage, 5867,
     /* 1657366 */     GIR_EraseRootFromParent_Done,
     /* 1657367 */   // Label 22792: @1657367
     /* 1657367 */   GIM_Try, /*On fail goto*//*Label 22793*/ GIMT_Encode4(1657453), // Rule ID 5870 //
     /* 1657372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1657375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1657383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1657386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1657389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1657392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657418 */     // MIs[0] policy
     /* 1657418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657428 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1657431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657452 */     // GIR_Coverage, 5870,
     /* 1657452 */     GIR_EraseRootFromParent_Done,
     /* 1657453 */   // Label 22793: @1657453
     /* 1657453 */   GIM_Try, /*On fail goto*//*Label 22794*/ GIMT_Encode4(1657539), // Rule ID 5871 //
     /* 1657458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1657461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1657469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1657472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1657475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1657478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657504 */     // MIs[0] policy
     /* 1657504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657514 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1657517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657538 */     // GIR_Coverage, 5871,
     /* 1657538 */     GIR_EraseRootFromParent_Done,
     /* 1657539 */   // Label 22794: @1657539
     /* 1657539 */   GIM_Try, /*On fail goto*//*Label 22795*/ GIMT_Encode4(1657625), // Rule ID 5874 //
     /* 1657544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1657555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1657558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1657561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657590 */     // MIs[0] policy
     /* 1657590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657600 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1657603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657624 */     // GIR_Coverage, 5874,
     /* 1657624 */     GIR_EraseRootFromParent_Done,
     /* 1657625 */   // Label 22795: @1657625
     /* 1657625 */   GIM_Try, /*On fail goto*//*Label 22796*/ GIMT_Encode4(1657711), // Rule ID 5875 //
     /* 1657630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1657641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1657644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1657647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657676 */     // MIs[0] policy
     /* 1657676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657686 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1657689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657710 */     // GIR_Coverage, 5875,
     /* 1657710 */     GIR_EraseRootFromParent_Done,
     /* 1657711 */   // Label 22796: @1657711
     /* 1657711 */   GIM_Try, /*On fail goto*//*Label 22797*/ GIMT_Encode4(1657797), // Rule ID 5878 //
     /* 1657716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1657727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1657730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1657733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657762 */     // MIs[0] policy
     /* 1657762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657772 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1657775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657796 */     // GIR_Coverage, 5878,
     /* 1657796 */     GIR_EraseRootFromParent_Done,
     /* 1657797 */   // Label 22797: @1657797
     /* 1657797 */   GIM_Try, /*On fail goto*//*Label 22798*/ GIMT_Encode4(1657883), // Rule ID 5879 //
     /* 1657802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1657813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1657816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1657819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657848 */     // MIs[0] policy
     /* 1657848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657858 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1657861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657882 */     // GIR_Coverage, 5879,
     /* 1657882 */     GIR_EraseRootFromParent_Done,
     /* 1657883 */   // Label 22798: @1657883
     /* 1657883 */   GIM_Try, /*On fail goto*//*Label 22799*/ GIMT_Encode4(1657969), // Rule ID 5882 //
     /* 1657888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1657899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1657902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1657905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657934 */     // MIs[0] policy
     /* 1657934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657944 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1657947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657968 */     // GIR_Coverage, 5882,
     /* 1657968 */     GIR_EraseRootFromParent_Done,
     /* 1657969 */   // Label 22799: @1657969
     /* 1657969 */   GIM_Try, /*On fail goto*//*Label 22800*/ GIMT_Encode4(1658055), // Rule ID 5883 //
     /* 1657974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1657985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1657988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1657991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658020 */     // MIs[0] policy
     /* 1658020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658030 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658054 */     // GIR_Coverage, 5883,
     /* 1658054 */     GIR_EraseRootFromParent_Done,
     /* 1658055 */   // Label 22800: @1658055
     /* 1658055 */   GIM_Try, /*On fail goto*//*Label 22801*/ GIMT_Encode4(1658141), // Rule ID 5886 //
     /* 1658060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1658071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1658074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1658077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658106 */     // MIs[0] policy
     /* 1658106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658116 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1658119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658140 */     // GIR_Coverage, 5886,
     /* 1658140 */     GIR_EraseRootFromParent_Done,
     /* 1658141 */   // Label 22801: @1658141
     /* 1658141 */   GIM_Try, /*On fail goto*//*Label 22802*/ GIMT_Encode4(1658227), // Rule ID 5887 //
     /* 1658146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1658157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1658160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1658163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658192 */     // MIs[0] policy
     /* 1658192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658202 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1658205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658226 */     // GIR_Coverage, 5887,
     /* 1658226 */     GIR_EraseRootFromParent_Done,
     /* 1658227 */   // Label 22802: @1658227
     /* 1658227 */   GIM_Try, /*On fail goto*//*Label 22803*/ GIMT_Encode4(1658313), // Rule ID 5890 //
     /* 1658232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1658243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1658246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1658249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658278 */     // MIs[0] policy
     /* 1658278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658288 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658312 */     // GIR_Coverage, 5890,
     /* 1658312 */     GIR_EraseRootFromParent_Done,
     /* 1658313 */   // Label 22803: @1658313
     /* 1658313 */   GIM_Try, /*On fail goto*//*Label 22804*/ GIMT_Encode4(1658399), // Rule ID 5891 //
     /* 1658318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1658329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1658332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1658335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658364 */     // MIs[0] policy
     /* 1658364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658374 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658398 */     // GIR_Coverage, 5891,
     /* 1658398 */     GIR_EraseRootFromParent_Done,
     /* 1658399 */   // Label 22804: @1658399
     /* 1658399 */   GIM_Try, /*On fail goto*//*Label 22805*/ GIMT_Encode4(1658485), // Rule ID 5894 //
     /* 1658404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1658415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1658418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1658421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658450 */     // MIs[0] policy
     /* 1658450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658460 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658484 */     // GIR_Coverage, 5894,
     /* 1658484 */     GIR_EraseRootFromParent_Done,
     /* 1658485 */   // Label 22805: @1658485
     /* 1658485 */   GIM_Try, /*On fail goto*//*Label 22806*/ GIMT_Encode4(1658571), // Rule ID 5895 //
     /* 1658490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1658501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1658504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1658507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658536 */     // MIs[0] policy
     /* 1658536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658570 */     // GIR_Coverage, 5895,
     /* 1658570 */     GIR_EraseRootFromParent_Done,
     /* 1658571 */   // Label 22806: @1658571
     /* 1658571 */   GIM_Try, /*On fail goto*//*Label 22807*/ GIMT_Encode4(1658657), // Rule ID 5898 //
     /* 1658576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1658587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1658590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1658593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658622 */     // MIs[0] policy
     /* 1658622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658632 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658656 */     // GIR_Coverage, 5898,
     /* 1658656 */     GIR_EraseRootFromParent_Done,
     /* 1658657 */   // Label 22807: @1658657
     /* 1658657 */   GIM_Try, /*On fail goto*//*Label 22808*/ GIMT_Encode4(1658743), // Rule ID 5899 //
     /* 1658662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1658673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1658676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1658679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658708 */     // MIs[0] policy
     /* 1658708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658742 */     // GIR_Coverage, 5899,
     /* 1658742 */     GIR_EraseRootFromParent_Done,
     /* 1658743 */   // Label 22808: @1658743
     /* 1658743 */   GIM_Try, /*On fail goto*//*Label 22809*/ GIMT_Encode4(1658829), // Rule ID 5902 //
     /* 1658748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1658759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1658762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1658765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658794 */     // MIs[0] policy
     /* 1658794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658828 */     // GIR_Coverage, 5902,
     /* 1658828 */     GIR_EraseRootFromParent_Done,
     /* 1658829 */   // Label 22809: @1658829
     /* 1658829 */   GIM_Try, /*On fail goto*//*Label 22810*/ GIMT_Encode4(1658915), // Rule ID 5903 //
     /* 1658834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1658845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1658848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1658851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658880 */     // MIs[0] policy
     /* 1658880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658914 */     // GIR_Coverage, 5903,
     /* 1658914 */     GIR_EraseRootFromParent_Done,
     /* 1658915 */   // Label 22810: @1658915
     /* 1658915 */   GIM_Try, /*On fail goto*//*Label 22811*/ GIMT_Encode4(1659001), // Rule ID 5906 //
     /* 1658920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1658931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1658934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1658937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658966 */     // MIs[0] policy
     /* 1658966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658976 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659000 */     // GIR_Coverage, 5906,
     /* 1659000 */     GIR_EraseRootFromParent_Done,
     /* 1659001 */   // Label 22811: @1659001
     /* 1659001 */   GIM_Try, /*On fail goto*//*Label 22812*/ GIMT_Encode4(1659087), // Rule ID 5907 //
     /* 1659006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1659017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1659020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1659023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1659029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659052 */     // MIs[0] policy
     /* 1659052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659062 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1659065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659086 */     // GIR_Coverage, 5907,
     /* 1659086 */     GIR_EraseRootFromParent_Done,
     /* 1659087 */   // Label 22812: @1659087
     /* 1659087 */   GIM_Try, /*On fail goto*//*Label 22813*/ GIMT_Encode4(1659173), // Rule ID 5910 //
     /* 1659092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1659095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1659103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1659106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1659109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659138 */     // MIs[0] policy
     /* 1659138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659148 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1659151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1659169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659172 */     // GIR_Coverage, 5910,
     /* 1659172 */     GIR_EraseRootFromParent_Done,
     /* 1659173 */   // Label 22813: @1659173
     /* 1659173 */   GIM_Try, /*On fail goto*//*Label 22814*/ GIMT_Encode4(1659259), // Rule ID 5911 //
     /* 1659178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1659181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1659189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1659192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1659195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659224 */     // MIs[0] policy
     /* 1659224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659234 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1659237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1659255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659258 */     // GIR_Coverage, 5911,
     /* 1659258 */     GIR_EraseRootFromParent_Done,
     /* 1659259 */   // Label 22814: @1659259
     /* 1659259 */   GIM_Try, /*On fail goto*//*Label 22815*/ GIMT_Encode4(1659345), // Rule ID 5914 //
     /* 1659264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1659275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1659278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1659281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659310 */     // MIs[0] policy
     /* 1659310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659344 */     // GIR_Coverage, 5914,
     /* 1659344 */     GIR_EraseRootFromParent_Done,
     /* 1659345 */   // Label 22815: @1659345
     /* 1659345 */   GIM_Try, /*On fail goto*//*Label 22816*/ GIMT_Encode4(1659431), // Rule ID 5915 //
     /* 1659350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1659361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1659364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1659367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659396 */     // MIs[0] policy
     /* 1659396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659406 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659430 */     // GIR_Coverage, 5915,
     /* 1659430 */     GIR_EraseRootFromParent_Done,
     /* 1659431 */   // Label 22816: @1659431
     /* 1659431 */   GIM_Try, /*On fail goto*//*Label 22817*/ GIMT_Encode4(1659517), // Rule ID 5918 //
     /* 1659436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1659447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1659450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1659453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659482 */     // MIs[0] policy
     /* 1659482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659492 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1659495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659516 */     // GIR_Coverage, 5918,
     /* 1659516 */     GIR_EraseRootFromParent_Done,
     /* 1659517 */   // Label 22817: @1659517
     /* 1659517 */   GIM_Try, /*On fail goto*//*Label 22818*/ GIMT_Encode4(1659603), // Rule ID 5919 //
     /* 1659522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1659533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1659536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1659539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659568 */     // MIs[0] policy
     /* 1659568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659578 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1659581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659602 */     // GIR_Coverage, 5919,
     /* 1659602 */     GIR_EraseRootFromParent_Done,
     /* 1659603 */   // Label 22818: @1659603
     /* 1659603 */   GIM_Try, /*On fail goto*//*Label 22819*/ GIMT_Encode4(1659689), // Rule ID 5922 //
     /* 1659608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1659619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1659622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1659625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1659631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659654 */     // MIs[0] policy
     /* 1659654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659664 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1659667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659688 */     // GIR_Coverage, 5922,
     /* 1659688 */     GIR_EraseRootFromParent_Done,
     /* 1659689 */   // Label 22819: @1659689
     /* 1659689 */   GIM_Try, /*On fail goto*//*Label 22820*/ GIMT_Encode4(1659775), // Rule ID 5923 //
     /* 1659694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1659705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1659708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1659711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1659717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659740 */     // MIs[0] policy
     /* 1659740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659750 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1659753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659774 */     // GIR_Coverage, 5923,
     /* 1659774 */     GIR_EraseRootFromParent_Done,
     /* 1659775 */   // Label 22820: @1659775
     /* 1659775 */   GIM_Try, /*On fail goto*//*Label 22821*/ GIMT_Encode4(1659861), // Rule ID 5926 //
     /* 1659780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1659791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1659794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1659797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659826 */     // MIs[0] policy
     /* 1659826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659860 */     // GIR_Coverage, 5926,
     /* 1659860 */     GIR_EraseRootFromParent_Done,
     /* 1659861 */   // Label 22821: @1659861
     /* 1659861 */   GIM_Try, /*On fail goto*//*Label 22822*/ GIMT_Encode4(1659947), // Rule ID 5927 //
     /* 1659866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1659877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1659880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1659883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659912 */     // MIs[0] policy
     /* 1659912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659946 */     // GIR_Coverage, 5927,
     /* 1659946 */     GIR_EraseRootFromParent_Done,
     /* 1659947 */   // Label 22822: @1659947
     /* 1659947 */   GIM_Try, /*On fail goto*//*Label 22823*/ GIMT_Encode4(1660033), // Rule ID 5930 //
     /* 1659952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1659963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1659966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1659969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659998 */     // MIs[0] policy
     /* 1659998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660008 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660032 */     // GIR_Coverage, 5930,
     /* 1660032 */     GIR_EraseRootFromParent_Done,
     /* 1660033 */   // Label 22823: @1660033
     /* 1660033 */   GIM_Try, /*On fail goto*//*Label 22824*/ GIMT_Encode4(1660119), // Rule ID 5931 //
     /* 1660038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1660049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1660052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1660055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660084 */     // MIs[0] policy
     /* 1660084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660094 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660118 */     // GIR_Coverage, 5931,
     /* 1660118 */     GIR_EraseRootFromParent_Done,
     /* 1660119 */   // Label 22824: @1660119
     /* 1660119 */   GIM_Try, /*On fail goto*//*Label 22825*/ GIMT_Encode4(1660205), // Rule ID 5934 //
     /* 1660124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1660135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1660138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1660141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1660147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660170 */     // MIs[0] policy
     /* 1660170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660180 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660204 */     // GIR_Coverage, 5934,
     /* 1660204 */     GIR_EraseRootFromParent_Done,
     /* 1660205 */   // Label 22825: @1660205
     /* 1660205 */   GIM_Try, /*On fail goto*//*Label 22826*/ GIMT_Encode4(1660291), // Rule ID 5935 //
     /* 1660210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1660221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1660224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1660227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1660233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660256 */     // MIs[0] policy
     /* 1660256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660266 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660290 */     // GIR_Coverage, 5935,
     /* 1660290 */     GIR_EraseRootFromParent_Done,
     /* 1660291 */   // Label 22826: @1660291
     /* 1660291 */   GIM_Try, /*On fail goto*//*Label 22827*/ GIMT_Encode4(1660377), // Rule ID 5938 //
     /* 1660296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1660307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1660310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1660313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660342 */     // MIs[0] policy
     /* 1660342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1660355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660376 */     // GIR_Coverage, 5938,
     /* 1660376 */     GIR_EraseRootFromParent_Done,
     /* 1660377 */   // Label 22827: @1660377
     /* 1660377 */   GIM_Try, /*On fail goto*//*Label 22828*/ GIMT_Encode4(1660463), // Rule ID 5939 //
     /* 1660382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1660393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1660396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1660399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660428 */     // MIs[0] policy
     /* 1660428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1660441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660462 */     // GIR_Coverage, 5939,
     /* 1660462 */     GIR_EraseRootFromParent_Done,
     /* 1660463 */   // Label 22828: @1660463
     /* 1660463 */   GIM_Try, /*On fail goto*//*Label 22829*/ GIMT_Encode4(1660549), // Rule ID 5942 //
     /* 1660468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1660479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1660482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1660485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660514 */     // MIs[0] policy
     /* 1660514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660548 */     // GIR_Coverage, 5942,
     /* 1660548 */     GIR_EraseRootFromParent_Done,
     /* 1660549 */   // Label 22829: @1660549
     /* 1660549 */   GIM_Try, /*On fail goto*//*Label 22830*/ GIMT_Encode4(1660635), // Rule ID 5943 //
     /* 1660554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1660565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1660568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1660571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660600 */     // MIs[0] policy
     /* 1660600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660610 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660634 */     // GIR_Coverage, 5943,
     /* 1660634 */     GIR_EraseRootFromParent_Done,
     /* 1660635 */   // Label 22830: @1660635
     /* 1660635 */   GIM_Try, /*On fail goto*//*Label 22831*/ GIMT_Encode4(1660721), // Rule ID 5946 //
     /* 1660640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1660651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1660654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1660657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660686 */     // MIs[0] policy
     /* 1660686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660720 */     // GIR_Coverage, 5946,
     /* 1660720 */     GIR_EraseRootFromParent_Done,
     /* 1660721 */   // Label 22831: @1660721
     /* 1660721 */   GIM_Try, /*On fail goto*//*Label 22832*/ GIMT_Encode4(1660807), // Rule ID 5947 //
     /* 1660726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1660737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1660740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1660743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660772 */     // MIs[0] policy
     /* 1660772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660782 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660806 */     // GIR_Coverage, 5947,
     /* 1660806 */     GIR_EraseRootFromParent_Done,
     /* 1660807 */   // Label 22832: @1660807
     /* 1660807 */   GIM_Try, /*On fail goto*//*Label 22833*/ GIMT_Encode4(1660893), // Rule ID 5950 //
     /* 1660812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1660823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1660826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1660829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660858 */     // MIs[0] policy
     /* 1660858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1660871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660892 */     // GIR_Coverage, 5950,
     /* 1660892 */     GIR_EraseRootFromParent_Done,
     /* 1660893 */   // Label 22833: @1660893
     /* 1660893 */   GIM_Try, /*On fail goto*//*Label 22834*/ GIMT_Encode4(1660979), // Rule ID 5951 //
     /* 1660898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1660901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1660909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1660912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1660915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660944 */     // MIs[0] policy
     /* 1660944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660954 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1660957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660978 */     // GIR_Coverage, 5951,
     /* 1660978 */     GIR_EraseRootFromParent_Done,
     /* 1660979 */   // Label 22834: @1660979
     /* 1660979 */   GIM_Try, /*On fail goto*//*Label 22835*/ GIMT_Encode4(1661065), // Rule ID 5954 //
     /* 1660984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1660995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1660998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1661001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661030 */     // MIs[0] policy
     /* 1661030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661040 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1661043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661064 */     // GIR_Coverage, 5954,
     /* 1661064 */     GIR_EraseRootFromParent_Done,
     /* 1661065 */   // Label 22835: @1661065
     /* 1661065 */   GIM_Try, /*On fail goto*//*Label 22836*/ GIMT_Encode4(1661151), // Rule ID 5955 //
     /* 1661070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1661073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1661081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1661084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1661087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661116 */     // MIs[0] policy
     /* 1661116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661126 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1661129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661150 */     // GIR_Coverage, 5955,
     /* 1661150 */     GIR_EraseRootFromParent_Done,
     /* 1661151 */   // Label 22836: @1661151
     /* 1661151 */   GIM_Try, /*On fail goto*//*Label 22837*/ GIMT_Encode4(1661237), // Rule ID 5958 //
     /* 1661156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1661159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1661167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1661170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1661173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661202 */     // MIs[0] policy
     /* 1661202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661212 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1661215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661236 */     // GIR_Coverage, 5958,
     /* 1661236 */     GIR_EraseRootFromParent_Done,
     /* 1661237 */   // Label 22837: @1661237
     /* 1661237 */   GIM_Try, /*On fail goto*//*Label 22838*/ GIMT_Encode4(1661323), // Rule ID 5959 //
     /* 1661242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1661245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1661253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1661256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1661259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661288 */     // MIs[0] policy
     /* 1661288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661298 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1661301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661322 */     // GIR_Coverage, 5959,
     /* 1661322 */     GIR_EraseRootFromParent_Done,
     /* 1661323 */   // Label 22838: @1661323
     /* 1661323 */   GIM_Try, /*On fail goto*//*Label 22839*/ GIMT_Encode4(1661409), // Rule ID 6050 //
     /* 1661328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1661339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1661342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1661345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1661348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661374 */     // MIs[0] policy
     /* 1661374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661384 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1661387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661408 */     // GIR_Coverage, 6050,
     /* 1661408 */     GIR_EraseRootFromParent_Done,
     /* 1661409 */   // Label 22839: @1661409
     /* 1661409 */   GIM_Try, /*On fail goto*//*Label 22840*/ GIMT_Encode4(1661495), // Rule ID 6051 //
     /* 1661414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1661425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1661428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1661431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1661434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661460 */     // MIs[0] policy
     /* 1661460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661470 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1661473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661494 */     // GIR_Coverage, 6051,
     /* 1661494 */     GIR_EraseRootFromParent_Done,
     /* 1661495 */   // Label 22840: @1661495
     /* 1661495 */   GIM_Try, /*On fail goto*//*Label 22841*/ GIMT_Encode4(1661581), // Rule ID 6054 //
     /* 1661500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1661511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1661514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1661517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1661520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661546 */     // MIs[0] policy
     /* 1661546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661556 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661580 */     // GIR_Coverage, 6054,
     /* 1661580 */     GIR_EraseRootFromParent_Done,
     /* 1661581 */   // Label 22841: @1661581
     /* 1661581 */   GIM_Try, /*On fail goto*//*Label 22842*/ GIMT_Encode4(1661667), // Rule ID 6055 //
     /* 1661586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1661597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1661600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1661603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1661606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661632 */     // MIs[0] policy
     /* 1661632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661642 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661666 */     // GIR_Coverage, 6055,
     /* 1661666 */     GIR_EraseRootFromParent_Done,
     /* 1661667 */   // Label 22842: @1661667
     /* 1661667 */   GIM_Try, /*On fail goto*//*Label 22843*/ GIMT_Encode4(1661753), // Rule ID 6058 //
     /* 1661672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1661683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1661686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1661689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1661692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661718 */     // MIs[0] policy
     /* 1661718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661728 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661752 */     // GIR_Coverage, 6058,
     /* 1661752 */     GIR_EraseRootFromParent_Done,
     /* 1661753 */   // Label 22843: @1661753
     /* 1661753 */   GIM_Try, /*On fail goto*//*Label 22844*/ GIMT_Encode4(1661839), // Rule ID 6059 //
     /* 1661758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1661769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1661772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1661775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1661778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661804 */     // MIs[0] policy
     /* 1661804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661814 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661838 */     // GIR_Coverage, 6059,
     /* 1661838 */     GIR_EraseRootFromParent_Done,
     /* 1661839 */   // Label 22844: @1661839
     /* 1661839 */   GIM_Try, /*On fail goto*//*Label 22845*/ GIMT_Encode4(1661925), // Rule ID 6062 //
     /* 1661844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1661855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1661858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1661861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1661864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661890 */     // MIs[0] policy
     /* 1661890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661900 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661924 */     // GIR_Coverage, 6062,
     /* 1661924 */     GIR_EraseRootFromParent_Done,
     /* 1661925 */   // Label 22845: @1661925
     /* 1661925 */   GIM_Try, /*On fail goto*//*Label 22846*/ GIMT_Encode4(1662011), // Rule ID 6063 //
     /* 1661930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1661941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1661944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1661947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1661950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661976 */     // MIs[0] policy
     /* 1661976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661986 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662010 */     // GIR_Coverage, 6063,
     /* 1662010 */     GIR_EraseRootFromParent_Done,
     /* 1662011 */   // Label 22846: @1662011
     /* 1662011 */   GIM_Try, /*On fail goto*//*Label 22847*/ GIMT_Encode4(1662097), // Rule ID 6066 //
     /* 1662016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1662027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1662030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1662033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1662036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662062 */     // MIs[0] policy
     /* 1662062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662072 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1662075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662096 */     // GIR_Coverage, 6066,
     /* 1662096 */     GIR_EraseRootFromParent_Done,
     /* 1662097 */   // Label 22847: @1662097
     /* 1662097 */   GIM_Try, /*On fail goto*//*Label 22848*/ GIMT_Encode4(1662183), // Rule ID 6067 //
     /* 1662102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1662113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1662116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1662119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1662122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662148 */     // MIs[0] policy
     /* 1662148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662158 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1662161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662182 */     // GIR_Coverage, 6067,
     /* 1662182 */     GIR_EraseRootFromParent_Done,
     /* 1662183 */   // Label 22848: @1662183
     /* 1662183 */   GIM_Try, /*On fail goto*//*Label 22849*/ GIMT_Encode4(1662269), // Rule ID 6070 //
     /* 1662188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1662199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1662202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1662205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1662208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662234 */     // MIs[0] policy
     /* 1662234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662244 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1662247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662268 */     // GIR_Coverage, 6070,
     /* 1662268 */     GIR_EraseRootFromParent_Done,
     /* 1662269 */   // Label 22849: @1662269
     /* 1662269 */   GIM_Try, /*On fail goto*//*Label 22850*/ GIMT_Encode4(1662355), // Rule ID 6071 //
     /* 1662274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1662285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1662288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1662291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1662294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662320 */     // MIs[0] policy
     /* 1662320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662330 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1662333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662354 */     // GIR_Coverage, 6071,
     /* 1662354 */     GIR_EraseRootFromParent_Done,
     /* 1662355 */   // Label 22850: @1662355
     /* 1662355 */   GIM_Try, /*On fail goto*//*Label 22851*/ GIMT_Encode4(1662441), // Rule ID 6074 //
     /* 1662360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1662371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1662374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1662377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1662380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1662383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662406 */     // MIs[0] policy
     /* 1662406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662416 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662440 */     // GIR_Coverage, 6074,
     /* 1662440 */     GIR_EraseRootFromParent_Done,
     /* 1662441 */   // Label 22851: @1662441
     /* 1662441 */   GIM_Try, /*On fail goto*//*Label 22852*/ GIMT_Encode4(1662527), // Rule ID 6075 //
     /* 1662446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1662457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1662460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1662463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1662466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1662469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662492 */     // MIs[0] policy
     /* 1662492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662526 */     // GIR_Coverage, 6075,
     /* 1662526 */     GIR_EraseRootFromParent_Done,
     /* 1662527 */   // Label 22852: @1662527
     /* 1662527 */   GIM_Try, /*On fail goto*//*Label 22853*/ GIMT_Encode4(1662613), // Rule ID 6078 //
     /* 1662532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1662543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1662546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1662549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1662552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662578 */     // MIs[0] policy
     /* 1662578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662588 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662612 */     // GIR_Coverage, 6078,
     /* 1662612 */     GIR_EraseRootFromParent_Done,
     /* 1662613 */   // Label 22853: @1662613
     /* 1662613 */   GIM_Try, /*On fail goto*//*Label 22854*/ GIMT_Encode4(1662699), // Rule ID 6079 //
     /* 1662618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1662629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1662632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1662635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1662638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662664 */     // MIs[0] policy
     /* 1662664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662698 */     // GIR_Coverage, 6079,
     /* 1662698 */     GIR_EraseRootFromParent_Done,
     /* 1662699 */   // Label 22854: @1662699
     /* 1662699 */   GIM_Try, /*On fail goto*//*Label 22855*/ GIMT_Encode4(1662785), // Rule ID 6082 //
     /* 1662704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1662715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1662718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1662721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1662724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662750 */     // MIs[0] policy
     /* 1662750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662760 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662784 */     // GIR_Coverage, 6082,
     /* 1662784 */     GIR_EraseRootFromParent_Done,
     /* 1662785 */   // Label 22855: @1662785
     /* 1662785 */   GIM_Try, /*On fail goto*//*Label 22856*/ GIMT_Encode4(1662871), // Rule ID 6083 //
     /* 1662790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1662801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1662804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1662807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1662810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662836 */     // MIs[0] policy
     /* 1662836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662846 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662870 */     // GIR_Coverage, 6083,
     /* 1662870 */     GIR_EraseRootFromParent_Done,
     /* 1662871 */   // Label 22856: @1662871
     /* 1662871 */   GIM_Try, /*On fail goto*//*Label 22857*/ GIMT_Encode4(1662957), // Rule ID 6086 //
     /* 1662876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1662879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1662887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1662890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1662893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1662896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662922 */     // MIs[0] policy
     /* 1662922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662932 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662956 */     // GIR_Coverage, 6086,
     /* 1662956 */     GIR_EraseRootFromParent_Done,
     /* 1662957 */   // Label 22857: @1662957
     /* 1662957 */   GIM_Try, /*On fail goto*//*Label 22858*/ GIMT_Encode4(1663043), // Rule ID 6087 //
     /* 1662962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1662965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1662973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1662976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1662979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1662982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663008 */     // MIs[0] policy
     /* 1663008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663018 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1663021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1663039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663042 */     // GIR_Coverage, 6087,
     /* 1663042 */     GIR_EraseRootFromParent_Done,
     /* 1663043 */   // Label 22858: @1663043
     /* 1663043 */   GIM_Try, /*On fail goto*//*Label 22859*/ GIMT_Encode4(1663129), // Rule ID 6090 //
     /* 1663048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1663059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1663062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1663065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1663068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663094 */     // MIs[0] policy
     /* 1663094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663104 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663128 */     // GIR_Coverage, 6090,
     /* 1663128 */     GIR_EraseRootFromParent_Done,
     /* 1663129 */   // Label 22859: @1663129
     /* 1663129 */   GIM_Try, /*On fail goto*//*Label 22860*/ GIMT_Encode4(1663215), // Rule ID 6091 //
     /* 1663134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1663145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1663148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1663151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1663154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663180 */     // MIs[0] policy
     /* 1663180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663214 */     // GIR_Coverage, 6091,
     /* 1663214 */     GIR_EraseRootFromParent_Done,
     /* 1663215 */   // Label 22860: @1663215
     /* 1663215 */   GIM_Try, /*On fail goto*//*Label 22861*/ GIMT_Encode4(1663301), // Rule ID 6094 //
     /* 1663220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1663231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1663234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1663237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1663240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663266 */     // MIs[0] policy
     /* 1663266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663276 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663300 */     // GIR_Coverage, 6094,
     /* 1663300 */     GIR_EraseRootFromParent_Done,
     /* 1663301 */   // Label 22861: @1663301
     /* 1663301 */   GIM_Try, /*On fail goto*//*Label 22862*/ GIMT_Encode4(1663387), // Rule ID 6095 //
     /* 1663306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1663317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1663320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1663323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1663326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663352 */     // MIs[0] policy
     /* 1663352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663362 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663386 */     // GIR_Coverage, 6095,
     /* 1663386 */     GIR_EraseRootFromParent_Done,
     /* 1663387 */   // Label 22862: @1663387
     /* 1663387 */   GIM_Try, /*On fail goto*//*Label 22863*/ GIMT_Encode4(1663473), // Rule ID 6098 //
     /* 1663392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1663403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1663406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1663409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1663412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1663415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663438 */     // MIs[0] policy
     /* 1663438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663448 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1663451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663472 */     // GIR_Coverage, 6098,
     /* 1663472 */     GIR_EraseRootFromParent_Done,
     /* 1663473 */   // Label 22863: @1663473
     /* 1663473 */   GIM_Try, /*On fail goto*//*Label 22864*/ GIMT_Encode4(1663559), // Rule ID 6099 //
     /* 1663478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1663489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1663492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1663495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1663498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1663501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663524 */     // MIs[0] policy
     /* 1663524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663534 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1663537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663558 */     // GIR_Coverage, 6099,
     /* 1663558 */     GIR_EraseRootFromParent_Done,
     /* 1663559 */   // Label 22864: @1663559
     /* 1663559 */   GIM_Try, /*On fail goto*//*Label 22865*/ GIMT_Encode4(1663645), // Rule ID 6102 //
     /* 1663564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1663575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1663578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1663581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1663584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663610 */     // MIs[0] policy
     /* 1663610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663620 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663644 */     // GIR_Coverage, 6102,
     /* 1663644 */     GIR_EraseRootFromParent_Done,
     /* 1663645 */   // Label 22865: @1663645
     /* 1663645 */   GIM_Try, /*On fail goto*//*Label 22866*/ GIMT_Encode4(1663731), // Rule ID 6103 //
     /* 1663650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1663661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1663664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1663667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1663670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663696 */     // MIs[0] policy
     /* 1663696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663706 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663730 */     // GIR_Coverage, 6103,
     /* 1663730 */     GIR_EraseRootFromParent_Done,
     /* 1663731 */   // Label 22866: @1663731
     /* 1663731 */   GIM_Try, /*On fail goto*//*Label 22867*/ GIMT_Encode4(1663817), // Rule ID 6106 //
     /* 1663736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1663747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1663750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1663753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1663756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663782 */     // MIs[0] policy
     /* 1663782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663792 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663816 */     // GIR_Coverage, 6106,
     /* 1663816 */     GIR_EraseRootFromParent_Done,
     /* 1663817 */   // Label 22867: @1663817
     /* 1663817 */   GIM_Try, /*On fail goto*//*Label 22868*/ GIMT_Encode4(1663903), // Rule ID 6107 //
     /* 1663822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1663833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1663836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1663839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1663842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663868 */     // MIs[0] policy
     /* 1663868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663878 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663902 */     // GIR_Coverage, 6107,
     /* 1663902 */     GIR_EraseRootFromParent_Done,
     /* 1663903 */   // Label 22868: @1663903
     /* 1663903 */   GIM_Try, /*On fail goto*//*Label 22869*/ GIMT_Encode4(1663989), // Rule ID 6110 //
     /* 1663908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1663919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1663922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1663925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1663928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663954 */     // MIs[0] policy
     /* 1663954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663964 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1663967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663988 */     // GIR_Coverage, 6110,
     /* 1663988 */     GIR_EraseRootFromParent_Done,
     /* 1663989 */   // Label 22869: @1663989
     /* 1663989 */   GIM_Try, /*On fail goto*//*Label 22870*/ GIMT_Encode4(1664075), // Rule ID 6111 //
     /* 1663994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1664005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1664008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1664011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1664014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1664017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664040 */     // MIs[0] policy
     /* 1664040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664050 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664074 */     // GIR_Coverage, 6111,
     /* 1664074 */     GIR_EraseRootFromParent_Done,
     /* 1664075 */   // Label 22870: @1664075
     /* 1664075 */   GIM_Try, /*On fail goto*//*Label 22871*/ GIMT_Encode4(1664161), // Rule ID 6114 //
     /* 1664080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1664091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1664094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1664097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1664100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664126 */     // MIs[0] policy
     /* 1664126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1664139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664160 */     // GIR_Coverage, 6114,
     /* 1664160 */     GIR_EraseRootFromParent_Done,
     /* 1664161 */   // Label 22871: @1664161
     /* 1664161 */   GIM_Try, /*On fail goto*//*Label 22872*/ GIMT_Encode4(1664247), // Rule ID 6115 //
     /* 1664166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1664177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1664180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1664183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1664186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664212 */     // MIs[0] policy
     /* 1664212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664222 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1664225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664246 */     // GIR_Coverage, 6115,
     /* 1664246 */     GIR_EraseRootFromParent_Done,
     /* 1664247 */   // Label 22872: @1664247
     /* 1664247 */   GIM_Try, /*On fail goto*//*Label 22873*/ GIMT_Encode4(1664333), // Rule ID 6118 //
     /* 1664252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1664263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1664266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1664269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1664272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664298 */     // MIs[0] policy
     /* 1664298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664308 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1664311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664332 */     // GIR_Coverage, 6118,
     /* 1664332 */     GIR_EraseRootFromParent_Done,
     /* 1664333 */   // Label 22873: @1664333
     /* 1664333 */   GIM_Try, /*On fail goto*//*Label 22874*/ GIMT_Encode4(1664419), // Rule ID 6119 //
     /* 1664338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1664349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1664352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1664355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1664358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664384 */     // MIs[0] policy
     /* 1664384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664394 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1664397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664418 */     // GIR_Coverage, 6119,
     /* 1664418 */     GIR_EraseRootFromParent_Done,
     /* 1664419 */   // Label 22874: @1664419
     /* 1664419 */   GIM_Try, /*On fail goto*//*Label 22875*/ GIMT_Encode4(1664505), // Rule ID 6122 //
     /* 1664424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1664435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1664438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1664441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1664444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664470 */     // MIs[0] policy
     /* 1664470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664480 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664504 */     // GIR_Coverage, 6122,
     /* 1664504 */     GIR_EraseRootFromParent_Done,
     /* 1664505 */   // Label 22875: @1664505
     /* 1664505 */   GIM_Try, /*On fail goto*//*Label 22876*/ GIMT_Encode4(1664591), // Rule ID 6123 //
     /* 1664510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1664521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1664524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1664527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1664530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664556 */     // MIs[0] policy
     /* 1664556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664566 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664590 */     // GIR_Coverage, 6123,
     /* 1664590 */     GIR_EraseRootFromParent_Done,
     /* 1664591 */   // Label 22876: @1664591
     /* 1664591 */   GIM_Try, /*On fail goto*//*Label 22877*/ GIMT_Encode4(1664677), // Rule ID 6126 //
     /* 1664596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1664607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1664610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1664613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1664616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664642 */     // MIs[0] policy
     /* 1664642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1664655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664676 */     // GIR_Coverage, 6126,
     /* 1664676 */     GIR_EraseRootFromParent_Done,
     /* 1664677 */   // Label 22877: @1664677
     /* 1664677 */   GIM_Try, /*On fail goto*//*Label 22878*/ GIMT_Encode4(1664763), // Rule ID 6127 //
     /* 1664682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1664693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1664696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1664699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1664702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664728 */     // MIs[0] policy
     /* 1664728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664738 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1664741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664762 */     // GIR_Coverage, 6127,
     /* 1664762 */     GIR_EraseRootFromParent_Done,
     /* 1664763 */   // Label 22878: @1664763
     /* 1664763 */   GIM_Try, /*On fail goto*//*Label 22879*/ GIMT_Encode4(1664849), // Rule ID 6130 //
     /* 1664768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1664779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1664782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1664785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1664788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664814 */     // MIs[0] policy
     /* 1664814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664824 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1664827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664848 */     // GIR_Coverage, 6130,
     /* 1664848 */     GIR_EraseRootFromParent_Done,
     /* 1664849 */   // Label 22879: @1664849
     /* 1664849 */   GIM_Try, /*On fail goto*//*Label 22880*/ GIMT_Encode4(1664935), // Rule ID 6131 //
     /* 1664854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1664865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1664868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1664871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1664874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664900 */     // MIs[0] policy
     /* 1664900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664910 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1664913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664934 */     // GIR_Coverage, 6131,
     /* 1664934 */     GIR_EraseRootFromParent_Done,
     /* 1664935 */   // Label 22880: @1664935
     /* 1664935 */   GIM_Try, /*On fail goto*//*Label 22881*/ GIMT_Encode4(1665021), // Rule ID 6134 //
     /* 1664940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1664951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1664954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1664957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1664960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664986 */     // MIs[0] policy
     /* 1664986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664996 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665020 */     // GIR_Coverage, 6134,
     /* 1665020 */     GIR_EraseRootFromParent_Done,
     /* 1665021 */   // Label 22881: @1665021
     /* 1665021 */   GIM_Try, /*On fail goto*//*Label 22882*/ GIMT_Encode4(1665107), // Rule ID 6135 //
     /* 1665026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1665029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1665037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1665040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1665043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1665046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1665056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665072 */     // MIs[0] policy
     /* 1665072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665082 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1665085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665106 */     // GIR_Coverage, 6135,
     /* 1665106 */     GIR_EraseRootFromParent_Done,
     /* 1665107 */   // Label 22882: @1665107
     /* 1665107 */   GIM_Try, /*On fail goto*//*Label 22883*/ GIMT_Encode4(1665193), // Rule ID 6138 //
     /* 1665112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1665123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1665126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1665129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665158 */     // MIs[0] policy
     /* 1665158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665168 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1665171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665192 */     // GIR_Coverage, 6138,
     /* 1665192 */     GIR_EraseRootFromParent_Done,
     /* 1665193 */   // Label 22883: @1665193
     /* 1665193 */   GIM_Try, /*On fail goto*//*Label 22884*/ GIMT_Encode4(1665279), // Rule ID 6139 //
     /* 1665198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1665209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1665212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1665215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665244 */     // MIs[0] policy
     /* 1665244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665254 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1665257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665278 */     // GIR_Coverage, 6139,
     /* 1665278 */     GIR_EraseRootFromParent_Done,
     /* 1665279 */   // Label 22884: @1665279
     /* 1665279 */   GIM_Try, /*On fail goto*//*Label 22885*/ GIMT_Encode4(1665365), // Rule ID 6142 //
     /* 1665284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1665295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1665298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1665301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665330 */     // MIs[0] policy
     /* 1665330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665340 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1665343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665364 */     // GIR_Coverage, 6142,
     /* 1665364 */     GIR_EraseRootFromParent_Done,
     /* 1665365 */   // Label 22885: @1665365
     /* 1665365 */   GIM_Try, /*On fail goto*//*Label 22886*/ GIMT_Encode4(1665451), // Rule ID 6143 //
     /* 1665370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1665381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1665384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1665387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665416 */     // MIs[0] policy
     /* 1665416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665426 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1665429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665450 */     // GIR_Coverage, 6143,
     /* 1665450 */     GIR_EraseRootFromParent_Done,
     /* 1665451 */   // Label 22886: @1665451
     /* 1665451 */   GIM_Try, /*On fail goto*//*Label 22887*/ GIMT_Encode4(1665537), // Rule ID 6146 //
     /* 1665456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1665467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1665470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1665473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665502 */     // MIs[0] policy
     /* 1665502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665512 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665536 */     // GIR_Coverage, 6146,
     /* 1665536 */     GIR_EraseRootFromParent_Done,
     /* 1665537 */   // Label 22887: @1665537
     /* 1665537 */   GIM_Try, /*On fail goto*//*Label 22888*/ GIMT_Encode4(1665623), // Rule ID 6147 //
     /* 1665542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1665553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1665556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1665559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665588 */     // MIs[0] policy
     /* 1665588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665598 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665622 */     // GIR_Coverage, 6147,
     /* 1665622 */     GIR_EraseRootFromParent_Done,
     /* 1665623 */   // Label 22888: @1665623
     /* 1665623 */   GIM_Try, /*On fail goto*//*Label 22889*/ GIMT_Encode4(1665709), // Rule ID 6150 //
     /* 1665628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1665639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1665642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1665645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665674 */     // MIs[0] policy
     /* 1665674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665684 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1665687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665708 */     // GIR_Coverage, 6150,
     /* 1665708 */     GIR_EraseRootFromParent_Done,
     /* 1665709 */   // Label 22889: @1665709
     /* 1665709 */   GIM_Try, /*On fail goto*//*Label 22890*/ GIMT_Encode4(1665795), // Rule ID 6151 //
     /* 1665714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1665725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1665728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1665731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665760 */     // MIs[0] policy
     /* 1665760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665770 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1665773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665794 */     // GIR_Coverage, 6151,
     /* 1665794 */     GIR_EraseRootFromParent_Done,
     /* 1665795 */   // Label 22890: @1665795
     /* 1665795 */   GIM_Try, /*On fail goto*//*Label 22891*/ GIMT_Encode4(1665881), // Rule ID 6154 //
     /* 1665800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1665811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1665814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1665817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665846 */     // MIs[0] policy
     /* 1665846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665856 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665880 */     // GIR_Coverage, 6154,
     /* 1665880 */     GIR_EraseRootFromParent_Done,
     /* 1665881 */   // Label 22891: @1665881
     /* 1665881 */   GIM_Try, /*On fail goto*//*Label 22892*/ GIMT_Encode4(1665967), // Rule ID 6155 //
     /* 1665886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1665897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1665900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1665903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665932 */     // MIs[0] policy
     /* 1665932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665942 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665966 */     // GIR_Coverage, 6155,
     /* 1665966 */     GIR_EraseRootFromParent_Done,
     /* 1665967 */   // Label 22892: @1665967
     /* 1665967 */   GIM_Try, /*On fail goto*//*Label 22893*/ GIMT_Encode4(1666053), // Rule ID 6158 //
     /* 1665972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1665983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1665986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1665989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666018 */     // MIs[0] policy
     /* 1666018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666028 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1666031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666052 */     // GIR_Coverage, 6158,
     /* 1666052 */     GIR_EraseRootFromParent_Done,
     /* 1666053 */   // Label 22893: @1666053
     /* 1666053 */   GIM_Try, /*On fail goto*//*Label 22894*/ GIMT_Encode4(1666139), // Rule ID 6159 //
     /* 1666058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1666069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1666072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1666075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666104 */     // MIs[0] policy
     /* 1666104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666114 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1666117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666138 */     // GIR_Coverage, 6159,
     /* 1666138 */     GIR_EraseRootFromParent_Done,
     /* 1666139 */   // Label 22894: @1666139
     /* 1666139 */   GIM_Try, /*On fail goto*//*Label 22895*/ GIMT_Encode4(1666225), // Rule ID 6162 //
     /* 1666144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1666155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1666158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1666161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666190 */     // MIs[0] policy
     /* 1666190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666200 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666224 */     // GIR_Coverage, 6162,
     /* 1666224 */     GIR_EraseRootFromParent_Done,
     /* 1666225 */   // Label 22895: @1666225
     /* 1666225 */   GIM_Try, /*On fail goto*//*Label 22896*/ GIMT_Encode4(1666311), // Rule ID 6163 //
     /* 1666230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1666241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1666244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1666247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666276 */     // MIs[0] policy
     /* 1666276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666286 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666310 */     // GIR_Coverage, 6163,
     /* 1666310 */     GIR_EraseRootFromParent_Done,
     /* 1666311 */   // Label 22896: @1666311
     /* 1666311 */   GIM_Try, /*On fail goto*//*Label 22897*/ GIMT_Encode4(1666397), // Rule ID 6166 //
     /* 1666316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1666327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1666330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1666333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666362 */     // MIs[0] policy
     /* 1666362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666372 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666396 */     // GIR_Coverage, 6166,
     /* 1666396 */     GIR_EraseRootFromParent_Done,
     /* 1666397 */   // Label 22897: @1666397
     /* 1666397 */   GIM_Try, /*On fail goto*//*Label 22898*/ GIMT_Encode4(1666483), // Rule ID 6167 //
     /* 1666402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1666413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1666416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1666419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666448 */     // MIs[0] policy
     /* 1666448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666458 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666482 */     // GIR_Coverage, 6167,
     /* 1666482 */     GIR_EraseRootFromParent_Done,
     /* 1666483 */   // Label 22898: @1666483
     /* 1666483 */   GIM_Try, /*On fail goto*//*Label 22899*/ GIMT_Encode4(1666569), // Rule ID 6170 //
     /* 1666488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1666499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1666502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1666505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666534 */     // MIs[0] policy
     /* 1666534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666544 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666568 */     // GIR_Coverage, 6170,
     /* 1666568 */     GIR_EraseRootFromParent_Done,
     /* 1666569 */   // Label 22899: @1666569
     /* 1666569 */   GIM_Try, /*On fail goto*//*Label 22900*/ GIMT_Encode4(1666655), // Rule ID 6171 //
     /* 1666574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1666585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1666588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1666591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666620 */     // MIs[0] policy
     /* 1666620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666630 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666654 */     // GIR_Coverage, 6171,
     /* 1666654 */     GIR_EraseRootFromParent_Done,
     /* 1666655 */   // Label 22900: @1666655
     /* 1666655 */   GIM_Try, /*On fail goto*//*Label 22901*/ GIMT_Encode4(1666741), // Rule ID 6174 //
     /* 1666660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1666663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1666671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1666674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1666677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666706 */     // MIs[0] policy
     /* 1666706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666716 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666740 */     // GIR_Coverage, 6174,
     /* 1666740 */     GIR_EraseRootFromParent_Done,
     /* 1666741 */   // Label 22901: @1666741
     /* 1666741 */   GIM_Try, /*On fail goto*//*Label 22902*/ GIMT_Encode4(1666827), // Rule ID 6175 //
     /* 1666746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1666749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1666757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1666760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1666763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666792 */     // MIs[0] policy
     /* 1666792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666826 */     // GIR_Coverage, 6175,
     /* 1666826 */     GIR_EraseRootFromParent_Done,
     /* 1666827 */   // Label 22902: @1666827
     /* 1666827 */   GIM_Try, /*On fail goto*//*Label 22903*/ GIMT_Encode4(1666913), // Rule ID 6178 //
     /* 1666832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1666843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1666846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1666849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1666855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666878 */     // MIs[0] policy
     /* 1666878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666888 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1666891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666912 */     // GIR_Coverage, 6178,
     /* 1666912 */     GIR_EraseRootFromParent_Done,
     /* 1666913 */   // Label 22903: @1666913
     /* 1666913 */   GIM_Try, /*On fail goto*//*Label 22904*/ GIMT_Encode4(1666999), // Rule ID 6179 //
     /* 1666918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1666929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1666932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1666935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1666941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666964 */     // MIs[0] policy
     /* 1666964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666974 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1666977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666998 */     // GIR_Coverage, 6179,
     /* 1666998 */     GIR_EraseRootFromParent_Done,
     /* 1666999 */   // Label 22904: @1666999
     /* 1666999 */   GIM_Try, /*On fail goto*//*Label 22905*/ GIMT_Encode4(1667085), // Rule ID 6182 //
     /* 1667004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1667015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1667018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1667021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667050 */     // MIs[0] policy
     /* 1667050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667060 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667084 */     // GIR_Coverage, 6182,
     /* 1667084 */     GIR_EraseRootFromParent_Done,
     /* 1667085 */   // Label 22905: @1667085
     /* 1667085 */   GIM_Try, /*On fail goto*//*Label 22906*/ GIMT_Encode4(1667171), // Rule ID 6183 //
     /* 1667090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1667101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1667104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1667107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667136 */     // MIs[0] policy
     /* 1667136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667170 */     // GIR_Coverage, 6183,
     /* 1667170 */     GIR_EraseRootFromParent_Done,
     /* 1667171 */   // Label 22906: @1667171
     /* 1667171 */   GIM_Try, /*On fail goto*//*Label 22907*/ GIMT_Encode4(1667257), // Rule ID 6186 //
     /* 1667176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1667187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1667190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1667193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1667199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667222 */     // MIs[0] policy
     /* 1667222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667232 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667256 */     // GIR_Coverage, 6186,
     /* 1667256 */     GIR_EraseRootFromParent_Done,
     /* 1667257 */   // Label 22907: @1667257
     /* 1667257 */   GIM_Try, /*On fail goto*//*Label 22908*/ GIMT_Encode4(1667343), // Rule ID 6187 //
     /* 1667262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1667273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1667276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1667279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1667285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667308 */     // MIs[0] policy
     /* 1667308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667318 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667342 */     // GIR_Coverage, 6187,
     /* 1667342 */     GIR_EraseRootFromParent_Done,
     /* 1667343 */   // Label 22908: @1667343
     /* 1667343 */   GIM_Try, /*On fail goto*//*Label 22909*/ GIMT_Encode4(1667429), // Rule ID 6190 //
     /* 1667348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1667359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1667362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1667365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667394 */     // MIs[0] policy
     /* 1667394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667428 */     // GIR_Coverage, 6190,
     /* 1667428 */     GIR_EraseRootFromParent_Done,
     /* 1667429 */   // Label 22909: @1667429
     /* 1667429 */   GIM_Try, /*On fail goto*//*Label 22910*/ GIMT_Encode4(1667515), // Rule ID 6191 //
     /* 1667434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1667445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1667448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1667451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667480 */     // MIs[0] policy
     /* 1667480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667514 */     // GIR_Coverage, 6191,
     /* 1667514 */     GIR_EraseRootFromParent_Done,
     /* 1667515 */   // Label 22910: @1667515
     /* 1667515 */   GIM_Try, /*On fail goto*//*Label 22911*/ GIMT_Encode4(1667601), // Rule ID 6194 //
     /* 1667520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1667531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1667534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1667537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667566 */     // MIs[0] policy
     /* 1667566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667576 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667600 */     // GIR_Coverage, 6194,
     /* 1667600 */     GIR_EraseRootFromParent_Done,
     /* 1667601 */   // Label 22911: @1667601
     /* 1667601 */   GIM_Try, /*On fail goto*//*Label 22912*/ GIMT_Encode4(1667687), // Rule ID 6195 //
     /* 1667606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1667617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1667620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1667623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667652 */     // MIs[0] policy
     /* 1667652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667662 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667686 */     // GIR_Coverage, 6195,
     /* 1667686 */     GIR_EraseRootFromParent_Done,
     /* 1667687 */   // Label 22912: @1667687
     /* 1667687 */   GIM_Try, /*On fail goto*//*Label 22913*/ GIMT_Encode4(1667773), // Rule ID 6198 //
     /* 1667692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1667703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1667706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1667709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667738 */     // MIs[0] policy
     /* 1667738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667748 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667772 */     // GIR_Coverage, 6198,
     /* 1667772 */     GIR_EraseRootFromParent_Done,
     /* 1667773 */   // Label 22913: @1667773
     /* 1667773 */   GIM_Try, /*On fail goto*//*Label 22914*/ GIMT_Encode4(1667859), // Rule ID 6199 //
     /* 1667778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1667789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1667792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1667795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667824 */     // MIs[0] policy
     /* 1667824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667834 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667858 */     // GIR_Coverage, 6199,
     /* 1667858 */     GIR_EraseRootFromParent_Done,
     /* 1667859 */   // Label 22914: @1667859
     /* 1667859 */   GIM_Try, /*On fail goto*//*Label 22915*/ GIMT_Encode4(1667945), // Rule ID 6202 //
     /* 1667864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1667875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1667878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1667881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667910 */     // MIs[0] policy
     /* 1667910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667944 */     // GIR_Coverage, 6202,
     /* 1667944 */     GIR_EraseRootFromParent_Done,
     /* 1667945 */   // Label 22915: @1667945
     /* 1667945 */   GIM_Try, /*On fail goto*//*Label 22916*/ GIMT_Encode4(1668031), // Rule ID 6203 //
     /* 1667950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1667961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1667964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1667967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667996 */     // MIs[0] policy
     /* 1667996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668006 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1668009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668030 */     // GIR_Coverage, 6203,
     /* 1668030 */     GIR_EraseRootFromParent_Done,
     /* 1668031 */   // Label 22916: @1668031
     /* 1668031 */   GIM_Try, /*On fail goto*//*Label 22917*/ GIMT_Encode4(1668117), // Rule ID 6206 //
     /* 1668036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1668047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1668050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1668053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668082 */     // MIs[0] policy
     /* 1668082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668092 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1668095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668116 */     // GIR_Coverage, 6206,
     /* 1668116 */     GIR_EraseRootFromParent_Done,
     /* 1668117 */   // Label 22917: @1668117
     /* 1668117 */   GIM_Try, /*On fail goto*//*Label 22918*/ GIMT_Encode4(1668203), // Rule ID 6207 //
     /* 1668122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1668133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1668136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1668139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668168 */     // MIs[0] policy
     /* 1668168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668178 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1668181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668202 */     // GIR_Coverage, 6207,
     /* 1668202 */     GIR_EraseRootFromParent_Done,
     /* 1668203 */   // Label 22918: @1668203
     /* 1668203 */   GIM_Try, /*On fail goto*//*Label 22919*/ GIMT_Encode4(1668289), // Rule ID 6210 //
     /* 1668208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1668219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1668222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1668225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1668231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668254 */     // MIs[0] policy
     /* 1668254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668264 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1668267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668288 */     // GIR_Coverage, 6210,
     /* 1668288 */     GIR_EraseRootFromParent_Done,
     /* 1668289 */   // Label 22919: @1668289
     /* 1668289 */   GIM_Try, /*On fail goto*//*Label 22920*/ GIMT_Encode4(1668375), // Rule ID 6211 //
     /* 1668294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1668305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1668308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1668311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1668317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668340 */     // MIs[0] policy
     /* 1668340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668350 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1668353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668374 */     // GIR_Coverage, 6211,
     /* 1668374 */     GIR_EraseRootFromParent_Done,
     /* 1668375 */   // Label 22920: @1668375
     /* 1668375 */   GIM_Try, /*On fail goto*//*Label 22921*/ GIMT_Encode4(1668461), // Rule ID 6214 //
     /* 1668380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1668391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1668394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1668397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668426 */     // MIs[0] policy
     /* 1668426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668436 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1668439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668460 */     // GIR_Coverage, 6214,
     /* 1668460 */     GIR_EraseRootFromParent_Done,
     /* 1668461 */   // Label 22921: @1668461
     /* 1668461 */   GIM_Try, /*On fail goto*//*Label 22922*/ GIMT_Encode4(1668547), // Rule ID 6215 //
     /* 1668466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1668477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1668480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1668483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668512 */     // MIs[0] policy
     /* 1668512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668522 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1668525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668546 */     // GIR_Coverage, 6215,
     /* 1668546 */     GIR_EraseRootFromParent_Done,
     /* 1668547 */   // Label 22922: @1668547
     /* 1668547 */   GIM_Try, /*On fail goto*//*Label 22923*/ GIMT_Encode4(1668633), // Rule ID 6218 //
     /* 1668552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668598 */     // MIs[0] policy
     /* 1668598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668608 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1668611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668632 */     // GIR_Coverage, 6218,
     /* 1668632 */     GIR_EraseRootFromParent_Done,
     /* 1668633 */   // Label 22923: @1668633
     /* 1668633 */   GIM_Try, /*On fail goto*//*Label 22924*/ GIMT_Encode4(1668719), // Rule ID 6219 //
     /* 1668638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668684 */     // MIs[0] policy
     /* 1668684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668694 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1668697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668718 */     // GIR_Coverage, 6219,
     /* 1668718 */     GIR_EraseRootFromParent_Done,
     /* 1668719 */   // Label 22924: @1668719
     /* 1668719 */   GIM_Try, /*On fail goto*//*Label 22925*/ GIMT_Encode4(1668805), // Rule ID 6222 //
     /* 1668724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668770 */     // MIs[0] policy
     /* 1668770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668780 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1668783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668804 */     // GIR_Coverage, 6222,
     /* 1668804 */     GIR_EraseRootFromParent_Done,
     /* 1668805 */   // Label 22925: @1668805
     /* 1668805 */   GIM_Try, /*On fail goto*//*Label 22926*/ GIMT_Encode4(1668891), // Rule ID 6223 //
     /* 1668810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668856 */     // MIs[0] policy
     /* 1668856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668866 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1668869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668890 */     // GIR_Coverage, 6223,
     /* 1668890 */     GIR_EraseRootFromParent_Done,
     /* 1668891 */   // Label 22926: @1668891
     /* 1668891 */   GIM_Try, /*On fail goto*//*Label 22927*/ GIMT_Encode4(1668977), // Rule ID 6314 //
     /* 1668896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1668907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1668910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1668913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1668916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668942 */     // MIs[0] policy
     /* 1668942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668952 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1668955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668976 */     // GIR_Coverage, 6314,
     /* 1668976 */     GIR_EraseRootFromParent_Done,
     /* 1668977 */   // Label 22927: @1668977
     /* 1668977 */   GIM_Try, /*On fail goto*//*Label 22928*/ GIMT_Encode4(1669063), // Rule ID 6315 //
     /* 1668982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1668993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1668996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1668999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1669002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669028 */     // MIs[0] policy
     /* 1669028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669038 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1669041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669062 */     // GIR_Coverage, 6315,
     /* 1669062 */     GIR_EraseRootFromParent_Done,
     /* 1669063 */   // Label 22928: @1669063
     /* 1669063 */   GIM_Try, /*On fail goto*//*Label 22929*/ GIMT_Encode4(1669149), // Rule ID 6318 //
     /* 1669068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1669079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1669082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1669085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1669088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669114 */     // MIs[0] policy
     /* 1669114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669124 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1669127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669148 */     // GIR_Coverage, 6318,
     /* 1669148 */     GIR_EraseRootFromParent_Done,
     /* 1669149 */   // Label 22929: @1669149
     /* 1669149 */   GIM_Try, /*On fail goto*//*Label 22930*/ GIMT_Encode4(1669235), // Rule ID 6319 //
     /* 1669154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1669165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1669168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1669171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1669174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669200 */     // MIs[0] policy
     /* 1669200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669210 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1669213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669234 */     // GIR_Coverage, 6319,
     /* 1669234 */     GIR_EraseRootFromParent_Done,
     /* 1669235 */   // Label 22930: @1669235
     /* 1669235 */   GIM_Try, /*On fail goto*//*Label 22931*/ GIMT_Encode4(1669321), // Rule ID 6322 //
     /* 1669240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1669251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1669254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1669257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1669260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669286 */     // MIs[0] policy
     /* 1669286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669296 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669320 */     // GIR_Coverage, 6322,
     /* 1669320 */     GIR_EraseRootFromParent_Done,
     /* 1669321 */   // Label 22931: @1669321
     /* 1669321 */   GIM_Try, /*On fail goto*//*Label 22932*/ GIMT_Encode4(1669407), // Rule ID 6323 //
     /* 1669326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1669337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1669340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1669343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1669346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669372 */     // MIs[0] policy
     /* 1669372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669382 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669406 */     // GIR_Coverage, 6323,
     /* 1669406 */     GIR_EraseRootFromParent_Done,
     /* 1669407 */   // Label 22932: @1669407
     /* 1669407 */   GIM_Try, /*On fail goto*//*Label 22933*/ GIMT_Encode4(1669493), // Rule ID 6326 //
     /* 1669412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1669423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1669426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1669429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1669432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669458 */     // MIs[0] policy
     /* 1669458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669468 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1669471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669492 */     // GIR_Coverage, 6326,
     /* 1669492 */     GIR_EraseRootFromParent_Done,
     /* 1669493 */   // Label 22933: @1669493
     /* 1669493 */   GIM_Try, /*On fail goto*//*Label 22934*/ GIMT_Encode4(1669579), // Rule ID 6327 //
     /* 1669498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1669509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1669512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1669515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1669518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669544 */     // MIs[0] policy
     /* 1669544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669554 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1669557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669578 */     // GIR_Coverage, 6327,
     /* 1669578 */     GIR_EraseRootFromParent_Done,
     /* 1669579 */   // Label 22934: @1669579
     /* 1669579 */   GIM_Try, /*On fail goto*//*Label 22935*/ GIMT_Encode4(1669665), // Rule ID 6330 //
     /* 1669584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1669595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1669598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1669601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1669604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669630 */     // MIs[0] policy
     /* 1669630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669640 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669664 */     // GIR_Coverage, 6330,
     /* 1669664 */     GIR_EraseRootFromParent_Done,
     /* 1669665 */   // Label 22935: @1669665
     /* 1669665 */   GIM_Try, /*On fail goto*//*Label 22936*/ GIMT_Encode4(1669751), // Rule ID 6331 //
     /* 1669670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1669681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1669684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1669687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1669690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669716 */     // MIs[0] policy
     /* 1669716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669750 */     // GIR_Coverage, 6331,
     /* 1669750 */     GIR_EraseRootFromParent_Done,
     /* 1669751 */   // Label 22936: @1669751
     /* 1669751 */   GIM_Try, /*On fail goto*//*Label 22937*/ GIMT_Encode4(1669837), // Rule ID 6334 //
     /* 1669756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1669767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1669770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1669773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1669776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669802 */     // MIs[0] policy
     /* 1669802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669812 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669836 */     // GIR_Coverage, 6334,
     /* 1669836 */     GIR_EraseRootFromParent_Done,
     /* 1669837 */   // Label 22937: @1669837
     /* 1669837 */   GIM_Try, /*On fail goto*//*Label 22938*/ GIMT_Encode4(1669923), // Rule ID 6335 //
     /* 1669842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1669853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1669856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1669859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1669862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669888 */     // MIs[0] policy
     /* 1669888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669898 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669922 */     // GIR_Coverage, 6335,
     /* 1669922 */     GIR_EraseRootFromParent_Done,
     /* 1669923 */   // Label 22938: @1669923
     /* 1669923 */   GIM_Try, /*On fail goto*//*Label 22939*/ GIMT_Encode4(1670009), // Rule ID 6338 //
     /* 1669928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1669939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1669942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1669945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1669948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669974 */     // MIs[0] policy
     /* 1669974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669984 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670008 */     // GIR_Coverage, 6338,
     /* 1670008 */     GIR_EraseRootFromParent_Done,
     /* 1670009 */   // Label 22939: @1670009
     /* 1670009 */   GIM_Try, /*On fail goto*//*Label 22940*/ GIMT_Encode4(1670095), // Rule ID 6339 //
     /* 1670014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1670025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1670028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1670031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1670034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1670037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670060 */     // MIs[0] policy
     /* 1670060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670094 */     // GIR_Coverage, 6339,
     /* 1670094 */     GIR_EraseRootFromParent_Done,
     /* 1670095 */   // Label 22940: @1670095
     /* 1670095 */   GIM_Try, /*On fail goto*//*Label 22941*/ GIMT_Encode4(1670181), // Rule ID 6342 //
     /* 1670100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1670111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1670114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1670117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1670120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1670123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670146 */     // MIs[0] policy
     /* 1670146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670180 */     // GIR_Coverage, 6342,
     /* 1670180 */     GIR_EraseRootFromParent_Done,
     /* 1670181 */   // Label 22941: @1670181
     /* 1670181 */   GIM_Try, /*On fail goto*//*Label 22942*/ GIMT_Encode4(1670267), // Rule ID 6343 //
     /* 1670186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1670197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1670200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1670203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1670206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1670209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670232 */     // MIs[0] policy
     /* 1670232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670242 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670266 */     // GIR_Coverage, 6343,
     /* 1670266 */     GIR_EraseRootFromParent_Done,
     /* 1670267 */   // Label 22942: @1670267
     /* 1670267 */   GIM_Try, /*On fail goto*//*Label 22943*/ GIMT_Encode4(1670353), // Rule ID 6346 //
     /* 1670272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1670283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1670286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1670289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1670292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670318 */     // MIs[0] policy
     /* 1670318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670328 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670352 */     // GIR_Coverage, 6346,
     /* 1670352 */     GIR_EraseRootFromParent_Done,
     /* 1670353 */   // Label 22943: @1670353
     /* 1670353 */   GIM_Try, /*On fail goto*//*Label 22944*/ GIMT_Encode4(1670439), // Rule ID 6347 //
     /* 1670358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1670369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1670372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1670375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1670378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670404 */     // MIs[0] policy
     /* 1670404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670414 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670438 */     // GIR_Coverage, 6347,
     /* 1670438 */     GIR_EraseRootFromParent_Done,
     /* 1670439 */   // Label 22944: @1670439
     /* 1670439 */   GIM_Try, /*On fail goto*//*Label 22945*/ GIMT_Encode4(1670525), // Rule ID 6350 //
     /* 1670444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1670447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1670455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1670458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1670461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1670464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670490 */     // MIs[0] policy
     /* 1670490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670500 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1670521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670524 */     // GIR_Coverage, 6350,
     /* 1670524 */     GIR_EraseRootFromParent_Done,
     /* 1670525 */   // Label 22945: @1670525
     /* 1670525 */   GIM_Try, /*On fail goto*//*Label 22946*/ GIMT_Encode4(1670611), // Rule ID 6351 //
     /* 1670530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1670533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1670541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1670544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1670547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1670550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670576 */     // MIs[0] policy
     /* 1670576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670586 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1670607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670610 */     // GIR_Coverage, 6351,
     /* 1670610 */     GIR_EraseRootFromParent_Done,
     /* 1670611 */   // Label 22946: @1670611
     /* 1670611 */   GIM_Try, /*On fail goto*//*Label 22947*/ GIMT_Encode4(1670697), // Rule ID 6354 //
     /* 1670616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1670627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1670630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1670633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1670636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670662 */     // MIs[0] policy
     /* 1670662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670672 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1670675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670696 */     // GIR_Coverage, 6354,
     /* 1670696 */     GIR_EraseRootFromParent_Done,
     /* 1670697 */   // Label 22947: @1670697
     /* 1670697 */   GIM_Try, /*On fail goto*//*Label 22948*/ GIMT_Encode4(1670783), // Rule ID 6355 //
     /* 1670702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1670713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1670716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1670719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1670722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670748 */     // MIs[0] policy
     /* 1670748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670758 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1670761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670782 */     // GIR_Coverage, 6355,
     /* 1670782 */     GIR_EraseRootFromParent_Done,
     /* 1670783 */   // Label 22948: @1670783
     /* 1670783 */   GIM_Try, /*On fail goto*//*Label 22949*/ GIMT_Encode4(1670869), // Rule ID 6358 //
     /* 1670788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1670799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1670802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1670805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1670808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1670811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670834 */     // MIs[0] policy
     /* 1670834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670844 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1670847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670868 */     // GIR_Coverage, 6358,
     /* 1670868 */     GIR_EraseRootFromParent_Done,
     /* 1670869 */   // Label 22949: @1670869
     /* 1670869 */   GIM_Try, /*On fail goto*//*Label 22950*/ GIMT_Encode4(1670955), // Rule ID 6359 //
     /* 1670874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1670885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1670888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1670891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1670894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1670897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670920 */     // MIs[0] policy
     /* 1670920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670930 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1670933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670954 */     // GIR_Coverage, 6359,
     /* 1670954 */     GIR_EraseRootFromParent_Done,
     /* 1670955 */   // Label 22950: @1670955
     /* 1670955 */   GIM_Try, /*On fail goto*//*Label 22951*/ GIMT_Encode4(1671041), // Rule ID 6362 //
     /* 1670960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1670971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1670974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1670977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1670980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1670983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1670990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671006 */     // MIs[0] policy
     /* 1671006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671016 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671040 */     // GIR_Coverage, 6362,
     /* 1671040 */     GIR_EraseRootFromParent_Done,
     /* 1671041 */   // Label 22951: @1671041
     /* 1671041 */   GIM_Try, /*On fail goto*//*Label 22952*/ GIMT_Encode4(1671127), // Rule ID 6363 //
     /* 1671046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1671057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1671060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1671063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1671066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1671069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671092 */     // MIs[0] policy
     /* 1671092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671102 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671126 */     // GIR_Coverage, 6363,
     /* 1671126 */     GIR_EraseRootFromParent_Done,
     /* 1671127 */   // Label 22952: @1671127
     /* 1671127 */   GIM_Try, /*On fail goto*//*Label 22953*/ GIMT_Encode4(1671213), // Rule ID 6366 //
     /* 1671132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1671143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1671146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1671149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1671152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671178 */     // MIs[0] policy
     /* 1671178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671212 */     // GIR_Coverage, 6366,
     /* 1671212 */     GIR_EraseRootFromParent_Done,
     /* 1671213 */   // Label 22953: @1671213
     /* 1671213 */   GIM_Try, /*On fail goto*//*Label 22954*/ GIMT_Encode4(1671299), // Rule ID 6367 //
     /* 1671218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1671229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1671232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1671235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1671238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671264 */     // MIs[0] policy
     /* 1671264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671298 */     // GIR_Coverage, 6367,
     /* 1671298 */     GIR_EraseRootFromParent_Done,
     /* 1671299 */   // Label 22954: @1671299
     /* 1671299 */   GIM_Try, /*On fail goto*//*Label 22955*/ GIMT_Encode4(1671385), // Rule ID 6370 //
     /* 1671304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1671315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1671318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1671321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1671324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671350 */     // MIs[0] policy
     /* 1671350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671360 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671384 */     // GIR_Coverage, 6370,
     /* 1671384 */     GIR_EraseRootFromParent_Done,
     /* 1671385 */   // Label 22955: @1671385
     /* 1671385 */   GIM_Try, /*On fail goto*//*Label 22956*/ GIMT_Encode4(1671471), // Rule ID 6371 //
     /* 1671390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1671401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1671404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1671407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1671410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671436 */     // MIs[0] policy
     /* 1671436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671446 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671470 */     // GIR_Coverage, 6371,
     /* 1671470 */     GIR_EraseRootFromParent_Done,
     /* 1671471 */   // Label 22956: @1671471
     /* 1671471 */   GIM_Try, /*On fail goto*//*Label 22957*/ GIMT_Encode4(1671557), // Rule ID 6374 //
     /* 1671476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1671493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1671496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671522 */     // MIs[0] policy
     /* 1671522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671532 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671556 */     // GIR_Coverage, 6374,
     /* 1671556 */     GIR_EraseRootFromParent_Done,
     /* 1671557 */   // Label 22957: @1671557
     /* 1671557 */   GIM_Try, /*On fail goto*//*Label 22958*/ GIMT_Encode4(1671643), // Rule ID 6375 //
     /* 1671562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1671579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1671582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671608 */     // MIs[0] policy
     /* 1671608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671618 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671642 */     // GIR_Coverage, 6375,
     /* 1671642 */     GIR_EraseRootFromParent_Done,
     /* 1671643 */   // Label 22958: @1671643
     /* 1671643 */   GIM_Try, /*On fail goto*//*Label 22959*/ GIMT_Encode4(1671729), // Rule ID 6378 //
     /* 1671648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1671659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1671662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1671665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1671668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671694 */     // MIs[0] policy
     /* 1671694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671728 */     // GIR_Coverage, 6378,
     /* 1671728 */     GIR_EraseRootFromParent_Done,
     /* 1671729 */   // Label 22959: @1671729
     /* 1671729 */   GIM_Try, /*On fail goto*//*Label 22960*/ GIMT_Encode4(1671815), // Rule ID 6379 //
     /* 1671734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1671745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1671748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1671751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1671754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671780 */     // MIs[0] policy
     /* 1671780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671814 */     // GIR_Coverage, 6379,
     /* 1671814 */     GIR_EraseRootFromParent_Done,
     /* 1671815 */   // Label 22960: @1671815
     /* 1671815 */   GIM_Try, /*On fail goto*//*Label 22961*/ GIMT_Encode4(1671901), // Rule ID 6382 //
     /* 1671820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1671831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1671834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1671837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1671840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671866 */     // MIs[0] policy
     /* 1671866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671900 */     // GIR_Coverage, 6382,
     /* 1671900 */     GIR_EraseRootFromParent_Done,
     /* 1671901 */   // Label 22961: @1671901
     /* 1671901 */   GIM_Try, /*On fail goto*//*Label 22962*/ GIMT_Encode4(1671987), // Rule ID 6383 //
     /* 1671906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1671917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1671920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1671923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1671926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671952 */     // MIs[0] policy
     /* 1671952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671962 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671986 */     // GIR_Coverage, 6383,
     /* 1671986 */     GIR_EraseRootFromParent_Done,
     /* 1671987 */   // Label 22962: @1671987
     /* 1671987 */   GIM_Try, /*On fail goto*//*Label 22963*/ GIMT_Encode4(1672073), // Rule ID 6386 //
     /* 1671992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1672003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1672006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1672009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1672012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1672015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672038 */     // MIs[0] policy
     /* 1672038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672048 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1672051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672072 */     // GIR_Coverage, 6386,
     /* 1672072 */     GIR_EraseRootFromParent_Done,
     /* 1672073 */   // Label 22963: @1672073
     /* 1672073 */   GIM_Try, /*On fail goto*//*Label 22964*/ GIMT_Encode4(1672159), // Rule ID 6387 //
     /* 1672078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1672089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1672092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1672095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1672098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1672101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672124 */     // MIs[0] policy
     /* 1672124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1672137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672158 */     // GIR_Coverage, 6387,
     /* 1672158 */     GIR_EraseRootFromParent_Done,
     /* 1672159 */   // Label 22964: @1672159
     /* 1672159 */   GIM_Try, /*On fail goto*//*Label 22965*/ GIMT_Encode4(1672245), // Rule ID 6390 //
     /* 1672164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1672175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1672178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1672181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1672184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672210 */     // MIs[0] policy
     /* 1672210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1672223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672244 */     // GIR_Coverage, 6390,
     /* 1672244 */     GIR_EraseRootFromParent_Done,
     /* 1672245 */   // Label 22965: @1672245
     /* 1672245 */   GIM_Try, /*On fail goto*//*Label 22966*/ GIMT_Encode4(1672331), // Rule ID 6391 //
     /* 1672250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1672261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1672264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1672267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1672270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672296 */     // MIs[0] policy
     /* 1672296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1672309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672330 */     // GIR_Coverage, 6391,
     /* 1672330 */     GIR_EraseRootFromParent_Done,
     /* 1672331 */   // Label 22966: @1672331
     /* 1672331 */   GIM_Try, /*On fail goto*//*Label 22967*/ GIMT_Encode4(1672417), // Rule ID 6394 //
     /* 1672336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1672347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1672350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1672353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1672356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672382 */     // MIs[0] policy
     /* 1672382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672392 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1672395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672416 */     // GIR_Coverage, 6394,
     /* 1672416 */     GIR_EraseRootFromParent_Done,
     /* 1672417 */   // Label 22967: @1672417
     /* 1672417 */   GIM_Try, /*On fail goto*//*Label 22968*/ GIMT_Encode4(1672503), // Rule ID 6395 //
     /* 1672422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1672433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1672436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1672439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1672442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672468 */     // MIs[0] policy
     /* 1672468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672478 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1672481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672502 */     // GIR_Coverage, 6395,
     /* 1672502 */     GIR_EraseRootFromParent_Done,
     /* 1672503 */   // Label 22968: @1672503
     /* 1672503 */   GIM_Try, /*On fail goto*//*Label 22969*/ GIMT_Encode4(1672589), // Rule ID 6398 //
     /* 1672508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1672519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1672522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1672525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1672528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672554 */     // MIs[0] policy
     /* 1672554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672564 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1672567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672588 */     // GIR_Coverage, 6398,
     /* 1672588 */     GIR_EraseRootFromParent_Done,
     /* 1672589 */   // Label 22969: @1672589
     /* 1672589 */   GIM_Try, /*On fail goto*//*Label 22970*/ GIMT_Encode4(1672675), // Rule ID 6399 //
     /* 1672594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1672605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1672608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1672611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1672614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672640 */     // MIs[0] policy
     /* 1672640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672650 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1672653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672674 */     // GIR_Coverage, 6399,
     /* 1672674 */     GIR_EraseRootFromParent_Done,
     /* 1672675 */   // Label 22970: @1672675
     /* 1672675 */   GIM_Try, /*On fail goto*//*Label 22971*/ GIMT_Encode4(1672761), // Rule ID 6402 //
     /* 1672680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1672691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1672694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1672697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672726 */     // MIs[0] policy
     /* 1672726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672736 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1672739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672760 */     // GIR_Coverage, 6402,
     /* 1672760 */     GIR_EraseRootFromParent_Done,
     /* 1672761 */   // Label 22971: @1672761
     /* 1672761 */   GIM_Try, /*On fail goto*//*Label 22972*/ GIMT_Encode4(1672847), // Rule ID 6403 //
     /* 1672766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1672777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1672780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1672783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672812 */     // MIs[0] policy
     /* 1672812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672822 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1672825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672846 */     // GIR_Coverage, 6403,
     /* 1672846 */     GIR_EraseRootFromParent_Done,
     /* 1672847 */   // Label 22972: @1672847
     /* 1672847 */   GIM_Try, /*On fail goto*//*Label 22973*/ GIMT_Encode4(1672933), // Rule ID 6406 //
     /* 1672852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1672863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1672866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1672869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672898 */     // MIs[0] policy
     /* 1672898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672908 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1672911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672932 */     // GIR_Coverage, 6406,
     /* 1672932 */     GIR_EraseRootFromParent_Done,
     /* 1672933 */   // Label 22973: @1672933
     /* 1672933 */   GIM_Try, /*On fail goto*//*Label 22974*/ GIMT_Encode4(1673019), // Rule ID 6407 //
     /* 1672938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1672949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1672952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1672955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672984 */     // MIs[0] policy
     /* 1672984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672994 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1672997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673018 */     // GIR_Coverage, 6407,
     /* 1673018 */     GIR_EraseRootFromParent_Done,
     /* 1673019 */   // Label 22974: @1673019
     /* 1673019 */   GIM_Try, /*On fail goto*//*Label 22975*/ GIMT_Encode4(1673105), // Rule ID 6410 //
     /* 1673024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1673035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1673038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1673041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673070 */     // MIs[0] policy
     /* 1673070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673080 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673104 */     // GIR_Coverage, 6410,
     /* 1673104 */     GIR_EraseRootFromParent_Done,
     /* 1673105 */   // Label 22975: @1673105
     /* 1673105 */   GIM_Try, /*On fail goto*//*Label 22976*/ GIMT_Encode4(1673191), // Rule ID 6411 //
     /* 1673110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1673121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1673124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1673127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673156 */     // MIs[0] policy
     /* 1673156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673166 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673190 */     // GIR_Coverage, 6411,
     /* 1673190 */     GIR_EraseRootFromParent_Done,
     /* 1673191 */   // Label 22976: @1673191
     /* 1673191 */   GIM_Try, /*On fail goto*//*Label 22977*/ GIMT_Encode4(1673277), // Rule ID 6414 //
     /* 1673196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1673207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1673210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1673213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673242 */     // MIs[0] policy
     /* 1673242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673252 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1673255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673276 */     // GIR_Coverage, 6414,
     /* 1673276 */     GIR_EraseRootFromParent_Done,
     /* 1673277 */   // Label 22977: @1673277
     /* 1673277 */   GIM_Try, /*On fail goto*//*Label 22978*/ GIMT_Encode4(1673363), // Rule ID 6415 //
     /* 1673282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1673293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1673296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1673299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673328 */     // MIs[0] policy
     /* 1673328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673338 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1673341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673362 */     // GIR_Coverage, 6415,
     /* 1673362 */     GIR_EraseRootFromParent_Done,
     /* 1673363 */   // Label 22978: @1673363
     /* 1673363 */   GIM_Try, /*On fail goto*//*Label 22979*/ GIMT_Encode4(1673449), // Rule ID 6418 //
     /* 1673368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1673379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1673382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1673385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673414 */     // MIs[0] policy
     /* 1673414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673424 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673448 */     // GIR_Coverage, 6418,
     /* 1673448 */     GIR_EraseRootFromParent_Done,
     /* 1673449 */   // Label 22979: @1673449
     /* 1673449 */   GIM_Try, /*On fail goto*//*Label 22980*/ GIMT_Encode4(1673535), // Rule ID 6419 //
     /* 1673454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1673465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1673468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1673471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673500 */     // MIs[0] policy
     /* 1673500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673510 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673534 */     // GIR_Coverage, 6419,
     /* 1673534 */     GIR_EraseRootFromParent_Done,
     /* 1673535 */   // Label 22980: @1673535
     /* 1673535 */   GIM_Try, /*On fail goto*//*Label 22981*/ GIMT_Encode4(1673621), // Rule ID 6422 //
     /* 1673540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1673551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1673554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1673557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673586 */     // MIs[0] policy
     /* 1673586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673620 */     // GIR_Coverage, 6422,
     /* 1673620 */     GIR_EraseRootFromParent_Done,
     /* 1673621 */   // Label 22981: @1673621
     /* 1673621 */   GIM_Try, /*On fail goto*//*Label 22982*/ GIMT_Encode4(1673707), // Rule ID 6423 //
     /* 1673626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1673637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1673640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1673643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673672 */     // MIs[0] policy
     /* 1673672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673682 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673706 */     // GIR_Coverage, 6423,
     /* 1673706 */     GIR_EraseRootFromParent_Done,
     /* 1673707 */   // Label 22982: @1673707
     /* 1673707 */   GIM_Try, /*On fail goto*//*Label 22983*/ GIMT_Encode4(1673793), // Rule ID 6426 //
     /* 1673712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1673723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1673726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1673729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673758 */     // MIs[0] policy
     /* 1673758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673768 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673792 */     // GIR_Coverage, 6426,
     /* 1673792 */     GIR_EraseRootFromParent_Done,
     /* 1673793 */   // Label 22983: @1673793
     /* 1673793 */   GIM_Try, /*On fail goto*//*Label 22984*/ GIMT_Encode4(1673879), // Rule ID 6427 //
     /* 1673798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1673809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1673812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1673815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673844 */     // MIs[0] policy
     /* 1673844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673854 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673878 */     // GIR_Coverage, 6427,
     /* 1673878 */     GIR_EraseRootFromParent_Done,
     /* 1673879 */   // Label 22984: @1673879
     /* 1673879 */   GIM_Try, /*On fail goto*//*Label 22985*/ GIMT_Encode4(1673965), // Rule ID 6430 //
     /* 1673884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1673895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1673898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1673901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673930 */     // MIs[0] policy
     /* 1673930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673964 */     // GIR_Coverage, 6430,
     /* 1673964 */     GIR_EraseRootFromParent_Done,
     /* 1673965 */   // Label 22985: @1673965
     /* 1673965 */   GIM_Try, /*On fail goto*//*Label 22986*/ GIMT_Encode4(1674051), // Rule ID 6431 //
     /* 1673970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1673981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1673984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1673987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674016 */     // MIs[0] policy
     /* 1674016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674026 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1674029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674050 */     // GIR_Coverage, 6431,
     /* 1674050 */     GIR_EraseRootFromParent_Done,
     /* 1674051 */   // Label 22986: @1674051
     /* 1674051 */   GIM_Try, /*On fail goto*//*Label 22987*/ GIMT_Encode4(1674137), // Rule ID 6434 //
     /* 1674056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1674067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1674070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1674073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1674079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674102 */     // MIs[0] policy
     /* 1674102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674112 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1674115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1674133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674136 */     // GIR_Coverage, 6434,
     /* 1674136 */     GIR_EraseRootFromParent_Done,
     /* 1674137 */   // Label 22987: @1674137
     /* 1674137 */   GIM_Try, /*On fail goto*//*Label 22988*/ GIMT_Encode4(1674223), // Rule ID 6435 //
     /* 1674142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1674153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1674156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1674159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1674165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674188 */     // MIs[0] policy
     /* 1674188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674198 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1674201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1674219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674222 */     // GIR_Coverage, 6435,
     /* 1674222 */     GIR_EraseRootFromParent_Done,
     /* 1674223 */   // Label 22988: @1674223
     /* 1674223 */   GIM_Try, /*On fail goto*//*Label 22989*/ GIMT_Encode4(1674309), // Rule ID 6438 //
     /* 1674228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1674231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1674239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1674242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1674245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674274 */     // MIs[0] policy
     /* 1674274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1674287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1674305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674308 */     // GIR_Coverage, 6438,
     /* 1674308 */     GIR_EraseRootFromParent_Done,
     /* 1674309 */   // Label 22989: @1674309
     /* 1674309 */   GIM_Try, /*On fail goto*//*Label 22990*/ GIMT_Encode4(1674395), // Rule ID 6439 //
     /* 1674314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1674317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1674325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1674328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1674331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674360 */     // MIs[0] policy
     /* 1674360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674370 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1674373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1674391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674394 */     // GIR_Coverage, 6439,
     /* 1674394 */     GIR_EraseRootFromParent_Done,
     /* 1674395 */   // Label 22990: @1674395
     /* 1674395 */   GIM_Try, /*On fail goto*//*Label 22991*/ GIMT_Encode4(1674481), // Rule ID 6442 //
     /* 1674400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1674411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1674414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1674417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674446 */     // MIs[0] policy
     /* 1674446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674456 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1674459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674480 */     // GIR_Coverage, 6442,
     /* 1674480 */     GIR_EraseRootFromParent_Done,
     /* 1674481 */   // Label 22991: @1674481
     /* 1674481 */   GIM_Try, /*On fail goto*//*Label 22992*/ GIMT_Encode4(1674567), // Rule ID 6443 //
     /* 1674486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1674497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1674500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1674503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674532 */     // MIs[0] policy
     /* 1674532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674542 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1674545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674566 */     // GIR_Coverage, 6443,
     /* 1674566 */     GIR_EraseRootFromParent_Done,
     /* 1674567 */   // Label 22992: @1674567
     /* 1674567 */   GIM_Try, /*On fail goto*//*Label 22993*/ GIMT_Encode4(1674653), // Rule ID 6446 //
     /* 1674572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1674583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1674586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1674589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674618 */     // MIs[0] policy
     /* 1674618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674628 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1674631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674652 */     // GIR_Coverage, 6446,
     /* 1674652 */     GIR_EraseRootFromParent_Done,
     /* 1674653 */   // Label 22993: @1674653
     /* 1674653 */   GIM_Try, /*On fail goto*//*Label 22994*/ GIMT_Encode4(1674739), // Rule ID 6447 //
     /* 1674658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1674669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1674672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1674675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674704 */     // MIs[0] policy
     /* 1674704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674714 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1674717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674738 */     // GIR_Coverage, 6447,
     /* 1674738 */     GIR_EraseRootFromParent_Done,
     /* 1674739 */   // Label 22994: @1674739
     /* 1674739 */   GIM_Try, /*On fail goto*//*Label 22995*/ GIMT_Encode4(1674825), // Rule ID 6450 //
     /* 1674744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1674755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1674758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1674761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1674767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674790 */     // MIs[0] policy
     /* 1674790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674800 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1674803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674824 */     // GIR_Coverage, 6450,
     /* 1674824 */     GIR_EraseRootFromParent_Done,
     /* 1674825 */   // Label 22995: @1674825
     /* 1674825 */   GIM_Try, /*On fail goto*//*Label 22996*/ GIMT_Encode4(1674911), // Rule ID 6451 //
     /* 1674830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1674841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1674844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1674847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1674853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674876 */     // MIs[0] policy
     /* 1674876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674886 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1674889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674910 */     // GIR_Coverage, 6451,
     /* 1674910 */     GIR_EraseRootFromParent_Done,
     /* 1674911 */   // Label 22996: @1674911
     /* 1674911 */   GIM_Try, /*On fail goto*//*Label 22997*/ GIMT_Encode4(1674997), // Rule ID 6454 //
     /* 1674916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1674927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1674930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1674933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674962 */     // MIs[0] policy
     /* 1674962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674972 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1674975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674996 */     // GIR_Coverage, 6454,
     /* 1674996 */     GIR_EraseRootFromParent_Done,
     /* 1674997 */   // Label 22997: @1674997
     /* 1674997 */   GIM_Try, /*On fail goto*//*Label 22998*/ GIMT_Encode4(1675083), // Rule ID 6455 //
     /* 1675002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1675013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1675016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1675019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675048 */     // MIs[0] policy
     /* 1675048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675058 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675082 */     // GIR_Coverage, 6455,
     /* 1675082 */     GIR_EraseRootFromParent_Done,
     /* 1675083 */   // Label 22998: @1675083
     /* 1675083 */   GIM_Try, /*On fail goto*//*Label 22999*/ GIMT_Encode4(1675169), // Rule ID 6458 //
     /* 1675088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1675099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1675102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1675105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675134 */     // MIs[0] policy
     /* 1675134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675144 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675168 */     // GIR_Coverage, 6458,
     /* 1675168 */     GIR_EraseRootFromParent_Done,
     /* 1675169 */   // Label 22999: @1675169
     /* 1675169 */   GIM_Try, /*On fail goto*//*Label 23000*/ GIMT_Encode4(1675255), // Rule ID 6459 //
     /* 1675174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1675185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1675188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1675191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675220 */     // MIs[0] policy
     /* 1675220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675230 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675254 */     // GIR_Coverage, 6459,
     /* 1675254 */     GIR_EraseRootFromParent_Done,
     /* 1675255 */   // Label 23000: @1675255
     /* 1675255 */   GIM_Try, /*On fail goto*//*Label 23001*/ GIMT_Encode4(1675341), // Rule ID 6462 //
     /* 1675260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1675271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1675274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1675277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1675283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675306 */     // MIs[0] policy
     /* 1675306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675316 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675340 */     // GIR_Coverage, 6462,
     /* 1675340 */     GIR_EraseRootFromParent_Done,
     /* 1675341 */   // Label 23001: @1675341
     /* 1675341 */   GIM_Try, /*On fail goto*//*Label 23002*/ GIMT_Encode4(1675427), // Rule ID 6463 //
     /* 1675346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1675357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1675360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1675363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1675369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675392 */     // MIs[0] policy
     /* 1675392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675402 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675426 */     // GIR_Coverage, 6463,
     /* 1675426 */     GIR_EraseRootFromParent_Done,
     /* 1675427 */   // Label 23002: @1675427
     /* 1675427 */   GIM_Try, /*On fail goto*//*Label 23003*/ GIMT_Encode4(1675513), // Rule ID 6466 //
     /* 1675432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1675443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1675446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1675449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675478 */     // MIs[0] policy
     /* 1675478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675512 */     // GIR_Coverage, 6466,
     /* 1675512 */     GIR_EraseRootFromParent_Done,
     /* 1675513 */   // Label 23003: @1675513
     /* 1675513 */   GIM_Try, /*On fail goto*//*Label 23004*/ GIMT_Encode4(1675599), // Rule ID 6467 //
     /* 1675518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1675529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1675532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1675535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675564 */     // MIs[0] policy
     /* 1675564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675574 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675598 */     // GIR_Coverage, 6467,
     /* 1675598 */     GIR_EraseRootFromParent_Done,
     /* 1675599 */   // Label 23004: @1675599
     /* 1675599 */   GIM_Try, /*On fail goto*//*Label 23005*/ GIMT_Encode4(1675685), // Rule ID 6470 //
     /* 1675604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1675615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1675618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1675621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675650 */     // MIs[0] policy
     /* 1675650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675660 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675684 */     // GIR_Coverage, 6470,
     /* 1675684 */     GIR_EraseRootFromParent_Done,
     /* 1675685 */   // Label 23005: @1675685
     /* 1675685 */   GIM_Try, /*On fail goto*//*Label 23006*/ GIMT_Encode4(1675771), // Rule ID 6471 //
     /* 1675690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1675701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1675704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1675707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675736 */     // MIs[0] policy
     /* 1675736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675770 */     // GIR_Coverage, 6471,
     /* 1675770 */     GIR_EraseRootFromParent_Done,
     /* 1675771 */   // Label 23006: @1675771
     /* 1675771 */   GIM_Try, /*On fail goto*//*Label 23007*/ GIMT_Encode4(1675857), // Rule ID 6474 //
     /* 1675776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1675787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1675790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1675793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675822 */     // MIs[0] policy
     /* 1675822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675832 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675856 */     // GIR_Coverage, 6474,
     /* 1675856 */     GIR_EraseRootFromParent_Done,
     /* 1675857 */   // Label 23007: @1675857
     /* 1675857 */   GIM_Try, /*On fail goto*//*Label 23008*/ GIMT_Encode4(1675943), // Rule ID 6475 //
     /* 1675862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1675873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1675876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1675879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675908 */     // MIs[0] policy
     /* 1675908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675942 */     // GIR_Coverage, 6475,
     /* 1675942 */     GIR_EraseRootFromParent_Done,
     /* 1675943 */   // Label 23008: @1675943
     /* 1675943 */   GIM_Try, /*On fail goto*//*Label 23009*/ GIMT_Encode4(1676029), // Rule ID 6478 //
     /* 1675948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1675951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1675959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1675962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1675965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1675971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675994 */     // MIs[0] policy
     /* 1675994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676004 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1676007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676028 */     // GIR_Coverage, 6478,
     /* 1676028 */     GIR_EraseRootFromParent_Done,
     /* 1676029 */   // Label 23009: @1676029
     /* 1676029 */   GIM_Try, /*On fail goto*//*Label 23010*/ GIMT_Encode4(1676115), // Rule ID 6479 //
     /* 1676034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1676037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1676045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1676048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1676051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1676064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676080 */     // MIs[0] policy
     /* 1676080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1676093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676114 */     // GIR_Coverage, 6479,
     /* 1676114 */     GIR_EraseRootFromParent_Done,
     /* 1676115 */   // Label 23010: @1676115
     /* 1676115 */   GIM_Try, /*On fail goto*//*Label 23011*/ GIMT_Encode4(1676201), // Rule ID 6482 //
     /* 1676120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1676123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1676131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1676134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1676137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676166 */     // MIs[0] policy
     /* 1676166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676176 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1676179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676200 */     // GIR_Coverage, 6482,
     /* 1676200 */     GIR_EraseRootFromParent_Done,
     /* 1676201 */   // Label 23011: @1676201
     /* 1676201 */   GIM_Try, /*On fail goto*//*Label 23012*/ GIMT_Encode4(1676287), // Rule ID 6483 //
     /* 1676206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1676209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1676217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1676220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1676223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676252 */     // MIs[0] policy
     /* 1676252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676262 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1676265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676286 */     // GIR_Coverage, 6483,
     /* 1676286 */     GIR_EraseRootFromParent_Done,
     /* 1676287 */   // Label 23012: @1676287
     /* 1676287 */   GIM_Try, /*On fail goto*//*Label 23013*/ GIMT_Encode4(1676373), // Rule ID 6486 //
     /* 1676292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1676295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1676303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1676306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1676309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676338 */     // MIs[0] policy
     /* 1676338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676348 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1676351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676372 */     // GIR_Coverage, 6486,
     /* 1676372 */     GIR_EraseRootFromParent_Done,
     /* 1676373 */   // Label 23013: @1676373
     /* 1676373 */   GIM_Try, /*On fail goto*//*Label 23014*/ GIMT_Encode4(1676459), // Rule ID 6487 //
     /* 1676378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1676381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1676389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1676392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1676395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676424 */     // MIs[0] policy
     /* 1676424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1676437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676458 */     // GIR_Coverage, 6487,
     /* 1676458 */     GIR_EraseRootFromParent_Done,
     /* 1676459 */   // Label 23014: @1676459
     /* 1676459 */   GIM_Try, /*On fail goto*//*Label 23015*/ GIMT_Encode4(1676545), // Rule ID 6578 //
     /* 1676464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1676484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676510 */     // MIs[0] policy
     /* 1676510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676520 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1676523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676544 */     // GIR_Coverage, 6578,
     /* 1676544 */     GIR_EraseRootFromParent_Done,
     /* 1676545 */   // Label 23015: @1676545
     /* 1676545 */   GIM_Try, /*On fail goto*//*Label 23016*/ GIMT_Encode4(1676631), // Rule ID 6579 //
     /* 1676550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1676570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676596 */     // MIs[0] policy
     /* 1676596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676606 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1676609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676630 */     // GIR_Coverage, 6579,
     /* 1676630 */     GIR_EraseRootFromParent_Done,
     /* 1676631 */   // Label 23016: @1676631
     /* 1676631 */   GIM_Try, /*On fail goto*//*Label 23017*/ GIMT_Encode4(1676717), // Rule ID 6582 //
     /* 1676636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1676647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1676650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1676653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1676656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676682 */     // MIs[0] policy
     /* 1676682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676692 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1676695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676716 */     // GIR_Coverage, 6582,
     /* 1676716 */     GIR_EraseRootFromParent_Done,
     /* 1676717 */   // Label 23017: @1676717
     /* 1676717 */   GIM_Try, /*On fail goto*//*Label 23018*/ GIMT_Encode4(1676803), // Rule ID 6583 //
     /* 1676722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1676733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1676736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1676739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1676742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676768 */     // MIs[0] policy
     /* 1676768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676778 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1676781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676802 */     // GIR_Coverage, 6583,
     /* 1676802 */     GIR_EraseRootFromParent_Done,
     /* 1676803 */   // Label 23018: @1676803
     /* 1676803 */   GIM_Try, /*On fail goto*//*Label 23019*/ GIMT_Encode4(1676889), // Rule ID 6586 //
     /* 1676808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1676819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1676822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1676825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1676828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676854 */     // MIs[0] policy
     /* 1676854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676864 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676888 */     // GIR_Coverage, 6586,
     /* 1676888 */     GIR_EraseRootFromParent_Done,
     /* 1676889 */   // Label 23019: @1676889
     /* 1676889 */   GIM_Try, /*On fail goto*//*Label 23020*/ GIMT_Encode4(1676975), // Rule ID 6587 //
     /* 1676894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1676905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1676908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1676911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1676914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676940 */     // MIs[0] policy
     /* 1676940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676950 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676974 */     // GIR_Coverage, 6587,
     /* 1676974 */     GIR_EraseRootFromParent_Done,
     /* 1676975 */   // Label 23020: @1676975
     /* 1676975 */   GIM_Try, /*On fail goto*//*Label 23021*/ GIMT_Encode4(1677061), // Rule ID 6590 //
     /* 1676980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1676991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1676994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1676997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1677000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677026 */     // MIs[0] policy
     /* 1677026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677036 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1677039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677060 */     // GIR_Coverage, 6590,
     /* 1677060 */     GIR_EraseRootFromParent_Done,
     /* 1677061 */   // Label 23021: @1677061
     /* 1677061 */   GIM_Try, /*On fail goto*//*Label 23022*/ GIMT_Encode4(1677147), // Rule ID 6591 //
     /* 1677066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1677077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1677080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1677083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1677086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677112 */     // MIs[0] policy
     /* 1677112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677122 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1677125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677146 */     // GIR_Coverage, 6591,
     /* 1677146 */     GIR_EraseRootFromParent_Done,
     /* 1677147 */   // Label 23022: @1677147
     /* 1677147 */   GIM_Try, /*On fail goto*//*Label 23023*/ GIMT_Encode4(1677233), // Rule ID 6594 //
     /* 1677152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1677163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1677166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1677169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1677172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677198 */     // MIs[0] policy
     /* 1677198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677208 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1677211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677232 */     // GIR_Coverage, 6594,
     /* 1677232 */     GIR_EraseRootFromParent_Done,
     /* 1677233 */   // Label 23023: @1677233
     /* 1677233 */   GIM_Try, /*On fail goto*//*Label 23024*/ GIMT_Encode4(1677319), // Rule ID 6595 //
     /* 1677238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1677249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1677252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1677255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1677258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677284 */     // MIs[0] policy
     /* 1677284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677294 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1677297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677318 */     // GIR_Coverage, 6595,
     /* 1677318 */     GIR_EraseRootFromParent_Done,
     /* 1677319 */   // Label 23024: @1677319
     /* 1677319 */   GIM_Try, /*On fail goto*//*Label 23025*/ GIMT_Encode4(1677405), // Rule ID 6598 //
     /* 1677324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1677335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1677338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1677341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1677344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677370 */     // MIs[0] policy
     /* 1677370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677380 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1677383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677404 */     // GIR_Coverage, 6598,
     /* 1677404 */     GIR_EraseRootFromParent_Done,
     /* 1677405 */   // Label 23025: @1677405
     /* 1677405 */   GIM_Try, /*On fail goto*//*Label 23026*/ GIMT_Encode4(1677491), // Rule ID 6599 //
     /* 1677410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1677421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1677424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1677427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1677430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677456 */     // MIs[0] policy
     /* 1677456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1677469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677490 */     // GIR_Coverage, 6599,
     /* 1677490 */     GIR_EraseRootFromParent_Done,
     /* 1677491 */   // Label 23026: @1677491
     /* 1677491 */   GIM_Try, /*On fail goto*//*Label 23027*/ GIMT_Encode4(1677577), // Rule ID 6602 //
     /* 1677496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1677507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1677510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1677513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1677516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677542 */     // MIs[0] policy
     /* 1677542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677552 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677576 */     // GIR_Coverage, 6602,
     /* 1677576 */     GIR_EraseRootFromParent_Done,
     /* 1677577 */   // Label 23027: @1677577
     /* 1677577 */   GIM_Try, /*On fail goto*//*Label 23028*/ GIMT_Encode4(1677663), // Rule ID 6603 //
     /* 1677582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1677593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1677596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1677599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1677602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677628 */     // MIs[0] policy
     /* 1677628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677638 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677662 */     // GIR_Coverage, 6603,
     /* 1677662 */     GIR_EraseRootFromParent_Done,
     /* 1677663 */   // Label 23028: @1677663
     /* 1677663 */   GIM_Try, /*On fail goto*//*Label 23029*/ GIMT_Encode4(1677749), // Rule ID 6606 //
     /* 1677668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1677679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1677682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1677685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1677688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677714 */     // MIs[0] policy
     /* 1677714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677748 */     // GIR_Coverage, 6606,
     /* 1677748 */     GIR_EraseRootFromParent_Done,
     /* 1677749 */   // Label 23029: @1677749
     /* 1677749 */   GIM_Try, /*On fail goto*//*Label 23030*/ GIMT_Encode4(1677835), // Rule ID 6607 //
     /* 1677754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1677765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1677768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1677771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1677774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677800 */     // MIs[0] policy
     /* 1677800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677810 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677834 */     // GIR_Coverage, 6607,
     /* 1677834 */     GIR_EraseRootFromParent_Done,
     /* 1677835 */   // Label 23030: @1677835
     /* 1677835 */   GIM_Try, /*On fail goto*//*Label 23031*/ GIMT_Encode4(1677921), // Rule ID 6610 //
     /* 1677840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1677851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1677854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1677857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1677860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677886 */     // MIs[0] policy
     /* 1677886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677920 */     // GIR_Coverage, 6610,
     /* 1677920 */     GIR_EraseRootFromParent_Done,
     /* 1677921 */   // Label 23031: @1677921
     /* 1677921 */   GIM_Try, /*On fail goto*//*Label 23032*/ GIMT_Encode4(1678007), // Rule ID 6611 //
     /* 1677926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1677937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1677940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1677943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1677946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677972 */     // MIs[0] policy
     /* 1677972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677982 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678006 */     // GIR_Coverage, 6611,
     /* 1678006 */     GIR_EraseRootFromParent_Done,
     /* 1678007 */   // Label 23032: @1678007
     /* 1678007 */   GIM_Try, /*On fail goto*//*Label 23033*/ GIMT_Encode4(1678093), // Rule ID 6614 //
     /* 1678012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1678015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1678023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1678026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1678029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1678032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1678035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678058 */     // MIs[0] policy
     /* 1678058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1678071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1678089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678092 */     // GIR_Coverage, 6614,
     /* 1678092 */     GIR_EraseRootFromParent_Done,
     /* 1678093 */   // Label 23033: @1678093
     /* 1678093 */   GIM_Try, /*On fail goto*//*Label 23034*/ GIMT_Encode4(1678179), // Rule ID 6615 //
     /* 1678098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1678101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1678109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1678112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1678115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1678118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1678121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678144 */     // MIs[0] policy
     /* 1678144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678154 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1678157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1678175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678178 */     // GIR_Coverage, 6615,
     /* 1678178 */     GIR_EraseRootFromParent_Done,
     /* 1678179 */   // Label 23034: @1678179
     /* 1678179 */   GIM_Try, /*On fail goto*//*Label 23035*/ GIMT_Encode4(1678265), // Rule ID 6618 //
     /* 1678184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1678195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1678198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1678201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1678204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678230 */     // MIs[0] policy
     /* 1678230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678240 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678264 */     // GIR_Coverage, 6618,
     /* 1678264 */     GIR_EraseRootFromParent_Done,
     /* 1678265 */   // Label 23035: @1678265
     /* 1678265 */   GIM_Try, /*On fail goto*//*Label 23036*/ GIMT_Encode4(1678351), // Rule ID 6619 //
     /* 1678270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1678281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1678284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1678287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1678290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678316 */     // MIs[0] policy
     /* 1678316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678350 */     // GIR_Coverage, 6619,
     /* 1678350 */     GIR_EraseRootFromParent_Done,
     /* 1678351 */   // Label 23036: @1678351
     /* 1678351 */   GIM_Try, /*On fail goto*//*Label 23037*/ GIMT_Encode4(1678437), // Rule ID 6622 //
     /* 1678356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1678367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1678370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1678373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1678376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678402 */     // MIs[0] policy
     /* 1678402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678412 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678436 */     // GIR_Coverage, 6622,
     /* 1678436 */     GIR_EraseRootFromParent_Done,
     /* 1678437 */   // Label 23037: @1678437
     /* 1678437 */   GIM_Try, /*On fail goto*//*Label 23038*/ GIMT_Encode4(1678523), // Rule ID 6623 //
     /* 1678442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1678453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1678456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1678459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1678462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678488 */     // MIs[0] policy
     /* 1678488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678498 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678522 */     // GIR_Coverage, 6623,
     /* 1678522 */     GIR_EraseRootFromParent_Done,
     /* 1678523 */   // Label 23038: @1678523
     /* 1678523 */   GIM_Try, /*On fail goto*//*Label 23039*/ GIMT_Encode4(1678609), // Rule ID 6626 //
     /* 1678528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1678539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1678542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1678545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1678548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1678551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678574 */     // MIs[0] policy
     /* 1678574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678584 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1678587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678608 */     // GIR_Coverage, 6626,
     /* 1678608 */     GIR_EraseRootFromParent_Done,
     /* 1678609 */   // Label 23039: @1678609
     /* 1678609 */   GIM_Try, /*On fail goto*//*Label 23040*/ GIMT_Encode4(1678695), // Rule ID 6627 //
     /* 1678614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1678625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1678628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1678631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1678634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1678637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678660 */     // MIs[0] policy
     /* 1678660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678670 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1678673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678694 */     // GIR_Coverage, 6627,
     /* 1678694 */     GIR_EraseRootFromParent_Done,
     /* 1678695 */   // Label 23040: @1678695
     /* 1678695 */   GIM_Try, /*On fail goto*//*Label 23041*/ GIMT_Encode4(1678781), // Rule ID 6630 //
     /* 1678700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1678711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1678714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1678717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1678720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678746 */     // MIs[0] policy
     /* 1678746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678756 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678780 */     // GIR_Coverage, 6630,
     /* 1678780 */     GIR_EraseRootFromParent_Done,
     /* 1678781 */   // Label 23041: @1678781
     /* 1678781 */   GIM_Try, /*On fail goto*//*Label 23042*/ GIMT_Encode4(1678867), // Rule ID 6631 //
     /* 1678786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1678797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1678800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1678803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1678806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678832 */     // MIs[0] policy
     /* 1678832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678842 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678866 */     // GIR_Coverage, 6631,
     /* 1678866 */     GIR_EraseRootFromParent_Done,
     /* 1678867 */   // Label 23042: @1678867
     /* 1678867 */   GIM_Try, /*On fail goto*//*Label 23043*/ GIMT_Encode4(1678953), // Rule ID 6634 //
     /* 1678872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1678883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1678886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1678889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1678892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678918 */     // MIs[0] policy
     /* 1678918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678928 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678952 */     // GIR_Coverage, 6634,
     /* 1678952 */     GIR_EraseRootFromParent_Done,
     /* 1678953 */   // Label 23043: @1678953
     /* 1678953 */   GIM_Try, /*On fail goto*//*Label 23044*/ GIMT_Encode4(1679039), // Rule ID 6635 //
     /* 1678958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1678969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1678972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1678975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1678978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679004 */     // MIs[0] policy
     /* 1679004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679014 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679038 */     // GIR_Coverage, 6635,
     /* 1679038 */     GIR_EraseRootFromParent_Done,
     /* 1679039 */   // Label 23044: @1679039
     /* 1679039 */   GIM_Try, /*On fail goto*//*Label 23045*/ GIMT_Encode4(1679125), // Rule ID 6638 //
     /* 1679044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1679055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1679058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1679061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1679064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1679067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679090 */     // MIs[0] policy
     /* 1679090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679100 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679124 */     // GIR_Coverage, 6638,
     /* 1679124 */     GIR_EraseRootFromParent_Done,
     /* 1679125 */   // Label 23045: @1679125
     /* 1679125 */   GIM_Try, /*On fail goto*//*Label 23046*/ GIMT_Encode4(1679211), // Rule ID 6639 //
     /* 1679130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1679141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1679144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1679147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1679150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1679153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679176 */     // MIs[0] policy
     /* 1679176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679186 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679210 */     // GIR_Coverage, 6639,
     /* 1679210 */     GIR_EraseRootFromParent_Done,
     /* 1679211 */   // Label 23046: @1679211
     /* 1679211 */   GIM_Try, /*On fail goto*//*Label 23047*/ GIMT_Encode4(1679297), // Rule ID 6642 //
     /* 1679216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1679227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1679230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1679233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1679236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679262 */     // MIs[0] policy
     /* 1679262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679272 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1679275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679296 */     // GIR_Coverage, 6642,
     /* 1679296 */     GIR_EraseRootFromParent_Done,
     /* 1679297 */   // Label 23047: @1679297
     /* 1679297 */   GIM_Try, /*On fail goto*//*Label 23048*/ GIMT_Encode4(1679383), // Rule ID 6643 //
     /* 1679302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1679313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1679316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1679319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1679322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679348 */     // MIs[0] policy
     /* 1679348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1679361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679382 */     // GIR_Coverage, 6643,
     /* 1679382 */     GIR_EraseRootFromParent_Done,
     /* 1679383 */   // Label 23048: @1679383
     /* 1679383 */   GIM_Try, /*On fail goto*//*Label 23049*/ GIMT_Encode4(1679469), // Rule ID 6646 //
     /* 1679388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1679399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1679402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1679405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1679408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679434 */     // MIs[0] policy
     /* 1679434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679444 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679468 */     // GIR_Coverage, 6646,
     /* 1679468 */     GIR_EraseRootFromParent_Done,
     /* 1679469 */   // Label 23049: @1679469
     /* 1679469 */   GIM_Try, /*On fail goto*//*Label 23050*/ GIMT_Encode4(1679555), // Rule ID 6647 //
     /* 1679474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1679485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1679488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1679491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1679494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679520 */     // MIs[0] policy
     /* 1679520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679530 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679554 */     // GIR_Coverage, 6647,
     /* 1679554 */     GIR_EraseRootFromParent_Done,
     /* 1679555 */   // Label 23050: @1679555
     /* 1679555 */   GIM_Try, /*On fail goto*//*Label 23051*/ GIMT_Encode4(1679641), // Rule ID 6650 //
     /* 1679560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1679571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1679574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1679577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1679580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679606 */     // MIs[0] policy
     /* 1679606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679616 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679640 */     // GIR_Coverage, 6650,
     /* 1679640 */     GIR_EraseRootFromParent_Done,
     /* 1679641 */   // Label 23051: @1679641
     /* 1679641 */   GIM_Try, /*On fail goto*//*Label 23052*/ GIMT_Encode4(1679727), // Rule ID 6651 //
     /* 1679646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1679657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1679660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1679663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1679666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679692 */     // MIs[0] policy
     /* 1679692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679702 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679726 */     // GIR_Coverage, 6651,
     /* 1679726 */     GIR_EraseRootFromParent_Done,
     /* 1679727 */   // Label 23052: @1679727
     /* 1679727 */   GIM_Try, /*On fail goto*//*Label 23053*/ GIMT_Encode4(1679813), // Rule ID 6654 //
     /* 1679732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1679743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1679746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1679749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1679752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679778 */     // MIs[0] policy
     /* 1679778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1679791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679812 */     // GIR_Coverage, 6654,
     /* 1679812 */     GIR_EraseRootFromParent_Done,
     /* 1679813 */   // Label 23053: @1679813
     /* 1679813 */   GIM_Try, /*On fail goto*//*Label 23054*/ GIMT_Encode4(1679899), // Rule ID 6655 //
     /* 1679818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1679829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1679832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1679835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1679838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679864 */     // MIs[0] policy
     /* 1679864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1679877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679898 */     // GIR_Coverage, 6655,
     /* 1679898 */     GIR_EraseRootFromParent_Done,
     /* 1679899 */   // Label 23054: @1679899
     /* 1679899 */   GIM_Try, /*On fail goto*//*Label 23055*/ GIMT_Encode4(1679985), // Rule ID 6658 //
     /* 1679904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1679915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1679918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1679921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1679924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679950 */     // MIs[0] policy
     /* 1679950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679960 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679984 */     // GIR_Coverage, 6658,
     /* 1679984 */     GIR_EraseRootFromParent_Done,
     /* 1679985 */   // Label 23055: @1679985
     /* 1679985 */   GIM_Try, /*On fail goto*//*Label 23056*/ GIMT_Encode4(1680071), // Rule ID 6659 //
     /* 1679990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1680001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1680004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1680007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1680010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1680020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680036 */     // MIs[0] policy
     /* 1680036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680046 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1680049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680070 */     // GIR_Coverage, 6659,
     /* 1680070 */     GIR_EraseRootFromParent_Done,
     /* 1680071 */   // Label 23056: @1680071
     /* 1680071 */   GIM_Try, /*On fail goto*//*Label 23057*/ GIMT_Encode4(1680157), // Rule ID 6662 //
     /* 1680076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1680079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1680087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1680090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1680093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1680096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680122 */     // MIs[0] policy
     /* 1680122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680132 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1680135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680156 */     // GIR_Coverage, 6662,
     /* 1680156 */     GIR_EraseRootFromParent_Done,
     /* 1680157 */   // Label 23057: @1680157
     /* 1680157 */   GIM_Try, /*On fail goto*//*Label 23058*/ GIMT_Encode4(1680243), // Rule ID 6663 //
     /* 1680162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1680165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1680173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1680176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1680179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1680182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680208 */     // MIs[0] policy
     /* 1680208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680218 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1680221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680242 */     // GIR_Coverage, 6663,
     /* 1680242 */     GIR_EraseRootFromParent_Done,
     /* 1680243 */   // Label 23058: @1680243
     /* 1680243 */   GIM_Try, /*On fail goto*//*Label 23059*/ GIMT_Encode4(1680329), // Rule ID 6666 //
     /* 1680248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1680259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1680262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1680265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680294 */     // MIs[0] policy
     /* 1680294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680304 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1680307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680328 */     // GIR_Coverage, 6666,
     /* 1680328 */     GIR_EraseRootFromParent_Done,
     /* 1680329 */   // Label 23059: @1680329
     /* 1680329 */   GIM_Try, /*On fail goto*//*Label 23060*/ GIMT_Encode4(1680415), // Rule ID 6667 //
     /* 1680334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1680345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1680348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1680351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680380 */     // MIs[0] policy
     /* 1680380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680390 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1680393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680414 */     // GIR_Coverage, 6667,
     /* 1680414 */     GIR_EraseRootFromParent_Done,
     /* 1680415 */   // Label 23060: @1680415
     /* 1680415 */   GIM_Try, /*On fail goto*//*Label 23061*/ GIMT_Encode4(1680501), // Rule ID 6670 //
     /* 1680420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1680431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1680434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1680437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680466 */     // MIs[0] policy
     /* 1680466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680476 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680500 */     // GIR_Coverage, 6670,
     /* 1680500 */     GIR_EraseRootFromParent_Done,
     /* 1680501 */   // Label 23061: @1680501
     /* 1680501 */   GIM_Try, /*On fail goto*//*Label 23062*/ GIMT_Encode4(1680587), // Rule ID 6671 //
     /* 1680506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1680517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1680520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1680523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680552 */     // MIs[0] policy
     /* 1680552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680562 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680586 */     // GIR_Coverage, 6671,
     /* 1680586 */     GIR_EraseRootFromParent_Done,
     /* 1680587 */   // Label 23062: @1680587
     /* 1680587 */   GIM_Try, /*On fail goto*//*Label 23063*/ GIMT_Encode4(1680673), // Rule ID 6674 //
     /* 1680592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1680603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1680606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1680609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680638 */     // MIs[0] policy
     /* 1680638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680648 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680672 */     // GIR_Coverage, 6674,
     /* 1680672 */     GIR_EraseRootFromParent_Done,
     /* 1680673 */   // Label 23063: @1680673
     /* 1680673 */   GIM_Try, /*On fail goto*//*Label 23064*/ GIMT_Encode4(1680759), // Rule ID 6675 //
     /* 1680678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1680689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1680692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1680695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680724 */     // MIs[0] policy
     /* 1680724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680734 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680758 */     // GIR_Coverage, 6675,
     /* 1680758 */     GIR_EraseRootFromParent_Done,
     /* 1680759 */   // Label 23064: @1680759
     /* 1680759 */   GIM_Try, /*On fail goto*//*Label 23065*/ GIMT_Encode4(1680845), // Rule ID 6678 //
     /* 1680764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1680775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1680778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1680781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680810 */     // MIs[0] policy
     /* 1680810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680820 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680844 */     // GIR_Coverage, 6678,
     /* 1680844 */     GIR_EraseRootFromParent_Done,
     /* 1680845 */   // Label 23065: @1680845
     /* 1680845 */   GIM_Try, /*On fail goto*//*Label 23066*/ GIMT_Encode4(1680931), // Rule ID 6679 //
     /* 1680850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1680861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1680864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1680867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680896 */     // MIs[0] policy
     /* 1680896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680906 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680930 */     // GIR_Coverage, 6679,
     /* 1680930 */     GIR_EraseRootFromParent_Done,
     /* 1680931 */   // Label 23066: @1680931
     /* 1680931 */   GIM_Try, /*On fail goto*//*Label 23067*/ GIMT_Encode4(1681017), // Rule ID 6682 //
     /* 1680936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1680947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1680950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1680953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680982 */     // MIs[0] policy
     /* 1680982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680992 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681016 */     // GIR_Coverage, 6682,
     /* 1681016 */     GIR_EraseRootFromParent_Done,
     /* 1681017 */   // Label 23067: @1681017
     /* 1681017 */   GIM_Try, /*On fail goto*//*Label 23068*/ GIMT_Encode4(1681103), // Rule ID 6683 //
     /* 1681022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1681033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1681036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1681039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681068 */     // MIs[0] policy
     /* 1681068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681078 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1681081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681102 */     // GIR_Coverage, 6683,
     /* 1681102 */     GIR_EraseRootFromParent_Done,
     /* 1681103 */   // Label 23068: @1681103
     /* 1681103 */   GIM_Try, /*On fail goto*//*Label 23069*/ GIMT_Encode4(1681189), // Rule ID 6686 //
     /* 1681108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1681119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1681122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1681125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681154 */     // MIs[0] policy
     /* 1681154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681164 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1681167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681188 */     // GIR_Coverage, 6686,
     /* 1681188 */     GIR_EraseRootFromParent_Done,
     /* 1681189 */   // Label 23069: @1681189
     /* 1681189 */   GIM_Try, /*On fail goto*//*Label 23070*/ GIMT_Encode4(1681275), // Rule ID 6687 //
     /* 1681194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1681205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1681208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1681211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681240 */     // MIs[0] policy
     /* 1681240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681250 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1681253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681274 */     // GIR_Coverage, 6687,
     /* 1681274 */     GIR_EraseRootFromParent_Done,
     /* 1681275 */   // Label 23070: @1681275
     /* 1681275 */   GIM_Try, /*On fail goto*//*Label 23071*/ GIMT_Encode4(1681361), // Rule ID 6690 //
     /* 1681280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1681291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1681294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1681297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1681303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681326 */     // MIs[0] policy
     /* 1681326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681336 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681360 */     // GIR_Coverage, 6690,
     /* 1681360 */     GIR_EraseRootFromParent_Done,
     /* 1681361 */   // Label 23071: @1681361
     /* 1681361 */   GIM_Try, /*On fail goto*//*Label 23072*/ GIMT_Encode4(1681447), // Rule ID 6691 //
     /* 1681366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1681377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1681380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1681383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1681389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681412 */     // MIs[0] policy
     /* 1681412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681422 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681446 */     // GIR_Coverage, 6691,
     /* 1681446 */     GIR_EraseRootFromParent_Done,
     /* 1681447 */   // Label 23072: @1681447
     /* 1681447 */   GIM_Try, /*On fail goto*//*Label 23073*/ GIMT_Encode4(1681533), // Rule ID 6694 //
     /* 1681452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1681463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1681466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1681469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681498 */     // MIs[0] policy
     /* 1681498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681508 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681532 */     // GIR_Coverage, 6694,
     /* 1681532 */     GIR_EraseRootFromParent_Done,
     /* 1681533 */   // Label 23073: @1681533
     /* 1681533 */   GIM_Try, /*On fail goto*//*Label 23074*/ GIMT_Encode4(1681619), // Rule ID 6695 //
     /* 1681538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1681549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1681552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1681555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681584 */     // MIs[0] policy
     /* 1681584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681594 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681618 */     // GIR_Coverage, 6695,
     /* 1681618 */     GIR_EraseRootFromParent_Done,
     /* 1681619 */   // Label 23074: @1681619
     /* 1681619 */   GIM_Try, /*On fail goto*//*Label 23075*/ GIMT_Encode4(1681705), // Rule ID 6698 //
     /* 1681624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1681635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1681638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1681641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681670 */     // MIs[0] policy
     /* 1681670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681680 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681704 */     // GIR_Coverage, 6698,
     /* 1681704 */     GIR_EraseRootFromParent_Done,
     /* 1681705 */   // Label 23075: @1681705
     /* 1681705 */   GIM_Try, /*On fail goto*//*Label 23076*/ GIMT_Encode4(1681791), // Rule ID 6699 //
     /* 1681710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1681721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1681724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1681727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681756 */     // MIs[0] policy
     /* 1681756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681766 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681790 */     // GIR_Coverage, 6699,
     /* 1681790 */     GIR_EraseRootFromParent_Done,
     /* 1681791 */   // Label 23076: @1681791
     /* 1681791 */   GIM_Try, /*On fail goto*//*Label 23077*/ GIMT_Encode4(1681877), // Rule ID 6702 //
     /* 1681796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1681799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1681807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1681810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1681813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681842 */     // MIs[0] policy
     /* 1681842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681876 */     // GIR_Coverage, 6702,
     /* 1681876 */     GIR_EraseRootFromParent_Done,
     /* 1681877 */   // Label 23077: @1681877
     /* 1681877 */   GIM_Try, /*On fail goto*//*Label 23078*/ GIMT_Encode4(1681963), // Rule ID 6703 //
     /* 1681882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1681885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1681893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1681896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1681899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681928 */     // MIs[0] policy
     /* 1681928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681938 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681962 */     // GIR_Coverage, 6703,
     /* 1681962 */     GIR_EraseRootFromParent_Done,
     /* 1681963 */   // Label 23078: @1681963
     /* 1681963 */   GIM_Try, /*On fail goto*//*Label 23079*/ GIMT_Encode4(1682049), // Rule ID 6706 //
     /* 1681968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1681979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1681982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1681985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1681991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1681998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682014 */     // MIs[0] policy
     /* 1682014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682024 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682048 */     // GIR_Coverage, 6706,
     /* 1682048 */     GIR_EraseRootFromParent_Done,
     /* 1682049 */   // Label 23079: @1682049
     /* 1682049 */   GIM_Try, /*On fail goto*//*Label 23080*/ GIMT_Encode4(1682135), // Rule ID 6707 //
     /* 1682054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1682065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1682068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1682071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682100 */     // MIs[0] policy
     /* 1682100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682110 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682134 */     // GIR_Coverage, 6707,
     /* 1682134 */     GIR_EraseRootFromParent_Done,
     /* 1682135 */   // Label 23080: @1682135
     /* 1682135 */   GIM_Try, /*On fail goto*//*Label 23081*/ GIMT_Encode4(1682221), // Rule ID 6710 //
     /* 1682140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1682151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1682154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1682157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682186 */     // MIs[0] policy
     /* 1682186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682196 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682220 */     // GIR_Coverage, 6710,
     /* 1682220 */     GIR_EraseRootFromParent_Done,
     /* 1682221 */   // Label 23081: @1682221
     /* 1682221 */   GIM_Try, /*On fail goto*//*Label 23082*/ GIMT_Encode4(1682307), // Rule ID 6711 //
     /* 1682226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1682237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1682240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1682243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682272 */     // MIs[0] policy
     /* 1682272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682282 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682306 */     // GIR_Coverage, 6711,
     /* 1682306 */     GIR_EraseRootFromParent_Done,
     /* 1682307 */   // Label 23082: @1682307
     /* 1682307 */   GIM_Try, /*On fail goto*//*Label 23083*/ GIMT_Encode4(1682393), // Rule ID 6714 //
     /* 1682312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1682323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1682326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1682329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1682335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682358 */     // MIs[0] policy
     /* 1682358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682368 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682392 */     // GIR_Coverage, 6714,
     /* 1682392 */     GIR_EraseRootFromParent_Done,
     /* 1682393 */   // Label 23083: @1682393
     /* 1682393 */   GIM_Try, /*On fail goto*//*Label 23084*/ GIMT_Encode4(1682479), // Rule ID 6715 //
     /* 1682398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1682409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1682412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1682415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1682421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682444 */     // MIs[0] policy
     /* 1682444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682454 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682478 */     // GIR_Coverage, 6715,
     /* 1682478 */     GIR_EraseRootFromParent_Done,
     /* 1682479 */   // Label 23084: @1682479
     /* 1682479 */   GIM_Try, /*On fail goto*//*Label 23085*/ GIMT_Encode4(1682565), // Rule ID 6718 //
     /* 1682484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1682495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1682498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1682501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682530 */     // MIs[0] policy
     /* 1682530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682564 */     // GIR_Coverage, 6718,
     /* 1682564 */     GIR_EraseRootFromParent_Done,
     /* 1682565 */   // Label 23085: @1682565
     /* 1682565 */   GIM_Try, /*On fail goto*//*Label 23086*/ GIMT_Encode4(1682651), // Rule ID 6719 //
     /* 1682570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1682581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1682584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1682587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682616 */     // MIs[0] policy
     /* 1682616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682650 */     // GIR_Coverage, 6719,
     /* 1682650 */     GIR_EraseRootFromParent_Done,
     /* 1682651 */   // Label 23086: @1682651
     /* 1682651 */   GIM_Try, /*On fail goto*//*Label 23087*/ GIMT_Encode4(1682737), // Rule ID 6722 //
     /* 1682656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1682667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1682670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1682673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682702 */     // MIs[0] policy
     /* 1682702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682712 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682736 */     // GIR_Coverage, 6722,
     /* 1682736 */     GIR_EraseRootFromParent_Done,
     /* 1682737 */   // Label 23087: @1682737
     /* 1682737 */   GIM_Try, /*On fail goto*//*Label 23088*/ GIMT_Encode4(1682823), // Rule ID 6723 //
     /* 1682742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1682753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1682756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1682759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682788 */     // MIs[0] policy
     /* 1682788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682798 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682822 */     // GIR_Coverage, 6723,
     /* 1682822 */     GIR_EraseRootFromParent_Done,
     /* 1682823 */   // Label 23088: @1682823
     /* 1682823 */   GIM_Try, /*On fail goto*//*Label 23089*/ GIMT_Encode4(1682909), // Rule ID 6726 //
     /* 1682828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1682839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1682842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1682845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682874 */     // MIs[0] policy
     /* 1682874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682884 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682908 */     // GIR_Coverage, 6726,
     /* 1682908 */     GIR_EraseRootFromParent_Done,
     /* 1682909 */   // Label 23089: @1682909
     /* 1682909 */   GIM_Try, /*On fail goto*//*Label 23090*/ GIMT_Encode4(1682995), // Rule ID 6727 //
     /* 1682914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1682925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1682928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1682931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682960 */     // MIs[0] policy
     /* 1682960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682970 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682994 */     // GIR_Coverage, 6727,
     /* 1682994 */     GIR_EraseRootFromParent_Done,
     /* 1682995 */   // Label 23090: @1682995
     /* 1682995 */   GIM_Try, /*On fail goto*//*Label 23091*/ GIMT_Encode4(1683081), // Rule ID 6730 //
     /* 1683000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1683011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1683014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1683017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683046 */     // MIs[0] policy
     /* 1683046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1683059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683080 */     // GIR_Coverage, 6730,
     /* 1683080 */     GIR_EraseRootFromParent_Done,
     /* 1683081 */   // Label 23091: @1683081
     /* 1683081 */   GIM_Try, /*On fail goto*//*Label 23092*/ GIMT_Encode4(1683167), // Rule ID 6731 //
     /* 1683086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1683097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1683100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1683103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683132 */     // MIs[0] policy
     /* 1683132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683142 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1683145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683166 */     // GIR_Coverage, 6731,
     /* 1683166 */     GIR_EraseRootFromParent_Done,
     /* 1683167 */   // Label 23092: @1683167
     /* 1683167 */   GIM_Try, /*On fail goto*//*Label 23093*/ GIMT_Encode4(1683253), // Rule ID 6734 //
     /* 1683172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1683183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1683186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1683189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683218 */     // MIs[0] policy
     /* 1683218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683228 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1683231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683252 */     // GIR_Coverage, 6734,
     /* 1683252 */     GIR_EraseRootFromParent_Done,
     /* 1683253 */   // Label 23093: @1683253
     /* 1683253 */   GIM_Try, /*On fail goto*//*Label 23094*/ GIMT_Encode4(1683339), // Rule ID 6735 //
     /* 1683258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1683269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1683272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1683275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683304 */     // MIs[0] policy
     /* 1683304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1683317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683338 */     // GIR_Coverage, 6735,
     /* 1683338 */     GIR_EraseRootFromParent_Done,
     /* 1683339 */   // Label 23094: @1683339
     /* 1683339 */   GIM_Try, /*On fail goto*//*Label 23095*/ GIMT_Encode4(1683425), // Rule ID 6738 //
     /* 1683344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1683355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1683358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1683361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683390 */     // MIs[0] policy
     /* 1683390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683424 */     // GIR_Coverage, 6738,
     /* 1683424 */     GIR_EraseRootFromParent_Done,
     /* 1683425 */   // Label 23095: @1683425
     /* 1683425 */   GIM_Try, /*On fail goto*//*Label 23096*/ GIMT_Encode4(1683511), // Rule ID 6739 //
     /* 1683430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1683441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1683444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1683447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683476 */     // MIs[0] policy
     /* 1683476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683510 */     // GIR_Coverage, 6739,
     /* 1683510 */     GIR_EraseRootFromParent_Done,
     /* 1683511 */   // Label 23096: @1683511
     /* 1683511 */   GIM_Try, /*On fail goto*//*Label 23097*/ GIMT_Encode4(1683597), // Rule ID 6742 //
     /* 1683516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1683527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1683530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1683533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683562 */     // MIs[0] policy
     /* 1683562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683572 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1683575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683596 */     // GIR_Coverage, 6742,
     /* 1683596 */     GIR_EraseRootFromParent_Done,
     /* 1683597 */   // Label 23097: @1683597
     /* 1683597 */   GIM_Try, /*On fail goto*//*Label 23098*/ GIMT_Encode4(1683683), // Rule ID 6743 //
     /* 1683602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1683613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1683616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1683619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683648 */     // MIs[0] policy
     /* 1683648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683658 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1683661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683682 */     // GIR_Coverage, 6743,
     /* 1683682 */     GIR_EraseRootFromParent_Done,
     /* 1683683 */   // Label 23098: @1683683
     /* 1683683 */   GIM_Try, /*On fail goto*//*Label 23099*/ GIMT_Encode4(1683769), // Rule ID 6746 //
     /* 1683688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1683699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1683702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1683705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683734 */     // MIs[0] policy
     /* 1683734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683744 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1683747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683768 */     // GIR_Coverage, 6746,
     /* 1683768 */     GIR_EraseRootFromParent_Done,
     /* 1683769 */   // Label 23099: @1683769
     /* 1683769 */   GIM_Try, /*On fail goto*//*Label 23100*/ GIMT_Encode4(1683855), // Rule ID 6747 //
     /* 1683774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1683785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1683788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1683791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683820 */     // MIs[0] policy
     /* 1683820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683830 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1683833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683854 */     // GIR_Coverage, 6747,
     /* 1683854 */     GIR_EraseRootFromParent_Done,
     /* 1683855 */   // Label 23100: @1683855
     /* 1683855 */   GIM_Try, /*On fail goto*//*Label 23101*/ GIMT_Encode4(1683941), // Rule ID 6750 //
     /* 1683860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1683871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1683874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1683877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683906 */     // MIs[0] policy
     /* 1683906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683916 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683940 */     // GIR_Coverage, 6750,
     /* 1683940 */     GIR_EraseRootFromParent_Done,
     /* 1683941 */   // Label 23101: @1683941
     /* 1683941 */   GIM_Try, /*On fail goto*//*Label 23102*/ GIMT_Encode4(1684027), // Rule ID 6751 //
     /* 1683946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1683957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1683960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1683963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683992 */     // MIs[0] policy
     /* 1683992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684002 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1684005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684026 */     // GIR_Coverage, 6751,
     /* 1684026 */     GIR_EraseRootFromParent_Done,
     /* 1684027 */   // Label 23102: @1684027
     /* 1684027 */   GIM_Try, /*On fail goto*//*Label 23103*/ GIMT_Encode4(1684113), // Rule ID 6842 //
     /* 1684032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1684043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1684046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1684049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1684052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684078 */     // MIs[0] policy
     /* 1684078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684088 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1684091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684112 */     // GIR_Coverage, 6842,
     /* 1684112 */     GIR_EraseRootFromParent_Done,
     /* 1684113 */   // Label 23103: @1684113
     /* 1684113 */   GIM_Try, /*On fail goto*//*Label 23104*/ GIMT_Encode4(1684199), // Rule ID 6843 //
     /* 1684118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1684129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1684132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1684135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1684138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684164 */     // MIs[0] policy
     /* 1684164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684174 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1684177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684198 */     // GIR_Coverage, 6843,
     /* 1684198 */     GIR_EraseRootFromParent_Done,
     /* 1684199 */   // Label 23104: @1684199
     /* 1684199 */   GIM_Try, /*On fail goto*//*Label 23105*/ GIMT_Encode4(1684285), // Rule ID 6846 //
     /* 1684204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1684215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1684218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1684221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1684224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684250 */     // MIs[0] policy
     /* 1684250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684260 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1684263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684284 */     // GIR_Coverage, 6846,
     /* 1684284 */     GIR_EraseRootFromParent_Done,
     /* 1684285 */   // Label 23105: @1684285
     /* 1684285 */   GIM_Try, /*On fail goto*//*Label 23106*/ GIMT_Encode4(1684371), // Rule ID 6847 //
     /* 1684290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1684301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1684304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1684307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1684310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684336 */     // MIs[0] policy
     /* 1684336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1684349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684370 */     // GIR_Coverage, 6847,
     /* 1684370 */     GIR_EraseRootFromParent_Done,
     /* 1684371 */   // Label 23106: @1684371
     /* 1684371 */   GIM_Try, /*On fail goto*//*Label 23107*/ GIMT_Encode4(1684457), // Rule ID 6850 //
     /* 1684376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1684387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1684390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1684393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1684396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684422 */     // MIs[0] policy
     /* 1684422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684432 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684456 */     // GIR_Coverage, 6850,
     /* 1684456 */     GIR_EraseRootFromParent_Done,
     /* 1684457 */   // Label 23107: @1684457
     /* 1684457 */   GIM_Try, /*On fail goto*//*Label 23108*/ GIMT_Encode4(1684543), // Rule ID 6851 //
     /* 1684462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1684473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1684476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1684479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1684482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684508 */     // MIs[0] policy
     /* 1684508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684542 */     // GIR_Coverage, 6851,
     /* 1684542 */     GIR_EraseRootFromParent_Done,
     /* 1684543 */   // Label 23108: @1684543
     /* 1684543 */   GIM_Try, /*On fail goto*//*Label 23109*/ GIMT_Encode4(1684629), // Rule ID 6854 //
     /* 1684548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1684559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1684562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1684565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1684568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684594 */     // MIs[0] policy
     /* 1684594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684604 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1684607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684628 */     // GIR_Coverage, 6854,
     /* 1684628 */     GIR_EraseRootFromParent_Done,
     /* 1684629 */   // Label 23109: @1684629
     /* 1684629 */   GIM_Try, /*On fail goto*//*Label 23110*/ GIMT_Encode4(1684715), // Rule ID 6855 //
     /* 1684634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1684645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1684648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1684651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1684654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684680 */     // MIs[0] policy
     /* 1684680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684690 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1684693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684714 */     // GIR_Coverage, 6855,
     /* 1684714 */     GIR_EraseRootFromParent_Done,
     /* 1684715 */   // Label 23110: @1684715
     /* 1684715 */   GIM_Try, /*On fail goto*//*Label 23111*/ GIMT_Encode4(1684801), // Rule ID 6858 //
     /* 1684720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1684731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1684734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1684737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1684740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684766 */     // MIs[0] policy
     /* 1684766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684776 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684800 */     // GIR_Coverage, 6858,
     /* 1684800 */     GIR_EraseRootFromParent_Done,
     /* 1684801 */   // Label 23111: @1684801
     /* 1684801 */   GIM_Try, /*On fail goto*//*Label 23112*/ GIMT_Encode4(1684887), // Rule ID 6859 //
     /* 1684806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1684817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1684820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1684823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1684826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684852 */     // MIs[0] policy
     /* 1684852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684862 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684886 */     // GIR_Coverage, 6859,
     /* 1684886 */     GIR_EraseRootFromParent_Done,
     /* 1684887 */   // Label 23112: @1684887
     /* 1684887 */   GIM_Try, /*On fail goto*//*Label 23113*/ GIMT_Encode4(1684973), // Rule ID 6862 //
     /* 1684892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1684903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1684906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1684909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1684912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684938 */     // MIs[0] policy
     /* 1684938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684948 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684972 */     // GIR_Coverage, 6862,
     /* 1684972 */     GIR_EraseRootFromParent_Done,
     /* 1684973 */   // Label 23113: @1684973
     /* 1684973 */   GIM_Try, /*On fail goto*//*Label 23114*/ GIMT_Encode4(1685059), // Rule ID 6863 //
     /* 1684978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1684989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1684992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1684995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1684998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685024 */     // MIs[0] policy
     /* 1685024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1685037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685058 */     // GIR_Coverage, 6863,
     /* 1685058 */     GIR_EraseRootFromParent_Done,
     /* 1685059 */   // Label 23114: @1685059
     /* 1685059 */   GIM_Try, /*On fail goto*//*Label 23115*/ GIMT_Encode4(1685145), // Rule ID 6866 //
     /* 1685064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1685075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1685078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1685081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1685084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685110 */     // MIs[0] policy
     /* 1685110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685120 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685144 */     // GIR_Coverage, 6866,
     /* 1685144 */     GIR_EraseRootFromParent_Done,
     /* 1685145 */   // Label 23115: @1685145
     /* 1685145 */   GIM_Try, /*On fail goto*//*Label 23116*/ GIMT_Encode4(1685231), // Rule ID 6867 //
     /* 1685150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1685161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1685164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1685167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1685170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685196 */     // MIs[0] policy
     /* 1685196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685206 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685230 */     // GIR_Coverage, 6867,
     /* 1685230 */     GIR_EraseRootFromParent_Done,
     /* 1685231 */   // Label 23116: @1685231
     /* 1685231 */   GIM_Try, /*On fail goto*//*Label 23117*/ GIMT_Encode4(1685317), // Rule ID 6870 //
     /* 1685236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1685247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1685250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1685253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1685256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1685259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685282 */     // MIs[0] policy
     /* 1685282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685292 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685316 */     // GIR_Coverage, 6870,
     /* 1685316 */     GIR_EraseRootFromParent_Done,
     /* 1685317 */   // Label 23117: @1685317
     /* 1685317 */   GIM_Try, /*On fail goto*//*Label 23118*/ GIMT_Encode4(1685403), // Rule ID 6871 //
     /* 1685322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1685333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1685336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1685339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1685342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1685345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685368 */     // MIs[0] policy
     /* 1685368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685378 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685402 */     // GIR_Coverage, 6871,
     /* 1685402 */     GIR_EraseRootFromParent_Done,
     /* 1685403 */   // Label 23118: @1685403
     /* 1685403 */   GIM_Try, /*On fail goto*//*Label 23119*/ GIMT_Encode4(1685489), // Rule ID 6874 //
     /* 1685408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1685419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1685422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1685425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1685428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685454 */     // MIs[0] policy
     /* 1685454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685488 */     // GIR_Coverage, 6874,
     /* 1685488 */     GIR_EraseRootFromParent_Done,
     /* 1685489 */   // Label 23119: @1685489
     /* 1685489 */   GIM_Try, /*On fail goto*//*Label 23120*/ GIMT_Encode4(1685575), // Rule ID 6875 //
     /* 1685494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1685505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1685508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1685511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1685514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685540 */     // MIs[0] policy
     /* 1685540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685574 */     // GIR_Coverage, 6875,
     /* 1685574 */     GIR_EraseRootFromParent_Done,
     /* 1685575 */   // Label 23120: @1685575
     /* 1685575 */   GIM_Try, /*On fail goto*//*Label 23121*/ GIMT_Encode4(1685661), // Rule ID 6878 //
     /* 1685580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1685583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1685591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1685594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1685597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1685600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685626 */     // MIs[0] policy
     /* 1685626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685660 */     // GIR_Coverage, 6878,
     /* 1685660 */     GIR_EraseRootFromParent_Done,
     /* 1685661 */   // Label 23121: @1685661
     /* 1685661 */   GIM_Try, /*On fail goto*//*Label 23122*/ GIMT_Encode4(1685747), // Rule ID 6879 //
     /* 1685666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1685669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1685677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1685680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1685683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1685686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685712 */     // MIs[0] policy
     /* 1685712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685722 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685746 */     // GIR_Coverage, 6879,
     /* 1685746 */     GIR_EraseRootFromParent_Done,
     /* 1685747 */   // Label 23122: @1685747
     /* 1685747 */   GIM_Try, /*On fail goto*//*Label 23123*/ GIMT_Encode4(1685833), // Rule ID 6882 //
     /* 1685752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1685763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1685766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1685769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1685772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1685775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685798 */     // MIs[0] policy
     /* 1685798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685808 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1685811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685832 */     // GIR_Coverage, 6882,
     /* 1685832 */     GIR_EraseRootFromParent_Done,
     /* 1685833 */   // Label 23123: @1685833
     /* 1685833 */   GIM_Try, /*On fail goto*//*Label 23124*/ GIMT_Encode4(1685919), // Rule ID 6883 //
     /* 1685838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1685849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1685852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1685855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1685858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1685861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685884 */     // MIs[0] policy
     /* 1685884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685894 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1685897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685918 */     // GIR_Coverage, 6883,
     /* 1685918 */     GIR_EraseRootFromParent_Done,
     /* 1685919 */   // Label 23124: @1685919
     /* 1685919 */   GIM_Try, /*On fail goto*//*Label 23125*/ GIMT_Encode4(1686005), // Rule ID 6886 //
     /* 1685924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1685935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1685938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1685941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1685944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1685947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1685954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685970 */     // MIs[0] policy
     /* 1685970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685980 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1685983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686004 */     // GIR_Coverage, 6886,
     /* 1686004 */     GIR_EraseRootFromParent_Done,
     /* 1686005 */   // Label 23125: @1686005
     /* 1686005 */   GIM_Try, /*On fail goto*//*Label 23126*/ GIMT_Encode4(1686091), // Rule ID 6887 //
     /* 1686010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1686021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1686024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1686027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1686030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686056 */     // MIs[0] policy
     /* 1686056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686066 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686090 */     // GIR_Coverage, 6887,
     /* 1686090 */     GIR_EraseRootFromParent_Done,
     /* 1686091 */   // Label 23126: @1686091
     /* 1686091 */   GIM_Try, /*On fail goto*//*Label 23127*/ GIMT_Encode4(1686177), // Rule ID 6890 //
     /* 1686096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1686107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1686110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1686113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1686116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1686119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686142 */     // MIs[0] policy
     /* 1686142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686176 */     // GIR_Coverage, 6890,
     /* 1686176 */     GIR_EraseRootFromParent_Done,
     /* 1686177 */   // Label 23127: @1686177
     /* 1686177 */   GIM_Try, /*On fail goto*//*Label 23128*/ GIMT_Encode4(1686263), // Rule ID 6891 //
     /* 1686182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1686193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1686196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1686199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1686202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1686205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686228 */     // MIs[0] policy
     /* 1686228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686238 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686262 */     // GIR_Coverage, 6891,
     /* 1686262 */     GIR_EraseRootFromParent_Done,
     /* 1686263 */   // Label 23128: @1686263
     /* 1686263 */   GIM_Try, /*On fail goto*//*Label 23129*/ GIMT_Encode4(1686349), // Rule ID 6894 //
     /* 1686268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1686279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1686282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1686285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1686288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686314 */     // MIs[0] policy
     /* 1686314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686348 */     // GIR_Coverage, 6894,
     /* 1686348 */     GIR_EraseRootFromParent_Done,
     /* 1686349 */   // Label 23129: @1686349
     /* 1686349 */   GIM_Try, /*On fail goto*//*Label 23130*/ GIMT_Encode4(1686435), // Rule ID 6895 //
     /* 1686354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1686365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1686368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1686371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1686374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686400 */     // MIs[0] policy
     /* 1686400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686410 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686434 */     // GIR_Coverage, 6895,
     /* 1686434 */     GIR_EraseRootFromParent_Done,
     /* 1686435 */   // Label 23130: @1686435
     /* 1686435 */   GIM_Try, /*On fail goto*//*Label 23131*/ GIMT_Encode4(1686521), // Rule ID 6898 //
     /* 1686440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1686451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1686454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1686457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1686460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686486 */     // MIs[0] policy
     /* 1686486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686520 */     // GIR_Coverage, 6898,
     /* 1686520 */     GIR_EraseRootFromParent_Done,
     /* 1686521 */   // Label 23131: @1686521
     /* 1686521 */   GIM_Try, /*On fail goto*//*Label 23132*/ GIMT_Encode4(1686607), // Rule ID 6899 //
     /* 1686526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1686537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1686540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1686543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1686546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686572 */     // MIs[0] policy
     /* 1686572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686582 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686606 */     // GIR_Coverage, 6899,
     /* 1686606 */     GIR_EraseRootFromParent_Done,
     /* 1686607 */   // Label 23132: @1686607
     /* 1686607 */   GIM_Try, /*On fail goto*//*Label 23133*/ GIMT_Encode4(1686693), // Rule ID 6902 //
     /* 1686612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1686623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1686626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1686629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1686632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686658 */     // MIs[0] policy
     /* 1686658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686668 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686692 */     // GIR_Coverage, 6902,
     /* 1686692 */     GIR_EraseRootFromParent_Done,
     /* 1686693 */   // Label 23133: @1686693
     /* 1686693 */   GIM_Try, /*On fail goto*//*Label 23134*/ GIMT_Encode4(1686779), // Rule ID 6903 //
     /* 1686698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1686709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1686712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1686715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1686718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686744 */     // MIs[0] policy
     /* 1686744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686754 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686778 */     // GIR_Coverage, 6903,
     /* 1686778 */     GIR_EraseRootFromParent_Done,
     /* 1686779 */   // Label 23134: @1686779
     /* 1686779 */   GIM_Try, /*On fail goto*//*Label 23135*/ GIMT_Encode4(1686865), // Rule ID 6906 //
     /* 1686784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1686795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1686798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1686801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1686804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686830 */     // MIs[0] policy
     /* 1686830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686864 */     // GIR_Coverage, 6906,
     /* 1686864 */     GIR_EraseRootFromParent_Done,
     /* 1686865 */   // Label 23135: @1686865
     /* 1686865 */   GIM_Try, /*On fail goto*//*Label 23136*/ GIMT_Encode4(1686951), // Rule ID 6907 //
     /* 1686870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1686881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1686884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1686887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1686890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686916 */     // MIs[0] policy
     /* 1686916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686950 */     // GIR_Coverage, 6907,
     /* 1686950 */     GIR_EraseRootFromParent_Done,
     /* 1686951 */   // Label 23136: @1686951
     /* 1686951 */   GIM_Try, /*On fail goto*//*Label 23137*/ GIMT_Encode4(1687037), // Rule ID 6910 //
     /* 1686956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1686967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1686970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1686973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1686976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687002 */     // MIs[0] policy
     /* 1687002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687012 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1687015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687036 */     // GIR_Coverage, 6910,
     /* 1687036 */     GIR_EraseRootFromParent_Done,
     /* 1687037 */   // Label 23137: @1687037
     /* 1687037 */   GIM_Try, /*On fail goto*//*Label 23138*/ GIMT_Encode4(1687123), // Rule ID 6911 //
     /* 1687042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1687053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1687056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1687059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1687062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687088 */     // MIs[0] policy
     /* 1687088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687098 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1687101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687122 */     // GIR_Coverage, 6911,
     /* 1687122 */     GIR_EraseRootFromParent_Done,
     /* 1687123 */   // Label 23138: @1687123
     /* 1687123 */   GIM_Try, /*On fail goto*//*Label 23139*/ GIMT_Encode4(1687209), // Rule ID 6914 //
     /* 1687128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1687139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1687142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1687145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1687148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1687151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687174 */     // MIs[0] policy
     /* 1687174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687184 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1687187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687208 */     // GIR_Coverage, 6914,
     /* 1687208 */     GIR_EraseRootFromParent_Done,
     /* 1687209 */   // Label 23139: @1687209
     /* 1687209 */   GIM_Try, /*On fail goto*//*Label 23140*/ GIMT_Encode4(1687295), // Rule ID 6915 //
     /* 1687214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1687225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1687228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1687231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1687234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1687237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687260 */     // MIs[0] policy
     /* 1687260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687270 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1687273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687294 */     // GIR_Coverage, 6915,
     /* 1687294 */     GIR_EraseRootFromParent_Done,
     /* 1687295 */   // Label 23140: @1687295
     /* 1687295 */   GIM_Try, /*On fail goto*//*Label 23141*/ GIMT_Encode4(1687381), // Rule ID 6918 //
     /* 1687300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1687311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1687314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1687317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1687320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687346 */     // MIs[0] policy
     /* 1687346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687356 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1687359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687380 */     // GIR_Coverage, 6918,
     /* 1687380 */     GIR_EraseRootFromParent_Done,
     /* 1687381 */   // Label 23141: @1687381
     /* 1687381 */   GIM_Try, /*On fail goto*//*Label 23142*/ GIMT_Encode4(1687467), // Rule ID 6919 //
     /* 1687386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1687397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1687400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1687403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1687406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687432 */     // MIs[0] policy
     /* 1687432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687442 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1687445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687466 */     // GIR_Coverage, 6919,
     /* 1687466 */     GIR_EraseRootFromParent_Done,
     /* 1687467 */   // Label 23142: @1687467
     /* 1687467 */   GIM_Try, /*On fail goto*//*Label 23143*/ GIMT_Encode4(1687553), // Rule ID 6922 //
     /* 1687472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1687492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687518 */     // MIs[0] policy
     /* 1687518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687528 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1687531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687552 */     // GIR_Coverage, 6922,
     /* 1687552 */     GIR_EraseRootFromParent_Done,
     /* 1687553 */   // Label 23143: @1687553
     /* 1687553 */   GIM_Try, /*On fail goto*//*Label 23144*/ GIMT_Encode4(1687639), // Rule ID 6923 //
     /* 1687558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1687578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687604 */     // MIs[0] policy
     /* 1687604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687614 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1687617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687638 */     // GIR_Coverage, 6923,
     /* 1687638 */     GIR_EraseRootFromParent_Done,
     /* 1687639 */   // Label 23144: @1687639
     /* 1687639 */   GIM_Try, /*On fail goto*//*Label 23145*/ GIMT_Encode4(1687725), // Rule ID 6926 //
     /* 1687644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1687655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1687658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1687661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1687664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687690 */     // MIs[0] policy
     /* 1687690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687700 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1687703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687724 */     // GIR_Coverage, 6926,
     /* 1687724 */     GIR_EraseRootFromParent_Done,
     /* 1687725 */   // Label 23145: @1687725
     /* 1687725 */   GIM_Try, /*On fail goto*//*Label 23146*/ GIMT_Encode4(1687811), // Rule ID 6927 //
     /* 1687730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1687741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1687744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1687747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1687750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687776 */     // MIs[0] policy
     /* 1687776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1687789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687810 */     // GIR_Coverage, 6927,
     /* 1687810 */     GIR_EraseRootFromParent_Done,
     /* 1687811 */   // Label 23146: @1687811
     /* 1687811 */   GIM_Try, /*On fail goto*//*Label 23147*/ GIMT_Encode4(1687897), // Rule ID 6930 //
     /* 1687816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1687827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1687830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1687833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687862 */     // MIs[0] policy
     /* 1687862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687872 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1687875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687896 */     // GIR_Coverage, 6930,
     /* 1687896 */     GIR_EraseRootFromParent_Done,
     /* 1687897 */   // Label 23147: @1687897
     /* 1687897 */   GIM_Try, /*On fail goto*//*Label 23148*/ GIMT_Encode4(1687983), // Rule ID 6931 //
     /* 1687902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1687913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1687916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1687919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687948 */     // MIs[0] policy
     /* 1687948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687958 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1687961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687982 */     // GIR_Coverage, 6931,
     /* 1687982 */     GIR_EraseRootFromParent_Done,
     /* 1687983 */   // Label 23148: @1687983
     /* 1687983 */   GIM_Try, /*On fail goto*//*Label 23149*/ GIMT_Encode4(1688069), // Rule ID 6934 //
     /* 1687988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1687999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1688002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1688005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688034 */     // MIs[0] policy
     /* 1688034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688044 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1688047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688068 */     // GIR_Coverage, 6934,
     /* 1688068 */     GIR_EraseRootFromParent_Done,
     /* 1688069 */   // Label 23149: @1688069
     /* 1688069 */   GIM_Try, /*On fail goto*//*Label 23150*/ GIMT_Encode4(1688155), // Rule ID 6935 //
     /* 1688074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1688085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1688088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1688091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688120 */     // MIs[0] policy
     /* 1688120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688130 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1688133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688154 */     // GIR_Coverage, 6935,
     /* 1688154 */     GIR_EraseRootFromParent_Done,
     /* 1688155 */   // Label 23150: @1688155
     /* 1688155 */   GIM_Try, /*On fail goto*//*Label 23151*/ GIMT_Encode4(1688241), // Rule ID 6938 //
     /* 1688160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1688171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1688174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1688177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688206 */     // MIs[0] policy
     /* 1688206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688216 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688240 */     // GIR_Coverage, 6938,
     /* 1688240 */     GIR_EraseRootFromParent_Done,
     /* 1688241 */   // Label 23151: @1688241
     /* 1688241 */   GIM_Try, /*On fail goto*//*Label 23152*/ GIMT_Encode4(1688327), // Rule ID 6939 //
     /* 1688246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1688257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1688260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1688263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688292 */     // MIs[0] policy
     /* 1688292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688302 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688326 */     // GIR_Coverage, 6939,
     /* 1688326 */     GIR_EraseRootFromParent_Done,
     /* 1688327 */   // Label 23152: @1688327
     /* 1688327 */   GIM_Try, /*On fail goto*//*Label 23153*/ GIMT_Encode4(1688413), // Rule ID 6942 //
     /* 1688332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1688343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1688346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1688349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688378 */     // MIs[0] policy
     /* 1688378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1688391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688412 */     // GIR_Coverage, 6942,
     /* 1688412 */     GIR_EraseRootFromParent_Done,
     /* 1688413 */   // Label 23153: @1688413
     /* 1688413 */   GIM_Try, /*On fail goto*//*Label 23154*/ GIMT_Encode4(1688499), // Rule ID 6943 //
     /* 1688418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1688429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1688432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1688435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688464 */     // MIs[0] policy
     /* 1688464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1688477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688498 */     // GIR_Coverage, 6943,
     /* 1688498 */     GIR_EraseRootFromParent_Done,
     /* 1688499 */   // Label 23154: @1688499
     /* 1688499 */   GIM_Try, /*On fail goto*//*Label 23155*/ GIMT_Encode4(1688585), // Rule ID 6946 //
     /* 1688504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1688515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1688518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1688521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688550 */     // MIs[0] policy
     /* 1688550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688560 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688584 */     // GIR_Coverage, 6946,
     /* 1688584 */     GIR_EraseRootFromParent_Done,
     /* 1688585 */   // Label 23155: @1688585
     /* 1688585 */   GIM_Try, /*On fail goto*//*Label 23156*/ GIMT_Encode4(1688671), // Rule ID 6947 //
     /* 1688590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1688601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1688604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1688607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688636 */     // MIs[0] policy
     /* 1688636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688646 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688670 */     // GIR_Coverage, 6947,
     /* 1688670 */     GIR_EraseRootFromParent_Done,
     /* 1688671 */   // Label 23156: @1688671
     /* 1688671 */   GIM_Try, /*On fail goto*//*Label 23157*/ GIMT_Encode4(1688757), // Rule ID 6950 //
     /* 1688676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1688687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1688690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1688693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688722 */     // MIs[0] policy
     /* 1688722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688756 */     // GIR_Coverage, 6950,
     /* 1688756 */     GIR_EraseRootFromParent_Done,
     /* 1688757 */   // Label 23157: @1688757
     /* 1688757 */   GIM_Try, /*On fail goto*//*Label 23158*/ GIMT_Encode4(1688843), // Rule ID 6951 //
     /* 1688762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1688773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1688776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1688779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688808 */     // MIs[0] policy
     /* 1688808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688818 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688842 */     // GIR_Coverage, 6951,
     /* 1688842 */     GIR_EraseRootFromParent_Done,
     /* 1688843 */   // Label 23158: @1688843
     /* 1688843 */   GIM_Try, /*On fail goto*//*Label 23159*/ GIMT_Encode4(1688929), // Rule ID 6954 //
     /* 1688848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1688859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1688862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1688865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688894 */     // MIs[0] policy
     /* 1688894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688904 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688928 */     // GIR_Coverage, 6954,
     /* 1688928 */     GIR_EraseRootFromParent_Done,
     /* 1688929 */   // Label 23159: @1688929
     /* 1688929 */   GIM_Try, /*On fail goto*//*Label 23160*/ GIMT_Encode4(1689015), // Rule ID 6955 //
     /* 1688934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1688945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1688948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1688951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688980 */     // MIs[0] policy
     /* 1688980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689014 */     // GIR_Coverage, 6955,
     /* 1689014 */     GIR_EraseRootFromParent_Done,
     /* 1689015 */   // Label 23160: @1689015
     /* 1689015 */   GIM_Try, /*On fail goto*//*Label 23161*/ GIMT_Encode4(1689101), // Rule ID 6958 //
     /* 1689020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1689031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1689034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1689037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1689043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689066 */     // MIs[0] policy
     /* 1689066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689076 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689100 */     // GIR_Coverage, 6958,
     /* 1689100 */     GIR_EraseRootFromParent_Done,
     /* 1689101 */   // Label 23161: @1689101
     /* 1689101 */   GIM_Try, /*On fail goto*//*Label 23162*/ GIMT_Encode4(1689187), // Rule ID 6959 //
     /* 1689106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1689117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1689120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1689123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1689129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689152 */     // MIs[0] policy
     /* 1689152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689162 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689186 */     // GIR_Coverage, 6959,
     /* 1689186 */     GIR_EraseRootFromParent_Done,
     /* 1689187 */   // Label 23162: @1689187
     /* 1689187 */   GIM_Try, /*On fail goto*//*Label 23163*/ GIMT_Encode4(1689273), // Rule ID 6962 //
     /* 1689192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1689203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1689206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1689209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689238 */     // MIs[0] policy
     /* 1689238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689248 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689272 */     // GIR_Coverage, 6962,
     /* 1689272 */     GIR_EraseRootFromParent_Done,
     /* 1689273 */   // Label 23163: @1689273
     /* 1689273 */   GIM_Try, /*On fail goto*//*Label 23164*/ GIMT_Encode4(1689359), // Rule ID 6963 //
     /* 1689278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1689289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1689292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1689295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689324 */     // MIs[0] policy
     /* 1689324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689358 */     // GIR_Coverage, 6963,
     /* 1689358 */     GIR_EraseRootFromParent_Done,
     /* 1689359 */   // Label 23164: @1689359
     /* 1689359 */   GIM_Try, /*On fail goto*//*Label 23165*/ GIMT_Encode4(1689445), // Rule ID 6966 //
     /* 1689364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1689367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1689375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1689378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1689381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689410 */     // MIs[0] policy
     /* 1689410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1689441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689444 */     // GIR_Coverage, 6966,
     /* 1689444 */     GIR_EraseRootFromParent_Done,
     /* 1689445 */   // Label 23165: @1689445
     /* 1689445 */   GIM_Try, /*On fail goto*//*Label 23166*/ GIMT_Encode4(1689531), // Rule ID 6967 //
     /* 1689450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1689453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1689461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1689464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1689467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689496 */     // MIs[0] policy
     /* 1689496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689506 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1689527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689530 */     // GIR_Coverage, 6967,
     /* 1689530 */     GIR_EraseRootFromParent_Done,
     /* 1689531 */   // Label 23166: @1689531
     /* 1689531 */   GIM_Try, /*On fail goto*//*Label 23167*/ GIMT_Encode4(1689617), // Rule ID 6970 //
     /* 1689536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1689547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1689550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1689553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689582 */     // MIs[0] policy
     /* 1689582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1689595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689616 */     // GIR_Coverage, 6970,
     /* 1689616 */     GIR_EraseRootFromParent_Done,
     /* 1689617 */   // Label 23167: @1689617
     /* 1689617 */   GIM_Try, /*On fail goto*//*Label 23168*/ GIMT_Encode4(1689703), // Rule ID 6971 //
     /* 1689622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1689633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1689636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1689639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689668 */     // MIs[0] policy
     /* 1689668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689678 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1689681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689702 */     // GIR_Coverage, 6971,
     /* 1689702 */     GIR_EraseRootFromParent_Done,
     /* 1689703 */   // Label 23168: @1689703
     /* 1689703 */   GIM_Try, /*On fail goto*//*Label 23169*/ GIMT_Encode4(1689789), // Rule ID 6974 //
     /* 1689708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1689719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1689722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1689725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689754 */     // MIs[0] policy
     /* 1689754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689764 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1689767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689788 */     // GIR_Coverage, 6974,
     /* 1689788 */     GIR_EraseRootFromParent_Done,
     /* 1689789 */   // Label 23169: @1689789
     /* 1689789 */   GIM_Try, /*On fail goto*//*Label 23170*/ GIMT_Encode4(1689875), // Rule ID 6975 //
     /* 1689794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1689805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1689808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1689811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689840 */     // MIs[0] policy
     /* 1689840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689850 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1689853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689874 */     // GIR_Coverage, 6975,
     /* 1689874 */     GIR_EraseRootFromParent_Done,
     /* 1689875 */   // Label 23170: @1689875
     /* 1689875 */   GIM_Try, /*On fail goto*//*Label 23171*/ GIMT_Encode4(1689961), // Rule ID 6978 //
     /* 1689880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1689891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1689894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1689897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1689903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1689910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689926 */     // MIs[0] policy
     /* 1689926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689936 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1689939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689960 */     // GIR_Coverage, 6978,
     /* 1689960 */     GIR_EraseRootFromParent_Done,
     /* 1689961 */   // Label 23171: @1689961
     /* 1689961 */   GIM_Try, /*On fail goto*//*Label 23172*/ GIMT_Encode4(1690047), // Rule ID 6979 //
     /* 1689966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1689977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1689980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1689983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1689989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1689996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690012 */     // MIs[0] policy
     /* 1690012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690022 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690046 */     // GIR_Coverage, 6979,
     /* 1690046 */     GIR_EraseRootFromParent_Done,
     /* 1690047 */   // Label 23172: @1690047
     /* 1690047 */   GIM_Try, /*On fail goto*//*Label 23173*/ GIMT_Encode4(1690133), // Rule ID 6982 //
     /* 1690052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1690063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1690066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1690069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690098 */     // MIs[0] policy
     /* 1690098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690132 */     // GIR_Coverage, 6982,
     /* 1690132 */     GIR_EraseRootFromParent_Done,
     /* 1690133 */   // Label 23173: @1690133
     /* 1690133 */   GIM_Try, /*On fail goto*//*Label 23174*/ GIMT_Encode4(1690219), // Rule ID 6983 //
     /* 1690138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1690149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1690152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1690155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690184 */     // MIs[0] policy
     /* 1690184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690218 */     // GIR_Coverage, 6983,
     /* 1690218 */     GIR_EraseRootFromParent_Done,
     /* 1690219 */   // Label 23174: @1690219
     /* 1690219 */   GIM_Try, /*On fail goto*//*Label 23175*/ GIMT_Encode4(1690305), // Rule ID 6986 //
     /* 1690224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1690235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1690238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1690241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690270 */     // MIs[0] policy
     /* 1690270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690280 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690304 */     // GIR_Coverage, 6986,
     /* 1690304 */     GIR_EraseRootFromParent_Done,
     /* 1690305 */   // Label 23175: @1690305
     /* 1690305 */   GIM_Try, /*On fail goto*//*Label 23176*/ GIMT_Encode4(1690391), // Rule ID 6987 //
     /* 1690310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1690321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1690324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1690327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690356 */     // MIs[0] policy
     /* 1690356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690366 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690390 */     // GIR_Coverage, 6987,
     /* 1690390 */     GIR_EraseRootFromParent_Done,
     /* 1690391 */   // Label 23176: @1690391
     /* 1690391 */   GIM_Try, /*On fail goto*//*Label 23177*/ GIMT_Encode4(1690477), // Rule ID 6990 //
     /* 1690396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1690407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1690410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1690413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690442 */     // MIs[0] policy
     /* 1690442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690452 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690476 */     // GIR_Coverage, 6990,
     /* 1690476 */     GIR_EraseRootFromParent_Done,
     /* 1690477 */   // Label 23177: @1690477
     /* 1690477 */   GIM_Try, /*On fail goto*//*Label 23178*/ GIMT_Encode4(1690563), // Rule ID 6991 //
     /* 1690482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1690493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1690496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1690499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690528 */     // MIs[0] policy
     /* 1690528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690538 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690562 */     // GIR_Coverage, 6991,
     /* 1690562 */     GIR_EraseRootFromParent_Done,
     /* 1690563 */   // Label 23178: @1690563
     /* 1690563 */   GIM_Try, /*On fail goto*//*Label 23179*/ GIMT_Encode4(1690649), // Rule ID 6994 //
     /* 1690568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1690579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1690582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1690585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690614 */     // MIs[0] policy
     /* 1690614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690648 */     // GIR_Coverage, 6994,
     /* 1690648 */     GIR_EraseRootFromParent_Done,
     /* 1690649 */   // Label 23179: @1690649
     /* 1690649 */   GIM_Try, /*On fail goto*//*Label 23180*/ GIMT_Encode4(1690735), // Rule ID 6995 //
     /* 1690654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1690665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1690668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1690671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690700 */     // MIs[0] policy
     /* 1690700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690734 */     // GIR_Coverage, 6995,
     /* 1690734 */     GIR_EraseRootFromParent_Done,
     /* 1690735 */   // Label 23180: @1690735
     /* 1690735 */   GIM_Try, /*On fail goto*//*Label 23181*/ GIMT_Encode4(1690821), // Rule ID 6998 //
     /* 1690740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1690751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1690754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1690757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690786 */     // MIs[0] policy
     /* 1690786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690796 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690820 */     // GIR_Coverage, 6998,
     /* 1690820 */     GIR_EraseRootFromParent_Done,
     /* 1690821 */   // Label 23181: @1690821
     /* 1690821 */   GIM_Try, /*On fail goto*//*Label 23182*/ GIMT_Encode4(1690907), // Rule ID 6999 //
     /* 1690826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1690837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1690840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1690843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690872 */     // MIs[0] policy
     /* 1690872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690882 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690906 */     // GIR_Coverage, 6999,
     /* 1690906 */     GIR_EraseRootFromParent_Done,
     /* 1690907 */   // Label 23182: @1690907
     /* 1690907 */   GIM_Try, /*On fail goto*//*Label 23183*/ GIMT_Encode4(1690993), // Rule ID 7002 //
     /* 1690912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1690923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1690926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1690929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690958 */     // MIs[0] policy
     /* 1690958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690968 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690992 */     // GIR_Coverage, 7002,
     /* 1690992 */     GIR_EraseRootFromParent_Done,
     /* 1690993 */   // Label 23183: @1690993
     /* 1690993 */   GIM_Try, /*On fail goto*//*Label 23184*/ GIMT_Encode4(1691079), // Rule ID 7003 //
     /* 1690998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1691009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1691012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1691015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1691021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691044 */     // MIs[0] policy
     /* 1691044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1691057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691078 */     // GIR_Coverage, 7003,
     /* 1691078 */     GIR_EraseRootFromParent_Done,
     /* 1691079 */   // Label 23184: @1691079
     /* 1691079 */   GIM_Try, /*On fail goto*//*Label 23185*/ GIMT_Encode4(1691165), // Rule ID 7006 //
     /* 1691084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1691095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1691098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1691101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691130 */     // MIs[0] policy
     /* 1691130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1691143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691164 */     // GIR_Coverage, 7006,
     /* 1691164 */     GIR_EraseRootFromParent_Done,
     /* 1691165 */   // Label 23185: @1691165
     /* 1691165 */   GIM_Try, /*On fail goto*//*Label 23186*/ GIMT_Encode4(1691251), // Rule ID 7007 //
     /* 1691170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1691181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1691184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1691187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691216 */     // MIs[0] policy
     /* 1691216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1691229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691250 */     // GIR_Coverage, 7007,
     /* 1691250 */     GIR_EraseRootFromParent_Done,
     /* 1691251 */   // Label 23186: @1691251
     /* 1691251 */   GIM_Try, /*On fail goto*//*Label 23187*/ GIMT_Encode4(1691337), // Rule ID 7010 //
     /* 1691256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1691267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1691270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1691273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691302 */     // MIs[0] policy
     /* 1691302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691312 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1691315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691336 */     // GIR_Coverage, 7010,
     /* 1691336 */     GIR_EraseRootFromParent_Done,
     /* 1691337 */   // Label 23187: @1691337
     /* 1691337 */   GIM_Try, /*On fail goto*//*Label 23188*/ GIMT_Encode4(1691423), // Rule ID 7011 //
     /* 1691342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1691353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1691356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1691359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691388 */     // MIs[0] policy
     /* 1691388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691398 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1691401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691422 */     // GIR_Coverage, 7011,
     /* 1691422 */     GIR_EraseRootFromParent_Done,
     /* 1691423 */   // Label 23188: @1691423
     /* 1691423 */   GIM_Try, /*On fail goto*//*Label 23189*/ GIMT_Encode4(1691509), // Rule ID 7014 //
     /* 1691428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1691439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1691442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1691445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691474 */     // MIs[0] policy
     /* 1691474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1691487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691508 */     // GIR_Coverage, 7014,
     /* 1691508 */     GIR_EraseRootFromParent_Done,
     /* 1691509 */   // Label 23189: @1691509
     /* 1691509 */   GIM_Try, /*On fail goto*//*Label 23190*/ GIMT_Encode4(1691595), // Rule ID 7015 //
     /* 1691514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1691525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1691528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1691531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691560 */     // MIs[0] policy
     /* 1691560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691570 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1691573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691594 */     // GIR_Coverage, 7015,
     /* 1691594 */     GIR_EraseRootFromParent_Done,
     /* 1691595 */   // Label 23190: @1691595
     /* 1691595 */   GIM_Try, /*On fail goto*//*Label 23191*/ GIMT_Encode4(1691681), // Rule ID 7106 //
     /* 1691600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1691611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1691614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1691617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1691620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691646 */     // MIs[0] policy
     /* 1691646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691656 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1691659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691680 */     // GIR_Coverage, 7106,
     /* 1691680 */     GIR_EraseRootFromParent_Done,
     /* 1691681 */   // Label 23191: @1691681
     /* 1691681 */   GIM_Try, /*On fail goto*//*Label 23192*/ GIMT_Encode4(1691767), // Rule ID 7107 //
     /* 1691686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1691697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1691700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1691703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1691706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691732 */     // MIs[0] policy
     /* 1691732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691742 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1691745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691766 */     // GIR_Coverage, 7107,
     /* 1691766 */     GIR_EraseRootFromParent_Done,
     /* 1691767 */   // Label 23192: @1691767
     /* 1691767 */   GIM_Try, /*On fail goto*//*Label 23193*/ GIMT_Encode4(1691853), // Rule ID 7110 //
     /* 1691772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1691783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1691786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1691789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1691792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691818 */     // MIs[0] policy
     /* 1691818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691828 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1691831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691852 */     // GIR_Coverage, 7110,
     /* 1691852 */     GIR_EraseRootFromParent_Done,
     /* 1691853 */   // Label 23193: @1691853
     /* 1691853 */   GIM_Try, /*On fail goto*//*Label 23194*/ GIMT_Encode4(1691939), // Rule ID 7111 //
     /* 1691858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1691869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1691872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1691875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1691878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691904 */     // MIs[0] policy
     /* 1691904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691914 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1691917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691938 */     // GIR_Coverage, 7111,
     /* 1691938 */     GIR_EraseRootFromParent_Done,
     /* 1691939 */   // Label 23194: @1691939
     /* 1691939 */   GIM_Try, /*On fail goto*//*Label 23195*/ GIMT_Encode4(1692025), // Rule ID 7114 //
     /* 1691944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1691955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1691958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1691961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1691964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691990 */     // MIs[0] policy
     /* 1691990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692000 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692024 */     // GIR_Coverage, 7114,
     /* 1692024 */     GIR_EraseRootFromParent_Done,
     /* 1692025 */   // Label 23195: @1692025
     /* 1692025 */   GIM_Try, /*On fail goto*//*Label 23196*/ GIMT_Encode4(1692111), // Rule ID 7115 //
     /* 1692030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1692041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1692044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1692047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1692050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692076 */     // MIs[0] policy
     /* 1692076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692086 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692110 */     // GIR_Coverage, 7115,
     /* 1692110 */     GIR_EraseRootFromParent_Done,
     /* 1692111 */   // Label 23196: @1692111
     /* 1692111 */   GIM_Try, /*On fail goto*//*Label 23197*/ GIMT_Encode4(1692197), // Rule ID 7118 //
     /* 1692116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1692127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1692130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1692133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1692136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692162 */     // MIs[0] policy
     /* 1692162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692172 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1692175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692196 */     // GIR_Coverage, 7118,
     /* 1692196 */     GIR_EraseRootFromParent_Done,
     /* 1692197 */   // Label 23197: @1692197
     /* 1692197 */   GIM_Try, /*On fail goto*//*Label 23198*/ GIMT_Encode4(1692283), // Rule ID 7119 //
     /* 1692202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1692213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1692216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1692219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1692222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692248 */     // MIs[0] policy
     /* 1692248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692258 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1692261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692282 */     // GIR_Coverage, 7119,
     /* 1692282 */     GIR_EraseRootFromParent_Done,
     /* 1692283 */   // Label 23198: @1692283
     /* 1692283 */   GIM_Try, /*On fail goto*//*Label 23199*/ GIMT_Encode4(1692369), // Rule ID 7122 //
     /* 1692288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1692299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1692302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1692305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1692308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692334 */     // MIs[0] policy
     /* 1692334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692344 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692368 */     // GIR_Coverage, 7122,
     /* 1692368 */     GIR_EraseRootFromParent_Done,
     /* 1692369 */   // Label 23199: @1692369
     /* 1692369 */   GIM_Try, /*On fail goto*//*Label 23200*/ GIMT_Encode4(1692455), // Rule ID 7123 //
     /* 1692374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1692385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1692388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1692391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1692394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692420 */     // MIs[0] policy
     /* 1692420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692430 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692454 */     // GIR_Coverage, 7123,
     /* 1692454 */     GIR_EraseRootFromParent_Done,
     /* 1692455 */   // Label 23200: @1692455
     /* 1692455 */   GIM_Try, /*On fail goto*//*Label 23201*/ GIMT_Encode4(1692541), // Rule ID 7126 //
     /* 1692460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1692471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1692474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1692477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1692480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692506 */     // MIs[0] policy
     /* 1692506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692516 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692540 */     // GIR_Coverage, 7126,
     /* 1692540 */     GIR_EraseRootFromParent_Done,
     /* 1692541 */   // Label 23201: @1692541
     /* 1692541 */   GIM_Try, /*On fail goto*//*Label 23202*/ GIMT_Encode4(1692627), // Rule ID 7127 //
     /* 1692546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1692557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1692560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1692563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1692566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692592 */     // MIs[0] policy
     /* 1692592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692602 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692626 */     // GIR_Coverage, 7127,
     /* 1692626 */     GIR_EraseRootFromParent_Done,
     /* 1692627 */   // Label 23202: @1692627
     /* 1692627 */   GIM_Try, /*On fail goto*//*Label 23203*/ GIMT_Encode4(1692713), // Rule ID 7130 //
     /* 1692632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1692649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1692652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692678 */     // MIs[0] policy
     /* 1692678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692688 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692712 */     // GIR_Coverage, 7130,
     /* 1692712 */     GIR_EraseRootFromParent_Done,
     /* 1692713 */   // Label 23203: @1692713
     /* 1692713 */   GIM_Try, /*On fail goto*//*Label 23204*/ GIMT_Encode4(1692799), // Rule ID 7131 //
     /* 1692718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1692735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1692738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692764 */     // MIs[0] policy
     /* 1692764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692774 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692798 */     // GIR_Coverage, 7131,
     /* 1692798 */     GIR_EraseRootFromParent_Done,
     /* 1692799 */   // Label 23204: @1692799
     /* 1692799 */   GIM_Try, /*On fail goto*//*Label 23205*/ GIMT_Encode4(1692885), // Rule ID 7134 //
     /* 1692804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1692815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1692818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1692821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1692824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692850 */     // MIs[0] policy
     /* 1692850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692884 */     // GIR_Coverage, 7134,
     /* 1692884 */     GIR_EraseRootFromParent_Done,
     /* 1692885 */   // Label 23205: @1692885
     /* 1692885 */   GIM_Try, /*On fail goto*//*Label 23206*/ GIMT_Encode4(1692971), // Rule ID 7135 //
     /* 1692890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1692901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1692904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1692907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1692910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692936 */     // MIs[0] policy
     /* 1692936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692970 */     // GIR_Coverage, 7135,
     /* 1692970 */     GIR_EraseRootFromParent_Done,
     /* 1692971 */   // Label 23206: @1692971
     /* 1692971 */   GIM_Try, /*On fail goto*//*Label 23207*/ GIMT_Encode4(1693057), // Rule ID 7138 //
     /* 1692976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1692987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1692990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1692993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1692996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693022 */     // MIs[0] policy
     /* 1693022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693032 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1693035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1693053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693056 */     // GIR_Coverage, 7138,
     /* 1693056 */     GIR_EraseRootFromParent_Done,
     /* 1693057 */   // Label 23207: @1693057
     /* 1693057 */   GIM_Try, /*On fail goto*//*Label 23208*/ GIMT_Encode4(1693143), // Rule ID 7139 //
     /* 1693062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1693073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1693076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1693079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1693082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1693085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693108 */     // MIs[0] policy
     /* 1693108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1693121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1693139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693142 */     // GIR_Coverage, 7139,
     /* 1693142 */     GIR_EraseRootFromParent_Done,
     /* 1693143 */   // Label 23208: @1693143
     /* 1693143 */   GIM_Try, /*On fail goto*//*Label 23209*/ GIMT_Encode4(1693229), // Rule ID 7142 //
     /* 1693148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1693151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1693159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1693162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1693165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1693168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1693171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693194 */     // MIs[0] policy
     /* 1693194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693204 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1693207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1693225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693228 */     // GIR_Coverage, 7142,
     /* 1693228 */     GIR_EraseRootFromParent_Done,
     /* 1693229 */   // Label 23209: @1693229
     /* 1693229 */   GIM_Try, /*On fail goto*//*Label 23210*/ GIMT_Encode4(1693315), // Rule ID 7143 //
     /* 1693234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1693237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1693245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1693248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1693251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1693254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1693257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693280 */     // MIs[0] policy
     /* 1693280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1693293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1693311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693314 */     // GIR_Coverage, 7143,
     /* 1693314 */     GIR_EraseRootFromParent_Done,
     /* 1693315 */   // Label 23210: @1693315
     /* 1693315 */   GIM_Try, /*On fail goto*//*Label 23211*/ GIMT_Encode4(1693401), // Rule ID 7146 //
     /* 1693320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1693331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1693334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1693337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1693340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693366 */     // MIs[0] policy
     /* 1693366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693376 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693400 */     // GIR_Coverage, 7146,
     /* 1693400 */     GIR_EraseRootFromParent_Done,
     /* 1693401 */   // Label 23211: @1693401
     /* 1693401 */   GIM_Try, /*On fail goto*//*Label 23212*/ GIMT_Encode4(1693487), // Rule ID 7147 //
     /* 1693406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1693417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1693420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1693423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1693426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693452 */     // MIs[0] policy
     /* 1693452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693462 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693486 */     // GIR_Coverage, 7147,
     /* 1693486 */     GIR_EraseRootFromParent_Done,
     /* 1693487 */   // Label 23212: @1693487
     /* 1693487 */   GIM_Try, /*On fail goto*//*Label 23213*/ GIMT_Encode4(1693573), // Rule ID 7150 //
     /* 1693492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1693509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1693512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693538 */     // MIs[0] policy
     /* 1693538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693548 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1693551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693572 */     // GIR_Coverage, 7150,
     /* 1693572 */     GIR_EraseRootFromParent_Done,
     /* 1693573 */   // Label 23213: @1693573
     /* 1693573 */   GIM_Try, /*On fail goto*//*Label 23214*/ GIMT_Encode4(1693659), // Rule ID 7151 //
     /* 1693578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1693595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1693598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693624 */     // MIs[0] policy
     /* 1693624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693634 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1693637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693658 */     // GIR_Coverage, 7151,
     /* 1693658 */     GIR_EraseRootFromParent_Done,
     /* 1693659 */   // Label 23214: @1693659
     /* 1693659 */   GIM_Try, /*On fail goto*//*Label 23215*/ GIMT_Encode4(1693745), // Rule ID 7154 //
     /* 1693664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1693675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1693678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1693681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1693684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1693687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693710 */     // MIs[0] policy
     /* 1693710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693720 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1693723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693744 */     // GIR_Coverage, 7154,
     /* 1693744 */     GIR_EraseRootFromParent_Done,
     /* 1693745 */   // Label 23215: @1693745
     /* 1693745 */   GIM_Try, /*On fail goto*//*Label 23216*/ GIMT_Encode4(1693831), // Rule ID 7155 //
     /* 1693750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1693761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1693764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1693767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1693770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1693773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693796 */     // MIs[0] policy
     /* 1693796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693806 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1693809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693830 */     // GIR_Coverage, 7155,
     /* 1693830 */     GIR_EraseRootFromParent_Done,
     /* 1693831 */   // Label 23216: @1693831
     /* 1693831 */   GIM_Try, /*On fail goto*//*Label 23217*/ GIMT_Encode4(1693917), // Rule ID 7158 //
     /* 1693836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1693847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1693850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1693853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1693856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693882 */     // MIs[0] policy
     /* 1693882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693916 */     // GIR_Coverage, 7158,
     /* 1693916 */     GIR_EraseRootFromParent_Done,
     /* 1693917 */   // Label 23217: @1693917
     /* 1693917 */   GIM_Try, /*On fail goto*//*Label 23218*/ GIMT_Encode4(1694003), // Rule ID 7159 //
     /* 1693922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1693933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1693936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1693939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1693942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693968 */     // MIs[0] policy
     /* 1693968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694002 */     // GIR_Coverage, 7159,
     /* 1694002 */     GIR_EraseRootFromParent_Done,
     /* 1694003 */   // Label 23218: @1694003
     /* 1694003 */   GIM_Try, /*On fail goto*//*Label 23219*/ GIMT_Encode4(1694089), // Rule ID 7162 //
     /* 1694008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1694019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1694022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1694025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1694028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694054 */     // MIs[0] policy
     /* 1694054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694088 */     // GIR_Coverage, 7162,
     /* 1694088 */     GIR_EraseRootFromParent_Done,
     /* 1694089 */   // Label 23219: @1694089
     /* 1694089 */   GIM_Try, /*On fail goto*//*Label 23220*/ GIMT_Encode4(1694175), // Rule ID 7163 //
     /* 1694094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1694105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1694108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1694111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1694114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694140 */     // MIs[0] policy
     /* 1694140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694150 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694174 */     // GIR_Coverage, 7163,
     /* 1694174 */     GIR_EraseRootFromParent_Done,
     /* 1694175 */   // Label 23220: @1694175
     /* 1694175 */   GIM_Try, /*On fail goto*//*Label 23221*/ GIMT_Encode4(1694261), // Rule ID 7166 //
     /* 1694180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1694191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1694194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1694197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1694200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1694203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694226 */     // MIs[0] policy
     /* 1694226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694260 */     // GIR_Coverage, 7166,
     /* 1694260 */     GIR_EraseRootFromParent_Done,
     /* 1694261 */   // Label 23221: @1694261
     /* 1694261 */   GIM_Try, /*On fail goto*//*Label 23222*/ GIMT_Encode4(1694347), // Rule ID 7167 //
     /* 1694266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1694277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1694280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1694283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1694286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1694289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694312 */     // MIs[0] policy
     /* 1694312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694322 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694346 */     // GIR_Coverage, 7167,
     /* 1694346 */     GIR_EraseRootFromParent_Done,
     /* 1694347 */   // Label 23222: @1694347
     /* 1694347 */   GIM_Try, /*On fail goto*//*Label 23223*/ GIMT_Encode4(1694433), // Rule ID 7170 //
     /* 1694352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1694363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1694366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1694369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1694372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694398 */     // MIs[0] policy
     /* 1694398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694408 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1694411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694432 */     // GIR_Coverage, 7170,
     /* 1694432 */     GIR_EraseRootFromParent_Done,
     /* 1694433 */   // Label 23223: @1694433
     /* 1694433 */   GIM_Try, /*On fail goto*//*Label 23224*/ GIMT_Encode4(1694519), // Rule ID 7171 //
     /* 1694438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1694449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1694452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1694455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1694458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694484 */     // MIs[0] policy
     /* 1694484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1694497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694518 */     // GIR_Coverage, 7171,
     /* 1694518 */     GIR_EraseRootFromParent_Done,
     /* 1694519 */   // Label 23224: @1694519
     /* 1694519 */   GIM_Try, /*On fail goto*//*Label 23225*/ GIMT_Encode4(1694605), // Rule ID 7174 //
     /* 1694524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1694541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1694544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694570 */     // MIs[0] policy
     /* 1694570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694580 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694604 */     // GIR_Coverage, 7174,
     /* 1694604 */     GIR_EraseRootFromParent_Done,
     /* 1694605 */   // Label 23225: @1694605
     /* 1694605 */   GIM_Try, /*On fail goto*//*Label 23226*/ GIMT_Encode4(1694691), // Rule ID 7175 //
     /* 1694610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1694627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1694630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694656 */     // MIs[0] policy
     /* 1694656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694666 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694690 */     // GIR_Coverage, 7175,
     /* 1694690 */     GIR_EraseRootFromParent_Done,
     /* 1694691 */   // Label 23226: @1694691
     /* 1694691 */   GIM_Try, /*On fail goto*//*Label 23227*/ GIMT_Encode4(1694777), // Rule ID 7178 //
     /* 1694696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1694707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1694710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1694713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1694716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694742 */     // MIs[0] policy
     /* 1694742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694776 */     // GIR_Coverage, 7178,
     /* 1694776 */     GIR_EraseRootFromParent_Done,
     /* 1694777 */   // Label 23227: @1694777
     /* 1694777 */   GIM_Try, /*On fail goto*//*Label 23228*/ GIMT_Encode4(1694863), // Rule ID 7179 //
     /* 1694782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1694793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1694796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1694799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1694802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694828 */     // MIs[0] policy
     /* 1694828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694838 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694862 */     // GIR_Coverage, 7179,
     /* 1694862 */     GIR_EraseRootFromParent_Done,
     /* 1694863 */   // Label 23228: @1694863
     /* 1694863 */   GIM_Try, /*On fail goto*//*Label 23229*/ GIMT_Encode4(1694949), // Rule ID 7182 //
     /* 1694868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1694871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1694879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1694882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1694885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1694888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694914 */     // MIs[0] policy
     /* 1694914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1694927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694948 */     // GIR_Coverage, 7182,
     /* 1694948 */     GIR_EraseRootFromParent_Done,
     /* 1694949 */   // Label 23229: @1694949
     /* 1694949 */   GIM_Try, /*On fail goto*//*Label 23230*/ GIMT_Encode4(1695035), // Rule ID 7183 //
     /* 1694954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1694957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1694965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1694968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1694971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1694974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695000 */     // MIs[0] policy
     /* 1695000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1695013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695034 */     // GIR_Coverage, 7183,
     /* 1695034 */     GIR_EraseRootFromParent_Done,
     /* 1695035 */   // Label 23230: @1695035
     /* 1695035 */   GIM_Try, /*On fail goto*//*Label 23231*/ GIMT_Encode4(1695121), // Rule ID 7186 //
     /* 1695040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1695043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1695051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1695054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1695057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1695060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1695070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695086 */     // MIs[0] policy
     /* 1695086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1695099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695120 */     // GIR_Coverage, 7186,
     /* 1695120 */     GIR_EraseRootFromParent_Done,
     /* 1695121 */   // Label 23231: @1695121
     /* 1695121 */   GIM_Try, /*On fail goto*//*Label 23232*/ GIMT_Encode4(1695207), // Rule ID 7187 //
     /* 1695126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1695129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1695137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1695140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1695143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1695146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1695156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695172 */     // MIs[0] policy
     /* 1695172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695182 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1695185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695206 */     // GIR_Coverage, 7187,
     /* 1695206 */     GIR_EraseRootFromParent_Done,
     /* 1695207 */   // Label 23232: @1695207
     /* 1695207 */   GIM_Try, /*On fail goto*//*Label 23233*/ GIMT_Encode4(1695293), // Rule ID 7190 //
     /* 1695212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1695215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1695223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1695226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1695229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1695232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1695242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695258 */     // MIs[0] policy
     /* 1695258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695268 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1695271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695292 */     // GIR_Coverage, 7190,
     /* 1695292 */     GIR_EraseRootFromParent_Done,
     /* 1695293 */   // Label 23233: @1695293
     /* 1695293 */   GIM_Try, /*On fail goto*//*Label 23234*/ GIMT_Encode4(1695379), // Rule ID 7191 //
     /* 1695298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1695301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1695309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1695312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1695315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1695318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1695328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695344 */     // MIs[0] policy
     /* 1695344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695354 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1695357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695378 */     // GIR_Coverage, 7191,
     /* 1695378 */     GIR_EraseRootFromParent_Done,
     /* 1695379 */   // Label 23234: @1695379
     /* 1695379 */   GIM_Try, /*On fail goto*//*Label 23235*/ GIMT_Encode4(1695465), // Rule ID 7194 //
     /* 1695384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1695395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1695398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1695401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695430 */     // MIs[0] policy
     /* 1695430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695440 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1695443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695464 */     // GIR_Coverage, 7194,
     /* 1695464 */     GIR_EraseRootFromParent_Done,
     /* 1695465 */   // Label 23235: @1695465
     /* 1695465 */   GIM_Try, /*On fail goto*//*Label 23236*/ GIMT_Encode4(1695551), // Rule ID 7195 //
     /* 1695470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1695481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1695484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1695487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695516 */     // MIs[0] policy
     /* 1695516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695526 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1695529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695550 */     // GIR_Coverage, 7195,
     /* 1695550 */     GIR_EraseRootFromParent_Done,
     /* 1695551 */   // Label 23236: @1695551
     /* 1695551 */   GIM_Try, /*On fail goto*//*Label 23237*/ GIMT_Encode4(1695637), // Rule ID 7198 //
     /* 1695556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1695567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1695570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1695573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695602 */     // MIs[0] policy
     /* 1695602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695612 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695636 */     // GIR_Coverage, 7198,
     /* 1695636 */     GIR_EraseRootFromParent_Done,
     /* 1695637 */   // Label 23237: @1695637
     /* 1695637 */   GIM_Try, /*On fail goto*//*Label 23238*/ GIMT_Encode4(1695723), // Rule ID 7199 //
     /* 1695642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1695653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1695656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1695659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695688 */     // MIs[0] policy
     /* 1695688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695698 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695722 */     // GIR_Coverage, 7199,
     /* 1695722 */     GIR_EraseRootFromParent_Done,
     /* 1695723 */   // Label 23238: @1695723
     /* 1695723 */   GIM_Try, /*On fail goto*//*Label 23239*/ GIMT_Encode4(1695809), // Rule ID 7202 //
     /* 1695728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1695745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695774 */     // MIs[0] policy
     /* 1695774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695784 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695808 */     // GIR_Coverage, 7202,
     /* 1695808 */     GIR_EraseRootFromParent_Done,
     /* 1695809 */   // Label 23239: @1695809
     /* 1695809 */   GIM_Try, /*On fail goto*//*Label 23240*/ GIMT_Encode4(1695895), // Rule ID 7203 //
     /* 1695814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1695831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695860 */     // MIs[0] policy
     /* 1695860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695870 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695894 */     // GIR_Coverage, 7203,
     /* 1695894 */     GIR_EraseRootFromParent_Done,
     /* 1695895 */   // Label 23240: @1695895
     /* 1695895 */   GIM_Try, /*On fail goto*//*Label 23241*/ GIMT_Encode4(1695981), // Rule ID 7206 //
     /* 1695900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1695911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1695914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1695917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695946 */     // MIs[0] policy
     /* 1695946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695956 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695980 */     // GIR_Coverage, 7206,
     /* 1695980 */     GIR_EraseRootFromParent_Done,
     /* 1695981 */   // Label 23241: @1695981
     /* 1695981 */   GIM_Try, /*On fail goto*//*Label 23242*/ GIMT_Encode4(1696067), // Rule ID 7207 //
     /* 1695986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1695997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1696000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1696003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696032 */     // MIs[0] policy
     /* 1696032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696042 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1696045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696066 */     // GIR_Coverage, 7207,
     /* 1696066 */     GIR_EraseRootFromParent_Done,
     /* 1696067 */   // Label 23242: @1696067
     /* 1696067 */   GIM_Try, /*On fail goto*//*Label 23243*/ GIMT_Encode4(1696153), // Rule ID 7210 //
     /* 1696072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1696083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1696086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1696089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696118 */     // MIs[0] policy
     /* 1696118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696128 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1696131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696152 */     // GIR_Coverage, 7210,
     /* 1696152 */     GIR_EraseRootFromParent_Done,
     /* 1696153 */   // Label 23243: @1696153
     /* 1696153 */   GIM_Try, /*On fail goto*//*Label 23244*/ GIMT_Encode4(1696239), // Rule ID 7211 //
     /* 1696158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1696169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1696172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1696175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696204 */     // MIs[0] policy
     /* 1696204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696214 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1696217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696238 */     // GIR_Coverage, 7211,
     /* 1696238 */     GIR_EraseRootFromParent_Done,
     /* 1696239 */   // Label 23244: @1696239
     /* 1696239 */   GIM_Try, /*On fail goto*//*Label 23245*/ GIMT_Encode4(1696325), // Rule ID 7214 //
     /* 1696244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1696255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1696258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1696261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696290 */     // MIs[0] policy
     /* 1696290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1696303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696324 */     // GIR_Coverage, 7214,
     /* 1696324 */     GIR_EraseRootFromParent_Done,
     /* 1696325 */   // Label 23245: @1696325
     /* 1696325 */   GIM_Try, /*On fail goto*//*Label 23246*/ GIMT_Encode4(1696411), // Rule ID 7215 //
     /* 1696330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1696341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1696344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1696347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696376 */     // MIs[0] policy
     /* 1696376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1696389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696410 */     // GIR_Coverage, 7215,
     /* 1696410 */     GIR_EraseRootFromParent_Done,
     /* 1696411 */   // Label 23246: @1696411
     /* 1696411 */   GIM_Try, /*On fail goto*//*Label 23247*/ GIMT_Encode4(1696497), // Rule ID 7218 //
     /* 1696416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1696427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1696430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1696433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696462 */     // MIs[0] policy
     /* 1696462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696472 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696496 */     // GIR_Coverage, 7218,
     /* 1696496 */     GIR_EraseRootFromParent_Done,
     /* 1696497 */   // Label 23247: @1696497
     /* 1696497 */   GIM_Try, /*On fail goto*//*Label 23248*/ GIMT_Encode4(1696583), // Rule ID 7219 //
     /* 1696502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1696513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1696516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1696519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696548 */     // MIs[0] policy
     /* 1696548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696558 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696582 */     // GIR_Coverage, 7219,
     /* 1696582 */     GIR_EraseRootFromParent_Done,
     /* 1696583 */   // Label 23248: @1696583
     /* 1696583 */   GIM_Try, /*On fail goto*//*Label 23249*/ GIMT_Encode4(1696669), // Rule ID 7222 //
     /* 1696588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696634 */     // MIs[0] policy
     /* 1696634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696644 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696668 */     // GIR_Coverage, 7222,
     /* 1696668 */     GIR_EraseRootFromParent_Done,
     /* 1696669 */   // Label 23249: @1696669
     /* 1696669 */   GIM_Try, /*On fail goto*//*Label 23250*/ GIMT_Encode4(1696755), // Rule ID 7223 //
     /* 1696674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696720 */     // MIs[0] policy
     /* 1696720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696730 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696754 */     // GIR_Coverage, 7223,
     /* 1696754 */     GIR_EraseRootFromParent_Done,
     /* 1696755 */   // Label 23250: @1696755
     /* 1696755 */   GIM_Try, /*On fail goto*//*Label 23251*/ GIMT_Encode4(1696841), // Rule ID 7226 //
     /* 1696760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1696777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696806 */     // MIs[0] policy
     /* 1696806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696816 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696840 */     // GIR_Coverage, 7226,
     /* 1696840 */     GIR_EraseRootFromParent_Done,
     /* 1696841 */   // Label 23251: @1696841
     /* 1696841 */   GIM_Try, /*On fail goto*//*Label 23252*/ GIMT_Encode4(1696927), // Rule ID 7227 //
     /* 1696846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1696863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696892 */     // MIs[0] policy
     /* 1696892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696926 */     // GIR_Coverage, 7227,
     /* 1696926 */     GIR_EraseRootFromParent_Done,
     /* 1696927 */   // Label 23252: @1696927
     /* 1696927 */   GIM_Try, /*On fail goto*//*Label 23253*/ GIMT_Encode4(1697013), // Rule ID 7230 //
     /* 1696932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1696935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1696943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1696946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1696949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696978 */     // MIs[0] policy
     /* 1696978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696988 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1697009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697012 */     // GIR_Coverage, 7230,
     /* 1697012 */     GIR_EraseRootFromParent_Done,
     /* 1697013 */   // Label 23253: @1697013
     /* 1697013 */   GIM_Try, /*On fail goto*//*Label 23254*/ GIMT_Encode4(1697099), // Rule ID 7231 //
     /* 1697018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1697021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1697029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1697032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1697035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1697041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697064 */     // MIs[0] policy
     /* 1697064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1697077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1697095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697098 */     // GIR_Coverage, 7231,
     /* 1697098 */     GIR_EraseRootFromParent_Done,
     /* 1697099 */   // Label 23254: @1697099
     /* 1697099 */   GIM_Try, /*On fail goto*//*Label 23255*/ GIMT_Encode4(1697185), // Rule ID 7234 //
     /* 1697104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1697115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1697118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1697121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697150 */     // MIs[0] policy
     /* 1697150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697160 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697184 */     // GIR_Coverage, 7234,
     /* 1697184 */     GIR_EraseRootFromParent_Done,
     /* 1697185 */   // Label 23255: @1697185
     /* 1697185 */   GIM_Try, /*On fail goto*//*Label 23256*/ GIMT_Encode4(1697271), // Rule ID 7235 //
     /* 1697190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1697201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1697204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1697207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697236 */     // MIs[0] policy
     /* 1697236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697246 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697270 */     // GIR_Coverage, 7235,
     /* 1697270 */     GIR_EraseRootFromParent_Done,
     /* 1697271 */   // Label 23256: @1697271
     /* 1697271 */   GIM_Try, /*On fail goto*//*Label 23257*/ GIMT_Encode4(1697357), // Rule ID 7238 //
     /* 1697276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1697287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1697290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1697293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697322 */     // MIs[0] policy
     /* 1697322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697332 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697356 */     // GIR_Coverage, 7238,
     /* 1697356 */     GIR_EraseRootFromParent_Done,
     /* 1697357 */   // Label 23257: @1697357
     /* 1697357 */   GIM_Try, /*On fail goto*//*Label 23258*/ GIMT_Encode4(1697443), // Rule ID 7239 //
     /* 1697362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1697373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1697376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1697379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697408 */     // MIs[0] policy
     /* 1697408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697418 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697442 */     // GIR_Coverage, 7239,
     /* 1697442 */     GIR_EraseRootFromParent_Done,
     /* 1697443 */   // Label 23258: @1697443
     /* 1697443 */   GIM_Try, /*On fail goto*//*Label 23259*/ GIMT_Encode4(1697529), // Rule ID 7242 //
     /* 1697448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1697459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1697462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1697465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1697471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697494 */     // MIs[0] policy
     /* 1697494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697504 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1697507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697528 */     // GIR_Coverage, 7242,
     /* 1697528 */     GIR_EraseRootFromParent_Done,
     /* 1697529 */   // Label 23259: @1697529
     /* 1697529 */   GIM_Try, /*On fail goto*//*Label 23260*/ GIMT_Encode4(1697615), // Rule ID 7243 //
     /* 1697534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1697545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1697548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1697551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1697557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697580 */     // MIs[0] policy
     /* 1697580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697590 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1697593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697614 */     // GIR_Coverage, 7243,
     /* 1697614 */     GIR_EraseRootFromParent_Done,
     /* 1697615 */   // Label 23260: @1697615
     /* 1697615 */   GIM_Try, /*On fail goto*//*Label 23261*/ GIMT_Encode4(1697701), // Rule ID 7246 //
     /* 1697620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1697631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1697634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697666 */     // MIs[0] policy
     /* 1697666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697700 */     // GIR_Coverage, 7246,
     /* 1697700 */     GIR_EraseRootFromParent_Done,
     /* 1697701 */   // Label 23261: @1697701
     /* 1697701 */   GIM_Try, /*On fail goto*//*Label 23262*/ GIMT_Encode4(1697787), // Rule ID 7247 //
     /* 1697706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1697717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1697720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697752 */     // MIs[0] policy
     /* 1697752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697786 */     // GIR_Coverage, 7247,
     /* 1697786 */     GIR_EraseRootFromParent_Done,
     /* 1697787 */   // Label 23262: @1697787
     /* 1697787 */   GIM_Try, /*On fail goto*//*Label 23263*/ GIMT_Encode4(1697873), // Rule ID 7250 //
     /* 1697792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1697803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1697806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697838 */     // MIs[0] policy
     /* 1697838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697872 */     // GIR_Coverage, 7250,
     /* 1697872 */     GIR_EraseRootFromParent_Done,
     /* 1697873 */   // Label 23263: @1697873
     /* 1697873 */   GIM_Try, /*On fail goto*//*Label 23264*/ GIMT_Encode4(1697959), // Rule ID 7251 //
     /* 1697878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1697889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1697892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697924 */     // MIs[0] policy
     /* 1697924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697958 */     // GIR_Coverage, 7251,
     /* 1697958 */     GIR_EraseRootFromParent_Done,
     /* 1697959 */   // Label 23264: @1697959
     /* 1697959 */   GIM_Try, /*On fail goto*//*Label 23265*/ GIMT_Encode4(1698045), // Rule ID 7254 //
     /* 1697964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1697975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1697978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1697981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698010 */     // MIs[0] policy
     /* 1698010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698020 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698044 */     // GIR_Coverage, 7254,
     /* 1698044 */     GIR_EraseRootFromParent_Done,
     /* 1698045 */   // Label 23265: @1698045
     /* 1698045 */   GIM_Try, /*On fail goto*//*Label 23266*/ GIMT_Encode4(1698131), // Rule ID 7255 //
     /* 1698050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1698061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1698064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1698067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1698073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698096 */     // MIs[0] policy
     /* 1698096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698106 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698130 */     // GIR_Coverage, 7255,
     /* 1698130 */     GIR_EraseRootFromParent_Done,
     /* 1698131 */   // Label 23266: @1698131
     /* 1698131 */   GIM_Try, /*On fail goto*//*Label 23267*/ GIMT_Encode4(1698217), // Rule ID 7258 //
     /* 1698136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1698147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1698150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1698153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698182 */     // MIs[0] policy
     /* 1698182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1698195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698216 */     // GIR_Coverage, 7258,
     /* 1698216 */     GIR_EraseRootFromParent_Done,
     /* 1698217 */   // Label 23267: @1698217
     /* 1698217 */   GIM_Try, /*On fail goto*//*Label 23268*/ GIMT_Encode4(1698303), // Rule ID 7259 //
     /* 1698222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1698233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1698236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1698239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698268 */     // MIs[0] policy
     /* 1698268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1698281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698302 */     // GIR_Coverage, 7259,
     /* 1698302 */     GIR_EraseRootFromParent_Done,
     /* 1698303 */   // Label 23268: @1698303
     /* 1698303 */   GIM_Try, /*On fail goto*//*Label 23269*/ GIMT_Encode4(1698389), // Rule ID 7262 //
     /* 1698308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1698319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1698322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1698325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698354 */     // MIs[0] policy
     /* 1698354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1698367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698388 */     // GIR_Coverage, 7262,
     /* 1698388 */     GIR_EraseRootFromParent_Done,
     /* 1698389 */   // Label 23269: @1698389
     /* 1698389 */   GIM_Try, /*On fail goto*//*Label 23270*/ GIMT_Encode4(1698475), // Rule ID 7263 //
     /* 1698394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1698405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1698408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1698411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698440 */     // MIs[0] policy
     /* 1698440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698450 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1698453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698474 */     // GIR_Coverage, 7263,
     /* 1698474 */     GIR_EraseRootFromParent_Done,
     /* 1698475 */   // Label 23270: @1698475
     /* 1698475 */   GIM_Try, /*On fail goto*//*Label 23271*/ GIMT_Encode4(1698561), // Rule ID 7266 //
     /* 1698480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1698491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1698494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698526 */     // MIs[0] policy
     /* 1698526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698560 */     // GIR_Coverage, 7266,
     /* 1698560 */     GIR_EraseRootFromParent_Done,
     /* 1698561 */   // Label 23271: @1698561
     /* 1698561 */   GIM_Try, /*On fail goto*//*Label 23272*/ GIMT_Encode4(1698647), // Rule ID 7267 //
     /* 1698566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1698577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1698580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698612 */     // MIs[0] policy
     /* 1698612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698622 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698646 */     // GIR_Coverage, 7267,
     /* 1698646 */     GIR_EraseRootFromParent_Done,
     /* 1698647 */   // Label 23272: @1698647
     /* 1698647 */   GIM_Try, /*On fail goto*//*Label 23273*/ GIMT_Encode4(1698733), // Rule ID 7270 //
     /* 1698652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1698663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1698666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698698 */     // MIs[0] policy
     /* 1698698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698708 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1698711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698732 */     // GIR_Coverage, 7270,
     /* 1698732 */     GIR_EraseRootFromParent_Done,
     /* 1698733 */   // Label 23273: @1698733
     /* 1698733 */   GIM_Try, /*On fail goto*//*Label 23274*/ GIMT_Encode4(1698819), // Rule ID 7271 //
     /* 1698738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1698749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1698752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698784 */     // MIs[0] policy
     /* 1698784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698794 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1698797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698818 */     // GIR_Coverage, 7271,
     /* 1698818 */     GIR_EraseRootFromParent_Done,
     /* 1698819 */   // Label 23274: @1698819
     /* 1698819 */   GIM_Try, /*On fail goto*//*Label 23275*/ GIMT_Encode4(1698905), // Rule ID 7274 //
     /* 1698824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1698835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1698838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1698841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698870 */     // MIs[0] policy
     /* 1698870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698880 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1698883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698904 */     // GIR_Coverage, 7274,
     /* 1698904 */     GIR_EraseRootFromParent_Done,
     /* 1698905 */   // Label 23275: @1698905
     /* 1698905 */   GIM_Try, /*On fail goto*//*Label 23276*/ GIMT_Encode4(1698991), // Rule ID 7275 //
     /* 1698910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1698921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1698924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1698927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698956 */     // MIs[0] policy
     /* 1698956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1698969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698990 */     // GIR_Coverage, 7275,
     /* 1698990 */     GIR_EraseRootFromParent_Done,
     /* 1698991 */   // Label 23276: @1698991
     /* 1698991 */   GIM_Try, /*On fail goto*//*Label 23277*/ GIMT_Encode4(1699077), // Rule ID 7278 //
     /* 1698996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1699007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1699010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1699013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1699026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699042 */     // MIs[0] policy
     /* 1699042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1699055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1699073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699076 */     // GIR_Coverage, 7278,
     /* 1699076 */     GIR_EraseRootFromParent_Done,
     /* 1699077 */   // Label 23277: @1699077
     /* 1699077 */   GIM_Try, /*On fail goto*//*Label 23278*/ GIMT_Encode4(1699163), // Rule ID 7279 //
     /* 1699082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1699085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1699093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1699096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1699099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1699112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699128 */     // MIs[0] policy
     /* 1699128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699138 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1699141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1699159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699162 */     // GIR_Coverage, 7279,
     /* 1699162 */     GIR_EraseRootFromParent_Done,
     /* 1699163 */   // Label 23278: @1699163
     /* 1699163 */   GIM_Try, /*On fail goto*//*Label 23279*/ GIMT_Encode4(1699249), // Rule ID 7458 //
     /* 1699168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1699179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1699182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1699185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1699188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699214 */     // MIs[0] policy
     /* 1699214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699224 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1699227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699248 */     // GIR_Coverage, 7458,
     /* 1699248 */     GIR_EraseRootFromParent_Done,
     /* 1699249 */   // Label 23279: @1699249
     /* 1699249 */   GIM_Try, /*On fail goto*//*Label 23280*/ GIMT_Encode4(1699335), // Rule ID 7459 //
     /* 1699254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1699265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1699268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1699271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1699274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699300 */     // MIs[0] policy
     /* 1699300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699310 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1699313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699334 */     // GIR_Coverage, 7459,
     /* 1699334 */     GIR_EraseRootFromParent_Done,
     /* 1699335 */   // Label 23280: @1699335
     /* 1699335 */   GIM_Try, /*On fail goto*//*Label 23281*/ GIMT_Encode4(1699421), // Rule ID 7462 //
     /* 1699340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1699351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1699354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1699357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1699360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699386 */     // MIs[0] policy
     /* 1699386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1699399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699420 */     // GIR_Coverage, 7462,
     /* 1699420 */     GIR_EraseRootFromParent_Done,
     /* 1699421 */   // Label 23281: @1699421
     /* 1699421 */   GIM_Try, /*On fail goto*//*Label 23282*/ GIMT_Encode4(1699507), // Rule ID 7463 //
     /* 1699426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1699437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1699440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1699443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1699446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699472 */     // MIs[0] policy
     /* 1699472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699482 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1699485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699506 */     // GIR_Coverage, 7463,
     /* 1699506 */     GIR_EraseRootFromParent_Done,
     /* 1699507 */   // Label 23282: @1699507
     /* 1699507 */   GIM_Try, /*On fail goto*//*Label 23283*/ GIMT_Encode4(1699593), // Rule ID 7466 //
     /* 1699512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1699523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1699526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1699529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1699532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699558 */     // MIs[0] policy
     /* 1699558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699568 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1699571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699592 */     // GIR_Coverage, 7466,
     /* 1699592 */     GIR_EraseRootFromParent_Done,
     /* 1699593 */   // Label 23283: @1699593
     /* 1699593 */   GIM_Try, /*On fail goto*//*Label 23284*/ GIMT_Encode4(1699679), // Rule ID 7467 //
     /* 1699598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1699609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1699612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1699615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1699618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699644 */     // MIs[0] policy
     /* 1699644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699654 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1699657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699678 */     // GIR_Coverage, 7467,
     /* 1699678 */     GIR_EraseRootFromParent_Done,
     /* 1699679 */   // Label 23284: @1699679
     /* 1699679 */   GIM_Try, /*On fail goto*//*Label 23285*/ GIMT_Encode4(1699765), // Rule ID 7470 //
     /* 1699684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1699695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1699698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1699701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1699704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699730 */     // MIs[0] policy
     /* 1699730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1699743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699764 */     // GIR_Coverage, 7470,
     /* 1699764 */     GIR_EraseRootFromParent_Done,
     /* 1699765 */   // Label 23285: @1699765
     /* 1699765 */   GIM_Try, /*On fail goto*//*Label 23286*/ GIMT_Encode4(1699851), // Rule ID 7471 //
     /* 1699770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1699781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1699784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1699787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1699790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699816 */     // MIs[0] policy
     /* 1699816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1699829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699850 */     // GIR_Coverage, 7471,
     /* 1699850 */     GIR_EraseRootFromParent_Done,
     /* 1699851 */   // Label 23286: @1699851
     /* 1699851 */   GIM_Try, /*On fail goto*//*Label 23287*/ GIMT_Encode4(1699937), // Rule ID 7474 //
     /* 1699856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1699867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1699870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1699873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1699876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1699879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699902 */     // MIs[0] policy
     /* 1699902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699912 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1699915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699936 */     // GIR_Coverage, 7474,
     /* 1699936 */     GIR_EraseRootFromParent_Done,
     /* 1699937 */   // Label 23287: @1699937
     /* 1699937 */   GIM_Try, /*On fail goto*//*Label 23288*/ GIMT_Encode4(1700023), // Rule ID 7475 //
     /* 1699942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1699953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1699956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1699959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1699962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1699965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699988 */     // MIs[0] policy
     /* 1699988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699998 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1700001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700022 */     // GIR_Coverage, 7475,
     /* 1700022 */     GIR_EraseRootFromParent_Done,
     /* 1700023 */   // Label 23288: @1700023
     /* 1700023 */   GIM_Try, /*On fail goto*//*Label 23289*/ GIMT_Encode4(1700109), // Rule ID 7478 //
     /* 1700028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1700039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1700042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1700045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1700048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1700051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700074 */     // MIs[0] policy
     /* 1700074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700084 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1700087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700108 */     // GIR_Coverage, 7478,
     /* 1700108 */     GIR_EraseRootFromParent_Done,
     /* 1700109 */   // Label 23289: @1700109
     /* 1700109 */   GIM_Try, /*On fail goto*//*Label 23290*/ GIMT_Encode4(1700195), // Rule ID 7479 //
     /* 1700114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1700125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1700128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1700131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1700134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1700137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700160 */     // MIs[0] policy
     /* 1700160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700170 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1700173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700194 */     // GIR_Coverage, 7479,
     /* 1700194 */     GIR_EraseRootFromParent_Done,
     /* 1700195 */   // Label 23290: @1700195
     /* 1700195 */   GIM_Try, /*On fail goto*//*Label 23291*/ GIMT_Encode4(1700281), // Rule ID 7482 //
     /* 1700200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1700211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1700214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1700217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1700220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700246 */     // MIs[0] policy
     /* 1700246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700256 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1700259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700280 */     // GIR_Coverage, 7482,
     /* 1700280 */     GIR_EraseRootFromParent_Done,
     /* 1700281 */   // Label 23291: @1700281
     /* 1700281 */   GIM_Try, /*On fail goto*//*Label 23292*/ GIMT_Encode4(1700367), // Rule ID 7483 //
     /* 1700286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1700297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1700300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1700303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1700306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700332 */     // MIs[0] policy
     /* 1700332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700342 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1700345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700366 */     // GIR_Coverage, 7483,
     /* 1700366 */     GIR_EraseRootFromParent_Done,
     /* 1700367 */   // Label 23292: @1700367
     /* 1700367 */   GIM_Try, /*On fail goto*//*Label 23293*/ GIMT_Encode4(1700453), // Rule ID 7486 //
     /* 1700372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1700383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1700386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1700389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1700392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700418 */     // MIs[0] policy
     /* 1700418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700428 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1700431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700452 */     // GIR_Coverage, 7486,
     /* 1700452 */     GIR_EraseRootFromParent_Done,
     /* 1700453 */   // Label 23293: @1700453
     /* 1700453 */   GIM_Try, /*On fail goto*//*Label 23294*/ GIMT_Encode4(1700539), // Rule ID 7487 //
     /* 1700458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1700469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1700472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1700475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1700478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700504 */     // MIs[0] policy
     /* 1700504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700514 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1700517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700538 */     // GIR_Coverage, 7487,
     /* 1700538 */     GIR_EraseRootFromParent_Done,
     /* 1700539 */   // Label 23294: @1700539
     /* 1700539 */   GIM_Try, /*On fail goto*//*Label 23295*/ GIMT_Encode4(1700625), // Rule ID 7490 //
     /* 1700544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1700555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1700558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1700561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1700564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700590 */     // MIs[0] policy
     /* 1700590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700600 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1700603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700624 */     // GIR_Coverage, 7490,
     /* 1700624 */     GIR_EraseRootFromParent_Done,
     /* 1700625 */   // Label 23295: @1700625
     /* 1700625 */   GIM_Try, /*On fail goto*//*Label 23296*/ GIMT_Encode4(1700711), // Rule ID 7491 //
     /* 1700630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1700641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1700644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1700647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1700650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700676 */     // MIs[0] policy
     /* 1700676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700686 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1700689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700710 */     // GIR_Coverage, 7491,
     /* 1700710 */     GIR_EraseRootFromParent_Done,
     /* 1700711 */   // Label 23296: @1700711
     /* 1700711 */   GIM_Try, /*On fail goto*//*Label 23297*/ GIMT_Encode4(1700797), // Rule ID 7494 //
     /* 1700716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1700727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1700730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1700733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1700736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700762 */     // MIs[0] policy
     /* 1700762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700772 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1700775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700796 */     // GIR_Coverage, 7494,
     /* 1700796 */     GIR_EraseRootFromParent_Done,
     /* 1700797 */   // Label 23297: @1700797
     /* 1700797 */   GIM_Try, /*On fail goto*//*Label 23298*/ GIMT_Encode4(1700883), // Rule ID 7495 //
     /* 1700802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1700813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1700816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1700819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1700822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700848 */     // MIs[0] policy
     /* 1700848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1700861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700882 */     // GIR_Coverage, 7495,
     /* 1700882 */     GIR_EraseRootFromParent_Done,
     /* 1700883 */   // Label 23298: @1700883
     /* 1700883 */   GIM_Try, /*On fail goto*//*Label 23299*/ GIMT_Encode4(1700969), // Rule ID 7498 //
     /* 1700888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1700899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1700902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1700905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1700908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700934 */     // MIs[0] policy
     /* 1700934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1700947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700968 */     // GIR_Coverage, 7498,
     /* 1700968 */     GIR_EraseRootFromParent_Done,
     /* 1700969 */   // Label 23299: @1700969
     /* 1700969 */   GIM_Try, /*On fail goto*//*Label 23300*/ GIMT_Encode4(1701055), // Rule ID 7499 //
     /* 1700974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1700985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1700988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1700991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1700994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701020 */     // MIs[0] policy
     /* 1701020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701030 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1701033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701054 */     // GIR_Coverage, 7499,
     /* 1701054 */     GIR_EraseRootFromParent_Done,
     /* 1701055 */   // Label 23300: @1701055
     /* 1701055 */   GIM_Try, /*On fail goto*//*Label 23301*/ GIMT_Encode4(1701141), // Rule ID 7502 //
     /* 1701060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1701071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1701074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1701077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1701080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701106 */     // MIs[0] policy
     /* 1701106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701116 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1701119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701140 */     // GIR_Coverage, 7502,
     /* 1701140 */     GIR_EraseRootFromParent_Done,
     /* 1701141 */   // Label 23301: @1701141
     /* 1701141 */   GIM_Try, /*On fail goto*//*Label 23302*/ GIMT_Encode4(1701227), // Rule ID 7503 //
     /* 1701146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1701157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1701160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1701163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1701166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701192 */     // MIs[0] policy
     /* 1701192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701202 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1701205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701226 */     // GIR_Coverage, 7503,
     /* 1701226 */     GIR_EraseRootFromParent_Done,
     /* 1701227 */   // Label 23302: @1701227
     /* 1701227 */   GIM_Try, /*On fail goto*//*Label 23303*/ GIMT_Encode4(1701313), // Rule ID 7506 //
     /* 1701232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1701243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1701246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1701249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1701252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701278 */     // MIs[0] policy
     /* 1701278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1701291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701312 */     // GIR_Coverage, 7506,
     /* 1701312 */     GIR_EraseRootFromParent_Done,
     /* 1701313 */   // Label 23303: @1701313
     /* 1701313 */   GIM_Try, /*On fail goto*//*Label 23304*/ GIMT_Encode4(1701399), // Rule ID 7507 //
     /* 1701318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1701329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1701332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1701335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1701338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701364 */     // MIs[0] policy
     /* 1701364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701374 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1701377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701398 */     // GIR_Coverage, 7507,
     /* 1701398 */     GIR_EraseRootFromParent_Done,
     /* 1701399 */   // Label 23304: @1701399
     /* 1701399 */   GIM_Try, /*On fail goto*//*Label 23305*/ GIMT_Encode4(1701485), // Rule ID 7510 //
     /* 1701404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1701415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1701418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1701421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1701424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701450 */     // MIs[0] policy
     /* 1701450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1701463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701484 */     // GIR_Coverage, 7510,
     /* 1701484 */     GIR_EraseRootFromParent_Done,
     /* 1701485 */   // Label 23305: @1701485
     /* 1701485 */   GIM_Try, /*On fail goto*//*Label 23306*/ GIMT_Encode4(1701571), // Rule ID 7511 //
     /* 1701490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1701501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1701504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1701507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1701510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701536 */     // MIs[0] policy
     /* 1701536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1701549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701570 */     // GIR_Coverage, 7511,
     /* 1701570 */     GIR_EraseRootFromParent_Done,
     /* 1701571 */   // Label 23306: @1701571
     /* 1701571 */   GIM_Try, /*On fail goto*//*Label 23307*/ GIMT_Encode4(1701657), // Rule ID 7514 //
     /* 1701576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1701593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1701596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701622 */     // MIs[0] policy
     /* 1701622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701632 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1701635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701656 */     // GIR_Coverage, 7514,
     /* 1701656 */     GIR_EraseRootFromParent_Done,
     /* 1701657 */   // Label 23307: @1701657
     /* 1701657 */   GIM_Try, /*On fail goto*//*Label 23308*/ GIMT_Encode4(1701743), // Rule ID 7515 //
     /* 1701662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1701679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1701682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701708 */     // MIs[0] policy
     /* 1701708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701718 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1701721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701742 */     // GIR_Coverage, 7515,
     /* 1701742 */     GIR_EraseRootFromParent_Done,
     /* 1701743 */   // Label 23308: @1701743
     /* 1701743 */   GIM_Try, /*On fail goto*//*Label 23309*/ GIMT_Encode4(1701829), // Rule ID 7518 //
     /* 1701748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1701759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1701762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1701765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701794 */     // MIs[0] policy
     /* 1701794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701804 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1701807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701828 */     // GIR_Coverage, 7518,
     /* 1701828 */     GIR_EraseRootFromParent_Done,
     /* 1701829 */   // Label 23309: @1701829
     /* 1701829 */   GIM_Try, /*On fail goto*//*Label 23310*/ GIMT_Encode4(1701915), // Rule ID 7519 //
     /* 1701834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1701845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1701848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1701851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701880 */     // MIs[0] policy
     /* 1701880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701890 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1701893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701914 */     // GIR_Coverage, 7519,
     /* 1701914 */     GIR_EraseRootFromParent_Done,
     /* 1701915 */   // Label 23310: @1701915
     /* 1701915 */   GIM_Try, /*On fail goto*//*Label 23311*/ GIMT_Encode4(1702001), // Rule ID 7522 //
     /* 1701920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1701931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1701934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1701937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701966 */     // MIs[0] policy
     /* 1701966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1701979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702000 */     // GIR_Coverage, 7522,
     /* 1702000 */     GIR_EraseRootFromParent_Done,
     /* 1702001 */   // Label 23311: @1702001
     /* 1702001 */   GIM_Try, /*On fail goto*//*Label 23312*/ GIMT_Encode4(1702087), // Rule ID 7523 //
     /* 1702006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1702017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1702020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1702023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702052 */     // MIs[0] policy
     /* 1702052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702062 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1702065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702086 */     // GIR_Coverage, 7523,
     /* 1702086 */     GIR_EraseRootFromParent_Done,
     /* 1702087 */   // Label 23312: @1702087
     /* 1702087 */   GIM_Try, /*On fail goto*//*Label 23313*/ GIMT_Encode4(1702173), // Rule ID 7526 //
     /* 1702092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1702103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1702106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1702109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702138 */     // MIs[0] policy
     /* 1702138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702148 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1702151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702172 */     // GIR_Coverage, 7526,
     /* 1702172 */     GIR_EraseRootFromParent_Done,
     /* 1702173 */   // Label 23313: @1702173
     /* 1702173 */   GIM_Try, /*On fail goto*//*Label 23314*/ GIMT_Encode4(1702259), // Rule ID 7527 //
     /* 1702178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1702189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1702192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1702195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702224 */     // MIs[0] policy
     /* 1702224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702234 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1702237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702258 */     // GIR_Coverage, 7527,
     /* 1702258 */     GIR_EraseRootFromParent_Done,
     /* 1702259 */   // Label 23314: @1702259
     /* 1702259 */   GIM_Try, /*On fail goto*//*Label 23315*/ GIMT_Encode4(1702345), // Rule ID 7530 //
     /* 1702264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1702275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1702278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1702281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702310 */     // MIs[0] policy
     /* 1702310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702320 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1702323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702344 */     // GIR_Coverage, 7530,
     /* 1702344 */     GIR_EraseRootFromParent_Done,
     /* 1702345 */   // Label 23315: @1702345
     /* 1702345 */   GIM_Try, /*On fail goto*//*Label 23316*/ GIMT_Encode4(1702431), // Rule ID 7531 //
     /* 1702350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1702361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1702364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1702367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702396 */     // MIs[0] policy
     /* 1702396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702406 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1702409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702430 */     // GIR_Coverage, 7531,
     /* 1702430 */     GIR_EraseRootFromParent_Done,
     /* 1702431 */   // Label 23316: @1702431
     /* 1702431 */   GIM_Try, /*On fail goto*//*Label 23317*/ GIMT_Encode4(1702517), // Rule ID 7534 //
     /* 1702436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1702447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1702450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1702453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1702459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702482 */     // MIs[0] policy
     /* 1702482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702492 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1702495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702516 */     // GIR_Coverage, 7534,
     /* 1702516 */     GIR_EraseRootFromParent_Done,
     /* 1702517 */   // Label 23317: @1702517
     /* 1702517 */   GIM_Try, /*On fail goto*//*Label 23318*/ GIMT_Encode4(1702603), // Rule ID 7535 //
     /* 1702522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1702533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1702536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1702539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1702545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702568 */     // MIs[0] policy
     /* 1702568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702578 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1702581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702602 */     // GIR_Coverage, 7535,
     /* 1702602 */     GIR_EraseRootFromParent_Done,
     /* 1702603 */   // Label 23318: @1702603
     /* 1702603 */   GIM_Try, /*On fail goto*//*Label 23319*/ GIMT_Encode4(1702689), // Rule ID 7538 //
     /* 1702608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1702619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1702622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1702625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1702631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702654 */     // MIs[0] policy
     /* 1702654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702664 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1702667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702688 */     // GIR_Coverage, 7538,
     /* 1702688 */     GIR_EraseRootFromParent_Done,
     /* 1702689 */   // Label 23319: @1702689
     /* 1702689 */   GIM_Try, /*On fail goto*//*Label 23320*/ GIMT_Encode4(1702775), // Rule ID 7539 //
     /* 1702694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1702705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1702708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1702711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1702717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702740 */     // MIs[0] policy
     /* 1702740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702750 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1702753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702774 */     // GIR_Coverage, 7539,
     /* 1702774 */     GIR_EraseRootFromParent_Done,
     /* 1702775 */   // Label 23320: @1702775
     /* 1702775 */   GIM_Try, /*On fail goto*//*Label 23321*/ GIMT_Encode4(1702861), // Rule ID 7542 //
     /* 1702780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1702791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1702794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1702797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702826 */     // MIs[0] policy
     /* 1702826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702836 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1702839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702860 */     // GIR_Coverage, 7542,
     /* 1702860 */     GIR_EraseRootFromParent_Done,
     /* 1702861 */   // Label 23321: @1702861
     /* 1702861 */   GIM_Try, /*On fail goto*//*Label 23322*/ GIMT_Encode4(1702947), // Rule ID 7543 //
     /* 1702866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1702877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1702880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1702883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702912 */     // MIs[0] policy
     /* 1702912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702922 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1702925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702946 */     // GIR_Coverage, 7543,
     /* 1702946 */     GIR_EraseRootFromParent_Done,
     /* 1702947 */   // Label 23322: @1702947
     /* 1702947 */   GIM_Try, /*On fail goto*//*Label 23323*/ GIMT_Encode4(1703033), // Rule ID 7546 //
     /* 1702952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1702963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1702966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1702969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702998 */     // MIs[0] policy
     /* 1702998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703008 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1703011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703032 */     // GIR_Coverage, 7546,
     /* 1703032 */     GIR_EraseRootFromParent_Done,
     /* 1703033 */   // Label 23323: @1703033
     /* 1703033 */   GIM_Try, /*On fail goto*//*Label 23324*/ GIMT_Encode4(1703119), // Rule ID 7547 //
     /* 1703038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1703049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1703052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1703055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703084 */     // MIs[0] policy
     /* 1703084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703094 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1703097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703118 */     // GIR_Coverage, 7547,
     /* 1703118 */     GIR_EraseRootFromParent_Done,
     /* 1703119 */   // Label 23324: @1703119
     /* 1703119 */   GIM_Try, /*On fail goto*//*Label 23325*/ GIMT_Encode4(1703205), // Rule ID 7550 //
     /* 1703124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1703135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1703138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1703141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703170 */     // MIs[0] policy
     /* 1703170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1703183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703204 */     // GIR_Coverage, 7550,
     /* 1703204 */     GIR_EraseRootFromParent_Done,
     /* 1703205 */   // Label 23325: @1703205
     /* 1703205 */   GIM_Try, /*On fail goto*//*Label 23326*/ GIMT_Encode4(1703291), // Rule ID 7551 //
     /* 1703210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1703221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1703224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1703227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703256 */     // MIs[0] policy
     /* 1703256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703266 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1703269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703290 */     // GIR_Coverage, 7551,
     /* 1703290 */     GIR_EraseRootFromParent_Done,
     /* 1703291 */   // Label 23326: @1703291
     /* 1703291 */   GIM_Try, /*On fail goto*//*Label 23327*/ GIMT_Encode4(1703377), // Rule ID 7554 //
     /* 1703296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1703307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1703310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1703313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703342 */     // MIs[0] policy
     /* 1703342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703352 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1703355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703376 */     // GIR_Coverage, 7554,
     /* 1703376 */     GIR_EraseRootFromParent_Done,
     /* 1703377 */   // Label 23327: @1703377
     /* 1703377 */   GIM_Try, /*On fail goto*//*Label 23328*/ GIMT_Encode4(1703463), // Rule ID 7555 //
     /* 1703382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1703393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1703396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1703399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703428 */     // MIs[0] policy
     /* 1703428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703438 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1703441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703462 */     // GIR_Coverage, 7555,
     /* 1703462 */     GIR_EraseRootFromParent_Done,
     /* 1703463 */   // Label 23328: @1703463
     /* 1703463 */   GIM_Try, /*On fail goto*//*Label 23329*/ GIMT_Encode4(1703549), // Rule ID 7558 //
     /* 1703468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1703479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1703482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1703485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703514 */     // MIs[0] policy
     /* 1703514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703524 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1703527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703548 */     // GIR_Coverage, 7558,
     /* 1703548 */     GIR_EraseRootFromParent_Done,
     /* 1703549 */   // Label 23329: @1703549
     /* 1703549 */   GIM_Try, /*On fail goto*//*Label 23330*/ GIMT_Encode4(1703635), // Rule ID 7559 //
     /* 1703554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1703565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1703568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1703571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703600 */     // MIs[0] policy
     /* 1703600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703610 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1703613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703634 */     // GIR_Coverage, 7559,
     /* 1703634 */     GIR_EraseRootFromParent_Done,
     /* 1703635 */   // Label 23330: @1703635
     /* 1703635 */   GIM_Try, /*On fail goto*//*Label 23331*/ GIMT_Encode4(1703721), // Rule ID 7562 //
     /* 1703640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1703657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703686 */     // MIs[0] policy
     /* 1703686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703696 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1703699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703720 */     // GIR_Coverage, 7562,
     /* 1703720 */     GIR_EraseRootFromParent_Done,
     /* 1703721 */   // Label 23331: @1703721
     /* 1703721 */   GIM_Try, /*On fail goto*//*Label 23332*/ GIMT_Encode4(1703807), // Rule ID 7563 //
     /* 1703726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1703743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703772 */     // MIs[0] policy
     /* 1703772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1703785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703806 */     // GIR_Coverage, 7563,
     /* 1703806 */     GIR_EraseRootFromParent_Done,
     /* 1703807 */   // Label 23332: @1703807
     /* 1703807 */   GIM_Try, /*On fail goto*//*Label 23333*/ GIMT_Encode4(1703893), // Rule ID 7566 //
     /* 1703812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1703829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703858 */     // MIs[0] policy
     /* 1703858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1703871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703892 */     // GIR_Coverage, 7566,
     /* 1703892 */     GIR_EraseRootFromParent_Done,
     /* 1703893 */   // Label 23333: @1703893
     /* 1703893 */   GIM_Try, /*On fail goto*//*Label 23334*/ GIMT_Encode4(1703979), // Rule ID 7567 //
     /* 1703898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1703915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703944 */     // MIs[0] policy
     /* 1703944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703954 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1703957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703978 */     // GIR_Coverage, 7567,
     /* 1703978 */     GIR_EraseRootFromParent_Done,
     /* 1703979 */   // Label 23334: @1703979
     /* 1703979 */   GIM_Try, /*On fail goto*//*Label 23335*/ GIMT_Encode4(1704065), // Rule ID 7570 //
     /* 1703984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1703995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1703998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1704001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1704004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704030 */     // MIs[0] policy
     /* 1704030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1704043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704064 */     // GIR_Coverage, 7570,
     /* 1704064 */     GIR_EraseRootFromParent_Done,
     /* 1704065 */   // Label 23335: @1704065
     /* 1704065 */   GIM_Try, /*On fail goto*//*Label 23336*/ GIMT_Encode4(1704151), // Rule ID 7571 //
     /* 1704070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1704073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1704081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1704084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1704087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1704090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704116 */     // MIs[0] policy
     /* 1704116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704126 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1704129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704150 */     // GIR_Coverage, 7571,
     /* 1704150 */     GIR_EraseRootFromParent_Done,
     /* 1704151 */   // Label 23336: @1704151
     /* 1704151 */   GIM_Try, /*On fail goto*//*Label 23337*/ GIMT_Encode4(1704237), // Rule ID 7574 //
     /* 1704156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1704159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1704167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1704170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1704173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1704176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704202 */     // MIs[0] policy
     /* 1704202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704212 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1704215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704236 */     // GIR_Coverage, 7574,
     /* 1704236 */     GIR_EraseRootFromParent_Done,
     /* 1704237 */   // Label 23337: @1704237
     /* 1704237 */   GIM_Try, /*On fail goto*//*Label 23338*/ GIMT_Encode4(1704323), // Rule ID 7575 //
     /* 1704242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1704245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1704253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1704256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1704259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1704262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704288 */     // MIs[0] policy
     /* 1704288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704298 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1704301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704322 */     // GIR_Coverage, 7575,
     /* 1704322 */     GIR_EraseRootFromParent_Done,
     /* 1704323 */   // Label 23338: @1704323
     /* 1704323 */   GIM_Try, /*On fail goto*//*Label 23339*/ GIMT_Encode4(1704409), // Rule ID 7638 //
     /* 1704328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1704339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1704342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1704345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1704348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704374 */     // MIs[0] policy
     /* 1704374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704384 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1704387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704408 */     // GIR_Coverage, 7638,
     /* 1704408 */     GIR_EraseRootFromParent_Done,
     /* 1704409 */   // Label 23339: @1704409
     /* 1704409 */   GIM_Try, /*On fail goto*//*Label 23340*/ GIMT_Encode4(1704495), // Rule ID 7639 //
     /* 1704414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1704425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1704428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1704431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1704434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704460 */     // MIs[0] policy
     /* 1704460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704470 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1704473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704494 */     // GIR_Coverage, 7639,
     /* 1704494 */     GIR_EraseRootFromParent_Done,
     /* 1704495 */   // Label 23340: @1704495
     /* 1704495 */   GIM_Try, /*On fail goto*//*Label 23341*/ GIMT_Encode4(1704581), // Rule ID 7642 //
     /* 1704500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1704511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1704514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1704517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1704520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704546 */     // MIs[0] policy
     /* 1704546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704556 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1704559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704580 */     // GIR_Coverage, 7642,
     /* 1704580 */     GIR_EraseRootFromParent_Done,
     /* 1704581 */   // Label 23341: @1704581
     /* 1704581 */   GIM_Try, /*On fail goto*//*Label 23342*/ GIMT_Encode4(1704667), // Rule ID 7643 //
     /* 1704586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1704597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1704600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1704603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1704606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704632 */     // MIs[0] policy
     /* 1704632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704642 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1704645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704666 */     // GIR_Coverage, 7643,
     /* 1704666 */     GIR_EraseRootFromParent_Done,
     /* 1704667 */   // Label 23342: @1704667
     /* 1704667 */   GIM_Try, /*On fail goto*//*Label 23343*/ GIMT_Encode4(1704753), // Rule ID 7646 //
     /* 1704672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1704683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1704686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1704689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1704692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704718 */     // MIs[0] policy
     /* 1704718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704728 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1704731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704752 */     // GIR_Coverage, 7646,
     /* 1704752 */     GIR_EraseRootFromParent_Done,
     /* 1704753 */   // Label 23343: @1704753
     /* 1704753 */   GIM_Try, /*On fail goto*//*Label 23344*/ GIMT_Encode4(1704839), // Rule ID 7647 //
     /* 1704758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1704769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1704772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1704775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1704778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704804 */     // MIs[0] policy
     /* 1704804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704814 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1704817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704838 */     // GIR_Coverage, 7647,
     /* 1704838 */     GIR_EraseRootFromParent_Done,
     /* 1704839 */   // Label 23344: @1704839
     /* 1704839 */   GIM_Try, /*On fail goto*//*Label 23345*/ GIMT_Encode4(1704925), // Rule ID 7650 //
     /* 1704844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1704855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1704858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1704861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1704864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704890 */     // MIs[0] policy
     /* 1704890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704900 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1704903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704924 */     // GIR_Coverage, 7650,
     /* 1704924 */     GIR_EraseRootFromParent_Done,
     /* 1704925 */   // Label 23345: @1704925
     /* 1704925 */   GIM_Try, /*On fail goto*//*Label 23346*/ GIMT_Encode4(1705011), // Rule ID 7651 //
     /* 1704930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1704941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1704944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1704947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1704950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704976 */     // MIs[0] policy
     /* 1704976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704986 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1704989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705010 */     // GIR_Coverage, 7651,
     /* 1705010 */     GIR_EraseRootFromParent_Done,
     /* 1705011 */   // Label 23346: @1705011
     /* 1705011 */   GIM_Try, /*On fail goto*//*Label 23347*/ GIMT_Encode4(1705097), // Rule ID 7654 //
     /* 1705016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1705027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1705030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1705033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1705036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705062 */     // MIs[0] policy
     /* 1705062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705072 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1705075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705096 */     // GIR_Coverage, 7654,
     /* 1705096 */     GIR_EraseRootFromParent_Done,
     /* 1705097 */   // Label 23347: @1705097
     /* 1705097 */   GIM_Try, /*On fail goto*//*Label 23348*/ GIMT_Encode4(1705183), // Rule ID 7655 //
     /* 1705102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1705113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1705116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1705119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1705122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705148 */     // MIs[0] policy
     /* 1705148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705158 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1705161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705182 */     // GIR_Coverage, 7655,
     /* 1705182 */     GIR_EraseRootFromParent_Done,
     /* 1705183 */   // Label 23348: @1705183
     /* 1705183 */   GIM_Try, /*On fail goto*//*Label 23349*/ GIMT_Encode4(1705269), // Rule ID 7658 //
     /* 1705188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1705199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1705202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1705205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1705208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1705211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705234 */     // MIs[0] policy
     /* 1705234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705244 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1705247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705268 */     // GIR_Coverage, 7658,
     /* 1705268 */     GIR_EraseRootFromParent_Done,
     /* 1705269 */   // Label 23349: @1705269
     /* 1705269 */   GIM_Try, /*On fail goto*//*Label 23350*/ GIMT_Encode4(1705355), // Rule ID 7659 //
     /* 1705274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1705285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1705288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1705291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1705294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1705297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705320 */     // MIs[0] policy
     /* 1705320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705330 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1705333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705354 */     // GIR_Coverage, 7659,
     /* 1705354 */     GIR_EraseRootFromParent_Done,
     /* 1705355 */   // Label 23350: @1705355
     /* 1705355 */   GIM_Try, /*On fail goto*//*Label 23351*/ GIMT_Encode4(1705441), // Rule ID 7662 //
     /* 1705360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1705371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1705374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1705377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1705380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705406 */     // MIs[0] policy
     /* 1705406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705416 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1705419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705440 */     // GIR_Coverage, 7662,
     /* 1705440 */     GIR_EraseRootFromParent_Done,
     /* 1705441 */   // Label 23351: @1705441
     /* 1705441 */   GIM_Try, /*On fail goto*//*Label 23352*/ GIMT_Encode4(1705527), // Rule ID 7663 //
     /* 1705446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1705457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1705460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1705463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1705466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705492 */     // MIs[0] policy
     /* 1705492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705502 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1705505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705526 */     // GIR_Coverage, 7663,
     /* 1705526 */     GIR_EraseRootFromParent_Done,
     /* 1705527 */   // Label 23352: @1705527
     /* 1705527 */   GIM_Try, /*On fail goto*//*Label 23353*/ GIMT_Encode4(1705613), // Rule ID 7666 //
     /* 1705532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1705543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1705546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1705549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1705552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705578 */     // MIs[0] policy
     /* 1705578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705588 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1705591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705612 */     // GIR_Coverage, 7666,
     /* 1705612 */     GIR_EraseRootFromParent_Done,
     /* 1705613 */   // Label 23353: @1705613
     /* 1705613 */   GIM_Try, /*On fail goto*//*Label 23354*/ GIMT_Encode4(1705699), // Rule ID 7667 //
     /* 1705618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1705629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1705632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1705635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1705638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705664 */     // MIs[0] policy
     /* 1705664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705674 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1705677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705698 */     // GIR_Coverage, 7667,
     /* 1705698 */     GIR_EraseRootFromParent_Done,
     /* 1705699 */   // Label 23354: @1705699
     /* 1705699 */   GIM_Try, /*On fail goto*//*Label 23355*/ GIMT_Encode4(1705785), // Rule ID 7670 //
     /* 1705704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1705715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1705718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1705721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1705724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705750 */     // MIs[0] policy
     /* 1705750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705760 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1705763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705784 */     // GIR_Coverage, 7670,
     /* 1705784 */     GIR_EraseRootFromParent_Done,
     /* 1705785 */   // Label 23355: @1705785
     /* 1705785 */   GIM_Try, /*On fail goto*//*Label 23356*/ GIMT_Encode4(1705871), // Rule ID 7671 //
     /* 1705790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1705801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1705804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1705807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1705810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705836 */     // MIs[0] policy
     /* 1705836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705846 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1705849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705870 */     // GIR_Coverage, 7671,
     /* 1705870 */     GIR_EraseRootFromParent_Done,
     /* 1705871 */   // Label 23356: @1705871
     /* 1705871 */   GIM_Try, /*On fail goto*//*Label 23357*/ GIMT_Encode4(1705957), // Rule ID 7674 //
     /* 1705876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1705887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1705890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1705893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1705896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705922 */     // MIs[0] policy
     /* 1705922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705932 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1705935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705956 */     // GIR_Coverage, 7674,
     /* 1705956 */     GIR_EraseRootFromParent_Done,
     /* 1705957 */   // Label 23357: @1705957
     /* 1705957 */   GIM_Try, /*On fail goto*//*Label 23358*/ GIMT_Encode4(1706043), // Rule ID 7675 //
     /* 1705962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1705973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1705976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1705979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1705982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706008 */     // MIs[0] policy
     /* 1706008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1706021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706042 */     // GIR_Coverage, 7675,
     /* 1706042 */     GIR_EraseRootFromParent_Done,
     /* 1706043 */   // Label 23358: @1706043
     /* 1706043 */   GIM_Try, /*On fail goto*//*Label 23359*/ GIMT_Encode4(1706129), // Rule ID 7678 //
     /* 1706048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1706059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1706062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1706065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1706068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1706071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706094 */     // MIs[0] policy
     /* 1706094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706104 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1706107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706128 */     // GIR_Coverage, 7678,
     /* 1706128 */     GIR_EraseRootFromParent_Done,
     /* 1706129 */   // Label 23359: @1706129
     /* 1706129 */   GIM_Try, /*On fail goto*//*Label 23360*/ GIMT_Encode4(1706215), // Rule ID 7679 //
     /* 1706134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1706145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1706148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1706151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1706154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1706157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706180 */     // MIs[0] policy
     /* 1706180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706190 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1706193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706214 */     // GIR_Coverage, 7679,
     /* 1706214 */     GIR_EraseRootFromParent_Done,
     /* 1706215 */   // Label 23360: @1706215
     /* 1706215 */   GIM_Try, /*On fail goto*//*Label 23361*/ GIMT_Encode4(1706301), // Rule ID 7682 //
     /* 1706220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1706231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1706234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1706237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1706240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706266 */     // MIs[0] policy
     /* 1706266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1706279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706300 */     // GIR_Coverage, 7682,
     /* 1706300 */     GIR_EraseRootFromParent_Done,
     /* 1706301 */   // Label 23361: @1706301
     /* 1706301 */   GIM_Try, /*On fail goto*//*Label 23362*/ GIMT_Encode4(1706387), // Rule ID 7683 //
     /* 1706306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1706317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1706320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1706323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1706326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706352 */     // MIs[0] policy
     /* 1706352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706362 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1706365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706386 */     // GIR_Coverage, 7683,
     /* 1706386 */     GIR_EraseRootFromParent_Done,
     /* 1706387 */   // Label 23362: @1706387
     /* 1706387 */   GIM_Try, /*On fail goto*//*Label 23363*/ GIMT_Encode4(1706473), // Rule ID 7686 //
     /* 1706392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1706403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1706406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1706409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1706412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706438 */     // MIs[0] policy
     /* 1706438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1706451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706472 */     // GIR_Coverage, 7686,
     /* 1706472 */     GIR_EraseRootFromParent_Done,
     /* 1706473 */   // Label 23363: @1706473
     /* 1706473 */   GIM_Try, /*On fail goto*//*Label 23364*/ GIMT_Encode4(1706559), // Rule ID 7687 //
     /* 1706478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1706489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1706492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1706495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1706498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706524 */     // MIs[0] policy
     /* 1706524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1706537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706558 */     // GIR_Coverage, 7687,
     /* 1706558 */     GIR_EraseRootFromParent_Done,
     /* 1706559 */   // Label 23364: @1706559
     /* 1706559 */   GIM_Try, /*On fail goto*//*Label 23365*/ GIMT_Encode4(1706645), // Rule ID 7690 //
     /* 1706564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1706575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1706578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1706581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1706584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706610 */     // MIs[0] policy
     /* 1706610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706620 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1706623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706644 */     // GIR_Coverage, 7690,
     /* 1706644 */     GIR_EraseRootFromParent_Done,
     /* 1706645 */   // Label 23365: @1706645
     /* 1706645 */   GIM_Try, /*On fail goto*//*Label 23366*/ GIMT_Encode4(1706731), // Rule ID 7691 //
     /* 1706650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1706661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1706664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1706667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1706670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706696 */     // MIs[0] policy
     /* 1706696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1706709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706730 */     // GIR_Coverage, 7691,
     /* 1706730 */     GIR_EraseRootFromParent_Done,
     /* 1706731 */   // Label 23366: @1706731
     /* 1706731 */   GIM_Try, /*On fail goto*//*Label 23367*/ GIMT_Encode4(1706817), // Rule ID 7694 //
     /* 1706736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1706747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1706750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1706753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1706756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706782 */     // MIs[0] policy
     /* 1706782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706792 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1706795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706816 */     // GIR_Coverage, 7694,
     /* 1706816 */     GIR_EraseRootFromParent_Done,
     /* 1706817 */   // Label 23367: @1706817
     /* 1706817 */   GIM_Try, /*On fail goto*//*Label 23368*/ GIMT_Encode4(1706903), // Rule ID 7695 //
     /* 1706822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1706833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1706836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1706839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1706842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706868 */     // MIs[0] policy
     /* 1706868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1706881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706902 */     // GIR_Coverage, 7695,
     /* 1706902 */     GIR_EraseRootFromParent_Done,
     /* 1706903 */   // Label 23368: @1706903
     /* 1706903 */   GIM_Try, /*On fail goto*//*Label 23369*/ GIMT_Encode4(1706989), // Rule ID 7698 //
     /* 1706908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1706919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1706922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1706925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706954 */     // MIs[0] policy
     /* 1706954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706964 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1706967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706988 */     // GIR_Coverage, 7698,
     /* 1706988 */     GIR_EraseRootFromParent_Done,
     /* 1706989 */   // Label 23369: @1706989
     /* 1706989 */   GIM_Try, /*On fail goto*//*Label 23370*/ GIMT_Encode4(1707075), // Rule ID 7699 //
     /* 1706994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1707005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1707008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1707011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707040 */     // MIs[0] policy
     /* 1707040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707050 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1707053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707074 */     // GIR_Coverage, 7699,
     /* 1707074 */     GIR_EraseRootFromParent_Done,
     /* 1707075 */   // Label 23370: @1707075
     /* 1707075 */   GIM_Try, /*On fail goto*//*Label 23371*/ GIMT_Encode4(1707161), // Rule ID 7702 //
     /* 1707080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1707091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1707094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1707097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707126 */     // MIs[0] policy
     /* 1707126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707136 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1707139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707160 */     // GIR_Coverage, 7702,
     /* 1707160 */     GIR_EraseRootFromParent_Done,
     /* 1707161 */   // Label 23371: @1707161
     /* 1707161 */   GIM_Try, /*On fail goto*//*Label 23372*/ GIMT_Encode4(1707247), // Rule ID 7703 //
     /* 1707166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1707177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1707180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1707183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707212 */     // MIs[0] policy
     /* 1707212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707222 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1707225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707246 */     // GIR_Coverage, 7703,
     /* 1707246 */     GIR_EraseRootFromParent_Done,
     /* 1707247 */   // Label 23372: @1707247
     /* 1707247 */   GIM_Try, /*On fail goto*//*Label 23373*/ GIMT_Encode4(1707333), // Rule ID 7706 //
     /* 1707252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1707263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1707266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1707269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707298 */     // MIs[0] policy
     /* 1707298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707308 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1707311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707332 */     // GIR_Coverage, 7706,
     /* 1707332 */     GIR_EraseRootFromParent_Done,
     /* 1707333 */   // Label 23373: @1707333
     /* 1707333 */   GIM_Try, /*On fail goto*//*Label 23374*/ GIMT_Encode4(1707419), // Rule ID 7707 //
     /* 1707338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1707349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1707352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1707355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707384 */     // MIs[0] policy
     /* 1707384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707394 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1707397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707418 */     // GIR_Coverage, 7707,
     /* 1707418 */     GIR_EraseRootFromParent_Done,
     /* 1707419 */   // Label 23374: @1707419
     /* 1707419 */   GIM_Try, /*On fail goto*//*Label 23375*/ GIMT_Encode4(1707505), // Rule ID 7710 //
     /* 1707424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1707435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1707438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1707441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707470 */     // MIs[0] policy
     /* 1707470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707480 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1707483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707504 */     // GIR_Coverage, 7710,
     /* 1707504 */     GIR_EraseRootFromParent_Done,
     /* 1707505 */   // Label 23375: @1707505
     /* 1707505 */   GIM_Try, /*On fail goto*//*Label 23376*/ GIMT_Encode4(1707591), // Rule ID 7711 //
     /* 1707510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1707521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1707524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1707527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707556 */     // MIs[0] policy
     /* 1707556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707566 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1707569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707590 */     // GIR_Coverage, 7711,
     /* 1707590 */     GIR_EraseRootFromParent_Done,
     /* 1707591 */   // Label 23376: @1707591
     /* 1707591 */   GIM_Try, /*On fail goto*//*Label 23377*/ GIMT_Encode4(1707677), // Rule ID 7714 //
     /* 1707596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1707607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1707610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1707613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1707619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707642 */     // MIs[0] policy
     /* 1707642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707652 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1707655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707676 */     // GIR_Coverage, 7714,
     /* 1707676 */     GIR_EraseRootFromParent_Done,
     /* 1707677 */   // Label 23377: @1707677
     /* 1707677 */   GIM_Try, /*On fail goto*//*Label 23378*/ GIMT_Encode4(1707763), // Rule ID 7715 //
     /* 1707682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1707693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1707696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1707699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1707705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707728 */     // MIs[0] policy
     /* 1707728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707738 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1707741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707762 */     // GIR_Coverage, 7715,
     /* 1707762 */     GIR_EraseRootFromParent_Done,
     /* 1707763 */   // Label 23378: @1707763
     /* 1707763 */   GIM_Try, /*On fail goto*//*Label 23379*/ GIMT_Encode4(1707849), // Rule ID 7718 //
     /* 1707768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1707779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1707782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1707785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1707791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1707798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1707806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707814 */     // MIs[0] policy
     /* 1707814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707824 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1707827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707848 */     // GIR_Coverage, 7718,
     /* 1707848 */     GIR_EraseRootFromParent_Done,
     /* 1707849 */   // Label 23379: @1707849
     /* 1707849 */   GIM_Try, /*On fail goto*//*Label 23380*/ GIMT_Encode4(1707935), // Rule ID 7719 //
     /* 1707854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1707865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1707868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1707871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1707877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1707884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1707892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707900 */     // MIs[0] policy
     /* 1707900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707910 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1707913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707934 */     // GIR_Coverage, 7719,
     /* 1707934 */     GIR_EraseRootFromParent_Done,
     /* 1707935 */   // Label 23380: @1707935
     /* 1707935 */   GIM_Try, /*On fail goto*//*Label 23381*/ GIMT_Encode4(1708021), // Rule ID 7722 //
     /* 1707940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1707951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1707954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1707957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707986 */     // MIs[0] policy
     /* 1707986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707996 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1707999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708020 */     // GIR_Coverage, 7722,
     /* 1708020 */     GIR_EraseRootFromParent_Done,
     /* 1708021 */   // Label 23381: @1708021
     /* 1708021 */   GIM_Try, /*On fail goto*//*Label 23382*/ GIMT_Encode4(1708107), // Rule ID 7723 //
     /* 1708026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1708037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1708040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1708043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708072 */     // MIs[0] policy
     /* 1708072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708082 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1708085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708106 */     // GIR_Coverage, 7723,
     /* 1708106 */     GIR_EraseRootFromParent_Done,
     /* 1708107 */   // Label 23382: @1708107
     /* 1708107 */   GIM_Try, /*On fail goto*//*Label 23383*/ GIMT_Encode4(1708193), // Rule ID 7726 //
     /* 1708112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1708123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1708126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1708129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708158 */     // MIs[0] policy
     /* 1708158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708168 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1708171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708192 */     // GIR_Coverage, 7726,
     /* 1708192 */     GIR_EraseRootFromParent_Done,
     /* 1708193 */   // Label 23383: @1708193
     /* 1708193 */   GIM_Try, /*On fail goto*//*Label 23384*/ GIMT_Encode4(1708279), // Rule ID 7727 //
     /* 1708198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1708209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1708212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1708215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708244 */     // MIs[0] policy
     /* 1708244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708254 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1708257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708278 */     // GIR_Coverage, 7727,
     /* 1708278 */     GIR_EraseRootFromParent_Done,
     /* 1708279 */   // Label 23384: @1708279
     /* 1708279 */   GIM_Try, /*On fail goto*//*Label 23385*/ GIMT_Encode4(1708365), // Rule ID 7730 //
     /* 1708284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1708295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1708298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1708301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708330 */     // MIs[0] policy
     /* 1708330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708340 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1708343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708364 */     // GIR_Coverage, 7730,
     /* 1708364 */     GIR_EraseRootFromParent_Done,
     /* 1708365 */   // Label 23385: @1708365
     /* 1708365 */   GIM_Try, /*On fail goto*//*Label 23386*/ GIMT_Encode4(1708451), // Rule ID 7731 //
     /* 1708370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1708381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1708384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1708387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708416 */     // MIs[0] policy
     /* 1708416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708426 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1708429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708450 */     // GIR_Coverage, 7731,
     /* 1708450 */     GIR_EraseRootFromParent_Done,
     /* 1708451 */   // Label 23386: @1708451
     /* 1708451 */   GIM_Try, /*On fail goto*//*Label 23387*/ GIMT_Encode4(1708537), // Rule ID 7734 //
     /* 1708456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1708467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1708470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1708473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708502 */     // MIs[0] policy
     /* 1708502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708512 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1708515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708536 */     // GIR_Coverage, 7734,
     /* 1708536 */     GIR_EraseRootFromParent_Done,
     /* 1708537 */   // Label 23387: @1708537
     /* 1708537 */   GIM_Try, /*On fail goto*//*Label 23388*/ GIMT_Encode4(1708623), // Rule ID 7735 //
     /* 1708542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1708553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1708556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1708559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708588 */     // MIs[0] policy
     /* 1708588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708598 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1708601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708622 */     // GIR_Coverage, 7735,
     /* 1708622 */     GIR_EraseRootFromParent_Done,
     /* 1708623 */   // Label 23388: @1708623
     /* 1708623 */   GIM_Try, /*On fail goto*//*Label 23389*/ GIMT_Encode4(1708709), // Rule ID 7738 //
     /* 1708628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1708639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1708642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1708645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708674 */     // MIs[0] policy
     /* 1708674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1708687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708708 */     // GIR_Coverage, 7738,
     /* 1708708 */     GIR_EraseRootFromParent_Done,
     /* 1708709 */   // Label 23389: @1708709
     /* 1708709 */   GIM_Try, /*On fail goto*//*Label 23390*/ GIMT_Encode4(1708795), // Rule ID 7739 //
     /* 1708714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1708725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1708728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1708731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708760 */     // MIs[0] policy
     /* 1708760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708770 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1708773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708794 */     // GIR_Coverage, 7739,
     /* 1708794 */     GIR_EraseRootFromParent_Done,
     /* 1708795 */   // Label 23390: @1708795
     /* 1708795 */   GIM_Try, /*On fail goto*//*Label 23391*/ GIMT_Encode4(1708881), // Rule ID 7742 //
     /* 1708800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1708811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1708814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1708817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708846 */     // MIs[0] policy
     /* 1708846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1708859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708880 */     // GIR_Coverage, 7742,
     /* 1708880 */     GIR_EraseRootFromParent_Done,
     /* 1708881 */   // Label 23391: @1708881
     /* 1708881 */   GIM_Try, /*On fail goto*//*Label 23392*/ GIMT_Encode4(1708967), // Rule ID 7743 //
     /* 1708886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1708889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1708897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1708900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1708903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708932 */     // MIs[0] policy
     /* 1708932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1708945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708966 */     // GIR_Coverage, 7743,
     /* 1708966 */     GIR_EraseRootFromParent_Done,
     /* 1708967 */   // Label 23392: @1708967
     /* 1708967 */   GIM_Try, /*On fail goto*//*Label 23393*/ GIMT_Encode4(1709053), // Rule ID 7746 //
     /* 1708972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1708983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1708986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1708989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709018 */     // MIs[0] policy
     /* 1709018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709028 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1709031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709052 */     // GIR_Coverage, 7746,
     /* 1709052 */     GIR_EraseRootFromParent_Done,
     /* 1709053 */   // Label 23393: @1709053
     /* 1709053 */   GIM_Try, /*On fail goto*//*Label 23394*/ GIMT_Encode4(1709139), // Rule ID 7747 //
     /* 1709058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1709061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1709069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1709072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1709075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709104 */     // MIs[0] policy
     /* 1709104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1709117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709138 */     // GIR_Coverage, 7747,
     /* 1709138 */     GIR_EraseRootFromParent_Done,
     /* 1709139 */   // Label 23394: @1709139
     /* 1709139 */   GIM_Try, /*On fail goto*//*Label 23395*/ GIMT_Encode4(1709225), // Rule ID 7750 //
     /* 1709144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1709147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1709155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1709158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1709161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709190 */     // MIs[0] policy
     /* 1709190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1709203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709224 */     // GIR_Coverage, 7750,
     /* 1709224 */     GIR_EraseRootFromParent_Done,
     /* 1709225 */   // Label 23395: @1709225
     /* 1709225 */   GIM_Try, /*On fail goto*//*Label 23396*/ GIMT_Encode4(1709311), // Rule ID 7751 //
     /* 1709230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1709233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1709241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1709244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1709247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709276 */     // MIs[0] policy
     /* 1709276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1709289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709310 */     // GIR_Coverage, 7751,
     /* 1709310 */     GIR_EraseRootFromParent_Done,
     /* 1709311 */   // Label 23396: @1709311
     /* 1709311 */   GIM_Try, /*On fail goto*//*Label 23397*/ GIMT_Encode4(1709397), // Rule ID 7754 //
     /* 1709316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1709319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1709327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1709330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1709333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709362 */     // MIs[0] policy
     /* 1709362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709372 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1709375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709396 */     // GIR_Coverage, 7754,
     /* 1709396 */     GIR_EraseRootFromParent_Done,
     /* 1709397 */   // Label 23397: @1709397
     /* 1709397 */   GIM_Try, /*On fail goto*//*Label 23398*/ GIMT_Encode4(1709483), // Rule ID 7755 //
     /* 1709402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1709405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1709413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1709416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1709419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709448 */     // MIs[0] policy
     /* 1709448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709458 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1709461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709482 */     // GIR_Coverage, 7755,
     /* 1709482 */     GIR_EraseRootFromParent_Done,
     /* 1709483 */   // Label 23398: @1709483
     /* 1709483 */   GIM_Try, /*On fail goto*//*Label 23399*/ GIMT_Encode4(1709569), // Rule ID 10270 //
     /* 1709488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1709499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1709502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1709505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1709508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709534 */     // MIs[0] policy
     /* 1709534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1709547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709568 */     // GIR_Coverage, 10270,
     /* 1709568 */     GIR_EraseRootFromParent_Done,
     /* 1709569 */   // Label 23399: @1709569
     /* 1709569 */   GIM_Try, /*On fail goto*//*Label 23400*/ GIMT_Encode4(1709655), // Rule ID 10271 //
     /* 1709574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1709585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1709588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1709591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1709594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709620 */     // MIs[0] policy
     /* 1709620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709630 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1709633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709654 */     // GIR_Coverage, 10271,
     /* 1709654 */     GIR_EraseRootFromParent_Done,
     /* 1709655 */   // Label 23400: @1709655
     /* 1709655 */   GIM_Try, /*On fail goto*//*Label 23401*/ GIMT_Encode4(1709741), // Rule ID 10274 //
     /* 1709660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1709671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1709674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1709677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1709680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709706 */     // MIs[0] policy
     /* 1709706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709716 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1709719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709740 */     // GIR_Coverage, 10274,
     /* 1709740 */     GIR_EraseRootFromParent_Done,
     /* 1709741 */   // Label 23401: @1709741
     /* 1709741 */   GIM_Try, /*On fail goto*//*Label 23402*/ GIMT_Encode4(1709827), // Rule ID 10275 //
     /* 1709746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1709757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1709760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1709763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1709766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709792 */     // MIs[0] policy
     /* 1709792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709802 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1709805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709826 */     // GIR_Coverage, 10275,
     /* 1709826 */     GIR_EraseRootFromParent_Done,
     /* 1709827 */   // Label 23402: @1709827
     /* 1709827 */   GIM_Try, /*On fail goto*//*Label 23403*/ GIMT_Encode4(1709913), // Rule ID 10278 //
     /* 1709832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1709843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1709846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1709849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1709852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709878 */     // MIs[0] policy
     /* 1709878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709888 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709912 */     // GIR_Coverage, 10278,
     /* 1709912 */     GIR_EraseRootFromParent_Done,
     /* 1709913 */   // Label 23403: @1709913
     /* 1709913 */   GIM_Try, /*On fail goto*//*Label 23404*/ GIMT_Encode4(1709999), // Rule ID 10279 //
     /* 1709918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1709929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1709932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1709935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1709938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709964 */     // MIs[0] policy
     /* 1709964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709974 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709998 */     // GIR_Coverage, 10279,
     /* 1709998 */     GIR_EraseRootFromParent_Done,
     /* 1709999 */   // Label 23404: @1709999
     /* 1709999 */   GIM_Try, /*On fail goto*//*Label 23405*/ GIMT_Encode4(1710085), // Rule ID 10282 //
     /* 1710004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1710015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1710018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1710021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1710024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710050 */     // MIs[0] policy
     /* 1710050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1710063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710084 */     // GIR_Coverage, 10282,
     /* 1710084 */     GIR_EraseRootFromParent_Done,
     /* 1710085 */   // Label 23405: @1710085
     /* 1710085 */   GIM_Try, /*On fail goto*//*Label 23406*/ GIMT_Encode4(1710171), // Rule ID 10283 //
     /* 1710090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1710101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1710104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1710107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1710110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710136 */     // MIs[0] policy
     /* 1710136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1710149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710170 */     // GIR_Coverage, 10283,
     /* 1710170 */     GIR_EraseRootFromParent_Done,
     /* 1710171 */   // Label 23406: @1710171
     /* 1710171 */   GIM_Try, /*On fail goto*//*Label 23407*/ GIMT_Encode4(1710257), // Rule ID 10286 //
     /* 1710176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1710187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1710190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1710193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1710196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710222 */     // MIs[0] policy
     /* 1710222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710232 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1710235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710256 */     // GIR_Coverage, 10286,
     /* 1710256 */     GIR_EraseRootFromParent_Done,
     /* 1710257 */   // Label 23407: @1710257
     /* 1710257 */   GIM_Try, /*On fail goto*//*Label 23408*/ GIMT_Encode4(1710343), // Rule ID 10287 //
     /* 1710262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1710273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1710276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1710279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1710282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710308 */     // MIs[0] policy
     /* 1710308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710318 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1710321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710342 */     // GIR_Coverage, 10287,
     /* 1710342 */     GIR_EraseRootFromParent_Done,
     /* 1710343 */   // Label 23408: @1710343
     /* 1710343 */   GIM_Try, /*On fail goto*//*Label 23409*/ GIMT_Encode4(1710429), // Rule ID 10290 //
     /* 1710348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1710359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1710362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1710365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1710368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710394 */     // MIs[0] policy
     /* 1710394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1710407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710428 */     // GIR_Coverage, 10290,
     /* 1710428 */     GIR_EraseRootFromParent_Done,
     /* 1710429 */   // Label 23409: @1710429
     /* 1710429 */   GIM_Try, /*On fail goto*//*Label 23410*/ GIMT_Encode4(1710515), // Rule ID 10291 //
     /* 1710434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1710445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1710448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1710451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1710454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710480 */     // MIs[0] policy
     /* 1710480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710490 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1710493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710514 */     // GIR_Coverage, 10291,
     /* 1710514 */     GIR_EraseRootFromParent_Done,
     /* 1710515 */   // Label 23410: @1710515
     /* 1710515 */   GIM_Try, /*On fail goto*//*Label 23411*/ GIMT_Encode4(1710601), // Rule ID 10294 //
     /* 1710520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1710531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1710534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1710537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1710540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710566 */     // MIs[0] policy
     /* 1710566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710576 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710600 */     // GIR_Coverage, 10294,
     /* 1710600 */     GIR_EraseRootFromParent_Done,
     /* 1710601 */   // Label 23411: @1710601
     /* 1710601 */   GIM_Try, /*On fail goto*//*Label 23412*/ GIMT_Encode4(1710687), // Rule ID 10295 //
     /* 1710606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1710617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1710620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1710623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1710626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710652 */     // MIs[0] policy
     /* 1710652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710662 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710686 */     // GIR_Coverage, 10295,
     /* 1710686 */     GIR_EraseRootFromParent_Done,
     /* 1710687 */   // Label 23412: @1710687
     /* 1710687 */   GIM_Try, /*On fail goto*//*Label 23413*/ GIMT_Encode4(1710773), // Rule ID 10298 //
     /* 1710692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1710703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1710706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1710709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1710712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710738 */     // MIs[0] policy
     /* 1710738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710748 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710772 */     // GIR_Coverage, 10298,
     /* 1710772 */     GIR_EraseRootFromParent_Done,
     /* 1710773 */   // Label 23413: @1710773
     /* 1710773 */   GIM_Try, /*On fail goto*//*Label 23414*/ GIMT_Encode4(1710859), // Rule ID 10299 //
     /* 1710778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1710789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1710792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1710795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1710798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710824 */     // MIs[0] policy
     /* 1710824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710834 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710858 */     // GIR_Coverage, 10299,
     /* 1710858 */     GIR_EraseRootFromParent_Done,
     /* 1710859 */   // Label 23414: @1710859
     /* 1710859 */   GIM_Try, /*On fail goto*//*Label 23415*/ GIMT_Encode4(1710945), // Rule ID 10302 //
     /* 1710864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1710875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1710878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1710881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1710884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710910 */     // MIs[0] policy
     /* 1710910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710920 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710944 */     // GIR_Coverage, 10302,
     /* 1710944 */     GIR_EraseRootFromParent_Done,
     /* 1710945 */   // Label 23415: @1710945
     /* 1710945 */   GIM_Try, /*On fail goto*//*Label 23416*/ GIMT_Encode4(1711031), // Rule ID 10303 //
     /* 1710950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1710961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1710964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1710967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1710970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710996 */     // MIs[0] policy
     /* 1710996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711006 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1711009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711030 */     // GIR_Coverage, 10303,
     /* 1711030 */     GIR_EraseRootFromParent_Done,
     /* 1711031 */   // Label 23416: @1711031
     /* 1711031 */   GIM_Try, /*On fail goto*//*Label 23417*/ GIMT_Encode4(1711117), // Rule ID 10306 //
     /* 1711036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1711039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1711047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1711050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1711053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1711056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711082 */     // MIs[0] policy
     /* 1711082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711092 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1711095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1711113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711116 */     // GIR_Coverage, 10306,
     /* 1711116 */     GIR_EraseRootFromParent_Done,
     /* 1711117 */   // Label 23417: @1711117
     /* 1711117 */   GIM_Try, /*On fail goto*//*Label 23418*/ GIMT_Encode4(1711203), // Rule ID 10307 //
     /* 1711122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1711125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1711133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1711136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1711139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1711142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711168 */     // MIs[0] policy
     /* 1711168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711178 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1711181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1711199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711202 */     // GIR_Coverage, 10307,
     /* 1711202 */     GIR_EraseRootFromParent_Done,
     /* 1711203 */   // Label 23418: @1711203
     /* 1711203 */   GIM_Try, /*On fail goto*//*Label 23419*/ GIMT_Encode4(1711289), // Rule ID 10310 //
     /* 1711208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1711219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1711222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1711225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1711228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711254 */     // MIs[0] policy
     /* 1711254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711264 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711288 */     // GIR_Coverage, 10310,
     /* 1711288 */     GIR_EraseRootFromParent_Done,
     /* 1711289 */   // Label 23419: @1711289
     /* 1711289 */   GIM_Try, /*On fail goto*//*Label 23420*/ GIMT_Encode4(1711375), // Rule ID 10311 //
     /* 1711294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1711305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1711308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1711311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1711314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711340 */     // MIs[0] policy
     /* 1711340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711350 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711374 */     // GIR_Coverage, 10311,
     /* 1711374 */     GIR_EraseRootFromParent_Done,
     /* 1711375 */   // Label 23420: @1711375
     /* 1711375 */   GIM_Try, /*On fail goto*//*Label 23421*/ GIMT_Encode4(1711461), // Rule ID 10314 //
     /* 1711380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1711391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1711394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1711397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1711400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711426 */     // MIs[0] policy
     /* 1711426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711436 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711460 */     // GIR_Coverage, 10314,
     /* 1711460 */     GIR_EraseRootFromParent_Done,
     /* 1711461 */   // Label 23421: @1711461
     /* 1711461 */   GIM_Try, /*On fail goto*//*Label 23422*/ GIMT_Encode4(1711547), // Rule ID 10315 //
     /* 1711466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1711477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1711480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1711483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1711486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711512 */     // MIs[0] policy
     /* 1711512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711522 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711546 */     // GIR_Coverage, 10315,
     /* 1711546 */     GIR_EraseRootFromParent_Done,
     /* 1711547 */   // Label 23422: @1711547
     /* 1711547 */   GIM_Try, /*On fail goto*//*Label 23423*/ GIMT_Encode4(1711633), // Rule ID 10318 //
     /* 1711552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1711563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1711566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1711569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1711572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1711575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711598 */     // MIs[0] policy
     /* 1711598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711608 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1711611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711632 */     // GIR_Coverage, 10318,
     /* 1711632 */     GIR_EraseRootFromParent_Done,
     /* 1711633 */   // Label 23423: @1711633
     /* 1711633 */   GIM_Try, /*On fail goto*//*Label 23424*/ GIMT_Encode4(1711719), // Rule ID 10319 //
     /* 1711638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1711649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1711652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1711655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1711658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1711661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711684 */     // MIs[0] policy
     /* 1711684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711694 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1711697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711718 */     // GIR_Coverage, 10319,
     /* 1711718 */     GIR_EraseRootFromParent_Done,
     /* 1711719 */   // Label 23424: @1711719
     /* 1711719 */   GIM_Try, /*On fail goto*//*Label 23425*/ GIMT_Encode4(1711805), // Rule ID 10322 //
     /* 1711724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1711735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1711738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1711741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1711744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711770 */     // MIs[0] policy
     /* 1711770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711780 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711804 */     // GIR_Coverage, 10322,
     /* 1711804 */     GIR_EraseRootFromParent_Done,
     /* 1711805 */   // Label 23425: @1711805
     /* 1711805 */   GIM_Try, /*On fail goto*//*Label 23426*/ GIMT_Encode4(1711891), // Rule ID 10323 //
     /* 1711810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1711821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1711824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1711827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1711830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711856 */     // MIs[0] policy
     /* 1711856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711890 */     // GIR_Coverage, 10323,
     /* 1711890 */     GIR_EraseRootFromParent_Done,
     /* 1711891 */   // Label 23426: @1711891
     /* 1711891 */   GIM_Try, /*On fail goto*//*Label 23427*/ GIMT_Encode4(1711977), // Rule ID 10326 //
     /* 1711896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1711907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1711910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1711913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1711916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711942 */     // MIs[0] policy
     /* 1711942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711952 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711976 */     // GIR_Coverage, 10326,
     /* 1711976 */     GIR_EraseRootFromParent_Done,
     /* 1711977 */   // Label 23427: @1711977
     /* 1711977 */   GIM_Try, /*On fail goto*//*Label 23428*/ GIMT_Encode4(1712063), // Rule ID 10327 //
     /* 1711982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1711993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1711996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1711999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1712002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712028 */     // MIs[0] policy
     /* 1712028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712038 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712062 */     // GIR_Coverage, 10327,
     /* 1712062 */     GIR_EraseRootFromParent_Done,
     /* 1712063 */   // Label 23428: @1712063
     /* 1712063 */   GIM_Try, /*On fail goto*//*Label 23429*/ GIMT_Encode4(1712149), // Rule ID 10330 //
     /* 1712068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1712079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1712082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1712085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1712088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1712091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712114 */     // MIs[0] policy
     /* 1712114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712124 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712148 */     // GIR_Coverage, 10330,
     /* 1712148 */     GIR_EraseRootFromParent_Done,
     /* 1712149 */   // Label 23429: @1712149
     /* 1712149 */   GIM_Try, /*On fail goto*//*Label 23430*/ GIMT_Encode4(1712235), // Rule ID 10331 //
     /* 1712154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1712165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1712168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1712171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1712174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1712177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712200 */     // MIs[0] policy
     /* 1712200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712210 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712234 */     // GIR_Coverage, 10331,
     /* 1712234 */     GIR_EraseRootFromParent_Done,
     /* 1712235 */   // Label 23430: @1712235
     /* 1712235 */   GIM_Try, /*On fail goto*//*Label 23431*/ GIMT_Encode4(1712321), // Rule ID 10334 //
     /* 1712240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1712251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1712254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1712257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1712260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712286 */     // MIs[0] policy
     /* 1712286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1712299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712320 */     // GIR_Coverage, 10334,
     /* 1712320 */     GIR_EraseRootFromParent_Done,
     /* 1712321 */   // Label 23431: @1712321
     /* 1712321 */   GIM_Try, /*On fail goto*//*Label 23432*/ GIMT_Encode4(1712407), // Rule ID 10335 //
     /* 1712326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1712337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1712340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1712343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1712346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712372 */     // MIs[0] policy
     /* 1712372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1712385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712406 */     // GIR_Coverage, 10335,
     /* 1712406 */     GIR_EraseRootFromParent_Done,
     /* 1712407 */   // Label 23432: @1712407
     /* 1712407 */   GIM_Try, /*On fail goto*//*Label 23433*/ GIMT_Encode4(1712493), // Rule ID 10338 //
     /* 1712412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1712423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1712426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1712429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1712432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712458 */     // MIs[0] policy
     /* 1712458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712492 */     // GIR_Coverage, 10338,
     /* 1712492 */     GIR_EraseRootFromParent_Done,
     /* 1712493 */   // Label 23433: @1712493
     /* 1712493 */   GIM_Try, /*On fail goto*//*Label 23434*/ GIMT_Encode4(1712579), // Rule ID 10339 //
     /* 1712498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1712509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1712512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1712515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1712518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712544 */     // MIs[0] policy
     /* 1712544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712554 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712578 */     // GIR_Coverage, 10339,
     /* 1712578 */     GIR_EraseRootFromParent_Done,
     /* 1712579 */   // Label 23434: @1712579
     /* 1712579 */   GIM_Try, /*On fail goto*//*Label 23435*/ GIMT_Encode4(1712665), // Rule ID 10342 //
     /* 1712584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1712595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1712598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1712601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1712604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712630 */     // MIs[0] policy
     /* 1712630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712664 */     // GIR_Coverage, 10342,
     /* 1712664 */     GIR_EraseRootFromParent_Done,
     /* 1712665 */   // Label 23435: @1712665
     /* 1712665 */   GIM_Try, /*On fail goto*//*Label 23436*/ GIMT_Encode4(1712751), // Rule ID 10343 //
     /* 1712670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1712681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1712684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1712687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1712690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712716 */     // MIs[0] policy
     /* 1712716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712726 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712750 */     // GIR_Coverage, 10343,
     /* 1712750 */     GIR_EraseRootFromParent_Done,
     /* 1712751 */   // Label 23436: @1712751
     /* 1712751 */   GIM_Try, /*On fail goto*//*Label 23437*/ GIMT_Encode4(1712837), // Rule ID 10346 //
     /* 1712756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1712759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1712767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1712770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1712773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1712776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712802 */     // MIs[0] policy
     /* 1712802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1712815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712836 */     // GIR_Coverage, 10346,
     /* 1712836 */     GIR_EraseRootFromParent_Done,
     /* 1712837 */   // Label 23437: @1712837
     /* 1712837 */   GIM_Try, /*On fail goto*//*Label 23438*/ GIMT_Encode4(1712923), // Rule ID 10347 //
     /* 1712842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1712845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1712853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1712856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1712859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1712862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712888 */     // MIs[0] policy
     /* 1712888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712898 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1712901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712922 */     // GIR_Coverage, 10347,
     /* 1712922 */     GIR_EraseRootFromParent_Done,
     /* 1712923 */   // Label 23438: @1712923
     /* 1712923 */   GIM_Try, /*On fail goto*//*Label 23439*/ GIMT_Encode4(1713009), // Rule ID 10350 //
     /* 1712928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1712931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1712939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1712942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1712945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1712948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712974 */     // MIs[0] policy
     /* 1712974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712984 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713008 */     // GIR_Coverage, 10350,
     /* 1713008 */     GIR_EraseRootFromParent_Done,
     /* 1713009 */   // Label 23439: @1713009
     /* 1713009 */   GIM_Try, /*On fail goto*//*Label 23440*/ GIMT_Encode4(1713095), // Rule ID 10351 //
     /* 1713014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1713017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1713025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1713028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1713031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1713034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1713044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713060 */     // MIs[0] policy
     /* 1713060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713070 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1713073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713094 */     // GIR_Coverage, 10351,
     /* 1713094 */     GIR_EraseRootFromParent_Done,
     /* 1713095 */   // Label 23440: @1713095
     /* 1713095 */   GIM_Try, /*On fail goto*//*Label 23441*/ GIMT_Encode4(1713181), // Rule ID 10354 //
     /* 1713100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1713103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1713111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1713114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1713117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1713120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713146 */     // MIs[0] policy
     /* 1713146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713156 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1713159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713180 */     // GIR_Coverage, 10354,
     /* 1713180 */     GIR_EraseRootFromParent_Done,
     /* 1713181 */   // Label 23441: @1713181
     /* 1713181 */   GIM_Try, /*On fail goto*//*Label 23442*/ GIMT_Encode4(1713267), // Rule ID 10355 //
     /* 1713186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1713189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1713197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1713200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1713203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1713206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713232 */     // MIs[0] policy
     /* 1713232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713242 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1713245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713266 */     // GIR_Coverage, 10355,
     /* 1713266 */     GIR_EraseRootFromParent_Done,
     /* 1713267 */   // Label 23442: @1713267
     /* 1713267 */   GIM_Try, /*On fail goto*//*Label 23443*/ GIMT_Encode4(1713353), // Rule ID 10358 //
     /* 1713272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1713283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1713286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1713289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713318 */     // MIs[0] policy
     /* 1713318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713328 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1713331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713352 */     // GIR_Coverage, 10358,
     /* 1713352 */     GIR_EraseRootFromParent_Done,
     /* 1713353 */   // Label 23443: @1713353
     /* 1713353 */   GIM_Try, /*On fail goto*//*Label 23444*/ GIMT_Encode4(1713439), // Rule ID 10359 //
     /* 1713358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1713369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1713372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1713375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713404 */     // MIs[0] policy
     /* 1713404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713414 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1713417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713438 */     // GIR_Coverage, 10359,
     /* 1713438 */     GIR_EraseRootFromParent_Done,
     /* 1713439 */   // Label 23444: @1713439
     /* 1713439 */   GIM_Try, /*On fail goto*//*Label 23445*/ GIMT_Encode4(1713525), // Rule ID 10362 //
     /* 1713444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1713455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1713458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1713461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713490 */     // MIs[0] policy
     /* 1713490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713500 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713524 */     // GIR_Coverage, 10362,
     /* 1713524 */     GIR_EraseRootFromParent_Done,
     /* 1713525 */   // Label 23445: @1713525
     /* 1713525 */   GIM_Try, /*On fail goto*//*Label 23446*/ GIMT_Encode4(1713611), // Rule ID 10363 //
     /* 1713530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1713541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1713544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1713547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713576 */     // MIs[0] policy
     /* 1713576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713586 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713610 */     // GIR_Coverage, 10363,
     /* 1713610 */     GIR_EraseRootFromParent_Done,
     /* 1713611 */   // Label 23446: @1713611
     /* 1713611 */   GIM_Try, /*On fail goto*//*Label 23447*/ GIMT_Encode4(1713697), // Rule ID 10366 //
     /* 1713616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1713627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1713630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1713633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713662 */     // MIs[0] policy
     /* 1713662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713672 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713696 */     // GIR_Coverage, 10366,
     /* 1713696 */     GIR_EraseRootFromParent_Done,
     /* 1713697 */   // Label 23447: @1713697
     /* 1713697 */   GIM_Try, /*On fail goto*//*Label 23448*/ GIMT_Encode4(1713783), // Rule ID 10367 //
     /* 1713702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1713713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1713716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1713719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713748 */     // MIs[0] policy
     /* 1713748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713758 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713782 */     // GIR_Coverage, 10367,
     /* 1713782 */     GIR_EraseRootFromParent_Done,
     /* 1713783 */   // Label 23448: @1713783
     /* 1713783 */   GIM_Try, /*On fail goto*//*Label 23449*/ GIMT_Encode4(1713869), // Rule ID 10370 //
     /* 1713788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1713799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1713802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1713805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713834 */     // MIs[0] policy
     /* 1713834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713844 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713868 */     // GIR_Coverage, 10370,
     /* 1713868 */     GIR_EraseRootFromParent_Done,
     /* 1713869 */   // Label 23449: @1713869
     /* 1713869 */   GIM_Try, /*On fail goto*//*Label 23450*/ GIMT_Encode4(1713955), // Rule ID 10371 //
     /* 1713874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1713885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1713888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1713891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713920 */     // MIs[0] policy
     /* 1713920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713930 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713954 */     // GIR_Coverage, 10371,
     /* 1713954 */     GIR_EraseRootFromParent_Done,
     /* 1713955 */   // Label 23450: @1713955
     /* 1713955 */   GIM_Try, /*On fail goto*//*Label 23451*/ GIMT_Encode4(1714041), // Rule ID 10374 //
     /* 1713960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1713971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1713974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1713977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714006 */     // MIs[0] policy
     /* 1714006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714016 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1714019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714040 */     // GIR_Coverage, 10374,
     /* 1714040 */     GIR_EraseRootFromParent_Done,
     /* 1714041 */   // Label 23451: @1714041
     /* 1714041 */   GIM_Try, /*On fail goto*//*Label 23452*/ GIMT_Encode4(1714127), // Rule ID 10375 //
     /* 1714046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1714057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1714060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1714063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714092 */     // MIs[0] policy
     /* 1714092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714102 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1714105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714126 */     // GIR_Coverage, 10375,
     /* 1714126 */     GIR_EraseRootFromParent_Done,
     /* 1714127 */   // Label 23452: @1714127
     /* 1714127 */   GIM_Try, /*On fail goto*//*Label 23453*/ GIMT_Encode4(1714213), // Rule ID 10378 //
     /* 1714132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1714143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1714146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1714149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714178 */     // MIs[0] policy
     /* 1714178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714188 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1714191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714212 */     // GIR_Coverage, 10378,
     /* 1714212 */     GIR_EraseRootFromParent_Done,
     /* 1714213 */   // Label 23453: @1714213
     /* 1714213 */   GIM_Try, /*On fail goto*//*Label 23454*/ GIMT_Encode4(1714299), // Rule ID 10379 //
     /* 1714218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1714229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1714232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1714235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714264 */     // MIs[0] policy
     /* 1714264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714274 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1714277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714298 */     // GIR_Coverage, 10379,
     /* 1714298 */     GIR_EraseRootFromParent_Done,
     /* 1714299 */   // Label 23454: @1714299
     /* 1714299 */   GIM_Try, /*On fail goto*//*Label 23455*/ GIMT_Encode4(1714385), // Rule ID 10382 //
     /* 1714304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1714315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1714318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1714321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1714327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714350 */     // MIs[0] policy
     /* 1714350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714384 */     // GIR_Coverage, 10382,
     /* 1714384 */     GIR_EraseRootFromParent_Done,
     /* 1714385 */   // Label 23455: @1714385
     /* 1714385 */   GIM_Try, /*On fail goto*//*Label 23456*/ GIMT_Encode4(1714471), // Rule ID 10383 //
     /* 1714390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1714401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1714404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1714407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1714413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714436 */     // MIs[0] policy
     /* 1714436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714446 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714470 */     // GIR_Coverage, 10383,
     /* 1714470 */     GIR_EraseRootFromParent_Done,
     /* 1714471 */   // Label 23456: @1714471
     /* 1714471 */   GIM_Try, /*On fail goto*//*Label 23457*/ GIMT_Encode4(1714557), // Rule ID 10386 //
     /* 1714476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1714487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1714490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1714493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714522 */     // MIs[0] policy
     /* 1714522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714556 */     // GIR_Coverage, 10386,
     /* 1714556 */     GIR_EraseRootFromParent_Done,
     /* 1714557 */   // Label 23457: @1714557
     /* 1714557 */   GIM_Try, /*On fail goto*//*Label 23458*/ GIMT_Encode4(1714643), // Rule ID 10387 //
     /* 1714562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1714573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1714576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1714579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714608 */     // MIs[0] policy
     /* 1714608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714618 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714642 */     // GIR_Coverage, 10387,
     /* 1714642 */     GIR_EraseRootFromParent_Done,
     /* 1714643 */   // Label 23458: @1714643
     /* 1714643 */   GIM_Try, /*On fail goto*//*Label 23459*/ GIMT_Encode4(1714729), // Rule ID 10390 //
     /* 1714648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1714659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1714662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1714665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714694 */     // MIs[0] policy
     /* 1714694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714728 */     // GIR_Coverage, 10390,
     /* 1714728 */     GIR_EraseRootFromParent_Done,
     /* 1714729 */   // Label 23459: @1714729
     /* 1714729 */   GIM_Try, /*On fail goto*//*Label 23460*/ GIMT_Encode4(1714815), // Rule ID 10391 //
     /* 1714734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1714745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1714748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1714751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714780 */     // MIs[0] policy
     /* 1714780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714814 */     // GIR_Coverage, 10391,
     /* 1714814 */     GIR_EraseRootFromParent_Done,
     /* 1714815 */   // Label 23460: @1714815
     /* 1714815 */   GIM_Try, /*On fail goto*//*Label 23461*/ GIMT_Encode4(1714901), // Rule ID 10394 //
     /* 1714820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1714823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1714831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1714834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1714837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714866 */     // MIs[0] policy
     /* 1714866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714900 */     // GIR_Coverage, 10394,
     /* 1714900 */     GIR_EraseRootFromParent_Done,
     /* 1714901 */   // Label 23461: @1714901
     /* 1714901 */   GIM_Try, /*On fail goto*//*Label 23462*/ GIMT_Encode4(1714987), // Rule ID 10395 //
     /* 1714906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1714909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1714917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1714920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1714923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714952 */     // MIs[0] policy
     /* 1714952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714962 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714986 */     // GIR_Coverage, 10395,
     /* 1714986 */     GIR_EraseRootFromParent_Done,
     /* 1714987 */   // Label 23462: @1714987
     /* 1714987 */   GIM_Try, /*On fail goto*//*Label 23463*/ GIMT_Encode4(1715073), // Rule ID 10398 //
     /* 1714992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1715003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1715006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1715009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715038 */     // MIs[0] policy
     /* 1715038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715048 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715072 */     // GIR_Coverage, 10398,
     /* 1715072 */     GIR_EraseRootFromParent_Done,
     /* 1715073 */   // Label 23463: @1715073
     /* 1715073 */   GIM_Try, /*On fail goto*//*Label 23464*/ GIMT_Encode4(1715159), // Rule ID 10399 //
     /* 1715078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1715089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1715092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1715095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715124 */     // MIs[0] policy
     /* 1715124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715134 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715158 */     // GIR_Coverage, 10399,
     /* 1715158 */     GIR_EraseRootFromParent_Done,
     /* 1715159 */   // Label 23464: @1715159
     /* 1715159 */   GIM_Try, /*On fail goto*//*Label 23465*/ GIMT_Encode4(1715245), // Rule ID 10402 //
     /* 1715164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1715175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1715178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1715181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715210 */     // MIs[0] policy
     /* 1715210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715220 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715244 */     // GIR_Coverage, 10402,
     /* 1715244 */     GIR_EraseRootFromParent_Done,
     /* 1715245 */   // Label 23465: @1715245
     /* 1715245 */   GIM_Try, /*On fail goto*//*Label 23466*/ GIMT_Encode4(1715331), // Rule ID 10403 //
     /* 1715250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1715261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1715264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1715267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715296 */     // MIs[0] policy
     /* 1715296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715306 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715330 */     // GIR_Coverage, 10403,
     /* 1715330 */     GIR_EraseRootFromParent_Done,
     /* 1715331 */   // Label 23466: @1715331
     /* 1715331 */   GIM_Try, /*On fail goto*//*Label 23467*/ GIMT_Encode4(1715417), // Rule ID 10406 //
     /* 1715336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1715347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1715350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1715353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1715359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715382 */     // MIs[0] policy
     /* 1715382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715392 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715416 */     // GIR_Coverage, 10406,
     /* 1715416 */     GIR_EraseRootFromParent_Done,
     /* 1715417 */   // Label 23467: @1715417
     /* 1715417 */   GIM_Try, /*On fail goto*//*Label 23468*/ GIMT_Encode4(1715503), // Rule ID 10407 //
     /* 1715422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1715433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1715436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1715439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1715445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715468 */     // MIs[0] policy
     /* 1715468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715478 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715502 */     // GIR_Coverage, 10407,
     /* 1715502 */     GIR_EraseRootFromParent_Done,
     /* 1715503 */   // Label 23468: @1715503
     /* 1715503 */   GIM_Try, /*On fail goto*//*Label 23469*/ GIMT_Encode4(1715589), // Rule ID 10410 //
     /* 1715508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1715519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1715522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1715525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715554 */     // MIs[0] policy
     /* 1715554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715588 */     // GIR_Coverage, 10410,
     /* 1715588 */     GIR_EraseRootFromParent_Done,
     /* 1715589 */   // Label 23469: @1715589
     /* 1715589 */   GIM_Try, /*On fail goto*//*Label 23470*/ GIMT_Encode4(1715675), // Rule ID 10411 //
     /* 1715594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1715605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1715608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1715611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715640 */     // MIs[0] policy
     /* 1715640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715674 */     // GIR_Coverage, 10411,
     /* 1715674 */     GIR_EraseRootFromParent_Done,
     /* 1715675 */   // Label 23470: @1715675
     /* 1715675 */   GIM_Try, /*On fail goto*//*Label 23471*/ GIMT_Encode4(1715761), // Rule ID 10414 //
     /* 1715680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1715691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1715694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1715697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715726 */     // MIs[0] policy
     /* 1715726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715736 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715760 */     // GIR_Coverage, 10414,
     /* 1715760 */     GIR_EraseRootFromParent_Done,
     /* 1715761 */   // Label 23471: @1715761
     /* 1715761 */   GIM_Try, /*On fail goto*//*Label 23472*/ GIMT_Encode4(1715847), // Rule ID 10415 //
     /* 1715766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1715777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1715780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1715783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715812 */     // MIs[0] policy
     /* 1715812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715822 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715846 */     // GIR_Coverage, 10415,
     /* 1715846 */     GIR_EraseRootFromParent_Done,
     /* 1715847 */   // Label 23472: @1715847
     /* 1715847 */   GIM_Try, /*On fail goto*//*Label 23473*/ GIMT_Encode4(1715933), // Rule ID 10418 //
     /* 1715852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1715863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1715866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1715869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715898 */     // MIs[0] policy
     /* 1715898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715908 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715932 */     // GIR_Coverage, 10418,
     /* 1715932 */     GIR_EraseRootFromParent_Done,
     /* 1715933 */   // Label 23473: @1715933
     /* 1715933 */   GIM_Try, /*On fail goto*//*Label 23474*/ GIMT_Encode4(1716019), // Rule ID 10419 //
     /* 1715938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1715949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1715952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1715955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715984 */     // MIs[0] policy
     /* 1715984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715994 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716018 */     // GIR_Coverage, 10419,
     /* 1716018 */     GIR_EraseRootFromParent_Done,
     /* 1716019 */   // Label 23474: @1716019
     /* 1716019 */   GIM_Try, /*On fail goto*//*Label 23475*/ GIMT_Encode4(1716105), // Rule ID 10422 //
     /* 1716024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1716035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1716038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1716041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716070 */     // MIs[0] policy
     /* 1716070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716080 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1716083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716104 */     // GIR_Coverage, 10422,
     /* 1716104 */     GIR_EraseRootFromParent_Done,
     /* 1716105 */   // Label 23475: @1716105
     /* 1716105 */   GIM_Try, /*On fail goto*//*Label 23476*/ GIMT_Encode4(1716191), // Rule ID 10423 //
     /* 1716110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1716121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1716124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1716127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716156 */     // MIs[0] policy
     /* 1716156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1716169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716190 */     // GIR_Coverage, 10423,
     /* 1716190 */     GIR_EraseRootFromParent_Done,
     /* 1716191 */   // Label 23476: @1716191
     /* 1716191 */   GIM_Try, /*On fail goto*//*Label 23477*/ GIMT_Encode4(1716277), // Rule ID 10426 //
     /* 1716196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1716207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1716210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1716213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716242 */     // MIs[0] policy
     /* 1716242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716252 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1716255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716276 */     // GIR_Coverage, 10426,
     /* 1716276 */     GIR_EraseRootFromParent_Done,
     /* 1716277 */   // Label 23477: @1716277
     /* 1716277 */   GIM_Try, /*On fail goto*//*Label 23478*/ GIMT_Encode4(1716363), // Rule ID 10427 //
     /* 1716282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1716293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1716296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1716299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716328 */     // MIs[0] policy
     /* 1716328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716338 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1716341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716362 */     // GIR_Coverage, 10427,
     /* 1716362 */     GIR_EraseRootFromParent_Done,
     /* 1716363 */   // Label 23478: @1716363
     /* 1716363 */   GIM_Try, /*On fail goto*//*Label 23479*/ GIMT_Encode4(1716449), // Rule ID 10430 //
     /* 1716368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1716379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1716382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1716385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716414 */     // MIs[0] policy
     /* 1716414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716424 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1716427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716448 */     // GIR_Coverage, 10430,
     /* 1716448 */     GIR_EraseRootFromParent_Done,
     /* 1716449 */   // Label 23479: @1716449
     /* 1716449 */   GIM_Try, /*On fail goto*//*Label 23480*/ GIMT_Encode4(1716535), // Rule ID 10431 //
     /* 1716454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1716465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1716468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1716471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716500 */     // MIs[0] policy
     /* 1716500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716510 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1716513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716534 */     // GIR_Coverage, 10431,
     /* 1716534 */     GIR_EraseRootFromParent_Done,
     /* 1716535 */   // Label 23480: @1716535
     /* 1716535 */   GIM_Try, /*On fail goto*//*Label 23481*/ GIMT_Encode4(1716621), // Rule ID 10434 //
     /* 1716540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1716551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1716554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1716557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716586 */     // MIs[0] policy
     /* 1716586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1716599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716620 */     // GIR_Coverage, 10434,
     /* 1716620 */     GIR_EraseRootFromParent_Done,
     /* 1716621 */   // Label 23481: @1716621
     /* 1716621 */   GIM_Try, /*On fail goto*//*Label 23482*/ GIMT_Encode4(1716707), // Rule ID 10435 //
     /* 1716626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1716637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1716640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1716643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716672 */     // MIs[0] policy
     /* 1716672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716682 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1716685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716706 */     // GIR_Coverage, 10435,
     /* 1716706 */     GIR_EraseRootFromParent_Done,
     /* 1716707 */   // Label 23482: @1716707
     /* 1716707 */   GIM_Try, /*On fail goto*//*Label 23483*/ GIMT_Encode4(1716793), // Rule ID 10438 //
     /* 1716712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1716723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1716726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1716729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716758 */     // MIs[0] policy
     /* 1716758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716768 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1716771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716792 */     // GIR_Coverage, 10438,
     /* 1716792 */     GIR_EraseRootFromParent_Done,
     /* 1716793 */   // Label 23483: @1716793
     /* 1716793 */   GIM_Try, /*On fail goto*//*Label 23484*/ GIMT_Encode4(1716879), // Rule ID 10439 //
     /* 1716798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1716809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1716812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1716815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716844 */     // MIs[0] policy
     /* 1716844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716854 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1716857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716878 */     // GIR_Coverage, 10439,
     /* 1716878 */     GIR_EraseRootFromParent_Done,
     /* 1716879 */   // Label 23484: @1716879
     /* 1716879 */   GIM_Try, /*On fail goto*//*Label 23485*/ GIMT_Encode4(1716965), // Rule ID 10442 //
     /* 1716884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1716895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1716898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1716901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716930 */     // MIs[0] policy
     /* 1716930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716940 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1716943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716964 */     // GIR_Coverage, 10442,
     /* 1716964 */     GIR_EraseRootFromParent_Done,
     /* 1716965 */   // Label 23485: @1716965
     /* 1716965 */   GIM_Try, /*On fail goto*//*Label 23486*/ GIMT_Encode4(1717051), // Rule ID 10443 //
     /* 1716970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1716981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1716984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1716987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1717000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717016 */     // MIs[0] policy
     /* 1717016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717026 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1717029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1717047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717050 */     // GIR_Coverage, 10443,
     /* 1717050 */     GIR_EraseRootFromParent_Done,
     /* 1717051 */   // Label 23486: @1717051
     /* 1717051 */   GIM_Try, /*On fail goto*//*Label 23487*/ GIMT_Encode4(1717137), // Rule ID 10446 //
     /* 1717056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1717067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1717070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1717073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1717076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717102 */     // MIs[0] policy
     /* 1717102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717112 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1717115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717136 */     // GIR_Coverage, 10446,
     /* 1717136 */     GIR_EraseRootFromParent_Done,
     /* 1717137 */   // Label 23487: @1717137
     /* 1717137 */   GIM_Try, /*On fail goto*//*Label 23488*/ GIMT_Encode4(1717223), // Rule ID 10447 //
     /* 1717142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1717153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1717156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1717159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1717162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717188 */     // MIs[0] policy
     /* 1717188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717198 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1717201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717222 */     // GIR_Coverage, 10447,
     /* 1717222 */     GIR_EraseRootFromParent_Done,
     /* 1717223 */   // Label 23488: @1717223
     /* 1717223 */   GIM_Try, /*On fail goto*//*Label 23489*/ GIMT_Encode4(1717309), // Rule ID 10450 //
     /* 1717228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1717239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1717242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1717245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1717248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717274 */     // MIs[0] policy
     /* 1717274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717284 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1717287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717308 */     // GIR_Coverage, 10450,
     /* 1717308 */     GIR_EraseRootFromParent_Done,
     /* 1717309 */   // Label 23489: @1717309
     /* 1717309 */   GIM_Try, /*On fail goto*//*Label 23490*/ GIMT_Encode4(1717395), // Rule ID 10451 //
     /* 1717314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1717325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1717328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1717331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1717334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717360 */     // MIs[0] policy
     /* 1717360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717370 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1717373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717394 */     // GIR_Coverage, 10451,
     /* 1717394 */     GIR_EraseRootFromParent_Done,
     /* 1717395 */   // Label 23490: @1717395
     /* 1717395 */   GIM_Try, /*On fail goto*//*Label 23491*/ GIMT_Encode4(1717481), // Rule ID 10454 //
     /* 1717400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1717411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1717414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1717417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1717420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717446 */     // MIs[0] policy
     /* 1717446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717456 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717480 */     // GIR_Coverage, 10454,
     /* 1717480 */     GIR_EraseRootFromParent_Done,
     /* 1717481 */   // Label 23491: @1717481
     /* 1717481 */   GIM_Try, /*On fail goto*//*Label 23492*/ GIMT_Encode4(1717567), // Rule ID 10455 //
     /* 1717486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1717497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1717500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1717503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1717506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717532 */     // MIs[0] policy
     /* 1717532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717542 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717566 */     // GIR_Coverage, 10455,
     /* 1717566 */     GIR_EraseRootFromParent_Done,
     /* 1717567 */   // Label 23492: @1717567
     /* 1717567 */   GIM_Try, /*On fail goto*//*Label 23493*/ GIMT_Encode4(1717653), // Rule ID 10458 //
     /* 1717572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1717583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1717586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1717589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1717592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717618 */     // MIs[0] policy
     /* 1717618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717628 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1717631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717652 */     // GIR_Coverage, 10458,
     /* 1717652 */     GIR_EraseRootFromParent_Done,
     /* 1717653 */   // Label 23493: @1717653
     /* 1717653 */   GIM_Try, /*On fail goto*//*Label 23494*/ GIMT_Encode4(1717739), // Rule ID 10459 //
     /* 1717658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1717669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1717672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1717675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1717678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717704 */     // MIs[0] policy
     /* 1717704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717714 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1717717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717738 */     // GIR_Coverage, 10459,
     /* 1717738 */     GIR_EraseRootFromParent_Done,
     /* 1717739 */   // Label 23494: @1717739
     /* 1717739 */   GIM_Try, /*On fail goto*//*Label 23495*/ GIMT_Encode4(1717825), // Rule ID 10462 //
     /* 1717744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1717755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1717758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1717761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1717764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717790 */     // MIs[0] policy
     /* 1717790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717800 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717824 */     // GIR_Coverage, 10462,
     /* 1717824 */     GIR_EraseRootFromParent_Done,
     /* 1717825 */   // Label 23495: @1717825
     /* 1717825 */   GIM_Try, /*On fail goto*//*Label 23496*/ GIMT_Encode4(1717911), // Rule ID 10463 //
     /* 1717830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1717841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1717844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1717847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1717850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717876 */     // MIs[0] policy
     /* 1717876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717886 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717910 */     // GIR_Coverage, 10463,
     /* 1717910 */     GIR_EraseRootFromParent_Done,
     /* 1717911 */   // Label 23496: @1717911
     /* 1717911 */   GIM_Try, /*On fail goto*//*Label 23497*/ GIMT_Encode4(1717997), // Rule ID 10466 //
     /* 1717916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1717927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1717930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1717933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1717936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717962 */     // MIs[0] policy
     /* 1717962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717996 */     // GIR_Coverage, 10466,
     /* 1717996 */     GIR_EraseRootFromParent_Done,
     /* 1717997 */   // Label 23497: @1717997
     /* 1717997 */   GIM_Try, /*On fail goto*//*Label 23498*/ GIMT_Encode4(1718083), // Rule ID 10467 //
     /* 1718002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1718013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1718016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1718019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1718022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718048 */     // MIs[0] policy
     /* 1718048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718058 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1718061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718082 */     // GIR_Coverage, 10467,
     /* 1718082 */     GIR_EraseRootFromParent_Done,
     /* 1718083 */   // Label 23498: @1718083
     /* 1718083 */   GIM_Try, /*On fail goto*//*Label 23499*/ GIMT_Encode4(1718169), // Rule ID 10470 //
     /* 1718088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1718099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1718102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1718105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1718108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718134 */     // MIs[0] policy
     /* 1718134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718168 */     // GIR_Coverage, 10470,
     /* 1718168 */     GIR_EraseRootFromParent_Done,
     /* 1718169 */   // Label 23499: @1718169
     /* 1718169 */   GIM_Try, /*On fail goto*//*Label 23500*/ GIMT_Encode4(1718255), // Rule ID 10471 //
     /* 1718174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1718185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1718188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1718191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1718194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718220 */     // MIs[0] policy
     /* 1718220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718230 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718254 */     // GIR_Coverage, 10471,
     /* 1718254 */     GIR_EraseRootFromParent_Done,
     /* 1718255 */   // Label 23500: @1718255
     /* 1718255 */   GIM_Try, /*On fail goto*//*Label 23501*/ GIMT_Encode4(1718341), // Rule ID 10474 //
     /* 1718260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1718271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1718274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1718277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1718280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718306 */     // MIs[0] policy
     /* 1718306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718340 */     // GIR_Coverage, 10474,
     /* 1718340 */     GIR_EraseRootFromParent_Done,
     /* 1718341 */   // Label 23501: @1718341
     /* 1718341 */   GIM_Try, /*On fail goto*//*Label 23502*/ GIMT_Encode4(1718427), // Rule ID 10475 //
     /* 1718346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1718357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1718360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1718363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1718366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718392 */     // MIs[0] policy
     /* 1718392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718426 */     // GIR_Coverage, 10475,
     /* 1718426 */     GIR_EraseRootFromParent_Done,
     /* 1718427 */   // Label 23502: @1718427
     /* 1718427 */   GIM_Try, /*On fail goto*//*Label 23503*/ GIMT_Encode4(1718513), // Rule ID 10478 //
     /* 1718432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1718443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1718446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1718449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1718452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718478 */     // MIs[0] policy
     /* 1718478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718488 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718512 */     // GIR_Coverage, 10478,
     /* 1718512 */     GIR_EraseRootFromParent_Done,
     /* 1718513 */   // Label 23503: @1718513
     /* 1718513 */   GIM_Try, /*On fail goto*//*Label 23504*/ GIMT_Encode4(1718599), // Rule ID 10479 //
     /* 1718518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1718529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1718532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1718535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1718538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718564 */     // MIs[0] policy
     /* 1718564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718574 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718598 */     // GIR_Coverage, 10479,
     /* 1718598 */     GIR_EraseRootFromParent_Done,
     /* 1718599 */   // Label 23504: @1718599
     /* 1718599 */   GIM_Try, /*On fail goto*//*Label 23505*/ GIMT_Encode4(1718685), // Rule ID 10482 //
     /* 1718604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1718607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1718615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1718618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1718621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1718624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718650 */     // MIs[0] policy
     /* 1718650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718684 */     // GIR_Coverage, 10482,
     /* 1718684 */     GIR_EraseRootFromParent_Done,
     /* 1718685 */   // Label 23505: @1718685
     /* 1718685 */   GIM_Try, /*On fail goto*//*Label 23506*/ GIMT_Encode4(1718771), // Rule ID 10483 //
     /* 1718690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1718693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1718701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1718704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1718707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1718710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718736 */     // MIs[0] policy
     /* 1718736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718770 */     // GIR_Coverage, 10483,
     /* 1718770 */     GIR_EraseRootFromParent_Done,
     /* 1718771 */   // Label 23506: @1718771
     /* 1718771 */   GIM_Try, /*On fail goto*//*Label 23507*/ GIMT_Encode4(1718857), // Rule ID 10486 //
     /* 1718776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1718787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1718790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1718793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1718796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1718799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718822 */     // MIs[0] policy
     /* 1718822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718832 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1718835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718856 */     // GIR_Coverage, 10486,
     /* 1718856 */     GIR_EraseRootFromParent_Done,
     /* 1718857 */   // Label 23507: @1718857
     /* 1718857 */   GIM_Try, /*On fail goto*//*Label 23508*/ GIMT_Encode4(1718943), // Rule ID 10487 //
     /* 1718862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1718873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1718876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1718879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1718882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1718885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718908 */     // MIs[0] policy
     /* 1718908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718918 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1718921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718942 */     // GIR_Coverage, 10487,
     /* 1718942 */     GIR_EraseRootFromParent_Done,
     /* 1718943 */   // Label 23508: @1718943
     /* 1718943 */   GIM_Try, /*On fail goto*//*Label 23509*/ GIMT_Encode4(1719029), // Rule ID 10490 //
     /* 1718948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1718959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1718962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1718965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1718968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1718971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1718978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718994 */     // MIs[0] policy
     /* 1718994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719004 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719028 */     // GIR_Coverage, 10490,
     /* 1719028 */     GIR_EraseRootFromParent_Done,
     /* 1719029 */   // Label 23509: @1719029
     /* 1719029 */   GIM_Try, /*On fail goto*//*Label 23510*/ GIMT_Encode4(1719115), // Rule ID 10491 //
     /* 1719034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1719045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1719048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1719051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1719054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719080 */     // MIs[0] policy
     /* 1719080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719090 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719114 */     // GIR_Coverage, 10491,
     /* 1719114 */     GIR_EraseRootFromParent_Done,
     /* 1719115 */   // Label 23510: @1719115
     /* 1719115 */   GIM_Try, /*On fail goto*//*Label 23511*/ GIMT_Encode4(1719201), // Rule ID 10494 //
     /* 1719120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1719131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1719134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1719137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1719140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1719143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719166 */     // MIs[0] policy
     /* 1719166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719176 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719200 */     // GIR_Coverage, 10494,
     /* 1719200 */     GIR_EraseRootFromParent_Done,
     /* 1719201 */   // Label 23511: @1719201
     /* 1719201 */   GIM_Try, /*On fail goto*//*Label 23512*/ GIMT_Encode4(1719287), // Rule ID 10495 //
     /* 1719206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1719217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1719220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1719223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1719226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1719229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719252 */     // MIs[0] policy
     /* 1719252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719262 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719286 */     // GIR_Coverage, 10495,
     /* 1719286 */     GIR_EraseRootFromParent_Done,
     /* 1719287 */   // Label 23512: @1719287
     /* 1719287 */   GIM_Try, /*On fail goto*//*Label 23513*/ GIMT_Encode4(1719373), // Rule ID 10498 //
     /* 1719292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1719303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1719306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1719309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1719312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719338 */     // MIs[0] policy
     /* 1719338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719372 */     // GIR_Coverage, 10498,
     /* 1719372 */     GIR_EraseRootFromParent_Done,
     /* 1719373 */   // Label 23513: @1719373
     /* 1719373 */   GIM_Try, /*On fail goto*//*Label 23514*/ GIMT_Encode4(1719459), // Rule ID 10499 //
     /* 1719378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1719389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1719392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1719395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1719398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719424 */     // MIs[0] policy
     /* 1719424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719434 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719458 */     // GIR_Coverage, 10499,
     /* 1719458 */     GIR_EraseRootFromParent_Done,
     /* 1719459 */   // Label 23514: @1719459
     /* 1719459 */   GIM_Try, /*On fail goto*//*Label 23515*/ GIMT_Encode4(1719545), // Rule ID 10502 //
     /* 1719464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1719475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1719478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1719481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1719484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719510 */     // MIs[0] policy
     /* 1719510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719520 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719544 */     // GIR_Coverage, 10502,
     /* 1719544 */     GIR_EraseRootFromParent_Done,
     /* 1719545 */   // Label 23515: @1719545
     /* 1719545 */   GIM_Try, /*On fail goto*//*Label 23516*/ GIMT_Encode4(1719631), // Rule ID 10503 //
     /* 1719550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1719561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1719564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1719567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1719570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719596 */     // MIs[0] policy
     /* 1719596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719606 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719630 */     // GIR_Coverage, 10503,
     /* 1719630 */     GIR_EraseRootFromParent_Done,
     /* 1719631 */   // Label 23516: @1719631
     /* 1719631 */   GIM_Try, /*On fail goto*//*Label 23517*/ GIMT_Encode4(1719717), // Rule ID 10506 //
     /* 1719636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1719647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1719650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1719653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1719656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719682 */     // MIs[0] policy
     /* 1719682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719692 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719716 */     // GIR_Coverage, 10506,
     /* 1719716 */     GIR_EraseRootFromParent_Done,
     /* 1719717 */   // Label 23517: @1719717
     /* 1719717 */   GIM_Try, /*On fail goto*//*Label 23518*/ GIMT_Encode4(1719803), // Rule ID 10507 //
     /* 1719722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1719733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1719736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1719739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1719742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719768 */     // MIs[0] policy
     /* 1719768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719778 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719802 */     // GIR_Coverage, 10507,
     /* 1719802 */     GIR_EraseRootFromParent_Done,
     /* 1719803 */   // Label 23518: @1719803
     /* 1719803 */   GIM_Try, /*On fail goto*//*Label 23519*/ GIMT_Encode4(1719889), // Rule ID 10510 //
     /* 1719808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1719819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1719822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1719825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1719828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719854 */     // MIs[0] policy
     /* 1719854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719888 */     // GIR_Coverage, 10510,
     /* 1719888 */     GIR_EraseRootFromParent_Done,
     /* 1719889 */   // Label 23519: @1719889
     /* 1719889 */   GIM_Try, /*On fail goto*//*Label 23520*/ GIMT_Encode4(1719975), // Rule ID 10511 //
     /* 1719894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1719905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1719908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1719911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1719914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719940 */     // MIs[0] policy
     /* 1719940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719974 */     // GIR_Coverage, 10511,
     /* 1719974 */     GIR_EraseRootFromParent_Done,
     /* 1719975 */   // Label 23520: @1719975
     /* 1719975 */   GIM_Try, /*On fail goto*//*Label 23521*/ GIMT_Encode4(1720061), // Rule ID 10514 //
     /* 1719980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1719991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1719994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1719997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1720000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720026 */     // MIs[0] policy
     /* 1720026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1720039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720060 */     // GIR_Coverage, 10514,
     /* 1720060 */     GIR_EraseRootFromParent_Done,
     /* 1720061 */   // Label 23521: @1720061
     /* 1720061 */   GIM_Try, /*On fail goto*//*Label 23522*/ GIMT_Encode4(1720147), // Rule ID 10515 //
     /* 1720066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1720077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1720080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1720083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1720086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720112 */     // MIs[0] policy
     /* 1720112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720122 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1720125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720146 */     // GIR_Coverage, 10515,
     /* 1720146 */     GIR_EraseRootFromParent_Done,
     /* 1720147 */   // Label 23522: @1720147
     /* 1720147 */   GIM_Try, /*On fail goto*//*Label 23523*/ GIMT_Encode4(1720233), // Rule ID 10518 //
     /* 1720152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1720163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1720166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1720169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1720172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720198 */     // MIs[0] policy
     /* 1720198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720208 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1720211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720232 */     // GIR_Coverage, 10518,
     /* 1720232 */     GIR_EraseRootFromParent_Done,
     /* 1720233 */   // Label 23523: @1720233
     /* 1720233 */   GIM_Try, /*On fail goto*//*Label 23524*/ GIMT_Encode4(1720319), // Rule ID 10519 //
     /* 1720238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1720249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1720252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1720255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1720258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720284 */     // MIs[0] policy
     /* 1720284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720294 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1720297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720318 */     // GIR_Coverage, 10519,
     /* 1720318 */     GIR_EraseRootFromParent_Done,
     /* 1720319 */   // Label 23524: @1720319
     /* 1720319 */   GIM_Try, /*On fail goto*//*Label 23525*/ GIMT_Encode4(1720405), // Rule ID 10522 //
     /* 1720324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1720335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1720338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1720341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1720344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720370 */     // MIs[0] policy
     /* 1720370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720380 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1720383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720404 */     // GIR_Coverage, 10522,
     /* 1720404 */     GIR_EraseRootFromParent_Done,
     /* 1720405 */   // Label 23525: @1720405
     /* 1720405 */   GIM_Try, /*On fail goto*//*Label 23526*/ GIMT_Encode4(1720491), // Rule ID 10523 //
     /* 1720410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1720421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1720424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1720427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1720430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720456 */     // MIs[0] policy
     /* 1720456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720466 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1720469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720490 */     // GIR_Coverage, 10523,
     /* 1720490 */     GIR_EraseRootFromParent_Done,
     /* 1720491 */   // Label 23526: @1720491
     /* 1720491 */   GIM_Try, /*On fail goto*//*Label 23527*/ GIMT_Encode4(1720577), // Rule ID 10526 //
     /* 1720496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1720507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1720510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1720513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1720516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720542 */     // MIs[0] policy
     /* 1720542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720552 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1720555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720576 */     // GIR_Coverage, 10526,
     /* 1720576 */     GIR_EraseRootFromParent_Done,
     /* 1720577 */   // Label 23527: @1720577
     /* 1720577 */   GIM_Try, /*On fail goto*//*Label 23528*/ GIMT_Encode4(1720663), // Rule ID 10527 //
     /* 1720582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1720593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1720596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1720599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1720602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720628 */     // MIs[0] policy
     /* 1720628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720638 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1720641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720662 */     // GIR_Coverage, 10527,
     /* 1720662 */     GIR_EraseRootFromParent_Done,
     /* 1720663 */   // Label 23528: @1720663
     /* 1720663 */   GIM_Try, /*On fail goto*//*Label 23529*/ GIMT_Encode4(1720749), // Rule ID 10530 //
     /* 1720668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1720679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1720682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1720685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1720688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720714 */     // MIs[0] policy
     /* 1720714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720724 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1720727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720748 */     // GIR_Coverage, 10530,
     /* 1720748 */     GIR_EraseRootFromParent_Done,
     /* 1720749 */   // Label 23529: @1720749
     /* 1720749 */   GIM_Try, /*On fail goto*//*Label 23530*/ GIMT_Encode4(1720835), // Rule ID 10531 //
     /* 1720754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1720765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1720768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1720771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1720774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720800 */     // MIs[0] policy
     /* 1720800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720810 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1720813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720834 */     // GIR_Coverage, 10531,
     /* 1720834 */     GIR_EraseRootFromParent_Done,
     /* 1720835 */   // Label 23530: @1720835
     /* 1720835 */   GIM_Try, /*On fail goto*//*Label 23531*/ GIMT_Encode4(1720921), // Rule ID 10534 //
     /* 1720840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1720851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1720854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1720857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720886 */     // MIs[0] policy
     /* 1720886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1720899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720920 */     // GIR_Coverage, 10534,
     /* 1720920 */     GIR_EraseRootFromParent_Done,
     /* 1720921 */   // Label 23531: @1720921
     /* 1720921 */   GIM_Try, /*On fail goto*//*Label 23532*/ GIMT_Encode4(1721007), // Rule ID 10535 //
     /* 1720926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1720937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1720940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1720943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720972 */     // MIs[0] policy
     /* 1720972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720982 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1720985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721006 */     // GIR_Coverage, 10535,
     /* 1721006 */     GIR_EraseRootFromParent_Done,
     /* 1721007 */   // Label 23532: @1721007
     /* 1721007 */   GIM_Try, /*On fail goto*//*Label 23533*/ GIMT_Encode4(1721093), // Rule ID 10538 //
     /* 1721012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1721023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1721026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1721029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721058 */     // MIs[0] policy
     /* 1721058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721068 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1721071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721092 */     // GIR_Coverage, 10538,
     /* 1721092 */     GIR_EraseRootFromParent_Done,
     /* 1721093 */   // Label 23533: @1721093
     /* 1721093 */   GIM_Try, /*On fail goto*//*Label 23534*/ GIMT_Encode4(1721179), // Rule ID 10539 //
     /* 1721098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1721109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1721112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1721115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721144 */     // MIs[0] policy
     /* 1721144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721154 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1721157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721178 */     // GIR_Coverage, 10539,
     /* 1721178 */     GIR_EraseRootFromParent_Done,
     /* 1721179 */   // Label 23534: @1721179
     /* 1721179 */   GIM_Try, /*On fail goto*//*Label 23535*/ GIMT_Encode4(1721265), // Rule ID 10542 //
     /* 1721184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1721195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1721198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1721201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721230 */     // MIs[0] policy
     /* 1721230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721240 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721264 */     // GIR_Coverage, 10542,
     /* 1721264 */     GIR_EraseRootFromParent_Done,
     /* 1721265 */   // Label 23535: @1721265
     /* 1721265 */   GIM_Try, /*On fail goto*//*Label 23536*/ GIMT_Encode4(1721351), // Rule ID 10543 //
     /* 1721270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1721281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1721284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1721287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721316 */     // MIs[0] policy
     /* 1721316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721326 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721350 */     // GIR_Coverage, 10543,
     /* 1721350 */     GIR_EraseRootFromParent_Done,
     /* 1721351 */   // Label 23536: @1721351
     /* 1721351 */   GIM_Try, /*On fail goto*//*Label 23537*/ GIMT_Encode4(1721437), // Rule ID 10546 //
     /* 1721356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1721367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1721370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1721373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721402 */     // MIs[0] policy
     /* 1721402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721412 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1721415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721436 */     // GIR_Coverage, 10546,
     /* 1721436 */     GIR_EraseRootFromParent_Done,
     /* 1721437 */   // Label 23537: @1721437
     /* 1721437 */   GIM_Try, /*On fail goto*//*Label 23538*/ GIMT_Encode4(1721523), // Rule ID 10547 //
     /* 1721442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1721453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1721456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1721459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721488 */     // MIs[0] policy
     /* 1721488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721498 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1721501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721522 */     // GIR_Coverage, 10547,
     /* 1721522 */     GIR_EraseRootFromParent_Done,
     /* 1721523 */   // Label 23538: @1721523
     /* 1721523 */   GIM_Try, /*On fail goto*//*Label 23539*/ GIMT_Encode4(1721609), // Rule ID 10550 //
     /* 1721528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1721539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1721542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1721545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721574 */     // MIs[0] policy
     /* 1721574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721584 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721608 */     // GIR_Coverage, 10550,
     /* 1721608 */     GIR_EraseRootFromParent_Done,
     /* 1721609 */   // Label 23539: @1721609
     /* 1721609 */   GIM_Try, /*On fail goto*//*Label 23540*/ GIMT_Encode4(1721695), // Rule ID 10551 //
     /* 1721614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1721625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1721628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1721631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721660 */     // MIs[0] policy
     /* 1721660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721670 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721694 */     // GIR_Coverage, 10551,
     /* 1721694 */     GIR_EraseRootFromParent_Done,
     /* 1721695 */   // Label 23540: @1721695
     /* 1721695 */   GIM_Try, /*On fail goto*//*Label 23541*/ GIMT_Encode4(1721781), // Rule ID 10554 //
     /* 1721700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1721711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1721714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1721717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721746 */     // MIs[0] policy
     /* 1721746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721756 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721780 */     // GIR_Coverage, 10554,
     /* 1721780 */     GIR_EraseRootFromParent_Done,
     /* 1721781 */   // Label 23541: @1721781
     /* 1721781 */   GIM_Try, /*On fail goto*//*Label 23542*/ GIMT_Encode4(1721867), // Rule ID 10555 //
     /* 1721786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1721797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1721800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1721803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721832 */     // MIs[0] policy
     /* 1721832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721842 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721866 */     // GIR_Coverage, 10555,
     /* 1721866 */     GIR_EraseRootFromParent_Done,
     /* 1721867 */   // Label 23542: @1721867
     /* 1721867 */   GIM_Try, /*On fail goto*//*Label 23543*/ GIMT_Encode4(1721953), // Rule ID 10558 //
     /* 1721872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1721883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1721886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1721889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721918 */     // MIs[0] policy
     /* 1721918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721928 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721952 */     // GIR_Coverage, 10558,
     /* 1721952 */     GIR_EraseRootFromParent_Done,
     /* 1721953 */   // Label 23543: @1721953
     /* 1721953 */   GIM_Try, /*On fail goto*//*Label 23544*/ GIMT_Encode4(1722039), // Rule ID 10559 //
     /* 1721958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1721969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1721972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1721975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722004 */     // MIs[0] policy
     /* 1722004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722014 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722038 */     // GIR_Coverage, 10559,
     /* 1722038 */     GIR_EraseRootFromParent_Done,
     /* 1722039 */   // Label 23544: @1722039
     /* 1722039 */   GIM_Try, /*On fail goto*//*Label 23545*/ GIMT_Encode4(1722125), // Rule ID 10562 //
     /* 1722044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1722055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1722058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1722061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1722067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722090 */     // MIs[0] policy
     /* 1722090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722124 */     // GIR_Coverage, 10562,
     /* 1722124 */     GIR_EraseRootFromParent_Done,
     /* 1722125 */   // Label 23545: @1722125
     /* 1722125 */   GIM_Try, /*On fail goto*//*Label 23546*/ GIMT_Encode4(1722211), // Rule ID 10563 //
     /* 1722130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1722141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1722144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1722147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1722153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722176 */     // MIs[0] policy
     /* 1722176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722186 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722210 */     // GIR_Coverage, 10563,
     /* 1722210 */     GIR_EraseRootFromParent_Done,
     /* 1722211 */   // Label 23546: @1722211
     /* 1722211 */   GIM_Try, /*On fail goto*//*Label 23547*/ GIMT_Encode4(1722297), // Rule ID 10566 //
     /* 1722216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1722227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1722230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1722233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722262 */     // MIs[0] policy
     /* 1722262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1722293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722296 */     // GIR_Coverage, 10566,
     /* 1722296 */     GIR_EraseRootFromParent_Done,
     /* 1722297 */   // Label 23547: @1722297
     /* 1722297 */   GIM_Try, /*On fail goto*//*Label 23548*/ GIMT_Encode4(1722383), // Rule ID 10567 //
     /* 1722302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1722313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1722316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1722319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722348 */     // MIs[0] policy
     /* 1722348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1722379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722382 */     // GIR_Coverage, 10567,
     /* 1722382 */     GIR_EraseRootFromParent_Done,
     /* 1722383 */   // Label 23548: @1722383
     /* 1722383 */   GIM_Try, /*On fail goto*//*Label 23549*/ GIMT_Encode4(1722469), // Rule ID 10570 //
     /* 1722388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1722391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1722399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1722402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1722405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722434 */     // MIs[0] policy
     /* 1722434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722468 */     // GIR_Coverage, 10570,
     /* 1722468 */     GIR_EraseRootFromParent_Done,
     /* 1722469 */   // Label 23549: @1722469
     /* 1722469 */   GIM_Try, /*On fail goto*//*Label 23550*/ GIMT_Encode4(1722555), // Rule ID 10571 //
     /* 1722474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1722477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1722485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1722488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1722491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722520 */     // MIs[0] policy
     /* 1722520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722554 */     // GIR_Coverage, 10571,
     /* 1722554 */     GIR_EraseRootFromParent_Done,
     /* 1722555 */   // Label 23550: @1722555
     /* 1722555 */   GIM_Try, /*On fail goto*//*Label 23551*/ GIMT_Encode4(1722641), // Rule ID 10574 //
     /* 1722560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1722571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1722574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1722577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722606 */     // MIs[0] policy
     /* 1722606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722616 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1722619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722640 */     // GIR_Coverage, 10574,
     /* 1722640 */     GIR_EraseRootFromParent_Done,
     /* 1722641 */   // Label 23551: @1722641
     /* 1722641 */   GIM_Try, /*On fail goto*//*Label 23552*/ GIMT_Encode4(1722727), // Rule ID 10575 //
     /* 1722646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1722657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1722660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1722663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722692 */     // MIs[0] policy
     /* 1722692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722702 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1722705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722726 */     // GIR_Coverage, 10575,
     /* 1722726 */     GIR_EraseRootFromParent_Done,
     /* 1722727 */   // Label 23552: @1722727
     /* 1722727 */   GIM_Try, /*On fail goto*//*Label 23553*/ GIMT_Encode4(1722813), // Rule ID 10578 //
     /* 1722732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1722743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1722746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1722749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1722755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722778 */     // MIs[0] policy
     /* 1722778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722788 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1722791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722812 */     // GIR_Coverage, 10578,
     /* 1722812 */     GIR_EraseRootFromParent_Done,
     /* 1722813 */   // Label 23553: @1722813
     /* 1722813 */   GIM_Try, /*On fail goto*//*Label 23554*/ GIMT_Encode4(1722899), // Rule ID 10579 //
     /* 1722818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1722829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1722832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1722835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1722841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722864 */     // MIs[0] policy
     /* 1722864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722874 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1722877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722898 */     // GIR_Coverage, 10579,
     /* 1722898 */     GIR_EraseRootFromParent_Done,
     /* 1722899 */   // Label 23554: @1722899
     /* 1722899 */   GIM_Try, /*On fail goto*//*Label 23555*/ GIMT_Encode4(1722985), // Rule ID 10582 //
     /* 1722904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1722915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1722918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1722921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1722927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1722934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722950 */     // MIs[0] policy
     /* 1722950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722960 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1722963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722984 */     // GIR_Coverage, 10582,
     /* 1722984 */     GIR_EraseRootFromParent_Done,
     /* 1722985 */   // Label 23555: @1722985
     /* 1722985 */   GIM_Try, /*On fail goto*//*Label 23556*/ GIMT_Encode4(1723071), // Rule ID 10583 //
     /* 1722990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1723001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1723004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1723007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1723013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723036 */     // MIs[0] policy
     /* 1723036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723046 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723070 */     // GIR_Coverage, 10583,
     /* 1723070 */     GIR_EraseRootFromParent_Done,
     /* 1723071 */   // Label 23556: @1723071
     /* 1723071 */   GIM_Try, /*On fail goto*//*Label 23557*/ GIMT_Encode4(1723157), // Rule ID 10586 //
     /* 1723076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1723087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1723090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1723093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723122 */     // MIs[0] policy
     /* 1723122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723132 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723156 */     // GIR_Coverage, 10586,
     /* 1723156 */     GIR_EraseRootFromParent_Done,
     /* 1723157 */   // Label 23557: @1723157
     /* 1723157 */   GIM_Try, /*On fail goto*//*Label 23558*/ GIMT_Encode4(1723243), // Rule ID 10587 //
     /* 1723162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1723173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1723176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1723179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723208 */     // MIs[0] policy
     /* 1723208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723242 */     // GIR_Coverage, 10587,
     /* 1723242 */     GIR_EraseRootFromParent_Done,
     /* 1723243 */   // Label 23558: @1723243
     /* 1723243 */   GIM_Try, /*On fail goto*//*Label 23559*/ GIMT_Encode4(1723329), // Rule ID 10590 //
     /* 1723248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1723259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1723262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1723265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723294 */     // MIs[0] policy
     /* 1723294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723304 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723328 */     // GIR_Coverage, 10590,
     /* 1723328 */     GIR_EraseRootFromParent_Done,
     /* 1723329 */   // Label 23559: @1723329
     /* 1723329 */   GIM_Try, /*On fail goto*//*Label 23560*/ GIMT_Encode4(1723415), // Rule ID 10591 //
     /* 1723334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1723345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1723348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1723351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723380 */     // MIs[0] policy
     /* 1723380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723390 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723414 */     // GIR_Coverage, 10591,
     /* 1723414 */     GIR_EraseRootFromParent_Done,
     /* 1723415 */   // Label 23560: @1723415
     /* 1723415 */   GIM_Try, /*On fail goto*//*Label 23561*/ GIMT_Encode4(1723501), // Rule ID 10594 //
     /* 1723420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1723431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1723434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1723437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723466 */     // MIs[0] policy
     /* 1723466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723476 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723500 */     // GIR_Coverage, 10594,
     /* 1723500 */     GIR_EraseRootFromParent_Done,
     /* 1723501 */   // Label 23561: @1723501
     /* 1723501 */   GIM_Try, /*On fail goto*//*Label 23562*/ GIMT_Encode4(1723587), // Rule ID 10595 //
     /* 1723506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1723517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1723520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1723523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723552 */     // MIs[0] policy
     /* 1723552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723562 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723586 */     // GIR_Coverage, 10595,
     /* 1723586 */     GIR_EraseRootFromParent_Done,
     /* 1723587 */   // Label 23562: @1723587
     /* 1723587 */   GIM_Try, /*On fail goto*//*Label 23563*/ GIMT_Encode4(1723673), // Rule ID 10598 //
     /* 1723592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1723603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1723606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1723609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723638 */     // MIs[0] policy
     /* 1723638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723672 */     // GIR_Coverage, 10598,
     /* 1723672 */     GIR_EraseRootFromParent_Done,
     /* 1723673 */   // Label 23563: @1723673
     /* 1723673 */   GIM_Try, /*On fail goto*//*Label 23564*/ GIMT_Encode4(1723759), // Rule ID 10599 //
     /* 1723678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1723689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1723692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1723695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723724 */     // MIs[0] policy
     /* 1723724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723758 */     // GIR_Coverage, 10599,
     /* 1723758 */     GIR_EraseRootFromParent_Done,
     /* 1723759 */   // Label 23564: @1723759
     /* 1723759 */   GIM_Try, /*On fail goto*//*Label 23565*/ GIMT_Encode4(1723845), // Rule ID 10602 //
     /* 1723764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1723775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1723778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1723781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723810 */     // MIs[0] policy
     /* 1723810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723820 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723844 */     // GIR_Coverage, 10602,
     /* 1723844 */     GIR_EraseRootFromParent_Done,
     /* 1723845 */   // Label 23565: @1723845
     /* 1723845 */   GIM_Try, /*On fail goto*//*Label 23566*/ GIMT_Encode4(1723931), // Rule ID 10603 //
     /* 1723850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1723861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1723864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1723867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723896 */     // MIs[0] policy
     /* 1723896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723906 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723930 */     // GIR_Coverage, 10603,
     /* 1723930 */     GIR_EraseRootFromParent_Done,
     /* 1723931 */   // Label 23566: @1723931
     /* 1723931 */   GIM_Try, /*On fail goto*//*Label 23567*/ GIMT_Encode4(1724017), // Rule ID 10606 //
     /* 1723936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1723947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1723950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1723953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723982 */     // MIs[0] policy
     /* 1723982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723992 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724016 */     // GIR_Coverage, 10606,
     /* 1724016 */     GIR_EraseRootFromParent_Done,
     /* 1724017 */   // Label 23567: @1724017
     /* 1724017 */   GIM_Try, /*On fail goto*//*Label 23568*/ GIMT_Encode4(1724103), // Rule ID 10607 //
     /* 1724022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1724033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1724036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1724039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1724045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724068 */     // MIs[0] policy
     /* 1724068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724078 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1724081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724102 */     // GIR_Coverage, 10607,
     /* 1724102 */     GIR_EraseRootFromParent_Done,
     /* 1724103 */   // Label 23568: @1724103
     /* 1724103 */   GIM_Try, /*On fail goto*//*Label 23569*/ GIMT_Encode4(1724189), // Rule ID 10610 //
     /* 1724108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1724111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1724119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1724122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1724125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724154 */     // MIs[0] policy
     /* 1724154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1724167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724188 */     // GIR_Coverage, 10610,
     /* 1724188 */     GIR_EraseRootFromParent_Done,
     /* 1724189 */   // Label 23569: @1724189
     /* 1724189 */   GIM_Try, /*On fail goto*//*Label 23570*/ GIMT_Encode4(1724275), // Rule ID 10611 //
     /* 1724194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1724197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1724205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1724208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1724211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724240 */     // MIs[0] policy
     /* 1724240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724250 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1724253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724274 */     // GIR_Coverage, 10611,
     /* 1724274 */     GIR_EraseRootFromParent_Done,
     /* 1724275 */   // Label 23570: @1724275
     /* 1724275 */   GIM_Try, /*On fail goto*//*Label 23571*/ GIMT_Encode4(1724361), // Rule ID 10614 //
     /* 1724280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1724283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1724291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1724294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1724297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724326 */     // MIs[0] policy
     /* 1724326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724336 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1724339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724360 */     // GIR_Coverage, 10614,
     /* 1724360 */     GIR_EraseRootFromParent_Done,
     /* 1724361 */   // Label 23571: @1724361
     /* 1724361 */   GIM_Try, /*On fail goto*//*Label 23572*/ GIMT_Encode4(1724447), // Rule ID 10615 //
     /* 1724366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1724369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1724377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1724380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1724383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724412 */     // MIs[0] policy
     /* 1724412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724422 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1724425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724446 */     // GIR_Coverage, 10615,
     /* 1724446 */     GIR_EraseRootFromParent_Done,
     /* 1724447 */   // Label 23572: @1724447
     /* 1724447 */   GIM_Try, /*On fail goto*//*Label 23573*/ GIMT_Encode4(1724533), // Rule ID 10618 //
     /* 1724452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1724455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1724463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1724466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1724469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724498 */     // MIs[0] policy
     /* 1724498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1724511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724532 */     // GIR_Coverage, 10618,
     /* 1724532 */     GIR_EraseRootFromParent_Done,
     /* 1724533 */   // Label 23573: @1724533
     /* 1724533 */   GIM_Try, /*On fail goto*//*Label 23574*/ GIMT_Encode4(1724619), // Rule ID 10619 //
     /* 1724538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1724541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1724549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1724552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1724555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724584 */     // MIs[0] policy
     /* 1724584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724594 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1724597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724618 */     // GIR_Coverage, 10619,
     /* 1724618 */     GIR_EraseRootFromParent_Done,
     /* 1724619 */   // Label 23574: @1724619
     /* 1724619 */   GIM_Try, /*On fail goto*//*Label 23575*/ GIMT_Encode4(1724705), // Rule ID 10622 //
     /* 1724624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1724635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1724638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1724641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1724644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724670 */     // MIs[0] policy
     /* 1724670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724680 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1724683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724704 */     // GIR_Coverage, 10622,
     /* 1724704 */     GIR_EraseRootFromParent_Done,
     /* 1724705 */   // Label 23575: @1724705
     /* 1724705 */   GIM_Try, /*On fail goto*//*Label 23576*/ GIMT_Encode4(1724791), // Rule ID 10623 //
     /* 1724710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1724721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1724724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1724727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1724730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724756 */     // MIs[0] policy
     /* 1724756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724766 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1724769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724790 */     // GIR_Coverage, 10623,
     /* 1724790 */     GIR_EraseRootFromParent_Done,
     /* 1724791 */   // Label 23576: @1724791
     /* 1724791 */   GIM_Try, /*On fail goto*//*Label 23577*/ GIMT_Encode4(1724877), // Rule ID 10626 //
     /* 1724796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1724807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1724810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1724813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1724816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724842 */     // MIs[0] policy
     /* 1724842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724852 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1724855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724876 */     // GIR_Coverage, 10626,
     /* 1724876 */     GIR_EraseRootFromParent_Done,
     /* 1724877 */   // Label 23577: @1724877
     /* 1724877 */   GIM_Try, /*On fail goto*//*Label 23578*/ GIMT_Encode4(1724963), // Rule ID 10627 //
     /* 1724882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1724893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1724896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1724899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1724902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724928 */     // MIs[0] policy
     /* 1724928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724938 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1724941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724962 */     // GIR_Coverage, 10627,
     /* 1724962 */     GIR_EraseRootFromParent_Done,
     /* 1724963 */   // Label 23578: @1724963
     /* 1724963 */   GIM_Try, /*On fail goto*//*Label 23579*/ GIMT_Encode4(1725049), // Rule ID 10630 //
     /* 1724968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1724979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1724982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1724985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1724988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725014 */     // MIs[0] policy
     /* 1725014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725024 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725048 */     // GIR_Coverage, 10630,
     /* 1725048 */     GIR_EraseRootFromParent_Done,
     /* 1725049 */   // Label 23579: @1725049
     /* 1725049 */   GIM_Try, /*On fail goto*//*Label 23580*/ GIMT_Encode4(1725135), // Rule ID 10631 //
     /* 1725054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1725065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1725068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1725071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1725074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725100 */     // MIs[0] policy
     /* 1725100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725110 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725134 */     // GIR_Coverage, 10631,
     /* 1725134 */     GIR_EraseRootFromParent_Done,
     /* 1725135 */   // Label 23580: @1725135
     /* 1725135 */   GIM_Try, /*On fail goto*//*Label 23581*/ GIMT_Encode4(1725221), // Rule ID 10634 //
     /* 1725140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1725151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1725154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1725157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1725160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725186 */     // MIs[0] policy
     /* 1725186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725196 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1725199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725220 */     // GIR_Coverage, 10634,
     /* 1725220 */     GIR_EraseRootFromParent_Done,
     /* 1725221 */   // Label 23581: @1725221
     /* 1725221 */   GIM_Try, /*On fail goto*//*Label 23582*/ GIMT_Encode4(1725307), // Rule ID 10635 //
     /* 1725226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1725237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1725240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1725243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1725246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725272 */     // MIs[0] policy
     /* 1725272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725282 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1725285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725306 */     // GIR_Coverage, 10635,
     /* 1725306 */     GIR_EraseRootFromParent_Done,
     /* 1725307 */   // Label 23582: @1725307
     /* 1725307 */   GIM_Try, /*On fail goto*//*Label 23583*/ GIMT_Encode4(1725393), // Rule ID 10638 //
     /* 1725312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1725323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1725326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1725329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1725332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725358 */     // MIs[0] policy
     /* 1725358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725368 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725392 */     // GIR_Coverage, 10638,
     /* 1725392 */     GIR_EraseRootFromParent_Done,
     /* 1725393 */   // Label 23583: @1725393
     /* 1725393 */   GIM_Try, /*On fail goto*//*Label 23584*/ GIMT_Encode4(1725479), // Rule ID 10639 //
     /* 1725398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1725409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1725412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1725415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1725418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725444 */     // MIs[0] policy
     /* 1725444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725454 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725478 */     // GIR_Coverage, 10639,
     /* 1725478 */     GIR_EraseRootFromParent_Done,
     /* 1725479 */   // Label 23584: @1725479
     /* 1725479 */   GIM_Try, /*On fail goto*//*Label 23585*/ GIMT_Encode4(1725565), // Rule ID 10642 //
     /* 1725484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1725495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1725498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1725501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1725504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725530 */     // MIs[0] policy
     /* 1725530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725540 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725564 */     // GIR_Coverage, 10642,
     /* 1725564 */     GIR_EraseRootFromParent_Done,
     /* 1725565 */   // Label 23585: @1725565
     /* 1725565 */   GIM_Try, /*On fail goto*//*Label 23586*/ GIMT_Encode4(1725651), // Rule ID 10643 //
     /* 1725570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1725581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1725584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1725587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1725590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725616 */     // MIs[0] policy
     /* 1725616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725626 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725650 */     // GIR_Coverage, 10643,
     /* 1725650 */     GIR_EraseRootFromParent_Done,
     /* 1725651 */   // Label 23586: @1725651
     /* 1725651 */   GIM_Try, /*On fail goto*//*Label 23587*/ GIMT_Encode4(1725737), // Rule ID 10646 //
     /* 1725656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1725667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1725670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1725673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1725676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725702 */     // MIs[0] policy
     /* 1725702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725712 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725736 */     // GIR_Coverage, 10646,
     /* 1725736 */     GIR_EraseRootFromParent_Done,
     /* 1725737 */   // Label 23587: @1725737
     /* 1725737 */   GIM_Try, /*On fail goto*//*Label 23588*/ GIMT_Encode4(1725823), // Rule ID 10647 //
     /* 1725742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1725753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1725756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1725759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1725762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725788 */     // MIs[0] policy
     /* 1725788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725798 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725822 */     // GIR_Coverage, 10647,
     /* 1725822 */     GIR_EraseRootFromParent_Done,
     /* 1725823 */   // Label 23588: @1725823
     /* 1725823 */   GIM_Try, /*On fail goto*//*Label 23589*/ GIMT_Encode4(1725909), // Rule ID 10650 //
     /* 1725828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1725839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1725842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1725845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1725848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725874 */     // MIs[0] policy
     /* 1725874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725884 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725908 */     // GIR_Coverage, 10650,
     /* 1725908 */     GIR_EraseRootFromParent_Done,
     /* 1725909 */   // Label 23589: @1725909
     /* 1725909 */   GIM_Try, /*On fail goto*//*Label 23590*/ GIMT_Encode4(1725995), // Rule ID 10651 //
     /* 1725914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1725925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1725928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1725931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1725934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725960 */     // MIs[0] policy
     /* 1725960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725970 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725994 */     // GIR_Coverage, 10651,
     /* 1725994 */     GIR_EraseRootFromParent_Done,
     /* 1725995 */   // Label 23590: @1725995
     /* 1725995 */   GIM_Try, /*On fail goto*//*Label 23591*/ GIMT_Encode4(1726081), // Rule ID 10654 //
     /* 1726000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1726011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1726014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1726017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1726020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1726023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726046 */     // MIs[0] policy
     /* 1726046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726056 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1726059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726080 */     // GIR_Coverage, 10654,
     /* 1726080 */     GIR_EraseRootFromParent_Done,
     /* 1726081 */   // Label 23591: @1726081
     /* 1726081 */   GIM_Try, /*On fail goto*//*Label 23592*/ GIMT_Encode4(1726167), // Rule ID 10655 //
     /* 1726086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1726097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1726100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1726103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1726106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1726109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726132 */     // MIs[0] policy
     /* 1726132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726142 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1726145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726166 */     // GIR_Coverage, 10655,
     /* 1726166 */     GIR_EraseRootFromParent_Done,
     /* 1726167 */   // Label 23592: @1726167
     /* 1726167 */   GIM_Try, /*On fail goto*//*Label 23593*/ GIMT_Encode4(1726253), // Rule ID 10658 //
     /* 1726172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1726175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1726183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1726186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1726189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1726192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726218 */     // MIs[0] policy
     /* 1726218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726228 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1726231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1726249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726252 */     // GIR_Coverage, 10658,
     /* 1726252 */     GIR_EraseRootFromParent_Done,
     /* 1726253 */   // Label 23593: @1726253
     /* 1726253 */   GIM_Try, /*On fail goto*//*Label 23594*/ GIMT_Encode4(1726339), // Rule ID 10659 //
     /* 1726258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1726261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1726269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1726272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1726275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1726278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726304 */     // MIs[0] policy
     /* 1726304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726314 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1726317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1726335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726338 */     // GIR_Coverage, 10659,
     /* 1726338 */     GIR_EraseRootFromParent_Done,
     /* 1726339 */   // Label 23594: @1726339
     /* 1726339 */   GIM_Try, /*On fail goto*//*Label 23595*/ GIMT_Encode4(1726425), // Rule ID 10662 //
     /* 1726344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1726355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1726358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1726361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1726364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726390 */     // MIs[0] policy
     /* 1726390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726400 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726424 */     // GIR_Coverage, 10662,
     /* 1726424 */     GIR_EraseRootFromParent_Done,
     /* 1726425 */   // Label 23595: @1726425
     /* 1726425 */   GIM_Try, /*On fail goto*//*Label 23596*/ GIMT_Encode4(1726511), // Rule ID 10663 //
     /* 1726430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1726441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1726444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1726447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1726450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726476 */     // MIs[0] policy
     /* 1726476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726486 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726510 */     // GIR_Coverage, 10663,
     /* 1726510 */     GIR_EraseRootFromParent_Done,
     /* 1726511 */   // Label 23596: @1726511
     /* 1726511 */   GIM_Try, /*On fail goto*//*Label 23597*/ GIMT_Encode4(1726597), // Rule ID 10666 //
     /* 1726516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1726527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1726530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1726533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1726536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726562 */     // MIs[0] policy
     /* 1726562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726572 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1726575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726596 */     // GIR_Coverage, 10666,
     /* 1726596 */     GIR_EraseRootFromParent_Done,
     /* 1726597 */   // Label 23597: @1726597
     /* 1726597 */   GIM_Try, /*On fail goto*//*Label 23598*/ GIMT_Encode4(1726683), // Rule ID 10667 //
     /* 1726602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1726613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1726616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1726619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1726622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726648 */     // MIs[0] policy
     /* 1726648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726658 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1726661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726682 */     // GIR_Coverage, 10667,
     /* 1726682 */     GIR_EraseRootFromParent_Done,
     /* 1726683 */   // Label 23598: @1726683
     /* 1726683 */   GIM_Try, /*On fail goto*//*Label 23599*/ GIMT_Encode4(1726769), // Rule ID 10670 //
     /* 1726688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1726699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1726702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1726705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1726708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1726711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726734 */     // MIs[0] policy
     /* 1726734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726744 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1726747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726768 */     // GIR_Coverage, 10670,
     /* 1726768 */     GIR_EraseRootFromParent_Done,
     /* 1726769 */   // Label 23599: @1726769
     /* 1726769 */   GIM_Try, /*On fail goto*//*Label 23600*/ GIMT_Encode4(1726855), // Rule ID 10671 //
     /* 1726774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1726785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1726788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1726791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1726794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1726797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726820 */     // MIs[0] policy
     /* 1726820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726830 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1726833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726854 */     // GIR_Coverage, 10671,
     /* 1726854 */     GIR_EraseRootFromParent_Done,
     /* 1726855 */   // Label 23600: @1726855
     /* 1726855 */   GIM_Try, /*On fail goto*//*Label 23601*/ GIMT_Encode4(1726941), // Rule ID 10674 //
     /* 1726860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1726871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1726874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1726877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1726880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726906 */     // MIs[0] policy
     /* 1726906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726940 */     // GIR_Coverage, 10674,
     /* 1726940 */     GIR_EraseRootFromParent_Done,
     /* 1726941 */   // Label 23601: @1726941
     /* 1726941 */   GIM_Try, /*On fail goto*//*Label 23602*/ GIMT_Encode4(1727027), // Rule ID 10675 //
     /* 1726946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1726957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1726960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1726963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1726966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726992 */     // MIs[0] policy
     /* 1726992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727002 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727026 */     // GIR_Coverage, 10675,
     /* 1727026 */     GIR_EraseRootFromParent_Done,
     /* 1727027 */   // Label 23602: @1727027
     /* 1727027 */   GIM_Try, /*On fail goto*//*Label 23603*/ GIMT_Encode4(1727113), // Rule ID 10678 //
     /* 1727032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1727043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1727046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1727049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1727052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727078 */     // MIs[0] policy
     /* 1727078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727088 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727112 */     // GIR_Coverage, 10678,
     /* 1727112 */     GIR_EraseRootFromParent_Done,
     /* 1727113 */   // Label 23603: @1727113
     /* 1727113 */   GIM_Try, /*On fail goto*//*Label 23604*/ GIMT_Encode4(1727199), // Rule ID 10679 //
     /* 1727118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1727129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1727132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1727135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1727138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727164 */     // MIs[0] policy
     /* 1727164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727174 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727198 */     // GIR_Coverage, 10679,
     /* 1727198 */     GIR_EraseRootFromParent_Done,
     /* 1727199 */   // Label 23604: @1727199
     /* 1727199 */   GIM_Try, /*On fail goto*//*Label 23605*/ GIMT_Encode4(1727285), // Rule ID 10682 //
     /* 1727204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1727215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1727218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1727221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1727224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1727227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727250 */     // MIs[0] policy
     /* 1727250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727260 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727284 */     // GIR_Coverage, 10682,
     /* 1727284 */     GIR_EraseRootFromParent_Done,
     /* 1727285 */   // Label 23605: @1727285
     /* 1727285 */   GIM_Try, /*On fail goto*//*Label 23606*/ GIMT_Encode4(1727371), // Rule ID 10683 //
     /* 1727290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1727301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1727304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1727307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1727310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1727313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727336 */     // MIs[0] policy
     /* 1727336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727346 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727370 */     // GIR_Coverage, 10683,
     /* 1727370 */     GIR_EraseRootFromParent_Done,
     /* 1727371 */   // Label 23606: @1727371
     /* 1727371 */   GIM_Try, /*On fail goto*//*Label 23607*/ GIMT_Encode4(1727457), // Rule ID 10686 //
     /* 1727376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1727387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1727390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1727393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1727396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727422 */     // MIs[0] policy
     /* 1727422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727456 */     // GIR_Coverage, 10686,
     /* 1727456 */     GIR_EraseRootFromParent_Done,
     /* 1727457 */   // Label 23607: @1727457
     /* 1727457 */   GIM_Try, /*On fail goto*//*Label 23608*/ GIMT_Encode4(1727543), // Rule ID 10687 //
     /* 1727462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1727473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1727476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1727479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1727482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727508 */     // MIs[0] policy
     /* 1727508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727542 */     // GIR_Coverage, 10687,
     /* 1727542 */     GIR_EraseRootFromParent_Done,
     /* 1727543 */   // Label 23608: @1727543
     /* 1727543 */   GIM_Try, /*On fail goto*//*Label 23609*/ GIMT_Encode4(1727629), // Rule ID 10690 //
     /* 1727548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1727559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1727562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1727565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1727568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727594 */     // MIs[0] policy
     /* 1727594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727604 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727628 */     // GIR_Coverage, 10690,
     /* 1727628 */     GIR_EraseRootFromParent_Done,
     /* 1727629 */   // Label 23609: @1727629
     /* 1727629 */   GIM_Try, /*On fail goto*//*Label 23610*/ GIMT_Encode4(1727715), // Rule ID 10691 //
     /* 1727634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1727645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1727648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1727651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1727654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727680 */     // MIs[0] policy
     /* 1727680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727690 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727714 */     // GIR_Coverage, 10691,
     /* 1727714 */     GIR_EraseRootFromParent_Done,
     /* 1727715 */   // Label 23610: @1727715
     /* 1727715 */   GIM_Try, /*On fail goto*//*Label 23611*/ GIMT_Encode4(1727801), // Rule ID 10694 //
     /* 1727720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1727731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1727734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1727737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1727740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727766 */     // MIs[0] policy
     /* 1727766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727776 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727800 */     // GIR_Coverage, 10694,
     /* 1727800 */     GIR_EraseRootFromParent_Done,
     /* 1727801 */   // Label 23611: @1727801
     /* 1727801 */   GIM_Try, /*On fail goto*//*Label 23612*/ GIMT_Encode4(1727887), // Rule ID 10695 //
     /* 1727806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1727817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1727820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1727823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1727826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727852 */     // MIs[0] policy
     /* 1727852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727862 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727886 */     // GIR_Coverage, 10695,
     /* 1727886 */     GIR_EraseRootFromParent_Done,
     /* 1727887 */   // Label 23612: @1727887
     /* 1727887 */   GIM_Try, /*On fail goto*//*Label 23613*/ GIMT_Encode4(1727973), // Rule ID 10698 //
     /* 1727892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1727903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1727906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1727909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1727912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727938 */     // MIs[0] policy
     /* 1727938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727972 */     // GIR_Coverage, 10698,
     /* 1727972 */     GIR_EraseRootFromParent_Done,
     /* 1727973 */   // Label 23613: @1727973
     /* 1727973 */   GIM_Try, /*On fail goto*//*Label 23614*/ GIMT_Encode4(1728059), // Rule ID 10699 //
     /* 1727978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1727989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1727992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1727995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1727998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728024 */     // MIs[0] policy
     /* 1728024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728034 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1728037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728058 */     // GIR_Coverage, 10699,
     /* 1728058 */     GIR_EraseRootFromParent_Done,
     /* 1728059 */   // Label 23614: @1728059
     /* 1728059 */   GIM_Try, /*On fail goto*//*Label 23615*/ GIMT_Encode4(1728145), // Rule ID 10702 //
     /* 1728064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1728067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1728075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1728078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1728081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1728084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728110 */     // MIs[0] policy
     /* 1728110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728120 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1728123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728144 */     // GIR_Coverage, 10702,
     /* 1728144 */     GIR_EraseRootFromParent_Done,
     /* 1728145 */   // Label 23615: @1728145
     /* 1728145 */   GIM_Try, /*On fail goto*//*Label 23616*/ GIMT_Encode4(1728231), // Rule ID 10703 //
     /* 1728150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1728153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1728161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1728164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1728167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1728170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728196 */     // MIs[0] policy
     /* 1728196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728206 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1728209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728230 */     // GIR_Coverage, 10703,
     /* 1728230 */     GIR_EraseRootFromParent_Done,
     /* 1728231 */   // Label 23616: @1728231
     /* 1728231 */   GIM_Try, /*On fail goto*//*Label 23617*/ GIMT_Encode4(1728317), // Rule ID 10706 //
     /* 1728236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1728239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1728247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1728250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1728253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1728256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728282 */     // MIs[0] policy
     /* 1728282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728292 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1728295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728316 */     // GIR_Coverage, 10706,
     /* 1728316 */     GIR_EraseRootFromParent_Done,
     /* 1728317 */   // Label 23617: @1728317
     /* 1728317 */   GIM_Try, /*On fail goto*//*Label 23618*/ GIMT_Encode4(1728403), // Rule ID 10707 //
     /* 1728322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1728325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1728333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1728336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1728339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1728342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728368 */     // MIs[0] policy
     /* 1728368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728378 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1728381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728402 */     // GIR_Coverage, 10707,
     /* 1728402 */     GIR_EraseRootFromParent_Done,
     /* 1728403 */   // Label 23618: @1728403
     /* 1728403 */   GIM_Try, /*On fail goto*//*Label 23619*/ GIMT_Encode4(1728489), // Rule ID 10710 //
     /* 1728408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1728419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1728422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1728425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728454 */     // MIs[0] policy
     /* 1728454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728464 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1728467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728488 */     // GIR_Coverage, 10710,
     /* 1728488 */     GIR_EraseRootFromParent_Done,
     /* 1728489 */   // Label 23619: @1728489
     /* 1728489 */   GIM_Try, /*On fail goto*//*Label 23620*/ GIMT_Encode4(1728575), // Rule ID 10711 //
     /* 1728494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1728505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1728508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1728511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728540 */     // MIs[0] policy
     /* 1728540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728550 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1728553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728574 */     // GIR_Coverage, 10711,
     /* 1728574 */     GIR_EraseRootFromParent_Done,
     /* 1728575 */   // Label 23620: @1728575
     /* 1728575 */   GIM_Try, /*On fail goto*//*Label 23621*/ GIMT_Encode4(1728661), // Rule ID 10714 //
     /* 1728580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1728591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1728594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1728597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728626 */     // MIs[0] policy
     /* 1728626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728636 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728660 */     // GIR_Coverage, 10714,
     /* 1728660 */     GIR_EraseRootFromParent_Done,
     /* 1728661 */   // Label 23621: @1728661
     /* 1728661 */   GIM_Try, /*On fail goto*//*Label 23622*/ GIMT_Encode4(1728747), // Rule ID 10715 //
     /* 1728666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1728677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1728680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1728683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728712 */     // MIs[0] policy
     /* 1728712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728722 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728746 */     // GIR_Coverage, 10715,
     /* 1728746 */     GIR_EraseRootFromParent_Done,
     /* 1728747 */   // Label 23622: @1728747
     /* 1728747 */   GIM_Try, /*On fail goto*//*Label 23623*/ GIMT_Encode4(1728833), // Rule ID 10718 //
     /* 1728752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1728763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1728766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1728769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728798 */     // MIs[0] policy
     /* 1728798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728808 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728832 */     // GIR_Coverage, 10718,
     /* 1728832 */     GIR_EraseRootFromParent_Done,
     /* 1728833 */   // Label 23623: @1728833
     /* 1728833 */   GIM_Try, /*On fail goto*//*Label 23624*/ GIMT_Encode4(1728919), // Rule ID 10719 //
     /* 1728838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1728849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1728852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1728855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728884 */     // MIs[0] policy
     /* 1728884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728894 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728918 */     // GIR_Coverage, 10719,
     /* 1728918 */     GIR_EraseRootFromParent_Done,
     /* 1728919 */   // Label 23624: @1728919
     /* 1728919 */   GIM_Try, /*On fail goto*//*Label 23625*/ GIMT_Encode4(1729005), // Rule ID 10722 //
     /* 1728924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1728935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1728938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1728941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728970 */     // MIs[0] policy
     /* 1728970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728980 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729004 */     // GIR_Coverage, 10722,
     /* 1729004 */     GIR_EraseRootFromParent_Done,
     /* 1729005 */   // Label 23625: @1729005
     /* 1729005 */   GIM_Try, /*On fail goto*//*Label 23626*/ GIMT_Encode4(1729091), // Rule ID 10723 //
     /* 1729010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1729021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1729024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1729027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729056 */     // MIs[0] policy
     /* 1729056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729066 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1729069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729090 */     // GIR_Coverage, 10723,
     /* 1729090 */     GIR_EraseRootFromParent_Done,
     /* 1729091 */   // Label 23626: @1729091
     /* 1729091 */   GIM_Try, /*On fail goto*//*Label 23627*/ GIMT_Encode4(1729177), // Rule ID 10726 //
     /* 1729096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1729107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1729110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1729113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729142 */     // MIs[0] policy
     /* 1729142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729152 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1729155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729176 */     // GIR_Coverage, 10726,
     /* 1729176 */     GIR_EraseRootFromParent_Done,
     /* 1729177 */   // Label 23627: @1729177
     /* 1729177 */   GIM_Try, /*On fail goto*//*Label 23628*/ GIMT_Encode4(1729263), // Rule ID 10727 //
     /* 1729182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1729193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1729196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1729199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729228 */     // MIs[0] policy
     /* 1729228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729238 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1729241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729262 */     // GIR_Coverage, 10727,
     /* 1729262 */     GIR_EraseRootFromParent_Done,
     /* 1729263 */   // Label 23628: @1729263
     /* 1729263 */   GIM_Try, /*On fail goto*//*Label 23629*/ GIMT_Encode4(1729349), // Rule ID 10730 //
     /* 1729268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1729279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1729282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1729285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729314 */     // MIs[0] policy
     /* 1729314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729324 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1729327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729348 */     // GIR_Coverage, 10730,
     /* 1729348 */     GIR_EraseRootFromParent_Done,
     /* 1729349 */   // Label 23629: @1729349
     /* 1729349 */   GIM_Try, /*On fail goto*//*Label 23630*/ GIMT_Encode4(1729435), // Rule ID 10731 //
     /* 1729354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1729365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1729368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1729371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729400 */     // MIs[0] policy
     /* 1729400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729410 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1729413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729434 */     // GIR_Coverage, 10731,
     /* 1729434 */     GIR_EraseRootFromParent_Done,
     /* 1729435 */   // Label 23630: @1729435
     /* 1729435 */   GIM_Try, /*On fail goto*//*Label 23631*/ GIMT_Encode4(1729521), // Rule ID 10734 //
     /* 1729440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1729451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1729454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1729457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729486 */     // MIs[0] policy
     /* 1729486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729496 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729520 */     // GIR_Coverage, 10734,
     /* 1729520 */     GIR_EraseRootFromParent_Done,
     /* 1729521 */   // Label 23631: @1729521
     /* 1729521 */   GIM_Try, /*On fail goto*//*Label 23632*/ GIMT_Encode4(1729607), // Rule ID 10735 //
     /* 1729526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1729537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1729540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1729543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729572 */     // MIs[0] policy
     /* 1729572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729606 */     // GIR_Coverage, 10735,
     /* 1729606 */     GIR_EraseRootFromParent_Done,
     /* 1729607 */   // Label 23632: @1729607
     /* 1729607 */   GIM_Try, /*On fail goto*//*Label 23633*/ GIMT_Encode4(1729693), // Rule ID 10738 //
     /* 1729612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1729623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1729626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1729629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729658 */     // MIs[0] policy
     /* 1729658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729692 */     // GIR_Coverage, 10738,
     /* 1729692 */     GIR_EraseRootFromParent_Done,
     /* 1729693 */   // Label 23633: @1729693
     /* 1729693 */   GIM_Try, /*On fail goto*//*Label 23634*/ GIMT_Encode4(1729779), // Rule ID 10739 //
     /* 1729698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1729709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1729712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1729715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729744 */     // MIs[0] policy
     /* 1729744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729754 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729778 */     // GIR_Coverage, 10739,
     /* 1729778 */     GIR_EraseRootFromParent_Done,
     /* 1729779 */   // Label 23634: @1729779
     /* 1729779 */   GIM_Try, /*On fail goto*//*Label 23635*/ GIMT_Encode4(1729865), // Rule ID 10742 //
     /* 1729784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1729795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1729798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1729801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729830 */     // MIs[0] policy
     /* 1729830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729864 */     // GIR_Coverage, 10742,
     /* 1729864 */     GIR_EraseRootFromParent_Done,
     /* 1729865 */   // Label 23635: @1729865
     /* 1729865 */   GIM_Try, /*On fail goto*//*Label 23636*/ GIMT_Encode4(1729951), // Rule ID 10743 //
     /* 1729870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1729881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1729884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1729887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729916 */     // MIs[0] policy
     /* 1729916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729926 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729950 */     // GIR_Coverage, 10743,
     /* 1729950 */     GIR_EraseRootFromParent_Done,
     /* 1729951 */   // Label 23636: @1729951
     /* 1729951 */   GIM_Try, /*On fail goto*//*Label 23637*/ GIMT_Encode4(1730037), // Rule ID 10746 //
     /* 1729956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1729959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1729967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1729970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1729973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730002 */     // MIs[0] policy
     /* 1730002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730012 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1730015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1730033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730036 */     // GIR_Coverage, 10746,
     /* 1730036 */     GIR_EraseRootFromParent_Done,
     /* 1730037 */   // Label 23637: @1730037
     /* 1730037 */   GIM_Try, /*On fail goto*//*Label 23638*/ GIMT_Encode4(1730123), // Rule ID 10747 //
     /* 1730042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1730045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1730053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1730056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1730059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1730065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730088 */     // MIs[0] policy
     /* 1730088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730098 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1730101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1730119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730122 */     // GIR_Coverage, 10747,
     /* 1730122 */     GIR_EraseRootFromParent_Done,
     /* 1730123 */   // Label 23638: @1730123
     /* 1730123 */   GIM_Try, /*On fail goto*//*Label 23639*/ GIMT_Encode4(1730209), // Rule ID 10750 //
     /* 1730128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1730139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1730142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1730145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730174 */     // MIs[0] policy
     /* 1730174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730184 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730208 */     // GIR_Coverage, 10750,
     /* 1730208 */     GIR_EraseRootFromParent_Done,
     /* 1730209 */   // Label 23639: @1730209
     /* 1730209 */   GIM_Try, /*On fail goto*//*Label 23640*/ GIMT_Encode4(1730295), // Rule ID 10751 //
     /* 1730214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1730225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1730228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1730231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730260 */     // MIs[0] policy
     /* 1730260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730270 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730294 */     // GIR_Coverage, 10751,
     /* 1730294 */     GIR_EraseRootFromParent_Done,
     /* 1730295 */   // Label 23640: @1730295
     /* 1730295 */   GIM_Try, /*On fail goto*//*Label 23641*/ GIMT_Encode4(1730381), // Rule ID 10754 //
     /* 1730300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1730311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1730314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1730317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1730323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730346 */     // MIs[0] policy
     /* 1730346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730356 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730380 */     // GIR_Coverage, 10754,
     /* 1730380 */     GIR_EraseRootFromParent_Done,
     /* 1730381 */   // Label 23641: @1730381
     /* 1730381 */   GIM_Try, /*On fail goto*//*Label 23642*/ GIMT_Encode4(1730467), // Rule ID 10755 //
     /* 1730386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1730397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1730400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1730403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1730409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730432 */     // MIs[0] policy
     /* 1730432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730442 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730466 */     // GIR_Coverage, 10755,
     /* 1730466 */     GIR_EraseRootFromParent_Done,
     /* 1730467 */   // Label 23642: @1730467
     /* 1730467 */   GIM_Try, /*On fail goto*//*Label 23643*/ GIMT_Encode4(1730553), // Rule ID 10758 //
     /* 1730472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1730483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1730486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1730489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1730495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730518 */     // MIs[0] policy
     /* 1730518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730528 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1730531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730552 */     // GIR_Coverage, 10758,
     /* 1730552 */     GIR_EraseRootFromParent_Done,
     /* 1730553 */   // Label 23643: @1730553
     /* 1730553 */   GIM_Try, /*On fail goto*//*Label 23644*/ GIMT_Encode4(1730639), // Rule ID 10759 //
     /* 1730558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1730569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1730572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1730575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1730581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730604 */     // MIs[0] policy
     /* 1730604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730614 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1730617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730638 */     // GIR_Coverage, 10759,
     /* 1730638 */     GIR_EraseRootFromParent_Done,
     /* 1730639 */   // Label 23644: @1730639
     /* 1730639 */   GIM_Try, /*On fail goto*//*Label 23645*/ GIMT_Encode4(1730725), // Rule ID 10762 //
     /* 1730644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1730655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1730658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1730661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730690 */     // MIs[0] policy
     /* 1730690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730700 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730724 */     // GIR_Coverage, 10762,
     /* 1730724 */     GIR_EraseRootFromParent_Done,
     /* 1730725 */   // Label 23645: @1730725
     /* 1730725 */   GIM_Try, /*On fail goto*//*Label 23646*/ GIMT_Encode4(1730811), // Rule ID 10763 //
     /* 1730730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1730741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1730744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1730747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730776 */     // MIs[0] policy
     /* 1730776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730786 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730810 */     // GIR_Coverage, 10763,
     /* 1730810 */     GIR_EraseRootFromParent_Done,
     /* 1730811 */   // Label 23646: @1730811
     /* 1730811 */   GIM_Try, /*On fail goto*//*Label 23647*/ GIMT_Encode4(1730897), // Rule ID 10766 //
     /* 1730816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1730827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1730830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1730833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730862 */     // MIs[0] policy
     /* 1730862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730872 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730896 */     // GIR_Coverage, 10766,
     /* 1730896 */     GIR_EraseRootFromParent_Done,
     /* 1730897 */   // Label 23647: @1730897
     /* 1730897 */   GIM_Try, /*On fail goto*//*Label 23648*/ GIMT_Encode4(1730983), // Rule ID 10767 //
     /* 1730902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1730913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1730916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1730919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730948 */     // MIs[0] policy
     /* 1730948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730958 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730982 */     // GIR_Coverage, 10767,
     /* 1730982 */     GIR_EraseRootFromParent_Done,
     /* 1730983 */   // Label 23648: @1730983
     /* 1730983 */   GIM_Try, /*On fail goto*//*Label 23649*/ GIMT_Encode4(1731069), // Rule ID 10770 //
     /* 1730988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1730999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1731002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1731005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1731011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731034 */     // MIs[0] policy
     /* 1731034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731044 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731068 */     // GIR_Coverage, 10770,
     /* 1731068 */     GIR_EraseRootFromParent_Done,
     /* 1731069 */   // Label 23649: @1731069
     /* 1731069 */   GIM_Try, /*On fail goto*//*Label 23650*/ GIMT_Encode4(1731155), // Rule ID 10771 //
     /* 1731074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1731085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1731088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1731091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1731097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731120 */     // MIs[0] policy
     /* 1731120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731130 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731154 */     // GIR_Coverage, 10771,
     /* 1731154 */     GIR_EraseRootFromParent_Done,
     /* 1731155 */   // Label 23650: @1731155
     /* 1731155 */   GIM_Try, /*On fail goto*//*Label 23651*/ GIMT_Encode4(1731241), // Rule ID 10774 //
     /* 1731160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1731171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1731174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1731177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731206 */     // MIs[0] policy
     /* 1731206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1731219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731240 */     // GIR_Coverage, 10774,
     /* 1731240 */     GIR_EraseRootFromParent_Done,
     /* 1731241 */   // Label 23651: @1731241
     /* 1731241 */   GIM_Try, /*On fail goto*//*Label 23652*/ GIMT_Encode4(1731327), // Rule ID 10775 //
     /* 1731246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1731257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1731260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1731263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731292 */     // MIs[0] policy
     /* 1731292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1731305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731326 */     // GIR_Coverage, 10775,
     /* 1731326 */     GIR_EraseRootFromParent_Done,
     /* 1731327 */   // Label 23652: @1731327
     /* 1731327 */   GIM_Try, /*On fail goto*//*Label 23653*/ GIMT_Encode4(1731413), // Rule ID 10778 //
     /* 1731332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1731343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1731346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1731349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731378 */     // MIs[0] policy
     /* 1731378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731388 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731412 */     // GIR_Coverage, 10778,
     /* 1731412 */     GIR_EraseRootFromParent_Done,
     /* 1731413 */   // Label 23653: @1731413
     /* 1731413 */   GIM_Try, /*On fail goto*//*Label 23654*/ GIMT_Encode4(1731499), // Rule ID 10779 //
     /* 1731418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1731429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1731432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1731435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731464 */     // MIs[0] policy
     /* 1731464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731474 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731498 */     // GIR_Coverage, 10779,
     /* 1731498 */     GIR_EraseRootFromParent_Done,
     /* 1731499 */   // Label 23654: @1731499
     /* 1731499 */   GIM_Try, /*On fail goto*//*Label 23655*/ GIMT_Encode4(1731585), // Rule ID 10782 //
     /* 1731504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1731515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1731518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1731521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731550 */     // MIs[0] policy
     /* 1731550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731560 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731584 */     // GIR_Coverage, 10782,
     /* 1731584 */     GIR_EraseRootFromParent_Done,
     /* 1731585 */   // Label 23655: @1731585
     /* 1731585 */   GIM_Try, /*On fail goto*//*Label 23656*/ GIMT_Encode4(1731671), // Rule ID 10783 //
     /* 1731590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1731601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1731604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1731607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731636 */     // MIs[0] policy
     /* 1731636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731670 */     // GIR_Coverage, 10783,
     /* 1731670 */     GIR_EraseRootFromParent_Done,
     /* 1731671 */   // Label 23656: @1731671
     /* 1731671 */   GIM_Try, /*On fail goto*//*Label 23657*/ GIMT_Encode4(1731757), // Rule ID 10786 //
     /* 1731676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1731687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1731690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1731693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731722 */     // MIs[0] policy
     /* 1731722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731732 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1731735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731756 */     // GIR_Coverage, 10786,
     /* 1731756 */     GIR_EraseRootFromParent_Done,
     /* 1731757 */   // Label 23657: @1731757
     /* 1731757 */   GIM_Try, /*On fail goto*//*Label 23658*/ GIMT_Encode4(1731843), // Rule ID 10787 //
     /* 1731762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1731773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1731776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1731779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731808 */     // MIs[0] policy
     /* 1731808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731818 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1731821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731842 */     // GIR_Coverage, 10787,
     /* 1731842 */     GIR_EraseRootFromParent_Done,
     /* 1731843 */   // Label 23658: @1731843
     /* 1731843 */   GIM_Try, /*On fail goto*//*Label 23659*/ GIMT_Encode4(1731929), // Rule ID 10790 //
     /* 1731848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1731859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1731862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1731865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731894 */     // MIs[0] policy
     /* 1731894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731904 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731928 */     // GIR_Coverage, 10790,
     /* 1731928 */     GIR_EraseRootFromParent_Done,
     /* 1731929 */   // Label 23659: @1731929
     /* 1731929 */   GIM_Try, /*On fail goto*//*Label 23660*/ GIMT_Encode4(1732015), // Rule ID 10791 //
     /* 1731934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1731945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1731948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1731951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731980 */     // MIs[0] policy
     /* 1731980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731990 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732014 */     // GIR_Coverage, 10791,
     /* 1732014 */     GIR_EraseRootFromParent_Done,
     /* 1732015 */   // Label 23660: @1732015
     /* 1732015 */   GIM_Try, /*On fail goto*//*Label 23661*/ GIMT_Encode4(1732101), // Rule ID 10794 //
     /* 1732020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1732023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1732031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1732034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1732037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1732040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732066 */     // MIs[0] policy
     /* 1732066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732076 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1732079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732100 */     // GIR_Coverage, 10794,
     /* 1732100 */     GIR_EraseRootFromParent_Done,
     /* 1732101 */   // Label 23661: @1732101
     /* 1732101 */   GIM_Try, /*On fail goto*//*Label 23662*/ GIMT_Encode4(1732187), // Rule ID 10795 //
     /* 1732106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1732109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1732117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1732120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1732123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1732126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732152 */     // MIs[0] policy
     /* 1732152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732162 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1732165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732186 */     // GIR_Coverage, 10795,
     /* 1732186 */     GIR_EraseRootFromParent_Done,
     /* 1732187 */   // Label 23662: @1732187
     /* 1732187 */   GIM_Try, /*On fail goto*//*Label 23663*/ GIMT_Encode4(1732273), // Rule ID 10798 //
     /* 1732192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1732203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1732206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1732209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1732212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732238 */     // MIs[0] policy
     /* 1732238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732248 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1732251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732272 */     // GIR_Coverage, 10798,
     /* 1732272 */     GIR_EraseRootFromParent_Done,
     /* 1732273 */   // Label 23663: @1732273
     /* 1732273 */   GIM_Try, /*On fail goto*//*Label 23664*/ GIMT_Encode4(1732359), // Rule ID 10799 //
     /* 1732278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1732289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1732292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1732295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1732298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732324 */     // MIs[0] policy
     /* 1732324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1732337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732358 */     // GIR_Coverage, 10799,
     /* 1732358 */     GIR_EraseRootFromParent_Done,
     /* 1732359 */   // Label 23664: @1732359
     /* 1732359 */   GIM_Try, /*On fail goto*//*Label 23665*/ GIMT_Encode4(1732445), // Rule ID 10802 //
     /* 1732364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1732375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1732378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1732381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1732384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732410 */     // MIs[0] policy
     /* 1732410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732420 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732444 */     // GIR_Coverage, 10802,
     /* 1732444 */     GIR_EraseRootFromParent_Done,
     /* 1732445 */   // Label 23665: @1732445
     /* 1732445 */   GIM_Try, /*On fail goto*//*Label 23666*/ GIMT_Encode4(1732531), // Rule ID 10803 //
     /* 1732450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1732461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1732464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1732467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1732470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732496 */     // MIs[0] policy
     /* 1732496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732506 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732530 */     // GIR_Coverage, 10803,
     /* 1732530 */     GIR_EraseRootFromParent_Done,
     /* 1732531 */   // Label 23666: @1732531
     /* 1732531 */   GIM_Try, /*On fail goto*//*Label 23667*/ GIMT_Encode4(1732617), // Rule ID 10806 //
     /* 1732536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1732547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1732550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1732553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1732556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732582 */     // MIs[0] policy
     /* 1732582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732592 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732616 */     // GIR_Coverage, 10806,
     /* 1732616 */     GIR_EraseRootFromParent_Done,
     /* 1732617 */   // Label 23667: @1732617
     /* 1732617 */   GIM_Try, /*On fail goto*//*Label 23668*/ GIMT_Encode4(1732703), // Rule ID 10807 //
     /* 1732622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1732633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1732636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1732639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1732642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732668 */     // MIs[0] policy
     /* 1732668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732678 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732702 */     // GIR_Coverage, 10807,
     /* 1732702 */     GIR_EraseRootFromParent_Done,
     /* 1732703 */   // Label 23668: @1732703
     /* 1732703 */   GIM_Try, /*On fail goto*//*Label 23669*/ GIMT_Encode4(1732789), // Rule ID 10810 //
     /* 1732708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1732719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1732722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1732725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1732728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732754 */     // MIs[0] policy
     /* 1732754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732764 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732788 */     // GIR_Coverage, 10810,
     /* 1732788 */     GIR_EraseRootFromParent_Done,
     /* 1732789 */   // Label 23669: @1732789
     /* 1732789 */   GIM_Try, /*On fail goto*//*Label 23670*/ GIMT_Encode4(1732875), // Rule ID 10811 //
     /* 1732794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1732805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1732808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1732811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1732814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732840 */     // MIs[0] policy
     /* 1732840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732850 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732874 */     // GIR_Coverage, 10811,
     /* 1732874 */     GIR_EraseRootFromParent_Done,
     /* 1732875 */   // Label 23670: @1732875
     /* 1732875 */   GIM_Try, /*On fail goto*//*Label 23671*/ GIMT_Encode4(1732961), // Rule ID 10814 //
     /* 1732880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1732891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1732894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1732897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1732900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732926 */     // MIs[0] policy
     /* 1732926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732936 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732960 */     // GIR_Coverage, 10814,
     /* 1732960 */     GIR_EraseRootFromParent_Done,
     /* 1732961 */   // Label 23671: @1732961
     /* 1732961 */   GIM_Try, /*On fail goto*//*Label 23672*/ GIMT_Encode4(1733047), // Rule ID 10815 //
     /* 1732966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1732977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1732980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1732983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1732986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733012 */     // MIs[0] policy
     /* 1733012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733022 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1733025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733046 */     // GIR_Coverage, 10815,
     /* 1733046 */     GIR_EraseRootFromParent_Done,
     /* 1733047 */   // Label 23672: @1733047
     /* 1733047 */   GIM_Try, /*On fail goto*//*Label 23673*/ GIMT_Encode4(1733133), // Rule ID 10818 //
     /* 1733052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1733063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1733066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1733069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1733072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733098 */     // MIs[0] policy
     /* 1733098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1733111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733132 */     // GIR_Coverage, 10818,
     /* 1733132 */     GIR_EraseRootFromParent_Done,
     /* 1733133 */   // Label 23673: @1733133
     /* 1733133 */   GIM_Try, /*On fail goto*//*Label 23674*/ GIMT_Encode4(1733219), // Rule ID 10819 //
     /* 1733138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1733149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1733152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1733155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1733158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733184 */     // MIs[0] policy
     /* 1733184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733194 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1733197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733218 */     // GIR_Coverage, 10819,
     /* 1733218 */     GIR_EraseRootFromParent_Done,
     /* 1733219 */   // Label 23674: @1733219
     /* 1733219 */   GIM_Try, /*On fail goto*//*Label 23675*/ GIMT_Encode4(1733305), // Rule ID 10822 //
     /* 1733224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1733235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1733238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1733241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1733244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1733247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733270 */     // MIs[0] policy
     /* 1733270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733280 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733304 */     // GIR_Coverage, 10822,
     /* 1733304 */     GIR_EraseRootFromParent_Done,
     /* 1733305 */   // Label 23675: @1733305
     /* 1733305 */   GIM_Try, /*On fail goto*//*Label 23676*/ GIMT_Encode4(1733391), // Rule ID 10823 //
     /* 1733310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1733321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1733324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1733327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1733330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1733333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733356 */     // MIs[0] policy
     /* 1733356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733366 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733390 */     // GIR_Coverage, 10823,
     /* 1733390 */     GIR_EraseRootFromParent_Done,
     /* 1733391 */   // Label 23676: @1733391
     /* 1733391 */   GIM_Try, /*On fail goto*//*Label 23677*/ GIMT_Encode4(1733477), // Rule ID 10826 //
     /* 1733396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1733407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1733410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1733413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1733416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733442 */     // MIs[0] policy
     /* 1733442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733476 */     // GIR_Coverage, 10826,
     /* 1733476 */     GIR_EraseRootFromParent_Done,
     /* 1733477 */   // Label 23677: @1733477
     /* 1733477 */   GIM_Try, /*On fail goto*//*Label 23678*/ GIMT_Encode4(1733563), // Rule ID 10827 //
     /* 1733482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1733493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1733496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1733499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1733502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733528 */     // MIs[0] policy
     /* 1733528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733538 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733562 */     // GIR_Coverage, 10827,
     /* 1733562 */     GIR_EraseRootFromParent_Done,
     /* 1733563 */   // Label 23678: @1733563
     /* 1733563 */   GIM_Try, /*On fail goto*//*Label 23679*/ GIMT_Encode4(1733649), // Rule ID 10830 //
     /* 1733568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1733579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1733582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1733585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1733588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733614 */     // MIs[0] policy
     /* 1733614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733648 */     // GIR_Coverage, 10830,
     /* 1733648 */     GIR_EraseRootFromParent_Done,
     /* 1733649 */   // Label 23679: @1733649
     /* 1733649 */   GIM_Try, /*On fail goto*//*Label 23680*/ GIMT_Encode4(1733735), // Rule ID 10831 //
     /* 1733654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1733665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1733668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1733671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1733674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733700 */     // MIs[0] policy
     /* 1733700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733734 */     // GIR_Coverage, 10831,
     /* 1733734 */     GIR_EraseRootFromParent_Done,
     /* 1733735 */   // Label 23680: @1733735
     /* 1733735 */   GIM_Try, /*On fail goto*//*Label 23681*/ GIMT_Encode4(1733821), // Rule ID 10834 //
     /* 1733740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1733743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1733751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1733754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1733757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1733760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733786 */     // MIs[0] policy
     /* 1733786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733796 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733820 */     // GIR_Coverage, 10834,
     /* 1733820 */     GIR_EraseRootFromParent_Done,
     /* 1733821 */   // Label 23681: @1733821
     /* 1733821 */   GIM_Try, /*On fail goto*//*Label 23682*/ GIMT_Encode4(1733907), // Rule ID 10835 //
     /* 1733826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1733829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1733837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1733840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1733843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1733846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733872 */     // MIs[0] policy
     /* 1733872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733882 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733906 */     // GIR_Coverage, 10835,
     /* 1733906 */     GIR_EraseRootFromParent_Done,
     /* 1733907 */   // Label 23682: @1733907
     /* 1733907 */   GIM_Try, /*On fail goto*//*Label 23683*/ GIMT_Encode4(1733993), // Rule ID 10838 //
     /* 1733912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1733923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1733926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1733929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1733932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1733935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1733942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733958 */     // MIs[0] policy
     /* 1733958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733968 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1733971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733992 */     // GIR_Coverage, 10838,
     /* 1733992 */     GIR_EraseRootFromParent_Done,
     /* 1733993 */   // Label 23683: @1733993
     /* 1733993 */   GIM_Try, /*On fail goto*//*Label 23684*/ GIMT_Encode4(1734079), // Rule ID 10839 //
     /* 1733998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1734009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1734012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1734015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1734018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734044 */     // MIs[0] policy
     /* 1734044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734054 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734078 */     // GIR_Coverage, 10839,
     /* 1734078 */     GIR_EraseRootFromParent_Done,
     /* 1734079 */   // Label 23684: @1734079
     /* 1734079 */   GIM_Try, /*On fail goto*//*Label 23685*/ GIMT_Encode4(1734165), // Rule ID 10842 //
     /* 1734084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1734095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1734098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1734101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1734104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734130 */     // MIs[0] policy
     /* 1734130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734140 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734164 */     // GIR_Coverage, 10842,
     /* 1734164 */     GIR_EraseRootFromParent_Done,
     /* 1734165 */   // Label 23685: @1734165
     /* 1734165 */   GIM_Try, /*On fail goto*//*Label 23686*/ GIMT_Encode4(1734251), // Rule ID 10843 //
     /* 1734170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1734181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1734184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1734187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1734190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734216 */     // MIs[0] policy
     /* 1734216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734226 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734250 */     // GIR_Coverage, 10843,
     /* 1734250 */     GIR_EraseRootFromParent_Done,
     /* 1734251 */   // Label 23686: @1734251
     /* 1734251 */   GIM_Try, /*On fail goto*//*Label 23687*/ GIMT_Encode4(1734337), // Rule ID 10846 //
     /* 1734256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1734267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1734270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1734273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1734276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1734279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734302 */     // MIs[0] policy
     /* 1734302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734312 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734336 */     // GIR_Coverage, 10846,
     /* 1734336 */     GIR_EraseRootFromParent_Done,
     /* 1734337 */   // Label 23687: @1734337
     /* 1734337 */   GIM_Try, /*On fail goto*//*Label 23688*/ GIMT_Encode4(1734423), // Rule ID 10847 //
     /* 1734342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1734353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1734356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1734359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1734362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1734365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734388 */     // MIs[0] policy
     /* 1734388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734398 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734422 */     // GIR_Coverage, 10847,
     /* 1734422 */     GIR_EraseRootFromParent_Done,
     /* 1734423 */   // Label 23688: @1734423
     /* 1734423 */   GIM_Try, /*On fail goto*//*Label 23689*/ GIMT_Encode4(1734509), // Rule ID 10850 //
     /* 1734428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1734439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1734442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1734445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1734448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734474 */     // MIs[0] policy
     /* 1734474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734508 */     // GIR_Coverage, 10850,
     /* 1734508 */     GIR_EraseRootFromParent_Done,
     /* 1734509 */   // Label 23689: @1734509
     /* 1734509 */   GIM_Try, /*On fail goto*//*Label 23690*/ GIMT_Encode4(1734595), // Rule ID 10851 //
     /* 1734514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1734525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1734528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1734531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1734534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734560 */     // MIs[0] policy
     /* 1734560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734570 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734594 */     // GIR_Coverage, 10851,
     /* 1734594 */     GIR_EraseRootFromParent_Done,
     /* 1734595 */   // Label 23690: @1734595
     /* 1734595 */   GIM_Try, /*On fail goto*//*Label 23691*/ GIMT_Encode4(1734681), // Rule ID 10854 //
     /* 1734600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1734611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1734614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1734617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1734620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734646 */     // MIs[0] policy
     /* 1734646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734656 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734680 */     // GIR_Coverage, 10854,
     /* 1734680 */     GIR_EraseRootFromParent_Done,
     /* 1734681 */   // Label 23691: @1734681
     /* 1734681 */   GIM_Try, /*On fail goto*//*Label 23692*/ GIMT_Encode4(1734767), // Rule ID 10855 //
     /* 1734686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1734697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1734700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1734703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1734706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734732 */     // MIs[0] policy
     /* 1734732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734742 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734766 */     // GIR_Coverage, 10855,
     /* 1734766 */     GIR_EraseRootFromParent_Done,
     /* 1734767 */   // Label 23692: @1734767
     /* 1734767 */   GIM_Try, /*On fail goto*//*Label 23693*/ GIMT_Encode4(1734853), // Rule ID 10858 //
     /* 1734772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1734783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1734786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1734789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1734792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734818 */     // MIs[0] policy
     /* 1734818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734828 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734852 */     // GIR_Coverage, 10858,
     /* 1734852 */     GIR_EraseRootFromParent_Done,
     /* 1734853 */   // Label 23693: @1734853
     /* 1734853 */   GIM_Try, /*On fail goto*//*Label 23694*/ GIMT_Encode4(1734939), // Rule ID 10859 //
     /* 1734858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1734869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1734872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1734875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1734878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734904 */     // MIs[0] policy
     /* 1734904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734914 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734938 */     // GIR_Coverage, 10859,
     /* 1734938 */     GIR_EraseRootFromParent_Done,
     /* 1734939 */   // Label 23694: @1734939
     /* 1734939 */   GIM_Try, /*On fail goto*//*Label 23695*/ GIMT_Encode4(1735025), // Rule ID 10862 //
     /* 1734944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1734955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1734958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1734961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1734964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734990 */     // MIs[0] policy
     /* 1734990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735000 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1735003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735024 */     // GIR_Coverage, 10862,
     /* 1735024 */     GIR_EraseRootFromParent_Done,
     /* 1735025 */   // Label 23695: @1735025
     /* 1735025 */   GIM_Try, /*On fail goto*//*Label 23696*/ GIMT_Encode4(1735111), // Rule ID 10863 //
     /* 1735030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1735041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1735044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1735047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1735050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735076 */     // MIs[0] policy
     /* 1735076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1735089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735110 */     // GIR_Coverage, 10863,
     /* 1735110 */     GIR_EraseRootFromParent_Done,
     /* 1735111 */   // Label 23696: @1735111
     /* 1735111 */   GIM_Try, /*On fail goto*//*Label 23697*/ GIMT_Encode4(1735197), // Rule ID 10866 //
     /* 1735116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1735127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1735130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1735133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1735136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735162 */     // MIs[0] policy
     /* 1735162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735172 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1735175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735196 */     // GIR_Coverage, 10866,
     /* 1735196 */     GIR_EraseRootFromParent_Done,
     /* 1735197 */   // Label 23697: @1735197
     /* 1735197 */   GIM_Try, /*On fail goto*//*Label 23698*/ GIMT_Encode4(1735283), // Rule ID 10867 //
     /* 1735202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1735213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1735216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1735219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1735222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735248 */     // MIs[0] policy
     /* 1735248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735258 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1735261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735282 */     // GIR_Coverage, 10867,
     /* 1735282 */     GIR_EraseRootFromParent_Done,
     /* 1735283 */   // Label 23698: @1735283
     /* 1735283 */   GIM_Try, /*On fail goto*//*Label 23699*/ GIMT_Encode4(1735369), // Rule ID 10870 //
     /* 1735288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1735299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1735302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1735305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1735308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735334 */     // MIs[0] policy
     /* 1735334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735344 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1735347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735368 */     // GIR_Coverage, 10870,
     /* 1735368 */     GIR_EraseRootFromParent_Done,
     /* 1735369 */   // Label 23699: @1735369
     /* 1735369 */   GIM_Try, /*On fail goto*//*Label 23700*/ GIMT_Encode4(1735455), // Rule ID 10871 //
     /* 1735374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1735385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1735388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1735391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1735394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735420 */     // MIs[0] policy
     /* 1735420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735430 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1735433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735454 */     // GIR_Coverage, 10871,
     /* 1735454 */     GIR_EraseRootFromParent_Done,
     /* 1735455 */   // Label 23700: @1735455
     /* 1735455 */   GIM_Try, /*On fail goto*//*Label 23701*/ GIMT_Encode4(1735541), // Rule ID 10874 //
     /* 1735460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1735471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1735474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1735477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1735480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735506 */     // MIs[0] policy
     /* 1735506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1735519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735540 */     // GIR_Coverage, 10874,
     /* 1735540 */     GIR_EraseRootFromParent_Done,
     /* 1735541 */   // Label 23701: @1735541
     /* 1735541 */   GIM_Try, /*On fail goto*//*Label 23702*/ GIMT_Encode4(1735627), // Rule ID 10875 //
     /* 1735546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1735557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1735560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1735563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1735566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735592 */     // MIs[0] policy
     /* 1735592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735602 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1735605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735626 */     // GIR_Coverage, 10875,
     /* 1735626 */     GIR_EraseRootFromParent_Done,
     /* 1735627 */   // Label 23702: @1735627
     /* 1735627 */   GIM_Try, /*On fail goto*//*Label 23703*/ GIMT_Encode4(1735713), // Rule ID 10878 //
     /* 1735632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1735643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1735646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1735649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1735652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735678 */     // MIs[0] policy
     /* 1735678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735688 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1735691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735712 */     // GIR_Coverage, 10878,
     /* 1735712 */     GIR_EraseRootFromParent_Done,
     /* 1735713 */   // Label 23703: @1735713
     /* 1735713 */   GIM_Try, /*On fail goto*//*Label 23704*/ GIMT_Encode4(1735799), // Rule ID 10879 //
     /* 1735718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1735729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1735732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1735735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1735738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735764 */     // MIs[0] policy
     /* 1735764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735774 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1735777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735798 */     // GIR_Coverage, 10879,
     /* 1735798 */     GIR_EraseRootFromParent_Done,
     /* 1735799 */   // Label 23704: @1735799
     /* 1735799 */   GIM_Try, /*On fail goto*//*Label 23705*/ GIMT_Encode4(1735885), // Rule ID 10882 //
     /* 1735804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1735815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1735818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1735821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1735824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735850 */     // MIs[0] policy
     /* 1735850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735860 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1735863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735884 */     // GIR_Coverage, 10882,
     /* 1735884 */     GIR_EraseRootFromParent_Done,
     /* 1735885 */   // Label 23705: @1735885
     /* 1735885 */   GIM_Try, /*On fail goto*//*Label 23706*/ GIMT_Encode4(1735971), // Rule ID 10883 //
     /* 1735890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1735901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1735904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1735907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1735910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735936 */     // MIs[0] policy
     /* 1735936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1735949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735970 */     // GIR_Coverage, 10883,
     /* 1735970 */     GIR_EraseRootFromParent_Done,
     /* 1735971 */   // Label 23706: @1735971
     /* 1735971 */   GIM_Try, /*On fail goto*//*Label 23707*/ GIMT_Encode4(1736057), // Rule ID 10886 //
     /* 1735976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1735987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1735990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1735993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1735999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736022 */     // MIs[0] policy
     /* 1736022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736032 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1736035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736056 */     // GIR_Coverage, 10886,
     /* 1736056 */     GIR_EraseRootFromParent_Done,
     /* 1736057 */   // Label 23707: @1736057
     /* 1736057 */   GIM_Try, /*On fail goto*//*Label 23708*/ GIMT_Encode4(1736143), // Rule ID 10887 //
     /* 1736062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1736073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1736076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1736079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736108 */     // MIs[0] policy
     /* 1736108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736118 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1736121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736142 */     // GIR_Coverage, 10887,
     /* 1736142 */     GIR_EraseRootFromParent_Done,
     /* 1736143 */   // Label 23708: @1736143
     /* 1736143 */   GIM_Try, /*On fail goto*//*Label 23709*/ GIMT_Encode4(1736229), // Rule ID 10890 //
     /* 1736148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1736159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1736162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1736165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736194 */     // MIs[0] policy
     /* 1736194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736204 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1736207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736228 */     // GIR_Coverage, 10890,
     /* 1736228 */     GIR_EraseRootFromParent_Done,
     /* 1736229 */   // Label 23709: @1736229
     /* 1736229 */   GIM_Try, /*On fail goto*//*Label 23710*/ GIMT_Encode4(1736315), // Rule ID 10891 //
     /* 1736234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1736245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1736248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1736251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736280 */     // MIs[0] policy
     /* 1736280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736290 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1736293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736314 */     // GIR_Coverage, 10891,
     /* 1736314 */     GIR_EraseRootFromParent_Done,
     /* 1736315 */   // Label 23710: @1736315
     /* 1736315 */   GIM_Try, /*On fail goto*//*Label 23711*/ GIMT_Encode4(1736401), // Rule ID 10894 //
     /* 1736320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1736331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1736334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1736337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736366 */     // MIs[0] policy
     /* 1736366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736376 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736400 */     // GIR_Coverage, 10894,
     /* 1736400 */     GIR_EraseRootFromParent_Done,
     /* 1736401 */   // Label 23711: @1736401
     /* 1736401 */   GIM_Try, /*On fail goto*//*Label 23712*/ GIMT_Encode4(1736487), // Rule ID 10895 //
     /* 1736406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1736417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1736420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1736423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736452 */     // MIs[0] policy
     /* 1736452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736462 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736486 */     // GIR_Coverage, 10895,
     /* 1736486 */     GIR_EraseRootFromParent_Done,
     /* 1736487 */   // Label 23712: @1736487
     /* 1736487 */   GIM_Try, /*On fail goto*//*Label 23713*/ GIMT_Encode4(1736573), // Rule ID 10898 //
     /* 1736492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1736503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1736506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1736509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736538 */     // MIs[0] policy
     /* 1736538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736548 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1736551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736572 */     // GIR_Coverage, 10898,
     /* 1736572 */     GIR_EraseRootFromParent_Done,
     /* 1736573 */   // Label 23713: @1736573
     /* 1736573 */   GIM_Try, /*On fail goto*//*Label 23714*/ GIMT_Encode4(1736659), // Rule ID 10899 //
     /* 1736578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1736589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1736592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1736595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736624 */     // MIs[0] policy
     /* 1736624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736634 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1736637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736658 */     // GIR_Coverage, 10899,
     /* 1736658 */     GIR_EraseRootFromParent_Done,
     /* 1736659 */   // Label 23714: @1736659
     /* 1736659 */   GIM_Try, /*On fail goto*//*Label 23715*/ GIMT_Encode4(1736745), // Rule ID 10902 //
     /* 1736664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1736675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1736678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1736681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736710 */     // MIs[0] policy
     /* 1736710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736720 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736744 */     // GIR_Coverage, 10902,
     /* 1736744 */     GIR_EraseRootFromParent_Done,
     /* 1736745 */   // Label 23715: @1736745
     /* 1736745 */   GIM_Try, /*On fail goto*//*Label 23716*/ GIMT_Encode4(1736831), // Rule ID 10903 //
     /* 1736750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1736761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1736764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1736767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736796 */     // MIs[0] policy
     /* 1736796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736806 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736830 */     // GIR_Coverage, 10903,
     /* 1736830 */     GIR_EraseRootFromParent_Done,
     /* 1736831 */   // Label 23716: @1736831
     /* 1736831 */   GIM_Try, /*On fail goto*//*Label 23717*/ GIMT_Encode4(1736917), // Rule ID 10906 //
     /* 1736836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1736847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1736850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1736853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736882 */     // MIs[0] policy
     /* 1736882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736892 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736916 */     // GIR_Coverage, 10906,
     /* 1736916 */     GIR_EraseRootFromParent_Done,
     /* 1736917 */   // Label 23717: @1736917
     /* 1736917 */   GIM_Try, /*On fail goto*//*Label 23718*/ GIMT_Encode4(1737003), // Rule ID 10907 //
     /* 1736922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1736933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1736936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1736939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736968 */     // MIs[0] policy
     /* 1736968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736978 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737002 */     // GIR_Coverage, 10907,
     /* 1737002 */     GIR_EraseRootFromParent_Done,
     /* 1737003 */   // Label 23718: @1737003
     /* 1737003 */   GIM_Try, /*On fail goto*//*Label 23719*/ GIMT_Encode4(1737089), // Rule ID 10910 //
     /* 1737008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1737019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1737022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1737025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737054 */     // MIs[0] policy
     /* 1737054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737088 */     // GIR_Coverage, 10910,
     /* 1737088 */     GIR_EraseRootFromParent_Done,
     /* 1737089 */   // Label 23719: @1737089
     /* 1737089 */   GIM_Try, /*On fail goto*//*Label 23720*/ GIMT_Encode4(1737175), // Rule ID 10911 //
     /* 1737094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1737105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1737108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1737111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737140 */     // MIs[0] policy
     /* 1737140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737150 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737174 */     // GIR_Coverage, 10911,
     /* 1737174 */     GIR_EraseRootFromParent_Done,
     /* 1737175 */   // Label 23720: @1737175
     /* 1737175 */   GIM_Try, /*On fail goto*//*Label 23721*/ GIMT_Encode4(1737261), // Rule ID 10914 //
     /* 1737180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1737191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1737194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1737197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1737203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737226 */     // MIs[0] policy
     /* 1737226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737236 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737260 */     // GIR_Coverage, 10914,
     /* 1737260 */     GIR_EraseRootFromParent_Done,
     /* 1737261 */   // Label 23721: @1737261
     /* 1737261 */   GIM_Try, /*On fail goto*//*Label 23722*/ GIMT_Encode4(1737347), // Rule ID 10915 //
     /* 1737266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1737277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1737280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1737283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1737289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737312 */     // MIs[0] policy
     /* 1737312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737322 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737346 */     // GIR_Coverage, 10915,
     /* 1737346 */     GIR_EraseRootFromParent_Done,
     /* 1737347 */   // Label 23722: @1737347
     /* 1737347 */   GIM_Try, /*On fail goto*//*Label 23723*/ GIMT_Encode4(1737433), // Rule ID 10918 //
     /* 1737352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1737363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1737366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1737369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737398 */     // MIs[0] policy
     /* 1737398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1737429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737432 */     // GIR_Coverage, 10918,
     /* 1737432 */     GIR_EraseRootFromParent_Done,
     /* 1737433 */   // Label 23723: @1737433
     /* 1737433 */   GIM_Try, /*On fail goto*//*Label 23724*/ GIMT_Encode4(1737519), // Rule ID 10919 //
     /* 1737438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1737449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1737452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1737455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737484 */     // MIs[0] policy
     /* 1737484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737494 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1737515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737518 */     // GIR_Coverage, 10919,
     /* 1737518 */     GIR_EraseRootFromParent_Done,
     /* 1737519 */   // Label 23724: @1737519
     /* 1737519 */   GIM_Try, /*On fail goto*//*Label 23725*/ GIMT_Encode4(1737605), // Rule ID 10922 //
     /* 1737524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1737527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1737535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1737538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1737541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737570 */     // MIs[0] policy
     /* 1737570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737580 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737604 */     // GIR_Coverage, 10922,
     /* 1737604 */     GIR_EraseRootFromParent_Done,
     /* 1737605 */   // Label 23725: @1737605
     /* 1737605 */   GIM_Try, /*On fail goto*//*Label 23726*/ GIMT_Encode4(1737691), // Rule ID 10923 //
     /* 1737610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1737613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1737621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1737624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1737627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737656 */     // MIs[0] policy
     /* 1737656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737666 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737690 */     // GIR_Coverage, 10923,
     /* 1737690 */     GIR_EraseRootFromParent_Done,
     /* 1737691 */   // Label 23726: @1737691
     /* 1737691 */   GIM_Try, /*On fail goto*//*Label 23727*/ GIMT_Encode4(1737777), // Rule ID 10926 //
     /* 1737696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1737707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1737710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1737713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737742 */     // MIs[0] policy
     /* 1737742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1737755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737776 */     // GIR_Coverage, 10926,
     /* 1737776 */     GIR_EraseRootFromParent_Done,
     /* 1737777 */   // Label 23727: @1737777
     /* 1737777 */   GIM_Try, /*On fail goto*//*Label 23728*/ GIMT_Encode4(1737863), // Rule ID 10927 //
     /* 1737782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1737793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1737796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1737799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737828 */     // MIs[0] policy
     /* 1737828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737838 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1737841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737862 */     // GIR_Coverage, 10927,
     /* 1737862 */     GIR_EraseRootFromParent_Done,
     /* 1737863 */   // Label 23728: @1737863
     /* 1737863 */   GIM_Try, /*On fail goto*//*Label 23729*/ GIMT_Encode4(1737949), // Rule ID 10930 //
     /* 1737868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1737879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1737882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1737885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1737891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737914 */     // MIs[0] policy
     /* 1737914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737924 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1737927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737948 */     // GIR_Coverage, 10930,
     /* 1737948 */     GIR_EraseRootFromParent_Done,
     /* 1737949 */   // Label 23729: @1737949
     /* 1737949 */   GIM_Try, /*On fail goto*//*Label 23730*/ GIMT_Encode4(1738035), // Rule ID 10931 //
     /* 1737954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1737965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1737968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1737971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1737977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738000 */     // MIs[0] policy
     /* 1738000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738010 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738034 */     // GIR_Coverage, 10931,
     /* 1738034 */     GIR_EraseRootFromParent_Done,
     /* 1738035 */   // Label 23730: @1738035
     /* 1738035 */   GIM_Try, /*On fail goto*//*Label 23731*/ GIMT_Encode4(1738121), // Rule ID 10934 //
     /* 1738040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1738051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1738054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1738057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1738063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738086 */     // MIs[0] policy
     /* 1738086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738096 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738120 */     // GIR_Coverage, 10934,
     /* 1738120 */     GIR_EraseRootFromParent_Done,
     /* 1738121 */   // Label 23731: @1738121
     /* 1738121 */   GIM_Try, /*On fail goto*//*Label 23732*/ GIMT_Encode4(1738207), // Rule ID 10935 //
     /* 1738126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1738137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1738140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1738143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1738149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738172 */     // MIs[0] policy
     /* 1738172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738182 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738206 */     // GIR_Coverage, 10935,
     /* 1738206 */     GIR_EraseRootFromParent_Done,
     /* 1738207 */   // Label 23732: @1738207
     /* 1738207 */   GIM_Try, /*On fail goto*//*Label 23733*/ GIMT_Encode4(1738293), // Rule ID 10938 //
     /* 1738212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1738223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1738226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1738229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738258 */     // MIs[0] policy
     /* 1738258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738292 */     // GIR_Coverage, 10938,
     /* 1738292 */     GIR_EraseRootFromParent_Done,
     /* 1738293 */   // Label 23733: @1738293
     /* 1738293 */   GIM_Try, /*On fail goto*//*Label 23734*/ GIMT_Encode4(1738379), // Rule ID 10939 //
     /* 1738298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1738309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1738312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1738315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738344 */     // MIs[0] policy
     /* 1738344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738354 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738378 */     // GIR_Coverage, 10939,
     /* 1738378 */     GIR_EraseRootFromParent_Done,
     /* 1738379 */   // Label 23734: @1738379
     /* 1738379 */   GIM_Try, /*On fail goto*//*Label 23735*/ GIMT_Encode4(1738465), // Rule ID 10942 //
     /* 1738384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1738395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1738398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1738401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738430 */     // MIs[0] policy
     /* 1738430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738440 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738464 */     // GIR_Coverage, 10942,
     /* 1738464 */     GIR_EraseRootFromParent_Done,
     /* 1738465 */   // Label 23735: @1738465
     /* 1738465 */   GIM_Try, /*On fail goto*//*Label 23736*/ GIMT_Encode4(1738551), // Rule ID 10943 //
     /* 1738470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1738481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1738484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1738487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738516 */     // MIs[0] policy
     /* 1738516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738526 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738550 */     // GIR_Coverage, 10943,
     /* 1738550 */     GIR_EraseRootFromParent_Done,
     /* 1738551 */   // Label 23736: @1738551
     /* 1738551 */   GIM_Try, /*On fail goto*//*Label 23737*/ GIMT_Encode4(1738637), // Rule ID 10946 //
     /* 1738556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1738567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1738570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1738573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738602 */     // MIs[0] policy
     /* 1738602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738612 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738636 */     // GIR_Coverage, 10946,
     /* 1738636 */     GIR_EraseRootFromParent_Done,
     /* 1738637 */   // Label 23737: @1738637
     /* 1738637 */   GIM_Try, /*On fail goto*//*Label 23738*/ GIMT_Encode4(1738723), // Rule ID 10947 //
     /* 1738642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1738653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1738656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1738659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738688 */     // MIs[0] policy
     /* 1738688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738698 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738722 */     // GIR_Coverage, 10947,
     /* 1738722 */     GIR_EraseRootFromParent_Done,
     /* 1738723 */   // Label 23738: @1738723
     /* 1738723 */   GIM_Try, /*On fail goto*//*Label 23739*/ GIMT_Encode4(1738809), // Rule ID 10950 //
     /* 1738728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1738739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1738742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1738745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738774 */     // MIs[0] policy
     /* 1738774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738808 */     // GIR_Coverage, 10950,
     /* 1738808 */     GIR_EraseRootFromParent_Done,
     /* 1738809 */   // Label 23739: @1738809
     /* 1738809 */   GIM_Try, /*On fail goto*//*Label 23740*/ GIMT_Encode4(1738895), // Rule ID 10951 //
     /* 1738814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1738825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1738828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1738831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738860 */     // MIs[0] policy
     /* 1738860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738894 */     // GIR_Coverage, 10951,
     /* 1738894 */     GIR_EraseRootFromParent_Done,
     /* 1738895 */   // Label 23740: @1738895
     /* 1738895 */   GIM_Try, /*On fail goto*//*Label 23741*/ GIMT_Encode4(1738981), // Rule ID 10954 //
     /* 1738900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1738911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1738914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1738917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738946 */     // MIs[0] policy
     /* 1738946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738956 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738980 */     // GIR_Coverage, 10954,
     /* 1738980 */     GIR_EraseRootFromParent_Done,
     /* 1738981 */   // Label 23741: @1738981
     /* 1738981 */   GIM_Try, /*On fail goto*//*Label 23742*/ GIMT_Encode4(1739067), // Rule ID 10955 //
     /* 1738986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1738997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1739000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1739003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739032 */     // MIs[0] policy
     /* 1739032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739042 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1739045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739066 */     // GIR_Coverage, 10955,
     /* 1739066 */     GIR_EraseRootFromParent_Done,
     /* 1739067 */   // Label 23742: @1739067
     /* 1739067 */   GIM_Try, /*On fail goto*//*Label 23743*/ GIMT_Encode4(1739153), // Rule ID 10958 //
     /* 1739072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1739083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1739086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1739089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739118 */     // MIs[0] policy
     /* 1739118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739128 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1739131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739152 */     // GIR_Coverage, 10958,
     /* 1739152 */     GIR_EraseRootFromParent_Done,
     /* 1739153 */   // Label 23743: @1739153
     /* 1739153 */   GIM_Try, /*On fail goto*//*Label 23744*/ GIMT_Encode4(1739239), // Rule ID 10959 //
     /* 1739158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1739169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1739172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1739175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739204 */     // MIs[0] policy
     /* 1739204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739214 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1739217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739238 */     // GIR_Coverage, 10959,
     /* 1739238 */     GIR_EraseRootFromParent_Done,
     /* 1739239 */   // Label 23744: @1739239
     /* 1739239 */   GIM_Try, /*On fail goto*//*Label 23745*/ GIMT_Encode4(1739325), // Rule ID 10962 //
     /* 1739244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1739247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1739255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1739258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1739261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739290 */     // MIs[0] policy
     /* 1739290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1739303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739324 */     // GIR_Coverage, 10962,
     /* 1739324 */     GIR_EraseRootFromParent_Done,
     /* 1739325 */   // Label 23745: @1739325
     /* 1739325 */   GIM_Try, /*On fail goto*//*Label 23746*/ GIMT_Encode4(1739411), // Rule ID 10963 //
     /* 1739330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1739341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1739344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1739347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739376 */     // MIs[0] policy
     /* 1739376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1739389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739410 */     // GIR_Coverage, 10963,
     /* 1739410 */     GIR_EraseRootFromParent_Done,
     /* 1739411 */   // Label 23746: @1739411
     /* 1739411 */   GIM_Try, /*On fail goto*//*Label 23747*/ GIMT_Encode4(1739497), // Rule ID 10966 //
     /* 1739416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1739419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1739427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1739430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1739433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739462 */     // MIs[0] policy
     /* 1739462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739472 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1739475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739496 */     // GIR_Coverage, 10966,
     /* 1739496 */     GIR_EraseRootFromParent_Done,
     /* 1739497 */   // Label 23747: @1739497
     /* 1739497 */   GIM_Try, /*On fail goto*//*Label 23748*/ GIMT_Encode4(1739583), // Rule ID 10967 //
     /* 1739502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1739513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1739516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1739519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739548 */     // MIs[0] policy
     /* 1739548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739558 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1739561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739582 */     // GIR_Coverage, 10967,
     /* 1739582 */     GIR_EraseRootFromParent_Done,
     /* 1739583 */   // Label 23748: @1739583
     /* 1739583 */   GIM_Try, /*On fail goto*//*Label 23749*/ GIMT_Encode4(1739669), // Rule ID 10970 //
     /* 1739588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1739591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1739599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1739602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1739605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739634 */     // MIs[0] policy
     /* 1739634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739644 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1739647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739668 */     // GIR_Coverage, 10970,
     /* 1739668 */     GIR_EraseRootFromParent_Done,
     /* 1739669 */   // Label 23749: @1739669
     /* 1739669 */   GIM_Try, /*On fail goto*//*Label 23750*/ GIMT_Encode4(1739755), // Rule ID 10971 //
     /* 1739674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1739685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1739688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1739691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739720 */     // MIs[0] policy
     /* 1739720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739730 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1739733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739754 */     // GIR_Coverage, 10971,
     /* 1739754 */     GIR_EraseRootFromParent_Done,
     /* 1739755 */   // Label 23750: @1739755
     /* 1739755 */   GIM_Try, /*On fail goto*//*Label 23751*/ GIMT_Encode4(1739841), // Rule ID 10974 //
     /* 1739760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1739771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1739774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1739777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1739780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739806 */     // MIs[0] policy
     /* 1739806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739816 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1739819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739840 */     // GIR_Coverage, 10974,
     /* 1739840 */     GIR_EraseRootFromParent_Done,
     /* 1739841 */   // Label 23751: @1739841
     /* 1739841 */   GIM_Try, /*On fail goto*//*Label 23752*/ GIMT_Encode4(1739927), // Rule ID 10975 //
     /* 1739846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1739857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1739860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1739863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1739866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739892 */     // MIs[0] policy
     /* 1739892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739902 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1739905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739926 */     // GIR_Coverage, 10975,
     /* 1739926 */     GIR_EraseRootFromParent_Done,
     /* 1739927 */   // Label 23752: @1739927
     /* 1739927 */   GIM_Try, /*On fail goto*//*Label 23753*/ GIMT_Encode4(1740013), // Rule ID 10978 //
     /* 1739932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1739943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1739946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1739949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1739952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739978 */     // MIs[0] policy
     /* 1739978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739988 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1739991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740012 */     // GIR_Coverage, 10978,
     /* 1740012 */     GIR_EraseRootFromParent_Done,
     /* 1740013 */   // Label 23753: @1740013
     /* 1740013 */   GIM_Try, /*On fail goto*//*Label 23754*/ GIMT_Encode4(1740099), // Rule ID 10979 //
     /* 1740018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1740029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1740032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1740035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1740038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740064 */     // MIs[0] policy
     /* 1740064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740074 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1740077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740098 */     // GIR_Coverage, 10979,
     /* 1740098 */     GIR_EraseRootFromParent_Done,
     /* 1740099 */   // Label 23754: @1740099
     /* 1740099 */   GIM_Try, /*On fail goto*//*Label 23755*/ GIMT_Encode4(1740185), // Rule ID 10982 //
     /* 1740104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1740115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1740118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1740121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1740124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740150 */     // MIs[0] policy
     /* 1740150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740160 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740184 */     // GIR_Coverage, 10982,
     /* 1740184 */     GIR_EraseRootFromParent_Done,
     /* 1740185 */   // Label 23755: @1740185
     /* 1740185 */   GIM_Try, /*On fail goto*//*Label 23756*/ GIMT_Encode4(1740271), // Rule ID 10983 //
     /* 1740190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1740201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1740204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1740207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1740210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740236 */     // MIs[0] policy
     /* 1740236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740246 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740270 */     // GIR_Coverage, 10983,
     /* 1740270 */     GIR_EraseRootFromParent_Done,
     /* 1740271 */   // Label 23756: @1740271
     /* 1740271 */   GIM_Try, /*On fail goto*//*Label 23757*/ GIMT_Encode4(1740357), // Rule ID 10986 //
     /* 1740276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1740287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1740290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1740293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1740296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740322 */     // MIs[0] policy
     /* 1740322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740332 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1740335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740356 */     // GIR_Coverage, 10986,
     /* 1740356 */     GIR_EraseRootFromParent_Done,
     /* 1740357 */   // Label 23757: @1740357
     /* 1740357 */   GIM_Try, /*On fail goto*//*Label 23758*/ GIMT_Encode4(1740443), // Rule ID 10987 //
     /* 1740362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1740373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1740376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1740379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1740382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740408 */     // MIs[0] policy
     /* 1740408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740418 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1740421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740442 */     // GIR_Coverage, 10987,
     /* 1740442 */     GIR_EraseRootFromParent_Done,
     /* 1740443 */   // Label 23758: @1740443
     /* 1740443 */   GIM_Try, /*On fail goto*//*Label 23759*/ GIMT_Encode4(1740529), // Rule ID 10990 //
     /* 1740448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1740459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1740462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1740465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1740468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740494 */     // MIs[0] policy
     /* 1740494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740504 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740528 */     // GIR_Coverage, 10990,
     /* 1740528 */     GIR_EraseRootFromParent_Done,
     /* 1740529 */   // Label 23759: @1740529
     /* 1740529 */   GIM_Try, /*On fail goto*//*Label 23760*/ GIMT_Encode4(1740615), // Rule ID 10991 //
     /* 1740534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1740545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1740548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1740551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1740554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740580 */     // MIs[0] policy
     /* 1740580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740590 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740614 */     // GIR_Coverage, 10991,
     /* 1740614 */     GIR_EraseRootFromParent_Done,
     /* 1740615 */   // Label 23760: @1740615
     /* 1740615 */   GIM_Try, /*On fail goto*//*Label 23761*/ GIMT_Encode4(1740701), // Rule ID 10994 //
     /* 1740620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1740631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1740634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1740637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1740640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740666 */     // MIs[0] policy
     /* 1740666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740676 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740700 */     // GIR_Coverage, 10994,
     /* 1740700 */     GIR_EraseRootFromParent_Done,
     /* 1740701 */   // Label 23761: @1740701
     /* 1740701 */   GIM_Try, /*On fail goto*//*Label 23762*/ GIMT_Encode4(1740787), // Rule ID 10995 //
     /* 1740706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1740717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1740720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1740723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1740726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740752 */     // MIs[0] policy
     /* 1740752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740762 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740786 */     // GIR_Coverage, 10995,
     /* 1740786 */     GIR_EraseRootFromParent_Done,
     /* 1740787 */   // Label 23762: @1740787
     /* 1740787 */   GIM_Try, /*On fail goto*//*Label 23763*/ GIMT_Encode4(1740873), // Rule ID 10998 //
     /* 1740792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1740803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1740806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1740809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1740812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740838 */     // MIs[0] policy
     /* 1740838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740848 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740872 */     // GIR_Coverage, 10998,
     /* 1740872 */     GIR_EraseRootFromParent_Done,
     /* 1740873 */   // Label 23763: @1740873
     /* 1740873 */   GIM_Try, /*On fail goto*//*Label 23764*/ GIMT_Encode4(1740959), // Rule ID 10999 //
     /* 1740878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1740889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1740892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1740895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1740898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740924 */     // MIs[0] policy
     /* 1740924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740958 */     // GIR_Coverage, 10999,
     /* 1740958 */     GIR_EraseRootFromParent_Done,
     /* 1740959 */   // Label 23764: @1740959
     /* 1740959 */   GIM_Try, /*On fail goto*//*Label 23765*/ GIMT_Encode4(1741045), // Rule ID 11002 //
     /* 1740964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1740975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1740978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1740981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1740984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741010 */     // MIs[0] policy
     /* 1741010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1741023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741044 */     // GIR_Coverage, 11002,
     /* 1741044 */     GIR_EraseRootFromParent_Done,
     /* 1741045 */   // Label 23765: @1741045
     /* 1741045 */   GIM_Try, /*On fail goto*//*Label 23766*/ GIMT_Encode4(1741131), // Rule ID 11003 //
     /* 1741050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1741061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1741064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1741067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1741070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1741073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741096 */     // MIs[0] policy
     /* 1741096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1741109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741130 */     // GIR_Coverage, 11003,
     /* 1741130 */     GIR_EraseRootFromParent_Done,
     /* 1741131 */   // Label 23766: @1741131
     /* 1741131 */   GIM_Try, /*On fail goto*//*Label 23767*/ GIMT_Encode4(1741217), // Rule ID 11006 //
     /* 1741136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1741147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1741150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1741153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1741156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741182 */     // MIs[0] policy
     /* 1741182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741192 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1741195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1741213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741216 */     // GIR_Coverage, 11006,
     /* 1741216 */     GIR_EraseRootFromParent_Done,
     /* 1741217 */   // Label 23767: @1741217
     /* 1741217 */   GIM_Try, /*On fail goto*//*Label 23768*/ GIMT_Encode4(1741303), // Rule ID 11007 //
     /* 1741222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1741233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1741236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1741239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1741242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741268 */     // MIs[0] policy
     /* 1741268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741278 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1741281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1741299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741302 */     // GIR_Coverage, 11007,
     /* 1741302 */     GIR_EraseRootFromParent_Done,
     /* 1741303 */   // Label 23768: @1741303
     /* 1741303 */   GIM_Try, /*On fail goto*//*Label 23769*/ GIMT_Encode4(1741389), // Rule ID 11010 //
     /* 1741308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1741311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1741319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1741322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1741325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1741328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741354 */     // MIs[0] policy
     /* 1741354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741364 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1741367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1741385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741388 */     // GIR_Coverage, 11010,
     /* 1741388 */     GIR_EraseRootFromParent_Done,
     /* 1741389 */   // Label 23769: @1741389
     /* 1741389 */   GIM_Try, /*On fail goto*//*Label 23770*/ GIMT_Encode4(1741475), // Rule ID 11011 //
     /* 1741394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1741397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1741405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1741408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1741411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1741414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741440 */     // MIs[0] policy
     /* 1741440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741450 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1741453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1741471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741474 */     // GIR_Coverage, 11011,
     /* 1741474 */     GIR_EraseRootFromParent_Done,
     /* 1741475 */   // Label 23770: @1741475
     /* 1741475 */   GIM_Try, /*On fail goto*//*Label 23771*/ GIMT_Encode4(1741561), // Rule ID 11014 //
     /* 1741480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1741491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1741494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1741497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1741500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741526 */     // MIs[0] policy
     /* 1741526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1741539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741560 */     // GIR_Coverage, 11014,
     /* 1741560 */     GIR_EraseRootFromParent_Done,
     /* 1741561 */   // Label 23771: @1741561
     /* 1741561 */   GIM_Try, /*On fail goto*//*Label 23772*/ GIMT_Encode4(1741647), // Rule ID 11015 //
     /* 1741566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1741577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1741580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1741583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1741586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741612 */     // MIs[0] policy
     /* 1741612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741622 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1741625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741646 */     // GIR_Coverage, 11015,
     /* 1741646 */     GIR_EraseRootFromParent_Done,
     /* 1741647 */   // Label 23772: @1741647
     /* 1741647 */   GIM_Try, /*On fail goto*//*Label 23773*/ GIMT_Encode4(1741733), // Rule ID 11018 //
     /* 1741652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1741663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1741666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1741669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1741672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741698 */     // MIs[0] policy
     /* 1741698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741708 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1741711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741732 */     // GIR_Coverage, 11018,
     /* 1741732 */     GIR_EraseRootFromParent_Done,
     /* 1741733 */   // Label 23773: @1741733
     /* 1741733 */   GIM_Try, /*On fail goto*//*Label 23774*/ GIMT_Encode4(1741819), // Rule ID 11019 //
     /* 1741738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1741749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1741752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1741755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1741758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741784 */     // MIs[0] policy
     /* 1741784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741794 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1741797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741818 */     // GIR_Coverage, 11019,
     /* 1741818 */     GIR_EraseRootFromParent_Done,
     /* 1741819 */   // Label 23774: @1741819
     /* 1741819 */   GIM_Try, /*On fail goto*//*Label 23775*/ GIMT_Encode4(1741905), // Rule ID 11022 //
     /* 1741824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1741835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1741838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1741841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1741844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1741847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741870 */     // MIs[0] policy
     /* 1741870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741880 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1741883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741904 */     // GIR_Coverage, 11022,
     /* 1741904 */     GIR_EraseRootFromParent_Done,
     /* 1741905 */   // Label 23775: @1741905
     /* 1741905 */   GIM_Try, /*On fail goto*//*Label 23776*/ GIMT_Encode4(1741991), // Rule ID 11023 //
     /* 1741910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1741921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1741924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1741927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1741930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1741933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741956 */     // MIs[0] policy
     /* 1741956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741966 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1741969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741990 */     // GIR_Coverage, 11023,
     /* 1741990 */     GIR_EraseRootFromParent_Done,
     /* 1741991 */   // Label 23776: @1741991
     /* 1741991 */   GIM_Try, /*On fail goto*//*Label 23777*/ GIMT_Encode4(1742077), // Rule ID 11026 //
     /* 1741996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1742007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1742010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1742013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1742016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742042 */     // MIs[0] policy
     /* 1742042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742052 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742076 */     // GIR_Coverage, 11026,
     /* 1742076 */     GIR_EraseRootFromParent_Done,
     /* 1742077 */   // Label 23777: @1742077
     /* 1742077 */   GIM_Try, /*On fail goto*//*Label 23778*/ GIMT_Encode4(1742163), // Rule ID 11027 //
     /* 1742082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1742093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1742096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1742099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1742102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742128 */     // MIs[0] policy
     /* 1742128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742162 */     // GIR_Coverage, 11027,
     /* 1742162 */     GIR_EraseRootFromParent_Done,
     /* 1742163 */   // Label 23778: @1742163
     /* 1742163 */   GIM_Try, /*On fail goto*//*Label 23779*/ GIMT_Encode4(1742249), // Rule ID 11030 //
     /* 1742168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1742179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1742182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1742185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1742188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742214 */     // MIs[0] policy
     /* 1742214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742224 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742248 */     // GIR_Coverage, 11030,
     /* 1742248 */     GIR_EraseRootFromParent_Done,
     /* 1742249 */   // Label 23779: @1742249
     /* 1742249 */   GIM_Try, /*On fail goto*//*Label 23780*/ GIMT_Encode4(1742335), // Rule ID 11031 //
     /* 1742254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1742265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1742268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1742271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1742274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742300 */     // MIs[0] policy
     /* 1742300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742310 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742334 */     // GIR_Coverage, 11031,
     /* 1742334 */     GIR_EraseRootFromParent_Done,
     /* 1742335 */   // Label 23780: @1742335
     /* 1742335 */   GIM_Try, /*On fail goto*//*Label 23781*/ GIMT_Encode4(1742421), // Rule ID 11034 //
     /* 1742340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1742351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1742354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1742357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1742360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1742363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742386 */     // MIs[0] policy
     /* 1742386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742396 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742420 */     // GIR_Coverage, 11034,
     /* 1742420 */     GIR_EraseRootFromParent_Done,
     /* 1742421 */   // Label 23781: @1742421
     /* 1742421 */   GIM_Try, /*On fail goto*//*Label 23782*/ GIMT_Encode4(1742507), // Rule ID 11035 //
     /* 1742426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1742437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1742440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1742443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1742446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1742449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742472 */     // MIs[0] policy
     /* 1742472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742482 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742506 */     // GIR_Coverage, 11035,
     /* 1742506 */     GIR_EraseRootFromParent_Done,
     /* 1742507 */   // Label 23782: @1742507
     /* 1742507 */   GIM_Try, /*On fail goto*//*Label 23783*/ GIMT_Encode4(1742593), // Rule ID 11038 //
     /* 1742512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1742523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1742526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1742529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1742532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742558 */     // MIs[0] policy
     /* 1742558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742592 */     // GIR_Coverage, 11038,
     /* 1742592 */     GIR_EraseRootFromParent_Done,
     /* 1742593 */   // Label 23783: @1742593
     /* 1742593 */   GIM_Try, /*On fail goto*//*Label 23784*/ GIMT_Encode4(1742679), // Rule ID 11039 //
     /* 1742598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1742609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1742612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1742615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1742618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742644 */     // MIs[0] policy
     /* 1742644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742678 */     // GIR_Coverage, 11039,
     /* 1742678 */     GIR_EraseRootFromParent_Done,
     /* 1742679 */   // Label 23784: @1742679
     /* 1742679 */   GIM_Try, /*On fail goto*//*Label 23785*/ GIMT_Encode4(1742765), // Rule ID 11042 //
     /* 1742684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1742695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1742698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1742701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1742704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742730 */     // MIs[0] policy
     /* 1742730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742740 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742764 */     // GIR_Coverage, 11042,
     /* 1742764 */     GIR_EraseRootFromParent_Done,
     /* 1742765 */   // Label 23785: @1742765
     /* 1742765 */   GIM_Try, /*On fail goto*//*Label 23786*/ GIMT_Encode4(1742851), // Rule ID 11043 //
     /* 1742770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1742781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1742784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1742787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1742790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742816 */     // MIs[0] policy
     /* 1742816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742826 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742850 */     // GIR_Coverage, 11043,
     /* 1742850 */     GIR_EraseRootFromParent_Done,
     /* 1742851 */   // Label 23786: @1742851
     /* 1742851 */   GIM_Try, /*On fail goto*//*Label 23787*/ GIMT_Encode4(1742937), // Rule ID 11046 //
     /* 1742856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1742867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1742870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1742873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1742876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742902 */     // MIs[0] policy
     /* 1742902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742912 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742936 */     // GIR_Coverage, 11046,
     /* 1742936 */     GIR_EraseRootFromParent_Done,
     /* 1742937 */   // Label 23787: @1742937
     /* 1742937 */   GIM_Try, /*On fail goto*//*Label 23788*/ GIMT_Encode4(1743023), // Rule ID 11047 //
     /* 1742942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1742953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1742956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1742959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1742962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742988 */     // MIs[0] policy
     /* 1742988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742998 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1743001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1743019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743022 */     // GIR_Coverage, 11047,
     /* 1743022 */     GIR_EraseRootFromParent_Done,
     /* 1743023 */   // Label 23788: @1743023
     /* 1743023 */   GIM_Try, /*On fail goto*//*Label 23789*/ GIMT_Encode4(1743109), // Rule ID 11050 //
     /* 1743028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1743031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1743039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1743042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1743045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1743048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1743058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743074 */     // MIs[0] policy
     /* 1743074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1743087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743108 */     // GIR_Coverage, 11050,
     /* 1743108 */     GIR_EraseRootFromParent_Done,
     /* 1743109 */   // Label 23789: @1743109
     /* 1743109 */   GIM_Try, /*On fail goto*//*Label 23790*/ GIMT_Encode4(1743195), // Rule ID 11051 //
     /* 1743114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1743117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1743125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1743128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1743131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1743134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1743144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743160 */     // MIs[0] policy
     /* 1743160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1743173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743194 */     // GIR_Coverage, 11051,
     /* 1743194 */     GIR_EraseRootFromParent_Done,
     /* 1743195 */   // Label 23790: @1743195
     /* 1743195 */   GIM_Try, /*On fail goto*//*Label 23791*/ GIMT_Encode4(1743281), // Rule ID 11054 //
     /* 1743200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1743203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1743211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1743214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1743217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1743220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743246 */     // MIs[0] policy
     /* 1743246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743256 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1743259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743280 */     // GIR_Coverage, 11054,
     /* 1743280 */     GIR_EraseRootFromParent_Done,
     /* 1743281 */   // Label 23791: @1743281
     /* 1743281 */   GIM_Try, /*On fail goto*//*Label 23792*/ GIMT_Encode4(1743367), // Rule ID 11055 //
     /* 1743286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1743289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1743297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1743300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1743303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1743306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743332 */     // MIs[0] policy
     /* 1743332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743342 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1743345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743366 */     // GIR_Coverage, 11055,
     /* 1743366 */     GIR_EraseRootFromParent_Done,
     /* 1743367 */   // Label 23792: @1743367
     /* 1743367 */   GIM_Try, /*On fail goto*//*Label 23793*/ GIMT_Encode4(1743453), // Rule ID 11058 //
     /* 1743372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1743375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1743383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1743386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1743389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1743392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743418 */     // MIs[0] policy
     /* 1743418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743428 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1743431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743452 */     // GIR_Coverage, 11058,
     /* 1743452 */     GIR_EraseRootFromParent_Done,
     /* 1743453 */   // Label 23793: @1743453
     /* 1743453 */   GIM_Try, /*On fail goto*//*Label 23794*/ GIMT_Encode4(1743539), // Rule ID 11059 //
     /* 1743458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1743461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1743469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1743472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1743475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1743478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743504 */     // MIs[0] policy
     /* 1743504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743514 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1743517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743538 */     // GIR_Coverage, 11059,
     /* 1743538 */     GIR_EraseRootFromParent_Done,
     /* 1743539 */   // Label 23794: @1743539
     /* 1743539 */   GIM_Try, /*On fail goto*//*Label 23795*/ GIMT_Encode4(1743625), // Rule ID 11062 //
     /* 1743544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1743555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1743558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1743561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743590 */     // MIs[0] policy
     /* 1743590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743600 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1743603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743624 */     // GIR_Coverage, 11062,
     /* 1743624 */     GIR_EraseRootFromParent_Done,
     /* 1743625 */   // Label 23795: @1743625
     /* 1743625 */   GIM_Try, /*On fail goto*//*Label 23796*/ GIMT_Encode4(1743711), // Rule ID 11063 //
     /* 1743630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1743641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1743644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1743647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743676 */     // MIs[0] policy
     /* 1743676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743686 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1743689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743710 */     // GIR_Coverage, 11063,
     /* 1743710 */     GIR_EraseRootFromParent_Done,
     /* 1743711 */   // Label 23796: @1743711
     /* 1743711 */   GIM_Try, /*On fail goto*//*Label 23797*/ GIMT_Encode4(1743797), // Rule ID 11066 //
     /* 1743716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1743727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1743730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1743733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743762 */     // MIs[0] policy
     /* 1743762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743772 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1743775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743796 */     // GIR_Coverage, 11066,
     /* 1743796 */     GIR_EraseRootFromParent_Done,
     /* 1743797 */   // Label 23797: @1743797
     /* 1743797 */   GIM_Try, /*On fail goto*//*Label 23798*/ GIMT_Encode4(1743883), // Rule ID 11067 //
     /* 1743802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1743813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1743816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1743819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743848 */     // MIs[0] policy
     /* 1743848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743858 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1743861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743882 */     // GIR_Coverage, 11067,
     /* 1743882 */     GIR_EraseRootFromParent_Done,
     /* 1743883 */   // Label 23798: @1743883
     /* 1743883 */   GIM_Try, /*On fail goto*//*Label 23799*/ GIMT_Encode4(1743969), // Rule ID 11070 //
     /* 1743888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1743899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1743902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1743905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743934 */     // MIs[0] policy
     /* 1743934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743944 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1743947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743968 */     // GIR_Coverage, 11070,
     /* 1743968 */     GIR_EraseRootFromParent_Done,
     /* 1743969 */   // Label 23799: @1743969
     /* 1743969 */   GIM_Try, /*On fail goto*//*Label 23800*/ GIMT_Encode4(1744055), // Rule ID 11071 //
     /* 1743974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1743985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1743988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1743991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744020 */     // MIs[0] policy
     /* 1744020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744030 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744054 */     // GIR_Coverage, 11071,
     /* 1744054 */     GIR_EraseRootFromParent_Done,
     /* 1744055 */   // Label 23800: @1744055
     /* 1744055 */   GIM_Try, /*On fail goto*//*Label 23801*/ GIMT_Encode4(1744141), // Rule ID 11074 //
     /* 1744060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1744071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1744074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1744077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744106 */     // MIs[0] policy
     /* 1744106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744116 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1744119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744140 */     // GIR_Coverage, 11074,
     /* 1744140 */     GIR_EraseRootFromParent_Done,
     /* 1744141 */   // Label 23801: @1744141
     /* 1744141 */   GIM_Try, /*On fail goto*//*Label 23802*/ GIMT_Encode4(1744227), // Rule ID 11075 //
     /* 1744146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1744157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1744160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1744163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744192 */     // MIs[0] policy
     /* 1744192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744202 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1744205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744226 */     // GIR_Coverage, 11075,
     /* 1744226 */     GIR_EraseRootFromParent_Done,
     /* 1744227 */   // Label 23802: @1744227
     /* 1744227 */   GIM_Try, /*On fail goto*//*Label 23803*/ GIMT_Encode4(1744313), // Rule ID 11078 //
     /* 1744232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1744243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1744246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1744249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744278 */     // MIs[0] policy
     /* 1744278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744288 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744312 */     // GIR_Coverage, 11078,
     /* 1744312 */     GIR_EraseRootFromParent_Done,
     /* 1744313 */   // Label 23803: @1744313
     /* 1744313 */   GIM_Try, /*On fail goto*//*Label 23804*/ GIMT_Encode4(1744399), // Rule ID 11079 //
     /* 1744318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1744329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1744332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1744335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744364 */     // MIs[0] policy
     /* 1744364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744374 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744398 */     // GIR_Coverage, 11079,
     /* 1744398 */     GIR_EraseRootFromParent_Done,
     /* 1744399 */   // Label 23804: @1744399
     /* 1744399 */   GIM_Try, /*On fail goto*//*Label 23805*/ GIMT_Encode4(1744485), // Rule ID 11082 //
     /* 1744404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1744415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1744418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1744421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744450 */     // MIs[0] policy
     /* 1744450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744460 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744484 */     // GIR_Coverage, 11082,
     /* 1744484 */     GIR_EraseRootFromParent_Done,
     /* 1744485 */   // Label 23805: @1744485
     /* 1744485 */   GIM_Try, /*On fail goto*//*Label 23806*/ GIMT_Encode4(1744571), // Rule ID 11083 //
     /* 1744490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1744501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1744504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1744507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744536 */     // MIs[0] policy
     /* 1744536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744570 */     // GIR_Coverage, 11083,
     /* 1744570 */     GIR_EraseRootFromParent_Done,
     /* 1744571 */   // Label 23806: @1744571
     /* 1744571 */   GIM_Try, /*On fail goto*//*Label 23807*/ GIMT_Encode4(1744657), // Rule ID 11086 //
     /* 1744576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1744587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1744590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1744593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744622 */     // MIs[0] policy
     /* 1744622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744632 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744656 */     // GIR_Coverage, 11086,
     /* 1744656 */     GIR_EraseRootFromParent_Done,
     /* 1744657 */   // Label 23807: @1744657
     /* 1744657 */   GIM_Try, /*On fail goto*//*Label 23808*/ GIMT_Encode4(1744743), // Rule ID 11087 //
     /* 1744662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1744673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1744676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1744679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744708 */     // MIs[0] policy
     /* 1744708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744742 */     // GIR_Coverage, 11087,
     /* 1744742 */     GIR_EraseRootFromParent_Done,
     /* 1744743 */   // Label 23808: @1744743
     /* 1744743 */   GIM_Try, /*On fail goto*//*Label 23809*/ GIMT_Encode4(1744829), // Rule ID 11090 //
     /* 1744748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1744759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1744762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1744765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744794 */     // MIs[0] policy
     /* 1744794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744828 */     // GIR_Coverage, 11090,
     /* 1744828 */     GIR_EraseRootFromParent_Done,
     /* 1744829 */   // Label 23809: @1744829
     /* 1744829 */   GIM_Try, /*On fail goto*//*Label 23810*/ GIMT_Encode4(1744915), // Rule ID 11091 //
     /* 1744834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1744845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1744848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1744851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744880 */     // MIs[0] policy
     /* 1744880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744914 */     // GIR_Coverage, 11091,
     /* 1744914 */     GIR_EraseRootFromParent_Done,
     /* 1744915 */   // Label 23810: @1744915
     /* 1744915 */   GIM_Try, /*On fail goto*//*Label 23811*/ GIMT_Encode4(1745001), // Rule ID 11094 //
     /* 1744920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1744931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1744934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1744937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744966 */     // MIs[0] policy
     /* 1744966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744976 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745000 */     // GIR_Coverage, 11094,
     /* 1745000 */     GIR_EraseRootFromParent_Done,
     /* 1745001 */   // Label 23811: @1745001
     /* 1745001 */   GIM_Try, /*On fail goto*//*Label 23812*/ GIMT_Encode4(1745087), // Rule ID 11095 //
     /* 1745006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1745017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1745020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1745023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1745029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745052 */     // MIs[0] policy
     /* 1745052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745062 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1745065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1745083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745086 */     // GIR_Coverage, 11095,
     /* 1745086 */     GIR_EraseRootFromParent_Done,
     /* 1745087 */   // Label 23812: @1745087
     /* 1745087 */   GIM_Try, /*On fail goto*//*Label 23813*/ GIMT_Encode4(1745173), // Rule ID 11098 //
     /* 1745092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1745095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1745103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1745106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1745109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1745115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745138 */     // MIs[0] policy
     /* 1745138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745148 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1745151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1745169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745172 */     // GIR_Coverage, 11098,
     /* 1745172 */     GIR_EraseRootFromParent_Done,
     /* 1745173 */   // Label 23813: @1745173
     /* 1745173 */   GIM_Try, /*On fail goto*//*Label 23814*/ GIMT_Encode4(1745259), // Rule ID 11099 //
     /* 1745178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1745181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1745189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1745192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1745195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1745201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745224 */     // MIs[0] policy
     /* 1745224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745234 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1745237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1745255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745258 */     // GIR_Coverage, 11099,
     /* 1745258 */     GIR_EraseRootFromParent_Done,
     /* 1745259 */   // Label 23814: @1745259
     /* 1745259 */   GIM_Try, /*On fail goto*//*Label 23815*/ GIMT_Encode4(1745345), // Rule ID 11102 //
     /* 1745264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1745275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1745278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1745281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745310 */     // MIs[0] policy
     /* 1745310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745344 */     // GIR_Coverage, 11102,
     /* 1745344 */     GIR_EraseRootFromParent_Done,
     /* 1745345 */   // Label 23815: @1745345
     /* 1745345 */   GIM_Try, /*On fail goto*//*Label 23816*/ GIMT_Encode4(1745431), // Rule ID 11103 //
     /* 1745350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1745361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1745364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1745367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745396 */     // MIs[0] policy
     /* 1745396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745406 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745430 */     // GIR_Coverage, 11103,
     /* 1745430 */     GIR_EraseRootFromParent_Done,
     /* 1745431 */   // Label 23816: @1745431
     /* 1745431 */   GIM_Try, /*On fail goto*//*Label 23817*/ GIMT_Encode4(1745517), // Rule ID 11106 //
     /* 1745436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1745447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1745450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1745453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745482 */     // MIs[0] policy
     /* 1745482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745492 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1745495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745516 */     // GIR_Coverage, 11106,
     /* 1745516 */     GIR_EraseRootFromParent_Done,
     /* 1745517 */   // Label 23817: @1745517
     /* 1745517 */   GIM_Try, /*On fail goto*//*Label 23818*/ GIMT_Encode4(1745603), // Rule ID 11107 //
     /* 1745522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1745533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1745536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1745539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745568 */     // MIs[0] policy
     /* 1745568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745578 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1745581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745602 */     // GIR_Coverage, 11107,
     /* 1745602 */     GIR_EraseRootFromParent_Done,
     /* 1745603 */   // Label 23818: @1745603
     /* 1745603 */   GIM_Try, /*On fail goto*//*Label 23819*/ GIMT_Encode4(1745689), // Rule ID 11110 //
     /* 1745608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1745619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1745622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1745625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1745631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745654 */     // MIs[0] policy
     /* 1745654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745664 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1745667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745688 */     // GIR_Coverage, 11110,
     /* 1745688 */     GIR_EraseRootFromParent_Done,
     /* 1745689 */   // Label 23819: @1745689
     /* 1745689 */   GIM_Try, /*On fail goto*//*Label 23820*/ GIMT_Encode4(1745775), // Rule ID 11111 //
     /* 1745694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1745705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1745708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1745711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1745717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745740 */     // MIs[0] policy
     /* 1745740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745750 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1745753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745774 */     // GIR_Coverage, 11111,
     /* 1745774 */     GIR_EraseRootFromParent_Done,
     /* 1745775 */   // Label 23820: @1745775
     /* 1745775 */   GIM_Try, /*On fail goto*//*Label 23821*/ GIMT_Encode4(1745861), // Rule ID 11114 //
     /* 1745780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1745797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745826 */     // MIs[0] policy
     /* 1745826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745860 */     // GIR_Coverage, 11114,
     /* 1745860 */     GIR_EraseRootFromParent_Done,
     /* 1745861 */   // Label 23821: @1745861
     /* 1745861 */   GIM_Try, /*On fail goto*//*Label 23822*/ GIMT_Encode4(1745947), // Rule ID 11115 //
     /* 1745866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1745883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745912 */     // MIs[0] policy
     /* 1745912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745946 */     // GIR_Coverage, 11115,
     /* 1745946 */     GIR_EraseRootFromParent_Done,
     /* 1745947 */   // Label 23822: @1745947
     /* 1745947 */   GIM_Try, /*On fail goto*//*Label 23823*/ GIMT_Encode4(1746033), // Rule ID 11118 //
     /* 1745952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1745963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1745966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1745969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745998 */     // MIs[0] policy
     /* 1745998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746008 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746032 */     // GIR_Coverage, 11118,
     /* 1746032 */     GIR_EraseRootFromParent_Done,
     /* 1746033 */   // Label 23823: @1746033
     /* 1746033 */   GIM_Try, /*On fail goto*//*Label 23824*/ GIMT_Encode4(1746119), // Rule ID 11119 //
     /* 1746038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1746049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1746052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1746055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746084 */     // MIs[0] policy
     /* 1746084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746094 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746118 */     // GIR_Coverage, 11119,
     /* 1746118 */     GIR_EraseRootFromParent_Done,
     /* 1746119 */   // Label 23824: @1746119
     /* 1746119 */   GIM_Try, /*On fail goto*//*Label 23825*/ GIMT_Encode4(1746205), // Rule ID 11122 //
     /* 1746124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1746135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1746138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1746141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1746147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746170 */     // MIs[0] policy
     /* 1746170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746180 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746204 */     // GIR_Coverage, 11122,
     /* 1746204 */     GIR_EraseRootFromParent_Done,
     /* 1746205 */   // Label 23825: @1746205
     /* 1746205 */   GIM_Try, /*On fail goto*//*Label 23826*/ GIMT_Encode4(1746291), // Rule ID 11123 //
     /* 1746210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1746221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1746224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1746227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1746233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746256 */     // MIs[0] policy
     /* 1746256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746266 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746290 */     // GIR_Coverage, 11123,
     /* 1746290 */     GIR_EraseRootFromParent_Done,
     /* 1746291 */   // Label 23826: @1746291
     /* 1746291 */   GIM_Try, /*On fail goto*//*Label 23827*/ GIMT_Encode4(1746377), // Rule ID 11126 //
     /* 1746296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1746307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1746310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1746313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746342 */     // MIs[0] policy
     /* 1746342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1746355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746376 */     // GIR_Coverage, 11126,
     /* 1746376 */     GIR_EraseRootFromParent_Done,
     /* 1746377 */   // Label 23827: @1746377
     /* 1746377 */   GIM_Try, /*On fail goto*//*Label 23828*/ GIMT_Encode4(1746463), // Rule ID 11127 //
     /* 1746382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1746393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1746396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1746399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746428 */     // MIs[0] policy
     /* 1746428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1746441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746462 */     // GIR_Coverage, 11127,
     /* 1746462 */     GIR_EraseRootFromParent_Done,
     /* 1746463 */   // Label 23828: @1746463
     /* 1746463 */   GIM_Try, /*On fail goto*//*Label 23829*/ GIMT_Encode4(1746549), // Rule ID 11130 //
     /* 1746468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1746485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746514 */     // MIs[0] policy
     /* 1746514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746548 */     // GIR_Coverage, 11130,
     /* 1746548 */     GIR_EraseRootFromParent_Done,
     /* 1746549 */   // Label 23829: @1746549
     /* 1746549 */   GIM_Try, /*On fail goto*//*Label 23830*/ GIMT_Encode4(1746635), // Rule ID 11131 //
     /* 1746554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1746571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746600 */     // MIs[0] policy
     /* 1746600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746610 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746634 */     // GIR_Coverage, 11131,
     /* 1746634 */     GIR_EraseRootFromParent_Done,
     /* 1746635 */   // Label 23830: @1746635
     /* 1746635 */   GIM_Try, /*On fail goto*//*Label 23831*/ GIMT_Encode4(1746721), // Rule ID 11134 //
     /* 1746640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1746657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746686 */     // MIs[0] policy
     /* 1746686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746720 */     // GIR_Coverage, 11134,
     /* 1746720 */     GIR_EraseRootFromParent_Done,
     /* 1746721 */   // Label 23831: @1746721
     /* 1746721 */   GIM_Try, /*On fail goto*//*Label 23832*/ GIMT_Encode4(1746807), // Rule ID 11135 //
     /* 1746726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1746743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746772 */     // MIs[0] policy
     /* 1746772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746782 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746806 */     // GIR_Coverage, 11135,
     /* 1746806 */     GIR_EraseRootFromParent_Done,
     /* 1746807 */   // Label 23832: @1746807
     /* 1746807 */   GIM_Try, /*On fail goto*//*Label 23833*/ GIMT_Encode4(1746893), // Rule ID 11138 //
     /* 1746812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1746823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1746826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1746829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746858 */     // MIs[0] policy
     /* 1746858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1746871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746892 */     // GIR_Coverage, 11138,
     /* 1746892 */     GIR_EraseRootFromParent_Done,
     /* 1746893 */   // Label 23833: @1746893
     /* 1746893 */   GIM_Try, /*On fail goto*//*Label 23834*/ GIMT_Encode4(1746979), // Rule ID 11139 //
     /* 1746898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1746901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1746909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1746912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1746915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746944 */     // MIs[0] policy
     /* 1746944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746954 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1746957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746978 */     // GIR_Coverage, 11139,
     /* 1746978 */     GIR_EraseRootFromParent_Done,
     /* 1746979 */   // Label 23834: @1746979
     /* 1746979 */   GIM_Try, /*On fail goto*//*Label 23835*/ GIMT_Encode4(1747065), // Rule ID 11142 //
     /* 1746984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1746995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1746998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1747001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1747004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1747014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747030 */     // MIs[0] policy
     /* 1747030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747040 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1747043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1747061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747064 */     // GIR_Coverage, 11142,
     /* 1747064 */     GIR_EraseRootFromParent_Done,
     /* 1747065 */   // Label 23835: @1747065
     /* 1747065 */   GIM_Try, /*On fail goto*//*Label 23836*/ GIMT_Encode4(1747151), // Rule ID 11143 //
     /* 1747070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1747073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1747081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1747084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1747087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1747090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1747100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747116 */     // MIs[0] policy
     /* 1747116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747126 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1747129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1747147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747150 */     // GIR_Coverage, 11143,
     /* 1747150 */     GIR_EraseRootFromParent_Done,
     /* 1747151 */   // Label 23836: @1747151
     /* 1747151 */   GIM_Try, /*On fail goto*//*Label 23837*/ GIMT_Encode4(1747237), // Rule ID 11146 //
     /* 1747156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1747159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1747167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1747170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1747173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1747176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1747186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747202 */     // MIs[0] policy
     /* 1747202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747212 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1747215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1747233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747236 */     // GIR_Coverage, 11146,
     /* 1747236 */     GIR_EraseRootFromParent_Done,
     /* 1747237 */   // Label 23837: @1747237
     /* 1747237 */   GIM_Try, /*On fail goto*//*Label 23838*/ GIMT_Encode4(1747323), // Rule ID 11147 //
     /* 1747242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1747245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1747253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1747256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1747259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1747262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1747272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747288 */     // MIs[0] policy
     /* 1747288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747298 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1747301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1747319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747322 */     // GIR_Coverage, 11147,
     /* 1747322 */     GIR_EraseRootFromParent_Done,
     /* 1747323 */   // Label 23838: @1747323
     /* 1747323 */   GIM_Try, /*On fail goto*//*Label 23839*/ GIMT_Encode4(1747409), // Rule ID 11150 //
     /* 1747328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1747339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1747342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1747345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1747348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747374 */     // MIs[0] policy
     /* 1747374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747384 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1747387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747408 */     // GIR_Coverage, 11150,
     /* 1747408 */     GIR_EraseRootFromParent_Done,
     /* 1747409 */   // Label 23839: @1747409
     /* 1747409 */   GIM_Try, /*On fail goto*//*Label 23840*/ GIMT_Encode4(1747495), // Rule ID 11151 //
     /* 1747414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1747425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1747428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1747431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1747434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747460 */     // MIs[0] policy
     /* 1747460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747470 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1747473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747494 */     // GIR_Coverage, 11151,
     /* 1747494 */     GIR_EraseRootFromParent_Done,
     /* 1747495 */   // Label 23840: @1747495
     /* 1747495 */   GIM_Try, /*On fail goto*//*Label 23841*/ GIMT_Encode4(1747581), // Rule ID 11154 //
     /* 1747500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1747511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1747514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1747517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1747520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747546 */     // MIs[0] policy
     /* 1747546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747556 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747580 */     // GIR_Coverage, 11154,
     /* 1747580 */     GIR_EraseRootFromParent_Done,
     /* 1747581 */   // Label 23841: @1747581
     /* 1747581 */   GIM_Try, /*On fail goto*//*Label 23842*/ GIMT_Encode4(1747667), // Rule ID 11155 //
     /* 1747586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1747597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1747600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1747603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1747606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747632 */     // MIs[0] policy
     /* 1747632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747642 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747666 */     // GIR_Coverage, 11155,
     /* 1747666 */     GIR_EraseRootFromParent_Done,
     /* 1747667 */   // Label 23842: @1747667
     /* 1747667 */   GIM_Try, /*On fail goto*//*Label 23843*/ GIMT_Encode4(1747753), // Rule ID 11158 //
     /* 1747672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1747683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1747686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1747689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1747692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747718 */     // MIs[0] policy
     /* 1747718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747728 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747752 */     // GIR_Coverage, 11158,
     /* 1747752 */     GIR_EraseRootFromParent_Done,
     /* 1747753 */   // Label 23843: @1747753
     /* 1747753 */   GIM_Try, /*On fail goto*//*Label 23844*/ GIMT_Encode4(1747839), // Rule ID 11159 //
     /* 1747758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1747769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1747772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1747775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1747778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747804 */     // MIs[0] policy
     /* 1747804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747814 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747838 */     // GIR_Coverage, 11159,
     /* 1747838 */     GIR_EraseRootFromParent_Done,
     /* 1747839 */   // Label 23844: @1747839
     /* 1747839 */   GIM_Try, /*On fail goto*//*Label 23845*/ GIMT_Encode4(1747925), // Rule ID 11162 //
     /* 1747844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1747861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1747864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747890 */     // MIs[0] policy
     /* 1747890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747900 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747924 */     // GIR_Coverage, 11162,
     /* 1747924 */     GIR_EraseRootFromParent_Done,
     /* 1747925 */   // Label 23845: @1747925
     /* 1747925 */   GIM_Try, /*On fail goto*//*Label 23846*/ GIMT_Encode4(1748011), // Rule ID 11163 //
     /* 1747930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1747947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1747950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747976 */     // MIs[0] policy
     /* 1747976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747986 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748010 */     // GIR_Coverage, 11163,
     /* 1748010 */     GIR_EraseRootFromParent_Done,
     /* 1748011 */   // Label 23846: @1748011
     /* 1748011 */   GIM_Try, /*On fail goto*//*Label 23847*/ GIMT_Encode4(1748097), // Rule ID 11166 //
     /* 1748016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1748027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1748030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1748033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1748036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748062 */     // MIs[0] policy
     /* 1748062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748072 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1748075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748096 */     // GIR_Coverage, 11166,
     /* 1748096 */     GIR_EraseRootFromParent_Done,
     /* 1748097 */   // Label 23847: @1748097
     /* 1748097 */   GIM_Try, /*On fail goto*//*Label 23848*/ GIMT_Encode4(1748183), // Rule ID 11167 //
     /* 1748102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1748113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1748116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1748119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1748122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748148 */     // MIs[0] policy
     /* 1748148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748158 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1748161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748182 */     // GIR_Coverage, 11167,
     /* 1748182 */     GIR_EraseRootFromParent_Done,
     /* 1748183 */   // Label 23848: @1748183
     /* 1748183 */   GIM_Try, /*On fail goto*//*Label 23849*/ GIMT_Encode4(1748269), // Rule ID 11170 //
     /* 1748188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1748199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1748202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1748205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1748208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1748211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748234 */     // MIs[0] policy
     /* 1748234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748244 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1748247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748268 */     // GIR_Coverage, 11170,
     /* 1748268 */     GIR_EraseRootFromParent_Done,
     /* 1748269 */   // Label 23849: @1748269
     /* 1748269 */   GIM_Try, /*On fail goto*//*Label 23850*/ GIMT_Encode4(1748355), // Rule ID 11171 //
     /* 1748274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1748285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1748288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1748291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1748294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1748297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748320 */     // MIs[0] policy
     /* 1748320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748330 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1748333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748354 */     // GIR_Coverage, 11171,
     /* 1748354 */     GIR_EraseRootFromParent_Done,
     /* 1748355 */   // Label 23850: @1748355
     /* 1748355 */   GIM_Try, /*On fail goto*//*Label 23851*/ GIMT_Encode4(1748441), // Rule ID 11174 //
     /* 1748360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1748371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1748374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1748377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1748380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748406 */     // MIs[0] policy
     /* 1748406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748416 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748440 */     // GIR_Coverage, 11174,
     /* 1748440 */     GIR_EraseRootFromParent_Done,
     /* 1748441 */   // Label 23851: @1748441
     /* 1748441 */   GIM_Try, /*On fail goto*//*Label 23852*/ GIMT_Encode4(1748527), // Rule ID 11175 //
     /* 1748446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1748457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1748460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1748463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1748466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748492 */     // MIs[0] policy
     /* 1748492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748526 */     // GIR_Coverage, 11175,
     /* 1748526 */     GIR_EraseRootFromParent_Done,
     /* 1748527 */   // Label 23852: @1748527
     /* 1748527 */   GIM_Try, /*On fail goto*//*Label 23853*/ GIMT_Encode4(1748613), // Rule ID 11178 //
     /* 1748532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1748543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1748546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1748549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1748552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748578 */     // MIs[0] policy
     /* 1748578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748588 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748612 */     // GIR_Coverage, 11178,
     /* 1748612 */     GIR_EraseRootFromParent_Done,
     /* 1748613 */   // Label 23853: @1748613
     /* 1748613 */   GIM_Try, /*On fail goto*//*Label 23854*/ GIMT_Encode4(1748699), // Rule ID 11179 //
     /* 1748618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1748629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1748632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1748635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1748638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748664 */     // MIs[0] policy
     /* 1748664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748698 */     // GIR_Coverage, 11179,
     /* 1748698 */     GIR_EraseRootFromParent_Done,
     /* 1748699 */   // Label 23854: @1748699
     /* 1748699 */   GIM_Try, /*On fail goto*//*Label 23855*/ GIMT_Encode4(1748785), // Rule ID 11182 //
     /* 1748704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1748715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1748718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1748721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1748724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748750 */     // MIs[0] policy
     /* 1748750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748760 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748784 */     // GIR_Coverage, 11182,
     /* 1748784 */     GIR_EraseRootFromParent_Done,
     /* 1748785 */   // Label 23855: @1748785
     /* 1748785 */   GIM_Try, /*On fail goto*//*Label 23856*/ GIMT_Encode4(1748871), // Rule ID 11183 //
     /* 1748790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1748801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1748804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1748807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1748810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748836 */     // MIs[0] policy
     /* 1748836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748846 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748870 */     // GIR_Coverage, 11183,
     /* 1748870 */     GIR_EraseRootFromParent_Done,
     /* 1748871 */   // Label 23856: @1748871
     /* 1748871 */   GIM_Try, /*On fail goto*//*Label 23857*/ GIMT_Encode4(1748957), // Rule ID 11186 //
     /* 1748876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1748887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1748890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1748893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1748896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748922 */     // MIs[0] policy
     /* 1748922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748932 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1748935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748956 */     // GIR_Coverage, 11186,
     /* 1748956 */     GIR_EraseRootFromParent_Done,
     /* 1748957 */   // Label 23857: @1748957
     /* 1748957 */   GIM_Try, /*On fail goto*//*Label 23858*/ GIMT_Encode4(1749043), // Rule ID 11187 //
     /* 1748962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1748973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1748976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1748979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1748982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749008 */     // MIs[0] policy
     /* 1749008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749018 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749042 */     // GIR_Coverage, 11187,
     /* 1749042 */     GIR_EraseRootFromParent_Done,
     /* 1749043 */   // Label 23858: @1749043
     /* 1749043 */   GIM_Try, /*On fail goto*//*Label 23859*/ GIMT_Encode4(1749129), // Rule ID 11190 //
     /* 1749048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1749059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1749062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1749065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1749068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749094 */     // MIs[0] policy
     /* 1749094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749104 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749128 */     // GIR_Coverage, 11190,
     /* 1749128 */     GIR_EraseRootFromParent_Done,
     /* 1749129 */   // Label 23859: @1749129
     /* 1749129 */   GIM_Try, /*On fail goto*//*Label 23860*/ GIMT_Encode4(1749215), // Rule ID 11191 //
     /* 1749134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1749145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1749148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1749151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1749154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749180 */     // MIs[0] policy
     /* 1749180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749190 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749214 */     // GIR_Coverage, 11191,
     /* 1749214 */     GIR_EraseRootFromParent_Done,
     /* 1749215 */   // Label 23860: @1749215
     /* 1749215 */   GIM_Try, /*On fail goto*//*Label 23861*/ GIMT_Encode4(1749301), // Rule ID 11194 //
     /* 1749220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1749231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1749234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1749237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1749240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1749243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749266 */     // MIs[0] policy
     /* 1749266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749276 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749300 */     // GIR_Coverage, 11194,
     /* 1749300 */     GIR_EraseRootFromParent_Done,
     /* 1749301 */   // Label 23861: @1749301
     /* 1749301 */   GIM_Try, /*On fail goto*//*Label 23862*/ GIMT_Encode4(1749387), // Rule ID 11195 //
     /* 1749306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1749317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1749320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1749323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1749326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1749329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749352 */     // MIs[0] policy
     /* 1749352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749362 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749386 */     // GIR_Coverage, 11195,
     /* 1749386 */     GIR_EraseRootFromParent_Done,
     /* 1749387 */   // Label 23862: @1749387
     /* 1749387 */   GIM_Try, /*On fail goto*//*Label 23863*/ GIMT_Encode4(1749473), // Rule ID 11198 //
     /* 1749392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1749403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1749406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1749409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1749412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749438 */     // MIs[0] policy
     /* 1749438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749472 */     // GIR_Coverage, 11198,
     /* 1749472 */     GIR_EraseRootFromParent_Done,
     /* 1749473 */   // Label 23863: @1749473
     /* 1749473 */   GIM_Try, /*On fail goto*//*Label 23864*/ GIMT_Encode4(1749559), // Rule ID 11199 //
     /* 1749478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1749489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1749492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1749495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1749498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749524 */     // MIs[0] policy
     /* 1749524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749534 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749558 */     // GIR_Coverage, 11199,
     /* 1749558 */     GIR_EraseRootFromParent_Done,
     /* 1749559 */   // Label 23864: @1749559
     /* 1749559 */   GIM_Try, /*On fail goto*//*Label 23865*/ GIMT_Encode4(1749645), // Rule ID 11202 //
     /* 1749564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1749575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1749578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1749581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1749584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749610 */     // MIs[0] policy
     /* 1749610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749620 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749644 */     // GIR_Coverage, 11202,
     /* 1749644 */     GIR_EraseRootFromParent_Done,
     /* 1749645 */   // Label 23865: @1749645
     /* 1749645 */   GIM_Try, /*On fail goto*//*Label 23866*/ GIMT_Encode4(1749731), // Rule ID 11203 //
     /* 1749650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1749661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1749664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1749667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1749670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749696 */     // MIs[0] policy
     /* 1749696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749706 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749730 */     // GIR_Coverage, 11203,
     /* 1749730 */     GIR_EraseRootFromParent_Done,
     /* 1749731 */   // Label 23866: @1749731
     /* 1749731 */   GIM_Try, /*On fail goto*//*Label 23867*/ GIMT_Encode4(1749817), // Rule ID 11206 //
     /* 1749736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1749747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1749750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1749753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1749756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749782 */     // MIs[0] policy
     /* 1749782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749792 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749816 */     // GIR_Coverage, 11206,
     /* 1749816 */     GIR_EraseRootFromParent_Done,
     /* 1749817 */   // Label 23867: @1749817
     /* 1749817 */   GIM_Try, /*On fail goto*//*Label 23868*/ GIMT_Encode4(1749903), // Rule ID 11207 //
     /* 1749822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1749833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1749836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1749839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1749842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749868 */     // MIs[0] policy
     /* 1749868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749878 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749902 */     // GIR_Coverage, 11207,
     /* 1749902 */     GIR_EraseRootFromParent_Done,
     /* 1749903 */   // Label 23868: @1749903
     /* 1749903 */   GIM_Try, /*On fail goto*//*Label 23869*/ GIMT_Encode4(1749989), // Rule ID 11210 //
     /* 1749908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1749919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1749922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1749925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1749928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749954 */     // MIs[0] policy
     /* 1749954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749988 */     // GIR_Coverage, 11210,
     /* 1749988 */     GIR_EraseRootFromParent_Done,
     /* 1749989 */   // Label 23869: @1749989
     /* 1749989 */   GIM_Try, /*On fail goto*//*Label 23870*/ GIMT_Encode4(1750075), // Rule ID 11211 //
     /* 1749994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1750005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1750008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1750011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1750014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1750024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750040 */     // MIs[0] policy
     /* 1750040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750050 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1750053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750074 */     // GIR_Coverage, 11211,
     /* 1750074 */     GIR_EraseRootFromParent_Done,
     /* 1750075 */   // Label 23870: @1750075
     /* 1750075 */   GIM_Try, /*On fail goto*//*Label 23871*/ GIMT_Encode4(1750161), // Rule ID 11214 //
     /* 1750080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1750091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1750094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1750097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1750100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1750110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750126 */     // MIs[0] policy
     /* 1750126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750136 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1750139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750160 */     // GIR_Coverage, 11214,
     /* 1750160 */     GIR_EraseRootFromParent_Done,
     /* 1750161 */   // Label 23871: @1750161
     /* 1750161 */   GIM_Try, /*On fail goto*//*Label 23872*/ GIMT_Encode4(1750247), // Rule ID 11215 //
     /* 1750166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1750177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1750180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1750183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1750186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1750196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750212 */     // MIs[0] policy
     /* 1750212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750222 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1750225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750246 */     // GIR_Coverage, 11215,
     /* 1750246 */     GIR_EraseRootFromParent_Done,
     /* 1750247 */   // Label 23872: @1750247
     /* 1750247 */   GIM_Try, /*On fail goto*//*Label 23873*/ GIMT_Encode4(1750333), // Rule ID 11218 //
     /* 1750252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1750263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1750266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1750269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1750272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1750275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750298 */     // MIs[0] policy
     /* 1750298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750308 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1750311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750332 */     // GIR_Coverage, 11218,
     /* 1750332 */     GIR_EraseRootFromParent_Done,
     /* 1750333 */   // Label 23873: @1750333
     /* 1750333 */   GIM_Try, /*On fail goto*//*Label 23874*/ GIMT_Encode4(1750419), // Rule ID 11219 //
     /* 1750338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1750349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1750352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1750355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1750358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1750361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750384 */     // MIs[0] policy
     /* 1750384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750394 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1750397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750418 */     // GIR_Coverage, 11219,
     /* 1750418 */     GIR_EraseRootFromParent_Done,
     /* 1750419 */   // Label 23874: @1750419
     /* 1750419 */   GIM_Try, /*On fail goto*//*Label 23875*/ GIMT_Encode4(1750505), // Rule ID 11222 //
     /* 1750424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1750435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1750438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1750441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750470 */     // MIs[0] policy
     /* 1750470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750480 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1750483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750504 */     // GIR_Coverage, 11222,
     /* 1750504 */     GIR_EraseRootFromParent_Done,
     /* 1750505 */   // Label 23875: @1750505
     /* 1750505 */   GIM_Try, /*On fail goto*//*Label 23876*/ GIMT_Encode4(1750591), // Rule ID 11223 //
     /* 1750510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1750521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1750524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1750527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750556 */     // MIs[0] policy
     /* 1750556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750566 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1750569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750590 */     // GIR_Coverage, 11223,
     /* 1750590 */     GIR_EraseRootFromParent_Done,
     /* 1750591 */   // Label 23876: @1750591
     /* 1750591 */   GIM_Try, /*On fail goto*//*Label 23877*/ GIMT_Encode4(1750677), // Rule ID 11226 //
     /* 1750596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1750607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1750610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1750613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750642 */     // MIs[0] policy
     /* 1750642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750652 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750676 */     // GIR_Coverage, 11226,
     /* 1750676 */     GIR_EraseRootFromParent_Done,
     /* 1750677 */   // Label 23877: @1750677
     /* 1750677 */   GIM_Try, /*On fail goto*//*Label 23878*/ GIMT_Encode4(1750763), // Rule ID 11227 //
     /* 1750682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1750693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1750696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1750699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750728 */     // MIs[0] policy
     /* 1750728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750738 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750762 */     // GIR_Coverage, 11227,
     /* 1750762 */     GIR_EraseRootFromParent_Done,
     /* 1750763 */   // Label 23878: @1750763
     /* 1750763 */   GIM_Try, /*On fail goto*//*Label 23879*/ GIMT_Encode4(1750849), // Rule ID 11230 //
     /* 1750768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1750779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1750782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1750785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750814 */     // MIs[0] policy
     /* 1750814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750824 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750848 */     // GIR_Coverage, 11230,
     /* 1750848 */     GIR_EraseRootFromParent_Done,
     /* 1750849 */   // Label 23879: @1750849
     /* 1750849 */   GIM_Try, /*On fail goto*//*Label 23880*/ GIMT_Encode4(1750935), // Rule ID 11231 //
     /* 1750854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1750865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1750868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1750871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750900 */     // MIs[0] policy
     /* 1750900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750910 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750934 */     // GIR_Coverage, 11231,
     /* 1750934 */     GIR_EraseRootFromParent_Done,
     /* 1750935 */   // Label 23880: @1750935
     /* 1750935 */   GIM_Try, /*On fail goto*//*Label 23881*/ GIMT_Encode4(1751021), // Rule ID 11234 //
     /* 1750940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1750951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1750954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1750957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750986 */     // MIs[0] policy
     /* 1750986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750996 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751020 */     // GIR_Coverage, 11234,
     /* 1751020 */     GIR_EraseRootFromParent_Done,
     /* 1751021 */   // Label 23881: @1751021
     /* 1751021 */   GIM_Try, /*On fail goto*//*Label 23882*/ GIMT_Encode4(1751107), // Rule ID 11235 //
     /* 1751026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1751037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1751040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1751043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751072 */     // MIs[0] policy
     /* 1751072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751082 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1751085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751106 */     // GIR_Coverage, 11235,
     /* 1751106 */     GIR_EraseRootFromParent_Done,
     /* 1751107 */   // Label 23882: @1751107
     /* 1751107 */   GIM_Try, /*On fail goto*//*Label 23883*/ GIMT_Encode4(1751193), // Rule ID 11238 //
     /* 1751112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1751123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1751126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1751129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751158 */     // MIs[0] policy
     /* 1751158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751168 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1751171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751192 */     // GIR_Coverage, 11238,
     /* 1751192 */     GIR_EraseRootFromParent_Done,
     /* 1751193 */   // Label 23883: @1751193
     /* 1751193 */   GIM_Try, /*On fail goto*//*Label 23884*/ GIMT_Encode4(1751279), // Rule ID 11239 //
     /* 1751198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1751209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1751212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1751215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751244 */     // MIs[0] policy
     /* 1751244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751254 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1751257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751278 */     // GIR_Coverage, 11239,
     /* 1751278 */     GIR_EraseRootFromParent_Done,
     /* 1751279 */   // Label 23884: @1751279
     /* 1751279 */   GIM_Try, /*On fail goto*//*Label 23885*/ GIMT_Encode4(1751365), // Rule ID 11242 //
     /* 1751284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1751295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1751298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1751301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751330 */     // MIs[0] policy
     /* 1751330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751340 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1751343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751364 */     // GIR_Coverage, 11242,
     /* 1751364 */     GIR_EraseRootFromParent_Done,
     /* 1751365 */   // Label 23885: @1751365
     /* 1751365 */   GIM_Try, /*On fail goto*//*Label 23886*/ GIMT_Encode4(1751451), // Rule ID 11243 //
     /* 1751370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1751381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1751384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1751387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751416 */     // MIs[0] policy
     /* 1751416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751426 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1751429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751450 */     // GIR_Coverage, 11243,
     /* 1751450 */     GIR_EraseRootFromParent_Done,
     /* 1751451 */   // Label 23886: @1751451
     /* 1751451 */   GIM_Try, /*On fail goto*//*Label 23887*/ GIMT_Encode4(1751537), // Rule ID 11246 //
     /* 1751456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1751467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1751470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1751473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751502 */     // MIs[0] policy
     /* 1751502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751512 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751536 */     // GIR_Coverage, 11246,
     /* 1751536 */     GIR_EraseRootFromParent_Done,
     /* 1751537 */   // Label 23887: @1751537
     /* 1751537 */   GIM_Try, /*On fail goto*//*Label 23888*/ GIMT_Encode4(1751623), // Rule ID 11247 //
     /* 1751542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1751553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1751556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1751559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751588 */     // MIs[0] policy
     /* 1751588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751598 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751622 */     // GIR_Coverage, 11247,
     /* 1751622 */     GIR_EraseRootFromParent_Done,
     /* 1751623 */   // Label 23888: @1751623
     /* 1751623 */   GIM_Try, /*On fail goto*//*Label 23889*/ GIMT_Encode4(1751709), // Rule ID 11250 //
     /* 1751628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1751639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1751642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1751645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751674 */     // MIs[0] policy
     /* 1751674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751684 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751708 */     // GIR_Coverage, 11250,
     /* 1751708 */     GIR_EraseRootFromParent_Done,
     /* 1751709 */   // Label 23889: @1751709
     /* 1751709 */   GIM_Try, /*On fail goto*//*Label 23890*/ GIMT_Encode4(1751795), // Rule ID 11251 //
     /* 1751714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1751725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1751728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1751731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751760 */     // MIs[0] policy
     /* 1751760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751794 */     // GIR_Coverage, 11251,
     /* 1751794 */     GIR_EraseRootFromParent_Done,
     /* 1751795 */   // Label 23890: @1751795
     /* 1751795 */   GIM_Try, /*On fail goto*//*Label 23891*/ GIMT_Encode4(1751881), // Rule ID 11254 //
     /* 1751800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1751811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1751814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1751817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751846 */     // MIs[0] policy
     /* 1751846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751856 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751880 */     // GIR_Coverage, 11254,
     /* 1751880 */     GIR_EraseRootFromParent_Done,
     /* 1751881 */   // Label 23891: @1751881
     /* 1751881 */   GIM_Try, /*On fail goto*//*Label 23892*/ GIMT_Encode4(1751967), // Rule ID 11255 //
     /* 1751886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1751897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1751900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1751903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751932 */     // MIs[0] policy
     /* 1751932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751942 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751966 */     // GIR_Coverage, 11255,
     /* 1751966 */     GIR_EraseRootFromParent_Done,
     /* 1751967 */   // Label 23892: @1751967
     /* 1751967 */   GIM_Try, /*On fail goto*//*Label 23893*/ GIMT_Encode4(1752053), // Rule ID 11258 //
     /* 1751972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1751983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1751986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1751989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1751995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752018 */     // MIs[0] policy
     /* 1752018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752028 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752052 */     // GIR_Coverage, 11258,
     /* 1752052 */     GIR_EraseRootFromParent_Done,
     /* 1752053 */   // Label 23893: @1752053
     /* 1752053 */   GIM_Try, /*On fail goto*//*Label 23894*/ GIMT_Encode4(1752139), // Rule ID 11259 //
     /* 1752058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1752069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1752072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1752075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752104 */     // MIs[0] policy
     /* 1752104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752114 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752138 */     // GIR_Coverage, 11259,
     /* 1752138 */     GIR_EraseRootFromParent_Done,
     /* 1752139 */   // Label 23894: @1752139
     /* 1752139 */   GIM_Try, /*On fail goto*//*Label 23895*/ GIMT_Encode4(1752225), // Rule ID 11262 //
     /* 1752144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1752155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1752158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1752161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752190 */     // MIs[0] policy
     /* 1752190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752200 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752224 */     // GIR_Coverage, 11262,
     /* 1752224 */     GIR_EraseRootFromParent_Done,
     /* 1752225 */   // Label 23895: @1752225
     /* 1752225 */   GIM_Try, /*On fail goto*//*Label 23896*/ GIMT_Encode4(1752311), // Rule ID 11263 //
     /* 1752230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1752241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1752244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1752247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752276 */     // MIs[0] policy
     /* 1752276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752286 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752310 */     // GIR_Coverage, 11263,
     /* 1752310 */     GIR_EraseRootFromParent_Done,
     /* 1752311 */   // Label 23896: @1752311
     /* 1752311 */   GIM_Try, /*On fail goto*//*Label 23897*/ GIMT_Encode4(1752397), // Rule ID 11266 //
     /* 1752316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1752327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1752330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1752333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1752339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752362 */     // MIs[0] policy
     /* 1752362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752372 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752396 */     // GIR_Coverage, 11266,
     /* 1752396 */     GIR_EraseRootFromParent_Done,
     /* 1752397 */   // Label 23897: @1752397
     /* 1752397 */   GIM_Try, /*On fail goto*//*Label 23898*/ GIMT_Encode4(1752483), // Rule ID 11267 //
     /* 1752402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1752413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1752416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1752419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1752425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752448 */     // MIs[0] policy
     /* 1752448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752458 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752482 */     // GIR_Coverage, 11267,
     /* 1752482 */     GIR_EraseRootFromParent_Done,
     /* 1752483 */   // Label 23898: @1752483
     /* 1752483 */   GIM_Try, /*On fail goto*//*Label 23899*/ GIMT_Encode4(1752569), // Rule ID 11270 //
     /* 1752488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1752499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1752502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1752505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752534 */     // MIs[0] policy
     /* 1752534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752568 */     // GIR_Coverage, 11270,
     /* 1752568 */     GIR_EraseRootFromParent_Done,
     /* 1752569 */   // Label 23899: @1752569
     /* 1752569 */   GIM_Try, /*On fail goto*//*Label 23900*/ GIMT_Encode4(1752655), // Rule ID 11271 //
     /* 1752574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1752585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1752588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1752591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752620 */     // MIs[0] policy
     /* 1752620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752654 */     // GIR_Coverage, 11271,
     /* 1752654 */     GIR_EraseRootFromParent_Done,
     /* 1752655 */   // Label 23900: @1752655
     /* 1752655 */   GIM_Try, /*On fail goto*//*Label 23901*/ GIMT_Encode4(1752741), // Rule ID 11274 //
     /* 1752660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1752671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1752674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1752677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752706 */     // MIs[0] policy
     /* 1752706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752716 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752740 */     // GIR_Coverage, 11274,
     /* 1752740 */     GIR_EraseRootFromParent_Done,
     /* 1752741 */   // Label 23901: @1752741
     /* 1752741 */   GIM_Try, /*On fail goto*//*Label 23902*/ GIMT_Encode4(1752827), // Rule ID 11275 //
     /* 1752746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1752757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1752760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1752763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752792 */     // MIs[0] policy
     /* 1752792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752802 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752826 */     // GIR_Coverage, 11275,
     /* 1752826 */     GIR_EraseRootFromParent_Done,
     /* 1752827 */   // Label 23902: @1752827
     /* 1752827 */   GIM_Try, /*On fail goto*//*Label 23903*/ GIMT_Encode4(1752913), // Rule ID 11278 //
     /* 1752832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1752843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1752846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1752849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752878 */     // MIs[0] policy
     /* 1752878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752888 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752912 */     // GIR_Coverage, 11278,
     /* 1752912 */     GIR_EraseRootFromParent_Done,
     /* 1752913 */   // Label 23903: @1752913
     /* 1752913 */   GIM_Try, /*On fail goto*//*Label 23904*/ GIMT_Encode4(1752999), // Rule ID 11279 //
     /* 1752918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1752929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1752932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1752935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752964 */     // MIs[0] policy
     /* 1752964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752974 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752998 */     // GIR_Coverage, 11279,
     /* 1752998 */     GIR_EraseRootFromParent_Done,
     /* 1752999 */   // Label 23904: @1752999
     /* 1752999 */   GIM_Try, /*On fail goto*//*Label 23905*/ GIMT_Encode4(1753085), // Rule ID 11282 //
     /* 1753004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1753015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1753018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1753021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1753024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1753034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753050 */     // MIs[0] policy
     /* 1753050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1753063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753084 */     // GIR_Coverage, 11282,
     /* 1753084 */     GIR_EraseRootFromParent_Done,
     /* 1753085 */   // Label 23905: @1753085
     /* 1753085 */   GIM_Try, /*On fail goto*//*Label 23906*/ GIMT_Encode4(1753171), // Rule ID 11283 //
     /* 1753090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1753101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1753104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1753107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1753110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1753120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753136 */     // MIs[0] policy
     /* 1753136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1753149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753170 */     // GIR_Coverage, 11283,
     /* 1753170 */     GIR_EraseRootFromParent_Done,
     /* 1753171 */   // Label 23906: @1753171
     /* 1753171 */   GIM_Try, /*On fail goto*//*Label 23907*/ GIMT_Encode4(1753257), // Rule ID 11286 //
     /* 1753176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1753187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1753190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1753193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1753196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1753199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753222 */     // MIs[0] policy
     /* 1753222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753232 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1753235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753256 */     // GIR_Coverage, 11286,
     /* 1753256 */     GIR_EraseRootFromParent_Done,
     /* 1753257 */   // Label 23907: @1753257
     /* 1753257 */   GIM_Try, /*On fail goto*//*Label 23908*/ GIMT_Encode4(1753343), // Rule ID 11287 //
     /* 1753262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1753273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1753276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1753279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1753282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1753285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753308 */     // MIs[0] policy
     /* 1753308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753318 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1753321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753342 */     // GIR_Coverage, 11287,
     /* 1753342 */     GIR_EraseRootFromParent_Done,
     /* 1753343 */   // Label 23908: @1753343
     /* 1753343 */   GIM_Try, /*On fail goto*//*Label 23909*/ GIMT_Encode4(1753429), // Rule ID 11290 //
     /* 1753348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1753359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1753362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1753365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1753368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753394 */     // MIs[0] policy
     /* 1753394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753404 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1753407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753428 */     // GIR_Coverage, 11290,
     /* 1753428 */     GIR_EraseRootFromParent_Done,
     /* 1753429 */   // Label 23909: @1753429
     /* 1753429 */   GIM_Try, /*On fail goto*//*Label 23910*/ GIMT_Encode4(1753515), // Rule ID 11291 //
     /* 1753434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1753445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1753448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1753451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1753454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753480 */     // MIs[0] policy
     /* 1753480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753490 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1753493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753514 */     // GIR_Coverage, 11291,
     /* 1753514 */     GIR_EraseRootFromParent_Done,
     /* 1753515 */   // Label 23910: @1753515
     /* 1753515 */   GIM_Try, /*On fail goto*//*Label 23911*/ GIMT_Encode4(1753601), // Rule ID 11294 //
     /* 1753520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1753531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1753534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1753537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1753540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753566 */     // MIs[0] policy
     /* 1753566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753576 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1753579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753600 */     // GIR_Coverage, 11294,
     /* 1753600 */     GIR_EraseRootFromParent_Done,
     /* 1753601 */   // Label 23911: @1753601
     /* 1753601 */   GIM_Try, /*On fail goto*//*Label 23912*/ GIMT_Encode4(1753687), // Rule ID 11295 //
     /* 1753606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1753617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1753620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1753623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1753626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753652 */     // MIs[0] policy
     /* 1753652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753662 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1753665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753686 */     // GIR_Coverage, 11295,
     /* 1753686 */     GIR_EraseRootFromParent_Done,
     /* 1753687 */   // Label 23912: @1753687
     /* 1753687 */   GIM_Try, /*On fail goto*//*Label 23913*/ GIMT_Encode4(1753773), // Rule ID 11298 //
     /* 1753692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1753703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1753706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1753709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1753712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753738 */     // MIs[0] policy
     /* 1753738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753748 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1753751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753772 */     // GIR_Coverage, 11298,
     /* 1753772 */     GIR_EraseRootFromParent_Done,
     /* 1753773 */   // Label 23913: @1753773
     /* 1753773 */   GIM_Try, /*On fail goto*//*Label 23914*/ GIMT_Encode4(1753859), // Rule ID 11299 //
     /* 1753778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1753789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1753792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1753795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1753798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753824 */     // MIs[0] policy
     /* 1753824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753834 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1753837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753858 */     // GIR_Coverage, 11299,
     /* 1753858 */     GIR_EraseRootFromParent_Done,
     /* 1753859 */   // Label 23914: @1753859
     /* 1753859 */   GIM_Try, /*On fail goto*//*Label 23915*/ GIMT_Encode4(1753945), // Rule ID 11302 //
     /* 1753864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1753875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1753878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1753881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1753884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753910 */     // MIs[0] policy
     /* 1753910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753920 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1753923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753944 */     // GIR_Coverage, 11302,
     /* 1753944 */     GIR_EraseRootFromParent_Done,
     /* 1753945 */   // Label 23915: @1753945
     /* 1753945 */   GIM_Try, /*On fail goto*//*Label 23916*/ GIMT_Encode4(1754031), // Rule ID 11303 //
     /* 1753950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1753961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1753964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1753967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1753970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753996 */     // MIs[0] policy
     /* 1753996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754006 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1754009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754030 */     // GIR_Coverage, 11303,
     /* 1754030 */     GIR_EraseRootFromParent_Done,
     /* 1754031 */   // Label 23916: @1754031
     /* 1754031 */   GIM_Try, /*On fail goto*//*Label 23917*/ GIMT_Encode4(1754117), // Rule ID 11306 //
     /* 1754036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1754047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1754050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1754053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1754056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754082 */     // MIs[0] policy
     /* 1754082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754092 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1754095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754116 */     // GIR_Coverage, 11306,
     /* 1754116 */     GIR_EraseRootFromParent_Done,
     /* 1754117 */   // Label 23917: @1754117
     /* 1754117 */   GIM_Try, /*On fail goto*//*Label 23918*/ GIMT_Encode4(1754203), // Rule ID 11307 //
     /* 1754122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1754133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1754136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1754139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1754142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754168 */     // MIs[0] policy
     /* 1754168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754178 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1754181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754202 */     // GIR_Coverage, 11307,
     /* 1754202 */     GIR_EraseRootFromParent_Done,
     /* 1754203 */   // Label 23918: @1754203
     /* 1754203 */   GIM_Try, /*On fail goto*//*Label 23919*/ GIMT_Encode4(1754289), // Rule ID 11310 //
     /* 1754208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1754219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1754222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1754225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1754228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754254 */     // MIs[0] policy
     /* 1754254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1754267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754288 */     // GIR_Coverage, 11310,
     /* 1754288 */     GIR_EraseRootFromParent_Done,
     /* 1754289 */   // Label 23919: @1754289
     /* 1754289 */   GIM_Try, /*On fail goto*//*Label 23920*/ GIMT_Encode4(1754375), // Rule ID 11311 //
     /* 1754294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1754305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1754308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1754311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1754314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754340 */     // MIs[0] policy
     /* 1754340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754350 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1754353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754374 */     // GIR_Coverage, 11311,
     /* 1754374 */     GIR_EraseRootFromParent_Done,
     /* 1754375 */   // Label 23920: @1754375
     /* 1754375 */   GIM_Try, /*On fail goto*//*Label 23921*/ GIMT_Encode4(1754461), // Rule ID 11314 //
     /* 1754380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1754391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1754394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1754397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1754400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754426 */     // MIs[0] policy
     /* 1754426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1754439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754460 */     // GIR_Coverage, 11314,
     /* 1754460 */     GIR_EraseRootFromParent_Done,
     /* 1754461 */   // Label 23921: @1754461
     /* 1754461 */   GIM_Try, /*On fail goto*//*Label 23922*/ GIMT_Encode4(1754547), // Rule ID 11315 //
     /* 1754466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1754477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1754480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1754483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1754486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754512 */     // MIs[0] policy
     /* 1754512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754522 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1754525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754546 */     // GIR_Coverage, 11315,
     /* 1754546 */     GIR_EraseRootFromParent_Done,
     /* 1754547 */   // Label 23922: @1754547
     /* 1754547 */   GIM_Try, /*On fail goto*//*Label 23923*/ GIMT_Encode4(1754633), // Rule ID 11318 //
     /* 1754552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1754563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1754566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1754569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1754572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754598 */     // MIs[0] policy
     /* 1754598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754608 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754632 */     // GIR_Coverage, 11318,
     /* 1754632 */     GIR_EraseRootFromParent_Done,
     /* 1754633 */   // Label 23923: @1754633
     /* 1754633 */   GIM_Try, /*On fail goto*//*Label 23924*/ GIMT_Encode4(1754719), // Rule ID 11319 //
     /* 1754638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1754649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1754652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1754655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1754658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754684 */     // MIs[0] policy
     /* 1754684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754694 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754718 */     // GIR_Coverage, 11319,
     /* 1754718 */     GIR_EraseRootFromParent_Done,
     /* 1754719 */   // Label 23924: @1754719
     /* 1754719 */   GIM_Try, /*On fail goto*//*Label 23925*/ GIMT_Encode4(1754805), // Rule ID 11322 //
     /* 1754724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1754735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1754738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1754741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1754744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754770 */     // MIs[0] policy
     /* 1754770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754804 */     // GIR_Coverage, 11322,
     /* 1754804 */     GIR_EraseRootFromParent_Done,
     /* 1754805 */   // Label 23925: @1754805
     /* 1754805 */   GIM_Try, /*On fail goto*//*Label 23926*/ GIMT_Encode4(1754891), // Rule ID 11323 //
     /* 1754810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1754821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1754824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1754827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1754830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754856 */     // MIs[0] policy
     /* 1754856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754866 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754890 */     // GIR_Coverage, 11323,
     /* 1754890 */     GIR_EraseRootFromParent_Done,
     /* 1754891 */   // Label 23926: @1754891
     /* 1754891 */   GIM_Try, /*On fail goto*//*Label 23927*/ GIMT_Encode4(1754977), // Rule ID 11326 //
     /* 1754896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1754907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1754910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1754913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1754916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754942 */     // MIs[0] policy
     /* 1754942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754976 */     // GIR_Coverage, 11326,
     /* 1754976 */     GIR_EraseRootFromParent_Done,
     /* 1754977 */   // Label 23927: @1754977
     /* 1754977 */   GIM_Try, /*On fail goto*//*Label 23928*/ GIMT_Encode4(1755063), // Rule ID 11327 //
     /* 1754982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1754993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1754996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1754999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1755002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1755005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755028 */     // MIs[0] policy
     /* 1755028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1755041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755062 */     // GIR_Coverage, 11327,
     /* 1755062 */     GIR_EraseRootFromParent_Done,
     /* 1755063 */   // Label 23928: @1755063
     /* 1755063 */   GIM_Try, /*On fail goto*//*Label 23929*/ GIMT_Encode4(1755149), // Rule ID 11330 //
     /* 1755068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1755079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1755082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1755085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1755088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755114 */     // MIs[0] policy
     /* 1755114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755124 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755148 */     // GIR_Coverage, 11330,
     /* 1755148 */     GIR_EraseRootFromParent_Done,
     /* 1755149 */   // Label 23929: @1755149
     /* 1755149 */   GIM_Try, /*On fail goto*//*Label 23930*/ GIMT_Encode4(1755235), // Rule ID 11331 //
     /* 1755154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1755165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1755168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1755171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1755174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755200 */     // MIs[0] policy
     /* 1755200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755210 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755234 */     // GIR_Coverage, 11331,
     /* 1755234 */     GIR_EraseRootFromParent_Done,
     /* 1755235 */   // Label 23930: @1755235
     /* 1755235 */   GIM_Try, /*On fail goto*//*Label 23931*/ GIMT_Encode4(1755321), // Rule ID 11334 //
     /* 1755240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1755251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1755254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1755257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1755260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755286 */     // MIs[0] policy
     /* 1755286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755296 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755320 */     // GIR_Coverage, 11334,
     /* 1755320 */     GIR_EraseRootFromParent_Done,
     /* 1755321 */   // Label 23931: @1755321
     /* 1755321 */   GIM_Try, /*On fail goto*//*Label 23932*/ GIMT_Encode4(1755407), // Rule ID 11335 //
     /* 1755326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1755337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1755340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1755343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1755346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755372 */     // MIs[0] policy
     /* 1755372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755382 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755406 */     // GIR_Coverage, 11335,
     /* 1755406 */     GIR_EraseRootFromParent_Done,
     /* 1755407 */   // Label 23932: @1755407
     /* 1755407 */   GIM_Try, /*On fail goto*//*Label 23933*/ GIMT_Encode4(1755493), // Rule ID 11338 //
     /* 1755412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1755423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1755426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1755429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1755432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1755435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755458 */     // MIs[0] policy
     /* 1755458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755468 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755492 */     // GIR_Coverage, 11338,
     /* 1755492 */     GIR_EraseRootFromParent_Done,
     /* 1755493 */   // Label 23933: @1755493
     /* 1755493 */   GIM_Try, /*On fail goto*//*Label 23934*/ GIMT_Encode4(1755579), // Rule ID 11339 //
     /* 1755498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1755509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1755512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1755515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1755518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1755521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755544 */     // MIs[0] policy
     /* 1755544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755554 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755578 */     // GIR_Coverage, 11339,
     /* 1755578 */     GIR_EraseRootFromParent_Done,
     /* 1755579 */   // Label 23934: @1755579
     /* 1755579 */   GIM_Try, /*On fail goto*//*Label 23935*/ GIMT_Encode4(1755665), // Rule ID 11342 //
     /* 1755584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1755601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1755604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755630 */     // MIs[0] policy
     /* 1755630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755664 */     // GIR_Coverage, 11342,
     /* 1755664 */     GIR_EraseRootFromParent_Done,
     /* 1755665 */   // Label 23935: @1755665
     /* 1755665 */   GIM_Try, /*On fail goto*//*Label 23936*/ GIMT_Encode4(1755751), // Rule ID 11343 //
     /* 1755670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1755687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1755690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755716 */     // MIs[0] policy
     /* 1755716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755750 */     // GIR_Coverage, 11343,
     /* 1755750 */     GIR_EraseRootFromParent_Done,
     /* 1755751 */   // Label 23936: @1755751
     /* 1755751 */   GIM_Try, /*On fail goto*//*Label 23937*/ GIMT_Encode4(1755837), // Rule ID 11346 //
     /* 1755756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1755767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1755770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1755773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1755776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755802 */     // MIs[0] policy
     /* 1755802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755812 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755836 */     // GIR_Coverage, 11346,
     /* 1755836 */     GIR_EraseRootFromParent_Done,
     /* 1755837 */   // Label 23937: @1755837
     /* 1755837 */   GIM_Try, /*On fail goto*//*Label 23938*/ GIMT_Encode4(1755923), // Rule ID 11347 //
     /* 1755842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1755853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1755856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1755859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1755862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755888 */     // MIs[0] policy
     /* 1755888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755898 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755922 */     // GIR_Coverage, 11347,
     /* 1755922 */     GIR_EraseRootFromParent_Done,
     /* 1755923 */   // Label 23938: @1755923
     /* 1755923 */   GIM_Try, /*On fail goto*//*Label 23939*/ GIMT_Encode4(1756009), // Rule ID 11350 //
     /* 1755928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1755939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1755942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1755945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1755948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755974 */     // MIs[0] policy
     /* 1755974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755984 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756008 */     // GIR_Coverage, 11350,
     /* 1756008 */     GIR_EraseRootFromParent_Done,
     /* 1756009 */   // Label 23939: @1756009
     /* 1756009 */   GIM_Try, /*On fail goto*//*Label 23940*/ GIMT_Encode4(1756095), // Rule ID 11351 //
     /* 1756014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1756025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1756028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1756031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1756034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1756037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756060 */     // MIs[0] policy
     /* 1756060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756070 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1756073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756094 */     // GIR_Coverage, 11351,
     /* 1756094 */     GIR_EraseRootFromParent_Done,
     /* 1756095 */   // Label 23940: @1756095
     /* 1756095 */   GIM_Try, /*On fail goto*//*Label 23941*/ GIMT_Encode4(1756181), // Rule ID 11354 //
     /* 1756100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1756111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1756114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1756117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1756120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1756130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756146 */     // MIs[0] policy
     /* 1756146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1756159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756180 */     // GIR_Coverage, 11354,
     /* 1756180 */     GIR_EraseRootFromParent_Done,
     /* 1756181 */   // Label 23941: @1756181
     /* 1756181 */   GIM_Try, /*On fail goto*//*Label 23942*/ GIMT_Encode4(1756267), // Rule ID 11355 //
     /* 1756186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1756197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1756200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1756203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1756206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1756216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756232 */     // MIs[0] policy
     /* 1756232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1756245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756266 */     // GIR_Coverage, 11355,
     /* 1756266 */     GIR_EraseRootFromParent_Done,
     /* 1756267 */   // Label 23942: @1756267
     /* 1756267 */   GIM_Try, /*On fail goto*//*Label 23943*/ GIMT_Encode4(1756353), // Rule ID 11358 //
     /* 1756272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1756283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1756286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1756289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1756292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756318 */     // MIs[0] policy
     /* 1756318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1756331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756352 */     // GIR_Coverage, 11358,
     /* 1756352 */     GIR_EraseRootFromParent_Done,
     /* 1756353 */   // Label 23943: @1756353
     /* 1756353 */   GIM_Try, /*On fail goto*//*Label 23944*/ GIMT_Encode4(1756439), // Rule ID 11359 //
     /* 1756358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1756369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1756372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1756375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1756378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756404 */     // MIs[0] policy
     /* 1756404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1756417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756438 */     // GIR_Coverage, 11359,
     /* 1756438 */     GIR_EraseRootFromParent_Done,
     /* 1756439 */   // Label 23944: @1756439
     /* 1756439 */   GIM_Try, /*On fail goto*//*Label 23945*/ GIMT_Encode4(1756525), // Rule ID 11362 //
     /* 1756444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1756455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1756458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1756461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1756464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756490 */     // MIs[0] policy
     /* 1756490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756500 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1756503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756524 */     // GIR_Coverage, 11362,
     /* 1756524 */     GIR_EraseRootFromParent_Done,
     /* 1756525 */   // Label 23945: @1756525
     /* 1756525 */   GIM_Try, /*On fail goto*//*Label 23946*/ GIMT_Encode4(1756611), // Rule ID 11363 //
     /* 1756530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1756541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1756544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1756547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1756550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756576 */     // MIs[0] policy
     /* 1756576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756586 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1756589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756610 */     // GIR_Coverage, 11363,
     /* 1756610 */     GIR_EraseRootFromParent_Done,
     /* 1756611 */   // Label 23946: @1756611
     /* 1756611 */   GIM_Try, /*On fail goto*//*Label 23947*/ GIMT_Encode4(1756697), // Rule ID 11366 //
     /* 1756616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1756627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1756630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1756633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756662 */     // MIs[0] policy
     /* 1756662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756672 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1756675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756696 */     // GIR_Coverage, 11366,
     /* 1756696 */     GIR_EraseRootFromParent_Done,
     /* 1756697 */   // Label 23947: @1756697
     /* 1756697 */   GIM_Try, /*On fail goto*//*Label 23948*/ GIMT_Encode4(1756783), // Rule ID 11367 //
     /* 1756702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1756713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1756716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1756719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756748 */     // MIs[0] policy
     /* 1756748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756758 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1756761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756782 */     // GIR_Coverage, 11367,
     /* 1756782 */     GIR_EraseRootFromParent_Done,
     /* 1756783 */   // Label 23948: @1756783
     /* 1756783 */   GIM_Try, /*On fail goto*//*Label 23949*/ GIMT_Encode4(1756869), // Rule ID 11370 //
     /* 1756788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1756799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1756802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1756805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756834 */     // MIs[0] policy
     /* 1756834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756844 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1756847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756868 */     // GIR_Coverage, 11370,
     /* 1756868 */     GIR_EraseRootFromParent_Done,
     /* 1756869 */   // Label 23949: @1756869
     /* 1756869 */   GIM_Try, /*On fail goto*//*Label 23950*/ GIMT_Encode4(1756955), // Rule ID 11371 //
     /* 1756874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1756885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1756888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1756891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756920 */     // MIs[0] policy
     /* 1756920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756930 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1756933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756954 */     // GIR_Coverage, 11371,
     /* 1756954 */     GIR_EraseRootFromParent_Done,
     /* 1756955 */   // Label 23950: @1756955
     /* 1756955 */   GIM_Try, /*On fail goto*//*Label 23951*/ GIMT_Encode4(1757041), // Rule ID 11374 //
     /* 1756960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1756971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1756974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1756977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757006 */     // MIs[0] policy
     /* 1757006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757016 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757040 */     // GIR_Coverage, 11374,
     /* 1757040 */     GIR_EraseRootFromParent_Done,
     /* 1757041 */   // Label 23951: @1757041
     /* 1757041 */   GIM_Try, /*On fail goto*//*Label 23952*/ GIMT_Encode4(1757127), // Rule ID 11375 //
     /* 1757046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1757057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1757060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1757063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757092 */     // MIs[0] policy
     /* 1757092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757102 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757126 */     // GIR_Coverage, 11375,
     /* 1757126 */     GIR_EraseRootFromParent_Done,
     /* 1757127 */   // Label 23952: @1757127
     /* 1757127 */   GIM_Try, /*On fail goto*//*Label 23953*/ GIMT_Encode4(1757213), // Rule ID 11378 //
     /* 1757132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1757143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1757146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1757149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757178 */     // MIs[0] policy
     /* 1757178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757188 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1757191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757212 */     // GIR_Coverage, 11378,
     /* 1757212 */     GIR_EraseRootFromParent_Done,
     /* 1757213 */   // Label 23953: @1757213
     /* 1757213 */   GIM_Try, /*On fail goto*//*Label 23954*/ GIMT_Encode4(1757299), // Rule ID 11379 //
     /* 1757218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1757229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1757232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1757235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757264 */     // MIs[0] policy
     /* 1757264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757274 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1757277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757298 */     // GIR_Coverage, 11379,
     /* 1757298 */     GIR_EraseRootFromParent_Done,
     /* 1757299 */   // Label 23954: @1757299
     /* 1757299 */   GIM_Try, /*On fail goto*//*Label 23955*/ GIMT_Encode4(1757385), // Rule ID 11382 //
     /* 1757304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1757315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1757318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1757321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757350 */     // MIs[0] policy
     /* 1757350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757360 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757384 */     // GIR_Coverage, 11382,
     /* 1757384 */     GIR_EraseRootFromParent_Done,
     /* 1757385 */   // Label 23955: @1757385
     /* 1757385 */   GIM_Try, /*On fail goto*//*Label 23956*/ GIMT_Encode4(1757471), // Rule ID 11383 //
     /* 1757390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1757401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1757404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1757407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757436 */     // MIs[0] policy
     /* 1757436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757446 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757470 */     // GIR_Coverage, 11383,
     /* 1757470 */     GIR_EraseRootFromParent_Done,
     /* 1757471 */   // Label 23956: @1757471
     /* 1757471 */   GIM_Try, /*On fail goto*//*Label 23957*/ GIMT_Encode4(1757557), // Rule ID 11386 //
     /* 1757476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1757487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1757490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757522 */     // MIs[0] policy
     /* 1757522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757532 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757556 */     // GIR_Coverage, 11386,
     /* 1757556 */     GIR_EraseRootFromParent_Done,
     /* 1757557 */   // Label 23957: @1757557
     /* 1757557 */   GIM_Try, /*On fail goto*//*Label 23958*/ GIMT_Encode4(1757643), // Rule ID 11387 //
     /* 1757562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1757573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1757576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757608 */     // MIs[0] policy
     /* 1757608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757618 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757642 */     // GIR_Coverage, 11387,
     /* 1757642 */     GIR_EraseRootFromParent_Done,
     /* 1757643 */   // Label 23958: @1757643
     /* 1757643 */   GIM_Try, /*On fail goto*//*Label 23959*/ GIMT_Encode4(1757729), // Rule ID 11390 //
     /* 1757648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1757659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1757662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1757665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757694 */     // MIs[0] policy
     /* 1757694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757704 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757728 */     // GIR_Coverage, 11390,
     /* 1757728 */     GIR_EraseRootFromParent_Done,
     /* 1757729 */   // Label 23959: @1757729
     /* 1757729 */   GIM_Try, /*On fail goto*//*Label 23960*/ GIMT_Encode4(1757815), // Rule ID 11391 //
     /* 1757734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1757745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1757748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1757751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757780 */     // MIs[0] policy
     /* 1757780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757790 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757814 */     // GIR_Coverage, 11391,
     /* 1757814 */     GIR_EraseRootFromParent_Done,
     /* 1757815 */   // Label 23960: @1757815
     /* 1757815 */   GIM_Try, /*On fail goto*//*Label 23961*/ GIMT_Encode4(1757901), // Rule ID 11394 //
     /* 1757820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1757831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1757834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1757837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757866 */     // MIs[0] policy
     /* 1757866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757900 */     // GIR_Coverage, 11394,
     /* 1757900 */     GIR_EraseRootFromParent_Done,
     /* 1757901 */   // Label 23961: @1757901
     /* 1757901 */   GIM_Try, /*On fail goto*//*Label 23962*/ GIMT_Encode4(1757987), // Rule ID 11395 //
     /* 1757906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1757917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1757920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1757923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757952 */     // MIs[0] policy
     /* 1757952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757962 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757986 */     // GIR_Coverage, 11395,
     /* 1757986 */     GIR_EraseRootFromParent_Done,
     /* 1757987 */   // Label 23962: @1757987
     /* 1757987 */   GIM_Try, /*On fail goto*//*Label 23963*/ GIMT_Encode4(1758073), // Rule ID 11398 //
     /* 1757992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1758003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1758006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1758009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1758015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758038 */     // MIs[0] policy
     /* 1758038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1758051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758072 */     // GIR_Coverage, 11398,
     /* 1758072 */     GIR_EraseRootFromParent_Done,
     /* 1758073 */   // Label 23963: @1758073
     /* 1758073 */   GIM_Try, /*On fail goto*//*Label 23964*/ GIMT_Encode4(1758159), // Rule ID 11399 //
     /* 1758078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1758089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1758092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1758095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1758101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758124 */     // MIs[0] policy
     /* 1758124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1758137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758158 */     // GIR_Coverage, 11399,
     /* 1758158 */     GIR_EraseRootFromParent_Done,
     /* 1758159 */   // Label 23964: @1758159
     /* 1758159 */   GIM_Try, /*On fail goto*//*Label 23965*/ GIMT_Encode4(1758245), // Rule ID 11402 //
     /* 1758164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1758175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1758178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1758181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758210 */     // MIs[0] policy
     /* 1758210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758220 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758244 */     // GIR_Coverage, 11402,
     /* 1758244 */     GIR_EraseRootFromParent_Done,
     /* 1758245 */   // Label 23965: @1758245
     /* 1758245 */   GIM_Try, /*On fail goto*//*Label 23966*/ GIMT_Encode4(1758331), // Rule ID 11403 //
     /* 1758250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1758261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1758264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1758267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758296 */     // MIs[0] policy
     /* 1758296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758306 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758330 */     // GIR_Coverage, 11403,
     /* 1758330 */     GIR_EraseRootFromParent_Done,
     /* 1758331 */   // Label 23966: @1758331
     /* 1758331 */   GIM_Try, /*On fail goto*//*Label 23967*/ GIMT_Encode4(1758417), // Rule ID 11406 //
     /* 1758336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1758347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1758350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1758353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758382 */     // MIs[0] policy
     /* 1758382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758392 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758416 */     // GIR_Coverage, 11406,
     /* 1758416 */     GIR_EraseRootFromParent_Done,
     /* 1758417 */   // Label 23967: @1758417
     /* 1758417 */   GIM_Try, /*On fail goto*//*Label 23968*/ GIMT_Encode4(1758503), // Rule ID 11407 //
     /* 1758422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1758433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1758436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1758439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758468 */     // MIs[0] policy
     /* 1758468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758478 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758502 */     // GIR_Coverage, 11407,
     /* 1758502 */     GIR_EraseRootFromParent_Done,
     /* 1758503 */   // Label 23968: @1758503
     /* 1758503 */   GIM_Try, /*On fail goto*//*Label 23969*/ GIMT_Encode4(1758589), // Rule ID 11410 //
     /* 1758508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1758519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1758522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1758525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1758531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758554 */     // MIs[0] policy
     /* 1758554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758564 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1758567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758588 */     // GIR_Coverage, 11410,
     /* 1758588 */     GIR_EraseRootFromParent_Done,
     /* 1758589 */   // Label 23969: @1758589
     /* 1758589 */   GIM_Try, /*On fail goto*//*Label 23970*/ GIMT_Encode4(1758675), // Rule ID 11411 //
     /* 1758594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1758605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1758608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1758611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1758617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758640 */     // MIs[0] policy
     /* 1758640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758650 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1758653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758674 */     // GIR_Coverage, 11411,
     /* 1758674 */     GIR_EraseRootFromParent_Done,
     /* 1758675 */   // Label 23970: @1758675
     /* 1758675 */   GIM_Try, /*On fail goto*//*Label 23971*/ GIMT_Encode4(1758761), // Rule ID 11414 //
     /* 1758680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1758691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1758694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1758697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758726 */     // MIs[0] policy
     /* 1758726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758760 */     // GIR_Coverage, 11414,
     /* 1758760 */     GIR_EraseRootFromParent_Done,
     /* 1758761 */   // Label 23971: @1758761
     /* 1758761 */   GIM_Try, /*On fail goto*//*Label 23972*/ GIMT_Encode4(1758847), // Rule ID 11415 //
     /* 1758766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1758777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1758780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1758783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758812 */     // MIs[0] policy
     /* 1758812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758822 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758846 */     // GIR_Coverage, 11415,
     /* 1758846 */     GIR_EraseRootFromParent_Done,
     /* 1758847 */   // Label 23972: @1758847
     /* 1758847 */   GIM_Try, /*On fail goto*//*Label 23973*/ GIMT_Encode4(1758933), // Rule ID 11418 //
     /* 1758852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1758863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1758866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1758869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758898 */     // MIs[0] policy
     /* 1758898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758908 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758932 */     // GIR_Coverage, 11418,
     /* 1758932 */     GIR_EraseRootFromParent_Done,
     /* 1758933 */   // Label 23973: @1758933
     /* 1758933 */   GIM_Try, /*On fail goto*//*Label 23974*/ GIMT_Encode4(1759019), // Rule ID 11419 //
     /* 1758938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1758949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1758952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1758955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758984 */     // MIs[0] policy
     /* 1758984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758994 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759018 */     // GIR_Coverage, 11419,
     /* 1759018 */     GIR_EraseRootFromParent_Done,
     /* 1759019 */   // Label 23974: @1759019
     /* 1759019 */   GIM_Try, /*On fail goto*//*Label 23975*/ GIMT_Encode4(1759105), // Rule ID 11422 //
     /* 1759024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1759035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1759038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1759041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1759047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759070 */     // MIs[0] policy
     /* 1759070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759080 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1759083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759104 */     // GIR_Coverage, 11422,
     /* 1759104 */     GIR_EraseRootFromParent_Done,
     /* 1759105 */   // Label 23975: @1759105
     /* 1759105 */   GIM_Try, /*On fail goto*//*Label 23976*/ GIMT_Encode4(1759191), // Rule ID 11423 //
     /* 1759110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1759121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1759124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1759127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1759133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759156 */     // MIs[0] policy
     /* 1759156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759166 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1759169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759190 */     // GIR_Coverage, 11423,
     /* 1759190 */     GIR_EraseRootFromParent_Done,
     /* 1759191 */   // Label 23976: @1759191
     /* 1759191 */   GIM_Try, /*On fail goto*//*Label 23977*/ GIMT_Encode4(1759277), // Rule ID 11426 //
     /* 1759196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1759207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1759210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1759213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759242 */     // MIs[0] policy
     /* 1759242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1759255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759276 */     // GIR_Coverage, 11426,
     /* 1759276 */     GIR_EraseRootFromParent_Done,
     /* 1759277 */   // Label 23977: @1759277
     /* 1759277 */   GIM_Try, /*On fail goto*//*Label 23978*/ GIMT_Encode4(1759363), // Rule ID 11427 //
     /* 1759282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1759293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1759296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1759299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759328 */     // MIs[0] policy
     /* 1759328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1759341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759362 */     // GIR_Coverage, 11427,
     /* 1759362 */     GIR_EraseRootFromParent_Done,
     /* 1759363 */   // Label 23978: @1759363
     /* 1759363 */   GIM_Try, /*On fail goto*//*Label 23979*/ GIMT_Encode4(1759449), // Rule ID 11430 //
     /* 1759368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1759379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1759382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1759385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759414 */     // MIs[0] policy
     /* 1759414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759424 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1759427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759448 */     // GIR_Coverage, 11430,
     /* 1759448 */     GIR_EraseRootFromParent_Done,
     /* 1759449 */   // Label 23979: @1759449
     /* 1759449 */   GIM_Try, /*On fail goto*//*Label 23980*/ GIMT_Encode4(1759535), // Rule ID 11431 //
     /* 1759454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1759465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1759468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1759471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759500 */     // MIs[0] policy
     /* 1759500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759510 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1759513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759534 */     // GIR_Coverage, 11431,
     /* 1759534 */     GIR_EraseRootFromParent_Done,
     /* 1759535 */   // Label 23980: @1759535
     /* 1759535 */   GIM_Try, /*On fail goto*//*Label 23981*/ GIMT_Encode4(1759621), // Rule ID 11434 //
     /* 1759540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1759557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759586 */     // MIs[0] policy
     /* 1759586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1759599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759620 */     // GIR_Coverage, 11434,
     /* 1759620 */     GIR_EraseRootFromParent_Done,
     /* 1759621 */   // Label 23981: @1759621
     /* 1759621 */   GIM_Try, /*On fail goto*//*Label 23982*/ GIMT_Encode4(1759707), // Rule ID 11435 //
     /* 1759626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1759643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759672 */     // MIs[0] policy
     /* 1759672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759682 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1759685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759706 */     // GIR_Coverage, 11435,
     /* 1759706 */     GIR_EraseRootFromParent_Done,
     /* 1759707 */   // Label 23982: @1759707
     /* 1759707 */   GIM_Try, /*On fail goto*//*Label 23983*/ GIMT_Encode4(1759793), // Rule ID 11438 //
     /* 1759712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1759723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1759726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1759729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1759732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759758 */     // MIs[0] policy
     /* 1759758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759768 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1759771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759792 */     // GIR_Coverage, 11438,
     /* 1759792 */     GIR_EraseRootFromParent_Done,
     /* 1759793 */   // Label 23983: @1759793
     /* 1759793 */   GIM_Try, /*On fail goto*//*Label 23984*/ GIMT_Encode4(1759879), // Rule ID 11439 //
     /* 1759798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1759809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1759812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1759815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1759818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759844 */     // MIs[0] policy
     /* 1759844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759854 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1759857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759878 */     // GIR_Coverage, 11439,
     /* 1759878 */     GIR_EraseRootFromParent_Done,
     /* 1759879 */   // Label 23984: @1759879
     /* 1759879 */   GIM_Try, /*On fail goto*//*Label 23985*/ GIMT_Encode4(1759965), // Rule ID 11442 //
     /* 1759884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1759895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1759898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1759901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1759904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759930 */     // MIs[0] policy
     /* 1759930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759940 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1759943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759964 */     // GIR_Coverage, 11442,
     /* 1759964 */     GIR_EraseRootFromParent_Done,
     /* 1759965 */   // Label 23985: @1759965
     /* 1759965 */   GIM_Try, /*On fail goto*//*Label 23986*/ GIMT_Encode4(1760051), // Rule ID 11443 //
     /* 1759970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1759981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1759984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1759987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1759990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760016 */     // MIs[0] policy
     /* 1760016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760026 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1760029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760050 */     // GIR_Coverage, 11443,
     /* 1760050 */     GIR_EraseRootFromParent_Done,
     /* 1760051 */   // Label 23986: @1760051
     /* 1760051 */   GIM_Try, /*On fail goto*//*Label 23987*/ GIMT_Encode4(1760137), // Rule ID 11446 //
     /* 1760056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1760067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1760070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1760073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1760076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760102 */     // MIs[0] policy
     /* 1760102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760112 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760136 */     // GIR_Coverage, 11446,
     /* 1760136 */     GIR_EraseRootFromParent_Done,
     /* 1760137 */   // Label 23987: @1760137
     /* 1760137 */   GIM_Try, /*On fail goto*//*Label 23988*/ GIMT_Encode4(1760223), // Rule ID 11447 //
     /* 1760142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1760153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1760156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1760159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1760162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760188 */     // MIs[0] policy
     /* 1760188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760198 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760222 */     // GIR_Coverage, 11447,
     /* 1760222 */     GIR_EraseRootFromParent_Done,
     /* 1760223 */   // Label 23988: @1760223
     /* 1760223 */   GIM_Try, /*On fail goto*//*Label 23989*/ GIMT_Encode4(1760309), // Rule ID 11450 //
     /* 1760228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1760239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1760242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1760245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1760248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760274 */     // MIs[0] policy
     /* 1760274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760284 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1760287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760308 */     // GIR_Coverage, 11450,
     /* 1760308 */     GIR_EraseRootFromParent_Done,
     /* 1760309 */   // Label 23989: @1760309
     /* 1760309 */   GIM_Try, /*On fail goto*//*Label 23990*/ GIMT_Encode4(1760395), // Rule ID 11451 //
     /* 1760314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1760325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1760328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1760331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1760334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760360 */     // MIs[0] policy
     /* 1760360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760370 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1760373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760394 */     // GIR_Coverage, 11451,
     /* 1760394 */     GIR_EraseRootFromParent_Done,
     /* 1760395 */   // Label 23990: @1760395
     /* 1760395 */   GIM_Try, /*On fail goto*//*Label 23991*/ GIMT_Encode4(1760481), // Rule ID 11454 //
     /* 1760400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1760411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1760414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1760417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1760420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760446 */     // MIs[0] policy
     /* 1760446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760456 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760480 */     // GIR_Coverage, 11454,
     /* 1760480 */     GIR_EraseRootFromParent_Done,
     /* 1760481 */   // Label 23991: @1760481
     /* 1760481 */   GIM_Try, /*On fail goto*//*Label 23992*/ GIMT_Encode4(1760567), // Rule ID 11455 //
     /* 1760486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1760497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1760500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1760503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1760506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760532 */     // MIs[0] policy
     /* 1760532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760542 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760566 */     // GIR_Coverage, 11455,
     /* 1760566 */     GIR_EraseRootFromParent_Done,
     /* 1760567 */   // Label 23992: @1760567
     /* 1760567 */   GIM_Try, /*On fail goto*//*Label 23993*/ GIMT_Encode4(1760653), // Rule ID 11458 //
     /* 1760572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1760583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1760586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1760589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1760592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760618 */     // MIs[0] policy
     /* 1760618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760628 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760652 */     // GIR_Coverage, 11458,
     /* 1760652 */     GIR_EraseRootFromParent_Done,
     /* 1760653 */   // Label 23993: @1760653
     /* 1760653 */   GIM_Try, /*On fail goto*//*Label 23994*/ GIMT_Encode4(1760739), // Rule ID 11459 //
     /* 1760658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1760669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1760672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1760675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1760678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760704 */     // MIs[0] policy
     /* 1760704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760738 */     // GIR_Coverage, 11459,
     /* 1760738 */     GIR_EraseRootFromParent_Done,
     /* 1760739 */   // Label 23994: @1760739
     /* 1760739 */   GIM_Try, /*On fail goto*//*Label 23995*/ GIMT_Encode4(1760825), // Rule ID 11462 //
     /* 1760744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1760755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1760758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1760761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1760764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760790 */     // MIs[0] policy
     /* 1760790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760800 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760824 */     // GIR_Coverage, 11462,
     /* 1760824 */     GIR_EraseRootFromParent_Done,
     /* 1760825 */   // Label 23995: @1760825
     /* 1760825 */   GIM_Try, /*On fail goto*//*Label 23996*/ GIMT_Encode4(1760911), // Rule ID 11463 //
     /* 1760830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1760841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1760844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1760847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1760850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760876 */     // MIs[0] policy
     /* 1760876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760886 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760910 */     // GIR_Coverage, 11463,
     /* 1760910 */     GIR_EraseRootFromParent_Done,
     /* 1760911 */   // Label 23996: @1760911
     /* 1760911 */   GIM_Try, /*On fail goto*//*Label 23997*/ GIMT_Encode4(1760997), // Rule ID 11466 //
     /* 1760916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1760927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1760930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1760933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1760936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760962 */     // MIs[0] policy
     /* 1760962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760972 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760996 */     // GIR_Coverage, 11466,
     /* 1760996 */     GIR_EraseRootFromParent_Done,
     /* 1760997 */   // Label 23997: @1760997
     /* 1760997 */   GIM_Try, /*On fail goto*//*Label 23998*/ GIMT_Encode4(1761083), // Rule ID 11467 //
     /* 1761002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1761013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1761016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1761019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1761022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761048 */     // MIs[0] policy
     /* 1761048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1761061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761082 */     // GIR_Coverage, 11467,
     /* 1761082 */     GIR_EraseRootFromParent_Done,
     /* 1761083 */   // Label 23998: @1761083
     /* 1761083 */   GIM_Try, /*On fail goto*//*Label 23999*/ GIMT_Encode4(1761169), // Rule ID 11470 //
     /* 1761088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1761099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1761102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1761105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1761108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761134 */     // MIs[0] policy
     /* 1761134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1761147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761168 */     // GIR_Coverage, 11470,
     /* 1761168 */     GIR_EraseRootFromParent_Done,
     /* 1761169 */   // Label 23999: @1761169
     /* 1761169 */   GIM_Try, /*On fail goto*//*Label 24000*/ GIMT_Encode4(1761255), // Rule ID 11471 //
     /* 1761174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1761185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1761188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1761191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1761194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761220 */     // MIs[0] policy
     /* 1761220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1761233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761254 */     // GIR_Coverage, 11471,
     /* 1761254 */     GIR_EraseRootFromParent_Done,
     /* 1761255 */   // Label 24000: @1761255
     /* 1761255 */   GIM_Try, /*On fail goto*//*Label 24001*/ GIMT_Encode4(1761341), // Rule ID 11474 //
     /* 1761260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1761271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1761274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1761277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1761280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761306 */     // MIs[0] policy
     /* 1761306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761316 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761340 */     // GIR_Coverage, 11474,
     /* 1761340 */     GIR_EraseRootFromParent_Done,
     /* 1761341 */   // Label 24001: @1761341
     /* 1761341 */   GIM_Try, /*On fail goto*//*Label 24002*/ GIMT_Encode4(1761427), // Rule ID 11475 //
     /* 1761346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1761357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1761360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1761363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1761366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761392 */     // MIs[0] policy
     /* 1761392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761402 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761426 */     // GIR_Coverage, 11475,
     /* 1761426 */     GIR_EraseRootFromParent_Done,
     /* 1761427 */   // Label 24002: @1761427
     /* 1761427 */   GIM_Try, /*On fail goto*//*Label 24003*/ GIMT_Encode4(1761513), // Rule ID 11478 //
     /* 1761432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1761443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1761446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1761449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1761452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761478 */     // MIs[0] policy
     /* 1761478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761488 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761512 */     // GIR_Coverage, 11478,
     /* 1761512 */     GIR_EraseRootFromParent_Done,
     /* 1761513 */   // Label 24003: @1761513
     /* 1761513 */   GIM_Try, /*On fail goto*//*Label 24004*/ GIMT_Encode4(1761599), // Rule ID 11479 //
     /* 1761518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1761529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1761532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1761535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1761538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761564 */     // MIs[0] policy
     /* 1761564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761574 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761598 */     // GIR_Coverage, 11479,
     /* 1761598 */     GIR_EraseRootFromParent_Done,
     /* 1761599 */   // Label 24004: @1761599
     /* 1761599 */   GIM_Try, /*On fail goto*//*Label 24005*/ GIMT_Encode4(1761685), // Rule ID 11482 //
     /* 1761604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1761615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1761618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1761621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1761624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1761627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761650 */     // MIs[0] policy
     /* 1761650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761660 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1761663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761684 */     // GIR_Coverage, 11482,
     /* 1761684 */     GIR_EraseRootFromParent_Done,
     /* 1761685 */   // Label 24005: @1761685
     /* 1761685 */   GIM_Try, /*On fail goto*//*Label 24006*/ GIMT_Encode4(1761771), // Rule ID 11483 //
     /* 1761690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1761701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1761704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1761707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1761710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1761713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761736 */     // MIs[0] policy
     /* 1761736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761746 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1761749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761770 */     // GIR_Coverage, 11483,
     /* 1761770 */     GIR_EraseRootFromParent_Done,
     /* 1761771 */   // Label 24006: @1761771
     /* 1761771 */   GIM_Try, /*On fail goto*//*Label 24007*/ GIMT_Encode4(1761857), // Rule ID 11486 //
     /* 1761776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1761787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1761790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1761793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1761796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761822 */     // MIs[0] policy
     /* 1761822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761832 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761856 */     // GIR_Coverage, 11486,
     /* 1761856 */     GIR_EraseRootFromParent_Done,
     /* 1761857 */   // Label 24007: @1761857
     /* 1761857 */   GIM_Try, /*On fail goto*//*Label 24008*/ GIMT_Encode4(1761943), // Rule ID 11487 //
     /* 1761862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1761873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1761876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1761879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1761882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761908 */     // MIs[0] policy
     /* 1761908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761942 */     // GIR_Coverage, 11487,
     /* 1761942 */     GIR_EraseRootFromParent_Done,
     /* 1761943 */   // Label 24008: @1761943
     /* 1761943 */   GIM_Try, /*On fail goto*//*Label 24009*/ GIMT_Encode4(1762029), // Rule ID 11490 //
     /* 1761948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1761959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1761962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1761965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1761968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761994 */     // MIs[0] policy
     /* 1761994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762004 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1762007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762028 */     // GIR_Coverage, 11490,
     /* 1762028 */     GIR_EraseRootFromParent_Done,
     /* 1762029 */   // Label 24009: @1762029
     /* 1762029 */   GIM_Try, /*On fail goto*//*Label 24010*/ GIMT_Encode4(1762115), // Rule ID 11491 //
     /* 1762034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1762045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1762048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1762051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1762054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762080 */     // MIs[0] policy
     /* 1762080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762090 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1762093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762114 */     // GIR_Coverage, 11491,
     /* 1762114 */     GIR_EraseRootFromParent_Done,
     /* 1762115 */   // Label 24010: @1762115
     /* 1762115 */   GIM_Try, /*On fail goto*//*Label 24011*/ GIMT_Encode4(1762201), // Rule ID 11494 //
     /* 1762120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1762131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1762134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1762137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1762140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1762143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762166 */     // MIs[0] policy
     /* 1762166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762176 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762200 */     // GIR_Coverage, 11494,
     /* 1762200 */     GIR_EraseRootFromParent_Done,
     /* 1762201 */   // Label 24011: @1762201
     /* 1762201 */   GIM_Try, /*On fail goto*//*Label 24012*/ GIMT_Encode4(1762287), // Rule ID 11495 //
     /* 1762206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1762217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1762220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1762223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1762226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1762229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762252 */     // MIs[0] policy
     /* 1762252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762262 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762286 */     // GIR_Coverage, 11495,
     /* 1762286 */     GIR_EraseRootFromParent_Done,
     /* 1762287 */   // Label 24012: @1762287
     /* 1762287 */   GIM_Try, /*On fail goto*//*Label 24013*/ GIMT_Encode4(1762373), // Rule ID 11498 //
     /* 1762292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1762303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1762306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1762309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1762312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762338 */     // MIs[0] policy
     /* 1762338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1762351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762372 */     // GIR_Coverage, 11498,
     /* 1762372 */     GIR_EraseRootFromParent_Done,
     /* 1762373 */   // Label 24013: @1762373
     /* 1762373 */   GIM_Try, /*On fail goto*//*Label 24014*/ GIMT_Encode4(1762459), // Rule ID 11499 //
     /* 1762378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1762389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1762392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1762395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1762398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762424 */     // MIs[0] policy
     /* 1762424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1762437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762458 */     // GIR_Coverage, 11499,
     /* 1762458 */     GIR_EraseRootFromParent_Done,
     /* 1762459 */   // Label 24014: @1762459
     /* 1762459 */   GIM_Try, /*On fail goto*//*Label 24015*/ GIMT_Encode4(1762545), // Rule ID 11502 //
     /* 1762464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1762481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1762484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762510 */     // MIs[0] policy
     /* 1762510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1762523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762544 */     // GIR_Coverage, 11502,
     /* 1762544 */     GIR_EraseRootFromParent_Done,
     /* 1762545 */   // Label 24015: @1762545
     /* 1762545 */   GIM_Try, /*On fail goto*//*Label 24016*/ GIMT_Encode4(1762631), // Rule ID 11503 //
     /* 1762550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1762567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1762570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762596 */     // MIs[0] policy
     /* 1762596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1762609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762630 */     // GIR_Coverage, 11503,
     /* 1762630 */     GIR_EraseRootFromParent_Done,
     /* 1762631 */   // Label 24016: @1762631
     /* 1762631 */   GIM_Try, /*On fail goto*//*Label 24017*/ GIMT_Encode4(1762717), // Rule ID 11506 //
     /* 1762636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1762647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1762650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1762653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1762656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762682 */     // MIs[0] policy
     /* 1762682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762716 */     // GIR_Coverage, 11506,
     /* 1762716 */     GIR_EraseRootFromParent_Done,
     /* 1762717 */   // Label 24017: @1762717
     /* 1762717 */   GIM_Try, /*On fail goto*//*Label 24018*/ GIMT_Encode4(1762803), // Rule ID 11507 //
     /* 1762722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1762733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1762736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1762739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1762742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762768 */     // MIs[0] policy
     /* 1762768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762778 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762802 */     // GIR_Coverage, 11507,
     /* 1762802 */     GIR_EraseRootFromParent_Done,
     /* 1762803 */   // Label 24018: @1762803
     /* 1762803 */   GIM_Try, /*On fail goto*//*Label 24019*/ GIMT_Encode4(1762889), // Rule ID 11510 //
     /* 1762808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1762819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1762822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1762825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762854 */     // MIs[0] policy
     /* 1762854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762864 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1762867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762888 */     // GIR_Coverage, 11510,
     /* 1762888 */     GIR_EraseRootFromParent_Done,
     /* 1762889 */   // Label 24019: @1762889
     /* 1762889 */   GIM_Try, /*On fail goto*//*Label 24020*/ GIMT_Encode4(1762975), // Rule ID 11511 //
     /* 1762894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1762905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1762908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1762911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762940 */     // MIs[0] policy
     /* 1762940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762950 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1762953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762974 */     // GIR_Coverage, 11511,
     /* 1762974 */     GIR_EraseRootFromParent_Done,
     /* 1762975 */   // Label 24020: @1762975
     /* 1762975 */   GIM_Try, /*On fail goto*//*Label 24021*/ GIMT_Encode4(1763061), // Rule ID 11514 //
     /* 1762980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1762991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1762994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1762997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763026 */     // MIs[0] policy
     /* 1763026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763036 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1763039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763060 */     // GIR_Coverage, 11514,
     /* 1763060 */     GIR_EraseRootFromParent_Done,
     /* 1763061 */   // Label 24021: @1763061
     /* 1763061 */   GIM_Try, /*On fail goto*//*Label 24022*/ GIMT_Encode4(1763147), // Rule ID 11515 //
     /* 1763066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1763077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1763080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1763083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763112 */     // MIs[0] policy
     /* 1763112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763122 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1763125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763146 */     // GIR_Coverage, 11515,
     /* 1763146 */     GIR_EraseRootFromParent_Done,
     /* 1763147 */   // Label 24022: @1763147
     /* 1763147 */   GIM_Try, /*On fail goto*//*Label 24023*/ GIMT_Encode4(1763233), // Rule ID 11518 //
     /* 1763152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1763163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1763166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1763169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763198 */     // MIs[0] policy
     /* 1763198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763232 */     // GIR_Coverage, 11518,
     /* 1763232 */     GIR_EraseRootFromParent_Done,
     /* 1763233 */   // Label 24023: @1763233
     /* 1763233 */   GIM_Try, /*On fail goto*//*Label 24024*/ GIMT_Encode4(1763319), // Rule ID 11519 //
     /* 1763238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1763249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1763252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1763255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763284 */     // MIs[0] policy
     /* 1763284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763318 */     // GIR_Coverage, 11519,
     /* 1763318 */     GIR_EraseRootFromParent_Done,
     /* 1763319 */   // Label 24024: @1763319
     /* 1763319 */   GIM_Try, /*On fail goto*//*Label 24025*/ GIMT_Encode4(1763405), // Rule ID 11522 //
     /* 1763324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1763335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1763338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1763341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763370 */     // MIs[0] policy
     /* 1763370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763380 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1763383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763404 */     // GIR_Coverage, 11522,
     /* 1763404 */     GIR_EraseRootFromParent_Done,
     /* 1763405 */   // Label 24025: @1763405
     /* 1763405 */   GIM_Try, /*On fail goto*//*Label 24026*/ GIMT_Encode4(1763491), // Rule ID 11523 //
     /* 1763410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1763421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1763424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1763427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763456 */     // MIs[0] policy
     /* 1763456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763466 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1763469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763490 */     // GIR_Coverage, 11523,
     /* 1763490 */     GIR_EraseRootFromParent_Done,
     /* 1763491 */   // Label 24026: @1763491
     /* 1763491 */   GIM_Try, /*On fail goto*//*Label 24027*/ GIMT_Encode4(1763577), // Rule ID 11526 //
     /* 1763496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763542 */     // MIs[0] policy
     /* 1763542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763576 */     // GIR_Coverage, 11526,
     /* 1763576 */     GIR_EraseRootFromParent_Done,
     /* 1763577 */   // Label 24027: @1763577
     /* 1763577 */   GIM_Try, /*On fail goto*//*Label 24028*/ GIMT_Encode4(1763663), // Rule ID 11527 //
     /* 1763582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763628 */     // MIs[0] policy
     /* 1763628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763638 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763662 */     // GIR_Coverage, 11527,
     /* 1763662 */     GIR_EraseRootFromParent_Done,
     /* 1763663 */   // Label 24028: @1763663
     /* 1763663 */   GIM_Try, /*On fail goto*//*Label 24029*/ GIMT_Encode4(1763749), // Rule ID 11530 //
     /* 1763668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763714 */     // MIs[0] policy
     /* 1763714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763748 */     // GIR_Coverage, 11530,
     /* 1763748 */     GIR_EraseRootFromParent_Done,
     /* 1763749 */   // Label 24029: @1763749
     /* 1763749 */   GIM_Try, /*On fail goto*//*Label 24030*/ GIMT_Encode4(1763835), // Rule ID 11531 //
     /* 1763754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763800 */     // MIs[0] policy
     /* 1763800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763810 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763834 */     // GIR_Coverage, 11531,
     /* 1763834 */     GIR_EraseRootFromParent_Done,
     /* 1763835 */   // Label 24030: @1763835
     /* 1763835 */   GIM_Try, /*On fail goto*//*Label 24031*/ GIMT_Encode4(1763921), // Rule ID 11534 //
     /* 1763840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1763851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1763854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1763857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1763863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763886 */     // MIs[0] policy
     /* 1763886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763920 */     // GIR_Coverage, 11534,
     /* 1763920 */     GIR_EraseRootFromParent_Done,
     /* 1763921 */   // Label 24031: @1763921
     /* 1763921 */   GIM_Try, /*On fail goto*//*Label 24032*/ GIMT_Encode4(1764007), // Rule ID 11535 //
     /* 1763926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1763937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1763940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1763943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1763949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763972 */     // MIs[0] policy
     /* 1763972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764006 */     // GIR_Coverage, 11535,
     /* 1764006 */     GIR_EraseRootFromParent_Done,
     /* 1764007 */   // Label 24032: @1764007
     /* 1764007 */   GIM_Try, /*On fail goto*//*Label 24033*/ GIMT_Encode4(1764093), // Rule ID 11538 //
     /* 1764012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1764023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1764026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1764029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764058 */     // MIs[0] policy
     /* 1764058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1764071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764092 */     // GIR_Coverage, 11538,
     /* 1764092 */     GIR_EraseRootFromParent_Done,
     /* 1764093 */   // Label 24033: @1764093
     /* 1764093 */   GIM_Try, /*On fail goto*//*Label 24034*/ GIMT_Encode4(1764179), // Rule ID 11539 //
     /* 1764098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1764109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1764112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1764115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764144 */     // MIs[0] policy
     /* 1764144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764154 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1764157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764178 */     // GIR_Coverage, 11539,
     /* 1764178 */     GIR_EraseRootFromParent_Done,
     /* 1764179 */   // Label 24034: @1764179
     /* 1764179 */   GIM_Try, /*On fail goto*//*Label 24035*/ GIMT_Encode4(1764265), // Rule ID 11542 //
     /* 1764184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1764195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1764198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1764201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764230 */     // MIs[0] policy
     /* 1764230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1764243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764264 */     // GIR_Coverage, 11542,
     /* 1764264 */     GIR_EraseRootFromParent_Done,
     /* 1764265 */   // Label 24035: @1764265
     /* 1764265 */   GIM_Try, /*On fail goto*//*Label 24036*/ GIMT_Encode4(1764351), // Rule ID 11543 //
     /* 1764270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1764281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1764284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1764287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764316 */     // MIs[0] policy
     /* 1764316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1764329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764350 */     // GIR_Coverage, 11543,
     /* 1764350 */     GIR_EraseRootFromParent_Done,
     /* 1764351 */   // Label 24036: @1764351
     /* 1764351 */   GIM_Try, /*On fail goto*//*Label 24037*/ GIMT_Encode4(1764437), // Rule ID 11546 //
     /* 1764356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1764367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1764370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1764373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764402 */     // MIs[0] policy
     /* 1764402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764412 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764436 */     // GIR_Coverage, 11546,
     /* 1764436 */     GIR_EraseRootFromParent_Done,
     /* 1764437 */   // Label 24037: @1764437
     /* 1764437 */   GIM_Try, /*On fail goto*//*Label 24038*/ GIMT_Encode4(1764523), // Rule ID 11547 //
     /* 1764442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1764453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1764456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1764459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764488 */     // MIs[0] policy
     /* 1764488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764498 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764522 */     // GIR_Coverage, 11547,
     /* 1764522 */     GIR_EraseRootFromParent_Done,
     /* 1764523 */   // Label 24038: @1764523
     /* 1764523 */   GIM_Try, /*On fail goto*//*Label 24039*/ GIMT_Encode4(1764609), // Rule ID 11550 //
     /* 1764528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764574 */     // MIs[0] policy
     /* 1764574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764584 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1764587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764608 */     // GIR_Coverage, 11550,
     /* 1764608 */     GIR_EraseRootFromParent_Done,
     /* 1764609 */   // Label 24039: @1764609
     /* 1764609 */   GIM_Try, /*On fail goto*//*Label 24040*/ GIMT_Encode4(1764695), // Rule ID 11551 //
     /* 1764614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764660 */     // MIs[0] policy
     /* 1764660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764670 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1764673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764694 */     // GIR_Coverage, 11551,
     /* 1764694 */     GIR_EraseRootFromParent_Done,
     /* 1764695 */   // Label 24040: @1764695
     /* 1764695 */   GIM_Try, /*On fail goto*//*Label 24041*/ GIMT_Encode4(1764781), // Rule ID 11554 //
     /* 1764700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1764711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1764714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1764717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1764723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764746 */     // MIs[0] policy
     /* 1764746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764756 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1764759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764780 */     // GIR_Coverage, 11554,
     /* 1764780 */     GIR_EraseRootFromParent_Done,
     /* 1764781 */   // Label 24041: @1764781
     /* 1764781 */   GIM_Try, /*On fail goto*//*Label 24042*/ GIMT_Encode4(1764867), // Rule ID 11555 //
     /* 1764786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1764797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1764800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1764803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1764809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764832 */     // MIs[0] policy
     /* 1764832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764842 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1764845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764866 */     // GIR_Coverage, 11555,
     /* 1764866 */     GIR_EraseRootFromParent_Done,
     /* 1764867 */   // Label 24042: @1764867
     /* 1764867 */   GIM_Try, /*On fail goto*//*Label 24043*/ GIMT_Encode4(1764953), // Rule ID 11558 //
     /* 1764872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1764883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1764886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1764889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764918 */     // MIs[0] policy
     /* 1764918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764928 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764952 */     // GIR_Coverage, 11558,
     /* 1764952 */     GIR_EraseRootFromParent_Done,
     /* 1764953 */   // Label 24043: @1764953
     /* 1764953 */   GIM_Try, /*On fail goto*//*Label 24044*/ GIMT_Encode4(1765039), // Rule ID 11559 //
     /* 1764958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1764969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1764972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1764975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765004 */     // MIs[0] policy
     /* 1765004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1765017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765038 */     // GIR_Coverage, 11559,
     /* 1765038 */     GIR_EraseRootFromParent_Done,
     /* 1765039 */   // Label 24044: @1765039
     /* 1765039 */   GIM_Try, /*On fail goto*//*Label 24045*/ GIMT_Encode4(1765125), // Rule ID 11562 //
     /* 1765044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1765055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1765058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1765061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765090 */     // MIs[0] policy
     /* 1765090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765100 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1765103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765124 */     // GIR_Coverage, 11562,
     /* 1765124 */     GIR_EraseRootFromParent_Done,
     /* 1765125 */   // Label 24045: @1765125
     /* 1765125 */   GIM_Try, /*On fail goto*//*Label 24046*/ GIMT_Encode4(1765211), // Rule ID 11563 //
     /* 1765130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1765141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1765144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1765147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765176 */     // MIs[0] policy
     /* 1765176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765186 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1765189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765210 */     // GIR_Coverage, 11563,
     /* 1765210 */     GIR_EraseRootFromParent_Done,
     /* 1765211 */   // Label 24046: @1765211
     /* 1765211 */   GIM_Try, /*On fail goto*//*Label 24047*/ GIMT_Encode4(1765297), // Rule ID 11566 //
     /* 1765216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1765227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1765230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1765233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1765239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765262 */     // MIs[0] policy
     /* 1765262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765272 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1765275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765296 */     // GIR_Coverage, 11566,
     /* 1765296 */     GIR_EraseRootFromParent_Done,
     /* 1765297 */   // Label 24047: @1765297
     /* 1765297 */   GIM_Try, /*On fail goto*//*Label 24048*/ GIMT_Encode4(1765383), // Rule ID 11567 //
     /* 1765302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1765313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1765316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1765319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1765325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765348 */     // MIs[0] policy
     /* 1765348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765358 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1765361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765382 */     // GIR_Coverage, 11567,
     /* 1765382 */     GIR_EraseRootFromParent_Done,
     /* 1765383 */   // Label 24048: @1765383
     /* 1765383 */   GIM_Try, /*On fail goto*//*Label 24049*/ GIMT_Encode4(1765469), // Rule ID 11570 //
     /* 1765388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1765399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1765402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1765405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765434 */     // MIs[0] policy
     /* 1765434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1765447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765468 */     // GIR_Coverage, 11570,
     /* 1765468 */     GIR_EraseRootFromParent_Done,
     /* 1765469 */   // Label 24049: @1765469
     /* 1765469 */   GIM_Try, /*On fail goto*//*Label 24050*/ GIMT_Encode4(1765555), // Rule ID 11571 //
     /* 1765474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1765485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1765488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1765491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765520 */     // MIs[0] policy
     /* 1765520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765530 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1765533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765554 */     // GIR_Coverage, 11571,
     /* 1765554 */     GIR_EraseRootFromParent_Done,
     /* 1765555 */   // Label 24050: @1765555
     /* 1765555 */   GIM_Try, /*On fail goto*//*Label 24051*/ GIMT_Encode4(1765641), // Rule ID 11574 //
     /* 1765560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1765571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1765574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1765577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765606 */     // MIs[0] policy
     /* 1765606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765616 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1765619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765640 */     // GIR_Coverage, 11574,
     /* 1765640 */     GIR_EraseRootFromParent_Done,
     /* 1765641 */   // Label 24051: @1765641
     /* 1765641 */   GIM_Try, /*On fail goto*//*Label 24052*/ GIMT_Encode4(1765727), // Rule ID 11575 //
     /* 1765646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1765657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1765660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1765663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765692 */     // MIs[0] policy
     /* 1765692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765702 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1765705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765726 */     // GIR_Coverage, 11575,
     /* 1765726 */     GIR_EraseRootFromParent_Done,
     /* 1765727 */   // Label 24052: @1765727
     /* 1765727 */   GIM_Try, /*On fail goto*//*Label 24053*/ GIMT_Encode4(1765813), // Rule ID 11578 //
     /* 1765732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1765743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1765746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1765749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765778 */     // MIs[0] policy
     /* 1765778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765788 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1765791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765812 */     // GIR_Coverage, 11578,
     /* 1765812 */     GIR_EraseRootFromParent_Done,
     /* 1765813 */   // Label 24053: @1765813
     /* 1765813 */   GIM_Try, /*On fail goto*//*Label 24054*/ GIMT_Encode4(1765899), // Rule ID 11579 //
     /* 1765818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1765829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1765832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1765835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765864 */     // MIs[0] policy
     /* 1765864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765874 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1765877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765898 */     // GIR_Coverage, 11579,
     /* 1765898 */     GIR_EraseRootFromParent_Done,
     /* 1765899 */   // Label 24054: @1765899
     /* 1765899 */   GIM_Try, /*On fail goto*//*Label 24055*/ GIMT_Encode4(1765985), // Rule ID 11582 //
     /* 1765904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1765915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1765918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1765921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1765924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1765927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1765934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765950 */     // MIs[0] policy
     /* 1765950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765960 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1765963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765984 */     // GIR_Coverage, 11582,
     /* 1765984 */     GIR_EraseRootFromParent_Done,
     /* 1765985 */   // Label 24055: @1765985
     /* 1765985 */   GIM_Try, /*On fail goto*//*Label 24056*/ GIMT_Encode4(1766071), // Rule ID 11583 //
     /* 1765990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1766010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766036 */     // MIs[0] policy
     /* 1766036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766046 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1766049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766070 */     // GIR_Coverage, 11583,
     /* 1766070 */     GIR_EraseRootFromParent_Done,
     /* 1766071 */   // Label 24056: @1766071
     /* 1766071 */   GIM_Try, /*On fail goto*//*Label 24057*/ GIMT_Encode4(1766157), // Rule ID 11586 //
     /* 1766076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1766096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766122 */     // MIs[0] policy
     /* 1766122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1766135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766156 */     // GIR_Coverage, 11586,
     /* 1766156 */     GIR_EraseRootFromParent_Done,
     /* 1766157 */   // Label 24057: @1766157
     /* 1766157 */   GIM_Try, /*On fail goto*//*Label 24058*/ GIMT_Encode4(1766243), // Rule ID 11587 //
     /* 1766162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1766182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766208 */     // MIs[0] policy
     /* 1766208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1766221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766242 */     // GIR_Coverage, 11587,
     /* 1766242 */     GIR_EraseRootFromParent_Done,
     /* 1766243 */   // Label 24058: @1766243
     /* 1766243 */   GIM_Try, /*On fail goto*//*Label 24059*/ GIMT_Encode4(1766329), // Rule ID 11590 //
     /* 1766248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1766268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766294 */     // MIs[0] policy
     /* 1766294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1766307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766328 */     // GIR_Coverage, 11590,
     /* 1766328 */     GIR_EraseRootFromParent_Done,
     /* 1766329 */   // Label 24059: @1766329
     /* 1766329 */   GIM_Try, /*On fail goto*//*Label 24060*/ GIMT_Encode4(1766415), // Rule ID 11591 //
     /* 1766334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1766354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766380 */     // MIs[0] policy
     /* 1766380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766390 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1766393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766414 */     // GIR_Coverage, 11591,
     /* 1766414 */     GIR_EraseRootFromParent_Done,
     /* 1766415 */   // Label 24060: @1766415
     /* 1766415 */   GIM_Try, /*On fail goto*//*Label 24061*/ GIMT_Encode4(1766501), // Rule ID 11594 //
     /* 1766420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1766440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766466 */     // MIs[0] policy
     /* 1766466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1766479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766500 */     // GIR_Coverage, 11594,
     /* 1766500 */     GIR_EraseRootFromParent_Done,
     /* 1766501 */   // Label 24061: @1766501
     /* 1766501 */   GIM_Try, /*On fail goto*//*Label 24062*/ GIMT_Encode4(1766587), // Rule ID 11595 //
     /* 1766506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1766526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766552 */     // MIs[0] policy
     /* 1766552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766562 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1766565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766586 */     // GIR_Coverage, 11595,
     /* 1766586 */     GIR_EraseRootFromParent_Done,
     /* 1766587 */   // Label 24062: @1766587
     /* 1766587 */   GIM_Try, /*On fail goto*//*Label 24063*/ GIMT_Encode4(1766673), // Rule ID 11598 //
     /* 1766592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766638 */     // MIs[0] policy
     /* 1766638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766648 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1766651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766672 */     // GIR_Coverage, 11598,
     /* 1766672 */     GIR_EraseRootFromParent_Done,
     /* 1766673 */   // Label 24063: @1766673
     /* 1766673 */   GIM_Try, /*On fail goto*//*Label 24064*/ GIMT_Encode4(1766759), // Rule ID 11599 //
     /* 1766678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766724 */     // MIs[0] policy
     /* 1766724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766734 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1766737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766758 */     // GIR_Coverage, 11599,
     /* 1766758 */     GIR_EraseRootFromParent_Done,
     /* 1766759 */   // Label 24064: @1766759
     /* 1766759 */   GIM_Try, /*On fail goto*//*Label 24065*/ GIMT_Encode4(1766845), // Rule ID 11602 //
     /* 1766764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766810 */     // MIs[0] policy
     /* 1766810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766820 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1766823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766844 */     // GIR_Coverage, 11602,
     /* 1766844 */     GIR_EraseRootFromParent_Done,
     /* 1766845 */   // Label 24065: @1766845
     /* 1766845 */   GIM_Try, /*On fail goto*//*Label 24066*/ GIMT_Encode4(1766931), // Rule ID 11603 //
     /* 1766850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766896 */     // MIs[0] policy
     /* 1766896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1766909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766930 */     // GIR_Coverage, 11603,
     /* 1766930 */     GIR_EraseRootFromParent_Done,
     /* 1766931 */   // Label 24066: @1766931
     /* 1766931 */   GIM_Try, /*On fail goto*//*Label 24067*/ GIMT_Encode4(1767017), // Rule ID 11606 //
     /* 1766936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766982 */     // MIs[0] policy
     /* 1766982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766992 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1766995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767016 */     // GIR_Coverage, 11606,
     /* 1767016 */     GIR_EraseRootFromParent_Done,
     /* 1767017 */   // Label 24067: @1767017
     /* 1767017 */   GIM_Try, /*On fail goto*//*Label 24068*/ GIMT_Encode4(1767103), // Rule ID 11607 //
     /* 1767022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1767030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767068 */     // MIs[0] policy
     /* 1767068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767078 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1767081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767102 */     // GIR_Coverage, 11607,
     /* 1767102 */     GIR_EraseRootFromParent_Done,
     /* 1767103 */   // Label 24068: @1767103
     /* 1767103 */   GIM_Try, /*On fail goto*//*Label 24069*/ GIMT_Encode4(1767189), // Rule ID 11610 //
     /* 1767108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1767116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767154 */     // MIs[0] policy
     /* 1767154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767164 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1767167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767188 */     // GIR_Coverage, 11610,
     /* 1767188 */     GIR_EraseRootFromParent_Done,
     /* 1767189 */   // Label 24069: @1767189
     /* 1767189 */   GIM_Try, /*On fail goto*//*Label 24070*/ GIMT_Encode4(1767275), // Rule ID 11611 //
     /* 1767194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1767202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767240 */     // MIs[0] policy
     /* 1767240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767250 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1767253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767274 */     // GIR_Coverage, 11611,
     /* 1767274 */     GIR_EraseRootFromParent_Done,
     /* 1767275 */   // Label 24070: @1767275
     /* 1767275 */   GIM_Try, /*On fail goto*//*Label 24071*/ GIMT_Encode4(1767361), // Rule ID 11614 //
     /* 1767280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1767291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1767294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1767297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1767300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767326 */     // MIs[0] policy
     /* 1767326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1767339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767360 */     // GIR_Coverage, 11614,
     /* 1767360 */     GIR_EraseRootFromParent_Done,
     /* 1767361 */   // Label 24071: @1767361
     /* 1767361 */   GIM_Try, /*On fail goto*//*Label 24072*/ GIMT_Encode4(1767447), // Rule ID 11615 //
     /* 1767366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1767377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1767380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1767383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1767386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767412 */     // MIs[0] policy
     /* 1767412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767422 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1767425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767446 */     // GIR_Coverage, 11615,
     /* 1767446 */     GIR_EraseRootFromParent_Done,
     /* 1767447 */   // Label 24072: @1767447
     /* 1767447 */   GIM_Try, /*On fail goto*//*Label 24073*/ GIMT_Encode4(1767533), // Rule ID 11618 //
     /* 1767452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1767463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1767466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1767469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1767472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767498 */     // MIs[0] policy
     /* 1767498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1767511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767532 */     // GIR_Coverage, 11618,
     /* 1767532 */     GIR_EraseRootFromParent_Done,
     /* 1767533 */   // Label 24073: @1767533
     /* 1767533 */   GIM_Try, /*On fail goto*//*Label 24074*/ GIMT_Encode4(1767619), // Rule ID 11619 //
     /* 1767538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1767549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1767552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1767555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1767558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767584 */     // MIs[0] policy
     /* 1767584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1767597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767618 */     // GIR_Coverage, 11619,
     /* 1767618 */     GIR_EraseRootFromParent_Done,
     /* 1767619 */   // Label 24074: @1767619
     /* 1767619 */   GIM_Try, /*On fail goto*//*Label 24075*/ GIMT_Encode4(1767705), // Rule ID 11622 //
     /* 1767624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1767644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767670 */     // MIs[0] policy
     /* 1767670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767680 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1767683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767704 */     // GIR_Coverage, 11622,
     /* 1767704 */     GIR_EraseRootFromParent_Done,
     /* 1767705 */   // Label 24075: @1767705
     /* 1767705 */   GIM_Try, /*On fail goto*//*Label 24076*/ GIMT_Encode4(1767791), // Rule ID 11623 //
     /* 1767710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1767730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767756 */     // MIs[0] policy
     /* 1767756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767766 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1767769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767790 */     // GIR_Coverage, 11623,
     /* 1767790 */     GIR_EraseRootFromParent_Done,
     /* 1767791 */   // Label 24076: @1767791
     /* 1767791 */   GIM_Try, /*On fail goto*//*Label 24077*/ GIMT_Encode4(1767877), // Rule ID 11626 //
     /* 1767796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1767816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767842 */     // MIs[0] policy
     /* 1767842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767852 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1767855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767876 */     // GIR_Coverage, 11626,
     /* 1767876 */     GIR_EraseRootFromParent_Done,
     /* 1767877 */   // Label 24077: @1767877
     /* 1767877 */   GIM_Try, /*On fail goto*//*Label 24078*/ GIMT_Encode4(1767963), // Rule ID 11627 //
     /* 1767882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1767902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767928 */     // MIs[0] policy
     /* 1767928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767938 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1767941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767962 */     // GIR_Coverage, 11627,
     /* 1767962 */     GIR_EraseRootFromParent_Done,
     /* 1767963 */   // Label 24078: @1767963
     /* 1767963 */   GIM_Try, /*On fail goto*//*Label 24079*/ GIMT_Encode4(1768049), // Rule ID 11630 //
     /* 1767968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1767979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1767982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1767985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768014 */     // MIs[0] policy
     /* 1768014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1768027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768048 */     // GIR_Coverage, 11630,
     /* 1768048 */     GIR_EraseRootFromParent_Done,
     /* 1768049 */   // Label 24079: @1768049
     /* 1768049 */   GIM_Try, /*On fail goto*//*Label 24080*/ GIMT_Encode4(1768135), // Rule ID 11631 //
     /* 1768054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768100 */     // MIs[0] policy
     /* 1768100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768110 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1768113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768134 */     // GIR_Coverage, 11631,
     /* 1768134 */     GIR_EraseRootFromParent_Done,
     /* 1768135 */   // Label 24080: @1768135
     /* 1768135 */   GIM_Try, /*On fail goto*//*Label 24081*/ GIMT_Encode4(1768221), // Rule ID 11634 //
     /* 1768140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1768151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1768154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1768157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768186 */     // MIs[0] policy
     /* 1768186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1768199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768220 */     // GIR_Coverage, 11634,
     /* 1768220 */     GIR_EraseRootFromParent_Done,
     /* 1768221 */   // Label 24081: @1768221
     /* 1768221 */   GIM_Try, /*On fail goto*//*Label 24082*/ GIMT_Encode4(1768307), // Rule ID 11635 //
     /* 1768226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1768237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1768240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1768243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768272 */     // MIs[0] policy
     /* 1768272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1768285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768306 */     // GIR_Coverage, 11635,
     /* 1768306 */     GIR_EraseRootFromParent_Done,
     /* 1768307 */   // Label 24082: @1768307
     /* 1768307 */   GIM_Try, /*On fail goto*//*Label 24083*/ GIMT_Encode4(1768393), // Rule ID 11638 //
     /* 1768312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1768323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1768326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1768329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768358 */     // MIs[0] policy
     /* 1768358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768368 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1768371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768392 */     // GIR_Coverage, 11638,
     /* 1768392 */     GIR_EraseRootFromParent_Done,
     /* 1768393 */   // Label 24083: @1768393
     /* 1768393 */   GIM_Try, /*On fail goto*//*Label 24084*/ GIMT_Encode4(1768479), // Rule ID 11639 //
     /* 1768398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1768409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1768412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1768415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768444 */     // MIs[0] policy
     /* 1768444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768454 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1768457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768478 */     // GIR_Coverage, 11639,
     /* 1768478 */     GIR_EraseRootFromParent_Done,
     /* 1768479 */   // Label 24084: @1768479
     /* 1768479 */   GIM_Try, /*On fail goto*//*Label 24085*/ GIMT_Encode4(1768565), // Rule ID 11642 //
     /* 1768484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1768495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1768498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1768501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768530 */     // MIs[0] policy
     /* 1768530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768540 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1768543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768564 */     // GIR_Coverage, 11642,
     /* 1768564 */     GIR_EraseRootFromParent_Done,
     /* 1768565 */   // Label 24085: @1768565
     /* 1768565 */   GIM_Try, /*On fail goto*//*Label 24086*/ GIMT_Encode4(1768651), // Rule ID 11643 //
     /* 1768570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1768581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1768584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1768587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768616 */     // MIs[0] policy
     /* 1768616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768626 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1768629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768650 */     // GIR_Coverage, 11643,
     /* 1768650 */     GIR_EraseRootFromParent_Done,
     /* 1768651 */   // Label 24086: @1768651
     /* 1768651 */   GIM_Try, /*On fail goto*//*Label 24087*/ GIMT_Encode4(1768737), // Rule ID 11646 //
     /* 1768656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1768676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768702 */     // MIs[0] policy
     /* 1768702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768712 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1768715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768736 */     // GIR_Coverage, 11646,
     /* 1768736 */     GIR_EraseRootFromParent_Done,
     /* 1768737 */   // Label 24087: @1768737
     /* 1768737 */   GIM_Try, /*On fail goto*//*Label 24088*/ GIMT_Encode4(1768823), // Rule ID 11647 //
     /* 1768742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1768762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768788 */     // MIs[0] policy
     /* 1768788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1768801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768822 */     // GIR_Coverage, 11647,
     /* 1768822 */     GIR_EraseRootFromParent_Done,
     /* 1768823 */   // Label 24088: @1768823
     /* 1768823 */   GIM_Try, /*On fail goto*//*Label 24089*/ GIMT_Encode4(1768909), // Rule ID 11650 //
     /* 1768828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1768839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1768842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1768845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1768848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768874 */     // MIs[0] policy
     /* 1768874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1768887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768908 */     // GIR_Coverage, 11650,
     /* 1768908 */     GIR_EraseRootFromParent_Done,
     /* 1768909 */   // Label 24089: @1768909
     /* 1768909 */   GIM_Try, /*On fail goto*//*Label 24090*/ GIMT_Encode4(1768995), // Rule ID 11651 //
     /* 1768914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1768925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1768928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1768931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1768934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768960 */     // MIs[0] policy
     /* 1768960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768970 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1768973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768994 */     // GIR_Coverage, 11651,
     /* 1768994 */     GIR_EraseRootFromParent_Done,
     /* 1768995 */   // Label 24090: @1768995
     /* 1768995 */   GIM_Try, /*On fail goto*//*Label 24091*/ GIMT_Encode4(1769081), // Rule ID 11654 //
     /* 1769000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1769020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769046 */     // MIs[0] policy
     /* 1769046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769056 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1769059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769080 */     // GIR_Coverage, 11654,
     /* 1769080 */     GIR_EraseRootFromParent_Done,
     /* 1769081 */   // Label 24091: @1769081
     /* 1769081 */   GIM_Try, /*On fail goto*//*Label 24092*/ GIMT_Encode4(1769167), // Rule ID 11655 //
     /* 1769086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1769106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769132 */     // MIs[0] policy
     /* 1769132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769142 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1769145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769166 */     // GIR_Coverage, 11655,
     /* 1769166 */     GIR_EraseRootFromParent_Done,
     /* 1769167 */   // Label 24092: @1769167
     /* 1769167 */   GIM_Try, /*On fail goto*//*Label 24093*/ GIMT_Encode4(1769253), // Rule ID 11658 //
     /* 1769172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1769192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769218 */     // MIs[0] policy
     /* 1769218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769228 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1769231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769252 */     // GIR_Coverage, 11658,
     /* 1769252 */     GIR_EraseRootFromParent_Done,
     /* 1769253 */   // Label 24093: @1769253
     /* 1769253 */   GIM_Try, /*On fail goto*//*Label 24094*/ GIMT_Encode4(1769339), // Rule ID 11659 //
     /* 1769258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1769278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769304 */     // MIs[0] policy
     /* 1769304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769314 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1769317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769338 */     // GIR_Coverage, 11659,
     /* 1769338 */     GIR_EraseRootFromParent_Done,
     /* 1769339 */   // Label 24094: @1769339
     /* 1769339 */   GIM_Try, /*On fail goto*//*Label 24095*/ GIMT_Encode4(1769425), // Rule ID 11662 //
     /* 1769344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1769355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1769358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1769361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1769367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769390 */     // MIs[0] policy
     /* 1769390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769400 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1769403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769424 */     // GIR_Coverage, 11662,
     /* 1769424 */     GIR_EraseRootFromParent_Done,
     /* 1769425 */   // Label 24095: @1769425
     /* 1769425 */   GIM_Try, /*On fail goto*//*Label 24096*/ GIMT_Encode4(1769511), // Rule ID 11663 //
     /* 1769430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1769441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1769444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1769447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1769453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769476 */     // MIs[0] policy
     /* 1769476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769486 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1769489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769510 */     // GIR_Coverage, 11663,
     /* 1769510 */     GIR_EraseRootFromParent_Done,
     /* 1769511 */   // Label 24096: @1769511
     /* 1769511 */   GIM_Try, /*On fail goto*//*Label 24097*/ GIMT_Encode4(1769597), // Rule ID 11666 //
     /* 1769516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1769527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1769530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1769533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769562 */     // MIs[0] policy
     /* 1769562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769572 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1769575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769596 */     // GIR_Coverage, 11666,
     /* 1769596 */     GIR_EraseRootFromParent_Done,
     /* 1769597 */   // Label 24097: @1769597
     /* 1769597 */   GIM_Try, /*On fail goto*//*Label 24098*/ GIMT_Encode4(1769683), // Rule ID 11667 //
     /* 1769602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1769613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1769616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1769619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769648 */     // MIs[0] policy
     /* 1769648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769658 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1769661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769682 */     // GIR_Coverage, 11667,
     /* 1769682 */     GIR_EraseRootFromParent_Done,
     /* 1769683 */   // Label 24098: @1769683
     /* 1769683 */   GIM_Try, /*On fail goto*//*Label 24099*/ GIMT_Encode4(1769769), // Rule ID 11670 //
     /* 1769688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769734 */     // MIs[0] policy
     /* 1769734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769744 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1769747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769768 */     // GIR_Coverage, 11670,
     /* 1769768 */     GIR_EraseRootFromParent_Done,
     /* 1769769 */   // Label 24099: @1769769
     /* 1769769 */   GIM_Try, /*On fail goto*//*Label 24100*/ GIMT_Encode4(1769855), // Rule ID 11671 //
     /* 1769774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769820 */     // MIs[0] policy
     /* 1769820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769830 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1769833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769854 */     // GIR_Coverage, 11671,
     /* 1769854 */     GIR_EraseRootFromParent_Done,
     /* 1769855 */   // Label 24100: @1769855
     /* 1769855 */   GIM_Try, /*On fail goto*//*Label 24101*/ GIMT_Encode4(1769941), // Rule ID 11674 //
     /* 1769860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769906 */     // MIs[0] policy
     /* 1769906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769916 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1769919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769940 */     // GIR_Coverage, 11674,
     /* 1769940 */     GIR_EraseRootFromParent_Done,
     /* 1769941 */   // Label 24101: @1769941
     /* 1769941 */   GIM_Try, /*On fail goto*//*Label 24102*/ GIMT_Encode4(1770027), // Rule ID 11675 //
     /* 1769946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769992 */     // MIs[0] policy
     /* 1769992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770002 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1770005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770026 */     // GIR_Coverage, 11675,
     /* 1770026 */     GIR_EraseRootFromParent_Done,
     /* 1770027 */   // Label 24102: @1770027
     /* 1770027 */   GIM_Try, /*On fail goto*//*Label 24103*/ GIMT_Encode4(1770113), // Rule ID 11678 //
     /* 1770032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1770043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1770046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1770049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1770052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770078 */     // MIs[0] policy
     /* 1770078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770088 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1770091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770112 */     // GIR_Coverage, 11678,
     /* 1770112 */     GIR_EraseRootFromParent_Done,
     /* 1770113 */   // Label 24103: @1770113
     /* 1770113 */   GIM_Try, /*On fail goto*//*Label 24104*/ GIMT_Encode4(1770199), // Rule ID 11679 //
     /* 1770118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1770129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1770132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1770135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1770138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770164 */     // MIs[0] policy
     /* 1770164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770174 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1770177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770198 */     // GIR_Coverage, 11679,
     /* 1770198 */     GIR_EraseRootFromParent_Done,
     /* 1770199 */   // Label 24104: @1770199
     /* 1770199 */   GIM_Try, /*On fail goto*//*Label 24105*/ GIMT_Encode4(1770285), // Rule ID 11682 //
     /* 1770204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1770215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1770218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1770221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1770224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770250 */     // MIs[0] policy
     /* 1770250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770260 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1770263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770284 */     // GIR_Coverage, 11682,
     /* 1770284 */     GIR_EraseRootFromParent_Done,
     /* 1770285 */   // Label 24105: @1770285
     /* 1770285 */   GIM_Try, /*On fail goto*//*Label 24106*/ GIMT_Encode4(1770371), // Rule ID 11683 //
     /* 1770290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1770301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1770304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1770307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1770310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770336 */     // MIs[0] policy
     /* 1770336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1770349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770370 */     // GIR_Coverage, 11683,
     /* 1770370 */     GIR_EraseRootFromParent_Done,
     /* 1770371 */   // Label 24106: @1770371
     /* 1770371 */   GIM_Try, /*On fail goto*//*Label 24107*/ GIMT_Encode4(1770457), // Rule ID 11686 //
     /* 1770376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1770387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1770390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1770393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1770396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770422 */     // MIs[0] policy
     /* 1770422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770432 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1770435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770456 */     // GIR_Coverage, 11686,
     /* 1770456 */     GIR_EraseRootFromParent_Done,
     /* 1770457 */   // Label 24107: @1770457
     /* 1770457 */   GIM_Try, /*On fail goto*//*Label 24108*/ GIMT_Encode4(1770543), // Rule ID 11687 //
     /* 1770462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1770473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1770476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1770479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1770482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770508 */     // MIs[0] policy
     /* 1770508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1770521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770542 */     // GIR_Coverage, 11687,
     /* 1770542 */     GIR_EraseRootFromParent_Done,
     /* 1770543 */   // Label 24108: @1770543
     /* 1770543 */   GIM_Try, /*On fail goto*//*Label 24109*/ GIMT_Encode4(1770629), // Rule ID 11690 //
     /* 1770548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1770559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1770562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1770565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1770568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770594 */     // MIs[0] policy
     /* 1770594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770604 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1770607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770628 */     // GIR_Coverage, 11690,
     /* 1770628 */     GIR_EraseRootFromParent_Done,
     /* 1770629 */   // Label 24109: @1770629
     /* 1770629 */   GIM_Try, /*On fail goto*//*Label 24110*/ GIMT_Encode4(1770715), // Rule ID 11691 //
     /* 1770634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1770645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1770648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1770651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1770654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770680 */     // MIs[0] policy
     /* 1770680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770690 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1770693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770714 */     // GIR_Coverage, 11691,
     /* 1770714 */     GIR_EraseRootFromParent_Done,
     /* 1770715 */   // Label 24110: @1770715
     /* 1770715 */   GIM_Try, /*On fail goto*//*Label 24111*/ GIMT_Encode4(1770801), // Rule ID 11694 //
     /* 1770720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1770731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1770734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1770737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1770740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770766 */     // MIs[0] policy
     /* 1770766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770776 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1770779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770800 */     // GIR_Coverage, 11694,
     /* 1770800 */     GIR_EraseRootFromParent_Done,
     /* 1770801 */   // Label 24111: @1770801
     /* 1770801 */   GIM_Try, /*On fail goto*//*Label 24112*/ GIMT_Encode4(1770887), // Rule ID 11695 //
     /* 1770806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1770817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1770820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1770823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1770826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770852 */     // MIs[0] policy
     /* 1770852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770862 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1770865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770886 */     // GIR_Coverage, 11695,
     /* 1770886 */     GIR_EraseRootFromParent_Done,
     /* 1770887 */   // Label 24112: @1770887
     /* 1770887 */   GIM_Try, /*On fail goto*//*Label 24113*/ GIMT_Encode4(1770973), // Rule ID 11698 //
     /* 1770892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1770903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1770906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1770909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1770912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770938 */     // MIs[0] policy
     /* 1770938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770948 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1770951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770972 */     // GIR_Coverage, 11698,
     /* 1770972 */     GIR_EraseRootFromParent_Done,
     /* 1770973 */   // Label 24113: @1770973
     /* 1770973 */   GIM_Try, /*On fail goto*//*Label 24114*/ GIMT_Encode4(1771059), // Rule ID 11699 //
     /* 1770978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1770989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1770992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1770995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1770998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771024 */     // MIs[0] policy
     /* 1771024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1771037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771058 */     // GIR_Coverage, 11699,
     /* 1771058 */     GIR_EraseRootFromParent_Done,
     /* 1771059 */   // Label 24114: @1771059
     /* 1771059 */   GIM_Try, /*On fail goto*//*Label 24115*/ GIMT_Encode4(1771145), // Rule ID 11702 //
     /* 1771064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1771075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1771078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1771081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1771084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771110 */     // MIs[0] policy
     /* 1771110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771120 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1771123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771144 */     // GIR_Coverage, 11702,
     /* 1771144 */     GIR_EraseRootFromParent_Done,
     /* 1771145 */   // Label 24115: @1771145
     /* 1771145 */   GIM_Try, /*On fail goto*//*Label 24116*/ GIMT_Encode4(1771231), // Rule ID 11703 //
     /* 1771150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1771161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1771164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1771167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1771170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771196 */     // MIs[0] policy
     /* 1771196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771206 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1771209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771230 */     // GIR_Coverage, 11703,
     /* 1771230 */     GIR_EraseRootFromParent_Done,
     /* 1771231 */   // Label 24116: @1771231
     /* 1771231 */   GIM_Try, /*On fail goto*//*Label 24117*/ GIMT_Encode4(1771317), // Rule ID 11706 //
     /* 1771236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1771247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1771250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1771253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1771256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771282 */     // MIs[0] policy
     /* 1771282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771292 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1771295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771316 */     // GIR_Coverage, 11706,
     /* 1771316 */     GIR_EraseRootFromParent_Done,
     /* 1771317 */   // Label 24117: @1771317
     /* 1771317 */   GIM_Try, /*On fail goto*//*Label 24118*/ GIMT_Encode4(1771403), // Rule ID 11707 //
     /* 1771322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1771333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1771336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1771339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1771342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771368 */     // MIs[0] policy
     /* 1771368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771378 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1771381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771402 */     // GIR_Coverage, 11707,
     /* 1771402 */     GIR_EraseRootFromParent_Done,
     /* 1771403 */   // Label 24118: @1771403
     /* 1771403 */   GIM_Try, /*On fail goto*//*Label 24119*/ GIMT_Encode4(1771489), // Rule ID 11710 //
     /* 1771408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1771419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1771422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1771425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1771428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771454 */     // MIs[0] policy
     /* 1771454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1771467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771488 */     // GIR_Coverage, 11710,
     /* 1771488 */     GIR_EraseRootFromParent_Done,
     /* 1771489 */   // Label 24119: @1771489
     /* 1771489 */   GIM_Try, /*On fail goto*//*Label 24120*/ GIMT_Encode4(1771575), // Rule ID 11711 //
     /* 1771494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1771505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1771508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1771511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1771514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771540 */     // MIs[0] policy
     /* 1771540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1771553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771574 */     // GIR_Coverage, 11711,
     /* 1771574 */     GIR_EraseRootFromParent_Done,
     /* 1771575 */   // Label 24120: @1771575
     /* 1771575 */   GIM_Try, /*On fail goto*//*Label 24121*/ GIMT_Encode4(1771661), // Rule ID 11714 //
     /* 1771580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1771583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1771591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1771594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1771597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1771600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771626 */     // MIs[0] policy
     /* 1771626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1771639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771660 */     // GIR_Coverage, 11714,
     /* 1771660 */     GIR_EraseRootFromParent_Done,
     /* 1771661 */   // Label 24121: @1771661
     /* 1771661 */   GIM_Try, /*On fail goto*//*Label 24122*/ GIMT_Encode4(1771747), // Rule ID 11715 //
     /* 1771666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1771669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1771677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1771680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1771683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1771686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771712 */     // MIs[0] policy
     /* 1771712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771722 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1771725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771746 */     // GIR_Coverage, 11715,
     /* 1771746 */     GIR_EraseRootFromParent_Done,
     /* 1771747 */   // Label 24122: @1771747
     /* 1771747 */   GIM_Try, /*On fail goto*//*Label 24123*/ GIMT_Encode4(1771833), // Rule ID 11718 //
     /* 1771752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1771763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1771766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1771769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1771772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1771775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771798 */     // MIs[0] policy
     /* 1771798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771808 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1771811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771832 */     // GIR_Coverage, 11718,
     /* 1771832 */     GIR_EraseRootFromParent_Done,
     /* 1771833 */   // Label 24123: @1771833
     /* 1771833 */   GIM_Try, /*On fail goto*//*Label 24124*/ GIMT_Encode4(1771919), // Rule ID 11719 //
     /* 1771838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1771849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1771852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1771855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1771858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1771861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771884 */     // MIs[0] policy
     /* 1771884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771894 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1771897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771918 */     // GIR_Coverage, 11719,
     /* 1771918 */     GIR_EraseRootFromParent_Done,
     /* 1771919 */   // Label 24124: @1771919
     /* 1771919 */   GIM_Try, /*On fail goto*//*Label 24125*/ GIMT_Encode4(1772005), // Rule ID 11722 //
     /* 1771924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1771935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1771938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1771941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1771944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1771947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1771954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771970 */     // MIs[0] policy
     /* 1771970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771980 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1771983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772004 */     // GIR_Coverage, 11722,
     /* 1772004 */     GIR_EraseRootFromParent_Done,
     /* 1772005 */   // Label 24125: @1772005
     /* 1772005 */   GIM_Try, /*On fail goto*//*Label 24126*/ GIMT_Encode4(1772091), // Rule ID 11723 //
     /* 1772010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1772021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1772024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1772027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1772030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772056 */     // MIs[0] policy
     /* 1772056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772066 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1772069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772090 */     // GIR_Coverage, 11723,
     /* 1772090 */     GIR_EraseRootFromParent_Done,
     /* 1772091 */   // Label 24126: @1772091
     /* 1772091 */   GIM_Try, /*On fail goto*//*Label 24127*/ GIMT_Encode4(1772177), // Rule ID 11726 //
     /* 1772096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1772107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1772110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1772113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1772116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1772119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772142 */     // MIs[0] policy
     /* 1772142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1772155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772176 */     // GIR_Coverage, 11726,
     /* 1772176 */     GIR_EraseRootFromParent_Done,
     /* 1772177 */   // Label 24127: @1772177
     /* 1772177 */   GIM_Try, /*On fail goto*//*Label 24128*/ GIMT_Encode4(1772263), // Rule ID 11727 //
     /* 1772182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1772193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1772196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1772199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1772202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1772205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772228 */     // MIs[0] policy
     /* 1772228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772238 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1772241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772262 */     // GIR_Coverage, 11727,
     /* 1772262 */     GIR_EraseRootFromParent_Done,
     /* 1772263 */   // Label 24128: @1772263
     /* 1772263 */   GIM_Try, /*On fail goto*//*Label 24129*/ GIMT_Encode4(1772349), // Rule ID 11730 //
     /* 1772268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1772279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1772282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1772285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1772288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772314 */     // MIs[0] policy
     /* 1772314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1772327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772348 */     // GIR_Coverage, 11730,
     /* 1772348 */     GIR_EraseRootFromParent_Done,
     /* 1772349 */   // Label 24129: @1772349
     /* 1772349 */   GIM_Try, /*On fail goto*//*Label 24130*/ GIMT_Encode4(1772435), // Rule ID 11731 //
     /* 1772354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1772365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1772368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1772371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1772374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772400 */     // MIs[0] policy
     /* 1772400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772410 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1772413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772434 */     // GIR_Coverage, 11731,
     /* 1772434 */     GIR_EraseRootFromParent_Done,
     /* 1772435 */   // Label 24130: @1772435
     /* 1772435 */   GIM_Try, /*On fail goto*//*Label 24131*/ GIMT_Encode4(1772521), // Rule ID 11734 //
     /* 1772440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1772451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1772454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1772457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1772460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772486 */     // MIs[0] policy
     /* 1772486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1772499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772520 */     // GIR_Coverage, 11734,
     /* 1772520 */     GIR_EraseRootFromParent_Done,
     /* 1772521 */   // Label 24131: @1772521
     /* 1772521 */   GIM_Try, /*On fail goto*//*Label 24132*/ GIMT_Encode4(1772607), // Rule ID 11735 //
     /* 1772526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1772537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1772540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1772543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1772546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772572 */     // MIs[0] policy
     /* 1772572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772582 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1772585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772606 */     // GIR_Coverage, 11735,
     /* 1772606 */     GIR_EraseRootFromParent_Done,
     /* 1772607 */   // Label 24132: @1772607
     /* 1772607 */   GIM_Try, /*On fail goto*//*Label 24133*/ GIMT_Encode4(1772693), // Rule ID 11738 //
     /* 1772612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1772623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1772626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1772629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1772632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772658 */     // MIs[0] policy
     /* 1772658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772668 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1772671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772692 */     // GIR_Coverage, 11738,
     /* 1772692 */     GIR_EraseRootFromParent_Done,
     /* 1772693 */   // Label 24133: @1772693
     /* 1772693 */   GIM_Try, /*On fail goto*//*Label 24134*/ GIMT_Encode4(1772779), // Rule ID 11739 //
     /* 1772698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1772709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1772712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1772715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1772718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772744 */     // MIs[0] policy
     /* 1772744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772754 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1772757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772778 */     // GIR_Coverage, 11739,
     /* 1772778 */     GIR_EraseRootFromParent_Done,
     /* 1772779 */   // Label 24134: @1772779
     /* 1772779 */   GIM_Try, /*On fail goto*//*Label 24135*/ GIMT_Encode4(1772865), // Rule ID 11742 //
     /* 1772784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1772795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1772798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1772801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1772804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772830 */     // MIs[0] policy
     /* 1772830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1772843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772864 */     // GIR_Coverage, 11742,
     /* 1772864 */     GIR_EraseRootFromParent_Done,
     /* 1772865 */   // Label 24135: @1772865
     /* 1772865 */   GIM_Try, /*On fail goto*//*Label 24136*/ GIMT_Encode4(1772951), // Rule ID 11743 //
     /* 1772870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1772881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1772884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1772887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1772890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772916 */     // MIs[0] policy
     /* 1772916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1772929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772950 */     // GIR_Coverage, 11743,
     /* 1772950 */     GIR_EraseRootFromParent_Done,
     /* 1772951 */   // Label 24136: @1772951
     /* 1772951 */   GIM_Try, /*On fail goto*//*Label 24137*/ GIMT_Encode4(1773037), // Rule ID 11746 //
     /* 1772956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1772967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1772970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1772973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1772976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773002 */     // MIs[0] policy
     /* 1773002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773012 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1773015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773036 */     // GIR_Coverage, 11746,
     /* 1773036 */     GIR_EraseRootFromParent_Done,
     /* 1773037 */   // Label 24137: @1773037
     /* 1773037 */   GIM_Try, /*On fail goto*//*Label 24138*/ GIMT_Encode4(1773123), // Rule ID 11747 //
     /* 1773042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1773053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1773056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1773059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1773062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773088 */     // MIs[0] policy
     /* 1773088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773098 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1773101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773122 */     // GIR_Coverage, 11747,
     /* 1773122 */     GIR_EraseRootFromParent_Done,
     /* 1773123 */   // Label 24138: @1773123
     /* 1773123 */   GIM_Try, /*On fail goto*//*Label 24139*/ GIMT_Encode4(1773209), // Rule ID 11750 //
     /* 1773128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1773139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1773142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1773145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1773148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1773151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773174 */     // MIs[0] policy
     /* 1773174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773184 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1773187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773208 */     // GIR_Coverage, 11750,
     /* 1773208 */     GIR_EraseRootFromParent_Done,
     /* 1773209 */   // Label 24139: @1773209
     /* 1773209 */   GIM_Try, /*On fail goto*//*Label 24140*/ GIMT_Encode4(1773295), // Rule ID 11751 //
     /* 1773214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1773225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1773228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1773231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1773234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1773237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773260 */     // MIs[0] policy
     /* 1773260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773270 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1773273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773294 */     // GIR_Coverage, 11751,
     /* 1773294 */     GIR_EraseRootFromParent_Done,
     /* 1773295 */   // Label 24140: @1773295
     /* 1773295 */   GIM_Try, /*On fail goto*//*Label 24141*/ GIMT_Encode4(1773381), // Rule ID 11754 //
     /* 1773300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1773303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1773311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1773314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1773317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1773320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1773323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773346 */     // MIs[0] policy
     /* 1773346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773356 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1773359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773380 */     // GIR_Coverage, 11754,
     /* 1773380 */     GIR_EraseRootFromParent_Done,
     /* 1773381 */   // Label 24141: @1773381
     /* 1773381 */   GIM_Try, /*On fail goto*//*Label 24142*/ GIMT_Encode4(1773467), // Rule ID 11755 //
     /* 1773386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1773389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1773397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1773400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1773403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1773406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1773409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773432 */     // MIs[0] policy
     /* 1773432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773442 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1773445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773466 */     // GIR_Coverage, 11755,
     /* 1773466 */     GIR_EraseRootFromParent_Done,
     /* 1773467 */   // Label 24142: @1773467
     /* 1773467 */   GIM_Try, /*On fail goto*//*Label 24143*/ GIMT_Encode4(1773553), // Rule ID 11758 //
     /* 1773472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1773475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1773483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1773486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1773489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1773492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773518 */     // MIs[0] policy
     /* 1773518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773528 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1773531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773552 */     // GIR_Coverage, 11758,
     /* 1773552 */     GIR_EraseRootFromParent_Done,
     /* 1773553 */   // Label 24143: @1773553
     /* 1773553 */   GIM_Try, /*On fail goto*//*Label 24144*/ GIMT_Encode4(1773639), // Rule ID 11759 //
     /* 1773558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1773561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1773569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1773572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1773575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1773578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773604 */     // MIs[0] policy
     /* 1773604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773614 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1773617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773638 */     // GIR_Coverage, 11759,
     /* 1773638 */     GIR_EraseRootFromParent_Done,
     /* 1773639 */   // Label 24144: @1773639
     /* 1773639 */   GIM_Try, /*On fail goto*//*Label 24145*/ GIMT_Encode4(1773725), // Rule ID 11762 //
     /* 1773644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1773647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1773655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1773658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1773661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1773664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773690 */     // MIs[0] policy
     /* 1773690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773700 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1773703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773724 */     // GIR_Coverage, 11762,
     /* 1773724 */     GIR_EraseRootFromParent_Done,
     /* 1773725 */   // Label 24145: @1773725
     /* 1773725 */   GIM_Try, /*On fail goto*//*Label 24146*/ GIMT_Encode4(1773811), // Rule ID 11763 //
     /* 1773730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1773733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1773741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1773744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1773747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1773750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773776 */     // MIs[0] policy
     /* 1773776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1773789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773810 */     // GIR_Coverage, 11763,
     /* 1773810 */     GIR_EraseRootFromParent_Done,
     /* 1773811 */   // Label 24146: @1773811
     /* 1773811 */   GIM_Try, /*On fail goto*//*Label 24147*/ GIMT_Encode4(1773897), // Rule ID 11766 //
     /* 1773816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1773827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1773830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1773833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773862 */     // MIs[0] policy
     /* 1773862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773872 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1773875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773896 */     // GIR_Coverage, 11766,
     /* 1773896 */     GIR_EraseRootFromParent_Done,
     /* 1773897 */   // Label 24147: @1773897
     /* 1773897 */   GIM_Try, /*On fail goto*//*Label 24148*/ GIMT_Encode4(1773983), // Rule ID 11767 //
     /* 1773902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1773913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1773916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1773919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773948 */     // MIs[0] policy
     /* 1773948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773958 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1773961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773982 */     // GIR_Coverage, 11767,
     /* 1773982 */     GIR_EraseRootFromParent_Done,
     /* 1773983 */   // Label 24148: @1773983
     /* 1773983 */   GIM_Try, /*On fail goto*//*Label 24149*/ GIMT_Encode4(1774069), // Rule ID 11770 //
     /* 1773988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1773999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1774002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1774005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774034 */     // MIs[0] policy
     /* 1774034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774044 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1774047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774068 */     // GIR_Coverage, 11770,
     /* 1774068 */     GIR_EraseRootFromParent_Done,
     /* 1774069 */   // Label 24149: @1774069
     /* 1774069 */   GIM_Try, /*On fail goto*//*Label 24150*/ GIMT_Encode4(1774155), // Rule ID 11771 //
     /* 1774074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1774085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1774088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1774091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774120 */     // MIs[0] policy
     /* 1774120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774130 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1774133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774154 */     // GIR_Coverage, 11771,
     /* 1774154 */     GIR_EraseRootFromParent_Done,
     /* 1774155 */   // Label 24150: @1774155
     /* 1774155 */   GIM_Try, /*On fail goto*//*Label 24151*/ GIMT_Encode4(1774241), // Rule ID 11774 //
     /* 1774160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1774171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1774174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1774177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774206 */     // MIs[0] policy
     /* 1774206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774216 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1774219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774240 */     // GIR_Coverage, 11774,
     /* 1774240 */     GIR_EraseRootFromParent_Done,
     /* 1774241 */   // Label 24151: @1774241
     /* 1774241 */   GIM_Try, /*On fail goto*//*Label 24152*/ GIMT_Encode4(1774327), // Rule ID 11775 //
     /* 1774246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1774257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1774260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1774263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774292 */     // MIs[0] policy
     /* 1774292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774302 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1774305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774326 */     // GIR_Coverage, 11775,
     /* 1774326 */     GIR_EraseRootFromParent_Done,
     /* 1774327 */   // Label 24152: @1774327
     /* 1774327 */   GIM_Try, /*On fail goto*//*Label 24153*/ GIMT_Encode4(1774413), // Rule ID 11778 //
     /* 1774332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1774343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1774346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1774349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774378 */     // MIs[0] policy
     /* 1774378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1774391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774412 */     // GIR_Coverage, 11778,
     /* 1774412 */     GIR_EraseRootFromParent_Done,
     /* 1774413 */   // Label 24153: @1774413
     /* 1774413 */   GIM_Try, /*On fail goto*//*Label 24154*/ GIMT_Encode4(1774499), // Rule ID 11779 //
     /* 1774418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1774429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1774432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1774435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774464 */     // MIs[0] policy
     /* 1774464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1774477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774498 */     // GIR_Coverage, 11779,
     /* 1774498 */     GIR_EraseRootFromParent_Done,
     /* 1774499 */   // Label 24154: @1774499
     /* 1774499 */   GIM_Try, /*On fail goto*//*Label 24155*/ GIMT_Encode4(1774585), // Rule ID 11782 //
     /* 1774504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1774515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1774518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1774521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774550 */     // MIs[0] policy
     /* 1774550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774560 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1774563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774584 */     // GIR_Coverage, 11782,
     /* 1774584 */     GIR_EraseRootFromParent_Done,
     /* 1774585 */   // Label 24155: @1774585
     /* 1774585 */   GIM_Try, /*On fail goto*//*Label 24156*/ GIMT_Encode4(1774671), // Rule ID 11783 //
     /* 1774590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1774601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1774604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1774607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774636 */     // MIs[0] policy
     /* 1774636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774646 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1774649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774670 */     // GIR_Coverage, 11783,
     /* 1774670 */     GIR_EraseRootFromParent_Done,
     /* 1774671 */   // Label 24156: @1774671
     /* 1774671 */   GIM_Try, /*On fail goto*//*Label 24157*/ GIMT_Encode4(1774757), // Rule ID 11786 //
     /* 1774676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1774687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1774690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1774693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774722 */     // MIs[0] policy
     /* 1774722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1774735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774756 */     // GIR_Coverage, 11786,
     /* 1774756 */     GIR_EraseRootFromParent_Done,
     /* 1774757 */   // Label 24157: @1774757
     /* 1774757 */   GIM_Try, /*On fail goto*//*Label 24158*/ GIMT_Encode4(1774843), // Rule ID 11787 //
     /* 1774762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1774773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1774776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1774779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774808 */     // MIs[0] policy
     /* 1774808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774818 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1774821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774842 */     // GIR_Coverage, 11787,
     /* 1774842 */     GIR_EraseRootFromParent_Done,
     /* 1774843 */   // Label 24158: @1774843
     /* 1774843 */   GIM_Try, /*On fail goto*//*Label 24159*/ GIMT_Encode4(1774929), // Rule ID 11790 //
     /* 1774848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1774859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1774862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1774865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774894 */     // MIs[0] policy
     /* 1774894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774904 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1774907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774928 */     // GIR_Coverage, 11790,
     /* 1774928 */     GIR_EraseRootFromParent_Done,
     /* 1774929 */   // Label 24159: @1774929
     /* 1774929 */   GIM_Try, /*On fail goto*//*Label 24160*/ GIMT_Encode4(1775015), // Rule ID 11791 //
     /* 1774934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1774945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1774948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1774951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774980 */     // MIs[0] policy
     /* 1774980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1774993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775014 */     // GIR_Coverage, 11791,
     /* 1775014 */     GIR_EraseRootFromParent_Done,
     /* 1775015 */   // Label 24160: @1775015
     /* 1775015 */   GIM_Try, /*On fail goto*//*Label 24161*/ GIMT_Encode4(1775101), // Rule ID 11794 //
     /* 1775020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1775031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1775034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1775037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1775043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775066 */     // MIs[0] policy
     /* 1775066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775076 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1775079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775100 */     // GIR_Coverage, 11794,
     /* 1775100 */     GIR_EraseRootFromParent_Done,
     /* 1775101 */   // Label 24161: @1775101
     /* 1775101 */   GIM_Try, /*On fail goto*//*Label 24162*/ GIMT_Encode4(1775187), // Rule ID 11795 //
     /* 1775106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1775117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1775120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1775123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1775129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775152 */     // MIs[0] policy
     /* 1775152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775162 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1775165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775186 */     // GIR_Coverage, 11795,
     /* 1775186 */     GIR_EraseRootFromParent_Done,
     /* 1775187 */   // Label 24162: @1775187
     /* 1775187 */   GIM_Try, /*On fail goto*//*Label 24163*/ GIMT_Encode4(1775273), // Rule ID 11798 //
     /* 1775192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1775203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1775206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1775209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775238 */     // MIs[0] policy
     /* 1775238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775248 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1775251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1775269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775272 */     // GIR_Coverage, 11798,
     /* 1775272 */     GIR_EraseRootFromParent_Done,
     /* 1775273 */   // Label 24163: @1775273
     /* 1775273 */   GIM_Try, /*On fail goto*//*Label 24164*/ GIMT_Encode4(1775359), // Rule ID 11799 //
     /* 1775278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1775289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1775292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1775295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775324 */     // MIs[0] policy
     /* 1775324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1775337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1775355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775358 */     // GIR_Coverage, 11799,
     /* 1775358 */     GIR_EraseRootFromParent_Done,
     /* 1775359 */   // Label 24164: @1775359
     /* 1775359 */   GIM_Try, /*On fail goto*//*Label 24165*/ GIMT_Encode4(1775445), // Rule ID 11802 //
     /* 1775364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1775367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1775375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1775378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1775381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775410 */     // MIs[0] policy
     /* 1775410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1775423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1775441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775444 */     // GIR_Coverage, 11802,
     /* 1775444 */     GIR_EraseRootFromParent_Done,
     /* 1775445 */   // Label 24165: @1775445
     /* 1775445 */   GIM_Try, /*On fail goto*//*Label 24166*/ GIMT_Encode4(1775531), // Rule ID 11803 //
     /* 1775450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1775453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1775461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1775464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1775467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775496 */     // MIs[0] policy
     /* 1775496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775506 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1775509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1775527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775530 */     // GIR_Coverage, 11803,
     /* 1775530 */     GIR_EraseRootFromParent_Done,
     /* 1775531 */   // Label 24166: @1775531
     /* 1775531 */   GIM_Try, /*On fail goto*//*Label 24167*/ GIMT_Encode4(1775617), // Rule ID 11806 //
     /* 1775536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1775547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1775550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1775553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775582 */     // MIs[0] policy
     /* 1775582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1775595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775616 */     // GIR_Coverage, 11806,
     /* 1775616 */     GIR_EraseRootFromParent_Done,
     /* 1775617 */   // Label 24167: @1775617
     /* 1775617 */   GIM_Try, /*On fail goto*//*Label 24168*/ GIMT_Encode4(1775703), // Rule ID 11807 //
     /* 1775622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1775633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1775636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1775639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775668 */     // MIs[0] policy
     /* 1775668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775678 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1775681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775702 */     // GIR_Coverage, 11807,
     /* 1775702 */     GIR_EraseRootFromParent_Done,
     /* 1775703 */   // Label 24168: @1775703
     /* 1775703 */   GIM_Try, /*On fail goto*//*Label 24169*/ GIMT_Encode4(1775789), // Rule ID 11810 //
     /* 1775708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1775719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1775722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1775725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1775731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775754 */     // MIs[0] policy
     /* 1775754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775764 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1775767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775788 */     // GIR_Coverage, 11810,
     /* 1775788 */     GIR_EraseRootFromParent_Done,
     /* 1775789 */   // Label 24169: @1775789
     /* 1775789 */   GIM_Try, /*On fail goto*//*Label 24170*/ GIMT_Encode4(1775875), // Rule ID 11811 //
     /* 1775794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1775805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1775808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1775811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1775817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775840 */     // MIs[0] policy
     /* 1775840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775850 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1775853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775874 */     // GIR_Coverage, 11811,
     /* 1775874 */     GIR_EraseRootFromParent_Done,
     /* 1775875 */   // Label 24170: @1775875
     /* 1775875 */   GIM_Try, /*On fail goto*//*Label 24171*/ GIMT_Encode4(1775961), // Rule ID 11814 //
     /* 1775880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1775891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1775894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1775897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1775903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1775910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775926 */     // MIs[0] policy
     /* 1775926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775936 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1775939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775960 */     // GIR_Coverage, 11814,
     /* 1775960 */     GIR_EraseRootFromParent_Done,
     /* 1775961 */   // Label 24171: @1775961
     /* 1775961 */   GIM_Try, /*On fail goto*//*Label 24172*/ GIMT_Encode4(1776047), // Rule ID 11815 //
     /* 1775966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1775977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1775980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1775983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1775989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1775996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776012 */     // MIs[0] policy
     /* 1776012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776022 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1776025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776046 */     // GIR_Coverage, 11815,
     /* 1776046 */     GIR_EraseRootFromParent_Done,
     /* 1776047 */   // Label 24172: @1776047
     /* 1776047 */   GIM_Try, /*On fail goto*//*Label 24173*/ GIMT_Encode4(1776133), // Rule ID 11818 //
     /* 1776052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1776063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1776066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1776069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776098 */     // MIs[0] policy
     /* 1776098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1776111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776132 */     // GIR_Coverage, 11818,
     /* 1776132 */     GIR_EraseRootFromParent_Done,
     /* 1776133 */   // Label 24173: @1776133
     /* 1776133 */   GIM_Try, /*On fail goto*//*Label 24174*/ GIMT_Encode4(1776219), // Rule ID 11819 //
     /* 1776138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1776149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1776152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1776155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776184 */     // MIs[0] policy
     /* 1776184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1776197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776218 */     // GIR_Coverage, 11819,
     /* 1776218 */     GIR_EraseRootFromParent_Done,
     /* 1776219 */   // Label 24174: @1776219
     /* 1776219 */   GIM_Try, /*On fail goto*//*Label 24175*/ GIMT_Encode4(1776305), // Rule ID 11822 //
     /* 1776224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1776235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1776238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1776241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776270 */     // MIs[0] policy
     /* 1776270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776280 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1776283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776304 */     // GIR_Coverage, 11822,
     /* 1776304 */     GIR_EraseRootFromParent_Done,
     /* 1776305 */   // Label 24175: @1776305
     /* 1776305 */   GIM_Try, /*On fail goto*//*Label 24176*/ GIMT_Encode4(1776391), // Rule ID 11823 //
     /* 1776310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1776321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1776324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1776327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776356 */     // MIs[0] policy
     /* 1776356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776366 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1776369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776390 */     // GIR_Coverage, 11823,
     /* 1776390 */     GIR_EraseRootFromParent_Done,
     /* 1776391 */   // Label 24176: @1776391
     /* 1776391 */   GIM_Try, /*On fail goto*//*Label 24177*/ GIMT_Encode4(1776477), // Rule ID 11826 //
     /* 1776396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1776407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1776410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1776413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776442 */     // MIs[0] policy
     /* 1776442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776452 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1776455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776476 */     // GIR_Coverage, 11826,
     /* 1776476 */     GIR_EraseRootFromParent_Done,
     /* 1776477 */   // Label 24177: @1776477
     /* 1776477 */   GIM_Try, /*On fail goto*//*Label 24178*/ GIMT_Encode4(1776563), // Rule ID 11827 //
     /* 1776482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1776493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1776496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1776499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776528 */     // MIs[0] policy
     /* 1776528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776538 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1776541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776562 */     // GIR_Coverage, 11827,
     /* 1776562 */     GIR_EraseRootFromParent_Done,
     /* 1776563 */   // Label 24178: @1776563
     /* 1776563 */   GIM_Try, /*On fail goto*//*Label 24179*/ GIMT_Encode4(1776649), // Rule ID 11830 //
     /* 1776568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1776579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1776582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1776585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776614 */     // MIs[0] policy
     /* 1776614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1776627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776648 */     // GIR_Coverage, 11830,
     /* 1776648 */     GIR_EraseRootFromParent_Done,
     /* 1776649 */   // Label 24179: @1776649
     /* 1776649 */   GIM_Try, /*On fail goto*//*Label 24180*/ GIMT_Encode4(1776735), // Rule ID 11831 //
     /* 1776654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1776665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1776668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1776671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776700 */     // MIs[0] policy
     /* 1776700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1776713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776734 */     // GIR_Coverage, 11831,
     /* 1776734 */     GIR_EraseRootFromParent_Done,
     /* 1776735 */   // Label 24180: @1776735
     /* 1776735 */   GIM_Try, /*On fail goto*//*Label 24181*/ GIMT_Encode4(1776821), // Rule ID 11834 //
     /* 1776740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1776751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1776754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1776757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776786 */     // MIs[0] policy
     /* 1776786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776796 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1776799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776820 */     // GIR_Coverage, 11834,
     /* 1776820 */     GIR_EraseRootFromParent_Done,
     /* 1776821 */   // Label 24181: @1776821
     /* 1776821 */   GIM_Try, /*On fail goto*//*Label 24182*/ GIMT_Encode4(1776907), // Rule ID 11835 //
     /* 1776826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1776837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1776840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1776843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776872 */     // MIs[0] policy
     /* 1776872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776882 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1776885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776906 */     // GIR_Coverage, 11835,
     /* 1776906 */     GIR_EraseRootFromParent_Done,
     /* 1776907 */   // Label 24182: @1776907
     /* 1776907 */   GIM_Try, /*On fail goto*//*Label 24183*/ GIMT_Encode4(1776993), // Rule ID 11838 //
     /* 1776912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1776923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1776926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1776929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776958 */     // MIs[0] policy
     /* 1776958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776968 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1776971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776992 */     // GIR_Coverage, 11838,
     /* 1776992 */     GIR_EraseRootFromParent_Done,
     /* 1776993 */   // Label 24183: @1776993
     /* 1776993 */   GIM_Try, /*On fail goto*//*Label 24184*/ GIMT_Encode4(1777079), // Rule ID 11839 //
     /* 1776998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1777009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1777012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1777015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1777021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777044 */     // MIs[0] policy
     /* 1777044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1777057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777078 */     // GIR_Coverage, 11839,
     /* 1777078 */     GIR_EraseRootFromParent_Done,
     /* 1777079 */   // Label 24184: @1777079
     /* 1777079 */   GIM_Try, /*On fail goto*//*Label 24185*/ GIMT_Encode4(1777165), // Rule ID 11842 //
     /* 1777084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1777087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1777095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1777098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1777101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777130 */     // MIs[0] policy
     /* 1777130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1777143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777164 */     // GIR_Coverage, 11842,
     /* 1777164 */     GIR_EraseRootFromParent_Done,
     /* 1777165 */   // Label 24185: @1777165
     /* 1777165 */   GIM_Try, /*On fail goto*//*Label 24186*/ GIMT_Encode4(1777251), // Rule ID 11843 //
     /* 1777170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1777173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1777181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1777184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1777187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777216 */     // MIs[0] policy
     /* 1777216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1777229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777250 */     // GIR_Coverage, 11843,
     /* 1777250 */     GIR_EraseRootFromParent_Done,
     /* 1777251 */   // Label 24186: @1777251
     /* 1777251 */   GIM_Try, /*On fail goto*//*Label 24187*/ GIMT_Encode4(1777337), // Rule ID 11846 //
     /* 1777256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1777259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1777267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1777270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1777273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777302 */     // MIs[0] policy
     /* 1777302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777312 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1777315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777336 */     // GIR_Coverage, 11846,
     /* 1777336 */     GIR_EraseRootFromParent_Done,
     /* 1777337 */   // Label 24187: @1777337
     /* 1777337 */   GIM_Try, /*On fail goto*//*Label 24188*/ GIMT_Encode4(1777423), // Rule ID 11847 //
     /* 1777342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1777345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1777353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1777356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1777359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777388 */     // MIs[0] policy
     /* 1777388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777398 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1777401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777422 */     // GIR_Coverage, 11847,
     /* 1777422 */     GIR_EraseRootFromParent_Done,
     /* 1777423 */   // Label 24188: @1777423
     /* 1777423 */   GIM_Try, /*On fail goto*//*Label 24189*/ GIMT_Encode4(1777509), // Rule ID 11850 //
     /* 1777428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1777431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1777439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1777442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1777445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777474 */     // MIs[0] policy
     /* 1777474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1777487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777508 */     // GIR_Coverage, 11850,
     /* 1777508 */     GIR_EraseRootFromParent_Done,
     /* 1777509 */   // Label 24189: @1777509
     /* 1777509 */   GIM_Try, /*On fail goto*//*Label 24190*/ GIMT_Encode4(1777595), // Rule ID 11851 //
     /* 1777514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1777517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1777525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1777528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1777531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777560 */     // MIs[0] policy
     /* 1777560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777570 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1777573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777594 */     // GIR_Coverage, 11851,
     /* 1777594 */     GIR_EraseRootFromParent_Done,
     /* 1777595 */   // Label 24190: @1777595
     /* 1777595 */   GIM_Try, /*On fail goto*//*Label 24191*/ GIMT_Encode4(1777681), // Rule ID 11854 //
     /* 1777600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1777611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1777614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1777617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1777620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777646 */     // MIs[0] policy
     /* 1777646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777656 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1777659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777680 */     // GIR_Coverage, 11854,
     /* 1777680 */     GIR_EraseRootFromParent_Done,
     /* 1777681 */   // Label 24191: @1777681
     /* 1777681 */   GIM_Try, /*On fail goto*//*Label 24192*/ GIMT_Encode4(1777767), // Rule ID 11855 //
     /* 1777686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1777697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1777700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1777703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1777706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777732 */     // MIs[0] policy
     /* 1777732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777742 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1777745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777766 */     // GIR_Coverage, 11855,
     /* 1777766 */     GIR_EraseRootFromParent_Done,
     /* 1777767 */   // Label 24192: @1777767
     /* 1777767 */   GIM_Try, /*On fail goto*//*Label 24193*/ GIMT_Encode4(1777853), // Rule ID 11858 //
     /* 1777772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1777783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1777786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1777789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1777792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777818 */     // MIs[0] policy
     /* 1777818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777828 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1777831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777852 */     // GIR_Coverage, 11858,
     /* 1777852 */     GIR_EraseRootFromParent_Done,
     /* 1777853 */   // Label 24193: @1777853
     /* 1777853 */   GIM_Try, /*On fail goto*//*Label 24194*/ GIMT_Encode4(1777939), // Rule ID 11859 //
     /* 1777858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1777869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1777872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1777875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1777878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777904 */     // MIs[0] policy
     /* 1777904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777914 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1777917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777938 */     // GIR_Coverage, 11859,
     /* 1777938 */     GIR_EraseRootFromParent_Done,
     /* 1777939 */   // Label 24194: @1777939
     /* 1777939 */   GIM_Try, /*On fail goto*//*Label 24195*/ GIMT_Encode4(1778025), // Rule ID 11862 //
     /* 1777944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1777955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1777958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1777961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1777964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777990 */     // MIs[0] policy
     /* 1777990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778000 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1778003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778024 */     // GIR_Coverage, 11862,
     /* 1778024 */     GIR_EraseRootFromParent_Done,
     /* 1778025 */   // Label 24195: @1778025
     /* 1778025 */   GIM_Try, /*On fail goto*//*Label 24196*/ GIMT_Encode4(1778111), // Rule ID 11863 //
     /* 1778030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1778041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1778044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1778047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1778050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778076 */     // MIs[0] policy
     /* 1778076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778086 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1778089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778110 */     // GIR_Coverage, 11863,
     /* 1778110 */     GIR_EraseRootFromParent_Done,
     /* 1778111 */   // Label 24196: @1778111
     /* 1778111 */   GIM_Try, /*On fail goto*//*Label 24197*/ GIMT_Encode4(1778197), // Rule ID 11866 //
     /* 1778116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1778127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1778130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1778133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1778136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778162 */     // MIs[0] policy
     /* 1778162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778172 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1778175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778196 */     // GIR_Coverage, 11866,
     /* 1778196 */     GIR_EraseRootFromParent_Done,
     /* 1778197 */   // Label 24197: @1778197
     /* 1778197 */   GIM_Try, /*On fail goto*//*Label 24198*/ GIMT_Encode4(1778283), // Rule ID 11867 //
     /* 1778202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1778213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1778216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1778219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1778222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778248 */     // MIs[0] policy
     /* 1778248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778258 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1778261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778282 */     // GIR_Coverage, 11867,
     /* 1778282 */     GIR_EraseRootFromParent_Done,
     /* 1778283 */   // Label 24198: @1778283
     /* 1778283 */   GIM_Try, /*On fail goto*//*Label 24199*/ GIMT_Encode4(1778369), // Rule ID 11870 //
     /* 1778288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1778299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1778302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1778305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1778308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778334 */     // MIs[0] policy
     /* 1778334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778344 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1778347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778368 */     // GIR_Coverage, 11870,
     /* 1778368 */     GIR_EraseRootFromParent_Done,
     /* 1778369 */   // Label 24199: @1778369
     /* 1778369 */   GIM_Try, /*On fail goto*//*Label 24200*/ GIMT_Encode4(1778455), // Rule ID 11871 //
     /* 1778374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1778385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1778388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1778391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1778394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778420 */     // MIs[0] policy
     /* 1778420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778430 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1778433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778454 */     // GIR_Coverage, 11871,
     /* 1778454 */     GIR_EraseRootFromParent_Done,
     /* 1778455 */   // Label 24200: @1778455
     /* 1778455 */   GIM_Try, /*On fail goto*//*Label 24201*/ GIMT_Encode4(1778541), // Rule ID 11874 //
     /* 1778460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1778471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1778474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1778477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1778480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778506 */     // MIs[0] policy
     /* 1778506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778516 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1778519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778540 */     // GIR_Coverage, 11874,
     /* 1778540 */     GIR_EraseRootFromParent_Done,
     /* 1778541 */   // Label 24201: @1778541
     /* 1778541 */   GIM_Try, /*On fail goto*//*Label 24202*/ GIMT_Encode4(1778627), // Rule ID 11875 //
     /* 1778546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1778557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1778560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1778563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1778566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778592 */     // MIs[0] policy
     /* 1778592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778602 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1778605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778626 */     // GIR_Coverage, 11875,
     /* 1778626 */     GIR_EraseRootFromParent_Done,
     /* 1778627 */   // Label 24202: @1778627
     /* 1778627 */   GIM_Try, /*On fail goto*//*Label 24203*/ GIMT_Encode4(1778713), // Rule ID 11878 //
     /* 1778632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1778643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1778646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1778649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1778652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778678 */     // MIs[0] policy
     /* 1778678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778688 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1778691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778712 */     // GIR_Coverage, 11878,
     /* 1778712 */     GIR_EraseRootFromParent_Done,
     /* 1778713 */   // Label 24203: @1778713
     /* 1778713 */   GIM_Try, /*On fail goto*//*Label 24204*/ GIMT_Encode4(1778799), // Rule ID 11879 //
     /* 1778718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1778729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1778732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1778735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1778738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778764 */     // MIs[0] policy
     /* 1778764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778774 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1778777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778798 */     // GIR_Coverage, 11879,
     /* 1778798 */     GIR_EraseRootFromParent_Done,
     /* 1778799 */   // Label 24204: @1778799
     /* 1778799 */   GIM_Try, /*On fail goto*//*Label 24205*/ GIMT_Encode4(1778885), // Rule ID 11882 //
     /* 1778804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1778815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1778818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1778821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1778824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778850 */     // MIs[0] policy
     /* 1778850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1778863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778884 */     // GIR_Coverage, 11882,
     /* 1778884 */     GIR_EraseRootFromParent_Done,
     /* 1778885 */   // Label 24205: @1778885
     /* 1778885 */   GIM_Try, /*On fail goto*//*Label 24206*/ GIMT_Encode4(1778971), // Rule ID 11883 //
     /* 1778890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1778901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1778904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1778907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1778910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778936 */     // MIs[0] policy
     /* 1778936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1778949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778970 */     // GIR_Coverage, 11883,
     /* 1778970 */     GIR_EraseRootFromParent_Done,
     /* 1778971 */   // Label 24206: @1778971
     /* 1778971 */   GIM_Try, /*On fail goto*//*Label 24207*/ GIMT_Encode4(1779057), // Rule ID 11886 //
     /* 1778976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1778987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1778990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1778993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1778996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779022 */     // MIs[0] policy
     /* 1779022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779032 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1779035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779056 */     // GIR_Coverage, 11886,
     /* 1779056 */     GIR_EraseRootFromParent_Done,
     /* 1779057 */   // Label 24207: @1779057
     /* 1779057 */   GIM_Try, /*On fail goto*//*Label 24208*/ GIMT_Encode4(1779143), // Rule ID 11887 //
     /* 1779062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1779073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1779076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1779079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1779082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1779085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779108 */     // MIs[0] policy
     /* 1779108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1779121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779142 */     // GIR_Coverage, 11887,
     /* 1779142 */     GIR_EraseRootFromParent_Done,
     /* 1779143 */   // Label 24208: @1779143
     /* 1779143 */   GIM_Try, /*On fail goto*//*Label 24209*/ GIMT_Encode4(1779229), // Rule ID 11890 //
     /* 1779148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1779151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1779159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1779162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1779165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1779168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779194 */     // MIs[0] policy
     /* 1779194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779204 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1779207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1779225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779228 */     // GIR_Coverage, 11890,
     /* 1779228 */     GIR_EraseRootFromParent_Done,
     /* 1779229 */   // Label 24209: @1779229
     /* 1779229 */   GIM_Try, /*On fail goto*//*Label 24210*/ GIMT_Encode4(1779315), // Rule ID 11891 //
     /* 1779234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1779237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1779245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1779248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1779251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1779254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779280 */     // MIs[0] policy
     /* 1779280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1779293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1779311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779314 */     // GIR_Coverage, 11891,
     /* 1779314 */     GIR_EraseRootFromParent_Done,
     /* 1779315 */   // Label 24210: @1779315
     /* 1779315 */   GIM_Try, /*On fail goto*//*Label 24211*/ GIMT_Encode4(1779401), // Rule ID 11894 //
     /* 1779320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1779331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1779334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1779337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1779340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779366 */     // MIs[0] policy
     /* 1779366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779376 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1779379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779400 */     // GIR_Coverage, 11894,
     /* 1779400 */     GIR_EraseRootFromParent_Done,
     /* 1779401 */   // Label 24211: @1779401
     /* 1779401 */   GIM_Try, /*On fail goto*//*Label 24212*/ GIMT_Encode4(1779487), // Rule ID 11895 //
     /* 1779406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1779417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1779420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1779423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1779426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779452 */     // MIs[0] policy
     /* 1779452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779462 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1779465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779486 */     // GIR_Coverage, 11895,
     /* 1779486 */     GIR_EraseRootFromParent_Done,
     /* 1779487 */   // Label 24212: @1779487
     /* 1779487 */   GIM_Try, /*On fail goto*//*Label 24213*/ GIMT_Encode4(1779573), // Rule ID 11898 //
     /* 1779492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1779503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1779506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1779509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1779512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779538 */     // MIs[0] policy
     /* 1779538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779548 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1779551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779572 */     // GIR_Coverage, 11898,
     /* 1779572 */     GIR_EraseRootFromParent_Done,
     /* 1779573 */   // Label 24213: @1779573
     /* 1779573 */   GIM_Try, /*On fail goto*//*Label 24214*/ GIMT_Encode4(1779659), // Rule ID 11899 //
     /* 1779578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1779589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1779592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1779595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1779598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779624 */     // MIs[0] policy
     /* 1779624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779634 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1779637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779658 */     // GIR_Coverage, 11899,
     /* 1779658 */     GIR_EraseRootFromParent_Done,
     /* 1779659 */   // Label 24214: @1779659
     /* 1779659 */   GIM_Try, /*On fail goto*//*Label 24215*/ GIMT_Encode4(1779745), // Rule ID 11902 //
     /* 1779664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1779675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1779678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1779681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1779684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1779687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779710 */     // MIs[0] policy
     /* 1779710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779720 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1779723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779744 */     // GIR_Coverage, 11902,
     /* 1779744 */     GIR_EraseRootFromParent_Done,
     /* 1779745 */   // Label 24215: @1779745
     /* 1779745 */   GIM_Try, /*On fail goto*//*Label 24216*/ GIMT_Encode4(1779831), // Rule ID 11903 //
     /* 1779750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1779761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1779764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1779767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1779770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1779773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779796 */     // MIs[0] policy
     /* 1779796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779806 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1779809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779830 */     // GIR_Coverage, 11903,
     /* 1779830 */     GIR_EraseRootFromParent_Done,
     /* 1779831 */   // Label 24216: @1779831
     /* 1779831 */   GIM_Try, /*On fail goto*//*Label 24217*/ GIMT_Encode4(1779917), // Rule ID 11906 //
     /* 1779836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1779847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1779850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1779853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1779856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779882 */     // MIs[0] policy
     /* 1779882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1779895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779916 */     // GIR_Coverage, 11906,
     /* 1779916 */     GIR_EraseRootFromParent_Done,
     /* 1779917 */   // Label 24217: @1779917
     /* 1779917 */   GIM_Try, /*On fail goto*//*Label 24218*/ GIMT_Encode4(1780003), // Rule ID 11907 //
     /* 1779922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1779933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1779936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1779939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1779942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779968 */     // MIs[0] policy
     /* 1779968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1779981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780002 */     // GIR_Coverage, 11907,
     /* 1780002 */     GIR_EraseRootFromParent_Done,
     /* 1780003 */   // Label 24218: @1780003
     /* 1780003 */   GIM_Try, /*On fail goto*//*Label 24219*/ GIMT_Encode4(1780089), // Rule ID 11910 //
     /* 1780008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1780019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1780022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1780025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1780028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780054 */     // MIs[0] policy
     /* 1780054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1780067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780088 */     // GIR_Coverage, 11910,
     /* 1780088 */     GIR_EraseRootFromParent_Done,
     /* 1780089 */   // Label 24219: @1780089
     /* 1780089 */   GIM_Try, /*On fail goto*//*Label 24220*/ GIMT_Encode4(1780175), // Rule ID 11911 //
     /* 1780094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1780105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1780108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1780111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1780114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780140 */     // MIs[0] policy
     /* 1780140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780150 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1780153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780174 */     // GIR_Coverage, 11911,
     /* 1780174 */     GIR_EraseRootFromParent_Done,
     /* 1780175 */   // Label 24220: @1780175
     /* 1780175 */   GIM_Try, /*On fail goto*//*Label 24221*/ GIMT_Encode4(1780261), // Rule ID 11914 //
     /* 1780180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1780191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1780194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1780197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1780200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1780203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780226 */     // MIs[0] policy
     /* 1780226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1780239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780260 */     // GIR_Coverage, 11914,
     /* 1780260 */     GIR_EraseRootFromParent_Done,
     /* 1780261 */   // Label 24221: @1780261
     /* 1780261 */   GIM_Try, /*On fail goto*//*Label 24222*/ GIMT_Encode4(1780347), // Rule ID 11915 //
     /* 1780266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1780277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1780280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1780283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1780286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1780289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780312 */     // MIs[0] policy
     /* 1780312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780322 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1780325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780346 */     // GIR_Coverage, 11915,
     /* 1780346 */     GIR_EraseRootFromParent_Done,
     /* 1780347 */   // Label 24222: @1780347
     /* 1780347 */   GIM_Try, /*On fail goto*//*Label 24223*/ GIMT_Encode4(1780433), // Rule ID 11918 //
     /* 1780352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1780363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1780366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1780369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1780372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780398 */     // MIs[0] policy
     /* 1780398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780408 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1780411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780432 */     // GIR_Coverage, 11918,
     /* 1780432 */     GIR_EraseRootFromParent_Done,
     /* 1780433 */   // Label 24223: @1780433
     /* 1780433 */   GIM_Try, /*On fail goto*//*Label 24224*/ GIMT_Encode4(1780519), // Rule ID 11919 //
     /* 1780438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1780449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1780452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1780455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1780458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780484 */     // MIs[0] policy
     /* 1780484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1780497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780518 */     // GIR_Coverage, 11919,
     /* 1780518 */     GIR_EraseRootFromParent_Done,
     /* 1780519 */   // Label 24224: @1780519
     /* 1780519 */   GIM_Try, /*On fail goto*//*Label 24225*/ GIMT_Encode4(1780605), // Rule ID 11922 //
     /* 1780524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1780535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1780538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1780541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1780544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780570 */     // MIs[0] policy
     /* 1780570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780580 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1780583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780604 */     // GIR_Coverage, 11922,
     /* 1780604 */     GIR_EraseRootFromParent_Done,
     /* 1780605 */   // Label 24225: @1780605
     /* 1780605 */   GIM_Try, /*On fail goto*//*Label 24226*/ GIMT_Encode4(1780691), // Rule ID 11923 //
     /* 1780610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1780621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1780624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1780627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1780630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780656 */     // MIs[0] policy
     /* 1780656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780666 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1780669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780690 */     // GIR_Coverage, 11923,
     /* 1780690 */     GIR_EraseRootFromParent_Done,
     /* 1780691 */   // Label 24226: @1780691
     /* 1780691 */   GIM_Try, /*On fail goto*//*Label 24227*/ GIMT_Encode4(1780777), // Rule ID 11926 //
     /* 1780696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1780707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1780710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1780713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1780716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780742 */     // MIs[0] policy
     /* 1780742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1780755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780776 */     // GIR_Coverage, 11926,
     /* 1780776 */     GIR_EraseRootFromParent_Done,
     /* 1780777 */   // Label 24227: @1780777
     /* 1780777 */   GIM_Try, /*On fail goto*//*Label 24228*/ GIMT_Encode4(1780863), // Rule ID 11927 //
     /* 1780782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1780793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1780796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1780799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1780802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780828 */     // MIs[0] policy
     /* 1780828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780838 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1780841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780862 */     // GIR_Coverage, 11927,
     /* 1780862 */     GIR_EraseRootFromParent_Done,
     /* 1780863 */   // Label 24228: @1780863
     /* 1780863 */   GIM_Try, /*On fail goto*//*Label 24229*/ GIMT_Encode4(1780949), // Rule ID 11930 //
     /* 1780868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1780879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1780882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1780885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1780888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780914 */     // MIs[0] policy
     /* 1780914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1780927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780948 */     // GIR_Coverage, 11930,
     /* 1780948 */     GIR_EraseRootFromParent_Done,
     /* 1780949 */   // Label 24229: @1780949
     /* 1780949 */   GIM_Try, /*On fail goto*//*Label 24230*/ GIMT_Encode4(1781035), // Rule ID 11931 //
     /* 1780954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1780965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1780968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1780971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1780974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781000 */     // MIs[0] policy
     /* 1781000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1781013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781034 */     // GIR_Coverage, 11931,
     /* 1781034 */     GIR_EraseRootFromParent_Done,
     /* 1781035 */   // Label 24230: @1781035
     /* 1781035 */   GIM_Try, /*On fail goto*//*Label 24231*/ GIMT_Encode4(1781121), // Rule ID 11934 //
     /* 1781040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1781043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1781051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1781054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1781057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1781060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781086 */     // MIs[0] policy
     /* 1781086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1781099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781120 */     // GIR_Coverage, 11934,
     /* 1781120 */     GIR_EraseRootFromParent_Done,
     /* 1781121 */   // Label 24231: @1781121
     /* 1781121 */   GIM_Try, /*On fail goto*//*Label 24232*/ GIMT_Encode4(1781207), // Rule ID 11935 //
     /* 1781126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1781129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1781137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1781140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1781143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1781146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781172 */     // MIs[0] policy
     /* 1781172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781182 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1781185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781206 */     // GIR_Coverage, 11935,
     /* 1781206 */     GIR_EraseRootFromParent_Done,
     /* 1781207 */   // Label 24232: @1781207
     /* 1781207 */   GIM_Try, /*On fail goto*//*Label 24233*/ GIMT_Encode4(1781293), // Rule ID 11938 //
     /* 1781212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1781215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1781223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1781226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1781229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1781232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781258 */     // MIs[0] policy
     /* 1781258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781268 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1781271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781292 */     // GIR_Coverage, 11938,
     /* 1781292 */     GIR_EraseRootFromParent_Done,
     /* 1781293 */   // Label 24233: @1781293
     /* 1781293 */   GIM_Try, /*On fail goto*//*Label 24234*/ GIMT_Encode4(1781379), // Rule ID 11939 //
     /* 1781298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1781301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1781309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1781312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1781315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1781318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781344 */     // MIs[0] policy
     /* 1781344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781354 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1781357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781378 */     // GIR_Coverage, 11939,
     /* 1781378 */     GIR_EraseRootFromParent_Done,
     /* 1781379 */   // Label 24234: @1781379
     /* 1781379 */   GIM_Try, /*On fail goto*//*Label 24235*/ GIMT_Encode4(1781465), // Rule ID 11942 //
     /* 1781384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1781395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1781398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1781401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781430 */     // MIs[0] policy
     /* 1781430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781440 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1781443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781464 */     // GIR_Coverage, 11942,
     /* 1781464 */     GIR_EraseRootFromParent_Done,
     /* 1781465 */   // Label 24235: @1781465
     /* 1781465 */   GIM_Try, /*On fail goto*//*Label 24236*/ GIMT_Encode4(1781551), // Rule ID 11943 //
     /* 1781470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1781481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1781484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1781487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781516 */     // MIs[0] policy
     /* 1781516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781526 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1781529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781550 */     // GIR_Coverage, 11943,
     /* 1781550 */     GIR_EraseRootFromParent_Done,
     /* 1781551 */   // Label 24236: @1781551
     /* 1781551 */   GIM_Try, /*On fail goto*//*Label 24237*/ GIMT_Encode4(1781637), // Rule ID 11946 //
     /* 1781556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1781567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1781570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1781573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781602 */     // MIs[0] policy
     /* 1781602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781612 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1781615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781636 */     // GIR_Coverage, 11946,
     /* 1781636 */     GIR_EraseRootFromParent_Done,
     /* 1781637 */   // Label 24237: @1781637
     /* 1781637 */   GIM_Try, /*On fail goto*//*Label 24238*/ GIMT_Encode4(1781723), // Rule ID 11947 //
     /* 1781642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1781653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1781656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1781659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781688 */     // MIs[0] policy
     /* 1781688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781698 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1781701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781722 */     // GIR_Coverage, 11947,
     /* 1781722 */     GIR_EraseRootFromParent_Done,
     /* 1781723 */   // Label 24238: @1781723
     /* 1781723 */   GIM_Try, /*On fail goto*//*Label 24239*/ GIMT_Encode4(1781809), // Rule ID 11950 //
     /* 1781728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1781739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1781742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1781745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781774 */     // MIs[0] policy
     /* 1781774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781784 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1781787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781808 */     // GIR_Coverage, 11950,
     /* 1781808 */     GIR_EraseRootFromParent_Done,
     /* 1781809 */   // Label 24239: @1781809
     /* 1781809 */   GIM_Try, /*On fail goto*//*Label 24240*/ GIMT_Encode4(1781895), // Rule ID 11951 //
     /* 1781814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1781825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1781828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1781831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781860 */     // MIs[0] policy
     /* 1781860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781870 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1781873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781894 */     // GIR_Coverage, 11951,
     /* 1781894 */     GIR_EraseRootFromParent_Done,
     /* 1781895 */   // Label 24240: @1781895
     /* 1781895 */   GIM_Try, /*On fail goto*//*Label 24241*/ GIMT_Encode4(1781981), // Rule ID 11954 //
     /* 1781900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1781911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1781914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1781917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781946 */     // MIs[0] policy
     /* 1781946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781956 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1781959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781980 */     // GIR_Coverage, 11954,
     /* 1781980 */     GIR_EraseRootFromParent_Done,
     /* 1781981 */   // Label 24241: @1781981
     /* 1781981 */   GIM_Try, /*On fail goto*//*Label 24242*/ GIMT_Encode4(1782067), // Rule ID 11955 //
     /* 1781986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1781997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1782000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1782003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782032 */     // MIs[0] policy
     /* 1782032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782042 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1782045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782066 */     // GIR_Coverage, 11955,
     /* 1782066 */     GIR_EraseRootFromParent_Done,
     /* 1782067 */   // Label 24242: @1782067
     /* 1782067 */   GIM_Try, /*On fail goto*//*Label 24243*/ GIMT_Encode4(1782153), // Rule ID 11958 //
     /* 1782072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1782083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1782086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1782089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782118 */     // MIs[0] policy
     /* 1782118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782128 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1782131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782152 */     // GIR_Coverage, 11958,
     /* 1782152 */     GIR_EraseRootFromParent_Done,
     /* 1782153 */   // Label 24243: @1782153
     /* 1782153 */   GIM_Try, /*On fail goto*//*Label 24244*/ GIMT_Encode4(1782239), // Rule ID 11959 //
     /* 1782158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1782169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1782172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1782175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782204 */     // MIs[0] policy
     /* 1782204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782214 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1782217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782238 */     // GIR_Coverage, 11959,
     /* 1782238 */     GIR_EraseRootFromParent_Done,
     /* 1782239 */   // Label 24244: @1782239
     /* 1782239 */   GIM_Try, /*On fail goto*//*Label 24245*/ GIMT_Encode4(1782325), // Rule ID 11962 //
     /* 1782244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1782255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1782258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1782261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782290 */     // MIs[0] policy
     /* 1782290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1782303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782324 */     // GIR_Coverage, 11962,
     /* 1782324 */     GIR_EraseRootFromParent_Done,
     /* 1782325 */   // Label 24245: @1782325
     /* 1782325 */   GIM_Try, /*On fail goto*//*Label 24246*/ GIMT_Encode4(1782411), // Rule ID 11963 //
     /* 1782330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1782341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1782344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1782347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782376 */     // MIs[0] policy
     /* 1782376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1782389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782410 */     // GIR_Coverage, 11963,
     /* 1782410 */     GIR_EraseRootFromParent_Done,
     /* 1782411 */   // Label 24246: @1782411
     /* 1782411 */   GIM_Try, /*On fail goto*//*Label 24247*/ GIMT_Encode4(1782497), // Rule ID 11966 //
     /* 1782416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1782427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1782430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1782433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782462 */     // MIs[0] policy
     /* 1782462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782472 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1782475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782496 */     // GIR_Coverage, 11966,
     /* 1782496 */     GIR_EraseRootFromParent_Done,
     /* 1782497 */   // Label 24247: @1782497
     /* 1782497 */   GIM_Try, /*On fail goto*//*Label 24248*/ GIMT_Encode4(1782583), // Rule ID 11967 //
     /* 1782502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1782513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1782516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1782519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782548 */     // MIs[0] policy
     /* 1782548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782558 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1782561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782582 */     // GIR_Coverage, 11967,
     /* 1782582 */     GIR_EraseRootFromParent_Done,
     /* 1782583 */   // Label 24248: @1782583
     /* 1782583 */   GIM_Try, /*On fail goto*//*Label 24249*/ GIMT_Encode4(1782669), // Rule ID 11970 //
     /* 1782588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1782599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1782602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1782605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782634 */     // MIs[0] policy
     /* 1782634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782644 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1782647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782668 */     // GIR_Coverage, 11970,
     /* 1782668 */     GIR_EraseRootFromParent_Done,
     /* 1782669 */   // Label 24249: @1782669
     /* 1782669 */   GIM_Try, /*On fail goto*//*Label 24250*/ GIMT_Encode4(1782755), // Rule ID 11971 //
     /* 1782674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1782685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1782688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1782691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782720 */     // MIs[0] policy
     /* 1782720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782730 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1782733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782754 */     // GIR_Coverage, 11971,
     /* 1782754 */     GIR_EraseRootFromParent_Done,
     /* 1782755 */   // Label 24250: @1782755
     /* 1782755 */   GIM_Try, /*On fail goto*//*Label 24251*/ GIMT_Encode4(1782841), // Rule ID 11974 //
     /* 1782760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1782771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1782774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1782777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782806 */     // MIs[0] policy
     /* 1782806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782816 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1782819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782840 */     // GIR_Coverage, 11974,
     /* 1782840 */     GIR_EraseRootFromParent_Done,
     /* 1782841 */   // Label 24251: @1782841
     /* 1782841 */   GIM_Try, /*On fail goto*//*Label 24252*/ GIMT_Encode4(1782927), // Rule ID 11975 //
     /* 1782846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1782857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1782860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1782863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782892 */     // MIs[0] policy
     /* 1782892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1782905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782926 */     // GIR_Coverage, 11975,
     /* 1782926 */     GIR_EraseRootFromParent_Done,
     /* 1782927 */   // Label 24252: @1782927
     /* 1782927 */   GIM_Try, /*On fail goto*//*Label 24253*/ GIMT_Encode4(1783013), // Rule ID 11978 //
     /* 1782932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1782935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1782943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1782946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1782949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782978 */     // MIs[0] policy
     /* 1782978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782988 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1782991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1783009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783012 */     // GIR_Coverage, 11978,
     /* 1783012 */     GIR_EraseRootFromParent_Done,
     /* 1783013 */   // Label 24253: @1783013
     /* 1783013 */   GIM_Try, /*On fail goto*//*Label 24254*/ GIMT_Encode4(1783099), // Rule ID 11979 //
     /* 1783018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1783021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1783029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1783032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1783035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1783041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783064 */     // MIs[0] policy
     /* 1783064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1783077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1783095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783098 */     // GIR_Coverage, 11979,
     /* 1783098 */     GIR_EraseRootFromParent_Done,
     /* 1783099 */   // Label 24254: @1783099
     /* 1783099 */   GIM_Try, /*On fail goto*//*Label 24255*/ GIMT_Encode4(1783185), // Rule ID 11982 //
     /* 1783104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1783115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1783118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1783121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783150 */     // MIs[0] policy
     /* 1783150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783160 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1783163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783184 */     // GIR_Coverage, 11982,
     /* 1783184 */     GIR_EraseRootFromParent_Done,
     /* 1783185 */   // Label 24255: @1783185
     /* 1783185 */   GIM_Try, /*On fail goto*//*Label 24256*/ GIMT_Encode4(1783271), // Rule ID 11983 //
     /* 1783190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1783201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1783204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1783207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783236 */     // MIs[0] policy
     /* 1783236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783246 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1783249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783270 */     // GIR_Coverage, 11983,
     /* 1783270 */     GIR_EraseRootFromParent_Done,
     /* 1783271 */   // Label 24256: @1783271
     /* 1783271 */   GIM_Try, /*On fail goto*//*Label 24257*/ GIMT_Encode4(1783357), // Rule ID 11986 //
     /* 1783276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1783287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1783290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1783293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783322 */     // MIs[0] policy
     /* 1783322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783332 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1783335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783356 */     // GIR_Coverage, 11986,
     /* 1783356 */     GIR_EraseRootFromParent_Done,
     /* 1783357 */   // Label 24257: @1783357
     /* 1783357 */   GIM_Try, /*On fail goto*//*Label 24258*/ GIMT_Encode4(1783443), // Rule ID 11987 //
     /* 1783362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1783373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1783376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1783379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783408 */     // MIs[0] policy
     /* 1783408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783418 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1783421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783442 */     // GIR_Coverage, 11987,
     /* 1783442 */     GIR_EraseRootFromParent_Done,
     /* 1783443 */   // Label 24258: @1783443
     /* 1783443 */   GIM_Try, /*On fail goto*//*Label 24259*/ GIMT_Encode4(1783529), // Rule ID 11990 //
     /* 1783448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1783459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1783462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1783465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1783471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783494 */     // MIs[0] policy
     /* 1783494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783504 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1783507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783528 */     // GIR_Coverage, 11990,
     /* 1783528 */     GIR_EraseRootFromParent_Done,
     /* 1783529 */   // Label 24259: @1783529
     /* 1783529 */   GIM_Try, /*On fail goto*//*Label 24260*/ GIMT_Encode4(1783615), // Rule ID 11991 //
     /* 1783534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1783545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1783548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1783551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1783557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783580 */     // MIs[0] policy
     /* 1783580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783590 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1783593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783614 */     // GIR_Coverage, 11991,
     /* 1783614 */     GIR_EraseRootFromParent_Done,
     /* 1783615 */   // Label 24260: @1783615
     /* 1783615 */   GIM_Try, /*On fail goto*//*Label 24261*/ GIMT_Encode4(1783701), // Rule ID 11994 //
     /* 1783620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1783631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1783634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1783637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783666 */     // MIs[0] policy
     /* 1783666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1783679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783700 */     // GIR_Coverage, 11994,
     /* 1783700 */     GIR_EraseRootFromParent_Done,
     /* 1783701 */   // Label 24261: @1783701
     /* 1783701 */   GIM_Try, /*On fail goto*//*Label 24262*/ GIMT_Encode4(1783787), // Rule ID 11995 //
     /* 1783706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1783717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1783720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1783723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783752 */     // MIs[0] policy
     /* 1783752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1783765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783786 */     // GIR_Coverage, 11995,
     /* 1783786 */     GIR_EraseRootFromParent_Done,
     /* 1783787 */   // Label 24262: @1783787
     /* 1783787 */   GIM_Try, /*On fail goto*//*Label 24263*/ GIMT_Encode4(1783873), // Rule ID 11998 //
     /* 1783792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1783803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1783806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1783809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783838 */     // MIs[0] policy
     /* 1783838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1783851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783872 */     // GIR_Coverage, 11998,
     /* 1783872 */     GIR_EraseRootFromParent_Done,
     /* 1783873 */   // Label 24263: @1783873
     /* 1783873 */   GIM_Try, /*On fail goto*//*Label 24264*/ GIMT_Encode4(1783959), // Rule ID 11999 //
     /* 1783878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1783889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1783892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1783895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783924 */     // MIs[0] policy
     /* 1783924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1783937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783958 */     // GIR_Coverage, 11999,
     /* 1783958 */     GIR_EraseRootFromParent_Done,
     /* 1783959 */   // Label 24264: @1783959
     /* 1783959 */   GIM_Try, /*On fail goto*//*Label 24265*/ GIMT_Encode4(1784045), // Rule ID 12002 //
     /* 1783964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1783975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1783978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1783981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784010 */     // MIs[0] policy
     /* 1784010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784020 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1784023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784044 */     // GIR_Coverage, 12002,
     /* 1784044 */     GIR_EraseRootFromParent_Done,
     /* 1784045 */   // Label 24265: @1784045
     /* 1784045 */   GIM_Try, /*On fail goto*//*Label 24266*/ GIMT_Encode4(1784131), // Rule ID 12003 //
     /* 1784050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1784061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1784064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1784067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1784073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784096 */     // MIs[0] policy
     /* 1784096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784106 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1784109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784130 */     // GIR_Coverage, 12003,
     /* 1784130 */     GIR_EraseRootFromParent_Done,
     /* 1784131 */   // Label 24266: @1784131
     /* 1784131 */   GIM_Try, /*On fail goto*//*Label 24267*/ GIMT_Encode4(1784217), // Rule ID 12006 //
     /* 1784136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1784147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1784150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1784153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784182 */     // MIs[0] policy
     /* 1784182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1784195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784216 */     // GIR_Coverage, 12006,
     /* 1784216 */     GIR_EraseRootFromParent_Done,
     /* 1784217 */   // Label 24267: @1784217
     /* 1784217 */   GIM_Try, /*On fail goto*//*Label 24268*/ GIMT_Encode4(1784303), // Rule ID 12007 //
     /* 1784222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1784233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1784236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1784239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784268 */     // MIs[0] policy
     /* 1784268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1784281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784302 */     // GIR_Coverage, 12007,
     /* 1784302 */     GIR_EraseRootFromParent_Done,
     /* 1784303 */   // Label 24268: @1784303
     /* 1784303 */   GIM_Try, /*On fail goto*//*Label 24269*/ GIMT_Encode4(1784389), // Rule ID 12010 //
     /* 1784308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1784319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1784322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1784325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784354 */     // MIs[0] policy
     /* 1784354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1784367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784388 */     // GIR_Coverage, 12010,
     /* 1784388 */     GIR_EraseRootFromParent_Done,
     /* 1784389 */   // Label 24269: @1784389
     /* 1784389 */   GIM_Try, /*On fail goto*//*Label 24270*/ GIMT_Encode4(1784475), // Rule ID 12011 //
     /* 1784394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1784405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1784408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1784411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784440 */     // MIs[0] policy
     /* 1784440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784450 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1784453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784474 */     // GIR_Coverage, 12011,
     /* 1784474 */     GIR_EraseRootFromParent_Done,
     /* 1784475 */   // Label 24270: @1784475
     /* 1784475 */   GIM_Try, /*On fail goto*//*Label 24271*/ GIMT_Encode4(1784561), // Rule ID 12014 //
     /* 1784480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1784491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1784494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1784497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784526 */     // MIs[0] policy
     /* 1784526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1784539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784560 */     // GIR_Coverage, 12014,
     /* 1784560 */     GIR_EraseRootFromParent_Done,
     /* 1784561 */   // Label 24271: @1784561
     /* 1784561 */   GIM_Try, /*On fail goto*//*Label 24272*/ GIMT_Encode4(1784647), // Rule ID 12015 //
     /* 1784566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1784577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1784580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1784583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784612 */     // MIs[0] policy
     /* 1784612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784622 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1784625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784646 */     // GIR_Coverage, 12015,
     /* 1784646 */     GIR_EraseRootFromParent_Done,
     /* 1784647 */   // Label 24272: @1784647
     /* 1784647 */   GIM_Try, /*On fail goto*//*Label 24273*/ GIMT_Encode4(1784733), // Rule ID 12018 //
     /* 1784652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1784663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1784666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1784669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784698 */     // MIs[0] policy
     /* 1784698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784708 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1784711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784732 */     // GIR_Coverage, 12018,
     /* 1784732 */     GIR_EraseRootFromParent_Done,
     /* 1784733 */   // Label 24273: @1784733
     /* 1784733 */   GIM_Try, /*On fail goto*//*Label 24274*/ GIMT_Encode4(1784819), // Rule ID 12019 //
     /* 1784738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1784749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1784752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1784755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784784 */     // MIs[0] policy
     /* 1784784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784794 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1784797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784818 */     // GIR_Coverage, 12019,
     /* 1784818 */     GIR_EraseRootFromParent_Done,
     /* 1784819 */   // Label 24274: @1784819
     /* 1784819 */   GIM_Try, /*On fail goto*//*Label 24275*/ GIMT_Encode4(1784905), // Rule ID 12022 //
     /* 1784824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1784835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1784838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1784841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784870 */     // MIs[0] policy
     /* 1784870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784880 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1784883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784904 */     // GIR_Coverage, 12022,
     /* 1784904 */     GIR_EraseRootFromParent_Done,
     /* 1784905 */   // Label 24275: @1784905
     /* 1784905 */   GIM_Try, /*On fail goto*//*Label 24276*/ GIMT_Encode4(1784991), // Rule ID 12023 //
     /* 1784910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1784921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1784924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1784927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784956 */     // MIs[0] policy
     /* 1784956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1784969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784990 */     // GIR_Coverage, 12023,
     /* 1784990 */     GIR_EraseRootFromParent_Done,
     /* 1784991 */   // Label 24276: @1784991
     /* 1784991 */   GIM_Try, /*On fail goto*//*Label 24277*/ GIMT_Encode4(1785077), // Rule ID 12026 //
     /* 1784996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1785007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1785010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1785013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785042 */     // MIs[0] policy
     /* 1785042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1785055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785076 */     // GIR_Coverage, 12026,
     /* 1785076 */     GIR_EraseRootFromParent_Done,
     /* 1785077 */   // Label 24277: @1785077
     /* 1785077 */   GIM_Try, /*On fail goto*//*Label 24278*/ GIMT_Encode4(1785163), // Rule ID 12027 //
     /* 1785082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1785085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1785093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1785096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1785099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785128 */     // MIs[0] policy
     /* 1785128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785138 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1785141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785162 */     // GIR_Coverage, 12027,
     /* 1785162 */     GIR_EraseRootFromParent_Done,
     /* 1785163 */   // Label 24278: @1785163
     /* 1785163 */   GIM_Try, /*On fail goto*//*Label 24279*/ GIMT_Encode4(1785249), // Rule ID 12030 //
     /* 1785168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1785179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1785182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1785185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1785188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785214 */     // MIs[0] policy
     /* 1785214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785224 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1785227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785248 */     // GIR_Coverage, 12030,
     /* 1785248 */     GIR_EraseRootFromParent_Done,
     /* 1785249 */   // Label 24279: @1785249
     /* 1785249 */   GIM_Try, /*On fail goto*//*Label 24280*/ GIMT_Encode4(1785335), // Rule ID 12031 //
     /* 1785254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1785265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1785268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1785271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1785274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785300 */     // MIs[0] policy
     /* 1785300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785310 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1785313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785334 */     // GIR_Coverage, 12031,
     /* 1785334 */     GIR_EraseRootFromParent_Done,
     /* 1785335 */   // Label 24280: @1785335
     /* 1785335 */   GIM_Try, /*On fail goto*//*Label 24281*/ GIMT_Encode4(1785421), // Rule ID 12034 //
     /* 1785340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1785351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1785354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1785357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1785360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785386 */     // MIs[0] policy
     /* 1785386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1785399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785420 */     // GIR_Coverage, 12034,
     /* 1785420 */     GIR_EraseRootFromParent_Done,
     /* 1785421 */   // Label 24281: @1785421
     /* 1785421 */   GIM_Try, /*On fail goto*//*Label 24282*/ GIMT_Encode4(1785507), // Rule ID 12035 //
     /* 1785426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1785437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1785440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1785443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1785446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785472 */     // MIs[0] policy
     /* 1785472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785482 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1785485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785506 */     // GIR_Coverage, 12035,
     /* 1785506 */     GIR_EraseRootFromParent_Done,
     /* 1785507 */   // Label 24282: @1785507
     /* 1785507 */   GIM_Try, /*On fail goto*//*Label 24283*/ GIMT_Encode4(1785593), // Rule ID 12038 //
     /* 1785512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1785523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1785526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1785529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1785532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785558 */     // MIs[0] policy
     /* 1785558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785568 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1785571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785592 */     // GIR_Coverage, 12038,
     /* 1785592 */     GIR_EraseRootFromParent_Done,
     /* 1785593 */   // Label 24283: @1785593
     /* 1785593 */   GIM_Try, /*On fail goto*//*Label 24284*/ GIMT_Encode4(1785679), // Rule ID 12039 //
     /* 1785598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1785609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1785612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1785615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1785618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785644 */     // MIs[0] policy
     /* 1785644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785654 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1785657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785678 */     // GIR_Coverage, 12039,
     /* 1785678 */     GIR_EraseRootFromParent_Done,
     /* 1785679 */   // Label 24284: @1785679
     /* 1785679 */   GIM_Try, /*On fail goto*//*Label 24285*/ GIMT_Encode4(1785765), // Rule ID 12042 //
     /* 1785684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1785695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1785698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1785701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1785704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785730 */     // MIs[0] policy
     /* 1785730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1785743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785764 */     // GIR_Coverage, 12042,
     /* 1785764 */     GIR_EraseRootFromParent_Done,
     /* 1785765 */   // Label 24285: @1785765
     /* 1785765 */   GIM_Try, /*On fail goto*//*Label 24286*/ GIMT_Encode4(1785851), // Rule ID 12043 //
     /* 1785770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1785781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1785784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1785787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1785790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785816 */     // MIs[0] policy
     /* 1785816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785826 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1785829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785850 */     // GIR_Coverage, 12043,
     /* 1785850 */     GIR_EraseRootFromParent_Done,
     /* 1785851 */   // Label 24286: @1785851
     /* 1785851 */   GIM_Try, /*On fail goto*//*Label 24287*/ GIMT_Encode4(1785937), // Rule ID 12046 //
     /* 1785856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1785867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1785870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1785873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1785876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785902 */     // MIs[0] policy
     /* 1785902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785912 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1785915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785936 */     // GIR_Coverage, 12046,
     /* 1785936 */     GIR_EraseRootFromParent_Done,
     /* 1785937 */   // Label 24287: @1785937
     /* 1785937 */   GIM_Try, /*On fail goto*//*Label 24288*/ GIMT_Encode4(1786023), // Rule ID 12047 //
     /* 1785942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1785953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1785956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1785959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1785962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785988 */     // MIs[0] policy
     /* 1785988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785998 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1786001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786022 */     // GIR_Coverage, 12047,
     /* 1786022 */     GIR_EraseRootFromParent_Done,
     /* 1786023 */   // Label 24288: @1786023
     /* 1786023 */   GIM_Try, /*On fail goto*//*Label 24289*/ GIMT_Encode4(1786109), // Rule ID 12050 //
     /* 1786028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1786039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1786042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1786045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1786048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786074 */     // MIs[0] policy
     /* 1786074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1786087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786108 */     // GIR_Coverage, 12050,
     /* 1786108 */     GIR_EraseRootFromParent_Done,
     /* 1786109 */   // Label 24289: @1786109
     /* 1786109 */   GIM_Try, /*On fail goto*//*Label 24290*/ GIMT_Encode4(1786195), // Rule ID 12051 //
     /* 1786114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1786125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1786128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1786131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1786134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786160 */     // MIs[0] policy
     /* 1786160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786170 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1786173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786194 */     // GIR_Coverage, 12051,
     /* 1786194 */     GIR_EraseRootFromParent_Done,
     /* 1786195 */   // Label 24290: @1786195
     /* 1786195 */   GIM_Try, /*On fail goto*//*Label 24291*/ GIMT_Encode4(1786281), // Rule ID 12054 //
     /* 1786200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1786211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1786214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1786217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1786220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1786223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786246 */     // MIs[0] policy
     /* 1786246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786256 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1786259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786280 */     // GIR_Coverage, 12054,
     /* 1786280 */     GIR_EraseRootFromParent_Done,
     /* 1786281 */   // Label 24291: @1786281
     /* 1786281 */   GIM_Try, /*On fail goto*//*Label 24292*/ GIMT_Encode4(1786367), // Rule ID 12055 //
     /* 1786286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1786297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1786300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1786303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1786306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1786309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786332 */     // MIs[0] policy
     /* 1786332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786342 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1786345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786366 */     // GIR_Coverage, 12055,
     /* 1786366 */     GIR_EraseRootFromParent_Done,
     /* 1786367 */   // Label 24292: @1786367
     /* 1786367 */   GIM_Try, /*On fail goto*//*Label 24293*/ GIMT_Encode4(1786453), // Rule ID 12058 //
     /* 1786372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1786383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1786386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1786389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1786392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786418 */     // MIs[0] policy
     /* 1786418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786428 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1786431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786452 */     // GIR_Coverage, 12058,
     /* 1786452 */     GIR_EraseRootFromParent_Done,
     /* 1786453 */   // Label 24293: @1786453
     /* 1786453 */   GIM_Try, /*On fail goto*//*Label 24294*/ GIMT_Encode4(1786539), // Rule ID 12059 //
     /* 1786458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1786469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1786472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1786475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1786478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786504 */     // MIs[0] policy
     /* 1786504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786514 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1786517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786538 */     // GIR_Coverage, 12059,
     /* 1786538 */     GIR_EraseRootFromParent_Done,
     /* 1786539 */   // Label 24294: @1786539
     /* 1786539 */   GIM_Try, /*On fail goto*//*Label 24295*/ GIMT_Encode4(1786625), // Rule ID 12062 //
     /* 1786544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1786555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1786558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1786561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1786564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786590 */     // MIs[0] policy
     /* 1786590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1786603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786624 */     // GIR_Coverage, 12062,
     /* 1786624 */     GIR_EraseRootFromParent_Done,
     /* 1786625 */   // Label 24295: @1786625
     /* 1786625 */   GIM_Try, /*On fail goto*//*Label 24296*/ GIMT_Encode4(1786711), // Rule ID 12063 //
     /* 1786630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1786641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1786644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1786647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1786650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786676 */     // MIs[0] policy
     /* 1786676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786686 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1786689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786710 */     // GIR_Coverage, 12063,
     /* 1786710 */     GIR_EraseRootFromParent_Done,
     /* 1786711 */   // Label 24296: @1786711
     /* 1786711 */   GIM_Try, /*On fail goto*//*Label 24297*/ GIMT_Encode4(1786797), // Rule ID 12066 //
     /* 1786716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1786719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1786727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1786730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1786733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1786736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786762 */     // MIs[0] policy
     /* 1786762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786772 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1786775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786796 */     // GIR_Coverage, 12066,
     /* 1786796 */     GIR_EraseRootFromParent_Done,
     /* 1786797 */   // Label 24297: @1786797
     /* 1786797 */   GIM_Try, /*On fail goto*//*Label 24298*/ GIMT_Encode4(1786883), // Rule ID 12067 //
     /* 1786802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1786805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1786813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1786816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1786819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1786822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786848 */     // MIs[0] policy
     /* 1786848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786858 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1786861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786882 */     // GIR_Coverage, 12067,
     /* 1786882 */     GIR_EraseRootFromParent_Done,
     /* 1786883 */   // Label 24298: @1786883
     /* 1786883 */   GIM_Try, /*On fail goto*//*Label 24299*/ GIMT_Encode4(1786969), // Rule ID 12070 //
     /* 1786888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1786899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1786902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1786905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1786908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1786911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1786918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786934 */     // MIs[0] policy
     /* 1786934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786944 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1786947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786968 */     // GIR_Coverage, 12070,
     /* 1786968 */     GIR_EraseRootFromParent_Done,
     /* 1786969 */   // Label 24299: @1786969
     /* 1786969 */   GIM_Try, /*On fail goto*//*Label 24300*/ GIMT_Encode4(1787055), // Rule ID 12071 //
     /* 1786974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1786985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1786988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1786991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1786994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1786997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787020 */     // MIs[0] policy
     /* 1787020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787030 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1787033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787054 */     // GIR_Coverage, 12071,
     /* 1787054 */     GIR_EraseRootFromParent_Done,
     /* 1787055 */   // Label 24300: @1787055
     /* 1787055 */   GIM_Try, /*On fail goto*//*Label 24301*/ GIMT_Encode4(1787141), // Rule ID 12074 //
     /* 1787060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1787071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1787074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1787077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1787080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787106 */     // MIs[0] policy
     /* 1787106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787116 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1787119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787140 */     // GIR_Coverage, 12074,
     /* 1787140 */     GIR_EraseRootFromParent_Done,
     /* 1787141 */   // Label 24301: @1787141
     /* 1787141 */   GIM_Try, /*On fail goto*//*Label 24302*/ GIMT_Encode4(1787227), // Rule ID 12075 //
     /* 1787146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1787157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1787160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1787163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1787166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787192 */     // MIs[0] policy
     /* 1787192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787202 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1787205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787226 */     // GIR_Coverage, 12075,
     /* 1787226 */     GIR_EraseRootFromParent_Done,
     /* 1787227 */   // Label 24302: @1787227
     /* 1787227 */   GIM_Try, /*On fail goto*//*Label 24303*/ GIMT_Encode4(1787313), // Rule ID 12078 //
     /* 1787232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1787243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1787246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1787249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1787252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1787255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787278 */     // MIs[0] policy
     /* 1787278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787288 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1787291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787312 */     // GIR_Coverage, 12078,
     /* 1787312 */     GIR_EraseRootFromParent_Done,
     /* 1787313 */   // Label 24303: @1787313
     /* 1787313 */   GIM_Try, /*On fail goto*//*Label 24304*/ GIMT_Encode4(1787399), // Rule ID 12079 //
     /* 1787318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1787329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1787332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1787335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1787338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1787341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787364 */     // MIs[0] policy
     /* 1787364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787374 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1787377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787398 */     // GIR_Coverage, 12079,
     /* 1787398 */     GIR_EraseRootFromParent_Done,
     /* 1787399 */   // Label 24304: @1787399
     /* 1787399 */   GIM_Try, /*On fail goto*//*Label 24305*/ GIMT_Encode4(1787485), // Rule ID 12082 //
     /* 1787404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1787415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1787418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1787421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1787424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787450 */     // MIs[0] policy
     /* 1787450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1787463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787484 */     // GIR_Coverage, 12082,
     /* 1787484 */     GIR_EraseRootFromParent_Done,
     /* 1787485 */   // Label 24305: @1787485
     /* 1787485 */   GIM_Try, /*On fail goto*//*Label 24306*/ GIMT_Encode4(1787571), // Rule ID 12083 //
     /* 1787490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1787501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1787504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1787507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1787510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787536 */     // MIs[0] policy
     /* 1787536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1787549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787570 */     // GIR_Coverage, 12083,
     /* 1787570 */     GIR_EraseRootFromParent_Done,
     /* 1787571 */   // Label 24306: @1787571
     /* 1787571 */   GIM_Try, /*On fail goto*//*Label 24307*/ GIMT_Encode4(1787657), // Rule ID 12086 //
     /* 1787576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1787587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1787590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1787593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1787596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787622 */     // MIs[0] policy
     /* 1787622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787632 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1787635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787656 */     // GIR_Coverage, 12086,
     /* 1787656 */     GIR_EraseRootFromParent_Done,
     /* 1787657 */   // Label 24307: @1787657
     /* 1787657 */   GIM_Try, /*On fail goto*//*Label 24308*/ GIMT_Encode4(1787743), // Rule ID 12087 //
     /* 1787662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1787673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1787676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1787679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1787682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787708 */     // MIs[0] policy
     /* 1787708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787718 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1787721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787742 */     // GIR_Coverage, 12087,
     /* 1787742 */     GIR_EraseRootFromParent_Done,
     /* 1787743 */   // Label 24308: @1787743
     /* 1787743 */   GIM_Try, /*On fail goto*//*Label 24309*/ GIMT_Encode4(1787829), // Rule ID 12090 //
     /* 1787748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1787759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1787762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1787765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1787768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787794 */     // MIs[0] policy
     /* 1787794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787804 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1787807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787828 */     // GIR_Coverage, 12090,
     /* 1787828 */     GIR_EraseRootFromParent_Done,
     /* 1787829 */   // Label 24309: @1787829
     /* 1787829 */   GIM_Try, /*On fail goto*//*Label 24310*/ GIMT_Encode4(1787915), // Rule ID 12091 //
     /* 1787834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1787845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1787848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1787851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1787854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787880 */     // MIs[0] policy
     /* 1787880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787890 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1787893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787914 */     // GIR_Coverage, 12091,
     /* 1787914 */     GIR_EraseRootFromParent_Done,
     /* 1787915 */   // Label 24310: @1787915
     /* 1787915 */   GIM_Try, /*On fail goto*//*Label 24311*/ GIMT_Encode4(1788001), // Rule ID 12094 //
     /* 1787920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1787931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1787934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1787937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1787940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1787943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787966 */     // MIs[0] policy
     /* 1787966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787976 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1787979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788000 */     // GIR_Coverage, 12094,
     /* 1788000 */     GIR_EraseRootFromParent_Done,
     /* 1788001 */   // Label 24311: @1788001
     /* 1788001 */   GIM_Try, /*On fail goto*//*Label 24312*/ GIMT_Encode4(1788087), // Rule ID 12095 //
     /* 1788006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1788017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1788020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1788023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1788026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788052 */     // MIs[0] policy
     /* 1788052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1788065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788086 */     // GIR_Coverage, 12095,
     /* 1788086 */     GIR_EraseRootFromParent_Done,
     /* 1788087 */   // Label 24312: @1788087
     /* 1788087 */   GIM_Try, /*On fail goto*//*Label 24313*/ GIMT_Encode4(1788173), // Rule ID 12098 //
     /* 1788092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1788103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1788106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1788109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1788112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788138 */     // MIs[0] policy
     /* 1788138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788148 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1788151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788172 */     // GIR_Coverage, 12098,
     /* 1788172 */     GIR_EraseRootFromParent_Done,
     /* 1788173 */   // Label 24313: @1788173
     /* 1788173 */   GIM_Try, /*On fail goto*//*Label 24314*/ GIMT_Encode4(1788259), // Rule ID 12099 //
     /* 1788178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1788189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1788192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1788195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1788198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788224 */     // MIs[0] policy
     /* 1788224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788234 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1788237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788258 */     // GIR_Coverage, 12099,
     /* 1788258 */     GIR_EraseRootFromParent_Done,
     /* 1788259 */   // Label 24314: @1788259
     /* 1788259 */   GIM_Try, /*On fail goto*//*Label 24315*/ GIMT_Encode4(1788345), // Rule ID 12102 //
     /* 1788264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1788275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1788278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1788281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1788284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788310 */     // MIs[0] policy
     /* 1788310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788320 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1788323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788344 */     // GIR_Coverage, 12102,
     /* 1788344 */     GIR_EraseRootFromParent_Done,
     /* 1788345 */   // Label 24315: @1788345
     /* 1788345 */   GIM_Try, /*On fail goto*//*Label 24316*/ GIMT_Encode4(1788431), // Rule ID 12103 //
     /* 1788350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1788361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1788364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1788367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1788370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788396 */     // MIs[0] policy
     /* 1788396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788406 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1788409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788430 */     // GIR_Coverage, 12103,
     /* 1788430 */     GIR_EraseRootFromParent_Done,
     /* 1788431 */   // Label 24316: @1788431
     /* 1788431 */   GIM_Try, /*On fail goto*//*Label 24317*/ GIMT_Encode4(1788517), // Rule ID 12106 //
     /* 1788436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1788447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1788450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1788453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1788456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788482 */     // MIs[0] policy
     /* 1788482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788492 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1788495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788516 */     // GIR_Coverage, 12106,
     /* 1788516 */     GIR_EraseRootFromParent_Done,
     /* 1788517 */   // Label 24317: @1788517
     /* 1788517 */   GIM_Try, /*On fail goto*//*Label 24318*/ GIMT_Encode4(1788603), // Rule ID 12107 //
     /* 1788522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1788533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1788536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1788539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1788542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788568 */     // MIs[0] policy
     /* 1788568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1788581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788602 */     // GIR_Coverage, 12107,
     /* 1788602 */     GIR_EraseRootFromParent_Done,
     /* 1788603 */   // Label 24318: @1788603
     /* 1788603 */   GIM_Try, /*On fail goto*//*Label 24319*/ GIMT_Encode4(1788689), // Rule ID 12110 //
     /* 1788608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1788619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1788622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1788625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1788628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788654 */     // MIs[0] policy
     /* 1788654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1788667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788688 */     // GIR_Coverage, 12110,
     /* 1788688 */     GIR_EraseRootFromParent_Done,
     /* 1788689 */   // Label 24319: @1788689
     /* 1788689 */   GIM_Try, /*On fail goto*//*Label 24320*/ GIMT_Encode4(1788775), // Rule ID 12111 //
     /* 1788694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1788705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1788708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1788711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1788714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788740 */     // MIs[0] policy
     /* 1788740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788750 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1788753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788774 */     // GIR_Coverage, 12111,
     /* 1788774 */     GIR_EraseRootFromParent_Done,
     /* 1788775 */   // Label 24320: @1788775
     /* 1788775 */   GIM_Try, /*On fail goto*//*Label 24321*/ GIMT_Encode4(1788861), // Rule ID 12114 //
     /* 1788780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1788791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1788794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1788797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1788800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788826 */     // MIs[0] policy
     /* 1788826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788836 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1788839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788860 */     // GIR_Coverage, 12114,
     /* 1788860 */     GIR_EraseRootFromParent_Done,
     /* 1788861 */   // Label 24321: @1788861
     /* 1788861 */   GIM_Try, /*On fail goto*//*Label 24322*/ GIMT_Encode4(1788947), // Rule ID 12115 //
     /* 1788866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1788877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1788880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1788883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1788886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788912 */     // MIs[0] policy
     /* 1788912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788922 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1788925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788946 */     // GIR_Coverage, 12115,
     /* 1788946 */     GIR_EraseRootFromParent_Done,
     /* 1788947 */   // Label 24322: @1788947
     /* 1788947 */   GIM_Try, /*On fail goto*//*Label 24323*/ GIMT_Encode4(1789033), // Rule ID 12118 //
     /* 1788952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1788963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1788966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1788969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1788975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788998 */     // MIs[0] policy
     /* 1788998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789008 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1789011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789032 */     // GIR_Coverage, 12118,
     /* 1789032 */     GIR_EraseRootFromParent_Done,
     /* 1789033 */   // Label 24323: @1789033
     /* 1789033 */   GIM_Try, /*On fail goto*//*Label 24324*/ GIMT_Encode4(1789119), // Rule ID 12119 //
     /* 1789038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1789049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1789052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1789055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789084 */     // MIs[0] policy
     /* 1789084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789094 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1789097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789118 */     // GIR_Coverage, 12119,
     /* 1789118 */     GIR_EraseRootFromParent_Done,
     /* 1789119 */   // Label 24324: @1789119
     /* 1789119 */   GIM_Try, /*On fail goto*//*Label 24325*/ GIMT_Encode4(1789205), // Rule ID 12122 //
     /* 1789124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1789135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1789138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1789141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789170 */     // MIs[0] policy
     /* 1789170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789180 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1789183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789204 */     // GIR_Coverage, 12122,
     /* 1789204 */     GIR_EraseRootFromParent_Done,
     /* 1789205 */   // Label 24325: @1789205
     /* 1789205 */   GIM_Try, /*On fail goto*//*Label 24326*/ GIMT_Encode4(1789291), // Rule ID 12123 //
     /* 1789210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1789221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1789224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1789227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789256 */     // MIs[0] policy
     /* 1789256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789266 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1789269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789290 */     // GIR_Coverage, 12123,
     /* 1789290 */     GIR_EraseRootFromParent_Done,
     /* 1789291 */   // Label 24326: @1789291
     /* 1789291 */   GIM_Try, /*On fail goto*//*Label 24327*/ GIMT_Encode4(1789377), // Rule ID 12126 //
     /* 1789296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1789307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1789310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1789313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789342 */     // MIs[0] policy
     /* 1789342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1789355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789376 */     // GIR_Coverage, 12126,
     /* 1789376 */     GIR_EraseRootFromParent_Done,
     /* 1789377 */   // Label 24327: @1789377
     /* 1789377 */   GIM_Try, /*On fail goto*//*Label 24328*/ GIMT_Encode4(1789463), // Rule ID 12127 //
     /* 1789382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1789393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1789396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1789399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789428 */     // MIs[0] policy
     /* 1789428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789438 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1789441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789462 */     // GIR_Coverage, 12127,
     /* 1789462 */     GIR_EraseRootFromParent_Done,
     /* 1789463 */   // Label 24328: @1789463
     /* 1789463 */   GIM_Try, /*On fail goto*//*Label 24329*/ GIMT_Encode4(1789549), // Rule ID 12130 //
     /* 1789468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1789479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1789482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1789485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789514 */     // MIs[0] policy
     /* 1789514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789524 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1789527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789548 */     // GIR_Coverage, 12130,
     /* 1789548 */     GIR_EraseRootFromParent_Done,
     /* 1789549 */   // Label 24329: @1789549
     /* 1789549 */   GIM_Try, /*On fail goto*//*Label 24330*/ GIMT_Encode4(1789635), // Rule ID 12131 //
     /* 1789554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1789565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1789568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1789571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789600 */     // MIs[0] policy
     /* 1789600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789610 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1789613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789634 */     // GIR_Coverage, 12131,
     /* 1789634 */     GIR_EraseRootFromParent_Done,
     /* 1789635 */   // Label 24330: @1789635
     /* 1789635 */   GIM_Try, /*On fail goto*//*Label 24331*/ GIMT_Encode4(1789721), // Rule ID 12134 //
     /* 1789640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1789651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1789654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1789657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789686 */     // MIs[0] policy
     /* 1789686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1789699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789720 */     // GIR_Coverage, 12134,
     /* 1789720 */     GIR_EraseRootFromParent_Done,
     /* 1789721 */   // Label 24331: @1789721
     /* 1789721 */   GIM_Try, /*On fail goto*//*Label 24332*/ GIMT_Encode4(1789807), // Rule ID 12135 //
     /* 1789726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1789737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1789740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1789743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789772 */     // MIs[0] policy
     /* 1789772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789782 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1789785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789806 */     // GIR_Coverage, 12135,
     /* 1789806 */     GIR_EraseRootFromParent_Done,
     /* 1789807 */   // Label 24332: @1789807
     /* 1789807 */   GIM_Try, /*On fail goto*//*Label 24333*/ GIMT_Encode4(1789893), // Rule ID 12138 //
     /* 1789812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1789823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1789826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1789829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789858 */     // MIs[0] policy
     /* 1789858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1789871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789892 */     // GIR_Coverage, 12138,
     /* 1789892 */     GIR_EraseRootFromParent_Done,
     /* 1789893 */   // Label 24333: @1789893
     /* 1789893 */   GIM_Try, /*On fail goto*//*Label 24334*/ GIMT_Encode4(1789979), // Rule ID 12139 //
     /* 1789898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1789909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1789912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1789915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789944 */     // MIs[0] policy
     /* 1789944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789954 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1789957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789978 */     // GIR_Coverage, 12139,
     /* 1789978 */     GIR_EraseRootFromParent_Done,
     /* 1789979 */   // Label 24334: @1789979
     /* 1789979 */   GIM_Try, /*On fail goto*//*Label 24335*/ GIMT_Encode4(1790065), // Rule ID 12142 //
     /* 1789984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1789995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1789998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1790001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790030 */     // MIs[0] policy
     /* 1790030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1790043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790064 */     // GIR_Coverage, 12142,
     /* 1790064 */     GIR_EraseRootFromParent_Done,
     /* 1790065 */   // Label 24335: @1790065
     /* 1790065 */   GIM_Try, /*On fail goto*//*Label 24336*/ GIMT_Encode4(1790151), // Rule ID 12143 //
     /* 1790070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1790081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1790084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1790087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790116 */     // MIs[0] policy
     /* 1790116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790126 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1790129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790150 */     // GIR_Coverage, 12143,
     /* 1790150 */     GIR_EraseRootFromParent_Done,
     /* 1790151 */   // Label 24336: @1790151
     /* 1790151 */   GIM_Try, /*On fail goto*//*Label 24337*/ GIMT_Encode4(1790237), // Rule ID 12146 //
     /* 1790156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1790167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1790170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1790173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1790179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790202 */     // MIs[0] policy
     /* 1790202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790212 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1790215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790236 */     // GIR_Coverage, 12146,
     /* 1790236 */     GIR_EraseRootFromParent_Done,
     /* 1790237 */   // Label 24337: @1790237
     /* 1790237 */   GIM_Try, /*On fail goto*//*Label 24338*/ GIMT_Encode4(1790323), // Rule ID 12147 //
     /* 1790242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1790253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1790256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1790259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1790265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790288 */     // MIs[0] policy
     /* 1790288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790298 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1790301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790322 */     // GIR_Coverage, 12147,
     /* 1790322 */     GIR_EraseRootFromParent_Done,
     /* 1790323 */   // Label 24338: @1790323
     /* 1790323 */   GIM_Try, /*On fail goto*//*Label 24339*/ GIMT_Encode4(1790409), // Rule ID 12150 //
     /* 1790328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1790339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1790342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1790345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790374 */     // MIs[0] policy
     /* 1790374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790384 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1790387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1790405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790408 */     // GIR_Coverage, 12150,
     /* 1790408 */     GIR_EraseRootFromParent_Done,
     /* 1790409 */   // Label 24339: @1790409
     /* 1790409 */   GIM_Try, /*On fail goto*//*Label 24340*/ GIMT_Encode4(1790495), // Rule ID 12151 //
     /* 1790414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1790425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1790428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1790431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790460 */     // MIs[0] policy
     /* 1790460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790470 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1790473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1790491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790494 */     // GIR_Coverage, 12151,
     /* 1790494 */     GIR_EraseRootFromParent_Done,
     /* 1790495 */   // Label 24340: @1790495
     /* 1790495 */   GIM_Try, /*On fail goto*//*Label 24341*/ GIMT_Encode4(1790581), // Rule ID 12154 //
     /* 1790500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1790503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1790511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1790514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1790517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790546 */     // MIs[0] policy
     /* 1790546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790556 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1790559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790580 */     // GIR_Coverage, 12154,
     /* 1790580 */     GIR_EraseRootFromParent_Done,
     /* 1790581 */   // Label 24341: @1790581
     /* 1790581 */   GIM_Try, /*On fail goto*//*Label 24342*/ GIMT_Encode4(1790667), // Rule ID 12155 //
     /* 1790586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1790589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1790597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1790600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1790603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790632 */     // MIs[0] policy
     /* 1790632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790642 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1790645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790666 */     // GIR_Coverage, 12155,
     /* 1790666 */     GIR_EraseRootFromParent_Done,
     /* 1790667 */   // Label 24342: @1790667
     /* 1790667 */   GIM_Try, /*On fail goto*//*Label 24343*/ GIMT_Encode4(1790753), // Rule ID 12158 //
     /* 1790672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1790683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1790686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1790689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790718 */     // MIs[0] policy
     /* 1790718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790728 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1790731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790752 */     // GIR_Coverage, 12158,
     /* 1790752 */     GIR_EraseRootFromParent_Done,
     /* 1790753 */   // Label 24343: @1790753
     /* 1790753 */   GIM_Try, /*On fail goto*//*Label 24344*/ GIMT_Encode4(1790839), // Rule ID 12159 //
     /* 1790758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1790769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1790772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1790775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790804 */     // MIs[0] policy
     /* 1790804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790814 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1790817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790838 */     // GIR_Coverage, 12159,
     /* 1790838 */     GIR_EraseRootFromParent_Done,
     /* 1790839 */   // Label 24344: @1790839
     /* 1790839 */   GIM_Try, /*On fail goto*//*Label 24345*/ GIMT_Encode4(1790925), // Rule ID 12162 //
     /* 1790844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1790855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1790858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1790861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1790867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790890 */     // MIs[0] policy
     /* 1790890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790900 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1790903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790924 */     // GIR_Coverage, 12162,
     /* 1790924 */     GIR_EraseRootFromParent_Done,
     /* 1790925 */   // Label 24345: @1790925
     /* 1790925 */   GIM_Try, /*On fail goto*//*Label 24346*/ GIMT_Encode4(1791011), // Rule ID 12163 //
     /* 1790930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1790941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1790944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1790947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1790953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790976 */     // MIs[0] policy
     /* 1790976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790986 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1790989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791010 */     // GIR_Coverage, 12163,
     /* 1791010 */     GIR_EraseRootFromParent_Done,
     /* 1791011 */   // Label 24346: @1791011
     /* 1791011 */   GIM_Try, /*On fail goto*//*Label 24347*/ GIMT_Encode4(1791097), // Rule ID 12166 //
     /* 1791016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1791027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1791030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1791033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1791039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791062 */     // MIs[0] policy
     /* 1791062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791072 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1791075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791096 */     // GIR_Coverage, 12166,
     /* 1791096 */     GIR_EraseRootFromParent_Done,
     /* 1791097 */   // Label 24347: @1791097
     /* 1791097 */   GIM_Try, /*On fail goto*//*Label 24348*/ GIMT_Encode4(1791183), // Rule ID 12167 //
     /* 1791102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1791113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1791116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1791119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1791125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791148 */     // MIs[0] policy
     /* 1791148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791158 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1791161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791182 */     // GIR_Coverage, 12167,
     /* 1791182 */     GIR_EraseRootFromParent_Done,
     /* 1791183 */   // Label 24348: @1791183
     /* 1791183 */   GIM_Try, /*On fail goto*//*Label 24349*/ GIMT_Encode4(1791269), // Rule ID 12170 //
     /* 1791188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1791199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1791202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1791205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791234 */     // MIs[0] policy
     /* 1791234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791244 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1791247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791268 */     // GIR_Coverage, 12170,
     /* 1791268 */     GIR_EraseRootFromParent_Done,
     /* 1791269 */   // Label 24349: @1791269
     /* 1791269 */   GIM_Try, /*On fail goto*//*Label 24350*/ GIMT_Encode4(1791355), // Rule ID 12171 //
     /* 1791274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1791285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1791288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1791291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791320 */     // MIs[0] policy
     /* 1791320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791330 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1791333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791354 */     // GIR_Coverage, 12171,
     /* 1791354 */     GIR_EraseRootFromParent_Done,
     /* 1791355 */   // Label 24350: @1791355
     /* 1791355 */   GIM_Try, /*On fail goto*//*Label 24351*/ GIMT_Encode4(1791441), // Rule ID 12174 //
     /* 1791360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1791371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1791374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1791377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791406 */     // MIs[0] policy
     /* 1791406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791416 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1791419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791440 */     // GIR_Coverage, 12174,
     /* 1791440 */     GIR_EraseRootFromParent_Done,
     /* 1791441 */   // Label 24351: @1791441
     /* 1791441 */   GIM_Try, /*On fail goto*//*Label 24352*/ GIMT_Encode4(1791527), // Rule ID 12175 //
     /* 1791446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1791457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1791460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1791463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791492 */     // MIs[0] policy
     /* 1791492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791502 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1791505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791526 */     // GIR_Coverage, 12175,
     /* 1791526 */     GIR_EraseRootFromParent_Done,
     /* 1791527 */   // Label 24352: @1791527
     /* 1791527 */   GIM_Try, /*On fail goto*//*Label 24353*/ GIMT_Encode4(1791613), // Rule ID 12178 //
     /* 1791532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1791543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1791546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1791549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791578 */     // MIs[0] policy
     /* 1791578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791588 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1791591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791612 */     // GIR_Coverage, 12178,
     /* 1791612 */     GIR_EraseRootFromParent_Done,
     /* 1791613 */   // Label 24353: @1791613
     /* 1791613 */   GIM_Try, /*On fail goto*//*Label 24354*/ GIMT_Encode4(1791699), // Rule ID 12179 //
     /* 1791618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1791629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1791632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1791635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791664 */     // MIs[0] policy
     /* 1791664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791674 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1791677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791698 */     // GIR_Coverage, 12179,
     /* 1791698 */     GIR_EraseRootFromParent_Done,
     /* 1791699 */   // Label 24354: @1791699
     /* 1791699 */   GIM_Try, /*On fail goto*//*Label 24355*/ GIMT_Encode4(1791785), // Rule ID 12182 //
     /* 1791704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1791715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1791718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1791721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791750 */     // MIs[0] policy
     /* 1791750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1791763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791784 */     // GIR_Coverage, 12182,
     /* 1791784 */     GIR_EraseRootFromParent_Done,
     /* 1791785 */   // Label 24355: @1791785
     /* 1791785 */   GIM_Try, /*On fail goto*//*Label 24356*/ GIMT_Encode4(1791871), // Rule ID 12183 //
     /* 1791790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1791801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1791804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1791807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791836 */     // MIs[0] policy
     /* 1791836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791846 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1791849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791870 */     // GIR_Coverage, 12183,
     /* 1791870 */     GIR_EraseRootFromParent_Done,
     /* 1791871 */   // Label 24356: @1791871
     /* 1791871 */   GIM_Try, /*On fail goto*//*Label 24357*/ GIMT_Encode4(1791957), // Rule ID 12186 //
     /* 1791876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1791887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1791890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1791893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791922 */     // MIs[0] policy
     /* 1791922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791932 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1791935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791956 */     // GIR_Coverage, 12186,
     /* 1791956 */     GIR_EraseRootFromParent_Done,
     /* 1791957 */   // Label 24357: @1791957
     /* 1791957 */   GIM_Try, /*On fail goto*//*Label 24358*/ GIMT_Encode4(1792043), // Rule ID 12187 //
     /* 1791962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1791973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1791976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1791979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792008 */     // MIs[0] policy
     /* 1792008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792018 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1792021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792042 */     // GIR_Coverage, 12187,
     /* 1792042 */     GIR_EraseRootFromParent_Done,
     /* 1792043 */   // Label 24358: @1792043
     /* 1792043 */   GIM_Try, /*On fail goto*//*Label 24359*/ GIMT_Encode4(1792129), // Rule ID 12190 //
     /* 1792048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1792059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1792062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1792065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1792071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792094 */     // MIs[0] policy
     /* 1792094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792104 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1792107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792128 */     // GIR_Coverage, 12190,
     /* 1792128 */     GIR_EraseRootFromParent_Done,
     /* 1792129 */   // Label 24359: @1792129
     /* 1792129 */   GIM_Try, /*On fail goto*//*Label 24360*/ GIMT_Encode4(1792215), // Rule ID 12191 //
     /* 1792134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1792145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1792148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1792151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1792157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792180 */     // MIs[0] policy
     /* 1792180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792190 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1792193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792214 */     // GIR_Coverage, 12191,
     /* 1792214 */     GIR_EraseRootFromParent_Done,
     /* 1792215 */   // Label 24360: @1792215
     /* 1792215 */   GIM_Try, /*On fail goto*//*Label 24361*/ GIMT_Encode4(1792301), // Rule ID 12194 //
     /* 1792220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1792223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1792231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1792234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1792237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792266 */     // MIs[0] policy
     /* 1792266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1792279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792300 */     // GIR_Coverage, 12194,
     /* 1792300 */     GIR_EraseRootFromParent_Done,
     /* 1792301 */   // Label 24361: @1792301
     /* 1792301 */   GIM_Try, /*On fail goto*//*Label 24362*/ GIMT_Encode4(1792387), // Rule ID 12195 //
     /* 1792306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1792317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1792320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1792323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792352 */     // MIs[0] policy
     /* 1792352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792362 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1792365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792386 */     // GIR_Coverage, 12195,
     /* 1792386 */     GIR_EraseRootFromParent_Done,
     /* 1792387 */   // Label 24362: @1792387
     /* 1792387 */   GIM_Try, /*On fail goto*//*Label 24363*/ GIMT_Encode4(1792473), // Rule ID 12198 //
     /* 1792392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1792395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1792403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1792406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1792409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792438 */     // MIs[0] policy
     /* 1792438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1792451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792472 */     // GIR_Coverage, 12198,
     /* 1792472 */     GIR_EraseRootFromParent_Done,
     /* 1792473 */   // Label 24363: @1792473
     /* 1792473 */   GIM_Try, /*On fail goto*//*Label 24364*/ GIMT_Encode4(1792559), // Rule ID 12199 //
     /* 1792478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1792489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1792492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1792495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792524 */     // MIs[0] policy
     /* 1792524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792534 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1792537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792558 */     // GIR_Coverage, 12199,
     /* 1792558 */     GIR_EraseRootFromParent_Done,
     /* 1792559 */   // Label 24364: @1792559
     /* 1792559 */   GIM_Try, /*On fail goto*//*Label 24365*/ GIMT_Encode4(1792645), // Rule ID 12202 //
     /* 1792564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1792567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1792575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1792578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1792581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792610 */     // MIs[0] policy
     /* 1792610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792620 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1792623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792644 */     // GIR_Coverage, 12202,
     /* 1792644 */     GIR_EraseRootFromParent_Done,
     /* 1792645 */   // Label 24365: @1792645
     /* 1792645 */   GIM_Try, /*On fail goto*//*Label 24366*/ GIMT_Encode4(1792731), // Rule ID 12203 //
     /* 1792650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1792661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1792664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1792667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792696 */     // MIs[0] policy
     /* 1792696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792706 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1792709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792730 */     // GIR_Coverage, 12203,
     /* 1792730 */     GIR_EraseRootFromParent_Done,
     /* 1792731 */   // Label 24366: @1792731
     /* 1792731 */   GIM_Try, /*On fail goto*//*Label 24367*/ GIMT_Encode4(1792817), // Rule ID 12206 //
     /* 1792736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1792747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1792750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1792753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1792756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792782 */     // MIs[0] policy
     /* 1792782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792792 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1792795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792816 */     // GIR_Coverage, 12206,
     /* 1792816 */     GIR_EraseRootFromParent_Done,
     /* 1792817 */   // Label 24367: @1792817
     /* 1792817 */   GIM_Try, /*On fail goto*//*Label 24368*/ GIMT_Encode4(1792903), // Rule ID 12207 //
     /* 1792822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1792833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1792836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1792839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1792842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792868 */     // MIs[0] policy
     /* 1792868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792878 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1792881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792902 */     // GIR_Coverage, 12207,
     /* 1792902 */     GIR_EraseRootFromParent_Done,
     /* 1792903 */   // Label 24368: @1792903
     /* 1792903 */   GIM_Try, /*On fail goto*//*Label 24369*/ GIMT_Encode4(1792989), // Rule ID 12210 //
     /* 1792908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1792919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1792922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1792925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1792928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792954 */     // MIs[0] policy
     /* 1792954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792964 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1792967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792988 */     // GIR_Coverage, 12210,
     /* 1792988 */     GIR_EraseRootFromParent_Done,
     /* 1792989 */   // Label 24369: @1792989
     /* 1792989 */   GIM_Try, /*On fail goto*//*Label 24370*/ GIMT_Encode4(1793075), // Rule ID 12211 //
     /* 1792994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1793005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1793008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1793011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1793014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793040 */     // MIs[0] policy
     /* 1793040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793050 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1793053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793074 */     // GIR_Coverage, 12211,
     /* 1793074 */     GIR_EraseRootFromParent_Done,
     /* 1793075 */   // Label 24370: @1793075
     /* 1793075 */   GIM_Try, /*On fail goto*//*Label 24371*/ GIMT_Encode4(1793161), // Rule ID 12214 //
     /* 1793080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1793091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1793094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1793097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1793100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793126 */     // MIs[0] policy
     /* 1793126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793136 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1793139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793160 */     // GIR_Coverage, 12214,
     /* 1793160 */     GIR_EraseRootFromParent_Done,
     /* 1793161 */   // Label 24371: @1793161
     /* 1793161 */   GIM_Try, /*On fail goto*//*Label 24372*/ GIMT_Encode4(1793247), // Rule ID 12215 //
     /* 1793166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1793177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1793180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1793183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1793186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793212 */     // MIs[0] policy
     /* 1793212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793222 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1793225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793246 */     // GIR_Coverage, 12215,
     /* 1793246 */     GIR_EraseRootFromParent_Done,
     /* 1793247 */   // Label 24372: @1793247
     /* 1793247 */   GIM_Try, /*On fail goto*//*Label 24373*/ GIMT_Encode4(1793333), // Rule ID 12218 //
     /* 1793252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1793263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1793266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1793269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1793272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793298 */     // MIs[0] policy
     /* 1793298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793308 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1793311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793332 */     // GIR_Coverage, 12218,
     /* 1793332 */     GIR_EraseRootFromParent_Done,
     /* 1793333 */   // Label 24373: @1793333
     /* 1793333 */   GIM_Try, /*On fail goto*//*Label 24374*/ GIMT_Encode4(1793419), // Rule ID 12219 //
     /* 1793338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1793349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1793352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1793355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1793358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793384 */     // MIs[0] policy
     /* 1793384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793394 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1793397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793418 */     // GIR_Coverage, 12219,
     /* 1793418 */     GIR_EraseRootFromParent_Done,
     /* 1793419 */   // Label 24374: @1793419
     /* 1793419 */   GIM_Try, /*On fail goto*//*Label 24375*/ GIMT_Encode4(1793505), // Rule ID 12222 //
     /* 1793424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1793435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1793438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1793441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1793444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793470 */     // MIs[0] policy
     /* 1793470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793480 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1793483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793504 */     // GIR_Coverage, 12222,
     /* 1793504 */     GIR_EraseRootFromParent_Done,
     /* 1793505 */   // Label 24375: @1793505
     /* 1793505 */   GIM_Try, /*On fail goto*//*Label 24376*/ GIMT_Encode4(1793591), // Rule ID 12223 //
     /* 1793510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1793521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1793524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1793527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1793530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793556 */     // MIs[0] policy
     /* 1793556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793566 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1793569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793590 */     // GIR_Coverage, 12223,
     /* 1793590 */     GIR_EraseRootFromParent_Done,
     /* 1793591 */   // Label 24376: @1793591
     /* 1793591 */   GIM_Try, /*On fail goto*//*Label 24377*/ GIMT_Encode4(1793677), // Rule ID 12226 //
     /* 1793596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1793607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1793610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1793613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1793616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793642 */     // MIs[0] policy
     /* 1793642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1793655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793676 */     // GIR_Coverage, 12226,
     /* 1793676 */     GIR_EraseRootFromParent_Done,
     /* 1793677 */   // Label 24377: @1793677
     /* 1793677 */   GIM_Try, /*On fail goto*//*Label 24378*/ GIMT_Encode4(1793763), // Rule ID 12227 //
     /* 1793682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1793693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1793696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1793699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1793702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793728 */     // MIs[0] policy
     /* 1793728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793738 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1793741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793762 */     // GIR_Coverage, 12227,
     /* 1793762 */     GIR_EraseRootFromParent_Done,
     /* 1793763 */   // Label 24378: @1793763
     /* 1793763 */   GIM_Try, /*On fail goto*//*Label 24379*/ GIMT_Encode4(1793849), // Rule ID 12230 //
     /* 1793768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1793779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1793782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1793785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1793788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793814 */     // MIs[0] policy
     /* 1793814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1793827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793848 */     // GIR_Coverage, 12230,
     /* 1793848 */     GIR_EraseRootFromParent_Done,
     /* 1793849 */   // Label 24379: @1793849
     /* 1793849 */   GIM_Try, /*On fail goto*//*Label 24380*/ GIMT_Encode4(1793935), // Rule ID 12231 //
     /* 1793854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1793865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1793868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1793871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1793874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793900 */     // MIs[0] policy
     /* 1793900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793910 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1793913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793934 */     // GIR_Coverage, 12231,
     /* 1793934 */     GIR_EraseRootFromParent_Done,
     /* 1793935 */   // Label 24380: @1793935
     /* 1793935 */   GIM_Try, /*On fail goto*//*Label 24381*/ GIMT_Encode4(1794021), // Rule ID 12234 //
     /* 1793940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1793951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1793954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1793957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1793960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793986 */     // MIs[0] policy
     /* 1793986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1793999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794020 */     // GIR_Coverage, 12234,
     /* 1794020 */     GIR_EraseRootFromParent_Done,
     /* 1794021 */   // Label 24381: @1794021
     /* 1794021 */   GIM_Try, /*On fail goto*//*Label 24382*/ GIMT_Encode4(1794107), // Rule ID 12235 //
     /* 1794026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1794037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1794040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1794043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1794046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1794049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794072 */     // MIs[0] policy
     /* 1794072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794082 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1794085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794106 */     // GIR_Coverage, 12235,
     /* 1794106 */     GIR_EraseRootFromParent_Done,
     /* 1794107 */   // Label 24382: @1794107
     /* 1794107 */   GIM_Try, /*On fail goto*//*Label 24383*/ GIMT_Encode4(1794193), // Rule ID 12238 //
     /* 1794112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1794123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1794126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1794129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1794132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1794135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794158 */     // MIs[0] policy
     /* 1794158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794168 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1794171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1794189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794192 */     // GIR_Coverage, 12238,
     /* 1794192 */     GIR_EraseRootFromParent_Done,
     /* 1794193 */   // Label 24383: @1794193
     /* 1794193 */   GIM_Try, /*On fail goto*//*Label 24384*/ GIMT_Encode4(1794279), // Rule ID 12239 //
     /* 1794198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1794209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1794212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1794215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1794218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1794221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794244 */     // MIs[0] policy
     /* 1794244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794254 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1794257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1794275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794278 */     // GIR_Coverage, 12239,
     /* 1794278 */     GIR_EraseRootFromParent_Done,
     /* 1794279 */   // Label 24384: @1794279
     /* 1794279 */   GIM_Try, /*On fail goto*//*Label 24385*/ GIMT_Encode4(1794365), // Rule ID 12242 //
     /* 1794284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1794287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1794295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1794298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1794301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1794304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794330 */     // MIs[0] policy
     /* 1794330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794340 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1794343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1794361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794364 */     // GIR_Coverage, 12242,
     /* 1794364 */     GIR_EraseRootFromParent_Done,
     /* 1794365 */   // Label 24385: @1794365
     /* 1794365 */   GIM_Try, /*On fail goto*//*Label 24386*/ GIMT_Encode4(1794451), // Rule ID 12243 //
     /* 1794370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1794373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1794381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1794384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1794387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1794390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794416 */     // MIs[0] policy
     /* 1794416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794426 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1794429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1794447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794450 */     // GIR_Coverage, 12243,
     /* 1794450 */     GIR_EraseRootFromParent_Done,
     /* 1794451 */   // Label 24386: @1794451
     /* 1794451 */   GIM_Try, /*On fail goto*//*Label 24387*/ GIMT_Encode4(1794537), // Rule ID 12246 //
     /* 1794456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1794467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1794470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1794473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1794476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794502 */     // MIs[0] policy
     /* 1794502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794512 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1794515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794536 */     // GIR_Coverage, 12246,
     /* 1794536 */     GIR_EraseRootFromParent_Done,
     /* 1794537 */   // Label 24387: @1794537
     /* 1794537 */   GIM_Try, /*On fail goto*//*Label 24388*/ GIMT_Encode4(1794623), // Rule ID 12247 //
     /* 1794542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1794553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1794556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1794559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1794562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794588 */     // MIs[0] policy
     /* 1794588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794598 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1794601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794622 */     // GIR_Coverage, 12247,
     /* 1794622 */     GIR_EraseRootFromParent_Done,
     /* 1794623 */   // Label 24388: @1794623
     /* 1794623 */   GIM_Try, /*On fail goto*//*Label 24389*/ GIMT_Encode4(1794709), // Rule ID 12250 //
     /* 1794628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1794639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1794642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1794645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1794648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794674 */     // MIs[0] policy
     /* 1794674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794684 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1794687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794708 */     // GIR_Coverage, 12250,
     /* 1794708 */     GIR_EraseRootFromParent_Done,
     /* 1794709 */   // Label 24389: @1794709
     /* 1794709 */   GIM_Try, /*On fail goto*//*Label 24390*/ GIMT_Encode4(1794795), // Rule ID 12251 //
     /* 1794714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1794725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1794728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1794731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1794734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794760 */     // MIs[0] policy
     /* 1794760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794770 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1794773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794794 */     // GIR_Coverage, 12251,
     /* 1794794 */     GIR_EraseRootFromParent_Done,
     /* 1794795 */   // Label 24390: @1794795
     /* 1794795 */   GIM_Try, /*On fail goto*//*Label 24391*/ GIMT_Encode4(1794881), // Rule ID 12254 //
     /* 1794800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1794811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1794814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1794817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1794820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1794823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794846 */     // MIs[0] policy
     /* 1794846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794856 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1794859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794880 */     // GIR_Coverage, 12254,
     /* 1794880 */     GIR_EraseRootFromParent_Done,
     /* 1794881 */   // Label 24391: @1794881
     /* 1794881 */   GIM_Try, /*On fail goto*//*Label 24392*/ GIMT_Encode4(1794967), // Rule ID 12255 //
     /* 1794886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1794897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1794900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1794903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1794906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1794909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794932 */     // MIs[0] policy
     /* 1794932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794942 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1794945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794966 */     // GIR_Coverage, 12255,
     /* 1794966 */     GIR_EraseRootFromParent_Done,
     /* 1794967 */   // Label 24392: @1794967
     /* 1794967 */   GIM_Try, /*On fail goto*//*Label 24393*/ GIMT_Encode4(1795053), // Rule ID 12258 //
     /* 1794972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1794983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1794986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1794989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1794992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795018 */     // MIs[0] policy
     /* 1795018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795028 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1795031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795052 */     // GIR_Coverage, 12258,
     /* 1795052 */     GIR_EraseRootFromParent_Done,
     /* 1795053 */   // Label 24393: @1795053
     /* 1795053 */   GIM_Try, /*On fail goto*//*Label 24394*/ GIMT_Encode4(1795139), // Rule ID 12259 //
     /* 1795058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1795069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1795072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1795075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1795078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795104 */     // MIs[0] policy
     /* 1795104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1795117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795138 */     // GIR_Coverage, 12259,
     /* 1795138 */     GIR_EraseRootFromParent_Done,
     /* 1795139 */   // Label 24394: @1795139
     /* 1795139 */   GIM_Try, /*On fail goto*//*Label 24395*/ GIMT_Encode4(1795225), // Rule ID 12262 //
     /* 1795144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1795155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1795158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1795161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1795164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795190 */     // MIs[0] policy
     /* 1795190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795200 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1795203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795224 */     // GIR_Coverage, 12262,
     /* 1795224 */     GIR_EraseRootFromParent_Done,
     /* 1795225 */   // Label 24395: @1795225
     /* 1795225 */   GIM_Try, /*On fail goto*//*Label 24396*/ GIMT_Encode4(1795311), // Rule ID 12263 //
     /* 1795230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1795241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1795244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1795247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1795250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795276 */     // MIs[0] policy
     /* 1795276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795286 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1795289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795310 */     // GIR_Coverage, 12263,
     /* 1795310 */     GIR_EraseRootFromParent_Done,
     /* 1795311 */   // Label 24396: @1795311
     /* 1795311 */   GIM_Try, /*On fail goto*//*Label 24397*/ GIMT_Encode4(1795397), // Rule ID 12266 //
     /* 1795316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1795327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1795330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1795333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1795336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1795339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795362 */     // MIs[0] policy
     /* 1795362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795372 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1795375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795396 */     // GIR_Coverage, 12266,
     /* 1795396 */     GIR_EraseRootFromParent_Done,
     /* 1795397 */   // Label 24397: @1795397
     /* 1795397 */   GIM_Try, /*On fail goto*//*Label 24398*/ GIMT_Encode4(1795483), // Rule ID 12267 //
     /* 1795402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1795413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1795416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1795419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1795422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1795425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795448 */     // MIs[0] policy
     /* 1795448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795458 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1795461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795482 */     // GIR_Coverage, 12267,
     /* 1795482 */     GIR_EraseRootFromParent_Done,
     /* 1795483 */   // Label 24398: @1795483
     /* 1795483 */   GIM_Try, /*On fail goto*//*Label 24399*/ GIMT_Encode4(1795569), // Rule ID 12270 //
     /* 1795488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1795499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1795502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1795508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795534 */     // MIs[0] policy
     /* 1795534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1795547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795568 */     // GIR_Coverage, 12270,
     /* 1795568 */     GIR_EraseRootFromParent_Done,
     /* 1795569 */   // Label 24399: @1795569
     /* 1795569 */   GIM_Try, /*On fail goto*//*Label 24400*/ GIMT_Encode4(1795655), // Rule ID 12271 //
     /* 1795574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1795585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1795588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1795594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795620 */     // MIs[0] policy
     /* 1795620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1795633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795654 */     // GIR_Coverage, 12271,
     /* 1795654 */     GIR_EraseRootFromParent_Done,
     /* 1795655 */   // Label 24400: @1795655
     /* 1795655 */   GIM_Try, /*On fail goto*//*Label 24401*/ GIMT_Encode4(1795741), // Rule ID 12274 //
     /* 1795660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1795671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1795674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1795677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1795680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795706 */     // MIs[0] policy
     /* 1795706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1795719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795740 */     // GIR_Coverage, 12274,
     /* 1795740 */     GIR_EraseRootFromParent_Done,
     /* 1795741 */   // Label 24401: @1795741
     /* 1795741 */   GIM_Try, /*On fail goto*//*Label 24402*/ GIMT_Encode4(1795827), // Rule ID 12275 //
     /* 1795746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1795757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1795760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1795763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1795766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795792 */     // MIs[0] policy
     /* 1795792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795802 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1795805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795826 */     // GIR_Coverage, 12275,
     /* 1795826 */     GIR_EraseRootFromParent_Done,
     /* 1795827 */   // Label 24402: @1795827
     /* 1795827 */   GIM_Try, /*On fail goto*//*Label 24403*/ GIMT_Encode4(1795913), // Rule ID 12278 //
     /* 1795832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1795843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1795846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1795849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1795852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795878 */     // MIs[0] policy
     /* 1795878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795888 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1795891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795912 */     // GIR_Coverage, 12278,
     /* 1795912 */     GIR_EraseRootFromParent_Done,
     /* 1795913 */   // Label 24403: @1795913
     /* 1795913 */   GIM_Try, /*On fail goto*//*Label 24404*/ GIMT_Encode4(1795999), // Rule ID 12279 //
     /* 1795918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1795929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1795932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1795935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1795938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795964 */     // MIs[0] policy
     /* 1795964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795974 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1795977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795998 */     // GIR_Coverage, 12279,
     /* 1795998 */     GIR_EraseRootFromParent_Done,
     /* 1795999 */   // Label 24404: @1795999
     /* 1795999 */   GIM_Try, /*On fail goto*//*Label 24405*/ GIMT_Encode4(1796085), // Rule ID 12282 //
     /* 1796004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1796007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1796015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1796018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1796021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1796024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1796034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796050 */     // MIs[0] policy
     /* 1796050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796060 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1796063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796084 */     // GIR_Coverage, 12282,
     /* 1796084 */     GIR_EraseRootFromParent_Done,
     /* 1796085 */   // Label 24405: @1796085
     /* 1796085 */   GIM_Try, /*On fail goto*//*Label 24406*/ GIMT_Encode4(1796171), // Rule ID 12283 //
     /* 1796090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1796093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1796101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1796104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1796107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1796110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1796120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796136 */     // MIs[0] policy
     /* 1796136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796146 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1796149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796170 */     // GIR_Coverage, 12283,
     /* 1796170 */     GIR_EraseRootFromParent_Done,
     /* 1796171 */   // Label 24406: @1796171
     /* 1796171 */   GIM_Try, /*On fail goto*//*Label 24407*/ GIMT_Encode4(1796257), // Rule ID 12286 //
     /* 1796176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1796179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1796187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1796190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1796193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1796196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796222 */     // MIs[0] policy
     /* 1796222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796232 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1796235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796256 */     // GIR_Coverage, 12286,
     /* 1796256 */     GIR_EraseRootFromParent_Done,
     /* 1796257 */   // Label 24407: @1796257
     /* 1796257 */   GIM_Try, /*On fail goto*//*Label 24408*/ GIMT_Encode4(1796343), // Rule ID 12287 //
     /* 1796262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1796265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1796273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1796276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1796279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1796282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796308 */     // MIs[0] policy
     /* 1796308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796318 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1796321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796342 */     // GIR_Coverage, 12287,
     /* 1796342 */     GIR_EraseRootFromParent_Done,
     /* 1796343 */   // Label 24408: @1796343
     /* 1796343 */   GIM_Try, /*On fail goto*//*Label 24409*/ GIMT_Encode4(1796429), // Rule ID 12290 //
     /* 1796348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1796351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1796359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1796362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1796365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1796368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796394 */     // MIs[0] policy
     /* 1796394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796404 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1796407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796428 */     // GIR_Coverage, 12290,
     /* 1796428 */     GIR_EraseRootFromParent_Done,
     /* 1796429 */   // Label 24409: @1796429
     /* 1796429 */   GIM_Try, /*On fail goto*//*Label 24410*/ GIMT_Encode4(1796515), // Rule ID 12291 //
     /* 1796434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1796437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1796445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1796448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1796451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1796454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796480 */     // MIs[0] policy
     /* 1796480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796490 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1796493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796514 */     // GIR_Coverage, 12291,
     /* 1796514 */     GIR_EraseRootFromParent_Done,
     /* 1796515 */   // Label 24410: @1796515
     /* 1796515 */   GIM_Try, /*On fail goto*//*Label 24411*/ GIMT_Encode4(1796601), // Rule ID 12294 //
     /* 1796520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1796531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1796534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1796537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796566 */     // MIs[0] policy
     /* 1796566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796576 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1796579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796600 */     // GIR_Coverage, 12294,
     /* 1796600 */     GIR_EraseRootFromParent_Done,
     /* 1796601 */   // Label 24411: @1796601
     /* 1796601 */   GIM_Try, /*On fail goto*//*Label 24412*/ GIMT_Encode4(1796687), // Rule ID 12295 //
     /* 1796606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1796617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1796620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1796623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796652 */     // MIs[0] policy
     /* 1796652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796662 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1796665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796686 */     // GIR_Coverage, 12295,
     /* 1796686 */     GIR_EraseRootFromParent_Done,
     /* 1796687 */   // Label 24412: @1796687
     /* 1796687 */   GIM_Try, /*On fail goto*//*Label 24413*/ GIMT_Encode4(1796773), // Rule ID 12298 //
     /* 1796692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1796703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1796706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1796709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796738 */     // MIs[0] policy
     /* 1796738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796748 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1796751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796772 */     // GIR_Coverage, 12298,
     /* 1796772 */     GIR_EraseRootFromParent_Done,
     /* 1796773 */   // Label 24413: @1796773
     /* 1796773 */   GIM_Try, /*On fail goto*//*Label 24414*/ GIMT_Encode4(1796859), // Rule ID 12299 //
     /* 1796778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1796789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1796792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1796795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796824 */     // MIs[0] policy
     /* 1796824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796834 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1796837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796858 */     // GIR_Coverage, 12299,
     /* 1796858 */     GIR_EraseRootFromParent_Done,
     /* 1796859 */   // Label 24414: @1796859
     /* 1796859 */   GIM_Try, /*On fail goto*//*Label 24415*/ GIMT_Encode4(1796945), // Rule ID 12302 //
     /* 1796864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1796875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1796878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1796881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796910 */     // MIs[0] policy
     /* 1796910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796920 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1796923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796944 */     // GIR_Coverage, 12302,
     /* 1796944 */     GIR_EraseRootFromParent_Done,
     /* 1796945 */   // Label 24415: @1796945
     /* 1796945 */   GIM_Try, /*On fail goto*//*Label 24416*/ GIMT_Encode4(1797031), // Rule ID 12303 //
     /* 1796950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1796961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1796964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1796967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796996 */     // MIs[0] policy
     /* 1796996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797006 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1797009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797030 */     // GIR_Coverage, 12303,
     /* 1797030 */     GIR_EraseRootFromParent_Done,
     /* 1797031 */   // Label 24416: @1797031
     /* 1797031 */   GIM_Try, /*On fail goto*//*Label 24417*/ GIMT_Encode4(1797117), // Rule ID 12306 //
     /* 1797036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1797047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1797050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1797053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797082 */     // MIs[0] policy
     /* 1797082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797092 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1797095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797116 */     // GIR_Coverage, 12306,
     /* 1797116 */     GIR_EraseRootFromParent_Done,
     /* 1797117 */   // Label 24417: @1797117
     /* 1797117 */   GIM_Try, /*On fail goto*//*Label 24418*/ GIMT_Encode4(1797203), // Rule ID 12307 //
     /* 1797122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1797133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1797136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1797139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797168 */     // MIs[0] policy
     /* 1797168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797178 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1797181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797202 */     // GIR_Coverage, 12307,
     /* 1797202 */     GIR_EraseRootFromParent_Done,
     /* 1797203 */   // Label 24418: @1797203
     /* 1797203 */   GIM_Try, /*On fail goto*//*Label 24419*/ GIMT_Encode4(1797289), // Rule ID 12310 //
     /* 1797208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1797219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1797222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1797225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797254 */     // MIs[0] policy
     /* 1797254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1797267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797288 */     // GIR_Coverage, 12310,
     /* 1797288 */     GIR_EraseRootFromParent_Done,
     /* 1797289 */   // Label 24419: @1797289
     /* 1797289 */   GIM_Try, /*On fail goto*//*Label 24420*/ GIMT_Encode4(1797375), // Rule ID 12311 //
     /* 1797294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1797305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1797308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1797311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797340 */     // MIs[0] policy
     /* 1797340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797350 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1797353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797374 */     // GIR_Coverage, 12311,
     /* 1797374 */     GIR_EraseRootFromParent_Done,
     /* 1797375 */   // Label 24420: @1797375
     /* 1797375 */   GIM_Try, /*On fail goto*//*Label 24421*/ GIMT_Encode4(1797461), // Rule ID 12314 //
     /* 1797380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1797391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1797394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1797397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797426 */     // MIs[0] policy
     /* 1797426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1797439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797460 */     // GIR_Coverage, 12314,
     /* 1797460 */     GIR_EraseRootFromParent_Done,
     /* 1797461 */   // Label 24421: @1797461
     /* 1797461 */   GIM_Try, /*On fail goto*//*Label 24422*/ GIMT_Encode4(1797547), // Rule ID 12315 //
     /* 1797466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1797477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1797480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1797483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797512 */     // MIs[0] policy
     /* 1797512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797522 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1797525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797546 */     // GIR_Coverage, 12315,
     /* 1797546 */     GIR_EraseRootFromParent_Done,
     /* 1797547 */   // Label 24422: @1797547
     /* 1797547 */   GIM_Try, /*On fail goto*//*Label 24423*/ GIMT_Encode4(1797633), // Rule ID 12318 //
     /* 1797552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1797563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1797566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1797569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797598 */     // MIs[0] policy
     /* 1797598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797608 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1797611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797632 */     // GIR_Coverage, 12318,
     /* 1797632 */     GIR_EraseRootFromParent_Done,
     /* 1797633 */   // Label 24423: @1797633
     /* 1797633 */   GIM_Try, /*On fail goto*//*Label 24424*/ GIMT_Encode4(1797719), // Rule ID 12319 //
     /* 1797638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1797649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1797652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1797655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797684 */     // MIs[0] policy
     /* 1797684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797694 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1797697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797718 */     // GIR_Coverage, 12319,
     /* 1797718 */     GIR_EraseRootFromParent_Done,
     /* 1797719 */   // Label 24424: @1797719
     /* 1797719 */   GIM_Try, /*On fail goto*//*Label 24425*/ GIMT_Encode4(1797805), // Rule ID 12322 //
     /* 1797724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797770 */     // MIs[0] policy
     /* 1797770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1797783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797804 */     // GIR_Coverage, 12322,
     /* 1797804 */     GIR_EraseRootFromParent_Done,
     /* 1797805 */   // Label 24425: @1797805
     /* 1797805 */   GIM_Try, /*On fail goto*//*Label 24426*/ GIMT_Encode4(1797891), // Rule ID 12323 //
     /* 1797810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797856 */     // MIs[0] policy
     /* 1797856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797866 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1797869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797890 */     // GIR_Coverage, 12323,
     /* 1797890 */     GIR_EraseRootFromParent_Done,
     /* 1797891 */   // Label 24426: @1797891
     /* 1797891 */   GIM_Try, /*On fail goto*//*Label 24427*/ GIMT_Encode4(1797977), // Rule ID 12326 //
     /* 1797896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797942 */     // MIs[0] policy
     /* 1797942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1797955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797976 */     // GIR_Coverage, 12326,
     /* 1797976 */     GIR_EraseRootFromParent_Done,
     /* 1797977 */   // Label 24427: @1797977
     /* 1797977 */   GIM_Try, /*On fail goto*//*Label 24428*/ GIMT_Encode4(1798063), // Rule ID 12327 //
     /* 1797982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1798005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798028 */     // MIs[0] policy
     /* 1798028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1798041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798062 */     // GIR_Coverage, 12327,
     /* 1798062 */     GIR_EraseRootFromParent_Done,
     /* 1798063 */   // Label 24428: @1798063
     /* 1798063 */   GIM_Try, /*On fail goto*//*Label 24429*/ GIMT_Encode4(1798149), // Rule ID 12330 //
     /* 1798068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1798071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1798079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1798082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1798085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1798091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798114 */     // MIs[0] policy
     /* 1798114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1798127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1798145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798148 */     // GIR_Coverage, 12330,
     /* 1798148 */     GIR_EraseRootFromParent_Done,
     /* 1798149 */   // Label 24429: @1798149
     /* 1798149 */   GIM_Try, /*On fail goto*//*Label 24430*/ GIMT_Encode4(1798235), // Rule ID 12331 //
     /* 1798154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1798157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1798165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1798168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1798171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1798177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798200 */     // MIs[0] policy
     /* 1798200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798210 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1798213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1798231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798234 */     // GIR_Coverage, 12331,
     /* 1798234 */     GIR_EraseRootFromParent_Done,
     /* 1798235 */   // Label 24430: @1798235
     /* 1798235 */   GIM_Try, /*On fail goto*//*Label 24431*/ GIMT_Encode4(1798321), // Rule ID 12334 //
     /* 1798240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1798251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1798254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1798257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798286 */     // MIs[0] policy
     /* 1798286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1798299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798320 */     // GIR_Coverage, 12334,
     /* 1798320 */     GIR_EraseRootFromParent_Done,
     /* 1798321 */   // Label 24431: @1798321
     /* 1798321 */   GIM_Try, /*On fail goto*//*Label 24432*/ GIMT_Encode4(1798407), // Rule ID 12335 //
     /* 1798326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1798337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1798340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1798343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798372 */     // MIs[0] policy
     /* 1798372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798382 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1798385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798406 */     // GIR_Coverage, 12335,
     /* 1798406 */     GIR_EraseRootFromParent_Done,
     /* 1798407 */   // Label 24432: @1798407
     /* 1798407 */   GIM_Try, /*On fail goto*//*Label 24433*/ GIMT_Encode4(1798493), // Rule ID 12338 //
     /* 1798412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1798423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1798426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1798429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798458 */     // MIs[0] policy
     /* 1798458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798468 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1798471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798492 */     // GIR_Coverage, 12338,
     /* 1798492 */     GIR_EraseRootFromParent_Done,
     /* 1798493 */   // Label 24433: @1798493
     /* 1798493 */   GIM_Try, /*On fail goto*//*Label 24434*/ GIMT_Encode4(1798579), // Rule ID 12339 //
     /* 1798498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1798509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1798512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1798515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798544 */     // MIs[0] policy
     /* 1798544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798554 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1798557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798578 */     // GIR_Coverage, 12339,
     /* 1798578 */     GIR_EraseRootFromParent_Done,
     /* 1798579 */   // Label 24434: @1798579
     /* 1798579 */   GIM_Try, /*On fail goto*//*Label 24435*/ GIMT_Encode4(1798665), // Rule ID 12342 //
     /* 1798584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1798595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1798598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1798601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1798607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798630 */     // MIs[0] policy
     /* 1798630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798640 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1798643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798664 */     // GIR_Coverage, 12342,
     /* 1798664 */     GIR_EraseRootFromParent_Done,
     /* 1798665 */   // Label 24435: @1798665
     /* 1798665 */   GIM_Try, /*On fail goto*//*Label 24436*/ GIMT_Encode4(1798751), // Rule ID 12343 //
     /* 1798670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1798681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1798684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1798687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1798693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798716 */     // MIs[0] policy
     /* 1798716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798726 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1798729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798750 */     // GIR_Coverage, 12343,
     /* 1798750 */     GIR_EraseRootFromParent_Done,
     /* 1798751 */   // Label 24436: @1798751
     /* 1798751 */   GIM_Try, /*On fail goto*//*Label 24437*/ GIMT_Encode4(1798837), // Rule ID 12346 //
     /* 1798756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1798773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798802 */     // MIs[0] policy
     /* 1798802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1798815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798836 */     // GIR_Coverage, 12346,
     /* 1798836 */     GIR_EraseRootFromParent_Done,
     /* 1798837 */   // Label 24437: @1798837
     /* 1798837 */   GIM_Try, /*On fail goto*//*Label 24438*/ GIMT_Encode4(1798923), // Rule ID 12347 //
     /* 1798842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1798859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798888 */     // MIs[0] policy
     /* 1798888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798898 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1798901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798922 */     // GIR_Coverage, 12347,
     /* 1798922 */     GIR_EraseRootFromParent_Done,
     /* 1798923 */   // Label 24438: @1798923
     /* 1798923 */   GIM_Try, /*On fail goto*//*Label 24439*/ GIMT_Encode4(1799009), // Rule ID 12350 //
     /* 1798928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1798939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1798942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1798945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798974 */     // MIs[0] policy
     /* 1798974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798984 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1798987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799008 */     // GIR_Coverage, 12350,
     /* 1799008 */     GIR_EraseRootFromParent_Done,
     /* 1799009 */   // Label 24439: @1799009
     /* 1799009 */   GIM_Try, /*On fail goto*//*Label 24440*/ GIMT_Encode4(1799095), // Rule ID 12351 //
     /* 1799014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1799025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1799028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1799031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799060 */     // MIs[0] policy
     /* 1799060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799070 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1799073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799094 */     // GIR_Coverage, 12351,
     /* 1799094 */     GIR_EraseRootFromParent_Done,
     /* 1799095 */   // Label 24440: @1799095
     /* 1799095 */   GIM_Try, /*On fail goto*//*Label 24441*/ GIMT_Encode4(1799181), // Rule ID 12354 //
     /* 1799100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1799111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1799114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1799117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1799123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799146 */     // MIs[0] policy
     /* 1799146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799156 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1799159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799180 */     // GIR_Coverage, 12354,
     /* 1799180 */     GIR_EraseRootFromParent_Done,
     /* 1799181 */   // Label 24441: @1799181
     /* 1799181 */   GIM_Try, /*On fail goto*//*Label 24442*/ GIMT_Encode4(1799267), // Rule ID 12355 //
     /* 1799186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1799197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1799200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1799203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1799209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799232 */     // MIs[0] policy
     /* 1799232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799242 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1799245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799266 */     // GIR_Coverage, 12355,
     /* 1799266 */     GIR_EraseRootFromParent_Done,
     /* 1799267 */   // Label 24442: @1799267
     /* 1799267 */   GIM_Try, /*On fail goto*//*Label 24443*/ GIMT_Encode4(1799353), // Rule ID 12358 //
     /* 1799272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1799283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1799286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1799289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799318 */     // MIs[0] policy
     /* 1799318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1799331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799352 */     // GIR_Coverage, 12358,
     /* 1799352 */     GIR_EraseRootFromParent_Done,
     /* 1799353 */   // Label 24443: @1799353
     /* 1799353 */   GIM_Try, /*On fail goto*//*Label 24444*/ GIMT_Encode4(1799439), // Rule ID 12359 //
     /* 1799358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1799369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1799372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1799375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799404 */     // MIs[0] policy
     /* 1799404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1799417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799438 */     // GIR_Coverage, 12359,
     /* 1799438 */     GIR_EraseRootFromParent_Done,
     /* 1799439 */   // Label 24444: @1799439
     /* 1799439 */   GIM_Try, /*On fail goto*//*Label 24445*/ GIMT_Encode4(1799525), // Rule ID 12362 //
     /* 1799444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1799455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1799458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1799461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799490 */     // MIs[0] policy
     /* 1799490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1799503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799524 */     // GIR_Coverage, 12362,
     /* 1799524 */     GIR_EraseRootFromParent_Done,
     /* 1799525 */   // Label 24445: @1799525
     /* 1799525 */   GIM_Try, /*On fail goto*//*Label 24446*/ GIMT_Encode4(1799611), // Rule ID 12363 //
     /* 1799530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1799541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1799544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1799547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799576 */     // MIs[0] policy
     /* 1799576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1799589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799610 */     // GIR_Coverage, 12363,
     /* 1799610 */     GIR_EraseRootFromParent_Done,
     /* 1799611 */   // Label 24446: @1799611
     /* 1799611 */   GIM_Try, /*On fail goto*//*Label 24447*/ GIMT_Encode4(1799697), // Rule ID 12366 //
     /* 1799616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1799627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1799630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1799633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799662 */     // MIs[0] policy
     /* 1799662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799672 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1799675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799696 */     // GIR_Coverage, 12366,
     /* 1799696 */     GIR_EraseRootFromParent_Done,
     /* 1799697 */   // Label 24447: @1799697
     /* 1799697 */   GIM_Try, /*On fail goto*//*Label 24448*/ GIMT_Encode4(1799783), // Rule ID 12367 //
     /* 1799702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1799713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1799716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1799719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799748 */     // MIs[0] policy
     /* 1799748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799758 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1799761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799782 */     // GIR_Coverage, 12367,
     /* 1799782 */     GIR_EraseRootFromParent_Done,
     /* 1799783 */   // Label 24448: @1799783
     /* 1799783 */   GIM_Try, /*On fail goto*//*Label 24449*/ GIMT_Encode4(1799869), // Rule ID 12370 //
     /* 1799788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1799805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799834 */     // MIs[0] policy
     /* 1799834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799844 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1799847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799868 */     // GIR_Coverage, 12370,
     /* 1799868 */     GIR_EraseRootFromParent_Done,
     /* 1799869 */   // Label 24449: @1799869
     /* 1799869 */   GIM_Try, /*On fail goto*//*Label 24450*/ GIMT_Encode4(1799955), // Rule ID 12371 //
     /* 1799874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1799877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1799891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799920 */     // MIs[0] policy
     /* 1799920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799930 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1799933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799954 */     // GIR_Coverage, 12371,
     /* 1799954 */     GIR_EraseRootFromParent_Done,
     /* 1799955 */   // Label 24450: @1799955
     /* 1799955 */   GIM_Try, /*On fail goto*//*Label 24451*/ GIMT_Encode4(1800041), // Rule ID 12374 //
     /* 1799960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1799971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1799974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1799977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800006 */     // MIs[0] policy
     /* 1800006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800016 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1800019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1800037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800040 */     // GIR_Coverage, 12374,
     /* 1800040 */     GIR_EraseRootFromParent_Done,
     /* 1800041 */   // Label 24451: @1800041
     /* 1800041 */   GIM_Try, /*On fail goto*//*Label 24452*/ GIMT_Encode4(1800127), // Rule ID 12375 //
     /* 1800046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1800049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1800057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1800060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1800063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800092 */     // MIs[0] policy
     /* 1800092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800102 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1800105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1800123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800126 */     // GIR_Coverage, 12375,
     /* 1800126 */     GIR_EraseRootFromParent_Done,
     /* 1800127 */   // Label 24452: @1800127
     /* 1800127 */   GIM_Try, /*On fail goto*//*Label 24453*/ GIMT_Encode4(1800213), // Rule ID 12378 //
     /* 1800132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1800135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1800143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1800146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1800149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800178 */     // MIs[0] policy
     /* 1800178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800188 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1800191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1800209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800212 */     // GIR_Coverage, 12378,
     /* 1800212 */     GIR_EraseRootFromParent_Done,
     /* 1800213 */   // Label 24453: @1800213
     /* 1800213 */   GIM_Try, /*On fail goto*//*Label 24454*/ GIMT_Encode4(1800299), // Rule ID 12379 //
     /* 1800218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1800221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1800229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1800232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1800235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800264 */     // MIs[0] policy
     /* 1800264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800274 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1800277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1800295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800298 */     // GIR_Coverage, 12379,
     /* 1800298 */     GIR_EraseRootFromParent_Done,
     /* 1800299 */   // Label 24454: @1800299
     /* 1800299 */   GIM_Try, /*On fail goto*//*Label 24455*/ GIMT_Encode4(1800385), // Rule ID 12382 //
     /* 1800304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1800315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1800318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1800321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1800324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800350 */     // MIs[0] policy
     /* 1800350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800360 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1800363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800384 */     // GIR_Coverage, 12382,
     /* 1800384 */     GIR_EraseRootFromParent_Done,
     /* 1800385 */   // Label 24455: @1800385
     /* 1800385 */   GIM_Try, /*On fail goto*//*Label 24456*/ GIMT_Encode4(1800471), // Rule ID 12383 //
     /* 1800390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1800401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1800404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1800407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1800410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800436 */     // MIs[0] policy
     /* 1800436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1800449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800470 */     // GIR_Coverage, 12383,
     /* 1800470 */     GIR_EraseRootFromParent_Done,
     /* 1800471 */   // Label 24456: @1800471
     /* 1800471 */   GIM_Try, /*On fail goto*//*Label 24457*/ GIMT_Encode4(1800557), // Rule ID 12386 //
     /* 1800476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1800487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1800490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1800493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1800496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800522 */     // MIs[0] policy
     /* 1800522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800532 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1800535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800556 */     // GIR_Coverage, 12386,
     /* 1800556 */     GIR_EraseRootFromParent_Done,
     /* 1800557 */   // Label 24457: @1800557
     /* 1800557 */   GIM_Try, /*On fail goto*//*Label 24458*/ GIMT_Encode4(1800643), // Rule ID 12387 //
     /* 1800562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1800573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1800576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1800579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1800582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800608 */     // MIs[0] policy
     /* 1800608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800618 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1800621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800642 */     // GIR_Coverage, 12387,
     /* 1800642 */     GIR_EraseRootFromParent_Done,
     /* 1800643 */   // Label 24458: @1800643
     /* 1800643 */   GIM_Try, /*On fail goto*//*Label 24459*/ GIMT_Encode4(1800729), // Rule ID 12390 //
     /* 1800648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1800659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1800662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1800665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1800668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800694 */     // MIs[0] policy
     /* 1800694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800704 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1800707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800728 */     // GIR_Coverage, 12390,
     /* 1800728 */     GIR_EraseRootFromParent_Done,
     /* 1800729 */   // Label 24459: @1800729
     /* 1800729 */   GIM_Try, /*On fail goto*//*Label 24460*/ GIMT_Encode4(1800815), // Rule ID 12391 //
     /* 1800734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1800745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1800748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1800751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1800754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800780 */     // MIs[0] policy
     /* 1800780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1800793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800814 */     // GIR_Coverage, 12391,
     /* 1800814 */     GIR_EraseRootFromParent_Done,
     /* 1800815 */   // Label 24460: @1800815
     /* 1800815 */   GIM_Try, /*On fail goto*//*Label 24461*/ GIMT_Encode4(1800901), // Rule ID 12394 //
     /* 1800820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1800831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1800834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1800837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1800840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800866 */     // MIs[0] policy
     /* 1800866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1800879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800900 */     // GIR_Coverage, 12394,
     /* 1800900 */     GIR_EraseRootFromParent_Done,
     /* 1800901 */   // Label 24461: @1800901
     /* 1800901 */   GIM_Try, /*On fail goto*//*Label 24462*/ GIMT_Encode4(1800987), // Rule ID 12395 //
     /* 1800906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1800917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1800920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1800923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1800926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800952 */     // MIs[0] policy
     /* 1800952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1800965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800986 */     // GIR_Coverage, 12395,
     /* 1800986 */     GIR_EraseRootFromParent_Done,
     /* 1800987 */   // Label 24462: @1800987
     /* 1800987 */   GIM_Try, /*On fail goto*//*Label 24463*/ GIMT_Encode4(1801073), // Rule ID 12398 //
     /* 1800992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1801003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1801006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1801009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1801012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801038 */     // MIs[0] policy
     /* 1801038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801048 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1801051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801072 */     // GIR_Coverage, 12398,
     /* 1801072 */     GIR_EraseRootFromParent_Done,
     /* 1801073 */   // Label 24463: @1801073
     /* 1801073 */   GIM_Try, /*On fail goto*//*Label 24464*/ GIMT_Encode4(1801159), // Rule ID 12399 //
     /* 1801078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1801089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1801092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1801095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1801098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801124 */     // MIs[0] policy
     /* 1801124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1801137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801158 */     // GIR_Coverage, 12399,
     /* 1801158 */     GIR_EraseRootFromParent_Done,
     /* 1801159 */   // Label 24464: @1801159
     /* 1801159 */   GIM_Try, /*On fail goto*//*Label 24465*/ GIMT_Encode4(1801245), // Rule ID 12402 //
     /* 1801164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1801175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1801178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1801181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1801184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1801187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801210 */     // MIs[0] policy
     /* 1801210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1801223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801244 */     // GIR_Coverage, 12402,
     /* 1801244 */     GIR_EraseRootFromParent_Done,
     /* 1801245 */   // Label 24465: @1801245
     /* 1801245 */   GIM_Try, /*On fail goto*//*Label 24466*/ GIMT_Encode4(1801331), // Rule ID 12403 //
     /* 1801250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1801261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1801264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1801267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1801270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1801273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801296 */     // MIs[0] policy
     /* 1801296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801306 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1801309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801330 */     // GIR_Coverage, 12403,
     /* 1801330 */     GIR_EraseRootFromParent_Done,
     /* 1801331 */   // Label 24466: @1801331
     /* 1801331 */   GIM_Try, /*On fail goto*//*Label 24467*/ GIMT_Encode4(1801417), // Rule ID 12406 //
     /* 1801336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1801347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1801350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1801353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1801356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801382 */     // MIs[0] policy
     /* 1801382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801392 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1801395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801416 */     // GIR_Coverage, 12406,
     /* 1801416 */     GIR_EraseRootFromParent_Done,
     /* 1801417 */   // Label 24467: @1801417
     /* 1801417 */   GIM_Try, /*On fail goto*//*Label 24468*/ GIMT_Encode4(1801503), // Rule ID 12407 //
     /* 1801422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1801433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1801436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1801439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1801442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801468 */     // MIs[0] policy
     /* 1801468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1801481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801502 */     // GIR_Coverage, 12407,
     /* 1801502 */     GIR_EraseRootFromParent_Done,
     /* 1801503 */   // Label 24468: @1801503
     /* 1801503 */   GIM_Try, /*On fail goto*//*Label 24469*/ GIMT_Encode4(1801589), // Rule ID 12410 //
     /* 1801508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1801519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1801522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1801525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1801528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801554 */     // MIs[0] policy
     /* 1801554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1801567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801588 */     // GIR_Coverage, 12410,
     /* 1801588 */     GIR_EraseRootFromParent_Done,
     /* 1801589 */   // Label 24469: @1801589
     /* 1801589 */   GIM_Try, /*On fail goto*//*Label 24470*/ GIMT_Encode4(1801675), // Rule ID 12411 //
     /* 1801594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1801605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1801608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1801611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1801614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801640 */     // MIs[0] policy
     /* 1801640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1801653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801674 */     // GIR_Coverage, 12411,
     /* 1801674 */     GIR_EraseRootFromParent_Done,
     /* 1801675 */   // Label 24470: @1801675
     /* 1801675 */   GIM_Try, /*On fail goto*//*Label 24471*/ GIMT_Encode4(1801761), // Rule ID 12414 //
     /* 1801680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1801691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1801694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1801697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1801700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801726 */     // MIs[0] policy
     /* 1801726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1801739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801760 */     // GIR_Coverage, 12414,
     /* 1801760 */     GIR_EraseRootFromParent_Done,
     /* 1801761 */   // Label 24471: @1801761
     /* 1801761 */   GIM_Try, /*On fail goto*//*Label 24472*/ GIMT_Encode4(1801847), // Rule ID 12415 //
     /* 1801766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1801777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1801780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1801783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1801786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801812 */     // MIs[0] policy
     /* 1801812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1801825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801846 */     // GIR_Coverage, 12415,
     /* 1801846 */     GIR_EraseRootFromParent_Done,
     /* 1801847 */   // Label 24472: @1801847
     /* 1801847 */   GIM_Try, /*On fail goto*//*Label 24473*/ GIMT_Encode4(1801933), // Rule ID 12418 //
     /* 1801852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1801863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1801866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1801869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1801872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801898 */     // MIs[0] policy
     /* 1801898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1801911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801932 */     // GIR_Coverage, 12418,
     /* 1801932 */     GIR_EraseRootFromParent_Done,
     /* 1801933 */   // Label 24473: @1801933
     /* 1801933 */   GIM_Try, /*On fail goto*//*Label 24474*/ GIMT_Encode4(1802019), // Rule ID 12419 //
     /* 1801938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1801949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1801952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1801955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1801958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801984 */     // MIs[0] policy
     /* 1801984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1801997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802018 */     // GIR_Coverage, 12419,
     /* 1802018 */     GIR_EraseRootFromParent_Done,
     /* 1802019 */   // Label 24474: @1802019
     /* 1802019 */   GIM_Try, /*On fail goto*//*Label 24475*/ GIMT_Encode4(1802105), // Rule ID 12422 //
     /* 1802024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1802035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1802038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1802041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1802044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1802047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802070 */     // MIs[0] policy
     /* 1802070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802080 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1802083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802104 */     // GIR_Coverage, 12422,
     /* 1802104 */     GIR_EraseRootFromParent_Done,
     /* 1802105 */   // Label 24475: @1802105
     /* 1802105 */   GIM_Try, /*On fail goto*//*Label 24476*/ GIMT_Encode4(1802191), // Rule ID 12423 //
     /* 1802110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1802121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1802124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1802127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1802130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1802133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802156 */     // MIs[0] policy
     /* 1802156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1802169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802190 */     // GIR_Coverage, 12423,
     /* 1802190 */     GIR_EraseRootFromParent_Done,
     /* 1802191 */   // Label 24476: @1802191
     /* 1802191 */   GIM_Try, /*On fail goto*//*Label 24477*/ GIMT_Encode4(1802277), // Rule ID 12426 //
     /* 1802196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1802207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1802210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1802213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1802216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802242 */     // MIs[0] policy
     /* 1802242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1802255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802276 */     // GIR_Coverage, 12426,
     /* 1802276 */     GIR_EraseRootFromParent_Done,
     /* 1802277 */   // Label 24477: @1802277
     /* 1802277 */   GIM_Try, /*On fail goto*//*Label 24478*/ GIMT_Encode4(1802363), // Rule ID 12427 //
     /* 1802282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1802293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1802296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1802299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1802302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802328 */     // MIs[0] policy
     /* 1802328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802338 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1802341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802362 */     // GIR_Coverage, 12427,
     /* 1802362 */     GIR_EraseRootFromParent_Done,
     /* 1802363 */   // Label 24478: @1802363
     /* 1802363 */   GIM_Try, /*On fail goto*//*Label 24479*/ GIMT_Encode4(1802449), // Rule ID 12430 //
     /* 1802368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1802379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1802382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1802385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1802388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802414 */     // MIs[0] policy
     /* 1802414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802424 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1802427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802448 */     // GIR_Coverage, 12430,
     /* 1802448 */     GIR_EraseRootFromParent_Done,
     /* 1802449 */   // Label 24479: @1802449
     /* 1802449 */   GIM_Try, /*On fail goto*//*Label 24480*/ GIMT_Encode4(1802535), // Rule ID 12431 //
     /* 1802454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1802465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1802468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1802471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1802474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802500 */     // MIs[0] policy
     /* 1802500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802510 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1802513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802534 */     // GIR_Coverage, 12431,
     /* 1802534 */     GIR_EraseRootFromParent_Done,
     /* 1802535 */   // Label 24480: @1802535
     /* 1802535 */   GIM_Try, /*On fail goto*//*Label 24481*/ GIMT_Encode4(1802621), // Rule ID 12434 //
     /* 1802540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1802551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1802554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1802557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1802560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802586 */     // MIs[0] policy
     /* 1802586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1802599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802620 */     // GIR_Coverage, 12434,
     /* 1802620 */     GIR_EraseRootFromParent_Done,
     /* 1802621 */   // Label 24481: @1802621
     /* 1802621 */   GIM_Try, /*On fail goto*//*Label 24482*/ GIMT_Encode4(1802707), // Rule ID 12435 //
     /* 1802626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1802637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1802640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1802643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1802646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802672 */     // MIs[0] policy
     /* 1802672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802682 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1802685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802706 */     // GIR_Coverage, 12435,
     /* 1802706 */     GIR_EraseRootFromParent_Done,
     /* 1802707 */   // Label 24482: @1802707
     /* 1802707 */   GIM_Try, /*On fail goto*//*Label 24483*/ GIMT_Encode4(1802793), // Rule ID 12438 //
     /* 1802712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1802723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1802726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1802729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1802732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802758 */     // MIs[0] policy
     /* 1802758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1802771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802792 */     // GIR_Coverage, 12438,
     /* 1802792 */     GIR_EraseRootFromParent_Done,
     /* 1802793 */   // Label 24483: @1802793
     /* 1802793 */   GIM_Try, /*On fail goto*//*Label 24484*/ GIMT_Encode4(1802879), // Rule ID 12439 //
     /* 1802798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1802809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1802812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1802815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1802818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802844 */     // MIs[0] policy
     /* 1802844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802854 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1802857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802878 */     // GIR_Coverage, 12439,
     /* 1802878 */     GIR_EraseRootFromParent_Done,
     /* 1802879 */   // Label 24484: @1802879
     /* 1802879 */   GIM_Try, /*On fail goto*//*Label 24485*/ GIMT_Encode4(1802965), // Rule ID 12442 //
     /* 1802884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1802895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1802898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1802901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802930 */     // MIs[0] policy
     /* 1802930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802940 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1802943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802964 */     // GIR_Coverage, 12442,
     /* 1802964 */     GIR_EraseRootFromParent_Done,
     /* 1802965 */   // Label 24485: @1802965
     /* 1802965 */   GIM_Try, /*On fail goto*//*Label 24486*/ GIMT_Encode4(1803051), // Rule ID 12443 //
     /* 1802970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1802981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1802984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1802987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803016 */     // MIs[0] policy
     /* 1803016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1803029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803050 */     // GIR_Coverage, 12443,
     /* 1803050 */     GIR_EraseRootFromParent_Done,
     /* 1803051 */   // Label 24486: @1803051
     /* 1803051 */   GIM_Try, /*On fail goto*//*Label 24487*/ GIMT_Encode4(1803137), // Rule ID 12446 //
     /* 1803056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1803067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1803070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1803073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803102 */     // MIs[0] policy
     /* 1803102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803112 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1803115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803136 */     // GIR_Coverage, 12446,
     /* 1803136 */     GIR_EraseRootFromParent_Done,
     /* 1803137 */   // Label 24487: @1803137
     /* 1803137 */   GIM_Try, /*On fail goto*//*Label 24488*/ GIMT_Encode4(1803223), // Rule ID 12447 //
     /* 1803142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1803153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1803156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1803159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803188 */     // MIs[0] policy
     /* 1803188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803198 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1803201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803222 */     // GIR_Coverage, 12447,
     /* 1803222 */     GIR_EraseRootFromParent_Done,
     /* 1803223 */   // Label 24488: @1803223
     /* 1803223 */   GIM_Try, /*On fail goto*//*Label 24489*/ GIMT_Encode4(1803309), // Rule ID 12450 //
     /* 1803228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1803239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1803242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1803245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803274 */     // MIs[0] policy
     /* 1803274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1803287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803308 */     // GIR_Coverage, 12450,
     /* 1803308 */     GIR_EraseRootFromParent_Done,
     /* 1803309 */   // Label 24489: @1803309
     /* 1803309 */   GIM_Try, /*On fail goto*//*Label 24490*/ GIMT_Encode4(1803395), // Rule ID 12451 //
     /* 1803314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1803325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1803328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1803331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803360 */     // MIs[0] policy
     /* 1803360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1803373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803394 */     // GIR_Coverage, 12451,
     /* 1803394 */     GIR_EraseRootFromParent_Done,
     /* 1803395 */   // Label 24490: @1803395
     /* 1803395 */   GIM_Try, /*On fail goto*//*Label 24491*/ GIMT_Encode4(1803481), // Rule ID 12454 //
     /* 1803400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1803411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1803414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1803417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803446 */     // MIs[0] policy
     /* 1803446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803456 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1803459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803480 */     // GIR_Coverage, 12454,
     /* 1803480 */     GIR_EraseRootFromParent_Done,
     /* 1803481 */   // Label 24491: @1803481
     /* 1803481 */   GIM_Try, /*On fail goto*//*Label 24492*/ GIMT_Encode4(1803567), // Rule ID 12455 //
     /* 1803486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1803497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1803500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1803503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803532 */     // MIs[0] policy
     /* 1803532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803542 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1803545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803566 */     // GIR_Coverage, 12455,
     /* 1803566 */     GIR_EraseRootFromParent_Done,
     /* 1803567 */   // Label 24492: @1803567
     /* 1803567 */   GIM_Try, /*On fail goto*//*Label 24493*/ GIMT_Encode4(1803653), // Rule ID 12458 //
     /* 1803572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1803583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1803586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1803589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803618 */     // MIs[0] policy
     /* 1803618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803628 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1803631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803652 */     // GIR_Coverage, 12458,
     /* 1803652 */     GIR_EraseRootFromParent_Done,
     /* 1803653 */   // Label 24493: @1803653
     /* 1803653 */   GIM_Try, /*On fail goto*//*Label 24494*/ GIMT_Encode4(1803739), // Rule ID 12459 //
     /* 1803658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1803669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1803672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1803675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803704 */     // MIs[0] policy
     /* 1803704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803714 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1803717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803738 */     // GIR_Coverage, 12459,
     /* 1803738 */     GIR_EraseRootFromParent_Done,
     /* 1803739 */   // Label 24494: @1803739
     /* 1803739 */   GIM_Try, /*On fail goto*//*Label 24495*/ GIMT_Encode4(1803825), // Rule ID 12462 //
     /* 1803744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1803755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1803758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1803761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1803767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803790 */     // MIs[0] policy
     /* 1803790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803800 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1803803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803824 */     // GIR_Coverage, 12462,
     /* 1803824 */     GIR_EraseRootFromParent_Done,
     /* 1803825 */   // Label 24495: @1803825
     /* 1803825 */   GIM_Try, /*On fail goto*//*Label 24496*/ GIMT_Encode4(1803911), // Rule ID 12463 //
     /* 1803830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1803841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1803844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1803847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1803853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803876 */     // MIs[0] policy
     /* 1803876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803886 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1803889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803910 */     // GIR_Coverage, 12463,
     /* 1803910 */     GIR_EraseRootFromParent_Done,
     /* 1803911 */   // Label 24496: @1803911
     /* 1803911 */   GIM_Try, /*On fail goto*//*Label 24497*/ GIMT_Encode4(1803997), // Rule ID 12466 //
     /* 1803916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1803927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1803930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1803933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803962 */     // MIs[0] policy
     /* 1803962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1803975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803996 */     // GIR_Coverage, 12466,
     /* 1803996 */     GIR_EraseRootFromParent_Done,
     /* 1803997 */   // Label 24497: @1803997
     /* 1803997 */   GIM_Try, /*On fail goto*//*Label 24498*/ GIMT_Encode4(1804083), // Rule ID 12467 //
     /* 1804002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1804013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1804016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1804019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804048 */     // MIs[0] policy
     /* 1804048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804058 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1804061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804082 */     // GIR_Coverage, 12467,
     /* 1804082 */     GIR_EraseRootFromParent_Done,
     /* 1804083 */   // Label 24498: @1804083
     /* 1804083 */   GIM_Try, /*On fail goto*//*Label 24499*/ GIMT_Encode4(1804169), // Rule ID 12470 //
     /* 1804088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1804099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1804102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1804105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804134 */     // MIs[0] policy
     /* 1804134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1804147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804168 */     // GIR_Coverage, 12470,
     /* 1804168 */     GIR_EraseRootFromParent_Done,
     /* 1804169 */   // Label 24499: @1804169
     /* 1804169 */   GIM_Try, /*On fail goto*//*Label 24500*/ GIMT_Encode4(1804255), // Rule ID 12471 //
     /* 1804174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1804185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1804188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1804191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804220 */     // MIs[0] policy
     /* 1804220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1804233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804254 */     // GIR_Coverage, 12471,
     /* 1804254 */     GIR_EraseRootFromParent_Done,
     /* 1804255 */   // Label 24500: @1804255
     /* 1804255 */   GIM_Try, /*On fail goto*//*Label 24501*/ GIMT_Encode4(1804341), // Rule ID 12474 //
     /* 1804260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1804271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1804274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1804277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804306 */     // MIs[0] policy
     /* 1804306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1804319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804340 */     // GIR_Coverage, 12474,
     /* 1804340 */     GIR_EraseRootFromParent_Done,
     /* 1804341 */   // Label 24501: @1804341
     /* 1804341 */   GIM_Try, /*On fail goto*//*Label 24502*/ GIMT_Encode4(1804427), // Rule ID 12475 //
     /* 1804346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1804357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1804360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1804363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804392 */     // MIs[0] policy
     /* 1804392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1804405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804426 */     // GIR_Coverage, 12475,
     /* 1804426 */     GIR_EraseRootFromParent_Done,
     /* 1804427 */   // Label 24502: @1804427
     /* 1804427 */   GIM_Try, /*On fail goto*//*Label 24503*/ GIMT_Encode4(1804513), // Rule ID 12478 //
     /* 1804432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1804443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1804446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1804449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804478 */     // MIs[0] policy
     /* 1804478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1804491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804512 */     // GIR_Coverage, 12478,
     /* 1804512 */     GIR_EraseRootFromParent_Done,
     /* 1804513 */   // Label 24503: @1804513
     /* 1804513 */   GIM_Try, /*On fail goto*//*Label 24504*/ GIMT_Encode4(1804599), // Rule ID 12479 //
     /* 1804518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1804529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1804532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1804535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804564 */     // MIs[0] policy
     /* 1804564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1804577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804598 */     // GIR_Coverage, 12479,
     /* 1804598 */     GIR_EraseRootFromParent_Done,
     /* 1804599 */   // Label 24504: @1804599
     /* 1804599 */   GIM_Try, /*On fail goto*//*Label 24505*/ GIMT_Encode4(1804685), // Rule ID 12482 //
     /* 1804604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1804615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1804618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1804621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804650 */     // MIs[0] policy
     /* 1804650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804660 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1804663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804684 */     // GIR_Coverage, 12482,
     /* 1804684 */     GIR_EraseRootFromParent_Done,
     /* 1804685 */   // Label 24505: @1804685
     /* 1804685 */   GIM_Try, /*On fail goto*//*Label 24506*/ GIMT_Encode4(1804771), // Rule ID 12483 //
     /* 1804690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1804701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1804704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1804707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804736 */     // MIs[0] policy
     /* 1804736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1804749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804770 */     // GIR_Coverage, 12483,
     /* 1804770 */     GIR_EraseRootFromParent_Done,
     /* 1804771 */   // Label 24506: @1804771
     /* 1804771 */   GIM_Try, /*On fail goto*//*Label 24507*/ GIMT_Encode4(1804857), // Rule ID 12486 //
     /* 1804776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1804787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1804790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1804793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804822 */     // MIs[0] policy
     /* 1804822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804832 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1804835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804856 */     // GIR_Coverage, 12486,
     /* 1804856 */     GIR_EraseRootFromParent_Done,
     /* 1804857 */   // Label 24507: @1804857
     /* 1804857 */   GIM_Try, /*On fail goto*//*Label 24508*/ GIMT_Encode4(1804943), // Rule ID 12487 //
     /* 1804862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1804865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1804873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1804876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1804879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804908 */     // MIs[0] policy
     /* 1804908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1804921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804942 */     // GIR_Coverage, 12487,
     /* 1804942 */     GIR_EraseRootFromParent_Done,
     /* 1804943 */   // Label 24508: @1804943
     /* 1804943 */   GIM_Try, /*On fail goto*//*Label 24509*/ GIMT_Encode4(1805029), // Rule ID 12490 //
     /* 1804948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1804959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1804962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1804965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804994 */     // MIs[0] policy
     /* 1804994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805004 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1805007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805028 */     // GIR_Coverage, 12490,
     /* 1805028 */     GIR_EraseRootFromParent_Done,
     /* 1805029 */   // Label 24509: @1805029
     /* 1805029 */   GIM_Try, /*On fail goto*//*Label 24510*/ GIMT_Encode4(1805115), // Rule ID 12491 //
     /* 1805034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1805045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1805048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1805051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1805054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805080 */     // MIs[0] policy
     /* 1805080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1805093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805114 */     // GIR_Coverage, 12491,
     /* 1805114 */     GIR_EraseRootFromParent_Done,
     /* 1805115 */   // Label 24510: @1805115
     /* 1805115 */   GIM_Try, /*On fail goto*//*Label 24511*/ GIMT_Encode4(1805201), // Rule ID 12494 //
     /* 1805120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1805123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1805131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1805134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1805137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1805140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805166 */     // MIs[0] policy
     /* 1805166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805176 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1805179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805200 */     // GIR_Coverage, 12494,
     /* 1805200 */     GIR_EraseRootFromParent_Done,
     /* 1805201 */   // Label 24511: @1805201
     /* 1805201 */   GIM_Try, /*On fail goto*//*Label 24512*/ GIMT_Encode4(1805287), // Rule ID 12495 //
     /* 1805206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1805217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1805220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1805223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1805226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805252 */     // MIs[0] policy
     /* 1805252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805262 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1805265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805286 */     // GIR_Coverage, 12495,
     /* 1805286 */     GIR_EraseRootFromParent_Done,
     /* 1805287 */   // Label 24512: @1805287
     /* 1805287 */   GIM_Try, /*On fail goto*//*Label 24513*/ GIMT_Encode4(1805373), // Rule ID 12498 //
     /* 1805292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1805295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1805303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1805306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1805309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1805312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805338 */     // MIs[0] policy
     /* 1805338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805348 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1805351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805372 */     // GIR_Coverage, 12498,
     /* 1805372 */     GIR_EraseRootFromParent_Done,
     /* 1805373 */   // Label 24513: @1805373
     /* 1805373 */   GIM_Try, /*On fail goto*//*Label 24514*/ GIMT_Encode4(1805459), // Rule ID 12499 //
     /* 1805378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1805389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1805392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1805395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1805398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805424 */     // MIs[0] policy
     /* 1805424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1805437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805458 */     // GIR_Coverage, 12499,
     /* 1805458 */     GIR_EraseRootFromParent_Done,
     /* 1805459 */   // Label 24514: @1805459
     /* 1805459 */   GIM_Try, /*On fail goto*//*Label 24515*/ GIMT_Encode4(1805545), // Rule ID 12502 //
     /* 1805464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1805475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1805478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1805481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1805484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805510 */     // MIs[0] policy
     /* 1805510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805520 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1805523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805544 */     // GIR_Coverage, 12502,
     /* 1805544 */     GIR_EraseRootFromParent_Done,
     /* 1805545 */   // Label 24515: @1805545
     /* 1805545 */   GIM_Try, /*On fail goto*//*Label 24516*/ GIMT_Encode4(1805631), // Rule ID 12503 //
     /* 1805550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1805561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1805564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1805567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1805570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805596 */     // MIs[0] policy
     /* 1805596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805606 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1805609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805630 */     // GIR_Coverage, 12503,
     /* 1805630 */     GIR_EraseRootFromParent_Done,
     /* 1805631 */   // Label 24516: @1805631
     /* 1805631 */   GIM_Try, /*On fail goto*//*Label 24517*/ GIMT_Encode4(1805717), // Rule ID 12506 //
     /* 1805636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1805647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1805650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1805653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1805656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805682 */     // MIs[0] policy
     /* 1805682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805692 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1805695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805716 */     // GIR_Coverage, 12506,
     /* 1805716 */     GIR_EraseRootFromParent_Done,
     /* 1805717 */   // Label 24517: @1805717
     /* 1805717 */   GIM_Try, /*On fail goto*//*Label 24518*/ GIMT_Encode4(1805803), // Rule ID 12507 //
     /* 1805722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1805733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1805736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1805739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1805742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805768 */     // MIs[0] policy
     /* 1805768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805778 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1805781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805802 */     // GIR_Coverage, 12507,
     /* 1805802 */     GIR_EraseRootFromParent_Done,
     /* 1805803 */   // Label 24518: @1805803
     /* 1805803 */   GIM_Try, /*On fail goto*//*Label 24519*/ GIMT_Encode4(1805889), // Rule ID 12510 //
     /* 1805808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1805819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1805822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1805825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1805828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805854 */     // MIs[0] policy
     /* 1805854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805864 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1805867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805888 */     // GIR_Coverage, 12510,
     /* 1805888 */     GIR_EraseRootFromParent_Done,
     /* 1805889 */   // Label 24519: @1805889
     /* 1805889 */   GIM_Try, /*On fail goto*//*Label 24520*/ GIMT_Encode4(1805975), // Rule ID 12511 //
     /* 1805894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1805905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1805908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1805911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1805914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805940 */     // MIs[0] policy
     /* 1805940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1805953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805974 */     // GIR_Coverage, 12511,
     /* 1805974 */     GIR_EraseRootFromParent_Done,
     /* 1805975 */   // Label 24520: @1805975
     /* 1805975 */   GIM_Try, /*On fail goto*//*Label 24521*/ GIMT_Encode4(1806061), // Rule ID 12514 //
     /* 1805980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1805991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1805994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1805997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1806000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806026 */     // MIs[0] policy
     /* 1806026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806036 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1806039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806060 */     // GIR_Coverage, 12514,
     /* 1806060 */     GIR_EraseRootFromParent_Done,
     /* 1806061 */   // Label 24521: @1806061
     /* 1806061 */   GIM_Try, /*On fail goto*//*Label 24522*/ GIMT_Encode4(1806147), // Rule ID 12515 //
     /* 1806066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1806077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1806080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1806083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1806086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806112 */     // MIs[0] policy
     /* 1806112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806122 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1806125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806146 */     // GIR_Coverage, 12515,
     /* 1806146 */     GIR_EraseRootFromParent_Done,
     /* 1806147 */   // Label 24522: @1806147
     /* 1806147 */   GIM_Try, /*On fail goto*//*Label 24523*/ GIMT_Encode4(1806233), // Rule ID 12518 //
     /* 1806152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1806163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1806166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1806169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1806172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806198 */     // MIs[0] policy
     /* 1806198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806208 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1806211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806232 */     // GIR_Coverage, 12518,
     /* 1806232 */     GIR_EraseRootFromParent_Done,
     /* 1806233 */   // Label 24523: @1806233
     /* 1806233 */   GIM_Try, /*On fail goto*//*Label 24524*/ GIMT_Encode4(1806319), // Rule ID 12519 //
     /* 1806238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1806249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1806252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1806255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1806258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806284 */     // MIs[0] policy
     /* 1806284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806294 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1806297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806318 */     // GIR_Coverage, 12519,
     /* 1806318 */     GIR_EraseRootFromParent_Done,
     /* 1806319 */   // Label 24524: @1806319
     /* 1806319 */   GIM_Try, /*On fail goto*//*Label 24525*/ GIMT_Encode4(1806405), // Rule ID 12522 //
     /* 1806324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1806335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1806338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1806341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1806344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1806347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806370 */     // MIs[0] policy
     /* 1806370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806380 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1806383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806404 */     // GIR_Coverage, 12522,
     /* 1806404 */     GIR_EraseRootFromParent_Done,
     /* 1806405 */   // Label 24525: @1806405
     /* 1806405 */   GIM_Try, /*On fail goto*//*Label 24526*/ GIMT_Encode4(1806491), // Rule ID 12523 //
     /* 1806410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1806421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1806424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1806427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1806430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1806433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806456 */     // MIs[0] policy
     /* 1806456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806466 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1806469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806490 */     // GIR_Coverage, 12523,
     /* 1806490 */     GIR_EraseRootFromParent_Done,
     /* 1806491 */   // Label 24526: @1806491
     /* 1806491 */   GIM_Try, /*On fail goto*//*Label 24527*/ GIMT_Encode4(1806577), // Rule ID 12526 //
     /* 1806496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1806507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1806510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1806513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1806516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806542 */     // MIs[0] policy
     /* 1806542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806552 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1806555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806576 */     // GIR_Coverage, 12526,
     /* 1806576 */     GIR_EraseRootFromParent_Done,
     /* 1806577 */   // Label 24527: @1806577
     /* 1806577 */   GIM_Try, /*On fail goto*//*Label 24528*/ GIMT_Encode4(1806663), // Rule ID 12527 //
     /* 1806582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1806593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1806596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1806599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1806602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806628 */     // MIs[0] policy
     /* 1806628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806638 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1806641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806662 */     // GIR_Coverage, 12527,
     /* 1806662 */     GIR_EraseRootFromParent_Done,
     /* 1806663 */   // Label 24528: @1806663
     /* 1806663 */   GIM_Try, /*On fail goto*//*Label 24529*/ GIMT_Encode4(1806749), // Rule ID 12530 //
     /* 1806668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1806679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1806682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1806685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1806688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806714 */     // MIs[0] policy
     /* 1806714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1806727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806748 */     // GIR_Coverage, 12530,
     /* 1806748 */     GIR_EraseRootFromParent_Done,
     /* 1806749 */   // Label 24529: @1806749
     /* 1806749 */   GIM_Try, /*On fail goto*//*Label 24530*/ GIMT_Encode4(1806835), // Rule ID 12531 //
     /* 1806754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1806765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1806768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1806771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1806774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806800 */     // MIs[0] policy
     /* 1806800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1806813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806834 */     // GIR_Coverage, 12531,
     /* 1806834 */     GIR_EraseRootFromParent_Done,
     /* 1806835 */   // Label 24530: @1806835
     /* 1806835 */   GIM_Try, /*On fail goto*//*Label 24531*/ GIMT_Encode4(1806921), // Rule ID 12534 //
     /* 1806840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1806851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1806854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1806857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1806860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806886 */     // MIs[0] policy
     /* 1806886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1806899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806920 */     // GIR_Coverage, 12534,
     /* 1806920 */     GIR_EraseRootFromParent_Done,
     /* 1806921 */   // Label 24531: @1806921
     /* 1806921 */   GIM_Try, /*On fail goto*//*Label 24532*/ GIMT_Encode4(1807007), // Rule ID 12535 //
     /* 1806926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1806937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1806940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1806943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1806946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806972 */     // MIs[0] policy
     /* 1806972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1806985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807006 */     // GIR_Coverage, 12535,
     /* 1807006 */     GIR_EraseRootFromParent_Done,
     /* 1807007 */   // Label 24532: @1807007
     /* 1807007 */   GIM_Try, /*On fail goto*//*Label 24533*/ GIMT_Encode4(1807093), // Rule ID 12538 //
     /* 1807012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1807023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1807026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1807029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1807032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807058 */     // MIs[0] policy
     /* 1807058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807068 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1807071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807092 */     // GIR_Coverage, 12538,
     /* 1807092 */     GIR_EraseRootFromParent_Done,
     /* 1807093 */   // Label 24533: @1807093
     /* 1807093 */   GIM_Try, /*On fail goto*//*Label 24534*/ GIMT_Encode4(1807179), // Rule ID 12539 //
     /* 1807098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1807109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1807112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1807115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1807118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807144 */     // MIs[0] policy
     /* 1807144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807154 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1807157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807178 */     // GIR_Coverage, 12539,
     /* 1807178 */     GIR_EraseRootFromParent_Done,
     /* 1807179 */   // Label 24534: @1807179
     /* 1807179 */   GIM_Try, /*On fail goto*//*Label 24535*/ GIMT_Encode4(1807265), // Rule ID 12542 //
     /* 1807184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1807195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1807198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1807201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1807204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1807207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807230 */     // MIs[0] policy
     /* 1807230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1807243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807264 */     // GIR_Coverage, 12542,
     /* 1807264 */     GIR_EraseRootFromParent_Done,
     /* 1807265 */   // Label 24535: @1807265
     /* 1807265 */   GIM_Try, /*On fail goto*//*Label 24536*/ GIMT_Encode4(1807351), // Rule ID 12543 //
     /* 1807270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1807281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1807284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1807287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1807290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1807293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807316 */     // MIs[0] policy
     /* 1807316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807326 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1807329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807350 */     // GIR_Coverage, 12543,
     /* 1807350 */     GIR_EraseRootFromParent_Done,
     /* 1807351 */   // Label 24536: @1807351
     /* 1807351 */   GIM_Try, /*On fail goto*//*Label 24537*/ GIMT_Encode4(1807437), // Rule ID 12546 //
     /* 1807356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1807367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1807370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1807373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1807376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807402 */     // MIs[0] policy
     /* 1807402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807412 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1807415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807436 */     // GIR_Coverage, 12546,
     /* 1807436 */     GIR_EraseRootFromParent_Done,
     /* 1807437 */   // Label 24537: @1807437
     /* 1807437 */   GIM_Try, /*On fail goto*//*Label 24538*/ GIMT_Encode4(1807523), // Rule ID 12547 //
     /* 1807442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1807453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1807456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1807459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1807462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807488 */     // MIs[0] policy
     /* 1807488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807498 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1807501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807522 */     // GIR_Coverage, 12547,
     /* 1807522 */     GIR_EraseRootFromParent_Done,
     /* 1807523 */   // Label 24538: @1807523
     /* 1807523 */   GIM_Try, /*On fail goto*//*Label 24539*/ GIMT_Encode4(1807609), // Rule ID 12550 //
     /* 1807528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1807539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1807542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1807545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1807548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807574 */     // MIs[0] policy
     /* 1807574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1807587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807608 */     // GIR_Coverage, 12550,
     /* 1807608 */     GIR_EraseRootFromParent_Done,
     /* 1807609 */   // Label 24539: @1807609
     /* 1807609 */   GIM_Try, /*On fail goto*//*Label 24540*/ GIMT_Encode4(1807695), // Rule ID 12551 //
     /* 1807614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1807625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1807628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1807631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1807634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807660 */     // MIs[0] policy
     /* 1807660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1807673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807694 */     // GIR_Coverage, 12551,
     /* 1807694 */     GIR_EraseRootFromParent_Done,
     /* 1807695 */   // Label 24540: @1807695
     /* 1807695 */   GIM_Try, /*On fail goto*//*Label 24541*/ GIMT_Encode4(1807781), // Rule ID 12554 //
     /* 1807700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1807711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1807714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1807717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1807720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807746 */     // MIs[0] policy
     /* 1807746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807756 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1807759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807780 */     // GIR_Coverage, 12554,
     /* 1807780 */     GIR_EraseRootFromParent_Done,
     /* 1807781 */   // Label 24541: @1807781
     /* 1807781 */   GIM_Try, /*On fail goto*//*Label 24542*/ GIMT_Encode4(1807867), // Rule ID 12555 //
     /* 1807786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1807797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1807800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1807803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1807806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807832 */     // MIs[0] policy
     /* 1807832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807842 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1807845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807866 */     // GIR_Coverage, 12555,
     /* 1807866 */     GIR_EraseRootFromParent_Done,
     /* 1807867 */   // Label 24542: @1807867
     /* 1807867 */   GIM_Try, /*On fail goto*//*Label 24543*/ GIMT_Encode4(1807953), // Rule ID 12558 //
     /* 1807872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1807883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1807886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1807889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1807892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807918 */     // MIs[0] policy
     /* 1807918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807928 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1807931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807952 */     // GIR_Coverage, 12558,
     /* 1807952 */     GIR_EraseRootFromParent_Done,
     /* 1807953 */   // Label 24543: @1807953
     /* 1807953 */   GIM_Try, /*On fail goto*//*Label 24544*/ GIMT_Encode4(1808039), // Rule ID 12559 //
     /* 1807958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1807969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1807972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1807975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1807978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808004 */     // MIs[0] policy
     /* 1808004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808014 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1808017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808038 */     // GIR_Coverage, 12559,
     /* 1808038 */     GIR_EraseRootFromParent_Done,
     /* 1808039 */   // Label 24544: @1808039
     /* 1808039 */   GIM_Try, /*On fail goto*//*Label 24545*/ GIMT_Encode4(1808125), // Rule ID 12562 //
     /* 1808044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1808055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1808058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1808061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808090 */     // MIs[0] policy
     /* 1808090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808100 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1808103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808124 */     // GIR_Coverage, 12562,
     /* 1808124 */     GIR_EraseRootFromParent_Done,
     /* 1808125 */   // Label 24545: @1808125
     /* 1808125 */   GIM_Try, /*On fail goto*//*Label 24546*/ GIMT_Encode4(1808211), // Rule ID 12563 //
     /* 1808130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1808141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1808144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1808147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808176 */     // MIs[0] policy
     /* 1808176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808186 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1808189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808210 */     // GIR_Coverage, 12563,
     /* 1808210 */     GIR_EraseRootFromParent_Done,
     /* 1808211 */   // Label 24546: @1808211
     /* 1808211 */   GIM_Try, /*On fail goto*//*Label 24547*/ GIMT_Encode4(1808297), // Rule ID 12566 //
     /* 1808216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1808227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1808230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1808233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808262 */     // MIs[0] policy
     /* 1808262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808272 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1808275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808296 */     // GIR_Coverage, 12566,
     /* 1808296 */     GIR_EraseRootFromParent_Done,
     /* 1808297 */   // Label 24547: @1808297
     /* 1808297 */   GIM_Try, /*On fail goto*//*Label 24548*/ GIMT_Encode4(1808383), // Rule ID 12567 //
     /* 1808302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1808313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1808316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1808319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808348 */     // MIs[0] policy
     /* 1808348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808358 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1808361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808382 */     // GIR_Coverage, 12567,
     /* 1808382 */     GIR_EraseRootFromParent_Done,
     /* 1808383 */   // Label 24548: @1808383
     /* 1808383 */   GIM_Try, /*On fail goto*//*Label 24549*/ GIMT_Encode4(1808469), // Rule ID 12570 //
     /* 1808388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1808399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1808402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1808405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808434 */     // MIs[0] policy
     /* 1808434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808444 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1808447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808468 */     // GIR_Coverage, 12570,
     /* 1808468 */     GIR_EraseRootFromParent_Done,
     /* 1808469 */   // Label 24549: @1808469
     /* 1808469 */   GIM_Try, /*On fail goto*//*Label 24550*/ GIMT_Encode4(1808555), // Rule ID 12571 //
     /* 1808474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1808485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1808488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1808491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808520 */     // MIs[0] policy
     /* 1808520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808530 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1808533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808554 */     // GIR_Coverage, 12571,
     /* 1808554 */     GIR_EraseRootFromParent_Done,
     /* 1808555 */   // Label 24550: @1808555
     /* 1808555 */   GIM_Try, /*On fail goto*//*Label 24551*/ GIMT_Encode4(1808641), // Rule ID 12574 //
     /* 1808560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1808571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1808574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1808577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808606 */     // MIs[0] policy
     /* 1808606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1808619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808640 */     // GIR_Coverage, 12574,
     /* 1808640 */     GIR_EraseRootFromParent_Done,
     /* 1808641 */   // Label 24551: @1808641
     /* 1808641 */   GIM_Try, /*On fail goto*//*Label 24552*/ GIMT_Encode4(1808727), // Rule ID 12575 //
     /* 1808646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1808657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1808660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1808663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808692 */     // MIs[0] policy
     /* 1808692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1808705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808726 */     // GIR_Coverage, 12575,
     /* 1808726 */     GIR_EraseRootFromParent_Done,
     /* 1808727 */   // Label 24552: @1808727
     /* 1808727 */   GIM_Try, /*On fail goto*//*Label 24553*/ GIMT_Encode4(1808813), // Rule ID 12578 //
     /* 1808732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1808743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1808746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1808749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808778 */     // MIs[0] policy
     /* 1808778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808788 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1808791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808812 */     // GIR_Coverage, 12578,
     /* 1808812 */     GIR_EraseRootFromParent_Done,
     /* 1808813 */   // Label 24553: @1808813
     /* 1808813 */   GIM_Try, /*On fail goto*//*Label 24554*/ GIMT_Encode4(1808899), // Rule ID 12579 //
     /* 1808818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1808829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1808832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1808835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808864 */     // MIs[0] policy
     /* 1808864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1808877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808898 */     // GIR_Coverage, 12579,
     /* 1808898 */     GIR_EraseRootFromParent_Done,
     /* 1808899 */   // Label 24554: @1808899
     /* 1808899 */   GIM_Try, /*On fail goto*//*Label 24555*/ GIMT_Encode4(1808985), // Rule ID 12582 //
     /* 1808904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1808915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1808918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1808921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1808927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808950 */     // MIs[0] policy
     /* 1808950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808960 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1808963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808984 */     // GIR_Coverage, 12582,
     /* 1808984 */     GIR_EraseRootFromParent_Done,
     /* 1808985 */   // Label 24555: @1808985
     /* 1808985 */   GIM_Try, /*On fail goto*//*Label 24556*/ GIMT_Encode4(1809071), // Rule ID 12583 //
     /* 1808990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1809001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1809004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1809007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1809013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809036 */     // MIs[0] policy
     /* 1809036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1809049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809070 */     // GIR_Coverage, 12583,
     /* 1809070 */     GIR_EraseRootFromParent_Done,
     /* 1809071 */   // Label 24556: @1809071
     /* 1809071 */   GIM_Try, /*On fail goto*//*Label 24557*/ GIMT_Encode4(1809157), // Rule ID 12586 //
     /* 1809076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1809087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1809090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1809093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809122 */     // MIs[0] policy
     /* 1809122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1809135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809156 */     // GIR_Coverage, 12586,
     /* 1809156 */     GIR_EraseRootFromParent_Done,
     /* 1809157 */   // Label 24557: @1809157
     /* 1809157 */   GIM_Try, /*On fail goto*//*Label 24558*/ GIMT_Encode4(1809243), // Rule ID 12587 //
     /* 1809162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1809173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1809176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1809179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809208 */     // MIs[0] policy
     /* 1809208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809218 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1809221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809242 */     // GIR_Coverage, 12587,
     /* 1809242 */     GIR_EraseRootFromParent_Done,
     /* 1809243 */   // Label 24558: @1809243
     /* 1809243 */   GIM_Try, /*On fail goto*//*Label 24559*/ GIMT_Encode4(1809329), // Rule ID 12590 //
     /* 1809248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1809259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1809262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1809265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809294 */     // MIs[0] policy
     /* 1809294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1809307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809328 */     // GIR_Coverage, 12590,
     /* 1809328 */     GIR_EraseRootFromParent_Done,
     /* 1809329 */   // Label 24559: @1809329
     /* 1809329 */   GIM_Try, /*On fail goto*//*Label 24560*/ GIMT_Encode4(1809415), // Rule ID 12591 //
     /* 1809334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1809345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1809348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1809351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809380 */     // MIs[0] policy
     /* 1809380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1809393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809414 */     // GIR_Coverage, 12591,
     /* 1809414 */     GIR_EraseRootFromParent_Done,
     /* 1809415 */   // Label 24560: @1809415
     /* 1809415 */   GIM_Try, /*On fail goto*//*Label 24561*/ GIMT_Encode4(1809501), // Rule ID 12594 //
     /* 1809420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1809431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1809434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1809437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809466 */     // MIs[0] policy
     /* 1809466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1809479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809500 */     // GIR_Coverage, 12594,
     /* 1809500 */     GIR_EraseRootFromParent_Done,
     /* 1809501 */   // Label 24561: @1809501
     /* 1809501 */   GIM_Try, /*On fail goto*//*Label 24562*/ GIMT_Encode4(1809587), // Rule ID 12595 //
     /* 1809506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1809517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1809520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1809523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809552 */     // MIs[0] policy
     /* 1809552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1809565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809586 */     // GIR_Coverage, 12595,
     /* 1809586 */     GIR_EraseRootFromParent_Done,
     /* 1809587 */   // Label 24562: @1809587
     /* 1809587 */   GIM_Try, /*On fail goto*//*Label 24563*/ GIMT_Encode4(1809673), // Rule ID 12598 //
     /* 1809592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1809603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1809606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1809609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809638 */     // MIs[0] policy
     /* 1809638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809648 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1809651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809672 */     // GIR_Coverage, 12598,
     /* 1809672 */     GIR_EraseRootFromParent_Done,
     /* 1809673 */   // Label 24563: @1809673
     /* 1809673 */   GIM_Try, /*On fail goto*//*Label 24564*/ GIMT_Encode4(1809759), // Rule ID 12599 //
     /* 1809678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1809689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1809692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1809695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809724 */     // MIs[0] policy
     /* 1809724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809734 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1809737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809758 */     // GIR_Coverage, 12599,
     /* 1809758 */     GIR_EraseRootFromParent_Done,
     /* 1809759 */   // Label 24564: @1809759
     /* 1809759 */   GIM_Try, /*On fail goto*//*Label 24565*/ GIMT_Encode4(1809845), // Rule ID 12602 //
     /* 1809764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1809775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1809778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1809781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809810 */     // MIs[0] policy
     /* 1809810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809820 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1809823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809844 */     // GIR_Coverage, 12602,
     /* 1809844 */     GIR_EraseRootFromParent_Done,
     /* 1809845 */   // Label 24565: @1809845
     /* 1809845 */   GIM_Try, /*On fail goto*//*Label 24566*/ GIMT_Encode4(1809931), // Rule ID 12603 //
     /* 1809850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1809861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1809864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1809867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809896 */     // MIs[0] policy
     /* 1809896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809906 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1809909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809930 */     // GIR_Coverage, 12603,
     /* 1809930 */     GIR_EraseRootFromParent_Done,
     /* 1809931 */   // Label 24566: @1809931
     /* 1809931 */   GIM_Try, /*On fail goto*//*Label 24567*/ GIMT_Encode4(1810017), // Rule ID 12606 //
     /* 1809936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1809939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1809947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1809950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1809953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809982 */     // MIs[0] policy
     /* 1809982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809992 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1809995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810016 */     // GIR_Coverage, 12606,
     /* 1810016 */     GIR_EraseRootFromParent_Done,
     /* 1810017 */   // Label 24567: @1810017
     /* 1810017 */   GIM_Try, /*On fail goto*//*Label 24568*/ GIMT_Encode4(1810103), // Rule ID 12607 //
     /* 1810022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1810033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1810036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1810039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810068 */     // MIs[0] policy
     /* 1810068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810078 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1810081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810102 */     // GIR_Coverage, 12607,
     /* 1810102 */     GIR_EraseRootFromParent_Done,
     /* 1810103 */   // Label 24568: @1810103
     /* 1810103 */   GIM_Try, /*On fail goto*//*Label 24569*/ GIMT_Encode4(1810189), // Rule ID 12610 //
     /* 1810108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1810111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1810119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1810122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1810125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1810128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810154 */     // MIs[0] policy
     /* 1810154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1810167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810188 */     // GIR_Coverage, 12610,
     /* 1810188 */     GIR_EraseRootFromParent_Done,
     /* 1810189 */   // Label 24569: @1810189
     /* 1810189 */   GIM_Try, /*On fail goto*//*Label 24570*/ GIMT_Encode4(1810275), // Rule ID 12611 //
     /* 1810194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1810205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1810208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1810211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810240 */     // MIs[0] policy
     /* 1810240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810250 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1810253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810274 */     // GIR_Coverage, 12611,
     /* 1810274 */     GIR_EraseRootFromParent_Done,
     /* 1810275 */   // Label 24570: @1810275
     /* 1810275 */   GIM_Try, /*On fail goto*//*Label 24571*/ GIMT_Encode4(1810361), // Rule ID 12614 //
     /* 1810280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1810283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1810291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1810294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1810297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1810300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810326 */     // MIs[0] policy
     /* 1810326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810336 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1810339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810360 */     // GIR_Coverage, 12614,
     /* 1810360 */     GIR_EraseRootFromParent_Done,
     /* 1810361 */   // Label 24571: @1810361
     /* 1810361 */   GIM_Try, /*On fail goto*//*Label 24572*/ GIMT_Encode4(1810447), // Rule ID 12615 //
     /* 1810366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1810377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1810380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1810383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810412 */     // MIs[0] policy
     /* 1810412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810422 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1810425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810446 */     // GIR_Coverage, 12615,
     /* 1810446 */     GIR_EraseRootFromParent_Done,
     /* 1810447 */   // Label 24572: @1810447
     /* 1810447 */   GIM_Try, /*On fail goto*//*Label 24573*/ GIMT_Encode4(1810533), // Rule ID 12618 //
     /* 1810452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1810455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1810463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1810466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1810469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1810472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810498 */     // MIs[0] policy
     /* 1810498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1810511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810532 */     // GIR_Coverage, 12618,
     /* 1810532 */     GIR_EraseRootFromParent_Done,
     /* 1810533 */   // Label 24573: @1810533
     /* 1810533 */   GIM_Try, /*On fail goto*//*Label 24574*/ GIMT_Encode4(1810619), // Rule ID 12619 //
     /* 1810538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1810549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1810552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1810555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810584 */     // MIs[0] policy
     /* 1810584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810594 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1810597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810618 */     // GIR_Coverage, 12619,
     /* 1810618 */     GIR_EraseRootFromParent_Done,
     /* 1810619 */   // Label 24574: @1810619
     /* 1810619 */   GIM_Try, /*On fail goto*//*Label 24575*/ GIMT_Encode4(1810705), // Rule ID 12622 //
     /* 1810624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1810635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1810638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1810641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1810644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810670 */     // MIs[0] policy
     /* 1810670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810680 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1810683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810704 */     // GIR_Coverage, 12622,
     /* 1810704 */     GIR_EraseRootFromParent_Done,
     /* 1810705 */   // Label 24575: @1810705
     /* 1810705 */   GIM_Try, /*On fail goto*//*Label 24576*/ GIMT_Encode4(1810791), // Rule ID 12623 //
     /* 1810710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1810721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1810724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1810727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1810730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810756 */     // MIs[0] policy
     /* 1810756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810766 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1810769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810790 */     // GIR_Coverage, 12623,
     /* 1810790 */     GIR_EraseRootFromParent_Done,
     /* 1810791 */   // Label 24576: @1810791
     /* 1810791 */   GIM_Try, /*On fail goto*//*Label 24577*/ GIMT_Encode4(1810877), // Rule ID 12626 //
     /* 1810796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1810807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1810810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1810813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1810816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810842 */     // MIs[0] policy
     /* 1810842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1810855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810876 */     // GIR_Coverage, 12626,
     /* 1810876 */     GIR_EraseRootFromParent_Done,
     /* 1810877 */   // Label 24577: @1810877
     /* 1810877 */   GIM_Try, /*On fail goto*//*Label 24578*/ GIMT_Encode4(1810963), // Rule ID 12627 //
     /* 1810882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1810893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1810896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1810899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1810902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810928 */     // MIs[0] policy
     /* 1810928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810938 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1810941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810962 */     // GIR_Coverage, 12627,
     /* 1810962 */     GIR_EraseRootFromParent_Done,
     /* 1810963 */   // Label 24578: @1810963
     /* 1810963 */   GIM_Try, /*On fail goto*//*Label 24579*/ GIMT_Encode4(1811049), // Rule ID 12630 //
     /* 1810968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1810979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1810982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1810985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1810988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811014 */     // MIs[0] policy
     /* 1811014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1811027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811048 */     // GIR_Coverage, 12630,
     /* 1811048 */     GIR_EraseRootFromParent_Done,
     /* 1811049 */   // Label 24579: @1811049
     /* 1811049 */   GIM_Try, /*On fail goto*//*Label 24580*/ GIMT_Encode4(1811135), // Rule ID 12631 //
     /* 1811054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1811065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1811068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1811071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1811074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811100 */     // MIs[0] policy
     /* 1811100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811110 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1811113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811134 */     // GIR_Coverage, 12631,
     /* 1811134 */     GIR_EraseRootFromParent_Done,
     /* 1811135 */   // Label 24580: @1811135
     /* 1811135 */   GIM_Try, /*On fail goto*//*Label 24581*/ GIMT_Encode4(1811221), // Rule ID 12634 //
     /* 1811140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1811151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1811154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1811157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1811160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811186 */     // MIs[0] policy
     /* 1811186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811196 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1811199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811220 */     // GIR_Coverage, 12634,
     /* 1811220 */     GIR_EraseRootFromParent_Done,
     /* 1811221 */   // Label 24581: @1811221
     /* 1811221 */   GIM_Try, /*On fail goto*//*Label 24582*/ GIMT_Encode4(1811307), // Rule ID 12635 //
     /* 1811226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1811237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1811240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1811243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1811246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811272 */     // MIs[0] policy
     /* 1811272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811282 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1811285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811306 */     // GIR_Coverage, 12635,
     /* 1811306 */     GIR_EraseRootFromParent_Done,
     /* 1811307 */   // Label 24582: @1811307
     /* 1811307 */   GIM_Try, /*On fail goto*//*Label 24583*/ GIMT_Encode4(1811393), // Rule ID 12638 //
     /* 1811312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1811323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1811326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1811329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1811332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811358 */     // MIs[0] policy
     /* 1811358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1811371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811392 */     // GIR_Coverage, 12638,
     /* 1811392 */     GIR_EraseRootFromParent_Done,
     /* 1811393 */   // Label 24583: @1811393
     /* 1811393 */   GIM_Try, /*On fail goto*//*Label 24584*/ GIMT_Encode4(1811479), // Rule ID 12639 //
     /* 1811398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1811409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1811412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1811415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1811418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811444 */     // MIs[0] policy
     /* 1811444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811454 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1811457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811478 */     // GIR_Coverage, 12639,
     /* 1811478 */     GIR_EraseRootFromParent_Done,
     /* 1811479 */   // Label 24584: @1811479
     /* 1811479 */   GIM_Try, /*On fail goto*//*Label 24585*/ GIMT_Encode4(1811565), // Rule ID 12642 //
     /* 1811484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1811501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1811504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811530 */     // MIs[0] policy
     /* 1811530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811540 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1811543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811564 */     // GIR_Coverage, 12642,
     /* 1811564 */     GIR_EraseRootFromParent_Done,
     /* 1811565 */   // Label 24585: @1811565
     /* 1811565 */   GIM_Try, /*On fail goto*//*Label 24586*/ GIMT_Encode4(1811651), // Rule ID 12643 //
     /* 1811570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1811587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1811590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811616 */     // MIs[0] policy
     /* 1811616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811626 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1811629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811650 */     // GIR_Coverage, 12643,
     /* 1811650 */     GIR_EraseRootFromParent_Done,
     /* 1811651 */   // Label 24586: @1811651
     /* 1811651 */   GIM_Try, /*On fail goto*//*Label 24587*/ GIMT_Encode4(1811737), // Rule ID 12646 //
     /* 1811656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1811667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1811670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1811673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1811676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1811679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811702 */     // MIs[0] policy
     /* 1811702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811712 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1811715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811736 */     // GIR_Coverage, 12646,
     /* 1811736 */     GIR_EraseRootFromParent_Done,
     /* 1811737 */   // Label 24587: @1811737
     /* 1811737 */   GIM_Try, /*On fail goto*//*Label 24588*/ GIMT_Encode4(1811823), // Rule ID 12647 //
     /* 1811742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1811753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1811756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1811759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1811762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1811765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811788 */     // MIs[0] policy
     /* 1811788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811798 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1811801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811822 */     // GIR_Coverage, 12647,
     /* 1811822 */     GIR_EraseRootFromParent_Done,
     /* 1811823 */   // Label 24588: @1811823
     /* 1811823 */   GIM_Try, /*On fail goto*//*Label 24589*/ GIMT_Encode4(1811909), // Rule ID 12650 //
     /* 1811828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1811839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1811842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1811845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1811848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811874 */     // MIs[0] policy
     /* 1811874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811884 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1811887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811908 */     // GIR_Coverage, 12650,
     /* 1811908 */     GIR_EraseRootFromParent_Done,
     /* 1811909 */   // Label 24589: @1811909
     /* 1811909 */   GIM_Try, /*On fail goto*//*Label 24590*/ GIMT_Encode4(1811995), // Rule ID 12651 //
     /* 1811914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1811925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1811928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1811931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1811934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811960 */     // MIs[0] policy
     /* 1811960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1811973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811994 */     // GIR_Coverage, 12651,
     /* 1811994 */     GIR_EraseRootFromParent_Done,
     /* 1811995 */   // Label 24590: @1811995
     /* 1811995 */   GIM_Try, /*On fail goto*//*Label 24591*/ GIMT_Encode4(1812081), // Rule ID 12654 //
     /* 1812000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1812011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1812014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1812017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1812020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812046 */     // MIs[0] policy
     /* 1812046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1812059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812080 */     // GIR_Coverage, 12654,
     /* 1812080 */     GIR_EraseRootFromParent_Done,
     /* 1812081 */   // Label 24591: @1812081
     /* 1812081 */   GIM_Try, /*On fail goto*//*Label 24592*/ GIMT_Encode4(1812167), // Rule ID 12655 //
     /* 1812086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1812097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1812100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1812103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1812106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812132 */     // MIs[0] policy
     /* 1812132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812142 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1812145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812166 */     // GIR_Coverage, 12655,
     /* 1812166 */     GIR_EraseRootFromParent_Done,
     /* 1812167 */   // Label 24592: @1812167
     /* 1812167 */   GIM_Try, /*On fail goto*//*Label 24593*/ GIMT_Encode4(1812253), // Rule ID 12658 //
     /* 1812172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1812183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1812186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1812189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1812192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812218 */     // MIs[0] policy
     /* 1812218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812228 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1812231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812252 */     // GIR_Coverage, 12658,
     /* 1812252 */     GIR_EraseRootFromParent_Done,
     /* 1812253 */   // Label 24593: @1812253
     /* 1812253 */   GIM_Try, /*On fail goto*//*Label 24594*/ GIMT_Encode4(1812339), // Rule ID 12659 //
     /* 1812258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1812269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1812272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1812275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1812278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812304 */     // MIs[0] policy
     /* 1812304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1812317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812338 */     // GIR_Coverage, 12659,
     /* 1812338 */     GIR_EraseRootFromParent_Done,
     /* 1812339 */   // Label 24594: @1812339
     /* 1812339 */   GIM_Try, /*On fail goto*//*Label 24595*/ GIMT_Encode4(1812425), // Rule ID 12662 //
     /* 1812344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1812355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1812358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1812361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1812364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1812367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812390 */     // MIs[0] policy
     /* 1812390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1812403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812424 */     // GIR_Coverage, 12662,
     /* 1812424 */     GIR_EraseRootFromParent_Done,
     /* 1812425 */   // Label 24595: @1812425
     /* 1812425 */   GIM_Try, /*On fail goto*//*Label 24596*/ GIMT_Encode4(1812511), // Rule ID 12663 //
     /* 1812430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1812441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1812444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1812447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1812450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1812453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812476 */     // MIs[0] policy
     /* 1812476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1812489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812510 */     // GIR_Coverage, 12663,
     /* 1812510 */     GIR_EraseRootFromParent_Done,
     /* 1812511 */   // Label 24596: @1812511
     /* 1812511 */   GIM_Try, /*On fail goto*//*Label 24597*/ GIMT_Encode4(1812597), // Rule ID 12666 //
     /* 1812516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1812527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1812530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1812533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1812536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812562 */     // MIs[0] policy
     /* 1812562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812572 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1812575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812596 */     // GIR_Coverage, 12666,
     /* 1812596 */     GIR_EraseRootFromParent_Done,
     /* 1812597 */   // Label 24597: @1812597
     /* 1812597 */   GIM_Try, /*On fail goto*//*Label 24598*/ GIMT_Encode4(1812683), // Rule ID 12667 //
     /* 1812602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1812613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1812616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1812619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1812622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812648 */     // MIs[0] policy
     /* 1812648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812658 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1812661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812682 */     // GIR_Coverage, 12667,
     /* 1812682 */     GIR_EraseRootFromParent_Done,
     /* 1812683 */   // Label 24598: @1812683
     /* 1812683 */   GIM_Try, /*On fail goto*//*Label 24599*/ GIMT_Encode4(1812769), // Rule ID 12670 //
     /* 1812688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1812699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1812702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1812705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1812708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812734 */     // MIs[0] policy
     /* 1812734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1812747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812768 */     // GIR_Coverage, 12670,
     /* 1812768 */     GIR_EraseRootFromParent_Done,
     /* 1812769 */   // Label 24599: @1812769
     /* 1812769 */   GIM_Try, /*On fail goto*//*Label 24600*/ GIMT_Encode4(1812855), // Rule ID 12671 //
     /* 1812774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1812785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1812788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1812791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1812794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812820 */     // MIs[0] policy
     /* 1812820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1812833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812854 */     // GIR_Coverage, 12671,
     /* 1812854 */     GIR_EraseRootFromParent_Done,
     /* 1812855 */   // Label 24600: @1812855
     /* 1812855 */   GIM_Try, /*On fail goto*//*Label 24601*/ GIMT_Encode4(1812941), // Rule ID 12674 //
     /* 1812860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1812877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1812880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812906 */     // MIs[0] policy
     /* 1812906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812916 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1812919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812940 */     // GIR_Coverage, 12674,
     /* 1812940 */     GIR_EraseRootFromParent_Done,
     /* 1812941 */   // Label 24601: @1812941
     /* 1812941 */   GIM_Try, /*On fail goto*//*Label 24602*/ GIMT_Encode4(1813027), // Rule ID 12675 //
     /* 1812946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1812963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1812966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812992 */     // MIs[0] policy
     /* 1812992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813002 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1813005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813026 */     // GIR_Coverage, 12675,
     /* 1813026 */     GIR_EraseRootFromParent_Done,
     /* 1813027 */   // Label 24602: @1813027
     /* 1813027 */   GIM_Try, /*On fail goto*//*Label 24603*/ GIMT_Encode4(1813113), // Rule ID 12678 //
     /* 1813032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1813035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1813043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1813046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1813049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1813052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813078 */     // MIs[0] policy
     /* 1813078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813088 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1813091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813112 */     // GIR_Coverage, 12678,
     /* 1813112 */     GIR_EraseRootFromParent_Done,
     /* 1813113 */   // Label 24603: @1813113
     /* 1813113 */   GIM_Try, /*On fail goto*//*Label 24604*/ GIMT_Encode4(1813199), // Rule ID 12679 //
     /* 1813118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1813121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1813129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1813132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1813135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1813138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813164 */     // MIs[0] policy
     /* 1813164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813174 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1813177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813198 */     // GIR_Coverage, 12679,
     /* 1813198 */     GIR_EraseRootFromParent_Done,
     /* 1813199 */   // Label 24604: @1813199
     /* 1813199 */   GIM_Try, /*On fail goto*//*Label 24605*/ GIMT_Encode4(1813285), // Rule ID 12682 //
     /* 1813204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1813215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1813218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1813221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813250 */     // MIs[0] policy
     /* 1813250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813260 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1813263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813284 */     // GIR_Coverage, 12682,
     /* 1813284 */     GIR_EraseRootFromParent_Done,
     /* 1813285 */   // Label 24605: @1813285
     /* 1813285 */   GIM_Try, /*On fail goto*//*Label 24606*/ GIMT_Encode4(1813371), // Rule ID 12683 //
     /* 1813290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1813301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1813304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1813307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813336 */     // MIs[0] policy
     /* 1813336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1813349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813370 */     // GIR_Coverage, 12683,
     /* 1813370 */     GIR_EraseRootFromParent_Done,
     /* 1813371 */   // Label 24606: @1813371
     /* 1813371 */   GIM_Try, /*On fail goto*//*Label 24607*/ GIMT_Encode4(1813457), // Rule ID 12686 //
     /* 1813376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1813387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1813390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1813393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813422 */     // MIs[0] policy
     /* 1813422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813432 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1813435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813456 */     // GIR_Coverage, 12686,
     /* 1813456 */     GIR_EraseRootFromParent_Done,
     /* 1813457 */   // Label 24607: @1813457
     /* 1813457 */   GIM_Try, /*On fail goto*//*Label 24608*/ GIMT_Encode4(1813543), // Rule ID 12687 //
     /* 1813462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1813473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1813476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1813479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813508 */     // MIs[0] policy
     /* 1813508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1813521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813542 */     // GIR_Coverage, 12687,
     /* 1813542 */     GIR_EraseRootFromParent_Done,
     /* 1813543 */   // Label 24608: @1813543
     /* 1813543 */   GIM_Try, /*On fail goto*//*Label 24609*/ GIMT_Encode4(1813629), // Rule ID 12690 //
     /* 1813548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1813559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1813562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1813565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813594 */     // MIs[0] policy
     /* 1813594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813604 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1813607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813628 */     // GIR_Coverage, 12690,
     /* 1813628 */     GIR_EraseRootFromParent_Done,
     /* 1813629 */   // Label 24609: @1813629
     /* 1813629 */   GIM_Try, /*On fail goto*//*Label 24610*/ GIMT_Encode4(1813715), // Rule ID 12691 //
     /* 1813634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1813645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1813648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1813651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813680 */     // MIs[0] policy
     /* 1813680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813690 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1813693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813714 */     // GIR_Coverage, 12691,
     /* 1813714 */     GIR_EraseRootFromParent_Done,
     /* 1813715 */   // Label 24610: @1813715
     /* 1813715 */   GIM_Try, /*On fail goto*//*Label 24611*/ GIMT_Encode4(1813801), // Rule ID 12694 //
     /* 1813720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1813731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1813734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1813737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813766 */     // MIs[0] policy
     /* 1813766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1813779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813800 */     // GIR_Coverage, 12694,
     /* 1813800 */     GIR_EraseRootFromParent_Done,
     /* 1813801 */   // Label 24611: @1813801
     /* 1813801 */   GIM_Try, /*On fail goto*//*Label 24612*/ GIMT_Encode4(1813887), // Rule ID 12695 //
     /* 1813806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1813817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1813820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1813823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813852 */     // MIs[0] policy
     /* 1813852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1813865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813886 */     // GIR_Coverage, 12695,
     /* 1813886 */     GIR_EraseRootFromParent_Done,
     /* 1813887 */   // Label 24612: @1813887
     /* 1813887 */   GIM_Try, /*On fail goto*//*Label 24613*/ GIMT_Encode4(1813973), // Rule ID 12698 //
     /* 1813892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1813903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1813906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1813909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1813915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1813922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813938 */     // MIs[0] policy
     /* 1813938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813948 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1813951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813972 */     // GIR_Coverage, 12698,
     /* 1813972 */     GIR_EraseRootFromParent_Done,
     /* 1813973 */   // Label 24613: @1813973
     /* 1813973 */   GIM_Try, /*On fail goto*//*Label 24614*/ GIMT_Encode4(1814059), // Rule ID 12699 //
     /* 1813978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1813989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1813992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1813995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814024 */     // MIs[0] policy
     /* 1814024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1814037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814058 */     // GIR_Coverage, 12699,
     /* 1814058 */     GIR_EraseRootFromParent_Done,
     /* 1814059 */   // Label 24614: @1814059
     /* 1814059 */   GIM_Try, /*On fail goto*//*Label 24615*/ GIMT_Encode4(1814145), // Rule ID 12702 //
     /* 1814064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1814075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1814078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1814081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1814087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814110 */     // MIs[0] policy
     /* 1814110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814120 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1814123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814144 */     // GIR_Coverage, 12702,
     /* 1814144 */     GIR_EraseRootFromParent_Done,
     /* 1814145 */   // Label 24615: @1814145
     /* 1814145 */   GIM_Try, /*On fail goto*//*Label 24616*/ GIMT_Encode4(1814231), // Rule ID 12703 //
     /* 1814150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1814161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1814164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1814167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1814173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814196 */     // MIs[0] policy
     /* 1814196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1814209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814230 */     // GIR_Coverage, 12703,
     /* 1814230 */     GIR_EraseRootFromParent_Done,
     /* 1814231 */   // Label 24616: @1814231
     /* 1814231 */   GIM_Try, /*On fail goto*//*Label 24617*/ GIMT_Encode4(1814317), // Rule ID 12706 //
     /* 1814236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1814247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1814250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1814253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814282 */     // MIs[0] policy
     /* 1814282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814292 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1814295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814316 */     // GIR_Coverage, 12706,
     /* 1814316 */     GIR_EraseRootFromParent_Done,
     /* 1814317 */   // Label 24617: @1814317
     /* 1814317 */   GIM_Try, /*On fail goto*//*Label 24618*/ GIMT_Encode4(1814403), // Rule ID 12707 //
     /* 1814322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1814333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1814336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1814339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814368 */     // MIs[0] policy
     /* 1814368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1814381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814402 */     // GIR_Coverage, 12707,
     /* 1814402 */     GIR_EraseRootFromParent_Done,
     /* 1814403 */   // Label 24618: @1814403
     /* 1814403 */   GIM_Try, /*On fail goto*//*Label 24619*/ GIMT_Encode4(1814489), // Rule ID 12710 //
     /* 1814408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1814419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1814422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1814425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814454 */     // MIs[0] policy
     /* 1814454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1814467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814488 */     // GIR_Coverage, 12710,
     /* 1814488 */     GIR_EraseRootFromParent_Done,
     /* 1814489 */   // Label 24619: @1814489
     /* 1814489 */   GIM_Try, /*On fail goto*//*Label 24620*/ GIMT_Encode4(1814575), // Rule ID 12711 //
     /* 1814494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1814505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1814508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1814511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814540 */     // MIs[0] policy
     /* 1814540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1814553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814574 */     // GIR_Coverage, 12711,
     /* 1814574 */     GIR_EraseRootFromParent_Done,
     /* 1814575 */   // Label 24620: @1814575
     /* 1814575 */   GIM_Try, /*On fail goto*//*Label 24621*/ GIMT_Encode4(1814661), // Rule ID 12714 //
     /* 1814580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1814591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1814594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1814597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814626 */     // MIs[0] policy
     /* 1814626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1814639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814660 */     // GIR_Coverage, 12714,
     /* 1814660 */     GIR_EraseRootFromParent_Done,
     /* 1814661 */   // Label 24621: @1814661
     /* 1814661 */   GIM_Try, /*On fail goto*//*Label 24622*/ GIMT_Encode4(1814747), // Rule ID 12715 //
     /* 1814666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1814677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1814680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1814683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814712 */     // MIs[0] policy
     /* 1814712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1814725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814746 */     // GIR_Coverage, 12715,
     /* 1814746 */     GIR_EraseRootFromParent_Done,
     /* 1814747 */   // Label 24622: @1814747
     /* 1814747 */   GIM_Try, /*On fail goto*//*Label 24623*/ GIMT_Encode4(1814833), // Rule ID 12718 //
     /* 1814752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1814763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1814766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1814769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814798 */     // MIs[0] policy
     /* 1814798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814808 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1814811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814832 */     // GIR_Coverage, 12718,
     /* 1814832 */     GIR_EraseRootFromParent_Done,
     /* 1814833 */   // Label 24623: @1814833
     /* 1814833 */   GIM_Try, /*On fail goto*//*Label 24624*/ GIMT_Encode4(1814919), // Rule ID 12719 //
     /* 1814838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1814849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1814852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1814855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814884 */     // MIs[0] policy
     /* 1814884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814894 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1814897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814918 */     // GIR_Coverage, 12719,
     /* 1814918 */     GIR_EraseRootFromParent_Done,
     /* 1814919 */   // Label 24624: @1814919
     /* 1814919 */   GIM_Try, /*On fail goto*//*Label 24625*/ GIMT_Encode4(1815005), // Rule ID 12722 //
     /* 1814924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1814935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1814938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1814941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814970 */     // MIs[0] policy
     /* 1814970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814980 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1814983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815004 */     // GIR_Coverage, 12722,
     /* 1815004 */     GIR_EraseRootFromParent_Done,
     /* 1815005 */   // Label 24625: @1815005
     /* 1815005 */   GIM_Try, /*On fail goto*//*Label 24626*/ GIMT_Encode4(1815091), // Rule ID 12723 //
     /* 1815010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1815021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1815024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1815027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1815033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815056 */     // MIs[0] policy
     /* 1815056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815066 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1815069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815090 */     // GIR_Coverage, 12723,
     /* 1815090 */     GIR_EraseRootFromParent_Done,
     /* 1815091 */   // Label 24626: @1815091
     /* 1815091 */   GIM_Try, /*On fail goto*//*Label 24627*/ GIMT_Encode4(1815177), // Rule ID 12726 //
     /* 1815096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1815099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1815107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1815110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1815113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1815116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815142 */     // MIs[0] policy
     /* 1815142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1815155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815176 */     // GIR_Coverage, 12726,
     /* 1815176 */     GIR_EraseRootFromParent_Done,
     /* 1815177 */   // Label 24627: @1815177
     /* 1815177 */   GIM_Try, /*On fail goto*//*Label 24628*/ GIMT_Encode4(1815263), // Rule ID 12727 //
     /* 1815182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1815193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1815196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1815199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815228 */     // MIs[0] policy
     /* 1815228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815238 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1815241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815262 */     // GIR_Coverage, 12727,
     /* 1815262 */     GIR_EraseRootFromParent_Done,
     /* 1815263 */   // Label 24628: @1815263
     /* 1815263 */   GIM_Try, /*On fail goto*//*Label 24629*/ GIMT_Encode4(1815349), // Rule ID 12730 //
     /* 1815268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1815271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1815279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1815282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1815285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1815288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815314 */     // MIs[0] policy
     /* 1815314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1815327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815348 */     // GIR_Coverage, 12730,
     /* 1815348 */     GIR_EraseRootFromParent_Done,
     /* 1815349 */   // Label 24629: @1815349
     /* 1815349 */   GIM_Try, /*On fail goto*//*Label 24630*/ GIMT_Encode4(1815435), // Rule ID 12731 //
     /* 1815354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1815365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1815368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1815371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815400 */     // MIs[0] policy
     /* 1815400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1815413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815434 */     // GIR_Coverage, 12731,
     /* 1815434 */     GIR_EraseRootFromParent_Done,
     /* 1815435 */   // Label 24630: @1815435
     /* 1815435 */   GIM_Try, /*On fail goto*//*Label 24631*/ GIMT_Encode4(1815521), // Rule ID 12734 //
     /* 1815440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1815443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1815451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1815454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1815457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1815460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815486 */     // MIs[0] policy
     /* 1815486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1815499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815520 */     // GIR_Coverage, 12734,
     /* 1815520 */     GIR_EraseRootFromParent_Done,
     /* 1815521 */   // Label 24631: @1815521
     /* 1815521 */   GIM_Try, /*On fail goto*//*Label 24632*/ GIMT_Encode4(1815607), // Rule ID 12735 //
     /* 1815526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1815537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1815540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1815543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815572 */     // MIs[0] policy
     /* 1815572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815582 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1815585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815606 */     // GIR_Coverage, 12735,
     /* 1815606 */     GIR_EraseRootFromParent_Done,
     /* 1815607 */   // Label 24632: @1815607
     /* 1815607 */   GIM_Try, /*On fail goto*//*Label 24633*/ GIMT_Encode4(1815693), // Rule ID 12738 //
     /* 1815612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1815615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1815623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1815626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1815629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1815632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815658 */     // MIs[0] policy
     /* 1815658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815668 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1815671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815692 */     // GIR_Coverage, 12738,
     /* 1815692 */     GIR_EraseRootFromParent_Done,
     /* 1815693 */   // Label 24633: @1815693
     /* 1815693 */   GIM_Try, /*On fail goto*//*Label 24634*/ GIMT_Encode4(1815779), // Rule ID 12739 //
     /* 1815698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1815709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1815712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1815715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815744 */     // MIs[0] policy
     /* 1815744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815754 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1815757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815778 */     // GIR_Coverage, 12739,
     /* 1815778 */     GIR_EraseRootFromParent_Done,
     /* 1815779 */   // Label 24634: @1815779
     /* 1815779 */   GIM_Try, /*On fail goto*//*Label 24635*/ GIMT_Encode4(1815865), // Rule ID 12742 //
     /* 1815784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1815795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1815798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1815801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1815804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815830 */     // MIs[0] policy
     /* 1815830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815840 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1815843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815864 */     // GIR_Coverage, 12742,
     /* 1815864 */     GIR_EraseRootFromParent_Done,
     /* 1815865 */   // Label 24635: @1815865
     /* 1815865 */   GIM_Try, /*On fail goto*//*Label 24636*/ GIMT_Encode4(1815951), // Rule ID 12743 //
     /* 1815870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1815881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1815884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1815887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1815890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815916 */     // MIs[0] policy
     /* 1815916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815926 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1815929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815950 */     // GIR_Coverage, 12743,
     /* 1815950 */     GIR_EraseRootFromParent_Done,
     /* 1815951 */   // Label 24636: @1815951
     /* 1815951 */   GIM_Try, /*On fail goto*//*Label 24637*/ GIMT_Encode4(1816037), // Rule ID 12746 //
     /* 1815956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1815967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1815970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1815973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1815976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816002 */     // MIs[0] policy
     /* 1816002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816012 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816036 */     // GIR_Coverage, 12746,
     /* 1816036 */     GIR_EraseRootFromParent_Done,
     /* 1816037 */   // Label 24637: @1816037
     /* 1816037 */   GIM_Try, /*On fail goto*//*Label 24638*/ GIMT_Encode4(1816123), // Rule ID 12747 //
     /* 1816042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1816053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1816056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1816059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1816062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816088 */     // MIs[0] policy
     /* 1816088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816098 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816122 */     // GIR_Coverage, 12747,
     /* 1816122 */     GIR_EraseRootFromParent_Done,
     /* 1816123 */   // Label 24638: @1816123
     /* 1816123 */   GIM_Try, /*On fail goto*//*Label 24639*/ GIMT_Encode4(1816209), // Rule ID 12750 //
     /* 1816128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1816139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1816142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1816145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1816148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816174 */     // MIs[0] policy
     /* 1816174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816184 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1816187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816208 */     // GIR_Coverage, 12750,
     /* 1816208 */     GIR_EraseRootFromParent_Done,
     /* 1816209 */   // Label 24639: @1816209
     /* 1816209 */   GIM_Try, /*On fail goto*//*Label 24640*/ GIMT_Encode4(1816295), // Rule ID 12751 //
     /* 1816214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1816225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1816228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1816231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1816234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816260 */     // MIs[0] policy
     /* 1816260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816270 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1816273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816294 */     // GIR_Coverage, 12751,
     /* 1816294 */     GIR_EraseRootFromParent_Done,
     /* 1816295 */   // Label 24640: @1816295
     /* 1816295 */   GIM_Try, /*On fail goto*//*Label 24641*/ GIMT_Encode4(1816381), // Rule ID 12754 //
     /* 1816300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1816311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1816314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1816317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1816320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816346 */     // MIs[0] policy
     /* 1816346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816356 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816380 */     // GIR_Coverage, 12754,
     /* 1816380 */     GIR_EraseRootFromParent_Done,
     /* 1816381 */   // Label 24641: @1816381
     /* 1816381 */   GIM_Try, /*On fail goto*//*Label 24642*/ GIMT_Encode4(1816467), // Rule ID 12755 //
     /* 1816386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1816397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1816400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1816403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1816406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816432 */     // MIs[0] policy
     /* 1816432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816442 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816466 */     // GIR_Coverage, 12755,
     /* 1816466 */     GIR_EraseRootFromParent_Done,
     /* 1816467 */   // Label 24642: @1816467
     /* 1816467 */   GIM_Try, /*On fail goto*//*Label 24643*/ GIMT_Encode4(1816553), // Rule ID 12758 //
     /* 1816472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1816483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1816486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1816489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1816492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816518 */     // MIs[0] policy
     /* 1816518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816528 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816552 */     // GIR_Coverage, 12758,
     /* 1816552 */     GIR_EraseRootFromParent_Done,
     /* 1816553 */   // Label 24643: @1816553
     /* 1816553 */   GIM_Try, /*On fail goto*//*Label 24644*/ GIMT_Encode4(1816639), // Rule ID 12759 //
     /* 1816558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1816569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1816572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1816575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1816578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816604 */     // MIs[0] policy
     /* 1816604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816614 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816638 */     // GIR_Coverage, 12759,
     /* 1816638 */     GIR_EraseRootFromParent_Done,
     /* 1816639 */   // Label 24644: @1816639
     /* 1816639 */   GIM_Try, /*On fail goto*//*Label 24645*/ GIMT_Encode4(1816725), // Rule ID 12762 //
     /* 1816644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1816655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1816658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1816661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1816664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816690 */     // MIs[0] policy
     /* 1816690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816700 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816724 */     // GIR_Coverage, 12762,
     /* 1816724 */     GIR_EraseRootFromParent_Done,
     /* 1816725 */   // Label 24645: @1816725
     /* 1816725 */   GIM_Try, /*On fail goto*//*Label 24646*/ GIMT_Encode4(1816811), // Rule ID 12763 //
     /* 1816730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1816741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1816744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1816747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1816750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816776 */     // MIs[0] policy
     /* 1816776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816786 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816810 */     // GIR_Coverage, 12763,
     /* 1816810 */     GIR_EraseRootFromParent_Done,
     /* 1816811 */   // Label 24646: @1816811
     /* 1816811 */   GIM_Try, /*On fail goto*//*Label 24647*/ GIMT_Encode4(1816897), // Rule ID 12766 //
     /* 1816816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1816827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1816830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1816833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1816836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816862 */     // MIs[0] policy
     /* 1816862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816896 */     // GIR_Coverage, 12766,
     /* 1816896 */     GIR_EraseRootFromParent_Done,
     /* 1816897 */   // Label 24647: @1816897
     /* 1816897 */   GIM_Try, /*On fail goto*//*Label 24648*/ GIMT_Encode4(1816983), // Rule ID 12767 //
     /* 1816902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1816913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1816916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1816919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1816922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816948 */     // MIs[0] policy
     /* 1816948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816958 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816982 */     // GIR_Coverage, 12767,
     /* 1816982 */     GIR_EraseRootFromParent_Done,
     /* 1816983 */   // Label 24648: @1816983
     /* 1816983 */   GIM_Try, /*On fail goto*//*Label 24649*/ GIMT_Encode4(1817069), // Rule ID 12770 //
     /* 1816988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1816999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1817002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1817005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1817008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817034 */     // MIs[0] policy
     /* 1817034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817044 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1817047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817068 */     // GIR_Coverage, 12770,
     /* 1817068 */     GIR_EraseRootFromParent_Done,
     /* 1817069 */   // Label 24649: @1817069
     /* 1817069 */   GIM_Try, /*On fail goto*//*Label 24650*/ GIMT_Encode4(1817155), // Rule ID 12771 //
     /* 1817074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1817085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1817088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1817091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1817094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817120 */     // MIs[0] policy
     /* 1817120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1817133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817154 */     // GIR_Coverage, 12771,
     /* 1817154 */     GIR_EraseRootFromParent_Done,
     /* 1817155 */   // Label 24650: @1817155
     /* 1817155 */   GIM_Try, /*On fail goto*//*Label 24651*/ GIMT_Encode4(1817241), // Rule ID 12774 //
     /* 1817160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1817163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1817171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1817174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1817177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1817180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817206 */     // MIs[0] policy
     /* 1817206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817216 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1817219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1817237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817240 */     // GIR_Coverage, 12774,
     /* 1817240 */     GIR_EraseRootFromParent_Done,
     /* 1817241 */   // Label 24651: @1817241
     /* 1817241 */   GIM_Try, /*On fail goto*//*Label 24652*/ GIMT_Encode4(1817327), // Rule ID 12775 //
     /* 1817246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1817249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1817257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1817260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1817263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1817266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817292 */     // MIs[0] policy
     /* 1817292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817302 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1817305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1817323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817326 */     // GIR_Coverage, 12775,
     /* 1817326 */     GIR_EraseRootFromParent_Done,
     /* 1817327 */   // Label 24652: @1817327
     /* 1817327 */   GIM_Try, /*On fail goto*//*Label 24653*/ GIMT_Encode4(1817413), // Rule ID 12778 //
     /* 1817332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1817343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1817346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1817349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1817352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1817355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817378 */     // MIs[0] policy
     /* 1817378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817388 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817412 */     // GIR_Coverage, 12778,
     /* 1817412 */     GIR_EraseRootFromParent_Done,
     /* 1817413 */   // Label 24653: @1817413
     /* 1817413 */   GIM_Try, /*On fail goto*//*Label 24654*/ GIMT_Encode4(1817499), // Rule ID 12779 //
     /* 1817418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1817429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1817432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1817435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1817438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1817441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817464 */     // MIs[0] policy
     /* 1817464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817498 */     // GIR_Coverage, 12779,
     /* 1817498 */     GIR_EraseRootFromParent_Done,
     /* 1817499 */   // Label 24654: @1817499
     /* 1817499 */   GIM_Try, /*On fail goto*//*Label 24655*/ GIMT_Encode4(1817585), // Rule ID 12782 //
     /* 1817504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1817515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1817518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1817521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1817524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817550 */     // MIs[0] policy
     /* 1817550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817560 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1817563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817584 */     // GIR_Coverage, 12782,
     /* 1817584 */     GIR_EraseRootFromParent_Done,
     /* 1817585 */   // Label 24655: @1817585
     /* 1817585 */   GIM_Try, /*On fail goto*//*Label 24656*/ GIMT_Encode4(1817671), // Rule ID 12783 //
     /* 1817590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1817601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1817604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1817607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1817610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817636 */     // MIs[0] policy
     /* 1817636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817646 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1817649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817670 */     // GIR_Coverage, 12783,
     /* 1817670 */     GIR_EraseRootFromParent_Done,
     /* 1817671 */   // Label 24656: @1817671
     /* 1817671 */   GIM_Try, /*On fail goto*//*Label 24657*/ GIMT_Encode4(1817757), // Rule ID 12786 //
     /* 1817676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1817687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1817690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1817693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1817696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1817699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817722 */     // MIs[0] policy
     /* 1817722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817732 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1817735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817756 */     // GIR_Coverage, 12786,
     /* 1817756 */     GIR_EraseRootFromParent_Done,
     /* 1817757 */   // Label 24657: @1817757
     /* 1817757 */   GIM_Try, /*On fail goto*//*Label 24658*/ GIMT_Encode4(1817843), // Rule ID 12787 //
     /* 1817762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1817773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1817776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1817779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1817782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1817785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817808 */     // MIs[0] policy
     /* 1817808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817818 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1817821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817842 */     // GIR_Coverage, 12787,
     /* 1817842 */     GIR_EraseRootFromParent_Done,
     /* 1817843 */   // Label 24658: @1817843
     /* 1817843 */   GIM_Try, /*On fail goto*//*Label 24659*/ GIMT_Encode4(1817929), // Rule ID 12790 //
     /* 1817848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1817859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1817862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1817865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1817868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817894 */     // MIs[0] policy
     /* 1817894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817904 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817928 */     // GIR_Coverage, 12790,
     /* 1817928 */     GIR_EraseRootFromParent_Done,
     /* 1817929 */   // Label 24659: @1817929
     /* 1817929 */   GIM_Try, /*On fail goto*//*Label 24660*/ GIMT_Encode4(1818015), // Rule ID 12791 //
     /* 1817934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1817945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1817948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1817951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1817954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817980 */     // MIs[0] policy
     /* 1817980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817990 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818014 */     // GIR_Coverage, 12791,
     /* 1818014 */     GIR_EraseRootFromParent_Done,
     /* 1818015 */   // Label 24660: @1818015
     /* 1818015 */   GIM_Try, /*On fail goto*//*Label 24661*/ GIMT_Encode4(1818101), // Rule ID 12794 //
     /* 1818020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1818031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1818034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1818037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1818040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818066 */     // MIs[0] policy
     /* 1818066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818076 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818100 */     // GIR_Coverage, 12794,
     /* 1818100 */     GIR_EraseRootFromParent_Done,
     /* 1818101 */   // Label 24661: @1818101
     /* 1818101 */   GIM_Try, /*On fail goto*//*Label 24662*/ GIMT_Encode4(1818187), // Rule ID 12795 //
     /* 1818106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1818117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1818120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1818123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1818126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818152 */     // MIs[0] policy
     /* 1818152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818162 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818186 */     // GIR_Coverage, 12795,
     /* 1818186 */     GIR_EraseRootFromParent_Done,
     /* 1818187 */   // Label 24662: @1818187
     /* 1818187 */   GIM_Try, /*On fail goto*//*Label 24663*/ GIMT_Encode4(1818273), // Rule ID 12798 //
     /* 1818192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1818203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1818206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1818209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1818212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1818215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818238 */     // MIs[0] policy
     /* 1818238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818248 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818272 */     // GIR_Coverage, 12798,
     /* 1818272 */     GIR_EraseRootFromParent_Done,
     /* 1818273 */   // Label 24663: @1818273
     /* 1818273 */   GIM_Try, /*On fail goto*//*Label 24664*/ GIMT_Encode4(1818359), // Rule ID 12799 //
     /* 1818278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1818289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1818292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1818295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1818298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1818301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818324 */     // MIs[0] policy
     /* 1818324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818334 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818358 */     // GIR_Coverage, 12799,
     /* 1818358 */     GIR_EraseRootFromParent_Done,
     /* 1818359 */   // Label 24664: @1818359
     /* 1818359 */   GIM_Try, /*On fail goto*//*Label 24665*/ GIMT_Encode4(1818445), // Rule ID 12802 //
     /* 1818364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1818375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1818378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1818381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1818384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818410 */     // MIs[0] policy
     /* 1818410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1818423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818444 */     // GIR_Coverage, 12802,
     /* 1818444 */     GIR_EraseRootFromParent_Done,
     /* 1818445 */   // Label 24665: @1818445
     /* 1818445 */   GIM_Try, /*On fail goto*//*Label 24666*/ GIMT_Encode4(1818531), // Rule ID 12803 //
     /* 1818450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1818461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1818464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1818467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1818470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818496 */     // MIs[0] policy
     /* 1818496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818506 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1818509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818530 */     // GIR_Coverage, 12803,
     /* 1818530 */     GIR_EraseRootFromParent_Done,
     /* 1818531 */   // Label 24666: @1818531
     /* 1818531 */   GIM_Try, /*On fail goto*//*Label 24667*/ GIMT_Encode4(1818617), // Rule ID 12806 //
     /* 1818536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1818547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1818550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1818553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1818556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818582 */     // MIs[0] policy
     /* 1818582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818616 */     // GIR_Coverage, 12806,
     /* 1818616 */     GIR_EraseRootFromParent_Done,
     /* 1818617 */   // Label 24667: @1818617
     /* 1818617 */   GIM_Try, /*On fail goto*//*Label 24668*/ GIMT_Encode4(1818703), // Rule ID 12807 //
     /* 1818622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1818633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1818636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1818639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1818642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818668 */     // MIs[0] policy
     /* 1818668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818678 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818702 */     // GIR_Coverage, 12807,
     /* 1818702 */     GIR_EraseRootFromParent_Done,
     /* 1818703 */   // Label 24668: @1818703
     /* 1818703 */   GIM_Try, /*On fail goto*//*Label 24669*/ GIMT_Encode4(1818789), // Rule ID 12810 //
     /* 1818708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1818719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1818722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1818725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1818728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818754 */     // MIs[0] policy
     /* 1818754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818764 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818788 */     // GIR_Coverage, 12810,
     /* 1818788 */     GIR_EraseRootFromParent_Done,
     /* 1818789 */   // Label 24669: @1818789
     /* 1818789 */   GIM_Try, /*On fail goto*//*Label 24670*/ GIMT_Encode4(1818875), // Rule ID 12811 //
     /* 1818794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1818805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1818808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1818811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1818814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818840 */     // MIs[0] policy
     /* 1818840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818850 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818874 */     // GIR_Coverage, 12811,
     /* 1818874 */     GIR_EraseRootFromParent_Done,
     /* 1818875 */   // Label 24670: @1818875
     /* 1818875 */   GIM_Try, /*On fail goto*//*Label 24671*/ GIMT_Encode4(1818961), // Rule ID 12814 //
     /* 1818880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1818883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1818891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1818894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1818897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1818900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818926 */     // MIs[0] policy
     /* 1818926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1818939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818960 */     // GIR_Coverage, 12814,
     /* 1818960 */     GIR_EraseRootFromParent_Done,
     /* 1818961 */   // Label 24671: @1818961
     /* 1818961 */   GIM_Try, /*On fail goto*//*Label 24672*/ GIMT_Encode4(1819047), // Rule ID 12815 //
     /* 1818966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1818969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1818977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1818980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1818983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1818986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819012 */     // MIs[0] policy
     /* 1819012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819022 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1819025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819046 */     // GIR_Coverage, 12815,
     /* 1819046 */     GIR_EraseRootFromParent_Done,
     /* 1819047 */   // Label 24672: @1819047
     /* 1819047 */   GIM_Try, /*On fail goto*//*Label 24673*/ GIMT_Encode4(1819133), // Rule ID 12818 //
     /* 1819052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1819055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1819063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1819066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1819069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1819072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819098 */     // MIs[0] policy
     /* 1819098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819108 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1819111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819132 */     // GIR_Coverage, 12818,
     /* 1819132 */     GIR_EraseRootFromParent_Done,
     /* 1819133 */   // Label 24673: @1819133
     /* 1819133 */   GIM_Try, /*On fail goto*//*Label 24674*/ GIMT_Encode4(1819219), // Rule ID 12819 //
     /* 1819138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1819141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1819149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1819152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1819155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1819158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819184 */     // MIs[0] policy
     /* 1819184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819194 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1819197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819218 */     // GIR_Coverage, 12819,
     /* 1819218 */     GIR_EraseRootFromParent_Done,
     /* 1819219 */   // Label 24674: @1819219
     /* 1819219 */   GIM_Try, /*On fail goto*//*Label 24675*/ GIMT_Encode4(1819305), // Rule ID 12822 //
     /* 1819224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1819227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1819235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1819238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1819241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1819244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819270 */     // MIs[0] policy
     /* 1819270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819280 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1819283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819304 */     // GIR_Coverage, 12822,
     /* 1819304 */     GIR_EraseRootFromParent_Done,
     /* 1819305 */   // Label 24675: @1819305
     /* 1819305 */   GIM_Try, /*On fail goto*//*Label 24676*/ GIMT_Encode4(1819391), // Rule ID 12823 //
     /* 1819310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1819313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1819321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1819324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1819327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1819330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819356 */     // MIs[0] policy
     /* 1819356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819366 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1819369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819390 */     // GIR_Coverage, 12823,
     /* 1819390 */     GIR_EraseRootFromParent_Done,
     /* 1819391 */   // Label 24676: @1819391
     /* 1819391 */   GIM_Try, /*On fail goto*//*Label 24677*/ GIMT_Encode4(1819477), // Rule ID 12826 //
     /* 1819396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1819407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1819410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1819416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819442 */     // MIs[0] policy
     /* 1819442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819452 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1819455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819476 */     // GIR_Coverage, 12826,
     /* 1819476 */     GIR_EraseRootFromParent_Done,
     /* 1819477 */   // Label 24677: @1819477
     /* 1819477 */   GIM_Try, /*On fail goto*//*Label 24678*/ GIMT_Encode4(1819563), // Rule ID 12827 //
     /* 1819482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1819493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1819496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1819502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819528 */     // MIs[0] policy
     /* 1819528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819538 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1819541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819562 */     // GIR_Coverage, 12827,
     /* 1819562 */     GIR_EraseRootFromParent_Done,
     /* 1819563 */   // Label 24678: @1819563
     /* 1819563 */   GIM_Try, /*On fail goto*//*Label 24679*/ GIMT_Encode4(1819649), // Rule ID 12830 //
     /* 1819568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1819579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1819582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1819588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819614 */     // MIs[0] policy
     /* 1819614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819624 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819648 */     // GIR_Coverage, 12830,
     /* 1819648 */     GIR_EraseRootFromParent_Done,
     /* 1819649 */   // Label 24679: @1819649
     /* 1819649 */   GIM_Try, /*On fail goto*//*Label 24680*/ GIMT_Encode4(1819735), // Rule ID 12831 //
     /* 1819654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1819665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1819668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1819674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819700 */     // MIs[0] policy
     /* 1819700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819710 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819734 */     // GIR_Coverage, 12831,
     /* 1819734 */     GIR_EraseRootFromParent_Done,
     /* 1819735 */   // Label 24680: @1819735
     /* 1819735 */   GIM_Try, /*On fail goto*//*Label 24681*/ GIMT_Encode4(1819821), // Rule ID 12834 //
     /* 1819740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1819751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1819754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1819760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819786 */     // MIs[0] policy
     /* 1819786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819820 */     // GIR_Coverage, 12834,
     /* 1819820 */     GIR_EraseRootFromParent_Done,
     /* 1819821 */   // Label 24681: @1819821
     /* 1819821 */   GIM_Try, /*On fail goto*//*Label 24682*/ GIMT_Encode4(1819907), // Rule ID 12835 //
     /* 1819826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1819837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1819840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1819846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819872 */     // MIs[0] policy
     /* 1819872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819882 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819906 */     // GIR_Coverage, 12835,
     /* 1819906 */     GIR_EraseRootFromParent_Done,
     /* 1819907 */   // Label 24682: @1819907
     /* 1819907 */   GIM_Try, /*On fail goto*//*Label 24683*/ GIMT_Encode4(1819993), // Rule ID 12838 //
     /* 1819912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1819923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1819926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1819932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819958 */     // MIs[0] policy
     /* 1819958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819968 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819992 */     // GIR_Coverage, 12838,
     /* 1819992 */     GIR_EraseRootFromParent_Done,
     /* 1819993 */   // Label 24683: @1819993
     /* 1819993 */   GIM_Try, /*On fail goto*//*Label 24684*/ GIMT_Encode4(1820079), // Rule ID 12839 //
     /* 1819998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1820009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1820012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1820018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820044 */     // MIs[0] policy
     /* 1820044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820054 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1820057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820078 */     // GIR_Coverage, 12839,
     /* 1820078 */     GIR_EraseRootFromParent_Done,
     /* 1820079 */   // Label 24684: @1820079
     /* 1820079 */   GIM_Try, /*On fail goto*//*Label 24685*/ GIMT_Encode4(1820165), // Rule ID 12842 //
     /* 1820084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1820095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1820098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1820104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820130 */     // MIs[0] policy
     /* 1820130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820140 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1820143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820164 */     // GIR_Coverage, 12842,
     /* 1820164 */     GIR_EraseRootFromParent_Done,
     /* 1820165 */   // Label 24685: @1820165
     /* 1820165 */   GIM_Try, /*On fail goto*//*Label 24686*/ GIMT_Encode4(1820251), // Rule ID 12843 //
     /* 1820170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1820181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1820184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1820190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820216 */     // MIs[0] policy
     /* 1820216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820226 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1820229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820250 */     // GIR_Coverage, 12843,
     /* 1820250 */     GIR_EraseRootFromParent_Done,
     /* 1820251 */   // Label 24686: @1820251
     /* 1820251 */   GIM_Try, /*On fail goto*//*Label 24687*/ GIMT_Encode4(1820337), // Rule ID 12846 //
     /* 1820256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1820267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1820270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1820276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820302 */     // MIs[0] policy
     /* 1820302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820312 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1820315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820336 */     // GIR_Coverage, 12846,
     /* 1820336 */     GIR_EraseRootFromParent_Done,
     /* 1820337 */   // Label 24687: @1820337
     /* 1820337 */   GIM_Try, /*On fail goto*//*Label 24688*/ GIMT_Encode4(1820423), // Rule ID 12847 //
     /* 1820342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1820353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1820356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1820362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820388 */     // MIs[0] policy
     /* 1820388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820398 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1820401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820422 */     // GIR_Coverage, 12847,
     /* 1820422 */     GIR_EraseRootFromParent_Done,
     /* 1820423 */   // Label 24688: @1820423
     /* 1820423 */   GIM_Try, /*On fail goto*//*Label 24689*/ GIMT_Encode4(1820509), // Rule ID 12850 //
     /* 1820428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1820439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1820442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1820448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1820451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820474 */     // MIs[0] policy
     /* 1820474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820484 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820508 */     // GIR_Coverage, 12850,
     /* 1820508 */     GIR_EraseRootFromParent_Done,
     /* 1820509 */   // Label 24689: @1820509
     /* 1820509 */   GIM_Try, /*On fail goto*//*Label 24690*/ GIMT_Encode4(1820595), // Rule ID 12851 //
     /* 1820514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1820525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1820528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1820534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1820537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820560 */     // MIs[0] policy
     /* 1820560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820570 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820594 */     // GIR_Coverage, 12851,
     /* 1820594 */     GIR_EraseRootFromParent_Done,
     /* 1820595 */   // Label 24690: @1820595
     /* 1820595 */   GIM_Try, /*On fail goto*//*Label 24691*/ GIMT_Encode4(1820681), // Rule ID 12854 //
     /* 1820600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1820611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1820614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1820620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820646 */     // MIs[0] policy
     /* 1820646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820656 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820680 */     // GIR_Coverage, 12854,
     /* 1820680 */     GIR_EraseRootFromParent_Done,
     /* 1820681 */   // Label 24691: @1820681
     /* 1820681 */   GIM_Try, /*On fail goto*//*Label 24692*/ GIMT_Encode4(1820767), // Rule ID 12855 //
     /* 1820686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1820697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1820700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1820706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820732 */     // MIs[0] policy
     /* 1820732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820742 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820766 */     // GIR_Coverage, 12855,
     /* 1820766 */     GIR_EraseRootFromParent_Done,
     /* 1820767 */   // Label 24692: @1820767
     /* 1820767 */   GIM_Try, /*On fail goto*//*Label 24693*/ GIMT_Encode4(1820853), // Rule ID 12858 //
     /* 1820772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1820783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1820786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1820792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820818 */     // MIs[0] policy
     /* 1820818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820828 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820852 */     // GIR_Coverage, 12858,
     /* 1820852 */     GIR_EraseRootFromParent_Done,
     /* 1820853 */   // Label 24693: @1820853
     /* 1820853 */   GIM_Try, /*On fail goto*//*Label 24694*/ GIMT_Encode4(1820939), // Rule ID 12859 //
     /* 1820858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1820869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1820872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1820878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820904 */     // MIs[0] policy
     /* 1820904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820914 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820938 */     // GIR_Coverage, 12859,
     /* 1820938 */     GIR_EraseRootFromParent_Done,
     /* 1820939 */   // Label 24694: @1820939
     /* 1820939 */   GIM_Try, /*On fail goto*//*Label 24695*/ GIMT_Encode4(1821025), // Rule ID 12862 //
     /* 1820944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1820947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1820955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1820958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1820964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820990 */     // MIs[0] policy
     /* 1820990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821000 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1821003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1821021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821024 */     // GIR_Coverage, 12862,
     /* 1821024 */     GIR_EraseRootFromParent_Done,
     /* 1821025 */   // Label 24695: @1821025
     /* 1821025 */   GIM_Try, /*On fail goto*//*Label 24696*/ GIMT_Encode4(1821111), // Rule ID 12863 //
     /* 1821030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1821033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1821041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1821044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1821050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1821053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821076 */     // MIs[0] policy
     /* 1821076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1821089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1821107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821110 */     // GIR_Coverage, 12863,
     /* 1821110 */     GIR_EraseRootFromParent_Done,
     /* 1821111 */   // Label 24696: @1821111
     /* 1821111 */   GIM_Try, /*On fail goto*//*Label 24697*/ GIMT_Encode4(1821197), // Rule ID 12866 //
     /* 1821116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1821127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1821130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1821136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821162 */     // MIs[0] policy
     /* 1821162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821172 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821196 */     // GIR_Coverage, 12866,
     /* 1821196 */     GIR_EraseRootFromParent_Done,
     /* 1821197 */   // Label 24697: @1821197
     /* 1821197 */   GIM_Try, /*On fail goto*//*Label 24698*/ GIMT_Encode4(1821283), // Rule ID 12867 //
     /* 1821202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1821213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1821216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1821222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821248 */     // MIs[0] policy
     /* 1821248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821258 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821282 */     // GIR_Coverage, 12867,
     /* 1821282 */     GIR_EraseRootFromParent_Done,
     /* 1821283 */   // Label 24698: @1821283
     /* 1821283 */   GIM_Try, /*On fail goto*//*Label 24699*/ GIMT_Encode4(1821369), // Rule ID 12870 //
     /* 1821288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1821299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1821302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1821308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821334 */     // MIs[0] policy
     /* 1821334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821344 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821368 */     // GIR_Coverage, 12870,
     /* 1821368 */     GIR_EraseRootFromParent_Done,
     /* 1821369 */   // Label 24699: @1821369
     /* 1821369 */   GIM_Try, /*On fail goto*//*Label 24700*/ GIMT_Encode4(1821455), // Rule ID 12871 //
     /* 1821374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1821385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1821388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1821394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821420 */     // MIs[0] policy
     /* 1821420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821430 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821454 */     // GIR_Coverage, 12871,
     /* 1821454 */     GIR_EraseRootFromParent_Done,
     /* 1821455 */   // Label 24700: @1821455
     /* 1821455 */   GIM_Try, /*On fail goto*//*Label 24701*/ GIMT_Encode4(1821541), // Rule ID 12874 //
     /* 1821460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1821471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1821474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1821480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1821483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821506 */     // MIs[0] policy
     /* 1821506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821516 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1821519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821540 */     // GIR_Coverage, 12874,
     /* 1821540 */     GIR_EraseRootFromParent_Done,
     /* 1821541 */   // Label 24701: @1821541
     /* 1821541 */   GIM_Try, /*On fail goto*//*Label 24702*/ GIMT_Encode4(1821627), // Rule ID 12875 //
     /* 1821546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1821557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1821560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1821566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1821569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821592 */     // MIs[0] policy
     /* 1821592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821602 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1821605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821626 */     // GIR_Coverage, 12875,
     /* 1821626 */     GIR_EraseRootFromParent_Done,
     /* 1821627 */   // Label 24702: @1821627
     /* 1821627 */   GIM_Try, /*On fail goto*//*Label 24703*/ GIMT_Encode4(1821713), // Rule ID 12878 //
     /* 1821632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1821643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1821646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1821652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821678 */     // MIs[0] policy
     /* 1821678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821688 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821712 */     // GIR_Coverage, 12878,
     /* 1821712 */     GIR_EraseRootFromParent_Done,
     /* 1821713 */   // Label 24703: @1821713
     /* 1821713 */   GIM_Try, /*On fail goto*//*Label 24704*/ GIMT_Encode4(1821799), // Rule ID 12879 //
     /* 1821718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1821729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1821732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1821738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821764 */     // MIs[0] policy
     /* 1821764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821774 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821798 */     // GIR_Coverage, 12879,
     /* 1821798 */     GIR_EraseRootFromParent_Done,
     /* 1821799 */   // Label 24704: @1821799
     /* 1821799 */   GIM_Try, /*On fail goto*//*Label 24705*/ GIMT_Encode4(1821885), // Rule ID 12882 //
     /* 1821804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1821815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1821818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1821824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821850 */     // MIs[0] policy
     /* 1821850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821860 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821884 */     // GIR_Coverage, 12882,
     /* 1821884 */     GIR_EraseRootFromParent_Done,
     /* 1821885 */   // Label 24705: @1821885
     /* 1821885 */   GIM_Try, /*On fail goto*//*Label 24706*/ GIMT_Encode4(1821971), // Rule ID 12883 //
     /* 1821890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1821901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1821904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1821910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821936 */     // MIs[0] policy
     /* 1821936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821946 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821970 */     // GIR_Coverage, 12883,
     /* 1821970 */     GIR_EraseRootFromParent_Done,
     /* 1821971 */   // Label 24706: @1821971
     /* 1821971 */   GIM_Try, /*On fail goto*//*Label 24707*/ GIMT_Encode4(1822057), // Rule ID 12886 //
     /* 1821976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1821987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1821990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1821996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822022 */     // MIs[0] policy
     /* 1822022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822032 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822056 */     // GIR_Coverage, 12886,
     /* 1822056 */     GIR_EraseRootFromParent_Done,
     /* 1822057 */   // Label 24707: @1822057
     /* 1822057 */   GIM_Try, /*On fail goto*//*Label 24708*/ GIMT_Encode4(1822143), // Rule ID 12887 //
     /* 1822062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1822073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1822076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1822082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1822085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822108 */     // MIs[0] policy
     /* 1822108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822118 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822142 */     // GIR_Coverage, 12887,
     /* 1822142 */     GIR_EraseRootFromParent_Done,
     /* 1822143 */   // Label 24708: @1822143
     /* 1822143 */   GIM_Try, /*On fail goto*//*Label 24709*/ GIMT_Encode4(1822229), // Rule ID 12890 //
     /* 1822148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1822159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1822162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1822168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822194 */     // MIs[0] policy
     /* 1822194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822204 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1822207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822228 */     // GIR_Coverage, 12890,
     /* 1822228 */     GIR_EraseRootFromParent_Done,
     /* 1822229 */   // Label 24709: @1822229
     /* 1822229 */   GIM_Try, /*On fail goto*//*Label 24710*/ GIMT_Encode4(1822315), // Rule ID 12891 //
     /* 1822234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1822245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1822248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1822254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822280 */     // MIs[0] policy
     /* 1822280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1822293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822314 */     // GIR_Coverage, 12891,
     /* 1822314 */     GIR_EraseRootFromParent_Done,
     /* 1822315 */   // Label 24710: @1822315
     /* 1822315 */   GIM_Try, /*On fail goto*//*Label 24711*/ GIMT_Encode4(1822401), // Rule ID 12894 //
     /* 1822320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1822331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1822334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1822340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822366 */     // MIs[0] policy
     /* 1822366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822376 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822400 */     // GIR_Coverage, 12894,
     /* 1822400 */     GIR_EraseRootFromParent_Done,
     /* 1822401 */   // Label 24711: @1822401
     /* 1822401 */   GIM_Try, /*On fail goto*//*Label 24712*/ GIMT_Encode4(1822487), // Rule ID 12895 //
     /* 1822406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1822417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1822420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1822426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822452 */     // MIs[0] policy
     /* 1822452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822462 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822486 */     // GIR_Coverage, 12895,
     /* 1822486 */     GIR_EraseRootFromParent_Done,
     /* 1822487 */   // Label 24712: @1822487
     /* 1822487 */   GIM_Try, /*On fail goto*//*Label 24713*/ GIMT_Encode4(1822573), // Rule ID 12898 //
     /* 1822492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1822503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1822506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1822512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822538 */     // MIs[0] policy
     /* 1822538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822548 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822572 */     // GIR_Coverage, 12898,
     /* 1822572 */     GIR_EraseRootFromParent_Done,
     /* 1822573 */   // Label 24713: @1822573
     /* 1822573 */   GIM_Try, /*On fail goto*//*Label 24714*/ GIMT_Encode4(1822659), // Rule ID 12899 //
     /* 1822578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1822589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1822592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1822598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822624 */     // MIs[0] policy
     /* 1822624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822634 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822658 */     // GIR_Coverage, 12899,
     /* 1822658 */     GIR_EraseRootFromParent_Done,
     /* 1822659 */   // Label 24714: @1822659
     /* 1822659 */   GIM_Try, /*On fail goto*//*Label 24715*/ GIMT_Encode4(1822745), // Rule ID 12902 //
     /* 1822664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1822675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1822678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1822684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822710 */     // MIs[0] policy
     /* 1822710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822720 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1822723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822744 */     // GIR_Coverage, 12902,
     /* 1822744 */     GIR_EraseRootFromParent_Done,
     /* 1822745 */   // Label 24715: @1822745
     /* 1822745 */   GIM_Try, /*On fail goto*//*Label 24716*/ GIMT_Encode4(1822831), // Rule ID 12903 //
     /* 1822750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1822761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1822764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1822770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822796 */     // MIs[0] policy
     /* 1822796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822806 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1822809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822830 */     // GIR_Coverage, 12903,
     /* 1822830 */     GIR_EraseRootFromParent_Done,
     /* 1822831 */   // Label 24716: @1822831
     /* 1822831 */   GIM_Try, /*On fail goto*//*Label 24717*/ GIMT_Encode4(1822917), // Rule ID 12906 //
     /* 1822836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1822847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1822850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1822856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822882 */     // MIs[0] policy
     /* 1822882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822892 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822916 */     // GIR_Coverage, 12906,
     /* 1822916 */     GIR_EraseRootFromParent_Done,
     /* 1822917 */   // Label 24717: @1822917
     /* 1822917 */   GIM_Try, /*On fail goto*//*Label 24718*/ GIMT_Encode4(1823003), // Rule ID 12907 //
     /* 1822922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1822933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1822936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1822942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822968 */     // MIs[0] policy
     /* 1822968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822978 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823002 */     // GIR_Coverage, 12907,
     /* 1823002 */     GIR_EraseRootFromParent_Done,
     /* 1823003 */   // Label 24718: @1823003
     /* 1823003 */   GIM_Try, /*On fail goto*//*Label 24719*/ GIMT_Encode4(1823089), // Rule ID 12910 //
     /* 1823008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1823011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1823019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1823022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1823025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1823028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823054 */     // MIs[0] policy
     /* 1823054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823064 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1823067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823088 */     // GIR_Coverage, 12910,
     /* 1823088 */     GIR_EraseRootFromParent_Done,
     /* 1823089 */   // Label 24719: @1823089
     /* 1823089 */   GIM_Try, /*On fail goto*//*Label 24720*/ GIMT_Encode4(1823175), // Rule ID 12911 //
     /* 1823094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1823097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1823105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1823108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1823111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1823114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823140 */     // MIs[0] policy
     /* 1823140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823150 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1823153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823174 */     // GIR_Coverage, 12911,
     /* 1823174 */     GIR_EraseRootFromParent_Done,
     /* 1823175 */   // Label 24720: @1823175
     /* 1823175 */   GIM_Try, /*On fail goto*//*Label 24721*/ GIMT_Encode4(1823261), // Rule ID 12914 //
     /* 1823180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1823191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1823194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1823197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1823200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823226 */     // MIs[0] policy
     /* 1823226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823236 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1823239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823260 */     // GIR_Coverage, 12914,
     /* 1823260 */     GIR_EraseRootFromParent_Done,
     /* 1823261 */   // Label 24721: @1823261
     /* 1823261 */   GIM_Try, /*On fail goto*//*Label 24722*/ GIMT_Encode4(1823347), // Rule ID 12915 //
     /* 1823266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1823277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1823280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1823283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1823286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823312 */     // MIs[0] policy
     /* 1823312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823322 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1823325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823346 */     // GIR_Coverage, 12915,
     /* 1823346 */     GIR_EraseRootFromParent_Done,
     /* 1823347 */   // Label 24722: @1823347
     /* 1823347 */   GIM_Try, /*On fail goto*//*Label 24723*/ GIMT_Encode4(1823433), // Rule ID 12918 //
     /* 1823352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1823363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1823366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1823369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1823372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823398 */     // MIs[0] policy
     /* 1823398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823408 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823432 */     // GIR_Coverage, 12918,
     /* 1823432 */     GIR_EraseRootFromParent_Done,
     /* 1823433 */   // Label 24723: @1823433
     /* 1823433 */   GIM_Try, /*On fail goto*//*Label 24724*/ GIMT_Encode4(1823519), // Rule ID 12919 //
     /* 1823438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1823449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1823452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1823455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1823458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823484 */     // MIs[0] policy
     /* 1823484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823494 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823518 */     // GIR_Coverage, 12919,
     /* 1823518 */     GIR_EraseRootFromParent_Done,
     /* 1823519 */   // Label 24724: @1823519
     /* 1823519 */   GIM_Try, /*On fail goto*//*Label 24725*/ GIMT_Encode4(1823605), // Rule ID 12922 //
     /* 1823524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1823535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1823538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1823541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1823544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823570 */     // MIs[0] policy
     /* 1823570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823580 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823604 */     // GIR_Coverage, 12922,
     /* 1823604 */     GIR_EraseRootFromParent_Done,
     /* 1823605 */   // Label 24725: @1823605
     /* 1823605 */   GIM_Try, /*On fail goto*//*Label 24726*/ GIMT_Encode4(1823691), // Rule ID 12923 //
     /* 1823610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1823621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1823624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1823627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1823630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823656 */     // MIs[0] policy
     /* 1823656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823666 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823690 */     // GIR_Coverage, 12923,
     /* 1823690 */     GIR_EraseRootFromParent_Done,
     /* 1823691 */   // Label 24726: @1823691
     /* 1823691 */   GIM_Try, /*On fail goto*//*Label 24727*/ GIMT_Encode4(1823777), // Rule ID 12926 //
     /* 1823696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1823707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1823710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1823713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1823716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823742 */     // MIs[0] policy
     /* 1823742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823752 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823776 */     // GIR_Coverage, 12926,
     /* 1823776 */     GIR_EraseRootFromParent_Done,
     /* 1823777 */   // Label 24727: @1823777
     /* 1823777 */   GIM_Try, /*On fail goto*//*Label 24728*/ GIMT_Encode4(1823863), // Rule ID 12927 //
     /* 1823782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1823793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1823796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1823799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1823802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823828 */     // MIs[0] policy
     /* 1823828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823838 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823862 */     // GIR_Coverage, 12927,
     /* 1823862 */     GIR_EraseRootFromParent_Done,
     /* 1823863 */   // Label 24728: @1823863
     /* 1823863 */   GIM_Try, /*On fail goto*//*Label 24729*/ GIMT_Encode4(1823949), // Rule ID 12930 //
     /* 1823868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1823879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1823882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1823885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1823888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823914 */     // MIs[0] policy
     /* 1823914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823924 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823948 */     // GIR_Coverage, 12930,
     /* 1823948 */     GIR_EraseRootFromParent_Done,
     /* 1823949 */   // Label 24729: @1823949
     /* 1823949 */   GIM_Try, /*On fail goto*//*Label 24730*/ GIMT_Encode4(1824035), // Rule ID 12931 //
     /* 1823954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1823965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1823968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1823971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1823974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824000 */     // MIs[0] policy
     /* 1824000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824010 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1824013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824034 */     // GIR_Coverage, 12931,
     /* 1824034 */     GIR_EraseRootFromParent_Done,
     /* 1824035 */   // Label 24730: @1824035
     /* 1824035 */   GIM_Try, /*On fail goto*//*Label 24731*/ GIMT_Encode4(1824121), // Rule ID 12934 //
     /* 1824040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1824051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1824054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1824057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1824060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824086 */     // MIs[0] policy
     /* 1824086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824096 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1824099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824120 */     // GIR_Coverage, 12934,
     /* 1824120 */     GIR_EraseRootFromParent_Done,
     /* 1824121 */   // Label 24731: @1824121
     /* 1824121 */   GIM_Try, /*On fail goto*//*Label 24732*/ GIMT_Encode4(1824207), // Rule ID 12935 //
     /* 1824126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1824137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1824140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1824143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1824146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824172 */     // MIs[0] policy
     /* 1824172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824182 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1824185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824206 */     // GIR_Coverage, 12935,
     /* 1824206 */     GIR_EraseRootFromParent_Done,
     /* 1824207 */   // Label 24732: @1824207
     /* 1824207 */   GIM_Try, /*On fail goto*//*Label 24733*/ GIMT_Encode4(1824293), // Rule ID 12938 //
     /* 1824212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1824223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1824226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1824229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1824232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1824235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824258 */     // MIs[0] policy
     /* 1824258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824268 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824292 */     // GIR_Coverage, 12938,
     /* 1824292 */     GIR_EraseRootFromParent_Done,
     /* 1824293 */   // Label 24733: @1824293
     /* 1824293 */   GIM_Try, /*On fail goto*//*Label 24734*/ GIMT_Encode4(1824379), // Rule ID 12939 //
     /* 1824298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1824309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1824312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1824315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1824318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1824321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824344 */     // MIs[0] policy
     /* 1824344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824354 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824378 */     // GIR_Coverage, 12939,
     /* 1824378 */     GIR_EraseRootFromParent_Done,
     /* 1824379 */   // Label 24734: @1824379
     /* 1824379 */   GIM_Try, /*On fail goto*//*Label 24735*/ GIMT_Encode4(1824465), // Rule ID 12942 //
     /* 1824384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1824395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1824398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1824401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1824404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824430 */     // MIs[0] policy
     /* 1824430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824440 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824464 */     // GIR_Coverage, 12942,
     /* 1824464 */     GIR_EraseRootFromParent_Done,
     /* 1824465 */   // Label 24735: @1824465
     /* 1824465 */   GIM_Try, /*On fail goto*//*Label 24736*/ GIMT_Encode4(1824551), // Rule ID 12943 //
     /* 1824470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1824481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1824484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1824487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1824490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824516 */     // MIs[0] policy
     /* 1824516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824526 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824550 */     // GIR_Coverage, 12943,
     /* 1824550 */     GIR_EraseRootFromParent_Done,
     /* 1824551 */   // Label 24736: @1824551
     /* 1824551 */   GIM_Try, /*On fail goto*//*Label 24737*/ GIMT_Encode4(1824637), // Rule ID 12946 //
     /* 1824556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1824567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1824570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1824573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1824576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824602 */     // MIs[0] policy
     /* 1824602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824612 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824636 */     // GIR_Coverage, 12946,
     /* 1824636 */     GIR_EraseRootFromParent_Done,
     /* 1824637 */   // Label 24737: @1824637
     /* 1824637 */   GIM_Try, /*On fail goto*//*Label 24738*/ GIMT_Encode4(1824723), // Rule ID 12947 //
     /* 1824642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1824653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1824656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1824659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1824662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824688 */     // MIs[0] policy
     /* 1824688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824698 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824722 */     // GIR_Coverage, 12947,
     /* 1824722 */     GIR_EraseRootFromParent_Done,
     /* 1824723 */   // Label 24738: @1824723
     /* 1824723 */   GIM_Try, /*On fail goto*//*Label 24739*/ GIMT_Encode4(1824809), // Rule ID 12950 //
     /* 1824728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1824731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1824739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1824742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1824745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1824748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824774 */     // MIs[0] policy
     /* 1824774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824784 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824808 */     // GIR_Coverage, 12950,
     /* 1824808 */     GIR_EraseRootFromParent_Done,
     /* 1824809 */   // Label 24739: @1824809
     /* 1824809 */   GIM_Try, /*On fail goto*//*Label 24740*/ GIMT_Encode4(1824895), // Rule ID 12951 //
     /* 1824814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1824817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1824825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1824828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1824831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1824834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824860 */     // MIs[0] policy
     /* 1824860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824870 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824894 */     // GIR_Coverage, 12951,
     /* 1824894 */     GIR_EraseRootFromParent_Done,
     /* 1824895 */   // Label 24740: @1824895
     /* 1824895 */   GIM_Try, /*On fail goto*//*Label 24741*/ GIMT_Encode4(1824981), // Rule ID 12954 //
     /* 1824900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1824911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1824914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1824917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1824920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1824923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1824930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824946 */     // MIs[0] policy
     /* 1824946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824956 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1824959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824980 */     // GIR_Coverage, 12954,
     /* 1824980 */     GIR_EraseRootFromParent_Done,
     /* 1824981 */   // Label 24741: @1824981
     /* 1824981 */   GIM_Try, /*On fail goto*//*Label 24742*/ GIMT_Encode4(1825067), // Rule ID 12955 //
     /* 1824986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1824997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1825000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1825003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1825006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825032 */     // MIs[0] policy
     /* 1825032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825042 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825066 */     // GIR_Coverage, 12955,
     /* 1825066 */     GIR_EraseRootFromParent_Done,
     /* 1825067 */   // Label 24742: @1825067
     /* 1825067 */   GIM_Try, /*On fail goto*//*Label 24743*/ GIMT_Encode4(1825153), // Rule ID 12958 //
     /* 1825072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1825083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1825086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1825089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1825092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825118 */     // MIs[0] policy
     /* 1825118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825128 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825152 */     // GIR_Coverage, 12958,
     /* 1825152 */     GIR_EraseRootFromParent_Done,
     /* 1825153 */   // Label 24743: @1825153
     /* 1825153 */   GIM_Try, /*On fail goto*//*Label 24744*/ GIMT_Encode4(1825239), // Rule ID 12959 //
     /* 1825158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1825169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1825172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1825175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1825178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825204 */     // MIs[0] policy
     /* 1825204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825214 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825238 */     // GIR_Coverage, 12959,
     /* 1825238 */     GIR_EraseRootFromParent_Done,
     /* 1825239 */   // Label 24744: @1825239
     /* 1825239 */   GIM_Try, /*On fail goto*//*Label 24745*/ GIMT_Encode4(1825325), // Rule ID 12962 //
     /* 1825244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1825255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1825258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1825261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1825264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1825267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825290 */     // MIs[0] policy
     /* 1825290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825300 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825324 */     // GIR_Coverage, 12962,
     /* 1825324 */     GIR_EraseRootFromParent_Done,
     /* 1825325 */   // Label 24745: @1825325
     /* 1825325 */   GIM_Try, /*On fail goto*//*Label 24746*/ GIMT_Encode4(1825411), // Rule ID 12963 //
     /* 1825330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1825341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1825344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1825347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1825350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1825353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825376 */     // MIs[0] policy
     /* 1825376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825386 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825410 */     // GIR_Coverage, 12963,
     /* 1825410 */     GIR_EraseRootFromParent_Done,
     /* 1825411 */   // Label 24746: @1825411
     /* 1825411 */   GIM_Try, /*On fail goto*//*Label 24747*/ GIMT_Encode4(1825497), // Rule ID 12966 //
     /* 1825416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1825427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1825430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1825433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1825436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825462 */     // MIs[0] policy
     /* 1825462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825472 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825496 */     // GIR_Coverage, 12966,
     /* 1825496 */     GIR_EraseRootFromParent_Done,
     /* 1825497 */   // Label 24747: @1825497
     /* 1825497 */   GIM_Try, /*On fail goto*//*Label 24748*/ GIMT_Encode4(1825583), // Rule ID 12967 //
     /* 1825502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1825513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1825516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1825519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1825522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825548 */     // MIs[0] policy
     /* 1825548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825558 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825582 */     // GIR_Coverage, 12967,
     /* 1825582 */     GIR_EraseRootFromParent_Done,
     /* 1825583 */   // Label 24748: @1825583
     /* 1825583 */   GIM_Try, /*On fail goto*//*Label 24749*/ GIMT_Encode4(1825669), // Rule ID 12970 //
     /* 1825588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1825599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1825602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1825605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1825608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825634 */     // MIs[0] policy
     /* 1825634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825668 */     // GIR_Coverage, 12970,
     /* 1825668 */     GIR_EraseRootFromParent_Done,
     /* 1825669 */   // Label 24749: @1825669
     /* 1825669 */   GIM_Try, /*On fail goto*//*Label 24750*/ GIMT_Encode4(1825755), // Rule ID 12971 //
     /* 1825674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1825685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1825688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1825691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1825694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825720 */     // MIs[0] policy
     /* 1825720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825730 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825754 */     // GIR_Coverage, 12971,
     /* 1825754 */     GIR_EraseRootFromParent_Done,
     /* 1825755 */   // Label 24750: @1825755
     /* 1825755 */   GIM_Try, /*On fail goto*//*Label 24751*/ GIMT_Encode4(1825841), // Rule ID 12974 //
     /* 1825760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1825771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1825774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1825777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1825780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825806 */     // MIs[0] policy
     /* 1825806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825816 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825840 */     // GIR_Coverage, 12974,
     /* 1825840 */     GIR_EraseRootFromParent_Done,
     /* 1825841 */   // Label 24751: @1825841
     /* 1825841 */   GIM_Try, /*On fail goto*//*Label 24752*/ GIMT_Encode4(1825927), // Rule ID 12975 //
     /* 1825846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1825857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1825860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1825863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1825866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825892 */     // MIs[0] policy
     /* 1825892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825902 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825926 */     // GIR_Coverage, 12975,
     /* 1825926 */     GIR_EraseRootFromParent_Done,
     /* 1825927 */   // Label 24752: @1825927
     /* 1825927 */   GIM_Try, /*On fail goto*//*Label 24753*/ GIMT_Encode4(1826013), // Rule ID 12978 //
     /* 1825932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1825943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1825946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1825949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1825952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825978 */     // MIs[0] policy
     /* 1825978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825988 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826012 */     // GIR_Coverage, 12978,
     /* 1826012 */     GIR_EraseRootFromParent_Done,
     /* 1826013 */   // Label 24753: @1826013
     /* 1826013 */   GIM_Try, /*On fail goto*//*Label 24754*/ GIMT_Encode4(1826099), // Rule ID 12979 //
     /* 1826018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1826029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1826032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1826035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1826038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826064 */     // MIs[0] policy
     /* 1826064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826074 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1826077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826098 */     // GIR_Coverage, 12979,
     /* 1826098 */     GIR_EraseRootFromParent_Done,
     /* 1826099 */   // Label 24754: @1826099
     /* 1826099 */   GIM_Try, /*On fail goto*//*Label 24755*/ GIMT_Encode4(1826185), // Rule ID 12982 //
     /* 1826104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1826115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1826118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1826121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1826124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826150 */     // MIs[0] policy
     /* 1826150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826160 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1826163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826184 */     // GIR_Coverage, 12982,
     /* 1826184 */     GIR_EraseRootFromParent_Done,
     /* 1826185 */   // Label 24755: @1826185
     /* 1826185 */   GIM_Try, /*On fail goto*//*Label 24756*/ GIMT_Encode4(1826271), // Rule ID 12983 //
     /* 1826190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1826201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1826204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1826207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1826210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826236 */     // MIs[0] policy
     /* 1826236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826246 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1826249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826270 */     // GIR_Coverage, 12983,
     /* 1826270 */     GIR_EraseRootFromParent_Done,
     /* 1826271 */   // Label 24756: @1826271
     /* 1826271 */   GIM_Try, /*On fail goto*//*Label 24757*/ GIMT_Encode4(1826357), // Rule ID 12986 //
     /* 1826276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1826287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1826290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1826293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1826296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826322 */     // MIs[0] policy
     /* 1826322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826332 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1826335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826356 */     // GIR_Coverage, 12986,
     /* 1826356 */     GIR_EraseRootFromParent_Done,
     /* 1826357 */   // Label 24757: @1826357
     /* 1826357 */   GIM_Try, /*On fail goto*//*Label 24758*/ GIMT_Encode4(1826443), // Rule ID 12987 //
     /* 1826362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1826373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1826376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1826379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1826382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826408 */     // MIs[0] policy
     /* 1826408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826418 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1826421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826442 */     // GIR_Coverage, 12987,
     /* 1826442 */     GIR_EraseRootFromParent_Done,
     /* 1826443 */   // Label 24758: @1826443
     /* 1826443 */   GIM_Try, /*On fail goto*//*Label 24759*/ GIMT_Encode4(1826529), // Rule ID 12990 //
     /* 1826448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1826459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1826462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1826465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1826468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826494 */     // MIs[0] policy
     /* 1826494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826504 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1826507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826528 */     // GIR_Coverage, 12990,
     /* 1826528 */     GIR_EraseRootFromParent_Done,
     /* 1826529 */   // Label 24759: @1826529
     /* 1826529 */   GIM_Try, /*On fail goto*//*Label 24760*/ GIMT_Encode4(1826615), // Rule ID 12991 //
     /* 1826534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1826545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1826548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1826551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1826554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826580 */     // MIs[0] policy
     /* 1826580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1826593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826614 */     // GIR_Coverage, 12991,
     /* 1826614 */     GIR_EraseRootFromParent_Done,
     /* 1826615 */   // Label 24760: @1826615
     /* 1826615 */   GIM_Try, /*On fail goto*//*Label 24761*/ GIMT_Encode4(1826701), // Rule ID 12994 //
     /* 1826620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1826631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1826634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1826637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1826640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826666 */     // MIs[0] policy
     /* 1826666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826676 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1826679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826700 */     // GIR_Coverage, 12994,
     /* 1826700 */     GIR_EraseRootFromParent_Done,
     /* 1826701 */   // Label 24761: @1826701
     /* 1826701 */   GIM_Try, /*On fail goto*//*Label 24762*/ GIMT_Encode4(1826787), // Rule ID 12995 //
     /* 1826706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1826717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1826720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1826723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1826726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826752 */     // MIs[0] policy
     /* 1826752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826762 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1826765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826786 */     // GIR_Coverage, 12995,
     /* 1826786 */     GIR_EraseRootFromParent_Done,
     /* 1826787 */   // Label 24762: @1826787
     /* 1826787 */   GIM_Try, /*On fail goto*//*Label 24763*/ GIMT_Encode4(1826873), // Rule ID 12998 //
     /* 1826792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1826803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1826806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1826809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1826812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826838 */     // MIs[0] policy
     /* 1826838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826848 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1826851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826872 */     // GIR_Coverage, 12998,
     /* 1826872 */     GIR_EraseRootFromParent_Done,
     /* 1826873 */   // Label 24763: @1826873
     /* 1826873 */   GIM_Try, /*On fail goto*//*Label 24764*/ GIMT_Encode4(1826959), // Rule ID 12999 //
     /* 1826878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1826889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1826892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1826895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1826898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826924 */     // MIs[0] policy
     /* 1826924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826934 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1826937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826958 */     // GIR_Coverage, 12999,
     /* 1826958 */     GIR_EraseRootFromParent_Done,
     /* 1826959 */   // Label 24764: @1826959
     /* 1826959 */   GIM_Try, /*On fail goto*//*Label 24765*/ GIMT_Encode4(1827045), // Rule ID 13002 //
     /* 1826964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1826975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1826978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1826984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1826987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827010 */     // MIs[0] policy
     /* 1827010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827020 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1827023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827044 */     // GIR_Coverage, 13002,
     /* 1827044 */     GIR_EraseRootFromParent_Done,
     /* 1827045 */   // Label 24765: @1827045
     /* 1827045 */   GIM_Try, /*On fail goto*//*Label 24766*/ GIMT_Encode4(1827131), // Rule ID 13003 //
     /* 1827050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1827061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1827064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1827070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827096 */     // MIs[0] policy
     /* 1827096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827106 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1827109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827130 */     // GIR_Coverage, 13003,
     /* 1827130 */     GIR_EraseRootFromParent_Done,
     /* 1827131 */   // Label 24766: @1827131
     /* 1827131 */   GIM_Try, /*On fail goto*//*Label 24767*/ GIMT_Encode4(1827217), // Rule ID 13006 //
     /* 1827136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1827147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1827150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1827156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827182 */     // MIs[0] policy
     /* 1827182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827192 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1827195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827216 */     // GIR_Coverage, 13006,
     /* 1827216 */     GIR_EraseRootFromParent_Done,
     /* 1827217 */   // Label 24767: @1827217
     /* 1827217 */   GIM_Try, /*On fail goto*//*Label 24768*/ GIMT_Encode4(1827303), // Rule ID 13007 //
     /* 1827222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1827233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1827236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1827242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827268 */     // MIs[0] policy
     /* 1827268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827278 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1827281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827302 */     // GIR_Coverage, 13007,
     /* 1827302 */     GIR_EraseRootFromParent_Done,
     /* 1827303 */   // Label 24768: @1827303
     /* 1827303 */   GIM_Try, /*On fail goto*//*Label 24769*/ GIMT_Encode4(1827389), // Rule ID 13010 //
     /* 1827308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1827319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1827322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1827328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827354 */     // MIs[0] policy
     /* 1827354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827364 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827388 */     // GIR_Coverage, 13010,
     /* 1827388 */     GIR_EraseRootFromParent_Done,
     /* 1827389 */   // Label 24769: @1827389
     /* 1827389 */   GIM_Try, /*On fail goto*//*Label 24770*/ GIMT_Encode4(1827475), // Rule ID 13011 //
     /* 1827394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1827405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1827408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1827414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827440 */     // MIs[0] policy
     /* 1827440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827450 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827474 */     // GIR_Coverage, 13011,
     /* 1827474 */     GIR_EraseRootFromParent_Done,
     /* 1827475 */   // Label 24770: @1827475
     /* 1827475 */   GIM_Try, /*On fail goto*//*Label 24771*/ GIMT_Encode4(1827561), // Rule ID 13014 //
     /* 1827480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1827491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1827494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1827500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827526 */     // MIs[0] policy
     /* 1827526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827536 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1827539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827560 */     // GIR_Coverage, 13014,
     /* 1827560 */     GIR_EraseRootFromParent_Done,
     /* 1827561 */   // Label 24771: @1827561
     /* 1827561 */   GIM_Try, /*On fail goto*//*Label 24772*/ GIMT_Encode4(1827647), // Rule ID 13015 //
     /* 1827566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1827577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1827580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1827586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827612 */     // MIs[0] policy
     /* 1827612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827622 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1827625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827646 */     // GIR_Coverage, 13015,
     /* 1827646 */     GIR_EraseRootFromParent_Done,
     /* 1827647 */   // Label 24772: @1827647
     /* 1827647 */   GIM_Try, /*On fail goto*//*Label 24773*/ GIMT_Encode4(1827733), // Rule ID 13018 //
     /* 1827652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1827663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1827666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1827672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827698 */     // MIs[0] policy
     /* 1827698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827708 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827732 */     // GIR_Coverage, 13018,
     /* 1827732 */     GIR_EraseRootFromParent_Done,
     /* 1827733 */   // Label 24773: @1827733
     /* 1827733 */   GIM_Try, /*On fail goto*//*Label 24774*/ GIMT_Encode4(1827819), // Rule ID 13019 //
     /* 1827738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1827749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1827752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1827758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827784 */     // MIs[0] policy
     /* 1827784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827794 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827818 */     // GIR_Coverage, 13019,
     /* 1827818 */     GIR_EraseRootFromParent_Done,
     /* 1827819 */   // Label 24774: @1827819
     /* 1827819 */   GIM_Try, /*On fail goto*//*Label 24775*/ GIMT_Encode4(1827905), // Rule ID 13022 //
     /* 1827824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1827835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1827838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1827844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827870 */     // MIs[0] policy
     /* 1827870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827880 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827904 */     // GIR_Coverage, 13022,
     /* 1827904 */     GIR_EraseRootFromParent_Done,
     /* 1827905 */   // Label 24775: @1827905
     /* 1827905 */   GIM_Try, /*On fail goto*//*Label 24776*/ GIMT_Encode4(1827991), // Rule ID 13023 //
     /* 1827910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1827921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1827924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1827930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827956 */     // MIs[0] policy
     /* 1827956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827966 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827990 */     // GIR_Coverage, 13023,
     /* 1827990 */     GIR_EraseRootFromParent_Done,
     /* 1827991 */   // Label 24776: @1827991
     /* 1827991 */   GIM_Try, /*On fail goto*//*Label 24777*/ GIMT_Encode4(1828077), // Rule ID 13026 //
     /* 1827996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1828007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1828010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1828016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828042 */     // MIs[0] policy
     /* 1828042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828052 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828076 */     // GIR_Coverage, 13026,
     /* 1828076 */     GIR_EraseRootFromParent_Done,
     /* 1828077 */   // Label 24777: @1828077
     /* 1828077 */   GIM_Try, /*On fail goto*//*Label 24778*/ GIMT_Encode4(1828163), // Rule ID 13027 //
     /* 1828082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1828093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1828096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1828102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828128 */     // MIs[0] policy
     /* 1828128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828138 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828162 */     // GIR_Coverage, 13027,
     /* 1828162 */     GIR_EraseRootFromParent_Done,
     /* 1828163 */   // Label 24778: @1828163
     /* 1828163 */   GIM_Try, /*On fail goto*//*Label 24779*/ GIMT_Encode4(1828249), // Rule ID 13030 //
     /* 1828168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1828179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1828182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1828188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1828191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828214 */     // MIs[0] policy
     /* 1828214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828248 */     // GIR_Coverage, 13030,
     /* 1828248 */     GIR_EraseRootFromParent_Done,
     /* 1828249 */   // Label 24779: @1828249
     /* 1828249 */   GIM_Try, /*On fail goto*//*Label 24780*/ GIMT_Encode4(1828335), // Rule ID 13031 //
     /* 1828254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1828265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1828268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1828274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1828277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828300 */     // MIs[0] policy
     /* 1828300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828310 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828334 */     // GIR_Coverage, 13031,
     /* 1828334 */     GIR_EraseRootFromParent_Done,
     /* 1828335 */   // Label 24780: @1828335
     /* 1828335 */   GIM_Try, /*On fail goto*//*Label 24781*/ GIMT_Encode4(1828421), // Rule ID 13034 //
     /* 1828340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1828351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1828354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1828360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828386 */     // MIs[0] policy
     /* 1828386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828420 */     // GIR_Coverage, 13034,
     /* 1828420 */     GIR_EraseRootFromParent_Done,
     /* 1828421 */   // Label 24781: @1828421
     /* 1828421 */   GIM_Try, /*On fail goto*//*Label 24782*/ GIMT_Encode4(1828507), // Rule ID 13035 //
     /* 1828426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1828437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1828440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1828446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828472 */     // MIs[0] policy
     /* 1828472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828482 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828506 */     // GIR_Coverage, 13035,
     /* 1828506 */     GIR_EraseRootFromParent_Done,
     /* 1828507 */   // Label 24782: @1828507
     /* 1828507 */   GIM_Try, /*On fail goto*//*Label 24783*/ GIMT_Encode4(1828593), // Rule ID 13038 //
     /* 1828512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1828515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1828523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1828526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1828532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828558 */     // MIs[0] policy
     /* 1828558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828568 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1828589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828592 */     // GIR_Coverage, 13038,
     /* 1828592 */     GIR_EraseRootFromParent_Done,
     /* 1828593 */   // Label 24783: @1828593
     /* 1828593 */   GIM_Try, /*On fail goto*//*Label 24784*/ GIMT_Encode4(1828679), // Rule ID 13039 //
     /* 1828598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1828601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1828609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1828612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1828618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828644 */     // MIs[0] policy
     /* 1828644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828654 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1828675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828678 */     // GIR_Coverage, 13039,
     /* 1828678 */     GIR_EraseRootFromParent_Done,
     /* 1828679 */   // Label 24784: @1828679
     /* 1828679 */   GIM_Try, /*On fail goto*//*Label 24785*/ GIMT_Encode4(1828765), // Rule ID 13042 //
     /* 1828684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1828695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1828698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1828704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828730 */     // MIs[0] policy
     /* 1828730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828740 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1828743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828764 */     // GIR_Coverage, 13042,
     /* 1828764 */     GIR_EraseRootFromParent_Done,
     /* 1828765 */   // Label 24785: @1828765
     /* 1828765 */   GIM_Try, /*On fail goto*//*Label 24786*/ GIMT_Encode4(1828851), // Rule ID 13043 //
     /* 1828770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1828781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1828784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1828790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828816 */     // MIs[0] policy
     /* 1828816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828826 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1828829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828850 */     // GIR_Coverage, 13043,
     /* 1828850 */     GIR_EraseRootFromParent_Done,
     /* 1828851 */   // Label 24786: @1828851
     /* 1828851 */   GIM_Try, /*On fail goto*//*Label 24787*/ GIMT_Encode4(1828937), // Rule ID 13046 //
     /* 1828856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1828867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1828870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1828876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1828879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828902 */     // MIs[0] policy
     /* 1828902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828912 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1828915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828936 */     // GIR_Coverage, 13046,
     /* 1828936 */     GIR_EraseRootFromParent_Done,
     /* 1828937 */   // Label 24787: @1828937
     /* 1828937 */   GIM_Try, /*On fail goto*//*Label 24788*/ GIMT_Encode4(1829023), // Rule ID 13047 //
     /* 1828942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1828953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1828956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1828962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1828965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828988 */     // MIs[0] policy
     /* 1828988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828998 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829022 */     // GIR_Coverage, 13047,
     /* 1829022 */     GIR_EraseRootFromParent_Done,
     /* 1829023 */   // Label 24788: @1829023
     /* 1829023 */   GIM_Try, /*On fail goto*//*Label 24789*/ GIMT_Encode4(1829109), // Rule ID 13050 //
     /* 1829028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1829039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1829042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1829048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1829051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829074 */     // MIs[0] policy
     /* 1829074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829084 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829108 */     // GIR_Coverage, 13050,
     /* 1829108 */     GIR_EraseRootFromParent_Done,
     /* 1829109 */   // Label 24789: @1829109
     /* 1829109 */   GIM_Try, /*On fail goto*//*Label 24790*/ GIMT_Encode4(1829195), // Rule ID 13051 //
     /* 1829114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1829125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1829128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1829134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1829137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829160 */     // MIs[0] policy
     /* 1829160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829170 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829194 */     // GIR_Coverage, 13051,
     /* 1829194 */     GIR_EraseRootFromParent_Done,
     /* 1829195 */   // Label 24790: @1829195
     /* 1829195 */   GIM_Try, /*On fail goto*//*Label 24791*/ GIMT_Encode4(1829281), // Rule ID 13054 //
     /* 1829200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1829211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1829214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1829220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829246 */     // MIs[0] policy
     /* 1829246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829256 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829280 */     // GIR_Coverage, 13054,
     /* 1829280 */     GIR_EraseRootFromParent_Done,
     /* 1829281 */   // Label 24791: @1829281
     /* 1829281 */   GIM_Try, /*On fail goto*//*Label 24792*/ GIMT_Encode4(1829367), // Rule ID 13055 //
     /* 1829286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1829297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1829300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1829306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829332 */     // MIs[0] policy
     /* 1829332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829342 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829366 */     // GIR_Coverage, 13055,
     /* 1829366 */     GIR_EraseRootFromParent_Done,
     /* 1829367 */   // Label 24792: @1829367
     /* 1829367 */   GIM_Try, /*On fail goto*//*Label 24793*/ GIMT_Encode4(1829453), // Rule ID 13058 //
     /* 1829372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1829383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1829386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1829392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829418 */     // MIs[0] policy
     /* 1829418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829428 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829452 */     // GIR_Coverage, 13058,
     /* 1829452 */     GIR_EraseRootFromParent_Done,
     /* 1829453 */   // Label 24793: @1829453
     /* 1829453 */   GIM_Try, /*On fail goto*//*Label 24794*/ GIMT_Encode4(1829539), // Rule ID 13059 //
     /* 1829458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1829469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1829472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1829478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829504 */     // MIs[0] policy
     /* 1829504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829514 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829538 */     // GIR_Coverage, 13059,
     /* 1829538 */     GIR_EraseRootFromParent_Done,
     /* 1829539 */   // Label 24794: @1829539
     /* 1829539 */   GIM_Try, /*On fail goto*//*Label 24795*/ GIMT_Encode4(1829625), // Rule ID 13062 //
     /* 1829544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1829555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1829558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1829564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829590 */     // MIs[0] policy
     /* 1829590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829600 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829624 */     // GIR_Coverage, 13062,
     /* 1829624 */     GIR_EraseRootFromParent_Done,
     /* 1829625 */   // Label 24795: @1829625
     /* 1829625 */   GIM_Try, /*On fail goto*//*Label 24796*/ GIMT_Encode4(1829711), // Rule ID 13063 //
     /* 1829630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1829641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1829644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1829650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829676 */     // MIs[0] policy
     /* 1829676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829686 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829710 */     // GIR_Coverage, 13063,
     /* 1829710 */     GIR_EraseRootFromParent_Done,
     /* 1829711 */   // Label 24796: @1829711
     /* 1829711 */   GIM_Try, /*On fail goto*//*Label 24797*/ GIMT_Encode4(1829797), // Rule ID 13066 //
     /* 1829716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1829727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1829730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1829736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829762 */     // MIs[0] policy
     /* 1829762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829796 */     // GIR_Coverage, 13066,
     /* 1829796 */     GIR_EraseRootFromParent_Done,
     /* 1829797 */   // Label 24797: @1829797
     /* 1829797 */   GIM_Try, /*On fail goto*//*Label 24798*/ GIMT_Encode4(1829883), // Rule ID 13067 //
     /* 1829802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1829813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1829816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1829822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829848 */     // MIs[0] policy
     /* 1829848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829858 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829882 */     // GIR_Coverage, 13067,
     /* 1829882 */     GIR_EraseRootFromParent_Done,
     /* 1829883 */   // Label 24798: @1829883
     /* 1829883 */   GIM_Try, /*On fail goto*//*Label 24799*/ GIMT_Encode4(1829969), // Rule ID 13070 //
     /* 1829888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1829899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1829902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1829908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829934 */     // MIs[0] policy
     /* 1829934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829944 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829968 */     // GIR_Coverage, 13070,
     /* 1829968 */     GIR_EraseRootFromParent_Done,
     /* 1829969 */   // Label 24799: @1829969
     /* 1829969 */   GIM_Try, /*On fail goto*//*Label 24800*/ GIMT_Encode4(1830055), // Rule ID 13071 //
     /* 1829974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1829985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1829988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1829994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830020 */     // MIs[0] policy
     /* 1830020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830030 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1830033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830054 */     // GIR_Coverage, 13071,
     /* 1830054 */     GIR_EraseRootFromParent_Done,
     /* 1830055 */   // Label 24800: @1830055
     /* 1830055 */   GIM_Try, /*On fail goto*//*Label 24801*/ GIMT_Encode4(1830141), // Rule ID 13074 //
     /* 1830060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1830071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1830074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1830080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1830083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830106 */     // MIs[0] policy
     /* 1830106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830116 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1830119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830140 */     // GIR_Coverage, 13074,
     /* 1830140 */     GIR_EraseRootFromParent_Done,
     /* 1830141 */   // Label 24801: @1830141
     /* 1830141 */   GIM_Try, /*On fail goto*//*Label 24802*/ GIMT_Encode4(1830227), // Rule ID 13075 //
     /* 1830146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1830157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1830160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1830166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1830169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830192 */     // MIs[0] policy
     /* 1830192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830202 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1830205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830226 */     // GIR_Coverage, 13075,
     /* 1830226 */     GIR_EraseRootFromParent_Done,
     /* 1830227 */   // Label 24802: @1830227
     /* 1830227 */   GIM_Try, /*On fail goto*//*Label 24803*/ GIMT_Encode4(1830313), // Rule ID 13078 //
     /* 1830232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1830235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1830243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1830246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1830252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830278 */     // MIs[0] policy
     /* 1830278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830288 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1830291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830312 */     // GIR_Coverage, 13078,
     /* 1830312 */     GIR_EraseRootFromParent_Done,
     /* 1830313 */   // Label 24803: @1830313
     /* 1830313 */   GIM_Try, /*On fail goto*//*Label 24804*/ GIMT_Encode4(1830399), // Rule ID 13079 //
     /* 1830318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1830329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1830332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1830338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830364 */     // MIs[0] policy
     /* 1830364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830374 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1830377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830398 */     // GIR_Coverage, 13079,
     /* 1830398 */     GIR_EraseRootFromParent_Done,
     /* 1830399 */   // Label 24804: @1830399
     /* 1830399 */   GIM_Try, /*On fail goto*//*Label 24805*/ GIMT_Encode4(1830485), // Rule ID 13082 //
     /* 1830404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1830407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1830415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1830418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1830424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830450 */     // MIs[0] policy
     /* 1830450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830460 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1830463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830484 */     // GIR_Coverage, 13082,
     /* 1830484 */     GIR_EraseRootFromParent_Done,
     /* 1830485 */   // Label 24805: @1830485
     /* 1830485 */   GIM_Try, /*On fail goto*//*Label 24806*/ GIMT_Encode4(1830571), // Rule ID 13083 //
     /* 1830490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1830501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1830504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1830510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830536 */     // MIs[0] policy
     /* 1830536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830546 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1830549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830570 */     // GIR_Coverage, 13083,
     /* 1830570 */     GIR_EraseRootFromParent_Done,
     /* 1830571 */   // Label 24806: @1830571
     /* 1830571 */   GIM_Try, /*On fail goto*//*Label 24807*/ GIMT_Encode4(1830657), // Rule ID 13086 //
     /* 1830576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1830579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1830587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1830590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1830596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830622 */     // MIs[0] policy
     /* 1830622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830632 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1830635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830656 */     // GIR_Coverage, 13086,
     /* 1830656 */     GIR_EraseRootFromParent_Done,
     /* 1830657 */   // Label 24807: @1830657
     /* 1830657 */   GIM_Try, /*On fail goto*//*Label 24808*/ GIMT_Encode4(1830743), // Rule ID 13087 //
     /* 1830662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1830673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1830676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1830682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830708 */     // MIs[0] policy
     /* 1830708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1830721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830742 */     // GIR_Coverage, 13087,
     /* 1830742 */     GIR_EraseRootFromParent_Done,
     /* 1830743 */   // Label 24808: @1830743
     /* 1830743 */   GIM_Try, /*On fail goto*//*Label 24809*/ GIMT_Encode4(1830829), // Rule ID 13090 //
     /* 1830748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1830759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1830762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1830765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1830768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830794 */     // MIs[0] policy
     /* 1830794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830804 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1830807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830828 */     // GIR_Coverage, 13090,
     /* 1830828 */     GIR_EraseRootFromParent_Done,
     /* 1830829 */   // Label 24809: @1830829
     /* 1830829 */   GIM_Try, /*On fail goto*//*Label 24810*/ GIMT_Encode4(1830915), // Rule ID 13091 //
     /* 1830834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1830845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1830848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1830851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1830854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830880 */     // MIs[0] policy
     /* 1830880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830890 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1830893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830914 */     // GIR_Coverage, 13091,
     /* 1830914 */     GIR_EraseRootFromParent_Done,
     /* 1830915 */   // Label 24810: @1830915
     /* 1830915 */   GIM_Try, /*On fail goto*//*Label 24811*/ GIMT_Encode4(1831001), // Rule ID 13094 //
     /* 1830920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1830931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1830934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1830937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1830940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830966 */     // MIs[0] policy
     /* 1830966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1830979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831000 */     // GIR_Coverage, 13094,
     /* 1831000 */     GIR_EraseRootFromParent_Done,
     /* 1831001 */   // Label 24811: @1831001
     /* 1831001 */   GIM_Try, /*On fail goto*//*Label 24812*/ GIMT_Encode4(1831087), // Rule ID 13095 //
     /* 1831006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1831017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1831020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1831023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1831026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831052 */     // MIs[0] policy
     /* 1831052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831062 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1831065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831086 */     // GIR_Coverage, 13095,
     /* 1831086 */     GIR_EraseRootFromParent_Done,
     /* 1831087 */   // Label 24812: @1831087
     /* 1831087 */   GIM_Try, /*On fail goto*//*Label 24813*/ GIMT_Encode4(1831173), // Rule ID 13098 //
     /* 1831092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1831103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1831106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1831109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1831112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831138 */     // MIs[0] policy
     /* 1831138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831148 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831172 */     // GIR_Coverage, 13098,
     /* 1831172 */     GIR_EraseRootFromParent_Done,
     /* 1831173 */   // Label 24813: @1831173
     /* 1831173 */   GIM_Try, /*On fail goto*//*Label 24814*/ GIMT_Encode4(1831259), // Rule ID 13099 //
     /* 1831178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1831189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1831192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1831195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1831198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831224 */     // MIs[0] policy
     /* 1831224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831234 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831258 */     // GIR_Coverage, 13099,
     /* 1831258 */     GIR_EraseRootFromParent_Done,
     /* 1831259 */   // Label 24814: @1831259
     /* 1831259 */   GIM_Try, /*On fail goto*//*Label 24815*/ GIMT_Encode4(1831345), // Rule ID 13102 //
     /* 1831264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1831275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1831278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1831281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1831284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831310 */     // MIs[0] policy
     /* 1831310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831320 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1831323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831344 */     // GIR_Coverage, 13102,
     /* 1831344 */     GIR_EraseRootFromParent_Done,
     /* 1831345 */   // Label 24815: @1831345
     /* 1831345 */   GIM_Try, /*On fail goto*//*Label 24816*/ GIMT_Encode4(1831431), // Rule ID 13103 //
     /* 1831350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1831361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1831364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1831367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1831370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831396 */     // MIs[0] policy
     /* 1831396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831406 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1831409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831430 */     // GIR_Coverage, 13103,
     /* 1831430 */     GIR_EraseRootFromParent_Done,
     /* 1831431 */   // Label 24816: @1831431
     /* 1831431 */   GIM_Try, /*On fail goto*//*Label 24817*/ GIMT_Encode4(1831517), // Rule ID 13106 //
     /* 1831436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1831447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1831450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1831453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1831456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831482 */     // MIs[0] policy
     /* 1831482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831492 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831516 */     // GIR_Coverage, 13106,
     /* 1831516 */     GIR_EraseRootFromParent_Done,
     /* 1831517 */   // Label 24817: @1831517
     /* 1831517 */   GIM_Try, /*On fail goto*//*Label 24818*/ GIMT_Encode4(1831603), // Rule ID 13107 //
     /* 1831522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1831533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1831536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1831539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1831542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831568 */     // MIs[0] policy
     /* 1831568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831578 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831602 */     // GIR_Coverage, 13107,
     /* 1831602 */     GIR_EraseRootFromParent_Done,
     /* 1831603 */   // Label 24818: @1831603
     /* 1831603 */   GIM_Try, /*On fail goto*//*Label 24819*/ GIMT_Encode4(1831689), // Rule ID 13110 //
     /* 1831608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1831619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1831622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1831625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1831628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831654 */     // MIs[0] policy
     /* 1831654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831664 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831688 */     // GIR_Coverage, 13110,
     /* 1831688 */     GIR_EraseRootFromParent_Done,
     /* 1831689 */   // Label 24819: @1831689
     /* 1831689 */   GIM_Try, /*On fail goto*//*Label 24820*/ GIMT_Encode4(1831775), // Rule ID 13111 //
     /* 1831694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1831705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1831708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1831711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1831714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831740 */     // MIs[0] policy
     /* 1831740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831750 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831774 */     // GIR_Coverage, 13111,
     /* 1831774 */     GIR_EraseRootFromParent_Done,
     /* 1831775 */   // Label 24820: @1831775
     /* 1831775 */   GIM_Try, /*On fail goto*//*Label 24821*/ GIMT_Encode4(1831861), // Rule ID 13114 //
     /* 1831780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1831791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1831794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1831797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1831800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831826 */     // MIs[0] policy
     /* 1831826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831836 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831860 */     // GIR_Coverage, 13114,
     /* 1831860 */     GIR_EraseRootFromParent_Done,
     /* 1831861 */   // Label 24821: @1831861
     /* 1831861 */   GIM_Try, /*On fail goto*//*Label 24822*/ GIMT_Encode4(1831947), // Rule ID 13115 //
     /* 1831866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1831877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1831880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1831883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1831886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831912 */     // MIs[0] policy
     /* 1831912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831922 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831946 */     // GIR_Coverage, 13115,
     /* 1831946 */     GIR_EraseRootFromParent_Done,
     /* 1831947 */   // Label 24822: @1831947
     /* 1831947 */   GIM_Try, /*On fail goto*//*Label 24823*/ GIMT_Encode4(1832033), // Rule ID 13118 //
     /* 1831952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1831963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1831966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1831969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1831972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831998 */     // MIs[0] policy
     /* 1831998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832008 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1832011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832032 */     // GIR_Coverage, 13118,
     /* 1832032 */     GIR_EraseRootFromParent_Done,
     /* 1832033 */   // Label 24823: @1832033
     /* 1832033 */   GIM_Try, /*On fail goto*//*Label 24824*/ GIMT_Encode4(1832119), // Rule ID 13119 //
     /* 1832038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1832049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1832052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1832055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1832058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1832061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832084 */     // MIs[0] policy
     /* 1832084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1832097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832118 */     // GIR_Coverage, 13119,
     /* 1832118 */     GIR_EraseRootFromParent_Done,
     /* 1832119 */   // Label 24824: @1832119
     /* 1832119 */   GIM_Try, /*On fail goto*//*Label 24825*/ GIMT_Encode4(1832205), // Rule ID 13122 //
     /* 1832124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1832135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1832138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1832141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1832144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832170 */     // MIs[0] policy
     /* 1832170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832180 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1832183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832204 */     // GIR_Coverage, 13122,
     /* 1832204 */     GIR_EraseRootFromParent_Done,
     /* 1832205 */   // Label 24825: @1832205
     /* 1832205 */   GIM_Try, /*On fail goto*//*Label 24826*/ GIMT_Encode4(1832291), // Rule ID 13123 //
     /* 1832210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1832221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1832224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1832227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1832230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832256 */     // MIs[0] policy
     /* 1832256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832266 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1832269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832290 */     // GIR_Coverage, 13123,
     /* 1832290 */     GIR_EraseRootFromParent_Done,
     /* 1832291 */   // Label 24826: @1832291
     /* 1832291 */   GIM_Try, /*On fail goto*//*Label 24827*/ GIMT_Encode4(1832377), // Rule ID 13126 //
     /* 1832296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1832299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1832307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1832310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1832313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1832316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832342 */     // MIs[0] policy
     /* 1832342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1832355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1832373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832376 */     // GIR_Coverage, 13126,
     /* 1832376 */     GIR_EraseRootFromParent_Done,
     /* 1832377 */   // Label 24827: @1832377
     /* 1832377 */   GIM_Try, /*On fail goto*//*Label 24828*/ GIMT_Encode4(1832463), // Rule ID 13127 //
     /* 1832382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1832385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1832393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1832396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1832399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1832402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832428 */     // MIs[0] policy
     /* 1832428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832438 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1832441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1832459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832462 */     // GIR_Coverage, 13127,
     /* 1832462 */     GIR_EraseRootFromParent_Done,
     /* 1832463 */   // Label 24828: @1832463
     /* 1832463 */   GIM_Try, /*On fail goto*//*Label 24829*/ GIMT_Encode4(1832549), // Rule ID 13130 //
     /* 1832468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1832479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1832482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1832485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1832488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832514 */     // MIs[0] policy
     /* 1832514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832524 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1832527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832548 */     // GIR_Coverage, 13130,
     /* 1832548 */     GIR_EraseRootFromParent_Done,
     /* 1832549 */   // Label 24829: @1832549
     /* 1832549 */   GIM_Try, /*On fail goto*//*Label 24830*/ GIMT_Encode4(1832635), // Rule ID 13131 //
     /* 1832554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1832565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1832568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1832571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1832574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832600 */     // MIs[0] policy
     /* 1832600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832610 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1832613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832634 */     // GIR_Coverage, 13131,
     /* 1832634 */     GIR_EraseRootFromParent_Done,
     /* 1832635 */   // Label 24830: @1832635
     /* 1832635 */   GIM_Try, /*On fail goto*//*Label 24831*/ GIMT_Encode4(1832721), // Rule ID 13134 //
     /* 1832640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1832651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1832654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1832657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1832660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832686 */     // MIs[0] policy
     /* 1832686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832696 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1832699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832720 */     // GIR_Coverage, 13134,
     /* 1832720 */     GIR_EraseRootFromParent_Done,
     /* 1832721 */   // Label 24831: @1832721
     /* 1832721 */   GIM_Try, /*On fail goto*//*Label 24832*/ GIMT_Encode4(1832807), // Rule ID 13135 //
     /* 1832726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1832737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1832740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1832743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1832746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832772 */     // MIs[0] policy
     /* 1832772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832782 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1832785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832806 */     // GIR_Coverage, 13135,
     /* 1832806 */     GIR_EraseRootFromParent_Done,
     /* 1832807 */   // Label 24832: @1832807
     /* 1832807 */   GIM_Try, /*On fail goto*//*Label 24833*/ GIMT_Encode4(1832893), // Rule ID 13138 //
     /* 1832812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1832823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1832826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1832829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1832832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1832835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832858 */     // MIs[0] policy
     /* 1832858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832868 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1832871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832892 */     // GIR_Coverage, 13138,
     /* 1832892 */     GIR_EraseRootFromParent_Done,
     /* 1832893 */   // Label 24833: @1832893
     /* 1832893 */   GIM_Try, /*On fail goto*//*Label 24834*/ GIMT_Encode4(1832979), // Rule ID 13139 //
     /* 1832898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1832909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1832912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1832915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1832918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1832921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832944 */     // MIs[0] policy
     /* 1832944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832954 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1832957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832978 */     // GIR_Coverage, 13139,
     /* 1832978 */     GIR_EraseRootFromParent_Done,
     /* 1832979 */   // Label 24834: @1832979
     /* 1832979 */   GIM_Try, /*On fail goto*//*Label 24835*/ GIMT_Encode4(1833065), // Rule ID 13142 //
     /* 1832984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1832995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1832998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1833001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1833004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833030 */     // MIs[0] policy
     /* 1833030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833040 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833064 */     // GIR_Coverage, 13142,
     /* 1833064 */     GIR_EraseRootFromParent_Done,
     /* 1833065 */   // Label 24835: @1833065
     /* 1833065 */   GIM_Try, /*On fail goto*//*Label 24836*/ GIMT_Encode4(1833151), // Rule ID 13143 //
     /* 1833070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1833081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1833084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1833087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1833090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833116 */     // MIs[0] policy
     /* 1833116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833126 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833150 */     // GIR_Coverage, 13143,
     /* 1833150 */     GIR_EraseRootFromParent_Done,
     /* 1833151 */   // Label 24836: @1833151
     /* 1833151 */   GIM_Try, /*On fail goto*//*Label 24837*/ GIMT_Encode4(1833237), // Rule ID 13146 //
     /* 1833156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1833167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1833170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1833173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1833176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833202 */     // MIs[0] policy
     /* 1833202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833212 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833236 */     // GIR_Coverage, 13146,
     /* 1833236 */     GIR_EraseRootFromParent_Done,
     /* 1833237 */   // Label 24837: @1833237
     /* 1833237 */   GIM_Try, /*On fail goto*//*Label 24838*/ GIMT_Encode4(1833323), // Rule ID 13147 //
     /* 1833242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1833253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1833256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1833259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1833262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833288 */     // MIs[0] policy
     /* 1833288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833298 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833322 */     // GIR_Coverage, 13147,
     /* 1833322 */     GIR_EraseRootFromParent_Done,
     /* 1833323 */   // Label 24838: @1833323
     /* 1833323 */   GIM_Try, /*On fail goto*//*Label 24839*/ GIMT_Encode4(1833409), // Rule ID 13150 //
     /* 1833328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1833339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1833342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1833345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1833348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833374 */     // MIs[0] policy
     /* 1833374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833384 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833408 */     // GIR_Coverage, 13150,
     /* 1833408 */     GIR_EraseRootFromParent_Done,
     /* 1833409 */   // Label 24839: @1833409
     /* 1833409 */   GIM_Try, /*On fail goto*//*Label 24840*/ GIMT_Encode4(1833495), // Rule ID 13151 //
     /* 1833414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1833425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1833428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1833431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1833434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833460 */     // MIs[0] policy
     /* 1833460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833470 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833494 */     // GIR_Coverage, 13151,
     /* 1833494 */     GIR_EraseRootFromParent_Done,
     /* 1833495 */   // Label 24840: @1833495
     /* 1833495 */   GIM_Try, /*On fail goto*//*Label 24841*/ GIMT_Encode4(1833581), // Rule ID 13154 //
     /* 1833500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1833511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1833514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1833517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1833520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833546 */     // MIs[0] policy
     /* 1833546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833556 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833580 */     // GIR_Coverage, 13154,
     /* 1833580 */     GIR_EraseRootFromParent_Done,
     /* 1833581 */   // Label 24841: @1833581
     /* 1833581 */   GIM_Try, /*On fail goto*//*Label 24842*/ GIMT_Encode4(1833667), // Rule ID 13155 //
     /* 1833586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1833597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1833600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1833603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1833606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833632 */     // MIs[0] policy
     /* 1833632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833666 */     // GIR_Coverage, 13155,
     /* 1833666 */     GIR_EraseRootFromParent_Done,
     /* 1833667 */   // Label 24842: @1833667
     /* 1833667 */   GIM_Try, /*On fail goto*//*Label 24843*/ GIMT_Encode4(1833753), // Rule ID 13158 //
     /* 1833672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1833683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1833686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1833689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1833692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833718 */     // MIs[0] policy
     /* 1833718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833728 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833752 */     // GIR_Coverage, 13158,
     /* 1833752 */     GIR_EraseRootFromParent_Done,
     /* 1833753 */   // Label 24843: @1833753
     /* 1833753 */   GIM_Try, /*On fail goto*//*Label 24844*/ GIMT_Encode4(1833839), // Rule ID 13159 //
     /* 1833758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1833769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1833772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1833775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1833778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833804 */     // MIs[0] policy
     /* 1833804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833814 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833838 */     // GIR_Coverage, 13159,
     /* 1833838 */     GIR_EraseRootFromParent_Done,
     /* 1833839 */   // Label 24844: @1833839
     /* 1833839 */   GIM_Try, /*On fail goto*//*Label 24845*/ GIMT_Encode4(1833925), // Rule ID 13162 //
     /* 1833844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1833855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1833858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1833861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1833864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833890 */     // MIs[0] policy
     /* 1833890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833900 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833924 */     // GIR_Coverage, 13162,
     /* 1833924 */     GIR_EraseRootFromParent_Done,
     /* 1833925 */   // Label 24845: @1833925
     /* 1833925 */   GIM_Try, /*On fail goto*//*Label 24846*/ GIMT_Encode4(1834011), // Rule ID 13163 //
     /* 1833930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1833941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1833944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1833947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1833950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833976 */     // MIs[0] policy
     /* 1833976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833986 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834010 */     // GIR_Coverage, 13163,
     /* 1834010 */     GIR_EraseRootFromParent_Done,
     /* 1834011 */   // Label 24846: @1834011
     /* 1834011 */   GIM_Try, /*On fail goto*//*Label 24847*/ GIMT_Encode4(1834097), // Rule ID 13166 //
     /* 1834016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1834019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1834027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1834030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1834033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1834036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834062 */     // MIs[0] policy
     /* 1834062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834072 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1834075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834096 */     // GIR_Coverage, 13166,
     /* 1834096 */     GIR_EraseRootFromParent_Done,
     /* 1834097 */   // Label 24847: @1834097
     /* 1834097 */   GIM_Try, /*On fail goto*//*Label 24848*/ GIMT_Encode4(1834183), // Rule ID 13167 //
     /* 1834102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1834105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1834113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1834116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1834119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1834122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834148 */     // MIs[0] policy
     /* 1834148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834158 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1834161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834182 */     // GIR_Coverage, 13167,
     /* 1834182 */     GIR_EraseRootFromParent_Done,
     /* 1834183 */   // Label 24848: @1834183
     /* 1834183 */   GIM_Try, /*On fail goto*//*Label 24849*/ GIMT_Encode4(1834269), // Rule ID 13170 //
     /* 1834188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1834191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1834199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1834202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1834205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1834208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834234 */     // MIs[0] policy
     /* 1834234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834244 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1834247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834268 */     // GIR_Coverage, 13170,
     /* 1834268 */     GIR_EraseRootFromParent_Done,
     /* 1834269 */   // Label 24849: @1834269
     /* 1834269 */   GIM_Try, /*On fail goto*//*Label 24850*/ GIMT_Encode4(1834355), // Rule ID 13171 //
     /* 1834274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1834277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1834285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1834288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1834291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1834294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834320 */     // MIs[0] policy
     /* 1834320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834330 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1834333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834354 */     // GIR_Coverage, 13171,
     /* 1834354 */     GIR_EraseRootFromParent_Done,
     /* 1834355 */   // Label 24850: @1834355
     /* 1834355 */   GIM_Try, /*On fail goto*//*Label 24851*/ GIMT_Encode4(1834441), // Rule ID 13174 //
     /* 1834360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1834363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1834371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1834374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1834377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1834380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834406 */     // MIs[0] policy
     /* 1834406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834416 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1834419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834440 */     // GIR_Coverage, 13174,
     /* 1834440 */     GIR_EraseRootFromParent_Done,
     /* 1834441 */   // Label 24851: @1834441
     /* 1834441 */   GIM_Try, /*On fail goto*//*Label 24852*/ GIMT_Encode4(1834527), // Rule ID 13175 //
     /* 1834446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1834449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1834457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1834460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1834463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1834466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834492 */     // MIs[0] policy
     /* 1834492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1834505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834526 */     // GIR_Coverage, 13175,
     /* 1834526 */     GIR_EraseRootFromParent_Done,
     /* 1834527 */   // Label 24852: @1834527
     /* 1834527 */   GIM_Try, /*On fail goto*//*Label 24853*/ GIMT_Encode4(1834613), // Rule ID 13178 //
     /* 1834532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1834543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1834546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1834552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834578 */     // MIs[0] policy
     /* 1834578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834588 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1834591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834612 */     // GIR_Coverage, 13178,
     /* 1834612 */     GIR_EraseRootFromParent_Done,
     /* 1834613 */   // Label 24853: @1834613
     /* 1834613 */   GIM_Try, /*On fail goto*//*Label 24854*/ GIMT_Encode4(1834699), // Rule ID 13179 //
     /* 1834618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1834629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1834632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1834638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834664 */     // MIs[0] policy
     /* 1834664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834674 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1834677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834698 */     // GIR_Coverage, 13179,
     /* 1834698 */     GIR_EraseRootFromParent_Done,
     /* 1834699 */   // Label 24854: @1834699
     /* 1834699 */   GIM_Try, /*On fail goto*//*Label 24855*/ GIMT_Encode4(1834785), // Rule ID 13182 //
     /* 1834704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1834715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1834718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1834724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834750 */     // MIs[0] policy
     /* 1834750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834760 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1834763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834784 */     // GIR_Coverage, 13182,
     /* 1834784 */     GIR_EraseRootFromParent_Done,
     /* 1834785 */   // Label 24855: @1834785
     /* 1834785 */   GIM_Try, /*On fail goto*//*Label 24856*/ GIMT_Encode4(1834871), // Rule ID 13183 //
     /* 1834790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1834801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1834804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1834810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834836 */     // MIs[0] policy
     /* 1834836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834846 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1834849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834870 */     // GIR_Coverage, 13183,
     /* 1834870 */     GIR_EraseRootFromParent_Done,
     /* 1834871 */   // Label 24856: @1834871
     /* 1834871 */   GIM_Try, /*On fail goto*//*Label 24857*/ GIMT_Encode4(1834957), // Rule ID 13186 //
     /* 1834876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1834887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1834890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1834896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834922 */     // MIs[0] policy
     /* 1834922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834932 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1834935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834956 */     // GIR_Coverage, 13186,
     /* 1834956 */     GIR_EraseRootFromParent_Done,
     /* 1834957 */   // Label 24857: @1834957
     /* 1834957 */   GIM_Try, /*On fail goto*//*Label 24858*/ GIMT_Encode4(1835043), // Rule ID 13187 //
     /* 1834962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1834973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1834976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1834982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835008 */     // MIs[0] policy
     /* 1835008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835018 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1835021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835042 */     // GIR_Coverage, 13187,
     /* 1835042 */     GIR_EraseRootFromParent_Done,
     /* 1835043 */   // Label 24858: @1835043
     /* 1835043 */   GIM_Try, /*On fail goto*//*Label 24859*/ GIMT_Encode4(1835129), // Rule ID 13190 //
     /* 1835048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1835059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1835062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1835068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835094 */     // MIs[0] policy
     /* 1835094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835104 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1835107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835128 */     // GIR_Coverage, 13190,
     /* 1835128 */     GIR_EraseRootFromParent_Done,
     /* 1835129 */   // Label 24859: @1835129
     /* 1835129 */   GIM_Try, /*On fail goto*//*Label 24860*/ GIMT_Encode4(1835215), // Rule ID 13191 //
     /* 1835134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1835145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1835148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1835154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835180 */     // MIs[0] policy
     /* 1835180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1835193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835214 */     // GIR_Coverage, 13191,
     /* 1835214 */     GIR_EraseRootFromParent_Done,
     /* 1835215 */   // Label 24860: @1835215
     /* 1835215 */   GIM_Try, /*On fail goto*//*Label 24861*/ GIMT_Encode4(1835301), // Rule ID 13194 //
     /* 1835220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1835231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1835234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1835240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835266 */     // MIs[0] policy
     /* 1835266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835276 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1835279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835300 */     // GIR_Coverage, 13194,
     /* 1835300 */     GIR_EraseRootFromParent_Done,
     /* 1835301 */   // Label 24861: @1835301
     /* 1835301 */   GIM_Try, /*On fail goto*//*Label 24862*/ GIMT_Encode4(1835387), // Rule ID 13195 //
     /* 1835306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1835317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1835320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1835326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835352 */     // MIs[0] policy
     /* 1835352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835362 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1835365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835386 */     // GIR_Coverage, 13195,
     /* 1835386 */     GIR_EraseRootFromParent_Done,
     /* 1835387 */   // Label 24862: @1835387
     /* 1835387 */   GIM_Try, /*On fail goto*//*Label 24863*/ GIMT_Encode4(1835473), // Rule ID 13198 //
     /* 1835392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1835403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1835406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1835412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835438 */     // MIs[0] policy
     /* 1835438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835448 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1835451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835472 */     // GIR_Coverage, 13198,
     /* 1835472 */     GIR_EraseRootFromParent_Done,
     /* 1835473 */   // Label 24863: @1835473
     /* 1835473 */   GIM_Try, /*On fail goto*//*Label 24864*/ GIMT_Encode4(1835559), // Rule ID 13199 //
     /* 1835478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1835489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1835492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1835498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835524 */     // MIs[0] policy
     /* 1835524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835534 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1835537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835558 */     // GIR_Coverage, 13199,
     /* 1835558 */     GIR_EraseRootFromParent_Done,
     /* 1835559 */   // Label 24864: @1835559
     /* 1835559 */   GIM_Try, /*On fail goto*//*Label 24865*/ GIMT_Encode4(1835645), // Rule ID 13202 //
     /* 1835564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1835575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1835578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1835584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835610 */     // MIs[0] policy
     /* 1835610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835620 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835644 */     // GIR_Coverage, 13202,
     /* 1835644 */     GIR_EraseRootFromParent_Done,
     /* 1835645 */   // Label 24865: @1835645
     /* 1835645 */   GIM_Try, /*On fail goto*//*Label 24866*/ GIMT_Encode4(1835731), // Rule ID 13203 //
     /* 1835650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1835661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1835664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1835670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835696 */     // MIs[0] policy
     /* 1835696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835706 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835730 */     // GIR_Coverage, 13203,
     /* 1835730 */     GIR_EraseRootFromParent_Done,
     /* 1835731 */   // Label 24866: @1835731
     /* 1835731 */   GIM_Try, /*On fail goto*//*Label 24867*/ GIMT_Encode4(1835817), // Rule ID 13206 //
     /* 1835736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1835747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1835750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1835756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835782 */     // MIs[0] policy
     /* 1835782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835792 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835816 */     // GIR_Coverage, 13206,
     /* 1835816 */     GIR_EraseRootFromParent_Done,
     /* 1835817 */   // Label 24867: @1835817
     /* 1835817 */   GIM_Try, /*On fail goto*//*Label 24868*/ GIMT_Encode4(1835903), // Rule ID 13207 //
     /* 1835822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1835833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1835836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1835842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835868 */     // MIs[0] policy
     /* 1835868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835878 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835902 */     // GIR_Coverage, 13207,
     /* 1835902 */     GIR_EraseRootFromParent_Done,
     /* 1835903 */   // Label 24868: @1835903
     /* 1835903 */   GIM_Try, /*On fail goto*//*Label 24869*/ GIMT_Encode4(1835989), // Rule ID 13210 //
     /* 1835908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1835919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1835922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1835928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835954 */     // MIs[0] policy
     /* 1835954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835964 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835988 */     // GIR_Coverage, 13210,
     /* 1835988 */     GIR_EraseRootFromParent_Done,
     /* 1835989 */   // Label 24869: @1835989
     /* 1835989 */   GIM_Try, /*On fail goto*//*Label 24870*/ GIMT_Encode4(1836075), // Rule ID 13211 //
     /* 1835994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1836005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1836008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1836014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1836017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836040 */     // MIs[0] policy
     /* 1836040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1836053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836074 */     // GIR_Coverage, 13211,
     /* 1836074 */     GIR_EraseRootFromParent_Done,
     /* 1836075 */   // Label 24870: @1836075
     /* 1836075 */   GIM_Try, /*On fail goto*//*Label 24871*/ GIMT_Encode4(1836161), // Rule ID 13214 //
     /* 1836080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1836083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1836091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1836094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1836100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836126 */     // MIs[0] policy
     /* 1836126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836136 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1836139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1836157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836160 */     // GIR_Coverage, 13214,
     /* 1836160 */     GIR_EraseRootFromParent_Done,
     /* 1836161 */   // Label 24871: @1836161
     /* 1836161 */   GIM_Try, /*On fail goto*//*Label 24872*/ GIMT_Encode4(1836247), // Rule ID 13215 //
     /* 1836166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1836169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1836177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1836180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1836186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836212 */     // MIs[0] policy
     /* 1836212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836222 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1836225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1836243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836246 */     // GIR_Coverage, 13215,
     /* 1836246 */     GIR_EraseRootFromParent_Done,
     /* 1836247 */   // Label 24872: @1836247
     /* 1836247 */   GIM_Try, /*On fail goto*//*Label 24873*/ GIMT_Encode4(1836333), // Rule ID 13218 //
     /* 1836252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1836263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1836266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1836272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836298 */     // MIs[0] policy
     /* 1836298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836308 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836332 */     // GIR_Coverage, 13218,
     /* 1836332 */     GIR_EraseRootFromParent_Done,
     /* 1836333 */   // Label 24873: @1836333
     /* 1836333 */   GIM_Try, /*On fail goto*//*Label 24874*/ GIMT_Encode4(1836419), // Rule ID 13219 //
     /* 1836338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1836349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1836352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1836358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836384 */     // MIs[0] policy
     /* 1836384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836394 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836418 */     // GIR_Coverage, 13219,
     /* 1836418 */     GIR_EraseRootFromParent_Done,
     /* 1836419 */   // Label 24874: @1836419
     /* 1836419 */   GIM_Try, /*On fail goto*//*Label 24875*/ GIMT_Encode4(1836505), // Rule ID 13222 //
     /* 1836424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1836435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1836438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1836444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836470 */     // MIs[0] policy
     /* 1836470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836480 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836504 */     // GIR_Coverage, 13222,
     /* 1836504 */     GIR_EraseRootFromParent_Done,
     /* 1836505 */   // Label 24875: @1836505
     /* 1836505 */   GIM_Try, /*On fail goto*//*Label 24876*/ GIMT_Encode4(1836591), // Rule ID 13223 //
     /* 1836510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1836521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1836524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1836530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836556 */     // MIs[0] policy
     /* 1836556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836566 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836590 */     // GIR_Coverage, 13223,
     /* 1836590 */     GIR_EraseRootFromParent_Done,
     /* 1836591 */   // Label 24876: @1836591
     /* 1836591 */   GIM_Try, /*On fail goto*//*Label 24877*/ GIMT_Encode4(1836677), // Rule ID 13226 //
     /* 1836596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1836607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1836610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1836616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1836619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836642 */     // MIs[0] policy
     /* 1836642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836652 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1836655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836676 */     // GIR_Coverage, 13226,
     /* 1836676 */     GIR_EraseRootFromParent_Done,
     /* 1836677 */   // Label 24877: @1836677
     /* 1836677 */   GIM_Try, /*On fail goto*//*Label 24878*/ GIMT_Encode4(1836763), // Rule ID 13227 //
     /* 1836682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1836693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1836696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1836702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1836705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836728 */     // MIs[0] policy
     /* 1836728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836738 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1836741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836762 */     // GIR_Coverage, 13227,
     /* 1836762 */     GIR_EraseRootFromParent_Done,
     /* 1836763 */   // Label 24878: @1836763
     /* 1836763 */   GIM_Try, /*On fail goto*//*Label 24879*/ GIMT_Encode4(1836849), // Rule ID 13230 //
     /* 1836768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1836779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1836782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1836788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836814 */     // MIs[0] policy
     /* 1836814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836824 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836848 */     // GIR_Coverage, 13230,
     /* 1836848 */     GIR_EraseRootFromParent_Done,
     /* 1836849 */   // Label 24879: @1836849
     /* 1836849 */   GIM_Try, /*On fail goto*//*Label 24880*/ GIMT_Encode4(1836935), // Rule ID 13231 //
     /* 1836854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1836865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1836868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1836874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836900 */     // MIs[0] policy
     /* 1836900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836910 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836934 */     // GIR_Coverage, 13231,
     /* 1836934 */     GIR_EraseRootFromParent_Done,
     /* 1836935 */   // Label 24880: @1836935
     /* 1836935 */   GIM_Try, /*On fail goto*//*Label 24881*/ GIMT_Encode4(1837021), // Rule ID 13234 //
     /* 1836940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1836951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1836954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1836960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836986 */     // MIs[0] policy
     /* 1836986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837020 */     // GIR_Coverage, 13234,
     /* 1837020 */     GIR_EraseRootFromParent_Done,
     /* 1837021 */   // Label 24881: @1837021
     /* 1837021 */   GIM_Try, /*On fail goto*//*Label 24882*/ GIMT_Encode4(1837107), // Rule ID 13235 //
     /* 1837026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1837037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1837040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1837046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837072 */     // MIs[0] policy
     /* 1837072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837082 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837106 */     // GIR_Coverage, 13235,
     /* 1837106 */     GIR_EraseRootFromParent_Done,
     /* 1837107 */   // Label 24882: @1837107
     /* 1837107 */   GIM_Try, /*On fail goto*//*Label 24883*/ GIMT_Encode4(1837193), // Rule ID 13238 //
     /* 1837112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1837123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1837126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1837132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1837135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837158 */     // MIs[0] policy
     /* 1837158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837168 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837192 */     // GIR_Coverage, 13238,
     /* 1837192 */     GIR_EraseRootFromParent_Done,
     /* 1837193 */   // Label 24883: @1837193
     /* 1837193 */   GIM_Try, /*On fail goto*//*Label 24884*/ GIMT_Encode4(1837279), // Rule ID 13239 //
     /* 1837198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1837209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1837212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1837218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1837221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837244 */     // MIs[0] policy
     /* 1837244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837254 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837278 */     // GIR_Coverage, 13239,
     /* 1837278 */     GIR_EraseRootFromParent_Done,
     /* 1837279 */   // Label 24884: @1837279
     /* 1837279 */   GIM_Try, /*On fail goto*//*Label 24885*/ GIMT_Encode4(1837365), // Rule ID 13242 //
     /* 1837284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1837295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1837298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1837304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837330 */     // MIs[0] policy
     /* 1837330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1837343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837364 */     // GIR_Coverage, 13242,
     /* 1837364 */     GIR_EraseRootFromParent_Done,
     /* 1837365 */   // Label 24885: @1837365
     /* 1837365 */   GIM_Try, /*On fail goto*//*Label 24886*/ GIMT_Encode4(1837451), // Rule ID 13243 //
     /* 1837370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1837381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1837384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1837390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837416 */     // MIs[0] policy
     /* 1837416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1837429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837450 */     // GIR_Coverage, 13243,
     /* 1837450 */     GIR_EraseRootFromParent_Done,
     /* 1837451 */   // Label 24886: @1837451
     /* 1837451 */   GIM_Try, /*On fail goto*//*Label 24887*/ GIMT_Encode4(1837537), // Rule ID 13246 //
     /* 1837456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1837467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1837470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1837476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837502 */     // MIs[0] policy
     /* 1837502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837512 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837536 */     // GIR_Coverage, 13246,
     /* 1837536 */     GIR_EraseRootFromParent_Done,
     /* 1837537 */   // Label 24887: @1837537
     /* 1837537 */   GIM_Try, /*On fail goto*//*Label 24888*/ GIMT_Encode4(1837623), // Rule ID 13247 //
     /* 1837542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1837553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1837556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1837562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837588 */     // MIs[0] policy
     /* 1837588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837622 */     // GIR_Coverage, 13247,
     /* 1837622 */     GIR_EraseRootFromParent_Done,
     /* 1837623 */   // Label 24888: @1837623
     /* 1837623 */   GIM_Try, /*On fail goto*//*Label 24889*/ GIMT_Encode4(1837709), // Rule ID 13250 //
     /* 1837628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1837639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1837642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1837648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837674 */     // MIs[0] policy
     /* 1837674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837684 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837708 */     // GIR_Coverage, 13250,
     /* 1837708 */     GIR_EraseRootFromParent_Done,
     /* 1837709 */   // Label 24889: @1837709
     /* 1837709 */   GIM_Try, /*On fail goto*//*Label 24890*/ GIMT_Encode4(1837795), // Rule ID 13251 //
     /* 1837714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1837725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1837728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1837734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837760 */     // MIs[0] policy
     /* 1837760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837770 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837794 */     // GIR_Coverage, 13251,
     /* 1837794 */     GIR_EraseRootFromParent_Done,
     /* 1837795 */   // Label 24890: @1837795
     /* 1837795 */   GIM_Try, /*On fail goto*//*Label 24891*/ GIMT_Encode4(1837881), // Rule ID 13254 //
     /* 1837800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1837811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1837814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1837820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837846 */     // MIs[0] policy
     /* 1837846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837856 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1837859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837880 */     // GIR_Coverage, 13254,
     /* 1837880 */     GIR_EraseRootFromParent_Done,
     /* 1837881 */   // Label 24891: @1837881
     /* 1837881 */   GIM_Try, /*On fail goto*//*Label 24892*/ GIMT_Encode4(1837967), // Rule ID 13255 //
     /* 1837886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1837889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1837897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1837900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1837906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837932 */     // MIs[0] policy
     /* 1837932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1837945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837966 */     // GIR_Coverage, 13255,
     /* 1837966 */     GIR_EraseRootFromParent_Done,
     /* 1837967 */   // Label 24892: @1837967
     /* 1837967 */   GIM_Try, /*On fail goto*//*Label 24893*/ GIMT_Encode4(1838053), // Rule ID 13258 //
     /* 1837972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1837983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1837986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1837992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1838002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838018 */     // MIs[0] policy
     /* 1838018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838028 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1838031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838052 */     // GIR_Coverage, 13258,
     /* 1838052 */     GIR_EraseRootFromParent_Done,
     /* 1838053 */   // Label 24893: @1838053
     /* 1838053 */   GIM_Try, /*On fail goto*//*Label 24894*/ GIMT_Encode4(1838139), // Rule ID 13259 //
     /* 1838058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1838061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1838069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1838072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1838078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1838088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838104 */     // MIs[0] policy
     /* 1838104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838114 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1838117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838138 */     // GIR_Coverage, 13259,
     /* 1838138 */     GIR_EraseRootFromParent_Done,
     /* 1838139 */   // Label 24894: @1838139
     /* 1838139 */   GIM_Try, /*On fail goto*//*Label 24895*/ GIMT_Encode4(1838225), // Rule ID 13262 //
     /* 1838144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1838147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1838155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1838158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1838161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1838164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1838174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838190 */     // MIs[0] policy
     /* 1838190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838200 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1838203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838224 */     // GIR_Coverage, 13262,
     /* 1838224 */     GIR_EraseRootFromParent_Done,
     /* 1838225 */   // Label 24895: @1838225
     /* 1838225 */   GIM_Try, /*On fail goto*//*Label 24896*/ GIMT_Encode4(1838311), // Rule ID 13263 //
     /* 1838230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1838233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1838241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1838244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1838250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1838260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838276 */     // MIs[0] policy
     /* 1838276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838286 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1838289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838310 */     // GIR_Coverage, 13263,
     /* 1838310 */     GIR_EraseRootFromParent_Done,
     /* 1838311 */   // Label 24896: @1838311
     /* 1838311 */   GIM_Try, /*On fail goto*//*Label 24897*/ GIMT_Encode4(1838397), // Rule ID 13266 //
     /* 1838316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1838327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1838330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1838333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1838336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838362 */     // MIs[0] policy
     /* 1838362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838372 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1838375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838396 */     // GIR_Coverage, 13266,
     /* 1838396 */     GIR_EraseRootFromParent_Done,
     /* 1838397 */   // Label 24897: @1838397
     /* 1838397 */   GIM_Try, /*On fail goto*//*Label 24898*/ GIMT_Encode4(1838483), // Rule ID 13267 //
     /* 1838402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1838413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1838416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1838419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1838422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838448 */     // MIs[0] policy
     /* 1838448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838458 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1838461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838482 */     // GIR_Coverage, 13267,
     /* 1838482 */     GIR_EraseRootFromParent_Done,
     /* 1838483 */   // Label 24898: @1838483
     /* 1838483 */   GIM_Try, /*On fail goto*//*Label 24899*/ GIMT_Encode4(1838569), // Rule ID 13270 //
     /* 1838488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1838499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1838502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1838505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1838508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838534 */     // MIs[0] policy
     /* 1838534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838544 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838568 */     // GIR_Coverage, 13270,
     /* 1838568 */     GIR_EraseRootFromParent_Done,
     /* 1838569 */   // Label 24899: @1838569
     /* 1838569 */   GIM_Try, /*On fail goto*//*Label 24900*/ GIMT_Encode4(1838655), // Rule ID 13271 //
     /* 1838574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1838585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1838588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1838591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1838594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838620 */     // MIs[0] policy
     /* 1838620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838630 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838654 */     // GIR_Coverage, 13271,
     /* 1838654 */     GIR_EraseRootFromParent_Done,
     /* 1838655 */   // Label 24900: @1838655
     /* 1838655 */   GIM_Try, /*On fail goto*//*Label 24901*/ GIMT_Encode4(1838741), // Rule ID 13274 //
     /* 1838660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1838671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1838674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1838677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1838680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838706 */     // MIs[0] policy
     /* 1838706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838716 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838740 */     // GIR_Coverage, 13274,
     /* 1838740 */     GIR_EraseRootFromParent_Done,
     /* 1838741 */   // Label 24901: @1838741
     /* 1838741 */   GIM_Try, /*On fail goto*//*Label 24902*/ GIMT_Encode4(1838827), // Rule ID 13275 //
     /* 1838746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1838757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1838760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1838763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1838766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838792 */     // MIs[0] policy
     /* 1838792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838802 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838826 */     // GIR_Coverage, 13275,
     /* 1838826 */     GIR_EraseRootFromParent_Done,
     /* 1838827 */   // Label 24902: @1838827
     /* 1838827 */   GIM_Try, /*On fail goto*//*Label 24903*/ GIMT_Encode4(1838913), // Rule ID 13278 //
     /* 1838832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1838843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1838846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1838849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1838852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838878 */     // MIs[0] policy
     /* 1838878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838888 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838912 */     // GIR_Coverage, 13278,
     /* 1838912 */     GIR_EraseRootFromParent_Done,
     /* 1838913 */   // Label 24903: @1838913
     /* 1838913 */   GIM_Try, /*On fail goto*//*Label 24904*/ GIMT_Encode4(1838999), // Rule ID 13279 //
     /* 1838918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1838929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1838932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1838935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1838938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838964 */     // MIs[0] policy
     /* 1838964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838974 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838998 */     // GIR_Coverage, 13279,
     /* 1838998 */     GIR_EraseRootFromParent_Done,
     /* 1838999 */   // Label 24904: @1838999
     /* 1838999 */   GIM_Try, /*On fail goto*//*Label 24905*/ GIMT_Encode4(1839085), // Rule ID 13282 //
     /* 1839004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1839015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1839018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1839021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1839024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839050 */     // MIs[0] policy
     /* 1839050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839060 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1839063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839084 */     // GIR_Coverage, 13282,
     /* 1839084 */     GIR_EraseRootFromParent_Done,
     /* 1839085 */   // Label 24905: @1839085
     /* 1839085 */   GIM_Try, /*On fail goto*//*Label 24906*/ GIMT_Encode4(1839171), // Rule ID 13283 //
     /* 1839090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1839101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1839104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1839107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1839110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839136 */     // MIs[0] policy
     /* 1839136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839146 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1839149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839170 */     // GIR_Coverage, 13283,
     /* 1839170 */     GIR_EraseRootFromParent_Done,
     /* 1839171 */   // Label 24906: @1839171
     /* 1839171 */   GIM_Try, /*On fail goto*//*Label 24907*/ GIMT_Encode4(1839257), // Rule ID 13286 //
     /* 1839176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1839187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1839190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1839193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1839196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839222 */     // MIs[0] policy
     /* 1839222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839232 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1839235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839256 */     // GIR_Coverage, 13286,
     /* 1839256 */     GIR_EraseRootFromParent_Done,
     /* 1839257 */   // Label 24907: @1839257
     /* 1839257 */   GIM_Try, /*On fail goto*//*Label 24908*/ GIMT_Encode4(1839343), // Rule ID 13287 //
     /* 1839262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1839273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1839276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1839279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1839282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839308 */     // MIs[0] policy
     /* 1839308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839318 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1839321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839342 */     // GIR_Coverage, 13287,
     /* 1839342 */     GIR_EraseRootFromParent_Done,
     /* 1839343 */   // Label 24908: @1839343
     /* 1839343 */   GIM_Try, /*On fail goto*//*Label 24909*/ GIMT_Encode4(1839429), // Rule ID 13290 //
     /* 1839348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1839359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1839362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1839365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1839368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1839371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839394 */     // MIs[0] policy
     /* 1839394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839404 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839428 */     // GIR_Coverage, 13290,
     /* 1839428 */     GIR_EraseRootFromParent_Done,
     /* 1839429 */   // Label 24909: @1839429
     /* 1839429 */   GIM_Try, /*On fail goto*//*Label 24910*/ GIMT_Encode4(1839515), // Rule ID 13291 //
     /* 1839434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1839445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1839448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1839451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1839454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1839457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839480 */     // MIs[0] policy
     /* 1839480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839490 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839514 */     // GIR_Coverage, 13291,
     /* 1839514 */     GIR_EraseRootFromParent_Done,
     /* 1839515 */   // Label 24910: @1839515
     /* 1839515 */   GIM_Try, /*On fail goto*//*Label 24911*/ GIMT_Encode4(1839601), // Rule ID 13294 //
     /* 1839520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1839531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1839534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1839537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1839540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839566 */     // MIs[0] policy
     /* 1839566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839600 */     // GIR_Coverage, 13294,
     /* 1839600 */     GIR_EraseRootFromParent_Done,
     /* 1839601 */   // Label 24911: @1839601
     /* 1839601 */   GIM_Try, /*On fail goto*//*Label 24912*/ GIMT_Encode4(1839687), // Rule ID 13295 //
     /* 1839606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1839617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1839620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1839623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1839626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839652 */     // MIs[0] policy
     /* 1839652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839662 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839686 */     // GIR_Coverage, 13295,
     /* 1839686 */     GIR_EraseRootFromParent_Done,
     /* 1839687 */   // Label 24912: @1839687
     /* 1839687 */   GIM_Try, /*On fail goto*//*Label 24913*/ GIMT_Encode4(1839773), // Rule ID 13298 //
     /* 1839692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1839703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1839706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1839709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1839712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839738 */     // MIs[0] policy
     /* 1839738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839748 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839772 */     // GIR_Coverage, 13298,
     /* 1839772 */     GIR_EraseRootFromParent_Done,
     /* 1839773 */   // Label 24913: @1839773
     /* 1839773 */   GIM_Try, /*On fail goto*//*Label 24914*/ GIMT_Encode4(1839859), // Rule ID 13299 //
     /* 1839778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1839789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1839792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1839795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1839798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839824 */     // MIs[0] policy
     /* 1839824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839858 */     // GIR_Coverage, 13299,
     /* 1839858 */     GIR_EraseRootFromParent_Done,
     /* 1839859 */   // Label 24914: @1839859
     /* 1839859 */   GIM_Try, /*On fail goto*//*Label 24915*/ GIMT_Encode4(1839945), // Rule ID 13302 //
     /* 1839864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1839867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1839875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1839878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1839881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1839884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839910 */     // MIs[0] policy
     /* 1839910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839920 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839944 */     // GIR_Coverage, 13302,
     /* 1839944 */     GIR_EraseRootFromParent_Done,
     /* 1839945 */   // Label 24915: @1839945
     /* 1839945 */   GIM_Try, /*On fail goto*//*Label 24916*/ GIMT_Encode4(1840031), // Rule ID 13303 //
     /* 1839950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1839953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1839961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1839964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1839967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1839970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839996 */     // MIs[0] policy
     /* 1839996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1840009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1840027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840030 */     // GIR_Coverage, 13303,
     /* 1840030 */     GIR_EraseRootFromParent_Done,
     /* 1840031 */   // Label 24916: @1840031
     /* 1840031 */   GIM_Try, /*On fail goto*//*Label 24917*/ GIMT_Encode4(1840117), // Rule ID 13306 //
     /* 1840036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1840047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1840050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1840053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1840056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840082 */     // MIs[0] policy
     /* 1840082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840092 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840116 */     // GIR_Coverage, 13306,
     /* 1840116 */     GIR_EraseRootFromParent_Done,
     /* 1840117 */   // Label 24917: @1840117
     /* 1840117 */   GIM_Try, /*On fail goto*//*Label 24918*/ GIMT_Encode4(1840203), // Rule ID 13307 //
     /* 1840122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1840133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1840136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1840139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1840142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840168 */     // MIs[0] policy
     /* 1840168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840178 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840202 */     // GIR_Coverage, 13307,
     /* 1840202 */     GIR_EraseRootFromParent_Done,
     /* 1840203 */   // Label 24918: @1840203
     /* 1840203 */   GIM_Try, /*On fail goto*//*Label 24919*/ GIMT_Encode4(1840289), // Rule ID 13310 //
     /* 1840208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1840219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1840222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1840225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1840228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840254 */     // MIs[0] policy
     /* 1840254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840264 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840288 */     // GIR_Coverage, 13310,
     /* 1840288 */     GIR_EraseRootFromParent_Done,
     /* 1840289 */   // Label 24919: @1840289
     /* 1840289 */   GIM_Try, /*On fail goto*//*Label 24920*/ GIMT_Encode4(1840375), // Rule ID 13311 //
     /* 1840294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1840305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1840308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1840311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1840314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840340 */     // MIs[0] policy
     /* 1840340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840350 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840374 */     // GIR_Coverage, 13311,
     /* 1840374 */     GIR_EraseRootFromParent_Done,
     /* 1840375 */   // Label 24920: @1840375
     /* 1840375 */   GIM_Try, /*On fail goto*//*Label 24921*/ GIMT_Encode4(1840461), // Rule ID 13314 //
     /* 1840380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1840391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1840394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1840397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1840400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1840403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840426 */     // MIs[0] policy
     /* 1840426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840436 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840460 */     // GIR_Coverage, 13314,
     /* 1840460 */     GIR_EraseRootFromParent_Done,
     /* 1840461 */   // Label 24921: @1840461
     /* 1840461 */   GIM_Try, /*On fail goto*//*Label 24922*/ GIMT_Encode4(1840547), // Rule ID 13315 //
     /* 1840466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1840477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1840480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1840483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1840486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1840489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840512 */     // MIs[0] policy
     /* 1840512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840522 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840546 */     // GIR_Coverage, 13315,
     /* 1840546 */     GIR_EraseRootFromParent_Done,
     /* 1840547 */   // Label 24922: @1840547
     /* 1840547 */   GIM_Try, /*On fail goto*//*Label 24923*/ GIMT_Encode4(1840633), // Rule ID 13318 //
     /* 1840552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1840563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1840566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1840569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1840572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840598 */     // MIs[0] policy
     /* 1840598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840608 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840632 */     // GIR_Coverage, 13318,
     /* 1840632 */     GIR_EraseRootFromParent_Done,
     /* 1840633 */   // Label 24923: @1840633
     /* 1840633 */   GIM_Try, /*On fail goto*//*Label 24924*/ GIMT_Encode4(1840719), // Rule ID 13319 //
     /* 1840638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1840649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1840652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1840655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1840658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840684 */     // MIs[0] policy
     /* 1840684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840718 */     // GIR_Coverage, 13319,
     /* 1840718 */     GIR_EraseRootFromParent_Done,
     /* 1840719 */   // Label 24924: @1840719
     /* 1840719 */   GIM_Try, /*On fail goto*//*Label 24925*/ GIMT_Encode4(1840805), // Rule ID 13322 //
     /* 1840724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1840735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1840738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1840741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1840744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840770 */     // MIs[0] policy
     /* 1840770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840780 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840804 */     // GIR_Coverage, 13322,
     /* 1840804 */     GIR_EraseRootFromParent_Done,
     /* 1840805 */   // Label 24925: @1840805
     /* 1840805 */   GIM_Try, /*On fail goto*//*Label 24926*/ GIMT_Encode4(1840891), // Rule ID 13323 //
     /* 1840810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1840821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1840824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1840827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1840830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840856 */     // MIs[0] policy
     /* 1840856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840890 */     // GIR_Coverage, 13323,
     /* 1840890 */     GIR_EraseRootFromParent_Done,
     /* 1840891 */   // Label 24926: @1840891
     /* 1840891 */   GIM_Try, /*On fail goto*//*Label 24927*/ GIMT_Encode4(1840977), // Rule ID 13326 //
     /* 1840896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1840907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1840910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1840913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1840916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840942 */     // MIs[0] policy
     /* 1840942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840952 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840976 */     // GIR_Coverage, 13326,
     /* 1840976 */     GIR_EraseRootFromParent_Done,
     /* 1840977 */   // Label 24927: @1840977
     /* 1840977 */   GIM_Try, /*On fail goto*//*Label 24928*/ GIMT_Encode4(1841063), // Rule ID 13327 //
     /* 1840982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1840993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1840996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1840999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1841002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1841005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841028 */     // MIs[0] policy
     /* 1841028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841038 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841062 */     // GIR_Coverage, 13327,
     /* 1841062 */     GIR_EraseRootFromParent_Done,
     /* 1841063 */   // Label 24928: @1841063
     /* 1841063 */   GIM_Try, /*On fail goto*//*Label 24929*/ GIMT_Encode4(1841149), // Rule ID 13330 //
     /* 1841068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1841079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1841082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1841085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1841088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841114 */     // MIs[0] policy
     /* 1841114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841124 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1841127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841148 */     // GIR_Coverage, 13330,
     /* 1841148 */     GIR_EraseRootFromParent_Done,
     /* 1841149 */   // Label 24929: @1841149
     /* 1841149 */   GIM_Try, /*On fail goto*//*Label 24930*/ GIMT_Encode4(1841235), // Rule ID 13331 //
     /* 1841154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1841165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1841168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1841171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1841174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841200 */     // MIs[0] policy
     /* 1841200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1841213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841234 */     // GIR_Coverage, 13331,
     /* 1841234 */     GIR_EraseRootFromParent_Done,
     /* 1841235 */   // Label 24930: @1841235
     /* 1841235 */   GIM_Try, /*On fail goto*//*Label 24931*/ GIMT_Encode4(1841321), // Rule ID 13334 //
     /* 1841240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1841251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1841254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1841257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1841260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841286 */     // MIs[0] policy
     /* 1841286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841296 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1841299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841320 */     // GIR_Coverage, 13334,
     /* 1841320 */     GIR_EraseRootFromParent_Done,
     /* 1841321 */   // Label 24931: @1841321
     /* 1841321 */   GIM_Try, /*On fail goto*//*Label 24932*/ GIMT_Encode4(1841407), // Rule ID 13335 //
     /* 1841326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1841337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1841340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1841343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1841346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841372 */     // MIs[0] policy
     /* 1841372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841382 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1841385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841406 */     // GIR_Coverage, 13335,
     /* 1841406 */     GIR_EraseRootFromParent_Done,
     /* 1841407 */   // Label 24932: @1841407
     /* 1841407 */   GIM_Try, /*On fail goto*//*Label 24933*/ GIMT_Encode4(1841493), // Rule ID 13338 //
     /* 1841412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1841423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1841426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1841429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1841432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841458 */     // MIs[0] policy
     /* 1841458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841468 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841492 */     // GIR_Coverage, 13338,
     /* 1841492 */     GIR_EraseRootFromParent_Done,
     /* 1841493 */   // Label 24933: @1841493
     /* 1841493 */   GIM_Try, /*On fail goto*//*Label 24934*/ GIMT_Encode4(1841579), // Rule ID 13339 //
     /* 1841498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1841509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1841512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1841515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1841518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841544 */     // MIs[0] policy
     /* 1841544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841554 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841578 */     // GIR_Coverage, 13339,
     /* 1841578 */     GIR_EraseRootFromParent_Done,
     /* 1841579 */   // Label 24934: @1841579
     /* 1841579 */   GIM_Try, /*On fail goto*//*Label 24935*/ GIMT_Encode4(1841665), // Rule ID 13342 //
     /* 1841584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1841595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1841598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1841601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1841604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841630 */     // MIs[0] policy
     /* 1841630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841640 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1841643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841664 */     // GIR_Coverage, 13342,
     /* 1841664 */     GIR_EraseRootFromParent_Done,
     /* 1841665 */   // Label 24935: @1841665
     /* 1841665 */   GIM_Try, /*On fail goto*//*Label 24936*/ GIMT_Encode4(1841751), // Rule ID 13343 //
     /* 1841670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1841681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1841684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1841687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1841690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841716 */     // MIs[0] policy
     /* 1841716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841726 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1841729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841750 */     // GIR_Coverage, 13343,
     /* 1841750 */     GIR_EraseRootFromParent_Done,
     /* 1841751 */   // Label 24936: @1841751
     /* 1841751 */   GIM_Try, /*On fail goto*//*Label 24937*/ GIMT_Encode4(1841837), // Rule ID 13346 //
     /* 1841756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1841767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1841770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1841773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1841776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841802 */     // MIs[0] policy
     /* 1841802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841812 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1841815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841836 */     // GIR_Coverage, 13346,
     /* 1841836 */     GIR_EraseRootFromParent_Done,
     /* 1841837 */   // Label 24937: @1841837
     /* 1841837 */   GIM_Try, /*On fail goto*//*Label 24938*/ GIMT_Encode4(1841923), // Rule ID 13347 //
     /* 1841842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1841853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1841856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1841859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1841862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841888 */     // MIs[0] policy
     /* 1841888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841898 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1841901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841922 */     // GIR_Coverage, 13347,
     /* 1841922 */     GIR_EraseRootFromParent_Done,
     /* 1841923 */   // Label 24938: @1841923
     /* 1841923 */   GIM_Try, /*On fail goto*//*Label 24939*/ GIMT_Encode4(1842009), // Rule ID 13350 //
     /* 1841928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1841939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1841942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1841945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1841948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841974 */     // MIs[0] policy
     /* 1841974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841984 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842008 */     // GIR_Coverage, 13350,
     /* 1842008 */     GIR_EraseRootFromParent_Done,
     /* 1842009 */   // Label 24939: @1842009
     /* 1842009 */   GIM_Try, /*On fail goto*//*Label 24940*/ GIMT_Encode4(1842095), // Rule ID 13351 //
     /* 1842014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1842017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1842025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1842028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1842031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1842034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1842044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842060 */     // MIs[0] policy
     /* 1842060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842070 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1842073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842094 */     // GIR_Coverage, 13351,
     /* 1842094 */     GIR_EraseRootFromParent_Done,
     /* 1842095 */   // Label 24940: @1842095
     /* 1842095 */   GIM_Try, /*On fail goto*//*Label 24941*/ GIMT_Encode4(1842181), // Rule ID 13354 //
     /* 1842100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1842111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1842114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1842120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842146 */     // MIs[0] policy
     /* 1842146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842156 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1842159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842180 */     // GIR_Coverage, 13354,
     /* 1842180 */     GIR_EraseRootFromParent_Done,
     /* 1842181 */   // Label 24941: @1842181
     /* 1842181 */   GIM_Try, /*On fail goto*//*Label 24942*/ GIMT_Encode4(1842267), // Rule ID 13355 //
     /* 1842186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1842197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1842200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1842206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842232 */     // MIs[0] policy
     /* 1842232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842242 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1842245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842266 */     // GIR_Coverage, 13355,
     /* 1842266 */     GIR_EraseRootFromParent_Done,
     /* 1842267 */   // Label 24942: @1842267
     /* 1842267 */   GIM_Try, /*On fail goto*//*Label 24943*/ GIMT_Encode4(1842353), // Rule ID 13358 //
     /* 1842272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1842283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1842286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1842292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842318 */     // MIs[0] policy
     /* 1842318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842328 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1842331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842352 */     // GIR_Coverage, 13358,
     /* 1842352 */     GIR_EraseRootFromParent_Done,
     /* 1842353 */   // Label 24943: @1842353
     /* 1842353 */   GIM_Try, /*On fail goto*//*Label 24944*/ GIMT_Encode4(1842439), // Rule ID 13359 //
     /* 1842358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1842369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1842372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1842378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842404 */     // MIs[0] policy
     /* 1842404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842414 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1842417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842438 */     // GIR_Coverage, 13359,
     /* 1842438 */     GIR_EraseRootFromParent_Done,
     /* 1842439 */   // Label 24944: @1842439
     /* 1842439 */   GIM_Try, /*On fail goto*//*Label 24945*/ GIMT_Encode4(1842525), // Rule ID 13362 //
     /* 1842444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1842455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1842458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1842464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842490 */     // MIs[0] policy
     /* 1842490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842500 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842524 */     // GIR_Coverage, 13362,
     /* 1842524 */     GIR_EraseRootFromParent_Done,
     /* 1842525 */   // Label 24945: @1842525
     /* 1842525 */   GIM_Try, /*On fail goto*//*Label 24946*/ GIMT_Encode4(1842611), // Rule ID 13363 //
     /* 1842530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1842541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1842544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1842550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842576 */     // MIs[0] policy
     /* 1842576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842586 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842610 */     // GIR_Coverage, 13363,
     /* 1842610 */     GIR_EraseRootFromParent_Done,
     /* 1842611 */   // Label 24946: @1842611
     /* 1842611 */   GIM_Try, /*On fail goto*//*Label 24947*/ GIMT_Encode4(1842697), // Rule ID 13366 //
     /* 1842616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1842627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1842630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1842636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842662 */     // MIs[0] policy
     /* 1842662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842672 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1842675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842696 */     // GIR_Coverage, 13366,
     /* 1842696 */     GIR_EraseRootFromParent_Done,
     /* 1842697 */   // Label 24947: @1842697
     /* 1842697 */   GIM_Try, /*On fail goto*//*Label 24948*/ GIMT_Encode4(1842783), // Rule ID 13367 //
     /* 1842702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1842713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1842716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1842722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842748 */     // MIs[0] policy
     /* 1842748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842758 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1842761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842782 */     // GIR_Coverage, 13367,
     /* 1842782 */     GIR_EraseRootFromParent_Done,
     /* 1842783 */   // Label 24948: @1842783
     /* 1842783 */   GIM_Try, /*On fail goto*//*Label 24949*/ GIMT_Encode4(1842869), // Rule ID 13370 //
     /* 1842788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1842799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1842802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1842808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842834 */     // MIs[0] policy
     /* 1842834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842868 */     // GIR_Coverage, 13370,
     /* 1842868 */     GIR_EraseRootFromParent_Done,
     /* 1842869 */   // Label 24949: @1842869
     /* 1842869 */   GIM_Try, /*On fail goto*//*Label 24950*/ GIMT_Encode4(1842955), // Rule ID 13371 //
     /* 1842874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1842885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1842888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1842894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842920 */     // MIs[0] policy
     /* 1842920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842930 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842954 */     // GIR_Coverage, 13371,
     /* 1842954 */     GIR_EraseRootFromParent_Done,
     /* 1842955 */   // Label 24950: @1842955
     /* 1842955 */   GIM_Try, /*On fail goto*//*Label 24951*/ GIMT_Encode4(1843041), // Rule ID 13374 //
     /* 1842960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1842971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1842974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1842980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843006 */     // MIs[0] policy
     /* 1843006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1843019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843040 */     // GIR_Coverage, 13374,
     /* 1843040 */     GIR_EraseRootFromParent_Done,
     /* 1843041 */   // Label 24951: @1843041
     /* 1843041 */   GIM_Try, /*On fail goto*//*Label 24952*/ GIMT_Encode4(1843127), // Rule ID 13375 //
     /* 1843046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1843057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1843060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1843066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843092 */     // MIs[0] policy
     /* 1843092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1843105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843126 */     // GIR_Coverage, 13375,
     /* 1843126 */     GIR_EraseRootFromParent_Done,
     /* 1843127 */   // Label 24952: @1843127
     /* 1843127 */   GIM_Try, /*On fail goto*//*Label 24953*/ GIMT_Encode4(1843213), // Rule ID 13378 //
     /* 1843132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1843143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1843146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1843152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843178 */     // MIs[0] policy
     /* 1843178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843188 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843212 */     // GIR_Coverage, 13378,
     /* 1843212 */     GIR_EraseRootFromParent_Done,
     /* 1843213 */   // Label 24953: @1843213
     /* 1843213 */   GIM_Try, /*On fail goto*//*Label 24954*/ GIMT_Encode4(1843299), // Rule ID 13379 //
     /* 1843218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1843229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1843232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1843238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843264 */     // MIs[0] policy
     /* 1843264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843274 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843298 */     // GIR_Coverage, 13379,
     /* 1843298 */     GIR_EraseRootFromParent_Done,
     /* 1843299 */   // Label 24954: @1843299
     /* 1843299 */   GIM_Try, /*On fail goto*//*Label 24955*/ GIMT_Encode4(1843385), // Rule ID 13382 //
     /* 1843304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1843315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1843318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1843324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1843327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843350 */     // MIs[0] policy
     /* 1843350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843360 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843384 */     // GIR_Coverage, 13382,
     /* 1843384 */     GIR_EraseRootFromParent_Done,
     /* 1843385 */   // Label 24955: @1843385
     /* 1843385 */   GIM_Try, /*On fail goto*//*Label 24956*/ GIMT_Encode4(1843471), // Rule ID 13383 //
     /* 1843390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1843401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1843404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1843410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1843413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843436 */     // MIs[0] policy
     /* 1843436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843470 */     // GIR_Coverage, 13383,
     /* 1843470 */     GIR_EraseRootFromParent_Done,
     /* 1843471 */   // Label 24956: @1843471
     /* 1843471 */   GIM_Try, /*On fail goto*//*Label 24957*/ GIMT_Encode4(1843557), // Rule ID 13386 //
     /* 1843476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1843487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1843490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1843496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843522 */     // MIs[0] policy
     /* 1843522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843556 */     // GIR_Coverage, 13386,
     /* 1843556 */     GIR_EraseRootFromParent_Done,
     /* 1843557 */   // Label 24957: @1843557
     /* 1843557 */   GIM_Try, /*On fail goto*//*Label 24958*/ GIMT_Encode4(1843643), // Rule ID 13387 //
     /* 1843562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1843573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1843576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1843582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843608 */     // MIs[0] policy
     /* 1843608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843642 */     // GIR_Coverage, 13387,
     /* 1843642 */     GIR_EraseRootFromParent_Done,
     /* 1843643 */   // Label 24958: @1843643
     /* 1843643 */   GIM_Try, /*On fail goto*//*Label 24959*/ GIMT_Encode4(1843729), // Rule ID 13390 //
     /* 1843648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1843651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1843668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843694 */     // MIs[0] policy
     /* 1843694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843704 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843728 */     // GIR_Coverage, 13390,
     /* 1843728 */     GIR_EraseRootFromParent_Done,
     /* 1843729 */   // Label 24959: @1843729
     /* 1843729 */   GIM_Try, /*On fail goto*//*Label 24960*/ GIMT_Encode4(1843815), // Rule ID 13391 //
     /* 1843734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1843737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1843754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843780 */     // MIs[0] policy
     /* 1843780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843814 */     // GIR_Coverage, 13391,
     /* 1843814 */     GIR_EraseRootFromParent_Done,
     /* 1843815 */   // Label 24960: @1843815
     /* 1843815 */   GIM_Try, /*On fail goto*//*Label 24961*/ GIMT_Encode4(1843901), // Rule ID 13394 //
     /* 1843820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1843831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1843834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1843840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843866 */     // MIs[0] policy
     /* 1843866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843876 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1843879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843900 */     // GIR_Coverage, 13394,
     /* 1843900 */     GIR_EraseRootFromParent_Done,
     /* 1843901 */   // Label 24961: @1843901
     /* 1843901 */   GIM_Try, /*On fail goto*//*Label 24962*/ GIMT_Encode4(1843987), // Rule ID 13395 //
     /* 1843906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1843917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1843920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1843926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843952 */     // MIs[0] policy
     /* 1843952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843962 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1843965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843986 */     // GIR_Coverage, 13395,
     /* 1843986 */     GIR_EraseRootFromParent_Done,
     /* 1843987 */   // Label 24962: @1843987
     /* 1843987 */   GIM_Try, /*On fail goto*//*Label 24963*/ GIMT_Encode4(1844073), // Rule ID 13398 //
     /* 1843992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1844003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1844006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1844012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844038 */     // MIs[0] policy
     /* 1844038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844048 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844072 */     // GIR_Coverage, 13398,
     /* 1844072 */     GIR_EraseRootFromParent_Done,
     /* 1844073 */   // Label 24963: @1844073
     /* 1844073 */   GIM_Try, /*On fail goto*//*Label 24964*/ GIMT_Encode4(1844159), // Rule ID 13399 //
     /* 1844078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1844089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1844092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1844098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844124 */     // MIs[0] policy
     /* 1844124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844134 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844158 */     // GIR_Coverage, 13399,
     /* 1844158 */     GIR_EraseRootFromParent_Done,
     /* 1844159 */   // Label 24964: @1844159
     /* 1844159 */   GIM_Try, /*On fail goto*//*Label 24965*/ GIMT_Encode4(1844245), // Rule ID 13402 //
     /* 1844164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1844175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1844178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1844184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1844187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844210 */     // MIs[0] policy
     /* 1844210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844220 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844244 */     // GIR_Coverage, 13402,
     /* 1844244 */     GIR_EraseRootFromParent_Done,
     /* 1844245 */   // Label 24965: @1844245
     /* 1844245 */   GIM_Try, /*On fail goto*//*Label 24966*/ GIMT_Encode4(1844331), // Rule ID 13403 //
     /* 1844250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1844261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1844264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1844270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1844273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844296 */     // MIs[0] policy
     /* 1844296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844306 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844330 */     // GIR_Coverage, 13403,
     /* 1844330 */     GIR_EraseRootFromParent_Done,
     /* 1844331 */   // Label 24966: @1844331
     /* 1844331 */   GIM_Try, /*On fail goto*//*Label 24967*/ GIMT_Encode4(1844417), // Rule ID 13406 //
     /* 1844336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1844347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1844350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1844356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844382 */     // MIs[0] policy
     /* 1844382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844416 */     // GIR_Coverage, 13406,
     /* 1844416 */     GIR_EraseRootFromParent_Done,
     /* 1844417 */   // Label 24967: @1844417
     /* 1844417 */   GIM_Try, /*On fail goto*//*Label 24968*/ GIMT_Encode4(1844503), // Rule ID 13407 //
     /* 1844422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1844433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1844436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1844442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844468 */     // MIs[0] policy
     /* 1844468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844478 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844502 */     // GIR_Coverage, 13407,
     /* 1844502 */     GIR_EraseRootFromParent_Done,
     /* 1844503 */   // Label 24968: @1844503
     /* 1844503 */   GIM_Try, /*On fail goto*//*Label 24969*/ GIMT_Encode4(1844589), // Rule ID 13410 //
     /* 1844508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1844528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844554 */     // MIs[0] policy
     /* 1844554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844564 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844588 */     // GIR_Coverage, 13410,
     /* 1844588 */     GIR_EraseRootFromParent_Done,
     /* 1844589 */   // Label 24969: @1844589
     /* 1844589 */   GIM_Try, /*On fail goto*//*Label 24970*/ GIMT_Encode4(1844675), // Rule ID 13411 //
     /* 1844594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1844614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844640 */     // MIs[0] policy
     /* 1844640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844650 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844674 */     // GIR_Coverage, 13411,
     /* 1844674 */     GIR_EraseRootFromParent_Done,
     /* 1844675 */   // Label 24970: @1844675
     /* 1844675 */   GIM_Try, /*On fail goto*//*Label 24971*/ GIMT_Encode4(1844761), // Rule ID 13414 //
     /* 1844680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1844700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844726 */     // MIs[0] policy
     /* 1844726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844736 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844760 */     // GIR_Coverage, 13414,
     /* 1844760 */     GIR_EraseRootFromParent_Done,
     /* 1844761 */   // Label 24971: @1844761
     /* 1844761 */   GIM_Try, /*On fail goto*//*Label 24972*/ GIMT_Encode4(1844847), // Rule ID 13415 //
     /* 1844766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1844786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844812 */     // MIs[0] policy
     /* 1844812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844822 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844846 */     // GIR_Coverage, 13415,
     /* 1844846 */     GIR_EraseRootFromParent_Done,
     /* 1844847 */   // Label 24972: @1844847
     /* 1844847 */   GIM_Try, /*On fail goto*//*Label 24973*/ GIMT_Encode4(1844933), // Rule ID 13418 //
     /* 1844852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1844872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844898 */     // MIs[0] policy
     /* 1844898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844908 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844932 */     // GIR_Coverage, 13418,
     /* 1844932 */     GIR_EraseRootFromParent_Done,
     /* 1844933 */   // Label 24973: @1844933
     /* 1844933 */   GIM_Try, /*On fail goto*//*Label 24974*/ GIMT_Encode4(1845019), // Rule ID 13419 //
     /* 1844938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1844958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844984 */     // MIs[0] policy
     /* 1844984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845018 */     // GIR_Coverage, 13419,
     /* 1845018 */     GIR_EraseRootFromParent_Done,
     /* 1845019 */   // Label 24974: @1845019
     /* 1845019 */   GIM_Try, /*On fail goto*//*Label 24975*/ GIMT_Encode4(1845105), // Rule ID 13422 //
     /* 1845024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1845035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1845038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1845044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845070 */     // MIs[0] policy
     /* 1845070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845080 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1845083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845104 */     // GIR_Coverage, 13422,
     /* 1845104 */     GIR_EraseRootFromParent_Done,
     /* 1845105 */   // Label 24975: @1845105
     /* 1845105 */   GIM_Try, /*On fail goto*//*Label 24976*/ GIMT_Encode4(1845191), // Rule ID 13423 //
     /* 1845110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1845121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1845124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1845130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845156 */     // MIs[0] policy
     /* 1845156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845166 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1845169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845190 */     // GIR_Coverage, 13423,
     /* 1845190 */     GIR_EraseRootFromParent_Done,
     /* 1845191 */   // Label 24976: @1845191
     /* 1845191 */   GIM_Try, /*On fail goto*//*Label 24977*/ GIMT_Encode4(1845277), // Rule ID 13426 //
     /* 1845196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1845207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1845210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1845216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1845219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845242 */     // MIs[0] policy
     /* 1845242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845252 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1845255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845276 */     // GIR_Coverage, 13426,
     /* 1845276 */     GIR_EraseRootFromParent_Done,
     /* 1845277 */   // Label 24977: @1845277
     /* 1845277 */   GIM_Try, /*On fail goto*//*Label 24978*/ GIMT_Encode4(1845363), // Rule ID 13427 //
     /* 1845282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1845293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1845296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1845302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1845305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845328 */     // MIs[0] policy
     /* 1845328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845338 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1845341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845362 */     // GIR_Coverage, 13427,
     /* 1845362 */     GIR_EraseRootFromParent_Done,
     /* 1845363 */   // Label 24978: @1845363
     /* 1845363 */   GIM_Try, /*On fail goto*//*Label 24979*/ GIMT_Encode4(1845449), // Rule ID 13430 //
     /* 1845368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1845371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1845379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1845382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1845388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845414 */     // MIs[0] policy
     /* 1845414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845424 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1845427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845448 */     // GIR_Coverage, 13430,
     /* 1845448 */     GIR_EraseRootFromParent_Done,
     /* 1845449 */   // Label 24979: @1845449
     /* 1845449 */   GIM_Try, /*On fail goto*//*Label 24980*/ GIMT_Encode4(1845535), // Rule ID 13431 //
     /* 1845454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1845465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1845468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1845474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845500 */     // MIs[0] policy
     /* 1845500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845510 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1845513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845534 */     // GIR_Coverage, 13431,
     /* 1845534 */     GIR_EraseRootFromParent_Done,
     /* 1845535 */   // Label 24980: @1845535
     /* 1845535 */   GIM_Try, /*On fail goto*//*Label 24981*/ GIMT_Encode4(1845621), // Rule ID 13434 //
     /* 1845540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1845543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1845560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845586 */     // MIs[0] policy
     /* 1845586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1845599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845620 */     // GIR_Coverage, 13434,
     /* 1845620 */     GIR_EraseRootFromParent_Done,
     /* 1845621 */   // Label 24981: @1845621
     /* 1845621 */   GIM_Try, /*On fail goto*//*Label 24982*/ GIMT_Encode4(1845707), // Rule ID 13435 //
     /* 1845626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1845646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845672 */     // MIs[0] policy
     /* 1845672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845682 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1845685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845706 */     // GIR_Coverage, 13435,
     /* 1845706 */     GIR_EraseRootFromParent_Done,
     /* 1845707 */   // Label 24982: @1845707
     /* 1845707 */   GIM_Try, /*On fail goto*//*Label 24983*/ GIMT_Encode4(1845793), // Rule ID 13438 //
     /* 1845712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1845715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1845732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845758 */     // MIs[0] policy
     /* 1845758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1845771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845792 */     // GIR_Coverage, 13438,
     /* 1845792 */     GIR_EraseRootFromParent_Done,
     /* 1845793 */   // Label 24983: @1845793
     /* 1845793 */   GIM_Try, /*On fail goto*//*Label 24984*/ GIMT_Encode4(1845879), // Rule ID 13439 //
     /* 1845798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1845818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845844 */     // MIs[0] policy
     /* 1845844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845854 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1845857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845878 */     // GIR_Coverage, 13439,
     /* 1845878 */     GIR_EraseRootFromParent_Done,
     /* 1845879 */   // Label 24984: @1845879
     /* 1845879 */   GIM_Try, /*On fail goto*//*Label 24985*/ GIMT_Encode4(1845965), // Rule ID 13442 //
     /* 1845884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1845895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1845898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1845901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845930 */     // MIs[0] policy
     /* 1845930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845940 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1845943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845964 */     // GIR_Coverage, 13442,
     /* 1845964 */     GIR_EraseRootFromParent_Done,
     /* 1845965 */   // Label 24985: @1845965
     /* 1845965 */   GIM_Try, /*On fail goto*//*Label 24986*/ GIMT_Encode4(1846051), // Rule ID 13443 //
     /* 1845970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1845981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1845984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1845987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846016 */     // MIs[0] policy
     /* 1846016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1846029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846050 */     // GIR_Coverage, 13443,
     /* 1846050 */     GIR_EraseRootFromParent_Done,
     /* 1846051 */   // Label 24986: @1846051
     /* 1846051 */   GIM_Try, /*On fail goto*//*Label 24987*/ GIMT_Encode4(1846137), // Rule ID 13446 //
     /* 1846056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1846067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1846070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1846073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1846076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846102 */     // MIs[0] policy
     /* 1846102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846112 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1846115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846136 */     // GIR_Coverage, 13446,
     /* 1846136 */     GIR_EraseRootFromParent_Done,
     /* 1846137 */   // Label 24987: @1846137
     /* 1846137 */   GIM_Try, /*On fail goto*//*Label 24988*/ GIMT_Encode4(1846223), // Rule ID 13447 //
     /* 1846142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1846153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1846156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1846159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1846162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846188 */     // MIs[0] policy
     /* 1846188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846198 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1846201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846222 */     // GIR_Coverage, 13447,
     /* 1846222 */     GIR_EraseRootFromParent_Done,
     /* 1846223 */   // Label 24988: @1846223
     /* 1846223 */   GIM_Try, /*On fail goto*//*Label 24989*/ GIMT_Encode4(1846309), // Rule ID 13450 //
     /* 1846228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1846239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1846242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1846245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1846248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846274 */     // MIs[0] policy
     /* 1846274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1846287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846308 */     // GIR_Coverage, 13450,
     /* 1846308 */     GIR_EraseRootFromParent_Done,
     /* 1846309 */   // Label 24989: @1846309
     /* 1846309 */   GIM_Try, /*On fail goto*//*Label 24990*/ GIMT_Encode4(1846395), // Rule ID 13451 //
     /* 1846314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1846325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1846328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1846331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1846334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846360 */     // MIs[0] policy
     /* 1846360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1846373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846394 */     // GIR_Coverage, 13451,
     /* 1846394 */     GIR_EraseRootFromParent_Done,
     /* 1846395 */   // Label 24990: @1846395
     /* 1846395 */   GIM_Try, /*On fail goto*//*Label 24991*/ GIMT_Encode4(1846481), // Rule ID 13454 //
     /* 1846400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1846411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1846414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1846417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1846420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846446 */     // MIs[0] policy
     /* 1846446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846456 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1846459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846480 */     // GIR_Coverage, 13454,
     /* 1846480 */     GIR_EraseRootFromParent_Done,
     /* 1846481 */   // Label 24991: @1846481
     /* 1846481 */   GIM_Try, /*On fail goto*//*Label 24992*/ GIMT_Encode4(1846567), // Rule ID 13455 //
     /* 1846486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1846497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1846500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1846503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1846506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846532 */     // MIs[0] policy
     /* 1846532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846542 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1846545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846566 */     // GIR_Coverage, 13455,
     /* 1846566 */     GIR_EraseRootFromParent_Done,
     /* 1846567 */   // Label 24992: @1846567
     /* 1846567 */   GIM_Try, /*On fail goto*//*Label 24993*/ GIMT_Encode4(1846653), // Rule ID 13458 //
     /* 1846572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1846583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1846586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1846589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1846592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1846595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846618 */     // MIs[0] policy
     /* 1846618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846628 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1846631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846652 */     // GIR_Coverage, 13458,
     /* 1846652 */     GIR_EraseRootFromParent_Done,
     /* 1846653 */   // Label 24993: @1846653
     /* 1846653 */   GIM_Try, /*On fail goto*//*Label 24994*/ GIMT_Encode4(1846739), // Rule ID 13459 //
     /* 1846658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1846669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1846672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1846675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1846678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1846681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846704 */     // MIs[0] policy
     /* 1846704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846714 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1846717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846738 */     // GIR_Coverage, 13459,
     /* 1846738 */     GIR_EraseRootFromParent_Done,
     /* 1846739 */   // Label 24994: @1846739
     /* 1846739 */   GIM_Try, /*On fail goto*//*Label 24995*/ GIMT_Encode4(1846825), // Rule ID 13462 //
     /* 1846744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1846755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1846758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1846761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1846764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1846767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1846774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1846778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846790 */     // MIs[0] policy
     /* 1846790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846800 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1846803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846824 */     // GIR_Coverage, 13462,
     /* 1846824 */     GIR_EraseRootFromParent_Done,
     /* 1846825 */   // Label 24995: @1846825
     /* 1846825 */   GIM_Try, /*On fail goto*//*Label 24996*/ GIMT_Encode4(1846911), // Rule ID 13463 //
     /* 1846830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1846841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1846844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1846847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1846850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1846853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1846860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1846864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846876 */     // MIs[0] policy
     /* 1846876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846886 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1846889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846910 */     // GIR_Coverage, 13463,
     /* 1846910 */     GIR_EraseRootFromParent_Done,
     /* 1846911 */   // Label 24996: @1846911
     /* 1846911 */   GIM_Try, /*On fail goto*//*Label 24997*/ GIMT_Encode4(1846997), // Rule ID 13466 //
     /* 1846916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1846927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1846930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1846933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1846936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846962 */     // MIs[0] policy
     /* 1846962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1846975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846996 */     // GIR_Coverage, 13466,
     /* 1846996 */     GIR_EraseRootFromParent_Done,
     /* 1846997 */   // Label 24997: @1846997
     /* 1846997 */   GIM_Try, /*On fail goto*//*Label 24998*/ GIMT_Encode4(1847083), // Rule ID 13467 //
     /* 1847002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1847013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1847016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1847019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1847022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847048 */     // MIs[0] policy
     /* 1847048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847058 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1847061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847082 */     // GIR_Coverage, 13467,
     /* 1847082 */     GIR_EraseRootFromParent_Done,
     /* 1847083 */   // Label 24998: @1847083
     /* 1847083 */   GIM_Try, /*On fail goto*//*Label 24999*/ GIMT_Encode4(1847169), // Rule ID 13470 //
     /* 1847088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1847099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1847102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1847105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1847108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847134 */     // MIs[0] policy
     /* 1847134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1847147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847168 */     // GIR_Coverage, 13470,
     /* 1847168 */     GIR_EraseRootFromParent_Done,
     /* 1847169 */   // Label 24999: @1847169
     /* 1847169 */   GIM_Try, /*On fail goto*//*Label 25000*/ GIMT_Encode4(1847255), // Rule ID 13471 //
     /* 1847174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1847185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1847188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1847191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1847194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847220 */     // MIs[0] policy
     /* 1847220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1847233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847254 */     // GIR_Coverage, 13471,
     /* 1847254 */     GIR_EraseRootFromParent_Done,
     /* 1847255 */   // Label 25000: @1847255
     /* 1847255 */   GIM_Try, /*On fail goto*//*Label 25001*/ GIMT_Encode4(1847341), // Rule ID 13474 //
     /* 1847260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1847271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1847274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1847277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1847280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1847283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847306 */     // MIs[0] policy
     /* 1847306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1847319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847340 */     // GIR_Coverage, 13474,
     /* 1847340 */     GIR_EraseRootFromParent_Done,
     /* 1847341 */   // Label 25001: @1847341
     /* 1847341 */   GIM_Try, /*On fail goto*//*Label 25002*/ GIMT_Encode4(1847427), // Rule ID 13475 //
     /* 1847346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1847357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1847360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1847363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1847366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1847369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847392 */     // MIs[0] policy
     /* 1847392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1847405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847426 */     // GIR_Coverage, 13475,
     /* 1847426 */     GIR_EraseRootFromParent_Done,
     /* 1847427 */   // Label 25002: @1847427
     /* 1847427 */   GIM_Try, /*On fail goto*//*Label 25003*/ GIMT_Encode4(1847513), // Rule ID 13478 //
     /* 1847432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1847443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1847446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1847449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1847452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847478 */     // MIs[0] policy
     /* 1847478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1847491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847512 */     // GIR_Coverage, 13478,
     /* 1847512 */     GIR_EraseRootFromParent_Done,
     /* 1847513 */   // Label 25003: @1847513
     /* 1847513 */   GIM_Try, /*On fail goto*//*Label 25004*/ GIMT_Encode4(1847599), // Rule ID 13479 //
     /* 1847518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1847529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1847532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1847535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1847538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847564 */     // MIs[0] policy
     /* 1847564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1847577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847598 */     // GIR_Coverage, 13479,
     /* 1847598 */     GIR_EraseRootFromParent_Done,
     /* 1847599 */   // Label 25004: @1847599
     /* 1847599 */   GIM_Try, /*On fail goto*//*Label 25005*/ GIMT_Encode4(1847685), // Rule ID 13482 //
     /* 1847604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1847615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1847618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1847621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1847624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847650 */     // MIs[0] policy
     /* 1847650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847660 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1847663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847684 */     // GIR_Coverage, 13482,
     /* 1847684 */     GIR_EraseRootFromParent_Done,
     /* 1847685 */   // Label 25005: @1847685
     /* 1847685 */   GIM_Try, /*On fail goto*//*Label 25006*/ GIMT_Encode4(1847771), // Rule ID 13483 //
     /* 1847690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1847701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1847704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1847707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1847710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847736 */     // MIs[0] policy
     /* 1847736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1847749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847770 */     // GIR_Coverage, 13483,
     /* 1847770 */     GIR_EraseRootFromParent_Done,
     /* 1847771 */   // Label 25006: @1847771
     /* 1847771 */   GIM_Try, /*On fail goto*//*Label 25007*/ GIMT_Encode4(1847857), // Rule ID 13486 //
     /* 1847776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1847793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1847796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847822 */     // MIs[0] policy
     /* 1847822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847832 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1847835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847856 */     // GIR_Coverage, 13486,
     /* 1847856 */     GIR_EraseRootFromParent_Done,
     /* 1847857 */   // Label 25007: @1847857
     /* 1847857 */   GIM_Try, /*On fail goto*//*Label 25008*/ GIMT_Encode4(1847943), // Rule ID 13487 //
     /* 1847862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1847865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1847879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1847882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847908 */     // MIs[0] policy
     /* 1847908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1847921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847942 */     // GIR_Coverage, 13487,
     /* 1847942 */     GIR_EraseRootFromParent_Done,
     /* 1847943 */   // Label 25008: @1847943
     /* 1847943 */   GIM_Try, /*On fail goto*//*Label 25009*/ GIMT_Encode4(1848029), // Rule ID 13490 //
     /* 1847948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1847959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1847962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1847965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1847968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847994 */     // MIs[0] policy
     /* 1847994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848004 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1848007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848028 */     // GIR_Coverage, 13490,
     /* 1848028 */     GIR_EraseRootFromParent_Done,
     /* 1848029 */   // Label 25009: @1848029
     /* 1848029 */   GIM_Try, /*On fail goto*//*Label 25010*/ GIMT_Encode4(1848115), // Rule ID 13491 //
     /* 1848034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1848037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1848045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1848048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1848051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1848054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848080 */     // MIs[0] policy
     /* 1848080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1848093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848114 */     // GIR_Coverage, 13491,
     /* 1848114 */     GIR_EraseRootFromParent_Done,
     /* 1848115 */   // Label 25010: @1848115
     /* 1848115 */   GIM_Try, /*On fail goto*//*Label 25011*/ GIMT_Encode4(1848201), // Rule ID 13494 //
     /* 1848120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1848123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1848131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1848134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1848137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1848140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848166 */     // MIs[0] policy
     /* 1848166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848176 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1848179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848200 */     // GIR_Coverage, 13494,
     /* 1848200 */     GIR_EraseRootFromParent_Done,
     /* 1848201 */   // Label 25011: @1848201
     /* 1848201 */   GIM_Try, /*On fail goto*//*Label 25012*/ GIMT_Encode4(1848287), // Rule ID 13495 //
     /* 1848206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1848209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1848217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1848220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1848223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1848226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848252 */     // MIs[0] policy
     /* 1848252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848262 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1848265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848286 */     // GIR_Coverage, 13495,
     /* 1848286 */     GIR_EraseRootFromParent_Done,
     /* 1848287 */   // Label 25012: @1848287
     /* 1848287 */   GIM_Try, /*On fail goto*//*Label 25013*/ GIMT_Encode4(1848373), // Rule ID 13498 //
     /* 1848292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1848295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1848303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1848306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1848309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1848312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848338 */     // MIs[0] policy
     /* 1848338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848348 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1848351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848372 */     // GIR_Coverage, 13498,
     /* 1848372 */     GIR_EraseRootFromParent_Done,
     /* 1848373 */   // Label 25013: @1848373
     /* 1848373 */   GIM_Try, /*On fail goto*//*Label 25014*/ GIMT_Encode4(1848459), // Rule ID 13499 //
     /* 1848378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1848381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1848389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1848392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1848395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1848398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848424 */     // MIs[0] policy
     /* 1848424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1848437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848458 */     // GIR_Coverage, 13499,
     /* 1848458 */     GIR_EraseRootFromParent_Done,
     /* 1848459 */   // Label 25014: @1848459
     /* 1848459 */   GIM_Try, /*On fail goto*//*Label 25015*/ GIMT_Encode4(1848545), // Rule ID 13502 //
     /* 1848464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1848475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1848478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1848484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1848487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848510 */     // MIs[0] policy
     /* 1848510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848520 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1848523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848544 */     // GIR_Coverage, 13502,
     /* 1848544 */     GIR_EraseRootFromParent_Done,
     /* 1848545 */   // Label 25015: @1848545
     /* 1848545 */   GIM_Try, /*On fail goto*//*Label 25016*/ GIMT_Encode4(1848631), // Rule ID 13503 //
     /* 1848550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1848561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1848564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1848570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1848573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848596 */     // MIs[0] policy
     /* 1848596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848606 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1848609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848630 */     // GIR_Coverage, 13503,
     /* 1848630 */     GIR_EraseRootFromParent_Done,
     /* 1848631 */   // Label 25016: @1848631
     /* 1848631 */   GIM_Try, /*On fail goto*//*Label 25017*/ GIMT_Encode4(1848717), // Rule ID 13506 //
     /* 1848636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1848647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1848650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1848656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848682 */     // MIs[0] policy
     /* 1848682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848692 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1848695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848716 */     // GIR_Coverage, 13506,
     /* 1848716 */     GIR_EraseRootFromParent_Done,
     /* 1848717 */   // Label 25017: @1848717
     /* 1848717 */   GIM_Try, /*On fail goto*//*Label 25018*/ GIMT_Encode4(1848803), // Rule ID 13507 //
     /* 1848722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1848733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1848736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1848742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848768 */     // MIs[0] policy
     /* 1848768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848778 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1848781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848802 */     // GIR_Coverage, 13507,
     /* 1848802 */     GIR_EraseRootFromParent_Done,
     /* 1848803 */   // Label 25018: @1848803
     /* 1848803 */   GIM_Try, /*On fail goto*//*Label 25019*/ GIMT_Encode4(1848889), // Rule ID 13510 //
     /* 1848808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1848819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1848822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1848828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848854 */     // MIs[0] policy
     /* 1848854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848864 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1848867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848888 */     // GIR_Coverage, 13510,
     /* 1848888 */     GIR_EraseRootFromParent_Done,
     /* 1848889 */   // Label 25019: @1848889
     /* 1848889 */   GIM_Try, /*On fail goto*//*Label 25020*/ GIMT_Encode4(1848975), // Rule ID 13511 //
     /* 1848894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1848905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1848908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1848914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848940 */     // MIs[0] policy
     /* 1848940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1848953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848974 */     // GIR_Coverage, 13511,
     /* 1848974 */     GIR_EraseRootFromParent_Done,
     /* 1848975 */   // Label 25020: @1848975
     /* 1848975 */   GIM_Try, /*On fail goto*//*Label 25021*/ GIMT_Encode4(1849061), // Rule ID 13514 //
     /* 1848980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1848991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1848994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1849000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849026 */     // MIs[0] policy
     /* 1849026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849036 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1849039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849060 */     // GIR_Coverage, 13514,
     /* 1849060 */     GIR_EraseRootFromParent_Done,
     /* 1849061 */   // Label 25021: @1849061
     /* 1849061 */   GIM_Try, /*On fail goto*//*Label 25022*/ GIMT_Encode4(1849147), // Rule ID 13515 //
     /* 1849066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1849077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1849080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1849086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849112 */     // MIs[0] policy
     /* 1849112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849122 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1849125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849146 */     // GIR_Coverage, 13515,
     /* 1849146 */     GIR_EraseRootFromParent_Done,
     /* 1849147 */   // Label 25022: @1849147
     /* 1849147 */   GIM_Try, /*On fail goto*//*Label 25023*/ GIMT_Encode4(1849233), // Rule ID 13518 //
     /* 1849152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1849163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1849166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1849172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849198 */     // MIs[0] policy
     /* 1849198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849208 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1849211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849232 */     // GIR_Coverage, 13518,
     /* 1849232 */     GIR_EraseRootFromParent_Done,
     /* 1849233 */   // Label 25023: @1849233
     /* 1849233 */   GIM_Try, /*On fail goto*//*Label 25024*/ GIMT_Encode4(1849319), // Rule ID 13519 //
     /* 1849238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1849249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1849252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1849258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849284 */     // MIs[0] policy
     /* 1849284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849294 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1849297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849318 */     // GIR_Coverage, 13519,
     /* 1849318 */     GIR_EraseRootFromParent_Done,
     /* 1849319 */   // Label 25024: @1849319
     /* 1849319 */   GIM_Try, /*On fail goto*//*Label 25025*/ GIMT_Encode4(1849405), // Rule ID 13522 //
     /* 1849324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1849335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1849338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1849344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1849347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849370 */     // MIs[0] policy
     /* 1849370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849380 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1849383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849404 */     // GIR_Coverage, 13522,
     /* 1849404 */     GIR_EraseRootFromParent_Done,
     /* 1849405 */   // Label 25025: @1849405
     /* 1849405 */   GIM_Try, /*On fail goto*//*Label 25026*/ GIMT_Encode4(1849491), // Rule ID 13523 //
     /* 1849410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1849421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1849424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1849430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1849433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849456 */     // MIs[0] policy
     /* 1849456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849466 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1849469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849490 */     // GIR_Coverage, 13523,
     /* 1849490 */     GIR_EraseRootFromParent_Done,
     /* 1849491 */   // Label 25026: @1849491
     /* 1849491 */   GIM_Try, /*On fail goto*//*Label 25027*/ GIMT_Encode4(1849577), // Rule ID 13526 //
     /* 1849496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1849507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1849510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1849516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849542 */     // MIs[0] policy
     /* 1849542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849552 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1849555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849576 */     // GIR_Coverage, 13526,
     /* 1849576 */     GIR_EraseRootFromParent_Done,
     /* 1849577 */   // Label 25027: @1849577
     /* 1849577 */   GIM_Try, /*On fail goto*//*Label 25028*/ GIMT_Encode4(1849663), // Rule ID 13527 //
     /* 1849582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1849593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1849596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1849602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849628 */     // MIs[0] policy
     /* 1849628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849638 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1849641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849662 */     // GIR_Coverage, 13527,
     /* 1849662 */     GIR_EraseRootFromParent_Done,
     /* 1849663 */   // Label 25028: @1849663
     /* 1849663 */   GIM_Try, /*On fail goto*//*Label 25029*/ GIMT_Encode4(1849749), // Rule ID 13530 //
     /* 1849668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1849679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1849682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1849688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849714 */     // MIs[0] policy
     /* 1849714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1849727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849748 */     // GIR_Coverage, 13530,
     /* 1849748 */     GIR_EraseRootFromParent_Done,
     /* 1849749 */   // Label 25029: @1849749
     /* 1849749 */   GIM_Try, /*On fail goto*//*Label 25030*/ GIMT_Encode4(1849835), // Rule ID 13531 //
     /* 1849754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1849765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1849768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1849774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849800 */     // MIs[0] policy
     /* 1849800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1849813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849834 */     // GIR_Coverage, 13531,
     /* 1849834 */     GIR_EraseRootFromParent_Done,
     /* 1849835 */   // Label 25030: @1849835
     /* 1849835 */   GIM_Try, /*On fail goto*//*Label 25031*/ GIMT_Encode4(1849921), // Rule ID 13534 //
     /* 1849840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1849851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1849854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1849860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849886 */     // MIs[0] policy
     /* 1849886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1849899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849920 */     // GIR_Coverage, 13534,
     /* 1849920 */     GIR_EraseRootFromParent_Done,
     /* 1849921 */   // Label 25031: @1849921
     /* 1849921 */   GIM_Try, /*On fail goto*//*Label 25032*/ GIMT_Encode4(1850007), // Rule ID 13535 //
     /* 1849926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1849937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1849940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1849946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849972 */     // MIs[0] policy
     /* 1849972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1849985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850006 */     // GIR_Coverage, 13535,
     /* 1850006 */     GIR_EraseRootFromParent_Done,
     /* 1850007 */   // Label 25032: @1850007
     /* 1850007 */   GIM_Try, /*On fail goto*//*Label 25033*/ GIMT_Encode4(1850093), // Rule ID 13538 //
     /* 1850012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1850023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1850026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1850032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850058 */     // MIs[0] policy
     /* 1850058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850068 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1850071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850092 */     // GIR_Coverage, 13538,
     /* 1850092 */     GIR_EraseRootFromParent_Done,
     /* 1850093 */   // Label 25033: @1850093
     /* 1850093 */   GIM_Try, /*On fail goto*//*Label 25034*/ GIMT_Encode4(1850179), // Rule ID 13539 //
     /* 1850098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1850109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1850112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1850118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850144 */     // MIs[0] policy
     /* 1850144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850154 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1850157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850178 */     // GIR_Coverage, 13539,
     /* 1850178 */     GIR_EraseRootFromParent_Done,
     /* 1850179 */   // Label 25034: @1850179
     /* 1850179 */   GIM_Try, /*On fail goto*//*Label 25035*/ GIMT_Encode4(1850265), // Rule ID 13542 //
     /* 1850184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1850195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1850198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1850204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1850207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850230 */     // MIs[0] policy
     /* 1850230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1850243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850264 */     // GIR_Coverage, 13542,
     /* 1850264 */     GIR_EraseRootFromParent_Done,
     /* 1850265 */   // Label 25035: @1850265
     /* 1850265 */   GIM_Try, /*On fail goto*//*Label 25036*/ GIMT_Encode4(1850351), // Rule ID 13543 //
     /* 1850270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1850281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1850284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1850290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1850293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850316 */     // MIs[0] policy
     /* 1850316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850326 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1850329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850350 */     // GIR_Coverage, 13543,
     /* 1850350 */     GIR_EraseRootFromParent_Done,
     /* 1850351 */   // Label 25036: @1850351
     /* 1850351 */   GIM_Try, /*On fail goto*//*Label 25037*/ GIMT_Encode4(1850437), // Rule ID 13546 //
     /* 1850356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1850367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1850370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1850376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850402 */     // MIs[0] policy
     /* 1850402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850412 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1850415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850436 */     // GIR_Coverage, 13546,
     /* 1850436 */     GIR_EraseRootFromParent_Done,
     /* 1850437 */   // Label 25037: @1850437
     /* 1850437 */   GIM_Try, /*On fail goto*//*Label 25038*/ GIMT_Encode4(1850523), // Rule ID 13547 //
     /* 1850442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1850453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1850456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1850462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850488 */     // MIs[0] policy
     /* 1850488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850498 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1850501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850522 */     // GIR_Coverage, 13547,
     /* 1850522 */     GIR_EraseRootFromParent_Done,
     /* 1850523 */   // Label 25038: @1850523
     /* 1850523 */   GIM_Try, /*On fail goto*//*Label 25039*/ GIMT_Encode4(1850609), // Rule ID 13550 //
     /* 1850528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1850539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1850542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1850548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850574 */     // MIs[0] policy
     /* 1850574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1850587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850608 */     // GIR_Coverage, 13550,
     /* 1850608 */     GIR_EraseRootFromParent_Done,
     /* 1850609 */   // Label 25039: @1850609
     /* 1850609 */   GIM_Try, /*On fail goto*//*Label 25040*/ GIMT_Encode4(1850695), // Rule ID 13551 //
     /* 1850614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1850625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1850628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1850634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850660 */     // MIs[0] policy
     /* 1850660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1850673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850694 */     // GIR_Coverage, 13551,
     /* 1850694 */     GIR_EraseRootFromParent_Done,
     /* 1850695 */   // Label 25040: @1850695
     /* 1850695 */   GIM_Try, /*On fail goto*//*Label 25041*/ GIMT_Encode4(1850781), // Rule ID 13554 //
     /* 1850700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1850711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1850714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1850720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850746 */     // MIs[0] policy
     /* 1850746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850756 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1850759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850780 */     // GIR_Coverage, 13554,
     /* 1850780 */     GIR_EraseRootFromParent_Done,
     /* 1850781 */   // Label 25041: @1850781
     /* 1850781 */   GIM_Try, /*On fail goto*//*Label 25042*/ GIMT_Encode4(1850867), // Rule ID 13555 //
     /* 1850786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1850797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1850800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1850806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850832 */     // MIs[0] policy
     /* 1850832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850842 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1850845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850866 */     // GIR_Coverage, 13555,
     /* 1850866 */     GIR_EraseRootFromParent_Done,
     /* 1850867 */   // Label 25042: @1850867
     /* 1850867 */   GIM_Try, /*On fail goto*//*Label 25043*/ GIMT_Encode4(1850953), // Rule ID 13558 //
     /* 1850872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1850883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1850886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1850892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850918 */     // MIs[0] policy
     /* 1850918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850928 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1850931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850952 */     // GIR_Coverage, 13558,
     /* 1850952 */     GIR_EraseRootFromParent_Done,
     /* 1850953 */   // Label 25043: @1850953
     /* 1850953 */   GIM_Try, /*On fail goto*//*Label 25044*/ GIMT_Encode4(1851039), // Rule ID 13559 //
     /* 1850958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1850969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1850972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1850978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851004 */     // MIs[0] policy
     /* 1851004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851014 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1851017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851038 */     // GIR_Coverage, 13559,
     /* 1851038 */     GIR_EraseRootFromParent_Done,
     /* 1851039 */   // Label 25044: @1851039
     /* 1851039 */   GIM_Try, /*On fail goto*//*Label 25045*/ GIMT_Encode4(1851125), // Rule ID 13562 //
     /* 1851044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1851055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1851058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1851061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1851064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851090 */     // MIs[0] policy
     /* 1851090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851100 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1851103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851124 */     // GIR_Coverage, 13562,
     /* 1851124 */     GIR_EraseRootFromParent_Done,
     /* 1851125 */   // Label 25045: @1851125
     /* 1851125 */   GIM_Try, /*On fail goto*//*Label 25046*/ GIMT_Encode4(1851211), // Rule ID 13563 //
     /* 1851130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1851141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1851144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1851147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1851150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851176 */     // MIs[0] policy
     /* 1851176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851186 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1851189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851210 */     // GIR_Coverage, 13563,
     /* 1851210 */     GIR_EraseRootFromParent_Done,
     /* 1851211 */   // Label 25046: @1851211
     /* 1851211 */   GIM_Try, /*On fail goto*//*Label 25047*/ GIMT_Encode4(1851297), // Rule ID 13566 //
     /* 1851216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1851227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1851230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1851233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1851236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851262 */     // MIs[0] policy
     /* 1851262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851272 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1851275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851296 */     // GIR_Coverage, 13566,
     /* 1851296 */     GIR_EraseRootFromParent_Done,
     /* 1851297 */   // Label 25047: @1851297
     /* 1851297 */   GIM_Try, /*On fail goto*//*Label 25048*/ GIMT_Encode4(1851383), // Rule ID 13567 //
     /* 1851302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1851313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1851316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1851319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1851322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851348 */     // MIs[0] policy
     /* 1851348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851358 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1851361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851382 */     // GIR_Coverage, 13567,
     /* 1851382 */     GIR_EraseRootFromParent_Done,
     /* 1851383 */   // Label 25048: @1851383
     /* 1851383 */   GIM_Try, /*On fail goto*//*Label 25049*/ GIMT_Encode4(1851469), // Rule ID 13570 //
     /* 1851388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1851399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1851402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1851405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1851408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851434 */     // MIs[0] policy
     /* 1851434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851444 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1851447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851468 */     // GIR_Coverage, 13570,
     /* 1851468 */     GIR_EraseRootFromParent_Done,
     /* 1851469 */   // Label 25049: @1851469
     /* 1851469 */   GIM_Try, /*On fail goto*//*Label 25050*/ GIMT_Encode4(1851555), // Rule ID 13571 //
     /* 1851474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1851485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1851488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1851491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1851494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851520 */     // MIs[0] policy
     /* 1851520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851530 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1851533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851554 */     // GIR_Coverage, 13571,
     /* 1851554 */     GIR_EraseRootFromParent_Done,
     /* 1851555 */   // Label 25050: @1851555
     /* 1851555 */   GIM_Try, /*On fail goto*//*Label 25051*/ GIMT_Encode4(1851641), // Rule ID 13574 //
     /* 1851560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1851571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1851574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1851577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1851580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851606 */     // MIs[0] policy
     /* 1851606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1851619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851640 */     // GIR_Coverage, 13574,
     /* 1851640 */     GIR_EraseRootFromParent_Done,
     /* 1851641 */   // Label 25051: @1851641
     /* 1851641 */   GIM_Try, /*On fail goto*//*Label 25052*/ GIMT_Encode4(1851727), // Rule ID 13575 //
     /* 1851646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1851657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1851660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1851663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1851666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851692 */     // MIs[0] policy
     /* 1851692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1851705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851726 */     // GIR_Coverage, 13575,
     /* 1851726 */     GIR_EraseRootFromParent_Done,
     /* 1851727 */   // Label 25052: @1851727
     /* 1851727 */   GIM_Try, /*On fail goto*//*Label 25053*/ GIMT_Encode4(1851813), // Rule ID 13578 //
     /* 1851732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1851743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1851746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1851749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1851752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851778 */     // MIs[0] policy
     /* 1851778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851788 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1851791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851812 */     // GIR_Coverage, 13578,
     /* 1851812 */     GIR_EraseRootFromParent_Done,
     /* 1851813 */   // Label 25053: @1851813
     /* 1851813 */   GIM_Try, /*On fail goto*//*Label 25054*/ GIMT_Encode4(1851899), // Rule ID 13579 //
     /* 1851818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1851829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1851832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1851835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1851838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851864 */     // MIs[0] policy
     /* 1851864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1851877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851898 */     // GIR_Coverage, 13579,
     /* 1851898 */     GIR_EraseRootFromParent_Done,
     /* 1851899 */   // Label 25054: @1851899
     /* 1851899 */   GIM_Try, /*On fail goto*//*Label 25055*/ GIMT_Encode4(1851985), // Rule ID 13582 //
     /* 1851904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1851915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1851918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1851921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1851924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1851927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851950 */     // MIs[0] policy
     /* 1851950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851960 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1851963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851984 */     // GIR_Coverage, 13582,
     /* 1851984 */     GIR_EraseRootFromParent_Done,
     /* 1851985 */   // Label 25055: @1851985
     /* 1851985 */   GIM_Try, /*On fail goto*//*Label 25056*/ GIMT_Encode4(1852071), // Rule ID 13583 //
     /* 1851990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1852001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1852004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1852007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1852010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1852013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852036 */     // MIs[0] policy
     /* 1852036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1852049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852070 */     // GIR_Coverage, 13583,
     /* 1852070 */     GIR_EraseRootFromParent_Done,
     /* 1852071 */   // Label 25056: @1852071
     /* 1852071 */   GIM_Try, /*On fail goto*//*Label 25057*/ GIMT_Encode4(1852157), // Rule ID 13586 //
     /* 1852076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1852087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1852090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1852093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1852096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852122 */     // MIs[0] policy
     /* 1852122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1852135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852156 */     // GIR_Coverage, 13586,
     /* 1852156 */     GIR_EraseRootFromParent_Done,
     /* 1852157 */   // Label 25057: @1852157
     /* 1852157 */   GIM_Try, /*On fail goto*//*Label 25058*/ GIMT_Encode4(1852243), // Rule ID 13587 //
     /* 1852162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1852173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1852176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1852179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1852182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852208 */     // MIs[0] policy
     /* 1852208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852218 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1852221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852242 */     // GIR_Coverage, 13587,
     /* 1852242 */     GIR_EraseRootFromParent_Done,
     /* 1852243 */   // Label 25058: @1852243
     /* 1852243 */   GIM_Try, /*On fail goto*//*Label 25059*/ GIMT_Encode4(1852329), // Rule ID 13590 //
     /* 1852248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1852259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1852262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1852265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1852268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852294 */     // MIs[0] policy
     /* 1852294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1852307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852328 */     // GIR_Coverage, 13590,
     /* 1852328 */     GIR_EraseRootFromParent_Done,
     /* 1852329 */   // Label 25059: @1852329
     /* 1852329 */   GIM_Try, /*On fail goto*//*Label 25060*/ GIMT_Encode4(1852415), // Rule ID 13591 //
     /* 1852334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1852345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1852348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1852351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1852354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852380 */     // MIs[0] policy
     /* 1852380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1852393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852414 */     // GIR_Coverage, 13591,
     /* 1852414 */     GIR_EraseRootFromParent_Done,
     /* 1852415 */   // Label 25060: @1852415
     /* 1852415 */   GIM_Try, /*On fail goto*//*Label 25061*/ GIMT_Encode4(1852501), // Rule ID 13594 //
     /* 1852420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1852431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1852434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1852437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1852440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852466 */     // MIs[0] policy
     /* 1852466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1852479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852500 */     // GIR_Coverage, 13594,
     /* 1852500 */     GIR_EraseRootFromParent_Done,
     /* 1852501 */   // Label 25061: @1852501
     /* 1852501 */   GIM_Try, /*On fail goto*//*Label 25062*/ GIMT_Encode4(1852587), // Rule ID 13595 //
     /* 1852506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1852517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1852520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1852523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1852526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852552 */     // MIs[0] policy
     /* 1852552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1852565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852586 */     // GIR_Coverage, 13595,
     /* 1852586 */     GIR_EraseRootFromParent_Done,
     /* 1852587 */   // Label 25062: @1852587
     /* 1852587 */   GIM_Try, /*On fail goto*//*Label 25063*/ GIMT_Encode4(1852673), // Rule ID 13598 //
     /* 1852592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1852603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1852606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1852609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1852612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852638 */     // MIs[0] policy
     /* 1852638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852648 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1852651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852672 */     // GIR_Coverage, 13598,
     /* 1852672 */     GIR_EraseRootFromParent_Done,
     /* 1852673 */   // Label 25063: @1852673
     /* 1852673 */   GIM_Try, /*On fail goto*//*Label 25064*/ GIMT_Encode4(1852759), // Rule ID 13599 //
     /* 1852678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1852689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1852692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1852695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1852698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852724 */     // MIs[0] policy
     /* 1852724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852734 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1852737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852758 */     // GIR_Coverage, 13599,
     /* 1852758 */     GIR_EraseRootFromParent_Done,
     /* 1852759 */   // Label 25064: @1852759
     /* 1852759 */   GIM_Try, /*On fail goto*//*Label 25065*/ GIMT_Encode4(1852845), // Rule ID 13602 //
     /* 1852764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1852775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1852778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1852781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1852784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852810 */     // MIs[0] policy
     /* 1852810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852820 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1852823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852844 */     // GIR_Coverage, 13602,
     /* 1852844 */     GIR_EraseRootFromParent_Done,
     /* 1852845 */   // Label 25065: @1852845
     /* 1852845 */   GIM_Try, /*On fail goto*//*Label 25066*/ GIMT_Encode4(1852931), // Rule ID 13603 //
     /* 1852850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1852861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1852864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1852867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1852870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852896 */     // MIs[0] policy
     /* 1852896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852906 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1852909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852930 */     // GIR_Coverage, 13603,
     /* 1852930 */     GIR_EraseRootFromParent_Done,
     /* 1852931 */   // Label 25066: @1852931
     /* 1852931 */   GIM_Try, /*On fail goto*//*Label 25067*/ GIMT_Encode4(1853017), // Rule ID 13606 //
     /* 1852936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1852939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1852947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1852950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1852953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1852956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852982 */     // MIs[0] policy
     /* 1852982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852992 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1852995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853016 */     // GIR_Coverage, 13606,
     /* 1853016 */     GIR_EraseRootFromParent_Done,
     /* 1853017 */   // Label 25067: @1853017
     /* 1853017 */   GIM_Try, /*On fail goto*//*Label 25068*/ GIMT_Encode4(1853103), // Rule ID 13607 //
     /* 1853022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1853033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1853036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1853039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1853042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853068 */     // MIs[0] policy
     /* 1853068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853078 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1853081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853102 */     // GIR_Coverage, 13607,
     /* 1853102 */     GIR_EraseRootFromParent_Done,
     /* 1853103 */   // Label 25068: @1853103
     /* 1853103 */   GIM_Try, /*On fail goto*//*Label 25069*/ GIMT_Encode4(1853189), // Rule ID 13610 //
     /* 1853108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1853119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1853122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1853125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1853128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853154 */     // MIs[0] policy
     /* 1853154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1853167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853188 */     // GIR_Coverage, 13610,
     /* 1853188 */     GIR_EraseRootFromParent_Done,
     /* 1853189 */   // Label 25069: @1853189
     /* 1853189 */   GIM_Try, /*On fail goto*//*Label 25070*/ GIMT_Encode4(1853275), // Rule ID 13611 //
     /* 1853194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1853205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1853208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1853211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1853214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853240 */     // MIs[0] policy
     /* 1853240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853250 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1853253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853274 */     // GIR_Coverage, 13611,
     /* 1853274 */     GIR_EraseRootFromParent_Done,
     /* 1853275 */   // Label 25070: @1853275
     /* 1853275 */   GIM_Try, /*On fail goto*//*Label 25071*/ GIMT_Encode4(1853361), // Rule ID 13614 //
     /* 1853280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1853291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1853294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1853297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1853300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853326 */     // MIs[0] policy
     /* 1853326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853336 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1853339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853360 */     // GIR_Coverage, 13614,
     /* 1853360 */     GIR_EraseRootFromParent_Done,
     /* 1853361 */   // Label 25071: @1853361
     /* 1853361 */   GIM_Try, /*On fail goto*//*Label 25072*/ GIMT_Encode4(1853447), // Rule ID 13615 //
     /* 1853366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1853377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1853380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1853383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1853386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853412 */     // MIs[0] policy
     /* 1853412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853422 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1853425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853446 */     // GIR_Coverage, 13615,
     /* 1853446 */     GIR_EraseRootFromParent_Done,
     /* 1853447 */   // Label 25072: @1853447
     /* 1853447 */   GIM_Try, /*On fail goto*//*Label 25073*/ GIMT_Encode4(1853533), // Rule ID 13618 //
     /* 1853452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1853463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1853466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1853469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1853472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853498 */     // MIs[0] policy
     /* 1853498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1853511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853532 */     // GIR_Coverage, 13618,
     /* 1853532 */     GIR_EraseRootFromParent_Done,
     /* 1853533 */   // Label 25073: @1853533
     /* 1853533 */   GIM_Try, /*On fail goto*//*Label 25074*/ GIMT_Encode4(1853619), // Rule ID 13619 //
     /* 1853538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1853549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1853552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1853555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1853558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853584 */     // MIs[0] policy
     /* 1853584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853594 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1853597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853618 */     // GIR_Coverage, 13619,
     /* 1853618 */     GIR_EraseRootFromParent_Done,
     /* 1853619 */   // Label 25074: @1853619
     /* 1853619 */   GIM_Try, /*On fail goto*//*Label 25075*/ GIMT_Encode4(1853705), // Rule ID 13622 //
     /* 1853624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1853635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1853638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1853644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853670 */     // MIs[0] policy
     /* 1853670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853680 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1853683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853704 */     // GIR_Coverage, 13622,
     /* 1853704 */     GIR_EraseRootFromParent_Done,
     /* 1853705 */   // Label 25075: @1853705
     /* 1853705 */   GIM_Try, /*On fail goto*//*Label 25076*/ GIMT_Encode4(1853791), // Rule ID 13623 //
     /* 1853710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1853721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1853724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1853730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853756 */     // MIs[0] policy
     /* 1853756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853766 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1853769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853790 */     // GIR_Coverage, 13623,
     /* 1853790 */     GIR_EraseRootFromParent_Done,
     /* 1853791 */   // Label 25076: @1853791
     /* 1853791 */   GIM_Try, /*On fail goto*//*Label 25077*/ GIMT_Encode4(1853877), // Rule ID 13626 //
     /* 1853796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1853807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1853810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1853816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853842 */     // MIs[0] policy
     /* 1853842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1853855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853876 */     // GIR_Coverage, 13626,
     /* 1853876 */     GIR_EraseRootFromParent_Done,
     /* 1853877 */   // Label 25077: @1853877
     /* 1853877 */   GIM_Try, /*On fail goto*//*Label 25078*/ GIMT_Encode4(1853963), // Rule ID 13627 //
     /* 1853882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1853893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1853896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1853902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853928 */     // MIs[0] policy
     /* 1853928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853938 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1853941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853962 */     // GIR_Coverage, 13627,
     /* 1853962 */     GIR_EraseRootFromParent_Done,
     /* 1853963 */   // Label 25078: @1853963
     /* 1853963 */   GIM_Try, /*On fail goto*//*Label 25079*/ GIMT_Encode4(1854049), // Rule ID 13630 //
     /* 1853968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1853979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1853982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1853988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854014 */     // MIs[0] policy
     /* 1854014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1854027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854048 */     // GIR_Coverage, 13630,
     /* 1854048 */     GIR_EraseRootFromParent_Done,
     /* 1854049 */   // Label 25079: @1854049
     /* 1854049 */   GIM_Try, /*On fail goto*//*Label 25080*/ GIMT_Encode4(1854135), // Rule ID 13631 //
     /* 1854054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1854065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1854068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1854074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854100 */     // MIs[0] policy
     /* 1854100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854110 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1854113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854134 */     // GIR_Coverage, 13631,
     /* 1854134 */     GIR_EraseRootFromParent_Done,
     /* 1854135 */   // Label 25080: @1854135
     /* 1854135 */   GIM_Try, /*On fail goto*//*Label 25081*/ GIMT_Encode4(1854221), // Rule ID 13634 //
     /* 1854140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1854151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1854154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1854160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854186 */     // MIs[0] policy
     /* 1854186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854196 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1854199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854220 */     // GIR_Coverage, 13634,
     /* 1854220 */     GIR_EraseRootFromParent_Done,
     /* 1854221 */   // Label 25081: @1854221
     /* 1854221 */   GIM_Try, /*On fail goto*//*Label 25082*/ GIMT_Encode4(1854307), // Rule ID 13635 //
     /* 1854226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1854237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1854240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1854246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854272 */     // MIs[0] policy
     /* 1854272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854282 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1854285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854306 */     // GIR_Coverage, 13635,
     /* 1854306 */     GIR_EraseRootFromParent_Done,
     /* 1854307 */   // Label 25082: @1854307
     /* 1854307 */   GIM_Try, /*On fail goto*//*Label 25083*/ GIMT_Encode4(1854393), // Rule ID 13638 //
     /* 1854312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1854323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1854326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1854332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1854335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854358 */     // MIs[0] policy
     /* 1854358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1854371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854392 */     // GIR_Coverage, 13638,
     /* 1854392 */     GIR_EraseRootFromParent_Done,
     /* 1854393 */   // Label 25083: @1854393
     /* 1854393 */   GIM_Try, /*On fail goto*//*Label 25084*/ GIMT_Encode4(1854479), // Rule ID 13639 //
     /* 1854398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1854409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1854412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1854418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1854421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854444 */     // MIs[0] policy
     /* 1854444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854454 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1854457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854478 */     // GIR_Coverage, 13639,
     /* 1854478 */     GIR_EraseRootFromParent_Done,
     /* 1854479 */   // Label 25084: @1854479
     /* 1854479 */   GIM_Try, /*On fail goto*//*Label 25085*/ GIMT_Encode4(1854565), // Rule ID 13642 //
     /* 1854484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1854495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1854498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1854504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1854507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854530 */     // MIs[0] policy
     /* 1854530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854540 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1854543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854564 */     // GIR_Coverage, 13642,
     /* 1854564 */     GIR_EraseRootFromParent_Done,
     /* 1854565 */   // Label 25085: @1854565
     /* 1854565 */   GIM_Try, /*On fail goto*//*Label 25086*/ GIMT_Encode4(1854651), // Rule ID 13643 //
     /* 1854570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1854581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1854584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1854590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1854593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854616 */     // MIs[0] policy
     /* 1854616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854626 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1854629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854650 */     // GIR_Coverage, 13643,
     /* 1854650 */     GIR_EraseRootFromParent_Done,
     /* 1854651 */   // Label 25086: @1854651
     /* 1854651 */   GIM_Try, /*On fail goto*//*Label 25087*/ GIMT_Encode4(1854737), // Rule ID 13646 //
     /* 1854656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1854667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1854670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854702 */     // MIs[0] policy
     /* 1854702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854712 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1854715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854736 */     // GIR_Coverage, 13646,
     /* 1854736 */     GIR_EraseRootFromParent_Done,
     /* 1854737 */   // Label 25087: @1854737
     /* 1854737 */   GIM_Try, /*On fail goto*//*Label 25088*/ GIMT_Encode4(1854823), // Rule ID 13647 //
     /* 1854742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1854753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1854756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854788 */     // MIs[0] policy
     /* 1854788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854798 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1854801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854822 */     // GIR_Coverage, 13647,
     /* 1854822 */     GIR_EraseRootFromParent_Done,
     /* 1854823 */   // Label 25088: @1854823
     /* 1854823 */   GIM_Try, /*On fail goto*//*Label 25089*/ GIMT_Encode4(1854909), // Rule ID 13650 //
     /* 1854828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1854839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1854842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1854848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854874 */     // MIs[0] policy
     /* 1854874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854884 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1854887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854908 */     // GIR_Coverage, 13650,
     /* 1854908 */     GIR_EraseRootFromParent_Done,
     /* 1854909 */   // Label 25089: @1854909
     /* 1854909 */   GIM_Try, /*On fail goto*//*Label 25090*/ GIMT_Encode4(1854995), // Rule ID 13651 //
     /* 1854914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1854925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1854928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1854934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854960 */     // MIs[0] policy
     /* 1854960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1854973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854994 */     // GIR_Coverage, 13651,
     /* 1854994 */     GIR_EraseRootFromParent_Done,
     /* 1854995 */   // Label 25090: @1854995
     /* 1854995 */   GIM_Try, /*On fail goto*//*Label 25091*/ GIMT_Encode4(1855081), // Rule ID 13654 //
     /* 1855000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1855011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1855014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1855020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855046 */     // MIs[0] policy
     /* 1855046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1855059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855080 */     // GIR_Coverage, 13654,
     /* 1855080 */     GIR_EraseRootFromParent_Done,
     /* 1855081 */   // Label 25091: @1855081
     /* 1855081 */   GIM_Try, /*On fail goto*//*Label 25092*/ GIMT_Encode4(1855167), // Rule ID 13655 //
     /* 1855086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1855097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1855100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1855106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855132 */     // MIs[0] policy
     /* 1855132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855142 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1855145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855166 */     // GIR_Coverage, 13655,
     /* 1855166 */     GIR_EraseRootFromParent_Done,
     /* 1855167 */   // Label 25092: @1855167
     /* 1855167 */   GIM_Try, /*On fail goto*//*Label 25093*/ GIMT_Encode4(1855253), // Rule ID 13658 //
     /* 1855172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1855183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1855186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1855192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855218 */     // MIs[0] policy
     /* 1855218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855228 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1855231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855252 */     // GIR_Coverage, 13658,
     /* 1855252 */     GIR_EraseRootFromParent_Done,
     /* 1855253 */   // Label 25093: @1855253
     /* 1855253 */   GIM_Try, /*On fail goto*//*Label 25094*/ GIMT_Encode4(1855339), // Rule ID 13659 //
     /* 1855258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1855269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1855272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1855278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855304 */     // MIs[0] policy
     /* 1855304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1855317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855338 */     // GIR_Coverage, 13659,
     /* 1855338 */     GIR_EraseRootFromParent_Done,
     /* 1855339 */   // Label 25094: @1855339
     /* 1855339 */   GIM_Try, /*On fail goto*//*Label 25095*/ GIMT_Encode4(1855425), // Rule ID 13662 //
     /* 1855344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1855355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1855358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1855364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1855367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855390 */     // MIs[0] policy
     /* 1855390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1855403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855424 */     // GIR_Coverage, 13662,
     /* 1855424 */     GIR_EraseRootFromParent_Done,
     /* 1855425 */   // Label 25095: @1855425
     /* 1855425 */   GIM_Try, /*On fail goto*//*Label 25096*/ GIMT_Encode4(1855511), // Rule ID 13663 //
     /* 1855430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1855441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1855444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1855450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1855453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855476 */     // MIs[0] policy
     /* 1855476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1855489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855510 */     // GIR_Coverage, 13663,
     /* 1855510 */     GIR_EraseRootFromParent_Done,
     /* 1855511 */   // Label 25096: @1855511
     /* 1855511 */   GIM_Try, /*On fail goto*//*Label 25097*/ GIMT_Encode4(1855597), // Rule ID 13666 //
     /* 1855516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1855527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1855530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1855536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855562 */     // MIs[0] policy
     /* 1855562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855572 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1855575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855596 */     // GIR_Coverage, 13666,
     /* 1855596 */     GIR_EraseRootFromParent_Done,
     /* 1855597 */   // Label 25097: @1855597
     /* 1855597 */   GIM_Try, /*On fail goto*//*Label 25098*/ GIMT_Encode4(1855683), // Rule ID 13667 //
     /* 1855602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1855613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1855616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1855622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855648 */     // MIs[0] policy
     /* 1855648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855658 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1855661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855682 */     // GIR_Coverage, 13667,
     /* 1855682 */     GIR_EraseRootFromParent_Done,
     /* 1855683 */   // Label 25098: @1855683
     /* 1855683 */   GIM_Try, /*On fail goto*//*Label 25099*/ GIMT_Encode4(1855769), // Rule ID 13670 //
     /* 1855688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1855699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1855702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1855708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855734 */     // MIs[0] policy
     /* 1855734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1855747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855768 */     // GIR_Coverage, 13670,
     /* 1855768 */     GIR_EraseRootFromParent_Done,
     /* 1855769 */   // Label 25099: @1855769
     /* 1855769 */   GIM_Try, /*On fail goto*//*Label 25100*/ GIMT_Encode4(1855855), // Rule ID 13671 //
     /* 1855774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1855785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1855788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1855794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855820 */     // MIs[0] policy
     /* 1855820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1855833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855854 */     // GIR_Coverage, 13671,
     /* 1855854 */     GIR_EraseRootFromParent_Done,
     /* 1855855 */   // Label 25100: @1855855
     /* 1855855 */   GIM_Try, /*On fail goto*//*Label 25101*/ GIMT_Encode4(1855941), // Rule ID 13674 //
     /* 1855860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1855871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1855874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1855880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855906 */     // MIs[0] policy
     /* 1855906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855916 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1855919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855940 */     // GIR_Coverage, 13674,
     /* 1855940 */     GIR_EraseRootFromParent_Done,
     /* 1855941 */   // Label 25101: @1855941
     /* 1855941 */   GIM_Try, /*On fail goto*//*Label 25102*/ GIMT_Encode4(1856027), // Rule ID 13675 //
     /* 1855946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1855957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1855960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1855966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855992 */     // MIs[0] policy
     /* 1855992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856002 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1856005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856026 */     // GIR_Coverage, 13675,
     /* 1856026 */     GIR_EraseRootFromParent_Done,
     /* 1856027 */   // Label 25102: @1856027
     /* 1856027 */   GIM_Try, /*On fail goto*//*Label 25103*/ GIMT_Encode4(1856113), // Rule ID 13678 //
     /* 1856032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1856043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1856046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1856052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856078 */     // MIs[0] policy
     /* 1856078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856088 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1856091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856112 */     // GIR_Coverage, 13678,
     /* 1856112 */     GIR_EraseRootFromParent_Done,
     /* 1856113 */   // Label 25103: @1856113
     /* 1856113 */   GIM_Try, /*On fail goto*//*Label 25104*/ GIMT_Encode4(1856199), // Rule ID 13679 //
     /* 1856118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1856129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1856132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1856135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1856138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856164 */     // MIs[0] policy
     /* 1856164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856174 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1856177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856198 */     // GIR_Coverage, 13679,
     /* 1856198 */     GIR_EraseRootFromParent_Done,
     /* 1856199 */   // Label 25104: @1856199
     /* 1856199 */   GIM_Try, /*On fail goto*//*Label 25105*/ GIMT_Encode4(1856285), // Rule ID 13682 //
     /* 1856204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1856215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1856218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1856221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1856224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856250 */     // MIs[0] policy
     /* 1856250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856260 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1856263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856284 */     // GIR_Coverage, 13682,
     /* 1856284 */     GIR_EraseRootFromParent_Done,
     /* 1856285 */   // Label 25105: @1856285
     /* 1856285 */   GIM_Try, /*On fail goto*//*Label 25106*/ GIMT_Encode4(1856371), // Rule ID 13683 //
     /* 1856290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1856301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1856304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1856307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1856310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856336 */     // MIs[0] policy
     /* 1856336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1856349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856370 */     // GIR_Coverage, 13683,
     /* 1856370 */     GIR_EraseRootFromParent_Done,
     /* 1856371 */   // Label 25106: @1856371
     /* 1856371 */   GIM_Try, /*On fail goto*//*Label 25107*/ GIMT_Encode4(1856457), // Rule ID 13686 //
     /* 1856376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1856387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1856390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1856393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1856396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856422 */     // MIs[0] policy
     /* 1856422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856432 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1856435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856456 */     // GIR_Coverage, 13686,
     /* 1856456 */     GIR_EraseRootFromParent_Done,
     /* 1856457 */   // Label 25107: @1856457
     /* 1856457 */   GIM_Try, /*On fail goto*//*Label 25108*/ GIMT_Encode4(1856543), // Rule ID 13687 //
     /* 1856462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1856473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1856476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1856479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1856482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856508 */     // MIs[0] policy
     /* 1856508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1856521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856542 */     // GIR_Coverage, 13687,
     /* 1856542 */     GIR_EraseRootFromParent_Done,
     /* 1856543 */   // Label 25108: @1856543
     /* 1856543 */   GIM_Try, /*On fail goto*//*Label 25109*/ GIMT_Encode4(1856629), // Rule ID 13690 //
     /* 1856548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1856559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1856562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1856565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1856568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856594 */     // MIs[0] policy
     /* 1856594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856604 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1856607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856628 */     // GIR_Coverage, 13690,
     /* 1856628 */     GIR_EraseRootFromParent_Done,
     /* 1856629 */   // Label 25109: @1856629
     /* 1856629 */   GIM_Try, /*On fail goto*//*Label 25110*/ GIMT_Encode4(1856715), // Rule ID 13691 //
     /* 1856634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1856645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1856648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1856651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1856654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856680 */     // MIs[0] policy
     /* 1856680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856690 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1856693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856714 */     // GIR_Coverage, 13691,
     /* 1856714 */     GIR_EraseRootFromParent_Done,
     /* 1856715 */   // Label 25110: @1856715
     /* 1856715 */   GIM_Try, /*On fail goto*//*Label 25111*/ GIMT_Encode4(1856801), // Rule ID 13694 //
     /* 1856720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1856731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1856734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1856737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1856740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856766 */     // MIs[0] policy
     /* 1856766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1856779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856800 */     // GIR_Coverage, 13694,
     /* 1856800 */     GIR_EraseRootFromParent_Done,
     /* 1856801 */   // Label 25111: @1856801
     /* 1856801 */   GIM_Try, /*On fail goto*//*Label 25112*/ GIMT_Encode4(1856887), // Rule ID 13695 //
     /* 1856806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1856817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1856820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1856823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1856826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856852 */     // MIs[0] policy
     /* 1856852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1856865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856886 */     // GIR_Coverage, 13695,
     /* 1856886 */     GIR_EraseRootFromParent_Done,
     /* 1856887 */   // Label 25112: @1856887
     /* 1856887 */   GIM_Try, /*On fail goto*//*Label 25113*/ GIMT_Encode4(1856973), // Rule ID 13698 //
     /* 1856892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1856903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1856906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1856909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1856912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856938 */     // MIs[0] policy
     /* 1856938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856948 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1856951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856972 */     // GIR_Coverage, 13698,
     /* 1856972 */     GIR_EraseRootFromParent_Done,
     /* 1856973 */   // Label 25113: @1856973
     /* 1856973 */   GIM_Try, /*On fail goto*//*Label 25114*/ GIMT_Encode4(1857059), // Rule ID 13699 //
     /* 1856978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1856989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1856992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1856995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1856998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857024 */     // MIs[0] policy
     /* 1857024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1857037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857058 */     // GIR_Coverage, 13699,
     /* 1857058 */     GIR_EraseRootFromParent_Done,
     /* 1857059 */   // Label 25114: @1857059
     /* 1857059 */   GIM_Try, /*On fail goto*//*Label 25115*/ GIMT_Encode4(1857145), // Rule ID 13702 //
     /* 1857064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1857075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1857078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1857081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1857084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1857087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857110 */     // MIs[0] policy
     /* 1857110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857120 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1857123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857144 */     // GIR_Coverage, 13702,
     /* 1857144 */     GIR_EraseRootFromParent_Done,
     /* 1857145 */   // Label 25115: @1857145
     /* 1857145 */   GIM_Try, /*On fail goto*//*Label 25116*/ GIMT_Encode4(1857231), // Rule ID 13703 //
     /* 1857150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1857161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1857164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1857167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1857170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1857173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857196 */     // MIs[0] policy
     /* 1857196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1857209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857230 */     // GIR_Coverage, 13703,
     /* 1857230 */     GIR_EraseRootFromParent_Done,
     /* 1857231 */   // Label 25116: @1857231
     /* 1857231 */   GIM_Try, /*On fail goto*//*Label 25117*/ GIMT_Encode4(1857317), // Rule ID 13706 //
     /* 1857236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1857247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1857250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1857253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1857256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857282 */     // MIs[0] policy
     /* 1857282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857292 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1857295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857316 */     // GIR_Coverage, 13706,
     /* 1857316 */     GIR_EraseRootFromParent_Done,
     /* 1857317 */   // Label 25117: @1857317
     /* 1857317 */   GIM_Try, /*On fail goto*//*Label 25118*/ GIMT_Encode4(1857403), // Rule ID 13707 //
     /* 1857322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1857333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1857336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1857339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1857342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857368 */     // MIs[0] policy
     /* 1857368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1857381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857402 */     // GIR_Coverage, 13707,
     /* 1857402 */     GIR_EraseRootFromParent_Done,
     /* 1857403 */   // Label 25118: @1857403
     /* 1857403 */   GIM_Try, /*On fail goto*//*Label 25119*/ GIMT_Encode4(1857489), // Rule ID 13710 //
     /* 1857408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1857419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1857422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1857425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1857428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857454 */     // MIs[0] policy
     /* 1857454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1857467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857488 */     // GIR_Coverage, 13710,
     /* 1857488 */     GIR_EraseRootFromParent_Done,
     /* 1857489 */   // Label 25119: @1857489
     /* 1857489 */   GIM_Try, /*On fail goto*//*Label 25120*/ GIMT_Encode4(1857575), // Rule ID 13711 //
     /* 1857494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1857505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1857508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1857511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1857514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857540 */     // MIs[0] policy
     /* 1857540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1857553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857574 */     // GIR_Coverage, 13711,
     /* 1857574 */     GIR_EraseRootFromParent_Done,
     /* 1857575 */   // Label 25120: @1857575
     /* 1857575 */   GIM_Try, /*On fail goto*//*Label 25121*/ GIMT_Encode4(1857661), // Rule ID 13714 //
     /* 1857580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1857591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1857594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1857597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1857600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857626 */     // MIs[0] policy
     /* 1857626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1857639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857660 */     // GIR_Coverage, 13714,
     /* 1857660 */     GIR_EraseRootFromParent_Done,
     /* 1857661 */   // Label 25121: @1857661
     /* 1857661 */   GIM_Try, /*On fail goto*//*Label 25122*/ GIMT_Encode4(1857747), // Rule ID 13715 //
     /* 1857666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1857677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1857680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1857683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1857686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857712 */     // MIs[0] policy
     /* 1857712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1857725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857746 */     // GIR_Coverage, 13715,
     /* 1857746 */     GIR_EraseRootFromParent_Done,
     /* 1857747 */   // Label 25122: @1857747
     /* 1857747 */   GIM_Try, /*On fail goto*//*Label 25123*/ GIMT_Encode4(1857833), // Rule ID 13718 //
     /* 1857752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1857763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1857766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1857769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1857772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857798 */     // MIs[0] policy
     /* 1857798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857808 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1857811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857832 */     // GIR_Coverage, 13718,
     /* 1857832 */     GIR_EraseRootFromParent_Done,
     /* 1857833 */   // Label 25123: @1857833
     /* 1857833 */   GIM_Try, /*On fail goto*//*Label 25124*/ GIMT_Encode4(1857919), // Rule ID 13719 //
     /* 1857838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1857849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1857852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1857855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1857858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857884 */     // MIs[0] policy
     /* 1857884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857894 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1857897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857918 */     // GIR_Coverage, 13719,
     /* 1857918 */     GIR_EraseRootFromParent_Done,
     /* 1857919 */   // Label 25124: @1857919
     /* 1857919 */   GIM_Try, /*On fail goto*//*Label 25125*/ GIMT_Encode4(1858005), // Rule ID 13722 //
     /* 1857924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1857935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1857938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1857941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1857944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857970 */     // MIs[0] policy
     /* 1857970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857980 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1857983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858004 */     // GIR_Coverage, 13722,
     /* 1858004 */     GIR_EraseRootFromParent_Done,
     /* 1858005 */   // Label 25125: @1858005
     /* 1858005 */   GIM_Try, /*On fail goto*//*Label 25126*/ GIMT_Encode4(1858091), // Rule ID 13723 //
     /* 1858010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1858021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1858024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1858027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1858030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1858033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858056 */     // MIs[0] policy
     /* 1858056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858066 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1858069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858090 */     // GIR_Coverage, 13723,
     /* 1858090 */     GIR_EraseRootFromParent_Done,
     /* 1858091 */   // Label 25126: @1858091
     /* 1858091 */   GIM_Try, /*On fail goto*//*Label 25127*/ GIMT_Encode4(1858177), // Rule ID 13726 //
     /* 1858096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1858107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1858110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1858113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1858116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858142 */     // MIs[0] policy
     /* 1858142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1858155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858176 */     // GIR_Coverage, 13726,
     /* 1858176 */     GIR_EraseRootFromParent_Done,
     /* 1858177 */   // Label 25127: @1858177
     /* 1858177 */   GIM_Try, /*On fail goto*//*Label 25128*/ GIMT_Encode4(1858263), // Rule ID 13727 //
     /* 1858182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1858193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1858196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1858199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1858202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858228 */     // MIs[0] policy
     /* 1858228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858238 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1858241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858262 */     // GIR_Coverage, 13727,
     /* 1858262 */     GIR_EraseRootFromParent_Done,
     /* 1858263 */   // Label 25128: @1858263
     /* 1858263 */   GIM_Try, /*On fail goto*//*Label 25129*/ GIMT_Encode4(1858349), // Rule ID 13730 //
     /* 1858268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1858279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1858282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1858285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1858288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858314 */     // MIs[0] policy
     /* 1858314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1858327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858348 */     // GIR_Coverage, 13730,
     /* 1858348 */     GIR_EraseRootFromParent_Done,
     /* 1858349 */   // Label 25129: @1858349
     /* 1858349 */   GIM_Try, /*On fail goto*//*Label 25130*/ GIMT_Encode4(1858435), // Rule ID 13731 //
     /* 1858354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1858365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1858368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1858371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1858374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858400 */     // MIs[0] policy
     /* 1858400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1858413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858434 */     // GIR_Coverage, 13731,
     /* 1858434 */     GIR_EraseRootFromParent_Done,
     /* 1858435 */   // Label 25130: @1858435
     /* 1858435 */   GIM_Try, /*On fail goto*//*Label 25131*/ GIMT_Encode4(1858521), // Rule ID 13734 //
     /* 1858440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1858451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1858454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1858457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1858460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858486 */     // MIs[0] policy
     /* 1858486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1858499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858520 */     // GIR_Coverage, 13734,
     /* 1858520 */     GIR_EraseRootFromParent_Done,
     /* 1858521 */   // Label 25131: @1858521
     /* 1858521 */   GIM_Try, /*On fail goto*//*Label 25132*/ GIMT_Encode4(1858607), // Rule ID 13735 //
     /* 1858526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1858537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1858540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1858543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1858546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858572 */     // MIs[0] policy
     /* 1858572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858582 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1858585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858606 */     // GIR_Coverage, 13735,
     /* 1858606 */     GIR_EraseRootFromParent_Done,
     /* 1858607 */   // Label 25132: @1858607
     /* 1858607 */   GIM_Try, /*On fail goto*//*Label 25133*/ GIMT_Encode4(1858693), // Rule ID 13738 //
     /* 1858612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1858623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1858626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1858629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1858632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858658 */     // MIs[0] policy
     /* 1858658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858668 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1858671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858692 */     // GIR_Coverage, 13738,
     /* 1858692 */     GIR_EraseRootFromParent_Done,
     /* 1858693 */   // Label 25133: @1858693
     /* 1858693 */   GIM_Try, /*On fail goto*//*Label 25134*/ GIMT_Encode4(1858779), // Rule ID 13739 //
     /* 1858698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1858709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1858712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1858715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1858718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858744 */     // MIs[0] policy
     /* 1858744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858754 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1858757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858778 */     // GIR_Coverage, 13739,
     /* 1858778 */     GIR_EraseRootFromParent_Done,
     /* 1858779 */   // Label 25134: @1858779
     /* 1858779 */   GIM_Try, /*On fail goto*//*Label 25135*/ GIMT_Encode4(1858865), // Rule ID 13742 //
     /* 1858784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1858795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1858798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1858804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858830 */     // MIs[0] policy
     /* 1858830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858840 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1858843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858864 */     // GIR_Coverage, 13742,
     /* 1858864 */     GIR_EraseRootFromParent_Done,
     /* 1858865 */   // Label 25135: @1858865
     /* 1858865 */   GIM_Try, /*On fail goto*//*Label 25136*/ GIMT_Encode4(1858951), // Rule ID 13743 //
     /* 1858870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1858881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1858884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1858890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858916 */     // MIs[0] policy
     /* 1858916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858926 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1858929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858950 */     // GIR_Coverage, 13743,
     /* 1858950 */     GIR_EraseRootFromParent_Done,
     /* 1858951 */   // Label 25136: @1858951
     /* 1858951 */   GIM_Try, /*On fail goto*//*Label 25137*/ GIMT_Encode4(1859037), // Rule ID 13746 //
     /* 1858956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1858967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1858970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1858976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859002 */     // MIs[0] policy
     /* 1859002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859012 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1859015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859036 */     // GIR_Coverage, 13746,
     /* 1859036 */     GIR_EraseRootFromParent_Done,
     /* 1859037 */   // Label 25137: @1859037
     /* 1859037 */   GIM_Try, /*On fail goto*//*Label 25138*/ GIMT_Encode4(1859123), // Rule ID 13747 //
     /* 1859042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1859053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1859056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1859062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859088 */     // MIs[0] policy
     /* 1859088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859098 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1859101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859122 */     // GIR_Coverage, 13747,
     /* 1859122 */     GIR_EraseRootFromParent_Done,
     /* 1859123 */   // Label 25138: @1859123
     /* 1859123 */   GIM_Try, /*On fail goto*//*Label 25139*/ GIMT_Encode4(1859209), // Rule ID 13750 //
     /* 1859128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1859139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1859142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1859148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859174 */     // MIs[0] policy
     /* 1859174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1859187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859208 */     // GIR_Coverage, 13750,
     /* 1859208 */     GIR_EraseRootFromParent_Done,
     /* 1859209 */   // Label 25139: @1859209
     /* 1859209 */   GIM_Try, /*On fail goto*//*Label 25140*/ GIMT_Encode4(1859295), // Rule ID 13751 //
     /* 1859214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1859225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1859228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1859234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859260 */     // MIs[0] policy
     /* 1859260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859270 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1859273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859294 */     // GIR_Coverage, 13751,
     /* 1859294 */     GIR_EraseRootFromParent_Done,
     /* 1859295 */   // Label 25140: @1859295
     /* 1859295 */   GIM_Try, /*On fail goto*//*Label 25141*/ GIMT_Encode4(1859381), // Rule ID 13754 //
     /* 1859300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1859311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1859314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1859320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859346 */     // MIs[0] policy
     /* 1859346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859356 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1859359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859380 */     // GIR_Coverage, 13754,
     /* 1859380 */     GIR_EraseRootFromParent_Done,
     /* 1859381 */   // Label 25141: @1859381
     /* 1859381 */   GIM_Try, /*On fail goto*//*Label 25142*/ GIMT_Encode4(1859467), // Rule ID 13755 //
     /* 1859386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1859397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1859400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1859406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859432 */     // MIs[0] policy
     /* 1859432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1859445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859466 */     // GIR_Coverage, 13755,
     /* 1859466 */     GIR_EraseRootFromParent_Done,
     /* 1859467 */   // Label 25142: @1859467
     /* 1859467 */   GIM_Try, /*On fail goto*//*Label 25143*/ GIMT_Encode4(1859553), // Rule ID 13758 //
     /* 1859472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1859483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1859486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1859492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859518 */     // MIs[0] policy
     /* 1859518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859528 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1859531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859552 */     // GIR_Coverage, 13758,
     /* 1859552 */     GIR_EraseRootFromParent_Done,
     /* 1859553 */   // Label 25143: @1859553
     /* 1859553 */   GIM_Try, /*On fail goto*//*Label 25144*/ GIMT_Encode4(1859639), // Rule ID 13759 //
     /* 1859558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1859569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1859572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1859578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859604 */     // MIs[0] policy
     /* 1859604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859614 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1859617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859638 */     // GIR_Coverage, 13759,
     /* 1859638 */     GIR_EraseRootFromParent_Done,
     /* 1859639 */   // Label 25144: @1859639
     /* 1859639 */   GIM_Try, /*On fail goto*//*Label 25145*/ GIMT_Encode4(1859725), // Rule ID 13762 //
     /* 1859644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1859655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1859658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1859664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1859667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859690 */     // MIs[0] policy
     /* 1859690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859700 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1859703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859724 */     // GIR_Coverage, 13762,
     /* 1859724 */     GIR_EraseRootFromParent_Done,
     /* 1859725 */   // Label 25145: @1859725
     /* 1859725 */   GIM_Try, /*On fail goto*//*Label 25146*/ GIMT_Encode4(1859811), // Rule ID 13763 //
     /* 1859730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1859741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1859744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1859750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1859753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859776 */     // MIs[0] policy
     /* 1859776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859786 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1859789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859810 */     // GIR_Coverage, 13763,
     /* 1859810 */     GIR_EraseRootFromParent_Done,
     /* 1859811 */   // Label 25146: @1859811
     /* 1859811 */   GIM_Try, /*On fail goto*//*Label 25147*/ GIMT_Encode4(1859897), // Rule ID 13766 //
     /* 1859816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1859827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1859830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1859836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859862 */     // MIs[0] policy
     /* 1859862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859872 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1859875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859896 */     // GIR_Coverage, 13766,
     /* 1859896 */     GIR_EraseRootFromParent_Done,
     /* 1859897 */   // Label 25147: @1859897
     /* 1859897 */   GIM_Try, /*On fail goto*//*Label 25148*/ GIMT_Encode4(1859983), // Rule ID 13767 //
     /* 1859902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1859913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1859916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1859922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859948 */     // MIs[0] policy
     /* 1859948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859958 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1859961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859982 */     // GIR_Coverage, 13767,
     /* 1859982 */     GIR_EraseRootFromParent_Done,
     /* 1859983 */   // Label 25148: @1859983
     /* 1859983 */   GIM_Try, /*On fail goto*//*Label 25149*/ GIMT_Encode4(1860069), // Rule ID 13770 //
     /* 1859988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1859999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1860002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1860008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860034 */     // MIs[0] policy
     /* 1860034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860044 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1860047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860068 */     // GIR_Coverage, 13770,
     /* 1860068 */     GIR_EraseRootFromParent_Done,
     /* 1860069 */   // Label 25149: @1860069
     /* 1860069 */   GIM_Try, /*On fail goto*//*Label 25150*/ GIMT_Encode4(1860155), // Rule ID 13771 //
     /* 1860074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1860085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1860088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1860094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860120 */     // MIs[0] policy
     /* 1860120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1860133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860154 */     // GIR_Coverage, 13771,
     /* 1860154 */     GIR_EraseRootFromParent_Done,
     /* 1860155 */   // Label 25150: @1860155
     /* 1860155 */   GIM_Try, /*On fail goto*//*Label 25151*/ GIMT_Encode4(1860241), // Rule ID 13774 //
     /* 1860160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1860171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1860174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1860180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860206 */     // MIs[0] policy
     /* 1860206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1860219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860240 */     // GIR_Coverage, 13774,
     /* 1860240 */     GIR_EraseRootFromParent_Done,
     /* 1860241 */   // Label 25151: @1860241
     /* 1860241 */   GIM_Try, /*On fail goto*//*Label 25152*/ GIMT_Encode4(1860327), // Rule ID 13775 //
     /* 1860246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1860257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1860260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1860266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860292 */     // MIs[0] policy
     /* 1860292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1860305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860326 */     // GIR_Coverage, 13775,
     /* 1860326 */     GIR_EraseRootFromParent_Done,
     /* 1860327 */   // Label 25152: @1860327
     /* 1860327 */   GIM_Try, /*On fail goto*//*Label 25153*/ GIMT_Encode4(1860413), // Rule ID 13778 //
     /* 1860332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1860343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1860346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1860352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860378 */     // MIs[0] policy
     /* 1860378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860388 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1860391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860412 */     // GIR_Coverage, 13778,
     /* 1860412 */     GIR_EraseRootFromParent_Done,
     /* 1860413 */   // Label 25153: @1860413
     /* 1860413 */   GIM_Try, /*On fail goto*//*Label 25154*/ GIMT_Encode4(1860499), // Rule ID 13779 //
     /* 1860418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1860429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1860432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1860438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860464 */     // MIs[0] policy
     /* 1860464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860474 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1860477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860498 */     // GIR_Coverage, 13779,
     /* 1860498 */     GIR_EraseRootFromParent_Done,
     /* 1860499 */   // Label 25154: @1860499
     /* 1860499 */   GIM_Try, /*On fail goto*//*Label 25155*/ GIMT_Encode4(1860585), // Rule ID 13782 //
     /* 1860504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1860515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1860518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1860524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860550 */     // MIs[0] policy
     /* 1860550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860560 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1860563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860584 */     // GIR_Coverage, 13782,
     /* 1860584 */     GIR_EraseRootFromParent_Done,
     /* 1860585 */   // Label 25155: @1860585
     /* 1860585 */   GIM_Try, /*On fail goto*//*Label 25156*/ GIMT_Encode4(1860671), // Rule ID 13783 //
     /* 1860590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1860601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1860604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1860610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860636 */     // MIs[0] policy
     /* 1860636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1860649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860670 */     // GIR_Coverage, 13783,
     /* 1860670 */     GIR_EraseRootFromParent_Done,
     /* 1860671 */   // Label 25156: @1860671
     /* 1860671 */   GIM_Try, /*On fail goto*//*Label 25157*/ GIMT_Encode4(1860757), // Rule ID 13786 //
     /* 1860676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1860687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1860690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1860696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860722 */     // MIs[0] policy
     /* 1860722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860732 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1860735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860756 */     // GIR_Coverage, 13786,
     /* 1860756 */     GIR_EraseRootFromParent_Done,
     /* 1860757 */   // Label 25157: @1860757
     /* 1860757 */   GIM_Try, /*On fail goto*//*Label 25158*/ GIMT_Encode4(1860843), // Rule ID 13787 //
     /* 1860762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1860773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1860776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1860782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860808 */     // MIs[0] policy
     /* 1860808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860818 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1860821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860842 */     // GIR_Coverage, 13787,
     /* 1860842 */     GIR_EraseRootFromParent_Done,
     /* 1860843 */   // Label 25158: @1860843
     /* 1860843 */   GIM_Try, /*On fail goto*//*Label 25159*/ GIMT_Encode4(1860929), // Rule ID 13790 //
     /* 1860848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1860859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1860862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1860868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860894 */     // MIs[0] policy
     /* 1860894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860904 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1860907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860928 */     // GIR_Coverage, 13790,
     /* 1860928 */     GIR_EraseRootFromParent_Done,
     /* 1860929 */   // Label 25159: @1860929
     /* 1860929 */   GIM_Try, /*On fail goto*//*Label 25160*/ GIMT_Encode4(1861015), // Rule ID 13791 //
     /* 1860934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1860945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1860948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1860954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860980 */     // MIs[0] policy
     /* 1860980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860990 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1860993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861014 */     // GIR_Coverage, 13791,
     /* 1861014 */     GIR_EraseRootFromParent_Done,
     /* 1861015 */   // Label 25160: @1861015
     /* 1861015 */   GIM_Try, /*On fail goto*//*Label 25161*/ GIMT_Encode4(1861101), // Rule ID 13794 //
     /* 1861020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1861023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1861031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1861034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1861040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861066 */     // MIs[0] policy
     /* 1861066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861076 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1861079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861100 */     // GIR_Coverage, 13794,
     /* 1861100 */     GIR_EraseRootFromParent_Done,
     /* 1861101 */   // Label 25161: @1861101
     /* 1861101 */   GIM_Try, /*On fail goto*//*Label 25162*/ GIMT_Encode4(1861187), // Rule ID 13795 //
     /* 1861106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1861109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1861117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1861120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1861126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861152 */     // MIs[0] policy
     /* 1861152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861162 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1861165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861186 */     // GIR_Coverage, 13795,
     /* 1861186 */     GIR_EraseRootFromParent_Done,
     /* 1861187 */   // Label 25162: @1861187
     /* 1861187 */   GIM_Try, /*On fail goto*//*Label 25163*/ GIMT_Encode4(1861273), // Rule ID 13798 //
     /* 1861192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1861195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1861203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1861206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1861212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861238 */     // MIs[0] policy
     /* 1861238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861248 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1861251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861272 */     // GIR_Coverage, 13798,
     /* 1861272 */     GIR_EraseRootFromParent_Done,
     /* 1861273 */   // Label 25163: @1861273
     /* 1861273 */   GIM_Try, /*On fail goto*//*Label 25164*/ GIMT_Encode4(1861359), // Rule ID 13799 //
     /* 1861278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1861281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1861289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1861292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1861298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861324 */     // MIs[0] policy
     /* 1861324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861334 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1861337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861358 */     // GIR_Coverage, 13799,
     /* 1861358 */     GIR_EraseRootFromParent_Done,
     /* 1861359 */   // Label 25164: @1861359
     /* 1861359 */   GIM_Try, /*On fail goto*//*Label 25165*/ GIMT_Encode4(1861445), // Rule ID 13802 //
     /* 1861364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1861375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1861378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1861384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861410 */     // MIs[0] policy
     /* 1861410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861420 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11709:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1861423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861444 */     // GIR_Coverage, 13802,
     /* 1861444 */     GIR_EraseRootFromParent_Done,
     /* 1861445 */   // Label 25165: @1861445
     /* 1861445 */   GIM_Try, /*On fail goto*//*Label 25166*/ GIMT_Encode4(1861531), // Rule ID 13803 //
     /* 1861450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1861461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1861464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1861470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861496 */     // MIs[0] policy
     /* 1861496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861506 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11709:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1861509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861530 */     // GIR_Coverage, 13803,
     /* 1861530 */     GIR_EraseRootFromParent_Done,
     /* 1861531 */   // Label 25166: @1861531
     /* 1861531 */   GIM_Try, /*On fail goto*//*Label 25167*/ GIMT_Encode4(1861617), // Rule ID 13806 //
     /* 1861536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1861556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861582 */     // MIs[0] policy
     /* 1861582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861592 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11709:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1861595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861616 */     // GIR_Coverage, 13806,
     /* 1861616 */     GIR_EraseRootFromParent_Done,
     /* 1861617 */   // Label 25167: @1861617
     /* 1861617 */   GIM_Try, /*On fail goto*//*Label 25168*/ GIMT_Encode4(1861703), // Rule ID 13807 //
     /* 1861622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1861642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861668 */     // MIs[0] policy
     /* 1861668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861678 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11709:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1861681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861702 */     // GIR_Coverage, 13807,
     /* 1861702 */     GIR_EraseRootFromParent_Done,
     /* 1861703 */   // Label 25168: @1861703
     /* 1861703 */   GIM_Try, /*On fail goto*//*Label 25169*/ GIMT_Encode4(1861789), // Rule ID 13810 //
     /* 1861708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1861719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1861722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1861728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861754 */     // MIs[0] policy
     /* 1861754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861764 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11709:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1861767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861788 */     // GIR_Coverage, 13810,
     /* 1861788 */     GIR_EraseRootFromParent_Done,
     /* 1861789 */   // Label 25169: @1861789
     /* 1861789 */   GIM_Try, /*On fail goto*//*Label 25170*/ GIMT_Encode4(1861875), // Rule ID 13811 //
     /* 1861794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1861805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1861808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1861814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861840 */     // MIs[0] policy
     /* 1861840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861850 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11709:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1861853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861874 */     // GIR_Coverage, 13811,
     /* 1861874 */     GIR_EraseRootFromParent_Done,
     /* 1861875 */   // Label 25170: @1861875
     /* 1861875 */   GIM_Try, /*On fail goto*//*Label 25171*/ GIMT_Encode4(1861961), // Rule ID 13814 //
     /* 1861880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1861891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1861894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1861900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861926 */     // MIs[0] policy
     /* 1861926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861936 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11709:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1861939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861960 */     // GIR_Coverage, 13814,
     /* 1861960 */     GIR_EraseRootFromParent_Done,
     /* 1861961 */   // Label 25171: @1861961
     /* 1861961 */   GIM_Try, /*On fail goto*//*Label 25172*/ GIMT_Encode4(1862047), // Rule ID 13815 //
     /* 1861966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1861977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1861980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1861986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862012 */     // MIs[0] policy
     /* 1862012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11709:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1862025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862046 */     // GIR_Coverage, 13815,
     /* 1862046 */     GIR_EraseRootFromParent_Done,
     /* 1862047 */   // Label 25172: @1862047
     /* 1862047 */   GIM_Try, /*On fail goto*//*Label 25173*/ GIMT_Encode4(1862133), // Rule ID 13818 //
     /* 1862052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1862063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1862066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1862072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1862075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862098 */     // MIs[0] policy
     /* 1862098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11709:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1862111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862132 */     // GIR_Coverage, 13818,
     /* 1862132 */     GIR_EraseRootFromParent_Done,
     /* 1862133 */   // Label 25173: @1862133
     /* 1862133 */   GIM_Try, /*On fail goto*//*Label 25174*/ GIMT_Encode4(1862219), // Rule ID 13819 //
     /* 1862138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1862149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1862152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1862158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1862161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862184 */     // MIs[0] policy
     /* 1862184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862194 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11709:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1862197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862218 */     // GIR_Coverage, 13819,
     /* 1862218 */     GIR_EraseRootFromParent_Done,
     /* 1862219 */   // Label 25174: @1862219
     /* 1862219 */   GIM_Try, /*On fail goto*//*Label 25175*/ GIMT_Encode4(1862305), // Rule ID 13822 //
     /* 1862224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1862235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1862238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1862244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1862247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1862254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1862258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862270 */     // MIs[0] policy
     /* 1862270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862280 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11709:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1862283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862304 */     // GIR_Coverage, 13822,
     /* 1862304 */     GIR_EraseRootFromParent_Done,
     /* 1862305 */   // Label 25175: @1862305
     /* 1862305 */   GIM_Try, /*On fail goto*//*Label 25176*/ GIMT_Encode4(1862391), // Rule ID 13823 //
     /* 1862310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1862321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1862324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1862330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1862333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1862340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1862344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862356 */     // MIs[0] policy
     /* 1862356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862366 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11709:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1862369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862390 */     // GIR_Coverage, 13823,
     /* 1862390 */     GIR_EraseRootFromParent_Done,
     /* 1862391 */   // Label 25176: @1862391
     /* 1862391 */   GIM_Try, /*On fail goto*//*Label 25177*/ GIMT_Encode4(1862477), // Rule ID 13826 //
     /* 1862396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1862407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1862410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1862416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862442 */     // MIs[0] policy
     /* 1862442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862452 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11709:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1862455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862476 */     // GIR_Coverage, 13826,
     /* 1862476 */     GIR_EraseRootFromParent_Done,
     /* 1862477 */   // Label 25177: @1862477
     /* 1862477 */   GIM_Try, /*On fail goto*//*Label 25178*/ GIMT_Encode4(1862563), // Rule ID 13827 //
     /* 1862482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1862493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1862496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1862502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862528 */     // MIs[0] policy
     /* 1862528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11709:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1862541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862562 */     // GIR_Coverage, 13827,
     /* 1862562 */     GIR_EraseRootFromParent_Done,
     /* 1862563 */   // Label 25178: @1862563
     /* 1862563 */   GIM_Try, /*On fail goto*//*Label 25179*/ GIMT_Encode4(1862649), // Rule ID 13830 //
     /* 1862568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862614 */     // MIs[0] policy
     /* 1862614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11709:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1862627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862648 */     // GIR_Coverage, 13830,
     /* 1862648 */     GIR_EraseRootFromParent_Done,
     /* 1862649 */   // Label 25179: @1862649
     /* 1862649 */   GIM_Try, /*On fail goto*//*Label 25180*/ GIMT_Encode4(1862735), // Rule ID 13831 //
     /* 1862654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862700 */     // MIs[0] policy
     /* 1862700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11709:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1862713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862734 */     // GIR_Coverage, 13831,
     /* 1862734 */     GIR_EraseRootFromParent_Done,
     /* 1862735 */   // Label 25180: @1862735
     /* 1862735 */   GIM_Try, /*On fail goto*//*Label 25181*/ GIMT_Encode4(1862821), // Rule ID 13834 //
     /* 1862740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1862751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1862754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1862760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862786 */     // MIs[0] policy
     /* 1862786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11709:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1862799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862820 */     // GIR_Coverage, 13834,
     /* 1862820 */     GIR_EraseRootFromParent_Done,
     /* 1862821 */   // Label 25181: @1862821
     /* 1862821 */   GIM_Try, /*On fail goto*//*Label 25182*/ GIMT_Encode4(1862907), // Rule ID 13835 //
     /* 1862826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1862837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1862840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1862846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862872 */     // MIs[0] policy
     /* 1862872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862882 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11709:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1862885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862906 */     // GIR_Coverage, 13835,
     /* 1862906 */     GIR_EraseRootFromParent_Done,
     /* 1862907 */   // Label 25182: @1862907
     /* 1862907 */   GIM_Try, /*On fail goto*//*Label 25183*/ GIMT_Encode4(1862993), // Rule ID 13838 //
     /* 1862912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1862923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1862926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1862932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862958 */     // MIs[0] policy
     /* 1862958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11709:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1862971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862992 */     // GIR_Coverage, 13838,
     /* 1862992 */     GIR_EraseRootFromParent_Done,
     /* 1862993 */   // Label 25183: @1862993
     /* 1862993 */   GIM_Try, /*On fail goto*//*Label 25184*/ GIMT_Encode4(1863079), // Rule ID 13839 //
     /* 1862998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1863009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1863012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1863018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863044 */     // MIs[0] policy
     /* 1863044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863054 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11709:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1863057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863078 */     // GIR_Coverage, 13839,
     /* 1863078 */     GIR_EraseRootFromParent_Done,
     /* 1863079 */   // Label 25184: @1863079
     /* 1863079 */   GIM_Try, /*On fail goto*//*Label 25185*/ GIMT_Encode4(1863165), // Rule ID 13842 //
     /* 1863084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1863095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1863098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1863104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863130 */     // MIs[0] policy
     /* 1863130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11709:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1863143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863164 */     // GIR_Coverage, 13842,
     /* 1863164 */     GIR_EraseRootFromParent_Done,
     /* 1863165 */   // Label 25185: @1863165
     /* 1863165 */   GIM_Try, /*On fail goto*//*Label 25186*/ GIMT_Encode4(1863251), // Rule ID 13843 //
     /* 1863170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1863181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1863184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1863190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863216 */     // MIs[0] policy
     /* 1863216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863226 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11709:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1863229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863250 */     // GIR_Coverage, 13843,
     /* 1863250 */     GIR_EraseRootFromParent_Done,
     /* 1863251 */   // Label 25186: @1863251
     /* 1863251 */   GIM_Try, /*On fail goto*//*Label 25187*/ GIMT_Encode4(1863337), // Rule ID 13846 //
     /* 1863256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1863259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1863267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1863270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1863276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1863279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863302 */     // MIs[0] policy
     /* 1863302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863312 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11709:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1863315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863336 */     // GIR_Coverage, 13846,
     /* 1863336 */     GIR_EraseRootFromParent_Done,
     /* 1863337 */   // Label 25187: @1863337
     /* 1863337 */   GIM_Try, /*On fail goto*//*Label 25188*/ GIMT_Encode4(1863423), // Rule ID 13847 //
     /* 1863342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1863353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1863356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1863362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1863365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863388 */     // MIs[0] policy
     /* 1863388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863398 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11709:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1863401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863422 */     // GIR_Coverage, 13847,
     /* 1863422 */     GIR_EraseRootFromParent_Done,
     /* 1863423 */   // Label 25188: @1863423
     /* 1863423 */   GIM_Try, /*On fail goto*//*Label 25189*/ GIMT_Encode4(1863509), // Rule ID 13850 //
     /* 1863428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1863431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1863439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1863442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1863448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1863451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863474 */     // MIs[0] policy
     /* 1863474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11709:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1863487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863508 */     // GIR_Coverage, 13850,
     /* 1863508 */     GIR_EraseRootFromParent_Done,
     /* 1863509 */   // Label 25189: @1863509
     /* 1863509 */   GIM_Try, /*On fail goto*//*Label 25190*/ GIMT_Encode4(1863595), // Rule ID 13851 //
     /* 1863514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1863525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1863528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1863534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1863537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863560 */     // MIs[0] policy
     /* 1863560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863570 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11709:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1863573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863594 */     // GIR_Coverage, 13851,
     /* 1863594 */     GIR_EraseRootFromParent_Done,
     /* 1863595 */   // Label 25190: @1863595
     /* 1863595 */   GIM_Try, /*On fail goto*//*Label 25191*/ GIMT_Encode4(1863681), // Rule ID 13854 //
     /* 1863600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1863603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1863611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1863614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1863620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863646 */     // MIs[0] policy
     /* 1863646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863656 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11709:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1863659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863680 */     // GIR_Coverage, 13854,
     /* 1863680 */     GIR_EraseRootFromParent_Done,
     /* 1863681 */   // Label 25191: @1863681
     /* 1863681 */   GIM_Try, /*On fail goto*//*Label 25192*/ GIMT_Encode4(1863767), // Rule ID 13855 //
     /* 1863686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1863697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1863700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1863706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863732 */     // MIs[0] policy
     /* 1863732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863742 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11709:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1863745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863766 */     // GIR_Coverage, 13855,
     /* 1863766 */     GIR_EraseRootFromParent_Done,
     /* 1863767 */   // Label 25192: @1863767
     /* 1863767 */   GIM_Try, /*On fail goto*//*Label 25193*/ GIMT_Encode4(1863853), // Rule ID 13858 //
     /* 1863772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1863775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1863783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1863786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1863792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863818 */     // MIs[0] policy
     /* 1863818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863828 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11709:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1863831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863852 */     // GIR_Coverage, 13858,
     /* 1863852 */     GIR_EraseRootFromParent_Done,
     /* 1863853 */   // Label 25193: @1863853
     /* 1863853 */   GIM_Try, /*On fail goto*//*Label 25194*/ GIMT_Encode4(1863939), // Rule ID 13859 //
     /* 1863858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1863869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1863872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1863878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863904 */     // MIs[0] policy
     /* 1863904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863914 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11709:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1863917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863938 */     // GIR_Coverage, 13859,
     /* 1863938 */     GIR_EraseRootFromParent_Done,
     /* 1863939 */   // Label 25194: @1863939
     /* 1863939 */   GIM_Try, /*On fail goto*//*Label 25195*/ GIMT_Encode4(1864028), // Rule ID 14068 //
     /* 1863944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1863955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1863958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1863961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1863964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1863967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863990 */     // MIs[0] policy
     /* 1863990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864000 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1864003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864027 */     // GIR_Coverage, 14068,
     /* 1864027 */     GIR_EraseRootFromParent_Done,
     /* 1864028 */   // Label 25195: @1864028
     /* 1864028 */   GIM_Try, /*On fail goto*//*Label 25196*/ GIMT_Encode4(1864117), // Rule ID 14069 //
     /* 1864033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1864044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1864047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1864050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1864053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864079 */     // MIs[0] policy
     /* 1864079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864089 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1864092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864116 */     // GIR_Coverage, 14069,
     /* 1864116 */     GIR_EraseRootFromParent_Done,
     /* 1864117 */   // Label 25196: @1864117
     /* 1864117 */   GIM_Try, /*On fail goto*//*Label 25197*/ GIMT_Encode4(1864206), // Rule ID 14072 //
     /* 1864122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1864133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1864136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1864139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1864142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864168 */     // MIs[0] policy
     /* 1864168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864178 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1864181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864205 */     // GIR_Coverage, 14072,
     /* 1864205 */     GIR_EraseRootFromParent_Done,
     /* 1864206 */   // Label 25197: @1864206
     /* 1864206 */   GIM_Try, /*On fail goto*//*Label 25198*/ GIMT_Encode4(1864295), // Rule ID 14073 //
     /* 1864211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1864222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1864225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1864228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1864231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864257 */     // MIs[0] policy
     /* 1864257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864267 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1864270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864294 */     // GIR_Coverage, 14073,
     /* 1864294 */     GIR_EraseRootFromParent_Done,
     /* 1864295 */   // Label 25198: @1864295
     /* 1864295 */   GIM_Try, /*On fail goto*//*Label 25199*/ GIMT_Encode4(1864384), // Rule ID 14076 //
     /* 1864300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1864311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1864314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1864317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1864320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864346 */     // MIs[0] policy
     /* 1864346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864356 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864383 */     // GIR_Coverage, 14076,
     /* 1864383 */     GIR_EraseRootFromParent_Done,
     /* 1864384 */   // Label 25199: @1864384
     /* 1864384 */   GIM_Try, /*On fail goto*//*Label 25200*/ GIMT_Encode4(1864473), // Rule ID 14077 //
     /* 1864389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1864400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1864403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1864406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1864409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864435 */     // MIs[0] policy
     /* 1864435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864445 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864472 */     // GIR_Coverage, 14077,
     /* 1864472 */     GIR_EraseRootFromParent_Done,
     /* 1864473 */   // Label 25200: @1864473
     /* 1864473 */   GIM_Try, /*On fail goto*//*Label 25201*/ GIMT_Encode4(1864562), // Rule ID 14080 //
     /* 1864478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1864489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1864492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1864495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1864498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864524 */     // MIs[0] policy
     /* 1864524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1864537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864561 */     // GIR_Coverage, 14080,
     /* 1864561 */     GIR_EraseRootFromParent_Done,
     /* 1864562 */   // Label 25201: @1864562
     /* 1864562 */   GIM_Try, /*On fail goto*//*Label 25202*/ GIMT_Encode4(1864651), // Rule ID 14081 //
     /* 1864567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1864578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1864581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1864584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1864587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864613 */     // MIs[0] policy
     /* 1864613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864623 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1864626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864650 */     // GIR_Coverage, 14081,
     /* 1864650 */     GIR_EraseRootFromParent_Done,
     /* 1864651 */   // Label 25202: @1864651
     /* 1864651 */   GIM_Try, /*On fail goto*//*Label 25203*/ GIMT_Encode4(1864740), // Rule ID 14084 //
     /* 1864656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1864667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1864670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1864673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1864676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864702 */     // MIs[0] policy
     /* 1864702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864712 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864739 */     // GIR_Coverage, 14084,
     /* 1864739 */     GIR_EraseRootFromParent_Done,
     /* 1864740 */   // Label 25203: @1864740
     /* 1864740 */   GIM_Try, /*On fail goto*//*Label 25204*/ GIMT_Encode4(1864829), // Rule ID 14085 //
     /* 1864745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1864756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1864759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1864762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1864765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864791 */     // MIs[0] policy
     /* 1864791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864801 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864828 */     // GIR_Coverage, 14085,
     /* 1864828 */     GIR_EraseRootFromParent_Done,
     /* 1864829 */   // Label 25204: @1864829
     /* 1864829 */   GIM_Try, /*On fail goto*//*Label 25205*/ GIMT_Encode4(1864918), // Rule ID 14088 //
     /* 1864834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1864845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1864848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1864851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1864854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864880 */     // MIs[0] policy
     /* 1864880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864890 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864917 */     // GIR_Coverage, 14088,
     /* 1864917 */     GIR_EraseRootFromParent_Done,
     /* 1864918 */   // Label 25205: @1864918
     /* 1864918 */   GIM_Try, /*On fail goto*//*Label 25206*/ GIMT_Encode4(1865007), // Rule ID 14089 //
     /* 1864923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1864934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1864937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1864940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1864943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864969 */     // MIs[0] policy
     /* 1864969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864979 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1865000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865006 */     // GIR_Coverage, 14089,
     /* 1865006 */     GIR_EraseRootFromParent_Done,
     /* 1865007 */   // Label 25206: @1865007
     /* 1865007 */   GIM_Try, /*On fail goto*//*Label 25207*/ GIMT_Encode4(1865096), // Rule ID 14092 //
     /* 1865012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1865023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1865026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1865029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1865032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865058 */     // MIs[0] policy
     /* 1865058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865068 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865095 */     // GIR_Coverage, 14092,
     /* 1865095 */     GIR_EraseRootFromParent_Done,
     /* 1865096 */   // Label 25207: @1865096
     /* 1865096 */   GIM_Try, /*On fail goto*//*Label 25208*/ GIMT_Encode4(1865185), // Rule ID 14093 //
     /* 1865101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1865112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1865115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1865118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1865121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865147 */     // MIs[0] policy
     /* 1865147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865157 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865184 */     // GIR_Coverage, 14093,
     /* 1865184 */     GIR_EraseRootFromParent_Done,
     /* 1865185 */   // Label 25208: @1865185
     /* 1865185 */   GIM_Try, /*On fail goto*//*Label 25209*/ GIMT_Encode4(1865274), // Rule ID 14096 //
     /* 1865190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1865201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1865204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1865207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1865210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865236 */     // MIs[0] policy
     /* 1865236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865273 */     // GIR_Coverage, 14096,
     /* 1865273 */     GIR_EraseRootFromParent_Done,
     /* 1865274 */   // Label 25209: @1865274
     /* 1865274 */   GIM_Try, /*On fail goto*//*Label 25210*/ GIMT_Encode4(1865363), // Rule ID 14097 //
     /* 1865279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1865290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1865293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1865296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1865299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865325 */     // MIs[0] policy
     /* 1865325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865335 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865362 */     // GIR_Coverage, 14097,
     /* 1865362 */     GIR_EraseRootFromParent_Done,
     /* 1865363 */   // Label 25210: @1865363
     /* 1865363 */   GIM_Try, /*On fail goto*//*Label 25211*/ GIMT_Encode4(1865452), // Rule ID 14100 //
     /* 1865368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1865379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1865382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1865385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1865388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865414 */     // MIs[0] policy
     /* 1865414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865424 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1865445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865451 */     // GIR_Coverage, 14100,
     /* 1865451 */     GIR_EraseRootFromParent_Done,
     /* 1865452 */   // Label 25211: @1865452
     /* 1865452 */   GIM_Try, /*On fail goto*//*Label 25212*/ GIMT_Encode4(1865541), // Rule ID 14101 //
     /* 1865457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1865468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1865471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1865474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1865477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865503 */     // MIs[0] policy
     /* 1865503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865513 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1865534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865540 */     // GIR_Coverage, 14101,
     /* 1865540 */     GIR_EraseRootFromParent_Done,
     /* 1865541 */   // Label 25212: @1865541
     /* 1865541 */   GIM_Try, /*On fail goto*//*Label 25213*/ GIMT_Encode4(1865630), // Rule ID 14104 //
     /* 1865546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1865549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1865557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1865560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1865563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1865566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865592 */     // MIs[0] policy
     /* 1865592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865602 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1865623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865629 */     // GIR_Coverage, 14104,
     /* 1865629 */     GIR_EraseRootFromParent_Done,
     /* 1865630 */   // Label 25213: @1865630
     /* 1865630 */   GIM_Try, /*On fail goto*//*Label 25214*/ GIMT_Encode4(1865719), // Rule ID 14105 //
     /* 1865635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1865638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1865646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1865649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1865652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1865655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865681 */     // MIs[0] policy
     /* 1865681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865691 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1865712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865718 */     // GIR_Coverage, 14105,
     /* 1865718 */     GIR_EraseRootFromParent_Done,
     /* 1865719 */   // Label 25214: @1865719
     /* 1865719 */   GIM_Try, /*On fail goto*//*Label 25215*/ GIMT_Encode4(1865808), // Rule ID 14108 //
     /* 1865724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1865735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1865738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1865741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1865744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865770 */     // MIs[0] policy
     /* 1865770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865780 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1865783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865807 */     // GIR_Coverage, 14108,
     /* 1865807 */     GIR_EraseRootFromParent_Done,
     /* 1865808 */   // Label 25215: @1865808
     /* 1865808 */   GIM_Try, /*On fail goto*//*Label 25216*/ GIMT_Encode4(1865897), // Rule ID 14109 //
     /* 1865813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1865824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1865827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1865830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1865833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865859 */     // MIs[0] policy
     /* 1865859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865869 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1865872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865896 */     // GIR_Coverage, 14109,
     /* 1865896 */     GIR_EraseRootFromParent_Done,
     /* 1865897 */   // Label 25216: @1865897
     /* 1865897 */   GIM_Try, /*On fail goto*//*Label 25217*/ GIMT_Encode4(1865986), // Rule ID 14112 //
     /* 1865902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1865913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1865916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1865919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1865922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1865925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1865932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865948 */     // MIs[0] policy
     /* 1865948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865958 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1865961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865985 */     // GIR_Coverage, 14112,
     /* 1865985 */     GIR_EraseRootFromParent_Done,
     /* 1865986 */   // Label 25217: @1865986
     /* 1865986 */   GIM_Try, /*On fail goto*//*Label 25218*/ GIMT_Encode4(1866075), // Rule ID 14113 //
     /* 1865991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1866002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1866005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1866008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1866011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1866014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866037 */     // MIs[0] policy
     /* 1866037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866047 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866074 */     // GIR_Coverage, 14113,
     /* 1866074 */     GIR_EraseRootFromParent_Done,
     /* 1866075 */   // Label 25218: @1866075
     /* 1866075 */   GIM_Try, /*On fail goto*//*Label 25219*/ GIMT_Encode4(1866164), // Rule ID 14116 //
     /* 1866080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1866091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1866094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1866097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1866100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1866103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866126 */     // MIs[0] policy
     /* 1866126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866136 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866163 */     // GIR_Coverage, 14116,
     /* 1866163 */     GIR_EraseRootFromParent_Done,
     /* 1866164 */   // Label 25219: @1866164
     /* 1866164 */   GIM_Try, /*On fail goto*//*Label 25220*/ GIMT_Encode4(1866253), // Rule ID 14117 //
     /* 1866169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1866180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1866183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1866186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1866189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1866192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866215 */     // MIs[0] policy
     /* 1866215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866225 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866252 */     // GIR_Coverage, 14117,
     /* 1866252 */     GIR_EraseRootFromParent_Done,
     /* 1866253 */   // Label 25220: @1866253
     /* 1866253 */   GIM_Try, /*On fail goto*//*Label 25221*/ GIMT_Encode4(1866342), // Rule ID 14120 //
     /* 1866258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1866269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1866272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1866275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1866278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866304 */     // MIs[0] policy
     /* 1866304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866341 */     // GIR_Coverage, 14120,
     /* 1866341 */     GIR_EraseRootFromParent_Done,
     /* 1866342 */   // Label 25221: @1866342
     /* 1866342 */   GIM_Try, /*On fail goto*//*Label 25222*/ GIMT_Encode4(1866431), // Rule ID 14121 //
     /* 1866347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1866358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1866361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1866364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1866367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866393 */     // MIs[0] policy
     /* 1866393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866403 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866430 */     // GIR_Coverage, 14121,
     /* 1866430 */     GIR_EraseRootFromParent_Done,
     /* 1866431 */   // Label 25222: @1866431
     /* 1866431 */   GIM_Try, /*On fail goto*//*Label 25223*/ GIMT_Encode4(1866520), // Rule ID 14124 //
     /* 1866436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1866447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1866450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1866453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1866456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866482 */     // MIs[0] policy
     /* 1866482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866492 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866519 */     // GIR_Coverage, 14124,
     /* 1866519 */     GIR_EraseRootFromParent_Done,
     /* 1866520 */   // Label 25223: @1866520
     /* 1866520 */   GIM_Try, /*On fail goto*//*Label 25224*/ GIMT_Encode4(1866609), // Rule ID 14125 //
     /* 1866525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1866536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1866539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1866542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1866545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866571 */     // MIs[0] policy
     /* 1866571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866581 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866608 */     // GIR_Coverage, 14125,
     /* 1866608 */     GIR_EraseRootFromParent_Done,
     /* 1866609 */   // Label 25224: @1866609
     /* 1866609 */   GIM_Try, /*On fail goto*//*Label 25225*/ GIMT_Encode4(1866698), // Rule ID 14128 //
     /* 1866614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1866625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1866628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1866631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1866634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1866637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866660 */     // MIs[0] policy
     /* 1866660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866670 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866697 */     // GIR_Coverage, 14128,
     /* 1866697 */     GIR_EraseRootFromParent_Done,
     /* 1866698 */   // Label 25225: @1866698
     /* 1866698 */   GIM_Try, /*On fail goto*//*Label 25226*/ GIMT_Encode4(1866787), // Rule ID 14129 //
     /* 1866703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1866714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1866717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1866720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1866723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1866726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866749 */     // MIs[0] policy
     /* 1866749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866759 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866782 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866786 */     // GIR_Coverage, 14129,
     /* 1866786 */     GIR_EraseRootFromParent_Done,
     /* 1866787 */   // Label 25226: @1866787
     /* 1866787 */   GIM_Try, /*On fail goto*//*Label 25227*/ GIMT_Encode4(1866876), // Rule ID 14132 //
     /* 1866792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1866803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1866806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1866809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1866812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866838 */     // MIs[0] policy
     /* 1866838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866875 */     // GIR_Coverage, 14132,
     /* 1866875 */     GIR_EraseRootFromParent_Done,
     /* 1866876 */   // Label 25227: @1866876
     /* 1866876 */   GIM_Try, /*On fail goto*//*Label 25228*/ GIMT_Encode4(1866965), // Rule ID 14133 //
     /* 1866881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1866892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1866895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1866898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1866901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866927 */     // MIs[0] policy
     /* 1866927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866937 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866964 */     // GIR_Coverage, 14133,
     /* 1866964 */     GIR_EraseRootFromParent_Done,
     /* 1866965 */   // Label 25228: @1866965
     /* 1866965 */   GIM_Try, /*On fail goto*//*Label 25229*/ GIMT_Encode4(1867054), // Rule ID 14136 //
     /* 1866970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1866981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1866984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1866987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1866990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867016 */     // MIs[0] policy
     /* 1867016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1867029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867053 */     // GIR_Coverage, 14136,
     /* 1867053 */     GIR_EraseRootFromParent_Done,
     /* 1867054 */   // Label 25229: @1867054
     /* 1867054 */   GIM_Try, /*On fail goto*//*Label 25230*/ GIMT_Encode4(1867143), // Rule ID 14137 //
     /* 1867059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1867070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1867073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1867076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1867079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867105 */     // MIs[0] policy
     /* 1867105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867115 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1867118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867142 */     // GIR_Coverage, 14137,
     /* 1867142 */     GIR_EraseRootFromParent_Done,
     /* 1867143 */   // Label 25230: @1867143
     /* 1867143 */   GIM_Try, /*On fail goto*//*Label 25231*/ GIMT_Encode4(1867232), // Rule ID 14140 //
     /* 1867148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1867159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1867162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1867165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1867168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1867171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867194 */     // MIs[0] policy
     /* 1867194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867204 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1867207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867231 */     // GIR_Coverage, 14140,
     /* 1867231 */     GIR_EraseRootFromParent_Done,
     /* 1867232 */   // Label 25231: @1867232
     /* 1867232 */   GIM_Try, /*On fail goto*//*Label 25232*/ GIMT_Encode4(1867321), // Rule ID 14141 //
     /* 1867237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1867248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1867251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1867254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1867257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1867260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867283 */     // MIs[0] policy
     /* 1867283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867293 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1867296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867320 */     // GIR_Coverage, 14141,
     /* 1867320 */     GIR_EraseRootFromParent_Done,
     /* 1867321 */   // Label 25232: @1867321
     /* 1867321 */   GIM_Try, /*On fail goto*//*Label 25233*/ GIMT_Encode4(1867410), // Rule ID 14144 //
     /* 1867326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1867329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1867337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1867340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1867343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1867346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1867349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867372 */     // MIs[0] policy
     /* 1867372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1867385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867409 */     // GIR_Coverage, 14144,
     /* 1867409 */     GIR_EraseRootFromParent_Done,
     /* 1867410 */   // Label 25233: @1867410
     /* 1867410 */   GIM_Try, /*On fail goto*//*Label 25234*/ GIMT_Encode4(1867499), // Rule ID 14145 //
     /* 1867415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1867418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1867426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1867429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1867432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1867435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1867438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867461 */     // MIs[0] policy
     /* 1867461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867471 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1867474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867498 */     // GIR_Coverage, 14145,
     /* 1867498 */     GIR_EraseRootFromParent_Done,
     /* 1867499 */   // Label 25234: @1867499
     /* 1867499 */   GIM_Try, /*On fail goto*//*Label 25235*/ GIMT_Encode4(1867588), // Rule ID 14148 //
     /* 1867504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1867507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1867515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1867518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1867521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1867524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867550 */     // MIs[0] policy
     /* 1867550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867560 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1867563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867587 */     // GIR_Coverage, 14148,
     /* 1867587 */     GIR_EraseRootFromParent_Done,
     /* 1867588 */   // Label 25235: @1867588
     /* 1867588 */   GIM_Try, /*On fail goto*//*Label 25236*/ GIMT_Encode4(1867677), // Rule ID 14149 //
     /* 1867593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1867596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1867604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1867607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1867610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1867613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867639 */     // MIs[0] policy
     /* 1867639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867649 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1867652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867676 */     // GIR_Coverage, 14149,
     /* 1867676 */     GIR_EraseRootFromParent_Done,
     /* 1867677 */   // Label 25236: @1867677
     /* 1867677 */   GIM_Try, /*On fail goto*//*Label 25237*/ GIMT_Encode4(1867766), // Rule ID 14152 //
     /* 1867682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1867685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1867693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1867696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1867699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1867702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867728 */     // MIs[0] policy
     /* 1867728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867738 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1867741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867765 */     // GIR_Coverage, 14152,
     /* 1867765 */     GIR_EraseRootFromParent_Done,
     /* 1867766 */   // Label 25237: @1867766
     /* 1867766 */   GIM_Try, /*On fail goto*//*Label 25238*/ GIMT_Encode4(1867855), // Rule ID 14153 //
     /* 1867771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1867774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1867782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1867785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1867788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1867791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867817 */     // MIs[0] policy
     /* 1867817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867827 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1867830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867854 */     // GIR_Coverage, 14153,
     /* 1867854 */     GIR_EraseRootFromParent_Done,
     /* 1867855 */   // Label 25238: @1867855
     /* 1867855 */   GIM_Try, /*On fail goto*//*Label 25239*/ GIMT_Encode4(1867944), // Rule ID 14156 //
     /* 1867860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1867871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1867874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1867877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867906 */     // MIs[0] policy
     /* 1867906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867916 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1867919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867943 */     // GIR_Coverage, 14156,
     /* 1867943 */     GIR_EraseRootFromParent_Done,
     /* 1867944 */   // Label 25239: @1867944
     /* 1867944 */   GIM_Try, /*On fail goto*//*Label 25240*/ GIMT_Encode4(1868033), // Rule ID 14157 //
     /* 1867949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1867960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1867963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1867966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867995 */     // MIs[0] policy
     /* 1867995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868005 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1868008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868032 */     // GIR_Coverage, 14157,
     /* 1868032 */     GIR_EraseRootFromParent_Done,
     /* 1868033 */   // Label 25240: @1868033
     /* 1868033 */   GIM_Try, /*On fail goto*//*Label 25241*/ GIMT_Encode4(1868122), // Rule ID 14160 //
     /* 1868038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1868049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1868052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1868055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868084 */     // MIs[0] policy
     /* 1868084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868094 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1868097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868121 */     // GIR_Coverage, 14160,
     /* 1868121 */     GIR_EraseRootFromParent_Done,
     /* 1868122 */   // Label 25241: @1868122
     /* 1868122 */   GIM_Try, /*On fail goto*//*Label 25242*/ GIMT_Encode4(1868211), // Rule ID 14161 //
     /* 1868127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1868138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1868141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1868144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868173 */     // MIs[0] policy
     /* 1868173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868183 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1868186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868210 */     // GIR_Coverage, 14161,
     /* 1868210 */     GIR_EraseRootFromParent_Done,
     /* 1868211 */   // Label 25242: @1868211
     /* 1868211 */   GIM_Try, /*On fail goto*//*Label 25243*/ GIMT_Encode4(1868300), // Rule ID 14164 //
     /* 1868216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1868227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1868230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1868233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868262 */     // MIs[0] policy
     /* 1868262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868272 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868299 */     // GIR_Coverage, 14164,
     /* 1868299 */     GIR_EraseRootFromParent_Done,
     /* 1868300 */   // Label 25243: @1868300
     /* 1868300 */   GIM_Try, /*On fail goto*//*Label 25244*/ GIMT_Encode4(1868389), // Rule ID 14165 //
     /* 1868305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1868316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1868319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1868322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868351 */     // MIs[0] policy
     /* 1868351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868361 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868388 */     // GIR_Coverage, 14165,
     /* 1868388 */     GIR_EraseRootFromParent_Done,
     /* 1868389 */   // Label 25244: @1868389
     /* 1868389 */   GIM_Try, /*On fail goto*//*Label 25245*/ GIMT_Encode4(1868478), // Rule ID 14168 //
     /* 1868394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1868405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1868408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1868411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868440 */     // MIs[0] policy
     /* 1868440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868450 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1868453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868477 */     // GIR_Coverage, 14168,
     /* 1868477 */     GIR_EraseRootFromParent_Done,
     /* 1868478 */   // Label 25245: @1868478
     /* 1868478 */   GIM_Try, /*On fail goto*//*Label 25246*/ GIMT_Encode4(1868567), // Rule ID 14169 //
     /* 1868483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1868494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1868497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1868500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868529 */     // MIs[0] policy
     /* 1868529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868539 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1868542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868566 */     // GIR_Coverage, 14169,
     /* 1868566 */     GIR_EraseRootFromParent_Done,
     /* 1868567 */   // Label 25246: @1868567
     /* 1868567 */   GIM_Try, /*On fail goto*//*Label 25247*/ GIMT_Encode4(1868656), // Rule ID 14172 //
     /* 1868572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1868583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1868586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1868589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868618 */     // MIs[0] policy
     /* 1868618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868628 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868655 */     // GIR_Coverage, 14172,
     /* 1868655 */     GIR_EraseRootFromParent_Done,
     /* 1868656 */   // Label 25247: @1868656
     /* 1868656 */   GIM_Try, /*On fail goto*//*Label 25248*/ GIMT_Encode4(1868745), // Rule ID 14173 //
     /* 1868661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1868672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1868675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1868678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868707 */     // MIs[0] policy
     /* 1868707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868717 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868744 */     // GIR_Coverage, 14173,
     /* 1868744 */     GIR_EraseRootFromParent_Done,
     /* 1868745 */   // Label 25248: @1868745
     /* 1868745 */   GIM_Try, /*On fail goto*//*Label 25249*/ GIMT_Encode4(1868834), // Rule ID 14176 //
     /* 1868750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1868761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1868764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1868767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868796 */     // MIs[0] policy
     /* 1868796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868806 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868833 */     // GIR_Coverage, 14176,
     /* 1868833 */     GIR_EraseRootFromParent_Done,
     /* 1868834 */   // Label 25249: @1868834
     /* 1868834 */   GIM_Try, /*On fail goto*//*Label 25250*/ GIMT_Encode4(1868923), // Rule ID 14177 //
     /* 1868839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1868850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1868853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1868856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868885 */     // MIs[0] policy
     /* 1868885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868895 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868922 */     // GIR_Coverage, 14177,
     /* 1868922 */     GIR_EraseRootFromParent_Done,
     /* 1868923 */   // Label 25250: @1868923
     /* 1868923 */   GIM_Try, /*On fail goto*//*Label 25251*/ GIMT_Encode4(1869012), // Rule ID 14180 //
     /* 1868928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1868939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1868942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1868945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868974 */     // MIs[0] policy
     /* 1868974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868984 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869007 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869011 */     // GIR_Coverage, 14180,
     /* 1869011 */     GIR_EraseRootFromParent_Done,
     /* 1869012 */   // Label 25251: @1869012
     /* 1869012 */   GIM_Try, /*On fail goto*//*Label 25252*/ GIMT_Encode4(1869101), // Rule ID 14181 //
     /* 1869017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1869028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1869031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1869034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869063 */     // MIs[0] policy
     /* 1869063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869073 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869100 */     // GIR_Coverage, 14181,
     /* 1869100 */     GIR_EraseRootFromParent_Done,
     /* 1869101 */   // Label 25252: @1869101
     /* 1869101 */   GIM_Try, /*On fail goto*//*Label 25253*/ GIMT_Encode4(1869190), // Rule ID 14184 //
     /* 1869106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1869117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1869120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1869123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1869129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869152 */     // MIs[0] policy
     /* 1869152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869162 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869189 */     // GIR_Coverage, 14184,
     /* 1869189 */     GIR_EraseRootFromParent_Done,
     /* 1869190 */   // Label 25253: @1869190
     /* 1869190 */   GIM_Try, /*On fail goto*//*Label 25254*/ GIMT_Encode4(1869279), // Rule ID 14185 //
     /* 1869195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1869206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1869209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1869212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1869218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869241 */     // MIs[0] policy
     /* 1869241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869251 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869278 */     // GIR_Coverage, 14185,
     /* 1869278 */     GIR_EraseRootFromParent_Done,
     /* 1869279 */   // Label 25254: @1869279
     /* 1869279 */   GIM_Try, /*On fail goto*//*Label 25255*/ GIMT_Encode4(1869368), // Rule ID 14188 //
     /* 1869284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1869295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1869298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1869301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869330 */     // MIs[0] policy
     /* 1869330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869367 */     // GIR_Coverage, 14188,
     /* 1869367 */     GIR_EraseRootFromParent_Done,
     /* 1869368 */   // Label 25255: @1869368
     /* 1869368 */   GIM_Try, /*On fail goto*//*Label 25256*/ GIMT_Encode4(1869457), // Rule ID 14189 //
     /* 1869373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1869384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1869387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1869390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869419 */     // MIs[0] policy
     /* 1869419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869429 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869456 */     // GIR_Coverage, 14189,
     /* 1869456 */     GIR_EraseRootFromParent_Done,
     /* 1869457 */   // Label 25256: @1869457
     /* 1869457 */   GIM_Try, /*On fail goto*//*Label 25257*/ GIMT_Encode4(1869546), // Rule ID 14192 //
     /* 1869462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1869465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1869473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1869476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1869479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869508 */     // MIs[0] policy
     /* 1869508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869545 */     // GIR_Coverage, 14192,
     /* 1869545 */     GIR_EraseRootFromParent_Done,
     /* 1869546 */   // Label 25257: @1869546
     /* 1869546 */   GIM_Try, /*On fail goto*//*Label 25258*/ GIMT_Encode4(1869635), // Rule ID 14193 //
     /* 1869551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1869554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1869562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1869565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1869568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869597 */     // MIs[0] policy
     /* 1869597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869607 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869634 */     // GIR_Coverage, 14193,
     /* 1869634 */     GIR_EraseRootFromParent_Done,
     /* 1869635 */   // Label 25258: @1869635
     /* 1869635 */   GIM_Try, /*On fail goto*//*Label 25259*/ GIMT_Encode4(1869724), // Rule ID 14196 //
     /* 1869640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1869651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1869654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1869657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869686 */     // MIs[0] policy
     /* 1869686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1869699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869719 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869723 */     // GIR_Coverage, 14196,
     /* 1869723 */     GIR_EraseRootFromParent_Done,
     /* 1869724 */   // Label 25259: @1869724
     /* 1869724 */   GIM_Try, /*On fail goto*//*Label 25260*/ GIMT_Encode4(1869813), // Rule ID 14197 //
     /* 1869729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1869740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1869743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1869746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869775 */     // MIs[0] policy
     /* 1869775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869785 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1869788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869812 */     // GIR_Coverage, 14197,
     /* 1869812 */     GIR_EraseRootFromParent_Done,
     /* 1869813 */   // Label 25260: @1869813
     /* 1869813 */   GIM_Try, /*On fail goto*//*Label 25261*/ GIMT_Encode4(1869902), // Rule ID 14200 //
     /* 1869818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1869829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1869832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1869835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1869841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869864 */     // MIs[0] policy
     /* 1869864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869874 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1869877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869901 */     // GIR_Coverage, 14200,
     /* 1869901 */     GIR_EraseRootFromParent_Done,
     /* 1869902 */   // Label 25261: @1869902
     /* 1869902 */   GIM_Try, /*On fail goto*//*Label 25262*/ GIMT_Encode4(1869991), // Rule ID 14201 //
     /* 1869907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1869918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1869921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1869924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1869930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869953 */     // MIs[0] policy
     /* 1869953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869963 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1869966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869986 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869990 */     // GIR_Coverage, 14201,
     /* 1869990 */     GIR_EraseRootFromParent_Done,
     /* 1869991 */   // Label 25262: @1869991
     /* 1869991 */   GIM_Try, /*On fail goto*//*Label 25263*/ GIMT_Encode4(1870080), // Rule ID 14204 //
     /* 1869996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1870007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1870010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1870013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1870019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870042 */     // MIs[0] policy
     /* 1870042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870052 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870079 */     // GIR_Coverage, 14204,
     /* 1870079 */     GIR_EraseRootFromParent_Done,
     /* 1870080 */   // Label 25263: @1870080
     /* 1870080 */   GIM_Try, /*On fail goto*//*Label 25264*/ GIMT_Encode4(1870169), // Rule ID 14205 //
     /* 1870085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1870096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1870099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1870102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1870108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870131 */     // MIs[0] policy
     /* 1870131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870141 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870168 */     // GIR_Coverage, 14205,
     /* 1870168 */     GIR_EraseRootFromParent_Done,
     /* 1870169 */   // Label 25264: @1870169
     /* 1870169 */   GIM_Try, /*On fail goto*//*Label 25265*/ GIMT_Encode4(1870258), // Rule ID 14208 //
     /* 1870174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1870185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1870188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1870191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870220 */     // MIs[0] policy
     /* 1870220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870230 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870257 */     // GIR_Coverage, 14208,
     /* 1870257 */     GIR_EraseRootFromParent_Done,
     /* 1870258 */   // Label 25265: @1870258
     /* 1870258 */   GIM_Try, /*On fail goto*//*Label 25266*/ GIMT_Encode4(1870347), // Rule ID 14209 //
     /* 1870263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1870274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1870277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1870280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870309 */     // MIs[0] policy
     /* 1870309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870319 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870346 */     // GIR_Coverage, 14209,
     /* 1870346 */     GIR_EraseRootFromParent_Done,
     /* 1870347 */   // Label 25266: @1870347
     /* 1870347 */   GIM_Try, /*On fail goto*//*Label 25267*/ GIMT_Encode4(1870436), // Rule ID 14212 //
     /* 1870352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1870363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1870366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1870369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870398 */     // MIs[0] policy
     /* 1870398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870408 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1870411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870435 */     // GIR_Coverage, 14212,
     /* 1870435 */     GIR_EraseRootFromParent_Done,
     /* 1870436 */   // Label 25267: @1870436
     /* 1870436 */   GIM_Try, /*On fail goto*//*Label 25268*/ GIMT_Encode4(1870525), // Rule ID 14213 //
     /* 1870441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1870452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1870455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1870458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870487 */     // MIs[0] policy
     /* 1870487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870497 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1870500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870524 */     // GIR_Coverage, 14213,
     /* 1870524 */     GIR_EraseRootFromParent_Done,
     /* 1870525 */   // Label 25268: @1870525
     /* 1870525 */   GIM_Try, /*On fail goto*//*Label 25269*/ GIMT_Encode4(1870614), // Rule ID 14216 //
     /* 1870530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1870541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1870544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1870547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1870553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870576 */     // MIs[0] policy
     /* 1870576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870586 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870609 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870613 */     // GIR_Coverage, 14216,
     /* 1870613 */     GIR_EraseRootFromParent_Done,
     /* 1870614 */   // Label 25269: @1870614
     /* 1870614 */   GIM_Try, /*On fail goto*//*Label 25270*/ GIMT_Encode4(1870703), // Rule ID 14217 //
     /* 1870619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1870630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1870633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1870636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1870642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870665 */     // MIs[0] policy
     /* 1870665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870675 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870702 */     // GIR_Coverage, 14217,
     /* 1870702 */     GIR_EraseRootFromParent_Done,
     /* 1870703 */   // Label 25270: @1870703
     /* 1870703 */   GIM_Try, /*On fail goto*//*Label 25271*/ GIMT_Encode4(1870792), // Rule ID 14220 //
     /* 1870708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1870719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1870722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1870725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870754 */     // MIs[0] policy
     /* 1870754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870791 */     // GIR_Coverage, 14220,
     /* 1870791 */     GIR_EraseRootFromParent_Done,
     /* 1870792 */   // Label 25271: @1870792
     /* 1870792 */   GIM_Try, /*On fail goto*//*Label 25272*/ GIMT_Encode4(1870881), // Rule ID 14221 //
     /* 1870797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1870808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1870811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1870814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870843 */     // MIs[0] policy
     /* 1870843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870853 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870880 */     // GIR_Coverage, 14221,
     /* 1870880 */     GIR_EraseRootFromParent_Done,
     /* 1870881 */   // Label 25272: @1870881
     /* 1870881 */   GIM_Try, /*On fail goto*//*Label 25273*/ GIMT_Encode4(1870970), // Rule ID 14224 //
     /* 1870886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1870897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1870900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1870903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870932 */     // MIs[0] policy
     /* 1870932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870942 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1870945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870969 */     // GIR_Coverage, 14224,
     /* 1870969 */     GIR_EraseRootFromParent_Done,
     /* 1870970 */   // Label 25273: @1870970
     /* 1870970 */   GIM_Try, /*On fail goto*//*Label 25274*/ GIMT_Encode4(1871059), // Rule ID 14225 //
     /* 1870975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1870986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1870989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1870992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871021 */     // MIs[0] policy
     /* 1871021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871031 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1871034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1871052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871058 */     // GIR_Coverage, 14225,
     /* 1871058 */     GIR_EraseRootFromParent_Done,
     /* 1871059 */   // Label 25274: @1871059
     /* 1871059 */   GIM_Try, /*On fail goto*//*Label 25275*/ GIMT_Encode4(1871148), // Rule ID 14228 //
     /* 1871064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1871075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1871078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1871081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1871087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871110 */     // MIs[0] policy
     /* 1871110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871120 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1871123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1871141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871147 */     // GIR_Coverage, 14228,
     /* 1871147 */     GIR_EraseRootFromParent_Done,
     /* 1871148 */   // Label 25275: @1871148
     /* 1871148 */   GIM_Try, /*On fail goto*//*Label 25276*/ GIMT_Encode4(1871237), // Rule ID 14229 //
     /* 1871153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1871164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1871167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1871170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1871176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871199 */     // MIs[0] policy
     /* 1871199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871209 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1871212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1871230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871236 */     // GIR_Coverage, 14229,
     /* 1871236 */     GIR_EraseRootFromParent_Done,
     /* 1871237 */   // Label 25276: @1871237
     /* 1871237 */   GIM_Try, /*On fail goto*//*Label 25277*/ GIMT_Encode4(1871326), // Rule ID 14232 //
     /* 1871242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1871245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1871253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1871256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1871259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871288 */     // MIs[0] policy
     /* 1871288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1871301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871325 */     // GIR_Coverage, 14232,
     /* 1871325 */     GIR_EraseRootFromParent_Done,
     /* 1871326 */   // Label 25277: @1871326
     /* 1871326 */   GIM_Try, /*On fail goto*//*Label 25278*/ GIMT_Encode4(1871415), // Rule ID 14233 //
     /* 1871331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1871334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1871342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1871345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1871348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871377 */     // MIs[0] policy
     /* 1871377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871387 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1871390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871414 */     // GIR_Coverage, 14233,
     /* 1871414 */     GIR_EraseRootFromParent_Done,
     /* 1871415 */   // Label 25278: @1871415
     /* 1871415 */   GIM_Try, /*On fail goto*//*Label 25279*/ GIMT_Encode4(1871504), // Rule ID 14236 //
     /* 1871420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1871423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1871431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1871434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1871437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871466 */     // MIs[0] policy
     /* 1871466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871476 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1871479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871503 */     // GIR_Coverage, 14236,
     /* 1871503 */     GIR_EraseRootFromParent_Done,
     /* 1871504 */   // Label 25279: @1871504
     /* 1871504 */   GIM_Try, /*On fail goto*//*Label 25280*/ GIMT_Encode4(1871593), // Rule ID 14237 //
     /* 1871509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1871512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1871520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1871523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1871526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871555 */     // MIs[0] policy
     /* 1871555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871565 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1871568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871592 */     // GIR_Coverage, 14237,
     /* 1871592 */     GIR_EraseRootFromParent_Done,
     /* 1871593 */   // Label 25280: @1871593
     /* 1871593 */   GIM_Try, /*On fail goto*//*Label 25281*/ GIMT_Encode4(1871682), // Rule ID 14240 //
     /* 1871598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1871601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1871609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1871612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1871615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871644 */     // MIs[0] policy
     /* 1871644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871654 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1871657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871681 */     // GIR_Coverage, 14240,
     /* 1871681 */     GIR_EraseRootFromParent_Done,
     /* 1871682 */   // Label 25281: @1871682
     /* 1871682 */   GIM_Try, /*On fail goto*//*Label 25282*/ GIMT_Encode4(1871771), // Rule ID 14241 //
     /* 1871687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1871690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1871698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1871701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1871704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871733 */     // MIs[0] policy
     /* 1871733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871743 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1871746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871770 */     // GIR_Coverage, 14241,
     /* 1871770 */     GIR_EraseRootFromParent_Done,
     /* 1871771 */   // Label 25282: @1871771
     /* 1871771 */   GIM_Try, /*On fail goto*//*Label 25283*/ GIMT_Encode4(1871860), // Rule ID 14332 //
     /* 1871776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1871787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1871790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1871793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1871796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871822 */     // MIs[0] policy
     /* 1871822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871832 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1871835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871859 */     // GIR_Coverage, 14332,
     /* 1871859 */     GIR_EraseRootFromParent_Done,
     /* 1871860 */   // Label 25283: @1871860
     /* 1871860 */   GIM_Try, /*On fail goto*//*Label 25284*/ GIMT_Encode4(1871949), // Rule ID 14333 //
     /* 1871865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1871876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1871879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1871882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1871885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871911 */     // MIs[0] policy
     /* 1871911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871921 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1871924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871948 */     // GIR_Coverage, 14333,
     /* 1871948 */     GIR_EraseRootFromParent_Done,
     /* 1871949 */   // Label 25284: @1871949
     /* 1871949 */   GIM_Try, /*On fail goto*//*Label 25285*/ GIMT_Encode4(1872038), // Rule ID 14336 //
     /* 1871954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1871965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1871968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1871971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1871974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872000 */     // MIs[0] policy
     /* 1872000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872010 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1872013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872037 */     // GIR_Coverage, 14336,
     /* 1872037 */     GIR_EraseRootFromParent_Done,
     /* 1872038 */   // Label 25285: @1872038
     /* 1872038 */   GIM_Try, /*On fail goto*//*Label 25286*/ GIMT_Encode4(1872127), // Rule ID 14337 //
     /* 1872043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1872054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1872057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1872060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1872063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872089 */     // MIs[0] policy
     /* 1872089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872099 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1872102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872126 */     // GIR_Coverage, 14337,
     /* 1872126 */     GIR_EraseRootFromParent_Done,
     /* 1872127 */   // Label 25286: @1872127
     /* 1872127 */   GIM_Try, /*On fail goto*//*Label 25287*/ GIMT_Encode4(1872216), // Rule ID 14340 //
     /* 1872132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1872143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1872146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1872149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1872152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872178 */     // MIs[0] policy
     /* 1872178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872188 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872215 */     // GIR_Coverage, 14340,
     /* 1872215 */     GIR_EraseRootFromParent_Done,
     /* 1872216 */   // Label 25287: @1872216
     /* 1872216 */   GIM_Try, /*On fail goto*//*Label 25288*/ GIMT_Encode4(1872305), // Rule ID 14341 //
     /* 1872221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1872232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1872235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1872238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1872241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872267 */     // MIs[0] policy
     /* 1872267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872277 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872304 */     // GIR_Coverage, 14341,
     /* 1872304 */     GIR_EraseRootFromParent_Done,
     /* 1872305 */   // Label 25288: @1872305
     /* 1872305 */   GIM_Try, /*On fail goto*//*Label 25289*/ GIMT_Encode4(1872394), // Rule ID 14344 //
     /* 1872310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1872321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1872324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1872327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1872330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872356 */     // MIs[0] policy
     /* 1872356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872366 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1872369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872393 */     // GIR_Coverage, 14344,
     /* 1872393 */     GIR_EraseRootFromParent_Done,
     /* 1872394 */   // Label 25289: @1872394
     /* 1872394 */   GIM_Try, /*On fail goto*//*Label 25290*/ GIMT_Encode4(1872483), // Rule ID 14345 //
     /* 1872399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1872410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1872413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1872416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1872419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872445 */     // MIs[0] policy
     /* 1872445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872455 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1872458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872482 */     // GIR_Coverage, 14345,
     /* 1872482 */     GIR_EraseRootFromParent_Done,
     /* 1872483 */   // Label 25290: @1872483
     /* 1872483 */   GIM_Try, /*On fail goto*//*Label 25291*/ GIMT_Encode4(1872572), // Rule ID 14348 //
     /* 1872488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1872499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1872502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1872505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1872508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872534 */     // MIs[0] policy
     /* 1872534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872544 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872571 */     // GIR_Coverage, 14348,
     /* 1872571 */     GIR_EraseRootFromParent_Done,
     /* 1872572 */   // Label 25291: @1872572
     /* 1872572 */   GIM_Try, /*On fail goto*//*Label 25292*/ GIMT_Encode4(1872661), // Rule ID 14349 //
     /* 1872577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1872588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1872591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1872594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1872597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872623 */     // MIs[0] policy
     /* 1872623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872633 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872660 */     // GIR_Coverage, 14349,
     /* 1872660 */     GIR_EraseRootFromParent_Done,
     /* 1872661 */   // Label 25292: @1872661
     /* 1872661 */   GIM_Try, /*On fail goto*//*Label 25293*/ GIMT_Encode4(1872750), // Rule ID 14352 //
     /* 1872666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1872677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1872680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1872683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1872686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872712 */     // MIs[0] policy
     /* 1872712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872722 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872745 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872749 */     // GIR_Coverage, 14352,
     /* 1872749 */     GIR_EraseRootFromParent_Done,
     /* 1872750 */   // Label 25293: @1872750
     /* 1872750 */   GIM_Try, /*On fail goto*//*Label 25294*/ GIMT_Encode4(1872839), // Rule ID 14353 //
     /* 1872755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1872766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1872769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1872772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1872775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872801 */     // MIs[0] policy
     /* 1872801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872811 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872834 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872838 */     // GIR_Coverage, 14353,
     /* 1872838 */     GIR_EraseRootFromParent_Done,
     /* 1872839 */   // Label 25294: @1872839
     /* 1872839 */   GIM_Try, /*On fail goto*//*Label 25295*/ GIMT_Encode4(1872928), // Rule ID 14356 //
     /* 1872844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1872855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1872858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1872861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1872864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872890 */     // MIs[0] policy
     /* 1872890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872900 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872927 */     // GIR_Coverage, 14356,
     /* 1872927 */     GIR_EraseRootFromParent_Done,
     /* 1872928 */   // Label 25295: @1872928
     /* 1872928 */   GIM_Try, /*On fail goto*//*Label 25296*/ GIMT_Encode4(1873017), // Rule ID 14357 //
     /* 1872933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1872944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1872947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1872950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1872953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872979 */     // MIs[0] policy
     /* 1872979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872989 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873016 */     // GIR_Coverage, 14357,
     /* 1873016 */     GIR_EraseRootFromParent_Done,
     /* 1873017 */   // Label 25296: @1873017
     /* 1873017 */   GIM_Try, /*On fail goto*//*Label 25297*/ GIMT_Encode4(1873106), // Rule ID 14360 //
     /* 1873022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1873033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1873036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1873039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1873042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1873045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873068 */     // MIs[0] policy
     /* 1873068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873078 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873105 */     // GIR_Coverage, 14360,
     /* 1873105 */     GIR_EraseRootFromParent_Done,
     /* 1873106 */   // Label 25297: @1873106
     /* 1873106 */   GIM_Try, /*On fail goto*//*Label 25298*/ GIMT_Encode4(1873195), // Rule ID 14361 //
     /* 1873111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1873122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1873125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1873128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1873131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1873134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873157 */     // MIs[0] policy
     /* 1873157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873167 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873194 */     // GIR_Coverage, 14361,
     /* 1873194 */     GIR_EraseRootFromParent_Done,
     /* 1873195 */   // Label 25298: @1873195
     /* 1873195 */   GIM_Try, /*On fail goto*//*Label 25299*/ GIMT_Encode4(1873284), // Rule ID 14364 //
     /* 1873200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1873211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1873214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1873217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1873220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873246 */     // MIs[0] policy
     /* 1873246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1873277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873283 */     // GIR_Coverage, 14364,
     /* 1873283 */     GIR_EraseRootFromParent_Done,
     /* 1873284 */   // Label 25299: @1873284
     /* 1873284 */   GIM_Try, /*On fail goto*//*Label 25300*/ GIMT_Encode4(1873373), // Rule ID 14365 //
     /* 1873289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1873300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1873303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1873306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1873309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873335 */     // MIs[0] policy
     /* 1873335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873345 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1873366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873372 */     // GIR_Coverage, 14365,
     /* 1873372 */     GIR_EraseRootFromParent_Done,
     /* 1873373 */   // Label 25300: @1873373
     /* 1873373 */   GIM_Try, /*On fail goto*//*Label 25301*/ GIMT_Encode4(1873462), // Rule ID 14368 //
     /* 1873378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1873381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1873389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1873392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1873395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1873398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873424 */     // MIs[0] policy
     /* 1873424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873434 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1873455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873457 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873461 */     // GIR_Coverage, 14368,
     /* 1873461 */     GIR_EraseRootFromParent_Done,
     /* 1873462 */   // Label 25301: @1873462
     /* 1873462 */   GIM_Try, /*On fail goto*//*Label 25302*/ GIMT_Encode4(1873551), // Rule ID 14369 //
     /* 1873467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1873470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1873478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1873481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1873484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1873487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873513 */     // MIs[0] policy
     /* 1873513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873523 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1873544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873550 */     // GIR_Coverage, 14369,
     /* 1873550 */     GIR_EraseRootFromParent_Done,
     /* 1873551 */   // Label 25302: @1873551
     /* 1873551 */   GIM_Try, /*On fail goto*//*Label 25303*/ GIMT_Encode4(1873640), // Rule ID 14372 //
     /* 1873556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1873567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1873570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1873573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1873576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873602 */     // MIs[0] policy
     /* 1873602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873612 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1873615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873639 */     // GIR_Coverage, 14372,
     /* 1873639 */     GIR_EraseRootFromParent_Done,
     /* 1873640 */   // Label 25303: @1873640
     /* 1873640 */   GIM_Try, /*On fail goto*//*Label 25304*/ GIMT_Encode4(1873729), // Rule ID 14373 //
     /* 1873645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1873656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1873659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1873662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1873665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873691 */     // MIs[0] policy
     /* 1873691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873701 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1873704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873728 */     // GIR_Coverage, 14373,
     /* 1873728 */     GIR_EraseRootFromParent_Done,
     /* 1873729 */   // Label 25304: @1873729
     /* 1873729 */   GIM_Try, /*On fail goto*//*Label 25305*/ GIMT_Encode4(1873818), // Rule ID 14376 //
     /* 1873734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1873745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1873748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1873751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1873754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1873757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873780 */     // MIs[0] policy
     /* 1873780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873790 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1873793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873817 */     // GIR_Coverage, 14376,
     /* 1873817 */     GIR_EraseRootFromParent_Done,
     /* 1873818 */   // Label 25305: @1873818
     /* 1873818 */   GIM_Try, /*On fail goto*//*Label 25306*/ GIMT_Encode4(1873907), // Rule ID 14377 //
     /* 1873823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1873834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1873837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1873840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1873843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1873846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873869 */     // MIs[0] policy
     /* 1873869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873879 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1873882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873906 */     // GIR_Coverage, 14377,
     /* 1873906 */     GIR_EraseRootFromParent_Done,
     /* 1873907 */   // Label 25306: @1873907
     /* 1873907 */   GIM_Try, /*On fail goto*//*Label 25307*/ GIMT_Encode4(1873996), // Rule ID 14380 //
     /* 1873912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1873923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1873926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1873929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1873932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1873935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1873942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873958 */     // MIs[0] policy
     /* 1873958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873968 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1873971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873995 */     // GIR_Coverage, 14380,
     /* 1873995 */     GIR_EraseRootFromParent_Done,
     /* 1873996 */   // Label 25307: @1873996
     /* 1873996 */   GIM_Try, /*On fail goto*//*Label 25308*/ GIMT_Encode4(1874085), // Rule ID 14381 //
     /* 1874001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1874012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1874015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1874018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1874021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1874024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874047 */     // MIs[0] policy
     /* 1874047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874057 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874084 */     // GIR_Coverage, 14381,
     /* 1874084 */     GIR_EraseRootFromParent_Done,
     /* 1874085 */   // Label 25308: @1874085
     /* 1874085 */   GIM_Try, /*On fail goto*//*Label 25309*/ GIMT_Encode4(1874174), // Rule ID 14384 //
     /* 1874090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1874101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1874104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1874107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1874110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874136 */     // MIs[0] policy
     /* 1874136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874173 */     // GIR_Coverage, 14384,
     /* 1874173 */     GIR_EraseRootFromParent_Done,
     /* 1874174 */   // Label 25309: @1874174
     /* 1874174 */   GIM_Try, /*On fail goto*//*Label 25310*/ GIMT_Encode4(1874263), // Rule ID 14385 //
     /* 1874179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1874190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1874193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1874196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1874199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874225 */     // MIs[0] policy
     /* 1874225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874235 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874262 */     // GIR_Coverage, 14385,
     /* 1874262 */     GIR_EraseRootFromParent_Done,
     /* 1874263 */   // Label 25310: @1874263
     /* 1874263 */   GIM_Try, /*On fail goto*//*Label 25311*/ GIMT_Encode4(1874352), // Rule ID 14388 //
     /* 1874268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1874279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1874282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1874285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1874288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874314 */     // MIs[0] policy
     /* 1874314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874351 */     // GIR_Coverage, 14388,
     /* 1874351 */     GIR_EraseRootFromParent_Done,
     /* 1874352 */   // Label 25311: @1874352
     /* 1874352 */   GIM_Try, /*On fail goto*//*Label 25312*/ GIMT_Encode4(1874441), // Rule ID 14389 //
     /* 1874357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1874368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1874371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1874374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1874377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874403 */     // MIs[0] policy
     /* 1874403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874413 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874440 */     // GIR_Coverage, 14389,
     /* 1874440 */     GIR_EraseRootFromParent_Done,
     /* 1874441 */   // Label 25312: @1874441
     /* 1874441 */   GIM_Try, /*On fail goto*//*Label 25313*/ GIMT_Encode4(1874530), // Rule ID 14392 //
     /* 1874446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1874457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1874460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1874463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1874466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874492 */     // MIs[0] policy
     /* 1874492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874502 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874529 */     // GIR_Coverage, 14392,
     /* 1874529 */     GIR_EraseRootFromParent_Done,
     /* 1874530 */   // Label 25313: @1874530
     /* 1874530 */   GIM_Try, /*On fail goto*//*Label 25314*/ GIMT_Encode4(1874619), // Rule ID 14393 //
     /* 1874535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1874546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1874549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1874552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1874555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874581 */     // MIs[0] policy
     /* 1874581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874591 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874618 */     // GIR_Coverage, 14393,
     /* 1874618 */     GIR_EraseRootFromParent_Done,
     /* 1874619 */   // Label 25314: @1874619
     /* 1874619 */   GIM_Try, /*On fail goto*//*Label 25315*/ GIMT_Encode4(1874708), // Rule ID 14396 //
     /* 1874624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1874635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1874638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1874641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1874644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874670 */     // MIs[0] policy
     /* 1874670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874703 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874707 */     // GIR_Coverage, 14396,
     /* 1874707 */     GIR_EraseRootFromParent_Done,
     /* 1874708 */   // Label 25315: @1874708
     /* 1874708 */   GIM_Try, /*On fail goto*//*Label 25316*/ GIMT_Encode4(1874797), // Rule ID 14397 //
     /* 1874713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1874724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1874727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1874730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1874733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874759 */     // MIs[0] policy
     /* 1874759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874769 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874796 */     // GIR_Coverage, 14397,
     /* 1874796 */     GIR_EraseRootFromParent_Done,
     /* 1874797 */   // Label 25316: @1874797
     /* 1874797 */   GIM_Try, /*On fail goto*//*Label 25317*/ GIMT_Encode4(1874886), // Rule ID 14400 //
     /* 1874802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1874813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1874816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1874819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1874822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874848 */     // MIs[0] policy
     /* 1874848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874858 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874885 */     // GIR_Coverage, 14400,
     /* 1874885 */     GIR_EraseRootFromParent_Done,
     /* 1874886 */   // Label 25317: @1874886
     /* 1874886 */   GIM_Try, /*On fail goto*//*Label 25318*/ GIMT_Encode4(1874975), // Rule ID 14401 //
     /* 1874891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1874902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1874905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1874908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1874911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874937 */     // MIs[0] policy
     /* 1874937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874947 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874974 */     // GIR_Coverage, 14401,
     /* 1874974 */     GIR_EraseRootFromParent_Done,
     /* 1874975 */   // Label 25318: @1874975
     /* 1874975 */   GIM_Try, /*On fail goto*//*Label 25319*/ GIMT_Encode4(1875064), // Rule ID 14404 //
     /* 1874980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1874991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1874994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1874997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1875000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1875003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875026 */     // MIs[0] policy
     /* 1875026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875036 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1875039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875063 */     // GIR_Coverage, 14404,
     /* 1875063 */     GIR_EraseRootFromParent_Done,
     /* 1875064 */   // Label 25319: @1875064
     /* 1875064 */   GIM_Try, /*On fail goto*//*Label 25320*/ GIMT_Encode4(1875153), // Rule ID 14405 //
     /* 1875069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1875080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1875083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1875086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1875089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1875092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875115 */     // MIs[0] policy
     /* 1875115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875125 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1875128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875152 */     // GIR_Coverage, 14405,
     /* 1875152 */     GIR_EraseRootFromParent_Done,
     /* 1875153 */   // Label 25320: @1875153
     /* 1875153 */   GIM_Try, /*On fail goto*//*Label 25321*/ GIMT_Encode4(1875242), // Rule ID 14408 //
     /* 1875158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1875161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1875169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1875172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1875175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1875178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875204 */     // MIs[0] policy
     /* 1875204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1875217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875241 */     // GIR_Coverage, 14408,
     /* 1875241 */     GIR_EraseRootFromParent_Done,
     /* 1875242 */   // Label 25321: @1875242
     /* 1875242 */   GIM_Try, /*On fail goto*//*Label 25322*/ GIMT_Encode4(1875331), // Rule ID 14409 //
     /* 1875247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1875250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1875258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1875261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1875264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1875267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875293 */     // MIs[0] policy
     /* 1875293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1875306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875326 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875330 */     // GIR_Coverage, 14409,
     /* 1875330 */     GIR_EraseRootFromParent_Done,
     /* 1875331 */   // Label 25322: @1875331
     /* 1875331 */   GIM_Try, /*On fail goto*//*Label 25323*/ GIMT_Encode4(1875420), // Rule ID 14412 //
     /* 1875336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1875339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1875347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1875350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1875353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1875356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875382 */     // MIs[0] policy
     /* 1875382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875392 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1875395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875419 */     // GIR_Coverage, 14412,
     /* 1875419 */     GIR_EraseRootFromParent_Done,
     /* 1875420 */   // Label 25323: @1875420
     /* 1875420 */   GIM_Try, /*On fail goto*//*Label 25324*/ GIMT_Encode4(1875509), // Rule ID 14413 //
     /* 1875425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1875428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1875436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1875439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1875442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1875445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875471 */     // MIs[0] policy
     /* 1875471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875481 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1875484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875508 */     // GIR_Coverage, 14413,
     /* 1875508 */     GIR_EraseRootFromParent_Done,
     /* 1875509 */   // Label 25324: @1875509
     /* 1875509 */   GIM_Try, /*On fail goto*//*Label 25325*/ GIMT_Encode4(1875598), // Rule ID 14416 //
     /* 1875514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1875517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1875525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1875528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1875531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1875534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875560 */     // MIs[0] policy
     /* 1875560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875570 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1875573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875597 */     // GIR_Coverage, 14416,
     /* 1875597 */     GIR_EraseRootFromParent_Done,
     /* 1875598 */   // Label 25325: @1875598
     /* 1875598 */   GIM_Try, /*On fail goto*//*Label 25326*/ GIMT_Encode4(1875687), // Rule ID 14417 //
     /* 1875603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1875606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1875614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1875617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1875620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1875623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875649 */     // MIs[0] policy
     /* 1875649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875659 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1875662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875686 */     // GIR_Coverage, 14417,
     /* 1875686 */     GIR_EraseRootFromParent_Done,
     /* 1875687 */   // Label 25326: @1875687
     /* 1875687 */   GIM_Try, /*On fail goto*//*Label 25327*/ GIMT_Encode4(1875776), // Rule ID 14420 //
     /* 1875692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1875703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1875706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1875709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875738 */     // MIs[0] policy
     /* 1875738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875748 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1875751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875775 */     // GIR_Coverage, 14420,
     /* 1875775 */     GIR_EraseRootFromParent_Done,
     /* 1875776 */   // Label 25327: @1875776
     /* 1875776 */   GIM_Try, /*On fail goto*//*Label 25328*/ GIMT_Encode4(1875865), // Rule ID 14421 //
     /* 1875781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1875792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1875795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1875798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875827 */     // MIs[0] policy
     /* 1875827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875837 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1875840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875864 */     // GIR_Coverage, 14421,
     /* 1875864 */     GIR_EraseRootFromParent_Done,
     /* 1875865 */   // Label 25328: @1875865
     /* 1875865 */   GIM_Try, /*On fail goto*//*Label 25329*/ GIMT_Encode4(1875954), // Rule ID 14424 //
     /* 1875870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1875881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1875884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1875887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875916 */     // MIs[0] policy
     /* 1875916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875926 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1875929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875953 */     // GIR_Coverage, 14424,
     /* 1875953 */     GIR_EraseRootFromParent_Done,
     /* 1875954 */   // Label 25329: @1875954
     /* 1875954 */   GIM_Try, /*On fail goto*//*Label 25330*/ GIMT_Encode4(1876043), // Rule ID 14425 //
     /* 1875959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1875970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1875973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1875976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876005 */     // MIs[0] policy
     /* 1876005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876015 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1876018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876042 */     // GIR_Coverage, 14425,
     /* 1876042 */     GIR_EraseRootFromParent_Done,
     /* 1876043 */   // Label 25330: @1876043
     /* 1876043 */   GIM_Try, /*On fail goto*//*Label 25331*/ GIMT_Encode4(1876132), // Rule ID 14428 //
     /* 1876048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1876059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1876062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1876065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876094 */     // MIs[0] policy
     /* 1876094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876104 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876131 */     // GIR_Coverage, 14428,
     /* 1876131 */     GIR_EraseRootFromParent_Done,
     /* 1876132 */   // Label 25331: @1876132
     /* 1876132 */   GIM_Try, /*On fail goto*//*Label 25332*/ GIMT_Encode4(1876221), // Rule ID 14429 //
     /* 1876137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1876148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1876151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1876154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876183 */     // MIs[0] policy
     /* 1876183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876193 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876220 */     // GIR_Coverage, 14429,
     /* 1876220 */     GIR_EraseRootFromParent_Done,
     /* 1876221 */   // Label 25332: @1876221
     /* 1876221 */   GIM_Try, /*On fail goto*//*Label 25333*/ GIMT_Encode4(1876310), // Rule ID 14432 //
     /* 1876226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1876237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1876240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1876243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876272 */     // MIs[0] policy
     /* 1876272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876282 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1876285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876309 */     // GIR_Coverage, 14432,
     /* 1876309 */     GIR_EraseRootFromParent_Done,
     /* 1876310 */   // Label 25333: @1876310
     /* 1876310 */   GIM_Try, /*On fail goto*//*Label 25334*/ GIMT_Encode4(1876399), // Rule ID 14433 //
     /* 1876315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1876326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1876329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1876332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876361 */     // MIs[0] policy
     /* 1876361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876371 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1876374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876398 */     // GIR_Coverage, 14433,
     /* 1876398 */     GIR_EraseRootFromParent_Done,
     /* 1876399 */   // Label 25334: @1876399
     /* 1876399 */   GIM_Try, /*On fail goto*//*Label 25335*/ GIMT_Encode4(1876488), // Rule ID 14436 //
     /* 1876404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1876415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1876418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1876421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876450 */     // MIs[0] policy
     /* 1876450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876460 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876487 */     // GIR_Coverage, 14436,
     /* 1876487 */     GIR_EraseRootFromParent_Done,
     /* 1876488 */   // Label 25335: @1876488
     /* 1876488 */   GIM_Try, /*On fail goto*//*Label 25336*/ GIMT_Encode4(1876577), // Rule ID 14437 //
     /* 1876493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1876504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1876507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1876510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876539 */     // MIs[0] policy
     /* 1876539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876549 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876576 */     // GIR_Coverage, 14437,
     /* 1876576 */     GIR_EraseRootFromParent_Done,
     /* 1876577 */   // Label 25336: @1876577
     /* 1876577 */   GIM_Try, /*On fail goto*//*Label 25337*/ GIMT_Encode4(1876666), // Rule ID 14440 //
     /* 1876582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1876593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1876596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1876599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876628 */     // MIs[0] policy
     /* 1876628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876638 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876661 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876665 */     // GIR_Coverage, 14440,
     /* 1876665 */     GIR_EraseRootFromParent_Done,
     /* 1876666 */   // Label 25337: @1876666
     /* 1876666 */   GIM_Try, /*On fail goto*//*Label 25338*/ GIMT_Encode4(1876755), // Rule ID 14441 //
     /* 1876671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1876682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1876685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1876688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876717 */     // MIs[0] policy
     /* 1876717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876727 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876754 */     // GIR_Coverage, 14441,
     /* 1876754 */     GIR_EraseRootFromParent_Done,
     /* 1876755 */   // Label 25338: @1876755
     /* 1876755 */   GIM_Try, /*On fail goto*//*Label 25339*/ GIMT_Encode4(1876844), // Rule ID 14444 //
     /* 1876760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1876771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1876774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1876777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876806 */     // MIs[0] policy
     /* 1876806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876816 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876843 */     // GIR_Coverage, 14444,
     /* 1876843 */     GIR_EraseRootFromParent_Done,
     /* 1876844 */   // Label 25339: @1876844
     /* 1876844 */   GIM_Try, /*On fail goto*//*Label 25340*/ GIMT_Encode4(1876933), // Rule ID 14445 //
     /* 1876849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1876860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1876863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1876866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876895 */     // MIs[0] policy
     /* 1876895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876905 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876932 */     // GIR_Coverage, 14445,
     /* 1876932 */     GIR_EraseRootFromParent_Done,
     /* 1876933 */   // Label 25340: @1876933
     /* 1876933 */   GIM_Try, /*On fail goto*//*Label 25341*/ GIMT_Encode4(1877022), // Rule ID 14448 //
     /* 1876938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1876949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1876952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1876955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876984 */     // MIs[0] policy
     /* 1876984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876994 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877021 */     // GIR_Coverage, 14448,
     /* 1877021 */     GIR_EraseRootFromParent_Done,
     /* 1877022 */   // Label 25341: @1877022
     /* 1877022 */   GIM_Try, /*On fail goto*//*Label 25342*/ GIMT_Encode4(1877111), // Rule ID 14449 //
     /* 1877027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1877038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1877041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1877044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1877050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877073 */     // MIs[0] policy
     /* 1877073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877083 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1877086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877110 */     // GIR_Coverage, 14449,
     /* 1877110 */     GIR_EraseRootFromParent_Done,
     /* 1877111 */   // Label 25342: @1877111
     /* 1877111 */   GIM_Try, /*On fail goto*//*Label 25343*/ GIMT_Encode4(1877200), // Rule ID 14452 //
     /* 1877116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1877127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1877130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1877133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877162 */     // MIs[0] policy
     /* 1877162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877172 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1877175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877199 */     // GIR_Coverage, 14452,
     /* 1877199 */     GIR_EraseRootFromParent_Done,
     /* 1877200 */   // Label 25343: @1877200
     /* 1877200 */   GIM_Try, /*On fail goto*//*Label 25344*/ GIMT_Encode4(1877289), // Rule ID 14453 //
     /* 1877205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1877216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1877219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1877222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877251 */     // MIs[0] policy
     /* 1877251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877261 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1877264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877288 */     // GIR_Coverage, 14453,
     /* 1877288 */     GIR_EraseRootFromParent_Done,
     /* 1877289 */   // Label 25344: @1877289
     /* 1877289 */   GIM_Try, /*On fail goto*//*Label 25345*/ GIMT_Encode4(1877378), // Rule ID 14456 //
     /* 1877294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1877297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1877305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1877308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1877311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877340 */     // MIs[0] policy
     /* 1877340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877350 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1877353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1877371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877377 */     // GIR_Coverage, 14456,
     /* 1877377 */     GIR_EraseRootFromParent_Done,
     /* 1877378 */   // Label 25345: @1877378
     /* 1877378 */   GIM_Try, /*On fail goto*//*Label 25346*/ GIMT_Encode4(1877467), // Rule ID 14457 //
     /* 1877383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1877386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1877394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1877397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1877400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877429 */     // MIs[0] policy
     /* 1877429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877439 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1877442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1877460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877466 */     // GIR_Coverage, 14457,
     /* 1877466 */     GIR_EraseRootFromParent_Done,
     /* 1877467 */   // Label 25346: @1877467
     /* 1877467 */   GIM_Try, /*On fail goto*//*Label 25347*/ GIMT_Encode4(1877556), // Rule ID 14460 //
     /* 1877472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1877483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1877486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1877489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877518 */     // MIs[0] policy
     /* 1877518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877528 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1877531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877555 */     // GIR_Coverage, 14460,
     /* 1877555 */     GIR_EraseRootFromParent_Done,
     /* 1877556 */   // Label 25347: @1877556
     /* 1877556 */   GIM_Try, /*On fail goto*//*Label 25348*/ GIMT_Encode4(1877645), // Rule ID 14461 //
     /* 1877561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1877572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1877575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1877578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877607 */     // MIs[0] policy
     /* 1877607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877617 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1877620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877644 */     // GIR_Coverage, 14461,
     /* 1877644 */     GIR_EraseRootFromParent_Done,
     /* 1877645 */   // Label 25348: @1877645
     /* 1877645 */   GIM_Try, /*On fail goto*//*Label 25349*/ GIMT_Encode4(1877734), // Rule ID 14464 //
     /* 1877650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1877661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1877664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1877667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877696 */     // MIs[0] policy
     /* 1877696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877706 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1877709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877733 */     // GIR_Coverage, 14464,
     /* 1877733 */     GIR_EraseRootFromParent_Done,
     /* 1877734 */   // Label 25349: @1877734
     /* 1877734 */   GIM_Try, /*On fail goto*//*Label 25350*/ GIMT_Encode4(1877823), // Rule ID 14465 //
     /* 1877739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1877750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1877753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1877756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877785 */     // MIs[0] policy
     /* 1877785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877795 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1877798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877822 */     // GIR_Coverage, 14465,
     /* 1877822 */     GIR_EraseRootFromParent_Done,
     /* 1877823 */   // Label 25350: @1877823
     /* 1877823 */   GIM_Try, /*On fail goto*//*Label 25351*/ GIMT_Encode4(1877912), // Rule ID 14468 //
     /* 1877828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1877839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1877842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1877845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1877851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877874 */     // MIs[0] policy
     /* 1877874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877884 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1877887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877911 */     // GIR_Coverage, 14468,
     /* 1877911 */     GIR_EraseRootFromParent_Done,
     /* 1877912 */   // Label 25351: @1877912
     /* 1877912 */   GIM_Try, /*On fail goto*//*Label 25352*/ GIMT_Encode4(1878001), // Rule ID 14469 //
     /* 1877917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1877928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1877931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1877934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1877940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877963 */     // MIs[0] policy
     /* 1877963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877973 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1877976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878000 */     // GIR_Coverage, 14469,
     /* 1878000 */     GIR_EraseRootFromParent_Done,
     /* 1878001 */   // Label 25352: @1878001
     /* 1878001 */   GIM_Try, /*On fail goto*//*Label 25353*/ GIMT_Encode4(1878090), // Rule ID 14472 //
     /* 1878006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1878017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1878020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1878023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878052 */     // MIs[0] policy
     /* 1878052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878062 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878089 */     // GIR_Coverage, 14472,
     /* 1878089 */     GIR_EraseRootFromParent_Done,
     /* 1878090 */   // Label 25353: @1878090
     /* 1878090 */   GIM_Try, /*On fail goto*//*Label 25354*/ GIMT_Encode4(1878179), // Rule ID 14473 //
     /* 1878095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1878106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1878109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1878112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878141 */     // MIs[0] policy
     /* 1878141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878151 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878178 */     // GIR_Coverage, 14473,
     /* 1878178 */     GIR_EraseRootFromParent_Done,
     /* 1878179 */   // Label 25354: @1878179
     /* 1878179 */   GIM_Try, /*On fail goto*//*Label 25355*/ GIMT_Encode4(1878268), // Rule ID 14476 //
     /* 1878184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1878195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1878198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1878201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878230 */     // MIs[0] policy
     /* 1878230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878240 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878267 */     // GIR_Coverage, 14476,
     /* 1878267 */     GIR_EraseRootFromParent_Done,
     /* 1878268 */   // Label 25355: @1878268
     /* 1878268 */   GIM_Try, /*On fail goto*//*Label 25356*/ GIMT_Encode4(1878357), // Rule ID 14477 //
     /* 1878273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1878284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1878287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1878290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878319 */     // MIs[0] policy
     /* 1878319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878329 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878356 */     // GIR_Coverage, 14477,
     /* 1878356 */     GIR_EraseRootFromParent_Done,
     /* 1878357 */   // Label 25356: @1878357
     /* 1878357 */   GIM_Try, /*On fail goto*//*Label 25357*/ GIMT_Encode4(1878446), // Rule ID 14480 //
     /* 1878362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1878373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1878376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1878379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878408 */     // MIs[0] policy
     /* 1878408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878418 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1878421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878445 */     // GIR_Coverage, 14480,
     /* 1878445 */     GIR_EraseRootFromParent_Done,
     /* 1878446 */   // Label 25357: @1878446
     /* 1878446 */   GIM_Try, /*On fail goto*//*Label 25358*/ GIMT_Encode4(1878535), // Rule ID 14481 //
     /* 1878451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1878462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1878465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1878468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878497 */     // MIs[0] policy
     /* 1878497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878507 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1878510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878534 */     // GIR_Coverage, 14481,
     /* 1878534 */     GIR_EraseRootFromParent_Done,
     /* 1878535 */   // Label 25358: @1878535
     /* 1878535 */   GIM_Try, /*On fail goto*//*Label 25359*/ GIMT_Encode4(1878624), // Rule ID 14484 //
     /* 1878540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1878551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1878554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1878557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878586 */     // MIs[0] policy
     /* 1878586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878623 */     // GIR_Coverage, 14484,
     /* 1878623 */     GIR_EraseRootFromParent_Done,
     /* 1878624 */   // Label 25359: @1878624
     /* 1878624 */   GIM_Try, /*On fail goto*//*Label 25360*/ GIMT_Encode4(1878713), // Rule ID 14485 //
     /* 1878629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1878640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1878643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1878646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878675 */     // MIs[0] policy
     /* 1878675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878685 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878712 */     // GIR_Coverage, 14485,
     /* 1878712 */     GIR_EraseRootFromParent_Done,
     /* 1878713 */   // Label 25360: @1878713
     /* 1878713 */   GIM_Try, /*On fail goto*//*Label 25361*/ GIMT_Encode4(1878802), // Rule ID 14488 //
     /* 1878718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1878729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1878732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1878735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878764 */     // MIs[0] policy
     /* 1878764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878774 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878801 */     // GIR_Coverage, 14488,
     /* 1878801 */     GIR_EraseRootFromParent_Done,
     /* 1878802 */   // Label 25361: @1878802
     /* 1878802 */   GIM_Try, /*On fail goto*//*Label 25362*/ GIMT_Encode4(1878891), // Rule ID 14489 //
     /* 1878807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1878818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1878821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1878824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878853 */     // MIs[0] policy
     /* 1878853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878863 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878890 */     // GIR_Coverage, 14489,
     /* 1878890 */     GIR_EraseRootFromParent_Done,
     /* 1878891 */   // Label 25362: @1878891
     /* 1878891 */   GIM_Try, /*On fail goto*//*Label 25363*/ GIMT_Encode4(1878980), // Rule ID 14492 //
     /* 1878896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1878907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1878910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1878913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878942 */     // MIs[0] policy
     /* 1878942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1878955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878979 */     // GIR_Coverage, 14492,
     /* 1878979 */     GIR_EraseRootFromParent_Done,
     /* 1878980 */   // Label 25363: @1878980
     /* 1878980 */   GIM_Try, /*On fail goto*//*Label 25364*/ GIMT_Encode4(1879069), // Rule ID 14493 //
     /* 1878985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1878996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1878999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1879002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1879008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879031 */     // MIs[0] policy
     /* 1879031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879041 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1879044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879068 */     // GIR_Coverage, 14493,
     /* 1879068 */     GIR_EraseRootFromParent_Done,
     /* 1879069 */   // Label 25364: @1879069
     /* 1879069 */   GIM_Try, /*On fail goto*//*Label 25365*/ GIMT_Encode4(1879158), // Rule ID 14496 //
     /* 1879074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1879077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1879085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1879088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1879091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879120 */     // MIs[0] policy
     /* 1879120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1879133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879157 */     // GIR_Coverage, 14496,
     /* 1879157 */     GIR_EraseRootFromParent_Done,
     /* 1879158 */   // Label 25365: @1879158
     /* 1879158 */   GIM_Try, /*On fail goto*//*Label 25366*/ GIMT_Encode4(1879247), // Rule ID 14497 //
     /* 1879163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1879166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1879174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1879177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1879180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879209 */     // MIs[0] policy
     /* 1879209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1879222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879246 */     // GIR_Coverage, 14497,
     /* 1879246 */     GIR_EraseRootFromParent_Done,
     /* 1879247 */   // Label 25366: @1879247
     /* 1879247 */   GIM_Try, /*On fail goto*//*Label 25367*/ GIMT_Encode4(1879336), // Rule ID 14500 //
     /* 1879252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1879255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1879263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1879266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1879269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879298 */     // MIs[0] policy
     /* 1879298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879308 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1879311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879335 */     // GIR_Coverage, 14500,
     /* 1879335 */     GIR_EraseRootFromParent_Done,
     /* 1879336 */   // Label 25367: @1879336
     /* 1879336 */   GIM_Try, /*On fail goto*//*Label 25368*/ GIMT_Encode4(1879425), // Rule ID 14501 //
     /* 1879341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1879344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1879352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1879355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1879358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879387 */     // MIs[0] policy
     /* 1879387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879397 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1879400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879424 */     // GIR_Coverage, 14501,
     /* 1879424 */     GIR_EraseRootFromParent_Done,
     /* 1879425 */   // Label 25368: @1879425
     /* 1879425 */   GIM_Try, /*On fail goto*//*Label 25369*/ GIMT_Encode4(1879514), // Rule ID 14504 //
     /* 1879430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1879433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1879441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1879444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1879447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879476 */     // MIs[0] policy
     /* 1879476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879486 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1879489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879513 */     // GIR_Coverage, 14504,
     /* 1879513 */     GIR_EraseRootFromParent_Done,
     /* 1879514 */   // Label 25369: @1879514
     /* 1879514 */   GIM_Try, /*On fail goto*//*Label 25370*/ GIMT_Encode4(1879603), // Rule ID 14505 //
     /* 1879519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1879522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1879530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1879533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1879536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879565 */     // MIs[0] policy
     /* 1879565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879575 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1879578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879602 */     // GIR_Coverage, 14505,
     /* 1879602 */     GIR_EraseRootFromParent_Done,
     /* 1879603 */   // Label 25370: @1879603
     /* 1879603 */   GIM_Try, /*On fail goto*//*Label 25371*/ GIMT_Encode4(1879692), // Rule ID 14596 //
     /* 1879608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1879619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1879622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1879625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1879628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879654 */     // MIs[0] policy
     /* 1879654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879664 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1879667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879687 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879691 */     // GIR_Coverage, 14596,
     /* 1879691 */     GIR_EraseRootFromParent_Done,
     /* 1879692 */   // Label 25371: @1879692
     /* 1879692 */   GIM_Try, /*On fail goto*//*Label 25372*/ GIMT_Encode4(1879781), // Rule ID 14597 //
     /* 1879697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1879708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1879711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1879714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1879717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879743 */     // MIs[0] policy
     /* 1879743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879753 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1879756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879780 */     // GIR_Coverage, 14597,
     /* 1879780 */     GIR_EraseRootFromParent_Done,
     /* 1879781 */   // Label 25372: @1879781
     /* 1879781 */   GIM_Try, /*On fail goto*//*Label 25373*/ GIMT_Encode4(1879870), // Rule ID 14600 //
     /* 1879786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1879797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1879800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1879803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1879806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879832 */     // MIs[0] policy
     /* 1879832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879842 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1879845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879869 */     // GIR_Coverage, 14600,
     /* 1879869 */     GIR_EraseRootFromParent_Done,
     /* 1879870 */   // Label 25373: @1879870
     /* 1879870 */   GIM_Try, /*On fail goto*//*Label 25374*/ GIMT_Encode4(1879959), // Rule ID 14601 //
     /* 1879875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1879886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1879889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1879892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1879895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879921 */     // MIs[0] policy
     /* 1879921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879931 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1879934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879958 */     // GIR_Coverage, 14601,
     /* 1879958 */     GIR_EraseRootFromParent_Done,
     /* 1879959 */   // Label 25374: @1879959
     /* 1879959 */   GIM_Try, /*On fail goto*//*Label 25375*/ GIMT_Encode4(1880048), // Rule ID 14604 //
     /* 1879964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1879975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1879978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1879981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1879984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880010 */     // MIs[0] policy
     /* 1880010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880020 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880047 */     // GIR_Coverage, 14604,
     /* 1880047 */     GIR_EraseRootFromParent_Done,
     /* 1880048 */   // Label 25375: @1880048
     /* 1880048 */   GIM_Try, /*On fail goto*//*Label 25376*/ GIMT_Encode4(1880137), // Rule ID 14605 //
     /* 1880053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1880064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1880067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1880070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1880073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880099 */     // MIs[0] policy
     /* 1880099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880109 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880136 */     // GIR_Coverage, 14605,
     /* 1880136 */     GIR_EraseRootFromParent_Done,
     /* 1880137 */   // Label 25376: @1880137
     /* 1880137 */   GIM_Try, /*On fail goto*//*Label 25377*/ GIMT_Encode4(1880226), // Rule ID 14608 //
     /* 1880142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1880153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1880156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1880159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1880162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880188 */     // MIs[0] policy
     /* 1880188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1880201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880221 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880225 */     // GIR_Coverage, 14608,
     /* 1880225 */     GIR_EraseRootFromParent_Done,
     /* 1880226 */   // Label 25377: @1880226
     /* 1880226 */   GIM_Try, /*On fail goto*//*Label 25378*/ GIMT_Encode4(1880315), // Rule ID 14609 //
     /* 1880231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1880242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1880245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1880248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1880251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880277 */     // MIs[0] policy
     /* 1880277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880287 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1880290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880310 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880314 */     // GIR_Coverage, 14609,
     /* 1880314 */     GIR_EraseRootFromParent_Done,
     /* 1880315 */   // Label 25378: @1880315
     /* 1880315 */   GIM_Try, /*On fail goto*//*Label 25379*/ GIMT_Encode4(1880404), // Rule ID 14612 //
     /* 1880320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1880331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1880334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1880337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1880340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880366 */     // MIs[0] policy
     /* 1880366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880376 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880403 */     // GIR_Coverage, 14612,
     /* 1880403 */     GIR_EraseRootFromParent_Done,
     /* 1880404 */   // Label 25379: @1880404
     /* 1880404 */   GIM_Try, /*On fail goto*//*Label 25380*/ GIMT_Encode4(1880493), // Rule ID 14613 //
     /* 1880409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1880420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1880423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1880426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1880429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880455 */     // MIs[0] policy
     /* 1880455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880465 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880488 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880492 */     // GIR_Coverage, 14613,
     /* 1880492 */     GIR_EraseRootFromParent_Done,
     /* 1880493 */   // Label 25380: @1880493
     /* 1880493 */   GIM_Try, /*On fail goto*//*Label 25381*/ GIMT_Encode4(1880582), // Rule ID 14616 //
     /* 1880498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1880509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1880512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1880515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1880518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880544 */     // MIs[0] policy
     /* 1880544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880581 */     // GIR_Coverage, 14616,
     /* 1880581 */     GIR_EraseRootFromParent_Done,
     /* 1880582 */   // Label 25381: @1880582
     /* 1880582 */   GIM_Try, /*On fail goto*//*Label 25382*/ GIMT_Encode4(1880671), // Rule ID 14617 //
     /* 1880587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1880598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1880601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1880604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1880607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880633 */     // MIs[0] policy
     /* 1880633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880643 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880670 */     // GIR_Coverage, 14617,
     /* 1880670 */     GIR_EraseRootFromParent_Done,
     /* 1880671 */   // Label 25382: @1880671
     /* 1880671 */   GIM_Try, /*On fail goto*//*Label 25383*/ GIMT_Encode4(1880760), // Rule ID 14620 //
     /* 1880676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1880687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1880690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1880693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1880696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880722 */     // MIs[0] policy
     /* 1880722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880759 */     // GIR_Coverage, 14620,
     /* 1880759 */     GIR_EraseRootFromParent_Done,
     /* 1880760 */   // Label 25383: @1880760
     /* 1880760 */   GIM_Try, /*On fail goto*//*Label 25384*/ GIMT_Encode4(1880849), // Rule ID 14621 //
     /* 1880765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1880776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1880779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1880782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1880785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880811 */     // MIs[0] policy
     /* 1880811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880821 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880848 */     // GIR_Coverage, 14621,
     /* 1880848 */     GIR_EraseRootFromParent_Done,
     /* 1880849 */   // Label 25384: @1880849
     /* 1880849 */   GIM_Try, /*On fail goto*//*Label 25385*/ GIMT_Encode4(1880938), // Rule ID 14624 //
     /* 1880854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1880865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1880868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1880871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1880874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880900 */     // MIs[0] policy
     /* 1880900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880910 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880937 */     // GIR_Coverage, 14624,
     /* 1880937 */     GIR_EraseRootFromParent_Done,
     /* 1880938 */   // Label 25385: @1880938
     /* 1880938 */   GIM_Try, /*On fail goto*//*Label 25386*/ GIMT_Encode4(1881027), // Rule ID 14625 //
     /* 1880943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1880954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1880957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1880960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1880963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880989 */     // MIs[0] policy
     /* 1880989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880999 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1881002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881026 */     // GIR_Coverage, 14625,
     /* 1881026 */     GIR_EraseRootFromParent_Done,
     /* 1881027 */   // Label 25386: @1881027
     /* 1881027 */   GIM_Try, /*On fail goto*//*Label 25387*/ GIMT_Encode4(1881116), // Rule ID 14628 //
     /* 1881032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1881043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1881046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1881049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1881052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881078 */     // MIs[0] policy
     /* 1881078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881088 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1881091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881115 */     // GIR_Coverage, 14628,
     /* 1881115 */     GIR_EraseRootFromParent_Done,
     /* 1881116 */   // Label 25387: @1881116
     /* 1881116 */   GIM_Try, /*On fail goto*//*Label 25388*/ GIMT_Encode4(1881205), // Rule ID 14629 //
     /* 1881121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1881132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1881135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1881138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1881141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881167 */     // MIs[0] policy
     /* 1881167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881177 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1881180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881204 */     // GIR_Coverage, 14629,
     /* 1881204 */     GIR_EraseRootFromParent_Done,
     /* 1881205 */   // Label 25388: @1881205
     /* 1881205 */   GIM_Try, /*On fail goto*//*Label 25389*/ GIMT_Encode4(1881294), // Rule ID 14632 //
     /* 1881210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1881213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1881221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1881224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1881227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1881230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881256 */     // MIs[0] policy
     /* 1881256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881266 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1881269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1881287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881289 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881293 */     // GIR_Coverage, 14632,
     /* 1881293 */     GIR_EraseRootFromParent_Done,
     /* 1881294 */   // Label 25389: @1881294
     /* 1881294 */   GIM_Try, /*On fail goto*//*Label 25390*/ GIMT_Encode4(1881383), // Rule ID 14633 //
     /* 1881299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1881302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1881310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1881313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1881316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1881319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881345 */     // MIs[0] policy
     /* 1881345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881355 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1881358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1881376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881382 */     // GIR_Coverage, 14633,
     /* 1881382 */     GIR_EraseRootFromParent_Done,
     /* 1881383 */   // Label 25390: @1881383
     /* 1881383 */   GIM_Try, /*On fail goto*//*Label 25391*/ GIMT_Encode4(1881472), // Rule ID 14636 //
     /* 1881388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1881399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1881402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1881405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1881408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881434 */     // MIs[0] policy
     /* 1881434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881444 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1881447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881471 */     // GIR_Coverage, 14636,
     /* 1881471 */     GIR_EraseRootFromParent_Done,
     /* 1881472 */   // Label 25391: @1881472
     /* 1881472 */   GIM_Try, /*On fail goto*//*Label 25392*/ GIMT_Encode4(1881561), // Rule ID 14637 //
     /* 1881477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1881488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1881491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1881494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1881497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881523 */     // MIs[0] policy
     /* 1881523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881533 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1881536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881560 */     // GIR_Coverage, 14637,
     /* 1881560 */     GIR_EraseRootFromParent_Done,
     /* 1881561 */   // Label 25392: @1881561
     /* 1881561 */   GIM_Try, /*On fail goto*//*Label 25393*/ GIMT_Encode4(1881650), // Rule ID 14640 //
     /* 1881566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1881577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1881580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1881583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1881586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881612 */     // MIs[0] policy
     /* 1881612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881622 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1881625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881649 */     // GIR_Coverage, 14640,
     /* 1881649 */     GIR_EraseRootFromParent_Done,
     /* 1881650 */   // Label 25393: @1881650
     /* 1881650 */   GIM_Try, /*On fail goto*//*Label 25394*/ GIMT_Encode4(1881739), // Rule ID 14641 //
     /* 1881655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1881666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1881669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1881672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1881675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881701 */     // MIs[0] policy
     /* 1881701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881711 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1881714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881738 */     // GIR_Coverage, 14641,
     /* 1881738 */     GIR_EraseRootFromParent_Done,
     /* 1881739 */   // Label 25394: @1881739
     /* 1881739 */   GIM_Try, /*On fail goto*//*Label 25395*/ GIMT_Encode4(1881828), // Rule ID 14644 //
     /* 1881744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1881755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1881758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1881761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1881764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1881767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881790 */     // MIs[0] policy
     /* 1881790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881800 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1881803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881827 */     // GIR_Coverage, 14644,
     /* 1881827 */     GIR_EraseRootFromParent_Done,
     /* 1881828 */   // Label 25395: @1881828
     /* 1881828 */   GIM_Try, /*On fail goto*//*Label 25396*/ GIMT_Encode4(1881917), // Rule ID 14645 //
     /* 1881833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1881844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1881847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1881850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1881853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1881856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881879 */     // MIs[0] policy
     /* 1881879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881889 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1881892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881916 */     // GIR_Coverage, 14645,
     /* 1881916 */     GIR_EraseRootFromParent_Done,
     /* 1881917 */   // Label 25396: @1881917
     /* 1881917 */   GIM_Try, /*On fail goto*//*Label 25397*/ GIMT_Encode4(1882006), // Rule ID 14648 //
     /* 1881922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1881933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1881936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1881939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1881942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881968 */     // MIs[0] policy
     /* 1881968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1881981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882005 */     // GIR_Coverage, 14648,
     /* 1882005 */     GIR_EraseRootFromParent_Done,
     /* 1882006 */   // Label 25397: @1882006
     /* 1882006 */   GIM_Try, /*On fail goto*//*Label 25398*/ GIMT_Encode4(1882095), // Rule ID 14649 //
     /* 1882011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1882022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1882025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1882028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1882031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882057 */     // MIs[0] policy
     /* 1882057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882067 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882094 */     // GIR_Coverage, 14649,
     /* 1882094 */     GIR_EraseRootFromParent_Done,
     /* 1882095 */   // Label 25398: @1882095
     /* 1882095 */   GIM_Try, /*On fail goto*//*Label 25399*/ GIMT_Encode4(1882184), // Rule ID 14652 //
     /* 1882100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1882111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1882114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1882117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1882120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882146 */     // MIs[0] policy
     /* 1882146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882156 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882183 */     // GIR_Coverage, 14652,
     /* 1882183 */     GIR_EraseRootFromParent_Done,
     /* 1882184 */   // Label 25399: @1882184
     /* 1882184 */   GIM_Try, /*On fail goto*//*Label 25400*/ GIMT_Encode4(1882273), // Rule ID 14653 //
     /* 1882189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1882200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1882203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1882206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1882209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882235 */     // MIs[0] policy
     /* 1882235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882245 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882272 */     // GIR_Coverage, 14653,
     /* 1882272 */     GIR_EraseRootFromParent_Done,
     /* 1882273 */   // Label 25400: @1882273
     /* 1882273 */   GIM_Try, /*On fail goto*//*Label 25401*/ GIMT_Encode4(1882362), // Rule ID 14656 //
     /* 1882278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1882289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1882292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1882295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1882298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1882301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882324 */     // MIs[0] policy
     /* 1882324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882334 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882361 */     // GIR_Coverage, 14656,
     /* 1882361 */     GIR_EraseRootFromParent_Done,
     /* 1882362 */   // Label 25401: @1882362
     /* 1882362 */   GIM_Try, /*On fail goto*//*Label 25402*/ GIMT_Encode4(1882451), // Rule ID 14657 //
     /* 1882367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1882378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1882381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1882384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1882387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1882390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882413 */     // MIs[0] policy
     /* 1882413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882423 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882450 */     // GIR_Coverage, 14657,
     /* 1882450 */     GIR_EraseRootFromParent_Done,
     /* 1882451 */   // Label 25402: @1882451
     /* 1882451 */   GIM_Try, /*On fail goto*//*Label 25403*/ GIMT_Encode4(1882540), // Rule ID 14660 //
     /* 1882456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1882467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1882470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1882473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1882476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882502 */     // MIs[0] policy
     /* 1882502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882539 */     // GIR_Coverage, 14660,
     /* 1882539 */     GIR_EraseRootFromParent_Done,
     /* 1882540 */   // Label 25403: @1882540
     /* 1882540 */   GIM_Try, /*On fail goto*//*Label 25404*/ GIMT_Encode4(1882629), // Rule ID 14661 //
     /* 1882545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1882556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1882559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1882562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1882565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882591 */     // MIs[0] policy
     /* 1882591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882628 */     // GIR_Coverage, 14661,
     /* 1882628 */     GIR_EraseRootFromParent_Done,
     /* 1882629 */   // Label 25404: @1882629
     /* 1882629 */   GIM_Try, /*On fail goto*//*Label 25405*/ GIMT_Encode4(1882718), // Rule ID 14664 //
     /* 1882634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1882645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1882648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1882651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1882654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882680 */     // MIs[0] policy
     /* 1882680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882690 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882713 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882717 */     // GIR_Coverage, 14664,
     /* 1882717 */     GIR_EraseRootFromParent_Done,
     /* 1882718 */   // Label 25405: @1882718
     /* 1882718 */   GIM_Try, /*On fail goto*//*Label 25406*/ GIMT_Encode4(1882807), // Rule ID 14665 //
     /* 1882723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1882734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1882737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1882740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1882743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882769 */     // MIs[0] policy
     /* 1882769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882779 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882806 */     // GIR_Coverage, 14665,
     /* 1882806 */     GIR_EraseRootFromParent_Done,
     /* 1882807 */   // Label 25406: @1882807
     /* 1882807 */   GIM_Try, /*On fail goto*//*Label 25407*/ GIMT_Encode4(1882896), // Rule ID 14668 //
     /* 1882812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1882823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1882826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1882829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1882832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882858 */     // MIs[0] policy
     /* 1882858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882868 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882895 */     // GIR_Coverage, 14668,
     /* 1882895 */     GIR_EraseRootFromParent_Done,
     /* 1882896 */   // Label 25407: @1882896
     /* 1882896 */   GIM_Try, /*On fail goto*//*Label 25408*/ GIMT_Encode4(1882985), // Rule ID 14669 //
     /* 1882901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1882912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1882915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1882918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1882921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882947 */     // MIs[0] policy
     /* 1882947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882957 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882984 */     // GIR_Coverage, 14669,
     /* 1882984 */     GIR_EraseRootFromParent_Done,
     /* 1882985 */   // Label 25408: @1882985
     /* 1882985 */   GIM_Try, /*On fail goto*//*Label 25409*/ GIMT_Encode4(1883074), // Rule ID 14672 //
     /* 1882990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1882993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1883001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1883004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1883007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1883010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883036 */     // MIs[0] policy
     /* 1883036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1883049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883073 */     // GIR_Coverage, 14672,
     /* 1883073 */     GIR_EraseRootFromParent_Done,
     /* 1883074 */   // Label 25409: @1883074
     /* 1883074 */   GIM_Try, /*On fail goto*//*Label 25410*/ GIMT_Encode4(1883163), // Rule ID 14673 //
     /* 1883079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1883082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1883090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1883093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1883096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1883099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883125 */     // MIs[0] policy
     /* 1883125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883135 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1883138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883162 */     // GIR_Coverage, 14673,
     /* 1883162 */     GIR_EraseRootFromParent_Done,
     /* 1883163 */   // Label 25410: @1883163
     /* 1883163 */   GIM_Try, /*On fail goto*//*Label 25411*/ GIMT_Encode4(1883252), // Rule ID 14676 //
     /* 1883168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1883171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1883179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1883182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1883185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1883188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883214 */     // MIs[0] policy
     /* 1883214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883224 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1883227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883251 */     // GIR_Coverage, 14676,
     /* 1883251 */     GIR_EraseRootFromParent_Done,
     /* 1883252 */   // Label 25411: @1883252
     /* 1883252 */   GIM_Try, /*On fail goto*//*Label 25412*/ GIMT_Encode4(1883341), // Rule ID 14677 //
     /* 1883257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1883260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1883268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1883271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1883274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1883277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883303 */     // MIs[0] policy
     /* 1883303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883313 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1883316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883340 */     // GIR_Coverage, 14677,
     /* 1883340 */     GIR_EraseRootFromParent_Done,
     /* 1883341 */   // Label 25412: @1883341
     /* 1883341 */   GIM_Try, /*On fail goto*//*Label 25413*/ GIMT_Encode4(1883430), // Rule ID 14680 //
     /* 1883346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1883349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1883357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1883360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1883363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1883366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883392 */     // MIs[0] policy
     /* 1883392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883402 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1883405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883429 */     // GIR_Coverage, 14680,
     /* 1883429 */     GIR_EraseRootFromParent_Done,
     /* 1883430 */   // Label 25413: @1883430
     /* 1883430 */   GIM_Try, /*On fail goto*//*Label 25414*/ GIMT_Encode4(1883519), // Rule ID 14681 //
     /* 1883435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1883438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1883446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1883449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1883452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1883455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883481 */     // MIs[0] policy
     /* 1883481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883491 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1883494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883518 */     // GIR_Coverage, 14681,
     /* 1883518 */     GIR_EraseRootFromParent_Done,
     /* 1883519 */   // Label 25414: @1883519
     /* 1883519 */   GIM_Try, /*On fail goto*//*Label 25415*/ GIMT_Encode4(1883608), // Rule ID 14684 //
     /* 1883524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1883535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1883538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1883541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883570 */     // MIs[0] policy
     /* 1883570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883580 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1883583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883607 */     // GIR_Coverage, 14684,
     /* 1883607 */     GIR_EraseRootFromParent_Done,
     /* 1883608 */   // Label 25415: @1883608
     /* 1883608 */   GIM_Try, /*On fail goto*//*Label 25416*/ GIMT_Encode4(1883697), // Rule ID 14685 //
     /* 1883613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1883624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1883627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1883630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883659 */     // MIs[0] policy
     /* 1883659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883669 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1883672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883696 */     // GIR_Coverage, 14685,
     /* 1883696 */     GIR_EraseRootFromParent_Done,
     /* 1883697 */   // Label 25416: @1883697
     /* 1883697 */   GIM_Try, /*On fail goto*//*Label 25417*/ GIMT_Encode4(1883786), // Rule ID 14688 //
     /* 1883702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1883713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1883716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1883719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883748 */     // MIs[0] policy
     /* 1883748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883758 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1883761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883785 */     // GIR_Coverage, 14688,
     /* 1883785 */     GIR_EraseRootFromParent_Done,
     /* 1883786 */   // Label 25417: @1883786
     /* 1883786 */   GIM_Try, /*On fail goto*//*Label 25418*/ GIMT_Encode4(1883875), // Rule ID 14689 //
     /* 1883791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1883802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1883805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1883808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883837 */     // MIs[0] policy
     /* 1883837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883847 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1883850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883870 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883874 */     // GIR_Coverage, 14689,
     /* 1883874 */     GIR_EraseRootFromParent_Done,
     /* 1883875 */   // Label 25418: @1883875
     /* 1883875 */   GIM_Try, /*On fail goto*//*Label 25419*/ GIMT_Encode4(1883964), // Rule ID 14692 //
     /* 1883880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1883891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1883894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1883897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883926 */     // MIs[0] policy
     /* 1883926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883936 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1883939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883963 */     // GIR_Coverage, 14692,
     /* 1883963 */     GIR_EraseRootFromParent_Done,
     /* 1883964 */   // Label 25419: @1883964
     /* 1883964 */   GIM_Try, /*On fail goto*//*Label 25420*/ GIMT_Encode4(1884053), // Rule ID 14693 //
     /* 1883969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1883980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1883983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1883986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884015 */     // MIs[0] policy
     /* 1884015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884025 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884052 */     // GIR_Coverage, 14693,
     /* 1884052 */     GIR_EraseRootFromParent_Done,
     /* 1884053 */   // Label 25420: @1884053
     /* 1884053 */   GIM_Try, /*On fail goto*//*Label 25421*/ GIMT_Encode4(1884142), // Rule ID 14696 //
     /* 1884058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1884069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1884072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1884075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884104 */     // MIs[0] policy
     /* 1884104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1884117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884141 */     // GIR_Coverage, 14696,
     /* 1884141 */     GIR_EraseRootFromParent_Done,
     /* 1884142 */   // Label 25421: @1884142
     /* 1884142 */   GIM_Try, /*On fail goto*//*Label 25422*/ GIMT_Encode4(1884231), // Rule ID 14697 //
     /* 1884147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1884158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1884161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1884164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884193 */     // MIs[0] policy
     /* 1884193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884203 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1884206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884230 */     // GIR_Coverage, 14697,
     /* 1884230 */     GIR_EraseRootFromParent_Done,
     /* 1884231 */   // Label 25422: @1884231
     /* 1884231 */   GIM_Try, /*On fail goto*//*Label 25423*/ GIMT_Encode4(1884320), // Rule ID 14700 //
     /* 1884236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1884247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1884250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1884253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884282 */     // MIs[0] policy
     /* 1884282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884292 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884319 */     // GIR_Coverage, 14700,
     /* 1884319 */     GIR_EraseRootFromParent_Done,
     /* 1884320 */   // Label 25423: @1884320
     /* 1884320 */   GIM_Try, /*On fail goto*//*Label 25424*/ GIMT_Encode4(1884409), // Rule ID 14701 //
     /* 1884325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1884336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1884339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1884342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884371 */     // MIs[0] policy
     /* 1884371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884381 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884408 */     // GIR_Coverage, 14701,
     /* 1884408 */     GIR_EraseRootFromParent_Done,
     /* 1884409 */   // Label 25424: @1884409
     /* 1884409 */   GIM_Try, /*On fail goto*//*Label 25425*/ GIMT_Encode4(1884498), // Rule ID 14704 //
     /* 1884414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1884425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1884428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1884431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884460 */     // MIs[0] policy
     /* 1884460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884470 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884497 */     // GIR_Coverage, 14704,
     /* 1884497 */     GIR_EraseRootFromParent_Done,
     /* 1884498 */   // Label 25425: @1884498
     /* 1884498 */   GIM_Try, /*On fail goto*//*Label 25426*/ GIMT_Encode4(1884587), // Rule ID 14705 //
     /* 1884503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1884514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1884517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1884520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884549 */     // MIs[0] policy
     /* 1884549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884559 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884586 */     // GIR_Coverage, 14705,
     /* 1884586 */     GIR_EraseRootFromParent_Done,
     /* 1884587 */   // Label 25426: @1884587
     /* 1884587 */   GIM_Try, /*On fail goto*//*Label 25427*/ GIMT_Encode4(1884676), // Rule ID 14708 //
     /* 1884592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1884603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1884606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1884609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884638 */     // MIs[0] policy
     /* 1884638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884648 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884675 */     // GIR_Coverage, 14708,
     /* 1884675 */     GIR_EraseRootFromParent_Done,
     /* 1884676 */   // Label 25427: @1884676
     /* 1884676 */   GIM_Try, /*On fail goto*//*Label 25428*/ GIMT_Encode4(1884765), // Rule ID 14709 //
     /* 1884681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1884692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1884695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1884698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884727 */     // MIs[0] policy
     /* 1884727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884737 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884764 */     // GIR_Coverage, 14709,
     /* 1884764 */     GIR_EraseRootFromParent_Done,
     /* 1884765 */   // Label 25428: @1884765
     /* 1884765 */   GIM_Try, /*On fail goto*//*Label 25429*/ GIMT_Encode4(1884854), // Rule ID 14712 //
     /* 1884770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1884781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1884784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1884787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884816 */     // MIs[0] policy
     /* 1884816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884826 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884853 */     // GIR_Coverage, 14712,
     /* 1884853 */     GIR_EraseRootFromParent_Done,
     /* 1884854 */   // Label 25429: @1884854
     /* 1884854 */   GIM_Try, /*On fail goto*//*Label 25430*/ GIMT_Encode4(1884943), // Rule ID 14713 //
     /* 1884859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1884870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1884873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1884876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884905 */     // MIs[0] policy
     /* 1884905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884915 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884938 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884942 */     // GIR_Coverage, 14713,
     /* 1884942 */     GIR_EraseRootFromParent_Done,
     /* 1884943 */   // Label 25430: @1884943
     /* 1884943 */   GIM_Try, /*On fail goto*//*Label 25431*/ GIMT_Encode4(1885032), // Rule ID 14716 //
     /* 1884948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1884959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1884962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1884965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884994 */     // MIs[0] policy
     /* 1884994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885004 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1885007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885031 */     // GIR_Coverage, 14716,
     /* 1885031 */     GIR_EraseRootFromParent_Done,
     /* 1885032 */   // Label 25431: @1885032
     /* 1885032 */   GIM_Try, /*On fail goto*//*Label 25432*/ GIMT_Encode4(1885121), // Rule ID 14717 //
     /* 1885037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1885048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1885051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1885054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1885060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885083 */     // MIs[0] policy
     /* 1885083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885093 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1885096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885120 */     // GIR_Coverage, 14717,
     /* 1885120 */     GIR_EraseRootFromParent_Done,
     /* 1885121 */   // Label 25432: @1885121
     /* 1885121 */   GIM_Try, /*On fail goto*//*Label 25433*/ GIMT_Encode4(1885210), // Rule ID 14720 //
     /* 1885126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1885129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1885137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1885140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1885143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885172 */     // MIs[0] policy
     /* 1885172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885182 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1885185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1885203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885209 */     // GIR_Coverage, 14720,
     /* 1885209 */     GIR_EraseRootFromParent_Done,
     /* 1885210 */   // Label 25433: @1885210
     /* 1885210 */   GIM_Try, /*On fail goto*//*Label 25434*/ GIMT_Encode4(1885299), // Rule ID 14721 //
     /* 1885215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1885218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1885226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1885229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1885232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885261 */     // MIs[0] policy
     /* 1885261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885271 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1885274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1885292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885298 */     // GIR_Coverage, 14721,
     /* 1885298 */     GIR_EraseRootFromParent_Done,
     /* 1885299 */   // Label 25434: @1885299
     /* 1885299 */   GIM_Try, /*On fail goto*//*Label 25435*/ GIMT_Encode4(1885388), // Rule ID 14724 //
     /* 1885304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1885315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1885318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1885321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1885327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885350 */     // MIs[0] policy
     /* 1885350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885360 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885387 */     // GIR_Coverage, 14724,
     /* 1885387 */     GIR_EraseRootFromParent_Done,
     /* 1885388 */   // Label 25435: @1885388
     /* 1885388 */   GIM_Try, /*On fail goto*//*Label 25436*/ GIMT_Encode4(1885477), // Rule ID 14725 //
     /* 1885393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1885404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1885407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1885410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1885416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885439 */     // MIs[0] policy
     /* 1885439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885449 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885476 */     // GIR_Coverage, 14725,
     /* 1885476 */     GIR_EraseRootFromParent_Done,
     /* 1885477 */   // Label 25436: @1885477
     /* 1885477 */   GIM_Try, /*On fail goto*//*Label 25437*/ GIMT_Encode4(1885566), // Rule ID 14728 //
     /* 1885482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1885493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1885496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1885499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885528 */     // MIs[0] policy
     /* 1885528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885538 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1885541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885565 */     // GIR_Coverage, 14728,
     /* 1885565 */     GIR_EraseRootFromParent_Done,
     /* 1885566 */   // Label 25437: @1885566
     /* 1885566 */   GIM_Try, /*On fail goto*//*Label 25438*/ GIMT_Encode4(1885655), // Rule ID 14729 //
     /* 1885571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1885582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1885585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1885588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885617 */     // MIs[0] policy
     /* 1885617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885627 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1885630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885654 */     // GIR_Coverage, 14729,
     /* 1885654 */     GIR_EraseRootFromParent_Done,
     /* 1885655 */   // Label 25438: @1885655
     /* 1885655 */   GIM_Try, /*On fail goto*//*Label 25439*/ GIMT_Encode4(1885744), // Rule ID 14732 //
     /* 1885660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1885671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1885674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1885677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1885683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885706 */     // MIs[0] policy
     /* 1885706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885716 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1885719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885743 */     // GIR_Coverage, 14732,
     /* 1885743 */     GIR_EraseRootFromParent_Done,
     /* 1885744 */   // Label 25439: @1885744
     /* 1885744 */   GIM_Try, /*On fail goto*//*Label 25440*/ GIMT_Encode4(1885833), // Rule ID 14733 //
     /* 1885749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1885760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1885763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1885766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1885772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885795 */     // MIs[0] policy
     /* 1885795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885805 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1885808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885832 */     // GIR_Coverage, 14733,
     /* 1885832 */     GIR_EraseRootFromParent_Done,
     /* 1885833 */   // Label 25440: @1885833
     /* 1885833 */   GIM_Try, /*On fail goto*//*Label 25441*/ GIMT_Encode4(1885922), // Rule ID 14736 //
     /* 1885838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1885849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1885852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1885855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885884 */     // MIs[0] policy
     /* 1885884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885921 */     // GIR_Coverage, 14736,
     /* 1885921 */     GIR_EraseRootFromParent_Done,
     /* 1885922 */   // Label 25441: @1885922
     /* 1885922 */   GIM_Try, /*On fail goto*//*Label 25442*/ GIMT_Encode4(1886011), // Rule ID 14737 //
     /* 1885927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1885938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1885941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1885944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885973 */     // MIs[0] policy
     /* 1885973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885983 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886010 */     // GIR_Coverage, 14737,
     /* 1886010 */     GIR_EraseRootFromParent_Done,
     /* 1886011 */   // Label 25442: @1886011
     /* 1886011 */   GIM_Try, /*On fail goto*//*Label 25443*/ GIMT_Encode4(1886100), // Rule ID 14740 //
     /* 1886016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1886027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1886030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1886033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886062 */     // MIs[0] policy
     /* 1886062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886072 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886099 */     // GIR_Coverage, 14740,
     /* 1886099 */     GIR_EraseRootFromParent_Done,
     /* 1886100 */   // Label 25443: @1886100
     /* 1886100 */   GIM_Try, /*On fail goto*//*Label 25444*/ GIMT_Encode4(1886189), // Rule ID 14741 //
     /* 1886105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1886116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1886119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1886122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886151 */     // MIs[0] policy
     /* 1886151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886161 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886188 */     // GIR_Coverage, 14741,
     /* 1886188 */     GIR_EraseRootFromParent_Done,
     /* 1886189 */   // Label 25444: @1886189
     /* 1886189 */   GIM_Try, /*On fail goto*//*Label 25445*/ GIMT_Encode4(1886278), // Rule ID 14744 //
     /* 1886194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1886205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1886208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1886211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1886217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886240 */     // MIs[0] policy
     /* 1886240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886250 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886277 */     // GIR_Coverage, 14744,
     /* 1886277 */     GIR_EraseRootFromParent_Done,
     /* 1886278 */   // Label 25445: @1886278
     /* 1886278 */   GIM_Try, /*On fail goto*//*Label 25446*/ GIMT_Encode4(1886367), // Rule ID 14745 //
     /* 1886283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1886294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1886297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1886300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1886306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886329 */     // MIs[0] policy
     /* 1886329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886339 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886366 */     // GIR_Coverage, 14745,
     /* 1886366 */     GIR_EraseRootFromParent_Done,
     /* 1886367 */   // Label 25446: @1886367
     /* 1886367 */   GIM_Try, /*On fail goto*//*Label 25447*/ GIMT_Encode4(1886456), // Rule ID 14748 //
     /* 1886372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1886383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1886386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1886389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886418 */     // MIs[0] policy
     /* 1886418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886428 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1886431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886455 */     // GIR_Coverage, 14748,
     /* 1886455 */     GIR_EraseRootFromParent_Done,
     /* 1886456 */   // Label 25447: @1886456
     /* 1886456 */   GIM_Try, /*On fail goto*//*Label 25448*/ GIMT_Encode4(1886545), // Rule ID 14749 //
     /* 1886461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1886472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1886475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1886478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886507 */     // MIs[0] policy
     /* 1886507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886517 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1886520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886544 */     // GIR_Coverage, 14749,
     /* 1886544 */     GIR_EraseRootFromParent_Done,
     /* 1886545 */   // Label 25448: @1886545
     /* 1886545 */   GIM_Try, /*On fail goto*//*Label 25449*/ GIMT_Encode4(1886634), // Rule ID 14752 //
     /* 1886550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1886561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1886564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1886567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886596 */     // MIs[0] policy
     /* 1886596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886633 */     // GIR_Coverage, 14752,
     /* 1886633 */     GIR_EraseRootFromParent_Done,
     /* 1886634 */   // Label 25449: @1886634
     /* 1886634 */   GIM_Try, /*On fail goto*//*Label 25450*/ GIMT_Encode4(1886723), // Rule ID 14753 //
     /* 1886639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1886650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1886653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1886656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886685 */     // MIs[0] policy
     /* 1886685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886695 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886722 */     // GIR_Coverage, 14753,
     /* 1886722 */     GIR_EraseRootFromParent_Done,
     /* 1886723 */   // Label 25450: @1886723
     /* 1886723 */   GIM_Try, /*On fail goto*//*Label 25451*/ GIMT_Encode4(1886812), // Rule ID 14756 //
     /* 1886728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1886739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1886742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1886745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886774 */     // MIs[0] policy
     /* 1886774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886784 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886811 */     // GIR_Coverage, 14756,
     /* 1886811 */     GIR_EraseRootFromParent_Done,
     /* 1886812 */   // Label 25451: @1886812
     /* 1886812 */   GIM_Try, /*On fail goto*//*Label 25452*/ GIMT_Encode4(1886901), // Rule ID 14757 //
     /* 1886817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1886828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1886831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1886834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886863 */     // MIs[0] policy
     /* 1886863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886873 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886900 */     // GIR_Coverage, 14757,
     /* 1886900 */     GIR_EraseRootFromParent_Done,
     /* 1886901 */   // Label 25452: @1886901
     /* 1886901 */   GIM_Try, /*On fail goto*//*Label 25453*/ GIMT_Encode4(1886990), // Rule ID 14760 //
     /* 1886906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1886909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1886917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1886920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1886923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1886929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886952 */     // MIs[0] policy
     /* 1886952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1886965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886989 */     // GIR_Coverage, 14760,
     /* 1886989 */     GIR_EraseRootFromParent_Done,
     /* 1886990 */   // Label 25453: @1886990
     /* 1886990 */   GIM_Try, /*On fail goto*//*Label 25454*/ GIMT_Encode4(1887079), // Rule ID 14761 //
     /* 1886995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1886998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1887006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1887009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1887012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1887025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887041 */     // MIs[0] policy
     /* 1887041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887051 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1887054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887078 */     // GIR_Coverage, 14761,
     /* 1887078 */     GIR_EraseRootFromParent_Done,
     /* 1887079 */   // Label 25454: @1887079
     /* 1887079 */   GIM_Try, /*On fail goto*//*Label 25455*/ GIMT_Encode4(1887168), // Rule ID 14764 //
     /* 1887084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1887087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1887095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1887098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1887101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887130 */     // MIs[0] policy
     /* 1887130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887140 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1887143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887167 */     // GIR_Coverage, 14764,
     /* 1887167 */     GIR_EraseRootFromParent_Done,
     /* 1887168 */   // Label 25455: @1887168
     /* 1887168 */   GIM_Try, /*On fail goto*//*Label 25456*/ GIMT_Encode4(1887257), // Rule ID 14765 //
     /* 1887173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1887176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1887184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1887187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1887190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887219 */     // MIs[0] policy
     /* 1887219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887229 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1887232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887256 */     // GIR_Coverage, 14765,
     /* 1887256 */     GIR_EraseRootFromParent_Done,
     /* 1887257 */   // Label 25456: @1887257
     /* 1887257 */   GIM_Try, /*On fail goto*//*Label 25457*/ GIMT_Encode4(1887346), // Rule ID 14768 //
     /* 1887262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1887265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1887273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1887276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1887279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1887292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887308 */     // MIs[0] policy
     /* 1887308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887318 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1887321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887345 */     // GIR_Coverage, 14768,
     /* 1887345 */     GIR_EraseRootFromParent_Done,
     /* 1887346 */   // Label 25457: @1887346
     /* 1887346 */   GIM_Try, /*On fail goto*//*Label 25458*/ GIMT_Encode4(1887435), // Rule ID 14769 //
     /* 1887351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1887354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1887362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1887365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1887368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1887381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887397 */     // MIs[0] policy
     /* 1887397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887407 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1887410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887434 */     // GIR_Coverage, 14769,
     /* 1887434 */     GIR_EraseRootFromParent_Done,
     /* 1887435 */   // Label 25458: @1887435
     /* 1887435 */   GIM_Try, /*On fail goto*//*Label 25459*/ GIMT_Encode4(1887524), // Rule ID 14772 //
     /* 1887440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1887451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1887454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1887457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1887460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887486 */     // MIs[0] policy
     /* 1887486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1887499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887523 */     // GIR_Coverage, 14772,
     /* 1887523 */     GIR_EraseRootFromParent_Done,
     /* 1887524 */   // Label 25459: @1887524
     /* 1887524 */   GIM_Try, /*On fail goto*//*Label 25460*/ GIMT_Encode4(1887613), // Rule ID 14773 //
     /* 1887529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1887540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1887543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1887546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1887549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887575 */     // MIs[0] policy
     /* 1887575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887585 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1887588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887612 */     // GIR_Coverage, 14773,
     /* 1887612 */     GIR_EraseRootFromParent_Done,
     /* 1887613 */   // Label 25460: @1887613
     /* 1887613 */   GIM_Try, /*On fail goto*//*Label 25461*/ GIMT_Encode4(1887702), // Rule ID 14776 //
     /* 1887618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1887629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1887632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1887635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1887638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887664 */     // MIs[0] policy
     /* 1887664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887674 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1887677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887701 */     // GIR_Coverage, 14776,
     /* 1887701 */     GIR_EraseRootFromParent_Done,
     /* 1887702 */   // Label 25461: @1887702
     /* 1887702 */   GIM_Try, /*On fail goto*//*Label 25462*/ GIMT_Encode4(1887791), // Rule ID 14777 //
     /* 1887707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1887718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1887721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1887724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1887727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887753 */     // MIs[0] policy
     /* 1887753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887763 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1887766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887790 */     // GIR_Coverage, 14777,
     /* 1887790 */     GIR_EraseRootFromParent_Done,
     /* 1887791 */   // Label 25462: @1887791
     /* 1887791 */   GIM_Try, /*On fail goto*//*Label 25463*/ GIMT_Encode4(1887880), // Rule ID 14780 //
     /* 1887796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1887807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1887810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1887813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1887816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887842 */     // MIs[0] policy
     /* 1887842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887852 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887879 */     // GIR_Coverage, 14780,
     /* 1887879 */     GIR_EraseRootFromParent_Done,
     /* 1887880 */   // Label 25463: @1887880
     /* 1887880 */   GIM_Try, /*On fail goto*//*Label 25464*/ GIMT_Encode4(1887969), // Rule ID 14781 //
     /* 1887885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1887896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1887899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1887902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1887905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887931 */     // MIs[0] policy
     /* 1887931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887941 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887968 */     // GIR_Coverage, 14781,
     /* 1887968 */     GIR_EraseRootFromParent_Done,
     /* 1887969 */   // Label 25464: @1887969
     /* 1887969 */   GIM_Try, /*On fail goto*//*Label 25465*/ GIMT_Encode4(1888058), // Rule ID 14784 //
     /* 1887974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1887985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1887988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1887991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1887994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888020 */     // MIs[0] policy
     /* 1888020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888030 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1888033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888057 */     // GIR_Coverage, 14784,
     /* 1888057 */     GIR_EraseRootFromParent_Done,
     /* 1888058 */   // Label 25465: @1888058
     /* 1888058 */   GIM_Try, /*On fail goto*//*Label 25466*/ GIMT_Encode4(1888147), // Rule ID 14785 //
     /* 1888063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1888074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1888077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1888080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1888083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888109 */     // MIs[0] policy
     /* 1888109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888119 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1888122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888146 */     // GIR_Coverage, 14785,
     /* 1888146 */     GIR_EraseRootFromParent_Done,
     /* 1888147 */   // Label 25466: @1888147
     /* 1888147 */   GIM_Try, /*On fail goto*//*Label 25467*/ GIMT_Encode4(1888236), // Rule ID 14788 //
     /* 1888152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1888163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1888166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1888169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1888172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888198 */     // MIs[0] policy
     /* 1888198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888208 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1888211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888235 */     // GIR_Coverage, 14788,
     /* 1888235 */     GIR_EraseRootFromParent_Done,
     /* 1888236 */   // Label 25467: @1888236
     /* 1888236 */   GIM_Try, /*On fail goto*//*Label 25468*/ GIMT_Encode4(1888325), // Rule ID 14789 //
     /* 1888241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1888252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1888255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1888258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1888261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888287 */     // MIs[0] policy
     /* 1888287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888297 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1888300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888324 */     // GIR_Coverage, 14789,
     /* 1888324 */     GIR_EraseRootFromParent_Done,
     /* 1888325 */   // Label 25468: @1888325
     /* 1888325 */   GIM_Try, /*On fail goto*//*Label 25469*/ GIMT_Encode4(1888414), // Rule ID 14792 //
     /* 1888330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1888341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1888344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1888347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1888350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888376 */     // MIs[0] policy
     /* 1888376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1888389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888413 */     // GIR_Coverage, 14792,
     /* 1888413 */     GIR_EraseRootFromParent_Done,
     /* 1888414 */   // Label 25469: @1888414
     /* 1888414 */   GIM_Try, /*On fail goto*//*Label 25470*/ GIMT_Encode4(1888503), // Rule ID 14793 //
     /* 1888419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1888430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1888433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1888436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1888439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888465 */     // MIs[0] policy
     /* 1888465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888475 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1888478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888502 */     // GIR_Coverage, 14793,
     /* 1888502 */     GIR_EraseRootFromParent_Done,
     /* 1888503 */   // Label 25470: @1888503
     /* 1888503 */   GIM_Try, /*On fail goto*//*Label 25471*/ GIMT_Encode4(1888592), // Rule ID 14796 //
     /* 1888508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1888519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1888522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1888525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1888528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888554 */     // MIs[0] policy
     /* 1888554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888564 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888591 */     // GIR_Coverage, 14796,
     /* 1888591 */     GIR_EraseRootFromParent_Done,
     /* 1888592 */   // Label 25471: @1888592
     /* 1888592 */   GIM_Try, /*On fail goto*//*Label 25472*/ GIMT_Encode4(1888681), // Rule ID 14797 //
     /* 1888597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1888608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1888611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1888614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1888617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888643 */     // MIs[0] policy
     /* 1888643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888653 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888680 */     // GIR_Coverage, 14797,
     /* 1888680 */     GIR_EraseRootFromParent_Done,
     /* 1888681 */   // Label 25472: @1888681
     /* 1888681 */   GIM_Try, /*On fail goto*//*Label 25473*/ GIMT_Encode4(1888770), // Rule ID 14800 //
     /* 1888686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1888706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888732 */     // MIs[0] policy
     /* 1888732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888742 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888769 */     // GIR_Coverage, 14800,
     /* 1888769 */     GIR_EraseRootFromParent_Done,
     /* 1888770 */   // Label 25473: @1888770
     /* 1888770 */   GIM_Try, /*On fail goto*//*Label 25474*/ GIMT_Encode4(1888859), // Rule ID 14801 //
     /* 1888775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1888795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888821 */     // MIs[0] policy
     /* 1888821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888831 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888858 */     // GIR_Coverage, 14801,
     /* 1888858 */     GIR_EraseRootFromParent_Done,
     /* 1888859 */   // Label 25474: @1888859
     /* 1888859 */   GIM_Try, /*On fail goto*//*Label 25475*/ GIMT_Encode4(1888948), // Rule ID 14804 //
     /* 1888864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1888878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1888881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1888884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888910 */     // MIs[0] policy
     /* 1888910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888920 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888947 */     // GIR_Coverage, 14804,
     /* 1888947 */     GIR_EraseRootFromParent_Done,
     /* 1888948 */   // Label 25475: @1888948
     /* 1888948 */   GIM_Try, /*On fail goto*//*Label 25476*/ GIMT_Encode4(1889037), // Rule ID 14805 //
     /* 1888953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1888967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1888970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1888973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888999 */     // MIs[0] policy
     /* 1888999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889009 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1889012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889036 */     // GIR_Coverage, 14805,
     /* 1889036 */     GIR_EraseRootFromParent_Done,
     /* 1889037 */   // Label 25476: @1889037
     /* 1889037 */   GIM_Try, /*On fail goto*//*Label 25477*/ GIMT_Encode4(1889126), // Rule ID 14808 //
     /* 1889042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1889045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1889053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1889056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1889059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1889062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1889065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889088 */     // MIs[0] policy
     /* 1889088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889098 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1889101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1889119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889121 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889125 */     // GIR_Coverage, 14808,
     /* 1889125 */     GIR_EraseRootFromParent_Done,
     /* 1889126 */   // Label 25477: @1889126
     /* 1889126 */   GIM_Try, /*On fail goto*//*Label 25478*/ GIMT_Encode4(1889215), // Rule ID 14809 //
     /* 1889131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1889134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1889142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1889145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1889148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1889151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1889154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889177 */     // MIs[0] policy
     /* 1889177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889187 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1889190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1889208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889214 */     // GIR_Coverage, 14809,
     /* 1889214 */     GIR_EraseRootFromParent_Done,
     /* 1889215 */   // Label 25478: @1889215
     /* 1889215 */   GIM_Try, /*On fail goto*//*Label 25479*/ GIMT_Encode4(1889304), // Rule ID 14812 //
     /* 1889220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1889231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1889234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1889237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1889240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889266 */     // MIs[0] policy
     /* 1889266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889276 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889303 */     // GIR_Coverage, 14812,
     /* 1889303 */     GIR_EraseRootFromParent_Done,
     /* 1889304 */   // Label 25479: @1889304
     /* 1889304 */   GIM_Try, /*On fail goto*//*Label 25480*/ GIMT_Encode4(1889393), // Rule ID 14813 //
     /* 1889309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1889320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1889323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1889326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1889329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889355 */     // MIs[0] policy
     /* 1889355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889365 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889392 */     // GIR_Coverage, 14813,
     /* 1889392 */     GIR_EraseRootFromParent_Done,
     /* 1889393 */   // Label 25480: @1889393
     /* 1889393 */   GIM_Try, /*On fail goto*//*Label 25481*/ GIMT_Encode4(1889482), // Rule ID 14816 //
     /* 1889398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1889409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1889412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1889415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1889418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889444 */     // MIs[0] policy
     /* 1889444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889454 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1889457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889481 */     // GIR_Coverage, 14816,
     /* 1889481 */     GIR_EraseRootFromParent_Done,
     /* 1889482 */   // Label 25481: @1889482
     /* 1889482 */   GIM_Try, /*On fail goto*//*Label 25482*/ GIMT_Encode4(1889571), // Rule ID 14817 //
     /* 1889487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1889498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1889501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1889504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1889507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889533 */     // MIs[0] policy
     /* 1889533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889543 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1889546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889570 */     // GIR_Coverage, 14817,
     /* 1889570 */     GIR_EraseRootFromParent_Done,
     /* 1889571 */   // Label 25482: @1889571
     /* 1889571 */   GIM_Try, /*On fail goto*//*Label 25483*/ GIMT_Encode4(1889660), // Rule ID 14820 //
     /* 1889576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1889587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1889590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1889593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1889596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1889599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889622 */     // MIs[0] policy
     /* 1889622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889632 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1889635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889659 */     // GIR_Coverage, 14820,
     /* 1889659 */     GIR_EraseRootFromParent_Done,
     /* 1889660 */   // Label 25483: @1889660
     /* 1889660 */   GIM_Try, /*On fail goto*//*Label 25484*/ GIMT_Encode4(1889749), // Rule ID 14821 //
     /* 1889665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1889676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1889679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1889682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1889685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1889688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889711 */     // MIs[0] policy
     /* 1889711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889721 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1889724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889748 */     // GIR_Coverage, 14821,
     /* 1889748 */     GIR_EraseRootFromParent_Done,
     /* 1889749 */   // Label 25484: @1889749
     /* 1889749 */   GIM_Try, /*On fail goto*//*Label 25485*/ GIMT_Encode4(1889838), // Rule ID 14824 //
     /* 1889754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1889774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889800 */     // MIs[0] policy
     /* 1889800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889810 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889837 */     // GIR_Coverage, 14824,
     /* 1889837 */     GIR_EraseRootFromParent_Done,
     /* 1889838 */   // Label 25485: @1889838
     /* 1889838 */   GIM_Try, /*On fail goto*//*Label 25486*/ GIMT_Encode4(1889927), // Rule ID 14825 //
     /* 1889843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1889863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889889 */     // MIs[0] policy
     /* 1889889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889899 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889926 */     // GIR_Coverage, 14825,
     /* 1889926 */     GIR_EraseRootFromParent_Done,
     /* 1889927 */   // Label 25486: @1889927
     /* 1889927 */   GIM_Try, /*On fail goto*//*Label 25487*/ GIMT_Encode4(1890016), // Rule ID 14828 //
     /* 1889932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1889943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1889946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1889949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1889952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889978 */     // MIs[0] policy
     /* 1889978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889988 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1889991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890015 */     // GIR_Coverage, 14828,
     /* 1890015 */     GIR_EraseRootFromParent_Done,
     /* 1890016 */   // Label 25487: @1890016
     /* 1890016 */   GIM_Try, /*On fail goto*//*Label 25488*/ GIMT_Encode4(1890105), // Rule ID 14829 //
     /* 1890021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1890032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1890035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1890038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1890041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890067 */     // MIs[0] policy
     /* 1890067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890077 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890104 */     // GIR_Coverage, 14829,
     /* 1890104 */     GIR_EraseRootFromParent_Done,
     /* 1890105 */   // Label 25488: @1890105
     /* 1890105 */   GIM_Try, /*On fail goto*//*Label 25489*/ GIMT_Encode4(1890194), // Rule ID 14832 //
     /* 1890110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1890121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1890124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1890127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1890130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1890133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890156 */     // MIs[0] policy
     /* 1890156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890166 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890193 */     // GIR_Coverage, 14832,
     /* 1890193 */     GIR_EraseRootFromParent_Done,
     /* 1890194 */   // Label 25489: @1890194
     /* 1890194 */   GIM_Try, /*On fail goto*//*Label 25490*/ GIMT_Encode4(1890283), // Rule ID 14833 //
     /* 1890199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1890210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1890213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1890216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1890219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1890222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890245 */     // MIs[0] policy
     /* 1890245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890255 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890282 */     // GIR_Coverage, 14833,
     /* 1890282 */     GIR_EraseRootFromParent_Done,
     /* 1890283 */   // Label 25490: @1890283
     /* 1890283 */   GIM_Try, /*On fail goto*//*Label 25491*/ GIMT_Encode4(1890372), // Rule ID 14836 //
     /* 1890288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1890299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1890302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1890305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1890308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890334 */     // MIs[0] policy
     /* 1890334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1890347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890371 */     // GIR_Coverage, 14836,
     /* 1890371 */     GIR_EraseRootFromParent_Done,
     /* 1890372 */   // Label 25491: @1890372
     /* 1890372 */   GIM_Try, /*On fail goto*//*Label 25492*/ GIMT_Encode4(1890461), // Rule ID 14837 //
     /* 1890377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1890388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1890391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1890394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1890397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890423 */     // MIs[0] policy
     /* 1890423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1890436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890460 */     // GIR_Coverage, 14837,
     /* 1890460 */     GIR_EraseRootFromParent_Done,
     /* 1890461 */   // Label 25492: @1890461
     /* 1890461 */   GIM_Try, /*On fail goto*//*Label 25493*/ GIMT_Encode4(1890550), // Rule ID 14840 //
     /* 1890466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1890477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1890480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1890483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1890486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890512 */     // MIs[0] policy
     /* 1890512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890522 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890549 */     // GIR_Coverage, 14840,
     /* 1890549 */     GIR_EraseRootFromParent_Done,
     /* 1890550 */   // Label 25493: @1890550
     /* 1890550 */   GIM_Try, /*On fail goto*//*Label 25494*/ GIMT_Encode4(1890639), // Rule ID 14841 //
     /* 1890555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1890566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1890569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1890572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1890575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890601 */     // MIs[0] policy
     /* 1890601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890611 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890638 */     // GIR_Coverage, 14841,
     /* 1890638 */     GIR_EraseRootFromParent_Done,
     /* 1890639 */   // Label 25494: @1890639
     /* 1890639 */   GIM_Try, /*On fail goto*//*Label 25495*/ GIMT_Encode4(1890728), // Rule ID 14844 //
     /* 1890644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1890664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890690 */     // MIs[0] policy
     /* 1890690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890700 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890727 */     // GIR_Coverage, 14844,
     /* 1890727 */     GIR_EraseRootFromParent_Done,
     /* 1890728 */   // Label 25495: @1890728
     /* 1890728 */   GIM_Try, /*On fail goto*//*Label 25496*/ GIMT_Encode4(1890817), // Rule ID 14845 //
     /* 1890733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1890753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890779 */     // MIs[0] policy
     /* 1890779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890789 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890816 */     // GIR_Coverage, 14845,
     /* 1890816 */     GIR_EraseRootFromParent_Done,
     /* 1890817 */   // Label 25496: @1890817
     /* 1890817 */   GIM_Try, /*On fail goto*//*Label 25497*/ GIMT_Encode4(1890906), // Rule ID 14848 //
     /* 1890822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1890842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890868 */     // MIs[0] policy
     /* 1890868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1890881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890905 */     // GIR_Coverage, 14848,
     /* 1890905 */     GIR_EraseRootFromParent_Done,
     /* 1890906 */   // Label 25497: @1890906
     /* 1890906 */   GIM_Try, /*On fail goto*//*Label 25498*/ GIMT_Encode4(1890995), // Rule ID 14849 //
     /* 1890911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1890914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1890931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890957 */     // MIs[0] policy
     /* 1890957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890967 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1890970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890994 */     // GIR_Coverage, 14849,
     /* 1890994 */     GIR_EraseRootFromParent_Done,
     /* 1890995 */   // Label 25498: @1890995
     /* 1890995 */   GIM_Try, /*On fail goto*//*Label 25499*/ GIMT_Encode4(1891084), // Rule ID 14852 //
     /* 1891000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1891003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1891011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1891014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1891017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1891020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1891030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891046 */     // MIs[0] policy
     /* 1891046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891056 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1891059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891083 */     // GIR_Coverage, 14852,
     /* 1891083 */     GIR_EraseRootFromParent_Done,
     /* 1891084 */   // Label 25499: @1891084
     /* 1891084 */   GIM_Try, /*On fail goto*//*Label 25500*/ GIMT_Encode4(1891173), // Rule ID 14853 //
     /* 1891089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1891092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1891100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1891103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1891106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1891109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1891119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891135 */     // MIs[0] policy
     /* 1891135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891145 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1891148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891172 */     // GIR_Coverage, 14853,
     /* 1891172 */     GIR_EraseRootFromParent_Done,
     /* 1891173 */   // Label 25500: @1891173
     /* 1891173 */   GIM_Try, /*On fail goto*//*Label 25501*/ GIMT_Encode4(1891262), // Rule ID 14856 //
     /* 1891178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1891181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1891189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1891192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1891195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1891198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1891208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891224 */     // MIs[0] policy
     /* 1891224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891234 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1891237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891261 */     // GIR_Coverage, 14856,
     /* 1891261 */     GIR_EraseRootFromParent_Done,
     /* 1891262 */   // Label 25501: @1891262
     /* 1891262 */   GIM_Try, /*On fail goto*//*Label 25502*/ GIMT_Encode4(1891351), // Rule ID 14857 //
     /* 1891267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1891270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1891278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1891281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1891284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1891287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1891297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891313 */     // MIs[0] policy
     /* 1891313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891323 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1891326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891350 */     // GIR_Coverage, 14857,
     /* 1891350 */     GIR_EraseRootFromParent_Done,
     /* 1891351 */   // Label 25502: @1891351
     /* 1891351 */   GIM_Try, /*On fail goto*//*Label 25503*/ GIMT_Encode4(1891440), // Rule ID 14860 //
     /* 1891356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1891367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1891370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1891373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891402 */     // MIs[0] policy
     /* 1891402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891412 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1891415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891439 */     // GIR_Coverage, 14860,
     /* 1891439 */     GIR_EraseRootFromParent_Done,
     /* 1891440 */   // Label 25503: @1891440
     /* 1891440 */   GIM_Try, /*On fail goto*//*Label 25504*/ GIMT_Encode4(1891529), // Rule ID 14861 //
     /* 1891445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1891456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1891459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1891462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891491 */     // MIs[0] policy
     /* 1891491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891501 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1891504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891528 */     // GIR_Coverage, 14861,
     /* 1891528 */     GIR_EraseRootFromParent_Done,
     /* 1891529 */   // Label 25504: @1891529
     /* 1891529 */   GIM_Try, /*On fail goto*//*Label 25505*/ GIMT_Encode4(1891618), // Rule ID 14864 //
     /* 1891534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1891545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1891548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1891551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891580 */     // MIs[0] policy
     /* 1891580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891590 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891617 */     // GIR_Coverage, 14864,
     /* 1891617 */     GIR_EraseRootFromParent_Done,
     /* 1891618 */   // Label 25505: @1891618
     /* 1891618 */   GIM_Try, /*On fail goto*//*Label 25506*/ GIMT_Encode4(1891707), // Rule ID 14865 //
     /* 1891623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1891634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1891637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1891640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891669 */     // MIs[0] policy
     /* 1891669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891679 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891706 */     // GIR_Coverage, 14865,
     /* 1891706 */     GIR_EraseRootFromParent_Done,
     /* 1891707 */   // Label 25506: @1891707
     /* 1891707 */   GIM_Try, /*On fail goto*//*Label 25507*/ GIMT_Encode4(1891796), // Rule ID 14868 //
     /* 1891712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1891723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1891726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1891729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891758 */     // MIs[0] policy
     /* 1891758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891768 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891795 */     // GIR_Coverage, 14868,
     /* 1891795 */     GIR_EraseRootFromParent_Done,
     /* 1891796 */   // Label 25507: @1891796
     /* 1891796 */   GIM_Try, /*On fail goto*//*Label 25508*/ GIMT_Encode4(1891885), // Rule ID 14869 //
     /* 1891801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1891812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1891815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1891818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891847 */     // MIs[0] policy
     /* 1891847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891857 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891884 */     // GIR_Coverage, 14869,
     /* 1891884 */     GIR_EraseRootFromParent_Done,
     /* 1891885 */   // Label 25508: @1891885
     /* 1891885 */   GIM_Try, /*On fail goto*//*Label 25509*/ GIMT_Encode4(1891974), // Rule ID 14872 //
     /* 1891890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1891901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1891904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1891907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891936 */     // MIs[0] policy
     /* 1891936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891973 */     // GIR_Coverage, 14872,
     /* 1891973 */     GIR_EraseRootFromParent_Done,
     /* 1891974 */   // Label 25509: @1891974
     /* 1891974 */   GIM_Try, /*On fail goto*//*Label 25510*/ GIMT_Encode4(1892063), // Rule ID 14873 //
     /* 1891979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1891990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1891993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1891996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892025 */     // MIs[0] policy
     /* 1892025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892035 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1892038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892062 */     // GIR_Coverage, 14873,
     /* 1892062 */     GIR_EraseRootFromParent_Done,
     /* 1892063 */   // Label 25510: @1892063
     /* 1892063 */   GIM_Try, /*On fail goto*//*Label 25511*/ GIMT_Encode4(1892152), // Rule ID 14876 //
     /* 1892068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1892079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1892082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1892085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892114 */     // MIs[0] policy
     /* 1892114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892124 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1892127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892151 */     // GIR_Coverage, 14876,
     /* 1892151 */     GIR_EraseRootFromParent_Done,
     /* 1892152 */   // Label 25511: @1892152
     /* 1892152 */   GIM_Try, /*On fail goto*//*Label 25512*/ GIMT_Encode4(1892241), // Rule ID 14877 //
     /* 1892157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1892168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1892171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1892174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892203 */     // MIs[0] policy
     /* 1892203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892213 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1892216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892240 */     // GIR_Coverage, 14877,
     /* 1892240 */     GIR_EraseRootFromParent_Done,
     /* 1892241 */   // Label 25512: @1892241
     /* 1892241 */   GIM_Try, /*On fail goto*//*Label 25513*/ GIMT_Encode4(1892330), // Rule ID 14880 //
     /* 1892246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1892257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1892260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1892263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892292 */     // MIs[0] policy
     /* 1892292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892302 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1892305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892329 */     // GIR_Coverage, 14880,
     /* 1892329 */     GIR_EraseRootFromParent_Done,
     /* 1892330 */   // Label 25513: @1892330
     /* 1892330 */   GIM_Try, /*On fail goto*//*Label 25514*/ GIMT_Encode4(1892419), // Rule ID 14881 //
     /* 1892335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1892346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1892349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1892352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892381 */     // MIs[0] policy
     /* 1892381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892391 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1892394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892418 */     // GIR_Coverage, 14881,
     /* 1892418 */     GIR_EraseRootFromParent_Done,
     /* 1892419 */   // Label 25514: @1892419
     /* 1892419 */   GIM_Try, /*On fail goto*//*Label 25515*/ GIMT_Encode4(1892508), // Rule ID 14884 //
     /* 1892424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1892435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1892438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1892441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1892447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892470 */     // MIs[0] policy
     /* 1892470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892480 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892507 */     // GIR_Coverage, 14884,
     /* 1892507 */     GIR_EraseRootFromParent_Done,
     /* 1892508 */   // Label 25515: @1892508
     /* 1892508 */   GIM_Try, /*On fail goto*//*Label 25516*/ GIMT_Encode4(1892597), // Rule ID 14885 //
     /* 1892513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1892524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1892527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1892530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1892536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892559 */     // MIs[0] policy
     /* 1892559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892569 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892596 */     // GIR_Coverage, 14885,
     /* 1892596 */     GIR_EraseRootFromParent_Done,
     /* 1892597 */   // Label 25516: @1892597
     /* 1892597 */   GIM_Try, /*On fail goto*//*Label 25517*/ GIMT_Encode4(1892686), // Rule ID 14888 //
     /* 1892602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1892613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1892616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1892619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892648 */     // MIs[0] policy
     /* 1892648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892658 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892685 */     // GIR_Coverage, 14888,
     /* 1892685 */     GIR_EraseRootFromParent_Done,
     /* 1892686 */   // Label 25517: @1892686
     /* 1892686 */   GIM_Try, /*On fail goto*//*Label 25518*/ GIMT_Encode4(1892775), // Rule ID 14889 //
     /* 1892691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1892702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1892705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1892708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892737 */     // MIs[0] policy
     /* 1892737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892747 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892774 */     // GIR_Coverage, 14889,
     /* 1892774 */     GIR_EraseRootFromParent_Done,
     /* 1892775 */   // Label 25518: @1892775
     /* 1892775 */   GIM_Try, /*On fail goto*//*Label 25519*/ GIMT_Encode4(1892864), // Rule ID 14892 //
     /* 1892780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1892791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1892794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1892797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892826 */     // MIs[0] policy
     /* 1892826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892836 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892863 */     // GIR_Coverage, 14892,
     /* 1892863 */     GIR_EraseRootFromParent_Done,
     /* 1892864 */   // Label 25519: @1892864
     /* 1892864 */   GIM_Try, /*On fail goto*//*Label 25520*/ GIMT_Encode4(1892953), // Rule ID 14893 //
     /* 1892869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1892880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1892883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1892886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892915 */     // MIs[0] policy
     /* 1892915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892925 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892952 */     // GIR_Coverage, 14893,
     /* 1892952 */     GIR_EraseRootFromParent_Done,
     /* 1892953 */   // Label 25520: @1892953
     /* 1892953 */   GIM_Try, /*On fail goto*//*Label 25521*/ GIMT_Encode4(1893042), // Rule ID 14896 //
     /* 1892958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1892961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1892969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1892972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1892975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893004 */     // MIs[0] policy
     /* 1893004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1893017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1893035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893041 */     // GIR_Coverage, 14896,
     /* 1893041 */     GIR_EraseRootFromParent_Done,
     /* 1893042 */   // Label 25521: @1893042
     /* 1893042 */   GIM_Try, /*On fail goto*//*Label 25522*/ GIMT_Encode4(1893131), // Rule ID 14897 //
     /* 1893047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1893050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1893058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1893061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1893064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1893070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893093 */     // MIs[0] policy
     /* 1893093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893103 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1893106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1893124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893130 */     // GIR_Coverage, 14897,
     /* 1893130 */     GIR_EraseRootFromParent_Done,
     /* 1893131 */   // Label 25522: @1893131
     /* 1893131 */   GIM_Try, /*On fail goto*//*Label 25523*/ GIMT_Encode4(1893220), // Rule ID 14900 //
     /* 1893136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1893147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1893150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1893153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893182 */     // MIs[0] policy
     /* 1893182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893192 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893219 */     // GIR_Coverage, 14900,
     /* 1893219 */     GIR_EraseRootFromParent_Done,
     /* 1893220 */   // Label 25523: @1893220
     /* 1893220 */   GIM_Try, /*On fail goto*//*Label 25524*/ GIMT_Encode4(1893309), // Rule ID 14901 //
     /* 1893225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1893236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1893239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1893242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893271 */     // MIs[0] policy
     /* 1893271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893281 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893308 */     // GIR_Coverage, 14901,
     /* 1893308 */     GIR_EraseRootFromParent_Done,
     /* 1893309 */   // Label 25524: @1893309
     /* 1893309 */   GIM_Try, /*On fail goto*//*Label 25525*/ GIMT_Encode4(1893398), // Rule ID 14904 //
     /* 1893314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1893325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1893328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1893331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893360 */     // MIs[0] policy
     /* 1893360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893370 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893397 */     // GIR_Coverage, 14904,
     /* 1893397 */     GIR_EraseRootFromParent_Done,
     /* 1893398 */   // Label 25525: @1893398
     /* 1893398 */   GIM_Try, /*On fail goto*//*Label 25526*/ GIMT_Encode4(1893487), // Rule ID 14905 //
     /* 1893403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1893414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1893417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1893420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893449 */     // MIs[0] policy
     /* 1893449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893459 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893486 */     // GIR_Coverage, 14905,
     /* 1893486 */     GIR_EraseRootFromParent_Done,
     /* 1893487 */   // Label 25526: @1893487
     /* 1893487 */   GIM_Try, /*On fail goto*//*Label 25527*/ GIMT_Encode4(1893576), // Rule ID 14908 //
     /* 1893492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1893503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1893506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1893509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1893515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893538 */     // MIs[0] policy
     /* 1893538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893548 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1893551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893575 */     // GIR_Coverage, 14908,
     /* 1893575 */     GIR_EraseRootFromParent_Done,
     /* 1893576 */   // Label 25527: @1893576
     /* 1893576 */   GIM_Try, /*On fail goto*//*Label 25528*/ GIMT_Encode4(1893665), // Rule ID 14909 //
     /* 1893581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1893592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1893595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1893598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1893604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893627 */     // MIs[0] policy
     /* 1893627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893637 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1893640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893664 */     // GIR_Coverage, 14909,
     /* 1893664 */     GIR_EraseRootFromParent_Done,
     /* 1893665 */   // Label 25528: @1893665
     /* 1893665 */   GIM_Try, /*On fail goto*//*Label 25529*/ GIMT_Encode4(1893754), // Rule ID 14912 //
     /* 1893670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893716 */     // MIs[0] policy
     /* 1893716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893753 */     // GIR_Coverage, 14912,
     /* 1893753 */     GIR_EraseRootFromParent_Done,
     /* 1893754 */   // Label 25529: @1893754
     /* 1893754 */   GIM_Try, /*On fail goto*//*Label 25530*/ GIMT_Encode4(1893843), // Rule ID 14913 //
     /* 1893759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893805 */     // MIs[0] policy
     /* 1893805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893815 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893842 */     // GIR_Coverage, 14913,
     /* 1893842 */     GIR_EraseRootFromParent_Done,
     /* 1893843 */   // Label 25530: @1893843
     /* 1893843 */   GIM_Try, /*On fail goto*//*Label 25531*/ GIMT_Encode4(1893932), // Rule ID 14916 //
     /* 1893848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893894 */     // MIs[0] policy
     /* 1893894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893904 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893931 */     // GIR_Coverage, 14916,
     /* 1893931 */     GIR_EraseRootFromParent_Done,
     /* 1893932 */   // Label 25531: @1893932
     /* 1893932 */   GIM_Try, /*On fail goto*//*Label 25532*/ GIMT_Encode4(1894021), // Rule ID 14917 //
     /* 1893937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893983 */     // MIs[0] policy
     /* 1893983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893993 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894020 */     // GIR_Coverage, 14917,
     /* 1894020 */     GIR_EraseRootFromParent_Done,
     /* 1894021 */   // Label 25532: @1894021
     /* 1894021 */   GIM_Try, /*On fail goto*//*Label 25533*/ GIMT_Encode4(1894110), // Rule ID 14920 //
     /* 1894026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1894037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1894040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1894043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1894049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894072 */     // MIs[0] policy
     /* 1894072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894082 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894109 */     // GIR_Coverage, 14920,
     /* 1894109 */     GIR_EraseRootFromParent_Done,
     /* 1894110 */   // Label 25533: @1894110
     /* 1894110 */   GIM_Try, /*On fail goto*//*Label 25534*/ GIMT_Encode4(1894199), // Rule ID 14921 //
     /* 1894115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1894126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1894129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1894132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1894138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894161 */     // MIs[0] policy
     /* 1894161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894171 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894198 */     // GIR_Coverage, 14921,
     /* 1894198 */     GIR_EraseRootFromParent_Done,
     /* 1894199 */   // Label 25534: @1894199
     /* 1894199 */   GIM_Try, /*On fail goto*//*Label 25535*/ GIMT_Encode4(1894288), // Rule ID 14924 //
     /* 1894204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1894215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1894218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1894221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894250 */     // MIs[0] policy
     /* 1894250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1894263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894287 */     // GIR_Coverage, 14924,
     /* 1894287 */     GIR_EraseRootFromParent_Done,
     /* 1894288 */   // Label 25535: @1894288
     /* 1894288 */   GIM_Try, /*On fail goto*//*Label 25536*/ GIMT_Encode4(1894377), // Rule ID 14925 //
     /* 1894293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1894304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1894307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1894310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894339 */     // MIs[0] policy
     /* 1894339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894349 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1894352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894376 */     // GIR_Coverage, 14925,
     /* 1894376 */     GIR_EraseRootFromParent_Done,
     /* 1894377 */   // Label 25536: @1894377
     /* 1894377 */   GIM_Try, /*On fail goto*//*Label 25537*/ GIMT_Encode4(1894466), // Rule ID 14928 //
     /* 1894382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1894393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1894396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1894399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894428 */     // MIs[0] policy
     /* 1894428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894438 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1894441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894465 */     // GIR_Coverage, 14928,
     /* 1894465 */     GIR_EraseRootFromParent_Done,
     /* 1894466 */   // Label 25537: @1894466
     /* 1894466 */   GIM_Try, /*On fail goto*//*Label 25538*/ GIMT_Encode4(1894555), // Rule ID 14929 //
     /* 1894471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1894482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1894485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1894488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894517 */     // MIs[0] policy
     /* 1894517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894527 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1894530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894554 */     // GIR_Coverage, 14929,
     /* 1894554 */     GIR_EraseRootFromParent_Done,
     /* 1894555 */   // Label 25538: @1894555
     /* 1894555 */   GIM_Try, /*On fail goto*//*Label 25539*/ GIMT_Encode4(1894644), // Rule ID 14932 //
     /* 1894560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894606 */     // MIs[0] policy
     /* 1894606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894616 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894643 */     // GIR_Coverage, 14932,
     /* 1894643 */     GIR_EraseRootFromParent_Done,
     /* 1894644 */   // Label 25539: @1894644
     /* 1894644 */   GIM_Try, /*On fail goto*//*Label 25540*/ GIMT_Encode4(1894733), // Rule ID 14933 //
     /* 1894649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894695 */     // MIs[0] policy
     /* 1894695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894705 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894732 */     // GIR_Coverage, 14933,
     /* 1894732 */     GIR_EraseRootFromParent_Done,
     /* 1894733 */   // Label 25540: @1894733
     /* 1894733 */   GIM_Try, /*On fail goto*//*Label 25541*/ GIMT_Encode4(1894822), // Rule ID 14936 //
     /* 1894738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894784 */     // MIs[0] policy
     /* 1894784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894794 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1894797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894821 */     // GIR_Coverage, 14936,
     /* 1894821 */     GIR_EraseRootFromParent_Done,
     /* 1894822 */   // Label 25541: @1894822
     /* 1894822 */   GIM_Try, /*On fail goto*//*Label 25542*/ GIMT_Encode4(1894911), // Rule ID 14937 //
     /* 1894827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1894830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894873 */     // MIs[0] policy
     /* 1894873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894883 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1894886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894910 */     // GIR_Coverage, 14937,
     /* 1894910 */     GIR_EraseRootFromParent_Done,
     /* 1894911 */   // Label 25542: @1894911
     /* 1894911 */   GIM_Try, /*On fail goto*//*Label 25543*/ GIMT_Encode4(1895000), // Rule ID 14940 //
     /* 1894916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1894927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1894930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1894933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894962 */     // MIs[0] policy
     /* 1894962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894972 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1894975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894999 */     // GIR_Coverage, 14940,
     /* 1894999 */     GIR_EraseRootFromParent_Done,
     /* 1895000 */   // Label 25543: @1895000
     /* 1895000 */   GIM_Try, /*On fail goto*//*Label 25544*/ GIMT_Encode4(1895089), // Rule ID 14941 //
     /* 1895005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1895008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1895016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1895019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1895022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1895035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895051 */     // MIs[0] policy
     /* 1895051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895061 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1895064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895088 */     // GIR_Coverage, 14941,
     /* 1895088 */     GIR_EraseRootFromParent_Done,
     /* 1895089 */   // Label 25544: @1895089
     /* 1895089 */   GIM_Try, /*On fail goto*//*Label 25545*/ GIMT_Encode4(1895178), // Rule ID 14944 //
     /* 1895094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1895097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1895105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1895108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1895111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1895114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895140 */     // MIs[0] policy
     /* 1895140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895150 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1895153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895177 */     // GIR_Coverage, 14944,
     /* 1895177 */     GIR_EraseRootFromParent_Done,
     /* 1895178 */   // Label 25545: @1895178
     /* 1895178 */   GIM_Try, /*On fail goto*//*Label 25546*/ GIMT_Encode4(1895267), // Rule ID 14945 //
     /* 1895183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1895186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1895194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1895197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1895200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895229 */     // MIs[0] policy
     /* 1895229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895239 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1895242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895266 */     // GIR_Coverage, 14945,
     /* 1895266 */     GIR_EraseRootFromParent_Done,
     /* 1895267 */   // Label 25546: @1895267
     /* 1895267 */   GIM_Try, /*On fail goto*//*Label 25547*/ GIMT_Encode4(1895353), // Rule ID 19186 //
     /* 1895272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1895283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1895286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1895289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1895292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895318 */     // MIs[0] policy
     /* 1895318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895328 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1895331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895352 */     // GIR_Coverage, 19186,
     /* 1895352 */     GIR_EraseRootFromParent_Done,
     /* 1895353 */   // Label 25547: @1895353
     /* 1895353 */   GIM_Try, /*On fail goto*//*Label 25548*/ GIMT_Encode4(1895439), // Rule ID 19187 //
     /* 1895358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1895369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1895372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1895375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1895378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895404 */     // MIs[0] policy
     /* 1895404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895414 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1895417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895438 */     // GIR_Coverage, 19187,
     /* 1895438 */     GIR_EraseRootFromParent_Done,
     /* 1895439 */   // Label 25548: @1895439
     /* 1895439 */   GIM_Try, /*On fail goto*//*Label 25549*/ GIMT_Encode4(1895525), // Rule ID 19190 //
     /* 1895444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1895455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1895458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1895461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1895464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895490 */     // MIs[0] policy
     /* 1895490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895500 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1895503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895524 */     // GIR_Coverage, 19190,
     /* 1895524 */     GIR_EraseRootFromParent_Done,
     /* 1895525 */   // Label 25549: @1895525
     /* 1895525 */   GIM_Try, /*On fail goto*//*Label 25550*/ GIMT_Encode4(1895611), // Rule ID 19191 //
     /* 1895530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1895541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1895544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1895547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1895550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895576 */     // MIs[0] policy
     /* 1895576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895586 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1895589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895610 */     // GIR_Coverage, 19191,
     /* 1895610 */     GIR_EraseRootFromParent_Done,
     /* 1895611 */   // Label 25550: @1895611
     /* 1895611 */   GIM_Try, /*On fail goto*//*Label 25551*/ GIMT_Encode4(1895697), // Rule ID 19194 //
     /* 1895616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1895619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1895633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1895636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895662 */     // MIs[0] policy
     /* 1895662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895672 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1895675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895696 */     // GIR_Coverage, 19194,
     /* 1895696 */     GIR_EraseRootFromParent_Done,
     /* 1895697 */   // Label 25551: @1895697
     /* 1895697 */   GIM_Try, /*On fail goto*//*Label 25552*/ GIMT_Encode4(1895783), // Rule ID 19195 //
     /* 1895702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1895705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1895719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1895722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895748 */     // MIs[0] policy
     /* 1895748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895758 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1895761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895782 */     // GIR_Coverage, 19195,
     /* 1895782 */     GIR_EraseRootFromParent_Done,
     /* 1895783 */   // Label 25552: @1895783
     /* 1895783 */   GIM_Try, /*On fail goto*//*Label 25553*/ GIMT_Encode4(1895869), // Rule ID 19198 //
     /* 1895788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1895799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1895802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1895805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1895808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895834 */     // MIs[0] policy
     /* 1895834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895844 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1895847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895868 */     // GIR_Coverage, 19198,
     /* 1895868 */     GIR_EraseRootFromParent_Done,
     /* 1895869 */   // Label 25553: @1895869
     /* 1895869 */   GIM_Try, /*On fail goto*//*Label 25554*/ GIMT_Encode4(1895955), // Rule ID 19199 //
     /* 1895874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1895885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1895888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1895891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1895894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895920 */     // MIs[0] policy
     /* 1895920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895930 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1895933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895954 */     // GIR_Coverage, 19199,
     /* 1895954 */     GIR_EraseRootFromParent_Done,
     /* 1895955 */   // Label 25554: @1895955
     /* 1895955 */   GIM_Try, /*On fail goto*//*Label 25555*/ GIMT_Encode4(1896041), // Rule ID 19202 //
     /* 1895960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1895963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1895971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1895974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1895977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1895980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896006 */     // MIs[0] policy
     /* 1896006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896016 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1896019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896040 */     // GIR_Coverage, 19202,
     /* 1896040 */     GIR_EraseRootFromParent_Done,
     /* 1896041 */   // Label 25555: @1896041
     /* 1896041 */   GIM_Try, /*On fail goto*//*Label 25556*/ GIMT_Encode4(1896127), // Rule ID 19203 //
     /* 1896046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1896057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1896060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1896063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1896066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1896069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896092 */     // MIs[0] policy
     /* 1896092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1896105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896126 */     // GIR_Coverage, 19203,
     /* 1896126 */     GIR_EraseRootFromParent_Done,
     /* 1896127 */   // Label 25556: @1896127
     /* 1896127 */   GIM_Try, /*On fail goto*//*Label 25557*/ GIMT_Encode4(1896213), // Rule ID 19206 //
     /* 1896132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1896135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1896143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1896146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1896149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1896152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896178 */     // MIs[0] policy
     /* 1896178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896188 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1896191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1896209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896212 */     // GIR_Coverage, 19206,
     /* 1896212 */     GIR_EraseRootFromParent_Done,
     /* 1896213 */   // Label 25557: @1896213
     /* 1896213 */   GIM_Try, /*On fail goto*//*Label 25558*/ GIMT_Encode4(1896299), // Rule ID 19207 //
     /* 1896218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1896221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1896229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1896232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1896235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1896238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896264 */     // MIs[0] policy
     /* 1896264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896274 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1896277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1896295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896298 */     // GIR_Coverage, 19207,
     /* 1896298 */     GIR_EraseRootFromParent_Done,
     /* 1896299 */   // Label 25558: @1896299
     /* 1896299 */   GIM_Try, /*On fail goto*//*Label 25559*/ GIMT_Encode4(1896385), // Rule ID 19210 //
     /* 1896304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1896315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1896318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1896321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1896324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896350 */     // MIs[0] policy
     /* 1896350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896360 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1896363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896384 */     // GIR_Coverage, 19210,
     /* 1896384 */     GIR_EraseRootFromParent_Done,
     /* 1896385 */   // Label 25559: @1896385
     /* 1896385 */   GIM_Try, /*On fail goto*//*Label 25560*/ GIMT_Encode4(1896471), // Rule ID 19211 //
     /* 1896390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1896401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1896404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1896407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1896410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896436 */     // MIs[0] policy
     /* 1896436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896446 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1896449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896470 */     // GIR_Coverage, 19211,
     /* 1896470 */     GIR_EraseRootFromParent_Done,
     /* 1896471 */   // Label 25560: @1896471
     /* 1896471 */   GIM_Try, /*On fail goto*//*Label 25561*/ GIMT_Encode4(1896557), // Rule ID 19214 //
     /* 1896476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1896487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1896490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1896493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1896496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896522 */     // MIs[0] policy
     /* 1896522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896532 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1896535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896556 */     // GIR_Coverage, 19214,
     /* 1896556 */     GIR_EraseRootFromParent_Done,
     /* 1896557 */   // Label 25561: @1896557
     /* 1896557 */   GIM_Try, /*On fail goto*//*Label 25562*/ GIMT_Encode4(1896643), // Rule ID 19215 //
     /* 1896562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1896573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1896576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1896579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1896582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896608 */     // MIs[0] policy
     /* 1896608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896618 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1896621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896642 */     // GIR_Coverage, 19215,
     /* 1896642 */     GIR_EraseRootFromParent_Done,
     /* 1896643 */   // Label 25562: @1896643
     /* 1896643 */   GIM_Try, /*On fail goto*//*Label 25563*/ GIMT_Encode4(1896729), // Rule ID 19218 //
     /* 1896648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1896659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1896662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1896665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1896668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896694 */     // MIs[0] policy
     /* 1896694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896704 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1896707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896728 */     // GIR_Coverage, 19218,
     /* 1896728 */     GIR_EraseRootFromParent_Done,
     /* 1896729 */   // Label 25563: @1896729
     /* 1896729 */   GIM_Try, /*On fail goto*//*Label 25564*/ GIMT_Encode4(1896815), // Rule ID 19219 //
     /* 1896734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1896745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1896748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1896751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1896754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896780 */     // MIs[0] policy
     /* 1896780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896790 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1896793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896814 */     // GIR_Coverage, 19219,
     /* 1896814 */     GIR_EraseRootFromParent_Done,
     /* 1896815 */   // Label 25564: @1896815
     /* 1896815 */   GIM_Try, /*On fail goto*//*Label 25565*/ GIMT_Encode4(1896901), // Rule ID 19222 //
     /* 1896820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1896831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1896834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1896837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1896840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896866 */     // MIs[0] policy
     /* 1896866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896876 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1896879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896900 */     // GIR_Coverage, 19222,
     /* 1896900 */     GIR_EraseRootFromParent_Done,
     /* 1896901 */   // Label 25565: @1896901
     /* 1896901 */   GIM_Try, /*On fail goto*//*Label 25566*/ GIMT_Encode4(1896987), // Rule ID 19223 //
     /* 1896906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1896917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1896920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1896923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1896926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896952 */     // MIs[0] policy
     /* 1896952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896962 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1896965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896986 */     // GIR_Coverage, 19223,
     /* 1896986 */     GIR_EraseRootFromParent_Done,
     /* 1896987 */   // Label 25566: @1896987
     /* 1896987 */   GIM_Try, /*On fail goto*//*Label 25567*/ GIMT_Encode4(1897073), // Rule ID 19226 //
     /* 1896992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1897003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1897006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1897009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1897012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897038 */     // MIs[0] policy
     /* 1897038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897048 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1897051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897072 */     // GIR_Coverage, 19226,
     /* 1897072 */     GIR_EraseRootFromParent_Done,
     /* 1897073 */   // Label 25567: @1897073
     /* 1897073 */   GIM_Try, /*On fail goto*//*Label 25568*/ GIMT_Encode4(1897159), // Rule ID 19227 //
     /* 1897078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1897081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1897089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1897092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1897095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1897098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897124 */     // MIs[0] policy
     /* 1897124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897134 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1897137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897158 */     // GIR_Coverage, 19227,
     /* 1897158 */     GIR_EraseRootFromParent_Done,
     /* 1897159 */   // Label 25568: @1897159
     /* 1897159 */   GIM_Try, /*On fail goto*//*Label 25569*/ GIMT_Encode4(1897245), // Rule ID 19230 //
     /* 1897164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1897167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1897175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1897178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1897181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1897184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897210 */     // MIs[0] policy
     /* 1897210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897220 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1897223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897244 */     // GIR_Coverage, 19230,
     /* 1897244 */     GIR_EraseRootFromParent_Done,
     /* 1897245 */   // Label 25569: @1897245
     /* 1897245 */   GIM_Try, /*On fail goto*//*Label 25570*/ GIMT_Encode4(1897331), // Rule ID 19231 //
     /* 1897250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1897253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1897261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1897264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1897267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1897270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897296 */     // MIs[0] policy
     /* 1897296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897306 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1897309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897330 */     // GIR_Coverage, 19231,
     /* 1897330 */     GIR_EraseRootFromParent_Done,
     /* 1897331 */   // Label 25570: @1897331
     /* 1897331 */   GIM_Try, /*On fail goto*//*Label 25571*/ GIMT_Encode4(1897417), // Rule ID 19234 //
     /* 1897336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1897347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1897350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1897353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1897356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1897359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897382 */     // MIs[0] policy
     /* 1897382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897392 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1897395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897416 */     // GIR_Coverage, 19234,
     /* 1897416 */     GIR_EraseRootFromParent_Done,
     /* 1897417 */   // Label 25571: @1897417
     /* 1897417 */   GIM_Try, /*On fail goto*//*Label 25572*/ GIMT_Encode4(1897503), // Rule ID 19235 //
     /* 1897422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1897433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1897436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1897439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1897442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1897445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897468 */     // MIs[0] policy
     /* 1897468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897478 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1897481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897502 */     // GIR_Coverage, 19235,
     /* 1897502 */     GIR_EraseRootFromParent_Done,
     /* 1897503 */   // Label 25572: @1897503
     /* 1897503 */   GIM_Try, /*On fail goto*//*Label 25573*/ GIMT_Encode4(1897589), // Rule ID 19238 //
     /* 1897508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1897519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1897522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1897525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1897528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897554 */     // MIs[0] policy
     /* 1897554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897564 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1897567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897588 */     // GIR_Coverage, 19238,
     /* 1897588 */     GIR_EraseRootFromParent_Done,
     /* 1897589 */   // Label 25573: @1897589
     /* 1897589 */   GIM_Try, /*On fail goto*//*Label 25574*/ GIMT_Encode4(1897675), // Rule ID 19239 //
     /* 1897594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1897605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1897608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1897611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1897614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897640 */     // MIs[0] policy
     /* 1897640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897650 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1897653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897674 */     // GIR_Coverage, 19239,
     /* 1897674 */     GIR_EraseRootFromParent_Done,
     /* 1897675 */   // Label 25574: @1897675
     /* 1897675 */   GIM_Try, /*On fail goto*//*Label 25575*/ GIMT_Encode4(1897761), // Rule ID 19242 //
     /* 1897680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1897691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1897694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1897697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1897700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897726 */     // MIs[0] policy
     /* 1897726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897736 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1897739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897760 */     // GIR_Coverage, 19242,
     /* 1897760 */     GIR_EraseRootFromParent_Done,
     /* 1897761 */   // Label 25575: @1897761
     /* 1897761 */   GIM_Try, /*On fail goto*//*Label 25576*/ GIMT_Encode4(1897847), // Rule ID 19243 //
     /* 1897766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1897777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1897780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1897783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1897786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897812 */     // MIs[0] policy
     /* 1897812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897822 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1897825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897846 */     // GIR_Coverage, 19243,
     /* 1897846 */     GIR_EraseRootFromParent_Done,
     /* 1897847 */   // Label 25576: @1897847
     /* 1897847 */   GIM_Try, /*On fail goto*//*Label 25577*/ GIMT_Encode4(1897933), // Rule ID 19246 //
     /* 1897852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1897855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1897863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1897866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1897869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897898 */     // MIs[0] policy
     /* 1897898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897908 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1897911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897932 */     // GIR_Coverage, 19246,
     /* 1897932 */     GIR_EraseRootFromParent_Done,
     /* 1897933 */   // Label 25577: @1897933
     /* 1897933 */   GIM_Try, /*On fail goto*//*Label 25578*/ GIMT_Encode4(1898019), // Rule ID 19247 //
     /* 1897938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1897949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1897952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1897955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897984 */     // MIs[0] policy
     /* 1897984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897994 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1897997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898018 */     // GIR_Coverage, 19247,
     /* 1898018 */     GIR_EraseRootFromParent_Done,
     /* 1898019 */   // Label 25578: @1898019
     /* 1898019 */   GIM_Try, /*On fail goto*//*Label 25579*/ GIMT_Encode4(1898105), // Rule ID 19250 //
     /* 1898024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1898035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1898038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1898041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898070 */     // MIs[0] policy
     /* 1898070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898080 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1898083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898104 */     // GIR_Coverage, 19250,
     /* 1898104 */     GIR_EraseRootFromParent_Done,
     /* 1898105 */   // Label 25579: @1898105
     /* 1898105 */   GIM_Try, /*On fail goto*//*Label 25580*/ GIMT_Encode4(1898191), // Rule ID 19251 //
     /* 1898110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1898121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1898124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1898127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898156 */     // MIs[0] policy
     /* 1898156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898166 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1898169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898190 */     // GIR_Coverage, 19251,
     /* 1898190 */     GIR_EraseRootFromParent_Done,
     /* 1898191 */   // Label 25580: @1898191
     /* 1898191 */   GIM_Try, /*On fail goto*//*Label 25581*/ GIMT_Encode4(1898277), // Rule ID 19254 //
     /* 1898196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1898199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1898207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1898210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1898213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898242 */     // MIs[0] policy
     /* 1898242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898252 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1898255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898276 */     // GIR_Coverage, 19254,
     /* 1898276 */     GIR_EraseRootFromParent_Done,
     /* 1898277 */   // Label 25581: @1898277
     /* 1898277 */   GIM_Try, /*On fail goto*//*Label 25582*/ GIMT_Encode4(1898363), // Rule ID 19255 //
     /* 1898282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1898285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1898293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1898296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1898299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898328 */     // MIs[0] policy
     /* 1898328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898338 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1898341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898362 */     // GIR_Coverage, 19255,
     /* 1898362 */     GIR_EraseRootFromParent_Done,
     /* 1898363 */   // Label 25582: @1898363
     /* 1898363 */   GIM_Try, /*On fail goto*//*Label 25583*/ GIMT_Encode4(1898449), // Rule ID 19258 //
     /* 1898368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1898379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1898382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1898385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898414 */     // MIs[0] policy
     /* 1898414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898424 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1898427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898448 */     // GIR_Coverage, 19258,
     /* 1898448 */     GIR_EraseRootFromParent_Done,
     /* 1898449 */   // Label 25583: @1898449
     /* 1898449 */   GIM_Try, /*On fail goto*//*Label 25584*/ GIMT_Encode4(1898535), // Rule ID 19259 //
     /* 1898454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1898465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1898468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1898471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898500 */     // MIs[0] policy
     /* 1898500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898510 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1898513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898534 */     // GIR_Coverage, 19259,
     /* 1898534 */     GIR_EraseRootFromParent_Done,
     /* 1898535 */   // Label 25584: @1898535
     /* 1898535 */   GIM_Try, /*On fail goto*//*Label 25585*/ GIMT_Encode4(1898621), // Rule ID 19262 //
     /* 1898540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1898543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1898551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1898554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1898557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898586 */     // MIs[0] policy
     /* 1898586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898596 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1898599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898620 */     // GIR_Coverage, 19262,
     /* 1898620 */     GIR_EraseRootFromParent_Done,
     /* 1898621 */   // Label 25585: @1898621
     /* 1898621 */   GIM_Try, /*On fail goto*//*Label 25586*/ GIMT_Encode4(1898707), // Rule ID 19263 //
     /* 1898626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1898629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1898637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1898640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1898643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898672 */     // MIs[0] policy
     /* 1898672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898682 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1898685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898706 */     // GIR_Coverage, 19263,
     /* 1898706 */     GIR_EraseRootFromParent_Done,
     /* 1898707 */   // Label 25586: @1898707
     /* 1898707 */   GIM_Try, /*On fail goto*//*Label 25587*/ GIMT_Encode4(1898793), // Rule ID 19266 //
     /* 1898712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1898715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1898723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1898726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1898729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898758 */     // MIs[0] policy
     /* 1898758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898768 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1898771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898792 */     // GIR_Coverage, 19266,
     /* 1898792 */     GIR_EraseRootFromParent_Done,
     /* 1898793 */   // Label 25587: @1898793
     /* 1898793 */   GIM_Try, /*On fail goto*//*Label 25588*/ GIMT_Encode4(1898879), // Rule ID 19267 //
     /* 1898798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1898801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1898809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1898812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1898815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898844 */     // MIs[0] policy
     /* 1898844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898854 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1898857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898878 */     // GIR_Coverage, 19267,
     /* 1898878 */     GIR_EraseRootFromParent_Done,
     /* 1898879 */   // Label 25588: @1898879
     /* 1898879 */   GIM_Try, /*On fail goto*//*Label 25589*/ GIMT_Encode4(1898965), // Rule ID 19270 //
     /* 1898884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1898895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1898898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1898901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898930 */     // MIs[0] policy
     /* 1898930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898940 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1898943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898964 */     // GIR_Coverage, 19270,
     /* 1898964 */     GIR_EraseRootFromParent_Done,
     /* 1898965 */   // Label 25589: @1898965
     /* 1898965 */   GIM_Try, /*On fail goto*//*Label 25590*/ GIMT_Encode4(1899051), // Rule ID 19271 //
     /* 1898970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1898981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1898984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1898987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1899012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899016 */     // MIs[0] policy
     /* 1899016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899026 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1899029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899050 */     // GIR_Coverage, 19271,
     /* 1899050 */     GIR_EraseRootFromParent_Done,
     /* 1899051 */   // Label 25590: @1899051
     /* 1899051 */   GIM_Try, /*On fail goto*//*Label 25591*/ GIMT_Encode4(1899137), // Rule ID 19274 //
     /* 1899056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1899067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1899070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1899073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1899076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1899098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899102 */     // MIs[0] policy
     /* 1899102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899112 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1899115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899136 */     // GIR_Coverage, 19274,
     /* 1899136 */     GIR_EraseRootFromParent_Done,
     /* 1899137 */   // Label 25591: @1899137
     /* 1899137 */   GIM_Try, /*On fail goto*//*Label 25592*/ GIMT_Encode4(1899223), // Rule ID 19275 //
     /* 1899142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1899153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1899156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1899159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1899162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1899184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899188 */     // MIs[0] policy
     /* 1899188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899198 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1899201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899222 */     // GIR_Coverage, 19275,
     /* 1899222 */     GIR_EraseRootFromParent_Done,
     /* 1899223 */   // Label 25592: @1899223
     /* 1899223 */   GIM_Try, /*On fail goto*//*Label 25593*/ GIMT_Encode4(1899309), // Rule ID 19278 //
     /* 1899228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1899239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1899242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1899245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1899248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1899251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1899270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899274 */     // MIs[0] policy
     /* 1899274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899284 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1899287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899308 */     // GIR_Coverage, 19278,
     /* 1899308 */     GIR_EraseRootFromParent_Done,
     /* 1899309 */   // Label 25593: @1899309
     /* 1899309 */   GIM_Try, /*On fail goto*//*Label 25594*/ GIMT_Encode4(1899395), // Rule ID 19279 //
     /* 1899314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1899325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1899328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1899331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1899334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1899337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1899356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899360 */     // MIs[0] policy
     /* 1899360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899370 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1899373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899394 */     // GIR_Coverage, 19279,
     /* 1899394 */     GIR_EraseRootFromParent_Done,
     /* 1899395 */   // Label 25594: @1899395
     /* 1899395 */   GIM_Try, /*On fail goto*//*Label 25595*/ GIMT_Encode4(1899481), // Rule ID 19282 //
     /* 1899400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1899411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1899414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1899417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899446 */     // MIs[0] policy
     /* 1899446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899456 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1899459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899480 */     // GIR_Coverage, 19282,
     /* 1899480 */     GIR_EraseRootFromParent_Done,
     /* 1899481 */   // Label 25595: @1899481
     /* 1899481 */   GIM_Try, /*On fail goto*//*Label 25596*/ GIMT_Encode4(1899567), // Rule ID 19283 //
     /* 1899486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1899497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1899500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1899503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899532 */     // MIs[0] policy
     /* 1899532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899542 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1899545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899566 */     // GIR_Coverage, 19283,
     /* 1899566 */     GIR_EraseRootFromParent_Done,
     /* 1899567 */   // Label 25596: @1899567
     /* 1899567 */   GIM_Try, /*On fail goto*//*Label 25597*/ GIMT_Encode4(1899653), // Rule ID 19286 //
     /* 1899572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1899589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899618 */     // MIs[0] policy
     /* 1899618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899628 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1899631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899652 */     // GIR_Coverage, 19286,
     /* 1899652 */     GIR_EraseRootFromParent_Done,
     /* 1899653 */   // Label 25597: @1899653
     /* 1899653 */   GIM_Try, /*On fail goto*//*Label 25598*/ GIMT_Encode4(1899739), // Rule ID 19287 //
     /* 1899658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1899675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899704 */     // MIs[0] policy
     /* 1899704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899714 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1899717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899738 */     // GIR_Coverage, 19287,
     /* 1899738 */     GIR_EraseRootFromParent_Done,
     /* 1899739 */   // Label 25598: @1899739
     /* 1899739 */   GIM_Try, /*On fail goto*//*Label 25599*/ GIMT_Encode4(1899825), // Rule ID 19290 //
     /* 1899744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1899755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1899758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1899761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899790 */     // MIs[0] policy
     /* 1899790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899800 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1899803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899824 */     // GIR_Coverage, 19290,
     /* 1899824 */     GIR_EraseRootFromParent_Done,
     /* 1899825 */   // Label 25599: @1899825
     /* 1899825 */   GIM_Try, /*On fail goto*//*Label 25600*/ GIMT_Encode4(1899911), // Rule ID 19291 //
     /* 1899830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1899841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1899844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1899847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899876 */     // MIs[0] policy
     /* 1899876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899886 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1899889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899910 */     // GIR_Coverage, 19291,
     /* 1899910 */     GIR_EraseRootFromParent_Done,
     /* 1899911 */   // Label 25600: @1899911
     /* 1899911 */   GIM_Try, /*On fail goto*//*Label 25601*/ GIMT_Encode4(1899997), // Rule ID 19294 //
     /* 1899916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1899919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1899927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1899930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1899933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1899939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899962 */     // MIs[0] policy
     /* 1899962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899972 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1899975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899996 */     // GIR_Coverage, 19294,
     /* 1899996 */     GIR_EraseRootFromParent_Done,
     /* 1899997 */   // Label 25601: @1899997
     /* 1899997 */   GIM_Try, /*On fail goto*//*Label 25602*/ GIMT_Encode4(1900083), // Rule ID 19295 //
     /* 1900002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1900013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1900016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1900019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1900022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1900032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1900044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900048 */     // MIs[0] policy
     /* 1900048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900058 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1900061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900082 */     // GIR_Coverage, 19295,
     /* 1900082 */     GIR_EraseRootFromParent_Done,
     /* 1900083 */   // Label 25602: @1900083
     /* 1900083 */   GIM_Try, /*On fail goto*//*Label 25603*/ GIMT_Encode4(1900169), // Rule ID 19298 //
     /* 1900088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1900091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1900099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1900102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1900105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1900108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1900130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900134 */     // MIs[0] policy
     /* 1900134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900144 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1900147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900168 */     // GIR_Coverage, 19298,
     /* 1900168 */     GIR_EraseRootFromParent_Done,
     /* 1900169 */   // Label 25603: @1900169
     /* 1900169 */   GIM_Try, /*On fail goto*//*Label 25604*/ GIMT_Encode4(1900255), // Rule ID 19299 //
     /* 1900174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1900185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1900188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1900191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1900194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1900216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900220 */     // MIs[0] policy
     /* 1900220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900230 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1900233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900254 */     // GIR_Coverage, 19299,
     /* 1900254 */     GIR_EraseRootFromParent_Done,
     /* 1900255 */   // Label 25604: @1900255
     /* 1900255 */   GIM_Try, /*On fail goto*//*Label 25605*/ GIMT_Encode4(1900341), // Rule ID 19302 //
     /* 1900260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1900263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1900271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1900274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1900277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1900280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1900302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900306 */     // MIs[0] policy
     /* 1900306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900316 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1900319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900340 */     // GIR_Coverage, 19302,
     /* 1900340 */     GIR_EraseRootFromParent_Done,
     /* 1900341 */   // Label 25605: @1900341
     /* 1900341 */   GIM_Try, /*On fail goto*//*Label 25606*/ GIMT_Encode4(1900427), // Rule ID 19303 //
     /* 1900346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1900357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1900360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1900363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1900366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1900388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900392 */     // MIs[0] policy
     /* 1900392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900402 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1900405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900426 */     // GIR_Coverage, 19303,
     /* 1900426 */     GIR_EraseRootFromParent_Done,
     /* 1900427 */   // Label 25606: @1900427
     /* 1900427 */   GIM_Try, /*On fail goto*//*Label 25607*/ GIMT_Encode4(1900513), // Rule ID 19306 //
     /* 1900432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1900443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1900446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1900449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1900452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900478 */     // MIs[0] policy
     /* 1900478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900488 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1900491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900512 */     // GIR_Coverage, 19306,
     /* 1900512 */     GIR_EraseRootFromParent_Done,
     /* 1900513 */   // Label 25607: @1900513
     /* 1900513 */   GIM_Try, /*On fail goto*//*Label 25608*/ GIMT_Encode4(1900599), // Rule ID 19307 //
     /* 1900518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1900529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1900532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1900535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1900538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900564 */     // MIs[0] policy
     /* 1900564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900574 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1900577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900598 */     // GIR_Coverage, 19307,
     /* 1900598 */     GIR_EraseRootFromParent_Done,
     /* 1900599 */   // Label 25608: @1900599
     /* 1900599 */   GIM_Try, /*On fail goto*//*Label 25609*/ GIMT_Encode4(1900685), // Rule ID 19310 //
     /* 1900604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1900615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1900618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1900621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1900624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900650 */     // MIs[0] policy
     /* 1900650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900660 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1900663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900684 */     // GIR_Coverage, 19310,
     /* 1900684 */     GIR_EraseRootFromParent_Done,
     /* 1900685 */   // Label 25609: @1900685
     /* 1900685 */   GIM_Try, /*On fail goto*//*Label 25610*/ GIMT_Encode4(1900771), // Rule ID 19311 //
     /* 1900690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1900701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1900704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1900707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1900710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900736 */     // MIs[0] policy
     /* 1900736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900746 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1900749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900770 */     // GIR_Coverage, 19311,
     /* 1900770 */     GIR_EraseRootFromParent_Done,
     /* 1900771 */   // Label 25610: @1900771
     /* 1900771 */   GIM_Try, /*On fail goto*//*Label 25611*/ GIMT_Encode4(1900857), // Rule ID 19314 //
     /* 1900776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1900787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1900790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1900793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1900796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900822 */     // MIs[0] policy
     /* 1900822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900832 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1900835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900856 */     // GIR_Coverage, 19314,
     /* 1900856 */     GIR_EraseRootFromParent_Done,
     /* 1900857 */   // Label 25611: @1900857
     /* 1900857 */   GIM_Try, /*On fail goto*//*Label 25612*/ GIMT_Encode4(1900943), // Rule ID 19315 //
     /* 1900862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1900873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1900876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1900879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1900882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900908 */     // MIs[0] policy
     /* 1900908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900918 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1900921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900942 */     // GIR_Coverage, 19315,
     /* 1900942 */     GIR_EraseRootFromParent_Done,
     /* 1900943 */   // Label 25612: @1900943
     /* 1900943 */   GIM_Try, /*On fail goto*//*Label 25613*/ GIMT_Encode4(1901029), // Rule ID 19318 //
     /* 1900948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1900959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1900962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1900965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1900968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900994 */     // MIs[0] policy
     /* 1900994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901004 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1901007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901028 */     // GIR_Coverage, 19318,
     /* 1901028 */     GIR_EraseRootFromParent_Done,
     /* 1901029 */   // Label 25613: @1901029
     /* 1901029 */   GIM_Try, /*On fail goto*//*Label 25614*/ GIMT_Encode4(1901115), // Rule ID 19319 //
     /* 1901034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1901045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1901048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1901051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1901054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901080 */     // MIs[0] policy
     /* 1901080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901090 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1901093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901114 */     // GIR_Coverage, 19319,
     /* 1901114 */     GIR_EraseRootFromParent_Done,
     /* 1901115 */   // Label 25614: @1901115
     /* 1901115 */   GIM_Try, /*On fail goto*//*Label 25615*/ GIMT_Encode4(1901201), // Rule ID 19322 //
     /* 1901120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1901137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1901140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901166 */     // MIs[0] policy
     /* 1901166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901176 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1901179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901200 */     // GIR_Coverage, 19322,
     /* 1901200 */     GIR_EraseRootFromParent_Done,
     /* 1901201 */   // Label 25615: @1901201
     /* 1901201 */   GIM_Try, /*On fail goto*//*Label 25616*/ GIMT_Encode4(1901287), // Rule ID 19323 //
     /* 1901206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1901223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1901226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901252 */     // MIs[0] policy
     /* 1901252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901262 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1901265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901286 */     // GIR_Coverage, 19323,
     /* 1901286 */     GIR_EraseRootFromParent_Done,
     /* 1901287 */   // Label 25616: @1901287
     /* 1901287 */   GIM_Try, /*On fail goto*//*Label 25617*/ GIMT_Encode4(1901373), // Rule ID 19326 //
     /* 1901292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1901295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1901303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1901306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1901309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1901312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901338 */     // MIs[0] policy
     /* 1901338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901348 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1901351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1901369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901372 */     // GIR_Coverage, 19326,
     /* 1901372 */     GIR_EraseRootFromParent_Done,
     /* 1901373 */   // Label 25617: @1901373
     /* 1901373 */   GIM_Try, /*On fail goto*//*Label 25618*/ GIMT_Encode4(1901459), // Rule ID 19327 //
     /* 1901378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1901381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1901389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1901392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1901395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1901398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901424 */     // MIs[0] policy
     /* 1901424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901434 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1901437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1901455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901458 */     // GIR_Coverage, 19327,
     /* 1901458 */     GIR_EraseRootFromParent_Done,
     /* 1901459 */   // Label 25618: @1901459
     /* 1901459 */   GIM_Try, /*On fail goto*//*Label 25619*/ GIMT_Encode4(1901545), // Rule ID 19330 //
     /* 1901464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1901475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1901478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1901481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1901484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901510 */     // MIs[0] policy
     /* 1901510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901520 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1901523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901544 */     // GIR_Coverage, 19330,
     /* 1901544 */     GIR_EraseRootFromParent_Done,
     /* 1901545 */   // Label 25619: @1901545
     /* 1901545 */   GIM_Try, /*On fail goto*//*Label 25620*/ GIMT_Encode4(1901631), // Rule ID 19331 //
     /* 1901550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1901561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1901564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1901567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1901570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901596 */     // MIs[0] policy
     /* 1901596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901606 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1901609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901630 */     // GIR_Coverage, 19331,
     /* 1901630 */     GIR_EraseRootFromParent_Done,
     /* 1901631 */   // Label 25620: @1901631
     /* 1901631 */   GIM_Try, /*On fail goto*//*Label 25621*/ GIMT_Encode4(1901717), // Rule ID 19334 //
     /* 1901636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1901647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1901650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1901653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1901656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901682 */     // MIs[0] policy
     /* 1901682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901692 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1901695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901716 */     // GIR_Coverage, 19334,
     /* 1901716 */     GIR_EraseRootFromParent_Done,
     /* 1901717 */   // Label 25621: @1901717
     /* 1901717 */   GIM_Try, /*On fail goto*//*Label 25622*/ GIMT_Encode4(1901803), // Rule ID 19335 //
     /* 1901722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1901733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1901736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1901739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1901742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901768 */     // MIs[0] policy
     /* 1901768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901778 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1901781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901802 */     // GIR_Coverage, 19335,
     /* 1901802 */     GIR_EraseRootFromParent_Done,
     /* 1901803 */   // Label 25622: @1901803
     /* 1901803 */   GIM_Try, /*On fail goto*//*Label 25623*/ GIMT_Encode4(1901889), // Rule ID 19338 //
     /* 1901808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1901819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1901822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1901825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1901828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1901831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901854 */     // MIs[0] policy
     /* 1901854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901864 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1901867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901888 */     // GIR_Coverage, 19338,
     /* 1901888 */     GIR_EraseRootFromParent_Done,
     /* 1901889 */   // Label 25623: @1901889
     /* 1901889 */   GIM_Try, /*On fail goto*//*Label 25624*/ GIMT_Encode4(1901975), // Rule ID 19339 //
     /* 1901894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1901905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1901908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1901911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1901914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1901917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901940 */     // MIs[0] policy
     /* 1901940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901950 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1901953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901974 */     // GIR_Coverage, 19339,
     /* 1901974 */     GIR_EraseRootFromParent_Done,
     /* 1901975 */   // Label 25624: @1901975
     /* 1901975 */   GIM_Try, /*On fail goto*//*Label 25625*/ GIMT_Encode4(1902061), // Rule ID 19342 //
     /* 1901980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1901991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1901994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1901997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1902000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902026 */     // MIs[0] policy
     /* 1902026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902036 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1902039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902060 */     // GIR_Coverage, 19342,
     /* 1902060 */     GIR_EraseRootFromParent_Done,
     /* 1902061 */   // Label 25625: @1902061
     /* 1902061 */   GIM_Try, /*On fail goto*//*Label 25626*/ GIMT_Encode4(1902147), // Rule ID 19343 //
     /* 1902066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1902077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1902080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1902083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1902086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902112 */     // MIs[0] policy
     /* 1902112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902122 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1902125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902146 */     // GIR_Coverage, 19343,
     /* 1902146 */     GIR_EraseRootFromParent_Done,
     /* 1902147 */   // Label 25626: @1902147
     /* 1902147 */   GIM_Try, /*On fail goto*//*Label 25627*/ GIMT_Encode4(1902233), // Rule ID 19346 //
     /* 1902152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1902163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1902166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1902169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1902172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902198 */     // MIs[0] policy
     /* 1902198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902208 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1902211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902232 */     // GIR_Coverage, 19346,
     /* 1902232 */     GIR_EraseRootFromParent_Done,
     /* 1902233 */   // Label 25627: @1902233
     /* 1902233 */   GIM_Try, /*On fail goto*//*Label 25628*/ GIMT_Encode4(1902319), // Rule ID 19347 //
     /* 1902238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1902249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1902252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1902255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1902258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902284 */     // MIs[0] policy
     /* 1902284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902294 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1902297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902318 */     // GIR_Coverage, 19347,
     /* 1902318 */     GIR_EraseRootFromParent_Done,
     /* 1902319 */   // Label 25628: @1902319
     /* 1902319 */   GIM_Try, /*On fail goto*//*Label 25629*/ GIMT_Encode4(1902405), // Rule ID 19350 //
     /* 1902324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1902335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1902338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1902341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1902344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1902347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902370 */     // MIs[0] policy
     /* 1902370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902380 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1902383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902404 */     // GIR_Coverage, 19350,
     /* 1902404 */     GIR_EraseRootFromParent_Done,
     /* 1902405 */   // Label 25629: @1902405
     /* 1902405 */   GIM_Try, /*On fail goto*//*Label 25630*/ GIMT_Encode4(1902491), // Rule ID 19351 //
     /* 1902410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1902421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1902424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1902427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1902430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1902433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902456 */     // MIs[0] policy
     /* 1902456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902466 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1902469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902490 */     // GIR_Coverage, 19351,
     /* 1902490 */     GIR_EraseRootFromParent_Done,
     /* 1902491 */   // Label 25630: @1902491
     /* 1902491 */   GIM_Try, /*On fail goto*//*Label 25631*/ GIMT_Encode4(1902577), // Rule ID 19354 //
     /* 1902496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1902507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1902510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1902513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1902516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902542 */     // MIs[0] policy
     /* 1902542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902552 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1902555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902576 */     // GIR_Coverage, 19354,
     /* 1902576 */     GIR_EraseRootFromParent_Done,
     /* 1902577 */   // Label 25631: @1902577
     /* 1902577 */   GIM_Try, /*On fail goto*//*Label 25632*/ GIMT_Encode4(1902663), // Rule ID 19355 //
     /* 1902582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1902593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1902596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1902599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1902602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902628 */     // MIs[0] policy
     /* 1902628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902638 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1902641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902662 */     // GIR_Coverage, 19355,
     /* 1902662 */     GIR_EraseRootFromParent_Done,
     /* 1902663 */   // Label 25632: @1902663
     /* 1902663 */   GIM_Try, /*On fail goto*//*Label 25633*/ GIMT_Encode4(1902749), // Rule ID 19358 //
     /* 1902668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1902679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1902682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1902685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1902688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902714 */     // MIs[0] policy
     /* 1902714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902724 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1902727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902748 */     // GIR_Coverage, 19358,
     /* 1902748 */     GIR_EraseRootFromParent_Done,
     /* 1902749 */   // Label 25633: @1902749
     /* 1902749 */   GIM_Try, /*On fail goto*//*Label 25634*/ GIMT_Encode4(1902835), // Rule ID 19359 //
     /* 1902754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1902765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1902768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1902771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1902774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902800 */     // MIs[0] policy
     /* 1902800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902810 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1902813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902834 */     // GIR_Coverage, 19359,
     /* 1902834 */     GIR_EraseRootFromParent_Done,
     /* 1902835 */   // Label 25634: @1902835
     /* 1902835 */   GIM_Try, /*On fail goto*//*Label 25635*/ GIMT_Encode4(1902921), // Rule ID 19362 //
     /* 1902840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1902851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1902854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1902857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1902860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902886 */     // MIs[0] policy
     /* 1902886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902896 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1902899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902920 */     // GIR_Coverage, 19362,
     /* 1902920 */     GIR_EraseRootFromParent_Done,
     /* 1902921 */   // Label 25635: @1902921
     /* 1902921 */   GIM_Try, /*On fail goto*//*Label 25636*/ GIMT_Encode4(1903007), // Rule ID 19363 //
     /* 1902926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1902937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1902940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1902943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1902946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902972 */     // MIs[0] policy
     /* 1902972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902982 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1902985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903006 */     // GIR_Coverage, 19363,
     /* 1903006 */     GIR_EraseRootFromParent_Done,
     /* 1903007 */   // Label 25636: @1903007
     /* 1903007 */   GIM_Try, /*On fail goto*//*Label 25637*/ GIMT_Encode4(1903093), // Rule ID 19366 //
     /* 1903012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1903023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1903026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1903029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903058 */     // MIs[0] policy
     /* 1903058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903068 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1903071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903092 */     // GIR_Coverage, 19366,
     /* 1903092 */     GIR_EraseRootFromParent_Done,
     /* 1903093 */   // Label 25637: @1903093
     /* 1903093 */   GIM_Try, /*On fail goto*//*Label 25638*/ GIMT_Encode4(1903179), // Rule ID 19367 //
     /* 1903098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1903109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1903112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1903115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903144 */     // MIs[0] policy
     /* 1903144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903154 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1903157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903178 */     // GIR_Coverage, 19367,
     /* 1903178 */     GIR_EraseRootFromParent_Done,
     /* 1903179 */   // Label 25638: @1903179
     /* 1903179 */   GIM_Try, /*On fail goto*//*Label 25639*/ GIMT_Encode4(1903265), // Rule ID 19370 //
     /* 1903184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1903195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1903198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1903201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903230 */     // MIs[0] policy
     /* 1903230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903240 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1903243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903264 */     // GIR_Coverage, 19370,
     /* 1903264 */     GIR_EraseRootFromParent_Done,
     /* 1903265 */   // Label 25639: @1903265
     /* 1903265 */   GIM_Try, /*On fail goto*//*Label 25640*/ GIMT_Encode4(1903351), // Rule ID 19371 //
     /* 1903270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1903281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1903284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1903287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903316 */     // MIs[0] policy
     /* 1903316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903326 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1903329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903350 */     // GIR_Coverage, 19371,
     /* 1903350 */     GIR_EraseRootFromParent_Done,
     /* 1903351 */   // Label 25640: @1903351
     /* 1903351 */   GIM_Try, /*On fail goto*//*Label 25641*/ GIMT_Encode4(1903437), // Rule ID 19374 //
     /* 1903356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1903359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1903367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1903370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1903373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903402 */     // MIs[0] policy
     /* 1903402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903412 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1903415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903436 */     // GIR_Coverage, 19374,
     /* 1903436 */     GIR_EraseRootFromParent_Done,
     /* 1903437 */   // Label 25641: @1903437
     /* 1903437 */   GIM_Try, /*On fail goto*//*Label 25642*/ GIMT_Encode4(1903523), // Rule ID 19375 //
     /* 1903442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1903453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1903456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1903459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903488 */     // MIs[0] policy
     /* 1903488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903498 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1903501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903522 */     // GIR_Coverage, 19375,
     /* 1903522 */     GIR_EraseRootFromParent_Done,
     /* 1903523 */   // Label 25642: @1903523
     /* 1903523 */   GIM_Try, /*On fail goto*//*Label 25643*/ GIMT_Encode4(1903609), // Rule ID 19378 //
     /* 1903528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1903542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1903545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903574 */     // MIs[0] policy
     /* 1903574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903584 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1903587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903608 */     // GIR_Coverage, 19378,
     /* 1903608 */     GIR_EraseRootFromParent_Done,
     /* 1903609 */   // Label 25643: @1903609
     /* 1903609 */   GIM_Try, /*On fail goto*//*Label 25644*/ GIMT_Encode4(1903695), // Rule ID 19379 //
     /* 1903614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1903628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1903631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903660 */     // MIs[0] policy
     /* 1903660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903670 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1903673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903694 */     // GIR_Coverage, 19379,
     /* 1903694 */     GIR_EraseRootFromParent_Done,
     /* 1903695 */   // Label 25644: @1903695
     /* 1903695 */   GIM_Try, /*On fail goto*//*Label 25645*/ GIMT_Encode4(1903781), // Rule ID 19382 //
     /* 1903700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1903703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1903717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903746 */     // MIs[0] policy
     /* 1903746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903756 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1903759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903780 */     // GIR_Coverage, 19382,
     /* 1903780 */     GIR_EraseRootFromParent_Done,
     /* 1903781 */   // Label 25645: @1903781
     /* 1903781 */   GIM_Try, /*On fail goto*//*Label 25646*/ GIMT_Encode4(1903867), // Rule ID 19383 //
     /* 1903786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1903803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903832 */     // MIs[0] policy
     /* 1903832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903842 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1903845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903866 */     // GIR_Coverage, 19383,
     /* 1903866 */     GIR_EraseRootFromParent_Done,
     /* 1903867 */   // Label 25646: @1903867
     /* 1903867 */   GIM_Try, /*On fail goto*//*Label 25647*/ GIMT_Encode4(1903953), // Rule ID 19386 //
     /* 1903872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1903889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903918 */     // MIs[0] policy
     /* 1903918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903928 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1903931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903952 */     // GIR_Coverage, 19386,
     /* 1903952 */     GIR_EraseRootFromParent_Done,
     /* 1903953 */   // Label 25647: @1903953
     /* 1903953 */   GIM_Try, /*On fail goto*//*Label 25648*/ GIMT_Encode4(1904039), // Rule ID 19387 //
     /* 1903958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1903975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1904000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904004 */     // MIs[0] policy
     /* 1904004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904014 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1904017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904038 */     // GIR_Coverage, 19387,
     /* 1904038 */     GIR_EraseRootFromParent_Done,
     /* 1904039 */   // Label 25648: @1904039
     /* 1904039 */   GIM_Try, /*On fail goto*//*Label 25649*/ GIMT_Encode4(1904125), // Rule ID 19390 //
     /* 1904044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1904055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1904058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1904061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904090 */     // MIs[0] policy
     /* 1904090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904100 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1904103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904124 */     // GIR_Coverage, 19390,
     /* 1904124 */     GIR_EraseRootFromParent_Done,
     /* 1904125 */   // Label 25649: @1904125
     /* 1904125 */   GIM_Try, /*On fail goto*//*Label 25650*/ GIMT_Encode4(1904211), // Rule ID 19391 //
     /* 1904130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1904141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1904144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1904147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904176 */     // MIs[0] policy
     /* 1904176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904186 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1904189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904210 */     // GIR_Coverage, 19391,
     /* 1904210 */     GIR_EraseRootFromParent_Done,
     /* 1904211 */   // Label 25650: @1904211
     /* 1904211 */   GIM_Try, /*On fail goto*//*Label 25651*/ GIMT_Encode4(1904297), // Rule ID 19394 //
     /* 1904216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1904227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1904230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1904233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904262 */     // MIs[0] policy
     /* 1904262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904272 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1904275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904296 */     // GIR_Coverage, 19394,
     /* 1904296 */     GIR_EraseRootFromParent_Done,
     /* 1904297 */   // Label 25651: @1904297
     /* 1904297 */   GIM_Try, /*On fail goto*//*Label 25652*/ GIMT_Encode4(1904383), // Rule ID 19395 //
     /* 1904302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1904313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1904316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1904319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904348 */     // MIs[0] policy
     /* 1904348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904358 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1904361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904382 */     // GIR_Coverage, 19395,
     /* 1904382 */     GIR_EraseRootFromParent_Done,
     /* 1904383 */   // Label 25652: @1904383
     /* 1904383 */   GIM_Try, /*On fail goto*//*Label 25653*/ GIMT_Encode4(1904469), // Rule ID 19398 //
     /* 1904388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1904399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1904402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1904405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1904411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904434 */     // MIs[0] policy
     /* 1904434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904444 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1904447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904468 */     // GIR_Coverage, 19398,
     /* 1904468 */     GIR_EraseRootFromParent_Done,
     /* 1904469 */   // Label 25653: @1904469
     /* 1904469 */   GIM_Try, /*On fail goto*//*Label 25654*/ GIMT_Encode4(1904555), // Rule ID 19399 //
     /* 1904474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1904485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1904488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1904491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1904497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904520 */     // MIs[0] policy
     /* 1904520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904530 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1904533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904554 */     // GIR_Coverage, 19399,
     /* 1904554 */     GIR_EraseRootFromParent_Done,
     /* 1904555 */   // Label 25654: @1904555
     /* 1904555 */   GIM_Try, /*On fail goto*//*Label 25655*/ GIMT_Encode4(1904641), // Rule ID 19402 //
     /* 1904560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1904571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1904574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1904577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904606 */     // MIs[0] policy
     /* 1904606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904616 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1904619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904640 */     // GIR_Coverage, 19402,
     /* 1904640 */     GIR_EraseRootFromParent_Done,
     /* 1904641 */   // Label 25655: @1904641
     /* 1904641 */   GIM_Try, /*On fail goto*//*Label 25656*/ GIMT_Encode4(1904727), // Rule ID 19403 //
     /* 1904646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1904657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1904660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1904663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904692 */     // MIs[0] policy
     /* 1904692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904702 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1904705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904726 */     // GIR_Coverage, 19403,
     /* 1904726 */     GIR_EraseRootFromParent_Done,
     /* 1904727 */   // Label 25656: @1904727
     /* 1904727 */   GIM_Try, /*On fail goto*//*Label 25657*/ GIMT_Encode4(1904813), // Rule ID 19406 //
     /* 1904732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1904743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1904746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1904749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904778 */     // MIs[0] policy
     /* 1904778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904788 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1904791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904812 */     // GIR_Coverage, 19406,
     /* 1904812 */     GIR_EraseRootFromParent_Done,
     /* 1904813 */   // Label 25657: @1904813
     /* 1904813 */   GIM_Try, /*On fail goto*//*Label 25658*/ GIMT_Encode4(1904899), // Rule ID 19407 //
     /* 1904818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1904829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1904832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1904835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904864 */     // MIs[0] policy
     /* 1904864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904874 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1904877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904898 */     // GIR_Coverage, 19407,
     /* 1904898 */     GIR_EraseRootFromParent_Done,
     /* 1904899 */   // Label 25658: @1904899
     /* 1904899 */   GIM_Try, /*On fail goto*//*Label 25659*/ GIMT_Encode4(1904985), // Rule ID 19410 //
     /* 1904904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1904915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1904918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1904921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904950 */     // MIs[0] policy
     /* 1904950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904960 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1904963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904984 */     // GIR_Coverage, 19410,
     /* 1904984 */     GIR_EraseRootFromParent_Done,
     /* 1904985 */   // Label 25659: @1904985
     /* 1904985 */   GIM_Try, /*On fail goto*//*Label 25660*/ GIMT_Encode4(1905071), // Rule ID 19411 //
     /* 1904990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1905001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1905004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1905007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1905010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1905032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905036 */     // MIs[0] policy
     /* 1905036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905046 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1905049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905070 */     // GIR_Coverage, 19411,
     /* 1905070 */     GIR_EraseRootFromParent_Done,
     /* 1905071 */   // Label 25660: @1905071
     /* 1905071 */   GIM_Try, /*On fail goto*//*Label 25661*/ GIMT_Encode4(1905157), // Rule ID 19414 //
     /* 1905076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1905087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1905090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1905093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905122 */     // MIs[0] policy
     /* 1905122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905132 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1905135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905156 */     // GIR_Coverage, 19414,
     /* 1905156 */     GIR_EraseRootFromParent_Done,
     /* 1905157 */   // Label 25661: @1905157
     /* 1905157 */   GIM_Try, /*On fail goto*//*Label 25662*/ GIMT_Encode4(1905243), // Rule ID 19415 //
     /* 1905162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1905173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1905176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1905179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905208 */     // MIs[0] policy
     /* 1905208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905218 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1905221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905242 */     // GIR_Coverage, 19415,
     /* 1905242 */     GIR_EraseRootFromParent_Done,
     /* 1905243 */   // Label 25662: @1905243
     /* 1905243 */   GIM_Try, /*On fail goto*//*Label 25663*/ GIMT_Encode4(1905329), // Rule ID 19418 //
     /* 1905248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1905259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1905262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1905265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905294 */     // MIs[0] policy
     /* 1905294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905304 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1905307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905328 */     // GIR_Coverage, 19418,
     /* 1905328 */     GIR_EraseRootFromParent_Done,
     /* 1905329 */   // Label 25663: @1905329
     /* 1905329 */   GIM_Try, /*On fail goto*//*Label 25664*/ GIMT_Encode4(1905415), // Rule ID 19419 //
     /* 1905334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1905345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1905348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1905351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905380 */     // MIs[0] policy
     /* 1905380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905390 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1905393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905414 */     // GIR_Coverage, 19419,
     /* 1905414 */     GIR_EraseRootFromParent_Done,
     /* 1905415 */   // Label 25664: @1905415
     /* 1905415 */   GIM_Try, /*On fail goto*//*Label 25665*/ GIMT_Encode4(1905501), // Rule ID 19422 //
     /* 1905420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1905431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1905434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1905437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905466 */     // MIs[0] policy
     /* 1905466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905476 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1905479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905500 */     // GIR_Coverage, 19422,
     /* 1905500 */     GIR_EraseRootFromParent_Done,
     /* 1905501 */   // Label 25665: @1905501
     /* 1905501 */   GIM_Try, /*On fail goto*//*Label 25666*/ GIMT_Encode4(1905587), // Rule ID 19423 //
     /* 1905506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1905517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1905520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1905523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905552 */     // MIs[0] policy
     /* 1905552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905562 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1905565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905586 */     // GIR_Coverage, 19423,
     /* 1905586 */     GIR_EraseRootFromParent_Done,
     /* 1905587 */   // Label 25666: @1905587
     /* 1905587 */   GIM_Try, /*On fail goto*//*Label 25667*/ GIMT_Encode4(1905673), // Rule ID 19426 //
     /* 1905592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1905603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1905606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1905609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1905612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905638 */     // MIs[0] policy
     /* 1905638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905648 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1905651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905672 */     // GIR_Coverage, 19426,
     /* 1905672 */     GIR_EraseRootFromParent_Done,
     /* 1905673 */   // Label 25667: @1905673
     /* 1905673 */   GIM_Try, /*On fail goto*//*Label 25668*/ GIMT_Encode4(1905759), // Rule ID 19427 //
     /* 1905678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1905689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1905692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1905695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1905698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905724 */     // MIs[0] policy
     /* 1905724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905734 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1905737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905758 */     // GIR_Coverage, 19427,
     /* 1905758 */     GIR_EraseRootFromParent_Done,
     /* 1905759 */   // Label 25668: @1905759
     /* 1905759 */   GIM_Try, /*On fail goto*//*Label 25669*/ GIMT_Encode4(1905845), // Rule ID 19430 //
     /* 1905764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1905775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1905778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1905781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1905784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905810 */     // MIs[0] policy
     /* 1905810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905820 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1905823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905844 */     // GIR_Coverage, 19430,
     /* 1905844 */     GIR_EraseRootFromParent_Done,
     /* 1905845 */   // Label 25669: @1905845
     /* 1905845 */   GIM_Try, /*On fail goto*//*Label 25670*/ GIMT_Encode4(1905931), // Rule ID 19431 //
     /* 1905850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1905861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1905864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1905867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1905870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905896 */     // MIs[0] policy
     /* 1905896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905906 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1905909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905930 */     // GIR_Coverage, 19431,
     /* 1905930 */     GIR_EraseRootFromParent_Done,
     /* 1905931 */   // Label 25670: @1905931
     /* 1905931 */   GIM_Try, /*On fail goto*//*Label 25671*/ GIMT_Encode4(1906017), // Rule ID 19434 //
     /* 1905936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1905947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1905950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1905953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1905956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905982 */     // MIs[0] policy
     /* 1905982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905992 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1905995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906016 */     // GIR_Coverage, 19434,
     /* 1906016 */     GIR_EraseRootFromParent_Done,
     /* 1906017 */   // Label 25671: @1906017
     /* 1906017 */   GIM_Try, /*On fail goto*//*Label 25672*/ GIMT_Encode4(1906103), // Rule ID 19435 //
     /* 1906022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1906025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1906033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1906036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1906039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1906042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906068 */     // MIs[0] policy
     /* 1906068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906078 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1906081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906102 */     // GIR_Coverage, 19435,
     /* 1906102 */     GIR_EraseRootFromParent_Done,
     /* 1906103 */   // Label 25672: @1906103
     /* 1906103 */   GIM_Try, /*On fail goto*//*Label 25673*/ GIMT_Encode4(1906189), // Rule ID 19438 //
     /* 1906108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1906119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1906122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1906125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1906128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906154 */     // MIs[0] policy
     /* 1906154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906164 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1906167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906188 */     // GIR_Coverage, 19438,
     /* 1906188 */     GIR_EraseRootFromParent_Done,
     /* 1906189 */   // Label 25673: @1906189
     /* 1906189 */   GIM_Try, /*On fail goto*//*Label 25674*/ GIMT_Encode4(1906275), // Rule ID 19439 //
     /* 1906194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1906205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1906208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1906211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1906214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906240 */     // MIs[0] policy
     /* 1906240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906250 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1906253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906274 */     // GIR_Coverage, 19439,
     /* 1906274 */     GIR_EraseRootFromParent_Done,
     /* 1906275 */   // Label 25674: @1906275
     /* 1906275 */   GIM_Try, /*On fail goto*//*Label 25675*/ GIMT_Encode4(1906361), // Rule ID 19442 //
     /* 1906280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1906283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1906291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1906294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1906297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1906300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906326 */     // MIs[0] policy
     /* 1906326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906336 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1906339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906360 */     // GIR_Coverage, 19442,
     /* 1906360 */     GIR_EraseRootFromParent_Done,
     /* 1906361 */   // Label 25675: @1906361
     /* 1906361 */   GIM_Try, /*On fail goto*//*Label 25676*/ GIMT_Encode4(1906447), // Rule ID 19443 //
     /* 1906366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1906369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1906377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1906380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1906383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1906386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906412 */     // MIs[0] policy
     /* 1906412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906422 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1906425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906446 */     // GIR_Coverage, 19443,
     /* 1906446 */     GIR_EraseRootFromParent_Done,
     /* 1906447 */   // Label 25676: @1906447
     /* 1906447 */   GIM_Try, /*On fail goto*//*Label 25677*/ GIMT_Encode4(1906533), // Rule ID 19446 //
     /* 1906452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1906455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1906469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906498 */     // MIs[0] policy
     /* 1906498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906508 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1906511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906532 */     // GIR_Coverage, 19446,
     /* 1906532 */     GIR_EraseRootFromParent_Done,
     /* 1906533 */   // Label 25677: @1906533
     /* 1906533 */   GIM_Try, /*On fail goto*//*Label 25678*/ GIMT_Encode4(1906619), // Rule ID 19447 //
     /* 1906538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1906541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1906555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906584 */     // MIs[0] policy
     /* 1906584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906594 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1906597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906618 */     // GIR_Coverage, 19447,
     /* 1906618 */     GIR_EraseRootFromParent_Done,
     /* 1906619 */   // Label 25678: @1906619
     /* 1906619 */   GIM_Try, /*On fail goto*//*Label 25679*/ GIMT_Encode4(1906705), // Rule ID 19450 //
     /* 1906624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1906635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1906638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1906641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1906644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906670 */     // MIs[0] policy
     /* 1906670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906680 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1906683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906704 */     // GIR_Coverage, 19450,
     /* 1906704 */     GIR_EraseRootFromParent_Done,
     /* 1906705 */   // Label 25679: @1906705
     /* 1906705 */   GIM_Try, /*On fail goto*//*Label 25680*/ GIMT_Encode4(1906791), // Rule ID 19451 //
     /* 1906710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1906721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1906724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1906727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1906730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906756 */     // MIs[0] policy
     /* 1906756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906766 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1906769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906790 */     // GIR_Coverage, 19451,
     /* 1906790 */     GIR_EraseRootFromParent_Done,
     /* 1906791 */   // Label 25680: @1906791
     /* 1906791 */   GIM_Try, /*On fail goto*//*Label 25681*/ GIMT_Encode4(1906877), // Rule ID 19454 //
     /* 1906796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1906807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1906810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1906813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1906816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1906819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906842 */     // MIs[0] policy
     /* 1906842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906852 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1906855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906876 */     // GIR_Coverage, 19454,
     /* 1906876 */     GIR_EraseRootFromParent_Done,
     /* 1906877 */   // Label 25681: @1906877
     /* 1906877 */   GIM_Try, /*On fail goto*//*Label 25682*/ GIMT_Encode4(1906963), // Rule ID 19455 //
     /* 1906882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1906893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1906896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1906899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1906902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1906905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906928 */     // MIs[0] policy
     /* 1906928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906938 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1906941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906962 */     // GIR_Coverage, 19455,
     /* 1906962 */     GIR_EraseRootFromParent_Done,
     /* 1906963 */   // Label 25682: @1906963
     /* 1906963 */   GIM_Try, /*On fail goto*//*Label 25683*/ GIMT_Encode4(1907049), // Rule ID 19458 //
     /* 1906968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1906979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1906982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1906985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1906988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1906991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1906998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907014 */     // MIs[0] policy
     /* 1907014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907024 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1907027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907048 */     // GIR_Coverage, 19458,
     /* 1907048 */     GIR_EraseRootFromParent_Done,
     /* 1907049 */   // Label 25683: @1907049
     /* 1907049 */   GIM_Try, /*On fail goto*//*Label 25684*/ GIMT_Encode4(1907135), // Rule ID 19459 //
     /* 1907054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1907065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1907068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1907071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1907074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1907077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907100 */     // MIs[0] policy
     /* 1907100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907110 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1907113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907134 */     // GIR_Coverage, 19459,
     /* 1907134 */     GIR_EraseRootFromParent_Done,
     /* 1907135 */   // Label 25684: @1907135
     /* 1907135 */   GIM_Try, /*On fail goto*//*Label 25685*/ GIMT_Encode4(1907221), // Rule ID 19462 //
     /* 1907140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1907151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1907154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1907157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1907160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907186 */     // MIs[0] policy
     /* 1907186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907196 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1907199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907220 */     // GIR_Coverage, 19462,
     /* 1907220 */     GIR_EraseRootFromParent_Done,
     /* 1907221 */   // Label 25685: @1907221
     /* 1907221 */   GIM_Try, /*On fail goto*//*Label 25686*/ GIMT_Encode4(1907307), // Rule ID 19463 //
     /* 1907226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1907237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1907240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1907243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1907246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907272 */     // MIs[0] policy
     /* 1907272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907282 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1907285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907306 */     // GIR_Coverage, 19463,
     /* 1907306 */     GIR_EraseRootFromParent_Done,
     /* 1907307 */   // Label 25686: @1907307
     /* 1907307 */   GIM_Try, /*On fail goto*//*Label 25687*/ GIMT_Encode4(1907393), // Rule ID 19466 //
     /* 1907312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1907323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1907326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1907329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1907332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907358 */     // MIs[0] policy
     /* 1907358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907368 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1907371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907392 */     // GIR_Coverage, 19466,
     /* 1907392 */     GIR_EraseRootFromParent_Done,
     /* 1907393 */   // Label 25687: @1907393
     /* 1907393 */   GIM_Try, /*On fail goto*//*Label 25688*/ GIMT_Encode4(1907479), // Rule ID 19467 //
     /* 1907398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1907409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1907412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1907415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1907418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907444 */     // MIs[0] policy
     /* 1907444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907454 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1907457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907478 */     // GIR_Coverage, 19467,
     /* 1907478 */     GIR_EraseRootFromParent_Done,
     /* 1907479 */   // Label 25688: @1907479
     /* 1907479 */   GIM_Try, /*On fail goto*//*Label 25689*/ GIMT_Encode4(1907565), // Rule ID 19470 //
     /* 1907484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1907495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1907498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1907501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1907504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907530 */     // MIs[0] policy
     /* 1907530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907540 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1907543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907564 */     // GIR_Coverage, 19470,
     /* 1907564 */     GIR_EraseRootFromParent_Done,
     /* 1907565 */   // Label 25689: @1907565
     /* 1907565 */   GIM_Try, /*On fail goto*//*Label 25690*/ GIMT_Encode4(1907651), // Rule ID 19471 //
     /* 1907570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1907581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1907584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1907587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1907590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907616 */     // MIs[0] policy
     /* 1907616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907626 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1907629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907650 */     // GIR_Coverage, 19471,
     /* 1907650 */     GIR_EraseRootFromParent_Done,
     /* 1907651 */   // Label 25690: @1907651
     /* 1907651 */   GIM_Try, /*On fail goto*//*Label 25691*/ GIMT_Encode4(1907737), // Rule ID 19474 //
     /* 1907656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1907667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1907670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1907673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1907676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907702 */     // MIs[0] policy
     /* 1907702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907712 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1907715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907736 */     // GIR_Coverage, 19474,
     /* 1907736 */     GIR_EraseRootFromParent_Done,
     /* 1907737 */   // Label 25691: @1907737
     /* 1907737 */   GIM_Try, /*On fail goto*//*Label 25692*/ GIMT_Encode4(1907823), // Rule ID 19475 //
     /* 1907742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1907753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1907756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1907759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1907762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907788 */     // MIs[0] policy
     /* 1907788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907798 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1907801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907822 */     // GIR_Coverage, 19475,
     /* 1907822 */     GIR_EraseRootFromParent_Done,
     /* 1907823 */   // Label 25692: @1907823
     /* 1907823 */   GIM_Try, /*On fail goto*//*Label 25693*/ GIMT_Encode4(1907909), // Rule ID 19478 //
     /* 1907828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1907839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1907842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1907845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1907848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907874 */     // MIs[0] policy
     /* 1907874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907884 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1907887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907908 */     // GIR_Coverage, 19478,
     /* 1907908 */     GIR_EraseRootFromParent_Done,
     /* 1907909 */   // Label 25693: @1907909
     /* 1907909 */   GIM_Try, /*On fail goto*//*Label 25694*/ GIMT_Encode4(1907995), // Rule ID 19479 //
     /* 1907914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1907925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1907928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1907931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1907934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907960 */     // MIs[0] policy
     /* 1907960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907970 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1907973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907994 */     // GIR_Coverage, 19479,
     /* 1907994 */     GIR_EraseRootFromParent_Done,
     /* 1907995 */   // Label 25694: @1907995
     /* 1907995 */   GIM_Try, /*On fail goto*//*Label 25695*/ GIMT_Encode4(1908081), // Rule ID 19482 //
     /* 1908000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1908003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1908011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1908014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1908017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1908020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1908030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908046 */     // MIs[0] policy
     /* 1908046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908056 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1908059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908080 */     // GIR_Coverage, 19482,
     /* 1908080 */     GIR_EraseRootFromParent_Done,
     /* 1908081 */   // Label 25695: @1908081
     /* 1908081 */   GIM_Try, /*On fail goto*//*Label 25696*/ GIMT_Encode4(1908167), // Rule ID 19483 //
     /* 1908086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1908089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1908097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1908100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1908103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1908106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1908116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908132 */     // MIs[0] policy
     /* 1908132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908142 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1908145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908166 */     // GIR_Coverage, 19483,
     /* 1908166 */     GIR_EraseRootFromParent_Done,
     /* 1908167 */   // Label 25696: @1908167
     /* 1908167 */   GIM_Try, /*On fail goto*//*Label 25697*/ GIMT_Encode4(1908253), // Rule ID 19486 //
     /* 1908172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1908183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1908186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1908189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908218 */     // MIs[0] policy
     /* 1908218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908228 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1908231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908252 */     // GIR_Coverage, 19486,
     /* 1908252 */     GIR_EraseRootFromParent_Done,
     /* 1908253 */   // Label 25697: @1908253
     /* 1908253 */   GIM_Try, /*On fail goto*//*Label 25698*/ GIMT_Encode4(1908339), // Rule ID 19487 //
     /* 1908258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1908269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1908272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1908275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908304 */     // MIs[0] policy
     /* 1908304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908314 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1908317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908338 */     // GIR_Coverage, 19487,
     /* 1908338 */     GIR_EraseRootFromParent_Done,
     /* 1908339 */   // Label 25698: @1908339
     /* 1908339 */   GIM_Try, /*On fail goto*//*Label 25699*/ GIMT_Encode4(1908425), // Rule ID 19490 //
     /* 1908344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1908355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1908358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1908361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908390 */     // MIs[0] policy
     /* 1908390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908400 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1908403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908424 */     // GIR_Coverage, 19490,
     /* 1908424 */     GIR_EraseRootFromParent_Done,
     /* 1908425 */   // Label 25699: @1908425
     /* 1908425 */   GIM_Try, /*On fail goto*//*Label 25700*/ GIMT_Encode4(1908511), // Rule ID 19491 //
     /* 1908430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1908441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1908444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1908447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908476 */     // MIs[0] policy
     /* 1908476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908486 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1908489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908510 */     // GIR_Coverage, 19491,
     /* 1908510 */     GIR_EraseRootFromParent_Done,
     /* 1908511 */   // Label 25700: @1908511
     /* 1908511 */   GIM_Try, /*On fail goto*//*Label 25701*/ GIMT_Encode4(1908597), // Rule ID 19494 //
     /* 1908516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1908527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1908530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1908533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908562 */     // MIs[0] policy
     /* 1908562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908572 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1908575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908596 */     // GIR_Coverage, 19494,
     /* 1908596 */     GIR_EraseRootFromParent_Done,
     /* 1908597 */   // Label 25701: @1908597
     /* 1908597 */   GIM_Try, /*On fail goto*//*Label 25702*/ GIMT_Encode4(1908683), // Rule ID 19495 //
     /* 1908602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1908613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1908616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1908619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908648 */     // MIs[0] policy
     /* 1908648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908658 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1908661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908682 */     // GIR_Coverage, 19495,
     /* 1908682 */     GIR_EraseRootFromParent_Done,
     /* 1908683 */   // Label 25702: @1908683
     /* 1908683 */   GIM_Try, /*On fail goto*//*Label 25703*/ GIMT_Encode4(1908769), // Rule ID 19498 //
     /* 1908688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1908699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1908702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1908705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908734 */     // MIs[0] policy
     /* 1908734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908744 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1908747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908768 */     // GIR_Coverage, 19498,
     /* 1908768 */     GIR_EraseRootFromParent_Done,
     /* 1908769 */   // Label 25703: @1908769
     /* 1908769 */   GIM_Try, /*On fail goto*//*Label 25704*/ GIMT_Encode4(1908855), // Rule ID 19499 //
     /* 1908774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1908785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1908788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1908791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908820 */     // MIs[0] policy
     /* 1908820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908830 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1908833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908854 */     // GIR_Coverage, 19499,
     /* 1908854 */     GIR_EraseRootFromParent_Done,
     /* 1908855 */   // Label 25704: @1908855
     /* 1908855 */   GIM_Try, /*On fail goto*//*Label 25705*/ GIMT_Encode4(1908941), // Rule ID 19502 //
     /* 1908860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1908877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908906 */     // MIs[0] policy
     /* 1908906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908916 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1908919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908940 */     // GIR_Coverage, 19502,
     /* 1908940 */     GIR_EraseRootFromParent_Done,
     /* 1908941 */   // Label 25705: @1908941
     /* 1908941 */   GIM_Try, /*On fail goto*//*Label 25706*/ GIMT_Encode4(1909027), // Rule ID 19503 //
     /* 1908946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1908963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908992 */     // MIs[0] policy
     /* 1908992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909002 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1909005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909026 */     // GIR_Coverage, 19503,
     /* 1909026 */     GIR_EraseRootFromParent_Done,
     /* 1909027 */   // Label 25706: @1909027
     /* 1909027 */   GIM_Try, /*On fail goto*//*Label 25707*/ GIMT_Encode4(1909113), // Rule ID 19506 //
     /* 1909032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1909035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1909049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1909052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1909074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909078 */     // MIs[0] policy
     /* 1909078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909088 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1909091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909112 */     // GIR_Coverage, 19506,
     /* 1909112 */     GIR_EraseRootFromParent_Done,
     /* 1909113 */   // Label 25707: @1909113
     /* 1909113 */   GIM_Try, /*On fail goto*//*Label 25708*/ GIMT_Encode4(1909199), // Rule ID 19507 //
     /* 1909118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1909121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1909135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1909138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1909160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909164 */     // MIs[0] policy
     /* 1909164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909174 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1909177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909198 */     // GIR_Coverage, 19507,
     /* 1909198 */     GIR_EraseRootFromParent_Done,
     /* 1909199 */   // Label 25708: @1909199
     /* 1909199 */   GIM_Try, /*On fail goto*//*Label 25709*/ GIMT_Encode4(1909285), // Rule ID 19510 //
     /* 1909204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1909215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1909218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1909221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909250 */     // MIs[0] policy
     /* 1909250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909260 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1909263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909284 */     // GIR_Coverage, 19510,
     /* 1909284 */     GIR_EraseRootFromParent_Done,
     /* 1909285 */   // Label 25709: @1909285
     /* 1909285 */   GIM_Try, /*On fail goto*//*Label 25710*/ GIMT_Encode4(1909371), // Rule ID 19511 //
     /* 1909290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1909301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1909304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1909307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909336 */     // MIs[0] policy
     /* 1909336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909346 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1909349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909370 */     // GIR_Coverage, 19511,
     /* 1909370 */     GIR_EraseRootFromParent_Done,
     /* 1909371 */   // Label 25710: @1909371
     /* 1909371 */   GIM_Try, /*On fail goto*//*Label 25711*/ GIMT_Encode4(1909457), // Rule ID 19514 //
     /* 1909376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1909387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1909390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1909393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909422 */     // MIs[0] policy
     /* 1909422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909432 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1909435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909456 */     // GIR_Coverage, 19514,
     /* 1909456 */     GIR_EraseRootFromParent_Done,
     /* 1909457 */   // Label 25711: @1909457
     /* 1909457 */   GIM_Try, /*On fail goto*//*Label 25712*/ GIMT_Encode4(1909543), // Rule ID 19515 //
     /* 1909462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1909473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1909476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1909479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909508 */     // MIs[0] policy
     /* 1909508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909518 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1909521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909542 */     // GIR_Coverage, 19515,
     /* 1909542 */     GIR_EraseRootFromParent_Done,
     /* 1909543 */   // Label 25712: @1909543
     /* 1909543 */   GIM_Try, /*On fail goto*//*Label 25713*/ GIMT_Encode4(1909629), // Rule ID 19518 //
     /* 1909548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1909559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1909562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1909565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1909571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909594 */     // MIs[0] policy
     /* 1909594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909604 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1909607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909628 */     // GIR_Coverage, 19518,
     /* 1909628 */     GIR_EraseRootFromParent_Done,
     /* 1909629 */   // Label 25713: @1909629
     /* 1909629 */   GIM_Try, /*On fail goto*//*Label 25714*/ GIMT_Encode4(1909715), // Rule ID 19519 //
     /* 1909634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1909645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1909648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1909651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1909657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909680 */     // MIs[0] policy
     /* 1909680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909690 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1909693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909714 */     // GIR_Coverage, 19519,
     /* 1909714 */     GIR_EraseRootFromParent_Done,
     /* 1909715 */   // Label 25714: @1909715
     /* 1909715 */   GIM_Try, /*On fail goto*//*Label 25715*/ GIMT_Encode4(1909801), // Rule ID 19522 //
     /* 1909720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1909731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1909734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1909737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909766 */     // MIs[0] policy
     /* 1909766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909776 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1909779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909800 */     // GIR_Coverage, 19522,
     /* 1909800 */     GIR_EraseRootFromParent_Done,
     /* 1909801 */   // Label 25715: @1909801
     /* 1909801 */   GIM_Try, /*On fail goto*//*Label 25716*/ GIMT_Encode4(1909887), // Rule ID 19523 //
     /* 1909806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1909817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1909820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1909823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909852 */     // MIs[0] policy
     /* 1909852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909862 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1909865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909886 */     // GIR_Coverage, 19523,
     /* 1909886 */     GIR_EraseRootFromParent_Done,
     /* 1909887 */   // Label 25716: @1909887
     /* 1909887 */   GIM_Try, /*On fail goto*//*Label 25717*/ GIMT_Encode4(1909973), // Rule ID 19526 //
     /* 1909892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1909903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1909906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1909909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909938 */     // MIs[0] policy
     /* 1909938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909948 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1909951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909972 */     // GIR_Coverage, 19526,
     /* 1909972 */     GIR_EraseRootFromParent_Done,
     /* 1909973 */   // Label 25717: @1909973
     /* 1909973 */   GIM_Try, /*On fail goto*//*Label 25718*/ GIMT_Encode4(1910059), // Rule ID 19527 //
     /* 1909978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1909989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1909992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1909995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1910020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910024 */     // MIs[0] policy
     /* 1910024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910034 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1910037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910058 */     // GIR_Coverage, 19527,
     /* 1910058 */     GIR_EraseRootFromParent_Done,
     /* 1910059 */   // Label 25718: @1910059
     /* 1910059 */   GIM_Try, /*On fail goto*//*Label 25719*/ GIMT_Encode4(1910145), // Rule ID 19530 //
     /* 1910064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1910075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1910078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1910081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1910084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1910106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910110 */     // MIs[0] policy
     /* 1910110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910120 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1910123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910144 */     // GIR_Coverage, 19530,
     /* 1910144 */     GIR_EraseRootFromParent_Done,
     /* 1910145 */   // Label 25719: @1910145
     /* 1910145 */   GIM_Try, /*On fail goto*//*Label 25720*/ GIMT_Encode4(1910231), // Rule ID 19531 //
     /* 1910150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1910161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1910164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1910167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1910170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1910192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910196 */     // MIs[0] policy
     /* 1910196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910206 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1910209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910230 */     // GIR_Coverage, 19531,
     /* 1910230 */     GIR_EraseRootFromParent_Done,
     /* 1910231 */   // Label 25720: @1910231
     /* 1910231 */   GIM_Try, /*On fail goto*//*Label 25721*/ GIMT_Encode4(1910317), // Rule ID 19534 //
     /* 1910236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1910239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1910247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1910250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1910253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910282 */     // MIs[0] policy
     /* 1910282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910292 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1910295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910316 */     // GIR_Coverage, 19534,
     /* 1910316 */     GIR_EraseRootFromParent_Done,
     /* 1910317 */   // Label 25721: @1910317
     /* 1910317 */   GIM_Try, /*On fail goto*//*Label 25722*/ GIMT_Encode4(1910403), // Rule ID 19535 //
     /* 1910322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1910333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1910336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1910339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910368 */     // MIs[0] policy
     /* 1910368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910378 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1910381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910402 */     // GIR_Coverage, 19535,
     /* 1910402 */     GIR_EraseRootFromParent_Done,
     /* 1910403 */   // Label 25722: @1910403
     /* 1910403 */   GIM_Try, /*On fail goto*//*Label 25723*/ GIMT_Encode4(1910489), // Rule ID 19538 //
     /* 1910408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1910411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1910419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1910422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1910425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910454 */     // MIs[0] policy
     /* 1910454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910464 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1910467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910488 */     // GIR_Coverage, 19538,
     /* 1910488 */     GIR_EraseRootFromParent_Done,
     /* 1910489 */   // Label 25723: @1910489
     /* 1910489 */   GIM_Try, /*On fail goto*//*Label 25724*/ GIMT_Encode4(1910575), // Rule ID 19539 //
     /* 1910494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1910505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1910508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1910511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910540 */     // MIs[0] policy
     /* 1910540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910550 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1910553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910574 */     // GIR_Coverage, 19539,
     /* 1910574 */     GIR_EraseRootFromParent_Done,
     /* 1910575 */   // Label 25724: @1910575
     /* 1910575 */   GIM_Try, /*On fail goto*//*Label 25725*/ GIMT_Encode4(1910661), // Rule ID 19542 //
     /* 1910580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1910583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1910591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1910594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1910597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910626 */     // MIs[0] policy
     /* 1910626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910636 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1910639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910660 */     // GIR_Coverage, 19542,
     /* 1910660 */     GIR_EraseRootFromParent_Done,
     /* 1910661 */   // Label 25725: @1910661
     /* 1910661 */   GIM_Try, /*On fail goto*//*Label 25726*/ GIMT_Encode4(1910747), // Rule ID 19543 //
     /* 1910666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1910677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1910680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1910683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910712 */     // MIs[0] policy
     /* 1910712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910722 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1910725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910746 */     // GIR_Coverage, 19543,
     /* 1910746 */     GIR_EraseRootFromParent_Done,
     /* 1910747 */   // Label 25726: @1910747
     /* 1910747 */   GIM_Try, /*On fail goto*//*Label 25727*/ GIMT_Encode4(1910833), // Rule ID 19546 //
     /* 1910752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1910763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1910766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1910769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1910772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910798 */     // MIs[0] policy
     /* 1910798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910808 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1910811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910832 */     // GIR_Coverage, 19546,
     /* 1910832 */     GIR_EraseRootFromParent_Done,
     /* 1910833 */   // Label 25727: @1910833
     /* 1910833 */   GIM_Try, /*On fail goto*//*Label 25728*/ GIMT_Encode4(1910919), // Rule ID 19547 //
     /* 1910838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1910849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1910852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1910855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1910858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910884 */     // MIs[0] policy
     /* 1910884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910894 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1910897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910918 */     // GIR_Coverage, 19547,
     /* 1910918 */     GIR_EraseRootFromParent_Done,
     /* 1910919 */   // Label 25728: @1910919
     /* 1910919 */   GIM_Try, /*On fail goto*//*Label 25729*/ GIMT_Encode4(1911005), // Rule ID 19550 //
     /* 1910924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1910935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1910938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1910941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1910944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910970 */     // MIs[0] policy
     /* 1910970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910980 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1910983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911004 */     // GIR_Coverage, 19550,
     /* 1911004 */     GIR_EraseRootFromParent_Done,
     /* 1911005 */   // Label 25729: @1911005
     /* 1911005 */   GIM_Try, /*On fail goto*//*Label 25730*/ GIMT_Encode4(1911091), // Rule ID 19551 //
     /* 1911010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1911021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1911024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1911027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1911030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911056 */     // MIs[0] policy
     /* 1911056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911066 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1911069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911090 */     // GIR_Coverage, 19551,
     /* 1911090 */     GIR_EraseRootFromParent_Done,
     /* 1911091 */   // Label 25730: @1911091
     /* 1911091 */   GIM_Try, /*On fail goto*//*Label 25731*/ GIMT_Encode4(1911177), // Rule ID 19554 //
     /* 1911096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1911099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1911107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1911110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1911113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1911116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911142 */     // MIs[0] policy
     /* 1911142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911152 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1911155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911176 */     // GIR_Coverage, 19554,
     /* 1911176 */     GIR_EraseRootFromParent_Done,
     /* 1911177 */   // Label 25731: @1911177
     /* 1911177 */   GIM_Try, /*On fail goto*//*Label 25732*/ GIMT_Encode4(1911263), // Rule ID 19555 //
     /* 1911182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1911185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1911193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1911196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1911199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1911202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911228 */     // MIs[0] policy
     /* 1911228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911238 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1911241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911262 */     // GIR_Coverage, 19555,
     /* 1911262 */     GIR_EraseRootFromParent_Done,
     /* 1911263 */   // Label 25732: @1911263
     /* 1911263 */   GIM_Try, /*On fail goto*//*Label 25733*/ GIMT_Encode4(1911349), // Rule ID 19558 //
     /* 1911268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1911279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1911282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1911285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1911288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911314 */     // MIs[0] policy
     /* 1911314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911324 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1911327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911348 */     // GIR_Coverage, 19558,
     /* 1911348 */     GIR_EraseRootFromParent_Done,
     /* 1911349 */   // Label 25733: @1911349
     /* 1911349 */   GIM_Try, /*On fail goto*//*Label 25734*/ GIMT_Encode4(1911435), // Rule ID 19559 //
     /* 1911354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1911365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1911368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1911371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1911374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911400 */     // MIs[0] policy
     /* 1911400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911410 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1911413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911434 */     // GIR_Coverage, 19559,
     /* 1911434 */     GIR_EraseRootFromParent_Done,
     /* 1911435 */   // Label 25734: @1911435
     /* 1911435 */   GIM_Try, /*On fail goto*//*Label 25735*/ GIMT_Encode4(1911521), // Rule ID 19562 //
     /* 1911440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1911443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1911451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1911454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1911457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1911460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911486 */     // MIs[0] policy
     /* 1911486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911496 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1911499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911520 */     // GIR_Coverage, 19562,
     /* 1911520 */     GIR_EraseRootFromParent_Done,
     /* 1911521 */   // Label 25735: @1911521
     /* 1911521 */   GIM_Try, /*On fail goto*//*Label 25736*/ GIMT_Encode4(1911607), // Rule ID 19563 //
     /* 1911526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1911529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1911537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1911540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1911543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1911546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911572 */     // MIs[0] policy
     /* 1911572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911582 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1911585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911606 */     // GIR_Coverage, 19563,
     /* 1911606 */     GIR_EraseRootFromParent_Done,
     /* 1911607 */   // Label 25736: @1911607
     /* 1911607 */   GIM_Try, /*On fail goto*//*Label 25737*/ GIMT_Encode4(1911693), // Rule ID 19566 //
     /* 1911612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1911615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1911623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1911626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1911629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1911632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911658 */     // MIs[0] policy
     /* 1911658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911668 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1911671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911692 */     // GIR_Coverage, 19566,
     /* 1911692 */     GIR_EraseRootFromParent_Done,
     /* 1911693 */   // Label 25737: @1911693
     /* 1911693 */   GIM_Try, /*On fail goto*//*Label 25738*/ GIMT_Encode4(1911779), // Rule ID 19567 //
     /* 1911698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1911701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1911709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1911712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1911715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1911718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911744 */     // MIs[0] policy
     /* 1911744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911754 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1911757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911778 */     // GIR_Coverage, 19567,
     /* 1911778 */     GIR_EraseRootFromParent_Done,
     /* 1911779 */   // Label 25738: @1911779
     /* 1911779 */   GIM_Try, /*On fail goto*//*Label 25739*/ GIMT_Encode4(1911865), // Rule ID 19570 //
     /* 1911784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1911795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1911798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1911801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1911804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911830 */     // MIs[0] policy
     /* 1911830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911840 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1911843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911864 */     // GIR_Coverage, 19570,
     /* 1911864 */     GIR_EraseRootFromParent_Done,
     /* 1911865 */   // Label 25739: @1911865
     /* 1911865 */   GIM_Try, /*On fail goto*//*Label 25740*/ GIMT_Encode4(1911951), // Rule ID 19571 //
     /* 1911870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1911881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1911884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1911887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1911890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911916 */     // MIs[0] policy
     /* 1911916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911926 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1911929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911950 */     // GIR_Coverage, 19571,
     /* 1911950 */     GIR_EraseRootFromParent_Done,
     /* 1911951 */   // Label 25740: @1911951
     /* 1911951 */   GIM_Try, /*On fail goto*//*Label 25741*/ GIMT_Encode4(1912037), // Rule ID 19574 //
     /* 1911956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1911967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1911970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1911973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1911976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1911979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1911986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912002 */     // MIs[0] policy
     /* 1912002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912012 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1912015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912036 */     // GIR_Coverage, 19574,
     /* 1912036 */     GIR_EraseRootFromParent_Done,
     /* 1912037 */   // Label 25741: @1912037
     /* 1912037 */   GIM_Try, /*On fail goto*//*Label 25742*/ GIMT_Encode4(1912123), // Rule ID 19575 //
     /* 1912042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1912053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1912056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1912059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1912062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912088 */     // MIs[0] policy
     /* 1912088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912098 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1912101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912122 */     // GIR_Coverage, 19575,
     /* 1912122 */     GIR_EraseRootFromParent_Done,
     /* 1912123 */   // Label 25742: @1912123
     /* 1912123 */   GIM_Try, /*On fail goto*//*Label 25743*/ GIMT_Encode4(1912209), // Rule ID 19578 //
     /* 1912128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1912131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1912139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1912142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1912145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1912148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1912151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912174 */     // MIs[0] policy
     /* 1912174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912184 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1912187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912208 */     // GIR_Coverage, 19578,
     /* 1912208 */     GIR_EraseRootFromParent_Done,
     /* 1912209 */   // Label 25743: @1912209
     /* 1912209 */   GIM_Try, /*On fail goto*//*Label 25744*/ GIMT_Encode4(1912295), // Rule ID 19579 //
     /* 1912214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1912225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1912228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1912231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1912234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1912237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912260 */     // MIs[0] policy
     /* 1912260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912270 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1912273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912294 */     // GIR_Coverage, 19579,
     /* 1912294 */     GIR_EraseRootFromParent_Done,
     /* 1912295 */   // Label 25744: @1912295
     /* 1912295 */   GIM_Try, /*On fail goto*//*Label 25745*/ GIMT_Encode4(1912381), // Rule ID 19582 //
     /* 1912300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1912311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1912314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1912317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1912320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912346 */     // MIs[0] policy
     /* 1912346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912356 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1912359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912380 */     // GIR_Coverage, 19582,
     /* 1912380 */     GIR_EraseRootFromParent_Done,
     /* 1912381 */   // Label 25745: @1912381
     /* 1912381 */   GIM_Try, /*On fail goto*//*Label 25746*/ GIMT_Encode4(1912467), // Rule ID 19583 //
     /* 1912386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1912397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1912400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1912403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1912406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912432 */     // MIs[0] policy
     /* 1912432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912442 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1912445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912466 */     // GIR_Coverage, 19583,
     /* 1912466 */     GIR_EraseRootFromParent_Done,
     /* 1912467 */   // Label 25746: @1912467
     /* 1912467 */   GIM_Try, /*On fail goto*//*Label 25747*/ GIMT_Encode4(1912553), // Rule ID 19586 //
     /* 1912472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1912483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1912486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1912489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1912492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912518 */     // MIs[0] policy
     /* 1912518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912528 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1912531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912552 */     // GIR_Coverage, 19586,
     /* 1912552 */     GIR_EraseRootFromParent_Done,
     /* 1912553 */   // Label 25747: @1912553
     /* 1912553 */   GIM_Try, /*On fail goto*//*Label 25748*/ GIMT_Encode4(1912639), // Rule ID 19587 //
     /* 1912558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1912569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1912572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1912575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1912578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912604 */     // MIs[0] policy
     /* 1912604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912614 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1912617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912638 */     // GIR_Coverage, 19587,
     /* 1912638 */     GIR_EraseRootFromParent_Done,
     /* 1912639 */   // Label 25748: @1912639
     /* 1912639 */   GIM_Try, /*On fail goto*//*Label 25749*/ GIMT_Encode4(1912725), // Rule ID 19590 //
     /* 1912644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1912655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1912658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1912661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1912664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912690 */     // MIs[0] policy
     /* 1912690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912700 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1912703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912724 */     // GIR_Coverage, 19590,
     /* 1912724 */     GIR_EraseRootFromParent_Done,
     /* 1912725 */   // Label 25749: @1912725
     /* 1912725 */   GIM_Try, /*On fail goto*//*Label 25750*/ GIMT_Encode4(1912811), // Rule ID 19591 //
     /* 1912730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1912741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1912744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1912747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1912750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912776 */     // MIs[0] policy
     /* 1912776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912786 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1912789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912810 */     // GIR_Coverage, 19591,
     /* 1912810 */     GIR_EraseRootFromParent_Done,
     /* 1912811 */   // Label 25750: @1912811
     /* 1912811 */   GIM_Try, /*On fail goto*//*Label 25751*/ GIMT_Encode4(1912897), // Rule ID 19594 //
     /* 1912816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1912827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1912830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1912833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1912836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912862 */     // MIs[0] policy
     /* 1912862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912872 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1912875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912896 */     // GIR_Coverage, 19594,
     /* 1912896 */     GIR_EraseRootFromParent_Done,
     /* 1912897 */   // Label 25751: @1912897
     /* 1912897 */   GIM_Try, /*On fail goto*//*Label 25752*/ GIMT_Encode4(1912983), // Rule ID 19595 //
     /* 1912902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1912905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1912913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1912916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1912919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1912922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912948 */     // MIs[0] policy
     /* 1912948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912958 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1912961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912982 */     // GIR_Coverage, 19595,
     /* 1912982 */     GIR_EraseRootFromParent_Done,
     /* 1912983 */   // Label 25752: @1912983
     /* 1912983 */   GIM_Try, /*On fail goto*//*Label 25753*/ GIMT_Encode4(1913069), // Rule ID 19598 //
     /* 1912988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1912999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1913002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1913005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1913008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913034 */     // MIs[0] policy
     /* 1913034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913044 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1913047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913068 */     // GIR_Coverage, 19598,
     /* 1913068 */     GIR_EraseRootFromParent_Done,
     /* 1913069 */   // Label 25753: @1913069
     /* 1913069 */   GIM_Try, /*On fail goto*//*Label 25754*/ GIMT_Encode4(1913155), // Rule ID 19599 //
     /* 1913074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1913077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1913085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1913088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1913091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1913094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913120 */     // MIs[0] policy
     /* 1913120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913130 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1913133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913154 */     // GIR_Coverage, 19599,
     /* 1913154 */     GIR_EraseRootFromParent_Done,
     /* 1913155 */   // Label 25754: @1913155
     /* 1913155 */   GIM_Try, /*On fail goto*//*Label 25755*/ GIMT_Encode4(1913241), // Rule ID 19602 //
     /* 1913160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1913163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1913171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1913174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1913177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1913180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913206 */     // MIs[0] policy
     /* 1913206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913216 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1913219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913240 */     // GIR_Coverage, 19602,
     /* 1913240 */     GIR_EraseRootFromParent_Done,
     /* 1913241 */   // Label 25755: @1913241
     /* 1913241 */   GIM_Try, /*On fail goto*//*Label 25756*/ GIMT_Encode4(1913327), // Rule ID 19603 //
     /* 1913246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1913249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1913257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1913260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1913263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1913266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913292 */     // MIs[0] policy
     /* 1913292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913302 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1913305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913326 */     // GIR_Coverage, 19603,
     /* 1913326 */     GIR_EraseRootFromParent_Done,
     /* 1913327 */   // Label 25756: @1913327
     /* 1913327 */   GIM_Try, /*On fail goto*//*Label 25757*/ GIMT_Encode4(1913413), // Rule ID 19606 //
     /* 1913332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1913343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1913346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1913349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913378 */     // MIs[0] policy
     /* 1913378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913388 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1913391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913412 */     // GIR_Coverage, 19606,
     /* 1913412 */     GIR_EraseRootFromParent_Done,
     /* 1913413 */   // Label 25757: @1913413
     /* 1913413 */   GIM_Try, /*On fail goto*//*Label 25758*/ GIMT_Encode4(1913499), // Rule ID 19607 //
     /* 1913418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1913429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1913432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1913435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913464 */     // MIs[0] policy
     /* 1913464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913474 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1913477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913498 */     // GIR_Coverage, 19607,
     /* 1913498 */     GIR_EraseRootFromParent_Done,
     /* 1913499 */   // Label 25758: @1913499
     /* 1913499 */   GIM_Try, /*On fail goto*//*Label 25759*/ GIMT_Encode4(1913585), // Rule ID 19610 //
     /* 1913504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1913515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1913518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1913521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913550 */     // MIs[0] policy
     /* 1913550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913560 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1913563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913584 */     // GIR_Coverage, 19610,
     /* 1913584 */     GIR_EraseRootFromParent_Done,
     /* 1913585 */   // Label 25759: @1913585
     /* 1913585 */   GIM_Try, /*On fail goto*//*Label 25760*/ GIMT_Encode4(1913671), // Rule ID 19611 //
     /* 1913590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1913601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1913604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1913607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913636 */     // MIs[0] policy
     /* 1913636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913646 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1913649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913670 */     // GIR_Coverage, 19611,
     /* 1913670 */     GIR_EraseRootFromParent_Done,
     /* 1913671 */   // Label 25760: @1913671
     /* 1913671 */   GIM_Try, /*On fail goto*//*Label 25761*/ GIMT_Encode4(1913757), // Rule ID 19614 //
     /* 1913676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1913687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1913690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1913693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913722 */     // MIs[0] policy
     /* 1913722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913732 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1913735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913756 */     // GIR_Coverage, 19614,
     /* 1913756 */     GIR_EraseRootFromParent_Done,
     /* 1913757 */   // Label 25761: @1913757
     /* 1913757 */   GIM_Try, /*On fail goto*//*Label 25762*/ GIMT_Encode4(1913843), // Rule ID 19615 //
     /* 1913762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1913773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1913776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1913779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913808 */     // MIs[0] policy
     /* 1913808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913818 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1913821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913842 */     // GIR_Coverage, 19615,
     /* 1913842 */     GIR_EraseRootFromParent_Done,
     /* 1913843 */   // Label 25762: @1913843
     /* 1913843 */   GIM_Try, /*On fail goto*//*Label 25763*/ GIMT_Encode4(1913929), // Rule ID 19618 //
     /* 1913848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1913859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1913862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1913865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913894 */     // MIs[0] policy
     /* 1913894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913904 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1913907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913928 */     // GIR_Coverage, 19618,
     /* 1913928 */     GIR_EraseRootFromParent_Done,
     /* 1913929 */   // Label 25763: @1913929
     /* 1913929 */   GIM_Try, /*On fail goto*//*Label 25764*/ GIMT_Encode4(1914015), // Rule ID 19619 //
     /* 1913934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1913945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1913948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1913951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913980 */     // MIs[0] policy
     /* 1913980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913990 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1913993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914014 */     // GIR_Coverage, 19619,
     /* 1914014 */     GIR_EraseRootFromParent_Done,
     /* 1914015 */   // Label 25764: @1914015
     /* 1914015 */   GIM_Try, /*On fail goto*//*Label 25765*/ GIMT_Encode4(1914101), // Rule ID 19622 //
     /* 1914020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1914031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1914034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1914037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914066 */     // MIs[0] policy
     /* 1914066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914076 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1914079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914100 */     // GIR_Coverage, 19622,
     /* 1914100 */     GIR_EraseRootFromParent_Done,
     /* 1914101 */   // Label 25765: @1914101
     /* 1914101 */   GIM_Try, /*On fail goto*//*Label 25766*/ GIMT_Encode4(1914187), // Rule ID 19623 //
     /* 1914106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1914117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1914120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1914123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914152 */     // MIs[0] policy
     /* 1914152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914162 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1914165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914186 */     // GIR_Coverage, 19623,
     /* 1914186 */     GIR_EraseRootFromParent_Done,
     /* 1914187 */   // Label 25766: @1914187
     /* 1914187 */   GIM_Try, /*On fail goto*//*Label 25767*/ GIMT_Encode4(1914273), // Rule ID 19626 //
     /* 1914192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1914195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1914203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1914206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1914209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1914234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914238 */     // MIs[0] policy
     /* 1914238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914248 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1914251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914272 */     // GIR_Coverage, 19626,
     /* 1914272 */     GIR_EraseRootFromParent_Done,
     /* 1914273 */   // Label 25767: @1914273
     /* 1914273 */   GIM_Try, /*On fail goto*//*Label 25768*/ GIMT_Encode4(1914359), // Rule ID 19627 //
     /* 1914278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1914281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1914289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1914292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1914295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1914320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914324 */     // MIs[0] policy
     /* 1914324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914334 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1914337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914358 */     // GIR_Coverage, 19627,
     /* 1914358 */     GIR_EraseRootFromParent_Done,
     /* 1914359 */   // Label 25768: @1914359
     /* 1914359 */   GIM_Try, /*On fail goto*//*Label 25769*/ GIMT_Encode4(1914445), // Rule ID 19630 //
     /* 1914364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1914375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1914378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1914381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914410 */     // MIs[0] policy
     /* 1914410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914420 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1914423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914444 */     // GIR_Coverage, 19630,
     /* 1914444 */     GIR_EraseRootFromParent_Done,
     /* 1914445 */   // Label 25769: @1914445
     /* 1914445 */   GIM_Try, /*On fail goto*//*Label 25770*/ GIMT_Encode4(1914531), // Rule ID 19631 //
     /* 1914450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1914461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1914464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1914467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914496 */     // MIs[0] policy
     /* 1914496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914506 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1914509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914530 */     // GIR_Coverage, 19631,
     /* 1914530 */     GIR_EraseRootFromParent_Done,
     /* 1914531 */   // Label 25770: @1914531
     /* 1914531 */   GIM_Try, /*On fail goto*//*Label 25771*/ GIMT_Encode4(1914617), // Rule ID 19634 //
     /* 1914536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1914547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1914550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1914553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914582 */     // MIs[0] policy
     /* 1914582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914592 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1914595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914616 */     // GIR_Coverage, 19634,
     /* 1914616 */     GIR_EraseRootFromParent_Done,
     /* 1914617 */   // Label 25771: @1914617
     /* 1914617 */   GIM_Try, /*On fail goto*//*Label 25772*/ GIMT_Encode4(1914703), // Rule ID 19635 //
     /* 1914622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1914633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1914636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1914639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914668 */     // MIs[0] policy
     /* 1914668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914678 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1914681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914702 */     // GIR_Coverage, 19635,
     /* 1914702 */     GIR_EraseRootFromParent_Done,
     /* 1914703 */   // Label 25772: @1914703
     /* 1914703 */   GIM_Try, /*On fail goto*//*Label 25773*/ GIMT_Encode4(1914789), // Rule ID 19638 //
     /* 1914708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1914719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1914722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1914725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1914731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914754 */     // MIs[0] policy
     /* 1914754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914764 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1914767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914788 */     // GIR_Coverage, 19638,
     /* 1914788 */     GIR_EraseRootFromParent_Done,
     /* 1914789 */   // Label 25773: @1914789
     /* 1914789 */   GIM_Try, /*On fail goto*//*Label 25774*/ GIMT_Encode4(1914875), // Rule ID 19639 //
     /* 1914794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1914805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1914808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1914811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1914817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914840 */     // MIs[0] policy
     /* 1914840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914850 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1914853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914874 */     // GIR_Coverage, 19639,
     /* 1914874 */     GIR_EraseRootFromParent_Done,
     /* 1914875 */   // Label 25774: @1914875
     /* 1914875 */   GIM_Try, /*On fail goto*//*Label 25775*/ GIMT_Encode4(1914961), // Rule ID 19642 //
     /* 1914880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1914891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1914894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1914897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914926 */     // MIs[0] policy
     /* 1914926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914936 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1914939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914960 */     // GIR_Coverage, 19642,
     /* 1914960 */     GIR_EraseRootFromParent_Done,
     /* 1914961 */   // Label 25775: @1914961
     /* 1914961 */   GIM_Try, /*On fail goto*//*Label 25776*/ GIMT_Encode4(1915047), // Rule ID 19643 //
     /* 1914966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1914977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1914980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1914983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1915008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915012 */     // MIs[0] policy
     /* 1915012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915022 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1915025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915046 */     // GIR_Coverage, 19643,
     /* 1915046 */     GIR_EraseRootFromParent_Done,
     /* 1915047 */   // Label 25776: @1915047
     /* 1915047 */   GIM_Try, /*On fail goto*//*Label 25777*/ GIMT_Encode4(1915133), // Rule ID 19646 //
     /* 1915052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1915055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1915063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1915066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1915069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1915094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915098 */     // MIs[0] policy
     /* 1915098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915108 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1915111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915132 */     // GIR_Coverage, 19646,
     /* 1915132 */     GIR_EraseRootFromParent_Done,
     /* 1915133 */   // Label 25777: @1915133
     /* 1915133 */   GIM_Try, /*On fail goto*//*Label 25778*/ GIMT_Encode4(1915219), // Rule ID 19647 //
     /* 1915138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1915141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1915149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1915152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1915155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1915180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915184 */     // MIs[0] policy
     /* 1915184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915194 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1915197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915218 */     // GIR_Coverage, 19647,
     /* 1915218 */     GIR_EraseRootFromParent_Done,
     /* 1915219 */   // Label 25778: @1915219
     /* 1915219 */   GIM_Try, /*On fail goto*//*Label 25779*/ GIMT_Encode4(1915305), // Rule ID 19650 //
     /* 1915224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1915227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1915235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1915238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1915241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1915247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1915266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915270 */     // MIs[0] policy
     /* 1915270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915280 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1915283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915304 */     // GIR_Coverage, 19650,
     /* 1915304 */     GIR_EraseRootFromParent_Done,
     /* 1915305 */   // Label 25779: @1915305
     /* 1915305 */   GIM_Try, /*On fail goto*//*Label 25780*/ GIMT_Encode4(1915391), // Rule ID 19651 //
     /* 1915310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1915313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1915321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1915324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1915327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1915333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1915352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915356 */     // MIs[0] policy
     /* 1915356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915366 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1915369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915390 */     // GIR_Coverage, 19651,
     /* 1915390 */     GIR_EraseRootFromParent_Done,
     /* 1915391 */   // Label 25780: @1915391
     /* 1915391 */   GIM_Try, /*On fail goto*//*Label 25781*/ GIMT_Encode4(1915477), // Rule ID 19654 //
     /* 1915396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1915407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1915410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1915413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915442 */     // MIs[0] policy
     /* 1915442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915452 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1915455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915476 */     // GIR_Coverage, 19654,
     /* 1915476 */     GIR_EraseRootFromParent_Done,
     /* 1915477 */   // Label 25781: @1915477
     /* 1915477 */   GIM_Try, /*On fail goto*//*Label 25782*/ GIMT_Encode4(1915563), // Rule ID 19655 //
     /* 1915482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1915493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1915496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1915499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915528 */     // MIs[0] policy
     /* 1915528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915538 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1915541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915562 */     // GIR_Coverage, 19655,
     /* 1915562 */     GIR_EraseRootFromParent_Done,
     /* 1915563 */   // Label 25782: @1915563
     /* 1915563 */   GIM_Try, /*On fail goto*//*Label 25783*/ GIMT_Encode4(1915649), // Rule ID 19658 //
     /* 1915568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1915579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1915582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1915585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915614 */     // MIs[0] policy
     /* 1915614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915624 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1915627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915648 */     // GIR_Coverage, 19658,
     /* 1915648 */     GIR_EraseRootFromParent_Done,
     /* 1915649 */   // Label 25783: @1915649
     /* 1915649 */   GIM_Try, /*On fail goto*//*Label 25784*/ GIMT_Encode4(1915735), // Rule ID 19659 //
     /* 1915654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1915665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1915668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1915671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915700 */     // MIs[0] policy
     /* 1915700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915710 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1915713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915734 */     // GIR_Coverage, 19659,
     /* 1915734 */     GIR_EraseRootFromParent_Done,
     /* 1915735 */   // Label 25784: @1915735
     /* 1915735 */   GIM_Try, /*On fail goto*//*Label 25785*/ GIMT_Encode4(1915821), // Rule ID 19662 //
     /* 1915740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1915751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1915754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1915757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915786 */     // MIs[0] policy
     /* 1915786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915796 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1915799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915820 */     // GIR_Coverage, 19662,
     /* 1915820 */     GIR_EraseRootFromParent_Done,
     /* 1915821 */   // Label 25785: @1915821
     /* 1915821 */   GIM_Try, /*On fail goto*//*Label 25786*/ GIMT_Encode4(1915907), // Rule ID 19663 //
     /* 1915826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1915837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1915840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1915843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915872 */     // MIs[0] policy
     /* 1915872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915882 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1915885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915906 */     // GIR_Coverage, 19663,
     /* 1915906 */     GIR_EraseRootFromParent_Done,
     /* 1915907 */   // Label 25786: @1915907
     /* 1915907 */   GIM_Try, /*On fail goto*//*Label 25787*/ GIMT_Encode4(1915993), // Rule ID 19666 //
     /* 1915912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1915923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1915926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1915929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1915932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915958 */     // MIs[0] policy
     /* 1915958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915968 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1915971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915992 */     // GIR_Coverage, 19666,
     /* 1915992 */     GIR_EraseRootFromParent_Done,
     /* 1915993 */   // Label 25787: @1915993
     /* 1915993 */   GIM_Try, /*On fail goto*//*Label 25788*/ GIMT_Encode4(1916079), // Rule ID 19667 //
     /* 1915998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1916009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1916012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1916015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1916018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916044 */     // MIs[0] policy
     /* 1916044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916054 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1916057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916078 */     // GIR_Coverage, 19667,
     /* 1916078 */     GIR_EraseRootFromParent_Done,
     /* 1916079 */   // Label 25788: @1916079
     /* 1916079 */   GIM_Try, /*On fail goto*//*Label 25789*/ GIMT_Encode4(1916165), // Rule ID 19670 //
     /* 1916084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1916095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1916098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1916101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1916104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916130 */     // MIs[0] policy
     /* 1916130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916140 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1916143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916164 */     // GIR_Coverage, 19670,
     /* 1916164 */     GIR_EraseRootFromParent_Done,
     /* 1916165 */   // Label 25789: @1916165
     /* 1916165 */   GIM_Try, /*On fail goto*//*Label 25790*/ GIMT_Encode4(1916251), // Rule ID 19671 //
     /* 1916170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1916181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1916184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1916187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1916190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916216 */     // MIs[0] policy
     /* 1916216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916226 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1916229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916250 */     // GIR_Coverage, 19671,
     /* 1916250 */     GIR_EraseRootFromParent_Done,
     /* 1916251 */   // Label 25790: @1916251
     /* 1916251 */   GIM_Try, /*On fail goto*//*Label 25791*/ GIMT_Encode4(1916337), // Rule ID 19674 //
     /* 1916256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1916259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1916267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1916270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1916273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1916276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916302 */     // MIs[0] policy
     /* 1916302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916312 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1916315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916336 */     // GIR_Coverage, 19674,
     /* 1916336 */     GIR_EraseRootFromParent_Done,
     /* 1916337 */   // Label 25791: @1916337
     /* 1916337 */   GIM_Try, /*On fail goto*//*Label 25792*/ GIMT_Encode4(1916423), // Rule ID 19675 //
     /* 1916342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1916345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1916353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1916356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1916359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1916362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916388 */     // MIs[0] policy
     /* 1916388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916398 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1916401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916422 */     // GIR_Coverage, 19675,
     /* 1916422 */     GIR_EraseRootFromParent_Done,
     /* 1916423 */   // Label 25792: @1916423
     /* 1916423 */   GIM_Try, /*On fail goto*//*Label 25793*/ GIMT_Encode4(1916509), // Rule ID 19678 //
     /* 1916428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1916439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1916442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1916445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1916448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916474 */     // MIs[0] policy
     /* 1916474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916484 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1916487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916508 */     // GIR_Coverage, 19678,
     /* 1916508 */     GIR_EraseRootFromParent_Done,
     /* 1916509 */   // Label 25793: @1916509
     /* 1916509 */   GIM_Try, /*On fail goto*//*Label 25794*/ GIMT_Encode4(1916595), // Rule ID 19679 //
     /* 1916514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1916525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1916528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1916531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1916534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916560 */     // MIs[0] policy
     /* 1916560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916570 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1916573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916594 */     // GIR_Coverage, 19679,
     /* 1916594 */     GIR_EraseRootFromParent_Done,
     /* 1916595 */   // Label 25794: @1916595
     /* 1916595 */   GIM_Try, /*On fail goto*//*Label 25795*/ GIMT_Encode4(1916681), // Rule ID 19682 //
     /* 1916600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1916603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1916611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1916614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1916617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1916620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916646 */     // MIs[0] policy
     /* 1916646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916656 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1916659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916680 */     // GIR_Coverage, 19682,
     /* 1916680 */     GIR_EraseRootFromParent_Done,
     /* 1916681 */   // Label 25795: @1916681
     /* 1916681 */   GIM_Try, /*On fail goto*//*Label 25796*/ GIMT_Encode4(1916767), // Rule ID 19683 //
     /* 1916686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1916689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1916697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1916700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1916703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1916706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916732 */     // MIs[0] policy
     /* 1916732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916742 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1916745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916766 */     // GIR_Coverage, 19683,
     /* 1916766 */     GIR_EraseRootFromParent_Done,
     /* 1916767 */   // Label 25796: @1916767
     /* 1916767 */   GIM_Try, /*On fail goto*//*Label 25797*/ GIMT_Encode4(1916853), // Rule ID 19686 //
     /* 1916772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1916775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1916783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1916786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1916789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1916792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916818 */     // MIs[0] policy
     /* 1916818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916828 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1916831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916852 */     // GIR_Coverage, 19686,
     /* 1916852 */     GIR_EraseRootFromParent_Done,
     /* 1916853 */   // Label 25797: @1916853
     /* 1916853 */   GIM_Try, /*On fail goto*//*Label 25798*/ GIMT_Encode4(1916939), // Rule ID 19687 //
     /* 1916858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1916861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1916869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1916872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1916875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1916878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916904 */     // MIs[0] policy
     /* 1916904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916914 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1916917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916938 */     // GIR_Coverage, 19687,
     /* 1916938 */     GIR_EraseRootFromParent_Done,
     /* 1916939 */   // Label 25798: @1916939
     /* 1916939 */   GIM_Try, /*On fail goto*//*Label 25799*/ GIMT_Encode4(1917025), // Rule ID 19690 //
     /* 1916944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1916955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1916958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1916961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1916964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916990 */     // MIs[0] policy
     /* 1916990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917000 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1917003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917024 */     // GIR_Coverage, 19690,
     /* 1917024 */     GIR_EraseRootFromParent_Done,
     /* 1917025 */   // Label 25799: @1917025
     /* 1917025 */   GIM_Try, /*On fail goto*//*Label 25800*/ GIMT_Encode4(1917111), // Rule ID 19691 //
     /* 1917030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1917033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1917041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1917044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1917047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1917050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917076 */     // MIs[0] policy
     /* 1917076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917086 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1917089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917110 */     // GIR_Coverage, 19691,
     /* 1917110 */     GIR_EraseRootFromParent_Done,
     /* 1917111 */   // Label 25800: @1917111
     /* 1917111 */   GIM_Try, /*On fail goto*//*Label 25801*/ GIMT_Encode4(1917197), // Rule ID 19694 //
     /* 1917116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1917119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1917127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1917130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1917133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1917136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917162 */     // MIs[0] policy
     /* 1917162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917172 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1917175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917196 */     // GIR_Coverage, 19694,
     /* 1917196 */     GIR_EraseRootFromParent_Done,
     /* 1917197 */   // Label 25801: @1917197
     /* 1917197 */   GIM_Try, /*On fail goto*//*Label 25802*/ GIMT_Encode4(1917283), // Rule ID 19695 //
     /* 1917202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1917205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1917213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1917216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1917219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1917222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917248 */     // MIs[0] policy
     /* 1917248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917258 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1917261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917282 */     // GIR_Coverage, 19695,
     /* 1917282 */     GIR_EraseRootFromParent_Done,
     /* 1917283 */   // Label 25802: @1917283
     /* 1917283 */   GIM_Try, /*On fail goto*//*Label 25803*/ GIMT_Encode4(1917369), // Rule ID 19698 //
     /* 1917288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1917291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1917299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1917302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1917305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1917308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1917311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917334 */     // MIs[0] policy
     /* 1917334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917344 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1917347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917368 */     // GIR_Coverage, 19698,
     /* 1917368 */     GIR_EraseRootFromParent_Done,
     /* 1917369 */   // Label 25803: @1917369
     /* 1917369 */   GIM_Try, /*On fail goto*//*Label 25804*/ GIMT_Encode4(1917455), // Rule ID 19699 //
     /* 1917374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1917377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1917385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1917388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1917391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1917394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1917397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917420 */     // MIs[0] policy
     /* 1917420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917430 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1917433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917454 */     // GIR_Coverage, 19699,
     /* 1917454 */     GIR_EraseRootFromParent_Done,
     /* 1917455 */   // Label 25804: @1917455
     /* 1917455 */   GIM_Try, /*On fail goto*//*Label 25805*/ GIMT_Encode4(1917541), // Rule ID 19702 //
     /* 1917460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1917471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1917474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1917477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1917480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917506 */     // MIs[0] policy
     /* 1917506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917516 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1917519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917540 */     // GIR_Coverage, 19702,
     /* 1917540 */     GIR_EraseRootFromParent_Done,
     /* 1917541 */   // Label 25805: @1917541
     /* 1917541 */   GIM_Try, /*On fail goto*//*Label 25806*/ GIMT_Encode4(1917627), // Rule ID 19703 //
     /* 1917546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1917557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1917560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1917563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1917566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917592 */     // MIs[0] policy
     /* 1917592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917602 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1917605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917626 */     // GIR_Coverage, 19703,
     /* 1917626 */     GIR_EraseRootFromParent_Done,
     /* 1917627 */   // Label 25806: @1917627
     /* 1917627 */   GIM_Try, /*On fail goto*//*Label 25807*/ GIMT_Encode4(1917713), // Rule ID 19706 //
     /* 1917632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1917643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1917646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1917649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1917652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917678 */     // MIs[0] policy
     /* 1917678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917688 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1917691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917712 */     // GIR_Coverage, 19706,
     /* 1917712 */     GIR_EraseRootFromParent_Done,
     /* 1917713 */   // Label 25807: @1917713
     /* 1917713 */   GIM_Try, /*On fail goto*//*Label 25808*/ GIMT_Encode4(1917799), // Rule ID 19707 //
     /* 1917718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1917729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1917732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1917735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1917738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917764 */     // MIs[0] policy
     /* 1917764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917774 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1917777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917798 */     // GIR_Coverage, 19707,
     /* 1917798 */     GIR_EraseRootFromParent_Done,
     /* 1917799 */   // Label 25808: @1917799
     /* 1917799 */   GIM_Try, /*On fail goto*//*Label 25809*/ GIMT_Encode4(1917885), // Rule ID 19710 //
     /* 1917804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1917815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1917818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1917821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1917824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917850 */     // MIs[0] policy
     /* 1917850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917860 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1917863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917884 */     // GIR_Coverage, 19710,
     /* 1917884 */     GIR_EraseRootFromParent_Done,
     /* 1917885 */   // Label 25809: @1917885
     /* 1917885 */   GIM_Try, /*On fail goto*//*Label 25810*/ GIMT_Encode4(1917971), // Rule ID 19711 //
     /* 1917890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1917901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1917904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1917907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1917910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917936 */     // MIs[0] policy
     /* 1917936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917946 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1917949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917970 */     // GIR_Coverage, 19711,
     /* 1917970 */     GIR_EraseRootFromParent_Done,
     /* 1917971 */   // Label 25810: @1917971
     /* 1917971 */   GIM_Try, /*On fail goto*//*Label 25811*/ GIMT_Encode4(1918057), // Rule ID 19714 //
     /* 1917976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1917979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1917987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1917990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1917993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1917996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1918006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918022 */     // MIs[0] policy
     /* 1918022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918032 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1918035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918056 */     // GIR_Coverage, 19714,
     /* 1918056 */     GIR_EraseRootFromParent_Done,
     /* 1918057 */   // Label 25811: @1918057
     /* 1918057 */   GIM_Try, /*On fail goto*//*Label 25812*/ GIMT_Encode4(1918143), // Rule ID 19715 //
     /* 1918062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1918065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1918073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1918076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1918079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1918082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1918092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918108 */     // MIs[0] policy
     /* 1918108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918118 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1918121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918142 */     // GIR_Coverage, 19715,
     /* 1918142 */     GIR_EraseRootFromParent_Done,
     /* 1918143 */   // Label 25812: @1918143
     /* 1918143 */   GIM_Try, /*On fail goto*//*Label 25813*/ GIMT_Encode4(1918229), // Rule ID 19718 //
     /* 1918148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1918151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1918159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1918162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1918165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1918168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1918178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918194 */     // MIs[0] policy
     /* 1918194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918204 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1918207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918228 */     // GIR_Coverage, 19718,
     /* 1918228 */     GIR_EraseRootFromParent_Done,
     /* 1918229 */   // Label 25813: @1918229
     /* 1918229 */   GIM_Try, /*On fail goto*//*Label 25814*/ GIMT_Encode4(1918315), // Rule ID 19719 //
     /* 1918234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1918237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1918245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1918248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1918251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1918254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1918264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918280 */     // MIs[0] policy
     /* 1918280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918290 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1918293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918314 */     // GIR_Coverage, 19719,
     /* 1918314 */     GIR_EraseRootFromParent_Done,
     /* 1918315 */   // Label 25814: @1918315
     /* 1918315 */   GIM_Try, /*On fail goto*//*Label 25815*/ GIMT_Encode4(1918401), // Rule ID 19722 //
     /* 1918320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1918323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1918331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1918334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1918337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1918340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1918343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918366 */     // MIs[0] policy
     /* 1918366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918376 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1918379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918400 */     // GIR_Coverage, 19722,
     /* 1918400 */     GIR_EraseRootFromParent_Done,
     /* 1918401 */   // Label 25815: @1918401
     /* 1918401 */   GIM_Try, /*On fail goto*//*Label 25816*/ GIMT_Encode4(1918487), // Rule ID 19723 //
     /* 1918406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1918409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1918417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1918420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1918423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1918426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1918429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918452 */     // MIs[0] policy
     /* 1918452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918462 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1918465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918486 */     // GIR_Coverage, 19723,
     /* 1918486 */     GIR_EraseRootFromParent_Done,
     /* 1918487 */   // Label 25816: @1918487
     /* 1918487 */   GIM_Try, /*On fail goto*//*Label 25817*/ GIMT_Encode4(1918573), // Rule ID 19726 //
     /* 1918492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1918495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1918503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1918506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1918509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918538 */     // MIs[0] policy
     /* 1918538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918548 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1918551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918572 */     // GIR_Coverage, 19726,
     /* 1918572 */     GIR_EraseRootFromParent_Done,
     /* 1918573 */   // Label 25817: @1918573
     /* 1918573 */   GIM_Try, /*On fail goto*//*Label 25818*/ GIMT_Encode4(1918659), // Rule ID 19727 //
     /* 1918578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1918581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1918589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1918592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1918595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918624 */     // MIs[0] policy
     /* 1918624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918634 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1918637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918658 */     // GIR_Coverage, 19727,
     /* 1918658 */     GIR_EraseRootFromParent_Done,
     /* 1918659 */   // Label 25818: @1918659
     /* 1918659 */   GIM_Try, /*On fail goto*//*Label 25819*/ GIMT_Encode4(1918745), // Rule ID 19730 //
     /* 1918664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1918667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1918675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1918678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1918681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918710 */     // MIs[0] policy
     /* 1918710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918720 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1918723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918744 */     // GIR_Coverage, 19730,
     /* 1918744 */     GIR_EraseRootFromParent_Done,
     /* 1918745 */   // Label 25819: @1918745
     /* 1918745 */   GIM_Try, /*On fail goto*//*Label 25820*/ GIMT_Encode4(1918831), // Rule ID 19731 //
     /* 1918750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1918753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1918761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1918764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1918767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918796 */     // MIs[0] policy
     /* 1918796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918806 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1918809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918830 */     // GIR_Coverage, 19731,
     /* 1918830 */     GIR_EraseRootFromParent_Done,
     /* 1918831 */   // Label 25820: @1918831
     /* 1918831 */   GIM_Try, /*On fail goto*//*Label 25821*/ GIMT_Encode4(1918917), // Rule ID 19734 //
     /* 1918836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1918839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1918847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1918850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1918853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918882 */     // MIs[0] policy
     /* 1918882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918892 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1918895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918916 */     // GIR_Coverage, 19734,
     /* 1918916 */     GIR_EraseRootFromParent_Done,
     /* 1918917 */   // Label 25821: @1918917
     /* 1918917 */   GIM_Try, /*On fail goto*//*Label 25822*/ GIMT_Encode4(1919003), // Rule ID 19735 //
     /* 1918922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1918925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1918933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1918936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1918939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918968 */     // MIs[0] policy
     /* 1918968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918978 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1918981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919002 */     // GIR_Coverage, 19735,
     /* 1919002 */     GIR_EraseRootFromParent_Done,
     /* 1919003 */   // Label 25822: @1919003
     /* 1919003 */   GIM_Try, /*On fail goto*//*Label 25823*/ GIMT_Encode4(1919089), // Rule ID 19738 //
     /* 1919008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1919019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1919022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1919025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919054 */     // MIs[0] policy
     /* 1919054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919064 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1919067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919088 */     // GIR_Coverage, 19738,
     /* 1919088 */     GIR_EraseRootFromParent_Done,
     /* 1919089 */   // Label 25823: @1919089
     /* 1919089 */   GIM_Try, /*On fail goto*//*Label 25824*/ GIMT_Encode4(1919175), // Rule ID 19739 //
     /* 1919094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1919105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1919108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1919111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919140 */     // MIs[0] policy
     /* 1919140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919150 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1919153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919174 */     // GIR_Coverage, 19739,
     /* 1919174 */     GIR_EraseRootFromParent_Done,
     /* 1919175 */   // Label 25824: @1919175
     /* 1919175 */   GIM_Try, /*On fail goto*//*Label 25825*/ GIMT_Encode4(1919261), // Rule ID 19742 //
     /* 1919180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1919183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1919191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1919194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1919197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919226 */     // MIs[0] policy
     /* 1919226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919236 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1919239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919260 */     // GIR_Coverage, 19742,
     /* 1919260 */     GIR_EraseRootFromParent_Done,
     /* 1919261 */   // Label 25825: @1919261
     /* 1919261 */   GIM_Try, /*On fail goto*//*Label 25826*/ GIMT_Encode4(1919347), // Rule ID 19743 //
     /* 1919266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1919269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1919277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1919280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1919283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919312 */     // MIs[0] policy
     /* 1919312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919322 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1919325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919346 */     // GIR_Coverage, 19743,
     /* 1919346 */     GIR_EraseRootFromParent_Done,
     /* 1919347 */   // Label 25826: @1919347
     /* 1919347 */   GIM_Try, /*On fail goto*//*Label 25827*/ GIMT_Encode4(1919433), // Rule ID 19746 //
     /* 1919352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1919355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1919363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1919366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1919369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1919394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919398 */     // MIs[0] policy
     /* 1919398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919408 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1919411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919432 */     // GIR_Coverage, 19746,
     /* 1919432 */     GIR_EraseRootFromParent_Done,
     /* 1919433 */   // Label 25827: @1919433
     /* 1919433 */   GIM_Try, /*On fail goto*//*Label 25828*/ GIMT_Encode4(1919519), // Rule ID 19747 //
     /* 1919438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1919441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1919449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1919452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1919455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1919480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919484 */     // MIs[0] policy
     /* 1919484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919494 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1919497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919518 */     // GIR_Coverage, 19747,
     /* 1919518 */     GIR_EraseRootFromParent_Done,
     /* 1919519 */   // Label 25828: @1919519
     /* 1919519 */   GIM_Try, /*On fail goto*//*Label 25829*/ GIMT_Encode4(1919605), // Rule ID 19750 //
     /* 1919524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1919535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1919538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1919541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919570 */     // MIs[0] policy
     /* 1919570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919580 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1919583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919604 */     // GIR_Coverage, 19750,
     /* 1919604 */     GIR_EraseRootFromParent_Done,
     /* 1919605 */   // Label 25829: @1919605
     /* 1919605 */   GIM_Try, /*On fail goto*//*Label 25830*/ GIMT_Encode4(1919691), // Rule ID 19751 //
     /* 1919610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1919621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1919624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1919627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919656 */     // MIs[0] policy
     /* 1919656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919666 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1919669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919690 */     // GIR_Coverage, 19751,
     /* 1919690 */     GIR_EraseRootFromParent_Done,
     /* 1919691 */   // Label 25830: @1919691
     /* 1919691 */   GIM_Try, /*On fail goto*//*Label 25831*/ GIMT_Encode4(1919777), // Rule ID 19754 //
     /* 1919696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1919707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1919710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1919713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1919719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919742 */     // MIs[0] policy
     /* 1919742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919752 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1919755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919776 */     // GIR_Coverage, 19754,
     /* 1919776 */     GIR_EraseRootFromParent_Done,
     /* 1919777 */   // Label 25831: @1919777
     /* 1919777 */   GIM_Try, /*On fail goto*//*Label 25832*/ GIMT_Encode4(1919863), // Rule ID 19755 //
     /* 1919782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1919793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1919796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1919799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1919805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919828 */     // MIs[0] policy
     /* 1919828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919838 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1919841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919862 */     // GIR_Coverage, 19755,
     /* 1919862 */     GIR_EraseRootFromParent_Done,
     /* 1919863 */   // Label 25832: @1919863
     /* 1919863 */   GIM_Try, /*On fail goto*//*Label 25833*/ GIMT_Encode4(1919949), // Rule ID 19758 //
     /* 1919868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1919879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1919882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1919885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1919891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919914 */     // MIs[0] policy
     /* 1919914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919924 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1919927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919948 */     // GIR_Coverage, 19758,
     /* 1919948 */     GIR_EraseRootFromParent_Done,
     /* 1919949 */   // Label 25833: @1919949
     /* 1919949 */   GIM_Try, /*On fail goto*//*Label 25834*/ GIMT_Encode4(1920035), // Rule ID 19759 //
     /* 1919954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1919965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1919968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1919971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1919977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920000 */     // MIs[0] policy
     /* 1920000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920010 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1920013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920034 */     // GIR_Coverage, 19759,
     /* 1920034 */     GIR_EraseRootFromParent_Done,
     /* 1920035 */   // Label 25834: @1920035
     /* 1920035 */   GIM_Try, /*On fail goto*//*Label 25835*/ GIMT_Encode4(1920121), // Rule ID 19762 //
     /* 1920040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1920043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1920051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1920054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1920057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920086 */     // MIs[0] policy
     /* 1920086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920096 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1920099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920120 */     // GIR_Coverage, 19762,
     /* 1920120 */     GIR_EraseRootFromParent_Done,
     /* 1920121 */   // Label 25835: @1920121
     /* 1920121 */   GIM_Try, /*On fail goto*//*Label 25836*/ GIMT_Encode4(1920207), // Rule ID 19763 //
     /* 1920126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1920129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1920137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1920140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1920143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920172 */     // MIs[0] policy
     /* 1920172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920182 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1920185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920206 */     // GIR_Coverage, 19763,
     /* 1920206 */     GIR_EraseRootFromParent_Done,
     /* 1920207 */   // Label 25836: @1920207
     /* 1920207 */   GIM_Try, /*On fail goto*//*Label 25837*/ GIMT_Encode4(1920293), // Rule ID 19766 //
     /* 1920212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1920215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1920223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1920226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1920229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920258 */     // MIs[0] policy
     /* 1920258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920268 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1920271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920292 */     // GIR_Coverage, 19766,
     /* 1920292 */     GIR_EraseRootFromParent_Done,
     /* 1920293 */   // Label 25837: @1920293
     /* 1920293 */   GIM_Try, /*On fail goto*//*Label 25838*/ GIMT_Encode4(1920379), // Rule ID 19767 //
     /* 1920298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1920301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1920309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1920312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1920315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920344 */     // MIs[0] policy
     /* 1920344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920354 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1920357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920378 */     // GIR_Coverage, 19767,
     /* 1920378 */     GIR_EraseRootFromParent_Done,
     /* 1920379 */   // Label 25838: @1920379
     /* 1920379 */   GIM_Try, /*On fail goto*//*Label 25839*/ GIMT_Encode4(1920465), // Rule ID 19770 //
     /* 1920384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1920387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1920395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1920398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1920401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920430 */     // MIs[0] policy
     /* 1920430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920440 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1920443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920464 */     // GIR_Coverage, 19770,
     /* 1920464 */     GIR_EraseRootFromParent_Done,
     /* 1920465 */   // Label 25839: @1920465
     /* 1920465 */   GIM_Try, /*On fail goto*//*Label 25840*/ GIMT_Encode4(1920551), // Rule ID 19771 //
     /* 1920470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1920473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1920481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1920484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1920487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920516 */     // MIs[0] policy
     /* 1920516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920526 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1920529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920550 */     // GIR_Coverage, 19771,
     /* 1920550 */     GIR_EraseRootFromParent_Done,
     /* 1920551 */   // Label 25840: @1920551
     /* 1920551 */   GIM_Try, /*On fail goto*//*Label 25841*/ GIMT_Encode4(1920637), // Rule ID 19774 //
     /* 1920556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1920567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1920570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1920573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920602 */     // MIs[0] policy
     /* 1920602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920612 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1920615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920636 */     // GIR_Coverage, 19774,
     /* 1920636 */     GIR_EraseRootFromParent_Done,
     /* 1920637 */   // Label 25841: @1920637
     /* 1920637 */   GIM_Try, /*On fail goto*//*Label 25842*/ GIMT_Encode4(1920723), // Rule ID 19775 //
     /* 1920642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1920653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1920656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1920659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920688 */     // MIs[0] policy
     /* 1920688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920698 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1920701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920722 */     // GIR_Coverage, 19775,
     /* 1920722 */     GIR_EraseRootFromParent_Done,
     /* 1920723 */   // Label 25842: @1920723
     /* 1920723 */   GIM_Try, /*On fail goto*//*Label 25843*/ GIMT_Encode4(1920809), // Rule ID 19778 //
     /* 1920728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1920739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1920742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1920745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920774 */     // MIs[0] policy
     /* 1920774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920784 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1920787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920808 */     // GIR_Coverage, 19778,
     /* 1920808 */     GIR_EraseRootFromParent_Done,
     /* 1920809 */   // Label 25843: @1920809
     /* 1920809 */   GIM_Try, /*On fail goto*//*Label 25844*/ GIMT_Encode4(1920895), // Rule ID 19779 //
     /* 1920814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1920825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1920828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1920831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920860 */     // MIs[0] policy
     /* 1920860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920870 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1920873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920894 */     // GIR_Coverage, 19779,
     /* 1920894 */     GIR_EraseRootFromParent_Done,
     /* 1920895 */   // Label 25844: @1920895
     /* 1920895 */   GIM_Try, /*On fail goto*//*Label 25845*/ GIMT_Encode4(1920981), // Rule ID 19782 //
     /* 1920900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1920911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1920914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1920917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920946 */     // MIs[0] policy
     /* 1920946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920956 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1920959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920980 */     // GIR_Coverage, 19782,
     /* 1920980 */     GIR_EraseRootFromParent_Done,
     /* 1920981 */   // Label 25845: @1920981
     /* 1920981 */   GIM_Try, /*On fail goto*//*Label 25846*/ GIMT_Encode4(1921067), // Rule ID 19783 //
     /* 1920986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1920997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1921000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1921003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1921016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1921028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921032 */     // MIs[0] policy
     /* 1921032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921042 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1921045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921066 */     // GIR_Coverage, 19783,
     /* 1921066 */     GIR_EraseRootFromParent_Done,
     /* 1921067 */   // Label 25846: @1921067
     /* 1921067 */   GIM_Try, /*On fail goto*//*Label 25847*/ GIMT_Encode4(1921153), // Rule ID 23624 //
     /* 1921072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1921083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1921086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1921089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921118 */     // MIs[0] policy
     /* 1921118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921128 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1921131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921152 */     // GIR_Coverage, 23624,
     /* 1921152 */     GIR_EraseRootFromParent_Done,
     /* 1921153 */   // Label 25847: @1921153
     /* 1921153 */   GIM_Try, /*On fail goto*//*Label 25848*/ GIMT_Encode4(1921239), // Rule ID 23625 //
     /* 1921158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1921169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1921172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1921175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921204 */     // MIs[0] policy
     /* 1921204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921214 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1921217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921238 */     // GIR_Coverage, 23625,
     /* 1921238 */     GIR_EraseRootFromParent_Done,
     /* 1921239 */   // Label 25848: @1921239
     /* 1921239 */   GIM_Try, /*On fail goto*//*Label 25849*/ GIMT_Encode4(1921325), // Rule ID 23628 //
     /* 1921244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1921255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1921258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1921261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921290 */     // MIs[0] policy
     /* 1921290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921300 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1921303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921324 */     // GIR_Coverage, 23628,
     /* 1921324 */     GIR_EraseRootFromParent_Done,
     /* 1921325 */   // Label 25849: @1921325
     /* 1921325 */   GIM_Try, /*On fail goto*//*Label 25850*/ GIMT_Encode4(1921411), // Rule ID 23629 //
     /* 1921330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1921341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1921344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1921347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921376 */     // MIs[0] policy
     /* 1921376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921386 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1921389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921410 */     // GIR_Coverage, 23629,
     /* 1921410 */     GIR_EraseRootFromParent_Done,
     /* 1921411 */   // Label 25850: @1921411
     /* 1921411 */   GIM_Try, /*On fail goto*//*Label 25851*/ GIMT_Encode4(1921497), // Rule ID 23632 //
     /* 1921416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1921427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1921430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1921433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921462 */     // MIs[0] policy
     /* 1921462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921472 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921496 */     // GIR_Coverage, 23632,
     /* 1921496 */     GIR_EraseRootFromParent_Done,
     /* 1921497 */   // Label 25851: @1921497
     /* 1921497 */   GIM_Try, /*On fail goto*//*Label 25852*/ GIMT_Encode4(1921583), // Rule ID 23633 //
     /* 1921502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1921513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1921516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1921519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921548 */     // MIs[0] policy
     /* 1921548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921558 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921582 */     // GIR_Coverage, 23633,
     /* 1921582 */     GIR_EraseRootFromParent_Done,
     /* 1921583 */   // Label 25852: @1921583
     /* 1921583 */   GIM_Try, /*On fail goto*//*Label 25853*/ GIMT_Encode4(1921669), // Rule ID 23636 //
     /* 1921588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1921599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1921602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1921605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921634 */     // MIs[0] policy
     /* 1921634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921644 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1921647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921668 */     // GIR_Coverage, 23636,
     /* 1921668 */     GIR_EraseRootFromParent_Done,
     /* 1921669 */   // Label 25853: @1921669
     /* 1921669 */   GIM_Try, /*On fail goto*//*Label 25854*/ GIMT_Encode4(1921755), // Rule ID 23637 //
     /* 1921674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1921685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1921688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1921691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921720 */     // MIs[0] policy
     /* 1921720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921730 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1921733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921754 */     // GIR_Coverage, 23637,
     /* 1921754 */     GIR_EraseRootFromParent_Done,
     /* 1921755 */   // Label 25854: @1921755
     /* 1921755 */   GIM_Try, /*On fail goto*//*Label 25855*/ GIMT_Encode4(1921841), // Rule ID 23640 //
     /* 1921760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1921771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1921774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1921777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921806 */     // MIs[0] policy
     /* 1921806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921816 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921840 */     // GIR_Coverage, 23640,
     /* 1921840 */     GIR_EraseRootFromParent_Done,
     /* 1921841 */   // Label 25855: @1921841
     /* 1921841 */   GIM_Try, /*On fail goto*//*Label 25856*/ GIMT_Encode4(1921927), // Rule ID 23641 //
     /* 1921846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1921857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1921860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1921863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921892 */     // MIs[0] policy
     /* 1921892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921902 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921926 */     // GIR_Coverage, 23641,
     /* 1921926 */     GIR_EraseRootFromParent_Done,
     /* 1921927 */   // Label 25856: @1921927
     /* 1921927 */   GIM_Try, /*On fail goto*//*Label 25857*/ GIMT_Encode4(1922013), // Rule ID 23644 //
     /* 1921932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1921943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1921946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1921949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921978 */     // MIs[0] policy
     /* 1921978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921988 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922012 */     // GIR_Coverage, 23644,
     /* 1922012 */     GIR_EraseRootFromParent_Done,
     /* 1922013 */   // Label 25857: @1922013
     /* 1922013 */   GIM_Try, /*On fail goto*//*Label 25858*/ GIMT_Encode4(1922099), // Rule ID 23645 //
     /* 1922018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1922029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1922032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1922035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922064 */     // MIs[0] policy
     /* 1922064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1922077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922098 */     // GIR_Coverage, 23645,
     /* 1922098 */     GIR_EraseRootFromParent_Done,
     /* 1922099 */   // Label 25858: @1922099
     /* 1922099 */   GIM_Try, /*On fail goto*//*Label 25859*/ GIMT_Encode4(1922185), // Rule ID 23648 //
     /* 1922104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1922115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1922118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1922121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922150 */     // MIs[0] policy
     /* 1922150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922160 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922184 */     // GIR_Coverage, 23648,
     /* 1922184 */     GIR_EraseRootFromParent_Done,
     /* 1922185 */   // Label 25859: @1922185
     /* 1922185 */   GIM_Try, /*On fail goto*//*Label 25860*/ GIMT_Encode4(1922271), // Rule ID 23649 //
     /* 1922190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1922201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1922204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1922207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922236 */     // MIs[0] policy
     /* 1922236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922246 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922270 */     // GIR_Coverage, 23649,
     /* 1922270 */     GIR_EraseRootFromParent_Done,
     /* 1922271 */   // Label 25860: @1922271
     /* 1922271 */   GIM_Try, /*On fail goto*//*Label 25861*/ GIMT_Encode4(1922357), // Rule ID 23652 //
     /* 1922276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1922287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1922290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1922293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922322 */     // MIs[0] policy
     /* 1922322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922356 */     // GIR_Coverage, 23652,
     /* 1922356 */     GIR_EraseRootFromParent_Done,
     /* 1922357 */   // Label 25861: @1922357
     /* 1922357 */   GIM_Try, /*On fail goto*//*Label 25862*/ GIMT_Encode4(1922443), // Rule ID 23653 //
     /* 1922362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1922373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1922376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1922379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922408 */     // MIs[0] policy
     /* 1922408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922418 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922442 */     // GIR_Coverage, 23653,
     /* 1922442 */     GIR_EraseRootFromParent_Done,
     /* 1922443 */   // Label 25862: @1922443
     /* 1922443 */   GIM_Try, /*On fail goto*//*Label 25863*/ GIMT_Encode4(1922529), // Rule ID 23656 //
     /* 1922448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1922459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1922462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1922465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922494 */     // MIs[0] policy
     /* 1922494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922504 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922528 */     // GIR_Coverage, 23656,
     /* 1922528 */     GIR_EraseRootFromParent_Done,
     /* 1922529 */   // Label 25863: @1922529
     /* 1922529 */   GIM_Try, /*On fail goto*//*Label 25864*/ GIMT_Encode4(1922615), // Rule ID 23657 //
     /* 1922534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1922545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1922548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1922551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922580 */     // MIs[0] policy
     /* 1922580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922590 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922614 */     // GIR_Coverage, 23657,
     /* 1922614 */     GIR_EraseRootFromParent_Done,
     /* 1922615 */   // Label 25864: @1922615
     /* 1922615 */   GIM_Try, /*On fail goto*//*Label 25865*/ GIMT_Encode4(1922701), // Rule ID 23660 //
     /* 1922620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1922623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1922631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1922634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1922637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922666 */     // MIs[0] policy
     /* 1922666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922676 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1922697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922700 */     // GIR_Coverage, 23660,
     /* 1922700 */     GIR_EraseRootFromParent_Done,
     /* 1922701 */   // Label 25865: @1922701
     /* 1922701 */   GIM_Try, /*On fail goto*//*Label 25866*/ GIMT_Encode4(1922787), // Rule ID 23661 //
     /* 1922706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1922709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1922717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1922720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1922723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922752 */     // MIs[0] policy
     /* 1922752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922762 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1922783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922786 */     // GIR_Coverage, 23661,
     /* 1922786 */     GIR_EraseRootFromParent_Done,
     /* 1922787 */   // Label 25866: @1922787
     /* 1922787 */   GIM_Try, /*On fail goto*//*Label 25867*/ GIMT_Encode4(1922873), // Rule ID 23664 //
     /* 1922792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1922803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1922806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1922809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1922815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922838 */     // MIs[0] policy
     /* 1922838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922848 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1922851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922872 */     // GIR_Coverage, 23664,
     /* 1922872 */     GIR_EraseRootFromParent_Done,
     /* 1922873 */   // Label 25867: @1922873
     /* 1922873 */   GIM_Try, /*On fail goto*//*Label 25868*/ GIMT_Encode4(1922959), // Rule ID 23665 //
     /* 1922878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1922889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1922892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1922895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1922901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922924 */     // MIs[0] policy
     /* 1922924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922934 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1922937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922958 */     // GIR_Coverage, 23665,
     /* 1922958 */     GIR_EraseRootFromParent_Done,
     /* 1922959 */   // Label 25868: @1922959
     /* 1922959 */   GIM_Try, /*On fail goto*//*Label 25869*/ GIMT_Encode4(1923045), // Rule ID 23668 //
     /* 1922964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1922975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1922978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1922981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1922987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1922994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923010 */     // MIs[0] policy
     /* 1923010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923020 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923044 */     // GIR_Coverage, 23668,
     /* 1923044 */     GIR_EraseRootFromParent_Done,
     /* 1923045 */   // Label 25869: @1923045
     /* 1923045 */   GIM_Try, /*On fail goto*//*Label 25870*/ GIMT_Encode4(1923131), // Rule ID 23669 //
     /* 1923050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1923061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1923064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1923067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923096 */     // MIs[0] policy
     /* 1923096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923106 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923130 */     // GIR_Coverage, 23669,
     /* 1923130 */     GIR_EraseRootFromParent_Done,
     /* 1923131 */   // Label 25870: @1923131
     /* 1923131 */   GIM_Try, /*On fail goto*//*Label 25871*/ GIMT_Encode4(1923217), // Rule ID 23672 //
     /* 1923136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1923147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1923150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1923153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1923159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923182 */     // MIs[0] policy
     /* 1923182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923192 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923216 */     // GIR_Coverage, 23672,
     /* 1923216 */     GIR_EraseRootFromParent_Done,
     /* 1923217 */   // Label 25871: @1923217
     /* 1923217 */   GIM_Try, /*On fail goto*//*Label 25872*/ GIMT_Encode4(1923303), // Rule ID 23673 //
     /* 1923222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1923233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1923236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1923239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1923245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923268 */     // MIs[0] policy
     /* 1923268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923278 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923302 */     // GIR_Coverage, 23673,
     /* 1923302 */     GIR_EraseRootFromParent_Done,
     /* 1923303 */   // Label 25872: @1923303
     /* 1923303 */   GIM_Try, /*On fail goto*//*Label 25873*/ GIMT_Encode4(1923389), // Rule ID 23676 //
     /* 1923308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1923319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1923322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1923325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923354 */     // MIs[0] policy
     /* 1923354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923364 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923388 */     // GIR_Coverage, 23676,
     /* 1923388 */     GIR_EraseRootFromParent_Done,
     /* 1923389 */   // Label 25873: @1923389
     /* 1923389 */   GIM_Try, /*On fail goto*//*Label 25874*/ GIMT_Encode4(1923475), // Rule ID 23677 //
     /* 1923394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1923405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1923408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1923411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923440 */     // MIs[0] policy
     /* 1923440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923450 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923474 */     // GIR_Coverage, 23677,
     /* 1923474 */     GIR_EraseRootFromParent_Done,
     /* 1923475 */   // Label 25874: @1923475
     /* 1923475 */   GIM_Try, /*On fail goto*//*Label 25875*/ GIMT_Encode4(1923561), // Rule ID 23680 //
     /* 1923480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1923491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1923494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1923497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923526 */     // MIs[0] policy
     /* 1923526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923536 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923560 */     // GIR_Coverage, 23680,
     /* 1923560 */     GIR_EraseRootFromParent_Done,
     /* 1923561 */   // Label 25875: @1923561
     /* 1923561 */   GIM_Try, /*On fail goto*//*Label 25876*/ GIMT_Encode4(1923647), // Rule ID 23681 //
     /* 1923566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1923577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1923580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1923583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923612 */     // MIs[0] policy
     /* 1923612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923622 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923646 */     // GIR_Coverage, 23681,
     /* 1923646 */     GIR_EraseRootFromParent_Done,
     /* 1923647 */   // Label 25876: @1923647
     /* 1923647 */   GIM_Try, /*On fail goto*//*Label 25877*/ GIMT_Encode4(1923733), // Rule ID 23684 //
     /* 1923652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1923663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1923666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1923669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923698 */     // MIs[0] policy
     /* 1923698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923708 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923732 */     // GIR_Coverage, 23684,
     /* 1923732 */     GIR_EraseRootFromParent_Done,
     /* 1923733 */   // Label 25877: @1923733
     /* 1923733 */   GIM_Try, /*On fail goto*//*Label 25878*/ GIMT_Encode4(1923819), // Rule ID 23685 //
     /* 1923738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1923749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1923752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1923755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923784 */     // MIs[0] policy
     /* 1923784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923794 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923818 */     // GIR_Coverage, 23685,
     /* 1923818 */     GIR_EraseRootFromParent_Done,
     /* 1923819 */   // Label 25878: @1923819
     /* 1923819 */   GIM_Try, /*On fail goto*//*Label 25879*/ GIMT_Encode4(1923905), // Rule ID 23688 //
     /* 1923824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1923835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1923838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1923841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923870 */     // MIs[0] policy
     /* 1923870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923904 */     // GIR_Coverage, 23688,
     /* 1923904 */     GIR_EraseRootFromParent_Done,
     /* 1923905 */   // Label 25879: @1923905
     /* 1923905 */   GIM_Try, /*On fail goto*//*Label 25880*/ GIMT_Encode4(1923991), // Rule ID 23689 //
     /* 1923910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1923921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1923924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1923927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923956 */     // MIs[0] policy
     /* 1923956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923990 */     // GIR_Coverage, 23689,
     /* 1923990 */     GIR_EraseRootFromParent_Done,
     /* 1923991 */   // Label 25880: @1923991
     /* 1923991 */   GIM_Try, /*On fail goto*//*Label 25881*/ GIMT_Encode4(1924077), // Rule ID 23692 //
     /* 1923996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1924007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1924010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1924013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924042 */     // MIs[0] policy
     /* 1924042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924052 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1924055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924076 */     // GIR_Coverage, 23692,
     /* 1924076 */     GIR_EraseRootFromParent_Done,
     /* 1924077 */   // Label 25881: @1924077
     /* 1924077 */   GIM_Try, /*On fail goto*//*Label 25882*/ GIMT_Encode4(1924163), // Rule ID 23693 //
     /* 1924082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1924093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1924096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1924099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924128 */     // MIs[0] policy
     /* 1924128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924138 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1924141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924162 */     // GIR_Coverage, 23693,
     /* 1924162 */     GIR_EraseRootFromParent_Done,
     /* 1924163 */   // Label 25882: @1924163
     /* 1924163 */   GIM_Try, /*On fail goto*//*Label 25883*/ GIMT_Encode4(1924249), // Rule ID 23696 //
     /* 1924168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1924179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1924182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1924185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1924191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924214 */     // MIs[0] policy
     /* 1924214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924224 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1924227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924248 */     // GIR_Coverage, 23696,
     /* 1924248 */     GIR_EraseRootFromParent_Done,
     /* 1924249 */   // Label 25883: @1924249
     /* 1924249 */   GIM_Try, /*On fail goto*//*Label 25884*/ GIMT_Encode4(1924335), // Rule ID 23697 //
     /* 1924254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1924265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1924268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1924271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1924277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924300 */     // MIs[0] policy
     /* 1924300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924310 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1924313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924334 */     // GIR_Coverage, 23697,
     /* 1924334 */     GIR_EraseRootFromParent_Done,
     /* 1924335 */   // Label 25884: @1924335
     /* 1924335 */   GIM_Try, /*On fail goto*//*Label 25885*/ GIMT_Encode4(1924421), // Rule ID 23700 //
     /* 1924340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1924343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1924351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1924354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1924357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924386 */     // MIs[0] policy
     /* 1924386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924396 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1924399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924420 */     // GIR_Coverage, 23700,
     /* 1924420 */     GIR_EraseRootFromParent_Done,
     /* 1924421 */   // Label 25885: @1924421
     /* 1924421 */   GIM_Try, /*On fail goto*//*Label 25886*/ GIMT_Encode4(1924507), // Rule ID 23701 //
     /* 1924426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1924429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1924437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1924440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1924443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924472 */     // MIs[0] policy
     /* 1924472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924482 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1924485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924506 */     // GIR_Coverage, 23701,
     /* 1924506 */     GIR_EraseRootFromParent_Done,
     /* 1924507 */   // Label 25886: @1924507
     /* 1924507 */   GIM_Try, /*On fail goto*//*Label 25887*/ GIMT_Encode4(1924593), // Rule ID 23704 //
     /* 1924512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1924515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1924523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1924526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1924529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924558 */     // MIs[0] policy
     /* 1924558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924568 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1924571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924592 */     // GIR_Coverage, 23704,
     /* 1924592 */     GIR_EraseRootFromParent_Done,
     /* 1924593 */   // Label 25887: @1924593
     /* 1924593 */   GIM_Try, /*On fail goto*//*Label 25888*/ GIMT_Encode4(1924679), // Rule ID 23705 //
     /* 1924598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1924601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1924609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1924612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1924615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924644 */     // MIs[0] policy
     /* 1924644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924654 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1924657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924678 */     // GIR_Coverage, 23705,
     /* 1924678 */     GIR_EraseRootFromParent_Done,
     /* 1924679 */   // Label 25888: @1924679
     /* 1924679 */   GIM_Try, /*On fail goto*//*Label 25889*/ GIMT_Encode4(1924765), // Rule ID 23708 //
     /* 1924684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1924687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1924695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1924698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1924701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924730 */     // MIs[0] policy
     /* 1924730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924740 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1924743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924764 */     // GIR_Coverage, 23708,
     /* 1924764 */     GIR_EraseRootFromParent_Done,
     /* 1924765 */   // Label 25889: @1924765
     /* 1924765 */   GIM_Try, /*On fail goto*//*Label 25890*/ GIMT_Encode4(1924851), // Rule ID 23709 //
     /* 1924770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1924773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1924781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1924784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1924787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924816 */     // MIs[0] policy
     /* 1924816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924826 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1924829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924850 */     // GIR_Coverage, 23709,
     /* 1924850 */     GIR_EraseRootFromParent_Done,
     /* 1924851 */   // Label 25890: @1924851
     /* 1924851 */   GIM_Try, /*On fail goto*//*Label 25891*/ GIMT_Encode4(1924937), // Rule ID 23800 //
     /* 1924856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1924867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1924870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1924873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924902 */     // MIs[0] policy
     /* 1924902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924912 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1924915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924936 */     // GIR_Coverage, 23800,
     /* 1924936 */     GIR_EraseRootFromParent_Done,
     /* 1924937 */   // Label 25891: @1924937
     /* 1924937 */   GIM_Try, /*On fail goto*//*Label 25892*/ GIMT_Encode4(1925023), // Rule ID 23801 //
     /* 1924942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1924953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1924956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1924959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924988 */     // MIs[0] policy
     /* 1924988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924998 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1925001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925022 */     // GIR_Coverage, 23801,
     /* 1925022 */     GIR_EraseRootFromParent_Done,
     /* 1925023 */   // Label 25892: @1925023
     /* 1925023 */   GIM_Try, /*On fail goto*//*Label 25893*/ GIMT_Encode4(1925109), // Rule ID 23804 //
     /* 1925028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1925039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1925042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1925045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925074 */     // MIs[0] policy
     /* 1925074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925084 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1925087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925108 */     // GIR_Coverage, 23804,
     /* 1925108 */     GIR_EraseRootFromParent_Done,
     /* 1925109 */   // Label 25893: @1925109
     /* 1925109 */   GIM_Try, /*On fail goto*//*Label 25894*/ GIMT_Encode4(1925195), // Rule ID 23805 //
     /* 1925114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1925125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1925128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1925131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925160 */     // MIs[0] policy
     /* 1925160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925170 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1925173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925194 */     // GIR_Coverage, 23805,
     /* 1925194 */     GIR_EraseRootFromParent_Done,
     /* 1925195 */   // Label 25894: @1925195
     /* 1925195 */   GIM_Try, /*On fail goto*//*Label 25895*/ GIMT_Encode4(1925281), // Rule ID 23808 //
     /* 1925200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1925211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1925214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1925217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925246 */     // MIs[0] policy
     /* 1925246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925256 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925280 */     // GIR_Coverage, 23808,
     /* 1925280 */     GIR_EraseRootFromParent_Done,
     /* 1925281 */   // Label 25895: @1925281
     /* 1925281 */   GIM_Try, /*On fail goto*//*Label 25896*/ GIMT_Encode4(1925367), // Rule ID 23809 //
     /* 1925286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1925297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1925300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1925303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925332 */     // MIs[0] policy
     /* 1925332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925342 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925366 */     // GIR_Coverage, 23809,
     /* 1925366 */     GIR_EraseRootFromParent_Done,
     /* 1925367 */   // Label 25896: @1925367
     /* 1925367 */   GIM_Try, /*On fail goto*//*Label 25897*/ GIMT_Encode4(1925453), // Rule ID 23812 //
     /* 1925372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1925383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1925386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1925389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925418 */     // MIs[0] policy
     /* 1925418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925428 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1925431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925452 */     // GIR_Coverage, 23812,
     /* 1925452 */     GIR_EraseRootFromParent_Done,
     /* 1925453 */   // Label 25897: @1925453
     /* 1925453 */   GIM_Try, /*On fail goto*//*Label 25898*/ GIMT_Encode4(1925539), // Rule ID 23813 //
     /* 1925458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1925469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1925472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1925475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925504 */     // MIs[0] policy
     /* 1925504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925514 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1925517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925538 */     // GIR_Coverage, 23813,
     /* 1925538 */     GIR_EraseRootFromParent_Done,
     /* 1925539 */   // Label 25898: @1925539
     /* 1925539 */   GIM_Try, /*On fail goto*//*Label 25899*/ GIMT_Encode4(1925625), // Rule ID 23816 //
     /* 1925544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1925555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1925558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1925561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925590 */     // MIs[0] policy
     /* 1925590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925600 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925624 */     // GIR_Coverage, 23816,
     /* 1925624 */     GIR_EraseRootFromParent_Done,
     /* 1925625 */   // Label 25899: @1925625
     /* 1925625 */   GIM_Try, /*On fail goto*//*Label 25900*/ GIMT_Encode4(1925711), // Rule ID 23817 //
     /* 1925630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1925641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1925644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1925647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925676 */     // MIs[0] policy
     /* 1925676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925686 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925710 */     // GIR_Coverage, 23817,
     /* 1925710 */     GIR_EraseRootFromParent_Done,
     /* 1925711 */   // Label 25900: @1925711
     /* 1925711 */   GIM_Try, /*On fail goto*//*Label 25901*/ GIMT_Encode4(1925797), // Rule ID 23820 //
     /* 1925716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1925727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1925730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1925733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925762 */     // MIs[0] policy
     /* 1925762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925772 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925796 */     // GIR_Coverage, 23820,
     /* 1925796 */     GIR_EraseRootFromParent_Done,
     /* 1925797 */   // Label 25901: @1925797
     /* 1925797 */   GIM_Try, /*On fail goto*//*Label 25902*/ GIMT_Encode4(1925883), // Rule ID 23821 //
     /* 1925802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1925813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1925816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1925819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925848 */     // MIs[0] policy
     /* 1925848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925858 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925882 */     // GIR_Coverage, 23821,
     /* 1925882 */     GIR_EraseRootFromParent_Done,
     /* 1925883 */   // Label 25902: @1925883
     /* 1925883 */   GIM_Try, /*On fail goto*//*Label 25903*/ GIMT_Encode4(1925969), // Rule ID 23824 //
     /* 1925888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1925899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1925902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1925905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925934 */     // MIs[0] policy
     /* 1925934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925968 */     // GIR_Coverage, 23824,
     /* 1925968 */     GIR_EraseRootFromParent_Done,
     /* 1925969 */   // Label 25903: @1925969
     /* 1925969 */   GIM_Try, /*On fail goto*//*Label 25904*/ GIMT_Encode4(1926055), // Rule ID 23825 //
     /* 1925974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1925985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1925988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1925991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926020 */     // MIs[0] policy
     /* 1926020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926030 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926054 */     // GIR_Coverage, 23825,
     /* 1926054 */     GIR_EraseRootFromParent_Done,
     /* 1926055 */   // Label 25904: @1926055
     /* 1926055 */   GIM_Try, /*On fail goto*//*Label 25905*/ GIMT_Encode4(1926141), // Rule ID 23828 //
     /* 1926060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1926071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1926074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1926077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1926083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926106 */     // MIs[0] policy
     /* 1926106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926116 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926140 */     // GIR_Coverage, 23828,
     /* 1926140 */     GIR_EraseRootFromParent_Done,
     /* 1926141 */   // Label 25905: @1926141
     /* 1926141 */   GIM_Try, /*On fail goto*//*Label 25906*/ GIMT_Encode4(1926227), // Rule ID 23829 //
     /* 1926146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1926157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1926160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1926163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1926169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926192 */     // MIs[0] policy
     /* 1926192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926226 */     // GIR_Coverage, 23829,
     /* 1926226 */     GIR_EraseRootFromParent_Done,
     /* 1926227 */   // Label 25906: @1926227
     /* 1926227 */   GIM_Try, /*On fail goto*//*Label 25907*/ GIMT_Encode4(1926313), // Rule ID 23832 //
     /* 1926232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1926243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1926246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1926249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926278 */     // MIs[0] policy
     /* 1926278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926312 */     // GIR_Coverage, 23832,
     /* 1926312 */     GIR_EraseRootFromParent_Done,
     /* 1926313 */   // Label 25907: @1926313
     /* 1926313 */   GIM_Try, /*On fail goto*//*Label 25908*/ GIMT_Encode4(1926399), // Rule ID 23833 //
     /* 1926318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1926329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1926332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1926335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926364 */     // MIs[0] policy
     /* 1926364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926374 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926398 */     // GIR_Coverage, 23833,
     /* 1926398 */     GIR_EraseRootFromParent_Done,
     /* 1926399 */   // Label 25908: @1926399
     /* 1926399 */   GIM_Try, /*On fail goto*//*Label 25909*/ GIMT_Encode4(1926485), // Rule ID 23836 //
     /* 1926404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1926407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1926415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1926418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1926421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926450 */     // MIs[0] policy
     /* 1926450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926460 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1926481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926484 */     // GIR_Coverage, 23836,
     /* 1926484 */     GIR_EraseRootFromParent_Done,
     /* 1926485 */   // Label 25909: @1926485
     /* 1926485 */   GIM_Try, /*On fail goto*//*Label 25910*/ GIMT_Encode4(1926571), // Rule ID 23837 //
     /* 1926490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1926493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1926501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1926504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1926507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926536 */     // MIs[0] policy
     /* 1926536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926546 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1926567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926570 */     // GIR_Coverage, 23837,
     /* 1926570 */     GIR_EraseRootFromParent_Done,
     /* 1926571 */   // Label 25910: @1926571
     /* 1926571 */   GIM_Try, /*On fail goto*//*Label 25911*/ GIMT_Encode4(1926657), // Rule ID 23840 //
     /* 1926576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1926587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1926590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1926593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926622 */     // MIs[0] policy
     /* 1926622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926632 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1926635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926656 */     // GIR_Coverage, 23840,
     /* 1926656 */     GIR_EraseRootFromParent_Done,
     /* 1926657 */   // Label 25911: @1926657
     /* 1926657 */   GIM_Try, /*On fail goto*//*Label 25912*/ GIMT_Encode4(1926743), // Rule ID 23841 //
     /* 1926662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1926673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1926676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1926679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926708 */     // MIs[0] policy
     /* 1926708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1926721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926742 */     // GIR_Coverage, 23841,
     /* 1926742 */     GIR_EraseRootFromParent_Done,
     /* 1926743 */   // Label 25912: @1926743
     /* 1926743 */   GIM_Try, /*On fail goto*//*Label 25913*/ GIMT_Encode4(1926829), // Rule ID 23844 //
     /* 1926748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1926759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1926762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1926765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1926771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926794 */     // MIs[0] policy
     /* 1926794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926804 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1926807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926828 */     // GIR_Coverage, 23844,
     /* 1926828 */     GIR_EraseRootFromParent_Done,
     /* 1926829 */   // Label 25913: @1926829
     /* 1926829 */   GIM_Try, /*On fail goto*//*Label 25914*/ GIMT_Encode4(1926915), // Rule ID 23845 //
     /* 1926834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1926845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1926848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1926851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1926857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926880 */     // MIs[0] policy
     /* 1926880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926890 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1926893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926914 */     // GIR_Coverage, 23845,
     /* 1926914 */     GIR_EraseRootFromParent_Done,
     /* 1926915 */   // Label 25914: @1926915
     /* 1926915 */   GIM_Try, /*On fail goto*//*Label 25915*/ GIMT_Encode4(1927001), // Rule ID 23848 //
     /* 1926920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1926931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1926934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1926937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1926943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1926950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926966 */     // MIs[0] policy
     /* 1926966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926976 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1926979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927000 */     // GIR_Coverage, 23848,
     /* 1927000 */     GIR_EraseRootFromParent_Done,
     /* 1927001 */   // Label 25915: @1927001
     /* 1927001 */   GIM_Try, /*On fail goto*//*Label 25916*/ GIMT_Encode4(1927087), // Rule ID 23849 //
     /* 1927006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1927017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1927020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1927023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1927029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927052 */     // MIs[0] policy
     /* 1927052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927062 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927086 */     // GIR_Coverage, 23849,
     /* 1927086 */     GIR_EraseRootFromParent_Done,
     /* 1927087 */   // Label 25916: @1927087
     /* 1927087 */   GIM_Try, /*On fail goto*//*Label 25917*/ GIMT_Encode4(1927173), // Rule ID 23852 //
     /* 1927092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1927103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1927106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1927109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927138 */     // MIs[0] policy
     /* 1927138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927148 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927172 */     // GIR_Coverage, 23852,
     /* 1927172 */     GIR_EraseRootFromParent_Done,
     /* 1927173 */   // Label 25917: @1927173
     /* 1927173 */   GIM_Try, /*On fail goto*//*Label 25918*/ GIMT_Encode4(1927259), // Rule ID 23853 //
     /* 1927178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1927189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1927192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1927195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927224 */     // MIs[0] policy
     /* 1927224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927234 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927258 */     // GIR_Coverage, 23853,
     /* 1927258 */     GIR_EraseRootFromParent_Done,
     /* 1927259 */   // Label 25918: @1927259
     /* 1927259 */   GIM_Try, /*On fail goto*//*Label 25919*/ GIMT_Encode4(1927345), // Rule ID 23856 //
     /* 1927264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1927275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1927278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1927281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927310 */     // MIs[0] policy
     /* 1927310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927320 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927344 */     // GIR_Coverage, 23856,
     /* 1927344 */     GIR_EraseRootFromParent_Done,
     /* 1927345 */   // Label 25919: @1927345
     /* 1927345 */   GIM_Try, /*On fail goto*//*Label 25920*/ GIMT_Encode4(1927431), // Rule ID 23857 //
     /* 1927350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1927361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1927364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1927367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927396 */     // MIs[0] policy
     /* 1927396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927406 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927430 */     // GIR_Coverage, 23857,
     /* 1927430 */     GIR_EraseRootFromParent_Done,
     /* 1927431 */   // Label 25920: @1927431
     /* 1927431 */   GIM_Try, /*On fail goto*//*Label 25921*/ GIMT_Encode4(1927517), // Rule ID 23860 //
     /* 1927436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1927447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1927450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1927453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927482 */     // MIs[0] policy
     /* 1927482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927492 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927516 */     // GIR_Coverage, 23860,
     /* 1927516 */     GIR_EraseRootFromParent_Done,
     /* 1927517 */   // Label 25921: @1927517
     /* 1927517 */   GIM_Try, /*On fail goto*//*Label 25922*/ GIMT_Encode4(1927603), // Rule ID 23861 //
     /* 1927522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1927533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1927536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1927539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927568 */     // MIs[0] policy
     /* 1927568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927578 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927602 */     // GIR_Coverage, 23861,
     /* 1927602 */     GIR_EraseRootFromParent_Done,
     /* 1927603 */   // Label 25922: @1927603
     /* 1927603 */   GIM_Try, /*On fail goto*//*Label 25923*/ GIMT_Encode4(1927689), // Rule ID 23864 //
     /* 1927608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1927619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1927622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1927625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927654 */     // MIs[0] policy
     /* 1927654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927688 */     // GIR_Coverage, 23864,
     /* 1927688 */     GIR_EraseRootFromParent_Done,
     /* 1927689 */   // Label 25923: @1927689
     /* 1927689 */   GIM_Try, /*On fail goto*//*Label 25924*/ GIMT_Encode4(1927775), // Rule ID 23865 //
     /* 1927694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1927705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1927708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1927711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927740 */     // MIs[0] policy
     /* 1927740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927750 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927774 */     // GIR_Coverage, 23865,
     /* 1927774 */     GIR_EraseRootFromParent_Done,
     /* 1927775 */   // Label 25924: @1927775
     /* 1927775 */   GIM_Try, /*On fail goto*//*Label 25925*/ GIMT_Encode4(1927861), // Rule ID 23868 //
     /* 1927780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1927791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1927794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1927797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927826 */     // MIs[0] policy
     /* 1927826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927860 */     // GIR_Coverage, 23868,
     /* 1927860 */     GIR_EraseRootFromParent_Done,
     /* 1927861 */   // Label 25925: @1927861
     /* 1927861 */   GIM_Try, /*On fail goto*//*Label 25926*/ GIMT_Encode4(1927947), // Rule ID 23869 //
     /* 1927866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1927877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1927880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1927883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927912 */     // MIs[0] policy
     /* 1927912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927922 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927946 */     // GIR_Coverage, 23869,
     /* 1927946 */     GIR_EraseRootFromParent_Done,
     /* 1927947 */   // Label 25926: @1927947
     /* 1927947 */   GIM_Try, /*On fail goto*//*Label 25927*/ GIMT_Encode4(1928033), // Rule ID 23872 //
     /* 1927952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1927963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1927966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1927969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927998 */     // MIs[0] policy
     /* 1927998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928008 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1928011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928032 */     // GIR_Coverage, 23872,
     /* 1928032 */     GIR_EraseRootFromParent_Done,
     /* 1928033 */   // Label 25927: @1928033
     /* 1928033 */   GIM_Try, /*On fail goto*//*Label 25928*/ GIMT_Encode4(1928119), // Rule ID 23873 //
     /* 1928038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1928049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1928052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1928055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1928061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928084 */     // MIs[0] policy
     /* 1928084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928094 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1928097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928118 */     // GIR_Coverage, 23873,
     /* 1928118 */     GIR_EraseRootFromParent_Done,
     /* 1928119 */   // Label 25928: @1928119
     /* 1928119 */   GIM_Try, /*On fail goto*//*Label 25929*/ GIMT_Encode4(1928205), // Rule ID 23876 //
     /* 1928124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1928127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1928135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1928138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1928141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928170 */     // MIs[0] policy
     /* 1928170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928180 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1928183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928204 */     // GIR_Coverage, 23876,
     /* 1928204 */     GIR_EraseRootFromParent_Done,
     /* 1928205 */   // Label 25929: @1928205
     /* 1928205 */   GIM_Try, /*On fail goto*//*Label 25930*/ GIMT_Encode4(1928291), // Rule ID 23877 //
     /* 1928210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1928213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1928221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1928224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1928227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928256 */     // MIs[0] policy
     /* 1928256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928266 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1928269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928290 */     // GIR_Coverage, 23877,
     /* 1928290 */     GIR_EraseRootFromParent_Done,
     /* 1928291 */   // Label 25930: @1928291
     /* 1928291 */   GIM_Try, /*On fail goto*//*Label 25931*/ GIMT_Encode4(1928377), // Rule ID 23880 //
     /* 1928296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1928299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1928307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1928310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1928313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928342 */     // MIs[0] policy
     /* 1928342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1928355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928376 */     // GIR_Coverage, 23880,
     /* 1928376 */     GIR_EraseRootFromParent_Done,
     /* 1928377 */   // Label 25931: @1928377
     /* 1928377 */   GIM_Try, /*On fail goto*//*Label 25932*/ GIMT_Encode4(1928463), // Rule ID 23881 //
     /* 1928382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1928385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1928393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1928396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1928399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928428 */     // MIs[0] policy
     /* 1928428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928438 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1928441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928462 */     // GIR_Coverage, 23881,
     /* 1928462 */     GIR_EraseRootFromParent_Done,
     /* 1928463 */   // Label 25932: @1928463
     /* 1928463 */   GIM_Try, /*On fail goto*//*Label 25933*/ GIMT_Encode4(1928549), // Rule ID 23884 //
     /* 1928468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1928471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1928485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928514 */     // MIs[0] policy
     /* 1928514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928524 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1928527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928548 */     // GIR_Coverage, 23884,
     /* 1928548 */     GIR_EraseRootFromParent_Done,
     /* 1928549 */   // Label 25933: @1928549
     /* 1928549 */   GIM_Try, /*On fail goto*//*Label 25934*/ GIMT_Encode4(1928635), // Rule ID 23885 //
     /* 1928554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1928557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1928571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928600 */     // MIs[0] policy
     /* 1928600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928610 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1928613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928634 */     // GIR_Coverage, 23885,
     /* 1928634 */     GIR_EraseRootFromParent_Done,
     /* 1928635 */   // Label 25934: @1928635
     /* 1928635 */   GIM_Try, /*On fail goto*//*Label 25935*/ GIMT_Encode4(1928721), // Rule ID 23976 //
     /* 1928640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1928651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1928654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1928657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928686 */     // MIs[0] policy
     /* 1928686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928696 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1928699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928720 */     // GIR_Coverage, 23976,
     /* 1928720 */     GIR_EraseRootFromParent_Done,
     /* 1928721 */   // Label 25935: @1928721
     /* 1928721 */   GIM_Try, /*On fail goto*//*Label 25936*/ GIMT_Encode4(1928807), // Rule ID 23977 //
     /* 1928726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1928737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1928740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1928743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928772 */     // MIs[0] policy
     /* 1928772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928782 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1928785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928806 */     // GIR_Coverage, 23977,
     /* 1928806 */     GIR_EraseRootFromParent_Done,
     /* 1928807 */   // Label 25936: @1928807
     /* 1928807 */   GIM_Try, /*On fail goto*//*Label 25937*/ GIMT_Encode4(1928893), // Rule ID 23980 //
     /* 1928812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1928823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1928826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1928829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928858 */     // MIs[0] policy
     /* 1928858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928868 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1928871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928892 */     // GIR_Coverage, 23980,
     /* 1928892 */     GIR_EraseRootFromParent_Done,
     /* 1928893 */   // Label 25937: @1928893
     /* 1928893 */   GIM_Try, /*On fail goto*//*Label 25938*/ GIMT_Encode4(1928979), // Rule ID 23981 //
     /* 1928898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1928909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1928912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1928915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928944 */     // MIs[0] policy
     /* 1928944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928954 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1928957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928978 */     // GIR_Coverage, 23981,
     /* 1928978 */     GIR_EraseRootFromParent_Done,
     /* 1928979 */   // Label 25938: @1928979
     /* 1928979 */   GIM_Try, /*On fail goto*//*Label 25939*/ GIMT_Encode4(1929065), // Rule ID 23984 //
     /* 1928984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1928995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1928998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1929001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929030 */     // MIs[0] policy
     /* 1929030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929040 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929064 */     // GIR_Coverage, 23984,
     /* 1929064 */     GIR_EraseRootFromParent_Done,
     /* 1929065 */   // Label 25939: @1929065
     /* 1929065 */   GIM_Try, /*On fail goto*//*Label 25940*/ GIMT_Encode4(1929151), // Rule ID 23985 //
     /* 1929070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1929081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1929084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1929087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929116 */     // MIs[0] policy
     /* 1929116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929126 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929150 */     // GIR_Coverage, 23985,
     /* 1929150 */     GIR_EraseRootFromParent_Done,
     /* 1929151 */   // Label 25940: @1929151
     /* 1929151 */   GIM_Try, /*On fail goto*//*Label 25941*/ GIMT_Encode4(1929237), // Rule ID 23988 //
     /* 1929156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1929167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1929170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1929173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929202 */     // MIs[0] policy
     /* 1929202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929212 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1929215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929236 */     // GIR_Coverage, 23988,
     /* 1929236 */     GIR_EraseRootFromParent_Done,
     /* 1929237 */   // Label 25941: @1929237
     /* 1929237 */   GIM_Try, /*On fail goto*//*Label 25942*/ GIMT_Encode4(1929323), // Rule ID 23989 //
     /* 1929242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1929253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1929256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1929259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929288 */     // MIs[0] policy
     /* 1929288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929298 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1929301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929322 */     // GIR_Coverage, 23989,
     /* 1929322 */     GIR_EraseRootFromParent_Done,
     /* 1929323 */   // Label 25942: @1929323
     /* 1929323 */   GIM_Try, /*On fail goto*//*Label 25943*/ GIMT_Encode4(1929409), // Rule ID 23992 //
     /* 1929328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1929339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1929342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1929345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929374 */     // MIs[0] policy
     /* 1929374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929384 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929408 */     // GIR_Coverage, 23992,
     /* 1929408 */     GIR_EraseRootFromParent_Done,
     /* 1929409 */   // Label 25943: @1929409
     /* 1929409 */   GIM_Try, /*On fail goto*//*Label 25944*/ GIMT_Encode4(1929495), // Rule ID 23993 //
     /* 1929414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1929425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1929428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1929431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929460 */     // MIs[0] policy
     /* 1929460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929470 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929494 */     // GIR_Coverage, 23993,
     /* 1929494 */     GIR_EraseRootFromParent_Done,
     /* 1929495 */   // Label 25944: @1929495
     /* 1929495 */   GIM_Try, /*On fail goto*//*Label 25945*/ GIMT_Encode4(1929581), // Rule ID 23996 //
     /* 1929500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929546 */     // MIs[0] policy
     /* 1929546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929556 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929580 */     // GIR_Coverage, 23996,
     /* 1929580 */     GIR_EraseRootFromParent_Done,
     /* 1929581 */   // Label 25945: @1929581
     /* 1929581 */   GIM_Try, /*On fail goto*//*Label 25946*/ GIMT_Encode4(1929667), // Rule ID 23997 //
     /* 1929586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929632 */     // MIs[0] policy
     /* 1929632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929642 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929666 */     // GIR_Coverage, 23997,
     /* 1929666 */     GIR_EraseRootFromParent_Done,
     /* 1929667 */   // Label 25946: @1929667
     /* 1929667 */   GIM_Try, /*On fail goto*//*Label 25947*/ GIMT_Encode4(1929753), // Rule ID 24000 //
     /* 1929672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1929683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1929686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1929689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929718 */     // MIs[0] policy
     /* 1929718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929728 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929752 */     // GIR_Coverage, 24000,
     /* 1929752 */     GIR_EraseRootFromParent_Done,
     /* 1929753 */   // Label 25947: @1929753
     /* 1929753 */   GIM_Try, /*On fail goto*//*Label 25948*/ GIMT_Encode4(1929839), // Rule ID 24001 //
     /* 1929758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1929769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1929772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1929775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929804 */     // MIs[0] policy
     /* 1929804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929814 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929838 */     // GIR_Coverage, 24001,
     /* 1929838 */     GIR_EraseRootFromParent_Done,
     /* 1929839 */   // Label 25948: @1929839
     /* 1929839 */   GIM_Try, /*On fail goto*//*Label 25949*/ GIMT_Encode4(1929925), // Rule ID 24004 //
     /* 1929844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1929855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1929858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1929861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929890 */     // MIs[0] policy
     /* 1929890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929924 */     // GIR_Coverage, 24004,
     /* 1929924 */     GIR_EraseRootFromParent_Done,
     /* 1929925 */   // Label 25949: @1929925
     /* 1929925 */   GIM_Try, /*On fail goto*//*Label 25950*/ GIMT_Encode4(1930011), // Rule ID 24005 //
     /* 1929930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1929941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1929944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1929947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929976 */     // MIs[0] policy
     /* 1929976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929986 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930010 */     // GIR_Coverage, 24005,
     /* 1930010 */     GIR_EraseRootFromParent_Done,
     /* 1930011 */   // Label 25950: @1930011
     /* 1930011 */   GIM_Try, /*On fail goto*//*Label 25951*/ GIMT_Encode4(1930097), // Rule ID 24008 //
     /* 1930016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1930027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1930030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1930033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1930039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930062 */     // MIs[0] policy
     /* 1930062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930072 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1930075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930096 */     // GIR_Coverage, 24008,
     /* 1930096 */     GIR_EraseRootFromParent_Done,
     /* 1930097 */   // Label 25951: @1930097
     /* 1930097 */   GIM_Try, /*On fail goto*//*Label 25952*/ GIMT_Encode4(1930183), // Rule ID 24009 //
     /* 1930102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1930113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1930116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1930119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1930125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930148 */     // MIs[0] policy
     /* 1930148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1930161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930182 */     // GIR_Coverage, 24009,
     /* 1930182 */     GIR_EraseRootFromParent_Done,
     /* 1930183 */   // Label 25952: @1930183
     /* 1930183 */   GIM_Try, /*On fail goto*//*Label 25953*/ GIMT_Encode4(1930269), // Rule ID 24012 //
     /* 1930188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1930191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1930199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1930202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1930205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930234 */     // MIs[0] policy
     /* 1930234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930244 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1930247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1930265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930268 */     // GIR_Coverage, 24012,
     /* 1930268 */     GIR_EraseRootFromParent_Done,
     /* 1930269 */   // Label 25953: @1930269
     /* 1930269 */   GIM_Try, /*On fail goto*//*Label 25954*/ GIMT_Encode4(1930355), // Rule ID 24013 //
     /* 1930274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1930277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1930285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1930288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1930291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930320 */     // MIs[0] policy
     /* 1930320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930330 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1930333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1930351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930354 */     // GIR_Coverage, 24013,
     /* 1930354 */     GIR_EraseRootFromParent_Done,
     /* 1930355 */   // Label 25954: @1930355
     /* 1930355 */   GIM_Try, /*On fail goto*//*Label 25955*/ GIMT_Encode4(1930441), // Rule ID 24016 //
     /* 1930360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1930371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1930374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1930377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930406 */     // MIs[0] policy
     /* 1930406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930416 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930440 */     // GIR_Coverage, 24016,
     /* 1930440 */     GIR_EraseRootFromParent_Done,
     /* 1930441 */   // Label 25955: @1930441
     /* 1930441 */   GIM_Try, /*On fail goto*//*Label 25956*/ GIMT_Encode4(1930527), // Rule ID 24017 //
     /* 1930446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1930457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1930460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1930463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930492 */     // MIs[0] policy
     /* 1930492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930502 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930526 */     // GIR_Coverage, 24017,
     /* 1930526 */     GIR_EraseRootFromParent_Done,
     /* 1930527 */   // Label 25956: @1930527
     /* 1930527 */   GIM_Try, /*On fail goto*//*Label 25957*/ GIMT_Encode4(1930613), // Rule ID 24020 //
     /* 1930532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1930543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1930546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1930549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930578 */     // MIs[0] policy
     /* 1930578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930588 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1930591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930612 */     // GIR_Coverage, 24020,
     /* 1930612 */     GIR_EraseRootFromParent_Done,
     /* 1930613 */   // Label 25957: @1930613
     /* 1930613 */   GIM_Try, /*On fail goto*//*Label 25958*/ GIMT_Encode4(1930699), // Rule ID 24021 //
     /* 1930618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1930629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1930632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1930635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930664 */     // MIs[0] policy
     /* 1930664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930674 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1930677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930698 */     // GIR_Coverage, 24021,
     /* 1930698 */     GIR_EraseRootFromParent_Done,
     /* 1930699 */   // Label 25958: @1930699
     /* 1930699 */   GIM_Try, /*On fail goto*//*Label 25959*/ GIMT_Encode4(1930785), // Rule ID 24024 //
     /* 1930704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1930715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1930718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1930721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1930727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930750 */     // MIs[0] policy
     /* 1930750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930760 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1930763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930784 */     // GIR_Coverage, 24024,
     /* 1930784 */     GIR_EraseRootFromParent_Done,
     /* 1930785 */   // Label 25959: @1930785
     /* 1930785 */   GIM_Try, /*On fail goto*//*Label 25960*/ GIMT_Encode4(1930871), // Rule ID 24025 //
     /* 1930790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1930801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1930804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1930807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1930813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930836 */     // MIs[0] policy
     /* 1930836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930846 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1930849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930870 */     // GIR_Coverage, 24025,
     /* 1930870 */     GIR_EraseRootFromParent_Done,
     /* 1930871 */   // Label 25960: @1930871
     /* 1930871 */   GIM_Try, /*On fail goto*//*Label 25961*/ GIMT_Encode4(1930957), // Rule ID 24028 //
     /* 1930876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1930887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1930890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1930893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930922 */     // MIs[0] policy
     /* 1930922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930932 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930956 */     // GIR_Coverage, 24028,
     /* 1930956 */     GIR_EraseRootFromParent_Done,
     /* 1930957 */   // Label 25961: @1930957
     /* 1930957 */   GIM_Try, /*On fail goto*//*Label 25962*/ GIMT_Encode4(1931043), // Rule ID 24029 //
     /* 1930962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1930973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1930976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1930979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931008 */     // MIs[0] policy
     /* 1931008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931042 */     // GIR_Coverage, 24029,
     /* 1931042 */     GIR_EraseRootFromParent_Done,
     /* 1931043 */   // Label 25962: @1931043
     /* 1931043 */   GIM_Try, /*On fail goto*//*Label 25963*/ GIMT_Encode4(1931129), // Rule ID 24032 //
     /* 1931048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1931059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1931062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1931065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931094 */     // MIs[0] policy
     /* 1931094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931104 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931128 */     // GIR_Coverage, 24032,
     /* 1931128 */     GIR_EraseRootFromParent_Done,
     /* 1931129 */   // Label 25963: @1931129
     /* 1931129 */   GIM_Try, /*On fail goto*//*Label 25964*/ GIMT_Encode4(1931215), // Rule ID 24033 //
     /* 1931134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1931145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1931148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1931151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931180 */     // MIs[0] policy
     /* 1931180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931190 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931214 */     // GIR_Coverage, 24033,
     /* 1931214 */     GIR_EraseRootFromParent_Done,
     /* 1931215 */   // Label 25964: @1931215
     /* 1931215 */   GIM_Try, /*On fail goto*//*Label 25965*/ GIMT_Encode4(1931301), // Rule ID 24036 //
     /* 1931220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1931231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1931234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1931237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1931243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931266 */     // MIs[0] policy
     /* 1931266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931276 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931300 */     // GIR_Coverage, 24036,
     /* 1931300 */     GIR_EraseRootFromParent_Done,
     /* 1931301 */   // Label 25965: @1931301
     /* 1931301 */   GIM_Try, /*On fail goto*//*Label 25966*/ GIMT_Encode4(1931387), // Rule ID 24037 //
     /* 1931306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1931317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1931320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1931323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1931329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931352 */     // MIs[0] policy
     /* 1931352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931362 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931386 */     // GIR_Coverage, 24037,
     /* 1931386 */     GIR_EraseRootFromParent_Done,
     /* 1931387 */   // Label 25966: @1931387
     /* 1931387 */   GIM_Try, /*On fail goto*//*Label 25967*/ GIMT_Encode4(1931473), // Rule ID 24040 //
     /* 1931392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1931403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1931406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1931409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931438 */     // MIs[0] policy
     /* 1931438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931448 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931472 */     // GIR_Coverage, 24040,
     /* 1931472 */     GIR_EraseRootFromParent_Done,
     /* 1931473 */   // Label 25967: @1931473
     /* 1931473 */   GIM_Try, /*On fail goto*//*Label 25968*/ GIMT_Encode4(1931559), // Rule ID 24041 //
     /* 1931478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1931489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1931492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1931495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931524 */     // MIs[0] policy
     /* 1931524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931558 */     // GIR_Coverage, 24041,
     /* 1931558 */     GIR_EraseRootFromParent_Done,
     /* 1931559 */   // Label 25968: @1931559
     /* 1931559 */   GIM_Try, /*On fail goto*//*Label 25969*/ GIMT_Encode4(1931645), // Rule ID 24044 //
     /* 1931564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1931575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1931578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1931581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931610 */     // MIs[0] policy
     /* 1931610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931620 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931644 */     // GIR_Coverage, 24044,
     /* 1931644 */     GIR_EraseRootFromParent_Done,
     /* 1931645 */   // Label 25969: @1931645
     /* 1931645 */   GIM_Try, /*On fail goto*//*Label 25970*/ GIMT_Encode4(1931731), // Rule ID 24045 //
     /* 1931650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1931661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1931664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1931667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931696 */     // MIs[0] policy
     /* 1931696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931706 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931730 */     // GIR_Coverage, 24045,
     /* 1931730 */     GIR_EraseRootFromParent_Done,
     /* 1931731 */   // Label 25970: @1931731
     /* 1931731 */   GIM_Try, /*On fail goto*//*Label 25971*/ GIMT_Encode4(1931817), // Rule ID 24048 //
     /* 1931736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1931747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1931750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1931753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931782 */     // MIs[0] policy
     /* 1931782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931792 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931816 */     // GIR_Coverage, 24048,
     /* 1931816 */     GIR_EraseRootFromParent_Done,
     /* 1931817 */   // Label 25971: @1931817
     /* 1931817 */   GIM_Try, /*On fail goto*//*Label 25972*/ GIMT_Encode4(1931903), // Rule ID 24049 //
     /* 1931822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1931833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1931836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1931839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931868 */     // MIs[0] policy
     /* 1931868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931878 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931902 */     // GIR_Coverage, 24049,
     /* 1931902 */     GIR_EraseRootFromParent_Done,
     /* 1931903 */   // Label 25972: @1931903
     /* 1931903 */   GIM_Try, /*On fail goto*//*Label 25973*/ GIMT_Encode4(1931989), // Rule ID 24052 //
     /* 1931908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1931911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1931919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1931922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1931925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931954 */     // MIs[0] policy
     /* 1931954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931964 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931988 */     // GIR_Coverage, 24052,
     /* 1931988 */     GIR_EraseRootFromParent_Done,
     /* 1931989 */   // Label 25973: @1931989
     /* 1931989 */   GIM_Try, /*On fail goto*//*Label 25974*/ GIMT_Encode4(1932075), // Rule ID 24053 //
     /* 1931994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1931997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1932005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1932008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1932011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1932024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932040 */     // MIs[0] policy
     /* 1932040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932050 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1932053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932074 */     // GIR_Coverage, 24053,
     /* 1932074 */     GIR_EraseRootFromParent_Done,
     /* 1932075 */   // Label 25974: @1932075
     /* 1932075 */   GIM_Try, /*On fail goto*//*Label 25975*/ GIMT_Encode4(1932161), // Rule ID 24056 //
     /* 1932080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1932083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1932091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1932094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1932097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932126 */     // MIs[0] policy
     /* 1932126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932136 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1932139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932160 */     // GIR_Coverage, 24056,
     /* 1932160 */     GIR_EraseRootFromParent_Done,
     /* 1932161 */   // Label 25975: @1932161
     /* 1932161 */   GIM_Try, /*On fail goto*//*Label 25976*/ GIMT_Encode4(1932247), // Rule ID 24057 //
     /* 1932166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1932169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1932177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1932180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1932183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932212 */     // MIs[0] policy
     /* 1932212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932222 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1932225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932246 */     // GIR_Coverage, 24057,
     /* 1932246 */     GIR_EraseRootFromParent_Done,
     /* 1932247 */   // Label 25976: @1932247
     /* 1932247 */   GIM_Try, /*On fail goto*//*Label 25977*/ GIMT_Encode4(1932333), // Rule ID 24060 //
     /* 1932252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1932255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1932263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1932266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1932269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1932275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1932282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932298 */     // MIs[0] policy
     /* 1932298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932308 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1932311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932332 */     // GIR_Coverage, 24060,
     /* 1932332 */     GIR_EraseRootFromParent_Done,
     /* 1932333 */   // Label 25977: @1932333
     /* 1932333 */   GIM_Try, /*On fail goto*//*Label 25978*/ GIMT_Encode4(1932419), // Rule ID 24061 //
     /* 1932338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1932341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1932349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1932352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1932355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1932361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1932368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932384 */     // MIs[0] policy
     /* 1932384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1932397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932418 */     // GIR_Coverage, 24061,
     /* 1932418 */     GIR_EraseRootFromParent_Done,
     /* 1932419 */   // Label 25978: @1932419
     /* 1932419 */   GIM_Try, /*On fail goto*//*Label 25979*/ GIMT_Encode4(1932505), // Rule ID 24064 //
     /* 1932424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1932435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1932438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1932441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932470 */     // MIs[0] policy
     /* 1932470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932480 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1932483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932504 */     // GIR_Coverage, 24064,
     /* 1932504 */     GIR_EraseRootFromParent_Done,
     /* 1932505 */   // Label 25979: @1932505
     /* 1932505 */   GIM_Try, /*On fail goto*//*Label 25980*/ GIMT_Encode4(1932591), // Rule ID 24065 //
     /* 1932510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1932521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1932524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1932527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932556 */     // MIs[0] policy
     /* 1932556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932566 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1932569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932590 */     // GIR_Coverage, 24065,
     /* 1932590 */     GIR_EraseRootFromParent_Done,
     /* 1932591 */   // Label 25980: @1932591
     /* 1932591 */   GIM_Try, /*On fail goto*//*Label 25981*/ GIMT_Encode4(1932677), // Rule ID 24068 //
     /* 1932596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1932607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1932610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1932613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932642 */     // MIs[0] policy
     /* 1932642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932652 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932676 */     // GIR_Coverage, 24068,
     /* 1932676 */     GIR_EraseRootFromParent_Done,
     /* 1932677 */   // Label 25981: @1932677
     /* 1932677 */   GIM_Try, /*On fail goto*//*Label 25982*/ GIMT_Encode4(1932763), // Rule ID 24069 //
     /* 1932682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1932693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1932696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1932699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932728 */     // MIs[0] policy
     /* 1932728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932738 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932762 */     // GIR_Coverage, 24069,
     /* 1932762 */     GIR_EraseRootFromParent_Done,
     /* 1932763 */   // Label 25982: @1932763
     /* 1932763 */   GIM_Try, /*On fail goto*//*Label 25983*/ GIMT_Encode4(1932849), // Rule ID 24072 //
     /* 1932768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1932779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1932782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1932785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932814 */     // MIs[0] policy
     /* 1932814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932824 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932848 */     // GIR_Coverage, 24072,
     /* 1932848 */     GIR_EraseRootFromParent_Done,
     /* 1932849 */   // Label 25983: @1932849
     /* 1932849 */   GIM_Try, /*On fail goto*//*Label 25984*/ GIMT_Encode4(1932935), // Rule ID 24073 //
     /* 1932854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1932865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1932868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1932871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932900 */     // MIs[0] policy
     /* 1932900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932910 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932934 */     // GIR_Coverage, 24073,
     /* 1932934 */     GIR_EraseRootFromParent_Done,
     /* 1932935 */   // Label 25984: @1932935
     /* 1932935 */   GIM_Try, /*On fail goto*//*Label 25985*/ GIMT_Encode4(1933021), // Rule ID 24076 //
     /* 1932940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1932951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1932954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1932957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932986 */     // MIs[0] policy
     /* 1932986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932996 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933020 */     // GIR_Coverage, 24076,
     /* 1933020 */     GIR_EraseRootFromParent_Done,
     /* 1933021 */   // Label 25985: @1933021
     /* 1933021 */   GIM_Try, /*On fail goto*//*Label 25986*/ GIMT_Encode4(1933107), // Rule ID 24077 //
     /* 1933026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1933037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1933040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1933043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933072 */     // MIs[0] policy
     /* 1933072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933082 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1933085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933106 */     // GIR_Coverage, 24077,
     /* 1933106 */     GIR_EraseRootFromParent_Done,
     /* 1933107 */   // Label 25986: @1933107
     /* 1933107 */   GIM_Try, /*On fail goto*//*Label 25987*/ GIMT_Encode4(1933193), // Rule ID 24080 //
     /* 1933112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1933123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1933126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1933129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933158 */     // MIs[0] policy
     /* 1933158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933168 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1933171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933192 */     // GIR_Coverage, 24080,
     /* 1933192 */     GIR_EraseRootFromParent_Done,
     /* 1933193 */   // Label 25987: @1933193
     /* 1933193 */   GIM_Try, /*On fail goto*//*Label 25988*/ GIMT_Encode4(1933279), // Rule ID 24081 //
     /* 1933198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1933209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1933212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1933215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933244 */     // MIs[0] policy
     /* 1933244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933254 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1933257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933278 */     // GIR_Coverage, 24081,
     /* 1933278 */     GIR_EraseRootFromParent_Done,
     /* 1933279 */   // Label 25988: @1933279
     /* 1933279 */   GIM_Try, /*On fail goto*//*Label 25989*/ GIMT_Encode4(1933365), // Rule ID 24084 //
     /* 1933284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1933295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1933298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1933301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933330 */     // MIs[0] policy
     /* 1933330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933340 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1933343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933364 */     // GIR_Coverage, 24084,
     /* 1933364 */     GIR_EraseRootFromParent_Done,
     /* 1933365 */   // Label 25989: @1933365
     /* 1933365 */   GIM_Try, /*On fail goto*//*Label 25990*/ GIMT_Encode4(1933451), // Rule ID 24085 //
     /* 1933370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1933381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1933384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1933387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933416 */     // MIs[0] policy
     /* 1933416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933426 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1933429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933450 */     // GIR_Coverage, 24085,
     /* 1933450 */     GIR_EraseRootFromParent_Done,
     /* 1933451 */   // Label 25990: @1933451
     /* 1933451 */   GIM_Try, /*On fail goto*//*Label 25991*/ GIMT_Encode4(1933537), // Rule ID 24088 //
     /* 1933456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1933467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1933470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1933473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933502 */     // MIs[0] policy
     /* 1933502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933512 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933536 */     // GIR_Coverage, 24088,
     /* 1933536 */     GIR_EraseRootFromParent_Done,
     /* 1933537 */   // Label 25991: @1933537
     /* 1933537 */   GIM_Try, /*On fail goto*//*Label 25992*/ GIMT_Encode4(1933623), // Rule ID 24089 //
     /* 1933542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1933553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1933556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1933559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933588 */     // MIs[0] policy
     /* 1933588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933598 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933622 */     // GIR_Coverage, 24089,
     /* 1933622 */     GIR_EraseRootFromParent_Done,
     /* 1933623 */   // Label 25992: @1933623
     /* 1933623 */   GIM_Try, /*On fail goto*//*Label 25993*/ GIMT_Encode4(1933709), // Rule ID 24092 //
     /* 1933628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1933639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1933642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1933645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933674 */     // MIs[0] policy
     /* 1933674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933684 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933708 */     // GIR_Coverage, 24092,
     /* 1933708 */     GIR_EraseRootFromParent_Done,
     /* 1933709 */   // Label 25993: @1933709
     /* 1933709 */   GIM_Try, /*On fail goto*//*Label 25994*/ GIMT_Encode4(1933795), // Rule ID 24093 //
     /* 1933714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1933725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1933728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1933731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933760 */     // MIs[0] policy
     /* 1933760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933794 */     // GIR_Coverage, 24093,
     /* 1933794 */     GIR_EraseRootFromParent_Done,
     /* 1933795 */   // Label 25994: @1933795
     /* 1933795 */   GIM_Try, /*On fail goto*//*Label 25995*/ GIMT_Encode4(1933881), // Rule ID 24096 //
     /* 1933800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1933811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1933814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1933817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933846 */     // MIs[0] policy
     /* 1933846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933856 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933880 */     // GIR_Coverage, 24096,
     /* 1933880 */     GIR_EraseRootFromParent_Done,
     /* 1933881 */   // Label 25995: @1933881
     /* 1933881 */   GIM_Try, /*On fail goto*//*Label 25996*/ GIMT_Encode4(1933967), // Rule ID 24097 //
     /* 1933886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1933897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1933900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1933903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933932 */     // MIs[0] policy
     /* 1933932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933942 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933966 */     // GIR_Coverage, 24097,
     /* 1933966 */     GIR_EraseRootFromParent_Done,
     /* 1933967 */   // Label 25996: @1933967
     /* 1933967 */   GIM_Try, /*On fail goto*//*Label 25997*/ GIMT_Encode4(1934053), // Rule ID 24100 //
     /* 1933972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1933975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1933983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1933986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1933989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934018 */     // MIs[0] policy
     /* 1934018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934028 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1934031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1934049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934052 */     // GIR_Coverage, 24100,
     /* 1934052 */     GIR_EraseRootFromParent_Done,
     /* 1934053 */   // Label 25997: @1934053
     /* 1934053 */   GIM_Try, /*On fail goto*//*Label 25998*/ GIMT_Encode4(1934139), // Rule ID 24101 //
     /* 1934058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1934061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1934069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1934072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1934075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1934081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934104 */     // MIs[0] policy
     /* 1934104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934114 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1934117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1934135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934138 */     // GIR_Coverage, 24101,
     /* 1934138 */     GIR_EraseRootFromParent_Done,
     /* 1934139 */   // Label 25998: @1934139
     /* 1934139 */   GIM_Try, /*On fail goto*//*Label 25999*/ GIMT_Encode4(1934225), // Rule ID 24104 //
     /* 1934144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1934155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1934158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1934161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934190 */     // MIs[0] policy
     /* 1934190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934224 */     // GIR_Coverage, 24104,
     /* 1934224 */     GIR_EraseRootFromParent_Done,
     /* 1934225 */   // Label 25999: @1934225
     /* 1934225 */   GIM_Try, /*On fail goto*//*Label 26000*/ GIMT_Encode4(1934311), // Rule ID 24105 //
     /* 1934230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1934241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1934244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1934247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934276 */     // MIs[0] policy
     /* 1934276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934286 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934310 */     // GIR_Coverage, 24105,
     /* 1934310 */     GIR_EraseRootFromParent_Done,
     /* 1934311 */   // Label 26000: @1934311
     /* 1934311 */   GIM_Try, /*On fail goto*//*Label 26001*/ GIMT_Encode4(1934397), // Rule ID 24108 //
     /* 1934316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1934327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1934330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1934333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934362 */     // MIs[0] policy
     /* 1934362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934372 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934396 */     // GIR_Coverage, 24108,
     /* 1934396 */     GIR_EraseRootFromParent_Done,
     /* 1934397 */   // Label 26001: @1934397
     /* 1934397 */   GIM_Try, /*On fail goto*//*Label 26002*/ GIMT_Encode4(1934483), // Rule ID 24109 //
     /* 1934402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1934413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1934416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1934419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934448 */     // MIs[0] policy
     /* 1934448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934458 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934482 */     // GIR_Coverage, 24109,
     /* 1934482 */     GIR_EraseRootFromParent_Done,
     /* 1934483 */   // Label 26002: @1934483
     /* 1934483 */   GIM_Try, /*On fail goto*//*Label 26003*/ GIMT_Encode4(1934569), // Rule ID 24112 //
     /* 1934488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1934499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1934502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1934505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1934511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934534 */     // MIs[0] policy
     /* 1934534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934544 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1934547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934568 */     // GIR_Coverage, 24112,
     /* 1934568 */     GIR_EraseRootFromParent_Done,
     /* 1934569 */   // Label 26003: @1934569
     /* 1934569 */   GIM_Try, /*On fail goto*//*Label 26004*/ GIMT_Encode4(1934655), // Rule ID 24113 //
     /* 1934574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1934585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1934588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1934591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1934597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934620 */     // MIs[0] policy
     /* 1934620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934630 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1934633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934654 */     // GIR_Coverage, 24113,
     /* 1934654 */     GIR_EraseRootFromParent_Done,
     /* 1934655 */   // Label 26004: @1934655
     /* 1934655 */   GIM_Try, /*On fail goto*//*Label 26005*/ GIMT_Encode4(1934741), // Rule ID 24116 //
     /* 1934660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1934671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1934674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1934677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934706 */     // MIs[0] policy
     /* 1934706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934740 */     // GIR_Coverage, 24116,
     /* 1934740 */     GIR_EraseRootFromParent_Done,
     /* 1934741 */   // Label 26005: @1934741
     /* 1934741 */   GIM_Try, /*On fail goto*//*Label 26006*/ GIMT_Encode4(1934827), // Rule ID 24117 //
     /* 1934746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1934757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1934760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1934763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934792 */     // MIs[0] policy
     /* 1934792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934826 */     // GIR_Coverage, 24117,
     /* 1934826 */     GIR_EraseRootFromParent_Done,
     /* 1934827 */   // Label 26006: @1934827
     /* 1934827 */   GIM_Try, /*On fail goto*//*Label 26007*/ GIMT_Encode4(1934913), // Rule ID 24120 //
     /* 1934832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1934843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1934846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1934849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934878 */     // MIs[0] policy
     /* 1934878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934888 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934912 */     // GIR_Coverage, 24120,
     /* 1934912 */     GIR_EraseRootFromParent_Done,
     /* 1934913 */   // Label 26007: @1934913
     /* 1934913 */   GIM_Try, /*On fail goto*//*Label 26008*/ GIMT_Encode4(1934999), // Rule ID 24121 //
     /* 1934918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1934929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1934932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1934935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934964 */     // MIs[0] policy
     /* 1934964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934974 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934998 */     // GIR_Coverage, 24121,
     /* 1934998 */     GIR_EraseRootFromParent_Done,
     /* 1934999 */   // Label 26008: @1934999
     /* 1934999 */   GIM_Try, /*On fail goto*//*Label 26009*/ GIMT_Encode4(1935085), // Rule ID 24124 //
     /* 1935004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1935015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1935018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1935021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1935027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935050 */     // MIs[0] policy
     /* 1935050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935060 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935084 */     // GIR_Coverage, 24124,
     /* 1935084 */     GIR_EraseRootFromParent_Done,
     /* 1935085 */   // Label 26009: @1935085
     /* 1935085 */   GIM_Try, /*On fail goto*//*Label 26010*/ GIMT_Encode4(1935171), // Rule ID 24125 //
     /* 1935090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1935101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1935104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1935107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1935113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935136 */     // MIs[0] policy
     /* 1935136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935170 */     // GIR_Coverage, 24125,
     /* 1935170 */     GIR_EraseRootFromParent_Done,
     /* 1935171 */   // Label 26010: @1935171
     /* 1935171 */   GIM_Try, /*On fail goto*//*Label 26011*/ GIMT_Encode4(1935257), // Rule ID 24128 //
     /* 1935176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1935187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1935190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1935193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935222 */     // MIs[0] policy
     /* 1935222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1935235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935256 */     // GIR_Coverage, 24128,
     /* 1935256 */     GIR_EraseRootFromParent_Done,
     /* 1935257 */   // Label 26011: @1935257
     /* 1935257 */   GIM_Try, /*On fail goto*//*Label 26012*/ GIMT_Encode4(1935343), // Rule ID 24129 //
     /* 1935262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1935273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1935276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1935279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935308 */     // MIs[0] policy
     /* 1935308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1935321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935342 */     // GIR_Coverage, 24129,
     /* 1935342 */     GIR_EraseRootFromParent_Done,
     /* 1935343 */   // Label 26012: @1935343
     /* 1935343 */   GIM_Try, /*On fail goto*//*Label 26013*/ GIMT_Encode4(1935429), // Rule ID 24132 //
     /* 1935348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1935359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1935362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1935365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935394 */     // MIs[0] policy
     /* 1935394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935404 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1935407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935428 */     // GIR_Coverage, 24132,
     /* 1935428 */     GIR_EraseRootFromParent_Done,
     /* 1935429 */   // Label 26013: @1935429
     /* 1935429 */   GIM_Try, /*On fail goto*//*Label 26014*/ GIMT_Encode4(1935515), // Rule ID 24133 //
     /* 1935434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1935445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1935448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1935451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935480 */     // MIs[0] policy
     /* 1935480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1935493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935514 */     // GIR_Coverage, 24133,
     /* 1935514 */     GIR_EraseRootFromParent_Done,
     /* 1935515 */   // Label 26014: @1935515
     /* 1935515 */   GIM_Try, /*On fail goto*//*Label 26015*/ GIMT_Encode4(1935601), // Rule ID 24136 //
     /* 1935520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1935531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1935534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1935537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935566 */     // MIs[0] policy
     /* 1935566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935576 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935600 */     // GIR_Coverage, 24136,
     /* 1935600 */     GIR_EraseRootFromParent_Done,
     /* 1935601 */   // Label 26015: @1935601
     /* 1935601 */   GIM_Try, /*On fail goto*//*Label 26016*/ GIMT_Encode4(1935687), // Rule ID 24137 //
     /* 1935606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1935617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1935620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1935623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935652 */     // MIs[0] policy
     /* 1935652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935662 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935686 */     // GIR_Coverage, 24137,
     /* 1935686 */     GIR_EraseRootFromParent_Done,
     /* 1935687 */   // Label 26016: @1935687
     /* 1935687 */   GIM_Try, /*On fail goto*//*Label 26017*/ GIMT_Encode4(1935773), // Rule ID 24140 //
     /* 1935692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1935703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1935706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1935709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935738 */     // MIs[0] policy
     /* 1935738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935748 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1935751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935772 */     // GIR_Coverage, 24140,
     /* 1935772 */     GIR_EraseRootFromParent_Done,
     /* 1935773 */   // Label 26017: @1935773
     /* 1935773 */   GIM_Try, /*On fail goto*//*Label 26018*/ GIMT_Encode4(1935859), // Rule ID 24141 //
     /* 1935778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1935789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1935792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1935795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935824 */     // MIs[0] policy
     /* 1935824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935834 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1935837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935858 */     // GIR_Coverage, 24141,
     /* 1935858 */     GIR_EraseRootFromParent_Done,
     /* 1935859 */   // Label 26018: @1935859
     /* 1935859 */   GIM_Try, /*On fail goto*//*Label 26019*/ GIMT_Encode4(1935945), // Rule ID 24144 //
     /* 1935864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1935875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1935878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1935881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935910 */     // MIs[0] policy
     /* 1935910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935920 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1935923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935944 */     // GIR_Coverage, 24144,
     /* 1935944 */     GIR_EraseRootFromParent_Done,
     /* 1935945 */   // Label 26019: @1935945
     /* 1935945 */   GIM_Try, /*On fail goto*//*Label 26020*/ GIMT_Encode4(1936031), // Rule ID 24145 //
     /* 1935950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1935961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1935964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1935967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935996 */     // MIs[0] policy
     /* 1935996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936006 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1936009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936030 */     // GIR_Coverage, 24145,
     /* 1936030 */     GIR_EraseRootFromParent_Done,
     /* 1936031 */   // Label 26020: @1936031
     /* 1936031 */   GIM_Try, /*On fail goto*//*Label 26021*/ GIMT_Encode4(1936117), // Rule ID 24148 //
     /* 1936036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1936039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1936047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1936050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1936053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1936066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936082 */     // MIs[0] policy
     /* 1936082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936092 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1936095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936116 */     // GIR_Coverage, 24148,
     /* 1936116 */     GIR_EraseRootFromParent_Done,
     /* 1936117 */   // Label 26021: @1936117
     /* 1936117 */   GIM_Try, /*On fail goto*//*Label 26022*/ GIMT_Encode4(1936203), // Rule ID 24149 //
     /* 1936122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1936125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1936133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1936136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1936139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1936152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936168 */     // MIs[0] policy
     /* 1936168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936178 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1936181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936202 */     // GIR_Coverage, 24149,
     /* 1936202 */     GIR_EraseRootFromParent_Done,
     /* 1936203 */   // Label 26022: @1936203
     /* 1936203 */   GIM_Try, /*On fail goto*//*Label 26023*/ GIMT_Encode4(1936289), // Rule ID 24152 //
     /* 1936208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1936219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1936222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1936225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936254 */     // MIs[0] policy
     /* 1936254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936264 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1936267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936288 */     // GIR_Coverage, 24152,
     /* 1936288 */     GIR_EraseRootFromParent_Done,
     /* 1936289 */   // Label 26023: @1936289
     /* 1936289 */   GIM_Try, /*On fail goto*//*Label 26024*/ GIMT_Encode4(1936375), // Rule ID 24153 //
     /* 1936294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1936305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1936308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1936311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936340 */     // MIs[0] policy
     /* 1936340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936350 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1936353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936374 */     // GIR_Coverage, 24153,
     /* 1936374 */     GIR_EraseRootFromParent_Done,
     /* 1936375 */   // Label 26024: @1936375
     /* 1936375 */   GIM_Try, /*On fail goto*//*Label 26025*/ GIMT_Encode4(1936461), // Rule ID 24156 //
     /* 1936380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1936391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1936394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1936397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936426 */     // MIs[0] policy
     /* 1936426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936436 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936460 */     // GIR_Coverage, 24156,
     /* 1936460 */     GIR_EraseRootFromParent_Done,
     /* 1936461 */   // Label 26025: @1936461
     /* 1936461 */   GIM_Try, /*On fail goto*//*Label 26026*/ GIMT_Encode4(1936547), // Rule ID 24157 //
     /* 1936466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1936477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1936480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1936483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936512 */     // MIs[0] policy
     /* 1936512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936522 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936546 */     // GIR_Coverage, 24157,
     /* 1936546 */     GIR_EraseRootFromParent_Done,
     /* 1936547 */   // Label 26026: @1936547
     /* 1936547 */   GIM_Try, /*On fail goto*//*Label 26027*/ GIMT_Encode4(1936633), // Rule ID 24160 //
     /* 1936552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1936563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1936566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1936569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936598 */     // MIs[0] policy
     /* 1936598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936632 */     // GIR_Coverage, 24160,
     /* 1936632 */     GIR_EraseRootFromParent_Done,
     /* 1936633 */   // Label 26027: @1936633
     /* 1936633 */   GIM_Try, /*On fail goto*//*Label 26028*/ GIMT_Encode4(1936719), // Rule ID 24161 //
     /* 1936638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1936649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1936652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1936655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936684 */     // MIs[0] policy
     /* 1936684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936694 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936718 */     // GIR_Coverage, 24161,
     /* 1936718 */     GIR_EraseRootFromParent_Done,
     /* 1936719 */   // Label 26028: @1936719
     /* 1936719 */   GIM_Try, /*On fail goto*//*Label 26029*/ GIMT_Encode4(1936805), // Rule ID 24164 //
     /* 1936724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1936735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1936738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1936741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936770 */     // MIs[0] policy
     /* 1936770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936780 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936804 */     // GIR_Coverage, 24164,
     /* 1936804 */     GIR_EraseRootFromParent_Done,
     /* 1936805 */   // Label 26029: @1936805
     /* 1936805 */   GIM_Try, /*On fail goto*//*Label 26030*/ GIMT_Encode4(1936891), // Rule ID 24165 //
     /* 1936810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1936821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1936824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1936827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936856 */     // MIs[0] policy
     /* 1936856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936866 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936890 */     // GIR_Coverage, 24165,
     /* 1936890 */     GIR_EraseRootFromParent_Done,
     /* 1936891 */   // Label 26030: @1936891
     /* 1936891 */   GIM_Try, /*On fail goto*//*Label 26031*/ GIMT_Encode4(1936977), // Rule ID 24168 //
     /* 1936896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1936907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1936910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1936913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936942 */     // MIs[0] policy
     /* 1936942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936952 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936976 */     // GIR_Coverage, 24168,
     /* 1936976 */     GIR_EraseRootFromParent_Done,
     /* 1936977 */   // Label 26031: @1936977
     /* 1936977 */   GIM_Try, /*On fail goto*//*Label 26032*/ GIMT_Encode4(1937063), // Rule ID 24169 //
     /* 1936982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1936993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1936996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1936999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937028 */     // MIs[0] policy
     /* 1937028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937038 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1937041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937062 */     // GIR_Coverage, 24169,
     /* 1937062 */     GIR_EraseRootFromParent_Done,
     /* 1937063 */   // Label 26032: @1937063
     /* 1937063 */   GIM_Try, /*On fail goto*//*Label 26033*/ GIMT_Encode4(1937149), // Rule ID 24172 //
     /* 1937068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1937071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1937079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1937082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1937085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937114 */     // MIs[0] policy
     /* 1937114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937124 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1937127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937148 */     // GIR_Coverage, 24172,
     /* 1937148 */     GIR_EraseRootFromParent_Done,
     /* 1937149 */   // Label 26033: @1937149
     /* 1937149 */   GIM_Try, /*On fail goto*//*Label 26034*/ GIMT_Encode4(1937235), // Rule ID 24173 //
     /* 1937154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1937157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1937165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1937168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1937171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937200 */     // MIs[0] policy
     /* 1937200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937210 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1937213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937234 */     // GIR_Coverage, 24173,
     /* 1937234 */     GIR_EraseRootFromParent_Done,
     /* 1937235 */   // Label 26034: @1937235
     /* 1937235 */   GIM_Try, /*On fail goto*//*Label 26035*/ GIMT_Encode4(1937321), // Rule ID 24176 //
     /* 1937240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1937251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1937254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1937257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937286 */     // MIs[0] policy
     /* 1937286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937296 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937320 */     // GIR_Coverage, 24176,
     /* 1937320 */     GIR_EraseRootFromParent_Done,
     /* 1937321 */   // Label 26035: @1937321
     /* 1937321 */   GIM_Try, /*On fail goto*//*Label 26036*/ GIMT_Encode4(1937407), // Rule ID 24177 //
     /* 1937326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1937337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1937340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1937343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937372 */     // MIs[0] policy
     /* 1937372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937382 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937406 */     // GIR_Coverage, 24177,
     /* 1937406 */     GIR_EraseRootFromParent_Done,
     /* 1937407 */   // Label 26036: @1937407
     /* 1937407 */   GIM_Try, /*On fail goto*//*Label 26037*/ GIMT_Encode4(1937493), // Rule ID 24180 //
     /* 1937412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1937423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1937426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1937429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937458 */     // MIs[0] policy
     /* 1937458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937468 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937492 */     // GIR_Coverage, 24180,
     /* 1937492 */     GIR_EraseRootFromParent_Done,
     /* 1937493 */   // Label 26037: @1937493
     /* 1937493 */   GIM_Try, /*On fail goto*//*Label 26038*/ GIMT_Encode4(1937579), // Rule ID 24181 //
     /* 1937498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1937509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1937512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1937515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937544 */     // MIs[0] policy
     /* 1937544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937554 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937578 */     // GIR_Coverage, 24181,
     /* 1937578 */     GIR_EraseRootFromParent_Done,
     /* 1937579 */   // Label 26038: @1937579
     /* 1937579 */   GIM_Try, /*On fail goto*//*Label 26039*/ GIMT_Encode4(1937665), // Rule ID 24184 //
     /* 1937584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1937595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1937598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1937601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1937607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937630 */     // MIs[0] policy
     /* 1937630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937640 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1937643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937664 */     // GIR_Coverage, 24184,
     /* 1937664 */     GIR_EraseRootFromParent_Done,
     /* 1937665 */   // Label 26039: @1937665
     /* 1937665 */   GIM_Try, /*On fail goto*//*Label 26040*/ GIMT_Encode4(1937751), // Rule ID 24185 //
     /* 1937670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1937681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1937684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1937687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1937693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937716 */     // MIs[0] policy
     /* 1937716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937726 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1937729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937750 */     // GIR_Coverage, 24185,
     /* 1937750 */     GIR_EraseRootFromParent_Done,
     /* 1937751 */   // Label 26040: @1937751
     /* 1937751 */   GIM_Try, /*On fail goto*//*Label 26041*/ GIMT_Encode4(1937837), // Rule ID 24188 //
     /* 1937756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1937767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1937770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1937773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937802 */     // MIs[0] policy
     /* 1937802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937812 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937836 */     // GIR_Coverage, 24188,
     /* 1937836 */     GIR_EraseRootFromParent_Done,
     /* 1937837 */   // Label 26041: @1937837
     /* 1937837 */   GIM_Try, /*On fail goto*//*Label 26042*/ GIMT_Encode4(1937923), // Rule ID 24189 //
     /* 1937842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1937853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1937856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1937859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937888 */     // MIs[0] policy
     /* 1937888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937898 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937922 */     // GIR_Coverage, 24189,
     /* 1937922 */     GIR_EraseRootFromParent_Done,
     /* 1937923 */   // Label 26042: @1937923
     /* 1937923 */   GIM_Try, /*On fail goto*//*Label 26043*/ GIMT_Encode4(1938009), // Rule ID 24192 //
     /* 1937928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1937939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1937942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1937945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937974 */     // MIs[0] policy
     /* 1937974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937984 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938008 */     // GIR_Coverage, 24192,
     /* 1938008 */     GIR_EraseRootFromParent_Done,
     /* 1938009 */   // Label 26043: @1938009
     /* 1938009 */   GIM_Try, /*On fail goto*//*Label 26044*/ GIMT_Encode4(1938095), // Rule ID 24193 //
     /* 1938014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1938025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1938028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1938031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938060 */     // MIs[0] policy
     /* 1938060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938070 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1938073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938094 */     // GIR_Coverage, 24193,
     /* 1938094 */     GIR_EraseRootFromParent_Done,
     /* 1938095 */   // Label 26044: @1938095
     /* 1938095 */   GIM_Try, /*On fail goto*//*Label 26045*/ GIMT_Encode4(1938181), // Rule ID 24196 //
     /* 1938100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1938111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1938114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1938117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938146 */     // MIs[0] policy
     /* 1938146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938156 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1938159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938180 */     // GIR_Coverage, 24196,
     /* 1938180 */     GIR_EraseRootFromParent_Done,
     /* 1938181 */   // Label 26045: @1938181
     /* 1938181 */   GIM_Try, /*On fail goto*//*Label 26046*/ GIMT_Encode4(1938267), // Rule ID 24197 //
     /* 1938186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1938197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1938200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1938203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938232 */     // MIs[0] policy
     /* 1938232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938242 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1938245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938266 */     // GIR_Coverage, 24197,
     /* 1938266 */     GIR_EraseRootFromParent_Done,
     /* 1938267 */   // Label 26046: @1938267
     /* 1938267 */   GIM_Try, /*On fail goto*//*Label 26047*/ GIMT_Encode4(1938353), // Rule ID 24200 //
     /* 1938272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1938275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1938283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1938286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1938289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938318 */     // MIs[0] policy
     /* 1938318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938328 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1938331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938352 */     // GIR_Coverage, 24200,
     /* 1938352 */     GIR_EraseRootFromParent_Done,
     /* 1938353 */   // Label 26047: @1938353
     /* 1938353 */   GIM_Try, /*On fail goto*//*Label 26048*/ GIMT_Encode4(1938439), // Rule ID 24201 //
     /* 1938358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1938361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1938369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1938372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1938375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938404 */     // MIs[0] policy
     /* 1938404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938414 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1938417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938438 */     // GIR_Coverage, 24201,
     /* 1938438 */     GIR_EraseRootFromParent_Done,
     /* 1938439 */   // Label 26048: @1938439
     /* 1938439 */   GIM_Try, /*On fail goto*//*Label 26049*/ GIMT_Encode4(1938525), // Rule ID 24204 //
     /* 1938444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1938447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1938455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1938458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1938461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938490 */     // MIs[0] policy
     /* 1938490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938500 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1938503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938524 */     // GIR_Coverage, 24204,
     /* 1938524 */     GIR_EraseRootFromParent_Done,
     /* 1938525 */   // Label 26049: @1938525
     /* 1938525 */   GIM_Try, /*On fail goto*//*Label 26050*/ GIMT_Encode4(1938611), // Rule ID 24205 //
     /* 1938530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1938533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1938541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1938544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1938547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938576 */     // MIs[0] policy
     /* 1938576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938586 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1938589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938610 */     // GIR_Coverage, 24205,
     /* 1938610 */     GIR_EraseRootFromParent_Done,
     /* 1938611 */   // Label 26050: @1938611
     /* 1938611 */   GIM_Try, /*On fail goto*//*Label 26051*/ GIMT_Encode4(1938697), // Rule ID 24208 //
     /* 1938616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1938619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1938627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1938630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1938633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938662 */     // MIs[0] policy
     /* 1938662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938672 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1938675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938696 */     // GIR_Coverage, 24208,
     /* 1938696 */     GIR_EraseRootFromParent_Done,
     /* 1938697 */   // Label 26051: @1938697
     /* 1938697 */   GIM_Try, /*On fail goto*//*Label 26052*/ GIMT_Encode4(1938783), // Rule ID 24209 //
     /* 1938702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1938705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1938713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1938716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1938719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938748 */     // MIs[0] policy
     /* 1938748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938758 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1938761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938782 */     // GIR_Coverage, 24209,
     /* 1938782 */     GIR_EraseRootFromParent_Done,
     /* 1938783 */   // Label 26052: @1938783
     /* 1938783 */   GIM_Try, /*On fail goto*//*Label 26053*/ GIMT_Encode4(1938869), // Rule ID 24272 //
     /* 1938788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1938799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1938802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1938805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938834 */     // MIs[0] policy
     /* 1938834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938844 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1938847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938868 */     // GIR_Coverage, 24272,
     /* 1938868 */     GIR_EraseRootFromParent_Done,
     /* 1938869 */   // Label 26053: @1938869
     /* 1938869 */   GIM_Try, /*On fail goto*//*Label 26054*/ GIMT_Encode4(1938955), // Rule ID 24273 //
     /* 1938874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1938885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1938888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1938891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938920 */     // MIs[0] policy
     /* 1938920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938930 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1938933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938954 */     // GIR_Coverage, 24273,
     /* 1938954 */     GIR_EraseRootFromParent_Done,
     /* 1938955 */   // Label 26054: @1938955
     /* 1938955 */   GIM_Try, /*On fail goto*//*Label 26055*/ GIMT_Encode4(1939041), // Rule ID 24276 //
     /* 1938960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1938971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1938974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1938977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939006 */     // MIs[0] policy
     /* 1939006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939016 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1939019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939040 */     // GIR_Coverage, 24276,
     /* 1939040 */     GIR_EraseRootFromParent_Done,
     /* 1939041 */   // Label 26055: @1939041
     /* 1939041 */   GIM_Try, /*On fail goto*//*Label 26056*/ GIMT_Encode4(1939127), // Rule ID 24277 //
     /* 1939046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1939057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1939060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1939063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939092 */     // MIs[0] policy
     /* 1939092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939102 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1939105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939126 */     // GIR_Coverage, 24277,
     /* 1939126 */     GIR_EraseRootFromParent_Done,
     /* 1939127 */   // Label 26056: @1939127
     /* 1939127 */   GIM_Try, /*On fail goto*//*Label 26057*/ GIMT_Encode4(1939213), // Rule ID 24280 //
     /* 1939132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1939143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1939146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1939149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939178 */     // MIs[0] policy
     /* 1939178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939188 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1939191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939212 */     // GIR_Coverage, 24280,
     /* 1939212 */     GIR_EraseRootFromParent_Done,
     /* 1939213 */   // Label 26057: @1939213
     /* 1939213 */   GIM_Try, /*On fail goto*//*Label 26058*/ GIMT_Encode4(1939299), // Rule ID 24281 //
     /* 1939218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1939229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1939232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1939235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939264 */     // MIs[0] policy
     /* 1939264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939274 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1939277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939298 */     // GIR_Coverage, 24281,
     /* 1939298 */     GIR_EraseRootFromParent_Done,
     /* 1939299 */   // Label 26058: @1939299
     /* 1939299 */   GIM_Try, /*On fail goto*//*Label 26059*/ GIMT_Encode4(1939385), // Rule ID 24284 //
     /* 1939304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1939315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1939318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1939321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939350 */     // MIs[0] policy
     /* 1939350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939360 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939384 */     // GIR_Coverage, 24284,
     /* 1939384 */     GIR_EraseRootFromParent_Done,
     /* 1939385 */   // Label 26059: @1939385
     /* 1939385 */   GIM_Try, /*On fail goto*//*Label 26060*/ GIMT_Encode4(1939471), // Rule ID 24285 //
     /* 1939390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1939401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1939404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1939407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939436 */     // MIs[0] policy
     /* 1939436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939446 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939470 */     // GIR_Coverage, 24285,
     /* 1939470 */     GIR_EraseRootFromParent_Done,
     /* 1939471 */   // Label 26060: @1939471
     /* 1939471 */   GIM_Try, /*On fail goto*//*Label 26061*/ GIMT_Encode4(1939557), // Rule ID 24288 //
     /* 1939476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1939487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1939490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1939493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939522 */     // MIs[0] policy
     /* 1939522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939532 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939556 */     // GIR_Coverage, 24288,
     /* 1939556 */     GIR_EraseRootFromParent_Done,
     /* 1939557 */   // Label 26061: @1939557
     /* 1939557 */   GIM_Try, /*On fail goto*//*Label 26062*/ GIMT_Encode4(1939643), // Rule ID 24289 //
     /* 1939562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1939573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1939576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1939579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939608 */     // MIs[0] policy
     /* 1939608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939618 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939642 */     // GIR_Coverage, 24289,
     /* 1939642 */     GIR_EraseRootFromParent_Done,
     /* 1939643 */   // Label 26062: @1939643
     /* 1939643 */   GIM_Try, /*On fail goto*//*Label 26063*/ GIMT_Encode4(1939729), // Rule ID 24292 //
     /* 1939648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1939651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1939659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1939662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1939665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939694 */     // MIs[0] policy
     /* 1939694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939704 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939728 */     // GIR_Coverage, 24292,
     /* 1939728 */     GIR_EraseRootFromParent_Done,
     /* 1939729 */   // Label 26063: @1939729
     /* 1939729 */   GIM_Try, /*On fail goto*//*Label 26064*/ GIMT_Encode4(1939815), // Rule ID 24293 //
     /* 1939734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1939737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1939745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1939748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1939751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939780 */     // MIs[0] policy
     /* 1939780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939790 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939814 */     // GIR_Coverage, 24293,
     /* 1939814 */     GIR_EraseRootFromParent_Done,
     /* 1939815 */   // Label 26064: @1939815
     /* 1939815 */   GIM_Try, /*On fail goto*//*Label 26065*/ GIMT_Encode4(1939901), // Rule ID 24296 //
     /* 1939820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1939831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1939834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1939837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939866 */     // MIs[0] policy
     /* 1939866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939876 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1939879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939900 */     // GIR_Coverage, 24296,
     /* 1939900 */     GIR_EraseRootFromParent_Done,
     /* 1939901 */   // Label 26065: @1939901
     /* 1939901 */   GIM_Try, /*On fail goto*//*Label 26066*/ GIMT_Encode4(1939987), // Rule ID 24297 //
     /* 1939906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1939917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1939920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1939923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939952 */     // MIs[0] policy
     /* 1939952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939962 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1939965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939986 */     // GIR_Coverage, 24297,
     /* 1939986 */     GIR_EraseRootFromParent_Done,
     /* 1939987 */   // Label 26066: @1939987
     /* 1939987 */   GIM_Try, /*On fail goto*//*Label 26067*/ GIMT_Encode4(1940073), // Rule ID 24300 //
     /* 1939992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1940003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1940006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1940009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940038 */     // MIs[0] policy
     /* 1940038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940048 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940072 */     // GIR_Coverage, 24300,
     /* 1940072 */     GIR_EraseRootFromParent_Done,
     /* 1940073 */   // Label 26067: @1940073
     /* 1940073 */   GIM_Try, /*On fail goto*//*Label 26068*/ GIMT_Encode4(1940159), // Rule ID 24301 //
     /* 1940078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1940089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1940092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1940095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940124 */     // MIs[0] policy
     /* 1940124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940134 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940158 */     // GIR_Coverage, 24301,
     /* 1940158 */     GIR_EraseRootFromParent_Done,
     /* 1940159 */   // Label 26068: @1940159
     /* 1940159 */   GIM_Try, /*On fail goto*//*Label 26069*/ GIMT_Encode4(1940245), // Rule ID 24304 //
     /* 1940164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1940175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1940178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1940181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1940187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940210 */     // MIs[0] policy
     /* 1940210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940220 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940244 */     // GIR_Coverage, 24304,
     /* 1940244 */     GIR_EraseRootFromParent_Done,
     /* 1940245 */   // Label 26069: @1940245
     /* 1940245 */   GIM_Try, /*On fail goto*//*Label 26070*/ GIMT_Encode4(1940331), // Rule ID 24305 //
     /* 1940250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1940261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1940264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1940267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1940273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940296 */     // MIs[0] policy
     /* 1940296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940306 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940330 */     // GIR_Coverage, 24305,
     /* 1940330 */     GIR_EraseRootFromParent_Done,
     /* 1940331 */   // Label 26070: @1940331
     /* 1940331 */   GIM_Try, /*On fail goto*//*Label 26071*/ GIMT_Encode4(1940417), // Rule ID 24308 //
     /* 1940336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1940347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1940350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1940353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940382 */     // MIs[0] policy
     /* 1940382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940392 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940416 */     // GIR_Coverage, 24308,
     /* 1940416 */     GIR_EraseRootFromParent_Done,
     /* 1940417 */   // Label 26071: @1940417
     /* 1940417 */   GIM_Try, /*On fail goto*//*Label 26072*/ GIMT_Encode4(1940503), // Rule ID 24309 //
     /* 1940422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1940433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1940436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1940439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940468 */     // MIs[0] policy
     /* 1940468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940478 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940502 */     // GIR_Coverage, 24309,
     /* 1940502 */     GIR_EraseRootFromParent_Done,
     /* 1940503 */   // Label 26072: @1940503
     /* 1940503 */   GIM_Try, /*On fail goto*//*Label 26073*/ GIMT_Encode4(1940589), // Rule ID 24312 //
     /* 1940508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1940519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1940522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1940525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940554 */     // MIs[0] policy
     /* 1940554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940564 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940588 */     // GIR_Coverage, 24312,
     /* 1940588 */     GIR_EraseRootFromParent_Done,
     /* 1940589 */   // Label 26073: @1940589
     /* 1940589 */   GIM_Try, /*On fail goto*//*Label 26074*/ GIMT_Encode4(1940675), // Rule ID 24313 //
     /* 1940594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1940605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1940608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1940611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940640 */     // MIs[0] policy
     /* 1940640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940650 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940674 */     // GIR_Coverage, 24313,
     /* 1940674 */     GIR_EraseRootFromParent_Done,
     /* 1940675 */   // Label 26074: @1940675
     /* 1940675 */   GIM_Try, /*On fail goto*//*Label 26075*/ GIMT_Encode4(1940761), // Rule ID 24316 //
     /* 1940680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1940691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1940694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1940697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940726 */     // MIs[0] policy
     /* 1940726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940736 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940760 */     // GIR_Coverage, 24316,
     /* 1940760 */     GIR_EraseRootFromParent_Done,
     /* 1940761 */   // Label 26075: @1940761
     /* 1940761 */   GIM_Try, /*On fail goto*//*Label 26076*/ GIMT_Encode4(1940847), // Rule ID 24317 //
     /* 1940766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1940777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1940780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1940783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940812 */     // MIs[0] policy
     /* 1940812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940822 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940846 */     // GIR_Coverage, 24317,
     /* 1940846 */     GIR_EraseRootFromParent_Done,
     /* 1940847 */   // Label 26076: @1940847
     /* 1940847 */   GIM_Try, /*On fail goto*//*Label 26077*/ GIMT_Encode4(1940933), // Rule ID 24320 //
     /* 1940852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1940855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1940863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1940866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1940869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940898 */     // MIs[0] policy
     /* 1940898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940908 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940932 */     // GIR_Coverage, 24320,
     /* 1940932 */     GIR_EraseRootFromParent_Done,
     /* 1940933 */   // Label 26077: @1940933
     /* 1940933 */   GIM_Try, /*On fail goto*//*Label 26078*/ GIMT_Encode4(1941019), // Rule ID 24321 //
     /* 1940938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1940941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1940949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1940952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1940955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940984 */     // MIs[0] policy
     /* 1940984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940994 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941018 */     // GIR_Coverage, 24321,
     /* 1941018 */     GIR_EraseRootFromParent_Done,
     /* 1941019 */   // Label 26078: @1941019
     /* 1941019 */   GIM_Try, /*On fail goto*//*Label 26079*/ GIMT_Encode4(1941105), // Rule ID 24324 //
     /* 1941024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1941027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1941032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1941035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1941038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1941041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941070 */     // MIs[0] policy
     /* 1941070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941080 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1941083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941104 */     // GIR_Coverage, 24324,
     /* 1941104 */     GIR_EraseRootFromParent_Done,
     /* 1941105 */   // Label 26079: @1941105
     /* 1941105 */   GIM_Try, /*On fail goto*//*Label 26080*/ GIMT_Encode4(1941191), // Rule ID 24325 //
     /* 1941110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1941113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1941118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1941121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1941124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1941127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941156 */     // MIs[0] policy
     /* 1941156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941166 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1941169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941190 */     // GIR_Coverage, 24325,
     /* 1941190 */     GIR_EraseRootFromParent_Done,
     /* 1941191 */   // Label 26080: @1941191
     /* 1941191 */   GIM_Try, /*On fail goto*//*Label 26081*/ GIMT_Encode4(1941277), // Rule ID 24328 //
     /* 1941196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1941199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1941204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1941207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1941210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1941213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941242 */     // MIs[0] policy
     /* 1941242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941252 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1941255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941276 */     // GIR_Coverage, 24328,
     /* 1941276 */     GIR_EraseRootFromParent_Done,
     /* 1941277 */   // Label 26081: @1941277
     /* 1941277 */   GIM_Try, /*On fail goto*//*Label 26082*/ GIMT_Encode4(1941363), // Rule ID 24329 //
     /* 1941282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1941285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1941290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1941293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1941296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1941299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941328 */     // MIs[0] policy
     /* 1941328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941338 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1941341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941362 */     // GIR_Coverage, 24329,
     /* 1941362 */     GIR_EraseRootFromParent_Done,
     /* 1941363 */   // Label 26082: @1941363
     /* 1941363 */   GIM_Try, /*On fail goto*//*Label 26083*/ GIMT_Encode4(1941449), // Rule ID 24392 //
     /* 1941368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1941379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1941382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1941385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941414 */     // MIs[0] policy
     /* 1941414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941424 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1941427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941448 */     // GIR_Coverage, 24392,
     /* 1941448 */     GIR_EraseRootFromParent_Done,
     /* 1941449 */   // Label 26083: @1941449
     /* 1941449 */   GIM_Try, /*On fail goto*//*Label 26084*/ GIMT_Encode4(1941535), // Rule ID 24393 //
     /* 1941454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1941465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1941468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1941471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941500 */     // MIs[0] policy
     /* 1941500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941510 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1941513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941534 */     // GIR_Coverage, 24393,
     /* 1941534 */     GIR_EraseRootFromParent_Done,
     /* 1941535 */   // Label 26084: @1941535
     /* 1941535 */   GIM_Try, /*On fail goto*//*Label 26085*/ GIMT_Encode4(1941621), // Rule ID 24396 //
     /* 1941540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1941551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1941554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1941557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941586 */     // MIs[0] policy
     /* 1941586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941596 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11329:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1941599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941620 */     // GIR_Coverage, 24396,
     /* 1941620 */     GIR_EraseRootFromParent_Done,
     /* 1941621 */   // Label 26085: @1941621
     /* 1941621 */   GIM_Try, /*On fail goto*//*Label 26086*/ GIMT_Encode4(1941707), // Rule ID 24397 //
     /* 1941626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1941637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1941640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1941643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941672 */     // MIs[0] policy
     /* 1941672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941682 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11329:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1941685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941706 */     // GIR_Coverage, 24397,
     /* 1941706 */     GIR_EraseRootFromParent_Done,
     /* 1941707 */   // Label 26086: @1941707
     /* 1941707 */   GIM_Try, /*On fail goto*//*Label 26087*/ GIMT_Encode4(1941793), // Rule ID 24400 //
     /* 1941712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1941715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1941723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1941726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1941729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941758 */     // MIs[0] policy
     /* 1941758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941768 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1941771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941792 */     // GIR_Coverage, 24400,
     /* 1941792 */     GIR_EraseRootFromParent_Done,
     /* 1941793 */   // Label 26087: @1941793
     /* 1941793 */   GIM_Try, /*On fail goto*//*Label 26088*/ GIMT_Encode4(1941879), // Rule ID 24401 //
     /* 1941798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1941801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1941809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1941812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1941815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941844 */     // MIs[0] policy
     /* 1941844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941854 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1941857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941878 */     // GIR_Coverage, 24401,
     /* 1941878 */     GIR_EraseRootFromParent_Done,
     /* 1941879 */   // Label 26088: @1941879
     /* 1941879 */   GIM_Try, /*On fail goto*//*Label 26089*/ GIMT_Encode4(1941965), // Rule ID 24404 //
     /* 1941884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1941895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1941898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1941901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941930 */     // MIs[0] policy
     /* 1941930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941940 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11329:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1941943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941964 */     // GIR_Coverage, 24404,
     /* 1941964 */     GIR_EraseRootFromParent_Done,
     /* 1941965 */   // Label 26089: @1941965
     /* 1941965 */   GIM_Try, /*On fail goto*//*Label 26090*/ GIMT_Encode4(1942051), // Rule ID 24405 //
     /* 1941970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1941981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1941984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1941987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942016 */     // MIs[0] policy
     /* 1942016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942026 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11329:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1942029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942050 */     // GIR_Coverage, 24405,
     /* 1942050 */     GIR_EraseRootFromParent_Done,
     /* 1942051 */   // Label 26090: @1942051
     /* 1942051 */   GIM_Try, /*On fail goto*//*Label 26091*/ GIMT_Encode4(1942137), // Rule ID 24408 //
     /* 1942056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1942067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1942070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1942073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942102 */     // MIs[0] policy
     /* 1942102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942112 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1942115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942136 */     // GIR_Coverage, 24408,
     /* 1942136 */     GIR_EraseRootFromParent_Done,
     /* 1942137 */   // Label 26091: @1942137
     /* 1942137 */   GIM_Try, /*On fail goto*//*Label 26092*/ GIMT_Encode4(1942223), // Rule ID 24409 //
     /* 1942142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1942153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1942156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1942159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942188 */     // MIs[0] policy
     /* 1942188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942198 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1942201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942222 */     // GIR_Coverage, 24409,
     /* 1942222 */     GIR_EraseRootFromParent_Done,
     /* 1942223 */   // Label 26092: @1942223
     /* 1942223 */   GIM_Try, /*On fail goto*//*Label 26093*/ GIMT_Encode4(1942309), // Rule ID 24412 //
     /* 1942228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1942231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1942239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1942242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1942245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1942270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942274 */     // MIs[0] policy
     /* 1942274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942284 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1942287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942308 */     // GIR_Coverage, 24412,
     /* 1942308 */     GIR_EraseRootFromParent_Done,
     /* 1942309 */   // Label 26093: @1942309
     /* 1942309 */   GIM_Try, /*On fail goto*//*Label 26094*/ GIMT_Encode4(1942395), // Rule ID 24413 //
     /* 1942314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1942317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1942325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1942328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1942331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1942356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942360 */     // MIs[0] policy
     /* 1942360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942370 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1942373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942394 */     // GIR_Coverage, 24413,
     /* 1942394 */     GIR_EraseRootFromParent_Done,
     /* 1942395 */   // Label 26094: @1942395
     /* 1942395 */   GIM_Try, /*On fail goto*//*Label 26095*/ GIMT_Encode4(1942481), // Rule ID 24416 //
     /* 1942400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1942411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1942414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1942417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942446 */     // MIs[0] policy
     /* 1942446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942456 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1942459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942480 */     // GIR_Coverage, 24416,
     /* 1942480 */     GIR_EraseRootFromParent_Done,
     /* 1942481 */   // Label 26095: @1942481
     /* 1942481 */   GIM_Try, /*On fail goto*//*Label 26096*/ GIMT_Encode4(1942567), // Rule ID 24417 //
     /* 1942486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1942497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1942500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1942503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942532 */     // MIs[0] policy
     /* 1942532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942542 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1942545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942566 */     // GIR_Coverage, 24417,
     /* 1942566 */     GIR_EraseRootFromParent_Done,
     /* 1942567 */   // Label 26096: @1942567
     /* 1942567 */   GIM_Try, /*On fail goto*//*Label 26097*/ GIMT_Encode4(1942653), // Rule ID 24420 //
     /* 1942572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1942583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1942586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1942589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942618 */     // MIs[0] policy
     /* 1942618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942628 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1942631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942652 */     // GIR_Coverage, 24420,
     /* 1942652 */     GIR_EraseRootFromParent_Done,
     /* 1942653 */   // Label 26097: @1942653
     /* 1942653 */   GIM_Try, /*On fail goto*//*Label 26098*/ GIMT_Encode4(1942739), // Rule ID 24421 //
     /* 1942658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1942669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1942672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1942675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942704 */     // MIs[0] policy
     /* 1942704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942714 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1942717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942738 */     // GIR_Coverage, 24421,
     /* 1942738 */     GIR_EraseRootFromParent_Done,
     /* 1942739 */   // Label 26098: @1942739
     /* 1942739 */   GIM_Try, /*On fail goto*//*Label 26099*/ GIMT_Encode4(1942825), // Rule ID 24424 //
     /* 1942744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1942755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1942758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1942761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1942767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942790 */     // MIs[0] policy
     /* 1942790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942800 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1942803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942824 */     // GIR_Coverage, 24424,
     /* 1942824 */     GIR_EraseRootFromParent_Done,
     /* 1942825 */   // Label 26099: @1942825
     /* 1942825 */   GIM_Try, /*On fail goto*//*Label 26100*/ GIMT_Encode4(1942911), // Rule ID 24425 //
     /* 1942830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1942841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1942844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1942847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1942853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942876 */     // MIs[0] policy
     /* 1942876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942886 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1942889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942910 */     // GIR_Coverage, 24425,
     /* 1942910 */     GIR_EraseRootFromParent_Done,
     /* 1942911 */   // Label 26100: @1942911
     /* 1942911 */   GIM_Try, /*On fail goto*//*Label 26101*/ GIMT_Encode4(1942997), // Rule ID 24428 //
     /* 1942916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1942927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1942930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1942933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942962 */     // MIs[0] policy
     /* 1942962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942972 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1942975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942996 */     // GIR_Coverage, 24428,
     /* 1942996 */     GIR_EraseRootFromParent_Done,
     /* 1942997 */   // Label 26101: @1942997
     /* 1942997 */   GIM_Try, /*On fail goto*//*Label 26102*/ GIMT_Encode4(1943083), // Rule ID 24429 //
     /* 1943002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1943005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1943013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1943016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1943019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943048 */     // MIs[0] policy
     /* 1943048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943058 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1943061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943082 */     // GIR_Coverage, 24429,
     /* 1943082 */     GIR_EraseRootFromParent_Done,
     /* 1943083 */   // Label 26102: @1943083
     /* 1943083 */   GIM_Try, /*On fail goto*//*Label 26103*/ GIMT_Encode4(1943169), // Rule ID 24432 //
     /* 1943088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1943091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1943099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1943102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1943105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943134 */     // MIs[0] policy
     /* 1943134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943144 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1943147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943168 */     // GIR_Coverage, 24432,
     /* 1943168 */     GIR_EraseRootFromParent_Done,
     /* 1943169 */   // Label 26103: @1943169
     /* 1943169 */   GIM_Try, /*On fail goto*//*Label 26104*/ GIMT_Encode4(1943255), // Rule ID 24433 //
     /* 1943174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1943177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1943185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1943188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1943191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943220 */     // MIs[0] policy
     /* 1943220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943230 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1943233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943254 */     // GIR_Coverage, 24433,
     /* 1943254 */     GIR_EraseRootFromParent_Done,
     /* 1943255 */   // Label 26104: @1943255
     /* 1943255 */   GIM_Try, /*On fail goto*//*Label 26105*/ GIMT_Encode4(1943341), // Rule ID 24436 //
     /* 1943260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1943263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1943271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1943274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1943277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1943283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943306 */     // MIs[0] policy
     /* 1943306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943316 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1943319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943340 */     // GIR_Coverage, 24436,
     /* 1943340 */     GIR_EraseRootFromParent_Done,
     /* 1943341 */   // Label 26105: @1943341
     /* 1943341 */   GIM_Try, /*On fail goto*//*Label 26106*/ GIMT_Encode4(1943427), // Rule ID 24437 //
     /* 1943346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1943349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1943357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1943360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1943363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1943369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943392 */     // MIs[0] policy
     /* 1943392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943402 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1943405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943426 */     // GIR_Coverage, 24437,
     /* 1943426 */     GIR_EraseRootFromParent_Done,
     /* 1943427 */   // Label 26106: @1943427
     /* 1943427 */   GIM_Try, /*On fail goto*//*Label 26107*/ GIMT_Encode4(1943513), // Rule ID 24440 //
     /* 1943432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1943443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1943446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1943449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943478 */     // MIs[0] policy
     /* 1943478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943488 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1943491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943512 */     // GIR_Coverage, 24440,
     /* 1943512 */     GIR_EraseRootFromParent_Done,
     /* 1943513 */   // Label 26107: @1943513
     /* 1943513 */   GIM_Try, /*On fail goto*//*Label 26108*/ GIMT_Encode4(1943599), // Rule ID 24441 //
     /* 1943518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1943529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1943532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1943535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943564 */     // MIs[0] policy
     /* 1943564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943574 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1943577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943598 */     // GIR_Coverage, 24441,
     /* 1943598 */     GIR_EraseRootFromParent_Done,
     /* 1943599 */   // Label 26108: @1943599
     /* 1943599 */   GIM_Try, /*On fail goto*//*Label 26109*/ GIMT_Encode4(1943685), // Rule ID 24444 //
     /* 1943604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1943615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1943618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1943621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943650 */     // MIs[0] policy
     /* 1943650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943660 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1943663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943684 */     // GIR_Coverage, 24444,
     /* 1943684 */     GIR_EraseRootFromParent_Done,
     /* 1943685 */   // Label 26109: @1943685
     /* 1943685 */   GIM_Try, /*On fail goto*//*Label 26110*/ GIMT_Encode4(1943771), // Rule ID 24445 //
     /* 1943690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1943701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1943704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1943707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943736 */     // MIs[0] policy
     /* 1943736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943746 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1943749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943770 */     // GIR_Coverage, 24445,
     /* 1943770 */     GIR_EraseRootFromParent_Done,
     /* 1943771 */   // Label 26110: @1943771
     /* 1943771 */   GIM_Try, /*On fail goto*//*Label 26111*/ GIMT_Encode4(1943857), // Rule ID 24448 //
     /* 1943776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1943787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1943790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1943793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943822 */     // MIs[0] policy
     /* 1943822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943832 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1943835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943856 */     // GIR_Coverage, 24448,
     /* 1943856 */     GIR_EraseRootFromParent_Done,
     /* 1943857 */   // Label 26111: @1943857
     /* 1943857 */   GIM_Try, /*On fail goto*//*Label 26112*/ GIMT_Encode4(1943943), // Rule ID 24449 //
     /* 1943862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1943873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1943876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1943879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943908 */     // MIs[0] policy
     /* 1943908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943918 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1943921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943942 */     // GIR_Coverage, 24449,
     /* 1943942 */     GIR_EraseRootFromParent_Done,
     /* 1943943 */   // Label 26112: @1943943
     /* 1943943 */   GIM_Try, /*On fail goto*//*Label 26113*/ GIMT_Encode4(1944029), // Rule ID 24452 //
     /* 1943948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1943951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1943959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1943962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1943965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1943968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1943990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943994 */     // MIs[0] policy
     /* 1943994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944004 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1944007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944028 */     // GIR_Coverage, 24452,
     /* 1944028 */     GIR_EraseRootFromParent_Done,
     /* 1944029 */   // Label 26113: @1944029
     /* 1944029 */   GIM_Try, /*On fail goto*//*Label 26114*/ GIMT_Encode4(1944115), // Rule ID 24453 //
     /* 1944034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1944045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1944048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1944051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944080 */     // MIs[0] policy
     /* 1944080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944090 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1944093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944114 */     // GIR_Coverage, 24453,
     /* 1944114 */     GIR_EraseRootFromParent_Done,
     /* 1944115 */   // Label 26114: @1944115
     /* 1944115 */   GIM_Try, /*On fail goto*//*Label 26115*/ GIMT_Encode4(1944201), // Rule ID 24456 //
     /* 1944120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1944131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1944134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1944137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944166 */     // MIs[0] policy
     /* 1944166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944176 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1944179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944200 */     // GIR_Coverage, 24456,
     /* 1944200 */     GIR_EraseRootFromParent_Done,
     /* 1944201 */   // Label 26115: @1944201
     /* 1944201 */   GIM_Try, /*On fail goto*//*Label 26116*/ GIMT_Encode4(1944287), // Rule ID 24457 //
     /* 1944206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1944217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1944220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1944223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944252 */     // MIs[0] policy
     /* 1944252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944262 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1944265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944286 */     // GIR_Coverage, 24457,
     /* 1944286 */     GIR_EraseRootFromParent_Done,
     /* 1944287 */   // Label 26116: @1944287
     /* 1944287 */   GIM_Try, /*On fail goto*//*Label 26117*/ GIMT_Encode4(1944373), // Rule ID 24460 //
     /* 1944292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1944295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1944303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1944306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1944309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1944334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944338 */     // MIs[0] policy
     /* 1944338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944348 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1944351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944372 */     // GIR_Coverage, 24460,
     /* 1944372 */     GIR_EraseRootFromParent_Done,
     /* 1944373 */   // Label 26117: @1944373
     /* 1944373 */   GIM_Try, /*On fail goto*//*Label 26118*/ GIMT_Encode4(1944459), // Rule ID 24461 //
     /* 1944378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1944381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1944389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1944392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1944395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1944420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944424 */     // MIs[0] policy
     /* 1944424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944434 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1944437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944458 */     // GIR_Coverage, 24461,
     /* 1944458 */     GIR_EraseRootFromParent_Done,
     /* 1944459 */   // Label 26118: @1944459
     /* 1944459 */   GIM_Try, /*On fail goto*//*Label 26119*/ GIMT_Encode4(1944545), // Rule ID 24464 //
     /* 1944464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1944475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1944478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1944481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944510 */     // MIs[0] policy
     /* 1944510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944520 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11327:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1944523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944544 */     // GIR_Coverage, 24464,
     /* 1944544 */     GIR_EraseRootFromParent_Done,
     /* 1944545 */   // Label 26119: @1944545
     /* 1944545 */   GIM_Try, /*On fail goto*//*Label 26120*/ GIMT_Encode4(1944631), // Rule ID 24465 //
     /* 1944550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1944561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1944564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1944567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944596 */     // MIs[0] policy
     /* 1944596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944606 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11327:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1944609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944630 */     // GIR_Coverage, 24465,
     /* 1944630 */     GIR_EraseRootFromParent_Done,
     /* 1944631 */   // Label 26120: @1944631
     /* 1944631 */   GIM_Try, /*On fail goto*//*Label 26121*/ GIMT_Encode4(1944717), // Rule ID 24468 //
     /* 1944636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1944639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1944647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1944650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1944653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1944678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944682 */     // MIs[0] policy
     /* 1944682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944692 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1944695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944716 */     // GIR_Coverage, 24468,
     /* 1944716 */     GIR_EraseRootFromParent_Done,
     /* 1944717 */   // Label 26121: @1944717
     /* 1944717 */   GIM_Try, /*On fail goto*//*Label 26122*/ GIMT_Encode4(1944803), // Rule ID 24469 //
     /* 1944722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1944725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1944733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1944736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1944739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1944764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944768 */     // MIs[0] policy
     /* 1944768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944778 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1944781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944802 */     // GIR_Coverage, 24469,
     /* 1944802 */     GIR_EraseRootFromParent_Done,
     /* 1944803 */   // Label 26122: @1944803
     /* 1944803 */   GIM_Try, /*On fail goto*//*Label 26123*/ GIMT_Encode4(1944889), // Rule ID 24472 //
     /* 1944808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1944811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1944819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1944822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1944825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1944850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944854 */     // MIs[0] policy
     /* 1944854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944864 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1944867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944888 */     // GIR_Coverage, 24472,
     /* 1944888 */     GIR_EraseRootFromParent_Done,
     /* 1944889 */   // Label 26123: @1944889
     /* 1944889 */   GIM_Try, /*On fail goto*//*Label 26124*/ GIMT_Encode4(1944975), // Rule ID 24473 //
     /* 1944894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1944897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1944905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1944908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1944911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1944936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944940 */     // MIs[0] policy
     /* 1944940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944950 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1944953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944974 */     // GIR_Coverage, 24473,
     /* 1944974 */     GIR_EraseRootFromParent_Done,
     /* 1944975 */   // Label 26124: @1944975
     /* 1944975 */   GIM_Try, /*On fail goto*//*Label 26125*/ GIMT_Encode4(1945061), // Rule ID 24476 //
     /* 1944980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1944991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1944994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1944997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945026 */     // MIs[0] policy
     /* 1945026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945036 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11327:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1945039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945060 */     // GIR_Coverage, 24476,
     /* 1945060 */     GIR_EraseRootFromParent_Done,
     /* 1945061 */   // Label 26125: @1945061
     /* 1945061 */   GIM_Try, /*On fail goto*//*Label 26126*/ GIMT_Encode4(1945147), // Rule ID 24477 //
     /* 1945066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1945069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1945077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1945080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1945083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945112 */     // MIs[0] policy
     /* 1945112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945122 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11327:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1945125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945146 */     // GIR_Coverage, 24477,
     /* 1945146 */     GIR_EraseRootFromParent_Done,
     /* 1945147 */   // Label 26126: @1945147
     /* 1945147 */   GIM_Try, /*On fail goto*//*Label 26127*/ GIMT_Encode4(1945233), // Rule ID 24480 //
     /* 1945152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1945155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1945163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1945166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1945169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945198 */     // MIs[0] policy
     /* 1945198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945208 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11327:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1945211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945232 */     // GIR_Coverage, 24480,
     /* 1945232 */     GIR_EraseRootFromParent_Done,
     /* 1945233 */   // Label 26127: @1945233
     /* 1945233 */   GIM_Try, /*On fail goto*//*Label 26128*/ GIMT_Encode4(1945319), // Rule ID 24481 //
     /* 1945238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1945241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1945249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1945252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1945255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945284 */     // MIs[0] policy
     /* 1945284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945294 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11327:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1945297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945318 */     // GIR_Coverage, 24481,
     /* 1945318 */     GIR_EraseRootFromParent_Done,
     /* 1945319 */   // Label 26128: @1945319
     /* 1945319 */   GIM_Try, /*On fail goto*//*Label 26129*/ GIMT_Encode4(1945405), // Rule ID 24484 //
     /* 1945324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1945327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1945335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1945338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1945341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1945347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945370 */     // MIs[0] policy
     /* 1945370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945380 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11327:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1945383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945404 */     // GIR_Coverage, 24484,
     /* 1945404 */     GIR_EraseRootFromParent_Done,
     /* 1945405 */   // Label 26129: @1945405
     /* 1945405 */   GIM_Try, /*On fail goto*//*Label 26130*/ GIMT_Encode4(1945491), // Rule ID 24485 //
     /* 1945410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1945413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1945421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1945424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1945427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1945433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945456 */     // MIs[0] policy
     /* 1945456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945466 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11327:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1945469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945490 */     // GIR_Coverage, 24485,
     /* 1945490 */     GIR_EraseRootFromParent_Done,
     /* 1945491 */   // Label 26130: @1945491
     /* 1945491 */   GIM_Try, /*On fail goto*//*Label 26131*/ GIMT_Encode4(1945577), // Rule ID 24488 //
     /* 1945496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1945507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1945510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1945513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945542 */     // MIs[0] policy
     /* 1945542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945552 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11327:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1945555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945576 */     // GIR_Coverage, 24488,
     /* 1945576 */     GIR_EraseRootFromParent_Done,
     /* 1945577 */   // Label 26131: @1945577
     /* 1945577 */   GIM_Try, /*On fail goto*//*Label 26132*/ GIMT_Encode4(1945663), // Rule ID 24489 //
     /* 1945582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1945593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1945596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1945599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945628 */     // MIs[0] policy
     /* 1945628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945638 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11327:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1945641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945662 */     // GIR_Coverage, 24489,
     /* 1945662 */     GIR_EraseRootFromParent_Done,
     /* 1945663 */   // Label 26132: @1945663
     /* 1945663 */   GIM_Try, /*On fail goto*//*Label 26133*/ GIMT_Encode4(1945749), // Rule ID 24492 //
     /* 1945668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1945679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1945682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1945685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945714 */     // MIs[0] policy
     /* 1945714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945724 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11327:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1945727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945748 */     // GIR_Coverage, 24492,
     /* 1945748 */     GIR_EraseRootFromParent_Done,
     /* 1945749 */   // Label 26133: @1945749
     /* 1945749 */   GIM_Try, /*On fail goto*//*Label 26134*/ GIMT_Encode4(1945835), // Rule ID 24493 //
     /* 1945754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1945765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1945768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1945771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945800 */     // MIs[0] policy
     /* 1945800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945810 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11327:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1945813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945834 */     // GIR_Coverage, 24493,
     /* 1945834 */     GIR_EraseRootFromParent_Done,
     /* 1945835 */   // Label 26134: @1945835
     /* 1945835 */   GIM_Try, /*On fail goto*//*Label 26135*/ GIMT_Encode4(1945921), // Rule ID 24496 //
     /* 1945840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1945851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1945854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1945857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945886 */     // MIs[0] policy
     /* 1945886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945896 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11327:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1945899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945920 */     // GIR_Coverage, 24496,
     /* 1945920 */     GIR_EraseRootFromParent_Done,
     /* 1945921 */   // Label 26135: @1945921
     /* 1945921 */   GIM_Try, /*On fail goto*//*Label 26136*/ GIMT_Encode4(1946007), // Rule ID 24497 //
     /* 1945926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1945937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1945940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1945943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945972 */     // MIs[0] policy
     /* 1945972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945982 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11327:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1945985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946006 */     // GIR_Coverage, 24497,
     /* 1946006 */     GIR_EraseRootFromParent_Done,
     /* 1946007 */   // Label 26136: @1946007
     /* 1946007 */   GIM_Try, /*On fail goto*//*Label 26137*/ GIMT_Encode4(1946093), // Rule ID 24500 //
     /* 1946012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1946015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1946020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1946023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1946026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1946029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946058 */     // MIs[0] policy
     /* 1946058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946068 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11327:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1946071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946092 */     // GIR_Coverage, 24500,
     /* 1946092 */     GIR_EraseRootFromParent_Done,
     /* 1946093 */   // Label 26137: @1946093
     /* 1946093 */   GIM_Try, /*On fail goto*//*Label 26138*/ GIMT_Encode4(1946179), // Rule ID 24501 //
     /* 1946098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1946101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1946106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1946109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1946112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1946115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946144 */     // MIs[0] policy
     /* 1946144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946154 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11327:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1946157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946178 */     // GIR_Coverage, 24501,
     /* 1946178 */     GIR_EraseRootFromParent_Done,
     /* 1946179 */   // Label 26138: @1946179
     /* 1946179 */   GIM_Try, /*On fail goto*//*Label 26139*/ GIMT_Encode4(1946265), // Rule ID 24504 //
     /* 1946184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1946187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1946192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1946195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1946198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1946201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946230 */     // MIs[0] policy
     /* 1946230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946240 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11327:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1946243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946264 */     // GIR_Coverage, 24504,
     /* 1946264 */     GIR_EraseRootFromParent_Done,
     /* 1946265 */   // Label 26139: @1946265
     /* 1946265 */   GIM_Try, /*On fail goto*//*Label 26140*/ GIMT_Encode4(1946351), // Rule ID 24505 //
     /* 1946270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1946273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1946278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1946281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1946284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1946287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946316 */     // MIs[0] policy
     /* 1946316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946326 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11327:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1946329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946350 */     // GIR_Coverage, 24505,
     /* 1946350 */     GIR_EraseRootFromParent_Done,
     /* 1946351 */   // Label 26140: @1946351
     /* 1946351 */   GIM_Try, /*On fail goto*//*Label 26141*/ GIMT_Encode4(1946437), // Rule ID 24508 //
     /* 1946356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1946359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1946364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1946367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1946370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1946373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946402 */     // MIs[0] policy
     /* 1946402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946412 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11327:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1946415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946436 */     // GIR_Coverage, 24508,
     /* 1946436 */     GIR_EraseRootFromParent_Done,
     /* 1946437 */   // Label 26141: @1946437
     /* 1946437 */   GIM_Try, /*On fail goto*//*Label 26142*/ GIMT_Encode4(1946523), // Rule ID 24509 //
     /* 1946442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1946445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1946450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1946453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1946456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1946459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946488 */     // MIs[0] policy
     /* 1946488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946498 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11327:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1946501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946522 */     // GIR_Coverage, 24509,
     /* 1946522 */     GIR_EraseRootFromParent_Done,
     /* 1946523 */   // Label 26142: @1946523
     /* 1946523 */   GIM_Try, /*On fail goto*//*Label 26143*/ GIMT_Encode4(1946609), // Rule ID 24512 //
     /* 1946528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1946539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1946542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1946545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1946548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946574 */     // MIs[0] policy
     /* 1946574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946584 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1946587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946608 */     // GIR_Coverage, 24512,
     /* 1946608 */     GIR_EraseRootFromParent_Done,
     /* 1946609 */   // Label 26143: @1946609
     /* 1946609 */   GIM_Try, /*On fail goto*//*Label 26144*/ GIMT_Encode4(1946695), // Rule ID 24513 //
     /* 1946614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1946625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1946628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1946631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1946634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946660 */     // MIs[0] policy
     /* 1946660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946670 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1946673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946694 */     // GIR_Coverage, 24513,
     /* 1946694 */     GIR_EraseRootFromParent_Done,
     /* 1946695 */   // Label 26144: @1946695
     /* 1946695 */   GIM_Try, /*On fail goto*//*Label 26145*/ GIMT_Encode4(1946781), // Rule ID 24516 //
     /* 1946700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1946711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1946714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1946717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1946720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946746 */     // MIs[0] policy
     /* 1946746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946756 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1946759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946780 */     // GIR_Coverage, 24516,
     /* 1946780 */     GIR_EraseRootFromParent_Done,
     /* 1946781 */   // Label 26145: @1946781
     /* 1946781 */   GIM_Try, /*On fail goto*//*Label 26146*/ GIMT_Encode4(1946867), // Rule ID 24517 //
     /* 1946786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1946797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1946800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1946803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1946806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946832 */     // MIs[0] policy
     /* 1946832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946842 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1946845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946866 */     // GIR_Coverage, 24517,
     /* 1946866 */     GIR_EraseRootFromParent_Done,
     /* 1946867 */   // Label 26146: @1946867
     /* 1946867 */   GIM_Try, /*On fail goto*//*Label 26147*/ GIMT_Encode4(1946953), // Rule ID 24520 //
     /* 1946872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1946883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1946886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1946889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1946892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946918 */     // MIs[0] policy
     /* 1946918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946928 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1946931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946952 */     // GIR_Coverage, 24520,
     /* 1946952 */     GIR_EraseRootFromParent_Done,
     /* 1946953 */   // Label 26147: @1946953
     /* 1946953 */   GIM_Try, /*On fail goto*//*Label 26148*/ GIMT_Encode4(1947039), // Rule ID 24521 //
     /* 1946958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1946969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1946972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1946975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1946978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947004 */     // MIs[0] policy
     /* 1947004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947014 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1947017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947038 */     // GIR_Coverage, 24521,
     /* 1947038 */     GIR_EraseRootFromParent_Done,
     /* 1947039 */   // Label 26148: @1947039
     /* 1947039 */   GIM_Try, /*On fail goto*//*Label 26149*/ GIMT_Encode4(1947125), // Rule ID 24524 //
     /* 1947044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1947055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1947058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1947061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1947064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947090 */     // MIs[0] policy
     /* 1947090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947100 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1947103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947124 */     // GIR_Coverage, 24524,
     /* 1947124 */     GIR_EraseRootFromParent_Done,
     /* 1947125 */   // Label 26149: @1947125
     /* 1947125 */   GIM_Try, /*On fail goto*//*Label 26150*/ GIMT_Encode4(1947211), // Rule ID 24525 //
     /* 1947130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1947141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1947144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1947147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1947150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947176 */     // MIs[0] policy
     /* 1947176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947186 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1947189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947210 */     // GIR_Coverage, 24525,
     /* 1947210 */     GIR_EraseRootFromParent_Done,
     /* 1947211 */   // Label 26150: @1947211
     /* 1947211 */   GIM_Try, /*On fail goto*//*Label 26151*/ GIMT_Encode4(1947297), // Rule ID 24528 //
     /* 1947216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1947227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1947230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1947233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1947236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947262 */     // MIs[0] policy
     /* 1947262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947272 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1947275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947296 */     // GIR_Coverage, 24528,
     /* 1947296 */     GIR_EraseRootFromParent_Done,
     /* 1947297 */   // Label 26151: @1947297
     /* 1947297 */   GIM_Try, /*On fail goto*//*Label 26152*/ GIMT_Encode4(1947383), // Rule ID 24529 //
     /* 1947302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1947313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1947316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1947319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1947322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947348 */     // MIs[0] policy
     /* 1947348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947358 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1947361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947382 */     // GIR_Coverage, 24529,
     /* 1947382 */     GIR_EraseRootFromParent_Done,
     /* 1947383 */   // Label 26152: @1947383
     /* 1947383 */   GIM_Try, /*On fail goto*//*Label 26153*/ GIMT_Encode4(1947469), // Rule ID 24532 //
     /* 1947388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1947399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1947402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1947405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1947408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947434 */     // MIs[0] policy
     /* 1947434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947444 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1947447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947468 */     // GIR_Coverage, 24532,
     /* 1947468 */     GIR_EraseRootFromParent_Done,
     /* 1947469 */   // Label 26153: @1947469
     /* 1947469 */   GIM_Try, /*On fail goto*//*Label 26154*/ GIMT_Encode4(1947555), // Rule ID 24533 //
     /* 1947474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1947485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1947488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1947491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1947494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947520 */     // MIs[0] policy
     /* 1947520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947530 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1947533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947554 */     // GIR_Coverage, 24533,
     /* 1947554 */     GIR_EraseRootFromParent_Done,
     /* 1947555 */   // Label 26154: @1947555
     /* 1947555 */   GIM_Try, /*On fail goto*//*Label 26155*/ GIMT_Encode4(1947641), // Rule ID 24536 //
     /* 1947560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1947571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1947574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1947577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1947580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947606 */     // MIs[0] policy
     /* 1947606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947616 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1947619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947640 */     // GIR_Coverage, 24536,
     /* 1947640 */     GIR_EraseRootFromParent_Done,
     /* 1947641 */   // Label 26155: @1947641
     /* 1947641 */   GIM_Try, /*On fail goto*//*Label 26156*/ GIMT_Encode4(1947727), // Rule ID 24537 //
     /* 1947646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1947657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1947660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1947663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1947666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947692 */     // MIs[0] policy
     /* 1947692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947702 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1947705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947726 */     // GIR_Coverage, 24537,
     /* 1947726 */     GIR_EraseRootFromParent_Done,
     /* 1947727 */   // Label 26156: @1947727
     /* 1947727 */   GIM_Try, /*On fail goto*//*Label 26157*/ GIMT_Encode4(1947813), // Rule ID 24540 //
     /* 1947732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1947743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1947746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1947749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1947752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947778 */     // MIs[0] policy
     /* 1947778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947788 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1947791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947812 */     // GIR_Coverage, 24540,
     /* 1947812 */     GIR_EraseRootFromParent_Done,
     /* 1947813 */   // Label 26157: @1947813
     /* 1947813 */   GIM_Try, /*On fail goto*//*Label 26158*/ GIMT_Encode4(1947899), // Rule ID 24541 //
     /* 1947818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1947829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1947832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1947835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1947838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947864 */     // MIs[0] policy
     /* 1947864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947874 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1947877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947898 */     // GIR_Coverage, 24541,
     /* 1947898 */     GIR_EraseRootFromParent_Done,
     /* 1947899 */   // Label 26158: @1947899
     /* 1947899 */   GIM_Try, /*On fail goto*//*Label 26159*/ GIMT_Encode4(1947985), // Rule ID 24544 //
     /* 1947904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1947915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1947918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1947921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1947924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947950 */     // MIs[0] policy
     /* 1947950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947960 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1947963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947984 */     // GIR_Coverage, 24544,
     /* 1947984 */     GIR_EraseRootFromParent_Done,
     /* 1947985 */   // Label 26159: @1947985
     /* 1947985 */   GIM_Try, /*On fail goto*//*Label 26160*/ GIMT_Encode4(1948071), // Rule ID 24545 //
     /* 1947990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1948001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1948004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1948007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1948010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1948013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948036 */     // MIs[0] policy
     /* 1948036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1948049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948070 */     // GIR_Coverage, 24545,
     /* 1948070 */     GIR_EraseRootFromParent_Done,
     /* 1948071 */   // Label 26160: @1948071
     /* 1948071 */   GIM_Try, /*On fail goto*//*Label 26161*/ GIMT_Encode4(1948157), // Rule ID 24548 //
     /* 1948076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1948079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1948087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1948090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1948093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1948096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948122 */     // MIs[0] policy
     /* 1948122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948132 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1948135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1948153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948156 */     // GIR_Coverage, 24548,
     /* 1948156 */     GIR_EraseRootFromParent_Done,
     /* 1948157 */   // Label 26161: @1948157
     /* 1948157 */   GIM_Try, /*On fail goto*//*Label 26162*/ GIMT_Encode4(1948243), // Rule ID 24549 //
     /* 1948162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1948165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1948173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1948176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1948179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1948182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948208 */     // MIs[0] policy
     /* 1948208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948218 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1948221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1948239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948242 */     // GIR_Coverage, 24549,
     /* 1948242 */     GIR_EraseRootFromParent_Done,
     /* 1948243 */   // Label 26162: @1948243
     /* 1948243 */   GIM_Try, /*On fail goto*//*Label 26163*/ GIMT_Encode4(1948329), // Rule ID 24552 //
     /* 1948248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1948259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1948262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1948265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1948268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948294 */     // MIs[0] policy
     /* 1948294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948304 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1948307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948328 */     // GIR_Coverage, 24552,
     /* 1948328 */     GIR_EraseRootFromParent_Done,
     /* 1948329 */   // Label 26163: @1948329
     /* 1948329 */   GIM_Try, /*On fail goto*//*Label 26164*/ GIMT_Encode4(1948415), // Rule ID 24553 //
     /* 1948334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1948345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1948348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1948351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1948354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948380 */     // MIs[0] policy
     /* 1948380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948390 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1948393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948414 */     // GIR_Coverage, 24553,
     /* 1948414 */     GIR_EraseRootFromParent_Done,
     /* 1948415 */   // Label 26164: @1948415
     /* 1948415 */   GIM_Try, /*On fail goto*//*Label 26165*/ GIMT_Encode4(1948501), // Rule ID 24556 //
     /* 1948420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1948431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1948434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1948437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1948440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948466 */     // MIs[0] policy
     /* 1948466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948476 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1948479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948500 */     // GIR_Coverage, 24556,
     /* 1948500 */     GIR_EraseRootFromParent_Done,
     /* 1948501 */   // Label 26165: @1948501
     /* 1948501 */   GIM_Try, /*On fail goto*//*Label 26166*/ GIMT_Encode4(1948587), // Rule ID 24557 //
     /* 1948506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1948517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1948520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1948523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1948526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948552 */     // MIs[0] policy
     /* 1948552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948562 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1948565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948586 */     // GIR_Coverage, 24557,
     /* 1948586 */     GIR_EraseRootFromParent_Done,
     /* 1948587 */   // Label 26166: @1948587
     /* 1948587 */   GIM_Try, /*On fail goto*//*Label 26167*/ GIMT_Encode4(1948673), // Rule ID 24560 //
     /* 1948592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1948603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1948606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1948609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1948612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1948615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948638 */     // MIs[0] policy
     /* 1948638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948648 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1948651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948672 */     // GIR_Coverage, 24560,
     /* 1948672 */     GIR_EraseRootFromParent_Done,
     /* 1948673 */   // Label 26167: @1948673
     /* 1948673 */   GIM_Try, /*On fail goto*//*Label 26168*/ GIMT_Encode4(1948759), // Rule ID 24561 //
     /* 1948678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1948689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1948692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1948695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1948698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1948701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948724 */     // MIs[0] policy
     /* 1948724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948734 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1948737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948758 */     // GIR_Coverage, 24561,
     /* 1948758 */     GIR_EraseRootFromParent_Done,
     /* 1948759 */   // Label 26168: @1948759
     /* 1948759 */   GIM_Try, /*On fail goto*//*Label 26169*/ GIMT_Encode4(1948845), // Rule ID 24564 //
     /* 1948764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1948775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1948778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1948781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1948784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948810 */     // MIs[0] policy
     /* 1948810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948820 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1948823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948844 */     // GIR_Coverage, 24564,
     /* 1948844 */     GIR_EraseRootFromParent_Done,
     /* 1948845 */   // Label 26169: @1948845
     /* 1948845 */   GIM_Try, /*On fail goto*//*Label 26170*/ GIMT_Encode4(1948931), // Rule ID 24565 //
     /* 1948850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1948861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1948864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1948867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1948870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948896 */     // MIs[0] policy
     /* 1948896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948906 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1948909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948930 */     // GIR_Coverage, 24565,
     /* 1948930 */     GIR_EraseRootFromParent_Done,
     /* 1948931 */   // Label 26170: @1948931
     /* 1948931 */   GIM_Try, /*On fail goto*//*Label 26171*/ GIMT_Encode4(1949017), // Rule ID 24568 //
     /* 1948936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1948947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1948950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1948953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1948956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948982 */     // MIs[0] policy
     /* 1948982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948992 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1948995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949016 */     // GIR_Coverage, 24568,
     /* 1949016 */     GIR_EraseRootFromParent_Done,
     /* 1949017 */   // Label 26171: @1949017
     /* 1949017 */   GIM_Try, /*On fail goto*//*Label 26172*/ GIMT_Encode4(1949103), // Rule ID 24569 //
     /* 1949022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1949033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1949036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1949039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1949042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949068 */     // MIs[0] policy
     /* 1949068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949078 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1949081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949102 */     // GIR_Coverage, 24569,
     /* 1949102 */     GIR_EraseRootFromParent_Done,
     /* 1949103 */   // Label 26172: @1949103
     /* 1949103 */   GIM_Try, /*On fail goto*//*Label 26173*/ GIMT_Encode4(1949189), // Rule ID 24572 //
     /* 1949108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1949119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1949122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1949125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1949128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1949131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949154 */     // MIs[0] policy
     /* 1949154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949164 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1949167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949188 */     // GIR_Coverage, 24572,
     /* 1949188 */     GIR_EraseRootFromParent_Done,
     /* 1949189 */   // Label 26173: @1949189
     /* 1949189 */   GIM_Try, /*On fail goto*//*Label 26174*/ GIMT_Encode4(1949275), // Rule ID 24573 //
     /* 1949194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1949205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1949208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1949211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1949214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1949217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949240 */     // MIs[0] policy
     /* 1949240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949250 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1949253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949274 */     // GIR_Coverage, 24573,
     /* 1949274 */     GIR_EraseRootFromParent_Done,
     /* 1949275 */   // Label 26174: @1949275
     /* 1949275 */   GIM_Try, /*On fail goto*//*Label 26175*/ GIMT_Encode4(1949361), // Rule ID 24576 //
     /* 1949280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1949291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1949294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1949297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1949300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949326 */     // MIs[0] policy
     /* 1949326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1949339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949360 */     // GIR_Coverage, 24576,
     /* 1949360 */     GIR_EraseRootFromParent_Done,
     /* 1949361 */   // Label 26175: @1949361
     /* 1949361 */   GIM_Try, /*On fail goto*//*Label 26176*/ GIMT_Encode4(1949447), // Rule ID 24577 //
     /* 1949366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1949377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1949380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1949383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1949386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949412 */     // MIs[0] policy
     /* 1949412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1949425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949446 */     // GIR_Coverage, 24577,
     /* 1949446 */     GIR_EraseRootFromParent_Done,
     /* 1949447 */   // Label 26176: @1949447
     /* 1949447 */   GIM_Try, /*On fail goto*//*Label 26177*/ GIMT_Encode4(1949533), // Rule ID 24580 //
     /* 1949452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1949463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1949466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1949469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1949472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949498 */     // MIs[0] policy
     /* 1949498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1949511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949532 */     // GIR_Coverage, 24580,
     /* 1949532 */     GIR_EraseRootFromParent_Done,
     /* 1949533 */   // Label 26177: @1949533
     /* 1949533 */   GIM_Try, /*On fail goto*//*Label 26178*/ GIMT_Encode4(1949619), // Rule ID 24581 //
     /* 1949538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1949549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1949552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1949555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1949558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949584 */     // MIs[0] policy
     /* 1949584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949594 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1949597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949618 */     // GIR_Coverage, 24581,
     /* 1949618 */     GIR_EraseRootFromParent_Done,
     /* 1949619 */   // Label 26178: @1949619
     /* 1949619 */   GIM_Try, /*On fail goto*//*Label 26179*/ GIMT_Encode4(1949705), // Rule ID 24584 //
     /* 1949624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1949635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1949638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1949641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1949644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949670 */     // MIs[0] policy
     /* 1949670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949680 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1949683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949704 */     // GIR_Coverage, 24584,
     /* 1949704 */     GIR_EraseRootFromParent_Done,
     /* 1949705 */   // Label 26179: @1949705
     /* 1949705 */   GIM_Try, /*On fail goto*//*Label 26180*/ GIMT_Encode4(1949791), // Rule ID 24585 //
     /* 1949710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1949721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1949724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1949727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1949730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949756 */     // MIs[0] policy
     /* 1949756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949766 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1949769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949790 */     // GIR_Coverage, 24585,
     /* 1949790 */     GIR_EraseRootFromParent_Done,
     /* 1949791 */   // Label 26180: @1949791
     /* 1949791 */   GIM_Try, /*On fail goto*//*Label 26181*/ GIMT_Encode4(1949877), // Rule ID 24588 //
     /* 1949796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1949799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1949807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1949810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1949813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1949816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949842 */     // MIs[0] policy
     /* 1949842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949852 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1949855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949876 */     // GIR_Coverage, 24588,
     /* 1949876 */     GIR_EraseRootFromParent_Done,
     /* 1949877 */   // Label 26181: @1949877
     /* 1949877 */   GIM_Try, /*On fail goto*//*Label 26182*/ GIMT_Encode4(1949963), // Rule ID 24589 //
     /* 1949882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1949885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1949893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1949896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1949899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1949902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949928 */     // MIs[0] policy
     /* 1949928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1949941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949962 */     // GIR_Coverage, 24589,
     /* 1949962 */     GIR_EraseRootFromParent_Done,
     /* 1949963 */   // Label 26182: @1949963
     /* 1949963 */   GIM_Try, /*On fail goto*//*Label 26183*/ GIMT_Encode4(1950049), // Rule ID 24592 //
     /* 1949968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1949971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1949979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1949982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1949985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1949988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950014 */     // MIs[0] policy
     /* 1950014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950024 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1950027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950048 */     // GIR_Coverage, 24592,
     /* 1950048 */     GIR_EraseRootFromParent_Done,
     /* 1950049 */   // Label 26183: @1950049
     /* 1950049 */   GIM_Try, /*On fail goto*//*Label 26184*/ GIMT_Encode4(1950135), // Rule ID 24593 //
     /* 1950054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1950057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1950065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1950068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1950071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1950074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1950084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950100 */     // MIs[0] policy
     /* 1950100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950110 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1950113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950134 */     // GIR_Coverage, 24593,
     /* 1950134 */     GIR_EraseRootFromParent_Done,
     /* 1950135 */   // Label 26184: @1950135
     /* 1950135 */   GIM_Try, /*On fail goto*//*Label 26185*/ GIMT_Encode4(1950221), // Rule ID 24596 //
     /* 1950140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1950143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1950151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1950154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1950157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1950160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1950170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950186 */     // MIs[0] policy
     /* 1950186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950196 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1950199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950220 */     // GIR_Coverage, 24596,
     /* 1950220 */     GIR_EraseRootFromParent_Done,
     /* 1950221 */   // Label 26185: @1950221
     /* 1950221 */   GIM_Try, /*On fail goto*//*Label 26186*/ GIMT_Encode4(1950307), // Rule ID 24597 //
     /* 1950226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1950229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1950237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1950240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1950243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1950246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1950256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950272 */     // MIs[0] policy
     /* 1950272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950282 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1950285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950306 */     // GIR_Coverage, 24597,
     /* 1950306 */     GIR_EraseRootFromParent_Done,
     /* 1950307 */   // Label 26186: @1950307
     /* 1950307 */   GIM_Try, /*On fail goto*//*Label 26187*/ GIMT_Encode4(1950393), // Rule ID 24600 //
     /* 1950312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1950323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1950326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1950329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950358 */     // MIs[0] policy
     /* 1950358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950368 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1950371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950392 */     // GIR_Coverage, 24600,
     /* 1950392 */     GIR_EraseRootFromParent_Done,
     /* 1950393 */   // Label 26187: @1950393
     /* 1950393 */   GIM_Try, /*On fail goto*//*Label 26188*/ GIMT_Encode4(1950479), // Rule ID 24601 //
     /* 1950398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1950409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1950412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1950415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950444 */     // MIs[0] policy
     /* 1950444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950454 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1950457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950478 */     // GIR_Coverage, 24601,
     /* 1950478 */     GIR_EraseRootFromParent_Done,
     /* 1950479 */   // Label 26188: @1950479
     /* 1950479 */   GIM_Try, /*On fail goto*//*Label 26189*/ GIMT_Encode4(1950565), // Rule ID 24604 //
     /* 1950484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1950495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1950498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1950501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950530 */     // MIs[0] policy
     /* 1950530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950540 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950564 */     // GIR_Coverage, 24604,
     /* 1950564 */     GIR_EraseRootFromParent_Done,
     /* 1950565 */   // Label 26189: @1950565
     /* 1950565 */   GIM_Try, /*On fail goto*//*Label 26190*/ GIMT_Encode4(1950651), // Rule ID 24605 //
     /* 1950570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1950581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1950584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1950587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950616 */     // MIs[0] policy
     /* 1950616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950626 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950650 */     // GIR_Coverage, 24605,
     /* 1950650 */     GIR_EraseRootFromParent_Done,
     /* 1950651 */   // Label 26190: @1950651
     /* 1950651 */   GIM_Try, /*On fail goto*//*Label 26191*/ GIMT_Encode4(1950737), // Rule ID 24608 //
     /* 1950656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1950667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1950670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1950673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950702 */     // MIs[0] policy
     /* 1950702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950712 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950736 */     // GIR_Coverage, 24608,
     /* 1950736 */     GIR_EraseRootFromParent_Done,
     /* 1950737 */   // Label 26191: @1950737
     /* 1950737 */   GIM_Try, /*On fail goto*//*Label 26192*/ GIMT_Encode4(1950823), // Rule ID 24609 //
     /* 1950742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1950753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1950756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1950759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950788 */     // MIs[0] policy
     /* 1950788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950798 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950822 */     // GIR_Coverage, 24609,
     /* 1950822 */     GIR_EraseRootFromParent_Done,
     /* 1950823 */   // Label 26192: @1950823
     /* 1950823 */   GIM_Try, /*On fail goto*//*Label 26193*/ GIMT_Encode4(1950909), // Rule ID 24612 //
     /* 1950828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1950839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1950842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1950845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950874 */     // MIs[0] policy
     /* 1950874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950908 */     // GIR_Coverage, 24612,
     /* 1950908 */     GIR_EraseRootFromParent_Done,
     /* 1950909 */   // Label 26193: @1950909
     /* 1950909 */   GIM_Try, /*On fail goto*//*Label 26194*/ GIMT_Encode4(1950995), // Rule ID 24613 //
     /* 1950914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1950925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1950928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1950931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950960 */     // MIs[0] policy
     /* 1950960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950970 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950994 */     // GIR_Coverage, 24613,
     /* 1950994 */     GIR_EraseRootFromParent_Done,
     /* 1950995 */   // Label 26194: @1950995
     /* 1950995 */   GIM_Try, /*On fail goto*//*Label 26195*/ GIMT_Encode4(1951081), // Rule ID 24616 //
     /* 1951000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1951011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1951014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1951017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951046 */     // MIs[0] policy
     /* 1951046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951056 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1951059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951080 */     // GIR_Coverage, 24616,
     /* 1951080 */     GIR_EraseRootFromParent_Done,
     /* 1951081 */   // Label 26195: @1951081
     /* 1951081 */   GIM_Try, /*On fail goto*//*Label 26196*/ GIMT_Encode4(1951167), // Rule ID 24617 //
     /* 1951086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1951097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1951100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1951103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951132 */     // MIs[0] policy
     /* 1951132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951142 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1951145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951166 */     // GIR_Coverage, 24617,
     /* 1951166 */     GIR_EraseRootFromParent_Done,
     /* 1951167 */   // Label 26196: @1951167
     /* 1951167 */   GIM_Try, /*On fail goto*//*Label 26197*/ GIMT_Encode4(1951253), // Rule ID 24620 //
     /* 1951172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1951183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1951186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1951189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951218 */     // MIs[0] policy
     /* 1951218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951228 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1951231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951252 */     // GIR_Coverage, 24620,
     /* 1951252 */     GIR_EraseRootFromParent_Done,
     /* 1951253 */   // Label 26197: @1951253
     /* 1951253 */   GIM_Try, /*On fail goto*//*Label 26198*/ GIMT_Encode4(1951339), // Rule ID 24621 //
     /* 1951258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1951269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1951272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1951275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951304 */     // MIs[0] policy
     /* 1951304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951314 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1951317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951338 */     // GIR_Coverage, 24621,
     /* 1951338 */     GIR_EraseRootFromParent_Done,
     /* 1951339 */   // Label 26198: @1951339
     /* 1951339 */   GIM_Try, /*On fail goto*//*Label 26199*/ GIMT_Encode4(1951425), // Rule ID 24624 //
     /* 1951344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1951355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1951358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1951361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1951367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951390 */     // MIs[0] policy
     /* 1951390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951400 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951424 */     // GIR_Coverage, 24624,
     /* 1951424 */     GIR_EraseRootFromParent_Done,
     /* 1951425 */   // Label 26199: @1951425
     /* 1951425 */   GIM_Try, /*On fail goto*//*Label 26200*/ GIMT_Encode4(1951511), // Rule ID 24625 //
     /* 1951430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1951441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1951444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1951447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1951453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951476 */     // MIs[0] policy
     /* 1951476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951486 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951510 */     // GIR_Coverage, 24625,
     /* 1951510 */     GIR_EraseRootFromParent_Done,
     /* 1951511 */   // Label 26200: @1951511
     /* 1951511 */   GIM_Try, /*On fail goto*//*Label 26201*/ GIMT_Encode4(1951597), // Rule ID 24628 //
     /* 1951516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1951527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1951530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1951533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951562 */     // MIs[0] policy
     /* 1951562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951572 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951596 */     // GIR_Coverage, 24628,
     /* 1951596 */     GIR_EraseRootFromParent_Done,
     /* 1951597 */   // Label 26201: @1951597
     /* 1951597 */   GIM_Try, /*On fail goto*//*Label 26202*/ GIMT_Encode4(1951683), // Rule ID 24629 //
     /* 1951602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1951613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1951616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1951619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951648 */     // MIs[0] policy
     /* 1951648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951658 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951682 */     // GIR_Coverage, 24629,
     /* 1951682 */     GIR_EraseRootFromParent_Done,
     /* 1951683 */   // Label 26202: @1951683
     /* 1951683 */   GIM_Try, /*On fail goto*//*Label 26203*/ GIMT_Encode4(1951769), // Rule ID 24632 //
     /* 1951688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1951699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1951702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1951705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951734 */     // MIs[0] policy
     /* 1951734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951768 */     // GIR_Coverage, 24632,
     /* 1951768 */     GIR_EraseRootFromParent_Done,
     /* 1951769 */   // Label 26203: @1951769
     /* 1951769 */   GIM_Try, /*On fail goto*//*Label 26204*/ GIMT_Encode4(1951855), // Rule ID 24633 //
     /* 1951774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1951785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1951788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1951791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951820 */     // MIs[0] policy
     /* 1951820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951854 */     // GIR_Coverage, 24633,
     /* 1951854 */     GIR_EraseRootFromParent_Done,
     /* 1951855 */   // Label 26204: @1951855
     /* 1951855 */   GIM_Try, /*On fail goto*//*Label 26205*/ GIMT_Encode4(1951941), // Rule ID 24636 //
     /* 1951860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1951863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1951871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1951874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1951877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951906 */     // MIs[0] policy
     /* 1951906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951940 */     // GIR_Coverage, 24636,
     /* 1951940 */     GIR_EraseRootFromParent_Done,
     /* 1951941 */   // Label 26205: @1951941
     /* 1951941 */   GIM_Try, /*On fail goto*//*Label 26206*/ GIMT_Encode4(1952027), // Rule ID 24637 //
     /* 1951946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1951949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1951957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1951960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1951963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951992 */     // MIs[0] policy
     /* 1951992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952002 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1952005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1952023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952026 */     // GIR_Coverage, 24637,
     /* 1952026 */     GIR_EraseRootFromParent_Done,
     /* 1952027 */   // Label 26206: @1952027
     /* 1952027 */   GIM_Try, /*On fail goto*//*Label 26207*/ GIMT_Encode4(1952113), // Rule ID 24640 //
     /* 1952032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1952043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1952046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1952049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952078 */     // MIs[0] policy
     /* 1952078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952088 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952112 */     // GIR_Coverage, 24640,
     /* 1952112 */     GIR_EraseRootFromParent_Done,
     /* 1952113 */   // Label 26207: @1952113
     /* 1952113 */   GIM_Try, /*On fail goto*//*Label 26208*/ GIMT_Encode4(1952199), // Rule ID 24641 //
     /* 1952118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1952129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1952132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1952135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952164 */     // MIs[0] policy
     /* 1952164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952174 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952198 */     // GIR_Coverage, 24641,
     /* 1952198 */     GIR_EraseRootFromParent_Done,
     /* 1952199 */   // Label 26208: @1952199
     /* 1952199 */   GIM_Try, /*On fail goto*//*Label 26209*/ GIMT_Encode4(1952285), // Rule ID 24644 //
     /* 1952204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1952215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1952218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1952221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952250 */     // MIs[0] policy
     /* 1952250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952260 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952284 */     // GIR_Coverage, 24644,
     /* 1952284 */     GIR_EraseRootFromParent_Done,
     /* 1952285 */   // Label 26209: @1952285
     /* 1952285 */   GIM_Try, /*On fail goto*//*Label 26210*/ GIMT_Encode4(1952371), // Rule ID 24645 //
     /* 1952290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1952301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1952304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1952307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952336 */     // MIs[0] policy
     /* 1952336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952346 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952370 */     // GIR_Coverage, 24645,
     /* 1952370 */     GIR_EraseRootFromParent_Done,
     /* 1952371 */   // Label 26210: @1952371
     /* 1952371 */   GIM_Try, /*On fail goto*//*Label 26211*/ GIMT_Encode4(1952457), // Rule ID 24648 //
     /* 1952376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1952387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1952390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1952393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1952399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952422 */     // MIs[0] policy
     /* 1952422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952432 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952456 */     // GIR_Coverage, 24648,
     /* 1952456 */     GIR_EraseRootFromParent_Done,
     /* 1952457 */   // Label 26211: @1952457
     /* 1952457 */   GIM_Try, /*On fail goto*//*Label 26212*/ GIMT_Encode4(1952543), // Rule ID 24649 //
     /* 1952462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1952473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1952476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1952479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1952485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952508 */     // MIs[0] policy
     /* 1952508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952518 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952542 */     // GIR_Coverage, 24649,
     /* 1952542 */     GIR_EraseRootFromParent_Done,
     /* 1952543 */   // Label 26212: @1952543
     /* 1952543 */   GIM_Try, /*On fail goto*//*Label 26213*/ GIMT_Encode4(1952629), // Rule ID 24652 //
     /* 1952548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1952559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1952562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1952565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952594 */     // MIs[0] policy
     /* 1952594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952604 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952628 */     // GIR_Coverage, 24652,
     /* 1952628 */     GIR_EraseRootFromParent_Done,
     /* 1952629 */   // Label 26213: @1952629
     /* 1952629 */   GIM_Try, /*On fail goto*//*Label 26214*/ GIMT_Encode4(1952715), // Rule ID 24653 //
     /* 1952634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1952645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1952648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1952651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952680 */     // MIs[0] policy
     /* 1952680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952690 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952714 */     // GIR_Coverage, 24653,
     /* 1952714 */     GIR_EraseRootFromParent_Done,
     /* 1952715 */   // Label 26214: @1952715
     /* 1952715 */   GIM_Try, /*On fail goto*//*Label 26215*/ GIMT_Encode4(1952801), // Rule ID 24656 //
     /* 1952720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1952731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1952734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1952737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952766 */     // MIs[0] policy
     /* 1952766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952776 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952800 */     // GIR_Coverage, 24656,
     /* 1952800 */     GIR_EraseRootFromParent_Done,
     /* 1952801 */   // Label 26215: @1952801
     /* 1952801 */   GIM_Try, /*On fail goto*//*Label 26216*/ GIMT_Encode4(1952887), // Rule ID 24657 //
     /* 1952806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1952817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1952820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1952823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952852 */     // MIs[0] policy
     /* 1952852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952862 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952886 */     // GIR_Coverage, 24657,
     /* 1952886 */     GIR_EraseRootFromParent_Done,
     /* 1952887 */   // Label 26216: @1952887
     /* 1952887 */   GIM_Try, /*On fail goto*//*Label 26217*/ GIMT_Encode4(1952973), // Rule ID 24660 //
     /* 1952892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1952903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1952906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1952909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952938 */     // MIs[0] policy
     /* 1952938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952948 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952972 */     // GIR_Coverage, 24660,
     /* 1952972 */     GIR_EraseRootFromParent_Done,
     /* 1952973 */   // Label 26217: @1952973
     /* 1952973 */   GIM_Try, /*On fail goto*//*Label 26218*/ GIMT_Encode4(1953059), // Rule ID 24661 //
     /* 1952978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1952989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1952992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1952995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1953001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953024 */     // MIs[0] policy
     /* 1953024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953034 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953058 */     // GIR_Coverage, 24661,
     /* 1953058 */     GIR_EraseRootFromParent_Done,
     /* 1953059 */   // Label 26218: @1953059
     /* 1953059 */   GIM_Try, /*On fail goto*//*Label 26219*/ GIMT_Encode4(1953145), // Rule ID 24664 //
     /* 1953064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1953075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1953078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1953081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953110 */     // MIs[0] policy
     /* 1953110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953120 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953144 */     // GIR_Coverage, 24664,
     /* 1953144 */     GIR_EraseRootFromParent_Done,
     /* 1953145 */   // Label 26219: @1953145
     /* 1953145 */   GIM_Try, /*On fail goto*//*Label 26220*/ GIMT_Encode4(1953231), // Rule ID 24665 //
     /* 1953150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1953161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1953164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1953167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953196 */     // MIs[0] policy
     /* 1953196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953230 */     // GIR_Coverage, 24665,
     /* 1953230 */     GIR_EraseRootFromParent_Done,
     /* 1953231 */   // Label 26220: @1953231
     /* 1953231 */   GIM_Try, /*On fail goto*//*Label 26221*/ GIMT_Encode4(1953317), // Rule ID 24668 //
     /* 1953236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1953247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1953250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1953253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953282 */     // MIs[0] policy
     /* 1953282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953292 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953316 */     // GIR_Coverage, 24668,
     /* 1953316 */     GIR_EraseRootFromParent_Done,
     /* 1953317 */   // Label 26221: @1953317
     /* 1953317 */   GIM_Try, /*On fail goto*//*Label 26222*/ GIMT_Encode4(1953403), // Rule ID 24669 //
     /* 1953322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1953333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1953336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1953339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953368 */     // MIs[0] policy
     /* 1953368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953378 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953402 */     // GIR_Coverage, 24669,
     /* 1953402 */     GIR_EraseRootFromParent_Done,
     /* 1953403 */   // Label 26222: @1953403
     /* 1953403 */   GIM_Try, /*On fail goto*//*Label 26223*/ GIMT_Encode4(1953489), // Rule ID 24672 //
     /* 1953408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1953419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1953422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1953425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953454 */     // MIs[0] policy
     /* 1953454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953488 */     // GIR_Coverage, 24672,
     /* 1953488 */     GIR_EraseRootFromParent_Done,
     /* 1953489 */   // Label 26223: @1953489
     /* 1953489 */   GIM_Try, /*On fail goto*//*Label 26224*/ GIMT_Encode4(1953575), // Rule ID 24673 //
     /* 1953494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1953505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1953508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1953511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953540 */     // MIs[0] policy
     /* 1953540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953550 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953574 */     // GIR_Coverage, 24673,
     /* 1953574 */     GIR_EraseRootFromParent_Done,
     /* 1953575 */   // Label 26224: @1953575
     /* 1953575 */   GIM_Try, /*On fail goto*//*Label 26225*/ GIMT_Encode4(1953661), // Rule ID 24676 //
     /* 1953580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1953591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1953594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1953597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953626 */     // MIs[0] policy
     /* 1953626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953660 */     // GIR_Coverage, 24676,
     /* 1953660 */     GIR_EraseRootFromParent_Done,
     /* 1953661 */   // Label 26225: @1953661
     /* 1953661 */   GIM_Try, /*On fail goto*//*Label 26226*/ GIMT_Encode4(1953747), // Rule ID 24677 //
     /* 1953666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1953677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1953680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1953683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953712 */     // MIs[0] policy
     /* 1953712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953722 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953746 */     // GIR_Coverage, 24677,
     /* 1953746 */     GIR_EraseRootFromParent_Done,
     /* 1953747 */   // Label 26226: @1953747
     /* 1953747 */   GIM_Try, /*On fail goto*//*Label 26227*/ GIMT_Encode4(1953833), // Rule ID 24680 //
     /* 1953752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1953763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1953766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1953769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953798 */     // MIs[0] policy
     /* 1953798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953808 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953832 */     // GIR_Coverage, 24680,
     /* 1953832 */     GIR_EraseRootFromParent_Done,
     /* 1953833 */   // Label 26227: @1953833
     /* 1953833 */   GIM_Try, /*On fail goto*//*Label 26228*/ GIMT_Encode4(1953919), // Rule ID 24681 //
     /* 1953838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1953849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1953852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1953855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953884 */     // MIs[0] policy
     /* 1953884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953894 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953918 */     // GIR_Coverage, 24681,
     /* 1953918 */     GIR_EraseRootFromParent_Done,
     /* 1953919 */   // Label 26228: @1953919
     /* 1953919 */   GIM_Try, /*On fail goto*//*Label 26229*/ GIMT_Encode4(1954005), // Rule ID 24684 //
     /* 1953924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1953935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1953938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1953941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953970 */     // MIs[0] policy
     /* 1953970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953980 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1954001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954004 */     // GIR_Coverage, 24684,
     /* 1954004 */     GIR_EraseRootFromParent_Done,
     /* 1954005 */   // Label 26229: @1954005
     /* 1954005 */   GIM_Try, /*On fail goto*//*Label 26230*/ GIMT_Encode4(1954091), // Rule ID 24685 //
     /* 1954010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1954013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1954021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1954024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1954027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1954030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1954040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954056 */     // MIs[0] policy
     /* 1954056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954066 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1954069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1954087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954090 */     // GIR_Coverage, 24685,
     /* 1954090 */     GIR_EraseRootFromParent_Done,
     /* 1954091 */   // Label 26230: @1954091
     /* 1954091 */   GIM_Try, /*On fail goto*//*Label 26231*/ GIMT_Encode4(1954177), // Rule ID 24776 //
     /* 1954096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1954107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1954110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1954113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954142 */     // MIs[0] policy
     /* 1954142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954152 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1954155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954176 */     // GIR_Coverage, 24776,
     /* 1954176 */     GIR_EraseRootFromParent_Done,
     /* 1954177 */   // Label 26231: @1954177
     /* 1954177 */   GIM_Try, /*On fail goto*//*Label 26232*/ GIMT_Encode4(1954263), // Rule ID 24777 //
     /* 1954182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1954193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1954196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1954199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954228 */     // MIs[0] policy
     /* 1954228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954238 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1954241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954262 */     // GIR_Coverage, 24777,
     /* 1954262 */     GIR_EraseRootFromParent_Done,
     /* 1954263 */   // Label 26232: @1954263
     /* 1954263 */   GIM_Try, /*On fail goto*//*Label 26233*/ GIMT_Encode4(1954349), // Rule ID 24780 //
     /* 1954268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1954279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1954282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1954285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954314 */     // MIs[0] policy
     /* 1954314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954324 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1954327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954348 */     // GIR_Coverage, 24780,
     /* 1954348 */     GIR_EraseRootFromParent_Done,
     /* 1954349 */   // Label 26233: @1954349
     /* 1954349 */   GIM_Try, /*On fail goto*//*Label 26234*/ GIMT_Encode4(1954435), // Rule ID 24781 //
     /* 1954354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1954365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1954368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1954371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954400 */     // MIs[0] policy
     /* 1954400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954410 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1954413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954434 */     // GIR_Coverage, 24781,
     /* 1954434 */     GIR_EraseRootFromParent_Done,
     /* 1954435 */   // Label 26234: @1954435
     /* 1954435 */   GIM_Try, /*On fail goto*//*Label 26235*/ GIMT_Encode4(1954521), // Rule ID 24784 //
     /* 1954440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1954451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1954454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1954457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954486 */     // MIs[0] policy
     /* 1954486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1954499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954520 */     // GIR_Coverage, 24784,
     /* 1954520 */     GIR_EraseRootFromParent_Done,
     /* 1954521 */   // Label 26235: @1954521
     /* 1954521 */   GIM_Try, /*On fail goto*//*Label 26236*/ GIMT_Encode4(1954607), // Rule ID 24785 //
     /* 1954526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1954537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1954540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1954543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954572 */     // MIs[0] policy
     /* 1954572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954582 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1954585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954606 */     // GIR_Coverage, 24785,
     /* 1954606 */     GIR_EraseRootFromParent_Done,
     /* 1954607 */   // Label 26236: @1954607
     /* 1954607 */   GIM_Try, /*On fail goto*//*Label 26237*/ GIMT_Encode4(1954693), // Rule ID 24788 //
     /* 1954612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1954623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1954626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1954629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954658 */     // MIs[0] policy
     /* 1954658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1954671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954692 */     // GIR_Coverage, 24788,
     /* 1954692 */     GIR_EraseRootFromParent_Done,
     /* 1954693 */   // Label 26237: @1954693
     /* 1954693 */   GIM_Try, /*On fail goto*//*Label 26238*/ GIMT_Encode4(1954779), // Rule ID 24789 //
     /* 1954698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1954709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1954712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1954715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954744 */     // MIs[0] policy
     /* 1954744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954754 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1954757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954778 */     // GIR_Coverage, 24789,
     /* 1954778 */     GIR_EraseRootFromParent_Done,
     /* 1954779 */   // Label 26238: @1954779
     /* 1954779 */   GIM_Try, /*On fail goto*//*Label 26239*/ GIMT_Encode4(1954865), // Rule ID 24792 //
     /* 1954784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954830 */     // MIs[0] policy
     /* 1954830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954840 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1954843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954864 */     // GIR_Coverage, 24792,
     /* 1954864 */     GIR_EraseRootFromParent_Done,
     /* 1954865 */   // Label 26239: @1954865
     /* 1954865 */   GIM_Try, /*On fail goto*//*Label 26240*/ GIMT_Encode4(1954951), // Rule ID 24793 //
     /* 1954870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954916 */     // MIs[0] policy
     /* 1954916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954926 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1954929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954950 */     // GIR_Coverage, 24793,
     /* 1954950 */     GIR_EraseRootFromParent_Done,
     /* 1954951 */   // Label 26240: @1954951
     /* 1954951 */   GIM_Try, /*On fail goto*//*Label 26241*/ GIMT_Encode4(1955037), // Rule ID 24796 //
     /* 1954956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1954967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1954970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1954973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955002 */     // MIs[0] policy
     /* 1955002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955012 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1955015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955036 */     // GIR_Coverage, 24796,
     /* 1955036 */     GIR_EraseRootFromParent_Done,
     /* 1955037 */   // Label 26241: @1955037
     /* 1955037 */   GIM_Try, /*On fail goto*//*Label 26242*/ GIMT_Encode4(1955123), // Rule ID 24797 //
     /* 1955042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1955053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1955056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1955059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1955062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955088 */     // MIs[0] policy
     /* 1955088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955098 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1955101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955122 */     // GIR_Coverage, 24797,
     /* 1955122 */     GIR_EraseRootFromParent_Done,
     /* 1955123 */   // Label 26242: @1955123
     /* 1955123 */   GIM_Try, /*On fail goto*//*Label 26243*/ GIMT_Encode4(1955209), // Rule ID 24800 //
     /* 1955128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1955139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1955142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1955145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1955148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955174 */     // MIs[0] policy
     /* 1955174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955184 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1955187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955208 */     // GIR_Coverage, 24800,
     /* 1955208 */     GIR_EraseRootFromParent_Done,
     /* 1955209 */   // Label 26243: @1955209
     /* 1955209 */   GIM_Try, /*On fail goto*//*Label 26244*/ GIMT_Encode4(1955295), // Rule ID 24801 //
     /* 1955214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1955225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1955228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1955231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1955234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955260 */     // MIs[0] policy
     /* 1955260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955270 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1955273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955294 */     // GIR_Coverage, 24801,
     /* 1955294 */     GIR_EraseRootFromParent_Done,
     /* 1955295 */   // Label 26244: @1955295
     /* 1955295 */   GIM_Try, /*On fail goto*//*Label 26245*/ GIMT_Encode4(1955381), // Rule ID 24804 //
     /* 1955300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1955311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1955314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1955317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1955320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1955323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955346 */     // MIs[0] policy
     /* 1955346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955356 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1955359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955380 */     // GIR_Coverage, 24804,
     /* 1955380 */     GIR_EraseRootFromParent_Done,
     /* 1955381 */   // Label 26245: @1955381
     /* 1955381 */   GIM_Try, /*On fail goto*//*Label 26246*/ GIMT_Encode4(1955467), // Rule ID 24805 //
     /* 1955386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1955397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1955400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1955403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1955406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1955409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955432 */     // MIs[0] policy
     /* 1955432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955442 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1955445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955466 */     // GIR_Coverage, 24805,
     /* 1955466 */     GIR_EraseRootFromParent_Done,
     /* 1955467 */   // Label 26246: @1955467
     /* 1955467 */   GIM_Try, /*On fail goto*//*Label 26247*/ GIMT_Encode4(1955553), // Rule ID 24808 //
     /* 1955472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1955483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1955486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1955489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1955492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955518 */     // MIs[0] policy
     /* 1955518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1955531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955552 */     // GIR_Coverage, 24808,
     /* 1955552 */     GIR_EraseRootFromParent_Done,
     /* 1955553 */   // Label 26247: @1955553
     /* 1955553 */   GIM_Try, /*On fail goto*//*Label 26248*/ GIMT_Encode4(1955639), // Rule ID 24809 //
     /* 1955558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1955569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1955572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1955575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1955578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955604 */     // MIs[0] policy
     /* 1955604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955614 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1955617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955638 */     // GIR_Coverage, 24809,
     /* 1955638 */     GIR_EraseRootFromParent_Done,
     /* 1955639 */   // Label 26248: @1955639
     /* 1955639 */   GIM_Try, /*On fail goto*//*Label 26249*/ GIMT_Encode4(1955725), // Rule ID 24812 //
     /* 1955644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1955647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1955655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1955658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1955661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1955664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955690 */     // MIs[0] policy
     /* 1955690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955700 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1955703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955724 */     // GIR_Coverage, 24812,
     /* 1955724 */     GIR_EraseRootFromParent_Done,
     /* 1955725 */   // Label 26249: @1955725
     /* 1955725 */   GIM_Try, /*On fail goto*//*Label 26250*/ GIMT_Encode4(1955811), // Rule ID 24813 //
     /* 1955730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1955733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1955741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1955744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1955747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1955750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955776 */     // MIs[0] policy
     /* 1955776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1955789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955810 */     // GIR_Coverage, 24813,
     /* 1955810 */     GIR_EraseRootFromParent_Done,
     /* 1955811 */   // Label 26250: @1955811
     /* 1955811 */   GIM_Try, /*On fail goto*//*Label 26251*/ GIMT_Encode4(1955897), // Rule ID 24816 //
     /* 1955816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1955827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1955830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1955833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955862 */     // MIs[0] policy
     /* 1955862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955872 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1955875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955896 */     // GIR_Coverage, 24816,
     /* 1955896 */     GIR_EraseRootFromParent_Done,
     /* 1955897 */   // Label 26251: @1955897
     /* 1955897 */   GIM_Try, /*On fail goto*//*Label 26252*/ GIMT_Encode4(1955983), // Rule ID 24817 //
     /* 1955902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1955913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1955916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1955919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955948 */     // MIs[0] policy
     /* 1955948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955958 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1955961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955982 */     // GIR_Coverage, 24817,
     /* 1955982 */     GIR_EraseRootFromParent_Done,
     /* 1955983 */   // Label 26252: @1955983
     /* 1955983 */   GIM_Try, /*On fail goto*//*Label 26253*/ GIMT_Encode4(1956069), // Rule ID 24820 //
     /* 1955988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1955999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1956002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1956005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956034 */     // MIs[0] policy
     /* 1956034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956044 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1956047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1956065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956068 */     // GIR_Coverage, 24820,
     /* 1956068 */     GIR_EraseRootFromParent_Done,
     /* 1956069 */   // Label 26253: @1956069
     /* 1956069 */   GIM_Try, /*On fail goto*//*Label 26254*/ GIMT_Encode4(1956155), // Rule ID 24821 //
     /* 1956074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1956085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1956088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1956091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956120 */     // MIs[0] policy
     /* 1956120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956130 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1956133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1956151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956154 */     // GIR_Coverage, 24821,
     /* 1956154 */     GIR_EraseRootFromParent_Done,
     /* 1956155 */   // Label 26254: @1956155
     /* 1956155 */   GIM_Try, /*On fail goto*//*Label 26255*/ GIMT_Encode4(1956241), // Rule ID 24824 //
     /* 1956160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1956171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1956174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1956177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956206 */     // MIs[0] policy
     /* 1956206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1956219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956240 */     // GIR_Coverage, 24824,
     /* 1956240 */     GIR_EraseRootFromParent_Done,
     /* 1956241 */   // Label 26255: @1956241
     /* 1956241 */   GIM_Try, /*On fail goto*//*Label 26256*/ GIMT_Encode4(1956327), // Rule ID 24825 //
     /* 1956246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1956257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1956260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1956263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956292 */     // MIs[0] policy
     /* 1956292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1956305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956326 */     // GIR_Coverage, 24825,
     /* 1956326 */     GIR_EraseRootFromParent_Done,
     /* 1956327 */   // Label 26256: @1956327
     /* 1956327 */   GIM_Try, /*On fail goto*//*Label 26257*/ GIMT_Encode4(1956413), // Rule ID 24828 //
     /* 1956332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1956343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1956346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1956349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1956352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956378 */     // MIs[0] policy
     /* 1956378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956388 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1956391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956412 */     // GIR_Coverage, 24828,
     /* 1956412 */     GIR_EraseRootFromParent_Done,
     /* 1956413 */   // Label 26257: @1956413
     /* 1956413 */   GIM_Try, /*On fail goto*//*Label 26258*/ GIMT_Encode4(1956499), // Rule ID 24829 //
     /* 1956418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1956429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1956432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1956435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1956438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956464 */     // MIs[0] policy
     /* 1956464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1956477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956498 */     // GIR_Coverage, 24829,
     /* 1956498 */     GIR_EraseRootFromParent_Done,
     /* 1956499 */   // Label 26258: @1956499
     /* 1956499 */   GIM_Try, /*On fail goto*//*Label 26259*/ GIMT_Encode4(1956585), // Rule ID 24832 //
     /* 1956504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1956515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1956518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1956521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956550 */     // MIs[0] policy
     /* 1956550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956560 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1956563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956584 */     // GIR_Coverage, 24832,
     /* 1956584 */     GIR_EraseRootFromParent_Done,
     /* 1956585 */   // Label 26259: @1956585
     /* 1956585 */   GIM_Try, /*On fail goto*//*Label 26260*/ GIMT_Encode4(1956671), // Rule ID 24833 //
     /* 1956590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1956601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1956604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1956607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956636 */     // MIs[0] policy
     /* 1956636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1956649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956670 */     // GIR_Coverage, 24833,
     /* 1956670 */     GIR_EraseRootFromParent_Done,
     /* 1956671 */   // Label 26260: @1956671
     /* 1956671 */   GIM_Try, /*On fail goto*//*Label 26261*/ GIMT_Encode4(1956757), // Rule ID 24836 //
     /* 1956676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1956687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1956690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1956693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956722 */     // MIs[0] policy
     /* 1956722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1956735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956756 */     // GIR_Coverage, 24836,
     /* 1956756 */     GIR_EraseRootFromParent_Done,
     /* 1956757 */   // Label 26261: @1956757
     /* 1956757 */   GIM_Try, /*On fail goto*//*Label 26262*/ GIMT_Encode4(1956843), // Rule ID 24837 //
     /* 1956762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1956773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1956776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1956779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956808 */     // MIs[0] policy
     /* 1956808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1956821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956842 */     // GIR_Coverage, 24837,
     /* 1956842 */     GIR_EraseRootFromParent_Done,
     /* 1956843 */   // Label 26262: @1956843
     /* 1956843 */   GIM_Try, /*On fail goto*//*Label 26263*/ GIMT_Encode4(1956929), // Rule ID 24840 //
     /* 1956848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1956859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1956862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1956865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956894 */     // MIs[0] policy
     /* 1956894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956904 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1956907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956928 */     // GIR_Coverage, 24840,
     /* 1956928 */     GIR_EraseRootFromParent_Done,
     /* 1956929 */   // Label 26263: @1956929
     /* 1956929 */   GIM_Try, /*On fail goto*//*Label 26264*/ GIMT_Encode4(1957015), // Rule ID 24841 //
     /* 1956934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1956945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1956948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1956951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956980 */     // MIs[0] policy
     /* 1956980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956990 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1956993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957014 */     // GIR_Coverage, 24841,
     /* 1957014 */     GIR_EraseRootFromParent_Done,
     /* 1957015 */   // Label 26264: @1957015
     /* 1957015 */   GIM_Try, /*On fail goto*//*Label 26265*/ GIMT_Encode4(1957101), // Rule ID 24844 //
     /* 1957020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1957031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1957034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1957037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1957040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1957043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957066 */     // MIs[0] policy
     /* 1957066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1957079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957100 */     // GIR_Coverage, 24844,
     /* 1957100 */     GIR_EraseRootFromParent_Done,
     /* 1957101 */   // Label 26265: @1957101
     /* 1957101 */   GIM_Try, /*On fail goto*//*Label 26266*/ GIMT_Encode4(1957187), // Rule ID 24845 //
     /* 1957106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1957117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1957120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1957123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1957126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1957129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957152 */     // MIs[0] policy
     /* 1957152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957162 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1957165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957186 */     // GIR_Coverage, 24845,
     /* 1957186 */     GIR_EraseRootFromParent_Done,
     /* 1957187 */   // Label 26266: @1957187
     /* 1957187 */   GIM_Try, /*On fail goto*//*Label 26267*/ GIMT_Encode4(1957273), // Rule ID 24848 //
     /* 1957192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1957195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1957203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1957206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1957209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957238 */     // MIs[0] policy
     /* 1957238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957248 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1957251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957272 */     // GIR_Coverage, 24848,
     /* 1957272 */     GIR_EraseRootFromParent_Done,
     /* 1957273 */   // Label 26267: @1957273
     /* 1957273 */   GIM_Try, /*On fail goto*//*Label 26268*/ GIMT_Encode4(1957359), // Rule ID 24849 //
     /* 1957278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1957281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1957289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1957292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1957295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957324 */     // MIs[0] policy
     /* 1957324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957334 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1957337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957358 */     // GIR_Coverage, 24849,
     /* 1957358 */     GIR_EraseRootFromParent_Done,
     /* 1957359 */   // Label 26268: @1957359
     /* 1957359 */   GIM_Try, /*On fail goto*//*Label 26269*/ GIMT_Encode4(1957445), // Rule ID 24852 //
     /* 1957364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1957367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1957375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1957378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1957381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957410 */     // MIs[0] policy
     /* 1957410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957420 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1957423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957444 */     // GIR_Coverage, 24852,
     /* 1957444 */     GIR_EraseRootFromParent_Done,
     /* 1957445 */   // Label 26269: @1957445
     /* 1957445 */   GIM_Try, /*On fail goto*//*Label 26270*/ GIMT_Encode4(1957531), // Rule ID 24853 //
     /* 1957450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1957453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1957461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1957464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1957467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957496 */     // MIs[0] policy
     /* 1957496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957506 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1957509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957530 */     // GIR_Coverage, 24853,
     /* 1957530 */     GIR_EraseRootFromParent_Done,
     /* 1957531 */   // Label 26270: @1957531
     /* 1957531 */   GIM_Try, /*On fail goto*//*Label 26271*/ GIMT_Encode4(1957617), // Rule ID 24856 //
     /* 1957536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1957539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1957556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957582 */     // MIs[0] policy
     /* 1957582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957592 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1957595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957616 */     // GIR_Coverage, 24856,
     /* 1957616 */     GIR_EraseRootFromParent_Done,
     /* 1957617 */   // Label 26271: @1957617
     /* 1957617 */   GIM_Try, /*On fail goto*//*Label 26272*/ GIMT_Encode4(1957703), // Rule ID 24857 //
     /* 1957622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1957625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1957642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957668 */     // MIs[0] policy
     /* 1957668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957678 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1957681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957702 */     // GIR_Coverage, 24857,
     /* 1957702 */     GIR_EraseRootFromParent_Done,
     /* 1957703 */   // Label 26272: @1957703
     /* 1957703 */   GIM_Try, /*On fail goto*//*Label 26273*/ GIMT_Encode4(1957789), // Rule ID 24860 //
     /* 1957708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1957719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1957722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1957725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1957728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957754 */     // MIs[0] policy
     /* 1957754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957764 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1957767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957788 */     // GIR_Coverage, 24860,
     /* 1957788 */     GIR_EraseRootFromParent_Done,
     /* 1957789 */   // Label 26273: @1957789
     /* 1957789 */   GIM_Try, /*On fail goto*//*Label 26274*/ GIMT_Encode4(1957875), // Rule ID 24861 //
     /* 1957794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1957805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1957808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1957811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1957814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957840 */     // MIs[0] policy
     /* 1957840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957850 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1957853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957874 */     // GIR_Coverage, 24861,
     /* 1957874 */     GIR_EraseRootFromParent_Done,
     /* 1957875 */   // Label 26274: @1957875
     /* 1957875 */   GIM_Try, /*On fail goto*//*Label 26275*/ GIMT_Encode4(1957961), // Rule ID 24864 //
     /* 1957880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1957891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1957894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1957897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957926 */     // MIs[0] policy
     /* 1957926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957936 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1957939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957960 */     // GIR_Coverage, 24864,
     /* 1957960 */     GIR_EraseRootFromParent_Done,
     /* 1957961 */   // Label 26275: @1957961
     /* 1957961 */   GIM_Try, /*On fail goto*//*Label 26276*/ GIMT_Encode4(1958047), // Rule ID 24865 //
     /* 1957966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1957977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1957980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1957983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958012 */     // MIs[0] policy
     /* 1958012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958022 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1958025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958046 */     // GIR_Coverage, 24865,
     /* 1958046 */     GIR_EraseRootFromParent_Done,
     /* 1958047 */   // Label 26276: @1958047
     /* 1958047 */   GIM_Try, /*On fail goto*//*Label 26277*/ GIMT_Encode4(1958133), // Rule ID 24868 //
     /* 1958052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1958063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1958066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1958069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1958072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958098 */     // MIs[0] policy
     /* 1958098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958108 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1958111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958132 */     // GIR_Coverage, 24868,
     /* 1958132 */     GIR_EraseRootFromParent_Done,
     /* 1958133 */   // Label 26277: @1958133
     /* 1958133 */   GIM_Try, /*On fail goto*//*Label 26278*/ GIMT_Encode4(1958219), // Rule ID 24869 //
     /* 1958138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1958149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1958152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1958155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1958158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958184 */     // MIs[0] policy
     /* 1958184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958194 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1958197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958218 */     // GIR_Coverage, 24869,
     /* 1958218 */     GIR_EraseRootFromParent_Done,
     /* 1958219 */   // Label 26278: @1958219
     /* 1958219 */   GIM_Try, /*On fail goto*//*Label 26279*/ GIMT_Encode4(1958305), // Rule ID 24872 //
     /* 1958224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1958235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1958238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1958241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1958244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958270 */     // MIs[0] policy
     /* 1958270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958280 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1958283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958304 */     // GIR_Coverage, 24872,
     /* 1958304 */     GIR_EraseRootFromParent_Done,
     /* 1958305 */   // Label 26279: @1958305
     /* 1958305 */   GIM_Try, /*On fail goto*//*Label 26280*/ GIMT_Encode4(1958391), // Rule ID 24873 //
     /* 1958310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1958321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1958324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1958327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1958330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958356 */     // MIs[0] policy
     /* 1958356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958366 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1958369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958390 */     // GIR_Coverage, 24873,
     /* 1958390 */     GIR_EraseRootFromParent_Done,
     /* 1958391 */   // Label 26280: @1958391
     /* 1958391 */   GIM_Try, /*On fail goto*//*Label 26281*/ GIMT_Encode4(1958477), // Rule ID 24876 //
     /* 1958396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1958407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1958410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1958413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1958416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958442 */     // MIs[0] policy
     /* 1958442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958452 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1958455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958476 */     // GIR_Coverage, 24876,
     /* 1958476 */     GIR_EraseRootFromParent_Done,
     /* 1958477 */   // Label 26281: @1958477
     /* 1958477 */   GIM_Try, /*On fail goto*//*Label 26282*/ GIMT_Encode4(1958563), // Rule ID 24877 //
     /* 1958482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1958493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1958496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1958499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1958502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958528 */     // MIs[0] policy
     /* 1958528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958538 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1958541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958562 */     // GIR_Coverage, 24877,
     /* 1958562 */     GIR_EraseRootFromParent_Done,
     /* 1958563 */   // Label 26282: @1958563
     /* 1958563 */   GIM_Try, /*On fail goto*//*Label 26283*/ GIMT_Encode4(1958649), // Rule ID 24880 //
     /* 1958568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1958571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1958579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1958582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1958585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1958588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958614 */     // MIs[0] policy
     /* 1958614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958624 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1958627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958648 */     // GIR_Coverage, 24880,
     /* 1958648 */     GIR_EraseRootFromParent_Done,
     /* 1958649 */   // Label 26283: @1958649
     /* 1958649 */   GIM_Try, /*On fail goto*//*Label 26284*/ GIMT_Encode4(1958735), // Rule ID 24881 //
     /* 1958654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1958657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1958665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1958668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1958671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1958674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958700 */     // MIs[0] policy
     /* 1958700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958710 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1958713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958734 */     // GIR_Coverage, 24881,
     /* 1958734 */     GIR_EraseRootFromParent_Done,
     /* 1958735 */   // Label 26284: @1958735
     /* 1958735 */   GIM_Try, /*On fail goto*//*Label 26285*/ GIMT_Encode4(1958821), // Rule ID 24884 //
     /* 1958740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1958751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1958754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1958757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958786 */     // MIs[0] policy
     /* 1958786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958796 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1958799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958820 */     // GIR_Coverage, 24884,
     /* 1958820 */     GIR_EraseRootFromParent_Done,
     /* 1958821 */   // Label 26285: @1958821
     /* 1958821 */   GIM_Try, /*On fail goto*//*Label 26286*/ GIMT_Encode4(1958907), // Rule ID 24885 //
     /* 1958826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1958837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1958840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1958843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958872 */     // MIs[0] policy
     /* 1958872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958882 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1958885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958906 */     // GIR_Coverage, 24885,
     /* 1958906 */     GIR_EraseRootFromParent_Done,
     /* 1958907 */   // Label 26286: @1958907
     /* 1958907 */   GIM_Try, /*On fail goto*//*Label 26287*/ GIMT_Encode4(1958993), // Rule ID 24888 //
     /* 1958912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1958923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1958926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1958929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1958932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1958935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1958942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958958 */     // MIs[0] policy
     /* 1958958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958968 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1958971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958992 */     // GIR_Coverage, 24888,
     /* 1958992 */     GIR_EraseRootFromParent_Done,
     /* 1958993 */   // Label 26287: @1958993
     /* 1958993 */   GIM_Try, /*On fail goto*//*Label 26288*/ GIMT_Encode4(1959079), // Rule ID 24889 //
     /* 1958998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1959009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1959012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1959015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1959018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959044 */     // MIs[0] policy
     /* 1959044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959054 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1959057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959078 */     // GIR_Coverage, 24889,
     /* 1959078 */     GIR_EraseRootFromParent_Done,
     /* 1959079 */   // Label 26288: @1959079
     /* 1959079 */   GIM_Try, /*On fail goto*//*Label 26289*/ GIMT_Encode4(1959165), // Rule ID 24892 //
     /* 1959084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1959095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1959098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1959101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1959104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959130 */     // MIs[0] policy
     /* 1959130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959140 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1959143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959164 */     // GIR_Coverage, 24892,
     /* 1959164 */     GIR_EraseRootFromParent_Done,
     /* 1959165 */   // Label 26289: @1959165
     /* 1959165 */   GIM_Try, /*On fail goto*//*Label 26290*/ GIMT_Encode4(1959251), // Rule ID 24893 //
     /* 1959170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1959181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1959184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1959187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1959190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959216 */     // MIs[0] policy
     /* 1959216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959226 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1959229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959250 */     // GIR_Coverage, 24893,
     /* 1959250 */     GIR_EraseRootFromParent_Done,
     /* 1959251 */   // Label 26290: @1959251
     /* 1959251 */   GIM_Try, /*On fail goto*//*Label 26291*/ GIMT_Encode4(1959337), // Rule ID 24896 //
     /* 1959256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1959267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1959270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1959273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1959276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959302 */     // MIs[0] policy
     /* 1959302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959312 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1959315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959336 */     // GIR_Coverage, 24896,
     /* 1959336 */     GIR_EraseRootFromParent_Done,
     /* 1959337 */   // Label 26291: @1959337
     /* 1959337 */   GIM_Try, /*On fail goto*//*Label 26292*/ GIMT_Encode4(1959423), // Rule ID 24897 //
     /* 1959342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1959353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1959356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1959359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1959362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959388 */     // MIs[0] policy
     /* 1959388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959398 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1959401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959422 */     // GIR_Coverage, 24897,
     /* 1959422 */     GIR_EraseRootFromParent_Done,
     /* 1959423 */   // Label 26292: @1959423
     /* 1959423 */   GIM_Try, /*On fail goto*//*Label 26293*/ GIMT_Encode4(1959509), // Rule ID 24900 //
     /* 1959428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1959439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1959442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1959445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1959448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959474 */     // MIs[0] policy
     /* 1959474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959484 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1959487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959508 */     // GIR_Coverage, 24900,
     /* 1959508 */     GIR_EraseRootFromParent_Done,
     /* 1959509 */   // Label 26293: @1959509
     /* 1959509 */   GIM_Try, /*On fail goto*//*Label 26294*/ GIMT_Encode4(1959595), // Rule ID 24901 //
     /* 1959514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1959525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1959528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1959531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1959534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959560 */     // MIs[0] policy
     /* 1959560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959570 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1959573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959594 */     // GIR_Coverage, 24901,
     /* 1959594 */     GIR_EraseRootFromParent_Done,
     /* 1959595 */   // Label 26294: @1959595
     /* 1959595 */   GIM_Try, /*On fail goto*//*Label 26295*/ GIMT_Encode4(1959681), // Rule ID 24904 //
     /* 1959600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1959611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1959614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1959617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1959620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959646 */     // MIs[0] policy
     /* 1959646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959656 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1959659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959680 */     // GIR_Coverage, 24904,
     /* 1959680 */     GIR_EraseRootFromParent_Done,
     /* 1959681 */   // Label 26295: @1959681
     /* 1959681 */   GIM_Try, /*On fail goto*//*Label 26296*/ GIMT_Encode4(1959767), // Rule ID 24905 //
     /* 1959686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1959697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1959700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1959703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1959706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959732 */     // MIs[0] policy
     /* 1959732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959742 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1959745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959766 */     // GIR_Coverage, 24905,
     /* 1959766 */     GIR_EraseRootFromParent_Done,
     /* 1959767 */   // Label 26296: @1959767
     /* 1959767 */   GIM_Try, /*On fail goto*//*Label 26297*/ GIMT_Encode4(1959853), // Rule ID 24908 //
     /* 1959772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1959775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1959783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1959786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1959789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1959792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1959795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959818 */     // MIs[0] policy
     /* 1959818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959828 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1959831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959852 */     // GIR_Coverage, 24908,
     /* 1959852 */     GIR_EraseRootFromParent_Done,
     /* 1959853 */   // Label 26297: @1959853
     /* 1959853 */   GIM_Try, /*On fail goto*//*Label 26298*/ GIMT_Encode4(1959939), // Rule ID 24909 //
     /* 1959858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1959861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1959869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1959872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1959875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1959878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1959881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959904 */     // MIs[0] policy
     /* 1959904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959914 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1959917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959938 */     // GIR_Coverage, 24909,
     /* 1959938 */     GIR_EraseRootFromParent_Done,
     /* 1959939 */   // Label 26298: @1959939
     /* 1959939 */   GIM_Try, /*On fail goto*//*Label 26299*/ GIMT_Encode4(1960025), // Rule ID 24912 //
     /* 1959944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1959947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1959955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1959958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1959961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1959964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959990 */     // MIs[0] policy
     /* 1959990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960000 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1960003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960024 */     // GIR_Coverage, 24912,
     /* 1960024 */     GIR_EraseRootFromParent_Done,
     /* 1960025 */   // Label 26299: @1960025
     /* 1960025 */   GIM_Try, /*On fail goto*//*Label 26300*/ GIMT_Encode4(1960111), // Rule ID 24913 //
     /* 1960030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1960033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1960038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1960041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1960044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1960047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1960050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960076 */     // MIs[0] policy
     /* 1960076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960086 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1960089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960110 */     // GIR_Coverage, 24913,
     /* 1960110 */     GIR_EraseRootFromParent_Done,
     /* 1960111 */   // Label 26300: @1960111
     /* 1960111 */   GIM_Try, /*On fail goto*//*Label 26301*/ GIMT_Encode4(1960197), // Rule ID 24916 //
     /* 1960116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1960119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1960124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1960127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1960130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1960133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1960136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960162 */     // MIs[0] policy
     /* 1960162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960172 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1960175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960196 */     // GIR_Coverage, 24916,
     /* 1960196 */     GIR_EraseRootFromParent_Done,
     /* 1960197 */   // Label 26301: @1960197
     /* 1960197 */   GIM_Try, /*On fail goto*//*Label 26302*/ GIMT_Encode4(1960283), // Rule ID 24917 //
     /* 1960202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1960205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1960210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1960213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1960216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1960219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1960222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960248 */     // MIs[0] policy
     /* 1960248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960258 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1960261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960282 */     // GIR_Coverage, 24917,
     /* 1960282 */     GIR_EraseRootFromParent_Done,
     /* 1960283 */   // Label 26302: @1960283
     /* 1960283 */   GIM_Try, /*On fail goto*//*Label 26303*/ GIMT_Encode4(1960369), // Rule ID 24920 //
     /* 1960288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1960299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1960302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1960305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960334 */     // MIs[0] policy
     /* 1960334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960344 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1960347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960368 */     // GIR_Coverage, 24920,
     /* 1960368 */     GIR_EraseRootFromParent_Done,
     /* 1960369 */   // Label 26303: @1960369
     /* 1960369 */   GIM_Try, /*On fail goto*//*Label 26304*/ GIMT_Encode4(1960455), // Rule ID 24921 //
     /* 1960374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1960385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1960388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1960391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960420 */     // MIs[0] policy
     /* 1960420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960430 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1960433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960454 */     // GIR_Coverage, 24921,
     /* 1960454 */     GIR_EraseRootFromParent_Done,
     /* 1960455 */   // Label 26304: @1960455
     /* 1960455 */   GIM_Try, /*On fail goto*//*Label 26305*/ GIMT_Encode4(1960541), // Rule ID 24924 //
     /* 1960460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1960471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1960474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1960477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960506 */     // MIs[0] policy
     /* 1960506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960516 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960540 */     // GIR_Coverage, 24924,
     /* 1960540 */     GIR_EraseRootFromParent_Done,
     /* 1960541 */   // Label 26305: @1960541
     /* 1960541 */   GIM_Try, /*On fail goto*//*Label 26306*/ GIMT_Encode4(1960627), // Rule ID 24925 //
     /* 1960546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1960557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1960560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1960563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960592 */     // MIs[0] policy
     /* 1960592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960602 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960626 */     // GIR_Coverage, 24925,
     /* 1960626 */     GIR_EraseRootFromParent_Done,
     /* 1960627 */   // Label 26306: @1960627
     /* 1960627 */   GIM_Try, /*On fail goto*//*Label 26307*/ GIMT_Encode4(1960713), // Rule ID 24928 //
     /* 1960632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1960643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1960646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1960649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960678 */     // MIs[0] policy
     /* 1960678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960688 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960712 */     // GIR_Coverage, 24928,
     /* 1960712 */     GIR_EraseRootFromParent_Done,
     /* 1960713 */   // Label 26307: @1960713
     /* 1960713 */   GIM_Try, /*On fail goto*//*Label 26308*/ GIMT_Encode4(1960799), // Rule ID 24929 //
     /* 1960718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1960729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1960732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1960735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960764 */     // MIs[0] policy
     /* 1960764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960774 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960798 */     // GIR_Coverage, 24929,
     /* 1960798 */     GIR_EraseRootFromParent_Done,
     /* 1960799 */   // Label 26308: @1960799
     /* 1960799 */   GIM_Try, /*On fail goto*//*Label 26309*/ GIMT_Encode4(1960885), // Rule ID 24932 //
     /* 1960804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1960815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1960818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1960821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960850 */     // MIs[0] policy
     /* 1960850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960860 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960884 */     // GIR_Coverage, 24932,
     /* 1960884 */     GIR_EraseRootFromParent_Done,
     /* 1960885 */   // Label 26309: @1960885
     /* 1960885 */   GIM_Try, /*On fail goto*//*Label 26310*/ GIMT_Encode4(1960971), // Rule ID 24933 //
     /* 1960890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1960901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1960904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1960907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960936 */     // MIs[0] policy
     /* 1960936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960946 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960970 */     // GIR_Coverage, 24933,
     /* 1960970 */     GIR_EraseRootFromParent_Done,
     /* 1960971 */   // Label 26310: @1960971
     /* 1960971 */   GIM_Try, /*On fail goto*//*Label 26311*/ GIMT_Encode4(1961057), // Rule ID 24936 //
     /* 1960976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1960987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1960990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1960993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961022 */     // MIs[0] policy
     /* 1961022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961032 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1961035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961056 */     // GIR_Coverage, 24936,
     /* 1961056 */     GIR_EraseRootFromParent_Done,
     /* 1961057 */   // Label 26311: @1961057
     /* 1961057 */   GIM_Try, /*On fail goto*//*Label 26312*/ GIMT_Encode4(1961143), // Rule ID 24937 //
     /* 1961062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1961073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1961076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1961079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961108 */     // MIs[0] policy
     /* 1961108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961118 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1961121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961142 */     // GIR_Coverage, 24937,
     /* 1961142 */     GIR_EraseRootFromParent_Done,
     /* 1961143 */   // Label 26312: @1961143
     /* 1961143 */   GIM_Try, /*On fail goto*//*Label 26313*/ GIMT_Encode4(1961229), // Rule ID 24940 //
     /* 1961148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1961151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1961159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1961162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1961165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961194 */     // MIs[0] policy
     /* 1961194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961204 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1961207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961228 */     // GIR_Coverage, 24940,
     /* 1961228 */     GIR_EraseRootFromParent_Done,
     /* 1961229 */   // Label 26313: @1961229
     /* 1961229 */   GIM_Try, /*On fail goto*//*Label 26314*/ GIMT_Encode4(1961315), // Rule ID 24941 //
     /* 1961234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1961237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1961245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1961248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1961251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961280 */     // MIs[0] policy
     /* 1961280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961290 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1961293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961314 */     // GIR_Coverage, 24941,
     /* 1961314 */     GIR_EraseRootFromParent_Done,
     /* 1961315 */   // Label 26314: @1961315
     /* 1961315 */   GIM_Try, /*On fail goto*//*Label 26315*/ GIMT_Encode4(1961401), // Rule ID 24944 //
     /* 1961320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1961331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1961334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1961337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961366 */     // MIs[0] policy
     /* 1961366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961376 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961400 */     // GIR_Coverage, 24944,
     /* 1961400 */     GIR_EraseRootFromParent_Done,
     /* 1961401 */   // Label 26315: @1961401
     /* 1961401 */   GIM_Try, /*On fail goto*//*Label 26316*/ GIMT_Encode4(1961487), // Rule ID 24945 //
     /* 1961406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1961417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1961420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1961423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961452 */     // MIs[0] policy
     /* 1961452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961462 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961486 */     // GIR_Coverage, 24945,
     /* 1961486 */     GIR_EraseRootFromParent_Done,
     /* 1961487 */   // Label 26316: @1961487
     /* 1961487 */   GIM_Try, /*On fail goto*//*Label 26317*/ GIMT_Encode4(1961573), // Rule ID 24948 //
     /* 1961492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1961503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1961506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1961509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961538 */     // MIs[0] policy
     /* 1961538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961548 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1961551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961572 */     // GIR_Coverage, 24948,
     /* 1961572 */     GIR_EraseRootFromParent_Done,
     /* 1961573 */   // Label 26317: @1961573
     /* 1961573 */   GIM_Try, /*On fail goto*//*Label 26318*/ GIMT_Encode4(1961659), // Rule ID 24949 //
     /* 1961578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1961589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1961592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1961595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961624 */     // MIs[0] policy
     /* 1961624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961634 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1961637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961658 */     // GIR_Coverage, 24949,
     /* 1961658 */     GIR_EraseRootFromParent_Done,
     /* 1961659 */   // Label 26318: @1961659
     /* 1961659 */   GIM_Try, /*On fail goto*//*Label 26319*/ GIMT_Encode4(1961745), // Rule ID 24952 //
     /* 1961664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1961675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1961678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1961681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1961687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961710 */     // MIs[0] policy
     /* 1961710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961720 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1961723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961744 */     // GIR_Coverage, 24952,
     /* 1961744 */     GIR_EraseRootFromParent_Done,
     /* 1961745 */   // Label 26319: @1961745
     /* 1961745 */   GIM_Try, /*On fail goto*//*Label 26320*/ GIMT_Encode4(1961831), // Rule ID 24953 //
     /* 1961750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1961761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1961764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1961767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1961773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961796 */     // MIs[0] policy
     /* 1961796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961806 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1961809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961830 */     // GIR_Coverage, 24953,
     /* 1961830 */     GIR_EraseRootFromParent_Done,
     /* 1961831 */   // Label 26320: @1961831
     /* 1961831 */   GIM_Try, /*On fail goto*//*Label 26321*/ GIMT_Encode4(1961917), // Rule ID 24956 //
     /* 1961836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1961847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1961850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1961853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961882 */     // MIs[0] policy
     /* 1961882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961892 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961916 */     // GIR_Coverage, 24956,
     /* 1961916 */     GIR_EraseRootFromParent_Done,
     /* 1961917 */   // Label 26321: @1961917
     /* 1961917 */   GIM_Try, /*On fail goto*//*Label 26322*/ GIMT_Encode4(1962003), // Rule ID 24957 //
     /* 1961922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1961933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1961936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1961939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961968 */     // MIs[0] policy
     /* 1961968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961978 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962002 */     // GIR_Coverage, 24957,
     /* 1962002 */     GIR_EraseRootFromParent_Done,
     /* 1962003 */   // Label 26322: @1962003
     /* 1962003 */   GIM_Try, /*On fail goto*//*Label 26323*/ GIMT_Encode4(1962089), // Rule ID 24960 //
     /* 1962008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1962019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1962022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1962025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962054 */     // MIs[0] policy
     /* 1962054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962064 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1962067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962088 */     // GIR_Coverage, 24960,
     /* 1962088 */     GIR_EraseRootFromParent_Done,
     /* 1962089 */   // Label 26323: @1962089
     /* 1962089 */   GIM_Try, /*On fail goto*//*Label 26324*/ GIMT_Encode4(1962175), // Rule ID 24961 //
     /* 1962094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1962105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1962108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1962111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962140 */     // MIs[0] policy
     /* 1962140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962150 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1962153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962174 */     // GIR_Coverage, 24961,
     /* 1962174 */     GIR_EraseRootFromParent_Done,
     /* 1962175 */   // Label 26324: @1962175
     /* 1962175 */   GIM_Try, /*On fail goto*//*Label 26325*/ GIMT_Encode4(1962261), // Rule ID 24964 //
     /* 1962180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1962191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1962194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1962197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1962203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962226 */     // MIs[0] policy
     /* 1962226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962236 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1962239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962260 */     // GIR_Coverage, 24964,
     /* 1962260 */     GIR_EraseRootFromParent_Done,
     /* 1962261 */   // Label 26325: @1962261
     /* 1962261 */   GIM_Try, /*On fail goto*//*Label 26326*/ GIMT_Encode4(1962347), // Rule ID 24965 //
     /* 1962266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1962277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1962280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1962283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1962289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962312 */     // MIs[0] policy
     /* 1962312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962322 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1962325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962346 */     // GIR_Coverage, 24965,
     /* 1962346 */     GIR_EraseRootFromParent_Done,
     /* 1962347 */   // Label 26326: @1962347
     /* 1962347 */   GIM_Try, /*On fail goto*//*Label 26327*/ GIMT_Encode4(1962433), // Rule ID 24968 //
     /* 1962352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1962355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1962363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1962366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1962369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1962382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962398 */     // MIs[0] policy
     /* 1962398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962408 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1962411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962432 */     // GIR_Coverage, 24968,
     /* 1962432 */     GIR_EraseRootFromParent_Done,
     /* 1962433 */   // Label 26327: @1962433
     /* 1962433 */   GIM_Try, /*On fail goto*//*Label 26328*/ GIMT_Encode4(1962519), // Rule ID 24969 //
     /* 1962438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1962441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1962449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1962452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1962455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1962468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962484 */     // MIs[0] policy
     /* 1962484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962494 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1962497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962518 */     // GIR_Coverage, 24969,
     /* 1962518 */     GIR_EraseRootFromParent_Done,
     /* 1962519 */   // Label 26328: @1962519
     /* 1962519 */   GIM_Try, /*On fail goto*//*Label 26329*/ GIMT_Encode4(1962605), // Rule ID 24972 //
     /* 1962524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1962527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1962535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1962538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1962541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962570 */     // MIs[0] policy
     /* 1962570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962580 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1962583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962604 */     // GIR_Coverage, 24972,
     /* 1962604 */     GIR_EraseRootFromParent_Done,
     /* 1962605 */   // Label 26329: @1962605
     /* 1962605 */   GIM_Try, /*On fail goto*//*Label 26330*/ GIMT_Encode4(1962691), // Rule ID 24973 //
     /* 1962610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1962613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1962621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1962624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1962627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962656 */     // MIs[0] policy
     /* 1962656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962666 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1962669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962690 */     // GIR_Coverage, 24973,
     /* 1962690 */     GIR_EraseRootFromParent_Done,
     /* 1962691 */   // Label 26330: @1962691
     /* 1962691 */   GIM_Try, /*On fail goto*//*Label 26331*/ GIMT_Encode4(1962777), // Rule ID 24976 //
     /* 1962696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1962699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1962707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1962710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1962713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962742 */     // MIs[0] policy
     /* 1962742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962752 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1962755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962776 */     // GIR_Coverage, 24976,
     /* 1962776 */     GIR_EraseRootFromParent_Done,
     /* 1962777 */   // Label 26331: @1962777
     /* 1962777 */   GIM_Try, /*On fail goto*//*Label 26332*/ GIMT_Encode4(1962863), // Rule ID 24977 //
     /* 1962782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1962785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1962793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1962796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1962799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962828 */     // MIs[0] policy
     /* 1962828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962838 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1962841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962862 */     // GIR_Coverage, 24977,
     /* 1962862 */     GIR_EraseRootFromParent_Done,
     /* 1962863 */   // Label 26332: @1962863
     /* 1962863 */   GIM_Try, /*On fail goto*//*Label 26333*/ GIMT_Encode4(1962949), // Rule ID 25040 //
     /* 1962868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1962879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1962882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1962885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1962888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962914 */     // MIs[0] policy
     /* 1962914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962924 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1962927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962948 */     // GIR_Coverage, 25040,
     /* 1962948 */     GIR_EraseRootFromParent_Done,
     /* 1962949 */   // Label 26333: @1962949
     /* 1962949 */   GIM_Try, /*On fail goto*//*Label 26334*/ GIMT_Encode4(1963035), // Rule ID 25041 //
     /* 1962954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1962965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1962968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1962971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1962974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963000 */     // MIs[0] policy
     /* 1963000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963010 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1963013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963034 */     // GIR_Coverage, 25041,
     /* 1963034 */     GIR_EraseRootFromParent_Done,
     /* 1963035 */   // Label 26334: @1963035
     /* 1963035 */   GIM_Try, /*On fail goto*//*Label 26335*/ GIMT_Encode4(1963121), // Rule ID 25044 //
     /* 1963040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1963051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1963054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1963057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963086 */     // MIs[0] policy
     /* 1963086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963096 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1963099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963120 */     // GIR_Coverage, 25044,
     /* 1963120 */     GIR_EraseRootFromParent_Done,
     /* 1963121 */   // Label 26335: @1963121
     /* 1963121 */   GIM_Try, /*On fail goto*//*Label 26336*/ GIMT_Encode4(1963207), // Rule ID 25045 //
     /* 1963126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1963137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1963140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1963143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963172 */     // MIs[0] policy
     /* 1963172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963182 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1963185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963206 */     // GIR_Coverage, 25045,
     /* 1963206 */     GIR_EraseRootFromParent_Done,
     /* 1963207 */   // Label 26336: @1963207
     /* 1963207 */   GIM_Try, /*On fail goto*//*Label 26337*/ GIMT_Encode4(1963293), // Rule ID 25048 //
     /* 1963212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1963223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1963226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1963229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963258 */     // MIs[0] policy
     /* 1963258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963268 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1963271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963292 */     // GIR_Coverage, 25048,
     /* 1963292 */     GIR_EraseRootFromParent_Done,
     /* 1963293 */   // Label 26337: @1963293
     /* 1963293 */   GIM_Try, /*On fail goto*//*Label 26338*/ GIMT_Encode4(1963379), // Rule ID 25049 //
     /* 1963298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1963309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1963312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1963315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963344 */     // MIs[0] policy
     /* 1963344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963354 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1963357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963378 */     // GIR_Coverage, 25049,
     /* 1963378 */     GIR_EraseRootFromParent_Done,
     /* 1963379 */   // Label 26338: @1963379
     /* 1963379 */   GIM_Try, /*On fail goto*//*Label 26339*/ GIMT_Encode4(1963465), // Rule ID 25052 //
     /* 1963384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1963395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1963398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1963401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1963404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963430 */     // MIs[0] policy
     /* 1963430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963440 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1963443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963464 */     // GIR_Coverage, 25052,
     /* 1963464 */     GIR_EraseRootFromParent_Done,
     /* 1963465 */   // Label 26339: @1963465
     /* 1963465 */   GIM_Try, /*On fail goto*//*Label 26340*/ GIMT_Encode4(1963551), // Rule ID 25053 //
     /* 1963470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1963481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1963484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1963487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1963490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963516 */     // MIs[0] policy
     /* 1963516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963526 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1963529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963550 */     // GIR_Coverage, 25053,
     /* 1963550 */     GIR_EraseRootFromParent_Done,
     /* 1963551 */   // Label 26340: @1963551
     /* 1963551 */   GIM_Try, /*On fail goto*//*Label 26341*/ GIMT_Encode4(1963637), // Rule ID 25056 //
     /* 1963556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1963567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1963570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1963573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963602 */     // MIs[0] policy
     /* 1963602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963612 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1963615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963636 */     // GIR_Coverage, 25056,
     /* 1963636 */     GIR_EraseRootFromParent_Done,
     /* 1963637 */   // Label 26341: @1963637
     /* 1963637 */   GIM_Try, /*On fail goto*//*Label 26342*/ GIMT_Encode4(1963723), // Rule ID 25057 //
     /* 1963642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1963653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1963656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1963659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963688 */     // MIs[0] policy
     /* 1963688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963698 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1963701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963722 */     // GIR_Coverage, 25057,
     /* 1963722 */     GIR_EraseRootFromParent_Done,
     /* 1963723 */   // Label 26342: @1963723
     /* 1963723 */   GIM_Try, /*On fail goto*//*Label 26343*/ GIMT_Encode4(1963809), // Rule ID 25060 //
     /* 1963728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1963731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1963739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1963742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1963745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963774 */     // MIs[0] policy
     /* 1963774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963784 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1963787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963808 */     // GIR_Coverage, 25060,
     /* 1963808 */     GIR_EraseRootFromParent_Done,
     /* 1963809 */   // Label 26343: @1963809
     /* 1963809 */   GIM_Try, /*On fail goto*//*Label 26344*/ GIMT_Encode4(1963895), // Rule ID 25061 //
     /* 1963814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1963817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1963825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1963828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1963831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963860 */     // MIs[0] policy
     /* 1963860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963870 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1963873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963894 */     // GIR_Coverage, 25061,
     /* 1963894 */     GIR_EraseRootFromParent_Done,
     /* 1963895 */   // Label 26344: @1963895
     /* 1963895 */   GIM_Try, /*On fail goto*//*Label 26345*/ GIMT_Encode4(1963981), // Rule ID 25064 //
     /* 1963900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1963911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1963914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1963917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1963920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963946 */     // MIs[0] policy
     /* 1963946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963956 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1963959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963980 */     // GIR_Coverage, 25064,
     /* 1963980 */     GIR_EraseRootFromParent_Done,
     /* 1963981 */   // Label 26345: @1963981
     /* 1963981 */   GIM_Try, /*On fail goto*//*Label 26346*/ GIMT_Encode4(1964067), // Rule ID 25065 //
     /* 1963986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1963997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1964000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1964003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964032 */     // MIs[0] policy
     /* 1964032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964042 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1964045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964066 */     // GIR_Coverage, 25065,
     /* 1964066 */     GIR_EraseRootFromParent_Done,
     /* 1964067 */   // Label 26346: @1964067
     /* 1964067 */   GIM_Try, /*On fail goto*//*Label 26347*/ GIMT_Encode4(1964153), // Rule ID 25068 //
     /* 1964072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1964083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1964086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1964089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964118 */     // MIs[0] policy
     /* 1964118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964128 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1964131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964152 */     // GIR_Coverage, 25068,
     /* 1964152 */     GIR_EraseRootFromParent_Done,
     /* 1964153 */   // Label 26347: @1964153
     /* 1964153 */   GIM_Try, /*On fail goto*//*Label 26348*/ GIMT_Encode4(1964239), // Rule ID 25069 //
     /* 1964158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1964169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1964172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1964175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964204 */     // MIs[0] policy
     /* 1964204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964214 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1964217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964238 */     // GIR_Coverage, 25069,
     /* 1964238 */     GIR_EraseRootFromParent_Done,
     /* 1964239 */   // Label 26348: @1964239
     /* 1964239 */   GIM_Try, /*On fail goto*//*Label 26349*/ GIMT_Encode4(1964325), // Rule ID 25072 //
     /* 1964244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1964255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1964258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1964261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1964264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1964267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964290 */     // MIs[0] policy
     /* 1964290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964300 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1964303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964324 */     // GIR_Coverage, 25072,
     /* 1964324 */     GIR_EraseRootFromParent_Done,
     /* 1964325 */   // Label 26349: @1964325
     /* 1964325 */   GIM_Try, /*On fail goto*//*Label 26350*/ GIMT_Encode4(1964411), // Rule ID 25073 //
     /* 1964330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1964341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1964344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1964347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1964350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1964353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964376 */     // MIs[0] policy
     /* 1964376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964386 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1964389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964410 */     // GIR_Coverage, 25073,
     /* 1964410 */     GIR_EraseRootFromParent_Done,
     /* 1964411 */   // Label 26350: @1964411
     /* 1964411 */   GIM_Try, /*On fail goto*//*Label 26351*/ GIMT_Encode4(1964497), // Rule ID 25076 //
     /* 1964416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1964427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1964430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1964433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964462 */     // MIs[0] policy
     /* 1964462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964472 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1964475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964496 */     // GIR_Coverage, 25076,
     /* 1964496 */     GIR_EraseRootFromParent_Done,
     /* 1964497 */   // Label 26351: @1964497
     /* 1964497 */   GIM_Try, /*On fail goto*//*Label 26352*/ GIMT_Encode4(1964583), // Rule ID 25077 //
     /* 1964502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1964513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1964516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1964519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964548 */     // MIs[0] policy
     /* 1964548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964558 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1964561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964582 */     // GIR_Coverage, 25077,
     /* 1964582 */     GIR_EraseRootFromParent_Done,
     /* 1964583 */   // Label 26352: @1964583
     /* 1964583 */   GIM_Try, /*On fail goto*//*Label 26353*/ GIMT_Encode4(1964669), // Rule ID 25080 //
     /* 1964588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1964599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1964602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1964605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964634 */     // MIs[0] policy
     /* 1964634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964644 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1964647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964668 */     // GIR_Coverage, 25080,
     /* 1964668 */     GIR_EraseRootFromParent_Done,
     /* 1964669 */   // Label 26353: @1964669
     /* 1964669 */   GIM_Try, /*On fail goto*//*Label 26354*/ GIMT_Encode4(1964755), // Rule ID 25081 //
     /* 1964674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1964685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1964688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1964691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964720 */     // MIs[0] policy
     /* 1964720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964730 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1964733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964754 */     // GIR_Coverage, 25081,
     /* 1964754 */     GIR_EraseRootFromParent_Done,
     /* 1964755 */   // Label 26354: @1964755
     /* 1964755 */   GIM_Try, /*On fail goto*//*Label 26355*/ GIMT_Encode4(1964841), // Rule ID 25084 //
     /* 1964760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1964771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1964774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1964777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964806 */     // MIs[0] policy
     /* 1964806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964816 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1964819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964840 */     // GIR_Coverage, 25084,
     /* 1964840 */     GIR_EraseRootFromParent_Done,
     /* 1964841 */   // Label 26355: @1964841
     /* 1964841 */   GIM_Try, /*On fail goto*//*Label 26356*/ GIMT_Encode4(1964927), // Rule ID 25085 //
     /* 1964846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1964857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1964860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1964863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964892 */     // MIs[0] policy
     /* 1964892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964902 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1964905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964926 */     // GIR_Coverage, 25085,
     /* 1964926 */     GIR_EraseRootFromParent_Done,
     /* 1964927 */   // Label 26356: @1964927
     /* 1964927 */   GIM_Try, /*On fail goto*//*Label 26357*/ GIMT_Encode4(1965013), // Rule ID 25088 //
     /* 1964932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1964935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1964943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1964946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1964949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1964952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964978 */     // MIs[0] policy
     /* 1964978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964988 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1964991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965012 */     // GIR_Coverage, 25088,
     /* 1965012 */     GIR_EraseRootFromParent_Done,
     /* 1965013 */   // Label 26357: @1965013
     /* 1965013 */   GIM_Try, /*On fail goto*//*Label 26358*/ GIMT_Encode4(1965099), // Rule ID 25089 //
     /* 1965018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1965021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1965026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1965029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1965032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1965035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1965038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965064 */     // MIs[0] policy
     /* 1965064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965074 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1965077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965098 */     // GIR_Coverage, 25089,
     /* 1965098 */     GIR_EraseRootFromParent_Done,
     /* 1965099 */   // Label 26358: @1965099
     /* 1965099 */   GIM_Try, /*On fail goto*//*Label 26359*/ GIMT_Encode4(1965185), // Rule ID 25092 //
     /* 1965104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1965107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1965112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1965115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1965118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1965121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1965124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965150 */     // MIs[0] policy
     /* 1965150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965160 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1965163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965184 */     // GIR_Coverage, 25092,
     /* 1965184 */     GIR_EraseRootFromParent_Done,
     /* 1965185 */   // Label 26359: @1965185
     /* 1965185 */   GIM_Try, /*On fail goto*//*Label 26360*/ GIMT_Encode4(1965271), // Rule ID 25093 //
     /* 1965190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1965193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1965198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1965201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1965204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1965207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1965210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965236 */     // MIs[0] policy
     /* 1965236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965246 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1965249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965270 */     // GIR_Coverage, 25093,
     /* 1965270 */     GIR_EraseRootFromParent_Done,
     /* 1965271 */   // Label 26360: @1965271
     /* 1965271 */   GIM_Try, /*On fail goto*//*Label 26361*/ GIMT_Encode4(1965357), // Rule ID 25096 //
     /* 1965276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1965279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1965284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1965287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1965290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1965293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1965296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965322 */     // MIs[0] policy
     /* 1965322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965332 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1965335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965356 */     // GIR_Coverage, 25096,
     /* 1965356 */     GIR_EraseRootFromParent_Done,
     /* 1965357 */   // Label 26361: @1965357
     /* 1965357 */   GIM_Try, /*On fail goto*//*Label 26362*/ GIMT_Encode4(1965443), // Rule ID 25097 //
     /* 1965362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1965365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1965370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1965373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1965376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1965379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1965382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965408 */     // MIs[0] policy
     /* 1965408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965418 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1965421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965442 */     // GIR_Coverage, 25097,
     /* 1965442 */     GIR_EraseRootFromParent_Done,
     /* 1965443 */   // Label 26362: @1965443
     /* 1965443 */   GIM_Try, /*On fail goto*//*Label 26363*/ GIMT_Encode4(1965529), // Rule ID 60984 //
     /* 1965448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1965459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1965465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1965468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965494 */     // MIs[0] policy
     /* 1965494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965504 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1965507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965528 */     // GIR_Coverage, 60984,
     /* 1965528 */     GIR_EraseRootFromParent_Done,
     /* 1965529 */   // Label 26363: @1965529
     /* 1965529 */   GIM_Try, /*On fail goto*//*Label 26364*/ GIMT_Encode4(1965615), // Rule ID 60985 //
     /* 1965534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1965545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1965551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1965554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965580 */     // MIs[0] policy
     /* 1965580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965590 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1965593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965614 */     // GIR_Coverage, 60985,
     /* 1965614 */     GIR_EraseRootFromParent_Done,
     /* 1965615 */   // Label 26364: @1965615
     /* 1965615 */   GIM_Try, /*On fail goto*//*Label 26365*/ GIMT_Encode4(1965701), // Rule ID 60988 //
     /* 1965620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1965637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1965640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965666 */     // MIs[0] policy
     /* 1965666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965676 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1965679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965700 */     // GIR_Coverage, 60988,
     /* 1965700 */     GIR_EraseRootFromParent_Done,
     /* 1965701 */   // Label 26365: @1965701
     /* 1965701 */   GIM_Try, /*On fail goto*//*Label 26366*/ GIMT_Encode4(1965787), // Rule ID 60989 //
     /* 1965706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1965723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1965726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965752 */     // MIs[0] policy
     /* 1965752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965762 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1965765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965786 */     // GIR_Coverage, 60989,
     /* 1965786 */     GIR_EraseRootFromParent_Done,
     /* 1965787 */   // Label 26366: @1965787
     /* 1965787 */   GIM_Try, /*On fail goto*//*Label 26367*/ GIMT_Encode4(1965873), // Rule ID 60992 //
     /* 1965792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1965809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1965812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965838 */     // MIs[0] policy
     /* 1965838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965848 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1965851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965872 */     // GIR_Coverage, 60992,
     /* 1965872 */     GIR_EraseRootFromParent_Done,
     /* 1965873 */   // Label 26367: @1965873
     /* 1965873 */   GIM_Try, /*On fail goto*//*Label 26368*/ GIMT_Encode4(1965959), // Rule ID 60993 //
     /* 1965878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1965895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1965898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965924 */     // MIs[0] policy
     /* 1965924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965934 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1965937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965958 */     // GIR_Coverage, 60993,
     /* 1965958 */     GIR_EraseRootFromParent_Done,
     /* 1965959 */   // Label 26368: @1965959
     /* 1965959 */   GIM_Try, /*On fail goto*//*Label 26369*/ GIMT_Encode4(1966045), // Rule ID 60996 //
     /* 1965964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1965975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1965978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1965981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1965984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966010 */     // MIs[0] policy
     /* 1966010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1966023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966044 */     // GIR_Coverage, 60996,
     /* 1966044 */     GIR_EraseRootFromParent_Done,
     /* 1966045 */   // Label 26369: @1966045
     /* 1966045 */   GIM_Try, /*On fail goto*//*Label 26370*/ GIMT_Encode4(1966131), // Rule ID 60997 //
     /* 1966050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1966061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1966064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1966067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1966070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1966073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966096 */     // MIs[0] policy
     /* 1966096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966106 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1966109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966130 */     // GIR_Coverage, 60997,
     /* 1966130 */     GIR_EraseRootFromParent_Done,
     /* 1966131 */   // Label 26370: @1966131
     /* 1966131 */   GIM_Try, /*On fail goto*//*Label 26371*/ GIMT_Encode4(1966217), // Rule ID 61000 //
     /* 1966136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1966147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1966150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1966153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1966156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966182 */     // MIs[0] policy
     /* 1966182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966192 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1966195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966216 */     // GIR_Coverage, 61000,
     /* 1966216 */     GIR_EraseRootFromParent_Done,
     /* 1966217 */   // Label 26371: @1966217
     /* 1966217 */   GIM_Try, /*On fail goto*//*Label 26372*/ GIMT_Encode4(1966303), // Rule ID 61001 //
     /* 1966222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1966233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1966236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1966239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1966242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966268 */     // MIs[0] policy
     /* 1966268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966278 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1966281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966302 */     // GIR_Coverage, 61001,
     /* 1966302 */     GIR_EraseRootFromParent_Done,
     /* 1966303 */   // Label 26372: @1966303
     /* 1966303 */   GIM_Try, /*On fail goto*//*Label 26373*/ GIMT_Encode4(1966389), // Rule ID 61004 //
     /* 1966308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1966319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1966322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1966325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1966328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1966331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966354 */     // MIs[0] policy
     /* 1966354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966364 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1966367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966388 */     // GIR_Coverage, 61004,
     /* 1966388 */     GIR_EraseRootFromParent_Done,
     /* 1966389 */   // Label 26373: @1966389
     /* 1966389 */   GIM_Try, /*On fail goto*//*Label 26374*/ GIMT_Encode4(1966475), // Rule ID 61005 //
     /* 1966394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1966405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1966408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1966411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1966414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1966417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966440 */     // MIs[0] policy
     /* 1966440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966450 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1966453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966474 */     // GIR_Coverage, 61005,
     /* 1966474 */     GIR_EraseRootFromParent_Done,
     /* 1966475 */   // Label 26374: @1966475
     /* 1966475 */   GIM_Try, /*On fail goto*//*Label 26375*/ GIMT_Encode4(1966561), // Rule ID 61008 //
     /* 1966480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1966491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1966494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966526 */     // MIs[0] policy
     /* 1966526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966536 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1966539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966560 */     // GIR_Coverage, 61008,
     /* 1966560 */     GIR_EraseRootFromParent_Done,
     /* 1966561 */   // Label 26375: @1966561
     /* 1966561 */   GIM_Try, /*On fail goto*//*Label 26376*/ GIMT_Encode4(1966647), // Rule ID 61009 //
     /* 1966566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1966577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1966580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966612 */     // MIs[0] policy
     /* 1966612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966622 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1966625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966646 */     // GIR_Coverage, 61009,
     /* 1966646 */     GIR_EraseRootFromParent_Done,
     /* 1966647 */   // Label 26376: @1966647
     /* 1966647 */   GIM_Try, /*On fail goto*//*Label 26377*/ GIMT_Encode4(1966733), // Rule ID 61012 //
     /* 1966652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1966669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1966672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966698 */     // MIs[0] policy
     /* 1966698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966708 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1966711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966732 */     // GIR_Coverage, 61012,
     /* 1966732 */     GIR_EraseRootFromParent_Done,
     /* 1966733 */   // Label 26377: @1966733
     /* 1966733 */   GIM_Try, /*On fail goto*//*Label 26378*/ GIMT_Encode4(1966819), // Rule ID 61013 //
     /* 1966738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1966755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1966758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966784 */     // MIs[0] policy
     /* 1966784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966794 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1966797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966818 */     // GIR_Coverage, 61013,
     /* 1966818 */     GIR_EraseRootFromParent_Done,
     /* 1966819 */   // Label 26378: @1966819
     /* 1966819 */   GIM_Try, /*On fail goto*//*Label 26379*/ GIMT_Encode4(1966905), // Rule ID 61016 //
     /* 1966824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1966835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1966838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1966844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966870 */     // MIs[0] policy
     /* 1966870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1966883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966904 */     // GIR_Coverage, 61016,
     /* 1966904 */     GIR_EraseRootFromParent_Done,
     /* 1966905 */   // Label 26379: @1966905
     /* 1966905 */   GIM_Try, /*On fail goto*//*Label 26380*/ GIMT_Encode4(1966991), // Rule ID 61017 //
     /* 1966910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1966921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1966924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1966930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966956 */     // MIs[0] policy
     /* 1966956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1966969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966990 */     // GIR_Coverage, 61017,
     /* 1966990 */     GIR_EraseRootFromParent_Done,
     /* 1966991 */   // Label 26380: @1966991
     /* 1966991 */   GIM_Try, /*On fail goto*//*Label 26381*/ GIMT_Encode4(1967077), // Rule ID 61020 //
     /* 1966996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1967007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1967010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1967013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1967016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967042 */     // MIs[0] policy
     /* 1967042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967052 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1967055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967076 */     // GIR_Coverage, 61020,
     /* 1967076 */     GIR_EraseRootFromParent_Done,
     /* 1967077 */   // Label 26381: @1967077
     /* 1967077 */   GIM_Try, /*On fail goto*//*Label 26382*/ GIMT_Encode4(1967163), // Rule ID 61021 //
     /* 1967082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1967093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1967096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1967099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1967102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967128 */     // MIs[0] policy
     /* 1967128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967138 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1967141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967162 */     // GIR_Coverage, 61021,
     /* 1967162 */     GIR_EraseRootFromParent_Done,
     /* 1967163 */   // Label 26382: @1967163
     /* 1967163 */   GIM_Try, /*On fail goto*//*Label 26383*/ GIMT_Encode4(1967249), // Rule ID 61024 //
     /* 1967168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1967179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1967182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1967185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1967188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1967191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967214 */     // MIs[0] policy
     /* 1967214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967224 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1967227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967248 */     // GIR_Coverage, 61024,
     /* 1967248 */     GIR_EraseRootFromParent_Done,
     /* 1967249 */   // Label 26383: @1967249
     /* 1967249 */   GIM_Try, /*On fail goto*//*Label 26384*/ GIMT_Encode4(1967335), // Rule ID 61025 //
     /* 1967254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1967265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1967268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1967271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1967274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1967277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967300 */     // MIs[0] policy
     /* 1967300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967310 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1967313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967334 */     // GIR_Coverage, 61025,
     /* 1967334 */     GIR_EraseRootFromParent_Done,
     /* 1967335 */   // Label 26384: @1967335
     /* 1967335 */   GIM_Try, /*On fail goto*//*Label 26385*/ GIMT_Encode4(1967421), // Rule ID 61028 //
     /* 1967340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1967354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1967357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1967360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967386 */     // MIs[0] policy
     /* 1967386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967396 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1967399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967420 */     // GIR_Coverage, 61028,
     /* 1967420 */     GIR_EraseRootFromParent_Done,
     /* 1967421 */   // Label 26385: @1967421
     /* 1967421 */   GIM_Try, /*On fail goto*//*Label 26386*/ GIMT_Encode4(1967507), // Rule ID 61029 //
     /* 1967426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1967440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1967443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1967446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967472 */     // MIs[0] policy
     /* 1967472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1967485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967506 */     // GIR_Coverage, 61029,
     /* 1967506 */     GIR_EraseRootFromParent_Done,
     /* 1967507 */   // Label 26386: @1967507
     /* 1967507 */   GIM_Try, /*On fail goto*//*Label 26387*/ GIMT_Encode4(1967593), // Rule ID 61032 //
     /* 1967512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1967523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1967526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1967532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967558 */     // MIs[0] policy
     /* 1967558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1967571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967592 */     // GIR_Coverage, 61032,
     /* 1967592 */     GIR_EraseRootFromParent_Done,
     /* 1967593 */   // Label 26387: @1967593
     /* 1967593 */   GIM_Try, /*On fail goto*//*Label 26388*/ GIMT_Encode4(1967679), // Rule ID 61033 //
     /* 1967598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1967609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1967612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1967618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967644 */     // MIs[0] policy
     /* 1967644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1967657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967678 */     // GIR_Coverage, 61033,
     /* 1967678 */     GIR_EraseRootFromParent_Done,
     /* 1967679 */   // Label 26388: @1967679
     /* 1967679 */   GIM_Try, /*On fail goto*//*Label 26389*/ GIMT_Encode4(1967765), // Rule ID 61036 //
     /* 1967684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1967695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1967698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1967704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967730 */     // MIs[0] policy
     /* 1967730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967740 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1967743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967764 */     // GIR_Coverage, 61036,
     /* 1967764 */     GIR_EraseRootFromParent_Done,
     /* 1967765 */   // Label 26389: @1967765
     /* 1967765 */   GIM_Try, /*On fail goto*//*Label 26390*/ GIMT_Encode4(1967851), // Rule ID 61037 //
     /* 1967770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1967781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1967784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1967790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967816 */     // MIs[0] policy
     /* 1967816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967826 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1967829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967850 */     // GIR_Coverage, 61037,
     /* 1967850 */     GIR_EraseRootFromParent_Done,
     /* 1967851 */   // Label 26390: @1967851
     /* 1967851 */   GIM_Try, /*On fail goto*//*Label 26391*/ GIMT_Encode4(1967937), // Rule ID 61040 //
     /* 1967856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1967867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1967870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1967876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967902 */     // MIs[0] policy
     /* 1967902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967912 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1967915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967936 */     // GIR_Coverage, 61040,
     /* 1967936 */     GIR_EraseRootFromParent_Done,
     /* 1967937 */   // Label 26391: @1967937
     /* 1967937 */   GIM_Try, /*On fail goto*//*Label 26392*/ GIMT_Encode4(1968023), // Rule ID 61041 //
     /* 1967942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1967953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1967956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1967962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967988 */     // MIs[0] policy
     /* 1967988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967998 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1968001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1968019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968022 */     // GIR_Coverage, 61041,
     /* 1968022 */     GIR_EraseRootFromParent_Done,
     /* 1968023 */   // Label 26392: @1968023
     /* 1968023 */   GIM_Try, /*On fail goto*//*Label 26393*/ GIMT_Encode4(1968109), // Rule ID 61044 //
     /* 1968028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1968039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1968042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1968045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968074 */     // MIs[0] policy
     /* 1968074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1968087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968108 */     // GIR_Coverage, 61044,
     /* 1968108 */     GIR_EraseRootFromParent_Done,
     /* 1968109 */   // Label 26393: @1968109
     /* 1968109 */   GIM_Try, /*On fail goto*//*Label 26394*/ GIMT_Encode4(1968195), // Rule ID 61045 //
     /* 1968114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1968125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1968128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1968131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968160 */     // MIs[0] policy
     /* 1968160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968170 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1968173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968194 */     // GIR_Coverage, 61045,
     /* 1968194 */     GIR_EraseRootFromParent_Done,
     /* 1968195 */   // Label 26394: @1968195
     /* 1968195 */   GIM_Try, /*On fail goto*//*Label 26395*/ GIMT_Encode4(1968281), // Rule ID 61052 //
     /* 1968200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1968211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1968214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1968217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968246 */     // MIs[0] policy
     /* 1968246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968256 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1968259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968280 */     // GIR_Coverage, 61052,
     /* 1968280 */     GIR_EraseRootFromParent_Done,
     /* 1968281 */   // Label 26395: @1968281
     /* 1968281 */   GIM_Try, /*On fail goto*//*Label 26396*/ GIMT_Encode4(1968367), // Rule ID 61053 //
     /* 1968286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1968297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1968300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1968303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968332 */     // MIs[0] policy
     /* 1968332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968342 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1968345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968366 */     // GIR_Coverage, 61053,
     /* 1968366 */     GIR_EraseRootFromParent_Done,
     /* 1968367 */   // Label 26396: @1968367
     /* 1968367 */   GIM_Try, /*On fail goto*//*Label 26397*/ GIMT_Encode4(1968453), // Rule ID 61060 //
     /* 1968372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1968383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1968386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1968389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968418 */     // MIs[0] policy
     /* 1968418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968428 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1968431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968452 */     // GIR_Coverage, 61060,
     /* 1968452 */     GIR_EraseRootFromParent_Done,
     /* 1968453 */   // Label 26397: @1968453
     /* 1968453 */   GIM_Try, /*On fail goto*//*Label 26398*/ GIMT_Encode4(1968539), // Rule ID 61061 //
     /* 1968458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1968469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1968472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1968475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968504 */     // MIs[0] policy
     /* 1968504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968514 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1968517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968538 */     // GIR_Coverage, 61061,
     /* 1968538 */     GIR_EraseRootFromParent_Done,
     /* 1968539 */   // Label 26398: @1968539
     /* 1968539 */   GIM_Try, /*On fail goto*//*Label 26399*/ GIMT_Encode4(1968625), // Rule ID 61068 //
     /* 1968544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1968555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1968558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1968561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968590 */     // MIs[0] policy
     /* 1968590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1968603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968624 */     // GIR_Coverage, 61068,
     /* 1968624 */     GIR_EraseRootFromParent_Done,
     /* 1968625 */   // Label 26399: @1968625
     /* 1968625 */   GIM_Try, /*On fail goto*//*Label 26400*/ GIMT_Encode4(1968711), // Rule ID 61069 //
     /* 1968630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1968641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1968644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1968647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968676 */     // MIs[0] policy
     /* 1968676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1968689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968710 */     // GIR_Coverage, 61069,
     /* 1968710 */     GIR_EraseRootFromParent_Done,
     /* 1968711 */   // Label 26400: @1968711
     /* 1968711 */   GIM_Try, /*On fail goto*//*Label 26401*/ GIMT_Encode4(1968797), // Rule ID 61076 //
     /* 1968716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1968727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1968730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1968733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968762 */     // MIs[0] policy
     /* 1968762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968772 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1968775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968796 */     // GIR_Coverage, 61076,
     /* 1968796 */     GIR_EraseRootFromParent_Done,
     /* 1968797 */   // Label 26401: @1968797
     /* 1968797 */   GIM_Try, /*On fail goto*//*Label 26402*/ GIMT_Encode4(1968883), // Rule ID 61077 //
     /* 1968802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1968813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1968816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1968819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968848 */     // MIs[0] policy
     /* 1968848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968858 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1968861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968882 */     // GIR_Coverage, 61077,
     /* 1968882 */     GIR_EraseRootFromParent_Done,
     /* 1968883 */   // Label 26402: @1968883
     /* 1968883 */   GIM_Try, /*On fail goto*//*Label 26403*/ GIMT_Encode4(1968969), // Rule ID 61084 //
     /* 1968888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1968899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1968902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1968905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1968911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968934 */     // MIs[0] policy
     /* 1968934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968944 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1968947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968968 */     // GIR_Coverage, 61084,
     /* 1968968 */     GIR_EraseRootFromParent_Done,
     /* 1968969 */   // Label 26403: @1968969
     /* 1968969 */   GIM_Try, /*On fail goto*//*Label 26404*/ GIMT_Encode4(1969055), // Rule ID 61085 //
     /* 1968974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1968985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1968988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1968991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1968997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969020 */     // MIs[0] policy
     /* 1969020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969030 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1969033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969054 */     // GIR_Coverage, 61085,
     /* 1969054 */     GIR_EraseRootFromParent_Done,
     /* 1969055 */   // Label 26404: @1969055
     /* 1969055 */   GIM_Try, /*On fail goto*//*Label 26405*/ GIMT_Encode4(1969141), // Rule ID 61092 //
     /* 1969060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1969071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1969074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1969077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969106 */     // MIs[0] policy
     /* 1969106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969116 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1969119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969140 */     // GIR_Coverage, 61092,
     /* 1969140 */     GIR_EraseRootFromParent_Done,
     /* 1969141 */   // Label 26405: @1969141
     /* 1969141 */   GIM_Try, /*On fail goto*//*Label 26406*/ GIMT_Encode4(1969227), // Rule ID 61093 //
     /* 1969146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1969157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1969160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1969163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969192 */     // MIs[0] policy
     /* 1969192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969202 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1969205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969226 */     // GIR_Coverage, 61093,
     /* 1969226 */     GIR_EraseRootFromParent_Done,
     /* 1969227 */   // Label 26406: @1969227
     /* 1969227 */   GIM_Try, /*On fail goto*//*Label 26407*/ GIMT_Encode4(1969313), // Rule ID 61100 //
     /* 1969232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1969243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1969246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1969249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969278 */     // MIs[0] policy
     /* 1969278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1969291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969312 */     // GIR_Coverage, 61100,
     /* 1969312 */     GIR_EraseRootFromParent_Done,
     /* 1969313 */   // Label 26407: @1969313
     /* 1969313 */   GIM_Try, /*On fail goto*//*Label 26408*/ GIMT_Encode4(1969399), // Rule ID 61101 //
     /* 1969318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1969329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1969332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1969335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969364 */     // MIs[0] policy
     /* 1969364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969374 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1969377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969398 */     // GIR_Coverage, 61101,
     /* 1969398 */     GIR_EraseRootFromParent_Done,
     /* 1969399 */   // Label 26408: @1969399
     /* 1969399 */   GIM_Try, /*On fail goto*//*Label 26409*/ GIMT_Encode4(1969485), // Rule ID 61108 //
     /* 1969404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1969415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1969418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1969421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969450 */     // MIs[0] policy
     /* 1969450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1969463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969484 */     // GIR_Coverage, 61108,
     /* 1969484 */     GIR_EraseRootFromParent_Done,
     /* 1969485 */   // Label 26409: @1969485
     /* 1969485 */   GIM_Try, /*On fail goto*//*Label 26410*/ GIMT_Encode4(1969571), // Rule ID 61109 //
     /* 1969490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1969501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1969504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1969507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969536 */     // MIs[0] policy
     /* 1969536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1969549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969570 */     // GIR_Coverage, 61109,
     /* 1969570 */     GIR_EraseRootFromParent_Done,
     /* 1969571 */   // Label 26410: @1969571
     /* 1969571 */   GIM_Try, /*On fail goto*//*Label 26411*/ GIMT_Encode4(1969657), // Rule ID 61116 //
     /* 1969576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1969587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1969590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1969593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969622 */     // MIs[0] policy
     /* 1969622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969632 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1969635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969656 */     // GIR_Coverage, 61116,
     /* 1969656 */     GIR_EraseRootFromParent_Done,
     /* 1969657 */   // Label 26411: @1969657
     /* 1969657 */   GIM_Try, /*On fail goto*//*Label 26412*/ GIMT_Encode4(1969743), // Rule ID 61117 //
     /* 1969662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1969673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1969676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1969679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969708 */     // MIs[0] policy
     /* 1969708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969718 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1969721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969742 */     // GIR_Coverage, 61117,
     /* 1969742 */     GIR_EraseRootFromParent_Done,
     /* 1969743 */   // Label 26412: @1969743
     /* 1969743 */   GIM_Try, /*On fail goto*//*Label 26413*/ GIMT_Encode4(1969829), // Rule ID 61124 //
     /* 1969748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1969759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1969762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1969765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1969771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969794 */     // MIs[0] policy
     /* 1969794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969804 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1969807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969828 */     // GIR_Coverage, 61124,
     /* 1969828 */     GIR_EraseRootFromParent_Done,
     /* 1969829 */   // Label 26413: @1969829
     /* 1969829 */   GIM_Try, /*On fail goto*//*Label 26414*/ GIMT_Encode4(1969915), // Rule ID 61125 //
     /* 1969834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1969845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1969848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1969851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1969857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969880 */     // MIs[0] policy
     /* 1969880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1969893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969914 */     // GIR_Coverage, 61125,
     /* 1969914 */     GIR_EraseRootFromParent_Done,
     /* 1969915 */   // Label 26414: @1969915
     /* 1969915 */   GIM_Try, /*On fail goto*//*Label 26415*/ GIMT_Encode4(1970001), // Rule ID 61132 //
     /* 1969920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1969931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1969934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1969937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969966 */     // MIs[0] policy
     /* 1969966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1969979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970000 */     // GIR_Coverage, 61132,
     /* 1970000 */     GIR_EraseRootFromParent_Done,
     /* 1970001 */   // Label 26415: @1970001
     /* 1970001 */   GIM_Try, /*On fail goto*//*Label 26416*/ GIMT_Encode4(1970087), // Rule ID 61133 //
     /* 1970006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1970023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970052 */     // MIs[0] policy
     /* 1970052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970062 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1970065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970086 */     // GIR_Coverage, 61133,
     /* 1970086 */     GIR_EraseRootFromParent_Done,
     /* 1970087 */   // Label 26416: @1970087
     /* 1970087 */   GIM_Try, /*On fail goto*//*Label 26417*/ GIMT_Encode4(1970173), // Rule ID 61140 //
     /* 1970092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1970095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1970109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970138 */     // MIs[0] policy
     /* 1970138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970148 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1970151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970172 */     // GIR_Coverage, 61140,
     /* 1970172 */     GIR_EraseRootFromParent_Done,
     /* 1970173 */   // Label 26417: @1970173
     /* 1970173 */   GIM_Try, /*On fail goto*//*Label 26418*/ GIMT_Encode4(1970259), // Rule ID 61141 //
     /* 1970178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1970195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970224 */     // MIs[0] policy
     /* 1970224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1970237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970258 */     // GIR_Coverage, 61141,
     /* 1970258 */     GIR_EraseRootFromParent_Done,
     /* 1970259 */   // Label 26418: @1970259
     /* 1970259 */   GIM_Try, /*On fail goto*//*Label 26419*/ GIMT_Encode4(1970345), // Rule ID 61148 //
     /* 1970264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1970267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1970275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1970278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1970281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970310 */     // MIs[0] policy
     /* 1970310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970320 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1970323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970344 */     // GIR_Coverage, 61148,
     /* 1970344 */     GIR_EraseRootFromParent_Done,
     /* 1970345 */   // Label 26419: @1970345
     /* 1970345 */   GIM_Try, /*On fail goto*//*Label 26420*/ GIMT_Encode4(1970431), // Rule ID 61149 //
     /* 1970350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1970361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1970364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1970367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970396 */     // MIs[0] policy
     /* 1970396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970406 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1970409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970430 */     // GIR_Coverage, 61149,
     /* 1970430 */     GIR_EraseRootFromParent_Done,
     /* 1970431 */   // Label 26420: @1970431
     /* 1970431 */   GIM_Try, /*On fail goto*//*Label 26421*/ GIMT_Encode4(1970517), // Rule ID 61156 //
     /* 1970436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1970439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1970453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970482 */     // MIs[0] policy
     /* 1970482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970492 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1970495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970516 */     // GIR_Coverage, 61156,
     /* 1970516 */     GIR_EraseRootFromParent_Done,
     /* 1970517 */   // Label 26421: @1970517
     /* 1970517 */   GIM_Try, /*On fail goto*//*Label 26422*/ GIMT_Encode4(1970603), // Rule ID 61157 //
     /* 1970522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1970539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970568 */     // MIs[0] policy
     /* 1970568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970578 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1970581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970602 */     // GIR_Coverage, 61157,
     /* 1970602 */     GIR_EraseRootFromParent_Done,
     /* 1970603 */   // Label 26422: @1970603
     /* 1970603 */   GIM_Try, /*On fail goto*//*Label 26423*/ GIMT_Encode4(1970689), // Rule ID 61164 //
     /* 1970608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1970628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970654 */     // MIs[0] policy
     /* 1970654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970664 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1970667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970688 */     // GIR_Coverage, 61164,
     /* 1970688 */     GIR_EraseRootFromParent_Done,
     /* 1970689 */   // Label 26423: @1970689
     /* 1970689 */   GIM_Try, /*On fail goto*//*Label 26424*/ GIMT_Encode4(1970775), // Rule ID 61165 //
     /* 1970694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1970714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970740 */     // MIs[0] policy
     /* 1970740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970750 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1970753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970774 */     // GIR_Coverage, 61165,
     /* 1970774 */     GIR_EraseRootFromParent_Done,
     /* 1970775 */   // Label 26424: @1970775
     /* 1970775 */   GIM_Try, /*On fail goto*//*Label 26425*/ GIMT_Encode4(1970861), // Rule ID 61168 //
     /* 1970780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1970797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1970800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970826 */     // MIs[0] policy
     /* 1970826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1970839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970860 */     // GIR_Coverage, 61168,
     /* 1970860 */     GIR_EraseRootFromParent_Done,
     /* 1970861 */   // Label 26425: @1970861
     /* 1970861 */   GIM_Try, /*On fail goto*//*Label 26426*/ GIMT_Encode4(1970947), // Rule ID 61169 //
     /* 1970866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1970883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1970886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970912 */     // MIs[0] policy
     /* 1970912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970922 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1970925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970946 */     // GIR_Coverage, 61169,
     /* 1970946 */     GIR_EraseRootFromParent_Done,
     /* 1970947 */   // Label 26426: @1970947
     /* 1970947 */   GIM_Try, /*On fail goto*//*Label 26427*/ GIMT_Encode4(1971033), // Rule ID 61172 //
     /* 1970952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1970963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1970966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1970969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1970972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970998 */     // MIs[0] policy
     /* 1970998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971008 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1971011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971032 */     // GIR_Coverage, 61172,
     /* 1971032 */     GIR_EraseRootFromParent_Done,
     /* 1971033 */   // Label 26427: @1971033
     /* 1971033 */   GIM_Try, /*On fail goto*//*Label 26428*/ GIMT_Encode4(1971119), // Rule ID 61173 //
     /* 1971038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1971058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971084 */     // MIs[0] policy
     /* 1971084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971094 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1971097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971118 */     // GIR_Coverage, 61173,
     /* 1971118 */     GIR_EraseRootFromParent_Done,
     /* 1971119 */   // Label 26428: @1971119
     /* 1971119 */   GIM_Try, /*On fail goto*//*Label 26429*/ GIMT_Encode4(1971205), // Rule ID 61176 //
     /* 1971124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1971141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1971144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971170 */     // MIs[0] policy
     /* 1971170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971180 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1971183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971204 */     // GIR_Coverage, 61176,
     /* 1971204 */     GIR_EraseRootFromParent_Done,
     /* 1971205 */   // Label 26429: @1971205
     /* 1971205 */   GIM_Try, /*On fail goto*//*Label 26430*/ GIMT_Encode4(1971291), // Rule ID 61177 //
     /* 1971210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1971227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1971230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971256 */     // MIs[0] policy
     /* 1971256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971266 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1971269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971290 */     // GIR_Coverage, 61177,
     /* 1971290 */     GIR_EraseRootFromParent_Done,
     /* 1971291 */   // Label 26430: @1971291
     /* 1971291 */   GIM_Try, /*On fail goto*//*Label 26431*/ GIMT_Encode4(1971377), // Rule ID 61180 //
     /* 1971296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971342 */     // MIs[0] policy
     /* 1971342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1971355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971376 */     // GIR_Coverage, 61180,
     /* 1971376 */     GIR_EraseRootFromParent_Done,
     /* 1971377 */   // Label 26431: @1971377
     /* 1971377 */   GIM_Try, /*On fail goto*//*Label 26432*/ GIMT_Encode4(1971463), // Rule ID 61181 //
     /* 1971382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971428 */     // MIs[0] policy
     /* 1971428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971438 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1971441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971462 */     // GIR_Coverage, 61181,
     /* 1971462 */     GIR_EraseRootFromParent_Done,
     /* 1971463 */   // Label 26432: @1971463
     /* 1971463 */   GIM_Try, /*On fail goto*//*Label 26433*/ GIMT_Encode4(1971549), // Rule ID 61184 //
     /* 1971468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1971479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1971482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1971485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971514 */     // MIs[0] policy
     /* 1971514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1971527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971548 */     // GIR_Coverage, 61184,
     /* 1971548 */     GIR_EraseRootFromParent_Done,
     /* 1971549 */   // Label 26433: @1971549
     /* 1971549 */   GIM_Try, /*On fail goto*//*Label 26434*/ GIMT_Encode4(1971635), // Rule ID 61185 //
     /* 1971554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1971565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1971568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1971571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971600 */     // MIs[0] policy
     /* 1971600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1971613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971634 */     // GIR_Coverage, 61185,
     /* 1971634 */     GIR_EraseRootFromParent_Done,
     /* 1971635 */   // Label 26434: @1971635
     /* 1971635 */   GIM_Try, /*On fail goto*//*Label 26435*/ GIMT_Encode4(1971721), // Rule ID 61188 //
     /* 1971640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971686 */     // MIs[0] policy
     /* 1971686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971696 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1971699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971720 */     // GIR_Coverage, 61188,
     /* 1971720 */     GIR_EraseRootFromParent_Done,
     /* 1971721 */   // Label 26435: @1971721
     /* 1971721 */   GIM_Try, /*On fail goto*//*Label 26436*/ GIMT_Encode4(1971807), // Rule ID 61189 //
     /* 1971726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971772 */     // MIs[0] policy
     /* 1971772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971782 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1971785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971806 */     // GIR_Coverage, 61189,
     /* 1971806 */     GIR_EraseRootFromParent_Done,
     /* 1971807 */   // Label 26436: @1971807
     /* 1971807 */   GIM_Try, /*On fail goto*//*Label 26437*/ GIMT_Encode4(1971893), // Rule ID 61192 //
     /* 1971812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1971829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971858 */     // MIs[0] policy
     /* 1971858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1971871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971892 */     // GIR_Coverage, 61192,
     /* 1971892 */     GIR_EraseRootFromParent_Done,
     /* 1971893 */   // Label 26437: @1971893
     /* 1971893 */   GIM_Try, /*On fail goto*//*Label 26438*/ GIMT_Encode4(1971979), // Rule ID 61193 //
     /* 1971898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1971915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971944 */     // MIs[0] policy
     /* 1971944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1971957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971978 */     // GIR_Coverage, 61193,
     /* 1971978 */     GIR_EraseRootFromParent_Done,
     /* 1971979 */   // Label 26438: @1971979
     /* 1971979 */   GIM_Try, /*On fail goto*//*Label 26439*/ GIMT_Encode4(1972065), // Rule ID 61196 //
     /* 1971984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1972004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972030 */     // MIs[0] policy
     /* 1972030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1972043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972064 */     // GIR_Coverage, 61196,
     /* 1972064 */     GIR_EraseRootFromParent_Done,
     /* 1972065 */   // Label 26439: @1972065
     /* 1972065 */   GIM_Try, /*On fail goto*//*Label 26440*/ GIMT_Encode4(1972151), // Rule ID 61197 //
     /* 1972070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1972081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1972084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1972090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972116 */     // MIs[0] policy
     /* 1972116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1972129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972150 */     // GIR_Coverage, 61197,
     /* 1972150 */     GIR_EraseRootFromParent_Done,
     /* 1972151 */   // Label 26440: @1972151
     /* 1972151 */   GIM_Try, /*On fail goto*//*Label 26441*/ GIMT_Encode4(1972237), // Rule ID 61200 //
     /* 1972156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1972176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972202 */     // MIs[0] policy
     /* 1972202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972212 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1972215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972236 */     // GIR_Coverage, 61200,
     /* 1972236 */     GIR_EraseRootFromParent_Done,
     /* 1972237 */   // Label 26441: @1972237
     /* 1972237 */   GIM_Try, /*On fail goto*//*Label 26442*/ GIMT_Encode4(1972323), // Rule ID 61201 //
     /* 1972242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1972262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972288 */     // MIs[0] policy
     /* 1972288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1972301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972322 */     // GIR_Coverage, 61201,
     /* 1972322 */     GIR_EraseRootFromParent_Done,
     /* 1972323 */   // Label 26442: @1972323
     /* 1972323 */   GIM_Try, /*On fail goto*//*Label 26443*/ GIMT_Encode4(1972409), // Rule ID 61204 //
     /* 1972328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1972339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1972342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1972345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1972348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972374 */     // MIs[0] policy
     /* 1972374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972384 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1972387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972408 */     // GIR_Coverage, 61204,
     /* 1972408 */     GIR_EraseRootFromParent_Done,
     /* 1972409 */   // Label 26443: @1972409
     /* 1972409 */   GIM_Try, /*On fail goto*//*Label 26444*/ GIMT_Encode4(1972495), // Rule ID 61205 //
     /* 1972414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1972425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1972428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1972431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1972434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972460 */     // MIs[0] policy
     /* 1972460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972470 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1972473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972494 */     // GIR_Coverage, 61205,
     /* 1972494 */     GIR_EraseRootFromParent_Done,
     /* 1972495 */   // Label 26444: @1972495
     /* 1972495 */   GIM_Try, /*On fail goto*//*Label 26445*/ GIMT_Encode4(1972581), // Rule ID 61208 //
     /* 1972500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1972511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1972514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1972517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1972520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972546 */     // MIs[0] policy
     /* 1972546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972556 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1972559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972580 */     // GIR_Coverage, 61208,
     /* 1972580 */     GIR_EraseRootFromParent_Done,
     /* 1972581 */   // Label 26445: @1972581
     /* 1972581 */   GIM_Try, /*On fail goto*//*Label 26446*/ GIMT_Encode4(1972667), // Rule ID 61209 //
     /* 1972586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1972597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1972600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1972603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1972606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972632 */     // MIs[0] policy
     /* 1972632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1972645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972666 */     // GIR_Coverage, 61209,
     /* 1972666 */     GIR_EraseRootFromParent_Done,
     /* 1972667 */   // Label 26446: @1972667
     /* 1972667 */   GIM_Try, /*On fail goto*//*Label 26447*/ GIMT_Encode4(1972753), // Rule ID 61212 //
     /* 1972672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1972683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1972686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972718 */     // MIs[0] policy
     /* 1972718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972728 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1972731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972752 */     // GIR_Coverage, 61212,
     /* 1972752 */     GIR_EraseRootFromParent_Done,
     /* 1972753 */   // Label 26447: @1972753
     /* 1972753 */   GIM_Try, /*On fail goto*//*Label 26448*/ GIMT_Encode4(1972839), // Rule ID 61213 //
     /* 1972758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1972769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1972772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972804 */     // MIs[0] policy
     /* 1972804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972814 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1972817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972838 */     // GIR_Coverage, 61213,
     /* 1972838 */     GIR_EraseRootFromParent_Done,
     /* 1972839 */   // Label 26448: @1972839
     /* 1972839 */   GIM_Try, /*On fail goto*//*Label 26449*/ GIMT_Encode4(1972925), // Rule ID 61216 //
     /* 1972844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972890 */     // MIs[0] policy
     /* 1972890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1972903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972924 */     // GIR_Coverage, 61216,
     /* 1972924 */     GIR_EraseRootFromParent_Done,
     /* 1972925 */   // Label 26449: @1972925
     /* 1972925 */   GIM_Try, /*On fail goto*//*Label 26450*/ GIMT_Encode4(1973011), // Rule ID 61217 //
     /* 1972930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972976 */     // MIs[0] policy
     /* 1972976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972986 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1972989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973010 */     // GIR_Coverage, 61217,
     /* 1973010 */     GIR_EraseRootFromParent_Done,
     /* 1973011 */   // Label 26450: @1973011
     /* 1973011 */   GIM_Try, /*On fail goto*//*Label 26451*/ GIMT_Encode4(1973097), // Rule ID 61220 //
     /* 1973016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1973019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1973024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1973027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1973030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1973033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973062 */     // MIs[0] policy
     /* 1973062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973072 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1973075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973096 */     // GIR_Coverage, 61220,
     /* 1973096 */     GIR_EraseRootFromParent_Done,
     /* 1973097 */   // Label 26451: @1973097
     /* 1973097 */   GIM_Try, /*On fail goto*//*Label 26452*/ GIMT_Encode4(1973183), // Rule ID 61221 //
     /* 1973102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1973105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1973110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1973113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1973116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1973119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973148 */     // MIs[0] policy
     /* 1973148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973158 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1973161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973182 */     // GIR_Coverage, 61221,
     /* 1973182 */     GIR_EraseRootFromParent_Done,
     /* 1973183 */   // Label 26452: @1973183
     /* 1973183 */   GIM_Try, /*On fail goto*//*Label 26453*/ GIMT_Encode4(1973269), // Rule ID 61224 //
     /* 1973188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1973191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1973196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1973199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1973202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1973205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973234 */     // MIs[0] policy
     /* 1973234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973244 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1973247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973268 */     // GIR_Coverage, 61224,
     /* 1973268 */     GIR_EraseRootFromParent_Done,
     /* 1973269 */   // Label 26453: @1973269
     /* 1973269 */   GIM_Try, /*On fail goto*//*Label 26454*/ GIMT_Encode4(1973355), // Rule ID 61225 //
     /* 1973274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1973277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1973282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1973285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1973288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1973291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973320 */     // MIs[0] policy
     /* 1973320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973330 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1973333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973354 */     // GIR_Coverage, 61225,
     /* 1973354 */     GIR_EraseRootFromParent_Done,
     /* 1973355 */   // Label 26454: @1973355
     /* 1973355 */   GIM_Try, /*On fail goto*//*Label 26455*/ GIMT_Encode4(1973441), // Rule ID 61228 //
     /* 1973360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1973371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1973374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1973377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1973380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973406 */     // MIs[0] policy
     /* 1973406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973416 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1973419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973440 */     // GIR_Coverage, 61228,
     /* 1973440 */     GIR_EraseRootFromParent_Done,
     /* 1973441 */   // Label 26455: @1973441
     /* 1973441 */   GIM_Try, /*On fail goto*//*Label 26456*/ GIMT_Encode4(1973527), // Rule ID 61229 //
     /* 1973446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1973457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1973460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1973463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1973466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973492 */     // MIs[0] policy
     /* 1973492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973502 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1973505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973526 */     // GIR_Coverage, 61229,
     /* 1973526 */     GIR_EraseRootFromParent_Done,
     /* 1973527 */   // Label 26456: @1973527
     /* 1973527 */   GIM_Try, /*On fail goto*//*Label 26457*/ GIMT_Encode4(1973613), // Rule ID 61232 //
     /* 1973532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1973543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1973546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1973549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1973552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973578 */     // MIs[0] policy
     /* 1973578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973588 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973612 */     // GIR_Coverage, 61232,
     /* 1973612 */     GIR_EraseRootFromParent_Done,
     /* 1973613 */   // Label 26457: @1973613
     /* 1973613 */   GIM_Try, /*On fail goto*//*Label 26458*/ GIMT_Encode4(1973699), // Rule ID 61233 //
     /* 1973618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1973629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1973632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1973635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1973638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973664 */     // MIs[0] policy
     /* 1973664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973674 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973698 */     // GIR_Coverage, 61233,
     /* 1973698 */     GIR_EraseRootFromParent_Done,
     /* 1973699 */   // Label 26458: @1973699
     /* 1973699 */   GIM_Try, /*On fail goto*//*Label 26459*/ GIMT_Encode4(1973785), // Rule ID 61236 //
     /* 1973704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1973715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1973718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1973721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1973724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973750 */     // MIs[0] policy
     /* 1973750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973760 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973784 */     // GIR_Coverage, 61236,
     /* 1973784 */     GIR_EraseRootFromParent_Done,
     /* 1973785 */   // Label 26459: @1973785
     /* 1973785 */   GIM_Try, /*On fail goto*//*Label 26460*/ GIMT_Encode4(1973871), // Rule ID 61237 //
     /* 1973790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1973801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1973804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1973807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1973810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973836 */     // MIs[0] policy
     /* 1973836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973846 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973870 */     // GIR_Coverage, 61237,
     /* 1973870 */     GIR_EraseRootFromParent_Done,
     /* 1973871 */   // Label 26460: @1973871
     /* 1973871 */   GIM_Try, /*On fail goto*//*Label 26461*/ GIMT_Encode4(1973957), // Rule ID 61240 //
     /* 1973876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1973887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1973890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1973893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1973896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973922 */     // MIs[0] policy
     /* 1973922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973932 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973956 */     // GIR_Coverage, 61240,
     /* 1973956 */     GIR_EraseRootFromParent_Done,
     /* 1973957 */   // Label 26461: @1973957
     /* 1973957 */   GIM_Try, /*On fail goto*//*Label 26462*/ GIMT_Encode4(1974043), // Rule ID 61241 //
     /* 1973962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1973973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1973976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1973979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1973982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974008 */     // MIs[0] policy
     /* 1974008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1974021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974042 */     // GIR_Coverage, 61241,
     /* 1974042 */     GIR_EraseRootFromParent_Done,
     /* 1974043 */   // Label 26462: @1974043
     /* 1974043 */   GIM_Try, /*On fail goto*//*Label 26463*/ GIMT_Encode4(1974129), // Rule ID 61244 //
     /* 1974048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1974059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1974062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1974065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1974068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974094 */     // MIs[0] policy
     /* 1974094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974104 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1974107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974128 */     // GIR_Coverage, 61244,
     /* 1974128 */     GIR_EraseRootFromParent_Done,
     /* 1974129 */   // Label 26463: @1974129
     /* 1974129 */   GIM_Try, /*On fail goto*//*Label 26464*/ GIMT_Encode4(1974215), // Rule ID 61245 //
     /* 1974134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1974145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1974148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1974151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1974154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974180 */     // MIs[0] policy
     /* 1974180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974190 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1974193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974214 */     // GIR_Coverage, 61245,
     /* 1974214 */     GIR_EraseRootFromParent_Done,
     /* 1974215 */   // Label 26464: @1974215
     /* 1974215 */   GIM_Try, /*On fail goto*//*Label 26465*/ GIMT_Encode4(1974301), // Rule ID 61248 //
     /* 1974220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1974231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1974234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1974237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1974240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974266 */     // MIs[0] policy
     /* 1974266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1974279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974300 */     // GIR_Coverage, 61248,
     /* 1974300 */     GIR_EraseRootFromParent_Done,
     /* 1974301 */   // Label 26465: @1974301
     /* 1974301 */   GIM_Try, /*On fail goto*//*Label 26466*/ GIMT_Encode4(1974387), // Rule ID 61249 //
     /* 1974306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1974317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1974320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1974323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1974326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974352 */     // MIs[0] policy
     /* 1974352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974362 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1974365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974386 */     // GIR_Coverage, 61249,
     /* 1974386 */     GIR_EraseRootFromParent_Done,
     /* 1974387 */   // Label 26466: @1974387
     /* 1974387 */   GIM_Try, /*On fail goto*//*Label 26467*/ GIMT_Encode4(1974473), // Rule ID 61252 //
     /* 1974392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1974403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1974406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1974409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1974412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974438 */     // MIs[0] policy
     /* 1974438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974448 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974472 */     // GIR_Coverage, 61252,
     /* 1974472 */     GIR_EraseRootFromParent_Done,
     /* 1974473 */   // Label 26467: @1974473
     /* 1974473 */   GIM_Try, /*On fail goto*//*Label 26468*/ GIMT_Encode4(1974559), // Rule ID 61253 //
     /* 1974478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1974489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1974492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1974495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1974498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974524 */     // MIs[0] policy
     /* 1974524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974534 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974558 */     // GIR_Coverage, 61253,
     /* 1974558 */     GIR_EraseRootFromParent_Done,
     /* 1974559 */   // Label 26468: @1974559
     /* 1974559 */   GIM_Try, /*On fail goto*//*Label 26469*/ GIMT_Encode4(1974645), // Rule ID 61256 //
     /* 1974564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1974575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1974578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1974581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1974584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974610 */     // MIs[0] policy
     /* 1974610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974644 */     // GIR_Coverage, 61256,
     /* 1974644 */     GIR_EraseRootFromParent_Done,
     /* 1974645 */   // Label 26469: @1974645
     /* 1974645 */   GIM_Try, /*On fail goto*//*Label 26470*/ GIMT_Encode4(1974731), // Rule ID 61257 //
     /* 1974650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1974661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1974664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1974667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1974670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974696 */     // MIs[0] policy
     /* 1974696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974706 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974730 */     // GIR_Coverage, 61257,
     /* 1974730 */     GIR_EraseRootFromParent_Done,
     /* 1974731 */   // Label 26470: @1974731
     /* 1974731 */   GIM_Try, /*On fail goto*//*Label 26471*/ GIMT_Encode4(1974817), // Rule ID 61260 //
     /* 1974736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1974747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1974750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1974753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1974756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974782 */     // MIs[0] policy
     /* 1974782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974816 */     // GIR_Coverage, 61260,
     /* 1974816 */     GIR_EraseRootFromParent_Done,
     /* 1974817 */   // Label 26471: @1974817
     /* 1974817 */   GIM_Try, /*On fail goto*//*Label 26472*/ GIMT_Encode4(1974903), // Rule ID 61261 //
     /* 1974822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1974833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1974836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1974839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1974842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974868 */     // MIs[0] policy
     /* 1974868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974902 */     // GIR_Coverage, 61261,
     /* 1974902 */     GIR_EraseRootFromParent_Done,
     /* 1974903 */   // Label 26472: @1974903
     /* 1974903 */   GIM_Try, /*On fail goto*//*Label 26473*/ GIMT_Encode4(1974989), // Rule ID 61264 //
     /* 1974908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1974919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1974922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1974925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1974928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974954 */     // MIs[0] policy
     /* 1974954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974964 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974988 */     // GIR_Coverage, 61264,
     /* 1974988 */     GIR_EraseRootFromParent_Done,
     /* 1974989 */   // Label 26473: @1974989
     /* 1974989 */   GIM_Try, /*On fail goto*//*Label 26474*/ GIMT_Encode4(1975075), // Rule ID 61265 //
     /* 1974994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1975005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1975008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1975011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1975014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1975017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975040 */     // MIs[0] policy
     /* 1975040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975050 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1975053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975074 */     // GIR_Coverage, 61265,
     /* 1975074 */     GIR_EraseRootFromParent_Done,
     /* 1975075 */   // Label 26474: @1975075
     /* 1975075 */   GIM_Try, /*On fail goto*//*Label 26475*/ GIMT_Encode4(1975161), // Rule ID 61268 //
     /* 1975080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1975091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1975094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1975097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1975100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975126 */     // MIs[0] policy
     /* 1975126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975136 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975160 */     // GIR_Coverage, 61268,
     /* 1975160 */     GIR_EraseRootFromParent_Done,
     /* 1975161 */   // Label 26475: @1975161
     /* 1975161 */   GIM_Try, /*On fail goto*//*Label 26476*/ GIMT_Encode4(1975247), // Rule ID 61269 //
     /* 1975166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1975177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1975180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1975183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1975186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975212 */     // MIs[0] policy
     /* 1975212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975222 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975246 */     // GIR_Coverage, 61269,
     /* 1975246 */     GIR_EraseRootFromParent_Done,
     /* 1975247 */   // Label 26476: @1975247
     /* 1975247 */   GIM_Try, /*On fail goto*//*Label 26477*/ GIMT_Encode4(1975333), // Rule ID 61272 //
     /* 1975252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1975263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1975266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1975269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1975272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975298 */     // MIs[0] policy
     /* 1975298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975308 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975332 */     // GIR_Coverage, 61272,
     /* 1975332 */     GIR_EraseRootFromParent_Done,
     /* 1975333 */   // Label 26477: @1975333
     /* 1975333 */   GIM_Try, /*On fail goto*//*Label 26478*/ GIMT_Encode4(1975419), // Rule ID 61273 //
     /* 1975338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1975349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1975352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1975355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1975358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975384 */     // MIs[0] policy
     /* 1975384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975394 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975418 */     // GIR_Coverage, 61273,
     /* 1975418 */     GIR_EraseRootFromParent_Done,
     /* 1975419 */   // Label 26478: @1975419
     /* 1975419 */   GIM_Try, /*On fail goto*//*Label 26479*/ GIMT_Encode4(1975505), // Rule ID 61276 //
     /* 1975424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1975435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1975438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1975441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1975444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1975447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975470 */     // MIs[0] policy
     /* 1975470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975480 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975504 */     // GIR_Coverage, 61276,
     /* 1975504 */     GIR_EraseRootFromParent_Done,
     /* 1975505 */   // Label 26479: @1975505
     /* 1975505 */   GIM_Try, /*On fail goto*//*Label 26480*/ GIMT_Encode4(1975591), // Rule ID 61277 //
     /* 1975510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1975521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1975524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1975527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1975530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1975533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975556 */     // MIs[0] policy
     /* 1975556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975566 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975590 */     // GIR_Coverage, 61277,
     /* 1975590 */     GIR_EraseRootFromParent_Done,
     /* 1975591 */   // Label 26480: @1975591
     /* 1975591 */   GIM_Try, /*On fail goto*//*Label 26481*/ GIMT_Encode4(1975677), // Rule ID 61280 //
     /* 1975596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1975607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1975610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1975613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1975616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975642 */     // MIs[0] policy
     /* 1975642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975676 */     // GIR_Coverage, 61280,
     /* 1975676 */     GIR_EraseRootFromParent_Done,
     /* 1975677 */   // Label 26481: @1975677
     /* 1975677 */   GIM_Try, /*On fail goto*//*Label 26482*/ GIMT_Encode4(1975763), // Rule ID 61281 //
     /* 1975682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1975693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1975696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1975699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1975702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975728 */     // MIs[0] policy
     /* 1975728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975738 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975762 */     // GIR_Coverage, 61281,
     /* 1975762 */     GIR_EraseRootFromParent_Done,
     /* 1975763 */   // Label 26482: @1975763
     /* 1975763 */   GIM_Try, /*On fail goto*//*Label 26483*/ GIMT_Encode4(1975849), // Rule ID 61284 //
     /* 1975768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1975779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1975782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1975785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1975788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975814 */     // MIs[0] policy
     /* 1975814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975824 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975848 */     // GIR_Coverage, 61284,
     /* 1975848 */     GIR_EraseRootFromParent_Done,
     /* 1975849 */   // Label 26483: @1975849
     /* 1975849 */   GIM_Try, /*On fail goto*//*Label 26484*/ GIMT_Encode4(1975935), // Rule ID 61285 //
     /* 1975854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1975865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1975868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1975871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1975874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975900 */     // MIs[0] policy
     /* 1975900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975910 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975934 */     // GIR_Coverage, 61285,
     /* 1975934 */     GIR_EraseRootFromParent_Done,
     /* 1975935 */   // Label 26484: @1975935
     /* 1975935 */   GIM_Try, /*On fail goto*//*Label 26485*/ GIMT_Encode4(1976021), // Rule ID 61288 //
     /* 1975940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1975951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1975954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1975957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1975960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975986 */     // MIs[0] policy
     /* 1975986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975996 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976020 */     // GIR_Coverage, 61288,
     /* 1976020 */     GIR_EraseRootFromParent_Done,
     /* 1976021 */   // Label 26485: @1976021
     /* 1976021 */   GIM_Try, /*On fail goto*//*Label 26486*/ GIMT_Encode4(1976107), // Rule ID 61289 //
     /* 1976026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1976037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1976040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1976043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1976046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1976049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976072 */     // MIs[0] policy
     /* 1976072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976082 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976106 */     // GIR_Coverage, 61289,
     /* 1976106 */     GIR_EraseRootFromParent_Done,
     /* 1976107 */   // Label 26486: @1976107
     /* 1976107 */   GIM_Try, /*On fail goto*//*Label 26487*/ GIMT_Encode4(1976193), // Rule ID 61292 //
     /* 1976112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1976123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1976126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1976129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1976132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976158 */     // MIs[0] policy
     /* 1976158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976168 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1976171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976192 */     // GIR_Coverage, 61292,
     /* 1976192 */     GIR_EraseRootFromParent_Done,
     /* 1976193 */   // Label 26487: @1976193
     /* 1976193 */   GIM_Try, /*On fail goto*//*Label 26488*/ GIMT_Encode4(1976279), // Rule ID 61293 //
     /* 1976198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1976209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1976212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1976215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1976218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976244 */     // MIs[0] policy
     /* 1976244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976254 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1976257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976278 */     // GIR_Coverage, 61293,
     /* 1976278 */     GIR_EraseRootFromParent_Done,
     /* 1976279 */   // Label 26488: @1976279
     /* 1976279 */   GIM_Try, /*On fail goto*//*Label 26489*/ GIMT_Encode4(1976365), // Rule ID 61296 //
     /* 1976284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1976295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1976298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1976301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1976304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976330 */     // MIs[0] policy
     /* 1976330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976340 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1976343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976364 */     // GIR_Coverage, 61296,
     /* 1976364 */     GIR_EraseRootFromParent_Done,
     /* 1976365 */   // Label 26489: @1976365
     /* 1976365 */   GIM_Try, /*On fail goto*//*Label 26490*/ GIMT_Encode4(1976451), // Rule ID 61297 //
     /* 1976370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1976381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1976384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1976387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1976390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976416 */     // MIs[0] policy
     /* 1976416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976426 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1976429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976450 */     // GIR_Coverage, 61297,
     /* 1976450 */     GIR_EraseRootFromParent_Done,
     /* 1976451 */   // Label 26490: @1976451
     /* 1976451 */   GIM_Try, /*On fail goto*//*Label 26491*/ GIMT_Encode4(1976537), // Rule ID 61300 //
     /* 1976456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1976467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1976470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1976473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1976476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976502 */     // MIs[0] policy
     /* 1976502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976512 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976536 */     // GIR_Coverage, 61300,
     /* 1976536 */     GIR_EraseRootFromParent_Done,
     /* 1976537 */   // Label 26491: @1976537
     /* 1976537 */   GIM_Try, /*On fail goto*//*Label 26492*/ GIMT_Encode4(1976623), // Rule ID 61301 //
     /* 1976542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1976553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1976556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1976559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1976562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976588 */     // MIs[0] policy
     /* 1976588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976598 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976622 */     // GIR_Coverage, 61301,
     /* 1976622 */     GIR_EraseRootFromParent_Done,
     /* 1976623 */   // Label 26492: @1976623
     /* 1976623 */   GIM_Try, /*On fail goto*//*Label 26493*/ GIMT_Encode4(1976709), // Rule ID 61304 //
     /* 1976628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1976639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1976642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1976645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1976648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976674 */     // MIs[0] policy
     /* 1976674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1976687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976708 */     // GIR_Coverage, 61304,
     /* 1976708 */     GIR_EraseRootFromParent_Done,
     /* 1976709 */   // Label 26493: @1976709
     /* 1976709 */   GIM_Try, /*On fail goto*//*Label 26494*/ GIMT_Encode4(1976795), // Rule ID 61305 //
     /* 1976714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1976725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1976728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1976731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1976734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976760 */     // MIs[0] policy
     /* 1976760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976770 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1976773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976794 */     // GIR_Coverage, 61305,
     /* 1976794 */     GIR_EraseRootFromParent_Done,
     /* 1976795 */   // Label 26494: @1976795
     /* 1976795 */   GIM_Try, /*On fail goto*//*Label 26495*/ GIMT_Encode4(1976881), // Rule ID 61308 //
     /* 1976800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1976811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1976814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1976817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1976820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976846 */     // MIs[0] policy
     /* 1976846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976856 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1976859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976880 */     // GIR_Coverage, 61308,
     /* 1976880 */     GIR_EraseRootFromParent_Done,
     /* 1976881 */   // Label 26495: @1976881
     /* 1976881 */   GIM_Try, /*On fail goto*//*Label 26496*/ GIMT_Encode4(1976967), // Rule ID 61309 //
     /* 1976886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1976897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1976900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1976903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1976906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976932 */     // MIs[0] policy
     /* 1976932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976942 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1976945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976966 */     // GIR_Coverage, 61309,
     /* 1976966 */     GIR_EraseRootFromParent_Done,
     /* 1976967 */   // Label 26496: @1976967
     /* 1976967 */   GIM_Try, /*On fail goto*//*Label 26497*/ GIMT_Encode4(1977053), // Rule ID 61312 //
     /* 1976972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1976983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1976986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1976989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1976992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1977002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977018 */     // MIs[0] policy
     /* 1977018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977028 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1977031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977052 */     // GIR_Coverage, 61312,
     /* 1977052 */     GIR_EraseRootFromParent_Done,
     /* 1977053 */   // Label 26497: @1977053
     /* 1977053 */   GIM_Try, /*On fail goto*//*Label 26498*/ GIMT_Encode4(1977139), // Rule ID 61313 //
     /* 1977058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1977069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1977072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1977075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1977078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1977088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977104 */     // MIs[0] policy
     /* 1977104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1977117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977138 */     // GIR_Coverage, 61313,
     /* 1977138 */     GIR_EraseRootFromParent_Done,
     /* 1977139 */   // Label 26498: @1977139
     /* 1977139 */   GIM_Try, /*On fail goto*//*Label 26499*/ GIMT_Encode4(1977225), // Rule ID 61316 //
     /* 1977144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1977155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1977158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1977161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977190 */     // MIs[0] policy
     /* 1977190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977200 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1977203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977224 */     // GIR_Coverage, 61316,
     /* 1977224 */     GIR_EraseRootFromParent_Done,
     /* 1977225 */   // Label 26499: @1977225
     /* 1977225 */   GIM_Try, /*On fail goto*//*Label 26500*/ GIMT_Encode4(1977311), // Rule ID 61317 //
     /* 1977230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1977241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1977244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1977247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977276 */     // MIs[0] policy
     /* 1977276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977286 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1977289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977310 */     // GIR_Coverage, 61317,
     /* 1977310 */     GIR_EraseRootFromParent_Done,
     /* 1977311 */   // Label 26500: @1977311
     /* 1977311 */   GIM_Try, /*On fail goto*//*Label 26501*/ GIMT_Encode4(1977397), // Rule ID 61320 //
     /* 1977316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1977327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1977330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1977333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977362 */     // MIs[0] policy
     /* 1977362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977372 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1977375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977396 */     // GIR_Coverage, 61320,
     /* 1977396 */     GIR_EraseRootFromParent_Done,
     /* 1977397 */   // Label 26501: @1977397
     /* 1977397 */   GIM_Try, /*On fail goto*//*Label 26502*/ GIMT_Encode4(1977483), // Rule ID 61321 //
     /* 1977402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1977413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1977416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1977419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977448 */     // MIs[0] policy
     /* 1977448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977458 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1977461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977482 */     // GIR_Coverage, 61321,
     /* 1977482 */     GIR_EraseRootFromParent_Done,
     /* 1977483 */   // Label 26502: @1977483
     /* 1977483 */   GIM_Try, /*On fail goto*//*Label 26503*/ GIMT_Encode4(1977569), // Rule ID 61324 //
     /* 1977488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1977499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1977502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1977505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977534 */     // MIs[0] policy
     /* 1977534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977568 */     // GIR_Coverage, 61324,
     /* 1977568 */     GIR_EraseRootFromParent_Done,
     /* 1977569 */   // Label 26503: @1977569
     /* 1977569 */   GIM_Try, /*On fail goto*//*Label 26504*/ GIMT_Encode4(1977655), // Rule ID 61325 //
     /* 1977574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1977585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1977588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1977591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977620 */     // MIs[0] policy
     /* 1977620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977630 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977654 */     // GIR_Coverage, 61325,
     /* 1977654 */     GIR_EraseRootFromParent_Done,
     /* 1977655 */   // Label 26504: @1977655
     /* 1977655 */   GIM_Try, /*On fail goto*//*Label 26505*/ GIMT_Encode4(1977741), // Rule ID 61328 //
     /* 1977660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1977671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1977674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1977677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977706 */     // MIs[0] policy
     /* 1977706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977716 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1977719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977740 */     // GIR_Coverage, 61328,
     /* 1977740 */     GIR_EraseRootFromParent_Done,
     /* 1977741 */   // Label 26505: @1977741
     /* 1977741 */   GIM_Try, /*On fail goto*//*Label 26506*/ GIMT_Encode4(1977827), // Rule ID 61329 //
     /* 1977746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1977757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1977760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1977763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977792 */     // MIs[0] policy
     /* 1977792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977802 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1977805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977826 */     // GIR_Coverage, 61329,
     /* 1977826 */     GIR_EraseRootFromParent_Done,
     /* 1977827 */   // Label 26506: @1977827
     /* 1977827 */   GIM_Try, /*On fail goto*//*Label 26507*/ GIMT_Encode4(1977913), // Rule ID 61332 //
     /* 1977832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1977843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1977846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1977849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977878 */     // MIs[0] policy
     /* 1977878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977888 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977912 */     // GIR_Coverage, 61332,
     /* 1977912 */     GIR_EraseRootFromParent_Done,
     /* 1977913 */   // Label 26507: @1977913
     /* 1977913 */   GIM_Try, /*On fail goto*//*Label 26508*/ GIMT_Encode4(1977999), // Rule ID 61333 //
     /* 1977918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1977929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1977932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1977935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977964 */     // MIs[0] policy
     /* 1977964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977974 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977998 */     // GIR_Coverage, 61333,
     /* 1977998 */     GIR_EraseRootFromParent_Done,
     /* 1977999 */   // Label 26508: @1977999
     /* 1977999 */   GIM_Try, /*On fail goto*//*Label 26509*/ GIMT_Encode4(1978085), // Rule ID 61336 //
     /* 1978004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1978015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1978018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1978021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978050 */     // MIs[0] policy
     /* 1978050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978060 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1978063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978084 */     // GIR_Coverage, 61336,
     /* 1978084 */     GIR_EraseRootFromParent_Done,
     /* 1978085 */   // Label 26509: @1978085
     /* 1978085 */   GIM_Try, /*On fail goto*//*Label 26510*/ GIMT_Encode4(1978171), // Rule ID 61337 //
     /* 1978090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1978101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1978104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1978107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978136 */     // MIs[0] policy
     /* 1978136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1978149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978170 */     // GIR_Coverage, 61337,
     /* 1978170 */     GIR_EraseRootFromParent_Done,
     /* 1978171 */   // Label 26510: @1978171
     /* 1978171 */   GIM_Try, /*On fail goto*//*Label 26511*/ GIMT_Encode4(1978257), // Rule ID 61340 //
     /* 1978176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1978187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1978190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1978193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978222 */     // MIs[0] policy
     /* 1978222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978256 */     // GIR_Coverage, 61340,
     /* 1978256 */     GIR_EraseRootFromParent_Done,
     /* 1978257 */   // Label 26511: @1978257
     /* 1978257 */   GIM_Try, /*On fail goto*//*Label 26512*/ GIMT_Encode4(1978343), // Rule ID 61341 //
     /* 1978262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1978273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1978276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1978279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978308 */     // MIs[0] policy
     /* 1978308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978318 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978342 */     // GIR_Coverage, 61341,
     /* 1978342 */     GIR_EraseRootFromParent_Done,
     /* 1978343 */   // Label 26512: @1978343
     /* 1978343 */   GIM_Try, /*On fail goto*//*Label 26513*/ GIMT_Encode4(1978429), // Rule ID 61344 //
     /* 1978348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1978359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1978362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1978365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978394 */     // MIs[0] policy
     /* 1978394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978404 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978428 */     // GIR_Coverage, 61344,
     /* 1978428 */     GIR_EraseRootFromParent_Done,
     /* 1978429 */   // Label 26513: @1978429
     /* 1978429 */   GIM_Try, /*On fail goto*//*Label 26514*/ GIMT_Encode4(1978515), // Rule ID 61345 //
     /* 1978434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1978445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1978448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1978451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978480 */     // MIs[0] policy
     /* 1978480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978514 */     // GIR_Coverage, 61345,
     /* 1978514 */     GIR_EraseRootFromParent_Done,
     /* 1978515 */   // Label 26514: @1978515
     /* 1978515 */   GIM_Try, /*On fail goto*//*Label 26515*/ GIMT_Encode4(1978601), // Rule ID 61348 //
     /* 1978520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1978531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1978534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1978537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978566 */     // MIs[0] policy
     /* 1978566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978600 */     // GIR_Coverage, 61348,
     /* 1978600 */     GIR_EraseRootFromParent_Done,
     /* 1978601 */   // Label 26515: @1978601
     /* 1978601 */   GIM_Try, /*On fail goto*//*Label 26516*/ GIMT_Encode4(1978687), // Rule ID 61349 //
     /* 1978606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1978617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1978620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1978623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978652 */     // MIs[0] policy
     /* 1978652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978662 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978686 */     // GIR_Coverage, 61349,
     /* 1978686 */     GIR_EraseRootFromParent_Done,
     /* 1978687 */   // Label 26516: @1978687
     /* 1978687 */   GIM_Try, /*On fail goto*//*Label 26517*/ GIMT_Encode4(1978773), // Rule ID 61352 //
     /* 1978692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1978703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1978706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1978709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978738 */     // MIs[0] policy
     /* 1978738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978748 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978772 */     // GIR_Coverage, 61352,
     /* 1978772 */     GIR_EraseRootFromParent_Done,
     /* 1978773 */   // Label 26517: @1978773
     /* 1978773 */   GIM_Try, /*On fail goto*//*Label 26518*/ GIMT_Encode4(1978859), // Rule ID 61353 //
     /* 1978778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1978789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1978792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1978795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978824 */     // MIs[0] policy
     /* 1978824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978834 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978858 */     // GIR_Coverage, 61353,
     /* 1978858 */     GIR_EraseRootFromParent_Done,
     /* 1978859 */   // Label 26518: @1978859
     /* 1978859 */   GIM_Try, /*On fail goto*//*Label 26519*/ GIMT_Encode4(1978945), // Rule ID 61356 //
     /* 1978864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1978875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1978878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1978881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1978887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978910 */     // MIs[0] policy
     /* 1978910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978920 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1978923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978944 */     // GIR_Coverage, 61356,
     /* 1978944 */     GIR_EraseRootFromParent_Done,
     /* 1978945 */   // Label 26519: @1978945
     /* 1978945 */   GIM_Try, /*On fail goto*//*Label 26520*/ GIMT_Encode4(1979031), // Rule ID 61357 //
     /* 1978950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1978961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1978964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1978967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1978973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978996 */     // MIs[0] policy
     /* 1978996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979030 */     // GIR_Coverage, 61357,
     /* 1979030 */     GIR_EraseRootFromParent_Done,
     /* 1979031 */   // Label 26520: @1979031
     /* 1979031 */   GIM_Try, /*On fail goto*//*Label 26521*/ GIMT_Encode4(1979117), // Rule ID 61360 //
     /* 1979036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1979047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1979050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1979053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979082 */     // MIs[0] policy
     /* 1979082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979092 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979116 */     // GIR_Coverage, 61360,
     /* 1979116 */     GIR_EraseRootFromParent_Done,
     /* 1979117 */   // Label 26521: @1979117
     /* 1979117 */   GIM_Try, /*On fail goto*//*Label 26522*/ GIMT_Encode4(1979203), // Rule ID 61361 //
     /* 1979122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1979133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1979136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1979139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979168 */     // MIs[0] policy
     /* 1979168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979178 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979202 */     // GIR_Coverage, 61361,
     /* 1979202 */     GIR_EraseRootFromParent_Done,
     /* 1979203 */   // Label 26522: @1979203
     /* 1979203 */   GIM_Try, /*On fail goto*//*Label 26523*/ GIMT_Encode4(1979289), // Rule ID 61364 //
     /* 1979208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1979219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1979222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1979225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1979231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979254 */     // MIs[0] policy
     /* 1979254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979264 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979288 */     // GIR_Coverage, 61364,
     /* 1979288 */     GIR_EraseRootFromParent_Done,
     /* 1979289 */   // Label 26523: @1979289
     /* 1979289 */   GIM_Try, /*On fail goto*//*Label 26524*/ GIMT_Encode4(1979375), // Rule ID 61365 //
     /* 1979294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1979305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1979308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1979311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1979317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979340 */     // MIs[0] policy
     /* 1979340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979350 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979374 */     // GIR_Coverage, 61365,
     /* 1979374 */     GIR_EraseRootFromParent_Done,
     /* 1979375 */   // Label 26524: @1979375
     /* 1979375 */   GIM_Try, /*On fail goto*//*Label 26525*/ GIMT_Encode4(1979461), // Rule ID 61368 //
     /* 1979380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1979391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1979394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1979397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979426 */     // MIs[0] policy
     /* 1979426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979436 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979460 */     // GIR_Coverage, 61368,
     /* 1979460 */     GIR_EraseRootFromParent_Done,
     /* 1979461 */   // Label 26525: @1979461
     /* 1979461 */   GIM_Try, /*On fail goto*//*Label 26526*/ GIMT_Encode4(1979547), // Rule ID 61369 //
     /* 1979466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1979477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1979480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1979483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979512 */     // MIs[0] policy
     /* 1979512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979522 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979546 */     // GIR_Coverage, 61369,
     /* 1979546 */     GIR_EraseRootFromParent_Done,
     /* 1979547 */   // Label 26526: @1979547
     /* 1979547 */   GIM_Try, /*On fail goto*//*Label 26527*/ GIMT_Encode4(1979633), // Rule ID 61372 //
     /* 1979552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1979563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1979566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1979569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979598 */     // MIs[0] policy
     /* 1979598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979608 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979632 */     // GIR_Coverage, 61372,
     /* 1979632 */     GIR_EraseRootFromParent_Done,
     /* 1979633 */   // Label 26527: @1979633
     /* 1979633 */   GIM_Try, /*On fail goto*//*Label 26528*/ GIMT_Encode4(1979719), // Rule ID 61373 //
     /* 1979638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1979649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1979652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1979655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979684 */     // MIs[0] policy
     /* 1979684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979694 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979718 */     // GIR_Coverage, 61373,
     /* 1979718 */     GIR_EraseRootFromParent_Done,
     /* 1979719 */   // Label 26528: @1979719
     /* 1979719 */   GIM_Try, /*On fail goto*//*Label 26529*/ GIMT_Encode4(1979805), // Rule ID 61376 //
     /* 1979724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1979735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1979738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1979741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979770 */     // MIs[0] policy
     /* 1979770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979780 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979804 */     // GIR_Coverage, 61376,
     /* 1979804 */     GIR_EraseRootFromParent_Done,
     /* 1979805 */   // Label 26529: @1979805
     /* 1979805 */   GIM_Try, /*On fail goto*//*Label 26530*/ GIMT_Encode4(1979891), // Rule ID 61377 //
     /* 1979810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1979821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1979824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1979827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979856 */     // MIs[0] policy
     /* 1979856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979866 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979890 */     // GIR_Coverage, 61377,
     /* 1979890 */     GIR_EraseRootFromParent_Done,
     /* 1979891 */   // Label 26530: @1979891
     /* 1979891 */   GIM_Try, /*On fail goto*//*Label 26531*/ GIMT_Encode4(1979977), // Rule ID 61380 //
     /* 1979896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1979907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1979910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1979913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1979919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979942 */     // MIs[0] policy
     /* 1979942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979976 */     // GIR_Coverage, 61380,
     /* 1979976 */     GIR_EraseRootFromParent_Done,
     /* 1979977 */   // Label 26531: @1979977
     /* 1979977 */   GIM_Try, /*On fail goto*//*Label 26532*/ GIMT_Encode4(1980063), // Rule ID 61381 //
     /* 1979982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1979993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1979996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1979999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980028 */     // MIs[0] policy
     /* 1980028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980038 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1980041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980062 */     // GIR_Coverage, 61381,
     /* 1980062 */     GIR_EraseRootFromParent_Done,
     /* 1980063 */   // Label 26532: @1980063
     /* 1980063 */   GIM_Try, /*On fail goto*//*Label 26533*/ GIMT_Encode4(1980149), // Rule ID 61384 //
     /* 1980068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1980079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1980082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1980085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980114 */     // MIs[0] policy
     /* 1980114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980124 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1980127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980148 */     // GIR_Coverage, 61384,
     /* 1980148 */     GIR_EraseRootFromParent_Done,
     /* 1980149 */   // Label 26533: @1980149
     /* 1980149 */   GIM_Try, /*On fail goto*//*Label 26534*/ GIMT_Encode4(1980235), // Rule ID 61385 //
     /* 1980154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1980165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1980168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1980171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980200 */     // MIs[0] policy
     /* 1980200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980210 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1980213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980234 */     // GIR_Coverage, 61385,
     /* 1980234 */     GIR_EraseRootFromParent_Done,
     /* 1980235 */   // Label 26534: @1980235
     /* 1980235 */   GIM_Try, /*On fail goto*//*Label 26535*/ GIMT_Encode4(1980321), // Rule ID 61388 //
     /* 1980240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1980251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1980254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1980257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980286 */     // MIs[0] policy
     /* 1980286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1980299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980320 */     // GIR_Coverage, 61388,
     /* 1980320 */     GIR_EraseRootFromParent_Done,
     /* 1980321 */   // Label 26535: @1980321
     /* 1980321 */   GIM_Try, /*On fail goto*//*Label 26536*/ GIMT_Encode4(1980407), // Rule ID 61389 //
     /* 1980326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1980337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1980340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1980343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980372 */     // MIs[0] policy
     /* 1980372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980382 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1980385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980406 */     // GIR_Coverage, 61389,
     /* 1980406 */     GIR_EraseRootFromParent_Done,
     /* 1980407 */   // Label 26536: @1980407
     /* 1980407 */   GIM_Try, /*On fail goto*//*Label 26537*/ GIMT_Encode4(1980493), // Rule ID 61392 //
     /* 1980412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1980423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1980426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1980429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980458 */     // MIs[0] policy
     /* 1980458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1980471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980492 */     // GIR_Coverage, 61392,
     /* 1980492 */     GIR_EraseRootFromParent_Done,
     /* 1980493 */   // Label 26537: @1980493
     /* 1980493 */   GIM_Try, /*On fail goto*//*Label 26538*/ GIMT_Encode4(1980579), // Rule ID 61393 //
     /* 1980498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1980509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1980512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1980515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980544 */     // MIs[0] policy
     /* 1980544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1980557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980578 */     // GIR_Coverage, 61393,
     /* 1980578 */     GIR_EraseRootFromParent_Done,
     /* 1980579 */   // Label 26538: @1980579
     /* 1980579 */   GIM_Try, /*On fail goto*//*Label 26539*/ GIMT_Encode4(1980665), // Rule ID 61396 //
     /* 1980584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1980595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1980598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1980601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980630 */     // MIs[0] policy
     /* 1980630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980640 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1980643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980664 */     // GIR_Coverage, 61396,
     /* 1980664 */     GIR_EraseRootFromParent_Done,
     /* 1980665 */   // Label 26539: @1980665
     /* 1980665 */   GIM_Try, /*On fail goto*//*Label 26540*/ GIMT_Encode4(1980751), // Rule ID 61397 //
     /* 1980670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1980681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1980684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1980687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980716 */     // MIs[0] policy
     /* 1980716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980726 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1980729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980750 */     // GIR_Coverage, 61397,
     /* 1980750 */     GIR_EraseRootFromParent_Done,
     /* 1980751 */   // Label 26540: @1980751
     /* 1980751 */   GIM_Try, /*On fail goto*//*Label 26541*/ GIMT_Encode4(1980837), // Rule ID 61400 //
     /* 1980756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1980767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1980770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1980773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980802 */     // MIs[0] policy
     /* 1980802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980812 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1980815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980836 */     // GIR_Coverage, 61400,
     /* 1980836 */     GIR_EraseRootFromParent_Done,
     /* 1980837 */   // Label 26541: @1980837
     /* 1980837 */   GIM_Try, /*On fail goto*//*Label 26542*/ GIMT_Encode4(1980923), // Rule ID 61401 //
     /* 1980842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1980853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1980856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1980859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980888 */     // MIs[0] policy
     /* 1980888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980898 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1980901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980922 */     // GIR_Coverage, 61401,
     /* 1980922 */     GIR_EraseRootFromParent_Done,
     /* 1980923 */   // Label 26542: @1980923
     /* 1980923 */   GIM_Try, /*On fail goto*//*Label 26543*/ GIMT_Encode4(1981009), // Rule ID 61580 //
     /* 1980928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1980939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1980942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1980945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1980948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1980951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980974 */     // MIs[0] policy
     /* 1980974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980984 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1980987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981008 */     // GIR_Coverage, 61580,
     /* 1981008 */     GIR_EraseRootFromParent_Done,
     /* 1981009 */   // Label 26543: @1981009
     /* 1981009 */   GIM_Try, /*On fail goto*//*Label 26544*/ GIMT_Encode4(1981095), // Rule ID 61581 //
     /* 1981014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1981025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1981028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1981031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1981034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981060 */     // MIs[0] policy
     /* 1981060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981070 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1981073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981094 */     // GIR_Coverage, 61581,
     /* 1981094 */     GIR_EraseRootFromParent_Done,
     /* 1981095 */   // Label 26544: @1981095
     /* 1981095 */   GIM_Try, /*On fail goto*//*Label 26545*/ GIMT_Encode4(1981181), // Rule ID 61584 //
     /* 1981100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1981111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1981114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1981117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1981120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981146 */     // MIs[0] policy
     /* 1981146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981156 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1981159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981180 */     // GIR_Coverage, 61584,
     /* 1981180 */     GIR_EraseRootFromParent_Done,
     /* 1981181 */   // Label 26545: @1981181
     /* 1981181 */   GIM_Try, /*On fail goto*//*Label 26546*/ GIMT_Encode4(1981267), // Rule ID 61585 //
     /* 1981186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1981197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1981200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1981203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1981206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981232 */     // MIs[0] policy
     /* 1981232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981242 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1981245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981266 */     // GIR_Coverage, 61585,
     /* 1981266 */     GIR_EraseRootFromParent_Done,
     /* 1981267 */   // Label 26546: @1981267
     /* 1981267 */   GIM_Try, /*On fail goto*//*Label 26547*/ GIMT_Encode4(1981353), // Rule ID 61588 //
     /* 1981272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1981283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1981286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1981289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1981292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981318 */     // MIs[0] policy
     /* 1981318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981328 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981352 */     // GIR_Coverage, 61588,
     /* 1981352 */     GIR_EraseRootFromParent_Done,
     /* 1981353 */   // Label 26547: @1981353
     /* 1981353 */   GIM_Try, /*On fail goto*//*Label 26548*/ GIMT_Encode4(1981439), // Rule ID 61589 //
     /* 1981358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1981369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1981372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1981375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1981378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981404 */     // MIs[0] policy
     /* 1981404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981414 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981438 */     // GIR_Coverage, 61589,
     /* 1981438 */     GIR_EraseRootFromParent_Done,
     /* 1981439 */   // Label 26548: @1981439
     /* 1981439 */   GIM_Try, /*On fail goto*//*Label 26549*/ GIMT_Encode4(1981525), // Rule ID 61592 //
     /* 1981444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1981455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1981458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1981461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1981464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981490 */     // MIs[0] policy
     /* 1981490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981500 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1981503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981524 */     // GIR_Coverage, 61592,
     /* 1981524 */     GIR_EraseRootFromParent_Done,
     /* 1981525 */   // Label 26549: @1981525
     /* 1981525 */   GIM_Try, /*On fail goto*//*Label 26550*/ GIMT_Encode4(1981611), // Rule ID 61593 //
     /* 1981530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1981541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1981544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1981547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1981550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981576 */     // MIs[0] policy
     /* 1981576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1981589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981610 */     // GIR_Coverage, 61593,
     /* 1981610 */     GIR_EraseRootFromParent_Done,
     /* 1981611 */   // Label 26550: @1981611
     /* 1981611 */   GIM_Try, /*On fail goto*//*Label 26551*/ GIMT_Encode4(1981697), // Rule ID 61596 //
     /* 1981616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1981627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1981630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1981633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1981636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981662 */     // MIs[0] policy
     /* 1981662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981672 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981696 */     // GIR_Coverage, 61596,
     /* 1981696 */     GIR_EraseRootFromParent_Done,
     /* 1981697 */   // Label 26551: @1981697
     /* 1981697 */   GIM_Try, /*On fail goto*//*Label 26552*/ GIMT_Encode4(1981783), // Rule ID 61597 //
     /* 1981702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1981713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1981716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1981719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1981722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981748 */     // MIs[0] policy
     /* 1981748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981758 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981782 */     // GIR_Coverage, 61597,
     /* 1981782 */     GIR_EraseRootFromParent_Done,
     /* 1981783 */   // Label 26552: @1981783
     /* 1981783 */   GIM_Try, /*On fail goto*//*Label 26553*/ GIMT_Encode4(1981869), // Rule ID 61600 //
     /* 1981788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1981799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1981802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1981805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1981808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981834 */     // MIs[0] policy
     /* 1981834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981844 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981868 */     // GIR_Coverage, 61600,
     /* 1981868 */     GIR_EraseRootFromParent_Done,
     /* 1981869 */   // Label 26553: @1981869
     /* 1981869 */   GIM_Try, /*On fail goto*//*Label 26554*/ GIMT_Encode4(1981955), // Rule ID 61601 //
     /* 1981874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1981885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1981888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1981891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1981894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981920 */     // MIs[0] policy
     /* 1981920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981930 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981954 */     // GIR_Coverage, 61601,
     /* 1981954 */     GIR_EraseRootFromParent_Done,
     /* 1981955 */   // Label 26554: @1981955
     /* 1981955 */   GIM_Try, /*On fail goto*//*Label 26555*/ GIMT_Encode4(1982041), // Rule ID 61604 //
     /* 1981960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1981971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1981974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1981977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1981980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982006 */     // MIs[0] policy
     /* 1982006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982016 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982040 */     // GIR_Coverage, 61604,
     /* 1982040 */     GIR_EraseRootFromParent_Done,
     /* 1982041 */   // Label 26555: @1982041
     /* 1982041 */   GIM_Try, /*On fail goto*//*Label 26556*/ GIMT_Encode4(1982127), // Rule ID 61605 //
     /* 1982046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1982057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1982060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1982063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1982066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1982069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982092 */     // MIs[0] policy
     /* 1982092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982126 */     // GIR_Coverage, 61605,
     /* 1982126 */     GIR_EraseRootFromParent_Done,
     /* 1982127 */   // Label 26556: @1982127
     /* 1982127 */   GIM_Try, /*On fail goto*//*Label 26557*/ GIMT_Encode4(1982213), // Rule ID 61608 //
     /* 1982132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1982143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1982146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1982149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1982152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1982155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982178 */     // MIs[0] policy
     /* 1982178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982188 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982212 */     // GIR_Coverage, 61608,
     /* 1982212 */     GIR_EraseRootFromParent_Done,
     /* 1982213 */   // Label 26557: @1982213
     /* 1982213 */   GIM_Try, /*On fail goto*//*Label 26558*/ GIMT_Encode4(1982299), // Rule ID 61609 //
     /* 1982218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1982229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1982232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1982235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1982238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1982241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982264 */     // MIs[0] policy
     /* 1982264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982274 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982298 */     // GIR_Coverage, 61609,
     /* 1982298 */     GIR_EraseRootFromParent_Done,
     /* 1982299 */   // Label 26558: @1982299
     /* 1982299 */   GIM_Try, /*On fail goto*//*Label 26559*/ GIMT_Encode4(1982385), // Rule ID 61612 //
     /* 1982304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1982315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1982318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1982321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1982324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982350 */     // MIs[0] policy
     /* 1982350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982384 */     // GIR_Coverage, 61612,
     /* 1982384 */     GIR_EraseRootFromParent_Done,
     /* 1982385 */   // Label 26559: @1982385
     /* 1982385 */   GIM_Try, /*On fail goto*//*Label 26560*/ GIMT_Encode4(1982471), // Rule ID 61613 //
     /* 1982390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1982401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1982404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1982407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1982410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982436 */     // MIs[0] policy
     /* 1982436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982446 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982470 */     // GIR_Coverage, 61613,
     /* 1982470 */     GIR_EraseRootFromParent_Done,
     /* 1982471 */   // Label 26560: @1982471
     /* 1982471 */   GIM_Try, /*On fail goto*//*Label 26561*/ GIMT_Encode4(1982557), // Rule ID 61616 //
     /* 1982476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1982487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1982490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1982493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1982496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982522 */     // MIs[0] policy
     /* 1982522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982532 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1982553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982556 */     // GIR_Coverage, 61616,
     /* 1982556 */     GIR_EraseRootFromParent_Done,
     /* 1982557 */   // Label 26561: @1982557
     /* 1982557 */   GIM_Try, /*On fail goto*//*Label 26562*/ GIMT_Encode4(1982643), // Rule ID 61617 //
     /* 1982562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1982573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1982576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1982579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1982582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982608 */     // MIs[0] policy
     /* 1982608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982618 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1982639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982642 */     // GIR_Coverage, 61617,
     /* 1982642 */     GIR_EraseRootFromParent_Done,
     /* 1982643 */   // Label 26562: @1982643
     /* 1982643 */   GIM_Try, /*On fail goto*//*Label 26563*/ GIMT_Encode4(1982729), // Rule ID 61620 //
     /* 1982648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1982659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1982662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1982665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1982668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982694 */     // MIs[0] policy
     /* 1982694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1982707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982728 */     // GIR_Coverage, 61620,
     /* 1982728 */     GIR_EraseRootFromParent_Done,
     /* 1982729 */   // Label 26563: @1982729
     /* 1982729 */   GIM_Try, /*On fail goto*//*Label 26564*/ GIMT_Encode4(1982815), // Rule ID 61621 //
     /* 1982734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1982745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1982748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1982751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1982754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982780 */     // MIs[0] policy
     /* 1982780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982790 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1982793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982814 */     // GIR_Coverage, 61621,
     /* 1982814 */     GIR_EraseRootFromParent_Done,
     /* 1982815 */   // Label 26564: @1982815
     /* 1982815 */   GIM_Try, /*On fail goto*//*Label 26565*/ GIMT_Encode4(1982901), // Rule ID 61624 //
     /* 1982820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1982831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1982834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1982837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1982840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1982843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982866 */     // MIs[0] policy
     /* 1982866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982876 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1982879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982900 */     // GIR_Coverage, 61624,
     /* 1982900 */     GIR_EraseRootFromParent_Done,
     /* 1982901 */   // Label 26565: @1982901
     /* 1982901 */   GIM_Try, /*On fail goto*//*Label 26566*/ GIMT_Encode4(1982987), // Rule ID 61625 //
     /* 1982906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1982917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1982920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1982923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1982926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1982929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982952 */     // MIs[0] policy
     /* 1982952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982962 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1982965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982986 */     // GIR_Coverage, 61625,
     /* 1982986 */     GIR_EraseRootFromParent_Done,
     /* 1982987 */   // Label 26566: @1982987
     /* 1982987 */   GIM_Try, /*On fail goto*//*Label 26567*/ GIMT_Encode4(1983073), // Rule ID 61628 //
     /* 1982992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1983003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1983006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1983009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1983012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1983015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983038 */     // MIs[0] policy
     /* 1983038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983048 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983072 */     // GIR_Coverage, 61628,
     /* 1983072 */     GIR_EraseRootFromParent_Done,
     /* 1983073 */   // Label 26567: @1983073
     /* 1983073 */   GIM_Try, /*On fail goto*//*Label 26568*/ GIMT_Encode4(1983159), // Rule ID 61629 //
     /* 1983078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1983089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1983092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1983095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1983098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1983101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983124 */     // MIs[0] policy
     /* 1983124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983134 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983158 */     // GIR_Coverage, 61629,
     /* 1983158 */     GIR_EraseRootFromParent_Done,
     /* 1983159 */   // Label 26568: @1983159
     /* 1983159 */   GIM_Try, /*On fail goto*//*Label 26569*/ GIMT_Encode4(1983245), // Rule ID 61632 //
     /* 1983164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1983175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1983178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1983181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1983184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983210 */     // MIs[0] policy
     /* 1983210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983244 */     // GIR_Coverage, 61632,
     /* 1983244 */     GIR_EraseRootFromParent_Done,
     /* 1983245 */   // Label 26569: @1983245
     /* 1983245 */   GIM_Try, /*On fail goto*//*Label 26570*/ GIMT_Encode4(1983331), // Rule ID 61633 //
     /* 1983250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1983261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1983264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1983267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1983270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983296 */     // MIs[0] policy
     /* 1983296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983330 */     // GIR_Coverage, 61633,
     /* 1983330 */     GIR_EraseRootFromParent_Done,
     /* 1983331 */   // Label 26570: @1983331
     /* 1983331 */   GIM_Try, /*On fail goto*//*Label 26571*/ GIMT_Encode4(1983417), // Rule ID 61636 //
     /* 1983336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1983347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1983350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1983353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1983356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983382 */     // MIs[0] policy
     /* 1983382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983392 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983416 */     // GIR_Coverage, 61636,
     /* 1983416 */     GIR_EraseRootFromParent_Done,
     /* 1983417 */   // Label 26571: @1983417
     /* 1983417 */   GIM_Try, /*On fail goto*//*Label 26572*/ GIMT_Encode4(1983503), // Rule ID 61637 //
     /* 1983422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1983433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1983436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1983439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1983442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983468 */     // MIs[0] policy
     /* 1983468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983478 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983502 */     // GIR_Coverage, 61637,
     /* 1983502 */     GIR_EraseRootFromParent_Done,
     /* 1983503 */   // Label 26572: @1983503
     /* 1983503 */   GIM_Try, /*On fail goto*//*Label 26573*/ GIMT_Encode4(1983589), // Rule ID 61640 //
     /* 1983508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1983519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1983522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1983525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1983528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983554 */     // MIs[0] policy
     /* 1983554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983564 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983588 */     // GIR_Coverage, 61640,
     /* 1983588 */     GIR_EraseRootFromParent_Done,
     /* 1983589 */   // Label 26573: @1983589
     /* 1983589 */   GIM_Try, /*On fail goto*//*Label 26574*/ GIMT_Encode4(1983675), // Rule ID 61641 //
     /* 1983594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1983605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1983608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1983611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1983614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983640 */     // MIs[0] policy
     /* 1983640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983650 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983674 */     // GIR_Coverage, 61641,
     /* 1983674 */     GIR_EraseRootFromParent_Done,
     /* 1983675 */   // Label 26574: @1983675
     /* 1983675 */   GIM_Try, /*On fail goto*//*Label 26575*/ GIMT_Encode4(1983761), // Rule ID 61644 //
     /* 1983680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1983691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1983694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1983697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1983700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983726 */     // MIs[0] policy
     /* 1983726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983760 */     // GIR_Coverage, 61644,
     /* 1983760 */     GIR_EraseRootFromParent_Done,
     /* 1983761 */   // Label 26575: @1983761
     /* 1983761 */   GIM_Try, /*On fail goto*//*Label 26576*/ GIMT_Encode4(1983847), // Rule ID 61645 //
     /* 1983766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1983777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1983780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1983783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1983786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983812 */     // MIs[0] policy
     /* 1983812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983846 */     // GIR_Coverage, 61645,
     /* 1983846 */     GIR_EraseRootFromParent_Done,
     /* 1983847 */   // Label 26576: @1983847
     /* 1983847 */   GIM_Try, /*On fail goto*//*Label 26577*/ GIMT_Encode4(1983933), // Rule ID 61648 //
     /* 1983852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1983863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1983866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1983869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1983872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983898 */     // MIs[0] policy
     /* 1983898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983932 */     // GIR_Coverage, 61648,
     /* 1983932 */     GIR_EraseRootFromParent_Done,
     /* 1983933 */   // Label 26577: @1983933
     /* 1983933 */   GIM_Try, /*On fail goto*//*Label 26578*/ GIMT_Encode4(1984019), // Rule ID 61649 //
     /* 1983938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1983949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1983952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1983955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1983958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983984 */     // MIs[0] policy
     /* 1983984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984018 */     // GIR_Coverage, 61649,
     /* 1984018 */     GIR_EraseRootFromParent_Done,
     /* 1984019 */   // Label 26578: @1984019
     /* 1984019 */   GIM_Try, /*On fail goto*//*Label 26579*/ GIMT_Encode4(1984105), // Rule ID 61652 //
     /* 1984024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1984035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1984038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1984041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1984044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1984047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984070 */     // MIs[0] policy
     /* 1984070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984080 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1984083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984104 */     // GIR_Coverage, 61652,
     /* 1984104 */     GIR_EraseRootFromParent_Done,
     /* 1984105 */   // Label 26579: @1984105
     /* 1984105 */   GIM_Try, /*On fail goto*//*Label 26580*/ GIMT_Encode4(1984191), // Rule ID 61653 //
     /* 1984110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1984121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1984124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1984127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1984130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1984133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984156 */     // MIs[0] policy
     /* 1984156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1984169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984190 */     // GIR_Coverage, 61653,
     /* 1984190 */     GIR_EraseRootFromParent_Done,
     /* 1984191 */   // Label 26580: @1984191
     /* 1984191 */   GIM_Try, /*On fail goto*//*Label 26581*/ GIMT_Encode4(1984277), // Rule ID 61656 //
     /* 1984196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1984207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1984210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1984213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1984216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984242 */     // MIs[0] policy
     /* 1984242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1984255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984276 */     // GIR_Coverage, 61656,
     /* 1984276 */     GIR_EraseRootFromParent_Done,
     /* 1984277 */   // Label 26581: @1984277
     /* 1984277 */   GIM_Try, /*On fail goto*//*Label 26582*/ GIMT_Encode4(1984363), // Rule ID 61657 //
     /* 1984282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1984293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1984296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1984299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1984302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984328 */     // MIs[0] policy
     /* 1984328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984338 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1984341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984362 */     // GIR_Coverage, 61657,
     /* 1984362 */     GIR_EraseRootFromParent_Done,
     /* 1984363 */   // Label 26582: @1984363
     /* 1984363 */   GIM_Try, /*On fail goto*//*Label 26583*/ GIMT_Encode4(1984449), // Rule ID 61660 //
     /* 1984368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1984379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1984382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1984385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1984388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984414 */     // MIs[0] policy
     /* 1984414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984424 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1984427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984448 */     // GIR_Coverage, 61660,
     /* 1984448 */     GIR_EraseRootFromParent_Done,
     /* 1984449 */   // Label 26583: @1984449
     /* 1984449 */   GIM_Try, /*On fail goto*//*Label 26584*/ GIMT_Encode4(1984535), // Rule ID 61661 //
     /* 1984454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1984465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1984468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1984471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1984474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984500 */     // MIs[0] policy
     /* 1984500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984510 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1984513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984534 */     // GIR_Coverage, 61661,
     /* 1984534 */     GIR_EraseRootFromParent_Done,
     /* 1984535 */   // Label 26584: @1984535
     /* 1984535 */   GIM_Try, /*On fail goto*//*Label 26585*/ GIMT_Encode4(1984621), // Rule ID 61664 //
     /* 1984540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1984551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1984554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1984557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1984560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984586 */     // MIs[0] policy
     /* 1984586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984596 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1984599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984620 */     // GIR_Coverage, 61664,
     /* 1984620 */     GIR_EraseRootFromParent_Done,
     /* 1984621 */   // Label 26585: @1984621
     /* 1984621 */   GIM_Try, /*On fail goto*//*Label 26586*/ GIMT_Encode4(1984707), // Rule ID 61665 //
     /* 1984626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1984637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1984640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1984643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1984646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984672 */     // MIs[0] policy
     /* 1984672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984682 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1984685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984706 */     // GIR_Coverage, 61665,
     /* 1984706 */     GIR_EraseRootFromParent_Done,
     /* 1984707 */   // Label 26586: @1984707
     /* 1984707 */   GIM_Try, /*On fail goto*//*Label 26587*/ GIMT_Encode4(1984793), // Rule ID 61668 //
     /* 1984712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1984723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1984726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1984729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984758 */     // MIs[0] policy
     /* 1984758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984768 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1984771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984792 */     // GIR_Coverage, 61668,
     /* 1984792 */     GIR_EraseRootFromParent_Done,
     /* 1984793 */   // Label 26587: @1984793
     /* 1984793 */   GIM_Try, /*On fail goto*//*Label 26588*/ GIMT_Encode4(1984879), // Rule ID 61669 //
     /* 1984798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1984809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1984812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1984815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984844 */     // MIs[0] policy
     /* 1984844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984854 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1984857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984878 */     // GIR_Coverage, 61669,
     /* 1984878 */     GIR_EraseRootFromParent_Done,
     /* 1984879 */   // Label 26588: @1984879
     /* 1984879 */   GIM_Try, /*On fail goto*//*Label 26589*/ GIMT_Encode4(1984965), // Rule ID 61672 //
     /* 1984884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1984895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1984898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1984901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984930 */     // MIs[0] policy
     /* 1984930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984940 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1984943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984964 */     // GIR_Coverage, 61672,
     /* 1984964 */     GIR_EraseRootFromParent_Done,
     /* 1984965 */   // Label 26589: @1984965
     /* 1984965 */   GIM_Try, /*On fail goto*//*Label 26590*/ GIMT_Encode4(1985051), // Rule ID 61673 //
     /* 1984970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1984981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1984984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1984987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985016 */     // MIs[0] policy
     /* 1985016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985026 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1985029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985050 */     // GIR_Coverage, 61673,
     /* 1985050 */     GIR_EraseRootFromParent_Done,
     /* 1985051 */   // Label 26590: @1985051
     /* 1985051 */   GIM_Try, /*On fail goto*//*Label 26591*/ GIMT_Encode4(1985137), // Rule ID 61676 //
     /* 1985056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1985067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1985070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1985073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985102 */     // MIs[0] policy
     /* 1985102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985112 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985136 */     // GIR_Coverage, 61676,
     /* 1985136 */     GIR_EraseRootFromParent_Done,
     /* 1985137 */   // Label 26591: @1985137
     /* 1985137 */   GIM_Try, /*On fail goto*//*Label 26592*/ GIMT_Encode4(1985223), // Rule ID 61677 //
     /* 1985142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1985153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1985156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1985159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985188 */     // MIs[0] policy
     /* 1985188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985198 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985222 */     // GIR_Coverage, 61677,
     /* 1985222 */     GIR_EraseRootFromParent_Done,
     /* 1985223 */   // Label 26592: @1985223
     /* 1985223 */   GIM_Try, /*On fail goto*//*Label 26593*/ GIMT_Encode4(1985309), // Rule ID 61680 //
     /* 1985228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1985239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1985242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1985245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985274 */     // MIs[0] policy
     /* 1985274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985284 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1985287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985308 */     // GIR_Coverage, 61680,
     /* 1985308 */     GIR_EraseRootFromParent_Done,
     /* 1985309 */   // Label 26593: @1985309
     /* 1985309 */   GIM_Try, /*On fail goto*//*Label 26594*/ GIMT_Encode4(1985395), // Rule ID 61681 //
     /* 1985314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1985325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1985328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1985331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985360 */     // MIs[0] policy
     /* 1985360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985370 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1985373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985394 */     // GIR_Coverage, 61681,
     /* 1985394 */     GIR_EraseRootFromParent_Done,
     /* 1985395 */   // Label 26594: @1985395
     /* 1985395 */   GIM_Try, /*On fail goto*//*Label 26595*/ GIMT_Encode4(1985481), // Rule ID 61684 //
     /* 1985400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1985411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1985414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1985417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985446 */     // MIs[0] policy
     /* 1985446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985456 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985480 */     // GIR_Coverage, 61684,
     /* 1985480 */     GIR_EraseRootFromParent_Done,
     /* 1985481 */   // Label 26595: @1985481
     /* 1985481 */   GIM_Try, /*On fail goto*//*Label 26596*/ GIMT_Encode4(1985567), // Rule ID 61685 //
     /* 1985486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1985497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1985500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1985503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985532 */     // MIs[0] policy
     /* 1985532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985542 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985566 */     // GIR_Coverage, 61685,
     /* 1985566 */     GIR_EraseRootFromParent_Done,
     /* 1985567 */   // Label 26596: @1985567
     /* 1985567 */   GIM_Try, /*On fail goto*//*Label 26597*/ GIMT_Encode4(1985653), // Rule ID 61688 //
     /* 1985572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1985583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1985586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1985589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985618 */     // MIs[0] policy
     /* 1985618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985628 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985652 */     // GIR_Coverage, 61688,
     /* 1985652 */     GIR_EraseRootFromParent_Done,
     /* 1985653 */   // Label 26597: @1985653
     /* 1985653 */   GIM_Try, /*On fail goto*//*Label 26598*/ GIMT_Encode4(1985739), // Rule ID 61689 //
     /* 1985658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1985669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1985672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1985675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985704 */     // MIs[0] policy
     /* 1985704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985738 */     // GIR_Coverage, 61689,
     /* 1985738 */     GIR_EraseRootFromParent_Done,
     /* 1985739 */   // Label 26598: @1985739
     /* 1985739 */   GIM_Try, /*On fail goto*//*Label 26599*/ GIMT_Encode4(1985825), // Rule ID 61692 //
     /* 1985744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1985755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1985758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1985761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985790 */     // MIs[0] policy
     /* 1985790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985800 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985824 */     // GIR_Coverage, 61692,
     /* 1985824 */     GIR_EraseRootFromParent_Done,
     /* 1985825 */   // Label 26599: @1985825
     /* 1985825 */   GIM_Try, /*On fail goto*//*Label 26600*/ GIMT_Encode4(1985911), // Rule ID 61693 //
     /* 1985830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1985841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1985844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1985847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985876 */     // MIs[0] policy
     /* 1985876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985886 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985910 */     // GIR_Coverage, 61693,
     /* 1985910 */     GIR_EraseRootFromParent_Done,
     /* 1985911 */   // Label 26600: @1985911
     /* 1985911 */   GIM_Try, /*On fail goto*//*Label 26601*/ GIMT_Encode4(1985997), // Rule ID 61696 //
     /* 1985916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1985927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1985930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1985933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985962 */     // MIs[0] policy
     /* 1985962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985972 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985996 */     // GIR_Coverage, 61696,
     /* 1985996 */     GIR_EraseRootFromParent_Done,
     /* 1985997 */   // Label 26601: @1985997
     /* 1985997 */   GIM_Try, /*On fail goto*//*Label 26602*/ GIMT_Encode4(1986083), // Rule ID 61697 //
     /* 1986002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1986013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1986016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1986019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1986025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986048 */     // MIs[0] policy
     /* 1986048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1986061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986082 */     // GIR_Coverage, 61697,
     /* 1986082 */     GIR_EraseRootFromParent_Done,
     /* 1986083 */   // Label 26602: @1986083
     /* 1986083 */   GIM_Try, /*On fail goto*//*Label 26603*/ GIMT_Encode4(1986169), // Rule ID 61700 //
     /* 1986088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1986099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1986102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1986105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1986111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986134 */     // MIs[0] policy
     /* 1986134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1986147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1986165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986168 */     // GIR_Coverage, 61700,
     /* 1986168 */     GIR_EraseRootFromParent_Done,
     /* 1986169 */   // Label 26603: @1986169
     /* 1986169 */   GIM_Try, /*On fail goto*//*Label 26604*/ GIMT_Encode4(1986255), // Rule ID 61701 //
     /* 1986174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1986185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1986188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1986191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1986197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986220 */     // MIs[0] policy
     /* 1986220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1986233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1986251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986254 */     // GIR_Coverage, 61701,
     /* 1986254 */     GIR_EraseRootFromParent_Done,
     /* 1986255 */   // Label 26604: @1986255
     /* 1986255 */   GIM_Try, /*On fail goto*//*Label 26605*/ GIMT_Encode4(1986341), // Rule ID 61704 //
     /* 1986260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1986271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1986274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1986277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986306 */     // MIs[0] policy
     /* 1986306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1986319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1986337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986340 */     // GIR_Coverage, 61704,
     /* 1986340 */     GIR_EraseRootFromParent_Done,
     /* 1986341 */   // Label 26605: @1986341
     /* 1986341 */   GIM_Try, /*On fail goto*//*Label 26606*/ GIMT_Encode4(1986427), // Rule ID 61705 //
     /* 1986346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1986357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1986360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1986363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986392 */     // MIs[0] policy
     /* 1986392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1986405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1986423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986426 */     // GIR_Coverage, 61705,
     /* 1986426 */     GIR_EraseRootFromParent_Done,
     /* 1986427 */   // Label 26606: @1986427
     /* 1986427 */   GIM_Try, /*On fail goto*//*Label 26607*/ GIMT_Encode4(1986513), // Rule ID 61708 //
     /* 1986432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1986443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1986446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1986449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986478 */     // MIs[0] policy
     /* 1986478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986488 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986512 */     // GIR_Coverage, 61708,
     /* 1986512 */     GIR_EraseRootFromParent_Done,
     /* 1986513 */   // Label 26607: @1986513
     /* 1986513 */   GIM_Try, /*On fail goto*//*Label 26608*/ GIMT_Encode4(1986599), // Rule ID 61709 //
     /* 1986518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1986529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1986532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1986535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986564 */     // MIs[0] policy
     /* 1986564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986574 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986598 */     // GIR_Coverage, 61709,
     /* 1986598 */     GIR_EraseRootFromParent_Done,
     /* 1986599 */   // Label 26608: @1986599
     /* 1986599 */   GIM_Try, /*On fail goto*//*Label 26609*/ GIMT_Encode4(1986685), // Rule ID 61712 //
     /* 1986604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1986615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1986618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1986621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986650 */     // MIs[0] policy
     /* 1986650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986660 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1986663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986684 */     // GIR_Coverage, 61712,
     /* 1986684 */     GIR_EraseRootFromParent_Done,
     /* 1986685 */   // Label 26609: @1986685
     /* 1986685 */   GIM_Try, /*On fail goto*//*Label 26610*/ GIMT_Encode4(1986771), // Rule ID 61713 //
     /* 1986690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1986701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1986704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1986707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986736 */     // MIs[0] policy
     /* 1986736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986746 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1986749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986770 */     // GIR_Coverage, 61713,
     /* 1986770 */     GIR_EraseRootFromParent_Done,
     /* 1986771 */   // Label 26610: @1986771
     /* 1986771 */   GIM_Try, /*On fail goto*//*Label 26611*/ GIMT_Encode4(1986857), // Rule ID 61716 //
     /* 1986776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1986787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1986790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1986793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1986799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986822 */     // MIs[0] policy
     /* 1986822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986832 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1986835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986856 */     // GIR_Coverage, 61716,
     /* 1986856 */     GIR_EraseRootFromParent_Done,
     /* 1986857 */   // Label 26611: @1986857
     /* 1986857 */   GIM_Try, /*On fail goto*//*Label 26612*/ GIMT_Encode4(1986943), // Rule ID 61717 //
     /* 1986862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1986873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1986876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1986879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1986885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986908 */     // MIs[0] policy
     /* 1986908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986918 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1986921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986942 */     // GIR_Coverage, 61717,
     /* 1986942 */     GIR_EraseRootFromParent_Done,
     /* 1986943 */   // Label 26612: @1986943
     /* 1986943 */   GIM_Try, /*On fail goto*//*Label 26613*/ GIMT_Encode4(1987029), // Rule ID 61720 //
     /* 1986948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1986959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1986962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1986965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986994 */     // MIs[0] policy
     /* 1986994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987004 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987028 */     // GIR_Coverage, 61720,
     /* 1987028 */     GIR_EraseRootFromParent_Done,
     /* 1987029 */   // Label 26613: @1987029
     /* 1987029 */   GIM_Try, /*On fail goto*//*Label 26614*/ GIMT_Encode4(1987115), // Rule ID 61721 //
     /* 1987034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1987045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1987048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1987051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987080 */     // MIs[0] policy
     /* 1987080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987114 */     // GIR_Coverage, 61721,
     /* 1987114 */     GIR_EraseRootFromParent_Done,
     /* 1987115 */   // Label 26614: @1987115
     /* 1987115 */   GIM_Try, /*On fail goto*//*Label 26615*/ GIMT_Encode4(1987201), // Rule ID 61724 //
     /* 1987120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1987131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1987134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1987137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987166 */     // MIs[0] policy
     /* 1987166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987176 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987200 */     // GIR_Coverage, 61724,
     /* 1987200 */     GIR_EraseRootFromParent_Done,
     /* 1987201 */   // Label 26615: @1987201
     /* 1987201 */   GIM_Try, /*On fail goto*//*Label 26616*/ GIMT_Encode4(1987287), // Rule ID 61725 //
     /* 1987206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1987217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1987220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1987223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987252 */     // MIs[0] policy
     /* 1987252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987262 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987286 */     // GIR_Coverage, 61725,
     /* 1987286 */     GIR_EraseRootFromParent_Done,
     /* 1987287 */   // Label 26616: @1987287
     /* 1987287 */   GIM_Try, /*On fail goto*//*Label 26617*/ GIMT_Encode4(1987373), // Rule ID 61728 //
     /* 1987292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1987303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1987306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1987309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1987315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987338 */     // MIs[0] policy
     /* 1987338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987348 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987372 */     // GIR_Coverage, 61728,
     /* 1987372 */     GIR_EraseRootFromParent_Done,
     /* 1987373 */   // Label 26617: @1987373
     /* 1987373 */   GIM_Try, /*On fail goto*//*Label 26618*/ GIMT_Encode4(1987459), // Rule ID 61729 //
     /* 1987378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1987389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1987392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1987395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1987401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987424 */     // MIs[0] policy
     /* 1987424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987434 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987458 */     // GIR_Coverage, 61729,
     /* 1987458 */     GIR_EraseRootFromParent_Done,
     /* 1987459 */   // Label 26618: @1987459
     /* 1987459 */   GIM_Try, /*On fail goto*//*Label 26619*/ GIMT_Encode4(1987545), // Rule ID 61732 //
     /* 1987464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1987475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1987478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987510 */     // MIs[0] policy
     /* 1987510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987520 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987544 */     // GIR_Coverage, 61732,
     /* 1987544 */     GIR_EraseRootFromParent_Done,
     /* 1987545 */   // Label 26619: @1987545
     /* 1987545 */   GIM_Try, /*On fail goto*//*Label 26620*/ GIMT_Encode4(1987631), // Rule ID 61733 //
     /* 1987550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1987561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1987564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987596 */     // MIs[0] policy
     /* 1987596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987606 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987630 */     // GIR_Coverage, 61733,
     /* 1987630 */     GIR_EraseRootFromParent_Done,
     /* 1987631 */   // Label 26620: @1987631
     /* 1987631 */   GIM_Try, /*On fail goto*//*Label 26621*/ GIMT_Encode4(1987717), // Rule ID 61736 //
     /* 1987636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1987647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1987650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1987653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987682 */     // MIs[0] policy
     /* 1987682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987692 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987716 */     // GIR_Coverage, 61736,
     /* 1987716 */     GIR_EraseRootFromParent_Done,
     /* 1987717 */   // Label 26621: @1987717
     /* 1987717 */   GIM_Try, /*On fail goto*//*Label 26622*/ GIMT_Encode4(1987803), // Rule ID 61737 //
     /* 1987722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1987733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1987736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1987739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987768 */     // MIs[0] policy
     /* 1987768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987778 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987802 */     // GIR_Coverage, 61737,
     /* 1987802 */     GIR_EraseRootFromParent_Done,
     /* 1987803 */   // Label 26622: @1987803
     /* 1987803 */   GIM_Try, /*On fail goto*//*Label 26623*/ GIMT_Encode4(1987889), // Rule ID 61740 //
     /* 1987808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1987819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1987822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1987825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987854 */     // MIs[0] policy
     /* 1987854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987888 */     // GIR_Coverage, 61740,
     /* 1987888 */     GIR_EraseRootFromParent_Done,
     /* 1987889 */   // Label 26623: @1987889
     /* 1987889 */   GIM_Try, /*On fail goto*//*Label 26624*/ GIMT_Encode4(1987975), // Rule ID 61741 //
     /* 1987894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1987905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1987908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1987911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987940 */     // MIs[0] policy
     /* 1987940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987950 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987974 */     // GIR_Coverage, 61741,
     /* 1987974 */     GIR_EraseRootFromParent_Done,
     /* 1987975 */   // Label 26624: @1987975
     /* 1987975 */   GIM_Try, /*On fail goto*//*Label 26625*/ GIMT_Encode4(1988061), // Rule ID 61744 //
     /* 1987980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1987991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1987994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1987997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988026 */     // MIs[0] policy
     /* 1988026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1988039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988060 */     // GIR_Coverage, 61744,
     /* 1988060 */     GIR_EraseRootFromParent_Done,
     /* 1988061 */   // Label 26625: @1988061
     /* 1988061 */   GIM_Try, /*On fail goto*//*Label 26626*/ GIMT_Encode4(1988147), // Rule ID 61745 //
     /* 1988066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1988077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1988080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1988083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988112 */     // MIs[0] policy
     /* 1988112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1988125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988146 */     // GIR_Coverage, 61745,
     /* 1988146 */     GIR_EraseRootFromParent_Done,
     /* 1988147 */   // Label 26626: @1988147
     /* 1988147 */   GIM_Try, /*On fail goto*//*Label 26627*/ GIMT_Encode4(1988233), // Rule ID 61748 //
     /* 1988152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1988163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1988166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1988169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988198 */     // MIs[0] policy
     /* 1988198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988208 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1988211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988232 */     // GIR_Coverage, 61748,
     /* 1988232 */     GIR_EraseRootFromParent_Done,
     /* 1988233 */   // Label 26627: @1988233
     /* 1988233 */   GIM_Try, /*On fail goto*//*Label 26628*/ GIMT_Encode4(1988319), // Rule ID 61749 //
     /* 1988238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1988249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1988252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1988255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988284 */     // MIs[0] policy
     /* 1988284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988294 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1988297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988318 */     // GIR_Coverage, 61749,
     /* 1988318 */     GIR_EraseRootFromParent_Done,
     /* 1988319 */   // Label 26628: @1988319
     /* 1988319 */   GIM_Try, /*On fail goto*//*Label 26629*/ GIMT_Encode4(1988405), // Rule ID 61752 //
     /* 1988324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1988335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1988338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1988341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1988354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988370 */     // MIs[0] policy
     /* 1988370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988380 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1988383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988404 */     // GIR_Coverage, 61752,
     /* 1988404 */     GIR_EraseRootFromParent_Done,
     /* 1988405 */   // Label 26629: @1988405
     /* 1988405 */   GIM_Try, /*On fail goto*//*Label 26630*/ GIMT_Encode4(1988491), // Rule ID 61753 //
     /* 1988410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1988421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1988424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1988427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1988440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988456 */     // MIs[0] policy
     /* 1988456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988466 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1988469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988490 */     // GIR_Coverage, 61753,
     /* 1988490 */     GIR_EraseRootFromParent_Done,
     /* 1988491 */   // Label 26630: @1988491
     /* 1988491 */   GIM_Try, /*On fail goto*//*Label 26631*/ GIMT_Encode4(1988577), // Rule ID 61840 //
     /* 1988496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1988507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1988510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1988513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1988516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988542 */     // MIs[0] policy
     /* 1988542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988552 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1988555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988576 */     // GIR_Coverage, 61840,
     /* 1988576 */     GIR_EraseRootFromParent_Done,
     /* 1988577 */   // Label 26631: @1988577
     /* 1988577 */   GIM_Try, /*On fail goto*//*Label 26632*/ GIMT_Encode4(1988663), // Rule ID 61841 //
     /* 1988582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1988593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1988596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1988599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1988602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988628 */     // MIs[0] policy
     /* 1988628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988638 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1988641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988662 */     // GIR_Coverage, 61841,
     /* 1988662 */     GIR_EraseRootFromParent_Done,
     /* 1988663 */   // Label 26632: @1988663
     /* 1988663 */   GIM_Try, /*On fail goto*//*Label 26633*/ GIMT_Encode4(1988749), // Rule ID 61844 //
     /* 1988668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1988679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1988682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1988685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1988688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988714 */     // MIs[0] policy
     /* 1988714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988724 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1988727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988748 */     // GIR_Coverage, 61844,
     /* 1988748 */     GIR_EraseRootFromParent_Done,
     /* 1988749 */   // Label 26633: @1988749
     /* 1988749 */   GIM_Try, /*On fail goto*//*Label 26634*/ GIMT_Encode4(1988835), // Rule ID 61845 //
     /* 1988754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1988765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1988768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1988771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1988774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988800 */     // MIs[0] policy
     /* 1988800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988810 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1988813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988834 */     // GIR_Coverage, 61845,
     /* 1988834 */     GIR_EraseRootFromParent_Done,
     /* 1988835 */   // Label 26634: @1988835
     /* 1988835 */   GIM_Try, /*On fail goto*//*Label 26635*/ GIMT_Encode4(1988921), // Rule ID 61848 //
     /* 1988840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1988851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1988854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1988857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1988860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988886 */     // MIs[0] policy
     /* 1988886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988896 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988920 */     // GIR_Coverage, 61848,
     /* 1988920 */     GIR_EraseRootFromParent_Done,
     /* 1988921 */   // Label 26635: @1988921
     /* 1988921 */   GIM_Try, /*On fail goto*//*Label 26636*/ GIMT_Encode4(1989007), // Rule ID 61849 //
     /* 1988926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1988937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1988940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1988943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1988946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988972 */     // MIs[0] policy
     /* 1988972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988982 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989006 */     // GIR_Coverage, 61849,
     /* 1989006 */     GIR_EraseRootFromParent_Done,
     /* 1989007 */   // Label 26636: @1989007
     /* 1989007 */   GIM_Try, /*On fail goto*//*Label 26637*/ GIMT_Encode4(1989093), // Rule ID 61852 //
     /* 1989012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1989023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1989026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1989029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1989032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989058 */     // MIs[0] policy
     /* 1989058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989068 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1989071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989092 */     // GIR_Coverage, 61852,
     /* 1989092 */     GIR_EraseRootFromParent_Done,
     /* 1989093 */   // Label 26637: @1989093
     /* 1989093 */   GIM_Try, /*On fail goto*//*Label 26638*/ GIMT_Encode4(1989179), // Rule ID 61853 //
     /* 1989098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1989109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1989112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1989115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1989118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989144 */     // MIs[0] policy
     /* 1989144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989154 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1989157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989178 */     // GIR_Coverage, 61853,
     /* 1989178 */     GIR_EraseRootFromParent_Done,
     /* 1989179 */   // Label 26638: @1989179
     /* 1989179 */   GIM_Try, /*On fail goto*//*Label 26639*/ GIMT_Encode4(1989265), // Rule ID 61856 //
     /* 1989184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1989195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1989198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1989201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1989204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989230 */     // MIs[0] policy
     /* 1989230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989240 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1989243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989264 */     // GIR_Coverage, 61856,
     /* 1989264 */     GIR_EraseRootFromParent_Done,
     /* 1989265 */   // Label 26639: @1989265
     /* 1989265 */   GIM_Try, /*On fail goto*//*Label 26640*/ GIMT_Encode4(1989351), // Rule ID 61857 //
     /* 1989270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1989281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1989284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1989287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1989290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989316 */     // MIs[0] policy
     /* 1989316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989326 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1989329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989350 */     // GIR_Coverage, 61857,
     /* 1989350 */     GIR_EraseRootFromParent_Done,
     /* 1989351 */   // Label 26640: @1989351
     /* 1989351 */   GIM_Try, /*On fail goto*//*Label 26641*/ GIMT_Encode4(1989437), // Rule ID 61860 //
     /* 1989356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1989367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1989370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1989373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1989376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989402 */     // MIs[0] policy
     /* 1989402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989412 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1989415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989436 */     // GIR_Coverage, 61860,
     /* 1989436 */     GIR_EraseRootFromParent_Done,
     /* 1989437 */   // Label 26641: @1989437
     /* 1989437 */   GIM_Try, /*On fail goto*//*Label 26642*/ GIMT_Encode4(1989523), // Rule ID 61861 //
     /* 1989442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1989453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1989456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1989459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1989462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989488 */     // MIs[0] policy
     /* 1989488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989498 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1989501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989522 */     // GIR_Coverage, 61861,
     /* 1989522 */     GIR_EraseRootFromParent_Done,
     /* 1989523 */   // Label 26642: @1989523
     /* 1989523 */   GIM_Try, /*On fail goto*//*Label 26643*/ GIMT_Encode4(1989609), // Rule ID 61864 //
     /* 1989528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1989539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1989542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1989545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1989548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989574 */     // MIs[0] policy
     /* 1989574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989584 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989608 */     // GIR_Coverage, 61864,
     /* 1989608 */     GIR_EraseRootFromParent_Done,
     /* 1989609 */   // Label 26643: @1989609
     /* 1989609 */   GIM_Try, /*On fail goto*//*Label 26644*/ GIMT_Encode4(1989695), // Rule ID 61865 //
     /* 1989614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1989625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1989628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1989631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1989634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989660 */     // MIs[0] policy
     /* 1989660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989670 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989694 */     // GIR_Coverage, 61865,
     /* 1989694 */     GIR_EraseRootFromParent_Done,
     /* 1989695 */   // Label 26644: @1989695
     /* 1989695 */   GIM_Try, /*On fail goto*//*Label 26645*/ GIMT_Encode4(1989781), // Rule ID 61868 //
     /* 1989700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1989711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1989714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1989717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1989720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989746 */     // MIs[0] policy
     /* 1989746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989780 */     // GIR_Coverage, 61868,
     /* 1989780 */     GIR_EraseRootFromParent_Done,
     /* 1989781 */   // Label 26645: @1989781
     /* 1989781 */   GIM_Try, /*On fail goto*//*Label 26646*/ GIMT_Encode4(1989867), // Rule ID 61869 //
     /* 1989786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1989797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1989800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1989803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1989806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989832 */     // MIs[0] policy
     /* 1989832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989842 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989866 */     // GIR_Coverage, 61869,
     /* 1989866 */     GIR_EraseRootFromParent_Done,
     /* 1989867 */   // Label 26646: @1989867
     /* 1989867 */   GIM_Try, /*On fail goto*//*Label 26647*/ GIMT_Encode4(1989953), // Rule ID 61872 //
     /* 1989872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1989883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1989886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1989889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1989892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989918 */     // MIs[0] policy
     /* 1989918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989952 */     // GIR_Coverage, 61872,
     /* 1989952 */     GIR_EraseRootFromParent_Done,
     /* 1989953 */   // Label 26647: @1989953
     /* 1989953 */   GIM_Try, /*On fail goto*//*Label 26648*/ GIMT_Encode4(1990039), // Rule ID 61873 //
     /* 1989958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1989969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1989972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1989975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1989978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990004 */     // MIs[0] policy
     /* 1990004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990014 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1990017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990038 */     // GIR_Coverage, 61873,
     /* 1990038 */     GIR_EraseRootFromParent_Done,
     /* 1990039 */   // Label 26648: @1990039
     /* 1990039 */   GIM_Try, /*On fail goto*//*Label 26649*/ GIMT_Encode4(1990125), // Rule ID 61876 //
     /* 1990044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1990055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1990058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1990061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1990064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1990067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990090 */     // MIs[0] policy
     /* 1990090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990100 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1990103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1990121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990124 */     // GIR_Coverage, 61876,
     /* 1990124 */     GIR_EraseRootFromParent_Done,
     /* 1990125 */   // Label 26649: @1990125
     /* 1990125 */   GIM_Try, /*On fail goto*//*Label 26650*/ GIMT_Encode4(1990211), // Rule ID 61877 //
     /* 1990130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1990141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1990144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1990147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1990150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1990153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990176 */     // MIs[0] policy
     /* 1990176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1990189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1990207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990210 */     // GIR_Coverage, 61877,
     /* 1990210 */     GIR_EraseRootFromParent_Done,
     /* 1990211 */   // Label 26650: @1990211
     /* 1990211 */   GIM_Try, /*On fail goto*//*Label 26651*/ GIMT_Encode4(1990297), // Rule ID 61880 //
     /* 1990216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1990227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1990230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1990233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1990236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990262 */     // MIs[0] policy
     /* 1990262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990272 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990296 */     // GIR_Coverage, 61880,
     /* 1990296 */     GIR_EraseRootFromParent_Done,
     /* 1990297 */   // Label 26651: @1990297
     /* 1990297 */   GIM_Try, /*On fail goto*//*Label 26652*/ GIMT_Encode4(1990383), // Rule ID 61881 //
     /* 1990302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1990313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1990316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1990319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1990322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990348 */     // MIs[0] policy
     /* 1990348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990358 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990382 */     // GIR_Coverage, 61881,
     /* 1990382 */     GIR_EraseRootFromParent_Done,
     /* 1990383 */   // Label 26652: @1990383
     /* 1990383 */   GIM_Try, /*On fail goto*//*Label 26653*/ GIMT_Encode4(1990469), // Rule ID 61884 //
     /* 1990388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1990399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1990402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1990405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1990408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990434 */     // MIs[0] policy
     /* 1990434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990444 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1990447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990468 */     // GIR_Coverage, 61884,
     /* 1990468 */     GIR_EraseRootFromParent_Done,
     /* 1990469 */   // Label 26653: @1990469
     /* 1990469 */   GIM_Try, /*On fail goto*//*Label 26654*/ GIMT_Encode4(1990555), // Rule ID 61885 //
     /* 1990474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1990485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1990488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1990491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1990494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990520 */     // MIs[0] policy
     /* 1990520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990530 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1990533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990554 */     // GIR_Coverage, 61885,
     /* 1990554 */     GIR_EraseRootFromParent_Done,
     /* 1990555 */   // Label 26654: @1990555
     /* 1990555 */   GIM_Try, /*On fail goto*//*Label 26655*/ GIMT_Encode4(1990641), // Rule ID 61888 //
     /* 1990560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1990571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1990574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1990577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1990580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1990583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990606 */     // MIs[0] policy
     /* 1990606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990616 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1990619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990640 */     // GIR_Coverage, 61888,
     /* 1990640 */     GIR_EraseRootFromParent_Done,
     /* 1990641 */   // Label 26655: @1990641
     /* 1990641 */   GIM_Try, /*On fail goto*//*Label 26656*/ GIMT_Encode4(1990727), // Rule ID 61889 //
     /* 1990646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1990657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1990660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1990663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1990666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1990669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990692 */     // MIs[0] policy
     /* 1990692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990702 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1990705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990726 */     // GIR_Coverage, 61889,
     /* 1990726 */     GIR_EraseRootFromParent_Done,
     /* 1990727 */   // Label 26656: @1990727
     /* 1990727 */   GIM_Try, /*On fail goto*//*Label 26657*/ GIMT_Encode4(1990813), // Rule ID 61892 //
     /* 1990732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1990743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1990746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1990749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1990752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990778 */     // MIs[0] policy
     /* 1990778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990788 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990812 */     // GIR_Coverage, 61892,
     /* 1990812 */     GIR_EraseRootFromParent_Done,
     /* 1990813 */   // Label 26657: @1990813
     /* 1990813 */   GIM_Try, /*On fail goto*//*Label 26658*/ GIMT_Encode4(1990899), // Rule ID 61893 //
     /* 1990818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1990829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1990832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1990835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1990838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990864 */     // MIs[0] policy
     /* 1990864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990874 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990898 */     // GIR_Coverage, 61893,
     /* 1990898 */     GIR_EraseRootFromParent_Done,
     /* 1990899 */   // Label 26658: @1990899
     /* 1990899 */   GIM_Try, /*On fail goto*//*Label 26659*/ GIMT_Encode4(1990985), // Rule ID 61896 //
     /* 1990904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1990915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1990918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1990921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1990924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990950 */     // MIs[0] policy
     /* 1990950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990960 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1990963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990984 */     // GIR_Coverage, 61896,
     /* 1990984 */     GIR_EraseRootFromParent_Done,
     /* 1990985 */   // Label 26659: @1990985
     /* 1990985 */   GIM_Try, /*On fail goto*//*Label 26660*/ GIMT_Encode4(1991071), // Rule ID 61897 //
     /* 1990990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1991001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1991004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1991007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1991010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991036 */     // MIs[0] policy
     /* 1991036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991046 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1991067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991070 */     // GIR_Coverage, 61897,
     /* 1991070 */     GIR_EraseRootFromParent_Done,
     /* 1991071 */   // Label 26660: @1991071
     /* 1991071 */   GIM_Try, /*On fail goto*//*Label 26661*/ GIMT_Encode4(1991157), // Rule ID 61900 //
     /* 1991076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1991087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1991090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1991093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1991096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1991099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991122 */     // MIs[0] policy
     /* 1991122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991132 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1991153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991156 */     // GIR_Coverage, 61900,
     /* 1991156 */     GIR_EraseRootFromParent_Done,
     /* 1991157 */   // Label 26661: @1991157
     /* 1991157 */   GIM_Try, /*On fail goto*//*Label 26662*/ GIMT_Encode4(1991243), // Rule ID 61901 //
     /* 1991162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1991173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1991176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1991179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1991182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1991185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991208 */     // MIs[0] policy
     /* 1991208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991218 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1991239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991242 */     // GIR_Coverage, 61901,
     /* 1991242 */     GIR_EraseRootFromParent_Done,
     /* 1991243 */   // Label 26662: @1991243
     /* 1991243 */   GIM_Try, /*On fail goto*//*Label 26663*/ GIMT_Encode4(1991329), // Rule ID 61904 //
     /* 1991248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1991259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1991262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1991265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1991268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991294 */     // MIs[0] policy
     /* 1991294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991304 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1991307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991328 */     // GIR_Coverage, 61904,
     /* 1991328 */     GIR_EraseRootFromParent_Done,
     /* 1991329 */   // Label 26663: @1991329
     /* 1991329 */   GIM_Try, /*On fail goto*//*Label 26664*/ GIMT_Encode4(1991415), // Rule ID 61905 //
     /* 1991334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1991345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1991348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1991351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1991354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991380 */     // MIs[0] policy
     /* 1991380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1991393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991414 */     // GIR_Coverage, 61905,
     /* 1991414 */     GIR_EraseRootFromParent_Done,
     /* 1991415 */   // Label 26664: @1991415
     /* 1991415 */   GIM_Try, /*On fail goto*//*Label 26665*/ GIMT_Encode4(1991501), // Rule ID 61908 //
     /* 1991420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1991431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1991434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1991437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1991440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991466 */     // MIs[0] policy
     /* 1991466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991476 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991500 */     // GIR_Coverage, 61908,
     /* 1991500 */     GIR_EraseRootFromParent_Done,
     /* 1991501 */   // Label 26665: @1991501
     /* 1991501 */   GIM_Try, /*On fail goto*//*Label 26666*/ GIMT_Encode4(1991587), // Rule ID 61909 //
     /* 1991506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1991517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1991520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1991523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1991526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991552 */     // MIs[0] policy
     /* 1991552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991562 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991586 */     // GIR_Coverage, 61909,
     /* 1991586 */     GIR_EraseRootFromParent_Done,
     /* 1991587 */   // Label 26666: @1991587
     /* 1991587 */   GIM_Try, /*On fail goto*//*Label 26667*/ GIMT_Encode4(1991673), // Rule ID 61912 //
     /* 1991592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1991603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1991606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1991609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1991612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991638 */     // MIs[0] policy
     /* 1991638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991648 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991672 */     // GIR_Coverage, 61912,
     /* 1991672 */     GIR_EraseRootFromParent_Done,
     /* 1991673 */   // Label 26667: @1991673
     /* 1991673 */   GIM_Try, /*On fail goto*//*Label 26668*/ GIMT_Encode4(1991759), // Rule ID 61913 //
     /* 1991678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1991689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1991692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1991695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1991698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991724 */     // MIs[0] policy
     /* 1991724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991734 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991758 */     // GIR_Coverage, 61913,
     /* 1991758 */     GIR_EraseRootFromParent_Done,
     /* 1991759 */   // Label 26668: @1991759
     /* 1991759 */   GIM_Try, /*On fail goto*//*Label 26669*/ GIMT_Encode4(1991845), // Rule ID 61916 //
     /* 1991764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1991775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1991778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1991781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1991784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991810 */     // MIs[0] policy
     /* 1991810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991820 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1991823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991844 */     // GIR_Coverage, 61916,
     /* 1991844 */     GIR_EraseRootFromParent_Done,
     /* 1991845 */   // Label 26669: @1991845
     /* 1991845 */   GIM_Try, /*On fail goto*//*Label 26670*/ GIMT_Encode4(1991931), // Rule ID 61917 //
     /* 1991850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1991861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1991864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1991867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1991870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991896 */     // MIs[0] policy
     /* 1991896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1991909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991930 */     // GIR_Coverage, 61917,
     /* 1991930 */     GIR_EraseRootFromParent_Done,
     /* 1991931 */   // Label 26670: @1991931
     /* 1991931 */   GIM_Try, /*On fail goto*//*Label 26671*/ GIMT_Encode4(1992017), // Rule ID 61920 //
     /* 1991936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1991947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1991950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1991953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1991956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991982 */     // MIs[0] policy
     /* 1991982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991992 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1992013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992016 */     // GIR_Coverage, 61920,
     /* 1992016 */     GIR_EraseRootFromParent_Done,
     /* 1992017 */   // Label 26671: @1992017
     /* 1992017 */   GIM_Try, /*On fail goto*//*Label 26672*/ GIMT_Encode4(1992103), // Rule ID 61921 //
     /* 1992022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1992033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1992036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1992039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1992042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1992052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992068 */     // MIs[0] policy
     /* 1992068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992078 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1992081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1992099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992102 */     // GIR_Coverage, 61921,
     /* 1992102 */     GIR_EraseRootFromParent_Done,
     /* 1992103 */   // Label 26672: @1992103
     /* 1992103 */   GIM_Try, /*On fail goto*//*Label 26673*/ GIMT_Encode4(1992189), // Rule ID 61924 //
     /* 1992108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1992119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1992122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1992125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1992128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1992138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992154 */     // MIs[0] policy
     /* 1992154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992164 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1992167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1992185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992188 */     // GIR_Coverage, 61924,
     /* 1992188 */     GIR_EraseRootFromParent_Done,
     /* 1992189 */   // Label 26673: @1992189
     /* 1992189 */   GIM_Try, /*On fail goto*//*Label 26674*/ GIMT_Encode4(1992275), // Rule ID 61925 //
     /* 1992194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1992205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1992208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1992211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1992214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1992224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992240 */     // MIs[0] policy
     /* 1992240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992250 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1992253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1992271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992274 */     // GIR_Coverage, 61925,
     /* 1992274 */     GIR_EraseRootFromParent_Done,
     /* 1992275 */   // Label 26674: @1992275
     /* 1992275 */   GIM_Try, /*On fail goto*//*Label 26675*/ GIMT_Encode4(1992361), // Rule ID 61928 //
     /* 1992280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1992291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1992294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1992297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992326 */     // MIs[0] policy
     /* 1992326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992336 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1992339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992360 */     // GIR_Coverage, 61928,
     /* 1992360 */     GIR_EraseRootFromParent_Done,
     /* 1992361 */   // Label 26675: @1992361
     /* 1992361 */   GIM_Try, /*On fail goto*//*Label 26676*/ GIMT_Encode4(1992447), // Rule ID 61929 //
     /* 1992366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1992377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1992380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1992383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992412 */     // MIs[0] policy
     /* 1992412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992422 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1992425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992446 */     // GIR_Coverage, 61929,
     /* 1992446 */     GIR_EraseRootFromParent_Done,
     /* 1992447 */   // Label 26676: @1992447
     /* 1992447 */   GIM_Try, /*On fail goto*//*Label 26677*/ GIMT_Encode4(1992533), // Rule ID 61932 //
     /* 1992452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1992463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1992466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1992469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992498 */     // MIs[0] policy
     /* 1992498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992508 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992532 */     // GIR_Coverage, 61932,
     /* 1992532 */     GIR_EraseRootFromParent_Done,
     /* 1992533 */   // Label 26677: @1992533
     /* 1992533 */   GIM_Try, /*On fail goto*//*Label 26678*/ GIMT_Encode4(1992619), // Rule ID 61933 //
     /* 1992538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1992549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1992552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1992555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992584 */     // MIs[0] policy
     /* 1992584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992594 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992618 */     // GIR_Coverage, 61933,
     /* 1992618 */     GIR_EraseRootFromParent_Done,
     /* 1992619 */   // Label 26678: @1992619
     /* 1992619 */   GIM_Try, /*On fail goto*//*Label 26679*/ GIMT_Encode4(1992705), // Rule ID 61936 //
     /* 1992624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1992635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1992638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1992641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992670 */     // MIs[0] policy
     /* 1992670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992680 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992704 */     // GIR_Coverage, 61936,
     /* 1992704 */     GIR_EraseRootFromParent_Done,
     /* 1992705 */   // Label 26679: @1992705
     /* 1992705 */   GIM_Try, /*On fail goto*//*Label 26680*/ GIMT_Encode4(1992791), // Rule ID 61937 //
     /* 1992710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1992721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1992724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1992727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992756 */     // MIs[0] policy
     /* 1992756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992766 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992790 */     // GIR_Coverage, 61937,
     /* 1992790 */     GIR_EraseRootFromParent_Done,
     /* 1992791 */   // Label 26680: @1992791
     /* 1992791 */   GIM_Try, /*On fail goto*//*Label 26681*/ GIMT_Encode4(1992877), // Rule ID 61940 //
     /* 1992796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1992807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1992810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1992813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992842 */     // MIs[0] policy
     /* 1992842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992852 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992876 */     // GIR_Coverage, 61940,
     /* 1992876 */     GIR_EraseRootFromParent_Done,
     /* 1992877 */   // Label 26681: @1992877
     /* 1992877 */   GIM_Try, /*On fail goto*//*Label 26682*/ GIMT_Encode4(1992963), // Rule ID 61941 //
     /* 1992882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1992893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1992896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1992899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992928 */     // MIs[0] policy
     /* 1992928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992938 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992962 */     // GIR_Coverage, 61941,
     /* 1992962 */     GIR_EraseRootFromParent_Done,
     /* 1992963 */   // Label 26682: @1992963
     /* 1992963 */   GIM_Try, /*On fail goto*//*Label 26683*/ GIMT_Encode4(1993049), // Rule ID 61944 //
     /* 1992968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1992979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1992982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1992985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993014 */     // MIs[0] policy
     /* 1993014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993024 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1993027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993048 */     // GIR_Coverage, 61944,
     /* 1993048 */     GIR_EraseRootFromParent_Done,
     /* 1993049 */   // Label 26683: @1993049
     /* 1993049 */   GIM_Try, /*On fail goto*//*Label 26684*/ GIMT_Encode4(1993135), // Rule ID 61945 //
     /* 1993054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1993065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1993068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1993071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993100 */     // MIs[0] policy
     /* 1993100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993110 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1993113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993134 */     // GIR_Coverage, 61945,
     /* 1993134 */     GIR_EraseRootFromParent_Done,
     /* 1993135 */   // Label 26684: @1993135
     /* 1993135 */   GIM_Try, /*On fail goto*//*Label 26685*/ GIMT_Encode4(1993221), // Rule ID 61948 //
     /* 1993140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1993151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1993154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1993157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993186 */     // MIs[0] policy
     /* 1993186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993196 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1993199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993220 */     // GIR_Coverage, 61948,
     /* 1993220 */     GIR_EraseRootFromParent_Done,
     /* 1993221 */   // Label 26685: @1993221
     /* 1993221 */   GIM_Try, /*On fail goto*//*Label 26686*/ GIMT_Encode4(1993307), // Rule ID 61949 //
     /* 1993226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1993237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1993240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1993243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993272 */     // MIs[0] policy
     /* 1993272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993282 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1993285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993306 */     // GIR_Coverage, 61949,
     /* 1993306 */     GIR_EraseRootFromParent_Done,
     /* 1993307 */   // Label 26686: @1993307
     /* 1993307 */   GIM_Try, /*On fail goto*//*Label 26687*/ GIMT_Encode4(1993393), // Rule ID 61952 //
     /* 1993312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1993323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1993326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1993329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993358 */     // MIs[0] policy
     /* 1993358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993368 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993392 */     // GIR_Coverage, 61952,
     /* 1993392 */     GIR_EraseRootFromParent_Done,
     /* 1993393 */   // Label 26687: @1993393
     /* 1993393 */   GIM_Try, /*On fail goto*//*Label 26688*/ GIMT_Encode4(1993479), // Rule ID 61953 //
     /* 1993398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1993409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1993412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1993415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993444 */     // MIs[0] policy
     /* 1993444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993454 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993478 */     // GIR_Coverage, 61953,
     /* 1993478 */     GIR_EraseRootFromParent_Done,
     /* 1993479 */   // Label 26688: @1993479
     /* 1993479 */   GIM_Try, /*On fail goto*//*Label 26689*/ GIMT_Encode4(1993565), // Rule ID 61956 //
     /* 1993484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1993495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1993498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1993501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993530 */     // MIs[0] policy
     /* 1993530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993564 */     // GIR_Coverage, 61956,
     /* 1993564 */     GIR_EraseRootFromParent_Done,
     /* 1993565 */   // Label 26689: @1993565
     /* 1993565 */   GIM_Try, /*On fail goto*//*Label 26690*/ GIMT_Encode4(1993651), // Rule ID 61957 //
     /* 1993570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1993581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1993584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1993587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993616 */     // MIs[0] policy
     /* 1993616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993650 */     // GIR_Coverage, 61957,
     /* 1993650 */     GIR_EraseRootFromParent_Done,
     /* 1993651 */   // Label 26690: @1993651
     /* 1993651 */   GIM_Try, /*On fail goto*//*Label 26691*/ GIMT_Encode4(1993737), // Rule ID 61960 //
     /* 1993656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1993673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993702 */     // MIs[0] policy
     /* 1993702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993712 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993736 */     // GIR_Coverage, 61960,
     /* 1993736 */     GIR_EraseRootFromParent_Done,
     /* 1993737 */   // Label 26691: @1993737
     /* 1993737 */   GIM_Try, /*On fail goto*//*Label 26692*/ GIMT_Encode4(1993823), // Rule ID 61961 //
     /* 1993742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1993759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993788 */     // MIs[0] policy
     /* 1993788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993798 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993822 */     // GIR_Coverage, 61961,
     /* 1993822 */     GIR_EraseRootFromParent_Done,
     /* 1993823 */   // Label 26692: @1993823
     /* 1993823 */   GIM_Try, /*On fail goto*//*Label 26693*/ GIMT_Encode4(1993909), // Rule ID 61964 //
     /* 1993828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1993839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1993842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1993845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993874 */     // MIs[0] policy
     /* 1993874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993884 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993908 */     // GIR_Coverage, 61964,
     /* 1993908 */     GIR_EraseRootFromParent_Done,
     /* 1993909 */   // Label 26693: @1993909
     /* 1993909 */   GIM_Try, /*On fail goto*//*Label 26694*/ GIMT_Encode4(1993995), // Rule ID 61965 //
     /* 1993914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1993925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1993928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1993931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993960 */     // MIs[0] policy
     /* 1993960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993970 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993994 */     // GIR_Coverage, 61965,
     /* 1993994 */     GIR_EraseRootFromParent_Done,
     /* 1993995 */   // Label 26694: @1993995
     /* 1993995 */   GIM_Try, /*On fail goto*//*Label 26695*/ GIMT_Encode4(1994081), // Rule ID 61968 //
     /* 1994000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1994011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1994014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1994017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994046 */     // MIs[0] policy
     /* 1994046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994056 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994080 */     // GIR_Coverage, 61968,
     /* 1994080 */     GIR_EraseRootFromParent_Done,
     /* 1994081 */   // Label 26695: @1994081
     /* 1994081 */   GIM_Try, /*On fail goto*//*Label 26696*/ GIMT_Encode4(1994167), // Rule ID 61969 //
     /* 1994086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1994097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1994100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1994103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994132 */     // MIs[0] policy
     /* 1994132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994142 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994166 */     // GIR_Coverage, 61969,
     /* 1994166 */     GIR_EraseRootFromParent_Done,
     /* 1994167 */   // Label 26696: @1994167
     /* 1994167 */   GIM_Try, /*On fail goto*//*Label 26697*/ GIMT_Encode4(1994253), // Rule ID 61972 //
     /* 1994172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1994183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1994186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1994189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994218 */     // MIs[0] policy
     /* 1994218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994228 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994252 */     // GIR_Coverage, 61972,
     /* 1994252 */     GIR_EraseRootFromParent_Done,
     /* 1994253 */   // Label 26697: @1994253
     /* 1994253 */   GIM_Try, /*On fail goto*//*Label 26698*/ GIMT_Encode4(1994339), // Rule ID 61973 //
     /* 1994258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1994269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1994272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1994275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994304 */     // MIs[0] policy
     /* 1994304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994314 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994338 */     // GIR_Coverage, 61973,
     /* 1994338 */     GIR_EraseRootFromParent_Done,
     /* 1994339 */   // Label 26698: @1994339
     /* 1994339 */   GIM_Try, /*On fail goto*//*Label 26699*/ GIMT_Encode4(1994425), // Rule ID 61976 //
     /* 1994344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1994355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1994358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1994361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1994367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994390 */     // MIs[0] policy
     /* 1994390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994400 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994424 */     // GIR_Coverage, 61976,
     /* 1994424 */     GIR_EraseRootFromParent_Done,
     /* 1994425 */   // Label 26699: @1994425
     /* 1994425 */   GIM_Try, /*On fail goto*//*Label 26700*/ GIMT_Encode4(1994511), // Rule ID 61977 //
     /* 1994430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1994441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1994444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1994447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1994453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994476 */     // MIs[0] policy
     /* 1994476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994486 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994510 */     // GIR_Coverage, 61977,
     /* 1994510 */     GIR_EraseRootFromParent_Done,
     /* 1994511 */   // Label 26700: @1994511
     /* 1994511 */   GIM_Try, /*On fail goto*//*Label 26701*/ GIMT_Encode4(1994597), // Rule ID 61980 //
     /* 1994516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1994527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1994530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1994533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994562 */     // MIs[0] policy
     /* 1994562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994572 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994596 */     // GIR_Coverage, 61980,
     /* 1994596 */     GIR_EraseRootFromParent_Done,
     /* 1994597 */   // Label 26701: @1994597
     /* 1994597 */   GIM_Try, /*On fail goto*//*Label 26702*/ GIMT_Encode4(1994683), // Rule ID 61981 //
     /* 1994602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1994613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1994616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1994619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994648 */     // MIs[0] policy
     /* 1994648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994658 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994682 */     // GIR_Coverage, 61981,
     /* 1994682 */     GIR_EraseRootFromParent_Done,
     /* 1994683 */   // Label 26702: @1994683
     /* 1994683 */   GIM_Try, /*On fail goto*//*Label 26703*/ GIMT_Encode4(1994769), // Rule ID 61984 //
     /* 1994688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1994699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1994702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1994705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994734 */     // MIs[0] policy
     /* 1994734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994744 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994768 */     // GIR_Coverage, 61984,
     /* 1994768 */     GIR_EraseRootFromParent_Done,
     /* 1994769 */   // Label 26703: @1994769
     /* 1994769 */   GIM_Try, /*On fail goto*//*Label 26704*/ GIMT_Encode4(1994855), // Rule ID 61985 //
     /* 1994774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1994785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1994788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1994791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994820 */     // MIs[0] policy
     /* 1994820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994830 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994854 */     // GIR_Coverage, 61985,
     /* 1994854 */     GIR_EraseRootFromParent_Done,
     /* 1994855 */   // Label 26704: @1994855
     /* 1994855 */   GIM_Try, /*On fail goto*//*Label 26705*/ GIMT_Encode4(1994941), // Rule ID 61988 //
     /* 1994860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1994871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1994874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1994877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994906 */     // MIs[0] policy
     /* 1994906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994916 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994940 */     // GIR_Coverage, 61988,
     /* 1994940 */     GIR_EraseRootFromParent_Done,
     /* 1994941 */   // Label 26705: @1994941
     /* 1994941 */   GIM_Try, /*On fail goto*//*Label 26706*/ GIMT_Encode4(1995027), // Rule ID 61989 //
     /* 1994946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1994957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1994960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1994963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994992 */     // MIs[0] policy
     /* 1994992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995002 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995026 */     // GIR_Coverage, 61989,
     /* 1995026 */     GIR_EraseRootFromParent_Done,
     /* 1995027 */   // Label 26706: @1995027
     /* 1995027 */   GIM_Try, /*On fail goto*//*Label 26707*/ GIMT_Encode4(1995113), // Rule ID 61992 //
     /* 1995032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1995043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1995046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1995049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995078 */     // MIs[0] policy
     /* 1995078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1995091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995112 */     // GIR_Coverage, 61992,
     /* 1995112 */     GIR_EraseRootFromParent_Done,
     /* 1995113 */   // Label 26707: @1995113
     /* 1995113 */   GIM_Try, /*On fail goto*//*Label 26708*/ GIMT_Encode4(1995199), // Rule ID 61993 //
     /* 1995118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1995129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1995132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1995135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995164 */     // MIs[0] policy
     /* 1995164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1995177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995198 */     // GIR_Coverage, 61993,
     /* 1995198 */     GIR_EraseRootFromParent_Done,
     /* 1995199 */   // Label 26708: @1995199
     /* 1995199 */   GIM_Try, /*On fail goto*//*Label 26709*/ GIMT_Encode4(1995285), // Rule ID 61996 //
     /* 1995204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1995215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1995218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1995221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995250 */     // MIs[0] policy
     /* 1995250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995260 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1995263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995284 */     // GIR_Coverage, 61996,
     /* 1995284 */     GIR_EraseRootFromParent_Done,
     /* 1995285 */   // Label 26709: @1995285
     /* 1995285 */   GIM_Try, /*On fail goto*//*Label 26710*/ GIMT_Encode4(1995371), // Rule ID 61997 //
     /* 1995290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1995301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1995304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1995307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995336 */     // MIs[0] policy
     /* 1995336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1995349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995370 */     // GIR_Coverage, 61997,
     /* 1995370 */     GIR_EraseRootFromParent_Done,
     /* 1995371 */   // Label 26710: @1995371
     /* 1995371 */   GIM_Try, /*On fail goto*//*Label 26711*/ GIMT_Encode4(1995457), // Rule ID 62000 //
     /* 1995376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1995387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1995390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1995393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995422 */     // MIs[0] policy
     /* 1995422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995432 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995456 */     // GIR_Coverage, 62000,
     /* 1995456 */     GIR_EraseRootFromParent_Done,
     /* 1995457 */   // Label 26711: @1995457
     /* 1995457 */   GIM_Try, /*On fail goto*//*Label 26712*/ GIMT_Encode4(1995543), // Rule ID 62001 //
     /* 1995462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1995473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1995476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1995479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995508 */     // MIs[0] policy
     /* 1995508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995542 */     // GIR_Coverage, 62001,
     /* 1995542 */     GIR_EraseRootFromParent_Done,
     /* 1995543 */   // Label 26712: @1995543
     /* 1995543 */   GIM_Try, /*On fail goto*//*Label 26713*/ GIMT_Encode4(1995629), // Rule ID 62004 //
     /* 1995548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1995559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1995562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1995565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995594 */     // MIs[0] policy
     /* 1995594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995604 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1995607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995628 */     // GIR_Coverage, 62004,
     /* 1995628 */     GIR_EraseRootFromParent_Done,
     /* 1995629 */   // Label 26713: @1995629
     /* 1995629 */   GIM_Try, /*On fail goto*//*Label 26714*/ GIMT_Encode4(1995715), // Rule ID 62005 //
     /* 1995634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1995645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1995648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1995651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995680 */     // MIs[0] policy
     /* 1995680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1995693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995714 */     // GIR_Coverage, 62005,
     /* 1995714 */     GIR_EraseRootFromParent_Done,
     /* 1995715 */   // Label 26714: @1995715
     /* 1995715 */   GIM_Try, /*On fail goto*//*Label 26715*/ GIMT_Encode4(1995801), // Rule ID 62008 //
     /* 1995720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1995731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1995734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1995737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995766 */     // MIs[0] policy
     /* 1995766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995776 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1995779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995800 */     // GIR_Coverage, 62008,
     /* 1995800 */     GIR_EraseRootFromParent_Done,
     /* 1995801 */   // Label 26715: @1995801
     /* 1995801 */   GIM_Try, /*On fail goto*//*Label 26716*/ GIMT_Encode4(1995887), // Rule ID 62009 //
     /* 1995806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1995817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1995820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1995823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995852 */     // MIs[0] policy
     /* 1995852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1995865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995886 */     // GIR_Coverage, 62009,
     /* 1995886 */     GIR_EraseRootFromParent_Done,
     /* 1995887 */   // Label 26716: @1995887
     /* 1995887 */   GIM_Try, /*On fail goto*//*Label 26717*/ GIMT_Encode4(1995973), // Rule ID 62012 //
     /* 1995892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1995903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1995906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1995909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995938 */     // MIs[0] policy
     /* 1995938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995948 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995972 */     // GIR_Coverage, 62012,
     /* 1995972 */     GIR_EraseRootFromParent_Done,
     /* 1995973 */   // Label 26717: @1995973
     /* 1995973 */   GIM_Try, /*On fail goto*//*Label 26718*/ GIMT_Encode4(1996059), // Rule ID 62013 //
     /* 1995978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1995989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1995992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1995995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1996008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996024 */     // MIs[0] policy
     /* 1996024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996034 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1996037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1996055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996058 */     // GIR_Coverage, 62013,
     /* 1996058 */     GIR_EraseRootFromParent_Done,
     /* 1996059 */   // Label 26718: @1996059
     /* 1996059 */   GIM_Try, /*On fail goto*//*Label 26719*/ GIMT_Encode4(1996145), // Rule ID 62618 //
     /* 1996064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1996081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996110 */     // MIs[0] policy
     /* 1996110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996120 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_MF2_MASK),
     /* 1996123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996144 */     // GIR_Coverage, 62618,
     /* 1996144 */     GIR_EraseRootFromParent_Done,
     /* 1996145 */   // Label 26719: @1996145
     /* 1996145 */   GIM_Try, /*On fail goto*//*Label 26720*/ GIMT_Encode4(1996231), // Rule ID 62619 //
     /* 1996150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1996167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996196 */     // MIs[0] policy
     /* 1996196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996206 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_MF2_MASK),
     /* 1996209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996230 */     // GIR_Coverage, 62619,
     /* 1996230 */     GIR_EraseRootFromParent_Done,
     /* 1996231 */   // Label 26720: @1996231
     /* 1996231 */   GIM_Try, /*On fail goto*//*Label 26721*/ GIMT_Encode4(1996317), // Rule ID 62622 //
     /* 1996236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1996253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1996256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996282 */     // MIs[0] policy
     /* 1996282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M1_MASK),
     /* 1996295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996316 */     // GIR_Coverage, 62622,
     /* 1996316 */     GIR_EraseRootFromParent_Done,
     /* 1996317 */   // Label 26721: @1996317
     /* 1996317 */   GIM_Try, /*On fail goto*//*Label 26722*/ GIMT_Encode4(1996403), // Rule ID 62623 //
     /* 1996322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1996339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1996342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996368 */     // MIs[0] policy
     /* 1996368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996378 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M1_MASK),
     /* 1996381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996402 */     // GIR_Coverage, 62623,
     /* 1996402 */     GIR_EraseRootFromParent_Done,
     /* 1996403 */   // Label 26722: @1996403
     /* 1996403 */   GIM_Try, /*On fail goto*//*Label 26723*/ GIMT_Encode4(1996489), // Rule ID 62626 //
     /* 1996408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1996425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1996428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996454 */     // MIs[0] policy
     /* 1996454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M2_MASK),
     /* 1996467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996488 */     // GIR_Coverage, 62626,
     /* 1996488 */     GIR_EraseRootFromParent_Done,
     /* 1996489 */   // Label 26723: @1996489
     /* 1996489 */   GIM_Try, /*On fail goto*//*Label 26724*/ GIMT_Encode4(1996575), // Rule ID 62627 //
     /* 1996494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1996511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1996514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996540 */     // MIs[0] policy
     /* 1996540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996550 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M2_MASK),
     /* 1996553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996574 */     // GIR_Coverage, 62627,
     /* 1996574 */     GIR_EraseRootFromParent_Done,
     /* 1996575 */   // Label 26724: @1996575
     /* 1996575 */   GIM_Try, /*On fail goto*//*Label 26725*/ GIMT_Encode4(1996661), // Rule ID 62630 //
     /* 1996580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1996597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1996600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996626 */     // MIs[0] policy
     /* 1996626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996636 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M4_MASK),
     /* 1996639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996660 */     // GIR_Coverage, 62630,
     /* 1996660 */     GIR_EraseRootFromParent_Done,
     /* 1996661 */   // Label 26725: @1996661
     /* 1996661 */   GIM_Try, /*On fail goto*//*Label 26726*/ GIMT_Encode4(1996747), // Rule ID 62631 //
     /* 1996666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1996683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1996686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996712 */     // MIs[0] policy
     /* 1996712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996722 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M4_MASK),
     /* 1996725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996746 */     // GIR_Coverage, 62631,
     /* 1996746 */     GIR_EraseRootFromParent_Done,
     /* 1996747 */   // Label 26726: @1996747
     /* 1996747 */   GIM_Try, /*On fail goto*//*Label 26727*/ GIMT_Encode4(1996833), // Rule ID 62634 //
     /* 1996752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1996763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1996766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1996769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1996772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1996775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1996782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996798 */     // MIs[0] policy
     /* 1996798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996808 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M8_MASK),
     /* 1996811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996832 */     // GIR_Coverage, 62634,
     /* 1996832 */     GIR_EraseRootFromParent_Done,
     /* 1996833 */   // Label 26727: @1996833
     /* 1996833 */   GIM_Try, /*On fail goto*//*Label 26728*/ GIMT_Encode4(1996919), // Rule ID 62635 //
     /* 1996838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1996849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1996852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1996855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1996858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1996861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1996868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996884 */     // MIs[0] policy
     /* 1996884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996894 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M8_MASK),
     /* 1996897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996918 */     // GIR_Coverage, 62635,
     /* 1996918 */     GIR_EraseRootFromParent_Done,
     /* 1996919 */   // Label 26728: @1996919
     /* 1996919 */   GIM_Try, /*On fail goto*//*Label 26729*/ GIMT_Encode4(1997005), // Rule ID 62638 //
     /* 1996924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996970 */     // MIs[0] policy
     /* 1996970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996980 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_MF2_MASK),
     /* 1996983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997004 */     // GIR_Coverage, 62638,
     /* 1997004 */     GIR_EraseRootFromParent_Done,
     /* 1997005 */   // Label 26729: @1997005
     /* 1997005 */   GIM_Try, /*On fail goto*//*Label 26730*/ GIMT_Encode4(1997091), // Rule ID 62639 //
     /* 1997010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1997030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997056 */     // MIs[0] policy
     /* 1997056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_MF2_MASK),
     /* 1997069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997090 */     // GIR_Coverage, 62639,
     /* 1997090 */     GIR_EraseRootFromParent_Done,
     /* 1997091 */   // Label 26730: @1997091
     /* 1997091 */   GIM_Try, /*On fail goto*//*Label 26731*/ GIMT_Encode4(1997177), // Rule ID 62642 //
     /* 1997096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1997113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997142 */     // MIs[0] policy
     /* 1997142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M1_MASK),
     /* 1997155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997176 */     // GIR_Coverage, 62642,
     /* 1997176 */     GIR_EraseRootFromParent_Done,
     /* 1997177 */   // Label 26731: @1997177
     /* 1997177 */   GIM_Try, /*On fail goto*//*Label 26732*/ GIMT_Encode4(1997263), // Rule ID 62643 //
     /* 1997182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997228 */     // MIs[0] policy
     /* 1997228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997238 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M1_MASK),
     /* 1997241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997262 */     // GIR_Coverage, 62643,
     /* 1997262 */     GIR_EraseRootFromParent_Done,
     /* 1997263 */   // Label 26732: @1997263
     /* 1997263 */   GIM_Try, /*On fail goto*//*Label 26733*/ GIMT_Encode4(1997349), // Rule ID 62646 //
     /* 1997268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1997279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1997282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1997285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1997288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997314 */     // MIs[0] policy
     /* 1997314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M2_MASK),
     /* 1997327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997348 */     // GIR_Coverage, 62646,
     /* 1997348 */     GIR_EraseRootFromParent_Done,
     /* 1997349 */   // Label 26733: @1997349
     /* 1997349 */   GIM_Try, /*On fail goto*//*Label 26734*/ GIMT_Encode4(1997435), // Rule ID 62647 //
     /* 1997354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1997365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1997368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1997374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997400 */     // MIs[0] policy
     /* 1997400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M2_MASK),
     /* 1997413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997434 */     // GIR_Coverage, 62647,
     /* 1997434 */     GIR_EraseRootFromParent_Done,
     /* 1997435 */   // Label 26734: @1997435
     /* 1997435 */   GIM_Try, /*On fail goto*//*Label 26735*/ GIMT_Encode4(1997521), // Rule ID 62650 //
     /* 1997440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1997451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1997454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1997457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1997460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997486 */     // MIs[0] policy
     /* 1997486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M4_MASK),
     /* 1997499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997520 */     // GIR_Coverage, 62650,
     /* 1997520 */     GIR_EraseRootFromParent_Done,
     /* 1997521 */   // Label 26735: @1997521
     /* 1997521 */   GIM_Try, /*On fail goto*//*Label 26736*/ GIMT_Encode4(1997607), // Rule ID 62651 //
     /* 1997526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1997537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1997540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1997546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997572 */     // MIs[0] policy
     /* 1997572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M4_MASK),
     /* 1997585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997606 */     // GIR_Coverage, 62651,
     /* 1997606 */     GIR_EraseRootFromParent_Done,
     /* 1997607 */   // Label 26736: @1997607
     /* 1997607 */   GIM_Try, /*On fail goto*//*Label 26737*/ GIMT_Encode4(1997693), // Rule ID 62654 //
     /* 1997612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1997623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1997626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1997629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1997632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1997635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1997642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997658 */     // MIs[0] policy
     /* 1997658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997668 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M8_MASK),
     /* 1997671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997692 */     // GIR_Coverage, 62654,
     /* 1997692 */     GIR_EraseRootFromParent_Done,
     /* 1997693 */   // Label 26737: @1997693
     /* 1997693 */   GIM_Try, /*On fail goto*//*Label 26738*/ GIMT_Encode4(1997779), // Rule ID 62655 //
     /* 1997698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1997709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1997712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1997718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1997721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1997728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997744 */     // MIs[0] policy
     /* 1997744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997754 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M8_MASK),
     /* 1997757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997778 */     // GIR_Coverage, 62655,
     /* 1997778 */     GIR_EraseRootFromParent_Done,
     /* 1997779 */   // Label 26738: @1997779
     /* 1997779 */   GIM_Try, /*On fail goto*//*Label 26739*/ GIMT_Encode4(1997865), // Rule ID 62658 //
     /* 1997784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1997801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1997804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997830 */     // MIs[0] policy
     /* 1997830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_MF2_MASK),
     /* 1997843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997864 */     // GIR_Coverage, 62658,
     /* 1997864 */     GIR_EraseRootFromParent_Done,
     /* 1997865 */   // Label 26739: @1997865
     /* 1997865 */   GIM_Try, /*On fail goto*//*Label 26740*/ GIMT_Encode4(1997951), // Rule ID 62659 //
     /* 1997870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1997887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1997890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997916 */     // MIs[0] policy
     /* 1997916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997926 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_MF2_MASK),
     /* 1997929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997950 */     // GIR_Coverage, 62659,
     /* 1997950 */     GIR_EraseRootFromParent_Done,
     /* 1997951 */   // Label 26740: @1997951
     /* 1997951 */   GIM_Try, /*On fail goto*//*Label 26741*/ GIMT_Encode4(1998037), // Rule ID 62662 //
     /* 1997956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1997973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998002 */     // MIs[0] policy
     /* 1998002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998012 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M1_MASK),
     /* 1998015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998036 */     // GIR_Coverage, 62662,
     /* 1998036 */     GIR_EraseRootFromParent_Done,
     /* 1998037 */   // Label 26741: @1998037
     /* 1998037 */   GIM_Try, /*On fail goto*//*Label 26742*/ GIMT_Encode4(1998123), // Rule ID 62663 //
     /* 1998042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1998059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1998062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998088 */     // MIs[0] policy
     /* 1998088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998098 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M1_MASK),
     /* 1998101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998122 */     // GIR_Coverage, 62663,
     /* 1998122 */     GIR_EraseRootFromParent_Done,
     /* 1998123 */   // Label 26742: @1998123
     /* 1998123 */   GIM_Try, /*On fail goto*//*Label 26743*/ GIMT_Encode4(1998209), // Rule ID 62666 //
     /* 1998128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1998145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1998148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998174 */     // MIs[0] policy
     /* 1998174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M2_MASK),
     /* 1998187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998208 */     // GIR_Coverage, 62666,
     /* 1998208 */     GIR_EraseRootFromParent_Done,
     /* 1998209 */   // Label 26743: @1998209
     /* 1998209 */   GIM_Try, /*On fail goto*//*Label 26744*/ GIMT_Encode4(1998295), // Rule ID 62667 //
     /* 1998214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1998231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1998234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998260 */     // MIs[0] policy
     /* 1998260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M2_MASK),
     /* 1998273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998294 */     // GIR_Coverage, 62667,
     /* 1998294 */     GIR_EraseRootFromParent_Done,
     /* 1998295 */   // Label 26744: @1998295
     /* 1998295 */   GIM_Try, /*On fail goto*//*Label 26745*/ GIMT_Encode4(1998381), // Rule ID 62670 //
     /* 1998300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1998317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1998320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998346 */     // MIs[0] policy
     /* 1998346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998356 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M4_MASK),
     /* 1998359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998380 */     // GIR_Coverage, 62670,
     /* 1998380 */     GIR_EraseRootFromParent_Done,
     /* 1998381 */   // Label 26745: @1998381
     /* 1998381 */   GIM_Try, /*On fail goto*//*Label 26746*/ GIMT_Encode4(1998467), // Rule ID 62671 //
     /* 1998386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1998403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1998406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998432 */     // MIs[0] policy
     /* 1998432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998442 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M4_MASK),
     /* 1998445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998466 */     // GIR_Coverage, 62671,
     /* 1998466 */     GIR_EraseRootFromParent_Done,
     /* 1998467 */   // Label 26746: @1998467
     /* 1998467 */   GIM_Try, /*On fail goto*//*Label 26747*/ GIMT_Encode4(1998553), // Rule ID 62674 //
     /* 1998472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1998489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998518 */     // MIs[0] policy
     /* 1998518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998528 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M8_MASK),
     /* 1998531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998552 */     // GIR_Coverage, 62674,
     /* 1998552 */     GIR_EraseRootFromParent_Done,
     /* 1998553 */   // Label 26747: @1998553
     /* 1998553 */   GIM_Try, /*On fail goto*//*Label 26748*/ GIMT_Encode4(1998639), // Rule ID 62675 //
     /* 1998558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1998575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998604 */     // MIs[0] policy
     /* 1998604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M8_MASK),
     /* 1998617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998638 */     // GIR_Coverage, 62675,
     /* 1998638 */     GIR_EraseRootFromParent_Done,
     /* 1998639 */   // Label 26748: @1998639
     /* 1998639 */   GIM_Try, /*On fail goto*//*Label 26749*/ GIMT_Encode4(1998725), // Rule ID 62678 //
     /* 1998644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1998655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1998658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1998664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998690 */     // MIs[0] policy
     /* 1998690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998700 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_MF2_MASK),
     /* 1998703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998724 */     // GIR_Coverage, 62678,
     /* 1998724 */     GIR_EraseRootFromParent_Done,
     /* 1998725 */   // Label 26749: @1998725
     /* 1998725 */   GIM_Try, /*On fail goto*//*Label 26750*/ GIMT_Encode4(1998811), // Rule ID 62679 //
     /* 1998730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1998741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1998744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1998750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998776 */     // MIs[0] policy
     /* 1998776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998786 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_MF2_MASK),
     /* 1998789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998810 */     // GIR_Coverage, 62679,
     /* 1998810 */     GIR_EraseRootFromParent_Done,
     /* 1998811 */   // Label 26750: @1998811
     /* 1998811 */   GIM_Try, /*On fail goto*//*Label 26751*/ GIMT_Encode4(1998897), // Rule ID 62682 //
     /* 1998816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1998836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998862 */     // MIs[0] policy
     /* 1998862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998872 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M1_MASK),
     /* 1998875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998896 */     // GIR_Coverage, 62682,
     /* 1998896 */     GIR_EraseRootFromParent_Done,
     /* 1998897 */   // Label 26751: @1998897
     /* 1998897 */   GIM_Try, /*On fail goto*//*Label 26752*/ GIMT_Encode4(1998983), // Rule ID 62683 //
     /* 1998902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1998922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998948 */     // MIs[0] policy
     /* 1998948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M1_MASK),
     /* 1998961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998982 */     // GIR_Coverage, 62683,
     /* 1998982 */     GIR_EraseRootFromParent_Done,
     /* 1998983 */   // Label 26752: @1998983
     /* 1998983 */   GIM_Try, /*On fail goto*//*Label 26753*/ GIMT_Encode4(1999069), // Rule ID 62686 //
     /* 1998988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1999005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999034 */     // MIs[0] policy
     /* 1999034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999044 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M2_MASK),
     /* 1999047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999068 */     // GIR_Coverage, 62686,
     /* 1999068 */     GIR_EraseRootFromParent_Done,
     /* 1999069 */   // Label 26753: @1999069
     /* 1999069 */   GIM_Try, /*On fail goto*//*Label 26754*/ GIMT_Encode4(1999155), // Rule ID 62687 //
     /* 1999074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1999082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1999085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1999091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999120 */     // MIs[0] policy
     /* 1999120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999130 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M2_MASK),
     /* 1999133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999154 */     // GIR_Coverage, 62687,
     /* 1999154 */     GIR_EraseRootFromParent_Done,
     /* 1999155 */   // Label 26754: @1999155
     /* 1999155 */   GIM_Try, /*On fail goto*//*Label 26755*/ GIMT_Encode4(1999241), // Rule ID 62690 //
     /* 1999160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1999168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1999171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1999174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1999177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1999180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999206 */     // MIs[0] policy
     /* 1999206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M4_MASK),
     /* 1999219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999240 */     // GIR_Coverage, 62690,
     /* 1999240 */     GIR_EraseRootFromParent_Done,
     /* 1999241 */   // Label 26755: @1999241
     /* 1999241 */   GIM_Try, /*On fail goto*//*Label 26756*/ GIMT_Encode4(1999327), // Rule ID 62691 //
     /* 1999246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1999254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1999257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1999260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1999263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1999266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999292 */     // MIs[0] policy
     /* 1999292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M4_MASK),
     /* 1999305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999326 */     // GIR_Coverage, 62691,
     /* 1999326 */     GIR_EraseRootFromParent_Done,
     /* 1999327 */   // Label 26756: @1999327
     /* 1999327 */   GIM_Try, /*On fail goto*//*Label 26757*/ GIMT_Encode4(1999413), // Rule ID 62694 //
     /* 1999332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1999340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1999343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1999346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1999349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1999352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1999355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999378 */     // MIs[0] policy
     /* 1999378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999388 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M8_MASK),
     /* 1999391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999412 */     // GIR_Coverage, 62694,
     /* 1999412 */     GIR_EraseRootFromParent_Done,
     /* 1999413 */   // Label 26757: @1999413
     /* 1999413 */   GIM_Try, /*On fail goto*//*Label 26758*/ GIMT_Encode4(1999499), // Rule ID 62695 //
     /* 1999418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1999426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1999429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1999432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1999435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1999438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1999441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999464 */     // MIs[0] policy
     /* 1999464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999474 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M8_MASK),
     /* 1999477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999498 */     // GIR_Coverage, 62695,
     /* 1999498 */     GIR_EraseRootFromParent_Done,
     /* 1999499 */   // Label 26758: @1999499
     /* 1999499 */   GIM_Try, /*On fail goto*//*Label 26759*/ GIMT_Encode4(1999585), // Rule ID 62698 //
     /* 1999504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1999521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999550 */     // MIs[0] policy
     /* 1999550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999560 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_MF2_MASK),
     /* 1999563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999584 */     // GIR_Coverage, 62698,
     /* 1999584 */     GIR_EraseRootFromParent_Done,
     /* 1999585 */   // Label 26759: @1999585
     /* 1999585 */   GIM_Try, /*On fail goto*//*Label 26760*/ GIMT_Encode4(1999671), // Rule ID 62699 //
     /* 1999590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1999607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999636 */     // MIs[0] policy
     /* 1999636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_MF2_MASK),
     /* 1999649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999670 */     // GIR_Coverage, 62699,
     /* 1999670 */     GIR_EraseRootFromParent_Done,
     /* 1999671 */   // Label 26760: @1999671
     /* 1999671 */   GIM_Try, /*On fail goto*//*Label 26761*/ GIMT_Encode4(1999757), // Rule ID 62702 //
     /* 1999676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1999693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1999696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999722 */     // MIs[0] policy
     /* 1999722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999732 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M1_MASK),
     /* 1999735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999756 */     // GIR_Coverage, 62702,
     /* 1999756 */     GIR_EraseRootFromParent_Done,
     /* 1999757 */   // Label 26761: @1999757
     /* 1999757 */   GIM_Try, /*On fail goto*//*Label 26762*/ GIMT_Encode4(1999843), // Rule ID 62703 //
     /* 1999762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1999779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1999782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999808 */     // MIs[0] policy
     /* 1999808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M1_MASK),
     /* 1999821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999842 */     // GIR_Coverage, 62703,
     /* 1999842 */     GIR_EraseRootFromParent_Done,
     /* 1999843 */   // Label 26762: @1999843
     /* 1999843 */   GIM_Try, /*On fail goto*//*Label 26763*/ GIMT_Encode4(1999929), // Rule ID 62706 //
     /* 1999848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1999859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1999865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999894 */     // MIs[0] policy
     /* 1999894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999904 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M2_MASK),
     /* 1999907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999928 */     // GIR_Coverage, 62706,
     /* 1999928 */     GIR_EraseRootFromParent_Done,
     /* 1999929 */   // Label 26763: @1999929
     /* 1999929 */   GIM_Try, /*On fail goto*//*Label 26764*/ GIMT_Encode4(2000015), // Rule ID 62707 //
     /* 1999934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1999945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1999951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999980 */     // MIs[0] policy
     /* 1999980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M2_MASK),
     /* 1999993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000014 */     // GIR_Coverage, 62707,
     /* 2000014 */     GIR_EraseRootFromParent_Done,
     /* 2000015 */   // Label 26764: @2000015
     /* 2000015 */   GIM_Try, /*On fail goto*//*Label 26765*/ GIMT_Encode4(2000101), // Rule ID 62710 //
     /* 2000020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2000037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000066 */     // MIs[0] policy
     /* 2000066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M4_MASK),
     /* 2000079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000100 */     // GIR_Coverage, 62710,
     /* 2000100 */     GIR_EraseRootFromParent_Done,
     /* 2000101 */   // Label 26765: @2000101
     /* 2000101 */   GIM_Try, /*On fail goto*//*Label 26766*/ GIMT_Encode4(2000187), // Rule ID 62711 //
     /* 2000106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2000123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000152 */     // MIs[0] policy
     /* 2000152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000162 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M4_MASK),
     /* 2000165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000186 */     // GIR_Coverage, 62711,
     /* 2000186 */     GIR_EraseRootFromParent_Done,
     /* 2000187 */   // Label 26766: @2000187
     /* 2000187 */   GIM_Try, /*On fail goto*//*Label 26767*/ GIMT_Encode4(2000273), // Rule ID 62714 //
     /* 2000192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2000203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2000206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2000209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2000212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2000215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2000222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000238 */     // MIs[0] policy
     /* 2000238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M8_MASK),
     /* 2000251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000272 */     // GIR_Coverage, 62714,
     /* 2000272 */     GIR_EraseRootFromParent_Done,
     /* 2000273 */   // Label 26767: @2000273
     /* 2000273 */   GIM_Try, /*On fail goto*//*Label 26768*/ GIMT_Encode4(2000359), // Rule ID 62715 //
     /* 2000278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2000289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2000292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2000295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2000298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2000301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2000308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000324 */     // MIs[0] policy
     /* 2000324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M8_MASK),
     /* 2000337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000358 */     // GIR_Coverage, 62715,
     /* 2000358 */     GIR_EraseRootFromParent_Done,
     /* 2000359 */   // Label 26768: @2000359
     /* 2000359 */   GIM_Try, /*On fail goto*//*Label 26769*/ GIMT_Encode4(2000445), // Rule ID 62718 //
     /* 2000364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2000375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2000378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2000384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000410 */     // MIs[0] policy
     /* 2000410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000420 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_MF2_MASK),
     /* 2000423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000444 */     // GIR_Coverage, 62718,
     /* 2000444 */     GIR_EraseRootFromParent_Done,
     /* 2000445 */   // Label 26769: @2000445
     /* 2000445 */   GIM_Try, /*On fail goto*//*Label 26770*/ GIMT_Encode4(2000531), // Rule ID 62719 //
     /* 2000450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2000461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2000464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2000470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000496 */     // MIs[0] policy
     /* 2000496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000506 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_MF2_MASK),
     /* 2000509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000530 */     // GIR_Coverage, 62719,
     /* 2000530 */     GIR_EraseRootFromParent_Done,
     /* 2000531 */   // Label 26770: @2000531
     /* 2000531 */   GIM_Try, /*On fail goto*//*Label 26771*/ GIMT_Encode4(2000617), // Rule ID 62722 //
     /* 2000536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2000556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000582 */     // MIs[0] policy
     /* 2000582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000592 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M1_MASK),
     /* 2000595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000616 */     // GIR_Coverage, 62722,
     /* 2000616 */     GIR_EraseRootFromParent_Done,
     /* 2000617 */   // Label 26771: @2000617
     /* 2000617 */   GIM_Try, /*On fail goto*//*Label 26772*/ GIMT_Encode4(2000703), // Rule ID 62723 //
     /* 2000622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2000642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000668 */     // MIs[0] policy
     /* 2000668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M1_MASK),
     /* 2000681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000702 */     // GIR_Coverage, 62723,
     /* 2000702 */     GIR_EraseRootFromParent_Done,
     /* 2000703 */   // Label 26772: @2000703
     /* 2000703 */   GIM_Try, /*On fail goto*//*Label 26773*/ GIMT_Encode4(2000789), // Rule ID 62726 //
     /* 2000708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2000719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2000722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2000728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2000738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000754 */     // MIs[0] policy
     /* 2000754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M2_MASK),
     /* 2000767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000788 */     // GIR_Coverage, 62726,
     /* 2000788 */     GIR_EraseRootFromParent_Done,
     /* 2000789 */   // Label 26773: @2000789
     /* 2000789 */   GIM_Try, /*On fail goto*//*Label 26774*/ GIMT_Encode4(2000875), // Rule ID 62727 //
     /* 2000794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2000805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2000808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2000814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2000824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000840 */     // MIs[0] policy
     /* 2000840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M2_MASK),
     /* 2000853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000874 */     // GIR_Coverage, 62727,
     /* 2000874 */     GIR_EraseRootFromParent_Done,
     /* 2000875 */   // Label 26774: @2000875
     /* 2000875 */   GIM_Try, /*On fail goto*//*Label 26775*/ GIMT_Encode4(2000961), // Rule ID 62730 //
     /* 2000880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000926 */     // MIs[0] policy
     /* 2000926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000936 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M4_MASK),
     /* 2000939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000960 */     // GIR_Coverage, 62730,
     /* 2000960 */     GIR_EraseRootFromParent_Done,
     /* 2000961 */   // Label 26775: @2000961
     /* 2000961 */   GIM_Try, /*On fail goto*//*Label 26776*/ GIMT_Encode4(2001047), // Rule ID 62731 //
     /* 2000966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001012 */     // MIs[0] policy
     /* 2001012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001022 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M4_MASK),
     /* 2001025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001046 */     // GIR_Coverage, 62731,
     /* 2001046 */     GIR_EraseRootFromParent_Done,
     /* 2001047 */   // Label 26776: @2001047
     /* 2001047 */   GIM_Try, /*On fail goto*//*Label 26777*/ GIMT_Encode4(2001133), // Rule ID 62734 //
     /* 2001052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2001060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001098 */     // MIs[0] policy
     /* 2001098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M8_MASK),
     /* 2001111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001132 */     // GIR_Coverage, 62734,
     /* 2001132 */     GIR_EraseRootFromParent_Done,
     /* 2001133 */   // Label 26777: @2001133
     /* 2001133 */   GIM_Try, /*On fail goto*//*Label 26778*/ GIMT_Encode4(2001219), // Rule ID 62735 //
     /* 2001138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2001146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001184 */     // MIs[0] policy
     /* 2001184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001194 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M8_MASK),
     /* 2001197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001218 */     // GIR_Coverage, 62735,
     /* 2001218 */     GIR_EraseRootFromParent_Done,
     /* 2001219 */   // Label 26778: @2001219
     /* 2001219 */   GIM_Try, /*On fail goto*//*Label 26779*/ GIMT_Encode4(2001305), // Rule ID 62738 //
     /* 2001224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2001235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2001238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2001244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001270 */     // MIs[0] policy
     /* 2001270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001280 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_MF2_MASK),
     /* 2001283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001304 */     // GIR_Coverage, 62738,
     /* 2001304 */     GIR_EraseRootFromParent_Done,
     /* 2001305 */   // Label 26779: @2001305
     /* 2001305 */   GIM_Try, /*On fail goto*//*Label 26780*/ GIMT_Encode4(2001391), // Rule ID 62739 //
     /* 2001310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2001321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2001324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2001330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001356 */     // MIs[0] policy
     /* 2001356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001366 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_MF2_MASK),
     /* 2001369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001390 */     // GIR_Coverage, 62739,
     /* 2001390 */     GIR_EraseRootFromParent_Done,
     /* 2001391 */   // Label 26780: @2001391
     /* 2001391 */   GIM_Try, /*On fail goto*//*Label 26781*/ GIMT_Encode4(2001477), // Rule ID 62742 //
     /* 2001396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2001416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001442 */     // MIs[0] policy
     /* 2001442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M1_MASK),
     /* 2001455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001476 */     // GIR_Coverage, 62742,
     /* 2001476 */     GIR_EraseRootFromParent_Done,
     /* 2001477 */   // Label 26781: @2001477
     /* 2001477 */   GIM_Try, /*On fail goto*//*Label 26782*/ GIMT_Encode4(2001563), // Rule ID 62743 //
     /* 2001482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2001502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001528 */     // MIs[0] policy
     /* 2001528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001538 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M1_MASK),
     /* 2001541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001562 */     // GIR_Coverage, 62743,
     /* 2001562 */     GIR_EraseRootFromParent_Done,
     /* 2001563 */   // Label 26782: @2001563
     /* 2001563 */   GIM_Try, /*On fail goto*//*Label 26783*/ GIMT_Encode4(2001649), // Rule ID 62746 //
     /* 2001568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2001588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001614 */     // MIs[0] policy
     /* 2001614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M2_MASK),
     /* 2001627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001648 */     // GIR_Coverage, 62746,
     /* 2001648 */     GIR_EraseRootFromParent_Done,
     /* 2001649 */   // Label 26783: @2001649
     /* 2001649 */   GIM_Try, /*On fail goto*//*Label 26784*/ GIMT_Encode4(2001735), // Rule ID 62747 //
     /* 2001654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2001674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001700 */     // MIs[0] policy
     /* 2001700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M2_MASK),
     /* 2001713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001734 */     // GIR_Coverage, 62747,
     /* 2001734 */     GIR_EraseRootFromParent_Done,
     /* 2001735 */   // Label 26784: @2001735
     /* 2001735 */   GIM_Try, /*On fail goto*//*Label 26785*/ GIMT_Encode4(2001821), // Rule ID 62750 //
     /* 2001740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2001751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2001754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2001760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001786 */     // MIs[0] policy
     /* 2001786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001796 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M4_MASK),
     /* 2001799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001820 */     // GIR_Coverage, 62750,
     /* 2001820 */     GIR_EraseRootFromParent_Done,
     /* 2001821 */   // Label 26785: @2001821
     /* 2001821 */   GIM_Try, /*On fail goto*//*Label 26786*/ GIMT_Encode4(2001907), // Rule ID 62751 //
     /* 2001826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2001837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2001840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2001846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001872 */     // MIs[0] policy
     /* 2001872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001882 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M4_MASK),
     /* 2001885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001906 */     // GIR_Coverage, 62751,
     /* 2001906 */     GIR_EraseRootFromParent_Done,
     /* 2001907 */   // Label 26786: @2001907
     /* 2001907 */   GIM_Try, /*On fail goto*//*Label 26787*/ GIMT_Encode4(2001993), // Rule ID 62754 //
     /* 2001912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001958 */     // MIs[0] policy
     /* 2001958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001968 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M8_MASK),
     /* 2001971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001992 */     // GIR_Coverage, 62754,
     /* 2001992 */     GIR_EraseRootFromParent_Done,
     /* 2001993 */   // Label 26787: @2001993
     /* 2001993 */   GIM_Try, /*On fail goto*//*Label 26788*/ GIMT_Encode4(2002079), // Rule ID 62755 //
     /* 2001998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2002001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2002006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2002009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2002012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2002015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2002018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2002021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2002036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002044 */     // MIs[0] policy
     /* 2002044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M8_MASK),
     /* 2002057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002078 */     // GIR_Coverage, 62755,
     /* 2002078 */     GIR_EraseRootFromParent_Done,
     /* 2002079 */   // Label 26788: @2002079
     /* 2002079 */   GIM_Try, /*On fail goto*//*Label 26789*/ GIMT_Encode4(2002165), // Rule ID 65242 //
     /* 2002084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2002095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2002098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2002101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2002104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002130 */     // MIs[0] policy
     /* 2002130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2_MASK),
     /* 2002143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002164 */     // GIR_Coverage, 65242,
     /* 2002164 */     GIR_EraseRootFromParent_Done,
     /* 2002165 */   // Label 26789: @2002165
     /* 2002165 */   GIM_Try, /*On fail goto*//*Label 26790*/ GIMT_Encode4(2002251), // Rule ID 65243 //
     /* 2002170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2002181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2002184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2002187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2002190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002216 */     // MIs[0] policy
     /* 2002216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002226 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2_MASK),
     /* 2002229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002250 */     // GIR_Coverage, 65243,
     /* 2002250 */     GIR_EraseRootFromParent_Done,
     /* 2002251 */   // Label 26790: @2002251
     /* 2002251 */   GIM_Try, /*On fail goto*//*Label 26791*/ GIMT_Encode4(2002337), // Rule ID 65246 //
     /* 2002256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2002273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2002276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002302 */     // MIs[0] policy
     /* 2002302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002312 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2002315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002336 */     // GIR_Coverage, 65246,
     /* 2002336 */     GIR_EraseRootFromParent_Done,
     /* 2002337 */   // Label 26791: @2002337
     /* 2002337 */   GIM_Try, /*On fail goto*//*Label 26792*/ GIMT_Encode4(2002423), // Rule ID 65247 //
     /* 2002342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2002359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2002362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002388 */     // MIs[0] policy
     /* 2002388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002398 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2002401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002422 */     // GIR_Coverage, 65247,
     /* 2002422 */     GIR_EraseRootFromParent_Done,
     /* 2002423 */   // Label 26792: @2002423
     /* 2002423 */   GIM_Try, /*On fail goto*//*Label 26793*/ GIMT_Encode4(2002509), // Rule ID 65250 //
     /* 2002428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2002439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2002442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2002445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2002448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2002458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002474 */     // MIs[0] policy
     /* 2002474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2002487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002508 */     // GIR_Coverage, 65250,
     /* 2002508 */     GIR_EraseRootFromParent_Done,
     /* 2002509 */   // Label 26793: @2002509
     /* 2002509 */   GIM_Try, /*On fail goto*//*Label 26794*/ GIMT_Encode4(2002595), // Rule ID 65251 //
     /* 2002514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2002525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2002528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2002531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2002534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2002544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002560 */     // MIs[0] policy
     /* 2002560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2002573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002594 */     // GIR_Coverage, 65251,
     /* 2002594 */     GIR_EraseRootFromParent_Done,
     /* 2002595 */   // Label 26794: @2002595
     /* 2002595 */   GIM_Try, /*On fail goto*//*Label 26795*/ GIMT_Encode4(2002681), // Rule ID 65254 //
     /* 2002600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2002611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2002614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2002617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2002620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002646 */     // MIs[0] policy
     /* 2002646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002656 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2002659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002680 */     // GIR_Coverage, 65254,
     /* 2002680 */     GIR_EraseRootFromParent_Done,
     /* 2002681 */   // Label 26795: @2002681
     /* 2002681 */   GIM_Try, /*On fail goto*//*Label 26796*/ GIMT_Encode4(2002767), // Rule ID 65255 //
     /* 2002686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2002697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2002700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2002703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2002706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002732 */     // MIs[0] policy
     /* 2002732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002742 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2002745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002766 */     // GIR_Coverage, 65255,
     /* 2002766 */     GIR_EraseRootFromParent_Done,
     /* 2002767 */   // Label 26796: @2002767
     /* 2002767 */   GIM_Try, /*On fail goto*//*Label 26797*/ GIMT_Encode4(2002853), // Rule ID 65258 //
     /* 2002772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2002783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2002786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2002789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2002792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2002795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002818 */     // MIs[0] policy
     /* 2002818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002828 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2002831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002852 */     // GIR_Coverage, 65258,
     /* 2002852 */     GIR_EraseRootFromParent_Done,
     /* 2002853 */   // Label 26797: @2002853
     /* 2002853 */   GIM_Try, /*On fail goto*//*Label 26798*/ GIMT_Encode4(2002939), // Rule ID 65259 //
     /* 2002858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2002869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2002872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2002875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2002878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2002881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002904 */     // MIs[0] policy
     /* 2002904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2002917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002938 */     // GIR_Coverage, 65259,
     /* 2002938 */     GIR_EraseRootFromParent_Done,
     /* 2002939 */   // Label 26798: @2002939
     /* 2002939 */   GIM_Try, /*On fail goto*//*Label 26799*/ GIMT_Encode4(2003025), // Rule ID 65262 //
     /* 2002944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2002947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2002955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2002958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2002961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002990 */     // MIs[0] policy
     /* 2002990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003000 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2003003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003024 */     // GIR_Coverage, 65262,
     /* 2003024 */     GIR_EraseRootFromParent_Done,
     /* 2003025 */   // Label 26799: @2003025
     /* 2003025 */   GIM_Try, /*On fail goto*//*Label 26800*/ GIMT_Encode4(2003111), // Rule ID 65263 //
     /* 2003030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2003033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2003041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2003044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2003047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2003050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003076 */     // MIs[0] policy
     /* 2003076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2003089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003110 */     // GIR_Coverage, 65263,
     /* 2003110 */     GIR_EraseRootFromParent_Done,
     /* 2003111 */   // Label 26800: @2003111
     /* 2003111 */   GIM_Try, /*On fail goto*//*Label 26801*/ GIMT_Encode4(2003197), // Rule ID 65266 //
     /* 2003116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2003119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2003127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2003130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2003133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2003136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003162 */     // MIs[0] policy
     /* 2003162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2003175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003196 */     // GIR_Coverage, 65266,
     /* 2003196 */     GIR_EraseRootFromParent_Done,
     /* 2003197 */   // Label 26801: @2003197
     /* 2003197 */   GIM_Try, /*On fail goto*//*Label 26802*/ GIMT_Encode4(2003283), // Rule ID 65267 //
     /* 2003202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2003205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2003213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2003216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2003219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2003222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003248 */     // MIs[0] policy
     /* 2003248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2003261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003282 */     // GIR_Coverage, 65267,
     /* 2003282 */     GIR_EraseRootFromParent_Done,
     /* 2003283 */   // Label 26802: @2003283
     /* 2003283 */   GIM_Try, /*On fail goto*//*Label 26803*/ GIMT_Encode4(2003369), // Rule ID 65270 //
     /* 2003288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2003291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2003299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2003302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2003305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2003308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2003318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003334 */     // MIs[0] policy
     /* 2003334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003344 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2003347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003368 */     // GIR_Coverage, 65270,
     /* 2003368 */     GIR_EraseRootFromParent_Done,
     /* 2003369 */   // Label 26803: @2003369
     /* 2003369 */   GIM_Try, /*On fail goto*//*Label 26804*/ GIMT_Encode4(2003455), // Rule ID 65271 //
     /* 2003374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2003377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2003385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2003388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2003391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2003394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2003404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003420 */     // MIs[0] policy
     /* 2003420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2003433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003454 */     // GIR_Coverage, 65271,
     /* 2003454 */     GIR_EraseRootFromParent_Done,
     /* 2003455 */   // Label 26804: @2003455
     /* 2003455 */   GIM_Try, /*On fail goto*//*Label 26805*/ GIMT_Encode4(2003541), // Rule ID 65274 //
     /* 2003460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2003463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2003471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2003474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2003480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003506 */     // MIs[0] policy
     /* 2003506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003516 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2003519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003540 */     // GIR_Coverage, 65274,
     /* 2003540 */     GIR_EraseRootFromParent_Done,
     /* 2003541 */   // Label 26805: @2003541
     /* 2003541 */   GIM_Try, /*On fail goto*//*Label 26806*/ GIMT_Encode4(2003627), // Rule ID 65275 //
     /* 2003546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2003549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2003557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2003560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2003566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003592 */     // MIs[0] policy
     /* 2003592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2003605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003626 */     // GIR_Coverage, 65275,
     /* 2003626 */     GIR_EraseRootFromParent_Done,
     /* 2003627 */   // Label 26806: @2003627
     /* 2003627 */   GIM_Try, /*On fail goto*//*Label 26807*/ GIMT_Encode4(2003713), // Rule ID 65278 //
     /* 2003632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2003643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2003646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2003649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2003652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003678 */     // MIs[0] policy
     /* 2003678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003688 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2_MASK),
     /* 2003691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003712 */     // GIR_Coverage, 65278,
     /* 2003712 */     GIR_EraseRootFromParent_Done,
     /* 2003713 */   // Label 26807: @2003713
     /* 2003713 */   GIM_Try, /*On fail goto*//*Label 26808*/ GIMT_Encode4(2003799), // Rule ID 65279 //
     /* 2003718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2003729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2003732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2003735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2003738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003764 */     // MIs[0] policy
     /* 2003764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003774 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2_MASK),
     /* 2003777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003798 */     // GIR_Coverage, 65279,
     /* 2003798 */     GIR_EraseRootFromParent_Done,
     /* 2003799 */   // Label 26808: @2003799
     /* 2003799 */   GIM_Try, /*On fail goto*//*Label 26809*/ GIMT_Encode4(2003885), // Rule ID 65282 //
     /* 2003804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2003821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2003824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003850 */     // MIs[0] policy
     /* 2003850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003860 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2003863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003884 */     // GIR_Coverage, 65282,
     /* 2003884 */     GIR_EraseRootFromParent_Done,
     /* 2003885 */   // Label 26809: @2003885
     /* 2003885 */   GIM_Try, /*On fail goto*//*Label 26810*/ GIMT_Encode4(2003971), // Rule ID 65283 //
     /* 2003890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2003907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2003910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003936 */     // MIs[0] policy
     /* 2003936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2003949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003970 */     // GIR_Coverage, 65283,
     /* 2003970 */     GIR_EraseRootFromParent_Done,
     /* 2003971 */   // Label 26810: @2003971
     /* 2003971 */   GIM_Try, /*On fail goto*//*Label 26811*/ GIMT_Encode4(2004057), // Rule ID 65286 //
     /* 2003976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2003987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2003990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2003993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2003996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004022 */     // MIs[0] policy
     /* 2004022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2004035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004056 */     // GIR_Coverage, 65286,
     /* 2004056 */     GIR_EraseRootFromParent_Done,
     /* 2004057 */   // Label 26811: @2004057
     /* 2004057 */   GIM_Try, /*On fail goto*//*Label 26812*/ GIMT_Encode4(2004143), // Rule ID 65287 //
     /* 2004062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2004073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2004076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2004079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2004082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004108 */     // MIs[0] policy
     /* 2004108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2004121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004142 */     // GIR_Coverage, 65287,
     /* 2004142 */     GIR_EraseRootFromParent_Done,
     /* 2004143 */   // Label 26812: @2004143
     /* 2004143 */   GIM_Try, /*On fail goto*//*Label 26813*/ GIMT_Encode4(2004229), // Rule ID 65290 //
     /* 2004148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2004151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2004159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2004162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2004165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2004168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004194 */     // MIs[0] policy
     /* 2004194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004204 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2004207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004228 */     // GIR_Coverage, 65290,
     /* 2004228 */     GIR_EraseRootFromParent_Done,
     /* 2004229 */   // Label 26813: @2004229
     /* 2004229 */   GIM_Try, /*On fail goto*//*Label 26814*/ GIMT_Encode4(2004315), // Rule ID 65291 //
     /* 2004234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2004245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2004248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2004251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2004254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004280 */     // MIs[0] policy
     /* 2004280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004290 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2004293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004314 */     // GIR_Coverage, 65291,
     /* 2004314 */     GIR_EraseRootFromParent_Done,
     /* 2004315 */   // Label 26814: @2004315
     /* 2004315 */   GIM_Try, /*On fail goto*//*Label 26815*/ GIMT_Encode4(2004401), // Rule ID 65294 //
     /* 2004320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2004323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2004331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2004334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2004337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2004340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004366 */     // MIs[0] policy
     /* 2004366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004376 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2004379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004400 */     // GIR_Coverage, 65294,
     /* 2004400 */     GIR_EraseRootFromParent_Done,
     /* 2004401 */   // Label 26815: @2004401
     /* 2004401 */   GIM_Try, /*On fail goto*//*Label 26816*/ GIMT_Encode4(2004487), // Rule ID 65295 //
     /* 2004406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2004417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2004420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2004423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2004426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004452 */     // MIs[0] policy
     /* 2004452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004462 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2004465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004486 */     // GIR_Coverage, 65295,
     /* 2004486 */     GIR_EraseRootFromParent_Done,
     /* 2004487 */   // Label 26816: @2004487
     /* 2004487 */   GIM_Try, /*On fail goto*//*Label 26817*/ GIMT_Encode4(2004573), // Rule ID 65298 //
     /* 2004492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2004509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2004512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004538 */     // MIs[0] policy
     /* 2004538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004548 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2004551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004572 */     // GIR_Coverage, 65298,
     /* 2004572 */     GIR_EraseRootFromParent_Done,
     /* 2004573 */   // Label 26817: @2004573
     /* 2004573 */   GIM_Try, /*On fail goto*//*Label 26818*/ GIMT_Encode4(2004659), // Rule ID 65299 //
     /* 2004578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2004595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2004598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004624 */     // MIs[0] policy
     /* 2004624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004634 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2004637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004658 */     // GIR_Coverage, 65299,
     /* 2004658 */     GIR_EraseRootFromParent_Done,
     /* 2004659 */   // Label 26818: @2004659
     /* 2004659 */   GIM_Try, /*On fail goto*//*Label 26819*/ GIMT_Encode4(2004745), // Rule ID 65302 //
     /* 2004664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2004675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2004678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2004681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2004684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004710 */     // MIs[0] policy
     /* 2004710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004720 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2004723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004744 */     // GIR_Coverage, 65302,
     /* 2004744 */     GIR_EraseRootFromParent_Done,
     /* 2004745 */   // Label 26819: @2004745
     /* 2004745 */   GIM_Try, /*On fail goto*//*Label 26820*/ GIMT_Encode4(2004831), // Rule ID 65303 //
     /* 2004750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2004761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2004764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2004767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2004770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004796 */     // MIs[0] policy
     /* 2004796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004806 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2004809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004830 */     // GIR_Coverage, 65303,
     /* 2004830 */     GIR_EraseRootFromParent_Done,
     /* 2004831 */   // Label 26820: @2004831
     /* 2004831 */   GIM_Try, /*On fail goto*//*Label 26821*/ GIMT_Encode4(2004917), // Rule ID 65306 //
     /* 2004836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2004847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2004850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2004853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2004856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004882 */     // MIs[0] policy
     /* 2004882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004892 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2004895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004916 */     // GIR_Coverage, 65306,
     /* 2004916 */     GIR_EraseRootFromParent_Done,
     /* 2004917 */   // Label 26821: @2004917
     /* 2004917 */   GIM_Try, /*On fail goto*//*Label 26822*/ GIMT_Encode4(2005003), // Rule ID 65307 //
     /* 2004922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2004933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2004936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2004939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2004942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004968 */     // MIs[0] policy
     /* 2004968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004978 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2004981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005002 */     // GIR_Coverage, 65307,
     /* 2005002 */     GIR_EraseRootFromParent_Done,
     /* 2005003 */   // Label 26822: @2005003
     /* 2005003 */   GIM_Try, /*On fail goto*//*Label 26823*/ GIMT_Encode4(2005089), // Rule ID 65310 //
     /* 2005008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2005011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2005016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2005019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2005022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2005025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2005028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005054 */     // MIs[0] policy
     /* 2005054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005064 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2005067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005088 */     // GIR_Coverage, 65310,
     /* 2005088 */     GIR_EraseRootFromParent_Done,
     /* 2005089 */   // Label 26823: @2005089
     /* 2005089 */   GIM_Try, /*On fail goto*//*Label 26824*/ GIMT_Encode4(2005175), // Rule ID 65311 //
     /* 2005094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2005097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2005102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2005105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2005108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2005111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2005114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005140 */     // MIs[0] policy
     /* 2005140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005150 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2005153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005174 */     // GIR_Coverage, 65311,
     /* 2005174 */     GIR_EraseRootFromParent_Done,
     /* 2005175 */   // Label 26824: @2005175
     /* 2005175 */   GIM_Try, /*On fail goto*//*Label 26825*/ GIMT_Encode4(2005261), // Rule ID 65314 //
     /* 2005180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2005191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2005194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2005197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2005200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005226 */     // MIs[0] policy
     /* 2005226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005236 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2_MASK),
     /* 2005239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005260 */     // GIR_Coverage, 65314,
     /* 2005260 */     GIR_EraseRootFromParent_Done,
     /* 2005261 */   // Label 26825: @2005261
     /* 2005261 */   GIM_Try, /*On fail goto*//*Label 26826*/ GIMT_Encode4(2005347), // Rule ID 65315 //
     /* 2005266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2005277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2005280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2005283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2005286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005312 */     // MIs[0] policy
     /* 2005312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2_MASK),
     /* 2005325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005346 */     // GIR_Coverage, 65315,
     /* 2005346 */     GIR_EraseRootFromParent_Done,
     /* 2005347 */   // Label 26826: @2005347
     /* 2005347 */   GIM_Try, /*On fail goto*//*Label 26827*/ GIMT_Encode4(2005433), // Rule ID 65318 //
     /* 2005352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2005369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2005372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005398 */     // MIs[0] policy
     /* 2005398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2005411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005432 */     // GIR_Coverage, 65318,
     /* 2005432 */     GIR_EraseRootFromParent_Done,
     /* 2005433 */   // Label 26827: @2005433
     /* 2005433 */   GIM_Try, /*On fail goto*//*Label 26828*/ GIMT_Encode4(2005519), // Rule ID 65319 //
     /* 2005438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2005455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2005458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005484 */     // MIs[0] policy
     /* 2005484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005494 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2005497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005518 */     // GIR_Coverage, 65319,
     /* 2005518 */     GIR_EraseRootFromParent_Done,
     /* 2005519 */   // Label 26828: @2005519
     /* 2005519 */   GIM_Try, /*On fail goto*//*Label 26829*/ GIMT_Encode4(2005605), // Rule ID 65322 //
     /* 2005524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2005535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2005538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2005541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2005544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005570 */     // MIs[0] policy
     /* 2005570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2005583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005604 */     // GIR_Coverage, 65322,
     /* 2005604 */     GIR_EraseRootFromParent_Done,
     /* 2005605 */   // Label 26829: @2005605
     /* 2005605 */   GIM_Try, /*On fail goto*//*Label 26830*/ GIMT_Encode4(2005691), // Rule ID 65323 //
     /* 2005610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2005621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2005624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2005627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2005630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005656 */     // MIs[0] policy
     /* 2005656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005666 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2005669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005690 */     // GIR_Coverage, 65323,
     /* 2005690 */     GIR_EraseRootFromParent_Done,
     /* 2005691 */   // Label 26830: @2005691
     /* 2005691 */   GIM_Try, /*On fail goto*//*Label 26831*/ GIMT_Encode4(2005777), // Rule ID 65326 //
     /* 2005696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2005707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2005710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2005713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2005716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2005726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005742 */     // MIs[0] policy
     /* 2005742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005752 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2005755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005776 */     // GIR_Coverage, 65326,
     /* 2005776 */     GIR_EraseRootFromParent_Done,
     /* 2005777 */   // Label 26831: @2005777
     /* 2005777 */   GIM_Try, /*On fail goto*//*Label 26832*/ GIMT_Encode4(2005863), // Rule ID 65327 //
     /* 2005782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2005793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2005796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2005799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2005802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2005812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005828 */     // MIs[0] policy
     /* 2005828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005838 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2005841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005862 */     // GIR_Coverage, 65327,
     /* 2005862 */     GIR_EraseRootFromParent_Done,
     /* 2005863 */   // Label 26832: @2005863
     /* 2005863 */   GIM_Try, /*On fail goto*//*Label 26833*/ GIMT_Encode4(2005949), // Rule ID 65330 //
     /* 2005868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2005879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2005882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2005885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2005888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2005891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005914 */     // MIs[0] policy
     /* 2005914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005924 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2005927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005948 */     // GIR_Coverage, 65330,
     /* 2005948 */     GIR_EraseRootFromParent_Done,
     /* 2005949 */   // Label 26833: @2005949
     /* 2005949 */   GIM_Try, /*On fail goto*//*Label 26834*/ GIMT_Encode4(2006035), // Rule ID 65331 //
     /* 2005954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2005965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2005968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2005971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2005974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2005977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006000 */     // MIs[0] policy
     /* 2006000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006010 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2006013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006034 */     // GIR_Coverage, 65331,
     /* 2006034 */     GIR_EraseRootFromParent_Done,
     /* 2006035 */   // Label 26834: @2006035
     /* 2006035 */   GIM_Try, /*On fail goto*//*Label 26835*/ GIMT_Encode4(2006121), // Rule ID 65334 //
     /* 2006040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2006057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006086 */     // MIs[0] policy
     /* 2006086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006096 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2006099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006120 */     // GIR_Coverage, 65334,
     /* 2006120 */     GIR_EraseRootFromParent_Done,
     /* 2006121 */   // Label 26835: @2006121
     /* 2006121 */   GIM_Try, /*On fail goto*//*Label 26836*/ GIMT_Encode4(2006207), // Rule ID 65335 //
     /* 2006126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2006143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006172 */     // MIs[0] policy
     /* 2006172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006182 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2006185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006206 */     // GIR_Coverage, 65335,
     /* 2006206 */     GIR_EraseRootFromParent_Done,
     /* 2006207 */   // Label 26836: @2006207
     /* 2006207 */   GIM_Try, /*On fail goto*//*Label 26837*/ GIMT_Encode4(2006293), // Rule ID 65338 //
     /* 2006212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2006223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2006226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2006229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2006232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006258 */     // MIs[0] policy
     /* 2006258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006268 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2006271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006292 */     // GIR_Coverage, 65338,
     /* 2006292 */     GIR_EraseRootFromParent_Done,
     /* 2006293 */   // Label 26837: @2006293
     /* 2006293 */   GIM_Try, /*On fail goto*//*Label 26838*/ GIMT_Encode4(2006379), // Rule ID 65339 //
     /* 2006298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2006309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2006312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2006315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2006318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006344 */     // MIs[0] policy
     /* 2006344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006354 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2006357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006378 */     // GIR_Coverage, 65339,
     /* 2006378 */     GIR_EraseRootFromParent_Done,
     /* 2006379 */   // Label 26838: @2006379
     /* 2006379 */   GIM_Try, /*On fail goto*//*Label 26839*/ GIMT_Encode4(2006465), // Rule ID 65342 //
     /* 2006384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2006395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2006398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2006401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2006404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006430 */     // MIs[0] policy
     /* 2006430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006440 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2006443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006464 */     // GIR_Coverage, 65342,
     /* 2006464 */     GIR_EraseRootFromParent_Done,
     /* 2006465 */   // Label 26839: @2006465
     /* 2006465 */   GIM_Try, /*On fail goto*//*Label 26840*/ GIMT_Encode4(2006551), // Rule ID 65343 //
     /* 2006470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2006481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2006484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2006487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2006490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006516 */     // MIs[0] policy
     /* 2006516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006526 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2006529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006550 */     // GIR_Coverage, 65343,
     /* 2006550 */     GIR_EraseRootFromParent_Done,
     /* 2006551 */   // Label 26840: @2006551
     /* 2006551 */   GIM_Try, /*On fail goto*//*Label 26841*/ GIMT_Encode4(2006637), // Rule ID 65346 //
     /* 2006556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2006567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2006570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2006576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006602 */     // MIs[0] policy
     /* 2006602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006612 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2006615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006636 */     // GIR_Coverage, 65346,
     /* 2006636 */     GIR_EraseRootFromParent_Done,
     /* 2006637 */   // Label 26841: @2006637
     /* 2006637 */   GIM_Try, /*On fail goto*//*Label 26842*/ GIMT_Encode4(2006723), // Rule ID 65347 //
     /* 2006642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2006653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2006656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2006662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006688 */     // MIs[0] policy
     /* 2006688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006698 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2006701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006722 */     // GIR_Coverage, 65347,
     /* 2006722 */     GIR_EraseRootFromParent_Done,
     /* 2006723 */   // Label 26842: @2006723
     /* 2006723 */   GIM_Try, /*On fail goto*//*Label 26843*/ GIMT_Encode4(2006812), // Rule ID 2798 //
     /* 2006728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2006745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006774 */     // MIs[0] round
     /* 2006774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006784 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 2006787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006811 */     // GIR_Coverage, 2798,
     /* 2006811 */     GIR_EraseRootFromParent_Done,
     /* 2006812 */   // Label 26843: @2006812
     /* 2006812 */   GIM_Try, /*On fail goto*//*Label 26844*/ GIMT_Encode4(2006901), // Rule ID 2799 //
     /* 2006817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2006834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006863 */     // MIs[0] round
     /* 2006863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006873 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 2006876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006900 */     // GIR_Coverage, 2799,
     /* 2006900 */     GIR_EraseRootFromParent_Done,
     /* 2006901 */   // Label 26844: @2006901
     /* 2006901 */   GIM_Try, /*On fail goto*//*Label 26845*/ GIMT_Encode4(2006990), // Rule ID 22844 //
     /* 2006906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2006923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006952 */     // MIs[0] round
     /* 2006952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006962 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 2006965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006989 */     // GIR_Coverage, 22844,
     /* 2006989 */     GIR_EraseRootFromParent_Done,
     /* 2006990 */   // Label 26845: @2006990
     /* 2006990 */   GIM_Try, /*On fail goto*//*Label 26846*/ GIMT_Encode4(2007079), // Rule ID 22845 //
     /* 2006995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2007012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007041 */     // MIs[0] round
     /* 2007041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007051 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 2007054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007078 */     // GIR_Coverage, 22845,
     /* 2007078 */     GIR_EraseRootFromParent_Done,
     /* 2007079 */   // Label 26846: @2007079
     /* 2007079 */   GIM_Try, /*On fail goto*//*Label 26847*/ GIMT_Encode4(2007168), // Rule ID 22848 //
     /* 2007084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2007087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2007101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007130 */     // MIs[0] round
     /* 2007130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007140 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 2007143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007167 */     // GIR_Coverage, 22848,
     /* 2007167 */     GIR_EraseRootFromParent_Done,
     /* 2007168 */   // Label 26847: @2007168
     /* 2007168 */   GIM_Try, /*On fail goto*//*Label 26848*/ GIMT_Encode4(2007257), // Rule ID 22849 //
     /* 2007173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2007176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2007190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007219 */     // MIs[0] round
     /* 2007219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007229 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 2007232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007256 */     // GIR_Coverage, 22849,
     /* 2007256 */     GIR_EraseRootFromParent_Done,
     /* 2007257 */   // Label 26848: @2007257
     /* 2007257 */   GIM_Try, /*On fail goto*//*Label 26849*/ GIMT_Encode4(2007346), // Rule ID 22852 //
     /* 2007262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2007279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007308 */     // MIs[0] round
     /* 2007308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007318 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 2007321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007345 */     // GIR_Coverage, 22852,
     /* 2007345 */     GIR_EraseRootFromParent_Done,
     /* 2007346 */   // Label 26849: @2007346
     /* 2007346 */   GIM_Try, /*On fail goto*//*Label 26850*/ GIMT_Encode4(2007435), // Rule ID 22853 //
     /* 2007351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2007368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007397 */     // MIs[0] round
     /* 2007397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007407 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 2007410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007434 */     // GIR_Coverage, 22853,
     /* 2007434 */     GIR_EraseRootFromParent_Done,
     /* 2007435 */   // Label 26850: @2007435
     /* 2007435 */   GIM_Try, /*On fail goto*//*Label 26851*/ GIMT_Encode4(2007524), // Rule ID 22856 //
     /* 2007440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2007443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2007457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007486 */     // MIs[0] round
     /* 2007486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007496 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 2007499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007523 */     // GIR_Coverage, 22856,
     /* 2007523 */     GIR_EraseRootFromParent_Done,
     /* 2007524 */   // Label 26851: @2007524
     /* 2007524 */   GIM_Try, /*On fail goto*//*Label 26852*/ GIMT_Encode4(2007613), // Rule ID 22857 //
     /* 2007529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2007532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2007546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007575 */     // MIs[0] round
     /* 2007575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007585 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 2007588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007612 */     // GIR_Coverage, 22857,
     /* 2007612 */     GIR_EraseRootFromParent_Done,
     /* 2007613 */   // Label 26852: @2007613
     /* 2007613 */   GIM_Try, /*On fail goto*//*Label 26853*/ GIMT_Encode4(2007702), // Rule ID 22860 //
     /* 2007618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2007621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2007635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2007638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007664 */     // MIs[0] round
     /* 2007664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007674 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 2007677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007701 */     // GIR_Coverage, 22860,
     /* 2007701 */     GIR_EraseRootFromParent_Done,
     /* 2007702 */   // Label 26853: @2007702
     /* 2007702 */   GIM_Try, /*On fail goto*//*Label 26854*/ GIMT_Encode4(2007791), // Rule ID 22861 //
     /* 2007707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2007710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2007724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2007727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007753 */     // MIs[0] round
     /* 2007753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007763 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 2007766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007790 */     // GIR_Coverage, 22861,
     /* 2007790 */     GIR_EraseRootFromParent_Done,
     /* 2007791 */   // Label 26854: @2007791
     /* 2007791 */   GIM_Try, /*On fail goto*//*Label 26855*/ GIMT_Encode4(2007880), // Rule ID 22864 //
     /* 2007796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2007813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007842 */     // MIs[0] round
     /* 2007842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007852 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 2007855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007879 */     // GIR_Coverage, 22864,
     /* 2007879 */     GIR_EraseRootFromParent_Done,
     /* 2007880 */   // Label 26855: @2007880
     /* 2007880 */   GIM_Try, /*On fail goto*//*Label 26856*/ GIMT_Encode4(2007969), // Rule ID 22865 //
     /* 2007885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2007902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007931 */     // MIs[0] round
     /* 2007931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007941 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 2007944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007968 */     // GIR_Coverage, 22865,
     /* 2007968 */     GIR_EraseRootFromParent_Done,
     /* 2007969 */   // Label 26856: @2007969
     /* 2007969 */   GIM_Try, /*On fail goto*//*Label 26857*/ GIMT_Encode4(2008058), // Rule ID 22868 //
     /* 2007974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2007991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008020 */     // MIs[0] round
     /* 2008020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008030 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 2008033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008057 */     // GIR_Coverage, 22868,
     /* 2008057 */     GIR_EraseRootFromParent_Done,
     /* 2008058 */   // Label 26857: @2008058
     /* 2008058 */   GIM_Try, /*On fail goto*//*Label 26858*/ GIMT_Encode4(2008147), // Rule ID 22869 //
     /* 2008063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2008066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2008074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2008077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2008080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2008083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008109 */     // MIs[0] round
     /* 2008109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008119 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 2008122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008146 */     // GIR_Coverage, 22869,
     /* 2008146 */     GIR_EraseRootFromParent_Done,
     /* 2008147 */   // Label 26858: @2008147
     /* 2008147 */   GIM_Try, /*On fail goto*//*Label 26859*/ GIMT_Encode4(2008236), // Rule ID 22872 //
     /* 2008152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2008155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2008163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2008166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2008169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2008172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2008175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008198 */     // MIs[0] round
     /* 2008198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008208 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 2008211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008235 */     // GIR_Coverage, 22872,
     /* 2008235 */     GIR_EraseRootFromParent_Done,
     /* 2008236 */   // Label 26859: @2008236
     /* 2008236 */   GIM_Try, /*On fail goto*//*Label 26860*/ GIMT_Encode4(2008325), // Rule ID 22873 //
     /* 2008241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2008244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2008252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2008255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2008258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2008261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2008264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008287 */     // MIs[0] round
     /* 2008287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008297 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 2008300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008324 */     // GIR_Coverage, 22873,
     /* 2008324 */     GIR_EraseRootFromParent_Done,
     /* 2008325 */   // Label 26860: @2008325
     /* 2008325 */   GIM_Try, /*On fail goto*//*Label 26861*/ GIMT_Encode4(2008414), // Rule ID 22876 //
     /* 2008330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2008347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008376 */     // MIs[0] round
     /* 2008376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008386 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 2008389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008413 */     // GIR_Coverage, 22876,
     /* 2008413 */     GIR_EraseRootFromParent_Done,
     /* 2008414 */   // Label 26861: @2008414
     /* 2008414 */   GIM_Try, /*On fail goto*//*Label 26862*/ GIMT_Encode4(2008503), // Rule ID 22877 //
     /* 2008419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2008436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008465 */     // MIs[0] round
     /* 2008465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008475 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 2008478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008502 */     // GIR_Coverage, 22877,
     /* 2008502 */     GIR_EraseRootFromParent_Done,
     /* 2008503 */   // Label 26862: @2008503
     /* 2008503 */   GIM_Try, /*On fail goto*//*Label 26863*/ GIMT_Encode4(2008592), // Rule ID 22880 //
     /* 2008508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2008525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008554 */     // MIs[0] round
     /* 2008554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008564 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 2008567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008591 */     // GIR_Coverage, 22880,
     /* 2008591 */     GIR_EraseRootFromParent_Done,
     /* 2008592 */   // Label 26863: @2008592
     /* 2008592 */   GIM_Try, /*On fail goto*//*Label 26864*/ GIMT_Encode4(2008681), // Rule ID 22881 //
     /* 2008597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2008614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008643 */     // MIs[0] round
     /* 2008643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008653 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 2008656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008680 */     // GIR_Coverage, 22881,
     /* 2008680 */     GIR_EraseRootFromParent_Done,
     /* 2008681 */   // Label 26864: @2008681
     /* 2008681 */   GIM_Try, /*On fail goto*//*Label 26865*/ GIMT_Encode4(2008770), // Rule ID 22884 //
     /* 2008686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2008703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008732 */     // MIs[0] round
     /* 2008732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008742 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 2008745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008769 */     // GIR_Coverage, 22884,
     /* 2008769 */     GIR_EraseRootFromParent_Done,
     /* 2008770 */   // Label 26865: @2008770
     /* 2008770 */   GIM_Try, /*On fail goto*//*Label 26866*/ GIMT_Encode4(2008859), // Rule ID 22885 //
     /* 2008775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2008792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008821 */     // MIs[0] round
     /* 2008821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008831 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 2008834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008858 */     // GIR_Coverage, 22885,
     /* 2008858 */     GIR_EraseRootFromParent_Done,
     /* 2008859 */   // Label 26866: @2008859
     /* 2008859 */   GIM_Try, /*On fail goto*//*Label 26867*/ GIMT_Encode4(2008948), // Rule ID 22888 //
     /* 2008864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2008867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2008881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008910 */     // MIs[0] round
     /* 2008910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008920 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 2008923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008947 */     // GIR_Coverage, 22888,
     /* 2008947 */     GIR_EraseRootFromParent_Done,
     /* 2008948 */   // Label 26867: @2008948
     /* 2008948 */   GIM_Try, /*On fail goto*//*Label 26868*/ GIMT_Encode4(2009037), // Rule ID 22889 //
     /* 2008953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2008956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2008970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008999 */     // MIs[0] round
     /* 2008999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009009 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 2009012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009036 */     // GIR_Coverage, 22889,
     /* 2009036 */     GIR_EraseRootFromParent_Done,
     /* 2009037 */   // Label 26868: @2009037
     /* 2009037 */   GIM_Try, /*On fail goto*//*Label 26869*/ GIMT_Encode4(2009126), // Rule ID 22892 //
     /* 2009042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2009045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2009050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2009059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2009062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009088 */     // MIs[0] round
     /* 2009088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009098 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 2009101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009125 */     // GIR_Coverage, 22892,
     /* 2009125 */     GIR_EraseRootFromParent_Done,
     /* 2009126 */   // Label 26869: @2009126
     /* 2009126 */   GIM_Try, /*On fail goto*//*Label 26870*/ GIMT_Encode4(2009215), // Rule ID 22893 //
     /* 2009131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2009134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2009139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2009148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2009151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009177 */     // MIs[0] round
     /* 2009177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009187 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 2009190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009214 */     // GIR_Coverage, 22893,
     /* 2009214 */     GIR_EraseRootFromParent_Done,
     /* 2009215 */   // Label 26870: @2009215
     /* 2009215 */   GIM_Try, /*On fail goto*//*Label 26871*/ GIMT_Encode4(2009304), // Rule ID 22896 //
     /* 2009220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2009223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2009228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2009237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2009240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2009243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009266 */     // MIs[0] round
     /* 2009266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009276 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 2009279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009303 */     // GIR_Coverage, 22896,
     /* 2009303 */     GIR_EraseRootFromParent_Done,
     /* 2009304 */   // Label 26871: @2009304
     /* 2009304 */   GIM_Try, /*On fail goto*//*Label 26872*/ GIMT_Encode4(2009393), // Rule ID 22897 //
     /* 2009309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2009312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2009317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2009326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2009329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2009332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009355 */     // MIs[0] round
     /* 2009355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009365 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 2009368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009392 */     // GIR_Coverage, 22897,
     /* 2009392 */     GIR_EraseRootFromParent_Done,
     /* 2009393 */   // Label 26872: @2009393
     /* 2009393 */   GIM_Try, /*On fail goto*//*Label 26873*/ GIMT_Encode4(2009482), // Rule ID 22900 //
     /* 2009398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2009401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2009415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009444 */     // MIs[0] round
     /* 2009444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009454 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 2009457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009481 */     // GIR_Coverage, 22900,
     /* 2009481 */     GIR_EraseRootFromParent_Done,
     /* 2009482 */   // Label 26873: @2009482
     /* 2009482 */   GIM_Try, /*On fail goto*//*Label 26874*/ GIMT_Encode4(2009571), // Rule ID 22901 //
     /* 2009487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2009490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2009504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009533 */     // MIs[0] round
     /* 2009533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009543 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 2009546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009570 */     // GIR_Coverage, 22901,
     /* 2009570 */     GIR_EraseRootFromParent_Done,
     /* 2009571 */   // Label 26874: @2009571
     /* 2009571 */   GIM_Try, /*On fail goto*//*Label 26875*/ GIMT_Encode4(2009660), // Rule ID 22904 //
     /* 2009576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2009579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2009593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009622 */     // MIs[0] round
     /* 2009622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009632 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 2009635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009659 */     // GIR_Coverage, 22904,
     /* 2009659 */     GIR_EraseRootFromParent_Done,
     /* 2009660 */   // Label 26875: @2009660
     /* 2009660 */   GIM_Try, /*On fail goto*//*Label 26876*/ GIMT_Encode4(2009749), // Rule ID 22905 //
     /* 2009665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2009668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2009682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009711 */     // MIs[0] round
     /* 2009711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009721 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 2009724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009748 */     // GIR_Coverage, 22905,
     /* 2009748 */     GIR_EraseRootFromParent_Done,
     /* 2009749 */   // Label 26876: @2009749
     /* 2009749 */   GIM_Try, /*On fail goto*//*Label 26877*/ GIMT_Encode4(2009838), // Rule ID 22908 //
     /* 2009754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2009757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2009765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2009768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2009771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2009774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009800 */     // MIs[0] round
     /* 2009800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009810 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 2009813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009837 */     // GIR_Coverage, 22908,
     /* 2009837 */     GIR_EraseRootFromParent_Done,
     /* 2009838 */   // Label 26877: @2009838
     /* 2009838 */   GIM_Try, /*On fail goto*//*Label 26878*/ GIMT_Encode4(2009927), // Rule ID 22909 //
     /* 2009843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2009846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2009854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2009857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2009860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2009863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009889 */     // MIs[0] round
     /* 2009889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009899 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 2009902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009926 */     // GIR_Coverage, 22909,
     /* 2009926 */     GIR_EraseRootFromParent_Done,
     /* 2009927 */   // Label 26878: @2009927
     /* 2009927 */   GIM_Try, /*On fail goto*//*Label 26879*/ GIMT_Encode4(2010016), // Rule ID 22912 //
     /* 2009932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2009935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2009949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009978 */     // MIs[0] round
     /* 2009978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009988 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 2009991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010015 */     // GIR_Coverage, 22912,
     /* 2010015 */     GIR_EraseRootFromParent_Done,
     /* 2010016 */   // Label 26879: @2010016
     /* 2010016 */   GIM_Try, /*On fail goto*//*Label 26880*/ GIMT_Encode4(2010105), // Rule ID 22913 //
     /* 2010021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2010038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010067 */     // MIs[0] round
     /* 2010067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010077 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 2010080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010104 */     // GIR_Coverage, 22913,
     /* 2010104 */     GIR_EraseRootFromParent_Done,
     /* 2010105 */   // Label 26880: @2010105
     /* 2010105 */   GIM_Try, /*On fail goto*//*Label 26881*/ GIMT_Encode4(2010194), // Rule ID 22916 //
     /* 2010110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2010113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2010127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010156 */     // MIs[0] round
     /* 2010156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010166 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 2010169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010193 */     // GIR_Coverage, 22916,
     /* 2010193 */     GIR_EraseRootFromParent_Done,
     /* 2010194 */   // Label 26881: @2010194
     /* 2010194 */   GIM_Try, /*On fail goto*//*Label 26882*/ GIMT_Encode4(2010283), // Rule ID 22917 //
     /* 2010199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2010202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2010216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010245 */     // MIs[0] round
     /* 2010245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010255 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 2010258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010282 */     // GIR_Coverage, 22917,
     /* 2010282 */     GIR_EraseRootFromParent_Done,
     /* 2010283 */   // Label 26882: @2010283
     /* 2010283 */   GIM_Try, /*On fail goto*//*Label 26883*/ GIMT_Encode4(2010372), // Rule ID 22920 //
     /* 2010288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2010291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2010299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2010302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2010305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2010308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010334 */     // MIs[0] round
     /* 2010334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010344 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 2010347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010371 */     // GIR_Coverage, 22920,
     /* 2010371 */     GIR_EraseRootFromParent_Done,
     /* 2010372 */   // Label 26883: @2010372
     /* 2010372 */   GIM_Try, /*On fail goto*//*Label 26884*/ GIMT_Encode4(2010461), // Rule ID 22921 //
     /* 2010377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2010380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2010388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2010391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2010394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2010397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010423 */     // MIs[0] round
     /* 2010423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010433 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 2010436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010460 */     // GIR_Coverage, 22921,
     /* 2010460 */     GIR_EraseRootFromParent_Done,
     /* 2010461 */   // Label 26884: @2010461
     /* 2010461 */   GIM_Try, /*On fail goto*//*Label 26885*/ GIMT_Encode4(2010550), // Rule ID 22924 //
     /* 2010466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2010483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010512 */     // MIs[0] round
     /* 2010512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010522 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 2010525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010549 */     // GIR_Coverage, 22924,
     /* 2010549 */     GIR_EraseRootFromParent_Done,
     /* 2010550 */   // Label 26885: @2010550
     /* 2010550 */   GIM_Try, /*On fail goto*//*Label 26886*/ GIMT_Encode4(2010639), // Rule ID 22925 //
     /* 2010555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2010572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010601 */     // MIs[0] round
     /* 2010601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010611 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 2010614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010638 */     // GIR_Coverage, 22925,
     /* 2010638 */     GIR_EraseRootFromParent_Done,
     /* 2010639 */   // Label 26886: @2010639
     /* 2010639 */   GIM_Try, /*On fail goto*//*Label 26887*/ GIMT_Encode4(2010728), // Rule ID 22928 //
     /* 2010644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2010661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010690 */     // MIs[0] round
     /* 2010690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010700 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 2010703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010727 */     // GIR_Coverage, 22928,
     /* 2010727 */     GIR_EraseRootFromParent_Done,
     /* 2010728 */   // Label 26887: @2010728
     /* 2010728 */   GIM_Try, /*On fail goto*//*Label 26888*/ GIMT_Encode4(2010817), // Rule ID 22929 //
     /* 2010733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2010750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010779 */     // MIs[0] round
     /* 2010779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010789 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 2010792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010816 */     // GIR_Coverage, 22929,
     /* 2010816 */     GIR_EraseRootFromParent_Done,
     /* 2010817 */   // Label 26888: @2010817
     /* 2010817 */   GIM_Try, /*On fail goto*//*Label 26889*/ GIMT_Encode4(2010906), // Rule ID 22932 //
     /* 2010822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2010839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2010845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010868 */     // MIs[0] round
     /* 2010868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010878 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 2010881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010905 */     // GIR_Coverage, 22932,
     /* 2010905 */     GIR_EraseRootFromParent_Done,
     /* 2010906 */   // Label 26889: @2010906
     /* 2010906 */   GIM_Try, /*On fail goto*//*Label 26890*/ GIMT_Encode4(2010995), // Rule ID 22933 //
     /* 2010911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2010928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2010934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010957 */     // MIs[0] round
     /* 2010957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010967 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 2010970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010994 */     // GIR_Coverage, 22933,
     /* 2010994 */     GIR_EraseRootFromParent_Done,
     /* 2010995 */   // Label 26890: @2010995
     /* 2010995 */   GIM_Try, /*On fail goto*//*Label 26891*/ GIMT_Encode4(2011084), // Rule ID 22936 //
     /* 2011000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2011003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2011017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011046 */     // MIs[0] round
     /* 2011046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011056 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 2011059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011083 */     // GIR_Coverage, 22936,
     /* 2011083 */     GIR_EraseRootFromParent_Done,
     /* 2011084 */   // Label 26891: @2011084
     /* 2011084 */   GIM_Try, /*On fail goto*//*Label 26892*/ GIMT_Encode4(2011173), // Rule ID 22937 //
     /* 2011089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2011092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2011106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011135 */     // MIs[0] round
     /* 2011135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011145 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 2011148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011172 */     // GIR_Coverage, 22937,
     /* 2011172 */     GIR_EraseRootFromParent_Done,
     /* 2011173 */   // Label 26892: @2011173
     /* 2011173 */   GIM_Try, /*On fail goto*//*Label 26893*/ GIMT_Encode4(2011262), // Rule ID 22940 //
     /* 2011178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2011181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2011195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011224 */     // MIs[0] round
     /* 2011224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011234 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 2011237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011261 */     // GIR_Coverage, 22940,
     /* 2011261 */     GIR_EraseRootFromParent_Done,
     /* 2011262 */   // Label 26893: @2011262
     /* 2011262 */   GIM_Try, /*On fail goto*//*Label 26894*/ GIMT_Encode4(2011351), // Rule ID 22941 //
     /* 2011267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2011270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2011284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011313 */     // MIs[0] round
     /* 2011313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011323 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 2011326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011350 */     // GIR_Coverage, 22941,
     /* 2011350 */     GIR_EraseRootFromParent_Done,
     /* 2011351 */   // Label 26894: @2011351
     /* 2011351 */   GIM_Try, /*On fail goto*//*Label 26895*/ GIMT_Encode4(2011440), // Rule ID 22944 //
     /* 2011356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2011359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2011373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011402 */     // MIs[0] round
     /* 2011402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011412 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 2011415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011439 */     // GIR_Coverage, 22944,
     /* 2011439 */     GIR_EraseRootFromParent_Done,
     /* 2011440 */   // Label 26895: @2011440
     /* 2011440 */   GIM_Try, /*On fail goto*//*Label 26896*/ GIMT_Encode4(2011529), // Rule ID 22945 //
     /* 2011445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2011448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2011462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011491 */     // MIs[0] round
     /* 2011491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011501 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 2011504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011528 */     // GIR_Coverage, 22945,
     /* 2011528 */     GIR_EraseRootFromParent_Done,
     /* 2011529 */   // Label 26896: @2011529
     /* 2011529 */   GIM_Try, /*On fail goto*//*Label 26897*/ GIMT_Encode4(2011618), // Rule ID 22948 //
     /* 2011534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2011537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2011551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011580 */     // MIs[0] round
     /* 2011580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011590 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 2011593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011617 */     // GIR_Coverage, 22948,
     /* 2011617 */     GIR_EraseRootFromParent_Done,
     /* 2011618 */   // Label 26897: @2011618
     /* 2011618 */   GIM_Try, /*On fail goto*//*Label 26898*/ GIMT_Encode4(2011707), // Rule ID 22949 //
     /* 2011623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2011640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011669 */     // MIs[0] round
     /* 2011669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011679 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 2011682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011706 */     // GIR_Coverage, 22949,
     /* 2011706 */     GIR_EraseRootFromParent_Done,
     /* 2011707 */   // Label 26898: @2011707
     /* 2011707 */   GIM_Try, /*On fail goto*//*Label 26899*/ GIMT_Encode4(2011796), // Rule ID 22952 //
     /* 2011712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2011715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2011729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011758 */     // MIs[0] round
     /* 2011758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011768 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2011771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011795 */     // GIR_Coverage, 22952,
     /* 2011795 */     GIR_EraseRootFromParent_Done,
     /* 2011796 */   // Label 26899: @2011796
     /* 2011796 */   GIM_Try, /*On fail goto*//*Label 26900*/ GIMT_Encode4(2011885), // Rule ID 22953 //
     /* 2011801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2011818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011847 */     // MIs[0] round
     /* 2011847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011857 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2011860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011884 */     // GIR_Coverage, 22953,
     /* 2011884 */     GIR_EraseRootFromParent_Done,
     /* 2011885 */   // Label 26900: @2011885
     /* 2011885 */   GIM_Try, /*On fail goto*//*Label 26901*/ GIMT_Encode4(2011974), // Rule ID 22956 //
     /* 2011890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2011893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2011907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011936 */     // MIs[0] round
     /* 2011936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011946 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2011949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011973 */     // GIR_Coverage, 22956,
     /* 2011973 */     GIR_EraseRootFromParent_Done,
     /* 2011974 */   // Label 26901: @2011974
     /* 2011974 */   GIM_Try, /*On fail goto*//*Label 26902*/ GIMT_Encode4(2012063), // Rule ID 22957 //
     /* 2011979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2011996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012025 */     // MIs[0] round
     /* 2012025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012035 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2012038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012062 */     // GIR_Coverage, 22957,
     /* 2012062 */     GIR_EraseRootFromParent_Done,
     /* 2012063 */   // Label 26902: @2012063
     /* 2012063 */   GIM_Try, /*On fail goto*//*Label 26903*/ GIMT_Encode4(2012152), // Rule ID 23080 //
     /* 2012068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2012085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012114 */     // MIs[0] round
     /* 2012114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012124 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2012127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012151 */     // GIR_Coverage, 23080,
     /* 2012151 */     GIR_EraseRootFromParent_Done,
     /* 2012152 */   // Label 26903: @2012152
     /* 2012152 */   GIM_Try, /*On fail goto*//*Label 26904*/ GIMT_Encode4(2012241), // Rule ID 23081 //
     /* 2012157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2012174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012203 */     // MIs[0] round
     /* 2012203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012213 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2012216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012240 */     // GIR_Coverage, 23081,
     /* 2012240 */     GIR_EraseRootFromParent_Done,
     /* 2012241 */   // Label 26904: @2012241
     /* 2012241 */   GIM_Try, /*On fail goto*//*Label 26905*/ GIMT_Encode4(2012330), // Rule ID 23084 //
     /* 2012246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2012263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012292 */     // MIs[0] round
     /* 2012292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012302 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2012305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012329 */     // GIR_Coverage, 23084,
     /* 2012329 */     GIR_EraseRootFromParent_Done,
     /* 2012330 */   // Label 26905: @2012330
     /* 2012330 */   GIM_Try, /*On fail goto*//*Label 26906*/ GIMT_Encode4(2012419), // Rule ID 23085 //
     /* 2012335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2012352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012381 */     // MIs[0] round
     /* 2012381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012391 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2012394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012418 */     // GIR_Coverage, 23085,
     /* 2012418 */     GIR_EraseRootFromParent_Done,
     /* 2012419 */   // Label 26906: @2012419
     /* 2012419 */   GIM_Try, /*On fail goto*//*Label 26907*/ GIMT_Encode4(2012508), // Rule ID 23088 //
     /* 2012424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2012427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2012441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012470 */     // MIs[0] round
     /* 2012470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012480 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2012483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012507 */     // GIR_Coverage, 23088,
     /* 2012507 */     GIR_EraseRootFromParent_Done,
     /* 2012508 */   // Label 26907: @2012508
     /* 2012508 */   GIM_Try, /*On fail goto*//*Label 26908*/ GIMT_Encode4(2012597), // Rule ID 23089 //
     /* 2012513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2012516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2012530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012559 */     // MIs[0] round
     /* 2012559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012569 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2012572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012596 */     // GIR_Coverage, 23089,
     /* 2012596 */     GIR_EraseRootFromParent_Done,
     /* 2012597 */   // Label 26908: @2012597
     /* 2012597 */   GIM_Try, /*On fail goto*//*Label 26909*/ GIMT_Encode4(2012686), // Rule ID 23092 //
     /* 2012602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2012619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012648 */     // MIs[0] round
     /* 2012648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012658 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2012661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012685 */     // GIR_Coverage, 23092,
     /* 2012685 */     GIR_EraseRootFromParent_Done,
     /* 2012686 */   // Label 26909: @2012686
     /* 2012686 */   GIM_Try, /*On fail goto*//*Label 26910*/ GIMT_Encode4(2012775), // Rule ID 23093 //
     /* 2012691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2012708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012737 */     // MIs[0] round
     /* 2012737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012747 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2012750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012774 */     // GIR_Coverage, 23093,
     /* 2012774 */     GIR_EraseRootFromParent_Done,
     /* 2012775 */   // Label 26910: @2012775
     /* 2012775 */   GIM_Try, /*On fail goto*//*Label 26911*/ GIMT_Encode4(2012864), // Rule ID 23096 //
     /* 2012780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2012783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2012797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012826 */     // MIs[0] round
     /* 2012826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012836 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2012839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012863 */     // GIR_Coverage, 23096,
     /* 2012863 */     GIR_EraseRootFromParent_Done,
     /* 2012864 */   // Label 26911: @2012864
     /* 2012864 */   GIM_Try, /*On fail goto*//*Label 26912*/ GIMT_Encode4(2012953), // Rule ID 23097 //
     /* 2012869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2012872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2012886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012915 */     // MIs[0] round
     /* 2012915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012925 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2012928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012952 */     // GIR_Coverage, 23097,
     /* 2012952 */     GIR_EraseRootFromParent_Done,
     /* 2012953 */   // Label 26912: @2012953
     /* 2012953 */   GIM_Try, /*On fail goto*//*Label 26913*/ GIMT_Encode4(2013042), // Rule ID 23100 //
     /* 2012958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2012975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013004 */     // MIs[0] round
     /* 2013004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013014 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2013017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013041 */     // GIR_Coverage, 23100,
     /* 2013041 */     GIR_EraseRootFromParent_Done,
     /* 2013042 */   // Label 26913: @2013042
     /* 2013042 */   GIM_Try, /*On fail goto*//*Label 26914*/ GIMT_Encode4(2013131), // Rule ID 23101 //
     /* 2013047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2013064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013093 */     // MIs[0] round
     /* 2013093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013103 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2013106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013130 */     // GIR_Coverage, 23101,
     /* 2013130 */     GIR_EraseRootFromParent_Done,
     /* 2013131 */   // Label 26914: @2013131
     /* 2013131 */   GIM_Try, /*On fail goto*//*Label 26915*/ GIMT_Encode4(2013220), // Rule ID 23104 //
     /* 2013136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2013139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2013153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2013159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013182 */     // MIs[0] round
     /* 2013182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013192 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2013195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013219 */     // GIR_Coverage, 23104,
     /* 2013219 */     GIR_EraseRootFromParent_Done,
     /* 2013220 */   // Label 26915: @2013220
     /* 2013220 */   GIM_Try, /*On fail goto*//*Label 26916*/ GIMT_Encode4(2013309), // Rule ID 23105 //
     /* 2013225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2013242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2013248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013271 */     // MIs[0] round
     /* 2013271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013281 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2013284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013308 */     // GIR_Coverage, 23105,
     /* 2013308 */     GIR_EraseRootFromParent_Done,
     /* 2013309 */   // Label 26916: @2013309
     /* 2013309 */   GIM_Try, /*On fail goto*//*Label 26917*/ GIMT_Encode4(2013398), // Rule ID 23108 //
     /* 2013314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2013317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2013331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2013337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013360 */     // MIs[0] round
     /* 2013360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013370 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2013373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013397 */     // GIR_Coverage, 23108,
     /* 2013397 */     GIR_EraseRootFromParent_Done,
     /* 2013398 */   // Label 26917: @2013398
     /* 2013398 */   GIM_Try, /*On fail goto*//*Label 26918*/ GIMT_Encode4(2013487), // Rule ID 23109 //
     /* 2013403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2013420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2013426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013449 */     // MIs[0] round
     /* 2013449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013459 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2013462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013486 */     // GIR_Coverage, 23109,
     /* 2013486 */     GIR_EraseRootFromParent_Done,
     /* 2013487 */   // Label 26918: @2013487
     /* 2013487 */   GIM_Try, /*On fail goto*//*Label 26919*/ GIMT_Encode4(2013576), // Rule ID 23112 //
     /* 2013492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2013509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013538 */     // MIs[0] round
     /* 2013538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013548 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2013551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013575 */     // GIR_Coverage, 23112,
     /* 2013575 */     GIR_EraseRootFromParent_Done,
     /* 2013576 */   // Label 26919: @2013576
     /* 2013576 */   GIM_Try, /*On fail goto*//*Label 26920*/ GIMT_Encode4(2013665), // Rule ID 23113 //
     /* 2013581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2013598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013627 */     // MIs[0] round
     /* 2013627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013637 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2013640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013664 */     // GIR_Coverage, 23113,
     /* 2013664 */     GIR_EraseRootFromParent_Done,
     /* 2013665 */   // Label 26920: @2013665
     /* 2013665 */   GIM_Try, /*On fail goto*//*Label 26921*/ GIMT_Encode4(2013754), // Rule ID 23116 //
     /* 2013670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2013687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013716 */     // MIs[0] round
     /* 2013716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013726 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2013729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013753 */     // GIR_Coverage, 23116,
     /* 2013753 */     GIR_EraseRootFromParent_Done,
     /* 2013754 */   // Label 26921: @2013754
     /* 2013754 */   GIM_Try, /*On fail goto*//*Label 26922*/ GIMT_Encode4(2013843), // Rule ID 23117 //
     /* 2013759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2013776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013805 */     // MIs[0] round
     /* 2013805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013815 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2013818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013842 */     // GIR_Coverage, 23117,
     /* 2013842 */     GIR_EraseRootFromParent_Done,
     /* 2013843 */   // Label 26922: @2013843
     /* 2013843 */   GIM_Try, /*On fail goto*//*Label 26923*/ GIMT_Encode4(2013932), // Rule ID 23120 //
     /* 2013848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2013865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2013871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013894 */     // MIs[0] round
     /* 2013894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013904 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2013907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013931 */     // GIR_Coverage, 23120,
     /* 2013931 */     GIR_EraseRootFromParent_Done,
     /* 2013932 */   // Label 26923: @2013932
     /* 2013932 */   GIM_Try, /*On fail goto*//*Label 26924*/ GIMT_Encode4(2014021), // Rule ID 23121 //
     /* 2013937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2013954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2013960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013983 */     // MIs[0] round
     /* 2013983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013993 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2013996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014020 */     // GIR_Coverage, 23121,
     /* 2014020 */     GIR_EraseRootFromParent_Done,
     /* 2014021 */   // Label 26924: @2014021
     /* 2014021 */   GIM_Try, /*On fail goto*//*Label 26925*/ GIMT_Encode4(2014110), // Rule ID 23124 //
     /* 2014026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2014043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014072 */     // MIs[0] round
     /* 2014072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014082 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2014085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014109 */     // GIR_Coverage, 23124,
     /* 2014109 */     GIR_EraseRootFromParent_Done,
     /* 2014110 */   // Label 26925: @2014110
     /* 2014110 */   GIM_Try, /*On fail goto*//*Label 26926*/ GIMT_Encode4(2014199), // Rule ID 23125 //
     /* 2014115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2014132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014161 */     // MIs[0] round
     /* 2014161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014171 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2014174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014198 */     // GIR_Coverage, 23125,
     /* 2014198 */     GIR_EraseRootFromParent_Done,
     /* 2014199 */   // Label 26926: @2014199
     /* 2014199 */   GIM_Try, /*On fail goto*//*Label 26927*/ GIMT_Encode4(2014288), // Rule ID 23128 //
     /* 2014204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2014221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014250 */     // MIs[0] round
     /* 2014250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014260 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2014263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014287 */     // GIR_Coverage, 23128,
     /* 2014287 */     GIR_EraseRootFromParent_Done,
     /* 2014288 */   // Label 26927: @2014288
     /* 2014288 */   GIM_Try, /*On fail goto*//*Label 26928*/ GIMT_Encode4(2014377), // Rule ID 23129 //
     /* 2014293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2014310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014339 */     // MIs[0] round
     /* 2014339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014349 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2014352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014376 */     // GIR_Coverage, 23129,
     /* 2014376 */     GIR_EraseRootFromParent_Done,
     /* 2014377 */   // Label 26928: @2014377
     /* 2014377 */   GIM_Try, /*On fail goto*//*Label 26929*/ GIMT_Encode4(2014466), // Rule ID 23132 //
     /* 2014382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2014385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2014399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014428 */     // MIs[0] round
     /* 2014428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014438 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2014441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014465 */     // GIR_Coverage, 23132,
     /* 2014465 */     GIR_EraseRootFromParent_Done,
     /* 2014466 */   // Label 26929: @2014466
     /* 2014466 */   GIM_Try, /*On fail goto*//*Label 26930*/ GIMT_Encode4(2014555), // Rule ID 23133 //
     /* 2014471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2014474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2014488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014517 */     // MIs[0] round
     /* 2014517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014527 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2014530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014554 */     // GIR_Coverage, 23133,
     /* 2014554 */     GIR_EraseRootFromParent_Done,
     /* 2014555 */   // Label 26930: @2014555
     /* 2014555 */   GIM_Try, /*On fail goto*//*Label 26931*/ GIMT_Encode4(2014644), // Rule ID 23136 //
     /* 2014560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2014577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014606 */     // MIs[0] round
     /* 2014606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014616 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2014619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014643 */     // GIR_Coverage, 23136,
     /* 2014643 */     GIR_EraseRootFromParent_Done,
     /* 2014644 */   // Label 26931: @2014644
     /* 2014644 */   GIM_Try, /*On fail goto*//*Label 26932*/ GIMT_Encode4(2014733), // Rule ID 23137 //
     /* 2014649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2014666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014695 */     // MIs[0] round
     /* 2014695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014705 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2014708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014732 */     // GIR_Coverage, 23137,
     /* 2014732 */     GIR_EraseRootFromParent_Done,
     /* 2014733 */   // Label 26932: @2014733
     /* 2014733 */   GIM_Try, /*On fail goto*//*Label 26933*/ GIMT_Encode4(2014822), // Rule ID 23140 //
     /* 2014738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2014741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014784 */     // MIs[0] round
     /* 2014784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014794 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2014797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014821 */     // GIR_Coverage, 23140,
     /* 2014821 */     GIR_EraseRootFromParent_Done,
     /* 2014822 */   // Label 26933: @2014822
     /* 2014822 */   GIM_Try, /*On fail goto*//*Label 26934*/ GIMT_Encode4(2014911), // Rule ID 23141 //
     /* 2014827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2014830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014873 */     // MIs[0] round
     /* 2014873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014883 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2014886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014910 */     // GIR_Coverage, 23141,
     /* 2014910 */     GIR_EraseRootFromParent_Done,
     /* 2014911 */   // Label 26934: @2014911
     /* 2014911 */   GIM_Try, /*On fail goto*//*Label 26935*/ GIMT_Encode4(2015000), // Rule ID 23144 //
     /* 2014916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2014933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014962 */     // MIs[0] round
     /* 2014962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014972 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2014975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014999 */     // GIR_Coverage, 23144,
     /* 2014999 */     GIR_EraseRootFromParent_Done,
     /* 2015000 */   // Label 26935: @2015000
     /* 2015000 */   GIM_Try, /*On fail goto*//*Label 26936*/ GIMT_Encode4(2015089), // Rule ID 23145 //
     /* 2015005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2015008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2015022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015051 */     // MIs[0] round
     /* 2015051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015061 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2015064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015088 */     // GIR_Coverage, 23145,
     /* 2015088 */     GIR_EraseRootFromParent_Done,
     /* 2015089 */   // Label 26936: @2015089
     /* 2015089 */   GIM_Try, /*On fail goto*//*Label 26937*/ GIMT_Encode4(2015178), // Rule ID 23148 //
     /* 2015094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2015097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2015111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015140 */     // MIs[0] round
     /* 2015140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015150 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2015153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015177 */     // GIR_Coverage, 23148,
     /* 2015177 */     GIR_EraseRootFromParent_Done,
     /* 2015178 */   // Label 26937: @2015178
     /* 2015178 */   GIM_Try, /*On fail goto*//*Label 26938*/ GIMT_Encode4(2015267), // Rule ID 23149 //
     /* 2015183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2015186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2015200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015229 */     // MIs[0] round
     /* 2015229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015239 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2015242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015266 */     // GIR_Coverage, 23149,
     /* 2015266 */     GIR_EraseRootFromParent_Done,
     /* 2015267 */   // Label 26938: @2015267
     /* 2015267 */   GIM_Try, /*On fail goto*//*Label 26939*/ GIMT_Encode4(2015356), // Rule ID 23152 //
     /* 2015272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2015275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2015289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2015295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015318 */     // MIs[0] round
     /* 2015318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015328 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2015331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015355 */     // GIR_Coverage, 23152,
     /* 2015355 */     GIR_EraseRootFromParent_Done,
     /* 2015356 */   // Label 26939: @2015356
     /* 2015356 */   GIM_Try, /*On fail goto*//*Label 26940*/ GIMT_Encode4(2015445), // Rule ID 23153 //
     /* 2015361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2015364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2015378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2015384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015407 */     // MIs[0] round
     /* 2015407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015417 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2015420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015444 */     // GIR_Coverage, 23153,
     /* 2015444 */     GIR_EraseRootFromParent_Done,
     /* 2015445 */   // Label 26940: @2015445
     /* 2015445 */   GIM_Try, /*On fail goto*//*Label 26941*/ GIMT_Encode4(2015534), // Rule ID 23156 //
     /* 2015450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2015453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2015467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015496 */     // MIs[0] round
     /* 2015496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015506 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2015509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015533 */     // GIR_Coverage, 23156,
     /* 2015533 */     GIR_EraseRootFromParent_Done,
     /* 2015534 */   // Label 26941: @2015534
     /* 2015534 */   GIM_Try, /*On fail goto*//*Label 26942*/ GIMT_Encode4(2015623), // Rule ID 23157 //
     /* 2015539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2015556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015585 */     // MIs[0] round
     /* 2015585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015595 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2015598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015622 */     // GIR_Coverage, 23157,
     /* 2015622 */     GIR_EraseRootFromParent_Done,
     /* 2015623 */   // Label 26942: @2015623
     /* 2015623 */   GIM_Try, /*On fail goto*//*Label 26943*/ GIMT_Encode4(2015712), // Rule ID 23160 //
     /* 2015628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2015631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2015645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015674 */     // MIs[0] round
     /* 2015674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015684 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2015687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015711 */     // GIR_Coverage, 23160,
     /* 2015711 */     GIR_EraseRootFromParent_Done,
     /* 2015712 */   // Label 26943: @2015712
     /* 2015712 */   GIM_Try, /*On fail goto*//*Label 26944*/ GIMT_Encode4(2015801), // Rule ID 23161 //
     /* 2015717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2015734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015763 */     // MIs[0] round
     /* 2015763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015773 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2015776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015800 */     // GIR_Coverage, 23161,
     /* 2015800 */     GIR_EraseRootFromParent_Done,
     /* 2015801 */   // Label 26944: @2015801
     /* 2015801 */   GIM_Try, /*On fail goto*//*Label 26945*/ GIMT_Encode4(2015890), // Rule ID 23164 //
     /* 2015806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2015809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2015823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015852 */     // MIs[0] round
     /* 2015852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015862 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2015865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015889 */     // GIR_Coverage, 23164,
     /* 2015889 */     GIR_EraseRootFromParent_Done,
     /* 2015890 */   // Label 26945: @2015890
     /* 2015890 */   GIM_Try, /*On fail goto*//*Label 26946*/ GIMT_Encode4(2015979), // Rule ID 23165 //
     /* 2015895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2015912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015941 */     // MIs[0] round
     /* 2015941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015951 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2015954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015978 */     // GIR_Coverage, 23165,
     /* 2015978 */     GIR_EraseRootFromParent_Done,
     /* 2015979 */   // Label 26946: @2015979
     /* 2015979 */   GIM_Reject,
     /* 2015980 */ // Label 19890: @2015980
     /* 2015980 */ GIM_Try, /*On fail goto*//*Label 26947*/ GIMT_Encode4(2206465),
     /* 2015985 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 2015988 */   GIM_Try, /*On fail goto*//*Label 26948*/ GIMT_Encode4(2016090), // Rule ID 16000 //
     /* 2015993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2016004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2016007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2016010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016043 */     // MIs[1] Operand 1
     /* 2016043 */     // No operand predicates
     /* 2016043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016047 */     // MIs[0] round
     /* 2016047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016050 */     // MIs[0] policy
     /* 2016050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016062 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2016065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016089 */     // GIR_Coverage, 16000,
     /* 2016089 */     GIR_EraseRootFromParent_Done,
     /* 2016090 */   // Label 26948: @2016090
     /* 2016090 */   GIM_Try, /*On fail goto*//*Label 26949*/ GIMT_Encode4(2016192), // Rule ID 16001 //
     /* 2016095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2016106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2016109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2016112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016145 */     // MIs[1] Operand 1
     /* 2016145 */     // No operand predicates
     /* 2016145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016149 */     // MIs[0] round
     /* 2016149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016152 */     // MIs[0] policy
     /* 2016152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016164 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2016167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016191 */     // GIR_Coverage, 16001,
     /* 2016191 */     GIR_EraseRootFromParent_Done,
     /* 2016192 */   // Label 26949: @2016192
     /* 2016192 */   GIM_Try, /*On fail goto*//*Label 26950*/ GIMT_Encode4(2016294), // Rule ID 16004 //
     /* 2016197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2016208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2016211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2016214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016247 */     // MIs[1] Operand 1
     /* 2016247 */     // No operand predicates
     /* 2016247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016251 */     // MIs[0] round
     /* 2016251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016254 */     // MIs[0] policy
     /* 2016254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016266 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2016269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016293 */     // GIR_Coverage, 16004,
     /* 2016293 */     GIR_EraseRootFromParent_Done,
     /* 2016294 */   // Label 26950: @2016294
     /* 2016294 */   GIM_Try, /*On fail goto*//*Label 26951*/ GIMT_Encode4(2016396), // Rule ID 16005 //
     /* 2016299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2016310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2016313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2016316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016349 */     // MIs[1] Operand 1
     /* 2016349 */     // No operand predicates
     /* 2016349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016353 */     // MIs[0] round
     /* 2016353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016356 */     // MIs[0] policy
     /* 2016356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016368 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2016371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016395 */     // GIR_Coverage, 16005,
     /* 2016395 */     GIR_EraseRootFromParent_Done,
     /* 2016396 */   // Label 26951: @2016396
     /* 2016396 */   GIM_Try, /*On fail goto*//*Label 26952*/ GIMT_Encode4(2016498), // Rule ID 16008 //
     /* 2016401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2016412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2016415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2016418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016451 */     // MIs[1] Operand 1
     /* 2016451 */     // No operand predicates
     /* 2016451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016455 */     // MIs[0] round
     /* 2016455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016458 */     // MIs[0] policy
     /* 2016458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016470 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016497 */     // GIR_Coverage, 16008,
     /* 2016497 */     GIR_EraseRootFromParent_Done,
     /* 2016498 */   // Label 26952: @2016498
     /* 2016498 */   GIM_Try, /*On fail goto*//*Label 26953*/ GIMT_Encode4(2016600), // Rule ID 16009 //
     /* 2016503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2016514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2016517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2016520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016553 */     // MIs[1] Operand 1
     /* 2016553 */     // No operand predicates
     /* 2016553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016557 */     // MIs[0] round
     /* 2016557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016560 */     // MIs[0] policy
     /* 2016560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016572 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016599 */     // GIR_Coverage, 16009,
     /* 2016599 */     GIR_EraseRootFromParent_Done,
     /* 2016600 */   // Label 26953: @2016600
     /* 2016600 */   GIM_Try, /*On fail goto*//*Label 26954*/ GIMT_Encode4(2016702), // Rule ID 16012 //
     /* 2016605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2016616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2016619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2016622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016655 */     // MIs[1] Operand 1
     /* 2016655 */     // No operand predicates
     /* 2016655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016659 */     // MIs[0] round
     /* 2016659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016662 */     // MIs[0] policy
     /* 2016662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2016677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016701 */     // GIR_Coverage, 16012,
     /* 2016701 */     GIR_EraseRootFromParent_Done,
     /* 2016702 */   // Label 26954: @2016702
     /* 2016702 */   GIM_Try, /*On fail goto*//*Label 26955*/ GIMT_Encode4(2016804), // Rule ID 16013 //
     /* 2016707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2016718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2016721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2016724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016757 */     // MIs[1] Operand 1
     /* 2016757 */     // No operand predicates
     /* 2016757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016761 */     // MIs[0] round
     /* 2016761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016764 */     // MIs[0] policy
     /* 2016764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016776 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2016779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016803 */     // GIR_Coverage, 16013,
     /* 2016803 */     GIR_EraseRootFromParent_Done,
     /* 2016804 */   // Label 26955: @2016804
     /* 2016804 */   GIM_Try, /*On fail goto*//*Label 26956*/ GIMT_Encode4(2016906), // Rule ID 16016 //
     /* 2016809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2016820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2016823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2016826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016859 */     // MIs[1] Operand 1
     /* 2016859 */     // No operand predicates
     /* 2016859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016863 */     // MIs[0] round
     /* 2016863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016866 */     // MIs[0] policy
     /* 2016866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016878 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016905 */     // GIR_Coverage, 16016,
     /* 2016905 */     GIR_EraseRootFromParent_Done,
     /* 2016906 */   // Label 26956: @2016906
     /* 2016906 */   GIM_Try, /*On fail goto*//*Label 26957*/ GIMT_Encode4(2017008), // Rule ID 16017 //
     /* 2016911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2016922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2016925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2016928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016961 */     // MIs[1] Operand 1
     /* 2016961 */     // No operand predicates
     /* 2016961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016965 */     // MIs[0] round
     /* 2016965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016968 */     // MIs[0] policy
     /* 2016968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016980 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017007 */     // GIR_Coverage, 16017,
     /* 2017007 */     GIR_EraseRootFromParent_Done,
     /* 2017008 */   // Label 26957: @2017008
     /* 2017008 */   GIM_Try, /*On fail goto*//*Label 26958*/ GIMT_Encode4(2017110), // Rule ID 16020 //
     /* 2017013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2017024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2017027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2017030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017063 */     // MIs[1] Operand 1
     /* 2017063 */     // No operand predicates
     /* 2017063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017067 */     // MIs[0] round
     /* 2017067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017070 */     // MIs[0] policy
     /* 2017070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017082 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2017085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017109 */     // GIR_Coverage, 16020,
     /* 2017109 */     GIR_EraseRootFromParent_Done,
     /* 2017110 */   // Label 26958: @2017110
     /* 2017110 */   GIM_Try, /*On fail goto*//*Label 26959*/ GIMT_Encode4(2017212), // Rule ID 16021 //
     /* 2017115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2017126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2017129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2017132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017165 */     // MIs[1] Operand 1
     /* 2017165 */     // No operand predicates
     /* 2017165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017169 */     // MIs[0] round
     /* 2017169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017172 */     // MIs[0] policy
     /* 2017172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2017187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017211 */     // GIR_Coverage, 16021,
     /* 2017211 */     GIR_EraseRootFromParent_Done,
     /* 2017212 */   // Label 26959: @2017212
     /* 2017212 */   GIM_Try, /*On fail goto*//*Label 26960*/ GIMT_Encode4(2017314), // Rule ID 16024 //
     /* 2017217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2017228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2017231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2017234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2017240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017267 */     // MIs[1] Operand 1
     /* 2017267 */     // No operand predicates
     /* 2017267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017271 */     // MIs[0] round
     /* 2017271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017274 */     // MIs[0] policy
     /* 2017274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017286 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017313 */     // GIR_Coverage, 16024,
     /* 2017313 */     GIR_EraseRootFromParent_Done,
     /* 2017314 */   // Label 26960: @2017314
     /* 2017314 */   GIM_Try, /*On fail goto*//*Label 26961*/ GIMT_Encode4(2017416), // Rule ID 16025 //
     /* 2017319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2017330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2017333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2017336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2017342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017369 */     // MIs[1] Operand 1
     /* 2017369 */     // No operand predicates
     /* 2017369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017373 */     // MIs[0] round
     /* 2017373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017376 */     // MIs[0] policy
     /* 2017376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017388 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017415 */     // GIR_Coverage, 16025,
     /* 2017415 */     GIR_EraseRootFromParent_Done,
     /* 2017416 */   // Label 26961: @2017416
     /* 2017416 */   GIM_Try, /*On fail goto*//*Label 26962*/ GIMT_Encode4(2017518), // Rule ID 16028 //
     /* 2017421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2017432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2017435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2017438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2017444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017471 */     // MIs[1] Operand 1
     /* 2017471 */     // No operand predicates
     /* 2017471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017475 */     // MIs[0] round
     /* 2017475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017478 */     // MIs[0] policy
     /* 2017478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017517 */     // GIR_Coverage, 16028,
     /* 2017517 */     GIR_EraseRootFromParent_Done,
     /* 2017518 */   // Label 26962: @2017518
     /* 2017518 */   GIM_Try, /*On fail goto*//*Label 26963*/ GIMT_Encode4(2017620), // Rule ID 16029 //
     /* 2017523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2017534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2017537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2017540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2017546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017573 */     // MIs[1] Operand 1
     /* 2017573 */     // No operand predicates
     /* 2017573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017577 */     // MIs[0] round
     /* 2017577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017580 */     // MIs[0] policy
     /* 2017580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017592 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017619 */     // GIR_Coverage, 16029,
     /* 2017619 */     GIR_EraseRootFromParent_Done,
     /* 2017620 */   // Label 26963: @2017620
     /* 2017620 */   GIM_Try, /*On fail goto*//*Label 26964*/ GIMT_Encode4(2017722), // Rule ID 16032 //
     /* 2017625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2017642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017675 */     // MIs[1] Operand 1
     /* 2017675 */     // No operand predicates
     /* 2017675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017679 */     // MIs[0] round
     /* 2017679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017682 */     // MIs[0] policy
     /* 2017682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017694 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017721 */     // GIR_Coverage, 16032,
     /* 2017721 */     GIR_EraseRootFromParent_Done,
     /* 2017722 */   // Label 26964: @2017722
     /* 2017722 */   GIM_Try, /*On fail goto*//*Label 26965*/ GIMT_Encode4(2017824), // Rule ID 16033 //
     /* 2017727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2017744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017777 */     // MIs[1] Operand 1
     /* 2017777 */     // No operand predicates
     /* 2017777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017781 */     // MIs[0] round
     /* 2017781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017784 */     // MIs[0] policy
     /* 2017784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017823 */     // GIR_Coverage, 16033,
     /* 2017823 */     GIR_EraseRootFromParent_Done,
     /* 2017824 */   // Label 26965: @2017824
     /* 2017824 */   GIM_Try, /*On fail goto*//*Label 26966*/ GIMT_Encode4(2017926), // Rule ID 16036 //
     /* 2017829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2017832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2017846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017879 */     // MIs[1] Operand 1
     /* 2017879 */     // No operand predicates
     /* 2017879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017883 */     // MIs[0] round
     /* 2017883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017886 */     // MIs[0] policy
     /* 2017886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017898 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2017922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017925 */     // GIR_Coverage, 16036,
     /* 2017925 */     GIR_EraseRootFromParent_Done,
     /* 2017926 */   // Label 26966: @2017926
     /* 2017926 */   GIM_Try, /*On fail goto*//*Label 26967*/ GIMT_Encode4(2018028), // Rule ID 16037 //
     /* 2017931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2017934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2017948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017981 */     // MIs[1] Operand 1
     /* 2017981 */     // No operand predicates
     /* 2017981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017985 */     // MIs[0] round
     /* 2017985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017988 */     // MIs[0] policy
     /* 2017988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018000 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2018003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2018024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018027 */     // GIR_Coverage, 16037,
     /* 2018027 */     GIR_EraseRootFromParent_Done,
     /* 2018028 */   // Label 26967: @2018028
     /* 2018028 */   GIM_Try, /*On fail goto*//*Label 26968*/ GIMT_Encode4(2018130), // Rule ID 16040 //
     /* 2018033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2018044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2018047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2018050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018083 */     // MIs[1] Operand 1
     /* 2018083 */     // No operand predicates
     /* 2018083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018087 */     // MIs[0] round
     /* 2018087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018090 */     // MIs[0] policy
     /* 2018090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018102 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018129 */     // GIR_Coverage, 16040,
     /* 2018129 */     GIR_EraseRootFromParent_Done,
     /* 2018130 */   // Label 26968: @2018130
     /* 2018130 */   GIM_Try, /*On fail goto*//*Label 26969*/ GIMT_Encode4(2018232), // Rule ID 16041 //
     /* 2018135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2018146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2018149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2018152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018185 */     // MIs[1] Operand 1
     /* 2018185 */     // No operand predicates
     /* 2018185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018189 */     // MIs[0] round
     /* 2018189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018192 */     // MIs[0] policy
     /* 2018192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018204 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018231 */     // GIR_Coverage, 16041,
     /* 2018231 */     GIR_EraseRootFromParent_Done,
     /* 2018232 */   // Label 26969: @2018232
     /* 2018232 */   GIM_Try, /*On fail goto*//*Label 26970*/ GIMT_Encode4(2018334), // Rule ID 16044 //
     /* 2018237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2018248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2018251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2018254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2018260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018287 */     // MIs[1] Operand 1
     /* 2018287 */     // No operand predicates
     /* 2018287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018291 */     // MIs[0] round
     /* 2018291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018294 */     // MIs[0] policy
     /* 2018294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018306 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2018309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018333 */     // GIR_Coverage, 16044,
     /* 2018333 */     GIR_EraseRootFromParent_Done,
     /* 2018334 */   // Label 26970: @2018334
     /* 2018334 */   GIM_Try, /*On fail goto*//*Label 26971*/ GIMT_Encode4(2018436), // Rule ID 16045 //
     /* 2018339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2018350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2018353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2018356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2018362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018389 */     // MIs[1] Operand 1
     /* 2018389 */     // No operand predicates
     /* 2018389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018393 */     // MIs[0] round
     /* 2018393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018396 */     // MIs[0] policy
     /* 2018396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018408 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2018411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018435 */     // GIR_Coverage, 16045,
     /* 2018435 */     GIR_EraseRootFromParent_Done,
     /* 2018436 */   // Label 26971: @2018436
     /* 2018436 */   GIM_Try, /*On fail goto*//*Label 26972*/ GIMT_Encode4(2018538), // Rule ID 16048 //
     /* 2018441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2018452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2018455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2018458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2018464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018491 */     // MIs[1] Operand 1
     /* 2018491 */     // No operand predicates
     /* 2018491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018495 */     // MIs[0] round
     /* 2018495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018498 */     // MIs[0] policy
     /* 2018498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018510 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2018513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018537 */     // GIR_Coverage, 16048,
     /* 2018537 */     GIR_EraseRootFromParent_Done,
     /* 2018538 */   // Label 26972: @2018538
     /* 2018538 */   GIM_Try, /*On fail goto*//*Label 26973*/ GIMT_Encode4(2018640), // Rule ID 16049 //
     /* 2018543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2018554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2018557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2018560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2018566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018593 */     // MIs[1] Operand 1
     /* 2018593 */     // No operand predicates
     /* 2018593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018597 */     // MIs[0] round
     /* 2018597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018600 */     // MIs[0] policy
     /* 2018600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018612 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2018615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018639 */     // GIR_Coverage, 16049,
     /* 2018639 */     GIR_EraseRootFromParent_Done,
     /* 2018640 */   // Label 26973: @2018640
     /* 2018640 */   GIM_Try, /*On fail goto*//*Label 26974*/ GIMT_Encode4(2018742), // Rule ID 16052 //
     /* 2018645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2018656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2018659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2018662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018695 */     // MIs[1] Operand 1
     /* 2018695 */     // No operand predicates
     /* 2018695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018699 */     // MIs[0] round
     /* 2018699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018702 */     // MIs[0] policy
     /* 2018702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018741 */     // GIR_Coverage, 16052,
     /* 2018741 */     GIR_EraseRootFromParent_Done,
     /* 2018742 */   // Label 26974: @2018742
     /* 2018742 */   GIM_Try, /*On fail goto*//*Label 26975*/ GIMT_Encode4(2018844), // Rule ID 16053 //
     /* 2018747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2018758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2018761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2018764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018797 */     // MIs[1] Operand 1
     /* 2018797 */     // No operand predicates
     /* 2018797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018801 */     // MIs[0] round
     /* 2018801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018804 */     // MIs[0] policy
     /* 2018804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018816 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018843 */     // GIR_Coverage, 16053,
     /* 2018843 */     GIR_EraseRootFromParent_Done,
     /* 2018844 */   // Label 26975: @2018844
     /* 2018844 */   GIM_Try, /*On fail goto*//*Label 26976*/ GIMT_Encode4(2018946), // Rule ID 16056 //
     /* 2018849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2018860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2018863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2018866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018899 */     // MIs[1] Operand 1
     /* 2018899 */     // No operand predicates
     /* 2018899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018903 */     // MIs[0] round
     /* 2018903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018906 */     // MIs[0] policy
     /* 2018906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2018921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018945 */     // GIR_Coverage, 16056,
     /* 2018945 */     GIR_EraseRootFromParent_Done,
     /* 2018946 */   // Label 26976: @2018946
     /* 2018946 */   GIM_Try, /*On fail goto*//*Label 26977*/ GIMT_Encode4(2019048), // Rule ID 16057 //
     /* 2018951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2018962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2018965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2018968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019001 */     // MIs[1] Operand 1
     /* 2019001 */     // No operand predicates
     /* 2019001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019005 */     // MIs[0] round
     /* 2019005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019008 */     // MIs[0] policy
     /* 2019008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019020 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019047 */     // GIR_Coverage, 16057,
     /* 2019047 */     GIR_EraseRootFromParent_Done,
     /* 2019048 */   // Label 26977: @2019048
     /* 2019048 */   GIM_Try, /*On fail goto*//*Label 26978*/ GIMT_Encode4(2019150), // Rule ID 16060 //
     /* 2019053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2019064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2019067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2019070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2019076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019103 */     // MIs[1] Operand 1
     /* 2019103 */     // No operand predicates
     /* 2019103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019107 */     // MIs[0] round
     /* 2019107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019110 */     // MIs[0] policy
     /* 2019110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019122 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019149 */     // GIR_Coverage, 16060,
     /* 2019149 */     GIR_EraseRootFromParent_Done,
     /* 2019150 */   // Label 26978: @2019150
     /* 2019150 */   GIM_Try, /*On fail goto*//*Label 26979*/ GIMT_Encode4(2019252), // Rule ID 16061 //
     /* 2019155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2019166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2019169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2019172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2019178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019205 */     // MIs[1] Operand 1
     /* 2019205 */     // No operand predicates
     /* 2019205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019209 */     // MIs[0] round
     /* 2019209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019212 */     // MIs[0] policy
     /* 2019212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019224 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019251 */     // GIR_Coverage, 16061,
     /* 2019251 */     GIR_EraseRootFromParent_Done,
     /* 2019252 */   // Label 26979: @2019252
     /* 2019252 */   GIM_Try, /*On fail goto*//*Label 26980*/ GIMT_Encode4(2019354), // Rule ID 16064 //
     /* 2019257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2019268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2019271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2019274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019307 */     // MIs[1] Operand 1
     /* 2019307 */     // No operand predicates
     /* 2019307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019311 */     // MIs[0] round
     /* 2019311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019314 */     // MIs[0] policy
     /* 2019314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019326 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2019329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019353 */     // GIR_Coverage, 16064,
     /* 2019353 */     GIR_EraseRootFromParent_Done,
     /* 2019354 */   // Label 26980: @2019354
     /* 2019354 */   GIM_Try, /*On fail goto*//*Label 26981*/ GIMT_Encode4(2019456), // Rule ID 16065 //
     /* 2019359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2019370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2019373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2019376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019409 */     // MIs[1] Operand 1
     /* 2019409 */     // No operand predicates
     /* 2019409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019413 */     // MIs[0] round
     /* 2019413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019416 */     // MIs[0] policy
     /* 2019416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019428 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2019431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019455 */     // GIR_Coverage, 16065,
     /* 2019455 */     GIR_EraseRootFromParent_Done,
     /* 2019456 */   // Label 26981: @2019456
     /* 2019456 */   GIM_Try, /*On fail goto*//*Label 26982*/ GIMT_Encode4(2019558), // Rule ID 16068 //
     /* 2019461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2019472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2019475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019511 */     // MIs[1] Operand 1
     /* 2019511 */     // No operand predicates
     /* 2019511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019515 */     // MIs[0] round
     /* 2019515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019518 */     // MIs[0] policy
     /* 2019518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019530 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019557 */     // GIR_Coverage, 16068,
     /* 2019557 */     GIR_EraseRootFromParent_Done,
     /* 2019558 */   // Label 26982: @2019558
     /* 2019558 */   GIM_Try, /*On fail goto*//*Label 26983*/ GIMT_Encode4(2019660), // Rule ID 16069 //
     /* 2019563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2019574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2019577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019613 */     // MIs[1] Operand 1
     /* 2019613 */     // No operand predicates
     /* 2019613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019617 */     // MIs[0] round
     /* 2019617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019620 */     // MIs[0] policy
     /* 2019620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019632 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019659 */     // GIR_Coverage, 16069,
     /* 2019659 */     GIR_EraseRootFromParent_Done,
     /* 2019660 */   // Label 26983: @2019660
     /* 2019660 */   GIM_Try, /*On fail goto*//*Label 26984*/ GIMT_Encode4(2019762), // Rule ID 16072 //
     /* 2019665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2019676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2019679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019715 */     // MIs[1] Operand 1
     /* 2019715 */     // No operand predicates
     /* 2019715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019719 */     // MIs[0] round
     /* 2019719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019722 */     // MIs[0] policy
     /* 2019722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019734 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019761 */     // GIR_Coverage, 16072,
     /* 2019761 */     GIR_EraseRootFromParent_Done,
     /* 2019762 */   // Label 26984: @2019762
     /* 2019762 */   GIM_Try, /*On fail goto*//*Label 26985*/ GIMT_Encode4(2019864), // Rule ID 16073 //
     /* 2019767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2019778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2019781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019817 */     // MIs[1] Operand 1
     /* 2019817 */     // No operand predicates
     /* 2019817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019821 */     // MIs[0] round
     /* 2019821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019824 */     // MIs[0] policy
     /* 2019824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019836 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019863 */     // GIR_Coverage, 16073,
     /* 2019863 */     GIR_EraseRootFromParent_Done,
     /* 2019864 */   // Label 26985: @2019864
     /* 2019864 */   GIM_Try, /*On fail goto*//*Label 26986*/ GIMT_Encode4(2019966), // Rule ID 16076 //
     /* 2019869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2019872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2019880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2019883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2019886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019919 */     // MIs[1] Operand 1
     /* 2019919 */     // No operand predicates
     /* 2019919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019923 */     // MIs[0] round
     /* 2019923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019926 */     // MIs[0] policy
     /* 2019926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2019941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019965 */     // GIR_Coverage, 16076,
     /* 2019965 */     GIR_EraseRootFromParent_Done,
     /* 2019966 */   // Label 26986: @2019966
     /* 2019966 */   GIM_Try, /*On fail goto*//*Label 26987*/ GIMT_Encode4(2020068), // Rule ID 16077 //
     /* 2019971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2019974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2019982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2019985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2019988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2020001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020021 */     // MIs[1] Operand 1
     /* 2020021 */     // No operand predicates
     /* 2020021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020025 */     // MIs[0] round
     /* 2020025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020028 */     // MIs[0] policy
     /* 2020028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2020043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2020064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020067 */     // GIR_Coverage, 16077,
     /* 2020067 */     GIR_EraseRootFromParent_Done,
     /* 2020068 */   // Label 26987: @2020068
     /* 2020068 */   GIM_Try, /*On fail goto*//*Label 26988*/ GIMT_Encode4(2020170), // Rule ID 16080 //
     /* 2020073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2020076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2020084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2020087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2020090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2020103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020123 */     // MIs[1] Operand 1
     /* 2020123 */     // No operand predicates
     /* 2020123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020127 */     // MIs[0] round
     /* 2020127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020130 */     // MIs[0] policy
     /* 2020130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020142 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2020145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2020166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020169 */     // GIR_Coverage, 16080,
     /* 2020169 */     GIR_EraseRootFromParent_Done,
     /* 2020170 */   // Label 26988: @2020170
     /* 2020170 */   GIM_Try, /*On fail goto*//*Label 26989*/ GIMT_Encode4(2020272), // Rule ID 16081 //
     /* 2020175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2020178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2020186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2020189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2020192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2020205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020225 */     // MIs[1] Operand 1
     /* 2020225 */     // No operand predicates
     /* 2020225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020229 */     // MIs[0] round
     /* 2020229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020232 */     // MIs[0] policy
     /* 2020232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020244 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2020247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2020268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020271 */     // GIR_Coverage, 16081,
     /* 2020271 */     GIR_EraseRootFromParent_Done,
     /* 2020272 */   // Label 26989: @2020272
     /* 2020272 */   GIM_Try, /*On fail goto*//*Label 26990*/ GIMT_Encode4(2020374), // Rule ID 16084 //
     /* 2020277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2020280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2020288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2020291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2020294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2020307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020327 */     // MIs[1] Operand 1
     /* 2020327 */     // No operand predicates
     /* 2020327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020331 */     // MIs[0] round
     /* 2020331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020334 */     // MIs[0] policy
     /* 2020334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2020349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2020370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020373 */     // GIR_Coverage, 16084,
     /* 2020373 */     GIR_EraseRootFromParent_Done,
     /* 2020374 */   // Label 26990: @2020374
     /* 2020374 */   GIM_Try, /*On fail goto*//*Label 26991*/ GIMT_Encode4(2020476), // Rule ID 16085 //
     /* 2020379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2020382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2020390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2020393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2020396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2020409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020429 */     // MIs[1] Operand 1
     /* 2020429 */     // No operand predicates
     /* 2020429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020433 */     // MIs[0] round
     /* 2020433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020436 */     // MIs[0] policy
     /* 2020436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020448 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2020451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2020472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020475 */     // GIR_Coverage, 16085,
     /* 2020475 */     GIR_EraseRootFromParent_Done,
     /* 2020476 */   // Label 26991: @2020476
     /* 2020476 */   GIM_Try, /*On fail goto*//*Label 26992*/ GIMT_Encode4(2020578), // Rule ID 16264 //
     /* 2020481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2020492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2020495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2020498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020531 */     // MIs[1] Operand 1
     /* 2020531 */     // No operand predicates
     /* 2020531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020535 */     // MIs[0] round
     /* 2020535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020538 */     // MIs[0] policy
     /* 2020538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020550 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2020553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020577 */     // GIR_Coverage, 16264,
     /* 2020577 */     GIR_EraseRootFromParent_Done,
     /* 2020578 */   // Label 26992: @2020578
     /* 2020578 */   GIM_Try, /*On fail goto*//*Label 26993*/ GIMT_Encode4(2020680), // Rule ID 16265 //
     /* 2020583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2020594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2020597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2020600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020633 */     // MIs[1] Operand 1
     /* 2020633 */     // No operand predicates
     /* 2020633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020637 */     // MIs[0] round
     /* 2020637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020640 */     // MIs[0] policy
     /* 2020640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020652 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2020655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020679 */     // GIR_Coverage, 16265,
     /* 2020679 */     GIR_EraseRootFromParent_Done,
     /* 2020680 */   // Label 26993: @2020680
     /* 2020680 */   GIM_Try, /*On fail goto*//*Label 26994*/ GIMT_Encode4(2020782), // Rule ID 16268 //
     /* 2020685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2020696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2020699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2020702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020735 */     // MIs[1] Operand 1
     /* 2020735 */     // No operand predicates
     /* 2020735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020739 */     // MIs[0] round
     /* 2020739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020742 */     // MIs[0] policy
     /* 2020742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020754 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2020757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020781 */     // GIR_Coverage, 16268,
     /* 2020781 */     GIR_EraseRootFromParent_Done,
     /* 2020782 */   // Label 26994: @2020782
     /* 2020782 */   GIM_Try, /*On fail goto*//*Label 26995*/ GIMT_Encode4(2020884), // Rule ID 16269 //
     /* 2020787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2020798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2020801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2020804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020837 */     // MIs[1] Operand 1
     /* 2020837 */     // No operand predicates
     /* 2020837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020841 */     // MIs[0] round
     /* 2020841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020844 */     // MIs[0] policy
     /* 2020844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020856 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2020859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020883 */     // GIR_Coverage, 16269,
     /* 2020883 */     GIR_EraseRootFromParent_Done,
     /* 2020884 */   // Label 26995: @2020884
     /* 2020884 */   GIM_Try, /*On fail goto*//*Label 26996*/ GIMT_Encode4(2020986), // Rule ID 16272 //
     /* 2020889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2020900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2020903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2020906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020939 */     // MIs[1] Operand 1
     /* 2020939 */     // No operand predicates
     /* 2020939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020943 */     // MIs[0] round
     /* 2020943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020946 */     // MIs[0] policy
     /* 2020946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020958 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2020961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020985 */     // GIR_Coverage, 16272,
     /* 2020985 */     GIR_EraseRootFromParent_Done,
     /* 2020986 */   // Label 26996: @2020986
     /* 2020986 */   GIM_Try, /*On fail goto*//*Label 26997*/ GIMT_Encode4(2021088), // Rule ID 16273 //
     /* 2020991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2021002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2021005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2021008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021041 */     // MIs[1] Operand 1
     /* 2021041 */     // No operand predicates
     /* 2021041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021045 */     // MIs[0] round
     /* 2021045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021048 */     // MIs[0] policy
     /* 2021048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021060 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021087 */     // GIR_Coverage, 16273,
     /* 2021087 */     GIR_EraseRootFromParent_Done,
     /* 2021088 */   // Label 26997: @2021088
     /* 2021088 */   GIM_Try, /*On fail goto*//*Label 26998*/ GIMT_Encode4(2021190), // Rule ID 16276 //
     /* 2021093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2021104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2021107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2021110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021143 */     // MIs[1] Operand 1
     /* 2021143 */     // No operand predicates
     /* 2021143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021147 */     // MIs[0] round
     /* 2021147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021150 */     // MIs[0] policy
     /* 2021150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021162 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2021165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021189 */     // GIR_Coverage, 16276,
     /* 2021189 */     GIR_EraseRootFromParent_Done,
     /* 2021190 */   // Label 26998: @2021190
     /* 2021190 */   GIM_Try, /*On fail goto*//*Label 26999*/ GIMT_Encode4(2021292), // Rule ID 16277 //
     /* 2021195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2021206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2021209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2021212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021245 */     // MIs[1] Operand 1
     /* 2021245 */     // No operand predicates
     /* 2021245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021249 */     // MIs[0] round
     /* 2021249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021252 */     // MIs[0] policy
     /* 2021252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021264 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2021267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021278 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021288 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021291 */     // GIR_Coverage, 16277,
     /* 2021291 */     GIR_EraseRootFromParent_Done,
     /* 2021292 */   // Label 26999: @2021292
     /* 2021292 */   GIM_Try, /*On fail goto*//*Label 27000*/ GIMT_Encode4(2021394), // Rule ID 16280 //
     /* 2021297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2021308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2021311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2021314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021347 */     // MIs[1] Operand 1
     /* 2021347 */     // No operand predicates
     /* 2021347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021351 */     // MIs[0] round
     /* 2021351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021354 */     // MIs[0] policy
     /* 2021354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021393 */     // GIR_Coverage, 16280,
     /* 2021393 */     GIR_EraseRootFromParent_Done,
     /* 2021394 */   // Label 27000: @2021394
     /* 2021394 */   GIM_Try, /*On fail goto*//*Label 27001*/ GIMT_Encode4(2021496), // Rule ID 16281 //
     /* 2021399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2021410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2021413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2021416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021449 */     // MIs[1] Operand 1
     /* 2021449 */     // No operand predicates
     /* 2021449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021453 */     // MIs[0] round
     /* 2021453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021456 */     // MIs[0] policy
     /* 2021456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021468 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021495 */     // GIR_Coverage, 16281,
     /* 2021495 */     GIR_EraseRootFromParent_Done,
     /* 2021496 */   // Label 27001: @2021496
     /* 2021496 */   GIM_Try, /*On fail goto*//*Label 27002*/ GIMT_Encode4(2021598), // Rule ID 16284 //
     /* 2021501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2021512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2021515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2021518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021551 */     // MIs[1] Operand 1
     /* 2021551 */     // No operand predicates
     /* 2021551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021555 */     // MIs[0] round
     /* 2021555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021558 */     // MIs[0] policy
     /* 2021558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021570 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021597 */     // GIR_Coverage, 16284,
     /* 2021597 */     GIR_EraseRootFromParent_Done,
     /* 2021598 */   // Label 27002: @2021598
     /* 2021598 */   GIM_Try, /*On fail goto*//*Label 27003*/ GIMT_Encode4(2021700), // Rule ID 16285 //
     /* 2021603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2021614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2021617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2021620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021653 */     // MIs[1] Operand 1
     /* 2021653 */     // No operand predicates
     /* 2021653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021657 */     // MIs[0] round
     /* 2021657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021660 */     // MIs[0] policy
     /* 2021660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021699 */     // GIR_Coverage, 16285,
     /* 2021699 */     GIR_EraseRootFromParent_Done,
     /* 2021700 */   // Label 27003: @2021700
     /* 2021700 */   GIM_Try, /*On fail goto*//*Label 27004*/ GIMT_Encode4(2021802), // Rule ID 16288 //
     /* 2021705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2021716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2021719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2021722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021755 */     // MIs[1] Operand 1
     /* 2021755 */     // No operand predicates
     /* 2021755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021759 */     // MIs[0] round
     /* 2021759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021762 */     // MIs[0] policy
     /* 2021762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021774 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021801 */     // GIR_Coverage, 16288,
     /* 2021801 */     GIR_EraseRootFromParent_Done,
     /* 2021802 */   // Label 27004: @2021802
     /* 2021802 */   GIM_Try, /*On fail goto*//*Label 27005*/ GIMT_Encode4(2021904), // Rule ID 16289 //
     /* 2021807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2021818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2021821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2021824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021857 */     // MIs[1] Operand 1
     /* 2021857 */     // No operand predicates
     /* 2021857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021861 */     // MIs[0] round
     /* 2021861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021864 */     // MIs[0] policy
     /* 2021864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021876 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021903 */     // GIR_Coverage, 16289,
     /* 2021903 */     GIR_EraseRootFromParent_Done,
     /* 2021904 */   // Label 27005: @2021904
     /* 2021904 */   GIM_Try, /*On fail goto*//*Label 27006*/ GIMT_Encode4(2022006), // Rule ID 16292 //
     /* 2021909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2021920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2021923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2021926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021959 */     // MIs[1] Operand 1
     /* 2021959 */     // No operand predicates
     /* 2021959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021963 */     // MIs[0] round
     /* 2021963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021966 */     // MIs[0] policy
     /* 2021966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021978 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022005 */     // GIR_Coverage, 16292,
     /* 2022005 */     GIR_EraseRootFromParent_Done,
     /* 2022006 */   // Label 27006: @2022006
     /* 2022006 */   GIM_Try, /*On fail goto*//*Label 27007*/ GIMT_Encode4(2022108), // Rule ID 16293 //
     /* 2022011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2022022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2022025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2022028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2022034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022061 */     // MIs[1] Operand 1
     /* 2022061 */     // No operand predicates
     /* 2022061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022065 */     // MIs[0] round
     /* 2022065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022068 */     // MIs[0] policy
     /* 2022068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022080 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2022083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022107 */     // GIR_Coverage, 16293,
     /* 2022107 */     GIR_EraseRootFromParent_Done,
     /* 2022108 */   // Label 27007: @2022108
     /* 2022108 */   GIM_Try, /*On fail goto*//*Label 27008*/ GIMT_Encode4(2022210), // Rule ID 16296 //
     /* 2022113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2022124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2022127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2022130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2022136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022163 */     // MIs[1] Operand 1
     /* 2022163 */     // No operand predicates
     /* 2022163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022167 */     // MIs[0] round
     /* 2022167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022170 */     // MIs[0] policy
     /* 2022170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022182 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2022185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022209 */     // GIR_Coverage, 16296,
     /* 2022209 */     GIR_EraseRootFromParent_Done,
     /* 2022210 */   // Label 27008: @2022210
     /* 2022210 */   GIM_Try, /*On fail goto*//*Label 27009*/ GIMT_Encode4(2022312), // Rule ID 16297 //
     /* 2022215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2022226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2022229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2022232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2022238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022265 */     // MIs[1] Operand 1
     /* 2022265 */     // No operand predicates
     /* 2022265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022269 */     // MIs[0] round
     /* 2022269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022272 */     // MIs[0] policy
     /* 2022272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022284 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2022287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022311 */     // GIR_Coverage, 16297,
     /* 2022311 */     GIR_EraseRootFromParent_Done,
     /* 2022312 */   // Label 27009: @2022312
     /* 2022312 */   GIM_Try, /*On fail goto*//*Label 27010*/ GIMT_Encode4(2022414), // Rule ID 16300 //
     /* 2022317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2022320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2022328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2022331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2022334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022367 */     // MIs[1] Operand 1
     /* 2022367 */     // No operand predicates
     /* 2022367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022371 */     // MIs[0] round
     /* 2022371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022374 */     // MIs[0] policy
     /* 2022374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022386 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2022389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2022410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022413 */     // GIR_Coverage, 16300,
     /* 2022413 */     GIR_EraseRootFromParent_Done,
     /* 2022414 */   // Label 27010: @2022414
     /* 2022414 */   GIM_Try, /*On fail goto*//*Label 27011*/ GIMT_Encode4(2022516), // Rule ID 16301 //
     /* 2022419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2022422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2022430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2022433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2022436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022469 */     // MIs[1] Operand 1
     /* 2022469 */     // No operand predicates
     /* 2022469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022473 */     // MIs[0] round
     /* 2022473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022476 */     // MIs[0] policy
     /* 2022476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022488 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2022491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2022512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022515 */     // GIR_Coverage, 16301,
     /* 2022515 */     GIR_EraseRootFromParent_Done,
     /* 2022516 */   // Label 27011: @2022516
     /* 2022516 */   GIM_Try, /*On fail goto*//*Label 27012*/ GIMT_Encode4(2022618), // Rule ID 16304 //
     /* 2022521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2022532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2022535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2022538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022571 */     // MIs[1] Operand 1
     /* 2022571 */     // No operand predicates
     /* 2022571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022575 */     // MIs[0] round
     /* 2022575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022578 */     // MIs[0] policy
     /* 2022578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022590 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2022593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022617 */     // GIR_Coverage, 16304,
     /* 2022617 */     GIR_EraseRootFromParent_Done,
     /* 2022618 */   // Label 27012: @2022618
     /* 2022618 */   GIM_Try, /*On fail goto*//*Label 27013*/ GIMT_Encode4(2022720), // Rule ID 16305 //
     /* 2022623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2022634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2022637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2022640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022673 */     // MIs[1] Operand 1
     /* 2022673 */     // No operand predicates
     /* 2022673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022677 */     // MIs[0] round
     /* 2022677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022680 */     // MIs[0] policy
     /* 2022680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022692 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2022695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022719 */     // GIR_Coverage, 16305,
     /* 2022719 */     GIR_EraseRootFromParent_Done,
     /* 2022720 */   // Label 27013: @2022720
     /* 2022720 */   GIM_Try, /*On fail goto*//*Label 27014*/ GIMT_Encode4(2022822), // Rule ID 16308 //
     /* 2022725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2022736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2022739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2022742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2022748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022775 */     // MIs[1] Operand 1
     /* 2022775 */     // No operand predicates
     /* 2022775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022779 */     // MIs[0] round
     /* 2022779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022782 */     // MIs[0] policy
     /* 2022782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022794 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2022797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022821 */     // GIR_Coverage, 16308,
     /* 2022821 */     GIR_EraseRootFromParent_Done,
     /* 2022822 */   // Label 27014: @2022822
     /* 2022822 */   GIM_Try, /*On fail goto*//*Label 27015*/ GIMT_Encode4(2022924), // Rule ID 16309 //
     /* 2022827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2022838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2022841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2022844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2022850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022877 */     // MIs[1] Operand 1
     /* 2022877 */     // No operand predicates
     /* 2022877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022881 */     // MIs[0] round
     /* 2022881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022884 */     // MIs[0] policy
     /* 2022884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022896 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2022899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022923 */     // GIR_Coverage, 16309,
     /* 2022923 */     GIR_EraseRootFromParent_Done,
     /* 2022924 */   // Label 27015: @2022924
     /* 2022924 */   GIM_Try, /*On fail goto*//*Label 27016*/ GIMT_Encode4(2023026), // Rule ID 16312 //
     /* 2022929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2022940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2022943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2022946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2022952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2022959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022979 */     // MIs[1] Operand 1
     /* 2022979 */     // No operand predicates
     /* 2022979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022983 */     // MIs[0] round
     /* 2022983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022986 */     // MIs[0] policy
     /* 2022986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022998 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2023022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023025 */     // GIR_Coverage, 16312,
     /* 2023025 */     GIR_EraseRootFromParent_Done,
     /* 2023026 */   // Label 27016: @2023026
     /* 2023026 */   GIM_Try, /*On fail goto*//*Label 27017*/ GIMT_Encode4(2023128), // Rule ID 16313 //
     /* 2023031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2023042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2023045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2023048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2023054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023081 */     // MIs[1] Operand 1
     /* 2023081 */     // No operand predicates
     /* 2023081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023085 */     // MIs[0] round
     /* 2023085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023088 */     // MIs[0] policy
     /* 2023088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023100 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2023124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023127 */     // GIR_Coverage, 16313,
     /* 2023127 */     GIR_EraseRootFromParent_Done,
     /* 2023128 */   // Label 27017: @2023128
     /* 2023128 */   GIM_Try, /*On fail goto*//*Label 27018*/ GIMT_Encode4(2023230), // Rule ID 16316 //
     /* 2023133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2023144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2023147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2023150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023183 */     // MIs[1] Operand 1
     /* 2023183 */     // No operand predicates
     /* 2023183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023187 */     // MIs[0] round
     /* 2023187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023190 */     // MIs[0] policy
     /* 2023190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023229 */     // GIR_Coverage, 16316,
     /* 2023229 */     GIR_EraseRootFromParent_Done,
     /* 2023230 */   // Label 27018: @2023230
     /* 2023230 */   GIM_Try, /*On fail goto*//*Label 27019*/ GIMT_Encode4(2023332), // Rule ID 16317 //
     /* 2023235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2023246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2023249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2023252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023285 */     // MIs[1] Operand 1
     /* 2023285 */     // No operand predicates
     /* 2023285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023289 */     // MIs[0] round
     /* 2023289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023292 */     // MIs[0] policy
     /* 2023292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023304 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023331 */     // GIR_Coverage, 16317,
     /* 2023331 */     GIR_EraseRootFromParent_Done,
     /* 2023332 */   // Label 27019: @2023332
     /* 2023332 */   GIM_Try, /*On fail goto*//*Label 27020*/ GIMT_Encode4(2023434), // Rule ID 16320 //
     /* 2023337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2023348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2023351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2023354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2023360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023387 */     // MIs[1] Operand 1
     /* 2023387 */     // No operand predicates
     /* 2023387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023391 */     // MIs[0] round
     /* 2023391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023394 */     // MIs[0] policy
     /* 2023394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023406 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2023409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023433 */     // GIR_Coverage, 16320,
     /* 2023433 */     GIR_EraseRootFromParent_Done,
     /* 2023434 */   // Label 27020: @2023434
     /* 2023434 */   GIM_Try, /*On fail goto*//*Label 27021*/ GIMT_Encode4(2023536), // Rule ID 16321 //
     /* 2023439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2023450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2023453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2023456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2023462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023489 */     // MIs[1] Operand 1
     /* 2023489 */     // No operand predicates
     /* 2023489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023493 */     // MIs[0] round
     /* 2023493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023496 */     // MIs[0] policy
     /* 2023496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023508 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2023511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023535 */     // GIR_Coverage, 16321,
     /* 2023535 */     GIR_EraseRootFromParent_Done,
     /* 2023536 */   // Label 27021: @2023536
     /* 2023536 */   GIM_Try, /*On fail goto*//*Label 27022*/ GIMT_Encode4(2023638), // Rule ID 16324 //
     /* 2023541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2023552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2023555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2023558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2023564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023591 */     // MIs[1] Operand 1
     /* 2023591 */     // No operand predicates
     /* 2023591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023595 */     // MIs[0] round
     /* 2023595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023598 */     // MIs[0] policy
     /* 2023598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023610 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023637 */     // GIR_Coverage, 16324,
     /* 2023637 */     GIR_EraseRootFromParent_Done,
     /* 2023638 */   // Label 27022: @2023638
     /* 2023638 */   GIM_Try, /*On fail goto*//*Label 27023*/ GIMT_Encode4(2023740), // Rule ID 16325 //
     /* 2023643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2023654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2023657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2023660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2023666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023693 */     // MIs[1] Operand 1
     /* 2023693 */     // No operand predicates
     /* 2023693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023697 */     // MIs[0] round
     /* 2023697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023700 */     // MIs[0] policy
     /* 2023700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023712 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023736 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023739 */     // GIR_Coverage, 16325,
     /* 2023739 */     GIR_EraseRootFromParent_Done,
     /* 2023740 */   // Label 27023: @2023740
     /* 2023740 */   GIM_Try, /*On fail goto*//*Label 27024*/ GIMT_Encode4(2023842), // Rule ID 16328 //
     /* 2023745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2023756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2023759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2023762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023795 */     // MIs[1] Operand 1
     /* 2023795 */     // No operand predicates
     /* 2023795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023799 */     // MIs[0] round
     /* 2023799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023802 */     // MIs[0] policy
     /* 2023802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023814 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023841 */     // GIR_Coverage, 16328,
     /* 2023841 */     GIR_EraseRootFromParent_Done,
     /* 2023842 */   // Label 27024: @2023842
     /* 2023842 */   GIM_Try, /*On fail goto*//*Label 27025*/ GIMT_Encode4(2023944), // Rule ID 16329 //
     /* 2023847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2023858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2023861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2023864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023897 */     // MIs[1] Operand 1
     /* 2023897 */     // No operand predicates
     /* 2023897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023901 */     // MIs[0] round
     /* 2023901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023904 */     // MIs[0] policy
     /* 2023904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023943 */     // GIR_Coverage, 16329,
     /* 2023943 */     GIR_EraseRootFromParent_Done,
     /* 2023944 */   // Label 27025: @2023944
     /* 2023944 */   GIM_Try, /*On fail goto*//*Label 27026*/ GIMT_Encode4(2024046), // Rule ID 16332 //
     /* 2023949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2023960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2023963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2023966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023999 */     // MIs[1] Operand 1
     /* 2023999 */     // No operand predicates
     /* 2023999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024003 */     // MIs[0] round
     /* 2024003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024006 */     // MIs[0] policy
     /* 2024006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024018 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2024021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024045 */     // GIR_Coverage, 16332,
     /* 2024045 */     GIR_EraseRootFromParent_Done,
     /* 2024046 */   // Label 27026: @2024046
     /* 2024046 */   GIM_Try, /*On fail goto*//*Label 27027*/ GIMT_Encode4(2024148), // Rule ID 16333 //
     /* 2024051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2024062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2024065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2024068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024101 */     // MIs[1] Operand 1
     /* 2024101 */     // No operand predicates
     /* 2024101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024105 */     // MIs[0] round
     /* 2024105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024108 */     // MIs[0] policy
     /* 2024108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024120 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2024123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024147 */     // GIR_Coverage, 16333,
     /* 2024147 */     GIR_EraseRootFromParent_Done,
     /* 2024148 */   // Label 27027: @2024148
     /* 2024148 */   GIM_Try, /*On fail goto*//*Label 27028*/ GIMT_Encode4(2024250), // Rule ID 16336 //
     /* 2024153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2024164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2024167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2024170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2024176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024203 */     // MIs[1] Operand 1
     /* 2024203 */     // No operand predicates
     /* 2024203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024207 */     // MIs[0] round
     /* 2024207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024210 */     // MIs[0] policy
     /* 2024210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024222 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2024225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024249 */     // GIR_Coverage, 16336,
     /* 2024249 */     GIR_EraseRootFromParent_Done,
     /* 2024250 */   // Label 27028: @2024250
     /* 2024250 */   GIM_Try, /*On fail goto*//*Label 27029*/ GIMT_Encode4(2024352), // Rule ID 16337 //
     /* 2024255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2024266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2024269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2024272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2024278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024305 */     // MIs[1] Operand 1
     /* 2024305 */     // No operand predicates
     /* 2024305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024309 */     // MIs[0] round
     /* 2024309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024312 */     // MIs[0] policy
     /* 2024312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024324 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2024327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024351 */     // GIR_Coverage, 16337,
     /* 2024351 */     GIR_EraseRootFromParent_Done,
     /* 2024352 */   // Label 27029: @2024352
     /* 2024352 */   GIM_Try, /*On fail goto*//*Label 27030*/ GIMT_Encode4(2024454), // Rule ID 16340 //
     /* 2024357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2024360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2024368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2024371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2024374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2024387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024407 */     // MIs[1] Operand 1
     /* 2024407 */     // No operand predicates
     /* 2024407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024411 */     // MIs[0] round
     /* 2024411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024414 */     // MIs[0] policy
     /* 2024414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2024429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024453 */     // GIR_Coverage, 16340,
     /* 2024453 */     GIR_EraseRootFromParent_Done,
     /* 2024454 */   // Label 27030: @2024454
     /* 2024454 */   GIM_Try, /*On fail goto*//*Label 27031*/ GIMT_Encode4(2024556), // Rule ID 16341 //
     /* 2024459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2024462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2024470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2024473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2024476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2024489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024509 */     // MIs[1] Operand 1
     /* 2024509 */     // No operand predicates
     /* 2024509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024513 */     // MIs[0] round
     /* 2024513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024516 */     // MIs[0] policy
     /* 2024516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024528 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2024531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024555 */     // GIR_Coverage, 16341,
     /* 2024555 */     GIR_EraseRootFromParent_Done,
     /* 2024556 */   // Label 27031: @2024556
     /* 2024556 */   GIM_Try, /*On fail goto*//*Label 27032*/ GIMT_Encode4(2024658), // Rule ID 16344 //
     /* 2024561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2024564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2024572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2024575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2024578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024611 */     // MIs[1] Operand 1
     /* 2024611 */     // No operand predicates
     /* 2024611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024615 */     // MIs[0] round
     /* 2024615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024618 */     // MIs[0] policy
     /* 2024618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024630 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2024633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024657 */     // GIR_Coverage, 16344,
     /* 2024657 */     GIR_EraseRootFromParent_Done,
     /* 2024658 */   // Label 27032: @2024658
     /* 2024658 */   GIM_Try, /*On fail goto*//*Label 27033*/ GIMT_Encode4(2024760), // Rule ID 16345 //
     /* 2024663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2024666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2024674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2024677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2024680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024713 */     // MIs[1] Operand 1
     /* 2024713 */     // No operand predicates
     /* 2024713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024717 */     // MIs[0] round
     /* 2024717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024720 */     // MIs[0] policy
     /* 2024720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024732 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2024735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024759 */     // GIR_Coverage, 16345,
     /* 2024759 */     GIR_EraseRootFromParent_Done,
     /* 2024760 */   // Label 27033: @2024760
     /* 2024760 */   GIM_Try, /*On fail goto*//*Label 27034*/ GIMT_Encode4(2024862), // Rule ID 16348 //
     /* 2024765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2024768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2024776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2024779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2024782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024815 */     // MIs[1] Operand 1
     /* 2024815 */     // No operand predicates
     /* 2024815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024819 */     // MIs[0] round
     /* 2024819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024822 */     // MIs[0] policy
     /* 2024822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024834 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2024837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024861 */     // GIR_Coverage, 16348,
     /* 2024861 */     GIR_EraseRootFromParent_Done,
     /* 2024862 */   // Label 27034: @2024862
     /* 2024862 */   GIM_Try, /*On fail goto*//*Label 27035*/ GIMT_Encode4(2024964), // Rule ID 16349 //
     /* 2024867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2024870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2024878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2024881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2024884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024917 */     // MIs[1] Operand 1
     /* 2024917 */     // No operand predicates
     /* 2024917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024921 */     // MIs[0] round
     /* 2024921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024924 */     // MIs[0] policy
     /* 2024924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024936 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2024939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024963 */     // GIR_Coverage, 16349,
     /* 2024963 */     GIR_EraseRootFromParent_Done,
     /* 2024964 */   // Label 27035: @2024964
     /* 2024964 */   GIM_Try, /*On fail goto*//*Label 27036*/ GIMT_Encode4(2025069), // Rule ID 16472 //
     /* 2024969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2024977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2024980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2024983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2024986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025019 */     // MIs[1] Operand 1
     /* 2025019 */     // No operand predicates
     /* 2025019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025023 */     // MIs[0] round
     /* 2025023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025026 */     // MIs[0] policy
     /* 2025026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025038 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2025041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025068 */     // GIR_Coverage, 16472,
     /* 2025068 */     GIR_EraseRootFromParent_Done,
     /* 2025069 */   // Label 27036: @2025069
     /* 2025069 */   GIM_Try, /*On fail goto*//*Label 27037*/ GIMT_Encode4(2025174), // Rule ID 16473 //
     /* 2025074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2025085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2025088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2025091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2025097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025124 */     // MIs[1] Operand 1
     /* 2025124 */     // No operand predicates
     /* 2025124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025128 */     // MIs[0] round
     /* 2025128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025131 */     // MIs[0] policy
     /* 2025131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025143 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2025146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025173 */     // GIR_Coverage, 16473,
     /* 2025173 */     GIR_EraseRootFromParent_Done,
     /* 2025174 */   // Label 27037: @2025174
     /* 2025174 */   GIM_Try, /*On fail goto*//*Label 27038*/ GIMT_Encode4(2025279), // Rule ID 16476 //
     /* 2025179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2025190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2025193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2025196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2025202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025229 */     // MIs[1] Operand 1
     /* 2025229 */     // No operand predicates
     /* 2025229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025233 */     // MIs[0] round
     /* 2025233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025236 */     // MIs[0] policy
     /* 2025236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025248 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2025251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025278 */     // GIR_Coverage, 16476,
     /* 2025278 */     GIR_EraseRootFromParent_Done,
     /* 2025279 */   // Label 27038: @2025279
     /* 2025279 */   GIM_Try, /*On fail goto*//*Label 27039*/ GIMT_Encode4(2025384), // Rule ID 16477 //
     /* 2025284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2025295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2025298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2025301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2025307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025334 */     // MIs[1] Operand 1
     /* 2025334 */     // No operand predicates
     /* 2025334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025338 */     // MIs[0] round
     /* 2025338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025341 */     // MIs[0] policy
     /* 2025341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025353 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2025356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025383 */     // GIR_Coverage, 16477,
     /* 2025383 */     GIR_EraseRootFromParent_Done,
     /* 2025384 */   // Label 27039: @2025384
     /* 2025384 */   GIM_Try, /*On fail goto*//*Label 27040*/ GIMT_Encode4(2025489), // Rule ID 16480 //
     /* 2025389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2025400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2025403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2025406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025439 */     // MIs[1] Operand 1
     /* 2025439 */     // No operand predicates
     /* 2025439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025443 */     // MIs[0] round
     /* 2025443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025446 */     // MIs[0] policy
     /* 2025446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025458 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2025461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025488 */     // GIR_Coverage, 16480,
     /* 2025488 */     GIR_EraseRootFromParent_Done,
     /* 2025489 */   // Label 27040: @2025489
     /* 2025489 */   GIM_Try, /*On fail goto*//*Label 27041*/ GIMT_Encode4(2025594), // Rule ID 16481 //
     /* 2025494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2025505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2025508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2025511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025544 */     // MIs[1] Operand 1
     /* 2025544 */     // No operand predicates
     /* 2025544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025548 */     // MIs[0] round
     /* 2025548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025551 */     // MIs[0] policy
     /* 2025551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025563 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2025566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025593 */     // GIR_Coverage, 16481,
     /* 2025593 */     GIR_EraseRootFromParent_Done,
     /* 2025594 */   // Label 27041: @2025594
     /* 2025594 */   GIM_Try, /*On fail goto*//*Label 27042*/ GIMT_Encode4(2025699), // Rule ID 16484 //
     /* 2025599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2025610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2025613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2025616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025649 */     // MIs[1] Operand 1
     /* 2025649 */     // No operand predicates
     /* 2025649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025653 */     // MIs[0] round
     /* 2025653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025656 */     // MIs[0] policy
     /* 2025656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025668 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2025671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025698 */     // GIR_Coverage, 16484,
     /* 2025698 */     GIR_EraseRootFromParent_Done,
     /* 2025699 */   // Label 27042: @2025699
     /* 2025699 */   GIM_Try, /*On fail goto*//*Label 27043*/ GIMT_Encode4(2025804), // Rule ID 16485 //
     /* 2025704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2025715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2025718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2025721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025754 */     // MIs[1] Operand 1
     /* 2025754 */     // No operand predicates
     /* 2025754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025758 */     // MIs[0] round
     /* 2025758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025761 */     // MIs[0] policy
     /* 2025761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025773 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2025776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025803 */     // GIR_Coverage, 16485,
     /* 2025803 */     GIR_EraseRootFromParent_Done,
     /* 2025804 */   // Label 27043: @2025804
     /* 2025804 */   GIM_Try, /*On fail goto*//*Label 27044*/ GIMT_Encode4(2025909), // Rule ID 16488 //
     /* 2025809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2025820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2025823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2025826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025859 */     // MIs[1] Operand 1
     /* 2025859 */     // No operand predicates
     /* 2025859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025863 */     // MIs[0] round
     /* 2025863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025866 */     // MIs[0] policy
     /* 2025866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025878 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2025881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025908 */     // GIR_Coverage, 16488,
     /* 2025908 */     GIR_EraseRootFromParent_Done,
     /* 2025909 */   // Label 27044: @2025909
     /* 2025909 */   GIM_Try, /*On fail goto*//*Label 27045*/ GIMT_Encode4(2026014), // Rule ID 16489 //
     /* 2025914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2025925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2025928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2025931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025964 */     // MIs[1] Operand 1
     /* 2025964 */     // No operand predicates
     /* 2025964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025968 */     // MIs[0] round
     /* 2025968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025971 */     // MIs[0] policy
     /* 2025971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025983 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2025986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2026007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026013 */     // GIR_Coverage, 16489,
     /* 2026013 */     GIR_EraseRootFromParent_Done,
     /* 2026014 */   // Label 27045: @2026014
     /* 2026014 */   GIM_Try, /*On fail goto*//*Label 27046*/ GIMT_Encode4(2026119), // Rule ID 16492 //
     /* 2026019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2026030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2026033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2026036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2026042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026069 */     // MIs[1] Operand 1
     /* 2026069 */     // No operand predicates
     /* 2026069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026073 */     // MIs[0] round
     /* 2026073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026076 */     // MIs[0] policy
     /* 2026076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026088 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2026091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2026112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026118 */     // GIR_Coverage, 16492,
     /* 2026118 */     GIR_EraseRootFromParent_Done,
     /* 2026119 */   // Label 27046: @2026119
     /* 2026119 */   GIM_Try, /*On fail goto*//*Label 27047*/ GIMT_Encode4(2026224), // Rule ID 16493 //
     /* 2026124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2026135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2026138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2026141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2026147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026174 */     // MIs[1] Operand 1
     /* 2026174 */     // No operand predicates
     /* 2026174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026178 */     // MIs[0] round
     /* 2026178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026181 */     // MIs[0] policy
     /* 2026181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026193 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2026196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2026217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026223 */     // GIR_Coverage, 16493,
     /* 2026223 */     GIR_EraseRootFromParent_Done,
     /* 2026224 */   // Label 27047: @2026224
     /* 2026224 */   GIM_Try, /*On fail goto*//*Label 27048*/ GIMT_Encode4(2026329), // Rule ID 16496 //
     /* 2026229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2026240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2026243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2026246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026279 */     // MIs[1] Operand 1
     /* 2026279 */     // No operand predicates
     /* 2026279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026283 */     // MIs[0] round
     /* 2026283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026286 */     // MIs[0] policy
     /* 2026286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026298 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2026301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026328 */     // GIR_Coverage, 16496,
     /* 2026328 */     GIR_EraseRootFromParent_Done,
     /* 2026329 */   // Label 27048: @2026329
     /* 2026329 */   GIM_Try, /*On fail goto*//*Label 27049*/ GIMT_Encode4(2026434), // Rule ID 16497 //
     /* 2026334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2026345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2026348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2026351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026384 */     // MIs[1] Operand 1
     /* 2026384 */     // No operand predicates
     /* 2026384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026388 */     // MIs[0] round
     /* 2026388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026391 */     // MIs[0] policy
     /* 2026391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026403 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2026406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026433 */     // GIR_Coverage, 16497,
     /* 2026433 */     GIR_EraseRootFromParent_Done,
     /* 2026434 */   // Label 27049: @2026434
     /* 2026434 */   GIM_Try, /*On fail goto*//*Label 27050*/ GIMT_Encode4(2026539), // Rule ID 16500 //
     /* 2026439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2026450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2026453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2026456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026489 */     // MIs[1] Operand 1
     /* 2026489 */     // No operand predicates
     /* 2026489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026493 */     // MIs[0] round
     /* 2026493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026496 */     // MIs[0] policy
     /* 2026496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026508 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2026511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026538 */     // GIR_Coverage, 16500,
     /* 2026538 */     GIR_EraseRootFromParent_Done,
     /* 2026539 */   // Label 27050: @2026539
     /* 2026539 */   GIM_Try, /*On fail goto*//*Label 27051*/ GIMT_Encode4(2026644), // Rule ID 16501 //
     /* 2026544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2026555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2026558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2026561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026594 */     // MIs[1] Operand 1
     /* 2026594 */     // No operand predicates
     /* 2026594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026598 */     // MIs[0] round
     /* 2026598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026601 */     // MIs[0] policy
     /* 2026601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026613 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2026616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026643 */     // GIR_Coverage, 16501,
     /* 2026643 */     GIR_EraseRootFromParent_Done,
     /* 2026644 */   // Label 27051: @2026644
     /* 2026644 */   GIM_Try, /*On fail goto*//*Label 27052*/ GIMT_Encode4(2026749), // Rule ID 16504 //
     /* 2026649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2026660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2026663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2026666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026699 */     // MIs[1] Operand 1
     /* 2026699 */     // No operand predicates
     /* 2026699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026703 */     // MIs[0] round
     /* 2026703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026706 */     // MIs[0] policy
     /* 2026706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026718 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2026721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026748 */     // GIR_Coverage, 16504,
     /* 2026748 */     GIR_EraseRootFromParent_Done,
     /* 2026749 */   // Label 27052: @2026749
     /* 2026749 */   GIM_Try, /*On fail goto*//*Label 27053*/ GIMT_Encode4(2026854), // Rule ID 16505 //
     /* 2026754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2026765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2026768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2026771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026804 */     // MIs[1] Operand 1
     /* 2026804 */     // No operand predicates
     /* 2026804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026808 */     // MIs[0] round
     /* 2026808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026811 */     // MIs[0] policy
     /* 2026811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026823 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2026826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026853 */     // GIR_Coverage, 16505,
     /* 2026853 */     GIR_EraseRootFromParent_Done,
     /* 2026854 */   // Label 27053: @2026854
     /* 2026854 */   GIM_Try, /*On fail goto*//*Label 27054*/ GIMT_Encode4(2026959), // Rule ID 16508 //
     /* 2026859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2026870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2026873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2026876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026909 */     // MIs[1] Operand 1
     /* 2026909 */     // No operand predicates
     /* 2026909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026913 */     // MIs[0] round
     /* 2026913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026916 */     // MIs[0] policy
     /* 2026916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026928 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2026931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026958 */     // GIR_Coverage, 16508,
     /* 2026958 */     GIR_EraseRootFromParent_Done,
     /* 2026959 */   // Label 27054: @2026959
     /* 2026959 */   GIM_Try, /*On fail goto*//*Label 27055*/ GIMT_Encode4(2027064), // Rule ID 16509 //
     /* 2026964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2026975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2026978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2026981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027014 */     // MIs[1] Operand 1
     /* 2027014 */     // No operand predicates
     /* 2027014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027018 */     // MIs[0] round
     /* 2027018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027021 */     // MIs[0] policy
     /* 2027021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027033 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2027036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027063 */     // GIR_Coverage, 16509,
     /* 2027063 */     GIR_EraseRootFromParent_Done,
     /* 2027064 */   // Label 27055: @2027064
     /* 2027064 */   GIM_Try, /*On fail goto*//*Label 27056*/ GIMT_Encode4(2027169), // Rule ID 16512 //
     /* 2027069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2027080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2027083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2027086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2027092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027119 */     // MIs[1] Operand 1
     /* 2027119 */     // No operand predicates
     /* 2027119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027123 */     // MIs[0] round
     /* 2027123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027126 */     // MIs[0] policy
     /* 2027126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027138 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2027141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027168 */     // GIR_Coverage, 16512,
     /* 2027168 */     GIR_EraseRootFromParent_Done,
     /* 2027169 */   // Label 27056: @2027169
     /* 2027169 */   GIM_Try, /*On fail goto*//*Label 27057*/ GIMT_Encode4(2027274), // Rule ID 16513 //
     /* 2027174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2027185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2027188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2027191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2027197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027224 */     // MIs[1] Operand 1
     /* 2027224 */     // No operand predicates
     /* 2027224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027228 */     // MIs[0] round
     /* 2027228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027231 */     // MIs[0] policy
     /* 2027231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027243 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2027246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027273 */     // GIR_Coverage, 16513,
     /* 2027273 */     GIR_EraseRootFromParent_Done,
     /* 2027274 */   // Label 27057: @2027274
     /* 2027274 */   GIM_Try, /*On fail goto*//*Label 27058*/ GIMT_Encode4(2027379), // Rule ID 16516 //
     /* 2027279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2027290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2027293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2027296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027329 */     // MIs[1] Operand 1
     /* 2027329 */     // No operand predicates
     /* 2027329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027333 */     // MIs[0] round
     /* 2027333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027336 */     // MIs[0] policy
     /* 2027336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027348 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2027351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027378 */     // GIR_Coverage, 16516,
     /* 2027378 */     GIR_EraseRootFromParent_Done,
     /* 2027379 */   // Label 27058: @2027379
     /* 2027379 */   GIM_Try, /*On fail goto*//*Label 27059*/ GIMT_Encode4(2027484), // Rule ID 16517 //
     /* 2027384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2027387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2027395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2027398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2027401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027434 */     // MIs[1] Operand 1
     /* 2027434 */     // No operand predicates
     /* 2027434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027438 */     // MIs[0] round
     /* 2027438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027441 */     // MIs[0] policy
     /* 2027441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027453 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2027456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027479 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027483 */     // GIR_Coverage, 16517,
     /* 2027483 */     GIR_EraseRootFromParent_Done,
     /* 2027484 */   // Label 27059: @2027484
     /* 2027484 */   GIM_Try, /*On fail goto*//*Label 27060*/ GIMT_Encode4(2027589), // Rule ID 16520 //
     /* 2027489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2027500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2027503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2027506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027539 */     // MIs[1] Operand 1
     /* 2027539 */     // No operand predicates
     /* 2027539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027543 */     // MIs[0] round
     /* 2027543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027546 */     // MIs[0] policy
     /* 2027546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2027561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027588 */     // GIR_Coverage, 16520,
     /* 2027588 */     GIR_EraseRootFromParent_Done,
     /* 2027589 */   // Label 27060: @2027589
     /* 2027589 */   GIM_Try, /*On fail goto*//*Label 27061*/ GIMT_Encode4(2027694), // Rule ID 16521 //
     /* 2027594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2027597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2027605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2027608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2027611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027644 */     // MIs[1] Operand 1
     /* 2027644 */     // No operand predicates
     /* 2027644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027648 */     // MIs[0] round
     /* 2027648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027651 */     // MIs[0] policy
     /* 2027651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027663 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2027666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027693 */     // GIR_Coverage, 16521,
     /* 2027693 */     GIR_EraseRootFromParent_Done,
     /* 2027694 */   // Label 27061: @2027694
     /* 2027694 */   GIM_Try, /*On fail goto*//*Label 27062*/ GIMT_Encode4(2027799), // Rule ID 16524 //
     /* 2027699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2027710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2027713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2027716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027749 */     // MIs[1] Operand 1
     /* 2027749 */     // No operand predicates
     /* 2027749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027753 */     // MIs[0] round
     /* 2027753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027756 */     // MIs[0] policy
     /* 2027756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2027771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027798 */     // GIR_Coverage, 16524,
     /* 2027798 */     GIR_EraseRootFromParent_Done,
     /* 2027799 */   // Label 27062: @2027799
     /* 2027799 */   GIM_Try, /*On fail goto*//*Label 27063*/ GIMT_Encode4(2027904), // Rule ID 16525 //
     /* 2027804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2027807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2027815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2027818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2027821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027854 */     // MIs[1] Operand 1
     /* 2027854 */     // No operand predicates
     /* 2027854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027858 */     // MIs[0] round
     /* 2027858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027861 */     // MIs[0] policy
     /* 2027861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027873 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2027876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027903 */     // GIR_Coverage, 16525,
     /* 2027903 */     GIR_EraseRootFromParent_Done,
     /* 2027904 */   // Label 27063: @2027904
     /* 2027904 */   GIM_Try, /*On fail goto*//*Label 27064*/ GIMT_Encode4(2028009), // Rule ID 16528 //
     /* 2027909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2027920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2027923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2027926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2027932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027959 */     // MIs[1] Operand 1
     /* 2027959 */     // No operand predicates
     /* 2027959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027963 */     // MIs[0] round
     /* 2027963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027966 */     // MIs[0] policy
     /* 2027966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027978 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2027981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028008 */     // GIR_Coverage, 16528,
     /* 2028008 */     GIR_EraseRootFromParent_Done,
     /* 2028009 */   // Label 27064: @2028009
     /* 2028009 */   GIM_Try, /*On fail goto*//*Label 27065*/ GIMT_Encode4(2028114), // Rule ID 16529 //
     /* 2028014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2028017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2028022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2028025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2028028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2028031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2028044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028064 */     // MIs[1] Operand 1
     /* 2028064 */     // No operand predicates
     /* 2028064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028068 */     // MIs[0] round
     /* 2028068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028071 */     // MIs[0] policy
     /* 2028071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028083 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2028086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028113 */     // GIR_Coverage, 16529,
     /* 2028113 */     GIR_EraseRootFromParent_Done,
     /* 2028114 */   // Label 27065: @2028114
     /* 2028114 */   GIM_Try, /*On fail goto*//*Label 27066*/ GIMT_Encode4(2028219), // Rule ID 16652 //
     /* 2028119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2028130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2028133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2028136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028169 */     // MIs[1] Operand 1
     /* 2028169 */     // No operand predicates
     /* 2028169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028173 */     // MIs[0] round
     /* 2028173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028176 */     // MIs[0] policy
     /* 2028176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028188 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2028191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028218 */     // GIR_Coverage, 16652,
     /* 2028218 */     GIR_EraseRootFromParent_Done,
     /* 2028219 */   // Label 27066: @2028219
     /* 2028219 */   GIM_Try, /*On fail goto*//*Label 27067*/ GIMT_Encode4(2028324), // Rule ID 16653 //
     /* 2028224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2028235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2028238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2028241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028274 */     // MIs[1] Operand 1
     /* 2028274 */     // No operand predicates
     /* 2028274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028278 */     // MIs[0] round
     /* 2028278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028281 */     // MIs[0] policy
     /* 2028281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028293 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2028296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028323 */     // GIR_Coverage, 16653,
     /* 2028323 */     GIR_EraseRootFromParent_Done,
     /* 2028324 */   // Label 27067: @2028324
     /* 2028324 */   GIM_Try, /*On fail goto*//*Label 27068*/ GIMT_Encode4(2028429), // Rule ID 16656 //
     /* 2028329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2028340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2028343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2028346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028379 */     // MIs[1] Operand 1
     /* 2028379 */     // No operand predicates
     /* 2028379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028383 */     // MIs[0] round
     /* 2028383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028386 */     // MIs[0] policy
     /* 2028386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028398 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2028401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028428 */     // GIR_Coverage, 16656,
     /* 2028428 */     GIR_EraseRootFromParent_Done,
     /* 2028429 */   // Label 27068: @2028429
     /* 2028429 */   GIM_Try, /*On fail goto*//*Label 27069*/ GIMT_Encode4(2028534), // Rule ID 16657 //
     /* 2028434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2028445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2028448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2028451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028484 */     // MIs[1] Operand 1
     /* 2028484 */     // No operand predicates
     /* 2028484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028488 */     // MIs[0] round
     /* 2028488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028491 */     // MIs[0] policy
     /* 2028491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028503 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2028506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028533 */     // GIR_Coverage, 16657,
     /* 2028533 */     GIR_EraseRootFromParent_Done,
     /* 2028534 */   // Label 27069: @2028534
     /* 2028534 */   GIM_Try, /*On fail goto*//*Label 27070*/ GIMT_Encode4(2028639), // Rule ID 16660 //
     /* 2028539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2028550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2028553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028589 */     // MIs[1] Operand 1
     /* 2028589 */     // No operand predicates
     /* 2028589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028593 */     // MIs[0] round
     /* 2028593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028596 */     // MIs[0] policy
     /* 2028596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028608 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2028611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028638 */     // GIR_Coverage, 16660,
     /* 2028638 */     GIR_EraseRootFromParent_Done,
     /* 2028639 */   // Label 27070: @2028639
     /* 2028639 */   GIM_Try, /*On fail goto*//*Label 27071*/ GIMT_Encode4(2028744), // Rule ID 16661 //
     /* 2028644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2028655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2028658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028694 */     // MIs[1] Operand 1
     /* 2028694 */     // No operand predicates
     /* 2028694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028698 */     // MIs[0] round
     /* 2028698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028701 */     // MIs[0] policy
     /* 2028701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028713 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2028716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028743 */     // GIR_Coverage, 16661,
     /* 2028743 */     GIR_EraseRootFromParent_Done,
     /* 2028744 */   // Label 27071: @2028744
     /* 2028744 */   GIM_Try, /*On fail goto*//*Label 27072*/ GIMT_Encode4(2028849), // Rule ID 16664 //
     /* 2028749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2028766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028799 */     // MIs[1] Operand 1
     /* 2028799 */     // No operand predicates
     /* 2028799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028803 */     // MIs[0] round
     /* 2028803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028806 */     // MIs[0] policy
     /* 2028806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2028821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028848 */     // GIR_Coverage, 16664,
     /* 2028848 */     GIR_EraseRootFromParent_Done,
     /* 2028849 */   // Label 27072: @2028849
     /* 2028849 */   GIM_Try, /*On fail goto*//*Label 27073*/ GIMT_Encode4(2028954), // Rule ID 16665 //
     /* 2028854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2028871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028904 */     // MIs[1] Operand 1
     /* 2028904 */     // No operand predicates
     /* 2028904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028908 */     // MIs[0] round
     /* 2028908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028911 */     // MIs[0] policy
     /* 2028911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028923 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2028926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028953 */     // GIR_Coverage, 16665,
     /* 2028953 */     GIR_EraseRootFromParent_Done,
     /* 2028954 */   // Label 27073: @2028954
     /* 2028954 */   GIM_Try, /*On fail goto*//*Label 27074*/ GIMT_Encode4(2029059), // Rule ID 16668 //
     /* 2028959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2028970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2028973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2028976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2028982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2028989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029009 */     // MIs[1] Operand 1
     /* 2029009 */     // No operand predicates
     /* 2029009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029013 */     // MIs[0] round
     /* 2029013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029016 */     // MIs[0] policy
     /* 2029016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029028 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2029031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029058 */     // GIR_Coverage, 16668,
     /* 2029058 */     GIR_EraseRootFromParent_Done,
     /* 2029059 */   // Label 27074: @2029059
     /* 2029059 */   GIM_Try, /*On fail goto*//*Label 27075*/ GIMT_Encode4(2029164), // Rule ID 16669 //
     /* 2029064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2029075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2029078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2029081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029114 */     // MIs[1] Operand 1
     /* 2029114 */     // No operand predicates
     /* 2029114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029118 */     // MIs[0] round
     /* 2029118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029121 */     // MIs[0] policy
     /* 2029121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029133 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2029136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029163 */     // GIR_Coverage, 16669,
     /* 2029163 */     GIR_EraseRootFromParent_Done,
     /* 2029164 */   // Label 27075: @2029164
     /* 2029164 */   GIM_Try, /*On fail goto*//*Label 27076*/ GIMT_Encode4(2029269), // Rule ID 16672 //
     /* 2029169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2029180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2029183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2029186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2029192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029219 */     // MIs[1] Operand 1
     /* 2029219 */     // No operand predicates
     /* 2029219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029223 */     // MIs[0] round
     /* 2029223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029226 */     // MIs[0] policy
     /* 2029226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029238 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2029241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029268 */     // GIR_Coverage, 16672,
     /* 2029268 */     GIR_EraseRootFromParent_Done,
     /* 2029269 */   // Label 27076: @2029269
     /* 2029269 */   GIM_Try, /*On fail goto*//*Label 27077*/ GIMT_Encode4(2029374), // Rule ID 16673 //
     /* 2029274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2029285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2029288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2029291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2029297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029324 */     // MIs[1] Operand 1
     /* 2029324 */     // No operand predicates
     /* 2029324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029328 */     // MIs[0] round
     /* 2029328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029331 */     // MIs[0] policy
     /* 2029331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029343 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2029346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029373 */     // GIR_Coverage, 16673,
     /* 2029373 */     GIR_EraseRootFromParent_Done,
     /* 2029374 */   // Label 27077: @2029374
     /* 2029374 */   GIM_Try, /*On fail goto*//*Label 27078*/ GIMT_Encode4(2029479), // Rule ID 16676 //
     /* 2029379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2029390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2029393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2029396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029429 */     // MIs[1] Operand 1
     /* 2029429 */     // No operand predicates
     /* 2029429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029433 */     // MIs[0] round
     /* 2029433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029436 */     // MIs[0] policy
     /* 2029436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029448 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2029451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029478 */     // GIR_Coverage, 16676,
     /* 2029478 */     GIR_EraseRootFromParent_Done,
     /* 2029479 */   // Label 27078: @2029479
     /* 2029479 */   GIM_Try, /*On fail goto*//*Label 27079*/ GIMT_Encode4(2029584), // Rule ID 16677 //
     /* 2029484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2029495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2029498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2029501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029534 */     // MIs[1] Operand 1
     /* 2029534 */     // No operand predicates
     /* 2029534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029538 */     // MIs[0] round
     /* 2029538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029541 */     // MIs[0] policy
     /* 2029541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029553 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2029556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029583 */     // GIR_Coverage, 16677,
     /* 2029583 */     GIR_EraseRootFromParent_Done,
     /* 2029584 */   // Label 27079: @2029584
     /* 2029584 */   GIM_Try, /*On fail goto*//*Label 27080*/ GIMT_Encode4(2029689), // Rule ID 16680 //
     /* 2029589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2029600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2029603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2029606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029639 */     // MIs[1] Operand 1
     /* 2029639 */     // No operand predicates
     /* 2029639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029643 */     // MIs[0] round
     /* 2029643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029646 */     // MIs[0] policy
     /* 2029646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029658 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2029661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029688 */     // GIR_Coverage, 16680,
     /* 2029688 */     GIR_EraseRootFromParent_Done,
     /* 2029689 */   // Label 27080: @2029689
     /* 2029689 */   GIM_Try, /*On fail goto*//*Label 27081*/ GIMT_Encode4(2029794), // Rule ID 16681 //
     /* 2029694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2029705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2029708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2029711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029744 */     // MIs[1] Operand 1
     /* 2029744 */     // No operand predicates
     /* 2029744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029748 */     // MIs[0] round
     /* 2029748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029751 */     // MIs[0] policy
     /* 2029751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029763 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2029766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029793 */     // GIR_Coverage, 16681,
     /* 2029793 */     GIR_EraseRootFromParent_Done,
     /* 2029794 */   // Label 27081: @2029794
     /* 2029794 */   GIM_Try, /*On fail goto*//*Label 27082*/ GIMT_Encode4(2029899), // Rule ID 16684 //
     /* 2029799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2029810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2029813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2029816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2029822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029849 */     // MIs[1] Operand 1
     /* 2029849 */     // No operand predicates
     /* 2029849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029853 */     // MIs[0] round
     /* 2029853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029856 */     // MIs[0] policy
     /* 2029856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2029871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029898 */     // GIR_Coverage, 16684,
     /* 2029898 */     GIR_EraseRootFromParent_Done,
     /* 2029899 */   // Label 27082: @2029899
     /* 2029899 */   GIM_Try, /*On fail goto*//*Label 27083*/ GIMT_Encode4(2030004), // Rule ID 16685 //
     /* 2029904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2029915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2029918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2029921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2029927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029954 */     // MIs[1] Operand 1
     /* 2029954 */     // No operand predicates
     /* 2029954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029958 */     // MIs[0] round
     /* 2029958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029961 */     // MIs[0] policy
     /* 2029961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029973 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2029976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030003 */     // GIR_Coverage, 16685,
     /* 2030003 */     GIR_EraseRootFromParent_Done,
     /* 2030004 */   // Label 27083: @2030004
     /* 2030004 */   GIM_Try, /*On fail goto*//*Label 27084*/ GIMT_Encode4(2030109), // Rule ID 16688 //
     /* 2030009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2030020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2030023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2030026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030059 */     // MIs[1] Operand 1
     /* 2030059 */     // No operand predicates
     /* 2030059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030063 */     // MIs[0] round
     /* 2030063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030066 */     // MIs[0] policy
     /* 2030066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030078 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2030081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030108 */     // GIR_Coverage, 16688,
     /* 2030108 */     GIR_EraseRootFromParent_Done,
     /* 2030109 */   // Label 27084: @2030109
     /* 2030109 */   GIM_Try, /*On fail goto*//*Label 27085*/ GIMT_Encode4(2030214), // Rule ID 16689 //
     /* 2030114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2030125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2030128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2030131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030164 */     // MIs[1] Operand 1
     /* 2030164 */     // No operand predicates
     /* 2030164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030168 */     // MIs[0] round
     /* 2030168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030171 */     // MIs[0] policy
     /* 2030171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030183 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2030186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030213 */     // GIR_Coverage, 16689,
     /* 2030213 */     GIR_EraseRootFromParent_Done,
     /* 2030214 */   // Label 27085: @2030214
     /* 2030214 */   GIM_Try, /*On fail goto*//*Label 27086*/ GIMT_Encode4(2030319), // Rule ID 16692 //
     /* 2030219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2030230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2030233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2030236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030269 */     // MIs[1] Operand 1
     /* 2030269 */     // No operand predicates
     /* 2030269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030273 */     // MIs[0] round
     /* 2030273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030276 */     // MIs[0] policy
     /* 2030276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030288 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2030291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030318 */     // GIR_Coverage, 16692,
     /* 2030318 */     GIR_EraseRootFromParent_Done,
     /* 2030319 */   // Label 27086: @2030319
     /* 2030319 */   GIM_Try, /*On fail goto*//*Label 27087*/ GIMT_Encode4(2030424), // Rule ID 16693 //
     /* 2030324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2030335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2030338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2030341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030374 */     // MIs[1] Operand 1
     /* 2030374 */     // No operand predicates
     /* 2030374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030378 */     // MIs[0] round
     /* 2030378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030381 */     // MIs[0] policy
     /* 2030381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030393 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2030396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030423 */     // GIR_Coverage, 16693,
     /* 2030423 */     GIR_EraseRootFromParent_Done,
     /* 2030424 */   // Label 27087: @2030424
     /* 2030424 */   GIM_Try, /*On fail goto*//*Label 27088*/ GIMT_Encode4(2030529), // Rule ID 16696 //
     /* 2030429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2030440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2030443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2030446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2030452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030479 */     // MIs[1] Operand 1
     /* 2030479 */     // No operand predicates
     /* 2030479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030483 */     // MIs[0] round
     /* 2030483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030486 */     // MIs[0] policy
     /* 2030486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030498 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2030501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030528 */     // GIR_Coverage, 16696,
     /* 2030528 */     GIR_EraseRootFromParent_Done,
     /* 2030529 */   // Label 27088: @2030529
     /* 2030529 */   GIM_Try, /*On fail goto*//*Label 27089*/ GIMT_Encode4(2030634), // Rule ID 16697 //
     /* 2030534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2030545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2030548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2030551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2030557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030584 */     // MIs[1] Operand 1
     /* 2030584 */     // No operand predicates
     /* 2030584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030588 */     // MIs[0] round
     /* 2030588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030591 */     // MIs[0] policy
     /* 2030591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030603 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2030606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030633 */     // GIR_Coverage, 16697,
     /* 2030633 */     GIR_EraseRootFromParent_Done,
     /* 2030634 */   // Label 27089: @2030634
     /* 2030634 */   GIM_Try, /*On fail goto*//*Label 27090*/ GIMT_Encode4(2030739), // Rule ID 16700 //
     /* 2030639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2030650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2030653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030689 */     // MIs[1] Operand 1
     /* 2030689 */     // No operand predicates
     /* 2030689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030693 */     // MIs[0] round
     /* 2030693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030696 */     // MIs[0] policy
     /* 2030696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030708 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2030711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030738 */     // GIR_Coverage, 16700,
     /* 2030738 */     GIR_EraseRootFromParent_Done,
     /* 2030739 */   // Label 27090: @2030739
     /* 2030739 */   GIM_Try, /*On fail goto*//*Label 27091*/ GIMT_Encode4(2030844), // Rule ID 16701 //
     /* 2030744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2030755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2030758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030794 */     // MIs[1] Operand 1
     /* 2030794 */     // No operand predicates
     /* 2030794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030798 */     // MIs[0] round
     /* 2030798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030801 */     // MIs[0] policy
     /* 2030801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030813 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2030816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030843 */     // GIR_Coverage, 16701,
     /* 2030843 */     GIR_EraseRootFromParent_Done,
     /* 2030844 */   // Label 27091: @2030844
     /* 2030844 */   GIM_Try, /*On fail goto*//*Label 27092*/ GIMT_Encode4(2030949), // Rule ID 16704 //
     /* 2030849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2030866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030899 */     // MIs[1] Operand 1
     /* 2030899 */     // No operand predicates
     /* 2030899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030903 */     // MIs[0] round
     /* 2030903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030906 */     // MIs[0] policy
     /* 2030906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2030921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030948 */     // GIR_Coverage, 16704,
     /* 2030948 */     GIR_EraseRootFromParent_Done,
     /* 2030949 */   // Label 27092: @2030949
     /* 2030949 */   GIM_Try, /*On fail goto*//*Label 27093*/ GIMT_Encode4(2031054), // Rule ID 16705 //
     /* 2030954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2030971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031004 */     // MIs[1] Operand 1
     /* 2031004 */     // No operand predicates
     /* 2031004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031008 */     // MIs[0] round
     /* 2031008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031011 */     // MIs[0] policy
     /* 2031011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2031026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031053 */     // GIR_Coverage, 16705,
     /* 2031053 */     GIR_EraseRootFromParent_Done,
     /* 2031054 */   // Label 27093: @2031054
     /* 2031054 */   GIM_Try, /*On fail goto*//*Label 27094*/ GIMT_Encode4(2031159), // Rule ID 16708 //
     /* 2031059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2031062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2031067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2031076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2031079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031109 */     // MIs[1] Operand 1
     /* 2031109 */     // No operand predicates
     /* 2031109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031113 */     // MIs[0] round
     /* 2031113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031116 */     // MIs[0] policy
     /* 2031116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031128 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2031131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031158 */     // GIR_Coverage, 16708,
     /* 2031158 */     GIR_EraseRootFromParent_Done,
     /* 2031159 */   // Label 27094: @2031159
     /* 2031159 */   GIM_Try, /*On fail goto*//*Label 27095*/ GIMT_Encode4(2031264), // Rule ID 16709 //
     /* 2031164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2031167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2031172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2031181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2031184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031214 */     // MIs[1] Operand 1
     /* 2031214 */     // No operand predicates
     /* 2031214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031218 */     // MIs[0] round
     /* 2031218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031221 */     // MIs[0] policy
     /* 2031221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031233 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2031236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031263 */     // GIR_Coverage, 16709,
     /* 2031263 */     GIR_EraseRootFromParent_Done,
     /* 2031264 */   // Label 27095: @2031264
     /* 2031264 */   GIM_Try, /*On fail goto*//*Label 27096*/ GIMT_Encode4(2031351), // Rule ID 2780 //
     /* 2031269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2031280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2031283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2031286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031300 */     // MIs[0] passthru
     /* 2031300 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031313 */     // MIs[0] round
     /* 2031313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031316 */     // MIs[0] policy
     /* 2031316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031326 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2031329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031350 */     // GIR_Coverage, 2780,
     /* 2031350 */     GIR_EraseRootFromParent_Done,
     /* 2031351 */   // Label 27096: @2031351
     /* 2031351 */   GIM_Try, /*On fail goto*//*Label 27097*/ GIMT_Encode4(2031438), // Rule ID 2781 //
     /* 2031356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2031367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2031370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2031373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031387 */     // MIs[0] passthru
     /* 2031387 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031400 */     // MIs[0] round
     /* 2031400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031403 */     // MIs[0] policy
     /* 2031403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031413 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2031416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031437 */     // GIR_Coverage, 2781,
     /* 2031437 */     GIR_EraseRootFromParent_Done,
     /* 2031438 */   // Label 27097: @2031438
     /* 2031438 */   GIM_Try, /*On fail goto*//*Label 27098*/ GIMT_Encode4(2031525), // Rule ID 17160 //
     /* 2031443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2031454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2031457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2031460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031474 */     // MIs[0] passthru
     /* 2031474 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031487 */     // MIs[0] round
     /* 2031487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031490 */     // MIs[0] policy
     /* 2031490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031500 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2031503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031524 */     // GIR_Coverage, 17160,
     /* 2031524 */     GIR_EraseRootFromParent_Done,
     /* 2031525 */   // Label 27098: @2031525
     /* 2031525 */   GIM_Try, /*On fail goto*//*Label 27099*/ GIMT_Encode4(2031612), // Rule ID 17161 //
     /* 2031530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2031541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2031544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2031547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031561 */     // MIs[0] passthru
     /* 2031561 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031574 */     // MIs[0] round
     /* 2031574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031577 */     // MIs[0] policy
     /* 2031577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031587 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2031590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031611 */     // GIR_Coverage, 17161,
     /* 2031611 */     GIR_EraseRootFromParent_Done,
     /* 2031612 */   // Label 27099: @2031612
     /* 2031612 */   GIM_Try, /*On fail goto*//*Label 27100*/ GIMT_Encode4(2031699), // Rule ID 17170 //
     /* 2031617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2031628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2031631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2031634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031648 */     // MIs[0] passthru
     /* 2031648 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031661 */     // MIs[0] round
     /* 2031661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031664 */     // MIs[0] policy
     /* 2031664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031674 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2031677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031698 */     // GIR_Coverage, 17170,
     /* 2031698 */     GIR_EraseRootFromParent_Done,
     /* 2031699 */   // Label 27100: @2031699
     /* 2031699 */   GIM_Try, /*On fail goto*//*Label 27101*/ GIMT_Encode4(2031786), // Rule ID 17171 //
     /* 2031704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2031715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2031718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2031721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031735 */     // MIs[0] passthru
     /* 2031735 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031748 */     // MIs[0] round
     /* 2031748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031751 */     // MIs[0] policy
     /* 2031751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031761 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2031764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031785 */     // GIR_Coverage, 17171,
     /* 2031785 */     GIR_EraseRootFromParent_Done,
     /* 2031786 */   // Label 27101: @2031786
     /* 2031786 */   GIM_Try, /*On fail goto*//*Label 27102*/ GIMT_Encode4(2031873), // Rule ID 17180 //
     /* 2031791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2031808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031822 */     // MIs[0] passthru
     /* 2031822 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031835 */     // MIs[0] round
     /* 2031835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031838 */     // MIs[0] policy
     /* 2031838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031848 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2031851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031872 */     // GIR_Coverage, 17180,
     /* 2031872 */     GIR_EraseRootFromParent_Done,
     /* 2031873 */   // Label 27102: @2031873
     /* 2031873 */   GIM_Try, /*On fail goto*//*Label 27103*/ GIMT_Encode4(2031960), // Rule ID 17181 //
     /* 2031878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2031895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031909 */     // MIs[0] passthru
     /* 2031909 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031922 */     // MIs[0] round
     /* 2031922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031925 */     // MIs[0] policy
     /* 2031925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031935 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2031938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031959 */     // GIR_Coverage, 17181,
     /* 2031959 */     GIR_EraseRootFromParent_Done,
     /* 2031960 */   // Label 27103: @2031960
     /* 2031960 */   GIM_Try, /*On fail goto*//*Label 27104*/ GIMT_Encode4(2032047), // Rule ID 17190 //
     /* 2031965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2031976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2031979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2031982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2031985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2031992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031996 */     // MIs[0] passthru
     /* 2031996 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032009 */     // MIs[0] round
     /* 2032009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032012 */     // MIs[0] policy
     /* 2032012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032022 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2032025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032046 */     // GIR_Coverage, 17190,
     /* 2032046 */     GIR_EraseRootFromParent_Done,
     /* 2032047 */   // Label 27104: @2032047
     /* 2032047 */   GIM_Try, /*On fail goto*//*Label 27105*/ GIMT_Encode4(2032134), // Rule ID 17191 //
     /* 2032052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2032055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2032063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2032066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2032069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2032072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2032079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2032083 */     // MIs[0] passthru
     /* 2032083 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032096 */     // MIs[0] round
     /* 2032096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032099 */     // MIs[0] policy
     /* 2032099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032109 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2032112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032133 */     // GIR_Coverage, 17191,
     /* 2032133 */     GIR_EraseRootFromParent_Done,
     /* 2032134 */   // Label 27105: @2032134
     /* 2032134 */   GIM_Try, /*On fail goto*//*Label 27106*/ GIMT_Encode4(2032221), // Rule ID 17200 //
     /* 2032139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2032142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2032150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2032153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2032156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032170 */     // MIs[0] passthru
     /* 2032170 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032183 */     // MIs[0] round
     /* 2032183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032186 */     // MIs[0] policy
     /* 2032186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032196 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2032199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032220 */     // GIR_Coverage, 17200,
     /* 2032220 */     GIR_EraseRootFromParent_Done,
     /* 2032221 */   // Label 27106: @2032221
     /* 2032221 */   GIM_Try, /*On fail goto*//*Label 27107*/ GIMT_Encode4(2032308), // Rule ID 17201 //
     /* 2032226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2032229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2032237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2032240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2032243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032257 */     // MIs[0] passthru
     /* 2032257 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032270 */     // MIs[0] round
     /* 2032270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032273 */     // MIs[0] policy
     /* 2032273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032283 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2032286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032307 */     // GIR_Coverage, 17201,
     /* 2032307 */     GIR_EraseRootFromParent_Done,
     /* 2032308 */   // Label 27107: @2032308
     /* 2032308 */   GIM_Try, /*On fail goto*//*Label 27108*/ GIMT_Encode4(2032395), // Rule ID 17210 //
     /* 2032313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2032316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2032324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2032327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2032330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032344 */     // MIs[0] passthru
     /* 2032344 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032357 */     // MIs[0] round
     /* 2032357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032360 */     // MIs[0] policy
     /* 2032360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032370 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2032373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032394 */     // GIR_Coverage, 17210,
     /* 2032394 */     GIR_EraseRootFromParent_Done,
     /* 2032395 */   // Label 27108: @2032395
     /* 2032395 */   GIM_Try, /*On fail goto*//*Label 27109*/ GIMT_Encode4(2032482), // Rule ID 17211 //
     /* 2032400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2032403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2032411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2032414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2032417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032431 */     // MIs[0] passthru
     /* 2032431 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032444 */     // MIs[0] round
     /* 2032444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032447 */     // MIs[0] policy
     /* 2032447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032457 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2032460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032481 */     // GIR_Coverage, 17211,
     /* 2032481 */     GIR_EraseRootFromParent_Done,
     /* 2032482 */   // Label 27109: @2032482
     /* 2032482 */   GIM_Try, /*On fail goto*//*Label 27110*/ GIMT_Encode4(2032569), // Rule ID 17220 //
     /* 2032487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2032490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2032498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2032501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2032504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032518 */     // MIs[0] passthru
     /* 2032518 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032531 */     // MIs[0] round
     /* 2032531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032534 */     // MIs[0] policy
     /* 2032534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032544 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2032547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032568 */     // GIR_Coverage, 17220,
     /* 2032568 */     GIR_EraseRootFromParent_Done,
     /* 2032569 */   // Label 27110: @2032569
     /* 2032569 */   GIM_Try, /*On fail goto*//*Label 27111*/ GIMT_Encode4(2032656), // Rule ID 17221 //
     /* 2032574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2032577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2032585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2032588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2032591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032605 */     // MIs[0] passthru
     /* 2032605 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032618 */     // MIs[0] round
     /* 2032618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032621 */     // MIs[0] policy
     /* 2032621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032631 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2032634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032655 */     // GIR_Coverage, 17221,
     /* 2032655 */     GIR_EraseRootFromParent_Done,
     /* 2032656 */   // Label 27111: @2032656
     /* 2032656 */   GIM_Try, /*On fail goto*//*Label 27112*/ GIMT_Encode4(2032743), // Rule ID 17230 //
     /* 2032661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2032664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2032672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2032675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2032678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2032688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2032692 */     // MIs[0] passthru
     /* 2032692 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032705 */     // MIs[0] round
     /* 2032705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032708 */     // MIs[0] policy
     /* 2032708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032718 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2032721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032742 */     // GIR_Coverage, 17230,
     /* 2032742 */     GIR_EraseRootFromParent_Done,
     /* 2032743 */   // Label 27112: @2032743
     /* 2032743 */   GIM_Try, /*On fail goto*//*Label 27113*/ GIMT_Encode4(2032830), // Rule ID 17231 //
     /* 2032748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2032751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2032759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2032762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2032765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2032775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2032779 */     // MIs[0] passthru
     /* 2032779 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032792 */     // MIs[0] round
     /* 2032792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032795 */     // MIs[0] policy
     /* 2032795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032805 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2032808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032829 */     // GIR_Coverage, 17231,
     /* 2032829 */     GIR_EraseRootFromParent_Done,
     /* 2032830 */   // Label 27113: @2032830
     /* 2032830 */   GIM_Try, /*On fail goto*//*Label 27114*/ GIMT_Encode4(2032917), // Rule ID 17276 //
     /* 2032835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2032838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2032846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2032849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2032852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032866 */     // MIs[0] passthru
     /* 2032866 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032879 */     // MIs[0] round
     /* 2032879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032882 */     // MIs[0] policy
     /* 2032882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032892 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2032895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032916 */     // GIR_Coverage, 17276,
     /* 2032916 */     GIR_EraseRootFromParent_Done,
     /* 2032917 */   // Label 27114: @2032917
     /* 2032917 */   GIM_Try, /*On fail goto*//*Label 27115*/ GIMT_Encode4(2033004), // Rule ID 17277 //
     /* 2032922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2032925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2032933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2032936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2032939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032953 */     // MIs[0] passthru
     /* 2032953 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032966 */     // MIs[0] round
     /* 2032966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032969 */     // MIs[0] policy
     /* 2032969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032979 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2032982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033003 */     // GIR_Coverage, 17277,
     /* 2033003 */     GIR_EraseRootFromParent_Done,
     /* 2033004 */   // Label 27115: @2033004
     /* 2033004 */   GIM_Try, /*On fail goto*//*Label 27116*/ GIMT_Encode4(2033091), // Rule ID 17286 //
     /* 2033009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2033012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2033020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2033023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2033026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033040 */     // MIs[0] passthru
     /* 2033040 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033053 */     // MIs[0] round
     /* 2033053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033056 */     // MIs[0] policy
     /* 2033056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033066 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2033069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033090 */     // GIR_Coverage, 17286,
     /* 2033090 */     GIR_EraseRootFromParent_Done,
     /* 2033091 */   // Label 27116: @2033091
     /* 2033091 */   GIM_Try, /*On fail goto*//*Label 27117*/ GIMT_Encode4(2033178), // Rule ID 17287 //
     /* 2033096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2033099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2033107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2033110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2033113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033127 */     // MIs[0] passthru
     /* 2033127 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033140 */     // MIs[0] round
     /* 2033140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033143 */     // MIs[0] policy
     /* 2033143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033153 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2033156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033177 */     // GIR_Coverage, 17287,
     /* 2033177 */     GIR_EraseRootFromParent_Done,
     /* 2033178 */   // Label 27117: @2033178
     /* 2033178 */   GIM_Try, /*On fail goto*//*Label 27118*/ GIMT_Encode4(2033265), // Rule ID 17296 //
     /* 2033183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2033186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2033194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2033197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2033200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033214 */     // MIs[0] passthru
     /* 2033214 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033227 */     // MIs[0] round
     /* 2033227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033230 */     // MIs[0] policy
     /* 2033230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033240 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2033243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033264 */     // GIR_Coverage, 17296,
     /* 2033264 */     GIR_EraseRootFromParent_Done,
     /* 2033265 */   // Label 27118: @2033265
     /* 2033265 */   GIM_Try, /*On fail goto*//*Label 27119*/ GIMT_Encode4(2033352), // Rule ID 17297 //
     /* 2033270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2033273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2033281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2033284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2033287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033301 */     // MIs[0] passthru
     /* 2033301 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033314 */     // MIs[0] round
     /* 2033314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033317 */     // MIs[0] policy
     /* 2033317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033327 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2033330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033351 */     // GIR_Coverage, 17297,
     /* 2033351 */     GIR_EraseRootFromParent_Done,
     /* 2033352 */   // Label 27119: @2033352
     /* 2033352 */   GIM_Try, /*On fail goto*//*Label 27120*/ GIMT_Encode4(2033439), // Rule ID 17306 //
     /* 2033357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2033360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2033368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2033371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2033374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033388 */     // MIs[0] passthru
     /* 2033388 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033401 */     // MIs[0] round
     /* 2033401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033404 */     // MIs[0] policy
     /* 2033404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033414 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2033417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033438 */     // GIR_Coverage, 17306,
     /* 2033438 */     GIR_EraseRootFromParent_Done,
     /* 2033439 */   // Label 27120: @2033439
     /* 2033439 */   GIM_Try, /*On fail goto*//*Label 27121*/ GIMT_Encode4(2033526), // Rule ID 17307 //
     /* 2033444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2033447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2033455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2033458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2033461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033475 */     // MIs[0] passthru
     /* 2033475 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033488 */     // MIs[0] round
     /* 2033488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033491 */     // MIs[0] policy
     /* 2033491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033501 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2033504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033525 */     // GIR_Coverage, 17307,
     /* 2033525 */     GIR_EraseRootFromParent_Done,
     /* 2033526 */   // Label 27121: @2033526
     /* 2033526 */   GIM_Try, /*On fail goto*//*Label 27122*/ GIMT_Encode4(2033613), // Rule ID 17316 //
     /* 2033531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2033534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2033542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2033545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2033548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033562 */     // MIs[0] passthru
     /* 2033562 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033575 */     // MIs[0] round
     /* 2033575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033578 */     // MIs[0] policy
     /* 2033578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033588 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2033591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033612 */     // GIR_Coverage, 17316,
     /* 2033612 */     GIR_EraseRootFromParent_Done,
     /* 2033613 */   // Label 27122: @2033613
     /* 2033613 */   GIM_Try, /*On fail goto*//*Label 27123*/ GIMT_Encode4(2033700), // Rule ID 17317 //
     /* 2033618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2033621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2033629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2033632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2033635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033649 */     // MIs[0] passthru
     /* 2033649 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033662 */     // MIs[0] round
     /* 2033662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033665 */     // MIs[0] policy
     /* 2033665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033675 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2033678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033699 */     // GIR_Coverage, 17317,
     /* 2033699 */     GIR_EraseRootFromParent_Done,
     /* 2033700 */   // Label 27123: @2033700
     /* 2033700 */   GIM_Try, /*On fail goto*//*Label 27124*/ GIMT_Encode4(2033787), // Rule ID 17326 //
     /* 2033705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2033708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2033716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2033719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2033722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033736 */     // MIs[0] passthru
     /* 2033736 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033749 */     // MIs[0] round
     /* 2033749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033752 */     // MIs[0] policy
     /* 2033752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033762 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2033765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033786 */     // GIR_Coverage, 17326,
     /* 2033786 */     GIR_EraseRootFromParent_Done,
     /* 2033787 */   // Label 27124: @2033787
     /* 2033787 */   GIM_Try, /*On fail goto*//*Label 27125*/ GIMT_Encode4(2033874), // Rule ID 17327 //
     /* 2033792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2033795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2033803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2033806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2033809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033823 */     // MIs[0] passthru
     /* 2033823 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033836 */     // MIs[0] round
     /* 2033836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033839 */     // MIs[0] policy
     /* 2033839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033849 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2033852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033873 */     // GIR_Coverage, 17327,
     /* 2033873 */     GIR_EraseRootFromParent_Done,
     /* 2033874 */   // Label 27125: @2033874
     /* 2033874 */   GIM_Try, /*On fail goto*//*Label 27126*/ GIMT_Encode4(2033961), // Rule ID 17336 //
     /* 2033879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2033882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2033890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2033893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2033896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033910 */     // MIs[0] passthru
     /* 2033910 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033923 */     // MIs[0] round
     /* 2033923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033926 */     // MIs[0] policy
     /* 2033926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033936 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2033939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033960 */     // GIR_Coverage, 17336,
     /* 2033960 */     GIR_EraseRootFromParent_Done,
     /* 2033961 */   // Label 27126: @2033961
     /* 2033961 */   GIM_Try, /*On fail goto*//*Label 27127*/ GIMT_Encode4(2034048), // Rule ID 17337 //
     /* 2033966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2033969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2033977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2033980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2033983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033997 */     // MIs[0] passthru
     /* 2033997 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034010 */     // MIs[0] round
     /* 2034010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034013 */     // MIs[0] policy
     /* 2034013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034023 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2034026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034047 */     // GIR_Coverage, 17337,
     /* 2034047 */     GIR_EraseRootFromParent_Done,
     /* 2034048 */   // Label 27127: @2034048
     /* 2034048 */   GIM_Try, /*On fail goto*//*Label 27128*/ GIMT_Encode4(2034135), // Rule ID 17346 //
     /* 2034053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2034056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2034061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2034064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2034067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2034070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034084 */     // MIs[0] passthru
     /* 2034084 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034097 */     // MIs[0] round
     /* 2034097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034100 */     // MIs[0] policy
     /* 2034100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034110 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2034113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034134 */     // GIR_Coverage, 17346,
     /* 2034134 */     GIR_EraseRootFromParent_Done,
     /* 2034135 */   // Label 27128: @2034135
     /* 2034135 */   GIM_Try, /*On fail goto*//*Label 27129*/ GIMT_Encode4(2034222), // Rule ID 17347 //
     /* 2034140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2034143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2034148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2034151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2034154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2034157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034171 */     // MIs[0] passthru
     /* 2034171 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034184 */     // MIs[0] round
     /* 2034184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034187 */     // MIs[0] policy
     /* 2034187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034197 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2034200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034221 */     // GIR_Coverage, 17347,
     /* 2034221 */     GIR_EraseRootFromParent_Done,
     /* 2034222 */   // Label 27129: @2034222
     /* 2034222 */   GIM_Try, /*On fail goto*//*Label 27130*/ GIMT_Encode4(2034309), // Rule ID 17356 //
     /* 2034227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2034230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2034235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2034238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2034241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2034244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034258 */     // MIs[0] passthru
     /* 2034258 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034271 */     // MIs[0] round
     /* 2034271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034274 */     // MIs[0] policy
     /* 2034274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034284 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2034287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034308 */     // GIR_Coverage, 17356,
     /* 2034308 */     GIR_EraseRootFromParent_Done,
     /* 2034309 */   // Label 27130: @2034309
     /* 2034309 */   GIM_Try, /*On fail goto*//*Label 27131*/ GIMT_Encode4(2034396), // Rule ID 17357 //
     /* 2034314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2034317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2034322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2034325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2034328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2034331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034345 */     // MIs[0] passthru
     /* 2034345 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034358 */     // MIs[0] round
     /* 2034358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034361 */     // MIs[0] policy
     /* 2034361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034371 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2034374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034395 */     // GIR_Coverage, 17357,
     /* 2034395 */     GIR_EraseRootFromParent_Done,
     /* 2034396 */   // Label 27131: @2034396
     /* 2034396 */   GIM_Try, /*On fail goto*//*Label 27132*/ GIMT_Encode4(2034487), // Rule ID 2738 //
     /* 2034401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2034412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2034415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2034418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2034421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034447 */     // MIs[0] round
     /* 2034447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034450 */     // MIs[0] policy
     /* 2034450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034460 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2034463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034486 */     // GIR_Coverage, 2738,
     /* 2034486 */     GIR_EraseRootFromParent_Done,
     /* 2034487 */   // Label 27132: @2034487
     /* 2034487 */   GIM_Try, /*On fail goto*//*Label 27133*/ GIMT_Encode4(2034578), // Rule ID 2739 //
     /* 2034492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2034503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2034506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2034509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2034512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034538 */     // MIs[0] round
     /* 2034538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034541 */     // MIs[0] policy
     /* 2034541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034551 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2034554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034577 */     // GIR_Coverage, 2739,
     /* 2034577 */     GIR_EraseRootFromParent_Done,
     /* 2034578 */   // Label 27133: @2034578
     /* 2034578 */   GIM_Try, /*On fail goto*//*Label 27134*/ GIMT_Encode4(2034669), // Rule ID 2782 //
     /* 2034583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2034586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2034594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2034597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2034600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034629 */     // MIs[0] round
     /* 2034629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034632 */     // MIs[0] policy
     /* 2034632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034642 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2034645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034668 */     // GIR_Coverage, 2782,
     /* 2034668 */     GIR_EraseRootFromParent_Done,
     /* 2034669 */   // Label 27134: @2034669
     /* 2034669 */   GIM_Try, /*On fail goto*//*Label 27135*/ GIMT_Encode4(2034760), // Rule ID 2783 //
     /* 2034674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2034677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2034685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2034688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2034691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034720 */     // MIs[0] round
     /* 2034720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034723 */     // MIs[0] policy
     /* 2034723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034733 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2034736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034759 */     // GIR_Coverage, 2783,
     /* 2034759 */     GIR_EraseRootFromParent_Done,
     /* 2034760 */   // Label 27135: @2034760
     /* 2034760 */   GIM_Try, /*On fail goto*//*Label 27136*/ GIMT_Encode4(2034851), // Rule ID 2790 //
     /* 2034765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2034768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2034773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034811 */     // MIs[0] round
     /* 2034811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034814 */     // MIs[0] policy
     /* 2034814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034824 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2034827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2034831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034850 */     // GIR_Coverage, 2790,
     /* 2034850 */     GIR_EraseRootFromParent_Done,
     /* 2034851 */   // Label 27136: @2034851
     /* 2034851 */   GIM_Try, /*On fail goto*//*Label 27137*/ GIMT_Encode4(2034942), // Rule ID 2791 //
     /* 2034856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2034859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2034864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034902 */     // MIs[0] round
     /* 2034902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034905 */     // MIs[0] policy
     /* 2034905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034915 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2034918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2034922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034941 */     // GIR_Coverage, 2791,
     /* 2034941 */     GIR_EraseRootFromParent_Done,
     /* 2034942 */   // Label 27137: @2034942
     /* 2034942 */   GIM_Try, /*On fail goto*//*Label 27138*/ GIMT_Encode4(2035033), // Rule ID 14948 //
     /* 2034947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2034958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2034961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2034964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2034967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034993 */     // MIs[0] round
     /* 2034993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034996 */     // MIs[0] policy
     /* 2034996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035006 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2035009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035032 */     // GIR_Coverage, 14948,
     /* 2035032 */     GIR_EraseRootFromParent_Done,
     /* 2035033 */   // Label 27138: @2035033
     /* 2035033 */   GIM_Try, /*On fail goto*//*Label 27139*/ GIMT_Encode4(2035124), // Rule ID 14949 //
     /* 2035038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2035049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2035052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2035055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2035058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035084 */     // MIs[0] round
     /* 2035084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035087 */     // MIs[0] policy
     /* 2035087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035097 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2035100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035123 */     // GIR_Coverage, 14949,
     /* 2035123 */     GIR_EraseRootFromParent_Done,
     /* 2035124 */   // Label 27139: @2035124
     /* 2035124 */   GIM_Try, /*On fail goto*//*Label 27140*/ GIMT_Encode4(2035215), // Rule ID 14952 //
     /* 2035129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2035140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2035143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2035146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2035149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035175 */     // MIs[0] round
     /* 2035175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035178 */     // MIs[0] policy
     /* 2035178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035188 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035214 */     // GIR_Coverage, 14952,
     /* 2035214 */     GIR_EraseRootFromParent_Done,
     /* 2035215 */   // Label 27140: @2035215
     /* 2035215 */   GIM_Try, /*On fail goto*//*Label 27141*/ GIMT_Encode4(2035306), // Rule ID 14953 //
     /* 2035220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2035231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2035234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2035237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2035240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035266 */     // MIs[0] round
     /* 2035266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035269 */     // MIs[0] policy
     /* 2035269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035279 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035305 */     // GIR_Coverage, 14953,
     /* 2035305 */     GIR_EraseRootFromParent_Done,
     /* 2035306 */   // Label 27141: @2035306
     /* 2035306 */   GIM_Try, /*On fail goto*//*Label 27142*/ GIMT_Encode4(2035397), // Rule ID 14956 //
     /* 2035311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2035322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2035325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2035328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2035331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035357 */     // MIs[0] round
     /* 2035357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035360 */     // MIs[0] policy
     /* 2035360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035370 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2035373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035396 */     // GIR_Coverage, 14956,
     /* 2035396 */     GIR_EraseRootFromParent_Done,
     /* 2035397 */   // Label 27142: @2035397
     /* 2035397 */   GIM_Try, /*On fail goto*//*Label 27143*/ GIMT_Encode4(2035488), // Rule ID 14957 //
     /* 2035402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2035413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2035416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2035419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2035422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035448 */     // MIs[0] round
     /* 2035448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035451 */     // MIs[0] policy
     /* 2035451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035461 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2035464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035487 */     // GIR_Coverage, 14957,
     /* 2035487 */     GIR_EraseRootFromParent_Done,
     /* 2035488 */   // Label 27143: @2035488
     /* 2035488 */   GIM_Try, /*On fail goto*//*Label 27144*/ GIMT_Encode4(2035579), // Rule ID 14960 //
     /* 2035493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2035504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2035507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2035510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2035513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035539 */     // MIs[0] round
     /* 2035539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035542 */     // MIs[0] policy
     /* 2035542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035578 */     // GIR_Coverage, 14960,
     /* 2035578 */     GIR_EraseRootFromParent_Done,
     /* 2035579 */   // Label 27144: @2035579
     /* 2035579 */   GIM_Try, /*On fail goto*//*Label 27145*/ GIMT_Encode4(2035670), // Rule ID 14961 //
     /* 2035584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2035595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2035598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2035601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2035604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035630 */     // MIs[0] round
     /* 2035630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035633 */     // MIs[0] policy
     /* 2035633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035643 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035669 */     // GIR_Coverage, 14961,
     /* 2035669 */     GIR_EraseRootFromParent_Done,
     /* 2035670 */   // Label 27145: @2035670
     /* 2035670 */   GIM_Try, /*On fail goto*//*Label 27146*/ GIMT_Encode4(2035761), // Rule ID 14964 //
     /* 2035675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2035686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2035689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2035692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2035695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035721 */     // MIs[0] round
     /* 2035721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035724 */     // MIs[0] policy
     /* 2035724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035760 */     // GIR_Coverage, 14964,
     /* 2035760 */     GIR_EraseRootFromParent_Done,
     /* 2035761 */   // Label 27146: @2035761
     /* 2035761 */   GIM_Try, /*On fail goto*//*Label 27147*/ GIMT_Encode4(2035852), // Rule ID 14965 //
     /* 2035766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2035777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2035780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2035783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2035786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035812 */     // MIs[0] round
     /* 2035812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035815 */     // MIs[0] policy
     /* 2035815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035825 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035851 */     // GIR_Coverage, 14965,
     /* 2035851 */     GIR_EraseRootFromParent_Done,
     /* 2035852 */   // Label 27147: @2035852
     /* 2035852 */   GIM_Try, /*On fail goto*//*Label 27148*/ GIMT_Encode4(2035943), // Rule ID 14968 //
     /* 2035857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2035868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2035871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2035874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2035877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035903 */     // MIs[0] round
     /* 2035903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035906 */     // MIs[0] policy
     /* 2035906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035916 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035942 */     // GIR_Coverage, 14968,
     /* 2035942 */     GIR_EraseRootFromParent_Done,
     /* 2035943 */   // Label 27148: @2035943
     /* 2035943 */   GIM_Try, /*On fail goto*//*Label 27149*/ GIMT_Encode4(2036034), // Rule ID 14969 //
     /* 2035948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2035959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2035962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2035965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2035968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035994 */     // MIs[0] round
     /* 2035994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035997 */     // MIs[0] policy
     /* 2035997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036007 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036033 */     // GIR_Coverage, 14969,
     /* 2036033 */     GIR_EraseRootFromParent_Done,
     /* 2036034 */   // Label 27149: @2036034
     /* 2036034 */   GIM_Try, /*On fail goto*//*Label 27150*/ GIMT_Encode4(2036125), // Rule ID 14972 //
     /* 2036039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2036050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2036053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2036056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2036059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036085 */     // MIs[0] round
     /* 2036085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036088 */     // MIs[0] policy
     /* 2036088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036098 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036124 */     // GIR_Coverage, 14972,
     /* 2036124 */     GIR_EraseRootFromParent_Done,
     /* 2036125 */   // Label 27150: @2036125
     /* 2036125 */   GIM_Try, /*On fail goto*//*Label 27151*/ GIMT_Encode4(2036216), // Rule ID 14973 //
     /* 2036130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2036141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2036144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2036147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2036150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036176 */     // MIs[0] round
     /* 2036176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036179 */     // MIs[0] policy
     /* 2036179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036189 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036215 */     // GIR_Coverage, 14973,
     /* 2036215 */     GIR_EraseRootFromParent_Done,
     /* 2036216 */   // Label 27151: @2036216
     /* 2036216 */   GIM_Try, /*On fail goto*//*Label 27152*/ GIMT_Encode4(2036307), // Rule ID 14976 //
     /* 2036221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2036232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2036235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2036238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2036241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036267 */     // MIs[0] round
     /* 2036267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036270 */     // MIs[0] policy
     /* 2036270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036280 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036306 */     // GIR_Coverage, 14976,
     /* 2036306 */     GIR_EraseRootFromParent_Done,
     /* 2036307 */   // Label 27152: @2036307
     /* 2036307 */   GIM_Try, /*On fail goto*//*Label 27153*/ GIMT_Encode4(2036398), // Rule ID 14977 //
     /* 2036312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2036323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2036326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2036329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2036332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036358 */     // MIs[0] round
     /* 2036358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036361 */     // MIs[0] policy
     /* 2036361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036371 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036397 */     // GIR_Coverage, 14977,
     /* 2036397 */     GIR_EraseRootFromParent_Done,
     /* 2036398 */   // Label 27153: @2036398
     /* 2036398 */   GIM_Try, /*On fail goto*//*Label 27154*/ GIMT_Encode4(2036489), // Rule ID 14980 //
     /* 2036403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2036406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2036414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2036417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2036420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2036423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036449 */     // MIs[0] round
     /* 2036449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036452 */     // MIs[0] policy
     /* 2036452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036462 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036488 */     // GIR_Coverage, 14980,
     /* 2036488 */     GIR_EraseRootFromParent_Done,
     /* 2036489 */   // Label 27154: @2036489
     /* 2036489 */   GIM_Try, /*On fail goto*//*Label 27155*/ GIMT_Encode4(2036580), // Rule ID 14981 //
     /* 2036494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2036497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2036505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2036508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2036511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2036514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036540 */     // MIs[0] round
     /* 2036540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036543 */     // MIs[0] policy
     /* 2036543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036553 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036579 */     // GIR_Coverage, 14981,
     /* 2036579 */     GIR_EraseRootFromParent_Done,
     /* 2036580 */   // Label 27155: @2036580
     /* 2036580 */   GIM_Try, /*On fail goto*//*Label 27156*/ GIMT_Encode4(2036671), // Rule ID 14984 //
     /* 2036585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2036596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2036599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2036602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2036605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036631 */     // MIs[0] round
     /* 2036631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036634 */     // MIs[0] policy
     /* 2036634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2036647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036670 */     // GIR_Coverage, 14984,
     /* 2036670 */     GIR_EraseRootFromParent_Done,
     /* 2036671 */   // Label 27156: @2036671
     /* 2036671 */   GIM_Try, /*On fail goto*//*Label 27157*/ GIMT_Encode4(2036762), // Rule ID 14985 //
     /* 2036676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2036687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2036690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2036693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2036696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036722 */     // MIs[0] round
     /* 2036722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036725 */     // MIs[0] policy
     /* 2036725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036735 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2036738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036761 */     // GIR_Coverage, 14985,
     /* 2036761 */     GIR_EraseRootFromParent_Done,
     /* 2036762 */   // Label 27157: @2036762
     /* 2036762 */   GIM_Try, /*On fail goto*//*Label 27158*/ GIMT_Encode4(2036853), // Rule ID 14988 //
     /* 2036767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2036778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2036781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2036784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2036787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2036790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036813 */     // MIs[0] round
     /* 2036813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036816 */     // MIs[0] policy
     /* 2036816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036826 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2036829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036852 */     // GIR_Coverage, 14988,
     /* 2036852 */     GIR_EraseRootFromParent_Done,
     /* 2036853 */   // Label 27158: @2036853
     /* 2036853 */   GIM_Try, /*On fail goto*//*Label 27159*/ GIMT_Encode4(2036944), // Rule ID 14989 //
     /* 2036858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2036869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2036872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2036875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2036878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2036881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036904 */     // MIs[0] round
     /* 2036904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036907 */     // MIs[0] policy
     /* 2036907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036917 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2036920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036943 */     // GIR_Coverage, 14989,
     /* 2036943 */     GIR_EraseRootFromParent_Done,
     /* 2036944 */   // Label 27159: @2036944
     /* 2036944 */   GIM_Try, /*On fail goto*//*Label 27160*/ GIMT_Encode4(2037035), // Rule ID 14992 //
     /* 2036949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2036960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2036963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2036966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2036969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2036972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036995 */     // MIs[0] round
     /* 2036995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036998 */     // MIs[0] policy
     /* 2036998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037008 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037034 */     // GIR_Coverage, 14992,
     /* 2037034 */     GIR_EraseRootFromParent_Done,
     /* 2037035 */   // Label 27160: @2037035
     /* 2037035 */   GIM_Try, /*On fail goto*//*Label 27161*/ GIMT_Encode4(2037126), // Rule ID 14993 //
     /* 2037040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2037051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2037054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2037057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2037060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2037063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037086 */     // MIs[0] round
     /* 2037086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037089 */     // MIs[0] policy
     /* 2037089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037099 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037125 */     // GIR_Coverage, 14993,
     /* 2037125 */     GIR_EraseRootFromParent_Done,
     /* 2037126 */   // Label 27161: @2037126
     /* 2037126 */   GIM_Try, /*On fail goto*//*Label 27162*/ GIMT_Encode4(2037217), // Rule ID 14996 //
     /* 2037131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2037142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2037145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2037148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2037151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037177 */     // MIs[0] round
     /* 2037177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037180 */     // MIs[0] policy
     /* 2037180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037216 */     // GIR_Coverage, 14996,
     /* 2037216 */     GIR_EraseRootFromParent_Done,
     /* 2037217 */   // Label 27162: @2037217
     /* 2037217 */   GIM_Try, /*On fail goto*//*Label 27163*/ GIMT_Encode4(2037308), // Rule ID 14997 //
     /* 2037222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2037233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2037236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2037239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2037242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037268 */     // MIs[0] round
     /* 2037268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037271 */     // MIs[0] policy
     /* 2037271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037281 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037307 */     // GIR_Coverage, 14997,
     /* 2037307 */     GIR_EraseRootFromParent_Done,
     /* 2037308 */   // Label 27163: @2037308
     /* 2037308 */   GIM_Try, /*On fail goto*//*Label 27164*/ GIMT_Encode4(2037399), // Rule ID 15000 //
     /* 2037313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2037324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2037327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2037330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2037333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037359 */     // MIs[0] round
     /* 2037359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037362 */     // MIs[0] policy
     /* 2037362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037372 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2037375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037398 */     // GIR_Coverage, 15000,
     /* 2037398 */     GIR_EraseRootFromParent_Done,
     /* 2037399 */   // Label 27164: @2037399
     /* 2037399 */   GIM_Try, /*On fail goto*//*Label 27165*/ GIMT_Encode4(2037490), // Rule ID 15001 //
     /* 2037404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2037415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2037418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2037421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2037424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037450 */     // MIs[0] round
     /* 2037450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037453 */     // MIs[0] policy
     /* 2037453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037463 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2037466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037489 */     // GIR_Coverage, 15001,
     /* 2037489 */     GIR_EraseRootFromParent_Done,
     /* 2037490 */   // Label 27165: @2037490
     /* 2037490 */   GIM_Try, /*On fail goto*//*Label 27166*/ GIMT_Encode4(2037581), // Rule ID 15004 //
     /* 2037495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2037506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2037509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2037512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2037515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037541 */     // MIs[0] round
     /* 2037541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037544 */     // MIs[0] policy
     /* 2037544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037554 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037580 */     // GIR_Coverage, 15004,
     /* 2037580 */     GIR_EraseRootFromParent_Done,
     /* 2037581 */   // Label 27166: @2037581
     /* 2037581 */   GIM_Try, /*On fail goto*//*Label 27167*/ GIMT_Encode4(2037672), // Rule ID 15005 //
     /* 2037586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2037597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2037600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2037603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2037606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037632 */     // MIs[0] round
     /* 2037632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037635 */     // MIs[0] policy
     /* 2037635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037645 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037671 */     // GIR_Coverage, 15005,
     /* 2037671 */     GIR_EraseRootFromParent_Done,
     /* 2037672 */   // Label 27167: @2037672
     /* 2037672 */   GIM_Try, /*On fail goto*//*Label 27168*/ GIMT_Encode4(2037763), // Rule ID 15008 //
     /* 2037677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2037688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2037691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2037694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2037697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037723 */     // MIs[0] round
     /* 2037723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037726 */     // MIs[0] policy
     /* 2037726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037762 */     // GIR_Coverage, 15008,
     /* 2037762 */     GIR_EraseRootFromParent_Done,
     /* 2037763 */   // Label 27168: @2037763
     /* 2037763 */   GIM_Try, /*On fail goto*//*Label 27169*/ GIMT_Encode4(2037854), // Rule ID 15009 //
     /* 2037768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2037779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2037782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2037785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2037788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037814 */     // MIs[0] round
     /* 2037814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037817 */     // MIs[0] policy
     /* 2037817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037853 */     // GIR_Coverage, 15009,
     /* 2037853 */     GIR_EraseRootFromParent_Done,
     /* 2037854 */   // Label 27169: @2037854
     /* 2037854 */   GIM_Try, /*On fail goto*//*Label 27170*/ GIMT_Encode4(2037945), // Rule ID 15012 //
     /* 2037859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2037870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2037873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2037876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2037879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037905 */     // MIs[0] round
     /* 2037905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037908 */     // MIs[0] policy
     /* 2037908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037918 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2037921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037944 */     // GIR_Coverage, 15012,
     /* 2037944 */     GIR_EraseRootFromParent_Done,
     /* 2037945 */   // Label 27170: @2037945
     /* 2037945 */   GIM_Try, /*On fail goto*//*Label 27171*/ GIMT_Encode4(2038036), // Rule ID 15013 //
     /* 2037950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2037961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2037964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2037967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2037970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037996 */     // MIs[0] round
     /* 2037996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037999 */     // MIs[0] policy
     /* 2037999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038009 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2038012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038035 */     // GIR_Coverage, 15013,
     /* 2038035 */     GIR_EraseRootFromParent_Done,
     /* 2038036 */   // Label 27171: @2038036
     /* 2038036 */   GIM_Try, /*On fail goto*//*Label 27172*/ GIMT_Encode4(2038127), // Rule ID 15016 //
     /* 2038041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2038052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2038055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2038058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2038061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2038064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038087 */     // MIs[0] round
     /* 2038087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038090 */     // MIs[0] policy
     /* 2038090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2038103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038126 */     // GIR_Coverage, 15016,
     /* 2038126 */     GIR_EraseRootFromParent_Done,
     /* 2038127 */   // Label 27172: @2038127
     /* 2038127 */   GIM_Try, /*On fail goto*//*Label 27173*/ GIMT_Encode4(2038218), // Rule ID 15017 //
     /* 2038132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2038143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2038146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2038149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2038152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2038155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038178 */     // MIs[0] round
     /* 2038178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038181 */     // MIs[0] policy
     /* 2038181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038191 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2038194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038217 */     // GIR_Coverage, 15017,
     /* 2038217 */     GIR_EraseRootFromParent_Done,
     /* 2038218 */   // Label 27173: @2038218
     /* 2038218 */   GIM_Try, /*On fail goto*//*Label 27174*/ GIMT_Encode4(2038309), // Rule ID 15020 //
     /* 2038223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2038226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2038234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2038237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2038240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2038243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038269 */     // MIs[0] round
     /* 2038269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038272 */     // MIs[0] policy
     /* 2038272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2038285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038308 */     // GIR_Coverage, 15020,
     /* 2038308 */     GIR_EraseRootFromParent_Done,
     /* 2038309 */   // Label 27174: @2038309
     /* 2038309 */   GIM_Try, /*On fail goto*//*Label 27175*/ GIMT_Encode4(2038400), // Rule ID 15021 //
     /* 2038314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2038325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2038328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2038331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2038334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038360 */     // MIs[0] round
     /* 2038360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038363 */     // MIs[0] policy
     /* 2038363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038373 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2038376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038399 */     // GIR_Coverage, 15021,
     /* 2038399 */     GIR_EraseRootFromParent_Done,
     /* 2038400 */   // Label 27175: @2038400
     /* 2038400 */   GIM_Try, /*On fail goto*//*Label 27176*/ GIMT_Encode4(2038491), // Rule ID 15024 //
     /* 2038405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2038408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2038416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2038419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2038422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2038425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038451 */     // MIs[0] round
     /* 2038451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038454 */     // MIs[0] policy
     /* 2038454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038464 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2038467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038490 */     // GIR_Coverage, 15024,
     /* 2038490 */     GIR_EraseRootFromParent_Done,
     /* 2038491 */   // Label 27176: @2038491
     /* 2038491 */   GIM_Try, /*On fail goto*//*Label 27177*/ GIMT_Encode4(2038582), // Rule ID 15025 //
     /* 2038496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2038507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2038510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2038513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2038516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038542 */     // MIs[0] round
     /* 2038542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038545 */     // MIs[0] policy
     /* 2038545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038555 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2038558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038581 */     // GIR_Coverage, 15025,
     /* 2038581 */     GIR_EraseRootFromParent_Done,
     /* 2038582 */   // Label 27177: @2038582
     /* 2038582 */   GIM_Try, /*On fail goto*//*Label 27178*/ GIMT_Encode4(2038673), // Rule ID 15028 //
     /* 2038587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2038590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2038598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2038601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2038604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2038607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038633 */     // MIs[0] round
     /* 2038633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038636 */     // MIs[0] policy
     /* 2038636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2038649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038672 */     // GIR_Coverage, 15028,
     /* 2038672 */     GIR_EraseRootFromParent_Done,
     /* 2038673 */   // Label 27178: @2038673
     /* 2038673 */   GIM_Try, /*On fail goto*//*Label 27179*/ GIMT_Encode4(2038764), // Rule ID 15029 //
     /* 2038678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2038689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2038692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2038695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2038698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038724 */     // MIs[0] round
     /* 2038724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038727 */     // MIs[0] policy
     /* 2038727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038737 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2038740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038763 */     // GIR_Coverage, 15029,
     /* 2038763 */     GIR_EraseRootFromParent_Done,
     /* 2038764 */   // Label 27179: @2038764
     /* 2038764 */   GIM_Try, /*On fail goto*//*Label 27180*/ GIMT_Encode4(2038855), // Rule ID 15032 //
     /* 2038769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2038780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2038783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2038786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038815 */     // MIs[0] round
     /* 2038815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038818 */     // MIs[0] policy
     /* 2038818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038828 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2038831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038854 */     // GIR_Coverage, 15032,
     /* 2038854 */     GIR_EraseRootFromParent_Done,
     /* 2038855 */   // Label 27180: @2038855
     /* 2038855 */   GIM_Try, /*On fail goto*//*Label 27181*/ GIMT_Encode4(2038946), // Rule ID 15033 //
     /* 2038860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2038871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2038874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2038877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038906 */     // MIs[0] round
     /* 2038906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038909 */     // MIs[0] policy
     /* 2038909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038919 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2038922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038945 */     // GIR_Coverage, 15033,
     /* 2038945 */     GIR_EraseRootFromParent_Done,
     /* 2038946 */   // Label 27181: @2038946
     /* 2038946 */   GIM_Try, /*On fail goto*//*Label 27182*/ GIMT_Encode4(2039037), // Rule ID 15036 //
     /* 2038951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2038962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2038965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2038968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038997 */     // MIs[0] round
     /* 2038997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039000 */     // MIs[0] policy
     /* 2039000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039010 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2039013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039036 */     // GIR_Coverage, 15036,
     /* 2039036 */     GIR_EraseRootFromParent_Done,
     /* 2039037 */   // Label 27182: @2039037
     /* 2039037 */   GIM_Try, /*On fail goto*//*Label 27183*/ GIMT_Encode4(2039128), // Rule ID 15037 //
     /* 2039042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2039053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2039056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2039059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039088 */     // MIs[0] round
     /* 2039088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039091 */     // MIs[0] policy
     /* 2039091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039101 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2039104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039127 */     // GIR_Coverage, 15037,
     /* 2039127 */     GIR_EraseRootFromParent_Done,
     /* 2039128 */   // Label 27183: @2039128
     /* 2039128 */   GIM_Try, /*On fail goto*//*Label 27184*/ GIMT_Encode4(2039219), // Rule ID 15040 //
     /* 2039133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2039144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2039147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2039150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039179 */     // MIs[0] round
     /* 2039179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039182 */     // MIs[0] policy
     /* 2039182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039192 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039218 */     // GIR_Coverage, 15040,
     /* 2039218 */     GIR_EraseRootFromParent_Done,
     /* 2039219 */   // Label 27184: @2039219
     /* 2039219 */   GIM_Try, /*On fail goto*//*Label 27185*/ GIMT_Encode4(2039310), // Rule ID 15041 //
     /* 2039224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2039235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2039238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2039241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039270 */     // MIs[0] round
     /* 2039270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039273 */     // MIs[0] policy
     /* 2039273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039283 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039309 */     // GIR_Coverage, 15041,
     /* 2039309 */     GIR_EraseRootFromParent_Done,
     /* 2039310 */   // Label 27185: @2039310
     /* 2039310 */   GIM_Try, /*On fail goto*//*Label 27186*/ GIMT_Encode4(2039401), // Rule ID 15044 //
     /* 2039315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2039326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2039329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2039332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039361 */     // MIs[0] round
     /* 2039361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039364 */     // MIs[0] policy
     /* 2039364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039374 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2039377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039400 */     // GIR_Coverage, 15044,
     /* 2039400 */     GIR_EraseRootFromParent_Done,
     /* 2039401 */   // Label 27186: @2039401
     /* 2039401 */   GIM_Try, /*On fail goto*//*Label 27187*/ GIMT_Encode4(2039492), // Rule ID 15045 //
     /* 2039406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2039417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2039420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2039423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039452 */     // MIs[0] round
     /* 2039452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039455 */     // MIs[0] policy
     /* 2039455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039465 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2039468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039491 */     // GIR_Coverage, 15045,
     /* 2039491 */     GIR_EraseRootFromParent_Done,
     /* 2039492 */   // Label 27187: @2039492
     /* 2039492 */   GIM_Try, /*On fail goto*//*Label 27188*/ GIMT_Encode4(2039583), // Rule ID 15048 //
     /* 2039497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2039508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2039511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2039514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039543 */     // MIs[0] round
     /* 2039543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039546 */     // MIs[0] policy
     /* 2039546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039556 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039582 */     // GIR_Coverage, 15048,
     /* 2039582 */     GIR_EraseRootFromParent_Done,
     /* 2039583 */   // Label 27188: @2039583
     /* 2039583 */   GIM_Try, /*On fail goto*//*Label 27189*/ GIMT_Encode4(2039674), // Rule ID 15049 //
     /* 2039588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2039599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2039602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2039605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039634 */     // MIs[0] round
     /* 2039634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039637 */     // MIs[0] policy
     /* 2039637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039647 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039673 */     // GIR_Coverage, 15049,
     /* 2039673 */     GIR_EraseRootFromParent_Done,
     /* 2039674 */   // Label 27189: @2039674
     /* 2039674 */   GIM_Try, /*On fail goto*//*Label 27190*/ GIMT_Encode4(2039765), // Rule ID 15052 //
     /* 2039679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2039690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2039693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2039696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039725 */     // MIs[0] round
     /* 2039725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039728 */     // MIs[0] policy
     /* 2039728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039738 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039764 */     // GIR_Coverage, 15052,
     /* 2039764 */     GIR_EraseRootFromParent_Done,
     /* 2039765 */   // Label 27190: @2039765
     /* 2039765 */   GIM_Try, /*On fail goto*//*Label 27191*/ GIMT_Encode4(2039856), // Rule ID 15053 //
     /* 2039770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2039781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2039784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2039787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039816 */     // MIs[0] round
     /* 2039816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039819 */     // MIs[0] policy
     /* 2039819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039829 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039855 */     // GIR_Coverage, 15053,
     /* 2039855 */     GIR_EraseRootFromParent_Done,
     /* 2039856 */   // Label 27191: @2039856
     /* 2039856 */   GIM_Try, /*On fail goto*//*Label 27192*/ GIMT_Encode4(2039947), // Rule ID 15056 //
     /* 2039861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2039872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2039875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2039878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039907 */     // MIs[0] round
     /* 2039907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039910 */     // MIs[0] policy
     /* 2039910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039920 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039946 */     // GIR_Coverage, 15056,
     /* 2039946 */     GIR_EraseRootFromParent_Done,
     /* 2039947 */   // Label 27192: @2039947
     /* 2039947 */   GIM_Try, /*On fail goto*//*Label 27193*/ GIMT_Encode4(2040038), // Rule ID 15057 //
     /* 2039952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2039963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2039966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2039969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039998 */     // MIs[0] round
     /* 2039998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040001 */     // MIs[0] policy
     /* 2040001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040011 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040037 */     // GIR_Coverage, 15057,
     /* 2040037 */     GIR_EraseRootFromParent_Done,
     /* 2040038 */   // Label 27193: @2040038
     /* 2040038 */   GIM_Try, /*On fail goto*//*Label 27194*/ GIMT_Encode4(2040129), // Rule ID 15060 //
     /* 2040043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2040054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2040057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2040060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2040066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040089 */     // MIs[0] round
     /* 2040089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040092 */     // MIs[0] policy
     /* 2040092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040128 */     // GIR_Coverage, 15060,
     /* 2040128 */     GIR_EraseRootFromParent_Done,
     /* 2040129 */   // Label 27194: @2040129
     /* 2040129 */   GIM_Try, /*On fail goto*//*Label 27195*/ GIMT_Encode4(2040220), // Rule ID 15061 //
     /* 2040134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2040145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2040148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2040151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2040157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040180 */     // MIs[0] round
     /* 2040180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040183 */     // MIs[0] policy
     /* 2040183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040193 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040219 */     // GIR_Coverage, 15061,
     /* 2040219 */     GIR_EraseRootFromParent_Done,
     /* 2040220 */   // Label 27195: @2040220
     /* 2040220 */   GIM_Try, /*On fail goto*//*Label 27196*/ GIMT_Encode4(2040311), // Rule ID 15064 //
     /* 2040225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2040236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2040239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2040242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040271 */     // MIs[0] round
     /* 2040271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040274 */     // MIs[0] policy
     /* 2040274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040284 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040310 */     // GIR_Coverage, 15064,
     /* 2040310 */     GIR_EraseRootFromParent_Done,
     /* 2040311 */   // Label 27196: @2040311
     /* 2040311 */   GIM_Try, /*On fail goto*//*Label 27197*/ GIMT_Encode4(2040402), // Rule ID 15065 //
     /* 2040316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2040327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2040330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2040333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040362 */     // MIs[0] round
     /* 2040362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040365 */     // MIs[0] policy
     /* 2040365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040375 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040401 */     // GIR_Coverage, 15065,
     /* 2040401 */     GIR_EraseRootFromParent_Done,
     /* 2040402 */   // Label 27197: @2040402
     /* 2040402 */   GIM_Try, /*On fail goto*//*Label 27198*/ GIMT_Encode4(2040493), // Rule ID 15068 //
     /* 2040407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2040410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2040418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2040421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2040424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040453 */     // MIs[0] round
     /* 2040453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040456 */     // MIs[0] policy
     /* 2040456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040466 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2040489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040492 */     // GIR_Coverage, 15068,
     /* 2040492 */     GIR_EraseRootFromParent_Done,
     /* 2040493 */   // Label 27198: @2040493
     /* 2040493 */   GIM_Try, /*On fail goto*//*Label 27199*/ GIMT_Encode4(2040584), // Rule ID 15069 //
     /* 2040498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2040501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2040509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2040512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2040515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040544 */     // MIs[0] round
     /* 2040544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040547 */     // MIs[0] policy
     /* 2040547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040557 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2040580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040583 */     // GIR_Coverage, 15069,
     /* 2040583 */     GIR_EraseRootFromParent_Done,
     /* 2040584 */   // Label 27199: @2040584
     /* 2040584 */   GIM_Try, /*On fail goto*//*Label 27200*/ GIMT_Encode4(2040675), // Rule ID 15072 //
     /* 2040589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2040600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2040603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2040606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040635 */     // MIs[0] round
     /* 2040635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040638 */     // MIs[0] policy
     /* 2040638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040648 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2040651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040674 */     // GIR_Coverage, 15072,
     /* 2040674 */     GIR_EraseRootFromParent_Done,
     /* 2040675 */   // Label 27200: @2040675
     /* 2040675 */   GIM_Try, /*On fail goto*//*Label 27201*/ GIMT_Encode4(2040766), // Rule ID 15073 //
     /* 2040680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2040691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2040694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2040697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040726 */     // MIs[0] round
     /* 2040726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040729 */     // MIs[0] policy
     /* 2040729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040739 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2040742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040765 */     // GIR_Coverage, 15073,
     /* 2040765 */     GIR_EraseRootFromParent_Done,
     /* 2040766 */   // Label 27201: @2040766
     /* 2040766 */   GIM_Try, /*On fail goto*//*Label 27202*/ GIMT_Encode4(2040857), // Rule ID 15076 //
     /* 2040771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2040782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2040785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2040788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2040794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040817 */     // MIs[0] round
     /* 2040817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040820 */     // MIs[0] policy
     /* 2040820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040830 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2040833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040856 */     // GIR_Coverage, 15076,
     /* 2040856 */     GIR_EraseRootFromParent_Done,
     /* 2040857 */   // Label 27202: @2040857
     /* 2040857 */   GIM_Try, /*On fail goto*//*Label 27203*/ GIMT_Encode4(2040948), // Rule ID 15077 //
     /* 2040862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2040873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2040876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2040879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2040885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040908 */     // MIs[0] round
     /* 2040908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040911 */     // MIs[0] policy
     /* 2040911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2040924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040947 */     // GIR_Coverage, 15077,
     /* 2040947 */     GIR_EraseRootFromParent_Done,
     /* 2040948 */   // Label 27203: @2040948
     /* 2040948 */   GIM_Try, /*On fail goto*//*Label 27204*/ GIMT_Encode4(2041039), // Rule ID 15080 //
     /* 2040953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2040964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2040967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2040970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2040976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2040983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040999 */     // MIs[0] round
     /* 2040999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041002 */     // MIs[0] policy
     /* 2041002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041012 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041038 */     // GIR_Coverage, 15080,
     /* 2041038 */     GIR_EraseRootFromParent_Done,
     /* 2041039 */   // Label 27204: @2041039
     /* 2041039 */   GIM_Try, /*On fail goto*//*Label 27205*/ GIMT_Encode4(2041130), // Rule ID 15081 //
     /* 2041044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2041055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2041058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2041061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2041067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041090 */     // MIs[0] round
     /* 2041090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041093 */     // MIs[0] policy
     /* 2041093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041103 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041129 */     // GIR_Coverage, 15081,
     /* 2041129 */     GIR_EraseRootFromParent_Done,
     /* 2041130 */   // Label 27205: @2041130
     /* 2041130 */   GIM_Try, /*On fail goto*//*Label 27206*/ GIMT_Encode4(2041221), // Rule ID 15084 //
     /* 2041135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2041146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2041149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2041152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041181 */     // MIs[0] round
     /* 2041181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041184 */     // MIs[0] policy
     /* 2041184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041220 */     // GIR_Coverage, 15084,
     /* 2041220 */     GIR_EraseRootFromParent_Done,
     /* 2041221 */   // Label 27206: @2041221
     /* 2041221 */   GIM_Try, /*On fail goto*//*Label 27207*/ GIMT_Encode4(2041312), // Rule ID 15085 //
     /* 2041226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2041237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2041240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2041243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041272 */     // MIs[0] round
     /* 2041272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041275 */     // MIs[0] policy
     /* 2041275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041285 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041311 */     // GIR_Coverage, 15085,
     /* 2041311 */     GIR_EraseRootFromParent_Done,
     /* 2041312 */   // Label 27207: @2041312
     /* 2041312 */   GIM_Try, /*On fail goto*//*Label 27208*/ GIMT_Encode4(2041403), // Rule ID 15088 //
     /* 2041317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2041328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2041331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2041334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041363 */     // MIs[0] round
     /* 2041363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041366 */     // MIs[0] policy
     /* 2041366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041376 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2041379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041402 */     // GIR_Coverage, 15088,
     /* 2041402 */     GIR_EraseRootFromParent_Done,
     /* 2041403 */   // Label 27208: @2041403
     /* 2041403 */   GIM_Try, /*On fail goto*//*Label 27209*/ GIMT_Encode4(2041494), // Rule ID 15089 //
     /* 2041408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2041419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2041422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2041425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041454 */     // MIs[0] round
     /* 2041454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041457 */     // MIs[0] policy
     /* 2041457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041467 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2041470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041493 */     // GIR_Coverage, 15089,
     /* 2041493 */     GIR_EraseRootFromParent_Done,
     /* 2041494 */   // Label 27209: @2041494
     /* 2041494 */   GIM_Try, /*On fail goto*//*Label 27210*/ GIMT_Encode4(2041585), // Rule ID 15092 //
     /* 2041499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2041510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2041513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2041516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041545 */     // MIs[0] round
     /* 2041545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041548 */     // MIs[0] policy
     /* 2041548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041584 */     // GIR_Coverage, 15092,
     /* 2041584 */     GIR_EraseRootFromParent_Done,
     /* 2041585 */   // Label 27210: @2041585
     /* 2041585 */   GIM_Try, /*On fail goto*//*Label 27211*/ GIMT_Encode4(2041676), // Rule ID 15093 //
     /* 2041590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2041601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2041604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2041607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041636 */     // MIs[0] round
     /* 2041636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041639 */     // MIs[0] policy
     /* 2041639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041649 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041675 */     // GIR_Coverage, 15093,
     /* 2041675 */     GIR_EraseRootFromParent_Done,
     /* 2041676 */   // Label 27211: @2041676
     /* 2041676 */   GIM_Try, /*On fail goto*//*Label 27212*/ GIMT_Encode4(2041767), // Rule ID 15096 //
     /* 2041681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2041692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2041695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2041698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041727 */     // MIs[0] round
     /* 2041727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041730 */     // MIs[0] policy
     /* 2041730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041766 */     // GIR_Coverage, 15096,
     /* 2041766 */     GIR_EraseRootFromParent_Done,
     /* 2041767 */   // Label 27212: @2041767
     /* 2041767 */   GIM_Try, /*On fail goto*//*Label 27213*/ GIMT_Encode4(2041858), // Rule ID 15097 //
     /* 2041772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2041783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2041786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2041789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041818 */     // MIs[0] round
     /* 2041818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041821 */     // MIs[0] policy
     /* 2041821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041831 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041857 */     // GIR_Coverage, 15097,
     /* 2041857 */     GIR_EraseRootFromParent_Done,
     /* 2041858 */   // Label 27213: @2041858
     /* 2041858 */   GIM_Try, /*On fail goto*//*Label 27214*/ GIMT_Encode4(2041949), // Rule ID 15100 //
     /* 2041863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2041874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2041877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2041880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041909 */     // MIs[0] round
     /* 2041909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041912 */     // MIs[0] policy
     /* 2041912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041922 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2041925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041948 */     // GIR_Coverage, 15100,
     /* 2041948 */     GIR_EraseRootFromParent_Done,
     /* 2041949 */   // Label 27214: @2041949
     /* 2041949 */   GIM_Try, /*On fail goto*//*Label 27215*/ GIMT_Encode4(2042040), // Rule ID 15101 //
     /* 2041954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2041965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2041968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2041971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042000 */     // MIs[0] round
     /* 2042000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042003 */     // MIs[0] policy
     /* 2042003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042013 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2042016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042039 */     // GIR_Coverage, 15101,
     /* 2042039 */     GIR_EraseRootFromParent_Done,
     /* 2042040 */   // Label 27215: @2042040
     /* 2042040 */   GIM_Try, /*On fail goto*//*Label 27216*/ GIMT_Encode4(2042131), // Rule ID 15104 //
     /* 2042045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2042056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2042059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2042062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2042068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042091 */     // MIs[0] round
     /* 2042091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042094 */     // MIs[0] policy
     /* 2042094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042104 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2042107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042130 */     // GIR_Coverage, 15104,
     /* 2042130 */     GIR_EraseRootFromParent_Done,
     /* 2042131 */   // Label 27216: @2042131
     /* 2042131 */   GIM_Try, /*On fail goto*//*Label 27217*/ GIMT_Encode4(2042222), // Rule ID 15105 //
     /* 2042136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2042147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2042150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2042153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2042159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042182 */     // MIs[0] round
     /* 2042182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042185 */     // MIs[0] policy
     /* 2042185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042195 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2042198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042221 */     // GIR_Coverage, 15105,
     /* 2042221 */     GIR_EraseRootFromParent_Done,
     /* 2042222 */   // Label 27217: @2042222
     /* 2042222 */   GIM_Try, /*On fail goto*//*Label 27218*/ GIMT_Encode4(2042313), // Rule ID 15108 //
     /* 2042227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2042230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2042238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2042241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2042244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042273 */     // MIs[0] round
     /* 2042273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042276 */     // MIs[0] policy
     /* 2042276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042286 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2042289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042312 */     // GIR_Coverage, 15108,
     /* 2042312 */     GIR_EraseRootFromParent_Done,
     /* 2042313 */   // Label 27218: @2042313
     /* 2042313 */   GIM_Try, /*On fail goto*//*Label 27219*/ GIMT_Encode4(2042404), // Rule ID 15109 //
     /* 2042318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2042329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2042332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2042335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042364 */     // MIs[0] round
     /* 2042364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042367 */     // MIs[0] policy
     /* 2042367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2042380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042403 */     // GIR_Coverage, 15109,
     /* 2042403 */     GIR_EraseRootFromParent_Done,
     /* 2042404 */   // Label 27219: @2042404
     /* 2042404 */   GIM_Try, /*On fail goto*//*Label 27220*/ GIMT_Encode4(2042495), // Rule ID 15112 //
     /* 2042409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2042412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2042420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2042423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2042426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042455 */     // MIs[0] round
     /* 2042455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042458 */     // MIs[0] policy
     /* 2042458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2042471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042494 */     // GIR_Coverage, 15112,
     /* 2042494 */     GIR_EraseRootFromParent_Done,
     /* 2042495 */   // Label 27220: @2042495
     /* 2042495 */   GIM_Try, /*On fail goto*//*Label 27221*/ GIMT_Encode4(2042586), // Rule ID 15113 //
     /* 2042500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2042511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2042514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2042517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042546 */     // MIs[0] round
     /* 2042546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042549 */     // MIs[0] policy
     /* 2042549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042559 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2042562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042585 */     // GIR_Coverage, 15113,
     /* 2042585 */     GIR_EraseRootFromParent_Done,
     /* 2042586 */   // Label 27221: @2042586
     /* 2042586 */   GIM_Try, /*On fail goto*//*Label 27222*/ GIMT_Encode4(2042677), // Rule ID 15116 //
     /* 2042591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2042594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2042602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2042605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2042608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042637 */     // MIs[0] round
     /* 2042637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042640 */     // MIs[0] policy
     /* 2042640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042650 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2042653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042676 */     // GIR_Coverage, 15116,
     /* 2042676 */     GIR_EraseRootFromParent_Done,
     /* 2042677 */   // Label 27222: @2042677
     /* 2042677 */   GIM_Try, /*On fail goto*//*Label 27223*/ GIMT_Encode4(2042768), // Rule ID 15117 //
     /* 2042682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2042693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2042696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2042699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042728 */     // MIs[0] round
     /* 2042728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042731 */     // MIs[0] policy
     /* 2042731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042741 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2042744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042767 */     // GIR_Coverage, 15117,
     /* 2042767 */     GIR_EraseRootFromParent_Done,
     /* 2042768 */   // Label 27223: @2042768
     /* 2042768 */   GIM_Try, /*On fail goto*//*Label 27224*/ GIMT_Encode4(2042859), // Rule ID 15120 //
     /* 2042773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2042784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2042787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2042790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2042793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042819 */     // MIs[0] round
     /* 2042819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042822 */     // MIs[0] policy
     /* 2042822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042832 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2042835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042858 */     // GIR_Coverage, 15120,
     /* 2042858 */     GIR_EraseRootFromParent_Done,
     /* 2042859 */   // Label 27224: @2042859
     /* 2042859 */   GIM_Try, /*On fail goto*//*Label 27225*/ GIMT_Encode4(2042950), // Rule ID 15121 //
     /* 2042864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2042875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2042878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2042881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2042884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042910 */     // MIs[0] round
     /* 2042910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042913 */     // MIs[0] policy
     /* 2042913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042923 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2042926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042949 */     // GIR_Coverage, 15121,
     /* 2042949 */     GIR_EraseRootFromParent_Done,
     /* 2042950 */   // Label 27225: @2042950
     /* 2042950 */   GIM_Try, /*On fail goto*//*Label 27226*/ GIMT_Encode4(2043041), // Rule ID 15124 //
     /* 2042955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2042966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2042969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2042972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2042975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043001 */     // MIs[0] round
     /* 2043001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043004 */     // MIs[0] policy
     /* 2043004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043014 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2043017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043040 */     // GIR_Coverage, 15124,
     /* 2043040 */     GIR_EraseRootFromParent_Done,
     /* 2043041 */   // Label 27226: @2043041
     /* 2043041 */   GIM_Try, /*On fail goto*//*Label 27227*/ GIMT_Encode4(2043132), // Rule ID 15125 //
     /* 2043046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2043057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2043060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2043063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2043066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043092 */     // MIs[0] round
     /* 2043092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043095 */     // MIs[0] policy
     /* 2043095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043105 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2043108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043131 */     // GIR_Coverage, 15125,
     /* 2043131 */     GIR_EraseRootFromParent_Done,
     /* 2043132 */   // Label 27227: @2043132
     /* 2043132 */   GIM_Try, /*On fail goto*//*Label 27228*/ GIMT_Encode4(2043223), // Rule ID 15128 //
     /* 2043137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2043148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2043151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2043154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2043157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043183 */     // MIs[0] round
     /* 2043183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043186 */     // MIs[0] policy
     /* 2043186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043222 */     // GIR_Coverage, 15128,
     /* 2043222 */     GIR_EraseRootFromParent_Done,
     /* 2043223 */   // Label 27228: @2043223
     /* 2043223 */   GIM_Try, /*On fail goto*//*Label 27229*/ GIMT_Encode4(2043314), // Rule ID 15129 //
     /* 2043228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2043239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2043242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2043245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2043248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043274 */     // MIs[0] round
     /* 2043274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043277 */     // MIs[0] policy
     /* 2043277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043287 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043313 */     // GIR_Coverage, 15129,
     /* 2043313 */     GIR_EraseRootFromParent_Done,
     /* 2043314 */   // Label 27229: @2043314
     /* 2043314 */   GIM_Try, /*On fail goto*//*Label 27230*/ GIMT_Encode4(2043405), // Rule ID 15132 //
     /* 2043319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2043330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2043333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2043336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2043339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043365 */     // MIs[0] round
     /* 2043365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043368 */     // MIs[0] policy
     /* 2043368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043378 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2043381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043404 */     // GIR_Coverage, 15132,
     /* 2043404 */     GIR_EraseRootFromParent_Done,
     /* 2043405 */   // Label 27230: @2043405
     /* 2043405 */   GIM_Try, /*On fail goto*//*Label 27231*/ GIMT_Encode4(2043496), // Rule ID 15133 //
     /* 2043410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2043421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2043424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2043427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2043430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043456 */     // MIs[0] round
     /* 2043456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043459 */     // MIs[0] policy
     /* 2043459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043469 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2043472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043495 */     // GIR_Coverage, 15133,
     /* 2043495 */     GIR_EraseRootFromParent_Done,
     /* 2043496 */   // Label 27231: @2043496
     /* 2043496 */   GIM_Try, /*On fail goto*//*Label 27232*/ GIMT_Encode4(2043587), // Rule ID 15136 //
     /* 2043501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2043512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2043515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2043518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2043521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043547 */     // MIs[0] round
     /* 2043547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043550 */     // MIs[0] policy
     /* 2043550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043560 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043586 */     // GIR_Coverage, 15136,
     /* 2043586 */     GIR_EraseRootFromParent_Done,
     /* 2043587 */   // Label 27232: @2043587
     /* 2043587 */   GIM_Try, /*On fail goto*//*Label 27233*/ GIMT_Encode4(2043678), // Rule ID 15137 //
     /* 2043592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2043603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2043606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2043609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2043612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043638 */     // MIs[0] round
     /* 2043638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043641 */     // MIs[0] policy
     /* 2043641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043651 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043677 */     // GIR_Coverage, 15137,
     /* 2043677 */     GIR_EraseRootFromParent_Done,
     /* 2043678 */   // Label 27233: @2043678
     /* 2043678 */   GIM_Try, /*On fail goto*//*Label 27234*/ GIMT_Encode4(2043769), // Rule ID 15140 //
     /* 2043683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2043694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2043697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2043700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2043703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043729 */     // MIs[0] round
     /* 2043729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043732 */     // MIs[0] policy
     /* 2043732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043742 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043768 */     // GIR_Coverage, 15140,
     /* 2043768 */     GIR_EraseRootFromParent_Done,
     /* 2043769 */   // Label 27234: @2043769
     /* 2043769 */   GIM_Try, /*On fail goto*//*Label 27235*/ GIMT_Encode4(2043860), // Rule ID 15141 //
     /* 2043774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2043785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2043788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2043791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2043794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043820 */     // MIs[0] round
     /* 2043820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043823 */     // MIs[0] policy
     /* 2043823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043833 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043859 */     // GIR_Coverage, 15141,
     /* 2043859 */     GIR_EraseRootFromParent_Done,
     /* 2043860 */   // Label 27235: @2043860
     /* 2043860 */   GIM_Try, /*On fail goto*//*Label 27236*/ GIMT_Encode4(2043951), // Rule ID 15144 //
     /* 2043865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2043876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2043879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2043882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2043885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043911 */     // MIs[0] round
     /* 2043911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043914 */     // MIs[0] policy
     /* 2043914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043950 */     // GIR_Coverage, 15144,
     /* 2043950 */     GIR_EraseRootFromParent_Done,
     /* 2043951 */   // Label 27236: @2043951
     /* 2043951 */   GIM_Try, /*On fail goto*//*Label 27237*/ GIMT_Encode4(2044042), // Rule ID 15145 //
     /* 2043956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2043967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2043970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2043973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2043976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044002 */     // MIs[0] round
     /* 2044002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044005 */     // MIs[0] policy
     /* 2044005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044015 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044041 */     // GIR_Coverage, 15145,
     /* 2044041 */     GIR_EraseRootFromParent_Done,
     /* 2044042 */   // Label 27237: @2044042
     /* 2044042 */   GIM_Try, /*On fail goto*//*Label 27238*/ GIMT_Encode4(2044133), // Rule ID 15148 //
     /* 2044047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2044058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2044061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2044064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2044067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2044070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044093 */     // MIs[0] round
     /* 2044093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044096 */     // MIs[0] policy
     /* 2044096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044132 */     // GIR_Coverage, 15148,
     /* 2044132 */     GIR_EraseRootFromParent_Done,
     /* 2044133 */   // Label 27238: @2044133
     /* 2044133 */   GIM_Try, /*On fail goto*//*Label 27239*/ GIMT_Encode4(2044224), // Rule ID 15149 //
     /* 2044138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2044149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2044152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2044155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2044158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2044161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044184 */     // MIs[0] round
     /* 2044184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044187 */     // MIs[0] policy
     /* 2044187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044197 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044223 */     // GIR_Coverage, 15149,
     /* 2044223 */     GIR_EraseRootFromParent_Done,
     /* 2044224 */   // Label 27239: @2044224
     /* 2044224 */   GIM_Try, /*On fail goto*//*Label 27240*/ GIMT_Encode4(2044315), // Rule ID 15152 //
     /* 2044229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2044240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2044243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2044246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2044249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2044252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044275 */     // MIs[0] round
     /* 2044275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044278 */     // MIs[0] policy
     /* 2044278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044314 */     // GIR_Coverage, 15152,
     /* 2044314 */     GIR_EraseRootFromParent_Done,
     /* 2044315 */   // Label 27240: @2044315
     /* 2044315 */   GIM_Try, /*On fail goto*//*Label 27241*/ GIMT_Encode4(2044406), // Rule ID 15153 //
     /* 2044320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2044331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2044334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2044337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2044340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2044343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044366 */     // MIs[0] round
     /* 2044366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044369 */     // MIs[0] policy
     /* 2044369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044379 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044405 */     // GIR_Coverage, 15153,
     /* 2044405 */     GIR_EraseRootFromParent_Done,
     /* 2044406 */   // Label 27241: @2044406
     /* 2044406 */   GIM_Try, /*On fail goto*//*Label 27242*/ GIMT_Encode4(2044497), // Rule ID 15156 //
     /* 2044411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2044414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2044422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2044425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2044428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2044431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044457 */     // MIs[0] round
     /* 2044457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044460 */     // MIs[0] policy
     /* 2044460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2044493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044496 */     // GIR_Coverage, 15156,
     /* 2044496 */     GIR_EraseRootFromParent_Done,
     /* 2044497 */   // Label 27242: @2044497
     /* 2044497 */   GIM_Try, /*On fail goto*//*Label 27243*/ GIMT_Encode4(2044588), // Rule ID 15157 //
     /* 2044502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2044505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2044513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2044516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2044519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2044522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044548 */     // MIs[0] round
     /* 2044548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044551 */     // MIs[0] policy
     /* 2044551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044561 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2044584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044587 */     // GIR_Coverage, 15157,
     /* 2044587 */     GIR_EraseRootFromParent_Done,
     /* 2044588 */   // Label 27243: @2044588
     /* 2044588 */   GIM_Try, /*On fail goto*//*Label 27244*/ GIMT_Encode4(2044679), // Rule ID 15160 //
     /* 2044593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2044604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2044607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2044610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2044613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044639 */     // MIs[0] round
     /* 2044639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044642 */     // MIs[0] policy
     /* 2044642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044652 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2044655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044678 */     // GIR_Coverage, 15160,
     /* 2044678 */     GIR_EraseRootFromParent_Done,
     /* 2044679 */   // Label 27244: @2044679
     /* 2044679 */   GIM_Try, /*On fail goto*//*Label 27245*/ GIMT_Encode4(2044770), // Rule ID 15161 //
     /* 2044684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2044695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2044698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2044701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2044704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044730 */     // MIs[0] round
     /* 2044730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044733 */     // MIs[0] policy
     /* 2044733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044743 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2044746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044769 */     // GIR_Coverage, 15161,
     /* 2044769 */     GIR_EraseRootFromParent_Done,
     /* 2044770 */   // Label 27245: @2044770
     /* 2044770 */   GIM_Try, /*On fail goto*//*Label 27246*/ GIMT_Encode4(2044861), // Rule ID 15164 //
     /* 2044775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2044786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2044789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2044792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2044795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044821 */     // MIs[0] round
     /* 2044821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044824 */     // MIs[0] policy
     /* 2044824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2044837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044860 */     // GIR_Coverage, 15164,
     /* 2044860 */     GIR_EraseRootFromParent_Done,
     /* 2044861 */   // Label 27246: @2044861
     /* 2044861 */   GIM_Try, /*On fail goto*//*Label 27247*/ GIMT_Encode4(2044952), // Rule ID 15165 //
     /* 2044866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2044877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2044880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2044883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2044886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044912 */     // MIs[0] round
     /* 2044912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044915 */     // MIs[0] policy
     /* 2044915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044925 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2044928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044951 */     // GIR_Coverage, 15165,
     /* 2044951 */     GIR_EraseRootFromParent_Done,
     /* 2044952 */   // Label 27247: @2044952
     /* 2044952 */   GIM_Try, /*On fail goto*//*Label 27248*/ GIMT_Encode4(2045043), // Rule ID 15168 //
     /* 2044957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2044968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2044971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2044974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2044977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2044980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045003 */     // MIs[0] round
     /* 2045003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045006 */     // MIs[0] policy
     /* 2045006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045016 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045042 */     // GIR_Coverage, 15168,
     /* 2045042 */     GIR_EraseRootFromParent_Done,
     /* 2045043 */   // Label 27248: @2045043
     /* 2045043 */   GIM_Try, /*On fail goto*//*Label 27249*/ GIMT_Encode4(2045134), // Rule ID 15169 //
     /* 2045048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2045059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2045062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2045065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2045068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2045071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045094 */     // MIs[0] round
     /* 2045094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045097 */     // MIs[0] policy
     /* 2045097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045107 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045133 */     // GIR_Coverage, 15169,
     /* 2045133 */     GIR_EraseRootFromParent_Done,
     /* 2045134 */   // Label 27249: @2045134
     /* 2045134 */   GIM_Try, /*On fail goto*//*Label 27250*/ GIMT_Encode4(2045225), // Rule ID 15172 //
     /* 2045139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2045150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2045153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2045156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2045159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045185 */     // MIs[0] round
     /* 2045185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045188 */     // MIs[0] policy
     /* 2045188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045224 */     // GIR_Coverage, 15172,
     /* 2045224 */     GIR_EraseRootFromParent_Done,
     /* 2045225 */   // Label 27250: @2045225
     /* 2045225 */   GIM_Try, /*On fail goto*//*Label 27251*/ GIMT_Encode4(2045316), // Rule ID 15173 //
     /* 2045230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2045241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2045244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2045247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2045250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045276 */     // MIs[0] round
     /* 2045276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045279 */     // MIs[0] policy
     /* 2045279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045315 */     // GIR_Coverage, 15173,
     /* 2045315 */     GIR_EraseRootFromParent_Done,
     /* 2045316 */   // Label 27251: @2045316
     /* 2045316 */   GIM_Try, /*On fail goto*//*Label 27252*/ GIMT_Encode4(2045407), // Rule ID 15176 //
     /* 2045321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2045332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2045335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2045338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2045341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045367 */     // MIs[0] round
     /* 2045367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045370 */     // MIs[0] policy
     /* 2045370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2045383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045406 */     // GIR_Coverage, 15176,
     /* 2045406 */     GIR_EraseRootFromParent_Done,
     /* 2045407 */   // Label 27252: @2045407
     /* 2045407 */   GIM_Try, /*On fail goto*//*Label 27253*/ GIMT_Encode4(2045498), // Rule ID 15177 //
     /* 2045412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2045423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2045426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2045429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2045432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045458 */     // MIs[0] round
     /* 2045458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045461 */     // MIs[0] policy
     /* 2045461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045471 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2045474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045497 */     // GIR_Coverage, 15177,
     /* 2045497 */     GIR_EraseRootFromParent_Done,
     /* 2045498 */   // Label 27253: @2045498
     /* 2045498 */   GIM_Try, /*On fail goto*//*Label 27254*/ GIMT_Encode4(2045589), // Rule ID 15180 //
     /* 2045503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2045514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2045517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2045520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2045523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045549 */     // MIs[0] round
     /* 2045549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045552 */     // MIs[0] policy
     /* 2045552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045562 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045588 */     // GIR_Coverage, 15180,
     /* 2045588 */     GIR_EraseRootFromParent_Done,
     /* 2045589 */   // Label 27254: @2045589
     /* 2045589 */   GIM_Try, /*On fail goto*//*Label 27255*/ GIMT_Encode4(2045680), // Rule ID 15181 //
     /* 2045594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2045605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2045608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2045611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2045614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045640 */     // MIs[0] round
     /* 2045640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045643 */     // MIs[0] policy
     /* 2045643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045653 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045679 */     // GIR_Coverage, 15181,
     /* 2045679 */     GIR_EraseRootFromParent_Done,
     /* 2045680 */   // Label 27255: @2045680
     /* 2045680 */   GIM_Try, /*On fail goto*//*Label 27256*/ GIMT_Encode4(2045771), // Rule ID 15184 //
     /* 2045685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2045696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2045699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2045702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2045705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045731 */     // MIs[0] round
     /* 2045731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045734 */     // MIs[0] policy
     /* 2045734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045770 */     // GIR_Coverage, 15184,
     /* 2045770 */     GIR_EraseRootFromParent_Done,
     /* 2045771 */   // Label 27256: @2045771
     /* 2045771 */   GIM_Try, /*On fail goto*//*Label 27257*/ GIMT_Encode4(2045862), // Rule ID 15185 //
     /* 2045776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2045787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2045790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2045793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2045796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045822 */     // MIs[0] round
     /* 2045822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045825 */     // MIs[0] policy
     /* 2045825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045861 */     // GIR_Coverage, 15185,
     /* 2045861 */     GIR_EraseRootFromParent_Done,
     /* 2045862 */   // Label 27257: @2045862
     /* 2045862 */   GIM_Try, /*On fail goto*//*Label 27258*/ GIMT_Encode4(2045953), // Rule ID 15188 //
     /* 2045867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2045878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2045881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2045884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2045887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045913 */     // MIs[0] round
     /* 2045913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045916 */     // MIs[0] policy
     /* 2045916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2045929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045952 */     // GIR_Coverage, 15188,
     /* 2045952 */     GIR_EraseRootFromParent_Done,
     /* 2045953 */   // Label 27258: @2045953
     /* 2045953 */   GIM_Try, /*On fail goto*//*Label 27259*/ GIMT_Encode4(2046044), // Rule ID 15189 //
     /* 2045958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2045969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2045972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2045975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2045978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046004 */     // MIs[0] round
     /* 2046004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046007 */     // MIs[0] policy
     /* 2046007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046017 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2046020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046043 */     // GIR_Coverage, 15189,
     /* 2046043 */     GIR_EraseRootFromParent_Done,
     /* 2046044 */   // Label 27259: @2046044
     /* 2046044 */   GIM_Try, /*On fail goto*//*Label 27260*/ GIMT_Encode4(2046135), // Rule ID 15192 //
     /* 2046049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2046060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2046063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2046066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2046069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2046072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046095 */     // MIs[0] round
     /* 2046095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046098 */     // MIs[0] policy
     /* 2046098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2046111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046134 */     // GIR_Coverage, 15192,
     /* 2046134 */     GIR_EraseRootFromParent_Done,
     /* 2046135 */   // Label 27260: @2046135
     /* 2046135 */   GIM_Try, /*On fail goto*//*Label 27261*/ GIMT_Encode4(2046226), // Rule ID 15193 //
     /* 2046140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2046151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2046154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2046157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2046160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2046163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046186 */     // MIs[0] round
     /* 2046186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046189 */     // MIs[0] policy
     /* 2046189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046199 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2046202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046225 */     // GIR_Coverage, 15193,
     /* 2046225 */     GIR_EraseRootFromParent_Done,
     /* 2046226 */   // Label 27261: @2046226
     /* 2046226 */   GIM_Try, /*On fail goto*//*Label 27262*/ GIMT_Encode4(2046317), // Rule ID 15196 //
     /* 2046231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2046234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2046242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2046245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2046248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2046251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046277 */     // MIs[0] round
     /* 2046277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046280 */     // MIs[0] policy
     /* 2046280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2046293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046316 */     // GIR_Coverage, 15196,
     /* 2046316 */     GIR_EraseRootFromParent_Done,
     /* 2046317 */   // Label 27262: @2046317
     /* 2046317 */   GIM_Try, /*On fail goto*//*Label 27263*/ GIMT_Encode4(2046408), // Rule ID 15197 //
     /* 2046322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2046333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2046336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2046339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2046342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046368 */     // MIs[0] round
     /* 2046368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046371 */     // MIs[0] policy
     /* 2046371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046381 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2046384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046407 */     // GIR_Coverage, 15197,
     /* 2046407 */     GIR_EraseRootFromParent_Done,
     /* 2046408 */   // Label 27263: @2046408
     /* 2046408 */   GIM_Try, /*On fail goto*//*Label 27264*/ GIMT_Encode4(2046499), // Rule ID 15200 //
     /* 2046413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2046416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2046424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2046427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2046430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2046433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046459 */     // MIs[0] round
     /* 2046459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046462 */     // MIs[0] policy
     /* 2046462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046472 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2046475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046498 */     // GIR_Coverage, 15200,
     /* 2046498 */     GIR_EraseRootFromParent_Done,
     /* 2046499 */   // Label 27264: @2046499
     /* 2046499 */   GIM_Try, /*On fail goto*//*Label 27265*/ GIMT_Encode4(2046590), // Rule ID 15201 //
     /* 2046504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2046515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2046518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2046521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2046524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046550 */     // MIs[0] round
     /* 2046550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046553 */     // MIs[0] policy
     /* 2046553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046563 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2046566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046589 */     // GIR_Coverage, 15201,
     /* 2046589 */     GIR_EraseRootFromParent_Done,
     /* 2046590 */   // Label 27265: @2046590
     /* 2046590 */   GIM_Try, /*On fail goto*//*Label 27266*/ GIMT_Encode4(2046681), // Rule ID 15204 //
     /* 2046595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2046598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2046606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2046609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2046612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2046615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046641 */     // MIs[0] round
     /* 2046641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046644 */     // MIs[0] policy
     /* 2046644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046654 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2046657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046680 */     // GIR_Coverage, 15204,
     /* 2046680 */     GIR_EraseRootFromParent_Done,
     /* 2046681 */   // Label 27266: @2046681
     /* 2046681 */   GIM_Try, /*On fail goto*//*Label 27267*/ GIMT_Encode4(2046772), // Rule ID 15205 //
     /* 2046686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2046697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2046700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2046703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2046706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046732 */     // MIs[0] round
     /* 2046732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046735 */     // MIs[0] policy
     /* 2046735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046745 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2046748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046771 */     // GIR_Coverage, 15205,
     /* 2046771 */     GIR_EraseRootFromParent_Done,
     /* 2046772 */   // Label 27267: @2046772
     /* 2046772 */   GIM_Try, /*On fail goto*//*Label 27268*/ GIMT_Encode4(2046863), // Rule ID 15208 //
     /* 2046777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2046788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2046791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2046794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046823 */     // MIs[0] round
     /* 2046823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046826 */     // MIs[0] policy
     /* 2046826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046836 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2046839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046862 */     // GIR_Coverage, 15208,
     /* 2046862 */     GIR_EraseRootFromParent_Done,
     /* 2046863 */   // Label 27268: @2046863
     /* 2046863 */   GIM_Try, /*On fail goto*//*Label 27269*/ GIMT_Encode4(2046954), // Rule ID 15209 //
     /* 2046868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2046879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2046882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2046885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046914 */     // MIs[0] round
     /* 2046914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046917 */     // MIs[0] policy
     /* 2046917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046927 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2046930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046953 */     // GIR_Coverage, 15209,
     /* 2046953 */     GIR_EraseRootFromParent_Done,
     /* 2046954 */   // Label 27269: @2046954
     /* 2046954 */   GIM_Try, /*On fail goto*//*Label 27270*/ GIMT_Encode4(2047045), // Rule ID 15212 //
     /* 2046959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2046970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2046973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2046976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047005 */     // MIs[0] round
     /* 2047005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047008 */     // MIs[0] policy
     /* 2047008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047018 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2047021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047044 */     // GIR_Coverage, 15212,
     /* 2047044 */     GIR_EraseRootFromParent_Done,
     /* 2047045 */   // Label 27270: @2047045
     /* 2047045 */   GIM_Try, /*On fail goto*//*Label 27271*/ GIMT_Encode4(2047136), // Rule ID 15213 //
     /* 2047050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2047061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2047064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2047067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047096 */     // MIs[0] round
     /* 2047096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047099 */     // MIs[0] policy
     /* 2047099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047109 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2047112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047135 */     // GIR_Coverage, 15213,
     /* 2047135 */     GIR_EraseRootFromParent_Done,
     /* 2047136 */   // Label 27271: @2047136
     /* 2047136 */   GIM_Try, /*On fail goto*//*Label 27272*/ GIMT_Encode4(2047227), // Rule ID 15216 //
     /* 2047141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2047152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2047155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2047158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047187 */     // MIs[0] round
     /* 2047187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047190 */     // MIs[0] policy
     /* 2047190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047200 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047226 */     // GIR_Coverage, 15216,
     /* 2047226 */     GIR_EraseRootFromParent_Done,
     /* 2047227 */   // Label 27272: @2047227
     /* 2047227 */   GIM_Try, /*On fail goto*//*Label 27273*/ GIMT_Encode4(2047318), // Rule ID 15217 //
     /* 2047232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2047243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2047246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2047249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047278 */     // MIs[0] round
     /* 2047278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047281 */     // MIs[0] policy
     /* 2047281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047291 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047317 */     // GIR_Coverage, 15217,
     /* 2047317 */     GIR_EraseRootFromParent_Done,
     /* 2047318 */   // Label 27273: @2047318
     /* 2047318 */   GIM_Try, /*On fail goto*//*Label 27274*/ GIMT_Encode4(2047409), // Rule ID 15220 //
     /* 2047323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2047334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2047337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2047340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047369 */     // MIs[0] round
     /* 2047369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047372 */     // MIs[0] policy
     /* 2047372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047382 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2047385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047408 */     // GIR_Coverage, 15220,
     /* 2047408 */     GIR_EraseRootFromParent_Done,
     /* 2047409 */   // Label 27274: @2047409
     /* 2047409 */   GIM_Try, /*On fail goto*//*Label 27275*/ GIMT_Encode4(2047500), // Rule ID 15221 //
     /* 2047414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2047425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2047428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2047431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047460 */     // MIs[0] round
     /* 2047460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047463 */     // MIs[0] policy
     /* 2047463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047473 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2047476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047499 */     // GIR_Coverage, 15221,
     /* 2047499 */     GIR_EraseRootFromParent_Done,
     /* 2047500 */   // Label 27275: @2047500
     /* 2047500 */   GIM_Try, /*On fail goto*//*Label 27276*/ GIMT_Encode4(2047591), // Rule ID 15224 //
     /* 2047505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2047516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2047519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2047522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047551 */     // MIs[0] round
     /* 2047551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047554 */     // MIs[0] policy
     /* 2047554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047590 */     // GIR_Coverage, 15224,
     /* 2047590 */     GIR_EraseRootFromParent_Done,
     /* 2047591 */   // Label 27276: @2047591
     /* 2047591 */   GIM_Try, /*On fail goto*//*Label 27277*/ GIMT_Encode4(2047682), // Rule ID 15225 //
     /* 2047596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2047607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2047610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2047613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047642 */     // MIs[0] round
     /* 2047642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047645 */     // MIs[0] policy
     /* 2047645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047655 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047681 */     // GIR_Coverage, 15225,
     /* 2047681 */     GIR_EraseRootFromParent_Done,
     /* 2047682 */   // Label 27277: @2047682
     /* 2047682 */   GIM_Try, /*On fail goto*//*Label 27278*/ GIMT_Encode4(2047773), // Rule ID 15228 //
     /* 2047687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2047698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2047701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2047704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047733 */     // MIs[0] round
     /* 2047733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047736 */     // MIs[0] policy
     /* 2047736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047772 */     // GIR_Coverage, 15228,
     /* 2047772 */     GIR_EraseRootFromParent_Done,
     /* 2047773 */   // Label 27278: @2047773
     /* 2047773 */   GIM_Try, /*On fail goto*//*Label 27279*/ GIMT_Encode4(2047864), // Rule ID 15229 //
     /* 2047778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2047789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2047792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2047795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047824 */     // MIs[0] round
     /* 2047824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047827 */     // MIs[0] policy
     /* 2047827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047837 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047863 */     // GIR_Coverage, 15229,
     /* 2047863 */     GIR_EraseRootFromParent_Done,
     /* 2047864 */   // Label 27279: @2047864
     /* 2047864 */   GIM_Try, /*On fail goto*//*Label 27280*/ GIMT_Encode4(2047955), // Rule ID 15232 //
     /* 2047869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2047880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2047883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2047886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047915 */     // MIs[0] round
     /* 2047915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047918 */     // MIs[0] policy
     /* 2047918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047928 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047954 */     // GIR_Coverage, 15232,
     /* 2047954 */     GIR_EraseRootFromParent_Done,
     /* 2047955 */   // Label 27280: @2047955
     /* 2047955 */   GIM_Try, /*On fail goto*//*Label 27281*/ GIMT_Encode4(2048046), // Rule ID 15233 //
     /* 2047960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2047971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2047974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2047977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048006 */     // MIs[0] round
     /* 2048006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048009 */     // MIs[0] policy
     /* 2048009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048019 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048045 */     // GIR_Coverage, 15233,
     /* 2048045 */     GIR_EraseRootFromParent_Done,
     /* 2048046 */   // Label 27281: @2048046
     /* 2048046 */   GIM_Try, /*On fail goto*//*Label 27282*/ GIMT_Encode4(2048137), // Rule ID 15236 //
     /* 2048051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2048062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2048065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2048068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2048074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048097 */     // MIs[0] round
     /* 2048097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048100 */     // MIs[0] policy
     /* 2048100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048110 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048136 */     // GIR_Coverage, 15236,
     /* 2048136 */     GIR_EraseRootFromParent_Done,
     /* 2048137 */   // Label 27282: @2048137
     /* 2048137 */   GIM_Try, /*On fail goto*//*Label 27283*/ GIMT_Encode4(2048228), // Rule ID 15237 //
     /* 2048142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2048153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2048156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2048159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2048165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048188 */     // MIs[0] round
     /* 2048188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048191 */     // MIs[0] policy
     /* 2048191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048201 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048227 */     // GIR_Coverage, 15237,
     /* 2048227 */     GIR_EraseRootFromParent_Done,
     /* 2048228 */   // Label 27283: @2048228
     /* 2048228 */   GIM_Try, /*On fail goto*//*Label 27284*/ GIMT_Encode4(2048319), // Rule ID 15240 //
     /* 2048233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2048244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2048247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2048250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2048256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048279 */     // MIs[0] round
     /* 2048279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048282 */     // MIs[0] policy
     /* 2048282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048318 */     // GIR_Coverage, 15240,
     /* 2048318 */     GIR_EraseRootFromParent_Done,
     /* 2048319 */   // Label 27284: @2048319
     /* 2048319 */   GIM_Try, /*On fail goto*//*Label 27285*/ GIMT_Encode4(2048410), // Rule ID 15241 //
     /* 2048324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2048335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2048338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2048341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2048347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048370 */     // MIs[0] round
     /* 2048370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048373 */     // MIs[0] policy
     /* 2048373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048383 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048409 */     // GIR_Coverage, 15241,
     /* 2048409 */     GIR_EraseRootFromParent_Done,
     /* 2048410 */   // Label 27285: @2048410
     /* 2048410 */   GIM_Try, /*On fail goto*//*Label 27286*/ GIMT_Encode4(2048501), // Rule ID 15244 //
     /* 2048415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2048418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2048426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2048429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2048432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048461 */     // MIs[0] round
     /* 2048461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048464 */     // MIs[0] policy
     /* 2048464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048474 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048500 */     // GIR_Coverage, 15244,
     /* 2048500 */     GIR_EraseRootFromParent_Done,
     /* 2048501 */   // Label 27286: @2048501
     /* 2048501 */   GIM_Try, /*On fail goto*//*Label 27287*/ GIMT_Encode4(2048592), // Rule ID 15245 //
     /* 2048506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2048509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2048517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2048520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2048523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048552 */     // MIs[0] round
     /* 2048552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048555 */     // MIs[0] policy
     /* 2048555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048565 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048591 */     // GIR_Coverage, 15245,
     /* 2048591 */     GIR_EraseRootFromParent_Done,
     /* 2048592 */   // Label 27287: @2048592
     /* 2048592 */   GIM_Try, /*On fail goto*//*Label 27288*/ GIMT_Encode4(2048683), // Rule ID 15248 //
     /* 2048597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2048608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2048611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2048614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048643 */     // MIs[0] round
     /* 2048643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048646 */     // MIs[0] policy
     /* 2048646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048656 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2048659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048682 */     // GIR_Coverage, 15248,
     /* 2048682 */     GIR_EraseRootFromParent_Done,
     /* 2048683 */   // Label 27288: @2048683
     /* 2048683 */   GIM_Try, /*On fail goto*//*Label 27289*/ GIMT_Encode4(2048774), // Rule ID 15249 //
     /* 2048688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2048699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2048702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2048705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048734 */     // MIs[0] round
     /* 2048734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048737 */     // MIs[0] policy
     /* 2048737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048747 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2048750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048773 */     // GIR_Coverage, 15249,
     /* 2048773 */     GIR_EraseRootFromParent_Done,
     /* 2048774 */   // Label 27289: @2048774
     /* 2048774 */   GIM_Try, /*On fail goto*//*Label 27290*/ GIMT_Encode4(2048865), // Rule ID 15252 //
     /* 2048779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2048790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2048793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2048796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2048802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048825 */     // MIs[0] round
     /* 2048825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048828 */     // MIs[0] policy
     /* 2048828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048838 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2048841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048864 */     // GIR_Coverage, 15252,
     /* 2048864 */     GIR_EraseRootFromParent_Done,
     /* 2048865 */   // Label 27290: @2048865
     /* 2048865 */   GIM_Try, /*On fail goto*//*Label 27291*/ GIMT_Encode4(2048956), // Rule ID 15253 //
     /* 2048870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2048881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2048884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2048887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2048893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048916 */     // MIs[0] round
     /* 2048916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048919 */     // MIs[0] policy
     /* 2048919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048929 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2048932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048955 */     // GIR_Coverage, 15253,
     /* 2048955 */     GIR_EraseRootFromParent_Done,
     /* 2048956 */   // Label 27291: @2048956
     /* 2048956 */   GIM_Try, /*On fail goto*//*Label 27292*/ GIMT_Encode4(2049047), // Rule ID 15256 //
     /* 2048961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2048972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2048975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2048978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2048984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2048991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049007 */     // MIs[0] round
     /* 2049007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049010 */     // MIs[0] policy
     /* 2049010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049020 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049046 */     // GIR_Coverage, 15256,
     /* 2049046 */     GIR_EraseRootFromParent_Done,
     /* 2049047 */   // Label 27292: @2049047
     /* 2049047 */   GIM_Try, /*On fail goto*//*Label 27293*/ GIMT_Encode4(2049138), // Rule ID 15257 //
     /* 2049052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2049063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2049066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2049069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2049075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049098 */     // MIs[0] round
     /* 2049098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049101 */     // MIs[0] policy
     /* 2049101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049111 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049137 */     // GIR_Coverage, 15257,
     /* 2049137 */     GIR_EraseRootFromParent_Done,
     /* 2049138 */   // Label 27293: @2049138
     /* 2049138 */   GIM_Try, /*On fail goto*//*Label 27294*/ GIMT_Encode4(2049229), // Rule ID 15260 //
     /* 2049143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2049154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2049157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2049160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049189 */     // MIs[0] round
     /* 2049189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049192 */     // MIs[0] policy
     /* 2049192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049228 */     // GIR_Coverage, 15260,
     /* 2049228 */     GIR_EraseRootFromParent_Done,
     /* 2049229 */   // Label 27294: @2049229
     /* 2049229 */   GIM_Try, /*On fail goto*//*Label 27295*/ GIMT_Encode4(2049320), // Rule ID 15261 //
     /* 2049234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2049245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2049248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2049251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049280 */     // MIs[0] round
     /* 2049280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049283 */     // MIs[0] policy
     /* 2049283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049319 */     // GIR_Coverage, 15261,
     /* 2049319 */     GIR_EraseRootFromParent_Done,
     /* 2049320 */   // Label 27295: @2049320
     /* 2049320 */   GIM_Try, /*On fail goto*//*Label 27296*/ GIMT_Encode4(2049411), // Rule ID 15264 //
     /* 2049325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2049336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2049339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2049342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049371 */     // MIs[0] round
     /* 2049371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049374 */     // MIs[0] policy
     /* 2049374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049384 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2049387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049410 */     // GIR_Coverage, 15264,
     /* 2049410 */     GIR_EraseRootFromParent_Done,
     /* 2049411 */   // Label 27296: @2049411
     /* 2049411 */   GIM_Try, /*On fail goto*//*Label 27297*/ GIMT_Encode4(2049502), // Rule ID 15265 //
     /* 2049416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2049427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2049430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2049433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049462 */     // MIs[0] round
     /* 2049462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049465 */     // MIs[0] policy
     /* 2049465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049475 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2049478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049501 */     // GIR_Coverage, 15265,
     /* 2049501 */     GIR_EraseRootFromParent_Done,
     /* 2049502 */   // Label 27297: @2049502
     /* 2049502 */   GIM_Try, /*On fail goto*//*Label 27298*/ GIMT_Encode4(2049593), // Rule ID 15268 //
     /* 2049507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2049518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2049521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2049524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049553 */     // MIs[0] round
     /* 2049553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049556 */     // MIs[0] policy
     /* 2049556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049566 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049592 */     // GIR_Coverage, 15268,
     /* 2049592 */     GIR_EraseRootFromParent_Done,
     /* 2049593 */   // Label 27298: @2049593
     /* 2049593 */   GIM_Try, /*On fail goto*//*Label 27299*/ GIMT_Encode4(2049684), // Rule ID 15269 //
     /* 2049598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2049609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2049612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2049615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049644 */     // MIs[0] round
     /* 2049644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049647 */     // MIs[0] policy
     /* 2049647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049657 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049683 */     // GIR_Coverage, 15269,
     /* 2049683 */     GIR_EraseRootFromParent_Done,
     /* 2049684 */   // Label 27299: @2049684
     /* 2049684 */   GIM_Try, /*On fail goto*//*Label 27300*/ GIMT_Encode4(2049775), // Rule ID 15272 //
     /* 2049689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2049700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2049703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2049706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049735 */     // MIs[0] round
     /* 2049735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049738 */     // MIs[0] policy
     /* 2049738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049774 */     // GIR_Coverage, 15272,
     /* 2049774 */     GIR_EraseRootFromParent_Done,
     /* 2049775 */   // Label 27300: @2049775
     /* 2049775 */   GIM_Try, /*On fail goto*//*Label 27301*/ GIMT_Encode4(2049866), // Rule ID 15273 //
     /* 2049780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2049791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2049794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2049797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049826 */     // MIs[0] round
     /* 2049826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049829 */     // MIs[0] policy
     /* 2049829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049865 */     // GIR_Coverage, 15273,
     /* 2049865 */     GIR_EraseRootFromParent_Done,
     /* 2049866 */   // Label 27301: @2049866
     /* 2049866 */   GIM_Try, /*On fail goto*//*Label 27302*/ GIMT_Encode4(2049957), // Rule ID 15276 //
     /* 2049871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2049882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2049885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2049888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049917 */     // MIs[0] round
     /* 2049917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049920 */     // MIs[0] policy
     /* 2049920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049930 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2049933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049956 */     // GIR_Coverage, 15276,
     /* 2049956 */     GIR_EraseRootFromParent_Done,
     /* 2049957 */   // Label 27302: @2049957
     /* 2049957 */   GIM_Try, /*On fail goto*//*Label 27303*/ GIMT_Encode4(2050048), // Rule ID 15277 //
     /* 2049962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2049973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2049976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2049979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050008 */     // MIs[0] round
     /* 2050008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050011 */     // MIs[0] policy
     /* 2050011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2050024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050047 */     // GIR_Coverage, 15277,
     /* 2050047 */     GIR_EraseRootFromParent_Done,
     /* 2050048 */   // Label 27303: @2050048
     /* 2050048 */   GIM_Try, /*On fail goto*//*Label 27304*/ GIMT_Encode4(2050139), // Rule ID 15280 //
     /* 2050053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2050064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2050067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2050070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2050076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050099 */     // MIs[0] round
     /* 2050099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050102 */     // MIs[0] policy
     /* 2050102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2050115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050138 */     // GIR_Coverage, 15280,
     /* 2050138 */     GIR_EraseRootFromParent_Done,
     /* 2050139 */   // Label 27304: @2050139
     /* 2050139 */   GIM_Try, /*On fail goto*//*Label 27305*/ GIMT_Encode4(2050230), // Rule ID 15281 //
     /* 2050144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2050155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2050158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2050161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2050167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050190 */     // MIs[0] round
     /* 2050190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050193 */     // MIs[0] policy
     /* 2050193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050203 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2050206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050229 */     // GIR_Coverage, 15281,
     /* 2050229 */     GIR_EraseRootFromParent_Done,
     /* 2050230 */   // Label 27305: @2050230
     /* 2050230 */   GIM_Try, /*On fail goto*//*Label 27306*/ GIMT_Encode4(2050321), // Rule ID 15284 //
     /* 2050235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2050238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2050246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2050249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2050252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050281 */     // MIs[0] round
     /* 2050281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050284 */     // MIs[0] policy
     /* 2050284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2050297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050320 */     // GIR_Coverage, 15284,
     /* 2050320 */     GIR_EraseRootFromParent_Done,
     /* 2050321 */   // Label 27306: @2050321
     /* 2050321 */   GIM_Try, /*On fail goto*//*Label 27307*/ GIMT_Encode4(2050412), // Rule ID 15285 //
     /* 2050326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2050337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2050340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2050343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050372 */     // MIs[0] round
     /* 2050372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050375 */     // MIs[0] policy
     /* 2050375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050385 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2050388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050411 */     // GIR_Coverage, 15285,
     /* 2050411 */     GIR_EraseRootFromParent_Done,
     /* 2050412 */   // Label 27307: @2050412
     /* 2050412 */   GIM_Try, /*On fail goto*//*Label 27308*/ GIMT_Encode4(2050503), // Rule ID 15288 //
     /* 2050417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2050420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2050428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2050431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2050434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050463 */     // MIs[0] round
     /* 2050463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050466 */     // MIs[0] policy
     /* 2050466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050476 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2050479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050502 */     // GIR_Coverage, 15288,
     /* 2050502 */     GIR_EraseRootFromParent_Done,
     /* 2050503 */   // Label 27308: @2050503
     /* 2050503 */   GIM_Try, /*On fail goto*//*Label 27309*/ GIMT_Encode4(2050594), // Rule ID 15289 //
     /* 2050508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2050519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2050522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2050525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050554 */     // MIs[0] round
     /* 2050554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050557 */     // MIs[0] policy
     /* 2050557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050567 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2050570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050593 */     // GIR_Coverage, 15289,
     /* 2050593 */     GIR_EraseRootFromParent_Done,
     /* 2050594 */   // Label 27309: @2050594
     /* 2050594 */   GIM_Try, /*On fail goto*//*Label 27310*/ GIMT_Encode4(2050685), // Rule ID 15292 //
     /* 2050599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2050602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2050610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2050613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2050616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050645 */     // MIs[0] round
     /* 2050645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050648 */     // MIs[0] policy
     /* 2050648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050658 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2050661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050684 */     // GIR_Coverage, 15292,
     /* 2050684 */     GIR_EraseRootFromParent_Done,
     /* 2050685 */   // Label 27310: @2050685
     /* 2050685 */   GIM_Try, /*On fail goto*//*Label 27311*/ GIMT_Encode4(2050776), // Rule ID 15293 //
     /* 2050690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2050701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2050704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2050707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050736 */     // MIs[0] round
     /* 2050736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050739 */     // MIs[0] policy
     /* 2050739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050749 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2050752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050775 */     // GIR_Coverage, 15293,
     /* 2050775 */     GIR_EraseRootFromParent_Done,
     /* 2050776 */   // Label 27311: @2050776
     /* 2050776 */   GIM_Try, /*On fail goto*//*Label 27312*/ GIMT_Encode4(2050867), // Rule ID 15296 //
     /* 2050781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2050792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2050795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2050798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2050801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050827 */     // MIs[0] round
     /* 2050827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050830 */     // MIs[0] policy
     /* 2050830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050840 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2050843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050866 */     // GIR_Coverage, 15296,
     /* 2050866 */     GIR_EraseRootFromParent_Done,
     /* 2050867 */   // Label 27312: @2050867
     /* 2050867 */   GIM_Try, /*On fail goto*//*Label 27313*/ GIMT_Encode4(2050958), // Rule ID 15297 //
     /* 2050872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2050883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2050886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2050889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2050892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050918 */     // MIs[0] round
     /* 2050918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050921 */     // MIs[0] policy
     /* 2050921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050931 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2050934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050957 */     // GIR_Coverage, 15297,
     /* 2050957 */     GIR_EraseRootFromParent_Done,
     /* 2050958 */   // Label 27313: @2050958
     /* 2050958 */   GIM_Try, /*On fail goto*//*Label 27314*/ GIMT_Encode4(2051049), // Rule ID 15300 //
     /* 2050963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2050974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2050977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2050980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2050983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051009 */     // MIs[0] round
     /* 2051009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051012 */     // MIs[0] policy
     /* 2051012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051022 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2051025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051048 */     // GIR_Coverage, 15300,
     /* 2051048 */     GIR_EraseRootFromParent_Done,
     /* 2051049 */   // Label 27314: @2051049
     /* 2051049 */   GIM_Try, /*On fail goto*//*Label 27315*/ GIMT_Encode4(2051140), // Rule ID 15301 //
     /* 2051054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2051065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2051068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2051071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2051074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051100 */     // MIs[0] round
     /* 2051100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051103 */     // MIs[0] policy
     /* 2051103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051113 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2051116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051139 */     // GIR_Coverage, 15301,
     /* 2051139 */     GIR_EraseRootFromParent_Done,
     /* 2051140 */   // Label 27315: @2051140
     /* 2051140 */   GIM_Try, /*On fail goto*//*Label 27316*/ GIMT_Encode4(2051231), // Rule ID 15304 //
     /* 2051145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2051156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2051159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2051162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2051165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051191 */     // MIs[0] round
     /* 2051191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051194 */     // MIs[0] policy
     /* 2051194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051204 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051230 */     // GIR_Coverage, 15304,
     /* 2051230 */     GIR_EraseRootFromParent_Done,
     /* 2051231 */   // Label 27316: @2051231
     /* 2051231 */   GIM_Try, /*On fail goto*//*Label 27317*/ GIMT_Encode4(2051322), // Rule ID 15305 //
     /* 2051236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2051247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2051250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2051253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2051256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051282 */     // MIs[0] round
     /* 2051282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051285 */     // MIs[0] policy
     /* 2051285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051295 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051321 */     // GIR_Coverage, 15305,
     /* 2051321 */     GIR_EraseRootFromParent_Done,
     /* 2051322 */   // Label 27317: @2051322
     /* 2051322 */   GIM_Try, /*On fail goto*//*Label 27318*/ GIMT_Encode4(2051413), // Rule ID 15308 //
     /* 2051327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2051338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2051341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2051344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2051347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051373 */     // MIs[0] round
     /* 2051373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051376 */     // MIs[0] policy
     /* 2051376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051386 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2051389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051412 */     // GIR_Coverage, 15308,
     /* 2051412 */     GIR_EraseRootFromParent_Done,
     /* 2051413 */   // Label 27318: @2051413
     /* 2051413 */   GIM_Try, /*On fail goto*//*Label 27319*/ GIMT_Encode4(2051504), // Rule ID 15309 //
     /* 2051418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2051429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2051432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2051435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2051438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051464 */     // MIs[0] round
     /* 2051464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051467 */     // MIs[0] policy
     /* 2051467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051477 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2051480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051503 */     // GIR_Coverage, 15309,
     /* 2051503 */     GIR_EraseRootFromParent_Done,
     /* 2051504 */   // Label 27319: @2051504
     /* 2051504 */   GIM_Try, /*On fail goto*//*Label 27320*/ GIMT_Encode4(2051595), // Rule ID 15312 //
     /* 2051509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2051520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2051523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2051526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2051529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051555 */     // MIs[0] round
     /* 2051555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051558 */     // MIs[0] policy
     /* 2051558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051568 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051594 */     // GIR_Coverage, 15312,
     /* 2051594 */     GIR_EraseRootFromParent_Done,
     /* 2051595 */   // Label 27320: @2051595
     /* 2051595 */   GIM_Try, /*On fail goto*//*Label 27321*/ GIMT_Encode4(2051686), // Rule ID 15313 //
     /* 2051600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2051611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2051614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2051617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2051620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051646 */     // MIs[0] round
     /* 2051646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051649 */     // MIs[0] policy
     /* 2051649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051659 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051685 */     // GIR_Coverage, 15313,
     /* 2051685 */     GIR_EraseRootFromParent_Done,
     /* 2051686 */   // Label 27321: @2051686
     /* 2051686 */   GIM_Try, /*On fail goto*//*Label 27322*/ GIMT_Encode4(2051777), // Rule ID 15316 //
     /* 2051691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2051702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2051705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2051708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2051711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051737 */     // MIs[0] round
     /* 2051737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051740 */     // MIs[0] policy
     /* 2051740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051750 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051776 */     // GIR_Coverage, 15316,
     /* 2051776 */     GIR_EraseRootFromParent_Done,
     /* 2051777 */   // Label 27322: @2051777
     /* 2051777 */   GIM_Try, /*On fail goto*//*Label 27323*/ GIMT_Encode4(2051868), // Rule ID 15317 //
     /* 2051782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2051793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2051796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2051799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2051802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051828 */     // MIs[0] round
     /* 2051828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051831 */     // MIs[0] policy
     /* 2051831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051841 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051867 */     // GIR_Coverage, 15317,
     /* 2051867 */     GIR_EraseRootFromParent_Done,
     /* 2051868 */   // Label 27323: @2051868
     /* 2051868 */   GIM_Try, /*On fail goto*//*Label 27324*/ GIMT_Encode4(2051959), // Rule ID 15320 //
     /* 2051873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2051884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2051887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2051890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2051893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051919 */     // MIs[0] round
     /* 2051919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051922 */     // MIs[0] policy
     /* 2051922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051932 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051958 */     // GIR_Coverage, 15320,
     /* 2051958 */     GIR_EraseRootFromParent_Done,
     /* 2051959 */   // Label 27324: @2051959
     /* 2051959 */   GIM_Try, /*On fail goto*//*Label 27325*/ GIMT_Encode4(2052050), // Rule ID 15321 //
     /* 2051964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2051975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2051978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2051981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2051984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052010 */     // MIs[0] round
     /* 2052010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052013 */     // MIs[0] policy
     /* 2052013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052023 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052049 */     // GIR_Coverage, 15321,
     /* 2052049 */     GIR_EraseRootFromParent_Done,
     /* 2052050 */   // Label 27325: @2052050
     /* 2052050 */   GIM_Try, /*On fail goto*//*Label 27326*/ GIMT_Encode4(2052141), // Rule ID 15324 //
     /* 2052055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2052066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2052069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2052072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2052075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2052078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052101 */     // MIs[0] round
     /* 2052101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052104 */     // MIs[0] policy
     /* 2052104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052140 */     // GIR_Coverage, 15324,
     /* 2052140 */     GIR_EraseRootFromParent_Done,
     /* 2052141 */   // Label 27326: @2052141
     /* 2052141 */   GIM_Try, /*On fail goto*//*Label 27327*/ GIMT_Encode4(2052232), // Rule ID 15325 //
     /* 2052146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2052157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2052160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2052163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2052166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2052169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052192 */     // MIs[0] round
     /* 2052192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052195 */     // MIs[0] policy
     /* 2052195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052205 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052231 */     // GIR_Coverage, 15325,
     /* 2052231 */     GIR_EraseRootFromParent_Done,
     /* 2052232 */   // Label 27327: @2052232
     /* 2052232 */   GIM_Try, /*On fail goto*//*Label 27328*/ GIMT_Encode4(2052323), // Rule ID 15328 //
     /* 2052237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2052248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2052251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2052254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2052257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2052260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052283 */     // MIs[0] round
     /* 2052283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052286 */     // MIs[0] policy
     /* 2052286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052322 */     // GIR_Coverage, 15328,
     /* 2052322 */     GIR_EraseRootFromParent_Done,
     /* 2052323 */   // Label 27328: @2052323
     /* 2052323 */   GIM_Try, /*On fail goto*//*Label 27329*/ GIMT_Encode4(2052414), // Rule ID 15329 //
     /* 2052328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2052339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2052342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2052345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2052348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2052351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052374 */     // MIs[0] round
     /* 2052374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052377 */     // MIs[0] policy
     /* 2052377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052387 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052413 */     // GIR_Coverage, 15329,
     /* 2052413 */     GIR_EraseRootFromParent_Done,
     /* 2052414 */   // Label 27329: @2052414
     /* 2052414 */   GIM_Try, /*On fail goto*//*Label 27330*/ GIMT_Encode4(2052505), // Rule ID 15332 //
     /* 2052419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2052422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2052430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2052433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2052436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2052439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052465 */     // MIs[0] round
     /* 2052465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052468 */     // MIs[0] policy
     /* 2052468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052478 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2052501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052504 */     // GIR_Coverage, 15332,
     /* 2052504 */     GIR_EraseRootFromParent_Done,
     /* 2052505 */   // Label 27330: @2052505
     /* 2052505 */   GIM_Try, /*On fail goto*//*Label 27331*/ GIMT_Encode4(2052596), // Rule ID 15333 //
     /* 2052510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2052513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2052521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2052524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2052527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2052530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052556 */     // MIs[0] round
     /* 2052556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052559 */     // MIs[0] policy
     /* 2052559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052569 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2052592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052595 */     // GIR_Coverage, 15333,
     /* 2052595 */     GIR_EraseRootFromParent_Done,
     /* 2052596 */   // Label 27331: @2052596
     /* 2052596 */   GIM_Try, /*On fail goto*//*Label 27332*/ GIMT_Encode4(2052687), // Rule ID 15336 //
     /* 2052601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2052612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2052615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2052618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2052621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052647 */     // MIs[0] round
     /* 2052647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052650 */     // MIs[0] policy
     /* 2052650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052660 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2052663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052686 */     // GIR_Coverage, 15336,
     /* 2052686 */     GIR_EraseRootFromParent_Done,
     /* 2052687 */   // Label 27332: @2052687
     /* 2052687 */   GIM_Try, /*On fail goto*//*Label 27333*/ GIMT_Encode4(2052778), // Rule ID 15337 //
     /* 2052692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2052703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2052706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2052709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2052712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052738 */     // MIs[0] round
     /* 2052738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052741 */     // MIs[0] policy
     /* 2052741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052751 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2052754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052777 */     // GIR_Coverage, 15337,
     /* 2052777 */     GIR_EraseRootFromParent_Done,
     /* 2052778 */   // Label 27333: @2052778
     /* 2052778 */   GIM_Try, /*On fail goto*//*Label 27334*/ GIMT_Encode4(2052869), // Rule ID 15340 //
     /* 2052783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2052794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2052797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2052800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2052803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052829 */     // MIs[0] round
     /* 2052829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052832 */     // MIs[0] policy
     /* 2052832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052842 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2052845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052868 */     // GIR_Coverage, 15340,
     /* 2052868 */     GIR_EraseRootFromParent_Done,
     /* 2052869 */   // Label 27334: @2052869
     /* 2052869 */   GIM_Try, /*On fail goto*//*Label 27335*/ GIMT_Encode4(2052960), // Rule ID 15341 //
     /* 2052874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2052885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2052888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2052891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2052894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052920 */     // MIs[0] round
     /* 2052920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052923 */     // MIs[0] policy
     /* 2052923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052933 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2052936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052959 */     // GIR_Coverage, 15341,
     /* 2052959 */     GIR_EraseRootFromParent_Done,
     /* 2052960 */   // Label 27335: @2052960
     /* 2052960 */   GIM_Try, /*On fail goto*//*Label 27336*/ GIMT_Encode4(2053051), // Rule ID 15344 //
     /* 2052965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2052976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2052979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2052982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2052985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2052988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2052995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053011 */     // MIs[0] round
     /* 2053011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053014 */     // MIs[0] policy
     /* 2053014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053024 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053050 */     // GIR_Coverage, 15344,
     /* 2053050 */     GIR_EraseRootFromParent_Done,
     /* 2053051 */   // Label 27336: @2053051
     /* 2053051 */   GIM_Try, /*On fail goto*//*Label 27337*/ GIMT_Encode4(2053142), // Rule ID 15345 //
     /* 2053056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2053067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2053070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2053073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2053076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2053079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053102 */     // MIs[0] round
     /* 2053102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053105 */     // MIs[0] policy
     /* 2053105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053115 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053141 */     // GIR_Coverage, 15345,
     /* 2053141 */     GIR_EraseRootFromParent_Done,
     /* 2053142 */   // Label 27337: @2053142
     /* 2053142 */   GIM_Try, /*On fail goto*//*Label 27338*/ GIMT_Encode4(2053233), // Rule ID 15348 //
     /* 2053147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2053158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2053161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2053164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2053167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053193 */     // MIs[0] round
     /* 2053193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053196 */     // MIs[0] policy
     /* 2053196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053232 */     // GIR_Coverage, 15348,
     /* 2053232 */     GIR_EraseRootFromParent_Done,
     /* 2053233 */   // Label 27338: @2053233
     /* 2053233 */   GIM_Try, /*On fail goto*//*Label 27339*/ GIMT_Encode4(2053324), // Rule ID 15349 //
     /* 2053238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2053249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2053252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2053255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2053258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053284 */     // MIs[0] round
     /* 2053284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053287 */     // MIs[0] policy
     /* 2053287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053297 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053323 */     // GIR_Coverage, 15349,
     /* 2053323 */     GIR_EraseRootFromParent_Done,
     /* 2053324 */   // Label 27339: @2053324
     /* 2053324 */   GIM_Try, /*On fail goto*//*Label 27340*/ GIMT_Encode4(2053415), // Rule ID 15352 //
     /* 2053329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2053340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2053343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2053346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2053349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053375 */     // MIs[0] round
     /* 2053375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053378 */     // MIs[0] policy
     /* 2053378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053388 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2053391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053414 */     // GIR_Coverage, 15352,
     /* 2053414 */     GIR_EraseRootFromParent_Done,
     /* 2053415 */   // Label 27340: @2053415
     /* 2053415 */   GIM_Try, /*On fail goto*//*Label 27341*/ GIMT_Encode4(2053506), // Rule ID 15353 //
     /* 2053420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2053431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2053434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2053437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2053440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053466 */     // MIs[0] round
     /* 2053466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053469 */     // MIs[0] policy
     /* 2053469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053479 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2053482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053505 */     // GIR_Coverage, 15353,
     /* 2053505 */     GIR_EraseRootFromParent_Done,
     /* 2053506 */   // Label 27341: @2053506
     /* 2053506 */   GIM_Try, /*On fail goto*//*Label 27342*/ GIMT_Encode4(2053597), // Rule ID 15356 //
     /* 2053511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2053522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2053525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2053528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2053531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053557 */     // MIs[0] round
     /* 2053557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053560 */     // MIs[0] policy
     /* 2053560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053570 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053596 */     // GIR_Coverage, 15356,
     /* 2053596 */     GIR_EraseRootFromParent_Done,
     /* 2053597 */   // Label 27342: @2053597
     /* 2053597 */   GIM_Try, /*On fail goto*//*Label 27343*/ GIMT_Encode4(2053688), // Rule ID 15357 //
     /* 2053602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2053613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2053616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2053619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2053622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053648 */     // MIs[0] round
     /* 2053648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053651 */     // MIs[0] policy
     /* 2053651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053661 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053687 */     // GIR_Coverage, 15357,
     /* 2053687 */     GIR_EraseRootFromParent_Done,
     /* 2053688 */   // Label 27343: @2053688
     /* 2053688 */   GIM_Try, /*On fail goto*//*Label 27344*/ GIMT_Encode4(2053779), // Rule ID 15360 //
     /* 2053693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2053704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2053707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2053710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2053713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053739 */     // MIs[0] round
     /* 2053739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053742 */     // MIs[0] policy
     /* 2053742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053778 */     // GIR_Coverage, 15360,
     /* 2053778 */     GIR_EraseRootFromParent_Done,
     /* 2053779 */   // Label 27344: @2053779
     /* 2053779 */   GIM_Try, /*On fail goto*//*Label 27345*/ GIMT_Encode4(2053870), // Rule ID 15361 //
     /* 2053784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2053795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2053798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2053801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2053804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053830 */     // MIs[0] round
     /* 2053830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053833 */     // MIs[0] policy
     /* 2053833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053843 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053869 */     // GIR_Coverage, 15361,
     /* 2053869 */     GIR_EraseRootFromParent_Done,
     /* 2053870 */   // Label 27345: @2053870
     /* 2053870 */   GIM_Try, /*On fail goto*//*Label 27346*/ GIMT_Encode4(2053961), // Rule ID 15364 //
     /* 2053875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2053886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2053889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2053892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2053895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053921 */     // MIs[0] round
     /* 2053921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053924 */     // MIs[0] policy
     /* 2053924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053934 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2053937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053960 */     // GIR_Coverage, 15364,
     /* 2053960 */     GIR_EraseRootFromParent_Done,
     /* 2053961 */   // Label 27346: @2053961
     /* 2053961 */   GIM_Try, /*On fail goto*//*Label 27347*/ GIMT_Encode4(2054052), // Rule ID 15365 //
     /* 2053966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2053977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2053980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2053983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2053986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054012 */     // MIs[0] round
     /* 2054012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054015 */     // MIs[0] policy
     /* 2054015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054025 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2054028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054051 */     // GIR_Coverage, 15365,
     /* 2054051 */     GIR_EraseRootFromParent_Done,
     /* 2054052 */   // Label 27347: @2054052
     /* 2054052 */   GIM_Try, /*On fail goto*//*Label 27348*/ GIMT_Encode4(2054143), // Rule ID 15368 //
     /* 2054057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2054068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2054071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2054074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2054077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2054080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054103 */     // MIs[0] round
     /* 2054103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054106 */     // MIs[0] policy
     /* 2054106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054116 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2054119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054142 */     // GIR_Coverage, 15368,
     /* 2054142 */     GIR_EraseRootFromParent_Done,
     /* 2054143 */   // Label 27348: @2054143
     /* 2054143 */   GIM_Try, /*On fail goto*//*Label 27349*/ GIMT_Encode4(2054234), // Rule ID 15369 //
     /* 2054148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2054159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2054162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2054165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2054168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2054171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054194 */     // MIs[0] round
     /* 2054194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054197 */     // MIs[0] policy
     /* 2054197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054207 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2054210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054233 */     // GIR_Coverage, 15369,
     /* 2054233 */     GIR_EraseRootFromParent_Done,
     /* 2054234 */   // Label 27349: @2054234
     /* 2054234 */   GIM_Try, /*On fail goto*//*Label 27350*/ GIMT_Encode4(2054325), // Rule ID 15372 //
     /* 2054239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2054242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2054250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2054253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2054256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2054259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054285 */     // MIs[0] round
     /* 2054285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054288 */     // MIs[0] policy
     /* 2054288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2054301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054324 */     // GIR_Coverage, 15372,
     /* 2054324 */     GIR_EraseRootFromParent_Done,
     /* 2054325 */   // Label 27350: @2054325
     /* 2054325 */   GIM_Try, /*On fail goto*//*Label 27351*/ GIMT_Encode4(2054416), // Rule ID 15373 //
     /* 2054330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2054341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2054344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2054347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2054350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054376 */     // MIs[0] round
     /* 2054376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054379 */     // MIs[0] policy
     /* 2054379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054389 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2054392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054415 */     // GIR_Coverage, 15373,
     /* 2054415 */     GIR_EraseRootFromParent_Done,
     /* 2054416 */   // Label 27351: @2054416
     /* 2054416 */   GIM_Try, /*On fail goto*//*Label 27352*/ GIMT_Encode4(2054507), // Rule ID 15376 //
     /* 2054421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2054424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2054432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2054435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2054438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2054441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054467 */     // MIs[0] round
     /* 2054467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054470 */     // MIs[0] policy
     /* 2054470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054480 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2054483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054506 */     // GIR_Coverage, 15376,
     /* 2054506 */     GIR_EraseRootFromParent_Done,
     /* 2054507 */   // Label 27352: @2054507
     /* 2054507 */   GIM_Try, /*On fail goto*//*Label 27353*/ GIMT_Encode4(2054598), // Rule ID 15377 //
     /* 2054512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2054523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2054526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2054529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2054532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054558 */     // MIs[0] round
     /* 2054558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054561 */     // MIs[0] policy
     /* 2054561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054571 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2054574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054597 */     // GIR_Coverage, 15377,
     /* 2054597 */     GIR_EraseRootFromParent_Done,
     /* 2054598 */   // Label 27353: @2054598
     /* 2054598 */   GIM_Try, /*On fail goto*//*Label 27354*/ GIMT_Encode4(2054689), // Rule ID 15380 //
     /* 2054603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2054606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2054614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2054617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2054620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2054623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054649 */     // MIs[0] round
     /* 2054649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054652 */     // MIs[0] policy
     /* 2054652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054662 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2054665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054688 */     // GIR_Coverage, 15380,
     /* 2054688 */     GIR_EraseRootFromParent_Done,
     /* 2054689 */   // Label 27354: @2054689
     /* 2054689 */   GIM_Try, /*On fail goto*//*Label 27355*/ GIMT_Encode4(2054780), // Rule ID 15381 //
     /* 2054694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2054705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2054708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2054711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2054714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054740 */     // MIs[0] round
     /* 2054740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054743 */     // MIs[0] policy
     /* 2054743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054753 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2054756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054779 */     // GIR_Coverage, 15381,
     /* 2054779 */     GIR_EraseRootFromParent_Done,
     /* 2054780 */   // Label 27355: @2054780
     /* 2054780 */   GIM_Try, /*On fail goto*//*Label 27356*/ GIMT_Encode4(2054871), // Rule ID 15384 //
     /* 2054785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2054796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2054799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2054802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054831 */     // MIs[0] round
     /* 2054831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054834 */     // MIs[0] policy
     /* 2054834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054844 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2054847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054870 */     // GIR_Coverage, 15384,
     /* 2054870 */     GIR_EraseRootFromParent_Done,
     /* 2054871 */   // Label 27356: @2054871
     /* 2054871 */   GIM_Try, /*On fail goto*//*Label 27357*/ GIMT_Encode4(2054962), // Rule ID 15385 //
     /* 2054876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2054887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2054890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2054893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054922 */     // MIs[0] round
     /* 2054922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054925 */     // MIs[0] policy
     /* 2054925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054935 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2054938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054961 */     // GIR_Coverage, 15385,
     /* 2054961 */     GIR_EraseRootFromParent_Done,
     /* 2054962 */   // Label 27357: @2054962
     /* 2054962 */   GIM_Try, /*On fail goto*//*Label 27358*/ GIMT_Encode4(2055053), // Rule ID 15388 //
     /* 2054967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2054978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2054981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2054984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055013 */     // MIs[0] round
     /* 2055013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055016 */     // MIs[0] policy
     /* 2055016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055026 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2055029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055052 */     // GIR_Coverage, 15388,
     /* 2055052 */     GIR_EraseRootFromParent_Done,
     /* 2055053 */   // Label 27358: @2055053
     /* 2055053 */   GIM_Try, /*On fail goto*//*Label 27359*/ GIMT_Encode4(2055144), // Rule ID 15389 //
     /* 2055058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2055069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2055072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2055075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055104 */     // MIs[0] round
     /* 2055104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055107 */     // MIs[0] policy
     /* 2055107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055117 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2055120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055143 */     // GIR_Coverage, 15389,
     /* 2055143 */     GIR_EraseRootFromParent_Done,
     /* 2055144 */   // Label 27359: @2055144
     /* 2055144 */   GIM_Try, /*On fail goto*//*Label 27360*/ GIMT_Encode4(2055235), // Rule ID 15392 //
     /* 2055149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2055160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2055163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2055166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055195 */     // MIs[0] round
     /* 2055195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055198 */     // MIs[0] policy
     /* 2055198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055234 */     // GIR_Coverage, 15392,
     /* 2055234 */     GIR_EraseRootFromParent_Done,
     /* 2055235 */   // Label 27360: @2055235
     /* 2055235 */   GIM_Try, /*On fail goto*//*Label 27361*/ GIMT_Encode4(2055326), // Rule ID 15393 //
     /* 2055240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2055251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2055254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2055257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055286 */     // MIs[0] round
     /* 2055286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055289 */     // MIs[0] policy
     /* 2055289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055299 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055325 */     // GIR_Coverage, 15393,
     /* 2055325 */     GIR_EraseRootFromParent_Done,
     /* 2055326 */   // Label 27361: @2055326
     /* 2055326 */   GIM_Try, /*On fail goto*//*Label 27362*/ GIMT_Encode4(2055417), // Rule ID 15396 //
     /* 2055331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2055342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2055345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2055348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055377 */     // MIs[0] round
     /* 2055377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055380 */     // MIs[0] policy
     /* 2055380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055390 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2055393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055416 */     // GIR_Coverage, 15396,
     /* 2055416 */     GIR_EraseRootFromParent_Done,
     /* 2055417 */   // Label 27362: @2055417
     /* 2055417 */   GIM_Try, /*On fail goto*//*Label 27363*/ GIMT_Encode4(2055508), // Rule ID 15397 //
     /* 2055422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2055433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2055436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2055439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055468 */     // MIs[0] round
     /* 2055468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055471 */     // MIs[0] policy
     /* 2055471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055481 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2055484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055507 */     // GIR_Coverage, 15397,
     /* 2055507 */     GIR_EraseRootFromParent_Done,
     /* 2055508 */   // Label 27363: @2055508
     /* 2055508 */   GIM_Try, /*On fail goto*//*Label 27364*/ GIMT_Encode4(2055599), // Rule ID 15400 //
     /* 2055513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2055524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2055527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2055530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055559 */     // MIs[0] round
     /* 2055559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055562 */     // MIs[0] policy
     /* 2055562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055572 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055598 */     // GIR_Coverage, 15400,
     /* 2055598 */     GIR_EraseRootFromParent_Done,
     /* 2055599 */   // Label 27364: @2055599
     /* 2055599 */   GIM_Try, /*On fail goto*//*Label 27365*/ GIMT_Encode4(2055690), // Rule ID 15401 //
     /* 2055604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2055615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2055618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2055621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055650 */     // MIs[0] round
     /* 2055650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055653 */     // MIs[0] policy
     /* 2055653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055663 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055689 */     // GIR_Coverage, 15401,
     /* 2055689 */     GIR_EraseRootFromParent_Done,
     /* 2055690 */   // Label 27365: @2055690
     /* 2055690 */   GIM_Try, /*On fail goto*//*Label 27366*/ GIMT_Encode4(2055781), // Rule ID 15404 //
     /* 2055695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2055706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2055709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2055712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055741 */     // MIs[0] round
     /* 2055741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055744 */     // MIs[0] policy
     /* 2055744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055754 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055780 */     // GIR_Coverage, 15404,
     /* 2055780 */     GIR_EraseRootFromParent_Done,
     /* 2055781 */   // Label 27366: @2055781
     /* 2055781 */   GIM_Try, /*On fail goto*//*Label 27367*/ GIMT_Encode4(2055872), // Rule ID 15405 //
     /* 2055786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2055797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2055800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2055803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055832 */     // MIs[0] round
     /* 2055832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055835 */     // MIs[0] policy
     /* 2055835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055845 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055871 */     // GIR_Coverage, 15405,
     /* 2055871 */     GIR_EraseRootFromParent_Done,
     /* 2055872 */   // Label 27367: @2055872
     /* 2055872 */   GIM_Try, /*On fail goto*//*Label 27368*/ GIMT_Encode4(2055963), // Rule ID 15408 //
     /* 2055877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2055888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2055891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2055894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055923 */     // MIs[0] round
     /* 2055923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055926 */     // MIs[0] policy
     /* 2055926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055936 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055962 */     // GIR_Coverage, 15408,
     /* 2055962 */     GIR_EraseRootFromParent_Done,
     /* 2055963 */   // Label 27368: @2055963
     /* 2055963 */   GIM_Try, /*On fail goto*//*Label 27369*/ GIMT_Encode4(2056054), // Rule ID 15409 //
     /* 2055968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2055979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2055982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2055985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056014 */     // MIs[0] round
     /* 2056014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056017 */     // MIs[0] policy
     /* 2056017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056053 */     // GIR_Coverage, 15409,
     /* 2056053 */     GIR_EraseRootFromParent_Done,
     /* 2056054 */   // Label 27369: @2056054
     /* 2056054 */   GIM_Try, /*On fail goto*//*Label 27370*/ GIMT_Encode4(2056145), // Rule ID 15412 //
     /* 2056059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2056070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2056073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2056076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2056082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056105 */     // MIs[0] round
     /* 2056105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056108 */     // MIs[0] policy
     /* 2056108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056118 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056144 */     // GIR_Coverage, 15412,
     /* 2056144 */     GIR_EraseRootFromParent_Done,
     /* 2056145 */   // Label 27370: @2056145
     /* 2056145 */   GIM_Try, /*On fail goto*//*Label 27371*/ GIMT_Encode4(2056236), // Rule ID 15413 //
     /* 2056150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2056161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2056164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2056167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2056173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056196 */     // MIs[0] round
     /* 2056196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056199 */     // MIs[0] policy
     /* 2056199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056209 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056235 */     // GIR_Coverage, 15413,
     /* 2056235 */     GIR_EraseRootFromParent_Done,
     /* 2056236 */   // Label 27371: @2056236
     /* 2056236 */   GIM_Try, /*On fail goto*//*Label 27372*/ GIMT_Encode4(2056327), // Rule ID 15416 //
     /* 2056241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2056252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2056255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2056258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2056264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056287 */     // MIs[0] round
     /* 2056287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056290 */     // MIs[0] policy
     /* 2056290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2056323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056326 */     // GIR_Coverage, 15416,
     /* 2056326 */     GIR_EraseRootFromParent_Done,
     /* 2056327 */   // Label 27372: @2056327
     /* 2056327 */   GIM_Try, /*On fail goto*//*Label 27373*/ GIMT_Encode4(2056418), // Rule ID 15417 //
     /* 2056332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2056343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2056346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2056349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2056355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056378 */     // MIs[0] round
     /* 2056378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056381 */     // MIs[0] policy
     /* 2056381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056391 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2056414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056417 */     // GIR_Coverage, 15417,
     /* 2056417 */     GIR_EraseRootFromParent_Done,
     /* 2056418 */   // Label 27373: @2056418
     /* 2056418 */   GIM_Try, /*On fail goto*//*Label 27374*/ GIMT_Encode4(2056509), // Rule ID 15420 //
     /* 2056423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2056426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2056434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2056437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2056440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056469 */     // MIs[0] round
     /* 2056469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056472 */     // MIs[0] policy
     /* 2056472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056508 */     // GIR_Coverage, 15420,
     /* 2056508 */     GIR_EraseRootFromParent_Done,
     /* 2056509 */   // Label 27374: @2056509
     /* 2056509 */   GIM_Try, /*On fail goto*//*Label 27375*/ GIMT_Encode4(2056600), // Rule ID 15421 //
     /* 2056514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2056517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2056525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2056528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2056531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056560 */     // MIs[0] round
     /* 2056560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056563 */     // MIs[0] policy
     /* 2056563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056573 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056599 */     // GIR_Coverage, 15421,
     /* 2056599 */     GIR_EraseRootFromParent_Done,
     /* 2056600 */   // Label 27375: @2056600
     /* 2056600 */   GIM_Try, /*On fail goto*//*Label 27376*/ GIMT_Encode4(2056691), // Rule ID 15424 //
     /* 2056605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2056616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2056619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2056622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056651 */     // MIs[0] round
     /* 2056651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056654 */     // MIs[0] policy
     /* 2056654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056664 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2056667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056690 */     // GIR_Coverage, 15424,
     /* 2056690 */     GIR_EraseRootFromParent_Done,
     /* 2056691 */   // Label 27376: @2056691
     /* 2056691 */   GIM_Try, /*On fail goto*//*Label 27377*/ GIMT_Encode4(2056782), // Rule ID 15425 //
     /* 2056696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2056707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2056710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2056713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056742 */     // MIs[0] round
     /* 2056742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056745 */     // MIs[0] policy
     /* 2056745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056755 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2056758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056781 */     // GIR_Coverage, 15425,
     /* 2056781 */     GIR_EraseRootFromParent_Done,
     /* 2056782 */   // Label 27377: @2056782
     /* 2056782 */   GIM_Try, /*On fail goto*//*Label 27378*/ GIMT_Encode4(2056873), // Rule ID 15428 //
     /* 2056787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2056798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2056801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2056804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056833 */     // MIs[0] round
     /* 2056833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056836 */     // MIs[0] policy
     /* 2056836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2056849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056872 */     // GIR_Coverage, 15428,
     /* 2056872 */     GIR_EraseRootFromParent_Done,
     /* 2056873 */   // Label 27378: @2056873
     /* 2056873 */   GIM_Try, /*On fail goto*//*Label 27379*/ GIMT_Encode4(2056964), // Rule ID 15429 //
     /* 2056878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2056889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2056892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2056895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056924 */     // MIs[0] round
     /* 2056924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056927 */     // MIs[0] policy
     /* 2056927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056937 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2056940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056963 */     // GIR_Coverage, 15429,
     /* 2056963 */     GIR_EraseRootFromParent_Done,
     /* 2056964 */   // Label 27379: @2056964
     /* 2056964 */   GIM_Try, /*On fail goto*//*Label 27380*/ GIMT_Encode4(2057055), // Rule ID 15432 //
     /* 2056969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2056980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2056983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2056986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2056992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2056999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057015 */     // MIs[0] round
     /* 2057015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057018 */     // MIs[0] policy
     /* 2057018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057028 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057054 */     // GIR_Coverage, 15432,
     /* 2057054 */     GIR_EraseRootFromParent_Done,
     /* 2057055 */   // Label 27380: @2057055
     /* 2057055 */   GIM_Try, /*On fail goto*//*Label 27381*/ GIMT_Encode4(2057146), // Rule ID 15433 //
     /* 2057060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2057071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2057074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2057077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2057083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057106 */     // MIs[0] round
     /* 2057106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057109 */     // MIs[0] policy
     /* 2057109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057119 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057145 */     // GIR_Coverage, 15433,
     /* 2057145 */     GIR_EraseRootFromParent_Done,
     /* 2057146 */   // Label 27381: @2057146
     /* 2057146 */   GIM_Try, /*On fail goto*//*Label 27382*/ GIMT_Encode4(2057237), // Rule ID 15436 //
     /* 2057151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2057162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2057165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2057168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057197 */     // MIs[0] round
     /* 2057197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057200 */     // MIs[0] policy
     /* 2057200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057236 */     // GIR_Coverage, 15436,
     /* 2057236 */     GIR_EraseRootFromParent_Done,
     /* 2057237 */   // Label 27382: @2057237
     /* 2057237 */   GIM_Try, /*On fail goto*//*Label 27383*/ GIMT_Encode4(2057328), // Rule ID 15437 //
     /* 2057242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2057253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2057256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2057259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057288 */     // MIs[0] round
     /* 2057288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057291 */     // MIs[0] policy
     /* 2057291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057301 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057327 */     // GIR_Coverage, 15437,
     /* 2057327 */     GIR_EraseRootFromParent_Done,
     /* 2057328 */   // Label 27383: @2057328
     /* 2057328 */   GIM_Try, /*On fail goto*//*Label 27384*/ GIMT_Encode4(2057419), // Rule ID 15440 //
     /* 2057333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2057344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2057347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2057350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057379 */     // MIs[0] round
     /* 2057379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057382 */     // MIs[0] policy
     /* 2057382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057392 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2057395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057418 */     // GIR_Coverage, 15440,
     /* 2057418 */     GIR_EraseRootFromParent_Done,
     /* 2057419 */   // Label 27384: @2057419
     /* 2057419 */   GIM_Try, /*On fail goto*//*Label 27385*/ GIMT_Encode4(2057510), // Rule ID 15441 //
     /* 2057424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2057435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2057438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2057441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057470 */     // MIs[0] round
     /* 2057470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057473 */     // MIs[0] policy
     /* 2057473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057483 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2057486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057509 */     // GIR_Coverage, 15441,
     /* 2057509 */     GIR_EraseRootFromParent_Done,
     /* 2057510 */   // Label 27385: @2057510
     /* 2057510 */   GIM_Try, /*On fail goto*//*Label 27386*/ GIMT_Encode4(2057601), // Rule ID 15444 //
     /* 2057515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2057526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2057529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2057532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057561 */     // MIs[0] round
     /* 2057561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057564 */     // MIs[0] policy
     /* 2057564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057574 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057600 */     // GIR_Coverage, 15444,
     /* 2057600 */     GIR_EraseRootFromParent_Done,
     /* 2057601 */   // Label 27386: @2057601
     /* 2057601 */   GIM_Try, /*On fail goto*//*Label 27387*/ GIMT_Encode4(2057692), // Rule ID 15445 //
     /* 2057606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2057617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2057620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2057623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057652 */     // MIs[0] round
     /* 2057652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057655 */     // MIs[0] policy
     /* 2057655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057665 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057691 */     // GIR_Coverage, 15445,
     /* 2057691 */     GIR_EraseRootFromParent_Done,
     /* 2057692 */   // Label 27387: @2057692
     /* 2057692 */   GIM_Try, /*On fail goto*//*Label 27388*/ GIMT_Encode4(2057783), // Rule ID 15448 //
     /* 2057697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2057708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2057711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2057714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057743 */     // MIs[0] round
     /* 2057743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057746 */     // MIs[0] policy
     /* 2057746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057782 */     // GIR_Coverage, 15448,
     /* 2057782 */     GIR_EraseRootFromParent_Done,
     /* 2057783 */   // Label 27388: @2057783
     /* 2057783 */   GIM_Try, /*On fail goto*//*Label 27389*/ GIMT_Encode4(2057874), // Rule ID 15449 //
     /* 2057788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2057799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2057802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2057805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057834 */     // MIs[0] round
     /* 2057834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057837 */     // MIs[0] policy
     /* 2057837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057847 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057873 */     // GIR_Coverage, 15449,
     /* 2057873 */     GIR_EraseRootFromParent_Done,
     /* 2057874 */   // Label 27389: @2057874
     /* 2057874 */   GIM_Try, /*On fail goto*//*Label 27390*/ GIMT_Encode4(2057965), // Rule ID 15452 //
     /* 2057879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2057890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2057893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2057896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057925 */     // MIs[0] round
     /* 2057925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057928 */     // MIs[0] policy
     /* 2057928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057938 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2057941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057964 */     // GIR_Coverage, 15452,
     /* 2057964 */     GIR_EraseRootFromParent_Done,
     /* 2057965 */   // Label 27390: @2057965
     /* 2057965 */   GIM_Try, /*On fail goto*//*Label 27391*/ GIMT_Encode4(2058056), // Rule ID 15453 //
     /* 2057970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2057981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2057984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2057987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058016 */     // MIs[0] round
     /* 2058016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058019 */     // MIs[0] policy
     /* 2058019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058029 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2058032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058055 */     // GIR_Coverage, 15453,
     /* 2058055 */     GIR_EraseRootFromParent_Done,
     /* 2058056 */   // Label 27391: @2058056
     /* 2058056 */   GIM_Try, /*On fail goto*//*Label 27392*/ GIMT_Encode4(2058147), // Rule ID 15456 //
     /* 2058061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2058072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2058075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2058078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2058084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058107 */     // MIs[0] round
     /* 2058107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058110 */     // MIs[0] policy
     /* 2058110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058120 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2058123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058146 */     // GIR_Coverage, 15456,
     /* 2058146 */     GIR_EraseRootFromParent_Done,
     /* 2058147 */   // Label 27392: @2058147
     /* 2058147 */   GIM_Try, /*On fail goto*//*Label 27393*/ GIMT_Encode4(2058238), // Rule ID 15457 //
     /* 2058152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2058163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2058166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2058169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2058175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058198 */     // MIs[0] round
     /* 2058198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058201 */     // MIs[0] policy
     /* 2058201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058211 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2058214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058237 */     // GIR_Coverage, 15457,
     /* 2058237 */     GIR_EraseRootFromParent_Done,
     /* 2058238 */   // Label 27393: @2058238
     /* 2058238 */   GIM_Try, /*On fail goto*//*Label 27394*/ GIMT_Encode4(2058329), // Rule ID 15460 //
     /* 2058243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2058246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2058254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2058257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2058260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2058273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058289 */     // MIs[0] round
     /* 2058289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058292 */     // MIs[0] policy
     /* 2058292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2058305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058328 */     // GIR_Coverage, 15460,
     /* 2058328 */     GIR_EraseRootFromParent_Done,
     /* 2058329 */   // Label 27394: @2058329
     /* 2058329 */   GIM_Try, /*On fail goto*//*Label 27395*/ GIMT_Encode4(2058420), // Rule ID 15461 //
     /* 2058334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2058337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2058345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2058348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2058351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2058364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058380 */     // MIs[0] round
     /* 2058380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058383 */     // MIs[0] policy
     /* 2058383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058393 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2058396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058419 */     // GIR_Coverage, 15461,
     /* 2058419 */     GIR_EraseRootFromParent_Done,
     /* 2058420 */   // Label 27395: @2058420
     /* 2058420 */   GIM_Try, /*On fail goto*//*Label 27396*/ GIMT_Encode4(2058511), // Rule ID 15464 //
     /* 2058425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2058428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2058436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2058439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2058442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058471 */     // MIs[0] round
     /* 2058471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058474 */     // MIs[0] policy
     /* 2058474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2058487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058510 */     // GIR_Coverage, 15464,
     /* 2058510 */     GIR_EraseRootFromParent_Done,
     /* 2058511 */   // Label 27396: @2058511
     /* 2058511 */   GIM_Try, /*On fail goto*//*Label 27397*/ GIMT_Encode4(2058602), // Rule ID 15465 //
     /* 2058516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2058519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2058527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2058530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2058533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058562 */     // MIs[0] round
     /* 2058562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058565 */     // MIs[0] policy
     /* 2058565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058575 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2058578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058601 */     // GIR_Coverage, 15465,
     /* 2058601 */     GIR_EraseRootFromParent_Done,
     /* 2058602 */   // Label 27397: @2058602
     /* 2058602 */   GIM_Try, /*On fail goto*//*Label 27398*/ GIMT_Encode4(2058693), // Rule ID 15468 //
     /* 2058607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2058610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2058618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2058621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2058624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058653 */     // MIs[0] round
     /* 2058653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058656 */     // MIs[0] policy
     /* 2058656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058666 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2058669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058692 */     // GIR_Coverage, 15468,
     /* 2058692 */     GIR_EraseRootFromParent_Done,
     /* 2058693 */   // Label 27398: @2058693
     /* 2058693 */   GIM_Try, /*On fail goto*//*Label 27399*/ GIMT_Encode4(2058784), // Rule ID 15469 //
     /* 2058698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2058701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2058709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2058712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2058715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058744 */     // MIs[0] round
     /* 2058744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058747 */     // MIs[0] policy
     /* 2058747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058757 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2058760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058783 */     // GIR_Coverage, 15469,
     /* 2058783 */     GIR_EraseRootFromParent_Done,
     /* 2058784 */   // Label 27399: @2058784
     /* 2058784 */   GIM_Try, /*On fail goto*//*Label 27400*/ GIMT_Encode4(2058875), // Rule ID 15472 //
     /* 2058789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2058800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2058803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2058806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2058809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058835 */     // MIs[0] round
     /* 2058835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058838 */     // MIs[0] policy
     /* 2058838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058848 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2058851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058874 */     // GIR_Coverage, 15472,
     /* 2058874 */     GIR_EraseRootFromParent_Done,
     /* 2058875 */   // Label 27400: @2058875
     /* 2058875 */   GIM_Try, /*On fail goto*//*Label 27401*/ GIMT_Encode4(2058966), // Rule ID 15473 //
     /* 2058880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2058891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2058894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2058897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2058900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058926 */     // MIs[0] round
     /* 2058926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058929 */     // MIs[0] policy
     /* 2058929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058939 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2058942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058965 */     // GIR_Coverage, 15473,
     /* 2058965 */     GIR_EraseRootFromParent_Done,
     /* 2058966 */   // Label 27401: @2058966
     /* 2058966 */   GIM_Try, /*On fail goto*//*Label 27402*/ GIMT_Encode4(2059057), // Rule ID 15476 //
     /* 2058971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2058982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2058985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2058988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2058991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059017 */     // MIs[0] round
     /* 2059017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059020 */     // MIs[0] policy
     /* 2059020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059030 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2059033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059056 */     // GIR_Coverage, 15476,
     /* 2059056 */     GIR_EraseRootFromParent_Done,
     /* 2059057 */   // Label 27402: @2059057
     /* 2059057 */   GIM_Try, /*On fail goto*//*Label 27403*/ GIMT_Encode4(2059148), // Rule ID 15477 //
     /* 2059062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2059073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2059076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2059079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2059082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059108 */     // MIs[0] round
     /* 2059108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059111 */     // MIs[0] policy
     /* 2059111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2059124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059147 */     // GIR_Coverage, 15477,
     /* 2059147 */     GIR_EraseRootFromParent_Done,
     /* 2059148 */   // Label 27403: @2059148
     /* 2059148 */   GIM_Try, /*On fail goto*//*Label 27404*/ GIMT_Encode4(2059239), // Rule ID 15480 //
     /* 2059153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2059164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2059167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2059170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2059173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059199 */     // MIs[0] round
     /* 2059199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059202 */     // MIs[0] policy
     /* 2059202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059212 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059238 */     // GIR_Coverage, 15480,
     /* 2059238 */     GIR_EraseRootFromParent_Done,
     /* 2059239 */   // Label 27404: @2059239
     /* 2059239 */   GIM_Try, /*On fail goto*//*Label 27405*/ GIMT_Encode4(2059330), // Rule ID 15481 //
     /* 2059244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2059255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2059258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2059261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2059264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059290 */     // MIs[0] round
     /* 2059290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059293 */     // MIs[0] policy
     /* 2059293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059303 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059329 */     // GIR_Coverage, 15481,
     /* 2059329 */     GIR_EraseRootFromParent_Done,
     /* 2059330 */   // Label 27405: @2059330
     /* 2059330 */   GIM_Try, /*On fail goto*//*Label 27406*/ GIMT_Encode4(2059421), // Rule ID 15484 //
     /* 2059335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2059346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2059349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2059352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2059355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059381 */     // MIs[0] round
     /* 2059381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059384 */     // MIs[0] policy
     /* 2059384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059394 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2059397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059420 */     // GIR_Coverage, 15484,
     /* 2059420 */     GIR_EraseRootFromParent_Done,
     /* 2059421 */   // Label 27406: @2059421
     /* 2059421 */   GIM_Try, /*On fail goto*//*Label 27407*/ GIMT_Encode4(2059512), // Rule ID 15485 //
     /* 2059426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2059437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2059440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2059443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2059446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059472 */     // MIs[0] round
     /* 2059472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059475 */     // MIs[0] policy
     /* 2059475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059485 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2059488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059511 */     // GIR_Coverage, 15485,
     /* 2059511 */     GIR_EraseRootFromParent_Done,
     /* 2059512 */   // Label 27407: @2059512
     /* 2059512 */   GIM_Try, /*On fail goto*//*Label 27408*/ GIMT_Encode4(2059603), // Rule ID 15488 //
     /* 2059517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2059528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2059531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2059534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2059537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059563 */     // MIs[0] round
     /* 2059563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059566 */     // MIs[0] policy
     /* 2059566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059576 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059602 */     // GIR_Coverage, 15488,
     /* 2059602 */     GIR_EraseRootFromParent_Done,
     /* 2059603 */   // Label 27408: @2059603
     /* 2059603 */   GIM_Try, /*On fail goto*//*Label 27409*/ GIMT_Encode4(2059694), // Rule ID 15489 //
     /* 2059608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2059619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2059622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2059625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2059628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059654 */     // MIs[0] round
     /* 2059654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059657 */     // MIs[0] policy
     /* 2059657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059667 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059693 */     // GIR_Coverage, 15489,
     /* 2059693 */     GIR_EraseRootFromParent_Done,
     /* 2059694 */   // Label 27409: @2059694
     /* 2059694 */   GIM_Try, /*On fail goto*//*Label 27410*/ GIMT_Encode4(2059785), // Rule ID 15492 //
     /* 2059699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2059716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2059719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059745 */     // MIs[0] round
     /* 2059745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059748 */     // MIs[0] policy
     /* 2059748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059758 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059784 */     // GIR_Coverage, 15492,
     /* 2059784 */     GIR_EraseRootFromParent_Done,
     /* 2059785 */   // Label 27410: @2059785
     /* 2059785 */   GIM_Try, /*On fail goto*//*Label 27411*/ GIMT_Encode4(2059876), // Rule ID 15493 //
     /* 2059790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2059807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2059810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059836 */     // MIs[0] round
     /* 2059836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059839 */     // MIs[0] policy
     /* 2059839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059849 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059875 */     // GIR_Coverage, 15493,
     /* 2059875 */     GIR_EraseRootFromParent_Done,
     /* 2059876 */   // Label 27411: @2059876
     /* 2059876 */   GIM_Try, /*On fail goto*//*Label 27412*/ GIMT_Encode4(2059967), // Rule ID 15496 //
     /* 2059881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2059892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2059895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2059898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2059901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059927 */     // MIs[0] round
     /* 2059927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059930 */     // MIs[0] policy
     /* 2059930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059940 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059966 */     // GIR_Coverage, 15496,
     /* 2059966 */     GIR_EraseRootFromParent_Done,
     /* 2059967 */   // Label 27412: @2059967
     /* 2059967 */   GIM_Try, /*On fail goto*//*Label 27413*/ GIMT_Encode4(2060058), // Rule ID 15497 //
     /* 2059972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2059983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2059986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2059989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2059992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060018 */     // MIs[0] round
     /* 2060018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060021 */     // MIs[0] policy
     /* 2060021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060031 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060057 */     // GIR_Coverage, 15497,
     /* 2060057 */     GIR_EraseRootFromParent_Done,
     /* 2060058 */   // Label 27413: @2060058
     /* 2060058 */   GIM_Try, /*On fail goto*//*Label 27414*/ GIMT_Encode4(2060149), // Rule ID 15500 //
     /* 2060063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2060074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2060077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2060080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2060083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2060086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060109 */     // MIs[0] round
     /* 2060109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060112 */     // MIs[0] policy
     /* 2060112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060122 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060148 */     // GIR_Coverage, 15500,
     /* 2060148 */     GIR_EraseRootFromParent_Done,
     /* 2060149 */   // Label 27414: @2060149
     /* 2060149 */   GIM_Try, /*On fail goto*//*Label 27415*/ GIMT_Encode4(2060240), // Rule ID 15501 //
     /* 2060154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2060165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2060168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2060171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2060174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2060177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060200 */     // MIs[0] round
     /* 2060200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060203 */     // MIs[0] policy
     /* 2060203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060213 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060239 */     // GIR_Coverage, 15501,
     /* 2060239 */     GIR_EraseRootFromParent_Done,
     /* 2060240 */   // Label 27415: @2060240
     /* 2060240 */   GIM_Try, /*On fail goto*//*Label 27416*/ GIMT_Encode4(2060331), // Rule ID 15504 //
     /* 2060245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2060256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2060259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2060262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2060265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2060268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060291 */     // MIs[0] round
     /* 2060291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060294 */     // MIs[0] policy
     /* 2060294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2060327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060330 */     // GIR_Coverage, 15504,
     /* 2060330 */     GIR_EraseRootFromParent_Done,
     /* 2060331 */   // Label 27416: @2060331
     /* 2060331 */   GIM_Try, /*On fail goto*//*Label 27417*/ GIMT_Encode4(2060422), // Rule ID 15505 //
     /* 2060336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2060347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2060350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2060353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2060356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2060359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060382 */     // MIs[0] round
     /* 2060382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060385 */     // MIs[0] policy
     /* 2060385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060395 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2060418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060421 */     // GIR_Coverage, 15505,
     /* 2060421 */     GIR_EraseRootFromParent_Done,
     /* 2060422 */   // Label 27417: @2060422
     /* 2060422 */   GIM_Try, /*On fail goto*//*Label 27418*/ GIMT_Encode4(2060513), // Rule ID 15508 //
     /* 2060427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2060430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2060438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2060441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2060444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2060447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2060450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060473 */     // MIs[0] round
     /* 2060473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060476 */     // MIs[0] policy
     /* 2060476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060486 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2060509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060512 */     // GIR_Coverage, 15508,
     /* 2060512 */     GIR_EraseRootFromParent_Done,
     /* 2060513 */   // Label 27418: @2060513
     /* 2060513 */   GIM_Try, /*On fail goto*//*Label 27419*/ GIMT_Encode4(2060604), // Rule ID 15509 //
     /* 2060518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2060521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2060529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2060532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2060535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2060538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2060541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060564 */     // MIs[0] round
     /* 2060564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060567 */     // MIs[0] policy
     /* 2060567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060577 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2060600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060603 */     // GIR_Coverage, 15509,
     /* 2060603 */     GIR_EraseRootFromParent_Done,
     /* 2060604 */   // Label 27419: @2060604
     /* 2060604 */   GIM_Try, /*On fail goto*//*Label 27420*/ GIMT_Encode4(2060695), // Rule ID 15512 //
     /* 2060609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2060620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2060623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2060626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2060629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060655 */     // MIs[0] round
     /* 2060655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060658 */     // MIs[0] policy
     /* 2060658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060668 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2060671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060694 */     // GIR_Coverage, 15512,
     /* 2060694 */     GIR_EraseRootFromParent_Done,
     /* 2060695 */   // Label 27420: @2060695
     /* 2060695 */   GIM_Try, /*On fail goto*//*Label 27421*/ GIMT_Encode4(2060786), // Rule ID 15513 //
     /* 2060700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2060711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2060714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2060717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2060720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060746 */     // MIs[0] round
     /* 2060746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060749 */     // MIs[0] policy
     /* 2060749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060759 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2060762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060785 */     // GIR_Coverage, 15513,
     /* 2060785 */     GIR_EraseRootFromParent_Done,
     /* 2060786 */   // Label 27421: @2060786
     /* 2060786 */   GIM_Try, /*On fail goto*//*Label 27422*/ GIMT_Encode4(2060877), // Rule ID 15516 //
     /* 2060791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2060802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2060805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2060808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2060811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060837 */     // MIs[0] round
     /* 2060837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060840 */     // MIs[0] policy
     /* 2060840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060850 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2060853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060876 */     // GIR_Coverage, 15516,
     /* 2060876 */     GIR_EraseRootFromParent_Done,
     /* 2060877 */   // Label 27422: @2060877
     /* 2060877 */   GIM_Try, /*On fail goto*//*Label 27423*/ GIMT_Encode4(2060968), // Rule ID 15517 //
     /* 2060882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2060893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2060896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2060899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2060902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060928 */     // MIs[0] round
     /* 2060928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060931 */     // MIs[0] policy
     /* 2060931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060941 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2060944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060967 */     // GIR_Coverage, 15517,
     /* 2060967 */     GIR_EraseRootFromParent_Done,
     /* 2060968 */   // Label 27423: @2060968
     /* 2060968 */   GIM_Try, /*On fail goto*//*Label 27424*/ GIMT_Encode4(2061059), // Rule ID 15520 //
     /* 2060973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2060984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2060987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2060990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2060993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2060996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061019 */     // MIs[0] round
     /* 2061019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061022 */     // MIs[0] policy
     /* 2061022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061032 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2061055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061058 */     // GIR_Coverage, 15520,
     /* 2061058 */     GIR_EraseRootFromParent_Done,
     /* 2061059 */   // Label 27424: @2061059
     /* 2061059 */   GIM_Try, /*On fail goto*//*Label 27425*/ GIMT_Encode4(2061150), // Rule ID 15521 //
     /* 2061064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2061075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2061078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2061081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2061084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2061087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061110 */     // MIs[0] round
     /* 2061110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061113 */     // MIs[0] policy
     /* 2061113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061123 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2061146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061149 */     // GIR_Coverage, 15521,
     /* 2061149 */     GIR_EraseRootFromParent_Done,
     /* 2061150 */   // Label 27425: @2061150
     /* 2061150 */   GIM_Try, /*On fail goto*//*Label 27426*/ GIMT_Encode4(2061241), // Rule ID 15524 //
     /* 2061155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2061166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2061169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2061172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2061175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061201 */     // MIs[0] round
     /* 2061201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061204 */     // MIs[0] policy
     /* 2061204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061214 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061240 */     // GIR_Coverage, 15524,
     /* 2061240 */     GIR_EraseRootFromParent_Done,
     /* 2061241 */   // Label 27426: @2061241
     /* 2061241 */   GIM_Try, /*On fail goto*//*Label 27427*/ GIMT_Encode4(2061332), // Rule ID 15525 //
     /* 2061246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2061257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2061260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2061263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2061266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061292 */     // MIs[0] round
     /* 2061292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061295 */     // MIs[0] policy
     /* 2061295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061305 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061331 */     // GIR_Coverage, 15525,
     /* 2061331 */     GIR_EraseRootFromParent_Done,
     /* 2061332 */   // Label 27427: @2061332
     /* 2061332 */   GIM_Try, /*On fail goto*//*Label 27428*/ GIMT_Encode4(2061423), // Rule ID 15528 //
     /* 2061337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2061348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2061351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2061354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2061357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061383 */     // MIs[0] round
     /* 2061383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061386 */     // MIs[0] policy
     /* 2061386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2061399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061422 */     // GIR_Coverage, 15528,
     /* 2061422 */     GIR_EraseRootFromParent_Done,
     /* 2061423 */   // Label 27428: @2061423
     /* 2061423 */   GIM_Try, /*On fail goto*//*Label 27429*/ GIMT_Encode4(2061514), // Rule ID 15529 //
     /* 2061428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2061439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2061442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2061445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2061448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061474 */     // MIs[0] round
     /* 2061474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061477 */     // MIs[0] policy
     /* 2061477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061487 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2061490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061513 */     // GIR_Coverage, 15529,
     /* 2061513 */     GIR_EraseRootFromParent_Done,
     /* 2061514 */   // Label 27429: @2061514
     /* 2061514 */   GIM_Try, /*On fail goto*//*Label 27430*/ GIMT_Encode4(2061605), // Rule ID 15532 //
     /* 2061519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2061530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2061533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2061536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2061539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2061542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061565 */     // MIs[0] round
     /* 2061565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061568 */     // MIs[0] policy
     /* 2061568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061578 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061604 */     // GIR_Coverage, 15532,
     /* 2061604 */     GIR_EraseRootFromParent_Done,
     /* 2061605 */   // Label 27430: @2061605
     /* 2061605 */   GIM_Try, /*On fail goto*//*Label 27431*/ GIMT_Encode4(2061696), // Rule ID 15533 //
     /* 2061610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2061621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2061624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2061627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2061630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2061633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061656 */     // MIs[0] round
     /* 2061656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061659 */     // MIs[0] policy
     /* 2061659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061669 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061695 */     // GIR_Coverage, 15533,
     /* 2061695 */     GIR_EraseRootFromParent_Done,
     /* 2061696 */   // Label 27431: @2061696
     /* 2061696 */   GIM_Try, /*On fail goto*//*Label 27432*/ GIMT_Encode4(2061787), // Rule ID 15536 //
     /* 2061701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2061712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2061715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2061718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2061721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061747 */     // MIs[0] round
     /* 2061747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061750 */     // MIs[0] policy
     /* 2061750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061786 */     // GIR_Coverage, 15536,
     /* 2061786 */     GIR_EraseRootFromParent_Done,
     /* 2061787 */   // Label 27432: @2061787
     /* 2061787 */   GIM_Try, /*On fail goto*//*Label 27433*/ GIMT_Encode4(2061878), // Rule ID 15537 //
     /* 2061792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2061803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2061806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2061809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2061812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061838 */     // MIs[0] round
     /* 2061838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061841 */     // MIs[0] policy
     /* 2061841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061877 */     // GIR_Coverage, 15537,
     /* 2061877 */     GIR_EraseRootFromParent_Done,
     /* 2061878 */   // Label 27433: @2061878
     /* 2061878 */   GIM_Try, /*On fail goto*//*Label 27434*/ GIMT_Encode4(2061969), // Rule ID 15540 //
     /* 2061883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2061900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2061903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061929 */     // MIs[0] round
     /* 2061929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061932 */     // MIs[0] policy
     /* 2061932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061942 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2061945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061968 */     // GIR_Coverage, 15540,
     /* 2061968 */     GIR_EraseRootFromParent_Done,
     /* 2061969 */   // Label 27434: @2061969
     /* 2061969 */   GIM_Try, /*On fail goto*//*Label 27435*/ GIMT_Encode4(2062060), // Rule ID 15541 //
     /* 2061974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2061991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2061994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2062004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062020 */     // MIs[0] round
     /* 2062020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062023 */     // MIs[0] policy
     /* 2062023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062033 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2062036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062059 */     // GIR_Coverage, 15541,
     /* 2062059 */     GIR_EraseRootFromParent_Done,
     /* 2062060 */   // Label 27435: @2062060
     /* 2062060 */   GIM_Try, /*On fail goto*//*Label 27436*/ GIMT_Encode4(2062151), // Rule ID 15544 //
     /* 2062065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2062076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2062079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2062082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2062085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2062088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062111 */     // MIs[0] round
     /* 2062111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062114 */     // MIs[0] policy
     /* 2062114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062124 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2062127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062150 */     // GIR_Coverage, 15544,
     /* 2062150 */     GIR_EraseRootFromParent_Done,
     /* 2062151 */   // Label 27436: @2062151
     /* 2062151 */   GIM_Try, /*On fail goto*//*Label 27437*/ GIMT_Encode4(2062242), // Rule ID 15545 //
     /* 2062156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2062167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2062170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2062173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2062176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2062179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062202 */     // MIs[0] round
     /* 2062202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062205 */     // MIs[0] policy
     /* 2062205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062215 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2062218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062241 */     // GIR_Coverage, 15545,
     /* 2062241 */     GIR_EraseRootFromParent_Done,
     /* 2062242 */   // Label 27437: @2062242
     /* 2062242 */   GIM_Try, /*On fail goto*//*Label 27438*/ GIMT_Encode4(2062333), // Rule ID 15548 //
     /* 2062247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2062250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2062258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2062261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2062264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2062267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2062277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062293 */     // MIs[0] round
     /* 2062293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062296 */     // MIs[0] policy
     /* 2062296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2062309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062332 */     // GIR_Coverage, 15548,
     /* 2062332 */     GIR_EraseRootFromParent_Done,
     /* 2062333 */   // Label 27438: @2062333
     /* 2062333 */   GIM_Try, /*On fail goto*//*Label 27439*/ GIMT_Encode4(2062424), // Rule ID 15549 //
     /* 2062338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2062341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2062349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2062352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2062355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2062358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2062368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062384 */     // MIs[0] round
     /* 2062384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062387 */     // MIs[0] policy
     /* 2062387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062397 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2062400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062423 */     // GIR_Coverage, 15549,
     /* 2062423 */     GIR_EraseRootFromParent_Done,
     /* 2062424 */   // Label 27439: @2062424
     /* 2062424 */   GIM_Try, /*On fail goto*//*Label 27440*/ GIMT_Encode4(2062515), // Rule ID 15552 //
     /* 2062429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2062432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2062440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2062443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2062446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2062449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2062459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062475 */     // MIs[0] round
     /* 2062475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062478 */     // MIs[0] policy
     /* 2062478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062488 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2062491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062514 */     // GIR_Coverage, 15552,
     /* 2062514 */     GIR_EraseRootFromParent_Done,
     /* 2062515 */   // Label 27440: @2062515
     /* 2062515 */   GIM_Try, /*On fail goto*//*Label 27441*/ GIMT_Encode4(2062606), // Rule ID 15553 //
     /* 2062520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2062523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2062531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2062534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2062537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2062540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2062550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062566 */     // MIs[0] round
     /* 2062566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062569 */     // MIs[0] policy
     /* 2062569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062579 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2062582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062605 */     // GIR_Coverage, 15553,
     /* 2062605 */     GIR_EraseRootFromParent_Done,
     /* 2062606 */   // Label 27441: @2062606
     /* 2062606 */   GIM_Try, /*On fail goto*//*Label 27442*/ GIMT_Encode4(2062697), // Rule ID 15556 //
     /* 2062611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2062614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2062622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2062625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2062628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2062631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062657 */     // MIs[0] round
     /* 2062657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062660 */     // MIs[0] policy
     /* 2062660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062670 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2062673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062696 */     // GIR_Coverage, 15556,
     /* 2062696 */     GIR_EraseRootFromParent_Done,
     /* 2062697 */   // Label 27442: @2062697
     /* 2062697 */   GIM_Try, /*On fail goto*//*Label 27443*/ GIMT_Encode4(2062788), // Rule ID 15557 //
     /* 2062702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2062705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2062713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2062716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2062719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2062722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062748 */     // MIs[0] round
     /* 2062748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062751 */     // MIs[0] policy
     /* 2062751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062761 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2062764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062787 */     // GIR_Coverage, 15557,
     /* 2062787 */     GIR_EraseRootFromParent_Done,
     /* 2062788 */   // Label 27443: @2062788
     /* 2062788 */   GIM_Try, /*On fail goto*//*Label 27444*/ GIMT_Encode4(2062879), // Rule ID 15560 //
     /* 2062793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2062804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2062807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2062810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062839 */     // MIs[0] round
     /* 2062839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062842 */     // MIs[0] policy
     /* 2062842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062852 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2062855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062878 */     // GIR_Coverage, 15560,
     /* 2062878 */     GIR_EraseRootFromParent_Done,
     /* 2062879 */   // Label 27444: @2062879
     /* 2062879 */   GIM_Try, /*On fail goto*//*Label 27445*/ GIMT_Encode4(2062970), // Rule ID 15561 //
     /* 2062884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2062895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2062898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2062901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062930 */     // MIs[0] round
     /* 2062930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062933 */     // MIs[0] policy
     /* 2062933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062943 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2062946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062969 */     // GIR_Coverage, 15561,
     /* 2062969 */     GIR_EraseRootFromParent_Done,
     /* 2062970 */   // Label 27445: @2062970
     /* 2062970 */   GIM_Try, /*On fail goto*//*Label 27446*/ GIMT_Encode4(2063061), // Rule ID 15564 //
     /* 2062975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2062986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2062989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2062992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063021 */     // MIs[0] round
     /* 2063021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063024 */     // MIs[0] policy
     /* 2063024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063034 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2063037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063060 */     // GIR_Coverage, 15564,
     /* 2063060 */     GIR_EraseRootFromParent_Done,
     /* 2063061 */   // Label 27446: @2063061
     /* 2063061 */   GIM_Try, /*On fail goto*//*Label 27447*/ GIMT_Encode4(2063152), // Rule ID 15565 //
     /* 2063066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2063077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2063080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2063083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063112 */     // MIs[0] round
     /* 2063112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063115 */     // MIs[0] policy
     /* 2063115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063125 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2063128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063151 */     // GIR_Coverage, 15565,
     /* 2063151 */     GIR_EraseRootFromParent_Done,
     /* 2063152 */   // Label 27447: @2063152
     /* 2063152 */   GIM_Try, /*On fail goto*//*Label 27448*/ GIMT_Encode4(2063243), // Rule ID 15568 //
     /* 2063157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2063168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2063171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2063174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063203 */     // MIs[0] round
     /* 2063203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063206 */     // MIs[0] policy
     /* 2063206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063216 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063242 */     // GIR_Coverage, 15568,
     /* 2063242 */     GIR_EraseRootFromParent_Done,
     /* 2063243 */   // Label 27448: @2063243
     /* 2063243 */   GIM_Try, /*On fail goto*//*Label 27449*/ GIMT_Encode4(2063334), // Rule ID 15569 //
     /* 2063248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2063259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2063262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2063265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063294 */     // MIs[0] round
     /* 2063294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063297 */     // MIs[0] policy
     /* 2063297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063307 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063333 */     // GIR_Coverage, 15569,
     /* 2063333 */     GIR_EraseRootFromParent_Done,
     /* 2063334 */   // Label 27449: @2063334
     /* 2063334 */   GIM_Try, /*On fail goto*//*Label 27450*/ GIMT_Encode4(2063425), // Rule ID 15572 //
     /* 2063339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2063350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2063353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2063356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063385 */     // MIs[0] round
     /* 2063385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063388 */     // MIs[0] policy
     /* 2063388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063398 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2063401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063424 */     // GIR_Coverage, 15572,
     /* 2063424 */     GIR_EraseRootFromParent_Done,
     /* 2063425 */   // Label 27450: @2063425
     /* 2063425 */   GIM_Try, /*On fail goto*//*Label 27451*/ GIMT_Encode4(2063516), // Rule ID 15573 //
     /* 2063430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2063441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2063444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2063447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063476 */     // MIs[0] round
     /* 2063476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063479 */     // MIs[0] policy
     /* 2063479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063489 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2063492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063515 */     // GIR_Coverage, 15573,
     /* 2063515 */     GIR_EraseRootFromParent_Done,
     /* 2063516 */   // Label 27451: @2063516
     /* 2063516 */   GIM_Try, /*On fail goto*//*Label 27452*/ GIMT_Encode4(2063607), // Rule ID 15576 //
     /* 2063521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2063532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2063535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2063538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063567 */     // MIs[0] round
     /* 2063567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063570 */     // MIs[0] policy
     /* 2063570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063580 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063606 */     // GIR_Coverage, 15576,
     /* 2063606 */     GIR_EraseRootFromParent_Done,
     /* 2063607 */   // Label 27452: @2063607
     /* 2063607 */   GIM_Try, /*On fail goto*//*Label 27453*/ GIMT_Encode4(2063698), // Rule ID 15577 //
     /* 2063612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2063623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2063626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2063629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063658 */     // MIs[0] round
     /* 2063658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063661 */     // MIs[0] policy
     /* 2063661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063697 */     // GIR_Coverage, 15577,
     /* 2063697 */     GIR_EraseRootFromParent_Done,
     /* 2063698 */   // Label 27453: @2063698
     /* 2063698 */   GIM_Try, /*On fail goto*//*Label 27454*/ GIMT_Encode4(2063789), // Rule ID 15580 //
     /* 2063703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2063714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2063717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2063720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063749 */     // MIs[0] round
     /* 2063749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063752 */     // MIs[0] policy
     /* 2063752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063762 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063788 */     // GIR_Coverage, 15580,
     /* 2063788 */     GIR_EraseRootFromParent_Done,
     /* 2063789 */   // Label 27454: @2063789
     /* 2063789 */   GIM_Try, /*On fail goto*//*Label 27455*/ GIMT_Encode4(2063880), // Rule ID 15581 //
     /* 2063794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2063805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2063808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2063811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063840 */     // MIs[0] round
     /* 2063840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063843 */     // MIs[0] policy
     /* 2063843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063853 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063879 */     // GIR_Coverage, 15581,
     /* 2063879 */     GIR_EraseRootFromParent_Done,
     /* 2063880 */   // Label 27455: @2063880
     /* 2063880 */   GIM_Try, /*On fail goto*//*Label 27456*/ GIMT_Encode4(2063971), // Rule ID 15584 //
     /* 2063885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2063896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2063899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2063902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063931 */     // MIs[0] round
     /* 2063931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063934 */     // MIs[0] policy
     /* 2063934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063970 */     // GIR_Coverage, 15584,
     /* 2063970 */     GIR_EraseRootFromParent_Done,
     /* 2063971 */   // Label 27456: @2063971
     /* 2063971 */   GIM_Try, /*On fail goto*//*Label 27457*/ GIMT_Encode4(2064062), // Rule ID 15585 //
     /* 2063976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2063987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2063990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2063993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064022 */     // MIs[0] round
     /* 2064022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064025 */     // MIs[0] policy
     /* 2064025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064035 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064061 */     // GIR_Coverage, 15585,
     /* 2064061 */     GIR_EraseRootFromParent_Done,
     /* 2064062 */   // Label 27457: @2064062
     /* 2064062 */   GIM_Try, /*On fail goto*//*Label 27458*/ GIMT_Encode4(2064153), // Rule ID 15588 //
     /* 2064067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2064078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2064081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2064084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2064090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064113 */     // MIs[0] round
     /* 2064113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064116 */     // MIs[0] policy
     /* 2064116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064126 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064152 */     // GIR_Coverage, 15588,
     /* 2064152 */     GIR_EraseRootFromParent_Done,
     /* 2064153 */   // Label 27458: @2064153
     /* 2064153 */   GIM_Try, /*On fail goto*//*Label 27459*/ GIMT_Encode4(2064244), // Rule ID 15589 //
     /* 2064158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2064169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2064172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2064175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2064181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064204 */     // MIs[0] round
     /* 2064204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064207 */     // MIs[0] policy
     /* 2064207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064217 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064243 */     // GIR_Coverage, 15589,
     /* 2064243 */     GIR_EraseRootFromParent_Done,
     /* 2064244 */   // Label 27459: @2064244
     /* 2064244 */   GIM_Try, /*On fail goto*//*Label 27460*/ GIMT_Encode4(2064335), // Rule ID 15592 //
     /* 2064249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2064260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2064263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2064266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064295 */     // MIs[0] round
     /* 2064295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064298 */     // MIs[0] policy
     /* 2064298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064308 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2064331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064334 */     // GIR_Coverage, 15592,
     /* 2064334 */     GIR_EraseRootFromParent_Done,
     /* 2064335 */   // Label 27460: @2064335
     /* 2064335 */   GIM_Try, /*On fail goto*//*Label 27461*/ GIMT_Encode4(2064426), // Rule ID 15593 //
     /* 2064340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2064351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2064354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2064357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064386 */     // MIs[0] round
     /* 2064386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064389 */     // MIs[0] policy
     /* 2064389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064399 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2064422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064425 */     // GIR_Coverage, 15593,
     /* 2064425 */     GIR_EraseRootFromParent_Done,
     /* 2064426 */   // Label 27461: @2064426
     /* 2064426 */   GIM_Try, /*On fail goto*//*Label 27462*/ GIMT_Encode4(2064517), // Rule ID 15596 //
     /* 2064431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2064434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2064442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2064445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2064448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2064454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064477 */     // MIs[0] round
     /* 2064477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064480 */     // MIs[0] policy
     /* 2064480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064516 */     // GIR_Coverage, 15596,
     /* 2064516 */     GIR_EraseRootFromParent_Done,
     /* 2064517 */   // Label 27462: @2064517
     /* 2064517 */   GIM_Try, /*On fail goto*//*Label 27463*/ GIMT_Encode4(2064608), // Rule ID 15597 //
     /* 2064522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2064525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2064533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2064536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2064539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2064545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064568 */     // MIs[0] round
     /* 2064568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064571 */     // MIs[0] policy
     /* 2064571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064581 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064607 */     // GIR_Coverage, 15597,
     /* 2064607 */     GIR_EraseRootFromParent_Done,
     /* 2064608 */   // Label 27463: @2064608
     /* 2064608 */   GIM_Try, /*On fail goto*//*Label 27464*/ GIMT_Encode4(2064699), // Rule ID 15600 //
     /* 2064613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2064624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2064627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2064630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064659 */     // MIs[0] round
     /* 2064659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064662 */     // MIs[0] policy
     /* 2064662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064672 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2064675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064698 */     // GIR_Coverage, 15600,
     /* 2064698 */     GIR_EraseRootFromParent_Done,
     /* 2064699 */   // Label 27464: @2064699
     /* 2064699 */   GIM_Try, /*On fail goto*//*Label 27465*/ GIMT_Encode4(2064790), // Rule ID 15601 //
     /* 2064704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2064715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2064718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2064721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064750 */     // MIs[0] round
     /* 2064750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064753 */     // MIs[0] policy
     /* 2064753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064763 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2064766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064789 */     // GIR_Coverage, 15601,
     /* 2064789 */     GIR_EraseRootFromParent_Done,
     /* 2064790 */   // Label 27465: @2064790
     /* 2064790 */   GIM_Try, /*On fail goto*//*Label 27466*/ GIMT_Encode4(2064881), // Rule ID 15604 //
     /* 2064795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2064806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2064809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2064812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064841 */     // MIs[0] round
     /* 2064841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064844 */     // MIs[0] policy
     /* 2064844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064854 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2064857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064880 */     // GIR_Coverage, 15604,
     /* 2064880 */     GIR_EraseRootFromParent_Done,
     /* 2064881 */   // Label 27466: @2064881
     /* 2064881 */   GIM_Try, /*On fail goto*//*Label 27467*/ GIMT_Encode4(2064972), // Rule ID 15605 //
     /* 2064886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2064897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2064900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2064903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064932 */     // MIs[0] round
     /* 2064932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064935 */     // MIs[0] policy
     /* 2064935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064945 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2064948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064971 */     // GIR_Coverage, 15605,
     /* 2064971 */     GIR_EraseRootFromParent_Done,
     /* 2064972 */   // Label 27467: @2064972
     /* 2064972 */   GIM_Try, /*On fail goto*//*Label 27468*/ GIMT_Encode4(2065063), // Rule ID 15608 //
     /* 2064977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2064988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2064991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2064994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2065000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065023 */     // MIs[0] round
     /* 2065023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065026 */     // MIs[0] policy
     /* 2065026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065036 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2065059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065062 */     // GIR_Coverage, 15608,
     /* 2065062 */     GIR_EraseRootFromParent_Done,
     /* 2065063 */   // Label 27468: @2065063
     /* 2065063 */   GIM_Try, /*On fail goto*//*Label 27469*/ GIMT_Encode4(2065154), // Rule ID 15609 //
     /* 2065068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2065079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2065082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2065085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2065091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065114 */     // MIs[0] round
     /* 2065114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065117 */     // MIs[0] policy
     /* 2065117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065127 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2065150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065153 */     // GIR_Coverage, 15609,
     /* 2065153 */     GIR_EraseRootFromParent_Done,
     /* 2065154 */   // Label 27469: @2065154
     /* 2065154 */   GIM_Try, /*On fail goto*//*Label 27470*/ GIMT_Encode4(2065245), // Rule ID 15612 //
     /* 2065159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2065170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2065173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2065176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065205 */     // MIs[0] round
     /* 2065205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065208 */     // MIs[0] policy
     /* 2065208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065244 */     // GIR_Coverage, 15612,
     /* 2065244 */     GIR_EraseRootFromParent_Done,
     /* 2065245 */   // Label 27470: @2065245
     /* 2065245 */   GIM_Try, /*On fail goto*//*Label 27471*/ GIMT_Encode4(2065336), // Rule ID 15613 //
     /* 2065250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2065261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2065264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2065267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065296 */     // MIs[0] round
     /* 2065296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065299 */     // MIs[0] policy
     /* 2065299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065309 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065335 */     // GIR_Coverage, 15613,
     /* 2065335 */     GIR_EraseRootFromParent_Done,
     /* 2065336 */   // Label 27471: @2065336
     /* 2065336 */   GIM_Try, /*On fail goto*//*Label 27472*/ GIMT_Encode4(2065427), // Rule ID 15616 //
     /* 2065341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2065352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2065355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2065358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065387 */     // MIs[0] round
     /* 2065387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065390 */     // MIs[0] policy
     /* 2065390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2065403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065426 */     // GIR_Coverage, 15616,
     /* 2065426 */     GIR_EraseRootFromParent_Done,
     /* 2065427 */   // Label 27472: @2065427
     /* 2065427 */   GIM_Try, /*On fail goto*//*Label 27473*/ GIMT_Encode4(2065518), // Rule ID 15617 //
     /* 2065432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2065443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2065446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2065449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065478 */     // MIs[0] round
     /* 2065478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065481 */     // MIs[0] policy
     /* 2065481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065491 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2065494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065517 */     // GIR_Coverage, 15617,
     /* 2065517 */     GIR_EraseRootFromParent_Done,
     /* 2065518 */   // Label 27473: @2065518
     /* 2065518 */   GIM_Try, /*On fail goto*//*Label 27474*/ GIMT_Encode4(2065609), // Rule ID 15620 //
     /* 2065523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2065534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2065537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2065540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065569 */     // MIs[0] round
     /* 2065569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065572 */     // MIs[0] policy
     /* 2065572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065582 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065608 */     // GIR_Coverage, 15620,
     /* 2065608 */     GIR_EraseRootFromParent_Done,
     /* 2065609 */   // Label 27474: @2065609
     /* 2065609 */   GIM_Try, /*On fail goto*//*Label 27475*/ GIMT_Encode4(2065700), // Rule ID 15621 //
     /* 2065614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2065625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2065628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2065631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065660 */     // MIs[0] round
     /* 2065660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065663 */     // MIs[0] policy
     /* 2065663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065673 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065699 */     // GIR_Coverage, 15621,
     /* 2065699 */     GIR_EraseRootFromParent_Done,
     /* 2065700 */   // Label 27475: @2065700
     /* 2065700 */   GIM_Try, /*On fail goto*//*Label 27476*/ GIMT_Encode4(2065791), // Rule ID 15624 //
     /* 2065705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2065716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2065719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2065722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065751 */     // MIs[0] round
     /* 2065751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065754 */     // MIs[0] policy
     /* 2065754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065790 */     // GIR_Coverage, 15624,
     /* 2065790 */     GIR_EraseRootFromParent_Done,
     /* 2065791 */   // Label 27476: @2065791
     /* 2065791 */   GIM_Try, /*On fail goto*//*Label 27477*/ GIMT_Encode4(2065882), // Rule ID 15625 //
     /* 2065796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2065807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2065810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2065813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065842 */     // MIs[0] round
     /* 2065842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065845 */     // MIs[0] policy
     /* 2065845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065855 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065881 */     // GIR_Coverage, 15625,
     /* 2065881 */     GIR_EraseRootFromParent_Done,
     /* 2065882 */   // Label 27477: @2065882
     /* 2065882 */   GIM_Try, /*On fail goto*//*Label 27478*/ GIMT_Encode4(2065973), // Rule ID 15628 //
     /* 2065887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2065898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2065901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2065904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065933 */     // MIs[0] round
     /* 2065933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065936 */     // MIs[0] policy
     /* 2065936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2065949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065972 */     // GIR_Coverage, 15628,
     /* 2065972 */     GIR_EraseRootFromParent_Done,
     /* 2065973 */   // Label 27478: @2065973
     /* 2065973 */   GIM_Try, /*On fail goto*//*Label 27479*/ GIMT_Encode4(2066064), // Rule ID 15629 //
     /* 2065978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2065989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2065992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2065995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066024 */     // MIs[0] round
     /* 2066024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066027 */     // MIs[0] policy
     /* 2066027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066037 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2066040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066063 */     // GIR_Coverage, 15629,
     /* 2066063 */     GIR_EraseRootFromParent_Done,
     /* 2066064 */   // Label 27479: @2066064
     /* 2066064 */   GIM_Try, /*On fail goto*//*Label 27480*/ GIMT_Encode4(2066155), // Rule ID 15632 //
     /* 2066069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2066080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2066083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2066086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2066092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066115 */     // MIs[0] round
     /* 2066115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066118 */     // MIs[0] policy
     /* 2066118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066128 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2066131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066154 */     // GIR_Coverage, 15632,
     /* 2066154 */     GIR_EraseRootFromParent_Done,
     /* 2066155 */   // Label 27480: @2066155
     /* 2066155 */   GIM_Try, /*On fail goto*//*Label 27481*/ GIMT_Encode4(2066246), // Rule ID 15633 //
     /* 2066160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2066171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2066174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2066177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2066183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066206 */     // MIs[0] round
     /* 2066206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066209 */     // MIs[0] policy
     /* 2066209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066219 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2066222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066245 */     // GIR_Coverage, 15633,
     /* 2066245 */     GIR_EraseRootFromParent_Done,
     /* 2066246 */   // Label 27481: @2066246
     /* 2066246 */   GIM_Try, /*On fail goto*//*Label 27482*/ GIMT_Encode4(2066337), // Rule ID 15636 //
     /* 2066251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2066254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2066262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2066265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2066268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066297 */     // MIs[0] round
     /* 2066297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066300 */     // MIs[0] policy
     /* 2066300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066310 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2066313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066336 */     // GIR_Coverage, 15636,
     /* 2066336 */     GIR_EraseRootFromParent_Done,
     /* 2066337 */   // Label 27482: @2066337
     /* 2066337 */   GIM_Try, /*On fail goto*//*Label 27483*/ GIMT_Encode4(2066428), // Rule ID 15637 //
     /* 2066342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2066345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2066353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2066356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2066359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066388 */     // MIs[0] round
     /* 2066388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066391 */     // MIs[0] policy
     /* 2066391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066401 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2066404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066427 */     // GIR_Coverage, 15637,
     /* 2066427 */     GIR_EraseRootFromParent_Done,
     /* 2066428 */   // Label 27483: @2066428
     /* 2066428 */   GIM_Try, /*On fail goto*//*Label 27484*/ GIMT_Encode4(2066519), // Rule ID 15640 //
     /* 2066433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2066436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2066444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2066447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2066450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066479 */     // MIs[0] round
     /* 2066479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066482 */     // MIs[0] policy
     /* 2066482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066492 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2066495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066518 */     // GIR_Coverage, 15640,
     /* 2066518 */     GIR_EraseRootFromParent_Done,
     /* 2066519 */   // Label 27484: @2066519
     /* 2066519 */   GIM_Try, /*On fail goto*//*Label 27485*/ GIMT_Encode4(2066610), // Rule ID 15641 //
     /* 2066524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2066527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2066535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2066538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2066541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066570 */     // MIs[0] round
     /* 2066570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066573 */     // MIs[0] policy
     /* 2066573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066583 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2066586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066609 */     // GIR_Coverage, 15641,
     /* 2066609 */     GIR_EraseRootFromParent_Done,
     /* 2066610 */   // Label 27485: @2066610
     /* 2066610 */   GIM_Try, /*On fail goto*//*Label 27486*/ GIMT_Encode4(2066701), // Rule ID 15644 //
     /* 2066615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2066618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2066626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2066629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2066632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066661 */     // MIs[0] round
     /* 2066661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066664 */     // MIs[0] policy
     /* 2066664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066674 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2066677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066700 */     // GIR_Coverage, 15644,
     /* 2066700 */     GIR_EraseRootFromParent_Done,
     /* 2066701 */   // Label 27486: @2066701
     /* 2066701 */   GIM_Try, /*On fail goto*//*Label 27487*/ GIMT_Encode4(2066792), // Rule ID 15645 //
     /* 2066706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2066709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2066717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2066720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2066723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066752 */     // MIs[0] round
     /* 2066752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066755 */     // MIs[0] policy
     /* 2066755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066765 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2066768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066791 */     // GIR_Coverage, 15645,
     /* 2066791 */     GIR_EraseRootFromParent_Done,
     /* 2066792 */   // Label 27487: @2066792
     /* 2066792 */   GIM_Try, /*On fail goto*//*Label 27488*/ GIMT_Encode4(2066886), // Rule ID 15648 //
     /* 2066797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2066808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2066811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2066814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2066817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066843 */     // MIs[0] round
     /* 2066843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066846 */     // MIs[0] policy
     /* 2066846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066856 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2066859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066885 */     // GIR_Coverage, 15648,
     /* 2066885 */     GIR_EraseRootFromParent_Done,
     /* 2066886 */   // Label 27488: @2066886
     /* 2066886 */   GIM_Try, /*On fail goto*//*Label 27489*/ GIMT_Encode4(2066980), // Rule ID 15649 //
     /* 2066891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2066902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2066905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2066908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2066911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066937 */     // MIs[0] round
     /* 2066937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066940 */     // MIs[0] policy
     /* 2066940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066950 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2066953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066979 */     // GIR_Coverage, 15649,
     /* 2066979 */     GIR_EraseRootFromParent_Done,
     /* 2066980 */   // Label 27489: @2066980
     /* 2066980 */   GIM_Try, /*On fail goto*//*Label 27490*/ GIMT_Encode4(2067074), // Rule ID 15652 //
     /* 2066985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2066996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2066999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2067002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2067005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067031 */     // MIs[0] round
     /* 2067031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067034 */     // MIs[0] policy
     /* 2067034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067044 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2067047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067073 */     // GIR_Coverage, 15652,
     /* 2067073 */     GIR_EraseRootFromParent_Done,
     /* 2067074 */   // Label 27490: @2067074
     /* 2067074 */   GIM_Try, /*On fail goto*//*Label 27491*/ GIMT_Encode4(2067168), // Rule ID 15653 //
     /* 2067079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2067090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2067093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2067096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2067099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067125 */     // MIs[0] round
     /* 2067125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067128 */     // MIs[0] policy
     /* 2067128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067138 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2067141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067167 */     // GIR_Coverage, 15653,
     /* 2067167 */     GIR_EraseRootFromParent_Done,
     /* 2067168 */   // Label 27491: @2067168
     /* 2067168 */   GIM_Try, /*On fail goto*//*Label 27492*/ GIMT_Encode4(2067262), // Rule ID 15656 //
     /* 2067173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2067184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2067187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2067190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2067193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067219 */     // MIs[0] round
     /* 2067219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067222 */     // MIs[0] policy
     /* 2067222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067232 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067261 */     // GIR_Coverage, 15656,
     /* 2067261 */     GIR_EraseRootFromParent_Done,
     /* 2067262 */   // Label 27492: @2067262
     /* 2067262 */   GIM_Try, /*On fail goto*//*Label 27493*/ GIMT_Encode4(2067356), // Rule ID 15657 //
     /* 2067267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2067278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2067281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2067284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2067287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067313 */     // MIs[0] round
     /* 2067313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067316 */     // MIs[0] policy
     /* 2067316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067326 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067355 */     // GIR_Coverage, 15657,
     /* 2067355 */     GIR_EraseRootFromParent_Done,
     /* 2067356 */   // Label 27493: @2067356
     /* 2067356 */   GIM_Try, /*On fail goto*//*Label 27494*/ GIMT_Encode4(2067450), // Rule ID 15660 //
     /* 2067361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2067372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2067375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2067378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2067381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067407 */     // MIs[0] round
     /* 2067407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067410 */     // MIs[0] policy
     /* 2067410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067420 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2067423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067449 */     // GIR_Coverage, 15660,
     /* 2067449 */     GIR_EraseRootFromParent_Done,
     /* 2067450 */   // Label 27494: @2067450
     /* 2067450 */   GIM_Try, /*On fail goto*//*Label 27495*/ GIMT_Encode4(2067544), // Rule ID 15661 //
     /* 2067455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2067466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2067469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2067472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2067475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067501 */     // MIs[0] round
     /* 2067501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067504 */     // MIs[0] policy
     /* 2067504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067514 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2067517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067543 */     // GIR_Coverage, 15661,
     /* 2067543 */     GIR_EraseRootFromParent_Done,
     /* 2067544 */   // Label 27495: @2067544
     /* 2067544 */   GIM_Try, /*On fail goto*//*Label 27496*/ GIMT_Encode4(2067638), // Rule ID 15664 //
     /* 2067549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2067560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2067563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2067566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2067569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067595 */     // MIs[0] round
     /* 2067595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067598 */     // MIs[0] policy
     /* 2067598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067608 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067637 */     // GIR_Coverage, 15664,
     /* 2067637 */     GIR_EraseRootFromParent_Done,
     /* 2067638 */   // Label 27496: @2067638
     /* 2067638 */   GIM_Try, /*On fail goto*//*Label 27497*/ GIMT_Encode4(2067732), // Rule ID 15665 //
     /* 2067643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2067654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2067657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2067660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2067663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067689 */     // MIs[0] round
     /* 2067689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067692 */     // MIs[0] policy
     /* 2067692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067702 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067731 */     // GIR_Coverage, 15665,
     /* 2067731 */     GIR_EraseRootFromParent_Done,
     /* 2067732 */   // Label 27497: @2067732
     /* 2067732 */   GIM_Try, /*On fail goto*//*Label 27498*/ GIMT_Encode4(2067826), // Rule ID 15668 //
     /* 2067737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2067748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2067751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2067754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2067757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067783 */     // MIs[0] round
     /* 2067783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067786 */     // MIs[0] policy
     /* 2067786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067796 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067825 */     // GIR_Coverage, 15668,
     /* 2067825 */     GIR_EraseRootFromParent_Done,
     /* 2067826 */   // Label 27498: @2067826
     /* 2067826 */   GIM_Try, /*On fail goto*//*Label 27499*/ GIMT_Encode4(2067920), // Rule ID 15669 //
     /* 2067831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2067842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2067845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2067848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2067851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067877 */     // MIs[0] round
     /* 2067877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067880 */     // MIs[0] policy
     /* 2067880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067890 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067919 */     // GIR_Coverage, 15669,
     /* 2067919 */     GIR_EraseRootFromParent_Done,
     /* 2067920 */   // Label 27499: @2067920
     /* 2067920 */   GIM_Try, /*On fail goto*//*Label 27500*/ GIMT_Encode4(2068014), // Rule ID 15672 //
     /* 2067925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2067936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2067939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2067942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2067945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067971 */     // MIs[0] round
     /* 2067971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067974 */     // MIs[0] policy
     /* 2067974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067984 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068013 */     // GIR_Coverage, 15672,
     /* 2068013 */     GIR_EraseRootFromParent_Done,
     /* 2068014 */   // Label 27500: @2068014
     /* 2068014 */   GIM_Try, /*On fail goto*//*Label 27501*/ GIMT_Encode4(2068108), // Rule ID 15673 //
     /* 2068019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2068030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2068033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2068036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2068039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068065 */     // MIs[0] round
     /* 2068065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068068 */     // MIs[0] policy
     /* 2068068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068078 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2068081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068107 */     // GIR_Coverage, 15673,
     /* 2068107 */     GIR_EraseRootFromParent_Done,
     /* 2068108 */   // Label 27501: @2068108
     /* 2068108 */   GIM_Try, /*On fail goto*//*Label 27502*/ GIMT_Encode4(2068202), // Rule ID 15676 //
     /* 2068113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2068124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2068127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2068130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2068133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2068136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068159 */     // MIs[0] round
     /* 2068159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068162 */     // MIs[0] policy
     /* 2068162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2068175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068201 */     // GIR_Coverage, 15676,
     /* 2068201 */     GIR_EraseRootFromParent_Done,
     /* 2068202 */   // Label 27502: @2068202
     /* 2068202 */   GIM_Try, /*On fail goto*//*Label 27503*/ GIMT_Encode4(2068296), // Rule ID 15677 //
     /* 2068207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2068218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2068221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2068224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2068227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2068230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068253 */     // MIs[0] round
     /* 2068253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068256 */     // MIs[0] policy
     /* 2068256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068266 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2068269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068295 */     // GIR_Coverage, 15677,
     /* 2068295 */     GIR_EraseRootFromParent_Done,
     /* 2068296 */   // Label 27503: @2068296
     /* 2068296 */   GIM_Try, /*On fail goto*//*Label 27504*/ GIMT_Encode4(2068390), // Rule ID 15680 //
     /* 2068301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2068312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2068315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2068318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2068321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068347 */     // MIs[0] round
     /* 2068347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068350 */     // MIs[0] policy
     /* 2068350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2068363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068385 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068389 */     // GIR_Coverage, 15680,
     /* 2068389 */     GIR_EraseRootFromParent_Done,
     /* 2068390 */   // Label 27504: @2068390
     /* 2068390 */   GIM_Try, /*On fail goto*//*Label 27505*/ GIMT_Encode4(2068484), // Rule ID 15681 //
     /* 2068395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2068406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2068409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2068412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2068415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068441 */     // MIs[0] round
     /* 2068441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068444 */     // MIs[0] policy
     /* 2068444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068454 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2068457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068479 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068483 */     // GIR_Coverage, 15681,
     /* 2068483 */     GIR_EraseRootFromParent_Done,
     /* 2068484 */   // Label 27505: @2068484
     /* 2068484 */   GIM_Try, /*On fail goto*//*Label 27506*/ GIMT_Encode4(2068578), // Rule ID 15684 //
     /* 2068489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2068500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2068503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2068506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2068509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068535 */     // MIs[0] round
     /* 2068535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068538 */     // MIs[0] policy
     /* 2068538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068548 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2068551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068577 */     // GIR_Coverage, 15684,
     /* 2068577 */     GIR_EraseRootFromParent_Done,
     /* 2068578 */   // Label 27506: @2068578
     /* 2068578 */   GIM_Try, /*On fail goto*//*Label 27507*/ GIMT_Encode4(2068672), // Rule ID 15685 //
     /* 2068583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2068594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2068597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2068600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2068603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068629 */     // MIs[0] round
     /* 2068629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068632 */     // MIs[0] policy
     /* 2068632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068642 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2068645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068671 */     // GIR_Coverage, 15685,
     /* 2068671 */     GIR_EraseRootFromParent_Done,
     /* 2068672 */   // Label 27507: @2068672
     /* 2068672 */   GIM_Try, /*On fail goto*//*Label 27508*/ GIMT_Encode4(2068766), // Rule ID 15688 //
     /* 2068677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2068688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2068691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2068694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2068697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068723 */     // MIs[0] round
     /* 2068723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068726 */     // MIs[0] policy
     /* 2068726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068736 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2068739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068765 */     // GIR_Coverage, 15688,
     /* 2068765 */     GIR_EraseRootFromParent_Done,
     /* 2068766 */   // Label 27508: @2068766
     /* 2068766 */   GIM_Try, /*On fail goto*//*Label 27509*/ GIMT_Encode4(2068860), // Rule ID 15689 //
     /* 2068771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2068782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2068785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2068788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2068791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068817 */     // MIs[0] round
     /* 2068817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068820 */     // MIs[0] policy
     /* 2068820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068830 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2068833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068859 */     // GIR_Coverage, 15689,
     /* 2068859 */     GIR_EraseRootFromParent_Done,
     /* 2068860 */   // Label 27509: @2068860
     /* 2068860 */   GIM_Try, /*On fail goto*//*Label 27510*/ GIMT_Encode4(2068954), // Rule ID 15692 //
     /* 2068865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2068876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2068879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2068882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2068885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2068888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068911 */     // MIs[0] round
     /* 2068911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068914 */     // MIs[0] policy
     /* 2068914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068924 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2068927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068953 */     // GIR_Coverage, 15692,
     /* 2068953 */     GIR_EraseRootFromParent_Done,
     /* 2068954 */   // Label 27510: @2068954
     /* 2068954 */   GIM_Try, /*On fail goto*//*Label 27511*/ GIMT_Encode4(2069048), // Rule ID 15693 //
     /* 2068959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2068970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2068973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2068976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2068979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2068982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069005 */     // MIs[0] round
     /* 2069005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069008 */     // MIs[0] policy
     /* 2069008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069018 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069047 */     // GIR_Coverage, 15693,
     /* 2069047 */     GIR_EraseRootFromParent_Done,
     /* 2069048 */   // Label 27511: @2069048
     /* 2069048 */   GIM_Try, /*On fail goto*//*Label 27512*/ GIMT_Encode4(2069142), // Rule ID 15696 //
     /* 2069053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2069064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2069067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2069070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2069073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069099 */     // MIs[0] round
     /* 2069099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069102 */     // MIs[0] policy
     /* 2069102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069112 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2069115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069141 */     // GIR_Coverage, 15696,
     /* 2069141 */     GIR_EraseRootFromParent_Done,
     /* 2069142 */   // Label 27512: @2069142
     /* 2069142 */   GIM_Try, /*On fail goto*//*Label 27513*/ GIMT_Encode4(2069236), // Rule ID 15697 //
     /* 2069147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2069158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2069161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2069164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2069167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069193 */     // MIs[0] round
     /* 2069193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069196 */     // MIs[0] policy
     /* 2069196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2069209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069235 */     // GIR_Coverage, 15697,
     /* 2069235 */     GIR_EraseRootFromParent_Done,
     /* 2069236 */   // Label 27513: @2069236
     /* 2069236 */   GIM_Try, /*On fail goto*//*Label 27514*/ GIMT_Encode4(2069330), // Rule ID 15700 //
     /* 2069241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2069252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2069255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2069258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2069261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069287 */     // MIs[0] round
     /* 2069287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069290 */     // MIs[0] policy
     /* 2069290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069300 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2069303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069329 */     // GIR_Coverage, 15700,
     /* 2069329 */     GIR_EraseRootFromParent_Done,
     /* 2069330 */   // Label 27514: @2069330
     /* 2069330 */   GIM_Try, /*On fail goto*//*Label 27515*/ GIMT_Encode4(2069424), // Rule ID 15701 //
     /* 2069335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2069346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2069349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2069352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2069355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069381 */     // MIs[0] round
     /* 2069381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069384 */     // MIs[0] policy
     /* 2069384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069394 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2069397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069423 */     // GIR_Coverage, 15701,
     /* 2069423 */     GIR_EraseRootFromParent_Done,
     /* 2069424 */   // Label 27515: @2069424
     /* 2069424 */   GIM_Try, /*On fail goto*//*Label 27516*/ GIMT_Encode4(2069518), // Rule ID 15704 //
     /* 2069429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2069440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2069443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2069446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2069449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2069452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069475 */     // MIs[0] round
     /* 2069475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069478 */     // MIs[0] policy
     /* 2069478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069488 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069517 */     // GIR_Coverage, 15704,
     /* 2069517 */     GIR_EraseRootFromParent_Done,
     /* 2069518 */   // Label 27516: @2069518
     /* 2069518 */   GIM_Try, /*On fail goto*//*Label 27517*/ GIMT_Encode4(2069612), // Rule ID 15705 //
     /* 2069523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2069534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2069537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2069540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2069543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2069546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069569 */     // MIs[0] round
     /* 2069569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069572 */     // MIs[0] policy
     /* 2069572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069582 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069611 */     // GIR_Coverage, 15705,
     /* 2069611 */     GIR_EraseRootFromParent_Done,
     /* 2069612 */   // Label 27517: @2069612
     /* 2069612 */   GIM_Try, /*On fail goto*//*Label 27518*/ GIMT_Encode4(2069706), // Rule ID 15708 //
     /* 2069617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2069628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2069631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2069634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2069637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069663 */     // MIs[0] round
     /* 2069663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069666 */     // MIs[0] policy
     /* 2069666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2069679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069705 */     // GIR_Coverage, 15708,
     /* 2069705 */     GIR_EraseRootFromParent_Done,
     /* 2069706 */   // Label 27518: @2069706
     /* 2069706 */   GIM_Try, /*On fail goto*//*Label 27519*/ GIMT_Encode4(2069800), // Rule ID 15709 //
     /* 2069711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2069722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2069725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2069728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2069731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069757 */     // MIs[0] round
     /* 2069757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069760 */     // MIs[0] policy
     /* 2069760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2069773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069799 */     // GIR_Coverage, 15709,
     /* 2069799 */     GIR_EraseRootFromParent_Done,
     /* 2069800 */   // Label 27519: @2069800
     /* 2069800 */   GIM_Try, /*On fail goto*//*Label 27520*/ GIMT_Encode4(2069894), // Rule ID 15712 //
     /* 2069805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2069816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2069819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2069822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2069825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069851 */     // MIs[0] round
     /* 2069851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069854 */     // MIs[0] policy
     /* 2069854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069864 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2069867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069893 */     // GIR_Coverage, 15712,
     /* 2069893 */     GIR_EraseRootFromParent_Done,
     /* 2069894 */   // Label 27520: @2069894
     /* 2069894 */   GIM_Try, /*On fail goto*//*Label 27521*/ GIMT_Encode4(2069988), // Rule ID 15713 //
     /* 2069899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2069910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2069913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2069916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2069919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069945 */     // MIs[0] round
     /* 2069945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069948 */     // MIs[0] policy
     /* 2069948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069958 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2069961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069987 */     // GIR_Coverage, 15713,
     /* 2069987 */     GIR_EraseRootFromParent_Done,
     /* 2069988 */   // Label 27521: @2069988
     /* 2069988 */   GIM_Try, /*On fail goto*//*Label 27522*/ GIMT_Encode4(2070082), // Rule ID 15716 //
     /* 2069993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2070004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2070007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2070010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2070013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2070016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070039 */     // MIs[0] round
     /* 2070039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070042 */     // MIs[0] policy
     /* 2070042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070052 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2070055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070081 */     // GIR_Coverage, 15716,
     /* 2070081 */     GIR_EraseRootFromParent_Done,
     /* 2070082 */   // Label 27522: @2070082
     /* 2070082 */   GIM_Try, /*On fail goto*//*Label 27523*/ GIMT_Encode4(2070176), // Rule ID 15717 //
     /* 2070087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2070098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2070101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2070104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2070107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2070110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070133 */     // MIs[0] round
     /* 2070133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070136 */     // MIs[0] policy
     /* 2070136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070146 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2070149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070175 */     // GIR_Coverage, 15717,
     /* 2070175 */     GIR_EraseRootFromParent_Done,
     /* 2070176 */   // Label 27523: @2070176
     /* 2070176 */   GIM_Try, /*On fail goto*//*Label 27524*/ GIMT_Encode4(2070270), // Rule ID 15720 //
     /* 2070181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2070192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2070195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2070198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070227 */     // MIs[0] round
     /* 2070227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070230 */     // MIs[0] policy
     /* 2070230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070240 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2070243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070269 */     // GIR_Coverage, 15720,
     /* 2070269 */     GIR_EraseRootFromParent_Done,
     /* 2070270 */   // Label 27524: @2070270
     /* 2070270 */   GIM_Try, /*On fail goto*//*Label 27525*/ GIMT_Encode4(2070364), // Rule ID 15721 //
     /* 2070275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2070286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2070289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2070292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070321 */     // MIs[0] round
     /* 2070321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070324 */     // MIs[0] policy
     /* 2070324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2070337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070363 */     // GIR_Coverage, 15721,
     /* 2070363 */     GIR_EraseRootFromParent_Done,
     /* 2070364 */   // Label 27525: @2070364
     /* 2070364 */   GIM_Try, /*On fail goto*//*Label 27526*/ GIMT_Encode4(2070458), // Rule ID 15724 //
     /* 2070369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2070380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2070383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2070386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070415 */     // MIs[0] round
     /* 2070415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070418 */     // MIs[0] policy
     /* 2070418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070428 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070457 */     // GIR_Coverage, 15724,
     /* 2070457 */     GIR_EraseRootFromParent_Done,
     /* 2070458 */   // Label 27526: @2070458
     /* 2070458 */   GIM_Try, /*On fail goto*//*Label 27527*/ GIMT_Encode4(2070552), // Rule ID 15725 //
     /* 2070463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2070474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2070477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2070480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070509 */     // MIs[0] round
     /* 2070509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070512 */     // MIs[0] policy
     /* 2070512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070522 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070551 */     // GIR_Coverage, 15725,
     /* 2070551 */     GIR_EraseRootFromParent_Done,
     /* 2070552 */   // Label 27527: @2070552
     /* 2070552 */   GIM_Try, /*On fail goto*//*Label 27528*/ GIMT_Encode4(2070646), // Rule ID 15728 //
     /* 2070557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2070568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2070571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2070574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070603 */     // MIs[0] round
     /* 2070603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070606 */     // MIs[0] policy
     /* 2070606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070616 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070645 */     // GIR_Coverage, 15728,
     /* 2070645 */     GIR_EraseRootFromParent_Done,
     /* 2070646 */   // Label 27528: @2070646
     /* 2070646 */   GIM_Try, /*On fail goto*//*Label 27529*/ GIMT_Encode4(2070740), // Rule ID 15729 //
     /* 2070651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2070662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2070665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2070668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070697 */     // MIs[0] round
     /* 2070697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070700 */     // MIs[0] policy
     /* 2070700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070710 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070739 */     // GIR_Coverage, 15729,
     /* 2070739 */     GIR_EraseRootFromParent_Done,
     /* 2070740 */   // Label 27529: @2070740
     /* 2070740 */   GIM_Try, /*On fail goto*//*Label 27530*/ GIMT_Encode4(2070834), // Rule ID 15732 //
     /* 2070745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2070756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2070759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2070762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070791 */     // MIs[0] round
     /* 2070791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070794 */     // MIs[0] policy
     /* 2070794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070804 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070833 */     // GIR_Coverage, 15732,
     /* 2070833 */     GIR_EraseRootFromParent_Done,
     /* 2070834 */   // Label 27530: @2070834
     /* 2070834 */   GIM_Try, /*On fail goto*//*Label 27531*/ GIMT_Encode4(2070928), // Rule ID 15733 //
     /* 2070839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2070850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2070853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2070856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070885 */     // MIs[0] round
     /* 2070885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070888 */     // MIs[0] policy
     /* 2070888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070898 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070927 */     // GIR_Coverage, 15733,
     /* 2070927 */     GIR_EraseRootFromParent_Done,
     /* 2070928 */   // Label 27531: @2070928
     /* 2070928 */   GIM_Try, /*On fail goto*//*Label 27532*/ GIMT_Encode4(2071022), // Rule ID 15736 //
     /* 2070933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2070944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2070947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2070950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070979 */     // MIs[0] round
     /* 2070979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070982 */     // MIs[0] policy
     /* 2070982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070992 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071021 */     // GIR_Coverage, 15736,
     /* 2071021 */     GIR_EraseRootFromParent_Done,
     /* 2071022 */   // Label 27532: @2071022
     /* 2071022 */   GIM_Try, /*On fail goto*//*Label 27533*/ GIMT_Encode4(2071116), // Rule ID 15737 //
     /* 2071027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2071038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2071041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2071044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071073 */     // MIs[0] round
     /* 2071073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071076 */     // MIs[0] policy
     /* 2071076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2071089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071115 */     // GIR_Coverage, 15737,
     /* 2071115 */     GIR_EraseRootFromParent_Done,
     /* 2071116 */   // Label 27533: @2071116
     /* 2071116 */   GIM_Try, /*On fail goto*//*Label 27534*/ GIMT_Encode4(2071210), // Rule ID 15740 //
     /* 2071121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2071132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2071135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2071138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071167 */     // MIs[0] round
     /* 2071167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071170 */     // MIs[0] policy
     /* 2071170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071180 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2071183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071209 */     // GIR_Coverage, 15740,
     /* 2071209 */     GIR_EraseRootFromParent_Done,
     /* 2071210 */   // Label 27534: @2071210
     /* 2071210 */   GIM_Try, /*On fail goto*//*Label 27535*/ GIMT_Encode4(2071304), // Rule ID 15741 //
     /* 2071215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2071226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2071229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2071232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071261 */     // MIs[0] round
     /* 2071261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071264 */     // MIs[0] policy
     /* 2071264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071274 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2071277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071303 */     // GIR_Coverage, 15741,
     /* 2071303 */     GIR_EraseRootFromParent_Done,
     /* 2071304 */   // Label 27535: @2071304
     /* 2071304 */   GIM_Try, /*On fail goto*//*Label 27536*/ GIMT_Encode4(2071398), // Rule ID 15744 //
     /* 2071309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2071320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2071323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2071326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071355 */     // MIs[0] round
     /* 2071355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071358 */     // MIs[0] policy
     /* 2071358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071368 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071397 */     // GIR_Coverage, 15744,
     /* 2071397 */     GIR_EraseRootFromParent_Done,
     /* 2071398 */   // Label 27536: @2071398
     /* 2071398 */   GIM_Try, /*On fail goto*//*Label 27537*/ GIMT_Encode4(2071492), // Rule ID 15745 //
     /* 2071403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2071414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2071417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2071420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071449 */     // MIs[0] round
     /* 2071449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071452 */     // MIs[0] policy
     /* 2071452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071462 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071491 */     // GIR_Coverage, 15745,
     /* 2071491 */     GIR_EraseRootFromParent_Done,
     /* 2071492 */   // Label 27537: @2071492
     /* 2071492 */   GIM_Try, /*On fail goto*//*Label 27538*/ GIMT_Encode4(2071586), // Rule ID 15748 //
     /* 2071497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2071508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2071511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2071514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071543 */     // MIs[0] round
     /* 2071543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071546 */     // MIs[0] policy
     /* 2071546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071556 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071585 */     // GIR_Coverage, 15748,
     /* 2071585 */     GIR_EraseRootFromParent_Done,
     /* 2071586 */   // Label 27538: @2071586
     /* 2071586 */   GIM_Try, /*On fail goto*//*Label 27539*/ GIMT_Encode4(2071680), // Rule ID 15749 //
     /* 2071591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2071602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2071605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2071608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071637 */     // MIs[0] round
     /* 2071637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071640 */     // MIs[0] policy
     /* 2071640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071679 */     // GIR_Coverage, 15749,
     /* 2071679 */     GIR_EraseRootFromParent_Done,
     /* 2071680 */   // Label 27539: @2071680
     /* 2071680 */   GIM_Try, /*On fail goto*//*Label 27540*/ GIMT_Encode4(2071774), // Rule ID 15752 //
     /* 2071685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2071696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2071699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2071702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071731 */     // MIs[0] round
     /* 2071731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071734 */     // MIs[0] policy
     /* 2071734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071773 */     // GIR_Coverage, 15752,
     /* 2071773 */     GIR_EraseRootFromParent_Done,
     /* 2071774 */   // Label 27540: @2071774
     /* 2071774 */   GIM_Try, /*On fail goto*//*Label 27541*/ GIMT_Encode4(2071868), // Rule ID 15753 //
     /* 2071779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2071790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2071793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2071796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071825 */     // MIs[0] round
     /* 2071825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071828 */     // MIs[0] policy
     /* 2071828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071867 */     // GIR_Coverage, 15753,
     /* 2071867 */     GIR_EraseRootFromParent_Done,
     /* 2071868 */   // Label 27541: @2071868
     /* 2071868 */   GIM_Try, /*On fail goto*//*Label 27542*/ GIMT_Encode4(2071962), // Rule ID 15756 //
     /* 2071873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2071884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2071887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2071890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071919 */     // MIs[0] round
     /* 2071919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071922 */     // MIs[0] policy
     /* 2071922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071932 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2071935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071961 */     // GIR_Coverage, 15756,
     /* 2071961 */     GIR_EraseRootFromParent_Done,
     /* 2071962 */   // Label 27542: @2071962
     /* 2071962 */   GIM_Try, /*On fail goto*//*Label 27543*/ GIMT_Encode4(2072056), // Rule ID 15757 //
     /* 2071967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2071978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2071981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2071984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072013 */     // MIs[0] round
     /* 2072013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072016 */     // MIs[0] policy
     /* 2072016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072055 */     // GIR_Coverage, 15757,
     /* 2072055 */     GIR_EraseRootFromParent_Done,
     /* 2072056 */   // Label 27543: @2072056
     /* 2072056 */   GIM_Try, /*On fail goto*//*Label 27544*/ GIMT_Encode4(2072150), // Rule ID 15760 //
     /* 2072061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2072072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2072075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2072078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072107 */     // MIs[0] round
     /* 2072107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072110 */     // MIs[0] policy
     /* 2072110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072120 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072149 */     // GIR_Coverage, 15760,
     /* 2072149 */     GIR_EraseRootFromParent_Done,
     /* 2072150 */   // Label 27544: @2072150
     /* 2072150 */   GIM_Try, /*On fail goto*//*Label 27545*/ GIMT_Encode4(2072244), // Rule ID 15761 //
     /* 2072155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2072166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2072169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2072172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072201 */     // MIs[0] round
     /* 2072201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072204 */     // MIs[0] policy
     /* 2072204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072214 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072243 */     // GIR_Coverage, 15761,
     /* 2072243 */     GIR_EraseRootFromParent_Done,
     /* 2072244 */   // Label 27545: @2072244
     /* 2072244 */   GIM_Try, /*On fail goto*//*Label 27546*/ GIMT_Encode4(2072338), // Rule ID 15764 //
     /* 2072249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2072260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2072263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2072266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2072272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072295 */     // MIs[0] round
     /* 2072295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072298 */     // MIs[0] policy
     /* 2072298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072308 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072337 */     // GIR_Coverage, 15764,
     /* 2072337 */     GIR_EraseRootFromParent_Done,
     /* 2072338 */   // Label 27546: @2072338
     /* 2072338 */   GIM_Try, /*On fail goto*//*Label 27547*/ GIMT_Encode4(2072432), // Rule ID 15765 //
     /* 2072343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2072354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2072357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2072360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2072366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072389 */     // MIs[0] round
     /* 2072389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072392 */     // MIs[0] policy
     /* 2072392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072402 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072431 */     // GIR_Coverage, 15765,
     /* 2072431 */     GIR_EraseRootFromParent_Done,
     /* 2072432 */   // Label 27547: @2072432
     /* 2072432 */   GIM_Try, /*On fail goto*//*Label 27548*/ GIMT_Encode4(2072526), // Rule ID 15768 //
     /* 2072437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2072448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2072451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2072454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072483 */     // MIs[0] round
     /* 2072483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072486 */     // MIs[0] policy
     /* 2072486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072496 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072525 */     // GIR_Coverage, 15768,
     /* 2072525 */     GIR_EraseRootFromParent_Done,
     /* 2072526 */   // Label 27548: @2072526
     /* 2072526 */   GIM_Try, /*On fail goto*//*Label 27549*/ GIMT_Encode4(2072620), // Rule ID 15769 //
     /* 2072531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2072542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2072545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2072548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072577 */     // MIs[0] round
     /* 2072577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072580 */     // MIs[0] policy
     /* 2072580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072619 */     // GIR_Coverage, 15769,
     /* 2072619 */     GIR_EraseRootFromParent_Done,
     /* 2072620 */   // Label 27549: @2072620
     /* 2072620 */   GIM_Try, /*On fail goto*//*Label 27550*/ GIMT_Encode4(2072714), // Rule ID 15772 //
     /* 2072625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2072636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2072639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2072642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072671 */     // MIs[0] round
     /* 2072671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072674 */     // MIs[0] policy
     /* 2072674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072713 */     // GIR_Coverage, 15772,
     /* 2072713 */     GIR_EraseRootFromParent_Done,
     /* 2072714 */   // Label 27550: @2072714
     /* 2072714 */   GIM_Try, /*On fail goto*//*Label 27551*/ GIMT_Encode4(2072808), // Rule ID 15773 //
     /* 2072719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2072730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2072733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2072736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072765 */     // MIs[0] round
     /* 2072765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072768 */     // MIs[0] policy
     /* 2072768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072778 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072807 */     // GIR_Coverage, 15773,
     /* 2072807 */     GIR_EraseRootFromParent_Done,
     /* 2072808 */   // Label 27551: @2072808
     /* 2072808 */   GIM_Try, /*On fail goto*//*Label 27552*/ GIMT_Encode4(2072902), // Rule ID 15776 //
     /* 2072813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2072824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2072827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2072830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072859 */     // MIs[0] round
     /* 2072859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072862 */     // MIs[0] policy
     /* 2072862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072872 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072901 */     // GIR_Coverage, 15776,
     /* 2072901 */     GIR_EraseRootFromParent_Done,
     /* 2072902 */   // Label 27552: @2072902
     /* 2072902 */   GIM_Try, /*On fail goto*//*Label 27553*/ GIMT_Encode4(2072996), // Rule ID 15777 //
     /* 2072907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2072918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2072921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2072924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072953 */     // MIs[0] round
     /* 2072953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072956 */     // MIs[0] policy
     /* 2072956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072966 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072995 */     // GIR_Coverage, 15777,
     /* 2072995 */     GIR_EraseRootFromParent_Done,
     /* 2072996 */   // Label 27553: @2072996
     /* 2072996 */   GIM_Try, /*On fail goto*//*Label 27554*/ GIMT_Encode4(2073090), // Rule ID 15780 //
     /* 2073001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2073012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2073015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2073018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073047 */     // MIs[0] round
     /* 2073047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073050 */     // MIs[0] policy
     /* 2073050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2073063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073089 */     // GIR_Coverage, 15780,
     /* 2073089 */     GIR_EraseRootFromParent_Done,
     /* 2073090 */   // Label 27554: @2073090
     /* 2073090 */   GIM_Try, /*On fail goto*//*Label 27555*/ GIMT_Encode4(2073184), // Rule ID 15781 //
     /* 2073095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2073106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2073109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2073112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073141 */     // MIs[0] round
     /* 2073141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073144 */     // MIs[0] policy
     /* 2073144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073154 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2073157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073183 */     // GIR_Coverage, 15781,
     /* 2073183 */     GIR_EraseRootFromParent_Done,
     /* 2073184 */   // Label 27555: @2073184
     /* 2073184 */   GIM_Try, /*On fail goto*//*Label 27556*/ GIMT_Encode4(2073278), // Rule ID 15784 //
     /* 2073189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2073200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2073203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2073206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073235 */     // MIs[0] round
     /* 2073235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073238 */     // MIs[0] policy
     /* 2073238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2073251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073277 */     // GIR_Coverage, 15784,
     /* 2073277 */     GIR_EraseRootFromParent_Done,
     /* 2073278 */   // Label 27556: @2073278
     /* 2073278 */   GIM_Try, /*On fail goto*//*Label 27557*/ GIMT_Encode4(2073372), // Rule ID 15785 //
     /* 2073283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2073294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2073297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2073300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073329 */     // MIs[0] round
     /* 2073329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073332 */     // MIs[0] policy
     /* 2073332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073342 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2073345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073371 */     // GIR_Coverage, 15785,
     /* 2073371 */     GIR_EraseRootFromParent_Done,
     /* 2073372 */   // Label 27557: @2073372
     /* 2073372 */   GIM_Try, /*On fail goto*//*Label 27558*/ GIMT_Encode4(2073466), // Rule ID 15788 //
     /* 2073377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2073388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2073391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2073394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073423 */     // MIs[0] round
     /* 2073423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073426 */     // MIs[0] policy
     /* 2073426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073436 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2073439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073465 */     // GIR_Coverage, 15788,
     /* 2073465 */     GIR_EraseRootFromParent_Done,
     /* 2073466 */   // Label 27558: @2073466
     /* 2073466 */   GIM_Try, /*On fail goto*//*Label 27559*/ GIMT_Encode4(2073560), // Rule ID 15789 //
     /* 2073471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2073482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2073485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2073488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073517 */     // MIs[0] round
     /* 2073517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073520 */     // MIs[0] policy
     /* 2073520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073530 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2073533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073559 */     // GIR_Coverage, 15789,
     /* 2073559 */     GIR_EraseRootFromParent_Done,
     /* 2073560 */   // Label 27559: @2073560
     /* 2073560 */   GIM_Try, /*On fail goto*//*Label 27560*/ GIMT_Encode4(2073654), // Rule ID 15792 //
     /* 2073565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2073585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073611 */     // MIs[0] round
     /* 2073611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073614 */     // MIs[0] policy
     /* 2073614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2073627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073653 */     // GIR_Coverage, 15792,
     /* 2073653 */     GIR_EraseRootFromParent_Done,
     /* 2073654 */   // Label 27560: @2073654
     /* 2073654 */   GIM_Try, /*On fail goto*//*Label 27561*/ GIMT_Encode4(2073748), // Rule ID 15793 //
     /* 2073659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2073679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073705 */     // MIs[0] round
     /* 2073705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073708 */     // MIs[0] policy
     /* 2073708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073718 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2073721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073747 */     // GIR_Coverage, 15793,
     /* 2073747 */     GIR_EraseRootFromParent_Done,
     /* 2073748 */   // Label 27561: @2073748
     /* 2073748 */   GIM_Try, /*On fail goto*//*Label 27562*/ GIMT_Encode4(2073842), // Rule ID 15796 //
     /* 2073753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2073764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2073767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2073770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2073773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073799 */     // MIs[0] round
     /* 2073799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073802 */     // MIs[0] policy
     /* 2073802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2073815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073841 */     // GIR_Coverage, 15796,
     /* 2073841 */     GIR_EraseRootFromParent_Done,
     /* 2073842 */   // Label 27562: @2073842
     /* 2073842 */   GIM_Try, /*On fail goto*//*Label 27563*/ GIMT_Encode4(2073936), // Rule ID 15797 //
     /* 2073847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2073858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2073861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2073864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2073867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073893 */     // MIs[0] round
     /* 2073893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073896 */     // MIs[0] policy
     /* 2073896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2073909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073935 */     // GIR_Coverage, 15797,
     /* 2073935 */     GIR_EraseRootFromParent_Done,
     /* 2073936 */   // Label 27563: @2073936
     /* 2073936 */   GIM_Try, /*On fail goto*//*Label 27564*/ GIMT_Encode4(2074030), // Rule ID 15800 //
     /* 2073941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2073952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2073955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2073958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2073961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073987 */     // MIs[0] round
     /* 2073987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073990 */     // MIs[0] policy
     /* 2073990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074000 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2074003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074029 */     // GIR_Coverage, 15800,
     /* 2074029 */     GIR_EraseRootFromParent_Done,
     /* 2074030 */   // Label 27564: @2074030
     /* 2074030 */   GIM_Try, /*On fail goto*//*Label 27565*/ GIMT_Encode4(2074124), // Rule ID 15801 //
     /* 2074035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2074046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2074049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2074052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2074055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074081 */     // MIs[0] round
     /* 2074081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074084 */     // MIs[0] policy
     /* 2074084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074094 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2074097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074123 */     // GIR_Coverage, 15801,
     /* 2074123 */     GIR_EraseRootFromParent_Done,
     /* 2074124 */   // Label 27565: @2074124
     /* 2074124 */   GIM_Try, /*On fail goto*//*Label 27566*/ GIMT_Encode4(2074218), // Rule ID 15804 //
     /* 2074129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2074140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2074143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2074146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2074149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074175 */     // MIs[0] round
     /* 2074175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074178 */     // MIs[0] policy
     /* 2074178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074188 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2074191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074217 */     // GIR_Coverage, 15804,
     /* 2074217 */     GIR_EraseRootFromParent_Done,
     /* 2074218 */   // Label 27566: @2074218
     /* 2074218 */   GIM_Try, /*On fail goto*//*Label 27567*/ GIMT_Encode4(2074312), // Rule ID 15805 //
     /* 2074223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2074234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2074237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2074240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2074243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074269 */     // MIs[0] round
     /* 2074269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074272 */     // MIs[0] policy
     /* 2074272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074282 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2074285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074311 */     // GIR_Coverage, 15805,
     /* 2074311 */     GIR_EraseRootFromParent_Done,
     /* 2074312 */   // Label 27567: @2074312
     /* 2074312 */   GIM_Try, /*On fail goto*//*Label 27568*/ GIMT_Encode4(2074406), // Rule ID 15808 //
     /* 2074317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2074328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2074331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2074334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2074340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074363 */     // MIs[0] round
     /* 2074363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074366 */     // MIs[0] policy
     /* 2074366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074376 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2074379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074405 */     // GIR_Coverage, 15808,
     /* 2074405 */     GIR_EraseRootFromParent_Done,
     /* 2074406 */   // Label 27568: @2074406
     /* 2074406 */   GIM_Try, /*On fail goto*//*Label 27569*/ GIMT_Encode4(2074500), // Rule ID 15809 //
     /* 2074411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2074422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2074425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2074428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2074434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074457 */     // MIs[0] round
     /* 2074457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074460 */     // MIs[0] policy
     /* 2074460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2074473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074499 */     // GIR_Coverage, 15809,
     /* 2074499 */     GIR_EraseRootFromParent_Done,
     /* 2074500 */   // Label 27569: @2074500
     /* 2074500 */   GIM_Try, /*On fail goto*//*Label 27570*/ GIMT_Encode4(2074594), // Rule ID 15812 //
     /* 2074505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2074516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2074519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2074522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074551 */     // MIs[0] round
     /* 2074551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074554 */     // MIs[0] policy
     /* 2074554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074564 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2074567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074593 */     // GIR_Coverage, 15812,
     /* 2074593 */     GIR_EraseRootFromParent_Done,
     /* 2074594 */   // Label 27570: @2074594
     /* 2074594 */   GIM_Try, /*On fail goto*//*Label 27571*/ GIMT_Encode4(2074688), // Rule ID 15813 //
     /* 2074599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2074610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2074613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2074616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074645 */     // MIs[0] round
     /* 2074645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074648 */     // MIs[0] policy
     /* 2074648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074658 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2074661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074687 */     // GIR_Coverage, 15813,
     /* 2074687 */     GIR_EraseRootFromParent_Done,
     /* 2074688 */   // Label 27571: @2074688
     /* 2074688 */   GIM_Try, /*On fail goto*//*Label 27572*/ GIMT_Encode4(2074782), // Rule ID 15816 //
     /* 2074693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2074704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2074707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2074710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074739 */     // MIs[0] round
     /* 2074739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074742 */     // MIs[0] policy
     /* 2074742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074752 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2074755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074781 */     // GIR_Coverage, 15816,
     /* 2074781 */     GIR_EraseRootFromParent_Done,
     /* 2074782 */   // Label 27572: @2074782
     /* 2074782 */   GIM_Try, /*On fail goto*//*Label 27573*/ GIMT_Encode4(2074876), // Rule ID 15817 //
     /* 2074787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2074798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2074801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2074804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074833 */     // MIs[0] round
     /* 2074833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074836 */     // MIs[0] policy
     /* 2074836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2074849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074875 */     // GIR_Coverage, 15817,
     /* 2074875 */     GIR_EraseRootFromParent_Done,
     /* 2074876 */   // Label 27573: @2074876
     /* 2074876 */   GIM_Try, /*On fail goto*//*Label 27574*/ GIMT_Encode4(2074970), // Rule ID 15820 //
     /* 2074881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2074892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2074895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2074898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074927 */     // MIs[0] round
     /* 2074927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074930 */     // MIs[0] policy
     /* 2074930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074940 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2074943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074969 */     // GIR_Coverage, 15820,
     /* 2074969 */     GIR_EraseRootFromParent_Done,
     /* 2074970 */   // Label 27574: @2074970
     /* 2074970 */   GIM_Try, /*On fail goto*//*Label 27575*/ GIMT_Encode4(2075064), // Rule ID 15821 //
     /* 2074975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2074986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2074989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2074992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2075005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075021 */     // MIs[0] round
     /* 2075021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075024 */     // MIs[0] policy
     /* 2075024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075034 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2075037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075063 */     // GIR_Coverage, 15821,
     /* 2075063 */     GIR_EraseRootFromParent_Done,
     /* 2075064 */   // Label 27575: @2075064
     /* 2075064 */   GIM_Try, /*On fail goto*//*Label 27576*/ GIMT_Encode4(2075155), // Rule ID 15824 //
     /* 2075069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2075080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2075083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2075086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2075089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075115 */     // MIs[0] round
     /* 2075115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075118 */     // MIs[0] policy
     /* 2075118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075128 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2075131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075154 */     // GIR_Coverage, 15824,
     /* 2075154 */     GIR_EraseRootFromParent_Done,
     /* 2075155 */   // Label 27576: @2075155
     /* 2075155 */   GIM_Try, /*On fail goto*//*Label 27577*/ GIMT_Encode4(2075246), // Rule ID 15825 //
     /* 2075160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2075171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2075174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2075177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2075180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075206 */     // MIs[0] round
     /* 2075206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075209 */     // MIs[0] policy
     /* 2075209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075219 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2075222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075245 */     // GIR_Coverage, 15825,
     /* 2075245 */     GIR_EraseRootFromParent_Done,
     /* 2075246 */   // Label 27577: @2075246
     /* 2075246 */   GIM_Try, /*On fail goto*//*Label 27578*/ GIMT_Encode4(2075337), // Rule ID 15828 //
     /* 2075251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2075262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2075265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2075268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2075271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075297 */     // MIs[0] round
     /* 2075297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075300 */     // MIs[0] policy
     /* 2075300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075310 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2075313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075336 */     // GIR_Coverage, 15828,
     /* 2075336 */     GIR_EraseRootFromParent_Done,
     /* 2075337 */   // Label 27578: @2075337
     /* 2075337 */   GIM_Try, /*On fail goto*//*Label 27579*/ GIMT_Encode4(2075428), // Rule ID 15829 //
     /* 2075342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2075353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2075356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2075359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2075362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075388 */     // MIs[0] round
     /* 2075388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075391 */     // MIs[0] policy
     /* 2075391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075401 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2075404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075427 */     // GIR_Coverage, 15829,
     /* 2075427 */     GIR_EraseRootFromParent_Done,
     /* 2075428 */   // Label 27579: @2075428
     /* 2075428 */   GIM_Try, /*On fail goto*//*Label 27580*/ GIMT_Encode4(2075519), // Rule ID 15832 //
     /* 2075433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2075444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2075447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2075450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2075453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075479 */     // MIs[0] round
     /* 2075479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075482 */     // MIs[0] policy
     /* 2075482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075492 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075518 */     // GIR_Coverage, 15832,
     /* 2075518 */     GIR_EraseRootFromParent_Done,
     /* 2075519 */   // Label 27580: @2075519
     /* 2075519 */   GIM_Try, /*On fail goto*//*Label 27581*/ GIMT_Encode4(2075610), // Rule ID 15833 //
     /* 2075524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2075535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2075538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2075541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2075544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075570 */     // MIs[0] round
     /* 2075570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075573 */     // MIs[0] policy
     /* 2075573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075583 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075609 */     // GIR_Coverage, 15833,
     /* 2075609 */     GIR_EraseRootFromParent_Done,
     /* 2075610 */   // Label 27581: @2075610
     /* 2075610 */   GIM_Try, /*On fail goto*//*Label 27582*/ GIMT_Encode4(2075701), // Rule ID 15836 //
     /* 2075615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2075626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2075629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2075632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2075635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075661 */     // MIs[0] round
     /* 2075661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075664 */     // MIs[0] policy
     /* 2075664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2075677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075700 */     // GIR_Coverage, 15836,
     /* 2075700 */     GIR_EraseRootFromParent_Done,
     /* 2075701 */   // Label 27582: @2075701
     /* 2075701 */   GIM_Try, /*On fail goto*//*Label 27583*/ GIMT_Encode4(2075792), // Rule ID 15837 //
     /* 2075706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2075717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2075720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2075723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2075726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075752 */     // MIs[0] round
     /* 2075752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075755 */     // MIs[0] policy
     /* 2075755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075765 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2075768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075791 */     // GIR_Coverage, 15837,
     /* 2075791 */     GIR_EraseRootFromParent_Done,
     /* 2075792 */   // Label 27583: @2075792
     /* 2075792 */   GIM_Try, /*On fail goto*//*Label 27584*/ GIMT_Encode4(2075883), // Rule ID 15840 //
     /* 2075797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2075808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2075811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2075814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2075817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075843 */     // MIs[0] round
     /* 2075843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075846 */     // MIs[0] policy
     /* 2075846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075856 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075882 */     // GIR_Coverage, 15840,
     /* 2075882 */     GIR_EraseRootFromParent_Done,
     /* 2075883 */   // Label 27584: @2075883
     /* 2075883 */   GIM_Try, /*On fail goto*//*Label 27585*/ GIMT_Encode4(2075974), // Rule ID 15841 //
     /* 2075888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2075899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2075902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2075905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2075908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075934 */     // MIs[0] round
     /* 2075934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075937 */     // MIs[0] policy
     /* 2075937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075947 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075973 */     // GIR_Coverage, 15841,
     /* 2075973 */     GIR_EraseRootFromParent_Done,
     /* 2075974 */   // Label 27585: @2075974
     /* 2075974 */   GIM_Try, /*On fail goto*//*Label 27586*/ GIMT_Encode4(2076065), // Rule ID 15844 //
     /* 2075979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2075990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2075993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2075996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2075999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076025 */     // MIs[0] round
     /* 2076025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076028 */     // MIs[0] policy
     /* 2076028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076038 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2076041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076064 */     // GIR_Coverage, 15844,
     /* 2076064 */     GIR_EraseRootFromParent_Done,
     /* 2076065 */   // Label 27586: @2076065
     /* 2076065 */   GIM_Try, /*On fail goto*//*Label 27587*/ GIMT_Encode4(2076156), // Rule ID 15845 //
     /* 2076070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2076081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2076084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2076087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2076090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076116 */     // MIs[0] round
     /* 2076116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076119 */     // MIs[0] policy
     /* 2076119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076129 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2076132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076155 */     // GIR_Coverage, 15845,
     /* 2076155 */     GIR_EraseRootFromParent_Done,
     /* 2076156 */   // Label 27587: @2076156
     /* 2076156 */   GIM_Try, /*On fail goto*//*Label 27588*/ GIMT_Encode4(2076247), // Rule ID 15848 //
     /* 2076161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2076172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2076175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2076178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2076181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076207 */     // MIs[0] round
     /* 2076207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076210 */     // MIs[0] policy
     /* 2076210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076246 */     // GIR_Coverage, 15848,
     /* 2076246 */     GIR_EraseRootFromParent_Done,
     /* 2076247 */   // Label 27588: @2076247
     /* 2076247 */   GIM_Try, /*On fail goto*//*Label 27589*/ GIMT_Encode4(2076338), // Rule ID 15849 //
     /* 2076252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2076263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2076266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2076269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2076272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076298 */     // MIs[0] round
     /* 2076298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076301 */     // MIs[0] policy
     /* 2076301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076311 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076337 */     // GIR_Coverage, 15849,
     /* 2076337 */     GIR_EraseRootFromParent_Done,
     /* 2076338 */   // Label 27589: @2076338
     /* 2076338 */   GIM_Try, /*On fail goto*//*Label 27590*/ GIMT_Encode4(2076429), // Rule ID 15852 //
     /* 2076343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2076354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2076357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2076360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2076363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2076366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076389 */     // MIs[0] round
     /* 2076389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076392 */     // MIs[0] policy
     /* 2076392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076428 */     // GIR_Coverage, 15852,
     /* 2076428 */     GIR_EraseRootFromParent_Done,
     /* 2076429 */   // Label 27590: @2076429
     /* 2076429 */   GIM_Try, /*On fail goto*//*Label 27591*/ GIMT_Encode4(2076520), // Rule ID 15853 //
     /* 2076434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2076445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2076448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2076451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2076454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2076457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076480 */     // MIs[0] round
     /* 2076480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076483 */     // MIs[0] policy
     /* 2076483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076493 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076519 */     // GIR_Coverage, 15853,
     /* 2076519 */     GIR_EraseRootFromParent_Done,
     /* 2076520 */   // Label 27591: @2076520
     /* 2076520 */   GIM_Try, /*On fail goto*//*Label 27592*/ GIMT_Encode4(2076611), // Rule ID 15856 //
     /* 2076525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2076536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2076539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2076542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2076545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076571 */     // MIs[0] round
     /* 2076571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076574 */     // MIs[0] policy
     /* 2076574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076610 */     // GIR_Coverage, 15856,
     /* 2076610 */     GIR_EraseRootFromParent_Done,
     /* 2076611 */   // Label 27592: @2076611
     /* 2076611 */   GIM_Try, /*On fail goto*//*Label 27593*/ GIMT_Encode4(2076702), // Rule ID 15857 //
     /* 2076616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2076627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2076630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2076633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2076636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076662 */     // MIs[0] round
     /* 2076662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076665 */     // MIs[0] policy
     /* 2076665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076675 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076701 */     // GIR_Coverage, 15857,
     /* 2076701 */     GIR_EraseRootFromParent_Done,
     /* 2076702 */   // Label 27593: @2076702
     /* 2076702 */   GIM_Try, /*On fail goto*//*Label 27594*/ GIMT_Encode4(2076793), // Rule ID 15860 //
     /* 2076707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2076710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2076718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2076721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2076724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2076727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076753 */     // MIs[0] round
     /* 2076753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076756 */     // MIs[0] policy
     /* 2076756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076766 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2076789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076792 */     // GIR_Coverage, 15860,
     /* 2076792 */     GIR_EraseRootFromParent_Done,
     /* 2076793 */   // Label 27594: @2076793
     /* 2076793 */   GIM_Try, /*On fail goto*//*Label 27595*/ GIMT_Encode4(2076884), // Rule ID 15861 //
     /* 2076798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2076801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2076809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2076812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2076815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2076818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076844 */     // MIs[0] round
     /* 2076844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076847 */     // MIs[0] policy
     /* 2076847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076857 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2076880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076883 */     // GIR_Coverage, 15861,
     /* 2076883 */     GIR_EraseRootFromParent_Done,
     /* 2076884 */   // Label 27595: @2076884
     /* 2076884 */   GIM_Try, /*On fail goto*//*Label 27596*/ GIMT_Encode4(2076975), // Rule ID 15864 //
     /* 2076889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2076900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2076903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2076906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2076909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2076919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076935 */     // MIs[0] round
     /* 2076935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076938 */     // MIs[0] policy
     /* 2076938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2076951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076974 */     // GIR_Coverage, 15864,
     /* 2076974 */     GIR_EraseRootFromParent_Done,
     /* 2076975 */   // Label 27596: @2076975
     /* 2076975 */   GIM_Try, /*On fail goto*//*Label 27597*/ GIMT_Encode4(2077066), // Rule ID 15865 //
     /* 2076980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2076991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2076994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2076997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2077000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077026 */     // MIs[0] round
     /* 2077026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077029 */     // MIs[0] policy
     /* 2077029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077039 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077065 */     // GIR_Coverage, 15865,
     /* 2077065 */     GIR_EraseRootFromParent_Done,
     /* 2077066 */   // Label 27597: @2077066
     /* 2077066 */   GIM_Try, /*On fail goto*//*Label 27598*/ GIMT_Encode4(2077157), // Rule ID 15868 //
     /* 2077071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2077082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2077085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2077088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2077091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077117 */     // MIs[0] round
     /* 2077117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077120 */     // MIs[0] policy
     /* 2077120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077130 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077156 */     // GIR_Coverage, 15868,
     /* 2077156 */     GIR_EraseRootFromParent_Done,
     /* 2077157 */   // Label 27598: @2077157
     /* 2077157 */   GIM_Try, /*On fail goto*//*Label 27599*/ GIMT_Encode4(2077248), // Rule ID 15869 //
     /* 2077162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2077173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2077176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2077179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2077182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077208 */     // MIs[0] round
     /* 2077208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077211 */     // MIs[0] policy
     /* 2077211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077221 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077247 */     // GIR_Coverage, 15869,
     /* 2077247 */     GIR_EraseRootFromParent_Done,
     /* 2077248 */   // Label 27599: @2077248
     /* 2077248 */   GIM_Try, /*On fail goto*//*Label 27600*/ GIMT_Encode4(2077339), // Rule ID 15872 //
     /* 2077253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2077264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2077267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2077270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2077273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2077276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077299 */     // MIs[0] round
     /* 2077299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077302 */     // MIs[0] policy
     /* 2077302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077312 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077338 */     // GIR_Coverage, 15872,
     /* 2077338 */     GIR_EraseRootFromParent_Done,
     /* 2077339 */   // Label 27600: @2077339
     /* 2077339 */   GIM_Try, /*On fail goto*//*Label 27601*/ GIMT_Encode4(2077430), // Rule ID 15873 //
     /* 2077344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2077355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2077358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2077361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2077364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2077367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077390 */     // MIs[0] round
     /* 2077390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077393 */     // MIs[0] policy
     /* 2077393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077403 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077429 */     // GIR_Coverage, 15873,
     /* 2077429 */     GIR_EraseRootFromParent_Done,
     /* 2077430 */   // Label 27601: @2077430
     /* 2077430 */   GIM_Try, /*On fail goto*//*Label 27602*/ GIMT_Encode4(2077521), // Rule ID 15876 //
     /* 2077435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2077446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2077449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2077452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2077455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077481 */     // MIs[0] round
     /* 2077481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077484 */     // MIs[0] policy
     /* 2077484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077520 */     // GIR_Coverage, 15876,
     /* 2077520 */     GIR_EraseRootFromParent_Done,
     /* 2077521 */   // Label 27602: @2077521
     /* 2077521 */   GIM_Try, /*On fail goto*//*Label 27603*/ GIMT_Encode4(2077612), // Rule ID 15877 //
     /* 2077526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2077537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2077540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2077543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2077546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077572 */     // MIs[0] round
     /* 2077572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077575 */     // MIs[0] policy
     /* 2077575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077585 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077611 */     // GIR_Coverage, 15877,
     /* 2077611 */     GIR_EraseRootFromParent_Done,
     /* 2077612 */   // Label 27603: @2077612
     /* 2077612 */   GIM_Try, /*On fail goto*//*Label 27604*/ GIMT_Encode4(2077703), // Rule ID 15880 //
     /* 2077617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2077628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2077631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2077634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2077637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077663 */     // MIs[0] round
     /* 2077663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077666 */     // MIs[0] policy
     /* 2077666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077702 */     // GIR_Coverage, 15880,
     /* 2077702 */     GIR_EraseRootFromParent_Done,
     /* 2077703 */   // Label 27604: @2077703
     /* 2077703 */   GIM_Try, /*On fail goto*//*Label 27605*/ GIMT_Encode4(2077794), // Rule ID 15881 //
     /* 2077708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2077719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2077722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2077725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2077728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077754 */     // MIs[0] round
     /* 2077754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077757 */     // MIs[0] policy
     /* 2077757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077767 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077793 */     // GIR_Coverage, 15881,
     /* 2077793 */     GIR_EraseRootFromParent_Done,
     /* 2077794 */   // Label 27605: @2077794
     /* 2077794 */   GIM_Try, /*On fail goto*//*Label 27606*/ GIMT_Encode4(2077885), // Rule ID 15884 //
     /* 2077799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2077810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2077813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2077816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2077819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077845 */     // MIs[0] round
     /* 2077845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077848 */     // MIs[0] policy
     /* 2077848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077858 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077884 */     // GIR_Coverage, 15884,
     /* 2077884 */     GIR_EraseRootFromParent_Done,
     /* 2077885 */   // Label 27606: @2077885
     /* 2077885 */   GIM_Try, /*On fail goto*//*Label 27607*/ GIMT_Encode4(2077976), // Rule ID 15885 //
     /* 2077890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2077901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2077904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2077907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2077910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077936 */     // MIs[0] round
     /* 2077936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077939 */     // MIs[0] policy
     /* 2077939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077949 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077975 */     // GIR_Coverage, 15885,
     /* 2077975 */     GIR_EraseRootFromParent_Done,
     /* 2077976 */   // Label 27607: @2077976
     /* 2077976 */   GIM_Try, /*On fail goto*//*Label 27608*/ GIMT_Encode4(2078067), // Rule ID 15888 //
     /* 2077981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2077992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2077995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2077998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2078001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078027 */     // MIs[0] round
     /* 2078027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078030 */     // MIs[0] policy
     /* 2078030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2078043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078066 */     // GIR_Coverage, 15888,
     /* 2078066 */     GIR_EraseRootFromParent_Done,
     /* 2078067 */   // Label 27608: @2078067
     /* 2078067 */   GIM_Try, /*On fail goto*//*Label 27609*/ GIMT_Encode4(2078158), // Rule ID 15889 //
     /* 2078072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2078083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2078086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2078089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2078092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078118 */     // MIs[0] round
     /* 2078118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078121 */     // MIs[0] policy
     /* 2078121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078131 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2078134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078157 */     // GIR_Coverage, 15889,
     /* 2078157 */     GIR_EraseRootFromParent_Done,
     /* 2078158 */   // Label 27609: @2078158
     /* 2078158 */   GIM_Try, /*On fail goto*//*Label 27610*/ GIMT_Encode4(2078249), // Rule ID 15892 //
     /* 2078163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2078174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2078177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2078180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2078183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078209 */     // MIs[0] round
     /* 2078209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078212 */     // MIs[0] policy
     /* 2078212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078222 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2078225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078248 */     // GIR_Coverage, 15892,
     /* 2078248 */     GIR_EraseRootFromParent_Done,
     /* 2078249 */   // Label 27610: @2078249
     /* 2078249 */   GIM_Try, /*On fail goto*//*Label 27611*/ GIMT_Encode4(2078340), // Rule ID 15893 //
     /* 2078254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2078265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2078268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2078271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2078274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078300 */     // MIs[0] round
     /* 2078300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078303 */     // MIs[0] policy
     /* 2078303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078313 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2078316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078339 */     // GIR_Coverage, 15893,
     /* 2078339 */     GIR_EraseRootFromParent_Done,
     /* 2078340 */   // Label 27611: @2078340
     /* 2078340 */   GIM_Try, /*On fail goto*//*Label 27612*/ GIMT_Encode4(2078431), // Rule ID 15896 //
     /* 2078345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2078356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2078359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2078362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2078365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2078368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078391 */     // MIs[0] round
     /* 2078391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078394 */     // MIs[0] policy
     /* 2078394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078404 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2078407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078430 */     // GIR_Coverage, 15896,
     /* 2078430 */     GIR_EraseRootFromParent_Done,
     /* 2078431 */   // Label 27612: @2078431
     /* 2078431 */   GIM_Try, /*On fail goto*//*Label 27613*/ GIMT_Encode4(2078522), // Rule ID 15897 //
     /* 2078436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2078447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2078450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2078453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2078456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2078459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078482 */     // MIs[0] round
     /* 2078482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078485 */     // MIs[0] policy
     /* 2078485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078495 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2078498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078521 */     // GIR_Coverage, 15897,
     /* 2078521 */     GIR_EraseRootFromParent_Done,
     /* 2078522 */   // Label 27613: @2078522
     /* 2078522 */   GIM_Try, /*On fail goto*//*Label 27614*/ GIMT_Encode4(2078613), // Rule ID 15900 //
     /* 2078527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2078538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2078541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2078544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2078547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078573 */     // MIs[0] round
     /* 2078573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078576 */     // MIs[0] policy
     /* 2078576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2078589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078612 */     // GIR_Coverage, 15900,
     /* 2078612 */     GIR_EraseRootFromParent_Done,
     /* 2078613 */   // Label 27614: @2078613
     /* 2078613 */   GIM_Try, /*On fail goto*//*Label 27615*/ GIMT_Encode4(2078704), // Rule ID 15901 //
     /* 2078618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2078629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2078632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2078635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2078638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078664 */     // MIs[0] round
     /* 2078664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078667 */     // MIs[0] policy
     /* 2078667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078677 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2078680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078703 */     // GIR_Coverage, 15901,
     /* 2078703 */     GIR_EraseRootFromParent_Done,
     /* 2078704 */   // Label 27615: @2078704
     /* 2078704 */   GIM_Try, /*On fail goto*//*Label 27616*/ GIMT_Encode4(2078795), // Rule ID 15904 //
     /* 2078709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2078720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2078723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2078726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2078729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078755 */     // MIs[0] round
     /* 2078755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078758 */     // MIs[0] policy
     /* 2078758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078768 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2078771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078794 */     // GIR_Coverage, 15904,
     /* 2078794 */     GIR_EraseRootFromParent_Done,
     /* 2078795 */   // Label 27616: @2078795
     /* 2078795 */   GIM_Try, /*On fail goto*//*Label 27617*/ GIMT_Encode4(2078886), // Rule ID 15905 //
     /* 2078800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2078811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2078814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2078817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2078820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078846 */     // MIs[0] round
     /* 2078846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078849 */     // MIs[0] policy
     /* 2078849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078859 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2078862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078885 */     // GIR_Coverage, 15905,
     /* 2078885 */     GIR_EraseRootFromParent_Done,
     /* 2078886 */   // Label 27617: @2078886
     /* 2078886 */   GIM_Try, /*On fail goto*//*Label 27618*/ GIMT_Encode4(2078977), // Rule ID 15908 //
     /* 2078891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2078902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2078905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2078908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2078911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078937 */     // MIs[0] round
     /* 2078937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078940 */     // MIs[0] policy
     /* 2078940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078950 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2078953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078976 */     // GIR_Coverage, 15908,
     /* 2078976 */     GIR_EraseRootFromParent_Done,
     /* 2078977 */   // Label 27618: @2078977
     /* 2078977 */   GIM_Try, /*On fail goto*//*Label 27619*/ GIMT_Encode4(2079068), // Rule ID 15909 //
     /* 2078982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2078993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2078996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2078999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2079002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2079012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079028 */     // MIs[0] round
     /* 2079028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079031 */     // MIs[0] policy
     /* 2079031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079041 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2079044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079067 */     // GIR_Coverage, 15909,
     /* 2079067 */     GIR_EraseRootFromParent_Done,
     /* 2079068 */   // Label 27619: @2079068
     /* 2079068 */   GIM_Try, /*On fail goto*//*Label 27620*/ GIMT_Encode4(2079159), // Rule ID 15912 //
     /* 2079073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2079084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2079087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2079090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079119 */     // MIs[0] round
     /* 2079119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079122 */     // MIs[0] policy
     /* 2079122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079132 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2079135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079158 */     // GIR_Coverage, 15912,
     /* 2079158 */     GIR_EraseRootFromParent_Done,
     /* 2079159 */   // Label 27620: @2079159
     /* 2079159 */   GIM_Try, /*On fail goto*//*Label 27621*/ GIMT_Encode4(2079250), // Rule ID 15913 //
     /* 2079164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2079175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2079178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2079181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079210 */     // MIs[0] round
     /* 2079210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079213 */     // MIs[0] policy
     /* 2079213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079223 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2079226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079249 */     // GIR_Coverage, 15913,
     /* 2079249 */     GIR_EraseRootFromParent_Done,
     /* 2079250 */   // Label 27621: @2079250
     /* 2079250 */   GIM_Try, /*On fail goto*//*Label 27622*/ GIMT_Encode4(2079341), // Rule ID 15916 //
     /* 2079255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2079266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2079269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2079272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079301 */     // MIs[0] round
     /* 2079301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079304 */     // MIs[0] policy
     /* 2079304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079314 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2079317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079340 */     // GIR_Coverage, 15916,
     /* 2079340 */     GIR_EraseRootFromParent_Done,
     /* 2079341 */   // Label 27622: @2079341
     /* 2079341 */   GIM_Try, /*On fail goto*//*Label 27623*/ GIMT_Encode4(2079432), // Rule ID 15917 //
     /* 2079346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2079357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2079360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2079363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079392 */     // MIs[0] round
     /* 2079392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079395 */     // MIs[0] policy
     /* 2079395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079405 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2079408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079431 */     // GIR_Coverage, 15917,
     /* 2079431 */     GIR_EraseRootFromParent_Done,
     /* 2079432 */   // Label 27623: @2079432
     /* 2079432 */   GIM_Try, /*On fail goto*//*Label 27624*/ GIMT_Encode4(2079523), // Rule ID 15920 //
     /* 2079437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2079448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2079451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2079454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079483 */     // MIs[0] round
     /* 2079483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079486 */     // MIs[0] policy
     /* 2079486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079522 */     // GIR_Coverage, 15920,
     /* 2079522 */     GIR_EraseRootFromParent_Done,
     /* 2079523 */   // Label 27624: @2079523
     /* 2079523 */   GIM_Try, /*On fail goto*//*Label 27625*/ GIMT_Encode4(2079614), // Rule ID 15921 //
     /* 2079528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2079539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2079542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2079545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079574 */     // MIs[0] round
     /* 2079574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079577 */     // MIs[0] policy
     /* 2079577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079587 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079613 */     // GIR_Coverage, 15921,
     /* 2079613 */     GIR_EraseRootFromParent_Done,
     /* 2079614 */   // Label 27625: @2079614
     /* 2079614 */   GIM_Try, /*On fail goto*//*Label 27626*/ GIMT_Encode4(2079705), // Rule ID 15924 //
     /* 2079619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2079630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2079633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2079636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079665 */     // MIs[0] round
     /* 2079665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079668 */     // MIs[0] policy
     /* 2079668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079678 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2079681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079704 */     // GIR_Coverage, 15924,
     /* 2079704 */     GIR_EraseRootFromParent_Done,
     /* 2079705 */   // Label 27626: @2079705
     /* 2079705 */   GIM_Try, /*On fail goto*//*Label 27627*/ GIMT_Encode4(2079796), // Rule ID 15925 //
     /* 2079710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2079721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2079724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2079727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079756 */     // MIs[0] round
     /* 2079756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079759 */     // MIs[0] policy
     /* 2079759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079769 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2079772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079795 */     // GIR_Coverage, 15925,
     /* 2079795 */     GIR_EraseRootFromParent_Done,
     /* 2079796 */   // Label 27627: @2079796
     /* 2079796 */   GIM_Try, /*On fail goto*//*Label 27628*/ GIMT_Encode4(2079887), // Rule ID 15928 //
     /* 2079801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2079812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2079815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2079818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079847 */     // MIs[0] round
     /* 2079847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079850 */     // MIs[0] policy
     /* 2079850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079886 */     // GIR_Coverage, 15928,
     /* 2079886 */     GIR_EraseRootFromParent_Done,
     /* 2079887 */   // Label 27628: @2079887
     /* 2079887 */   GIM_Try, /*On fail goto*//*Label 27629*/ GIMT_Encode4(2079978), // Rule ID 15929 //
     /* 2079892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2079903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2079906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2079909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079938 */     // MIs[0] round
     /* 2079938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079941 */     // MIs[0] policy
     /* 2079941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079951 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079977 */     // GIR_Coverage, 15929,
     /* 2079977 */     GIR_EraseRootFromParent_Done,
     /* 2079978 */   // Label 27629: @2079978
     /* 2079978 */   GIM_Try, /*On fail goto*//*Label 27630*/ GIMT_Encode4(2080069), // Rule ID 15932 //
     /* 2079983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2079994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2079997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2080000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080029 */     // MIs[0] round
     /* 2080029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080032 */     // MIs[0] policy
     /* 2080032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2080045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080068 */     // GIR_Coverage, 15932,
     /* 2080068 */     GIR_EraseRootFromParent_Done,
     /* 2080069 */   // Label 27630: @2080069
     /* 2080069 */   GIM_Try, /*On fail goto*//*Label 27631*/ GIMT_Encode4(2080160), // Rule ID 15933 //
     /* 2080074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2080085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2080088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2080091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080120 */     // MIs[0] round
     /* 2080120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080123 */     // MIs[0] policy
     /* 2080123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080133 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2080136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080159 */     // GIR_Coverage, 15933,
     /* 2080159 */     GIR_EraseRootFromParent_Done,
     /* 2080160 */   // Label 27631: @2080160
     /* 2080160 */   GIM_Try, /*On fail goto*//*Label 27632*/ GIMT_Encode4(2080251), // Rule ID 15936 //
     /* 2080165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2080176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2080179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2080182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080211 */     // MIs[0] round
     /* 2080211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080214 */     // MIs[0] policy
     /* 2080214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080250 */     // GIR_Coverage, 15936,
     /* 2080250 */     GIR_EraseRootFromParent_Done,
     /* 2080251 */   // Label 27632: @2080251
     /* 2080251 */   GIM_Try, /*On fail goto*//*Label 27633*/ GIMT_Encode4(2080342), // Rule ID 15937 //
     /* 2080256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2080267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2080270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2080273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080302 */     // MIs[0] round
     /* 2080302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080305 */     // MIs[0] policy
     /* 2080305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080315 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080341 */     // GIR_Coverage, 15937,
     /* 2080341 */     GIR_EraseRootFromParent_Done,
     /* 2080342 */   // Label 27633: @2080342
     /* 2080342 */   GIM_Try, /*On fail goto*//*Label 27634*/ GIMT_Encode4(2080433), // Rule ID 15940 //
     /* 2080347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2080358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2080361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2080364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2080370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080393 */     // MIs[0] round
     /* 2080393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080396 */     // MIs[0] policy
     /* 2080396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080406 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080432 */     // GIR_Coverage, 15940,
     /* 2080432 */     GIR_EraseRootFromParent_Done,
     /* 2080433 */   // Label 27634: @2080433
     /* 2080433 */   GIM_Try, /*On fail goto*//*Label 27635*/ GIMT_Encode4(2080524), // Rule ID 15941 //
     /* 2080438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2080449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2080452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2080455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2080461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080484 */     // MIs[0] round
     /* 2080484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080487 */     // MIs[0] policy
     /* 2080487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080497 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080523 */     // GIR_Coverage, 15941,
     /* 2080523 */     GIR_EraseRootFromParent_Done,
     /* 2080524 */   // Label 27635: @2080524
     /* 2080524 */   GIM_Try, /*On fail goto*//*Label 27636*/ GIMT_Encode4(2080615), // Rule ID 15944 //
     /* 2080529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2080540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2080543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2080546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080575 */     // MIs[0] round
     /* 2080575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080578 */     // MIs[0] policy
     /* 2080578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080614 */     // GIR_Coverage, 15944,
     /* 2080614 */     GIR_EraseRootFromParent_Done,
     /* 2080615 */   // Label 27636: @2080615
     /* 2080615 */   GIM_Try, /*On fail goto*//*Label 27637*/ GIMT_Encode4(2080706), // Rule ID 15945 //
     /* 2080620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2080631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2080634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2080637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080666 */     // MIs[0] round
     /* 2080666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080669 */     // MIs[0] policy
     /* 2080669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080679 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080705 */     // GIR_Coverage, 15945,
     /* 2080705 */     GIR_EraseRootFromParent_Done,
     /* 2080706 */   // Label 27637: @2080706
     /* 2080706 */   GIM_Try, /*On fail goto*//*Label 27638*/ GIMT_Encode4(2080797), // Rule ID 15948 //
     /* 2080711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2080714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2080722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2080725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2080728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080757 */     // MIs[0] round
     /* 2080757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080760 */     // MIs[0] policy
     /* 2080760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080770 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080796 */     // GIR_Coverage, 15948,
     /* 2080796 */     GIR_EraseRootFromParent_Done,
     /* 2080797 */   // Label 27638: @2080797
     /* 2080797 */   GIM_Try, /*On fail goto*//*Label 27639*/ GIMT_Encode4(2080888), // Rule ID 15949 //
     /* 2080802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2080805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2080813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2080816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2080819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080848 */     // MIs[0] round
     /* 2080848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080851 */     // MIs[0] policy
     /* 2080851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080861 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080887 */     // GIR_Coverage, 15949,
     /* 2080887 */     GIR_EraseRootFromParent_Done,
     /* 2080888 */   // Label 27639: @2080888
     /* 2080888 */   GIM_Try, /*On fail goto*//*Label 27640*/ GIMT_Encode4(2080979), // Rule ID 15952 //
     /* 2080893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2080904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2080907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2080910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080939 */     // MIs[0] round
     /* 2080939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080942 */     // MIs[0] policy
     /* 2080942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080952 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2080955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080978 */     // GIR_Coverage, 15952,
     /* 2080978 */     GIR_EraseRootFromParent_Done,
     /* 2080979 */   // Label 27640: @2080979
     /* 2080979 */   GIM_Try, /*On fail goto*//*Label 27641*/ GIMT_Encode4(2081070), // Rule ID 15953 //
     /* 2080984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2080995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2080998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2081001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081030 */     // MIs[0] round
     /* 2081030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081033 */     // MIs[0] policy
     /* 2081033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081069 */     // GIR_Coverage, 15953,
     /* 2081069 */     GIR_EraseRootFromParent_Done,
     /* 2081070 */   // Label 27641: @2081070
     /* 2081070 */   GIM_Try, /*On fail goto*//*Label 27642*/ GIMT_Encode4(2081161), // Rule ID 15956 //
     /* 2081075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2081086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2081089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2081092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081121 */     // MIs[0] round
     /* 2081121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081124 */     // MIs[0] policy
     /* 2081124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081134 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081160 */     // GIR_Coverage, 15956,
     /* 2081160 */     GIR_EraseRootFromParent_Done,
     /* 2081161 */   // Label 27642: @2081161
     /* 2081161 */   GIM_Try, /*On fail goto*//*Label 27643*/ GIMT_Encode4(2081252), // Rule ID 15957 //
     /* 2081166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2081177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2081180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2081183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081212 */     // MIs[0] round
     /* 2081212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081215 */     // MIs[0] policy
     /* 2081215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081225 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081251 */     // GIR_Coverage, 15957,
     /* 2081251 */     GIR_EraseRootFromParent_Done,
     /* 2081252 */   // Label 27643: @2081252
     /* 2081252 */   GIM_Try, /*On fail goto*//*Label 27644*/ GIMT_Encode4(2081343), // Rule ID 15960 //
     /* 2081257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2081268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2081271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2081274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2081280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081303 */     // MIs[0] round
     /* 2081303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081306 */     // MIs[0] policy
     /* 2081306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081316 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081342 */     // GIR_Coverage, 15960,
     /* 2081342 */     GIR_EraseRootFromParent_Done,
     /* 2081343 */   // Label 27644: @2081343
     /* 2081343 */   GIM_Try, /*On fail goto*//*Label 27645*/ GIMT_Encode4(2081434), // Rule ID 15961 //
     /* 2081348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2081359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2081362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2081365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2081371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081394 */     // MIs[0] round
     /* 2081394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081397 */     // MIs[0] policy
     /* 2081397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081407 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081433 */     // GIR_Coverage, 15961,
     /* 2081433 */     GIR_EraseRootFromParent_Done,
     /* 2081434 */   // Label 27645: @2081434
     /* 2081434 */   GIM_Try, /*On fail goto*//*Label 27646*/ GIMT_Encode4(2081525), // Rule ID 15964 //
     /* 2081439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2081450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2081453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2081456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081485 */     // MIs[0] round
     /* 2081485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081488 */     // MIs[0] policy
     /* 2081488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081498 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081524 */     // GIR_Coverage, 15964,
     /* 2081524 */     GIR_EraseRootFromParent_Done,
     /* 2081525 */   // Label 27646: @2081525
     /* 2081525 */   GIM_Try, /*On fail goto*//*Label 27647*/ GIMT_Encode4(2081616), // Rule ID 15965 //
     /* 2081530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2081541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2081544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2081547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081576 */     // MIs[0] round
     /* 2081576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081579 */     // MIs[0] policy
     /* 2081579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081589 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081615 */     // GIR_Coverage, 15965,
     /* 2081615 */     GIR_EraseRootFromParent_Done,
     /* 2081616 */   // Label 27647: @2081616
     /* 2081616 */   GIM_Try, /*On fail goto*//*Label 27648*/ GIMT_Encode4(2081707), // Rule ID 15968 //
     /* 2081621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2081632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2081635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2081638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081667 */     // MIs[0] round
     /* 2081667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081670 */     // MIs[0] policy
     /* 2081670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081680 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081706 */     // GIR_Coverage, 15968,
     /* 2081706 */     GIR_EraseRootFromParent_Done,
     /* 2081707 */   // Label 27648: @2081707
     /* 2081707 */   GIM_Try, /*On fail goto*//*Label 27649*/ GIMT_Encode4(2081798), // Rule ID 15969 //
     /* 2081712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2081723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2081726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2081729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081758 */     // MIs[0] round
     /* 2081758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081761 */     // MIs[0] policy
     /* 2081761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081797 */     // GIR_Coverage, 15969,
     /* 2081797 */     GIR_EraseRootFromParent_Done,
     /* 2081798 */   // Label 27649: @2081798
     /* 2081798 */   GIM_Try, /*On fail goto*//*Label 27650*/ GIMT_Encode4(2081889), // Rule ID 15972 //
     /* 2081803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2081814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2081817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2081820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081849 */     // MIs[0] round
     /* 2081849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081852 */     // MIs[0] policy
     /* 2081852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081862 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081888 */     // GIR_Coverage, 15972,
     /* 2081888 */     GIR_EraseRootFromParent_Done,
     /* 2081889 */   // Label 27650: @2081889
     /* 2081889 */   GIM_Try, /*On fail goto*//*Label 27651*/ GIMT_Encode4(2081980), // Rule ID 15973 //
     /* 2081894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2081905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2081908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2081911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081940 */     // MIs[0] round
     /* 2081940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081943 */     // MIs[0] policy
     /* 2081943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081953 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081979 */     // GIR_Coverage, 15973,
     /* 2081979 */     GIR_EraseRootFromParent_Done,
     /* 2081980 */   // Label 27651: @2081980
     /* 2081980 */   GIM_Try, /*On fail goto*//*Label 27652*/ GIMT_Encode4(2082071), // Rule ID 15976 //
     /* 2081985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2081996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2081999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2082002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082031 */     // MIs[0] round
     /* 2082031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082034 */     // MIs[0] policy
     /* 2082034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082044 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2082047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082070 */     // GIR_Coverage, 15976,
     /* 2082070 */     GIR_EraseRootFromParent_Done,
     /* 2082071 */   // Label 27652: @2082071
     /* 2082071 */   GIM_Try, /*On fail goto*//*Label 27653*/ GIMT_Encode4(2082162), // Rule ID 15977 //
     /* 2082076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2082087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2082090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2082093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082122 */     // MIs[0] round
     /* 2082122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082125 */     // MIs[0] policy
     /* 2082125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2082138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082161 */     // GIR_Coverage, 15977,
     /* 2082161 */     GIR_EraseRootFromParent_Done,
     /* 2082162 */   // Label 27653: @2082162
     /* 2082162 */   GIM_Try, /*On fail goto*//*Label 27654*/ GIMT_Encode4(2082253), // Rule ID 15980 //
     /* 2082167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2082178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2082181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2082184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082213 */     // MIs[0] round
     /* 2082213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082216 */     // MIs[0] policy
     /* 2082216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082226 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2082229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082252 */     // GIR_Coverage, 15980,
     /* 2082252 */     GIR_EraseRootFromParent_Done,
     /* 2082253 */   // Label 27654: @2082253
     /* 2082253 */   GIM_Try, /*On fail goto*//*Label 27655*/ GIMT_Encode4(2082344), // Rule ID 15981 //
     /* 2082258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2082269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2082272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2082275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082304 */     // MIs[0] round
     /* 2082304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082307 */     // MIs[0] policy
     /* 2082307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082317 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2082320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082343 */     // GIR_Coverage, 15981,
     /* 2082343 */     GIR_EraseRootFromParent_Done,
     /* 2082344 */   // Label 27655: @2082344
     /* 2082344 */   GIM_Try, /*On fail goto*//*Label 27656*/ GIMT_Encode4(2082435), // Rule ID 15984 //
     /* 2082349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2082360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2082363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2082366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2082372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082395 */     // MIs[0] round
     /* 2082395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082398 */     // MIs[0] policy
     /* 2082398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082408 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2082411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082434 */     // GIR_Coverage, 15984,
     /* 2082434 */     GIR_EraseRootFromParent_Done,
     /* 2082435 */   // Label 27656: @2082435
     /* 2082435 */   GIM_Try, /*On fail goto*//*Label 27657*/ GIMT_Encode4(2082526), // Rule ID 15985 //
     /* 2082440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2082451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2082454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2082457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2082463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082486 */     // MIs[0] round
     /* 2082486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082489 */     // MIs[0] policy
     /* 2082489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2082502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082525 */     // GIR_Coverage, 15985,
     /* 2082525 */     GIR_EraseRootFromParent_Done,
     /* 2082526 */   // Label 27657: @2082526
     /* 2082526 */   GIM_Try, /*On fail goto*//*Label 27658*/ GIMT_Encode4(2082617), // Rule ID 15988 //
     /* 2082531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2082542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2082545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2082548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082577 */     // MIs[0] round
     /* 2082577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082580 */     // MIs[0] policy
     /* 2082580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2082593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082616 */     // GIR_Coverage, 15988,
     /* 2082616 */     GIR_EraseRootFromParent_Done,
     /* 2082617 */   // Label 27658: @2082617
     /* 2082617 */   GIM_Try, /*On fail goto*//*Label 27659*/ GIMT_Encode4(2082708), // Rule ID 15989 //
     /* 2082622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2082633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2082636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2082639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082668 */     // MIs[0] round
     /* 2082668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082671 */     // MIs[0] policy
     /* 2082671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2082684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082707 */     // GIR_Coverage, 15989,
     /* 2082707 */     GIR_EraseRootFromParent_Done,
     /* 2082708 */   // Label 27659: @2082708
     /* 2082708 */   GIM_Try, /*On fail goto*//*Label 27660*/ GIMT_Encode4(2082799), // Rule ID 15992 //
     /* 2082713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2082724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2082727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2082730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082759 */     // MIs[0] round
     /* 2082759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082762 */     // MIs[0] policy
     /* 2082762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082772 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2082775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082798 */     // GIR_Coverage, 15992,
     /* 2082798 */     GIR_EraseRootFromParent_Done,
     /* 2082799 */   // Label 27660: @2082799
     /* 2082799 */   GIM_Try, /*On fail goto*//*Label 27661*/ GIMT_Encode4(2082890), // Rule ID 15993 //
     /* 2082804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2082815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2082818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2082821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082850 */     // MIs[0] round
     /* 2082850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082853 */     // MIs[0] policy
     /* 2082853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082863 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2082866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082889 */     // GIR_Coverage, 15993,
     /* 2082889 */     GIR_EraseRootFromParent_Done,
     /* 2082890 */   // Label 27661: @2082890
     /* 2082890 */   GIM_Try, /*On fail goto*//*Label 27662*/ GIMT_Encode4(2082981), // Rule ID 15996 //
     /* 2082895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2082906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2082909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2082912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082941 */     // MIs[0] round
     /* 2082941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082944 */     // MIs[0] policy
     /* 2082944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2082957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082980 */     // GIR_Coverage, 15996,
     /* 2082980 */     GIR_EraseRootFromParent_Done,
     /* 2082981 */   // Label 27662: @2082981
     /* 2082981 */   GIM_Try, /*On fail goto*//*Label 27663*/ GIMT_Encode4(2083072), // Rule ID 15997 //
     /* 2082986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2082997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2083000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2083003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2083016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083032 */     // MIs[0] round
     /* 2083032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083035 */     // MIs[0] policy
     /* 2083035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083045 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2083048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083071 */     // GIR_Coverage, 15997,
     /* 2083071 */     GIR_EraseRootFromParent_Done,
     /* 2083072 */   // Label 27663: @2083072
     /* 2083072 */   GIM_Try, /*On fail goto*//*Label 27664*/ GIMT_Encode4(2083163), // Rule ID 16088 //
     /* 2083077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2083088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2083091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2083094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2083097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083123 */     // MIs[0] round
     /* 2083123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083126 */     // MIs[0] policy
     /* 2083126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083136 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2083139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083162 */     // GIR_Coverage, 16088,
     /* 2083162 */     GIR_EraseRootFromParent_Done,
     /* 2083163 */   // Label 27664: @2083163
     /* 2083163 */   GIM_Try, /*On fail goto*//*Label 27665*/ GIMT_Encode4(2083254), // Rule ID 16089 //
     /* 2083168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2083179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2083182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2083185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2083188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083214 */     // MIs[0] round
     /* 2083214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083217 */     // MIs[0] policy
     /* 2083217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083227 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2083230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083253 */     // GIR_Coverage, 16089,
     /* 2083253 */     GIR_EraseRootFromParent_Done,
     /* 2083254 */   // Label 27665: @2083254
     /* 2083254 */   GIM_Try, /*On fail goto*//*Label 27666*/ GIMT_Encode4(2083345), // Rule ID 16092 //
     /* 2083259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2083270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2083273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2083276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2083279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083305 */     // MIs[0] round
     /* 2083305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083308 */     // MIs[0] policy
     /* 2083308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083318 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2083321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083344 */     // GIR_Coverage, 16092,
     /* 2083344 */     GIR_EraseRootFromParent_Done,
     /* 2083345 */   // Label 27666: @2083345
     /* 2083345 */   GIM_Try, /*On fail goto*//*Label 27667*/ GIMT_Encode4(2083436), // Rule ID 16093 //
     /* 2083350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2083361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2083364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2083367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2083370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083396 */     // MIs[0] round
     /* 2083396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083399 */     // MIs[0] policy
     /* 2083399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083409 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2083412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083435 */     // GIR_Coverage, 16093,
     /* 2083435 */     GIR_EraseRootFromParent_Done,
     /* 2083436 */   // Label 27667: @2083436
     /* 2083436 */   GIM_Try, /*On fail goto*//*Label 27668*/ GIMT_Encode4(2083527), // Rule ID 16096 //
     /* 2083441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2083452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2083455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2083458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2083461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083487 */     // MIs[0] round
     /* 2083487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083490 */     // MIs[0] policy
     /* 2083490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083500 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083526 */     // GIR_Coverage, 16096,
     /* 2083526 */     GIR_EraseRootFromParent_Done,
     /* 2083527 */   // Label 27668: @2083527
     /* 2083527 */   GIM_Try, /*On fail goto*//*Label 27669*/ GIMT_Encode4(2083618), // Rule ID 16097 //
     /* 2083532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2083543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2083546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2083549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2083552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083578 */     // MIs[0] round
     /* 2083578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083581 */     // MIs[0] policy
     /* 2083581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083591 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083617 */     // GIR_Coverage, 16097,
     /* 2083617 */     GIR_EraseRootFromParent_Done,
     /* 2083618 */   // Label 27669: @2083618
     /* 2083618 */   GIM_Try, /*On fail goto*//*Label 27670*/ GIMT_Encode4(2083709), // Rule ID 16100 //
     /* 2083623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2083634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2083637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2083643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083669 */     // MIs[0] round
     /* 2083669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083672 */     // MIs[0] policy
     /* 2083672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083682 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2083685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083708 */     // GIR_Coverage, 16100,
     /* 2083708 */     GIR_EraseRootFromParent_Done,
     /* 2083709 */   // Label 27670: @2083709
     /* 2083709 */   GIM_Try, /*On fail goto*//*Label 27671*/ GIMT_Encode4(2083800), // Rule ID 16101 //
     /* 2083714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2083725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2083728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2083734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083760 */     // MIs[0] round
     /* 2083760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083763 */     // MIs[0] policy
     /* 2083763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083773 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2083776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083799 */     // GIR_Coverage, 16101,
     /* 2083799 */     GIR_EraseRootFromParent_Done,
     /* 2083800 */   // Label 27671: @2083800
     /* 2083800 */   GIM_Try, /*On fail goto*//*Label 27672*/ GIMT_Encode4(2083891), // Rule ID 16104 //
     /* 2083805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2083816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2083819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2083822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2083825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083851 */     // MIs[0] round
     /* 2083851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083854 */     // MIs[0] policy
     /* 2083854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083864 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083890 */     // GIR_Coverage, 16104,
     /* 2083890 */     GIR_EraseRootFromParent_Done,
     /* 2083891 */   // Label 27672: @2083891
     /* 2083891 */   GIM_Try, /*On fail goto*//*Label 27673*/ GIMT_Encode4(2083982), // Rule ID 16105 //
     /* 2083896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2083907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2083910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2083913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2083916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083942 */     // MIs[0] round
     /* 2083942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083945 */     // MIs[0] policy
     /* 2083945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083955 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083981 */     // GIR_Coverage, 16105,
     /* 2083981 */     GIR_EraseRootFromParent_Done,
     /* 2083982 */   // Label 27673: @2083982
     /* 2083982 */   GIM_Try, /*On fail goto*//*Label 27674*/ GIMT_Encode4(2084073), // Rule ID 16108 //
     /* 2083987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2083998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2084001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2084004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2084007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084033 */     // MIs[0] round
     /* 2084033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084036 */     // MIs[0] policy
     /* 2084036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2084049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084072 */     // GIR_Coverage, 16108,
     /* 2084072 */     GIR_EraseRootFromParent_Done,
     /* 2084073 */   // Label 27674: @2084073
     /* 2084073 */   GIM_Try, /*On fail goto*//*Label 27675*/ GIMT_Encode4(2084164), // Rule ID 16109 //
     /* 2084078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2084089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2084092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2084095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2084098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084124 */     // MIs[0] round
     /* 2084124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084127 */     // MIs[0] policy
     /* 2084127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084137 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2084140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084163 */     // GIR_Coverage, 16109,
     /* 2084163 */     GIR_EraseRootFromParent_Done,
     /* 2084164 */   // Label 27675: @2084164
     /* 2084164 */   GIM_Try, /*On fail goto*//*Label 27676*/ GIMT_Encode4(2084255), // Rule ID 16112 //
     /* 2084169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2084180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2084183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2084186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2084189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084215 */     // MIs[0] round
     /* 2084215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084218 */     // MIs[0] policy
     /* 2084218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084228 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084254 */     // GIR_Coverage, 16112,
     /* 2084254 */     GIR_EraseRootFromParent_Done,
     /* 2084255 */   // Label 27676: @2084255
     /* 2084255 */   GIM_Try, /*On fail goto*//*Label 27677*/ GIMT_Encode4(2084346), // Rule ID 16113 //
     /* 2084260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2084271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2084274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2084277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2084280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084306 */     // MIs[0] round
     /* 2084306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084309 */     // MIs[0] policy
     /* 2084309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084319 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084345 */     // GIR_Coverage, 16113,
     /* 2084345 */     GIR_EraseRootFromParent_Done,
     /* 2084346 */   // Label 27677: @2084346
     /* 2084346 */   GIM_Try, /*On fail goto*//*Label 27678*/ GIMT_Encode4(2084437), // Rule ID 16116 //
     /* 2084351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2084362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2084365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2084368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2084371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2084374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084397 */     // MIs[0] round
     /* 2084397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084400 */     // MIs[0] policy
     /* 2084400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084410 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084436 */     // GIR_Coverage, 16116,
     /* 2084436 */     GIR_EraseRootFromParent_Done,
     /* 2084437 */   // Label 27678: @2084437
     /* 2084437 */   GIM_Try, /*On fail goto*//*Label 27679*/ GIMT_Encode4(2084528), // Rule ID 16117 //
     /* 2084442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2084453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2084456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2084459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2084462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2084465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084488 */     // MIs[0] round
     /* 2084488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084491 */     // MIs[0] policy
     /* 2084491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084501 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084527 */     // GIR_Coverage, 16117,
     /* 2084527 */     GIR_EraseRootFromParent_Done,
     /* 2084528 */   // Label 27679: @2084528
     /* 2084528 */   GIM_Try, /*On fail goto*//*Label 27680*/ GIMT_Encode4(2084619), // Rule ID 16120 //
     /* 2084533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2084544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2084547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2084550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2084553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084579 */     // MIs[0] round
     /* 2084579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084582 */     // MIs[0] policy
     /* 2084582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084592 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084618 */     // GIR_Coverage, 16120,
     /* 2084618 */     GIR_EraseRootFromParent_Done,
     /* 2084619 */   // Label 27680: @2084619
     /* 2084619 */   GIM_Try, /*On fail goto*//*Label 27681*/ GIMT_Encode4(2084710), // Rule ID 16121 //
     /* 2084624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2084635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2084638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2084641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2084644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084670 */     // MIs[0] round
     /* 2084670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084673 */     // MIs[0] policy
     /* 2084673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084683 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084709 */     // GIR_Coverage, 16121,
     /* 2084709 */     GIR_EraseRootFromParent_Done,
     /* 2084710 */   // Label 27681: @2084710
     /* 2084710 */   GIM_Try, /*On fail goto*//*Label 27682*/ GIMT_Encode4(2084801), // Rule ID 16124 //
     /* 2084715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2084718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2084726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2084729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2084732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2084735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084761 */     // MIs[0] round
     /* 2084761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084764 */     // MIs[0] policy
     /* 2084764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2084797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084800 */     // GIR_Coverage, 16124,
     /* 2084800 */     GIR_EraseRootFromParent_Done,
     /* 2084801 */   // Label 27682: @2084801
     /* 2084801 */   GIM_Try, /*On fail goto*//*Label 27683*/ GIMT_Encode4(2084892), // Rule ID 16125 //
     /* 2084806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2084809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2084817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2084820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2084823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2084826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084852 */     // MIs[0] round
     /* 2084852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084855 */     // MIs[0] policy
     /* 2084855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084865 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2084888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084891 */     // GIR_Coverage, 16125,
     /* 2084891 */     GIR_EraseRootFromParent_Done,
     /* 2084892 */   // Label 27683: @2084892
     /* 2084892 */   GIM_Try, /*On fail goto*//*Label 27684*/ GIMT_Encode4(2084983), // Rule ID 16128 //
     /* 2084897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2084908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2084911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2084914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2084917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084943 */     // MIs[0] round
     /* 2084943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084946 */     // MIs[0] policy
     /* 2084946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084956 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2084959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084982 */     // GIR_Coverage, 16128,
     /* 2084982 */     GIR_EraseRootFromParent_Done,
     /* 2084983 */   // Label 27684: @2084983
     /* 2084983 */   GIM_Try, /*On fail goto*//*Label 27685*/ GIMT_Encode4(2085074), // Rule ID 16129 //
     /* 2084988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2084999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2085002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2085005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2085008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085034 */     // MIs[0] round
     /* 2085034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085037 */     // MIs[0] policy
     /* 2085037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085047 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085073 */     // GIR_Coverage, 16129,
     /* 2085073 */     GIR_EraseRootFromParent_Done,
     /* 2085074 */   // Label 27685: @2085074
     /* 2085074 */   GIM_Try, /*On fail goto*//*Label 27686*/ GIMT_Encode4(2085165), // Rule ID 16132 //
     /* 2085079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2085090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2085093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2085096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2085099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085125 */     // MIs[0] round
     /* 2085125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085128 */     // MIs[0] policy
     /* 2085128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085138 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085164 */     // GIR_Coverage, 16132,
     /* 2085164 */     GIR_EraseRootFromParent_Done,
     /* 2085165 */   // Label 27686: @2085165
     /* 2085165 */   GIM_Try, /*On fail goto*//*Label 27687*/ GIMT_Encode4(2085256), // Rule ID 16133 //
     /* 2085170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2085181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2085184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2085187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2085190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085216 */     // MIs[0] round
     /* 2085216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085219 */     // MIs[0] policy
     /* 2085219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085229 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085255 */     // GIR_Coverage, 16133,
     /* 2085255 */     GIR_EraseRootFromParent_Done,
     /* 2085256 */   // Label 27687: @2085256
     /* 2085256 */   GIM_Try, /*On fail goto*//*Label 27688*/ GIMT_Encode4(2085347), // Rule ID 16136 //
     /* 2085261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2085272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2085275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2085278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2085281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2085284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085307 */     // MIs[0] round
     /* 2085307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085310 */     // MIs[0] policy
     /* 2085310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085320 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085346 */     // GIR_Coverage, 16136,
     /* 2085346 */     GIR_EraseRootFromParent_Done,
     /* 2085347 */   // Label 27688: @2085347
     /* 2085347 */   GIM_Try, /*On fail goto*//*Label 27689*/ GIMT_Encode4(2085438), // Rule ID 16137 //
     /* 2085352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2085363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2085366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2085369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2085372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2085375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085398 */     // MIs[0] round
     /* 2085398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085401 */     // MIs[0] policy
     /* 2085401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085411 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085437 */     // GIR_Coverage, 16137,
     /* 2085437 */     GIR_EraseRootFromParent_Done,
     /* 2085438 */   // Label 27689: @2085438
     /* 2085438 */   GIM_Try, /*On fail goto*//*Label 27690*/ GIMT_Encode4(2085529), // Rule ID 16140 //
     /* 2085443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2085454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2085457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2085460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2085463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085489 */     // MIs[0] round
     /* 2085489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085492 */     // MIs[0] policy
     /* 2085492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085528 */     // GIR_Coverage, 16140,
     /* 2085528 */     GIR_EraseRootFromParent_Done,
     /* 2085529 */   // Label 27690: @2085529
     /* 2085529 */   GIM_Try, /*On fail goto*//*Label 27691*/ GIMT_Encode4(2085620), // Rule ID 16141 //
     /* 2085534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2085545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2085548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2085551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2085554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085580 */     // MIs[0] round
     /* 2085580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085583 */     // MIs[0] policy
     /* 2085583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085593 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085619 */     // GIR_Coverage, 16141,
     /* 2085619 */     GIR_EraseRootFromParent_Done,
     /* 2085620 */   // Label 27691: @2085620
     /* 2085620 */   GIM_Try, /*On fail goto*//*Label 27692*/ GIMT_Encode4(2085711), // Rule ID 16144 //
     /* 2085625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2085636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2085639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2085642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2085645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085671 */     // MIs[0] round
     /* 2085671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085674 */     // MIs[0] policy
     /* 2085674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085710 */     // GIR_Coverage, 16144,
     /* 2085710 */     GIR_EraseRootFromParent_Done,
     /* 2085711 */   // Label 27692: @2085711
     /* 2085711 */   GIM_Try, /*On fail goto*//*Label 27693*/ GIMT_Encode4(2085802), // Rule ID 16145 //
     /* 2085716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2085727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2085730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2085733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2085736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085762 */     // MIs[0] round
     /* 2085762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085765 */     // MIs[0] policy
     /* 2085765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085775 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085801 */     // GIR_Coverage, 16145,
     /* 2085801 */     GIR_EraseRootFromParent_Done,
     /* 2085802 */   // Label 27693: @2085802
     /* 2085802 */   GIM_Try, /*On fail goto*//*Label 27694*/ GIMT_Encode4(2085893), // Rule ID 16148 //
     /* 2085807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2085818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2085821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2085824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2085827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085853 */     // MIs[0] round
     /* 2085853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085856 */     // MIs[0] policy
     /* 2085856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085866 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085892 */     // GIR_Coverage, 16148,
     /* 2085892 */     GIR_EraseRootFromParent_Done,
     /* 2085893 */   // Label 27694: @2085893
     /* 2085893 */   GIM_Try, /*On fail goto*//*Label 27695*/ GIMT_Encode4(2085984), // Rule ID 16149 //
     /* 2085898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2085909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2085912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2085915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2085918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085944 */     // MIs[0] round
     /* 2085944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085947 */     // MIs[0] policy
     /* 2085947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085957 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085983 */     // GIR_Coverage, 16149,
     /* 2085983 */     GIR_EraseRootFromParent_Done,
     /* 2085984 */   // Label 27695: @2085984
     /* 2085984 */   GIM_Try, /*On fail goto*//*Label 27696*/ GIMT_Encode4(2086075), // Rule ID 16152 //
     /* 2085989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2086000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2086003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2086006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2086009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086035 */     // MIs[0] round
     /* 2086035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086038 */     // MIs[0] policy
     /* 2086038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2086051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086074 */     // GIR_Coverage, 16152,
     /* 2086074 */     GIR_EraseRootFromParent_Done,
     /* 2086075 */   // Label 27696: @2086075
     /* 2086075 */   GIM_Try, /*On fail goto*//*Label 27697*/ GIMT_Encode4(2086166), // Rule ID 16153 //
     /* 2086080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2086091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2086094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2086097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2086100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086126 */     // MIs[0] round
     /* 2086126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086129 */     // MIs[0] policy
     /* 2086129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2086142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086165 */     // GIR_Coverage, 16153,
     /* 2086165 */     GIR_EraseRootFromParent_Done,
     /* 2086166 */   // Label 27697: @2086166
     /* 2086166 */   GIM_Try, /*On fail goto*//*Label 27698*/ GIMT_Encode4(2086257), // Rule ID 16156 //
     /* 2086171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2086182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2086185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2086188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2086191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086217 */     // MIs[0] round
     /* 2086217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086220 */     // MIs[0] policy
     /* 2086220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086230 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2086233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086256 */     // GIR_Coverage, 16156,
     /* 2086256 */     GIR_EraseRootFromParent_Done,
     /* 2086257 */   // Label 27698: @2086257
     /* 2086257 */   GIM_Try, /*On fail goto*//*Label 27699*/ GIMT_Encode4(2086348), // Rule ID 16157 //
     /* 2086262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2086273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2086276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2086279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2086282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086308 */     // MIs[0] round
     /* 2086308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086311 */     // MIs[0] policy
     /* 2086311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086321 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2086324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086347 */     // GIR_Coverage, 16157,
     /* 2086347 */     GIR_EraseRootFromParent_Done,
     /* 2086348 */   // Label 27699: @2086348
     /* 2086348 */   GIM_Try, /*On fail goto*//*Label 27700*/ GIMT_Encode4(2086439), // Rule ID 16160 //
     /* 2086353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2086364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2086367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2086370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2086373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2086376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086399 */     // MIs[0] round
     /* 2086399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086402 */     // MIs[0] policy
     /* 2086402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086412 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2086415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086438 */     // GIR_Coverage, 16160,
     /* 2086438 */     GIR_EraseRootFromParent_Done,
     /* 2086439 */   // Label 27700: @2086439
     /* 2086439 */   GIM_Try, /*On fail goto*//*Label 27701*/ GIMT_Encode4(2086530), // Rule ID 16161 //
     /* 2086444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2086455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2086458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2086461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2086464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2086467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086490 */     // MIs[0] round
     /* 2086490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086493 */     // MIs[0] policy
     /* 2086493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086503 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2086506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086529 */     // GIR_Coverage, 16161,
     /* 2086529 */     GIR_EraseRootFromParent_Done,
     /* 2086530 */   // Label 27701: @2086530
     /* 2086530 */   GIM_Try, /*On fail goto*//*Label 27702*/ GIMT_Encode4(2086621), // Rule ID 16164 //
     /* 2086535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2086546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2086549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2086552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2086555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086581 */     // MIs[0] round
     /* 2086581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086584 */     // MIs[0] policy
     /* 2086584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2086597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086620 */     // GIR_Coverage, 16164,
     /* 2086620 */     GIR_EraseRootFromParent_Done,
     /* 2086621 */   // Label 27702: @2086621
     /* 2086621 */   GIM_Try, /*On fail goto*//*Label 27703*/ GIMT_Encode4(2086712), // Rule ID 16165 //
     /* 2086626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2086637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2086640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2086643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2086646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086672 */     // MIs[0] round
     /* 2086672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086675 */     // MIs[0] policy
     /* 2086675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086685 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2086688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086711 */     // GIR_Coverage, 16165,
     /* 2086711 */     GIR_EraseRootFromParent_Done,
     /* 2086712 */   // Label 27703: @2086712
     /* 2086712 */   GIM_Try, /*On fail goto*//*Label 27704*/ GIMT_Encode4(2086803), // Rule ID 16168 //
     /* 2086717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2086728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2086731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2086734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2086737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086763 */     // MIs[0] round
     /* 2086763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086766 */     // MIs[0] policy
     /* 2086766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086776 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2086779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086802 */     // GIR_Coverage, 16168,
     /* 2086802 */     GIR_EraseRootFromParent_Done,
     /* 2086803 */   // Label 27704: @2086803
     /* 2086803 */   GIM_Try, /*On fail goto*//*Label 27705*/ GIMT_Encode4(2086894), // Rule ID 16169 //
     /* 2086808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2086819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2086822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2086825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2086828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086854 */     // MIs[0] round
     /* 2086854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086857 */     // MIs[0] policy
     /* 2086857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086867 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2086870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086893 */     // GIR_Coverage, 16169,
     /* 2086893 */     GIR_EraseRootFromParent_Done,
     /* 2086894 */   // Label 27705: @2086894
     /* 2086894 */   GIM_Try, /*On fail goto*//*Label 27706*/ GIMT_Encode4(2086985), // Rule ID 16172 //
     /* 2086899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2086910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2086913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2086916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2086919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086945 */     // MIs[0] round
     /* 2086945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086948 */     // MIs[0] policy
     /* 2086948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086958 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2086961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086984 */     // GIR_Coverage, 16172,
     /* 2086984 */     GIR_EraseRootFromParent_Done,
     /* 2086985 */   // Label 27706: @2086985
     /* 2086985 */   GIM_Try, /*On fail goto*//*Label 27707*/ GIMT_Encode4(2087076), // Rule ID 16173 //
     /* 2086990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2087001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2087004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2087007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2087010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2087020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087036 */     // MIs[0] round
     /* 2087036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087039 */     // MIs[0] policy
     /* 2087039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087049 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2087052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2087072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087075 */     // GIR_Coverage, 16173,
     /* 2087075 */     GIR_EraseRootFromParent_Done,
     /* 2087076 */   // Label 27707: @2087076
     /* 2087076 */   GIM_Try, /*On fail goto*//*Label 27708*/ GIMT_Encode4(2087167), // Rule ID 16176 //
     /* 2087081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2087092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2087095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2087098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087127 */     // MIs[0] round
     /* 2087127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087130 */     // MIs[0] policy
     /* 2087130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2087143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087166 */     // GIR_Coverage, 16176,
     /* 2087166 */     GIR_EraseRootFromParent_Done,
     /* 2087167 */   // Label 27708: @2087167
     /* 2087167 */   GIM_Try, /*On fail goto*//*Label 27709*/ GIMT_Encode4(2087258), // Rule ID 16177 //
     /* 2087172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2087183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2087186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2087189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087218 */     // MIs[0] round
     /* 2087218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087221 */     // MIs[0] policy
     /* 2087221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087231 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2087234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087257 */     // GIR_Coverage, 16177,
     /* 2087257 */     GIR_EraseRootFromParent_Done,
     /* 2087258 */   // Label 27709: @2087258
     /* 2087258 */   GIM_Try, /*On fail goto*//*Label 27710*/ GIMT_Encode4(2087349), // Rule ID 16180 //
     /* 2087263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2087274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2087277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2087280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087309 */     // MIs[0] round
     /* 2087309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087312 */     // MIs[0] policy
     /* 2087312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087322 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2087325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087348 */     // GIR_Coverage, 16180,
     /* 2087348 */     GIR_EraseRootFromParent_Done,
     /* 2087349 */   // Label 27710: @2087349
     /* 2087349 */   GIM_Try, /*On fail goto*//*Label 27711*/ GIMT_Encode4(2087440), // Rule ID 16181 //
     /* 2087354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2087365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2087368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2087371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087400 */     // MIs[0] round
     /* 2087400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087403 */     // MIs[0] policy
     /* 2087403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087413 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2087416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087439 */     // GIR_Coverage, 16181,
     /* 2087439 */     GIR_EraseRootFromParent_Done,
     /* 2087440 */   // Label 27711: @2087440
     /* 2087440 */   GIM_Try, /*On fail goto*//*Label 27712*/ GIMT_Encode4(2087531), // Rule ID 16184 //
     /* 2087445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2087456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2087459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2087462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087491 */     // MIs[0] round
     /* 2087491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087494 */     // MIs[0] policy
     /* 2087494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087504 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087530 */     // GIR_Coverage, 16184,
     /* 2087530 */     GIR_EraseRootFromParent_Done,
     /* 2087531 */   // Label 27712: @2087531
     /* 2087531 */   GIM_Try, /*On fail goto*//*Label 27713*/ GIMT_Encode4(2087622), // Rule ID 16185 //
     /* 2087536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2087547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2087550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2087553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087582 */     // MIs[0] round
     /* 2087582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087585 */     // MIs[0] policy
     /* 2087585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087595 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087621 */     // GIR_Coverage, 16185,
     /* 2087621 */     GIR_EraseRootFromParent_Done,
     /* 2087622 */   // Label 27713: @2087622
     /* 2087622 */   GIM_Try, /*On fail goto*//*Label 27714*/ GIMT_Encode4(2087713), // Rule ID 16188 //
     /* 2087627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2087638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2087641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087673 */     // MIs[0] round
     /* 2087673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087676 */     // MIs[0] policy
     /* 2087676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087686 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2087689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087712 */     // GIR_Coverage, 16188,
     /* 2087712 */     GIR_EraseRootFromParent_Done,
     /* 2087713 */   // Label 27714: @2087713
     /* 2087713 */   GIM_Try, /*On fail goto*//*Label 27715*/ GIMT_Encode4(2087804), // Rule ID 16189 //
     /* 2087718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2087729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2087732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087764 */     // MIs[0] round
     /* 2087764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087767 */     // MIs[0] policy
     /* 2087767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087777 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2087780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087803 */     // GIR_Coverage, 16189,
     /* 2087803 */     GIR_EraseRootFromParent_Done,
     /* 2087804 */   // Label 27715: @2087804
     /* 2087804 */   GIM_Try, /*On fail goto*//*Label 27716*/ GIMT_Encode4(2087895), // Rule ID 16192 //
     /* 2087809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2087820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2087823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2087826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087855 */     // MIs[0] round
     /* 2087855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087858 */     // MIs[0] policy
     /* 2087858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087868 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087894 */     // GIR_Coverage, 16192,
     /* 2087894 */     GIR_EraseRootFromParent_Done,
     /* 2087895 */   // Label 27716: @2087895
     /* 2087895 */   GIM_Try, /*On fail goto*//*Label 27717*/ GIMT_Encode4(2087986), // Rule ID 16193 //
     /* 2087900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2087911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2087914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2087917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087946 */     // MIs[0] round
     /* 2087946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087949 */     // MIs[0] policy
     /* 2087949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087959 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087985 */     // GIR_Coverage, 16193,
     /* 2087985 */     GIR_EraseRootFromParent_Done,
     /* 2087986 */   // Label 27717: @2087986
     /* 2087986 */   GIM_Try, /*On fail goto*//*Label 27718*/ GIMT_Encode4(2088077), // Rule ID 16196 //
     /* 2087991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2088002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2088005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2088008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088037 */     // MIs[0] round
     /* 2088037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088040 */     // MIs[0] policy
     /* 2088040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088050 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2088053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088076 */     // GIR_Coverage, 16196,
     /* 2088076 */     GIR_EraseRootFromParent_Done,
     /* 2088077 */   // Label 27718: @2088077
     /* 2088077 */   GIM_Try, /*On fail goto*//*Label 27719*/ GIMT_Encode4(2088168), // Rule ID 16197 //
     /* 2088082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2088093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2088096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2088099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088128 */     // MIs[0] round
     /* 2088128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088131 */     // MIs[0] policy
     /* 2088131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088141 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2088144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088167 */     // GIR_Coverage, 16197,
     /* 2088167 */     GIR_EraseRootFromParent_Done,
     /* 2088168 */   // Label 27719: @2088168
     /* 2088168 */   GIM_Try, /*On fail goto*//*Label 27720*/ GIMT_Encode4(2088259), // Rule ID 16200 //
     /* 2088173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2088184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2088187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2088190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088219 */     // MIs[0] round
     /* 2088219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088222 */     // MIs[0] policy
     /* 2088222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088258 */     // GIR_Coverage, 16200,
     /* 2088258 */     GIR_EraseRootFromParent_Done,
     /* 2088259 */   // Label 27720: @2088259
     /* 2088259 */   GIM_Try, /*On fail goto*//*Label 27721*/ GIMT_Encode4(2088350), // Rule ID 16201 //
     /* 2088264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2088275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2088278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2088281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088310 */     // MIs[0] round
     /* 2088310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088313 */     // MIs[0] policy
     /* 2088313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088323 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088349 */     // GIR_Coverage, 16201,
     /* 2088349 */     GIR_EraseRootFromParent_Done,
     /* 2088350 */   // Label 27721: @2088350
     /* 2088350 */   GIM_Try, /*On fail goto*//*Label 27722*/ GIMT_Encode4(2088441), // Rule ID 16204 //
     /* 2088355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2088366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2088369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2088372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2088378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088401 */     // MIs[0] round
     /* 2088401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088404 */     // MIs[0] policy
     /* 2088404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088440 */     // GIR_Coverage, 16204,
     /* 2088440 */     GIR_EraseRootFromParent_Done,
     /* 2088441 */   // Label 27722: @2088441
     /* 2088441 */   GIM_Try, /*On fail goto*//*Label 27723*/ GIMT_Encode4(2088532), // Rule ID 16205 //
     /* 2088446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2088457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2088460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2088463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2088469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088492 */     // MIs[0] round
     /* 2088492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088495 */     // MIs[0] policy
     /* 2088495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088505 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088531 */     // GIR_Coverage, 16205,
     /* 2088531 */     GIR_EraseRootFromParent_Done,
     /* 2088532 */   // Label 27723: @2088532
     /* 2088532 */   GIM_Try, /*On fail goto*//*Label 27724*/ GIMT_Encode4(2088623), // Rule ID 16208 //
     /* 2088537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2088554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088583 */     // MIs[0] round
     /* 2088583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088586 */     // MIs[0] policy
     /* 2088586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088622 */     // GIR_Coverage, 16208,
     /* 2088622 */     GIR_EraseRootFromParent_Done,
     /* 2088623 */   // Label 27724: @2088623
     /* 2088623 */   GIM_Try, /*On fail goto*//*Label 27725*/ GIMT_Encode4(2088714), // Rule ID 16209 //
     /* 2088628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2088645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088674 */     // MIs[0] round
     /* 2088674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088677 */     // MIs[0] policy
     /* 2088677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088687 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088713 */     // GIR_Coverage, 16209,
     /* 2088713 */     GIR_EraseRootFromParent_Done,
     /* 2088714 */   // Label 27725: @2088714
     /* 2088714 */   GIM_Try, /*On fail goto*//*Label 27726*/ GIMT_Encode4(2088805), // Rule ID 16212 //
     /* 2088719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2088722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2088730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2088733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2088736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088765 */     // MIs[0] round
     /* 2088765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088768 */     // MIs[0] policy
     /* 2088768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088778 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2088801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088804 */     // GIR_Coverage, 16212,
     /* 2088804 */     GIR_EraseRootFromParent_Done,
     /* 2088805 */   // Label 27726: @2088805
     /* 2088805 */   GIM_Try, /*On fail goto*//*Label 27727*/ GIMT_Encode4(2088896), // Rule ID 16213 //
     /* 2088810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2088813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2088821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2088824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2088827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088856 */     // MIs[0] round
     /* 2088856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088859 */     // MIs[0] policy
     /* 2088859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2088892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088895 */     // GIR_Coverage, 16213,
     /* 2088895 */     GIR_EraseRootFromParent_Done,
     /* 2088896 */   // Label 27727: @2088896
     /* 2088896 */   GIM_Try, /*On fail goto*//*Label 27728*/ GIMT_Encode4(2088987), // Rule ID 16216 //
     /* 2088901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2088912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2088915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2088918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2088924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088947 */     // MIs[0] round
     /* 2088947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088950 */     // MIs[0] policy
     /* 2088950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2088963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088986 */     // GIR_Coverage, 16216,
     /* 2088986 */     GIR_EraseRootFromParent_Done,
     /* 2088987 */   // Label 27728: @2088987
     /* 2088987 */   GIM_Try, /*On fail goto*//*Label 27729*/ GIMT_Encode4(2089078), // Rule ID 16217 //
     /* 2088992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2089003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2089006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2089009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089038 */     // MIs[0] round
     /* 2089038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089041 */     // MIs[0] policy
     /* 2089041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089051 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089077 */     // GIR_Coverage, 16217,
     /* 2089077 */     GIR_EraseRootFromParent_Done,
     /* 2089078 */   // Label 27729: @2089078
     /* 2089078 */   GIM_Try, /*On fail goto*//*Label 27730*/ GIMT_Encode4(2089169), // Rule ID 16220 //
     /* 2089083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2089094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2089097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2089100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089129 */     // MIs[0] round
     /* 2089129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089132 */     // MIs[0] policy
     /* 2089132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089142 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089168 */     // GIR_Coverage, 16220,
     /* 2089168 */     GIR_EraseRootFromParent_Done,
     /* 2089169 */   // Label 27730: @2089169
     /* 2089169 */   GIM_Try, /*On fail goto*//*Label 27731*/ GIMT_Encode4(2089260), // Rule ID 16221 //
     /* 2089174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2089185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2089188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2089191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089220 */     // MIs[0] round
     /* 2089220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089223 */     // MIs[0] policy
     /* 2089223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089233 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089259 */     // GIR_Coverage, 16221,
     /* 2089259 */     GIR_EraseRootFromParent_Done,
     /* 2089260 */   // Label 27731: @2089260
     /* 2089260 */   GIM_Try, /*On fail goto*//*Label 27732*/ GIMT_Encode4(2089351), // Rule ID 16224 //
     /* 2089265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2089276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2089279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2089282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2089288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089311 */     // MIs[0] round
     /* 2089311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089314 */     // MIs[0] policy
     /* 2089314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089324 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089350 */     // GIR_Coverage, 16224,
     /* 2089350 */     GIR_EraseRootFromParent_Done,
     /* 2089351 */   // Label 27732: @2089351
     /* 2089351 */   GIM_Try, /*On fail goto*//*Label 27733*/ GIMT_Encode4(2089442), // Rule ID 16225 //
     /* 2089356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2089367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2089370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2089373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2089379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089402 */     // MIs[0] round
     /* 2089402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089405 */     // MIs[0] policy
     /* 2089405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089415 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089441 */     // GIR_Coverage, 16225,
     /* 2089441 */     GIR_EraseRootFromParent_Done,
     /* 2089442 */   // Label 27733: @2089442
     /* 2089442 */   GIM_Try, /*On fail goto*//*Label 27734*/ GIMT_Encode4(2089533), // Rule ID 16228 //
     /* 2089447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2089458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2089461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2089464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089493 */     // MIs[0] round
     /* 2089493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089496 */     // MIs[0] policy
     /* 2089496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089532 */     // GIR_Coverage, 16228,
     /* 2089532 */     GIR_EraseRootFromParent_Done,
     /* 2089533 */   // Label 27734: @2089533
     /* 2089533 */   GIM_Try, /*On fail goto*//*Label 27735*/ GIMT_Encode4(2089624), // Rule ID 16229 //
     /* 2089538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2089549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2089552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2089555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089584 */     // MIs[0] round
     /* 2089584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089587 */     // MIs[0] policy
     /* 2089587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089623 */     // GIR_Coverage, 16229,
     /* 2089623 */     GIR_EraseRootFromParent_Done,
     /* 2089624 */   // Label 27735: @2089624
     /* 2089624 */   GIM_Try, /*On fail goto*//*Label 27736*/ GIMT_Encode4(2089715), // Rule ID 16232 //
     /* 2089629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2089640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2089643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2089646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089675 */     // MIs[0] round
     /* 2089675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089678 */     // MIs[0] policy
     /* 2089678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089688 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089714 */     // GIR_Coverage, 16232,
     /* 2089714 */     GIR_EraseRootFromParent_Done,
     /* 2089715 */   // Label 27736: @2089715
     /* 2089715 */   GIM_Try, /*On fail goto*//*Label 27737*/ GIMT_Encode4(2089806), // Rule ID 16233 //
     /* 2089720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2089731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2089734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2089737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089766 */     // MIs[0] round
     /* 2089766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089769 */     // MIs[0] policy
     /* 2089769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089779 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089805 */     // GIR_Coverage, 16233,
     /* 2089805 */     GIR_EraseRootFromParent_Done,
     /* 2089806 */   // Label 27737: @2089806
     /* 2089806 */   GIM_Try, /*On fail goto*//*Label 27738*/ GIMT_Encode4(2089897), // Rule ID 16236 //
     /* 2089811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2089822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2089825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2089828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089857 */     // MIs[0] round
     /* 2089857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089860 */     // MIs[0] policy
     /* 2089860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089870 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089896 */     // GIR_Coverage, 16236,
     /* 2089896 */     GIR_EraseRootFromParent_Done,
     /* 2089897 */   // Label 27738: @2089897
     /* 2089897 */   GIM_Try, /*On fail goto*//*Label 27739*/ GIMT_Encode4(2089988), // Rule ID 16237 //
     /* 2089902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2089913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2089916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2089919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089948 */     // MIs[0] round
     /* 2089948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089951 */     // MIs[0] policy
     /* 2089951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089961 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089987 */     // GIR_Coverage, 16237,
     /* 2089987 */     GIR_EraseRootFromParent_Done,
     /* 2089988 */   // Label 27739: @2089988
     /* 2089988 */   GIM_Try, /*On fail goto*//*Label 27740*/ GIMT_Encode4(2090079), // Rule ID 16240 //
     /* 2089993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2090004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2090007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2090010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090039 */     // MIs[0] round
     /* 2090039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090042 */     // MIs[0] policy
     /* 2090042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2090055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090078 */     // GIR_Coverage, 16240,
     /* 2090078 */     GIR_EraseRootFromParent_Done,
     /* 2090079 */   // Label 27740: @2090079
     /* 2090079 */   GIM_Try, /*On fail goto*//*Label 27741*/ GIMT_Encode4(2090170), // Rule ID 16241 //
     /* 2090084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2090095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2090098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2090101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090130 */     // MIs[0] round
     /* 2090130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090133 */     // MIs[0] policy
     /* 2090133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2090146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090169 */     // GIR_Coverage, 16241,
     /* 2090169 */     GIR_EraseRootFromParent_Done,
     /* 2090170 */   // Label 27741: @2090170
     /* 2090170 */   GIM_Try, /*On fail goto*//*Label 27742*/ GIMT_Encode4(2090261), // Rule ID 16244 //
     /* 2090175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2090186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2090189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2090192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090221 */     // MIs[0] round
     /* 2090221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090224 */     // MIs[0] policy
     /* 2090224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090234 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2090237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090260 */     // GIR_Coverage, 16244,
     /* 2090260 */     GIR_EraseRootFromParent_Done,
     /* 2090261 */   // Label 27742: @2090261
     /* 2090261 */   GIM_Try, /*On fail goto*//*Label 27743*/ GIMT_Encode4(2090352), // Rule ID 16245 //
     /* 2090266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2090277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2090280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2090283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090312 */     // MIs[0] round
     /* 2090312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090315 */     // MIs[0] policy
     /* 2090315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090325 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2090328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090351 */     // GIR_Coverage, 16245,
     /* 2090351 */     GIR_EraseRootFromParent_Done,
     /* 2090352 */   // Label 27743: @2090352
     /* 2090352 */   GIM_Try, /*On fail goto*//*Label 27744*/ GIMT_Encode4(2090443), // Rule ID 16248 //
     /* 2090357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2090368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2090371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2090374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2090380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090403 */     // MIs[0] round
     /* 2090403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090406 */     // MIs[0] policy
     /* 2090406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090416 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2090419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090442 */     // GIR_Coverage, 16248,
     /* 2090442 */     GIR_EraseRootFromParent_Done,
     /* 2090443 */   // Label 27744: @2090443
     /* 2090443 */   GIM_Try, /*On fail goto*//*Label 27745*/ GIMT_Encode4(2090534), // Rule ID 16249 //
     /* 2090448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2090459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2090462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2090465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2090471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090494 */     // MIs[0] round
     /* 2090494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090497 */     // MIs[0] policy
     /* 2090497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090507 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2090510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090533 */     // GIR_Coverage, 16249,
     /* 2090533 */     GIR_EraseRootFromParent_Done,
     /* 2090534 */   // Label 27745: @2090534
     /* 2090534 */   GIM_Try, /*On fail goto*//*Label 27746*/ GIMT_Encode4(2090625), // Rule ID 16252 //
     /* 2090539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2090550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2090553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2090556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090585 */     // MIs[0] round
     /* 2090585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090588 */     // MIs[0] policy
     /* 2090588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2090601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090624 */     // GIR_Coverage, 16252,
     /* 2090624 */     GIR_EraseRootFromParent_Done,
     /* 2090625 */   // Label 27746: @2090625
     /* 2090625 */   GIM_Try, /*On fail goto*//*Label 27747*/ GIMT_Encode4(2090716), // Rule ID 16253 //
     /* 2090630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2090641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2090644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2090647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090676 */     // MIs[0] round
     /* 2090676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090679 */     // MIs[0] policy
     /* 2090679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2090692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090715 */     // GIR_Coverage, 16253,
     /* 2090715 */     GIR_EraseRootFromParent_Done,
     /* 2090716 */   // Label 27747: @2090716
     /* 2090716 */   GIM_Try, /*On fail goto*//*Label 27748*/ GIMT_Encode4(2090807), // Rule ID 16256 //
     /* 2090721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2090732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2090735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2090738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090767 */     // MIs[0] round
     /* 2090767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090770 */     // MIs[0] policy
     /* 2090770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090780 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2090783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090806 */     // GIR_Coverage, 16256,
     /* 2090806 */     GIR_EraseRootFromParent_Done,
     /* 2090807 */   // Label 27748: @2090807
     /* 2090807 */   GIM_Try, /*On fail goto*//*Label 27749*/ GIMT_Encode4(2090898), // Rule ID 16257 //
     /* 2090812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2090823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2090826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2090829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090858 */     // MIs[0] round
     /* 2090858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090861 */     // MIs[0] policy
     /* 2090861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2090874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090897 */     // GIR_Coverage, 16257,
     /* 2090897 */     GIR_EraseRootFromParent_Done,
     /* 2090898 */   // Label 27749: @2090898
     /* 2090898 */   GIM_Try, /*On fail goto*//*Label 27750*/ GIMT_Encode4(2090989), // Rule ID 16260 //
     /* 2090903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2090914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2090917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2090920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090949 */     // MIs[0] round
     /* 2090949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090952 */     // MIs[0] policy
     /* 2090952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090962 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2090965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090988 */     // GIR_Coverage, 16260,
     /* 2090988 */     GIR_EraseRootFromParent_Done,
     /* 2090989 */   // Label 27750: @2090989
     /* 2090989 */   GIM_Try, /*On fail goto*//*Label 27751*/ GIMT_Encode4(2091080), // Rule ID 16261 //
     /* 2090994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2091002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2091005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2091008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2091011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2091014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2091024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091040 */     // MIs[0] round
     /* 2091040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091043 */     // MIs[0] policy
     /* 2091043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091053 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2091056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2091076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091079 */     // GIR_Coverage, 16261,
     /* 2091079 */     GIR_EraseRootFromParent_Done,
     /* 2091080 */   // Label 27751: @2091080
     /* 2091080 */   GIM_Try, /*On fail goto*//*Label 27752*/ GIMT_Encode4(2091174), // Rule ID 16352 //
     /* 2091085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2091096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2091099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2091102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2091105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091131 */     // MIs[0] round
     /* 2091131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091134 */     // MIs[0] policy
     /* 2091134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091144 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2091147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091173 */     // GIR_Coverage, 16352,
     /* 2091173 */     GIR_EraseRootFromParent_Done,
     /* 2091174 */   // Label 27752: @2091174
     /* 2091174 */   GIM_Try, /*On fail goto*//*Label 27753*/ GIMT_Encode4(2091268), // Rule ID 16353 //
     /* 2091179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2091190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2091193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2091196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2091199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091225 */     // MIs[0] round
     /* 2091225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091228 */     // MIs[0] policy
     /* 2091228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091238 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2091241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091267 */     // GIR_Coverage, 16353,
     /* 2091267 */     GIR_EraseRootFromParent_Done,
     /* 2091268 */   // Label 27753: @2091268
     /* 2091268 */   GIM_Try, /*On fail goto*//*Label 27754*/ GIMT_Encode4(2091362), // Rule ID 16356 //
     /* 2091273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2091284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2091287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2091290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2091293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091319 */     // MIs[0] round
     /* 2091319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091322 */     // MIs[0] policy
     /* 2091322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091332 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2091335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091361 */     // GIR_Coverage, 16356,
     /* 2091361 */     GIR_EraseRootFromParent_Done,
     /* 2091362 */   // Label 27754: @2091362
     /* 2091362 */   GIM_Try, /*On fail goto*//*Label 27755*/ GIMT_Encode4(2091456), // Rule ID 16357 //
     /* 2091367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2091378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2091381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2091384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2091387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091413 */     // MIs[0] round
     /* 2091413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091416 */     // MIs[0] policy
     /* 2091416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091426 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2091429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091455 */     // GIR_Coverage, 16357,
     /* 2091455 */     GIR_EraseRootFromParent_Done,
     /* 2091456 */   // Label 27755: @2091456
     /* 2091456 */   GIM_Try, /*On fail goto*//*Label 27756*/ GIMT_Encode4(2091550), // Rule ID 16360 //
     /* 2091461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2091472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2091475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2091478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2091481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091507 */     // MIs[0] round
     /* 2091507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091510 */     // MIs[0] policy
     /* 2091510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091520 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2091523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091549 */     // GIR_Coverage, 16360,
     /* 2091549 */     GIR_EraseRootFromParent_Done,
     /* 2091550 */   // Label 27756: @2091550
     /* 2091550 */   GIM_Try, /*On fail goto*//*Label 27757*/ GIMT_Encode4(2091644), // Rule ID 16361 //
     /* 2091555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2091566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2091569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2091572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2091575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091601 */     // MIs[0] round
     /* 2091601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091604 */     // MIs[0] policy
     /* 2091604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091614 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2091617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091643 */     // GIR_Coverage, 16361,
     /* 2091643 */     GIR_EraseRootFromParent_Done,
     /* 2091644 */   // Label 27757: @2091644
     /* 2091644 */   GIM_Try, /*On fail goto*//*Label 27758*/ GIMT_Encode4(2091738), // Rule ID 16364 //
     /* 2091649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2091660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2091663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2091666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2091669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091695 */     // MIs[0] round
     /* 2091695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091698 */     // MIs[0] policy
     /* 2091698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091708 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2091711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091737 */     // GIR_Coverage, 16364,
     /* 2091737 */     GIR_EraseRootFromParent_Done,
     /* 2091738 */   // Label 27758: @2091738
     /* 2091738 */   GIM_Try, /*On fail goto*//*Label 27759*/ GIMT_Encode4(2091832), // Rule ID 16365 //
     /* 2091743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2091754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2091757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2091760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2091763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091789 */     // MIs[0] round
     /* 2091789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091792 */     // MIs[0] policy
     /* 2091792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2091805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091831 */     // GIR_Coverage, 16365,
     /* 2091831 */     GIR_EraseRootFromParent_Done,
     /* 2091832 */   // Label 27759: @2091832
     /* 2091832 */   GIM_Try, /*On fail goto*//*Label 27760*/ GIMT_Encode4(2091926), // Rule ID 16368 //
     /* 2091837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2091848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2091851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2091854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2091857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091883 */     // MIs[0] round
     /* 2091883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091886 */     // MIs[0] policy
     /* 2091886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2091899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091925 */     // GIR_Coverage, 16368,
     /* 2091925 */     GIR_EraseRootFromParent_Done,
     /* 2091926 */   // Label 27760: @2091926
     /* 2091926 */   GIM_Try, /*On fail goto*//*Label 27761*/ GIMT_Encode4(2092020), // Rule ID 16369 //
     /* 2091931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2091942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2091945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2091948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2091951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091977 */     // MIs[0] round
     /* 2091977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091980 */     // MIs[0] policy
     /* 2091980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091990 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2091993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092019 */     // GIR_Coverage, 16369,
     /* 2092019 */     GIR_EraseRootFromParent_Done,
     /* 2092020 */   // Label 27761: @2092020
     /* 2092020 */   GIM_Try, /*On fail goto*//*Label 27762*/ GIMT_Encode4(2092114), // Rule ID 16372 //
     /* 2092025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2092036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2092039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2092042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2092045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2092048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092071 */     // MIs[0] round
     /* 2092071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092074 */     // MIs[0] policy
     /* 2092074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092084 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2092087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092113 */     // GIR_Coverage, 16372,
     /* 2092113 */     GIR_EraseRootFromParent_Done,
     /* 2092114 */   // Label 27762: @2092114
     /* 2092114 */   GIM_Try, /*On fail goto*//*Label 27763*/ GIMT_Encode4(2092208), // Rule ID 16373 //
     /* 2092119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2092130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2092133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2092136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2092139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2092142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092165 */     // MIs[0] round
     /* 2092165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092168 */     // MIs[0] policy
     /* 2092168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092178 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2092181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092207 */     // GIR_Coverage, 16373,
     /* 2092207 */     GIR_EraseRootFromParent_Done,
     /* 2092208 */   // Label 27763: @2092208
     /* 2092208 */   GIM_Try, /*On fail goto*//*Label 27764*/ GIMT_Encode4(2092302), // Rule ID 16376 //
     /* 2092213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2092224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2092227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2092230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2092233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092259 */     // MIs[0] round
     /* 2092259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092262 */     // MIs[0] policy
     /* 2092262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092272 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2092275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092301 */     // GIR_Coverage, 16376,
     /* 2092301 */     GIR_EraseRootFromParent_Done,
     /* 2092302 */   // Label 27764: @2092302
     /* 2092302 */   GIM_Try, /*On fail goto*//*Label 27765*/ GIMT_Encode4(2092396), // Rule ID 16377 //
     /* 2092307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2092318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2092321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2092324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2092327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092353 */     // MIs[0] round
     /* 2092353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092356 */     // MIs[0] policy
     /* 2092356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092366 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2092369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092395 */     // GIR_Coverage, 16377,
     /* 2092395 */     GIR_EraseRootFromParent_Done,
     /* 2092396 */   // Label 27765: @2092396
     /* 2092396 */   GIM_Try, /*On fail goto*//*Label 27766*/ GIMT_Encode4(2092490), // Rule ID 16380 //
     /* 2092401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2092412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2092415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2092418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2092421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092447 */     // MIs[0] round
     /* 2092447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092450 */     // MIs[0] policy
     /* 2092450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092460 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2092463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092489 */     // GIR_Coverage, 16380,
     /* 2092489 */     GIR_EraseRootFromParent_Done,
     /* 2092490 */   // Label 27766: @2092490
     /* 2092490 */   GIM_Try, /*On fail goto*//*Label 27767*/ GIMT_Encode4(2092584), // Rule ID 16381 //
     /* 2092495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2092506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2092509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2092512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2092515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092541 */     // MIs[0] round
     /* 2092541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092544 */     // MIs[0] policy
     /* 2092544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092554 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2092557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092583 */     // GIR_Coverage, 16381,
     /* 2092583 */     GIR_EraseRootFromParent_Done,
     /* 2092584 */   // Label 27767: @2092584
     /* 2092584 */   GIM_Try, /*On fail goto*//*Label 27768*/ GIMT_Encode4(2092678), // Rule ID 16384 //
     /* 2092589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2092600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2092603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2092606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2092609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092635 */     // MIs[0] round
     /* 2092635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092638 */     // MIs[0] policy
     /* 2092638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092648 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2092651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092677 */     // GIR_Coverage, 16384,
     /* 2092677 */     GIR_EraseRootFromParent_Done,
     /* 2092678 */   // Label 27768: @2092678
     /* 2092678 */   GIM_Try, /*On fail goto*//*Label 27769*/ GIMT_Encode4(2092772), // Rule ID 16385 //
     /* 2092683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2092694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2092697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2092700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2092703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092729 */     // MIs[0] round
     /* 2092729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092732 */     // MIs[0] policy
     /* 2092732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092742 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2092745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092771 */     // GIR_Coverage, 16385,
     /* 2092771 */     GIR_EraseRootFromParent_Done,
     /* 2092772 */   // Label 27769: @2092772
     /* 2092772 */   GIM_Try, /*On fail goto*//*Label 27770*/ GIMT_Encode4(2092866), // Rule ID 16388 //
     /* 2092777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2092788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2092791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2092794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2092797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092823 */     // MIs[0] round
     /* 2092823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092826 */     // MIs[0] policy
     /* 2092826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2092839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092865 */     // GIR_Coverage, 16388,
     /* 2092865 */     GIR_EraseRootFromParent_Done,
     /* 2092866 */   // Label 27770: @2092866
     /* 2092866 */   GIM_Try, /*On fail goto*//*Label 27771*/ GIMT_Encode4(2092960), // Rule ID 16389 //
     /* 2092871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2092882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2092885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2092888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2092891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092917 */     // MIs[0] round
     /* 2092917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092920 */     // MIs[0] policy
     /* 2092920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092930 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2092933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092959 */     // GIR_Coverage, 16389,
     /* 2092959 */     GIR_EraseRootFromParent_Done,
     /* 2092960 */   // Label 27771: @2092960
     /* 2092960 */   GIM_Try, /*On fail goto*//*Label 27772*/ GIMT_Encode4(2093054), // Rule ID 16392 //
     /* 2092965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2092976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2092979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2092982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2092985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093011 */     // MIs[0] round
     /* 2093011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093014 */     // MIs[0] policy
     /* 2093014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093024 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2093027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093053 */     // GIR_Coverage, 16392,
     /* 2093053 */     GIR_EraseRootFromParent_Done,
     /* 2093054 */   // Label 27772: @2093054
     /* 2093054 */   GIM_Try, /*On fail goto*//*Label 27773*/ GIMT_Encode4(2093148), // Rule ID 16393 //
     /* 2093059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2093070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2093073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2093076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2093079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2093082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093105 */     // MIs[0] round
     /* 2093105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093108 */     // MIs[0] policy
     /* 2093108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2093121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093147 */     // GIR_Coverage, 16393,
     /* 2093147 */     GIR_EraseRootFromParent_Done,
     /* 2093148 */   // Label 27773: @2093148
     /* 2093148 */   GIM_Try, /*On fail goto*//*Label 27774*/ GIMT_Encode4(2093242), // Rule ID 16396 //
     /* 2093153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2093156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2093164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2093167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2093170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2093173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093199 */     // MIs[0] round
     /* 2093199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093202 */     // MIs[0] policy
     /* 2093202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093212 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2093215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093241 */     // GIR_Coverage, 16396,
     /* 2093241 */     GIR_EraseRootFromParent_Done,
     /* 2093242 */   // Label 27774: @2093242
     /* 2093242 */   GIM_Try, /*On fail goto*//*Label 27775*/ GIMT_Encode4(2093336), // Rule ID 16397 //
     /* 2093247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2093250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2093258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2093261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2093264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2093267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093293 */     // MIs[0] round
     /* 2093293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093296 */     // MIs[0] policy
     /* 2093296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093306 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2093309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093335 */     // GIR_Coverage, 16397,
     /* 2093335 */     GIR_EraseRootFromParent_Done,
     /* 2093336 */   // Label 27775: @2093336
     /* 2093336 */   GIM_Try, /*On fail goto*//*Label 27776*/ GIMT_Encode4(2093430), // Rule ID 16400 //
     /* 2093341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2093344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2093352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2093355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2093358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2093361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093387 */     // MIs[0] round
     /* 2093387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093390 */     // MIs[0] policy
     /* 2093390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2093403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093429 */     // GIR_Coverage, 16400,
     /* 2093429 */     GIR_EraseRootFromParent_Done,
     /* 2093430 */   // Label 27776: @2093430
     /* 2093430 */   GIM_Try, /*On fail goto*//*Label 27777*/ GIMT_Encode4(2093524), // Rule ID 16401 //
     /* 2093435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2093438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2093446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2093449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2093452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2093455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093481 */     // MIs[0] round
     /* 2093481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093484 */     // MIs[0] policy
     /* 2093484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093494 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2093497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093523 */     // GIR_Coverage, 16401,
     /* 2093523 */     GIR_EraseRootFromParent_Done,
     /* 2093524 */   // Label 27777: @2093524
     /* 2093524 */   GIM_Try, /*On fail goto*//*Label 27778*/ GIMT_Encode4(2093618), // Rule ID 16404 //
     /* 2093529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2093532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2093540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2093543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2093546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2093549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093575 */     // MIs[0] round
     /* 2093575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093578 */     // MIs[0] policy
     /* 2093578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2093591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093617 */     // GIR_Coverage, 16404,
     /* 2093617 */     GIR_EraseRootFromParent_Done,
     /* 2093618 */   // Label 27778: @2093618
     /* 2093618 */   GIM_Try, /*On fail goto*//*Label 27779*/ GIMT_Encode4(2093712), // Rule ID 16405 //
     /* 2093623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2093626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2093634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2093637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2093640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2093643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093669 */     // MIs[0] round
     /* 2093669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093672 */     // MIs[0] policy
     /* 2093672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2093685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093711 */     // GIR_Coverage, 16405,
     /* 2093711 */     GIR_EraseRootFromParent_Done,
     /* 2093712 */   // Label 27779: @2093712
     /* 2093712 */   GIM_Try, /*On fail goto*//*Label 27780*/ GIMT_Encode4(2093806), // Rule ID 16408 //
     /* 2093717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2093720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2093728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2093731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2093734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2093737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093763 */     // MIs[0] round
     /* 2093763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093766 */     // MIs[0] policy
     /* 2093766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2093779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093805 */     // GIR_Coverage, 16408,
     /* 2093805 */     GIR_EraseRootFromParent_Done,
     /* 2093806 */   // Label 27780: @2093806
     /* 2093806 */   GIM_Try, /*On fail goto*//*Label 27781*/ GIMT_Encode4(2093900), // Rule ID 16409 //
     /* 2093811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2093814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2093822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2093825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2093828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2093831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093857 */     // MIs[0] round
     /* 2093857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093860 */     // MIs[0] policy
     /* 2093860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093870 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2093873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093899 */     // GIR_Coverage, 16409,
     /* 2093899 */     GIR_EraseRootFromParent_Done,
     /* 2093900 */   // Label 27781: @2093900
     /* 2093900 */   GIM_Try, /*On fail goto*//*Label 27782*/ GIMT_Encode4(2093994), // Rule ID 16412 //
     /* 2093905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2093916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2093919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2093922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093951 */     // MIs[0] round
     /* 2093951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093954 */     // MIs[0] policy
     /* 2093954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093964 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2093967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093993 */     // GIR_Coverage, 16412,
     /* 2093993 */     GIR_EraseRootFromParent_Done,
     /* 2093994 */   // Label 27782: @2093994
     /* 2093994 */   GIM_Try, /*On fail goto*//*Label 27783*/ GIMT_Encode4(2094088), // Rule ID 16413 //
     /* 2093999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2094010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2094013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2094016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094045 */     // MIs[0] round
     /* 2094045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094048 */     // MIs[0] policy
     /* 2094048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094058 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2094061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094087 */     // GIR_Coverage, 16413,
     /* 2094087 */     GIR_EraseRootFromParent_Done,
     /* 2094088 */   // Label 27783: @2094088
     /* 2094088 */   GIM_Try, /*On fail goto*//*Label 27784*/ GIMT_Encode4(2094182), // Rule ID 16416 //
     /* 2094093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2094104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2094107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2094110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094139 */     // MIs[0] round
     /* 2094139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094142 */     // MIs[0] policy
     /* 2094142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094152 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2094155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094181 */     // GIR_Coverage, 16416,
     /* 2094181 */     GIR_EraseRootFromParent_Done,
     /* 2094182 */   // Label 27784: @2094182
     /* 2094182 */   GIM_Try, /*On fail goto*//*Label 27785*/ GIMT_Encode4(2094276), // Rule ID 16417 //
     /* 2094187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2094198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2094201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2094204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094233 */     // MIs[0] round
     /* 2094233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094236 */     // MIs[0] policy
     /* 2094236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094246 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2094249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094275 */     // GIR_Coverage, 16417,
     /* 2094275 */     GIR_EraseRootFromParent_Done,
     /* 2094276 */   // Label 27785: @2094276
     /* 2094276 */   GIM_Try, /*On fail goto*//*Label 27786*/ GIMT_Encode4(2094370), // Rule ID 16420 //
     /* 2094281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2094292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2094295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2094298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094327 */     // MIs[0] round
     /* 2094327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094330 */     // MIs[0] policy
     /* 2094330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094340 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2094343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094369 */     // GIR_Coverage, 16420,
     /* 2094369 */     GIR_EraseRootFromParent_Done,
     /* 2094370 */   // Label 27786: @2094370
     /* 2094370 */   GIM_Try, /*On fail goto*//*Label 27787*/ GIMT_Encode4(2094464), // Rule ID 16421 //
     /* 2094375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2094386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2094389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2094392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094421 */     // MIs[0] round
     /* 2094421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094424 */     // MIs[0] policy
     /* 2094424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094434 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2094437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094463 */     // GIR_Coverage, 16421,
     /* 2094463 */     GIR_EraseRootFromParent_Done,
     /* 2094464 */   // Label 27787: @2094464
     /* 2094464 */   GIM_Try, /*On fail goto*//*Label 27788*/ GIMT_Encode4(2094558), // Rule ID 16424 //
     /* 2094469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2094480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2094483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2094486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094515 */     // MIs[0] round
     /* 2094515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094518 */     // MIs[0] policy
     /* 2094518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094528 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2094531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094557 */     // GIR_Coverage, 16424,
     /* 2094557 */     GIR_EraseRootFromParent_Done,
     /* 2094558 */   // Label 27788: @2094558
     /* 2094558 */   GIM_Try, /*On fail goto*//*Label 27789*/ GIMT_Encode4(2094652), // Rule ID 16425 //
     /* 2094563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2094574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2094577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2094580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094609 */     // MIs[0] round
     /* 2094609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094612 */     // MIs[0] policy
     /* 2094612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094622 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2094625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094651 */     // GIR_Coverage, 16425,
     /* 2094651 */     GIR_EraseRootFromParent_Done,
     /* 2094652 */   // Label 27789: @2094652
     /* 2094652 */   GIM_Try, /*On fail goto*//*Label 27790*/ GIMT_Encode4(2094746), // Rule ID 16428 //
     /* 2094657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2094668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2094671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2094674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094703 */     // MIs[0] round
     /* 2094703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094706 */     // MIs[0] policy
     /* 2094706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094716 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2094719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094745 */     // GIR_Coverage, 16428,
     /* 2094745 */     GIR_EraseRootFromParent_Done,
     /* 2094746 */   // Label 27790: @2094746
     /* 2094746 */   GIM_Try, /*On fail goto*//*Label 27791*/ GIMT_Encode4(2094840), // Rule ID 16429 //
     /* 2094751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2094762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2094765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2094768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094797 */     // MIs[0] round
     /* 2094797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094800 */     // MIs[0] policy
     /* 2094800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094810 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2094813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094839 */     // GIR_Coverage, 16429,
     /* 2094839 */     GIR_EraseRootFromParent_Done,
     /* 2094840 */   // Label 27791: @2094840
     /* 2094840 */   GIM_Try, /*On fail goto*//*Label 27792*/ GIMT_Encode4(2094934), // Rule ID 16432 //
     /* 2094845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2094856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2094859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2094862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2094868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094891 */     // MIs[0] round
     /* 2094891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094894 */     // MIs[0] policy
     /* 2094894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094904 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2094907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094933 */     // GIR_Coverage, 16432,
     /* 2094933 */     GIR_EraseRootFromParent_Done,
     /* 2094934 */   // Label 27792: @2094934
     /* 2094934 */   GIM_Try, /*On fail goto*//*Label 27793*/ GIMT_Encode4(2095028), // Rule ID 16433 //
     /* 2094939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2094950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2094953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2094956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2094962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094985 */     // MIs[0] round
     /* 2094985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094988 */     // MIs[0] policy
     /* 2094988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094998 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2095001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2095021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095027 */     // GIR_Coverage, 16433,
     /* 2095027 */     GIR_EraseRootFromParent_Done,
     /* 2095028 */   // Label 27793: @2095028
     /* 2095028 */   GIM_Try, /*On fail goto*//*Label 27794*/ GIMT_Encode4(2095122), // Rule ID 16436 //
     /* 2095033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2095044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2095047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2095050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095079 */     // MIs[0] round
     /* 2095079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095082 */     // MIs[0] policy
     /* 2095082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095092 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2095095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095121 */     // GIR_Coverage, 16436,
     /* 2095121 */     GIR_EraseRootFromParent_Done,
     /* 2095122 */   // Label 27794: @2095122
     /* 2095122 */   GIM_Try, /*On fail goto*//*Label 27795*/ GIMT_Encode4(2095216), // Rule ID 16437 //
     /* 2095127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2095138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2095141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2095144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095173 */     // MIs[0] round
     /* 2095173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095176 */     // MIs[0] policy
     /* 2095176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095186 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2095189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095215 */     // GIR_Coverage, 16437,
     /* 2095215 */     GIR_EraseRootFromParent_Done,
     /* 2095216 */   // Label 27795: @2095216
     /* 2095216 */   GIM_Try, /*On fail goto*//*Label 27796*/ GIMT_Encode4(2095310), // Rule ID 16440 //
     /* 2095221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2095232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2095235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2095238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095267 */     // MIs[0] round
     /* 2095267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095270 */     // MIs[0] policy
     /* 2095270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095280 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2095283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095309 */     // GIR_Coverage, 16440,
     /* 2095309 */     GIR_EraseRootFromParent_Done,
     /* 2095310 */   // Label 27796: @2095310
     /* 2095310 */   GIM_Try, /*On fail goto*//*Label 27797*/ GIMT_Encode4(2095404), // Rule ID 16441 //
     /* 2095315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2095326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2095329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2095332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095361 */     // MIs[0] round
     /* 2095361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095364 */     // MIs[0] policy
     /* 2095364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095374 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2095377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095403 */     // GIR_Coverage, 16441,
     /* 2095403 */     GIR_EraseRootFromParent_Done,
     /* 2095404 */   // Label 27797: @2095404
     /* 2095404 */   GIM_Try, /*On fail goto*//*Label 27798*/ GIMT_Encode4(2095498), // Rule ID 16444 //
     /* 2095409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2095420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2095423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2095426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095455 */     // MIs[0] round
     /* 2095455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095458 */     // MIs[0] policy
     /* 2095458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095468 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2095471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095497 */     // GIR_Coverage, 16444,
     /* 2095497 */     GIR_EraseRootFromParent_Done,
     /* 2095498 */   // Label 27798: @2095498
     /* 2095498 */   GIM_Try, /*On fail goto*//*Label 27799*/ GIMT_Encode4(2095592), // Rule ID 16445 //
     /* 2095503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2095514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2095517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2095520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095549 */     // MIs[0] round
     /* 2095549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095552 */     // MIs[0] policy
     /* 2095552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095562 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2095565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095591 */     // GIR_Coverage, 16445,
     /* 2095591 */     GIR_EraseRootFromParent_Done,
     /* 2095592 */   // Label 27799: @2095592
     /* 2095592 */   GIM_Try, /*On fail goto*//*Label 27800*/ GIMT_Encode4(2095686), // Rule ID 16448 //
     /* 2095597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2095608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2095611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2095614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095643 */     // MIs[0] round
     /* 2095643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095646 */     // MIs[0] policy
     /* 2095646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095656 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2095659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095685 */     // GIR_Coverage, 16448,
     /* 2095685 */     GIR_EraseRootFromParent_Done,
     /* 2095686 */   // Label 27800: @2095686
     /* 2095686 */   GIM_Try, /*On fail goto*//*Label 27801*/ GIMT_Encode4(2095780), // Rule ID 16449 //
     /* 2095691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2095702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2095705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2095708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095737 */     // MIs[0] round
     /* 2095737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095740 */     // MIs[0] policy
     /* 2095740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095750 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2095753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095779 */     // GIR_Coverage, 16449,
     /* 2095779 */     GIR_EraseRootFromParent_Done,
     /* 2095780 */   // Label 27801: @2095780
     /* 2095780 */   GIM_Try, /*On fail goto*//*Label 27802*/ GIMT_Encode4(2095874), // Rule ID 16452 //
     /* 2095785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2095796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2095799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2095802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095831 */     // MIs[0] round
     /* 2095831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095834 */     // MIs[0] policy
     /* 2095834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095844 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2095847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095873 */     // GIR_Coverage, 16452,
     /* 2095873 */     GIR_EraseRootFromParent_Done,
     /* 2095874 */   // Label 27802: @2095874
     /* 2095874 */   GIM_Try, /*On fail goto*//*Label 27803*/ GIMT_Encode4(2095968), // Rule ID 16453 //
     /* 2095879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2095890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2095893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2095896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095925 */     // MIs[0] round
     /* 2095925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095928 */     // MIs[0] policy
     /* 2095928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095938 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2095941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095967 */     // GIR_Coverage, 16453,
     /* 2095967 */     GIR_EraseRootFromParent_Done,
     /* 2095968 */   // Label 27803: @2095968
     /* 2095968 */   GIM_Try, /*On fail goto*//*Label 27804*/ GIMT_Encode4(2096062), // Rule ID 16456 //
     /* 2095973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2095976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2095984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2095987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2095990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096019 */     // MIs[0] round
     /* 2096019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096022 */     // MIs[0] policy
     /* 2096022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096032 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2096035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096061 */     // GIR_Coverage, 16456,
     /* 2096061 */     GIR_EraseRootFromParent_Done,
     /* 2096062 */   // Label 27804: @2096062
     /* 2096062 */   GIM_Try, /*On fail goto*//*Label 27805*/ GIMT_Encode4(2096156), // Rule ID 16457 //
     /* 2096067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2096078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2096081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2096084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096113 */     // MIs[0] round
     /* 2096113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096116 */     // MIs[0] policy
     /* 2096116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096126 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2096129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096155 */     // GIR_Coverage, 16457,
     /* 2096155 */     GIR_EraseRootFromParent_Done,
     /* 2096156 */   // Label 27805: @2096156
     /* 2096156 */   GIM_Try, /*On fail goto*//*Label 27806*/ GIMT_Encode4(2096250), // Rule ID 16460 //
     /* 2096161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2096164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2096172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2096175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2096178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2096181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096207 */     // MIs[0] round
     /* 2096207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096210 */     // MIs[0] policy
     /* 2096210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096220 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2096223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096249 */     // GIR_Coverage, 16460,
     /* 2096249 */     GIR_EraseRootFromParent_Done,
     /* 2096250 */   // Label 27806: @2096250
     /* 2096250 */   GIM_Try, /*On fail goto*//*Label 27807*/ GIMT_Encode4(2096344), // Rule ID 16461 //
     /* 2096255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2096266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2096269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2096272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096301 */     // MIs[0] round
     /* 2096301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096304 */     // MIs[0] policy
     /* 2096304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096314 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2096317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096343 */     // GIR_Coverage, 16461,
     /* 2096343 */     GIR_EraseRootFromParent_Done,
     /* 2096344 */   // Label 27807: @2096344
     /* 2096344 */   GIM_Try, /*On fail goto*//*Label 27808*/ GIMT_Encode4(2096438), // Rule ID 16464 //
     /* 2096349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2096352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2096360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2096363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2096366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2096369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096395 */     // MIs[0] round
     /* 2096395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096398 */     // MIs[0] policy
     /* 2096398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096408 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2096411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096437 */     // GIR_Coverage, 16464,
     /* 2096437 */     GIR_EraseRootFromParent_Done,
     /* 2096438 */   // Label 27808: @2096438
     /* 2096438 */   GIM_Try, /*On fail goto*//*Label 27809*/ GIMT_Encode4(2096532), // Rule ID 16465 //
     /* 2096443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2096454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2096457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2096460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096489 */     // MIs[0] round
     /* 2096489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096492 */     // MIs[0] policy
     /* 2096492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2096505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096531 */     // GIR_Coverage, 16465,
     /* 2096531 */     GIR_EraseRootFromParent_Done,
     /* 2096532 */   // Label 27809: @2096532
     /* 2096532 */   GIM_Try, /*On fail goto*//*Label 27810*/ GIMT_Encode4(2096626), // Rule ID 16468 //
     /* 2096537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2096540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2096548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2096551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2096554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2096557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096583 */     // MIs[0] round
     /* 2096583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096586 */     // MIs[0] policy
     /* 2096586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2096599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096625 */     // GIR_Coverage, 16468,
     /* 2096625 */     GIR_EraseRootFromParent_Done,
     /* 2096626 */   // Label 27810: @2096626
     /* 2096626 */   GIM_Try, /*On fail goto*//*Label 27811*/ GIMT_Encode4(2096720), // Rule ID 16469 //
     /* 2096631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2096642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2096645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2096648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096677 */     // MIs[0] round
     /* 2096677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096680 */     // MIs[0] policy
     /* 2096680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096690 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2096693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096719 */     // GIR_Coverage, 16469,
     /* 2096719 */     GIR_EraseRootFromParent_Done,
     /* 2096720 */   // Label 27811: @2096720
     /* 2096720 */   GIM_Try, /*On fail goto*//*Label 27812*/ GIMT_Encode4(2096814), // Rule ID 16532 //
     /* 2096725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2096736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2096739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2096742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2096745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096771 */     // MIs[0] round
     /* 2096771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096774 */     // MIs[0] policy
     /* 2096774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096784 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2096787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096813 */     // GIR_Coverage, 16532,
     /* 2096813 */     GIR_EraseRootFromParent_Done,
     /* 2096814 */   // Label 27812: @2096814
     /* 2096814 */   GIM_Try, /*On fail goto*//*Label 27813*/ GIMT_Encode4(2096908), // Rule ID 16533 //
     /* 2096819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2096830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2096833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2096836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2096839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096865 */     // MIs[0] round
     /* 2096865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096868 */     // MIs[0] policy
     /* 2096868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096878 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2096881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096903 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096907 */     // GIR_Coverage, 16533,
     /* 2096907 */     GIR_EraseRootFromParent_Done,
     /* 2096908 */   // Label 27813: @2096908
     /* 2096908 */   GIM_Try, /*On fail goto*//*Label 27814*/ GIMT_Encode4(2097002), // Rule ID 16536 //
     /* 2096913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2096924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2096927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2096930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2096933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096959 */     // MIs[0] round
     /* 2096959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096962 */     // MIs[0] policy
     /* 2096962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096972 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2096975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097001 */     // GIR_Coverage, 16536,
     /* 2097001 */     GIR_EraseRootFromParent_Done,
     /* 2097002 */   // Label 27814: @2097002
     /* 2097002 */   GIM_Try, /*On fail goto*//*Label 27815*/ GIMT_Encode4(2097096), // Rule ID 16537 //
     /* 2097007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2097018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2097021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2097024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2097027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097053 */     // MIs[0] round
     /* 2097053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097056 */     // MIs[0] policy
     /* 2097056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097066 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2097069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097095 */     // GIR_Coverage, 16537,
     /* 2097095 */     GIR_EraseRootFromParent_Done,
     /* 2097096 */   // Label 27815: @2097096
     /* 2097096 */   GIM_Try, /*On fail goto*//*Label 27816*/ GIMT_Encode4(2097190), // Rule ID 16540 //
     /* 2097101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2097112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2097115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2097118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2097121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097147 */     // MIs[0] round
     /* 2097147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097150 */     // MIs[0] policy
     /* 2097150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097160 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2097163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097189 */     // GIR_Coverage, 16540,
     /* 2097189 */     GIR_EraseRootFromParent_Done,
     /* 2097190 */   // Label 27816: @2097190
     /* 2097190 */   GIM_Try, /*On fail goto*//*Label 27817*/ GIMT_Encode4(2097284), // Rule ID 16541 //
     /* 2097195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2097206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2097209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2097212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2097215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097241 */     // MIs[0] round
     /* 2097241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097244 */     // MIs[0] policy
     /* 2097244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097254 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2097257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097283 */     // GIR_Coverage, 16541,
     /* 2097283 */     GIR_EraseRootFromParent_Done,
     /* 2097284 */   // Label 27817: @2097284
     /* 2097284 */   GIM_Try, /*On fail goto*//*Label 27818*/ GIMT_Encode4(2097378), // Rule ID 16544 //
     /* 2097289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2097300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2097303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2097306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2097309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097335 */     // MIs[0] round
     /* 2097335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097338 */     // MIs[0] policy
     /* 2097338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097348 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2097351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097377 */     // GIR_Coverage, 16544,
     /* 2097377 */     GIR_EraseRootFromParent_Done,
     /* 2097378 */   // Label 27818: @2097378
     /* 2097378 */   GIM_Try, /*On fail goto*//*Label 27819*/ GIMT_Encode4(2097472), // Rule ID 16545 //
     /* 2097383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2097394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2097397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2097400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2097403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097429 */     // MIs[0] round
     /* 2097429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097432 */     // MIs[0] policy
     /* 2097432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2097445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097471 */     // GIR_Coverage, 16545,
     /* 2097471 */     GIR_EraseRootFromParent_Done,
     /* 2097472 */   // Label 27819: @2097472
     /* 2097472 */   GIM_Try, /*On fail goto*//*Label 27820*/ GIMT_Encode4(2097566), // Rule ID 16548 //
     /* 2097477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2097488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2097491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2097494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2097497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097523 */     // MIs[0] round
     /* 2097523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097526 */     // MIs[0] policy
     /* 2097526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2097539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097565 */     // GIR_Coverage, 16548,
     /* 2097565 */     GIR_EraseRootFromParent_Done,
     /* 2097566 */   // Label 27820: @2097566
     /* 2097566 */   GIM_Try, /*On fail goto*//*Label 27821*/ GIMT_Encode4(2097660), // Rule ID 16549 //
     /* 2097571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2097582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2097585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2097588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2097591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097617 */     // MIs[0] round
     /* 2097617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097620 */     // MIs[0] policy
     /* 2097620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097630 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2097633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097659 */     // GIR_Coverage, 16549,
     /* 2097659 */     GIR_EraseRootFromParent_Done,
     /* 2097660 */   // Label 27821: @2097660
     /* 2097660 */   GIM_Try, /*On fail goto*//*Label 27822*/ GIMT_Encode4(2097754), // Rule ID 16552 //
     /* 2097665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2097676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2097679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2097682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2097685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2097688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097711 */     // MIs[0] round
     /* 2097711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097714 */     // MIs[0] policy
     /* 2097714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097724 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2097727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097753 */     // GIR_Coverage, 16552,
     /* 2097753 */     GIR_EraseRootFromParent_Done,
     /* 2097754 */   // Label 27822: @2097754
     /* 2097754 */   GIM_Try, /*On fail goto*//*Label 27823*/ GIMT_Encode4(2097848), // Rule ID 16553 //
     /* 2097759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2097770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2097773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2097776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2097779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2097782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097805 */     // MIs[0] round
     /* 2097805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097808 */     // MIs[0] policy
     /* 2097808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097818 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2097821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097847 */     // GIR_Coverage, 16553,
     /* 2097847 */     GIR_EraseRootFromParent_Done,
     /* 2097848 */   // Label 27823: @2097848
     /* 2097848 */   GIM_Try, /*On fail goto*//*Label 27824*/ GIMT_Encode4(2097942), // Rule ID 16556 //
     /* 2097853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2097864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2097867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2097870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2097873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097899 */     // MIs[0] round
     /* 2097899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097902 */     // MIs[0] policy
     /* 2097902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097912 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2097915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097941 */     // GIR_Coverage, 16556,
     /* 2097941 */     GIR_EraseRootFromParent_Done,
     /* 2097942 */   // Label 27824: @2097942
     /* 2097942 */   GIM_Try, /*On fail goto*//*Label 27825*/ GIMT_Encode4(2098036), // Rule ID 16557 //
     /* 2097947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2097958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2097961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2097964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2097967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097993 */     // MIs[0] round
     /* 2097993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097996 */     // MIs[0] policy
     /* 2097996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098006 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2098009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098035 */     // GIR_Coverage, 16557,
     /* 2098035 */     GIR_EraseRootFromParent_Done,
     /* 2098036 */   // Label 27825: @2098036
     /* 2098036 */   GIM_Try, /*On fail goto*//*Label 27826*/ GIMT_Encode4(2098130), // Rule ID 16560 //
     /* 2098041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2098052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2098055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2098058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2098061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098087 */     // MIs[0] round
     /* 2098087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098090 */     // MIs[0] policy
     /* 2098090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098100 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2098103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098129 */     // GIR_Coverage, 16560,
     /* 2098129 */     GIR_EraseRootFromParent_Done,
     /* 2098130 */   // Label 27826: @2098130
     /* 2098130 */   GIM_Try, /*On fail goto*//*Label 27827*/ GIMT_Encode4(2098224), // Rule ID 16561 //
     /* 2098135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2098146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2098149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2098152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2098155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098181 */     // MIs[0] round
     /* 2098181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098184 */     // MIs[0] policy
     /* 2098184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2098197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098223 */     // GIR_Coverage, 16561,
     /* 2098223 */     GIR_EraseRootFromParent_Done,
     /* 2098224 */   // Label 27827: @2098224
     /* 2098224 */   GIM_Try, /*On fail goto*//*Label 27828*/ GIMT_Encode4(2098318), // Rule ID 16564 //
     /* 2098229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2098240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2098243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2098246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2098249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098275 */     // MIs[0] round
     /* 2098275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098278 */     // MIs[0] policy
     /* 2098278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098288 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2098291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098317 */     // GIR_Coverage, 16564,
     /* 2098317 */     GIR_EraseRootFromParent_Done,
     /* 2098318 */   // Label 27828: @2098318
     /* 2098318 */   GIM_Try, /*On fail goto*//*Label 27829*/ GIMT_Encode4(2098412), // Rule ID 16565 //
     /* 2098323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2098334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2098337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2098340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2098343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098369 */     // MIs[0] round
     /* 2098369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098372 */     // MIs[0] policy
     /* 2098372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2098385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098411 */     // GIR_Coverage, 16565,
     /* 2098411 */     GIR_EraseRootFromParent_Done,
     /* 2098412 */   // Label 27829: @2098412
     /* 2098412 */   GIM_Try, /*On fail goto*//*Label 27830*/ GIMT_Encode4(2098506), // Rule ID 16568 //
     /* 2098417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2098428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2098431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2098434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2098437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098463 */     // MIs[0] round
     /* 2098463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098466 */     // MIs[0] policy
     /* 2098466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2098479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098505 */     // GIR_Coverage, 16568,
     /* 2098505 */     GIR_EraseRootFromParent_Done,
     /* 2098506 */   // Label 27830: @2098506
     /* 2098506 */   GIM_Try, /*On fail goto*//*Label 27831*/ GIMT_Encode4(2098600), // Rule ID 16569 //
     /* 2098511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2098522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2098525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2098528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2098531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098557 */     // MIs[0] round
     /* 2098557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098560 */     // MIs[0] policy
     /* 2098560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098570 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2098573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098599 */     // GIR_Coverage, 16569,
     /* 2098599 */     GIR_EraseRootFromParent_Done,
     /* 2098600 */   // Label 27831: @2098600
     /* 2098600 */   GIM_Try, /*On fail goto*//*Label 27832*/ GIMT_Encode4(2098694), // Rule ID 16572 //
     /* 2098605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2098616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2098619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2098622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2098625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098651 */     // MIs[0] round
     /* 2098651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098654 */     // MIs[0] policy
     /* 2098654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098664 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2098667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098693 */     // GIR_Coverage, 16572,
     /* 2098693 */     GIR_EraseRootFromParent_Done,
     /* 2098694 */   // Label 27832: @2098694
     /* 2098694 */   GIM_Try, /*On fail goto*//*Label 27833*/ GIMT_Encode4(2098788), // Rule ID 16573 //
     /* 2098699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2098710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2098713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2098716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2098719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098745 */     // MIs[0] round
     /* 2098745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098748 */     // MIs[0] policy
     /* 2098748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098758 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2098761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098787 */     // GIR_Coverage, 16573,
     /* 2098787 */     GIR_EraseRootFromParent_Done,
     /* 2098788 */   // Label 27833: @2098788
     /* 2098788 */   GIM_Try, /*On fail goto*//*Label 27834*/ GIMT_Encode4(2098882), // Rule ID 16576 //
     /* 2098793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2098796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2098804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2098807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2098810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2098813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098839 */     // MIs[0] round
     /* 2098839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098842 */     // MIs[0] policy
     /* 2098842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098852 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2098855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098881 */     // GIR_Coverage, 16576,
     /* 2098881 */     GIR_EraseRootFromParent_Done,
     /* 2098882 */   // Label 27834: @2098882
     /* 2098882 */   GIM_Try, /*On fail goto*//*Label 27835*/ GIMT_Encode4(2098976), // Rule ID 16577 //
     /* 2098887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2098890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2098898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2098901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2098904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2098907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098933 */     // MIs[0] round
     /* 2098933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098936 */     // MIs[0] policy
     /* 2098936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2098949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098975 */     // GIR_Coverage, 16577,
     /* 2098975 */     GIR_EraseRootFromParent_Done,
     /* 2098976 */   // Label 27835: @2098976
     /* 2098976 */   GIM_Try, /*On fail goto*//*Label 27836*/ GIMT_Encode4(2099070), // Rule ID 16580 //
     /* 2098981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2098984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2098992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2098995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2098998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2099001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099027 */     // MIs[0] round
     /* 2099027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099030 */     // MIs[0] policy
     /* 2099030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2099043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099069 */     // GIR_Coverage, 16580,
     /* 2099069 */     GIR_EraseRootFromParent_Done,
     /* 2099070 */   // Label 27836: @2099070
     /* 2099070 */   GIM_Try, /*On fail goto*//*Label 27837*/ GIMT_Encode4(2099164), // Rule ID 16581 //
     /* 2099075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2099078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2099086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2099089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2099092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2099095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099121 */     // MIs[0] round
     /* 2099121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099124 */     // MIs[0] policy
     /* 2099124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2099137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099163 */     // GIR_Coverage, 16581,
     /* 2099163 */     GIR_EraseRootFromParent_Done,
     /* 2099164 */   // Label 27837: @2099164
     /* 2099164 */   GIM_Try, /*On fail goto*//*Label 27838*/ GIMT_Encode4(2099258), // Rule ID 16584 //
     /* 2099169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2099172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2099180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2099183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2099186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2099189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099215 */     // MIs[0] round
     /* 2099215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099218 */     // MIs[0] policy
     /* 2099218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2099231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099257 */     // GIR_Coverage, 16584,
     /* 2099257 */     GIR_EraseRootFromParent_Done,
     /* 2099258 */   // Label 27838: @2099258
     /* 2099258 */   GIM_Try, /*On fail goto*//*Label 27839*/ GIMT_Encode4(2099352), // Rule ID 16585 //
     /* 2099263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2099266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2099274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2099277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2099280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2099283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099309 */     // MIs[0] round
     /* 2099309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099312 */     // MIs[0] policy
     /* 2099312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2099325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099351 */     // GIR_Coverage, 16585,
     /* 2099351 */     GIR_EraseRootFromParent_Done,
     /* 2099352 */   // Label 27839: @2099352
     /* 2099352 */   GIM_Try, /*On fail goto*//*Label 27840*/ GIMT_Encode4(2099446), // Rule ID 16588 //
     /* 2099357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2099360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2099368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2099371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2099374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2099377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099403 */     // MIs[0] round
     /* 2099403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099406 */     // MIs[0] policy
     /* 2099406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2099419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099445 */     // GIR_Coverage, 16588,
     /* 2099445 */     GIR_EraseRootFromParent_Done,
     /* 2099446 */   // Label 27840: @2099446
     /* 2099446 */   GIM_Try, /*On fail goto*//*Label 27841*/ GIMT_Encode4(2099540), // Rule ID 16589 //
     /* 2099451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2099454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2099462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2099465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2099468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2099471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099497 */     // MIs[0] round
     /* 2099497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099500 */     // MIs[0] policy
     /* 2099500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099510 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2099513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099539 */     // GIR_Coverage, 16589,
     /* 2099539 */     GIR_EraseRootFromParent_Done,
     /* 2099540 */   // Label 27841: @2099540
     /* 2099540 */   GIM_Try, /*On fail goto*//*Label 27842*/ GIMT_Encode4(2099634), // Rule ID 16592 //
     /* 2099545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2099556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2099559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2099562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099591 */     // MIs[0] round
     /* 2099591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099594 */     // MIs[0] policy
     /* 2099594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099604 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2099607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099633 */     // GIR_Coverage, 16592,
     /* 2099633 */     GIR_EraseRootFromParent_Done,
     /* 2099634 */   // Label 27842: @2099634
     /* 2099634 */   GIM_Try, /*On fail goto*//*Label 27843*/ GIMT_Encode4(2099728), // Rule ID 16593 //
     /* 2099639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2099650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2099653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2099656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099685 */     // MIs[0] round
     /* 2099685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099688 */     // MIs[0] policy
     /* 2099688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099698 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2099701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099727 */     // GIR_Coverage, 16593,
     /* 2099727 */     GIR_EraseRootFromParent_Done,
     /* 2099728 */   // Label 27843: @2099728
     /* 2099728 */   GIM_Try, /*On fail goto*//*Label 27844*/ GIMT_Encode4(2099822), // Rule ID 16596 //
     /* 2099733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2099744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2099747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2099750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099779 */     // MIs[0] round
     /* 2099779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099782 */     // MIs[0] policy
     /* 2099782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099792 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2099795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099821 */     // GIR_Coverage, 16596,
     /* 2099821 */     GIR_EraseRootFromParent_Done,
     /* 2099822 */   // Label 27844: @2099822
     /* 2099822 */   GIM_Try, /*On fail goto*//*Label 27845*/ GIMT_Encode4(2099916), // Rule ID 16597 //
     /* 2099827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2099838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2099841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2099844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099873 */     // MIs[0] round
     /* 2099873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099876 */     // MIs[0] policy
     /* 2099876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099886 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2099889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099915 */     // GIR_Coverage, 16597,
     /* 2099915 */     GIR_EraseRootFromParent_Done,
     /* 2099916 */   // Label 27845: @2099916
     /* 2099916 */   GIM_Try, /*On fail goto*//*Label 27846*/ GIMT_Encode4(2100010), // Rule ID 16600 //
     /* 2099921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2099932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2099935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2099938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099967 */     // MIs[0] round
     /* 2099967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099970 */     // MIs[0] policy
     /* 2099970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099980 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2099983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100009 */     // GIR_Coverage, 16600,
     /* 2100009 */     GIR_EraseRootFromParent_Done,
     /* 2100010 */   // Label 27846: @2100010
     /* 2100010 */   GIM_Try, /*On fail goto*//*Label 27847*/ GIMT_Encode4(2100104), // Rule ID 16601 //
     /* 2100015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2100026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2100029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2100032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2100038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100061 */     // MIs[0] round
     /* 2100061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100064 */     // MIs[0] policy
     /* 2100064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100074 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2100077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100103 */     // GIR_Coverage, 16601,
     /* 2100103 */     GIR_EraseRootFromParent_Done,
     /* 2100104 */   // Label 27847: @2100104
     /* 2100104 */   GIM_Try, /*On fail goto*//*Label 27848*/ GIMT_Encode4(2100198), // Rule ID 16604 //
     /* 2100109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2100120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2100123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2100126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100155 */     // MIs[0] round
     /* 2100155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100158 */     // MIs[0] policy
     /* 2100158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100168 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2100171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100197 */     // GIR_Coverage, 16604,
     /* 2100197 */     GIR_EraseRootFromParent_Done,
     /* 2100198 */   // Label 27848: @2100198
     /* 2100198 */   GIM_Try, /*On fail goto*//*Label 27849*/ GIMT_Encode4(2100292), // Rule ID 16605 //
     /* 2100203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2100214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2100217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2100220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100249 */     // MIs[0] round
     /* 2100249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100252 */     // MIs[0] policy
     /* 2100252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100262 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2100265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100291 */     // GIR_Coverage, 16605,
     /* 2100291 */     GIR_EraseRootFromParent_Done,
     /* 2100292 */   // Label 27849: @2100292
     /* 2100292 */   GIM_Try, /*On fail goto*//*Label 27850*/ GIMT_Encode4(2100386), // Rule ID 16608 //
     /* 2100297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2100308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2100311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2100314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2100320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100343 */     // MIs[0] round
     /* 2100343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100346 */     // MIs[0] policy
     /* 2100346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100356 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2100359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100385 */     // GIR_Coverage, 16608,
     /* 2100385 */     GIR_EraseRootFromParent_Done,
     /* 2100386 */   // Label 27850: @2100386
     /* 2100386 */   GIM_Try, /*On fail goto*//*Label 27851*/ GIMT_Encode4(2100480), // Rule ID 16609 //
     /* 2100391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2100402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2100405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2100408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2100414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100437 */     // MIs[0] round
     /* 2100437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100440 */     // MIs[0] policy
     /* 2100440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100450 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2100453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100479 */     // GIR_Coverage, 16609,
     /* 2100479 */     GIR_EraseRootFromParent_Done,
     /* 2100480 */   // Label 27851: @2100480
     /* 2100480 */   GIM_Try, /*On fail goto*//*Label 27852*/ GIMT_Encode4(2100574), // Rule ID 16612 //
     /* 2100485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2100496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2100499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2100502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2100508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100531 */     // MIs[0] round
     /* 2100531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100534 */     // MIs[0] policy
     /* 2100534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100544 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2100547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100573 */     // GIR_Coverage, 16612,
     /* 2100573 */     GIR_EraseRootFromParent_Done,
     /* 2100574 */   // Label 27852: @2100574
     /* 2100574 */   GIM_Try, /*On fail goto*//*Label 27853*/ GIMT_Encode4(2100668), // Rule ID 16613 //
     /* 2100579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2100590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2100593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2100596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2100602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100625 */     // MIs[0] round
     /* 2100625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100628 */     // MIs[0] policy
     /* 2100628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100638 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2100641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100667 */     // GIR_Coverage, 16613,
     /* 2100667 */     GIR_EraseRootFromParent_Done,
     /* 2100668 */   // Label 27853: @2100668
     /* 2100668 */   GIM_Try, /*On fail goto*//*Label 27854*/ GIMT_Encode4(2100762), // Rule ID 16616 //
     /* 2100673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2100684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2100687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2100690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100719 */     // MIs[0] round
     /* 2100719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100722 */     // MIs[0] policy
     /* 2100722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100732 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2100735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100761 */     // GIR_Coverage, 16616,
     /* 2100761 */     GIR_EraseRootFromParent_Done,
     /* 2100762 */   // Label 27854: @2100762
     /* 2100762 */   GIM_Try, /*On fail goto*//*Label 27855*/ GIMT_Encode4(2100856), // Rule ID 16617 //
     /* 2100767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2100778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2100781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2100784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100813 */     // MIs[0] round
     /* 2100813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100816 */     // MIs[0] policy
     /* 2100816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100826 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2100829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100855 */     // GIR_Coverage, 16617,
     /* 2100855 */     GIR_EraseRootFromParent_Done,
     /* 2100856 */   // Label 27855: @2100856
     /* 2100856 */   GIM_Try, /*On fail goto*//*Label 27856*/ GIMT_Encode4(2100950), // Rule ID 16620 //
     /* 2100861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2100872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2100875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2100878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100907 */     // MIs[0] round
     /* 2100907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100910 */     // MIs[0] policy
     /* 2100910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100920 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2100923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100949 */     // GIR_Coverage, 16620,
     /* 2100949 */     GIR_EraseRootFromParent_Done,
     /* 2100950 */   // Label 27856: @2100950
     /* 2100950 */   GIM_Try, /*On fail goto*//*Label 27857*/ GIMT_Encode4(2101044), // Rule ID 16621 //
     /* 2100955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2100966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2100969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2100972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101001 */     // MIs[0] round
     /* 2101001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101004 */     // MIs[0] policy
     /* 2101004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101014 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2101017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101043 */     // GIR_Coverage, 16621,
     /* 2101043 */     GIR_EraseRootFromParent_Done,
     /* 2101044 */   // Label 27857: @2101044
     /* 2101044 */   GIM_Try, /*On fail goto*//*Label 27858*/ GIMT_Encode4(2101138), // Rule ID 16624 //
     /* 2101049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2101060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2101063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2101066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101095 */     // MIs[0] round
     /* 2101095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101098 */     // MIs[0] policy
     /* 2101098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2101111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101137 */     // GIR_Coverage, 16624,
     /* 2101137 */     GIR_EraseRootFromParent_Done,
     /* 2101138 */   // Label 27858: @2101138
     /* 2101138 */   GIM_Try, /*On fail goto*//*Label 27859*/ GIMT_Encode4(2101232), // Rule ID 16625 //
     /* 2101143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2101154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2101157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2101160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101189 */     // MIs[0] round
     /* 2101189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101192 */     // MIs[0] policy
     /* 2101192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2101205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101231 */     // GIR_Coverage, 16625,
     /* 2101231 */     GIR_EraseRootFromParent_Done,
     /* 2101232 */   // Label 27859: @2101232
     /* 2101232 */   GIM_Try, /*On fail goto*//*Label 27860*/ GIMT_Encode4(2101326), // Rule ID 16628 //
     /* 2101237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2101248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2101251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2101254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101283 */     // MIs[0] round
     /* 2101283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101286 */     // MIs[0] policy
     /* 2101286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2101299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101325 */     // GIR_Coverage, 16628,
     /* 2101325 */     GIR_EraseRootFromParent_Done,
     /* 2101326 */   // Label 27860: @2101326
     /* 2101326 */   GIM_Try, /*On fail goto*//*Label 27861*/ GIMT_Encode4(2101420), // Rule ID 16629 //
     /* 2101331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2101342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2101345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2101348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101377 */     // MIs[0] round
     /* 2101377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101380 */     // MIs[0] policy
     /* 2101380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101390 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2101393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101419 */     // GIR_Coverage, 16629,
     /* 2101419 */     GIR_EraseRootFromParent_Done,
     /* 2101420 */   // Label 27861: @2101420
     /* 2101420 */   GIM_Try, /*On fail goto*//*Label 27862*/ GIMT_Encode4(2101514), // Rule ID 16632 //
     /* 2101425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2101436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2101439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2101442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2101448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101471 */     // MIs[0] round
     /* 2101471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101474 */     // MIs[0] policy
     /* 2101474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101484 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2101487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101513 */     // GIR_Coverage, 16632,
     /* 2101513 */     GIR_EraseRootFromParent_Done,
     /* 2101514 */   // Label 27862: @2101514
     /* 2101514 */   GIM_Try, /*On fail goto*//*Label 27863*/ GIMT_Encode4(2101608), // Rule ID 16633 //
     /* 2101519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2101530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2101533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2101536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2101542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101565 */     // MIs[0] round
     /* 2101565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101568 */     // MIs[0] policy
     /* 2101568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101578 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2101581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101607 */     // GIR_Coverage, 16633,
     /* 2101607 */     GIR_EraseRootFromParent_Done,
     /* 2101608 */   // Label 27863: @2101608
     /* 2101608 */   GIM_Try, /*On fail goto*//*Label 27864*/ GIMT_Encode4(2101702), // Rule ID 16636 //
     /* 2101613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2101624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2101627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2101630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101659 */     // MIs[0] round
     /* 2101659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101662 */     // MIs[0] policy
     /* 2101662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2101675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101701 */     // GIR_Coverage, 16636,
     /* 2101701 */     GIR_EraseRootFromParent_Done,
     /* 2101702 */   // Label 27864: @2101702
     /* 2101702 */   GIM_Try, /*On fail goto*//*Label 27865*/ GIMT_Encode4(2101796), // Rule ID 16637 //
     /* 2101707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2101718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2101721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2101724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101753 */     // MIs[0] round
     /* 2101753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101756 */     // MIs[0] policy
     /* 2101756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101766 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2101769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101795 */     // GIR_Coverage, 16637,
     /* 2101795 */     GIR_EraseRootFromParent_Done,
     /* 2101796 */   // Label 27865: @2101796
     /* 2101796 */   GIM_Try, /*On fail goto*//*Label 27866*/ GIMT_Encode4(2101890), // Rule ID 16640 //
     /* 2101801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2101812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2101815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2101818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101847 */     // MIs[0] round
     /* 2101847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101850 */     // MIs[0] policy
     /* 2101850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101860 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2101863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101889 */     // GIR_Coverage, 16640,
     /* 2101889 */     GIR_EraseRootFromParent_Done,
     /* 2101890 */   // Label 27866: @2101890
     /* 2101890 */   GIM_Try, /*On fail goto*//*Label 27867*/ GIMT_Encode4(2101984), // Rule ID 16641 //
     /* 2101895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2101906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2101909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2101912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101941 */     // MIs[0] round
     /* 2101941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101944 */     // MIs[0] policy
     /* 2101944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101954 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2101957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101983 */     // GIR_Coverage, 16641,
     /* 2101983 */     GIR_EraseRootFromParent_Done,
     /* 2101984 */   // Label 27867: @2101984
     /* 2101984 */   GIM_Try, /*On fail goto*//*Label 27868*/ GIMT_Encode4(2102078), // Rule ID 16644 //
     /* 2101989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2102000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2102003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2102006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2102009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2102019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2102031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102035 */     // MIs[0] round
     /* 2102035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102038 */     // MIs[0] policy
     /* 2102038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2102051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102077 */     // GIR_Coverage, 16644,
     /* 2102077 */     GIR_EraseRootFromParent_Done,
     /* 2102078 */   // Label 27868: @2102078
     /* 2102078 */   GIM_Try, /*On fail goto*//*Label 27869*/ GIMT_Encode4(2102172), // Rule ID 16645 //
     /* 2102083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2102094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2102097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2102100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2102103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2102113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2102125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102129 */     // MIs[0] round
     /* 2102129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102132 */     // MIs[0] policy
     /* 2102132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102142 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2102145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102171 */     // GIR_Coverage, 16645,
     /* 2102171 */     GIR_EraseRootFromParent_Done,
     /* 2102172 */   // Label 27869: @2102172
     /* 2102172 */   GIM_Try, /*On fail goto*//*Label 27870*/ GIMT_Encode4(2102266), // Rule ID 16648 //
     /* 2102177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2102180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2102188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2102191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2102194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2102197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2102200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2102219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102223 */     // MIs[0] round
     /* 2102223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102226 */     // MIs[0] policy
     /* 2102226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102236 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2102239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102265 */     // GIR_Coverage, 16648,
     /* 2102265 */     GIR_EraseRootFromParent_Done,
     /* 2102266 */   // Label 27870: @2102266
     /* 2102266 */   GIM_Try, /*On fail goto*//*Label 27871*/ GIMT_Encode4(2102360), // Rule ID 16649 //
     /* 2102271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2102282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2102285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2102288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2102291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2102294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2102313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102317 */     // MIs[0] round
     /* 2102317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102320 */     // MIs[0] policy
     /* 2102320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102330 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2102333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102359 */     // GIR_Coverage, 16649,
     /* 2102359 */     GIR_EraseRootFromParent_Done,
     /* 2102360 */   // Label 27871: @2102360
     /* 2102360 */   GIM_Try, /*On fail goto*//*Label 27872*/ GIMT_Encode4(2102451), // Rule ID 16712 //
     /* 2102365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2102376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2102379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2102382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2102385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102411 */     // MIs[0] round
     /* 2102411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102414 */     // MIs[0] policy
     /* 2102414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102424 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2102427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102450 */     // GIR_Coverage, 16712,
     /* 2102450 */     GIR_EraseRootFromParent_Done,
     /* 2102451 */   // Label 27872: @2102451
     /* 2102451 */   GIM_Try, /*On fail goto*//*Label 27873*/ GIMT_Encode4(2102542), // Rule ID 16713 //
     /* 2102456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2102467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2102470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2102473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2102476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102502 */     // MIs[0] round
     /* 2102502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102505 */     // MIs[0] policy
     /* 2102505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102515 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2102518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102541 */     // GIR_Coverage, 16713,
     /* 2102541 */     GIR_EraseRootFromParent_Done,
     /* 2102542 */   // Label 27873: @2102542
     /* 2102542 */   GIM_Try, /*On fail goto*//*Label 27874*/ GIMT_Encode4(2102633), // Rule ID 16716 //
     /* 2102547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2102558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2102561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2102564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2102567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102593 */     // MIs[0] round
     /* 2102593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102596 */     // MIs[0] policy
     /* 2102596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102606 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2102609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102632 */     // GIR_Coverage, 16716,
     /* 2102632 */     GIR_EraseRootFromParent_Done,
     /* 2102633 */   // Label 27874: @2102633
     /* 2102633 */   GIM_Try, /*On fail goto*//*Label 27875*/ GIMT_Encode4(2102724), // Rule ID 16717 //
     /* 2102638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2102649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2102652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2102655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2102658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102684 */     // MIs[0] round
     /* 2102684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102687 */     // MIs[0] policy
     /* 2102687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102697 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2102700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102723 */     // GIR_Coverage, 16717,
     /* 2102723 */     GIR_EraseRootFromParent_Done,
     /* 2102724 */   // Label 27875: @2102724
     /* 2102724 */   GIM_Try, /*On fail goto*//*Label 27876*/ GIMT_Encode4(2102815), // Rule ID 16720 //
     /* 2102729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2102732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2102740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2102743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2102746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2102749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102775 */     // MIs[0] round
     /* 2102775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102778 */     // MIs[0] policy
     /* 2102778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102788 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2102791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102814 */     // GIR_Coverage, 16720,
     /* 2102814 */     GIR_EraseRootFromParent_Done,
     /* 2102815 */   // Label 27876: @2102815
     /* 2102815 */   GIM_Try, /*On fail goto*//*Label 27877*/ GIMT_Encode4(2102906), // Rule ID 16721 //
     /* 2102820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2102823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2102831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2102834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2102837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2102840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102866 */     // MIs[0] round
     /* 2102866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102869 */     // MIs[0] policy
     /* 2102869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102879 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2102882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102905 */     // GIR_Coverage, 16721,
     /* 2102905 */     GIR_EraseRootFromParent_Done,
     /* 2102906 */   // Label 27877: @2102906
     /* 2102906 */   GIM_Try, /*On fail goto*//*Label 27878*/ GIMT_Encode4(2102997), // Rule ID 16724 //
     /* 2102911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2102922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2102925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2102928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2102931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102957 */     // MIs[0] round
     /* 2102957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102960 */     // MIs[0] policy
     /* 2102960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102970 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2102973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102996 */     // GIR_Coverage, 16724,
     /* 2102996 */     GIR_EraseRootFromParent_Done,
     /* 2102997 */   // Label 27878: @2102997
     /* 2102997 */   GIM_Try, /*On fail goto*//*Label 27879*/ GIMT_Encode4(2103088), // Rule ID 16725 //
     /* 2103002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2103013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2103016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2103019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2103022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103048 */     // MIs[0] round
     /* 2103048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103051 */     // MIs[0] policy
     /* 2103051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103061 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2103064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103087 */     // GIR_Coverage, 16725,
     /* 2103087 */     GIR_EraseRootFromParent_Done,
     /* 2103088 */   // Label 27879: @2103088
     /* 2103088 */   GIM_Try, /*On fail goto*//*Label 27880*/ GIMT_Encode4(2103179), // Rule ID 16728 //
     /* 2103093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2103104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2103107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2103110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2103113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2103116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103139 */     // MIs[0] round
     /* 2103139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103142 */     // MIs[0] policy
     /* 2103142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103152 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2103155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103178 */     // GIR_Coverage, 16728,
     /* 2103178 */     GIR_EraseRootFromParent_Done,
     /* 2103179 */   // Label 27880: @2103179
     /* 2103179 */   GIM_Try, /*On fail goto*//*Label 27881*/ GIMT_Encode4(2103270), // Rule ID 16729 //
     /* 2103184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2103187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2103195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2103198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2103201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2103204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2103207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103230 */     // MIs[0] round
     /* 2103230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103233 */     // MIs[0] policy
     /* 2103233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103243 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2103246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103269 */     // GIR_Coverage, 16729,
     /* 2103269 */     GIR_EraseRootFromParent_Done,
     /* 2103270 */   // Label 27881: @2103270
     /* 2103270 */   GIM_Try, /*On fail goto*//*Label 27882*/ GIMT_Encode4(2103361), // Rule ID 16732 //
     /* 2103275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2103278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2103286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2103289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2103292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2103295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2103298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103321 */     // MIs[0] round
     /* 2103321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103324 */     // MIs[0] policy
     /* 2103324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103334 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2103337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2103357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103360 */     // GIR_Coverage, 16732,
     /* 2103360 */     GIR_EraseRootFromParent_Done,
     /* 2103361 */   // Label 27882: @2103361
     /* 2103361 */   GIM_Try, /*On fail goto*//*Label 27883*/ GIMT_Encode4(2103452), // Rule ID 16733 //
     /* 2103366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2103369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2103377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2103380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2103383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2103386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2103389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103412 */     // MIs[0] round
     /* 2103412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103415 */     // MIs[0] policy
     /* 2103415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103425 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2103428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2103448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103451 */     // GIR_Coverage, 16733,
     /* 2103451 */     GIR_EraseRootFromParent_Done,
     /* 2103452 */   // Label 27883: @2103452
     /* 2103452 */   GIM_Try, /*On fail goto*//*Label 27884*/ GIMT_Encode4(2103543), // Rule ID 16736 //
     /* 2103457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2103468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2103471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2103474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2103477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103503 */     // MIs[0] round
     /* 2103503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103506 */     // MIs[0] policy
     /* 2103506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103516 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2103519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103542 */     // GIR_Coverage, 16736,
     /* 2103542 */     GIR_EraseRootFromParent_Done,
     /* 2103543 */   // Label 27884: @2103543
     /* 2103543 */   GIM_Try, /*On fail goto*//*Label 27885*/ GIMT_Encode4(2103634), // Rule ID 16737 //
     /* 2103548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2103559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2103562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2103565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2103568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103594 */     // MIs[0] round
     /* 2103594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103597 */     // MIs[0] policy
     /* 2103597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103607 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2103610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103633 */     // GIR_Coverage, 16737,
     /* 2103633 */     GIR_EraseRootFromParent_Done,
     /* 2103634 */   // Label 27885: @2103634
     /* 2103634 */   GIM_Try, /*On fail goto*//*Label 27886*/ GIMT_Encode4(2103725), // Rule ID 16740 //
     /* 2103639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2103650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2103653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2103656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2103659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103685 */     // MIs[0] round
     /* 2103685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103688 */     // MIs[0] policy
     /* 2103688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103698 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2103701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103724 */     // GIR_Coverage, 16740,
     /* 2103724 */     GIR_EraseRootFromParent_Done,
     /* 2103725 */   // Label 27886: @2103725
     /* 2103725 */   GIM_Try, /*On fail goto*//*Label 27887*/ GIMT_Encode4(2103816), // Rule ID 16741 //
     /* 2103730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2103741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2103744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2103747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2103750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103776 */     // MIs[0] round
     /* 2103776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103779 */     // MIs[0] policy
     /* 2103779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103789 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2103792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103815 */     // GIR_Coverage, 16741,
     /* 2103815 */     GIR_EraseRootFromParent_Done,
     /* 2103816 */   // Label 27887: @2103816
     /* 2103816 */   GIM_Try, /*On fail goto*//*Label 27888*/ GIMT_Encode4(2103907), // Rule ID 16744 //
     /* 2103821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2103832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2103835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2103838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2103841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2103844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103867 */     // MIs[0] round
     /* 2103867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103870 */     // MIs[0] policy
     /* 2103870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103880 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2103883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103906 */     // GIR_Coverage, 16744,
     /* 2103906 */     GIR_EraseRootFromParent_Done,
     /* 2103907 */   // Label 27888: @2103907
     /* 2103907 */   GIM_Try, /*On fail goto*//*Label 27889*/ GIMT_Encode4(2103998), // Rule ID 16745 //
     /* 2103912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2103923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2103926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2103929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2103932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2103935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103958 */     // MIs[0] round
     /* 2103958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103961 */     // MIs[0] policy
     /* 2103961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103971 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2103974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103997 */     // GIR_Coverage, 16745,
     /* 2103997 */     GIR_EraseRootFromParent_Done,
     /* 2103998 */   // Label 27889: @2103998
     /* 2103998 */   GIM_Try, /*On fail goto*//*Label 27890*/ GIMT_Encode4(2104089), // Rule ID 16748 //
     /* 2104003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2104006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2104014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2104017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2104020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2104023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104049 */     // MIs[0] round
     /* 2104049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104052 */     // MIs[0] policy
     /* 2104052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104062 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2104065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104088 */     // GIR_Coverage, 16748,
     /* 2104088 */     GIR_EraseRootFromParent_Done,
     /* 2104089 */   // Label 27890: @2104089
     /* 2104089 */   GIM_Try, /*On fail goto*//*Label 27891*/ GIMT_Encode4(2104180), // Rule ID 16749 //
     /* 2104094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2104097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2104105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2104108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2104111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2104114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104140 */     // MIs[0] round
     /* 2104140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104143 */     // MIs[0] policy
     /* 2104143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104153 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2104156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104179 */     // GIR_Coverage, 16749,
     /* 2104179 */     GIR_EraseRootFromParent_Done,
     /* 2104180 */   // Label 27891: @2104180
     /* 2104180 */   GIM_Try, /*On fail goto*//*Label 27892*/ GIMT_Encode4(2104271), // Rule ID 16752 //
     /* 2104185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2104188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2104196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2104199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2104202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2104205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104231 */     // MIs[0] round
     /* 2104231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104234 */     // MIs[0] policy
     /* 2104234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104244 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2104247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104270 */     // GIR_Coverage, 16752,
     /* 2104270 */     GIR_EraseRootFromParent_Done,
     /* 2104271 */   // Label 27892: @2104271
     /* 2104271 */   GIM_Try, /*On fail goto*//*Label 27893*/ GIMT_Encode4(2104362), // Rule ID 16753 //
     /* 2104276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2104279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2104287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2104290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2104293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2104296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104322 */     // MIs[0] round
     /* 2104322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104325 */     // MIs[0] policy
     /* 2104325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104335 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2104338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104361 */     // GIR_Coverage, 16753,
     /* 2104361 */     GIR_EraseRootFromParent_Done,
     /* 2104362 */   // Label 27893: @2104362
     /* 2104362 */   GIM_Try, /*On fail goto*//*Label 27894*/ GIMT_Encode4(2104453), // Rule ID 16756 //
     /* 2104367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2104370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2104378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2104381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2104384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2104387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2104390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104413 */     // MIs[0] round
     /* 2104413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104416 */     // MIs[0] policy
     /* 2104416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104426 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2104429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104452 */     // GIR_Coverage, 16756,
     /* 2104452 */     GIR_EraseRootFromParent_Done,
     /* 2104453 */   // Label 27894: @2104453
     /* 2104453 */   GIM_Try, /*On fail goto*//*Label 27895*/ GIMT_Encode4(2104544), // Rule ID 16757 //
     /* 2104458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2104461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2104469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2104472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2104475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2104478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2104481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104504 */     // MIs[0] round
     /* 2104504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104507 */     // MIs[0] policy
     /* 2104507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104517 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2104520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104543 */     // GIR_Coverage, 16757,
     /* 2104543 */     GIR_EraseRootFromParent_Done,
     /* 2104544 */   // Label 27895: @2104544
     /* 2104544 */   GIM_Try, /*On fail goto*//*Label 27896*/ GIMT_Encode4(2104635), // Rule ID 16760 //
     /* 2104549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2104560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2104563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2104566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2104569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104595 */     // MIs[0] round
     /* 2104595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104598 */     // MIs[0] policy
     /* 2104598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104608 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2104611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104634 */     // GIR_Coverage, 16760,
     /* 2104634 */     GIR_EraseRootFromParent_Done,
     /* 2104635 */   // Label 27896: @2104635
     /* 2104635 */   GIM_Try, /*On fail goto*//*Label 27897*/ GIMT_Encode4(2104726), // Rule ID 16761 //
     /* 2104640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2104651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2104654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2104657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2104660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104686 */     // MIs[0] round
     /* 2104686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104689 */     // MIs[0] policy
     /* 2104689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104699 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2104702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104725 */     // GIR_Coverage, 16761,
     /* 2104725 */     GIR_EraseRootFromParent_Done,
     /* 2104726 */   // Label 27897: @2104726
     /* 2104726 */   GIM_Try, /*On fail goto*//*Label 27898*/ GIMT_Encode4(2104817), // Rule ID 16764 //
     /* 2104731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2104742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2104745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2104748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2104751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104777 */     // MIs[0] round
     /* 2104777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104780 */     // MIs[0] policy
     /* 2104780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104790 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2104793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104816 */     // GIR_Coverage, 16764,
     /* 2104816 */     GIR_EraseRootFromParent_Done,
     /* 2104817 */   // Label 27898: @2104817
     /* 2104817 */   GIM_Try, /*On fail goto*//*Label 27899*/ GIMT_Encode4(2104908), // Rule ID 16765 //
     /* 2104822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2104833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2104836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2104839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2104842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104868 */     // MIs[0] round
     /* 2104868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104871 */     // MIs[0] policy
     /* 2104871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104881 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2104884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104907 */     // GIR_Coverage, 16765,
     /* 2104907 */     GIR_EraseRootFromParent_Done,
     /* 2104908 */   // Label 27899: @2104908
     /* 2104908 */   GIM_Try, /*On fail goto*//*Label 27900*/ GIMT_Encode4(2104999), // Rule ID 16768 //
     /* 2104913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2104924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2104927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2104930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2104933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104959 */     // MIs[0] round
     /* 2104959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104962 */     // MIs[0] policy
     /* 2104962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104972 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2104975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104998 */     // GIR_Coverage, 16768,
     /* 2104998 */     GIR_EraseRootFromParent_Done,
     /* 2104999 */   // Label 27900: @2104999
     /* 2104999 */   GIM_Try, /*On fail goto*//*Label 27901*/ GIMT_Encode4(2105090), // Rule ID 16769 //
     /* 2105004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2105007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2105015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2105018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2105021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2105024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2105034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105050 */     // MIs[0] round
     /* 2105050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105053 */     // MIs[0] policy
     /* 2105053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105063 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2105066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105089 */     // GIR_Coverage, 16769,
     /* 2105089 */     GIR_EraseRootFromParent_Done,
     /* 2105090 */   // Label 27901: @2105090
     /* 2105090 */   GIM_Try, /*On fail goto*//*Label 27902*/ GIMT_Encode4(2105181), // Rule ID 16772 //
     /* 2105095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2105106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2105109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2105112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105141 */     // MIs[0] round
     /* 2105141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105144 */     // MIs[0] policy
     /* 2105144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105154 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2105157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105180 */     // GIR_Coverage, 16772,
     /* 2105180 */     GIR_EraseRootFromParent_Done,
     /* 2105181 */   // Label 27902: @2105181
     /* 2105181 */   GIM_Try, /*On fail goto*//*Label 27903*/ GIMT_Encode4(2105272), // Rule ID 16773 //
     /* 2105186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2105189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2105197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2105200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2105203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105232 */     // MIs[0] round
     /* 2105232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105235 */     // MIs[0] policy
     /* 2105235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105245 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2105248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105271 */     // GIR_Coverage, 16773,
     /* 2105271 */     GIR_EraseRootFromParent_Done,
     /* 2105272 */   // Label 27903: @2105272
     /* 2105272 */   GIM_Try, /*On fail goto*//*Label 27904*/ GIMT_Encode4(2105363), // Rule ID 16776 //
     /* 2105277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2105288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2105291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2105294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105323 */     // MIs[0] round
     /* 2105323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105326 */     // MIs[0] policy
     /* 2105326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105336 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2105339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105362 */     // GIR_Coverage, 16776,
     /* 2105362 */     GIR_EraseRootFromParent_Done,
     /* 2105363 */   // Label 27904: @2105363
     /* 2105363 */   GIM_Try, /*On fail goto*//*Label 27905*/ GIMT_Encode4(2105454), // Rule ID 16777 //
     /* 2105368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2105371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2105379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2105382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2105385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105414 */     // MIs[0] round
     /* 2105414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105417 */     // MIs[0] policy
     /* 2105417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105427 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2105430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105453 */     // GIR_Coverage, 16777,
     /* 2105453 */     GIR_EraseRootFromParent_Done,
     /* 2105454 */   // Label 27905: @2105454
     /* 2105454 */   GIM_Try, /*On fail goto*//*Label 27906*/ GIMT_Encode4(2105545), // Rule ID 16780 //
     /* 2105459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2105462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2105470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2105473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2105476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105505 */     // MIs[0] round
     /* 2105505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105508 */     // MIs[0] policy
     /* 2105508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105518 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2105521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105544 */     // GIR_Coverage, 16780,
     /* 2105544 */     GIR_EraseRootFromParent_Done,
     /* 2105545 */   // Label 27906: @2105545
     /* 2105545 */   GIM_Try, /*On fail goto*//*Label 27907*/ GIMT_Encode4(2105636), // Rule ID 16781 //
     /* 2105550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2105553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2105561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2105564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2105567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105596 */     // MIs[0] round
     /* 2105596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105599 */     // MIs[0] policy
     /* 2105599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105609 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2105612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105635 */     // GIR_Coverage, 16781,
     /* 2105635 */     GIR_EraseRootFromParent_Done,
     /* 2105636 */   // Label 27907: @2105636
     /* 2105636 */   GIM_Try, /*On fail goto*//*Label 27908*/ GIMT_Encode4(2105727), // Rule ID 16784 //
     /* 2105641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2105652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2105655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2105658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105687 */     // MIs[0] round
     /* 2105687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105690 */     // MIs[0] policy
     /* 2105690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105700 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2105703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105726 */     // GIR_Coverage, 16784,
     /* 2105726 */     GIR_EraseRootFromParent_Done,
     /* 2105727 */   // Label 27908: @2105727
     /* 2105727 */   GIM_Try, /*On fail goto*//*Label 27909*/ GIMT_Encode4(2105818), // Rule ID 16785 //
     /* 2105732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2105735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2105743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2105746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2105749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105778 */     // MIs[0] round
     /* 2105778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105781 */     // MIs[0] policy
     /* 2105781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105791 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2105794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105817 */     // GIR_Coverage, 16785,
     /* 2105817 */     GIR_EraseRootFromParent_Done,
     /* 2105818 */   // Label 27909: @2105818
     /* 2105818 */   GIM_Try, /*On fail goto*//*Label 27910*/ GIMT_Encode4(2105909), // Rule ID 16788 //
     /* 2105823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2105826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2105834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2105837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2105840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105869 */     // MIs[0] round
     /* 2105869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105872 */     // MIs[0] policy
     /* 2105872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105882 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2105885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105908 */     // GIR_Coverage, 16788,
     /* 2105908 */     GIR_EraseRootFromParent_Done,
     /* 2105909 */   // Label 27910: @2105909
     /* 2105909 */   GIM_Try, /*On fail goto*//*Label 27911*/ GIMT_Encode4(2106000), // Rule ID 16789 //
     /* 2105914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2105917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2105925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2105928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2105931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105960 */     // MIs[0] round
     /* 2105960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105963 */     // MIs[0] policy
     /* 2105963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105973 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2105976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105999 */     // GIR_Coverage, 16789,
     /* 2105999 */     GIR_EraseRootFromParent_Done,
     /* 2106000 */   // Label 27911: @2106000
     /* 2106000 */   GIM_Try, /*On fail goto*//*Label 27912*/ GIMT_Encode4(2106091), // Rule ID 16792 //
     /* 2106005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2106008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2106016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2106019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2106022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2106025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2106047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106051 */     // MIs[0] round
     /* 2106051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106054 */     // MIs[0] policy
     /* 2106054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106064 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2106067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106090 */     // GIR_Coverage, 16792,
     /* 2106090 */     GIR_EraseRootFromParent_Done,
     /* 2106091 */   // Label 27912: @2106091
     /* 2106091 */   GIM_Try, /*On fail goto*//*Label 27913*/ GIMT_Encode4(2106182), // Rule ID 16793 //
     /* 2106096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2106099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2106107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2106110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2106113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2106116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2106138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106142 */     // MIs[0] round
     /* 2106142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106145 */     // MIs[0] policy
     /* 2106145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106155 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2106158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106181 */     // GIR_Coverage, 16793,
     /* 2106181 */     GIR_EraseRootFromParent_Done,
     /* 2106182 */   // Label 27913: @2106182
     /* 2106182 */   GIM_Try, /*On fail goto*//*Label 27914*/ GIMT_Encode4(2106273), // Rule ID 16796 //
     /* 2106187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2106190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2106198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2106201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2106204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106233 */     // MIs[0] round
     /* 2106233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106236 */     // MIs[0] policy
     /* 2106236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106246 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2106249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106272 */     // GIR_Coverage, 16796,
     /* 2106272 */     GIR_EraseRootFromParent_Done,
     /* 2106273 */   // Label 27914: @2106273
     /* 2106273 */   GIM_Try, /*On fail goto*//*Label 27915*/ GIMT_Encode4(2106364), // Rule ID 16797 //
     /* 2106278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2106289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2106292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2106295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106324 */     // MIs[0] round
     /* 2106324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106327 */     // MIs[0] policy
     /* 2106327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106337 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2106340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106363 */     // GIR_Coverage, 16797,
     /* 2106363 */     GIR_EraseRootFromParent_Done,
     /* 2106364 */   // Label 27915: @2106364
     /* 2106364 */   GIM_Try, /*On fail goto*//*Label 27916*/ GIMT_Encode4(2106455), // Rule ID 16800 //
     /* 2106369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2106372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2106380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2106383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2106386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2106392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106415 */     // MIs[0] round
     /* 2106415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106418 */     // MIs[0] policy
     /* 2106418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106428 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2106431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106454 */     // GIR_Coverage, 16800,
     /* 2106454 */     GIR_EraseRootFromParent_Done,
     /* 2106455 */   // Label 27916: @2106455
     /* 2106455 */   GIM_Try, /*On fail goto*//*Label 27917*/ GIMT_Encode4(2106546), // Rule ID 16801 //
     /* 2106460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2106471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2106474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2106477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2106483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106506 */     // MIs[0] round
     /* 2106506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106509 */     // MIs[0] policy
     /* 2106509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106519 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2106522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106545 */     // GIR_Coverage, 16801,
     /* 2106545 */     GIR_EraseRootFromParent_Done,
     /* 2106546 */   // Label 27917: @2106546
     /* 2106546 */   GIM_Try, /*On fail goto*//*Label 27918*/ GIMT_Encode4(2106637), // Rule ID 16804 //
     /* 2106551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2106554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2106562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2106565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2106568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2106574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106597 */     // MIs[0] round
     /* 2106597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106600 */     // MIs[0] policy
     /* 2106600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106610 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2106613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106636 */     // GIR_Coverage, 16804,
     /* 2106636 */     GIR_EraseRootFromParent_Done,
     /* 2106637 */   // Label 27918: @2106637
     /* 2106637 */   GIM_Try, /*On fail goto*//*Label 27919*/ GIMT_Encode4(2106728), // Rule ID 16805 //
     /* 2106642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2106653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2106656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2106659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2106665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106688 */     // MIs[0] round
     /* 2106688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106691 */     // MIs[0] policy
     /* 2106691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106701 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2106704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106727 */     // GIR_Coverage, 16805,
     /* 2106727 */     GIR_EraseRootFromParent_Done,
     /* 2106728 */   // Label 27919: @2106728
     /* 2106728 */   GIM_Try, /*On fail goto*//*Label 27920*/ GIMT_Encode4(2106819), // Rule ID 16808 //
     /* 2106733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2106744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2106747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2106750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106779 */     // MIs[0] round
     /* 2106779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106782 */     // MIs[0] policy
     /* 2106782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106792 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2106795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106818 */     // GIR_Coverage, 16808,
     /* 2106818 */     GIR_EraseRootFromParent_Done,
     /* 2106819 */   // Label 27920: @2106819
     /* 2106819 */   GIM_Try, /*On fail goto*//*Label 27921*/ GIMT_Encode4(2106910), // Rule ID 16809 //
     /* 2106824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2106827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2106835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2106838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2106841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106870 */     // MIs[0] round
     /* 2106870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106873 */     // MIs[0] policy
     /* 2106873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106883 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2106886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106909 */     // GIR_Coverage, 16809,
     /* 2106909 */     GIR_EraseRootFromParent_Done,
     /* 2106910 */   // Label 27921: @2106910
     /* 2106910 */   GIM_Try, /*On fail goto*//*Label 27922*/ GIMT_Encode4(2107001), // Rule ID 16812 //
     /* 2106915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2106926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2106929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2106932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106961 */     // MIs[0] round
     /* 2106961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106964 */     // MIs[0] policy
     /* 2106964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106974 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2106977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107000 */     // GIR_Coverage, 16812,
     /* 2107000 */     GIR_EraseRootFromParent_Done,
     /* 2107001 */   // Label 27922: @2107001
     /* 2107001 */   GIM_Try, /*On fail goto*//*Label 27923*/ GIMT_Encode4(2107092), // Rule ID 16813 //
     /* 2107006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2107009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2107017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2107020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2107023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107052 */     // MIs[0] round
     /* 2107052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107055 */     // MIs[0] policy
     /* 2107055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107065 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2107068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107091 */     // GIR_Coverage, 16813,
     /* 2107091 */     GIR_EraseRootFromParent_Done,
     /* 2107092 */   // Label 27923: @2107092
     /* 2107092 */   GIM_Try, /*On fail goto*//*Label 27924*/ GIMT_Encode4(2107183), // Rule ID 16816 //
     /* 2107097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2107100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2107108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2107111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2107114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2107120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107143 */     // MIs[0] round
     /* 2107143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107146 */     // MIs[0] policy
     /* 2107146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107156 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2107159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107182 */     // GIR_Coverage, 16816,
     /* 2107182 */     GIR_EraseRootFromParent_Done,
     /* 2107183 */   // Label 27924: @2107183
     /* 2107183 */   GIM_Try, /*On fail goto*//*Label 27925*/ GIMT_Encode4(2107274), // Rule ID 16817 //
     /* 2107188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2107191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2107199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2107202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2107205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2107211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107234 */     // MIs[0] round
     /* 2107234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107237 */     // MIs[0] policy
     /* 2107237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107247 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2107250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107273 */     // GIR_Coverage, 16817,
     /* 2107273 */     GIR_EraseRootFromParent_Done,
     /* 2107274 */   // Label 27925: @2107274
     /* 2107274 */   GIM_Try, /*On fail goto*//*Label 27926*/ GIMT_Encode4(2107365), // Rule ID 16820 //
     /* 2107279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2107282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2107290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2107293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2107296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107325 */     // MIs[0] round
     /* 2107325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107328 */     // MIs[0] policy
     /* 2107328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107338 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2107341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107364 */     // GIR_Coverage, 16820,
     /* 2107364 */     GIR_EraseRootFromParent_Done,
     /* 2107365 */   // Label 27926: @2107365
     /* 2107365 */   GIM_Try, /*On fail goto*//*Label 27927*/ GIMT_Encode4(2107456), // Rule ID 16821 //
     /* 2107370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2107373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2107381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2107384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2107387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107416 */     // MIs[0] round
     /* 2107416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107419 */     // MIs[0] policy
     /* 2107419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107429 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2107432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107455 */     // GIR_Coverage, 16821,
     /* 2107455 */     GIR_EraseRootFromParent_Done,
     /* 2107456 */   // Label 27927: @2107456
     /* 2107456 */   GIM_Try, /*On fail goto*//*Label 27928*/ GIMT_Encode4(2107547), // Rule ID 16824 //
     /* 2107461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2107464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2107472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2107475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2107478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107507 */     // MIs[0] round
     /* 2107507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107510 */     // MIs[0] policy
     /* 2107510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107520 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2107523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107546 */     // GIR_Coverage, 16824,
     /* 2107546 */     GIR_EraseRootFromParent_Done,
     /* 2107547 */   // Label 27928: @2107547
     /* 2107547 */   GIM_Try, /*On fail goto*//*Label 27929*/ GIMT_Encode4(2107638), // Rule ID 16825 //
     /* 2107552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2107555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2107563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2107566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2107569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107598 */     // MIs[0] round
     /* 2107598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107601 */     // MIs[0] policy
     /* 2107601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107611 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2107614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107637 */     // GIR_Coverage, 16825,
     /* 2107637 */     GIR_EraseRootFromParent_Done,
     /* 2107638 */   // Label 27929: @2107638
     /* 2107638 */   GIM_Try, /*On fail goto*//*Label 27930*/ GIMT_Encode4(2107729), // Rule ID 16828 //
     /* 2107643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2107646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2107654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2107657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2107660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107689 */     // MIs[0] round
     /* 2107689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107692 */     // MIs[0] policy
     /* 2107692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107702 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2107705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107728 */     // GIR_Coverage, 16828,
     /* 2107728 */     GIR_EraseRootFromParent_Done,
     /* 2107729 */   // Label 27930: @2107729
     /* 2107729 */   GIM_Try, /*On fail goto*//*Label 27931*/ GIMT_Encode4(2107820), // Rule ID 16829 //
     /* 2107734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2107737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2107745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2107748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2107751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107780 */     // MIs[0] round
     /* 2107780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107783 */     // MIs[0] policy
     /* 2107783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107793 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2107796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107819 */     // GIR_Coverage, 16829,
     /* 2107819 */     GIR_EraseRootFromParent_Done,
     /* 2107820 */   // Label 27931: @2107820
     /* 2107820 */   GIM_Try, /*On fail goto*//*Label 27932*/ GIMT_Encode4(2107911), // Rule ID 16832 //
     /* 2107825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2107836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2107839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2107842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2107845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107871 */     // MIs[0] round
     /* 2107871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107874 */     // MIs[0] policy
     /* 2107874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107884 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2107887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107910 */     // GIR_Coverage, 16832,
     /* 2107910 */     GIR_EraseRootFromParent_Done,
     /* 2107911 */   // Label 27932: @2107911
     /* 2107911 */   GIM_Try, /*On fail goto*//*Label 27933*/ GIMT_Encode4(2108002), // Rule ID 16833 //
     /* 2107916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2107919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2107927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2107930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2107933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2107936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107962 */     // MIs[0] round
     /* 2107962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107965 */     // MIs[0] policy
     /* 2107965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107975 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2107978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108001 */     // GIR_Coverage, 16833,
     /* 2108001 */     GIR_EraseRootFromParent_Done,
     /* 2108002 */   // Label 27933: @2108002
     /* 2108002 */   GIM_Try, /*On fail goto*//*Label 27934*/ GIMT_Encode4(2108093), // Rule ID 16836 //
     /* 2108007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2108018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2108021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2108024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2108027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108053 */     // MIs[0] round
     /* 2108053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108056 */     // MIs[0] policy
     /* 2108056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108066 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2108069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108092 */     // GIR_Coverage, 16836,
     /* 2108092 */     GIR_EraseRootFromParent_Done,
     /* 2108093 */   // Label 27934: @2108093
     /* 2108093 */   GIM_Try, /*On fail goto*//*Label 27935*/ GIMT_Encode4(2108184), // Rule ID 16837 //
     /* 2108098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2108109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2108112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2108115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2108118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108144 */     // MIs[0] round
     /* 2108144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108147 */     // MIs[0] policy
     /* 2108147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108157 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2108160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108183 */     // GIR_Coverage, 16837,
     /* 2108183 */     GIR_EraseRootFromParent_Done,
     /* 2108184 */   // Label 27935: @2108184
     /* 2108184 */   GIM_Try, /*On fail goto*//*Label 27936*/ GIMT_Encode4(2108275), // Rule ID 16840 //
     /* 2108189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2108192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2108200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2108203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2108206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2108209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108235 */     // MIs[0] round
     /* 2108235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108238 */     // MIs[0] policy
     /* 2108238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108248 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2108251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108274 */     // GIR_Coverage, 16840,
     /* 2108274 */     GIR_EraseRootFromParent_Done,
     /* 2108275 */   // Label 27936: @2108275
     /* 2108275 */   GIM_Try, /*On fail goto*//*Label 27937*/ GIMT_Encode4(2108366), // Rule ID 16841 //
     /* 2108280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2108283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2108291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2108294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2108297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2108300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108326 */     // MIs[0] round
     /* 2108326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108329 */     // MIs[0] policy
     /* 2108329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108339 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2108342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108352 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108362 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108365 */     // GIR_Coverage, 16841,
     /* 2108365 */     GIR_EraseRootFromParent_Done,
     /* 2108366 */   // Label 27937: @2108366
     /* 2108366 */   GIM_Try, /*On fail goto*//*Label 27938*/ GIMT_Encode4(2108457), // Rule ID 16844 //
     /* 2108371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2108382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2108385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2108388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2108391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108417 */     // MIs[0] round
     /* 2108417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108420 */     // MIs[0] policy
     /* 2108420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108430 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2108433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108456 */     // GIR_Coverage, 16844,
     /* 2108456 */     GIR_EraseRootFromParent_Done,
     /* 2108457 */   // Label 27938: @2108457
     /* 2108457 */   GIM_Try, /*On fail goto*//*Label 27939*/ GIMT_Encode4(2108548), // Rule ID 16845 //
     /* 2108462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2108473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2108476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2108479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2108482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108485 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108508 */     // MIs[0] round
     /* 2108508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108511 */     // MIs[0] policy
     /* 2108511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108521 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2108524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108547 */     // GIR_Coverage, 16845,
     /* 2108547 */     GIR_EraseRootFromParent_Done,
     /* 2108548 */   // Label 27939: @2108548
     /* 2108548 */   GIM_Try, /*On fail goto*//*Label 27940*/ GIMT_Encode4(2108639), // Rule ID 16848 //
     /* 2108553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2108556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2108564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2108567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2108570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2108573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108599 */     // MIs[0] round
     /* 2108599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108602 */     // MIs[0] policy
     /* 2108602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108612 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2108615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108638 */     // GIR_Coverage, 16848,
     /* 2108638 */     GIR_EraseRootFromParent_Done,
     /* 2108639 */   // Label 27940: @2108639
     /* 2108639 */   GIM_Try, /*On fail goto*//*Label 27941*/ GIMT_Encode4(2108730), // Rule ID 16849 //
     /* 2108644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2108647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2108655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2108658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2108661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2108664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108690 */     // MIs[0] round
     /* 2108690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108693 */     // MIs[0] policy
     /* 2108693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108703 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2108706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108729 */     // GIR_Coverage, 16849,
     /* 2108729 */     GIR_EraseRootFromParent_Done,
     /* 2108730 */   // Label 27941: @2108730
     /* 2108730 */   GIM_Try, /*On fail goto*//*Label 27942*/ GIMT_Encode4(2108821), // Rule ID 16852 //
     /* 2108735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2108738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2108746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2108749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2108752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2108755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108781 */     // MIs[0] round
     /* 2108781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108784 */     // MIs[0] policy
     /* 2108784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108794 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2108797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108820 */     // GIR_Coverage, 16852,
     /* 2108820 */     GIR_EraseRootFromParent_Done,
     /* 2108821 */   // Label 27942: @2108821
     /* 2108821 */   GIM_Try, /*On fail goto*//*Label 27943*/ GIMT_Encode4(2108912), // Rule ID 16853 //
     /* 2108826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2108829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2108837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2108840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2108843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2108846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108872 */     // MIs[0] round
     /* 2108872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108875 */     // MIs[0] policy
     /* 2108875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108885 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2108888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108911 */     // GIR_Coverage, 16853,
     /* 2108911 */     GIR_EraseRootFromParent_Done,
     /* 2108912 */   // Label 27943: @2108912
     /* 2108912 */   GIM_Try, /*On fail goto*//*Label 27944*/ GIMT_Encode4(2109003), // Rule ID 16856 //
     /* 2108917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2108928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2108931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2108934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2108937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2108940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2108947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108963 */     // MIs[0] round
     /* 2108963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108966 */     // MIs[0] policy
     /* 2108966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108976 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2108979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109002 */     // GIR_Coverage, 16856,
     /* 2109002 */     GIR_EraseRootFromParent_Done,
     /* 2109003 */   // Label 27944: @2109003
     /* 2109003 */   GIM_Try, /*On fail goto*//*Label 27945*/ GIMT_Encode4(2109094), // Rule ID 16857 //
     /* 2109008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2109011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2109019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2109022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2109025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2109028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109054 */     // MIs[0] round
     /* 2109054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109057 */     // MIs[0] policy
     /* 2109057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109067 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2109070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109093 */     // GIR_Coverage, 16857,
     /* 2109093 */     GIR_EraseRootFromParent_Done,
     /* 2109094 */   // Label 27945: @2109094
     /* 2109094 */   GIM_Try, /*On fail goto*//*Label 27946*/ GIMT_Encode4(2109185), // Rule ID 16860 //
     /* 2109099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2109102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2109110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2109113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2109116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2109119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109145 */     // MIs[0] round
     /* 2109145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109148 */     // MIs[0] policy
     /* 2109148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109158 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2109161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109184 */     // GIR_Coverage, 16860,
     /* 2109184 */     GIR_EraseRootFromParent_Done,
     /* 2109185 */   // Label 27946: @2109185
     /* 2109185 */   GIM_Try, /*On fail goto*//*Label 27947*/ GIMT_Encode4(2109276), // Rule ID 16861 //
     /* 2109190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2109193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2109201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2109204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2109207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2109210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109236 */     // MIs[0] round
     /* 2109236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109239 */     // MIs[0] policy
     /* 2109239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109249 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2109252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109275 */     // GIR_Coverage, 16861,
     /* 2109275 */     GIR_EraseRootFromParent_Done,
     /* 2109276 */   // Label 27947: @2109276
     /* 2109276 */   GIM_Try, /*On fail goto*//*Label 27948*/ GIMT_Encode4(2109367), // Rule ID 16864 //
     /* 2109281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2109284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2109292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2109295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2109298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2109301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2109304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109327 */     // MIs[0] round
     /* 2109327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109330 */     // MIs[0] policy
     /* 2109330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109340 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2109343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109366 */     // GIR_Coverage, 16864,
     /* 2109366 */     GIR_EraseRootFromParent_Done,
     /* 2109367 */   // Label 27948: @2109367
     /* 2109367 */   GIM_Try, /*On fail goto*//*Label 27949*/ GIMT_Encode4(2109458), // Rule ID 16865 //
     /* 2109372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2109375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2109383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2109386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2109389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2109392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2109395 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109418 */     // MIs[0] round
     /* 2109418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109421 */     // MIs[0] policy
     /* 2109421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109431 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2109434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109457 */     // GIR_Coverage, 16865,
     /* 2109457 */     GIR_EraseRootFromParent_Done,
     /* 2109458 */   // Label 27949: @2109458
     /* 2109458 */   GIM_Try, /*On fail goto*//*Label 27950*/ GIMT_Encode4(2109549), // Rule ID 16868 //
     /* 2109463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2109466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2109474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2109477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2109480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2109483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109509 */     // MIs[0] round
     /* 2109509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109512 */     // MIs[0] policy
     /* 2109512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109522 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2109525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109548 */     // GIR_Coverage, 16868,
     /* 2109548 */     GIR_EraseRootFromParent_Done,
     /* 2109549 */   // Label 27950: @2109549
     /* 2109549 */   GIM_Try, /*On fail goto*//*Label 27951*/ GIMT_Encode4(2109640), // Rule ID 16869 //
     /* 2109554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2109565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2109568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2109571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2109574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109600 */     // MIs[0] round
     /* 2109600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109603 */     // MIs[0] policy
     /* 2109603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109613 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2109616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109639 */     // GIR_Coverage, 16869,
     /* 2109639 */     GIR_EraseRootFromParent_Done,
     /* 2109640 */   // Label 27951: @2109640
     /* 2109640 */   GIM_Try, /*On fail goto*//*Label 27952*/ GIMT_Encode4(2109731), // Rule ID 16872 //
     /* 2109645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2109648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2109656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2109659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2109662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2109665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109691 */     // MIs[0] round
     /* 2109691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109694 */     // MIs[0] policy
     /* 2109694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109704 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2109707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109730 */     // GIR_Coverage, 16872,
     /* 2109730 */     GIR_EraseRootFromParent_Done,
     /* 2109731 */   // Label 27952: @2109731
     /* 2109731 */   GIM_Try, /*On fail goto*//*Label 27953*/ GIMT_Encode4(2109822), // Rule ID 16873 //
     /* 2109736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2109747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2109750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2109753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2109756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109782 */     // MIs[0] round
     /* 2109782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109785 */     // MIs[0] policy
     /* 2109785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109795 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2109798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109821 */     // GIR_Coverage, 16873,
     /* 2109821 */     GIR_EraseRootFromParent_Done,
     /* 2109822 */   // Label 27953: @2109822
     /* 2109822 */   GIM_Try, /*On fail goto*//*Label 27954*/ GIMT_Encode4(2109913), // Rule ID 16876 //
     /* 2109827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2109830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2109838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2109841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2109844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2109847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109873 */     // MIs[0] round
     /* 2109873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109876 */     // MIs[0] policy
     /* 2109876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109886 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2109889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109912 */     // GIR_Coverage, 16876,
     /* 2109912 */     GIR_EraseRootFromParent_Done,
     /* 2109913 */   // Label 27954: @2109913
     /* 2109913 */   GIM_Try, /*On fail goto*//*Label 27955*/ GIMT_Encode4(2110004), // Rule ID 16877 //
     /* 2109918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2109929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2109932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2109935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2109938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109964 */     // MIs[0] round
     /* 2109964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109967 */     // MIs[0] policy
     /* 2109967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109977 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2109980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110003 */     // GIR_Coverage, 16877,
     /* 2110003 */     GIR_EraseRootFromParent_Done,
     /* 2110004 */   // Label 27955: @2110004
     /* 2110004 */   GIM_Try, /*On fail goto*//*Label 27956*/ GIMT_Encode4(2110095), // Rule ID 16880 //
     /* 2110009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2110012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2110020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2110023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2110026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2110029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2110039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110055 */     // MIs[0] round
     /* 2110055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110058 */     // MIs[0] policy
     /* 2110058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110068 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2110071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110094 */     // GIR_Coverage, 16880,
     /* 2110094 */     GIR_EraseRootFromParent_Done,
     /* 2110095 */   // Label 27956: @2110095
     /* 2110095 */   GIM_Try, /*On fail goto*//*Label 27957*/ GIMT_Encode4(2110186), // Rule ID 16881 //
     /* 2110100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2110103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2110111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2110114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2110117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2110120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2110130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110146 */     // MIs[0] round
     /* 2110146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110149 */     // MIs[0] policy
     /* 2110149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110159 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2110162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110185 */     // GIR_Coverage, 16881,
     /* 2110185 */     GIR_EraseRootFromParent_Done,
     /* 2110186 */   // Label 27957: @2110186
     /* 2110186 */   GIM_Try, /*On fail goto*//*Label 27958*/ GIMT_Encode4(2110277), // Rule ID 16884 //
     /* 2110191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2110194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2110202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2110205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2110208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2110211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110237 */     // MIs[0] round
     /* 2110237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110240 */     // MIs[0] policy
     /* 2110240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110250 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2110253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110276 */     // GIR_Coverage, 16884,
     /* 2110276 */     GIR_EraseRootFromParent_Done,
     /* 2110277 */   // Label 27958: @2110277
     /* 2110277 */   GIM_Try, /*On fail goto*//*Label 27959*/ GIMT_Encode4(2110368), // Rule ID 16885 //
     /* 2110282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2110285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2110293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2110296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2110299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2110302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110328 */     // MIs[0] round
     /* 2110328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110331 */     // MIs[0] policy
     /* 2110331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110341 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2110344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110367 */     // GIR_Coverage, 16885,
     /* 2110367 */     GIR_EraseRootFromParent_Done,
     /* 2110368 */   // Label 27959: @2110368
     /* 2110368 */   GIM_Try, /*On fail goto*//*Label 27960*/ GIMT_Encode4(2110459), // Rule ID 16888 //
     /* 2110373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2110376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2110384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2110387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2110390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2110393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110419 */     // MIs[0] round
     /* 2110419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110422 */     // MIs[0] policy
     /* 2110422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110432 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2110435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110458 */     // GIR_Coverage, 16888,
     /* 2110458 */     GIR_EraseRootFromParent_Done,
     /* 2110459 */   // Label 27960: @2110459
     /* 2110459 */   GIM_Try, /*On fail goto*//*Label 27961*/ GIMT_Encode4(2110550), // Rule ID 16889 //
     /* 2110464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2110467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2110475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2110478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2110481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2110484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110510 */     // MIs[0] round
     /* 2110510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110513 */     // MIs[0] policy
     /* 2110513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110523 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2110526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110549 */     // GIR_Coverage, 16889,
     /* 2110549 */     GIR_EraseRootFromParent_Done,
     /* 2110550 */   // Label 27961: @2110550
     /* 2110550 */   GIM_Try, /*On fail goto*//*Label 27962*/ GIMT_Encode4(2110641), // Rule ID 16892 //
     /* 2110555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2110558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2110566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2110569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2110572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110601 */     // MIs[0] round
     /* 2110601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110604 */     // MIs[0] policy
     /* 2110604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110614 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2110617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110640 */     // GIR_Coverage, 16892,
     /* 2110640 */     GIR_EraseRootFromParent_Done,
     /* 2110641 */   // Label 27962: @2110641
     /* 2110641 */   GIM_Try, /*On fail goto*//*Label 27963*/ GIMT_Encode4(2110732), // Rule ID 16893 //
     /* 2110646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2110649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2110657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2110660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2110663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110692 */     // MIs[0] round
     /* 2110692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110695 */     // MIs[0] policy
     /* 2110695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110705 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2110708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110731 */     // GIR_Coverage, 16893,
     /* 2110731 */     GIR_EraseRootFromParent_Done,
     /* 2110732 */   // Label 27963: @2110732
     /* 2110732 */   GIM_Try, /*On fail goto*//*Label 27964*/ GIMT_Encode4(2110823), // Rule ID 16896 //
     /* 2110737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2110740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2110748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2110751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2110754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110783 */     // MIs[0] round
     /* 2110783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110786 */     // MIs[0] policy
     /* 2110786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110796 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2110799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110822 */     // GIR_Coverage, 16896,
     /* 2110822 */     GIR_EraseRootFromParent_Done,
     /* 2110823 */   // Label 27964: @2110823
     /* 2110823 */   GIM_Try, /*On fail goto*//*Label 27965*/ GIMT_Encode4(2110914), // Rule ID 16897 //
     /* 2110828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2110831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2110839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2110842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2110845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110874 */     // MIs[0] round
     /* 2110874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110877 */     // MIs[0] policy
     /* 2110877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110887 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2110890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110913 */     // GIR_Coverage, 16897,
     /* 2110913 */     GIR_EraseRootFromParent_Done,
     /* 2110914 */   // Label 27965: @2110914
     /* 2110914 */   GIM_Try, /*On fail goto*//*Label 27966*/ GIMT_Encode4(2111005), // Rule ID 16900 //
     /* 2110919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2110922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2110930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2110933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2110936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110965 */     // MIs[0] round
     /* 2110965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110968 */     // MIs[0] policy
     /* 2110968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110978 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2110981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111004 */     // GIR_Coverage, 16900,
     /* 2111004 */     GIR_EraseRootFromParent_Done,
     /* 2111005 */   // Label 27966: @2111005
     /* 2111005 */   GIM_Try, /*On fail goto*//*Label 27967*/ GIMT_Encode4(2111096), // Rule ID 16901 //
     /* 2111010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2111013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2111021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2111024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2111027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111056 */     // MIs[0] round
     /* 2111056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111059 */     // MIs[0] policy
     /* 2111059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111069 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2111072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111095 */     // GIR_Coverage, 16901,
     /* 2111095 */     GIR_EraseRootFromParent_Done,
     /* 2111096 */   // Label 27967: @2111096
     /* 2111096 */   GIM_Try, /*On fail goto*//*Label 27968*/ GIMT_Encode4(2111187), // Rule ID 16904 //
     /* 2111101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2111112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2111115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2111118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111147 */     // MIs[0] round
     /* 2111147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111150 */     // MIs[0] policy
     /* 2111150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111160 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2111163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111186 */     // GIR_Coverage, 16904,
     /* 2111186 */     GIR_EraseRootFromParent_Done,
     /* 2111187 */   // Label 27968: @2111187
     /* 2111187 */   GIM_Try, /*On fail goto*//*Label 27969*/ GIMT_Encode4(2111278), // Rule ID 16905 //
     /* 2111192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2111203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2111206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2111209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111238 */     // MIs[0] round
     /* 2111238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111241 */     // MIs[0] policy
     /* 2111241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111251 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2111254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111277 */     // GIR_Coverage, 16905,
     /* 2111277 */     GIR_EraseRootFromParent_Done,
     /* 2111278 */   // Label 27969: @2111278
     /* 2111278 */   GIM_Try, /*On fail goto*//*Label 27970*/ GIMT_Encode4(2111369), // Rule ID 16908 //
     /* 2111283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2111286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2111294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2111297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2111300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2111306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111329 */     // MIs[0] round
     /* 2111329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111332 */     // MIs[0] policy
     /* 2111332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111342 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2111345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111368 */     // GIR_Coverage, 16908,
     /* 2111368 */     GIR_EraseRootFromParent_Done,
     /* 2111369 */   // Label 27970: @2111369
     /* 2111369 */   GIM_Try, /*On fail goto*//*Label 27971*/ GIMT_Encode4(2111460), // Rule ID 16909 //
     /* 2111374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2111377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2111385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2111388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2111391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2111397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111420 */     // MIs[0] round
     /* 2111420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111423 */     // MIs[0] policy
     /* 2111423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111433 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2111436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111459 */     // GIR_Coverage, 16909,
     /* 2111459 */     GIR_EraseRootFromParent_Done,
     /* 2111460 */   // Label 27971: @2111460
     /* 2111460 */   GIM_Try, /*On fail goto*//*Label 27972*/ GIMT_Encode4(2111551), // Rule ID 16912 //
     /* 2111465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2111468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2111476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2111479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2111482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2111485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2111507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111511 */     // MIs[0] round
     /* 2111511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111514 */     // MIs[0] policy
     /* 2111514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111524 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2111527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2111547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111550 */     // GIR_Coverage, 16912,
     /* 2111550 */     GIR_EraseRootFromParent_Done,
     /* 2111551 */   // Label 27972: @2111551
     /* 2111551 */   GIM_Try, /*On fail goto*//*Label 27973*/ GIMT_Encode4(2111642), // Rule ID 16913 //
     /* 2111556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2111559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2111567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2111570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2111573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2111576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2111598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111602 */     // MIs[0] round
     /* 2111602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111605 */     // MIs[0] policy
     /* 2111605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111615 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2111618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2111638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111641 */     // GIR_Coverage, 16913,
     /* 2111641 */     GIR_EraseRootFromParent_Done,
     /* 2111642 */   // Label 27973: @2111642
     /* 2111642 */   GIM_Try, /*On fail goto*//*Label 27974*/ GIMT_Encode4(2111733), // Rule ID 16916 //
     /* 2111647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2111658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2111661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2111664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111693 */     // MIs[0] round
     /* 2111693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111696 */     // MIs[0] policy
     /* 2111696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111706 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2111709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111732 */     // GIR_Coverage, 16916,
     /* 2111732 */     GIR_EraseRootFromParent_Done,
     /* 2111733 */   // Label 27974: @2111733
     /* 2111733 */   GIM_Try, /*On fail goto*//*Label 27975*/ GIMT_Encode4(2111824), // Rule ID 16917 //
     /* 2111738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2111749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2111752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2111755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111784 */     // MIs[0] round
     /* 2111784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111787 */     // MIs[0] policy
     /* 2111787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111797 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2111800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111823 */     // GIR_Coverage, 16917,
     /* 2111823 */     GIR_EraseRootFromParent_Done,
     /* 2111824 */   // Label 27975: @2111824
     /* 2111824 */   GIM_Try, /*On fail goto*//*Label 27976*/ GIMT_Encode4(2111915), // Rule ID 16920 //
     /* 2111829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2111840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2111843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2111846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2111852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111875 */     // MIs[0] round
     /* 2111875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111878 */     // MIs[0] policy
     /* 2111878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111888 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2111891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111914 */     // GIR_Coverage, 16920,
     /* 2111914 */     GIR_EraseRootFromParent_Done,
     /* 2111915 */   // Label 27976: @2111915
     /* 2111915 */   GIM_Try, /*On fail goto*//*Label 27977*/ GIMT_Encode4(2112006), // Rule ID 16921 //
     /* 2111920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2111931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2111934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2111937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2111943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111966 */     // MIs[0] round
     /* 2111966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111969 */     // MIs[0] policy
     /* 2111969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111979 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2111982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112005 */     // GIR_Coverage, 16921,
     /* 2112005 */     GIR_EraseRootFromParent_Done,
     /* 2112006 */   // Label 27977: @2112006
     /* 2112006 */   GIM_Try, /*On fail goto*//*Label 27978*/ GIMT_Encode4(2112097), // Rule ID 16924 //
     /* 2112011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2112014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2112022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2112025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2112028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2112034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112057 */     // MIs[0] round
     /* 2112057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112060 */     // MIs[0] policy
     /* 2112060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112070 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2112073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112096 */     // GIR_Coverage, 16924,
     /* 2112096 */     GIR_EraseRootFromParent_Done,
     /* 2112097 */   // Label 27978: @2112097
     /* 2112097 */   GIM_Try, /*On fail goto*//*Label 27979*/ GIMT_Encode4(2112188), // Rule ID 16925 //
     /* 2112102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2112105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2112113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2112116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2112119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2112125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112148 */     // MIs[0] round
     /* 2112148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112151 */     // MIs[0] policy
     /* 2112151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112161 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2112164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112187 */     // GIR_Coverage, 16925,
     /* 2112187 */     GIR_EraseRootFromParent_Done,
     /* 2112188 */   // Label 27979: @2112188
     /* 2112188 */   GIM_Try, /*On fail goto*//*Label 27980*/ GIMT_Encode4(2112279), // Rule ID 16928 //
     /* 2112193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2112196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2112204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2112207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2112210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112239 */     // MIs[0] round
     /* 2112239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112242 */     // MIs[0] policy
     /* 2112242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2112255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112278 */     // GIR_Coverage, 16928,
     /* 2112278 */     GIR_EraseRootFromParent_Done,
     /* 2112279 */   // Label 27980: @2112279
     /* 2112279 */   GIM_Try, /*On fail goto*//*Label 27981*/ GIMT_Encode4(2112370), // Rule ID 16929 //
     /* 2112284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2112287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2112295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2112298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2112301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112330 */     // MIs[0] round
     /* 2112330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112333 */     // MIs[0] policy
     /* 2112333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112343 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2112346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112369 */     // GIR_Coverage, 16929,
     /* 2112369 */     GIR_EraseRootFromParent_Done,
     /* 2112370 */   // Label 27981: @2112370
     /* 2112370 */   GIM_Try, /*On fail goto*//*Label 27982*/ GIMT_Encode4(2112461), // Rule ID 16932 //
     /* 2112375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2112378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2112386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2112389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2112392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112421 */     // MIs[0] round
     /* 2112421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112424 */     // MIs[0] policy
     /* 2112424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112434 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2112437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112460 */     // GIR_Coverage, 16932,
     /* 2112460 */     GIR_EraseRootFromParent_Done,
     /* 2112461 */   // Label 27982: @2112461
     /* 2112461 */   GIM_Try, /*On fail goto*//*Label 27983*/ GIMT_Encode4(2112552), // Rule ID 16933 //
     /* 2112466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2112469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2112477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2112480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2112483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112512 */     // MIs[0] round
     /* 2112512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112515 */     // MIs[0] policy
     /* 2112515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112525 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2112528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112551 */     // GIR_Coverage, 16933,
     /* 2112551 */     GIR_EraseRootFromParent_Done,
     /* 2112552 */   // Label 27983: @2112552
     /* 2112552 */   GIM_Try, /*On fail goto*//*Label 27984*/ GIMT_Encode4(2112643), // Rule ID 16936 //
     /* 2112557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2112560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2112568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2112571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2112574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2112580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112603 */     // MIs[0] round
     /* 2112603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112606 */     // MIs[0] policy
     /* 2112606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112616 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2112619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112642 */     // GIR_Coverage, 16936,
     /* 2112642 */     GIR_EraseRootFromParent_Done,
     /* 2112643 */   // Label 27984: @2112643
     /* 2112643 */   GIM_Try, /*On fail goto*//*Label 27985*/ GIMT_Encode4(2112734), // Rule ID 16937 //
     /* 2112648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2112651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2112659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2112662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2112665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2112671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112694 */     // MIs[0] round
     /* 2112694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112697 */     // MIs[0] policy
     /* 2112697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112707 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2112710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112733 */     // GIR_Coverage, 16937,
     /* 2112733 */     GIR_EraseRootFromParent_Done,
     /* 2112734 */   // Label 27985: @2112734
     /* 2112734 */   GIM_Try, /*On fail goto*//*Label 27986*/ GIMT_Encode4(2112825), // Rule ID 16940 //
     /* 2112739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2112742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2112750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2112753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2112756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112785 */     // MIs[0] round
     /* 2112785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112788 */     // MIs[0] policy
     /* 2112788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112798 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2112801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112824 */     // GIR_Coverage, 16940,
     /* 2112824 */     GIR_EraseRootFromParent_Done,
     /* 2112825 */   // Label 27986: @2112825
     /* 2112825 */   GIM_Try, /*On fail goto*//*Label 27987*/ GIMT_Encode4(2112916), // Rule ID 16941 //
     /* 2112830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2112833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2112841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2112844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2112847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112876 */     // MIs[0] round
     /* 2112876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112879 */     // MIs[0] policy
     /* 2112879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112889 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2112892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112915 */     // GIR_Coverage, 16941,
     /* 2112915 */     GIR_EraseRootFromParent_Done,
     /* 2112916 */   // Label 27987: @2112916
     /* 2112916 */   GIM_Try, /*On fail goto*//*Label 27988*/ GIMT_Encode4(2113007), // Rule ID 16944 //
     /* 2112921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2112924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2112932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2112935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2112938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112967 */     // MIs[0] round
     /* 2112967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112970 */     // MIs[0] policy
     /* 2112970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112980 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2112983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113006 */     // GIR_Coverage, 16944,
     /* 2113006 */     GIR_EraseRootFromParent_Done,
     /* 2113007 */   // Label 27988: @2113007
     /* 2113007 */   GIM_Try, /*On fail goto*//*Label 27989*/ GIMT_Encode4(2113098), // Rule ID 16945 //
     /* 2113012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2113015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2113023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2113026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2113029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2113032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113035 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2113042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2113054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113058 */     // MIs[0] round
     /* 2113058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113061 */     // MIs[0] policy
     /* 2113061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113071 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2113074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113097 */     // GIR_Coverage, 16945,
     /* 2113097 */     GIR_EraseRootFromParent_Done,
     /* 2113098 */   // Label 27989: @2113098
     /* 2113098 */   GIM_Try, /*On fail goto*//*Label 27990*/ GIMT_Encode4(2113189), // Rule ID 16948 //
     /* 2113103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2113106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2113114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2113117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2113120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2113123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2113145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113149 */     // MIs[0] round
     /* 2113149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113152 */     // MIs[0] policy
     /* 2113152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113162 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2113165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113188 */     // GIR_Coverage, 16948,
     /* 2113188 */     GIR_EraseRootFromParent_Done,
     /* 2113189 */   // Label 27990: @2113189
     /* 2113189 */   GIM_Try, /*On fail goto*//*Label 27991*/ GIMT_Encode4(2113280), // Rule ID 16949 //
     /* 2113194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2113197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2113205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2113208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2113211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2113214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113217 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2113236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113240 */     // MIs[0] round
     /* 2113240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113243 */     // MIs[0] policy
     /* 2113243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113253 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2113256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113279 */     // GIR_Coverage, 16949,
     /* 2113279 */     GIR_EraseRootFromParent_Done,
     /* 2113280 */   // Label 27991: @2113280
     /* 2113280 */   GIM_Try, /*On fail goto*//*Label 27992*/ GIMT_Encode4(2113371), // Rule ID 16952 //
     /* 2113285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2113288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2113296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2113299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2113302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113331 */     // MIs[0] round
     /* 2113331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113334 */     // MIs[0] policy
     /* 2113334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113344 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2113347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113370 */     // GIR_Coverage, 16952,
     /* 2113370 */     GIR_EraseRootFromParent_Done,
     /* 2113371 */   // Label 27992: @2113371
     /* 2113371 */   GIM_Try, /*On fail goto*//*Label 27993*/ GIMT_Encode4(2113462), // Rule ID 16953 //
     /* 2113376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2113379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2113387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2113390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2113393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113422 */     // MIs[0] round
     /* 2113422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113425 */     // MIs[0] policy
     /* 2113425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113435 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2113438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113461 */     // GIR_Coverage, 16953,
     /* 2113461 */     GIR_EraseRootFromParent_Done,
     /* 2113462 */   // Label 27993: @2113462
     /* 2113462 */   GIM_Try, /*On fail goto*//*Label 27994*/ GIMT_Encode4(2113553), // Rule ID 16956 //
     /* 2113467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2113470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2113478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2113481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2113484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113513 */     // MIs[0] round
     /* 2113513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113516 */     // MIs[0] policy
     /* 2113516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113526 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2113529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113552 */     // GIR_Coverage, 16956,
     /* 2113552 */     GIR_EraseRootFromParent_Done,
     /* 2113553 */   // Label 27994: @2113553
     /* 2113553 */   GIM_Try, /*On fail goto*//*Label 27995*/ GIMT_Encode4(2113644), // Rule ID 16957 //
     /* 2113558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2113561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2113569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2113572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2113575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113604 */     // MIs[0] round
     /* 2113604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113607 */     // MIs[0] policy
     /* 2113607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113617 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2113620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113643 */     // GIR_Coverage, 16957,
     /* 2113643 */     GIR_EraseRootFromParent_Done,
     /* 2113644 */   // Label 27995: @2113644
     /* 2113644 */   GIM_Try, /*On fail goto*//*Label 27996*/ GIMT_Encode4(2113735), // Rule ID 16960 //
     /* 2113649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2113652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2113660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2113663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2113666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113695 */     // MIs[0] round
     /* 2113695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113698 */     // MIs[0] policy
     /* 2113698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113708 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2113711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113734 */     // GIR_Coverage, 16960,
     /* 2113734 */     GIR_EraseRootFromParent_Done,
     /* 2113735 */   // Label 27996: @2113735
     /* 2113735 */   GIM_Try, /*On fail goto*//*Label 27997*/ GIMT_Encode4(2113826), // Rule ID 16961 //
     /* 2113740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2113743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2113751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2113754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2113757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113786 */     // MIs[0] round
     /* 2113786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113789 */     // MIs[0] policy
     /* 2113789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113799 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2113802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113825 */     // GIR_Coverage, 16961,
     /* 2113825 */     GIR_EraseRootFromParent_Done,
     /* 2113826 */   // Label 27997: @2113826
     /* 2113826 */   GIM_Try, /*On fail goto*//*Label 27998*/ GIMT_Encode4(2113917), // Rule ID 16964 //
     /* 2113831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2113834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2113842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2113845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2113848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113877 */     // MIs[0] round
     /* 2113877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113880 */     // MIs[0] policy
     /* 2113880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113890 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11319:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2113893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113916 */     // GIR_Coverage, 16964,
     /* 2113916 */     GIR_EraseRootFromParent_Done,
     /* 2113917 */   // Label 27998: @2113917
     /* 2113917 */   GIM_Try, /*On fail goto*//*Label 27999*/ GIMT_Encode4(2114008), // Rule ID 16965 //
     /* 2113922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2113925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2113933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2113936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2113939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113968 */     // MIs[0] round
     /* 2113968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113971 */     // MIs[0] policy
     /* 2113971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113981 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11319:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2113984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114007 */     // GIR_Coverage, 16965,
     /* 2114007 */     GIR_EraseRootFromParent_Done,
     /* 2114008 */   // Label 27999: @2114008
     /* 2114008 */   GIM_Try, /*On fail goto*//*Label 28000*/ GIMT_Encode4(2114099), // Rule ID 16968 //
     /* 2114013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2114016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2114024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2114027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2114030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2114036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114059 */     // MIs[0] round
     /* 2114059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114062 */     // MIs[0] policy
     /* 2114062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114072 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2114075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114098 */     // GIR_Coverage, 16968,
     /* 2114098 */     GIR_EraseRootFromParent_Done,
     /* 2114099 */   // Label 28000: @2114099
     /* 2114099 */   GIM_Try, /*On fail goto*//*Label 28001*/ GIMT_Encode4(2114190), // Rule ID 16969 //
     /* 2114104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2114107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2114115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2114118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2114121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2114127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114150 */     // MIs[0] round
     /* 2114150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114153 */     // MIs[0] policy
     /* 2114153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114163 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2114166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114189 */     // GIR_Coverage, 16969,
     /* 2114189 */     GIR_EraseRootFromParent_Done,
     /* 2114190 */   // Label 28001: @2114190
     /* 2114190 */   GIM_Try, /*On fail goto*//*Label 28002*/ GIMT_Encode4(2114281), // Rule ID 16972 //
     /* 2114195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2114198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2114206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2114209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2114212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2114215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2114237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114241 */     // MIs[0] round
     /* 2114241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114244 */     // MIs[0] policy
     /* 2114244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114254 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2114257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2114277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114280 */     // GIR_Coverage, 16972,
     /* 2114280 */     GIR_EraseRootFromParent_Done,
     /* 2114281 */   // Label 28002: @2114281
     /* 2114281 */   GIM_Try, /*On fail goto*//*Label 28003*/ GIMT_Encode4(2114372), // Rule ID 16973 //
     /* 2114286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2114289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2114297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2114300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2114303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2114306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2114328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114332 */     // MIs[0] round
     /* 2114332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114335 */     // MIs[0] policy
     /* 2114335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114345 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2114348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2114368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114371 */     // GIR_Coverage, 16973,
     /* 2114371 */     GIR_EraseRootFromParent_Done,
     /* 2114372 */   // Label 28003: @2114372
     /* 2114372 */   GIM_Try, /*On fail goto*//*Label 28004*/ GIMT_Encode4(2114463), // Rule ID 16976 //
     /* 2114377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2114380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2114388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2114391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2114394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114423 */     // MIs[0] round
     /* 2114423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114426 */     // MIs[0] policy
     /* 2114426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114436 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2114439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114462 */     // GIR_Coverage, 16976,
     /* 2114462 */     GIR_EraseRootFromParent_Done,
     /* 2114463 */   // Label 28004: @2114463
     /* 2114463 */   GIM_Try, /*On fail goto*//*Label 28005*/ GIMT_Encode4(2114554), // Rule ID 16977 //
     /* 2114468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2114479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2114482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2114485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114514 */     // MIs[0] round
     /* 2114514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114517 */     // MIs[0] policy
     /* 2114517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114527 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2114530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114553 */     // GIR_Coverage, 16977,
     /* 2114553 */     GIR_EraseRootFromParent_Done,
     /* 2114554 */   // Label 28005: @2114554
     /* 2114554 */   GIM_Try, /*On fail goto*//*Label 28006*/ GIMT_Encode4(2114645), // Rule ID 16980 //
     /* 2114559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2114562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2114570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2114573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2114576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114605 */     // MIs[0] round
     /* 2114605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114608 */     // MIs[0] policy
     /* 2114608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114618 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2114621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114644 */     // GIR_Coverage, 16980,
     /* 2114644 */     GIR_EraseRootFromParent_Done,
     /* 2114645 */   // Label 28006: @2114645
     /* 2114645 */   GIM_Try, /*On fail goto*//*Label 28007*/ GIMT_Encode4(2114736), // Rule ID 16981 //
     /* 2114650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2114661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2114664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2114667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114696 */     // MIs[0] round
     /* 2114696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114699 */     // MIs[0] policy
     /* 2114699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114709 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2114712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114735 */     // GIR_Coverage, 16981,
     /* 2114735 */     GIR_EraseRootFromParent_Done,
     /* 2114736 */   // Label 28007: @2114736
     /* 2114736 */   GIM_Try, /*On fail goto*//*Label 28008*/ GIMT_Encode4(2114827), // Rule ID 16984 //
     /* 2114741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2114744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2114752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2114755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2114758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2114764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114787 */     // MIs[0] round
     /* 2114787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114790 */     // MIs[0] policy
     /* 2114790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114800 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2114803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114826 */     // GIR_Coverage, 16984,
     /* 2114826 */     GIR_EraseRootFromParent_Done,
     /* 2114827 */   // Label 28008: @2114827
     /* 2114827 */   GIM_Try, /*On fail goto*//*Label 28009*/ GIMT_Encode4(2114918), // Rule ID 16985 //
     /* 2114832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2114843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2114846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2114849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2114855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114878 */     // MIs[0] round
     /* 2114878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114881 */     // MIs[0] policy
     /* 2114881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114891 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2114894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114917 */     // GIR_Coverage, 16985,
     /* 2114917 */     GIR_EraseRootFromParent_Done,
     /* 2114918 */   // Label 28009: @2114918
     /* 2114918 */   GIM_Try, /*On fail goto*//*Label 28010*/ GIMT_Encode4(2115009), // Rule ID 16988 //
     /* 2114923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2114926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2114934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2114937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2114940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114969 */     // MIs[0] round
     /* 2114969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114972 */     // MIs[0] policy
     /* 2114972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114982 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2114985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115008 */     // GIR_Coverage, 16988,
     /* 2115008 */     GIR_EraseRootFromParent_Done,
     /* 2115009 */   // Label 28010: @2115009
     /* 2115009 */   GIM_Try, /*On fail goto*//*Label 28011*/ GIMT_Encode4(2115100), // Rule ID 16989 //
     /* 2115014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2115017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2115025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2115028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2115031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115060 */     // MIs[0] round
     /* 2115060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115063 */     // MIs[0] policy
     /* 2115063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115073 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2115076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115099 */     // GIR_Coverage, 16989,
     /* 2115099 */     GIR_EraseRootFromParent_Done,
     /* 2115100 */   // Label 28011: @2115100
     /* 2115100 */   GIM_Try, /*On fail goto*//*Label 28012*/ GIMT_Encode4(2115191), // Rule ID 16992 //
     /* 2115105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2115108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2115116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2115119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2115122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115151 */     // MIs[0] round
     /* 2115151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115154 */     // MIs[0] policy
     /* 2115154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115164 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2115167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115190 */     // GIR_Coverage, 16992,
     /* 2115190 */     GIR_EraseRootFromParent_Done,
     /* 2115191 */   // Label 28012: @2115191
     /* 2115191 */   GIM_Try, /*On fail goto*//*Label 28013*/ GIMT_Encode4(2115282), // Rule ID 16993 //
     /* 2115196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2115199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2115207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2115210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2115213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115242 */     // MIs[0] round
     /* 2115242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115245 */     // MIs[0] policy
     /* 2115245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115255 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2115258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115281 */     // GIR_Coverage, 16993,
     /* 2115281 */     GIR_EraseRootFromParent_Done,
     /* 2115282 */   // Label 28013: @2115282
     /* 2115282 */   GIM_Try, /*On fail goto*//*Label 28014*/ GIMT_Encode4(2115373), // Rule ID 16996 //
     /* 2115287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2115290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2115298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2115301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2115304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2115310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115333 */     // MIs[0] round
     /* 2115333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115336 */     // MIs[0] policy
     /* 2115336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115346 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2115349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115372 */     // GIR_Coverage, 16996,
     /* 2115372 */     GIR_EraseRootFromParent_Done,
     /* 2115373 */   // Label 28014: @2115373
     /* 2115373 */   GIM_Try, /*On fail goto*//*Label 28015*/ GIMT_Encode4(2115464), // Rule ID 16997 //
     /* 2115378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2115381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2115389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2115392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2115395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2115401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115424 */     // MIs[0] round
     /* 2115424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115427 */     // MIs[0] policy
     /* 2115427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115437 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2115440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115463 */     // GIR_Coverage, 16997,
     /* 2115463 */     GIR_EraseRootFromParent_Done,
     /* 2115464 */   // Label 28015: @2115464
     /* 2115464 */   GIM_Try, /*On fail goto*//*Label 28016*/ GIMT_Encode4(2115555), // Rule ID 17000 //
     /* 2115469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2115472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2115480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2115483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2115486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115515 */     // MIs[0] round
     /* 2115515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115518 */     // MIs[0] policy
     /* 2115518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115528 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2115531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115554 */     // GIR_Coverage, 17000,
     /* 2115554 */     GIR_EraseRootFromParent_Done,
     /* 2115555 */   // Label 28016: @2115555
     /* 2115555 */   GIM_Try, /*On fail goto*//*Label 28017*/ GIMT_Encode4(2115646), // Rule ID 17001 //
     /* 2115560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2115563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2115571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2115574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2115577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115606 */     // MIs[0] round
     /* 2115606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115609 */     // MIs[0] policy
     /* 2115609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115619 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2115622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115645 */     // GIR_Coverage, 17001,
     /* 2115645 */     GIR_EraseRootFromParent_Done,
     /* 2115646 */   // Label 28017: @2115646
     /* 2115646 */   GIM_Try, /*On fail goto*//*Label 28018*/ GIMT_Encode4(2115737), // Rule ID 17004 //
     /* 2115651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2115654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2115662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2115665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2115668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115697 */     // MIs[0] round
     /* 2115697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115700 */     // MIs[0] policy
     /* 2115700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115710 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2115713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115736 */     // GIR_Coverage, 17004,
     /* 2115736 */     GIR_EraseRootFromParent_Done,
     /* 2115737 */   // Label 28018: @2115737
     /* 2115737 */   GIM_Try, /*On fail goto*//*Label 28019*/ GIMT_Encode4(2115828), // Rule ID 17005 //
     /* 2115742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2115745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2115753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2115756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2115759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115788 */     // MIs[0] round
     /* 2115788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115791 */     // MIs[0] policy
     /* 2115791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115801 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2115804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115827 */     // GIR_Coverage, 17005,
     /* 2115827 */     GIR_EraseRootFromParent_Done,
     /* 2115828 */   // Label 28019: @2115828
     /* 2115828 */   GIM_Try, /*On fail goto*//*Label 28020*/ GIMT_Encode4(2115919), // Rule ID 17008 //
     /* 2115833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2115836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2115844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2115847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2115850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115879 */     // MIs[0] round
     /* 2115879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115882 */     // MIs[0] policy
     /* 2115882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115892 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2115895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115918 */     // GIR_Coverage, 17008,
     /* 2115918 */     GIR_EraseRootFromParent_Done,
     /* 2115919 */   // Label 28020: @2115919
     /* 2115919 */   GIM_Try, /*On fail goto*//*Label 28021*/ GIMT_Encode4(2116010), // Rule ID 17009 //
     /* 2115924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2115927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2115935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2115938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2115941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115970 */     // MIs[0] round
     /* 2115970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115973 */     // MIs[0] policy
     /* 2115973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115983 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2115986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2116006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116009 */     // GIR_Coverage, 17009,
     /* 2116009 */     GIR_EraseRootFromParent_Done,
     /* 2116010 */   // Label 28021: @2116010
     /* 2116010 */   GIM_Try, /*On fail goto*//*Label 28022*/ GIMT_Encode4(2116101), // Rule ID 17012 //
     /* 2116015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2116026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2116029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2116032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2116035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116061 */     // MIs[0] round
     /* 2116061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116064 */     // MIs[0] policy
     /* 2116064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116074 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2116077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116100 */     // GIR_Coverage, 17012,
     /* 2116100 */     GIR_EraseRootFromParent_Done,
     /* 2116101 */   // Label 28022: @2116101
     /* 2116101 */   GIM_Try, /*On fail goto*//*Label 28023*/ GIMT_Encode4(2116192), // Rule ID 17013 //
     /* 2116106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2116117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2116120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2116123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2116126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116152 */     // MIs[0] round
     /* 2116152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116155 */     // MIs[0] policy
     /* 2116155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116165 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2116168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116191 */     // GIR_Coverage, 17013,
     /* 2116191 */     GIR_EraseRootFromParent_Done,
     /* 2116192 */   // Label 28023: @2116192
     /* 2116192 */   GIM_Try, /*On fail goto*//*Label 28024*/ GIMT_Encode4(2116283), // Rule ID 17016 //
     /* 2116197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2116208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2116211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2116214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2116217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116243 */     // MIs[0] round
     /* 2116243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116246 */     // MIs[0] policy
     /* 2116246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116256 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2116259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116282 */     // GIR_Coverage, 17016,
     /* 2116282 */     GIR_EraseRootFromParent_Done,
     /* 2116283 */   // Label 28024: @2116283
     /* 2116283 */   GIM_Try, /*On fail goto*//*Label 28025*/ GIMT_Encode4(2116374), // Rule ID 17017 //
     /* 2116288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2116299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2116302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2116305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2116308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116334 */     // MIs[0] round
     /* 2116334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116337 */     // MIs[0] policy
     /* 2116337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116347 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2116350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116373 */     // GIR_Coverage, 17017,
     /* 2116373 */     GIR_EraseRootFromParent_Done,
     /* 2116374 */   // Label 28025: @2116374
     /* 2116374 */   GIM_Try, /*On fail goto*//*Label 28026*/ GIMT_Encode4(2116465), // Rule ID 17020 //
     /* 2116379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2116390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2116393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2116396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2116399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116425 */     // MIs[0] round
     /* 2116425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116428 */     // MIs[0] policy
     /* 2116428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116438 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2116441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116464 */     // GIR_Coverage, 17020,
     /* 2116464 */     GIR_EraseRootFromParent_Done,
     /* 2116465 */   // Label 28026: @2116465
     /* 2116465 */   GIM_Try, /*On fail goto*//*Label 28027*/ GIMT_Encode4(2116556), // Rule ID 17021 //
     /* 2116470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2116481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2116484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2116487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2116490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116516 */     // MIs[0] round
     /* 2116516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116519 */     // MIs[0] policy
     /* 2116519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116529 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2116532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116555 */     // GIR_Coverage, 17021,
     /* 2116555 */     GIR_EraseRootFromParent_Done,
     /* 2116556 */   // Label 28027: @2116556
     /* 2116556 */   GIM_Try, /*On fail goto*//*Label 28028*/ GIMT_Encode4(2116647), // Rule ID 17024 //
     /* 2116561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2116572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2116575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2116578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2116581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116607 */     // MIs[0] round
     /* 2116607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116610 */     // MIs[0] policy
     /* 2116610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116620 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2116623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116646 */     // GIR_Coverage, 17024,
     /* 2116646 */     GIR_EraseRootFromParent_Done,
     /* 2116647 */   // Label 28028: @2116647
     /* 2116647 */   GIM_Try, /*On fail goto*//*Label 28029*/ GIMT_Encode4(2116738), // Rule ID 17025 //
     /* 2116652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2116663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2116666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2116669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2116672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116698 */     // MIs[0] round
     /* 2116698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116701 */     // MIs[0] policy
     /* 2116701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116711 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2116714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116737 */     // GIR_Coverage, 17025,
     /* 2116737 */     GIR_EraseRootFromParent_Done,
     /* 2116738 */   // Label 28029: @2116738
     /* 2116738 */   GIM_Try, /*On fail goto*//*Label 28030*/ GIMT_Encode4(2116829), // Rule ID 17028 //
     /* 2116743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2116754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2116757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2116760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2116763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2116766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116789 */     // MIs[0] round
     /* 2116789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116792 */     // MIs[0] policy
     /* 2116792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116802 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2116805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116828 */     // GIR_Coverage, 17028,
     /* 2116828 */     GIR_EraseRootFromParent_Done,
     /* 2116829 */   // Label 28030: @2116829
     /* 2116829 */   GIM_Try, /*On fail goto*//*Label 28031*/ GIMT_Encode4(2116920), // Rule ID 17029 //
     /* 2116834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2116845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2116848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2116851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2116854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2116857 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116880 */     // MIs[0] round
     /* 2116880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116883 */     // MIs[0] policy
     /* 2116883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116893 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2116896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116919 */     // GIR_Coverage, 17029,
     /* 2116919 */     GIR_EraseRootFromParent_Done,
     /* 2116920 */   // Label 28031: @2116920
     /* 2116920 */   GIM_Try, /*On fail goto*//*Label 28032*/ GIMT_Encode4(2117011), // Rule ID 17032 //
     /* 2116925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2116936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2116939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2116942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2116945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116971 */     // MIs[0] round
     /* 2116971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116974 */     // MIs[0] policy
     /* 2116974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116984 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2116987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117010 */     // GIR_Coverage, 17032,
     /* 2117010 */     GIR_EraseRootFromParent_Done,
     /* 2117011 */   // Label 28032: @2117011
     /* 2117011 */   GIM_Try, /*On fail goto*//*Label 28033*/ GIMT_Encode4(2117102), // Rule ID 17033 //
     /* 2117016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2117027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2117030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2117033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2117036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117062 */     // MIs[0] round
     /* 2117062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117065 */     // MIs[0] policy
     /* 2117065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117075 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2117078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117101 */     // GIR_Coverage, 17033,
     /* 2117101 */     GIR_EraseRootFromParent_Done,
     /* 2117102 */   // Label 28033: @2117102
     /* 2117102 */   GIM_Try, /*On fail goto*//*Label 28034*/ GIMT_Encode4(2117193), // Rule ID 17036 //
     /* 2117107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2117110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2117118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2117121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2117124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2117127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117153 */     // MIs[0] round
     /* 2117153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117156 */     // MIs[0] policy
     /* 2117156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117166 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2117169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117192 */     // GIR_Coverage, 17036,
     /* 2117192 */     GIR_EraseRootFromParent_Done,
     /* 2117193 */   // Label 28034: @2117193
     /* 2117193 */   GIM_Try, /*On fail goto*//*Label 28035*/ GIMT_Encode4(2117284), // Rule ID 17037 //
     /* 2117198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2117209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2117212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2117215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2117218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117244 */     // MIs[0] round
     /* 2117244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117247 */     // MIs[0] policy
     /* 2117247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117257 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2117260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117283 */     // GIR_Coverage, 17037,
     /* 2117283 */     GIR_EraseRootFromParent_Done,
     /* 2117284 */   // Label 28035: @2117284
     /* 2117284 */   GIM_Try, /*On fail goto*//*Label 28036*/ GIMT_Encode4(2117375), // Rule ID 17040 //
     /* 2117289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2117292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2117300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2117303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2117306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2117309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2117319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117335 */     // MIs[0] round
     /* 2117335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117338 */     // MIs[0] policy
     /* 2117338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117348 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2117351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117374 */     // GIR_Coverage, 17040,
     /* 2117374 */     GIR_EraseRootFromParent_Done,
     /* 2117375 */   // Label 28036: @2117375
     /* 2117375 */   GIM_Try, /*On fail goto*//*Label 28037*/ GIMT_Encode4(2117466), // Rule ID 17041 //
     /* 2117380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2117391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2117394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2117397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2117400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2117410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117426 */     // MIs[0] round
     /* 2117426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117429 */     // MIs[0] policy
     /* 2117429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117439 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2117442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117465 */     // GIR_Coverage, 17041,
     /* 2117465 */     GIR_EraseRootFromParent_Done,
     /* 2117466 */   // Label 28037: @2117466
     /* 2117466 */   GIM_Try, /*On fail goto*//*Label 28038*/ GIMT_Encode4(2117557), // Rule ID 17044 //
     /* 2117471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2117474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2117482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2117485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2117488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2117491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117517 */     // MIs[0] round
     /* 2117517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117520 */     // MIs[0] policy
     /* 2117520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117530 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2117533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117556 */     // GIR_Coverage, 17044,
     /* 2117556 */     GIR_EraseRootFromParent_Done,
     /* 2117557 */   // Label 28038: @2117557
     /* 2117557 */   GIM_Try, /*On fail goto*//*Label 28039*/ GIMT_Encode4(2117648), // Rule ID 17045 //
     /* 2117562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2117573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2117576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2117579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2117582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117608 */     // MIs[0] round
     /* 2117608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117611 */     // MIs[0] policy
     /* 2117611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117621 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2117624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117647 */     // GIR_Coverage, 17045,
     /* 2117647 */     GIR_EraseRootFromParent_Done,
     /* 2117648 */   // Label 28039: @2117648
     /* 2117648 */   GIM_Try, /*On fail goto*//*Label 28040*/ GIMT_Encode4(2117739), // Rule ID 17048 //
     /* 2117653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2117664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2117670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117699 */     // MIs[0] round
     /* 2117699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117702 */     // MIs[0] policy
     /* 2117702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117712 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2117715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117738 */     // GIR_Coverage, 17048,
     /* 2117738 */     GIR_EraseRootFromParent_Done,
     /* 2117739 */   // Label 28040: @2117739
     /* 2117739 */   GIM_Try, /*On fail goto*//*Label 28041*/ GIMT_Encode4(2117830), // Rule ID 17049 //
     /* 2117744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2117755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2117761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117790 */     // MIs[0] round
     /* 2117790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117793 */     // MIs[0] policy
     /* 2117793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117803 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2117806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117829 */     // GIR_Coverage, 17049,
     /* 2117829 */     GIR_EraseRootFromParent_Done,
     /* 2117830 */   // Label 28041: @2117830
     /* 2117830 */   GIM_Try, /*On fail goto*//*Label 28042*/ GIMT_Encode4(2117921), // Rule ID 17052 //
     /* 2117835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2117846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2117849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2117852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117881 */     // MIs[0] round
     /* 2117881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117884 */     // MIs[0] policy
     /* 2117884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117894 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2117897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117920 */     // GIR_Coverage, 17052,
     /* 2117920 */     GIR_EraseRootFromParent_Done,
     /* 2117921 */   // Label 28042: @2117921
     /* 2117921 */   GIM_Try, /*On fail goto*//*Label 28043*/ GIMT_Encode4(2118012), // Rule ID 17053 //
     /* 2117926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2117937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2117940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2117943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117972 */     // MIs[0] round
     /* 2117972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117975 */     // MIs[0] policy
     /* 2117975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117985 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2117988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118011 */     // GIR_Coverage, 17053,
     /* 2118011 */     GIR_EraseRootFromParent_Done,
     /* 2118012 */   // Label 28043: @2118012
     /* 2118012 */   GIM_Try, /*On fail goto*//*Label 28044*/ GIMT_Encode4(2118103), // Rule ID 17056 //
     /* 2118017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2118020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2118028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2118031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2118034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118063 */     // MIs[0] round
     /* 2118063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118066 */     // MIs[0] policy
     /* 2118066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118076 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2118079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118102 */     // GIR_Coverage, 17056,
     /* 2118102 */     GIR_EraseRootFromParent_Done,
     /* 2118103 */   // Label 28044: @2118103
     /* 2118103 */   GIM_Try, /*On fail goto*//*Label 28045*/ GIMT_Encode4(2118194), // Rule ID 17057 //
     /* 2118108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2118119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2118122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2118125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118154 */     // MIs[0] round
     /* 2118154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118157 */     // MIs[0] policy
     /* 2118157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118167 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2118170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118193 */     // GIR_Coverage, 17057,
     /* 2118193 */     GIR_EraseRootFromParent_Done,
     /* 2118194 */   // Label 28045: @2118194
     /* 2118194 */   GIM_Try, /*On fail goto*//*Label 28046*/ GIMT_Encode4(2118285), // Rule ID 17060 //
     /* 2118199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2118202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2118210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2118213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2118216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118245 */     // MIs[0] round
     /* 2118245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118248 */     // MIs[0] policy
     /* 2118248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118258 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2118261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118284 */     // GIR_Coverage, 17060,
     /* 2118284 */     GIR_EraseRootFromParent_Done,
     /* 2118285 */   // Label 28046: @2118285
     /* 2118285 */   GIM_Try, /*On fail goto*//*Label 28047*/ GIMT_Encode4(2118376), // Rule ID 17061 //
     /* 2118290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2118301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2118304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2118307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118336 */     // MIs[0] round
     /* 2118336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118339 */     // MIs[0] policy
     /* 2118339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118349 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2118352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118375 */     // GIR_Coverage, 17061,
     /* 2118375 */     GIR_EraseRootFromParent_Done,
     /* 2118376 */   // Label 28047: @2118376
     /* 2118376 */   GIM_Try, /*On fail goto*//*Label 28048*/ GIMT_Encode4(2118467), // Rule ID 17064 //
     /* 2118381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2118384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2118392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2118395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2118398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2118404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118427 */     // MIs[0] round
     /* 2118427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118430 */     // MIs[0] policy
     /* 2118430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118440 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2118443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118466 */     // GIR_Coverage, 17064,
     /* 2118466 */     GIR_EraseRootFromParent_Done,
     /* 2118467 */   // Label 28048: @2118467
     /* 2118467 */   GIM_Try, /*On fail goto*//*Label 28049*/ GIMT_Encode4(2118558), // Rule ID 17065 //
     /* 2118472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2118483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2118486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2118489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2118495 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118518 */     // MIs[0] round
     /* 2118518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118521 */     // MIs[0] policy
     /* 2118521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118531 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2118534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118557 */     // GIR_Coverage, 17065,
     /* 2118557 */     GIR_EraseRootFromParent_Done,
     /* 2118558 */   // Label 28049: @2118558
     /* 2118558 */   GIM_Try, /*On fail goto*//*Label 28050*/ GIMT_Encode4(2118649), // Rule ID 17068 //
     /* 2118563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2118574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2118577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2118580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118609 */     // MIs[0] round
     /* 2118609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118612 */     // MIs[0] policy
     /* 2118612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118622 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2118625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118648 */     // GIR_Coverage, 17068,
     /* 2118648 */     GIR_EraseRootFromParent_Done,
     /* 2118649 */   // Label 28050: @2118649
     /* 2118649 */   GIM_Try, /*On fail goto*//*Label 28051*/ GIMT_Encode4(2118740), // Rule ID 17069 //
     /* 2118654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2118665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2118668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2118671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118700 */     // MIs[0] round
     /* 2118700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118703 */     // MIs[0] policy
     /* 2118703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118713 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2118716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118736 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118739 */     // GIR_Coverage, 17069,
     /* 2118739 */     GIR_EraseRootFromParent_Done,
     /* 2118740 */   // Label 28051: @2118740
     /* 2118740 */   GIM_Try, /*On fail goto*//*Label 28052*/ GIMT_Encode4(2118831), // Rule ID 17072 //
     /* 2118745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2118756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2118759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2118762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118791 */     // MIs[0] round
     /* 2118791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118794 */     // MIs[0] policy
     /* 2118794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118804 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2118807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118830 */     // GIR_Coverage, 17072,
     /* 2118830 */     GIR_EraseRootFromParent_Done,
     /* 2118831 */   // Label 28052: @2118831
     /* 2118831 */   GIM_Try, /*On fail goto*//*Label 28053*/ GIMT_Encode4(2118922), // Rule ID 17073 //
     /* 2118836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2118847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2118850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2118853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118882 */     // MIs[0] round
     /* 2118882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118885 */     // MIs[0] policy
     /* 2118885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118895 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2118898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118921 */     // GIR_Coverage, 17073,
     /* 2118921 */     GIR_EraseRootFromParent_Done,
     /* 2118922 */   // Label 28053: @2118922
     /* 2118922 */   GIM_Try, /*On fail goto*//*Label 28054*/ GIMT_Encode4(2119013), // Rule ID 17076 //
     /* 2118927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2118938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2118941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2118944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118973 */     // MIs[0] round
     /* 2118973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118976 */     // MIs[0] policy
     /* 2118976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118986 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2118989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119012 */     // GIR_Coverage, 17076,
     /* 2119012 */     GIR_EraseRootFromParent_Done,
     /* 2119013 */   // Label 28054: @2119013
     /* 2119013 */   GIM_Try, /*On fail goto*//*Label 28055*/ GIMT_Encode4(2119104), // Rule ID 17077 //
     /* 2119018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2119021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2119029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2119032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2119035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2119038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2119060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119064 */     // MIs[0] round
     /* 2119064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119067 */     // MIs[0] policy
     /* 2119067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119077 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2119080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119103 */     // GIR_Coverage, 17077,
     /* 2119103 */     GIR_EraseRootFromParent_Done,
     /* 2119104 */   // Label 28055: @2119104
     /* 2119104 */   GIM_Try, /*On fail goto*//*Label 28056*/ GIMT_Encode4(2119195), // Rule ID 17080 //
     /* 2119109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2119112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2119120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2119123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2119126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2119129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2119151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119155 */     // MIs[0] round
     /* 2119155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119158 */     // MIs[0] policy
     /* 2119158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119168 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2119171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119194 */     // GIR_Coverage, 17080,
     /* 2119194 */     GIR_EraseRootFromParent_Done,
     /* 2119195 */   // Label 28056: @2119195
     /* 2119195 */   GIM_Try, /*On fail goto*//*Label 28057*/ GIMT_Encode4(2119286), // Rule ID 17081 //
     /* 2119200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2119203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2119211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2119214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2119217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2119220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2119242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119246 */     // MIs[0] round
     /* 2119246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119249 */     // MIs[0] policy
     /* 2119249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119259 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2119262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119285 */     // GIR_Coverage, 17081,
     /* 2119285 */     GIR_EraseRootFromParent_Done,
     /* 2119286 */   // Label 28057: @2119286
     /* 2119286 */   GIM_Try, /*On fail goto*//*Label 28058*/ GIMT_Encode4(2119377), // Rule ID 17084 //
     /* 2119291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2119302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2119305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2119308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2119311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119337 */     // MIs[0] round
     /* 2119337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119340 */     // MIs[0] policy
     /* 2119340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119350 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2119353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119376 */     // GIR_Coverage, 17084,
     /* 2119376 */     GIR_EraseRootFromParent_Done,
     /* 2119377 */   // Label 28058: @2119377
     /* 2119377 */   GIM_Try, /*On fail goto*//*Label 28059*/ GIMT_Encode4(2119468), // Rule ID 17085 //
     /* 2119382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2119393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2119396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2119399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2119402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119428 */     // MIs[0] round
     /* 2119428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119431 */     // MIs[0] policy
     /* 2119431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119441 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2119444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119467 */     // GIR_Coverage, 17085,
     /* 2119467 */     GIR_EraseRootFromParent_Done,
     /* 2119468 */   // Label 28059: @2119468
     /* 2119468 */   GIM_Try, /*On fail goto*//*Label 28060*/ GIMT_Encode4(2119559), // Rule ID 17088 //
     /* 2119473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2119484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2119487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2119490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2119493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119519 */     // MIs[0] round
     /* 2119519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119522 */     // MIs[0] policy
     /* 2119522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119532 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2119535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119558 */     // GIR_Coverage, 17088,
     /* 2119558 */     GIR_EraseRootFromParent_Done,
     /* 2119559 */   // Label 28060: @2119559
     /* 2119559 */   GIM_Try, /*On fail goto*//*Label 28061*/ GIMT_Encode4(2119650), // Rule ID 17089 //
     /* 2119564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2119575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2119578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2119581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2119584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119610 */     // MIs[0] round
     /* 2119610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119613 */     // MIs[0] policy
     /* 2119613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119623 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2119626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119649 */     // GIR_Coverage, 17089,
     /* 2119649 */     GIR_EraseRootFromParent_Done,
     /* 2119650 */   // Label 28061: @2119650
     /* 2119650 */   GIM_Try, /*On fail goto*//*Label 28062*/ GIMT_Encode4(2119741), // Rule ID 17092 //
     /* 2119655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2119666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2119669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2119672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2119675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119701 */     // MIs[0] round
     /* 2119701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119704 */     // MIs[0] policy
     /* 2119704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119714 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2119717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119740 */     // GIR_Coverage, 17092,
     /* 2119740 */     GIR_EraseRootFromParent_Done,
     /* 2119741 */   // Label 28062: @2119741
     /* 2119741 */   GIM_Try, /*On fail goto*//*Label 28063*/ GIMT_Encode4(2119832), // Rule ID 17093 //
     /* 2119746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2119757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2119760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2119763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2119766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119792 */     // MIs[0] round
     /* 2119792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119795 */     // MIs[0] policy
     /* 2119795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119805 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2119808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119831 */     // GIR_Coverage, 17093,
     /* 2119831 */     GIR_EraseRootFromParent_Done,
     /* 2119832 */   // Label 28063: @2119832
     /* 2119832 */   GIM_Try, /*On fail goto*//*Label 28064*/ GIMT_Encode4(2119923), // Rule ID 17096 //
     /* 2119837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2119848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2119851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2119854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2119857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119883 */     // MIs[0] round
     /* 2119883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119886 */     // MIs[0] policy
     /* 2119886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119896 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2119899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119922 */     // GIR_Coverage, 17096,
     /* 2119922 */     GIR_EraseRootFromParent_Done,
     /* 2119923 */   // Label 28064: @2119923
     /* 2119923 */   GIM_Try, /*On fail goto*//*Label 28065*/ GIMT_Encode4(2120014), // Rule ID 17097 //
     /* 2119928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2119939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2119942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2119945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2119948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119974 */     // MIs[0] round
     /* 2119974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119977 */     // MIs[0] policy
     /* 2119977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119987 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2119990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120013 */     // GIR_Coverage, 17097,
     /* 2120013 */     GIR_EraseRootFromParent_Done,
     /* 2120014 */   // Label 28065: @2120014
     /* 2120014 */   GIM_Try, /*On fail goto*//*Label 28066*/ GIMT_Encode4(2120105), // Rule ID 17100 //
     /* 2120019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2120030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2120033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2120036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2120039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2120042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120065 */     // MIs[0] round
     /* 2120065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120068 */     // MIs[0] policy
     /* 2120068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120078 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2120081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120104 */     // GIR_Coverage, 17100,
     /* 2120104 */     GIR_EraseRootFromParent_Done,
     /* 2120105 */   // Label 28066: @2120105
     /* 2120105 */   GIM_Try, /*On fail goto*//*Label 28067*/ GIMT_Encode4(2120196), // Rule ID 17101 //
     /* 2120110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2120121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2120124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2120127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2120130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2120133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120156 */     // MIs[0] round
     /* 2120156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120159 */     // MIs[0] policy
     /* 2120159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120169 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2120172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120195 */     // GIR_Coverage, 17101,
     /* 2120195 */     GIR_EraseRootFromParent_Done,
     /* 2120196 */   // Label 28067: @2120196
     /* 2120196 */   GIM_Try, /*On fail goto*//*Label 28068*/ GIMT_Encode4(2120287), // Rule ID 17104 //
     /* 2120201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2120212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2120215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2120218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2120221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120247 */     // MIs[0] round
     /* 2120247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120250 */     // MIs[0] policy
     /* 2120250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120260 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2120263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120286 */     // GIR_Coverage, 17104,
     /* 2120286 */     GIR_EraseRootFromParent_Done,
     /* 2120287 */   // Label 28068: @2120287
     /* 2120287 */   GIM_Try, /*On fail goto*//*Label 28069*/ GIMT_Encode4(2120378), // Rule ID 17105 //
     /* 2120292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2120303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2120306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2120309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2120312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120338 */     // MIs[0] round
     /* 2120338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120341 */     // MIs[0] policy
     /* 2120341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120351 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2120354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120377 */     // GIR_Coverage, 17105,
     /* 2120377 */     GIR_EraseRootFromParent_Done,
     /* 2120378 */   // Label 28069: @2120378
     /* 2120378 */   GIM_Try, /*On fail goto*//*Label 28070*/ GIMT_Encode4(2120469), // Rule ID 17108 //
     /* 2120383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2120394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2120397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2120400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2120403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120429 */     // MIs[0] round
     /* 2120429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120432 */     // MIs[0] policy
     /* 2120432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120442 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2120445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120468 */     // GIR_Coverage, 17108,
     /* 2120468 */     GIR_EraseRootFromParent_Done,
     /* 2120469 */   // Label 28070: @2120469
     /* 2120469 */   GIM_Try, /*On fail goto*//*Label 28071*/ GIMT_Encode4(2120560), // Rule ID 17109 //
     /* 2120474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2120485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2120488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2120491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2120494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120520 */     // MIs[0] round
     /* 2120520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120523 */     // MIs[0] policy
     /* 2120523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120533 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2120536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120559 */     // GIR_Coverage, 17109,
     /* 2120559 */     GIR_EraseRootFromParent_Done,
     /* 2120560 */   // Label 28071: @2120560
     /* 2120560 */   GIM_Try, /*On fail goto*//*Label 28072*/ GIMT_Encode4(2120651), // Rule ID 17112 //
     /* 2120565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2120576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2120579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2120582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2120585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120611 */     // MIs[0] round
     /* 2120611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120614 */     // MIs[0] policy
     /* 2120614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120624 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2120627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120650 */     // GIR_Coverage, 17112,
     /* 2120650 */     GIR_EraseRootFromParent_Done,
     /* 2120651 */   // Label 28072: @2120651
     /* 2120651 */   GIM_Try, /*On fail goto*//*Label 28073*/ GIMT_Encode4(2120742), // Rule ID 17113 //
     /* 2120656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2120667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2120670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2120673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2120676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120702 */     // MIs[0] round
     /* 2120702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120705 */     // MIs[0] policy
     /* 2120705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120715 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2120718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120741 */     // GIR_Coverage, 17113,
     /* 2120741 */     GIR_EraseRootFromParent_Done,
     /* 2120742 */   // Label 28073: @2120742
     /* 2120742 */   GIM_Try, /*On fail goto*//*Label 28074*/ GIMT_Encode4(2120833), // Rule ID 17116 //
     /* 2120747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2120758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2120761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2120764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2120767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120793 */     // MIs[0] round
     /* 2120793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120796 */     // MIs[0] policy
     /* 2120796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120806 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2120809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120832 */     // GIR_Coverage, 17116,
     /* 2120832 */     GIR_EraseRootFromParent_Done,
     /* 2120833 */   // Label 28074: @2120833
     /* 2120833 */   GIM_Try, /*On fail goto*//*Label 28075*/ GIMT_Encode4(2120924), // Rule ID 17117 //
     /* 2120838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2120849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2120852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2120855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2120858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120884 */     // MIs[0] round
     /* 2120884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120887 */     // MIs[0] policy
     /* 2120887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120897 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2120900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120923 */     // GIR_Coverage, 17117,
     /* 2120923 */     GIR_EraseRootFromParent_Done,
     /* 2120924 */   // Label 28075: @2120924
     /* 2120924 */   GIM_Try, /*On fail goto*//*Label 28076*/ GIMT_Encode4(2121015), // Rule ID 17120 //
     /* 2120929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2120940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2120943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2120946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120975 */     // MIs[0] round
     /* 2120975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120978 */     // MIs[0] policy
     /* 2120978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120988 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2120991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121014 */     // GIR_Coverage, 17120,
     /* 2121014 */     GIR_EraseRootFromParent_Done,
     /* 2121015 */   // Label 28076: @2121015
     /* 2121015 */   GIM_Try, /*On fail goto*//*Label 28077*/ GIMT_Encode4(2121106), // Rule ID 17121 //
     /* 2121020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2121031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2121034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2121037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121066 */     // MIs[0] round
     /* 2121066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121069 */     // MIs[0] policy
     /* 2121069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121079 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2121082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121105 */     // GIR_Coverage, 17121,
     /* 2121105 */     GIR_EraseRootFromParent_Done,
     /* 2121106 */   // Label 28077: @2121106
     /* 2121106 */   GIM_Try, /*On fail goto*//*Label 28078*/ GIMT_Encode4(2121197), // Rule ID 17124 //
     /* 2121111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2121122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2121125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2121128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121157 */     // MIs[0] round
     /* 2121157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121160 */     // MIs[0] policy
     /* 2121160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121170 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2121173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121196 */     // GIR_Coverage, 17124,
     /* 2121196 */     GIR_EraseRootFromParent_Done,
     /* 2121197 */   // Label 28078: @2121197
     /* 2121197 */   GIM_Try, /*On fail goto*//*Label 28079*/ GIMT_Encode4(2121288), // Rule ID 17125 //
     /* 2121202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2121213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2121216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2121219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121248 */     // MIs[0] round
     /* 2121248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121251 */     // MIs[0] policy
     /* 2121251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121261 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2121264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121287 */     // GIR_Coverage, 17125,
     /* 2121287 */     GIR_EraseRootFromParent_Done,
     /* 2121288 */   // Label 28079: @2121288
     /* 2121288 */   GIM_Try, /*On fail goto*//*Label 28080*/ GIMT_Encode4(2121379), // Rule ID 17128 //
     /* 2121293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2121304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2121307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2121310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121339 */     // MIs[0] round
     /* 2121339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121342 */     // MIs[0] policy
     /* 2121342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121352 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2121355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121378 */     // GIR_Coverage, 17128,
     /* 2121378 */     GIR_EraseRootFromParent_Done,
     /* 2121379 */   // Label 28080: @2121379
     /* 2121379 */   GIM_Try, /*On fail goto*//*Label 28081*/ GIMT_Encode4(2121470), // Rule ID 17129 //
     /* 2121384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2121395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2121398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2121401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121430 */     // MIs[0] round
     /* 2121430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121433 */     // MIs[0] policy
     /* 2121433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121443 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2121446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121469 */     // GIR_Coverage, 17129,
     /* 2121469 */     GIR_EraseRootFromParent_Done,
     /* 2121470 */   // Label 28081: @2121470
     /* 2121470 */   GIM_Try, /*On fail goto*//*Label 28082*/ GIMT_Encode4(2121561), // Rule ID 17132 //
     /* 2121475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2121486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2121489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2121492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121521 */     // MIs[0] round
     /* 2121521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121524 */     // MIs[0] policy
     /* 2121524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121534 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2121537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121560 */     // GIR_Coverage, 17132,
     /* 2121560 */     GIR_EraseRootFromParent_Done,
     /* 2121561 */   // Label 28082: @2121561
     /* 2121561 */   GIM_Try, /*On fail goto*//*Label 28083*/ GIMT_Encode4(2121652), // Rule ID 17133 //
     /* 2121566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2121577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2121580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2121583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121612 */     // MIs[0] round
     /* 2121612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121615 */     // MIs[0] policy
     /* 2121615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121625 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2121628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121651 */     // GIR_Coverage, 17133,
     /* 2121651 */     GIR_EraseRootFromParent_Done,
     /* 2121652 */   // Label 28083: @2121652
     /* 2121652 */   GIM_Try, /*On fail goto*//*Label 28084*/ GIMT_Encode4(2121743), // Rule ID 17136 //
     /* 2121657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2121668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2121671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2121674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121703 */     // MIs[0] round
     /* 2121703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121706 */     // MIs[0] policy
     /* 2121706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121716 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2121719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121742 */     // GIR_Coverage, 17136,
     /* 2121742 */     GIR_EraseRootFromParent_Done,
     /* 2121743 */   // Label 28084: @2121743
     /* 2121743 */   GIM_Try, /*On fail goto*//*Label 28085*/ GIMT_Encode4(2121834), // Rule ID 17137 //
     /* 2121748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2121759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2121762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2121765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121794 */     // MIs[0] round
     /* 2121794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121797 */     // MIs[0] policy
     /* 2121797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121807 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2121810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121833 */     // GIR_Coverage, 17137,
     /* 2121833 */     GIR_EraseRootFromParent_Done,
     /* 2121834 */   // Label 28085: @2121834
     /* 2121834 */   GIM_Try, /*On fail goto*//*Label 28086*/ GIMT_Encode4(2121925), // Rule ID 17140 //
     /* 2121839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2121850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2121853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2121856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121885 */     // MIs[0] round
     /* 2121885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121888 */     // MIs[0] policy
     /* 2121888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121898 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2121901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121924 */     // GIR_Coverage, 17140,
     /* 2121924 */     GIR_EraseRootFromParent_Done,
     /* 2121925 */   // Label 28086: @2121925
     /* 2121925 */   GIM_Try, /*On fail goto*//*Label 28087*/ GIMT_Encode4(2122016), // Rule ID 17141 //
     /* 2121930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2121933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2121941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2121944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2121947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121976 */     // MIs[0] round
     /* 2121976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121979 */     // MIs[0] policy
     /* 2121979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121989 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2121992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122015 */     // GIR_Coverage, 17141,
     /* 2122015 */     GIR_EraseRootFromParent_Done,
     /* 2122016 */   // Label 28087: @2122016
     /* 2122016 */   GIM_Try, /*On fail goto*//*Label 28088*/ GIMT_Encode4(2122107), // Rule ID 17144 //
     /* 2122021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2122024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2122032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2122035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122067 */     // MIs[0] round
     /* 2122067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122070 */     // MIs[0] policy
     /* 2122070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122080 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2122083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122106 */     // GIR_Coverage, 17144,
     /* 2122106 */     GIR_EraseRootFromParent_Done,
     /* 2122107 */   // Label 28088: @2122107
     /* 2122107 */   GIM_Try, /*On fail goto*//*Label 28089*/ GIMT_Encode4(2122198), // Rule ID 17145 //
     /* 2122112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2122123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2122126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122135 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122158 */     // MIs[0] round
     /* 2122158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122161 */     // MIs[0] policy
     /* 2122161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122171 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2122174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122197 */     // GIR_Coverage, 17145,
     /* 2122197 */     GIR_EraseRootFromParent_Done,
     /* 2122198 */   // Label 28089: @2122198
     /* 2122198 */   GIM_Try, /*On fail goto*//*Label 28090*/ GIMT_Encode4(2122289), // Rule ID 17148 //
     /* 2122203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2122206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2122214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2122217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122249 */     // MIs[0] round
     /* 2122249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122252 */     // MIs[0] policy
     /* 2122252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122262 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2122265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122288 */     // GIR_Coverage, 17148,
     /* 2122288 */     GIR_EraseRootFromParent_Done,
     /* 2122289 */   // Label 28090: @2122289
     /* 2122289 */   GIM_Try, /*On fail goto*//*Label 28091*/ GIMT_Encode4(2122380), // Rule ID 17149 //
     /* 2122294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2122305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2122308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122317 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122340 */     // MIs[0] round
     /* 2122340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122343 */     // MIs[0] policy
     /* 2122343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122353 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2122356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122376 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122379 */     // GIR_Coverage, 17149,
     /* 2122379 */     GIR_EraseRootFromParent_Done,
     /* 2122380 */   // Label 28091: @2122380
     /* 2122380 */   GIM_Try, /*On fail goto*//*Label 28092*/ GIMT_Encode4(2122471), // Rule ID 17152 //
     /* 2122385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2122388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2122396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2122399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122431 */     // MIs[0] round
     /* 2122431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122434 */     // MIs[0] policy
     /* 2122434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122444 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2122447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122470 */     // GIR_Coverage, 17152,
     /* 2122470 */     GIR_EraseRootFromParent_Done,
     /* 2122471 */   // Label 28092: @2122471
     /* 2122471 */   GIM_Try, /*On fail goto*//*Label 28093*/ GIMT_Encode4(2122562), // Rule ID 17153 //
     /* 2122476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2122487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2122490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122522 */     // MIs[0] round
     /* 2122522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122525 */     // MIs[0] policy
     /* 2122525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122535 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2122538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122561 */     // GIR_Coverage, 17153,
     /* 2122561 */     GIR_EraseRootFromParent_Done,
     /* 2122562 */   // Label 28093: @2122562
     /* 2122562 */   GIM_Try, /*On fail goto*//*Label 28094*/ GIMT_Encode4(2122653), // Rule ID 17162 //
     /* 2122567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2122578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2122581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2122587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122613 */     // MIs[0] round
     /* 2122613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122616 */     // MIs[0] policy
     /* 2122616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122626 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2122629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122652 */     // GIR_Coverage, 17162,
     /* 2122652 */     GIR_EraseRootFromParent_Done,
     /* 2122653 */   // Label 28094: @2122653
     /* 2122653 */   GIM_Try, /*On fail goto*//*Label 28095*/ GIMT_Encode4(2122744), // Rule ID 17163 //
     /* 2122658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2122669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2122672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2122678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122704 */     // MIs[0] round
     /* 2122704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122707 */     // MIs[0] policy
     /* 2122707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122717 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2122720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122743 */     // GIR_Coverage, 17163,
     /* 2122743 */     GIR_EraseRootFromParent_Done,
     /* 2122744 */   // Label 28095: @2122744
     /* 2122744 */   GIM_Try, /*On fail goto*//*Label 28096*/ GIMT_Encode4(2122835), // Rule ID 17172 //
     /* 2122749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2122760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2122763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2122769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122795 */     // MIs[0] round
     /* 2122795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122798 */     // MIs[0] policy
     /* 2122798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122808 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2122811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122834 */     // GIR_Coverage, 17172,
     /* 2122834 */     GIR_EraseRootFromParent_Done,
     /* 2122835 */   // Label 28096: @2122835
     /* 2122835 */   GIM_Try, /*On fail goto*//*Label 28097*/ GIMT_Encode4(2122926), // Rule ID 17173 //
     /* 2122840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2122851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2122854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2122860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122886 */     // MIs[0] round
     /* 2122886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122889 */     // MIs[0] policy
     /* 2122889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122899 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2122902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122925 */     // GIR_Coverage, 17173,
     /* 2122925 */     GIR_EraseRootFromParent_Done,
     /* 2122926 */   // Label 28097: @2122926
     /* 2122926 */   GIM_Try, /*On fail goto*//*Label 28098*/ GIMT_Encode4(2123017), // Rule ID 17182 //
     /* 2122931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2122942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2122945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2122951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122977 */     // MIs[0] round
     /* 2122977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122980 */     // MIs[0] policy
     /* 2122980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122990 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2122993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123016 */     // GIR_Coverage, 17182,
     /* 2123016 */     GIR_EraseRootFromParent_Done,
     /* 2123017 */   // Label 28098: @2123017
     /* 2123017 */   GIM_Try, /*On fail goto*//*Label 28099*/ GIMT_Encode4(2123108), // Rule ID 17183 //
     /* 2123022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2123025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2123033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2123036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2123039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2123042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123068 */     // MIs[0] round
     /* 2123068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123071 */     // MIs[0] policy
     /* 2123071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123081 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2123084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123107 */     // GIR_Coverage, 17183,
     /* 2123107 */     GIR_EraseRootFromParent_Done,
     /* 2123108 */   // Label 28099: @2123108
     /* 2123108 */   GIM_Try, /*On fail goto*//*Label 28100*/ GIMT_Encode4(2123199), // Rule ID 17192 //
     /* 2123113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2123116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2123124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2123127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2123130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2123133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2123136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123159 */     // MIs[0] round
     /* 2123159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123162 */     // MIs[0] policy
     /* 2123162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123172 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2123175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123198 */     // GIR_Coverage, 17192,
     /* 2123198 */     GIR_EraseRootFromParent_Done,
     /* 2123199 */   // Label 28100: @2123199
     /* 2123199 */   GIM_Try, /*On fail goto*//*Label 28101*/ GIMT_Encode4(2123290), // Rule ID 17193 //
     /* 2123204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2123207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2123215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2123218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2123221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2123224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2123227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123250 */     // MIs[0] round
     /* 2123250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123253 */     // MIs[0] policy
     /* 2123253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123263 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2123266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123286 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123289 */     // GIR_Coverage, 17193,
     /* 2123289 */     GIR_EraseRootFromParent_Done,
     /* 2123290 */   // Label 28101: @2123290
     /* 2123290 */   GIM_Try, /*On fail goto*//*Label 28102*/ GIMT_Encode4(2123381), // Rule ID 17202 //
     /* 2123295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2123306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2123309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2123312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2123315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123341 */     // MIs[0] round
     /* 2123341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123344 */     // MIs[0] policy
     /* 2123344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123354 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2123357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123380 */     // GIR_Coverage, 17202,
     /* 2123380 */     GIR_EraseRootFromParent_Done,
     /* 2123381 */   // Label 28102: @2123381
     /* 2123381 */   GIM_Try, /*On fail goto*//*Label 28103*/ GIMT_Encode4(2123472), // Rule ID 17203 //
     /* 2123386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2123397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2123400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2123403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2123406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123432 */     // MIs[0] round
     /* 2123432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123435 */     // MIs[0] policy
     /* 2123435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123445 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2123448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123471 */     // GIR_Coverage, 17203,
     /* 2123471 */     GIR_EraseRootFromParent_Done,
     /* 2123472 */   // Label 28103: @2123472
     /* 2123472 */   GIM_Try, /*On fail goto*//*Label 28104*/ GIMT_Encode4(2123563), // Rule ID 17212 //
     /* 2123477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2123488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2123491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2123494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2123497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123523 */     // MIs[0] round
     /* 2123523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123526 */     // MIs[0] policy
     /* 2123526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123536 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2123539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123562 */     // GIR_Coverage, 17212,
     /* 2123562 */     GIR_EraseRootFromParent_Done,
     /* 2123563 */   // Label 28104: @2123563
     /* 2123563 */   GIM_Try, /*On fail goto*//*Label 28105*/ GIMT_Encode4(2123654), // Rule ID 17213 //
     /* 2123568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2123579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2123582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2123585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2123588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123614 */     // MIs[0] round
     /* 2123614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123617 */     // MIs[0] policy
     /* 2123617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123627 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2123630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123653 */     // GIR_Coverage, 17213,
     /* 2123653 */     GIR_EraseRootFromParent_Done,
     /* 2123654 */   // Label 28105: @2123654
     /* 2123654 */   GIM_Try, /*On fail goto*//*Label 28106*/ GIMT_Encode4(2123745), // Rule ID 17222 //
     /* 2123659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2123670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2123673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2123676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2123679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123705 */     // MIs[0] round
     /* 2123705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123708 */     // MIs[0] policy
     /* 2123708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123718 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2123721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123744 */     // GIR_Coverage, 17222,
     /* 2123744 */     GIR_EraseRootFromParent_Done,
     /* 2123745 */   // Label 28106: @2123745
     /* 2123745 */   GIM_Try, /*On fail goto*//*Label 28107*/ GIMT_Encode4(2123836), // Rule ID 17223 //
     /* 2123750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2123761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2123764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2123767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2123770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123796 */     // MIs[0] round
     /* 2123796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123799 */     // MIs[0] policy
     /* 2123799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123809 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2123812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123822 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123832 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123835 */     // GIR_Coverage, 17223,
     /* 2123835 */     GIR_EraseRootFromParent_Done,
     /* 2123836 */   // Label 28107: @2123836
     /* 2123836 */   GIM_Try, /*On fail goto*//*Label 28108*/ GIMT_Encode4(2123927), // Rule ID 17232 //
     /* 2123841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2123852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2123855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2123858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2123861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123887 */     // MIs[0] round
     /* 2123887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123890 */     // MIs[0] policy
     /* 2123890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123900 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2123903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123926 */     // GIR_Coverage, 17232,
     /* 2123926 */     GIR_EraseRootFromParent_Done,
     /* 2123927 */   // Label 28108: @2123927
     /* 2123927 */   GIM_Try, /*On fail goto*//*Label 28109*/ GIMT_Encode4(2124018), // Rule ID 17233 //
     /* 2123932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2123943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2123946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2123949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2123952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123978 */     // MIs[0] round
     /* 2123978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123981 */     // MIs[0] policy
     /* 2123981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123991 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2123994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124017 */     // GIR_Coverage, 17233,
     /* 2124017 */     GIR_EraseRootFromParent_Done,
     /* 2124018 */   // Label 28109: @2124018
     /* 2124018 */   GIM_Try, /*On fail goto*//*Label 28110*/ GIMT_Encode4(2124109), // Rule ID 17236 //
     /* 2124023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2124034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2124037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2124040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124069 */     // MIs[0] round
     /* 2124069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124072 */     // MIs[0] policy
     /* 2124072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124082 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2124085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124108 */     // GIR_Coverage, 17236,
     /* 2124108 */     GIR_EraseRootFromParent_Done,
     /* 2124109 */   // Label 28110: @2124109
     /* 2124109 */   GIM_Try, /*On fail goto*//*Label 28111*/ GIMT_Encode4(2124200), // Rule ID 17237 //
     /* 2124114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2124125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2124128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2124131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124160 */     // MIs[0] round
     /* 2124160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124163 */     // MIs[0] policy
     /* 2124163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124173 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2124176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124199 */     // GIR_Coverage, 17237,
     /* 2124199 */     GIR_EraseRootFromParent_Done,
     /* 2124200 */   // Label 28111: @2124200
     /* 2124200 */   GIM_Try, /*On fail goto*//*Label 28112*/ GIMT_Encode4(2124291), // Rule ID 17240 //
     /* 2124205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2124216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2124219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2124222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124251 */     // MIs[0] round
     /* 2124251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124254 */     // MIs[0] policy
     /* 2124254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124264 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2124267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124290 */     // GIR_Coverage, 17240,
     /* 2124290 */     GIR_EraseRootFromParent_Done,
     /* 2124291 */   // Label 28112: @2124291
     /* 2124291 */   GIM_Try, /*On fail goto*//*Label 28113*/ GIMT_Encode4(2124382), // Rule ID 17241 //
     /* 2124296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2124307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2124310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2124313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124342 */     // MIs[0] round
     /* 2124342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124345 */     // MIs[0] policy
     /* 2124345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124355 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2124358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124368 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124378 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124381 */     // GIR_Coverage, 17241,
     /* 2124381 */     GIR_EraseRootFromParent_Done,
     /* 2124382 */   // Label 28113: @2124382
     /* 2124382 */   GIM_Try, /*On fail goto*//*Label 28114*/ GIMT_Encode4(2124473), // Rule ID 17244 //
     /* 2124387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2124398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2124401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2124404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124433 */     // MIs[0] round
     /* 2124433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124436 */     // MIs[0] policy
     /* 2124436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124446 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2124449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124472 */     // GIR_Coverage, 17244,
     /* 2124472 */     GIR_EraseRootFromParent_Done,
     /* 2124473 */   // Label 28114: @2124473
     /* 2124473 */   GIM_Try, /*On fail goto*//*Label 28115*/ GIMT_Encode4(2124564), // Rule ID 17245 //
     /* 2124478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2124489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2124492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2124495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124501 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124524 */     // MIs[0] round
     /* 2124524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124527 */     // MIs[0] policy
     /* 2124527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124537 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2124540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124563 */     // GIR_Coverage, 17245,
     /* 2124563 */     GIR_EraseRootFromParent_Done,
     /* 2124564 */   // Label 28115: @2124564
     /* 2124564 */   GIM_Try, /*On fail goto*//*Label 28116*/ GIMT_Encode4(2124655), // Rule ID 17248 //
     /* 2124569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2124580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2124583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2124586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124615 */     // MIs[0] round
     /* 2124615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124618 */     // MIs[0] policy
     /* 2124618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124628 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2124631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124654 */     // GIR_Coverage, 17248,
     /* 2124654 */     GIR_EraseRootFromParent_Done,
     /* 2124655 */   // Label 28116: @2124655
     /* 2124655 */   GIM_Try, /*On fail goto*//*Label 28117*/ GIMT_Encode4(2124746), // Rule ID 17249 //
     /* 2124660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2124671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2124674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2124677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124706 */     // MIs[0] round
     /* 2124706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124709 */     // MIs[0] policy
     /* 2124709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124719 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2124722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124745 */     // GIR_Coverage, 17249,
     /* 2124745 */     GIR_EraseRootFromParent_Done,
     /* 2124746 */   // Label 28117: @2124746
     /* 2124746 */   GIM_Try, /*On fail goto*//*Label 28118*/ GIMT_Encode4(2124837), // Rule ID 17252 //
     /* 2124751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2124762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2124765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2124768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2124774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124797 */     // MIs[0] round
     /* 2124797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124800 */     // MIs[0] policy
     /* 2124800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124810 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2124813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124836 */     // GIR_Coverage, 17252,
     /* 2124836 */     GIR_EraseRootFromParent_Done,
     /* 2124837 */   // Label 28118: @2124837
     /* 2124837 */   GIM_Try, /*On fail goto*//*Label 28119*/ GIMT_Encode4(2124928), // Rule ID 17253 //
     /* 2124842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2124853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2124856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2124859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2124865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124888 */     // MIs[0] round
     /* 2124888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124891 */     // MIs[0] policy
     /* 2124891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124901 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2124904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124914 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124924 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124927 */     // GIR_Coverage, 17253,
     /* 2124927 */     GIR_EraseRootFromParent_Done,
     /* 2124928 */   // Label 28119: @2124928
     /* 2124928 */   GIM_Try, /*On fail goto*//*Label 28120*/ GIMT_Encode4(2125019), // Rule ID 17256 //
     /* 2124933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2124936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2124944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2124947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2124950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124979 */     // MIs[0] round
     /* 2124979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124982 */     // MIs[0] policy
     /* 2124982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124992 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2124995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125018 */     // GIR_Coverage, 17256,
     /* 2125018 */     GIR_EraseRootFromParent_Done,
     /* 2125019 */   // Label 28120: @2125019
     /* 2125019 */   GIM_Try, /*On fail goto*//*Label 28121*/ GIMT_Encode4(2125110), // Rule ID 17257 //
     /* 2125024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2125035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2125038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2125041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125070 */     // MIs[0] round
     /* 2125070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125073 */     // MIs[0] policy
     /* 2125073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125083 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2125086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125109 */     // GIR_Coverage, 17257,
     /* 2125109 */     GIR_EraseRootFromParent_Done,
     /* 2125110 */   // Label 28121: @2125110
     /* 2125110 */   GIM_Try, /*On fail goto*//*Label 28122*/ GIMT_Encode4(2125201), // Rule ID 17260 //
     /* 2125115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2125118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2125126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2125129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2125132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125161 */     // MIs[0] round
     /* 2125161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125164 */     // MIs[0] policy
     /* 2125164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125174 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2125177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125200 */     // GIR_Coverage, 17260,
     /* 2125200 */     GIR_EraseRootFromParent_Done,
     /* 2125201 */   // Label 28122: @2125201
     /* 2125201 */   GIM_Try, /*On fail goto*//*Label 28123*/ GIMT_Encode4(2125292), // Rule ID 17261 //
     /* 2125206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2125217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2125220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2125223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125252 */     // MIs[0] round
     /* 2125252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125255 */     // MIs[0] policy
     /* 2125255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125265 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2125268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125278 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125288 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125291 */     // GIR_Coverage, 17261,
     /* 2125291 */     GIR_EraseRootFromParent_Done,
     /* 2125292 */   // Label 28123: @2125292
     /* 2125292 */   GIM_Try, /*On fail goto*//*Label 28124*/ GIMT_Encode4(2125383), // Rule ID 17264 //
     /* 2125297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2125300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2125308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2125311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2125314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125343 */     // MIs[0] round
     /* 2125343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125346 */     // MIs[0] policy
     /* 2125346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125356 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2125359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125382 */     // GIR_Coverage, 17264,
     /* 2125382 */     GIR_EraseRootFromParent_Done,
     /* 2125383 */   // Label 28124: @2125383
     /* 2125383 */   GIM_Try, /*On fail goto*//*Label 28125*/ GIMT_Encode4(2125474), // Rule ID 17265 //
     /* 2125388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2125399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2125402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2125405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125411 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125434 */     // MIs[0] round
     /* 2125434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125437 */     // MIs[0] policy
     /* 2125437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125447 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2125450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125470 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125473 */     // GIR_Coverage, 17265,
     /* 2125473 */     GIR_EraseRootFromParent_Done,
     /* 2125474 */   // Label 28125: @2125474
     /* 2125474 */   GIM_Try, /*On fail goto*//*Label 28126*/ GIMT_Encode4(2125565), // Rule ID 17268 //
     /* 2125479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2125482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2125490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2125496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125525 */     // MIs[0] round
     /* 2125525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125528 */     // MIs[0] policy
     /* 2125528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125538 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2125541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125564 */     // GIR_Coverage, 17268,
     /* 2125564 */     GIR_EraseRootFromParent_Done,
     /* 2125565 */   // Label 28126: @2125565
     /* 2125565 */   GIM_Try, /*On fail goto*//*Label 28127*/ GIMT_Encode4(2125656), // Rule ID 17269 //
     /* 2125570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2125581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2125587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125593 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125616 */     // MIs[0] round
     /* 2125616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125619 */     // MIs[0] policy
     /* 2125619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125629 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2125632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125655 */     // GIR_Coverage, 17269,
     /* 2125655 */     GIR_EraseRootFromParent_Done,
     /* 2125656 */   // Label 28127: @2125656
     /* 2125656 */   GIM_Try, /*On fail goto*//*Label 28128*/ GIMT_Encode4(2125747), // Rule ID 17278 //
     /* 2125661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2125672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2125675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2125678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2125681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125707 */     // MIs[0] round
     /* 2125707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125710 */     // MIs[0] policy
     /* 2125710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125720 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2125723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125746 */     // GIR_Coverage, 17278,
     /* 2125746 */     GIR_EraseRootFromParent_Done,
     /* 2125747 */   // Label 28128: @2125747
     /* 2125747 */   GIM_Try, /*On fail goto*//*Label 28129*/ GIMT_Encode4(2125838), // Rule ID 17279 //
     /* 2125752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2125763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2125766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2125769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2125772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125798 */     // MIs[0] round
     /* 2125798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125801 */     // MIs[0] policy
     /* 2125801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125811 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2125814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125837 */     // GIR_Coverage, 17279,
     /* 2125837 */     GIR_EraseRootFromParent_Done,
     /* 2125838 */   // Label 28129: @2125838
     /* 2125838 */   GIM_Try, /*On fail goto*//*Label 28130*/ GIMT_Encode4(2125929), // Rule ID 17288 //
     /* 2125843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2125854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2125857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2125863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125889 */     // MIs[0] round
     /* 2125889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125892 */     // MIs[0] policy
     /* 2125892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125902 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2125905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125928 */     // GIR_Coverage, 17288,
     /* 2125928 */     GIR_EraseRootFromParent_Done,
     /* 2125929 */   // Label 28130: @2125929
     /* 2125929 */   GIM_Try, /*On fail goto*//*Label 28131*/ GIMT_Encode4(2126020), // Rule ID 17289 //
     /* 2125934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2125945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2125948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2125954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125980 */     // MIs[0] round
     /* 2125980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125983 */     // MIs[0] policy
     /* 2125983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125993 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2125996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126019 */     // GIR_Coverage, 17289,
     /* 2126019 */     GIR_EraseRootFromParent_Done,
     /* 2126020 */   // Label 28131: @2126020
     /* 2126020 */   GIM_Try, /*On fail goto*//*Label 28132*/ GIMT_Encode4(2126111), // Rule ID 17298 //
     /* 2126025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2126028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2126036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2126039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2126042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2126045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126071 */     // MIs[0] round
     /* 2126071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126074 */     // MIs[0] policy
     /* 2126074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126084 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2126087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126110 */     // GIR_Coverage, 17298,
     /* 2126110 */     GIR_EraseRootFromParent_Done,
     /* 2126111 */   // Label 28132: @2126111
     /* 2126111 */   GIM_Try, /*On fail goto*//*Label 28133*/ GIMT_Encode4(2126202), // Rule ID 17299 //
     /* 2126116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2126127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2126130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2126133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2126136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126162 */     // MIs[0] round
     /* 2126162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126165 */     // MIs[0] policy
     /* 2126165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126175 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2126178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126201 */     // GIR_Coverage, 17299,
     /* 2126201 */     GIR_EraseRootFromParent_Done,
     /* 2126202 */   // Label 28133: @2126202
     /* 2126202 */   GIM_Try, /*On fail goto*//*Label 28134*/ GIMT_Encode4(2126293), // Rule ID 17308 //
     /* 2126207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2126210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2126218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2126221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2126224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2126227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126253 */     // MIs[0] round
     /* 2126253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126256 */     // MIs[0] policy
     /* 2126256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126266 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2126269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126292 */     // GIR_Coverage, 17308,
     /* 2126292 */     GIR_EraseRootFromParent_Done,
     /* 2126293 */   // Label 28134: @2126293
     /* 2126293 */   GIM_Try, /*On fail goto*//*Label 28135*/ GIMT_Encode4(2126384), // Rule ID 17309 //
     /* 2126298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2126309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2126312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2126315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2126318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126321 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126344 */     // MIs[0] round
     /* 2126344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126347 */     // MIs[0] policy
     /* 2126347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126357 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2126360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126383 */     // GIR_Coverage, 17309,
     /* 2126383 */     GIR_EraseRootFromParent_Done,
     /* 2126384 */   // Label 28135: @2126384
     /* 2126384 */   GIM_Try, /*On fail goto*//*Label 28136*/ GIMT_Encode4(2126475), // Rule ID 17318 //
     /* 2126389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2126392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2126400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2126403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2126406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2126409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2126412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126435 */     // MIs[0] round
     /* 2126435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126438 */     // MIs[0] policy
     /* 2126438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126448 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2126451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126474 */     // GIR_Coverage, 17318,
     /* 2126474 */     GIR_EraseRootFromParent_Done,
     /* 2126475 */   // Label 28136: @2126475
     /* 2126475 */   GIM_Try, /*On fail goto*//*Label 28137*/ GIMT_Encode4(2126566), // Rule ID 17319 //
     /* 2126480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2126491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2126494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2126497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2126500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2126503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126526 */     // MIs[0] round
     /* 2126526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126529 */     // MIs[0] policy
     /* 2126529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126539 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2126542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126565 */     // GIR_Coverage, 17319,
     /* 2126565 */     GIR_EraseRootFromParent_Done,
     /* 2126566 */   // Label 28137: @2126566
     /* 2126566 */   GIM_Try, /*On fail goto*//*Label 28138*/ GIMT_Encode4(2126657), // Rule ID 17328 //
     /* 2126571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2126582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2126585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2126588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2126591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126617 */     // MIs[0] round
     /* 2126617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126620 */     // MIs[0] policy
     /* 2126620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126630 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2126633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126656 */     // GIR_Coverage, 17328,
     /* 2126656 */     GIR_EraseRootFromParent_Done,
     /* 2126657 */   // Label 28138: @2126657
     /* 2126657 */   GIM_Try, /*On fail goto*//*Label 28139*/ GIMT_Encode4(2126748), // Rule ID 17329 //
     /* 2126662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2126673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2126676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2126679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2126682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126708 */     // MIs[0] round
     /* 2126708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126711 */     // MIs[0] policy
     /* 2126711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126721 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2126724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126747 */     // GIR_Coverage, 17329,
     /* 2126747 */     GIR_EraseRootFromParent_Done,
     /* 2126748 */   // Label 28139: @2126748
     /* 2126748 */   GIM_Try, /*On fail goto*//*Label 28140*/ GIMT_Encode4(2126839), // Rule ID 17338 //
     /* 2126753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2126764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2126767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2126770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2126773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126799 */     // MIs[0] round
     /* 2126799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126802 */     // MIs[0] policy
     /* 2126802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126812 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2126815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126838 */     // GIR_Coverage, 17338,
     /* 2126838 */     GIR_EraseRootFromParent_Done,
     /* 2126839 */   // Label 28140: @2126839
     /* 2126839 */   GIM_Try, /*On fail goto*//*Label 28141*/ GIMT_Encode4(2126930), // Rule ID 17339 //
     /* 2126844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2126855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2126858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2126861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2126864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126890 */     // MIs[0] round
     /* 2126890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126893 */     // MIs[0] policy
     /* 2126893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126903 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2126906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126926 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126929 */     // GIR_Coverage, 17339,
     /* 2126929 */     GIR_EraseRootFromParent_Done,
     /* 2126930 */   // Label 28141: @2126930
     /* 2126930 */   GIM_Try, /*On fail goto*//*Label 28142*/ GIMT_Encode4(2127021), // Rule ID 17348 //
     /* 2126935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2126946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2126949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2126952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2126955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126981 */     // MIs[0] round
     /* 2126981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126984 */     // MIs[0] policy
     /* 2126984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126994 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2126997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127020 */     // GIR_Coverage, 17348,
     /* 2127020 */     GIR_EraseRootFromParent_Done,
     /* 2127021 */   // Label 28142: @2127021
     /* 2127021 */   GIM_Try, /*On fail goto*//*Label 28143*/ GIMT_Encode4(2127112), // Rule ID 17349 //
     /* 2127026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2127029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2127037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2127040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2127043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2127046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127072 */     // MIs[0] round
     /* 2127072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127075 */     // MIs[0] policy
     /* 2127075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127085 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2127088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127111 */     // GIR_Coverage, 17349,
     /* 2127111 */     GIR_EraseRootFromParent_Done,
     /* 2127112 */   // Label 28143: @2127112
     /* 2127112 */   GIM_Try, /*On fail goto*//*Label 28144*/ GIMT_Encode4(2127203), // Rule ID 17358 //
     /* 2127117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2127120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2127128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2127131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2127134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2127137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127163 */     // MIs[0] round
     /* 2127163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127166 */     // MIs[0] policy
     /* 2127166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127176 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2127179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127202 */     // GIR_Coverage, 17358,
     /* 2127202 */     GIR_EraseRootFromParent_Done,
     /* 2127203 */   // Label 28144: @2127203
     /* 2127203 */   GIM_Try, /*On fail goto*//*Label 28145*/ GIMT_Encode4(2127294), // Rule ID 17359 //
     /* 2127208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2127211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2127219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2127222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2127225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2127228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127254 */     // MIs[0] round
     /* 2127254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127257 */     // MIs[0] policy
     /* 2127257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127267 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2127270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127293 */     // GIR_Coverage, 17359,
     /* 2127293 */     GIR_EraseRootFromParent_Done,
     /* 2127294 */   // Label 28145: @2127294
     /* 2127294 */   GIM_Try, /*On fail goto*//*Label 28146*/ GIMT_Encode4(2127385), // Rule ID 17362 //
     /* 2127299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2127310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2127313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2127316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127345 */     // MIs[0] round
     /* 2127345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127348 */     // MIs[0] policy
     /* 2127348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127358 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2127361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127384 */     // GIR_Coverage, 17362,
     /* 2127384 */     GIR_EraseRootFromParent_Done,
     /* 2127385 */   // Label 28146: @2127385
     /* 2127385 */   GIM_Try, /*On fail goto*//*Label 28147*/ GIMT_Encode4(2127476), // Rule ID 17363 //
     /* 2127390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2127401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2127404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2127407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127436 */     // MIs[0] round
     /* 2127436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127439 */     // MIs[0] policy
     /* 2127439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127449 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2127452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127475 */     // GIR_Coverage, 17363,
     /* 2127475 */     GIR_EraseRootFromParent_Done,
     /* 2127476 */   // Label 28147: @2127476
     /* 2127476 */   GIM_Try, /*On fail goto*//*Label 28148*/ GIMT_Encode4(2127567), // Rule ID 17366 //
     /* 2127481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2127492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2127495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2127498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127527 */     // MIs[0] round
     /* 2127527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127530 */     // MIs[0] policy
     /* 2127530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127540 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2127543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127566 */     // GIR_Coverage, 17366,
     /* 2127566 */     GIR_EraseRootFromParent_Done,
     /* 2127567 */   // Label 28148: @2127567
     /* 2127567 */   GIM_Try, /*On fail goto*//*Label 28149*/ GIMT_Encode4(2127658), // Rule ID 17367 //
     /* 2127572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2127583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2127586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2127589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127618 */     // MIs[0] round
     /* 2127618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127621 */     // MIs[0] policy
     /* 2127621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127631 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2127634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127657 */     // GIR_Coverage, 17367,
     /* 2127657 */     GIR_EraseRootFromParent_Done,
     /* 2127658 */   // Label 28149: @2127658
     /* 2127658 */   GIM_Try, /*On fail goto*//*Label 28150*/ GIMT_Encode4(2127749), // Rule ID 17370 //
     /* 2127663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2127674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2127677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2127680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127709 */     // MIs[0] round
     /* 2127709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127712 */     // MIs[0] policy
     /* 2127712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127722 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2127725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127748 */     // GIR_Coverage, 17370,
     /* 2127748 */     GIR_EraseRootFromParent_Done,
     /* 2127749 */   // Label 28150: @2127749
     /* 2127749 */   GIM_Try, /*On fail goto*//*Label 28151*/ GIMT_Encode4(2127840), // Rule ID 17371 //
     /* 2127754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2127765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2127768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2127771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127800 */     // MIs[0] round
     /* 2127800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127803 */     // MIs[0] policy
     /* 2127803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127813 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2127816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127839 */     // GIR_Coverage, 17371,
     /* 2127839 */     GIR_EraseRootFromParent_Done,
     /* 2127840 */   // Label 28151: @2127840
     /* 2127840 */   GIM_Try, /*On fail goto*//*Label 28152*/ GIMT_Encode4(2127931), // Rule ID 17374 //
     /* 2127845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2127856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2127859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2127862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127891 */     // MIs[0] round
     /* 2127891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127894 */     // MIs[0] policy
     /* 2127894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127904 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2127907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127930 */     // GIR_Coverage, 17374,
     /* 2127930 */     GIR_EraseRootFromParent_Done,
     /* 2127931 */   // Label 28152: @2127931
     /* 2127931 */   GIM_Try, /*On fail goto*//*Label 28153*/ GIMT_Encode4(2128022), // Rule ID 17375 //
     /* 2127936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2127947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2127950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2127953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127982 */     // MIs[0] round
     /* 2127982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127985 */     // MIs[0] policy
     /* 2127985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127995 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2127998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128021 */     // GIR_Coverage, 17375,
     /* 2128021 */     GIR_EraseRootFromParent_Done,
     /* 2128022 */   // Label 28153: @2128022
     /* 2128022 */   GIM_Try, /*On fail goto*//*Label 28154*/ GIMT_Encode4(2128113), // Rule ID 17378 //
     /* 2128027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2128030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2128038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2128041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2128044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2128050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128073 */     // MIs[0] round
     /* 2128073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128076 */     // MIs[0] policy
     /* 2128076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128086 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2128089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128112 */     // GIR_Coverage, 17378,
     /* 2128112 */     GIR_EraseRootFromParent_Done,
     /* 2128113 */   // Label 28154: @2128113
     /* 2128113 */   GIM_Try, /*On fail goto*//*Label 28155*/ GIMT_Encode4(2128204), // Rule ID 17379 //
     /* 2128118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2128121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2128129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2128132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2128135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2128141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128164 */     // MIs[0] round
     /* 2128164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128167 */     // MIs[0] policy
     /* 2128167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128177 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2128180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128203 */     // GIR_Coverage, 17379,
     /* 2128203 */     GIR_EraseRootFromParent_Done,
     /* 2128204 */   // Label 28155: @2128204
     /* 2128204 */   GIM_Try, /*On fail goto*//*Label 28156*/ GIMT_Encode4(2128295), // Rule ID 17382 //
     /* 2128209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2128220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2128223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2128226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128255 */     // MIs[0] round
     /* 2128255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128258 */     // MIs[0] policy
     /* 2128258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128268 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2128271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128294 */     // GIR_Coverage, 17382,
     /* 2128294 */     GIR_EraseRootFromParent_Done,
     /* 2128295 */   // Label 28156: @2128295
     /* 2128295 */   GIM_Try, /*On fail goto*//*Label 28157*/ GIMT_Encode4(2128386), // Rule ID 17383 //
     /* 2128300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2128311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2128314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2128317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128346 */     // MIs[0] round
     /* 2128346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128349 */     // MIs[0] policy
     /* 2128349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128359 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2128362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128385 */     // GIR_Coverage, 17383,
     /* 2128385 */     GIR_EraseRootFromParent_Done,
     /* 2128386 */   // Label 28157: @2128386
     /* 2128386 */   GIM_Try, /*On fail goto*//*Label 28158*/ GIMT_Encode4(2128477), // Rule ID 17386 //
     /* 2128391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2128402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2128405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2128408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2128421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128437 */     // MIs[0] round
     /* 2128437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128440 */     // MIs[0] policy
     /* 2128440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128450 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2128453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128476 */     // GIR_Coverage, 17386,
     /* 2128476 */     GIR_EraseRootFromParent_Done,
     /* 2128477 */   // Label 28158: @2128477
     /* 2128477 */   GIM_Try, /*On fail goto*//*Label 28159*/ GIMT_Encode4(2128568), // Rule ID 17387 //
     /* 2128482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2128493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2128496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2128499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128505 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2128512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128528 */     // MIs[0] round
     /* 2128528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128531 */     // MIs[0] policy
     /* 2128531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128541 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2128544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128564 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128567 */     // GIR_Coverage, 17387,
     /* 2128567 */     GIR_EraseRootFromParent_Done,
     /* 2128568 */   // Label 28159: @2128568
     /* 2128568 */   GIM_Try, /*On fail goto*//*Label 28160*/ GIMT_Encode4(2128659), // Rule ID 17390 //
     /* 2128573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2128584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2128587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2128590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128619 */     // MIs[0] round
     /* 2128619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128622 */     // MIs[0] policy
     /* 2128622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128632 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2128635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128658 */     // GIR_Coverage, 17390,
     /* 2128658 */     GIR_EraseRootFromParent_Done,
     /* 2128659 */   // Label 28160: @2128659
     /* 2128659 */   GIM_Try, /*On fail goto*//*Label 28161*/ GIMT_Encode4(2128750), // Rule ID 17391 //
     /* 2128664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2128675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2128678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2128681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128687 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128710 */     // MIs[0] round
     /* 2128710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128713 */     // MIs[0] policy
     /* 2128713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128723 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2128726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128749 */     // GIR_Coverage, 17391,
     /* 2128749 */     GIR_EraseRootFromParent_Done,
     /* 2128750 */   // Label 28161: @2128750
     /* 2128750 */   GIM_Try, /*On fail goto*//*Label 28162*/ GIMT_Encode4(2128841), // Rule ID 17394 //
     /* 2128755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2128766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2128769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2128772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128801 */     // MIs[0] round
     /* 2128801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128804 */     // MIs[0] policy
     /* 2128804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128814 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2128817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128840 */     // GIR_Coverage, 17394,
     /* 2128840 */     GIR_EraseRootFromParent_Done,
     /* 2128841 */   // Label 28162: @2128841
     /* 2128841 */   GIM_Try, /*On fail goto*//*Label 28163*/ GIMT_Encode4(2128932), // Rule ID 17395 //
     /* 2128846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2128857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2128860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2128863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128892 */     // MIs[0] round
     /* 2128892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128895 */     // MIs[0] policy
     /* 2128895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128905 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2128908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128931 */     // GIR_Coverage, 17395,
     /* 2128931 */     GIR_EraseRootFromParent_Done,
     /* 2128932 */   // Label 28163: @2128932
     /* 2128932 */   GIM_Try, /*On fail goto*//*Label 28164*/ GIMT_Encode4(2129023), // Rule ID 17398 //
     /* 2128937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2128940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2128948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2128951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2128954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2128957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128983 */     // MIs[0] round
     /* 2128983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128986 */     // MIs[0] policy
     /* 2128986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128996 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2128999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129022 */     // GIR_Coverage, 17398,
     /* 2129022 */     GIR_EraseRootFromParent_Done,
     /* 2129023 */   // Label 28164: @2129023
     /* 2129023 */   GIM_Try, /*On fail goto*//*Label 28165*/ GIMT_Encode4(2129114), // Rule ID 17399 //
     /* 2129028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2129039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2129042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2129045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2129048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129074 */     // MIs[0] round
     /* 2129074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129077 */     // MIs[0] policy
     /* 2129077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129087 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2129090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129100 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129110 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129113 */     // GIR_Coverage, 17399,
     /* 2129113 */     GIR_EraseRootFromParent_Done,
     /* 2129114 */   // Label 28165: @2129114
     /* 2129114 */   GIM_Try, /*On fail goto*//*Label 28166*/ GIMT_Encode4(2129205), // Rule ID 17402 //
     /* 2129119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2129130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2129133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2129136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2129139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129165 */     // MIs[0] round
     /* 2129165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129168 */     // MIs[0] policy
     /* 2129168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129178 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2129181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129204 */     // GIR_Coverage, 17402,
     /* 2129204 */     GIR_EraseRootFromParent_Done,
     /* 2129205 */   // Label 28166: @2129205
     /* 2129205 */   GIM_Try, /*On fail goto*//*Label 28167*/ GIMT_Encode4(2129296), // Rule ID 17403 //
     /* 2129210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2129221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2129224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2129227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2129230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129256 */     // MIs[0] round
     /* 2129256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129259 */     // MIs[0] policy
     /* 2129259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129269 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2129272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129292 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129295 */     // GIR_Coverage, 17403,
     /* 2129295 */     GIR_EraseRootFromParent_Done,
     /* 2129296 */   // Label 28167: @2129296
     /* 2129296 */   GIM_Try, /*On fail goto*//*Label 28168*/ GIMT_Encode4(2129387), // Rule ID 17406 //
     /* 2129301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2129304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2129312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2129315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2129318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2129321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129347 */     // MIs[0] round
     /* 2129347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129350 */     // MIs[0] policy
     /* 2129350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129360 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2129363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129386 */     // GIR_Coverage, 17406,
     /* 2129386 */     GIR_EraseRootFromParent_Done,
     /* 2129387 */   // Label 28168: @2129387
     /* 2129387 */   GIM_Try, /*On fail goto*//*Label 28169*/ GIMT_Encode4(2129478), // Rule ID 17407 //
     /* 2129392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2129395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2129403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2129406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2129409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2129412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129438 */     // MIs[0] round
     /* 2129438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129441 */     // MIs[0] policy
     /* 2129441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129451 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2129454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129477 */     // GIR_Coverage, 17407,
     /* 2129477 */     GIR_EraseRootFromParent_Done,
     /* 2129478 */   // Label 28169: @2129478
     /* 2129478 */   GIM_Try, /*On fail goto*//*Label 28170*/ GIMT_Encode4(2129569), // Rule ID 17410 //
     /* 2129483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2129494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2129497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2129500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2129503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129529 */     // MIs[0] round
     /* 2129529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129532 */     // MIs[0] policy
     /* 2129532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129542 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2129545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129568 */     // GIR_Coverage, 17410,
     /* 2129568 */     GIR_EraseRootFromParent_Done,
     /* 2129569 */   // Label 28170: @2129569
     /* 2129569 */   GIM_Try, /*On fail goto*//*Label 28171*/ GIMT_Encode4(2129660), // Rule ID 17411 //
     /* 2129574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2129585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2129588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2129591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2129594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129620 */     // MIs[0] round
     /* 2129620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129623 */     // MIs[0] policy
     /* 2129623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129633 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2129636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129659 */     // GIR_Coverage, 17411,
     /* 2129659 */     GIR_EraseRootFromParent_Done,
     /* 2129660 */   // Label 28171: @2129660
     /* 2129660 */   GIM_Try, /*On fail goto*//*Label 28172*/ GIMT_Encode4(2129751), // Rule ID 17414 //
     /* 2129665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2129668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2129676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2129679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2129682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2129685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129711 */     // MIs[0] round
     /* 2129711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129714 */     // MIs[0] policy
     /* 2129714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129724 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2129727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129750 */     // GIR_Coverage, 17414,
     /* 2129750 */     GIR_EraseRootFromParent_Done,
     /* 2129751 */   // Label 28172: @2129751
     /* 2129751 */   GIM_Try, /*On fail goto*//*Label 28173*/ GIMT_Encode4(2129842), // Rule ID 17415 //
     /* 2129756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2129759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2129767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2129770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2129773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2129776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129779 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129802 */     // MIs[0] round
     /* 2129802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129805 */     // MIs[0] policy
     /* 2129805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129815 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2129818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129841 */     // GIR_Coverage, 17415,
     /* 2129841 */     GIR_EraseRootFromParent_Done,
     /* 2129842 */   // Label 28173: @2129842
     /* 2129842 */   GIM_Try, /*On fail goto*//*Label 28174*/ GIMT_Encode4(2129933), // Rule ID 17418 //
     /* 2129847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2129850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2129858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2129861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2129864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2129867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129893 */     // MIs[0] round
     /* 2129893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129896 */     // MIs[0] policy
     /* 2129896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129906 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2129909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129932 */     // GIR_Coverage, 17418,
     /* 2129932 */     GIR_EraseRootFromParent_Done,
     /* 2129933 */   // Label 28174: @2129933
     /* 2129933 */   GIM_Try, /*On fail goto*//*Label 28175*/ GIMT_Encode4(2130024), // Rule ID 17419 //
     /* 2129938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2129941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2129949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2129952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2129955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2129958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129961 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129984 */     // MIs[0] round
     /* 2129984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129987 */     // MIs[0] policy
     /* 2129987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129997 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2130000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130023 */     // GIR_Coverage, 17419,
     /* 2130023 */     GIR_EraseRootFromParent_Done,
     /* 2130024 */   // Label 28175: @2130024
     /* 2130024 */   GIM_Try, /*On fail goto*//*Label 28176*/ GIMT_Encode4(2130115), // Rule ID 17422 //
     /* 2130029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2130032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2130040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2130043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2130046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2130049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130075 */     // MIs[0] round
     /* 2130075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130078 */     // MIs[0] policy
     /* 2130078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130088 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2130091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130114 */     // GIR_Coverage, 17422,
     /* 2130114 */     GIR_EraseRootFromParent_Done,
     /* 2130115 */   // Label 28176: @2130115
     /* 2130115 */   GIM_Try, /*On fail goto*//*Label 28177*/ GIMT_Encode4(2130206), // Rule ID 17423 //
     /* 2130120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2130123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2130131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2130134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2130137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2130140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130143 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130166 */     // MIs[0] round
     /* 2130166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130169 */     // MIs[0] policy
     /* 2130169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130179 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2130182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130205 */     // GIR_Coverage, 17423,
     /* 2130205 */     GIR_EraseRootFromParent_Done,
     /* 2130206 */   // Label 28177: @2130206
     /* 2130206 */   GIM_Try, /*On fail goto*//*Label 28178*/ GIMT_Encode4(2130297), // Rule ID 17426 //
     /* 2130211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2130214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2130222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2130225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2130228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2130231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2130234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130257 */     // MIs[0] round
     /* 2130257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130260 */     // MIs[0] policy
     /* 2130260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130270 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2130273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130296 */     // GIR_Coverage, 17426,
     /* 2130296 */     GIR_EraseRootFromParent_Done,
     /* 2130297 */   // Label 28178: @2130297
     /* 2130297 */   GIM_Try, /*On fail goto*//*Label 28179*/ GIMT_Encode4(2130388), // Rule ID 17427 //
     /* 2130302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2130305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2130313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2130316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2130319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2130322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2130325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130348 */     // MIs[0] round
     /* 2130348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130351 */     // MIs[0] policy
     /* 2130351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130361 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2130364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130387 */     // GIR_Coverage, 17427,
     /* 2130387 */     GIR_EraseRootFromParent_Done,
     /* 2130388 */   // Label 28179: @2130388
     /* 2130388 */   GIM_Try, /*On fail goto*//*Label 28180*/ GIMT_Encode4(2130479), // Rule ID 17430 //
     /* 2130393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2130396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2130404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2130407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2130410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2130413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2130416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130439 */     // MIs[0] round
     /* 2130439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130442 */     // MIs[0] policy
     /* 2130442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130452 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2130455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130478 */     // GIR_Coverage, 17430,
     /* 2130478 */     GIR_EraseRootFromParent_Done,
     /* 2130479 */   // Label 28180: @2130479
     /* 2130479 */   GIM_Try, /*On fail goto*//*Label 28181*/ GIMT_Encode4(2130570), // Rule ID 17431 //
     /* 2130484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2130487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2130495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2130498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2130501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2130504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2130507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130530 */     // MIs[0] round
     /* 2130530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130533 */     // MIs[0] policy
     /* 2130533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130543 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2130546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130569 */     // GIR_Coverage, 17431,
     /* 2130569 */     GIR_EraseRootFromParent_Done,
     /* 2130570 */   // Label 28181: @2130570
     /* 2130570 */   GIM_Try, /*On fail goto*//*Label 28182*/ GIMT_Encode4(2130661), // Rule ID 17434 //
     /* 2130575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2130586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2130589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2130592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2130595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130621 */     // MIs[0] round
     /* 2130621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130624 */     // MIs[0] policy
     /* 2130624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130634 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2130637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130660 */     // GIR_Coverage, 17434,
     /* 2130660 */     GIR_EraseRootFromParent_Done,
     /* 2130661 */   // Label 28182: @2130661
     /* 2130661 */   GIM_Try, /*On fail goto*//*Label 28183*/ GIMT_Encode4(2130752), // Rule ID 17435 //
     /* 2130666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2130677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2130680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2130683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2130686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130712 */     // MIs[0] round
     /* 2130712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130715 */     // MIs[0] policy
     /* 2130715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130725 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2130728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130751 */     // GIR_Coverage, 17435,
     /* 2130751 */     GIR_EraseRootFromParent_Done,
     /* 2130752 */   // Label 28183: @2130752
     /* 2130752 */   GIM_Try, /*On fail goto*//*Label 28184*/ GIMT_Encode4(2130843), // Rule ID 17438 //
     /* 2130757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2130768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2130771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2130774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2130777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130803 */     // MIs[0] round
     /* 2130803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130806 */     // MIs[0] policy
     /* 2130806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130816 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2130819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130842 */     // GIR_Coverage, 17438,
     /* 2130842 */     GIR_EraseRootFromParent_Done,
     /* 2130843 */   // Label 28184: @2130843
     /* 2130843 */   GIM_Try, /*On fail goto*//*Label 28185*/ GIMT_Encode4(2130934), // Rule ID 17439 //
     /* 2130848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2130859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2130862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2130865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2130868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130894 */     // MIs[0] round
     /* 2130894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130897 */     // MIs[0] policy
     /* 2130897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130907 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2130910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130933 */     // GIR_Coverage, 17439,
     /* 2130933 */     GIR_EraseRootFromParent_Done,
     /* 2130934 */   // Label 28185: @2130934
     /* 2130934 */   GIM_Try, /*On fail goto*//*Label 28186*/ GIMT_Encode4(2131025), // Rule ID 17442 //
     /* 2130939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2130950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2130953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2130956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2130959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2130962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130985 */     // MIs[0] round
     /* 2130985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130988 */     // MIs[0] policy
     /* 2130988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130998 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2131001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131024 */     // GIR_Coverage, 17442,
     /* 2131024 */     GIR_EraseRootFromParent_Done,
     /* 2131025 */   // Label 28186: @2131025
     /* 2131025 */   GIM_Try, /*On fail goto*//*Label 28187*/ GIMT_Encode4(2131116), // Rule ID 17443 //
     /* 2131030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2131033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2131041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2131044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2131047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2131050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2131053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131076 */     // MIs[0] round
     /* 2131076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131079 */     // MIs[0] policy
     /* 2131079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131089 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2131092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131115 */     // GIR_Coverage, 17443,
     /* 2131115 */     GIR_EraseRootFromParent_Done,
     /* 2131116 */   // Label 28187: @2131116
     /* 2131116 */   GIM_Try, /*On fail goto*//*Label 28188*/ GIMT_Encode4(2131207), // Rule ID 17446 //
     /* 2131121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2131124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2131132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2131135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2131138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2131141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131167 */     // MIs[0] round
     /* 2131167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131170 */     // MIs[0] policy
     /* 2131170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131180 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2131183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131206 */     // GIR_Coverage, 17446,
     /* 2131206 */     GIR_EraseRootFromParent_Done,
     /* 2131207 */   // Label 28188: @2131207
     /* 2131207 */   GIM_Try, /*On fail goto*//*Label 28189*/ GIMT_Encode4(2131298), // Rule ID 17447 //
     /* 2131212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2131215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2131223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2131226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2131229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2131232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131258 */     // MIs[0] round
     /* 2131258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131261 */     // MIs[0] policy
     /* 2131261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131271 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2131274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131297 */     // GIR_Coverage, 17447,
     /* 2131297 */     GIR_EraseRootFromParent_Done,
     /* 2131298 */   // Label 28189: @2131298
     /* 2131298 */   GIM_Try, /*On fail goto*//*Label 28190*/ GIMT_Encode4(2131389), // Rule ID 17450 //
     /* 2131303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2131306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2131314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2131317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2131320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2131323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131349 */     // MIs[0] round
     /* 2131349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131352 */     // MIs[0] policy
     /* 2131352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131362 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2131365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131388 */     // GIR_Coverage, 17450,
     /* 2131388 */     GIR_EraseRootFromParent_Done,
     /* 2131389 */   // Label 28190: @2131389
     /* 2131389 */   GIM_Try, /*On fail goto*//*Label 28191*/ GIMT_Encode4(2131480), // Rule ID 17451 //
     /* 2131394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2131397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2131405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2131408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2131411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2131414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131440 */     // MIs[0] round
     /* 2131440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131443 */     // MIs[0] policy
     /* 2131443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131453 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2131456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131479 */     // GIR_Coverage, 17451,
     /* 2131479 */     GIR_EraseRootFromParent_Done,
     /* 2131480 */   // Label 28191: @2131480
     /* 2131480 */   GIM_Try, /*On fail goto*//*Label 28192*/ GIMT_Encode4(2131571), // Rule ID 17454 //
     /* 2131485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2131488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2131496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2131499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2131502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2131505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131531 */     // MIs[0] round
     /* 2131531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131534 */     // MIs[0] policy
     /* 2131534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131544 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2131547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131570 */     // GIR_Coverage, 17454,
     /* 2131570 */     GIR_EraseRootFromParent_Done,
     /* 2131571 */   // Label 28192: @2131571
     /* 2131571 */   GIM_Try, /*On fail goto*//*Label 28193*/ GIMT_Encode4(2131662), // Rule ID 17455 //
     /* 2131576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2131579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2131587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2131590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2131593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2131596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131622 */     // MIs[0] round
     /* 2131622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131625 */     // MIs[0] policy
     /* 2131625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131635 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2131638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131661 */     // GIR_Coverage, 17455,
     /* 2131661 */     GIR_EraseRootFromParent_Done,
     /* 2131662 */   // Label 28193: @2131662
     /* 2131662 */   GIM_Try, /*On fail goto*//*Label 28194*/ GIMT_Encode4(2131753), // Rule ID 17458 //
     /* 2131667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2131670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2131678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2131681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2131684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131713 */     // MIs[0] round
     /* 2131713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131716 */     // MIs[0] policy
     /* 2131716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131726 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2131729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131752 */     // GIR_Coverage, 17458,
     /* 2131752 */     GIR_EraseRootFromParent_Done,
     /* 2131753 */   // Label 28194: @2131753
     /* 2131753 */   GIM_Try, /*On fail goto*//*Label 28195*/ GIMT_Encode4(2131844), // Rule ID 17459 //
     /* 2131758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2131761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2131769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2131772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2131775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131804 */     // MIs[0] round
     /* 2131804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131807 */     // MIs[0] policy
     /* 2131807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131817 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2131820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131843 */     // GIR_Coverage, 17459,
     /* 2131843 */     GIR_EraseRootFromParent_Done,
     /* 2131844 */   // Label 28195: @2131844
     /* 2131844 */   GIM_Try, /*On fail goto*//*Label 28196*/ GIMT_Encode4(2131935), // Rule ID 17462 //
     /* 2131849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2131852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2131860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2131863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2131866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131895 */     // MIs[0] round
     /* 2131895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131898 */     // MIs[0] policy
     /* 2131898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131908 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2131911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131934 */     // GIR_Coverage, 17462,
     /* 2131934 */     GIR_EraseRootFromParent_Done,
     /* 2131935 */   // Label 28196: @2131935
     /* 2131935 */   GIM_Try, /*On fail goto*//*Label 28197*/ GIMT_Encode4(2132026), // Rule ID 17463 //
     /* 2131940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2131943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2131951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2131954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2131957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131986 */     // MIs[0] round
     /* 2131986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131989 */     // MIs[0] policy
     /* 2131989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131999 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2132002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132025 */     // GIR_Coverage, 17463,
     /* 2132025 */     GIR_EraseRootFromParent_Done,
     /* 2132026 */   // Label 28197: @2132026
     /* 2132026 */   GIM_Try, /*On fail goto*//*Label 28198*/ GIMT_Encode4(2132117), // Rule ID 17466 //
     /* 2132031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2132034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2132042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132077 */     // MIs[0] round
     /* 2132077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132080 */     // MIs[0] policy
     /* 2132080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132090 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2132093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132116 */     // GIR_Coverage, 17466,
     /* 2132116 */     GIR_EraseRootFromParent_Done,
     /* 2132117 */   // Label 28198: @2132117
     /* 2132117 */   GIM_Try, /*On fail goto*//*Label 28199*/ GIMT_Encode4(2132208), // Rule ID 17467 //
     /* 2132122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2132125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2132133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132168 */     // MIs[0] round
     /* 2132168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132171 */     // MIs[0] policy
     /* 2132171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132181 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2132184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132207 */     // GIR_Coverage, 17467,
     /* 2132207 */     GIR_EraseRootFromParent_Done,
     /* 2132208 */   // Label 28199: @2132208
     /* 2132208 */   GIM_Try, /*On fail goto*//*Label 28200*/ GIMT_Encode4(2132299), // Rule ID 17470 //
     /* 2132213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2132224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2132227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2132230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132259 */     // MIs[0] round
     /* 2132259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132262 */     // MIs[0] policy
     /* 2132262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132272 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2132275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132298 */     // GIR_Coverage, 17470,
     /* 2132298 */     GIR_EraseRootFromParent_Done,
     /* 2132299 */   // Label 28200: @2132299
     /* 2132299 */   GIM_Try, /*On fail goto*//*Label 28201*/ GIMT_Encode4(2132390), // Rule ID 17471 //
     /* 2132304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2132315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2132318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2132321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132350 */     // MIs[0] round
     /* 2132350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132353 */     // MIs[0] policy
     /* 2132353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132363 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2132366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132389 */     // GIR_Coverage, 17471,
     /* 2132389 */     GIR_EraseRootFromParent_Done,
     /* 2132390 */   // Label 28201: @2132390
     /* 2132390 */   GIM_Try, /*On fail goto*//*Label 28202*/ GIMT_Encode4(2132481), // Rule ID 17474 //
     /* 2132395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2132398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2132406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2132409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2132412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132441 */     // MIs[0] round
     /* 2132441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132444 */     // MIs[0] policy
     /* 2132444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2132457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132480 */     // GIR_Coverage, 17474,
     /* 2132480 */     GIR_EraseRootFromParent_Done,
     /* 2132481 */   // Label 28202: @2132481
     /* 2132481 */   GIM_Try, /*On fail goto*//*Label 28203*/ GIMT_Encode4(2132572), // Rule ID 17475 //
     /* 2132486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2132489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2132497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2132500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2132503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132532 */     // MIs[0] round
     /* 2132532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132535 */     // MIs[0] policy
     /* 2132535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132545 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2132548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132571 */     // GIR_Coverage, 17475,
     /* 2132571 */     GIR_EraseRootFromParent_Done,
     /* 2132572 */   // Label 28203: @2132572
     /* 2132572 */   GIM_Try, /*On fail goto*//*Label 28204*/ GIMT_Encode4(2132663), // Rule ID 17478 //
     /* 2132577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2132580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2132588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132623 */     // MIs[0] round
     /* 2132623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132626 */     // MIs[0] policy
     /* 2132626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132636 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2132639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132662 */     // GIR_Coverage, 17478,
     /* 2132662 */     GIR_EraseRootFromParent_Done,
     /* 2132663 */   // Label 28204: @2132663
     /* 2132663 */   GIM_Try, /*On fail goto*//*Label 28205*/ GIMT_Encode4(2132754), // Rule ID 17479 //
     /* 2132668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2132671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2132679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132714 */     // MIs[0] round
     /* 2132714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132717 */     // MIs[0] policy
     /* 2132717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132727 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2132730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132753 */     // GIR_Coverage, 17479,
     /* 2132753 */     GIR_EraseRootFromParent_Done,
     /* 2132754 */   // Label 28205: @2132754
     /* 2132754 */   GIM_Try, /*On fail goto*//*Label 28206*/ GIMT_Encode4(2132845), // Rule ID 17482 //
     /* 2132759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2132770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2132773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2132776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132805 */     // MIs[0] round
     /* 2132805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132808 */     // MIs[0] policy
     /* 2132808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132818 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2132821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132844 */     // GIR_Coverage, 17482,
     /* 2132844 */     GIR_EraseRootFromParent_Done,
     /* 2132845 */   // Label 28206: @2132845
     /* 2132845 */   GIM_Try, /*On fail goto*//*Label 28207*/ GIMT_Encode4(2132936), // Rule ID 17483 //
     /* 2132850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2132861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2132864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2132867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132896 */     // MIs[0] round
     /* 2132896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132899 */     // MIs[0] policy
     /* 2132899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132909 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2132912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132935 */     // GIR_Coverage, 17483,
     /* 2132935 */     GIR_EraseRootFromParent_Done,
     /* 2132936 */   // Label 28207: @2132936
     /* 2132936 */   GIM_Try, /*On fail goto*//*Label 28208*/ GIMT_Encode4(2133027), // Rule ID 17486 //
     /* 2132941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2132952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2132955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2132958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2132964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2132971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132987 */     // MIs[0] round
     /* 2132987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132990 */     // MIs[0] policy
     /* 2132990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133000 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2133003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133026 */     // GIR_Coverage, 17486,
     /* 2133026 */     GIR_EraseRootFromParent_Done,
     /* 2133027 */   // Label 28208: @2133027
     /* 2133027 */   GIM_Try, /*On fail goto*//*Label 28209*/ GIMT_Encode4(2133118), // Rule ID 17487 //
     /* 2133032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2133035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2133043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2133046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2133049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133078 */     // MIs[0] round
     /* 2133078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133081 */     // MIs[0] policy
     /* 2133081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133091 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2133094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133117 */     // GIR_Coverage, 17487,
     /* 2133117 */     GIR_EraseRootFromParent_Done,
     /* 2133118 */   // Label 28209: @2133118
     /* 2133118 */   GIM_Try, /*On fail goto*//*Label 28210*/ GIMT_Encode4(2133209), // Rule ID 17490 //
     /* 2133123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2133126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2133134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2133137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2133140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2133146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133169 */     // MIs[0] round
     /* 2133169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133172 */     // MIs[0] policy
     /* 2133172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133182 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2133185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133208 */     // GIR_Coverage, 17490,
     /* 2133208 */     GIR_EraseRootFromParent_Done,
     /* 2133209 */   // Label 28210: @2133209
     /* 2133209 */   GIM_Try, /*On fail goto*//*Label 28211*/ GIMT_Encode4(2133300), // Rule ID 17491 //
     /* 2133214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2133217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2133225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2133228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2133231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2133237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133260 */     // MIs[0] round
     /* 2133260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133263 */     // MIs[0] policy
     /* 2133263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133273 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2133276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133299 */     // GIR_Coverage, 17491,
     /* 2133299 */     GIR_EraseRootFromParent_Done,
     /* 2133300 */   // Label 28211: @2133300
     /* 2133300 */   GIM_Try, /*On fail goto*//*Label 28212*/ GIMT_Encode4(2133391), // Rule ID 17494 //
     /* 2133305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2133316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2133319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2133322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133351 */     // MIs[0] round
     /* 2133351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133354 */     // MIs[0] policy
     /* 2133354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133364 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2133367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133390 */     // GIR_Coverage, 17494,
     /* 2133390 */     GIR_EraseRootFromParent_Done,
     /* 2133391 */   // Label 28212: @2133391
     /* 2133391 */   GIM_Try, /*On fail goto*//*Label 28213*/ GIMT_Encode4(2133482), // Rule ID 17495 //
     /* 2133396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2133399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2133407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2133410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2133413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133442 */     // MIs[0] round
     /* 2133442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133445 */     // MIs[0] policy
     /* 2133445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133455 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2133458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133481 */     // GIR_Coverage, 17495,
     /* 2133481 */     GIR_EraseRootFromParent_Done,
     /* 2133482 */   // Label 28213: @2133482
     /* 2133482 */   GIM_Try, /*On fail goto*//*Label 28214*/ GIMT_Encode4(2133573), // Rule ID 17498 //
     /* 2133487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2133498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2133501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2133504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133533 */     // MIs[0] round
     /* 2133533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133536 */     // MIs[0] policy
     /* 2133536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133546 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2133549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133572 */     // GIR_Coverage, 17498,
     /* 2133572 */     GIR_EraseRootFromParent_Done,
     /* 2133573 */   // Label 28214: @2133573
     /* 2133573 */   GIM_Try, /*On fail goto*//*Label 28215*/ GIMT_Encode4(2133664), // Rule ID 17499 //
     /* 2133578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2133581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2133589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2133592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2133595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133624 */     // MIs[0] round
     /* 2133624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133627 */     // MIs[0] policy
     /* 2133627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133637 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2133640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133663 */     // GIR_Coverage, 17499,
     /* 2133663 */     GIR_EraseRootFromParent_Done,
     /* 2133664 */   // Label 28215: @2133664
     /* 2133664 */   GIM_Try, /*On fail goto*//*Label 28216*/ GIMT_Encode4(2133755), // Rule ID 17502 //
     /* 2133669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2133680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2133683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2133686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133715 */     // MIs[0] round
     /* 2133715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133718 */     // MIs[0] policy
     /* 2133718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133728 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2133731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133754 */     // GIR_Coverage, 17502,
     /* 2133754 */     GIR_EraseRootFromParent_Done,
     /* 2133755 */   // Label 28216: @2133755
     /* 2133755 */   GIM_Try, /*On fail goto*//*Label 28217*/ GIMT_Encode4(2133846), // Rule ID 17503 //
     /* 2133760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2133763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2133771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2133774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2133777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133806 */     // MIs[0] round
     /* 2133806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133809 */     // MIs[0] policy
     /* 2133809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133819 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2133822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133845 */     // GIR_Coverage, 17503,
     /* 2133845 */     GIR_EraseRootFromParent_Done,
     /* 2133846 */   // Label 28217: @2133846
     /* 2133846 */   GIM_Try, /*On fail goto*//*Label 28218*/ GIMT_Encode4(2133937), // Rule ID 17506 //
     /* 2133851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2133854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2133862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2133865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2133868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133897 */     // MIs[0] round
     /* 2133897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133900 */     // MIs[0] policy
     /* 2133900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133910 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2133913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133936 */     // GIR_Coverage, 17506,
     /* 2133936 */     GIR_EraseRootFromParent_Done,
     /* 2133937 */   // Label 28218: @2133937
     /* 2133937 */   GIM_Try, /*On fail goto*//*Label 28219*/ GIMT_Encode4(2134028), // Rule ID 17507 //
     /* 2133942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2133945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2133953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2133956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2133959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133988 */     // MIs[0] round
     /* 2133988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133991 */     // MIs[0] policy
     /* 2133991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134001 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2134004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134027 */     // GIR_Coverage, 17507,
     /* 2134027 */     GIR_EraseRootFromParent_Done,
     /* 2134028 */   // Label 28219: @2134028
     /* 2134028 */   GIM_Try, /*On fail goto*//*Label 28220*/ GIMT_Encode4(2134119), // Rule ID 17510 //
     /* 2134033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2134036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2134044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2134047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2134050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2134053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2134063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2134075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134079 */     // MIs[0] round
     /* 2134079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134082 */     // MIs[0] policy
     /* 2134082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134092 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2134095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134118 */     // GIR_Coverage, 17510,
     /* 2134118 */     GIR_EraseRootFromParent_Done,
     /* 2134119 */   // Label 28220: @2134119
     /* 2134119 */   GIM_Try, /*On fail goto*//*Label 28221*/ GIMT_Encode4(2134210), // Rule ID 17511 //
     /* 2134124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2134127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2134135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2134138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2134141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2134144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2134154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2134166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134170 */     // MIs[0] round
     /* 2134170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134173 */     // MIs[0] policy
     /* 2134173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134183 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2134186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134209 */     // GIR_Coverage, 17511,
     /* 2134209 */     GIR_EraseRootFromParent_Done,
     /* 2134210 */   // Label 28221: @2134210
     /* 2134210 */   GIM_Try, /*On fail goto*//*Label 28222*/ GIMT_Encode4(2134301), // Rule ID 17514 //
     /* 2134215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2134218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2134226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2134229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2134232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2134235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2134238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2134257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134261 */     // MIs[0] round
     /* 2134261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134264 */     // MIs[0] policy
     /* 2134264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134274 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2134277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134300 */     // GIR_Coverage, 17514,
     /* 2134300 */     GIR_EraseRootFromParent_Done,
     /* 2134301 */   // Label 28222: @2134301
     /* 2134301 */   GIM_Try, /*On fail goto*//*Label 28223*/ GIMT_Encode4(2134392), // Rule ID 17515 //
     /* 2134306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2134309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2134317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2134320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2134323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2134326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2134329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2134348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134352 */     // MIs[0] round
     /* 2134352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134355 */     // MIs[0] policy
     /* 2134355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134365 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2134368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134391 */     // GIR_Coverage, 17515,
     /* 2134391 */     GIR_EraseRootFromParent_Done,
     /* 2134392 */   // Label 28223: @2134392
     /* 2134392 */   GIM_Try, /*On fail goto*//*Label 28224*/ GIMT_Encode4(2134483), // Rule ID 17518 //
     /* 2134397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2134400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2134408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2134411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2134414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2134417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134443 */     // MIs[0] round
     /* 2134443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134446 */     // MIs[0] policy
     /* 2134446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134456 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2134459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134482 */     // GIR_Coverage, 17518,
     /* 2134482 */     GIR_EraseRootFromParent_Done,
     /* 2134483 */   // Label 28224: @2134483
     /* 2134483 */   GIM_Try, /*On fail goto*//*Label 28225*/ GIMT_Encode4(2134574), // Rule ID 17519 //
     /* 2134488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2134499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2134502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2134505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2134508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134534 */     // MIs[0] round
     /* 2134534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134537 */     // MIs[0] policy
     /* 2134537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134547 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2134550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134573 */     // GIR_Coverage, 17519,
     /* 2134573 */     GIR_EraseRootFromParent_Done,
     /* 2134574 */   // Label 28225: @2134574
     /* 2134574 */   GIM_Try, /*On fail goto*//*Label 28226*/ GIMT_Encode4(2134665), // Rule ID 17522 //
     /* 2134579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2134582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2134590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2134593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2134596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2134599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134625 */     // MIs[0] round
     /* 2134625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134628 */     // MIs[0] policy
     /* 2134628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134638 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2134641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134664 */     // GIR_Coverage, 17522,
     /* 2134664 */     GIR_EraseRootFromParent_Done,
     /* 2134665 */   // Label 28226: @2134665
     /* 2134665 */   GIM_Try, /*On fail goto*//*Label 28227*/ GIMT_Encode4(2134756), // Rule ID 17523 //
     /* 2134670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2134681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2134684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2134687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2134690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134716 */     // MIs[0] round
     /* 2134716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134719 */     // MIs[0] policy
     /* 2134719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134729 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2134732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134755 */     // GIR_Coverage, 17523,
     /* 2134755 */     GIR_EraseRootFromParent_Done,
     /* 2134756 */   // Label 28227: @2134756
     /* 2134756 */   GIM_Try, /*On fail goto*//*Label 28228*/ GIMT_Encode4(2134847), // Rule ID 17526 //
     /* 2134761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2134772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2134781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134807 */     // MIs[0] round
     /* 2134807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134810 */     // MIs[0] policy
     /* 2134810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134820 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2134823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134846 */     // GIR_Coverage, 17526,
     /* 2134846 */     GIR_EraseRootFromParent_Done,
     /* 2134847 */   // Label 28228: @2134847
     /* 2134847 */   GIM_Try, /*On fail goto*//*Label 28229*/ GIMT_Encode4(2134938), // Rule ID 17527 //
     /* 2134852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2134863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2134872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134898 */     // MIs[0] round
     /* 2134898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134901 */     // MIs[0] policy
     /* 2134901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134911 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2134914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134937 */     // GIR_Coverage, 17527,
     /* 2134937 */     GIR_EraseRootFromParent_Done,
     /* 2134938 */   // Label 28229: @2134938
     /* 2134938 */   GIM_Try, /*On fail goto*//*Label 28230*/ GIMT_Encode4(2135029), // Rule ID 17530 //
     /* 2134943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2134946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2134954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2134957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2134960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2134963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134989 */     // MIs[0] round
     /* 2134989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134992 */     // MIs[0] policy
     /* 2134992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135002 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2135005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135028 */     // GIR_Coverage, 17530,
     /* 2135028 */     GIR_EraseRootFromParent_Done,
     /* 2135029 */   // Label 28230: @2135029
     /* 2135029 */   GIM_Try, /*On fail goto*//*Label 28231*/ GIMT_Encode4(2135120), // Rule ID 17531 //
     /* 2135034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2135045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2135048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2135051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2135054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2135057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135080 */     // MIs[0] round
     /* 2135080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135083 */     // MIs[0] policy
     /* 2135083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135093 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2135096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135119 */     // GIR_Coverage, 17531,
     /* 2135119 */     GIR_EraseRootFromParent_Done,
     /* 2135120 */   // Label 28231: @2135120
     /* 2135120 */   GIM_Try, /*On fail goto*//*Label 28232*/ GIMT_Encode4(2135211), // Rule ID 17534 //
     /* 2135125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2135136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2135139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2135142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2135145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2135148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135171 */     // MIs[0] round
     /* 2135171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135174 */     // MIs[0] policy
     /* 2135174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135184 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2135187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135210 */     // GIR_Coverage, 17534,
     /* 2135210 */     GIR_EraseRootFromParent_Done,
     /* 2135211 */   // Label 28232: @2135211
     /* 2135211 */   GIM_Try, /*On fail goto*//*Label 28233*/ GIMT_Encode4(2135302), // Rule ID 17535 //
     /* 2135216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2135219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2135227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2135230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2135233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2135236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2135239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135262 */     // MIs[0] round
     /* 2135262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135265 */     // MIs[0] policy
     /* 2135265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135275 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2135278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135301 */     // GIR_Coverage, 17535,
     /* 2135301 */     GIR_EraseRootFromParent_Done,
     /* 2135302 */   // Label 28233: @2135302
     /* 2135302 */   GIM_Try, /*On fail goto*//*Label 28234*/ GIMT_Encode4(2135393), // Rule ID 17538 //
     /* 2135307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2135310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2135318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2135321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2135324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2135327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2135330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135353 */     // MIs[0] round
     /* 2135353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135356 */     // MIs[0] policy
     /* 2135356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135366 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2135369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135392 */     // GIR_Coverage, 17538,
     /* 2135392 */     GIR_EraseRootFromParent_Done,
     /* 2135393 */   // Label 28234: @2135393
     /* 2135393 */   GIM_Try, /*On fail goto*//*Label 28235*/ GIMT_Encode4(2135484), // Rule ID 17539 //
     /* 2135398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2135401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2135409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2135412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2135415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2135418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2135421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135444 */     // MIs[0] round
     /* 2135444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135447 */     // MIs[0] policy
     /* 2135447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135457 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2135460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135483 */     // GIR_Coverage, 17539,
     /* 2135483 */     GIR_EraseRootFromParent_Done,
     /* 2135484 */   // Label 28235: @2135484
     /* 2135484 */   GIM_Try, /*On fail goto*//*Label 28236*/ GIMT_Encode4(2135575), // Rule ID 17542 //
     /* 2135489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2135500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2135503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2135506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2135509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135535 */     // MIs[0] round
     /* 2135535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135538 */     // MIs[0] policy
     /* 2135538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135548 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2135551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135574 */     // GIR_Coverage, 17542,
     /* 2135574 */     GIR_EraseRootFromParent_Done,
     /* 2135575 */   // Label 28236: @2135575
     /* 2135575 */   GIM_Try, /*On fail goto*//*Label 28237*/ GIMT_Encode4(2135666), // Rule ID 17543 //
     /* 2135580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2135591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2135594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2135597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2135600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135626 */     // MIs[0] round
     /* 2135626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135629 */     // MIs[0] policy
     /* 2135629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135639 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2135642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135665 */     // GIR_Coverage, 17543,
     /* 2135665 */     GIR_EraseRootFromParent_Done,
     /* 2135666 */   // Label 28237: @2135666
     /* 2135666 */   GIM_Try, /*On fail goto*//*Label 28238*/ GIMT_Encode4(2135757), // Rule ID 17546 //
     /* 2135671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2135682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2135685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2135688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2135691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135717 */     // MIs[0] round
     /* 2135717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135720 */     // MIs[0] policy
     /* 2135720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135730 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2135733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135756 */     // GIR_Coverage, 17546,
     /* 2135756 */     GIR_EraseRootFromParent_Done,
     /* 2135757 */   // Label 28238: @2135757
     /* 2135757 */   GIM_Try, /*On fail goto*//*Label 28239*/ GIMT_Encode4(2135848), // Rule ID 17547 //
     /* 2135762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2135773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2135776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2135779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2135782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135808 */     // MIs[0] round
     /* 2135808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135811 */     // MIs[0] policy
     /* 2135811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135821 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2135824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135847 */     // GIR_Coverage, 17547,
     /* 2135847 */     GIR_EraseRootFromParent_Done,
     /* 2135848 */   // Label 28239: @2135848
     /* 2135848 */   GIM_Try, /*On fail goto*//*Label 28240*/ GIMT_Encode4(2135939), // Rule ID 17550 //
     /* 2135853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2135864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2135867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2135870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2135873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2135876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135899 */     // MIs[0] round
     /* 2135899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135902 */     // MIs[0] policy
     /* 2135902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135912 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2135915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135938 */     // GIR_Coverage, 17550,
     /* 2135938 */     GIR_EraseRootFromParent_Done,
     /* 2135939 */   // Label 28240: @2135939
     /* 2135939 */   GIM_Try, /*On fail goto*//*Label 28241*/ GIMT_Encode4(2136030), // Rule ID 17551 //
     /* 2135944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2135955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2135958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2135961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2135964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2135967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135990 */     // MIs[0] round
     /* 2135990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135993 */     // MIs[0] policy
     /* 2135993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136003 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2136006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136029 */     // GIR_Coverage, 17551,
     /* 2136029 */     GIR_EraseRootFromParent_Done,
     /* 2136030 */   // Label 28241: @2136030
     /* 2136030 */   GIM_Try, /*On fail goto*//*Label 28242*/ GIMT_Encode4(2136121), // Rule ID 17554 //
     /* 2136035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2136038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2136046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2136049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2136052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2136055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136081 */     // MIs[0] round
     /* 2136081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136084 */     // MIs[0] policy
     /* 2136084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2136097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136120 */     // GIR_Coverage, 17554,
     /* 2136120 */     GIR_EraseRootFromParent_Done,
     /* 2136121 */   // Label 28242: @2136121
     /* 2136121 */   GIM_Try, /*On fail goto*//*Label 28243*/ GIMT_Encode4(2136212), // Rule ID 17555 //
     /* 2136126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2136129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2136137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2136140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2136143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2136146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136172 */     // MIs[0] round
     /* 2136172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136175 */     // MIs[0] policy
     /* 2136175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136185 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2136188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136211 */     // GIR_Coverage, 17555,
     /* 2136211 */     GIR_EraseRootFromParent_Done,
     /* 2136212 */   // Label 28243: @2136212
     /* 2136212 */   GIM_Try, /*On fail goto*//*Label 28244*/ GIMT_Encode4(2136303), // Rule ID 17558 //
     /* 2136217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2136220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2136228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2136231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2136234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2136237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136263 */     // MIs[0] round
     /* 2136263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136266 */     // MIs[0] policy
     /* 2136266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136276 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2136279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136302 */     // GIR_Coverage, 17558,
     /* 2136302 */     GIR_EraseRootFromParent_Done,
     /* 2136303 */   // Label 28244: @2136303
     /* 2136303 */   GIM_Try, /*On fail goto*//*Label 28245*/ GIMT_Encode4(2136394), // Rule ID 17559 //
     /* 2136308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2136311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2136319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2136322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2136325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2136328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136354 */     // MIs[0] round
     /* 2136354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136357 */     // MIs[0] policy
     /* 2136357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136367 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2136370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136393 */     // GIR_Coverage, 17559,
     /* 2136393 */     GIR_EraseRootFromParent_Done,
     /* 2136394 */   // Label 28245: @2136394
     /* 2136394 */   GIM_Try, /*On fail goto*//*Label 28246*/ GIMT_Encode4(2136485), // Rule ID 17562 //
     /* 2136399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2136402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2136410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2136413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2136416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2136419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2136422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136445 */     // MIs[0] round
     /* 2136445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136448 */     // MIs[0] policy
     /* 2136448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136458 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2136461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136484 */     // GIR_Coverage, 17562,
     /* 2136484 */     GIR_EraseRootFromParent_Done,
     /* 2136485 */   // Label 28246: @2136485
     /* 2136485 */   GIM_Try, /*On fail goto*//*Label 28247*/ GIMT_Encode4(2136576), // Rule ID 17563 //
     /* 2136490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2136493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2136501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2136504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2136507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2136510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2136513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136536 */     // MIs[0] round
     /* 2136536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136539 */     // MIs[0] policy
     /* 2136539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136549 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2136552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136575 */     // GIR_Coverage, 17563,
     /* 2136575 */     GIR_EraseRootFromParent_Done,
     /* 2136576 */   // Label 28247: @2136576
     /* 2136576 */   GIM_Try, /*On fail goto*//*Label 28248*/ GIMT_Encode4(2136667), // Rule ID 17566 //
     /* 2136581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2136592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2136601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136627 */     // MIs[0] round
     /* 2136627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136630 */     // MIs[0] policy
     /* 2136630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136640 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2136643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136666 */     // GIR_Coverage, 17566,
     /* 2136666 */     GIR_EraseRootFromParent_Done,
     /* 2136667 */   // Label 28248: @2136667
     /* 2136667 */   GIM_Try, /*On fail goto*//*Label 28249*/ GIMT_Encode4(2136758), // Rule ID 17567 //
     /* 2136672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2136683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2136692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136718 */     // MIs[0] round
     /* 2136718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136721 */     // MIs[0] policy
     /* 2136721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136731 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2136734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136757 */     // GIR_Coverage, 17567,
     /* 2136757 */     GIR_EraseRootFromParent_Done,
     /* 2136758 */   // Label 28249: @2136758
     /* 2136758 */   GIM_Try, /*On fail goto*//*Label 28250*/ GIMT_Encode4(2136849), // Rule ID 17570 //
     /* 2136763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2136774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2136777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2136780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2136783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136809 */     // MIs[0] round
     /* 2136809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136812 */     // MIs[0] policy
     /* 2136812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136822 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2136825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136848 */     // GIR_Coverage, 17570,
     /* 2136848 */     GIR_EraseRootFromParent_Done,
     /* 2136849 */   // Label 28250: @2136849
     /* 2136849 */   GIM_Try, /*On fail goto*//*Label 28251*/ GIMT_Encode4(2136940), // Rule ID 17571 //
     /* 2136854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2136865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2136868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2136871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2136874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136900 */     // MIs[0] round
     /* 2136900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136903 */     // MIs[0] policy
     /* 2136903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136913 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2136916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136939 */     // GIR_Coverage, 17571,
     /* 2136939 */     GIR_EraseRootFromParent_Done,
     /* 2136940 */   // Label 28251: @2136940
     /* 2136940 */   GIM_Try, /*On fail goto*//*Label 28252*/ GIMT_Encode4(2137031), // Rule ID 17574 //
     /* 2136945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2136956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2136959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2136962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2136965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136991 */     // MIs[0] round
     /* 2136991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136994 */     // MIs[0] policy
     /* 2136994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137004 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2137007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137030 */     // GIR_Coverage, 17574,
     /* 2137030 */     GIR_EraseRootFromParent_Done,
     /* 2137031 */   // Label 28252: @2137031
     /* 2137031 */   GIM_Try, /*On fail goto*//*Label 28253*/ GIMT_Encode4(2137122), // Rule ID 17575 //
     /* 2137036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2137039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2137047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2137050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2137053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2137056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2137059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2137066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137082 */     // MIs[0] round
     /* 2137082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137085 */     // MIs[0] policy
     /* 2137085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137095 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2137098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137121 */     // GIR_Coverage, 17575,
     /* 2137121 */     GIR_EraseRootFromParent_Done,
     /* 2137122 */   // Label 28253: @2137122
     /* 2137122 */   GIM_Try, /*On fail goto*//*Label 28254*/ GIMT_Encode4(2137213), // Rule ID 17578 //
     /* 2137127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2137138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2137141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2137144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137173 */     // MIs[0] round
     /* 2137173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137176 */     // MIs[0] policy
     /* 2137176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137186 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2137189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137212 */     // GIR_Coverage, 17578,
     /* 2137212 */     GIR_EraseRootFromParent_Done,
     /* 2137213 */   // Label 28254: @2137213
     /* 2137213 */   GIM_Try, /*On fail goto*//*Label 28255*/ GIMT_Encode4(2137304), // Rule ID 17579 //
     /* 2137218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2137229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2137232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2137235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137264 */     // MIs[0] round
     /* 2137264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137267 */     // MIs[0] policy
     /* 2137267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137277 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2137280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137303 */     // GIR_Coverage, 17579,
     /* 2137303 */     GIR_EraseRootFromParent_Done,
     /* 2137304 */   // Label 28255: @2137304
     /* 2137304 */   GIM_Try, /*On fail goto*//*Label 28256*/ GIMT_Encode4(2137395), // Rule ID 17582 //
     /* 2137309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2137320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2137323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2137326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137355 */     // MIs[0] round
     /* 2137355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137358 */     // MIs[0] policy
     /* 2137358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137368 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2137371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137394 */     // GIR_Coverage, 17582,
     /* 2137394 */     GIR_EraseRootFromParent_Done,
     /* 2137395 */   // Label 28256: @2137395
     /* 2137395 */   GIM_Try, /*On fail goto*//*Label 28257*/ GIMT_Encode4(2137486), // Rule ID 17583 //
     /* 2137400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2137411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2137414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2137417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137446 */     // MIs[0] round
     /* 2137446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137449 */     // MIs[0] policy
     /* 2137449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137459 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2137462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137485 */     // GIR_Coverage, 17583,
     /* 2137485 */     GIR_EraseRootFromParent_Done,
     /* 2137486 */   // Label 28257: @2137486
     /* 2137486 */   GIM_Try, /*On fail goto*//*Label 28258*/ GIMT_Encode4(2137577), // Rule ID 17586 //
     /* 2137491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2137494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2137502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2137505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2137508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137537 */     // MIs[0] round
     /* 2137537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137540 */     // MIs[0] policy
     /* 2137540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137550 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2137553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137576 */     // GIR_Coverage, 17586,
     /* 2137576 */     GIR_EraseRootFromParent_Done,
     /* 2137577 */   // Label 28258: @2137577
     /* 2137577 */   GIM_Try, /*On fail goto*//*Label 28259*/ GIMT_Encode4(2137668), // Rule ID 17587 //
     /* 2137582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2137585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2137593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2137596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2137599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137605 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137628 */     // MIs[0] round
     /* 2137628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137631 */     // MIs[0] policy
     /* 2137631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137641 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2137644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137667 */     // GIR_Coverage, 17587,
     /* 2137667 */     GIR_EraseRootFromParent_Done,
     /* 2137668 */   // Label 28259: @2137668
     /* 2137668 */   GIM_Try, /*On fail goto*//*Label 28260*/ GIMT_Encode4(2137759), // Rule ID 17590 //
     /* 2137673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2137684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2137687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2137690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137719 */     // MIs[0] round
     /* 2137719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137722 */     // MIs[0] policy
     /* 2137722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137732 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2137735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137758 */     // GIR_Coverage, 17590,
     /* 2137758 */     GIR_EraseRootFromParent_Done,
     /* 2137759 */   // Label 28260: @2137759
     /* 2137759 */   GIM_Try, /*On fail goto*//*Label 28261*/ GIMT_Encode4(2137850), // Rule ID 17591 //
     /* 2137764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2137775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2137778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2137781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137810 */     // MIs[0] round
     /* 2137810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137813 */     // MIs[0] policy
     /* 2137813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137823 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2137826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137849 */     // GIR_Coverage, 17591,
     /* 2137849 */     GIR_EraseRootFromParent_Done,
     /* 2137850 */   // Label 28261: @2137850
     /* 2137850 */   GIM_Try, /*On fail goto*//*Label 28262*/ GIMT_Encode4(2137941), // Rule ID 17594 //
     /* 2137855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2137858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2137866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137901 */     // MIs[0] round
     /* 2137901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137904 */     // MIs[0] policy
     /* 2137904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137914 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2137917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137940 */     // GIR_Coverage, 17594,
     /* 2137940 */     GIR_EraseRootFromParent_Done,
     /* 2137941 */   // Label 28262: @2137941
     /* 2137941 */   GIM_Try, /*On fail goto*//*Label 28263*/ GIMT_Encode4(2138032), // Rule ID 17595 //
     /* 2137946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2137949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2137957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137992 */     // MIs[0] round
     /* 2137992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137995 */     // MIs[0] policy
     /* 2137995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138005 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2138008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138031 */     // GIR_Coverage, 17595,
     /* 2138031 */     GIR_EraseRootFromParent_Done,
     /* 2138032 */   // Label 28263: @2138032
     /* 2138032 */   GIM_Try, /*On fail goto*//*Label 28264*/ GIMT_Encode4(2138123), // Rule ID 17598 //
     /* 2138037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2138040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2138048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2138051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2138054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2138057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2138060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2138079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138083 */     // MIs[0] round
     /* 2138083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138086 */     // MIs[0] policy
     /* 2138086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138096 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2138099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138122 */     // GIR_Coverage, 17598,
     /* 2138122 */     GIR_EraseRootFromParent_Done,
     /* 2138123 */   // Label 28264: @2138123
     /* 2138123 */   GIM_Try, /*On fail goto*//*Label 28265*/ GIMT_Encode4(2138214), // Rule ID 17599 //
     /* 2138128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2138131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2138139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2138142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2138145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2138148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2138151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2138170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138174 */     // MIs[0] round
     /* 2138174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138177 */     // MIs[0] policy
     /* 2138177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138187 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2138190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138213 */     // GIR_Coverage, 17599,
     /* 2138213 */     GIR_EraseRootFromParent_Done,
     /* 2138214 */   // Label 28265: @2138214
     /* 2138214 */   GIM_Try, /*On fail goto*//*Label 28266*/ GIMT_Encode4(2138305), // Rule ID 17602 //
     /* 2138219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2138230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2138233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2138236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138265 */     // MIs[0] round
     /* 2138265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138268 */     // MIs[0] policy
     /* 2138268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138278 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2138281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138304 */     // GIR_Coverage, 17602,
     /* 2138304 */     GIR_EraseRootFromParent_Done,
     /* 2138305 */   // Label 28266: @2138305
     /* 2138305 */   GIM_Try, /*On fail goto*//*Label 28267*/ GIMT_Encode4(2138396), // Rule ID 17603 //
     /* 2138310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2138321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2138324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2138327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138356 */     // MIs[0] round
     /* 2138356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138359 */     // MIs[0] policy
     /* 2138359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138369 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2138372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138395 */     // GIR_Coverage, 17603,
     /* 2138395 */     GIR_EraseRootFromParent_Done,
     /* 2138396 */   // Label 28267: @2138396
     /* 2138396 */   GIM_Try, /*On fail goto*//*Label 28268*/ GIMT_Encode4(2138487), // Rule ID 17606 //
     /* 2138401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2138412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2138415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2138418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138447 */     // MIs[0] round
     /* 2138447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138450 */     // MIs[0] policy
     /* 2138450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138460 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2138463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138486 */     // GIR_Coverage, 17606,
     /* 2138486 */     GIR_EraseRootFromParent_Done,
     /* 2138487 */   // Label 28268: @2138487
     /* 2138487 */   GIM_Try, /*On fail goto*//*Label 28269*/ GIMT_Encode4(2138578), // Rule ID 17607 //
     /* 2138492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2138503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2138506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2138509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138538 */     // MIs[0] round
     /* 2138538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138541 */     // MIs[0] policy
     /* 2138541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138551 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2138554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138577 */     // GIR_Coverage, 17607,
     /* 2138577 */     GIR_EraseRootFromParent_Done,
     /* 2138578 */   // Label 28269: @2138578
     /* 2138578 */   GIM_Try, /*On fail goto*//*Label 28270*/ GIMT_Encode4(2138669), // Rule ID 17610 //
     /* 2138583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2138594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2138597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2138600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2138606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138629 */     // MIs[0] round
     /* 2138629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138632 */     // MIs[0] policy
     /* 2138632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138642 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2138645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138668 */     // GIR_Coverage, 17610,
     /* 2138668 */     GIR_EraseRootFromParent_Done,
     /* 2138669 */   // Label 28270: @2138669
     /* 2138669 */   GIM_Try, /*On fail goto*//*Label 28271*/ GIMT_Encode4(2138760), // Rule ID 17611 //
     /* 2138674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2138685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2138688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2138691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2138697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138720 */     // MIs[0] round
     /* 2138720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138723 */     // MIs[0] policy
     /* 2138723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138733 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2138736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138759 */     // GIR_Coverage, 17611,
     /* 2138759 */     GIR_EraseRootFromParent_Done,
     /* 2138760 */   // Label 28271: @2138760
     /* 2138760 */   GIM_Try, /*On fail goto*//*Label 28272*/ GIMT_Encode4(2138851), // Rule ID 17614 //
     /* 2138765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2138776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2138779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2138782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138811 */     // MIs[0] round
     /* 2138811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138814 */     // MIs[0] policy
     /* 2138814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2138827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138850 */     // GIR_Coverage, 17614,
     /* 2138850 */     GIR_EraseRootFromParent_Done,
     /* 2138851 */   // Label 28272: @2138851
     /* 2138851 */   GIM_Try, /*On fail goto*//*Label 28273*/ GIMT_Encode4(2138942), // Rule ID 17615 //
     /* 2138856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2138867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2138870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2138873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138902 */     // MIs[0] round
     /* 2138902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138905 */     // MIs[0] policy
     /* 2138905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138915 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2138918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138941 */     // GIR_Coverage, 17615,
     /* 2138941 */     GIR_EraseRootFromParent_Done,
     /* 2138942 */   // Label 28273: @2138942
     /* 2138942 */   GIM_Try, /*On fail goto*//*Label 28274*/ GIMT_Encode4(2139033), // Rule ID 17618 //
     /* 2138947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2138958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2138961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2138964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138993 */     // MIs[0] round
     /* 2138993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138996 */     // MIs[0] policy
     /* 2138996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139006 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2139009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139032 */     // GIR_Coverage, 17618,
     /* 2139032 */     GIR_EraseRootFromParent_Done,
     /* 2139033 */   // Label 28274: @2139033
     /* 2139033 */   GIM_Try, /*On fail goto*//*Label 28275*/ GIMT_Encode4(2139124), // Rule ID 17619 //
     /* 2139038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2139041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2139049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2139052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2139055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2139058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2139080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139084 */     // MIs[0] round
     /* 2139084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139087 */     // MIs[0] policy
     /* 2139087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139097 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2139100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139123 */     // GIR_Coverage, 17619,
     /* 2139123 */     GIR_EraseRootFromParent_Done,
     /* 2139124 */   // Label 28275: @2139124
     /* 2139124 */   GIM_Try, /*On fail goto*//*Label 28276*/ GIMT_Encode4(2139215), // Rule ID 17622 //
     /* 2139129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2139132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2139140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2139143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2139146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2139149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2139152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2139171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139175 */     // MIs[0] round
     /* 2139175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139178 */     // MIs[0] policy
     /* 2139178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139188 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2139191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139214 */     // GIR_Coverage, 17622,
     /* 2139214 */     GIR_EraseRootFromParent_Done,
     /* 2139215 */   // Label 28276: @2139215
     /* 2139215 */   GIM_Try, /*On fail goto*//*Label 28277*/ GIMT_Encode4(2139306), // Rule ID 17623 //
     /* 2139220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2139223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2139231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2139234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2139237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2139240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2139243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2139262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139266 */     // MIs[0] round
     /* 2139266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139269 */     // MIs[0] policy
     /* 2139269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139279 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2139282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139305 */     // GIR_Coverage, 17623,
     /* 2139305 */     GIR_EraseRootFromParent_Done,
     /* 2139306 */   // Label 28277: @2139306
     /* 2139306 */   GIM_Try, /*On fail goto*//*Label 28278*/ GIMT_Encode4(2139397), // Rule ID 17626 //
     /* 2139311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2139322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2139325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2139328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2139341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139357 */     // MIs[0] round
     /* 2139357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139360 */     // MIs[0] policy
     /* 2139360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139370 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2139373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139396 */     // GIR_Coverage, 17626,
     /* 2139396 */     GIR_EraseRootFromParent_Done,
     /* 2139397 */   // Label 28278: @2139397
     /* 2139397 */   GIM_Try, /*On fail goto*//*Label 28279*/ GIMT_Encode4(2139488), // Rule ID 17627 //
     /* 2139402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2139413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2139416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2139419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2139432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139448 */     // MIs[0] round
     /* 2139448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139451 */     // MIs[0] policy
     /* 2139451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139461 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2139464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139487 */     // GIR_Coverage, 17627,
     /* 2139487 */     GIR_EraseRootFromParent_Done,
     /* 2139488 */   // Label 28279: @2139488
     /* 2139488 */   GIM_Try, /*On fail goto*//*Label 28280*/ GIMT_Encode4(2139579), // Rule ID 17630 //
     /* 2139493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2139504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2139507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2139510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139539 */     // MIs[0] round
     /* 2139539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139542 */     // MIs[0] policy
     /* 2139542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139552 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2139555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139578 */     // GIR_Coverage, 17630,
     /* 2139578 */     GIR_EraseRootFromParent_Done,
     /* 2139579 */   // Label 28280: @2139579
     /* 2139579 */   GIM_Try, /*On fail goto*//*Label 28281*/ GIMT_Encode4(2139670), // Rule ID 17631 //
     /* 2139584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2139595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2139598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2139601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139630 */     // MIs[0] round
     /* 2139630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139633 */     // MIs[0] policy
     /* 2139633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139643 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2139646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139669 */     // GIR_Coverage, 17631,
     /* 2139669 */     GIR_EraseRootFromParent_Done,
     /* 2139670 */   // Label 28281: @2139670
     /* 2139670 */   GIM_Try, /*On fail goto*//*Label 28282*/ GIMT_Encode4(2139761), // Rule ID 17634 //
     /* 2139675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2139686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2139689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2139692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139721 */     // MIs[0] round
     /* 2139721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139724 */     // MIs[0] policy
     /* 2139724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139734 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2139737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139760 */     // GIR_Coverage, 17634,
     /* 2139760 */     GIR_EraseRootFromParent_Done,
     /* 2139761 */   // Label 28282: @2139761
     /* 2139761 */   GIM_Try, /*On fail goto*//*Label 28283*/ GIMT_Encode4(2139852), // Rule ID 17635 //
     /* 2139766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2139777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2139780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2139783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139812 */     // MIs[0] round
     /* 2139812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139815 */     // MIs[0] policy
     /* 2139815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139825 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2139828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139851 */     // GIR_Coverage, 17635,
     /* 2139851 */     GIR_EraseRootFromParent_Done,
     /* 2139852 */   // Label 28283: @2139852
     /* 2139852 */   GIM_Try, /*On fail goto*//*Label 28284*/ GIMT_Encode4(2139943), // Rule ID 17638 //
     /* 2139857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2139868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2139871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2139874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139903 */     // MIs[0] round
     /* 2139903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139906 */     // MIs[0] policy
     /* 2139906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139916 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2139919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139942 */     // GIR_Coverage, 17638,
     /* 2139942 */     GIR_EraseRootFromParent_Done,
     /* 2139943 */   // Label 28284: @2139943
     /* 2139943 */   GIM_Try, /*On fail goto*//*Label 28285*/ GIMT_Encode4(2140034), // Rule ID 17639 //
     /* 2139948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2139959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2139962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2139965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139994 */     // MIs[0] round
     /* 2139994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139997 */     // MIs[0] policy
     /* 2139997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140007 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2140010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140033 */     // GIR_Coverage, 17639,
     /* 2140033 */     GIR_EraseRootFromParent_Done,
     /* 2140034 */   // Label 28285: @2140034
     /* 2140034 */   GIM_Try, /*On fail goto*//*Label 28286*/ GIMT_Encode4(2140125), // Rule ID 17642 //
     /* 2140039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2140050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2140053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2140056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140085 */     // MIs[0] round
     /* 2140085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140088 */     // MIs[0] policy
     /* 2140088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140098 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2140101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140124 */     // GIR_Coverage, 17642,
     /* 2140124 */     GIR_EraseRootFromParent_Done,
     /* 2140125 */   // Label 28286: @2140125
     /* 2140125 */   GIM_Try, /*On fail goto*//*Label 28287*/ GIMT_Encode4(2140216), // Rule ID 17643 //
     /* 2140130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2140141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2140144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2140147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140176 */     // MIs[0] round
     /* 2140176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140179 */     // MIs[0] policy
     /* 2140179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140189 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2140192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140215 */     // GIR_Coverage, 17643,
     /* 2140215 */     GIR_EraseRootFromParent_Done,
     /* 2140216 */   // Label 28287: @2140216
     /* 2140216 */   GIM_Try, /*On fail goto*//*Label 28288*/ GIMT_Encode4(2140307), // Rule ID 17646 //
     /* 2140221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2140224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2140232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2140235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2140238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140267 */     // MIs[0] round
     /* 2140267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140270 */     // MIs[0] policy
     /* 2140270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140280 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2140283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140306 */     // GIR_Coverage, 17646,
     /* 2140306 */     GIR_EraseRootFromParent_Done,
     /* 2140307 */   // Label 28288: @2140307
     /* 2140307 */   GIM_Try, /*On fail goto*//*Label 28289*/ GIMT_Encode4(2140398), // Rule ID 17647 //
     /* 2140312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2140315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2140323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2140326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2140329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140358 */     // MIs[0] round
     /* 2140358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140361 */     // MIs[0] policy
     /* 2140361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140371 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2140374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140397 */     // GIR_Coverage, 17647,
     /* 2140397 */     GIR_EraseRootFromParent_Done,
     /* 2140398 */   // Label 28289: @2140398
     /* 2140398 */   GIM_Try, /*On fail goto*//*Label 28290*/ GIMT_Encode4(2140489), // Rule ID 17650 //
     /* 2140403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2140414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2140417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2140420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140449 */     // MIs[0] round
     /* 2140449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140452 */     // MIs[0] policy
     /* 2140452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140462 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11305:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2140465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140488 */     // GIR_Coverage, 17650,
     /* 2140488 */     GIR_EraseRootFromParent_Done,
     /* 2140489 */   // Label 28290: @2140489
     /* 2140489 */   GIM_Try, /*On fail goto*//*Label 28291*/ GIMT_Encode4(2140580), // Rule ID 17651 //
     /* 2140494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2140505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2140508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2140511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140540 */     // MIs[0] round
     /* 2140540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140543 */     // MIs[0] policy
     /* 2140543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140553 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11305:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2140556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140579 */     // GIR_Coverage, 17651,
     /* 2140579 */     GIR_EraseRootFromParent_Done,
     /* 2140580 */   // Label 28291: @2140580
     /* 2140580 */   GIM_Try, /*On fail goto*//*Label 28292*/ GIMT_Encode4(2140671), // Rule ID 17654 //
     /* 2140585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2140588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2140596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2140599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2140602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140631 */     // MIs[0] round
     /* 2140631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140634 */     // MIs[0] policy
     /* 2140634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140644 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2140647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140670 */     // GIR_Coverage, 17654,
     /* 2140670 */     GIR_EraseRootFromParent_Done,
     /* 2140671 */   // Label 28292: @2140671
     /* 2140671 */   GIM_Try, /*On fail goto*//*Label 28293*/ GIMT_Encode4(2140762), // Rule ID 17655 //
     /* 2140676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2140679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2140687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2140690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2140693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140722 */     // MIs[0] round
     /* 2140722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140725 */     // MIs[0] policy
     /* 2140725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140735 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2140738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140761 */     // GIR_Coverage, 17655,
     /* 2140761 */     GIR_EraseRootFromParent_Done,
     /* 2140762 */   // Label 28293: @2140762
     /* 2140762 */   GIM_Try, /*On fail goto*//*Label 28294*/ GIMT_Encode4(2140853), // Rule ID 17658 //
     /* 2140767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2140770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2140778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2140781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2140784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2140787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2140809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140813 */     // MIs[0] round
     /* 2140813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140816 */     // MIs[0] policy
     /* 2140816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140826 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2140829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140852 */     // GIR_Coverage, 17658,
     /* 2140852 */     GIR_EraseRootFromParent_Done,
     /* 2140853 */   // Label 28294: @2140853
     /* 2140853 */   GIM_Try, /*On fail goto*//*Label 28295*/ GIMT_Encode4(2140944), // Rule ID 17659 //
     /* 2140858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2140861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2140869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2140872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2140875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2140878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2140900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140904 */     // MIs[0] round
     /* 2140904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140907 */     // MIs[0] policy
     /* 2140907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140917 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2140920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140943 */     // GIR_Coverage, 17659,
     /* 2140943 */     GIR_EraseRootFromParent_Done,
     /* 2140944 */   // Label 28295: @2140944
     /* 2140944 */   GIM_Try, /*On fail goto*//*Label 28296*/ GIMT_Encode4(2141035), // Rule ID 17662 //
     /* 2140949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2140960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2140963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2140966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2140979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140995 */     // MIs[0] round
     /* 2140995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140998 */     // MIs[0] policy
     /* 2140998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141008 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2141011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141034 */     // GIR_Coverage, 17662,
     /* 2141034 */     GIR_EraseRootFromParent_Done,
     /* 2141035 */   // Label 28296: @2141035
     /* 2141035 */   GIM_Try, /*On fail goto*//*Label 28297*/ GIMT_Encode4(2141126), // Rule ID 17663 //
     /* 2141040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2141043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2141051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2141054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2141057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141086 */     // MIs[0] round
     /* 2141086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141089 */     // MIs[0] policy
     /* 2141089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141099 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2141102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141125 */     // GIR_Coverage, 17663,
     /* 2141125 */     GIR_EraseRootFromParent_Done,
     /* 2141126 */   // Label 28297: @2141126
     /* 2141126 */   GIM_Try, /*On fail goto*//*Label 28298*/ GIMT_Encode4(2141217), // Rule ID 17666 //
     /* 2141131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2141134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2141142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2141145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2141148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141177 */     // MIs[0] round
     /* 2141177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141180 */     // MIs[0] policy
     /* 2141180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141190 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2141193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141216 */     // GIR_Coverage, 17666,
     /* 2141216 */     GIR_EraseRootFromParent_Done,
     /* 2141217 */   // Label 28298: @2141217
     /* 2141217 */   GIM_Try, /*On fail goto*//*Label 28299*/ GIMT_Encode4(2141308), // Rule ID 17667 //
     /* 2141222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2141225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2141233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2141236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2141239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141268 */     // MIs[0] round
     /* 2141268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141271 */     // MIs[0] policy
     /* 2141271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141281 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2141284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141307 */     // GIR_Coverage, 17667,
     /* 2141307 */     GIR_EraseRootFromParent_Done,
     /* 2141308 */   // Label 28299: @2141308
     /* 2141308 */   GIM_Try, /*On fail goto*//*Label 28300*/ GIMT_Encode4(2141399), // Rule ID 17670 //
     /* 2141313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2141316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2141324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2141327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2141330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2141336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141359 */     // MIs[0] round
     /* 2141359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141362 */     // MIs[0] policy
     /* 2141362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141372 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2141375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141398 */     // GIR_Coverage, 17670,
     /* 2141398 */     GIR_EraseRootFromParent_Done,
     /* 2141399 */   // Label 28300: @2141399
     /* 2141399 */   GIM_Try, /*On fail goto*//*Label 28301*/ GIMT_Encode4(2141490), // Rule ID 17671 //
     /* 2141404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2141407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2141415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2141418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2141421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2141427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141450 */     // MIs[0] round
     /* 2141450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141453 */     // MIs[0] policy
     /* 2141453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141463 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2141466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141489 */     // GIR_Coverage, 17671,
     /* 2141489 */     GIR_EraseRootFromParent_Done,
     /* 2141490 */   // Label 28301: @2141490
     /* 2141490 */   GIM_Try, /*On fail goto*//*Label 28302*/ GIMT_Encode4(2141581), // Rule ID 17674 //
     /* 2141495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2141506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141541 */     // MIs[0] round
     /* 2141541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141544 */     // MIs[0] policy
     /* 2141544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141554 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2141557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141580 */     // GIR_Coverage, 17674,
     /* 2141580 */     GIR_EraseRootFromParent_Done,
     /* 2141581 */   // Label 28302: @2141581
     /* 2141581 */   GIM_Try, /*On fail goto*//*Label 28303*/ GIMT_Encode4(2141672), // Rule ID 17675 //
     /* 2141586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2141597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141632 */     // MIs[0] round
     /* 2141632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141635 */     // MIs[0] policy
     /* 2141635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141645 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2141648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141671 */     // GIR_Coverage, 17675,
     /* 2141671 */     GIR_EraseRootFromParent_Done,
     /* 2141672 */   // Label 28303: @2141672
     /* 2141672 */   GIM_Try, /*On fail goto*//*Label 28304*/ GIMT_Encode4(2141763), // Rule ID 17678 //
     /* 2141677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2141688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2141691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2141694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141723 */     // MIs[0] round
     /* 2141723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141726 */     // MIs[0] policy
     /* 2141726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141736 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2141739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141762 */     // GIR_Coverage, 17678,
     /* 2141762 */     GIR_EraseRootFromParent_Done,
     /* 2141763 */   // Label 28304: @2141763
     /* 2141763 */   GIM_Try, /*On fail goto*//*Label 28305*/ GIMT_Encode4(2141854), // Rule ID 17679 //
     /* 2141768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2141779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2141782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2141785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141814 */     // MIs[0] round
     /* 2141814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141817 */     // MIs[0] policy
     /* 2141817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141827 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2141830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141853 */     // GIR_Coverage, 17679,
     /* 2141853 */     GIR_EraseRootFromParent_Done,
     /* 2141854 */   // Label 28305: @2141854
     /* 2141854 */   GIM_Try, /*On fail goto*//*Label 28306*/ GIMT_Encode4(2141945), // Rule ID 17682 //
     /* 2141859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2141870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2141873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2141876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141905 */     // MIs[0] round
     /* 2141905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141908 */     // MIs[0] policy
     /* 2141908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141918 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2141921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141944 */     // GIR_Coverage, 17682,
     /* 2141944 */     GIR_EraseRootFromParent_Done,
     /* 2141945 */   // Label 28306: @2141945
     /* 2141945 */   GIM_Try, /*On fail goto*//*Label 28307*/ GIMT_Encode4(2142036), // Rule ID 17683 //
     /* 2141950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2141961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2141964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2141967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141996 */     // MIs[0] round
     /* 2141996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141999 */     // MIs[0] policy
     /* 2141999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142009 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2142012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142035 */     // GIR_Coverage, 17683,
     /* 2142035 */     GIR_EraseRootFromParent_Done,
     /* 2142036 */   // Label 28307: @2142036
     /* 2142036 */   GIM_Try, /*On fail goto*//*Label 28308*/ GIMT_Encode4(2142127), // Rule ID 17686 //
     /* 2142041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2142044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2142052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2142055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2142058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142087 */     // MIs[0] round
     /* 2142087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142090 */     // MIs[0] policy
     /* 2142090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142100 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2142103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142126 */     // GIR_Coverage, 17686,
     /* 2142126 */     GIR_EraseRootFromParent_Done,
     /* 2142127 */   // Label 28308: @2142127
     /* 2142127 */   GIM_Try, /*On fail goto*//*Label 28309*/ GIMT_Encode4(2142218), // Rule ID 17687 //
     /* 2142132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2142135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2142143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2142146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2142149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142178 */     // MIs[0] round
     /* 2142178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142181 */     // MIs[0] policy
     /* 2142181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142191 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2142194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142217 */     // GIR_Coverage, 17687,
     /* 2142217 */     GIR_EraseRootFromParent_Done,
     /* 2142218 */   // Label 28309: @2142218
     /* 2142218 */   GIM_Try, /*On fail goto*//*Label 28310*/ GIMT_Encode4(2142309), // Rule ID 17690 //
     /* 2142223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2142226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2142234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2142237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2142240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142269 */     // MIs[0] round
     /* 2142269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142272 */     // MIs[0] policy
     /* 2142272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142282 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2142285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142308 */     // GIR_Coverage, 17690,
     /* 2142308 */     GIR_EraseRootFromParent_Done,
     /* 2142309 */   // Label 28310: @2142309
     /* 2142309 */   GIM_Try, /*On fail goto*//*Label 28311*/ GIMT_Encode4(2142400), // Rule ID 17691 //
     /* 2142314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2142317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2142325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2142328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2142331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142360 */     // MIs[0] round
     /* 2142360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142363 */     // MIs[0] policy
     /* 2142363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142373 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2142376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142399 */     // GIR_Coverage, 17691,
     /* 2142399 */     GIR_EraseRootFromParent_Done,
     /* 2142400 */   // Label 28311: @2142400
     /* 2142400 */   GIM_Try, /*On fail goto*//*Label 28312*/ GIMT_Encode4(2142491), // Rule ID 17694 //
     /* 2142405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2142408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2142416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2142419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2142422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142451 */     // MIs[0] round
     /* 2142451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142454 */     // MIs[0] policy
     /* 2142454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142464 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2142467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142490 */     // GIR_Coverage, 17694,
     /* 2142490 */     GIR_EraseRootFromParent_Done,
     /* 2142491 */   // Label 28312: @2142491
     /* 2142491 */   GIM_Try, /*On fail goto*//*Label 28313*/ GIMT_Encode4(2142582), // Rule ID 17695 //
     /* 2142496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2142499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2142507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2142510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2142513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142542 */     // MIs[0] round
     /* 2142542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142545 */     // MIs[0] policy
     /* 2142545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142555 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2142558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142581 */     // GIR_Coverage, 17695,
     /* 2142581 */     GIR_EraseRootFromParent_Done,
     /* 2142582 */   // Label 28313: @2142582
     /* 2142582 */   GIM_Try, /*On fail goto*//*Label 28314*/ GIMT_Encode4(2142673), // Rule ID 17698 //
     /* 2142587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2142598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2142601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2142604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2142607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142633 */     // MIs[0] round
     /* 2142633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142636 */     // MIs[0] policy
     /* 2142636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142646 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2142649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142672 */     // GIR_Coverage, 17698,
     /* 2142672 */     GIR_EraseRootFromParent_Done,
     /* 2142673 */   // Label 28314: @2142673
     /* 2142673 */   GIM_Try, /*On fail goto*//*Label 28315*/ GIMT_Encode4(2142764), // Rule ID 17699 //
     /* 2142678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2142689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2142692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2142695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2142698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142724 */     // MIs[0] round
     /* 2142724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142727 */     // MIs[0] policy
     /* 2142727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142737 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2142740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142763 */     // GIR_Coverage, 17699,
     /* 2142763 */     GIR_EraseRootFromParent_Done,
     /* 2142764 */   // Label 28315: @2142764
     /* 2142764 */   GIM_Try, /*On fail goto*//*Label 28316*/ GIMT_Encode4(2142855), // Rule ID 17702 //
     /* 2142769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2142780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2142783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2142786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2142789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142815 */     // MIs[0] round
     /* 2142815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142818 */     // MIs[0] policy
     /* 2142818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142828 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2142831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142854 */     // GIR_Coverage, 17702,
     /* 2142854 */     GIR_EraseRootFromParent_Done,
     /* 2142855 */   // Label 28316: @2142855
     /* 2142855 */   GIM_Try, /*On fail goto*//*Label 28317*/ GIMT_Encode4(2142946), // Rule ID 17703 //
     /* 2142860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2142871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2142874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2142877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2142880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142906 */     // MIs[0] round
     /* 2142906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142909 */     // MIs[0] policy
     /* 2142909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142919 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2142922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142945 */     // GIR_Coverage, 17703,
     /* 2142945 */     GIR_EraseRootFromParent_Done,
     /* 2142946 */   // Label 28317: @2142946
     /* 2142946 */   GIM_Try, /*On fail goto*//*Label 28318*/ GIMT_Encode4(2143037), // Rule ID 17706 //
     /* 2142951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2142962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2142968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2142971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142997 */     // MIs[0] round
     /* 2142997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143000 */     // MIs[0] policy
     /* 2143000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143010 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2143013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143036 */     // GIR_Coverage, 17706,
     /* 2143036 */     GIR_EraseRootFromParent_Done,
     /* 2143037 */   // Label 28318: @2143037
     /* 2143037 */   GIM_Try, /*On fail goto*//*Label 28319*/ GIMT_Encode4(2143128), // Rule ID 17707 //
     /* 2143042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2143045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2143053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2143056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2143059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2143062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143088 */     // MIs[0] round
     /* 2143088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143091 */     // MIs[0] policy
     /* 2143091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143101 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2143104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143127 */     // GIR_Coverage, 17707,
     /* 2143127 */     GIR_EraseRootFromParent_Done,
     /* 2143128 */   // Label 28319: @2143128
     /* 2143128 */   GIM_Try, /*On fail goto*//*Label 28320*/ GIMT_Encode4(2143219), // Rule ID 17710 //
     /* 2143133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2143136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2143144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2143147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2143150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2143153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143179 */     // MIs[0] round
     /* 2143179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143182 */     // MIs[0] policy
     /* 2143182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143192 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2143195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143218 */     // GIR_Coverage, 17710,
     /* 2143218 */     GIR_EraseRootFromParent_Done,
     /* 2143219 */   // Label 28320: @2143219
     /* 2143219 */   GIM_Try, /*On fail goto*//*Label 28321*/ GIMT_Encode4(2143310), // Rule ID 17711 //
     /* 2143224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2143227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2143235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2143238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2143241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2143244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143270 */     // MIs[0] round
     /* 2143270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143273 */     // MIs[0] policy
     /* 2143273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143283 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2143286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143309 */     // GIR_Coverage, 17711,
     /* 2143309 */     GIR_EraseRootFromParent_Done,
     /* 2143310 */   // Label 28321: @2143310
     /* 2143310 */   GIM_Try, /*On fail goto*//*Label 28322*/ GIMT_Encode4(2143401), // Rule ID 17714 //
     /* 2143315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2143318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2143326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2143329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2143332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2143335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2143338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143361 */     // MIs[0] round
     /* 2143361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143364 */     // MIs[0] policy
     /* 2143364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143374 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2143377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143400 */     // GIR_Coverage, 17714,
     /* 2143400 */     GIR_EraseRootFromParent_Done,
     /* 2143401 */   // Label 28322: @2143401
     /* 2143401 */   GIM_Try, /*On fail goto*//*Label 28323*/ GIMT_Encode4(2143492), // Rule ID 17715 //
     /* 2143406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2143409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2143417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2143420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2143423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2143426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2143429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143452 */     // MIs[0] round
     /* 2143452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143455 */     // MIs[0] policy
     /* 2143455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143465 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2143468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143491 */     // GIR_Coverage, 17715,
     /* 2143491 */     GIR_EraseRootFromParent_Done,
     /* 2143492 */   // Label 28323: @2143492
     /* 2143492 */   GIM_Try, /*On fail goto*//*Label 28324*/ GIMT_Encode4(2143583), // Rule ID 17718 //
     /* 2143497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2143508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2143511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2143514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2143517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143543 */     // MIs[0] round
     /* 2143543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143546 */     // MIs[0] policy
     /* 2143546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143556 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2143559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143582 */     // GIR_Coverage, 17718,
     /* 2143582 */     GIR_EraseRootFromParent_Done,
     /* 2143583 */   // Label 28324: @2143583
     /* 2143583 */   GIM_Try, /*On fail goto*//*Label 28325*/ GIMT_Encode4(2143674), // Rule ID 17719 //
     /* 2143588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2143599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2143602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2143605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2143608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143634 */     // MIs[0] round
     /* 2143634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143637 */     // MIs[0] policy
     /* 2143637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143647 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2143650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143673 */     // GIR_Coverage, 17719,
     /* 2143673 */     GIR_EraseRootFromParent_Done,
     /* 2143674 */   // Label 28325: @2143674
     /* 2143674 */   GIM_Try, /*On fail goto*//*Label 28326*/ GIMT_Encode4(2143765), // Rule ID 17722 //
     /* 2143679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2143690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2143693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2143696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2143699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143725 */     // MIs[0] round
     /* 2143725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143728 */     // MIs[0] policy
     /* 2143728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143738 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2143741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143764 */     // GIR_Coverage, 17722,
     /* 2143764 */     GIR_EraseRootFromParent_Done,
     /* 2143765 */   // Label 28326: @2143765
     /* 2143765 */   GIM_Try, /*On fail goto*//*Label 28327*/ GIMT_Encode4(2143856), // Rule ID 17723 //
     /* 2143770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2143781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2143784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2143787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2143790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143816 */     // MIs[0] round
     /* 2143816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143819 */     // MIs[0] policy
     /* 2143819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143829 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2143832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143855 */     // GIR_Coverage, 17723,
     /* 2143855 */     GIR_EraseRootFromParent_Done,
     /* 2143856 */   // Label 28327: @2143856
     /* 2143856 */   GIM_Try, /*On fail goto*//*Label 28328*/ GIMT_Encode4(2143947), // Rule ID 17726 //
     /* 2143861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2143872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2143875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2143878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2143881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143907 */     // MIs[0] round
     /* 2143907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143910 */     // MIs[0] policy
     /* 2143910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143920 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2143923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143946 */     // GIR_Coverage, 17726,
     /* 2143946 */     GIR_EraseRootFromParent_Done,
     /* 2143947 */   // Label 28328: @2143947
     /* 2143947 */   GIM_Try, /*On fail goto*//*Label 28329*/ GIMT_Encode4(2144038), // Rule ID 17727 //
     /* 2143952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2143963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2143966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2143969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2143972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143998 */     // MIs[0] round
     /* 2143998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144001 */     // MIs[0] policy
     /* 2144001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144011 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2144014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144037 */     // GIR_Coverage, 17727,
     /* 2144037 */     GIR_EraseRootFromParent_Done,
     /* 2144038 */   // Label 28329: @2144038
     /* 2144038 */   GIM_Try, /*On fail goto*//*Label 28330*/ GIMT_Encode4(2144129), // Rule ID 17730 //
     /* 2144043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2144046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2144054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2144057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2144060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2144063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144089 */     // MIs[0] round
     /* 2144089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144092 */     // MIs[0] policy
     /* 2144092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144102 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2144105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144128 */     // GIR_Coverage, 17730,
     /* 2144128 */     GIR_EraseRootFromParent_Done,
     /* 2144129 */   // Label 28330: @2144129
     /* 2144129 */   GIM_Try, /*On fail goto*//*Label 28331*/ GIMT_Encode4(2144220), // Rule ID 17731 //
     /* 2144134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2144137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2144145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2144148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2144151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2144154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144180 */     // MIs[0] round
     /* 2144180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144183 */     // MIs[0] policy
     /* 2144183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144193 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2144196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144219 */     // GIR_Coverage, 17731,
     /* 2144219 */     GIR_EraseRootFromParent_Done,
     /* 2144220 */   // Label 28331: @2144220
     /* 2144220 */   GIM_Try, /*On fail goto*//*Label 28332*/ GIMT_Encode4(2144311), // Rule ID 17734 //
     /* 2144225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2144236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2144239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2144242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144271 */     // MIs[0] round
     /* 2144271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144274 */     // MIs[0] policy
     /* 2144274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144284 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2144287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144310 */     // GIR_Coverage, 17734,
     /* 2144310 */     GIR_EraseRootFromParent_Done,
     /* 2144311 */   // Label 28332: @2144311
     /* 2144311 */   GIM_Try, /*On fail goto*//*Label 28333*/ GIMT_Encode4(2144402), // Rule ID 17735 //
     /* 2144316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2144327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2144330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2144333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144362 */     // MIs[0] round
     /* 2144362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144365 */     // MIs[0] policy
     /* 2144365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144375 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2144378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144401 */     // GIR_Coverage, 17735,
     /* 2144401 */     GIR_EraseRootFromParent_Done,
     /* 2144402 */   // Label 28333: @2144402
     /* 2144402 */   GIM_Try, /*On fail goto*//*Label 28334*/ GIMT_Encode4(2144493), // Rule ID 17738 //
     /* 2144407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2144418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2144421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2144424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144453 */     // MIs[0] round
     /* 2144453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144456 */     // MIs[0] policy
     /* 2144456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144466 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2144469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144492 */     // GIR_Coverage, 17738,
     /* 2144492 */     GIR_EraseRootFromParent_Done,
     /* 2144493 */   // Label 28334: @2144493
     /* 2144493 */   GIM_Try, /*On fail goto*//*Label 28335*/ GIMT_Encode4(2144584), // Rule ID 17739 //
     /* 2144498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2144509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2144512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2144515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144544 */     // MIs[0] round
     /* 2144544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144547 */     // MIs[0] policy
     /* 2144547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144557 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2144560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144583 */     // GIR_Coverage, 17739,
     /* 2144583 */     GIR_EraseRootFromParent_Done,
     /* 2144584 */   // Label 28335: @2144584
     /* 2144584 */   GIM_Try, /*On fail goto*//*Label 28336*/ GIMT_Encode4(2144675), // Rule ID 17742 //
     /* 2144589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2144600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2144603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2144606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144635 */     // MIs[0] round
     /* 2144635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144638 */     // MIs[0] policy
     /* 2144638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144648 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2144651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144674 */     // GIR_Coverage, 17742,
     /* 2144674 */     GIR_EraseRootFromParent_Done,
     /* 2144675 */   // Label 28336: @2144675
     /* 2144675 */   GIM_Try, /*On fail goto*//*Label 28337*/ GIMT_Encode4(2144766), // Rule ID 17743 //
     /* 2144680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2144691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2144694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2144697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144726 */     // MIs[0] round
     /* 2144726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144729 */     // MIs[0] policy
     /* 2144729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144739 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2144742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144765 */     // GIR_Coverage, 17743,
     /* 2144765 */     GIR_EraseRootFromParent_Done,
     /* 2144766 */   // Label 28337: @2144766
     /* 2144766 */   GIM_Try, /*On fail goto*//*Label 28338*/ GIMT_Encode4(2144857), // Rule ID 17746 //
     /* 2144771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2144782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144817 */     // MIs[0] round
     /* 2144817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144820 */     // MIs[0] policy
     /* 2144820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144830 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2144833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144856 */     // GIR_Coverage, 17746,
     /* 2144856 */     GIR_EraseRootFromParent_Done,
     /* 2144857 */   // Label 28338: @2144857
     /* 2144857 */   GIM_Try, /*On fail goto*//*Label 28339*/ GIMT_Encode4(2144948), // Rule ID 17747 //
     /* 2144862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2144873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144908 */     // MIs[0] round
     /* 2144908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144911 */     // MIs[0] policy
     /* 2144911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144921 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2144924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144947 */     // GIR_Coverage, 17747,
     /* 2144947 */     GIR_EraseRootFromParent_Done,
     /* 2144948 */   // Label 28339: @2144948
     /* 2144948 */   GIM_Try, /*On fail goto*//*Label 28340*/ GIMT_Encode4(2145039), // Rule ID 17750 //
     /* 2144953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2144964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2144967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2144970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2144976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144999 */     // MIs[0] round
     /* 2144999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145002 */     // MIs[0] policy
     /* 2145002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145012 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2145015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145038 */     // GIR_Coverage, 17750,
     /* 2145038 */     GIR_EraseRootFromParent_Done,
     /* 2145039 */   // Label 28340: @2145039
     /* 2145039 */   GIM_Try, /*On fail goto*//*Label 28341*/ GIMT_Encode4(2145130), // Rule ID 17751 //
     /* 2145044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2145047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2145055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2145058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2145061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2145064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2145067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2145086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145090 */     // MIs[0] round
     /* 2145090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145093 */     // MIs[0] policy
     /* 2145093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145103 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2145106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145129 */     // GIR_Coverage, 17751,
     /* 2145129 */     GIR_EraseRootFromParent_Done,
     /* 2145130 */   // Label 28341: @2145130
     /* 2145130 */   GIM_Try, /*On fail goto*//*Label 28342*/ GIMT_Encode4(2145221), // Rule ID 17754 //
     /* 2145135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2145138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2145146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2145149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2145152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145181 */     // MIs[0] round
     /* 2145181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145184 */     // MIs[0] policy
     /* 2145184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145194 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2145197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145220 */     // GIR_Coverage, 17754,
     /* 2145220 */     GIR_EraseRootFromParent_Done,
     /* 2145221 */   // Label 28342: @2145221
     /* 2145221 */   GIM_Try, /*On fail goto*//*Label 28343*/ GIMT_Encode4(2145312), // Rule ID 17755 //
     /* 2145226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2145229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2145237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2145240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2145243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145272 */     // MIs[0] round
     /* 2145272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145275 */     // MIs[0] policy
     /* 2145275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145285 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2145288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145311 */     // GIR_Coverage, 17755,
     /* 2145311 */     GIR_EraseRootFromParent_Done,
     /* 2145312 */   // Label 28343: @2145312
     /* 2145312 */   GIM_Try, /*On fail goto*//*Label 28344*/ GIMT_Encode4(2145403), // Rule ID 17758 //
     /* 2145317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2145320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2145328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2145331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2145334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2145347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145363 */     // MIs[0] round
     /* 2145363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145366 */     // MIs[0] policy
     /* 2145366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145376 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2145379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145402 */     // GIR_Coverage, 17758,
     /* 2145402 */     GIR_EraseRootFromParent_Done,
     /* 2145403 */   // Label 28344: @2145403
     /* 2145403 */   GIM_Try, /*On fail goto*//*Label 28345*/ GIMT_Encode4(2145494), // Rule ID 17759 //
     /* 2145408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2145411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2145419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2145422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2145425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2145438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145454 */     // MIs[0] round
     /* 2145454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145457 */     // MIs[0] policy
     /* 2145457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145467 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2145470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145493 */     // GIR_Coverage, 17759,
     /* 2145493 */     GIR_EraseRootFromParent_Done,
     /* 2145494 */   // Label 28345: @2145494
     /* 2145494 */   GIM_Try, /*On fail goto*//*Label 28346*/ GIMT_Encode4(2145585), // Rule ID 17762 //
     /* 2145499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2145502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2145510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2145513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2145516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145545 */     // MIs[0] round
     /* 2145545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145548 */     // MIs[0] policy
     /* 2145548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145558 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2145561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145584 */     // GIR_Coverage, 17762,
     /* 2145584 */     GIR_EraseRootFromParent_Done,
     /* 2145585 */   // Label 28346: @2145585
     /* 2145585 */   GIM_Try, /*On fail goto*//*Label 28347*/ GIMT_Encode4(2145676), // Rule ID 17763 //
     /* 2145590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2145593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2145601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2145604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2145607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145636 */     // MIs[0] round
     /* 2145636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145639 */     // MIs[0] policy
     /* 2145639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145649 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2145652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145675 */     // GIR_Coverage, 17763,
     /* 2145675 */     GIR_EraseRootFromParent_Done,
     /* 2145676 */   // Label 28347: @2145676
     /* 2145676 */   GIM_Try, /*On fail goto*//*Label 28348*/ GIMT_Encode4(2145767), // Rule ID 17766 //
     /* 2145681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2145684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2145692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145727 */     // MIs[0] round
     /* 2145727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145730 */     // MIs[0] policy
     /* 2145730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145740 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2145743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145766 */     // GIR_Coverage, 17766,
     /* 2145766 */     GIR_EraseRootFromParent_Done,
     /* 2145767 */   // Label 28348: @2145767
     /* 2145767 */   GIM_Try, /*On fail goto*//*Label 28349*/ GIMT_Encode4(2145858), // Rule ID 17767 //
     /* 2145772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2145775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2145783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145818 */     // MIs[0] round
     /* 2145818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145821 */     // MIs[0] policy
     /* 2145821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145831 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2145834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145857 */     // GIR_Coverage, 17767,
     /* 2145857 */     GIR_EraseRootFromParent_Done,
     /* 2145858 */   // Label 28349: @2145858
     /* 2145858 */   GIM_Try, /*On fail goto*//*Label 28350*/ GIMT_Encode4(2145949), // Rule ID 17770 //
     /* 2145863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2145866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2145874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2145877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2145880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2145883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145909 */     // MIs[0] round
     /* 2145909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145912 */     // MIs[0] policy
     /* 2145912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145922 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2145925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145948 */     // GIR_Coverage, 17770,
     /* 2145948 */     GIR_EraseRootFromParent_Done,
     /* 2145949 */   // Label 28350: @2145949
     /* 2145949 */   GIM_Try, /*On fail goto*//*Label 28351*/ GIMT_Encode4(2146040), // Rule ID 17771 //
     /* 2145954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2145957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2145965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2145968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2145971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2145974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146000 */     // MIs[0] round
     /* 2146000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146003 */     // MIs[0] policy
     /* 2146003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146013 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2146016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146039 */     // GIR_Coverage, 17771,
     /* 2146039 */     GIR_EraseRootFromParent_Done,
     /* 2146040 */   // Label 28351: @2146040
     /* 2146040 */   GIM_Try, /*On fail goto*//*Label 28352*/ GIMT_Encode4(2146131), // Rule ID 17774 //
     /* 2146045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2146048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2146056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2146059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2146062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2146065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146091 */     // MIs[0] round
     /* 2146091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146094 */     // MIs[0] policy
     /* 2146094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146104 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2146107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146130 */     // GIR_Coverage, 17774,
     /* 2146130 */     GIR_EraseRootFromParent_Done,
     /* 2146131 */   // Label 28352: @2146131
     /* 2146131 */   GIM_Try, /*On fail goto*//*Label 28353*/ GIMT_Encode4(2146222), // Rule ID 17775 //
     /* 2146136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2146139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2146147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2146150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2146153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2146156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146182 */     // MIs[0] round
     /* 2146182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146185 */     // MIs[0] policy
     /* 2146185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146195 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2146198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146221 */     // GIR_Coverage, 17775,
     /* 2146221 */     GIR_EraseRootFromParent_Done,
     /* 2146222 */   // Label 28353: @2146222
     /* 2146222 */   GIM_Try, /*On fail goto*//*Label 28354*/ GIMT_Encode4(2146313), // Rule ID 17778 //
     /* 2146227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2146238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2146241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2146244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2146247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146273 */     // MIs[0] round
     /* 2146273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146276 */     // MIs[0] policy
     /* 2146276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146286 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2146289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146312 */     // GIR_Coverage, 17778,
     /* 2146312 */     GIR_EraseRootFromParent_Done,
     /* 2146313 */   // Label 28354: @2146313
     /* 2146313 */   GIM_Try, /*On fail goto*//*Label 28355*/ GIMT_Encode4(2146404), // Rule ID 17779 //
     /* 2146318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2146329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2146332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2146335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2146338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146364 */     // MIs[0] round
     /* 2146364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146367 */     // MIs[0] policy
     /* 2146367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146377 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2146380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146403 */     // GIR_Coverage, 17779,
     /* 2146403 */     GIR_EraseRootFromParent_Done,
     /* 2146404 */   // Label 28355: @2146404
     /* 2146404 */   GIM_Try, /*On fail goto*//*Label 28356*/ GIMT_Encode4(2146495), // Rule ID 17782 //
     /* 2146409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2146412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2146420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2146423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2146426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2146429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2146432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146455 */     // MIs[0] round
     /* 2146455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146458 */     // MIs[0] policy
     /* 2146458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146468 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2146471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146494 */     // GIR_Coverage, 17782,
     /* 2146494 */     GIR_EraseRootFromParent_Done,
     /* 2146495 */   // Label 28356: @2146495
     /* 2146495 */   GIM_Try, /*On fail goto*//*Label 28357*/ GIMT_Encode4(2146586), // Rule ID 17783 //
     /* 2146500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2146503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2146511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2146514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2146517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2146520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2146523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146546 */     // MIs[0] round
     /* 2146546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146549 */     // MIs[0] policy
     /* 2146549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146559 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2146562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146585 */     // GIR_Coverage, 17783,
     /* 2146585 */     GIR_EraseRootFromParent_Done,
     /* 2146586 */   // Label 28357: @2146586
     /* 2146586 */   GIM_Try, /*On fail goto*//*Label 28358*/ GIMT_Encode4(2146677), // Rule ID 17786 //
     /* 2146591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2146594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2146602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2146605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2146608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2146611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146637 */     // MIs[0] round
     /* 2146637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146640 */     // MIs[0] policy
     /* 2146640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146650 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2146653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146676 */     // GIR_Coverage, 17786,
     /* 2146676 */     GIR_EraseRootFromParent_Done,
     /* 2146677 */   // Label 28358: @2146677
     /* 2146677 */   GIM_Try, /*On fail goto*//*Label 28359*/ GIMT_Encode4(2146768), // Rule ID 17787 //
     /* 2146682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2146685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2146693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2146696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2146699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2146702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146728 */     // MIs[0] round
     /* 2146728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146731 */     // MIs[0] policy
     /* 2146731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146741 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2146744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146767 */     // GIR_Coverage, 17787,
     /* 2146767 */     GIR_EraseRootFromParent_Done,
     /* 2146768 */   // Label 28359: @2146768
     /* 2146768 */   GIM_Try, /*On fail goto*//*Label 28360*/ GIMT_Encode4(2146859), // Rule ID 17790 //
     /* 2146773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2146784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2146793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146819 */     // MIs[0] round
     /* 2146819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146822 */     // MIs[0] policy
     /* 2146822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146832 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2146835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146858 */     // GIR_Coverage, 17790,
     /* 2146858 */     GIR_EraseRootFromParent_Done,
     /* 2146859 */   // Label 28360: @2146859
     /* 2146859 */   GIM_Try, /*On fail goto*//*Label 28361*/ GIMT_Encode4(2146950), // Rule ID 17791 //
     /* 2146864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2146875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2146884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146910 */     // MIs[0] round
     /* 2146910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146913 */     // MIs[0] policy
     /* 2146913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146923 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2146926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146949 */     // GIR_Coverage, 17791,
     /* 2146949 */     GIR_EraseRootFromParent_Done,
     /* 2146950 */   // Label 28361: @2146950
     /* 2146950 */   GIM_Try, /*On fail goto*//*Label 28362*/ GIMT_Encode4(2147041), // Rule ID 17794 //
     /* 2146955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2146966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2146969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2146972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2146975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2146978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147001 */     // MIs[0] round
     /* 2147001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147004 */     // MIs[0] policy
     /* 2147004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147014 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2147017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147040 */     // GIR_Coverage, 17794,
     /* 2147040 */     GIR_EraseRootFromParent_Done,
     /* 2147041 */   // Label 28362: @2147041
     /* 2147041 */   GIM_Try, /*On fail goto*//*Label 28363*/ GIMT_Encode4(2147132), // Rule ID 17795 //
     /* 2147046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2147049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2147057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2147060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2147063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2147066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147092 */     // MIs[0] round
     /* 2147092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147095 */     // MIs[0] policy
     /* 2147095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147105 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2147108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147131 */     // GIR_Coverage, 17795,
     /* 2147131 */     GIR_EraseRootFromParent_Done,
     /* 2147132 */   // Label 28363: @2147132
     /* 2147132 */   GIM_Try, /*On fail goto*//*Label 28364*/ GIMT_Encode4(2147223), // Rule ID 17798 //
     /* 2147137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2147140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2147148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2147151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2147154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2147157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2147160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147183 */     // MIs[0] round
     /* 2147183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147186 */     // MIs[0] policy
     /* 2147186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147196 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2147199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147222 */     // GIR_Coverage, 17798,
     /* 2147222 */     GIR_EraseRootFromParent_Done,
     /* 2147223 */   // Label 28364: @2147223
     /* 2147223 */   GIM_Try, /*On fail goto*//*Label 28365*/ GIMT_Encode4(2147314), // Rule ID 17799 //
     /* 2147228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2147231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2147239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2147242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2147245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2147248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2147251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147274 */     // MIs[0] round
     /* 2147274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147277 */     // MIs[0] policy
     /* 2147277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147287 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2147290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147313 */     // GIR_Coverage, 17799,
     /* 2147313 */     GIR_EraseRootFromParent_Done,
     /* 2147314 */   // Label 28365: @2147314
     /* 2147314 */   GIM_Try, /*On fail goto*//*Label 28366*/ GIMT_Encode4(2147405), // Rule ID 17802 //
     /* 2147319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2147322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2147330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2147333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2147336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2147339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147365 */     // MIs[0] round
     /* 2147365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147368 */     // MIs[0] policy
     /* 2147368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147378 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2147381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147404 */     // GIR_Coverage, 17802,
     /* 2147404 */     GIR_EraseRootFromParent_Done,
     /* 2147405 */   // Label 28366: @2147405
     /* 2147405 */   GIM_Try, /*On fail goto*//*Label 28367*/ GIMT_Encode4(2147496), // Rule ID 17803 //
     /* 2147410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2147413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2147421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2147424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2147427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2147430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147456 */     // MIs[0] round
     /* 2147456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147459 */     // MIs[0] policy
     /* 2147459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147469 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2147472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147495 */     // GIR_Coverage, 17803,
     /* 2147495 */     GIR_EraseRootFromParent_Done,
     /* 2147496 */   // Label 28367: @2147496
     /* 2147496 */   GIM_Try, /*On fail goto*//*Label 28368*/ GIMT_Encode4(2147587), // Rule ID 17806 //
     /* 2147501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2147504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2147512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2147515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2147518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2147521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147547 */     // MIs[0] round
     /* 2147547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147550 */     // MIs[0] policy
     /* 2147550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147560 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2147563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147586 */     // GIR_Coverage, 17806,
     /* 2147586 */     GIR_EraseRootFromParent_Done,
     /* 2147587 */   // Label 28368: @2147587
     /* 2147587 */   GIM_Try, /*On fail goto*//*Label 28369*/ GIMT_Encode4(2147678), // Rule ID 17807 //
     /* 2147592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2147595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2147603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2147606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2147609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2147612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147638 */     // MIs[0] round
     /* 2147638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147641 */     // MIs[0] policy
     /* 2147641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147651 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2147654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147677 */     // GIR_Coverage, 17807,
     /* 2147677 */     GIR_EraseRootFromParent_Done,
     /* 2147678 */   // Label 28369: @2147678
     /* 2147678 */   GIM_Try, /*On fail goto*//*Label 28370*/ GIMT_Encode4(2147769), // Rule ID 17810 //
     /* 2147683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2147686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2147694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2147703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147729 */     // MIs[0] round
     /* 2147729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147732 */     // MIs[0] policy
     /* 2147732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147742 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2147745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147768 */     // GIR_Coverage, 17810,
     /* 2147768 */     GIR_EraseRootFromParent_Done,
     /* 2147769 */   // Label 28370: @2147769
     /* 2147769 */   GIM_Try, /*On fail goto*//*Label 28371*/ GIMT_Encode4(2147860), // Rule ID 17811 //
     /* 2147774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2147777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2147785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2147794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147820 */     // MIs[0] round
     /* 2147820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147823 */     // MIs[0] policy
     /* 2147823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147833 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2147836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147859 */     // GIR_Coverage, 17811,
     /* 2147859 */     GIR_EraseRootFromParent_Done,
     /* 2147860 */   // Label 28371: @2147860
     /* 2147860 */   GIM_Try, /*On fail goto*//*Label 28372*/ GIMT_Encode4(2147951), // Rule ID 17814 //
     /* 2147865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2147868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2147876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2147879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2147882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2147885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147911 */     // MIs[0] round
     /* 2147911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147914 */     // MIs[0] policy
     /* 2147914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147924 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2147927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147950 */     // GIR_Coverage, 17814,
     /* 2147950 */     GIR_EraseRootFromParent_Done,
     /* 2147951 */   // Label 28372: @2147951
     /* 2147951 */   GIM_Try, /*On fail goto*//*Label 28373*/ GIMT_Encode4(2148042), // Rule ID 17815 //
     /* 2147956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2147959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2147967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2147970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2147973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2147976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148002 */     // MIs[0] round
     /* 2148002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148005 */     // MIs[0] policy
     /* 2148005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148015 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2148018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148041 */     // GIR_Coverage, 17815,
     /* 2148041 */     GIR_EraseRootFromParent_Done,
     /* 2148042 */   // Label 28373: @2148042
     /* 2148042 */   GIM_Try, /*On fail goto*//*Label 28374*/ GIMT_Encode4(2148133), // Rule ID 17818 //
     /* 2148047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2148050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2148058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2148061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2148064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2148067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2148077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148093 */     // MIs[0] round
     /* 2148093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148096 */     // MIs[0] policy
     /* 2148096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148106 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2148109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148132 */     // GIR_Coverage, 17818,
     /* 2148132 */     GIR_EraseRootFromParent_Done,
     /* 2148133 */   // Label 28374: @2148133
     /* 2148133 */   GIM_Try, /*On fail goto*//*Label 28375*/ GIMT_Encode4(2148224), // Rule ID 17819 //
     /* 2148138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2148141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2148149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2148152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2148155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2148158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2148168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148184 */     // MIs[0] round
     /* 2148184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148187 */     // MIs[0] policy
     /* 2148187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148197 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2148200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148223 */     // GIR_Coverage, 17819,
     /* 2148223 */     GIR_EraseRootFromParent_Done,
     /* 2148224 */   // Label 28375: @2148224
     /* 2148224 */   GIM_Try, /*On fail goto*//*Label 28376*/ GIMT_Encode4(2148315), // Rule ID 17822 //
     /* 2148229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2148232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2148240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2148243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2148246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2148249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2148252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2148259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148275 */     // MIs[0] round
     /* 2148275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148278 */     // MIs[0] policy
     /* 2148278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148288 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2148291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148314 */     // GIR_Coverage, 17822,
     /* 2148314 */     GIR_EraseRootFromParent_Done,
     /* 2148315 */   // Label 28376: @2148315
     /* 2148315 */   GIM_Try, /*On fail goto*//*Label 28377*/ GIMT_Encode4(2148406), // Rule ID 17823 //
     /* 2148320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2148323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2148331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2148334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2148337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2148340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2148343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2148350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148366 */     // MIs[0] round
     /* 2148366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148369 */     // MIs[0] policy
     /* 2148369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148379 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2148382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148405 */     // GIR_Coverage, 17823,
     /* 2148405 */     GIR_EraseRootFromParent_Done,
     /* 2148406 */   // Label 28377: @2148406
     /* 2148406 */   GIM_Try, /*On fail goto*//*Label 28378*/ GIMT_Encode4(2148497), // Rule ID 17826 //
     /* 2148411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2148422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2148425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2148431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148457 */     // MIs[0] round
     /* 2148457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148460 */     // MIs[0] policy
     /* 2148460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148470 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2148473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148496 */     // GIR_Coverage, 17826,
     /* 2148496 */     GIR_EraseRootFromParent_Done,
     /* 2148497 */   // Label 28378: @2148497
     /* 2148497 */   GIM_Try, /*On fail goto*//*Label 28379*/ GIMT_Encode4(2148588), // Rule ID 17827 //
     /* 2148502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2148513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2148516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2148522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148548 */     // MIs[0] round
     /* 2148548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148551 */     // MIs[0] policy
     /* 2148551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148561 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2148564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148587 */     // GIR_Coverage, 17827,
     /* 2148587 */     GIR_EraseRootFromParent_Done,
     /* 2148588 */   // Label 28379: @2148588
     /* 2148588 */   GIM_Try, /*On fail goto*//*Label 28380*/ GIMT_Encode4(2148679), // Rule ID 17830 //
     /* 2148593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2148604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2148607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2148613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148639 */     // MIs[0] round
     /* 2148639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148642 */     // MIs[0] policy
     /* 2148642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148652 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2148655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148678 */     // GIR_Coverage, 17830,
     /* 2148678 */     GIR_EraseRootFromParent_Done,
     /* 2148679 */   // Label 28380: @2148679
     /* 2148679 */   GIM_Try, /*On fail goto*//*Label 28381*/ GIMT_Encode4(2148770), // Rule ID 17831 //
     /* 2148684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2148695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2148698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2148704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148730 */     // MIs[0] round
     /* 2148730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148733 */     // MIs[0] policy
     /* 2148733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148743 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2148746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148769 */     // GIR_Coverage, 17831,
     /* 2148769 */     GIR_EraseRootFromParent_Done,
     /* 2148770 */   // Label 28381: @2148770
     /* 2148770 */   GIM_Try, /*On fail goto*//*Label 28382*/ GIMT_Encode4(2148861), // Rule ID 17834 //
     /* 2148775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2148778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2148786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2148789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2148795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148821 */     // MIs[0] round
     /* 2148821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148824 */     // MIs[0] policy
     /* 2148824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148834 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2148837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148860 */     // GIR_Coverage, 17834,
     /* 2148860 */     GIR_EraseRootFromParent_Done,
     /* 2148861 */   // Label 28382: @2148861
     /* 2148861 */   GIM_Try, /*On fail goto*//*Label 28383*/ GIMT_Encode4(2148952), // Rule ID 17835 //
     /* 2148866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2148869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2148877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2148880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2148886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148912 */     // MIs[0] round
     /* 2148912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148915 */     // MIs[0] policy
     /* 2148915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148925 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2148928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148951 */     // GIR_Coverage, 17835,
     /* 2148951 */     GIR_EraseRootFromParent_Done,
     /* 2148952 */   // Label 28383: @2148952
     /* 2148952 */   GIM_Try, /*On fail goto*//*Label 28384*/ GIMT_Encode4(2149043), // Rule ID 17838 //
     /* 2148957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2148968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2148971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2148977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149003 */     // MIs[0] round
     /* 2149003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149006 */     // MIs[0] policy
     /* 2149006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149016 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2149019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149042 */     // GIR_Coverage, 17838,
     /* 2149042 */     GIR_EraseRootFromParent_Done,
     /* 2149043 */   // Label 28384: @2149043
     /* 2149043 */   GIM_Try, /*On fail goto*//*Label 28385*/ GIMT_Encode4(2149134), // Rule ID 17839 //
     /* 2149048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2149059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2149062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2149068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2149071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149094 */     // MIs[0] round
     /* 2149094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149097 */     // MIs[0] policy
     /* 2149097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149107 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2149110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149133 */     // GIR_Coverage, 17839,
     /* 2149133 */     GIR_EraseRootFromParent_Done,
     /* 2149134 */   // Label 28385: @2149134
     /* 2149134 */   GIM_Try, /*On fail goto*//*Label 28386*/ GIMT_Encode4(2149225), // Rule ID 17842 //
     /* 2149139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2149150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2149153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2149159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2149162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149185 */     // MIs[0] round
     /* 2149185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149188 */     // MIs[0] policy
     /* 2149188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149198 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2149201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149224 */     // GIR_Coverage, 17842,
     /* 2149224 */     GIR_EraseRootFromParent_Done,
     /* 2149225 */   // Label 28386: @2149225
     /* 2149225 */   GIM_Try, /*On fail goto*//*Label 28387*/ GIMT_Encode4(2149316), // Rule ID 17843 //
     /* 2149230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2149233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2149241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2149244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2149250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2149253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149276 */     // MIs[0] round
     /* 2149276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149279 */     // MIs[0] policy
     /* 2149279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149289 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2149292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149315 */     // GIR_Coverage, 17843,
     /* 2149315 */     GIR_EraseRootFromParent_Done,
     /* 2149316 */   // Label 28387: @2149316
     /* 2149316 */   GIM_Try, /*On fail goto*//*Label 28388*/ GIMT_Encode4(2149407), // Rule ID 17846 //
     /* 2149321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2149324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2149332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2149335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2149338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2149341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2149344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2149359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149367 */     // MIs[0] round
     /* 2149367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149370 */     // MIs[0] policy
     /* 2149370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149380 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2149383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2149403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149406 */     // GIR_Coverage, 17846,
     /* 2149406 */     GIR_EraseRootFromParent_Done,
     /* 2149407 */   // Label 28388: @2149407
     /* 2149407 */   GIM_Try, /*On fail goto*//*Label 28389*/ GIMT_Encode4(2149498), // Rule ID 17847 //
     /* 2149412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2149415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2149423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2149426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2149429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2149432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2149435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2149450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149458 */     // MIs[0] round
     /* 2149458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149461 */     // MIs[0] policy
     /* 2149461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149471 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2149474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2149494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149497 */     // GIR_Coverage, 17847,
     /* 2149497 */     GIR_EraseRootFromParent_Done,
     /* 2149498 */   // Label 28389: @2149498
     /* 2149498 */   GIM_Try, /*On fail goto*//*Label 28390*/ GIMT_Encode4(2149589), // Rule ID 17850 //
     /* 2149503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2149514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2149517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2149523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149549 */     // MIs[0] round
     /* 2149549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149552 */     // MIs[0] policy
     /* 2149552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149562 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2149565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149588 */     // GIR_Coverage, 17850,
     /* 2149588 */     GIR_EraseRootFromParent_Done,
     /* 2149589 */   // Label 28390: @2149589
     /* 2149589 */   GIM_Try, /*On fail goto*//*Label 28391*/ GIMT_Encode4(2149680), // Rule ID 17851 //
     /* 2149594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2149605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2149608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2149614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149640 */     // MIs[0] round
     /* 2149640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149643 */     // MIs[0] policy
     /* 2149643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149653 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2149656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149679 */     // GIR_Coverage, 17851,
     /* 2149679 */     GIR_EraseRootFromParent_Done,
     /* 2149680 */   // Label 28391: @2149680
     /* 2149680 */   GIM_Try, /*On fail goto*//*Label 28392*/ GIMT_Encode4(2149771), // Rule ID 17854 //
     /* 2149685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2149696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2149705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149731 */     // MIs[0] round
     /* 2149731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149734 */     // MIs[0] policy
     /* 2149734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149744 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2149747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149770 */     // GIR_Coverage, 17854,
     /* 2149770 */     GIR_EraseRootFromParent_Done,
     /* 2149771 */   // Label 28392: @2149771
     /* 2149771 */   GIM_Try, /*On fail goto*//*Label 28393*/ GIMT_Encode4(2149862), // Rule ID 17855 //
     /* 2149776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2149787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2149796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149822 */     // MIs[0] round
     /* 2149822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149825 */     // MIs[0] policy
     /* 2149825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149835 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2149838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149861 */     // GIR_Coverage, 17855,
     /* 2149861 */     GIR_EraseRootFromParent_Done,
     /* 2149862 */   // Label 28393: @2149862
     /* 2149862 */   GIM_Try, /*On fail goto*//*Label 28394*/ GIMT_Encode4(2149953), // Rule ID 17858 //
     /* 2149867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2149878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2149881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2149887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2149890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149913 */     // MIs[0] round
     /* 2149913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149916 */     // MIs[0] policy
     /* 2149916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149926 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2149929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149952 */     // GIR_Coverage, 17858,
     /* 2149952 */     GIR_EraseRootFromParent_Done,
     /* 2149953 */   // Label 28394: @2149953
     /* 2149953 */   GIM_Try, /*On fail goto*//*Label 28395*/ GIMT_Encode4(2150044), // Rule ID 17859 //
     /* 2149958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2149969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2149972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2149978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2149981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150004 */     // MIs[0] round
     /* 2150004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150007 */     // MIs[0] policy
     /* 2150007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150017 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2150020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150043 */     // GIR_Coverage, 17859,
     /* 2150043 */     GIR_EraseRootFromParent_Done,
     /* 2150044 */   // Label 28395: @2150044
     /* 2150044 */   GIM_Try, /*On fail goto*//*Label 28396*/ GIMT_Encode4(2150135), // Rule ID 17862 //
     /* 2150049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2150052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2150060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2150063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2150069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150095 */     // MIs[0] round
     /* 2150095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150098 */     // MIs[0] policy
     /* 2150098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150108 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2150111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150134 */     // GIR_Coverage, 17862,
     /* 2150134 */     GIR_EraseRootFromParent_Done,
     /* 2150135 */   // Label 28396: @2150135
     /* 2150135 */   GIM_Try, /*On fail goto*//*Label 28397*/ GIMT_Encode4(2150226), // Rule ID 17863 //
     /* 2150140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2150151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2150154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2150160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150186 */     // MIs[0] round
     /* 2150186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150189 */     // MIs[0] policy
     /* 2150189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150199 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2150202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150225 */     // GIR_Coverage, 17863,
     /* 2150225 */     GIR_EraseRootFromParent_Done,
     /* 2150226 */   // Label 28397: @2150226
     /* 2150226 */   GIM_Try, /*On fail goto*//*Label 28398*/ GIMT_Encode4(2150317), // Rule ID 17866 //
     /* 2150231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2150234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2150242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2150245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2150251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150277 */     // MIs[0] round
     /* 2150277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150280 */     // MIs[0] policy
     /* 2150280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150290 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2150293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150316 */     // GIR_Coverage, 17866,
     /* 2150316 */     GIR_EraseRootFromParent_Done,
     /* 2150317 */   // Label 28398: @2150317
     /* 2150317 */   GIM_Try, /*On fail goto*//*Label 28399*/ GIMT_Encode4(2150408), // Rule ID 17867 //
     /* 2150322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2150333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2150336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2150342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150368 */     // MIs[0] round
     /* 2150368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150371 */     // MIs[0] policy
     /* 2150371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150381 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2150384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150407 */     // GIR_Coverage, 17867,
     /* 2150407 */     GIR_EraseRootFromParent_Done,
     /* 2150408 */   // Label 28399: @2150408
     /* 2150408 */   GIM_Try, /*On fail goto*//*Label 28400*/ GIMT_Encode4(2150499), // Rule ID 17870 //
     /* 2150413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2150416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2150424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2150427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2150433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2150436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150459 */     // MIs[0] round
     /* 2150459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150462 */     // MIs[0] policy
     /* 2150462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150472 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2150475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150498 */     // GIR_Coverage, 17870,
     /* 2150498 */     GIR_EraseRootFromParent_Done,
     /* 2150499 */   // Label 28400: @2150499
     /* 2150499 */   GIM_Try, /*On fail goto*//*Label 28401*/ GIMT_Encode4(2150590), // Rule ID 17871 //
     /* 2150504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2150515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2150518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2150524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2150527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150550 */     // MIs[0] round
     /* 2150550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150553 */     // MIs[0] policy
     /* 2150553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150563 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2150566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150589 */     // GIR_Coverage, 17871,
     /* 2150589 */     GIR_EraseRootFromParent_Done,
     /* 2150590 */   // Label 28401: @2150590
     /* 2150590 */   GIM_Try, /*On fail goto*//*Label 28402*/ GIMT_Encode4(2150681), // Rule ID 17874 //
     /* 2150595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2150606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2150609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2150615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150641 */     // MIs[0] round
     /* 2150641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150644 */     // MIs[0] policy
     /* 2150644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150654 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2150657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150680 */     // GIR_Coverage, 17874,
     /* 2150680 */     GIR_EraseRootFromParent_Done,
     /* 2150681 */   // Label 28402: @2150681
     /* 2150681 */   GIM_Try, /*On fail goto*//*Label 28403*/ GIMT_Encode4(2150772), // Rule ID 17875 //
     /* 2150686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2150697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2150700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2150706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150732 */     // MIs[0] round
     /* 2150732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150735 */     // MIs[0] policy
     /* 2150735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150745 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2150748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150771 */     // GIR_Coverage, 17875,
     /* 2150771 */     GIR_EraseRootFromParent_Done,
     /* 2150772 */   // Label 28403: @2150772
     /* 2150772 */   GIM_Try, /*On fail goto*//*Label 28404*/ GIMT_Encode4(2150863), // Rule ID 17878 //
     /* 2150777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2150788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2150791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2150797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150823 */     // MIs[0] round
     /* 2150823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150826 */     // MIs[0] policy
     /* 2150826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150836 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2150839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150862 */     // GIR_Coverage, 17878,
     /* 2150862 */     GIR_EraseRootFromParent_Done,
     /* 2150863 */   // Label 28404: @2150863
     /* 2150863 */   GIM_Try, /*On fail goto*//*Label 28405*/ GIMT_Encode4(2150954), // Rule ID 17879 //
     /* 2150868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2150879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2150882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2150888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150914 */     // MIs[0] round
     /* 2150914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150917 */     // MIs[0] policy
     /* 2150917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150927 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2150930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150953 */     // GIR_Coverage, 17879,
     /* 2150953 */     GIR_EraseRootFromParent_Done,
     /* 2150954 */   // Label 28405: @2150954
     /* 2150954 */   GIM_Try, /*On fail goto*//*Label 28406*/ GIMT_Encode4(2151045), // Rule ID 17882 //
     /* 2150959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2150970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2150973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2150979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151005 */     // MIs[0] round
     /* 2151005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151008 */     // MIs[0] policy
     /* 2151008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151018 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2151021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151044 */     // GIR_Coverage, 17882,
     /* 2151044 */     GIR_EraseRootFromParent_Done,
     /* 2151045 */   // Label 28406: @2151045
     /* 2151045 */   GIM_Try, /*On fail goto*//*Label 28407*/ GIMT_Encode4(2151136), // Rule ID 17883 //
     /* 2151050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2151053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2151061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2151064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2151067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2151070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2151080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2151088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151096 */     // MIs[0] round
     /* 2151096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151099 */     // MIs[0] policy
     /* 2151099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151109 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2151112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151135 */     // GIR_Coverage, 17883,
     /* 2151135 */     GIR_EraseRootFromParent_Done,
     /* 2151136 */   // Label 28407: @2151136
     /* 2151136 */   GIM_Try, /*On fail goto*//*Label 28408*/ GIMT_Encode4(2151227), // Rule ID 17886 //
     /* 2151141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2151152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2151155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2151158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2151161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151187 */     // MIs[0] round
     /* 2151187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151190 */     // MIs[0] policy
     /* 2151190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151200 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2151203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151226 */     // GIR_Coverage, 17886,
     /* 2151226 */     GIR_EraseRootFromParent_Done,
     /* 2151227 */   // Label 28408: @2151227
     /* 2151227 */   GIM_Try, /*On fail goto*//*Label 28409*/ GIMT_Encode4(2151318), // Rule ID 17887 //
     /* 2151232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2151243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2151246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2151249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2151252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151278 */     // MIs[0] round
     /* 2151278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151281 */     // MIs[0] policy
     /* 2151281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151291 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2151294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151317 */     // GIR_Coverage, 17887,
     /* 2151317 */     GIR_EraseRootFromParent_Done,
     /* 2151318 */   // Label 28409: @2151318
     /* 2151318 */   GIM_Try, /*On fail goto*//*Label 28410*/ GIMT_Encode4(2151409), // Rule ID 17890 //
     /* 2151323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2151334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2151337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2151340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2151343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151369 */     // MIs[0] round
     /* 2151369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151372 */     // MIs[0] policy
     /* 2151372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151382 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2151385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151408 */     // GIR_Coverage, 17890,
     /* 2151408 */     GIR_EraseRootFromParent_Done,
     /* 2151409 */   // Label 28410: @2151409
     /* 2151409 */   GIM_Try, /*On fail goto*//*Label 28411*/ GIMT_Encode4(2151500), // Rule ID 17891 //
     /* 2151414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2151425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2151428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2151431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2151434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151460 */     // MIs[0] round
     /* 2151460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151463 */     // MIs[0] policy
     /* 2151463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151473 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2151476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151499 */     // GIR_Coverage, 17891,
     /* 2151499 */     GIR_EraseRootFromParent_Done,
     /* 2151500 */   // Label 28411: @2151500
     /* 2151500 */   GIM_Try, /*On fail goto*//*Label 28412*/ GIMT_Encode4(2151591), // Rule ID 17894 //
     /* 2151505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2151516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2151519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2151522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2151525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151551 */     // MIs[0] round
     /* 2151551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151554 */     // MIs[0] policy
     /* 2151554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151564 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2151567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151590 */     // GIR_Coverage, 17894,
     /* 2151590 */     GIR_EraseRootFromParent_Done,
     /* 2151591 */   // Label 28412: @2151591
     /* 2151591 */   GIM_Try, /*On fail goto*//*Label 28413*/ GIMT_Encode4(2151682), // Rule ID 17895 //
     /* 2151596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2151599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2151607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2151610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2151613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2151616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151642 */     // MIs[0] round
     /* 2151642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151645 */     // MIs[0] policy
     /* 2151645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151655 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2151658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151681 */     // GIR_Coverage, 17895,
     /* 2151681 */     GIR_EraseRootFromParent_Done,
     /* 2151682 */   // Label 28413: @2151682
     /* 2151682 */   GIM_Try, /*On fail goto*//*Label 28414*/ GIMT_Encode4(2151773), // Rule ID 17898 //
     /* 2151687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2151698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2151701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2151704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2151707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151733 */     // MIs[0] round
     /* 2151733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151736 */     // MIs[0] policy
     /* 2151736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151746 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2151749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151772 */     // GIR_Coverage, 17898,
     /* 2151772 */     GIR_EraseRootFromParent_Done,
     /* 2151773 */   // Label 28414: @2151773
     /* 2151773 */   GIM_Try, /*On fail goto*//*Label 28415*/ GIMT_Encode4(2151864), // Rule ID 17899 //
     /* 2151778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2151789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2151792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2151795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2151798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151824 */     // MIs[0] round
     /* 2151824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151827 */     // MIs[0] policy
     /* 2151827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151837 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2151840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151863 */     // GIR_Coverage, 17899,
     /* 2151863 */     GIR_EraseRootFromParent_Done,
     /* 2151864 */   // Label 28415: @2151864
     /* 2151864 */   GIM_Try, /*On fail goto*//*Label 28416*/ GIMT_Encode4(2151955), // Rule ID 17902 //
     /* 2151869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2151880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2151883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2151886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2151889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151915 */     // MIs[0] round
     /* 2151915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151918 */     // MIs[0] policy
     /* 2151918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151928 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2151931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151954 */     // GIR_Coverage, 17902,
     /* 2151954 */     GIR_EraseRootFromParent_Done,
     /* 2151955 */   // Label 28416: @2151955
     /* 2151955 */   GIM_Try, /*On fail goto*//*Label 28417*/ GIMT_Encode4(2152046), // Rule ID 17903 //
     /* 2151960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2151963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2151971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2151974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2151977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2151980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152006 */     // MIs[0] round
     /* 2152006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152009 */     // MIs[0] policy
     /* 2152009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152019 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2152022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152045 */     // GIR_Coverage, 17903,
     /* 2152045 */     GIR_EraseRootFromParent_Done,
     /* 2152046 */   // Label 28417: @2152046
     /* 2152046 */   GIM_Try, /*On fail goto*//*Label 28418*/ GIMT_Encode4(2152137), // Rule ID 17906 //
     /* 2152051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2152054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2152062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2152065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2152068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2152071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152097 */     // MIs[0] round
     /* 2152097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152100 */     // MIs[0] policy
     /* 2152100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152110 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2152113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152136 */     // GIR_Coverage, 17906,
     /* 2152136 */     GIR_EraseRootFromParent_Done,
     /* 2152137 */   // Label 28418: @2152137
     /* 2152137 */   GIM_Try, /*On fail goto*//*Label 28419*/ GIMT_Encode4(2152228), // Rule ID 17907 //
     /* 2152142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2152145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2152153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2152156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2152159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2152162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152188 */     // MIs[0] round
     /* 2152188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152191 */     // MIs[0] policy
     /* 2152191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152201 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2152204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152227 */     // GIR_Coverage, 17907,
     /* 2152227 */     GIR_EraseRootFromParent_Done,
     /* 2152228 */   // Label 28419: @2152228
     /* 2152228 */   GIM_Try, /*On fail goto*//*Label 28420*/ GIMT_Encode4(2152319), // Rule ID 17910 //
     /* 2152233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2152236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2152244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2152247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2152250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2152253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152279 */     // MIs[0] round
     /* 2152279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152282 */     // MIs[0] policy
     /* 2152282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152292 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2152295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152318 */     // GIR_Coverage, 17910,
     /* 2152318 */     GIR_EraseRootFromParent_Done,
     /* 2152319 */   // Label 28420: @2152319
     /* 2152319 */   GIM_Try, /*On fail goto*//*Label 28421*/ GIMT_Encode4(2152410), // Rule ID 17911 //
     /* 2152324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2152335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2152338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2152341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2152344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152370 */     // MIs[0] round
     /* 2152370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152373 */     // MIs[0] policy
     /* 2152373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152383 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2152386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152409 */     // GIR_Coverage, 17911,
     /* 2152409 */     GIR_EraseRootFromParent_Done,
     /* 2152410 */   // Label 28421: @2152410
     /* 2152410 */   GIM_Try, /*On fail goto*//*Label 28422*/ GIMT_Encode4(2152501), // Rule ID 17914 //
     /* 2152415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2152418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2152426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2152429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2152432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2152435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2152438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152461 */     // MIs[0] round
     /* 2152461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152464 */     // MIs[0] policy
     /* 2152464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152474 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2152477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152500 */     // GIR_Coverage, 17914,
     /* 2152500 */     GIR_EraseRootFromParent_Done,
     /* 2152501 */   // Label 28422: @2152501
     /* 2152501 */   GIM_Try, /*On fail goto*//*Label 28423*/ GIMT_Encode4(2152592), // Rule ID 17915 //
     /* 2152506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2152517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2152520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2152523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2152526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2152529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152552 */     // MIs[0] round
     /* 2152552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152555 */     // MIs[0] policy
     /* 2152555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152565 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2152568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152591 */     // GIR_Coverage, 17915,
     /* 2152591 */     GIR_EraseRootFromParent_Done,
     /* 2152592 */   // Label 28423: @2152592
     /* 2152592 */   GIM_Try, /*On fail goto*//*Label 28424*/ GIMT_Encode4(2152683), // Rule ID 17918 //
     /* 2152597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2152600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2152608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2152611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2152614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2152617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2152620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152643 */     // MIs[0] round
     /* 2152643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152646 */     // MIs[0] policy
     /* 2152646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152656 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2152659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152682 */     // GIR_Coverage, 17918,
     /* 2152682 */     GIR_EraseRootFromParent_Done,
     /* 2152683 */   // Label 28424: @2152683
     /* 2152683 */   GIM_Try, /*On fail goto*//*Label 28425*/ GIMT_Encode4(2152774), // Rule ID 17919 //
     /* 2152688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2152699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2152702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2152705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2152708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2152711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152734 */     // MIs[0] round
     /* 2152734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152737 */     // MIs[0] policy
     /* 2152737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152747 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2152750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152773 */     // GIR_Coverage, 17919,
     /* 2152773 */     GIR_EraseRootFromParent_Done,
     /* 2152774 */   // Label 28425: @2152774
     /* 2152774 */   GIM_Try, /*On fail goto*//*Label 28426*/ GIMT_Encode4(2152865), // Rule ID 17922 //
     /* 2152779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2152790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2152793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2152796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2152799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152825 */     // MIs[0] round
     /* 2152825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152828 */     // MIs[0] policy
     /* 2152828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152838 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2152841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152864 */     // GIR_Coverage, 17922,
     /* 2152864 */     GIR_EraseRootFromParent_Done,
     /* 2152865 */   // Label 28426: @2152865
     /* 2152865 */   GIM_Try, /*On fail goto*//*Label 28427*/ GIMT_Encode4(2152956), // Rule ID 17923 //
     /* 2152870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2152881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2152884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2152887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2152890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152916 */     // MIs[0] round
     /* 2152916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152919 */     // MIs[0] policy
     /* 2152919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152929 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2152932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152955 */     // GIR_Coverage, 17923,
     /* 2152955 */     GIR_EraseRootFromParent_Done,
     /* 2152956 */   // Label 28427: @2152956
     /* 2152956 */   GIM_Try, /*On fail goto*//*Label 28428*/ GIMT_Encode4(2153047), // Rule ID 17926 //
     /* 2152961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2152972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2152975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2152978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2152981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153007 */     // MIs[0] round
     /* 2153007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153010 */     // MIs[0] policy
     /* 2153010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153020 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2153023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153046 */     // GIR_Coverage, 17926,
     /* 2153046 */     GIR_EraseRootFromParent_Done,
     /* 2153047 */   // Label 28428: @2153047
     /* 2153047 */   GIM_Try, /*On fail goto*//*Label 28429*/ GIMT_Encode4(2153138), // Rule ID 17927 //
     /* 2153052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2153063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2153066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2153069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2153072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153098 */     // MIs[0] round
     /* 2153098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153101 */     // MIs[0] policy
     /* 2153101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153111 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2153114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153137 */     // GIR_Coverage, 17927,
     /* 2153137 */     GIR_EraseRootFromParent_Done,
     /* 2153138 */   // Label 28429: @2153138
     /* 2153138 */   GIM_Try, /*On fail goto*//*Label 28430*/ GIMT_Encode4(2153229), // Rule ID 17930 //
     /* 2153143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2153146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2153154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2153157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2153160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2153163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2153166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153189 */     // MIs[0] round
     /* 2153189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153192 */     // MIs[0] policy
     /* 2153192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153202 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2153205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153228 */     // GIR_Coverage, 17930,
     /* 2153228 */     GIR_EraseRootFromParent_Done,
     /* 2153229 */   // Label 28430: @2153229
     /* 2153229 */   GIM_Try, /*On fail goto*//*Label 28431*/ GIMT_Encode4(2153320), // Rule ID 17931 //
     /* 2153234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2153245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2153248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2153251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2153254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2153257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153280 */     // MIs[0] round
     /* 2153280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153283 */     // MIs[0] policy
     /* 2153283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153293 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2153296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153319 */     // GIR_Coverage, 17931,
     /* 2153319 */     GIR_EraseRootFromParent_Done,
     /* 2153320 */   // Label 28431: @2153320
     /* 2153320 */   GIM_Try, /*On fail goto*//*Label 28432*/ GIMT_Encode4(2153411), // Rule ID 17934 //
     /* 2153325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2153328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2153336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2153339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2153342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2153345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2153355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153371 */     // MIs[0] round
     /* 2153371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153374 */     // MIs[0] policy
     /* 2153374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153384 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2153387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153410 */     // GIR_Coverage, 17934,
     /* 2153410 */     GIR_EraseRootFromParent_Done,
     /* 2153411 */   // Label 28432: @2153411
     /* 2153411 */   GIM_Try, /*On fail goto*//*Label 28433*/ GIMT_Encode4(2153502), // Rule ID 17935 //
     /* 2153416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2153419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2153427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2153430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2153433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2153436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2153446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153462 */     // MIs[0] round
     /* 2153462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153465 */     // MIs[0] policy
     /* 2153465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153475 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2153478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153501 */     // GIR_Coverage, 17935,
     /* 2153501 */     GIR_EraseRootFromParent_Done,
     /* 2153502 */   // Label 28433: @2153502
     /* 2153502 */   GIM_Try, /*On fail goto*//*Label 28434*/ GIMT_Encode4(2153593), // Rule ID 17938 //
     /* 2153507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2153510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2153518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2153521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2153524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2153527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153553 */     // MIs[0] round
     /* 2153553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153556 */     // MIs[0] policy
     /* 2153556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153566 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2153569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153592 */     // GIR_Coverage, 17938,
     /* 2153592 */     GIR_EraseRootFromParent_Done,
     /* 2153593 */   // Label 28434: @2153593
     /* 2153593 */   GIM_Try, /*On fail goto*//*Label 28435*/ GIMT_Encode4(2153684), // Rule ID 17939 //
     /* 2153598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2153601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2153609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2153612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2153615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2153618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153644 */     // MIs[0] round
     /* 2153644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153647 */     // MIs[0] policy
     /* 2153647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153657 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2153660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153683 */     // GIR_Coverage, 17939,
     /* 2153683 */     GIR_EraseRootFromParent_Done,
     /* 2153684 */   // Label 28435: @2153684
     /* 2153684 */   GIM_Try, /*On fail goto*//*Label 28436*/ GIMT_Encode4(2153775), // Rule ID 17942 //
     /* 2153689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2153692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2153700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2153703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2153706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2153709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153735 */     // MIs[0] round
     /* 2153735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153738 */     // MIs[0] policy
     /* 2153738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153748 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2153751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153774 */     // GIR_Coverage, 17942,
     /* 2153774 */     GIR_EraseRootFromParent_Done,
     /* 2153775 */   // Label 28436: @2153775
     /* 2153775 */   GIM_Try, /*On fail goto*//*Label 28437*/ GIMT_Encode4(2153866), // Rule ID 17943 //
     /* 2153780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2153783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2153791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2153794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2153797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2153800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153826 */     // MIs[0] round
     /* 2153826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153829 */     // MIs[0] policy
     /* 2153829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153839 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2153842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153865 */     // GIR_Coverage, 17943,
     /* 2153865 */     GIR_EraseRootFromParent_Done,
     /* 2153866 */   // Label 28437: @2153866
     /* 2153866 */   GIM_Try, /*On fail goto*//*Label 28438*/ GIMT_Encode4(2153957), // Rule ID 17946 //
     /* 2153871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2153882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2153885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2153891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153917 */     // MIs[0] round
     /* 2153917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153920 */     // MIs[0] policy
     /* 2153920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153930 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2153933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153956 */     // GIR_Coverage, 17946,
     /* 2153956 */     GIR_EraseRootFromParent_Done,
     /* 2153957 */   // Label 28438: @2153957
     /* 2153957 */   GIM_Try, /*On fail goto*//*Label 28439*/ GIMT_Encode4(2154048), // Rule ID 17947 //
     /* 2153962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2153973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2153976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2153982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154008 */     // MIs[0] round
     /* 2154008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154011 */     // MIs[0] policy
     /* 2154011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154021 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2154024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154047 */     // GIR_Coverage, 17947,
     /* 2154047 */     GIR_EraseRootFromParent_Done,
     /* 2154048 */   // Label 28439: @2154048
     /* 2154048 */   GIM_Try, /*On fail goto*//*Label 28440*/ GIMT_Encode4(2154139), // Rule ID 17950 //
     /* 2154053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2154064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2154067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2154073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154099 */     // MIs[0] round
     /* 2154099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154102 */     // MIs[0] policy
     /* 2154102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154112 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2154115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154138 */     // GIR_Coverage, 17950,
     /* 2154138 */     GIR_EraseRootFromParent_Done,
     /* 2154139 */   // Label 28440: @2154139
     /* 2154139 */   GIM_Try, /*On fail goto*//*Label 28441*/ GIMT_Encode4(2154230), // Rule ID 17951 //
     /* 2154144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2154155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2154158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2154164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154190 */     // MIs[0] round
     /* 2154190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154193 */     // MIs[0] policy
     /* 2154193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154203 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2154206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154229 */     // GIR_Coverage, 17951,
     /* 2154229 */     GIR_EraseRootFromParent_Done,
     /* 2154230 */   // Label 28441: @2154230
     /* 2154230 */   GIM_Try, /*On fail goto*//*Label 28442*/ GIMT_Encode4(2154321), // Rule ID 17954 //
     /* 2154235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2154238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2154246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2154249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2154255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154281 */     // MIs[0] round
     /* 2154281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154284 */     // MIs[0] policy
     /* 2154284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154294 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2154297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154320 */     // GIR_Coverage, 17954,
     /* 2154320 */     GIR_EraseRootFromParent_Done,
     /* 2154321 */   // Label 28442: @2154321
     /* 2154321 */   GIM_Try, /*On fail goto*//*Label 28443*/ GIMT_Encode4(2154412), // Rule ID 17955 //
     /* 2154326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2154329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2154337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2154340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2154346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154372 */     // MIs[0] round
     /* 2154372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154375 */     // MIs[0] policy
     /* 2154375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154385 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2154388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154411 */     // GIR_Coverage, 17955,
     /* 2154411 */     GIR_EraseRootFromParent_Done,
     /* 2154412 */   // Label 28443: @2154412
     /* 2154412 */   GIM_Try, /*On fail goto*//*Label 28444*/ GIMT_Encode4(2154503), // Rule ID 17958 //
     /* 2154417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2154428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2154431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2154437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2154440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154463 */     // MIs[0] round
     /* 2154463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154466 */     // MIs[0] policy
     /* 2154466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154476 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2154479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154502 */     // GIR_Coverage, 17958,
     /* 2154502 */     GIR_EraseRootFromParent_Done,
     /* 2154503 */   // Label 28444: @2154503
     /* 2154503 */   GIM_Try, /*On fail goto*//*Label 28445*/ GIMT_Encode4(2154594), // Rule ID 17959 //
     /* 2154508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2154519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2154522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2154528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2154531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154554 */     // MIs[0] round
     /* 2154554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154557 */     // MIs[0] policy
     /* 2154557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154567 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2154570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154593 */     // GIR_Coverage, 17959,
     /* 2154593 */     GIR_EraseRootFromParent_Done,
     /* 2154594 */   // Label 28445: @2154594
     /* 2154594 */   GIM_Try, /*On fail goto*//*Label 28446*/ GIMT_Encode4(2154685), // Rule ID 17962 //
     /* 2154599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2154602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2154610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2154613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2154619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154645 */     // MIs[0] round
     /* 2154645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154648 */     // MIs[0] policy
     /* 2154648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154658 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2154661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154684 */     // GIR_Coverage, 17962,
     /* 2154684 */     GIR_EraseRootFromParent_Done,
     /* 2154685 */   // Label 28446: @2154685
     /* 2154685 */   GIM_Try, /*On fail goto*//*Label 28447*/ GIMT_Encode4(2154776), // Rule ID 17963 //
     /* 2154690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2154693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2154701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2154704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2154710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154736 */     // MIs[0] round
     /* 2154736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154739 */     // MIs[0] policy
     /* 2154739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154749 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2154752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154775 */     // GIR_Coverage, 17963,
     /* 2154775 */     GIR_EraseRootFromParent_Done,
     /* 2154776 */   // Label 28447: @2154776
     /* 2154776 */   GIM_Try, /*On fail goto*//*Label 28448*/ GIMT_Encode4(2154867), // Rule ID 17966 //
     /* 2154781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2154784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2154792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2154801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154827 */     // MIs[0] round
     /* 2154827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154830 */     // MIs[0] policy
     /* 2154830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154840 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2154843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154866 */     // GIR_Coverage, 17966,
     /* 2154866 */     GIR_EraseRootFromParent_Done,
     /* 2154867 */   // Label 28448: @2154867
     /* 2154867 */   GIM_Try, /*On fail goto*//*Label 28449*/ GIMT_Encode4(2154958), // Rule ID 17967 //
     /* 2154872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2154883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2154892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154918 */     // MIs[0] round
     /* 2154918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154921 */     // MIs[0] policy
     /* 2154921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154931 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2154934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154957 */     // GIR_Coverage, 17967,
     /* 2154957 */     GIR_EraseRootFromParent_Done,
     /* 2154958 */   // Label 28449: @2154958
     /* 2154958 */   GIM_Try, /*On fail goto*//*Label 28450*/ GIMT_Encode4(2155049), // Rule ID 17970 //
     /* 2154963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2154974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2154977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2154983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2155001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155009 */     // MIs[0] round
     /* 2155009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155012 */     // MIs[0] policy
     /* 2155012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155022 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2155025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155048 */     // GIR_Coverage, 17970,
     /* 2155048 */     GIR_EraseRootFromParent_Done,
     /* 2155049 */   // Label 28450: @2155049
     /* 2155049 */   GIM_Try, /*On fail goto*//*Label 28451*/ GIMT_Encode4(2155140), // Rule ID 17971 //
     /* 2155054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2155065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2155068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2155071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2155074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2155092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155100 */     // MIs[0] round
     /* 2155100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155103 */     // MIs[0] policy
     /* 2155103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155113 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2155116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155139 */     // GIR_Coverage, 17971,
     /* 2155139 */     GIR_EraseRootFromParent_Done,
     /* 2155140 */   // Label 28451: @2155140
     /* 2155140 */   GIM_Try, /*On fail goto*//*Label 28452*/ GIMT_Encode4(2155231), // Rule ID 17974 //
     /* 2155145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2155156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2155159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2155162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2155165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2155183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155191 */     // MIs[0] round
     /* 2155191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155194 */     // MIs[0] policy
     /* 2155194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155204 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2155207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155230 */     // GIR_Coverage, 17974,
     /* 2155230 */     GIR_EraseRootFromParent_Done,
     /* 2155231 */   // Label 28452: @2155231
     /* 2155231 */   GIM_Try, /*On fail goto*//*Label 28453*/ GIMT_Encode4(2155322), // Rule ID 17975 //
     /* 2155236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2155247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2155250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2155253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2155256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2155274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155282 */     // MIs[0] round
     /* 2155282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155285 */     // MIs[0] policy
     /* 2155285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155295 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2155298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155321 */     // GIR_Coverage, 17975,
     /* 2155321 */     GIR_EraseRootFromParent_Done,
     /* 2155322 */   // Label 28453: @2155322
     /* 2155322 */   GIM_Try, /*On fail goto*//*Label 28454*/ GIMT_Encode4(2155413), // Rule ID 17978 //
     /* 2155327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2155338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2155341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2155344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2155347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2155350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2155365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155373 */     // MIs[0] round
     /* 2155373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155376 */     // MIs[0] policy
     /* 2155376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155386 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2155389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155412 */     // GIR_Coverage, 17978,
     /* 2155412 */     GIR_EraseRootFromParent_Done,
     /* 2155413 */   // Label 28454: @2155413
     /* 2155413 */   GIM_Try, /*On fail goto*//*Label 28455*/ GIMT_Encode4(2155504), // Rule ID 17979 //
     /* 2155418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2155429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2155432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2155435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2155438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2155441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2155456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155464 */     // MIs[0] round
     /* 2155464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155467 */     // MIs[0] policy
     /* 2155467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155477 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2155480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155503 */     // GIR_Coverage, 17979,
     /* 2155503 */     GIR_EraseRootFromParent_Done,
     /* 2155504 */   // Label 28455: @2155504
     /* 2155504 */   GIM_Try, /*On fail goto*//*Label 28456*/ GIMT_Encode4(2155595), // Rule ID 17982 //
     /* 2155509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2155520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2155523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2155529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155555 */     // MIs[0] round
     /* 2155555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155558 */     // MIs[0] policy
     /* 2155558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155568 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2155571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155594 */     // GIR_Coverage, 17982,
     /* 2155594 */     GIR_EraseRootFromParent_Done,
     /* 2155595 */   // Label 28456: @2155595
     /* 2155595 */   GIM_Try, /*On fail goto*//*Label 28457*/ GIMT_Encode4(2155686), // Rule ID 17983 //
     /* 2155600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2155611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2155614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2155620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155646 */     // MIs[0] round
     /* 2155646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155649 */     // MIs[0] policy
     /* 2155649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155659 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2155662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155685 */     // GIR_Coverage, 17983,
     /* 2155685 */     GIR_EraseRootFromParent_Done,
     /* 2155686 */   // Label 28457: @2155686
     /* 2155686 */   GIM_Try, /*On fail goto*//*Label 28458*/ GIMT_Encode4(2155777), // Rule ID 17986 //
     /* 2155691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2155702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2155705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2155711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155737 */     // MIs[0] round
     /* 2155737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155740 */     // MIs[0] policy
     /* 2155740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155750 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2155753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155776 */     // GIR_Coverage, 17986,
     /* 2155776 */     GIR_EraseRootFromParent_Done,
     /* 2155777 */   // Label 28458: @2155777
     /* 2155777 */   GIM_Try, /*On fail goto*//*Label 28459*/ GIMT_Encode4(2155868), // Rule ID 17987 //
     /* 2155782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2155793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2155796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2155802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155828 */     // MIs[0] round
     /* 2155828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155831 */     // MIs[0] policy
     /* 2155831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155841 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2155844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155867 */     // GIR_Coverage, 17987,
     /* 2155867 */     GIR_EraseRootFromParent_Done,
     /* 2155868 */   // Label 28459: @2155868
     /* 2155868 */   GIM_Try, /*On fail goto*//*Label 28460*/ GIMT_Encode4(2155959), // Rule ID 17990 //
     /* 2155873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2155884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2155887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2155893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155919 */     // MIs[0] round
     /* 2155919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155922 */     // MIs[0] policy
     /* 2155922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155932 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2155935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155958 */     // GIR_Coverage, 17990,
     /* 2155958 */     GIR_EraseRootFromParent_Done,
     /* 2155959 */   // Label 28460: @2155959
     /* 2155959 */   GIM_Try, /*On fail goto*//*Label 28461*/ GIMT_Encode4(2156050), // Rule ID 17991 //
     /* 2155964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2155975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2155978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2155984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2156002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156010 */     // MIs[0] round
     /* 2156010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156013 */     // MIs[0] policy
     /* 2156013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156023 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2156026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156049 */     // GIR_Coverage, 17991,
     /* 2156049 */     GIR_EraseRootFromParent_Done,
     /* 2156050 */   // Label 28461: @2156050
     /* 2156050 */   GIM_Try, /*On fail goto*//*Label 28462*/ GIMT_Encode4(2156141), // Rule ID 17994 //
     /* 2156055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2156066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2156075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2156085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156101 */     // MIs[0] round
     /* 2156101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156104 */     // MIs[0] policy
     /* 2156104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156114 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2156117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156140 */     // GIR_Coverage, 17994,
     /* 2156140 */     GIR_EraseRootFromParent_Done,
     /* 2156141 */   // Label 28462: @2156141
     /* 2156141 */   GIM_Try, /*On fail goto*//*Label 28463*/ GIMT_Encode4(2156232), // Rule ID 17995 //
     /* 2156146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2156157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2156166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2156176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156192 */     // MIs[0] round
     /* 2156192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156195 */     // MIs[0] policy
     /* 2156195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156205 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2156208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156231 */     // GIR_Coverage, 17995,
     /* 2156231 */     GIR_EraseRootFromParent_Done,
     /* 2156232 */   // Label 28463: @2156232
     /* 2156232 */   GIM_Try, /*On fail goto*//*Label 28464*/ GIMT_Encode4(2156323), // Rule ID 17998 //
     /* 2156237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2156248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2156251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2156257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2156267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156283 */     // MIs[0] round
     /* 2156283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156286 */     // MIs[0] policy
     /* 2156286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156296 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2156299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156322 */     // GIR_Coverage, 17998,
     /* 2156322 */     GIR_EraseRootFromParent_Done,
     /* 2156323 */   // Label 28464: @2156323
     /* 2156323 */   GIM_Try, /*On fail goto*//*Label 28465*/ GIMT_Encode4(2156414), // Rule ID 17999 //
     /* 2156328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2156339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2156342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2156348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2156358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156374 */     // MIs[0] round
     /* 2156374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156377 */     // MIs[0] policy
     /* 2156377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156387 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2156390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156413 */     // GIR_Coverage, 17999,
     /* 2156413 */     GIR_EraseRootFromParent_Done,
     /* 2156414 */   // Label 28465: @2156414
     /* 2156414 */   GIM_Try, /*On fail goto*//*Label 28466*/ GIMT_Encode4(2156505), // Rule ID 18002 //
     /* 2156419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2156430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2156433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2156439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2156442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156465 */     // MIs[0] round
     /* 2156465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156468 */     // MIs[0] policy
     /* 2156468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156478 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2156481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156504 */     // GIR_Coverage, 18002,
     /* 2156504 */     GIR_EraseRootFromParent_Done,
     /* 2156505 */   // Label 28466: @2156505
     /* 2156505 */   GIM_Try, /*On fail goto*//*Label 28467*/ GIMT_Encode4(2156596), // Rule ID 18003 //
     /* 2156510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2156521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2156524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2156530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2156533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156556 */     // MIs[0] round
     /* 2156556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156559 */     // MIs[0] policy
     /* 2156559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156569 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2156572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156595 */     // GIR_Coverage, 18003,
     /* 2156595 */     GIR_EraseRootFromParent_Done,
     /* 2156596 */   // Label 28467: @2156596
     /* 2156596 */   GIM_Try, /*On fail goto*//*Label 28468*/ GIMT_Encode4(2156687), // Rule ID 18006 //
     /* 2156601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2156612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2156615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2156618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2156621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156647 */     // MIs[0] round
     /* 2156647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156650 */     // MIs[0] policy
     /* 2156650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156660 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2156663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156686 */     // GIR_Coverage, 18006,
     /* 2156686 */     GIR_EraseRootFromParent_Done,
     /* 2156687 */   // Label 28468: @2156687
     /* 2156687 */   GIM_Try, /*On fail goto*//*Label 28469*/ GIMT_Encode4(2156778), // Rule ID 18007 //
     /* 2156692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2156703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2156706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2156709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2156712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156738 */     // MIs[0] round
     /* 2156738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156741 */     // MIs[0] policy
     /* 2156741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156751 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2156754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156777 */     // GIR_Coverage, 18007,
     /* 2156777 */     GIR_EraseRootFromParent_Done,
     /* 2156778 */   // Label 28469: @2156778
     /* 2156778 */   GIM_Try, /*On fail goto*//*Label 28470*/ GIMT_Encode4(2156869), // Rule ID 18010 //
     /* 2156783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2156794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2156803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156829 */     // MIs[0] round
     /* 2156829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156832 */     // MIs[0] policy
     /* 2156832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156842 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2156845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156868 */     // GIR_Coverage, 18010,
     /* 2156868 */     GIR_EraseRootFromParent_Done,
     /* 2156869 */   // Label 28470: @2156869
     /* 2156869 */   GIM_Try, /*On fail goto*//*Label 28471*/ GIMT_Encode4(2156960), // Rule ID 18011 //
     /* 2156874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2156885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2156894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156920 */     // MIs[0] round
     /* 2156920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156923 */     // MIs[0] policy
     /* 2156923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156933 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2156936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156959 */     // GIR_Coverage, 18011,
     /* 2156959 */     GIR_EraseRootFromParent_Done,
     /* 2156960 */   // Label 28471: @2156960
     /* 2156960 */   GIM_Try, /*On fail goto*//*Label 28472*/ GIMT_Encode4(2157051), // Rule ID 18014 //
     /* 2156965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2156976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2156979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2156982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2156985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157011 */     // MIs[0] round
     /* 2157011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157014 */     // MIs[0] policy
     /* 2157014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157024 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2157027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157050 */     // GIR_Coverage, 18014,
     /* 2157050 */     GIR_EraseRootFromParent_Done,
     /* 2157051 */   // Label 28472: @2157051
     /* 2157051 */   GIM_Try, /*On fail goto*//*Label 28473*/ GIMT_Encode4(2157142), // Rule ID 18015 //
     /* 2157056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2157067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2157070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2157073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2157076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157102 */     // MIs[0] round
     /* 2157102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157105 */     // MIs[0] policy
     /* 2157105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157115 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2157118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157141 */     // GIR_Coverage, 18015,
     /* 2157141 */     GIR_EraseRootFromParent_Done,
     /* 2157142 */   // Label 28473: @2157142
     /* 2157142 */   GIM_Try, /*On fail goto*//*Label 28474*/ GIMT_Encode4(2157233), // Rule ID 18018 //
     /* 2157147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2157158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2157164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2157167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157193 */     // MIs[0] round
     /* 2157193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157196 */     // MIs[0] policy
     /* 2157196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157206 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2157209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157232 */     // GIR_Coverage, 18018,
     /* 2157232 */     GIR_EraseRootFromParent_Done,
     /* 2157233 */   // Label 28474: @2157233
     /* 2157233 */   GIM_Try, /*On fail goto*//*Label 28475*/ GIMT_Encode4(2157324), // Rule ID 18019 //
     /* 2157238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2157249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2157255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2157258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157284 */     // MIs[0] round
     /* 2157284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157287 */     // MIs[0] policy
     /* 2157287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157297 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2157300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157323 */     // GIR_Coverage, 18019,
     /* 2157323 */     GIR_EraseRootFromParent_Done,
     /* 2157324 */   // Label 28475: @2157324
     /* 2157324 */   GIM_Try, /*On fail goto*//*Label 28476*/ GIMT_Encode4(2157415), // Rule ID 18022 //
     /* 2157329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2157340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2157343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2157346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2157349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2157352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157375 */     // MIs[0] round
     /* 2157375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157378 */     // MIs[0] policy
     /* 2157378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157388 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2157391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157414 */     // GIR_Coverage, 18022,
     /* 2157414 */     GIR_EraseRootFromParent_Done,
     /* 2157415 */   // Label 28476: @2157415
     /* 2157415 */   GIM_Try, /*On fail goto*//*Label 28477*/ GIMT_Encode4(2157506), // Rule ID 18023 //
     /* 2157420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2157431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2157434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2157437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2157440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2157443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157466 */     // MIs[0] round
     /* 2157466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157469 */     // MIs[0] policy
     /* 2157469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157479 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2157482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157505 */     // GIR_Coverage, 18023,
     /* 2157505 */     GIR_EraseRootFromParent_Done,
     /* 2157506 */   // Label 28477: @2157506
     /* 2157506 */   GIM_Try, /*On fail goto*//*Label 28478*/ GIMT_Encode4(2157597), // Rule ID 18026 //
     /* 2157511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2157514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2157522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2157525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2157528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2157531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157557 */     // MIs[0] round
     /* 2157557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157560 */     // MIs[0] policy
     /* 2157560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2157573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157596 */     // GIR_Coverage, 18026,
     /* 2157596 */     GIR_EraseRootFromParent_Done,
     /* 2157597 */   // Label 28478: @2157597
     /* 2157597 */   GIM_Try, /*On fail goto*//*Label 28479*/ GIMT_Encode4(2157688), // Rule ID 18027 //
     /* 2157602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2157605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2157613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2157616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2157619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2157622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157648 */     // MIs[0] round
     /* 2157648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157651 */     // MIs[0] policy
     /* 2157651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157661 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2157664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157687 */     // GIR_Coverage, 18027,
     /* 2157687 */     GIR_EraseRootFromParent_Done,
     /* 2157688 */   // Label 28479: @2157688
     /* 2157688 */   GIM_Try, /*On fail goto*//*Label 28480*/ GIMT_Encode4(2157779), // Rule ID 18030 //
     /* 2157693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2157704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2157707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2157710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2157713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157739 */     // MIs[0] round
     /* 2157739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157742 */     // MIs[0] policy
     /* 2157742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157752 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2157755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157778 */     // GIR_Coverage, 18030,
     /* 2157778 */     GIR_EraseRootFromParent_Done,
     /* 2157779 */   // Label 28480: @2157779
     /* 2157779 */   GIM_Try, /*On fail goto*//*Label 28481*/ GIMT_Encode4(2157870), // Rule ID 18031 //
     /* 2157784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2157795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2157798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2157801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2157804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157830 */     // MIs[0] round
     /* 2157830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157833 */     // MIs[0] policy
     /* 2157833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157843 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2157846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157869 */     // GIR_Coverage, 18031,
     /* 2157869 */     GIR_EraseRootFromParent_Done,
     /* 2157870 */   // Label 28481: @2157870
     /* 2157870 */   GIM_Try, /*On fail goto*//*Label 28482*/ GIMT_Encode4(2157961), // Rule ID 18034 //
     /* 2157875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2157886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2157889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2157892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2157895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2157898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157921 */     // MIs[0] round
     /* 2157921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157924 */     // MIs[0] policy
     /* 2157924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157934 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2157937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157960 */     // GIR_Coverage, 18034,
     /* 2157960 */     GIR_EraseRootFromParent_Done,
     /* 2157961 */   // Label 28482: @2157961
     /* 2157961 */   GIM_Try, /*On fail goto*//*Label 28483*/ GIMT_Encode4(2158052), // Rule ID 18035 //
     /* 2157966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2157977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2157980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2157983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2157986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2157989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158012 */     // MIs[0] round
     /* 2158012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158015 */     // MIs[0] policy
     /* 2158015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158025 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2158028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158051 */     // GIR_Coverage, 18035,
     /* 2158051 */     GIR_EraseRootFromParent_Done,
     /* 2158052 */   // Label 28483: @2158052
     /* 2158052 */   GIM_Try, /*On fail goto*//*Label 28484*/ GIMT_Encode4(2158143), // Rule ID 18038 //
     /* 2158057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2158068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2158071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2158074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2158077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2158080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158103 */     // MIs[0] round
     /* 2158103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158106 */     // MIs[0] policy
     /* 2158106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158116 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2158119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158142 */     // GIR_Coverage, 18038,
     /* 2158142 */     GIR_EraseRootFromParent_Done,
     /* 2158143 */   // Label 28484: @2158143
     /* 2158143 */   GIM_Try, /*On fail goto*//*Label 28485*/ GIMT_Encode4(2158234), // Rule ID 18039 //
     /* 2158148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2158159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2158162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2158165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2158168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2158171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158194 */     // MIs[0] round
     /* 2158194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158197 */     // MIs[0] policy
     /* 2158197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158207 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2158210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158233 */     // GIR_Coverage, 18039,
     /* 2158233 */     GIR_EraseRootFromParent_Done,
     /* 2158234 */   // Label 28485: @2158234
     /* 2158234 */   GIM_Try, /*On fail goto*//*Label 28486*/ GIMT_Encode4(2158325), // Rule ID 18042 //
     /* 2158239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2158250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2158253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2158256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2158259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158285 */     // MIs[0] round
     /* 2158285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158288 */     // MIs[0] policy
     /* 2158288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158298 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2158301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158324 */     // GIR_Coverage, 18042,
     /* 2158324 */     GIR_EraseRootFromParent_Done,
     /* 2158325 */   // Label 28486: @2158325
     /* 2158325 */   GIM_Try, /*On fail goto*//*Label 28487*/ GIMT_Encode4(2158416), // Rule ID 18043 //
     /* 2158330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2158341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2158344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2158347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2158350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158376 */     // MIs[0] round
     /* 2158376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158379 */     // MIs[0] policy
     /* 2158379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158389 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2158392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158415 */     // GIR_Coverage, 18043,
     /* 2158415 */     GIR_EraseRootFromParent_Done,
     /* 2158416 */   // Label 28487: @2158416
     /* 2158416 */   GIM_Try, /*On fail goto*//*Label 28488*/ GIMT_Encode4(2158507), // Rule ID 18046 //
     /* 2158421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2158432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2158441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158467 */     // MIs[0] round
     /* 2158467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158470 */     // MIs[0] policy
     /* 2158470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158480 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2158483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158506 */     // GIR_Coverage, 18046,
     /* 2158506 */     GIR_EraseRootFromParent_Done,
     /* 2158507 */   // Label 28488: @2158507
     /* 2158507 */   GIM_Try, /*On fail goto*//*Label 28489*/ GIMT_Encode4(2158598), // Rule ID 18047 //
     /* 2158512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2158523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2158532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158558 */     // MIs[0] round
     /* 2158558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158561 */     // MIs[0] policy
     /* 2158561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158571 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2158574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158597 */     // GIR_Coverage, 18047,
     /* 2158597 */     GIR_EraseRootFromParent_Done,
     /* 2158598 */   // Label 28489: @2158598
     /* 2158598 */   GIM_Try, /*On fail goto*//*Label 28490*/ GIMT_Encode4(2158689), // Rule ID 18050 //
     /* 2158603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2158614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2158617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2158620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2158623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2158626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158649 */     // MIs[0] round
     /* 2158649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158652 */     // MIs[0] policy
     /* 2158652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158662 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2158665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158688 */     // GIR_Coverage, 18050,
     /* 2158688 */     GIR_EraseRootFromParent_Done,
     /* 2158689 */   // Label 28490: @2158689
     /* 2158689 */   GIM_Try, /*On fail goto*//*Label 28491*/ GIMT_Encode4(2158780), // Rule ID 18051 //
     /* 2158694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2158705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2158708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2158711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2158714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2158717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158740 */     // MIs[0] round
     /* 2158740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158743 */     // MIs[0] policy
     /* 2158743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158753 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2158756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158779 */     // GIR_Coverage, 18051,
     /* 2158779 */     GIR_EraseRootFromParent_Done,
     /* 2158780 */   // Label 28491: @2158780
     /* 2158780 */   GIM_Try, /*On fail goto*//*Label 28492*/ GIMT_Encode4(2158871), // Rule ID 18054 //
     /* 2158785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2158796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2158799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2158802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2158805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158831 */     // MIs[0] round
     /* 2158831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158834 */     // MIs[0] policy
     /* 2158834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158844 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2158847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158870 */     // GIR_Coverage, 18054,
     /* 2158870 */     GIR_EraseRootFromParent_Done,
     /* 2158871 */   // Label 28492: @2158871
     /* 2158871 */   GIM_Try, /*On fail goto*//*Label 28493*/ GIMT_Encode4(2158962), // Rule ID 18055 //
     /* 2158876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2158887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2158890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2158893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2158896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158922 */     // MIs[0] round
     /* 2158922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158925 */     // MIs[0] policy
     /* 2158925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158935 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2158938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158961 */     // GIR_Coverage, 18055,
     /* 2158961 */     GIR_EraseRootFromParent_Done,
     /* 2158962 */   // Label 28493: @2158962
     /* 2158962 */   GIM_Try, /*On fail goto*//*Label 28494*/ GIMT_Encode4(2159053), // Rule ID 18058 //
     /* 2158967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2158978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2158981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2158984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2158987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159013 */     // MIs[0] round
     /* 2159013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159016 */     // MIs[0] policy
     /* 2159016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159026 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2159029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159052 */     // GIR_Coverage, 18058,
     /* 2159052 */     GIR_EraseRootFromParent_Done,
     /* 2159053 */   // Label 28494: @2159053
     /* 2159053 */   GIM_Try, /*On fail goto*//*Label 28495*/ GIMT_Encode4(2159144), // Rule ID 18059 //
     /* 2159058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2159061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2159069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2159072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2159075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2159078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2159088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159104 */     // MIs[0] round
     /* 2159104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159107 */     // MIs[0] policy
     /* 2159107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159117 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2159120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159143 */     // GIR_Coverage, 18059,
     /* 2159143 */     GIR_EraseRootFromParent_Done,
     /* 2159144 */   // Label 28495: @2159144
     /* 2159144 */   GIM_Try, /*On fail goto*//*Label 28496*/ GIMT_Encode4(2159235), // Rule ID 18062 //
     /* 2159149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2159152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2159160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2159163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2159166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2159169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2159179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159195 */     // MIs[0] round
     /* 2159195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159198 */     // MIs[0] policy
     /* 2159198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159208 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2159211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159234 */     // GIR_Coverage, 18062,
     /* 2159234 */     GIR_EraseRootFromParent_Done,
     /* 2159235 */   // Label 28496: @2159235
     /* 2159235 */   GIM_Try, /*On fail goto*//*Label 28497*/ GIMT_Encode4(2159326), // Rule ID 18063 //
     /* 2159240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2159243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2159251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2159254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2159257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2159260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2159270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159286 */     // MIs[0] round
     /* 2159286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159289 */     // MIs[0] policy
     /* 2159289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159299 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2159302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159325 */     // GIR_Coverage, 18063,
     /* 2159325 */     GIR_EraseRootFromParent_Done,
     /* 2159326 */   // Label 28497: @2159326
     /* 2159326 */   GIM_Try, /*On fail goto*//*Label 28498*/ GIMT_Encode4(2159417), // Rule ID 18066 //
     /* 2159331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2159342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2159345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2159351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159377 */     // MIs[0] round
     /* 2159377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159380 */     // MIs[0] policy
     /* 2159380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159390 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2159393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159416 */     // GIR_Coverage, 18066,
     /* 2159416 */     GIR_EraseRootFromParent_Done,
     /* 2159417 */   // Label 28498: @2159417
     /* 2159417 */   GIM_Try, /*On fail goto*//*Label 28499*/ GIMT_Encode4(2159508), // Rule ID 18067 //
     /* 2159422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2159433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2159436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2159442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159468 */     // MIs[0] round
     /* 2159468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159471 */     // MIs[0] policy
     /* 2159471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159481 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2159484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159507 */     // GIR_Coverage, 18067,
     /* 2159507 */     GIR_EraseRootFromParent_Done,
     /* 2159508 */   // Label 28499: @2159508
     /* 2159508 */   GIM_Try, /*On fail goto*//*Label 28500*/ GIMT_Encode4(2159599), // Rule ID 18070 //
     /* 2159513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2159524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2159527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2159533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159559 */     // MIs[0] round
     /* 2159559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159562 */     // MIs[0] policy
     /* 2159562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159572 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2159575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159598 */     // GIR_Coverage, 18070,
     /* 2159598 */     GIR_EraseRootFromParent_Done,
     /* 2159599 */   // Label 28500: @2159599
     /* 2159599 */   GIM_Try, /*On fail goto*//*Label 28501*/ GIMT_Encode4(2159690), // Rule ID 18071 //
     /* 2159604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2159615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2159618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2159624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159650 */     // MIs[0] round
     /* 2159650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159653 */     // MIs[0] policy
     /* 2159653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159663 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2159666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159689 */     // GIR_Coverage, 18071,
     /* 2159689 */     GIR_EraseRootFromParent_Done,
     /* 2159690 */   // Label 28501: @2159690
     /* 2159690 */   GIM_Try, /*On fail goto*//*Label 28502*/ GIMT_Encode4(2159781), // Rule ID 18074 //
     /* 2159695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2159706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2159709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2159715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159741 */     // MIs[0] round
     /* 2159741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159744 */     // MIs[0] policy
     /* 2159744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159754 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2159757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159780 */     // GIR_Coverage, 18074,
     /* 2159780 */     GIR_EraseRootFromParent_Done,
     /* 2159781 */   // Label 28502: @2159781
     /* 2159781 */   GIM_Try, /*On fail goto*//*Label 28503*/ GIMT_Encode4(2159872), // Rule ID 18075 //
     /* 2159786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2159797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2159800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2159806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159832 */     // MIs[0] round
     /* 2159832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159835 */     // MIs[0] policy
     /* 2159835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159845 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2159848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159871 */     // GIR_Coverage, 18075,
     /* 2159871 */     GIR_EraseRootFromParent_Done,
     /* 2159872 */   // Label 28503: @2159872
     /* 2159872 */   GIM_Try, /*On fail goto*//*Label 28504*/ GIMT_Encode4(2159963), // Rule ID 18078 //
     /* 2159877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2159888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2159891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2159897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159923 */     // MIs[0] round
     /* 2159923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159926 */     // MIs[0] policy
     /* 2159926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159936 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2159939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159962 */     // GIR_Coverage, 18078,
     /* 2159962 */     GIR_EraseRootFromParent_Done,
     /* 2159963 */   // Label 28504: @2159963
     /* 2159963 */   GIM_Try, /*On fail goto*//*Label 28505*/ GIMT_Encode4(2160054), // Rule ID 18079 //
     /* 2159968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2159979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2159982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2159988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160014 */     // MIs[0] round
     /* 2160014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160017 */     // MIs[0] policy
     /* 2160017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160027 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2160030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160053 */     // GIR_Coverage, 18079,
     /* 2160053 */     GIR_EraseRootFromParent_Done,
     /* 2160054 */   // Label 28505: @2160054
     /* 2160054 */   GIM_Try, /*On fail goto*//*Label 28506*/ GIMT_Encode4(2160145), // Rule ID 18082 //
     /* 2160059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2160070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2160073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2160079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160105 */     // MIs[0] round
     /* 2160105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160108 */     // MIs[0] policy
     /* 2160108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160118 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2160121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160144 */     // GIR_Coverage, 18082,
     /* 2160144 */     GIR_EraseRootFromParent_Done,
     /* 2160145 */   // Label 28506: @2160145
     /* 2160145 */   GIM_Try, /*On fail goto*//*Label 28507*/ GIMT_Encode4(2160236), // Rule ID 18083 //
     /* 2160150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2160161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2160164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2160170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160196 */     // MIs[0] round
     /* 2160196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160199 */     // MIs[0] policy
     /* 2160199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160209 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2160212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160235 */     // GIR_Coverage, 18083,
     /* 2160235 */     GIR_EraseRootFromParent_Done,
     /* 2160236 */   // Label 28507: @2160236
     /* 2160236 */   GIM_Try, /*On fail goto*//*Label 28508*/ GIMT_Encode4(2160327), // Rule ID 18086 //
     /* 2160241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2160244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2160252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2160255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2160258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2160261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2160279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160287 */     // MIs[0] round
     /* 2160287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160290 */     // MIs[0] policy
     /* 2160290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160300 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2160303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2160323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160326 */     // GIR_Coverage, 18086,
     /* 2160326 */     GIR_EraseRootFromParent_Done,
     /* 2160327 */   // Label 28508: @2160327
     /* 2160327 */   GIM_Try, /*On fail goto*//*Label 28509*/ GIMT_Encode4(2160418), // Rule ID 18087 //
     /* 2160332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2160335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2160343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2160346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2160349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2160352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2160370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160378 */     // MIs[0] round
     /* 2160378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160381 */     // MIs[0] policy
     /* 2160381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160391 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2160394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2160414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160417 */     // GIR_Coverage, 18087,
     /* 2160417 */     GIR_EraseRootFromParent_Done,
     /* 2160418 */   // Label 28509: @2160418
     /* 2160418 */   GIM_Try, /*On fail goto*//*Label 28510*/ GIMT_Encode4(2160509), // Rule ID 18090 //
     /* 2160423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2160434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2160437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2160443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160469 */     // MIs[0] round
     /* 2160469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160472 */     // MIs[0] policy
     /* 2160472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160482 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2160485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160508 */     // GIR_Coverage, 18090,
     /* 2160508 */     GIR_EraseRootFromParent_Done,
     /* 2160509 */   // Label 28510: @2160509
     /* 2160509 */   GIM_Try, /*On fail goto*//*Label 28511*/ GIMT_Encode4(2160600), // Rule ID 18091 //
     /* 2160514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2160525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2160528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2160534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160560 */     // MIs[0] round
     /* 2160560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160563 */     // MIs[0] policy
     /* 2160563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160573 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2160576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160599 */     // GIR_Coverage, 18091,
     /* 2160599 */     GIR_EraseRootFromParent_Done,
     /* 2160600 */   // Label 28511: @2160600
     /* 2160600 */   GIM_Try, /*On fail goto*//*Label 28512*/ GIMT_Encode4(2160691), // Rule ID 18094 //
     /* 2160605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2160616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2160619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2160625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160651 */     // MIs[0] round
     /* 2160651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160654 */     // MIs[0] policy
     /* 2160654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160664 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2160667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160690 */     // GIR_Coverage, 18094,
     /* 2160690 */     GIR_EraseRootFromParent_Done,
     /* 2160691 */   // Label 28512: @2160691
     /* 2160691 */   GIM_Try, /*On fail goto*//*Label 28513*/ GIMT_Encode4(2160782), // Rule ID 18095 //
     /* 2160696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2160707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2160710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2160716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160742 */     // MIs[0] round
     /* 2160742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160745 */     // MIs[0] policy
     /* 2160745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160755 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2160758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160781 */     // GIR_Coverage, 18095,
     /* 2160781 */     GIR_EraseRootFromParent_Done,
     /* 2160782 */   // Label 28513: @2160782
     /* 2160782 */   GIM_Try, /*On fail goto*//*Label 28514*/ GIMT_Encode4(2160873), // Rule ID 18098 //
     /* 2160787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2160798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2160801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2160807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2160810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160833 */     // MIs[0] round
     /* 2160833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160836 */     // MIs[0] policy
     /* 2160836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160846 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2160849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160872 */     // GIR_Coverage, 18098,
     /* 2160872 */     GIR_EraseRootFromParent_Done,
     /* 2160873 */   // Label 28514: @2160873
     /* 2160873 */   GIM_Try, /*On fail goto*//*Label 28515*/ GIMT_Encode4(2160964), // Rule ID 18099 //
     /* 2160878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2160889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2160892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2160898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2160901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160924 */     // MIs[0] round
     /* 2160924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160927 */     // MIs[0] policy
     /* 2160927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160937 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2160940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160963 */     // GIR_Coverage, 18099,
     /* 2160963 */     GIR_EraseRootFromParent_Done,
     /* 2160964 */   // Label 28515: @2160964
     /* 2160964 */   GIM_Try, /*On fail goto*//*Label 28516*/ GIMT_Encode4(2161055), // Rule ID 18102 //
     /* 2160969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2160980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2160983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2160989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2161007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161015 */     // MIs[0] round
     /* 2161015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161018 */     // MIs[0] policy
     /* 2161018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161028 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2161031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161054 */     // GIR_Coverage, 18102,
     /* 2161054 */     GIR_EraseRootFromParent_Done,
     /* 2161055 */   // Label 28516: @2161055
     /* 2161055 */   GIM_Try, /*On fail goto*//*Label 28517*/ GIMT_Encode4(2161146), // Rule ID 18103 //
     /* 2161060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2161063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2161071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2161074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2161077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2161080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2161098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161106 */     // MIs[0] round
     /* 2161106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161109 */     // MIs[0] policy
     /* 2161109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161119 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2161122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161145 */     // GIR_Coverage, 18103,
     /* 2161145 */     GIR_EraseRootFromParent_Done,
     /* 2161146 */   // Label 28517: @2161146
     /* 2161146 */   GIM_Try, /*On fail goto*//*Label 28518*/ GIMT_Encode4(2161237), // Rule ID 18106 //
     /* 2161151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2161154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2161162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2161165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2161168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2161171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2161189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161197 */     // MIs[0] round
     /* 2161197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161200 */     // MIs[0] policy
     /* 2161200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161210 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2161213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161236 */     // GIR_Coverage, 18106,
     /* 2161236 */     GIR_EraseRootFromParent_Done,
     /* 2161237 */   // Label 28518: @2161237
     /* 2161237 */   GIM_Try, /*On fail goto*//*Label 28519*/ GIMT_Encode4(2161328), // Rule ID 18107 //
     /* 2161242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2161245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2161253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2161256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2161259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2161262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2161280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161288 */     // MIs[0] round
     /* 2161288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161291 */     // MIs[0] policy
     /* 2161291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161301 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2161304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161327 */     // GIR_Coverage, 18107,
     /* 2161327 */     GIR_EraseRootFromParent_Done,
     /* 2161328 */   // Label 28519: @2161328
     /* 2161328 */   GIM_Try, /*On fail goto*//*Label 28520*/ GIMT_Encode4(2161419), // Rule ID 18110 //
     /* 2161333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2161336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2161344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2161347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2161350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2161353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2161356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2161371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161379 */     // MIs[0] round
     /* 2161379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161382 */     // MIs[0] policy
     /* 2161382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161392 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2161395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161418 */     // GIR_Coverage, 18110,
     /* 2161418 */     GIR_EraseRootFromParent_Done,
     /* 2161419 */   // Label 28520: @2161419
     /* 2161419 */   GIM_Try, /*On fail goto*//*Label 28521*/ GIMT_Encode4(2161510), // Rule ID 18111 //
     /* 2161424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2161427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2161435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2161438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2161441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2161444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2161447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2161462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161470 */     // MIs[0] round
     /* 2161470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161473 */     // MIs[0] policy
     /* 2161473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161483 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2161486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161509 */     // GIR_Coverage, 18111,
     /* 2161509 */     GIR_EraseRootFromParent_Done,
     /* 2161510 */   // Label 28521: @2161510
     /* 2161510 */   GIM_Try, /*On fail goto*//*Label 28522*/ GIMT_Encode4(2161601), // Rule ID 18114 //
     /* 2161515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2161526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2161529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2161535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161561 */     // MIs[0] round
     /* 2161561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161564 */     // MIs[0] policy
     /* 2161564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161574 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2161577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161600 */     // GIR_Coverage, 18114,
     /* 2161600 */     GIR_EraseRootFromParent_Done,
     /* 2161601 */   // Label 28522: @2161601
     /* 2161601 */   GIM_Try, /*On fail goto*//*Label 28523*/ GIMT_Encode4(2161692), // Rule ID 18115 //
     /* 2161606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2161617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2161620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2161626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161652 */     // MIs[0] round
     /* 2161652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161655 */     // MIs[0] policy
     /* 2161655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161665 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2161668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161691 */     // GIR_Coverage, 18115,
     /* 2161691 */     GIR_EraseRootFromParent_Done,
     /* 2161692 */   // Label 28523: @2161692
     /* 2161692 */   GIM_Try, /*On fail goto*//*Label 28524*/ GIMT_Encode4(2161783), // Rule ID 18118 //
     /* 2161697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2161708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2161711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2161717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161743 */     // MIs[0] round
     /* 2161743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161746 */     // MIs[0] policy
     /* 2161746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161756 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2161759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161782 */     // GIR_Coverage, 18118,
     /* 2161782 */     GIR_EraseRootFromParent_Done,
     /* 2161783 */   // Label 28524: @2161783
     /* 2161783 */   GIM_Try, /*On fail goto*//*Label 28525*/ GIMT_Encode4(2161874), // Rule ID 18119 //
     /* 2161788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2161799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2161802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2161808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161834 */     // MIs[0] round
     /* 2161834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161837 */     // MIs[0] policy
     /* 2161837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161847 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2161850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161873 */     // GIR_Coverage, 18119,
     /* 2161873 */     GIR_EraseRootFromParent_Done,
     /* 2161874 */   // Label 28525: @2161874
     /* 2161874 */   GIM_Try, /*On fail goto*//*Label 28526*/ GIMT_Encode4(2161965), // Rule ID 18122 //
     /* 2161879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2161890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2161893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2161899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161925 */     // MIs[0] round
     /* 2161925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161928 */     // MIs[0] policy
     /* 2161928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161938 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2161941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161964 */     // GIR_Coverage, 18122,
     /* 2161964 */     GIR_EraseRootFromParent_Done,
     /* 2161965 */   // Label 28526: @2161965
     /* 2161965 */   GIM_Try, /*On fail goto*//*Label 28527*/ GIMT_Encode4(2162056), // Rule ID 18123 //
     /* 2161970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2161981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2161984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2161990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2162000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2162008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162016 */     // MIs[0] round
     /* 2162016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162019 */     // MIs[0] policy
     /* 2162019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162029 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2162032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162055 */     // GIR_Coverage, 18123,
     /* 2162055 */     GIR_EraseRootFromParent_Done,
     /* 2162056 */   // Label 28527: @2162056
     /* 2162056 */   GIM_Try, /*On fail goto*//*Label 28528*/ GIMT_Encode4(2162147), // Rule ID 18126 //
     /* 2162061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2162072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2162075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2162078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2162081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162107 */     // MIs[0] round
     /* 2162107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162110 */     // MIs[0] policy
     /* 2162110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162120 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2162123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162146 */     // GIR_Coverage, 18126,
     /* 2162146 */     GIR_EraseRootFromParent_Done,
     /* 2162147 */   // Label 28528: @2162147
     /* 2162147 */   GIM_Try, /*On fail goto*//*Label 28529*/ GIMT_Encode4(2162238), // Rule ID 18127 //
     /* 2162152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2162163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2162166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2162169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2162172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162198 */     // MIs[0] round
     /* 2162198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162201 */     // MIs[0] policy
     /* 2162201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162211 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2162214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162237 */     // GIR_Coverage, 18127,
     /* 2162237 */     GIR_EraseRootFromParent_Done,
     /* 2162238 */   // Label 28529: @2162238
     /* 2162238 */   GIM_Try, /*On fail goto*//*Label 28530*/ GIMT_Encode4(2162329), // Rule ID 18130 //
     /* 2162243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2162254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2162257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2162260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2162263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162289 */     // MIs[0] round
     /* 2162289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162292 */     // MIs[0] policy
     /* 2162292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162302 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2162305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162328 */     // GIR_Coverage, 18130,
     /* 2162328 */     GIR_EraseRootFromParent_Done,
     /* 2162329 */   // Label 28530: @2162329
     /* 2162329 */   GIM_Try, /*On fail goto*//*Label 28531*/ GIMT_Encode4(2162420), // Rule ID 18131 //
     /* 2162334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2162345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2162348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2162351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2162354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162380 */     // MIs[0] round
     /* 2162380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162383 */     // MIs[0] policy
     /* 2162383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162393 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2162396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162419 */     // GIR_Coverage, 18131,
     /* 2162419 */     GIR_EraseRootFromParent_Done,
     /* 2162420 */   // Label 28531: @2162420
     /* 2162420 */   GIM_Try, /*On fail goto*//*Label 28532*/ GIMT_Encode4(2162511), // Rule ID 18134 //
     /* 2162425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2162428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2162436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2162439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2162442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2162445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162471 */     // MIs[0] round
     /* 2162471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162474 */     // MIs[0] policy
     /* 2162474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162484 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2162487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162510 */     // GIR_Coverage, 18134,
     /* 2162510 */     GIR_EraseRootFromParent_Done,
     /* 2162511 */   // Label 28532: @2162511
     /* 2162511 */   GIM_Try, /*On fail goto*//*Label 28533*/ GIMT_Encode4(2162602), // Rule ID 18135 //
     /* 2162516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2162519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2162527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2162530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2162533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2162536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162562 */     // MIs[0] round
     /* 2162562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162565 */     // MIs[0] policy
     /* 2162565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162575 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2162578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162601 */     // GIR_Coverage, 18135,
     /* 2162601 */     GIR_EraseRootFromParent_Done,
     /* 2162602 */   // Label 28533: @2162602
     /* 2162602 */   GIM_Try, /*On fail goto*//*Label 28534*/ GIMT_Encode4(2162693), // Rule ID 18138 //
     /* 2162607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2162618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2162621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2162624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2162627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162653 */     // MIs[0] round
     /* 2162653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162656 */     // MIs[0] policy
     /* 2162656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162666 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2162669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162692 */     // GIR_Coverage, 18138,
     /* 2162692 */     GIR_EraseRootFromParent_Done,
     /* 2162693 */   // Label 28534: @2162693
     /* 2162693 */   GIM_Try, /*On fail goto*//*Label 28535*/ GIMT_Encode4(2162784), // Rule ID 18139 //
     /* 2162698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2162709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2162712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2162715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2162718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162744 */     // MIs[0] round
     /* 2162744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162747 */     // MIs[0] policy
     /* 2162747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162757 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2162760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162783 */     // GIR_Coverage, 18139,
     /* 2162783 */     GIR_EraseRootFromParent_Done,
     /* 2162784 */   // Label 28535: @2162784
     /* 2162784 */   GIM_Try, /*On fail goto*//*Label 28536*/ GIMT_Encode4(2162875), // Rule ID 18142 //
     /* 2162789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2162792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2162800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2162803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2162806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2162809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162835 */     // MIs[0] round
     /* 2162835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162838 */     // MIs[0] policy
     /* 2162838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162848 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2162851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162874 */     // GIR_Coverage, 18142,
     /* 2162874 */     GIR_EraseRootFromParent_Done,
     /* 2162875 */   // Label 28536: @2162875
     /* 2162875 */   GIM_Try, /*On fail goto*//*Label 28537*/ GIMT_Encode4(2162966), // Rule ID 18143 //
     /* 2162880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2162883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2162891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2162894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2162897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2162900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162926 */     // MIs[0] round
     /* 2162926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162929 */     // MIs[0] policy
     /* 2162929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162939 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2162942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162965 */     // GIR_Coverage, 18143,
     /* 2162965 */     GIR_EraseRootFromParent_Done,
     /* 2162966 */   // Label 28537: @2162966
     /* 2162966 */   GIM_Try, /*On fail goto*//*Label 28538*/ GIMT_Encode4(2163057), // Rule ID 18146 //
     /* 2162971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2162974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2162982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2162985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2162988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2162991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163017 */     // MIs[0] round
     /* 2163017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163020 */     // MIs[0] policy
     /* 2163020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163030 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2163033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163056 */     // GIR_Coverage, 18146,
     /* 2163056 */     GIR_EraseRootFromParent_Done,
     /* 2163057 */   // Label 28538: @2163057
     /* 2163057 */   GIM_Try, /*On fail goto*//*Label 28539*/ GIMT_Encode4(2163148), // Rule ID 18147 //
     /* 2163062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2163065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2163073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2163076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2163079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2163082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2163085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163108 */     // MIs[0] round
     /* 2163108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163111 */     // MIs[0] policy
     /* 2163111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163121 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2163124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163147 */     // GIR_Coverage, 18147,
     /* 2163147 */     GIR_EraseRootFromParent_Done,
     /* 2163148 */   // Label 28539: @2163148
     /* 2163148 */   GIM_Try, /*On fail goto*//*Label 28540*/ GIMT_Encode4(2163239), // Rule ID 18150 //
     /* 2163153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2163164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2163167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2163170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2163173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163199 */     // MIs[0] round
     /* 2163199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163202 */     // MIs[0] policy
     /* 2163202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163212 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2163215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163238 */     // GIR_Coverage, 18150,
     /* 2163238 */     GIR_EraseRootFromParent_Done,
     /* 2163239 */   // Label 28540: @2163239
     /* 2163239 */   GIM_Try, /*On fail goto*//*Label 28541*/ GIMT_Encode4(2163330), // Rule ID 18151 //
     /* 2163244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2163247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2163255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2163258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2163261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2163264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163290 */     // MIs[0] round
     /* 2163290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163293 */     // MIs[0] policy
     /* 2163293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163303 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2163306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163329 */     // GIR_Coverage, 18151,
     /* 2163329 */     GIR_EraseRootFromParent_Done,
     /* 2163330 */   // Label 28541: @2163330
     /* 2163330 */   GIM_Try, /*On fail goto*//*Label 28542*/ GIMT_Encode4(2163421), // Rule ID 18154 //
     /* 2163335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2163346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2163349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2163352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2163355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2163358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163381 */     // MIs[0] round
     /* 2163381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163384 */     // MIs[0] policy
     /* 2163384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163394 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2163397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163420 */     // GIR_Coverage, 18154,
     /* 2163420 */     GIR_EraseRootFromParent_Done,
     /* 2163421 */   // Label 28542: @2163421
     /* 2163421 */   GIM_Try, /*On fail goto*//*Label 28543*/ GIMT_Encode4(2163512), // Rule ID 18155 //
     /* 2163426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2163429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2163437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2163440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2163443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2163446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2163449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163472 */     // MIs[0] round
     /* 2163472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163475 */     // MIs[0] policy
     /* 2163475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163485 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2163488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163511 */     // GIR_Coverage, 18155,
     /* 2163511 */     GIR_EraseRootFromParent_Done,
     /* 2163512 */   // Label 28543: @2163512
     /* 2163512 */   GIM_Try, /*On fail goto*//*Label 28544*/ GIMT_Encode4(2163603), // Rule ID 18158 //
     /* 2163517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2163528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2163531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2163534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2163537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2163540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163563 */     // MIs[0] round
     /* 2163563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163566 */     // MIs[0] policy
     /* 2163566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163576 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2163579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163602 */     // GIR_Coverage, 18158,
     /* 2163602 */     GIR_EraseRootFromParent_Done,
     /* 2163603 */   // Label 28544: @2163603
     /* 2163603 */   GIM_Try, /*On fail goto*//*Label 28545*/ GIMT_Encode4(2163694), // Rule ID 18159 //
     /* 2163608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2163611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2163619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2163622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2163625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2163628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2163631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163654 */     // MIs[0] round
     /* 2163654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163657 */     // MIs[0] policy
     /* 2163657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163667 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2163670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163693 */     // GIR_Coverage, 18159,
     /* 2163693 */     GIR_EraseRootFromParent_Done,
     /* 2163694 */   // Label 28545: @2163694
     /* 2163694 */   GIM_Try, /*On fail goto*//*Label 28546*/ GIMT_Encode4(2163785), // Rule ID 18162 //
     /* 2163699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2163710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2163713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2163716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2163719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163745 */     // MIs[0] round
     /* 2163745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163748 */     // MIs[0] policy
     /* 2163748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163758 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2163761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163784 */     // GIR_Coverage, 18162,
     /* 2163784 */     GIR_EraseRootFromParent_Done,
     /* 2163785 */   // Label 28546: @2163785
     /* 2163785 */   GIM_Try, /*On fail goto*//*Label 28547*/ GIMT_Encode4(2163876), // Rule ID 18163 //
     /* 2163790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2163801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2163804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2163807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2163810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163836 */     // MIs[0] round
     /* 2163836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163839 */     // MIs[0] policy
     /* 2163839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163849 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2163852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163875 */     // GIR_Coverage, 18163,
     /* 2163875 */     GIR_EraseRootFromParent_Done,
     /* 2163876 */   // Label 28547: @2163876
     /* 2163876 */   GIM_Try, /*On fail goto*//*Label 28548*/ GIMT_Encode4(2163967), // Rule ID 18166 //
     /* 2163881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2163892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2163895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2163898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2163901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163927 */     // MIs[0] round
     /* 2163927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163930 */     // MIs[0] policy
     /* 2163930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163940 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2163943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163966 */     // GIR_Coverage, 18166,
     /* 2163966 */     GIR_EraseRootFromParent_Done,
     /* 2163967 */   // Label 28548: @2163967
     /* 2163967 */   GIM_Try, /*On fail goto*//*Label 28549*/ GIMT_Encode4(2164058), // Rule ID 18167 //
     /* 2163972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2163983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2163986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2163989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2163992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164018 */     // MIs[0] round
     /* 2164018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164021 */     // MIs[0] policy
     /* 2164021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164031 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2164034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164057 */     // GIR_Coverage, 18167,
     /* 2164057 */     GIR_EraseRootFromParent_Done,
     /* 2164058 */   // Label 28549: @2164058
     /* 2164058 */   GIM_Try, /*On fail goto*//*Label 28550*/ GIMT_Encode4(2164149), // Rule ID 18170 //
     /* 2164063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2164066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2164074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2164077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2164080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2164083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2164086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164109 */     // MIs[0] round
     /* 2164109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164112 */     // MIs[0] policy
     /* 2164112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164122 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2164125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164148 */     // GIR_Coverage, 18170,
     /* 2164148 */     GIR_EraseRootFromParent_Done,
     /* 2164149 */   // Label 28550: @2164149
     /* 2164149 */   GIM_Try, /*On fail goto*//*Label 28551*/ GIMT_Encode4(2164240), // Rule ID 18171 //
     /* 2164154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2164157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2164165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2164168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2164171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2164174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2164177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164200 */     // MIs[0] round
     /* 2164200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164203 */     // MIs[0] policy
     /* 2164203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164213 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2164216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164239 */     // GIR_Coverage, 18171,
     /* 2164239 */     GIR_EraseRootFromParent_Done,
     /* 2164240 */   // Label 28551: @2164240
     /* 2164240 */   GIM_Try, /*On fail goto*//*Label 28552*/ GIMT_Encode4(2164331), // Rule ID 18174 //
     /* 2164245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2164248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2164256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2164259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2164262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2164265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2164275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164291 */     // MIs[0] round
     /* 2164291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164294 */     // MIs[0] policy
     /* 2164294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164304 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2164307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164330 */     // GIR_Coverage, 18174,
     /* 2164330 */     GIR_EraseRootFromParent_Done,
     /* 2164331 */   // Label 28552: @2164331
     /* 2164331 */   GIM_Try, /*On fail goto*//*Label 28553*/ GIMT_Encode4(2164422), // Rule ID 18175 //
     /* 2164336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2164339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2164347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2164350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2164353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2164356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2164366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164382 */     // MIs[0] round
     /* 2164382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164385 */     // MIs[0] policy
     /* 2164385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164395 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2164398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164421 */     // GIR_Coverage, 18175,
     /* 2164421 */     GIR_EraseRootFromParent_Done,
     /* 2164422 */   // Label 28553: @2164422
     /* 2164422 */   GIM_Try, /*On fail goto*//*Label 28554*/ GIMT_Encode4(2164513), // Rule ID 18178 //
     /* 2164427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2164430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2164438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2164441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2164444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2164447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164473 */     // MIs[0] round
     /* 2164473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164476 */     // MIs[0] policy
     /* 2164476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164486 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2164489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164512 */     // GIR_Coverage, 18178,
     /* 2164512 */     GIR_EraseRootFromParent_Done,
     /* 2164513 */   // Label 28554: @2164513
     /* 2164513 */   GIM_Try, /*On fail goto*//*Label 28555*/ GIMT_Encode4(2164604), // Rule ID 18179 //
     /* 2164518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2164521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2164529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2164532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2164535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2164538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164564 */     // MIs[0] round
     /* 2164564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164567 */     // MIs[0] policy
     /* 2164567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164577 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2164580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164603 */     // GIR_Coverage, 18179,
     /* 2164603 */     GIR_EraseRootFromParent_Done,
     /* 2164604 */   // Label 28555: @2164604
     /* 2164604 */   GIM_Try, /*On fail goto*//*Label 28556*/ GIMT_Encode4(2164695), // Rule ID 18182 //
     /* 2164609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2164612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2164620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2164623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2164626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2164629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164655 */     // MIs[0] round
     /* 2164655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164658 */     // MIs[0] policy
     /* 2164658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164668 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2164671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164694 */     // GIR_Coverage, 18182,
     /* 2164694 */     GIR_EraseRootFromParent_Done,
     /* 2164695 */   // Label 28556: @2164695
     /* 2164695 */   GIM_Try, /*On fail goto*//*Label 28557*/ GIMT_Encode4(2164786), // Rule ID 18183 //
     /* 2164700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2164703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2164711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2164714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2164717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2164720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164746 */     // MIs[0] round
     /* 2164746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164749 */     // MIs[0] policy
     /* 2164749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164759 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2164762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164785 */     // GIR_Coverage, 18183,
     /* 2164785 */     GIR_EraseRootFromParent_Done,
     /* 2164786 */   // Label 28557: @2164786
     /* 2164786 */   GIM_Try, /*On fail goto*//*Label 28558*/ GIMT_Encode4(2164877), // Rule ID 18186 //
     /* 2164791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2164802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2164805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2164811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164837 */     // MIs[0] round
     /* 2164837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164840 */     // MIs[0] policy
     /* 2164840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164850 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2164853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164876 */     // GIR_Coverage, 18186,
     /* 2164876 */     GIR_EraseRootFromParent_Done,
     /* 2164877 */   // Label 28558: @2164877
     /* 2164877 */   GIM_Try, /*On fail goto*//*Label 28559*/ GIMT_Encode4(2164968), // Rule ID 18187 //
     /* 2164882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2164893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2164896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2164902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164928 */     // MIs[0] round
     /* 2164928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164931 */     // MIs[0] policy
     /* 2164931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164941 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2164944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164967 */     // GIR_Coverage, 18187,
     /* 2164967 */     GIR_EraseRootFromParent_Done,
     /* 2164968 */   // Label 28559: @2164968
     /* 2164968 */   GIM_Try, /*On fail goto*//*Label 28560*/ GIMT_Encode4(2165059), // Rule ID 18190 //
     /* 2164973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2164984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2164987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2164993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165019 */     // MIs[0] round
     /* 2165019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165022 */     // MIs[0] policy
     /* 2165022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165032 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2165035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165058 */     // GIR_Coverage, 18190,
     /* 2165058 */     GIR_EraseRootFromParent_Done,
     /* 2165059 */   // Label 28560: @2165059
     /* 2165059 */   GIM_Try, /*On fail goto*//*Label 28561*/ GIMT_Encode4(2165150), // Rule ID 18191 //
     /* 2165064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2165075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2165078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2165084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165110 */     // MIs[0] round
     /* 2165110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165113 */     // MIs[0] policy
     /* 2165113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165123 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2165126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165149 */     // GIR_Coverage, 18191,
     /* 2165149 */     GIR_EraseRootFromParent_Done,
     /* 2165150 */   // Label 28561: @2165150
     /* 2165150 */   GIM_Try, /*On fail goto*//*Label 28562*/ GIMT_Encode4(2165241), // Rule ID 18194 //
     /* 2165155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2165158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2165166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2165169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2165175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165201 */     // MIs[0] round
     /* 2165201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165204 */     // MIs[0] policy
     /* 2165204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165214 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2165217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165240 */     // GIR_Coverage, 18194,
     /* 2165240 */     GIR_EraseRootFromParent_Done,
     /* 2165241 */   // Label 28562: @2165241
     /* 2165241 */   GIM_Try, /*On fail goto*//*Label 28563*/ GIMT_Encode4(2165332), // Rule ID 18195 //
     /* 2165246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2165249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2165257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2165260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2165266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165292 */     // MIs[0] round
     /* 2165292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165295 */     // MIs[0] policy
     /* 2165295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165305 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2165308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165331 */     // GIR_Coverage, 18195,
     /* 2165331 */     GIR_EraseRootFromParent_Done,
     /* 2165332 */   // Label 28563: @2165332
     /* 2165332 */   GIM_Try, /*On fail goto*//*Label 28564*/ GIMT_Encode4(2165423), // Rule ID 18198 //
     /* 2165337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2165348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2165351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2165357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2165360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165383 */     // MIs[0] round
     /* 2165383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165386 */     // MIs[0] policy
     /* 2165386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165396 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2165399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165422 */     // GIR_Coverage, 18198,
     /* 2165422 */     GIR_EraseRootFromParent_Done,
     /* 2165423 */   // Label 28564: @2165423
     /* 2165423 */   GIM_Try, /*On fail goto*//*Label 28565*/ GIMT_Encode4(2165514), // Rule ID 18199 //
     /* 2165428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2165439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2165442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2165448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2165451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165474 */     // MIs[0] round
     /* 2165474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165477 */     // MIs[0] policy
     /* 2165477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165487 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2165490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165513 */     // GIR_Coverage, 18199,
     /* 2165513 */     GIR_EraseRootFromParent_Done,
     /* 2165514 */   // Label 28565: @2165514
     /* 2165514 */   GIM_Try, /*On fail goto*//*Label 28566*/ GIMT_Encode4(2165605), // Rule ID 18202 //
     /* 2165519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2165522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2165530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2165533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2165539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165565 */     // MIs[0] round
     /* 2165565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165568 */     // MIs[0] policy
     /* 2165568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165578 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2165581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165604 */     // GIR_Coverage, 18202,
     /* 2165604 */     GIR_EraseRootFromParent_Done,
     /* 2165605 */   // Label 28566: @2165605
     /* 2165605 */   GIM_Try, /*On fail goto*//*Label 28567*/ GIMT_Encode4(2165696), // Rule ID 18203 //
     /* 2165610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2165613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2165621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2165624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2165630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165656 */     // MIs[0] round
     /* 2165656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165659 */     // MIs[0] policy
     /* 2165659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165669 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2165672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165695 */     // GIR_Coverage, 18203,
     /* 2165695 */     GIR_EraseRootFromParent_Done,
     /* 2165696 */   // Label 28567: @2165696
     /* 2165696 */   GIM_Try, /*On fail goto*//*Label 28568*/ GIMT_Encode4(2165787), // Rule ID 18206 //
     /* 2165701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2165704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2165712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2165715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2165721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165747 */     // MIs[0] round
     /* 2165747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165750 */     // MIs[0] policy
     /* 2165750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165760 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2165763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165786 */     // GIR_Coverage, 18206,
     /* 2165786 */     GIR_EraseRootFromParent_Done,
     /* 2165787 */   // Label 28568: @2165787
     /* 2165787 */   GIM_Try, /*On fail goto*//*Label 28569*/ GIMT_Encode4(2165878), // Rule ID 18207 //
     /* 2165792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2165795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2165803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2165806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2165812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165838 */     // MIs[0] round
     /* 2165838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165841 */     // MIs[0] policy
     /* 2165841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165851 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2165854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165877 */     // GIR_Coverage, 18207,
     /* 2165877 */     GIR_EraseRootFromParent_Done,
     /* 2165878 */   // Label 28569: @2165878
     /* 2165878 */   GIM_Try, /*On fail goto*//*Label 28570*/ GIMT_Encode4(2165969), // Rule ID 18210 //
     /* 2165883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2165894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2165897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2165903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165929 */     // MIs[0] round
     /* 2165929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165932 */     // MIs[0] policy
     /* 2165932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165942 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2165945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165968 */     // GIR_Coverage, 18210,
     /* 2165968 */     GIR_EraseRootFromParent_Done,
     /* 2165969 */   // Label 28570: @2165969
     /* 2165969 */   GIM_Try, /*On fail goto*//*Label 28571*/ GIMT_Encode4(2166060), // Rule ID 18211 //
     /* 2165974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2165985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2165988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2165994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2166012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166020 */     // MIs[0] round
     /* 2166020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166023 */     // MIs[0] policy
     /* 2166023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166033 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2166036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166059 */     // GIR_Coverage, 18211,
     /* 2166059 */     GIR_EraseRootFromParent_Done,
     /* 2166060 */   // Label 28571: @2166060
     /* 2166060 */   GIM_Try, /*On fail goto*//*Label 28572*/ GIMT_Encode4(2166151), // Rule ID 18214 //
     /* 2166065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2166068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2166076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2166079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2166082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2166085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2166103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166111 */     // MIs[0] round
     /* 2166111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166114 */     // MIs[0] policy
     /* 2166114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166124 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2166127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166150 */     // GIR_Coverage, 18214,
     /* 2166150 */     GIR_EraseRootFromParent_Done,
     /* 2166151 */   // Label 28572: @2166151
     /* 2166151 */   GIM_Try, /*On fail goto*//*Label 28573*/ GIMT_Encode4(2166242), // Rule ID 18215 //
     /* 2166156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2166159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2166167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2166170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2166173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2166176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2166194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166202 */     // MIs[0] round
     /* 2166202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166205 */     // MIs[0] policy
     /* 2166205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166215 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2166218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166241 */     // GIR_Coverage, 18215,
     /* 2166241 */     GIR_EraseRootFromParent_Done,
     /* 2166242 */   // Label 28573: @2166242
     /* 2166242 */   GIM_Try, /*On fail goto*//*Label 28574*/ GIMT_Encode4(2166333), // Rule ID 18218 //
     /* 2166247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2166250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2166258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2166261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2166264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2166267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2166270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2166285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166293 */     // MIs[0] round
     /* 2166293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166296 */     // MIs[0] policy
     /* 2166296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166306 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2166309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166332 */     // GIR_Coverage, 18218,
     /* 2166332 */     GIR_EraseRootFromParent_Done,
     /* 2166333 */   // Label 28574: @2166333
     /* 2166333 */   GIM_Try, /*On fail goto*//*Label 28575*/ GIMT_Encode4(2166424), // Rule ID 18219 //
     /* 2166338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2166341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2166349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2166352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2166355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2166358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2166361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2166376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166384 */     // MIs[0] round
     /* 2166384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166387 */     // MIs[0] policy
     /* 2166387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166397 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2166400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166423 */     // GIR_Coverage, 18219,
     /* 2166423 */     GIR_EraseRootFromParent_Done,
     /* 2166424 */   // Label 28575: @2166424
     /* 2166424 */   GIM_Try, /*On fail goto*//*Label 28576*/ GIMT_Encode4(2166515), // Rule ID 18222 //
     /* 2166429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2166440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2166443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2166449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166475 */     // MIs[0] round
     /* 2166475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166478 */     // MIs[0] policy
     /* 2166478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166488 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2166491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166514 */     // GIR_Coverage, 18222,
     /* 2166514 */     GIR_EraseRootFromParent_Done,
     /* 2166515 */   // Label 28576: @2166515
     /* 2166515 */   GIM_Try, /*On fail goto*//*Label 28577*/ GIMT_Encode4(2166606), // Rule ID 18223 //
     /* 2166520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2166531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2166534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2166540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166566 */     // MIs[0] round
     /* 2166566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166569 */     // MIs[0] policy
     /* 2166569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166579 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2166582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166605 */     // GIR_Coverage, 18223,
     /* 2166605 */     GIR_EraseRootFromParent_Done,
     /* 2166606 */   // Label 28577: @2166606
     /* 2166606 */   GIM_Try, /*On fail goto*//*Label 28578*/ GIMT_Encode4(2166697), // Rule ID 18226 //
     /* 2166611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2166622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2166625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2166631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166657 */     // MIs[0] round
     /* 2166657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166660 */     // MIs[0] policy
     /* 2166660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166670 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2166673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166696 */     // GIR_Coverage, 18226,
     /* 2166696 */     GIR_EraseRootFromParent_Done,
     /* 2166697 */   // Label 28578: @2166697
     /* 2166697 */   GIM_Try, /*On fail goto*//*Label 28579*/ GIMT_Encode4(2166788), // Rule ID 18227 //
     /* 2166702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2166713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2166716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2166722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166748 */     // MIs[0] round
     /* 2166748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166751 */     // MIs[0] policy
     /* 2166751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166761 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2166764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166787 */     // GIR_Coverage, 18227,
     /* 2166787 */     GIR_EraseRootFromParent_Done,
     /* 2166788 */   // Label 28579: @2166788
     /* 2166788 */   GIM_Try, /*On fail goto*//*Label 28580*/ GIMT_Encode4(2166879), // Rule ID 18230 //
     /* 2166793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2166804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2166807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2166813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166839 */     // MIs[0] round
     /* 2166839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166842 */     // MIs[0] policy
     /* 2166842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166852 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2166855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166878 */     // GIR_Coverage, 18230,
     /* 2166878 */     GIR_EraseRootFromParent_Done,
     /* 2166879 */   // Label 28580: @2166879
     /* 2166879 */   GIM_Try, /*On fail goto*//*Label 28581*/ GIMT_Encode4(2166970), // Rule ID 18231 //
     /* 2166884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2166895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2166898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2166904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166930 */     // MIs[0] round
     /* 2166930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166933 */     // MIs[0] policy
     /* 2166933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166943 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2166946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166969 */     // GIR_Coverage, 18231,
     /* 2166969 */     GIR_EraseRootFromParent_Done,
     /* 2166970 */   // Label 28581: @2166970
     /* 2166970 */   GIM_Try, /*On fail goto*//*Label 28582*/ GIMT_Encode4(2167061), // Rule ID 18234 //
     /* 2166975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2166986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2166989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2166995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167021 */     // MIs[0] round
     /* 2167021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167024 */     // MIs[0] policy
     /* 2167024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167034 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2167037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167060 */     // GIR_Coverage, 18234,
     /* 2167060 */     GIR_EraseRootFromParent_Done,
     /* 2167061 */   // Label 28582: @2167061
     /* 2167061 */   GIM_Try, /*On fail goto*//*Label 28583*/ GIMT_Encode4(2167152), // Rule ID 18235 //
     /* 2167066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2167069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2167077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2167080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2167083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2167086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167112 */     // MIs[0] round
     /* 2167112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167115 */     // MIs[0] policy
     /* 2167115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167125 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2167128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167151 */     // GIR_Coverage, 18235,
     /* 2167151 */     GIR_EraseRootFromParent_Done,
     /* 2167152 */   // Label 28583: @2167152
     /* 2167152 */   GIM_Try, /*On fail goto*//*Label 28584*/ GIMT_Encode4(2167243), // Rule ID 18238 //
     /* 2167157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2167160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2167168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2167171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2167174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2167177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2167187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167203 */     // MIs[0] round
     /* 2167203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167206 */     // MIs[0] policy
     /* 2167206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167216 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2167219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167242 */     // GIR_Coverage, 18238,
     /* 2167242 */     GIR_EraseRootFromParent_Done,
     /* 2167243 */   // Label 28584: @2167243
     /* 2167243 */   GIM_Try, /*On fail goto*//*Label 28585*/ GIMT_Encode4(2167334), // Rule ID 18239 //
     /* 2167248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2167251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2167259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2167262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2167265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2167268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2167278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167294 */     // MIs[0] round
     /* 2167294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167297 */     // MIs[0] policy
     /* 2167297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167307 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2167310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167333 */     // GIR_Coverage, 18239,
     /* 2167333 */     GIR_EraseRootFromParent_Done,
     /* 2167334 */   // Label 28585: @2167334
     /* 2167334 */   GIM_Try, /*On fail goto*//*Label 28586*/ GIMT_Encode4(2167425), // Rule ID 18242 //
     /* 2167339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2167342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2167350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2167353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2167356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2167359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2167362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2167369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167385 */     // MIs[0] round
     /* 2167385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167388 */     // MIs[0] policy
     /* 2167388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167398 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2167401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167424 */     // GIR_Coverage, 18242,
     /* 2167424 */     GIR_EraseRootFromParent_Done,
     /* 2167425 */   // Label 28586: @2167425
     /* 2167425 */   GIM_Try, /*On fail goto*//*Label 28587*/ GIMT_Encode4(2167516), // Rule ID 18243 //
     /* 2167430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2167433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2167441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2167444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2167447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2167450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2167453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2167460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167476 */     // MIs[0] round
     /* 2167476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167479 */     // MIs[0] policy
     /* 2167479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167489 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2167492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167515 */     // GIR_Coverage, 18243,
     /* 2167515 */     GIR_EraseRootFromParent_Done,
     /* 2167516 */   // Label 28587: @2167516
     /* 2167516 */   GIM_Try, /*On fail goto*//*Label 28588*/ GIMT_Encode4(2167607), // Rule ID 18246 //
     /* 2167521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2167532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2167535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2167538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2167541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167567 */     // MIs[0] round
     /* 2167567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167570 */     // MIs[0] policy
     /* 2167570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167580 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2167583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167606 */     // GIR_Coverage, 18246,
     /* 2167606 */     GIR_EraseRootFromParent_Done,
     /* 2167607 */   // Label 28588: @2167607
     /* 2167607 */   GIM_Try, /*On fail goto*//*Label 28589*/ GIMT_Encode4(2167698), // Rule ID 18247 //
     /* 2167612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2167623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2167626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2167629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2167632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167658 */     // MIs[0] round
     /* 2167658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167661 */     // MIs[0] policy
     /* 2167661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167671 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2167674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167697 */     // GIR_Coverage, 18247,
     /* 2167697 */     GIR_EraseRootFromParent_Done,
     /* 2167698 */   // Label 28589: @2167698
     /* 2167698 */   GIM_Try, /*On fail goto*//*Label 28590*/ GIMT_Encode4(2167789), // Rule ID 18250 //
     /* 2167703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2167714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2167717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2167720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2167723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167749 */     // MIs[0] round
     /* 2167749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167752 */     // MIs[0] policy
     /* 2167752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167762 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2167765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167788 */     // GIR_Coverage, 18250,
     /* 2167788 */     GIR_EraseRootFromParent_Done,
     /* 2167789 */   // Label 28590: @2167789
     /* 2167789 */   GIM_Try, /*On fail goto*//*Label 28591*/ GIMT_Encode4(2167880), // Rule ID 18251 //
     /* 2167794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2167805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2167808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2167811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2167814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167840 */     // MIs[0] round
     /* 2167840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167843 */     // MIs[0] policy
     /* 2167843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167853 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2167856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167879 */     // GIR_Coverage, 18251,
     /* 2167879 */     GIR_EraseRootFromParent_Done,
     /* 2167880 */   // Label 28591: @2167880
     /* 2167880 */   GIM_Try, /*On fail goto*//*Label 28592*/ GIMT_Encode4(2167971), // Rule ID 18254 //
     /* 2167885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2167896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2167899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2167902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2167905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167931 */     // MIs[0] round
     /* 2167931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167934 */     // MIs[0] policy
     /* 2167934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167944 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2167947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167970 */     // GIR_Coverage, 18254,
     /* 2167970 */     GIR_EraseRootFromParent_Done,
     /* 2167971 */   // Label 28592: @2167971
     /* 2167971 */   GIM_Try, /*On fail goto*//*Label 28593*/ GIMT_Encode4(2168062), // Rule ID 18255 //
     /* 2167976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2167987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2167990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2167993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2167996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168022 */     // MIs[0] round
     /* 2168022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168025 */     // MIs[0] policy
     /* 2168025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168035 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2168038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168061 */     // GIR_Coverage, 18255,
     /* 2168061 */     GIR_EraseRootFromParent_Done,
     /* 2168062 */   // Label 28593: @2168062
     /* 2168062 */   GIM_Try, /*On fail goto*//*Label 28594*/ GIMT_Encode4(2168153), // Rule ID 18258 //
     /* 2168067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2168078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2168081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2168084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2168087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168113 */     // MIs[0] round
     /* 2168113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168116 */     // MIs[0] policy
     /* 2168116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168126 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2168129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168152 */     // GIR_Coverage, 18258,
     /* 2168152 */     GIR_EraseRootFromParent_Done,
     /* 2168153 */   // Label 28594: @2168153
     /* 2168153 */   GIM_Try, /*On fail goto*//*Label 28595*/ GIMT_Encode4(2168244), // Rule ID 18259 //
     /* 2168158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2168169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2168172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2168175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2168178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168204 */     // MIs[0] round
     /* 2168204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168207 */     // MIs[0] policy
     /* 2168207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168217 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2168220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168243 */     // GIR_Coverage, 18259,
     /* 2168243 */     GIR_EraseRootFromParent_Done,
     /* 2168244 */   // Label 28595: @2168244
     /* 2168244 */   GIM_Try, /*On fail goto*//*Label 28596*/ GIMT_Encode4(2168335), // Rule ID 18262 //
     /* 2168249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2168252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2168260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2168263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2168266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2168269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2168272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168295 */     // MIs[0] round
     /* 2168295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168298 */     // MIs[0] policy
     /* 2168298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168308 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2168311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168334 */     // GIR_Coverage, 18262,
     /* 2168334 */     GIR_EraseRootFromParent_Done,
     /* 2168335 */   // Label 28596: @2168335
     /* 2168335 */   GIM_Try, /*On fail goto*//*Label 28597*/ GIMT_Encode4(2168426), // Rule ID 18263 //
     /* 2168340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2168343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2168351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2168354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2168357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2168360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2168363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168386 */     // MIs[0] round
     /* 2168386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168389 */     // MIs[0] policy
     /* 2168389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168399 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2168402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168425 */     // GIR_Coverage, 18263,
     /* 2168425 */     GIR_EraseRootFromParent_Done,
     /* 2168426 */   // Label 28597: @2168426
     /* 2168426 */   GIM_Try, /*On fail goto*//*Label 28598*/ GIMT_Encode4(2168517), // Rule ID 18266 //
     /* 2168431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2168434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2168442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2168445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2168448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2168451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168477 */     // MIs[0] round
     /* 2168477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168480 */     // MIs[0] policy
     /* 2168480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2168493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168516 */     // GIR_Coverage, 18266,
     /* 2168516 */     GIR_EraseRootFromParent_Done,
     /* 2168517 */   // Label 28598: @2168517
     /* 2168517 */   GIM_Try, /*On fail goto*//*Label 28599*/ GIMT_Encode4(2168608), // Rule ID 18267 //
     /* 2168522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2168525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2168533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2168536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2168539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2168542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168568 */     // MIs[0] round
     /* 2168568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168571 */     // MIs[0] policy
     /* 2168571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168581 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2168584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168607 */     // GIR_Coverage, 18267,
     /* 2168607 */     GIR_EraseRootFromParent_Done,
     /* 2168608 */   // Label 28599: @2168608
     /* 2168608 */   GIM_Try, /*On fail goto*//*Label 28600*/ GIMT_Encode4(2168699), // Rule ID 18270 //
     /* 2168613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2168624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2168627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2168630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2168633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168659 */     // MIs[0] round
     /* 2168659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168662 */     // MIs[0] policy
     /* 2168662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168672 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2168675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168698 */     // GIR_Coverage, 18270,
     /* 2168698 */     GIR_EraseRootFromParent_Done,
     /* 2168699 */   // Label 28600: @2168699
     /* 2168699 */   GIM_Try, /*On fail goto*//*Label 28601*/ GIMT_Encode4(2168790), // Rule ID 18271 //
     /* 2168704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2168715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2168718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2168721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2168724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168750 */     // MIs[0] round
     /* 2168750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168753 */     // MIs[0] policy
     /* 2168753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168763 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2168766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168789 */     // GIR_Coverage, 18271,
     /* 2168789 */     GIR_EraseRootFromParent_Done,
     /* 2168790 */   // Label 28601: @2168790
     /* 2168790 */   GIM_Try, /*On fail goto*//*Label 28602*/ GIMT_Encode4(2168881), // Rule ID 18274 //
     /* 2168795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2168806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2168809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2168812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2168815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2168818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168841 */     // MIs[0] round
     /* 2168841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168844 */     // MIs[0] policy
     /* 2168844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168854 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2168857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168880 */     // GIR_Coverage, 18274,
     /* 2168880 */     GIR_EraseRootFromParent_Done,
     /* 2168881 */   // Label 28602: @2168881
     /* 2168881 */   GIM_Try, /*On fail goto*//*Label 28603*/ GIMT_Encode4(2168972), // Rule ID 18275 //
     /* 2168886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2168897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2168900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2168903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2168906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2168909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168932 */     // MIs[0] round
     /* 2168932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168935 */     // MIs[0] policy
     /* 2168935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168945 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2168948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168971 */     // GIR_Coverage, 18275,
     /* 2168971 */     GIR_EraseRootFromParent_Done,
     /* 2168972 */   // Label 28603: @2168972
     /* 2168972 */   GIM_Try, /*On fail goto*//*Label 28604*/ GIMT_Encode4(2169063), // Rule ID 18278 //
     /* 2168977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2168988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2168991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2168994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2168997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2169000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169023 */     // MIs[0] round
     /* 2169023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169026 */     // MIs[0] policy
     /* 2169026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169036 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2169039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169062 */     // GIR_Coverage, 18278,
     /* 2169062 */     GIR_EraseRootFromParent_Done,
     /* 2169063 */   // Label 28604: @2169063
     /* 2169063 */   GIM_Try, /*On fail goto*//*Label 28605*/ GIMT_Encode4(2169154), // Rule ID 18279 //
     /* 2169068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2169071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2169079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2169082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2169085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2169088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2169091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169114 */     // MIs[0] round
     /* 2169114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169117 */     // MIs[0] policy
     /* 2169117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169127 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2169130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169153 */     // GIR_Coverage, 18279,
     /* 2169153 */     GIR_EraseRootFromParent_Done,
     /* 2169154 */   // Label 28605: @2169154
     /* 2169154 */   GIM_Try, /*On fail goto*//*Label 28606*/ GIMT_Encode4(2169245), // Rule ID 18282 //
     /* 2169159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2169162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2169170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2169173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2169176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2169179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169205 */     // MIs[0] round
     /* 2169205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169208 */     // MIs[0] policy
     /* 2169208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169218 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2169221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169244 */     // GIR_Coverage, 18282,
     /* 2169244 */     GIR_EraseRootFromParent_Done,
     /* 2169245 */   // Label 28606: @2169245
     /* 2169245 */   GIM_Try, /*On fail goto*//*Label 28607*/ GIMT_Encode4(2169336), // Rule ID 18283 //
     /* 2169250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2169253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2169261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2169264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2169267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2169270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169296 */     // MIs[0] round
     /* 2169296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169299 */     // MIs[0] policy
     /* 2169299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169309 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2169312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169335 */     // GIR_Coverage, 18283,
     /* 2169335 */     GIR_EraseRootFromParent_Done,
     /* 2169336 */   // Label 28607: @2169336
     /* 2169336 */   GIM_Try, /*On fail goto*//*Label 28608*/ GIMT_Encode4(2169427), // Rule ID 18286 //
     /* 2169341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2169344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2169352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2169355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2169358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2169361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169387 */     // MIs[0] round
     /* 2169387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169390 */     // MIs[0] policy
     /* 2169390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169400 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2169403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169426 */     // GIR_Coverage, 18286,
     /* 2169426 */     GIR_EraseRootFromParent_Done,
     /* 2169427 */   // Label 28608: @2169427
     /* 2169427 */   GIM_Try, /*On fail goto*//*Label 28609*/ GIMT_Encode4(2169518), // Rule ID 18287 //
     /* 2169432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2169435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2169443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2169446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2169449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2169452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169478 */     // MIs[0] round
     /* 2169478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169481 */     // MIs[0] policy
     /* 2169481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169491 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2169494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169517 */     // GIR_Coverage, 18287,
     /* 2169517 */     GIR_EraseRootFromParent_Done,
     /* 2169518 */   // Label 28609: @2169518
     /* 2169518 */   GIM_Try, /*On fail goto*//*Label 28610*/ GIMT_Encode4(2169609), // Rule ID 18290 //
     /* 2169523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2169526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2169534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2169537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2169540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2169543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2169546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169569 */     // MIs[0] round
     /* 2169569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169572 */     // MIs[0] policy
     /* 2169572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169582 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2169585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169608 */     // GIR_Coverage, 18290,
     /* 2169608 */     GIR_EraseRootFromParent_Done,
     /* 2169609 */   // Label 28610: @2169609
     /* 2169609 */   GIM_Try, /*On fail goto*//*Label 28611*/ GIMT_Encode4(2169700), // Rule ID 18291 //
     /* 2169614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2169617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2169625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2169628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2169631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2169634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2169637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169660 */     // MIs[0] round
     /* 2169660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169663 */     // MIs[0] policy
     /* 2169663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169673 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2169676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169699 */     // GIR_Coverage, 18291,
     /* 2169699 */     GIR_EraseRootFromParent_Done,
     /* 2169700 */   // Label 28611: @2169700
     /* 2169700 */   GIM_Try, /*On fail goto*//*Label 28612*/ GIMT_Encode4(2169791), // Rule ID 18294 //
     /* 2169705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2169716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2169719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2169722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2169725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169751 */     // MIs[0] round
     /* 2169751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169754 */     // MIs[0] policy
     /* 2169754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169764 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2169767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169790 */     // GIR_Coverage, 18294,
     /* 2169790 */     GIR_EraseRootFromParent_Done,
     /* 2169791 */   // Label 28612: @2169791
     /* 2169791 */   GIM_Try, /*On fail goto*//*Label 28613*/ GIMT_Encode4(2169882), // Rule ID 18295 //
     /* 2169796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2169807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2169810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2169813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2169816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169842 */     // MIs[0] round
     /* 2169842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169845 */     // MIs[0] policy
     /* 2169845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169855 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2169858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169881 */     // GIR_Coverage, 18295,
     /* 2169881 */     GIR_EraseRootFromParent_Done,
     /* 2169882 */   // Label 28613: @2169882
     /* 2169882 */   GIM_Try, /*On fail goto*//*Label 28614*/ GIMT_Encode4(2169973), // Rule ID 18298 //
     /* 2169887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2169898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2169901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2169904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2169907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169933 */     // MIs[0] round
     /* 2169933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169936 */     // MIs[0] policy
     /* 2169936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169946 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2169949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169972 */     // GIR_Coverage, 18298,
     /* 2169972 */     GIR_EraseRootFromParent_Done,
     /* 2169973 */   // Label 28614: @2169973
     /* 2169973 */   GIM_Try, /*On fail goto*//*Label 28615*/ GIMT_Encode4(2170064), // Rule ID 18299 //
     /* 2169978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2169989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2169992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2169995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2169998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2170008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170024 */     // MIs[0] round
     /* 2170024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170027 */     // MIs[0] policy
     /* 2170027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170037 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2170040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170063 */     // GIR_Coverage, 18299,
     /* 2170063 */     GIR_EraseRootFromParent_Done,
     /* 2170064 */   // Label 28615: @2170064
     /* 2170064 */   GIM_Try, /*On fail goto*//*Label 28616*/ GIMT_Encode4(2170155), // Rule ID 18302 //
     /* 2170069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2170072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2170080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2170083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2170086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2170089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2170099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170115 */     // MIs[0] round
     /* 2170115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170118 */     // MIs[0] policy
     /* 2170118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170128 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2170131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170154 */     // GIR_Coverage, 18302,
     /* 2170154 */     GIR_EraseRootFromParent_Done,
     /* 2170155 */   // Label 28616: @2170155
     /* 2170155 */   GIM_Try, /*On fail goto*//*Label 28617*/ GIMT_Encode4(2170246), // Rule ID 18303 //
     /* 2170160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2170163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2170171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2170174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2170177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2170180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2170190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170206 */     // MIs[0] round
     /* 2170206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170209 */     // MIs[0] policy
     /* 2170209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170219 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2170222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170245 */     // GIR_Coverage, 18303,
     /* 2170245 */     GIR_EraseRootFromParent_Done,
     /* 2170246 */   // Label 28617: @2170246
     /* 2170246 */   GIM_Try, /*On fail goto*//*Label 28618*/ GIMT_Encode4(2170337), // Rule ID 18306 //
     /* 2170251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2170262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2170265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2170271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170297 */     // MIs[0] round
     /* 2170297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170300 */     // MIs[0] policy
     /* 2170300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170310 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2170313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170336 */     // GIR_Coverage, 18306,
     /* 2170336 */     GIR_EraseRootFromParent_Done,
     /* 2170337 */   // Label 28618: @2170337
     /* 2170337 */   GIM_Try, /*On fail goto*//*Label 28619*/ GIMT_Encode4(2170428), // Rule ID 18307 //
     /* 2170342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2170353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2170356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2170362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170388 */     // MIs[0] round
     /* 2170388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170391 */     // MIs[0] policy
     /* 2170391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170401 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2170404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170427 */     // GIR_Coverage, 18307,
     /* 2170427 */     GIR_EraseRootFromParent_Done,
     /* 2170428 */   // Label 28619: @2170428
     /* 2170428 */   GIM_Try, /*On fail goto*//*Label 28620*/ GIMT_Encode4(2170519), // Rule ID 18310 //
     /* 2170433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2170444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2170447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2170453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170479 */     // MIs[0] round
     /* 2170479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170482 */     // MIs[0] policy
     /* 2170482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170492 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2170495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170518 */     // GIR_Coverage, 18310,
     /* 2170518 */     GIR_EraseRootFromParent_Done,
     /* 2170519 */   // Label 28620: @2170519
     /* 2170519 */   GIM_Try, /*On fail goto*//*Label 28621*/ GIMT_Encode4(2170610), // Rule ID 18311 //
     /* 2170524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2170535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2170538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2170544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170570 */     // MIs[0] round
     /* 2170570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170573 */     // MIs[0] policy
     /* 2170573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170583 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2170586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170609 */     // GIR_Coverage, 18311,
     /* 2170609 */     GIR_EraseRootFromParent_Done,
     /* 2170610 */   // Label 28621: @2170610
     /* 2170610 */   GIM_Try, /*On fail goto*//*Label 28622*/ GIMT_Encode4(2170701), // Rule ID 18314 //
     /* 2170615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2170626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2170629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2170635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170661 */     // MIs[0] round
     /* 2170661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170664 */     // MIs[0] policy
     /* 2170664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170674 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2170677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170700 */     // GIR_Coverage, 18314,
     /* 2170700 */     GIR_EraseRootFromParent_Done,
     /* 2170701 */   // Label 28622: @2170701
     /* 2170701 */   GIM_Try, /*On fail goto*//*Label 28623*/ GIMT_Encode4(2170792), // Rule ID 18315 //
     /* 2170706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2170709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2170717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2170720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2170726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170752 */     // MIs[0] round
     /* 2170752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170755 */     // MIs[0] policy
     /* 2170755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170765 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2170768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170791 */     // GIR_Coverage, 18315,
     /* 2170791 */     GIR_EraseRootFromParent_Done,
     /* 2170792 */   // Label 28623: @2170792
     /* 2170792 */   GIM_Try, /*On fail goto*//*Label 28624*/ GIMT_Encode4(2170883), // Rule ID 18318 //
     /* 2170797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2170808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2170811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2170817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170843 */     // MIs[0] round
     /* 2170843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170846 */     // MIs[0] policy
     /* 2170846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170856 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2170859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170882 */     // GIR_Coverage, 18318,
     /* 2170882 */     GIR_EraseRootFromParent_Done,
     /* 2170883 */   // Label 28624: @2170883
     /* 2170883 */   GIM_Try, /*On fail goto*//*Label 28625*/ GIMT_Encode4(2170974), // Rule ID 18319 //
     /* 2170888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2170899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2170902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2170908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170934 */     // MIs[0] round
     /* 2170934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170937 */     // MIs[0] policy
     /* 2170937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170947 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2170950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170973 */     // GIR_Coverage, 18319,
     /* 2170973 */     GIR_EraseRootFromParent_Done,
     /* 2170974 */   // Label 28625: @2170974
     /* 2170974 */   GIM_Try, /*On fail goto*//*Label 28626*/ GIMT_Encode4(2171065), // Rule ID 18322 //
     /* 2170979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2170990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2170993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2170999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171025 */     // MIs[0] round
     /* 2171025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171028 */     // MIs[0] policy
     /* 2171028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171038 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2171041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171064 */     // GIR_Coverage, 18322,
     /* 2171064 */     GIR_EraseRootFromParent_Done,
     /* 2171065 */   // Label 28626: @2171065
     /* 2171065 */   GIM_Try, /*On fail goto*//*Label 28627*/ GIMT_Encode4(2171156), // Rule ID 18323 //
     /* 2171070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2171081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2171084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2171090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171116 */     // MIs[0] round
     /* 2171116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171119 */     // MIs[0] policy
     /* 2171119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171129 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2171132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171155 */     // GIR_Coverage, 18323,
     /* 2171155 */     GIR_EraseRootFromParent_Done,
     /* 2171156 */   // Label 28627: @2171156
     /* 2171156 */   GIM_Try, /*On fail goto*//*Label 28628*/ GIMT_Encode4(2171247), // Rule ID 18326 //
     /* 2171161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2171164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2171172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2171175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2171178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2171181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2171199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171207 */     // MIs[0] round
     /* 2171207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171210 */     // MIs[0] policy
     /* 2171210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171220 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2171223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171246 */     // GIR_Coverage, 18326,
     /* 2171246 */     GIR_EraseRootFromParent_Done,
     /* 2171247 */   // Label 28628: @2171247
     /* 2171247 */   GIM_Try, /*On fail goto*//*Label 28629*/ GIMT_Encode4(2171338), // Rule ID 18327 //
     /* 2171252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2171255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2171263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2171266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2171269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2171272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2171290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171298 */     // MIs[0] round
     /* 2171298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171301 */     // MIs[0] policy
     /* 2171301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171311 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2171314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171337 */     // GIR_Coverage, 18327,
     /* 2171337 */     GIR_EraseRootFromParent_Done,
     /* 2171338 */   // Label 28629: @2171338
     /* 2171338 */   GIM_Try, /*On fail goto*//*Label 28630*/ GIMT_Encode4(2171429), // Rule ID 18330 //
     /* 2171343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2171354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2171357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2171363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2171366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171389 */     // MIs[0] round
     /* 2171389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171392 */     // MIs[0] policy
     /* 2171392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171402 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2171405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171428 */     // GIR_Coverage, 18330,
     /* 2171428 */     GIR_EraseRootFromParent_Done,
     /* 2171429 */   // Label 28630: @2171429
     /* 2171429 */   GIM_Try, /*On fail goto*//*Label 28631*/ GIMT_Encode4(2171520), // Rule ID 18331 //
     /* 2171434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2171445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2171448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2171454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2171457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171480 */     // MIs[0] round
     /* 2171480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171483 */     // MIs[0] policy
     /* 2171483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171493 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2171496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171519 */     // GIR_Coverage, 18331,
     /* 2171519 */     GIR_EraseRootFromParent_Done,
     /* 2171520 */   // Label 28631: @2171520
     /* 2171520 */   GIM_Try, /*On fail goto*//*Label 28632*/ GIMT_Encode4(2171611), // Rule ID 18334 //
     /* 2171525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2171536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2171539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2171545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171571 */     // MIs[0] round
     /* 2171571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171574 */     // MIs[0] policy
     /* 2171574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171584 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2171587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171610 */     // GIR_Coverage, 18334,
     /* 2171610 */     GIR_EraseRootFromParent_Done,
     /* 2171611 */   // Label 28632: @2171611
     /* 2171611 */   GIM_Try, /*On fail goto*//*Label 28633*/ GIMT_Encode4(2171702), // Rule ID 18335 //
     /* 2171616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2171627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2171630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2171636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171662 */     // MIs[0] round
     /* 2171662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171665 */     // MIs[0] policy
     /* 2171665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171675 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2171678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171701 */     // GIR_Coverage, 18335,
     /* 2171701 */     GIR_EraseRootFromParent_Done,
     /* 2171702 */   // Label 28633: @2171702
     /* 2171702 */   GIM_Try, /*On fail goto*//*Label 28634*/ GIMT_Encode4(2171793), // Rule ID 18338 //
     /* 2171707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2171718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2171721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2171727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2171730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171753 */     // MIs[0] round
     /* 2171753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171756 */     // MIs[0] policy
     /* 2171756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171766 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2171769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171792 */     // GIR_Coverage, 18338,
     /* 2171792 */     GIR_EraseRootFromParent_Done,
     /* 2171793 */   // Label 28634: @2171793
     /* 2171793 */   GIM_Try, /*On fail goto*//*Label 28635*/ GIMT_Encode4(2171884), // Rule ID 18339 //
     /* 2171798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2171809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2171812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2171818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2171821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171844 */     // MIs[0] round
     /* 2171844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171847 */     // MIs[0] policy
     /* 2171847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171857 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2171860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171883 */     // GIR_Coverage, 18339,
     /* 2171883 */     GIR_EraseRootFromParent_Done,
     /* 2171884 */   // Label 28635: @2171884
     /* 2171884 */   GIM_Try, /*On fail goto*//*Label 28636*/ GIMT_Encode4(2171975), // Rule ID 18342 //
     /* 2171889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2171900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2171903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2171909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171935 */     // MIs[0] round
     /* 2171935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171938 */     // MIs[0] policy
     /* 2171938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171948 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2171951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171974 */     // GIR_Coverage, 18342,
     /* 2171974 */     GIR_EraseRootFromParent_Done,
     /* 2171975 */   // Label 28636: @2171975
     /* 2171975 */   GIM_Try, /*On fail goto*//*Label 28637*/ GIMT_Encode4(2172066), // Rule ID 18343 //
     /* 2171980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2171991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2171994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2172000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2172018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172026 */     // MIs[0] round
     /* 2172026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172029 */     // MIs[0] policy
     /* 2172029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172039 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2172042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172065 */     // GIR_Coverage, 18343,
     /* 2172065 */     GIR_EraseRootFromParent_Done,
     /* 2172066 */   // Label 28637: @2172066
     /* 2172066 */   GIM_Try, /*On fail goto*//*Label 28638*/ GIMT_Encode4(2172157), // Rule ID 18346 //
     /* 2172071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2172082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2172085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2172088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2172091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2172109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172117 */     // MIs[0] round
     /* 2172117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172120 */     // MIs[0] policy
     /* 2172120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172130 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2172133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172156 */     // GIR_Coverage, 18346,
     /* 2172156 */     GIR_EraseRootFromParent_Done,
     /* 2172157 */   // Label 28638: @2172157
     /* 2172157 */   GIM_Try, /*On fail goto*//*Label 28639*/ GIMT_Encode4(2172248), // Rule ID 18347 //
     /* 2172162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2172165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2172173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2172176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2172179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2172182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2172200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172208 */     // MIs[0] round
     /* 2172208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172211 */     // MIs[0] policy
     /* 2172211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172221 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2172224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172247 */     // GIR_Coverage, 18347,
     /* 2172247 */     GIR_EraseRootFromParent_Done,
     /* 2172248 */   // Label 28639: @2172248
     /* 2172248 */   GIM_Try, /*On fail goto*//*Label 28640*/ GIMT_Encode4(2172339), // Rule ID 18350 //
     /* 2172253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2172264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2172267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2172270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2172273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2172276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2172291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172299 */     // MIs[0] round
     /* 2172299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172302 */     // MIs[0] policy
     /* 2172302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172312 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2172315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172338 */     // GIR_Coverage, 18350,
     /* 2172338 */     GIR_EraseRootFromParent_Done,
     /* 2172339 */   // Label 28640: @2172339
     /* 2172339 */   GIM_Try, /*On fail goto*//*Label 28641*/ GIMT_Encode4(2172430), // Rule ID 18351 //
     /* 2172344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2172347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2172355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2172358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2172361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2172364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2172367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2172382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172390 */     // MIs[0] round
     /* 2172390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172393 */     // MIs[0] policy
     /* 2172393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172403 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2172406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172429 */     // GIR_Coverage, 18351,
     /* 2172429 */     GIR_EraseRootFromParent_Done,
     /* 2172430 */   // Label 28641: @2172430
     /* 2172430 */   GIM_Try, /*On fail goto*//*Label 28642*/ GIMT_Encode4(2172521), // Rule ID 18354 //
     /* 2172435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2172438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2172446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2172449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2172455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172481 */     // MIs[0] round
     /* 2172481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172484 */     // MIs[0] policy
     /* 2172484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172494 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2172497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172520 */     // GIR_Coverage, 18354,
     /* 2172520 */     GIR_EraseRootFromParent_Done,
     /* 2172521 */   // Label 28642: @2172521
     /* 2172521 */   GIM_Try, /*On fail goto*//*Label 28643*/ GIMT_Encode4(2172612), // Rule ID 18355 //
     /* 2172526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2172537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2172540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2172546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172572 */     // MIs[0] round
     /* 2172572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172575 */     // MIs[0] policy
     /* 2172575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172585 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2172588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172611 */     // GIR_Coverage, 18355,
     /* 2172611 */     GIR_EraseRootFromParent_Done,
     /* 2172612 */   // Label 28643: @2172612
     /* 2172612 */   GIM_Try, /*On fail goto*//*Label 28644*/ GIMT_Encode4(2172703), // Rule ID 18358 //
     /* 2172617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2172620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2172628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2172631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2172637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172663 */     // MIs[0] round
     /* 2172663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172666 */     // MIs[0] policy
     /* 2172666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172676 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2172679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172702 */     // GIR_Coverage, 18358,
     /* 2172702 */     GIR_EraseRootFromParent_Done,
     /* 2172703 */   // Label 28644: @2172703
     /* 2172703 */   GIM_Try, /*On fail goto*//*Label 28645*/ GIMT_Encode4(2172794), // Rule ID 18359 //
     /* 2172708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2172719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2172722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2172728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172754 */     // MIs[0] round
     /* 2172754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172757 */     // MIs[0] policy
     /* 2172757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172767 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2172770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172793 */     // GIR_Coverage, 18359,
     /* 2172793 */     GIR_EraseRootFromParent_Done,
     /* 2172794 */   // Label 28645: @2172794
     /* 2172794 */   GIM_Try, /*On fail goto*//*Label 28646*/ GIMT_Encode4(2172885), // Rule ID 18362 //
     /* 2172799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2172802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2172810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2172813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2172819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172845 */     // MIs[0] round
     /* 2172845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172848 */     // MIs[0] policy
     /* 2172848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172858 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2172861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172884 */     // GIR_Coverage, 18362,
     /* 2172884 */     GIR_EraseRootFromParent_Done,
     /* 2172885 */   // Label 28646: @2172885
     /* 2172885 */   GIM_Try, /*On fail goto*//*Label 28647*/ GIMT_Encode4(2172976), // Rule ID 18363 //
     /* 2172890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2172901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2172904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2172910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172936 */     // MIs[0] round
     /* 2172936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172939 */     // MIs[0] policy
     /* 2172939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172949 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2172952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172975 */     // GIR_Coverage, 18363,
     /* 2172975 */     GIR_EraseRootFromParent_Done,
     /* 2172976 */   // Label 28647: @2172976
     /* 2172976 */   GIM_Try, /*On fail goto*//*Label 28648*/ GIMT_Encode4(2173067), // Rule ID 18366 //
     /* 2172981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2172992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2172995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2172998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2173001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173027 */     // MIs[0] round
     /* 2173027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173030 */     // MIs[0] policy
     /* 2173030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173040 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2173043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173066 */     // GIR_Coverage, 18366,
     /* 2173066 */     GIR_EraseRootFromParent_Done,
     /* 2173067 */   // Label 28648: @2173067
     /* 2173067 */   GIM_Try, /*On fail goto*//*Label 28649*/ GIMT_Encode4(2173158), // Rule ID 18367 //
     /* 2173072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2173083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2173086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2173089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2173092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173118 */     // MIs[0] round
     /* 2173118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173121 */     // MIs[0] policy
     /* 2173121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173131 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2173134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173157 */     // GIR_Coverage, 18367,
     /* 2173157 */     GIR_EraseRootFromParent_Done,
     /* 2173158 */   // Label 28649: @2173158
     /* 2173158 */   GIM_Try, /*On fail goto*//*Label 28650*/ GIMT_Encode4(2173249), // Rule ID 18370 //
     /* 2173163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2173174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2173177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2173180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2173183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173209 */     // MIs[0] round
     /* 2173209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173212 */     // MIs[0] policy
     /* 2173212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173222 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2173225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173248 */     // GIR_Coverage, 18370,
     /* 2173248 */     GIR_EraseRootFromParent_Done,
     /* 2173249 */   // Label 28650: @2173249
     /* 2173249 */   GIM_Try, /*On fail goto*//*Label 28651*/ GIMT_Encode4(2173340), // Rule ID 18371 //
     /* 2173254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2173265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2173268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2173271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2173274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173300 */     // MIs[0] round
     /* 2173300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173303 */     // MIs[0] policy
     /* 2173303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173313 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2173316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173339 */     // GIR_Coverage, 18371,
     /* 2173339 */     GIR_EraseRootFromParent_Done,
     /* 2173340 */   // Label 28651: @2173340
     /* 2173340 */   GIM_Try, /*On fail goto*//*Label 28652*/ GIMT_Encode4(2173431), // Rule ID 18374 //
     /* 2173345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2173348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2173356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2173359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2173362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2173365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173391 */     // MIs[0] round
     /* 2173391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173394 */     // MIs[0] policy
     /* 2173394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173404 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2173407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173430 */     // GIR_Coverage, 18374,
     /* 2173430 */     GIR_EraseRootFromParent_Done,
     /* 2173431 */   // Label 28652: @2173431
     /* 2173431 */   GIM_Try, /*On fail goto*//*Label 28653*/ GIMT_Encode4(2173522), // Rule ID 18375 //
     /* 2173436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2173439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2173447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2173450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2173453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2173456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173482 */     // MIs[0] round
     /* 2173482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173485 */     // MIs[0] policy
     /* 2173485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173495 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2173498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173521 */     // GIR_Coverage, 18375,
     /* 2173521 */     GIR_EraseRootFromParent_Done,
     /* 2173522 */   // Label 28653: @2173522
     /* 2173522 */   GIM_Try, /*On fail goto*//*Label 28654*/ GIMT_Encode4(2173613), // Rule ID 18378 //
     /* 2173527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2173538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2173541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2173544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2173547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173573 */     // MIs[0] round
     /* 2173573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173576 */     // MIs[0] policy
     /* 2173576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173586 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2173589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173612 */     // GIR_Coverage, 18378,
     /* 2173612 */     GIR_EraseRootFromParent_Done,
     /* 2173613 */   // Label 28654: @2173613
     /* 2173613 */   GIM_Try, /*On fail goto*//*Label 28655*/ GIMT_Encode4(2173704), // Rule ID 18379 //
     /* 2173618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2173629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2173632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2173635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2173638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173664 */     // MIs[0] round
     /* 2173664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173667 */     // MIs[0] policy
     /* 2173667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173677 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2173680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173703 */     // GIR_Coverage, 18379,
     /* 2173703 */     GIR_EraseRootFromParent_Done,
     /* 2173704 */   // Label 28655: @2173704
     /* 2173704 */   GIM_Try, /*On fail goto*//*Label 28656*/ GIMT_Encode4(2173795), // Rule ID 18382 //
     /* 2173709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2173712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2173720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2173723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2173726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2173729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173755 */     // MIs[0] round
     /* 2173755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173758 */     // MIs[0] policy
     /* 2173758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173768 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2173771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173794 */     // GIR_Coverage, 18382,
     /* 2173794 */     GIR_EraseRootFromParent_Done,
     /* 2173795 */   // Label 28656: @2173795
     /* 2173795 */   GIM_Try, /*On fail goto*//*Label 28657*/ GIMT_Encode4(2173886), // Rule ID 18383 //
     /* 2173800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2173803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2173811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2173814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2173817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2173820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173846 */     // MIs[0] round
     /* 2173846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173849 */     // MIs[0] policy
     /* 2173849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173859 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2173862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173885 */     // GIR_Coverage, 18383,
     /* 2173885 */     GIR_EraseRootFromParent_Done,
     /* 2173886 */   // Label 28657: @2173886
     /* 2173886 */   GIM_Try, /*On fail goto*//*Label 28658*/ GIMT_Encode4(2173977), // Rule ID 18386 //
     /* 2173891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2173894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2173902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2173905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2173908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2173911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173937 */     // MIs[0] round
     /* 2173937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173940 */     // MIs[0] policy
     /* 2173940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173950 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2173953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173976 */     // GIR_Coverage, 18386,
     /* 2173976 */     GIR_EraseRootFromParent_Done,
     /* 2173977 */   // Label 28658: @2173977
     /* 2173977 */   GIM_Try, /*On fail goto*//*Label 28659*/ GIMT_Encode4(2174068), // Rule ID 18387 //
     /* 2173982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2173985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2173993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2173996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2173999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2174002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2174005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174028 */     // MIs[0] round
     /* 2174028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174031 */     // MIs[0] policy
     /* 2174031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174041 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2174044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174067 */     // GIR_Coverage, 18387,
     /* 2174067 */     GIR_EraseRootFromParent_Done,
     /* 2174068 */   // Label 28659: @2174068
     /* 2174068 */   GIM_Try, /*On fail goto*//*Label 28660*/ GIMT_Encode4(2174159), // Rule ID 18390 //
     /* 2174073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2174084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2174087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2174090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2174093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174119 */     // MIs[0] round
     /* 2174119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174122 */     // MIs[0] policy
     /* 2174122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174132 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2174135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174158 */     // GIR_Coverage, 18390,
     /* 2174158 */     GIR_EraseRootFromParent_Done,
     /* 2174159 */   // Label 28660: @2174159
     /* 2174159 */   GIM_Try, /*On fail goto*//*Label 28661*/ GIMT_Encode4(2174250), // Rule ID 18391 //
     /* 2174164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2174175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2174178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2174181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2174184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174210 */     // MIs[0] round
     /* 2174210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174213 */     // MIs[0] policy
     /* 2174213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174223 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2174226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174249 */     // GIR_Coverage, 18391,
     /* 2174249 */     GIR_EraseRootFromParent_Done,
     /* 2174250 */   // Label 28661: @2174250
     /* 2174250 */   GIM_Try, /*On fail goto*//*Label 28662*/ GIMT_Encode4(2174341), // Rule ID 18394 //
     /* 2174255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2174266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2174269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2174272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2174275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2174278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174301 */     // MIs[0] round
     /* 2174301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174304 */     // MIs[0] policy
     /* 2174304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174314 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2174317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174340 */     // GIR_Coverage, 18394,
     /* 2174340 */     GIR_EraseRootFromParent_Done,
     /* 2174341 */   // Label 28662: @2174341
     /* 2174341 */   GIM_Try, /*On fail goto*//*Label 28663*/ GIMT_Encode4(2174432), // Rule ID 18395 //
     /* 2174346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2174357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2174360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2174363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2174366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2174369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174392 */     // MIs[0] round
     /* 2174392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174395 */     // MIs[0] policy
     /* 2174395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174405 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2174408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174431 */     // GIR_Coverage, 18395,
     /* 2174431 */     GIR_EraseRootFromParent_Done,
     /* 2174432 */   // Label 28663: @2174432
     /* 2174432 */   GIM_Try, /*On fail goto*//*Label 28664*/ GIMT_Encode4(2174523), // Rule ID 18398 //
     /* 2174437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2174448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2174451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2174454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2174457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2174460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174483 */     // MIs[0] round
     /* 2174483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174486 */     // MIs[0] policy
     /* 2174486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174496 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2174499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174522 */     // GIR_Coverage, 18398,
     /* 2174522 */     GIR_EraseRootFromParent_Done,
     /* 2174523 */   // Label 28664: @2174523
     /* 2174523 */   GIM_Try, /*On fail goto*//*Label 28665*/ GIMT_Encode4(2174614), // Rule ID 18399 //
     /* 2174528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2174539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2174542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2174545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2174548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2174551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174574 */     // MIs[0] round
     /* 2174574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174577 */     // MIs[0] policy
     /* 2174577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174587 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2174590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174613 */     // GIR_Coverage, 18399,
     /* 2174613 */     GIR_EraseRootFromParent_Done,
     /* 2174614 */   // Label 28665: @2174614
     /* 2174614 */   GIM_Try, /*On fail goto*//*Label 28666*/ GIMT_Encode4(2174705), // Rule ID 18402 //
     /* 2174619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2174630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2174633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2174636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2174639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174665 */     // MIs[0] round
     /* 2174665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174668 */     // MIs[0] policy
     /* 2174668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174678 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2174681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174704 */     // GIR_Coverage, 18402,
     /* 2174704 */     GIR_EraseRootFromParent_Done,
     /* 2174705 */   // Label 28666: @2174705
     /* 2174705 */   GIM_Try, /*On fail goto*//*Label 28667*/ GIMT_Encode4(2174796), // Rule ID 18403 //
     /* 2174710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2174721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2174724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2174727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2174730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174756 */     // MIs[0] round
     /* 2174756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174759 */     // MIs[0] policy
     /* 2174759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174769 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2174772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174795 */     // GIR_Coverage, 18403,
     /* 2174795 */     GIR_EraseRootFromParent_Done,
     /* 2174796 */   // Label 28667: @2174796
     /* 2174796 */   GIM_Try, /*On fail goto*//*Label 28668*/ GIMT_Encode4(2174887), // Rule ID 18406 //
     /* 2174801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2174812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2174815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2174818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2174821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174847 */     // MIs[0] round
     /* 2174847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174850 */     // MIs[0] policy
     /* 2174850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174860 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2174863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174886 */     // GIR_Coverage, 18406,
     /* 2174886 */     GIR_EraseRootFromParent_Done,
     /* 2174887 */   // Label 28668: @2174887
     /* 2174887 */   GIM_Try, /*On fail goto*//*Label 28669*/ GIMT_Encode4(2174978), // Rule ID 18407 //
     /* 2174892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2174903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2174906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2174909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2174912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174938 */     // MIs[0] round
     /* 2174938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174941 */     // MIs[0] policy
     /* 2174941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174951 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2174954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174977 */     // GIR_Coverage, 18407,
     /* 2174977 */     GIR_EraseRootFromParent_Done,
     /* 2174978 */   // Label 28669: @2174978
     /* 2174978 */   GIM_Try, /*On fail goto*//*Label 28670*/ GIMT_Encode4(2175069), // Rule ID 18410 //
     /* 2174983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2174994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2174997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2175000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2175003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2175006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175029 */     // MIs[0] round
     /* 2175029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175032 */     // MIs[0] policy
     /* 2175032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175042 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2175045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175068 */     // GIR_Coverage, 18410,
     /* 2175068 */     GIR_EraseRootFromParent_Done,
     /* 2175069 */   // Label 28670: @2175069
     /* 2175069 */   GIM_Try, /*On fail goto*//*Label 28671*/ GIMT_Encode4(2175160), // Rule ID 18411 //
     /* 2175074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2175077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2175085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2175088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2175091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2175094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2175097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175120 */     // MIs[0] round
     /* 2175120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175123 */     // MIs[0] policy
     /* 2175123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175133 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2175136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175159 */     // GIR_Coverage, 18411,
     /* 2175159 */     GIR_EraseRootFromParent_Done,
     /* 2175160 */   // Label 28671: @2175160
     /* 2175160 */   GIM_Try, /*On fail goto*//*Label 28672*/ GIMT_Encode4(2175251), // Rule ID 18414 //
     /* 2175165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2175168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2175176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2175179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2175182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2175185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2175195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175211 */     // MIs[0] round
     /* 2175211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175214 */     // MIs[0] policy
     /* 2175214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175224 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2175227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175250 */     // GIR_Coverage, 18414,
     /* 2175250 */     GIR_EraseRootFromParent_Done,
     /* 2175251 */   // Label 28672: @2175251
     /* 2175251 */   GIM_Try, /*On fail goto*//*Label 28673*/ GIMT_Encode4(2175342), // Rule ID 18415 //
     /* 2175256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2175259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2175267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2175270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2175273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2175276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2175286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175302 */     // MIs[0] round
     /* 2175302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175305 */     // MIs[0] policy
     /* 2175305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175315 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2175318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175341 */     // GIR_Coverage, 18415,
     /* 2175341 */     GIR_EraseRootFromParent_Done,
     /* 2175342 */   // Label 28673: @2175342
     /* 2175342 */   GIM_Try, /*On fail goto*//*Label 28674*/ GIMT_Encode4(2175433), // Rule ID 18418 //
     /* 2175347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2175350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2175358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2175361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2175364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2175367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2175377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175393 */     // MIs[0] round
     /* 2175393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175396 */     // MIs[0] policy
     /* 2175396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175406 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2175409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175432 */     // GIR_Coverage, 18418,
     /* 2175432 */     GIR_EraseRootFromParent_Done,
     /* 2175433 */   // Label 28674: @2175433
     /* 2175433 */   GIM_Try, /*On fail goto*//*Label 28675*/ GIMT_Encode4(2175524), // Rule ID 18419 //
     /* 2175438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2175441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2175449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2175452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2175455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2175458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2175468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175484 */     // MIs[0] round
     /* 2175484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175487 */     // MIs[0] policy
     /* 2175487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175497 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2175500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175523 */     // GIR_Coverage, 18419,
     /* 2175523 */     GIR_EraseRootFromParent_Done,
     /* 2175524 */   // Label 28675: @2175524
     /* 2175524 */   GIM_Try, /*On fail goto*//*Label 28676*/ GIMT_Encode4(2175615), // Rule ID 18422 //
     /* 2175529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2175532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2175540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2175543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2175546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2175549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175575 */     // MIs[0] round
     /* 2175575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175578 */     // MIs[0] policy
     /* 2175578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175588 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2175591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175614 */     // GIR_Coverage, 18422,
     /* 2175614 */     GIR_EraseRootFromParent_Done,
     /* 2175615 */   // Label 28676: @2175615
     /* 2175615 */   GIM_Try, /*On fail goto*//*Label 28677*/ GIMT_Encode4(2175706), // Rule ID 18423 //
     /* 2175620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2175623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2175631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2175634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2175637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2175640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175666 */     // MIs[0] round
     /* 2175666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175669 */     // MIs[0] policy
     /* 2175669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175679 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2175682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175705 */     // GIR_Coverage, 18423,
     /* 2175705 */     GIR_EraseRootFromParent_Done,
     /* 2175706 */   // Label 28677: @2175706
     /* 2175706 */   GIM_Try, /*On fail goto*//*Label 28678*/ GIMT_Encode4(2175797), // Rule ID 18426 //
     /* 2175711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2175722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2175725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2175731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175757 */     // MIs[0] round
     /* 2175757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175760 */     // MIs[0] policy
     /* 2175760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175770 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2175773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175796 */     // GIR_Coverage, 18426,
     /* 2175796 */     GIR_EraseRootFromParent_Done,
     /* 2175797 */   // Label 28678: @2175797
     /* 2175797 */   GIM_Try, /*On fail goto*//*Label 28679*/ GIMT_Encode4(2175888), // Rule ID 18427 //
     /* 2175802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2175813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2175816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2175822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175848 */     // MIs[0] round
     /* 2175848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175851 */     // MIs[0] policy
     /* 2175851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175861 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2175864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175887 */     // GIR_Coverage, 18427,
     /* 2175887 */     GIR_EraseRootFromParent_Done,
     /* 2175888 */   // Label 28679: @2175888
     /* 2175888 */   GIM_Try, /*On fail goto*//*Label 28680*/ GIMT_Encode4(2175979), // Rule ID 18430 //
     /* 2175893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2175904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2175907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2175913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175939 */     // MIs[0] round
     /* 2175939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175942 */     // MIs[0] policy
     /* 2175942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175952 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2175955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175978 */     // GIR_Coverage, 18430,
     /* 2175978 */     GIR_EraseRootFromParent_Done,
     /* 2175979 */   // Label 28680: @2175979
     /* 2175979 */   GIM_Try, /*On fail goto*//*Label 28681*/ GIMT_Encode4(2176070), // Rule ID 18431 //
     /* 2175984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2175995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2175998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2176004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176030 */     // MIs[0] round
     /* 2176030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176033 */     // MIs[0] policy
     /* 2176033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176043 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2176046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176069 */     // GIR_Coverage, 18431,
     /* 2176069 */     GIR_EraseRootFromParent_Done,
     /* 2176070 */   // Label 28681: @2176070
     /* 2176070 */   GIM_Try, /*On fail goto*//*Label 28682*/ GIMT_Encode4(2176161), // Rule ID 18434 //
     /* 2176075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2176078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2176086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2176089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2176095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176121 */     // MIs[0] round
     /* 2176121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176124 */     // MIs[0] policy
     /* 2176124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176134 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2176137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176160 */     // GIR_Coverage, 18434,
     /* 2176160 */     GIR_EraseRootFromParent_Done,
     /* 2176161 */   // Label 28682: @2176161
     /* 2176161 */   GIM_Try, /*On fail goto*//*Label 28683*/ GIMT_Encode4(2176252), // Rule ID 18435 //
     /* 2176166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2176169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2176177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2176180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2176186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176212 */     // MIs[0] round
     /* 2176212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176215 */     // MIs[0] policy
     /* 2176215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176225 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2176228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176251 */     // GIR_Coverage, 18435,
     /* 2176251 */     GIR_EraseRootFromParent_Done,
     /* 2176252 */   // Label 28683: @2176252
     /* 2176252 */   GIM_Try, /*On fail goto*//*Label 28684*/ GIMT_Encode4(2176343), // Rule ID 18438 //
     /* 2176257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2176268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2176271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2176277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176303 */     // MIs[0] round
     /* 2176303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176306 */     // MIs[0] policy
     /* 2176306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176316 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2176319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176342 */     // GIR_Coverage, 18438,
     /* 2176342 */     GIR_EraseRootFromParent_Done,
     /* 2176343 */   // Label 28684: @2176343
     /* 2176343 */   GIM_Try, /*On fail goto*//*Label 28685*/ GIMT_Encode4(2176434), // Rule ID 18439 //
     /* 2176348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2176359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2176362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2176368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176394 */     // MIs[0] round
     /* 2176394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176397 */     // MIs[0] policy
     /* 2176397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176407 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2176410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176433 */     // GIR_Coverage, 18439,
     /* 2176433 */     GIR_EraseRootFromParent_Done,
     /* 2176434 */   // Label 28685: @2176434
     /* 2176434 */   GIM_Try, /*On fail goto*//*Label 28686*/ GIMT_Encode4(2176525), // Rule ID 18442 //
     /* 2176439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2176442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2176450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2176453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2176459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176485 */     // MIs[0] round
     /* 2176485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176488 */     // MIs[0] policy
     /* 2176488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176498 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2176501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176524 */     // GIR_Coverage, 18442,
     /* 2176524 */     GIR_EraseRootFromParent_Done,
     /* 2176525 */   // Label 28686: @2176525
     /* 2176525 */   GIM_Try, /*On fail goto*//*Label 28687*/ GIMT_Encode4(2176616), // Rule ID 18443 //
     /* 2176530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2176533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2176541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2176544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2176550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176576 */     // MIs[0] round
     /* 2176576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176579 */     // MIs[0] policy
     /* 2176579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176589 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2176592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176615 */     // GIR_Coverage, 18443,
     /* 2176615 */     GIR_EraseRootFromParent_Done,
     /* 2176616 */   // Label 28687: @2176616
     /* 2176616 */   GIM_Try, /*On fail goto*//*Label 28688*/ GIMT_Encode4(2176707), // Rule ID 18446 //
     /* 2176621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2176624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2176632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2176635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2176641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176667 */     // MIs[0] round
     /* 2176667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176670 */     // MIs[0] policy
     /* 2176670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176680 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2176683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176706 */     // GIR_Coverage, 18446,
     /* 2176706 */     GIR_EraseRootFromParent_Done,
     /* 2176707 */   // Label 28688: @2176707
     /* 2176707 */   GIM_Try, /*On fail goto*//*Label 28689*/ GIMT_Encode4(2176798), // Rule ID 18447 //
     /* 2176712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2176715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2176723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2176726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2176732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176758 */     // MIs[0] round
     /* 2176758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176761 */     // MIs[0] policy
     /* 2176761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176771 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2176774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176797 */     // GIR_Coverage, 18447,
     /* 2176797 */     GIR_EraseRootFromParent_Done,
     /* 2176798 */   // Label 28689: @2176798
     /* 2176798 */   GIM_Try, /*On fail goto*//*Label 28690*/ GIMT_Encode4(2176889), // Rule ID 18450 //
     /* 2176803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2176814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2176817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2176823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176849 */     // MIs[0] round
     /* 2176849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176852 */     // MIs[0] policy
     /* 2176852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176862 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2176865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176888 */     // GIR_Coverage, 18450,
     /* 2176888 */     GIR_EraseRootFromParent_Done,
     /* 2176889 */   // Label 28690: @2176889
     /* 2176889 */   GIM_Try, /*On fail goto*//*Label 28691*/ GIMT_Encode4(2176980), // Rule ID 18451 //
     /* 2176894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2176905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2176908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2176914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176940 */     // MIs[0] round
     /* 2176940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176943 */     // MIs[0] policy
     /* 2176943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176953 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2176956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176979 */     // GIR_Coverage, 18451,
     /* 2176979 */     GIR_EraseRootFromParent_Done,
     /* 2176980 */   // Label 28691: @2176980
     /* 2176980 */   GIM_Try, /*On fail goto*//*Label 28692*/ GIMT_Encode4(2177071), // Rule ID 18454 //
     /* 2176985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2176996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2176999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2177002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2177005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2177023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177031 */     // MIs[0] round
     /* 2177031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177034 */     // MIs[0] policy
     /* 2177034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177044 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2177047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177070 */     // GIR_Coverage, 18454,
     /* 2177070 */     GIR_EraseRootFromParent_Done,
     /* 2177071 */   // Label 28692: @2177071
     /* 2177071 */   GIM_Try, /*On fail goto*//*Label 28693*/ GIMT_Encode4(2177162), // Rule ID 18455 //
     /* 2177076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2177079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2177087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2177090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2177093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2177096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2177114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177122 */     // MIs[0] round
     /* 2177122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177125 */     // MIs[0] policy
     /* 2177125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177135 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2177138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177161 */     // GIR_Coverage, 18455,
     /* 2177161 */     GIR_EraseRootFromParent_Done,
     /* 2177162 */   // Label 28693: @2177162
     /* 2177162 */   GIM_Try, /*On fail goto*//*Label 28694*/ GIMT_Encode4(2177253), // Rule ID 18458 //
     /* 2177167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2177170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2177178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2177181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2177184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2177187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2177190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2177205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177213 */     // MIs[0] round
     /* 2177213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177216 */     // MIs[0] policy
     /* 2177216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177226 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2177229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177252 */     // GIR_Coverage, 18458,
     /* 2177252 */     GIR_EraseRootFromParent_Done,
     /* 2177253 */   // Label 28694: @2177253
     /* 2177253 */   GIM_Try, /*On fail goto*//*Label 28695*/ GIMT_Encode4(2177344), // Rule ID 18459 //
     /* 2177258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2177261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2177269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2177272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2177275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2177278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2177281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2177296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177304 */     // MIs[0] round
     /* 2177304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177307 */     // MIs[0] policy
     /* 2177307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177317 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2177320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177343 */     // GIR_Coverage, 18459,
     /* 2177343 */     GIR_EraseRootFromParent_Done,
     /* 2177344 */   // Label 28695: @2177344
     /* 2177344 */   GIM_Try, /*On fail goto*//*Label 28696*/ GIMT_Encode4(2177435), // Rule ID 18462 //
     /* 2177349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2177360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2177363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2177369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177395 */     // MIs[0] round
     /* 2177395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177398 */     // MIs[0] policy
     /* 2177398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177408 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2177411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177434 */     // GIR_Coverage, 18462,
     /* 2177434 */     GIR_EraseRootFromParent_Done,
     /* 2177435 */   // Label 28696: @2177435
     /* 2177435 */   GIM_Try, /*On fail goto*//*Label 28697*/ GIMT_Encode4(2177526), // Rule ID 18463 //
     /* 2177440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2177451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2177454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2177460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177486 */     // MIs[0] round
     /* 2177486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177489 */     // MIs[0] policy
     /* 2177489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177499 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2177502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177525 */     // GIR_Coverage, 18463,
     /* 2177525 */     GIR_EraseRootFromParent_Done,
     /* 2177526 */   // Label 28697: @2177526
     /* 2177526 */   GIM_Try, /*On fail goto*//*Label 28698*/ GIMT_Encode4(2177617), // Rule ID 18466 //
     /* 2177531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2177542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2177545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2177551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177577 */     // MIs[0] round
     /* 2177577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177580 */     // MIs[0] policy
     /* 2177580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177590 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2177593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177616 */     // GIR_Coverage, 18466,
     /* 2177616 */     GIR_EraseRootFromParent_Done,
     /* 2177617 */   // Label 28698: @2177617
     /* 2177617 */   GIM_Try, /*On fail goto*//*Label 28699*/ GIMT_Encode4(2177708), // Rule ID 18467 //
     /* 2177622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2177633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2177636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2177642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177668 */     // MIs[0] round
     /* 2177668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177671 */     // MIs[0] policy
     /* 2177671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177681 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2177684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177707 */     // GIR_Coverage, 18467,
     /* 2177707 */     GIR_EraseRootFromParent_Done,
     /* 2177708 */   // Label 28699: @2177708
     /* 2177708 */   GIM_Try, /*On fail goto*//*Label 28700*/ GIMT_Encode4(2177799), // Rule ID 18470 //
     /* 2177713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2177724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2177727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2177733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177759 */     // MIs[0] round
     /* 2177759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177762 */     // MIs[0] policy
     /* 2177762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177772 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2177775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177798 */     // GIR_Coverage, 18470,
     /* 2177798 */     GIR_EraseRootFromParent_Done,
     /* 2177799 */   // Label 28700: @2177799
     /* 2177799 */   GIM_Try, /*On fail goto*//*Label 28701*/ GIMT_Encode4(2177890), // Rule ID 18471 //
     /* 2177804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2177815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2177818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2177824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177850 */     // MIs[0] round
     /* 2177850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177853 */     // MIs[0] policy
     /* 2177853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177863 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2177866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177889 */     // GIR_Coverage, 18471,
     /* 2177889 */     GIR_EraseRootFromParent_Done,
     /* 2177890 */   // Label 28701: @2177890
     /* 2177890 */   GIM_Try, /*On fail goto*//*Label 28702*/ GIMT_Encode4(2177981), // Rule ID 18474 //
     /* 2177895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2177906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2177909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2177915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177941 */     // MIs[0] round
     /* 2177941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177944 */     // MIs[0] policy
     /* 2177944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177954 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2177957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177980 */     // GIR_Coverage, 18474,
     /* 2177980 */     GIR_EraseRootFromParent_Done,
     /* 2177981 */   // Label 28702: @2177981
     /* 2177981 */   GIM_Try, /*On fail goto*//*Label 28703*/ GIMT_Encode4(2178072), // Rule ID 18475 //
     /* 2177986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2177997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2178000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2178003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2178006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2178024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178032 */     // MIs[0] round
     /* 2178032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178035 */     // MIs[0] policy
     /* 2178035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178045 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2178048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178071 */     // GIR_Coverage, 18475,
     /* 2178071 */     GIR_EraseRootFromParent_Done,
     /* 2178072 */   // Label 28703: @2178072
     /* 2178072 */   GIM_Try, /*On fail goto*//*Label 28704*/ GIMT_Encode4(2178163), // Rule ID 18478 //
     /* 2178077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2178080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2178088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2178091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2178094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2178097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2178115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178123 */     // MIs[0] round
     /* 2178123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178126 */     // MIs[0] policy
     /* 2178126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178136 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2178139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178162 */     // GIR_Coverage, 18478,
     /* 2178162 */     GIR_EraseRootFromParent_Done,
     /* 2178163 */   // Label 28704: @2178163
     /* 2178163 */   GIM_Try, /*On fail goto*//*Label 28705*/ GIMT_Encode4(2178254), // Rule ID 18479 //
     /* 2178168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2178171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2178179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2178182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2178185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2178188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2178206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178214 */     // MIs[0] round
     /* 2178214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178217 */     // MIs[0] policy
     /* 2178217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178227 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2178230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178253 */     // GIR_Coverage, 18479,
     /* 2178253 */     GIR_EraseRootFromParent_Done,
     /* 2178254 */   // Label 28705: @2178254
     /* 2178254 */   GIM_Try, /*On fail goto*//*Label 28706*/ GIMT_Encode4(2178345), // Rule ID 18482 //
     /* 2178259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2178262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2178270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2178273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2178276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2178279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2178282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2178297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178305 */     // MIs[0] round
     /* 2178305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178308 */     // MIs[0] policy
     /* 2178308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178318 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2178321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178344 */     // GIR_Coverage, 18482,
     /* 2178344 */     GIR_EraseRootFromParent_Done,
     /* 2178345 */   // Label 28706: @2178345
     /* 2178345 */   GIM_Try, /*On fail goto*//*Label 28707*/ GIMT_Encode4(2178436), // Rule ID 18483 //
     /* 2178350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2178353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2178361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2178364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2178367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2178370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2178373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2178388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178396 */     // MIs[0] round
     /* 2178396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178399 */     // MIs[0] policy
     /* 2178399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178409 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2178412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178435 */     // GIR_Coverage, 18483,
     /* 2178435 */     GIR_EraseRootFromParent_Done,
     /* 2178436 */   // Label 28707: @2178436
     /* 2178436 */   GIM_Try, /*On fail goto*//*Label 28708*/ GIMT_Encode4(2178527), // Rule ID 18486 //
     /* 2178441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2178444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2178452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2178455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2178458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2178461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178487 */     // MIs[0] round
     /* 2178487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178490 */     // MIs[0] policy
     /* 2178490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178500 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2178503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178526 */     // GIR_Coverage, 18486,
     /* 2178526 */     GIR_EraseRootFromParent_Done,
     /* 2178527 */   // Label 28708: @2178527
     /* 2178527 */   GIM_Try, /*On fail goto*//*Label 28709*/ GIMT_Encode4(2178618), // Rule ID 18487 //
     /* 2178532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2178535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2178543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2178546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2178549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2178552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178578 */     // MIs[0] round
     /* 2178578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178581 */     // MIs[0] policy
     /* 2178581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178591 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2178594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178617 */     // GIR_Coverage, 18487,
     /* 2178617 */     GIR_EraseRootFromParent_Done,
     /* 2178618 */   // Label 28709: @2178618
     /* 2178618 */   GIM_Try, /*On fail goto*//*Label 28710*/ GIMT_Encode4(2178709), // Rule ID 18490 //
     /* 2178623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2178626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2178634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2178637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2178640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2178643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178669 */     // MIs[0] round
     /* 2178669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178672 */     // MIs[0] policy
     /* 2178672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178682 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2178685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178708 */     // GIR_Coverage, 18490,
     /* 2178708 */     GIR_EraseRootFromParent_Done,
     /* 2178709 */   // Label 28710: @2178709
     /* 2178709 */   GIM_Try, /*On fail goto*//*Label 28711*/ GIMT_Encode4(2178800), // Rule ID 18491 //
     /* 2178714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2178717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2178725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2178728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2178731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2178734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178760 */     // MIs[0] round
     /* 2178760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178763 */     // MIs[0] policy
     /* 2178763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178773 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2178776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178799 */     // GIR_Coverage, 18491,
     /* 2178799 */     GIR_EraseRootFromParent_Done,
     /* 2178800 */   // Label 28711: @2178800
     /* 2178800 */   GIM_Try, /*On fail goto*//*Label 28712*/ GIMT_Encode4(2178891), // Rule ID 18494 //
     /* 2178805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2178808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2178816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2178819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2178822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2178825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178851 */     // MIs[0] round
     /* 2178851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178854 */     // MIs[0] policy
     /* 2178854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178864 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2178867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178890 */     // GIR_Coverage, 18494,
     /* 2178890 */     GIR_EraseRootFromParent_Done,
     /* 2178891 */   // Label 28712: @2178891
     /* 2178891 */   GIM_Try, /*On fail goto*//*Label 28713*/ GIMT_Encode4(2178982), // Rule ID 18495 //
     /* 2178896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2178899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2178907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2178910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2178913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2178916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178942 */     // MIs[0] round
     /* 2178942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178945 */     // MIs[0] policy
     /* 2178945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178955 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2178958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178981 */     // GIR_Coverage, 18495,
     /* 2178981 */     GIR_EraseRootFromParent_Done,
     /* 2178982 */   // Label 28713: @2178982
     /* 2178982 */   GIM_Try, /*On fail goto*//*Label 28714*/ GIMT_Encode4(2179073), // Rule ID 18498 //
     /* 2178987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2178990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2178998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2179001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2179004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2179007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179033 */     // MIs[0] round
     /* 2179033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179036 */     // MIs[0] policy
     /* 2179036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179046 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2179049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179072 */     // GIR_Coverage, 18498,
     /* 2179072 */     GIR_EraseRootFromParent_Done,
     /* 2179073 */   // Label 28714: @2179073
     /* 2179073 */   GIM_Try, /*On fail goto*//*Label 28715*/ GIMT_Encode4(2179164), // Rule ID 18499 //
     /* 2179078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2179089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2179092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2179095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2179098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179124 */     // MIs[0] round
     /* 2179124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179127 */     // MIs[0] policy
     /* 2179127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179137 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2179140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179163 */     // GIR_Coverage, 18499,
     /* 2179163 */     GIR_EraseRootFromParent_Done,
     /* 2179164 */   // Label 28715: @2179164
     /* 2179164 */   GIM_Try, /*On fail goto*//*Label 28716*/ GIMT_Encode4(2179255), // Rule ID 18502 //
     /* 2179169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2179172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2179180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2179183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2179186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2179189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2179192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179215 */     // MIs[0] round
     /* 2179215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179218 */     // MIs[0] policy
     /* 2179218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179228 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2179231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179254 */     // GIR_Coverage, 18502,
     /* 2179254 */     GIR_EraseRootFromParent_Done,
     /* 2179255 */   // Label 28716: @2179255
     /* 2179255 */   GIM_Try, /*On fail goto*//*Label 28717*/ GIMT_Encode4(2179346), // Rule ID 18503 //
     /* 2179260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2179263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2179271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2179274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2179277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2179280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2179283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179306 */     // MIs[0] round
     /* 2179306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179309 */     // MIs[0] policy
     /* 2179309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179319 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2179322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179345 */     // GIR_Coverage, 18503,
     /* 2179345 */     GIR_EraseRootFromParent_Done,
     /* 2179346 */   // Label 28717: @2179346
     /* 2179346 */   GIM_Try, /*On fail goto*//*Label 28718*/ GIMT_Encode4(2179437), // Rule ID 18506 //
     /* 2179351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2179354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2179362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2179365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2179368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2179371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179397 */     // MIs[0] round
     /* 2179397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179400 */     // MIs[0] policy
     /* 2179400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179410 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2179413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179436 */     // GIR_Coverage, 18506,
     /* 2179436 */     GIR_EraseRootFromParent_Done,
     /* 2179437 */   // Label 28718: @2179437
     /* 2179437 */   GIM_Try, /*On fail goto*//*Label 28719*/ GIMT_Encode4(2179528), // Rule ID 18507 //
     /* 2179442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2179445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2179453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2179456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2179459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2179462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179488 */     // MIs[0] round
     /* 2179488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179491 */     // MIs[0] policy
     /* 2179491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179501 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2179504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179527 */     // GIR_Coverage, 18507,
     /* 2179527 */     GIR_EraseRootFromParent_Done,
     /* 2179528 */   // Label 28719: @2179528
     /* 2179528 */   GIM_Try, /*On fail goto*//*Label 28720*/ GIMT_Encode4(2179619), // Rule ID 18510 //
     /* 2179533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2179544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2179547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2179550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2179553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179579 */     // MIs[0] round
     /* 2179579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179582 */     // MIs[0] policy
     /* 2179582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179592 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2179595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179618 */     // GIR_Coverage, 18510,
     /* 2179618 */     GIR_EraseRootFromParent_Done,
     /* 2179619 */   // Label 28720: @2179619
     /* 2179619 */   GIM_Try, /*On fail goto*//*Label 28721*/ GIMT_Encode4(2179710), // Rule ID 18511 //
     /* 2179624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2179635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2179638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2179641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2179644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179670 */     // MIs[0] round
     /* 2179670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179673 */     // MIs[0] policy
     /* 2179673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179683 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2179686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179709 */     // GIR_Coverage, 18511,
     /* 2179709 */     GIR_EraseRootFromParent_Done,
     /* 2179710 */   // Label 28721: @2179710
     /* 2179710 */   GIM_Try, /*On fail goto*//*Label 28722*/ GIMT_Encode4(2179801), // Rule ID 18514 //
     /* 2179715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2179726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2179729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2179732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2179735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2179738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179761 */     // MIs[0] round
     /* 2179761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179764 */     // MIs[0] policy
     /* 2179764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179774 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2179777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179800 */     // GIR_Coverage, 18514,
     /* 2179800 */     GIR_EraseRootFromParent_Done,
     /* 2179801 */   // Label 28722: @2179801
     /* 2179801 */   GIM_Try, /*On fail goto*//*Label 28723*/ GIMT_Encode4(2179892), // Rule ID 18515 //
     /* 2179806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2179817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2179820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2179823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2179826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2179829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179852 */     // MIs[0] round
     /* 2179852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179855 */     // MIs[0] policy
     /* 2179855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179865 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2179868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179891 */     // GIR_Coverage, 18515,
     /* 2179891 */     GIR_EraseRootFromParent_Done,
     /* 2179892 */   // Label 28723: @2179892
     /* 2179892 */   GIM_Try, /*On fail goto*//*Label 28724*/ GIMT_Encode4(2179983), // Rule ID 18518 //
     /* 2179897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2179908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2179911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2179914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2179917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2179920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2179927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179943 */     // MIs[0] round
     /* 2179943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179946 */     // MIs[0] policy
     /* 2179946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179956 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2179959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179982 */     // GIR_Coverage, 18518,
     /* 2179982 */     GIR_EraseRootFromParent_Done,
     /* 2179983 */   // Label 28724: @2179983
     /* 2179983 */   GIM_Try, /*On fail goto*//*Label 28725*/ GIMT_Encode4(2180074), // Rule ID 18519 //
     /* 2179988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2179999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2180002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2180005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2180008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2180011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180034 */     // MIs[0] round
     /* 2180034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180037 */     // MIs[0] policy
     /* 2180037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180047 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2180050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180073 */     // GIR_Coverage, 18519,
     /* 2180073 */     GIR_EraseRootFromParent_Done,
     /* 2180074 */   // Label 28725: @2180074
     /* 2180074 */   GIM_Try, /*On fail goto*//*Label 28726*/ GIMT_Encode4(2180165), // Rule ID 18522 //
     /* 2180079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2180082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2180090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2180093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2180096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2180099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180125 */     // MIs[0] round
     /* 2180125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180128 */     // MIs[0] policy
     /* 2180128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180138 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2180141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180164 */     // GIR_Coverage, 18522,
     /* 2180164 */     GIR_EraseRootFromParent_Done,
     /* 2180165 */   // Label 28726: @2180165
     /* 2180165 */   GIM_Try, /*On fail goto*//*Label 28727*/ GIMT_Encode4(2180256), // Rule ID 18523 //
     /* 2180170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2180173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2180181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2180184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2180187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2180190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180216 */     // MIs[0] round
     /* 2180216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180219 */     // MIs[0] policy
     /* 2180219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180229 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2180232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180255 */     // GIR_Coverage, 18523,
     /* 2180255 */     GIR_EraseRootFromParent_Done,
     /* 2180256 */   // Label 28727: @2180256
     /* 2180256 */   GIM_Try, /*On fail goto*//*Label 28728*/ GIMT_Encode4(2180347), // Rule ID 18526 //
     /* 2180261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2180264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2180272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2180275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2180278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2180281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180307 */     // MIs[0] round
     /* 2180307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180310 */     // MIs[0] policy
     /* 2180310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180320 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2180323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180346 */     // GIR_Coverage, 18526,
     /* 2180346 */     GIR_EraseRootFromParent_Done,
     /* 2180347 */   // Label 28728: @2180347
     /* 2180347 */   GIM_Try, /*On fail goto*//*Label 28729*/ GIMT_Encode4(2180438), // Rule ID 18527 //
     /* 2180352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2180355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2180363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2180366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2180369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2180372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180398 */     // MIs[0] round
     /* 2180398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180401 */     // MIs[0] policy
     /* 2180401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180411 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2180414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180437 */     // GIR_Coverage, 18527,
     /* 2180437 */     GIR_EraseRootFromParent_Done,
     /* 2180438 */   // Label 28729: @2180438
     /* 2180438 */   GIM_Try, /*On fail goto*//*Label 28730*/ GIMT_Encode4(2180529), // Rule ID 18530 //
     /* 2180443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2180446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2180454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2180457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2180460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2180463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180489 */     // MIs[0] round
     /* 2180489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180492 */     // MIs[0] policy
     /* 2180492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180502 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2180505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180528 */     // GIR_Coverage, 18530,
     /* 2180528 */     GIR_EraseRootFromParent_Done,
     /* 2180529 */   // Label 28730: @2180529
     /* 2180529 */   GIM_Try, /*On fail goto*//*Label 28731*/ GIMT_Encode4(2180620), // Rule ID 18531 //
     /* 2180534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2180537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2180545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2180548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2180551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2180554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180580 */     // MIs[0] round
     /* 2180580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180583 */     // MIs[0] policy
     /* 2180583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180593 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2180596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180619 */     // GIR_Coverage, 18531,
     /* 2180619 */     GIR_EraseRootFromParent_Done,
     /* 2180620 */   // Label 28731: @2180620
     /* 2180620 */   GIM_Try, /*On fail goto*//*Label 28732*/ GIMT_Encode4(2180711), // Rule ID 18534 //
     /* 2180625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2180636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2180639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2180642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2180645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180671 */     // MIs[0] round
     /* 2180671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180674 */     // MIs[0] policy
     /* 2180674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180684 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2180687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180710 */     // GIR_Coverage, 18534,
     /* 2180710 */     GIR_EraseRootFromParent_Done,
     /* 2180711 */   // Label 28732: @2180711
     /* 2180711 */   GIM_Try, /*On fail goto*//*Label 28733*/ GIMT_Encode4(2180802), // Rule ID 18535 //
     /* 2180716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2180719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2180727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2180730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2180733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2180736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180762 */     // MIs[0] round
     /* 2180762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180765 */     // MIs[0] policy
     /* 2180765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180775 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2180778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180801 */     // GIR_Coverage, 18535,
     /* 2180801 */     GIR_EraseRootFromParent_Done,
     /* 2180802 */   // Label 28733: @2180802
     /* 2180802 */   GIM_Try, /*On fail goto*//*Label 28734*/ GIMT_Encode4(2180893), // Rule ID 18538 //
     /* 2180807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2180818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2180821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2180824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2180827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180853 */     // MIs[0] round
     /* 2180853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180856 */     // MIs[0] policy
     /* 2180856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180866 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2180869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180892 */     // GIR_Coverage, 18538,
     /* 2180892 */     GIR_EraseRootFromParent_Done,
     /* 2180893 */   // Label 28734: @2180893
     /* 2180893 */   GIM_Try, /*On fail goto*//*Label 28735*/ GIMT_Encode4(2180984), // Rule ID 18539 //
     /* 2180898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2180901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2180909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2180912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2180915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2180918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180944 */     // MIs[0] round
     /* 2180944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180947 */     // MIs[0] policy
     /* 2180947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180957 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2180960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180983 */     // GIR_Coverage, 18539,
     /* 2180983 */     GIR_EraseRootFromParent_Done,
     /* 2180984 */   // Label 28735: @2180984
     /* 2180984 */   GIM_Try, /*On fail goto*//*Label 28736*/ GIMT_Encode4(2181075), // Rule ID 18542 //
     /* 2180989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2181000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2181003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2181006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2181009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181035 */     // MIs[0] round
     /* 2181035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181038 */     // MIs[0] policy
     /* 2181038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181048 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2181051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181074 */     // GIR_Coverage, 18542,
     /* 2181074 */     GIR_EraseRootFromParent_Done,
     /* 2181075 */   // Label 28736: @2181075
     /* 2181075 */   GIM_Try, /*On fail goto*//*Label 28737*/ GIMT_Encode4(2181166), // Rule ID 18543 //
     /* 2181080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2181083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2181091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2181094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2181097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2181100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181126 */     // MIs[0] round
     /* 2181126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181129 */     // MIs[0] policy
     /* 2181129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181139 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2181142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181165 */     // GIR_Coverage, 18543,
     /* 2181165 */     GIR_EraseRootFromParent_Done,
     /* 2181166 */   // Label 28737: @2181166
     /* 2181166 */   GIM_Try, /*On fail goto*//*Label 28738*/ GIMT_Encode4(2181257), // Rule ID 18546 //
     /* 2181171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2181182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2181185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2181191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181217 */     // MIs[0] round
     /* 2181217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181220 */     // MIs[0] policy
     /* 2181220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181230 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2181233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181256 */     // GIR_Coverage, 18546,
     /* 2181256 */     GIR_EraseRootFromParent_Done,
     /* 2181257 */   // Label 28738: @2181257
     /* 2181257 */   GIM_Try, /*On fail goto*//*Label 28739*/ GIMT_Encode4(2181348), // Rule ID 18547 //
     /* 2181262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2181265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2181273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2181276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2181282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181308 */     // MIs[0] round
     /* 2181308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181311 */     // MIs[0] policy
     /* 2181311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181321 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2181324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181347 */     // GIR_Coverage, 18547,
     /* 2181347 */     GIR_EraseRootFromParent_Done,
     /* 2181348 */   // Label 28739: @2181348
     /* 2181348 */   GIM_Try, /*On fail goto*//*Label 28740*/ GIMT_Encode4(2181439), // Rule ID 18550 //
     /* 2181353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2181364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2181367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2181373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181399 */     // MIs[0] round
     /* 2181399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181402 */     // MIs[0] policy
     /* 2181402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181412 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2181415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181438 */     // GIR_Coverage, 18550,
     /* 2181438 */     GIR_EraseRootFromParent_Done,
     /* 2181439 */   // Label 28740: @2181439
     /* 2181439 */   GIM_Try, /*On fail goto*//*Label 28741*/ GIMT_Encode4(2181530), // Rule ID 18551 //
     /* 2181444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2181447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2181455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2181458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2181464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181490 */     // MIs[0] round
     /* 2181490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181493 */     // MIs[0] policy
     /* 2181493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181503 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2181506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181529 */     // GIR_Coverage, 18551,
     /* 2181529 */     GIR_EraseRootFromParent_Done,
     /* 2181530 */   // Label 28741: @2181530
     /* 2181530 */   GIM_Try, /*On fail goto*//*Label 28742*/ GIMT_Encode4(2181621), // Rule ID 18554 //
     /* 2181535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2181538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2181546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2181549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2181555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181581 */     // MIs[0] round
     /* 2181581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181584 */     // MIs[0] policy
     /* 2181584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181594 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2181597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181620 */     // GIR_Coverage, 18554,
     /* 2181620 */     GIR_EraseRootFromParent_Done,
     /* 2181621 */   // Label 28742: @2181621
     /* 2181621 */   GIM_Try, /*On fail goto*//*Label 28743*/ GIMT_Encode4(2181712), // Rule ID 18555 //
     /* 2181626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2181637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2181640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2181646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181672 */     // MIs[0] round
     /* 2181672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181675 */     // MIs[0] policy
     /* 2181675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181685 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2181688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181711 */     // GIR_Coverage, 18555,
     /* 2181711 */     GIR_EraseRootFromParent_Done,
     /* 2181712 */   // Label 28743: @2181712
     /* 2181712 */   GIM_Try, /*On fail goto*//*Label 28744*/ GIMT_Encode4(2181803), // Rule ID 18558 //
     /* 2181717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2181728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2181731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2181737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181763 */     // MIs[0] round
     /* 2181763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181766 */     // MIs[0] policy
     /* 2181766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181776 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2181779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181802 */     // GIR_Coverage, 18558,
     /* 2181802 */     GIR_EraseRootFromParent_Done,
     /* 2181803 */   // Label 28744: @2181803
     /* 2181803 */   GIM_Try, /*On fail goto*//*Label 28745*/ GIMT_Encode4(2181894), // Rule ID 18559 //
     /* 2181808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2181811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2181819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2181822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2181828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181854 */     // MIs[0] round
     /* 2181854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181857 */     // MIs[0] policy
     /* 2181857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181867 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2181870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181893 */     // GIR_Coverage, 18559,
     /* 2181893 */     GIR_EraseRootFromParent_Done,
     /* 2181894 */   // Label 28745: @2181894
     /* 2181894 */   GIM_Try, /*On fail goto*//*Label 28746*/ GIMT_Encode4(2181985), // Rule ID 18562 //
     /* 2181899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2181902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2181910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2181913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2181919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181945 */     // MIs[0] round
     /* 2181945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181948 */     // MIs[0] policy
     /* 2181948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181958 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2181961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181984 */     // GIR_Coverage, 18562,
     /* 2181984 */     GIR_EraseRootFromParent_Done,
     /* 2181985 */   // Label 28746: @2181985
     /* 2181985 */   GIM_Try, /*On fail goto*//*Label 28747*/ GIMT_Encode4(2182076), // Rule ID 18563 //
     /* 2181990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2182001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2182004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2182010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182036 */     // MIs[0] round
     /* 2182036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182039 */     // MIs[0] policy
     /* 2182039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182049 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2182052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182075 */     // GIR_Coverage, 18563,
     /* 2182075 */     GIR_EraseRootFromParent_Done,
     /* 2182076 */   // Label 28747: @2182076
     /* 2182076 */   GIM_Try, /*On fail goto*//*Label 28748*/ GIMT_Encode4(2182167), // Rule ID 18566 //
     /* 2182081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2182084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2182092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2182095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2182098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2182101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2182119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182127 */     // MIs[0] round
     /* 2182127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182130 */     // MIs[0] policy
     /* 2182130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182140 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2182143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182166 */     // GIR_Coverage, 18566,
     /* 2182166 */     GIR_EraseRootFromParent_Done,
     /* 2182167 */   // Label 28748: @2182167
     /* 2182167 */   GIM_Try, /*On fail goto*//*Label 28749*/ GIMT_Encode4(2182258), // Rule ID 18567 //
     /* 2182172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2182175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2182183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2182186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2182189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2182192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2182210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182218 */     // MIs[0] round
     /* 2182218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182221 */     // MIs[0] policy
     /* 2182221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182231 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2182234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182257 */     // GIR_Coverage, 18567,
     /* 2182257 */     GIR_EraseRootFromParent_Done,
     /* 2182258 */   // Label 28749: @2182258
     /* 2182258 */   GIM_Try, /*On fail goto*//*Label 28750*/ GIMT_Encode4(2182349), // Rule ID 18570 //
     /* 2182263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2182274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2182277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2182283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182309 */     // MIs[0] round
     /* 2182309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182312 */     // MIs[0] policy
     /* 2182312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182322 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2182325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182348 */     // GIR_Coverage, 18570,
     /* 2182348 */     GIR_EraseRootFromParent_Done,
     /* 2182349 */   // Label 28750: @2182349
     /* 2182349 */   GIM_Try, /*On fail goto*//*Label 28751*/ GIMT_Encode4(2182440), // Rule ID 18571 //
     /* 2182354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2182365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2182368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2182374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182400 */     // MIs[0] round
     /* 2182400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182403 */     // MIs[0] policy
     /* 2182403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182413 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2182416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182439 */     // GIR_Coverage, 18571,
     /* 2182439 */     GIR_EraseRootFromParent_Done,
     /* 2182440 */   // Label 28751: @2182440
     /* 2182440 */   GIM_Try, /*On fail goto*//*Label 28752*/ GIMT_Encode4(2182531), // Rule ID 18574 //
     /* 2182445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2182456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2182459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2182465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182491 */     // MIs[0] round
     /* 2182491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182494 */     // MIs[0] policy
     /* 2182494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182504 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2182507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182530 */     // GIR_Coverage, 18574,
     /* 2182530 */     GIR_EraseRootFromParent_Done,
     /* 2182531 */   // Label 28752: @2182531
     /* 2182531 */   GIM_Try, /*On fail goto*//*Label 28753*/ GIMT_Encode4(2182622), // Rule ID 18575 //
     /* 2182536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2182547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2182550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2182556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182582 */     // MIs[0] round
     /* 2182582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182585 */     // MIs[0] policy
     /* 2182585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182595 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2182598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182621 */     // GIR_Coverage, 18575,
     /* 2182621 */     GIR_EraseRootFromParent_Done,
     /* 2182622 */   // Label 28753: @2182622
     /* 2182622 */   GIM_Try, /*On fail goto*//*Label 28754*/ GIMT_Encode4(2182713), // Rule ID 18578 //
     /* 2182627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2182638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2182641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2182647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2182650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182673 */     // MIs[0] round
     /* 2182673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182676 */     // MIs[0] policy
     /* 2182676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182686 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2182689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182712 */     // GIR_Coverage, 18578,
     /* 2182712 */     GIR_EraseRootFromParent_Done,
     /* 2182713 */   // Label 28754: @2182713
     /* 2182713 */   GIM_Try, /*On fail goto*//*Label 28755*/ GIMT_Encode4(2182804), // Rule ID 18579 //
     /* 2182718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2182729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2182732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2182738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2182741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182764 */     // MIs[0] round
     /* 2182764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182767 */     // MIs[0] policy
     /* 2182767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182777 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2182780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182803 */     // GIR_Coverage, 18579,
     /* 2182803 */     GIR_EraseRootFromParent_Done,
     /* 2182804 */   // Label 28755: @2182804
     /* 2182804 */   GIM_Try, /*On fail goto*//*Label 28756*/ GIMT_Encode4(2182895), // Rule ID 18582 //
     /* 2182809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2182820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2182823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2182829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182855 */     // MIs[0] round
     /* 2182855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182858 */     // MIs[0] policy
     /* 2182858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182868 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2182871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182894 */     // GIR_Coverage, 18582,
     /* 2182894 */     GIR_EraseRootFromParent_Done,
     /* 2182895 */   // Label 28756: @2182895
     /* 2182895 */   GIM_Try, /*On fail goto*//*Label 28757*/ GIMT_Encode4(2182986), // Rule ID 18583 //
     /* 2182900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2182903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2182911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2182914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2182920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182946 */     // MIs[0] round
     /* 2182946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182949 */     // MIs[0] policy
     /* 2182949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182959 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2182962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182985 */     // GIR_Coverage, 18583,
     /* 2182985 */     GIR_EraseRootFromParent_Done,
     /* 2182986 */   // Label 28757: @2182986
     /* 2182986 */   GIM_Try, /*On fail goto*//*Label 28758*/ GIMT_Encode4(2183077), // Rule ID 18586 //
     /* 2182991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2183002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2183005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2183011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183037 */     // MIs[0] round
     /* 2183037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183040 */     // MIs[0] policy
     /* 2183040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183050 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2183053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183076 */     // GIR_Coverage, 18586,
     /* 2183076 */     GIR_EraseRootFromParent_Done,
     /* 2183077 */   // Label 28758: @2183077
     /* 2183077 */   GIM_Try, /*On fail goto*//*Label 28759*/ GIMT_Encode4(2183168), // Rule ID 18587 //
     /* 2183082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2183085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2183093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2183096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2183102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183128 */     // MIs[0] round
     /* 2183128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183131 */     // MIs[0] policy
     /* 2183131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183141 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2183144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183167 */     // GIR_Coverage, 18587,
     /* 2183167 */     GIR_EraseRootFromParent_Done,
     /* 2183168 */   // Label 28759: @2183168
     /* 2183168 */   GIM_Try, /*On fail goto*//*Label 28760*/ GIMT_Encode4(2183259), // Rule ID 18590 //
     /* 2183173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2183176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2183184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2183187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2183193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2183196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183219 */     // MIs[0] round
     /* 2183219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183222 */     // MIs[0] policy
     /* 2183222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183232 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2183235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183258 */     // GIR_Coverage, 18590,
     /* 2183258 */     GIR_EraseRootFromParent_Done,
     /* 2183259 */   // Label 28760: @2183259
     /* 2183259 */   GIM_Try, /*On fail goto*//*Label 28761*/ GIMT_Encode4(2183350), // Rule ID 18591 //
     /* 2183264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2183267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2183275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2183278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2183284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2183287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183310 */     // MIs[0] round
     /* 2183310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183313 */     // MIs[0] policy
     /* 2183313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183323 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2183326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183349 */     // GIR_Coverage, 18591,
     /* 2183349 */     GIR_EraseRootFromParent_Done,
     /* 2183350 */   // Label 28761: @2183350
     /* 2183350 */   GIM_Try, /*On fail goto*//*Label 28762*/ GIMT_Encode4(2183441), // Rule ID 18594 //
     /* 2183355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2183358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2183366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2183369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2183375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183401 */     // MIs[0] round
     /* 2183401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183404 */     // MIs[0] policy
     /* 2183404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183414 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2183417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183440 */     // GIR_Coverage, 18594,
     /* 2183440 */     GIR_EraseRootFromParent_Done,
     /* 2183441 */   // Label 28762: @2183441
     /* 2183441 */   GIM_Try, /*On fail goto*//*Label 28763*/ GIMT_Encode4(2183532), // Rule ID 18595 //
     /* 2183446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2183449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2183457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2183460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2183466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183492 */     // MIs[0] round
     /* 2183492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183495 */     // MIs[0] policy
     /* 2183495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183505 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2183508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183531 */     // GIR_Coverage, 18595,
     /* 2183531 */     GIR_EraseRootFromParent_Done,
     /* 2183532 */   // Label 28763: @2183532
     /* 2183532 */   GIM_Try, /*On fail goto*//*Label 28764*/ GIMT_Encode4(2183623), // Rule ID 18598 //
     /* 2183537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2183540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2183548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2183551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2183557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183583 */     // MIs[0] round
     /* 2183583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183586 */     // MIs[0] policy
     /* 2183586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183596 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2183599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183622 */     // GIR_Coverage, 18598,
     /* 2183622 */     GIR_EraseRootFromParent_Done,
     /* 2183623 */   // Label 28764: @2183623
     /* 2183623 */   GIM_Try, /*On fail goto*//*Label 28765*/ GIMT_Encode4(2183714), // Rule ID 18599 //
     /* 2183628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2183631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2183639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2183642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2183648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183674 */     // MIs[0] round
     /* 2183674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183677 */     // MIs[0] policy
     /* 2183677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183687 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2183690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183713 */     // GIR_Coverage, 18599,
     /* 2183713 */     GIR_EraseRootFromParent_Done,
     /* 2183714 */   // Label 28765: @2183714
     /* 2183714 */   GIM_Try, /*On fail goto*//*Label 28766*/ GIMT_Encode4(2183805), // Rule ID 18602 //
     /* 2183719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2183722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2183730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2183733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2183739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183765 */     // MIs[0] round
     /* 2183765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183768 */     // MIs[0] policy
     /* 2183768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183778 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2183781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183804 */     // GIR_Coverage, 18602,
     /* 2183804 */     GIR_EraseRootFromParent_Done,
     /* 2183805 */   // Label 28766: @2183805
     /* 2183805 */   GIM_Try, /*On fail goto*//*Label 28767*/ GIMT_Encode4(2183896), // Rule ID 18603 //
     /* 2183810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2183813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2183821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2183824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2183830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183856 */     // MIs[0] round
     /* 2183856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183859 */     // MIs[0] policy
     /* 2183859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183869 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2183872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183895 */     // GIR_Coverage, 18603,
     /* 2183895 */     GIR_EraseRootFromParent_Done,
     /* 2183896 */   // Label 28767: @2183896
     /* 2183896 */   GIM_Try, /*On fail goto*//*Label 28768*/ GIMT_Encode4(2183987), // Rule ID 18606 //
     /* 2183901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2183904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2183912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2183915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2183918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2183921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183947 */     // MIs[0] round
     /* 2183947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183950 */     // MIs[0] policy
     /* 2183950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183960 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2183963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183986 */     // GIR_Coverage, 18606,
     /* 2183986 */     GIR_EraseRootFromParent_Done,
     /* 2183987 */   // Label 28768: @2183987
     /* 2183987 */   GIM_Try, /*On fail goto*//*Label 28769*/ GIMT_Encode4(2184078), // Rule ID 18607 //
     /* 2183992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2183995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2184003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2184006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2184009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2184012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184038 */     // MIs[0] round
     /* 2184038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184041 */     // MIs[0] policy
     /* 2184041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184051 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2184054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184077 */     // GIR_Coverage, 18607,
     /* 2184077 */     GIR_EraseRootFromParent_Done,
     /* 2184078 */   // Label 28769: @2184078
     /* 2184078 */   GIM_Try, /*On fail goto*//*Label 28770*/ GIMT_Encode4(2184169), // Rule ID 18610 //
     /* 2184083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2184094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2184097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2184100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2184103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184129 */     // MIs[0] round
     /* 2184129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184132 */     // MIs[0] policy
     /* 2184132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184142 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2184145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184168 */     // GIR_Coverage, 18610,
     /* 2184168 */     GIR_EraseRootFromParent_Done,
     /* 2184169 */   // Label 28770: @2184169
     /* 2184169 */   GIM_Try, /*On fail goto*//*Label 28771*/ GIMT_Encode4(2184260), // Rule ID 18611 //
     /* 2184174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2184185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2184188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2184191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2184194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184220 */     // MIs[0] round
     /* 2184220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184223 */     // MIs[0] policy
     /* 2184223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184233 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2184236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184259 */     // GIR_Coverage, 18611,
     /* 2184259 */     GIR_EraseRootFromParent_Done,
     /* 2184260 */   // Label 28771: @2184260
     /* 2184260 */   GIM_Try, /*On fail goto*//*Label 28772*/ GIMT_Encode4(2184351), // Rule ID 18614 //
     /* 2184265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2184268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2184276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2184279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2184282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2184285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184311 */     // MIs[0] round
     /* 2184311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184314 */     // MIs[0] policy
     /* 2184314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184324 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2184327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184350 */     // GIR_Coverage, 18614,
     /* 2184350 */     GIR_EraseRootFromParent_Done,
     /* 2184351 */   // Label 28772: @2184351
     /* 2184351 */   GIM_Try, /*On fail goto*//*Label 28773*/ GIMT_Encode4(2184442), // Rule ID 18615 //
     /* 2184356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2184359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2184367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2184370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2184373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2184376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184402 */     // MIs[0] round
     /* 2184402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184405 */     // MIs[0] policy
     /* 2184405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184415 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2184418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184441 */     // GIR_Coverage, 18615,
     /* 2184441 */     GIR_EraseRootFromParent_Done,
     /* 2184442 */   // Label 28773: @2184442
     /* 2184442 */   GIM_Try, /*On fail goto*//*Label 28774*/ GIMT_Encode4(2184533), // Rule ID 18618 //
     /* 2184447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2184458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2184461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2184464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2184467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184493 */     // MIs[0] round
     /* 2184493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184496 */     // MIs[0] policy
     /* 2184496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184506 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2184509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184532 */     // GIR_Coverage, 18618,
     /* 2184532 */     GIR_EraseRootFromParent_Done,
     /* 2184533 */   // Label 28774: @2184533
     /* 2184533 */   GIM_Try, /*On fail goto*//*Label 28775*/ GIMT_Encode4(2184624), // Rule ID 18619 //
     /* 2184538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2184549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2184552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2184555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2184558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184584 */     // MIs[0] round
     /* 2184584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184587 */     // MIs[0] policy
     /* 2184587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184597 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2184600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184623 */     // GIR_Coverage, 18619,
     /* 2184623 */     GIR_EraseRootFromParent_Done,
     /* 2184624 */   // Label 28775: @2184624
     /* 2184624 */   GIM_Try, /*On fail goto*//*Label 28776*/ GIMT_Encode4(2184715), // Rule ID 18622 //
     /* 2184629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2184632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2184640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2184643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2184646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2184649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184675 */     // MIs[0] round
     /* 2184675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184678 */     // MIs[0] policy
     /* 2184678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184688 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2184691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184714 */     // GIR_Coverage, 18622,
     /* 2184714 */     GIR_EraseRootFromParent_Done,
     /* 2184715 */   // Label 28776: @2184715
     /* 2184715 */   GIM_Try, /*On fail goto*//*Label 28777*/ GIMT_Encode4(2184806), // Rule ID 18623 //
     /* 2184720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2184723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2184731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2184734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2184737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2184740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184766 */     // MIs[0] round
     /* 2184766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184769 */     // MIs[0] policy
     /* 2184769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184779 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2184782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184805 */     // GIR_Coverage, 18623,
     /* 2184805 */     GIR_EraseRootFromParent_Done,
     /* 2184806 */   // Label 28777: @2184806
     /* 2184806 */   GIM_Try, /*On fail goto*//*Label 28778*/ GIMT_Encode4(2184897), // Rule ID 18626 //
     /* 2184811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2184814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2184822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2184825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2184828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2184831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184857 */     // MIs[0] round
     /* 2184857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184860 */     // MIs[0] policy
     /* 2184860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184870 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2184873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184896 */     // GIR_Coverage, 18626,
     /* 2184896 */     GIR_EraseRootFromParent_Done,
     /* 2184897 */   // Label 28778: @2184897
     /* 2184897 */   GIM_Try, /*On fail goto*//*Label 28779*/ GIMT_Encode4(2184988), // Rule ID 18627 //
     /* 2184902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2184905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2184913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2184916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2184919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2184922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184948 */     // MIs[0] round
     /* 2184948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184951 */     // MIs[0] policy
     /* 2184951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184961 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2184964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184987 */     // GIR_Coverage, 18627,
     /* 2184987 */     GIR_EraseRootFromParent_Done,
     /* 2184988 */   // Label 28779: @2184988
     /* 2184988 */   GIM_Try, /*On fail goto*//*Label 28780*/ GIMT_Encode4(2185079), // Rule ID 18630 //
     /* 2184993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2185004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2185007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2185010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2185013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185039 */     // MIs[0] round
     /* 2185039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185042 */     // MIs[0] policy
     /* 2185042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185052 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2185055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185078 */     // GIR_Coverage, 18630,
     /* 2185078 */     GIR_EraseRootFromParent_Done,
     /* 2185079 */   // Label 28780: @2185079
     /* 2185079 */   GIM_Try, /*On fail goto*//*Label 28781*/ GIMT_Encode4(2185170), // Rule ID 18631 //
     /* 2185084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2185087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2185095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2185098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2185101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2185104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185130 */     // MIs[0] round
     /* 2185130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185133 */     // MIs[0] policy
     /* 2185133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185143 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2185146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185169 */     // GIR_Coverage, 18631,
     /* 2185169 */     GIR_EraseRootFromParent_Done,
     /* 2185170 */   // Label 28781: @2185170
     /* 2185170 */   GIM_Try, /*On fail goto*//*Label 28782*/ GIMT_Encode4(2185261), // Rule ID 18634 //
     /* 2185175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2185178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2185186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2185189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2185192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2185195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185221 */     // MIs[0] round
     /* 2185221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185224 */     // MIs[0] policy
     /* 2185224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185234 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2185237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185260 */     // GIR_Coverage, 18634,
     /* 2185260 */     GIR_EraseRootFromParent_Done,
     /* 2185261 */   // Label 28782: @2185261
     /* 2185261 */   GIM_Try, /*On fail goto*//*Label 28783*/ GIMT_Encode4(2185352), // Rule ID 18635 //
     /* 2185266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2185269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2185277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2185280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2185283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2185286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185312 */     // MIs[0] round
     /* 2185312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185315 */     // MIs[0] policy
     /* 2185315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185325 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2185328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185351 */     // GIR_Coverage, 18635,
     /* 2185351 */     GIR_EraseRootFromParent_Done,
     /* 2185352 */   // Label 28783: @2185352
     /* 2185352 */   GIM_Try, /*On fail goto*//*Label 28784*/ GIMT_Encode4(2185443), // Rule ID 18638 //
     /* 2185357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2185360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2185368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2185371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2185374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2185377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2185380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185403 */     // MIs[0] round
     /* 2185403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185406 */     // MIs[0] policy
     /* 2185406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185416 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2185419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185442 */     // GIR_Coverage, 18638,
     /* 2185442 */     GIR_EraseRootFromParent_Done,
     /* 2185443 */   // Label 28784: @2185443
     /* 2185443 */   GIM_Try, /*On fail goto*//*Label 28785*/ GIMT_Encode4(2185534), // Rule ID 18639 //
     /* 2185448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2185451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2185459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2185462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2185465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2185468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2185471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185494 */     // MIs[0] round
     /* 2185494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185497 */     // MIs[0] policy
     /* 2185497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185507 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2185510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185533 */     // GIR_Coverage, 18639,
     /* 2185533 */     GIR_EraseRootFromParent_Done,
     /* 2185534 */   // Label 28785: @2185534
     /* 2185534 */   GIM_Try, /*On fail goto*//*Label 28786*/ GIMT_Encode4(2185625), // Rule ID 18642 //
     /* 2185539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2185550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2185553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2185556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2185559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185585 */     // MIs[0] round
     /* 2185585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185588 */     // MIs[0] policy
     /* 2185588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185598 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2185601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185624 */     // GIR_Coverage, 18642,
     /* 2185624 */     GIR_EraseRootFromParent_Done,
     /* 2185625 */   // Label 28786: @2185625
     /* 2185625 */   GIM_Try, /*On fail goto*//*Label 28787*/ GIMT_Encode4(2185716), // Rule ID 18643 //
     /* 2185630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2185641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2185644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2185647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2185650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185676 */     // MIs[0] round
     /* 2185676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185679 */     // MIs[0] policy
     /* 2185679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185689 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2185692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185715 */     // GIR_Coverage, 18643,
     /* 2185715 */     GIR_EraseRootFromParent_Done,
     /* 2185716 */   // Label 28787: @2185716
     /* 2185716 */   GIM_Try, /*On fail goto*//*Label 28788*/ GIMT_Encode4(2185807), // Rule ID 18646 //
     /* 2185721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2185732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2185735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2185738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2185741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185767 */     // MIs[0] round
     /* 2185767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185770 */     // MIs[0] policy
     /* 2185770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185780 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2185783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185806 */     // GIR_Coverage, 18646,
     /* 2185806 */     GIR_EraseRootFromParent_Done,
     /* 2185807 */   // Label 28788: @2185807
     /* 2185807 */   GIM_Try, /*On fail goto*//*Label 28789*/ GIMT_Encode4(2185898), // Rule ID 18647 //
     /* 2185812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2185823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2185826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2185829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2185832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185858 */     // MIs[0] round
     /* 2185858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185861 */     // MIs[0] policy
     /* 2185861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185871 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2185874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185897 */     // GIR_Coverage, 18647,
     /* 2185897 */     GIR_EraseRootFromParent_Done,
     /* 2185898 */   // Label 28789: @2185898
     /* 2185898 */   GIM_Try, /*On fail goto*//*Label 28790*/ GIMT_Encode4(2185989), // Rule ID 18650 //
     /* 2185903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2185914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2185917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2185920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2185923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185949 */     // MIs[0] round
     /* 2185949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185952 */     // MIs[0] policy
     /* 2185952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185962 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2185965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185988 */     // GIR_Coverage, 18650,
     /* 2185988 */     GIR_EraseRootFromParent_Done,
     /* 2185989 */   // Label 28790: @2185989
     /* 2185989 */   GIM_Try, /*On fail goto*//*Label 28791*/ GIMT_Encode4(2186080), // Rule ID 18651 //
     /* 2185994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2186005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2186008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2186011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2186014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2186017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186040 */     // MIs[0] round
     /* 2186040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186043 */     // MIs[0] policy
     /* 2186043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186053 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2186056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186079 */     // GIR_Coverage, 18651,
     /* 2186079 */     GIR_EraseRootFromParent_Done,
     /* 2186080 */   // Label 28791: @2186080
     /* 2186080 */   GIM_Try, /*On fail goto*//*Label 28792*/ GIMT_Encode4(2186171), // Rule ID 18654 //
     /* 2186085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2186088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2186096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2186099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2186102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2186105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186131 */     // MIs[0] round
     /* 2186131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186134 */     // MIs[0] policy
     /* 2186134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186144 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2186147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186170 */     // GIR_Coverage, 18654,
     /* 2186170 */     GIR_EraseRootFromParent_Done,
     /* 2186171 */   // Label 28792: @2186171
     /* 2186171 */   GIM_Try, /*On fail goto*//*Label 28793*/ GIMT_Encode4(2186262), // Rule ID 18655 //
     /* 2186176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2186179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2186187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2186190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2186193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2186196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186222 */     // MIs[0] round
     /* 2186222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186225 */     // MIs[0] policy
     /* 2186225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186235 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2186238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186261 */     // GIR_Coverage, 18655,
     /* 2186261 */     GIR_EraseRootFromParent_Done,
     /* 2186262 */   // Label 28793: @2186262
     /* 2186262 */   GIM_Try, /*On fail goto*//*Label 28794*/ GIMT_Encode4(2186353), // Rule ID 18658 //
     /* 2186267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2186270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2186278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2186281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2186284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2186287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2186297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186313 */     // MIs[0] round
     /* 2186313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186316 */     // MIs[0] policy
     /* 2186316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186326 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2186329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186352 */     // GIR_Coverage, 18658,
     /* 2186352 */     GIR_EraseRootFromParent_Done,
     /* 2186353 */   // Label 28794: @2186353
     /* 2186353 */   GIM_Try, /*On fail goto*//*Label 28795*/ GIMT_Encode4(2186444), // Rule ID 18659 //
     /* 2186358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2186361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2186369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2186372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2186375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2186378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2186388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186404 */     // MIs[0] round
     /* 2186404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186407 */     // MIs[0] policy
     /* 2186407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186417 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2186420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186443 */     // GIR_Coverage, 18659,
     /* 2186443 */     GIR_EraseRootFromParent_Done,
     /* 2186444 */   // Label 28795: @2186444
     /* 2186444 */   GIM_Try, /*On fail goto*//*Label 28796*/ GIMT_Encode4(2186535), // Rule ID 18662 //
     /* 2186449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2186452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2186460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2186463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2186466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2186469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186495 */     // MIs[0] round
     /* 2186495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186498 */     // MIs[0] policy
     /* 2186498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186508 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2186511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186534 */     // GIR_Coverage, 18662,
     /* 2186534 */     GIR_EraseRootFromParent_Done,
     /* 2186535 */   // Label 28796: @2186535
     /* 2186535 */   GIM_Try, /*On fail goto*//*Label 28797*/ GIMT_Encode4(2186626), // Rule ID 18663 //
     /* 2186540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2186543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2186551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2186554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2186557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2186560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186586 */     // MIs[0] round
     /* 2186586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186589 */     // MIs[0] policy
     /* 2186589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186599 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2186602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186625 */     // GIR_Coverage, 18663,
     /* 2186625 */     GIR_EraseRootFromParent_Done,
     /* 2186626 */   // Label 28797: @2186626
     /* 2186626 */   GIM_Try, /*On fail goto*//*Label 28798*/ GIMT_Encode4(2186717), // Rule ID 18666 //
     /* 2186631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2186642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2186645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2186651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186677 */     // MIs[0] round
     /* 2186677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186680 */     // MIs[0] policy
     /* 2186680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186690 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2186693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186716 */     // GIR_Coverage, 18666,
     /* 2186716 */     GIR_EraseRootFromParent_Done,
     /* 2186717 */   // Label 28798: @2186717
     /* 2186717 */   GIM_Try, /*On fail goto*//*Label 28799*/ GIMT_Encode4(2186808), // Rule ID 18667 //
     /* 2186722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2186725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2186733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2186736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2186742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186768 */     // MIs[0] round
     /* 2186768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186771 */     // MIs[0] policy
     /* 2186771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186781 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2186784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186807 */     // GIR_Coverage, 18667,
     /* 2186807 */     GIR_EraseRootFromParent_Done,
     /* 2186808 */   // Label 28799: @2186808
     /* 2186808 */   GIM_Try, /*On fail goto*//*Label 28800*/ GIMT_Encode4(2186899), // Rule ID 18670 //
     /* 2186813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2186824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2186827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2186833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186859 */     // MIs[0] round
     /* 2186859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186862 */     // MIs[0] policy
     /* 2186862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186872 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2186875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186898 */     // GIR_Coverage, 18670,
     /* 2186898 */     GIR_EraseRootFromParent_Done,
     /* 2186899 */   // Label 28800: @2186899
     /* 2186899 */   GIM_Try, /*On fail goto*//*Label 28801*/ GIMT_Encode4(2186990), // Rule ID 18671 //
     /* 2186904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2186907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2186915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2186918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2186924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186950 */     // MIs[0] round
     /* 2186950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186953 */     // MIs[0] policy
     /* 2186953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186963 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2186966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186989 */     // GIR_Coverage, 18671,
     /* 2186989 */     GIR_EraseRootFromParent_Done,
     /* 2186990 */   // Label 28801: @2186990
     /* 2186990 */   GIM_Try, /*On fail goto*//*Label 28802*/ GIMT_Encode4(2187081), // Rule ID 18674 //
     /* 2186995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2186998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2187006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2187009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2187015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187041 */     // MIs[0] round
     /* 2187041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187044 */     // MIs[0] policy
     /* 2187044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187054 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2187057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187080 */     // GIR_Coverage, 18674,
     /* 2187080 */     GIR_EraseRootFromParent_Done,
     /* 2187081 */   // Label 28802: @2187081
     /* 2187081 */   GIM_Try, /*On fail goto*//*Label 28803*/ GIMT_Encode4(2187172), // Rule ID 18675 //
     /* 2187086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2187089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2187097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2187100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2187106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187132 */     // MIs[0] round
     /* 2187132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187135 */     // MIs[0] policy
     /* 2187135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187145 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2187148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187171 */     // GIR_Coverage, 18675,
     /* 2187171 */     GIR_EraseRootFromParent_Done,
     /* 2187172 */   // Label 28803: @2187172
     /* 2187172 */   GIM_Try, /*On fail goto*//*Label 28804*/ GIMT_Encode4(2187263), // Rule ID 18678 //
     /* 2187177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2187188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2187191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2187197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187223 */     // MIs[0] round
     /* 2187223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187226 */     // MIs[0] policy
     /* 2187226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187236 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2187239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187262 */     // GIR_Coverage, 18678,
     /* 2187262 */     GIR_EraseRootFromParent_Done,
     /* 2187263 */   // Label 28804: @2187263
     /* 2187263 */   GIM_Try, /*On fail goto*//*Label 28805*/ GIMT_Encode4(2187354), // Rule ID 18679 //
     /* 2187268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2187279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2187282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2187288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187314 */     // MIs[0] round
     /* 2187314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187317 */     // MIs[0] policy
     /* 2187317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187327 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2187330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187353 */     // GIR_Coverage, 18679,
     /* 2187353 */     GIR_EraseRootFromParent_Done,
     /* 2187354 */   // Label 28805: @2187354
     /* 2187354 */   GIM_Try, /*On fail goto*//*Label 28806*/ GIMT_Encode4(2187445), // Rule ID 18682 //
     /* 2187359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2187362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2187370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2187373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2187379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2187382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187405 */     // MIs[0] round
     /* 2187405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187408 */     // MIs[0] policy
     /* 2187408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187418 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2187421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187444 */     // GIR_Coverage, 18682,
     /* 2187444 */     GIR_EraseRootFromParent_Done,
     /* 2187445 */   // Label 28806: @2187445
     /* 2187445 */   GIM_Try, /*On fail goto*//*Label 28807*/ GIMT_Encode4(2187536), // Rule ID 18683 //
     /* 2187450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2187453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2187461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2187464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2187470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2187473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187496 */     // MIs[0] round
     /* 2187496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187499 */     // MIs[0] policy
     /* 2187499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187509 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2187512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187535 */     // GIR_Coverage, 18683,
     /* 2187535 */     GIR_EraseRootFromParent_Done,
     /* 2187536 */   // Label 28807: @2187536
     /* 2187536 */   GIM_Try, /*On fail goto*//*Label 28808*/ GIMT_Encode4(2187627), // Rule ID 18686 //
     /* 2187541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2187544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2187552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2187555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2187558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2187561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2187579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187587 */     // MIs[0] round
     /* 2187587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187590 */     // MIs[0] policy
     /* 2187590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187600 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2187603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187626 */     // GIR_Coverage, 18686,
     /* 2187626 */     GIR_EraseRootFromParent_Done,
     /* 2187627 */   // Label 28808: @2187627
     /* 2187627 */   GIM_Try, /*On fail goto*//*Label 28809*/ GIMT_Encode4(2187718), // Rule ID 18687 //
     /* 2187632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2187635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2187643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2187646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2187649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2187652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2187670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187678 */     // MIs[0] round
     /* 2187678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187681 */     // MIs[0] policy
     /* 2187681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187691 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2187694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187717 */     // GIR_Coverage, 18687,
     /* 2187717 */     GIR_EraseRootFromParent_Done,
     /* 2187718 */   // Label 28809: @2187718
     /* 2187718 */   GIM_Try, /*On fail goto*//*Label 28810*/ GIMT_Encode4(2187809), // Rule ID 18690 //
     /* 2187723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2187734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2187737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2187743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187769 */     // MIs[0] round
     /* 2187769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187772 */     // MIs[0] policy
     /* 2187772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187782 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2187785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187808 */     // GIR_Coverage, 18690,
     /* 2187808 */     GIR_EraseRootFromParent_Done,
     /* 2187809 */   // Label 28810: @2187809
     /* 2187809 */   GIM_Try, /*On fail goto*//*Label 28811*/ GIMT_Encode4(2187900), // Rule ID 18691 //
     /* 2187814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2187825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2187828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2187834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187860 */     // MIs[0] round
     /* 2187860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187863 */     // MIs[0] policy
     /* 2187863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187873 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2187876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187899 */     // GIR_Coverage, 18691,
     /* 2187899 */     GIR_EraseRootFromParent_Done,
     /* 2187900 */   // Label 28811: @2187900
     /* 2187900 */   GIM_Try, /*On fail goto*//*Label 28812*/ GIMT_Encode4(2187991), // Rule ID 18694 //
     /* 2187905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2187916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2187919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2187925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2187928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2187935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187951 */     // MIs[0] round
     /* 2187951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187954 */     // MIs[0] policy
     /* 2187954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187964 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2187967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187990 */     // GIR_Coverage, 18694,
     /* 2187990 */     GIR_EraseRootFromParent_Done,
     /* 2187991 */   // Label 28812: @2187991
     /* 2187991 */   GIM_Try, /*On fail goto*//*Label 28813*/ GIMT_Encode4(2188082), // Rule ID 18695 //
     /* 2187996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2188007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2188010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2188013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2188016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188042 */     // MIs[0] round
     /* 2188042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188045 */     // MIs[0] policy
     /* 2188045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188055 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2188058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188081 */     // GIR_Coverage, 18695,
     /* 2188081 */     GIR_EraseRootFromParent_Done,
     /* 2188082 */   // Label 28813: @2188082
     /* 2188082 */   GIM_Try, /*On fail goto*//*Label 28814*/ GIMT_Encode4(2188173), // Rule ID 18698 //
     /* 2188087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2188090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2188098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2188101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2188104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2188107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2188110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188133 */     // MIs[0] round
     /* 2188133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188136 */     // MIs[0] policy
     /* 2188136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188146 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2188149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188172 */     // GIR_Coverage, 18698,
     /* 2188172 */     GIR_EraseRootFromParent_Done,
     /* 2188173 */   // Label 28814: @2188173
     /* 2188173 */   GIM_Try, /*On fail goto*//*Label 28815*/ GIMT_Encode4(2188264), // Rule ID 18699 //
     /* 2188178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2188181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2188189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2188192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2188195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2188198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2188201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188224 */     // MIs[0] round
     /* 2188224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188227 */     // MIs[0] policy
     /* 2188227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188237 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2188240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188263 */     // GIR_Coverage, 18699,
     /* 2188263 */     GIR_EraseRootFromParent_Done,
     /* 2188264 */   // Label 28815: @2188264
     /* 2188264 */   GIM_Try, /*On fail goto*//*Label 28816*/ GIMT_Encode4(2188355), // Rule ID 18702 //
     /* 2188269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2188272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2188280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2188283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2188289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188315 */     // MIs[0] round
     /* 2188315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188318 */     // MIs[0] policy
     /* 2188318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188328 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2188331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188354 */     // GIR_Coverage, 18702,
     /* 2188354 */     GIR_EraseRootFromParent_Done,
     /* 2188355 */   // Label 28816: @2188355
     /* 2188355 */   GIM_Try, /*On fail goto*//*Label 28817*/ GIMT_Encode4(2188446), // Rule ID 18703 //
     /* 2188360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2188363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2188371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2188374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2188380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188406 */     // MIs[0] round
     /* 2188406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188409 */     // MIs[0] policy
     /* 2188409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188419 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2188422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188445 */     // GIR_Coverage, 18703,
     /* 2188445 */     GIR_EraseRootFromParent_Done,
     /* 2188446 */   // Label 28817: @2188446
     /* 2188446 */   GIM_Try, /*On fail goto*//*Label 28818*/ GIMT_Encode4(2188537), // Rule ID 18706 //
     /* 2188451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2188454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2188462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2188465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2188471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188497 */     // MIs[0] round
     /* 2188497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188500 */     // MIs[0] policy
     /* 2188500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188510 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2188513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188536 */     // GIR_Coverage, 18706,
     /* 2188536 */     GIR_EraseRootFromParent_Done,
     /* 2188537 */   // Label 28818: @2188537
     /* 2188537 */   GIM_Try, /*On fail goto*//*Label 28819*/ GIMT_Encode4(2188628), // Rule ID 18707 //
     /* 2188542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2188545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2188553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2188556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2188562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188588 */     // MIs[0] round
     /* 2188588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188591 */     // MIs[0] policy
     /* 2188591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188601 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2188604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188627 */     // GIR_Coverage, 18707,
     /* 2188627 */     GIR_EraseRootFromParent_Done,
     /* 2188628 */   // Label 28819: @2188628
     /* 2188628 */   GIM_Try, /*On fail goto*//*Label 28820*/ GIMT_Encode4(2188719), // Rule ID 18710 //
     /* 2188633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2188636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2188644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2188647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2188653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188679 */     // MIs[0] round
     /* 2188679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188682 */     // MIs[0] policy
     /* 2188682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188692 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2188695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188718 */     // GIR_Coverage, 18710,
     /* 2188718 */     GIR_EraseRootFromParent_Done,
     /* 2188719 */   // Label 28820: @2188719
     /* 2188719 */   GIM_Try, /*On fail goto*//*Label 28821*/ GIMT_Encode4(2188810), // Rule ID 18711 //
     /* 2188724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2188727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2188735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2188738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2188744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188770 */     // MIs[0] round
     /* 2188770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188773 */     // MIs[0] policy
     /* 2188773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188783 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2188786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188809 */     // GIR_Coverage, 18711,
     /* 2188809 */     GIR_EraseRootFromParent_Done,
     /* 2188810 */   // Label 28821: @2188810
     /* 2188810 */   GIM_Try, /*On fail goto*//*Label 28822*/ GIMT_Encode4(2188901), // Rule ID 18714 //
     /* 2188815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2188818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2188826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2188829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2188835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188861 */     // MIs[0] round
     /* 2188861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188864 */     // MIs[0] policy
     /* 2188864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188874 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2188877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188900 */     // GIR_Coverage, 18714,
     /* 2188900 */     GIR_EraseRootFromParent_Done,
     /* 2188901 */   // Label 28822: @2188901
     /* 2188901 */   GIM_Try, /*On fail goto*//*Label 28823*/ GIMT_Encode4(2188992), // Rule ID 18715 //
     /* 2188906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2188909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2188917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2188920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2188926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188952 */     // MIs[0] round
     /* 2188952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188955 */     // MIs[0] policy
     /* 2188955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188965 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2188968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188991 */     // GIR_Coverage, 18715,
     /* 2188991 */     GIR_EraseRootFromParent_Done,
     /* 2188992 */   // Label 28823: @2188992
     /* 2188992 */   GIM_Try, /*On fail goto*//*Label 28824*/ GIMT_Encode4(2189083), // Rule ID 18718 //
     /* 2188997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2189000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2189008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2189011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2189014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2189017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2189035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189043 */     // MIs[0] round
     /* 2189043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189046 */     // MIs[0] policy
     /* 2189046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189056 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2189059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189082 */     // GIR_Coverage, 18718,
     /* 2189082 */     GIR_EraseRootFromParent_Done,
     /* 2189083 */   // Label 28824: @2189083
     /* 2189083 */   GIM_Try, /*On fail goto*//*Label 28825*/ GIMT_Encode4(2189174), // Rule ID 18719 //
     /* 2189088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2189091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2189099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2189102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2189105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2189108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2189126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189134 */     // MIs[0] round
     /* 2189134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189137 */     // MIs[0] policy
     /* 2189137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189147 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2189150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189173 */     // GIR_Coverage, 18719,
     /* 2189173 */     GIR_EraseRootFromParent_Done,
     /* 2189174 */   // Label 28825: @2189174
     /* 2189174 */   GIM_Try, /*On fail goto*//*Label 28826*/ GIMT_Encode4(2189265), // Rule ID 18722 //
     /* 2189179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2189182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2189190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2189193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2189196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2189199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2189217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189225 */     // MIs[0] round
     /* 2189225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189228 */     // MIs[0] policy
     /* 2189228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189238 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2189241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189264 */     // GIR_Coverage, 18722,
     /* 2189264 */     GIR_EraseRootFromParent_Done,
     /* 2189265 */   // Label 28826: @2189265
     /* 2189265 */   GIM_Try, /*On fail goto*//*Label 28827*/ GIMT_Encode4(2189356), // Rule ID 18723 //
     /* 2189270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2189273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2189281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2189284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2189287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2189290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2189308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189316 */     // MIs[0] round
     /* 2189316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189319 */     // MIs[0] policy
     /* 2189319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189329 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2189332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189355 */     // GIR_Coverage, 18723,
     /* 2189355 */     GIR_EraseRootFromParent_Done,
     /* 2189356 */   // Label 28827: @2189356
     /* 2189356 */   GIM_Try, /*On fail goto*//*Label 28828*/ GIMT_Encode4(2189447), // Rule ID 18726 //
     /* 2189361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2189372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2189375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2189378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2189381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189407 */     // MIs[0] round
     /* 2189407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189410 */     // MIs[0] policy
     /* 2189410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189420 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2189423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189446 */     // GIR_Coverage, 18726,
     /* 2189446 */     GIR_EraseRootFromParent_Done,
     /* 2189447 */   // Label 28828: @2189447
     /* 2189447 */   GIM_Try, /*On fail goto*//*Label 28829*/ GIMT_Encode4(2189538), // Rule ID 18727 //
     /* 2189452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2189463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2189466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2189469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2189472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189498 */     // MIs[0] round
     /* 2189498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189501 */     // MIs[0] policy
     /* 2189501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189511 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2189514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189537 */     // GIR_Coverage, 18727,
     /* 2189537 */     GIR_EraseRootFromParent_Done,
     /* 2189538 */   // Label 28829: @2189538
     /* 2189538 */   GIM_Try, /*On fail goto*//*Label 28830*/ GIMT_Encode4(2189629), // Rule ID 18730 //
     /* 2189543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2189554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2189557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2189560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2189563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189589 */     // MIs[0] round
     /* 2189589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189592 */     // MIs[0] policy
     /* 2189592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189602 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2189605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189628 */     // GIR_Coverage, 18730,
     /* 2189628 */     GIR_EraseRootFromParent_Done,
     /* 2189629 */   // Label 28830: @2189629
     /* 2189629 */   GIM_Try, /*On fail goto*//*Label 28831*/ GIMT_Encode4(2189720), // Rule ID 18731 //
     /* 2189634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2189645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2189648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2189651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2189654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189680 */     // MIs[0] round
     /* 2189680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189683 */     // MIs[0] policy
     /* 2189683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189693 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2189696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189719 */     // GIR_Coverage, 18731,
     /* 2189719 */     GIR_EraseRootFromParent_Done,
     /* 2189720 */   // Label 28831: @2189720
     /* 2189720 */   GIM_Try, /*On fail goto*//*Label 28832*/ GIMT_Encode4(2189811), // Rule ID 18734 //
     /* 2189725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2189736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2189739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2189742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2189745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189771 */     // MIs[0] round
     /* 2189771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189774 */     // MIs[0] policy
     /* 2189774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189784 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2189787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189810 */     // GIR_Coverage, 18734,
     /* 2189810 */     GIR_EraseRootFromParent_Done,
     /* 2189811 */   // Label 28832: @2189811
     /* 2189811 */   GIM_Try, /*On fail goto*//*Label 28833*/ GIMT_Encode4(2189902), // Rule ID 18735 //
     /* 2189816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2189827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2189830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2189833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2189836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189862 */     // MIs[0] round
     /* 2189862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189865 */     // MIs[0] policy
     /* 2189865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189875 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2189878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189901 */     // GIR_Coverage, 18735,
     /* 2189901 */     GIR_EraseRootFromParent_Done,
     /* 2189902 */   // Label 28833: @2189902
     /* 2189902 */   GIM_Try, /*On fail goto*//*Label 28834*/ GIMT_Encode4(2189993), // Rule ID 18738 //
     /* 2189907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2189918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2189921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2189924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2189927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189953 */     // MIs[0] round
     /* 2189953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189956 */     // MIs[0] policy
     /* 2189956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189966 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2189969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189992 */     // GIR_Coverage, 18738,
     /* 2189992 */     GIR_EraseRootFromParent_Done,
     /* 2189993 */   // Label 28834: @2189993
     /* 2189993 */   GIM_Try, /*On fail goto*//*Label 28835*/ GIMT_Encode4(2190084), // Rule ID 18739 //
     /* 2189998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2190009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2190012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2190015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2190018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190044 */     // MIs[0] round
     /* 2190044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190047 */     // MIs[0] policy
     /* 2190047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190057 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2190060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190083 */     // GIR_Coverage, 18739,
     /* 2190083 */     GIR_EraseRootFromParent_Done,
     /* 2190084 */   // Label 28835: @2190084
     /* 2190084 */   GIM_Try, /*On fail goto*//*Label 28836*/ GIMT_Encode4(2190175), // Rule ID 18742 //
     /* 2190089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2190100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2190103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2190106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2190109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2190112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190135 */     // MIs[0] round
     /* 2190135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190138 */     // MIs[0] policy
     /* 2190138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190148 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2190151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190174 */     // GIR_Coverage, 18742,
     /* 2190174 */     GIR_EraseRootFromParent_Done,
     /* 2190175 */   // Label 28836: @2190175
     /* 2190175 */   GIM_Try, /*On fail goto*//*Label 28837*/ GIMT_Encode4(2190266), // Rule ID 18743 //
     /* 2190180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2190191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2190194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2190197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2190200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2190203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190226 */     // MIs[0] round
     /* 2190226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190229 */     // MIs[0] policy
     /* 2190229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190239 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2190242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190265 */     // GIR_Coverage, 18743,
     /* 2190265 */     GIR_EraseRootFromParent_Done,
     /* 2190266 */   // Label 28837: @2190266
     /* 2190266 */   GIM_Try, /*On fail goto*//*Label 28838*/ GIMT_Encode4(2190357), // Rule ID 18746 //
     /* 2190271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2190282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2190285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2190288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2190291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190317 */     // MIs[0] round
     /* 2190317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190320 */     // MIs[0] policy
     /* 2190320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190330 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2190333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190356 */     // GIR_Coverage, 18746,
     /* 2190356 */     GIR_EraseRootFromParent_Done,
     /* 2190357 */   // Label 28838: @2190357
     /* 2190357 */   GIM_Try, /*On fail goto*//*Label 28839*/ GIMT_Encode4(2190448), // Rule ID 18747 //
     /* 2190362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2190373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2190376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2190379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2190382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190408 */     // MIs[0] round
     /* 2190408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190411 */     // MIs[0] policy
     /* 2190411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190421 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2190424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190447 */     // GIR_Coverage, 18747,
     /* 2190447 */     GIR_EraseRootFromParent_Done,
     /* 2190448 */   // Label 28839: @2190448
     /* 2190448 */   GIM_Try, /*On fail goto*//*Label 28840*/ GIMT_Encode4(2190539), // Rule ID 18750 //
     /* 2190453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2190464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2190467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2190470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2190473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190499 */     // MIs[0] round
     /* 2190499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190502 */     // MIs[0] policy
     /* 2190502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190512 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2190515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190538 */     // GIR_Coverage, 18750,
     /* 2190538 */     GIR_EraseRootFromParent_Done,
     /* 2190539 */   // Label 28840: @2190539
     /* 2190539 */   GIM_Try, /*On fail goto*//*Label 28841*/ GIMT_Encode4(2190630), // Rule ID 18751 //
     /* 2190544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2190555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2190558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2190561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2190564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190590 */     // MIs[0] round
     /* 2190590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190593 */     // MIs[0] policy
     /* 2190593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190603 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2190606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190629 */     // GIR_Coverage, 18751,
     /* 2190629 */     GIR_EraseRootFromParent_Done,
     /* 2190630 */   // Label 28841: @2190630
     /* 2190630 */   GIM_Try, /*On fail goto*//*Label 28842*/ GIMT_Encode4(2190721), // Rule ID 18754 //
     /* 2190635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2190646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2190649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2190652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2190655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190681 */     // MIs[0] round
     /* 2190681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190684 */     // MIs[0] policy
     /* 2190684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190694 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2190697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190720 */     // GIR_Coverage, 18754,
     /* 2190720 */     GIR_EraseRootFromParent_Done,
     /* 2190721 */   // Label 28842: @2190721
     /* 2190721 */   GIM_Try, /*On fail goto*//*Label 28843*/ GIMT_Encode4(2190812), // Rule ID 18755 //
     /* 2190726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2190737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2190740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2190743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2190746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190772 */     // MIs[0] round
     /* 2190772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190775 */     // MIs[0] policy
     /* 2190775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190785 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2190788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190811 */     // GIR_Coverage, 18755,
     /* 2190811 */     GIR_EraseRootFromParent_Done,
     /* 2190812 */   // Label 28843: @2190812
     /* 2190812 */   GIM_Try, /*On fail goto*//*Label 28844*/ GIMT_Encode4(2190903), // Rule ID 18758 //
     /* 2190817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2190828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2190831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2190834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2190837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190863 */     // MIs[0] round
     /* 2190863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190866 */     // MIs[0] policy
     /* 2190866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190876 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2190879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190902 */     // GIR_Coverage, 18758,
     /* 2190902 */     GIR_EraseRootFromParent_Done,
     /* 2190903 */   // Label 28844: @2190903
     /* 2190903 */   GIM_Try, /*On fail goto*//*Label 28845*/ GIMT_Encode4(2190994), // Rule ID 18759 //
     /* 2190908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2190919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2190922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2190925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2190928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190954 */     // MIs[0] round
     /* 2190954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190957 */     // MIs[0] policy
     /* 2190957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190967 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2190970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190993 */     // GIR_Coverage, 18759,
     /* 2190993 */     GIR_EraseRootFromParent_Done,
     /* 2190994 */   // Label 28845: @2190994
     /* 2190994 */   GIM_Try, /*On fail goto*//*Label 28846*/ GIMT_Encode4(2191085), // Rule ID 18762 //
     /* 2190999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2191010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2191013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2191019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191045 */     // MIs[0] round
     /* 2191045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191048 */     // MIs[0] policy
     /* 2191048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191058 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2191061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191084 */     // GIR_Coverage, 18762,
     /* 2191084 */     GIR_EraseRootFromParent_Done,
     /* 2191085 */   // Label 28846: @2191085
     /* 2191085 */   GIM_Try, /*On fail goto*//*Label 28847*/ GIMT_Encode4(2191176), // Rule ID 18763 //
     /* 2191090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2191101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2191104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2191110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191136 */     // MIs[0] round
     /* 2191136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191139 */     // MIs[0] policy
     /* 2191139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191149 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2191152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191175 */     // GIR_Coverage, 18763,
     /* 2191175 */     GIR_EraseRootFromParent_Done,
     /* 2191176 */   // Label 28847: @2191176
     /* 2191176 */   GIM_Try, /*On fail goto*//*Label 28848*/ GIMT_Encode4(2191267), // Rule ID 18766 //
     /* 2191181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2191192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2191195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2191201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191227 */     // MIs[0] round
     /* 2191227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191230 */     // MIs[0] policy
     /* 2191230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191240 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2191243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191266 */     // GIR_Coverage, 18766,
     /* 2191266 */     GIR_EraseRootFromParent_Done,
     /* 2191267 */   // Label 28848: @2191267
     /* 2191267 */   GIM_Try, /*On fail goto*//*Label 28849*/ GIMT_Encode4(2191358), // Rule ID 18767 //
     /* 2191272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2191283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2191286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2191292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191318 */     // MIs[0] round
     /* 2191318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191321 */     // MIs[0] policy
     /* 2191321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191331 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2191334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191357 */     // GIR_Coverage, 18767,
     /* 2191357 */     GIR_EraseRootFromParent_Done,
     /* 2191358 */   // Label 28849: @2191358
     /* 2191358 */   GIM_Try, /*On fail goto*//*Label 28850*/ GIMT_Encode4(2191449), // Rule ID 18770 //
     /* 2191363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2191374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2191377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2191383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191409 */     // MIs[0] round
     /* 2191409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191412 */     // MIs[0] policy
     /* 2191412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191422 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2191425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191448 */     // GIR_Coverage, 18770,
     /* 2191448 */     GIR_EraseRootFromParent_Done,
     /* 2191449 */   // Label 28850: @2191449
     /* 2191449 */   GIM_Try, /*On fail goto*//*Label 28851*/ GIMT_Encode4(2191540), // Rule ID 18771 //
     /* 2191454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2191465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2191468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2191474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191500 */     // MIs[0] round
     /* 2191500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191503 */     // MIs[0] policy
     /* 2191503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191513 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2191516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191539 */     // GIR_Coverage, 18771,
     /* 2191539 */     GIR_EraseRootFromParent_Done,
     /* 2191540 */   // Label 28851: @2191540
     /* 2191540 */   GIM_Try, /*On fail goto*//*Label 28852*/ GIMT_Encode4(2191631), // Rule ID 18774 //
     /* 2191545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2191556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2191559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2191565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191591 */     // MIs[0] round
     /* 2191591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191594 */     // MIs[0] policy
     /* 2191594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191604 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2191607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191630 */     // GIR_Coverage, 18774,
     /* 2191630 */     GIR_EraseRootFromParent_Done,
     /* 2191631 */   // Label 28852: @2191631
     /* 2191631 */   GIM_Try, /*On fail goto*//*Label 28853*/ GIMT_Encode4(2191722), // Rule ID 18775 //
     /* 2191636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2191647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2191650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2191656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191682 */     // MIs[0] round
     /* 2191682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191685 */     // MIs[0] policy
     /* 2191685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191695 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2191698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191721 */     // GIR_Coverage, 18775,
     /* 2191721 */     GIR_EraseRootFromParent_Done,
     /* 2191722 */   // Label 28853: @2191722
     /* 2191722 */   GIM_Try, /*On fail goto*//*Label 28854*/ GIMT_Encode4(2191813), // Rule ID 18778 //
     /* 2191727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2191738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2191741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2191747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191773 */     // MIs[0] round
     /* 2191773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191776 */     // MIs[0] policy
     /* 2191776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191786 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2191789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191812 */     // GIR_Coverage, 18778,
     /* 2191812 */     GIR_EraseRootFromParent_Done,
     /* 2191813 */   // Label 28854: @2191813
     /* 2191813 */   GIM_Try, /*On fail goto*//*Label 28855*/ GIMT_Encode4(2191904), // Rule ID 18779 //
     /* 2191818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2191829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2191832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2191838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191864 */     // MIs[0] round
     /* 2191864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191867 */     // MIs[0] policy
     /* 2191867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191877 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2191880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191903 */     // GIR_Coverage, 18779,
     /* 2191903 */     GIR_EraseRootFromParent_Done,
     /* 2191904 */   // Label 28855: @2191904
     /* 2191904 */   GIM_Try, /*On fail goto*//*Label 28856*/ GIMT_Encode4(2191995), // Rule ID 18782 //
     /* 2191909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2191920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2191923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2191929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191955 */     // MIs[0] round
     /* 2191955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191958 */     // MIs[0] policy
     /* 2191958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191968 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2191971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191994 */     // GIR_Coverage, 18782,
     /* 2191994 */     GIR_EraseRootFromParent_Done,
     /* 2191995 */   // Label 28856: @2191995
     /* 2191995 */   GIM_Try, /*On fail goto*//*Label 28857*/ GIMT_Encode4(2192086), // Rule ID 18783 //
     /* 2192000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2192003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2192011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2192014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2192020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192046 */     // MIs[0] round
     /* 2192046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192049 */     // MIs[0] policy
     /* 2192049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192059 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2192062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192085 */     // GIR_Coverage, 18783,
     /* 2192085 */     GIR_EraseRootFromParent_Done,
     /* 2192086 */   // Label 28857: @2192086
     /* 2192086 */   GIM_Try, /*On fail goto*//*Label 28858*/ GIMT_Encode4(2192177), // Rule ID 18786 //
     /* 2192091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2192094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2192102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2192105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2192111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192137 */     // MIs[0] round
     /* 2192137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192140 */     // MIs[0] policy
     /* 2192140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192150 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2192153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192176 */     // GIR_Coverage, 18786,
     /* 2192176 */     GIR_EraseRootFromParent_Done,
     /* 2192177 */   // Label 28858: @2192177
     /* 2192177 */   GIM_Try, /*On fail goto*//*Label 28859*/ GIMT_Encode4(2192268), // Rule ID 18787 //
     /* 2192182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2192185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2192193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2192196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2192202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192228 */     // MIs[0] round
     /* 2192228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192231 */     // MIs[0] policy
     /* 2192231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192241 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2192244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192267 */     // GIR_Coverage, 18787,
     /* 2192267 */     GIR_EraseRootFromParent_Done,
     /* 2192268 */   // Label 28859: @2192268
     /* 2192268 */   GIM_Try, /*On fail goto*//*Label 28860*/ GIMT_Encode4(2192359), // Rule ID 18790 //
     /* 2192273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2192276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2192284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2192287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2192293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2192303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192319 */     // MIs[0] round
     /* 2192319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192322 */     // MIs[0] policy
     /* 2192322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192332 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2192335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192358 */     // GIR_Coverage, 18790,
     /* 2192358 */     GIR_EraseRootFromParent_Done,
     /* 2192359 */   // Label 28860: @2192359
     /* 2192359 */   GIM_Try, /*On fail goto*//*Label 28861*/ GIMT_Encode4(2192450), // Rule ID 18791 //
     /* 2192364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2192367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2192375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2192378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2192384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2192394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192410 */     // MIs[0] round
     /* 2192410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192413 */     // MIs[0] policy
     /* 2192413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192423 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2192426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192449 */     // GIR_Coverage, 18791,
     /* 2192449 */     GIR_EraseRootFromParent_Done,
     /* 2192450 */   // Label 28861: @2192450
     /* 2192450 */   GIM_Try, /*On fail goto*//*Label 28862*/ GIMT_Encode4(2192541), // Rule ID 18794 //
     /* 2192455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2192458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2192466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2192469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2192475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192501 */     // MIs[0] round
     /* 2192501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192504 */     // MIs[0] policy
     /* 2192504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192514 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2192517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192540 */     // GIR_Coverage, 18794,
     /* 2192540 */     GIR_EraseRootFromParent_Done,
     /* 2192541 */   // Label 28862: @2192541
     /* 2192541 */   GIM_Try, /*On fail goto*//*Label 28863*/ GIMT_Encode4(2192632), // Rule ID 18795 //
     /* 2192546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2192549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2192557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2192560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2192566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192592 */     // MIs[0] round
     /* 2192592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192595 */     // MIs[0] policy
     /* 2192595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192605 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2192608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192631 */     // GIR_Coverage, 18795,
     /* 2192631 */     GIR_EraseRootFromParent_Done,
     /* 2192632 */   // Label 28863: @2192632
     /* 2192632 */   GIM_Try, /*On fail goto*//*Label 28864*/ GIMT_Encode4(2192723), // Rule ID 18798 //
     /* 2192637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2192648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2192651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2192654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2192657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192683 */     // MIs[0] round
     /* 2192683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192686 */     // MIs[0] policy
     /* 2192686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192696 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2192699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192722 */     // GIR_Coverage, 18798,
     /* 2192722 */     GIR_EraseRootFromParent_Done,
     /* 2192723 */   // Label 28864: @2192723
     /* 2192723 */   GIM_Try, /*On fail goto*//*Label 28865*/ GIMT_Encode4(2192814), // Rule ID 18799 //
     /* 2192728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2192739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2192742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2192745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2192748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192774 */     // MIs[0] round
     /* 2192774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192777 */     // MIs[0] policy
     /* 2192777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192787 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2192790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192813 */     // GIR_Coverage, 18799,
     /* 2192813 */     GIR_EraseRootFromParent_Done,
     /* 2192814 */   // Label 28865: @2192814
     /* 2192814 */   GIM_Try, /*On fail goto*//*Label 28866*/ GIMT_Encode4(2192905), // Rule ID 18802 //
     /* 2192819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2192830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2192833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2192836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2192839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192865 */     // MIs[0] round
     /* 2192865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192868 */     // MIs[0] policy
     /* 2192868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192878 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2192881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192904 */     // GIR_Coverage, 18802,
     /* 2192904 */     GIR_EraseRootFromParent_Done,
     /* 2192905 */   // Label 28866: @2192905
     /* 2192905 */   GIM_Try, /*On fail goto*//*Label 28867*/ GIMT_Encode4(2192996), // Rule ID 18803 //
     /* 2192910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2192921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2192924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2192927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2192930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192956 */     // MIs[0] round
     /* 2192956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192959 */     // MIs[0] policy
     /* 2192959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192969 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2192972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192995 */     // GIR_Coverage, 18803,
     /* 2192995 */     GIR_EraseRootFromParent_Done,
     /* 2192996 */   // Label 28867: @2192996
     /* 2192996 */   GIM_Try, /*On fail goto*//*Label 28868*/ GIMT_Encode4(2193087), // Rule ID 18806 //
     /* 2193001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2193012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2193015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2193018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2193021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193047 */     // MIs[0] round
     /* 2193047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193050 */     // MIs[0] policy
     /* 2193050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193060 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2193063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193086 */     // GIR_Coverage, 18806,
     /* 2193086 */     GIR_EraseRootFromParent_Done,
     /* 2193087 */   // Label 28868: @2193087
     /* 2193087 */   GIM_Try, /*On fail goto*//*Label 28869*/ GIMT_Encode4(2193178), // Rule ID 18807 //
     /* 2193092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2193103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2193106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2193109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2193112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193138 */     // MIs[0] round
     /* 2193138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193141 */     // MIs[0] policy
     /* 2193141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193151 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2193154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193177 */     // GIR_Coverage, 18807,
     /* 2193177 */     GIR_EraseRootFromParent_Done,
     /* 2193178 */   // Label 28869: @2193178
     /* 2193178 */   GIM_Try, /*On fail goto*//*Label 28870*/ GIMT_Encode4(2193269), // Rule ID 18810 //
     /* 2193183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2193194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2193197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2193200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2193203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2193206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193229 */     // MIs[0] round
     /* 2193229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193232 */     // MIs[0] policy
     /* 2193232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193242 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2193245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193268 */     // GIR_Coverage, 18810,
     /* 2193268 */     GIR_EraseRootFromParent_Done,
     /* 2193269 */   // Label 28870: @2193269
     /* 2193269 */   GIM_Try, /*On fail goto*//*Label 28871*/ GIMT_Encode4(2193360), // Rule ID 18811 //
     /* 2193274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2193285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2193288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2193291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2193294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2193297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193320 */     // MIs[0] round
     /* 2193320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193323 */     // MIs[0] policy
     /* 2193323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193333 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2193336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193359 */     // GIR_Coverage, 18811,
     /* 2193359 */     GIR_EraseRootFromParent_Done,
     /* 2193360 */   // Label 28871: @2193360
     /* 2193360 */   GIM_Try, /*On fail goto*//*Label 28872*/ GIMT_Encode4(2193451), // Rule ID 18814 //
     /* 2193365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2193376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2193379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2193382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2193385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2193388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193411 */     // MIs[0] round
     /* 2193411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193414 */     // MIs[0] policy
     /* 2193414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193424 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2193427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193450 */     // GIR_Coverage, 18814,
     /* 2193450 */     GIR_EraseRootFromParent_Done,
     /* 2193451 */   // Label 28872: @2193451
     /* 2193451 */   GIM_Try, /*On fail goto*//*Label 28873*/ GIMT_Encode4(2193542), // Rule ID 18815 //
     /* 2193456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2193467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2193470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2193473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2193476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2193479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193502 */     // MIs[0] round
     /* 2193502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193505 */     // MIs[0] policy
     /* 2193505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193515 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2193518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193541 */     // GIR_Coverage, 18815,
     /* 2193541 */     GIR_EraseRootFromParent_Done,
     /* 2193542 */   // Label 28873: @2193542
     /* 2193542 */   GIM_Try, /*On fail goto*//*Label 28874*/ GIMT_Encode4(2193633), // Rule ID 18818 //
     /* 2193547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2193558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2193561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2193564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2193567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193593 */     // MIs[0] round
     /* 2193593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193596 */     // MIs[0] policy
     /* 2193596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193606 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2193609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193632 */     // GIR_Coverage, 18818,
     /* 2193632 */     GIR_EraseRootFromParent_Done,
     /* 2193633 */   // Label 28874: @2193633
     /* 2193633 */   GIM_Try, /*On fail goto*//*Label 28875*/ GIMT_Encode4(2193724), // Rule ID 18819 //
     /* 2193638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2193649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2193652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2193655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2193658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193684 */     // MIs[0] round
     /* 2193684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193687 */     // MIs[0] policy
     /* 2193687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193697 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2193700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193723 */     // GIR_Coverage, 18819,
     /* 2193723 */     GIR_EraseRootFromParent_Done,
     /* 2193724 */   // Label 28875: @2193724
     /* 2193724 */   GIM_Try, /*On fail goto*//*Label 28876*/ GIMT_Encode4(2193815), // Rule ID 18822 //
     /* 2193729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2193740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2193743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2193746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2193749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193775 */     // MIs[0] round
     /* 2193775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193778 */     // MIs[0] policy
     /* 2193778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193788 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2193791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193814 */     // GIR_Coverage, 18822,
     /* 2193814 */     GIR_EraseRootFromParent_Done,
     /* 2193815 */   // Label 28876: @2193815
     /* 2193815 */   GIM_Try, /*On fail goto*//*Label 28877*/ GIMT_Encode4(2193906), // Rule ID 18823 //
     /* 2193820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2193831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2193834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2193837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2193840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193866 */     // MIs[0] round
     /* 2193866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193869 */     // MIs[0] policy
     /* 2193869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193879 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2193882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193905 */     // GIR_Coverage, 18823,
     /* 2193905 */     GIR_EraseRootFromParent_Done,
     /* 2193906 */   // Label 28877: @2193906
     /* 2193906 */   GIM_Try, /*On fail goto*//*Label 28878*/ GIMT_Encode4(2193997), // Rule ID 18826 //
     /* 2193911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2193922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2193925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2193928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2193931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193957 */     // MIs[0] round
     /* 2193957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193960 */     // MIs[0] policy
     /* 2193960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193970 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2193973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193996 */     // GIR_Coverage, 18826,
     /* 2193996 */     GIR_EraseRootFromParent_Done,
     /* 2193997 */   // Label 28878: @2193997
     /* 2193997 */   GIM_Try, /*On fail goto*//*Label 28879*/ GIMT_Encode4(2194088), // Rule ID 18827 //
     /* 2194002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2194005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2194013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2194016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2194019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2194022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194048 */     // MIs[0] round
     /* 2194048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194051 */     // MIs[0] policy
     /* 2194051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194061 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2194064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194087 */     // GIR_Coverage, 18827,
     /* 2194087 */     GIR_EraseRootFromParent_Done,
     /* 2194088 */   // Label 28879: @2194088
     /* 2194088 */   GIM_Try, /*On fail goto*//*Label 28880*/ GIMT_Encode4(2194179), // Rule ID 18830 //
     /* 2194093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2194096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2194104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2194107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2194110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2194113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194139 */     // MIs[0] round
     /* 2194139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194142 */     // MIs[0] policy
     /* 2194142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194152 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2194155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194178 */     // GIR_Coverage, 18830,
     /* 2194178 */     GIR_EraseRootFromParent_Done,
     /* 2194179 */   // Label 28880: @2194179
     /* 2194179 */   GIM_Try, /*On fail goto*//*Label 28881*/ GIMT_Encode4(2194270), // Rule ID 18831 //
     /* 2194184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2194187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2194195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2194198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2194201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2194204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194230 */     // MIs[0] round
     /* 2194230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194233 */     // MIs[0] policy
     /* 2194233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194243 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2194246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194269 */     // GIR_Coverage, 18831,
     /* 2194269 */     GIR_EraseRootFromParent_Done,
     /* 2194270 */   // Label 28881: @2194270
     /* 2194270 */   GIM_Try, /*On fail goto*//*Label 28882*/ GIMT_Encode4(2194361), // Rule ID 18834 //
     /* 2194275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2194286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2194289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2194295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2194298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194321 */     // MIs[0] round
     /* 2194321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194324 */     // MIs[0] policy
     /* 2194324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194334 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2194337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194360 */     // GIR_Coverage, 18834,
     /* 2194360 */     GIR_EraseRootFromParent_Done,
     /* 2194361 */   // Label 28882: @2194361
     /* 2194361 */   GIM_Try, /*On fail goto*//*Label 28883*/ GIMT_Encode4(2194452), // Rule ID 18835 //
     /* 2194366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2194377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2194380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2194386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2194389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194412 */     // MIs[0] round
     /* 2194412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194415 */     // MIs[0] policy
     /* 2194415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194425 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2194428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194451 */     // GIR_Coverage, 18835,
     /* 2194451 */     GIR_EraseRootFromParent_Done,
     /* 2194452 */   // Label 28883: @2194452
     /* 2194452 */   GIM_Try, /*On fail goto*//*Label 28884*/ GIMT_Encode4(2194543), // Rule ID 18838 //
     /* 2194457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2194468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2194471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2194477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194503 */     // MIs[0] round
     /* 2194503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194506 */     // MIs[0] policy
     /* 2194506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194516 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2194519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194542 */     // GIR_Coverage, 18838,
     /* 2194542 */     GIR_EraseRootFromParent_Done,
     /* 2194543 */   // Label 28884: @2194543
     /* 2194543 */   GIM_Try, /*On fail goto*//*Label 28885*/ GIMT_Encode4(2194634), // Rule ID 18839 //
     /* 2194548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2194559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2194562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2194568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194594 */     // MIs[0] round
     /* 2194594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194597 */     // MIs[0] policy
     /* 2194597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194607 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2194610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194633 */     // GIR_Coverage, 18839,
     /* 2194633 */     GIR_EraseRootFromParent_Done,
     /* 2194634 */   // Label 28885: @2194634
     /* 2194634 */   GIM_Try, /*On fail goto*//*Label 28886*/ GIMT_Encode4(2194725), // Rule ID 18842 //
     /* 2194639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2194650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2194653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2194659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194685 */     // MIs[0] round
     /* 2194685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194688 */     // MIs[0] policy
     /* 2194688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194698 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2194701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194724 */     // GIR_Coverage, 18842,
     /* 2194724 */     GIR_EraseRootFromParent_Done,
     /* 2194725 */   // Label 28886: @2194725
     /* 2194725 */   GIM_Try, /*On fail goto*//*Label 28887*/ GIMT_Encode4(2194816), // Rule ID 18843 //
     /* 2194730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2194741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2194744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2194750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194776 */     // MIs[0] round
     /* 2194776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194779 */     // MIs[0] policy
     /* 2194779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194789 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2194792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194815 */     // GIR_Coverage, 18843,
     /* 2194815 */     GIR_EraseRootFromParent_Done,
     /* 2194816 */   // Label 28887: @2194816
     /* 2194816 */   GIM_Try, /*On fail goto*//*Label 28888*/ GIMT_Encode4(2194907), // Rule ID 18846 //
     /* 2194821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2194832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2194835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2194841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194867 */     // MIs[0] round
     /* 2194867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194870 */     // MIs[0] policy
     /* 2194870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194880 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2194883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194906 */     // GIR_Coverage, 18846,
     /* 2194906 */     GIR_EraseRootFromParent_Done,
     /* 2194907 */   // Label 28888: @2194907
     /* 2194907 */   GIM_Try, /*On fail goto*//*Label 28889*/ GIMT_Encode4(2194998), // Rule ID 18847 //
     /* 2194912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2194923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2194926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2194932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194958 */     // MIs[0] round
     /* 2194958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194961 */     // MIs[0] policy
     /* 2194961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194971 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2194974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194997 */     // GIR_Coverage, 18847,
     /* 2194997 */     GIR_EraseRootFromParent_Done,
     /* 2194998 */   // Label 28889: @2194998
     /* 2194998 */   GIM_Try, /*On fail goto*//*Label 28890*/ GIMT_Encode4(2195089), // Rule ID 18850 //
     /* 2195003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2195006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2195014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2195017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2195020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2195023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2195026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2195041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195049 */     // MIs[0] round
     /* 2195049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195052 */     // MIs[0] policy
     /* 2195052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195062 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2195065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195088 */     // GIR_Coverage, 18850,
     /* 2195088 */     GIR_EraseRootFromParent_Done,
     /* 2195089 */   // Label 28890: @2195089
     /* 2195089 */   GIM_Try, /*On fail goto*//*Label 28891*/ GIMT_Encode4(2195180), // Rule ID 18851 //
     /* 2195094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2195097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2195105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2195108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2195111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2195114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2195117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2195132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195140 */     // MIs[0] round
     /* 2195140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195143 */     // MIs[0] policy
     /* 2195143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195153 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2195156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195179 */     // GIR_Coverage, 18851,
     /* 2195179 */     GIR_EraseRootFromParent_Done,
     /* 2195180 */   // Label 28891: @2195180
     /* 2195180 */   GIM_Try, /*On fail goto*//*Label 28892*/ GIMT_Encode4(2195271), // Rule ID 18854 //
     /* 2195185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2195196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2195199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2195205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195231 */     // MIs[0] round
     /* 2195231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195234 */     // MIs[0] policy
     /* 2195234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195244 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2195247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195270 */     // GIR_Coverage, 18854,
     /* 2195270 */     GIR_EraseRootFromParent_Done,
     /* 2195271 */   // Label 28892: @2195271
     /* 2195271 */   GIM_Try, /*On fail goto*//*Label 28893*/ GIMT_Encode4(2195362), // Rule ID 18855 //
     /* 2195276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2195287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2195290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2195296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195322 */     // MIs[0] round
     /* 2195322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195325 */     // MIs[0] policy
     /* 2195325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195335 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2195338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195361 */     // GIR_Coverage, 18855,
     /* 2195361 */     GIR_EraseRootFromParent_Done,
     /* 2195362 */   // Label 28893: @2195362
     /* 2195362 */   GIM_Try, /*On fail goto*//*Label 28894*/ GIMT_Encode4(2195453), // Rule ID 18858 //
     /* 2195367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2195378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2195381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2195387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195413 */     // MIs[0] round
     /* 2195413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195416 */     // MIs[0] policy
     /* 2195416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195426 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2195429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195452 */     // GIR_Coverage, 18858,
     /* 2195452 */     GIR_EraseRootFromParent_Done,
     /* 2195453 */   // Label 28894: @2195453
     /* 2195453 */   GIM_Try, /*On fail goto*//*Label 28895*/ GIMT_Encode4(2195544), // Rule ID 18859 //
     /* 2195458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2195469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2195472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2195478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195504 */     // MIs[0] round
     /* 2195504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195507 */     // MIs[0] policy
     /* 2195507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195517 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2195520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195543 */     // GIR_Coverage, 18859,
     /* 2195543 */     GIR_EraseRootFromParent_Done,
     /* 2195544 */   // Label 28895: @2195544
     /* 2195544 */   GIM_Try, /*On fail goto*//*Label 28896*/ GIMT_Encode4(2195635), // Rule ID 18862 //
     /* 2195549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2195560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2195563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2195569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2195579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195595 */     // MIs[0] round
     /* 2195595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195598 */     // MIs[0] policy
     /* 2195598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195608 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2195611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195634 */     // GIR_Coverage, 18862,
     /* 2195634 */     GIR_EraseRootFromParent_Done,
     /* 2195635 */   // Label 28896: @2195635
     /* 2195635 */   GIM_Try, /*On fail goto*//*Label 28897*/ GIMT_Encode4(2195726), // Rule ID 18863 //
     /* 2195640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2195651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2195654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2195660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2195670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195686 */     // MIs[0] round
     /* 2195686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195689 */     // MIs[0] policy
     /* 2195689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195699 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2195702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195725 */     // GIR_Coverage, 18863,
     /* 2195725 */     GIR_EraseRootFromParent_Done,
     /* 2195726 */   // Label 28897: @2195726
     /* 2195726 */   GIM_Try, /*On fail goto*//*Label 28898*/ GIMT_Encode4(2195817), // Rule ID 18866 //
     /* 2195731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2195742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2195745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2195751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195777 */     // MIs[0] round
     /* 2195777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195780 */     // MIs[0] policy
     /* 2195780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195790 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2195793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195816 */     // GIR_Coverage, 18866,
     /* 2195816 */     GIR_EraseRootFromParent_Done,
     /* 2195817 */   // Label 28898: @2195817
     /* 2195817 */   GIM_Try, /*On fail goto*//*Label 28899*/ GIMT_Encode4(2195908), // Rule ID 18867 //
     /* 2195822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2195833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2195836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2195842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195868 */     // MIs[0] round
     /* 2195868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195871 */     // MIs[0] policy
     /* 2195871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195881 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2195884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195907 */     // GIR_Coverage, 18867,
     /* 2195907 */     GIR_EraseRootFromParent_Done,
     /* 2195908 */   // Label 28899: @2195908
     /* 2195908 */   GIM_Try, /*On fail goto*//*Label 28900*/ GIMT_Encode4(2195999), // Rule ID 18870 //
     /* 2195913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2195916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2195924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2195927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2195930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2195933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195959 */     // MIs[0] round
     /* 2195959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195962 */     // MIs[0] policy
     /* 2195962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195972 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2195975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195998 */     // GIR_Coverage, 18870,
     /* 2195998 */     GIR_EraseRootFromParent_Done,
     /* 2195999 */   // Label 28900: @2195999
     /* 2195999 */   GIM_Try, /*On fail goto*//*Label 28901*/ GIMT_Encode4(2196090), // Rule ID 18871 //
     /* 2196004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2196015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2196018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2196021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2196024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196050 */     // MIs[0] round
     /* 2196050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196053 */     // MIs[0] policy
     /* 2196053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196063 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2196066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196089 */     // GIR_Coverage, 18871,
     /* 2196089 */     GIR_EraseRootFromParent_Done,
     /* 2196090 */   // Label 28901: @2196090
     /* 2196090 */   GIM_Try, /*On fail goto*//*Label 28902*/ GIMT_Encode4(2196181), // Rule ID 18874 //
     /* 2196095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2196106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2196109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2196112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2196115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2196118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196141 */     // MIs[0] round
     /* 2196141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196144 */     // MIs[0] policy
     /* 2196144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196154 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2196157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196180 */     // GIR_Coverage, 18874,
     /* 2196180 */     GIR_EraseRootFromParent_Done,
     /* 2196181 */   // Label 28902: @2196181
     /* 2196181 */   GIM_Try, /*On fail goto*//*Label 28903*/ GIMT_Encode4(2196272), // Rule ID 18875 //
     /* 2196186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2196197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2196200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2196203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2196206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2196209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196232 */     // MIs[0] round
     /* 2196232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196235 */     // MIs[0] policy
     /* 2196235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196245 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2196248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196271 */     // GIR_Coverage, 18875,
     /* 2196271 */     GIR_EraseRootFromParent_Done,
     /* 2196272 */   // Label 28903: @2196272
     /* 2196272 */   GIM_Try, /*On fail goto*//*Label 28904*/ GIMT_Encode4(2196363), // Rule ID 18878 //
     /* 2196277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2196288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2196291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2196294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2196297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2196300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2196307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196323 */     // MIs[0] round
     /* 2196323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196326 */     // MIs[0] policy
     /* 2196326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196336 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2196339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196362 */     // GIR_Coverage, 18878,
     /* 2196362 */     GIR_EraseRootFromParent_Done,
     /* 2196363 */   // Label 28904: @2196363
     /* 2196363 */   GIM_Try, /*On fail goto*//*Label 28905*/ GIMT_Encode4(2196454), // Rule ID 18879 //
     /* 2196368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2196379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2196382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2196385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2196388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2196391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2196398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196414 */     // MIs[0] round
     /* 2196414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196417 */     // MIs[0] policy
     /* 2196417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196427 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2196430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196453 */     // GIR_Coverage, 18879,
     /* 2196453 */     GIR_EraseRootFromParent_Done,
     /* 2196454 */   // Label 28905: @2196454
     /* 2196454 */   GIM_Try, /*On fail goto*//*Label 28906*/ GIMT_Encode4(2196545), // Rule ID 18882 //
     /* 2196459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2196470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2196473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2196476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2196479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196505 */     // MIs[0] round
     /* 2196505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196508 */     // MIs[0] policy
     /* 2196508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196518 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2196521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196544 */     // GIR_Coverage, 18882,
     /* 2196544 */     GIR_EraseRootFromParent_Done,
     /* 2196545 */   // Label 28906: @2196545
     /* 2196545 */   GIM_Try, /*On fail goto*//*Label 28907*/ GIMT_Encode4(2196636), // Rule ID 18883 //
     /* 2196550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2196561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2196564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2196567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2196570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196596 */     // MIs[0] round
     /* 2196596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196599 */     // MIs[0] policy
     /* 2196599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196609 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2196612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196635 */     // GIR_Coverage, 18883,
     /* 2196635 */     GIR_EraseRootFromParent_Done,
     /* 2196636 */   // Label 28907: @2196636
     /* 2196636 */   GIM_Try, /*On fail goto*//*Label 28908*/ GIMT_Encode4(2196727), // Rule ID 18886 //
     /* 2196641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2196652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2196655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2196658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2196661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2196664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2196671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196687 */     // MIs[0] round
     /* 2196687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196690 */     // MIs[0] policy
     /* 2196690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196700 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2196703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196726 */     // GIR_Coverage, 18886,
     /* 2196726 */     GIR_EraseRootFromParent_Done,
     /* 2196727 */   // Label 28908: @2196727
     /* 2196727 */   GIM_Try, /*On fail goto*//*Label 28909*/ GIMT_Encode4(2196818), // Rule ID 18887 //
     /* 2196732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2196743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2196746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2196749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2196752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2196755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2196762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196778 */     // MIs[0] round
     /* 2196778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196781 */     // MIs[0] policy
     /* 2196781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196791 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2196794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196817 */     // GIR_Coverage, 18887,
     /* 2196817 */     GIR_EraseRootFromParent_Done,
     /* 2196818 */   // Label 28909: @2196818
     /* 2196818 */   GIM_Try, /*On fail goto*//*Label 28910*/ GIMT_Encode4(2196909), // Rule ID 18890 //
     /* 2196823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2196826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2196834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2196837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2196840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2196843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196869 */     // MIs[0] round
     /* 2196869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196872 */     // MIs[0] policy
     /* 2196872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196882 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2196885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196908 */     // GIR_Coverage, 18890,
     /* 2196908 */     GIR_EraseRootFromParent_Done,
     /* 2196909 */   // Label 28910: @2196909
     /* 2196909 */   GIM_Try, /*On fail goto*//*Label 28911*/ GIMT_Encode4(2197000), // Rule ID 18891 //
     /* 2196914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2196917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2196925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2196928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2196931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2196934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196960 */     // MIs[0] round
     /* 2196960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196963 */     // MIs[0] policy
     /* 2196963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196973 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2196976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196999 */     // GIR_Coverage, 18891,
     /* 2196999 */     GIR_EraseRootFromParent_Done,
     /* 2197000 */   // Label 28911: @2197000
     /* 2197000 */   GIM_Try, /*On fail goto*//*Label 28912*/ GIMT_Encode4(2197091), // Rule ID 18894 //
     /* 2197005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2197008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2197016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2197019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2197022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2197025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2197035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197051 */     // MIs[0] round
     /* 2197051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197054 */     // MIs[0] policy
     /* 2197054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197064 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2197067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197090 */     // GIR_Coverage, 18894,
     /* 2197090 */     GIR_EraseRootFromParent_Done,
     /* 2197091 */   // Label 28912: @2197091
     /* 2197091 */   GIM_Try, /*On fail goto*//*Label 28913*/ GIMT_Encode4(2197182), // Rule ID 18895 //
     /* 2197096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2197099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2197107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2197110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2197113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2197116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2197126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197142 */     // MIs[0] round
     /* 2197142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197145 */     // MIs[0] policy
     /* 2197145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197155 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2197158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197181 */     // GIR_Coverage, 18895,
     /* 2197181 */     GIR_EraseRootFromParent_Done,
     /* 2197182 */   // Label 28913: @2197182
     /* 2197182 */   GIM_Try, /*On fail goto*//*Label 28914*/ GIMT_Encode4(2197273), // Rule ID 18898 //
     /* 2197187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2197190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2197198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2197201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2197204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2197207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2197210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2197217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197233 */     // MIs[0] round
     /* 2197233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197236 */     // MIs[0] policy
     /* 2197236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197246 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2197249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197272 */     // GIR_Coverage, 18898,
     /* 2197272 */     GIR_EraseRootFromParent_Done,
     /* 2197273 */   // Label 28914: @2197273
     /* 2197273 */   GIM_Try, /*On fail goto*//*Label 28915*/ GIMT_Encode4(2197364), // Rule ID 18899 //
     /* 2197278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2197281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2197289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2197292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2197295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2197298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2197301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2197308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197324 */     // MIs[0] round
     /* 2197324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197327 */     // MIs[0] policy
     /* 2197327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197337 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2197340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197363 */     // GIR_Coverage, 18899,
     /* 2197363 */     GIR_EraseRootFromParent_Done,
     /* 2197364 */   // Label 28915: @2197364
     /* 2197364 */   GIM_Try, /*On fail goto*//*Label 28916*/ GIMT_Encode4(2197455), // Rule ID 18902 //
     /* 2197369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2197372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2197380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2197383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2197386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2197389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2197392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2197399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197415 */     // MIs[0] round
     /* 2197415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197418 */     // MIs[0] policy
     /* 2197418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197428 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2197431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197454 */     // GIR_Coverage, 18902,
     /* 2197454 */     GIR_EraseRootFromParent_Done,
     /* 2197455 */   // Label 28916: @2197455
     /* 2197455 */   GIM_Try, /*On fail goto*//*Label 28917*/ GIMT_Encode4(2197546), // Rule ID 18903 //
     /* 2197460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2197463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2197471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2197474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2197477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2197480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2197483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2197490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197506 */     // MIs[0] round
     /* 2197506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197509 */     // MIs[0] policy
     /* 2197509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197519 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2197522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197545 */     // GIR_Coverage, 18903,
     /* 2197545 */     GIR_EraseRootFromParent_Done,
     /* 2197546 */   // Label 28917: @2197546
     /* 2197546 */   GIM_Try, /*On fail goto*//*Label 28918*/ GIMT_Encode4(2197637), // Rule ID 18906 //
     /* 2197551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2197562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2197565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2197571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2197574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197597 */     // MIs[0] round
     /* 2197597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197600 */     // MIs[0] policy
     /* 2197600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197610 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2197613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197636 */     // GIR_Coverage, 18906,
     /* 2197636 */     GIR_EraseRootFromParent_Done,
     /* 2197637 */   // Label 28918: @2197637
     /* 2197637 */   GIM_Try, /*On fail goto*//*Label 28919*/ GIMT_Encode4(2197728), // Rule ID 18907 //
     /* 2197642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2197653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2197656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2197662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2197665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197688 */     // MIs[0] round
     /* 2197688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197691 */     // MIs[0] policy
     /* 2197691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197701 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2197704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197727 */     // GIR_Coverage, 18907,
     /* 2197727 */     GIR_EraseRootFromParent_Done,
     /* 2197728 */   // Label 28919: @2197728
     /* 2197728 */   GIM_Try, /*On fail goto*//*Label 28920*/ GIMT_Encode4(2197819), // Rule ID 18910 //
     /* 2197733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2197744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2197747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2197753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197779 */     // MIs[0] round
     /* 2197779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197782 */     // MIs[0] policy
     /* 2197782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197792 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2197795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197818 */     // GIR_Coverage, 18910,
     /* 2197818 */     GIR_EraseRootFromParent_Done,
     /* 2197819 */   // Label 28920: @2197819
     /* 2197819 */   GIM_Try, /*On fail goto*//*Label 28921*/ GIMT_Encode4(2197910), // Rule ID 18911 //
     /* 2197824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2197835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2197838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2197844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197870 */     // MIs[0] round
     /* 2197870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197873 */     // MIs[0] policy
     /* 2197873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197883 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2197886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197909 */     // GIR_Coverage, 18911,
     /* 2197909 */     GIR_EraseRootFromParent_Done,
     /* 2197910 */   // Label 28921: @2197910
     /* 2197910 */   GIM_Try, /*On fail goto*//*Label 28922*/ GIMT_Encode4(2198001), // Rule ID 18914 //
     /* 2197915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2197926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2197929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2197935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2197938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2197945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197961 */     // MIs[0] round
     /* 2197961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197964 */     // MIs[0] policy
     /* 2197964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197974 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2197977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198000 */     // GIR_Coverage, 18914,
     /* 2198000 */     GIR_EraseRootFromParent_Done,
     /* 2198001 */   // Label 28922: @2198001
     /* 2198001 */   GIM_Try, /*On fail goto*//*Label 28923*/ GIMT_Encode4(2198092), // Rule ID 18915 //
     /* 2198006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2198009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2198017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2198020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2198026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198052 */     // MIs[0] round
     /* 2198052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198055 */     // MIs[0] policy
     /* 2198055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198065 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2198068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198091 */     // GIR_Coverage, 18915,
     /* 2198091 */     GIR_EraseRootFromParent_Done,
     /* 2198092 */   // Label 28923: @2198092
     /* 2198092 */   GIM_Try, /*On fail goto*//*Label 28924*/ GIMT_Encode4(2198183), // Rule ID 18918 //
     /* 2198097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2198100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2198108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2198111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2198117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2198120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198143 */     // MIs[0] round
     /* 2198143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198146 */     // MIs[0] policy
     /* 2198146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198156 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2198159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198182 */     // GIR_Coverage, 18918,
     /* 2198182 */     GIR_EraseRootFromParent_Done,
     /* 2198183 */   // Label 28924: @2198183
     /* 2198183 */   GIM_Try, /*On fail goto*//*Label 28925*/ GIMT_Encode4(2198274), // Rule ID 18919 //
     /* 2198188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2198191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2198199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2198202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2198208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2198211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198234 */     // MIs[0] round
     /* 2198234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198237 */     // MIs[0] policy
     /* 2198237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198247 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2198250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198273 */     // GIR_Coverage, 18919,
     /* 2198273 */     GIR_EraseRootFromParent_Done,
     /* 2198274 */   // Label 28925: @2198274
     /* 2198274 */   GIM_Try, /*On fail goto*//*Label 28926*/ GIMT_Encode4(2198365), // Rule ID 18922 //
     /* 2198279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2198282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2198290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2198293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2198299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2198302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2198309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2198313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198325 */     // MIs[0] round
     /* 2198325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198328 */     // MIs[0] policy
     /* 2198328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198338 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2198341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198364 */     // GIR_Coverage, 18922,
     /* 2198364 */     GIR_EraseRootFromParent_Done,
     /* 2198365 */   // Label 28926: @2198365
     /* 2198365 */   GIM_Try, /*On fail goto*//*Label 28927*/ GIMT_Encode4(2198456), // Rule ID 18923 //
     /* 2198370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2198373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2198381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2198384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2198390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2198393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2198400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2198404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198416 */     // MIs[0] round
     /* 2198416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198419 */     // MIs[0] policy
     /* 2198419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198429 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2198432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198455 */     // GIR_Coverage, 18923,
     /* 2198455 */     GIR_EraseRootFromParent_Done,
     /* 2198456 */   // Label 28927: @2198456
     /* 2198456 */   GIM_Try, /*On fail goto*//*Label 28928*/ GIMT_Encode4(2198547), // Rule ID 18926 //
     /* 2198461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2198472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2198475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2198481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198507 */     // MIs[0] round
     /* 2198507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198510 */     // MIs[0] policy
     /* 2198510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198520 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2198523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198546 */     // GIR_Coverage, 18926,
     /* 2198546 */     GIR_EraseRootFromParent_Done,
     /* 2198547 */   // Label 28928: @2198547
     /* 2198547 */   GIM_Try, /*On fail goto*//*Label 28929*/ GIMT_Encode4(2198638), // Rule ID 18927 //
     /* 2198552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2198563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2198566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2198572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198598 */     // MIs[0] round
     /* 2198598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198601 */     // MIs[0] policy
     /* 2198601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198611 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2198614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198637 */     // GIR_Coverage, 18927,
     /* 2198637 */     GIR_EraseRootFromParent_Done,
     /* 2198638 */   // Label 28929: @2198638
     /* 2198638 */   GIM_Try, /*On fail goto*//*Label 28930*/ GIMT_Encode4(2198729), // Rule ID 18930 //
     /* 2198643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2198654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2198657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2198663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2198666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198689 */     // MIs[0] round
     /* 2198689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198692 */     // MIs[0] policy
     /* 2198692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2198705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198728 */     // GIR_Coverage, 18930,
     /* 2198728 */     GIR_EraseRootFromParent_Done,
     /* 2198729 */   // Label 28930: @2198729
     /* 2198729 */   GIM_Try, /*On fail goto*//*Label 28931*/ GIMT_Encode4(2198820), // Rule ID 18931 //
     /* 2198734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2198745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2198748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2198754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2198757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198780 */     // MIs[0] round
     /* 2198780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198783 */     // MIs[0] policy
     /* 2198783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198793 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2198796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198819 */     // GIR_Coverage, 18931,
     /* 2198819 */     GIR_EraseRootFromParent_Done,
     /* 2198820 */   // Label 28931: @2198820
     /* 2198820 */   GIM_Try, /*On fail goto*//*Label 28932*/ GIMT_Encode4(2198911), // Rule ID 18934 //
     /* 2198825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2198836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2198839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2198845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198871 */     // MIs[0] round
     /* 2198871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198874 */     // MIs[0] policy
     /* 2198874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198884 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2198887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198910 */     // GIR_Coverage, 18934,
     /* 2198910 */     GIR_EraseRootFromParent_Done,
     /* 2198911 */   // Label 28932: @2198911
     /* 2198911 */   GIM_Try, /*On fail goto*//*Label 28933*/ GIMT_Encode4(2199002), // Rule ID 18935 //
     /* 2198916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2198927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2198930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2198936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198962 */     // MIs[0] round
     /* 2198962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198965 */     // MIs[0] policy
     /* 2198965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198975 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2198978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199001 */     // GIR_Coverage, 18935,
     /* 2199001 */     GIR_EraseRootFromParent_Done,
     /* 2199002 */   // Label 28933: @2199002
     /* 2199002 */   GIM_Try, /*On fail goto*//*Label 28934*/ GIMT_Encode4(2199093), // Rule ID 18938 //
     /* 2199007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2199010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2199015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2199018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2199021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2199024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2199027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2199037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2199045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199053 */     // MIs[0] round
     /* 2199053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199056 */     // MIs[0] policy
     /* 2199056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199066 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2199069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199092 */     // GIR_Coverage, 18938,
     /* 2199092 */     GIR_EraseRootFromParent_Done,
     /* 2199093 */   // Label 28934: @2199093
     /* 2199093 */   GIM_Try, /*On fail goto*//*Label 28935*/ GIMT_Encode4(2199184), // Rule ID 18939 //
     /* 2199098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2199101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2199106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2199109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2199112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2199115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2199118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2199128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2199136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199144 */     // MIs[0] round
     /* 2199144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199147 */     // MIs[0] policy
     /* 2199147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199157 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2199160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199183 */     // GIR_Coverage, 18939,
     /* 2199183 */     GIR_EraseRootFromParent_Done,
     /* 2199184 */   // Label 28935: @2199184
     /* 2199184 */   GIM_Try, /*On fail goto*//*Label 28936*/ GIMT_Encode4(2199275), // Rule ID 18942 //
     /* 2199189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2199200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2199203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2199206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2199209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2199212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199235 */     // MIs[0] round
     /* 2199235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199238 */     // MIs[0] policy
     /* 2199238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199248 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2199251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199274 */     // GIR_Coverage, 18942,
     /* 2199274 */     GIR_EraseRootFromParent_Done,
     /* 2199275 */   // Label 28936: @2199275
     /* 2199275 */   GIM_Try, /*On fail goto*//*Label 28937*/ GIMT_Encode4(2199366), // Rule ID 18943 //
     /* 2199280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2199291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2199294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2199297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2199300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2199303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199326 */     // MIs[0] round
     /* 2199326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199329 */     // MIs[0] policy
     /* 2199329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199339 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2199342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199352 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199362 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199365 */     // GIR_Coverage, 18943,
     /* 2199365 */     GIR_EraseRootFromParent_Done,
     /* 2199366 */   // Label 28937: @2199366
     /* 2199366 */   GIM_Try, /*On fail goto*//*Label 28938*/ GIMT_Encode4(2199457), // Rule ID 18946 //
     /* 2199371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2199382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2199385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2199388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2199391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2199394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199417 */     // MIs[0] round
     /* 2199417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199420 */     // MIs[0] policy
     /* 2199420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199430 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2199433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199456 */     // GIR_Coverage, 18946,
     /* 2199456 */     GIR_EraseRootFromParent_Done,
     /* 2199457 */   // Label 28938: @2199457
     /* 2199457 */   GIM_Try, /*On fail goto*//*Label 28939*/ GIMT_Encode4(2199548), // Rule ID 18947 //
     /* 2199462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2199473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2199476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2199479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2199482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2199485 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199508 */     // MIs[0] round
     /* 2199508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199511 */     // MIs[0] policy
     /* 2199511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199521 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2199524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199547 */     // GIR_Coverage, 18947,
     /* 2199547 */     GIR_EraseRootFromParent_Done,
     /* 2199548 */   // Label 28939: @2199548
     /* 2199548 */   GIM_Try, /*On fail goto*//*Label 28940*/ GIMT_Encode4(2199639), // Rule ID 18950 //
     /* 2199553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2199564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2199567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2199570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2199573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2199576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199599 */     // MIs[0] round
     /* 2199599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199602 */     // MIs[0] policy
     /* 2199602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199612 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2199615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199638 */     // GIR_Coverage, 18950,
     /* 2199638 */     GIR_EraseRootFromParent_Done,
     /* 2199639 */   // Label 28940: @2199639
     /* 2199639 */   GIM_Try, /*On fail goto*//*Label 28941*/ GIMT_Encode4(2199730), // Rule ID 18951 //
     /* 2199644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2199655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2199658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2199661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2199664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2199667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199690 */     // MIs[0] round
     /* 2199690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199693 */     // MIs[0] policy
     /* 2199693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199703 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2199706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199729 */     // GIR_Coverage, 18951,
     /* 2199729 */     GIR_EraseRootFromParent_Done,
     /* 2199730 */   // Label 28941: @2199730
     /* 2199730 */   GIM_Try, /*On fail goto*//*Label 28942*/ GIMT_Encode4(2199821), // Rule ID 18954 //
     /* 2199735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2199746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2199749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2199752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2199755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2199765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199781 */     // MIs[0] round
     /* 2199781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199784 */     // MIs[0] policy
     /* 2199784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199794 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2199797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199820 */     // GIR_Coverage, 18954,
     /* 2199820 */     GIR_EraseRootFromParent_Done,
     /* 2199821 */   // Label 28942: @2199821
     /* 2199821 */   GIM_Try, /*On fail goto*//*Label 28943*/ GIMT_Encode4(2199912), // Rule ID 18955 //
     /* 2199826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2199837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2199840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2199843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2199846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2199856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199872 */     // MIs[0] round
     /* 2199872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199875 */     // MIs[0] policy
     /* 2199875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199885 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2199888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199911 */     // GIR_Coverage, 18955,
     /* 2199911 */     GIR_EraseRootFromParent_Done,
     /* 2199912 */   // Label 28943: @2199912
     /* 2199912 */   GIM_Try, /*On fail goto*//*Label 28944*/ GIMT_Encode4(2200003), // Rule ID 18958 //
     /* 2199917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2199928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2199931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2199934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2199937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2199940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2199947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199963 */     // MIs[0] round
     /* 2199963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199966 */     // MIs[0] policy
     /* 2199966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199976 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2199979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200002 */     // GIR_Coverage, 18958,
     /* 2200002 */     GIR_EraseRootFromParent_Done,
     /* 2200003 */   // Label 28944: @2200003
     /* 2200003 */   GIM_Try, /*On fail goto*//*Label 28945*/ GIMT_Encode4(2200094), // Rule ID 18959 //
     /* 2200008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2200011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2200019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2200022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2200025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2200028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2200031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200054 */     // MIs[0] round
     /* 2200054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200057 */     // MIs[0] policy
     /* 2200057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200067 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2200070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200093 */     // GIR_Coverage, 18959,
     /* 2200093 */     GIR_EraseRootFromParent_Done,
     /* 2200094 */   // Label 28945: @2200094
     /* 2200094 */   GIM_Try, /*On fail goto*//*Label 28946*/ GIMT_Encode4(2200185), // Rule ID 18962 //
     /* 2200099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2200110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2200113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2200116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2200119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200145 */     // MIs[0] round
     /* 2200145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200148 */     // MIs[0] policy
     /* 2200148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200158 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2200161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200184 */     // GIR_Coverage, 18962,
     /* 2200184 */     GIR_EraseRootFromParent_Done,
     /* 2200185 */   // Label 28946: @2200185
     /* 2200185 */   GIM_Try, /*On fail goto*//*Label 28947*/ GIMT_Encode4(2200276), // Rule ID 18963 //
     /* 2200190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2200201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2200204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2200207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2200210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200236 */     // MIs[0] round
     /* 2200236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200239 */     // MIs[0] policy
     /* 2200239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200249 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2200252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200275 */     // GIR_Coverage, 18963,
     /* 2200275 */     GIR_EraseRootFromParent_Done,
     /* 2200276 */   // Label 28947: @2200276
     /* 2200276 */   GIM_Try, /*On fail goto*//*Label 28948*/ GIMT_Encode4(2200367), // Rule ID 18966 //
     /* 2200281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2200292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2200295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2200298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2200301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2200304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2200311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200327 */     // MIs[0] round
     /* 2200327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200330 */     // MIs[0] policy
     /* 2200330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200340 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2200343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200366 */     // GIR_Coverage, 18966,
     /* 2200366 */     GIR_EraseRootFromParent_Done,
     /* 2200367 */   // Label 28948: @2200367
     /* 2200367 */   GIM_Try, /*On fail goto*//*Label 28949*/ GIMT_Encode4(2200458), // Rule ID 18967 //
     /* 2200372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2200383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2200386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2200389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2200392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2200395 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2200402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200418 */     // MIs[0] round
     /* 2200418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200421 */     // MIs[0] policy
     /* 2200421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200431 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2200434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200457 */     // GIR_Coverage, 18967,
     /* 2200457 */     GIR_EraseRootFromParent_Done,
     /* 2200458 */   // Label 28949: @2200458
     /* 2200458 */   GIM_Try, /*On fail goto*//*Label 28950*/ GIMT_Encode4(2200549), // Rule ID 18970 //
     /* 2200463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2200474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2200477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2200480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2200483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2200493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200509 */     // MIs[0] round
     /* 2200509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200512 */     // MIs[0] policy
     /* 2200512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200522 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2200525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200548 */     // GIR_Coverage, 18970,
     /* 2200548 */     GIR_EraseRootFromParent_Done,
     /* 2200549 */   // Label 28950: @2200549
     /* 2200549 */   GIM_Try, /*On fail goto*//*Label 28951*/ GIMT_Encode4(2200640), // Rule ID 18971 //
     /* 2200554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2200565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2200568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2200571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2200574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2200584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200600 */     // MIs[0] round
     /* 2200600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200603 */     // MIs[0] policy
     /* 2200603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200613 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2200616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200639 */     // GIR_Coverage, 18971,
     /* 2200639 */     GIR_EraseRootFromParent_Done,
     /* 2200640 */   // Label 28951: @2200640
     /* 2200640 */   GIM_Try, /*On fail goto*//*Label 28952*/ GIMT_Encode4(2200731), // Rule ID 18974 //
     /* 2200645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2200656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2200659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2200662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2200665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2200668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200691 */     // MIs[0] round
     /* 2200691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200694 */     // MIs[0] policy
     /* 2200694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200704 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2200707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200730 */     // GIR_Coverage, 18974,
     /* 2200730 */     GIR_EraseRootFromParent_Done,
     /* 2200731 */   // Label 28952: @2200731
     /* 2200731 */   GIM_Try, /*On fail goto*//*Label 28953*/ GIMT_Encode4(2200822), // Rule ID 18975 //
     /* 2200736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2200747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2200750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2200753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2200756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2200759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200782 */     // MIs[0] round
     /* 2200782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200785 */     // MIs[0] policy
     /* 2200785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200795 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2200798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200821 */     // GIR_Coverage, 18975,
     /* 2200821 */     GIR_EraseRootFromParent_Done,
     /* 2200822 */   // Label 28953: @2200822
     /* 2200822 */   GIM_Try, /*On fail goto*//*Label 28954*/ GIMT_Encode4(2200913), // Rule ID 18978 //
     /* 2200827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2200830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2200838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2200841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2200847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200873 */     // MIs[0] round
     /* 2200873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200876 */     // MIs[0] policy
     /* 2200876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200886 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2200889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200912 */     // GIR_Coverage, 18978,
     /* 2200912 */     GIR_EraseRootFromParent_Done,
     /* 2200913 */   // Label 28954: @2200913
     /* 2200913 */   GIM_Try, /*On fail goto*//*Label 28955*/ GIMT_Encode4(2201004), // Rule ID 18979 //
     /* 2200918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2200921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2200929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2200932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2200938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200964 */     // MIs[0] round
     /* 2200964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200967 */     // MIs[0] policy
     /* 2200967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200977 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2200980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201003 */     // GIR_Coverage, 18979,
     /* 2201003 */     GIR_EraseRootFromParent_Done,
     /* 2201004 */   // Label 28955: @2201004
     /* 2201004 */   GIM_Try, /*On fail goto*//*Label 28956*/ GIMT_Encode4(2201095), // Rule ID 18982 //
     /* 2201009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2201020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2201023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2201029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2201032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201055 */     // MIs[0] round
     /* 2201055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201058 */     // MIs[0] policy
     /* 2201058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201068 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2201071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201094 */     // GIR_Coverage, 18982,
     /* 2201094 */     GIR_EraseRootFromParent_Done,
     /* 2201095 */   // Label 28956: @2201095
     /* 2201095 */   GIM_Try, /*On fail goto*//*Label 28957*/ GIMT_Encode4(2201186), // Rule ID 18983 //
     /* 2201100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2201111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2201114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2201120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2201123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201146 */     // MIs[0] round
     /* 2201146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201149 */     // MIs[0] policy
     /* 2201149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201159 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2201162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201185 */     // GIR_Coverage, 18983,
     /* 2201185 */     GIR_EraseRootFromParent_Done,
     /* 2201186 */   // Label 28957: @2201186
     /* 2201186 */   GIM_Try, /*On fail goto*//*Label 28958*/ GIMT_Encode4(2201277), // Rule ID 18986 //
     /* 2201191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2201202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2201205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2201211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2201214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2201221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201237 */     // MIs[0] round
     /* 2201237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201240 */     // MIs[0] policy
     /* 2201240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201250 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2201253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201276 */     // GIR_Coverage, 18986,
     /* 2201276 */     GIR_EraseRootFromParent_Done,
     /* 2201277 */   // Label 28958: @2201277
     /* 2201277 */   GIM_Try, /*On fail goto*//*Label 28959*/ GIMT_Encode4(2201368), // Rule ID 18987 //
     /* 2201282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2201293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2201296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2201302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2201305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2201312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201328 */     // MIs[0] round
     /* 2201328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201331 */     // MIs[0] policy
     /* 2201331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201341 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2201344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201367 */     // GIR_Coverage, 18987,
     /* 2201367 */     GIR_EraseRootFromParent_Done,
     /* 2201368 */   // Label 28959: @2201368
     /* 2201368 */   GIM_Try, /*On fail goto*//*Label 28960*/ GIMT_Encode4(2201459), // Rule ID 18990 //
     /* 2201373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2201384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2201387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2201393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2201396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2201403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201419 */     // MIs[0] round
     /* 2201419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201422 */     // MIs[0] policy
     /* 2201422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201432 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2201435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201458 */     // GIR_Coverage, 18990,
     /* 2201458 */     GIR_EraseRootFromParent_Done,
     /* 2201459 */   // Label 28960: @2201459
     /* 2201459 */   GIM_Try, /*On fail goto*//*Label 28961*/ GIMT_Encode4(2201550), // Rule ID 18991 //
     /* 2201464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2201475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2201478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2201484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2201487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2201494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201510 */     // MIs[0] round
     /* 2201510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201513 */     // MIs[0] policy
     /* 2201513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201523 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2201526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201549 */     // GIR_Coverage, 18991,
     /* 2201549 */     GIR_EraseRootFromParent_Done,
     /* 2201550 */   // Label 28961: @2201550
     /* 2201550 */   GIM_Try, /*On fail goto*//*Label 28962*/ GIMT_Encode4(2201641), // Rule ID 18994 //
     /* 2201555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2201566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2201569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2201575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2201578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201601 */     // MIs[0] round
     /* 2201601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201604 */     // MIs[0] policy
     /* 2201604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201614 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2201617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201640 */     // GIR_Coverage, 18994,
     /* 2201640 */     GIR_EraseRootFromParent_Done,
     /* 2201641 */   // Label 28962: @2201641
     /* 2201641 */   GIM_Try, /*On fail goto*//*Label 28963*/ GIMT_Encode4(2201732), // Rule ID 18995 //
     /* 2201646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2201657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2201660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2201666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2201669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201692 */     // MIs[0] round
     /* 2201692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201695 */     // MIs[0] policy
     /* 2201695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201705 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2201708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201731 */     // GIR_Coverage, 18995,
     /* 2201731 */     GIR_EraseRootFromParent_Done,
     /* 2201732 */   // Label 28963: @2201732
     /* 2201732 */   GIM_Try, /*On fail goto*//*Label 28964*/ GIMT_Encode4(2201823), // Rule ID 18998 //
     /* 2201737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2201748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2201751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2201757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2201760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201783 */     // MIs[0] round
     /* 2201783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201786 */     // MIs[0] policy
     /* 2201786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201796 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2201799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201822 */     // GIR_Coverage, 18998,
     /* 2201822 */     GIR_EraseRootFromParent_Done,
     /* 2201823 */   // Label 28964: @2201823
     /* 2201823 */   GIM_Try, /*On fail goto*//*Label 28965*/ GIMT_Encode4(2201914), // Rule ID 18999 //
     /* 2201828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2201831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2201839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2201842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2201848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2201851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201874 */     // MIs[0] round
     /* 2201874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201877 */     // MIs[0] policy
     /* 2201877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201887 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2201890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201913 */     // GIR_Coverage, 18999,
     /* 2201913 */     GIR_EraseRootFromParent_Done,
     /* 2201914 */   // Label 28965: @2201914
     /* 2201914 */   GIM_Try, /*On fail goto*//*Label 28966*/ GIMT_Encode4(2202005), // Rule ID 19002 //
     /* 2201919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2201930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2201933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2201939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2201942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2201949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201965 */     // MIs[0] round
     /* 2201965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201968 */     // MIs[0] policy
     /* 2201968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201978 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2201981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202004 */     // GIR_Coverage, 19002,
     /* 2202004 */     GIR_EraseRootFromParent_Done,
     /* 2202005 */   // Label 28966: @2202005
     /* 2202005 */   GIM_Try, /*On fail goto*//*Label 28967*/ GIMT_Encode4(2202096), // Rule ID 19003 //
     /* 2202010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2202013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2202021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2202024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2202030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2202040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202056 */     // MIs[0] round
     /* 2202056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202059 */     // MIs[0] policy
     /* 2202059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202069 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2202072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202095 */     // GIR_Coverage, 19003,
     /* 2202095 */     GIR_EraseRootFromParent_Done,
     /* 2202096 */   // Label 28967: @2202096
     /* 2202096 */   GIM_Try, /*On fail goto*//*Label 28968*/ GIMT_Encode4(2202187), // Rule ID 19006 //
     /* 2202101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2202104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2202112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2202115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2202121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2202131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202147 */     // MIs[0] round
     /* 2202147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202150 */     // MIs[0] policy
     /* 2202150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202160 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2202163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202186 */     // GIR_Coverage, 19006,
     /* 2202186 */     GIR_EraseRootFromParent_Done,
     /* 2202187 */   // Label 28968: @2202187
     /* 2202187 */   GIM_Try, /*On fail goto*//*Label 28969*/ GIMT_Encode4(2202278), // Rule ID 19007 //
     /* 2202192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2202195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2202203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2202206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2202212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2202222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202238 */     // MIs[0] round
     /* 2202238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202241 */     // MIs[0] policy
     /* 2202241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202251 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2202254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202277 */     // GIR_Coverage, 19007,
     /* 2202277 */     GIR_EraseRootFromParent_Done,
     /* 2202278 */   // Label 28969: @2202278
     /* 2202278 */   GIM_Try, /*On fail goto*//*Label 28970*/ GIMT_Encode4(2202369), // Rule ID 19010 //
     /* 2202283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2202286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2202294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2202297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2202303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2202306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2202313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202329 */     // MIs[0] round
     /* 2202329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202332 */     // MIs[0] policy
     /* 2202332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202342 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2202345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202368 */     // GIR_Coverage, 19010,
     /* 2202368 */     GIR_EraseRootFromParent_Done,
     /* 2202369 */   // Label 28970: @2202369
     /* 2202369 */   GIM_Try, /*On fail goto*//*Label 28971*/ GIMT_Encode4(2202460), // Rule ID 19011 //
     /* 2202374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2202377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2202385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2202388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2202394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2202397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2202404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202420 */     // MIs[0] round
     /* 2202420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202423 */     // MIs[0] policy
     /* 2202423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202433 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2202436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202459 */     // GIR_Coverage, 19011,
     /* 2202459 */     GIR_EraseRootFromParent_Done,
     /* 2202460 */   // Label 28971: @2202460
     /* 2202460 */   GIM_Try, /*On fail goto*//*Label 28972*/ GIMT_Encode4(2202551), // Rule ID 64369 //
     /* 2202465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2202476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2202479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2202482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2202488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202511 */     // MIs[0] round
     /* 2202511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202514 */     // MIs[0] policy
     /* 2202514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202524 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2202527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202550 */     // GIR_Coverage, 64369,
     /* 2202550 */     GIR_EraseRootFromParent_Done,
     /* 2202551 */   // Label 28972: @2202551
     /* 2202551 */   GIM_Try, /*On fail goto*//*Label 28973*/ GIMT_Encode4(2202642), // Rule ID 64370 //
     /* 2202556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2202567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2202570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2202573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2202579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202602 */     // MIs[0] round
     /* 2202602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202605 */     // MIs[0] policy
     /* 2202605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202615 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2202618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202641 */     // GIR_Coverage, 64370,
     /* 2202641 */     GIR_EraseRootFromParent_Done,
     /* 2202642 */   // Label 28973: @2202642
     /* 2202642 */   GIM_Try, /*On fail goto*//*Label 28974*/ GIMT_Encode4(2202733), // Rule ID 64373 //
     /* 2202647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2202658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2202661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2202664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202693 */     // MIs[0] round
     /* 2202693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202696 */     // MIs[0] policy
     /* 2202696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202706 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2202709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202732 */     // GIR_Coverage, 64373,
     /* 2202732 */     GIR_EraseRootFromParent_Done,
     /* 2202733 */   // Label 28974: @2202733
     /* 2202733 */   GIM_Try, /*On fail goto*//*Label 28975*/ GIMT_Encode4(2202824), // Rule ID 64374 //
     /* 2202738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2202749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2202752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2202755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202784 */     // MIs[0] round
     /* 2202784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202787 */     // MIs[0] policy
     /* 2202787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202797 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2202800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202823 */     // GIR_Coverage, 64374,
     /* 2202823 */     GIR_EraseRootFromParent_Done,
     /* 2202824 */   // Label 28975: @2202824
     /* 2202824 */   GIM_Try, /*On fail goto*//*Label 28976*/ GIMT_Encode4(2202915), // Rule ID 64377 //
     /* 2202829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2202840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2202843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2202846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202875 */     // MIs[0] round
     /* 2202875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202878 */     // MIs[0] policy
     /* 2202878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202888 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2202891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202914 */     // GIR_Coverage, 64377,
     /* 2202914 */     GIR_EraseRootFromParent_Done,
     /* 2202915 */   // Label 28976: @2202915
     /* 2202915 */   GIM_Try, /*On fail goto*//*Label 28977*/ GIMT_Encode4(2203006), // Rule ID 64378 //
     /* 2202920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2202931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2202934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2202937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202966 */     // MIs[0] round
     /* 2202966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202969 */     // MIs[0] policy
     /* 2202969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202979 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2202982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203005 */     // GIR_Coverage, 64378,
     /* 2203005 */     GIR_EraseRootFromParent_Done,
     /* 2203006 */   // Label 28977: @2203006
     /* 2203006 */   GIM_Try, /*On fail goto*//*Label 28978*/ GIMT_Encode4(2203097), // Rule ID 64381 //
     /* 2203011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2203019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2203022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2203025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2203028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2203034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203057 */     // MIs[0] round
     /* 2203057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203060 */     // MIs[0] policy
     /* 2203060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M1_MASK),
     /* 2203073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203096 */     // GIR_Coverage, 64381,
     /* 2203096 */     GIR_EraseRootFromParent_Done,
     /* 2203097 */   // Label 28978: @2203097
     /* 2203097 */   GIM_Try, /*On fail goto*//*Label 28979*/ GIMT_Encode4(2203188), // Rule ID 64382 //
     /* 2203102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2203110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2203113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2203116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2203119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2203125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203148 */     // MIs[0] round
     /* 2203148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203151 */     // MIs[0] policy
     /* 2203151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203161 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M1_MASK),
     /* 2203164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203187 */     // GIR_Coverage, 64382,
     /* 2203187 */     GIR_EraseRootFromParent_Done,
     /* 2203188 */   // Label 28979: @2203188
     /* 2203188 */   GIM_Try, /*On fail goto*//*Label 28980*/ GIMT_Encode4(2203279), // Rule ID 64385 //
     /* 2203193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2203201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2203204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2203207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2203210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2203216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2203223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203239 */     // MIs[0] round
     /* 2203239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203242 */     // MIs[0] policy
     /* 2203242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203252 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M2_MASK),
     /* 2203255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203278 */     // GIR_Coverage, 64385,
     /* 2203278 */     GIR_EraseRootFromParent_Done,
     /* 2203279 */   // Label 28980: @2203279
     /* 2203279 */   GIM_Try, /*On fail goto*//*Label 28981*/ GIMT_Encode4(2203370), // Rule ID 64386 //
     /* 2203284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2203292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2203295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2203298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2203301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2203307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2203314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203330 */     // MIs[0] round
     /* 2203330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203333 */     // MIs[0] policy
     /* 2203333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203343 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M2_MASK),
     /* 2203346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203369 */     // GIR_Coverage, 64386,
     /* 2203369 */     GIR_EraseRootFromParent_Done,
     /* 2203370 */   // Label 28981: @2203370
     /* 2203370 */   GIM_Try, /*On fail goto*//*Label 28982*/ GIMT_Encode4(2203461), // Rule ID 64389 //
     /* 2203375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2203386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2203389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2203392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2203398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203421 */     // MIs[0] round
     /* 2203421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203424 */     // MIs[0] policy
     /* 2203424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203434 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF8_MASK),
     /* 2203437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203460 */     // GIR_Coverage, 64389,
     /* 2203460 */     GIR_EraseRootFromParent_Done,
     /* 2203461 */   // Label 28982: @2203461
     /* 2203461 */   GIM_Try, /*On fail goto*//*Label 28983*/ GIMT_Encode4(2203552), // Rule ID 64390 //
     /* 2203466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2203477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2203480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2203483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2203489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203512 */     // MIs[0] round
     /* 2203512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203515 */     // MIs[0] policy
     /* 2203515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203525 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF8_MASK),
     /* 2203528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203551 */     // GIR_Coverage, 64390,
     /* 2203551 */     GIR_EraseRootFromParent_Done,
     /* 2203552 */   // Label 28983: @2203552
     /* 2203552 */   GIM_Try, /*On fail goto*//*Label 28984*/ GIMT_Encode4(2203643), // Rule ID 64393 //
     /* 2203557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2203568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2203571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2203574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2203580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203603 */     // MIs[0] round
     /* 2203603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203606 */     // MIs[0] policy
     /* 2203606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203616 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF4_MASK),
     /* 2203619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203642 */     // GIR_Coverage, 64393,
     /* 2203642 */     GIR_EraseRootFromParent_Done,
     /* 2203643 */   // Label 28984: @2203643
     /* 2203643 */   GIM_Try, /*On fail goto*//*Label 28985*/ GIMT_Encode4(2203734), // Rule ID 64394 //
     /* 2203648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2203659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2203662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2203665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2203671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203694 */     // MIs[0] round
     /* 2203694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203697 */     // MIs[0] policy
     /* 2203697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203707 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF4_MASK),
     /* 2203710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203733 */     // GIR_Coverage, 64394,
     /* 2203733 */     GIR_EraseRootFromParent_Done,
     /* 2203734 */   // Label 28985: @2203734
     /* 2203734 */   GIM_Try, /*On fail goto*//*Label 28986*/ GIMT_Encode4(2203825), // Rule ID 64397 //
     /* 2203739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2203750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2203753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2203756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2203762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203785 */     // MIs[0] round
     /* 2203785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203788 */     // MIs[0] policy
     /* 2203788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203798 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF2_MASK),
     /* 2203801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203824 */     // GIR_Coverage, 64397,
     /* 2203824 */     GIR_EraseRootFromParent_Done,
     /* 2203825 */   // Label 28986: @2203825
     /* 2203825 */   GIM_Try, /*On fail goto*//*Label 28987*/ GIMT_Encode4(2203916), // Rule ID 64398 //
     /* 2203830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2203841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2203844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2203847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2203853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203876 */     // MIs[0] round
     /* 2203876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203879 */     // MIs[0] policy
     /* 2203879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203889 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF2_MASK),
     /* 2203892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203915 */     // GIR_Coverage, 64398,
     /* 2203915 */     GIR_EraseRootFromParent_Done,
     /* 2203916 */   // Label 28987: @2203916
     /* 2203916 */   GIM_Try, /*On fail goto*//*Label 28988*/ GIMT_Encode4(2204007), // Rule ID 64401 //
     /* 2203921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2203932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2203935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2203938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2203944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203967 */     // MIs[0] round
     /* 2203967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203970 */     // MIs[0] policy
     /* 2203970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203980 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M1_MASK),
     /* 2203983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204006 */     // GIR_Coverage, 64401,
     /* 2204006 */     GIR_EraseRootFromParent_Done,
     /* 2204007 */   // Label 28988: @2204007
     /* 2204007 */   GIM_Try, /*On fail goto*//*Label 28989*/ GIMT_Encode4(2204098), // Rule ID 64402 //
     /* 2204012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2204015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2204020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2204023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2204026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2204029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204035 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204058 */     // MIs[0] round
     /* 2204058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204061 */     // MIs[0] policy
     /* 2204061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204071 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M1_MASK),
     /* 2204074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204097 */     // GIR_Coverage, 64402,
     /* 2204097 */     GIR_EraseRootFromParent_Done,
     /* 2204098 */   // Label 28989: @2204098
     /* 2204098 */   GIM_Try, /*On fail goto*//*Label 28990*/ GIMT_Encode4(2204189), // Rule ID 64405 //
     /* 2204103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2204106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2204111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2204114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2204117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2204120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2204126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204149 */     // MIs[0] round
     /* 2204149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204152 */     // MIs[0] policy
     /* 2204152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204162 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M2_MASK),
     /* 2204165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204188 */     // GIR_Coverage, 64405,
     /* 2204188 */     GIR_EraseRootFromParent_Done,
     /* 2204189 */   // Label 28990: @2204189
     /* 2204189 */   GIM_Try, /*On fail goto*//*Label 28991*/ GIMT_Encode4(2204280), // Rule ID 64406 //
     /* 2204194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2204197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2204202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2204205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2204208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2204211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2204217 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204240 */     // MIs[0] round
     /* 2204240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204243 */     // MIs[0] policy
     /* 2204243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204253 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M2_MASK),
     /* 2204256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204279 */     // GIR_Coverage, 64406,
     /* 2204279 */     GIR_EraseRootFromParent_Done,
     /* 2204280 */   // Label 28991: @2204280
     /* 2204280 */   GIM_Try, /*On fail goto*//*Label 28992*/ GIMT_Encode4(2204371), // Rule ID 65194 //
     /* 2204285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2204296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2204299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2204302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2204308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204331 */     // MIs[0] round
     /* 2204331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204334 */     // MIs[0] policy
     /* 2204334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204344 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4_MASK),
     /* 2204347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204370 */     // GIR_Coverage, 65194,
     /* 2204370 */     GIR_EraseRootFromParent_Done,
     /* 2204371 */   // Label 28992: @2204371
     /* 2204371 */   GIM_Try, /*On fail goto*//*Label 28993*/ GIMT_Encode4(2204462), // Rule ID 65195 //
     /* 2204376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2204387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2204390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2204393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2204399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204422 */     // MIs[0] round
     /* 2204422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204425 */     // MIs[0] policy
     /* 2204425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204435 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4_MASK),
     /* 2204438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204461 */     // GIR_Coverage, 65195,
     /* 2204461 */     GIR_EraseRootFromParent_Done,
     /* 2204462 */   // Label 28993: @2204462
     /* 2204462 */   GIM_Try, /*On fail goto*//*Label 28994*/ GIMT_Encode4(2204553), // Rule ID 65198 //
     /* 2204467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2204478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2204481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2204484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2204490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204513 */     // MIs[0] round
     /* 2204513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204516 */     // MIs[0] policy
     /* 2204516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204526 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2_MASK),
     /* 2204529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204552 */     // GIR_Coverage, 65198,
     /* 2204552 */     GIR_EraseRootFromParent_Done,
     /* 2204553 */   // Label 28994: @2204553
     /* 2204553 */   GIM_Try, /*On fail goto*//*Label 28995*/ GIMT_Encode4(2204644), // Rule ID 65199 //
     /* 2204558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2204569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2204572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2204575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2204581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204604 */     // MIs[0] round
     /* 2204604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204607 */     // MIs[0] policy
     /* 2204607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204617 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2_MASK),
     /* 2204620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204643 */     // GIR_Coverage, 65199,
     /* 2204643 */     GIR_EraseRootFromParent_Done,
     /* 2204644 */   // Label 28995: @2204644
     /* 2204644 */   GIM_Try, /*On fail goto*//*Label 28996*/ GIMT_Encode4(2204735), // Rule ID 65202 //
     /* 2204649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2204660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2204663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2204666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2204672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204695 */     // MIs[0] round
     /* 2204695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204698 */     // MIs[0] policy
     /* 2204698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204708 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1_MASK),
     /* 2204711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204734 */     // GIR_Coverage, 65202,
     /* 2204734 */     GIR_EraseRootFromParent_Done,
     /* 2204735 */   // Label 28996: @2204735
     /* 2204735 */   GIM_Try, /*On fail goto*//*Label 28997*/ GIMT_Encode4(2204826), // Rule ID 65203 //
     /* 2204740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2204751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2204754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2204757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2204763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204786 */     // MIs[0] round
     /* 2204786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204789 */     // MIs[0] policy
     /* 2204789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204799 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1_MASK),
     /* 2204802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204825 */     // GIR_Coverage, 65203,
     /* 2204825 */     GIR_EraseRootFromParent_Done,
     /* 2204826 */   // Label 28997: @2204826
     /* 2204826 */   GIM_Try, /*On fail goto*//*Label 28998*/ GIMT_Encode4(2204917), // Rule ID 65206 //
     /* 2204831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2204842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2204845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2204848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204877 */     // MIs[0] round
     /* 2204877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204880 */     // MIs[0] policy
     /* 2204880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204890 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2_MASK),
     /* 2204893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204916 */     // GIR_Coverage, 65206,
     /* 2204916 */     GIR_EraseRootFromParent_Done,
     /* 2204917 */   // Label 28998: @2204917
     /* 2204917 */   GIM_Try, /*On fail goto*//*Label 28999*/ GIMT_Encode4(2205008), // Rule ID 65207 //
     /* 2204922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2204933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2204936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2204939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204968 */     // MIs[0] round
     /* 2204968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204971 */     // MIs[0] policy
     /* 2204971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204981 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2_MASK),
     /* 2204984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205007 */     // GIR_Coverage, 65207,
     /* 2205007 */     GIR_EraseRootFromParent_Done,
     /* 2205008 */   // Label 28999: @2205008
     /* 2205008 */   GIM_Try, /*On fail goto*//*Label 29000*/ GIMT_Encode4(2205099), // Rule ID 65210 //
     /* 2205013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2205021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2205024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2205027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2205030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2205036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2205043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205059 */     // MIs[0] round
     /* 2205059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205062 */     // MIs[0] policy
     /* 2205062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205072 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4_MASK),
     /* 2205075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205098 */     // GIR_Coverage, 65210,
     /* 2205098 */     GIR_EraseRootFromParent_Done,
     /* 2205099 */   // Label 29000: @2205099
     /* 2205099 */   GIM_Try, /*On fail goto*//*Label 29001*/ GIMT_Encode4(2205190), // Rule ID 65211 //
     /* 2205104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2205112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2205115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2205118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2205121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2205127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2205134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205150 */     // MIs[0] round
     /* 2205150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205153 */     // MIs[0] policy
     /* 2205153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205163 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4_MASK),
     /* 2205166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205189 */     // GIR_Coverage, 65211,
     /* 2205189 */     GIR_EraseRootFromParent_Done,
     /* 2205190 */   // Label 29001: @2205190
     /* 2205190 */   GIM_Try, /*On fail goto*//*Label 29002*/ GIMT_Encode4(2205281), // Rule ID 65214 //
     /* 2205195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2205203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2205206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2205209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2205212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2205218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2205225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205241 */     // MIs[0] round
     /* 2205241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205244 */     // MIs[0] policy
     /* 2205244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205254 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8_MASK),
     /* 2205257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205280 */     // GIR_Coverage, 65214,
     /* 2205280 */     GIR_EraseRootFromParent_Done,
     /* 2205281 */   // Label 29002: @2205281
     /* 2205281 */   GIM_Try, /*On fail goto*//*Label 29003*/ GIMT_Encode4(2205372), // Rule ID 65215 //
     /* 2205286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2205294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2205297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2205300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2205303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2205309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2205316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205332 */     // MIs[0] round
     /* 2205332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205335 */     // MIs[0] policy
     /* 2205335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205345 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8_MASK),
     /* 2205348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205371 */     // GIR_Coverage, 65215,
     /* 2205371 */     GIR_EraseRootFromParent_Done,
     /* 2205372 */   // Label 29003: @2205372
     /* 2205372 */   GIM_Try, /*On fail goto*//*Label 29004*/ GIMT_Encode4(2205463), // Rule ID 65218 //
     /* 2205377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2205388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2205391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2205394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2205400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205423 */     // MIs[0] round
     /* 2205423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205426 */     // MIs[0] policy
     /* 2205426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205436 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4_MASK),
     /* 2205439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205462 */     // GIR_Coverage, 65218,
     /* 2205462 */     GIR_EraseRootFromParent_Done,
     /* 2205463 */   // Label 29004: @2205463
     /* 2205463 */   GIM_Try, /*On fail goto*//*Label 29005*/ GIMT_Encode4(2205554), // Rule ID 65219 //
     /* 2205468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2205479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2205482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2205485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2205491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205514 */     // MIs[0] round
     /* 2205514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205517 */     // MIs[0] policy
     /* 2205517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205527 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4_MASK),
     /* 2205530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205553 */     // GIR_Coverage, 65219,
     /* 2205553 */     GIR_EraseRootFromParent_Done,
     /* 2205554 */   // Label 29005: @2205554
     /* 2205554 */   GIM_Try, /*On fail goto*//*Label 29006*/ GIMT_Encode4(2205645), // Rule ID 65222 //
     /* 2205559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2205570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2205573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2205576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2205582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205605 */     // MIs[0] round
     /* 2205605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205608 */     // MIs[0] policy
     /* 2205608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205618 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2_MASK),
     /* 2205621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205644 */     // GIR_Coverage, 65222,
     /* 2205644 */     GIR_EraseRootFromParent_Done,
     /* 2205645 */   // Label 29006: @2205645
     /* 2205645 */   GIM_Try, /*On fail goto*//*Label 29007*/ GIMT_Encode4(2205736), // Rule ID 65223 //
     /* 2205650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2205661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2205664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2205667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2205673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205696 */     // MIs[0] round
     /* 2205696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205699 */     // MIs[0] policy
     /* 2205699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205709 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2_MASK),
     /* 2205712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205735 */     // GIR_Coverage, 65223,
     /* 2205735 */     GIR_EraseRootFromParent_Done,
     /* 2205736 */   // Label 29007: @2205736
     /* 2205736 */   GIM_Try, /*On fail goto*//*Label 29008*/ GIMT_Encode4(2205827), // Rule ID 65226 //
     /* 2205741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2205752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2205755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2205758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2205764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205787 */     // MIs[0] round
     /* 2205787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205790 */     // MIs[0] policy
     /* 2205790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205800 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1_MASK),
     /* 2205803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205826 */     // GIR_Coverage, 65226,
     /* 2205826 */     GIR_EraseRootFromParent_Done,
     /* 2205827 */   // Label 29008: @2205827
     /* 2205827 */   GIM_Try, /*On fail goto*//*Label 29009*/ GIMT_Encode4(2205918), // Rule ID 65227 //
     /* 2205832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2205843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2205846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2205849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2205855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205878 */     // MIs[0] round
     /* 2205878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205881 */     // MIs[0] policy
     /* 2205881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205891 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1_MASK),
     /* 2205894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205917 */     // GIR_Coverage, 65227,
     /* 2205917 */     GIR_EraseRootFromParent_Done,
     /* 2205918 */   // Label 29009: @2205918
     /* 2205918 */   GIM_Try, /*On fail goto*//*Label 29010*/ GIMT_Encode4(2206009), // Rule ID 65230 //
     /* 2205923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2205934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2205937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2205940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2205946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2205953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205969 */     // MIs[0] round
     /* 2205969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205972 */     // MIs[0] policy
     /* 2205972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205982 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2_MASK),
     /* 2205985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206008 */     // GIR_Coverage, 65230,
     /* 2206008 */     GIR_EraseRootFromParent_Done,
     /* 2206009 */   // Label 29010: @2206009
     /* 2206009 */   GIM_Try, /*On fail goto*//*Label 29011*/ GIMT_Encode4(2206100), // Rule ID 65231 //
     /* 2206014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2206017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2206022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2206025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2206028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2206031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2206037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2206040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2206044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206060 */     // MIs[0] round
     /* 2206060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206063 */     // MIs[0] policy
     /* 2206063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206073 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2206073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2_MASK),
     /* 2206076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206099 */     // GIR_Coverage, 65231,
     /* 2206099 */     GIR_EraseRootFromParent_Done,
     /* 2206100 */   // Label 29011: @2206100
     /* 2206100 */   GIM_Try, /*On fail goto*//*Label 29012*/ GIMT_Encode4(2206191), // Rule ID 65234 //
     /* 2206105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2206108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2206113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2206116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2206119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2206122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2206128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2206131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2206135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206151 */     // MIs[0] round
     /* 2206151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206154 */     // MIs[0] policy
     /* 2206154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206164 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2206164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4_MASK),
     /* 2206167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206190 */     // GIR_Coverage, 65234,
     /* 2206190 */     GIR_EraseRootFromParent_Done,
     /* 2206191 */   // Label 29012: @2206191
     /* 2206191 */   GIM_Try, /*On fail goto*//*Label 29013*/ GIMT_Encode4(2206282), // Rule ID 65235 //
     /* 2206196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2206199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2206204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2206207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2206210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2206213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2206219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2206222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2206226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206242 */     // MIs[0] round
     /* 2206242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206245 */     // MIs[0] policy
     /* 2206245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206255 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2206255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4_MASK),
     /* 2206258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206281 */     // GIR_Coverage, 65235,
     /* 2206281 */     GIR_EraseRootFromParent_Done,
     /* 2206282 */   // Label 29013: @2206282
     /* 2206282 */   GIM_Try, /*On fail goto*//*Label 29014*/ GIMT_Encode4(2206373), // Rule ID 65238 //
     /* 2206287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2206290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2206295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2206298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2206301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2206304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2206310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2206313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2206317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2206321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2206325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206333 */     // MIs[0] round
     /* 2206333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206336 */     // MIs[0] policy
     /* 2206336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206346 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2206346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8_MASK),
     /* 2206349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206372 */     // GIR_Coverage, 65238,
     /* 2206372 */     GIR_EraseRootFromParent_Done,
     /* 2206373 */   // Label 29014: @2206373
     /* 2206373 */   GIM_Try, /*On fail goto*//*Label 29015*/ GIMT_Encode4(2206464), // Rule ID 65239 //
     /* 2206378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2206381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2206386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2206389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2206392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2206395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2206401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2206404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2206408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2206412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2206416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206424 */     // MIs[0] round
     /* 2206424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206427 */     // MIs[0] policy
     /* 2206427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206437 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2206437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8_MASK),
     /* 2206440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206463 */     // GIR_Coverage, 65239,
     /* 2206463 */     GIR_EraseRootFromParent_Done,
     /* 2206464 */   // Label 29015: @2206464
     /* 2206464 */   GIM_Reject,
     /* 2206465 */ // Label 26947: @2206465
     /* 2206465 */ GIM_Reject,
     /* 2206466 */ // Label 38: @2206466
     /* 2206466 */ GIM_Try, /*On fail goto*//*Label 29016*/ GIMT_Encode4(2206518),
     /* 2206471 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 2206474 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::riscv_pause),
     /* 2206479 */   GIM_Try, /*On fail goto*//*Label 29017*/ GIMT_Encode4(2206498), // Rule ID 307 //
     /* 2206484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZihintpause_HwMode0),
     /* 2206487 */     // (intrinsic_void 11094:{ *:[iPTR] })  =>  (FENCE 1:{ *:[i64] }, 0:{ *:[i64] })
     /* 2206487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /* 2206490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2206493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2206496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206497 */     // GIR_Coverage, 307,
     /* 2206497 */     GIR_EraseRootFromParent_Done,
     /* 2206498 */   // Label 29017: @2206498
     /* 2206498 */   GIM_Try, /*On fail goto*//*Label 29018*/ GIMT_Encode4(2206517), // Rule ID 308 //
     /* 2206503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZihintpause_HwMode1),
     /* 2206506 */     // (intrinsic_void 11094:{ *:[iPTR] })  =>  (FENCE 1:{ *:[i32] }, 0:{ *:[i32] })
     /* 2206506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /* 2206509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2206512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2206515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206516 */     // GIR_Coverage, 308,
     /* 2206516 */     GIR_EraseRootFromParent_Done,
     /* 2206517 */   // Label 29018: @2206517
     /* 2206517 */   GIM_Reject,
     /* 2206518 */ // Label 29016: @2206518
     /* 2206518 */ GIM_Try, /*On fail goto*//*Label 29019*/ GIMT_Encode4(2206601), // Rule ID 49 //
     /* 2206523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2206526 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 2206529 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 2206534 */   // MIs[0] Operand 1
     /* 2206534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 2206538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRX5RegClassID),
     /* 2206542 */   // MIs[0] ptr
     /* 2206542 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRJALRRegClassID),
     /* 2206550 */   // MIs[0] accessinfo
     /* 2206550 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 2206553 */   // (intrinsic_void 195:{ *:[iPTR] }, X5:{ *:[i64] }, GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 2206553 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 2206557 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X5), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206563 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X5
     /* 2206567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 2206570 */   GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 2206572 */   GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 2206574 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X1*/0,
     /* 2206577 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X6*/1,
     /* 2206580 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X7*/2,
     /* 2206583 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X28*/3,
     /* 2206586 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X29*/4,
     /* 2206589 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X30*/5,
     /* 2206592 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X31*/6,
     /* 2206595 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206599 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206600 */   // GIR_Coverage, 49,
     /* 2206600 */   GIR_EraseRootFromParent_Done,
     /* 2206601 */ // Label 29019: @2206601
     /* 2206601 */ GIM_Try, /*On fail goto*//*Label 29020*/ GIMT_Encode4(2207506),
     /* 2206606 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 2206609 */   GIM_Try, /*On fail goto*//*Label 29021*/ GIMT_Encode4(2206681), // Rule ID 641 //
     /* 2206614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i32),
     /* 2206622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206635 */     // MIs[0] addr
     /* 2206635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206651 */     // MIs[0] ordering
     /* 2206651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206654 */     // (intrinsic_w_chain:{ *:[i32] } 11071:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2206660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206662 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206667 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206669 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206671 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206673 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206680 */     // GIR_Coverage, 641,
     /* 2206680 */     GIR_EraseRootFromParent_Done,
     /* 2206681 */   // Label 29021: @2206681
     /* 2206681 */   GIM_Try, /*On fail goto*//*Label 29022*/ GIMT_Encode4(2206753), // Rule ID 642 //
     /* 2206686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i32),
     /* 2206694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206707 */     // MIs[0] addr
     /* 2206707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206723 */     // MIs[0] ordering
     /* 2206723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206726 */     // (intrinsic_w_chain:{ *:[i32] } 11057:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2206732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206734 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206739 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206741 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206743 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206745 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206752 */     // GIR_Coverage, 642,
     /* 2206752 */     GIR_EraseRootFromParent_Done,
     /* 2206753 */   // Label 29022: @2206753
     /* 2206753 */   GIM_Try, /*On fail goto*//*Label 29023*/ GIMT_Encode4(2206825), // Rule ID 643 //
     /* 2206758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i32),
     /* 2206766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206779 */     // MIs[0] addr
     /* 2206779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206795 */     // MIs[0] ordering
     /* 2206795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206798 */     // (intrinsic_w_chain:{ *:[i32] } 11065:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2206804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206806 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206811 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206813 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206815 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206817 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206824 */     // GIR_Coverage, 643,
     /* 2206824 */     GIR_EraseRootFromParent_Done,
     /* 2206825 */   // Label 29023: @2206825
     /* 2206825 */   GIM_Try, /*On fail goto*//*Label 29024*/ GIMT_Encode4(2206897), // Rule ID 644 //
     /* 2206830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i32),
     /* 2206838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206851 */     // MIs[0] addr
     /* 2206851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206867 */     // MIs[0] ordering
     /* 2206867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206870 */     // (intrinsic_w_chain:{ *:[i32] } 11063:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2206876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206878 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206883 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206885 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206887 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206889 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206896 */     // GIR_Coverage, 644,
     /* 2206896 */     GIR_EraseRootFromParent_Done,
     /* 2206897 */   // Label 29024: @2206897
     /* 2206897 */   GIM_Try, /*On fail goto*//*Label 29025*/ GIMT_Encode4(2206977), // Rule ID 647 //
     /* 2206902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i32),
     /* 2206910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206923 */     // MIs[0] addr
     /* 2206923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206939 */     // MIs[0] ordering
     /* 2206939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206942 */     // (intrinsic_w_chain:{ *:[i32] } 11067:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206942 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2206945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2206951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206953 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206958 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206963 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206965 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206967 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206969 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206976 */     // GIR_Coverage, 647,
     /* 2206976 */     GIR_EraseRootFromParent_Done,
     /* 2206977 */   // Label 29025: @2206977
     /* 2206977 */   GIM_Try, /*On fail goto*//*Label 29026*/ GIMT_Encode4(2207057), // Rule ID 648 //
     /* 2206982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i32),
     /* 2206990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207003 */     // MIs[0] addr
     /* 2207003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207019 */     // MIs[0] ordering
     /* 2207019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207022 */     // (intrinsic_w_chain:{ *:[i32] } 11069:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2207022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2207031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207033 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207038 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207043 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207045 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207047 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207049 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207056 */     // GIR_Coverage, 648,
     /* 2207056 */     GIR_EraseRootFromParent_Done,
     /* 2207057 */   // Label 29026: @2207057
     /* 2207057 */   GIM_Try, /*On fail goto*//*Label 29027*/ GIMT_Encode4(2207129), // Rule ID 654 //
     /* 2207062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i64),
     /* 2207070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207083 */     // MIs[0] addr
     /* 2207083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207099 */     // MIs[0] ordering
     /* 2207099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207102 */     // (intrinsic_w_chain:{ *:[i64] } 11072:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2207108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207110 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207115 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207117 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207119 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207121 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207128 */     // GIR_Coverage, 654,
     /* 2207128 */     GIR_EraseRootFromParent_Done,
     /* 2207129 */   // Label 29027: @2207129
     /* 2207129 */   GIM_Try, /*On fail goto*//*Label 29028*/ GIMT_Encode4(2207201), // Rule ID 655 //
     /* 2207134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i64),
     /* 2207142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207155 */     // MIs[0] addr
     /* 2207155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207171 */     // MIs[0] ordering
     /* 2207171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207174 */     // (intrinsic_w_chain:{ *:[i64] } 11058:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2207180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207182 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207187 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207189 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207191 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207193 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207200 */     // GIR_Coverage, 655,
     /* 2207200 */     GIR_EraseRootFromParent_Done,
     /* 2207201 */   // Label 29028: @2207201
     /* 2207201 */   GIM_Try, /*On fail goto*//*Label 29029*/ GIMT_Encode4(2207273), // Rule ID 656 //
     /* 2207206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i64),
     /* 2207214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207227 */     // MIs[0] addr
     /* 2207227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207243 */     // MIs[0] ordering
     /* 2207243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207246 */     // (intrinsic_w_chain:{ *:[i64] } 11066:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2207252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207254 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207259 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207261 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207263 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207265 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207272 */     // GIR_Coverage, 656,
     /* 2207272 */     GIR_EraseRootFromParent_Done,
     /* 2207273 */   // Label 29029: @2207273
     /* 2207273 */   GIM_Try, /*On fail goto*//*Label 29030*/ GIMT_Encode4(2207345), // Rule ID 657 //
     /* 2207278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i64),
     /* 2207286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207299 */     // MIs[0] addr
     /* 2207299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207315 */     // MIs[0] ordering
     /* 2207315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207318 */     // (intrinsic_w_chain:{ *:[i64] } 11064:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2207324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207326 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207331 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207333 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207335 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207337 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207344 */     // GIR_Coverage, 657,
     /* 2207344 */     GIR_EraseRootFromParent_Done,
     /* 2207345 */   // Label 29030: @2207345
     /* 2207345 */   GIM_Try, /*On fail goto*//*Label 29031*/ GIMT_Encode4(2207425), // Rule ID 660 //
     /* 2207350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i64),
     /* 2207358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207371 */     // MIs[0] addr
     /* 2207371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207387 */     // MIs[0] ordering
     /* 2207387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207390 */     // (intrinsic_w_chain:{ *:[i64] } 11068:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207390 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2207399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207401 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207406 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207411 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207413 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207415 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207417 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207424 */     // GIR_Coverage, 660,
     /* 2207424 */     GIR_EraseRootFromParent_Done,
     /* 2207425 */   // Label 29031: @2207425
     /* 2207425 */   GIM_Try, /*On fail goto*//*Label 29032*/ GIMT_Encode4(2207505), // Rule ID 661 //
     /* 2207430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i64),
     /* 2207438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207451 */     // MIs[0] addr
     /* 2207451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207467 */     // MIs[0] ordering
     /* 2207467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207470 */     // (intrinsic_w_chain:{ *:[i64] } 11070:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207470 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2207479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207481 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207486 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207491 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207493 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207495 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207497 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207504 */     // GIR_Coverage, 661,
     /* 2207504 */     GIR_EraseRootFromParent_Done,
     /* 2207505 */   // Label 29032: @2207505
     /* 2207505 */   GIM_Reject,
     /* 2207506 */ // Label 29020: @2207506
     /* 2207506 */ GIM_Try, /*On fail goto*//*Label 29033*/ GIMT_Encode4(2208033),
     /* 2207511 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 2207514 */   GIM_Try, /*On fail goto*//*Label 29034*/ GIMT_Encode4(2207603), // Rule ID 645 //
     /* 2207519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2207522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i32),
     /* 2207527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2207530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2207533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2207539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207543 */     // MIs[0] addr
     /* 2207543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207563 */     // MIs[0] ordering
     /* 2207563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207566 */     // (intrinsic_w_chain:{ *:[i32] } 11059:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2207566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2207575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207577 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207582 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207587 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207589 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207591 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207593 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207595 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207602 */     // GIR_Coverage, 645,
     /* 2207602 */     GIR_EraseRootFromParent_Done,
     /* 2207603 */   // Label 29034: @2207603
     /* 2207603 */   GIM_Try, /*On fail goto*//*Label 29035*/ GIMT_Encode4(2207692), // Rule ID 646 //
     /* 2207608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2207611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i32),
     /* 2207616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2207619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2207622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2207628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207632 */     // MIs[0] addr
     /* 2207632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207652 */     // MIs[0] ordering
     /* 2207652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207655 */     // (intrinsic_w_chain:{ *:[i32] } 11061:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2207655 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2207664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207666 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207671 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207676 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207678 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207680 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207682 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207684 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207691 */     // GIR_Coverage, 646,
     /* 2207691 */     GIR_EraseRootFromParent_Done,
     /* 2207692 */   // Label 29035: @2207692
     /* 2207692 */   GIM_Try, /*On fail goto*//*Label 29036*/ GIMT_Encode4(2207781), // Rule ID 658 //
     /* 2207697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i64),
     /* 2207705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2207717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207721 */     // MIs[0] addr
     /* 2207721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207741 */     // MIs[0] ordering
     /* 2207741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207744 */     // (intrinsic_w_chain:{ *:[i64] } 11060:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2207744 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2207753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207755 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207760 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207765 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207767 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207769 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207771 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207773 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207780 */     // GIR_Coverage, 658,
     /* 2207780 */     GIR_EraseRootFromParent_Done,
     /* 2207781 */   // Label 29036: @2207781
     /* 2207781 */   GIM_Try, /*On fail goto*//*Label 29037*/ GIMT_Encode4(2207870), // Rule ID 659 //
     /* 2207786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i64),
     /* 2207794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2207806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207810 */     // MIs[0] addr
     /* 2207810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207830 */     // MIs[0] ordering
     /* 2207830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207833 */     // (intrinsic_w_chain:{ *:[i64] } 11062:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2207833 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2207842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207844 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207849 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207854 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207856 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207858 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207860 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207862 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207869 */     // GIR_Coverage, 659,
     /* 2207869 */     GIR_EraseRootFromParent_Done,
     /* 2207870 */   // Label 29037: @2207870
     /* 2207870 */   GIM_Try, /*On fail goto*//*Label 29038*/ GIMT_Encode4(2207951), // Rule ID 677 //
     /* 2207875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2207878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i32),
     /* 2207883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2207886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2207889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2207895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207899 */     // MIs[0] addr
     /* 2207899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207919 */     // MIs[0] ordering
     /* 2207919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207922 */     // (intrinsic_w_chain:{ *:[i32] } 11073:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2207922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2207928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207930 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207935 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207937 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2207939 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2207941 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2207943 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207950 */     // GIR_Coverage, 677,
     /* 2207950 */     GIR_EraseRootFromParent_Done,
     /* 2207951 */   // Label 29038: @2207951
     /* 2207951 */   GIM_Try, /*On fail goto*//*Label 29039*/ GIMT_Encode4(2208032), // Rule ID 678 //
     /* 2207956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i64),
     /* 2207964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2207976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207980 */     // MIs[0] addr
     /* 2207980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2208000 */     // MIs[0] ordering
     /* 2208000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2208003 */     // (intrinsic_w_chain:{ *:[i64] } 11074:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2208003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2208006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2208009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2208011 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2208016 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2208018 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2208020 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2208022 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2208024 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2208026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2208030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208031 */     // GIR_Coverage, 678,
     /* 2208031 */     GIR_EraseRootFromParent_Done,
     /* 2208032 */   // Label 29039: @2208032
     /* 2208032 */   GIM_Reject,
     /* 2208033 */ // Label 29033: @2208033
     /* 2208033 */ GIM_Reject,
     /* 2208034 */ // Label 39: @2208034
     /* 2208034 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(32), /*)*//*default:*//*Label 29055*/ GIMT_Encode4(2211154),
     /* 2208045 */ /*GILLT_nxv1s16*//*Label 29040*/ GIMT_Encode4(2208145),
     /* 2208049 */ /*GILLT_nxv1s32*//*Label 29041*/ GIMT_Encode4(2208249),
     /* 2208053 */ /*GILLT_nxv1s64*//*Label 29042*/ GIMT_Encode4(2208466), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2208065 */ /*GILLT_nxv2s16*//*Label 29043*/ GIMT_Encode4(2208791),
     /* 2208069 */ /*GILLT_nxv2s32*//*Label 29044*/ GIMT_Encode4(2208895),
     /* 2208073 */ /*GILLT_nxv2s64*//*Label 29045*/ GIMT_Encode4(2209112), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2208085 */ /*GILLT_nxv4s16*//*Label 29046*/ GIMT_Encode4(2209437),
     /* 2208089 */ /*GILLT_nxv4s32*//*Label 29047*/ GIMT_Encode4(2209541),
     /* 2208093 */ /*GILLT_nxv4s64*//*Label 29048*/ GIMT_Encode4(2209758), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2208105 */ /*GILLT_nxv8s16*//*Label 29049*/ GIMT_Encode4(2210083),
     /* 2208109 */ /*GILLT_nxv8s32*//*Label 29050*/ GIMT_Encode4(2210187),
     /* 2208113 */ /*GILLT_nxv8s64*//*Label 29051*/ GIMT_Encode4(2210404), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2208125 */ /*GILLT_nxv16s16*//*Label 29052*/ GIMT_Encode4(2210729),
     /* 2208129 */ /*GILLT_nxv16s32*//*Label 29053*/ GIMT_Encode4(2210833), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2208141 */ /*GILLT_nxv32s16*//*Label 29054*/ GIMT_Encode4(2211050),
     /* 2208145 */ // Label 29040: @2208145
     /* 2208145 */ GIM_Try, /*On fail goto*//*Label 29056*/ GIMT_Encode4(2208248),
     /* 2208150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208161 */   GIM_Try, /*On fail goto*//*Label 29057*/ GIMT_Encode4(2208204), // Rule ID 47498 //
     /* 2208166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208169 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2208172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2208186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208203 */     // GIR_Coverage, 47498,
     /* 2208203 */     GIR_EraseRootFromParent_Done,
     /* 2208204 */   // Label 29057: @2208204
     /* 2208204 */   GIM_Try, /*On fail goto*//*Label 29058*/ GIMT_Encode4(2208247), // Rule ID 47499 //
     /* 2208209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208212 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2208215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2208229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208246 */     // GIR_Coverage, 47499,
     /* 2208246 */     GIR_EraseRootFromParent_Done,
     /* 2208247 */   // Label 29058: @2208247
     /* 2208247 */   GIM_Reject,
     /* 2208248 */ // Label 29056: @2208248
     /* 2208248 */ GIM_Reject,
     /* 2208249 */ // Label 29041: @2208249
     /* 2208249 */ GIM_Try, /*On fail goto*//*Label 29059*/ GIMT_Encode4(2208303), // Rule ID 47522 //
     /* 2208254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2208260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208268 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2208271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2208285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208290 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208302 */   // GIR_Coverage, 47522,
     /* 2208302 */   GIR_EraseRootFromParent_Done,
     /* 2208303 */ // Label 29059: @2208303
     /* 2208303 */ GIM_Try, /*On fail goto*//*Label 29060*/ GIMT_Encode4(2208357), // Rule ID 47523 //
     /* 2208308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2208314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208322 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2208325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2208339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208344 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208356 */   // GIR_Coverage, 47523,
     /* 2208356 */   GIR_EraseRootFromParent_Done,
     /* 2208357 */ // Label 29060: @2208357
     /* 2208357 */ GIM_Try, /*On fail goto*//*Label 29061*/ GIMT_Encode4(2208411), // Rule ID 47588 //
     /* 2208362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208376 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2208379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2208393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208398 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208409 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208410 */   // GIR_Coverage, 47588,
     /* 2208410 */   GIR_EraseRootFromParent_Done,
     /* 2208411 */ // Label 29061: @2208411
     /* 2208411 */ GIM_Try, /*On fail goto*//*Label 29062*/ GIMT_Encode4(2208465), // Rule ID 47589 //
     /* 2208416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208430 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2208433 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208437 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2208447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208449 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208452 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208463 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208464 */   // GIR_Coverage, 47589,
     /* 2208464 */   GIR_EraseRootFromParent_Done,
     /* 2208465 */ // Label 29062: @2208465
     /* 2208465 */ GIM_Reject,
     /* 2208466 */ // Label 29042: @2208466
     /* 2208466 */ GIM_Try, /*On fail goto*//*Label 29063*/ GIMT_Encode4(2208520), // Rule ID 47542 //
     /* 2208471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2208477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208485 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208507 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208518 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208519 */   // GIR_Coverage, 47542,
     /* 2208519 */   GIR_EraseRootFromParent_Done,
     /* 2208520 */ // Label 29063: @2208520
     /* 2208520 */ GIM_Try, /*On fail goto*//*Label 29064*/ GIMT_Encode4(2208574), // Rule ID 47543 //
     /* 2208525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2208531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208539 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208558 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208561 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208572 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208573 */   // GIR_Coverage, 47543,
     /* 2208573 */   GIR_EraseRootFromParent_Done,
     /* 2208574 */ // Label 29064: @2208574
     /* 2208574 */ GIM_Try, /*On fail goto*//*Label 29065*/ GIMT_Encode4(2208628), // Rule ID 47608 //
     /* 2208579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2208585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208593 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208593 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208596 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208600 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2208610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208612 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208615 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208626 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208627 */   // GIR_Coverage, 47608,
     /* 2208627 */   GIR_EraseRootFromParent_Done,
     /* 2208628 */ // Label 29065: @2208628
     /* 2208628 */ GIM_Try, /*On fail goto*//*Label 29066*/ GIMT_Encode4(2208682), // Rule ID 47609 //
     /* 2208633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2208639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208647 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208647 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208650 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208654 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2208664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208669 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208680 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208681 */   // GIR_Coverage, 47609,
     /* 2208681 */   GIR_EraseRootFromParent_Done,
     /* 2208682 */ // Label 29066: @2208682
     /* 2208682 */ GIM_Try, /*On fail goto*//*Label 29067*/ GIMT_Encode4(2208736), // Rule ID 47642 //
     /* 2208687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208701 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208701 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208704 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208708 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2208718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208723 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208734 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208735 */   // GIR_Coverage, 47642,
     /* 2208735 */   GIR_EraseRootFromParent_Done,
     /* 2208736 */ // Label 29067: @2208736
     /* 2208736 */ GIM_Try, /*On fail goto*//*Label 29068*/ GIMT_Encode4(2208790), // Rule ID 47643 //
     /* 2208741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208755 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2208772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208774 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208777 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208788 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208789 */   // GIR_Coverage, 47643,
     /* 2208789 */   GIR_EraseRootFromParent_Done,
     /* 2208790 */ // Label 29068: @2208790
     /* 2208790 */ GIM_Reject,
     /* 2208791 */ // Label 29043: @2208791
     /* 2208791 */ GIM_Try, /*On fail goto*//*Label 29069*/ GIMT_Encode4(2208894),
     /* 2208796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2208799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208807 */   GIM_Try, /*On fail goto*//*Label 29070*/ GIMT_Encode4(2208850), // Rule ID 47502 //
     /* 2208812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208815 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2208818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2208832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208849 */     // GIR_Coverage, 47502,
     /* 2208849 */     GIR_EraseRootFromParent_Done,
     /* 2208850 */   // Label 29070: @2208850
     /* 2208850 */   GIM_Try, /*On fail goto*//*Label 29071*/ GIMT_Encode4(2208893), // Rule ID 47503 //
     /* 2208855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208858 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2208861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2208875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208892 */     // GIR_Coverage, 47503,
     /* 2208892 */     GIR_EraseRootFromParent_Done,
     /* 2208893 */   // Label 29071: @2208893
     /* 2208893 */   GIM_Reject,
     /* 2208894 */ // Label 29069: @2208894
     /* 2208894 */ GIM_Reject,
     /* 2208895 */ // Label 29044: @2208895
     /* 2208895 */ GIM_Try, /*On fail goto*//*Label 29072*/ GIMT_Encode4(2208949), // Rule ID 47526 //
     /* 2208900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208914 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208936 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208947 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208948 */   // GIR_Coverage, 47526,
     /* 2208948 */   GIR_EraseRootFromParent_Done,
     /* 2208949 */ // Label 29072: @2208949
     /* 2208949 */ GIM_Try, /*On fail goto*//*Label 29073*/ GIMT_Encode4(2209003), // Rule ID 47527 //
     /* 2208954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208968 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208990 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209001 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209002 */   // GIR_Coverage, 47527,
     /* 2209002 */   GIR_EraseRootFromParent_Done,
     /* 2209003 */ // Label 29073: @2209003
     /* 2209003 */ GIM_Try, /*On fail goto*//*Label 29074*/ GIMT_Encode4(2209057), // Rule ID 47592 //
     /* 2209008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2209014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209022 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209022 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2209025 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209029 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2209039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209044 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209055 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209056 */   // GIR_Coverage, 47592,
     /* 2209056 */   GIR_EraseRootFromParent_Done,
     /* 2209057 */ // Label 29074: @2209057
     /* 2209057 */ GIM_Try, /*On fail goto*//*Label 29075*/ GIMT_Encode4(2209111), // Rule ID 47593 //
     /* 2209062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2209068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209076 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2209079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2209093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209098 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209109 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209110 */   // GIR_Coverage, 47593,
     /* 2209110 */   GIR_EraseRootFromParent_Done,
     /* 2209111 */ // Label 29075: @2209111
     /* 2209111 */ GIM_Reject,
     /* 2209112 */ // Label 29045: @2209112
     /* 2209112 */ GIM_Try, /*On fail goto*//*Label 29076*/ GIMT_Encode4(2209166), // Rule ID 47546 //
     /* 2209117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2209123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209131 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209131 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2209134 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209138 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209153 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209165 */   // GIR_Coverage, 47546,
     /* 2209165 */   GIR_EraseRootFromParent_Done,
     /* 2209166 */ // Label 29076: @2209166
     /* 2209166 */ GIM_Try, /*On fail goto*//*Label 29077*/ GIMT_Encode4(2209220), // Rule ID 47547 //
     /* 2209171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2209177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209185 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209185 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2209188 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209192 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209207 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209218 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209219 */   // GIR_Coverage, 47547,
     /* 2209219 */   GIR_EraseRootFromParent_Done,
     /* 2209220 */ // Label 29077: @2209220
     /* 2209220 */ GIM_Try, /*On fail goto*//*Label 29078*/ GIMT_Encode4(2209274), // Rule ID 47612 //
     /* 2209225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2209231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209239 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209239 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2209242 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209246 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2209256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209261 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209272 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209273 */   // GIR_Coverage, 47612,
     /* 2209273 */   GIR_EraseRootFromParent_Done,
     /* 2209274 */ // Label 29078: @2209274
     /* 2209274 */ GIM_Try, /*On fail goto*//*Label 29079*/ GIMT_Encode4(2209328), // Rule ID 47613 //
     /* 2209279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2209285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209293 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2209296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2209310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209315 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209326 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209327 */   // GIR_Coverage, 47613,
     /* 2209327 */   GIR_EraseRootFromParent_Done,
     /* 2209328 */ // Label 29079: @2209328
     /* 2209328 */ GIM_Try, /*On fail goto*//*Label 29080*/ GIMT_Encode4(2209382), // Rule ID 47646 //
     /* 2209333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2209339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209347 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209347 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2209350 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209354 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2209364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209366 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209369 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209380 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209381 */   // GIR_Coverage, 47646,
     /* 2209381 */   GIR_EraseRootFromParent_Done,
     /* 2209382 */ // Label 29080: @2209382
     /* 2209382 */ GIM_Try, /*On fail goto*//*Label 29081*/ GIMT_Encode4(2209436), // Rule ID 47647 //
     /* 2209387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2209393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209401 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2209404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2209418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209420 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209423 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209434 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209435 */   // GIR_Coverage, 47647,
     /* 2209435 */   GIR_EraseRootFromParent_Done,
     /* 2209436 */ // Label 29081: @2209436
     /* 2209436 */ GIM_Reject,
     /* 2209437 */ // Label 29046: @2209437
     /* 2209437 */ GIM_Try, /*On fail goto*//*Label 29082*/ GIMT_Encode4(2209540),
     /* 2209442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209453 */   GIM_Try, /*On fail goto*//*Label 29083*/ GIMT_Encode4(2209496), // Rule ID 47506 //
     /* 2209458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209461 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2209464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2209478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209495 */     // GIR_Coverage, 47506,
     /* 2209495 */     GIR_EraseRootFromParent_Done,
     /* 2209496 */   // Label 29083: @2209496
     /* 2209496 */   GIM_Try, /*On fail goto*//*Label 29084*/ GIMT_Encode4(2209539), // Rule ID 47507 //
     /* 2209501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209504 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2209507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2209521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209538 */     // GIR_Coverage, 47507,
     /* 2209538 */     GIR_EraseRootFromParent_Done,
     /* 2209539 */   // Label 29084: @2209539
     /* 2209539 */   GIM_Reject,
     /* 2209540 */ // Label 29082: @2209540
     /* 2209540 */ GIM_Reject,
     /* 2209541 */ // Label 29047: @2209541
     /* 2209541 */ GIM_Try, /*On fail goto*//*Label 29085*/ GIMT_Encode4(2209595), // Rule ID 47530 //
     /* 2209546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209560 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209582 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209593 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209594 */   // GIR_Coverage, 47530,
     /* 2209594 */   GIR_EraseRootFromParent_Done,
     /* 2209595 */ // Label 29085: @2209595
     /* 2209595 */ GIM_Try, /*On fail goto*//*Label 29086*/ GIMT_Encode4(2209649), // Rule ID 47531 //
     /* 2209600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209614 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209633 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209636 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209647 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209648 */   // GIR_Coverage, 47531,
     /* 2209648 */   GIR_EraseRootFromParent_Done,
     /* 2209649 */ // Label 29086: @2209649
     /* 2209649 */ GIM_Try, /*On fail goto*//*Label 29087*/ GIMT_Encode4(2209703), // Rule ID 47596 //
     /* 2209654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209668 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209668 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209671 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209675 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2209685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209687 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209690 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209701 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209702 */   // GIR_Coverage, 47596,
     /* 2209702 */   GIR_EraseRootFromParent_Done,
     /* 2209703 */ // Label 29087: @2209703
     /* 2209703 */ GIM_Try, /*On fail goto*//*Label 29088*/ GIMT_Encode4(2209757), // Rule ID 47597 //
     /* 2209708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209722 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209722 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209725 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209729 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2209739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209744 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209755 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209756 */   // GIR_Coverage, 47597,
     /* 2209756 */   GIR_EraseRootFromParent_Done,
     /* 2209757 */ // Label 29088: @2209757
     /* 2209757 */ GIM_Reject,
     /* 2209758 */ // Label 29048: @2209758
     /* 2209758 */ GIM_Try, /*On fail goto*//*Label 29089*/ GIMT_Encode4(2209812), // Rule ID 47550 //
     /* 2209763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209777 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209777 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209780 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209784 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2209794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209796 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209799 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209811 */   // GIR_Coverage, 47550,
     /* 2209811 */   GIR_EraseRootFromParent_Done,
     /* 2209812 */ // Label 29089: @2209812
     /* 2209812 */ GIM_Try, /*On fail goto*//*Label 29090*/ GIMT_Encode4(2209866), // Rule ID 47551 //
     /* 2209817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209831 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2209848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209853 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209864 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209865 */   // GIR_Coverage, 47551,
     /* 2209865 */   GIR_EraseRootFromParent_Done,
     /* 2209866 */ // Label 29090: @2209866
     /* 2209866 */ GIM_Try, /*On fail goto*//*Label 29091*/ GIMT_Encode4(2209920), // Rule ID 47616 //
     /* 2209871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209885 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2209902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209904 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209907 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209919 */   // GIR_Coverage, 47616,
     /* 2209919 */   GIR_EraseRootFromParent_Done,
     /* 2209920 */ // Label 29091: @2209920
     /* 2209920 */ GIM_Try, /*On fail goto*//*Label 29092*/ GIMT_Encode4(2209974), // Rule ID 47617 //
     /* 2209925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209939 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209939 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209942 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209946 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2209956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209961 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209973 */   // GIR_Coverage, 47617,
     /* 2209973 */   GIR_EraseRootFromParent_Done,
     /* 2209974 */ // Label 29092: @2209974
     /* 2209974 */ GIM_Try, /*On fail goto*//*Label 29093*/ GIMT_Encode4(2210028), // Rule ID 47650 //
     /* 2209979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209993 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2210010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210012 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210015 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210026 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210027 */   // GIR_Coverage, 47650,
     /* 2210027 */   GIR_EraseRootFromParent_Done,
     /* 2210028 */ // Label 29093: @2210028
     /* 2210028 */ GIM_Try, /*On fail goto*//*Label 29094*/ GIMT_Encode4(2210082), // Rule ID 47651 //
     /* 2210033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2210039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210047 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2210050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2210064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210066 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210069 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210080 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210081 */   // GIR_Coverage, 47651,
     /* 2210081 */   GIR_EraseRootFromParent_Done,
     /* 2210082 */ // Label 29094: @2210082
     /* 2210082 */ GIM_Reject,
     /* 2210083 */ // Label 29049: @2210083
     /* 2210083 */ GIM_Try, /*On fail goto*//*Label 29095*/ GIMT_Encode4(2210186),
     /* 2210088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210099 */   GIM_Try, /*On fail goto*//*Label 29096*/ GIMT_Encode4(2210142), // Rule ID 47510 //
     /* 2210104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210107 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2210110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2210124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210141 */     // GIR_Coverage, 47510,
     /* 2210141 */     GIR_EraseRootFromParent_Done,
     /* 2210142 */   // Label 29096: @2210142
     /* 2210142 */   GIM_Try, /*On fail goto*//*Label 29097*/ GIMT_Encode4(2210185), // Rule ID 47511 //
     /* 2210147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210150 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2210153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2210167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210184 */     // GIR_Coverage, 47511,
     /* 2210184 */     GIR_EraseRootFromParent_Done,
     /* 2210185 */   // Label 29097: @2210185
     /* 2210185 */   GIM_Reject,
     /* 2210186 */ // Label 29095: @2210186
     /* 2210186 */ GIM_Reject,
     /* 2210187 */ // Label 29050: @2210187
     /* 2210187 */ GIM_Try, /*On fail goto*//*Label 29098*/ GIMT_Encode4(2210241), // Rule ID 47534 //
     /* 2210192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210206 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210206 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2210209 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210213 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2210223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210228 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210239 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210240 */   // GIR_Coverage, 47534,
     /* 2210240 */   GIR_EraseRootFromParent_Done,
     /* 2210241 */ // Label 29098: @2210241
     /* 2210241 */ GIM_Try, /*On fail goto*//*Label 29099*/ GIMT_Encode4(2210295), // Rule ID 47535 //
     /* 2210246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210260 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2210263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210272 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2210277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210279 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210282 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210293 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210294 */   // GIR_Coverage, 47535,
     /* 2210294 */   GIR_EraseRootFromParent_Done,
     /* 2210295 */ // Label 29099: @2210295
     /* 2210295 */ GIM_Try, /*On fail goto*//*Label 29100*/ GIMT_Encode4(2210349), // Rule ID 47600 //
     /* 2210300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210314 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210314 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2210317 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210321 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2210331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210336 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210348 */   // GIR_Coverage, 47600,
     /* 2210348 */   GIR_EraseRootFromParent_Done,
     /* 2210349 */ // Label 29100: @2210349
     /* 2210349 */ GIM_Try, /*On fail goto*//*Label 29101*/ GIMT_Encode4(2210403), // Rule ID 47601 //
     /* 2210354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210368 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2210371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2210385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210390 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210401 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210402 */   // GIR_Coverage, 47601,
     /* 2210402 */   GIR_EraseRootFromParent_Done,
     /* 2210403 */ // Label 29101: @2210403
     /* 2210403 */ GIM_Reject,
     /* 2210404 */ // Label 29051: @2210404
     /* 2210404 */ GIM_Try, /*On fail goto*//*Label 29102*/ GIMT_Encode4(2210458), // Rule ID 47554 //
     /* 2210409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2210412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2210415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210423 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210445 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210456 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210457 */   // GIR_Coverage, 47554,
     /* 2210457 */   GIR_EraseRootFromParent_Done,
     /* 2210458 */ // Label 29102: @2210458
     /* 2210458 */ GIM_Try, /*On fail goto*//*Label 29103*/ GIMT_Encode4(2210512), // Rule ID 47555 //
     /* 2210463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2210469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210477 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210499 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210511 */   // GIR_Coverage, 47555,
     /* 2210511 */   GIR_EraseRootFromParent_Done,
     /* 2210512 */ // Label 29103: @2210512
     /* 2210512 */ GIM_Try, /*On fail goto*//*Label 29104*/ GIMT_Encode4(2210566), // Rule ID 47620 //
     /* 2210517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2210520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210531 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210553 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210564 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210565 */   // GIR_Coverage, 47620,
     /* 2210565 */   GIR_EraseRootFromParent_Done,
     /* 2210566 */ // Label 29104: @2210566
     /* 2210566 */ GIM_Try, /*On fail goto*//*Label 29105*/ GIMT_Encode4(2210620), // Rule ID 47621 //
     /* 2210571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210585 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210607 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210619 */   // GIR_Coverage, 47621,
     /* 2210619 */   GIR_EraseRootFromParent_Done,
     /* 2210620 */ // Label 29105: @2210620
     /* 2210620 */ GIM_Try, /*On fail goto*//*Label 29106*/ GIMT_Encode4(2210674), // Rule ID 47654 //
     /* 2210625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2210628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210639 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2210656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210661 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210672 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210673 */   // GIR_Coverage, 47654,
     /* 2210673 */   GIR_EraseRootFromParent_Done,
     /* 2210674 */ // Label 29106: @2210674
     /* 2210674 */ GIM_Try, /*On fail goto*//*Label 29107*/ GIMT_Encode4(2210728), // Rule ID 47655 //
     /* 2210679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210693 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2210710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210715 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210726 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210727 */   // GIR_Coverage, 47655,
     /* 2210727 */   GIR_EraseRootFromParent_Done,
     /* 2210728 */ // Label 29107: @2210728
     /* 2210728 */ GIM_Reject,
     /* 2210729 */ // Label 29052: @2210729
     /* 2210729 */ GIM_Try, /*On fail goto*//*Label 29108*/ GIMT_Encode4(2210832),
     /* 2210734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2210737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210745 */   GIM_Try, /*On fail goto*//*Label 29109*/ GIMT_Encode4(2210788), // Rule ID 47514 //
     /* 2210750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210753 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2210756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2210770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210787 */     // GIR_Coverage, 47514,
     /* 2210787 */     GIR_EraseRootFromParent_Done,
     /* 2210788 */   // Label 29109: @2210788
     /* 2210788 */   GIM_Try, /*On fail goto*//*Label 29110*/ GIMT_Encode4(2210831), // Rule ID 47515 //
     /* 2210793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210796 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2210799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2210813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210830 */     // GIR_Coverage, 47515,
     /* 2210830 */     GIR_EraseRootFromParent_Done,
     /* 2210831 */   // Label 29110: @2210831
     /* 2210831 */   GIM_Reject,
     /* 2210832 */ // Label 29108: @2210832
     /* 2210832 */ GIM_Reject,
     /* 2210833 */ // Label 29053: @2210833
     /* 2210833 */ GIM_Try, /*On fail goto*//*Label 29111*/ GIMT_Encode4(2210887), // Rule ID 47538 //
     /* 2210838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2210844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210852 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210852 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210855 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210859 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210871 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210874 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210885 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210886 */   // GIR_Coverage, 47538,
     /* 2210886 */   GIR_EraseRootFromParent_Done,
     /* 2210887 */ // Label 29111: @2210887
     /* 2210887 */ GIM_Try, /*On fail goto*//*Label 29112*/ GIMT_Encode4(2210941), // Rule ID 47539 //
     /* 2210892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2210898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210906 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210906 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210909 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210913 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210925 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210928 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210940 */   // GIR_Coverage, 47539,
     /* 2210940 */   GIR_EraseRootFromParent_Done,
     /* 2210941 */ // Label 29112: @2210941
     /* 2210941 */ GIM_Try, /*On fail goto*//*Label 29113*/ GIMT_Encode4(2210995), // Rule ID 47604 //
     /* 2210946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2210952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210960 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210982 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210993 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210994 */   // GIR_Coverage, 47604,
     /* 2210994 */   GIR_EraseRootFromParent_Done,
     /* 2210995 */ // Label 29113: @2210995
     /* 2210995 */ GIM_Try, /*On fail goto*//*Label 29114*/ GIMT_Encode4(2211049), // Rule ID 47605 //
     /* 2211000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2211006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2211010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211014 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211014 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2211017 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211021 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2211031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211036 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211047 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211048 */   // GIR_Coverage, 47605,
     /* 2211048 */   GIR_EraseRootFromParent_Done,
     /* 2211049 */ // Label 29114: @2211049
     /* 2211049 */ GIM_Reject,
     /* 2211050 */ // Label 29054: @2211050
     /* 2211050 */ GIM_Try, /*On fail goto*//*Label 29115*/ GIMT_Encode4(2211153),
     /* 2211055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2211058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2211062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211066 */   GIM_Try, /*On fail goto*//*Label 29116*/ GIMT_Encode4(2211109), // Rule ID 47518 //
     /* 2211071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211074 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2211077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2211091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211108 */     // GIR_Coverage, 47518,
     /* 2211108 */     GIR_EraseRootFromParent_Done,
     /* 2211109 */   // Label 29116: @2211109
     /* 2211109 */   GIM_Try, /*On fail goto*//*Label 29117*/ GIMT_Encode4(2211152), // Rule ID 47519 //
     /* 2211114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211117 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2211120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2211134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211151 */     // GIR_Coverage, 47519,
     /* 2211151 */     GIR_EraseRootFromParent_Done,
     /* 2211152 */   // Label 29117: @2211152
     /* 2211152 */   GIM_Reject,
     /* 2211153 */ // Label 29115: @2211153
     /* 2211153 */ GIM_Reject,
     /* 2211154 */ // Label 29055: @2211154
     /* 2211154 */ GIM_Reject,
     /* 2211155 */ // Label 40: @2211155
     /* 2211155 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 29135*/ GIMT_Encode4(2214629),
     /* 2211166 */ /*GILLT_s32*//*Label 29118*/ GIMT_Encode4(2211282),
     /* 2211170 */ /*GILLT_s64*//*Label 29119*/ GIMT_Encode4(2211456), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211182 */ /*GILLT_nxv1s16*//*Label 29120*/ GIMT_Encode4(2211620),
     /* 2211186 */ /*GILLT_nxv1s32*//*Label 29121*/ GIMT_Encode4(2211724),
     /* 2211190 */ /*GILLT_nxv1s64*//*Label 29122*/ GIMT_Encode4(2211941), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211202 */ /*GILLT_nxv2s16*//*Label 29123*/ GIMT_Encode4(2212266),
     /* 2211206 */ /*GILLT_nxv2s32*//*Label 29124*/ GIMT_Encode4(2212370),
     /* 2211210 */ /*GILLT_nxv2s64*//*Label 29125*/ GIMT_Encode4(2212587), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211222 */ /*GILLT_nxv4s16*//*Label 29126*/ GIMT_Encode4(2212912),
     /* 2211226 */ /*GILLT_nxv4s32*//*Label 29127*/ GIMT_Encode4(2213016),
     /* 2211230 */ /*GILLT_nxv4s64*//*Label 29128*/ GIMT_Encode4(2213233), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211242 */ /*GILLT_nxv8s16*//*Label 29129*/ GIMT_Encode4(2213558),
     /* 2211246 */ /*GILLT_nxv8s32*//*Label 29130*/ GIMT_Encode4(2213662),
     /* 2211250 */ /*GILLT_nxv8s64*//*Label 29131*/ GIMT_Encode4(2213879), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211262 */ /*GILLT_nxv16s16*//*Label 29132*/ GIMT_Encode4(2214204),
     /* 2211266 */ /*GILLT_nxv16s32*//*Label 29133*/ GIMT_Encode4(2214308), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211278 */ /*GILLT_nxv32s16*//*Label 29134*/ GIMT_Encode4(2214525),
     /* 2211282 */ // Label 29118: @2211282
     /* 2211282 */ GIM_Try, /*On fail goto*//*Label 29136*/ GIMT_Encode4(2211455),
     /* 2211287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211298 */   GIM_Try, /*On fail goto*//*Label 29137*/ GIMT_Encode4(2211340), // Rule ID 65476 //
     /* 2211303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode1),
     /* 2211306 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2211306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2211309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211322 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2211325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2211338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211339 */     // GIR_Coverage, 65476,
     /* 2211339 */     GIR_EraseRootFromParent_Done,
     /* 2211340 */   // Label 29137: @2211340
     /* 2211340 */   GIM_Try, /*On fail goto*//*Label 29138*/ GIMT_Encode4(2211382), // Rule ID 65478 //
     /* 2211345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2211348 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2211348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2211351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211364 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2211367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2211380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211381 */     // GIR_Coverage, 65478,
     /* 2211381 */     GIR_EraseRootFromParent_Done,
     /* 2211382 */   // Label 29138: @2211382
     /* 2211382 */   GIM_Try, /*On fail goto*//*Label 29139*/ GIMT_Encode4(2211424), // Rule ID 65479 //
     /* 2211387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode1),
     /* 2211390 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2211390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2211393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211406 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2211409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2211422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211423 */     // GIR_Coverage, 65479,
     /* 2211423 */     GIR_EraseRootFromParent_Done,
     /* 2211424 */   // Label 29139: @2211424
     /* 2211424 */   GIM_Try, /*On fail goto*//*Label 29140*/ GIMT_Encode4(2211439), // Rule ID 65481 //
     /* 2211429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2211432 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2211432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2211437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211438 */     // GIR_Coverage, 65481,
     /* 2211438 */     GIR_Done,
     /* 2211439 */   // Label 29140: @2211439
     /* 2211439 */   GIM_Try, /*On fail goto*//*Label 29141*/ GIMT_Encode4(2211454), // Rule ID 65482 //
     /* 2211444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2211447 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2211447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2211452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211453 */     // GIR_Coverage, 65482,
     /* 2211453 */     GIR_Done,
     /* 2211454 */   // Label 29141: @2211454
     /* 2211454 */   GIM_Reject,
     /* 2211455 */ // Label 29136: @2211455
     /* 2211455 */ GIM_Reject,
     /* 2211456 */ // Label 29119: @2211456
     /* 2211456 */ GIM_Try, /*On fail goto*//*Label 29142*/ GIMT_Encode4(2211487), // Rule ID 65466 //
     /* 2211461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2211464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2211467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211475 */   // (sext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i32] }:$src, 0:{ *:[i64] })
     /* 2211475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2211478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211480 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2211482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2211485 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211486 */   // GIR_Coverage, 65466,
     /* 2211486 */   GIR_EraseRootFromParent_Done,
     /* 2211487 */ // Label 29142: @2211487
     /* 2211487 */ GIM_Try, /*On fail goto*//*Label 29143*/ GIMT_Encode4(2211540), // Rule ID 65475 //
     /* 2211492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode0),
     /* 2211495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211506 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2211506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2211509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211518 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211522 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2211525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2211538 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211539 */   // GIR_Coverage, 65475,
     /* 2211539 */   GIR_EraseRootFromParent_Done,
     /* 2211540 */ // Label 29143: @2211540
     /* 2211540 */ GIM_Try, /*On fail goto*//*Label 29144*/ GIMT_Encode4(2211593), // Rule ID 65477 //
     /* 2211545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2211548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211559 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2211559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2211562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211571 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211575 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2211578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2211591 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211592 */   // GIR_Coverage, 65477,
     /* 2211592 */   GIR_EraseRootFromParent_Done,
     /* 2211593 */ // Label 29144: @2211593
     /* 2211593 */ GIM_Try, /*On fail goto*//*Label 29145*/ GIMT_Encode4(2211619), // Rule ID 65483 //
     /* 2211598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2211601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211612 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2211612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2211617 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211618 */   // GIR_Coverage, 65483,
     /* 2211618 */   GIR_Done,
     /* 2211619 */ // Label 29145: @2211619
     /* 2211619 */ GIM_Reject,
     /* 2211620 */ // Label 29120: @2211620
     /* 2211620 */ GIM_Try, /*On fail goto*//*Label 29146*/ GIMT_Encode4(2211723),
     /* 2211625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211636 */   GIM_Try, /*On fail goto*//*Label 29147*/ GIMT_Encode4(2211679), // Rule ID 47556 //
     /* 2211641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211644 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2211647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2211661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211678 */     // GIR_Coverage, 47556,
     /* 2211678 */     GIR_EraseRootFromParent_Done,
     /* 2211679 */   // Label 29147: @2211679
     /* 2211679 */   GIM_Try, /*On fail goto*//*Label 29148*/ GIMT_Encode4(2211722), // Rule ID 47557 //
     /* 2211684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211687 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2211690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2211704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211721 */     // GIR_Coverage, 47557,
     /* 2211721 */     GIR_EraseRootFromParent_Done,
     /* 2211722 */   // Label 29148: @2211722
     /* 2211722 */   GIM_Reject,
     /* 2211723 */ // Label 29146: @2211723
     /* 2211723 */ GIM_Reject,
     /* 2211724 */ // Label 29121: @2211724
     /* 2211724 */ GIM_Try, /*On fail goto*//*Label 29149*/ GIMT_Encode4(2211778), // Rule ID 47568 //
     /* 2211729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211743 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2211760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211765 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211776 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211777 */   // GIR_Coverage, 47568,
     /* 2211777 */   GIR_EraseRootFromParent_Done,
     /* 2211778 */ // Label 29149: @2211778
     /* 2211778 */ GIM_Try, /*On fail goto*//*Label 29150*/ GIMT_Encode4(2211832), // Rule ID 47569 //
     /* 2211783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211797 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211797 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211800 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211804 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2211814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211819 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211830 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211831 */   // GIR_Coverage, 47569,
     /* 2211831 */   GIR_EraseRootFromParent_Done,
     /* 2211832 */ // Label 29150: @2211832
     /* 2211832 */ GIM_Try, /*On fail goto*//*Label 29151*/ GIMT_Encode4(2211886), // Rule ID 47622 //
     /* 2211837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211851 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211863 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2211868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211870 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211873 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211884 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211885 */   // GIR_Coverage, 47622,
     /* 2211885 */   GIR_EraseRootFromParent_Done,
     /* 2211886 */ // Label 29151: @2211886
     /* 2211886 */ GIM_Try, /*On fail goto*//*Label 29152*/ GIMT_Encode4(2211940), // Rule ID 47623 //
     /* 2211891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211905 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211905 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211908 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211912 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2211922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211924 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211927 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211938 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211939 */   // GIR_Coverage, 47623,
     /* 2211939 */   GIR_EraseRootFromParent_Done,
     /* 2211940 */ // Label 29152: @2211940
     /* 2211940 */ GIM_Reject,
     /* 2211941 */ // Label 29122: @2211941
     /* 2211941 */ GIM_Try, /*On fail goto*//*Label 29153*/ GIMT_Encode4(2211995), // Rule ID 47578 //
     /* 2211946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211960 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2211977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211982 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211993 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211994 */   // GIR_Coverage, 47578,
     /* 2211994 */   GIR_EraseRootFromParent_Done,
     /* 2211995 */ // Label 29153: @2211995
     /* 2211995 */ GIM_Try, /*On fail goto*//*Label 29154*/ GIMT_Encode4(2212049), // Rule ID 47579 //
     /* 2212000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2212006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212014 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212014 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212017 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212021 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212036 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212047 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212048 */   // GIR_Coverage, 47579,
     /* 2212048 */   GIR_EraseRootFromParent_Done,
     /* 2212049 */ // Label 29154: @2212049
     /* 2212049 */ GIM_Try, /*On fail goto*//*Label 29155*/ GIMT_Encode4(2212103), // Rule ID 47632 //
     /* 2212054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2212060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212068 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212068 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212071 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212075 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2212085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212087 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212090 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212101 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212102 */   // GIR_Coverage, 47632,
     /* 2212102 */   GIR_EraseRootFromParent_Done,
     /* 2212103 */ // Label 29155: @2212103
     /* 2212103 */ GIM_Try, /*On fail goto*//*Label 29156*/ GIMT_Encode4(2212157), // Rule ID 47633 //
     /* 2212108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2212114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212122 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212122 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212125 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212129 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2212139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212144 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212156 */   // GIR_Coverage, 47633,
     /* 2212156 */   GIR_EraseRootFromParent_Done,
     /* 2212157 */ // Label 29156: @2212157
     /* 2212157 */ GIM_Try, /*On fail goto*//*Label 29157*/ GIMT_Encode4(2212211), // Rule ID 47656 //
     /* 2212162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2212168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212176 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2212193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212198 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212209 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212210 */   // GIR_Coverage, 47656,
     /* 2212210 */   GIR_EraseRootFromParent_Done,
     /* 2212211 */ // Label 29157: @2212211
     /* 2212211 */ GIM_Try, /*On fail goto*//*Label 29158*/ GIMT_Encode4(2212265), // Rule ID 47657 //
     /* 2212216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2212222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212230 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2212247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212252 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212263 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212264 */   // GIR_Coverage, 47657,
     /* 2212264 */   GIR_EraseRootFromParent_Done,
     /* 2212265 */ // Label 29158: @2212265
     /* 2212265 */ GIM_Reject,
     /* 2212266 */ // Label 29123: @2212266
     /* 2212266 */ GIM_Try, /*On fail goto*//*Label 29159*/ GIMT_Encode4(2212369),
     /* 2212271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212282 */   GIM_Try, /*On fail goto*//*Label 29160*/ GIMT_Encode4(2212325), // Rule ID 47558 //
     /* 2212287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212290 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2212293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2212307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212324 */     // GIR_Coverage, 47558,
     /* 2212324 */     GIR_EraseRootFromParent_Done,
     /* 2212325 */   // Label 29160: @2212325
     /* 2212325 */   GIM_Try, /*On fail goto*//*Label 29161*/ GIMT_Encode4(2212368), // Rule ID 47559 //
     /* 2212330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212333 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2212336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2212350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212367 */     // GIR_Coverage, 47559,
     /* 2212367 */     GIR_EraseRootFromParent_Done,
     /* 2212368 */   // Label 29161: @2212368
     /* 2212368 */   GIM_Reject,
     /* 2212369 */ // Label 29159: @2212369
     /* 2212369 */ GIM_Reject,
     /* 2212370 */ // Label 29124: @2212370
     /* 2212370 */ GIM_Try, /*On fail goto*//*Label 29162*/ GIMT_Encode4(2212424), // Rule ID 47570 //
     /* 2212375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212389 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212389 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212392 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212396 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212411 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212422 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212423 */   // GIR_Coverage, 47570,
     /* 2212423 */   GIR_EraseRootFromParent_Done,
     /* 2212424 */ // Label 29162: @2212424
     /* 2212424 */ GIM_Try, /*On fail goto*//*Label 29163*/ GIMT_Encode4(2212478), // Rule ID 47571 //
     /* 2212429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212443 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212465 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212476 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212477 */   // GIR_Coverage, 47571,
     /* 2212477 */   GIR_EraseRootFromParent_Done,
     /* 2212478 */ // Label 29163: @2212478
     /* 2212478 */ GIM_Try, /*On fail goto*//*Label 29164*/ GIMT_Encode4(2212532), // Rule ID 47624 //
     /* 2212483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212497 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2212514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212519 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212531 */   // GIR_Coverage, 47624,
     /* 2212531 */   GIR_EraseRootFromParent_Done,
     /* 2212532 */ // Label 29164: @2212532
     /* 2212532 */ GIM_Try, /*On fail goto*//*Label 29165*/ GIMT_Encode4(2212586), // Rule ID 47625 //
     /* 2212537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212551 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2212568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212570 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212573 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212584 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212585 */   // GIR_Coverage, 47625,
     /* 2212585 */   GIR_EraseRootFromParent_Done,
     /* 2212586 */ // Label 29165: @2212586
     /* 2212586 */ GIM_Reject,
     /* 2212587 */ // Label 29125: @2212587
     /* 2212587 */ GIM_Try, /*On fail goto*//*Label 29166*/ GIMT_Encode4(2212641), // Rule ID 47580 //
     /* 2212592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212606 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2212623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212628 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212639 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212640 */   // GIR_Coverage, 47580,
     /* 2212640 */   GIR_EraseRootFromParent_Done,
     /* 2212641 */ // Label 29166: @2212641
     /* 2212641 */ GIM_Try, /*On fail goto*//*Label 29167*/ GIMT_Encode4(2212695), // Rule ID 47581 //
     /* 2212646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212660 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212660 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212663 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212667 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2212677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212679 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212682 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212694 */   // GIR_Coverage, 47581,
     /* 2212694 */   GIR_EraseRootFromParent_Done,
     /* 2212695 */ // Label 29167: @2212695
     /* 2212695 */ GIM_Try, /*On fail goto*//*Label 29168*/ GIMT_Encode4(2212749), // Rule ID 47634 //
     /* 2212700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212714 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2212731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212736 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212748 */   // GIR_Coverage, 47634,
     /* 2212748 */   GIR_EraseRootFromParent_Done,
     /* 2212749 */ // Label 29168: @2212749
     /* 2212749 */ GIM_Try, /*On fail goto*//*Label 29169*/ GIMT_Encode4(2212803), // Rule ID 47635 //
     /* 2212754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212768 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2212785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212790 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212801 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212802 */   // GIR_Coverage, 47635,
     /* 2212802 */   GIR_EraseRootFromParent_Done,
     /* 2212803 */ // Label 29169: @2212803
     /* 2212803 */ GIM_Try, /*On fail goto*//*Label 29170*/ GIMT_Encode4(2212857), // Rule ID 47658 //
     /* 2212808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212822 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2212839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212844 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212855 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212856 */   // GIR_Coverage, 47658,
     /* 2212856 */   GIR_EraseRootFromParent_Done,
     /* 2212857 */ // Label 29170: @2212857
     /* 2212857 */ GIM_Try, /*On fail goto*//*Label 29171*/ GIMT_Encode4(2212911), // Rule ID 47659 //
     /* 2212862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212876 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2212893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212898 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212909 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212910 */   // GIR_Coverage, 47659,
     /* 2212910 */   GIR_EraseRootFromParent_Done,
     /* 2212911 */ // Label 29171: @2212911
     /* 2212911 */ GIM_Reject,
     /* 2212912 */ // Label 29126: @2212912
     /* 2212912 */ GIM_Try, /*On fail goto*//*Label 29172*/ GIMT_Encode4(2213015),
     /* 2212917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2212920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212928 */   GIM_Try, /*On fail goto*//*Label 29173*/ GIMT_Encode4(2212971), // Rule ID 47560 //
     /* 2212933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212936 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2212939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212970 */     // GIR_Coverage, 47560,
     /* 2212970 */     GIR_EraseRootFromParent_Done,
     /* 2212971 */   // Label 29173: @2212971
     /* 2212971 */   GIM_Try, /*On fail goto*//*Label 29174*/ GIMT_Encode4(2213014), // Rule ID 47561 //
     /* 2212976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212979 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2212982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213013 */     // GIR_Coverage, 47561,
     /* 2213013 */     GIR_EraseRootFromParent_Done,
     /* 2213014 */   // Label 29174: @2213014
     /* 2213014 */   GIM_Reject,
     /* 2213015 */ // Label 29172: @2213015
     /* 2213015 */ GIM_Reject,
     /* 2213016 */ // Label 29127: @2213016
     /* 2213016 */ GIM_Try, /*On fail goto*//*Label 29175*/ GIMT_Encode4(2213070), // Rule ID 47572 //
     /* 2213021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213035 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213038 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213042 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2213052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213057 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213069 */   // GIR_Coverage, 47572,
     /* 2213069 */   GIR_EraseRootFromParent_Done,
     /* 2213070 */ // Label 29175: @2213070
     /* 2213070 */ GIM_Try, /*On fail goto*//*Label 29176*/ GIMT_Encode4(2213124), // Rule ID 47573 //
     /* 2213075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213089 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2213106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213111 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213122 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213123 */   // GIR_Coverage, 47573,
     /* 2213123 */   GIR_EraseRootFromParent_Done,
     /* 2213124 */ // Label 29176: @2213124
     /* 2213124 */ GIM_Try, /*On fail goto*//*Label 29177*/ GIMT_Encode4(2213178), // Rule ID 47626 //
     /* 2213129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213143 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213143 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213146 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213150 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2213160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213162 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213165 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213176 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213177 */   // GIR_Coverage, 47626,
     /* 2213177 */   GIR_EraseRootFromParent_Done,
     /* 2213178 */ // Label 29177: @2213178
     /* 2213178 */ GIM_Try, /*On fail goto*//*Label 29178*/ GIMT_Encode4(2213232), // Rule ID 47627 //
     /* 2213183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213197 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213197 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213200 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213204 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2213214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213219 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213230 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213231 */   // GIR_Coverage, 47627,
     /* 2213231 */   GIR_EraseRootFromParent_Done,
     /* 2213232 */ // Label 29178: @2213232
     /* 2213232 */ GIM_Reject,
     /* 2213233 */ // Label 29128: @2213233
     /* 2213233 */ GIM_Try, /*On fail goto*//*Label 29179*/ GIMT_Encode4(2213287), // Rule ID 47582 //
     /* 2213238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2213244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213252 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213274 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213286 */   // GIR_Coverage, 47582,
     /* 2213286 */   GIR_EraseRootFromParent_Done,
     /* 2213287 */ // Label 29179: @2213287
     /* 2213287 */ GIM_Try, /*On fail goto*//*Label 29180*/ GIMT_Encode4(2213341), // Rule ID 47583 //
     /* 2213292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2213298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213306 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213328 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213339 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213340 */   // GIR_Coverage, 47583,
     /* 2213340 */   GIR_EraseRootFromParent_Done,
     /* 2213341 */ // Label 29180: @2213341
     /* 2213341 */ GIM_Try, /*On fail goto*//*Label 29181*/ GIMT_Encode4(2213395), // Rule ID 47636 //
     /* 2213346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213360 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2213377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213382 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213393 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213394 */   // GIR_Coverage, 47636,
     /* 2213394 */   GIR_EraseRootFromParent_Done,
     /* 2213395 */ // Label 29181: @2213395
     /* 2213395 */ GIM_Try, /*On fail goto*//*Label 29182*/ GIMT_Encode4(2213449), // Rule ID 47637 //
     /* 2213400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213414 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2213431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213436 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213447 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213448 */   // GIR_Coverage, 47637,
     /* 2213448 */   GIR_EraseRootFromParent_Done,
     /* 2213449 */ // Label 29182: @2213449
     /* 2213449 */ GIM_Try, /*On fail goto*//*Label 29183*/ GIMT_Encode4(2213503), // Rule ID 47660 //
     /* 2213454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213468 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2213485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213490 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213501 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213502 */   // GIR_Coverage, 47660,
     /* 2213502 */   GIR_EraseRootFromParent_Done,
     /* 2213503 */ // Label 29183: @2213503
     /* 2213503 */ GIM_Try, /*On fail goto*//*Label 29184*/ GIMT_Encode4(2213557), // Rule ID 47661 //
     /* 2213508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213522 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213522 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213525 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213529 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2213539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213544 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213555 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213556 */   // GIR_Coverage, 47661,
     /* 2213556 */   GIR_EraseRootFromParent_Done,
     /* 2213557 */ // Label 29184: @2213557
     /* 2213557 */ GIM_Reject,
     /* 2213558 */ // Label 29129: @2213558
     /* 2213558 */ GIM_Try, /*On fail goto*//*Label 29185*/ GIMT_Encode4(2213661),
     /* 2213563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213574 */   GIM_Try, /*On fail goto*//*Label 29186*/ GIMT_Encode4(2213617), // Rule ID 47562 //
     /* 2213579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213582 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2213585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2213599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213616 */     // GIR_Coverage, 47562,
     /* 2213616 */     GIR_EraseRootFromParent_Done,
     /* 2213617 */   // Label 29186: @2213617
     /* 2213617 */   GIM_Try, /*On fail goto*//*Label 29187*/ GIMT_Encode4(2213660), // Rule ID 47563 //
     /* 2213622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213625 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2213628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2213642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213659 */     // GIR_Coverage, 47563,
     /* 2213659 */     GIR_EraseRootFromParent_Done,
     /* 2213660 */   // Label 29187: @2213660
     /* 2213660 */   GIM_Reject,
     /* 2213661 */ // Label 29185: @2213661
     /* 2213661 */ GIM_Reject,
     /* 2213662 */ // Label 29130: @2213662
     /* 2213662 */ GIM_Try, /*On fail goto*//*Label 29188*/ GIMT_Encode4(2213716), // Rule ID 47574 //
     /* 2213667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213681 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213703 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213714 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213715 */   // GIR_Coverage, 47574,
     /* 2213715 */   GIR_EraseRootFromParent_Done,
     /* 2213716 */ // Label 29188: @2213716
     /* 2213716 */ GIM_Try, /*On fail goto*//*Label 29189*/ GIMT_Encode4(2213770), // Rule ID 47575 //
     /* 2213721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213735 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213757 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213768 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213769 */   // GIR_Coverage, 47575,
     /* 2213769 */   GIR_EraseRootFromParent_Done,
     /* 2213770 */ // Label 29189: @2213770
     /* 2213770 */ GIM_Try, /*On fail goto*//*Label 29190*/ GIMT_Encode4(2213824), // Rule ID 47628 //
     /* 2213775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213789 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213789 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213792 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213796 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2213806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213811 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213823 */   // GIR_Coverage, 47628,
     /* 2213823 */   GIR_EraseRootFromParent_Done,
     /* 2213824 */ // Label 29190: @2213824
     /* 2213824 */ GIM_Try, /*On fail goto*//*Label 29191*/ GIMT_Encode4(2213878), // Rule ID 47629 //
     /* 2213829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213843 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2213860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213865 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213877 */   // GIR_Coverage, 47629,
     /* 2213877 */   GIR_EraseRootFromParent_Done,
     /* 2213878 */ // Label 29191: @2213878
     /* 2213878 */ GIM_Reject,
     /* 2213879 */ // Label 29131: @2213879
     /* 2213879 */ GIM_Try, /*On fail goto*//*Label 29192*/ GIMT_Encode4(2213933), // Rule ID 47584 //
     /* 2213884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2213890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213898 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2213915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213920 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213932 */   // GIR_Coverage, 47584,
     /* 2213932 */   GIR_EraseRootFromParent_Done,
     /* 2213933 */ // Label 29192: @2213933
     /* 2213933 */ GIM_Try, /*On fail goto*//*Label 29193*/ GIMT_Encode4(2213987), // Rule ID 47585 //
     /* 2213938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2213944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213952 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2213969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213974 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213986 */   // GIR_Coverage, 47585,
     /* 2213986 */   GIR_EraseRootFromParent_Done,
     /* 2213987 */ // Label 29193: @2213987
     /* 2213987 */ GIM_Try, /*On fail goto*//*Label 29194*/ GIMT_Encode4(2214041), // Rule ID 47638 //
     /* 2213992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214006 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2214009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2214023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214028 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214039 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214040 */   // GIR_Coverage, 47638,
     /* 2214040 */   GIR_EraseRootFromParent_Done,
     /* 2214041 */ // Label 29194: @2214041
     /* 2214041 */ GIM_Try, /*On fail goto*//*Label 29195*/ GIMT_Encode4(2214095), // Rule ID 47639 //
     /* 2214046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2214049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2214052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214060 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2214063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2214077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214082 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214094 */   // GIR_Coverage, 47639,
     /* 2214094 */   GIR_EraseRootFromParent_Done,
     /* 2214095 */ // Label 29195: @2214095
     /* 2214095 */ GIM_Try, /*On fail goto*//*Label 29196*/ GIMT_Encode4(2214149), // Rule ID 47662 //
     /* 2214100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2214103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214114 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2214117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2214131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214133 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214136 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214148 */   // GIR_Coverage, 47662,
     /* 2214148 */   GIR_EraseRootFromParent_Done,
     /* 2214149 */ // Label 29196: @2214149
     /* 2214149 */ GIM_Try, /*On fail goto*//*Label 29197*/ GIMT_Encode4(2214203), // Rule ID 47663 //
     /* 2214154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2214157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214168 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2214171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2214185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214187 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214190 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214201 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214202 */   // GIR_Coverage, 47663,
     /* 2214202 */   GIR_EraseRootFromParent_Done,
     /* 2214203 */ // Label 29197: @2214203
     /* 2214203 */ GIM_Reject,
     /* 2214204 */ // Label 29132: @2214204
     /* 2214204 */ GIM_Try, /*On fail goto*//*Label 29198*/ GIMT_Encode4(2214307),
     /* 2214209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2214212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214220 */   GIM_Try, /*On fail goto*//*Label 29199*/ GIMT_Encode4(2214263), // Rule ID 47564 //
     /* 2214225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214228 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2214231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2214245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214262 */     // GIR_Coverage, 47564,
     /* 2214262 */     GIR_EraseRootFromParent_Done,
     /* 2214263 */   // Label 29199: @2214263
     /* 2214263 */   GIM_Try, /*On fail goto*//*Label 29200*/ GIMT_Encode4(2214306), // Rule ID 47565 //
     /* 2214268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214271 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2214274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2214288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214305 */     // GIR_Coverage, 47565,
     /* 2214305 */     GIR_EraseRootFromParent_Done,
     /* 2214306 */   // Label 29200: @2214306
     /* 2214306 */   GIM_Reject,
     /* 2214307 */ // Label 29198: @2214307
     /* 2214307 */ GIM_Reject,
     /* 2214308 */ // Label 29133: @2214308
     /* 2214308 */ GIM_Try, /*On fail goto*//*Label 29201*/ GIMT_Encode4(2214362), // Rule ID 47576 //
     /* 2214313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2214319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214327 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2214344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214349 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214360 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214361 */   // GIR_Coverage, 47576,
     /* 2214361 */   GIR_EraseRootFromParent_Done,
     /* 2214362 */ // Label 29201: @2214362
     /* 2214362 */ GIM_Try, /*On fail goto*//*Label 29202*/ GIMT_Encode4(2214416), // Rule ID 47577 //
     /* 2214367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2214373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214381 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2214398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214403 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214415 */   // GIR_Coverage, 47577,
     /* 2214415 */   GIR_EraseRootFromParent_Done,
     /* 2214416 */ // Label 29202: @2214416
     /* 2214416 */ GIM_Try, /*On fail goto*//*Label 29203*/ GIMT_Encode4(2214470), // Rule ID 47630 //
     /* 2214421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2214427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214435 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214435 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214438 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214442 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2214452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214457 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214468 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214469 */   // GIR_Coverage, 47630,
     /* 2214469 */   GIR_EraseRootFromParent_Done,
     /* 2214470 */ // Label 29203: @2214470
     /* 2214470 */ GIM_Try, /*On fail goto*//*Label 29204*/ GIMT_Encode4(2214524), // Rule ID 47631 //
     /* 2214475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2214481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214489 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2214506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214511 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214522 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214523 */   // GIR_Coverage, 47631,
     /* 2214523 */   GIR_EraseRootFromParent_Done,
     /* 2214524 */ // Label 29204: @2214524
     /* 2214524 */ GIM_Reject,
     /* 2214525 */ // Label 29134: @2214525
     /* 2214525 */ GIM_Try, /*On fail goto*//*Label 29205*/ GIMT_Encode4(2214628),
     /* 2214530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2214533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214541 */   GIM_Try, /*On fail goto*//*Label 29206*/ GIMT_Encode4(2214584), // Rule ID 47566 //
     /* 2214546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214549 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2214552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2214566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214583 */     // GIR_Coverage, 47566,
     /* 2214583 */     GIR_EraseRootFromParent_Done,
     /* 2214584 */   // Label 29206: @2214584
     /* 2214584 */   GIM_Try, /*On fail goto*//*Label 29207*/ GIMT_Encode4(2214627), // Rule ID 47567 //
     /* 2214589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214592 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2214595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2214609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214626 */     // GIR_Coverage, 47567,
     /* 2214626 */     GIR_EraseRootFromParent_Done,
     /* 2214627 */   // Label 29207: @2214627
     /* 2214627 */   GIM_Reject,
     /* 2214628 */ // Label 29205: @2214628
     /* 2214628 */ GIM_Reject,
     /* 2214629 */ // Label 29135: @2214629
     /* 2214629 */ GIM_Reject,
     /* 2214630 */ // Label 41: @2214630
     /* 2214630 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 29210*/ GIMT_Encode4(2215672),
     /* 2214641 */ /*GILLT_s32*//*Label 29208*/ GIMT_Encode4(2214649),
     /* 2214645 */ /*GILLT_s64*//*Label 29209*/ GIMT_Encode4(2215307),
     /* 2214649 */ // Label 29208: @2214649
     /* 2214649 */ GIM_Try, /*On fail goto*//*Label 29211*/ GIMT_Encode4(2215306),
     /* 2214654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2214657 */   GIM_Try, /*On fail goto*//*Label 29212*/ GIMT_Encode4(2214693), // Rule ID 64482 //
     /* 2214662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2214665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214673 */     // MIs[0] Operand 2
     /* 2214673 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214684 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2214687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214692 */     // GIR_Coverage, 64482,
     /* 2214692 */     GIR_EraseRootFromParent_Done,
     /* 2214693 */   // Label 29212: @2214693
     /* 2214693 */   GIM_Try, /*On fail goto*//*Label 29213*/ GIMT_Encode4(2214729), // Rule ID 64484 //
     /* 2214698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2214701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214709 */     // MIs[0] Operand 2
     /* 2214709 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214720 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2214723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214728 */     // GIR_Coverage, 64484,
     /* 2214728 */     GIR_EraseRootFromParent_Done,
     /* 2214729 */   // Label 29213: @2214729
     /* 2214729 */   GIM_Try, /*On fail goto*//*Label 29214*/ GIMT_Encode4(2214765), // Rule ID 2535 //
     /* 2214734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2214737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214745 */     // MIs[0] Operand 2
     /* 2214745 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214756 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2214759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214764 */     // GIR_Coverage, 2535,
     /* 2214764 */     GIR_EraseRootFromParent_Done,
     /* 2214765 */   // Label 29214: @2214765
     /* 2214765 */   GIM_Try, /*On fail goto*//*Label 29215*/ GIMT_Encode4(2214801), // Rule ID 2537 //
     /* 2214770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2214773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214781 */     // MIs[0] Operand 2
     /* 2214781 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214792 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2214795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214800 */     // GIR_Coverage, 2537,
     /* 2214800 */     GIR_EraseRootFromParent_Done,
     /* 2214801 */   // Label 29215: @2214801
     /* 2214801 */   GIM_Try, /*On fail goto*//*Label 29216*/ GIMT_Encode4(2214843), // Rule ID 62568 //
     /* 2214806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2214809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214817 */     // MIs[0] Operand 2
     /* 2214817 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214828 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2214831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2214838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214842 */     // GIR_Coverage, 62568,
     /* 2214842 */     GIR_EraseRootFromParent_Done,
     /* 2214843 */   // Label 29216: @2214843
     /* 2214843 */   GIM_Try, /*On fail goto*//*Label 29217*/ GIMT_Encode4(2214885), // Rule ID 62570 //
     /* 2214848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2214851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214859 */     // MIs[0] Operand 2
     /* 2214859 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214870 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2214873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2214880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214884 */     // GIR_Coverage, 62570,
     /* 2214884 */     GIR_EraseRootFromParent_Done,
     /* 2214885 */   // Label 29217: @2214885
     /* 2214885 */   GIM_Try, /*On fail goto*//*Label 29218*/ GIMT_Encode4(2214927), // Rule ID 62572 //
     /* 2214890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2214893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214901 */     // MIs[0] Operand 2
     /* 2214901 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214912 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2214915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214926 */     // GIR_Coverage, 62572,
     /* 2214926 */     GIR_EraseRootFromParent_Done,
     /* 2214927 */   // Label 29218: @2214927
     /* 2214927 */   GIM_Try, /*On fail goto*//*Label 29219*/ GIMT_Encode4(2214969), // Rule ID 64629 //
     /* 2214932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2214935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214943 */     // MIs[0] Operand 2
     /* 2214943 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214954 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i64] }, 0:{ *:[i64] })
     /* 2214954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2214964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214968 */     // GIR_Coverage, 64629,
     /* 2214968 */     GIR_EraseRootFromParent_Done,
     /* 2214969 */   // Label 29219: @2214969
     /* 2214969 */   GIM_Try, /*On fail goto*//*Label 29220*/ GIMT_Encode4(2215011), // Rule ID 64630 //
     /* 2214974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2214977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214985 */     // MIs[0] Operand 2
     /* 2214985 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214996 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2215006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215010 */     // GIR_Coverage, 64630,
     /* 2215010 */     GIR_EraseRootFromParent_Done,
     /* 2215011 */   // Label 29220: @2215011
     /* 2215011 */   GIM_Try, /*On fail goto*//*Label 29221*/ GIMT_Encode4(2215053), // Rule ID 64645 //
     /* 2215016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode0),
     /* 2215019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2215023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215027 */     // MIs[0] Operand 2
     /* 2215027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215038 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 16:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2215041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2215048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215052 */     // GIR_Coverage, 64645,
     /* 2215052 */     GIR_EraseRootFromParent_Done,
     /* 2215053 */   // Label 29221: @2215053
     /* 2215053 */   GIM_Try, /*On fail goto*//*Label 29222*/ GIMT_Encode4(2215095), // Rule ID 64646 //
     /* 2215058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode1),
     /* 2215061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2215065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215069 */     // MIs[0] Operand 2
     /* 2215069 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215080 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 16:{ *:[i32] }, 0:{ *:[i32] })
     /* 2215080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2215083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2215090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215094 */     // GIR_Coverage, 64646,
     /* 2215094 */     GIR_EraseRootFromParent_Done,
     /* 2215095 */   // Label 29222: @2215095
     /* 2215095 */   GIM_Try, /*On fail goto*//*Label 29223*/ GIMT_Encode4(2215137), // Rule ID 64647 //
     /* 2215100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode0),
     /* 2215103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2215107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215111 */     // MIs[0] Operand 2
     /* 2215111 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215122 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 8:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2215125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 2215132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215136 */     // GIR_Coverage, 64647,
     /* 2215136 */     GIR_EraseRootFromParent_Done,
     /* 2215137 */   // Label 29223: @2215137
     /* 2215137 */   GIM_Try, /*On fail goto*//*Label 29224*/ GIMT_Encode4(2215179), // Rule ID 64648 //
     /* 2215142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode1),
     /* 2215145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2215149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215153 */     // MIs[0] Operand 2
     /* 2215153 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215164 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 8:{ *:[i32] }, 0:{ *:[i32] })
     /* 2215164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2215167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 2215174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215178 */     // GIR_Coverage, 64648,
     /* 2215178 */     GIR_EraseRootFromParent_Done,
     /* 2215179 */   // Label 29224: @2215179
     /* 2215179 */   GIM_Try, /*On fail goto*//*Label 29225*/ GIMT_Encode4(2215221), // Rule ID 65111 //
     /* 2215184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2215187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215195 */     // MIs[0] Operand 2
     /* 2215195 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215206 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2215206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2215216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215220 */     // GIR_Coverage, 65111,
     /* 2215220 */     GIR_EraseRootFromParent_Done,
     /* 2215221 */   // Label 29225: @2215221
     /* 2215221 */   GIM_Try, /*On fail goto*//*Label 29226*/ GIMT_Encode4(2215263), // Rule ID 65113 //
     /* 2215226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2215229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215237 */     // MIs[0] Operand 2
     /* 2215237 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215248 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2215248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2215258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215262 */     // GIR_Coverage, 65113,
     /* 2215262 */     GIR_EraseRootFromParent_Done,
     /* 2215263 */   // Label 29226: @2215263
     /* 2215263 */   GIM_Try, /*On fail goto*//*Label 29227*/ GIMT_Encode4(2215305), // Rule ID 65115 //
     /* 2215268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2215271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215279 */     // MIs[0] Operand 2
     /* 2215279 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2215290 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2215290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215304 */     // GIR_Coverage, 65115,
     /* 2215304 */     GIR_EraseRootFromParent_Done,
     /* 2215305 */   // Label 29227: @2215305
     /* 2215305 */   GIM_Reject,
     /* 2215306 */ // Label 29211: @2215306
     /* 2215306 */ GIM_Reject,
     /* 2215307 */ // Label 29209: @2215307
     /* 2215307 */ GIM_Try, /*On fail goto*//*Label 29228*/ GIMT_Encode4(2215671),
     /* 2215312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2215315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215323 */   GIM_Try, /*On fail goto*//*Label 29229*/ GIMT_Encode4(2215351), // Rule ID 64481 //
     /* 2215328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2215331 */     // MIs[0] Operand 2
     /* 2215331 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215342 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2215342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2215345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215350 */     // GIR_Coverage, 64481,
     /* 2215350 */     GIR_EraseRootFromParent_Done,
     /* 2215351 */   // Label 29229: @2215351
     /* 2215351 */   GIM_Try, /*On fail goto*//*Label 29230*/ GIMT_Encode4(2215379), // Rule ID 64483 //
     /* 2215356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2215359 */     // MIs[0] Operand 2
     /* 2215359 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215370 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2215370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2215373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215378 */     // GIR_Coverage, 64483,
     /* 2215378 */     GIR_EraseRootFromParent_Done,
     /* 2215379 */   // Label 29230: @2215379
     /* 2215379 */   GIM_Try, /*On fail goto*//*Label 29231*/ GIMT_Encode4(2215410), // Rule ID 274 //
     /* 2215384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2215387 */     // MIs[0] Operand 2
     /* 2215387 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2215398 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] })  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2215398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2215401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215409 */     // GIR_Coverage, 274,
     /* 2215409 */     GIR_EraseRootFromParent_Done,
     /* 2215410 */   // Label 29231: @2215410
     /* 2215410 */   GIM_Try, /*On fail goto*//*Label 29232*/ GIMT_Encode4(2215438), // Rule ID 2534 //
     /* 2215415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2215418 */     // MIs[0] Operand 2
     /* 2215418 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215429 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2215429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2215432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215437 */     // GIR_Coverage, 2534,
     /* 2215437 */     GIR_EraseRootFromParent_Done,
     /* 2215438 */   // Label 29232: @2215438
     /* 2215438 */   GIM_Try, /*On fail goto*//*Label 29233*/ GIMT_Encode4(2215466), // Rule ID 2536 //
     /* 2215443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2215446 */     // MIs[0] Operand 2
     /* 2215446 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215457 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2215457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2215460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215465 */     // GIR_Coverage, 2536,
     /* 2215465 */     GIR_EraseRootFromParent_Done,
     /* 2215466 */   // Label 29233: @2215466
     /* 2215466 */   GIM_Try, /*On fail goto*//*Label 29234*/ GIMT_Encode4(2215500), // Rule ID 62567 //
     /* 2215471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2215474 */     // MIs[0] Operand 2
     /* 2215474 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215485 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2215488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2215495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215499 */     // GIR_Coverage, 62567,
     /* 2215499 */     GIR_EraseRootFromParent_Done,
     /* 2215500 */   // Label 29234: @2215500
     /* 2215500 */   GIM_Try, /*On fail goto*//*Label 29235*/ GIMT_Encode4(2215534), // Rule ID 62569 //
     /* 2215505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2215508 */     // MIs[0] Operand 2
     /* 2215508 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215519 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2215522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2215529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215533 */     // GIR_Coverage, 62569,
     /* 2215533 */     GIR_EraseRootFromParent_Done,
     /* 2215534 */   // Label 29235: @2215534
     /* 2215534 */   GIM_Try, /*On fail goto*//*Label 29236*/ GIMT_Encode4(2215568), // Rule ID 62571 //
     /* 2215539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2215542 */     // MIs[0] Operand 2
     /* 2215542 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2215553 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2215556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215567 */     // GIR_Coverage, 62571,
     /* 2215567 */     GIR_EraseRootFromParent_Done,
     /* 2215568 */   // Label 29236: @2215568
     /* 2215568 */   GIM_Try, /*On fail goto*//*Label 29237*/ GIMT_Encode4(2215602), // Rule ID 65110 //
     /* 2215573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2215576 */     // MIs[0] Operand 2
     /* 2215576 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215587 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2215597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215601 */     // GIR_Coverage, 65110,
     /* 2215601 */     GIR_EraseRootFromParent_Done,
     /* 2215602 */   // Label 29237: @2215602
     /* 2215602 */   GIM_Try, /*On fail goto*//*Label 29238*/ GIMT_Encode4(2215636), // Rule ID 65112 //
     /* 2215607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2215610 */     // MIs[0] Operand 2
     /* 2215610 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215621 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2215631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215635 */     // GIR_Coverage, 65112,
     /* 2215635 */     GIR_EraseRootFromParent_Done,
     /* 2215636 */   // Label 29238: @2215636
     /* 2215636 */   GIM_Try, /*On fail goto*//*Label 29239*/ GIMT_Encode4(2215670), // Rule ID 65114 //
     /* 2215641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2215644 */     // MIs[0] Operand 2
     /* 2215644 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2215655 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215669 */     // GIR_Coverage, 65114,
     /* 2215669 */     GIR_EraseRootFromParent_Done,
     /* 2215670 */   // Label 29239: @2215670
     /* 2215670 */   GIM_Reject,
     /* 2215671 */ // Label 29228: @2215671
     /* 2215671 */ GIM_Reject,
     /* 2215672 */ // Label 29210: @2215672
     /* 2215672 */ GIM_Reject,
     /* 2215673 */ // Label 42: @2215673
     /* 2215673 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 29257*/ GIMT_Encode4(2219359),
     /* 2215684 */ /*GILLT_s32*//*Label 29240*/ GIMT_Encode4(2215800),
     /* 2215688 */ /*GILLT_s64*//*Label 29241*/ GIMT_Encode4(2216096), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215700 */ /*GILLT_nxv1s16*//*Label 29242*/ GIMT_Encode4(2216350),
     /* 2215704 */ /*GILLT_nxv1s32*//*Label 29243*/ GIMT_Encode4(2216454),
     /* 2215708 */ /*GILLT_nxv1s64*//*Label 29244*/ GIMT_Encode4(2216671), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215720 */ /*GILLT_nxv2s16*//*Label 29245*/ GIMT_Encode4(2216996),
     /* 2215724 */ /*GILLT_nxv2s32*//*Label 29246*/ GIMT_Encode4(2217100),
     /* 2215728 */ /*GILLT_nxv2s64*//*Label 29247*/ GIMT_Encode4(2217317), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215740 */ /*GILLT_nxv4s16*//*Label 29248*/ GIMT_Encode4(2217642),
     /* 2215744 */ /*GILLT_nxv4s32*//*Label 29249*/ GIMT_Encode4(2217746),
     /* 2215748 */ /*GILLT_nxv4s64*//*Label 29250*/ GIMT_Encode4(2217963), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215760 */ /*GILLT_nxv8s16*//*Label 29251*/ GIMT_Encode4(2218288),
     /* 2215764 */ /*GILLT_nxv8s32*//*Label 29252*/ GIMT_Encode4(2218392),
     /* 2215768 */ /*GILLT_nxv8s64*//*Label 29253*/ GIMT_Encode4(2218609), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215780 */ /*GILLT_nxv16s16*//*Label 29254*/ GIMT_Encode4(2218934),
     /* 2215784 */ /*GILLT_nxv16s32*//*Label 29255*/ GIMT_Encode4(2219038), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215796 */ /*GILLT_nxv32s16*//*Label 29256*/ GIMT_Encode4(2219255),
     /* 2215800 */ // Label 29240: @2215800
     /* 2215800 */ GIM_Try, /*On fail goto*//*Label 29258*/ GIMT_Encode4(2216095),
     /* 2215805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2215808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215816 */   GIM_Try, /*On fail goto*//*Label 29259*/ GIMT_Encode4(2215858), // Rule ID 65471 //
     /* 2215821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2215824 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2215824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2215827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215840 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2215843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2215856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215857 */     // GIR_Coverage, 65471,
     /* 2215857 */     GIR_EraseRootFromParent_Done,
     /* 2215858 */   // Label 29259: @2215858
     /* 2215858 */   GIM_Try, /*On fail goto*//*Label 29260*/ GIMT_Encode4(2215900), // Rule ID 65473 //
     /* 2215863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2215866 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2215866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2215869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215882 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2215885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2215898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215899 */     // GIR_Coverage, 65473,
     /* 2215899 */     GIR_EraseRootFromParent_Done,
     /* 2215900 */   // Label 29260: @2215900
     /* 2215900 */   GIM_Try, /*On fail goto*//*Label 29261*/ GIMT_Encode4(2215942), // Rule ID 65474 //
     /* 2215905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2215908 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2215908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2215911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215924 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2215927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2215940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215941 */     // GIR_Coverage, 65474,
     /* 2215941 */     GIR_EraseRootFromParent_Done,
     /* 2215942 */   // Label 29261: @2215942
     /* 2215942 */   GIM_Try, /*On fail goto*//*Label 29262*/ GIMT_Encode4(2215957), // Rule ID 65484 //
     /* 2215947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /* 2215950 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2215955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215956 */     // GIR_Coverage, 65484,
     /* 2215956 */     GIR_Done,
     /* 2215957 */   // Label 29262: @2215957
     /* 2215957 */   GIM_Try, /*On fail goto*//*Label 29263*/ GIMT_Encode4(2215972), // Rule ID 65485 //
     /* 2215962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /* 2215965 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2215970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215971 */     // GIR_Coverage, 65485,
     /* 2215971 */     GIR_Done,
     /* 2215972 */   // Label 29263: @2215972
     /* 2215972 */   GIM_Try, /*On fail goto*//*Label 29264*/ GIMT_Encode4(2215987), // Rule ID 65487 //
     /* 2215977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2215980 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2215985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215986 */     // GIR_Coverage, 65487,
     /* 2215986 */     GIR_Done,
     /* 2215987 */   // Label 29264: @2215987
     /* 2215987 */   GIM_Try, /*On fail goto*//*Label 29265*/ GIMT_Encode4(2216002), // Rule ID 65488 //
     /* 2215992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode1),
     /* 2215995 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2216000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216001 */     // GIR_Coverage, 65488,
     /* 2216001 */     GIR_Done,
     /* 2216002 */   // Label 29265: @2216002
     /* 2216002 */   GIM_Try, /*On fail goto*//*Label 29266*/ GIMT_Encode4(2216025), // Rule ID 65489 //
     /* 2216007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /* 2216010 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2216010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2216013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2216017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2216023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216024 */     // GIR_Coverage, 65489,
     /* 2216024 */     GIR_EraseRootFromParent_Done,
     /* 2216025 */   // Label 29266: @2216025
     /* 2216025 */   GIM_Try, /*On fail goto*//*Label 29267*/ GIMT_Encode4(2216048), // Rule ID 65490 //
     /* 2216030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /* 2216033 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2216033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2216036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2216040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2216046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216047 */     // GIR_Coverage, 65490,
     /* 2216047 */     GIR_EraseRootFromParent_Done,
     /* 2216048 */   // Label 29267: @2216048
     /* 2216048 */   GIM_Try, /*On fail goto*//*Label 29268*/ GIMT_Encode4(2216071), // Rule ID 65492 //
     /* 2216053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2216056 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2216056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2216059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2216063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2216069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216070 */     // GIR_Coverage, 65492,
     /* 2216070 */     GIR_EraseRootFromParent_Done,
     /* 2216071 */   // Label 29268: @2216071
     /* 2216071 */   GIM_Try, /*On fail goto*//*Label 29269*/ GIMT_Encode4(2216094), // Rule ID 65493 //
     /* 2216076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1),
     /* 2216079 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2216079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2216082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2216086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2216092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216093 */     // GIR_Coverage, 65493,
     /* 2216093 */     GIR_EraseRootFromParent_Done,
     /* 2216094 */   // Label 29269: @2216094
     /* 2216094 */   GIM_Reject,
     /* 2216095 */ // Label 29258: @2216095
     /* 2216095 */ GIM_Reject,
     /* 2216096 */ // Label 29241: @2216096
     /* 2216096 */ GIM_Try, /*On fail goto*//*Label 29270*/ GIMT_Encode4(2216149), // Rule ID 65469 //
     /* 2216101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2216104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2216107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216115 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i32] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 2216115 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2216118 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2216122 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216127 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2216131 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2216134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2216139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 2216147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216148 */   // GIR_Coverage, 65469,
     /* 2216148 */   GIR_EraseRootFromParent_Done,
     /* 2216149 */ // Label 29270: @2216149
     /* 2216149 */ GIM_Try, /*On fail goto*//*Label 29271*/ GIMT_Encode4(2216202), // Rule ID 65470 //
     /* 2216154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2216157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216168 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2216168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2216171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2216175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216180 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2216184 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2216187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2216192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2216200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216201 */   // GIR_Coverage, 65470,
     /* 2216201 */   GIR_EraseRootFromParent_Done,
     /* 2216202 */ // Label 29271: @2216202
     /* 2216202 */ GIM_Try, /*On fail goto*//*Label 29272*/ GIMT_Encode4(2216255), // Rule ID 65472 //
     /* 2216207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2216210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216221 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2216221 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2216224 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2216228 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216233 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2216237 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2216240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2216245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2216253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216254 */   // GIR_Coverage, 65472,
     /* 2216254 */   GIR_EraseRootFromParent_Done,
     /* 2216255 */ // Label 29272: @2216255
     /* 2216255 */ GIM_Try, /*On fail goto*//*Label 29273*/ GIMT_Encode4(2216289), // Rule ID 65480 //
     /* 2216260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2216263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2216266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216274 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i32] }:$src, X0:{ *:[i64] })
     /* 2216274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /* 2216277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216279 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2216281 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2216287 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216288 */   // GIR_Coverage, 65480,
     /* 2216288 */   GIR_EraseRootFromParent_Done,
     /* 2216289 */ // Label 29273: @2216289
     /* 2216289 */ GIM_Try, /*On fail goto*//*Label 29274*/ GIMT_Encode4(2216315), // Rule ID 65486 //
     /* 2216294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2216297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216308 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2216308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2216313 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216314 */   // GIR_Coverage, 65486,
     /* 2216314 */   GIR_Done,
     /* 2216315 */ // Label 29274: @2216315
     /* 2216315 */ GIM_Try, /*On fail goto*//*Label 29275*/ GIMT_Encode4(2216349), // Rule ID 65491 //
     /* 2216320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2216323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216334 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i64] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2216334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2216337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216339 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2216341 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2216347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216348 */   // GIR_Coverage, 65491,
     /* 2216348 */   GIR_EraseRootFromParent_Done,
     /* 2216349 */ // Label 29275: @2216349
     /* 2216349 */ GIM_Reject,
     /* 2216350 */ // Label 29242: @2216350
     /* 2216350 */ GIM_Try, /*On fail goto*//*Label 29276*/ GIMT_Encode4(2216453),
     /* 2216355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216366 */   GIM_Try, /*On fail goto*//*Label 29277*/ GIMT_Encode4(2216409), // Rule ID 45808 //
     /* 2216371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216374 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2216377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2216391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216408 */     // GIR_Coverage, 45808,
     /* 2216408 */     GIR_EraseRootFromParent_Done,
     /* 2216409 */   // Label 29277: @2216409
     /* 2216409 */   GIM_Try, /*On fail goto*//*Label 29278*/ GIMT_Encode4(2216452), // Rule ID 45809 //
     /* 2216414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216417 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2216420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2216434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216451 */     // GIR_Coverage, 45809,
     /* 2216451 */     GIR_EraseRootFromParent_Done,
     /* 2216452 */   // Label 29278: @2216452
     /* 2216452 */   GIM_Reject,
     /* 2216453 */ // Label 29276: @2216453
     /* 2216453 */ GIM_Reject,
     /* 2216454 */ // Label 29243: @2216454
     /* 2216454 */ GIM_Try, /*On fail goto*//*Label 29279*/ GIMT_Encode4(2216508), // Rule ID 47520 //
     /* 2216459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216473 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216476 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216480 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2216490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216492 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216495 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216506 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216507 */   // GIR_Coverage, 47520,
     /* 2216507 */   GIR_EraseRootFromParent_Done,
     /* 2216508 */ // Label 29279: @2216508
     /* 2216508 */ GIM_Try, /*On fail goto*//*Label 29280*/ GIMT_Encode4(2216562), // Rule ID 47521 //
     /* 2216513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216527 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2216544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216549 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216560 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216561 */   // GIR_Coverage, 47521,
     /* 2216561 */   GIR_EraseRootFromParent_Done,
     /* 2216562 */ // Label 29280: @2216562
     /* 2216562 */ GIM_Try, /*On fail goto*//*Label 29281*/ GIMT_Encode4(2216616), // Rule ID 47586 //
     /* 2216567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216581 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216581 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216584 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216588 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2216598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216600 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216603 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216614 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216615 */   // GIR_Coverage, 47586,
     /* 2216615 */   GIR_EraseRootFromParent_Done,
     /* 2216616 */ // Label 29281: @2216616
     /* 2216616 */ GIM_Try, /*On fail goto*//*Label 29282*/ GIMT_Encode4(2216670), // Rule ID 47587 //
     /* 2216621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216635 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216635 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216638 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216642 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2216652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216657 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216668 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216669 */   // GIR_Coverage, 47587,
     /* 2216669 */   GIR_EraseRootFromParent_Done,
     /* 2216670 */ // Label 29282: @2216670
     /* 2216670 */ GIM_Reject,
     /* 2216671 */ // Label 29244: @2216671
     /* 2216671 */ GIM_Try, /*On fail goto*//*Label 29283*/ GIMT_Encode4(2216725), // Rule ID 47540 //
     /* 2216676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2216682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216690 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216693 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216697 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2216707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216712 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216723 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216724 */   // GIR_Coverage, 47540,
     /* 2216724 */   GIR_EraseRootFromParent_Done,
     /* 2216725 */ // Label 29283: @2216725
     /* 2216725 */ GIM_Try, /*On fail goto*//*Label 29284*/ GIMT_Encode4(2216779), // Rule ID 47541 //
     /* 2216730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2216736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216744 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2216761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216766 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216777 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216778 */   // GIR_Coverage, 47541,
     /* 2216778 */   GIR_EraseRootFromParent_Done,
     /* 2216779 */ // Label 29284: @2216779
     /* 2216779 */ GIM_Try, /*On fail goto*//*Label 29285*/ GIMT_Encode4(2216833), // Rule ID 47606 //
     /* 2216784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216798 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216798 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216805 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2216815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216817 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216820 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216831 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216832 */   // GIR_Coverage, 47606,
     /* 2216832 */   GIR_EraseRootFromParent_Done,
     /* 2216833 */ // Label 29285: @2216833
     /* 2216833 */ GIM_Try, /*On fail goto*//*Label 29286*/ GIMT_Encode4(2216887), // Rule ID 47607 //
     /* 2216838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216852 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216852 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216855 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216859 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2216869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216871 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216874 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216885 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216886 */   // GIR_Coverage, 47607,
     /* 2216886 */   GIR_EraseRootFromParent_Done,
     /* 2216887 */ // Label 29286: @2216887
     /* 2216887 */ GIM_Try, /*On fail goto*//*Label 29287*/ GIMT_Encode4(2216941), // Rule ID 47640 //
     /* 2216892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216906 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216906 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216909 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216913 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2216923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216925 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216928 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216940 */   // GIR_Coverage, 47640,
     /* 2216940 */   GIR_EraseRootFromParent_Done,
     /* 2216941 */ // Label 29287: @2216941
     /* 2216941 */ GIM_Try, /*On fail goto*//*Label 29288*/ GIMT_Encode4(2216995), // Rule ID 47641 //
     /* 2216946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216960 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2216977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216982 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216993 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216994 */   // GIR_Coverage, 47641,
     /* 2216994 */   GIR_EraseRootFromParent_Done,
     /* 2216995 */ // Label 29288: @2216995
     /* 2216995 */ GIM_Reject,
     /* 2216996 */ // Label 29245: @2216996
     /* 2216996 */ GIM_Try, /*On fail goto*//*Label 29289*/ GIMT_Encode4(2217099),
     /* 2217001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217012 */   GIM_Try, /*On fail goto*//*Label 29290*/ GIMT_Encode4(2217055), // Rule ID 47500 //
     /* 2217017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217020 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2217023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2217037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217054 */     // GIR_Coverage, 47500,
     /* 2217054 */     GIR_EraseRootFromParent_Done,
     /* 2217055 */   // Label 29290: @2217055
     /* 2217055 */   GIM_Try, /*On fail goto*//*Label 29291*/ GIMT_Encode4(2217098), // Rule ID 47501 //
     /* 2217060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217063 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2217066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2217080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217097 */     // GIR_Coverage, 47501,
     /* 2217097 */     GIR_EraseRootFromParent_Done,
     /* 2217098 */   // Label 29291: @2217098
     /* 2217098 */   GIM_Reject,
     /* 2217099 */ // Label 29289: @2217099
     /* 2217099 */ GIM_Reject,
     /* 2217100 */ // Label 29246: @2217100
     /* 2217100 */ GIM_Try, /*On fail goto*//*Label 29292*/ GIMT_Encode4(2217154), // Rule ID 47524 //
     /* 2217105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217119 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2217122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2217136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217141 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217152 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217153 */   // GIR_Coverage, 47524,
     /* 2217153 */   GIR_EraseRootFromParent_Done,
     /* 2217154 */ // Label 29292: @2217154
     /* 2217154 */ GIM_Try, /*On fail goto*//*Label 29293*/ GIMT_Encode4(2217208), // Rule ID 47525 //
     /* 2217159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217173 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217173 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2217176 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217180 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2217190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217195 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217207 */   // GIR_Coverage, 47525,
     /* 2217207 */   GIR_EraseRootFromParent_Done,
     /* 2217208 */ // Label 29293: @2217208
     /* 2217208 */ GIM_Try, /*On fail goto*//*Label 29294*/ GIMT_Encode4(2217262), // Rule ID 47590 //
     /* 2217213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217227 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2217230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2217244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217246 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217249 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217260 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217261 */   // GIR_Coverage, 47590,
     /* 2217261 */   GIR_EraseRootFromParent_Done,
     /* 2217262 */ // Label 29294: @2217262
     /* 2217262 */ GIM_Try, /*On fail goto*//*Label 29295*/ GIMT_Encode4(2217316), // Rule ID 47591 //
     /* 2217267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217281 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2217284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2217298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217303 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217314 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217315 */   // GIR_Coverage, 47591,
     /* 2217315 */   GIR_EraseRootFromParent_Done,
     /* 2217316 */ // Label 29295: @2217316
     /* 2217316 */ GIM_Reject,
     /* 2217317 */ // Label 29247: @2217317
     /* 2217317 */ GIM_Try, /*On fail goto*//*Label 29296*/ GIMT_Encode4(2217371), // Rule ID 47544 //
     /* 2217322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2217328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217336 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217358 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217369 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217370 */   // GIR_Coverage, 47544,
     /* 2217370 */   GIR_EraseRootFromParent_Done,
     /* 2217371 */ // Label 29296: @2217371
     /* 2217371 */ GIM_Try, /*On fail goto*//*Label 29297*/ GIMT_Encode4(2217425), // Rule ID 47545 //
     /* 2217376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2217382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217390 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217390 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217393 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217397 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217412 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217423 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217424 */   // GIR_Coverage, 47545,
     /* 2217424 */   GIR_EraseRootFromParent_Done,
     /* 2217425 */ // Label 29297: @2217425
     /* 2217425 */ GIM_Try, /*On fail goto*//*Label 29298*/ GIMT_Encode4(2217479), // Rule ID 47610 //
     /* 2217430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217444 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217444 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217447 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217451 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217466 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217478 */   // GIR_Coverage, 47610,
     /* 2217478 */   GIR_EraseRootFromParent_Done,
     /* 2217479 */ // Label 29298: @2217479
     /* 2217479 */ GIM_Try, /*On fail goto*//*Label 29299*/ GIMT_Encode4(2217533), // Rule ID 47611 //
     /* 2217484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217498 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217520 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217531 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217532 */   // GIR_Coverage, 47611,
     /* 2217532 */   GIR_EraseRootFromParent_Done,
     /* 2217533 */ // Label 29299: @2217533
     /* 2217533 */ GIM_Try, /*On fail goto*//*Label 29300*/ GIMT_Encode4(2217587), // Rule ID 47644 //
     /* 2217538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217552 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217552 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217555 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217559 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2217569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217571 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217574 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217585 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217586 */   // GIR_Coverage, 47644,
     /* 2217586 */   GIR_EraseRootFromParent_Done,
     /* 2217587 */ // Label 29300: @2217587
     /* 2217587 */ GIM_Try, /*On fail goto*//*Label 29301*/ GIMT_Encode4(2217641), // Rule ID 47645 //
     /* 2217592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217606 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2217623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217628 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217639 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217640 */   // GIR_Coverage, 47645,
     /* 2217640 */   GIR_EraseRootFromParent_Done,
     /* 2217641 */ // Label 29301: @2217641
     /* 2217641 */ GIM_Reject,
     /* 2217642 */ // Label 29248: @2217642
     /* 2217642 */ GIM_Try, /*On fail goto*//*Label 29302*/ GIMT_Encode4(2217745),
     /* 2217647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217658 */   GIM_Try, /*On fail goto*//*Label 29303*/ GIMT_Encode4(2217701), // Rule ID 47504 //
     /* 2217663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217666 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2217669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2217683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217700 */     // GIR_Coverage, 47504,
     /* 2217700 */     GIR_EraseRootFromParent_Done,
     /* 2217701 */   // Label 29303: @2217701
     /* 2217701 */   GIM_Try, /*On fail goto*//*Label 29304*/ GIMT_Encode4(2217744), // Rule ID 47505 //
     /* 2217706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217709 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2217712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2217726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217743 */     // GIR_Coverage, 47505,
     /* 2217743 */     GIR_EraseRootFromParent_Done,
     /* 2217744 */   // Label 29304: @2217744
     /* 2217744 */   GIM_Reject,
     /* 2217745 */ // Label 29302: @2217745
     /* 2217745 */ GIM_Reject,
     /* 2217746 */ // Label 29249: @2217746
     /* 2217746 */ GIM_Try, /*On fail goto*//*Label 29305*/ GIMT_Encode4(2217800), // Rule ID 47528 //
     /* 2217751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2217757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217765 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217787 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217798 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217799 */   // GIR_Coverage, 47528,
     /* 2217799 */   GIR_EraseRootFromParent_Done,
     /* 2217800 */ // Label 29305: @2217800
     /* 2217800 */ GIM_Try, /*On fail goto*//*Label 29306*/ GIMT_Encode4(2217854), // Rule ID 47529 //
     /* 2217805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2217811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217819 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217838 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217841 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217852 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217853 */   // GIR_Coverage, 47529,
     /* 2217853 */   GIR_EraseRootFromParent_Done,
     /* 2217854 */ // Label 29306: @2217854
     /* 2217854 */ GIM_Try, /*On fail goto*//*Label 29307*/ GIMT_Encode4(2217908), // Rule ID 47594 //
     /* 2217859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217873 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217873 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217876 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217880 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217895 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217906 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217907 */   // GIR_Coverage, 47594,
     /* 2217907 */   GIR_EraseRootFromParent_Done,
     /* 2217908 */ // Label 29307: @2217908
     /* 2217908 */ GIM_Try, /*On fail goto*//*Label 29308*/ GIMT_Encode4(2217962), // Rule ID 47595 //
     /* 2217913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217927 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217949 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217960 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217961 */   // GIR_Coverage, 47595,
     /* 2217961 */   GIR_EraseRootFromParent_Done,
     /* 2217962 */ // Label 29308: @2217962
     /* 2217962 */ GIM_Reject,
     /* 2217963 */ // Label 29250: @2217963
     /* 2217963 */ GIM_Try, /*On fail goto*//*Label 29309*/ GIMT_Encode4(2218017), // Rule ID 47548 //
     /* 2217968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2217974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217982 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217982 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217985 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217989 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2217999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218001 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218004 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218015 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218016 */   // GIR_Coverage, 47548,
     /* 2218016 */   GIR_EraseRootFromParent_Done,
     /* 2218017 */ // Label 29309: @2218017
     /* 2218017 */ GIM_Try, /*On fail goto*//*Label 29310*/ GIMT_Encode4(2218071), // Rule ID 47549 //
     /* 2218022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2218028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218036 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2218039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218058 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218069 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218070 */   // GIR_Coverage, 47549,
     /* 2218070 */   GIR_EraseRootFromParent_Done,
     /* 2218071 */ // Label 29310: @2218071
     /* 2218071 */ GIM_Try, /*On fail goto*//*Label 29311*/ GIMT_Encode4(2218125), // Rule ID 47614 //
     /* 2218076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2218082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218090 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2218093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2218107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218112 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218123 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218124 */   // GIR_Coverage, 47614,
     /* 2218124 */   GIR_EraseRootFromParent_Done,
     /* 2218125 */ // Label 29311: @2218125
     /* 2218125 */ GIM_Try, /*On fail goto*//*Label 29312*/ GIMT_Encode4(2218179), // Rule ID 47615 //
     /* 2218130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2218136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218144 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2218147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2218161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218166 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218177 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218178 */   // GIR_Coverage, 47615,
     /* 2218178 */   GIR_EraseRootFromParent_Done,
     /* 2218179 */ // Label 29312: @2218179
     /* 2218179 */ GIM_Try, /*On fail goto*//*Label 29313*/ GIMT_Encode4(2218233), // Rule ID 47648 //
     /* 2218184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2218190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218198 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218198 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2218201 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218205 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2218215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218220 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218231 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218232 */   // GIR_Coverage, 47648,
     /* 2218232 */   GIR_EraseRootFromParent_Done,
     /* 2218233 */ // Label 29313: @2218233
     /* 2218233 */ GIM_Try, /*On fail goto*//*Label 29314*/ GIMT_Encode4(2218287), // Rule ID 47649 //
     /* 2218238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2218244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218252 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2218255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2218269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218274 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218286 */   // GIR_Coverage, 47649,
     /* 2218286 */   GIR_EraseRootFromParent_Done,
     /* 2218287 */ // Label 29314: @2218287
     /* 2218287 */ GIM_Reject,
     /* 2218288 */ // Label 29251: @2218288
     /* 2218288 */ GIM_Try, /*On fail goto*//*Label 29315*/ GIMT_Encode4(2218391),
     /* 2218293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218304 */   GIM_Try, /*On fail goto*//*Label 29316*/ GIMT_Encode4(2218347), // Rule ID 47508 //
     /* 2218309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218312 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2218315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2218329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218346 */     // GIR_Coverage, 47508,
     /* 2218346 */     GIR_EraseRootFromParent_Done,
     /* 2218347 */   // Label 29316: @2218347
     /* 2218347 */   GIM_Try, /*On fail goto*//*Label 29317*/ GIMT_Encode4(2218390), // Rule ID 47509 //
     /* 2218352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218355 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2218358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2218372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218389 */     // GIR_Coverage, 47509,
     /* 2218389 */     GIR_EraseRootFromParent_Done,
     /* 2218390 */   // Label 29317: @2218390
     /* 2218390 */   GIM_Reject,
     /* 2218391 */ // Label 29315: @2218391
     /* 2218391 */ GIM_Reject,
     /* 2218392 */ // Label 29252: @2218392
     /* 2218392 */ GIM_Try, /*On fail goto*//*Label 29318*/ GIMT_Encode4(2218446), // Rule ID 47532 //
     /* 2218397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218411 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218433 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218445 */   // GIR_Coverage, 47532,
     /* 2218445 */   GIR_EraseRootFromParent_Done,
     /* 2218446 */ // Label 29318: @2218446
     /* 2218446 */ GIM_Try, /*On fail goto*//*Label 29319*/ GIMT_Encode4(2218500), // Rule ID 47533 //
     /* 2218451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218465 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218487 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218498 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218499 */   // GIR_Coverage, 47533,
     /* 2218499 */   GIR_EraseRootFromParent_Done,
     /* 2218500 */ // Label 29319: @2218500
     /* 2218500 */ GIM_Try, /*On fail goto*//*Label 29320*/ GIMT_Encode4(2218554), // Rule ID 47598 //
     /* 2218505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218519 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2218536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218541 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218552 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218553 */   // GIR_Coverage, 47598,
     /* 2218553 */   GIR_EraseRootFromParent_Done,
     /* 2218554 */ // Label 29320: @2218554
     /* 2218554 */ GIM_Try, /*On fail goto*//*Label 29321*/ GIMT_Encode4(2218608), // Rule ID 47599 //
     /* 2218559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218573 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2218590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218595 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218606 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218607 */   // GIR_Coverage, 47599,
     /* 2218607 */   GIR_EraseRootFromParent_Done,
     /* 2218608 */ // Label 29321: @2218608
     /* 2218608 */ GIM_Reject,
     /* 2218609 */ // Label 29253: @2218609
     /* 2218609 */ GIM_Try, /*On fail goto*//*Label 29322*/ GIMT_Encode4(2218663), // Rule ID 47552 //
     /* 2218614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2218620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218628 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218650 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218662 */   // GIR_Coverage, 47552,
     /* 2218662 */   GIR_EraseRootFromParent_Done,
     /* 2218663 */ // Label 29322: @2218663
     /* 2218663 */ GIM_Try, /*On fail goto*//*Label 29323*/ GIMT_Encode4(2218717), // Rule ID 47553 //
     /* 2218668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2218674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218682 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218704 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218716 */   // GIR_Coverage, 47553,
     /* 2218716 */   GIR_EraseRootFromParent_Done,
     /* 2218717 */ // Label 29323: @2218717
     /* 2218717 */ GIM_Try, /*On fail goto*//*Label 29324*/ GIMT_Encode4(2218771), // Rule ID 47618 //
     /* 2218722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218736 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2218753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218758 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218770 */   // GIR_Coverage, 47618,
     /* 2218770 */   GIR_EraseRootFromParent_Done,
     /* 2218771 */ // Label 29324: @2218771
     /* 2218771 */ GIM_Try, /*On fail goto*//*Label 29325*/ GIMT_Encode4(2218825), // Rule ID 47619 //
     /* 2218776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218790 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2218807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218812 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218824 */   // GIR_Coverage, 47619,
     /* 2218824 */   GIR_EraseRootFromParent_Done,
     /* 2218825 */ // Label 29325: @2218825
     /* 2218825 */ GIM_Try, /*On fail goto*//*Label 29326*/ GIMT_Encode4(2218879), // Rule ID 47652 //
     /* 2218830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218844 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218844 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218847 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218851 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2218861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218863 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218866 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218878 */   // GIR_Coverage, 47652,
     /* 2218878 */   GIR_EraseRootFromParent_Done,
     /* 2218879 */ // Label 29326: @2218879
     /* 2218879 */ GIM_Try, /*On fail goto*//*Label 29327*/ GIMT_Encode4(2218933), // Rule ID 47653 //
     /* 2218884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218898 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2218915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218920 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218932 */   // GIR_Coverage, 47653,
     /* 2218932 */   GIR_EraseRootFromParent_Done,
     /* 2218933 */ // Label 29327: @2218933
     /* 2218933 */ GIM_Reject,
     /* 2218934 */ // Label 29254: @2218934
     /* 2218934 */ GIM_Try, /*On fail goto*//*Label 29328*/ GIMT_Encode4(2219037),
     /* 2218939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2218942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218950 */   GIM_Try, /*On fail goto*//*Label 29329*/ GIMT_Encode4(2218993), // Rule ID 47512 //
     /* 2218955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218958 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2218961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218992 */     // GIR_Coverage, 47512,
     /* 2218992 */     GIR_EraseRootFromParent_Done,
     /* 2218993 */   // Label 29329: @2218993
     /* 2218993 */   GIM_Try, /*On fail goto*//*Label 29330*/ GIMT_Encode4(2219036), // Rule ID 47513 //
     /* 2218998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219001 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2219004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2219018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219035 */     // GIR_Coverage, 47513,
     /* 2219035 */     GIR_EraseRootFromParent_Done,
     /* 2219036 */   // Label 29330: @2219036
     /* 2219036 */   GIM_Reject,
     /* 2219037 */ // Label 29328: @2219037
     /* 2219037 */ GIM_Reject,
     /* 2219038 */ // Label 29255: @2219038
     /* 2219038 */ GIM_Try, /*On fail goto*//*Label 29331*/ GIMT_Encode4(2219092), // Rule ID 47536 //
     /* 2219043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2219049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219057 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2219060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2219074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219076 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219079 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219091 */   // GIR_Coverage, 47536,
     /* 2219091 */   GIR_EraseRootFromParent_Done,
     /* 2219092 */ // Label 29331: @2219092
     /* 2219092 */ GIM_Try, /*On fail goto*//*Label 29332*/ GIMT_Encode4(2219146), // Rule ID 47537 //
     /* 2219097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2219103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219111 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2219114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2219128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219133 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219145 */   // GIR_Coverage, 47537,
     /* 2219145 */   GIR_EraseRootFromParent_Done,
     /* 2219146 */ // Label 29332: @2219146
     /* 2219146 */ GIM_Try, /*On fail goto*//*Label 29333*/ GIMT_Encode4(2219200), // Rule ID 47602 //
     /* 2219151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2219157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219165 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2219168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2219182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219187 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219199 */   // GIR_Coverage, 47602,
     /* 2219199 */   GIR_EraseRootFromParent_Done,
     /* 2219200 */ // Label 29333: @2219200
     /* 2219200 */ GIM_Try, /*On fail goto*//*Label 29334*/ GIMT_Encode4(2219254), // Rule ID 47603 //
     /* 2219205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2219211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219219 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2219222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2219236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219241 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219253 */   // GIR_Coverage, 47603,
     /* 2219253 */   GIR_EraseRootFromParent_Done,
     /* 2219254 */ // Label 29334: @2219254
     /* 2219254 */ GIM_Reject,
     /* 2219255 */ // Label 29256: @2219255
     /* 2219255 */ GIM_Try, /*On fail goto*//*Label 29335*/ GIMT_Encode4(2219358),
     /* 2219260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2219263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219271 */   GIM_Try, /*On fail goto*//*Label 29336*/ GIMT_Encode4(2219314), // Rule ID 47516 //
     /* 2219276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219279 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2219282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2219296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219313 */     // GIR_Coverage, 47516,
     /* 2219313 */     GIR_EraseRootFromParent_Done,
     /* 2219314 */   // Label 29336: @2219314
     /* 2219314 */   GIM_Try, /*On fail goto*//*Label 29337*/ GIMT_Encode4(2219357), // Rule ID 47517 //
     /* 2219319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219322 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2219325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2219339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219356 */     // GIR_Coverage, 47517,
     /* 2219356 */     GIR_EraseRootFromParent_Done,
     /* 2219357 */   // Label 29337: @2219357
     /* 2219357 */   GIM_Reject,
     /* 2219358 */ // Label 29335: @2219358
     /* 2219358 */ GIM_Reject,
     /* 2219359 */ // Label 29257: @2219359
     /* 2219359 */ GIM_Reject,
     /* 2219360 */ // Label 43: @2219360
     /* 2219360 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29362*/ GIMT_Encode4(2227955),
     /* 2219371 */ /*GILLT_s32*//*Label 29338*/ GIMT_Encode4(2219495),
     /* 2219375 */ /*GILLT_s64*//*Label 29339*/ GIMT_Encode4(2219620), GIMT_Encode4(0),
     /* 2219383 */ /*GILLT_nxv1s8*//*Label 29340*/ GIMT_Encode4(2219965),
     /* 2219387 */ /*GILLT_nxv1s16*//*Label 29341*/ GIMT_Encode4(2220080),
     /* 2219391 */ /*GILLT_nxv1s32*//*Label 29342*/ GIMT_Encode4(2220559),
     /* 2219395 */ /*GILLT_nxv1s64*//*Label 29343*/ GIMT_Encode4(2221038), GIMT_Encode4(0),
     /* 2219403 */ /*GILLT_nxv2s8*//*Label 29344*/ GIMT_Encode4(2221517),
     /* 2219407 */ /*GILLT_nxv2s16*//*Label 29345*/ GIMT_Encode4(2221632),
     /* 2219411 */ /*GILLT_nxv2s32*//*Label 29346*/ GIMT_Encode4(2222111),
     /* 2219415 */ /*GILLT_nxv2s64*//*Label 29347*/ GIMT_Encode4(2222590), GIMT_Encode4(0),
     /* 2219423 */ /*GILLT_nxv4s8*//*Label 29348*/ GIMT_Encode4(2223069),
     /* 2219427 */ /*GILLT_nxv4s16*//*Label 29349*/ GIMT_Encode4(2223184),
     /* 2219431 */ /*GILLT_nxv4s32*//*Label 29350*/ GIMT_Encode4(2223663),
     /* 2219435 */ /*GILLT_nxv4s64*//*Label 29351*/ GIMT_Encode4(2224142), GIMT_Encode4(0),
     /* 2219443 */ /*GILLT_nxv8s8*//*Label 29352*/ GIMT_Encode4(2224621),
     /* 2219447 */ /*GILLT_nxv8s16*//*Label 29353*/ GIMT_Encode4(2224736),
     /* 2219451 */ /*GILLT_nxv8s32*//*Label 29354*/ GIMT_Encode4(2225215),
     /* 2219455 */ /*GILLT_nxv8s64*//*Label 29355*/ GIMT_Encode4(2225694), GIMT_Encode4(0),
     /* 2219463 */ /*GILLT_nxv16s8*//*Label 29356*/ GIMT_Encode4(2226173),
     /* 2219467 */ /*GILLT_nxv16s16*//*Label 29357*/ GIMT_Encode4(2226288),
     /* 2219471 */ /*GILLT_nxv16s32*//*Label 29358*/ GIMT_Encode4(2226767), GIMT_Encode4(0),
     /* 2219479 */ /*GILLT_nxv32s8*//*Label 29359*/ GIMT_Encode4(2227246),
     /* 2219483 */ /*GILLT_nxv32s16*//*Label 29360*/ GIMT_Encode4(2227361), GIMT_Encode4(0),
     /* 2219491 */ /*GILLT_nxv64s8*//*Label 29361*/ GIMT_Encode4(2227840),
     /* 2219495 */ // Label 29338: @2219495
     /* 2219495 */ GIM_Try, /*On fail goto*//*Label 29363*/ GIMT_Encode4(2219619),
     /* 2219500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2219503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2219506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219510 */   GIM_Try, /*On fail goto*//*Label 29364*/ GIMT_Encode4(2219547), // Rule ID 2491 //
     /* 2219515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /* 2219518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2219522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219529 */     // (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2)
     /* 2219529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2219532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219546 */     // GIR_Coverage, 2491,
     /* 2219546 */     GIR_EraseRootFromParent_Done,
     /* 2219547 */   // Label 29364: @2219547
     /* 2219547 */   GIM_Try, /*On fail goto*//*Label 29365*/ GIMT_Encode4(2219585), // Rule ID 105 //
     /* 2219552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2219555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2219571 */     // MIs[1] Operand 1
     /* 2219571 */     // No operand predicates
     /* 2219571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219573 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2219573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219584 */     // GIR_Coverage, 105,
     /* 2219584 */     GIR_EraseRootFromParent_Done,
     /* 2219585 */   // Label 29365: @2219585
     /* 2219585 */   GIM_Try, /*On fail goto*//*Label 29366*/ GIMT_Encode4(2219618), // Rule ID 119 //
     /* 2219590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2219593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219604 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SLL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2219604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2219607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219617 */     // GIR_Coverage, 119,
     /* 2219617 */     GIR_EraseRootFromParent_Done,
     /* 2219618 */   // Label 29366: @2219618
     /* 2219618 */   GIM_Reject,
     /* 2219619 */ // Label 29363: @2219619
     /* 2219619 */ GIM_Reject,
     /* 2219620 */ // Label 29339: @2219620
     /* 2219620 */ GIM_Try, /*On fail goto*//*Label 29367*/ GIMT_Encode4(2219964),
     /* 2219625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219631 */   GIM_Try, /*On fail goto*//*Label 29368*/ GIMT_Encode4(2219725), // Rule ID 271 //
     /* 2219636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2219639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2219651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219664 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2219675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219683 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2219687 */     // MIs[2] Operand 1
     /* 2219687 */     // No operand predicates
     /* 2219687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219689 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt))
     /* 2219689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2219692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2219705 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2219708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2219713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219718 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // shamt
     /* 2219723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219724 */     // GIR_Coverage, 271,
     /* 2219724 */     GIR_EraseRootFromParent_Done,
     /* 2219725 */   // Label 29368: @2219725
     /* 2219725 */   GIM_Try, /*On fail goto*//*Label 29369*/ GIMT_Encode4(2219797), // Rule ID 2631 //
     /* 2219730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2219733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2219745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219758 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2219769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219777 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2219781 */     // MIs[2] Operand 1
     /* 2219781 */     // No operand predicates
     /* 2219781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219783 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SLLI_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2219783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /* 2219786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2219792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2219795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219796 */     // GIR_Coverage, 2631,
     /* 2219796 */     GIR_EraseRootFromParent_Done,
     /* 2219797 */   // Label 29369: @2219797
     /* 2219797 */   GIM_Try, /*On fail goto*//*Label 29370*/ GIMT_Encode4(2219838), // Rule ID 2490 //
     /* 2219802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /* 2219805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2219813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219820 */     // (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2)
     /* 2219820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2219823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219837 */     // GIR_Coverage, 2490,
     /* 2219837 */     GIR_EraseRootFromParent_Done,
     /* 2219838 */   // Label 29370: @2219838
     /* 2219838 */   GIM_Try, /*On fail goto*//*Label 29371*/ GIMT_Encode4(2219884), // Rule ID 286 //
     /* 2219843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2219846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2219866 */     // MIs[1] Operand 1
     /* 2219866 */     // No operand predicates
     /* 2219866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10088),
     /* 2219870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219872 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)<<P:Predicate_anonymous_10088>>  =>  (SLLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2219872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLIW),
     /* 2219875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219883 */     // GIR_Coverage, 286,
     /* 2219883 */     GIR_EraseRootFromParent_Done,
     /* 2219884 */   // Label 29371: @2219884
     /* 2219884 */   GIM_Try, /*On fail goto*//*Label 29372*/ GIMT_Encode4(2219926), // Rule ID 104 //
     /* 2219889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2219892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2219912 */     // MIs[1] Operand 1
     /* 2219912 */     // No operand predicates
     /* 2219912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219914 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2219914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219925 */     // GIR_Coverage, 104,
     /* 2219925 */     GIR_EraseRootFromParent_Done,
     /* 2219926 */   // Label 29372: @2219926
     /* 2219926 */   GIM_Try, /*On fail goto*//*Label 29373*/ GIMT_Encode4(2219963), // Rule ID 118 //
     /* 2219931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2219934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219949 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2219949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2219952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219962 */     // GIR_Coverage, 118,
     /* 2219962 */     GIR_EraseRootFromParent_Done,
     /* 2219963 */   // Label 29373: @2219963
     /* 2219963 */   GIM_Reject,
     /* 2219964 */ // Label 29367: @2219964
     /* 2219964 */ GIM_Reject,
     /* 2219965 */ // Label 29340: @2219965
     /* 2219965 */ GIM_Try, /*On fail goto*//*Label 29374*/ GIMT_Encode4(2220079),
     /* 2219970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2219976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219988 */   GIM_Try, /*On fail goto*//*Label 29375*/ GIMT_Encode4(2220033), // Rule ID 48060 //
     /* 2219993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219996 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2219999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2220013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220032 */     // GIR_Coverage, 48060,
     /* 2220032 */     GIR_EraseRootFromParent_Done,
     /* 2220033 */   // Label 29375: @2220033
     /* 2220033 */   GIM_Try, /*On fail goto*//*Label 29376*/ GIMT_Encode4(2220078), // Rule ID 48061 //
     /* 2220038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220041 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2220044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2220058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220077 */     // GIR_Coverage, 48061,
     /* 2220077 */     GIR_EraseRootFromParent_Done,
     /* 2220078 */   // Label 29376: @2220078
     /* 2220078 */   GIM_Reject,
     /* 2220079 */ // Label 29374: @2220079
     /* 2220079 */ GIM_Reject,
     /* 2220080 */ // Label 29341: @2220080
     /* 2220080 */ GIM_Try, /*On fail goto*//*Label 29377*/ GIMT_Encode4(2220558),
     /* 2220085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2220091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220095 */   GIM_Try, /*On fail goto*//*Label 29378*/ GIMT_Encode4(2220184), // Rule ID 59548 //
     /* 2220100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2220103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220115 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220134 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220143 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2220160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220183 */     // GIR_Coverage, 59548,
     /* 2220183 */     GIR_EraseRootFromParent_Done,
     /* 2220184 */   // Label 29378: @2220184
     /* 2220184 */   GIM_Try, /*On fail goto*//*Label 29379*/ GIMT_Encode4(2220273), // Rule ID 59549 //
     /* 2220189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2220192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220204 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220223 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220232 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2220249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220272 */     // GIR_Coverage, 59549,
     /* 2220272 */     GIR_EraseRootFromParent_Done,
     /* 2220273 */   // Label 29379: @2220273
     /* 2220273 */   GIM_Try, /*On fail goto*//*Label 29380*/ GIMT_Encode4(2220362), // Rule ID 59550 //
     /* 2220278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2220281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220293 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220312 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220321 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2220338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220361 */     // GIR_Coverage, 59550,
     /* 2220361 */     GIR_EraseRootFromParent_Done,
     /* 2220362 */   // Label 29380: @2220362
     /* 2220362 */   GIM_Try, /*On fail goto*//*Label 29381*/ GIMT_Encode4(2220451), // Rule ID 59551 //
     /* 2220367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2220370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220382 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220401 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220410 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2220427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220450 */     // GIR_Coverage, 59551,
     /* 2220450 */     GIR_EraseRootFromParent_Done,
     /* 2220451 */   // Label 29381: @2220451
     /* 2220451 */   GIM_Try, /*On fail goto*//*Label 29382*/ GIMT_Encode4(2220504), // Rule ID 48072 //
     /* 2220456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220467 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2220484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220503 */     // GIR_Coverage, 48072,
     /* 2220503 */     GIR_EraseRootFromParent_Done,
     /* 2220504 */   // Label 29382: @2220504
     /* 2220504 */   GIM_Try, /*On fail goto*//*Label 29383*/ GIMT_Encode4(2220557), // Rule ID 48073 //
     /* 2220509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220520 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2220537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220556 */     // GIR_Coverage, 48073,
     /* 2220556 */     GIR_EraseRootFromParent_Done,
     /* 2220557 */   // Label 29383: @2220557
     /* 2220557 */   GIM_Reject,
     /* 2220558 */ // Label 29377: @2220558
     /* 2220558 */ GIM_Reject,
     /* 2220559 */ // Label 29342: @2220559
     /* 2220559 */ GIM_Try, /*On fail goto*//*Label 29384*/ GIMT_Encode4(2221037),
     /* 2220564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2220570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220574 */   GIM_Try, /*On fail goto*//*Label 29385*/ GIMT_Encode4(2220663), // Rule ID 59596 //
     /* 2220579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2220582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220594 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220613 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220622 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220662 */     // GIR_Coverage, 59596,
     /* 2220662 */     GIR_EraseRootFromParent_Done,
     /* 2220663 */   // Label 29385: @2220663
     /* 2220663 */   GIM_Try, /*On fail goto*//*Label 29386*/ GIMT_Encode4(2220752), // Rule ID 59597 //
     /* 2220668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2220671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220683 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220702 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220711 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220751 */     // GIR_Coverage, 59597,
     /* 2220751 */     GIR_EraseRootFromParent_Done,
     /* 2220752 */   // Label 29386: @2220752
     /* 2220752 */   GIM_Try, /*On fail goto*//*Label 29387*/ GIMT_Encode4(2220841), // Rule ID 59598 //
     /* 2220757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2220760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220772 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220791 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220793 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220800 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220840 */     // GIR_Coverage, 59598,
     /* 2220840 */     GIR_EraseRootFromParent_Done,
     /* 2220841 */   // Label 29387: @2220841
     /* 2220841 */   GIM_Try, /*On fail goto*//*Label 29388*/ GIMT_Encode4(2220930), // Rule ID 59599 //
     /* 2220846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2220849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220861 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220880 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220889 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220929 */     // GIR_Coverage, 59599,
     /* 2220929 */     GIR_EraseRootFromParent_Done,
     /* 2220930 */   // Label 29388: @2220930
     /* 2220930 */   GIM_Try, /*On fail goto*//*Label 29389*/ GIMT_Encode4(2220983), // Rule ID 48080 //
     /* 2220935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220946 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2220963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220982 */     // GIR_Coverage, 48080,
     /* 2220982 */     GIR_EraseRootFromParent_Done,
     /* 2220983 */   // Label 29389: @2220983
     /* 2220983 */   GIM_Try, /*On fail goto*//*Label 29390*/ GIMT_Encode4(2221036), // Rule ID 48081 //
     /* 2220988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220999 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2221002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2221016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221035 */     // GIR_Coverage, 48081,
     /* 2221035 */     GIR_EraseRootFromParent_Done,
     /* 2221036 */   // Label 29390: @2221036
     /* 2221036 */   GIM_Reject,
     /* 2221037 */ // Label 29384: @2221037
     /* 2221037 */ GIM_Reject,
     /* 2221038 */ // Label 29343: @2221038
     /* 2221038 */ GIM_Try, /*On fail goto*//*Label 29391*/ GIMT_Encode4(2221516),
     /* 2221043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2221046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2221049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221053 */   GIM_Try, /*On fail goto*//*Label 29392*/ GIMT_Encode4(2221142), // Rule ID 59636 //
     /* 2221058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2221061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221073 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221092 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221101 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221141 */     // GIR_Coverage, 59636,
     /* 2221141 */     GIR_EraseRootFromParent_Done,
     /* 2221142 */   // Label 29392: @2221142
     /* 2221142 */   GIM_Try, /*On fail goto*//*Label 29393*/ GIMT_Encode4(2221231), // Rule ID 59637 //
     /* 2221147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2221150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221162 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221181 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221190 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221230 */     // GIR_Coverage, 59637,
     /* 2221230 */     GIR_EraseRootFromParent_Done,
     /* 2221231 */   // Label 29393: @2221231
     /* 2221231 */   GIM_Try, /*On fail goto*//*Label 29394*/ GIMT_Encode4(2221320), // Rule ID 59638 //
     /* 2221236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2221239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221251 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221270 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221279 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221319 */     // GIR_Coverage, 59638,
     /* 2221319 */     GIR_EraseRootFromParent_Done,
     /* 2221320 */   // Label 29394: @2221320
     /* 2221320 */   GIM_Try, /*On fail goto*//*Label 29395*/ GIMT_Encode4(2221409), // Rule ID 59639 //
     /* 2221325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2221328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221340 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221359 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221368 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221408 */     // GIR_Coverage, 59639,
     /* 2221408 */     GIR_EraseRootFromParent_Done,
     /* 2221409 */   // Label 29395: @2221409
     /* 2221409 */   GIM_Try, /*On fail goto*//*Label 29396*/ GIMT_Encode4(2221462), // Rule ID 48096 //
     /* 2221414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2221417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221425 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2221442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221461 */     // GIR_Coverage, 48096,
     /* 2221461 */     GIR_EraseRootFromParent_Done,
     /* 2221462 */   // Label 29396: @2221462
     /* 2221462 */   GIM_Try, /*On fail goto*//*Label 29397*/ GIMT_Encode4(2221515), // Rule ID 48097 //
     /* 2221467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2221470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221478 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2221495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221514 */     // GIR_Coverage, 48097,
     /* 2221514 */     GIR_EraseRootFromParent_Done,
     /* 2221515 */   // Label 29397: @2221515
     /* 2221515 */   GIM_Reject,
     /* 2221516 */ // Label 29391: @2221516
     /* 2221516 */ GIM_Reject,
     /* 2221517 */ // Label 29344: @2221517
     /* 2221517 */ GIM_Try, /*On fail goto*//*Label 29398*/ GIMT_Encode4(2221631),
     /* 2221522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2221528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221540 */   GIM_Try, /*On fail goto*//*Label 29399*/ GIMT_Encode4(2221585), // Rule ID 48064 //
     /* 2221545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221548 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2221551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2221565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221584 */     // GIR_Coverage, 48064,
     /* 2221584 */     GIR_EraseRootFromParent_Done,
     /* 2221585 */   // Label 29399: @2221585
     /* 2221585 */   GIM_Try, /*On fail goto*//*Label 29400*/ GIMT_Encode4(2221630), // Rule ID 48065 //
     /* 2221590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221593 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2221596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2221610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221629 */     // GIR_Coverage, 48065,
     /* 2221629 */     GIR_EraseRootFromParent_Done,
     /* 2221630 */   // Label 29400: @2221630
     /* 2221630 */   GIM_Reject,
     /* 2221631 */ // Label 29398: @2221631
     /* 2221631 */ GIM_Reject,
     /* 2221632 */ // Label 29345: @2221632
     /* 2221632 */ GIM_Try, /*On fail goto*//*Label 29401*/ GIMT_Encode4(2222110),
     /* 2221637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2221643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221647 */   GIM_Try, /*On fail goto*//*Label 29402*/ GIMT_Encode4(2221736), // Rule ID 59556 //
     /* 2221652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2221655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221667 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221686 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221695 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221735 */     // GIR_Coverage, 59556,
     /* 2221735 */     GIR_EraseRootFromParent_Done,
     /* 2221736 */   // Label 29402: @2221736
     /* 2221736 */   GIM_Try, /*On fail goto*//*Label 29403*/ GIMT_Encode4(2221825), // Rule ID 59557 //
     /* 2221741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2221744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221756 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221775 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221784 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221824 */     // GIR_Coverage, 59557,
     /* 2221824 */     GIR_EraseRootFromParent_Done,
     /* 2221825 */   // Label 29403: @2221825
     /* 2221825 */   GIM_Try, /*On fail goto*//*Label 29404*/ GIMT_Encode4(2221914), // Rule ID 59558 //
     /* 2221830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2221833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221845 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221864 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221873 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221913 */     // GIR_Coverage, 59558,
     /* 2221913 */     GIR_EraseRootFromParent_Done,
     /* 2221914 */   // Label 29404: @2221914
     /* 2221914 */   GIM_Try, /*On fail goto*//*Label 29405*/ GIMT_Encode4(2222003), // Rule ID 59559 //
     /* 2221919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2221922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221934 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221953 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221962 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222002 */     // GIR_Coverage, 59559,
     /* 2222002 */     GIR_EraseRootFromParent_Done,
     /* 2222003 */   // Label 29405: @2222003
     /* 2222003 */   GIM_Try, /*On fail goto*//*Label 29406*/ GIMT_Encode4(2222056), // Rule ID 48076 //
     /* 2222008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222019 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2222022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2222036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222055 */     // GIR_Coverage, 48076,
     /* 2222055 */     GIR_EraseRootFromParent_Done,
     /* 2222056 */   // Label 29406: @2222056
     /* 2222056 */   GIM_Try, /*On fail goto*//*Label 29407*/ GIMT_Encode4(2222109), // Rule ID 48077 //
     /* 2222061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222072 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2222075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2222089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222108 */     // GIR_Coverage, 48077,
     /* 2222108 */     GIR_EraseRootFromParent_Done,
     /* 2222109 */   // Label 29407: @2222109
     /* 2222109 */   GIM_Reject,
     /* 2222110 */ // Label 29401: @2222110
     /* 2222110 */ GIM_Reject,
     /* 2222111 */ // Label 29346: @2222111
     /* 2222111 */ GIM_Try, /*On fail goto*//*Label 29408*/ GIMT_Encode4(2222589),
     /* 2222116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2222122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222126 */   GIM_Try, /*On fail goto*//*Label 29409*/ GIMT_Encode4(2222215), // Rule ID 59604 //
     /* 2222131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2222134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222146 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222165 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222174 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222214 */     // GIR_Coverage, 59604,
     /* 2222214 */     GIR_EraseRootFromParent_Done,
     /* 2222215 */   // Label 29409: @2222215
     /* 2222215 */   GIM_Try, /*On fail goto*//*Label 29410*/ GIMT_Encode4(2222304), // Rule ID 59605 //
     /* 2222220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2222223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222235 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222254 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222263 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222303 */     // GIR_Coverage, 59605,
     /* 2222303 */     GIR_EraseRootFromParent_Done,
     /* 2222304 */   // Label 29410: @2222304
     /* 2222304 */   GIM_Try, /*On fail goto*//*Label 29411*/ GIMT_Encode4(2222393), // Rule ID 59606 //
     /* 2222309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2222312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222324 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222343 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222352 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222392 */     // GIR_Coverage, 59606,
     /* 2222392 */     GIR_EraseRootFromParent_Done,
     /* 2222393 */   // Label 29411: @2222393
     /* 2222393 */   GIM_Try, /*On fail goto*//*Label 29412*/ GIMT_Encode4(2222482), // Rule ID 59607 //
     /* 2222398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2222401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222413 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222432 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222441 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222481 */     // GIR_Coverage, 59607,
     /* 2222481 */     GIR_EraseRootFromParent_Done,
     /* 2222482 */   // Label 29412: @2222482
     /* 2222482 */   GIM_Try, /*On fail goto*//*Label 29413*/ GIMT_Encode4(2222535), // Rule ID 48092 //
     /* 2222487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222498 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2222515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222534 */     // GIR_Coverage, 48092,
     /* 2222534 */     GIR_EraseRootFromParent_Done,
     /* 2222535 */   // Label 29413: @2222535
     /* 2222535 */   GIM_Try, /*On fail goto*//*Label 29414*/ GIMT_Encode4(2222588), // Rule ID 48093 //
     /* 2222540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222551 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2222568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222587 */     // GIR_Coverage, 48093,
     /* 2222587 */     GIR_EraseRootFromParent_Done,
     /* 2222588 */   // Label 29414: @2222588
     /* 2222588 */   GIM_Reject,
     /* 2222589 */ // Label 29408: @2222589
     /* 2222589 */ GIM_Reject,
     /* 2222590 */ // Label 29347: @2222590
     /* 2222590 */ GIM_Try, /*On fail goto*//*Label 29415*/ GIMT_Encode4(2223068),
     /* 2222595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2222598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2222601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222605 */   GIM_Try, /*On fail goto*//*Label 29416*/ GIMT_Encode4(2222694), // Rule ID 59644 //
     /* 2222610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2222613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222625 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222644 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222653 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222693 */     // GIR_Coverage, 59644,
     /* 2222693 */     GIR_EraseRootFromParent_Done,
     /* 2222694 */   // Label 29416: @2222694
     /* 2222694 */   GIM_Try, /*On fail goto*//*Label 29417*/ GIMT_Encode4(2222783), // Rule ID 59645 //
     /* 2222699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2222702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222714 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222733 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222742 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222782 */     // GIR_Coverage, 59645,
     /* 2222782 */     GIR_EraseRootFromParent_Done,
     /* 2222783 */   // Label 29417: @2222783
     /* 2222783 */   GIM_Try, /*On fail goto*//*Label 29418*/ GIMT_Encode4(2222872), // Rule ID 59646 //
     /* 2222788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2222791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222803 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222822 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222831 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222871 */     // GIR_Coverage, 59646,
     /* 2222871 */     GIR_EraseRootFromParent_Done,
     /* 2222872 */   // Label 29418: @2222872
     /* 2222872 */   GIM_Try, /*On fail goto*//*Label 29419*/ GIMT_Encode4(2222961), // Rule ID 59647 //
     /* 2222877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2222880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222892 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222911 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222920 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222960 */     // GIR_Coverage, 59647,
     /* 2222960 */     GIR_EraseRootFromParent_Done,
     /* 2222961 */   // Label 29419: @2222961
     /* 2222961 */   GIM_Try, /*On fail goto*//*Label 29420*/ GIMT_Encode4(2223014), // Rule ID 48136 //
     /* 2222966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2222969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222977 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2222994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2223009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223013 */     // GIR_Coverage, 48136,
     /* 2223013 */     GIR_EraseRootFromParent_Done,
     /* 2223014 */   // Label 29420: @2223014
     /* 2223014 */   GIM_Try, /*On fail goto*//*Label 29421*/ GIMT_Encode4(2223067), // Rule ID 48137 //
     /* 2223019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2223022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223030 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2223033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2223047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2223062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223066 */     // GIR_Coverage, 48137,
     /* 2223066 */     GIR_EraseRootFromParent_Done,
     /* 2223067 */   // Label 29421: @2223067
     /* 2223067 */   GIM_Reject,
     /* 2223068 */ // Label 29415: @2223068
     /* 2223068 */ GIM_Reject,
     /* 2223069 */ // Label 29348: @2223069
     /* 2223069 */ GIM_Try, /*On fail goto*//*Label 29422*/ GIMT_Encode4(2223183),
     /* 2223074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2223080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223092 */   GIM_Try, /*On fail goto*//*Label 29423*/ GIMT_Encode4(2223137), // Rule ID 48068 //
     /* 2223097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223100 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2223103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2223117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223136 */     // GIR_Coverage, 48068,
     /* 2223136 */     GIR_EraseRootFromParent_Done,
     /* 2223137 */   // Label 29423: @2223137
     /* 2223137 */   GIM_Try, /*On fail goto*//*Label 29424*/ GIMT_Encode4(2223182), // Rule ID 48069 //
     /* 2223142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223145 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2223148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2223162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223181 */     // GIR_Coverage, 48069,
     /* 2223181 */     GIR_EraseRootFromParent_Done,
     /* 2223182 */   // Label 29424: @2223182
     /* 2223182 */   GIM_Reject,
     /* 2223183 */ // Label 29422: @2223183
     /* 2223183 */ GIM_Reject,
     /* 2223184 */ // Label 29349: @2223184
     /* 2223184 */ GIM_Try, /*On fail goto*//*Label 29425*/ GIMT_Encode4(2223662),
     /* 2223189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2223195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223199 */   GIM_Try, /*On fail goto*//*Label 29426*/ GIMT_Encode4(2223288), // Rule ID 59564 //
     /* 2223204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223219 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223238 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223247 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2223264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223287 */     // GIR_Coverage, 59564,
     /* 2223287 */     GIR_EraseRootFromParent_Done,
     /* 2223288 */   // Label 29426: @2223288
     /* 2223288 */   GIM_Try, /*On fail goto*//*Label 29427*/ GIMT_Encode4(2223377), // Rule ID 59565 //
     /* 2223293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223308 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223327 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223336 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2223353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223376 */     // GIR_Coverage, 59565,
     /* 2223376 */     GIR_EraseRootFromParent_Done,
     /* 2223377 */   // Label 29427: @2223377
     /* 2223377 */   GIM_Try, /*On fail goto*//*Label 29428*/ GIMT_Encode4(2223466), // Rule ID 59566 //
     /* 2223382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223397 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223416 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223425 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2223442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223465 */     // GIR_Coverage, 59566,
     /* 2223465 */     GIR_EraseRootFromParent_Done,
     /* 2223466 */   // Label 29428: @2223466
     /* 2223466 */   GIM_Try, /*On fail goto*//*Label 29429*/ GIMT_Encode4(2223555), // Rule ID 59567 //
     /* 2223471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223486 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223505 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223514 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2223531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223554 */     // GIR_Coverage, 59567,
     /* 2223554 */     GIR_EraseRootFromParent_Done,
     /* 2223555 */   // Label 29429: @2223555
     /* 2223555 */   GIM_Try, /*On fail goto*//*Label 29430*/ GIMT_Encode4(2223608), // Rule ID 48088 //
     /* 2223560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223571 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2223588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223607 */     // GIR_Coverage, 48088,
     /* 2223607 */     GIR_EraseRootFromParent_Done,
     /* 2223608 */   // Label 29430: @2223608
     /* 2223608 */   GIM_Try, /*On fail goto*//*Label 29431*/ GIMT_Encode4(2223661), // Rule ID 48089 //
     /* 2223613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223624 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2223641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223660 */     // GIR_Coverage, 48089,
     /* 2223660 */     GIR_EraseRootFromParent_Done,
     /* 2223661 */   // Label 29431: @2223661
     /* 2223661 */   GIM_Reject,
     /* 2223662 */ // Label 29425: @2223662
     /* 2223662 */ GIM_Reject,
     /* 2223663 */ // Label 29350: @2223663
     /* 2223663 */ GIM_Try, /*On fail goto*//*Label 29432*/ GIMT_Encode4(2224141),
     /* 2223668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2223674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223678 */   GIM_Try, /*On fail goto*//*Label 29433*/ GIMT_Encode4(2223767), // Rule ID 59612 //
     /* 2223683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223698 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223717 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223719 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223726 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223766 */     // GIR_Coverage, 59612,
     /* 2223766 */     GIR_EraseRootFromParent_Done,
     /* 2223767 */   // Label 29433: @2223767
     /* 2223767 */   GIM_Try, /*On fail goto*//*Label 29434*/ GIMT_Encode4(2223856), // Rule ID 59613 //
     /* 2223772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223787 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223806 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223815 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223855 */     // GIR_Coverage, 59613,
     /* 2223855 */     GIR_EraseRootFromParent_Done,
     /* 2223856 */   // Label 29434: @2223856
     /* 2223856 */   GIM_Try, /*On fail goto*//*Label 29435*/ GIMT_Encode4(2223945), // Rule ID 59614 //
     /* 2223861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223876 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223895 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223904 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223944 */     // GIR_Coverage, 59614,
     /* 2223944 */     GIR_EraseRootFromParent_Done,
     /* 2223945 */   // Label 29435: @2223945
     /* 2223945 */   GIM_Try, /*On fail goto*//*Label 29436*/ GIMT_Encode4(2224034), // Rule ID 59615 //
     /* 2223950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223965 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223984 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223993 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224033 */     // GIR_Coverage, 59615,
     /* 2224033 */     GIR_EraseRootFromParent_Done,
     /* 2224034 */   // Label 29436: @2224034
     /* 2224034 */   GIM_Try, /*On fail goto*//*Label 29437*/ GIMT_Encode4(2224087), // Rule ID 48124 //
     /* 2224039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224050 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2224053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2224067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224086 */     // GIR_Coverage, 48124,
     /* 2224086 */     GIR_EraseRootFromParent_Done,
     /* 2224087 */   // Label 29437: @2224087
     /* 2224087 */   GIM_Try, /*On fail goto*//*Label 29438*/ GIMT_Encode4(2224140), // Rule ID 48125 //
     /* 2224092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224103 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2224106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2224120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224139 */     // GIR_Coverage, 48125,
     /* 2224139 */     GIR_EraseRootFromParent_Done,
     /* 2224140 */   // Label 29438: @2224140
     /* 2224140 */   GIM_Reject,
     /* 2224141 */ // Label 29432: @2224141
     /* 2224141 */ GIM_Reject,
     /* 2224142 */ // Label 29351: @2224142
     /* 2224142 */ GIM_Try, /*On fail goto*//*Label 29439*/ GIMT_Encode4(2224620),
     /* 2224147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2224150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2224153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224157 */   GIM_Try, /*On fail goto*//*Label 29440*/ GIMT_Encode4(2224246), // Rule ID 59652 //
     /* 2224162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2224165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224177 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224196 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224205 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224245 */     // GIR_Coverage, 59652,
     /* 2224245 */     GIR_EraseRootFromParent_Done,
     /* 2224246 */   // Label 29440: @2224246
     /* 2224246 */   GIM_Try, /*On fail goto*//*Label 29441*/ GIMT_Encode4(2224335), // Rule ID 59653 //
     /* 2224251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2224254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224266 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224285 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224294 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224334 */     // GIR_Coverage, 59653,
     /* 2224334 */     GIR_EraseRootFromParent_Done,
     /* 2224335 */   // Label 29441: @2224335
     /* 2224335 */   GIM_Try, /*On fail goto*//*Label 29442*/ GIMT_Encode4(2224424), // Rule ID 59654 //
     /* 2224340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2224343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224355 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224374 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224383 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224423 */     // GIR_Coverage, 59654,
     /* 2224423 */     GIR_EraseRootFromParent_Done,
     /* 2224424 */   // Label 29442: @2224424
     /* 2224424 */   GIM_Try, /*On fail goto*//*Label 29443*/ GIMT_Encode4(2224513), // Rule ID 59655 //
     /* 2224429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2224432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224444 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224463 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224472 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224512 */     // GIR_Coverage, 59655,
     /* 2224512 */     GIR_EraseRootFromParent_Done,
     /* 2224513 */   // Label 29443: @2224513
     /* 2224513 */   GIM_Try, /*On fail goto*//*Label 29444*/ GIMT_Encode4(2224566), // Rule ID 48140 //
     /* 2224518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2224521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224529 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2224546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224565 */     // GIR_Coverage, 48140,
     /* 2224565 */     GIR_EraseRootFromParent_Done,
     /* 2224566 */   // Label 29444: @2224566
     /* 2224566 */   GIM_Try, /*On fail goto*//*Label 29445*/ GIMT_Encode4(2224619), // Rule ID 48141 //
     /* 2224571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2224574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224582 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2224599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224618 */     // GIR_Coverage, 48141,
     /* 2224618 */     GIR_EraseRootFromParent_Done,
     /* 2224619 */   // Label 29445: @2224619
     /* 2224619 */   GIM_Reject,
     /* 2224620 */ // Label 29439: @2224620
     /* 2224620 */ GIM_Reject,
     /* 2224621 */ // Label 29352: @2224621
     /* 2224621 */ GIM_Try, /*On fail goto*//*Label 29446*/ GIMT_Encode4(2224735),
     /* 2224626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2224632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224644 */   GIM_Try, /*On fail goto*//*Label 29447*/ GIMT_Encode4(2224689), // Rule ID 48084 //
     /* 2224649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224652 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2224655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2224669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224688 */     // GIR_Coverage, 48084,
     /* 2224688 */     GIR_EraseRootFromParent_Done,
     /* 2224689 */   // Label 29447: @2224689
     /* 2224689 */   GIM_Try, /*On fail goto*//*Label 29448*/ GIMT_Encode4(2224734), // Rule ID 48085 //
     /* 2224694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224697 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2224700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2224714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224733 */     // GIR_Coverage, 48085,
     /* 2224733 */     GIR_EraseRootFromParent_Done,
     /* 2224734 */   // Label 29448: @2224734
     /* 2224734 */   GIM_Reject,
     /* 2224735 */ // Label 29446: @2224735
     /* 2224735 */ GIM_Reject,
     /* 2224736 */ // Label 29353: @2224736
     /* 2224736 */ GIM_Try, /*On fail goto*//*Label 29449*/ GIMT_Encode4(2225214),
     /* 2224741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2224747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224751 */   GIM_Try, /*On fail goto*//*Label 29450*/ GIMT_Encode4(2224840), // Rule ID 59572 //
     /* 2224756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224771 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224790 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224799 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224839 */     // GIR_Coverage, 59572,
     /* 2224839 */     GIR_EraseRootFromParent_Done,
     /* 2224840 */   // Label 29450: @2224840
     /* 2224840 */   GIM_Try, /*On fail goto*//*Label 29451*/ GIMT_Encode4(2224929), // Rule ID 59573 //
     /* 2224845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2224848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224860 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224879 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224888 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224928 */     // GIR_Coverage, 59573,
     /* 2224928 */     GIR_EraseRootFromParent_Done,
     /* 2224929 */   // Label 29451: @2224929
     /* 2224929 */   GIM_Try, /*On fail goto*//*Label 29452*/ GIMT_Encode4(2225018), // Rule ID 59574 //
     /* 2224934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224949 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224968 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224977 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225017 */     // GIR_Coverage, 59574,
     /* 2225017 */     GIR_EraseRootFromParent_Done,
     /* 2225018 */   // Label 29452: @2225018
     /* 2225018 */   GIM_Try, /*On fail goto*//*Label 29453*/ GIMT_Encode4(2225107), // Rule ID 59575 //
     /* 2225023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2225038 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2225057 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225066 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2225069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2225083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225106 */     // GIR_Coverage, 59575,
     /* 2225106 */     GIR_EraseRootFromParent_Done,
     /* 2225107 */   // Label 29453: @2225107
     /* 2225107 */   GIM_Try, /*On fail goto*//*Label 29454*/ GIMT_Encode4(2225160), // Rule ID 48112 //
     /* 2225112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225123 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2225126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2225140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225159 */     // GIR_Coverage, 48112,
     /* 2225159 */     GIR_EraseRootFromParent_Done,
     /* 2225160 */   // Label 29454: @2225160
     /* 2225160 */   GIM_Try, /*On fail goto*//*Label 29455*/ GIMT_Encode4(2225213), // Rule ID 48113 //
     /* 2225165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225176 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2225179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2225193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225212 */     // GIR_Coverage, 48113,
     /* 2225212 */     GIR_EraseRootFromParent_Done,
     /* 2225213 */   // Label 29455: @2225213
     /* 2225213 */   GIM_Reject,
     /* 2225214 */ // Label 29449: @2225214
     /* 2225214 */ GIM_Reject,
     /* 2225215 */ // Label 29354: @2225215
     /* 2225215 */ GIM_Try, /*On fail goto*//*Label 29456*/ GIMT_Encode4(2225693),
     /* 2225220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2225226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225230 */   GIM_Try, /*On fail goto*//*Label 29457*/ GIMT_Encode4(2225319), // Rule ID 59620 //
     /* 2225235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2225238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225250 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225269 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225278 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225318 */     // GIR_Coverage, 59620,
     /* 2225318 */     GIR_EraseRootFromParent_Done,
     /* 2225319 */   // Label 29457: @2225319
     /* 2225319 */   GIM_Try, /*On fail goto*//*Label 29458*/ GIMT_Encode4(2225408), // Rule ID 59621 //
     /* 2225324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225339 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225358 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225367 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225407 */     // GIR_Coverage, 59621,
     /* 2225407 */     GIR_EraseRootFromParent_Done,
     /* 2225408 */   // Label 29458: @2225408
     /* 2225408 */   GIM_Try, /*On fail goto*//*Label 29459*/ GIMT_Encode4(2225497), // Rule ID 59622 //
     /* 2225413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2225416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225428 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225447 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225456 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225496 */     // GIR_Coverage, 59622,
     /* 2225496 */     GIR_EraseRootFromParent_Done,
     /* 2225497 */   // Label 29459: @2225497
     /* 2225497 */   GIM_Try, /*On fail goto*//*Label 29460*/ GIMT_Encode4(2225586), // Rule ID 59623 //
     /* 2225502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225517 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225536 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225545 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225585 */     // GIR_Coverage, 59623,
     /* 2225585 */     GIR_EraseRootFromParent_Done,
     /* 2225586 */   // Label 29460: @2225586
     /* 2225586 */   GIM_Try, /*On fail goto*//*Label 29461*/ GIMT_Encode4(2225639), // Rule ID 48128 //
     /* 2225591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225602 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2225619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225638 */     // GIR_Coverage, 48128,
     /* 2225638 */     GIR_EraseRootFromParent_Done,
     /* 2225639 */   // Label 29461: @2225639
     /* 2225639 */   GIM_Try, /*On fail goto*//*Label 29462*/ GIMT_Encode4(2225692), // Rule ID 48129 //
     /* 2225644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225655 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2225672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225691 */     // GIR_Coverage, 48129,
     /* 2225691 */     GIR_EraseRootFromParent_Done,
     /* 2225692 */   // Label 29462: @2225692
     /* 2225692 */   GIM_Reject,
     /* 2225693 */ // Label 29456: @2225693
     /* 2225693 */ GIM_Reject,
     /* 2225694 */ // Label 29355: @2225694
     /* 2225694 */ GIM_Try, /*On fail goto*//*Label 29463*/ GIMT_Encode4(2226172),
     /* 2225699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2225702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2225705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225709 */   GIM_Try, /*On fail goto*//*Label 29464*/ GIMT_Encode4(2225798), // Rule ID 59660 //
     /* 2225714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2225717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225729 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225748 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225757 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225797 */     // GIR_Coverage, 59660,
     /* 2225797 */     GIR_EraseRootFromParent_Done,
     /* 2225798 */   // Label 29464: @2225798
     /* 2225798 */   GIM_Try, /*On fail goto*//*Label 29465*/ GIMT_Encode4(2225887), // Rule ID 59661 //
     /* 2225803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2225806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225818 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225837 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225846 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225886 */     // GIR_Coverage, 59661,
     /* 2225886 */     GIR_EraseRootFromParent_Done,
     /* 2225887 */   // Label 29465: @2225887
     /* 2225887 */   GIM_Try, /*On fail goto*//*Label 29466*/ GIMT_Encode4(2225976), // Rule ID 59662 //
     /* 2225892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2225895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225907 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225926 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225935 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225975 */     // GIR_Coverage, 59662,
     /* 2225975 */     GIR_EraseRootFromParent_Done,
     /* 2225976 */   // Label 29466: @2225976
     /* 2225976 */   GIM_Try, /*On fail goto*//*Label 29467*/ GIMT_Encode4(2226065), // Rule ID 59663 //
     /* 2225981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2225984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225996 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2226015 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226024 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2226027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226064 */     // GIR_Coverage, 59663,
     /* 2226064 */     GIR_EraseRootFromParent_Done,
     /* 2226065 */   // Label 29467: @2226065
     /* 2226065 */   GIM_Try, /*On fail goto*//*Label 29468*/ GIMT_Encode4(2226118), // Rule ID 48144 //
     /* 2226070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2226073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226081 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2226084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2226098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2226113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226117 */     // GIR_Coverage, 48144,
     /* 2226117 */     GIR_EraseRootFromParent_Done,
     /* 2226118 */   // Label 29468: @2226118
     /* 2226118 */   GIM_Try, /*On fail goto*//*Label 29469*/ GIMT_Encode4(2226171), // Rule ID 48145 //
     /* 2226123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2226126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226134 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2226137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2226151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2226166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226170 */     // GIR_Coverage, 48145,
     /* 2226170 */     GIR_EraseRootFromParent_Done,
     /* 2226171 */   // Label 29469: @2226171
     /* 2226171 */   GIM_Reject,
     /* 2226172 */ // Label 29463: @2226172
     /* 2226172 */ GIM_Reject,
     /* 2226173 */ // Label 29356: @2226173
     /* 2226173 */ GIM_Try, /*On fail goto*//*Label 29470*/ GIMT_Encode4(2226287),
     /* 2226178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2226184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226196 */   GIM_Try, /*On fail goto*//*Label 29471*/ GIMT_Encode4(2226241), // Rule ID 48100 //
     /* 2226201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226204 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2226207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2226221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226240 */     // GIR_Coverage, 48100,
     /* 2226240 */     GIR_EraseRootFromParent_Done,
     /* 2226241 */   // Label 29471: @2226241
     /* 2226241 */   GIM_Try, /*On fail goto*//*Label 29472*/ GIMT_Encode4(2226286), // Rule ID 48101 //
     /* 2226246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226249 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2226252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2226266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226285 */     // GIR_Coverage, 48101,
     /* 2226285 */     GIR_EraseRootFromParent_Done,
     /* 2226286 */   // Label 29472: @2226286
     /* 2226286 */   GIM_Reject,
     /* 2226287 */ // Label 29470: @2226287
     /* 2226287 */ GIM_Reject,
     /* 2226288 */ // Label 29357: @2226288
     /* 2226288 */ GIM_Try, /*On fail goto*//*Label 29473*/ GIMT_Encode4(2226766),
     /* 2226293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2226299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226303 */   GIM_Try, /*On fail goto*//*Label 29474*/ GIMT_Encode4(2226392), // Rule ID 59580 //
     /* 2226308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226323 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226342 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226351 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2226368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226391 */     // GIR_Coverage, 59580,
     /* 2226391 */     GIR_EraseRootFromParent_Done,
     /* 2226392 */   // Label 29474: @2226392
     /* 2226392 */   GIM_Try, /*On fail goto*//*Label 29475*/ GIMT_Encode4(2226481), // Rule ID 59581 //
     /* 2226397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226412 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226431 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226440 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2226457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226480 */     // GIR_Coverage, 59581,
     /* 2226480 */     GIR_EraseRootFromParent_Done,
     /* 2226481 */   // Label 29475: @2226481
     /* 2226481 */   GIM_Try, /*On fail goto*//*Label 29476*/ GIMT_Encode4(2226570), // Rule ID 59582 //
     /* 2226486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226501 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226520 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226529 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2226546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226569 */     // GIR_Coverage, 59582,
     /* 2226569 */     GIR_EraseRootFromParent_Done,
     /* 2226570 */   // Label 29476: @2226570
     /* 2226570 */   GIM_Try, /*On fail goto*//*Label 29477*/ GIMT_Encode4(2226659), // Rule ID 59583 //
     /* 2226575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226590 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226609 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226618 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2226635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226658 */     // GIR_Coverage, 59583,
     /* 2226658 */     GIR_EraseRootFromParent_Done,
     /* 2226659 */   // Label 29477: @2226659
     /* 2226659 */   GIM_Try, /*On fail goto*//*Label 29478*/ GIMT_Encode4(2226712), // Rule ID 48116 //
     /* 2226664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226675 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2226692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226711 */     // GIR_Coverage, 48116,
     /* 2226711 */     GIR_EraseRootFromParent_Done,
     /* 2226712 */   // Label 29478: @2226712
     /* 2226712 */   GIM_Try, /*On fail goto*//*Label 29479*/ GIMT_Encode4(2226765), // Rule ID 48117 //
     /* 2226717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226728 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2226745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226764 */     // GIR_Coverage, 48117,
     /* 2226764 */     GIR_EraseRootFromParent_Done,
     /* 2226765 */   // Label 29479: @2226765
     /* 2226765 */   GIM_Reject,
     /* 2226766 */ // Label 29473: @2226766
     /* 2226766 */ GIM_Reject,
     /* 2226767 */ // Label 29358: @2226767
     /* 2226767 */ GIM_Try, /*On fail goto*//*Label 29480*/ GIMT_Encode4(2227245),
     /* 2226772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2226775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2226778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226782 */   GIM_Try, /*On fail goto*//*Label 29481*/ GIMT_Encode4(2226871), // Rule ID 59628 //
     /* 2226787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226802 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226821 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226823 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226830 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226870 */     // GIR_Coverage, 59628,
     /* 2226870 */     GIR_EraseRootFromParent_Done,
     /* 2226871 */   // Label 29481: @2226871
     /* 2226871 */   GIM_Try, /*On fail goto*//*Label 29482*/ GIMT_Encode4(2226960), // Rule ID 59629 //
     /* 2226876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226891 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226910 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226919 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226959 */     // GIR_Coverage, 59629,
     /* 2226959 */     GIR_EraseRootFromParent_Done,
     /* 2226960 */   // Label 29482: @2226960
     /* 2226960 */   GIM_Try, /*On fail goto*//*Label 29483*/ GIMT_Encode4(2227049), // Rule ID 59630 //
     /* 2226965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226980 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226999 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227008 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2227011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227048 */     // GIR_Coverage, 59630,
     /* 2227048 */     GIR_EraseRootFromParent_Done,
     /* 2227049 */   // Label 29483: @2227049
     /* 2227049 */   GIM_Try, /*On fail goto*//*Label 29484*/ GIMT_Encode4(2227138), // Rule ID 59631 //
     /* 2227054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2227057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2227069 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2227088 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227097 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2227100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227137 */     // GIR_Coverage, 59631,
     /* 2227137 */     GIR_EraseRootFromParent_Done,
     /* 2227138 */   // Label 29484: @2227138
     /* 2227138 */   GIM_Try, /*On fail goto*//*Label 29485*/ GIMT_Encode4(2227191), // Rule ID 48132 //
     /* 2227143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227154 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2227157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227190 */     // GIR_Coverage, 48132,
     /* 2227190 */     GIR_EraseRootFromParent_Done,
     /* 2227191 */   // Label 29485: @2227191
     /* 2227191 */   GIM_Try, /*On fail goto*//*Label 29486*/ GIMT_Encode4(2227244), // Rule ID 48133 //
     /* 2227196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227207 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2227210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227243 */     // GIR_Coverage, 48133,
     /* 2227243 */     GIR_EraseRootFromParent_Done,
     /* 2227244 */   // Label 29486: @2227244
     /* 2227244 */   GIM_Reject,
     /* 2227245 */ // Label 29480: @2227245
     /* 2227245 */ GIM_Reject,
     /* 2227246 */ // Label 29359: @2227246
     /* 2227246 */ GIM_Try, /*On fail goto*//*Label 29487*/ GIMT_Encode4(2227360),
     /* 2227251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2227257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227269 */   GIM_Try, /*On fail goto*//*Label 29488*/ GIMT_Encode4(2227314), // Rule ID 48104 //
     /* 2227274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227277 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2227280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2227294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227313 */     // GIR_Coverage, 48104,
     /* 2227313 */     GIR_EraseRootFromParent_Done,
     /* 2227314 */   // Label 29488: @2227314
     /* 2227314 */   GIM_Try, /*On fail goto*//*Label 29489*/ GIMT_Encode4(2227359), // Rule ID 48105 //
     /* 2227319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227322 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2227325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2227339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227358 */     // GIR_Coverage, 48105,
     /* 2227358 */     GIR_EraseRootFromParent_Done,
     /* 2227359 */   // Label 29489: @2227359
     /* 2227359 */   GIM_Reject,
     /* 2227360 */ // Label 29487: @2227360
     /* 2227360 */ GIM_Reject,
     /* 2227361 */ // Label 29360: @2227361
     /* 2227361 */ GIM_Try, /*On fail goto*//*Label 29490*/ GIMT_Encode4(2227839),
     /* 2227366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2227369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2227372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227376 */   GIM_Try, /*On fail goto*//*Label 29491*/ GIMT_Encode4(2227465), // Rule ID 59588 //
     /* 2227381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2227384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227396 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2227411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227415 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227424 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227464 */     // GIR_Coverage, 59588,
     /* 2227464 */     GIR_EraseRootFromParent_Done,
     /* 2227465 */   // Label 29491: @2227465
     /* 2227465 */   GIM_Try, /*On fail goto*//*Label 29492*/ GIMT_Encode4(2227554), // Rule ID 59589 //
     /* 2227470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2227473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227485 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2227500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227504 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227513 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227553 */     // GIR_Coverage, 59589,
     /* 2227553 */     GIR_EraseRootFromParent_Done,
     /* 2227554 */   // Label 29492: @2227554
     /* 2227554 */   GIM_Try, /*On fail goto*//*Label 29493*/ GIMT_Encode4(2227643), // Rule ID 59590 //
     /* 2227559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2227562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227574 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227593 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227602 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227642 */     // GIR_Coverage, 59590,
     /* 2227642 */     GIR_EraseRootFromParent_Done,
     /* 2227643 */   // Label 29493: @2227643
     /* 2227643 */   GIM_Try, /*On fail goto*//*Label 29494*/ GIMT_Encode4(2227732), // Rule ID 59591 //
     /* 2227648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2227651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227663 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227682 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227691 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227731 */     // GIR_Coverage, 59591,
     /* 2227731 */     GIR_EraseRootFromParent_Done,
     /* 2227732 */   // Label 29494: @2227732
     /* 2227732 */   GIM_Try, /*On fail goto*//*Label 29495*/ GIMT_Encode4(2227785), // Rule ID 48120 //
     /* 2227737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227748 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227784 */     // GIR_Coverage, 48120,
     /* 2227784 */     GIR_EraseRootFromParent_Done,
     /* 2227785 */   // Label 29495: @2227785
     /* 2227785 */   GIM_Try, /*On fail goto*//*Label 29496*/ GIMT_Encode4(2227838), // Rule ID 48121 //
     /* 2227790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227801 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227837 */     // GIR_Coverage, 48121,
     /* 2227837 */     GIR_EraseRootFromParent_Done,
     /* 2227838 */   // Label 29496: @2227838
     /* 2227838 */   GIM_Reject,
     /* 2227839 */ // Label 29490: @2227839
     /* 2227839 */ GIM_Reject,
     /* 2227840 */ // Label 29361: @2227840
     /* 2227840 */ GIM_Try, /*On fail goto*//*Label 29497*/ GIMT_Encode4(2227954),
     /* 2227845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2227848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2227851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227863 */   GIM_Try, /*On fail goto*//*Label 29498*/ GIMT_Encode4(2227908), // Rule ID 48108 //
     /* 2227868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227871 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2227874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227907 */     // GIR_Coverage, 48108,
     /* 2227907 */     GIR_EraseRootFromParent_Done,
     /* 2227908 */   // Label 29498: @2227908
     /* 2227908 */   GIM_Try, /*On fail goto*//*Label 29499*/ GIMT_Encode4(2227953), // Rule ID 48109 //
     /* 2227913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227916 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2227919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227952 */     // GIR_Coverage, 48109,
     /* 2227952 */     GIR_EraseRootFromParent_Done,
     /* 2227953 */   // Label 29499: @2227953
     /* 2227953 */   GIM_Reject,
     /* 2227954 */ // Label 29497: @2227954
     /* 2227954 */ GIM_Reject,
     /* 2227955 */ // Label 29362: @2227955
     /* 2227955 */ GIM_Reject,
     /* 2227956 */ // Label 44: @2227956
     /* 2227956 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29524*/ GIMT_Encode4(2230986),
     /* 2227967 */ /*GILLT_s32*//*Label 29500*/ GIMT_Encode4(2228091),
     /* 2227971 */ /*GILLT_s64*//*Label 29501*/ GIMT_Encode4(2228175), GIMT_Encode4(0),
     /* 2227979 */ /*GILLT_nxv1s8*//*Label 29502*/ GIMT_Encode4(2228456),
     /* 2227983 */ /*GILLT_nxv1s16*//*Label 29503*/ GIMT_Encode4(2228571),
     /* 2227987 */ /*GILLT_nxv1s32*//*Label 29504*/ GIMT_Encode4(2228686),
     /* 2227991 */ /*GILLT_nxv1s64*//*Label 29505*/ GIMT_Encode4(2228801), GIMT_Encode4(0),
     /* 2227999 */ /*GILLT_nxv2s8*//*Label 29506*/ GIMT_Encode4(2228916),
     /* 2228003 */ /*GILLT_nxv2s16*//*Label 29507*/ GIMT_Encode4(2229031),
     /* 2228007 */ /*GILLT_nxv2s32*//*Label 29508*/ GIMT_Encode4(2229146),
     /* 2228011 */ /*GILLT_nxv2s64*//*Label 29509*/ GIMT_Encode4(2229261), GIMT_Encode4(0),
     /* 2228019 */ /*GILLT_nxv4s8*//*Label 29510*/ GIMT_Encode4(2229376),
     /* 2228023 */ /*GILLT_nxv4s16*//*Label 29511*/ GIMT_Encode4(2229491),
     /* 2228027 */ /*GILLT_nxv4s32*//*Label 29512*/ GIMT_Encode4(2229606),
     /* 2228031 */ /*GILLT_nxv4s64*//*Label 29513*/ GIMT_Encode4(2229721), GIMT_Encode4(0),
     /* 2228039 */ /*GILLT_nxv8s8*//*Label 29514*/ GIMT_Encode4(2229836),
     /* 2228043 */ /*GILLT_nxv8s16*//*Label 29515*/ GIMT_Encode4(2229951),
     /* 2228047 */ /*GILLT_nxv8s32*//*Label 29516*/ GIMT_Encode4(2230066),
     /* 2228051 */ /*GILLT_nxv8s64*//*Label 29517*/ GIMT_Encode4(2230181), GIMT_Encode4(0),
     /* 2228059 */ /*GILLT_nxv16s8*//*Label 29518*/ GIMT_Encode4(2230296),
     /* 2228063 */ /*GILLT_nxv16s16*//*Label 29519*/ GIMT_Encode4(2230411),
     /* 2228067 */ /*GILLT_nxv16s32*//*Label 29520*/ GIMT_Encode4(2230526), GIMT_Encode4(0),
     /* 2228075 */ /*GILLT_nxv32s8*//*Label 29521*/ GIMT_Encode4(2230641),
     /* 2228079 */ /*GILLT_nxv32s16*//*Label 29522*/ GIMT_Encode4(2230756), GIMT_Encode4(0),
     /* 2228087 */ /*GILLT_nxv64s8*//*Label 29523*/ GIMT_Encode4(2230871),
     /* 2228091 */ // Label 29500: @2228091
     /* 2228091 */ GIM_Try, /*On fail goto*//*Label 29525*/ GIMT_Encode4(2228174),
     /* 2228096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2228099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2228102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228110 */   GIM_Try, /*On fail goto*//*Label 29526*/ GIMT_Encode4(2228144), // Rule ID 107 //
     /* 2228115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2228118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2228122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2228130 */     // MIs[1] Operand 1
     /* 2228130 */     // No operand predicates
     /* 2228130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228132 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2228132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2228135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2228142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228143 */     // GIR_Coverage, 107,
     /* 2228143 */     GIR_EraseRootFromParent_Done,
     /* 2228144 */   // Label 29526: @2228144
     /* 2228144 */   GIM_Try, /*On fail goto*//*Label 29527*/ GIMT_Encode4(2228173), // Rule ID 121 //
     /* 2228149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2228152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2228159 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2228159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2228162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2228171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228172 */     // GIR_Coverage, 121,
     /* 2228172 */     GIR_EraseRootFromParent_Done,
     /* 2228173 */   // Label 29527: @2228173
     /* 2228173 */   GIM_Reject,
     /* 2228174 */ // Label 29525: @2228174
     /* 2228174 */ GIM_Reject,
     /* 2228175 */ // Label 29501: @2228175
     /* 2228175 */ GIM_Try, /*On fail goto*//*Label 29528*/ GIMT_Encode4(2228455),
     /* 2228180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2228183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2228186 */   GIM_Try, /*On fail goto*//*Label 29529*/ GIMT_Encode4(2228258), // Rule ID 275 //
     /* 2228191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2228194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2228206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2228210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2228214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228219 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2228230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2228234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228238 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2228242 */     // MIs[2] Operand 1
     /* 2228242 */     // No operand predicates
     /* 2228242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2228244 */     // (srl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2228244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /* 2228247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2228253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2228256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228257 */     // GIR_Coverage, 275,
     /* 2228257 */     GIR_EraseRootFromParent_Done,
     /* 2228258 */   // Label 29529: @2228258
     /* 2228258 */   GIM_Try, /*On fail goto*//*Label 29530*/ GIMT_Encode4(2228303), // Rule ID 62582 //
     /* 2228263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2228266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2228278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2228282 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2228286 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10090),
     /* 2228290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228292 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })<<P:Predicate_anonymous_10090>>  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2228292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2228295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2228301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228302 */     // GIR_Coverage, 62582,
     /* 2228302 */     GIR_EraseRootFromParent_Done,
     /* 2228303 */   // Label 29530: @2228303
     /* 2228303 */   GIM_Try, /*On fail goto*//*Label 29531*/ GIMT_Encode4(2228375), // Rule ID 287 //
     /* 2228308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2228311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2228323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2228327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228332 */     // MIs[1] Operand 2
     /* 2228332 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2228343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2228347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228351 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2228355 */     // MIs[2] Operand 1
     /* 2228355 */     // No operand predicates
     /* 2228355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10090),
     /* 2228359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2228361 */     // (srl:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)<<P:Predicate_anonymous_10090>>  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2228361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2228364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2228370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2228373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228374 */     // GIR_Coverage, 287,
     /* 2228374 */     GIR_EraseRootFromParent_Done,
     /* 2228375 */   // Label 29531: @2228375
     /* 2228375 */   GIM_Try, /*On fail goto*//*Label 29532*/ GIMT_Encode4(2228417), // Rule ID 106 //
     /* 2228380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2228395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2228403 */     // MIs[1] Operand 1
     /* 2228403 */     // No operand predicates
     /* 2228403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228405 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2228405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2228408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2228415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228416 */     // GIR_Coverage, 106,
     /* 2228416 */     GIR_EraseRootFromParent_Done,
     /* 2228417 */   // Label 29532: @2228417
     /* 2228417 */   GIM_Try, /*On fail goto*//*Label 29533*/ GIMT_Encode4(2228454), // Rule ID 120 //
     /* 2228422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2228440 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2228440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2228443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2228452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228453 */     // GIR_Coverage, 120,
     /* 2228453 */     GIR_EraseRootFromParent_Done,
     /* 2228454 */   // Label 29533: @2228454
     /* 2228454 */   GIM_Reject,
     /* 2228455 */ // Label 29528: @2228455
     /* 2228455 */ GIM_Reject,
     /* 2228456 */ // Label 29502: @2228456
     /* 2228456 */ GIM_Try, /*On fail goto*//*Label 29534*/ GIMT_Encode4(2228570),
     /* 2228461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2228464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2228467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228479 */   GIM_Try, /*On fail goto*//*Label 29535*/ GIMT_Encode4(2228524), // Rule ID 48192 //
     /* 2228484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228487 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2228490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2228504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228523 */     // GIR_Coverage, 48192,
     /* 2228523 */     GIR_EraseRootFromParent_Done,
     /* 2228524 */   // Label 29535: @2228524
     /* 2228524 */   GIM_Try, /*On fail goto*//*Label 29536*/ GIMT_Encode4(2228569), // Rule ID 48193 //
     /* 2228529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228532 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2228535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2228549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228568 */     // GIR_Coverage, 48193,
     /* 2228568 */     GIR_EraseRootFromParent_Done,
     /* 2228569 */   // Label 29536: @2228569
     /* 2228569 */   GIM_Reject,
     /* 2228570 */ // Label 29534: @2228570
     /* 2228570 */ GIM_Reject,
     /* 2228571 */ // Label 29503: @2228571
     /* 2228571 */ GIM_Try, /*On fail goto*//*Label 29537*/ GIMT_Encode4(2228685),
     /* 2228576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2228579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2228582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228594 */   GIM_Try, /*On fail goto*//*Label 29538*/ GIMT_Encode4(2228639), // Rule ID 48204 //
     /* 2228599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228602 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2228605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228638 */     // GIR_Coverage, 48204,
     /* 2228638 */     GIR_EraseRootFromParent_Done,
     /* 2228639 */   // Label 29538: @2228639
     /* 2228639 */   GIM_Try, /*On fail goto*//*Label 29539*/ GIMT_Encode4(2228684), // Rule ID 48205 //
     /* 2228644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228647 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2228650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228683 */     // GIR_Coverage, 48205,
     /* 2228683 */     GIR_EraseRootFromParent_Done,
     /* 2228684 */   // Label 29539: @2228684
     /* 2228684 */   GIM_Reject,
     /* 2228685 */ // Label 29537: @2228685
     /* 2228685 */ GIM_Reject,
     /* 2228686 */ // Label 29504: @2228686
     /* 2228686 */ GIM_Try, /*On fail goto*//*Label 29540*/ GIMT_Encode4(2228800),
     /* 2228691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2228694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2228697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228709 */   GIM_Try, /*On fail goto*//*Label 29541*/ GIMT_Encode4(2228754), // Rule ID 48212 //
     /* 2228714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228717 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2228720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228753 */     // GIR_Coverage, 48212,
     /* 2228753 */     GIR_EraseRootFromParent_Done,
     /* 2228754 */   // Label 29541: @2228754
     /* 2228754 */   GIM_Try, /*On fail goto*//*Label 29542*/ GIMT_Encode4(2228799), // Rule ID 48213 //
     /* 2228759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228762 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2228765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228798 */     // GIR_Coverage, 48213,
     /* 2228798 */     GIR_EraseRootFromParent_Done,
     /* 2228799 */   // Label 29542: @2228799
     /* 2228799 */   GIM_Reject,
     /* 2228800 */ // Label 29540: @2228800
     /* 2228800 */ GIM_Reject,
     /* 2228801 */ // Label 29505: @2228801
     /* 2228801 */ GIM_Try, /*On fail goto*//*Label 29543*/ GIMT_Encode4(2228915),
     /* 2228806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2228809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2228812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228824 */   GIM_Try, /*On fail goto*//*Label 29544*/ GIMT_Encode4(2228869), // Rule ID 48228 //
     /* 2228829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2228832 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2228835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2228849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228868 */     // GIR_Coverage, 48228,
     /* 2228868 */     GIR_EraseRootFromParent_Done,
     /* 2228869 */   // Label 29544: @2228869
     /* 2228869 */   GIM_Try, /*On fail goto*//*Label 29545*/ GIMT_Encode4(2228914), // Rule ID 48229 //
     /* 2228874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2228877 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2228880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2228894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228913 */     // GIR_Coverage, 48229,
     /* 2228913 */     GIR_EraseRootFromParent_Done,
     /* 2228914 */   // Label 29545: @2228914
     /* 2228914 */   GIM_Reject,
     /* 2228915 */ // Label 29543: @2228915
     /* 2228915 */ GIM_Reject,
     /* 2228916 */ // Label 29506: @2228916
     /* 2228916 */ GIM_Try, /*On fail goto*//*Label 29546*/ GIMT_Encode4(2229030),
     /* 2228921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2228924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2228927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228939 */   GIM_Try, /*On fail goto*//*Label 29547*/ GIMT_Encode4(2228984), // Rule ID 48196 //
     /* 2228944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228947 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2228950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228983 */     // GIR_Coverage, 48196,
     /* 2228983 */     GIR_EraseRootFromParent_Done,
     /* 2228984 */   // Label 29547: @2228984
     /* 2228984 */   GIM_Try, /*On fail goto*//*Label 29548*/ GIMT_Encode4(2229029), // Rule ID 48197 //
     /* 2228989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228992 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2228995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2229009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229028 */     // GIR_Coverage, 48197,
     /* 2229028 */     GIR_EraseRootFromParent_Done,
     /* 2229029 */   // Label 29548: @2229029
     /* 2229029 */   GIM_Reject,
     /* 2229030 */ // Label 29546: @2229030
     /* 2229030 */ GIM_Reject,
     /* 2229031 */ // Label 29507: @2229031
     /* 2229031 */ GIM_Try, /*On fail goto*//*Label 29549*/ GIMT_Encode4(2229145),
     /* 2229036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2229039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2229042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229050 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229054 */   GIM_Try, /*On fail goto*//*Label 29550*/ GIMT_Encode4(2229099), // Rule ID 48208 //
     /* 2229059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229062 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2229065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2229079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229098 */     // GIR_Coverage, 48208,
     /* 2229098 */     GIR_EraseRootFromParent_Done,
     /* 2229099 */   // Label 29550: @2229099
     /* 2229099 */   GIM_Try, /*On fail goto*//*Label 29551*/ GIMT_Encode4(2229144), // Rule ID 48209 //
     /* 2229104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229107 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2229110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2229124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229143 */     // GIR_Coverage, 48209,
     /* 2229143 */     GIR_EraseRootFromParent_Done,
     /* 2229144 */   // Label 29551: @2229144
     /* 2229144 */   GIM_Reject,
     /* 2229145 */ // Label 29549: @2229145
     /* 2229145 */ GIM_Reject,
     /* 2229146 */ // Label 29508: @2229146
     /* 2229146 */ GIM_Try, /*On fail goto*//*Label 29552*/ GIMT_Encode4(2229260),
     /* 2229151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2229154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2229157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229169 */   GIM_Try, /*On fail goto*//*Label 29553*/ GIMT_Encode4(2229214), // Rule ID 48224 //
     /* 2229174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229177 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2229180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229213 */     // GIR_Coverage, 48224,
     /* 2229213 */     GIR_EraseRootFromParent_Done,
     /* 2229214 */   // Label 29553: @2229214
     /* 2229214 */   GIM_Try, /*On fail goto*//*Label 29554*/ GIMT_Encode4(2229259), // Rule ID 48225 //
     /* 2229219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229222 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2229225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229258 */     // GIR_Coverage, 48225,
     /* 2229258 */     GIR_EraseRootFromParent_Done,
     /* 2229259 */   // Label 29554: @2229259
     /* 2229259 */   GIM_Reject,
     /* 2229260 */ // Label 29552: @2229260
     /* 2229260 */ GIM_Reject,
     /* 2229261 */ // Label 29509: @2229261
     /* 2229261 */ GIM_Try, /*On fail goto*//*Label 29555*/ GIMT_Encode4(2229375),
     /* 2229266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2229269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2229272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229284 */   GIM_Try, /*On fail goto*//*Label 29556*/ GIMT_Encode4(2229329), // Rule ID 48268 //
     /* 2229289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2229292 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2229295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229328 */     // GIR_Coverage, 48268,
     /* 2229328 */     GIR_EraseRootFromParent_Done,
     /* 2229329 */   // Label 29556: @2229329
     /* 2229329 */   GIM_Try, /*On fail goto*//*Label 29557*/ GIMT_Encode4(2229374), // Rule ID 48269 //
     /* 2229334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2229337 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2229340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229373 */     // GIR_Coverage, 48269,
     /* 2229373 */     GIR_EraseRootFromParent_Done,
     /* 2229374 */   // Label 29557: @2229374
     /* 2229374 */   GIM_Reject,
     /* 2229375 */ // Label 29555: @2229375
     /* 2229375 */ GIM_Reject,
     /* 2229376 */ // Label 29510: @2229376
     /* 2229376 */ GIM_Try, /*On fail goto*//*Label 29558*/ GIMT_Encode4(2229490),
     /* 2229381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2229384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2229387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229399 */   GIM_Try, /*On fail goto*//*Label 29559*/ GIMT_Encode4(2229444), // Rule ID 48200 //
     /* 2229404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229407 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2229410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2229424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229443 */     // GIR_Coverage, 48200,
     /* 2229443 */     GIR_EraseRootFromParent_Done,
     /* 2229444 */   // Label 29559: @2229444
     /* 2229444 */   GIM_Try, /*On fail goto*//*Label 29560*/ GIMT_Encode4(2229489), // Rule ID 48201 //
     /* 2229449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229452 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2229455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2229469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229488 */     // GIR_Coverage, 48201,
     /* 2229488 */     GIR_EraseRootFromParent_Done,
     /* 2229489 */   // Label 29560: @2229489
     /* 2229489 */   GIM_Reject,
     /* 2229490 */ // Label 29558: @2229490
     /* 2229490 */ GIM_Reject,
     /* 2229491 */ // Label 29511: @2229491
     /* 2229491 */ GIM_Try, /*On fail goto*//*Label 29561*/ GIMT_Encode4(2229605),
     /* 2229496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2229499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2229502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229514 */   GIM_Try, /*On fail goto*//*Label 29562*/ GIMT_Encode4(2229559), // Rule ID 48220 //
     /* 2229519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229522 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229558 */     // GIR_Coverage, 48220,
     /* 2229558 */     GIR_EraseRootFromParent_Done,
     /* 2229559 */   // Label 29562: @2229559
     /* 2229559 */   GIM_Try, /*On fail goto*//*Label 29563*/ GIMT_Encode4(2229604), // Rule ID 48221 //
     /* 2229564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229567 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229603 */     // GIR_Coverage, 48221,
     /* 2229603 */     GIR_EraseRootFromParent_Done,
     /* 2229604 */   // Label 29563: @2229604
     /* 2229604 */   GIM_Reject,
     /* 2229605 */ // Label 29561: @2229605
     /* 2229605 */ GIM_Reject,
     /* 2229606 */ // Label 29512: @2229606
     /* 2229606 */ GIM_Try, /*On fail goto*//*Label 29564*/ GIMT_Encode4(2229720),
     /* 2229611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2229614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2229617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229629 */   GIM_Try, /*On fail goto*//*Label 29565*/ GIMT_Encode4(2229674), // Rule ID 48256 //
     /* 2229634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229637 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229673 */     // GIR_Coverage, 48256,
     /* 2229673 */     GIR_EraseRootFromParent_Done,
     /* 2229674 */   // Label 29565: @2229674
     /* 2229674 */   GIM_Try, /*On fail goto*//*Label 29566*/ GIMT_Encode4(2229719), // Rule ID 48257 //
     /* 2229679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229682 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229718 */     // GIR_Coverage, 48257,
     /* 2229718 */     GIR_EraseRootFromParent_Done,
     /* 2229719 */   // Label 29566: @2229719
     /* 2229719 */   GIM_Reject,
     /* 2229720 */ // Label 29564: @2229720
     /* 2229720 */ GIM_Reject,
     /* 2229721 */ // Label 29513: @2229721
     /* 2229721 */ GIM_Try, /*On fail goto*//*Label 29567*/ GIMT_Encode4(2229835),
     /* 2229726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2229729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2229732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229744 */   GIM_Try, /*On fail goto*//*Label 29568*/ GIMT_Encode4(2229789), // Rule ID 48272 //
     /* 2229749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2229752 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2229755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229788 */     // GIR_Coverage, 48272,
     /* 2229788 */     GIR_EraseRootFromParent_Done,
     /* 2229789 */   // Label 29568: @2229789
     /* 2229789 */   GIM_Try, /*On fail goto*//*Label 29569*/ GIMT_Encode4(2229834), // Rule ID 48273 //
     /* 2229794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2229797 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2229800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229833 */     // GIR_Coverage, 48273,
     /* 2229833 */     GIR_EraseRootFromParent_Done,
     /* 2229834 */   // Label 29569: @2229834
     /* 2229834 */   GIM_Reject,
     /* 2229835 */ // Label 29567: @2229835
     /* 2229835 */ GIM_Reject,
     /* 2229836 */ // Label 29514: @2229836
     /* 2229836 */ GIM_Try, /*On fail goto*//*Label 29570*/ GIMT_Encode4(2229950),
     /* 2229841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2229844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2229847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229859 */   GIM_Try, /*On fail goto*//*Label 29571*/ GIMT_Encode4(2229904), // Rule ID 48216 //
     /* 2229864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229867 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2229870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229903 */     // GIR_Coverage, 48216,
     /* 2229903 */     GIR_EraseRootFromParent_Done,
     /* 2229904 */   // Label 29571: @2229904
     /* 2229904 */   GIM_Try, /*On fail goto*//*Label 29572*/ GIMT_Encode4(2229949), // Rule ID 48217 //
     /* 2229909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229912 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2229915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229948 */     // GIR_Coverage, 48217,
     /* 2229948 */     GIR_EraseRootFromParent_Done,
     /* 2229949 */   // Label 29572: @2229949
     /* 2229949 */   GIM_Reject,
     /* 2229950 */ // Label 29570: @2229950
     /* 2229950 */ GIM_Reject,
     /* 2229951 */ // Label 29515: @2229951
     /* 2229951 */ GIM_Try, /*On fail goto*//*Label 29573*/ GIMT_Encode4(2230065),
     /* 2229956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2229959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2229962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229974 */   GIM_Try, /*On fail goto*//*Label 29574*/ GIMT_Encode4(2230019), // Rule ID 48244 //
     /* 2229979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229982 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2229985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230018 */     // GIR_Coverage, 48244,
     /* 2230018 */     GIR_EraseRootFromParent_Done,
     /* 2230019 */   // Label 29574: @2230019
     /* 2230019 */   GIM_Try, /*On fail goto*//*Label 29575*/ GIMT_Encode4(2230064), // Rule ID 48245 //
     /* 2230024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230027 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2230030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2230044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230063 */     // GIR_Coverage, 48245,
     /* 2230063 */     GIR_EraseRootFromParent_Done,
     /* 2230064 */   // Label 29575: @2230064
     /* 2230064 */   GIM_Reject,
     /* 2230065 */ // Label 29573: @2230065
     /* 2230065 */ GIM_Reject,
     /* 2230066 */ // Label 29516: @2230066
     /* 2230066 */ GIM_Try, /*On fail goto*//*Label 29576*/ GIMT_Encode4(2230180),
     /* 2230071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2230074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2230077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230089 */   GIM_Try, /*On fail goto*//*Label 29577*/ GIMT_Encode4(2230134), // Rule ID 48260 //
     /* 2230094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230097 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2230100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230133 */     // GIR_Coverage, 48260,
     /* 2230133 */     GIR_EraseRootFromParent_Done,
     /* 2230134 */   // Label 29577: @2230134
     /* 2230134 */   GIM_Try, /*On fail goto*//*Label 29578*/ GIMT_Encode4(2230179), // Rule ID 48261 //
     /* 2230139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230142 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2230145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230178 */     // GIR_Coverage, 48261,
     /* 2230178 */     GIR_EraseRootFromParent_Done,
     /* 2230179 */   // Label 29578: @2230179
     /* 2230179 */   GIM_Reject,
     /* 2230180 */ // Label 29576: @2230180
     /* 2230180 */ GIM_Reject,
     /* 2230181 */ // Label 29517: @2230181
     /* 2230181 */ GIM_Try, /*On fail goto*//*Label 29579*/ GIMT_Encode4(2230295),
     /* 2230186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2230189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2230192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230204 */   GIM_Try, /*On fail goto*//*Label 29580*/ GIMT_Encode4(2230249), // Rule ID 48276 //
     /* 2230209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2230212 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2230215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2230244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230248 */     // GIR_Coverage, 48276,
     /* 2230248 */     GIR_EraseRootFromParent_Done,
     /* 2230249 */   // Label 29580: @2230249
     /* 2230249 */   GIM_Try, /*On fail goto*//*Label 29581*/ GIMT_Encode4(2230294), // Rule ID 48277 //
     /* 2230254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2230257 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2230260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2230289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230293 */     // GIR_Coverage, 48277,
     /* 2230293 */     GIR_EraseRootFromParent_Done,
     /* 2230294 */   // Label 29581: @2230294
     /* 2230294 */   GIM_Reject,
     /* 2230295 */ // Label 29579: @2230295
     /* 2230295 */ GIM_Reject,
     /* 2230296 */ // Label 29518: @2230296
     /* 2230296 */ GIM_Try, /*On fail goto*//*Label 29582*/ GIMT_Encode4(2230410),
     /* 2230301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2230304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2230307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230319 */   GIM_Try, /*On fail goto*//*Label 29583*/ GIMT_Encode4(2230364), // Rule ID 48232 //
     /* 2230324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230327 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2230330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2230344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230363 */     // GIR_Coverage, 48232,
     /* 2230363 */     GIR_EraseRootFromParent_Done,
     /* 2230364 */   // Label 29583: @2230364
     /* 2230364 */   GIM_Try, /*On fail goto*//*Label 29584*/ GIMT_Encode4(2230409), // Rule ID 48233 //
     /* 2230369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230372 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2230375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2230389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230408 */     // GIR_Coverage, 48233,
     /* 2230408 */     GIR_EraseRootFromParent_Done,
     /* 2230409 */   // Label 29584: @2230409
     /* 2230409 */   GIM_Reject,
     /* 2230410 */ // Label 29582: @2230410
     /* 2230410 */ GIM_Reject,
     /* 2230411 */ // Label 29519: @2230411
     /* 2230411 */ GIM_Try, /*On fail goto*//*Label 29585*/ GIMT_Encode4(2230525),
     /* 2230416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2230419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2230422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230434 */   GIM_Try, /*On fail goto*//*Label 29586*/ GIMT_Encode4(2230479), // Rule ID 48248 //
     /* 2230439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230442 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2230445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230478 */     // GIR_Coverage, 48248,
     /* 2230478 */     GIR_EraseRootFromParent_Done,
     /* 2230479 */   // Label 29586: @2230479
     /* 2230479 */   GIM_Try, /*On fail goto*//*Label 29587*/ GIMT_Encode4(2230524), // Rule ID 48249 //
     /* 2230484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230487 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2230490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230523 */     // GIR_Coverage, 48249,
     /* 2230523 */     GIR_EraseRootFromParent_Done,
     /* 2230524 */   // Label 29587: @2230524
     /* 2230524 */   GIM_Reject,
     /* 2230525 */ // Label 29585: @2230525
     /* 2230525 */ GIM_Reject,
     /* 2230526 */ // Label 29520: @2230526
     /* 2230526 */ GIM_Try, /*On fail goto*//*Label 29588*/ GIMT_Encode4(2230640),
     /* 2230531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2230534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2230537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230545 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230549 */   GIM_Try, /*On fail goto*//*Label 29589*/ GIMT_Encode4(2230594), // Rule ID 48264 //
     /* 2230554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230557 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230593 */     // GIR_Coverage, 48264,
     /* 2230593 */     GIR_EraseRootFromParent_Done,
     /* 2230594 */   // Label 29589: @2230594
     /* 2230594 */   GIM_Try, /*On fail goto*//*Label 29590*/ GIMT_Encode4(2230639), // Rule ID 48265 //
     /* 2230599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230602 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230638 */     // GIR_Coverage, 48265,
     /* 2230638 */     GIR_EraseRootFromParent_Done,
     /* 2230639 */   // Label 29590: @2230639
     /* 2230639 */   GIM_Reject,
     /* 2230640 */ // Label 29588: @2230640
     /* 2230640 */ GIM_Reject,
     /* 2230641 */ // Label 29521: @2230641
     /* 2230641 */ GIM_Try, /*On fail goto*//*Label 29591*/ GIMT_Encode4(2230755),
     /* 2230646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2230649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2230652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230664 */   GIM_Try, /*On fail goto*//*Label 29592*/ GIMT_Encode4(2230709), // Rule ID 48236 //
     /* 2230669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230672 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2230675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230708 */     // GIR_Coverage, 48236,
     /* 2230708 */     GIR_EraseRootFromParent_Done,
     /* 2230709 */   // Label 29592: @2230709
     /* 2230709 */   GIM_Try, /*On fail goto*//*Label 29593*/ GIMT_Encode4(2230754), // Rule ID 48237 //
     /* 2230714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230717 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2230720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230753 */     // GIR_Coverage, 48237,
     /* 2230753 */     GIR_EraseRootFromParent_Done,
     /* 2230754 */   // Label 29593: @2230754
     /* 2230754 */   GIM_Reject,
     /* 2230755 */ // Label 29591: @2230755
     /* 2230755 */ GIM_Reject,
     /* 2230756 */ // Label 29522: @2230756
     /* 2230756 */ GIM_Try, /*On fail goto*//*Label 29594*/ GIMT_Encode4(2230870),
     /* 2230761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2230764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2230767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230779 */   GIM_Try, /*On fail goto*//*Label 29595*/ GIMT_Encode4(2230824), // Rule ID 48252 //
     /* 2230784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230787 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2230790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230823 */     // GIR_Coverage, 48252,
     /* 2230823 */     GIR_EraseRootFromParent_Done,
     /* 2230824 */   // Label 29595: @2230824
     /* 2230824 */   GIM_Try, /*On fail goto*//*Label 29596*/ GIMT_Encode4(2230869), // Rule ID 48253 //
     /* 2230829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230832 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2230835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230868 */     // GIR_Coverage, 48253,
     /* 2230868 */     GIR_EraseRootFromParent_Done,
     /* 2230869 */   // Label 29596: @2230869
     /* 2230869 */   GIM_Reject,
     /* 2230870 */ // Label 29594: @2230870
     /* 2230870 */ GIM_Reject,
     /* 2230871 */ // Label 29523: @2230871
     /* 2230871 */ GIM_Try, /*On fail goto*//*Label 29597*/ GIMT_Encode4(2230985),
     /* 2230876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2230879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2230882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230894 */   GIM_Try, /*On fail goto*//*Label 29598*/ GIMT_Encode4(2230939), // Rule ID 48240 //
     /* 2230899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230902 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2230905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230938 */     // GIR_Coverage, 48240,
     /* 2230938 */     GIR_EraseRootFromParent_Done,
     /* 2230939 */   // Label 29598: @2230939
     /* 2230939 */   GIM_Try, /*On fail goto*//*Label 29599*/ GIMT_Encode4(2230984), // Rule ID 48241 //
     /* 2230944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230947 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2230950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230983 */     // GIR_Coverage, 48241,
     /* 2230983 */     GIR_EraseRootFromParent_Done,
     /* 2230984 */   // Label 29599: @2230984
     /* 2230984 */   GIM_Reject,
     /* 2230985 */ // Label 29597: @2230985
     /* 2230985 */ GIM_Reject,
     /* 2230986 */ // Label 29524: @2230986
     /* 2230986 */ GIM_Reject,
     /* 2230987 */ // Label 45: @2230987
     /* 2230987 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29624*/ GIMT_Encode4(2233925),
     /* 2230998 */ /*GILLT_s32*//*Label 29600*/ GIMT_Encode4(2231122),
     /* 2231002 */ /*GILLT_s64*//*Label 29601*/ GIMT_Encode4(2231206), GIMT_Encode4(0),
     /* 2231010 */ /*GILLT_nxv1s8*//*Label 29602*/ GIMT_Encode4(2231395),
     /* 2231014 */ /*GILLT_nxv1s16*//*Label 29603*/ GIMT_Encode4(2231510),
     /* 2231018 */ /*GILLT_nxv1s32*//*Label 29604*/ GIMT_Encode4(2231625),
     /* 2231022 */ /*GILLT_nxv1s64*//*Label 29605*/ GIMT_Encode4(2231740), GIMT_Encode4(0),
     /* 2231030 */ /*GILLT_nxv2s8*//*Label 29606*/ GIMT_Encode4(2231855),
     /* 2231034 */ /*GILLT_nxv2s16*//*Label 29607*/ GIMT_Encode4(2231970),
     /* 2231038 */ /*GILLT_nxv2s32*//*Label 29608*/ GIMT_Encode4(2232085),
     /* 2231042 */ /*GILLT_nxv2s64*//*Label 29609*/ GIMT_Encode4(2232200), GIMT_Encode4(0),
     /* 2231050 */ /*GILLT_nxv4s8*//*Label 29610*/ GIMT_Encode4(2232315),
     /* 2231054 */ /*GILLT_nxv4s16*//*Label 29611*/ GIMT_Encode4(2232430),
     /* 2231058 */ /*GILLT_nxv4s32*//*Label 29612*/ GIMT_Encode4(2232545),
     /* 2231062 */ /*GILLT_nxv4s64*//*Label 29613*/ GIMT_Encode4(2232660), GIMT_Encode4(0),
     /* 2231070 */ /*GILLT_nxv8s8*//*Label 29614*/ GIMT_Encode4(2232775),
     /* 2231074 */ /*GILLT_nxv8s16*//*Label 29615*/ GIMT_Encode4(2232890),
     /* 2231078 */ /*GILLT_nxv8s32*//*Label 29616*/ GIMT_Encode4(2233005),
     /* 2231082 */ /*GILLT_nxv8s64*//*Label 29617*/ GIMT_Encode4(2233120), GIMT_Encode4(0),
     /* 2231090 */ /*GILLT_nxv16s8*//*Label 29618*/ GIMT_Encode4(2233235),
     /* 2231094 */ /*GILLT_nxv16s16*//*Label 29619*/ GIMT_Encode4(2233350),
     /* 2231098 */ /*GILLT_nxv16s32*//*Label 29620*/ GIMT_Encode4(2233465), GIMT_Encode4(0),
     /* 2231106 */ /*GILLT_nxv32s8*//*Label 29621*/ GIMT_Encode4(2233580),
     /* 2231110 */ /*GILLT_nxv32s16*//*Label 29622*/ GIMT_Encode4(2233695), GIMT_Encode4(0),
     /* 2231118 */ /*GILLT_nxv64s8*//*Label 29623*/ GIMT_Encode4(2233810),
     /* 2231122 */ // Label 29600: @2231122
     /* 2231122 */ GIM_Try, /*On fail goto*//*Label 29625*/ GIMT_Encode4(2231205),
     /* 2231127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2231130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2231133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231141 */   GIM_Try, /*On fail goto*//*Label 29626*/ GIMT_Encode4(2231175), // Rule ID 109 //
     /* 2231146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2231153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2231161 */     // MIs[1] Operand 1
     /* 2231161 */     // No operand predicates
     /* 2231161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231163 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2231163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2231166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2231173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231174 */     // GIR_Coverage, 109,
     /* 2231174 */     GIR_EraseRootFromParent_Done,
     /* 2231175 */   // Label 29626: @2231175
     /* 2231175 */   GIM_Try, /*On fail goto*//*Label 29627*/ GIMT_Encode4(2231204), // Rule ID 123 //
     /* 2231180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2231190 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRA:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2231190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2231193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2231202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231203 */     // GIR_Coverage, 123,
     /* 2231203 */     GIR_EraseRootFromParent_Done,
     /* 2231204 */   // Label 29627: @2231204
     /* 2231204 */   GIM_Reject,
     /* 2231205 */ // Label 29625: @2231205
     /* 2231205 */ GIM_Reject,
     /* 2231206 */ // Label 29601: @2231206
     /* 2231206 */ GIM_Try, /*On fail goto*//*Label 29628*/ GIMT_Encode4(2231394),
     /* 2231211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2231214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2231217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231221 */   GIM_Try, /*On fail goto*//*Label 29629*/ GIMT_Encode4(2231258), // Rule ID 62581 //
     /* 2231226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2231229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2231233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2231237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2231241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2231245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231247 */     // (sra:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2231247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2231250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2231256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231257 */     // GIR_Coverage, 62581,
     /* 2231257 */     GIR_EraseRootFromParent_Done,
     /* 2231258 */   // Label 29629: @2231258
     /* 2231258 */   GIM_Try, /*On fail goto*//*Label 29630*/ GIMT_Encode4(2231322), // Rule ID 277 //
     /* 2231263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2231266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2231270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2231274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2231278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231283 */     // MIs[1] Operand 2
     /* 2231283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2231294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2231298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231302 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2231306 */     // MIs[2] Operand 1
     /* 2231306 */     // No operand predicates
     /* 2231306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2231308 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2231308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2231311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2231317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2231320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231321 */     // GIR_Coverage, 277,
     /* 2231321 */     GIR_EraseRootFromParent_Done,
     /* 2231322 */   // Label 29630: @2231322
     /* 2231322 */   GIM_Try, /*On fail goto*//*Label 29631*/ GIMT_Encode4(2231360), // Rule ID 108 //
     /* 2231327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2231330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2231338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2231346 */     // MIs[1] Operand 1
     /* 2231346 */     // No operand predicates
     /* 2231346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231348 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2231348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2231351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2231358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231359 */     // GIR_Coverage, 108,
     /* 2231359 */     GIR_EraseRootFromParent_Done,
     /* 2231360 */   // Label 29631: @2231360
     /* 2231360 */   GIM_Try, /*On fail goto*//*Label 29632*/ GIMT_Encode4(2231393), // Rule ID 122 //
     /* 2231365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2231368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2231379 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRA:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2231379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2231382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2231391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231392 */     // GIR_Coverage, 122,
     /* 2231392 */     GIR_EraseRootFromParent_Done,
     /* 2231393 */   // Label 29632: @2231393
     /* 2231393 */   GIM_Reject,
     /* 2231394 */ // Label 29628: @2231394
     /* 2231394 */ GIM_Reject,
     /* 2231395 */ // Label 29602: @2231395
     /* 2231395 */ GIM_Try, /*On fail goto*//*Label 29633*/ GIMT_Encode4(2231509),
     /* 2231400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2231403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2231406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231418 */   GIM_Try, /*On fail goto*//*Label 29634*/ GIMT_Encode4(2231463), // Rule ID 48324 //
     /* 2231423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231426 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2231429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2231443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231462 */     // GIR_Coverage, 48324,
     /* 2231462 */     GIR_EraseRootFromParent_Done,
     /* 2231463 */   // Label 29634: @2231463
     /* 2231463 */   GIM_Try, /*On fail goto*//*Label 29635*/ GIMT_Encode4(2231508), // Rule ID 48325 //
     /* 2231468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231471 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2231474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2231488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231507 */     // GIR_Coverage, 48325,
     /* 2231507 */     GIR_EraseRootFromParent_Done,
     /* 2231508 */   // Label 29635: @2231508
     /* 2231508 */   GIM_Reject,
     /* 2231509 */ // Label 29633: @2231509
     /* 2231509 */ GIM_Reject,
     /* 2231510 */ // Label 29603: @2231510
     /* 2231510 */ GIM_Try, /*On fail goto*//*Label 29636*/ GIMT_Encode4(2231624),
     /* 2231515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2231518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2231521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231533 */   GIM_Try, /*On fail goto*//*Label 29637*/ GIMT_Encode4(2231578), // Rule ID 48336 //
     /* 2231538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231541 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2231544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231577 */     // GIR_Coverage, 48336,
     /* 2231577 */     GIR_EraseRootFromParent_Done,
     /* 2231578 */   // Label 29637: @2231578
     /* 2231578 */   GIM_Try, /*On fail goto*//*Label 29638*/ GIMT_Encode4(2231623), // Rule ID 48337 //
     /* 2231583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231586 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2231589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231622 */     // GIR_Coverage, 48337,
     /* 2231622 */     GIR_EraseRootFromParent_Done,
     /* 2231623 */   // Label 29638: @2231623
     /* 2231623 */   GIM_Reject,
     /* 2231624 */ // Label 29636: @2231624
     /* 2231624 */ GIM_Reject,
     /* 2231625 */ // Label 29604: @2231625
     /* 2231625 */ GIM_Try, /*On fail goto*//*Label 29639*/ GIMT_Encode4(2231739),
     /* 2231630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2231633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2231636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231648 */   GIM_Try, /*On fail goto*//*Label 29640*/ GIMT_Encode4(2231693), // Rule ID 48344 //
     /* 2231653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231656 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2231659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231692 */     // GIR_Coverage, 48344,
     /* 2231692 */     GIR_EraseRootFromParent_Done,
     /* 2231693 */   // Label 29640: @2231693
     /* 2231693 */   GIM_Try, /*On fail goto*//*Label 29641*/ GIMT_Encode4(2231738), // Rule ID 48345 //
     /* 2231698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231701 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2231704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231737 */     // GIR_Coverage, 48345,
     /* 2231737 */     GIR_EraseRootFromParent_Done,
     /* 2231738 */   // Label 29641: @2231738
     /* 2231738 */   GIM_Reject,
     /* 2231739 */ // Label 29639: @2231739
     /* 2231739 */ GIM_Reject,
     /* 2231740 */ // Label 29605: @2231740
     /* 2231740 */ GIM_Try, /*On fail goto*//*Label 29642*/ GIMT_Encode4(2231854),
     /* 2231745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2231748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2231751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231763 */   GIM_Try, /*On fail goto*//*Label 29643*/ GIMT_Encode4(2231808), // Rule ID 48360 //
     /* 2231768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2231771 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2231774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2231788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231807 */     // GIR_Coverage, 48360,
     /* 2231807 */     GIR_EraseRootFromParent_Done,
     /* 2231808 */   // Label 29643: @2231808
     /* 2231808 */   GIM_Try, /*On fail goto*//*Label 29644*/ GIMT_Encode4(2231853), // Rule ID 48361 //
     /* 2231813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2231816 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2231819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2231833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231852 */     // GIR_Coverage, 48361,
     /* 2231852 */     GIR_EraseRootFromParent_Done,
     /* 2231853 */   // Label 29644: @2231853
     /* 2231853 */   GIM_Reject,
     /* 2231854 */ // Label 29642: @2231854
     /* 2231854 */ GIM_Reject,
     /* 2231855 */ // Label 29606: @2231855
     /* 2231855 */ GIM_Try, /*On fail goto*//*Label 29645*/ GIMT_Encode4(2231969),
     /* 2231860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2231863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2231866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231878 */   GIM_Try, /*On fail goto*//*Label 29646*/ GIMT_Encode4(2231923), // Rule ID 48328 //
     /* 2231883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231886 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2231889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231922 */     // GIR_Coverage, 48328,
     /* 2231922 */     GIR_EraseRootFromParent_Done,
     /* 2231923 */   // Label 29646: @2231923
     /* 2231923 */   GIM_Try, /*On fail goto*//*Label 29647*/ GIMT_Encode4(2231968), // Rule ID 48329 //
     /* 2231928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231931 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2231934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231967 */     // GIR_Coverage, 48329,
     /* 2231967 */     GIR_EraseRootFromParent_Done,
     /* 2231968 */   // Label 29647: @2231968
     /* 2231968 */   GIM_Reject,
     /* 2231969 */ // Label 29645: @2231969
     /* 2231969 */ GIM_Reject,
     /* 2231970 */ // Label 29607: @2231970
     /* 2231970 */ GIM_Try, /*On fail goto*//*Label 29648*/ GIMT_Encode4(2232084),
     /* 2231975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2231978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2231981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231993 */   GIM_Try, /*On fail goto*//*Label 29649*/ GIMT_Encode4(2232038), // Rule ID 48340 //
     /* 2231998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232001 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2232004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2232018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232037 */     // GIR_Coverage, 48340,
     /* 2232037 */     GIR_EraseRootFromParent_Done,
     /* 2232038 */   // Label 29649: @2232038
     /* 2232038 */   GIM_Try, /*On fail goto*//*Label 29650*/ GIMT_Encode4(2232083), // Rule ID 48341 //
     /* 2232043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232046 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2232049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2232063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232082 */     // GIR_Coverage, 48341,
     /* 2232082 */     GIR_EraseRootFromParent_Done,
     /* 2232083 */   // Label 29650: @2232083
     /* 2232083 */   GIM_Reject,
     /* 2232084 */ // Label 29648: @2232084
     /* 2232084 */ GIM_Reject,
     /* 2232085 */ // Label 29608: @2232085
     /* 2232085 */ GIM_Try, /*On fail goto*//*Label 29651*/ GIMT_Encode4(2232199),
     /* 2232090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2232093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2232096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232108 */   GIM_Try, /*On fail goto*//*Label 29652*/ GIMT_Encode4(2232153), // Rule ID 48356 //
     /* 2232113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232116 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2232119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232152 */     // GIR_Coverage, 48356,
     /* 2232152 */     GIR_EraseRootFromParent_Done,
     /* 2232153 */   // Label 29652: @2232153
     /* 2232153 */   GIM_Try, /*On fail goto*//*Label 29653*/ GIMT_Encode4(2232198), // Rule ID 48357 //
     /* 2232158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232161 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2232164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232197 */     // GIR_Coverage, 48357,
     /* 2232197 */     GIR_EraseRootFromParent_Done,
     /* 2232198 */   // Label 29653: @2232198
     /* 2232198 */   GIM_Reject,
     /* 2232199 */ // Label 29651: @2232199
     /* 2232199 */ GIM_Reject,
     /* 2232200 */ // Label 29609: @2232200
     /* 2232200 */ GIM_Try, /*On fail goto*//*Label 29654*/ GIMT_Encode4(2232314),
     /* 2232205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2232208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2232211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232223 */   GIM_Try, /*On fail goto*//*Label 29655*/ GIMT_Encode4(2232268), // Rule ID 48400 //
     /* 2232228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232231 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2232234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232267 */     // GIR_Coverage, 48400,
     /* 2232267 */     GIR_EraseRootFromParent_Done,
     /* 2232268 */   // Label 29655: @2232268
     /* 2232268 */   GIM_Try, /*On fail goto*//*Label 29656*/ GIMT_Encode4(2232313), // Rule ID 48401 //
     /* 2232273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232276 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2232279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232312 */     // GIR_Coverage, 48401,
     /* 2232312 */     GIR_EraseRootFromParent_Done,
     /* 2232313 */   // Label 29656: @2232313
     /* 2232313 */   GIM_Reject,
     /* 2232314 */ // Label 29654: @2232314
     /* 2232314 */ GIM_Reject,
     /* 2232315 */ // Label 29610: @2232315
     /* 2232315 */ GIM_Try, /*On fail goto*//*Label 29657*/ GIMT_Encode4(2232429),
     /* 2232320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2232323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2232326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232338 */   GIM_Try, /*On fail goto*//*Label 29658*/ GIMT_Encode4(2232383), // Rule ID 48332 //
     /* 2232343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232346 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2232349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2232363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232382 */     // GIR_Coverage, 48332,
     /* 2232382 */     GIR_EraseRootFromParent_Done,
     /* 2232383 */   // Label 29658: @2232383
     /* 2232383 */   GIM_Try, /*On fail goto*//*Label 29659*/ GIMT_Encode4(2232428), // Rule ID 48333 //
     /* 2232388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232391 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2232394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2232408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232427 */     // GIR_Coverage, 48333,
     /* 2232427 */     GIR_EraseRootFromParent_Done,
     /* 2232428 */   // Label 29659: @2232428
     /* 2232428 */   GIM_Reject,
     /* 2232429 */ // Label 29657: @2232429
     /* 2232429 */ GIM_Reject,
     /* 2232430 */ // Label 29611: @2232430
     /* 2232430 */ GIM_Try, /*On fail goto*//*Label 29660*/ GIMT_Encode4(2232544),
     /* 2232435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2232438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2232441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232453 */   GIM_Try, /*On fail goto*//*Label 29661*/ GIMT_Encode4(2232498), // Rule ID 48352 //
     /* 2232458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232461 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2232464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232497 */     // GIR_Coverage, 48352,
     /* 2232497 */     GIR_EraseRootFromParent_Done,
     /* 2232498 */   // Label 29661: @2232498
     /* 2232498 */   GIM_Try, /*On fail goto*//*Label 29662*/ GIMT_Encode4(2232543), // Rule ID 48353 //
     /* 2232503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232506 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2232509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232542 */     // GIR_Coverage, 48353,
     /* 2232542 */     GIR_EraseRootFromParent_Done,
     /* 2232543 */   // Label 29662: @2232543
     /* 2232543 */   GIM_Reject,
     /* 2232544 */ // Label 29660: @2232544
     /* 2232544 */ GIM_Reject,
     /* 2232545 */ // Label 29612: @2232545
     /* 2232545 */ GIM_Try, /*On fail goto*//*Label 29663*/ GIMT_Encode4(2232659),
     /* 2232550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2232553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2232556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232568 */   GIM_Try, /*On fail goto*//*Label 29664*/ GIMT_Encode4(2232613), // Rule ID 48388 //
     /* 2232573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232576 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2232579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232612 */     // GIR_Coverage, 48388,
     /* 2232612 */     GIR_EraseRootFromParent_Done,
     /* 2232613 */   // Label 29664: @2232613
     /* 2232613 */   GIM_Try, /*On fail goto*//*Label 29665*/ GIMT_Encode4(2232658), // Rule ID 48389 //
     /* 2232618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232621 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2232624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232657 */     // GIR_Coverage, 48389,
     /* 2232657 */     GIR_EraseRootFromParent_Done,
     /* 2232658 */   // Label 29665: @2232658
     /* 2232658 */   GIM_Reject,
     /* 2232659 */ // Label 29663: @2232659
     /* 2232659 */ GIM_Reject,
     /* 2232660 */ // Label 29613: @2232660
     /* 2232660 */ GIM_Try, /*On fail goto*//*Label 29666*/ GIMT_Encode4(2232774),
     /* 2232665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2232668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2232671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232683 */   GIM_Try, /*On fail goto*//*Label 29667*/ GIMT_Encode4(2232728), // Rule ID 48404 //
     /* 2232688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232691 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2232694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232727 */     // GIR_Coverage, 48404,
     /* 2232727 */     GIR_EraseRootFromParent_Done,
     /* 2232728 */   // Label 29667: @2232728
     /* 2232728 */   GIM_Try, /*On fail goto*//*Label 29668*/ GIMT_Encode4(2232773), // Rule ID 48405 //
     /* 2232733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232736 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2232739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232772 */     // GIR_Coverage, 48405,
     /* 2232772 */     GIR_EraseRootFromParent_Done,
     /* 2232773 */   // Label 29668: @2232773
     /* 2232773 */   GIM_Reject,
     /* 2232774 */ // Label 29666: @2232774
     /* 2232774 */ GIM_Reject,
     /* 2232775 */ // Label 29614: @2232775
     /* 2232775 */ GIM_Try, /*On fail goto*//*Label 29669*/ GIMT_Encode4(2232889),
     /* 2232780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2232783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2232786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232798 */   GIM_Try, /*On fail goto*//*Label 29670*/ GIMT_Encode4(2232843), // Rule ID 48348 //
     /* 2232803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232806 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2232809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232842 */     // GIR_Coverage, 48348,
     /* 2232842 */     GIR_EraseRootFromParent_Done,
     /* 2232843 */   // Label 29670: @2232843
     /* 2232843 */   GIM_Try, /*On fail goto*//*Label 29671*/ GIMT_Encode4(2232888), // Rule ID 48349 //
     /* 2232848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232851 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2232854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232887 */     // GIR_Coverage, 48349,
     /* 2232887 */     GIR_EraseRootFromParent_Done,
     /* 2232888 */   // Label 29671: @2232888
     /* 2232888 */   GIM_Reject,
     /* 2232889 */ // Label 29669: @2232889
     /* 2232889 */ GIM_Reject,
     /* 2232890 */ // Label 29615: @2232890
     /* 2232890 */ GIM_Try, /*On fail goto*//*Label 29672*/ GIMT_Encode4(2233004),
     /* 2232895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2232898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2232901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232913 */   GIM_Try, /*On fail goto*//*Label 29673*/ GIMT_Encode4(2232958), // Rule ID 48376 //
     /* 2232918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232921 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2232924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232957 */     // GIR_Coverage, 48376,
     /* 2232957 */     GIR_EraseRootFromParent_Done,
     /* 2232958 */   // Label 29673: @2232958
     /* 2232958 */   GIM_Try, /*On fail goto*//*Label 29674*/ GIMT_Encode4(2233003), // Rule ID 48377 //
     /* 2232963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232966 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2232969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233002 */     // GIR_Coverage, 48377,
     /* 2233002 */     GIR_EraseRootFromParent_Done,
     /* 2233003 */   // Label 29674: @2233003
     /* 2233003 */   GIM_Reject,
     /* 2233004 */ // Label 29672: @2233004
     /* 2233004 */ GIM_Reject,
     /* 2233005 */ // Label 29616: @2233005
     /* 2233005 */ GIM_Try, /*On fail goto*//*Label 29675*/ GIMT_Encode4(2233119),
     /* 2233010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2233013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2233016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233028 */   GIM_Try, /*On fail goto*//*Label 29676*/ GIMT_Encode4(2233073), // Rule ID 48392 //
     /* 2233033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233036 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2233039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233072 */     // GIR_Coverage, 48392,
     /* 2233072 */     GIR_EraseRootFromParent_Done,
     /* 2233073 */   // Label 29676: @2233073
     /* 2233073 */   GIM_Try, /*On fail goto*//*Label 29677*/ GIMT_Encode4(2233118), // Rule ID 48393 //
     /* 2233078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233081 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2233084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233117 */     // GIR_Coverage, 48393,
     /* 2233117 */     GIR_EraseRootFromParent_Done,
     /* 2233118 */   // Label 29677: @2233118
     /* 2233118 */   GIM_Reject,
     /* 2233119 */ // Label 29675: @2233119
     /* 2233119 */ GIM_Reject,
     /* 2233120 */ // Label 29617: @2233120
     /* 2233120 */ GIM_Try, /*On fail goto*//*Label 29678*/ GIMT_Encode4(2233234),
     /* 2233125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2233128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2233131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233143 */   GIM_Try, /*On fail goto*//*Label 29679*/ GIMT_Encode4(2233188), // Rule ID 48408 //
     /* 2233148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2233151 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2233154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233187 */     // GIR_Coverage, 48408,
     /* 2233187 */     GIR_EraseRootFromParent_Done,
     /* 2233188 */   // Label 29679: @2233188
     /* 2233188 */   GIM_Try, /*On fail goto*//*Label 29680*/ GIMT_Encode4(2233233), // Rule ID 48409 //
     /* 2233193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2233196 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2233199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233232 */     // GIR_Coverage, 48409,
     /* 2233232 */     GIR_EraseRootFromParent_Done,
     /* 2233233 */   // Label 29680: @2233233
     /* 2233233 */   GIM_Reject,
     /* 2233234 */ // Label 29678: @2233234
     /* 2233234 */ GIM_Reject,
     /* 2233235 */ // Label 29618: @2233235
     /* 2233235 */ GIM_Try, /*On fail goto*//*Label 29681*/ GIMT_Encode4(2233349),
     /* 2233240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2233243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2233246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233258 */   GIM_Try, /*On fail goto*//*Label 29682*/ GIMT_Encode4(2233303), // Rule ID 48364 //
     /* 2233263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233266 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2233269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2233283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233302 */     // GIR_Coverage, 48364,
     /* 2233302 */     GIR_EraseRootFromParent_Done,
     /* 2233303 */   // Label 29682: @2233303
     /* 2233303 */   GIM_Try, /*On fail goto*//*Label 29683*/ GIMT_Encode4(2233348), // Rule ID 48365 //
     /* 2233308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233311 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2233314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2233328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233347 */     // GIR_Coverage, 48365,
     /* 2233347 */     GIR_EraseRootFromParent_Done,
     /* 2233348 */   // Label 29683: @2233348
     /* 2233348 */   GIM_Reject,
     /* 2233349 */ // Label 29681: @2233349
     /* 2233349 */ GIM_Reject,
     /* 2233350 */ // Label 29619: @2233350
     /* 2233350 */ GIM_Try, /*On fail goto*//*Label 29684*/ GIMT_Encode4(2233464),
     /* 2233355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2233358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2233361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233373 */   GIM_Try, /*On fail goto*//*Label 29685*/ GIMT_Encode4(2233418), // Rule ID 48380 //
     /* 2233378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233381 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2233384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233417 */     // GIR_Coverage, 48380,
     /* 2233417 */     GIR_EraseRootFromParent_Done,
     /* 2233418 */   // Label 29685: @2233418
     /* 2233418 */   GIM_Try, /*On fail goto*//*Label 29686*/ GIMT_Encode4(2233463), // Rule ID 48381 //
     /* 2233423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233426 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2233429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233462 */     // GIR_Coverage, 48381,
     /* 2233462 */     GIR_EraseRootFromParent_Done,
     /* 2233463 */   // Label 29686: @2233463
     /* 2233463 */   GIM_Reject,
     /* 2233464 */ // Label 29684: @2233464
     /* 2233464 */ GIM_Reject,
     /* 2233465 */ // Label 29620: @2233465
     /* 2233465 */ GIM_Try, /*On fail goto*//*Label 29687*/ GIMT_Encode4(2233579),
     /* 2233470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2233473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2233476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233488 */   GIM_Try, /*On fail goto*//*Label 29688*/ GIMT_Encode4(2233533), // Rule ID 48396 //
     /* 2233493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233496 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2233499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233532 */     // GIR_Coverage, 48396,
     /* 2233532 */     GIR_EraseRootFromParent_Done,
     /* 2233533 */   // Label 29688: @2233533
     /* 2233533 */   GIM_Try, /*On fail goto*//*Label 29689*/ GIMT_Encode4(2233578), // Rule ID 48397 //
     /* 2233538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233541 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2233544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233577 */     // GIR_Coverage, 48397,
     /* 2233577 */     GIR_EraseRootFromParent_Done,
     /* 2233578 */   // Label 29689: @2233578
     /* 2233578 */   GIM_Reject,
     /* 2233579 */ // Label 29687: @2233579
     /* 2233579 */ GIM_Reject,
     /* 2233580 */ // Label 29621: @2233580
     /* 2233580 */ GIM_Try, /*On fail goto*//*Label 29690*/ GIMT_Encode4(2233694),
     /* 2233585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2233588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2233591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233603 */   GIM_Try, /*On fail goto*//*Label 29691*/ GIMT_Encode4(2233648), // Rule ID 48368 //
     /* 2233608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233611 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2233614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233647 */     // GIR_Coverage, 48368,
     /* 2233647 */     GIR_EraseRootFromParent_Done,
     /* 2233648 */   // Label 29691: @2233648
     /* 2233648 */   GIM_Try, /*On fail goto*//*Label 29692*/ GIMT_Encode4(2233693), // Rule ID 48369 //
     /* 2233653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233656 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2233659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233692 */     // GIR_Coverage, 48369,
     /* 2233692 */     GIR_EraseRootFromParent_Done,
     /* 2233693 */   // Label 29692: @2233693
     /* 2233693 */   GIM_Reject,
     /* 2233694 */ // Label 29690: @2233694
     /* 2233694 */ GIM_Reject,
     /* 2233695 */ // Label 29622: @2233695
     /* 2233695 */ GIM_Try, /*On fail goto*//*Label 29693*/ GIMT_Encode4(2233809),
     /* 2233700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2233703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2233706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233718 */   GIM_Try, /*On fail goto*//*Label 29694*/ GIMT_Encode4(2233763), // Rule ID 48384 //
     /* 2233723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233726 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2233729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233762 */     // GIR_Coverage, 48384,
     /* 2233762 */     GIR_EraseRootFromParent_Done,
     /* 2233763 */   // Label 29694: @2233763
     /* 2233763 */   GIM_Try, /*On fail goto*//*Label 29695*/ GIMT_Encode4(2233808), // Rule ID 48385 //
     /* 2233768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233771 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2233774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233807 */     // GIR_Coverage, 48385,
     /* 2233807 */     GIR_EraseRootFromParent_Done,
     /* 2233808 */   // Label 29695: @2233808
     /* 2233808 */   GIM_Reject,
     /* 2233809 */ // Label 29693: @2233809
     /* 2233809 */ GIM_Reject,
     /* 2233810 */ // Label 29623: @2233810
     /* 2233810 */ GIM_Try, /*On fail goto*//*Label 29696*/ GIMT_Encode4(2233924),
     /* 2233815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2233818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2233821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233833 */   GIM_Try, /*On fail goto*//*Label 29697*/ GIMT_Encode4(2233878), // Rule ID 48372 //
     /* 2233838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233841 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2233844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233877 */     // GIR_Coverage, 48372,
     /* 2233877 */     GIR_EraseRootFromParent_Done,
     /* 2233878 */   // Label 29697: @2233878
     /* 2233878 */   GIM_Try, /*On fail goto*//*Label 29698*/ GIMT_Encode4(2233923), // Rule ID 48373 //
     /* 2233883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233886 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2233889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233922 */     // GIR_Coverage, 48373,
     /* 2233922 */     GIR_EraseRootFromParent_Done,
     /* 2233923 */   // Label 29698: @2233923
     /* 2233923 */   GIM_Reject,
     /* 2233924 */ // Label 29696: @2233924
     /* 2233924 */ GIM_Reject,
     /* 2233925 */ // Label 29624: @2233925
     /* 2233925 */ GIM_Reject,
     /* 2233926 */ // Label 46: @2233926
     /* 2233926 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29723*/ GIMT_Encode4(2236865),
     /* 2233937 */ /*GILLT_s32*//*Label 29699*/ GIMT_Encode4(2234061),
     /* 2233941 */ /*GILLT_s64*//*Label 29700*/ GIMT_Encode4(2234198), GIMT_Encode4(0),
     /* 2233949 */ /*GILLT_nxv1s8*//*Label 29701*/ GIMT_Encode4(2234335),
     /* 2233953 */ /*GILLT_nxv1s16*//*Label 29702*/ GIMT_Encode4(2234450),
     /* 2233957 */ /*GILLT_nxv1s32*//*Label 29703*/ GIMT_Encode4(2234565),
     /* 2233961 */ /*GILLT_nxv1s64*//*Label 29704*/ GIMT_Encode4(2234680), GIMT_Encode4(0),
     /* 2233969 */ /*GILLT_nxv2s8*//*Label 29705*/ GIMT_Encode4(2234795),
     /* 2233973 */ /*GILLT_nxv2s16*//*Label 29706*/ GIMT_Encode4(2234910),
     /* 2233977 */ /*GILLT_nxv2s32*//*Label 29707*/ GIMT_Encode4(2235025),
     /* 2233981 */ /*GILLT_nxv2s64*//*Label 29708*/ GIMT_Encode4(2235140), GIMT_Encode4(0),
     /* 2233989 */ /*GILLT_nxv4s8*//*Label 29709*/ GIMT_Encode4(2235255),
     /* 2233993 */ /*GILLT_nxv4s16*//*Label 29710*/ GIMT_Encode4(2235370),
     /* 2233997 */ /*GILLT_nxv4s32*//*Label 29711*/ GIMT_Encode4(2235485),
     /* 2234001 */ /*GILLT_nxv4s64*//*Label 29712*/ GIMT_Encode4(2235600), GIMT_Encode4(0),
     /* 2234009 */ /*GILLT_nxv8s8*//*Label 29713*/ GIMT_Encode4(2235715),
     /* 2234013 */ /*GILLT_nxv8s16*//*Label 29714*/ GIMT_Encode4(2235830),
     /* 2234017 */ /*GILLT_nxv8s32*//*Label 29715*/ GIMT_Encode4(2235945),
     /* 2234021 */ /*GILLT_nxv8s64*//*Label 29716*/ GIMT_Encode4(2236060), GIMT_Encode4(0),
     /* 2234029 */ /*GILLT_nxv16s8*//*Label 29717*/ GIMT_Encode4(2236175),
     /* 2234033 */ /*GILLT_nxv16s16*//*Label 29718*/ GIMT_Encode4(2236290),
     /* 2234037 */ /*GILLT_nxv16s32*//*Label 29719*/ GIMT_Encode4(2236405), GIMT_Encode4(0),
     /* 2234045 */ /*GILLT_nxv32s8*//*Label 29720*/ GIMT_Encode4(2236520),
     /* 2234049 */ /*GILLT_nxv32s16*//*Label 29721*/ GIMT_Encode4(2236635), GIMT_Encode4(0),
     /* 2234057 */ /*GILLT_nxv64s8*//*Label 29722*/ GIMT_Encode4(2236750),
     /* 2234061 */ // Label 29699: @2234061
     /* 2234061 */ GIM_Try, /*On fail goto*//*Label 29724*/ GIMT_Encode4(2234197),
     /* 2234066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2234069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2234072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234080 */   GIM_Try, /*On fail goto*//*Label 29725*/ GIMT_Encode4(2234114), // Rule ID 2473 //
     /* 2234085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2234088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2234092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2234100 */     // MIs[1] Operand 1
     /* 2234100 */     // No operand predicates
     /* 2234100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234102 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2234102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2234105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2234112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234113 */     // GIR_Coverage, 2473,
     /* 2234113 */     GIR_EraseRootFromParent_Done,
     /* 2234114 */   // Label 29725: @2234114
     /* 2234114 */   GIM_Try, /*On fail goto*//*Label 29726*/ GIMT_Encode4(2234148), // Rule ID 62564 //
     /* 2234119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2234122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2234126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2234134 */     // MIs[1] Operand 1
     /* 2234134 */     // No operand predicates
     /* 2234134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234136 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2234136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2234139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2234146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234147 */     // GIR_Coverage, 62564,
     /* 2234147 */     GIR_EraseRootFromParent_Done,
     /* 2234148 */   // Label 29726: @2234148
     /* 2234148 */   GIM_Try, /*On fail goto*//*Label 29727*/ GIMT_Encode4(2234177), // Rule ID 2471 //
     /* 2234153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2234156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2234163 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2234163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2234166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2234175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234176 */     // GIR_Coverage, 2471,
     /* 2234176 */     GIR_EraseRootFromParent_Done,
     /* 2234177 */   // Label 29727: @2234177
     /* 2234177 */   GIM_Try, /*On fail goto*//*Label 29728*/ GIMT_Encode4(2234196), // Rule ID 64458 //
     /* 2234182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2234185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234189 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2234189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2234194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234195 */     // GIR_Coverage, 64458,
     /* 2234195 */     GIR_Done,
     /* 2234196 */   // Label 29728: @2234196
     /* 2234196 */   GIM_Reject,
     /* 2234197 */ // Label 29724: @2234197
     /* 2234197 */ GIM_Reject,
     /* 2234198 */ // Label 29700: @2234198
     /* 2234198 */ GIM_Try, /*On fail goto*//*Label 29729*/ GIMT_Encode4(2234334),
     /* 2234203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2234206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234217 */   GIM_Try, /*On fail goto*//*Label 29730*/ GIMT_Encode4(2234251), // Rule ID 2472 //
     /* 2234222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2234225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2234229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2234237 */     // MIs[1] Operand 1
     /* 2234237 */     // No operand predicates
     /* 2234237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234239 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2234239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2234242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2234249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234250 */     // GIR_Coverage, 2472,
     /* 2234250 */     GIR_EraseRootFromParent_Done,
     /* 2234251 */   // Label 29730: @2234251
     /* 2234251 */   GIM_Try, /*On fail goto*//*Label 29731*/ GIMT_Encode4(2234285), // Rule ID 62563 //
     /* 2234256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2234259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2234263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2234271 */     // MIs[1] Operand 1
     /* 2234271 */     // No operand predicates
     /* 2234271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234273 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2234273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2234276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2234283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234284 */     // GIR_Coverage, 62563,
     /* 2234284 */     GIR_EraseRootFromParent_Done,
     /* 2234285 */   // Label 29731: @2234285
     /* 2234285 */   GIM_Try, /*On fail goto*//*Label 29732*/ GIMT_Encode4(2234314), // Rule ID 2470 //
     /* 2234290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2234293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2234300 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2234300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2234303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2234312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234313 */     // GIR_Coverage, 2470,
     /* 2234313 */     GIR_EraseRootFromParent_Done,
     /* 2234314 */   // Label 29732: @2234314
     /* 2234314 */   GIM_Try, /*On fail goto*//*Label 29733*/ GIMT_Encode4(2234333), // Rule ID 64457 //
     /* 2234319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2234322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234326 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2234326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2234331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234332 */     // GIR_Coverage, 64457,
     /* 2234332 */     GIR_Done,
     /* 2234333 */   // Label 29733: @2234333
     /* 2234333 */   GIM_Reject,
     /* 2234334 */ // Label 29729: @2234334
     /* 2234334 */ GIM_Reject,
     /* 2234335 */ // Label 29701: @2234335
     /* 2234335 */ GIM_Try, /*On fail goto*//*Label 29734*/ GIMT_Encode4(2234449),
     /* 2234340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2234343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2234346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234358 */   GIM_Try, /*On fail goto*//*Label 29735*/ GIMT_Encode4(2234403), // Rule ID 59416 //
     /* 2234363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234366 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2234369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2234383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234402 */     // GIR_Coverage, 59416,
     /* 2234402 */     GIR_EraseRootFromParent_Done,
     /* 2234403 */   // Label 29735: @2234403
     /* 2234403 */   GIM_Try, /*On fail goto*//*Label 29736*/ GIMT_Encode4(2234448), // Rule ID 59417 //
     /* 2234408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234411 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2234414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2234428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234447 */     // GIR_Coverage, 59417,
     /* 2234447 */     GIR_EraseRootFromParent_Done,
     /* 2234448 */   // Label 29736: @2234448
     /* 2234448 */   GIM_Reject,
     /* 2234449 */ // Label 29734: @2234449
     /* 2234449 */ GIM_Reject,
     /* 2234450 */ // Label 29702: @2234450
     /* 2234450 */ GIM_Try, /*On fail goto*//*Label 29737*/ GIMT_Encode4(2234564),
     /* 2234455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2234458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2234461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234473 */   GIM_Try, /*On fail goto*//*Label 29738*/ GIMT_Encode4(2234518), // Rule ID 59428 //
     /* 2234478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234481 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2234484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234517 */     // GIR_Coverage, 59428,
     /* 2234517 */     GIR_EraseRootFromParent_Done,
     /* 2234518 */   // Label 29738: @2234518
     /* 2234518 */   GIM_Try, /*On fail goto*//*Label 29739*/ GIMT_Encode4(2234563), // Rule ID 59429 //
     /* 2234523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234526 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2234529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234562 */     // GIR_Coverage, 59429,
     /* 2234562 */     GIR_EraseRootFromParent_Done,
     /* 2234563 */   // Label 29739: @2234563
     /* 2234563 */   GIM_Reject,
     /* 2234564 */ // Label 29737: @2234564
     /* 2234564 */ GIM_Reject,
     /* 2234565 */ // Label 29703: @2234565
     /* 2234565 */ GIM_Try, /*On fail goto*//*Label 29740*/ GIMT_Encode4(2234679),
     /* 2234570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2234573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2234576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234588 */   GIM_Try, /*On fail goto*//*Label 29741*/ GIMT_Encode4(2234633), // Rule ID 59436 //
     /* 2234593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234596 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2234599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234632 */     // GIR_Coverage, 59436,
     /* 2234632 */     GIR_EraseRootFromParent_Done,
     /* 2234633 */   // Label 29741: @2234633
     /* 2234633 */   GIM_Try, /*On fail goto*//*Label 29742*/ GIMT_Encode4(2234678), // Rule ID 59437 //
     /* 2234638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234641 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2234644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234677 */     // GIR_Coverage, 59437,
     /* 2234677 */     GIR_EraseRootFromParent_Done,
     /* 2234678 */   // Label 29742: @2234678
     /* 2234678 */   GIM_Reject,
     /* 2234679 */ // Label 29740: @2234679
     /* 2234679 */ GIM_Reject,
     /* 2234680 */ // Label 29704: @2234680
     /* 2234680 */ GIM_Try, /*On fail goto*//*Label 29743*/ GIMT_Encode4(2234794),
     /* 2234685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2234688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2234691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234703 */   GIM_Try, /*On fail goto*//*Label 29744*/ GIMT_Encode4(2234748), // Rule ID 59452 //
     /* 2234708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2234711 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2234714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234747 */     // GIR_Coverage, 59452,
     /* 2234747 */     GIR_EraseRootFromParent_Done,
     /* 2234748 */   // Label 29744: @2234748
     /* 2234748 */   GIM_Try, /*On fail goto*//*Label 29745*/ GIMT_Encode4(2234793), // Rule ID 59453 //
     /* 2234753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2234756 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2234759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234792 */     // GIR_Coverage, 59453,
     /* 2234792 */     GIR_EraseRootFromParent_Done,
     /* 2234793 */   // Label 29745: @2234793
     /* 2234793 */   GIM_Reject,
     /* 2234794 */ // Label 29743: @2234794
     /* 2234794 */ GIM_Reject,
     /* 2234795 */ // Label 29705: @2234795
     /* 2234795 */ GIM_Try, /*On fail goto*//*Label 29746*/ GIMT_Encode4(2234909),
     /* 2234800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2234803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2234806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234818 */   GIM_Try, /*On fail goto*//*Label 29747*/ GIMT_Encode4(2234863), // Rule ID 59420 //
     /* 2234823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234826 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2234829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234862 */     // GIR_Coverage, 59420,
     /* 2234862 */     GIR_EraseRootFromParent_Done,
     /* 2234863 */   // Label 29747: @2234863
     /* 2234863 */   GIM_Try, /*On fail goto*//*Label 29748*/ GIMT_Encode4(2234908), // Rule ID 59421 //
     /* 2234868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234871 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2234874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234907 */     // GIR_Coverage, 59421,
     /* 2234907 */     GIR_EraseRootFromParent_Done,
     /* 2234908 */   // Label 29748: @2234908
     /* 2234908 */   GIM_Reject,
     /* 2234909 */ // Label 29746: @2234909
     /* 2234909 */ GIM_Reject,
     /* 2234910 */ // Label 29706: @2234910
     /* 2234910 */ GIM_Try, /*On fail goto*//*Label 29749*/ GIMT_Encode4(2235024),
     /* 2234915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2234918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2234921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234933 */   GIM_Try, /*On fail goto*//*Label 29750*/ GIMT_Encode4(2234978), // Rule ID 59432 //
     /* 2234938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234941 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2234944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234977 */     // GIR_Coverage, 59432,
     /* 2234977 */     GIR_EraseRootFromParent_Done,
     /* 2234978 */   // Label 29750: @2234978
     /* 2234978 */   GIM_Try, /*On fail goto*//*Label 29751*/ GIMT_Encode4(2235023), // Rule ID 59433 //
     /* 2234983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234986 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2234989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2235003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235022 */     // GIR_Coverage, 59433,
     /* 2235022 */     GIR_EraseRootFromParent_Done,
     /* 2235023 */   // Label 29751: @2235023
     /* 2235023 */   GIM_Reject,
     /* 2235024 */ // Label 29749: @2235024
     /* 2235024 */ GIM_Reject,
     /* 2235025 */ // Label 29707: @2235025
     /* 2235025 */ GIM_Try, /*On fail goto*//*Label 29752*/ GIMT_Encode4(2235139),
     /* 2235030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2235033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2235036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235048 */   GIM_Try, /*On fail goto*//*Label 29753*/ GIMT_Encode4(2235093), // Rule ID 59448 //
     /* 2235053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235056 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2235059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235092 */     // GIR_Coverage, 59448,
     /* 2235092 */     GIR_EraseRootFromParent_Done,
     /* 2235093 */   // Label 29753: @2235093
     /* 2235093 */   GIM_Try, /*On fail goto*//*Label 29754*/ GIMT_Encode4(2235138), // Rule ID 59449 //
     /* 2235098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235101 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2235104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235137 */     // GIR_Coverage, 59449,
     /* 2235137 */     GIR_EraseRootFromParent_Done,
     /* 2235138 */   // Label 29754: @2235138
     /* 2235138 */   GIM_Reject,
     /* 2235139 */ // Label 29752: @2235139
     /* 2235139 */ GIM_Reject,
     /* 2235140 */ // Label 29708: @2235140
     /* 2235140 */ GIM_Try, /*On fail goto*//*Label 29755*/ GIMT_Encode4(2235254),
     /* 2235145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2235148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2235151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235163 */   GIM_Try, /*On fail goto*//*Label 29756*/ GIMT_Encode4(2235208), // Rule ID 59492 //
     /* 2235168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235171 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2235174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235207 */     // GIR_Coverage, 59492,
     /* 2235207 */     GIR_EraseRootFromParent_Done,
     /* 2235208 */   // Label 29756: @2235208
     /* 2235208 */   GIM_Try, /*On fail goto*//*Label 29757*/ GIMT_Encode4(2235253), // Rule ID 59493 //
     /* 2235213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235216 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2235219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235252 */     // GIR_Coverage, 59493,
     /* 2235252 */     GIR_EraseRootFromParent_Done,
     /* 2235253 */   // Label 29757: @2235253
     /* 2235253 */   GIM_Reject,
     /* 2235254 */ // Label 29755: @2235254
     /* 2235254 */ GIM_Reject,
     /* 2235255 */ // Label 29709: @2235255
     /* 2235255 */ GIM_Try, /*On fail goto*//*Label 29758*/ GIMT_Encode4(2235369),
     /* 2235260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2235263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2235266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235278 */   GIM_Try, /*On fail goto*//*Label 29759*/ GIMT_Encode4(2235323), // Rule ID 59424 //
     /* 2235283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235286 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2235289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2235303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235322 */     // GIR_Coverage, 59424,
     /* 2235322 */     GIR_EraseRootFromParent_Done,
     /* 2235323 */   // Label 29759: @2235323
     /* 2235323 */   GIM_Try, /*On fail goto*//*Label 29760*/ GIMT_Encode4(2235368), // Rule ID 59425 //
     /* 2235328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235331 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2235334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2235348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235367 */     // GIR_Coverage, 59425,
     /* 2235367 */     GIR_EraseRootFromParent_Done,
     /* 2235368 */   // Label 29760: @2235368
     /* 2235368 */   GIM_Reject,
     /* 2235369 */ // Label 29758: @2235369
     /* 2235369 */ GIM_Reject,
     /* 2235370 */ // Label 29710: @2235370
     /* 2235370 */ GIM_Try, /*On fail goto*//*Label 29761*/ GIMT_Encode4(2235484),
     /* 2235375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2235378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2235381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235393 */   GIM_Try, /*On fail goto*//*Label 29762*/ GIMT_Encode4(2235438), // Rule ID 59444 //
     /* 2235398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235401 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2235404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235437 */     // GIR_Coverage, 59444,
     /* 2235437 */     GIR_EraseRootFromParent_Done,
     /* 2235438 */   // Label 29762: @2235438
     /* 2235438 */   GIM_Try, /*On fail goto*//*Label 29763*/ GIMT_Encode4(2235483), // Rule ID 59445 //
     /* 2235443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235446 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2235449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235482 */     // GIR_Coverage, 59445,
     /* 2235482 */     GIR_EraseRootFromParent_Done,
     /* 2235483 */   // Label 29763: @2235483
     /* 2235483 */   GIM_Reject,
     /* 2235484 */ // Label 29761: @2235484
     /* 2235484 */ GIM_Reject,
     /* 2235485 */ // Label 29711: @2235485
     /* 2235485 */ GIM_Try, /*On fail goto*//*Label 29764*/ GIMT_Encode4(2235599),
     /* 2235490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2235493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2235496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235508 */   GIM_Try, /*On fail goto*//*Label 29765*/ GIMT_Encode4(2235553), // Rule ID 59480 //
     /* 2235513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235516 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2235519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235552 */     // GIR_Coverage, 59480,
     /* 2235552 */     GIR_EraseRootFromParent_Done,
     /* 2235553 */   // Label 29765: @2235553
     /* 2235553 */   GIM_Try, /*On fail goto*//*Label 29766*/ GIMT_Encode4(2235598), // Rule ID 59481 //
     /* 2235558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235561 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2235564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235597 */     // GIR_Coverage, 59481,
     /* 2235597 */     GIR_EraseRootFromParent_Done,
     /* 2235598 */   // Label 29766: @2235598
     /* 2235598 */   GIM_Reject,
     /* 2235599 */ // Label 29764: @2235599
     /* 2235599 */ GIM_Reject,
     /* 2235600 */ // Label 29712: @2235600
     /* 2235600 */ GIM_Try, /*On fail goto*//*Label 29767*/ GIMT_Encode4(2235714),
     /* 2235605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2235608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2235611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235623 */   GIM_Try, /*On fail goto*//*Label 29768*/ GIMT_Encode4(2235668), // Rule ID 59496 //
     /* 2235628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235631 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2235634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235667 */     // GIR_Coverage, 59496,
     /* 2235667 */     GIR_EraseRootFromParent_Done,
     /* 2235668 */   // Label 29768: @2235668
     /* 2235668 */   GIM_Try, /*On fail goto*//*Label 29769*/ GIMT_Encode4(2235713), // Rule ID 59497 //
     /* 2235673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235676 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2235679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235712 */     // GIR_Coverage, 59497,
     /* 2235712 */     GIR_EraseRootFromParent_Done,
     /* 2235713 */   // Label 29769: @2235713
     /* 2235713 */   GIM_Reject,
     /* 2235714 */ // Label 29767: @2235714
     /* 2235714 */ GIM_Reject,
     /* 2235715 */ // Label 29713: @2235715
     /* 2235715 */ GIM_Try, /*On fail goto*//*Label 29770*/ GIMT_Encode4(2235829),
     /* 2235720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2235723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2235726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235738 */   GIM_Try, /*On fail goto*//*Label 29771*/ GIMT_Encode4(2235783), // Rule ID 59440 //
     /* 2235743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235746 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2235749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235782 */     // GIR_Coverage, 59440,
     /* 2235782 */     GIR_EraseRootFromParent_Done,
     /* 2235783 */   // Label 29771: @2235783
     /* 2235783 */   GIM_Try, /*On fail goto*//*Label 29772*/ GIMT_Encode4(2235828), // Rule ID 59441 //
     /* 2235788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235791 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2235794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235827 */     // GIR_Coverage, 59441,
     /* 2235827 */     GIR_EraseRootFromParent_Done,
     /* 2235828 */   // Label 29772: @2235828
     /* 2235828 */   GIM_Reject,
     /* 2235829 */ // Label 29770: @2235829
     /* 2235829 */ GIM_Reject,
     /* 2235830 */ // Label 29714: @2235830
     /* 2235830 */ GIM_Try, /*On fail goto*//*Label 29773*/ GIMT_Encode4(2235944),
     /* 2235835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2235838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2235841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235853 */   GIM_Try, /*On fail goto*//*Label 29774*/ GIMT_Encode4(2235898), // Rule ID 59468 //
     /* 2235858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235861 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2235864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235897 */     // GIR_Coverage, 59468,
     /* 2235897 */     GIR_EraseRootFromParent_Done,
     /* 2235898 */   // Label 29774: @2235898
     /* 2235898 */   GIM_Try, /*On fail goto*//*Label 29775*/ GIMT_Encode4(2235943), // Rule ID 59469 //
     /* 2235903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235906 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2235909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235942 */     // GIR_Coverage, 59469,
     /* 2235942 */     GIR_EraseRootFromParent_Done,
     /* 2235943 */   // Label 29775: @2235943
     /* 2235943 */   GIM_Reject,
     /* 2235944 */ // Label 29773: @2235944
     /* 2235944 */ GIM_Reject,
     /* 2235945 */ // Label 29715: @2235945
     /* 2235945 */ GIM_Try, /*On fail goto*//*Label 29776*/ GIMT_Encode4(2236059),
     /* 2235950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2235953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2235956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235964 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235968 */   GIM_Try, /*On fail goto*//*Label 29777*/ GIMT_Encode4(2236013), // Rule ID 59484 //
     /* 2235973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235976 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2235979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236012 */     // GIR_Coverage, 59484,
     /* 2236012 */     GIR_EraseRootFromParent_Done,
     /* 2236013 */   // Label 29777: @2236013
     /* 2236013 */   GIM_Try, /*On fail goto*//*Label 29778*/ GIMT_Encode4(2236058), // Rule ID 59485 //
     /* 2236018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236021 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2236024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236057 */     // GIR_Coverage, 59485,
     /* 2236057 */     GIR_EraseRootFromParent_Done,
     /* 2236058 */   // Label 29778: @2236058
     /* 2236058 */   GIM_Reject,
     /* 2236059 */ // Label 29776: @2236059
     /* 2236059 */ GIM_Reject,
     /* 2236060 */ // Label 29716: @2236060
     /* 2236060 */ GIM_Try, /*On fail goto*//*Label 29779*/ GIMT_Encode4(2236174),
     /* 2236065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2236068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2236071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236083 */   GIM_Try, /*On fail goto*//*Label 29780*/ GIMT_Encode4(2236128), // Rule ID 59500 //
     /* 2236088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2236091 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2236094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236127 */     // GIR_Coverage, 59500,
     /* 2236127 */     GIR_EraseRootFromParent_Done,
     /* 2236128 */   // Label 29780: @2236128
     /* 2236128 */   GIM_Try, /*On fail goto*//*Label 29781*/ GIMT_Encode4(2236173), // Rule ID 59501 //
     /* 2236133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2236136 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2236139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236172 */     // GIR_Coverage, 59501,
     /* 2236172 */     GIR_EraseRootFromParent_Done,
     /* 2236173 */   // Label 29781: @2236173
     /* 2236173 */   GIM_Reject,
     /* 2236174 */ // Label 29779: @2236174
     /* 2236174 */ GIM_Reject,
     /* 2236175 */ // Label 29717: @2236175
     /* 2236175 */ GIM_Try, /*On fail goto*//*Label 29782*/ GIMT_Encode4(2236289),
     /* 2236180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2236183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2236186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236198 */   GIM_Try, /*On fail goto*//*Label 29783*/ GIMT_Encode4(2236243), // Rule ID 59456 //
     /* 2236203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236206 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2236209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2236223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236242 */     // GIR_Coverage, 59456,
     /* 2236242 */     GIR_EraseRootFromParent_Done,
     /* 2236243 */   // Label 29783: @2236243
     /* 2236243 */   GIM_Try, /*On fail goto*//*Label 29784*/ GIMT_Encode4(2236288), // Rule ID 59457 //
     /* 2236248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236251 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2236254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2236268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236287 */     // GIR_Coverage, 59457,
     /* 2236287 */     GIR_EraseRootFromParent_Done,
     /* 2236288 */   // Label 29784: @2236288
     /* 2236288 */   GIM_Reject,
     /* 2236289 */ // Label 29782: @2236289
     /* 2236289 */ GIM_Reject,
     /* 2236290 */ // Label 29718: @2236290
     /* 2236290 */ GIM_Try, /*On fail goto*//*Label 29785*/ GIMT_Encode4(2236404),
     /* 2236295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2236298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2236301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236313 */   GIM_Try, /*On fail goto*//*Label 29786*/ GIMT_Encode4(2236358), // Rule ID 59472 //
     /* 2236318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236321 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2236324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236357 */     // GIR_Coverage, 59472,
     /* 2236357 */     GIR_EraseRootFromParent_Done,
     /* 2236358 */   // Label 29786: @2236358
     /* 2236358 */   GIM_Try, /*On fail goto*//*Label 29787*/ GIMT_Encode4(2236403), // Rule ID 59473 //
     /* 2236363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236366 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2236369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236402 */     // GIR_Coverage, 59473,
     /* 2236402 */     GIR_EraseRootFromParent_Done,
     /* 2236403 */   // Label 29787: @2236403
     /* 2236403 */   GIM_Reject,
     /* 2236404 */ // Label 29785: @2236404
     /* 2236404 */ GIM_Reject,
     /* 2236405 */ // Label 29719: @2236405
     /* 2236405 */ GIM_Try, /*On fail goto*//*Label 29788*/ GIMT_Encode4(2236519),
     /* 2236410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2236413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2236416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236428 */   GIM_Try, /*On fail goto*//*Label 29789*/ GIMT_Encode4(2236473), // Rule ID 59488 //
     /* 2236433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236436 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2236439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236472 */     // GIR_Coverage, 59488,
     /* 2236472 */     GIR_EraseRootFromParent_Done,
     /* 2236473 */   // Label 29789: @2236473
     /* 2236473 */   GIM_Try, /*On fail goto*//*Label 29790*/ GIMT_Encode4(2236518), // Rule ID 59489 //
     /* 2236478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236481 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2236484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236517 */     // GIR_Coverage, 59489,
     /* 2236517 */     GIR_EraseRootFromParent_Done,
     /* 2236518 */   // Label 29790: @2236518
     /* 2236518 */   GIM_Reject,
     /* 2236519 */ // Label 29788: @2236519
     /* 2236519 */ GIM_Reject,
     /* 2236520 */ // Label 29720: @2236520
     /* 2236520 */ GIM_Try, /*On fail goto*//*Label 29791*/ GIMT_Encode4(2236634),
     /* 2236525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2236528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2236531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236543 */   GIM_Try, /*On fail goto*//*Label 29792*/ GIMT_Encode4(2236588), // Rule ID 59460 //
     /* 2236548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236551 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2236554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236587 */     // GIR_Coverage, 59460,
     /* 2236587 */     GIR_EraseRootFromParent_Done,
     /* 2236588 */   // Label 29792: @2236588
     /* 2236588 */   GIM_Try, /*On fail goto*//*Label 29793*/ GIMT_Encode4(2236633), // Rule ID 59461 //
     /* 2236593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236596 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2236599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236632 */     // GIR_Coverage, 59461,
     /* 2236632 */     GIR_EraseRootFromParent_Done,
     /* 2236633 */   // Label 29793: @2236633
     /* 2236633 */   GIM_Reject,
     /* 2236634 */ // Label 29791: @2236634
     /* 2236634 */ GIM_Reject,
     /* 2236635 */ // Label 29721: @2236635
     /* 2236635 */ GIM_Try, /*On fail goto*//*Label 29794*/ GIMT_Encode4(2236749),
     /* 2236640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2236643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2236646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236658 */   GIM_Try, /*On fail goto*//*Label 29795*/ GIMT_Encode4(2236703), // Rule ID 59476 //
     /* 2236663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236666 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2236669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236702 */     // GIR_Coverage, 59476,
     /* 2236702 */     GIR_EraseRootFromParent_Done,
     /* 2236703 */   // Label 29795: @2236703
     /* 2236703 */   GIM_Try, /*On fail goto*//*Label 29796*/ GIMT_Encode4(2236748), // Rule ID 59477 //
     /* 2236708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236711 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2236714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236747 */     // GIR_Coverage, 59477,
     /* 2236747 */     GIR_EraseRootFromParent_Done,
     /* 2236748 */   // Label 29796: @2236748
     /* 2236748 */   GIM_Reject,
     /* 2236749 */ // Label 29794: @2236749
     /* 2236749 */ GIM_Reject,
     /* 2236750 */ // Label 29722: @2236750
     /* 2236750 */ GIM_Try, /*On fail goto*//*Label 29797*/ GIMT_Encode4(2236864),
     /* 2236755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2236758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2236761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236773 */   GIM_Try, /*On fail goto*//*Label 29798*/ GIMT_Encode4(2236818), // Rule ID 59464 //
     /* 2236778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236781 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2236784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236817 */     // GIR_Coverage, 59464,
     /* 2236817 */     GIR_EraseRootFromParent_Done,
     /* 2236818 */   // Label 29798: @2236818
     /* 2236818 */   GIM_Try, /*On fail goto*//*Label 29799*/ GIMT_Encode4(2236863), // Rule ID 59465 //
     /* 2236823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236826 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2236829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236862 */     // GIR_Coverage, 59465,
     /* 2236862 */     GIR_EraseRootFromParent_Done,
     /* 2236863 */   // Label 29799: @2236863
     /* 2236863 */   GIM_Reject,
     /* 2236864 */ // Label 29797: @2236864
     /* 2236864 */ GIM_Reject,
     /* 2236865 */ // Label 29723: @2236865
     /* 2236865 */ GIM_Reject,
     /* 2236866 */ // Label 47: @2236866
     /* 2236866 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29824*/ GIMT_Encode4(2239775),
     /* 2236877 */ /*GILLT_s32*//*Label 29800*/ GIMT_Encode4(2237001),
     /* 2236881 */ /*GILLT_s64*//*Label 29801*/ GIMT_Encode4(2237123), GIMT_Encode4(0),
     /* 2236889 */ /*GILLT_nxv1s8*//*Label 29802*/ GIMT_Encode4(2237245),
     /* 2236893 */ /*GILLT_nxv1s16*//*Label 29803*/ GIMT_Encode4(2237360),
     /* 2236897 */ /*GILLT_nxv1s32*//*Label 29804*/ GIMT_Encode4(2237475),
     /* 2236901 */ /*GILLT_nxv1s64*//*Label 29805*/ GIMT_Encode4(2237590), GIMT_Encode4(0),
     /* 2236909 */ /*GILLT_nxv2s8*//*Label 29806*/ GIMT_Encode4(2237705),
     /* 2236913 */ /*GILLT_nxv2s16*//*Label 29807*/ GIMT_Encode4(2237820),
     /* 2236917 */ /*GILLT_nxv2s32*//*Label 29808*/ GIMT_Encode4(2237935),
     /* 2236921 */ /*GILLT_nxv2s64*//*Label 29809*/ GIMT_Encode4(2238050), GIMT_Encode4(0),
     /* 2236929 */ /*GILLT_nxv4s8*//*Label 29810*/ GIMT_Encode4(2238165),
     /* 2236933 */ /*GILLT_nxv4s16*//*Label 29811*/ GIMT_Encode4(2238280),
     /* 2236937 */ /*GILLT_nxv4s32*//*Label 29812*/ GIMT_Encode4(2238395),
     /* 2236941 */ /*GILLT_nxv4s64*//*Label 29813*/ GIMT_Encode4(2238510), GIMT_Encode4(0),
     /* 2236949 */ /*GILLT_nxv8s8*//*Label 29814*/ GIMT_Encode4(2238625),
     /* 2236953 */ /*GILLT_nxv8s16*//*Label 29815*/ GIMT_Encode4(2238740),
     /* 2236957 */ /*GILLT_nxv8s32*//*Label 29816*/ GIMT_Encode4(2238855),
     /* 2236961 */ /*GILLT_nxv8s64*//*Label 29817*/ GIMT_Encode4(2238970), GIMT_Encode4(0),
     /* 2236969 */ /*GILLT_nxv16s8*//*Label 29818*/ GIMT_Encode4(2239085),
     /* 2236973 */ /*GILLT_nxv16s16*//*Label 29819*/ GIMT_Encode4(2239200),
     /* 2236977 */ /*GILLT_nxv16s32*//*Label 29820*/ GIMT_Encode4(2239315), GIMT_Encode4(0),
     /* 2236985 */ /*GILLT_nxv32s8*//*Label 29821*/ GIMT_Encode4(2239430),
     /* 2236989 */ /*GILLT_nxv32s16*//*Label 29822*/ GIMT_Encode4(2239545), GIMT_Encode4(0),
     /* 2236997 */ /*GILLT_nxv64s8*//*Label 29823*/ GIMT_Encode4(2239660),
     /* 2237001 */ // Label 29800: @2237001
     /* 2237001 */ GIM_Try, /*On fail goto*//*Label 29825*/ GIMT_Encode4(2237122),
     /* 2237006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2237009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2237012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237020 */   GIM_Try, /*On fail goto*//*Label 29826*/ GIMT_Encode4(2237056), // Rule ID 2475 //
     /* 2237025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2237028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2237036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2237040 */     // MIs[1] Operand 1
     /* 2237040 */     // No operand predicates
     /* 2237040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237042 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2237042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2237045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237049 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2237054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237055 */     // GIR_Coverage, 2475,
     /* 2237055 */     GIR_EraseRootFromParent_Done,
     /* 2237056 */   // Label 29826: @2237056
     /* 2237056 */   GIM_Try, /*On fail goto*//*Label 29827*/ GIMT_Encode4(2237092), // Rule ID 62566 //
     /* 2237061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2237064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2237072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2237076 */     // MIs[1] Operand 1
     /* 2237076 */     // No operand predicates
     /* 2237076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237078 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2237078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2237081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237085 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2237090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237091 */     // GIR_Coverage, 62566,
     /* 2237091 */     GIR_EraseRootFromParent_Done,
     /* 2237092 */   // Label 29827: @2237092
     /* 2237092 */   GIM_Try, /*On fail goto*//*Label 29828*/ GIMT_Encode4(2237121), // Rule ID 2469 //
     /* 2237097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2237100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2237107 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2237107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2237110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2237119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237120 */     // GIR_Coverage, 2469,
     /* 2237120 */     GIR_EraseRootFromParent_Done,
     /* 2237121 */   // Label 29828: @2237121
     /* 2237121 */   GIM_Reject,
     /* 2237122 */ // Label 29825: @2237122
     /* 2237122 */ GIM_Reject,
     /* 2237123 */ // Label 29801: @2237123
     /* 2237123 */ GIM_Try, /*On fail goto*//*Label 29829*/ GIMT_Encode4(2237244),
     /* 2237128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2237131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2237134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237142 */   GIM_Try, /*On fail goto*//*Label 29830*/ GIMT_Encode4(2237178), // Rule ID 2474 //
     /* 2237147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2237150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2237158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2237162 */     // MIs[1] Operand 1
     /* 2237162 */     // No operand predicates
     /* 2237162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237164 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2237164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2237167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237171 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2237176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237177 */     // GIR_Coverage, 2474,
     /* 2237177 */     GIR_EraseRootFromParent_Done,
     /* 2237178 */   // Label 29830: @2237178
     /* 2237178 */   GIM_Try, /*On fail goto*//*Label 29831*/ GIMT_Encode4(2237214), // Rule ID 62565 //
     /* 2237183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2237186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2237194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2237198 */     // MIs[1] Operand 1
     /* 2237198 */     // No operand predicates
     /* 2237198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237200 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2237200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2237203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237207 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2237212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237213 */     // GIR_Coverage, 62565,
     /* 2237213 */     GIR_EraseRootFromParent_Done,
     /* 2237214 */   // Label 29831: @2237214
     /* 2237214 */   GIM_Try, /*On fail goto*//*Label 29832*/ GIMT_Encode4(2237243), // Rule ID 2468 //
     /* 2237219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2237222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2237229 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2237229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2237232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2237241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237242 */     // GIR_Coverage, 2468,
     /* 2237242 */     GIR_EraseRootFromParent_Done,
     /* 2237243 */   // Label 29832: @2237243
     /* 2237243 */   GIM_Reject,
     /* 2237244 */ // Label 29829: @2237244
     /* 2237244 */ GIM_Reject,
     /* 2237245 */ // Label 29802: @2237245
     /* 2237245 */ GIM_Try, /*On fail goto*//*Label 29833*/ GIMT_Encode4(2237359),
     /* 2237250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2237253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2237256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237268 */   GIM_Try, /*On fail goto*//*Label 29834*/ GIMT_Encode4(2237313), // Rule ID 59284 //
     /* 2237273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237276 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2237279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2237293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237312 */     // GIR_Coverage, 59284,
     /* 2237312 */     GIR_EraseRootFromParent_Done,
     /* 2237313 */   // Label 29834: @2237313
     /* 2237313 */   GIM_Try, /*On fail goto*//*Label 29835*/ GIMT_Encode4(2237358), // Rule ID 59285 //
     /* 2237318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237321 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2237324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2237338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237357 */     // GIR_Coverage, 59285,
     /* 2237357 */     GIR_EraseRootFromParent_Done,
     /* 2237358 */   // Label 29835: @2237358
     /* 2237358 */   GIM_Reject,
     /* 2237359 */ // Label 29833: @2237359
     /* 2237359 */ GIM_Reject,
     /* 2237360 */ // Label 29803: @2237360
     /* 2237360 */ GIM_Try, /*On fail goto*//*Label 29836*/ GIMT_Encode4(2237474),
     /* 2237365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2237368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2237371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237383 */   GIM_Try, /*On fail goto*//*Label 29837*/ GIMT_Encode4(2237428), // Rule ID 59296 //
     /* 2237388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237391 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2237394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2237408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237427 */     // GIR_Coverage, 59296,
     /* 2237427 */     GIR_EraseRootFromParent_Done,
     /* 2237428 */   // Label 29837: @2237428
     /* 2237428 */   GIM_Try, /*On fail goto*//*Label 29838*/ GIMT_Encode4(2237473), // Rule ID 59297 //
     /* 2237433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237436 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2237439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2237453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237472 */     // GIR_Coverage, 59297,
     /* 2237472 */     GIR_EraseRootFromParent_Done,
     /* 2237473 */   // Label 29838: @2237473
     /* 2237473 */   GIM_Reject,
     /* 2237474 */ // Label 29836: @2237474
     /* 2237474 */ GIM_Reject,
     /* 2237475 */ // Label 29804: @2237475
     /* 2237475 */ GIM_Try, /*On fail goto*//*Label 29839*/ GIMT_Encode4(2237589),
     /* 2237480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2237483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2237486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237498 */   GIM_Try, /*On fail goto*//*Label 29840*/ GIMT_Encode4(2237543), // Rule ID 59304 //
     /* 2237503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237506 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2237509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237542 */     // GIR_Coverage, 59304,
     /* 2237542 */     GIR_EraseRootFromParent_Done,
     /* 2237543 */   // Label 29840: @2237543
     /* 2237543 */   GIM_Try, /*On fail goto*//*Label 29841*/ GIMT_Encode4(2237588), // Rule ID 59305 //
     /* 2237548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237551 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2237554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237587 */     // GIR_Coverage, 59305,
     /* 2237587 */     GIR_EraseRootFromParent_Done,
     /* 2237588 */   // Label 29841: @2237588
     /* 2237588 */   GIM_Reject,
     /* 2237589 */ // Label 29839: @2237589
     /* 2237589 */ GIM_Reject,
     /* 2237590 */ // Label 29805: @2237590
     /* 2237590 */ GIM_Try, /*On fail goto*//*Label 29842*/ GIMT_Encode4(2237704),
     /* 2237595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2237598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2237601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237613 */   GIM_Try, /*On fail goto*//*Label 29843*/ GIMT_Encode4(2237658), // Rule ID 59320 //
     /* 2237618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2237621 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2237624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237657 */     // GIR_Coverage, 59320,
     /* 2237657 */     GIR_EraseRootFromParent_Done,
     /* 2237658 */   // Label 29843: @2237658
     /* 2237658 */   GIM_Try, /*On fail goto*//*Label 29844*/ GIMT_Encode4(2237703), // Rule ID 59321 //
     /* 2237663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2237666 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2237669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237702 */     // GIR_Coverage, 59321,
     /* 2237702 */     GIR_EraseRootFromParent_Done,
     /* 2237703 */   // Label 29844: @2237703
     /* 2237703 */   GIM_Reject,
     /* 2237704 */ // Label 29842: @2237704
     /* 2237704 */ GIM_Reject,
     /* 2237705 */ // Label 29806: @2237705
     /* 2237705 */ GIM_Try, /*On fail goto*//*Label 29845*/ GIMT_Encode4(2237819),
     /* 2237710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2237713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2237716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237728 */   GIM_Try, /*On fail goto*//*Label 29846*/ GIMT_Encode4(2237773), // Rule ID 59288 //
     /* 2237733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237736 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2237739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2237753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237772 */     // GIR_Coverage, 59288,
     /* 2237772 */     GIR_EraseRootFromParent_Done,
     /* 2237773 */   // Label 29846: @2237773
     /* 2237773 */   GIM_Try, /*On fail goto*//*Label 29847*/ GIMT_Encode4(2237818), // Rule ID 59289 //
     /* 2237778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237781 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2237784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2237798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237817 */     // GIR_Coverage, 59289,
     /* 2237817 */     GIR_EraseRootFromParent_Done,
     /* 2237818 */   // Label 29847: @2237818
     /* 2237818 */   GIM_Reject,
     /* 2237819 */ // Label 29845: @2237819
     /* 2237819 */ GIM_Reject,
     /* 2237820 */ // Label 29807: @2237820
     /* 2237820 */ GIM_Try, /*On fail goto*//*Label 29848*/ GIMT_Encode4(2237934),
     /* 2237825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2237828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2237831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237843 */   GIM_Try, /*On fail goto*//*Label 29849*/ GIMT_Encode4(2237888), // Rule ID 59300 //
     /* 2237848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237851 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2237854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237887 */     // GIR_Coverage, 59300,
     /* 2237887 */     GIR_EraseRootFromParent_Done,
     /* 2237888 */   // Label 29849: @2237888
     /* 2237888 */   GIM_Try, /*On fail goto*//*Label 29850*/ GIMT_Encode4(2237933), // Rule ID 59301 //
     /* 2237893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237896 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2237899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237932 */     // GIR_Coverage, 59301,
     /* 2237932 */     GIR_EraseRootFromParent_Done,
     /* 2237933 */   // Label 29850: @2237933
     /* 2237933 */   GIM_Reject,
     /* 2237934 */ // Label 29848: @2237934
     /* 2237934 */ GIM_Reject,
     /* 2237935 */ // Label 29808: @2237935
     /* 2237935 */ GIM_Try, /*On fail goto*//*Label 29851*/ GIMT_Encode4(2238049),
     /* 2237940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2237943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2237946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237958 */   GIM_Try, /*On fail goto*//*Label 29852*/ GIMT_Encode4(2238003), // Rule ID 59316 //
     /* 2237963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237966 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2237969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238002 */     // GIR_Coverage, 59316,
     /* 2238002 */     GIR_EraseRootFromParent_Done,
     /* 2238003 */   // Label 29852: @2238003
     /* 2238003 */   GIM_Try, /*On fail goto*//*Label 29853*/ GIMT_Encode4(2238048), // Rule ID 59317 //
     /* 2238008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238011 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2238014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238047 */     // GIR_Coverage, 59317,
     /* 2238047 */     GIR_EraseRootFromParent_Done,
     /* 2238048 */   // Label 29853: @2238048
     /* 2238048 */   GIM_Reject,
     /* 2238049 */ // Label 29851: @2238049
     /* 2238049 */ GIM_Reject,
     /* 2238050 */ // Label 29809: @2238050
     /* 2238050 */ GIM_Try, /*On fail goto*//*Label 29854*/ GIMT_Encode4(2238164),
     /* 2238055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2238058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2238061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238073 */   GIM_Try, /*On fail goto*//*Label 29855*/ GIMT_Encode4(2238118), // Rule ID 59360 //
     /* 2238078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238081 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2238084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238117 */     // GIR_Coverage, 59360,
     /* 2238117 */     GIR_EraseRootFromParent_Done,
     /* 2238118 */   // Label 29855: @2238118
     /* 2238118 */   GIM_Try, /*On fail goto*//*Label 29856*/ GIMT_Encode4(2238163), // Rule ID 59361 //
     /* 2238123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238126 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2238129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238162 */     // GIR_Coverage, 59361,
     /* 2238162 */     GIR_EraseRootFromParent_Done,
     /* 2238163 */   // Label 29856: @2238163
     /* 2238163 */   GIM_Reject,
     /* 2238164 */ // Label 29854: @2238164
     /* 2238164 */ GIM_Reject,
     /* 2238165 */ // Label 29810: @2238165
     /* 2238165 */ GIM_Try, /*On fail goto*//*Label 29857*/ GIMT_Encode4(2238279),
     /* 2238170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2238173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2238176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238188 */   GIM_Try, /*On fail goto*//*Label 29858*/ GIMT_Encode4(2238233), // Rule ID 59292 //
     /* 2238193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238196 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2238199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2238213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238232 */     // GIR_Coverage, 59292,
     /* 2238232 */     GIR_EraseRootFromParent_Done,
     /* 2238233 */   // Label 29858: @2238233
     /* 2238233 */   GIM_Try, /*On fail goto*//*Label 29859*/ GIMT_Encode4(2238278), // Rule ID 59293 //
     /* 2238238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238241 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2238244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2238258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238277 */     // GIR_Coverage, 59293,
     /* 2238277 */     GIR_EraseRootFromParent_Done,
     /* 2238278 */   // Label 29859: @2238278
     /* 2238278 */   GIM_Reject,
     /* 2238279 */ // Label 29857: @2238279
     /* 2238279 */ GIM_Reject,
     /* 2238280 */ // Label 29811: @2238280
     /* 2238280 */ GIM_Try, /*On fail goto*//*Label 29860*/ GIMT_Encode4(2238394),
     /* 2238285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2238288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2238291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238303 */   GIM_Try, /*On fail goto*//*Label 29861*/ GIMT_Encode4(2238348), // Rule ID 59312 //
     /* 2238308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238311 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2238314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238347 */     // GIR_Coverage, 59312,
     /* 2238347 */     GIR_EraseRootFromParent_Done,
     /* 2238348 */   // Label 29861: @2238348
     /* 2238348 */   GIM_Try, /*On fail goto*//*Label 29862*/ GIMT_Encode4(2238393), // Rule ID 59313 //
     /* 2238353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238356 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2238359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238392 */     // GIR_Coverage, 59313,
     /* 2238392 */     GIR_EraseRootFromParent_Done,
     /* 2238393 */   // Label 29862: @2238393
     /* 2238393 */   GIM_Reject,
     /* 2238394 */ // Label 29860: @2238394
     /* 2238394 */ GIM_Reject,
     /* 2238395 */ // Label 29812: @2238395
     /* 2238395 */ GIM_Try, /*On fail goto*//*Label 29863*/ GIMT_Encode4(2238509),
     /* 2238400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2238403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2238406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238418 */   GIM_Try, /*On fail goto*//*Label 29864*/ GIMT_Encode4(2238463), // Rule ID 59348 //
     /* 2238423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238426 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2238429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238462 */     // GIR_Coverage, 59348,
     /* 2238462 */     GIR_EraseRootFromParent_Done,
     /* 2238463 */   // Label 29864: @2238463
     /* 2238463 */   GIM_Try, /*On fail goto*//*Label 29865*/ GIMT_Encode4(2238508), // Rule ID 59349 //
     /* 2238468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238471 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2238474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238507 */     // GIR_Coverage, 59349,
     /* 2238507 */     GIR_EraseRootFromParent_Done,
     /* 2238508 */   // Label 29865: @2238508
     /* 2238508 */   GIM_Reject,
     /* 2238509 */ // Label 29863: @2238509
     /* 2238509 */ GIM_Reject,
     /* 2238510 */ // Label 29813: @2238510
     /* 2238510 */ GIM_Try, /*On fail goto*//*Label 29866*/ GIMT_Encode4(2238624),
     /* 2238515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2238518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2238521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238533 */   GIM_Try, /*On fail goto*//*Label 29867*/ GIMT_Encode4(2238578), // Rule ID 59364 //
     /* 2238538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238541 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2238544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238577 */     // GIR_Coverage, 59364,
     /* 2238577 */     GIR_EraseRootFromParent_Done,
     /* 2238578 */   // Label 29867: @2238578
     /* 2238578 */   GIM_Try, /*On fail goto*//*Label 29868*/ GIMT_Encode4(2238623), // Rule ID 59365 //
     /* 2238583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238586 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2238589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238622 */     // GIR_Coverage, 59365,
     /* 2238622 */     GIR_EraseRootFromParent_Done,
     /* 2238623 */   // Label 29868: @2238623
     /* 2238623 */   GIM_Reject,
     /* 2238624 */ // Label 29866: @2238624
     /* 2238624 */ GIM_Reject,
     /* 2238625 */ // Label 29814: @2238625
     /* 2238625 */ GIM_Try, /*On fail goto*//*Label 29869*/ GIMT_Encode4(2238739),
     /* 2238630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2238633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2238636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238648 */   GIM_Try, /*On fail goto*//*Label 29870*/ GIMT_Encode4(2238693), // Rule ID 59308 //
     /* 2238653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238656 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2238659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238692 */     // GIR_Coverage, 59308,
     /* 2238692 */     GIR_EraseRootFromParent_Done,
     /* 2238693 */   // Label 29870: @2238693
     /* 2238693 */   GIM_Try, /*On fail goto*//*Label 29871*/ GIMT_Encode4(2238738), // Rule ID 59309 //
     /* 2238698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238701 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2238704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238737 */     // GIR_Coverage, 59309,
     /* 2238737 */     GIR_EraseRootFromParent_Done,
     /* 2238738 */   // Label 29871: @2238738
     /* 2238738 */   GIM_Reject,
     /* 2238739 */ // Label 29869: @2238739
     /* 2238739 */ GIM_Reject,
     /* 2238740 */ // Label 29815: @2238740
     /* 2238740 */ GIM_Try, /*On fail goto*//*Label 29872*/ GIMT_Encode4(2238854),
     /* 2238745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2238748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2238751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238763 */   GIM_Try, /*On fail goto*//*Label 29873*/ GIMT_Encode4(2238808), // Rule ID 59336 //
     /* 2238768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238771 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2238774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238807 */     // GIR_Coverage, 59336,
     /* 2238807 */     GIR_EraseRootFromParent_Done,
     /* 2238808 */   // Label 29873: @2238808
     /* 2238808 */   GIM_Try, /*On fail goto*//*Label 29874*/ GIMT_Encode4(2238853), // Rule ID 59337 //
     /* 2238813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238816 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2238819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238852 */     // GIR_Coverage, 59337,
     /* 2238852 */     GIR_EraseRootFromParent_Done,
     /* 2238853 */   // Label 29874: @2238853
     /* 2238853 */   GIM_Reject,
     /* 2238854 */ // Label 29872: @2238854
     /* 2238854 */ GIM_Reject,
     /* 2238855 */ // Label 29816: @2238855
     /* 2238855 */ GIM_Try, /*On fail goto*//*Label 29875*/ GIMT_Encode4(2238969),
     /* 2238860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2238863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2238866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238878 */   GIM_Try, /*On fail goto*//*Label 29876*/ GIMT_Encode4(2238923), // Rule ID 59352 //
     /* 2238883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238886 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2238889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238922 */     // GIR_Coverage, 59352,
     /* 2238922 */     GIR_EraseRootFromParent_Done,
     /* 2238923 */   // Label 29876: @2238923
     /* 2238923 */   GIM_Try, /*On fail goto*//*Label 29877*/ GIMT_Encode4(2238968), // Rule ID 59353 //
     /* 2238928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238931 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2238934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238967 */     // GIR_Coverage, 59353,
     /* 2238967 */     GIR_EraseRootFromParent_Done,
     /* 2238968 */   // Label 29877: @2238968
     /* 2238968 */   GIM_Reject,
     /* 2238969 */ // Label 29875: @2238969
     /* 2238969 */ GIM_Reject,
     /* 2238970 */ // Label 29817: @2238970
     /* 2238970 */ GIM_Try, /*On fail goto*//*Label 29878*/ GIMT_Encode4(2239084),
     /* 2238975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2238978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2238981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238993 */   GIM_Try, /*On fail goto*//*Label 29879*/ GIMT_Encode4(2239038), // Rule ID 59368 //
     /* 2238998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2239001 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2239004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239037 */     // GIR_Coverage, 59368,
     /* 2239037 */     GIR_EraseRootFromParent_Done,
     /* 2239038 */   // Label 29879: @2239038
     /* 2239038 */   GIM_Try, /*On fail goto*//*Label 29880*/ GIMT_Encode4(2239083), // Rule ID 59369 //
     /* 2239043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2239046 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2239049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239082 */     // GIR_Coverage, 59369,
     /* 2239082 */     GIR_EraseRootFromParent_Done,
     /* 2239083 */   // Label 29880: @2239083
     /* 2239083 */   GIM_Reject,
     /* 2239084 */ // Label 29878: @2239084
     /* 2239084 */ GIM_Reject,
     /* 2239085 */ // Label 29818: @2239085
     /* 2239085 */ GIM_Try, /*On fail goto*//*Label 29881*/ GIMT_Encode4(2239199),
     /* 2239090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2239093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2239096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239108 */   GIM_Try, /*On fail goto*//*Label 29882*/ GIMT_Encode4(2239153), // Rule ID 59324 //
     /* 2239113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239116 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2239119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2239133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239152 */     // GIR_Coverage, 59324,
     /* 2239152 */     GIR_EraseRootFromParent_Done,
     /* 2239153 */   // Label 29882: @2239153
     /* 2239153 */   GIM_Try, /*On fail goto*//*Label 29883*/ GIMT_Encode4(2239198), // Rule ID 59325 //
     /* 2239158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239161 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2239164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2239178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239197 */     // GIR_Coverage, 59325,
     /* 2239197 */     GIR_EraseRootFromParent_Done,
     /* 2239198 */   // Label 29883: @2239198
     /* 2239198 */   GIM_Reject,
     /* 2239199 */ // Label 29881: @2239199
     /* 2239199 */ GIM_Reject,
     /* 2239200 */ // Label 29819: @2239200
     /* 2239200 */ GIM_Try, /*On fail goto*//*Label 29884*/ GIMT_Encode4(2239314),
     /* 2239205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2239208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2239211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239223 */   GIM_Try, /*On fail goto*//*Label 29885*/ GIMT_Encode4(2239268), // Rule ID 59340 //
     /* 2239228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239231 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2239234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2239248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239267 */     // GIR_Coverage, 59340,
     /* 2239267 */     GIR_EraseRootFromParent_Done,
     /* 2239268 */   // Label 29885: @2239268
     /* 2239268 */   GIM_Try, /*On fail goto*//*Label 29886*/ GIMT_Encode4(2239313), // Rule ID 59341 //
     /* 2239273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239276 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2239279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2239293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239312 */     // GIR_Coverage, 59341,
     /* 2239312 */     GIR_EraseRootFromParent_Done,
     /* 2239313 */   // Label 29886: @2239313
     /* 2239313 */   GIM_Reject,
     /* 2239314 */ // Label 29884: @2239314
     /* 2239314 */ GIM_Reject,
     /* 2239315 */ // Label 29820: @2239315
     /* 2239315 */ GIM_Try, /*On fail goto*//*Label 29887*/ GIMT_Encode4(2239429),
     /* 2239320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2239323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2239326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239338 */   GIM_Try, /*On fail goto*//*Label 29888*/ GIMT_Encode4(2239383), // Rule ID 59356 //
     /* 2239343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239346 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2239349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239382 */     // GIR_Coverage, 59356,
     /* 2239382 */     GIR_EraseRootFromParent_Done,
     /* 2239383 */   // Label 29888: @2239383
     /* 2239383 */   GIM_Try, /*On fail goto*//*Label 29889*/ GIMT_Encode4(2239428), // Rule ID 59357 //
     /* 2239388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239391 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2239394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239427 */     // GIR_Coverage, 59357,
     /* 2239427 */     GIR_EraseRootFromParent_Done,
     /* 2239428 */   // Label 29889: @2239428
     /* 2239428 */   GIM_Reject,
     /* 2239429 */ // Label 29887: @2239429
     /* 2239429 */ GIM_Reject,
     /* 2239430 */ // Label 29821: @2239430
     /* 2239430 */ GIM_Try, /*On fail goto*//*Label 29890*/ GIMT_Encode4(2239544),
     /* 2239435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2239438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2239441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239453 */   GIM_Try, /*On fail goto*//*Label 29891*/ GIMT_Encode4(2239498), // Rule ID 59328 //
     /* 2239458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239461 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2239464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2239478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239497 */     // GIR_Coverage, 59328,
     /* 2239497 */     GIR_EraseRootFromParent_Done,
     /* 2239498 */   // Label 29891: @2239498
     /* 2239498 */   GIM_Try, /*On fail goto*//*Label 29892*/ GIMT_Encode4(2239543), // Rule ID 59329 //
     /* 2239503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239506 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2239509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2239523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239542 */     // GIR_Coverage, 59329,
     /* 2239542 */     GIR_EraseRootFromParent_Done,
     /* 2239543 */   // Label 29892: @2239543
     /* 2239543 */   GIM_Reject,
     /* 2239544 */ // Label 29890: @2239544
     /* 2239544 */ GIM_Reject,
     /* 2239545 */ // Label 29822: @2239545
     /* 2239545 */ GIM_Try, /*On fail goto*//*Label 29893*/ GIMT_Encode4(2239659),
     /* 2239550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2239553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2239556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239568 */   GIM_Try, /*On fail goto*//*Label 29894*/ GIMT_Encode4(2239613), // Rule ID 59344 //
     /* 2239573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239576 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2239579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239612 */     // GIR_Coverage, 59344,
     /* 2239612 */     GIR_EraseRootFromParent_Done,
     /* 2239613 */   // Label 29894: @2239613
     /* 2239613 */   GIM_Try, /*On fail goto*//*Label 29895*/ GIMT_Encode4(2239658), // Rule ID 59345 //
     /* 2239618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239621 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2239624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239657 */     // GIR_Coverage, 59345,
     /* 2239657 */     GIR_EraseRootFromParent_Done,
     /* 2239658 */   // Label 29895: @2239658
     /* 2239658 */   GIM_Reject,
     /* 2239659 */ // Label 29893: @2239659
     /* 2239659 */ GIM_Reject,
     /* 2239660 */ // Label 29823: @2239660
     /* 2239660 */ GIM_Try, /*On fail goto*//*Label 29896*/ GIMT_Encode4(2239774),
     /* 2239665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2239668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2239671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239683 */   GIM_Try, /*On fail goto*//*Label 29897*/ GIMT_Encode4(2239728), // Rule ID 59332 //
     /* 2239688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239691 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2239694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239727 */     // GIR_Coverage, 59332,
     /* 2239727 */     GIR_EraseRootFromParent_Done,
     /* 2239728 */   // Label 29897: @2239728
     /* 2239728 */   GIM_Try, /*On fail goto*//*Label 29898*/ GIMT_Encode4(2239773), // Rule ID 59333 //
     /* 2239733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239736 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2239739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239772 */     // GIR_Coverage, 59333,
     /* 2239772 */     GIR_EraseRootFromParent_Done,
     /* 2239773 */   // Label 29898: @2239773
     /* 2239773 */   GIM_Reject,
     /* 2239774 */ // Label 29896: @2239774
     /* 2239774 */ GIM_Reject,
     /* 2239775 */ // Label 29824: @2239775
     /* 2239775 */ GIM_Reject,
     /* 2239776 */ // Label 48: @2239776
     /* 2239776 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(33), /*)*//*default:*//*Label 29908*/ GIMT_Encode4(2266852),
     /* 2239787 */ /*GILLT_s32*//*Label 29899*/ GIMT_Encode4(2239907),
     /* 2239791 */ /*GILLT_s64*//*Label 29900*/ GIMT_Encode4(2242908),
     /* 2239795 */ /*GILLT_nxv1s1*//*Label 29901*/ GIMT_Encode4(2245909), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239815 */ /*GILLT_nxv2s1*//*Label 29902*/ GIMT_Encode4(2249750), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239835 */ /*GILLT_nxv4s1*//*Label 29903*/ GIMT_Encode4(2253591), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239855 */ /*GILLT_nxv8s1*//*Label 29904*/ GIMT_Encode4(2257432), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239875 */ /*GILLT_nxv16s1*//*Label 29905*/ GIMT_Encode4(2261273), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239891 */ /*GILLT_nxv32s1*//*Label 29906*/ GIMT_Encode4(2264154), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239903 */ /*GILLT_nxv64s1*//*Label 29907*/ GIMT_Encode4(2266075),
     /* 2239907 */ // Label 29899: @2239907
     /* 2239907 */ GIM_Try, /*On fail goto*//*Label 29909*/ GIMT_Encode4(2240009), // Rule ID 175 //
     /* 2239912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239918 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239925 */   // MIs[0] Operand 1
     /* 2239925 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239930 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2239934 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2239938 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2239942 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239946 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239951 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2239955 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2239959 */   GIM_CheckAPIntImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /* 2239963 */   // MIs[2] Operand 1
     /* 2239963 */   // No operand predicates
     /* 2239963 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9978),
     /* 2239967 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2239971 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2239973 */   // (setcc:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9978>><<X:XLenSubTrailingOnes>>:$mask), 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)), 1:{ *:[i32] })
     /* 2239973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2239976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2239980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239985 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 2239989 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /* 2239994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240001 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240008 */   // GIR_Coverage, 175,
     /* 2240008 */   GIR_EraseRootFromParent_Done,
     /* 2240009 */ // Label 29909: @2240009
     /* 2240009 */ GIM_Try, /*On fail goto*//*Label 29910*/ GIMT_Encode4(2240114), // Rule ID 177 //
     /* 2240014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240027 */   // MIs[0] Operand 1
     /* 2240027 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2240036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2240040 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2240044 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240048 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240053 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2240057 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240061 */   GIM_CheckAPIntImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /* 2240065 */   // MIs[2] Operand 1
     /* 2240065 */   // No operand predicates
     /* 2240065 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9978),
     /* 2240069 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2240073 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2240075 */   // (setcc:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9978>><<X:XLenSubTrailingOnes>>:$mask), 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)))
     /* 2240075 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2240078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2240082 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240087 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 2240091 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /* 2240096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2240101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240103 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2240109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240112 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240113 */   // GIR_Coverage, 177,
     /* 2240113 */   GIR_EraseRootFromParent_Done,
     /* 2240114 */ // Label 29910: @2240114
     /* 2240114 */ GIM_Try, /*On fail goto*//*Label 29911*/ GIMT_Encode4(2240157), // Rule ID 173 //
     /* 2240119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240125 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240132 */   // MIs[0] Operand 1
     /* 2240132 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240141 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2240145 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] })
     /* 2240145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240150 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240156 */   // GIR_Coverage, 173,
     /* 2240156 */   GIR_EraseRootFromParent_Done,
     /* 2240157 */ // Label 29911: @2240157
     /* 2240157 */ GIM_Try, /*On fail goto*//*Label 29912*/ GIMT_Encode4(2240200), // Rule ID 65357 //
     /* 2240162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240168 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2240171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240175 */   // MIs[0] Operand 1
     /* 2240175 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2240180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240184 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2240188 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2240188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240193 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240199 */   // GIR_Coverage, 65357,
     /* 2240199 */   GIR_EraseRootFromParent_Done,
     /* 2240200 */ // Label 29912: @2240200
     /* 2240200 */ GIM_Try, /*On fail goto*//*Label 29913*/ GIMT_Encode4(2240246), // Rule ID 65363 //
     /* 2240205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240211 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2240214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240218 */   // MIs[0] Operand 1
     /* 2240218 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240227 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2240231 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2240231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2240234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240236 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2240242 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240245 */   // GIR_Coverage, 65363,
     /* 2240245 */   GIR_EraseRootFromParent_Done,
     /* 2240246 */ // Label 29913: @2240246
     /* 2240246 */ GIM_Try, /*On fail goto*//*Label 29914*/ GIMT_Encode4(2240289), // Rule ID 65393 //
     /* 2240251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240257 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240264 */   // MIs[0] Operand 1
     /* 2240264 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2240269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240273 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2240277 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2240277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240282 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240287 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240288 */   // GIR_Coverage, 65393,
     /* 2240288 */   GIR_EraseRootFromParent_Done,
     /* 2240289 */ // Label 29914: @2240289
     /* 2240289 */ GIM_Try, /*On fail goto*//*Label 29915*/ GIMT_Encode4(2240335), // Rule ID 65399 //
     /* 2240294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240300 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240307 */   // MIs[0] Operand 1
     /* 2240307 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240316 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2240320 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2240320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2240323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240325 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2240331 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240333 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240334 */   // GIR_Coverage, 65399,
     /* 2240334 */   GIR_EraseRootFromParent_Done,
     /* 2240335 */ // Label 29915: @2240335
     /* 2240335 */ GIM_Try, /*On fail goto*//*Label 29916*/ GIMT_Encode4(2240388), // Rule ID 163 //
     /* 2240340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240346 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240353 */   // MIs[0] Operand 1
     /* 2240353 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240362 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240370 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240374 */   // MIs[1] Operand 1
     /* 2240374 */   // No operand predicates
     /* 2240374 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240376 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2240376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240381 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240383 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2240386 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240387 */   // GIR_Coverage, 163,
     /* 2240387 */   GIR_EraseRootFromParent_Done,
     /* 2240388 */ // Label 29916: @2240388
     /* 2240388 */ GIM_Try, /*On fail goto*//*Label 29917*/ GIMT_Encode4(2240441), // Rule ID 167 //
     /* 2240393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240399 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240406 */   // MIs[0] Operand 1
     /* 2240406 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240415 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240419 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240423 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240427 */   // MIs[1] Operand 1
     /* 2240427 */   // No operand predicates
     /* 2240427 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240429 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2240429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240434 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240436 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2240439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240440 */   // GIR_Coverage, 167,
     /* 2240440 */   GIR_EraseRootFromParent_Done,
     /* 2240441 */ // Label 29917: @2240441
     /* 2240441 */ GIM_Try, /*On fail goto*//*Label 29918*/ GIMT_Encode4(2240494), // Rule ID 65349 //
     /* 2240446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240452 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240459 */   // MIs[0] Operand 1
     /* 2240459 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240468 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240472 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240476 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240480 */   // MIs[1] Operand 1
     /* 2240480 */   // No operand predicates
     /* 2240480 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240482 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2240482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240487 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240489 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2240492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240493 */   // GIR_Coverage, 65349,
     /* 2240493 */   GIR_EraseRootFromParent_Done,
     /* 2240494 */ // Label 29918: @2240494
     /* 2240494 */ GIM_Try, /*On fail goto*//*Label 29919*/ GIMT_Encode4(2240547), // Rule ID 65353 //
     /* 2240499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240505 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240512 */   // MIs[0] Operand 1
     /* 2240512 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240521 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240525 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240529 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240533 */   // MIs[1] Operand 1
     /* 2240533 */   // No operand predicates
     /* 2240533 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240535 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2240535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240540 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240542 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2240545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240546 */   // GIR_Coverage, 65353,
     /* 2240546 */   GIR_EraseRootFromParent_Done,
     /* 2240547 */ // Label 29919: @2240547
     /* 2240547 */ GIM_Try, /*On fail goto*//*Label 29920*/ GIMT_Encode4(2240624), // Rule ID 65359 //
     /* 2240552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240565 */   // MIs[0] Operand 1
     /* 2240565 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2240570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240582 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2240586 */   // MIs[1] Operand 1
     /* 2240586 */   // No operand predicates
     /* 2240586 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240588 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2240588 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240591 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2240595 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240600 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240604 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2240609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240623 */   // GIR_Coverage, 65359,
     /* 2240623 */   GIR_EraseRootFromParent_Done,
     /* 2240624 */ // Label 29920: @2240624
     /* 2240624 */ GIM_Try, /*On fail goto*//*Label 29921*/ GIMT_Encode4(2240704), // Rule ID 65365 //
     /* 2240629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240642 */   // MIs[0] Operand 1
     /* 2240642 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240651 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240655 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240659 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2240663 */   // MIs[1] Operand 1
     /* 2240663 */   // No operand predicates
     /* 2240663 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240665 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2240665 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240668 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2240672 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240677 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240681 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2240686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2240691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240693 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2240699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240703 */   // GIR_Coverage, 65365,
     /* 2240703 */   GIR_EraseRootFromParent_Done,
     /* 2240704 */ // Label 29921: @2240704
     /* 2240704 */ GIM_Try, /*On fail goto*//*Label 29922*/ GIMT_Encode4(2240781), // Rule ID 65369 //
     /* 2240709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240715 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240722 */   // MIs[0] Operand 1
     /* 2240722 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240739 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2240743 */   // MIs[1] Operand 1
     /* 2240743 */   // No operand predicates
     /* 2240743 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240745 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2240745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240757 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240761 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240780 */   // GIR_Coverage, 65369,
     /* 2240780 */   GIR_EraseRootFromParent_Done,
     /* 2240781 */ // Label 29922: @2240781
     /* 2240781 */ GIM_Try, /*On fail goto*//*Label 29923*/ GIMT_Encode4(2240858), // Rule ID 65373 //
     /* 2240786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240792 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240799 */   // MIs[0] Operand 1
     /* 2240799 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240808 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240812 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240816 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2240820 */   // MIs[1] Operand 1
     /* 2240820 */   // No operand predicates
     /* 2240820 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240822 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2240822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240834 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240838 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240856 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240857 */   // GIR_Coverage, 65373,
     /* 2240857 */   GIR_EraseRootFromParent_Done,
     /* 2240858 */ // Label 29923: @2240858
     /* 2240858 */ GIM_Try, /*On fail goto*//*Label 29924*/ GIMT_Encode4(2240933), // Rule ID 65377 //
     /* 2240863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240869 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240876 */   // MIs[0] Operand 1
     /* 2240876 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2240881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240885 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240889 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240893 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240897 */   // MIs[1] Operand 1
     /* 2240897 */   // No operand predicates
     /* 2240897 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240899 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2240899 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240906 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240911 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240915 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2240918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240925 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240932 */   // GIR_Coverage, 65377,
     /* 2240932 */   GIR_EraseRootFromParent_Done,
     /* 2240933 */ // Label 29924: @2240933
     /* 2240933 */ GIM_Try, /*On fail goto*//*Label 29925*/ GIMT_Encode4(2241008), // Rule ID 65381 //
     /* 2240938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240951 */   // MIs[0] Operand 1
     /* 2240951 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2240956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240960 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240964 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240968 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240972 */   // MIs[1] Operand 1
     /* 2240972 */   // No operand predicates
     /* 2240972 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240974 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2240974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240986 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240990 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2240993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241000 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241006 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241007 */   // GIR_Coverage, 65381,
     /* 2241007 */   GIR_EraseRootFromParent_Done,
     /* 2241008 */ // Label 29925: @2241008
     /* 2241008 */ GIM_Try, /*On fail goto*//*Label 29926*/ GIMT_Encode4(2241063), // Rule ID 65385 //
     /* 2241013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241026 */   // MIs[0] Operand 1
     /* 2241026 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241035 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241039 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241043 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2241047 */   // MIs[1] Operand 1
     /* 2241047 */   // No operand predicates
     /* 2241047 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241049 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2241049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241054 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241056 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241062 */   // GIR_Coverage, 65385,
     /* 2241062 */   GIR_EraseRootFromParent_Done,
     /* 2241063 */ // Label 29926: @2241063
     /* 2241063 */ GIM_Try, /*On fail goto*//*Label 29927*/ GIMT_Encode4(2241118), // Rule ID 65389 //
     /* 2241068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241074 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241081 */   // MIs[0] Operand 1
     /* 2241081 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241098 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2241102 */   // MIs[1] Operand 1
     /* 2241102 */   // No operand predicates
     /* 2241102 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241104 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2241104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2241107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241109 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241111 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241117 */   // GIR_Coverage, 65389,
     /* 2241117 */   GIR_EraseRootFromParent_Done,
     /* 2241118 */ // Label 29927: @2241118
     /* 2241118 */ GIM_Try, /*On fail goto*//*Label 29928*/ GIMT_Encode4(2241195), // Rule ID 65395 //
     /* 2241123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241136 */   // MIs[0] Operand 1
     /* 2241136 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2241141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241145 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241153 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2241157 */   // MIs[1] Operand 1
     /* 2241157 */   // No operand predicates
     /* 2241157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241159 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2241159 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241162 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2241166 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241171 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241175 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2241180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241187 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241193 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241194 */   // GIR_Coverage, 65395,
     /* 2241194 */   GIR_EraseRootFromParent_Done,
     /* 2241195 */ // Label 29928: @2241195
     /* 2241195 */ GIM_Try, /*On fail goto*//*Label 29929*/ GIMT_Encode4(2241275), // Rule ID 65401 //
     /* 2241200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241206 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241213 */   // MIs[0] Operand 1
     /* 2241213 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2241218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241222 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241226 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241230 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2241234 */   // MIs[1] Operand 1
     /* 2241234 */   // No operand predicates
     /* 2241234 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241236 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2241236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2241243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241248 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241252 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2241257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241264 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2241270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241273 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241274 */   // GIR_Coverage, 65401,
     /* 2241274 */   GIR_EraseRootFromParent_Done,
     /* 2241275 */ // Label 29929: @2241275
     /* 2241275 */ GIM_Try, /*On fail goto*//*Label 29930*/ GIMT_Encode4(2241352), // Rule ID 65405 //
     /* 2241280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241286 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241293 */   // MIs[0] Operand 1
     /* 2241293 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241302 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241306 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241310 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2241314 */   // MIs[1] Operand 1
     /* 2241314 */   // No operand predicates
     /* 2241314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241316 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2241316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241328 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241332 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241337 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241344 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241350 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241351 */   // GIR_Coverage, 65405,
     /* 2241351 */   GIR_EraseRootFromParent_Done,
     /* 2241352 */ // Label 29930: @2241352
     /* 2241352 */ GIM_Try, /*On fail goto*//*Label 29931*/ GIMT_Encode4(2241429), // Rule ID 65409 //
     /* 2241357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241363 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241370 */   // MIs[0] Operand 1
     /* 2241370 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2241375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241379 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241383 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241387 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2241391 */   // MIs[1] Operand 1
     /* 2241391 */   // No operand predicates
     /* 2241391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241393 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2241393 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241396 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2241400 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241405 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241409 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241427 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241428 */   // GIR_Coverage, 65409,
     /* 2241428 */   GIR_EraseRootFromParent_Done,
     /* 2241429 */ // Label 29931: @2241429
     /* 2241429 */ GIM_Try, /*On fail goto*//*Label 29932*/ GIMT_Encode4(2241504), // Rule ID 65413 //
     /* 2241434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241440 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241447 */   // MIs[0] Operand 1
     /* 2241447 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2241452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241456 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241460 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241464 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2241468 */   // MIs[1] Operand 1
     /* 2241468 */   // No operand predicates
     /* 2241468 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241470 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2241470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241482 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241486 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2241489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241503 */   // GIR_Coverage, 65413,
     /* 2241503 */   GIR_EraseRootFromParent_Done,
     /* 2241504 */ // Label 29932: @2241504
     /* 2241504 */ GIM_Try, /*On fail goto*//*Label 29933*/ GIMT_Encode4(2241579), // Rule ID 65417 //
     /* 2241509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241522 */   // MIs[0] Operand 1
     /* 2241522 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241531 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241535 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241539 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2241543 */   // MIs[1] Operand 1
     /* 2241543 */   // No operand predicates
     /* 2241543 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241545 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2241545 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2241552 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241557 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241561 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2241564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241571 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241577 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241578 */   // GIR_Coverage, 65417,
     /* 2241578 */   GIR_EraseRootFromParent_Done,
     /* 2241579 */ // Label 29933: @2241579
     /* 2241579 */ GIM_Try, /*On fail goto*//*Label 29934*/ GIMT_Encode4(2241634), // Rule ID 65421 //
     /* 2241584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241590 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241597 */   // MIs[0] Operand 1
     /* 2241597 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241602 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241606 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241610 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241614 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2241618 */   // MIs[1] Operand 1
     /* 2241618 */   // No operand predicates
     /* 2241618 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241620 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2241620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241625 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241627 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241632 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241633 */   // GIR_Coverage, 65421,
     /* 2241633 */   GIR_EraseRootFromParent_Done,
     /* 2241634 */ // Label 29934: @2241634
     /* 2241634 */ GIM_Try, /*On fail goto*//*Label 29935*/ GIMT_Encode4(2241689), // Rule ID 65425 //
     /* 2241639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241652 */   // MIs[0] Operand 1
     /* 2241652 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241661 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241665 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241669 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2241673 */   // MIs[1] Operand 1
     /* 2241673 */   // No operand predicates
     /* 2241673 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241675 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2241675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2241678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241680 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241682 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241687 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241688 */   // GIR_Coverage, 65425,
     /* 2241688 */   GIR_EraseRootFromParent_Done,
     /* 2241689 */ // Label 29935: @2241689
     /* 2241689 */ GIM_Try, /*On fail goto*//*Label 29936*/ GIMT_Encode4(2241731), // Rule ID 64470 //
     /* 2241694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2241697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241700 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241707 */   // MIs[0] Operand 1
     /* 2241707 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241716 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241720 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2241723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241725 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241727 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241729 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241730 */   // GIR_Coverage, 64470,
     /* 2241730 */   GIR_EraseRootFromParent_Done,
     /* 2241731 */ // Label 29936: @2241731
     /* 2241731 */ GIM_Try, /*On fail goto*//*Label 29937*/ GIMT_Encode4(2241773), // Rule ID 64472 //
     /* 2241736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2241739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241742 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241749 */   // MIs[0] Operand 1
     /* 2241749 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241758 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241762 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2241765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241767 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241769 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241772 */   // GIR_Coverage, 64472,
     /* 2241772 */   GIR_EraseRootFromParent_Done,
     /* 2241773 */ // Label 29937: @2241773
     /* 2241773 */ GIM_Try, /*On fail goto*//*Label 29938*/ GIMT_Encode4(2241815), // Rule ID 161 //
     /* 2241778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241784 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241791 */   // MIs[0] Operand 1
     /* 2241791 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2241796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241800 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241804 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241809 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241811 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241813 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241814 */   // GIR_Coverage, 161,
     /* 2241814 */   GIR_EraseRootFromParent_Done,
     /* 2241815 */ // Label 29938: @2241815
     /* 2241815 */ GIM_Try, /*On fail goto*//*Label 29939*/ GIMT_Encode4(2241857), // Rule ID 165 //
     /* 2241820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241826 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241833 */   // MIs[0] Operand 1
     /* 2241833 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2241838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241842 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241846 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241851 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241853 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241855 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241856 */   // GIR_Coverage, 165,
     /* 2241856 */   GIR_EraseRootFromParent_Done,
     /* 2241857 */ // Label 29939: @2241857
     /* 2241857 */ GIM_Try, /*On fail goto*//*Label 29940*/ GIMT_Encode4(2241899), // Rule ID 65351 //
     /* 2241862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241868 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241875 */   // MIs[0] Operand 1
     /* 2241875 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2241880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241884 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241888 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241893 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241895 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241897 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241898 */   // GIR_Coverage, 65351,
     /* 2241898 */   GIR_EraseRootFromParent_Done,
     /* 2241899 */ // Label 29940: @2241899
     /* 2241899 */ GIM_Try, /*On fail goto*//*Label 29941*/ GIMT_Encode4(2241941), // Rule ID 65355 //
     /* 2241904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241910 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241917 */   // MIs[0] Operand 1
     /* 2241917 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2241922 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241926 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241930 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241935 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241937 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241940 */   // GIR_Coverage, 65355,
     /* 2241940 */   GIR_EraseRootFromParent_Done,
     /* 2241941 */ // Label 29941: @2241941
     /* 2241941 */ GIM_Try, /*On fail goto*//*Label 29942*/ GIMT_Encode4(2242007), // Rule ID 65361 //
     /* 2241946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241952 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241959 */   // MIs[0] Operand 1
     /* 2241959 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2241964 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241968 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241972 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2241972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2241979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241984 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241988 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241999 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242005 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242006 */   // GIR_Coverage, 65361,
     /* 2242006 */   GIR_EraseRootFromParent_Done,
     /* 2242007 */ // Label 29942: @2242007
     /* 2242007 */ GIM_Try, /*On fail goto*//*Label 29943*/ GIMT_Encode4(2242076), // Rule ID 65367 //
     /* 2242012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242018 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242025 */   // MIs[0] Operand 1
     /* 2242025 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242034 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242038 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2242038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2242045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242050 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242054 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242065 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2242071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242074 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242075 */   // GIR_Coverage, 65367,
     /* 2242075 */   GIR_EraseRootFromParent_Done,
     /* 2242076 */ // Label 29943: @2242076
     /* 2242076 */ GIM_Try, /*On fail goto*//*Label 29944*/ GIMT_Encode4(2242118), // Rule ID 65371 //
     /* 2242081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242087 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242094 */   // MIs[0] Operand 1
     /* 2242094 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2242099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242103 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242107 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2242107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242112 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242114 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242117 */   // GIR_Coverage, 65371,
     /* 2242117 */   GIR_EraseRootFromParent_Done,
     /* 2242118 */ // Label 29944: @2242118
     /* 2242118 */ GIM_Try, /*On fail goto*//*Label 29945*/ GIMT_Encode4(2242160), // Rule ID 65375 //
     /* 2242123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242136 */   // MIs[0] Operand 1
     /* 2242136 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2242141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242145 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242149 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2242149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242154 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242156 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242159 */   // GIR_Coverage, 65375,
     /* 2242159 */   GIR_EraseRootFromParent_Done,
     /* 2242160 */ // Label 29945: @2242160
     /* 2242160 */ GIM_Try, /*On fail goto*//*Label 29946*/ GIMT_Encode4(2242226), // Rule ID 65379 //
     /* 2242165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242178 */   // MIs[0] Operand 1
     /* 2242178 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242187 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242191 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242224 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242225 */   // GIR_Coverage, 65379,
     /* 2242225 */   GIR_EraseRootFromParent_Done,
     /* 2242226 */ // Label 29946: @2242226
     /* 2242226 */ GIM_Try, /*On fail goto*//*Label 29947*/ GIMT_Encode4(2242292), // Rule ID 65383 //
     /* 2242231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242237 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242244 */   // MIs[0] Operand 1
     /* 2242244 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2242249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242253 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242257 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242257 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242260 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242264 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242269 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242273 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242291 */   // GIR_Coverage, 65383,
     /* 2242291 */   GIR_EraseRootFromParent_Done,
     /* 2242292 */ // Label 29947: @2242292
     /* 2242292 */ GIM_Try, /*On fail goto*//*Label 29948*/ GIMT_Encode4(2242358), // Rule ID 65387 //
     /* 2242297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242303 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242310 */   // MIs[0] Operand 1
     /* 2242310 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242319 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242323 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2242323 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242326 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242330 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242335 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242339 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242357 */   // GIR_Coverage, 65387,
     /* 2242357 */   GIR_EraseRootFromParent_Done,
     /* 2242358 */ // Label 29948: @2242358
     /* 2242358 */ GIM_Try, /*On fail goto*//*Label 29949*/ GIMT_Encode4(2242424), // Rule ID 65391 //
     /* 2242363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242369 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242376 */   // MIs[0] Operand 1
     /* 2242376 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2242381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242385 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242389 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2242389 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242392 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242396 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242401 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242405 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242422 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242423 */   // GIR_Coverage, 65391,
     /* 2242423 */   GIR_EraseRootFromParent_Done,
     /* 2242424 */ // Label 29949: @2242424
     /* 2242424 */ GIM_Try, /*On fail goto*//*Label 29950*/ GIMT_Encode4(2242490), // Rule ID 65397 //
     /* 2242429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242435 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242442 */   // MIs[0] Operand 1
     /* 2242442 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242451 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242455 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2242462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242467 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242471 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242488 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242489 */   // GIR_Coverage, 65397,
     /* 2242489 */   GIR_EraseRootFromParent_Done,
     /* 2242490 */ // Label 29950: @2242490
     /* 2242490 */ GIM_Try, /*On fail goto*//*Label 29951*/ GIMT_Encode4(2242559), // Rule ID 65403 //
     /* 2242495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242501 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242508 */   // MIs[0] Operand 1
     /* 2242508 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242517 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242521 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2242521 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242524 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2242528 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242533 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242537 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242548 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2242554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242558 */   // GIR_Coverage, 65403,
     /* 2242558 */   GIR_EraseRootFromParent_Done,
     /* 2242559 */ // Label 29951: @2242559
     /* 2242559 */ GIM_Try, /*On fail goto*//*Label 29952*/ GIMT_Encode4(2242601), // Rule ID 65407 //
     /* 2242564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242577 */   // MIs[0] Operand 1
     /* 2242577 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2242582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242586 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242590 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2242590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242595 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242597 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242599 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242600 */   // GIR_Coverage, 65407,
     /* 2242600 */   GIR_EraseRootFromParent_Done,
     /* 2242601 */ // Label 29952: @2242601
     /* 2242601 */ GIM_Try, /*On fail goto*//*Label 29953*/ GIMT_Encode4(2242643), // Rule ID 65411 //
     /* 2242606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242612 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242619 */   // MIs[0] Operand 1
     /* 2242619 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2242624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242628 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242632 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2242632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242637 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242639 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242641 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242642 */   // GIR_Coverage, 65411,
     /* 2242642 */   GIR_EraseRootFromParent_Done,
     /* 2242643 */ // Label 29953: @2242643
     /* 2242643 */ GIM_Try, /*On fail goto*//*Label 29954*/ GIMT_Encode4(2242709), // Rule ID 65415 //
     /* 2242648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242654 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242661 */   // MIs[0] Operand 1
     /* 2242661 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242670 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242674 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242686 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242690 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242708 */   // GIR_Coverage, 65415,
     /* 2242708 */   GIR_EraseRootFromParent_Done,
     /* 2242709 */ // Label 29954: @2242709
     /* 2242709 */ GIM_Try, /*On fail goto*//*Label 29955*/ GIMT_Encode4(2242775), // Rule ID 65419 //
     /* 2242714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242720 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242727 */   // MIs[0] Operand 1
     /* 2242727 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2242732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242736 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242740 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242752 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242756 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242767 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242773 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242774 */   // GIR_Coverage, 65419,
     /* 2242774 */   GIR_EraseRootFromParent_Done,
     /* 2242775 */ // Label 29955: @2242775
     /* 2242775 */ GIM_Try, /*On fail goto*//*Label 29956*/ GIMT_Encode4(2242841), // Rule ID 65423 //
     /* 2242780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242786 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242793 */   // MIs[0] Operand 1
     /* 2242793 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242802 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242806 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2242806 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242813 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242818 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242822 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242839 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242840 */   // GIR_Coverage, 65423,
     /* 2242840 */   GIR_EraseRootFromParent_Done,
     /* 2242841 */ // Label 29956: @2242841
     /* 2242841 */ GIM_Try, /*On fail goto*//*Label 29957*/ GIMT_Encode4(2242907), // Rule ID 65427 //
     /* 2242846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242852 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242859 */   // MIs[0] Operand 1
     /* 2242859 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2242864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242868 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242872 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2242872 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242875 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242879 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242884 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242888 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242905 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242906 */   // GIR_Coverage, 65427,
     /* 2242906 */   GIR_EraseRootFromParent_Done,
     /* 2242907 */ // Label 29957: @2242907
     /* 2242907 */ GIM_Reject,
     /* 2242908 */ // Label 29900: @2242908
     /* 2242908 */ GIM_Try, /*On fail goto*//*Label 29958*/ GIMT_Encode4(2243010), // Rule ID 174 //
     /* 2242913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242919 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242926 */   // MIs[0] Operand 1
     /* 2242926 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242931 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2242935 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2242939 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2242943 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242947 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242952 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2242956 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242960 */   GIM_CheckAPIntImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /* 2242964 */   // MIs[2] Operand 1
     /* 2242964 */   // No operand predicates
     /* 2242964 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9978),
     /* 2242968 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2242972 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2242974 */   // (setcc:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9978>><<X:XLenSubTrailingOnes>>:$mask), 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)), 1:{ *:[i64] })
     /* 2242974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2242977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2242981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242986 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 2242990 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /* 2242995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243008 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243009 */   // GIR_Coverage, 174,
     /* 2243009 */   GIR_EraseRootFromParent_Done,
     /* 2243010 */ // Label 29958: @2243010
     /* 2243010 */ GIM_Try, /*On fail goto*//*Label 29959*/ GIMT_Encode4(2243115), // Rule ID 176 //
     /* 2243015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243021 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243028 */   // MIs[0] Operand 1
     /* 2243028 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243033 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2243037 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2243041 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2243045 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243049 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243054 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2243058 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243062 */   GIM_CheckAPIntImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /* 2243066 */   // MIs[2] Operand 1
     /* 2243066 */   // No operand predicates
     /* 2243066 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9978),
     /* 2243070 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243074 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2243076 */   // (setcc:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9978>><<X:XLenSubTrailingOnes>>:$mask), 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)))
     /* 2243076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2243079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2243083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243088 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 2243092 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /* 2243097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243104 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243113 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243114 */   // GIR_Coverage, 176,
     /* 2243114 */   GIR_EraseRootFromParent_Done,
     /* 2243115 */ // Label 29959: @2243115
     /* 2243115 */ GIM_Try, /*On fail goto*//*Label 29960*/ GIMT_Encode4(2243158), // Rule ID 172 //
     /* 2243120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243126 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243133 */   // MIs[0] Operand 1
     /* 2243133 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243142 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2243146 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] })
     /* 2243146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243151 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243157 */   // GIR_Coverage, 172,
     /* 2243157 */   GIR_EraseRootFromParent_Done,
     /* 2243158 */ // Label 29960: @2243158
     /* 2243158 */ GIM_Try, /*On fail goto*//*Label 29961*/ GIMT_Encode4(2243201), // Rule ID 65356 //
     /* 2243163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243169 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2243172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243176 */   // MIs[0] Operand 1
     /* 2243176 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243185 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243189 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2243189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243194 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243200 */   // GIR_Coverage, 65356,
     /* 2243200 */   GIR_EraseRootFromParent_Done,
     /* 2243201 */ // Label 29961: @2243201
     /* 2243201 */ GIM_Try, /*On fail goto*//*Label 29962*/ GIMT_Encode4(2243247), // Rule ID 65362 //
     /* 2243206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243212 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2243215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243219 */   // MIs[0] Operand 1
     /* 2243219 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243228 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243232 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2243232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243237 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243243 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243245 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243246 */   // GIR_Coverage, 65362,
     /* 2243246 */   GIR_EraseRootFromParent_Done,
     /* 2243247 */ // Label 29962: @2243247
     /* 2243247 */ GIM_Try, /*On fail goto*//*Label 29963*/ GIMT_Encode4(2243290), // Rule ID 65392 //
     /* 2243252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243258 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243265 */   // MIs[0] Operand 1
     /* 2243265 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243274 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243278 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2243278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243283 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243288 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243289 */   // GIR_Coverage, 65392,
     /* 2243289 */   GIR_EraseRootFromParent_Done,
     /* 2243290 */ // Label 29963: @2243290
     /* 2243290 */ GIM_Try, /*On fail goto*//*Label 29964*/ GIMT_Encode4(2243336), // Rule ID 65398 //
     /* 2243295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243301 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243308 */   // MIs[0] Operand 1
     /* 2243308 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243317 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243321 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2243321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243326 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243332 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243334 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243335 */   // GIR_Coverage, 65398,
     /* 2243335 */   GIR_EraseRootFromParent_Done,
     /* 2243336 */ // Label 29964: @2243336
     /* 2243336 */ GIM_Try, /*On fail goto*//*Label 29965*/ GIMT_Encode4(2243389), // Rule ID 162 //
     /* 2243341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243347 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243354 */   // MIs[0] Operand 1
     /* 2243354 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243363 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243367 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243371 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243375 */   // MIs[1] Operand 1
     /* 2243375 */   // No operand predicates
     /* 2243375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243377 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2243377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243382 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243384 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2243387 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243388 */   // GIR_Coverage, 162,
     /* 2243388 */   GIR_EraseRootFromParent_Done,
     /* 2243389 */ // Label 29965: @2243389
     /* 2243389 */ GIM_Try, /*On fail goto*//*Label 29966*/ GIMT_Encode4(2243442), // Rule ID 166 //
     /* 2243394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243407 */   // MIs[0] Operand 1
     /* 2243407 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2243412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243416 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243420 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243424 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243428 */   // MIs[1] Operand 1
     /* 2243428 */   // No operand predicates
     /* 2243428 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243430 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2243430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243435 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243437 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2243440 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243441 */   // GIR_Coverage, 166,
     /* 2243441 */   GIR_EraseRootFromParent_Done,
     /* 2243442 */ // Label 29966: @2243442
     /* 2243442 */ GIM_Try, /*On fail goto*//*Label 29967*/ GIMT_Encode4(2243495), // Rule ID 65348 //
     /* 2243447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243453 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243460 */   // MIs[0] Operand 1
     /* 2243460 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2243465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243477 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243481 */   // MIs[1] Operand 1
     /* 2243481 */   // No operand predicates
     /* 2243481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243483 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2243483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243488 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243490 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2243493 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243494 */   // GIR_Coverage, 65348,
     /* 2243494 */   GIR_EraseRootFromParent_Done,
     /* 2243495 */ // Label 29967: @2243495
     /* 2243495 */ GIM_Try, /*On fail goto*//*Label 29968*/ GIMT_Encode4(2243548), // Rule ID 65352 //
     /* 2243500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243506 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243513 */   // MIs[0] Operand 1
     /* 2243513 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243522 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243530 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243534 */   // MIs[1] Operand 1
     /* 2243534 */   // No operand predicates
     /* 2243534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243536 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2243536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243541 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243543 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2243546 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243547 */   // GIR_Coverage, 65352,
     /* 2243547 */   GIR_EraseRootFromParent_Done,
     /* 2243548 */ // Label 29968: @2243548
     /* 2243548 */ GIM_Try, /*On fail goto*//*Label 29969*/ GIMT_Encode4(2243625), // Rule ID 65358 //
     /* 2243553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243559 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243566 */   // MIs[0] Operand 1
     /* 2243566 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243571 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243575 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243579 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243583 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2243587 */   // MIs[1] Operand 1
     /* 2243587 */   // No operand predicates
     /* 2243587 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243589 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2243589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2243596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243601 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243605 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2243610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243623 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243624 */   // GIR_Coverage, 65358,
     /* 2243624 */   GIR_EraseRootFromParent_Done,
     /* 2243625 */ // Label 29969: @2243625
     /* 2243625 */ GIM_Try, /*On fail goto*//*Label 29970*/ GIMT_Encode4(2243705), // Rule ID 65364 //
     /* 2243630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243636 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243643 */   // MIs[0] Operand 1
     /* 2243643 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243660 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2243664 */   // MIs[1] Operand 1
     /* 2243664 */   // No operand predicates
     /* 2243664 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243666 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2243666 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243669 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2243673 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243678 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243682 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2243687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243694 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243703 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243704 */   // GIR_Coverage, 65364,
     /* 2243704 */   GIR_EraseRootFromParent_Done,
     /* 2243705 */ // Label 29970: @2243705
     /* 2243705 */ GIM_Try, /*On fail goto*//*Label 29971*/ GIMT_Encode4(2243782), // Rule ID 65368 //
     /* 2243710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243716 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243723 */   // MIs[0] Operand 1
     /* 2243723 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2243728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243740 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2243744 */   // MIs[1] Operand 1
     /* 2243744 */   // No operand predicates
     /* 2243744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243746 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2243746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243758 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243762 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243774 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243781 */   // GIR_Coverage, 65368,
     /* 2243781 */   GIR_EraseRootFromParent_Done,
     /* 2243782 */ // Label 29971: @2243782
     /* 2243782 */ GIM_Try, /*On fail goto*//*Label 29972*/ GIMT_Encode4(2243859), // Rule ID 65372 //
     /* 2243787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243793 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243800 */   // MIs[0] Operand 1
     /* 2243800 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2243805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243809 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243817 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2243821 */   // MIs[1] Operand 1
     /* 2243821 */   // No operand predicates
     /* 2243821 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243823 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2243823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243835 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243839 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243857 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243858 */   // GIR_Coverage, 65372,
     /* 2243858 */   GIR_EraseRootFromParent_Done,
     /* 2243859 */ // Label 29972: @2243859
     /* 2243859 */ GIM_Try, /*On fail goto*//*Label 29973*/ GIMT_Encode4(2243934), // Rule ID 65376 //
     /* 2243864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243870 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243877 */   // MIs[0] Operand 1
     /* 2243877 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2243882 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243886 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243890 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243894 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243898 */   // MIs[1] Operand 1
     /* 2243898 */   // No operand predicates
     /* 2243898 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243900 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2243900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243912 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243916 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2243919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243933 */   // GIR_Coverage, 65376,
     /* 2243933 */   GIR_EraseRootFromParent_Done,
     /* 2243934 */ // Label 29973: @2243934
     /* 2243934 */ GIM_Try, /*On fail goto*//*Label 29974*/ GIMT_Encode4(2244009), // Rule ID 65380 //
     /* 2243939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243952 */   // MIs[0] Operand 1
     /* 2243952 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2243957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243961 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243965 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243969 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243973 */   // MIs[1] Operand 1
     /* 2243973 */   // No operand predicates
     /* 2243973 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243975 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2243975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243987 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243991 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2243994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244001 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244008 */   // GIR_Coverage, 65380,
     /* 2244008 */   GIR_EraseRootFromParent_Done,
     /* 2244009 */ // Label 29974: @2244009
     /* 2244009 */ GIM_Try, /*On fail goto*//*Label 29975*/ GIMT_Encode4(2244064), // Rule ID 65384 //
     /* 2244014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244027 */   // MIs[0] Operand 1
     /* 2244027 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244044 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2244048 */   // MIs[1] Operand 1
     /* 2244048 */   // No operand predicates
     /* 2244048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244050 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2244050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244055 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244057 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244062 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244063 */   // GIR_Coverage, 65384,
     /* 2244063 */   GIR_EraseRootFromParent_Done,
     /* 2244064 */ // Label 29975: @2244064
     /* 2244064 */ GIM_Try, /*On fail goto*//*Label 29976*/ GIMT_Encode4(2244119), // Rule ID 65388 //
     /* 2244069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244075 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244082 */   // MIs[0] Operand 1
     /* 2244082 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244099 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2244103 */   // MIs[1] Operand 1
     /* 2244103 */   // No operand predicates
     /* 2244103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244105 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2244105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244110 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244112 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244118 */   // GIR_Coverage, 65388,
     /* 2244118 */   GIR_EraseRootFromParent_Done,
     /* 2244119 */ // Label 29976: @2244119
     /* 2244119 */ GIM_Try, /*On fail goto*//*Label 29977*/ GIMT_Encode4(2244196), // Rule ID 65394 //
     /* 2244124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244130 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244137 */   // MIs[0] Operand 1
     /* 2244137 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2244142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244146 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244154 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2244158 */   // MIs[1] Operand 1
     /* 2244158 */   // No operand predicates
     /* 2244158 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244160 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2244160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2244167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244172 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244176 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2244181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244195 */   // GIR_Coverage, 65394,
     /* 2244195 */   GIR_EraseRootFromParent_Done,
     /* 2244196 */ // Label 29977: @2244196
     /* 2244196 */ GIM_Try, /*On fail goto*//*Label 29978*/ GIMT_Encode4(2244276), // Rule ID 65400 //
     /* 2244201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244207 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244214 */   // MIs[0] Operand 1
     /* 2244214 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2244219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244231 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2244235 */   // MIs[1] Operand 1
     /* 2244235 */   // No operand predicates
     /* 2244235 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244237 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2244237 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244240 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2244244 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244249 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244253 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2244258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244265 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2244271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244274 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244275 */   // GIR_Coverage, 65400,
     /* 2244275 */   GIR_EraseRootFromParent_Done,
     /* 2244276 */ // Label 29978: @2244276
     /* 2244276 */ GIM_Try, /*On fail goto*//*Label 29979*/ GIMT_Encode4(2244353), // Rule ID 65404 //
     /* 2244281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244287 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244294 */   // MIs[0] Operand 1
     /* 2244294 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244303 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244307 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244311 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2244315 */   // MIs[1] Operand 1
     /* 2244315 */   // No operand predicates
     /* 2244315 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244317 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2244317 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244320 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244324 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244329 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244333 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244345 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244351 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244352 */   // GIR_Coverage, 65404,
     /* 2244352 */   GIR_EraseRootFromParent_Done,
     /* 2244353 */ // Label 29979: @2244353
     /* 2244353 */ GIM_Try, /*On fail goto*//*Label 29980*/ GIMT_Encode4(2244430), // Rule ID 65408 //
     /* 2244358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244364 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244371 */   // MIs[0] Operand 1
     /* 2244371 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244380 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244384 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244388 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2244392 */   // MIs[1] Operand 1
     /* 2244392 */   // No operand predicates
     /* 2244392 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244394 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2244394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244406 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244410 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244428 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244429 */   // GIR_Coverage, 65408,
     /* 2244429 */   GIR_EraseRootFromParent_Done,
     /* 2244430 */ // Label 29980: @2244430
     /* 2244430 */ GIM_Try, /*On fail goto*//*Label 29981*/ GIMT_Encode4(2244505), // Rule ID 65412 //
     /* 2244435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244448 */   // MIs[0] Operand 1
     /* 2244448 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2244453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244457 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244465 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2244469 */   // MIs[1] Operand 1
     /* 2244469 */   // No operand predicates
     /* 2244469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244471 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2244471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244483 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244487 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2244490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244503 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244504 */   // GIR_Coverage, 65412,
     /* 2244504 */   GIR_EraseRootFromParent_Done,
     /* 2244505 */ // Label 29981: @2244505
     /* 2244505 */ GIM_Try, /*On fail goto*//*Label 29982*/ GIMT_Encode4(2244580), // Rule ID 65416 //
     /* 2244510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244516 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244523 */   // MIs[0] Operand 1
     /* 2244523 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2244528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244532 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244536 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244540 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2244544 */   // MIs[1] Operand 1
     /* 2244544 */   // No operand predicates
     /* 2244544 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244546 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2244546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244558 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244562 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2244565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244579 */   // GIR_Coverage, 65416,
     /* 2244579 */   GIR_EraseRootFromParent_Done,
     /* 2244580 */ // Label 29982: @2244580
     /* 2244580 */ GIM_Try, /*On fail goto*//*Label 29983*/ GIMT_Encode4(2244635), // Rule ID 65420 //
     /* 2244585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244591 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244598 */   // MIs[0] Operand 1
     /* 2244598 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244607 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244611 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244615 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2244619 */   // MIs[1] Operand 1
     /* 2244619 */   // No operand predicates
     /* 2244619 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244621 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2244621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244626 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244628 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244633 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244634 */   // GIR_Coverage, 65420,
     /* 2244634 */   GIR_EraseRootFromParent_Done,
     /* 2244635 */ // Label 29983: @2244635
     /* 2244635 */ GIM_Try, /*On fail goto*//*Label 29984*/ GIMT_Encode4(2244690), // Rule ID 65424 //
     /* 2244640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244646 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244653 */   // MIs[0] Operand 1
     /* 2244653 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244662 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244666 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244670 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2244674 */   // MIs[1] Operand 1
     /* 2244674 */   // No operand predicates
     /* 2244674 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244676 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2244676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244681 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244683 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244688 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244689 */   // GIR_Coverage, 65424,
     /* 2244689 */   GIR_EraseRootFromParent_Done,
     /* 2244690 */ // Label 29984: @2244690
     /* 2244690 */ GIM_Try, /*On fail goto*//*Label 29985*/ GIMT_Encode4(2244732), // Rule ID 64469 //
     /* 2244695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2244698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244701 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244708 */   // MIs[0] Operand 1
     /* 2244708 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244717 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244721 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2244724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244726 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244728 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244730 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244731 */   // GIR_Coverage, 64469,
     /* 2244731 */   GIR_EraseRootFromParent_Done,
     /* 2244732 */ // Label 29985: @2244732
     /* 2244732 */ GIM_Try, /*On fail goto*//*Label 29986*/ GIMT_Encode4(2244774), // Rule ID 64471 //
     /* 2244737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2244740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244750 */   // MIs[0] Operand 1
     /* 2244750 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244759 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244763 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2244766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244768 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244770 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244773 */   // GIR_Coverage, 64471,
     /* 2244773 */   GIR_EraseRootFromParent_Done,
     /* 2244774 */ // Label 29986: @2244774
     /* 2244774 */ GIM_Try, /*On fail goto*//*Label 29987*/ GIMT_Encode4(2244816), // Rule ID 160 //
     /* 2244779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244785 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244792 */   // MIs[0] Operand 1
     /* 2244792 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2244797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244801 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244805 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244810 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244812 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244815 */   // GIR_Coverage, 160,
     /* 2244815 */   GIR_EraseRootFromParent_Done,
     /* 2244816 */ // Label 29987: @2244816
     /* 2244816 */ GIM_Try, /*On fail goto*//*Label 29988*/ GIMT_Encode4(2244858), // Rule ID 164 //
     /* 2244821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244834 */   // MIs[0] Operand 1
     /* 2244834 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244843 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244847 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244852 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244854 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244856 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244857 */   // GIR_Coverage, 164,
     /* 2244857 */   GIR_EraseRootFromParent_Done,
     /* 2244858 */ // Label 29988: @2244858
     /* 2244858 */ GIM_Try, /*On fail goto*//*Label 29989*/ GIMT_Encode4(2244900), // Rule ID 65350 //
     /* 2244863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244869 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244876 */   // MIs[0] Operand 1
     /* 2244876 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244885 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244889 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244894 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244896 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244898 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244899 */   // GIR_Coverage, 65350,
     /* 2244899 */   GIR_EraseRootFromParent_Done,
     /* 2244900 */ // Label 29989: @2244900
     /* 2244900 */ GIM_Try, /*On fail goto*//*Label 29990*/ GIMT_Encode4(2244942), // Rule ID 65354 //
     /* 2244905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244911 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244918 */   // MIs[0] Operand 1
     /* 2244918 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2244923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244927 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244931 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244936 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244938 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244940 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244941 */   // GIR_Coverage, 65354,
     /* 2244941 */   GIR_EraseRootFromParent_Done,
     /* 2244942 */ // Label 29990: @2244942
     /* 2244942 */ GIM_Try, /*On fail goto*//*Label 29991*/ GIMT_Encode4(2245008), // Rule ID 65360 //
     /* 2244947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244953 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244960 */   // MIs[0] Operand 1
     /* 2244960 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2244965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244969 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244973 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2244973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2244980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244985 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244989 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245000 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245006 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245007 */   // GIR_Coverage, 65360,
     /* 2245007 */   GIR_EraseRootFromParent_Done,
     /* 2245008 */ // Label 29991: @2245008
     /* 2245008 */ GIM_Try, /*On fail goto*//*Label 29992*/ GIMT_Encode4(2245077), // Rule ID 65366 //
     /* 2245013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245026 */   // MIs[0] Operand 1
     /* 2245026 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245035 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245039 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2245039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2245046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245051 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245055 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2245072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245075 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245076 */   // GIR_Coverage, 65366,
     /* 2245076 */   GIR_EraseRootFromParent_Done,
     /* 2245077 */ // Label 29992: @2245077
     /* 2245077 */ GIM_Try, /*On fail goto*//*Label 29993*/ GIMT_Encode4(2245119), // Rule ID 65370 //
     /* 2245082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245088 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245095 */   // MIs[0] Operand 1
     /* 2245095 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245104 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245108 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2245108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245113 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245115 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245118 */   // GIR_Coverage, 65370,
     /* 2245118 */   GIR_EraseRootFromParent_Done,
     /* 2245119 */ // Label 29993: @2245119
     /* 2245119 */ GIM_Try, /*On fail goto*//*Label 29994*/ GIMT_Encode4(2245161), // Rule ID 65374 //
     /* 2245124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245130 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245137 */   // MIs[0] Operand 1
     /* 2245137 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2245142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245146 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245150 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2245150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245155 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245157 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245159 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245160 */   // GIR_Coverage, 65374,
     /* 2245160 */   GIR_EraseRootFromParent_Done,
     /* 2245161 */ // Label 29994: @2245161
     /* 2245161 */ GIM_Try, /*On fail goto*//*Label 29995*/ GIMT_Encode4(2245227), // Rule ID 65378 //
     /* 2245166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245172 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245179 */   // MIs[0] Operand 1
     /* 2245179 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2245184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245188 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245192 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2245192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245204 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245208 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245225 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245226 */   // GIR_Coverage, 65378,
     /* 2245226 */   GIR_EraseRootFromParent_Done,
     /* 2245227 */ // Label 29995: @2245227
     /* 2245227 */ GIM_Try, /*On fail goto*//*Label 29996*/ GIMT_Encode4(2245293), // Rule ID 65382 //
     /* 2245232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245238 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245245 */   // MIs[0] Operand 1
     /* 2245245 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245254 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245258 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2245258 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245261 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245265 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245270 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245274 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245291 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245292 */   // GIR_Coverage, 65382,
     /* 2245292 */   GIR_EraseRootFromParent_Done,
     /* 2245293 */ // Label 29996: @2245293
     /* 2245293 */ GIM_Try, /*On fail goto*//*Label 29997*/ GIMT_Encode4(2245359), // Rule ID 65386 //
     /* 2245298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245304 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245311 */   // MIs[0] Operand 1
     /* 2245311 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245320 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245324 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2245324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245336 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245340 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245357 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245358 */   // GIR_Coverage, 65386,
     /* 2245358 */   GIR_EraseRootFromParent_Done,
     /* 2245359 */ // Label 29997: @2245359
     /* 2245359 */ GIM_Try, /*On fail goto*//*Label 29998*/ GIMT_Encode4(2245425), // Rule ID 65390 //
     /* 2245364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245377 */   // MIs[0] Operand 1
     /* 2245377 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245386 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245390 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2245390 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245393 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245397 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245402 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245406 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245423 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245424 */   // GIR_Coverage, 65390,
     /* 2245424 */   GIR_EraseRootFromParent_Done,
     /* 2245425 */ // Label 29998: @2245425
     /* 2245425 */ GIM_Try, /*On fail goto*//*Label 29999*/ GIMT_Encode4(2245491), // Rule ID 65396 //
     /* 2245430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245436 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245443 */   // MIs[0] Operand 1
     /* 2245443 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245452 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245456 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2245456 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245459 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2245463 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245468 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245472 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2245481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245489 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245490 */   // GIR_Coverage, 65396,
     /* 2245490 */   GIR_EraseRootFromParent_Done,
     /* 2245491 */ // Label 29999: @2245491
     /* 2245491 */ GIM_Try, /*On fail goto*//*Label 30000*/ GIMT_Encode4(2245560), // Rule ID 65402 //
     /* 2245496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245502 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245509 */   // MIs[0] Operand 1
     /* 2245509 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245518 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245522 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2245522 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245525 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2245529 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245534 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245538 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245549 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2245555 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245558 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245559 */   // GIR_Coverage, 65402,
     /* 2245559 */   GIR_EraseRootFromParent_Done,
     /* 2245560 */ // Label 30000: @2245560
     /* 2245560 */ GIM_Try, /*On fail goto*//*Label 30001*/ GIMT_Encode4(2245602), // Rule ID 65406 //
     /* 2245565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245571 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245578 */   // MIs[0] Operand 1
     /* 2245578 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245587 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245591 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2245591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245596 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245598 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245600 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245601 */   // GIR_Coverage, 65406,
     /* 2245601 */   GIR_EraseRootFromParent_Done,
     /* 2245602 */ // Label 30001: @2245602
     /* 2245602 */ GIM_Try, /*On fail goto*//*Label 30002*/ GIMT_Encode4(2245644), // Rule ID 65410 //
     /* 2245607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245613 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245620 */   // MIs[0] Operand 1
     /* 2245620 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2245625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245629 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245633 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2245633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245638 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245640 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245642 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245643 */   // GIR_Coverage, 65410,
     /* 2245643 */   GIR_EraseRootFromParent_Done,
     /* 2245644 */ // Label 30002: @2245644
     /* 2245644 */ GIM_Try, /*On fail goto*//*Label 30003*/ GIMT_Encode4(2245710), // Rule ID 65414 //
     /* 2245649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245655 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245662 */   // MIs[0] Operand 1
     /* 2245662 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2245667 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245671 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245675 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2245675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245687 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245691 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245702 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245708 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245709 */   // GIR_Coverage, 65414,
     /* 2245709 */   GIR_EraseRootFromParent_Done,
     /* 2245710 */ // Label 30003: @2245710
     /* 2245710 */ GIM_Try, /*On fail goto*//*Label 30004*/ GIMT_Encode4(2245776), // Rule ID 65418 //
     /* 2245715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245721 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245728 */   // MIs[0] Operand 1
     /* 2245728 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245733 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245737 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245741 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2245741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245753 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245757 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245768 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245774 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245775 */   // GIR_Coverage, 65418,
     /* 2245775 */   GIR_EraseRootFromParent_Done,
     /* 2245776 */ // Label 30004: @2245776
     /* 2245776 */ GIM_Try, /*On fail goto*//*Label 30005*/ GIMT_Encode4(2245842), // Rule ID 65422 //
     /* 2245781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245787 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245794 */   // MIs[0] Operand 1
     /* 2245794 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245803 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245807 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2245807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245819 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245840 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245841 */   // GIR_Coverage, 65422,
     /* 2245841 */   GIR_EraseRootFromParent_Done,
     /* 2245842 */ // Label 30005: @2245842
     /* 2245842 */ GIM_Try, /*On fail goto*//*Label 30006*/ GIMT_Encode4(2245908), // Rule ID 65426 //
     /* 2245847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245853 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245860 */   // MIs[0] Operand 1
     /* 2245860 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245869 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245873 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2245873 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245876 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245880 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245885 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245889 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245906 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245907 */   // GIR_Coverage, 65426,
     /* 2245907 */   GIR_EraseRootFromParent_Done,
     /* 2245908 */ // Label 30006: @2245908
     /* 2245908 */ GIM_Reject,
     /* 2245909 */ // Label 29901: @2245909
     /* 2245909 */ GIM_Try, /*On fail goto*//*Label 30007*/ GIMT_Encode4(2245957), // Rule ID 45790 //
     /* 2245914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245920 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245927 */   // MIs[0] Operand 1
     /* 2245927 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245932 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245936 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245940 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2245943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245945 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245947 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245955 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245956 */   // GIR_Coverage, 45790,
     /* 2245956 */   GIR_EraseRootFromParent_Done,
     /* 2245957 */ // Label 30007: @2245957
     /* 2245957 */ GIM_Try, /*On fail goto*//*Label 30008*/ GIMT_Encode4(2246005), // Rule ID 45791 //
     /* 2245962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245968 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245975 */   // MIs[0] Operand 1
     /* 2245975 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245984 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245988 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2245991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245993 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245995 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246004 */   // GIR_Coverage, 45791,
     /* 2246004 */   GIR_EraseRootFromParent_Done,
     /* 2246005 */ // Label 30008: @2246005
     /* 2246005 */ GIM_Try, /*On fail goto*//*Label 30009*/ GIMT_Encode4(2246053), // Rule ID 45792 //
     /* 2246010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246016 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246023 */   // MIs[0] Operand 1
     /* 2246023 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246032 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246036 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2246039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246041 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246043 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246052 */   // GIR_Coverage, 45792,
     /* 2246052 */   GIR_EraseRootFromParent_Done,
     /* 2246053 */ // Label 30009: @2246053
     /* 2246053 */ GIM_Try, /*On fail goto*//*Label 30010*/ GIMT_Encode4(2246101), // Rule ID 45793 //
     /* 2246058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246064 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246071 */   // MIs[0] Operand 1
     /* 2246071 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246080 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246084 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2246087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246089 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246091 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246099 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246100 */   // GIR_Coverage, 45793,
     /* 2246100 */   GIR_EraseRootFromParent_Done,
     /* 2246101 */ // Label 30010: @2246101
     /* 2246101 */ GIM_Try, /*On fail goto*//*Label 30011*/ GIMT_Encode4(2246149), // Rule ID 48504 //
     /* 2246106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246112 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246119 */   // MIs[0] Operand 1
     /* 2246119 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246128 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246132 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2246135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246137 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246139 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246148 */   // GIR_Coverage, 48504,
     /* 2246148 */   GIR_EraseRootFromParent_Done,
     /* 2246149 */ // Label 30011: @2246149
     /* 2246149 */ GIM_Try, /*On fail goto*//*Label 30012*/ GIMT_Encode4(2246197), // Rule ID 48505 //
     /* 2246154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246160 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246167 */   // MIs[0] Operand 1
     /* 2246167 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246176 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246180 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2246183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246185 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246187 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246195 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246196 */   // GIR_Coverage, 48505,
     /* 2246196 */   GIR_EraseRootFromParent_Done,
     /* 2246197 */ // Label 30012: @2246197
     /* 2246197 */ GIM_Try, /*On fail goto*//*Label 30013*/ GIMT_Encode4(2246245), // Rule ID 48508 //
     /* 2246202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246208 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246215 */   // MIs[0] Operand 1
     /* 2246215 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246224 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246228 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2246231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246233 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246235 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246243 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246244 */   // GIR_Coverage, 48508,
     /* 2246244 */   GIR_EraseRootFromParent_Done,
     /* 2246245 */ // Label 30013: @2246245
     /* 2246245 */ GIM_Try, /*On fail goto*//*Label 30014*/ GIMT_Encode4(2246293), // Rule ID 48509 //
     /* 2246250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246256 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246263 */   // MIs[0] Operand 1
     /* 2246263 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246272 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246276 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2246279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246281 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246283 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246291 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246292 */   // GIR_Coverage, 48509,
     /* 2246292 */   GIR_EraseRootFromParent_Done,
     /* 2246293 */ // Label 30014: @2246293
     /* 2246293 */ GIM_Try, /*On fail goto*//*Label 30015*/ GIMT_Encode4(2246341), // Rule ID 48516 //
     /* 2246298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246304 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246311 */   // MIs[0] Operand 1
     /* 2246311 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246320 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246324 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2246327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246329 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246331 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246339 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246340 */   // GIR_Coverage, 48516,
     /* 2246340 */   GIR_EraseRootFromParent_Done,
     /* 2246341 */ // Label 30015: @2246341
     /* 2246341 */ GIM_Try, /*On fail goto*//*Label 30016*/ GIMT_Encode4(2246389), // Rule ID 48517 //
     /* 2246346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246352 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246359 */   // MIs[0] Operand 1
     /* 2246359 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246368 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246372 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2246375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246377 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246379 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246387 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246388 */   // GIR_Coverage, 48517,
     /* 2246388 */   GIR_EraseRootFromParent_Done,
     /* 2246389 */ // Label 30016: @2246389
     /* 2246389 */ GIM_Try, /*On fail goto*//*Label 30017*/ GIMT_Encode4(2246437), // Rule ID 48542 //
     /* 2246394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246407 */   // MIs[0] Operand 1
     /* 2246407 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246416 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246420 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2246423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246425 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246427 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246435 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246436 */   // GIR_Coverage, 48542,
     /* 2246436 */   GIR_EraseRootFromParent_Done,
     /* 2246437 */ // Label 30017: @2246437
     /* 2246437 */ GIM_Try, /*On fail goto*//*Label 30018*/ GIMT_Encode4(2246485), // Rule ID 48543 //
     /* 2246442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246448 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246455 */   // MIs[0] Operand 1
     /* 2246455 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246464 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246468 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2246471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246473 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246475 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246483 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246484 */   // GIR_Coverage, 48543,
     /* 2246484 */   GIR_EraseRootFromParent_Done,
     /* 2246485 */ // Label 30018: @2246485
     /* 2246485 */ GIM_Try, /*On fail goto*//*Label 30019*/ GIMT_Encode4(2246533), // Rule ID 48548 //
     /* 2246490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246503 */   // MIs[0] Operand 1
     /* 2246503 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246512 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246516 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2246519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246521 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246523 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246531 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246532 */   // GIR_Coverage, 48548,
     /* 2246532 */   GIR_EraseRootFromParent_Done,
     /* 2246533 */ // Label 30019: @2246533
     /* 2246533 */ GIM_Try, /*On fail goto*//*Label 30020*/ GIMT_Encode4(2246581), // Rule ID 48549 //
     /* 2246538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246544 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246551 */   // MIs[0] Operand 1
     /* 2246551 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246560 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246564 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2246567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246569 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246571 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246579 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246580 */   // GIR_Coverage, 48549,
     /* 2246580 */   GIR_EraseRootFromParent_Done,
     /* 2246581 */ // Label 30020: @2246581
     /* 2246581 */ GIM_Try, /*On fail goto*//*Label 30021*/ GIMT_Encode4(2246629), // Rule ID 48552 //
     /* 2246586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246592 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246599 */   // MIs[0] Operand 1
     /* 2246599 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246608 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246612 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2246615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246617 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246619 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246627 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246628 */   // GIR_Coverage, 48552,
     /* 2246628 */   GIR_EraseRootFromParent_Done,
     /* 2246629 */ // Label 30021: @2246629
     /* 2246629 */ GIM_Try, /*On fail goto*//*Label 30022*/ GIMT_Encode4(2246677), // Rule ID 48553 //
     /* 2246634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246640 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246647 */   // MIs[0] Operand 1
     /* 2246647 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246656 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246660 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2246663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246665 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246667 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246675 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246676 */   // GIR_Coverage, 48553,
     /* 2246676 */   GIR_EraseRootFromParent_Done,
     /* 2246677 */ // Label 30022: @2246677
     /* 2246677 */ GIM_Try, /*On fail goto*//*Label 30023*/ GIMT_Encode4(2246725), // Rule ID 48560 //
     /* 2246682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246695 */   // MIs[0] Operand 1
     /* 2246695 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246704 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246708 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2246711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246713 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246715 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246723 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246724 */   // GIR_Coverage, 48560,
     /* 2246724 */   GIR_EraseRootFromParent_Done,
     /* 2246725 */ // Label 30023: @2246725
     /* 2246725 */ GIM_Try, /*On fail goto*//*Label 30024*/ GIMT_Encode4(2246773), // Rule ID 48561 //
     /* 2246730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246736 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246743 */   // MIs[0] Operand 1
     /* 2246743 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246752 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246756 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2246759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246761 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246763 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246772 */   // GIR_Coverage, 48561,
     /* 2246772 */   GIR_EraseRootFromParent_Done,
     /* 2246773 */ // Label 30024: @2246773
     /* 2246773 */ GIM_Try, /*On fail goto*//*Label 30025*/ GIMT_Encode4(2246821), // Rule ID 48586 //
     /* 2246778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246784 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246791 */   // MIs[0] Operand 1
     /* 2246791 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246800 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246804 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2246807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246809 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246811 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246819 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246820 */   // GIR_Coverage, 48586,
     /* 2246820 */   GIR_EraseRootFromParent_Done,
     /* 2246821 */ // Label 30025: @2246821
     /* 2246821 */ GIM_Try, /*On fail goto*//*Label 30026*/ GIMT_Encode4(2246869), // Rule ID 48587 //
     /* 2246826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246832 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246839 */   // MIs[0] Operand 1
     /* 2246839 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246848 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246852 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2246855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246857 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246859 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246867 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246868 */   // GIR_Coverage, 48587,
     /* 2246868 */   GIR_EraseRootFromParent_Done,
     /* 2246869 */ // Label 30026: @2246869
     /* 2246869 */ GIM_Try, /*On fail goto*//*Label 30027*/ GIMT_Encode4(2246917), // Rule ID 48592 //
     /* 2246874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246880 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246887 */   // MIs[0] Operand 1
     /* 2246887 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246896 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246900 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2246903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246905 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246907 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246915 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246916 */   // GIR_Coverage, 48592,
     /* 2246916 */   GIR_EraseRootFromParent_Done,
     /* 2246917 */ // Label 30027: @2246917
     /* 2246917 */ GIM_Try, /*On fail goto*//*Label 30028*/ GIMT_Encode4(2246965), // Rule ID 48593 //
     /* 2246922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246928 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246935 */   // MIs[0] Operand 1
     /* 2246935 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246944 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246948 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2246951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246953 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246955 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246964 */   // GIR_Coverage, 48593,
     /* 2246964 */   GIR_EraseRootFromParent_Done,
     /* 2246965 */ // Label 30028: @2246965
     /* 2246965 */ GIM_Try, /*On fail goto*//*Label 30029*/ GIMT_Encode4(2247013), // Rule ID 48596 //
     /* 2246970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246983 */   // MIs[0] Operand 1
     /* 2246983 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246992 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246996 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2246999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247001 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247003 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247012 */   // GIR_Coverage, 48596,
     /* 2247012 */   GIR_EraseRootFromParent_Done,
     /* 2247013 */ // Label 30029: @2247013
     /* 2247013 */ GIM_Try, /*On fail goto*//*Label 30030*/ GIMT_Encode4(2247061), // Rule ID 48597 //
     /* 2247018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247024 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247031 */   // MIs[0] Operand 1
     /* 2247031 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247040 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247044 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2247047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247049 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247051 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247059 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247060 */   // GIR_Coverage, 48597,
     /* 2247060 */   GIR_EraseRootFromParent_Done,
     /* 2247061 */ // Label 30030: @2247061
     /* 2247061 */ GIM_Try, /*On fail goto*//*Label 30031*/ GIMT_Encode4(2247109), // Rule ID 48604 //
     /* 2247066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247079 */   // MIs[0] Operand 1
     /* 2247079 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247088 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247092 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2247095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247097 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247099 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247108 */   // GIR_Coverage, 48604,
     /* 2247108 */   GIR_EraseRootFromParent_Done,
     /* 2247109 */ // Label 30031: @2247109
     /* 2247109 */ GIM_Try, /*On fail goto*//*Label 30032*/ GIMT_Encode4(2247157), // Rule ID 48605 //
     /* 2247114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247120 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247127 */   // MIs[0] Operand 1
     /* 2247127 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247136 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247140 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2247140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2247143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247145 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247147 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247156 */   // GIR_Coverage, 48605,
     /* 2247156 */   GIR_EraseRootFromParent_Done,
     /* 2247157 */ // Label 30032: @2247157
     /* 2247157 */ GIM_Try, /*On fail goto*//*Label 30033*/ GIMT_Encode4(2247205), // Rule ID 48634 //
     /* 2247162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247168 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247175 */   // MIs[0] Operand 1
     /* 2247175 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247184 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247188 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2247191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247193 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247195 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247203 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247204 */   // GIR_Coverage, 48634,
     /* 2247204 */   GIR_EraseRootFromParent_Done,
     /* 2247205 */ // Label 30033: @2247205
     /* 2247205 */ GIM_Try, /*On fail goto*//*Label 30034*/ GIMT_Encode4(2247253), // Rule ID 48635 //
     /* 2247210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247216 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247223 */   // MIs[0] Operand 1
     /* 2247223 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247232 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247236 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2247239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247241 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247243 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247252 */   // GIR_Coverage, 48635,
     /* 2247252 */   GIR_EraseRootFromParent_Done,
     /* 2247253 */ // Label 30034: @2247253
     /* 2247253 */ GIM_Try, /*On fail goto*//*Label 30035*/ GIMT_Encode4(2247301), // Rule ID 48638 //
     /* 2247258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247264 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247271 */   // MIs[0] Operand 1
     /* 2247271 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247280 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247284 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2247287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247289 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247291 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247300 */   // GIR_Coverage, 48638,
     /* 2247300 */   GIR_EraseRootFromParent_Done,
     /* 2247301 */ // Label 30035: @2247301
     /* 2247301 */ GIM_Try, /*On fail goto*//*Label 30036*/ GIMT_Encode4(2247349), // Rule ID 48639 //
     /* 2247306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247319 */   // MIs[0] Operand 1
     /* 2247319 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247328 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247332 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2247335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247337 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247339 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247348 */   // GIR_Coverage, 48639,
     /* 2247348 */   GIR_EraseRootFromParent_Done,
     /* 2247349 */ // Label 30036: @2247349
     /* 2247349 */ GIM_Try, /*On fail goto*//*Label 30037*/ GIMT_Encode4(2247397), // Rule ID 48646 //
     /* 2247354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247360 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247367 */   // MIs[0] Operand 1
     /* 2247367 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247376 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247380 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2247383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247385 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247387 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247395 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247396 */   // GIR_Coverage, 48646,
     /* 2247396 */   GIR_EraseRootFromParent_Done,
     /* 2247397 */ // Label 30037: @2247397
     /* 2247397 */ GIM_Try, /*On fail goto*//*Label 30038*/ GIMT_Encode4(2247445), // Rule ID 48647 //
     /* 2247402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247408 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247415 */   // MIs[0] Operand 1
     /* 2247415 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247424 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247428 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2247428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2247431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247433 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247435 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247444 */   // GIR_Coverage, 48647,
     /* 2247444 */   GIR_EraseRootFromParent_Done,
     /* 2247445 */ // Label 30038: @2247445
     /* 2247445 */ GIM_Try, /*On fail goto*//*Label 30039*/ GIMT_Encode4(2247493), // Rule ID 48672 //
     /* 2247450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247456 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247463 */   // MIs[0] Operand 1
     /* 2247463 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247472 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247476 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247481 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247483 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247491 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247492 */   // GIR_Coverage, 48672,
     /* 2247492 */   GIR_EraseRootFromParent_Done,
     /* 2247493 */ // Label 30039: @2247493
     /* 2247493 */ GIM_Try, /*On fail goto*//*Label 30040*/ GIMT_Encode4(2247541), // Rule ID 48673 //
     /* 2247498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247504 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247511 */   // MIs[0] Operand 1
     /* 2247511 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247520 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247524 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247529 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247531 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247540 */   // GIR_Coverage, 48673,
     /* 2247540 */   GIR_EraseRootFromParent_Done,
     /* 2247541 */ // Label 30040: @2247541
     /* 2247541 */ GIM_Try, /*On fail goto*//*Label 30041*/ GIMT_Encode4(2247589), // Rule ID 48678 //
     /* 2247546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247552 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247559 */   // MIs[0] Operand 1
     /* 2247559 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247568 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247572 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247577 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247579 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247588 */   // GIR_Coverage, 48678,
     /* 2247588 */   GIR_EraseRootFromParent_Done,
     /* 2247589 */ // Label 30041: @2247589
     /* 2247589 */ GIM_Try, /*On fail goto*//*Label 30042*/ GIMT_Encode4(2247637), // Rule ID 48679 //
     /* 2247594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247600 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247607 */   // MIs[0] Operand 1
     /* 2247607 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247616 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247620 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247625 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247627 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247636 */   // GIR_Coverage, 48679,
     /* 2247636 */   GIR_EraseRootFromParent_Done,
     /* 2247637 */ // Label 30042: @2247637
     /* 2247637 */ GIM_Try, /*On fail goto*//*Label 30043*/ GIMT_Encode4(2247685), // Rule ID 48682 //
     /* 2247642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247648 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247655 */   // MIs[0] Operand 1
     /* 2247655 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247664 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247668 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2247671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247673 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247675 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247683 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247684 */   // GIR_Coverage, 48682,
     /* 2247684 */   GIR_EraseRootFromParent_Done,
     /* 2247685 */ // Label 30043: @2247685
     /* 2247685 */ GIM_Try, /*On fail goto*//*Label 30044*/ GIMT_Encode4(2247733), // Rule ID 48683 //
     /* 2247690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247703 */   // MIs[0] Operand 1
     /* 2247703 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247712 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247716 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2247719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247721 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247723 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247732 */   // GIR_Coverage, 48683,
     /* 2247732 */   GIR_EraseRootFromParent_Done,
     /* 2247733 */ // Label 30044: @2247733
     /* 2247733 */ GIM_Try, /*On fail goto*//*Label 30045*/ GIMT_Encode4(2247781), // Rule ID 48690 //
     /* 2247738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247751 */   // MIs[0] Operand 1
     /* 2247751 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247760 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247764 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2247767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247769 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247771 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247780 */   // GIR_Coverage, 48690,
     /* 2247780 */   GIR_EraseRootFromParent_Done,
     /* 2247781 */ // Label 30045: @2247781
     /* 2247781 */ GIM_Try, /*On fail goto*//*Label 30046*/ GIMT_Encode4(2247829), // Rule ID 48691 //
     /* 2247786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247792 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247799 */   // MIs[0] Operand 1
     /* 2247799 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247808 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247812 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2247812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2247815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247817 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247819 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247828 */   // GIR_Coverage, 48691,
     /* 2247828 */   GIR_EraseRootFromParent_Done,
     /* 2247829 */ // Label 30046: @2247829
     /* 2247829 */ GIM_Try, /*On fail goto*//*Label 30047*/ GIMT_Encode4(2247877), // Rule ID 48716 //
     /* 2247834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247840 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247847 */   // MIs[0] Operand 1
     /* 2247847 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247856 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247860 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247865 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247867 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247876 */   // GIR_Coverage, 48716,
     /* 2247876 */   GIR_EraseRootFromParent_Done,
     /* 2247877 */ // Label 30047: @2247877
     /* 2247877 */ GIM_Try, /*On fail goto*//*Label 30048*/ GIMT_Encode4(2247925), // Rule ID 48717 //
     /* 2247882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247888 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247895 */   // MIs[0] Operand 1
     /* 2247895 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247904 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247908 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247913 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247915 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247924 */   // GIR_Coverage, 48717,
     /* 2247924 */   GIR_EraseRootFromParent_Done,
     /* 2247925 */ // Label 30048: @2247925
     /* 2247925 */ GIM_Try, /*On fail goto*//*Label 30049*/ GIMT_Encode4(2247973), // Rule ID 48722 //
     /* 2247930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247936 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247943 */   // MIs[0] Operand 1
     /* 2247943 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247952 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247956 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247961 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247963 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247971 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247972 */   // GIR_Coverage, 48722,
     /* 2247972 */   GIR_EraseRootFromParent_Done,
     /* 2247973 */ // Label 30049: @2247973
     /* 2247973 */ GIM_Try, /*On fail goto*//*Label 30050*/ GIMT_Encode4(2248021), // Rule ID 48723 //
     /* 2247978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247984 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247991 */   // MIs[0] Operand 1
     /* 2247991 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248000 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248004 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2248007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248009 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248011 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248020 */   // GIR_Coverage, 48723,
     /* 2248020 */   GIR_EraseRootFromParent_Done,
     /* 2248021 */ // Label 30050: @2248021
     /* 2248021 */ GIM_Try, /*On fail goto*//*Label 30051*/ GIMT_Encode4(2248069), // Rule ID 48726 //
     /* 2248026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248039 */   // MIs[0] Operand 1
     /* 2248039 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248052 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2248055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248057 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248059 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248067 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248068 */   // GIR_Coverage, 48726,
     /* 2248068 */   GIR_EraseRootFromParent_Done,
     /* 2248069 */ // Label 30051: @2248069
     /* 2248069 */ GIM_Try, /*On fail goto*//*Label 30052*/ GIMT_Encode4(2248117), // Rule ID 48727 //
     /* 2248074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248087 */   // MIs[0] Operand 1
     /* 2248087 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248096 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248100 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2248103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248105 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248107 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248116 */   // GIR_Coverage, 48727,
     /* 2248116 */   GIR_EraseRootFromParent_Done,
     /* 2248117 */ // Label 30052: @2248117
     /* 2248117 */ GIM_Try, /*On fail goto*//*Label 30053*/ GIMT_Encode4(2248165), // Rule ID 48734 //
     /* 2248122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248135 */   // MIs[0] Operand 1
     /* 2248135 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248144 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248148 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2248151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248153 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248155 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248163 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248164 */   // GIR_Coverage, 48734,
     /* 2248164 */   GIR_EraseRootFromParent_Done,
     /* 2248165 */ // Label 30053: @2248165
     /* 2248165 */ GIM_Try, /*On fail goto*//*Label 30054*/ GIMT_Encode4(2248213), // Rule ID 48735 //
     /* 2248170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248176 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248183 */   // MIs[0] Operand 1
     /* 2248183 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248192 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248196 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2248199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248201 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248203 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248212 */   // GIR_Coverage, 48735,
     /* 2248212 */   GIR_EraseRootFromParent_Done,
     /* 2248213 */ // Label 30054: @2248213
     /* 2248213 */ GIM_Try, /*On fail goto*//*Label 30055*/ GIMT_Encode4(2248261), // Rule ID 48760 //
     /* 2248218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248224 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248231 */   // MIs[0] Operand 1
     /* 2248231 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248240 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248244 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2248247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248249 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248251 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248260 */   // GIR_Coverage, 48760,
     /* 2248260 */   GIR_EraseRootFromParent_Done,
     /* 2248261 */ // Label 30055: @2248261
     /* 2248261 */ GIM_Try, /*On fail goto*//*Label 30056*/ GIMT_Encode4(2248309), // Rule ID 48761 //
     /* 2248266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248279 */   // MIs[0] Operand 1
     /* 2248279 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248288 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248292 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2248295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248297 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248299 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248308 */   // GIR_Coverage, 48761,
     /* 2248308 */   GIR_EraseRootFromParent_Done,
     /* 2248309 */ // Label 30056: @2248309
     /* 2248309 */ GIM_Try, /*On fail goto*//*Label 30057*/ GIMT_Encode4(2248357), // Rule ID 48766 //
     /* 2248314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248327 */   // MIs[0] Operand 1
     /* 2248327 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248336 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248340 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2248343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248345 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248347 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248356 */   // GIR_Coverage, 48766,
     /* 2248356 */   GIR_EraseRootFromParent_Done,
     /* 2248357 */ // Label 30057: @2248357
     /* 2248357 */ GIM_Try, /*On fail goto*//*Label 30058*/ GIMT_Encode4(2248405), // Rule ID 48767 //
     /* 2248362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248368 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248375 */   // MIs[0] Operand 1
     /* 2248375 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248384 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248388 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2248391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248393 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248395 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248403 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248404 */   // GIR_Coverage, 48767,
     /* 2248404 */   GIR_EraseRootFromParent_Done,
     /* 2248405 */ // Label 30058: @2248405
     /* 2248405 */ GIM_Try, /*On fail goto*//*Label 30059*/ GIMT_Encode4(2248453), // Rule ID 48770 //
     /* 2248410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248416 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248423 */   // MIs[0] Operand 1
     /* 2248423 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248432 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248436 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2248439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248441 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248443 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248451 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248452 */   // GIR_Coverage, 48770,
     /* 2248452 */   GIR_EraseRootFromParent_Done,
     /* 2248453 */ // Label 30059: @2248453
     /* 2248453 */ GIM_Try, /*On fail goto*//*Label 30060*/ GIMT_Encode4(2248501), // Rule ID 48771 //
     /* 2248458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248464 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248471 */   // MIs[0] Operand 1
     /* 2248471 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248480 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248484 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2248487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248489 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248491 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248500 */   // GIR_Coverage, 48771,
     /* 2248500 */   GIR_EraseRootFromParent_Done,
     /* 2248501 */ // Label 30060: @2248501
     /* 2248501 */ GIM_Try, /*On fail goto*//*Label 30061*/ GIMT_Encode4(2248549), // Rule ID 48778 //
     /* 2248506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248519 */   // MIs[0] Operand 1
     /* 2248519 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248528 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248532 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248537 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248539 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248547 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248548 */   // GIR_Coverage, 48778,
     /* 2248548 */   GIR_EraseRootFromParent_Done,
     /* 2248549 */ // Label 30061: @2248549
     /* 2248549 */ GIM_Try, /*On fail goto*//*Label 30062*/ GIMT_Encode4(2248597), // Rule ID 48779 //
     /* 2248554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248560 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248567 */   // MIs[0] Operand 1
     /* 2248567 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248576 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248580 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248585 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248587 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248596 */   // GIR_Coverage, 48779,
     /* 2248596 */   GIR_EraseRootFromParent_Done,
     /* 2248597 */ // Label 30062: @2248597
     /* 2248597 */ GIM_Try, /*On fail goto*//*Label 30063*/ GIMT_Encode4(2248645), // Rule ID 48804 //
     /* 2248602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248608 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248615 */   // MIs[0] Operand 1
     /* 2248615 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248624 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248628 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2248631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248633 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248635 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248644 */   // GIR_Coverage, 48804,
     /* 2248644 */   GIR_EraseRootFromParent_Done,
     /* 2248645 */ // Label 30063: @2248645
     /* 2248645 */ GIM_Try, /*On fail goto*//*Label 30064*/ GIMT_Encode4(2248693), // Rule ID 48805 //
     /* 2248650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248656 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248663 */   // MIs[0] Operand 1
     /* 2248663 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248672 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248676 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2248679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248681 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248683 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248691 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248692 */   // GIR_Coverage, 48805,
     /* 2248692 */   GIR_EraseRootFromParent_Done,
     /* 2248693 */ // Label 30064: @2248693
     /* 2248693 */ GIM_Try, /*On fail goto*//*Label 30065*/ GIMT_Encode4(2248741), // Rule ID 48810 //
     /* 2248698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248704 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248711 */   // MIs[0] Operand 1
     /* 2248711 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248720 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248724 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2248727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248729 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248731 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248740 */   // GIR_Coverage, 48810,
     /* 2248740 */   GIR_EraseRootFromParent_Done,
     /* 2248741 */ // Label 30065: @2248741
     /* 2248741 */ GIM_Try, /*On fail goto*//*Label 30066*/ GIMT_Encode4(2248789), // Rule ID 48811 //
     /* 2248746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248752 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248759 */   // MIs[0] Operand 1
     /* 2248759 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248768 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248772 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2248775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248777 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248779 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248787 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248788 */   // GIR_Coverage, 48811,
     /* 2248788 */   GIR_EraseRootFromParent_Done,
     /* 2248789 */ // Label 30066: @2248789
     /* 2248789 */ GIM_Try, /*On fail goto*//*Label 30067*/ GIMT_Encode4(2248837), // Rule ID 48814 //
     /* 2248794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248800 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248807 */   // MIs[0] Operand 1
     /* 2248807 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248816 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248820 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2248823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248825 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248827 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248835 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248836 */   // GIR_Coverage, 48814,
     /* 2248836 */   GIR_EraseRootFromParent_Done,
     /* 2248837 */ // Label 30067: @2248837
     /* 2248837 */ GIM_Try, /*On fail goto*//*Label 30068*/ GIMT_Encode4(2248885), // Rule ID 48815 //
     /* 2248842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248848 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248855 */   // MIs[0] Operand 1
     /* 2248855 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248864 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248868 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2248871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248873 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248875 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248883 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248884 */   // GIR_Coverage, 48815,
     /* 2248884 */   GIR_EraseRootFromParent_Done,
     /* 2248885 */ // Label 30068: @2248885
     /* 2248885 */ GIM_Try, /*On fail goto*//*Label 30069*/ GIMT_Encode4(2248933), // Rule ID 48822 //
     /* 2248890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248896 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248903 */   // MIs[0] Operand 1
     /* 2248903 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248912 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248916 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248921 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248923 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248932 */   // GIR_Coverage, 48822,
     /* 2248932 */   GIR_EraseRootFromParent_Done,
     /* 2248933 */ // Label 30069: @2248933
     /* 2248933 */ GIM_Try, /*On fail goto*//*Label 30070*/ GIMT_Encode4(2248981), // Rule ID 48823 //
     /* 2248938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248951 */   // MIs[0] Operand 1
     /* 2248951 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248960 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248964 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248969 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248971 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248979 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248980 */   // GIR_Coverage, 48823,
     /* 2248980 */   GIR_EraseRootFromParent_Done,
     /* 2248981 */ // Label 30070: @2248981
     /* 2248981 */ GIM_Try, /*On fail goto*//*Label 30071*/ GIMT_Encode4(2249029), // Rule ID 48848 //
     /* 2248986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248992 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248999 */   // MIs[0] Operand 1
     /* 2248999 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249008 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249012 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2249015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249017 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249019 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249027 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249028 */   // GIR_Coverage, 48848,
     /* 2249028 */   GIR_EraseRootFromParent_Done,
     /* 2249029 */ // Label 30071: @2249029
     /* 2249029 */ GIM_Try, /*On fail goto*//*Label 30072*/ GIMT_Encode4(2249077), // Rule ID 48849 //
     /* 2249034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2249040 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2249043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249047 */   // MIs[0] Operand 1
     /* 2249047 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249056 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249060 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2249063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249065 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249067 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249075 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249076 */   // GIR_Coverage, 48849,
     /* 2249076 */   GIR_EraseRootFromParent_Done,
     /* 2249077 */ // Label 30072: @2249077
     /* 2249077 */ GIM_Try, /*On fail goto*//*Label 30073*/ GIMT_Encode4(2249125), // Rule ID 48854 //
     /* 2249082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249088 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249095 */   // MIs[0] Operand 1
     /* 2249095 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249104 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249108 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2249111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249113 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249115 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249123 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249124 */   // GIR_Coverage, 48854,
     /* 2249124 */   GIR_EraseRootFromParent_Done,
     /* 2249125 */ // Label 30073: @2249125
     /* 2249125 */ GIM_Try, /*On fail goto*//*Label 30074*/ GIMT_Encode4(2249173), // Rule ID 48855 //
     /* 2249130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249136 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249143 */   // MIs[0] Operand 1
     /* 2249143 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249152 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249156 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2249159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249161 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249163 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249171 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249172 */   // GIR_Coverage, 48855,
     /* 2249172 */   GIR_EraseRootFromParent_Done,
     /* 2249173 */ // Label 30074: @2249173
     /* 2249173 */ GIM_Try, /*On fail goto*//*Label 30075*/ GIMT_Encode4(2249221), // Rule ID 48858 //
     /* 2249178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249184 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249191 */   // MIs[0] Operand 1
     /* 2249191 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249200 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249204 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2249207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249209 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249211 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249219 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249220 */   // GIR_Coverage, 48858,
     /* 2249220 */   GIR_EraseRootFromParent_Done,
     /* 2249221 */ // Label 30075: @2249221
     /* 2249221 */ GIM_Try, /*On fail goto*//*Label 30076*/ GIMT_Encode4(2249269), // Rule ID 48859 //
     /* 2249226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249232 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249239 */   // MIs[0] Operand 1
     /* 2249239 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249244 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249248 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249252 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2249255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249257 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249259 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249267 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249268 */   // GIR_Coverage, 48859,
     /* 2249268 */   GIR_EraseRootFromParent_Done,
     /* 2249269 */ // Label 30076: @2249269
     /* 2249269 */ GIM_Try, /*On fail goto*//*Label 30077*/ GIMT_Encode4(2249317), // Rule ID 48866 //
     /* 2249274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249280 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249287 */   // MIs[0] Operand 1
     /* 2249287 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249296 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249300 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2249303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249305 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249307 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249315 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249316 */   // GIR_Coverage, 48866,
     /* 2249316 */   GIR_EraseRootFromParent_Done,
     /* 2249317 */ // Label 30077: @2249317
     /* 2249317 */ GIM_Try, /*On fail goto*//*Label 30078*/ GIMT_Encode4(2249365), // Rule ID 48867 //
     /* 2249322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249328 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249335 */   // MIs[0] Operand 1
     /* 2249335 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249344 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249348 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2249351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249353 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249355 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249363 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249364 */   // GIR_Coverage, 48867,
     /* 2249364 */   GIR_EraseRootFromParent_Done,
     /* 2249365 */ // Label 30078: @2249365
     /* 2249365 */ GIM_Try, /*On fail goto*//*Label 30079*/ GIMT_Encode4(2249413), // Rule ID 48892 //
     /* 2249370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2249376 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2249379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249383 */   // MIs[0] Operand 1
     /* 2249383 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249392 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249396 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2249399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249401 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249403 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249411 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249412 */   // GIR_Coverage, 48892,
     /* 2249412 */   GIR_EraseRootFromParent_Done,
     /* 2249413 */ // Label 30079: @2249413
     /* 2249413 */ GIM_Try, /*On fail goto*//*Label 30080*/ GIMT_Encode4(2249461), // Rule ID 48893 //
     /* 2249418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2249424 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2249427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249431 */   // MIs[0] Operand 1
     /* 2249431 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249440 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249444 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2249447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249449 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249451 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249459 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249460 */   // GIR_Coverage, 48893,
     /* 2249460 */   GIR_EraseRootFromParent_Done,
     /* 2249461 */ // Label 30080: @2249461
     /* 2249461 */ GIM_Try, /*On fail goto*//*Label 30081*/ GIMT_Encode4(2249509), // Rule ID 48898 //
     /* 2249466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249472 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249479 */   // MIs[0] Operand 1
     /* 2249479 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249488 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249492 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2249495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249497 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249499 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249507 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249508 */   // GIR_Coverage, 48898,
     /* 2249508 */   GIR_EraseRootFromParent_Done,
     /* 2249509 */ // Label 30081: @2249509
     /* 2249509 */ GIM_Try, /*On fail goto*//*Label 30082*/ GIMT_Encode4(2249557), // Rule ID 48899 //
     /* 2249514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249520 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249527 */   // MIs[0] Operand 1
     /* 2249527 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249536 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249540 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2249543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249545 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249547 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249555 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249556 */   // GIR_Coverage, 48899,
     /* 2249556 */   GIR_EraseRootFromParent_Done,
     /* 2249557 */ // Label 30082: @2249557
     /* 2249557 */ GIM_Try, /*On fail goto*//*Label 30083*/ GIMT_Encode4(2249605), // Rule ID 48902 //
     /* 2249562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249568 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249575 */   // MIs[0] Operand 1
     /* 2249575 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249584 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249588 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2249591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249593 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249595 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249603 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249604 */   // GIR_Coverage, 48902,
     /* 2249604 */   GIR_EraseRootFromParent_Done,
     /* 2249605 */ // Label 30083: @2249605
     /* 2249605 */ GIM_Try, /*On fail goto*//*Label 30084*/ GIMT_Encode4(2249653), // Rule ID 48903 //
     /* 2249610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249616 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249623 */   // MIs[0] Operand 1
     /* 2249623 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249632 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249636 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2249639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249641 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249643 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249651 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249652 */   // GIR_Coverage, 48903,
     /* 2249652 */   GIR_EraseRootFromParent_Done,
     /* 2249653 */ // Label 30084: @2249653
     /* 2249653 */ GIM_Try, /*On fail goto*//*Label 30085*/ GIMT_Encode4(2249701), // Rule ID 48910 //
     /* 2249658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249664 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249671 */   // MIs[0] Operand 1
     /* 2249671 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249676 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249680 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249684 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2249687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249689 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249691 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249699 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249700 */   // GIR_Coverage, 48910,
     /* 2249700 */   GIR_EraseRootFromParent_Done,
     /* 2249701 */ // Label 30085: @2249701
     /* 2249701 */ GIM_Try, /*On fail goto*//*Label 30086*/ GIMT_Encode4(2249749), // Rule ID 48911 //
     /* 2249706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249712 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249719 */   // MIs[0] Operand 1
     /* 2249719 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249728 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249732 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2249735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249737 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249739 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249748 */   // GIR_Coverage, 48911,
     /* 2249748 */   GIR_EraseRootFromParent_Done,
     /* 2249749 */ // Label 30086: @2249749
     /* 2249749 */ GIM_Reject,
     /* 2249750 */ // Label 29902: @2249750
     /* 2249750 */ GIM_Try, /*On fail goto*//*Label 30087*/ GIMT_Encode4(2249798), // Rule ID 48500 //
     /* 2249755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2249761 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2249764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249768 */   // MIs[0] Operand 1
     /* 2249768 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249777 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249781 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2249784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249786 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249788 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249796 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249797 */   // GIR_Coverage, 48500,
     /* 2249797 */   GIR_EraseRootFromParent_Done,
     /* 2249798 */ // Label 30087: @2249798
     /* 2249798 */ GIM_Try, /*On fail goto*//*Label 30088*/ GIMT_Encode4(2249846), // Rule ID 48501 //
     /* 2249803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2249809 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2249812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249816 */   // MIs[0] Operand 1
     /* 2249816 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249825 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249829 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2249832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249834 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249836 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249844 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249845 */   // GIR_Coverage, 48501,
     /* 2249845 */   GIR_EraseRootFromParent_Done,
     /* 2249846 */ // Label 30088: @2249846
     /* 2249846 */ GIM_Try, /*On fail goto*//*Label 30089*/ GIMT_Encode4(2249894), // Rule ID 48506 //
     /* 2249851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249857 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249864 */   // MIs[0] Operand 1
     /* 2249864 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249869 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249873 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249877 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2249880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249882 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249884 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249892 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249893 */   // GIR_Coverage, 48506,
     /* 2249893 */   GIR_EraseRootFromParent_Done,
     /* 2249894 */ // Label 30089: @2249894
     /* 2249894 */ GIM_Try, /*On fail goto*//*Label 30090*/ GIMT_Encode4(2249942), // Rule ID 48507 //
     /* 2249899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249905 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249912 */   // MIs[0] Operand 1
     /* 2249912 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249917 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249921 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249925 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2249928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249930 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249932 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249940 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249941 */   // GIR_Coverage, 48507,
     /* 2249941 */   GIR_EraseRootFromParent_Done,
     /* 2249942 */ // Label 30090: @2249942
     /* 2249942 */ GIM_Try, /*On fail goto*//*Label 30091*/ GIMT_Encode4(2249990), // Rule ID 48514 //
     /* 2249947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249953 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249960 */   // MIs[0] Operand 1
     /* 2249960 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249969 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249973 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2249976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249978 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249980 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249988 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249989 */   // GIR_Coverage, 48514,
     /* 2249989 */   GIR_EraseRootFromParent_Done,
     /* 2249990 */ // Label 30091: @2249990
     /* 2249990 */ GIM_Try, /*On fail goto*//*Label 30092*/ GIMT_Encode4(2250038), // Rule ID 48515 //
     /* 2249995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250001 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250008 */   // MIs[0] Operand 1
     /* 2250008 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2250013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250017 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250021 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2250024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250026 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250028 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250036 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250037 */   // GIR_Coverage, 48515,
     /* 2250037 */   GIR_EraseRootFromParent_Done,
     /* 2250038 */ // Label 30092: @2250038
     /* 2250038 */ GIM_Try, /*On fail goto*//*Label 30093*/ GIMT_Encode4(2250086), // Rule ID 48536 //
     /* 2250043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250049 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250056 */   // MIs[0] Operand 1
     /* 2250056 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2250061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250065 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250069 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2250072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250074 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250076 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250085 */   // GIR_Coverage, 48536,
     /* 2250085 */   GIR_EraseRootFromParent_Done,
     /* 2250086 */ // Label 30093: @2250086
     /* 2250086 */ GIM_Try, /*On fail goto*//*Label 30094*/ GIMT_Encode4(2250134), // Rule ID 48537 //
     /* 2250091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250097 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250104 */   // MIs[0] Operand 1
     /* 2250104 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2250109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250113 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250117 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2250120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250122 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250124 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250132 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250133 */   // GIR_Coverage, 48537,
     /* 2250133 */   GIR_EraseRootFromParent_Done,
     /* 2250134 */ // Label 30094: @2250134
     /* 2250134 */ GIM_Try, /*On fail goto*//*Label 30095*/ GIMT_Encode4(2250182), // Rule ID 48544 //
     /* 2250139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250145 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250152 */   // MIs[0] Operand 1
     /* 2250152 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250161 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250165 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2250168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250170 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250172 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250180 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250181 */   // GIR_Coverage, 48544,
     /* 2250181 */   GIR_EraseRootFromParent_Done,
     /* 2250182 */ // Label 30095: @2250182
     /* 2250182 */ GIM_Try, /*On fail goto*//*Label 30096*/ GIMT_Encode4(2250230), // Rule ID 48545 //
     /* 2250187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250193 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250200 */   // MIs[0] Operand 1
     /* 2250200 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250209 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250213 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2250216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250218 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250220 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250228 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250229 */   // GIR_Coverage, 48545,
     /* 2250229 */   GIR_EraseRootFromParent_Done,
     /* 2250230 */ // Label 30096: @2250230
     /* 2250230 */ GIM_Try, /*On fail goto*//*Label 30097*/ GIMT_Encode4(2250278), // Rule ID 48550 //
     /* 2250235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250241 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250248 */   // MIs[0] Operand 1
     /* 2250248 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250257 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250261 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2250264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250266 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250268 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250276 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250277 */   // GIR_Coverage, 48550,
     /* 2250277 */   GIR_EraseRootFromParent_Done,
     /* 2250278 */ // Label 30097: @2250278
     /* 2250278 */ GIM_Try, /*On fail goto*//*Label 30098*/ GIMT_Encode4(2250326), // Rule ID 48551 //
     /* 2250283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250289 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250296 */   // MIs[0] Operand 1
     /* 2250296 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250305 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250309 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2250312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250314 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250316 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250324 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250325 */   // GIR_Coverage, 48551,
     /* 2250325 */   GIR_EraseRootFromParent_Done,
     /* 2250326 */ // Label 30098: @2250326
     /* 2250326 */ GIM_Try, /*On fail goto*//*Label 30099*/ GIMT_Encode4(2250374), // Rule ID 48558 //
     /* 2250331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250337 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250344 */   // MIs[0] Operand 1
     /* 2250344 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250353 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250357 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2250360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250362 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250364 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250372 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250373 */   // GIR_Coverage, 48558,
     /* 2250373 */   GIR_EraseRootFromParent_Done,
     /* 2250374 */ // Label 30099: @2250374
     /* 2250374 */ GIM_Try, /*On fail goto*//*Label 30100*/ GIMT_Encode4(2250422), // Rule ID 48559 //
     /* 2250379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250385 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250392 */   // MIs[0] Operand 1
     /* 2250392 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250401 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250405 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2250408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250410 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250412 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250420 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250421 */   // GIR_Coverage, 48559,
     /* 2250421 */   GIR_EraseRootFromParent_Done,
     /* 2250422 */ // Label 30100: @2250422
     /* 2250422 */ GIM_Try, /*On fail goto*//*Label 30101*/ GIMT_Encode4(2250470), // Rule ID 48580 //
     /* 2250427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250433 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250440 */   // MIs[0] Operand 1
     /* 2250440 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250449 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250453 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2250456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250458 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250460 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250468 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250469 */   // GIR_Coverage, 48580,
     /* 2250469 */   GIR_EraseRootFromParent_Done,
     /* 2250470 */ // Label 30101: @2250470
     /* 2250470 */ GIM_Try, /*On fail goto*//*Label 30102*/ GIMT_Encode4(2250518), // Rule ID 48581 //
     /* 2250475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250481 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250488 */   // MIs[0] Operand 1
     /* 2250488 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250497 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250501 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2250504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250506 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250508 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250516 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250517 */   // GIR_Coverage, 48581,
     /* 2250517 */   GIR_EraseRootFromParent_Done,
     /* 2250518 */ // Label 30102: @2250518
     /* 2250518 */ GIM_Try, /*On fail goto*//*Label 30103*/ GIMT_Encode4(2250566), // Rule ID 48588 //
     /* 2250523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250529 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250536 */   // MIs[0] Operand 1
     /* 2250536 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250545 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250549 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250554 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250556 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250564 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250565 */   // GIR_Coverage, 48588,
     /* 2250565 */   GIR_EraseRootFromParent_Done,
     /* 2250566 */ // Label 30103: @2250566
     /* 2250566 */ GIM_Try, /*On fail goto*//*Label 30104*/ GIMT_Encode4(2250614), // Rule ID 48589 //
     /* 2250571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250577 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250584 */   // MIs[0] Operand 1
     /* 2250584 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250593 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250597 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250602 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250604 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250612 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250613 */   // GIR_Coverage, 48589,
     /* 2250613 */   GIR_EraseRootFromParent_Done,
     /* 2250614 */ // Label 30104: @2250614
     /* 2250614 */ GIM_Try, /*On fail goto*//*Label 30105*/ GIMT_Encode4(2250662), // Rule ID 48594 //
     /* 2250619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250625 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250632 */   // MIs[0] Operand 1
     /* 2250632 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250641 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250645 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250650 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250652 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250660 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250661 */   // GIR_Coverage, 48594,
     /* 2250661 */   GIR_EraseRootFromParent_Done,
     /* 2250662 */ // Label 30105: @2250662
     /* 2250662 */ GIM_Try, /*On fail goto*//*Label 30106*/ GIMT_Encode4(2250710), // Rule ID 48595 //
     /* 2250667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250673 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250680 */   // MIs[0] Operand 1
     /* 2250680 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250689 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250693 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250698 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250700 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250708 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250709 */   // GIR_Coverage, 48595,
     /* 2250709 */   GIR_EraseRootFromParent_Done,
     /* 2250710 */ // Label 30106: @2250710
     /* 2250710 */ GIM_Try, /*On fail goto*//*Label 30107*/ GIMT_Encode4(2250758), // Rule ID 48602 //
     /* 2250715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250721 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250728 */   // MIs[0] Operand 1
     /* 2250728 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250733 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250737 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250741 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250746 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250748 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250756 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250757 */   // GIR_Coverage, 48602,
     /* 2250757 */   GIR_EraseRootFromParent_Done,
     /* 2250758 */ // Label 30107: @2250758
     /* 2250758 */ GIM_Try, /*On fail goto*//*Label 30108*/ GIMT_Encode4(2250806), // Rule ID 48603 //
     /* 2250763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250769 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250776 */   // MIs[0] Operand 1
     /* 2250776 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250785 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250789 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250794 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250796 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250804 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250805 */   // GIR_Coverage, 48603,
     /* 2250805 */   GIR_EraseRootFromParent_Done,
     /* 2250806 */ // Label 30108: @2250806
     /* 2250806 */ GIM_Try, /*On fail goto*//*Label 30109*/ GIMT_Encode4(2250854), // Rule ID 48624 //
     /* 2250811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250817 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250824 */   // MIs[0] Operand 1
     /* 2250824 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250833 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250837 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2250840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250842 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250844 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250852 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250853 */   // GIR_Coverage, 48624,
     /* 2250853 */   GIR_EraseRootFromParent_Done,
     /* 2250854 */ // Label 30109: @2250854
     /* 2250854 */ GIM_Try, /*On fail goto*//*Label 30110*/ GIMT_Encode4(2250902), // Rule ID 48625 //
     /* 2250859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250865 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250872 */   // MIs[0] Operand 1
     /* 2250872 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250881 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250885 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2250888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250890 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250892 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250900 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250901 */   // GIR_Coverage, 48625,
     /* 2250901 */   GIR_EraseRootFromParent_Done,
     /* 2250902 */ // Label 30110: @2250902
     /* 2250902 */ GIM_Try, /*On fail goto*//*Label 30111*/ GIMT_Encode4(2250950), // Rule ID 48630 //
     /* 2250907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250913 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250920 */   // MIs[0] Operand 1
     /* 2250920 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250929 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250933 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250938 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250940 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250948 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250949 */   // GIR_Coverage, 48630,
     /* 2250949 */   GIR_EraseRootFromParent_Done,
     /* 2250950 */ // Label 30111: @2250950
     /* 2250950 */ GIM_Try, /*On fail goto*//*Label 30112*/ GIMT_Encode4(2250998), // Rule ID 48631 //
     /* 2250955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250961 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250968 */   // MIs[0] Operand 1
     /* 2250968 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250977 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250981 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250986 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250988 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250997 */   // GIR_Coverage, 48631,
     /* 2250997 */   GIR_EraseRootFromParent_Done,
     /* 2250998 */ // Label 30112: @2250998
     /* 2250998 */ GIM_Try, /*On fail goto*//*Label 30113*/ GIMT_Encode4(2251046), // Rule ID 48636 //
     /* 2251003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251009 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251016 */   // MIs[0] Operand 1
     /* 2251016 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251025 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251029 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2251032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251034 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251036 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251045 */   // GIR_Coverage, 48636,
     /* 2251045 */   GIR_EraseRootFromParent_Done,
     /* 2251046 */ // Label 30113: @2251046
     /* 2251046 */ GIM_Try, /*On fail goto*//*Label 30114*/ GIMT_Encode4(2251094), // Rule ID 48637 //
     /* 2251051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251057 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251064 */   // MIs[0] Operand 1
     /* 2251064 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251073 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251077 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2251080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251082 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251084 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251092 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251093 */   // GIR_Coverage, 48637,
     /* 2251093 */   GIR_EraseRootFromParent_Done,
     /* 2251094 */ // Label 30114: @2251094
     /* 2251094 */ GIM_Try, /*On fail goto*//*Label 30115*/ GIMT_Encode4(2251142), // Rule ID 48644 //
     /* 2251099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251105 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251112 */   // MIs[0] Operand 1
     /* 2251112 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251121 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251125 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2251128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251130 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251132 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251141 */   // GIR_Coverage, 48644,
     /* 2251141 */   GIR_EraseRootFromParent_Done,
     /* 2251142 */ // Label 30115: @2251142
     /* 2251142 */ GIM_Try, /*On fail goto*//*Label 30116*/ GIMT_Encode4(2251190), // Rule ID 48645 //
     /* 2251147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251153 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251160 */   // MIs[0] Operand 1
     /* 2251160 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251169 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251173 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2251176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251178 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251180 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251188 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251189 */   // GIR_Coverage, 48645,
     /* 2251189 */   GIR_EraseRootFromParent_Done,
     /* 2251190 */ // Label 30116: @2251190
     /* 2251190 */ GIM_Try, /*On fail goto*//*Label 30117*/ GIMT_Encode4(2251238), // Rule ID 48666 //
     /* 2251195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251201 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251208 */   // MIs[0] Operand 1
     /* 2251208 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251217 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251221 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2251224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251226 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251228 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251236 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251237 */   // GIR_Coverage, 48666,
     /* 2251237 */   GIR_EraseRootFromParent_Done,
     /* 2251238 */ // Label 30117: @2251238
     /* 2251238 */ GIM_Try, /*On fail goto*//*Label 30118*/ GIMT_Encode4(2251286), // Rule ID 48667 //
     /* 2251243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251249 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251256 */   // MIs[0] Operand 1
     /* 2251256 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251265 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251269 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2251272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251274 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251276 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251284 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251285 */   // GIR_Coverage, 48667,
     /* 2251285 */   GIR_EraseRootFromParent_Done,
     /* 2251286 */ // Label 30118: @2251286
     /* 2251286 */ GIM_Try, /*On fail goto*//*Label 30119*/ GIMT_Encode4(2251334), // Rule ID 48674 //
     /* 2251291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251304 */   // MIs[0] Operand 1
     /* 2251304 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251313 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251317 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2251320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251322 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251324 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251332 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251333 */   // GIR_Coverage, 48674,
     /* 2251333 */   GIR_EraseRootFromParent_Done,
     /* 2251334 */ // Label 30119: @2251334
     /* 2251334 */ GIM_Try, /*On fail goto*//*Label 30120*/ GIMT_Encode4(2251382), // Rule ID 48675 //
     /* 2251339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251345 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251352 */   // MIs[0] Operand 1
     /* 2251352 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251361 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251365 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2251368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251370 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251372 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251380 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251381 */   // GIR_Coverage, 48675,
     /* 2251381 */   GIR_EraseRootFromParent_Done,
     /* 2251382 */ // Label 30120: @2251382
     /* 2251382 */ GIM_Try, /*On fail goto*//*Label 30121*/ GIMT_Encode4(2251430), // Rule ID 48680 //
     /* 2251387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251393 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251400 */   // MIs[0] Operand 1
     /* 2251400 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251409 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251413 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251418 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251420 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251428 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251429 */   // GIR_Coverage, 48680,
     /* 2251429 */   GIR_EraseRootFromParent_Done,
     /* 2251430 */ // Label 30121: @2251430
     /* 2251430 */ GIM_Try, /*On fail goto*//*Label 30122*/ GIMT_Encode4(2251478), // Rule ID 48681 //
     /* 2251435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251448 */   // MIs[0] Operand 1
     /* 2251448 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251457 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251461 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251466 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251468 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251476 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251477 */   // GIR_Coverage, 48681,
     /* 2251477 */   GIR_EraseRootFromParent_Done,
     /* 2251478 */ // Label 30122: @2251478
     /* 2251478 */ GIM_Try, /*On fail goto*//*Label 30123*/ GIMT_Encode4(2251526), // Rule ID 48688 //
     /* 2251483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251489 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251496 */   // MIs[0] Operand 1
     /* 2251496 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251505 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251509 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251514 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251516 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251524 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251525 */   // GIR_Coverage, 48688,
     /* 2251525 */   GIR_EraseRootFromParent_Done,
     /* 2251526 */ // Label 30123: @2251526
     /* 2251526 */ GIM_Try, /*On fail goto*//*Label 30124*/ GIMT_Encode4(2251574), // Rule ID 48689 //
     /* 2251531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251544 */   // MIs[0] Operand 1
     /* 2251544 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251553 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251557 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251562 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251564 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251572 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251573 */   // GIR_Coverage, 48689,
     /* 2251573 */   GIR_EraseRootFromParent_Done,
     /* 2251574 */ // Label 30124: @2251574
     /* 2251574 */ GIM_Try, /*On fail goto*//*Label 30125*/ GIMT_Encode4(2251622), // Rule ID 48710 //
     /* 2251579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251585 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251592 */   // MIs[0] Operand 1
     /* 2251592 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251597 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251601 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251605 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251610 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251612 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251620 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251621 */   // GIR_Coverage, 48710,
     /* 2251621 */   GIR_EraseRootFromParent_Done,
     /* 2251622 */ // Label 30125: @2251622
     /* 2251622 */ GIM_Try, /*On fail goto*//*Label 30126*/ GIMT_Encode4(2251670), // Rule ID 48711 //
     /* 2251627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251633 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251640 */   // MIs[0] Operand 1
     /* 2251640 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251649 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251653 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251658 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251660 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251668 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251669 */   // GIR_Coverage, 48711,
     /* 2251669 */   GIR_EraseRootFromParent_Done,
     /* 2251670 */ // Label 30126: @2251670
     /* 2251670 */ GIM_Try, /*On fail goto*//*Label 30127*/ GIMT_Encode4(2251718), // Rule ID 48718 //
     /* 2251675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251681 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251688 */   // MIs[0] Operand 1
     /* 2251688 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251697 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251701 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2251704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251706 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251708 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251716 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251717 */   // GIR_Coverage, 48718,
     /* 2251717 */   GIR_EraseRootFromParent_Done,
     /* 2251718 */ // Label 30127: @2251718
     /* 2251718 */ GIM_Try, /*On fail goto*//*Label 30128*/ GIMT_Encode4(2251766), // Rule ID 48719 //
     /* 2251723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251729 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251736 */   // MIs[0] Operand 1
     /* 2251736 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251745 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251749 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2251752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251754 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251756 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251765 */   // GIR_Coverage, 48719,
     /* 2251765 */   GIR_EraseRootFromParent_Done,
     /* 2251766 */ // Label 30128: @2251766
     /* 2251766 */ GIM_Try, /*On fail goto*//*Label 30129*/ GIMT_Encode4(2251814), // Rule ID 48724 //
     /* 2251771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251777 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251784 */   // MIs[0] Operand 1
     /* 2251784 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251793 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251797 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251802 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251804 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251812 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251813 */   // GIR_Coverage, 48724,
     /* 2251813 */   GIR_EraseRootFromParent_Done,
     /* 2251814 */ // Label 30129: @2251814
     /* 2251814 */ GIM_Try, /*On fail goto*//*Label 30130*/ GIMT_Encode4(2251862), // Rule ID 48725 //
     /* 2251819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251825 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251832 */   // MIs[0] Operand 1
     /* 2251832 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251837 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251841 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251845 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251850 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251852 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251860 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251861 */   // GIR_Coverage, 48725,
     /* 2251861 */   GIR_EraseRootFromParent_Done,
     /* 2251862 */ // Label 30130: @2251862
     /* 2251862 */ GIM_Try, /*On fail goto*//*Label 30131*/ GIMT_Encode4(2251910), // Rule ID 48732 //
     /* 2251867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251873 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251880 */   // MIs[0] Operand 1
     /* 2251880 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251889 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251893 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251898 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251900 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251908 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251909 */   // GIR_Coverage, 48732,
     /* 2251909 */   GIR_EraseRootFromParent_Done,
     /* 2251910 */ // Label 30131: @2251910
     /* 2251910 */ GIM_Try, /*On fail goto*//*Label 30132*/ GIMT_Encode4(2251958), // Rule ID 48733 //
     /* 2251915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251921 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251928 */   // MIs[0] Operand 1
     /* 2251928 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251937 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251941 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251946 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251948 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251956 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251957 */   // GIR_Coverage, 48733,
     /* 2251957 */   GIR_EraseRootFromParent_Done,
     /* 2251958 */ // Label 30132: @2251958
     /* 2251958 */ GIM_Try, /*On fail goto*//*Label 30133*/ GIMT_Encode4(2252006), // Rule ID 48754 //
     /* 2251963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251969 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251976 */   // MIs[0] Operand 1
     /* 2251976 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251985 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251989 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251994 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251996 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252004 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252005 */   // GIR_Coverage, 48754,
     /* 2252005 */   GIR_EraseRootFromParent_Done,
     /* 2252006 */ // Label 30133: @2252006
     /* 2252006 */ GIM_Try, /*On fail goto*//*Label 30134*/ GIMT_Encode4(2252054), // Rule ID 48755 //
     /* 2252011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252024 */   // MIs[0] Operand 1
     /* 2252024 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2252029 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252033 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252037 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2252037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2252040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252042 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252044 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252053 */   // GIR_Coverage, 48755,
     /* 2252053 */   GIR_EraseRootFromParent_Done,
     /* 2252054 */ // Label 30134: @2252054
     /* 2252054 */ GIM_Try, /*On fail goto*//*Label 30135*/ GIMT_Encode4(2252102), // Rule ID 48762 //
     /* 2252059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252072 */   // MIs[0] Operand 1
     /* 2252072 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252081 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252085 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2252088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252090 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252092 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252100 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252101 */   // GIR_Coverage, 48762,
     /* 2252101 */   GIR_EraseRootFromParent_Done,
     /* 2252102 */ // Label 30135: @2252102
     /* 2252102 */ GIM_Try, /*On fail goto*//*Label 30136*/ GIMT_Encode4(2252150), // Rule ID 48763 //
     /* 2252107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252113 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252120 */   // MIs[0] Operand 1
     /* 2252120 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252129 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252133 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2252136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252138 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252140 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252148 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252149 */   // GIR_Coverage, 48763,
     /* 2252149 */   GIR_EraseRootFromParent_Done,
     /* 2252150 */ // Label 30136: @2252150
     /* 2252150 */ GIM_Try, /*On fail goto*//*Label 30137*/ GIMT_Encode4(2252198), // Rule ID 48768 //
     /* 2252155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252161 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252168 */   // MIs[0] Operand 1
     /* 2252168 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252177 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252181 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2252184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252186 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252188 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252196 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252197 */   // GIR_Coverage, 48768,
     /* 2252197 */   GIR_EraseRootFromParent_Done,
     /* 2252198 */ // Label 30137: @2252198
     /* 2252198 */ GIM_Try, /*On fail goto*//*Label 30138*/ GIMT_Encode4(2252246), // Rule ID 48769 //
     /* 2252203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252209 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252216 */   // MIs[0] Operand 1
     /* 2252216 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252225 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252229 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2252232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252234 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252236 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252245 */   // GIR_Coverage, 48769,
     /* 2252245 */   GIR_EraseRootFromParent_Done,
     /* 2252246 */ // Label 30138: @2252246
     /* 2252246 */ GIM_Try, /*On fail goto*//*Label 30139*/ GIMT_Encode4(2252294), // Rule ID 48776 //
     /* 2252251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252257 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252264 */   // MIs[0] Operand 1
     /* 2252264 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252273 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252277 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2252280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252282 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252284 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252292 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252293 */   // GIR_Coverage, 48776,
     /* 2252293 */   GIR_EraseRootFromParent_Done,
     /* 2252294 */ // Label 30139: @2252294
     /* 2252294 */ GIM_Try, /*On fail goto*//*Label 30140*/ GIMT_Encode4(2252342), // Rule ID 48777 //
     /* 2252299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252305 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252312 */   // MIs[0] Operand 1
     /* 2252312 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252321 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252325 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2252328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252330 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252332 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252341 */   // GIR_Coverage, 48777,
     /* 2252341 */   GIR_EraseRootFromParent_Done,
     /* 2252342 */ // Label 30140: @2252342
     /* 2252342 */ GIM_Try, /*On fail goto*//*Label 30141*/ GIMT_Encode4(2252390), // Rule ID 48798 //
     /* 2252347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2252350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252353 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252360 */   // MIs[0] Operand 1
     /* 2252360 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252365 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252369 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252373 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2252373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252378 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252380 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252389 */   // GIR_Coverage, 48798,
     /* 2252389 */   GIR_EraseRootFromParent_Done,
     /* 2252390 */ // Label 30141: @2252390
     /* 2252390 */ GIM_Try, /*On fail goto*//*Label 30142*/ GIMT_Encode4(2252438), // Rule ID 48799 //
     /* 2252395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252401 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252408 */   // MIs[0] Operand 1
     /* 2252408 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252417 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252421 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2252421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252426 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252428 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252437 */   // GIR_Coverage, 48799,
     /* 2252437 */   GIR_EraseRootFromParent_Done,
     /* 2252438 */ // Label 30142: @2252438
     /* 2252438 */ GIM_Try, /*On fail goto*//*Label 30143*/ GIMT_Encode4(2252486), // Rule ID 48806 //
     /* 2252443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252456 */   // MIs[0] Operand 1
     /* 2252456 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252465 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252469 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2252472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252474 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252476 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252484 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252485 */   // GIR_Coverage, 48806,
     /* 2252485 */   GIR_EraseRootFromParent_Done,
     /* 2252486 */ // Label 30143: @2252486
     /* 2252486 */ GIM_Try, /*On fail goto*//*Label 30144*/ GIMT_Encode4(2252534), // Rule ID 48807 //
     /* 2252491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252497 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252504 */   // MIs[0] Operand 1
     /* 2252504 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252513 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252517 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2252520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252522 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252524 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252533 */   // GIR_Coverage, 48807,
     /* 2252533 */   GIR_EraseRootFromParent_Done,
     /* 2252534 */ // Label 30144: @2252534
     /* 2252534 */ GIM_Try, /*On fail goto*//*Label 30145*/ GIMT_Encode4(2252582), // Rule ID 48812 //
     /* 2252539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252552 */   // MIs[0] Operand 1
     /* 2252552 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252561 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252565 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2252568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252570 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252572 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252580 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252581 */   // GIR_Coverage, 48812,
     /* 2252581 */   GIR_EraseRootFromParent_Done,
     /* 2252582 */ // Label 30145: @2252582
     /* 2252582 */ GIM_Try, /*On fail goto*//*Label 30146*/ GIMT_Encode4(2252630), // Rule ID 48813 //
     /* 2252587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252593 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252600 */   // MIs[0] Operand 1
     /* 2252600 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252609 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252613 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2252616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252618 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252620 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252628 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252629 */   // GIR_Coverage, 48813,
     /* 2252629 */   GIR_EraseRootFromParent_Done,
     /* 2252630 */ // Label 30146: @2252630
     /* 2252630 */ GIM_Try, /*On fail goto*//*Label 30147*/ GIMT_Encode4(2252678), // Rule ID 48820 //
     /* 2252635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252641 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252648 */   // MIs[0] Operand 1
     /* 2252648 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252657 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252661 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2252664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252666 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252668 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252677 */   // GIR_Coverage, 48820,
     /* 2252677 */   GIR_EraseRootFromParent_Done,
     /* 2252678 */ // Label 30147: @2252678
     /* 2252678 */ GIM_Try, /*On fail goto*//*Label 30148*/ GIMT_Encode4(2252726), // Rule ID 48821 //
     /* 2252683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252689 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252696 */   // MIs[0] Operand 1
     /* 2252696 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252705 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252709 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2252712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252714 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252716 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252724 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252725 */   // GIR_Coverage, 48821,
     /* 2252725 */   GIR_EraseRootFromParent_Done,
     /* 2252726 */ // Label 30148: @2252726
     /* 2252726 */ GIM_Try, /*On fail goto*//*Label 30149*/ GIMT_Encode4(2252774), // Rule ID 48842 //
     /* 2252731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2252734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252737 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252744 */   // MIs[0] Operand 1
     /* 2252744 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252753 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252757 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2252757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252762 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252764 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252773 */   // GIR_Coverage, 48842,
     /* 2252773 */   GIR_EraseRootFromParent_Done,
     /* 2252774 */ // Label 30149: @2252774
     /* 2252774 */ GIM_Try, /*On fail goto*//*Label 30150*/ GIMT_Encode4(2252822), // Rule ID 48843 //
     /* 2252779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252785 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252792 */   // MIs[0] Operand 1
     /* 2252792 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252801 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252805 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2252805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252810 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252812 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252820 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252821 */   // GIR_Coverage, 48843,
     /* 2252821 */   GIR_EraseRootFromParent_Done,
     /* 2252822 */ // Label 30150: @2252822
     /* 2252822 */ GIM_Try, /*On fail goto*//*Label 30151*/ GIMT_Encode4(2252870), // Rule ID 48850 //
     /* 2252827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252833 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252840 */   // MIs[0] Operand 1
     /* 2252840 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252849 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252853 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252858 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252860 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252868 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252869 */   // GIR_Coverage, 48850,
     /* 2252869 */   GIR_EraseRootFromParent_Done,
     /* 2252870 */ // Label 30151: @2252870
     /* 2252870 */ GIM_Try, /*On fail goto*//*Label 30152*/ GIMT_Encode4(2252918), // Rule ID 48851 //
     /* 2252875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252881 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252888 */   // MIs[0] Operand 1
     /* 2252888 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252897 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252901 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252906 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252908 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252917 */   // GIR_Coverage, 48851,
     /* 2252917 */   GIR_EraseRootFromParent_Done,
     /* 2252918 */ // Label 30152: @2252918
     /* 2252918 */ GIM_Try, /*On fail goto*//*Label 30153*/ GIMT_Encode4(2252966), // Rule ID 48856 //
     /* 2252923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252929 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252936 */   // MIs[0] Operand 1
     /* 2252936 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252945 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252949 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252954 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252956 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252964 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252965 */   // GIR_Coverage, 48856,
     /* 2252965 */   GIR_EraseRootFromParent_Done,
     /* 2252966 */ // Label 30153: @2252966
     /* 2252966 */ GIM_Try, /*On fail goto*//*Label 30154*/ GIMT_Encode4(2253014), // Rule ID 48857 //
     /* 2252971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252977 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252984 */   // MIs[0] Operand 1
     /* 2252984 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252993 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252997 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2253000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253002 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253004 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253013 */   // GIR_Coverage, 48857,
     /* 2253013 */   GIR_EraseRootFromParent_Done,
     /* 2253014 */ // Label 30154: @2253014
     /* 2253014 */ GIM_Try, /*On fail goto*//*Label 30155*/ GIMT_Encode4(2253062), // Rule ID 48864 //
     /* 2253019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2253028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253032 */   // MIs[0] Operand 1
     /* 2253032 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253041 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253045 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2253048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253050 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253052 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253061 */   // GIR_Coverage, 48864,
     /* 2253061 */   GIR_EraseRootFromParent_Done,
     /* 2253062 */ // Label 30155: @2253062
     /* 2253062 */ GIM_Try, /*On fail goto*//*Label 30156*/ GIMT_Encode4(2253110), // Rule ID 48865 //
     /* 2253067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253073 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2253076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253080 */   // MIs[0] Operand 1
     /* 2253080 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253089 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253093 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2253096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253098 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253100 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253108 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253109 */   // GIR_Coverage, 48865,
     /* 2253109 */   GIR_EraseRootFromParent_Done,
     /* 2253110 */ // Label 30156: @2253110
     /* 2253110 */ GIM_Try, /*On fail goto*//*Label 30157*/ GIMT_Encode4(2253158), // Rule ID 48886 //
     /* 2253115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253121 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253128 */   // MIs[0] Operand 1
     /* 2253128 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253137 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253141 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253146 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253148 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253157 */   // GIR_Coverage, 48886,
     /* 2253157 */   GIR_EraseRootFromParent_Done,
     /* 2253158 */ // Label 30157: @2253158
     /* 2253158 */ GIM_Try, /*On fail goto*//*Label 30158*/ GIMT_Encode4(2253206), // Rule ID 48887 //
     /* 2253163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253169 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253176 */   // MIs[0] Operand 1
     /* 2253176 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253185 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253189 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253194 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253196 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253204 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253205 */   // GIR_Coverage, 48887,
     /* 2253205 */   GIR_EraseRootFromParent_Done,
     /* 2253206 */ // Label 30158: @2253206
     /* 2253206 */ GIM_Try, /*On fail goto*//*Label 30159*/ GIMT_Encode4(2253254), // Rule ID 48894 //
     /* 2253211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2253217 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2253220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253224 */   // MIs[0] Operand 1
     /* 2253224 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253233 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253237 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2253240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253242 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253244 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253253 */   // GIR_Coverage, 48894,
     /* 2253253 */   GIR_EraseRootFromParent_Done,
     /* 2253254 */ // Label 30159: @2253254
     /* 2253254 */ GIM_Try, /*On fail goto*//*Label 30160*/ GIMT_Encode4(2253302), // Rule ID 48895 //
     /* 2253259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2253265 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2253268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253272 */   // MIs[0] Operand 1
     /* 2253272 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253281 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253285 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2253288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253290 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253292 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253300 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253301 */   // GIR_Coverage, 48895,
     /* 2253301 */   GIR_EraseRootFromParent_Done,
     /* 2253302 */ // Label 30160: @2253302
     /* 2253302 */ GIM_Try, /*On fail goto*//*Label 30161*/ GIMT_Encode4(2253350), // Rule ID 48900 //
     /* 2253307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2253313 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2253316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253320 */   // MIs[0] Operand 1
     /* 2253320 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253329 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253333 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2253336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253338 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253340 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253349 */   // GIR_Coverage, 48900,
     /* 2253349 */   GIR_EraseRootFromParent_Done,
     /* 2253350 */ // Label 30161: @2253350
     /* 2253350 */ GIM_Try, /*On fail goto*//*Label 30162*/ GIMT_Encode4(2253398), // Rule ID 48901 //
     /* 2253355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2253361 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2253364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253368 */   // MIs[0] Operand 1
     /* 2253368 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253377 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253381 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2253384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253386 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253388 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253397 */   // GIR_Coverage, 48901,
     /* 2253397 */   GIR_EraseRootFromParent_Done,
     /* 2253398 */ // Label 30162: @2253398
     /* 2253398 */ GIM_Try, /*On fail goto*//*Label 30163*/ GIMT_Encode4(2253446), // Rule ID 48908 //
     /* 2253403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253409 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2253412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253416 */   // MIs[0] Operand 1
     /* 2253416 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253425 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253429 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2253432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253434 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253436 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253445 */   // GIR_Coverage, 48908,
     /* 2253445 */   GIR_EraseRootFromParent_Done,
     /* 2253446 */ // Label 30163: @2253446
     /* 2253446 */ GIM_Try, /*On fail goto*//*Label 30164*/ GIMT_Encode4(2253494), // Rule ID 48909 //
     /* 2253451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2253460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253464 */   // MIs[0] Operand 1
     /* 2253464 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253473 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253477 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2253480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253482 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253484 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253493 */   // GIR_Coverage, 48909,
     /* 2253493 */   GIR_EraseRootFromParent_Done,
     /* 2253494 */ // Label 30164: @2253494
     /* 2253494 */ GIM_Try, /*On fail goto*//*Label 30165*/ GIMT_Encode4(2253542), // Rule ID 48930 //
     /* 2253499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253505 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253512 */   // MIs[0] Operand 1
     /* 2253512 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253521 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253525 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253530 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253532 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253540 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253541 */   // GIR_Coverage, 48930,
     /* 2253541 */   GIR_EraseRootFromParent_Done,
     /* 2253542 */ // Label 30165: @2253542
     /* 2253542 */ GIM_Try, /*On fail goto*//*Label 30166*/ GIMT_Encode4(2253590), // Rule ID 48931 //
     /* 2253547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253560 */   // MIs[0] Operand 1
     /* 2253560 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253569 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253573 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253578 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253580 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253589 */   // GIR_Coverage, 48931,
     /* 2253589 */   GIR_EraseRootFromParent_Done,
     /* 2253590 */ // Label 30166: @2253590
     /* 2253590 */ GIM_Reject,
     /* 2253591 */ // Label 29903: @2253591
     /* 2253591 */ GIM_Try, /*On fail goto*//*Label 30167*/ GIMT_Encode4(2253639), // Rule ID 48502 //
     /* 2253596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253602 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253609 */   // MIs[0] Operand 1
     /* 2253609 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253618 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253622 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2253625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253627 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253629 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253637 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253638 */   // GIR_Coverage, 48502,
     /* 2253638 */   GIR_EraseRootFromParent_Done,
     /* 2253639 */ // Label 30167: @2253639
     /* 2253639 */ GIM_Try, /*On fail goto*//*Label 30168*/ GIMT_Encode4(2253687), // Rule ID 48503 //
     /* 2253644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253650 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253657 */   // MIs[0] Operand 1
     /* 2253657 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253666 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253670 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2253673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253675 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253677 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253686 */   // GIR_Coverage, 48503,
     /* 2253686 */   GIR_EraseRootFromParent_Done,
     /* 2253687 */ // Label 30168: @2253687
     /* 2253687 */ GIM_Try, /*On fail goto*//*Label 30169*/ GIMT_Encode4(2253735), // Rule ID 48512 //
     /* 2253692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253698 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253705 */   // MIs[0] Operand 1
     /* 2253705 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253714 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253718 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2253721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253723 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253725 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253734 */   // GIR_Coverage, 48512,
     /* 2253734 */   GIR_EraseRootFromParent_Done,
     /* 2253735 */ // Label 30169: @2253735
     /* 2253735 */ GIM_Try, /*On fail goto*//*Label 30170*/ GIMT_Encode4(2253783), // Rule ID 48513 //
     /* 2253740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253746 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253753 */   // MIs[0] Operand 1
     /* 2253753 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253762 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253766 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2253769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253771 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253773 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253781 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253782 */   // GIR_Coverage, 48513,
     /* 2253782 */   GIR_EraseRootFromParent_Done,
     /* 2253783 */ // Label 30170: @2253783
     /* 2253783 */ GIM_Try, /*On fail goto*//*Label 30171*/ GIMT_Encode4(2253831), // Rule ID 48530 //
     /* 2253788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2253794 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2253797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253801 */   // MIs[0] Operand 1
     /* 2253801 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253810 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253814 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2253817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253819 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253821 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253830 */   // GIR_Coverage, 48530,
     /* 2253830 */   GIR_EraseRootFromParent_Done,
     /* 2253831 */ // Label 30171: @2253831
     /* 2253831 */ GIM_Try, /*On fail goto*//*Label 30172*/ GIMT_Encode4(2253879), // Rule ID 48531 //
     /* 2253836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2253842 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2253845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253849 */   // MIs[0] Operand 1
     /* 2253849 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253858 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253862 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2253865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253867 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253869 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253878 */   // GIR_Coverage, 48531,
     /* 2253878 */   GIR_EraseRootFromParent_Done,
     /* 2253879 */ // Label 30172: @2253879
     /* 2253879 */ GIM_Try, /*On fail goto*//*Label 30173*/ GIMT_Encode4(2253927), // Rule ID 48538 //
     /* 2253884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253890 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253897 */   // MIs[0] Operand 1
     /* 2253897 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253906 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253910 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2253913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253915 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253917 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253925 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253926 */   // GIR_Coverage, 48538,
     /* 2253926 */   GIR_EraseRootFromParent_Done,
     /* 2253927 */ // Label 30173: @2253927
     /* 2253927 */ GIM_Try, /*On fail goto*//*Label 30174*/ GIMT_Encode4(2253975), // Rule ID 48539 //
     /* 2253932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253945 */   // MIs[0] Operand 1
     /* 2253945 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253954 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253958 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2253961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253963 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253965 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253974 */   // GIR_Coverage, 48539,
     /* 2253974 */   GIR_EraseRootFromParent_Done,
     /* 2253975 */ // Label 30174: @2253975
     /* 2253975 */ GIM_Try, /*On fail goto*//*Label 30175*/ GIMT_Encode4(2254023), // Rule ID 48546 //
     /* 2253980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253993 */   // MIs[0] Operand 1
     /* 2253993 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254002 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254006 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2254009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254011 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254013 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254022 */   // GIR_Coverage, 48546,
     /* 2254022 */   GIR_EraseRootFromParent_Done,
     /* 2254023 */ // Label 30175: @2254023
     /* 2254023 */ GIM_Try, /*On fail goto*//*Label 30176*/ GIMT_Encode4(2254071), // Rule ID 48547 //
     /* 2254028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254034 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254041 */   // MIs[0] Operand 1
     /* 2254041 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254050 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254054 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2254057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254059 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254061 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254069 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254070 */   // GIR_Coverage, 48547,
     /* 2254070 */   GIR_EraseRootFromParent_Done,
     /* 2254071 */ // Label 30176: @2254071
     /* 2254071 */ GIM_Try, /*On fail goto*//*Label 30177*/ GIMT_Encode4(2254119), // Rule ID 48556 //
     /* 2254076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254082 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254089 */   // MIs[0] Operand 1
     /* 2254089 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254098 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254102 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2254105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254107 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254109 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254118 */   // GIR_Coverage, 48556,
     /* 2254118 */   GIR_EraseRootFromParent_Done,
     /* 2254119 */ // Label 30177: @2254119
     /* 2254119 */ GIM_Try, /*On fail goto*//*Label 30178*/ GIMT_Encode4(2254167), // Rule ID 48557 //
     /* 2254124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254130 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254137 */   // MIs[0] Operand 1
     /* 2254137 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254146 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254150 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2254153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254155 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254157 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254166 */   // GIR_Coverage, 48557,
     /* 2254166 */   GIR_EraseRootFromParent_Done,
     /* 2254167 */ // Label 30178: @2254167
     /* 2254167 */ GIM_Try, /*On fail goto*//*Label 30179*/ GIMT_Encode4(2254215), // Rule ID 48574 //
     /* 2254172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254178 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254185 */   // MIs[0] Operand 1
     /* 2254185 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254194 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254198 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2254201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254203 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254205 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254213 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254214 */   // GIR_Coverage, 48574,
     /* 2254214 */   GIR_EraseRootFromParent_Done,
     /* 2254215 */ // Label 30179: @2254215
     /* 2254215 */ GIM_Try, /*On fail goto*//*Label 30180*/ GIMT_Encode4(2254263), // Rule ID 48575 //
     /* 2254220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254226 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254233 */   // MIs[0] Operand 1
     /* 2254233 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254242 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254246 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2254249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254251 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254253 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254261 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254262 */   // GIR_Coverage, 48575,
     /* 2254262 */   GIR_EraseRootFromParent_Done,
     /* 2254263 */ // Label 30180: @2254263
     /* 2254263 */ GIM_Try, /*On fail goto*//*Label 30181*/ GIMT_Encode4(2254311), // Rule ID 48582 //
     /* 2254268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254274 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254281 */   // MIs[0] Operand 1
     /* 2254281 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254290 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254294 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2254297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254299 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254301 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254309 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254310 */   // GIR_Coverage, 48582,
     /* 2254310 */   GIR_EraseRootFromParent_Done,
     /* 2254311 */ // Label 30181: @2254311
     /* 2254311 */ GIM_Try, /*On fail goto*//*Label 30182*/ GIMT_Encode4(2254359), // Rule ID 48583 //
     /* 2254316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254329 */   // MIs[0] Operand 1
     /* 2254329 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254338 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254342 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2254345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254347 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254349 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254357 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254358 */   // GIR_Coverage, 48583,
     /* 2254358 */   GIR_EraseRootFromParent_Done,
     /* 2254359 */ // Label 30182: @2254359
     /* 2254359 */ GIM_Try, /*On fail goto*//*Label 30183*/ GIMT_Encode4(2254407), // Rule ID 48590 //
     /* 2254364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254377 */   // MIs[0] Operand 1
     /* 2254377 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254386 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254390 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2254393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254397 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254405 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254406 */   // GIR_Coverage, 48590,
     /* 2254406 */   GIR_EraseRootFromParent_Done,
     /* 2254407 */ // Label 30183: @2254407
     /* 2254407 */ GIM_Try, /*On fail goto*//*Label 30184*/ GIMT_Encode4(2254455), // Rule ID 48591 //
     /* 2254412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254418 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254425 */   // MIs[0] Operand 1
     /* 2254425 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254434 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254438 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2254441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254443 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254445 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254454 */   // GIR_Coverage, 48591,
     /* 2254454 */   GIR_EraseRootFromParent_Done,
     /* 2254455 */ // Label 30184: @2254455
     /* 2254455 */ GIM_Try, /*On fail goto*//*Label 30185*/ GIMT_Encode4(2254503), // Rule ID 48600 //
     /* 2254460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254466 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254473 */   // MIs[0] Operand 1
     /* 2254473 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254482 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254486 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254491 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254493 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254501 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254502 */   // GIR_Coverage, 48600,
     /* 2254502 */   GIR_EraseRootFromParent_Done,
     /* 2254503 */ // Label 30185: @2254503
     /* 2254503 */ GIM_Try, /*On fail goto*//*Label 30186*/ GIMT_Encode4(2254551), // Rule ID 48601 //
     /* 2254508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254514 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254521 */   // MIs[0] Operand 1
     /* 2254521 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254530 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254534 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254539 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254541 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254549 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254550 */   // GIR_Coverage, 48601,
     /* 2254550 */   GIR_EraseRootFromParent_Done,
     /* 2254551 */ // Label 30186: @2254551
     /* 2254551 */ GIM_Try, /*On fail goto*//*Label 30187*/ GIMT_Encode4(2254599), // Rule ID 48618 //
     /* 2254556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254562 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254569 */   // MIs[0] Operand 1
     /* 2254569 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254578 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254582 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254587 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254589 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254597 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254598 */   // GIR_Coverage, 48618,
     /* 2254598 */   GIR_EraseRootFromParent_Done,
     /* 2254599 */ // Label 30187: @2254599
     /* 2254599 */ GIM_Try, /*On fail goto*//*Label 30188*/ GIMT_Encode4(2254647), // Rule ID 48619 //
     /* 2254604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254617 */   // MIs[0] Operand 1
     /* 2254617 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254626 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254630 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254635 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254637 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254645 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254646 */   // GIR_Coverage, 48619,
     /* 2254646 */   GIR_EraseRootFromParent_Done,
     /* 2254647 */ // Label 30188: @2254647
     /* 2254647 */ GIM_Try, /*On fail goto*//*Label 30189*/ GIMT_Encode4(2254695), // Rule ID 48626 //
     /* 2254652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254658 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254665 */   // MIs[0] Operand 1
     /* 2254665 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254674 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254678 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254683 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254685 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254694 */   // GIR_Coverage, 48626,
     /* 2254694 */   GIR_EraseRootFromParent_Done,
     /* 2254695 */ // Label 30189: @2254695
     /* 2254695 */ GIM_Try, /*On fail goto*//*Label 30190*/ GIMT_Encode4(2254743), // Rule ID 48627 //
     /* 2254700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254706 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254713 */   // MIs[0] Operand 1
     /* 2254713 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254722 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254726 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254731 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254733 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254741 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254742 */   // GIR_Coverage, 48627,
     /* 2254742 */   GIR_EraseRootFromParent_Done,
     /* 2254743 */ // Label 30190: @2254743
     /* 2254743 */ GIM_Try, /*On fail goto*//*Label 30191*/ GIMT_Encode4(2254791), // Rule ID 48632 //
     /* 2254748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254754 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254761 */   // MIs[0] Operand 1
     /* 2254761 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254770 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254774 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2254777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254779 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254781 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254789 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254790 */   // GIR_Coverage, 48632,
     /* 2254790 */   GIR_EraseRootFromParent_Done,
     /* 2254791 */ // Label 30191: @2254791
     /* 2254791 */ GIM_Try, /*On fail goto*//*Label 30192*/ GIMT_Encode4(2254839), // Rule ID 48633 //
     /* 2254796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254802 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254809 */   // MIs[0] Operand 1
     /* 2254809 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254818 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254822 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2254825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254827 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254829 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254837 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254838 */   // GIR_Coverage, 48633,
     /* 2254838 */   GIR_EraseRootFromParent_Done,
     /* 2254839 */ // Label 30192: @2254839
     /* 2254839 */ GIM_Try, /*On fail goto*//*Label 30193*/ GIMT_Encode4(2254887), // Rule ID 48642 //
     /* 2254844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254850 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254857 */   // MIs[0] Operand 1
     /* 2254857 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254866 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254870 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254875 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254877 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254885 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254886 */   // GIR_Coverage, 48642,
     /* 2254886 */   GIR_EraseRootFromParent_Done,
     /* 2254887 */ // Label 30193: @2254887
     /* 2254887 */ GIM_Try, /*On fail goto*//*Label 30194*/ GIMT_Encode4(2254935), // Rule ID 48643 //
     /* 2254892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254898 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254905 */   // MIs[0] Operand 1
     /* 2254905 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254914 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254918 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254923 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254925 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254933 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254934 */   // GIR_Coverage, 48643,
     /* 2254934 */   GIR_EraseRootFromParent_Done,
     /* 2254935 */ // Label 30194: @2254935
     /* 2254935 */ GIM_Try, /*On fail goto*//*Label 30195*/ GIMT_Encode4(2254983), // Rule ID 48660 //
     /* 2254940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254946 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254953 */   // MIs[0] Operand 1
     /* 2254953 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254962 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254966 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254971 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254973 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254981 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254982 */   // GIR_Coverage, 48660,
     /* 2254982 */   GIR_EraseRootFromParent_Done,
     /* 2254983 */ // Label 30195: @2254983
     /* 2254983 */ GIM_Try, /*On fail goto*//*Label 30196*/ GIMT_Encode4(2255031), // Rule ID 48661 //
     /* 2254988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254994 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255001 */   // MIs[0] Operand 1
     /* 2255001 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2255006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255010 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255014 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2255017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255019 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255021 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255030 */   // GIR_Coverage, 48661,
     /* 2255030 */   GIR_EraseRootFromParent_Done,
     /* 2255031 */ // Label 30196: @2255031
     /* 2255031 */ GIM_Try, /*On fail goto*//*Label 30197*/ GIMT_Encode4(2255079), // Rule ID 48668 //
     /* 2255036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2255039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255049 */   // MIs[0] Operand 1
     /* 2255049 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2255054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255058 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255062 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2255065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255067 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255069 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255077 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255078 */   // GIR_Coverage, 48668,
     /* 2255078 */   GIR_EraseRootFromParent_Done,
     /* 2255079 */ // Label 30197: @2255079
     /* 2255079 */ GIM_Try, /*On fail goto*//*Label 30198*/ GIMT_Encode4(2255127), // Rule ID 48669 //
     /* 2255084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255090 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255097 */   // MIs[0] Operand 1
     /* 2255097 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2255102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255106 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255110 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2255113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255115 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255117 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255125 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255126 */   // GIR_Coverage, 48669,
     /* 2255126 */   GIR_EraseRootFromParent_Done,
     /* 2255127 */ // Label 30198: @2255127
     /* 2255127 */ GIM_Try, /*On fail goto*//*Label 30199*/ GIMT_Encode4(2255175), // Rule ID 48676 //
     /* 2255132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255138 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255145 */   // MIs[0] Operand 1
     /* 2255145 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255154 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255158 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2255161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255163 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255165 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255174 */   // GIR_Coverage, 48676,
     /* 2255174 */   GIR_EraseRootFromParent_Done,
     /* 2255175 */ // Label 30199: @2255175
     /* 2255175 */ GIM_Try, /*On fail goto*//*Label 30200*/ GIMT_Encode4(2255223), // Rule ID 48677 //
     /* 2255180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255193 */   // MIs[0] Operand 1
     /* 2255193 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255202 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255206 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2255209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255211 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255213 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255221 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255222 */   // GIR_Coverage, 48677,
     /* 2255222 */   GIR_EraseRootFromParent_Done,
     /* 2255223 */ // Label 30200: @2255223
     /* 2255223 */ GIM_Try, /*On fail goto*//*Label 30201*/ GIMT_Encode4(2255271), // Rule ID 48686 //
     /* 2255228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255241 */   // MIs[0] Operand 1
     /* 2255241 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255250 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255254 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2255257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255259 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255261 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255270 */   // GIR_Coverage, 48686,
     /* 2255270 */   GIR_EraseRootFromParent_Done,
     /* 2255271 */ // Label 30201: @2255271
     /* 2255271 */ GIM_Try, /*On fail goto*//*Label 30202*/ GIMT_Encode4(2255319), // Rule ID 48687 //
     /* 2255276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255289 */   // MIs[0] Operand 1
     /* 2255289 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255298 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255302 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2255305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255307 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255309 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255317 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255318 */   // GIR_Coverage, 48687,
     /* 2255318 */   GIR_EraseRootFromParent_Done,
     /* 2255319 */ // Label 30202: @2255319
     /* 2255319 */ GIM_Try, /*On fail goto*//*Label 30203*/ GIMT_Encode4(2255367), // Rule ID 48704 //
     /* 2255324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255330 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255337 */   // MIs[0] Operand 1
     /* 2255337 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255346 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255350 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2255353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255355 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255357 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255366 */   // GIR_Coverage, 48704,
     /* 2255366 */   GIR_EraseRootFromParent_Done,
     /* 2255367 */ // Label 30203: @2255367
     /* 2255367 */ GIM_Try, /*On fail goto*//*Label 30204*/ GIMT_Encode4(2255415), // Rule ID 48705 //
     /* 2255372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255385 */   // MIs[0] Operand 1
     /* 2255385 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255394 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255398 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2255401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255403 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255405 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255413 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255414 */   // GIR_Coverage, 48705,
     /* 2255414 */   GIR_EraseRootFromParent_Done,
     /* 2255415 */ // Label 30204: @2255415
     /* 2255415 */ GIM_Try, /*On fail goto*//*Label 30205*/ GIMT_Encode4(2255463), // Rule ID 48712 //
     /* 2255420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2255423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255426 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255433 */   // MIs[0] Operand 1
     /* 2255433 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255442 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255446 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2255449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255451 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255453 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255461 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255462 */   // GIR_Coverage, 48712,
     /* 2255462 */   GIR_EraseRootFromParent_Done,
     /* 2255463 */ // Label 30205: @2255463
     /* 2255463 */ GIM_Try, /*On fail goto*//*Label 30206*/ GIMT_Encode4(2255511), // Rule ID 48713 //
     /* 2255468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255474 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255481 */   // MIs[0] Operand 1
     /* 2255481 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255490 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255494 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2255497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255499 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255501 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255509 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255510 */   // GIR_Coverage, 48713,
     /* 2255510 */   GIR_EraseRootFromParent_Done,
     /* 2255511 */ // Label 30206: @2255511
     /* 2255511 */ GIM_Try, /*On fail goto*//*Label 30207*/ GIMT_Encode4(2255559), // Rule ID 48720 //
     /* 2255516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255529 */   // MIs[0] Operand 1
     /* 2255529 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255538 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255542 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2255545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255547 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255549 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255558 */   // GIR_Coverage, 48720,
     /* 2255558 */   GIR_EraseRootFromParent_Done,
     /* 2255559 */ // Label 30207: @2255559
     /* 2255559 */ GIM_Try, /*On fail goto*//*Label 30208*/ GIMT_Encode4(2255607), // Rule ID 48721 //
     /* 2255564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255577 */   // MIs[0] Operand 1
     /* 2255577 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255586 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255590 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2255593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255595 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255597 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255605 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255606 */   // GIR_Coverage, 48721,
     /* 2255606 */   GIR_EraseRootFromParent_Done,
     /* 2255607 */ // Label 30208: @2255607
     /* 2255607 */ GIM_Try, /*On fail goto*//*Label 30209*/ GIMT_Encode4(2255655), // Rule ID 48730 //
     /* 2255612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255625 */   // MIs[0] Operand 1
     /* 2255625 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255634 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255638 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2255641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255643 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255645 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255654 */   // GIR_Coverage, 48730,
     /* 2255654 */   GIR_EraseRootFromParent_Done,
     /* 2255655 */ // Label 30209: @2255655
     /* 2255655 */ GIM_Try, /*On fail goto*//*Label 30210*/ GIMT_Encode4(2255703), // Rule ID 48731 //
     /* 2255660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255666 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255673 */   // MIs[0] Operand 1
     /* 2255673 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255682 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255686 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2255689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255691 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255693 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255701 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255702 */   // GIR_Coverage, 48731,
     /* 2255702 */   GIR_EraseRootFromParent_Done,
     /* 2255703 */ // Label 30210: @2255703
     /* 2255703 */ GIM_Try, /*On fail goto*//*Label 30211*/ GIMT_Encode4(2255751), // Rule ID 48748 //
     /* 2255708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255721 */   // MIs[0] Operand 1
     /* 2255721 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255730 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255734 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2255737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255739 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255741 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255750 */   // GIR_Coverage, 48748,
     /* 2255750 */   GIR_EraseRootFromParent_Done,
     /* 2255751 */ // Label 30211: @2255751
     /* 2255751 */ GIM_Try, /*On fail goto*//*Label 30212*/ GIMT_Encode4(2255799), // Rule ID 48749 //
     /* 2255756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255762 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255769 */   // MIs[0] Operand 1
     /* 2255769 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255778 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255782 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2255785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255787 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255789 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255797 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255798 */   // GIR_Coverage, 48749,
     /* 2255798 */   GIR_EraseRootFromParent_Done,
     /* 2255799 */ // Label 30212: @2255799
     /* 2255799 */ GIM_Try, /*On fail goto*//*Label 30213*/ GIMT_Encode4(2255847), // Rule ID 48756 //
     /* 2255804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2255807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255810 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255817 */   // MIs[0] Operand 1
     /* 2255817 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255826 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255830 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2255833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255835 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255837 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255845 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255846 */   // GIR_Coverage, 48756,
     /* 2255846 */   GIR_EraseRootFromParent_Done,
     /* 2255847 */ // Label 30213: @2255847
     /* 2255847 */ GIM_Try, /*On fail goto*//*Label 30214*/ GIMT_Encode4(2255895), // Rule ID 48757 //
     /* 2255852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255858 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255865 */   // MIs[0] Operand 1
     /* 2255865 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255874 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255878 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2255881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255883 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255885 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255894 */   // GIR_Coverage, 48757,
     /* 2255894 */   GIR_EraseRootFromParent_Done,
     /* 2255895 */ // Label 30214: @2255895
     /* 2255895 */ GIM_Try, /*On fail goto*//*Label 30215*/ GIMT_Encode4(2255943), // Rule ID 48764 //
     /* 2255900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255906 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255913 */   // MIs[0] Operand 1
     /* 2255913 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255922 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255926 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255931 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255933 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255941 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255942 */   // GIR_Coverage, 48764,
     /* 2255942 */   GIR_EraseRootFromParent_Done,
     /* 2255943 */ // Label 30215: @2255943
     /* 2255943 */ GIM_Try, /*On fail goto*//*Label 30216*/ GIMT_Encode4(2255991), // Rule ID 48765 //
     /* 2255948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255954 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255961 */   // MIs[0] Operand 1
     /* 2255961 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255970 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255974 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255979 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255981 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255989 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255990 */   // GIR_Coverage, 48765,
     /* 2255990 */   GIR_EraseRootFromParent_Done,
     /* 2255991 */ // Label 30216: @2255991
     /* 2255991 */ GIM_Try, /*On fail goto*//*Label 30217*/ GIMT_Encode4(2256039), // Rule ID 48774 //
     /* 2255996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256002 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256009 */   // MIs[0] Operand 1
     /* 2256009 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256018 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256022 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2256025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256027 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256029 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256038 */   // GIR_Coverage, 48774,
     /* 2256038 */   GIR_EraseRootFromParent_Done,
     /* 2256039 */ // Label 30217: @2256039
     /* 2256039 */ GIM_Try, /*On fail goto*//*Label 30218*/ GIMT_Encode4(2256087), // Rule ID 48775 //
     /* 2256044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256057 */   // MIs[0] Operand 1
     /* 2256057 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256066 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256070 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2256073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256075 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256077 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256086 */   // GIR_Coverage, 48775,
     /* 2256086 */   GIR_EraseRootFromParent_Done,
     /* 2256087 */ // Label 30218: @2256087
     /* 2256087 */ GIM_Try, /*On fail goto*//*Label 30219*/ GIMT_Encode4(2256135), // Rule ID 48792 //
     /* 2256092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256098 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256105 */   // MIs[0] Operand 1
     /* 2256105 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256114 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256118 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2256121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256123 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256125 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256133 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256134 */   // GIR_Coverage, 48792,
     /* 2256134 */   GIR_EraseRootFromParent_Done,
     /* 2256135 */ // Label 30219: @2256135
     /* 2256135 */ GIM_Try, /*On fail goto*//*Label 30220*/ GIMT_Encode4(2256183), // Rule ID 48793 //
     /* 2256140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256146 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256153 */   // MIs[0] Operand 1
     /* 2256153 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256162 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256166 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2256169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256171 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256173 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256182 */   // GIR_Coverage, 48793,
     /* 2256182 */   GIR_EraseRootFromParent_Done,
     /* 2256183 */ // Label 30220: @2256183
     /* 2256183 */ GIM_Try, /*On fail goto*//*Label 30221*/ GIMT_Encode4(2256231), // Rule ID 48800 //
     /* 2256188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256201 */   // MIs[0] Operand 1
     /* 2256201 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256210 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256214 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2256217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256219 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256221 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256230 */   // GIR_Coverage, 48800,
     /* 2256230 */   GIR_EraseRootFromParent_Done,
     /* 2256231 */ // Label 30221: @2256231
     /* 2256231 */ GIM_Try, /*On fail goto*//*Label 30222*/ GIMT_Encode4(2256279), // Rule ID 48801 //
     /* 2256236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256249 */   // MIs[0] Operand 1
     /* 2256249 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256258 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256262 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2256265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256267 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256269 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256278 */   // GIR_Coverage, 48801,
     /* 2256278 */   GIR_EraseRootFromParent_Done,
     /* 2256279 */ // Label 30222: @2256279
     /* 2256279 */ GIM_Try, /*On fail goto*//*Label 30223*/ GIMT_Encode4(2256327), // Rule ID 48808 //
     /* 2256284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256290 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256297 */   // MIs[0] Operand 1
     /* 2256297 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256306 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256310 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2256313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256315 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256317 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256326 */   // GIR_Coverage, 48808,
     /* 2256326 */   GIR_EraseRootFromParent_Done,
     /* 2256327 */ // Label 30223: @2256327
     /* 2256327 */ GIM_Try, /*On fail goto*//*Label 30224*/ GIMT_Encode4(2256375), // Rule ID 48809 //
     /* 2256332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256345 */   // MIs[0] Operand 1
     /* 2256345 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256354 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256358 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2256361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256363 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256365 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256373 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256374 */   // GIR_Coverage, 48809,
     /* 2256374 */   GIR_EraseRootFromParent_Done,
     /* 2256375 */ // Label 30224: @2256375
     /* 2256375 */ GIM_Try, /*On fail goto*//*Label 30225*/ GIMT_Encode4(2256423), // Rule ID 48818 //
     /* 2256380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256386 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256393 */   // MIs[0] Operand 1
     /* 2256393 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256402 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256406 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2256409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256411 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256413 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256421 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256422 */   // GIR_Coverage, 48818,
     /* 2256422 */   GIR_EraseRootFromParent_Done,
     /* 2256423 */ // Label 30225: @2256423
     /* 2256423 */ GIM_Try, /*On fail goto*//*Label 30226*/ GIMT_Encode4(2256471), // Rule ID 48819 //
     /* 2256428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256434 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256441 */   // MIs[0] Operand 1
     /* 2256441 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256450 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256454 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2256457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256459 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256461 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256470 */   // GIR_Coverage, 48819,
     /* 2256470 */   GIR_EraseRootFromParent_Done,
     /* 2256471 */ // Label 30226: @2256471
     /* 2256471 */ GIM_Try, /*On fail goto*//*Label 30227*/ GIMT_Encode4(2256519), // Rule ID 48836 //
     /* 2256476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256482 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256489 */   // MIs[0] Operand 1
     /* 2256489 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256498 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256502 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2256505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256507 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256509 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256518 */   // GIR_Coverage, 48836,
     /* 2256518 */   GIR_EraseRootFromParent_Done,
     /* 2256519 */ // Label 30227: @2256519
     /* 2256519 */ GIM_Try, /*On fail goto*//*Label 30228*/ GIMT_Encode4(2256567), // Rule ID 48837 //
     /* 2256524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256537 */   // MIs[0] Operand 1
     /* 2256537 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256546 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256550 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2256553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256555 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256557 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256565 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256566 */   // GIR_Coverage, 48837,
     /* 2256566 */   GIR_EraseRootFromParent_Done,
     /* 2256567 */ // Label 30228: @2256567
     /* 2256567 */ GIM_Try, /*On fail goto*//*Label 30229*/ GIMT_Encode4(2256615), // Rule ID 48844 //
     /* 2256572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256578 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256585 */   // MIs[0] Operand 1
     /* 2256585 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256594 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256598 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2256601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256603 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256605 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256613 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256614 */   // GIR_Coverage, 48844,
     /* 2256614 */   GIR_EraseRootFromParent_Done,
     /* 2256615 */ // Label 30229: @2256615
     /* 2256615 */ GIM_Try, /*On fail goto*//*Label 30230*/ GIMT_Encode4(2256663), // Rule ID 48845 //
     /* 2256620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256633 */   // MIs[0] Operand 1
     /* 2256633 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256642 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256646 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2256649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256651 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256653 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256662 */   // GIR_Coverage, 48845,
     /* 2256662 */   GIR_EraseRootFromParent_Done,
     /* 2256663 */ // Label 30230: @2256663
     /* 2256663 */ GIM_Try, /*On fail goto*//*Label 30231*/ GIMT_Encode4(2256711), // Rule ID 48852 //
     /* 2256668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256674 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256681 */   // MIs[0] Operand 1
     /* 2256681 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256690 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256694 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2256697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256699 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256701 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256710 */   // GIR_Coverage, 48852,
     /* 2256710 */   GIR_EraseRootFromParent_Done,
     /* 2256711 */ // Label 30231: @2256711
     /* 2256711 */ GIM_Try, /*On fail goto*//*Label 30232*/ GIMT_Encode4(2256759), // Rule ID 48853 //
     /* 2256716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256722 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256729 */   // MIs[0] Operand 1
     /* 2256729 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256738 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256742 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2256745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256747 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256749 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256757 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256758 */   // GIR_Coverage, 48853,
     /* 2256758 */   GIR_EraseRootFromParent_Done,
     /* 2256759 */ // Label 30232: @2256759
     /* 2256759 */ GIM_Try, /*On fail goto*//*Label 30233*/ GIMT_Encode4(2256807), // Rule ID 48862 //
     /* 2256764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256770 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256777 */   // MIs[0] Operand 1
     /* 2256777 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256786 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256790 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256795 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256797 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256805 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256806 */   // GIR_Coverage, 48862,
     /* 2256806 */   GIR_EraseRootFromParent_Done,
     /* 2256807 */ // Label 30233: @2256807
     /* 2256807 */ GIM_Try, /*On fail goto*//*Label 30234*/ GIMT_Encode4(2256855), // Rule ID 48863 //
     /* 2256812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256825 */   // MIs[0] Operand 1
     /* 2256825 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256834 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256838 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256843 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256845 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256853 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256854 */   // GIR_Coverage, 48863,
     /* 2256854 */   GIR_EraseRootFromParent_Done,
     /* 2256855 */ // Label 30234: @2256855
     /* 2256855 */ GIM_Try, /*On fail goto*//*Label 30235*/ GIMT_Encode4(2256903), // Rule ID 48880 //
     /* 2256860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256866 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256873 */   // MIs[0] Operand 1
     /* 2256873 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256882 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256886 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256891 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256893 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256901 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256902 */   // GIR_Coverage, 48880,
     /* 2256902 */   GIR_EraseRootFromParent_Done,
     /* 2256903 */ // Label 30235: @2256903
     /* 2256903 */ GIM_Try, /*On fail goto*//*Label 30236*/ GIMT_Encode4(2256951), // Rule ID 48881 //
     /* 2256908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256914 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256921 */   // MIs[0] Operand 1
     /* 2256921 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256930 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256934 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256939 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256941 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256949 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256950 */   // GIR_Coverage, 48881,
     /* 2256950 */   GIR_EraseRootFromParent_Done,
     /* 2256951 */ // Label 30236: @2256951
     /* 2256951 */ GIM_Try, /*On fail goto*//*Label 30237*/ GIMT_Encode4(2256999), // Rule ID 48888 //
     /* 2256956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256962 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256969 */   // MIs[0] Operand 1
     /* 2256969 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256978 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256982 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2256985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256987 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256989 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256997 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256998 */   // GIR_Coverage, 48888,
     /* 2256998 */   GIR_EraseRootFromParent_Done,
     /* 2256999 */ // Label 30237: @2256999
     /* 2256999 */ GIM_Try, /*On fail goto*//*Label 30238*/ GIMT_Encode4(2257047), // Rule ID 48889 //
     /* 2257004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2257007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257010 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2257013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257017 */   // MIs[0] Operand 1
     /* 2257017 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2257022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257026 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257030 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2257033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257035 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257037 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257045 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257046 */   // GIR_Coverage, 48889,
     /* 2257046 */   GIR_EraseRootFromParent_Done,
     /* 2257047 */ // Label 30238: @2257047
     /* 2257047 */ GIM_Try, /*On fail goto*//*Label 30239*/ GIMT_Encode4(2257095), // Rule ID 48896 //
     /* 2257052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2257058 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2257061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257065 */   // MIs[0] Operand 1
     /* 2257065 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257074 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257078 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2257081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257083 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257085 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257094 */   // GIR_Coverage, 48896,
     /* 2257094 */   GIR_EraseRootFromParent_Done,
     /* 2257095 */ // Label 30239: @2257095
     /* 2257095 */ GIM_Try, /*On fail goto*//*Label 30240*/ GIMT_Encode4(2257143), // Rule ID 48897 //
     /* 2257100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2257106 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2257109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257113 */   // MIs[0] Operand 1
     /* 2257113 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257122 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257126 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2257129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257131 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257133 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257141 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257142 */   // GIR_Coverage, 48897,
     /* 2257142 */   GIR_EraseRootFromParent_Done,
     /* 2257143 */ // Label 30240: @2257143
     /* 2257143 */ GIM_Try, /*On fail goto*//*Label 30241*/ GIMT_Encode4(2257191), // Rule ID 48906 //
     /* 2257148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2257154 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2257157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257161 */   // MIs[0] Operand 1
     /* 2257161 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257170 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257174 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2257177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257179 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257181 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257189 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257190 */   // GIR_Coverage, 48906,
     /* 2257190 */   GIR_EraseRootFromParent_Done,
     /* 2257191 */ // Label 30241: @2257191
     /* 2257191 */ GIM_Try, /*On fail goto*//*Label 30242*/ GIMT_Encode4(2257239), // Rule ID 48907 //
     /* 2257196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2257202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2257205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257209 */   // MIs[0] Operand 1
     /* 2257209 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257218 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257222 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2257225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257227 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257229 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257238 */   // GIR_Coverage, 48907,
     /* 2257238 */   GIR_EraseRootFromParent_Done,
     /* 2257239 */ // Label 30242: @2257239
     /* 2257239 */ GIM_Try, /*On fail goto*//*Label 30243*/ GIMT_Encode4(2257287), // Rule ID 48924 //
     /* 2257244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2257250 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2257253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257257 */   // MIs[0] Operand 1
     /* 2257257 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257266 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257270 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2257273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257275 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257277 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257286 */   // GIR_Coverage, 48924,
     /* 2257286 */   GIR_EraseRootFromParent_Done,
     /* 2257287 */ // Label 30243: @2257287
     /* 2257287 */ GIM_Try, /*On fail goto*//*Label 30244*/ GIMT_Encode4(2257335), // Rule ID 48925 //
     /* 2257292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2257298 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2257301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257305 */   // MIs[0] Operand 1
     /* 2257305 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257314 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257318 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2257321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257323 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257325 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257333 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257334 */   // GIR_Coverage, 48925,
     /* 2257334 */   GIR_EraseRootFromParent_Done,
     /* 2257335 */ // Label 30244: @2257335
     /* 2257335 */ GIM_Try, /*On fail goto*//*Label 30245*/ GIMT_Encode4(2257383), // Rule ID 48932 //
     /* 2257340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2257343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257346 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2257349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257353 */   // MIs[0] Operand 1
     /* 2257353 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257362 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257366 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2257369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257371 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257373 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257381 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257382 */   // GIR_Coverage, 48932,
     /* 2257382 */   GIR_EraseRootFromParent_Done,
     /* 2257383 */ // Label 30245: @2257383
     /* 2257383 */ GIM_Try, /*On fail goto*//*Label 30246*/ GIMT_Encode4(2257431), // Rule ID 48933 //
     /* 2257388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2257391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257394 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2257397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257401 */   // MIs[0] Operand 1
     /* 2257401 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257410 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257414 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2257417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257419 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257421 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257429 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257430 */   // GIR_Coverage, 48933,
     /* 2257430 */   GIR_EraseRootFromParent_Done,
     /* 2257431 */ // Label 30246: @2257431
     /* 2257431 */ GIM_Reject,
     /* 2257432 */ // Label 29904: @2257432
     /* 2257432 */ GIM_Try, /*On fail goto*//*Label 30247*/ GIMT_Encode4(2257480), // Rule ID 48510 //
     /* 2257437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257443 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257450 */   // MIs[0] Operand 1
     /* 2257450 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257459 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257463 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2257466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257468 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257470 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257479 */   // GIR_Coverage, 48510,
     /* 2257479 */   GIR_EraseRootFromParent_Done,
     /* 2257480 */ // Label 30247: @2257480
     /* 2257480 */ GIM_Try, /*On fail goto*//*Label 30248*/ GIMT_Encode4(2257528), // Rule ID 48511 //
     /* 2257485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257491 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257498 */   // MIs[0] Operand 1
     /* 2257498 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257507 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257511 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2257514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257516 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257518 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257526 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257527 */   // GIR_Coverage, 48511,
     /* 2257527 */   GIR_EraseRootFromParent_Done,
     /* 2257528 */ // Label 30248: @2257528
     /* 2257528 */ GIM_Try, /*On fail goto*//*Label 30249*/ GIMT_Encode4(2257576), // Rule ID 48524 //
     /* 2257533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257546 */   // MIs[0] Operand 1
     /* 2257546 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257555 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257559 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2257562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257564 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257566 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257574 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257575 */   // GIR_Coverage, 48524,
     /* 2257575 */   GIR_EraseRootFromParent_Done,
     /* 2257576 */ // Label 30249: @2257576
     /* 2257576 */ GIM_Try, /*On fail goto*//*Label 30250*/ GIMT_Encode4(2257624), // Rule ID 48525 //
     /* 2257581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257587 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257594 */   // MIs[0] Operand 1
     /* 2257594 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257603 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257607 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2257610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257612 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257614 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257623 */   // GIR_Coverage, 48525,
     /* 2257623 */   GIR_EraseRootFromParent_Done,
     /* 2257624 */ // Label 30250: @2257624
     /* 2257624 */ GIM_Try, /*On fail goto*//*Label 30251*/ GIMT_Encode4(2257672), // Rule ID 48532 //
     /* 2257629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257642 */   // MIs[0] Operand 1
     /* 2257642 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257651 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257655 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2257658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257660 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257662 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257670 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257671 */   // GIR_Coverage, 48532,
     /* 2257671 */   GIR_EraseRootFromParent_Done,
     /* 2257672 */ // Label 30251: @2257672
     /* 2257672 */ GIM_Try, /*On fail goto*//*Label 30252*/ GIMT_Encode4(2257720), // Rule ID 48533 //
     /* 2257677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257690 */   // MIs[0] Operand 1
     /* 2257690 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257699 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257703 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2257706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257708 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257710 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257719 */   // GIR_Coverage, 48533,
     /* 2257719 */   GIR_EraseRootFromParent_Done,
     /* 2257720 */ // Label 30252: @2257720
     /* 2257720 */ GIM_Try, /*On fail goto*//*Label 30253*/ GIMT_Encode4(2257768), // Rule ID 48540 //
     /* 2257725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2257728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257731 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257738 */   // MIs[0] Operand 1
     /* 2257738 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257747 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257751 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2257754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257756 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257758 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257767 */   // GIR_Coverage, 48540,
     /* 2257767 */   GIR_EraseRootFromParent_Done,
     /* 2257768 */ // Label 30253: @2257768
     /* 2257768 */ GIM_Try, /*On fail goto*//*Label 30254*/ GIMT_Encode4(2257816), // Rule ID 48541 //
     /* 2257773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2257776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257779 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257786 */   // MIs[0] Operand 1
     /* 2257786 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257795 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257799 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2257802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257804 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257806 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257815 */   // GIR_Coverage, 48541,
     /* 2257815 */   GIR_EraseRootFromParent_Done,
     /* 2257816 */ // Label 30254: @2257816
     /* 2257816 */ GIM_Try, /*On fail goto*//*Label 30255*/ GIMT_Encode4(2257864), // Rule ID 48554 //
     /* 2257821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257834 */   // MIs[0] Operand 1
     /* 2257834 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257843 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257847 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2257850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257852 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257854 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257862 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257863 */   // GIR_Coverage, 48554,
     /* 2257863 */   GIR_EraseRootFromParent_Done,
     /* 2257864 */ // Label 30255: @2257864
     /* 2257864 */ GIM_Try, /*On fail goto*//*Label 30256*/ GIMT_Encode4(2257912), // Rule ID 48555 //
     /* 2257869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257875 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257882 */   // MIs[0] Operand 1
     /* 2257882 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257891 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257895 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2257898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257900 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257902 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257910 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257911 */   // GIR_Coverage, 48555,
     /* 2257911 */   GIR_EraseRootFromParent_Done,
     /* 2257912 */ // Label 30256: @2257912
     /* 2257912 */ GIM_Try, /*On fail goto*//*Label 30257*/ GIMT_Encode4(2257960), // Rule ID 48568 //
     /* 2257917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257923 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257930 */   // MIs[0] Operand 1
     /* 2257930 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257939 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257943 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2257946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257948 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257950 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257958 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257959 */   // GIR_Coverage, 48568,
     /* 2257959 */   GIR_EraseRootFromParent_Done,
     /* 2257960 */ // Label 30257: @2257960
     /* 2257960 */ GIM_Try, /*On fail goto*//*Label 30258*/ GIMT_Encode4(2258008), // Rule ID 48569 //
     /* 2257965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257971 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257978 */   // MIs[0] Operand 1
     /* 2257978 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257987 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257991 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2257994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257996 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257998 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258006 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258007 */   // GIR_Coverage, 48569,
     /* 2258007 */   GIR_EraseRootFromParent_Done,
     /* 2258008 */ // Label 30258: @2258008
     /* 2258008 */ GIM_Try, /*On fail goto*//*Label 30259*/ GIMT_Encode4(2258056), // Rule ID 48576 //
     /* 2258013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258026 */   // MIs[0] Operand 1
     /* 2258026 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2258031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258035 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258039 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2258042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258044 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258046 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258055 */   // GIR_Coverage, 48576,
     /* 2258055 */   GIR_EraseRootFromParent_Done,
     /* 2258056 */ // Label 30259: @2258056
     /* 2258056 */ GIM_Try, /*On fail goto*//*Label 30260*/ GIMT_Encode4(2258104), // Rule ID 48577 //
     /* 2258061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258074 */   // MIs[0] Operand 1
     /* 2258074 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2258079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258083 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258087 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2258090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258092 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258094 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258102 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258103 */   // GIR_Coverage, 48577,
     /* 2258103 */   GIR_EraseRootFromParent_Done,
     /* 2258104 */ // Label 30260: @2258104
     /* 2258104 */ GIM_Try, /*On fail goto*//*Label 30261*/ GIMT_Encode4(2258152), // Rule ID 48584 //
     /* 2258109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258115 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258122 */   // MIs[0] Operand 1
     /* 2258122 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2258127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258131 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258135 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2258138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258140 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258142 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258150 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258151 */   // GIR_Coverage, 48584,
     /* 2258151 */   GIR_EraseRootFromParent_Done,
     /* 2258152 */ // Label 30261: @2258152
     /* 2258152 */ GIM_Try, /*On fail goto*//*Label 30262*/ GIMT_Encode4(2258200), // Rule ID 48585 //
     /* 2258157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258163 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258170 */   // MIs[0] Operand 1
     /* 2258170 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2258175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258179 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258183 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2258186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258188 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258190 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258199 */   // GIR_Coverage, 48585,
     /* 2258199 */   GIR_EraseRootFromParent_Done,
     /* 2258200 */ // Label 30262: @2258200
     /* 2258200 */ GIM_Try, /*On fail goto*//*Label 30263*/ GIMT_Encode4(2258248), // Rule ID 48598 //
     /* 2258205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258211 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258218 */   // MIs[0] Operand 1
     /* 2258218 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258227 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258231 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2258234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258236 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258238 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258246 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258247 */   // GIR_Coverage, 48598,
     /* 2258247 */   GIR_EraseRootFromParent_Done,
     /* 2258248 */ // Label 30263: @2258248
     /* 2258248 */ GIM_Try, /*On fail goto*//*Label 30264*/ GIMT_Encode4(2258296), // Rule ID 48599 //
     /* 2258253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258259 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258266 */   // MIs[0] Operand 1
     /* 2258266 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258275 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258279 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2258282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258284 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258286 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258294 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258295 */   // GIR_Coverage, 48599,
     /* 2258295 */   GIR_EraseRootFromParent_Done,
     /* 2258296 */ // Label 30264: @2258296
     /* 2258296 */ GIM_Try, /*On fail goto*//*Label 30265*/ GIMT_Encode4(2258344), // Rule ID 48612 //
     /* 2258301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258307 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258314 */   // MIs[0] Operand 1
     /* 2258314 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258323 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258327 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2258330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258332 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258334 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258342 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258343 */   // GIR_Coverage, 48612,
     /* 2258343 */   GIR_EraseRootFromParent_Done,
     /* 2258344 */ // Label 30265: @2258344
     /* 2258344 */ GIM_Try, /*On fail goto*//*Label 30266*/ GIMT_Encode4(2258392), // Rule ID 48613 //
     /* 2258349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258355 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258362 */   // MIs[0] Operand 1
     /* 2258362 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258367 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258371 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258375 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2258378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258380 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258382 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258390 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258391 */   // GIR_Coverage, 48613,
     /* 2258391 */   GIR_EraseRootFromParent_Done,
     /* 2258392 */ // Label 30266: @2258392
     /* 2258392 */ GIM_Try, /*On fail goto*//*Label 30267*/ GIMT_Encode4(2258440), // Rule ID 48620 //
     /* 2258397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258403 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258410 */   // MIs[0] Operand 1
     /* 2258410 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258419 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258423 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258428 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258430 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258439 */   // GIR_Coverage, 48620,
     /* 2258439 */   GIR_EraseRootFromParent_Done,
     /* 2258440 */ // Label 30267: @2258440
     /* 2258440 */ GIM_Try, /*On fail goto*//*Label 30268*/ GIMT_Encode4(2258488), // Rule ID 48621 //
     /* 2258445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258451 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258458 */   // MIs[0] Operand 1
     /* 2258458 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258463 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258467 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258471 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258476 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258478 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258486 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258487 */   // GIR_Coverage, 48621,
     /* 2258487 */   GIR_EraseRootFromParent_Done,
     /* 2258488 */ // Label 30268: @2258488
     /* 2258488 */ GIM_Try, /*On fail goto*//*Label 30269*/ GIMT_Encode4(2258536), // Rule ID 48628 //
     /* 2258493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258499 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258506 */   // MIs[0] Operand 1
     /* 2258506 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258515 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258519 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258524 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258526 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258534 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258535 */   // GIR_Coverage, 48628,
     /* 2258535 */   GIR_EraseRootFromParent_Done,
     /* 2258536 */ // Label 30269: @2258536
     /* 2258536 */ GIM_Try, /*On fail goto*//*Label 30270*/ GIMT_Encode4(2258584), // Rule ID 48629 //
     /* 2258541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258554 */   // MIs[0] Operand 1
     /* 2258554 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258563 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258567 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258572 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258574 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258582 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258583 */   // GIR_Coverage, 48629,
     /* 2258583 */   GIR_EraseRootFromParent_Done,
     /* 2258584 */ // Label 30270: @2258584
     /* 2258584 */ GIM_Try, /*On fail goto*//*Label 30271*/ GIMT_Encode4(2258632), // Rule ID 48640 //
     /* 2258589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258595 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258602 */   // MIs[0] Operand 1
     /* 2258602 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258607 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258611 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258615 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2258618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258620 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258622 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258630 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258631 */   // GIR_Coverage, 48640,
     /* 2258631 */   GIR_EraseRootFromParent_Done,
     /* 2258632 */ // Label 30271: @2258632
     /* 2258632 */ GIM_Try, /*On fail goto*//*Label 30272*/ GIMT_Encode4(2258680), // Rule ID 48641 //
     /* 2258637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258643 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258650 */   // MIs[0] Operand 1
     /* 2258650 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258659 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258663 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2258666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258668 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258670 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258678 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258679 */   // GIR_Coverage, 48641,
     /* 2258679 */   GIR_EraseRootFromParent_Done,
     /* 2258680 */ // Label 30272: @2258680
     /* 2258680 */ GIM_Try, /*On fail goto*//*Label 30273*/ GIMT_Encode4(2258728), // Rule ID 48654 //
     /* 2258685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258691 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258698 */   // MIs[0] Operand 1
     /* 2258698 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258707 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258711 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2258714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258716 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258718 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258726 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258727 */   // GIR_Coverage, 48654,
     /* 2258727 */   GIR_EraseRootFromParent_Done,
     /* 2258728 */ // Label 30273: @2258728
     /* 2258728 */ GIM_Try, /*On fail goto*//*Label 30274*/ GIMT_Encode4(2258776), // Rule ID 48655 //
     /* 2258733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258739 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258746 */   // MIs[0] Operand 1
     /* 2258746 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258755 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258759 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2258762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258764 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258766 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258774 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258775 */   // GIR_Coverage, 48655,
     /* 2258775 */   GIR_EraseRootFromParent_Done,
     /* 2258776 */ // Label 30274: @2258776
     /* 2258776 */ GIM_Try, /*On fail goto*//*Label 30275*/ GIMT_Encode4(2258824), // Rule ID 48662 //
     /* 2258781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258787 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258794 */   // MIs[0] Operand 1
     /* 2258794 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258803 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258807 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258812 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258814 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258823 */   // GIR_Coverage, 48662,
     /* 2258823 */   GIR_EraseRootFromParent_Done,
     /* 2258824 */ // Label 30275: @2258824
     /* 2258824 */ GIM_Try, /*On fail goto*//*Label 30276*/ GIMT_Encode4(2258872), // Rule ID 48663 //
     /* 2258829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258835 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258842 */   // MIs[0] Operand 1
     /* 2258842 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258851 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258855 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258860 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258862 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258871 */   // GIR_Coverage, 48663,
     /* 2258871 */   GIR_EraseRootFromParent_Done,
     /* 2258872 */ // Label 30276: @2258872
     /* 2258872 */ GIM_Try, /*On fail goto*//*Label 30277*/ GIMT_Encode4(2258920), // Rule ID 48670 //
     /* 2258877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258890 */   // MIs[0] Operand 1
     /* 2258890 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258899 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258903 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258908 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258910 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258919 */   // GIR_Coverage, 48670,
     /* 2258919 */   GIR_EraseRootFromParent_Done,
     /* 2258920 */ // Label 30277: @2258920
     /* 2258920 */ GIM_Try, /*On fail goto*//*Label 30278*/ GIMT_Encode4(2258968), // Rule ID 48671 //
     /* 2258925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258931 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258938 */   // MIs[0] Operand 1
     /* 2258938 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258947 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258951 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258956 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258958 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258966 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258967 */   // GIR_Coverage, 48671,
     /* 2258967 */   GIR_EraseRootFromParent_Done,
     /* 2258968 */ // Label 30278: @2258968
     /* 2258968 */ GIM_Try, /*On fail goto*//*Label 30279*/ GIMT_Encode4(2259016), // Rule ID 48684 //
     /* 2258973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258986 */   // MIs[0] Operand 1
     /* 2258986 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258995 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258999 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2259002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259004 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259006 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259014 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259015 */   // GIR_Coverage, 48684,
     /* 2259015 */   GIR_EraseRootFromParent_Done,
     /* 2259016 */ // Label 30279: @2259016
     /* 2259016 */ GIM_Try, /*On fail goto*//*Label 30280*/ GIMT_Encode4(2259064), // Rule ID 48685 //
     /* 2259021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259027 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259034 */   // MIs[0] Operand 1
     /* 2259034 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259043 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259047 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2259050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259052 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259054 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259062 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259063 */   // GIR_Coverage, 48685,
     /* 2259063 */   GIR_EraseRootFromParent_Done,
     /* 2259064 */ // Label 30280: @2259064
     /* 2259064 */ GIM_Try, /*On fail goto*//*Label 30281*/ GIMT_Encode4(2259112), // Rule ID 48698 //
     /* 2259069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259075 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259082 */   // MIs[0] Operand 1
     /* 2259082 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259091 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259095 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2259098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259100 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259102 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259111 */   // GIR_Coverage, 48698,
     /* 2259111 */   GIR_EraseRootFromParent_Done,
     /* 2259112 */ // Label 30281: @2259112
     /* 2259112 */ GIM_Try, /*On fail goto*//*Label 30282*/ GIMT_Encode4(2259160), // Rule ID 48699 //
     /* 2259117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259123 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259130 */   // MIs[0] Operand 1
     /* 2259130 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259139 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259143 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2259146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259148 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259150 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259159 */   // GIR_Coverage, 48699,
     /* 2259159 */   GIR_EraseRootFromParent_Done,
     /* 2259160 */ // Label 30282: @2259160
     /* 2259160 */ GIM_Try, /*On fail goto*//*Label 30283*/ GIMT_Encode4(2259208), // Rule ID 48706 //
     /* 2259165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259178 */   // MIs[0] Operand 1
     /* 2259178 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259187 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259191 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2259194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259196 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259198 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259207 */   // GIR_Coverage, 48706,
     /* 2259207 */   GIR_EraseRootFromParent_Done,
     /* 2259208 */ // Label 30283: @2259208
     /* 2259208 */ GIM_Try, /*On fail goto*//*Label 30284*/ GIMT_Encode4(2259256), // Rule ID 48707 //
     /* 2259213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259219 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259226 */   // MIs[0] Operand 1
     /* 2259226 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259235 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259239 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2259242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259244 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259246 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259254 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259255 */   // GIR_Coverage, 48707,
     /* 2259255 */   GIR_EraseRootFromParent_Done,
     /* 2259256 */ // Label 30284: @2259256
     /* 2259256 */ GIM_Try, /*On fail goto*//*Label 30285*/ GIMT_Encode4(2259304), // Rule ID 48714 //
     /* 2259261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259267 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259274 */   // MIs[0] Operand 1
     /* 2259274 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259283 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259287 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2259290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259292 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259294 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259302 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259303 */   // GIR_Coverage, 48714,
     /* 2259303 */   GIR_EraseRootFromParent_Done,
     /* 2259304 */ // Label 30285: @2259304
     /* 2259304 */ GIM_Try, /*On fail goto*//*Label 30286*/ GIMT_Encode4(2259352), // Rule ID 48715 //
     /* 2259309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2259312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259315 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259322 */   // MIs[0] Operand 1
     /* 2259322 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259327 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259331 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259335 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2259338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259340 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259342 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259350 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259351 */   // GIR_Coverage, 48715,
     /* 2259351 */   GIR_EraseRootFromParent_Done,
     /* 2259352 */ // Label 30286: @2259352
     /* 2259352 */ GIM_Try, /*On fail goto*//*Label 30287*/ GIMT_Encode4(2259400), // Rule ID 48728 //
     /* 2259357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259363 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259370 */   // MIs[0] Operand 1
     /* 2259370 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259379 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259383 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2259386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259388 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259390 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259398 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259399 */   // GIR_Coverage, 48728,
     /* 2259399 */   GIR_EraseRootFromParent_Done,
     /* 2259400 */ // Label 30287: @2259400
     /* 2259400 */ GIM_Try, /*On fail goto*//*Label 30288*/ GIMT_Encode4(2259448), // Rule ID 48729 //
     /* 2259405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259411 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259418 */   // MIs[0] Operand 1
     /* 2259418 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259427 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259431 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2259434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259436 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259438 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259446 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259447 */   // GIR_Coverage, 48729,
     /* 2259447 */   GIR_EraseRootFromParent_Done,
     /* 2259448 */ // Label 30288: @2259448
     /* 2259448 */ GIM_Try, /*On fail goto*//*Label 30289*/ GIMT_Encode4(2259496), // Rule ID 48742 //
     /* 2259453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259459 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259466 */   // MIs[0] Operand 1
     /* 2259466 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259475 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259479 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2259482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259484 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259486 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259494 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259495 */   // GIR_Coverage, 48742,
     /* 2259495 */   GIR_EraseRootFromParent_Done,
     /* 2259496 */ // Label 30289: @2259496
     /* 2259496 */ GIM_Try, /*On fail goto*//*Label 30290*/ GIMT_Encode4(2259544), // Rule ID 48743 //
     /* 2259501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259507 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259514 */   // MIs[0] Operand 1
     /* 2259514 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259523 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259527 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2259530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259532 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259534 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259542 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259543 */   // GIR_Coverage, 48743,
     /* 2259543 */   GIR_EraseRootFromParent_Done,
     /* 2259544 */ // Label 30290: @2259544
     /* 2259544 */ GIM_Try, /*On fail goto*//*Label 30291*/ GIMT_Encode4(2259592), // Rule ID 48750 //
     /* 2259549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259562 */   // MIs[0] Operand 1
     /* 2259562 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259571 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259575 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2259578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259580 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259582 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259591 */   // GIR_Coverage, 48750,
     /* 2259591 */   GIR_EraseRootFromParent_Done,
     /* 2259592 */ // Label 30291: @2259592
     /* 2259592 */ GIM_Try, /*On fail goto*//*Label 30292*/ GIMT_Encode4(2259640), // Rule ID 48751 //
     /* 2259597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259603 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259610 */   // MIs[0] Operand 1
     /* 2259610 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259619 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259623 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2259626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259628 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259630 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259638 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259639 */   // GIR_Coverage, 48751,
     /* 2259639 */   GIR_EraseRootFromParent_Done,
     /* 2259640 */ // Label 30292: @2259640
     /* 2259640 */ GIM_Try, /*On fail goto*//*Label 30293*/ GIMT_Encode4(2259688), // Rule ID 48758 //
     /* 2259645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259651 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259658 */   // MIs[0] Operand 1
     /* 2259658 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259667 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259671 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2259674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259676 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259678 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259686 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259687 */   // GIR_Coverage, 48758,
     /* 2259687 */   GIR_EraseRootFromParent_Done,
     /* 2259688 */ // Label 30293: @2259688
     /* 2259688 */ GIM_Try, /*On fail goto*//*Label 30294*/ GIMT_Encode4(2259736), // Rule ID 48759 //
     /* 2259693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2259696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259699 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259706 */   // MIs[0] Operand 1
     /* 2259706 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259715 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259719 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2259722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259724 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259726 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259734 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259735 */   // GIR_Coverage, 48759,
     /* 2259735 */   GIR_EraseRootFromParent_Done,
     /* 2259736 */ // Label 30294: @2259736
     /* 2259736 */ GIM_Try, /*On fail goto*//*Label 30295*/ GIMT_Encode4(2259784), // Rule ID 48772 //
     /* 2259741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259747 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259754 */   // MIs[0] Operand 1
     /* 2259754 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259763 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259767 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259772 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259774 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259782 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259783 */   // GIR_Coverage, 48772,
     /* 2259783 */   GIR_EraseRootFromParent_Done,
     /* 2259784 */ // Label 30295: @2259784
     /* 2259784 */ GIM_Try, /*On fail goto*//*Label 30296*/ GIMT_Encode4(2259832), // Rule ID 48773 //
     /* 2259789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259795 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259802 */   // MIs[0] Operand 1
     /* 2259802 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259811 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259815 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259820 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259822 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259830 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259831 */   // GIR_Coverage, 48773,
     /* 2259831 */   GIR_EraseRootFromParent_Done,
     /* 2259832 */ // Label 30296: @2259832
     /* 2259832 */ GIM_Try, /*On fail goto*//*Label 30297*/ GIMT_Encode4(2259880), // Rule ID 48786 //
     /* 2259837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259843 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259850 */   // MIs[0] Operand 1
     /* 2259850 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259859 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259863 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259868 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259870 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259878 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259879 */   // GIR_Coverage, 48786,
     /* 2259879 */   GIR_EraseRootFromParent_Done,
     /* 2259880 */ // Label 30297: @2259880
     /* 2259880 */ GIM_Try, /*On fail goto*//*Label 30298*/ GIMT_Encode4(2259928), // Rule ID 48787 //
     /* 2259885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259891 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259898 */   // MIs[0] Operand 1
     /* 2259898 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259907 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259911 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259916 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259918 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259927 */   // GIR_Coverage, 48787,
     /* 2259927 */   GIR_EraseRootFromParent_Done,
     /* 2259928 */ // Label 30298: @2259928
     /* 2259928 */ GIM_Try, /*On fail goto*//*Label 30299*/ GIMT_Encode4(2259976), // Rule ID 48794 //
     /* 2259933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259946 */   // MIs[0] Operand 1
     /* 2259946 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259955 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259959 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259964 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259966 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259974 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259975 */   // GIR_Coverage, 48794,
     /* 2259975 */   GIR_EraseRootFromParent_Done,
     /* 2259976 */ // Label 30299: @2259976
     /* 2259976 */ GIM_Try, /*On fail goto*//*Label 30300*/ GIMT_Encode4(2260024), // Rule ID 48795 //
     /* 2259981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259987 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259994 */   // MIs[0] Operand 1
     /* 2259994 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260003 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260007 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2260010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260012 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260014 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260022 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260023 */   // GIR_Coverage, 48795,
     /* 2260023 */   GIR_EraseRootFromParent_Done,
     /* 2260024 */ // Label 30300: @2260024
     /* 2260024 */ GIM_Try, /*On fail goto*//*Label 30301*/ GIMT_Encode4(2260072), // Rule ID 48802 //
     /* 2260029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260035 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260042 */   // MIs[0] Operand 1
     /* 2260042 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2260047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260051 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260055 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2260058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260060 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260062 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260070 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260071 */   // GIR_Coverage, 48802,
     /* 2260071 */   GIR_EraseRootFromParent_Done,
     /* 2260072 */ // Label 30301: @2260072
     /* 2260072 */ GIM_Try, /*On fail goto*//*Label 30302*/ GIMT_Encode4(2260120), // Rule ID 48803 //
     /* 2260077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260083 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260090 */   // MIs[0] Operand 1
     /* 2260090 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2260095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260099 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260103 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2260106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260108 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260110 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260118 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260119 */   // GIR_Coverage, 48803,
     /* 2260119 */   GIR_EraseRootFromParent_Done,
     /* 2260120 */ // Label 30302: @2260120
     /* 2260120 */ GIM_Try, /*On fail goto*//*Label 30303*/ GIMT_Encode4(2260168), // Rule ID 48816 //
     /* 2260125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260131 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260138 */   // MIs[0] Operand 1
     /* 2260138 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260147 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260151 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2260154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260156 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260158 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260166 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260167 */   // GIR_Coverage, 48816,
     /* 2260167 */   GIR_EraseRootFromParent_Done,
     /* 2260168 */ // Label 30303: @2260168
     /* 2260168 */ GIM_Try, /*On fail goto*//*Label 30304*/ GIMT_Encode4(2260216), // Rule ID 48817 //
     /* 2260173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260179 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260186 */   // MIs[0] Operand 1
     /* 2260186 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260195 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260199 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2260202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260204 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260206 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260214 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260215 */   // GIR_Coverage, 48817,
     /* 2260215 */   GIR_EraseRootFromParent_Done,
     /* 2260216 */ // Label 30304: @2260216
     /* 2260216 */ GIM_Try, /*On fail goto*//*Label 30305*/ GIMT_Encode4(2260264), // Rule ID 48830 //
     /* 2260221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260227 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260234 */   // MIs[0] Operand 1
     /* 2260234 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260243 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260247 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2260250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260252 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260254 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260262 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260263 */   // GIR_Coverage, 48830,
     /* 2260263 */   GIR_EraseRootFromParent_Done,
     /* 2260264 */ // Label 30305: @2260264
     /* 2260264 */ GIM_Try, /*On fail goto*//*Label 30306*/ GIMT_Encode4(2260312), // Rule ID 48831 //
     /* 2260269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260275 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260282 */   // MIs[0] Operand 1
     /* 2260282 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260291 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260295 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2260298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260300 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260302 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260310 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260311 */   // GIR_Coverage, 48831,
     /* 2260311 */   GIR_EraseRootFromParent_Done,
     /* 2260312 */ // Label 30306: @2260312
     /* 2260312 */ GIM_Try, /*On fail goto*//*Label 30307*/ GIMT_Encode4(2260360), // Rule ID 48838 //
     /* 2260317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260330 */   // MIs[0] Operand 1
     /* 2260330 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260339 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260343 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2260346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260348 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260350 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260358 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260359 */   // GIR_Coverage, 48838,
     /* 2260359 */   GIR_EraseRootFromParent_Done,
     /* 2260360 */ // Label 30307: @2260360
     /* 2260360 */ GIM_Try, /*On fail goto*//*Label 30308*/ GIMT_Encode4(2260408), // Rule ID 48839 //
     /* 2260365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260371 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260378 */   // MIs[0] Operand 1
     /* 2260378 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260387 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260391 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2260394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260396 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260398 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260406 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260407 */   // GIR_Coverage, 48839,
     /* 2260407 */   GIR_EraseRootFromParent_Done,
     /* 2260408 */ // Label 30308: @2260408
     /* 2260408 */ GIM_Try, /*On fail goto*//*Label 30309*/ GIMT_Encode4(2260456), // Rule ID 48846 //
     /* 2260413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260426 */   // MIs[0] Operand 1
     /* 2260426 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260435 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260439 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2260442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260444 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260446 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260454 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260455 */   // GIR_Coverage, 48846,
     /* 2260455 */   GIR_EraseRootFromParent_Done,
     /* 2260456 */ // Label 30309: @2260456
     /* 2260456 */ GIM_Try, /*On fail goto*//*Label 30310*/ GIMT_Encode4(2260504), // Rule ID 48847 //
     /* 2260461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260467 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260474 */   // MIs[0] Operand 1
     /* 2260474 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260483 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260487 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2260490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260492 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260494 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260503 */   // GIR_Coverage, 48847,
     /* 2260503 */   GIR_EraseRootFromParent_Done,
     /* 2260504 */ // Label 30310: @2260504
     /* 2260504 */ GIM_Try, /*On fail goto*//*Label 30311*/ GIMT_Encode4(2260552), // Rule ID 48860 //
     /* 2260509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260522 */   // MIs[0] Operand 1
     /* 2260522 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260531 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260535 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260540 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260542 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260550 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260551 */   // GIR_Coverage, 48860,
     /* 2260551 */   GIR_EraseRootFromParent_Done,
     /* 2260552 */ // Label 30311: @2260552
     /* 2260552 */ GIM_Try, /*On fail goto*//*Label 30312*/ GIMT_Encode4(2260600), // Rule ID 48861 //
     /* 2260557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260563 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260570 */   // MIs[0] Operand 1
     /* 2260570 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260579 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260583 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260588 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260590 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260599 */   // GIR_Coverage, 48861,
     /* 2260599 */   GIR_EraseRootFromParent_Done,
     /* 2260600 */ // Label 30312: @2260600
     /* 2260600 */ GIM_Try, /*On fail goto*//*Label 30313*/ GIMT_Encode4(2260648), // Rule ID 48874 //
     /* 2260605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260611 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260618 */   // MIs[0] Operand 1
     /* 2260618 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260627 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260631 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2260634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260636 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260638 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260646 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260647 */   // GIR_Coverage, 48874,
     /* 2260647 */   GIR_EraseRootFromParent_Done,
     /* 2260648 */ // Label 30313: @2260648
     /* 2260648 */ GIM_Try, /*On fail goto*//*Label 30314*/ GIMT_Encode4(2260696), // Rule ID 48875 //
     /* 2260653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260659 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260666 */   // MIs[0] Operand 1
     /* 2260666 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260675 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260679 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2260682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260684 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260686 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260694 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260695 */   // GIR_Coverage, 48875,
     /* 2260695 */   GIR_EraseRootFromParent_Done,
     /* 2260696 */ // Label 30314: @2260696
     /* 2260696 */ GIM_Try, /*On fail goto*//*Label 30315*/ GIMT_Encode4(2260744), // Rule ID 48882 //
     /* 2260701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260714 */   // MIs[0] Operand 1
     /* 2260714 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260723 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260727 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2260730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260732 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260734 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260742 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260743 */   // GIR_Coverage, 48882,
     /* 2260743 */   GIR_EraseRootFromParent_Done,
     /* 2260744 */ // Label 30315: @2260744
     /* 2260744 */ GIM_Try, /*On fail goto*//*Label 30316*/ GIMT_Encode4(2260792), // Rule ID 48883 //
     /* 2260749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260755 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260762 */   // MIs[0] Operand 1
     /* 2260762 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260771 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260775 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2260778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260780 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260782 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260791 */   // GIR_Coverage, 48883,
     /* 2260791 */   GIR_EraseRootFromParent_Done,
     /* 2260792 */ // Label 30316: @2260792
     /* 2260792 */ GIM_Try, /*On fail goto*//*Label 30317*/ GIMT_Encode4(2260840), // Rule ID 48890 //
     /* 2260797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260803 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260810 */   // MIs[0] Operand 1
     /* 2260810 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260819 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260823 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2260826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260828 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260830 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260838 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260839 */   // GIR_Coverage, 48890,
     /* 2260839 */   GIR_EraseRootFromParent_Done,
     /* 2260840 */ // Label 30317: @2260840
     /* 2260840 */ GIM_Try, /*On fail goto*//*Label 30318*/ GIMT_Encode4(2260888), // Rule ID 48891 //
     /* 2260845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260851 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260858 */   // MIs[0] Operand 1
     /* 2260858 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260867 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260871 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2260874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260876 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260878 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260887 */   // GIR_Coverage, 48891,
     /* 2260887 */   GIR_EraseRootFromParent_Done,
     /* 2260888 */ // Label 30318: @2260888
     /* 2260888 */ GIM_Try, /*On fail goto*//*Label 30319*/ GIMT_Encode4(2260936), // Rule ID 48904 //
     /* 2260893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260899 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260906 */   // MIs[0] Operand 1
     /* 2260906 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260915 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260919 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260924 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260926 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260935 */   // GIR_Coverage, 48904,
     /* 2260935 */   GIR_EraseRootFromParent_Done,
     /* 2260936 */ // Label 30319: @2260936
     /* 2260936 */ GIM_Try, /*On fail goto*//*Label 30320*/ GIMT_Encode4(2260984), // Rule ID 48905 //
     /* 2260941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260954 */   // MIs[0] Operand 1
     /* 2260954 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260963 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260967 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260972 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260974 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260983 */   // GIR_Coverage, 48905,
     /* 2260983 */   GIR_EraseRootFromParent_Done,
     /* 2260984 */ // Label 30320: @2260984
     /* 2260984 */ GIM_Try, /*On fail goto*//*Label 30321*/ GIMT_Encode4(2261032), // Rule ID 48918 //
     /* 2260989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261002 */   // MIs[0] Operand 1
     /* 2261002 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2261007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261011 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261015 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2261018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261020 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261022 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261031 */   // GIR_Coverage, 48918,
     /* 2261031 */   GIR_EraseRootFromParent_Done,
     /* 2261032 */ // Label 30321: @2261032
     /* 2261032 */ GIM_Try, /*On fail goto*//*Label 30322*/ GIMT_Encode4(2261080), // Rule ID 48919 //
     /* 2261037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2261043 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2261046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261050 */   // MIs[0] Operand 1
     /* 2261050 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2261055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261059 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261063 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2261066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261068 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261070 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261078 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261079 */   // GIR_Coverage, 48919,
     /* 2261079 */   GIR_EraseRootFromParent_Done,
     /* 2261080 */ // Label 30322: @2261080
     /* 2261080 */ GIM_Try, /*On fail goto*//*Label 30323*/ GIMT_Encode4(2261128), // Rule ID 48926 //
     /* 2261085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261091 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261098 */   // MIs[0] Operand 1
     /* 2261098 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2261103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261107 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261111 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2261114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261116 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261118 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261126 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261127 */   // GIR_Coverage, 48926,
     /* 2261127 */   GIR_EraseRootFromParent_Done,
     /* 2261128 */ // Label 30323: @2261128
     /* 2261128 */ GIM_Try, /*On fail goto*//*Label 30324*/ GIMT_Encode4(2261176), // Rule ID 48927 //
     /* 2261133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261139 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261146 */   // MIs[0] Operand 1
     /* 2261146 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2261151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261155 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261159 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2261162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261164 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261166 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261174 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261175 */   // GIR_Coverage, 48927,
     /* 2261175 */   GIR_EraseRootFromParent_Done,
     /* 2261176 */ // Label 30324: @2261176
     /* 2261176 */ GIM_Try, /*On fail goto*//*Label 30325*/ GIMT_Encode4(2261224), // Rule ID 48934 //
     /* 2261181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2261184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2261187 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2261190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261194 */   // MIs[0] Operand 1
     /* 2261194 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2261199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261203 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261207 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2261207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2261210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261212 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261214 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261223 */   // GIR_Coverage, 48934,
     /* 2261223 */   GIR_EraseRootFromParent_Done,
     /* 2261224 */ // Label 30325: @2261224
     /* 2261224 */ GIM_Try, /*On fail goto*//*Label 30326*/ GIMT_Encode4(2261272), // Rule ID 48935 //
     /* 2261229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2261232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2261235 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2261238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261242 */   // MIs[0] Operand 1
     /* 2261242 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2261247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261251 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261255 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2261255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2261258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261260 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261262 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261270 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261271 */   // GIR_Coverage, 48935,
     /* 2261271 */   GIR_EraseRootFromParent_Done,
     /* 2261272 */ // Label 30326: @2261272
     /* 2261272 */ GIM_Reject,
     /* 2261273 */ // Label 29905: @2261273
     /* 2261273 */ GIM_Try, /*On fail goto*//*Label 30327*/ GIMT_Encode4(2261321), // Rule ID 48518 //
     /* 2261278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261284 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261291 */   // MIs[0] Operand 1
     /* 2261291 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261300 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261304 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2261307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261309 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261311 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261319 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261320 */   // GIR_Coverage, 48518,
     /* 2261320 */   GIR_EraseRootFromParent_Done,
     /* 2261321 */ // Label 30327: @2261321
     /* 2261321 */ GIM_Try, /*On fail goto*//*Label 30328*/ GIMT_Encode4(2261369), // Rule ID 48519 //
     /* 2261326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261332 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261339 */   // MIs[0] Operand 1
     /* 2261339 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261348 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261352 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2261355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261357 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261359 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261367 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261368 */   // GIR_Coverage, 48519,
     /* 2261368 */   GIR_EraseRootFromParent_Done,
     /* 2261369 */ // Label 30328: @2261369
     /* 2261369 */ GIM_Try, /*On fail goto*//*Label 30329*/ GIMT_Encode4(2261417), // Rule ID 48526 //
     /* 2261374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261380 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261387 */   // MIs[0] Operand 1
     /* 2261387 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261396 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261400 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2261403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261405 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261407 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261416 */   // GIR_Coverage, 48526,
     /* 2261416 */   GIR_EraseRootFromParent_Done,
     /* 2261417 */ // Label 30329: @2261417
     /* 2261417 */ GIM_Try, /*On fail goto*//*Label 30330*/ GIMT_Encode4(2261465), // Rule ID 48527 //
     /* 2261422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261428 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261435 */   // MIs[0] Operand 1
     /* 2261435 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261444 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261448 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2261451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261453 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261455 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261463 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261464 */   // GIR_Coverage, 48527,
     /* 2261464 */   GIR_EraseRootFromParent_Done,
     /* 2261465 */ // Label 30330: @2261465
     /* 2261465 */ GIM_Try, /*On fail goto*//*Label 30331*/ GIMT_Encode4(2261513), // Rule ID 48534 //
     /* 2261470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261476 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261483 */   // MIs[0] Operand 1
     /* 2261483 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261492 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261496 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2261499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261501 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261503 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261511 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261512 */   // GIR_Coverage, 48534,
     /* 2261512 */   GIR_EraseRootFromParent_Done,
     /* 2261513 */ // Label 30331: @2261513
     /* 2261513 */ GIM_Try, /*On fail goto*//*Label 30332*/ GIMT_Encode4(2261561), // Rule ID 48535 //
     /* 2261518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261524 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261531 */   // MIs[0] Operand 1
     /* 2261531 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261540 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261544 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2261547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261549 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261551 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261559 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261560 */   // GIR_Coverage, 48535,
     /* 2261560 */   GIR_EraseRootFromParent_Done,
     /* 2261561 */ // Label 30332: @2261561
     /* 2261561 */ GIM_Try, /*On fail goto*//*Label 30333*/ GIMT_Encode4(2261609), // Rule ID 48562 //
     /* 2261566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261572 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261579 */   // MIs[0] Operand 1
     /* 2261579 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261588 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261592 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2261595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261597 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261599 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261607 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261608 */   // GIR_Coverage, 48562,
     /* 2261608 */   GIR_EraseRootFromParent_Done,
     /* 2261609 */ // Label 30333: @2261609
     /* 2261609 */ GIM_Try, /*On fail goto*//*Label 30334*/ GIMT_Encode4(2261657), // Rule ID 48563 //
     /* 2261614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261620 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261627 */   // MIs[0] Operand 1
     /* 2261627 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261636 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261640 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2261643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261645 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261647 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261656 */   // GIR_Coverage, 48563,
     /* 2261656 */   GIR_EraseRootFromParent_Done,
     /* 2261657 */ // Label 30334: @2261657
     /* 2261657 */ GIM_Try, /*On fail goto*//*Label 30335*/ GIMT_Encode4(2261705), // Rule ID 48570 //
     /* 2261662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261675 */   // MIs[0] Operand 1
     /* 2261675 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261684 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261688 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2261691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261693 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261695 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261703 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261704 */   // GIR_Coverage, 48570,
     /* 2261704 */   GIR_EraseRootFromParent_Done,
     /* 2261705 */ // Label 30335: @2261705
     /* 2261705 */ GIM_Try, /*On fail goto*//*Label 30336*/ GIMT_Encode4(2261753), // Rule ID 48571 //
     /* 2261710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261716 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261723 */   // MIs[0] Operand 1
     /* 2261723 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261732 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261736 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2261739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261741 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261743 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261751 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261752 */   // GIR_Coverage, 48571,
     /* 2261752 */   GIR_EraseRootFromParent_Done,
     /* 2261753 */ // Label 30336: @2261753
     /* 2261753 */ GIM_Try, /*On fail goto*//*Label 30337*/ GIMT_Encode4(2261801), // Rule ID 48578 //
     /* 2261758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261764 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261771 */   // MIs[0] Operand 1
     /* 2261771 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261776 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261780 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261784 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2261787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261789 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261791 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261799 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261800 */   // GIR_Coverage, 48578,
     /* 2261800 */   GIR_EraseRootFromParent_Done,
     /* 2261801 */ // Label 30337: @2261801
     /* 2261801 */ GIM_Try, /*On fail goto*//*Label 30338*/ GIMT_Encode4(2261849), // Rule ID 48579 //
     /* 2261806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261812 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261819 */   // MIs[0] Operand 1
     /* 2261819 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261828 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261832 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2261835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261837 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261839 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261847 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261848 */   // GIR_Coverage, 48579,
     /* 2261848 */   GIR_EraseRootFromParent_Done,
     /* 2261849 */ // Label 30338: @2261849
     /* 2261849 */ GIM_Try, /*On fail goto*//*Label 30339*/ GIMT_Encode4(2261897), // Rule ID 48606 //
     /* 2261854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261860 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261867 */   // MIs[0] Operand 1
     /* 2261867 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261876 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261880 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261885 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261887 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261896 */   // GIR_Coverage, 48606,
     /* 2261896 */   GIR_EraseRootFromParent_Done,
     /* 2261897 */ // Label 30339: @2261897
     /* 2261897 */ GIM_Try, /*On fail goto*//*Label 30340*/ GIMT_Encode4(2261945), // Rule ID 48607 //
     /* 2261902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261908 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261915 */   // MIs[0] Operand 1
     /* 2261915 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261924 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261928 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261933 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261935 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261943 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261944 */   // GIR_Coverage, 48607,
     /* 2261944 */   GIR_EraseRootFromParent_Done,
     /* 2261945 */ // Label 30340: @2261945
     /* 2261945 */ GIM_Try, /*On fail goto*//*Label 30341*/ GIMT_Encode4(2261993), // Rule ID 48614 //
     /* 2261950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261956 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261963 */   // MIs[0] Operand 1
     /* 2261963 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261972 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261976 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261981 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261983 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261991 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261992 */   // GIR_Coverage, 48614,
     /* 2261992 */   GIR_EraseRootFromParent_Done,
     /* 2261993 */ // Label 30341: @2261993
     /* 2261993 */ GIM_Try, /*On fail goto*//*Label 30342*/ GIMT_Encode4(2262041), // Rule ID 48615 //
     /* 2261998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262004 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262011 */   // MIs[0] Operand 1
     /* 2262011 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2262016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262020 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262024 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2262027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262029 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262031 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262039 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262040 */   // GIR_Coverage, 48615,
     /* 2262040 */   GIR_EraseRootFromParent_Done,
     /* 2262041 */ // Label 30342: @2262041
     /* 2262041 */ GIM_Try, /*On fail goto*//*Label 30343*/ GIMT_Encode4(2262089), // Rule ID 48622 //
     /* 2262046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262052 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262059 */   // MIs[0] Operand 1
     /* 2262059 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2262064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262068 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262072 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2262075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262077 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262079 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262087 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262088 */   // GIR_Coverage, 48622,
     /* 2262088 */   GIR_EraseRootFromParent_Done,
     /* 2262089 */ // Label 30343: @2262089
     /* 2262089 */ GIM_Try, /*On fail goto*//*Label 30344*/ GIMT_Encode4(2262137), // Rule ID 48623 //
     /* 2262094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262100 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262107 */   // MIs[0] Operand 1
     /* 2262107 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2262112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262116 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262120 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2262123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262125 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262127 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262135 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262136 */   // GIR_Coverage, 48623,
     /* 2262136 */   GIR_EraseRootFromParent_Done,
     /* 2262137 */ // Label 30344: @2262137
     /* 2262137 */ GIM_Try, /*On fail goto*//*Label 30345*/ GIMT_Encode4(2262185), // Rule ID 48648 //
     /* 2262142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262148 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262155 */   // MIs[0] Operand 1
     /* 2262155 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2262160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262164 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262168 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2262171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262173 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262175 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262183 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262184 */   // GIR_Coverage, 48648,
     /* 2262184 */   GIR_EraseRootFromParent_Done,
     /* 2262185 */ // Label 30345: @2262185
     /* 2262185 */ GIM_Try, /*On fail goto*//*Label 30346*/ GIMT_Encode4(2262233), // Rule ID 48649 //
     /* 2262190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262196 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262203 */   // MIs[0] Operand 1
     /* 2262203 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2262208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262212 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262216 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2262219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262221 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262223 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262231 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262232 */   // GIR_Coverage, 48649,
     /* 2262232 */   GIR_EraseRootFromParent_Done,
     /* 2262233 */ // Label 30346: @2262233
     /* 2262233 */ GIM_Try, /*On fail goto*//*Label 30347*/ GIMT_Encode4(2262281), // Rule ID 48656 //
     /* 2262238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262244 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262251 */   // MIs[0] Operand 1
     /* 2262251 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2262256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262260 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262264 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2262267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262269 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262271 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262279 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262280 */   // GIR_Coverage, 48656,
     /* 2262280 */   GIR_EraseRootFromParent_Done,
     /* 2262281 */ // Label 30347: @2262281
     /* 2262281 */ GIM_Try, /*On fail goto*//*Label 30348*/ GIMT_Encode4(2262329), // Rule ID 48657 //
     /* 2262286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262292 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262299 */   // MIs[0] Operand 1
     /* 2262299 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2262304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262308 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262312 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2262315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262317 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262319 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262327 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262328 */   // GIR_Coverage, 48657,
     /* 2262328 */   GIR_EraseRootFromParent_Done,
     /* 2262329 */ // Label 30348: @2262329
     /* 2262329 */ GIM_Try, /*On fail goto*//*Label 30349*/ GIMT_Encode4(2262377), // Rule ID 48664 //
     /* 2262334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262340 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262347 */   // MIs[0] Operand 1
     /* 2262347 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2262352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262356 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262360 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2262363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262365 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262367 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262375 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262376 */   // GIR_Coverage, 48664,
     /* 2262376 */   GIR_EraseRootFromParent_Done,
     /* 2262377 */ // Label 30349: @2262377
     /* 2262377 */ GIM_Try, /*On fail goto*//*Label 30350*/ GIMT_Encode4(2262425), // Rule ID 48665 //
     /* 2262382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262388 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262395 */   // MIs[0] Operand 1
     /* 2262395 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2262400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262404 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262408 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2262411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262413 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262415 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262423 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262424 */   // GIR_Coverage, 48665,
     /* 2262424 */   GIR_EraseRootFromParent_Done,
     /* 2262425 */ // Label 30350: @2262425
     /* 2262425 */ GIM_Try, /*On fail goto*//*Label 30351*/ GIMT_Encode4(2262473), // Rule ID 48692 //
     /* 2262430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262436 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262443 */   // MIs[0] Operand 1
     /* 2262443 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262452 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262456 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262461 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262463 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262471 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262472 */   // GIR_Coverage, 48692,
     /* 2262472 */   GIR_EraseRootFromParent_Done,
     /* 2262473 */ // Label 30351: @2262473
     /* 2262473 */ GIM_Try, /*On fail goto*//*Label 30352*/ GIMT_Encode4(2262521), // Rule ID 48693 //
     /* 2262478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262484 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262491 */   // MIs[0] Operand 1
     /* 2262491 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262500 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262504 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262509 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262511 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262520 */   // GIR_Coverage, 48693,
     /* 2262520 */   GIR_EraseRootFromParent_Done,
     /* 2262521 */ // Label 30352: @2262521
     /* 2262521 */ GIM_Try, /*On fail goto*//*Label 30353*/ GIMT_Encode4(2262569), // Rule ID 48700 //
     /* 2262526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262532 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262539 */   // MIs[0] Operand 1
     /* 2262539 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262548 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262552 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262557 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262559 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262567 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262568 */   // GIR_Coverage, 48700,
     /* 2262568 */   GIR_EraseRootFromParent_Done,
     /* 2262569 */ // Label 30353: @2262569
     /* 2262569 */ GIM_Try, /*On fail goto*//*Label 30354*/ GIMT_Encode4(2262617), // Rule ID 48701 //
     /* 2262574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262580 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262587 */   // MIs[0] Operand 1
     /* 2262587 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262596 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262600 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262605 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262607 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262615 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262616 */   // GIR_Coverage, 48701,
     /* 2262616 */   GIR_EraseRootFromParent_Done,
     /* 2262617 */ // Label 30354: @2262617
     /* 2262617 */ GIM_Try, /*On fail goto*//*Label 30355*/ GIMT_Encode4(2262665), // Rule ID 48708 //
     /* 2262622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262628 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262635 */   // MIs[0] Operand 1
     /* 2262635 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262644 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262648 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262653 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262655 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262663 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262664 */   // GIR_Coverage, 48708,
     /* 2262664 */   GIR_EraseRootFromParent_Done,
     /* 2262665 */ // Label 30355: @2262665
     /* 2262665 */ GIM_Try, /*On fail goto*//*Label 30356*/ GIMT_Encode4(2262713), // Rule ID 48709 //
     /* 2262670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262676 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262683 */   // MIs[0] Operand 1
     /* 2262683 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262692 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262696 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262701 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262703 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262711 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262712 */   // GIR_Coverage, 48709,
     /* 2262712 */   GIR_EraseRootFromParent_Done,
     /* 2262713 */ // Label 30356: @2262713
     /* 2262713 */ GIM_Try, /*On fail goto*//*Label 30357*/ GIMT_Encode4(2262761), // Rule ID 48736 //
     /* 2262718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262724 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262731 */   // MIs[0] Operand 1
     /* 2262731 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262740 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262744 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262749 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262751 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262760 */   // GIR_Coverage, 48736,
     /* 2262760 */   GIR_EraseRootFromParent_Done,
     /* 2262761 */ // Label 30357: @2262761
     /* 2262761 */ GIM_Try, /*On fail goto*//*Label 30358*/ GIMT_Encode4(2262809), // Rule ID 48737 //
     /* 2262766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262772 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262779 */   // MIs[0] Operand 1
     /* 2262779 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262788 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262792 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262797 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262799 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262807 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262808 */   // GIR_Coverage, 48737,
     /* 2262808 */   GIR_EraseRootFromParent_Done,
     /* 2262809 */ // Label 30358: @2262809
     /* 2262809 */ GIM_Try, /*On fail goto*//*Label 30359*/ GIMT_Encode4(2262857), // Rule ID 48744 //
     /* 2262814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262820 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262827 */   // MIs[0] Operand 1
     /* 2262827 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262836 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262840 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262845 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262847 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262855 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262856 */   // GIR_Coverage, 48744,
     /* 2262856 */   GIR_EraseRootFromParent_Done,
     /* 2262857 */ // Label 30359: @2262857
     /* 2262857 */ GIM_Try, /*On fail goto*//*Label 30360*/ GIMT_Encode4(2262905), // Rule ID 48745 //
     /* 2262862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262868 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262875 */   // MIs[0] Operand 1
     /* 2262875 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262884 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262888 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262893 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262895 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262903 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262904 */   // GIR_Coverage, 48745,
     /* 2262904 */   GIR_EraseRootFromParent_Done,
     /* 2262905 */ // Label 30360: @2262905
     /* 2262905 */ GIM_Try, /*On fail goto*//*Label 30361*/ GIMT_Encode4(2262953), // Rule ID 48752 //
     /* 2262910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262916 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262923 */   // MIs[0] Operand 1
     /* 2262923 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262932 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262936 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262941 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262943 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262951 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262952 */   // GIR_Coverage, 48752,
     /* 2262952 */   GIR_EraseRootFromParent_Done,
     /* 2262953 */ // Label 30361: @2262953
     /* 2262953 */ GIM_Try, /*On fail goto*//*Label 30362*/ GIMT_Encode4(2263001), // Rule ID 48753 //
     /* 2262958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262964 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262971 */   // MIs[0] Operand 1
     /* 2262971 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262980 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262984 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262989 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262991 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262999 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263000 */   // GIR_Coverage, 48753,
     /* 2263000 */   GIR_EraseRootFromParent_Done,
     /* 2263001 */ // Label 30362: @2263001
     /* 2263001 */ GIM_Try, /*On fail goto*//*Label 30363*/ GIMT_Encode4(2263049), // Rule ID 48780 //
     /* 2263006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263012 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263019 */   // MIs[0] Operand 1
     /* 2263019 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263028 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263032 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2263035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263037 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263039 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263047 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263048 */   // GIR_Coverage, 48780,
     /* 2263048 */   GIR_EraseRootFromParent_Done,
     /* 2263049 */ // Label 30363: @2263049
     /* 2263049 */ GIM_Try, /*On fail goto*//*Label 30364*/ GIMT_Encode4(2263097), // Rule ID 48781 //
     /* 2263054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263060 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263067 */   // MIs[0] Operand 1
     /* 2263067 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263076 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263080 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2263083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263085 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263087 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263095 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263096 */   // GIR_Coverage, 48781,
     /* 2263096 */   GIR_EraseRootFromParent_Done,
     /* 2263097 */ // Label 30364: @2263097
     /* 2263097 */ GIM_Try, /*On fail goto*//*Label 30365*/ GIMT_Encode4(2263145), // Rule ID 48788 //
     /* 2263102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263108 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263115 */   // MIs[0] Operand 1
     /* 2263115 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263124 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263128 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2263131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263133 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263135 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263143 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263144 */   // GIR_Coverage, 48788,
     /* 2263144 */   GIR_EraseRootFromParent_Done,
     /* 2263145 */ // Label 30365: @2263145
     /* 2263145 */ GIM_Try, /*On fail goto*//*Label 30366*/ GIMT_Encode4(2263193), // Rule ID 48789 //
     /* 2263150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263156 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263163 */   // MIs[0] Operand 1
     /* 2263163 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263172 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263176 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2263179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263181 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263183 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263191 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263192 */   // GIR_Coverage, 48789,
     /* 2263192 */   GIR_EraseRootFromParent_Done,
     /* 2263193 */ // Label 30366: @2263193
     /* 2263193 */ GIM_Try, /*On fail goto*//*Label 30367*/ GIMT_Encode4(2263241), // Rule ID 48796 //
     /* 2263198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263204 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263211 */   // MIs[0] Operand 1
     /* 2263211 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263220 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263224 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263229 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263231 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263239 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263240 */   // GIR_Coverage, 48796,
     /* 2263240 */   GIR_EraseRootFromParent_Done,
     /* 2263241 */ // Label 30367: @2263241
     /* 2263241 */ GIM_Try, /*On fail goto*//*Label 30368*/ GIMT_Encode4(2263289), // Rule ID 48797 //
     /* 2263246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263252 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263259 */   // MIs[0] Operand 1
     /* 2263259 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263268 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263272 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263277 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263279 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263287 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263288 */   // GIR_Coverage, 48797,
     /* 2263288 */   GIR_EraseRootFromParent_Done,
     /* 2263289 */ // Label 30368: @2263289
     /* 2263289 */ GIM_Try, /*On fail goto*//*Label 30369*/ GIMT_Encode4(2263337), // Rule ID 48824 //
     /* 2263294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263300 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263307 */   // MIs[0] Operand 1
     /* 2263307 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263316 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263320 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2263323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263325 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263327 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263335 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263336 */   // GIR_Coverage, 48824,
     /* 2263336 */   GIR_EraseRootFromParent_Done,
     /* 2263337 */ // Label 30369: @2263337
     /* 2263337 */ GIM_Try, /*On fail goto*//*Label 30370*/ GIMT_Encode4(2263385), // Rule ID 48825 //
     /* 2263342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263348 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263355 */   // MIs[0] Operand 1
     /* 2263355 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263360 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263364 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263368 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2263371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263373 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263375 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263383 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263384 */   // GIR_Coverage, 48825,
     /* 2263384 */   GIR_EraseRootFromParent_Done,
     /* 2263385 */ // Label 30370: @2263385
     /* 2263385 */ GIM_Try, /*On fail goto*//*Label 30371*/ GIMT_Encode4(2263433), // Rule ID 48832 //
     /* 2263390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263396 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263403 */   // MIs[0] Operand 1
     /* 2263403 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263412 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263416 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2263419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263421 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263423 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263431 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263432 */   // GIR_Coverage, 48832,
     /* 2263432 */   GIR_EraseRootFromParent_Done,
     /* 2263433 */ // Label 30371: @2263433
     /* 2263433 */ GIM_Try, /*On fail goto*//*Label 30372*/ GIMT_Encode4(2263481), // Rule ID 48833 //
     /* 2263438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263444 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263451 */   // MIs[0] Operand 1
     /* 2263451 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263460 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263464 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2263467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263469 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263471 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263479 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263480 */   // GIR_Coverage, 48833,
     /* 2263480 */   GIR_EraseRootFromParent_Done,
     /* 2263481 */ // Label 30372: @2263481
     /* 2263481 */ GIM_Try, /*On fail goto*//*Label 30373*/ GIMT_Encode4(2263529), // Rule ID 48840 //
     /* 2263486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263492 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263499 */   // MIs[0] Operand 1
     /* 2263499 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263508 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263512 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263517 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263519 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263527 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263528 */   // GIR_Coverage, 48840,
     /* 2263528 */   GIR_EraseRootFromParent_Done,
     /* 2263529 */ // Label 30373: @2263529
     /* 2263529 */ GIM_Try, /*On fail goto*//*Label 30374*/ GIMT_Encode4(2263577), // Rule ID 48841 //
     /* 2263534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263540 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263547 */   // MIs[0] Operand 1
     /* 2263547 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263556 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263560 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263565 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263567 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263575 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263576 */   // GIR_Coverage, 48841,
     /* 2263576 */   GIR_EraseRootFromParent_Done,
     /* 2263577 */ // Label 30374: @2263577
     /* 2263577 */ GIM_Try, /*On fail goto*//*Label 30375*/ GIMT_Encode4(2263625), // Rule ID 48868 //
     /* 2263582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263588 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263595 */   // MIs[0] Operand 1
     /* 2263595 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263604 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263608 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263613 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263615 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263623 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263624 */   // GIR_Coverage, 48868,
     /* 2263624 */   GIR_EraseRootFromParent_Done,
     /* 2263625 */ // Label 30375: @2263625
     /* 2263625 */ GIM_Try, /*On fail goto*//*Label 30376*/ GIMT_Encode4(2263673), // Rule ID 48869 //
     /* 2263630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263636 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263643 */   // MIs[0] Operand 1
     /* 2263643 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263652 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263656 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263661 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263663 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263671 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263672 */   // GIR_Coverage, 48869,
     /* 2263672 */   GIR_EraseRootFromParent_Done,
     /* 2263673 */ // Label 30376: @2263673
     /* 2263673 */ GIM_Try, /*On fail goto*//*Label 30377*/ GIMT_Encode4(2263721), // Rule ID 48876 //
     /* 2263678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263684 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263691 */   // MIs[0] Operand 1
     /* 2263691 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263700 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263704 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263709 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263711 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263719 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263720 */   // GIR_Coverage, 48876,
     /* 2263720 */   GIR_EraseRootFromParent_Done,
     /* 2263721 */ // Label 30377: @2263721
     /* 2263721 */ GIM_Try, /*On fail goto*//*Label 30378*/ GIMT_Encode4(2263769), // Rule ID 48877 //
     /* 2263726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263732 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263739 */   // MIs[0] Operand 1
     /* 2263739 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263748 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263752 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263757 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263759 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263767 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263768 */   // GIR_Coverage, 48877,
     /* 2263768 */   GIR_EraseRootFromParent_Done,
     /* 2263769 */ // Label 30378: @2263769
     /* 2263769 */ GIM_Try, /*On fail goto*//*Label 30379*/ GIMT_Encode4(2263817), // Rule ID 48884 //
     /* 2263774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263780 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263787 */   // MIs[0] Operand 1
     /* 2263787 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263796 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263800 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2263803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263805 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263807 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263816 */   // GIR_Coverage, 48884,
     /* 2263816 */   GIR_EraseRootFromParent_Done,
     /* 2263817 */ // Label 30379: @2263817
     /* 2263817 */ GIM_Try, /*On fail goto*//*Label 30380*/ GIMT_Encode4(2263865), // Rule ID 48885 //
     /* 2263822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263828 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263835 */   // MIs[0] Operand 1
     /* 2263835 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263844 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263848 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2263851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263853 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263855 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263863 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263864 */   // GIR_Coverage, 48885,
     /* 2263864 */   GIR_EraseRootFromParent_Done,
     /* 2263865 */ // Label 30380: @2263865
     /* 2263865 */ GIM_Try, /*On fail goto*//*Label 30381*/ GIMT_Encode4(2263913), // Rule ID 48912 //
     /* 2263870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263876 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263883 */   // MIs[0] Operand 1
     /* 2263883 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263892 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263896 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263901 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263903 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263912 */   // GIR_Coverage, 48912,
     /* 2263912 */   GIR_EraseRootFromParent_Done,
     /* 2263913 */ // Label 30381: @2263913
     /* 2263913 */ GIM_Try, /*On fail goto*//*Label 30382*/ GIMT_Encode4(2263961), // Rule ID 48913 //
     /* 2263918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263924 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263931 */   // MIs[0] Operand 1
     /* 2263931 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263940 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263944 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263949 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263951 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263960 */   // GIR_Coverage, 48913,
     /* 2263960 */   GIR_EraseRootFromParent_Done,
     /* 2263961 */ // Label 30382: @2263961
     /* 2263961 */ GIM_Try, /*On fail goto*//*Label 30383*/ GIMT_Encode4(2264009), // Rule ID 48920 //
     /* 2263966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263972 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263979 */   // MIs[0] Operand 1
     /* 2263979 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263988 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263992 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263997 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263999 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264008 */   // GIR_Coverage, 48920,
     /* 2264008 */   GIR_EraseRootFromParent_Done,
     /* 2264009 */ // Label 30383: @2264009
     /* 2264009 */ GIM_Try, /*On fail goto*//*Label 30384*/ GIMT_Encode4(2264057), // Rule ID 48921 //
     /* 2264014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2264020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2264023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264027 */   // MIs[0] Operand 1
     /* 2264027 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2264032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264036 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264040 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2264043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264045 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264047 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264055 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264056 */   // GIR_Coverage, 48921,
     /* 2264056 */   GIR_EraseRootFromParent_Done,
     /* 2264057 */ // Label 30384: @2264057
     /* 2264057 */ GIM_Try, /*On fail goto*//*Label 30385*/ GIMT_Encode4(2264105), // Rule ID 48928 //
     /* 2264062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2264068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2264071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264075 */   // MIs[0] Operand 1
     /* 2264075 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2264080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264084 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264088 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2264088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2264091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264093 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264095 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264104 */   // GIR_Coverage, 48928,
     /* 2264104 */   GIR_EraseRootFromParent_Done,
     /* 2264105 */ // Label 30385: @2264105
     /* 2264105 */ GIM_Try, /*On fail goto*//*Label 30386*/ GIMT_Encode4(2264153), // Rule ID 48929 //
     /* 2264110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2264116 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2264119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264123 */   // MIs[0] Operand 1
     /* 2264123 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2264128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264132 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264136 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2264136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2264139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264141 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264143 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264151 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264152 */   // GIR_Coverage, 48929,
     /* 2264152 */   GIR_EraseRootFromParent_Done,
     /* 2264153 */ // Label 30386: @2264153
     /* 2264153 */ GIM_Reject,
     /* 2264154 */ // Label 29906: @2264154
     /* 2264154 */ GIM_Try, /*On fail goto*//*Label 30387*/ GIMT_Encode4(2264202), // Rule ID 48520 //
     /* 2264159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264165 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264172 */   // MIs[0] Operand 1
     /* 2264172 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264181 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264185 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2264188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264190 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264192 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264201 */   // GIR_Coverage, 48520,
     /* 2264201 */   GIR_EraseRootFromParent_Done,
     /* 2264202 */ // Label 30387: @2264202
     /* 2264202 */ GIM_Try, /*On fail goto*//*Label 30388*/ GIMT_Encode4(2264250), // Rule ID 48521 //
     /* 2264207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264213 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264220 */   // MIs[0] Operand 1
     /* 2264220 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264229 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264233 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2264236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264238 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264240 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264248 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264249 */   // GIR_Coverage, 48521,
     /* 2264249 */   GIR_EraseRootFromParent_Done,
     /* 2264250 */ // Label 30388: @2264250
     /* 2264250 */ GIM_Try, /*On fail goto*//*Label 30389*/ GIMT_Encode4(2264298), // Rule ID 48528 //
     /* 2264255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264261 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264268 */   // MIs[0] Operand 1
     /* 2264268 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264277 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264281 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2264284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264286 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264288 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264296 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264297 */   // GIR_Coverage, 48528,
     /* 2264297 */   GIR_EraseRootFromParent_Done,
     /* 2264298 */ // Label 30389: @2264298
     /* 2264298 */ GIM_Try, /*On fail goto*//*Label 30390*/ GIMT_Encode4(2264346), // Rule ID 48529 //
     /* 2264303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264309 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264316 */   // MIs[0] Operand 1
     /* 2264316 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264325 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264329 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2264332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264334 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264336 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264344 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264345 */   // GIR_Coverage, 48529,
     /* 2264345 */   GIR_EraseRootFromParent_Done,
     /* 2264346 */ // Label 30390: @2264346
     /* 2264346 */ GIM_Try, /*On fail goto*//*Label 30391*/ GIMT_Encode4(2264394), // Rule ID 48564 //
     /* 2264351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264357 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264364 */   // MIs[0] Operand 1
     /* 2264364 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264373 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264377 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2264380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264382 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264384 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264392 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264393 */   // GIR_Coverage, 48564,
     /* 2264393 */   GIR_EraseRootFromParent_Done,
     /* 2264394 */ // Label 30391: @2264394
     /* 2264394 */ GIM_Try, /*On fail goto*//*Label 30392*/ GIMT_Encode4(2264442), // Rule ID 48565 //
     /* 2264399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264405 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264412 */   // MIs[0] Operand 1
     /* 2264412 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264417 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264421 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264425 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2264428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264430 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264432 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264440 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264441 */   // GIR_Coverage, 48565,
     /* 2264441 */   GIR_EraseRootFromParent_Done,
     /* 2264442 */ // Label 30392: @2264442
     /* 2264442 */ GIM_Try, /*On fail goto*//*Label 30393*/ GIMT_Encode4(2264490), // Rule ID 48572 //
     /* 2264447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264453 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264460 */   // MIs[0] Operand 1
     /* 2264460 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264469 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264473 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2264476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264478 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264480 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264488 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264489 */   // GIR_Coverage, 48572,
     /* 2264489 */   GIR_EraseRootFromParent_Done,
     /* 2264490 */ // Label 30393: @2264490
     /* 2264490 */ GIM_Try, /*On fail goto*//*Label 30394*/ GIMT_Encode4(2264538), // Rule ID 48573 //
     /* 2264495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264501 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264508 */   // MIs[0] Operand 1
     /* 2264508 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264517 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264521 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2264524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264526 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264528 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264536 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264537 */   // GIR_Coverage, 48573,
     /* 2264537 */   GIR_EraseRootFromParent_Done,
     /* 2264538 */ // Label 30394: @2264538
     /* 2264538 */ GIM_Try, /*On fail goto*//*Label 30395*/ GIMT_Encode4(2264586), // Rule ID 48608 //
     /* 2264543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264549 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264556 */   // MIs[0] Operand 1
     /* 2264556 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264565 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264569 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264574 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264576 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264584 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264585 */   // GIR_Coverage, 48608,
     /* 2264585 */   GIR_EraseRootFromParent_Done,
     /* 2264586 */ // Label 30395: @2264586
     /* 2264586 */ GIM_Try, /*On fail goto*//*Label 30396*/ GIMT_Encode4(2264634), // Rule ID 48609 //
     /* 2264591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264597 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264604 */   // MIs[0] Operand 1
     /* 2264604 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264613 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264617 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264622 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264624 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264632 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264633 */   // GIR_Coverage, 48609,
     /* 2264633 */   GIR_EraseRootFromParent_Done,
     /* 2264634 */ // Label 30396: @2264634
     /* 2264634 */ GIM_Try, /*On fail goto*//*Label 30397*/ GIMT_Encode4(2264682), // Rule ID 48616 //
     /* 2264639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264652 */   // MIs[0] Operand 1
     /* 2264652 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264661 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264665 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264670 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264672 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264680 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264681 */   // GIR_Coverage, 48616,
     /* 2264681 */   GIR_EraseRootFromParent_Done,
     /* 2264682 */ // Label 30397: @2264682
     /* 2264682 */ GIM_Try, /*On fail goto*//*Label 30398*/ GIMT_Encode4(2264730), // Rule ID 48617 //
     /* 2264687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264693 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264700 */   // MIs[0] Operand 1
     /* 2264700 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264709 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264713 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264718 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264720 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264728 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264729 */   // GIR_Coverage, 48617,
     /* 2264729 */   GIR_EraseRootFromParent_Done,
     /* 2264730 */ // Label 30398: @2264730
     /* 2264730 */ GIM_Try, /*On fail goto*//*Label 30399*/ GIMT_Encode4(2264778), // Rule ID 48650 //
     /* 2264735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264741 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264748 */   // MIs[0] Operand 1
     /* 2264748 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264757 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264761 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264766 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264768 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264776 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264777 */   // GIR_Coverage, 48650,
     /* 2264777 */   GIR_EraseRootFromParent_Done,
     /* 2264778 */ // Label 30399: @2264778
     /* 2264778 */ GIM_Try, /*On fail goto*//*Label 30400*/ GIMT_Encode4(2264826), // Rule ID 48651 //
     /* 2264783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264789 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264796 */   // MIs[0] Operand 1
     /* 2264796 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264805 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264809 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264814 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264816 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264824 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264825 */   // GIR_Coverage, 48651,
     /* 2264825 */   GIR_EraseRootFromParent_Done,
     /* 2264826 */ // Label 30400: @2264826
     /* 2264826 */ GIM_Try, /*On fail goto*//*Label 30401*/ GIMT_Encode4(2264874), // Rule ID 48658 //
     /* 2264831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264837 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264844 */   // MIs[0] Operand 1
     /* 2264844 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264853 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264857 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264862 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264864 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264872 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264873 */   // GIR_Coverage, 48658,
     /* 2264873 */   GIR_EraseRootFromParent_Done,
     /* 2264874 */ // Label 30401: @2264874
     /* 2264874 */ GIM_Try, /*On fail goto*//*Label 30402*/ GIMT_Encode4(2264922), // Rule ID 48659 //
     /* 2264879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264885 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264892 */   // MIs[0] Operand 1
     /* 2264892 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264901 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264905 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264910 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264912 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264920 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264921 */   // GIR_Coverage, 48659,
     /* 2264921 */   GIR_EraseRootFromParent_Done,
     /* 2264922 */ // Label 30402: @2264922
     /* 2264922 */ GIM_Try, /*On fail goto*//*Label 30403*/ GIMT_Encode4(2264970), // Rule ID 48694 //
     /* 2264927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264933 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264940 */   // MIs[0] Operand 1
     /* 2264940 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2264945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264949 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264953 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2264956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264958 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264960 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264968 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264969 */   // GIR_Coverage, 48694,
     /* 2264969 */   GIR_EraseRootFromParent_Done,
     /* 2264970 */ // Label 30403: @2264970
     /* 2264970 */ GIM_Try, /*On fail goto*//*Label 30404*/ GIMT_Encode4(2265018), // Rule ID 48695 //
     /* 2264975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264981 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264988 */   // MIs[0] Operand 1
     /* 2264988 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2264993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264997 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265001 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2265004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265006 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265008 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265016 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265017 */   // GIR_Coverage, 48695,
     /* 2265017 */   GIR_EraseRootFromParent_Done,
     /* 2265018 */ // Label 30404: @2265018
     /* 2265018 */ GIM_Try, /*On fail goto*//*Label 30405*/ GIMT_Encode4(2265066), // Rule ID 48702 //
     /* 2265023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265029 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265036 */   // MIs[0] Operand 1
     /* 2265036 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265045 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265049 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265054 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265056 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265064 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265065 */   // GIR_Coverage, 48702,
     /* 2265065 */   GIR_EraseRootFromParent_Done,
     /* 2265066 */ // Label 30405: @2265066
     /* 2265066 */ GIM_Try, /*On fail goto*//*Label 30406*/ GIMT_Encode4(2265114), // Rule ID 48703 //
     /* 2265071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265077 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265084 */   // MIs[0] Operand 1
     /* 2265084 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265093 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265097 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265102 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265104 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265112 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265113 */   // GIR_Coverage, 48703,
     /* 2265113 */   GIR_EraseRootFromParent_Done,
     /* 2265114 */ // Label 30406: @2265114
     /* 2265114 */ GIM_Try, /*On fail goto*//*Label 30407*/ GIMT_Encode4(2265162), // Rule ID 48738 //
     /* 2265119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265125 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265132 */   // MIs[0] Operand 1
     /* 2265132 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265141 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265145 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2265148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265150 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265152 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265161 */   // GIR_Coverage, 48738,
     /* 2265161 */   GIR_EraseRootFromParent_Done,
     /* 2265162 */ // Label 30407: @2265162
     /* 2265162 */ GIM_Try, /*On fail goto*//*Label 30408*/ GIMT_Encode4(2265210), // Rule ID 48739 //
     /* 2265167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265173 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265180 */   // MIs[0] Operand 1
     /* 2265180 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265189 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265193 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2265196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265198 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265200 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265208 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265209 */   // GIR_Coverage, 48739,
     /* 2265209 */   GIR_EraseRootFromParent_Done,
     /* 2265210 */ // Label 30408: @2265210
     /* 2265210 */ GIM_Try, /*On fail goto*//*Label 30409*/ GIMT_Encode4(2265258), // Rule ID 48746 //
     /* 2265215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265221 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265228 */   // MIs[0] Operand 1
     /* 2265228 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265237 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265241 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265246 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265248 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265256 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265257 */   // GIR_Coverage, 48746,
     /* 2265257 */   GIR_EraseRootFromParent_Done,
     /* 2265258 */ // Label 30409: @2265258
     /* 2265258 */ GIM_Try, /*On fail goto*//*Label 30410*/ GIMT_Encode4(2265306), // Rule ID 48747 //
     /* 2265263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265269 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265276 */   // MIs[0] Operand 1
     /* 2265276 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265285 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265289 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265294 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265296 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265304 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265305 */   // GIR_Coverage, 48747,
     /* 2265305 */   GIR_EraseRootFromParent_Done,
     /* 2265306 */ // Label 30410: @2265306
     /* 2265306 */ GIM_Try, /*On fail goto*//*Label 30411*/ GIMT_Encode4(2265354), // Rule ID 48782 //
     /* 2265311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265324 */   // MIs[0] Operand 1
     /* 2265324 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2265329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265333 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265337 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2265340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265342 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265344 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265352 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265353 */   // GIR_Coverage, 48782,
     /* 2265353 */   GIR_EraseRootFromParent_Done,
     /* 2265354 */ // Label 30411: @2265354
     /* 2265354 */ GIM_Try, /*On fail goto*//*Label 30412*/ GIMT_Encode4(2265402), // Rule ID 48783 //
     /* 2265359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265365 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265372 */   // MIs[0] Operand 1
     /* 2265372 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2265377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265381 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265385 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2265388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265390 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265392 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265400 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265401 */   // GIR_Coverage, 48783,
     /* 2265401 */   GIR_EraseRootFromParent_Done,
     /* 2265402 */ // Label 30412: @2265402
     /* 2265402 */ GIM_Try, /*On fail goto*//*Label 30413*/ GIMT_Encode4(2265450), // Rule ID 48790 //
     /* 2265407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265413 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265420 */   // MIs[0] Operand 1
     /* 2265420 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2265425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265429 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265433 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265438 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265440 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265449 */   // GIR_Coverage, 48790,
     /* 2265449 */   GIR_EraseRootFromParent_Done,
     /* 2265450 */ // Label 30413: @2265450
     /* 2265450 */ GIM_Try, /*On fail goto*//*Label 30414*/ GIMT_Encode4(2265498), // Rule ID 48791 //
     /* 2265455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265461 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265468 */   // MIs[0] Operand 1
     /* 2265468 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2265473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265477 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265481 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265486 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265488 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265496 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265497 */   // GIR_Coverage, 48791,
     /* 2265497 */   GIR_EraseRootFromParent_Done,
     /* 2265498 */ // Label 30414: @2265498
     /* 2265498 */ GIM_Try, /*On fail goto*//*Label 30415*/ GIMT_Encode4(2265546), // Rule ID 48826 //
     /* 2265503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265509 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265516 */   // MIs[0] Operand 1
     /* 2265516 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265525 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265529 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2265532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265534 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265536 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265545 */   // GIR_Coverage, 48826,
     /* 2265545 */   GIR_EraseRootFromParent_Done,
     /* 2265546 */ // Label 30415: @2265546
     /* 2265546 */ GIM_Try, /*On fail goto*//*Label 30416*/ GIMT_Encode4(2265594), // Rule ID 48827 //
     /* 2265551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265557 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265564 */   // MIs[0] Operand 1
     /* 2265564 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265573 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265577 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2265580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265582 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265584 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265592 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265593 */   // GIR_Coverage, 48827,
     /* 2265593 */   GIR_EraseRootFromParent_Done,
     /* 2265594 */ // Label 30416: @2265594
     /* 2265594 */ GIM_Try, /*On fail goto*//*Label 30417*/ GIMT_Encode4(2265642), // Rule ID 48834 //
     /* 2265599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265605 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265612 */   // MIs[0] Operand 1
     /* 2265612 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265621 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265625 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265630 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265632 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265640 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265641 */   // GIR_Coverage, 48834,
     /* 2265641 */   GIR_EraseRootFromParent_Done,
     /* 2265642 */ // Label 30417: @2265642
     /* 2265642 */ GIM_Try, /*On fail goto*//*Label 30418*/ GIMT_Encode4(2265690), // Rule ID 48835 //
     /* 2265647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265653 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265660 */   // MIs[0] Operand 1
     /* 2265660 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265669 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265673 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265678 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265680 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265688 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265689 */   // GIR_Coverage, 48835,
     /* 2265689 */   GIR_EraseRootFromParent_Done,
     /* 2265690 */ // Label 30418: @2265690
     /* 2265690 */ GIM_Try, /*On fail goto*//*Label 30419*/ GIMT_Encode4(2265738), // Rule ID 48870 //
     /* 2265695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265701 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265708 */   // MIs[0] Operand 1
     /* 2265708 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265717 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265721 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265726 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265728 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265736 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265737 */   // GIR_Coverage, 48870,
     /* 2265737 */   GIR_EraseRootFromParent_Done,
     /* 2265738 */ // Label 30419: @2265738
     /* 2265738 */ GIM_Try, /*On fail goto*//*Label 30420*/ GIMT_Encode4(2265786), // Rule ID 48871 //
     /* 2265743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265749 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265756 */   // MIs[0] Operand 1
     /* 2265756 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265765 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265769 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265774 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265776 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265784 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265785 */   // GIR_Coverage, 48871,
     /* 2265785 */   GIR_EraseRootFromParent_Done,
     /* 2265786 */ // Label 30420: @2265786
     /* 2265786 */ GIM_Try, /*On fail goto*//*Label 30421*/ GIMT_Encode4(2265834), // Rule ID 48878 //
     /* 2265791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265797 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265804 */   // MIs[0] Operand 1
     /* 2265804 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265813 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265817 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265822 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265824 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265833 */   // GIR_Coverage, 48878,
     /* 2265833 */   GIR_EraseRootFromParent_Done,
     /* 2265834 */ // Label 30421: @2265834
     /* 2265834 */ GIM_Try, /*On fail goto*//*Label 30422*/ GIMT_Encode4(2265882), // Rule ID 48879 //
     /* 2265839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265845 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265852 */   // MIs[0] Operand 1
     /* 2265852 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265861 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265865 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265870 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265872 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265880 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265881 */   // GIR_Coverage, 48879,
     /* 2265881 */   GIR_EraseRootFromParent_Done,
     /* 2265882 */ // Label 30422: @2265882
     /* 2265882 */ GIM_Try, /*On fail goto*//*Label 30423*/ GIMT_Encode4(2265930), // Rule ID 48914 //
     /* 2265887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265893 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265900 */   // MIs[0] Operand 1
     /* 2265900 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265909 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265913 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265918 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265920 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265928 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265929 */   // GIR_Coverage, 48914,
     /* 2265929 */   GIR_EraseRootFromParent_Done,
     /* 2265930 */ // Label 30423: @2265930
     /* 2265930 */ GIM_Try, /*On fail goto*//*Label 30424*/ GIMT_Encode4(2265978), // Rule ID 48915 //
     /* 2265935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265941 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265948 */   // MIs[0] Operand 1
     /* 2265948 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265957 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265961 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265966 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265968 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265976 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265977 */   // GIR_Coverage, 48915,
     /* 2265977 */   GIR_EraseRootFromParent_Done,
     /* 2265978 */ // Label 30424: @2265978
     /* 2265978 */ GIM_Try, /*On fail goto*//*Label 30425*/ GIMT_Encode4(2266026), // Rule ID 48922 //
     /* 2265983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265989 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265996 */   // MIs[0] Operand 1
     /* 2265996 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266005 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266009 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2266009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266014 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266016 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266024 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266025 */   // GIR_Coverage, 48922,
     /* 2266025 */   GIR_EraseRootFromParent_Done,
     /* 2266026 */ // Label 30425: @2266026
     /* 2266026 */ GIM_Try, /*On fail goto*//*Label 30426*/ GIMT_Encode4(2266074), // Rule ID 48923 //
     /* 2266031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2266037 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2266040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266044 */   // MIs[0] Operand 1
     /* 2266044 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266053 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266057 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2266057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266062 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266064 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266072 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266073 */   // GIR_Coverage, 48923,
     /* 2266073 */   GIR_EraseRootFromParent_Done,
     /* 2266074 */ // Label 30426: @2266074
     /* 2266074 */ GIM_Reject,
     /* 2266075 */ // Label 29907: @2266075
     /* 2266075 */ GIM_Try, /*On fail goto*//*Label 30427*/ GIMT_Encode4(2266851),
     /* 2266080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2266083 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2266086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266090 */   GIM_Try, /*On fail goto*//*Label 30428*/ GIMT_Encode4(2266128), // Rule ID 48522 //
     /* 2266095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266098 */     // MIs[0] Operand 1
     /* 2266098 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2266103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266111 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2266114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266127 */     // GIR_Coverage, 48522,
     /* 2266127 */     GIR_EraseRootFromParent_Done,
     /* 2266128 */   // Label 30428: @2266128
     /* 2266128 */   GIM_Try, /*On fail goto*//*Label 30429*/ GIMT_Encode4(2266166), // Rule ID 48523 //
     /* 2266133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266136 */     // MIs[0] Operand 1
     /* 2266136 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2266141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266149 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2266152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266165 */     // GIR_Coverage, 48523,
     /* 2266165 */     GIR_EraseRootFromParent_Done,
     /* 2266166 */   // Label 30429: @2266166
     /* 2266166 */   GIM_Try, /*On fail goto*//*Label 30430*/ GIMT_Encode4(2266204), // Rule ID 48566 //
     /* 2266171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266174 */     // MIs[0] Operand 1
     /* 2266174 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2266179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266187 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2266190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266203 */     // GIR_Coverage, 48566,
     /* 2266203 */     GIR_EraseRootFromParent_Done,
     /* 2266204 */   // Label 30430: @2266204
     /* 2266204 */   GIM_Try, /*On fail goto*//*Label 30431*/ GIMT_Encode4(2266242), // Rule ID 48567 //
     /* 2266209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266212 */     // MIs[0] Operand 1
     /* 2266212 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2266217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266225 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2266228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266241 */     // GIR_Coverage, 48567,
     /* 2266241 */     GIR_EraseRootFromParent_Done,
     /* 2266242 */   // Label 30431: @2266242
     /* 2266242 */   GIM_Try, /*On fail goto*//*Label 30432*/ GIMT_Encode4(2266280), // Rule ID 48610 //
     /* 2266247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266250 */     // MIs[0] Operand 1
     /* 2266250 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2266255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266263 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2266266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266279 */     // GIR_Coverage, 48610,
     /* 2266279 */     GIR_EraseRootFromParent_Done,
     /* 2266280 */   // Label 30432: @2266280
     /* 2266280 */   GIM_Try, /*On fail goto*//*Label 30433*/ GIMT_Encode4(2266318), // Rule ID 48611 //
     /* 2266285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266288 */     // MIs[0] Operand 1
     /* 2266288 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2266293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266301 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2266304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266317 */     // GIR_Coverage, 48611,
     /* 2266317 */     GIR_EraseRootFromParent_Done,
     /* 2266318 */   // Label 30433: @2266318
     /* 2266318 */   GIM_Try, /*On fail goto*//*Label 30434*/ GIMT_Encode4(2266356), // Rule ID 48652 //
     /* 2266323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266326 */     // MIs[0] Operand 1
     /* 2266326 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2266331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266339 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2266342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266355 */     // GIR_Coverage, 48652,
     /* 2266355 */     GIR_EraseRootFromParent_Done,
     /* 2266356 */   // Label 30434: @2266356
     /* 2266356 */   GIM_Try, /*On fail goto*//*Label 30435*/ GIMT_Encode4(2266394), // Rule ID 48653 //
     /* 2266361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266364 */     // MIs[0] Operand 1
     /* 2266364 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2266369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266377 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2266380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266393 */     // GIR_Coverage, 48653,
     /* 2266393 */     GIR_EraseRootFromParent_Done,
     /* 2266394 */   // Label 30435: @2266394
     /* 2266394 */   GIM_Try, /*On fail goto*//*Label 30436*/ GIMT_Encode4(2266432), // Rule ID 48696 //
     /* 2266399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266402 */     // MIs[0] Operand 1
     /* 2266402 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2266407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266415 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2266418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266431 */     // GIR_Coverage, 48696,
     /* 2266431 */     GIR_EraseRootFromParent_Done,
     /* 2266432 */   // Label 30436: @2266432
     /* 2266432 */   GIM_Try, /*On fail goto*//*Label 30437*/ GIMT_Encode4(2266470), // Rule ID 48697 //
     /* 2266437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266440 */     // MIs[0] Operand 1
     /* 2266440 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2266445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266453 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2266456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266469 */     // GIR_Coverage, 48697,
     /* 2266469 */     GIR_EraseRootFromParent_Done,
     /* 2266470 */   // Label 30437: @2266470
     /* 2266470 */   GIM_Try, /*On fail goto*//*Label 30438*/ GIMT_Encode4(2266508), // Rule ID 48740 //
     /* 2266475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266478 */     // MIs[0] Operand 1
     /* 2266478 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2266483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266491 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2266494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266507 */     // GIR_Coverage, 48740,
     /* 2266507 */     GIR_EraseRootFromParent_Done,
     /* 2266508 */   // Label 30438: @2266508
     /* 2266508 */   GIM_Try, /*On fail goto*//*Label 30439*/ GIMT_Encode4(2266546), // Rule ID 48741 //
     /* 2266513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266516 */     // MIs[0] Operand 1
     /* 2266516 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2266521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266529 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2266532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266545 */     // GIR_Coverage, 48741,
     /* 2266545 */     GIR_EraseRootFromParent_Done,
     /* 2266546 */   // Label 30439: @2266546
     /* 2266546 */   GIM_Try, /*On fail goto*//*Label 30440*/ GIMT_Encode4(2266584), // Rule ID 48784 //
     /* 2266551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266554 */     // MIs[0] Operand 1
     /* 2266554 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2266559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266567 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266583 */     // GIR_Coverage, 48784,
     /* 2266583 */     GIR_EraseRootFromParent_Done,
     /* 2266584 */   // Label 30440: @2266584
     /* 2266584 */   GIM_Try, /*On fail goto*//*Label 30441*/ GIMT_Encode4(2266622), // Rule ID 48785 //
     /* 2266589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266592 */     // MIs[0] Operand 1
     /* 2266592 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2266597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266605 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266621 */     // GIR_Coverage, 48785,
     /* 2266621 */     GIR_EraseRootFromParent_Done,
     /* 2266622 */   // Label 30441: @2266622
     /* 2266622 */   GIM_Try, /*On fail goto*//*Label 30442*/ GIMT_Encode4(2266660), // Rule ID 48828 //
     /* 2266627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266630 */     // MIs[0] Operand 1
     /* 2266630 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2266635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266643 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266659 */     // GIR_Coverage, 48828,
     /* 2266659 */     GIR_EraseRootFromParent_Done,
     /* 2266660 */   // Label 30442: @2266660
     /* 2266660 */   GIM_Try, /*On fail goto*//*Label 30443*/ GIMT_Encode4(2266698), // Rule ID 48829 //
     /* 2266665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266668 */     // MIs[0] Operand 1
     /* 2266668 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2266673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266681 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266697 */     // GIR_Coverage, 48829,
     /* 2266697 */     GIR_EraseRootFromParent_Done,
     /* 2266698 */   // Label 30443: @2266698
     /* 2266698 */   GIM_Try, /*On fail goto*//*Label 30444*/ GIMT_Encode4(2266736), // Rule ID 48872 //
     /* 2266703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266706 */     // MIs[0] Operand 1
     /* 2266706 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2266711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266719 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266735 */     // GIR_Coverage, 48872,
     /* 2266735 */     GIR_EraseRootFromParent_Done,
     /* 2266736 */   // Label 30444: @2266736
     /* 2266736 */   GIM_Try, /*On fail goto*//*Label 30445*/ GIMT_Encode4(2266774), // Rule ID 48873 //
     /* 2266741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266744 */     // MIs[0] Operand 1
     /* 2266744 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2266749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266757 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266773 */     // GIR_Coverage, 48873,
     /* 2266773 */     GIR_EraseRootFromParent_Done,
     /* 2266774 */   // Label 30445: @2266774
     /* 2266774 */   GIM_Try, /*On fail goto*//*Label 30446*/ GIMT_Encode4(2266812), // Rule ID 48916 //
     /* 2266779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266782 */     // MIs[0] Operand 1
     /* 2266782 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266795 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266811 */     // GIR_Coverage, 48916,
     /* 2266811 */     GIR_EraseRootFromParent_Done,
     /* 2266812 */   // Label 30446: @2266812
     /* 2266812 */   GIM_Try, /*On fail goto*//*Label 30447*/ GIMT_Encode4(2266850), // Rule ID 48917 //
     /* 2266817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266820 */     // MIs[0] Operand 1
     /* 2266820 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266833 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266849 */     // GIR_Coverage, 48917,
     /* 2266849 */     GIR_EraseRootFromParent_Done,
     /* 2266850 */   // Label 30447: @2266850
     /* 2266850 */   GIM_Reject,
     /* 2266851 */ // Label 30427: @2266851
     /* 2266851 */ GIM_Reject,
     /* 2266852 */ // Label 29908: @2266852
     /* 2266852 */ GIM_Reject,
     /* 2266853 */ // Label 49: @2266853
     /* 2266853 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(30), /*)*//*default:*//*Label 30456*/ GIMT_Encode4(2274314),
     /* 2266864 */ /*GILLT_s32*//*Label 30448*/ GIMT_Encode4(2266972),
     /* 2266868 */ /*GILLT_s64*//*Label 30449*/ GIMT_Encode4(2267729),
     /* 2266872 */ /*GILLT_nxv1s1*//*Label 30450*/ GIMT_Encode4(2268612), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266892 */ /*GILLT_nxv2s1*//*Label 30451*/ GIMT_Encode4(2269765), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266912 */ /*GILLT_nxv4s1*//*Label 30452*/ GIMT_Encode4(2270918), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266932 */ /*GILLT_nxv8s1*//*Label 30453*/ GIMT_Encode4(2272071), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266952 */ /*GILLT_nxv16s1*//*Label 30454*/ GIMT_Encode4(2273224), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266968 */ /*GILLT_nxv32s1*//*Label 30455*/ GIMT_Encode4(2273993),
     /* 2266972 */ // Label 30448: @2266972
     /* 2266972 */ GIM_Try, /*On fail goto*//*Label 30457*/ GIMT_Encode4(2267014), // Rule ID 1374 //
     /* 2266977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2266980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266983 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266990 */   // MIs[0] Operand 1
     /* 2266990 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266999 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267003 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2267006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267008 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267010 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267013 */   // GIR_Coverage, 1374,
     /* 2267013 */   GIR_EraseRootFromParent_Done,
     /* 2267014 */ // Label 30457: @2267014
     /* 2267014 */ GIM_Try, /*On fail goto*//*Label 30458*/ GIMT_Encode4(2267056), // Rule ID 1378 //
     /* 2267019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2267022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267032 */   // MIs[0] Operand 1
     /* 2267032 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267041 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267045 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2267048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267050 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267052 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267055 */   // GIR_Coverage, 1378,
     /* 2267055 */   GIR_EraseRootFromParent_Done,
     /* 2267056 */ // Label 30458: @2267056
     /* 2267056 */ GIM_Try, /*On fail goto*//*Label 30459*/ GIMT_Encode4(2267098), // Rule ID 1422 //
     /* 2267061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2267064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267074 */   // MIs[0] Operand 1
     /* 2267074 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267083 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267087 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2267090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267092 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267094 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267096 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267097 */   // GIR_Coverage, 1422,
     /* 2267097 */   GIR_EraseRootFromParent_Done,
     /* 2267098 */ // Label 30459: @2267098
     /* 2267098 */ GIM_Try, /*On fail goto*//*Label 30460*/ GIMT_Encode4(2267140), // Rule ID 1426 //
     /* 2267103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2267106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267109 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267116 */   // MIs[0] Operand 1
     /* 2267116 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267125 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267129 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2267132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267134 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267136 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267138 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267139 */   // GIR_Coverage, 1426,
     /* 2267139 */   GIR_EraseRootFromParent_Done,
     /* 2267140 */ // Label 30460: @2267140
     /* 2267140 */ GIM_Try, /*On fail goto*//*Label 30461*/ GIMT_Encode4(2267182), // Rule ID 1438 //
     /* 2267145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2267148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267151 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267158 */   // MIs[0] Operand 1
     /* 2267158 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267167 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267171 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2267174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267176 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267178 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267180 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267181 */   // GIR_Coverage, 1438,
     /* 2267181 */   GIR_EraseRootFromParent_Done,
     /* 2267182 */ // Label 30461: @2267182
     /* 2267182 */ GIM_Try, /*On fail goto*//*Label 30462*/ GIMT_Encode4(2267224), // Rule ID 1442 //
     /* 2267187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2267190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267193 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267200 */   // MIs[0] Operand 1
     /* 2267200 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267209 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267213 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2267216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267218 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267220 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267223 */   // GIR_Coverage, 1442,
     /* 2267223 */   GIR_EraseRootFromParent_Done,
     /* 2267224 */ // Label 30462: @2267224
     /* 2267224 */ GIM_Try, /*On fail goto*//*Label 30463*/ GIMT_Encode4(2267266), // Rule ID 1754 //
     /* 2267229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2267232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267235 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267242 */   // MIs[0] Operand 1
     /* 2267242 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267251 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267255 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2267258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267260 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267262 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267264 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267265 */   // GIR_Coverage, 1754,
     /* 2267265 */   GIR_EraseRootFromParent_Done,
     /* 2267266 */ // Label 30463: @2267266
     /* 2267266 */ GIM_Try, /*On fail goto*//*Label 30464*/ GIMT_Encode4(2267308), // Rule ID 1758 //
     /* 2267271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2267274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267277 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267284 */   // MIs[0] Operand 1
     /* 2267284 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267293 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267297 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2267300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267302 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267304 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267306 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267307 */   // GIR_Coverage, 1758,
     /* 2267307 */   GIR_EraseRootFromParent_Done,
     /* 2267308 */ // Label 30464: @2267308
     /* 2267308 */ GIM_Try, /*On fail goto*//*Label 30465*/ GIMT_Encode4(2267350), // Rule ID 1796 //
     /* 2267313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2267316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267319 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267326 */   // MIs[0] Operand 1
     /* 2267326 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267331 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267335 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267339 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2267342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267344 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267346 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267349 */   // GIR_Coverage, 1796,
     /* 2267349 */   GIR_EraseRootFromParent_Done,
     /* 2267350 */ // Label 30465: @2267350
     /* 2267350 */ GIM_Try, /*On fail goto*//*Label 30466*/ GIMT_Encode4(2267392), // Rule ID 1804 //
     /* 2267355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2267358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267361 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267368 */   // MIs[0] Operand 1
     /* 2267368 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267377 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267381 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2267384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267386 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267388 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267390 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267391 */   // GIR_Coverage, 1804,
     /* 2267391 */   GIR_EraseRootFromParent_Done,
     /* 2267392 */ // Label 30466: @2267392
     /* 2267392 */ GIM_Try, /*On fail goto*//*Label 30467*/ GIMT_Encode4(2267434), // Rule ID 1832 //
     /* 2267397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2267400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267403 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267410 */   // MIs[0] Operand 1
     /* 2267410 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267419 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267423 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2267426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267428 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267430 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267432 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267433 */   // GIR_Coverage, 1832,
     /* 2267433 */   GIR_EraseRootFromParent_Done,
     /* 2267434 */ // Label 30467: @2267434
     /* 2267434 */ GIM_Try, /*On fail goto*//*Label 30468*/ GIMT_Encode4(2267476), // Rule ID 1840 //
     /* 2267439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2267442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267445 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267452 */   // MIs[0] Operand 1
     /* 2267452 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267461 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267465 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2267468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267470 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267472 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267474 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267475 */   // GIR_Coverage, 1840,
     /* 2267475 */   GIR_EraseRootFromParent_Done,
     /* 2267476 */ // Label 30468: @2267476
     /* 2267476 */ GIM_Try, /*On fail goto*//*Label 30469*/ GIMT_Encode4(2267518), // Rule ID 2087 //
     /* 2267481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2267484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267487 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267494 */   // MIs[0] Operand 1
     /* 2267494 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267503 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267507 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2267510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267512 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267514 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267516 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267517 */   // GIR_Coverage, 2087,
     /* 2267517 */   GIR_EraseRootFromParent_Done,
     /* 2267518 */ // Label 30469: @2267518
     /* 2267518 */ GIM_Try, /*On fail goto*//*Label 30470*/ GIMT_Encode4(2267560), // Rule ID 2091 //
     /* 2267523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2267526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267529 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267536 */   // MIs[0] Operand 1
     /* 2267536 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267545 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267549 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2267552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267554 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267556 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267558 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267559 */   // GIR_Coverage, 2091,
     /* 2267559 */   GIR_EraseRootFromParent_Done,
     /* 2267560 */ // Label 30470: @2267560
     /* 2267560 */ GIM_Try, /*On fail goto*//*Label 30471*/ GIMT_Encode4(2267602), // Rule ID 2135 //
     /* 2267565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2267568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267571 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267578 */   // MIs[0] Operand 1
     /* 2267578 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267587 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267591 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2267594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267596 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267598 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267600 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267601 */   // GIR_Coverage, 2135,
     /* 2267601 */   GIR_EraseRootFromParent_Done,
     /* 2267602 */ // Label 30471: @2267602
     /* 2267602 */ GIM_Try, /*On fail goto*//*Label 30472*/ GIMT_Encode4(2267644), // Rule ID 2139 //
     /* 2267607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2267610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267613 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267620 */   // MIs[0] Operand 1
     /* 2267620 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267629 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267633 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2267636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267638 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267640 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267642 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267643 */   // GIR_Coverage, 2139,
     /* 2267643 */   GIR_EraseRootFromParent_Done,
     /* 2267644 */ // Label 30472: @2267644
     /* 2267644 */ GIM_Try, /*On fail goto*//*Label 30473*/ GIMT_Encode4(2267686), // Rule ID 2151 //
     /* 2267649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2267652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267655 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267662 */   // MIs[0] Operand 1
     /* 2267662 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267667 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267671 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267675 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2267678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267680 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267682 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267685 */   // GIR_Coverage, 2151,
     /* 2267685 */   GIR_EraseRootFromParent_Done,
     /* 2267686 */ // Label 30473: @2267686
     /* 2267686 */ GIM_Try, /*On fail goto*//*Label 30474*/ GIMT_Encode4(2267728), // Rule ID 2155 //
     /* 2267691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2267694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267697 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267704 */   // MIs[0] Operand 1
     /* 2267704 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267713 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267717 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2267720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267722 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267724 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267726 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267727 */   // GIR_Coverage, 2155,
     /* 2267727 */   GIR_EraseRootFromParent_Done,
     /* 2267728 */ // Label 30474: @2267728
     /* 2267728 */ GIM_Reject,
     /* 2267729 */ // Label 30449: @2267729
     /* 2267729 */ GIM_Try, /*On fail goto*//*Label 30475*/ GIMT_Encode4(2267771), // Rule ID 1373 //
     /* 2267734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2267737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267740 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267747 */   // MIs[0] Operand 1
     /* 2267747 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267756 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267760 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2267763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267765 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267767 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267770 */   // GIR_Coverage, 1373,
     /* 2267770 */   GIR_EraseRootFromParent_Done,
     /* 2267771 */ // Label 30475: @2267771
     /* 2267771 */ GIM_Try, /*On fail goto*//*Label 30476*/ GIMT_Encode4(2267813), // Rule ID 1377 //
     /* 2267776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2267779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267782 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267789 */   // MIs[0] Operand 1
     /* 2267789 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267798 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267802 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2267805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267807 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267809 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267812 */   // GIR_Coverage, 1377,
     /* 2267812 */   GIR_EraseRootFromParent_Done,
     /* 2267813 */ // Label 30476: @2267813
     /* 2267813 */ GIM_Try, /*On fail goto*//*Label 30477*/ GIMT_Encode4(2267855), // Rule ID 1421 //
     /* 2267818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2267821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267831 */   // MIs[0] Operand 1
     /* 2267831 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267840 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267844 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2267847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267849 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267851 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267853 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267854 */   // GIR_Coverage, 1421,
     /* 2267854 */   GIR_EraseRootFromParent_Done,
     /* 2267855 */ // Label 30477: @2267855
     /* 2267855 */ GIM_Try, /*On fail goto*//*Label 30478*/ GIMT_Encode4(2267897), // Rule ID 1425 //
     /* 2267860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2267863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267866 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267873 */   // MIs[0] Operand 1
     /* 2267873 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267882 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267886 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2267889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267891 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267893 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267896 */   // GIR_Coverage, 1425,
     /* 2267896 */   GIR_EraseRootFromParent_Done,
     /* 2267897 */ // Label 30478: @2267897
     /* 2267897 */ GIM_Try, /*On fail goto*//*Label 30479*/ GIMT_Encode4(2267939), // Rule ID 1437 //
     /* 2267902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2267905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267908 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267915 */   // MIs[0] Operand 1
     /* 2267915 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267924 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267928 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2267931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267933 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267935 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267937 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267938 */   // GIR_Coverage, 1437,
     /* 2267938 */   GIR_EraseRootFromParent_Done,
     /* 2267939 */ // Label 30479: @2267939
     /* 2267939 */ GIM_Try, /*On fail goto*//*Label 30480*/ GIMT_Encode4(2267981), // Rule ID 1441 //
     /* 2267944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2267947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267950 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267957 */   // MIs[0] Operand 1
     /* 2267957 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267966 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267970 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2267973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267975 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267977 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267979 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267980 */   // GIR_Coverage, 1441,
     /* 2267980 */   GIR_EraseRootFromParent_Done,
     /* 2267981 */ // Label 30480: @2267981
     /* 2267981 */ GIM_Try, /*On fail goto*//*Label 30481*/ GIMT_Encode4(2268023), // Rule ID 1753 //
     /* 2267986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2267989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267992 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267999 */   // MIs[0] Operand 1
     /* 2267999 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2268008 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2268012 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2268015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268017 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268019 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268022 */   // GIR_Coverage, 1753,
     /* 2268022 */   GIR_EraseRootFromParent_Done,
     /* 2268023 */ // Label 30481: @2268023
     /* 2268023 */ GIM_Try, /*On fail goto*//*Label 30482*/ GIMT_Encode4(2268065), // Rule ID 1757 //
     /* 2268028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2268031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268034 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268041 */   // MIs[0] Operand 1
     /* 2268041 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2268050 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2268054 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2268057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268059 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268061 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268063 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268064 */   // GIR_Coverage, 1757,
     /* 2268064 */   GIR_EraseRootFromParent_Done,
     /* 2268065 */ // Label 30482: @2268065
     /* 2268065 */ GIM_Try, /*On fail goto*//*Label 30483*/ GIMT_Encode4(2268107), // Rule ID 1760 //
     /* 2268070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2268073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268076 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268083 */   // MIs[0] Operand 1
     /* 2268083 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268092 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268096 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_INX),
     /* 2268099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268101 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268103 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268105 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268106 */   // GIR_Coverage, 1760,
     /* 2268106 */   GIR_EraseRootFromParent_Done,
     /* 2268107 */ // Label 30483: @2268107
     /* 2268107 */ GIM_Try, /*On fail goto*//*Label 30484*/ GIMT_Encode4(2268149), // Rule ID 1795 //
     /* 2268112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2268115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268118 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268125 */   // MIs[0] Operand 1
     /* 2268125 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2268134 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2268138 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2268141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268143 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268145 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268148 */   // GIR_Coverage, 1795,
     /* 2268148 */   GIR_EraseRootFromParent_Done,
     /* 2268149 */ // Label 30484: @2268149
     /* 2268149 */ GIM_Try, /*On fail goto*//*Label 30485*/ GIMT_Encode4(2268191), // Rule ID 1803 //
     /* 2268154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2268157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268160 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268167 */   // MIs[0] Operand 1
     /* 2268167 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2268176 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2268180 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2268183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268185 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268187 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268189 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268190 */   // GIR_Coverage, 1803,
     /* 2268190 */   GIR_EraseRootFromParent_Done,
     /* 2268191 */ // Label 30485: @2268191
     /* 2268191 */ GIM_Try, /*On fail goto*//*Label 30486*/ GIMT_Encode4(2268233), // Rule ID 1812 //
     /* 2268196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2268199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268209 */   // MIs[0] Operand 1
     /* 2268209 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268218 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268222 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_INX),
     /* 2268225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268227 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268229 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268231 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268232 */   // GIR_Coverage, 1812,
     /* 2268232 */   GIR_EraseRootFromParent_Done,
     /* 2268233 */ // Label 30486: @2268233
     /* 2268233 */ GIM_Try, /*On fail goto*//*Label 30487*/ GIMT_Encode4(2268275), // Rule ID 1816 //
     /* 2268238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2268241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268244 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268251 */   // MIs[0] Operand 1
     /* 2268251 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268260 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268264 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_INX),
     /* 2268267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268269 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268271 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268273 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268274 */   // GIR_Coverage, 1816,
     /* 2268274 */   GIR_EraseRootFromParent_Done,
     /* 2268275 */ // Label 30487: @2268275
     /* 2268275 */ GIM_Try, /*On fail goto*//*Label 30488*/ GIMT_Encode4(2268317), // Rule ID 1831 //
     /* 2268280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2268283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268286 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268293 */   // MIs[0] Operand 1
     /* 2268293 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2268302 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2268306 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2268309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268311 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268313 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268315 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268316 */   // GIR_Coverage, 1831,
     /* 2268316 */   GIR_EraseRootFromParent_Done,
     /* 2268317 */ // Label 30488: @2268317
     /* 2268317 */ GIM_Try, /*On fail goto*//*Label 30489*/ GIMT_Encode4(2268359), // Rule ID 1839 //
     /* 2268322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2268325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268328 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268335 */   // MIs[0] Operand 1
     /* 2268335 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2268344 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2268348 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2268351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268353 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268355 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268357 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268358 */   // GIR_Coverage, 1839,
     /* 2268358 */   GIR_EraseRootFromParent_Done,
     /* 2268359 */ // Label 30489: @2268359
     /* 2268359 */ GIM_Try, /*On fail goto*//*Label 30490*/ GIMT_Encode4(2268401), // Rule ID 2086 //
     /* 2268364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2268367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268377 */   // MIs[0] Operand 1
     /* 2268377 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268386 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268390 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2268393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268397 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268399 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268400 */   // GIR_Coverage, 2086,
     /* 2268400 */   GIR_EraseRootFromParent_Done,
     /* 2268401 */ // Label 30490: @2268401
     /* 2268401 */ GIM_Try, /*On fail goto*//*Label 30491*/ GIMT_Encode4(2268443), // Rule ID 2090 //
     /* 2268406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2268409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268412 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268419 */   // MIs[0] Operand 1
     /* 2268419 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268428 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268432 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2268435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268437 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268439 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268441 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268442 */   // GIR_Coverage, 2090,
     /* 2268442 */   GIR_EraseRootFromParent_Done,
     /* 2268443 */ // Label 30491: @2268443
     /* 2268443 */ GIM_Try, /*On fail goto*//*Label 30492*/ GIMT_Encode4(2268485), // Rule ID 2134 //
     /* 2268448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2268451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268454 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268461 */   // MIs[0] Operand 1
     /* 2268461 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268470 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268474 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2268477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268479 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268481 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268483 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268484 */   // GIR_Coverage, 2134,
     /* 2268484 */   GIR_EraseRootFromParent_Done,
     /* 2268485 */ // Label 30492: @2268485
     /* 2268485 */ GIM_Try, /*On fail goto*//*Label 30493*/ GIMT_Encode4(2268527), // Rule ID 2138 //
     /* 2268490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2268493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268503 */   // MIs[0] Operand 1
     /* 2268503 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268512 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268516 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2268519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268521 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268523 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268525 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268526 */   // GIR_Coverage, 2138,
     /* 2268526 */   GIR_EraseRootFromParent_Done,
     /* 2268527 */ // Label 30493: @2268527
     /* 2268527 */ GIM_Try, /*On fail goto*//*Label 30494*/ GIMT_Encode4(2268569), // Rule ID 2150 //
     /* 2268532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2268535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268538 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268545 */   // MIs[0] Operand 1
     /* 2268545 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268554 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268558 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2268561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268563 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268565 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268567 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268568 */   // GIR_Coverage, 2150,
     /* 2268568 */   GIR_EraseRootFromParent_Done,
     /* 2268569 */ // Label 30494: @2268569
     /* 2268569 */ GIM_Try, /*On fail goto*//*Label 30495*/ GIMT_Encode4(2268611), // Rule ID 2154 //
     /* 2268574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2268577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268580 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268587 */   // MIs[0] Operand 1
     /* 2268587 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268596 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268600 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2268603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268605 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268607 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268609 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268610 */   // GIR_Coverage, 2154,
     /* 2268610 */   GIR_EraseRootFromParent_Done,
     /* 2268611 */ // Label 30495: @2268611
     /* 2268611 */ GIM_Reject,
     /* 2268612 */ // Label 30450: @2268612
     /* 2268612 */ GIM_Try, /*On fail goto*//*Label 30496*/ GIMT_Encode4(2268660), // Rule ID 57042 //
     /* 2268617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2268620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268623 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268630 */   // MIs[0] Operand 1
     /* 2268630 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268639 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268643 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2268646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268648 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268650 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268658 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268659 */   // GIR_Coverage, 57042,
     /* 2268659 */   GIR_EraseRootFromParent_Done,
     /* 2268660 */ // Label 30496: @2268660
     /* 2268660 */ GIM_Try, /*On fail goto*//*Label 30497*/ GIMT_Encode4(2268708), // Rule ID 57043 //
     /* 2268665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2268668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268671 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268678 */   // MIs[0] Operand 1
     /* 2268678 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268687 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268691 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2268694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268696 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268698 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268706 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268707 */   // GIR_Coverage, 57043,
     /* 2268707 */   GIR_EraseRootFromParent_Done,
     /* 2268708 */ // Label 30497: @2268708
     /* 2268708 */ GIM_Try, /*On fail goto*//*Label 30498*/ GIMT_Encode4(2268756), // Rule ID 57062 //
     /* 2268713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2268716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268719 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268726 */   // MIs[0] Operand 1
     /* 2268726 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268735 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268739 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2268739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2268742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268744 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268746 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268754 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268755 */   // GIR_Coverage, 57062,
     /* 2268755 */   GIR_EraseRootFromParent_Done,
     /* 2268756 */ // Label 30498: @2268756
     /* 2268756 */ GIM_Try, /*On fail goto*//*Label 30499*/ GIMT_Encode4(2268804), // Rule ID 57063 //
     /* 2268761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2268764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268767 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268774 */   // MIs[0] Operand 1
     /* 2268774 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268783 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268787 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2268787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2268790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268792 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268794 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268802 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268803 */   // GIR_Coverage, 57063,
     /* 2268803 */   GIR_EraseRootFromParent_Done,
     /* 2268804 */ // Label 30499: @2268804
     /* 2268804 */ GIM_Try, /*On fail goto*//*Label 30500*/ GIMT_Encode4(2268852), // Rule ID 57092 //
     /* 2268809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2268812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268815 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268822 */   // MIs[0] Operand 1
     /* 2268822 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268831 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268835 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2268835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2268838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268840 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268842 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268850 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268851 */   // GIR_Coverage, 57092,
     /* 2268851 */   GIR_EraseRootFromParent_Done,
     /* 2268852 */ // Label 30500: @2268852
     /* 2268852 */ GIM_Try, /*On fail goto*//*Label 30501*/ GIMT_Encode4(2268900), // Rule ID 57093 //
     /* 2268857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2268860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268863 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268870 */   // MIs[0] Operand 1
     /* 2268870 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268875 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268879 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268883 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2268883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2268886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268888 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268890 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268898 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268899 */   // GIR_Coverage, 57093,
     /* 2268899 */   GIR_EraseRootFromParent_Done,
     /* 2268900 */ // Label 30501: @2268900
     /* 2268900 */ GIM_Try, /*On fail goto*//*Label 30502*/ GIMT_Encode4(2268948), // Rule ID 57342 //
     /* 2268905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2268908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268911 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268918 */   // MIs[0] Operand 1
     /* 2268918 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268927 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268931 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2268934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268936 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268938 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268946 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268947 */   // GIR_Coverage, 57342,
     /* 2268947 */   GIR_EraseRootFromParent_Done,
     /* 2268948 */ // Label 30502: @2268948
     /* 2268948 */ GIM_Try, /*On fail goto*//*Label 30503*/ GIMT_Encode4(2268996), // Rule ID 57343 //
     /* 2268953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2268956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268959 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268966 */   // MIs[0] Operand 1
     /* 2268966 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268971 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268975 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268979 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2268982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268984 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268986 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268994 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268995 */   // GIR_Coverage, 57343,
     /* 2268995 */   GIR_EraseRootFromParent_Done,
     /* 2268996 */ // Label 30503: @2268996
     /* 2268996 */ GIM_Try, /*On fail goto*//*Label 30504*/ GIMT_Encode4(2269044), // Rule ID 57362 //
     /* 2269001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269007 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269014 */   // MIs[0] Operand 1
     /* 2269014 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269023 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269027 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2269030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269032 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269034 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269042 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269043 */   // GIR_Coverage, 57362,
     /* 2269043 */   GIR_EraseRootFromParent_Done,
     /* 2269044 */ // Label 30504: @2269044
     /* 2269044 */ GIM_Try, /*On fail goto*//*Label 30505*/ GIMT_Encode4(2269092), // Rule ID 57363 //
     /* 2269049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269055 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269062 */   // MIs[0] Operand 1
     /* 2269062 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269067 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269071 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269075 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2269078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269080 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269082 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269091 */   // GIR_Coverage, 57363,
     /* 2269091 */   GIR_EraseRootFromParent_Done,
     /* 2269092 */ // Label 30505: @2269092
     /* 2269092 */ GIM_Try, /*On fail goto*//*Label 30506*/ GIMT_Encode4(2269140), // Rule ID 57392 //
     /* 2269097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269103 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269110 */   // MIs[0] Operand 1
     /* 2269110 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269119 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269123 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2269126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269128 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269130 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269138 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269139 */   // GIR_Coverage, 57392,
     /* 2269139 */   GIR_EraseRootFromParent_Done,
     /* 2269140 */ // Label 30506: @2269140
     /* 2269140 */ GIM_Try, /*On fail goto*//*Label 30507*/ GIMT_Encode4(2269188), // Rule ID 57393 //
     /* 2269145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269151 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269158 */   // MIs[0] Operand 1
     /* 2269158 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269167 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269171 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2269171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2269174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269176 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269178 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269186 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269187 */   // GIR_Coverage, 57393,
     /* 2269187 */   GIR_EraseRootFromParent_Done,
     /* 2269188 */ // Label 30507: @2269188
     /* 2269188 */ GIM_Try, /*On fail goto*//*Label 30508*/ GIMT_Encode4(2269236), // Rule ID 57642 //
     /* 2269193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2269199 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2269202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269206 */   // MIs[0] Operand 1
     /* 2269206 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269215 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269219 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2269222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269224 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269226 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269234 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269235 */   // GIR_Coverage, 57642,
     /* 2269235 */   GIR_EraseRootFromParent_Done,
     /* 2269236 */ // Label 30508: @2269236
     /* 2269236 */ GIM_Try, /*On fail goto*//*Label 30509*/ GIMT_Encode4(2269284), // Rule ID 57643 //
     /* 2269241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2269247 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2269250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269254 */   // MIs[0] Operand 1
     /* 2269254 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269263 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269267 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2269270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269272 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269274 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269282 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269283 */   // GIR_Coverage, 57643,
     /* 2269283 */   GIR_EraseRootFromParent_Done,
     /* 2269284 */ // Label 30509: @2269284
     /* 2269284 */ GIM_Try, /*On fail goto*//*Label 30510*/ GIMT_Encode4(2269332), // Rule ID 57662 //
     /* 2269289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269295 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269302 */   // MIs[0] Operand 1
     /* 2269302 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269311 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269315 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2269318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269320 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269322 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269330 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269331 */   // GIR_Coverage, 57662,
     /* 2269331 */   GIR_EraseRootFromParent_Done,
     /* 2269332 */ // Label 30510: @2269332
     /* 2269332 */ GIM_Try, /*On fail goto*//*Label 30511*/ GIMT_Encode4(2269380), // Rule ID 57663 //
     /* 2269337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269343 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269350 */   // MIs[0] Operand 1
     /* 2269350 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269359 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269363 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2269366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269368 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269370 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269378 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269379 */   // GIR_Coverage, 57663,
     /* 2269379 */   GIR_EraseRootFromParent_Done,
     /* 2269380 */ // Label 30511: @2269380
     /* 2269380 */ GIM_Try, /*On fail goto*//*Label 30512*/ GIMT_Encode4(2269428), // Rule ID 57692 //
     /* 2269385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269391 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269398 */   // MIs[0] Operand 1
     /* 2269398 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269407 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269411 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2269414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269416 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269418 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269426 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269427 */   // GIR_Coverage, 57692,
     /* 2269427 */   GIR_EraseRootFromParent_Done,
     /* 2269428 */ // Label 30512: @2269428
     /* 2269428 */ GIM_Try, /*On fail goto*//*Label 30513*/ GIMT_Encode4(2269476), // Rule ID 57693 //
     /* 2269433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269439 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269446 */   // MIs[0] Operand 1
     /* 2269446 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269451 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269455 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269459 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2269459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2269462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269464 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269466 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269474 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269475 */   // GIR_Coverage, 57693,
     /* 2269475 */   GIR_EraseRootFromParent_Done,
     /* 2269476 */ // Label 30513: @2269476
     /* 2269476 */ GIM_Try, /*On fail goto*//*Label 30514*/ GIMT_Encode4(2269524), // Rule ID 57942 //
     /* 2269481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2269487 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2269490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269494 */   // MIs[0] Operand 1
     /* 2269494 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269503 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269507 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2269510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269512 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269514 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269522 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269523 */   // GIR_Coverage, 57942,
     /* 2269523 */   GIR_EraseRootFromParent_Done,
     /* 2269524 */ // Label 30514: @2269524
     /* 2269524 */ GIM_Try, /*On fail goto*//*Label 30515*/ GIMT_Encode4(2269572), // Rule ID 57943 //
     /* 2269529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2269535 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2269538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269542 */   // MIs[0] Operand 1
     /* 2269542 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269551 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269555 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2269558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269560 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269562 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269570 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269571 */   // GIR_Coverage, 57943,
     /* 2269571 */   GIR_EraseRootFromParent_Done,
     /* 2269572 */ // Label 30515: @2269572
     /* 2269572 */ GIM_Try, /*On fail goto*//*Label 30516*/ GIMT_Encode4(2269620), // Rule ID 57962 //
     /* 2269577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269583 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269590 */   // MIs[0] Operand 1
     /* 2269590 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269595 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269599 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269603 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2269606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269608 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269610 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269619 */   // GIR_Coverage, 57962,
     /* 2269619 */   GIR_EraseRootFromParent_Done,
     /* 2269620 */ // Label 30516: @2269620
     /* 2269620 */ GIM_Try, /*On fail goto*//*Label 30517*/ GIMT_Encode4(2269668), // Rule ID 57963 //
     /* 2269625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269631 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269638 */   // MIs[0] Operand 1
     /* 2269638 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269647 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269651 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2269654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269656 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269658 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269666 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269667 */   // GIR_Coverage, 57963,
     /* 2269667 */   GIR_EraseRootFromParent_Done,
     /* 2269668 */ // Label 30517: @2269668
     /* 2269668 */ GIM_Try, /*On fail goto*//*Label 30518*/ GIMT_Encode4(2269716), // Rule ID 57992 //
     /* 2269673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269679 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269686 */   // MIs[0] Operand 1
     /* 2269686 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269695 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269699 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2269702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269704 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269706 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269714 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269715 */   // GIR_Coverage, 57992,
     /* 2269715 */   GIR_EraseRootFromParent_Done,
     /* 2269716 */ // Label 30518: @2269716
     /* 2269716 */ GIM_Try, /*On fail goto*//*Label 30519*/ GIMT_Encode4(2269764), // Rule ID 57993 //
     /* 2269721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269727 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269734 */   // MIs[0] Operand 1
     /* 2269734 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269739 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269743 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269747 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2269747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2269750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269752 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269754 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269762 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269763 */   // GIR_Coverage, 57993,
     /* 2269763 */   GIR_EraseRootFromParent_Done,
     /* 2269764 */ // Label 30519: @2269764
     /* 2269764 */ GIM_Reject,
     /* 2269765 */ // Label 30451: @2269765
     /* 2269765 */ GIM_Try, /*On fail goto*//*Label 30520*/ GIMT_Encode4(2269813), // Rule ID 57052 //
     /* 2269770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269776 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269783 */   // MIs[0] Operand 1
     /* 2269783 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269792 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269796 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2269799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269801 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269803 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269812 */   // GIR_Coverage, 57052,
     /* 2269812 */   GIR_EraseRootFromParent_Done,
     /* 2269813 */ // Label 30520: @2269813
     /* 2269813 */ GIM_Try, /*On fail goto*//*Label 30521*/ GIMT_Encode4(2269861), // Rule ID 57053 //
     /* 2269818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269831 */   // MIs[0] Operand 1
     /* 2269831 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269840 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269844 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2269847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269849 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269851 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269859 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269860 */   // GIR_Coverage, 57053,
     /* 2269860 */   GIR_EraseRootFromParent_Done,
     /* 2269861 */ // Label 30521: @2269861
     /* 2269861 */ GIM_Try, /*On fail goto*//*Label 30522*/ GIMT_Encode4(2269909), // Rule ID 57082 //
     /* 2269866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269872 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269879 */   // MIs[0] Operand 1
     /* 2269879 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269884 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269888 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269892 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2269895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269897 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269899 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269907 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269908 */   // GIR_Coverage, 57082,
     /* 2269908 */   GIR_EraseRootFromParent_Done,
     /* 2269909 */ // Label 30522: @2269909
     /* 2269909 */ GIM_Try, /*On fail goto*//*Label 30523*/ GIMT_Encode4(2269957), // Rule ID 57083 //
     /* 2269914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269920 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269927 */   // MIs[0] Operand 1
     /* 2269927 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269932 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269936 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269940 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2269943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269945 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269947 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269955 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269956 */   // GIR_Coverage, 57083,
     /* 2269956 */   GIR_EraseRootFromParent_Done,
     /* 2269957 */ // Label 30523: @2269957
     /* 2269957 */ GIM_Try, /*On fail goto*//*Label 30524*/ GIMT_Encode4(2270005), // Rule ID 57162 //
     /* 2269962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269968 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269975 */   // MIs[0] Operand 1
     /* 2269975 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269984 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269988 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2269991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269993 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269995 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270004 */   // GIR_Coverage, 57162,
     /* 2270004 */   GIR_EraseRootFromParent_Done,
     /* 2270005 */ // Label 30524: @2270005
     /* 2270005 */ GIM_Try, /*On fail goto*//*Label 30525*/ GIMT_Encode4(2270053), // Rule ID 57163 //
     /* 2270010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270016 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270023 */   // MIs[0] Operand 1
     /* 2270023 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270032 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270036 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2270039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270041 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270043 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270052 */   // GIR_Coverage, 57163,
     /* 2270052 */   GIR_EraseRootFromParent_Done,
     /* 2270053 */ // Label 30525: @2270053
     /* 2270053 */ GIM_Try, /*On fail goto*//*Label 30526*/ GIMT_Encode4(2270101), // Rule ID 57352 //
     /* 2270058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270064 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270071 */   // MIs[0] Operand 1
     /* 2270071 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270080 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270084 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2270087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270089 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270091 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270099 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270100 */   // GIR_Coverage, 57352,
     /* 2270100 */   GIR_EraseRootFromParent_Done,
     /* 2270101 */ // Label 30526: @2270101
     /* 2270101 */ GIM_Try, /*On fail goto*//*Label 30527*/ GIMT_Encode4(2270149), // Rule ID 57353 //
     /* 2270106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270112 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270119 */   // MIs[0] Operand 1
     /* 2270119 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270128 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270132 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2270135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270137 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270139 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270148 */   // GIR_Coverage, 57353,
     /* 2270148 */   GIR_EraseRootFromParent_Done,
     /* 2270149 */ // Label 30527: @2270149
     /* 2270149 */ GIM_Try, /*On fail goto*//*Label 30528*/ GIMT_Encode4(2270197), // Rule ID 57382 //
     /* 2270154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270160 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270167 */   // MIs[0] Operand 1
     /* 2270167 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270176 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270180 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2270183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270185 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270187 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270195 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270196 */   // GIR_Coverage, 57382,
     /* 2270196 */   GIR_EraseRootFromParent_Done,
     /* 2270197 */ // Label 30528: @2270197
     /* 2270197 */ GIM_Try, /*On fail goto*//*Label 30529*/ GIMT_Encode4(2270245), // Rule ID 57383 //
     /* 2270202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270208 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270215 */   // MIs[0] Operand 1
     /* 2270215 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270224 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270228 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2270231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270233 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270235 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270243 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270244 */   // GIR_Coverage, 57383,
     /* 2270244 */   GIR_EraseRootFromParent_Done,
     /* 2270245 */ // Label 30529: @2270245
     /* 2270245 */ GIM_Try, /*On fail goto*//*Label 30530*/ GIMT_Encode4(2270293), // Rule ID 57462 //
     /* 2270250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270256 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270263 */   // MIs[0] Operand 1
     /* 2270263 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270272 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270276 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2270279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270281 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270283 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270291 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270292 */   // GIR_Coverage, 57462,
     /* 2270292 */   GIR_EraseRootFromParent_Done,
     /* 2270293 */ // Label 30530: @2270293
     /* 2270293 */ GIM_Try, /*On fail goto*//*Label 30531*/ GIMT_Encode4(2270341), // Rule ID 57463 //
     /* 2270298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270304 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270311 */   // MIs[0] Operand 1
     /* 2270311 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270320 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270324 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2270327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270329 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270331 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270339 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270340 */   // GIR_Coverage, 57463,
     /* 2270340 */   GIR_EraseRootFromParent_Done,
     /* 2270341 */ // Label 30531: @2270341
     /* 2270341 */ GIM_Try, /*On fail goto*//*Label 30532*/ GIMT_Encode4(2270389), // Rule ID 57652 //
     /* 2270346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270352 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270359 */   // MIs[0] Operand 1
     /* 2270359 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270368 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270372 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2270375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270377 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270379 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270387 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270388 */   // GIR_Coverage, 57652,
     /* 2270388 */   GIR_EraseRootFromParent_Done,
     /* 2270389 */ // Label 30532: @2270389
     /* 2270389 */ GIM_Try, /*On fail goto*//*Label 30533*/ GIMT_Encode4(2270437), // Rule ID 57653 //
     /* 2270394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270407 */   // MIs[0] Operand 1
     /* 2270407 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270416 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270420 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2270423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270425 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270427 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270435 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270436 */   // GIR_Coverage, 57653,
     /* 2270436 */   GIR_EraseRootFromParent_Done,
     /* 2270437 */ // Label 30533: @2270437
     /* 2270437 */ GIM_Try, /*On fail goto*//*Label 30534*/ GIMT_Encode4(2270485), // Rule ID 57682 //
     /* 2270442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270448 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270455 */   // MIs[0] Operand 1
     /* 2270455 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270464 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270468 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2270471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270473 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270475 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270483 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270484 */   // GIR_Coverage, 57682,
     /* 2270484 */   GIR_EraseRootFromParent_Done,
     /* 2270485 */ // Label 30534: @2270485
     /* 2270485 */ GIM_Try, /*On fail goto*//*Label 30535*/ GIMT_Encode4(2270533), // Rule ID 57683 //
     /* 2270490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270503 */   // MIs[0] Operand 1
     /* 2270503 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270512 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270516 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2270519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270521 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270523 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270531 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270532 */   // GIR_Coverage, 57683,
     /* 2270532 */   GIR_EraseRootFromParent_Done,
     /* 2270533 */ // Label 30535: @2270533
     /* 2270533 */ GIM_Try, /*On fail goto*//*Label 30536*/ GIMT_Encode4(2270581), // Rule ID 57762 //
     /* 2270538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270544 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270551 */   // MIs[0] Operand 1
     /* 2270551 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270560 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270564 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2270567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270569 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270571 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270579 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270580 */   // GIR_Coverage, 57762,
     /* 2270580 */   GIR_EraseRootFromParent_Done,
     /* 2270581 */ // Label 30536: @2270581
     /* 2270581 */ GIM_Try, /*On fail goto*//*Label 30537*/ GIMT_Encode4(2270629), // Rule ID 57763 //
     /* 2270586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270592 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270599 */   // MIs[0] Operand 1
     /* 2270599 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270608 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270612 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2270615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270617 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270619 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270627 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270628 */   // GIR_Coverage, 57763,
     /* 2270628 */   GIR_EraseRootFromParent_Done,
     /* 2270629 */ // Label 30537: @2270629
     /* 2270629 */ GIM_Try, /*On fail goto*//*Label 30538*/ GIMT_Encode4(2270677), // Rule ID 57952 //
     /* 2270634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270640 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270647 */   // MIs[0] Operand 1
     /* 2270647 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270656 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270660 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2270663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270665 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270667 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270675 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270676 */   // GIR_Coverage, 57952,
     /* 2270676 */   GIR_EraseRootFromParent_Done,
     /* 2270677 */ // Label 30538: @2270677
     /* 2270677 */ GIM_Try, /*On fail goto*//*Label 30539*/ GIMT_Encode4(2270725), // Rule ID 57953 //
     /* 2270682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270695 */   // MIs[0] Operand 1
     /* 2270695 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270704 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270708 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2270711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270713 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270715 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270723 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270724 */   // GIR_Coverage, 57953,
     /* 2270724 */   GIR_EraseRootFromParent_Done,
     /* 2270725 */ // Label 30539: @2270725
     /* 2270725 */ GIM_Try, /*On fail goto*//*Label 30540*/ GIMT_Encode4(2270773), // Rule ID 57982 //
     /* 2270730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270736 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270743 */   // MIs[0] Operand 1
     /* 2270743 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270752 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270756 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2270759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270761 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270763 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270772 */   // GIR_Coverage, 57982,
     /* 2270772 */   GIR_EraseRootFromParent_Done,
     /* 2270773 */ // Label 30540: @2270773
     /* 2270773 */ GIM_Try, /*On fail goto*//*Label 30541*/ GIMT_Encode4(2270821), // Rule ID 57983 //
     /* 2270778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270784 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270791 */   // MIs[0] Operand 1
     /* 2270791 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270800 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270804 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2270807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270809 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270811 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270819 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270820 */   // GIR_Coverage, 57983,
     /* 2270820 */   GIR_EraseRootFromParent_Done,
     /* 2270821 */ // Label 30541: @2270821
     /* 2270821 */ GIM_Try, /*On fail goto*//*Label 30542*/ GIMT_Encode4(2270869), // Rule ID 58062 //
     /* 2270826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270832 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270839 */   // MIs[0] Operand 1
     /* 2270839 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270848 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270852 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2270855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270857 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270859 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270867 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270868 */   // GIR_Coverage, 58062,
     /* 2270868 */   GIR_EraseRootFromParent_Done,
     /* 2270869 */ // Label 30542: @2270869
     /* 2270869 */ GIM_Try, /*On fail goto*//*Label 30543*/ GIMT_Encode4(2270917), // Rule ID 58063 //
     /* 2270874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270880 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270887 */   // MIs[0] Operand 1
     /* 2270887 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270896 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270900 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2270903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270905 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270907 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270915 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270916 */   // GIR_Coverage, 58063,
     /* 2270916 */   GIR_EraseRootFromParent_Done,
     /* 2270917 */ // Label 30543: @2270917
     /* 2270917 */ GIM_Reject,
     /* 2270918 */ // Label 30452: @2270918
     /* 2270918 */ GIM_Try, /*On fail goto*//*Label 30544*/ GIMT_Encode4(2270966), // Rule ID 57072 //
     /* 2270923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270929 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270936 */   // MIs[0] Operand 1
     /* 2270936 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270945 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270949 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2270952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270954 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270956 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270964 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270965 */   // GIR_Coverage, 57072,
     /* 2270965 */   GIR_EraseRootFromParent_Done,
     /* 2270966 */ // Label 30544: @2270966
     /* 2270966 */ GIM_Try, /*On fail goto*//*Label 30545*/ GIMT_Encode4(2271014), // Rule ID 57073 //
     /* 2270971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270977 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270984 */   // MIs[0] Operand 1
     /* 2270984 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270993 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270997 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2271000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271002 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271004 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271013 */   // GIR_Coverage, 57073,
     /* 2271013 */   GIR_EraseRootFromParent_Done,
     /* 2271014 */ // Label 30545: @2271014
     /* 2271014 */ GIM_Try, /*On fail goto*//*Label 30546*/ GIMT_Encode4(2271062), // Rule ID 57132 //
     /* 2271019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271032 */   // MIs[0] Operand 1
     /* 2271032 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271041 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271045 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2271048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271050 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271052 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271061 */   // GIR_Coverage, 57132,
     /* 2271061 */   GIR_EraseRootFromParent_Done,
     /* 2271062 */ // Label 30546: @2271062
     /* 2271062 */ GIM_Try, /*On fail goto*//*Label 30547*/ GIMT_Encode4(2271110), // Rule ID 57133 //
     /* 2271067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271073 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271080 */   // MIs[0] Operand 1
     /* 2271080 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271089 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271093 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2271096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271098 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271100 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271108 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271109 */   // GIR_Coverage, 57133,
     /* 2271109 */   GIR_EraseRootFromParent_Done,
     /* 2271110 */ // Label 30547: @2271110
     /* 2271110 */ GIM_Try, /*On fail goto*//*Label 30548*/ GIMT_Encode4(2271158), // Rule ID 57172 //
     /* 2271115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271121 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271128 */   // MIs[0] Operand 1
     /* 2271128 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271137 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271141 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2271144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271146 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271148 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271157 */   // GIR_Coverage, 57172,
     /* 2271157 */   GIR_EraseRootFromParent_Done,
     /* 2271158 */ // Label 30548: @2271158
     /* 2271158 */ GIM_Try, /*On fail goto*//*Label 30549*/ GIMT_Encode4(2271206), // Rule ID 57173 //
     /* 2271163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271169 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271176 */   // MIs[0] Operand 1
     /* 2271176 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271185 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271189 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2271192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271194 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271196 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271204 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271205 */   // GIR_Coverage, 57173,
     /* 2271205 */   GIR_EraseRootFromParent_Done,
     /* 2271206 */ // Label 30549: @2271206
     /* 2271206 */ GIM_Try, /*On fail goto*//*Label 30550*/ GIMT_Encode4(2271254), // Rule ID 57372 //
     /* 2271211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271217 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271224 */   // MIs[0] Operand 1
     /* 2271224 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271233 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271237 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2271240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271242 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271244 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271253 */   // GIR_Coverage, 57372,
     /* 2271253 */   GIR_EraseRootFromParent_Done,
     /* 2271254 */ // Label 30550: @2271254
     /* 2271254 */ GIM_Try, /*On fail goto*//*Label 30551*/ GIMT_Encode4(2271302), // Rule ID 57373 //
     /* 2271259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271265 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271272 */   // MIs[0] Operand 1
     /* 2271272 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271281 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271285 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2271288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271290 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271292 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271300 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271301 */   // GIR_Coverage, 57373,
     /* 2271301 */   GIR_EraseRootFromParent_Done,
     /* 2271302 */ // Label 30551: @2271302
     /* 2271302 */ GIM_Try, /*On fail goto*//*Label 30552*/ GIMT_Encode4(2271350), // Rule ID 57432 //
     /* 2271307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271313 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271320 */   // MIs[0] Operand 1
     /* 2271320 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271329 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271333 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2271336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271338 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271340 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271349 */   // GIR_Coverage, 57432,
     /* 2271349 */   GIR_EraseRootFromParent_Done,
     /* 2271350 */ // Label 30552: @2271350
     /* 2271350 */ GIM_Try, /*On fail goto*//*Label 30553*/ GIMT_Encode4(2271398), // Rule ID 57433 //
     /* 2271355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271361 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271368 */   // MIs[0] Operand 1
     /* 2271368 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271377 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271381 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2271384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271386 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271388 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271397 */   // GIR_Coverage, 57433,
     /* 2271397 */   GIR_EraseRootFromParent_Done,
     /* 2271398 */ // Label 30553: @2271398
     /* 2271398 */ GIM_Try, /*On fail goto*//*Label 30554*/ GIMT_Encode4(2271446), // Rule ID 57472 //
     /* 2271403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271409 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271416 */   // MIs[0] Operand 1
     /* 2271416 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271425 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271429 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2271432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271434 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271436 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271445 */   // GIR_Coverage, 57472,
     /* 2271445 */   GIR_EraseRootFromParent_Done,
     /* 2271446 */ // Label 30554: @2271446
     /* 2271446 */ GIM_Try, /*On fail goto*//*Label 30555*/ GIMT_Encode4(2271494), // Rule ID 57473 //
     /* 2271451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271464 */   // MIs[0] Operand 1
     /* 2271464 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271473 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271477 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2271480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271482 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271484 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271493 */   // GIR_Coverage, 57473,
     /* 2271493 */   GIR_EraseRootFromParent_Done,
     /* 2271494 */ // Label 30555: @2271494
     /* 2271494 */ GIM_Try, /*On fail goto*//*Label 30556*/ GIMT_Encode4(2271542), // Rule ID 57672 //
     /* 2271499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271505 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271512 */   // MIs[0] Operand 1
     /* 2271512 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271521 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271525 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2271528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271530 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271532 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271540 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271541 */   // GIR_Coverage, 57672,
     /* 2271541 */   GIR_EraseRootFromParent_Done,
     /* 2271542 */ // Label 30556: @2271542
     /* 2271542 */ GIM_Try, /*On fail goto*//*Label 30557*/ GIMT_Encode4(2271590), // Rule ID 57673 //
     /* 2271547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271560 */   // MIs[0] Operand 1
     /* 2271560 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271569 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271573 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2271576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271578 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271580 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271589 */   // GIR_Coverage, 57673,
     /* 2271589 */   GIR_EraseRootFromParent_Done,
     /* 2271590 */ // Label 30557: @2271590
     /* 2271590 */ GIM_Try, /*On fail goto*//*Label 30558*/ GIMT_Encode4(2271638), // Rule ID 57732 //
     /* 2271595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271601 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271608 */   // MIs[0] Operand 1
     /* 2271608 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271617 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271621 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2271624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271626 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271628 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271636 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271637 */   // GIR_Coverage, 57732,
     /* 2271637 */   GIR_EraseRootFromParent_Done,
     /* 2271638 */ // Label 30558: @2271638
     /* 2271638 */ GIM_Try, /*On fail goto*//*Label 30559*/ GIMT_Encode4(2271686), // Rule ID 57733 //
     /* 2271643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271649 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271656 */   // MIs[0] Operand 1
     /* 2271656 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271665 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271669 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2271672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271674 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271676 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271685 */   // GIR_Coverage, 57733,
     /* 2271685 */   GIR_EraseRootFromParent_Done,
     /* 2271686 */ // Label 30559: @2271686
     /* 2271686 */ GIM_Try, /*On fail goto*//*Label 30560*/ GIMT_Encode4(2271734), // Rule ID 57772 //
     /* 2271691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271697 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271704 */   // MIs[0] Operand 1
     /* 2271704 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271713 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271717 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2271720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271722 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271724 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271733 */   // GIR_Coverage, 57772,
     /* 2271733 */   GIR_EraseRootFromParent_Done,
     /* 2271734 */ // Label 30560: @2271734
     /* 2271734 */ GIM_Try, /*On fail goto*//*Label 30561*/ GIMT_Encode4(2271782), // Rule ID 57773 //
     /* 2271739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271745 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271752 */   // MIs[0] Operand 1
     /* 2271752 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271761 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271765 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2271768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271770 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271772 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271781 */   // GIR_Coverage, 57773,
     /* 2271781 */   GIR_EraseRootFromParent_Done,
     /* 2271782 */ // Label 30561: @2271782
     /* 2271782 */ GIM_Try, /*On fail goto*//*Label 30562*/ GIMT_Encode4(2271830), // Rule ID 57972 //
     /* 2271787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271793 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271800 */   // MIs[0] Operand 1
     /* 2271800 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271809 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271813 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2271816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271818 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271820 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271829 */   // GIR_Coverage, 57972,
     /* 2271829 */   GIR_EraseRootFromParent_Done,
     /* 2271830 */ // Label 30562: @2271830
     /* 2271830 */ GIM_Try, /*On fail goto*//*Label 30563*/ GIMT_Encode4(2271878), // Rule ID 57973 //
     /* 2271835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271848 */   // MIs[0] Operand 1
     /* 2271848 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271857 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271861 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2271864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271866 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271868 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271877 */   // GIR_Coverage, 57973,
     /* 2271877 */   GIR_EraseRootFromParent_Done,
     /* 2271878 */ // Label 30563: @2271878
     /* 2271878 */ GIM_Try, /*On fail goto*//*Label 30564*/ GIMT_Encode4(2271926), // Rule ID 58032 //
     /* 2271883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271889 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271896 */   // MIs[0] Operand 1
     /* 2271896 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271905 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271909 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2271912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271914 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271916 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271925 */   // GIR_Coverage, 58032,
     /* 2271925 */   GIR_EraseRootFromParent_Done,
     /* 2271926 */ // Label 30564: @2271926
     /* 2271926 */ GIM_Try, /*On fail goto*//*Label 30565*/ GIMT_Encode4(2271974), // Rule ID 58033 //
     /* 2271931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271944 */   // MIs[0] Operand 1
     /* 2271944 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271953 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271957 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2271960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271962 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271964 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271973 */   // GIR_Coverage, 58033,
     /* 2271973 */   GIR_EraseRootFromParent_Done,
     /* 2271974 */ // Label 30565: @2271974
     /* 2271974 */ GIM_Try, /*On fail goto*//*Label 30566*/ GIMT_Encode4(2272022), // Rule ID 58072 //
     /* 2271979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271985 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271992 */   // MIs[0] Operand 1
     /* 2271992 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272001 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272005 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2272008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272010 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272012 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272021 */   // GIR_Coverage, 58072,
     /* 2272021 */   GIR_EraseRootFromParent_Done,
     /* 2272022 */ // Label 30566: @2272022
     /* 2272022 */ GIM_Try, /*On fail goto*//*Label 30567*/ GIMT_Encode4(2272070), // Rule ID 58073 //
     /* 2272027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2272033 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2272036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272040 */   // MIs[0] Operand 1
     /* 2272040 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272049 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272053 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2272056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272058 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272060 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272069 */   // GIR_Coverage, 58073,
     /* 2272069 */   GIR_EraseRootFromParent_Done,
     /* 2272070 */ // Label 30567: @2272070
     /* 2272070 */ GIM_Reject,
     /* 2272071 */ // Label 30453: @2272071
     /* 2272071 */ GIM_Try, /*On fail goto*//*Label 30568*/ GIMT_Encode4(2272119), // Rule ID 57102 //
     /* 2272076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272082 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272089 */   // MIs[0] Operand 1
     /* 2272089 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272098 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272102 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2272105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272107 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272109 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272118 */   // GIR_Coverage, 57102,
     /* 2272118 */   GIR_EraseRootFromParent_Done,
     /* 2272119 */ // Label 30568: @2272119
     /* 2272119 */ GIM_Try, /*On fail goto*//*Label 30569*/ GIMT_Encode4(2272167), // Rule ID 57103 //
     /* 2272124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272130 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272137 */   // MIs[0] Operand 1
     /* 2272137 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272146 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272150 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2272153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272155 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272157 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272166 */   // GIR_Coverage, 57103,
     /* 2272166 */   GIR_EraseRootFromParent_Done,
     /* 2272167 */ // Label 30569: @2272167
     /* 2272167 */ GIM_Try, /*On fail goto*//*Label 30570*/ GIMT_Encode4(2272215), // Rule ID 57142 //
     /* 2272172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272178 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272185 */   // MIs[0] Operand 1
     /* 2272185 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272194 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272198 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2272201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272203 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272205 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272213 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272214 */   // GIR_Coverage, 57142,
     /* 2272214 */   GIR_EraseRootFromParent_Done,
     /* 2272215 */ // Label 30570: @2272215
     /* 2272215 */ GIM_Try, /*On fail goto*//*Label 30571*/ GIMT_Encode4(2272263), // Rule ID 57143 //
     /* 2272220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272226 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272233 */   // MIs[0] Operand 1
     /* 2272233 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272242 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272246 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2272249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272251 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272253 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272261 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272262 */   // GIR_Coverage, 57143,
     /* 2272262 */   GIR_EraseRootFromParent_Done,
     /* 2272263 */ // Label 30571: @2272263
     /* 2272263 */ GIM_Try, /*On fail goto*//*Label 30572*/ GIMT_Encode4(2272311), // Rule ID 57182 //
     /* 2272268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272274 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272281 */   // MIs[0] Operand 1
     /* 2272281 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272290 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272294 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2272297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272299 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272301 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272309 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272310 */   // GIR_Coverage, 57182,
     /* 2272310 */   GIR_EraseRootFromParent_Done,
     /* 2272311 */ // Label 30572: @2272311
     /* 2272311 */ GIM_Try, /*On fail goto*//*Label 30573*/ GIMT_Encode4(2272359), // Rule ID 57183 //
     /* 2272316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272329 */   // MIs[0] Operand 1
     /* 2272329 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272338 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272342 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2272345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272347 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272349 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272357 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272358 */   // GIR_Coverage, 57183,
     /* 2272358 */   GIR_EraseRootFromParent_Done,
     /* 2272359 */ // Label 30573: @2272359
     /* 2272359 */ GIM_Try, /*On fail goto*//*Label 30574*/ GIMT_Encode4(2272407), // Rule ID 57402 //
     /* 2272364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272377 */   // MIs[0] Operand 1
     /* 2272377 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272386 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272390 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2272393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272397 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272405 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272406 */   // GIR_Coverage, 57402,
     /* 2272406 */   GIR_EraseRootFromParent_Done,
     /* 2272407 */ // Label 30574: @2272407
     /* 2272407 */ GIM_Try, /*On fail goto*//*Label 30575*/ GIMT_Encode4(2272455), // Rule ID 57403 //
     /* 2272412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272418 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272425 */   // MIs[0] Operand 1
     /* 2272425 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272434 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272438 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2272441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272443 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272445 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272454 */   // GIR_Coverage, 57403,
     /* 2272454 */   GIR_EraseRootFromParent_Done,
     /* 2272455 */ // Label 30575: @2272455
     /* 2272455 */ GIM_Try, /*On fail goto*//*Label 30576*/ GIMT_Encode4(2272503), // Rule ID 57442 //
     /* 2272460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272466 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272473 */   // MIs[0] Operand 1
     /* 2272473 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272482 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272486 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2272489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272491 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272493 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272501 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272502 */   // GIR_Coverage, 57442,
     /* 2272502 */   GIR_EraseRootFromParent_Done,
     /* 2272503 */ // Label 30576: @2272503
     /* 2272503 */ GIM_Try, /*On fail goto*//*Label 30577*/ GIMT_Encode4(2272551), // Rule ID 57443 //
     /* 2272508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272514 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272521 */   // MIs[0] Operand 1
     /* 2272521 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272530 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272534 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2272537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272539 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272541 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272549 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272550 */   // GIR_Coverage, 57443,
     /* 2272550 */   GIR_EraseRootFromParent_Done,
     /* 2272551 */ // Label 30577: @2272551
     /* 2272551 */ GIM_Try, /*On fail goto*//*Label 30578*/ GIMT_Encode4(2272599), // Rule ID 57482 //
     /* 2272556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272562 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272569 */   // MIs[0] Operand 1
     /* 2272569 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272578 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272582 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2272585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272587 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272589 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272597 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272598 */   // GIR_Coverage, 57482,
     /* 2272598 */   GIR_EraseRootFromParent_Done,
     /* 2272599 */ // Label 30578: @2272599
     /* 2272599 */ GIM_Try, /*On fail goto*//*Label 30579*/ GIMT_Encode4(2272647), // Rule ID 57483 //
     /* 2272604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272617 */   // MIs[0] Operand 1
     /* 2272617 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272626 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272630 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2272633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272635 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272637 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272645 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272646 */   // GIR_Coverage, 57483,
     /* 2272646 */   GIR_EraseRootFromParent_Done,
     /* 2272647 */ // Label 30579: @2272647
     /* 2272647 */ GIM_Try, /*On fail goto*//*Label 30580*/ GIMT_Encode4(2272695), // Rule ID 57702 //
     /* 2272652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272658 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272665 */   // MIs[0] Operand 1
     /* 2272665 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272674 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272678 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2272681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272683 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272685 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272694 */   // GIR_Coverage, 57702,
     /* 2272694 */   GIR_EraseRootFromParent_Done,
     /* 2272695 */ // Label 30580: @2272695
     /* 2272695 */ GIM_Try, /*On fail goto*//*Label 30581*/ GIMT_Encode4(2272743), // Rule ID 57703 //
     /* 2272700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272706 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272713 */   // MIs[0] Operand 1
     /* 2272713 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272722 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272726 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2272729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272731 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272733 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272741 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272742 */   // GIR_Coverage, 57703,
     /* 2272742 */   GIR_EraseRootFromParent_Done,
     /* 2272743 */ // Label 30581: @2272743
     /* 2272743 */ GIM_Try, /*On fail goto*//*Label 30582*/ GIMT_Encode4(2272791), // Rule ID 57742 //
     /* 2272748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272754 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272761 */   // MIs[0] Operand 1
     /* 2272761 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272770 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272774 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2272777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272779 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272781 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272789 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272790 */   // GIR_Coverage, 57742,
     /* 2272790 */   GIR_EraseRootFromParent_Done,
     /* 2272791 */ // Label 30582: @2272791
     /* 2272791 */ GIM_Try, /*On fail goto*//*Label 30583*/ GIMT_Encode4(2272839), // Rule ID 57743 //
     /* 2272796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272802 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272809 */   // MIs[0] Operand 1
     /* 2272809 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272818 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272822 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2272825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272827 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272829 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272837 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272838 */   // GIR_Coverage, 57743,
     /* 2272838 */   GIR_EraseRootFromParent_Done,
     /* 2272839 */ // Label 30583: @2272839
     /* 2272839 */ GIM_Try, /*On fail goto*//*Label 30584*/ GIMT_Encode4(2272887), // Rule ID 57782 //
     /* 2272844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272850 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272857 */   // MIs[0] Operand 1
     /* 2272857 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272866 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272870 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2272873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272875 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272877 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272885 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272886 */   // GIR_Coverage, 57782,
     /* 2272886 */   GIR_EraseRootFromParent_Done,
     /* 2272887 */ // Label 30584: @2272887
     /* 2272887 */ GIM_Try, /*On fail goto*//*Label 30585*/ GIMT_Encode4(2272935), // Rule ID 57783 //
     /* 2272892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272898 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272905 */   // MIs[0] Operand 1
     /* 2272905 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272914 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272918 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2272921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272923 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272925 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272933 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272934 */   // GIR_Coverage, 57783,
     /* 2272934 */   GIR_EraseRootFromParent_Done,
     /* 2272935 */ // Label 30585: @2272935
     /* 2272935 */ GIM_Try, /*On fail goto*//*Label 30586*/ GIMT_Encode4(2272983), // Rule ID 58002 //
     /* 2272940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272946 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272953 */   // MIs[0] Operand 1
     /* 2272953 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272962 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272966 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2272969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272971 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272973 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272981 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272982 */   // GIR_Coverage, 58002,
     /* 2272982 */   GIR_EraseRootFromParent_Done,
     /* 2272983 */ // Label 30586: @2272983
     /* 2272983 */ GIM_Try, /*On fail goto*//*Label 30587*/ GIMT_Encode4(2273031), // Rule ID 58003 //
     /* 2272988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272994 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273001 */   // MIs[0] Operand 1
     /* 2273001 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273010 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273014 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2273017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273019 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273021 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273030 */   // GIR_Coverage, 58003,
     /* 2273030 */   GIR_EraseRootFromParent_Done,
     /* 2273031 */ // Label 30587: @2273031
     /* 2273031 */ GIM_Try, /*On fail goto*//*Label 30588*/ GIMT_Encode4(2273079), // Rule ID 58042 //
     /* 2273036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2273042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2273045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273049 */   // MIs[0] Operand 1
     /* 2273049 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273058 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273062 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2273065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273067 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273069 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273077 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273078 */   // GIR_Coverage, 58042,
     /* 2273078 */   GIR_EraseRootFromParent_Done,
     /* 2273079 */ // Label 30588: @2273079
     /* 2273079 */ GIM_Try, /*On fail goto*//*Label 30589*/ GIMT_Encode4(2273127), // Rule ID 58043 //
     /* 2273084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2273090 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2273093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273097 */   // MIs[0] Operand 1
     /* 2273097 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273106 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273110 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2273113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273115 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273117 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273125 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273126 */   // GIR_Coverage, 58043,
     /* 2273126 */   GIR_EraseRootFromParent_Done,
     /* 2273127 */ // Label 30589: @2273127
     /* 2273127 */ GIM_Try, /*On fail goto*//*Label 30590*/ GIMT_Encode4(2273175), // Rule ID 58082 //
     /* 2273132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2273135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2273138 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2273141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273145 */   // MIs[0] Operand 1
     /* 2273145 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273154 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273158 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2273158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273163 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273165 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273174 */   // GIR_Coverage, 58082,
     /* 2273174 */   GIR_EraseRootFromParent_Done,
     /* 2273175 */ // Label 30590: @2273175
     /* 2273175 */ GIM_Try, /*On fail goto*//*Label 30591*/ GIMT_Encode4(2273223), // Rule ID 58083 //
     /* 2273180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2273183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2273186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2273189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273193 */   // MIs[0] Operand 1
     /* 2273193 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273202 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273206 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2273206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273211 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273213 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273221 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273222 */   // GIR_Coverage, 58083,
     /* 2273222 */   GIR_EraseRootFromParent_Done,
     /* 2273223 */ // Label 30591: @2273223
     /* 2273223 */ GIM_Reject,
     /* 2273224 */ // Label 30454: @2273224
     /* 2273224 */ GIM_Try, /*On fail goto*//*Label 30592*/ GIMT_Encode4(2273272), // Rule ID 57112 //
     /* 2273229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273235 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273242 */   // MIs[0] Operand 1
     /* 2273242 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273251 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273255 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2273258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273260 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273262 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273270 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273271 */   // GIR_Coverage, 57112,
     /* 2273271 */   GIR_EraseRootFromParent_Done,
     /* 2273272 */ // Label 30592: @2273272
     /* 2273272 */ GIM_Try, /*On fail goto*//*Label 30593*/ GIMT_Encode4(2273320), // Rule ID 57113 //
     /* 2273277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273283 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273290 */   // MIs[0] Operand 1
     /* 2273290 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273299 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273303 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2273306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273308 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273310 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273319 */   // GIR_Coverage, 57113,
     /* 2273319 */   GIR_EraseRootFromParent_Done,
     /* 2273320 */ // Label 30593: @2273320
     /* 2273320 */ GIM_Try, /*On fail goto*//*Label 30594*/ GIMT_Encode4(2273368), // Rule ID 57152 //
     /* 2273325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273338 */   // MIs[0] Operand 1
     /* 2273338 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273347 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273351 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2273354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273356 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273358 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273366 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273367 */   // GIR_Coverage, 57152,
     /* 2273367 */   GIR_EraseRootFromParent_Done,
     /* 2273368 */ // Label 30594: @2273368
     /* 2273368 */ GIM_Try, /*On fail goto*//*Label 30595*/ GIMT_Encode4(2273416), // Rule ID 57153 //
     /* 2273373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273379 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273386 */   // MIs[0] Operand 1
     /* 2273386 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273395 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273399 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2273402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273404 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273406 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273415 */   // GIR_Coverage, 57153,
     /* 2273415 */   GIR_EraseRootFromParent_Done,
     /* 2273416 */ // Label 30595: @2273416
     /* 2273416 */ GIM_Try, /*On fail goto*//*Label 30596*/ GIMT_Encode4(2273464), // Rule ID 57412 //
     /* 2273421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273427 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273434 */   // MIs[0] Operand 1
     /* 2273434 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273443 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273447 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2273450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273452 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273454 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273462 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273463 */   // GIR_Coverage, 57412,
     /* 2273463 */   GIR_EraseRootFromParent_Done,
     /* 2273464 */ // Label 30596: @2273464
     /* 2273464 */ GIM_Try, /*On fail goto*//*Label 30597*/ GIMT_Encode4(2273512), // Rule ID 57413 //
     /* 2273469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273475 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273482 */   // MIs[0] Operand 1
     /* 2273482 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273491 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273495 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2273498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273500 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273502 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273511 */   // GIR_Coverage, 57413,
     /* 2273511 */   GIR_EraseRootFromParent_Done,
     /* 2273512 */ // Label 30597: @2273512
     /* 2273512 */ GIM_Try, /*On fail goto*//*Label 30598*/ GIMT_Encode4(2273560), // Rule ID 57452 //
     /* 2273517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273523 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273530 */   // MIs[0] Operand 1
     /* 2273530 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273539 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273543 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2273546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273548 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273550 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273558 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273559 */   // GIR_Coverage, 57452,
     /* 2273559 */   GIR_EraseRootFromParent_Done,
     /* 2273560 */ // Label 30598: @2273560
     /* 2273560 */ GIM_Try, /*On fail goto*//*Label 30599*/ GIMT_Encode4(2273608), // Rule ID 57453 //
     /* 2273565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273571 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273578 */   // MIs[0] Operand 1
     /* 2273578 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273587 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273591 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2273594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273596 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273598 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273606 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273607 */   // GIR_Coverage, 57453,
     /* 2273607 */   GIR_EraseRootFromParent_Done,
     /* 2273608 */ // Label 30599: @2273608
     /* 2273608 */ GIM_Try, /*On fail goto*//*Label 30600*/ GIMT_Encode4(2273656), // Rule ID 57712 //
     /* 2273613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273619 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273626 */   // MIs[0] Operand 1
     /* 2273626 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273635 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273639 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2273642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273644 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273646 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273654 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273655 */   // GIR_Coverage, 57712,
     /* 2273655 */   GIR_EraseRootFromParent_Done,
     /* 2273656 */ // Label 30600: @2273656
     /* 2273656 */ GIM_Try, /*On fail goto*//*Label 30601*/ GIMT_Encode4(2273704), // Rule ID 57713 //
     /* 2273661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273667 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273674 */   // MIs[0] Operand 1
     /* 2273674 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273683 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273687 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2273690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273692 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273694 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273703 */   // GIR_Coverage, 57713,
     /* 2273703 */   GIR_EraseRootFromParent_Done,
     /* 2273704 */ // Label 30601: @2273704
     /* 2273704 */ GIM_Try, /*On fail goto*//*Label 30602*/ GIMT_Encode4(2273752), // Rule ID 57752 //
     /* 2273709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273715 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273722 */   // MIs[0] Operand 1
     /* 2273722 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273731 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273735 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2273738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273740 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273742 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273750 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273751 */   // GIR_Coverage, 57752,
     /* 2273751 */   GIR_EraseRootFromParent_Done,
     /* 2273752 */ // Label 30602: @2273752
     /* 2273752 */ GIM_Try, /*On fail goto*//*Label 30603*/ GIMT_Encode4(2273800), // Rule ID 57753 //
     /* 2273757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273770 */   // MIs[0] Operand 1
     /* 2273770 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273779 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273783 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2273786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273788 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273790 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273798 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273799 */   // GIR_Coverage, 57753,
     /* 2273799 */   GIR_EraseRootFromParent_Done,
     /* 2273800 */ // Label 30603: @2273800
     /* 2273800 */ GIM_Try, /*On fail goto*//*Label 30604*/ GIMT_Encode4(2273848), // Rule ID 58012 //
     /* 2273805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273811 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273818 */   // MIs[0] Operand 1
     /* 2273818 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273827 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273831 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2273834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273836 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273838 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273846 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273847 */   // GIR_Coverage, 58012,
     /* 2273847 */   GIR_EraseRootFromParent_Done,
     /* 2273848 */ // Label 30604: @2273848
     /* 2273848 */ GIM_Try, /*On fail goto*//*Label 30605*/ GIMT_Encode4(2273896), // Rule ID 58013 //
     /* 2273853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273859 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273866 */   // MIs[0] Operand 1
     /* 2273866 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273871 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273875 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273879 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2273882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273884 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273886 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273894 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273895 */   // GIR_Coverage, 58013,
     /* 2273895 */   GIR_EraseRootFromParent_Done,
     /* 2273896 */ // Label 30605: @2273896
     /* 2273896 */ GIM_Try, /*On fail goto*//*Label 30606*/ GIMT_Encode4(2273944), // Rule ID 58052 //
     /* 2273901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273907 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273914 */   // MIs[0] Operand 1
     /* 2273914 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273923 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273927 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273932 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273934 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273942 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273943 */   // GIR_Coverage, 58052,
     /* 2273943 */   GIR_EraseRootFromParent_Done,
     /* 2273944 */ // Label 30606: @2273944
     /* 2273944 */ GIM_Try, /*On fail goto*//*Label 30607*/ GIMT_Encode4(2273992), // Rule ID 58053 //
     /* 2273949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273955 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273962 */   // MIs[0] Operand 1
     /* 2273962 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273971 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273975 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273980 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273982 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273990 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273991 */   // GIR_Coverage, 58053,
     /* 2273991 */   GIR_EraseRootFromParent_Done,
     /* 2273992 */ // Label 30607: @2273992
     /* 2273992 */ GIM_Reject,
     /* 2273993 */ // Label 30455: @2273993
     /* 2273993 */ GIM_Try, /*On fail goto*//*Label 30608*/ GIMT_Encode4(2274313),
     /* 2273998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2274001 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2274004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274008 */   GIM_Try, /*On fail goto*//*Label 30609*/ GIMT_Encode4(2274046), // Rule ID 57122 //
     /* 2274013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274016 */     // MIs[0] Operand 1
     /* 2274016 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2274021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274029 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2274029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2274032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274045 */     // GIR_Coverage, 57122,
     /* 2274045 */     GIR_EraseRootFromParent_Done,
     /* 2274046 */   // Label 30609: @2274046
     /* 2274046 */   GIM_Try, /*On fail goto*//*Label 30610*/ GIMT_Encode4(2274084), // Rule ID 57123 //
     /* 2274051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274054 */     // MIs[0] Operand 1
     /* 2274054 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2274059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274067 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2274067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2274070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274083 */     // GIR_Coverage, 57123,
     /* 2274083 */     GIR_EraseRootFromParent_Done,
     /* 2274084 */   // Label 30610: @2274084
     /* 2274084 */   GIM_Try, /*On fail goto*//*Label 30611*/ GIMT_Encode4(2274122), // Rule ID 57422 //
     /* 2274089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274092 */     // MIs[0] Operand 1
     /* 2274092 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2274097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274105 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2274105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2274108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274121 */     // GIR_Coverage, 57422,
     /* 2274121 */     GIR_EraseRootFromParent_Done,
     /* 2274122 */   // Label 30611: @2274122
     /* 2274122 */   GIM_Try, /*On fail goto*//*Label 30612*/ GIMT_Encode4(2274160), // Rule ID 57423 //
     /* 2274127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274130 */     // MIs[0] Operand 1
     /* 2274130 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2274135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274143 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2274143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2274146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274159 */     // GIR_Coverage, 57423,
     /* 2274159 */     GIR_EraseRootFromParent_Done,
     /* 2274160 */   // Label 30612: @2274160
     /* 2274160 */   GIM_Try, /*On fail goto*//*Label 30613*/ GIMT_Encode4(2274198), // Rule ID 57722 //
     /* 2274165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274168 */     // MIs[0] Operand 1
     /* 2274168 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2274173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274181 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2274181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2274184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274197 */     // GIR_Coverage, 57722,
     /* 2274197 */     GIR_EraseRootFromParent_Done,
     /* 2274198 */   // Label 30613: @2274198
     /* 2274198 */   GIM_Try, /*On fail goto*//*Label 30614*/ GIMT_Encode4(2274236), // Rule ID 57723 //
     /* 2274203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274206 */     // MIs[0] Operand 1
     /* 2274206 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2274211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274219 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2274219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2274222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274235 */     // GIR_Coverage, 57723,
     /* 2274235 */     GIR_EraseRootFromParent_Done,
     /* 2274236 */   // Label 30614: @2274236
     /* 2274236 */   GIM_Try, /*On fail goto*//*Label 30615*/ GIMT_Encode4(2274274), // Rule ID 58022 //
     /* 2274241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274244 */     // MIs[0] Operand 1
     /* 2274244 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2274249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274257 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2274257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2274260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274273 */     // GIR_Coverage, 58022,
     /* 2274273 */     GIR_EraseRootFromParent_Done,
     /* 2274274 */   // Label 30615: @2274274
     /* 2274274 */   GIM_Try, /*On fail goto*//*Label 30616*/ GIMT_Encode4(2274312), // Rule ID 58023 //
     /* 2274279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274282 */     // MIs[0] Operand 1
     /* 2274282 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2274287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274295 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2274295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2274298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274311 */     // GIR_Coverage, 58023,
     /* 2274311 */     GIR_EraseRootFromParent_Done,
     /* 2274312 */   // Label 30616: @2274312
     /* 2274312 */   GIM_Reject,
     /* 2274313 */ // Label 30608: @2274313
     /* 2274313 */ GIM_Reject,
     /* 2274314 */ // Label 30456: @2274314
     /* 2274314 */ GIM_Reject,
     /* 2274315 */ // Label 50: @2274315
     /* 2274315 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30641*/ GIMT_Encode4(2285299),
     /* 2274326 */ /*GILLT_s32*//*Label 30617*/ GIMT_Encode4(2274450),
     /* 2274330 */ /*GILLT_s64*//*Label 30618*/ GIMT_Encode4(2278716), GIMT_Encode4(0),
     /* 2274338 */ /*GILLT_nxv1s8*//*Label 30619*/ GIMT_Encode4(2281339),
     /* 2274342 */ /*GILLT_nxv1s16*//*Label 30620*/ GIMT_Encode4(2281459),
     /* 2274346 */ /*GILLT_nxv1s32*//*Label 30621*/ GIMT_Encode4(2281667),
     /* 2274350 */ /*GILLT_nxv1s64*//*Label 30622*/ GIMT_Encode4(2281875), GIMT_Encode4(0),
     /* 2274358 */ /*GILLT_nxv2s8*//*Label 30623*/ GIMT_Encode4(2282083),
     /* 2274362 */ /*GILLT_nxv2s16*//*Label 30624*/ GIMT_Encode4(2282203),
     /* 2274366 */ /*GILLT_nxv2s32*//*Label 30625*/ GIMT_Encode4(2282411),
     /* 2274370 */ /*GILLT_nxv2s64*//*Label 30626*/ GIMT_Encode4(2282619), GIMT_Encode4(0),
     /* 2274378 */ /*GILLT_nxv4s8*//*Label 30627*/ GIMT_Encode4(2282827),
     /* 2274382 */ /*GILLT_nxv4s16*//*Label 30628*/ GIMT_Encode4(2282947),
     /* 2274386 */ /*GILLT_nxv4s32*//*Label 30629*/ GIMT_Encode4(2283155),
     /* 2274390 */ /*GILLT_nxv4s64*//*Label 30630*/ GIMT_Encode4(2283363), GIMT_Encode4(0),
     /* 2274398 */ /*GILLT_nxv8s8*//*Label 30631*/ GIMT_Encode4(2283571),
     /* 2274402 */ /*GILLT_nxv8s16*//*Label 30632*/ GIMT_Encode4(2283691),
     /* 2274406 */ /*GILLT_nxv8s32*//*Label 30633*/ GIMT_Encode4(2283899),
     /* 2274410 */ /*GILLT_nxv8s64*//*Label 30634*/ GIMT_Encode4(2284107), GIMT_Encode4(0),
     /* 2274418 */ /*GILLT_nxv16s8*//*Label 30635*/ GIMT_Encode4(2284315),
     /* 2274422 */ /*GILLT_nxv16s16*//*Label 30636*/ GIMT_Encode4(2284435),
     /* 2274426 */ /*GILLT_nxv16s32*//*Label 30637*/ GIMT_Encode4(2284643), GIMT_Encode4(0),
     /* 2274434 */ /*GILLT_nxv32s8*//*Label 30638*/ GIMT_Encode4(2284851),
     /* 2274438 */ /*GILLT_nxv32s16*//*Label 30639*/ GIMT_Encode4(2284971), GIMT_Encode4(0),
     /* 2274446 */ /*GILLT_nxv64s8*//*Label 30640*/ GIMT_Encode4(2285179),
     /* 2274450 */ // Label 30617: @2274450
     /* 2274450 */ GIM_Try, /*On fail goto*//*Label 30642*/ GIMT_Encode4(2278715),
     /* 2274455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2274458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274461 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274464 */   GIM_Try, /*On fail goto*//*Label 30643*/ GIMT_Encode4(2274551), // Rule ID 64680 //
     /* 2274469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2274472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274488 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274492 */     // MIs[1] Operand 1
     /* 2274492 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2274497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274510 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274514 */     // MIs[2] Operand 1
     /* 2274514 */     // No operand predicates
     /* 2274514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2274518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274526 */     // MIs[3] Operand 1
     /* 2274526 */     // No operand predicates
     /* 2274526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2274532 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LIEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2274532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQI),
     /* 2274535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2274549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274550 */     // GIR_Coverage, 64680,
     /* 2274550 */     GIR_EraseRootFromParent_Done,
     /* 2274551 */   // Label 30643: @2274551
     /* 2274551 */   GIM_Try, /*On fail goto*//*Label 30644*/ GIMT_Encode4(2274638), // Rule ID 64682 //
     /* 2274556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2274559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274575 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274579 */     // MIs[1] Operand 1
     /* 2274579 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2274584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274601 */     // MIs[2] Operand 1
     /* 2274601 */     // No operand predicates
     /* 2274601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2274605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274609 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274613 */     // MIs[3] Operand 1
     /* 2274613 */     // No operand predicates
     /* 2274613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2274619 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LINEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2274619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINEI),
     /* 2274622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2274636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274637 */     // GIR_Coverage, 64682,
     /* 2274637 */     GIR_EraseRootFromParent_Done,
     /* 2274638 */   // Label 30644: @2274638
     /* 2274638 */   GIM_Try, /*On fail goto*//*Label 30645*/ GIMT_Encode4(2274725), // Rule ID 64684 //
     /* 2274643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2274646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274662 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274666 */     // MIs[1] Operand 1
     /* 2274666 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2274671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274684 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274688 */     // MIs[2] Operand 1
     /* 2274688 */     // No operand predicates
     /* 2274688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2274692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274696 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274700 */     // MIs[3] Operand 1
     /* 2274700 */     // No operand predicates
     /* 2274700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2274706 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LILTI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2274706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTI),
     /* 2274709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2274723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274724 */     // GIR_Coverage, 64684,
     /* 2274724 */     GIR_EraseRootFromParent_Done,
     /* 2274725 */   // Label 30645: @2274725
     /* 2274725 */   GIM_Try, /*On fail goto*//*Label 30646*/ GIMT_Encode4(2274812), // Rule ID 64686 //
     /* 2274730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2274733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274749 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274753 */     // MIs[1] Operand 1
     /* 2274753 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2274758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274771 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274775 */     // MIs[2] Operand 1
     /* 2274775 */     // No operand predicates
     /* 2274775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2274779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274783 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274787 */     // MIs[3] Operand 1
     /* 2274787 */     // No operand predicates
     /* 2274787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2274793 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETGE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LIGEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2274793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEI),
     /* 2274796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2274810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274811 */     // GIR_Coverage, 64686,
     /* 2274811 */     GIR_EraseRootFromParent_Done,
     /* 2274812 */   // Label 30646: @2274812
     /* 2274812 */   GIM_Try, /*On fail goto*//*Label 30647*/ GIMT_Encode4(2274899), // Rule ID 64688 //
     /* 2274817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2274820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274836 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274840 */     // MIs[1] Operand 1
     /* 2274840 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2274845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274858 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2274862 */     // MIs[2] Operand 1
     /* 2274862 */     // No operand predicates
     /* 2274862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2274866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274870 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274874 */     // MIs[3] Operand 1
     /* 2274874 */     // No operand predicates
     /* 2274874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2274880 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, SETULT:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LILTUI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2274880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTUI),
     /* 2274883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2274897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274898 */     // GIR_Coverage, 64688,
     /* 2274898 */     GIR_EraseRootFromParent_Done,
     /* 2274899 */   // Label 30647: @2274899
     /* 2274899 */   GIM_Try, /*On fail goto*//*Label 30648*/ GIMT_Encode4(2274986), // Rule ID 64690 //
     /* 2274904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2274907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274923 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274927 */     // MIs[1] Operand 1
     /* 2274927 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2274932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274945 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2274949 */     // MIs[2] Operand 1
     /* 2274949 */     // No operand predicates
     /* 2274949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2274953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274957 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274961 */     // MIs[3] Operand 1
     /* 2274961 */     // No operand predicates
     /* 2274961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2274967 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, SETUGE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LIGEUI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2274967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEUI),
     /* 2274970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2274984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274985 */     // GIR_Coverage, 64690,
     /* 2274985 */     GIR_EraseRootFromParent_Done,
     /* 2274986 */   // Label 30648: @2274986
     /* 2274986 */   GIM_Try, /*On fail goto*//*Label 30649*/ GIMT_Encode4(2275073), // Rule ID 64722 //
     /* 2274991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2274994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275010 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275014 */     // MIs[1] Operand 1
     /* 2275014 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2275019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275032 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275036 */     // MIs[2] Operand 1
     /* 2275036 */     // No operand predicates
     /* 2275036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2275040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275044 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275048 */     // MIs[3] Operand 1
     /* 2275048 */     // No operand predicates
     /* 2275048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275054 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SELECTINEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2275054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTINEI),
     /* 2275057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2275063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2275071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275072 */     // GIR_Coverage, 64722,
     /* 2275072 */     GIR_EraseRootFromParent_Done,
     /* 2275073 */   // Label 30649: @2275073
     /* 2275073 */   GIM_Try, /*On fail goto*//*Label 30650*/ GIMT_Encode4(2275160), // Rule ID 64723 //
     /* 2275078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2275081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275097 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275101 */     // MIs[1] Operand 1
     /* 2275101 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2275106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275119 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275123 */     // MIs[2] Operand 1
     /* 2275123 */     // No operand predicates
     /* 2275123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2275127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275131 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275135 */     // MIs[3] Operand 1
     /* 2275135 */     // No operand predicates
     /* 2275135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275141 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SELECTIEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2275141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIEQI),
     /* 2275144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2275150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2275158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275159 */     // GIR_Coverage, 64723,
     /* 2275159 */     GIR_EraseRootFromParent_Done,
     /* 2275160 */   // Label 30650: @2275160
     /* 2275160 */   GIM_Try, /*On fail goto*//*Label 30651*/ GIMT_Encode4(2275247), // Rule ID 64704 //
     /* 2275165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2275168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275184 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275188 */     // MIs[1] Operand 1
     /* 2275188 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2275193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275206 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275210 */     // MIs[2] Operand 1
     /* 2275210 */     // No operand predicates
     /* 2275210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275222 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275226 */     // MIs[3] Operand 1
     /* 2275226 */     // No operand predicates
     /* 2275226 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275228 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2275228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQI),
     /* 2275231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2275245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275246 */     // GIR_Coverage, 64704,
     /* 2275246 */     GIR_EraseRootFromParent_Done,
     /* 2275247 */   // Label 30651: @2275247
     /* 2275247 */   GIM_Try, /*On fail goto*//*Label 30652*/ GIMT_Encode4(2275334), // Rule ID 64706 //
     /* 2275252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2275255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275271 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275275 */     // MIs[1] Operand 1
     /* 2275275 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2275280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275293 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275297 */     // MIs[2] Operand 1
     /* 2275297 */     // No operand predicates
     /* 2275297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275309 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275313 */     // MIs[3] Operand 1
     /* 2275313 */     // No operand predicates
     /* 2275313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275315 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LINEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2275315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINEI),
     /* 2275318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2275332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275333 */     // GIR_Coverage, 64706,
     /* 2275333 */     GIR_EraseRootFromParent_Done,
     /* 2275334 */   // Label 30652: @2275334
     /* 2275334 */   GIM_Try, /*On fail goto*//*Label 30653*/ GIMT_Encode4(2275421), // Rule ID 64708 //
     /* 2275339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2275342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275358 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275362 */     // MIs[1] Operand 1
     /* 2275362 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2275367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275380 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275384 */     // MIs[2] Operand 1
     /* 2275384 */     // No operand predicates
     /* 2275384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275396 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275400 */     // MIs[3] Operand 1
     /* 2275400 */     // No operand predicates
     /* 2275400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275402 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETGE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILTI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2275402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTI),
     /* 2275405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2275419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275420 */     // GIR_Coverage, 64708,
     /* 2275420 */     GIR_EraseRootFromParent_Done,
     /* 2275421 */   // Label 30653: @2275421
     /* 2275421 */   GIM_Try, /*On fail goto*//*Label 30654*/ GIMT_Encode4(2275508), // Rule ID 64710 //
     /* 2275426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2275429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275445 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275449 */     // MIs[1] Operand 1
     /* 2275449 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2275454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275467 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275471 */     // MIs[2] Operand 1
     /* 2275471 */     // No operand predicates
     /* 2275471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275483 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275487 */     // MIs[3] Operand 1
     /* 2275487 */     // No operand predicates
     /* 2275487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275489 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2275489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEI),
     /* 2275492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2275506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275507 */     // GIR_Coverage, 64710,
     /* 2275507 */     GIR_EraseRootFromParent_Done,
     /* 2275508 */   // Label 30654: @2275508
     /* 2275508 */   GIM_Try, /*On fail goto*//*Label 30655*/ GIMT_Encode4(2275595), // Rule ID 64712 //
     /* 2275513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2275516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275532 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275536 */     // MIs[1] Operand 1
     /* 2275536 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2275541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275554 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2275558 */     // MIs[2] Operand 1
     /* 2275558 */     // No operand predicates
     /* 2275558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275570 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275574 */     // MIs[3] Operand 1
     /* 2275574 */     // No operand predicates
     /* 2275574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275576 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, SETUGE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILTUI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2275576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTUI),
     /* 2275579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2275593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275594 */     // GIR_Coverage, 64712,
     /* 2275594 */     GIR_EraseRootFromParent_Done,
     /* 2275595 */   // Label 30655: @2275595
     /* 2275595 */   GIM_Try, /*On fail goto*//*Label 30656*/ GIMT_Encode4(2275682), // Rule ID 64714 //
     /* 2275600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2275603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275619 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275623 */     // MIs[1] Operand 1
     /* 2275623 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2275628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2275645 */     // MIs[2] Operand 1
     /* 2275645 */     // No operand predicates
     /* 2275645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275657 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275661 */     // MIs[3] Operand 1
     /* 2275661 */     // No operand predicates
     /* 2275661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275663 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGEUI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2275663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEUI),
     /* 2275666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2275680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275681 */     // GIR_Coverage, 64714,
     /* 2275681 */     GIR_EraseRootFromParent_Done,
     /* 2275682 */   // Label 30656: @2275682
     /* 2275682 */   GIM_Try, /*On fail goto*//*Label 30657*/ GIMT_Encode4(2275769), // Rule ID 64720 //
     /* 2275687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2275690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275706 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275710 */     // MIs[1] Operand 1
     /* 2275710 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2275715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275728 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275732 */     // MIs[2] Operand 1
     /* 2275732 */     // No operand predicates
     /* 2275732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275744 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275748 */     // MIs[3] Operand 1
     /* 2275748 */     // No operand predicates
     /* 2275748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275750 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTIEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2275750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIEQI),
     /* 2275753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2275759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2275767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275768 */     // GIR_Coverage, 64720,
     /* 2275768 */     GIR_EraseRootFromParent_Done,
     /* 2275769 */   // Label 30657: @2275769
     /* 2275769 */   GIM_Try, /*On fail goto*//*Label 30658*/ GIMT_Encode4(2275856), // Rule ID 64721 //
     /* 2275774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2275777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275793 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275797 */     // MIs[1] Operand 1
     /* 2275797 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2275802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275815 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275819 */     // MIs[2] Operand 1
     /* 2275819 */     // No operand predicates
     /* 2275819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275831 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275835 */     // MIs[3] Operand 1
     /* 2275835 */     // No operand predicates
     /* 2275835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275837 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTINEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2275837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTINEI),
     /* 2275840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2275846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2275854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275855 */     // GIR_Coverage, 64721,
     /* 2275855 */     GIR_EraseRootFromParent_Done,
     /* 2275856 */   // Label 30658: @2275856
     /* 2275856 */   GIM_Try, /*On fail goto*//*Label 30659*/ GIMT_Encode4(2275946), // Rule ID 64729 //
     /* 2275861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2275864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275880 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275884 */     // MIs[1] Operand 1
     /* 2275884 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2275889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2275903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275907 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275911 */     // MIs[2] Operand 1
     /* 2275911 */     // No operand predicates
     /* 2275911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275919 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275923 */     // MIs[3] Operand 1
     /* 2275923 */     // No operand predicates
     /* 2275923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275925 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETEQ:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTIIEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2275925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIIEQ),
     /* 2275928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2275934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2275938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm1
     /* 2275941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2275944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275945 */     // GIR_Coverage, 64729,
     /* 2275945 */     GIR_EraseRootFromParent_Done,
     /* 2275946 */   // Label 30659: @2275946
     /* 2275946 */   GIM_Try, /*On fail goto*//*Label 30660*/ GIMT_Encode4(2276036), // Rule ID 64731 //
     /* 2275951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2275954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275970 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275974 */     // MIs[1] Operand 1
     /* 2275974 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2275979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2275993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275997 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276001 */     // MIs[2] Operand 1
     /* 2276001 */     // No operand predicates
     /* 2276001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2276005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276013 */     // MIs[3] Operand 1
     /* 2276013 */     // No operand predicates
     /* 2276013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2276015 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETNE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTIINE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2276015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIINE),
     /* 2276018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2276024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2276028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm1
     /* 2276031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2276034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276035 */     // GIR_Coverage, 64731,
     /* 2276035 */     GIR_EraseRootFromParent_Done,
     /* 2276036 */   // Label 30660: @2276036
     /* 2276036 */   GIM_Try, /*On fail goto*//*Label 30661*/ GIMT_Encode4(2276114), // Rule ID 64663 //
     /* 2276041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2276044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276060 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276064 */     // MIs[1] Operand 1
     /* 2276064 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2276069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2276078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276082 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276086 */     // MIs[2] Operand 1
     /* 2276086 */     // No operand predicates
     /* 2276086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276096 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2276096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTI),
     /* 2276099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2276110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2276112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276113 */     // GIR_Coverage, 64663,
     /* 2276113 */     GIR_EraseRootFromParent_Done,
     /* 2276114 */   // Label 30661: @2276114
     /* 2276114 */   GIM_Try, /*On fail goto*//*Label 30662*/ GIMT_Encode4(2276192), // Rule ID 64664 //
     /* 2276119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2276122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276138 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276142 */     // MIs[1] Operand 1
     /* 2276142 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2276147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2276156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2276164 */     // MIs[2] Operand 1
     /* 2276164 */     // No operand predicates
     /* 2276164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276174 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTUI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2276174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTUI),
     /* 2276177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2276188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2276190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276191 */     // GIR_Coverage, 64664,
     /* 2276191 */     GIR_EraseRootFromParent_Done,
     /* 2276192 */   // Label 30662: @2276192
     /* 2276192 */   GIM_Try, /*On fail goto*//*Label 30663*/ GIMT_Encode4(2276270), // Rule ID 64665 //
     /* 2276197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_NoVendorXqcics_HwMode1),
     /* 2276200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276216 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276220 */     // MIs[1] Operand 1
     /* 2276220 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2276225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2276234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276238 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276242 */     // MIs[2] Operand 1
     /* 2276242 */     // No operand predicates
     /* 2276242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276252 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2276252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQI),
     /* 2276255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2276266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2276268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276269 */     // GIR_Coverage, 64665,
     /* 2276269 */     GIR_EraseRootFromParent_Done,
     /* 2276270 */   // Label 30663: @2276270
     /* 2276270 */   GIM_Try, /*On fail goto*//*Label 30664*/ GIMT_Encode4(2276348), // Rule ID 64666 //
     /* 2276275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_NoVendorXqcics_HwMode1),
     /* 2276278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276294 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276298 */     // MIs[1] Operand 1
     /* 2276298 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2276303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2276312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276316 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276320 */     // MIs[2] Operand 1
     /* 2276320 */     // No operand predicates
     /* 2276320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276330 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVNEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2276330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNEI),
     /* 2276333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2276344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2276346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276347 */     // GIR_Coverage, 64666,
     /* 2276347 */     GIR_EraseRootFromParent_Done,
     /* 2276348 */   // Label 30664: @2276348
     /* 2276348 */   GIM_Try, /*On fail goto*//*Label 30665*/ GIMT_Encode4(2276426), // Rule ID 64718 //
     /* 2276353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2276356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276372 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276376 */     // MIs[1] Operand 1
     /* 2276376 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2276381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2276390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276394 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276398 */     // MIs[2] Operand 1
     /* 2276398 */     // No operand predicates
     /* 2276398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276408 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)  =>  (QC_SELECTEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2276408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTEQI),
     /* 2276411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2276417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2276420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2276424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276425 */     // GIR_Coverage, 64718,
     /* 2276425 */     GIR_EraseRootFromParent_Done,
     /* 2276426 */   // Label 30665: @2276426
     /* 2276426 */   GIM_Try, /*On fail goto*//*Label 30666*/ GIMT_Encode4(2276504), // Rule ID 64719 //
     /* 2276431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2276434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276450 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276454 */     // MIs[1] Operand 1
     /* 2276454 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2276459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2276468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276472 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276476 */     // MIs[2] Operand 1
     /* 2276476 */     // No operand predicates
     /* 2276476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276486 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)  =>  (QC_SELECTNEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2276486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTNEI),
     /* 2276489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2276495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2276498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2276502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276503 */     // GIR_Coverage, 64719,
     /* 2276503 */     GIR_EraseRootFromParent_Done,
     /* 2276504 */   // Label 30666: @2276504
     /* 2276504 */   GIM_Try, /*On fail goto*//*Label 30667*/ GIMT_Encode4(2276585), // Rule ID 64668 //
     /* 2276509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2276512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276528 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276532 */     // MIs[1] Operand 1
     /* 2276532 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2276537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2276551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276555 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276559 */     // MIs[2] Operand 1
     /* 2276559 */     // No operand predicates
     /* 2276559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276565 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LIEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2276565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQ),
     /* 2276568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2276580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2276583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276584 */     // GIR_Coverage, 64668,
     /* 2276584 */     GIR_EraseRootFromParent_Done,
     /* 2276585 */   // Label 30667: @2276585
     /* 2276585 */   GIM_Try, /*On fail goto*//*Label 30668*/ GIMT_Encode4(2276666), // Rule ID 64670 //
     /* 2276590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2276593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276609 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276613 */     // MIs[1] Operand 1
     /* 2276613 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2276618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2276632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276636 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276640 */     // MIs[2] Operand 1
     /* 2276640 */     // No operand predicates
     /* 2276640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276646 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETNE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LINE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2276646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINE),
     /* 2276649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2276661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2276664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276665 */     // GIR_Coverage, 64670,
     /* 2276665 */     GIR_EraseRootFromParent_Done,
     /* 2276666 */   // Label 30668: @2276666
     /* 2276666 */   GIM_Try, /*On fail goto*//*Label 30669*/ GIMT_Encode4(2276747), // Rule ID 64672 //
     /* 2276671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2276674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276690 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276694 */     // MIs[1] Operand 1
     /* 2276694 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2276699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2276713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276717 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276721 */     // MIs[2] Operand 1
     /* 2276721 */     // No operand predicates
     /* 2276721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276727 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETLT:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LILT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2276727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILT),
     /* 2276730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2276742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2276745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276746 */     // GIR_Coverage, 64672,
     /* 2276746 */     GIR_EraseRootFromParent_Done,
     /* 2276747 */   // Label 30669: @2276747
     /* 2276747 */   GIM_Try, /*On fail goto*//*Label 30670*/ GIMT_Encode4(2276828), // Rule ID 64674 //
     /* 2276752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2276755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276771 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276775 */     // MIs[1] Operand 1
     /* 2276775 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2276780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2276794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276798 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276802 */     // MIs[2] Operand 1
     /* 2276802 */     // No operand predicates
     /* 2276802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276808 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETGE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LIGE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2276808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGE),
     /* 2276811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2276823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2276826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276827 */     // GIR_Coverage, 64674,
     /* 2276827 */     GIR_EraseRootFromParent_Done,
     /* 2276828 */   // Label 30670: @2276828
     /* 2276828 */   GIM_Try, /*On fail goto*//*Label 30671*/ GIMT_Encode4(2276909), // Rule ID 64676 //
     /* 2276833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2276836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276852 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276856 */     // MIs[1] Operand 1
     /* 2276856 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2276861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2276875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276879 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276883 */     // MIs[2] Operand 1
     /* 2276883 */     // No operand predicates
     /* 2276883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276889 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETULT:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LILTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2276889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTU),
     /* 2276892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2276904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2276907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276908 */     // GIR_Coverage, 64676,
     /* 2276908 */     GIR_EraseRootFromParent_Done,
     /* 2276909 */   // Label 30671: @2276909
     /* 2276909 */   GIM_Try, /*On fail goto*//*Label 30672*/ GIMT_Encode4(2276990), // Rule ID 64678 //
     /* 2276914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2276917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276933 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276937 */     // MIs[1] Operand 1
     /* 2276937 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2276942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2276956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276964 */     // MIs[2] Operand 1
     /* 2276964 */     // No operand predicates
     /* 2276964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276970 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LIGEU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2276970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEU),
     /* 2276973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2276985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2276988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276989 */     // GIR_Coverage, 64678,
     /* 2276989 */     GIR_EraseRootFromParent_Done,
     /* 2276990 */   // Label 30672: @2276990
     /* 2276990 */   GIM_Try, /*On fail goto*//*Label 30673*/ GIMT_Encode4(2277071), // Rule ID 64726 //
     /* 2276995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2276998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277014 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277018 */     // MIs[1] Operand 1
     /* 2277018 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2277023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2277037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277041 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277045 */     // MIs[2] Operand 1
     /* 2277045 */     // No operand predicates
     /* 2277045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277051 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETEQ:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SELECTINE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2277051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTINE),
     /* 2277054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2277060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2277064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm2
     /* 2277069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277070 */     // GIR_Coverage, 64726,
     /* 2277070 */     GIR_EraseRootFromParent_Done,
     /* 2277071 */   // Label 30673: @2277071
     /* 2277071 */   GIM_Try, /*On fail goto*//*Label 30674*/ GIMT_Encode4(2277152), // Rule ID 64727 //
     /* 2277076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2277079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277095 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277099 */     // MIs[1] Operand 1
     /* 2277099 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2277104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2277118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277122 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277126 */     // MIs[2] Operand 1
     /* 2277126 */     // No operand predicates
     /* 2277126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277132 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETNE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SELECTIEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2277132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIEQ),
     /* 2277135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2277141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2277145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm2
     /* 2277150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277151 */     // GIR_Coverage, 64727,
     /* 2277151 */     GIR_EraseRootFromParent_Done,
     /* 2277152 */   // Label 30674: @2277152
     /* 2277152 */   GIM_Try, /*On fail goto*//*Label 30675*/ GIMT_Encode4(2277233), // Rule ID 64692 //
     /* 2277157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2277160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277176 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277180 */     // MIs[1] Operand 1
     /* 2277180 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2277185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277207 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277211 */     // MIs[2] Operand 1
     /* 2277211 */     // No operand predicates
     /* 2277211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277213 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2277213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQ),
     /* 2277216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2277220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2277224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2277228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2277231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277232 */     // GIR_Coverage, 64692,
     /* 2277232 */     GIR_EraseRootFromParent_Done,
     /* 2277233 */   // Label 30675: @2277233
     /* 2277233 */   GIM_Try, /*On fail goto*//*Label 30676*/ GIMT_Encode4(2277314), // Rule ID 64694 //
     /* 2277238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2277241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277257 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277261 */     // MIs[1] Operand 1
     /* 2277261 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2277266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277288 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277292 */     // MIs[2] Operand 1
     /* 2277292 */     // No operand predicates
     /* 2277292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277294 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LINE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2277294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINE),
     /* 2277297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2277301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2277305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2277309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2277312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277313 */     // GIR_Coverage, 64694,
     /* 2277313 */     GIR_EraseRootFromParent_Done,
     /* 2277314 */   // Label 30676: @2277314
     /* 2277314 */   GIM_Try, /*On fail goto*//*Label 30677*/ GIMT_Encode4(2277395), // Rule ID 64696 //
     /* 2277319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2277322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277338 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277342 */     // MIs[1] Operand 1
     /* 2277342 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2277347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277369 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277373 */     // MIs[2] Operand 1
     /* 2277373 */     // No operand predicates
     /* 2277373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277375 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETGE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2277375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILT),
     /* 2277378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2277382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2277386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2277390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2277393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277394 */     // GIR_Coverage, 64696,
     /* 2277394 */     GIR_EraseRootFromParent_Done,
     /* 2277395 */   // Label 30677: @2277395
     /* 2277395 */   GIM_Try, /*On fail goto*//*Label 30678*/ GIMT_Encode4(2277476), // Rule ID 64698 //
     /* 2277400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2277403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277419 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277423 */     // MIs[1] Operand 1
     /* 2277423 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2277428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277450 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277454 */     // MIs[2] Operand 1
     /* 2277454 */     // No operand predicates
     /* 2277454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277456 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2277456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGE),
     /* 2277459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2277463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2277467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2277471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2277474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277475 */     // GIR_Coverage, 64698,
     /* 2277475 */     GIR_EraseRootFromParent_Done,
     /* 2277476 */   // Label 30678: @2277476
     /* 2277476 */   GIM_Try, /*On fail goto*//*Label 30679*/ GIMT_Encode4(2277557), // Rule ID 64700 //
     /* 2277481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2277484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277500 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277504 */     // MIs[1] Operand 1
     /* 2277504 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2277509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277531 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277535 */     // MIs[2] Operand 1
     /* 2277535 */     // No operand predicates
     /* 2277535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277537 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2277537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTU),
     /* 2277540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2277544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2277548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2277552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2277555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277556 */     // GIR_Coverage, 64700,
     /* 2277556 */     GIR_EraseRootFromParent_Done,
     /* 2277557 */   // Label 30679: @2277557
     /* 2277557 */   GIM_Try, /*On fail goto*//*Label 30680*/ GIMT_Encode4(2277638), // Rule ID 64702 //
     /* 2277562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2277565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277581 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277585 */     // MIs[1] Operand 1
     /* 2277585 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2277590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277612 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277616 */     // MIs[2] Operand 1
     /* 2277616 */     // No operand predicates
     /* 2277616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277618 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGEU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2277618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEU),
     /* 2277621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2277625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2277629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2277633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2277636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277637 */     // GIR_Coverage, 64702,
     /* 2277637 */     GIR_EraseRootFromParent_Done,
     /* 2277638 */   // Label 30680: @2277638
     /* 2277638 */   GIM_Try, /*On fail goto*//*Label 30681*/ GIMT_Encode4(2277719), // Rule ID 64724 //
     /* 2277643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2277646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277662 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277666 */     // MIs[1] Operand 1
     /* 2277666 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2277671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277693 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277697 */     // MIs[2] Operand 1
     /* 2277697 */     // No operand predicates
     /* 2277697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277699 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTIEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2277699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIEQ),
     /* 2277702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2277708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2277712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm2
     /* 2277717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277718 */     // GIR_Coverage, 64724,
     /* 2277718 */     GIR_EraseRootFromParent_Done,
     /* 2277719 */   // Label 30681: @2277719
     /* 2277719 */   GIM_Try, /*On fail goto*//*Label 30682*/ GIMT_Encode4(2277800), // Rule ID 64725 //
     /* 2277724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2277727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277743 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277747 */     // MIs[1] Operand 1
     /* 2277747 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2277752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277774 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277778 */     // MIs[2] Operand 1
     /* 2277778 */     // No operand predicates
     /* 2277778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277780 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTINE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2277780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTINE),
     /* 2277783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2277789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2277793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm2
     /* 2277798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277799 */     // GIR_Coverage, 64725,
     /* 2277799 */     GIR_EraseRootFromParent_Done,
     /* 2277800 */   // Label 30682: @2277800
     /* 2277800 */   GIM_Try, /*On fail goto*//*Label 30683*/ GIMT_Encode4(2277841), // Rule ID 62593 //
     /* 2277805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2277808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2277820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277824 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, 0:{ *:[i32] }, GPR:{ *:[i32] }:$b)  =>  (TH_MVNEZ:{ *:[i32] } GPR:{ *:[i32] }:$b, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2277824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2277827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277829 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2277831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2277837 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2277839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277840 */     // GIR_Coverage, 62593,
     /* 2277840 */     GIR_EraseRootFromParent_Done,
     /* 2277841 */   // Label 30683: @2277841
     /* 2277841 */   GIM_Try, /*On fail goto*//*Label 30684*/ GIMT_Encode4(2277882), // Rule ID 62591 //
     /* 2277846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2277849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2277865 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2277865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2277868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277870 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2277872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2277878 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2277880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277881 */     // GIR_Coverage, 62591,
     /* 2277881 */     GIR_EraseRootFromParent_Done,
     /* 2277882 */   // Label 30684: @2277882
     /* 2277882 */   GIM_Try, /*On fail goto*//*Label 30685*/ GIMT_Encode4(2277933), // Rule ID 64717 //
     /* 2277887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2277890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2277902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277910 */     // MIs[1] Operand 1
     /* 2277910 */     // No operand predicates
     /* 2277910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2277916 */     // (select:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SELECTIEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, 0:{ *:[i32] }, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2277916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIEQI),
     /* 2277919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2277923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2277926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // simm2
     /* 2277931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277932 */     // GIR_Coverage, 64717,
     /* 2277932 */     GIR_EraseRootFromParent_Done,
     /* 2277933 */   // Label 30685: @2277933
     /* 2277933 */   GIM_Try, /*On fail goto*//*Label 30686*/ GIMT_Encode4(2277984), // Rule ID 64716 //
     /* 2277938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2277941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2277957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277965 */     // MIs[1] Operand 1
     /* 2277965 */     // No operand predicates
     /* 2277965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2277967 */     // (select:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTINEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, 0:{ *:[i32] }, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2277967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTINEI),
     /* 2277970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2277974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2277977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // simm2
     /* 2277982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277983 */     // GIR_Coverage, 64716,
     /* 2277983 */     GIR_EraseRootFromParent_Done,
     /* 2277984 */   // Label 30686: @2277984
     /* 2277984 */   GIM_Try, /*On fail goto*//*Label 30687*/ GIMT_Encode4(2278056), // Rule ID 64655 //
     /* 2277989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2277992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278008 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278012 */     // MIs[1] Operand 1
     /* 2278012 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2278017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278037 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQ),
     /* 2278040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278055 */     // GIR_Coverage, 64655,
     /* 2278055 */     GIR_EraseRootFromParent_Done,
     /* 2278056 */   // Label 30687: @2278056
     /* 2278056 */   GIM_Try, /*On fail goto*//*Label 30688*/ GIMT_Encode4(2278128), // Rule ID 64656 //
     /* 2278061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2278064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278080 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278084 */     // MIs[1] Operand 1
     /* 2278084 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2278089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278109 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQ),
     /* 2278112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278127 */     // GIR_Coverage, 64656,
     /* 2278127 */     GIR_EraseRootFromParent_Done,
     /* 2278128 */   // Label 30688: @2278128
     /* 2278128 */   GIM_Try, /*On fail goto*//*Label 30689*/ GIMT_Encode4(2278200), // Rule ID 64657 //
     /* 2278133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2278136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278152 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278156 */     // MIs[1] Operand 1
     /* 2278156 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2278161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278181 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVNE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNE),
     /* 2278184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278199 */     // GIR_Coverage, 64657,
     /* 2278199 */     GIR_EraseRootFromParent_Done,
     /* 2278200 */   // Label 30689: @2278200
     /* 2278200 */   GIM_Try, /*On fail goto*//*Label 30690*/ GIMT_Encode4(2278272), // Rule ID 64658 //
     /* 2278205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2278208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278224 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278228 */     // MIs[1] Operand 1
     /* 2278228 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2278233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278253 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVNE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNE),
     /* 2278256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278271 */     // GIR_Coverage, 64658,
     /* 2278271 */     GIR_EraseRootFromParent_Done,
     /* 2278272 */   // Label 30690: @2278272
     /* 2278272 */   GIM_Try, /*On fail goto*//*Label 30691*/ GIMT_Encode4(2278344), // Rule ID 64659 //
     /* 2278277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2278280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278296 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278300 */     // MIs[1] Operand 1
     /* 2278300 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2278305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278325 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLT),
     /* 2278328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278343 */     // GIR_Coverage, 64659,
     /* 2278343 */     GIR_EraseRootFromParent_Done,
     /* 2278344 */   // Label 30691: @2278344
     /* 2278344 */   GIM_Try, /*On fail goto*//*Label 30692*/ GIMT_Encode4(2278416), // Rule ID 64660 //
     /* 2278349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2278352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278368 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278372 */     // MIs[1] Operand 1
     /* 2278372 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2278377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278397 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLT),
     /* 2278400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278415 */     // GIR_Coverage, 64660,
     /* 2278415 */     GIR_EraseRootFromParent_Done,
     /* 2278416 */   // Label 30692: @2278416
     /* 2278416 */   GIM_Try, /*On fail goto*//*Label 30693*/ GIMT_Encode4(2278488), // Rule ID 64661 //
     /* 2278421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2278424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278440 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278444 */     // MIs[1] Operand 1
     /* 2278444 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2278449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278469 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTU),
     /* 2278472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278487 */     // GIR_Coverage, 64661,
     /* 2278487 */     GIR_EraseRootFromParent_Done,
     /* 2278488 */   // Label 30693: @2278488
     /* 2278488 */   GIM_Try, /*On fail goto*//*Label 30694*/ GIMT_Encode4(2278560), // Rule ID 64662 //
     /* 2278493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2278496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278512 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278516 */     // MIs[1] Operand 1
     /* 2278516 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2278521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278541 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTU),
     /* 2278544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278559 */     // GIR_Coverage, 64662,
     /* 2278559 */     GIR_EraseRootFromParent_Done,
     /* 2278560 */   // Label 30694: @2278560
     /* 2278560 */   GIM_Try, /*On fail goto*//*Label 30695*/ GIMT_Encode4(2278597), // Rule ID 62589 //
     /* 2278565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2278568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278584 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$cond)
     /* 2278584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2278587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278589 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2278591 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2278593 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2278595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278596 */     // GIR_Coverage, 62589,
     /* 2278596 */     GIR_EraseRootFromParent_Done,
     /* 2278597 */   // Label 30695: @2278597
     /* 2278597 */   GIM_Try, /*On fail goto*//*Label 30696*/ GIMT_Encode4(2278637), // Rule ID 64654 //
     /* 2278602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2278605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278621 */     // (select:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs3)  =>  (QC_MVEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, 0:{ *:[i32] }, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQI),
     /* 2278624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2278628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2278633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2278635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278636 */     // GIR_Coverage, 64654,
     /* 2278636 */     GIR_EraseRootFromParent_Done,
     /* 2278637 */   // Label 30696: @2278637
     /* 2278637 */   GIM_Try, /*On fail goto*//*Label 30697*/ GIMT_Encode4(2278677), // Rule ID 64715 //
     /* 2278642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2278645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278661 */     // (select:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)  =>  (QC_SELECTNEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, 0:{ *:[i32] }, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTNEI),
     /* 2278664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2278668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2278671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2278675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278676 */     // GIR_Coverage, 64715,
     /* 2278676 */     GIR_EraseRootFromParent_Done,
     /* 2278677 */   // Label 30697: @2278677
     /* 2278677 */   GIM_Try, /*On fail goto*//*Label 30698*/ GIMT_Encode4(2278714), // Rule ID 64741 //
     /* 2278682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
     /* 2278685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278701 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /* 2278701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2278704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2278710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2278712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278713 */     // GIR_Coverage, 64741,
     /* 2278713 */     GIR_EraseRootFromParent_Done,
     /* 2278714 */   // Label 30698: @2278714
     /* 2278714 */   GIM_Reject,
     /* 2278715 */ // Label 30642: @2278715
     /* 2278715 */ GIM_Reject,
     /* 2278716 */ // Label 30618: @2278716
     /* 2278716 */ GIM_Try, /*On fail goto*//*Label 30699*/ GIMT_Encode4(2278812), // Rule ID 64679 //
     /* 2278721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2278724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2278727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2278730 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2278733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278737 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278745 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2278749 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2278753 */   // MIs[1] Operand 1
     /* 2278753 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2278758 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278763 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2278767 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2278771 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2278775 */   // MIs[2] Operand 1
     /* 2278775 */   // No operand predicates
     /* 2278775 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2278779 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2278783 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2278787 */   // MIs[3] Operand 1
     /* 2278787 */   // No operand predicates
     /* 2278787 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278791 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2278793 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LIEQI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2278793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQI),
     /* 2278796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278798 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278800 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278804 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2278807 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2278810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2278811 */   // GIR_Coverage, 64679,
     /* 2278811 */   GIR_EraseRootFromParent_Done,
     /* 2278812 */ // Label 30699: @2278812
     /* 2278812 */ GIM_Try, /*On fail goto*//*Label 30700*/ GIMT_Encode4(2278908), // Rule ID 64681 //
     /* 2278817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2278820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2278823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2278826 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2278829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278833 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278837 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278841 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2278845 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2278849 */   // MIs[1] Operand 1
     /* 2278849 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2278854 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278859 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2278863 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2278867 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2278871 */   // MIs[2] Operand 1
     /* 2278871 */   // No operand predicates
     /* 2278871 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2278875 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2278879 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2278883 */   // MIs[3] Operand 1
     /* 2278883 */   // No operand predicates
     /* 2278883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278887 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2278889 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LINEI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2278889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINEI),
     /* 2278892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278894 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278896 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278900 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2278903 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2278906 */   GIR_RootConstrainSelectedInstOperands,
     /* 2278907 */   // GIR_Coverage, 64681,
     /* 2278907 */   GIR_EraseRootFromParent_Done,
     /* 2278908 */ // Label 30700: @2278908
     /* 2278908 */ GIM_Try, /*On fail goto*//*Label 30701*/ GIMT_Encode4(2279004), // Rule ID 64683 //
     /* 2278913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2278916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2278919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2278922 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2278925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278929 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278933 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278937 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2278941 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2278945 */   // MIs[1] Operand 1
     /* 2278945 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2278950 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278955 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2278959 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2278963 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2278967 */   // MIs[2] Operand 1
     /* 2278967 */   // No operand predicates
     /* 2278967 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2278971 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2278975 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2278979 */   // MIs[3] Operand 1
     /* 2278979 */   // No operand predicates
     /* 2278979 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278983 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2278985 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LILTI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2278985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTI),
     /* 2278988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278990 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278992 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278996 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2278999 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279002 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279003 */   // GIR_Coverage, 64683,
     /* 2279003 */   GIR_EraseRootFromParent_Done,
     /* 2279004 */ // Label 30701: @2279004
     /* 2279004 */ GIM_Try, /*On fail goto*//*Label 30702*/ GIMT_Encode4(2279100), // Rule ID 64685 //
     /* 2279009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279018 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279033 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279037 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279041 */   // MIs[1] Operand 1
     /* 2279041 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2279046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279051 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279055 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279059 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279063 */   // MIs[2] Operand 1
     /* 2279063 */   // No operand predicates
     /* 2279063 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2279067 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279071 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279075 */   // MIs[3] Operand 1
     /* 2279075 */   // No operand predicates
     /* 2279075 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279079 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279081 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETGE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LIGEI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEI),
     /* 2279084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279086 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2279088 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279092 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279095 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279099 */   // GIR_Coverage, 64685,
     /* 2279099 */   GIR_EraseRootFromParent_Done,
     /* 2279100 */ // Label 30702: @2279100
     /* 2279100 */ GIM_Try, /*On fail goto*//*Label 30703*/ GIMT_Encode4(2279196), // Rule ID 64687 //
     /* 2279105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279114 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279121 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279125 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279129 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279133 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279137 */   // MIs[1] Operand 1
     /* 2279137 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2279142 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279147 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279151 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279155 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2279159 */   // MIs[2] Operand 1
     /* 2279159 */   // No operand predicates
     /* 2279159 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2279163 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279167 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279171 */   // MIs[3] Operand 1
     /* 2279171 */   // No operand predicates
     /* 2279171 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279175 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279177 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, SETULT:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LILTUI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTUI),
     /* 2279180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279182 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2279184 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279188 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279191 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279195 */   // GIR_Coverage, 64687,
     /* 2279195 */   GIR_EraseRootFromParent_Done,
     /* 2279196 */ // Label 30703: @2279196
     /* 2279196 */ GIM_Try, /*On fail goto*//*Label 30704*/ GIMT_Encode4(2279292), // Rule ID 64689 //
     /* 2279201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279210 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279217 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279221 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279225 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279229 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279233 */   // MIs[1] Operand 1
     /* 2279233 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2279238 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279243 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279247 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279251 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2279255 */   // MIs[2] Operand 1
     /* 2279255 */   // No operand predicates
     /* 2279255 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2279259 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279263 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279267 */   // MIs[3] Operand 1
     /* 2279267 */   // No operand predicates
     /* 2279267 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279271 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279273 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, SETUGE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LIGEUI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEUI),
     /* 2279276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279278 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2279280 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279284 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279287 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279291 */   // GIR_Coverage, 64689,
     /* 2279291 */   GIR_EraseRootFromParent_Done,
     /* 2279292 */ // Label 30704: @2279292
     /* 2279292 */ GIM_Try, /*On fail goto*//*Label 30705*/ GIMT_Encode4(2279388), // Rule ID 64703 //
     /* 2279297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279306 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279313 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279317 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279321 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279325 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279329 */   // MIs[1] Operand 1
     /* 2279329 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2279334 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279339 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279343 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279347 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279351 */   // MIs[2] Operand 1
     /* 2279351 */   // No operand predicates
     /* 2279351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279355 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279359 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279363 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279367 */   // MIs[3] Operand 1
     /* 2279367 */   // No operand predicates
     /* 2279367 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279369 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIEQI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQI),
     /* 2279372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279374 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2279376 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279380 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279383 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279386 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279387 */   // GIR_Coverage, 64703,
     /* 2279387 */   GIR_EraseRootFromParent_Done,
     /* 2279388 */ // Label 30705: @2279388
     /* 2279388 */ GIM_Try, /*On fail goto*//*Label 30706*/ GIMT_Encode4(2279484), // Rule ID 64705 //
     /* 2279393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279402 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279409 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279413 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279417 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279421 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279425 */   // MIs[1] Operand 1
     /* 2279425 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2279430 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279435 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279439 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279443 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279447 */   // MIs[2] Operand 1
     /* 2279447 */   // No operand predicates
     /* 2279447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279451 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279455 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279459 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279463 */   // MIs[3] Operand 1
     /* 2279463 */   // No operand predicates
     /* 2279463 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279465 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LINEI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINEI),
     /* 2279468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279470 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2279472 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279476 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279479 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279482 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279483 */   // GIR_Coverage, 64705,
     /* 2279483 */   GIR_EraseRootFromParent_Done,
     /* 2279484 */ // Label 30706: @2279484
     /* 2279484 */ GIM_Try, /*On fail goto*//*Label 30707*/ GIMT_Encode4(2279580), // Rule ID 64707 //
     /* 2279489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279498 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279505 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279509 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279513 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279517 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279521 */   // MIs[1] Operand 1
     /* 2279521 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2279526 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279531 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279535 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279539 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279543 */   // MIs[2] Operand 1
     /* 2279543 */   // No operand predicates
     /* 2279543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279547 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279551 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279555 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279559 */   // MIs[3] Operand 1
     /* 2279559 */   // No operand predicates
     /* 2279559 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279561 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETGE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILTI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTI),
     /* 2279564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279566 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2279568 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279572 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279575 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279579 */   // GIR_Coverage, 64707,
     /* 2279579 */   GIR_EraseRootFromParent_Done,
     /* 2279580 */ // Label 30707: @2279580
     /* 2279580 */ GIM_Try, /*On fail goto*//*Label 30708*/ GIMT_Encode4(2279676), // Rule ID 64709 //
     /* 2279585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279594 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279601 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279605 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279609 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279613 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279617 */   // MIs[1] Operand 1
     /* 2279617 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2279622 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279627 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279631 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279635 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279639 */   // MIs[2] Operand 1
     /* 2279639 */   // No operand predicates
     /* 2279639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279643 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279647 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279651 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279655 */   // MIs[3] Operand 1
     /* 2279655 */   // No operand predicates
     /* 2279655 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279657 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGEI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEI),
     /* 2279660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279662 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2279664 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279668 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279671 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279674 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279675 */   // GIR_Coverage, 64709,
     /* 2279675 */   GIR_EraseRootFromParent_Done,
     /* 2279676 */ // Label 30708: @2279676
     /* 2279676 */ GIM_Try, /*On fail goto*//*Label 30709*/ GIMT_Encode4(2279772), // Rule ID 64711 //
     /* 2279681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279690 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279697 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279701 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279705 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279709 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279713 */   // MIs[1] Operand 1
     /* 2279713 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2279718 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279723 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279727 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279731 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2279735 */   // MIs[2] Operand 1
     /* 2279735 */   // No operand predicates
     /* 2279735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279739 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279743 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279747 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279751 */   // MIs[3] Operand 1
     /* 2279751 */   // No operand predicates
     /* 2279751 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279753 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, SETUGE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILTUI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTUI),
     /* 2279756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279758 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2279760 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279764 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279767 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279770 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279771 */   // GIR_Coverage, 64711,
     /* 2279771 */   GIR_EraseRootFromParent_Done,
     /* 2279772 */ // Label 30709: @2279772
     /* 2279772 */ GIM_Try, /*On fail goto*//*Label 30710*/ GIMT_Encode4(2279868), // Rule ID 64713 //
     /* 2279777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279786 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279793 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279801 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279805 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279809 */   // MIs[1] Operand 1
     /* 2279809 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2279814 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279819 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279823 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279827 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2279831 */   // MIs[2] Operand 1
     /* 2279831 */   // No operand predicates
     /* 2279831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279835 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279839 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279843 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279847 */   // MIs[3] Operand 1
     /* 2279847 */   // No operand predicates
     /* 2279847 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279849 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGEUI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEUI),
     /* 2279852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279854 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2279856 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279860 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279863 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279867 */   // GIR_Coverage, 64713,
     /* 2279867 */   GIR_EraseRootFromParent_Done,
     /* 2279868 */ // Label 30710: @2279868
     /* 2279868 */ GIM_Try, /*On fail goto*//*Label 30711*/ GIMT_Encode4(2279967), // Rule ID 64728 //
     /* 2279873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode0),
     /* 2279876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2279879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279882 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279889 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279893 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279897 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2279901 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2279905 */   // MIs[1] Operand 1
     /* 2279905 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2279910 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279915 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279920 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2279924 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279928 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279932 */   // MIs[2] Operand 1
     /* 2279932 */   // No operand predicates
     /* 2279932 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279936 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279940 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279944 */   // MIs[3] Operand 1
     /* 2279944 */   // No operand predicates
     /* 2279944 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279946 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETEQ:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTIIEQ:{ *:[i64] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm2)
     /* 2279946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIIEQ),
     /* 2279949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279951 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2279955 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2279959 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm1
     /* 2279962 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2279965 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279966 */   // GIR_Coverage, 64728,
     /* 2279966 */   GIR_EraseRootFromParent_Done,
     /* 2279967 */ // Label 30711: @2279967
     /* 2279967 */ GIM_Try, /*On fail goto*//*Label 30712*/ GIMT_Encode4(2280066), // Rule ID 64730 //
     /* 2279972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode0),
     /* 2279975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2279978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279981 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279996 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2280000 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2280004 */   // MIs[1] Operand 1
     /* 2280004 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2280009 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280014 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280019 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280023 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280027 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280031 */   // MIs[2] Operand 1
     /* 2280031 */   // No operand predicates
     /* 2280031 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2280035 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280039 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280043 */   // MIs[3] Operand 1
     /* 2280043 */   // No operand predicates
     /* 2280043 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2280045 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETNE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTIINE:{ *:[i64] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm2)
     /* 2280045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIINE),
     /* 2280048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280050 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2280054 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2280058 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm1
     /* 2280061 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2280064 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280065 */   // GIR_Coverage, 64730,
     /* 2280065 */   GIR_EraseRootFromParent_Done,
     /* 2280066 */ // Label 30712: @2280066
     /* 2280066 */ GIM_Try, /*On fail goto*//*Label 30713*/ GIMT_Encode4(2280156), // Rule ID 64667 //
     /* 2280071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280087 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280095 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280099 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280103 */   // MIs[1] Operand 1
     /* 2280103 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2280108 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280113 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280118 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280122 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280126 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280130 */   // MIs[2] Operand 1
     /* 2280130 */   // No operand predicates
     /* 2280130 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280134 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280136 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LIEQ:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQ),
     /* 2280139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280141 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2280143 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280147 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280151 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280154 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280155 */   // GIR_Coverage, 64667,
     /* 2280155 */   GIR_EraseRootFromParent_Done,
     /* 2280156 */ // Label 30713: @2280156
     /* 2280156 */ GIM_Try, /*On fail goto*//*Label 30714*/ GIMT_Encode4(2280246), // Rule ID 64669 //
     /* 2280161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280170 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280177 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280181 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280185 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280189 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280193 */   // MIs[1] Operand 1
     /* 2280193 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2280198 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280208 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280212 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280216 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280220 */   // MIs[2] Operand 1
     /* 2280220 */   // No operand predicates
     /* 2280220 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280224 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280226 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETNE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LINE:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINE),
     /* 2280229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280231 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2280233 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280237 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280241 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280245 */   // GIR_Coverage, 64669,
     /* 2280245 */   GIR_EraseRootFromParent_Done,
     /* 2280246 */ // Label 30714: @2280246
     /* 2280246 */ GIM_Try, /*On fail goto*//*Label 30715*/ GIMT_Encode4(2280336), // Rule ID 64671 //
     /* 2280251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280267 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280271 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280275 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280279 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280283 */   // MIs[1] Operand 1
     /* 2280283 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2280288 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280293 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280298 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280302 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280306 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280310 */   // MIs[2] Operand 1
     /* 2280310 */   // No operand predicates
     /* 2280310 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280314 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280316 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETLT:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LILT:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILT),
     /* 2280319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280321 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2280323 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280327 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280331 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280334 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280335 */   // GIR_Coverage, 64671,
     /* 2280335 */   GIR_EraseRootFromParent_Done,
     /* 2280336 */ // Label 30715: @2280336
     /* 2280336 */ GIM_Try, /*On fail goto*//*Label 30716*/ GIMT_Encode4(2280426), // Rule ID 64673 //
     /* 2280341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280350 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280365 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280369 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280373 */   // MIs[1] Operand 1
     /* 2280373 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2280378 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280383 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280388 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280392 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280396 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280400 */   // MIs[2] Operand 1
     /* 2280400 */   // No operand predicates
     /* 2280400 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280404 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280406 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETGE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LIGE:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGE),
     /* 2280409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280411 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2280413 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280417 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280421 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280424 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280425 */   // GIR_Coverage, 64673,
     /* 2280425 */   GIR_EraseRootFromParent_Done,
     /* 2280426 */ // Label 30716: @2280426
     /* 2280426 */ GIM_Try, /*On fail goto*//*Label 30717*/ GIMT_Encode4(2280516), // Rule ID 64675 //
     /* 2280431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280440 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280447 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280451 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280455 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280459 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280463 */   // MIs[1] Operand 1
     /* 2280463 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2280468 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280473 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280478 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280482 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280486 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280490 */   // MIs[2] Operand 1
     /* 2280490 */   // No operand predicates
     /* 2280490 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280494 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280496 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETULT:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LILTU:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTU),
     /* 2280499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280501 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2280503 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280507 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280511 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280515 */   // GIR_Coverage, 64675,
     /* 2280515 */   GIR_EraseRootFromParent_Done,
     /* 2280516 */ // Label 30717: @2280516
     /* 2280516 */ GIM_Try, /*On fail goto*//*Label 30718*/ GIMT_Encode4(2280606), // Rule ID 64677 //
     /* 2280521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280537 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280541 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280545 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280549 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280553 */   // MIs[1] Operand 1
     /* 2280553 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2280558 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280563 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280568 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280572 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280576 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280580 */   // MIs[2] Operand 1
     /* 2280580 */   // No operand predicates
     /* 2280580 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280584 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280586 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LIGEU:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEU),
     /* 2280589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280591 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2280593 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280597 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280601 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280604 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280605 */   // GIR_Coverage, 64677,
     /* 2280605 */   GIR_EraseRootFromParent_Done,
     /* 2280606 */ // Label 30718: @2280606
     /* 2280606 */ GIM_Try, /*On fail goto*//*Label 30719*/ GIMT_Encode4(2280696), // Rule ID 64691 //
     /* 2280611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280620 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280627 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280631 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280635 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280639 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280643 */   // MIs[1] Operand 1
     /* 2280643 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2280648 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280653 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280662 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2280666 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280670 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280674 */   // MIs[2] Operand 1
     /* 2280674 */   // No operand predicates
     /* 2280674 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280676 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIEQ:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQ),
     /* 2280679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280681 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2280683 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280687 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280691 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280694 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280695 */   // GIR_Coverage, 64691,
     /* 2280695 */   GIR_EraseRootFromParent_Done,
     /* 2280696 */ // Label 30719: @2280696
     /* 2280696 */ GIM_Try, /*On fail goto*//*Label 30720*/ GIMT_Encode4(2280786), // Rule ID 64693 //
     /* 2280701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280710 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280717 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280721 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280725 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280729 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280733 */   // MIs[1] Operand 1
     /* 2280733 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2280738 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280743 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280752 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2280756 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280760 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280764 */   // MIs[2] Operand 1
     /* 2280764 */   // No operand predicates
     /* 2280764 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280766 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LINE:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINE),
     /* 2280769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280771 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2280773 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280777 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280781 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280784 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280785 */   // GIR_Coverage, 64693,
     /* 2280785 */   GIR_EraseRootFromParent_Done,
     /* 2280786 */ // Label 30720: @2280786
     /* 2280786 */ GIM_Try, /*On fail goto*//*Label 30721*/ GIMT_Encode4(2280876), // Rule ID 64695 //
     /* 2280791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280800 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280807 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280811 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280815 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280819 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280823 */   // MIs[1] Operand 1
     /* 2280823 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2280828 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280833 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280842 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2280846 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280850 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280854 */   // MIs[2] Operand 1
     /* 2280854 */   // No operand predicates
     /* 2280854 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280856 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETGE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILT:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILT),
     /* 2280859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280861 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2280863 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280867 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280871 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280874 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280875 */   // GIR_Coverage, 64695,
     /* 2280875 */   GIR_EraseRootFromParent_Done,
     /* 2280876 */ // Label 30721: @2280876
     /* 2280876 */ GIM_Try, /*On fail goto*//*Label 30722*/ GIMT_Encode4(2280966), // Rule ID 64697 //
     /* 2280881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280890 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280897 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280901 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280905 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280909 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280913 */   // MIs[1] Operand 1
     /* 2280913 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2280918 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280923 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280932 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2280936 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280940 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280944 */   // MIs[2] Operand 1
     /* 2280944 */   // No operand predicates
     /* 2280944 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280946 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGE:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGE),
     /* 2280949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280951 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2280953 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280957 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280961 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280964 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280965 */   // GIR_Coverage, 64697,
     /* 2280965 */   GIR_EraseRootFromParent_Done,
     /* 2280966 */ // Label 30722: @2280966
     /* 2280966 */ GIM_Try, /*On fail goto*//*Label 30723*/ GIMT_Encode4(2281056), // Rule ID 64699 //
     /* 2280971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280980 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280987 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280991 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280995 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280999 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281003 */   // MIs[1] Operand 1
     /* 2281003 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2281008 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281013 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281022 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2281026 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2281030 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2281034 */   // MIs[2] Operand 1
     /* 2281034 */   // No operand predicates
     /* 2281034 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2281036 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILTU:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2281036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTU),
     /* 2281039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2281041 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2281043 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2281047 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2281051 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2281054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281055 */   // GIR_Coverage, 64699,
     /* 2281055 */   GIR_EraseRootFromParent_Done,
     /* 2281056 */ // Label 30723: @2281056
     /* 2281056 */ GIM_Try, /*On fail goto*//*Label 30724*/ GIMT_Encode4(2281146), // Rule ID 64701 //
     /* 2281061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2281064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2281067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281070 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281077 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2281081 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2281085 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281089 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281093 */   // MIs[1] Operand 1
     /* 2281093 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2281098 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281103 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281112 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2281116 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2281120 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2281124 */   // MIs[2] Operand 1
     /* 2281124 */   // No operand predicates
     /* 2281124 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2281126 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGEU:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2281126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEU),
     /* 2281129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2281131 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2281133 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2281137 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2281141 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2281144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281145 */   // GIR_Coverage, 64701,
     /* 2281145 */   GIR_EraseRootFromParent_Done,
     /* 2281146 */ // Label 30724: @2281146
     /* 2281146 */ GIM_Try, /*On fail goto*//*Label 30725*/ GIMT_Encode4(2281196), // Rule ID 62592 //
     /* 2281151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2281154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2281157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281160 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281171 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2281175 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281179 */   // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, 0:{ *:[i64] }, GPR:{ *:[i64] }:$b)  =>  (TH_MVNEZ:{ *:[i64] } GPR:{ *:[i64] }:$b, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2281179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2281182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2281184 */   GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2281186 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2281192 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2281194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281195 */   // GIR_Coverage, 62592,
     /* 2281195 */   GIR_EraseRootFromParent_Done,
     /* 2281196 */ // Label 30725: @2281196
     /* 2281196 */ GIM_Try, /*On fail goto*//*Label 30726*/ GIMT_Encode4(2281246), // Rule ID 62590 //
     /* 2281201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2281204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2281207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281210 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281225 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2281229 */   // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, 0:{ *:[i64] })  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2281229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2281232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2281234 */   GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2281236 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2281242 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2281244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281245 */   // GIR_Coverage, 62590,
     /* 2281245 */   GIR_EraseRootFromParent_Done,
     /* 2281246 */ // Label 30726: @2281246
     /* 2281246 */ GIM_Try, /*On fail goto*//*Label 30727*/ GIMT_Encode4(2281292), // Rule ID 62588 //
     /* 2281251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2281254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2281257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281275 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281279 */   // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b)  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b, GPR:{ *:[i64] }:$cond)
     /* 2281279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2281282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2281284 */   GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2281286 */   GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2281288 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2281290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281291 */   // GIR_Coverage, 62588,
     /* 2281291 */   GIR_EraseRootFromParent_Done,
     /* 2281292 */ // Label 30727: @2281292
     /* 2281292 */ GIM_Try, /*On fail goto*//*Label 30728*/ GIMT_Encode4(2281338), // Rule ID 64740 //
     /* 2281297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
     /* 2281300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2281303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281306 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281321 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281325 */   // (select:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs3)
     /* 2281325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2281328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281330 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281332 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2281334 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2281336 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281337 */   // GIR_Coverage, 64740,
     /* 2281337 */   GIR_EraseRootFromParent_Done,
     /* 2281338 */ // Label 30728: @2281338
     /* 2281338 */ GIM_Reject,
     /* 2281339 */ // Label 30619: @2281339
     /* 2281339 */ GIM_Try, /*On fail goto*//*Label 30729*/ GIMT_Encode4(2281458),
     /* 2281344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2281347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2281350 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2281353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2281357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2281361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281365 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281369 */   GIM_Try, /*On fail goto*//*Label 30730*/ GIMT_Encode4(2281413), // Rule ID 52252 //
     /* 2281374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281377 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2281380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2281394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281403 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281412 */     // GIR_Coverage, 52252,
     /* 2281412 */     GIR_EraseRootFromParent_Done,
     /* 2281413 */   // Label 30730: @2281413
     /* 2281413 */   GIM_Try, /*On fail goto*//*Label 30731*/ GIMT_Encode4(2281457), // Rule ID 52253 //
     /* 2281418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281421 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2281424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2281438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281447 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281456 */     // GIR_Coverage, 52253,
     /* 2281456 */     GIR_EraseRootFromParent_Done,
     /* 2281457 */   // Label 30731: @2281457
     /* 2281457 */   GIM_Reject,
     /* 2281458 */ // Label 30729: @2281458
     /* 2281458 */ GIM_Reject,
     /* 2281459 */ // Label 30620: @2281459
     /* 2281459 */ GIM_Try, /*On fail goto*//*Label 30732*/ GIMT_Encode4(2281666),
     /* 2281464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2281467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2281470 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2281473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2281477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2281481 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281485 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281489 */   GIM_Try, /*On fail goto*//*Label 30733*/ GIMT_Encode4(2281533), // Rule ID 52270 //
     /* 2281494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281497 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2281497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2281500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2281514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281523 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281532 */     // GIR_Coverage, 52270,
     /* 2281532 */     GIR_EraseRootFromParent_Done,
     /* 2281533 */   // Label 30733: @2281533
     /* 2281533 */   GIM_Try, /*On fail goto*//*Label 30734*/ GIMT_Encode4(2281577), // Rule ID 52271 //
     /* 2281538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281541 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2281541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2281544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2281558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281567 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281576 */     // GIR_Coverage, 52271,
     /* 2281576 */     GIR_EraseRootFromParent_Done,
     /* 2281577 */   // Label 30734: @2281577
     /* 2281577 */   GIM_Try, /*On fail goto*//*Label 30735*/ GIMT_Encode4(2281621), // Rule ID 58092 //
     /* 2281582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281585 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2281585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2281588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2281602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281611 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281620 */     // GIR_Coverage, 58092,
     /* 2281620 */     GIR_EraseRootFromParent_Done,
     /* 2281621 */   // Label 30735: @2281621
     /* 2281621 */   GIM_Try, /*On fail goto*//*Label 30736*/ GIMT_Encode4(2281665), // Rule ID 58093 //
     /* 2281626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281629 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2281629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2281632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2281646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281655 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281664 */     // GIR_Coverage, 58093,
     /* 2281664 */     GIR_EraseRootFromParent_Done,
     /* 2281665 */   // Label 30736: @2281665
     /* 2281665 */   GIM_Reject,
     /* 2281666 */ // Label 30732: @2281666
     /* 2281666 */ GIM_Reject,
     /* 2281667 */ // Label 30621: @2281667
     /* 2281667 */ GIM_Try, /*On fail goto*//*Label 30737*/ GIMT_Encode4(2281874),
     /* 2281672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2281675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2281678 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2281681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2281685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2281689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281693 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281697 */   GIM_Try, /*On fail goto*//*Label 30738*/ GIMT_Encode4(2281741), // Rule ID 52282 //
     /* 2281702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281705 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2281705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2281708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2281722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281731 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281740 */     // GIR_Coverage, 52282,
     /* 2281740 */     GIR_EraseRootFromParent_Done,
     /* 2281741 */   // Label 30738: @2281741
     /* 2281741 */   GIM_Try, /*On fail goto*//*Label 30739*/ GIMT_Encode4(2281785), // Rule ID 52283 //
     /* 2281746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281749 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2281749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2281752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2281766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281775 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281784 */     // GIR_Coverage, 52283,
     /* 2281784 */     GIR_EraseRootFromParent_Done,
     /* 2281785 */   // Label 30739: @2281785
     /* 2281785 */   GIM_Try, /*On fail goto*//*Label 30740*/ GIMT_Encode4(2281829), // Rule ID 58112 //
     /* 2281790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281793 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2281793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2281796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2281810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281819 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281828 */     // GIR_Coverage, 58112,
     /* 2281828 */     GIR_EraseRootFromParent_Done,
     /* 2281829 */   // Label 30740: @2281829
     /* 2281829 */   GIM_Try, /*On fail goto*//*Label 30741*/ GIMT_Encode4(2281873), // Rule ID 58113 //
     /* 2281834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281837 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2281837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2281840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2281854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281863 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281872 */     // GIR_Coverage, 58113,
     /* 2281872 */     GIR_EraseRootFromParent_Done,
     /* 2281873 */   // Label 30741: @2281873
     /* 2281873 */   GIM_Reject,
     /* 2281874 */ // Label 30737: @2281874
     /* 2281874 */ GIM_Reject,
     /* 2281875 */ // Label 30622: @2281875
     /* 2281875 */ GIM_Try, /*On fail goto*//*Label 30742*/ GIMT_Encode4(2282082),
     /* 2281880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2281883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2281886 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2281889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2281893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2281897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281901 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281905 */   GIM_Try, /*On fail goto*//*Label 30743*/ GIMT_Encode4(2281949), // Rule ID 52306 //
     /* 2281910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2281913 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2281913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2281916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2281930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281939 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281948 */     // GIR_Coverage, 52306,
     /* 2281948 */     GIR_EraseRootFromParent_Done,
     /* 2281949 */   // Label 30743: @2281949
     /* 2281949 */   GIM_Try, /*On fail goto*//*Label 30744*/ GIMT_Encode4(2281993), // Rule ID 52307 //
     /* 2281954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2281957 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2281957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2281960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2281974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281983 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281992 */     // GIR_Coverage, 52307,
     /* 2281992 */     GIR_EraseRootFromParent_Done,
     /* 2281993 */   // Label 30744: @2281993
     /* 2281993 */   GIM_Try, /*On fail goto*//*Label 30745*/ GIMT_Encode4(2282037), // Rule ID 58142 //
     /* 2281998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2282001 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2282001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2282004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282027 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282036 */     // GIR_Coverage, 58142,
     /* 2282036 */     GIR_EraseRootFromParent_Done,
     /* 2282037 */   // Label 30745: @2282037
     /* 2282037 */   GIM_Try, /*On fail goto*//*Label 30746*/ GIMT_Encode4(2282081), // Rule ID 58143 //
     /* 2282042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2282045 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2282045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2282048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282071 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282080 */     // GIR_Coverage, 58143,
     /* 2282080 */     GIR_EraseRootFromParent_Done,
     /* 2282081 */   // Label 30746: @2282081
     /* 2282081 */   GIM_Reject,
     /* 2282082 */ // Label 30742: @2282082
     /* 2282082 */ GIM_Reject,
     /* 2282083 */ // Label 30623: @2282083
     /* 2282083 */ GIM_Try, /*On fail goto*//*Label 30747*/ GIMT_Encode4(2282202),
     /* 2282088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2282091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2282094 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2282097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2282101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2282105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282109 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282113 */   GIM_Try, /*On fail goto*//*Label 30748*/ GIMT_Encode4(2282157), // Rule ID 52258 //
     /* 2282118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282121 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2282124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2282138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282147 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282156 */     // GIR_Coverage, 52258,
     /* 2282156 */     GIR_EraseRootFromParent_Done,
     /* 2282157 */   // Label 30748: @2282157
     /* 2282157 */   GIM_Try, /*On fail goto*//*Label 30749*/ GIMT_Encode4(2282201), // Rule ID 52259 //
     /* 2282162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282165 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2282168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2282182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282191 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282200 */     // GIR_Coverage, 52259,
     /* 2282200 */     GIR_EraseRootFromParent_Done,
     /* 2282201 */   // Label 30749: @2282201
     /* 2282201 */   GIM_Reject,
     /* 2282202 */ // Label 30747: @2282202
     /* 2282202 */ GIM_Reject,
     /* 2282203 */ // Label 30624: @2282203
     /* 2282203 */ GIM_Try, /*On fail goto*//*Label 30750*/ GIMT_Encode4(2282410),
     /* 2282208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2282211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2282214 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2282217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2282221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2282225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282229 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282233 */   GIM_Try, /*On fail goto*//*Label 30751*/ GIMT_Encode4(2282277), // Rule ID 52276 //
     /* 2282238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282241 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2282241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2282244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2282258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282267 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282276 */     // GIR_Coverage, 52276,
     /* 2282276 */     GIR_EraseRootFromParent_Done,
     /* 2282277 */   // Label 30751: @2282277
     /* 2282277 */   GIM_Try, /*On fail goto*//*Label 30752*/ GIMT_Encode4(2282321), // Rule ID 52277 //
     /* 2282282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282285 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2282285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2282288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2282302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282311 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282320 */     // GIR_Coverage, 52277,
     /* 2282320 */     GIR_EraseRootFromParent_Done,
     /* 2282321 */   // Label 30752: @2282321
     /* 2282321 */   GIM_Try, /*On fail goto*//*Label 30753*/ GIMT_Encode4(2282365), // Rule ID 58102 //
     /* 2282326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282329 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2282329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2282332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2282346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282355 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282364 */     // GIR_Coverage, 58102,
     /* 2282364 */     GIR_EraseRootFromParent_Done,
     /* 2282365 */   // Label 30753: @2282365
     /* 2282365 */   GIM_Try, /*On fail goto*//*Label 30754*/ GIMT_Encode4(2282409), // Rule ID 58103 //
     /* 2282370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282373 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2282373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2282376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2282390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282399 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282408 */     // GIR_Coverage, 58103,
     /* 2282408 */     GIR_EraseRootFromParent_Done,
     /* 2282409 */   // Label 30754: @2282409
     /* 2282409 */   GIM_Reject,
     /* 2282410 */ // Label 30750: @2282410
     /* 2282410 */ GIM_Reject,
     /* 2282411 */ // Label 30625: @2282411
     /* 2282411 */ GIM_Try, /*On fail goto*//*Label 30755*/ GIMT_Encode4(2282618),
     /* 2282416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2282419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2282422 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2282425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2282429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2282433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282437 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282441 */   GIM_Try, /*On fail goto*//*Label 30756*/ GIMT_Encode4(2282485), // Rule ID 52300 //
     /* 2282446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282449 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2282449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282475 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282484 */     // GIR_Coverage, 52300,
     /* 2282484 */     GIR_EraseRootFromParent_Done,
     /* 2282485 */   // Label 30756: @2282485
     /* 2282485 */   GIM_Try, /*On fail goto*//*Label 30757*/ GIMT_Encode4(2282529), // Rule ID 52301 //
     /* 2282490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282493 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2282493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282519 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282528 */     // GIR_Coverage, 52301,
     /* 2282528 */     GIR_EraseRootFromParent_Done,
     /* 2282529 */   // Label 30757: @2282529
     /* 2282529 */   GIM_Try, /*On fail goto*//*Label 30758*/ GIMT_Encode4(2282573), // Rule ID 58132 //
     /* 2282534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282537 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2282537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282563 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282572 */     // GIR_Coverage, 58132,
     /* 2282572 */     GIR_EraseRootFromParent_Done,
     /* 2282573 */   // Label 30758: @2282573
     /* 2282573 */   GIM_Try, /*On fail goto*//*Label 30759*/ GIMT_Encode4(2282617), // Rule ID 58133 //
     /* 2282578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282581 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2282581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282607 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282616 */     // GIR_Coverage, 58133,
     /* 2282616 */     GIR_EraseRootFromParent_Done,
     /* 2282617 */   // Label 30759: @2282617
     /* 2282617 */   GIM_Reject,
     /* 2282618 */ // Label 30755: @2282618
     /* 2282618 */ GIM_Reject,
     /* 2282619 */ // Label 30626: @2282619
     /* 2282619 */ GIM_Try, /*On fail goto*//*Label 30760*/ GIMT_Encode4(2282826),
     /* 2282624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2282627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2282630 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2282633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2282637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2282641 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282645 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282649 */   GIM_Try, /*On fail goto*//*Label 30761*/ GIMT_Encode4(2282693), // Rule ID 52366 //
     /* 2282654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2282657 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2282657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2282674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282683 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282692 */     // GIR_Coverage, 52366,
     /* 2282692 */     GIR_EraseRootFromParent_Done,
     /* 2282693 */   // Label 30761: @2282693
     /* 2282693 */   GIM_Try, /*On fail goto*//*Label 30762*/ GIMT_Encode4(2282737), // Rule ID 52367 //
     /* 2282698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2282701 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2282701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2282718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282727 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282736 */     // GIR_Coverage, 52367,
     /* 2282736 */     GIR_EraseRootFromParent_Done,
     /* 2282737 */   // Label 30762: @2282737
     /* 2282737 */   GIM_Try, /*On fail goto*//*Label 30763*/ GIMT_Encode4(2282781), // Rule ID 58212 //
     /* 2282742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2282745 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2282745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2282762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282771 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282780 */     // GIR_Coverage, 58212,
     /* 2282780 */     GIR_EraseRootFromParent_Done,
     /* 2282781 */   // Label 30763: @2282781
     /* 2282781 */   GIM_Try, /*On fail goto*//*Label 30764*/ GIMT_Encode4(2282825), // Rule ID 58213 //
     /* 2282786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2282789 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2282789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2282806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282815 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282824 */     // GIR_Coverage, 58213,
     /* 2282824 */     GIR_EraseRootFromParent_Done,
     /* 2282825 */   // Label 30764: @2282825
     /* 2282825 */   GIM_Reject,
     /* 2282826 */ // Label 30760: @2282826
     /* 2282826 */ GIM_Reject,
     /* 2282827 */ // Label 30627: @2282827
     /* 2282827 */ GIM_Try, /*On fail goto*//*Label 30765*/ GIMT_Encode4(2282946),
     /* 2282832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2282835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2282838 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2282841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2282845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2282849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282853 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282857 */   GIM_Try, /*On fail goto*//*Label 30766*/ GIMT_Encode4(2282901), // Rule ID 52264 //
     /* 2282862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282865 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2282868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2282882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282891 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282900 */     // GIR_Coverage, 52264,
     /* 2282900 */     GIR_EraseRootFromParent_Done,
     /* 2282901 */   // Label 30766: @2282901
     /* 2282901 */   GIM_Try, /*On fail goto*//*Label 30767*/ GIMT_Encode4(2282945), // Rule ID 52265 //
     /* 2282906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282909 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2282912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2282926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282935 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282944 */     // GIR_Coverage, 52265,
     /* 2282944 */     GIR_EraseRootFromParent_Done,
     /* 2282945 */   // Label 30767: @2282945
     /* 2282945 */   GIM_Reject,
     /* 2282946 */ // Label 30765: @2282946
     /* 2282946 */ GIM_Reject,
     /* 2282947 */ // Label 30628: @2282947
     /* 2282947 */ GIM_Try, /*On fail goto*//*Label 30768*/ GIMT_Encode4(2283154),
     /* 2282952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2282955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2282958 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2282961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2282965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2282969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282973 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282977 */   GIM_Try, /*On fail goto*//*Label 30769*/ GIMT_Encode4(2283021), // Rule ID 52294 //
     /* 2282982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282985 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2282985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2282988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2283002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283011 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283020 */     // GIR_Coverage, 52294,
     /* 2283020 */     GIR_EraseRootFromParent_Done,
     /* 2283021 */   // Label 30769: @2283021
     /* 2283021 */   GIM_Try, /*On fail goto*//*Label 30770*/ GIMT_Encode4(2283065), // Rule ID 52295 //
     /* 2283026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283029 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2283029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2283032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2283046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283055 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283064 */     // GIR_Coverage, 52295,
     /* 2283064 */     GIR_EraseRootFromParent_Done,
     /* 2283065 */   // Label 30770: @2283065
     /* 2283065 */   GIM_Try, /*On fail goto*//*Label 30771*/ GIMT_Encode4(2283109), // Rule ID 58122 //
     /* 2283070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283073 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2283073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2283076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2283090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283099 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283108 */     // GIR_Coverage, 58122,
     /* 2283108 */     GIR_EraseRootFromParent_Done,
     /* 2283109 */   // Label 30771: @2283109
     /* 2283109 */   GIM_Try, /*On fail goto*//*Label 30772*/ GIMT_Encode4(2283153), // Rule ID 58123 //
     /* 2283114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283117 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2283117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2283120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2283134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283143 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283152 */     // GIR_Coverage, 58123,
     /* 2283152 */     GIR_EraseRootFromParent_Done,
     /* 2283153 */   // Label 30772: @2283153
     /* 2283153 */   GIM_Reject,
     /* 2283154 */ // Label 30768: @2283154
     /* 2283154 */ GIM_Reject,
     /* 2283155 */ // Label 30629: @2283155
     /* 2283155 */ GIM_Try, /*On fail goto*//*Label 30773*/ GIMT_Encode4(2283362),
     /* 2283160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2283163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2283166 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2283169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2283173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2283177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283181 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283185 */   GIM_Try, /*On fail goto*//*Label 30774*/ GIMT_Encode4(2283229), // Rule ID 52348 //
     /* 2283190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283193 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2283193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283219 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283228 */     // GIR_Coverage, 52348,
     /* 2283228 */     GIR_EraseRootFromParent_Done,
     /* 2283229 */   // Label 30774: @2283229
     /* 2283229 */   GIM_Try, /*On fail goto*//*Label 30775*/ GIMT_Encode4(2283273), // Rule ID 52349 //
     /* 2283234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283237 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2283237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283263 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283272 */     // GIR_Coverage, 52349,
     /* 2283272 */     GIR_EraseRootFromParent_Done,
     /* 2283273 */   // Label 30775: @2283273
     /* 2283273 */   GIM_Try, /*On fail goto*//*Label 30776*/ GIMT_Encode4(2283317), // Rule ID 58182 //
     /* 2283278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283281 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2283281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283307 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283316 */     // GIR_Coverage, 58182,
     /* 2283316 */     GIR_EraseRootFromParent_Done,
     /* 2283317 */   // Label 30776: @2283317
     /* 2283317 */   GIM_Try, /*On fail goto*//*Label 30777*/ GIMT_Encode4(2283361), // Rule ID 58183 //
     /* 2283322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283325 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2283325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283351 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283360 */     // GIR_Coverage, 58183,
     /* 2283360 */     GIR_EraseRootFromParent_Done,
     /* 2283361 */   // Label 30777: @2283361
     /* 2283361 */   GIM_Reject,
     /* 2283362 */ // Label 30773: @2283362
     /* 2283362 */ GIM_Reject,
     /* 2283363 */ // Label 30630: @2283363
     /* 2283363 */ GIM_Try, /*On fail goto*//*Label 30778*/ GIMT_Encode4(2283570),
     /* 2283368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2283371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2283374 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2283377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2283381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2283385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283389 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283393 */   GIM_Try, /*On fail goto*//*Label 30779*/ GIMT_Encode4(2283437), // Rule ID 52372 //
     /* 2283398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2283401 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2283401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2283418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283427 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283436 */     // GIR_Coverage, 52372,
     /* 2283436 */     GIR_EraseRootFromParent_Done,
     /* 2283437 */   // Label 30779: @2283437
     /* 2283437 */   GIM_Try, /*On fail goto*//*Label 30780*/ GIMT_Encode4(2283481), // Rule ID 52373 //
     /* 2283442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2283445 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2283445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2283462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283471 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283480 */     // GIR_Coverage, 52373,
     /* 2283480 */     GIR_EraseRootFromParent_Done,
     /* 2283481 */   // Label 30780: @2283481
     /* 2283481 */   GIM_Try, /*On fail goto*//*Label 30781*/ GIMT_Encode4(2283525), // Rule ID 58222 //
     /* 2283486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2283489 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2283489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2283506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283515 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283524 */     // GIR_Coverage, 58222,
     /* 2283524 */     GIR_EraseRootFromParent_Done,
     /* 2283525 */   // Label 30781: @2283525
     /* 2283525 */   GIM_Try, /*On fail goto*//*Label 30782*/ GIMT_Encode4(2283569), // Rule ID 58223 //
     /* 2283530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2283533 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2283533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2283550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283559 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283568 */     // GIR_Coverage, 58223,
     /* 2283568 */     GIR_EraseRootFromParent_Done,
     /* 2283569 */   // Label 30782: @2283569
     /* 2283569 */   GIM_Reject,
     /* 2283570 */ // Label 30778: @2283570
     /* 2283570 */ GIM_Reject,
     /* 2283571 */ // Label 30631: @2283571
     /* 2283571 */ GIM_Try, /*On fail goto*//*Label 30783*/ GIMT_Encode4(2283690),
     /* 2283576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2283579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2283582 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2283585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2283589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2283593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283597 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283601 */   GIM_Try, /*On fail goto*//*Label 30784*/ GIMT_Encode4(2283645), // Rule ID 52288 //
     /* 2283606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283609 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2283612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2283626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283635 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283644 */     // GIR_Coverage, 52288,
     /* 2283644 */     GIR_EraseRootFromParent_Done,
     /* 2283645 */   // Label 30784: @2283645
     /* 2283645 */   GIM_Try, /*On fail goto*//*Label 30785*/ GIMT_Encode4(2283689), // Rule ID 52289 //
     /* 2283650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283653 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2283656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2283670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283679 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283688 */     // GIR_Coverage, 52289,
     /* 2283688 */     GIR_EraseRootFromParent_Done,
     /* 2283689 */   // Label 30785: @2283689
     /* 2283689 */   GIM_Reject,
     /* 2283690 */ // Label 30783: @2283690
     /* 2283690 */ GIM_Reject,
     /* 2283691 */ // Label 30632: @2283691
     /* 2283691 */ GIM_Try, /*On fail goto*//*Label 30786*/ GIMT_Encode4(2283898),
     /* 2283696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2283699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2283702 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2283705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2283709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2283713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283717 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283721 */   GIM_Try, /*On fail goto*//*Label 30787*/ GIMT_Encode4(2283765), // Rule ID 52330 //
     /* 2283726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283729 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2283729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2283732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283755 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283764 */     // GIR_Coverage, 52330,
     /* 2283764 */     GIR_EraseRootFromParent_Done,
     /* 2283765 */   // Label 30787: @2283765
     /* 2283765 */   GIM_Try, /*On fail goto*//*Label 30788*/ GIMT_Encode4(2283809), // Rule ID 52331 //
     /* 2283770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283773 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2283773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2283776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283799 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283808 */     // GIR_Coverage, 52331,
     /* 2283808 */     GIR_EraseRootFromParent_Done,
     /* 2283809 */   // Label 30788: @2283809
     /* 2283809 */   GIM_Try, /*On fail goto*//*Label 30789*/ GIMT_Encode4(2283853), // Rule ID 58152 //
     /* 2283814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283817 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2283817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2283820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283843 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283852 */     // GIR_Coverage, 58152,
     /* 2283852 */     GIR_EraseRootFromParent_Done,
     /* 2283853 */   // Label 30789: @2283853
     /* 2283853 */   GIM_Try, /*On fail goto*//*Label 30790*/ GIMT_Encode4(2283897), // Rule ID 58153 //
     /* 2283858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283861 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2283861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2283864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283887 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283896 */     // GIR_Coverage, 58153,
     /* 2283896 */     GIR_EraseRootFromParent_Done,
     /* 2283897 */   // Label 30790: @2283897
     /* 2283897 */   GIM_Reject,
     /* 2283898 */ // Label 30786: @2283898
     /* 2283898 */ GIM_Reject,
     /* 2283899 */ // Label 30633: @2283899
     /* 2283899 */ GIM_Try, /*On fail goto*//*Label 30791*/ GIMT_Encode4(2284106),
     /* 2283904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2283907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2283910 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2283913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2283917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2283921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283925 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283929 */   GIM_Try, /*On fail goto*//*Label 30792*/ GIMT_Encode4(2283973), // Rule ID 52354 //
     /* 2283934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283937 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2283937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2283940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2283954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283963 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283972 */     // GIR_Coverage, 52354,
     /* 2283972 */     GIR_EraseRootFromParent_Done,
     /* 2283973 */   // Label 30792: @2283973
     /* 2283973 */   GIM_Try, /*On fail goto*//*Label 30793*/ GIMT_Encode4(2284017), // Rule ID 52355 //
     /* 2283978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283981 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2283981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2283984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2283998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284007 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284016 */     // GIR_Coverage, 52355,
     /* 2284016 */     GIR_EraseRootFromParent_Done,
     /* 2284017 */   // Label 30793: @2284017
     /* 2284017 */   GIM_Try, /*On fail goto*//*Label 30794*/ GIMT_Encode4(2284061), // Rule ID 58192 //
     /* 2284022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284025 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2284025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2284028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284051 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284060 */     // GIR_Coverage, 58192,
     /* 2284060 */     GIR_EraseRootFromParent_Done,
     /* 2284061 */   // Label 30794: @2284061
     /* 2284061 */   GIM_Try, /*On fail goto*//*Label 30795*/ GIMT_Encode4(2284105), // Rule ID 58193 //
     /* 2284066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284069 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2284069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2284072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284095 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284104 */     // GIR_Coverage, 58193,
     /* 2284104 */     GIR_EraseRootFromParent_Done,
     /* 2284105 */   // Label 30795: @2284105
     /* 2284105 */   GIM_Reject,
     /* 2284106 */ // Label 30791: @2284106
     /* 2284106 */ GIM_Reject,
     /* 2284107 */ // Label 30634: @2284107
     /* 2284107 */ GIM_Try, /*On fail goto*//*Label 30796*/ GIMT_Encode4(2284314),
     /* 2284112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2284115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2284118 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2284121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2284125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2284129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284133 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284137 */   GIM_Try, /*On fail goto*//*Label 30797*/ GIMT_Encode4(2284181), // Rule ID 52378 //
     /* 2284142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2284145 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2284145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2284148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284171 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284180 */     // GIR_Coverage, 52378,
     /* 2284180 */     GIR_EraseRootFromParent_Done,
     /* 2284181 */   // Label 30797: @2284181
     /* 2284181 */   GIM_Try, /*On fail goto*//*Label 30798*/ GIMT_Encode4(2284225), // Rule ID 52379 //
     /* 2284186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2284189 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2284189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2284192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284215 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284224 */     // GIR_Coverage, 52379,
     /* 2284224 */     GIR_EraseRootFromParent_Done,
     /* 2284225 */   // Label 30798: @2284225
     /* 2284225 */   GIM_Try, /*On fail goto*//*Label 30799*/ GIMT_Encode4(2284269), // Rule ID 58232 //
     /* 2284230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2284233 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2284233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2284236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284259 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284268 */     // GIR_Coverage, 58232,
     /* 2284268 */     GIR_EraseRootFromParent_Done,
     /* 2284269 */   // Label 30799: @2284269
     /* 2284269 */   GIM_Try, /*On fail goto*//*Label 30800*/ GIMT_Encode4(2284313), // Rule ID 58233 //
     /* 2284274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2284277 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2284277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2284280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284303 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284312 */     // GIR_Coverage, 58233,
     /* 2284312 */     GIR_EraseRootFromParent_Done,
     /* 2284313 */   // Label 30800: @2284313
     /* 2284313 */   GIM_Reject,
     /* 2284314 */ // Label 30796: @2284314
     /* 2284314 */ GIM_Reject,
     /* 2284315 */ // Label 30635: @2284315
     /* 2284315 */ GIM_Try, /*On fail goto*//*Label 30801*/ GIMT_Encode4(2284434),
     /* 2284320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2284323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2284326 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2284329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2284333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2284337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284341 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284345 */   GIM_Try, /*On fail goto*//*Label 30802*/ GIMT_Encode4(2284389), // Rule ID 52312 //
     /* 2284350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284353 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2284356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2284370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284379 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284388 */     // GIR_Coverage, 52312,
     /* 2284388 */     GIR_EraseRootFromParent_Done,
     /* 2284389 */   // Label 30802: @2284389
     /* 2284389 */   GIM_Try, /*On fail goto*//*Label 30803*/ GIMT_Encode4(2284433), // Rule ID 52313 //
     /* 2284394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284397 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2284400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2284414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284423 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284432 */     // GIR_Coverage, 52313,
     /* 2284432 */     GIR_EraseRootFromParent_Done,
     /* 2284433 */   // Label 30803: @2284433
     /* 2284433 */   GIM_Reject,
     /* 2284434 */ // Label 30801: @2284434
     /* 2284434 */ GIM_Reject,
     /* 2284435 */ // Label 30636: @2284435
     /* 2284435 */ GIM_Try, /*On fail goto*//*Label 30804*/ GIMT_Encode4(2284642),
     /* 2284440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2284443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2284446 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2284449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2284453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2284457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284461 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284465 */   GIM_Try, /*On fail goto*//*Label 30805*/ GIMT_Encode4(2284509), // Rule ID 52336 //
     /* 2284470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284473 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2284473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284499 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284508 */     // GIR_Coverage, 52336,
     /* 2284508 */     GIR_EraseRootFromParent_Done,
     /* 2284509 */   // Label 30805: @2284509
     /* 2284509 */   GIM_Try, /*On fail goto*//*Label 30806*/ GIMT_Encode4(2284553), // Rule ID 52337 //
     /* 2284514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284517 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2284517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284543 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284552 */     // GIR_Coverage, 52337,
     /* 2284552 */     GIR_EraseRootFromParent_Done,
     /* 2284553 */   // Label 30806: @2284553
     /* 2284553 */   GIM_Try, /*On fail goto*//*Label 30807*/ GIMT_Encode4(2284597), // Rule ID 58162 //
     /* 2284558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284561 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2284561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284587 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284596 */     // GIR_Coverage, 58162,
     /* 2284596 */     GIR_EraseRootFromParent_Done,
     /* 2284597 */   // Label 30807: @2284597
     /* 2284597 */   GIM_Try, /*On fail goto*//*Label 30808*/ GIMT_Encode4(2284641), // Rule ID 58163 //
     /* 2284602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284605 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2284605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284631 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284640 */     // GIR_Coverage, 58163,
     /* 2284640 */     GIR_EraseRootFromParent_Done,
     /* 2284641 */   // Label 30808: @2284641
     /* 2284641 */   GIM_Reject,
     /* 2284642 */ // Label 30804: @2284642
     /* 2284642 */ GIM_Reject,
     /* 2284643 */ // Label 30637: @2284643
     /* 2284643 */ GIM_Try, /*On fail goto*//*Label 30809*/ GIMT_Encode4(2284850),
     /* 2284648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2284651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2284654 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2284657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2284661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2284665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284669 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284673 */   GIM_Try, /*On fail goto*//*Label 30810*/ GIMT_Encode4(2284717), // Rule ID 52360 //
     /* 2284678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284681 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2284681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284707 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284716 */     // GIR_Coverage, 52360,
     /* 2284716 */     GIR_EraseRootFromParent_Done,
     /* 2284717 */   // Label 30810: @2284717
     /* 2284717 */   GIM_Try, /*On fail goto*//*Label 30811*/ GIMT_Encode4(2284761), // Rule ID 52361 //
     /* 2284722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284725 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2284725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284751 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284760 */     // GIR_Coverage, 52361,
     /* 2284760 */     GIR_EraseRootFromParent_Done,
     /* 2284761 */   // Label 30811: @2284761
     /* 2284761 */   GIM_Try, /*On fail goto*//*Label 30812*/ GIMT_Encode4(2284805), // Rule ID 58202 //
     /* 2284766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284769 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2284769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284795 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284804 */     // GIR_Coverage, 58202,
     /* 2284804 */     GIR_EraseRootFromParent_Done,
     /* 2284805 */   // Label 30812: @2284805
     /* 2284805 */   GIM_Try, /*On fail goto*//*Label 30813*/ GIMT_Encode4(2284849), // Rule ID 58203 //
     /* 2284810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284813 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2284813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284839 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284848 */     // GIR_Coverage, 58203,
     /* 2284848 */     GIR_EraseRootFromParent_Done,
     /* 2284849 */   // Label 30813: @2284849
     /* 2284849 */   GIM_Reject,
     /* 2284850 */ // Label 30809: @2284850
     /* 2284850 */ GIM_Reject,
     /* 2284851 */ // Label 30638: @2284851
     /* 2284851 */ GIM_Try, /*On fail goto*//*Label 30814*/ GIMT_Encode4(2284970),
     /* 2284856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2284859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2284862 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2284865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2284869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2284873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284877 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284881 */   GIM_Try, /*On fail goto*//*Label 30815*/ GIMT_Encode4(2284925), // Rule ID 52318 //
     /* 2284886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284889 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2284892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284915 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284924 */     // GIR_Coverage, 52318,
     /* 2284924 */     GIR_EraseRootFromParent_Done,
     /* 2284925 */   // Label 30815: @2284925
     /* 2284925 */   GIM_Try, /*On fail goto*//*Label 30816*/ GIMT_Encode4(2284969), // Rule ID 52319 //
     /* 2284930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284933 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2284936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284959 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284968 */     // GIR_Coverage, 52319,
     /* 2284968 */     GIR_EraseRootFromParent_Done,
     /* 2284969 */   // Label 30816: @2284969
     /* 2284969 */   GIM_Reject,
     /* 2284970 */ // Label 30814: @2284970
     /* 2284970 */ GIM_Reject,
     /* 2284971 */ // Label 30639: @2284971
     /* 2284971 */ GIM_Try, /*On fail goto*//*Label 30817*/ GIMT_Encode4(2285178),
     /* 2284976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2284979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2284982 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2284985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2284989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2284993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284997 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285001 */   GIM_Try, /*On fail goto*//*Label 30818*/ GIMT_Encode4(2285045), // Rule ID 52342 //
     /* 2285006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285009 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2285009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2285012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2285026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2285033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2285035 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2285037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285044 */     // GIR_Coverage, 52342,
     /* 2285044 */     GIR_EraseRootFromParent_Done,
     /* 2285045 */   // Label 30818: @2285045
     /* 2285045 */   GIM_Try, /*On fail goto*//*Label 30819*/ GIMT_Encode4(2285089), // Rule ID 52343 //
     /* 2285050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285053 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2285053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2285056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2285070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2285077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2285079 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2285081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285088 */     // GIR_Coverage, 52343,
     /* 2285088 */     GIR_EraseRootFromParent_Done,
     /* 2285089 */   // Label 30819: @2285089
     /* 2285089 */   GIM_Try, /*On fail goto*//*Label 30820*/ GIMT_Encode4(2285133), // Rule ID 58172 //
     /* 2285094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285097 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2285097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2285100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2285114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2285121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2285123 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2285125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285132 */     // GIR_Coverage, 58172,
     /* 2285132 */     GIR_EraseRootFromParent_Done,
     /* 2285133 */   // Label 30820: @2285133
     /* 2285133 */   GIM_Try, /*On fail goto*//*Label 30821*/ GIMT_Encode4(2285177), // Rule ID 58173 //
     /* 2285138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285141 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2285141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2285144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2285158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2285165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2285167 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2285169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285176 */     // GIR_Coverage, 58173,
     /* 2285176 */     GIR_EraseRootFromParent_Done,
     /* 2285177 */   // Label 30821: @2285177
     /* 2285177 */   GIM_Reject,
     /* 2285178 */ // Label 30817: @2285178
     /* 2285178 */ GIM_Reject,
     /* 2285179 */ // Label 30640: @2285179
     /* 2285179 */ GIM_Try, /*On fail goto*//*Label 30822*/ GIMT_Encode4(2285298),
     /* 2285184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /* 2285187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2285190 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2285193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2285197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2285201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285205 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285209 */   GIM_Try, /*On fail goto*//*Label 30823*/ GIMT_Encode4(2285253), // Rule ID 52324 //
     /* 2285214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285217 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2285220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2285234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2285241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2285243 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2285245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285252 */     // GIR_Coverage, 52324,
     /* 2285252 */     GIR_EraseRootFromParent_Done,
     /* 2285253 */   // Label 30823: @2285253
     /* 2285253 */   GIM_Try, /*On fail goto*//*Label 30824*/ GIMT_Encode4(2285297), // Rule ID 52325 //
     /* 2285258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285261 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2285264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2285278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2285285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2285287 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2285289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285296 */     // GIR_Coverage, 52325,
     /* 2285296 */     GIR_EraseRootFromParent_Done,
     /* 2285297 */   // Label 30824: @2285297
     /* 2285297 */   GIM_Reject,
     /* 2285298 */ // Label 30822: @2285298
     /* 2285298 */ GIM_Reject,
     /* 2285299 */ // Label 30641: @2285299
     /* 2285299 */ GIM_Reject,
     /* 2285300 */ // Label 51: @2285300
     /* 2285300 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30849*/ GIMT_Encode4(2288033),
     /* 2285311 */ /*GILLT_s32*//*Label 30825*/ GIMT_Encode4(2285435),
     /* 2285315 */ /*GILLT_s64*//*Label 30826*/ GIMT_Encode4(2285469), GIMT_Encode4(0),
     /* 2285323 */ /*GILLT_nxv1s8*//*Label 30827*/ GIMT_Encode4(2285503),
     /* 2285327 */ /*GILLT_nxv1s16*//*Label 30828*/ GIMT_Encode4(2285618),
     /* 2285331 */ /*GILLT_nxv1s32*//*Label 30829*/ GIMT_Encode4(2285733),
     /* 2285335 */ /*GILLT_nxv1s64*//*Label 30830*/ GIMT_Encode4(2285848), GIMT_Encode4(0),
     /* 2285343 */ /*GILLT_nxv2s8*//*Label 30831*/ GIMT_Encode4(2285963),
     /* 2285347 */ /*GILLT_nxv2s16*//*Label 30832*/ GIMT_Encode4(2286078),
     /* 2285351 */ /*GILLT_nxv2s32*//*Label 30833*/ GIMT_Encode4(2286193),
     /* 2285355 */ /*GILLT_nxv2s64*//*Label 30834*/ GIMT_Encode4(2286308), GIMT_Encode4(0),
     /* 2285363 */ /*GILLT_nxv4s8*//*Label 30835*/ GIMT_Encode4(2286423),
     /* 2285367 */ /*GILLT_nxv4s16*//*Label 30836*/ GIMT_Encode4(2286538),
     /* 2285371 */ /*GILLT_nxv4s32*//*Label 30837*/ GIMT_Encode4(2286653),
     /* 2285375 */ /*GILLT_nxv4s64*//*Label 30838*/ GIMT_Encode4(2286768), GIMT_Encode4(0),
     /* 2285383 */ /*GILLT_nxv8s8*//*Label 30839*/ GIMT_Encode4(2286883),
     /* 2285387 */ /*GILLT_nxv8s16*//*Label 30840*/ GIMT_Encode4(2286998),
     /* 2285391 */ /*GILLT_nxv8s32*//*Label 30841*/ GIMT_Encode4(2287113),
     /* 2285395 */ /*GILLT_nxv8s64*//*Label 30842*/ GIMT_Encode4(2287228), GIMT_Encode4(0),
     /* 2285403 */ /*GILLT_nxv16s8*//*Label 30843*/ GIMT_Encode4(2287343),
     /* 2285407 */ /*GILLT_nxv16s16*//*Label 30844*/ GIMT_Encode4(2287458),
     /* 2285411 */ /*GILLT_nxv16s32*//*Label 30845*/ GIMT_Encode4(2287573), GIMT_Encode4(0),
     /* 2285419 */ /*GILLT_nxv32s8*//*Label 30846*/ GIMT_Encode4(2287688),
     /* 2285423 */ /*GILLT_nxv32s16*//*Label 30847*/ GIMT_Encode4(2287803), GIMT_Encode4(0),
     /* 2285431 */ /*GILLT_nxv64s8*//*Label 30848*/ GIMT_Encode4(2287918),
     /* 2285435 */ // Label 30825: @2285435
     /* 2285435 */ GIM_Try, /*On fail goto*//*Label 30850*/ GIMT_Encode4(2285468), // Rule ID 314 //
     /* 2285440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2285443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2285446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2285449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285461 */   // (mulhu:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULHU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2285461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2285466 */   GIR_RootConstrainSelectedInstOperands,
     /* 2285467 */   // GIR_Coverage, 314,
     /* 2285467 */   GIR_Done,
     /* 2285468 */ // Label 30850: @2285468
     /* 2285468 */ GIM_Reject,
     /* 2285469 */ // Label 30826: @2285469
     /* 2285469 */ GIM_Try, /*On fail goto*//*Label 30851*/ GIMT_Encode4(2285502), // Rule ID 313 //
     /* 2285474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2285477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2285483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285495 */   // (mulhu:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULHU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2285495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2285500 */   GIR_RootConstrainSelectedInstOperands,
     /* 2285501 */   // GIR_Coverage, 313,
     /* 2285501 */   GIR_Done,
     /* 2285502 */ // Label 30851: @2285502
     /* 2285502 */ GIM_Reject,
     /* 2285503 */ // Label 30827: @2285503
     /* 2285503 */ GIM_Try, /*On fail goto*//*Label 30852*/ GIMT_Encode4(2285617),
     /* 2285508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2285511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2285514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285526 */   GIM_Try, /*On fail goto*//*Label 30853*/ GIMT_Encode4(2285571), // Rule ID 51028 //
     /* 2285531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285534 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2285537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2285551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285570 */     // GIR_Coverage, 51028,
     /* 2285570 */     GIR_EraseRootFromParent_Done,
     /* 2285571 */   // Label 30853: @2285571
     /* 2285571 */   GIM_Try, /*On fail goto*//*Label 30854*/ GIMT_Encode4(2285616), // Rule ID 51029 //
     /* 2285576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285579 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2285582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2285596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285615 */     // GIR_Coverage, 51029,
     /* 2285615 */     GIR_EraseRootFromParent_Done,
     /* 2285616 */   // Label 30854: @2285616
     /* 2285616 */   GIM_Reject,
     /* 2285617 */ // Label 30852: @2285617
     /* 2285617 */ GIM_Reject,
     /* 2285618 */ // Label 30828: @2285618
     /* 2285618 */ GIM_Try, /*On fail goto*//*Label 30855*/ GIMT_Encode4(2285732),
     /* 2285623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2285626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2285629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285641 */   GIM_Try, /*On fail goto*//*Label 30856*/ GIMT_Encode4(2285686), // Rule ID 51040 //
     /* 2285646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285649 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2285652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2285666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285685 */     // GIR_Coverage, 51040,
     /* 2285685 */     GIR_EraseRootFromParent_Done,
     /* 2285686 */   // Label 30856: @2285686
     /* 2285686 */   GIM_Try, /*On fail goto*//*Label 30857*/ GIMT_Encode4(2285731), // Rule ID 51041 //
     /* 2285691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285694 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2285697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2285711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285730 */     // GIR_Coverage, 51041,
     /* 2285730 */     GIR_EraseRootFromParent_Done,
     /* 2285731 */   // Label 30857: @2285731
     /* 2285731 */   GIM_Reject,
     /* 2285732 */ // Label 30855: @2285732
     /* 2285732 */ GIM_Reject,
     /* 2285733 */ // Label 30829: @2285733
     /* 2285733 */ GIM_Try, /*On fail goto*//*Label 30858*/ GIMT_Encode4(2285847),
     /* 2285738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2285741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2285744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285756 */   GIM_Try, /*On fail goto*//*Label 30859*/ GIMT_Encode4(2285801), // Rule ID 51048 //
     /* 2285761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285764 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2285767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2285781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285800 */     // GIR_Coverage, 51048,
     /* 2285800 */     GIR_EraseRootFromParent_Done,
     /* 2285801 */   // Label 30859: @2285801
     /* 2285801 */   GIM_Try, /*On fail goto*//*Label 30860*/ GIMT_Encode4(2285846), // Rule ID 51049 //
     /* 2285806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285809 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2285812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2285826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285845 */     // GIR_Coverage, 51049,
     /* 2285845 */     GIR_EraseRootFromParent_Done,
     /* 2285846 */   // Label 30860: @2285846
     /* 2285846 */   GIM_Reject,
     /* 2285847 */ // Label 30858: @2285847
     /* 2285847 */ GIM_Reject,
     /* 2285848 */ // Label 30830: @2285848
     /* 2285848 */ GIM_Try, /*On fail goto*//*Label 30861*/ GIMT_Encode4(2285962),
     /* 2285853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2285856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2285859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285871 */   GIM_Try, /*On fail goto*//*Label 30862*/ GIMT_Encode4(2285916), // Rule ID 51116 //
     /* 2285876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2285879 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2285882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2285896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285915 */     // GIR_Coverage, 51116,
     /* 2285915 */     GIR_EraseRootFromParent_Done,
     /* 2285916 */   // Label 30862: @2285916
     /* 2285916 */   GIM_Try, /*On fail goto*//*Label 30863*/ GIMT_Encode4(2285961), // Rule ID 51117 //
     /* 2285921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2285924 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2285927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2285941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285960 */     // GIR_Coverage, 51117,
     /* 2285960 */     GIR_EraseRootFromParent_Done,
     /* 2285961 */   // Label 30863: @2285961
     /* 2285961 */   GIM_Reject,
     /* 2285962 */ // Label 30861: @2285962
     /* 2285962 */ GIM_Reject,
     /* 2285963 */ // Label 30831: @2285963
     /* 2285963 */ GIM_Try, /*On fail goto*//*Label 30864*/ GIMT_Encode4(2286077),
     /* 2285968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2285971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2285974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285986 */   GIM_Try, /*On fail goto*//*Label 30865*/ GIMT_Encode4(2286031), // Rule ID 51032 //
     /* 2285991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285994 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2285997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2286011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286030 */     // GIR_Coverage, 51032,
     /* 2286030 */     GIR_EraseRootFromParent_Done,
     /* 2286031 */   // Label 30865: @2286031
     /* 2286031 */   GIM_Try, /*On fail goto*//*Label 30866*/ GIMT_Encode4(2286076), // Rule ID 51033 //
     /* 2286036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286039 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2286042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2286056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286075 */     // GIR_Coverage, 51033,
     /* 2286075 */     GIR_EraseRootFromParent_Done,
     /* 2286076 */   // Label 30866: @2286076
     /* 2286076 */   GIM_Reject,
     /* 2286077 */ // Label 30864: @2286077
     /* 2286077 */ GIM_Reject,
     /* 2286078 */ // Label 30832: @2286078
     /* 2286078 */ GIM_Try, /*On fail goto*//*Label 30867*/ GIMT_Encode4(2286192),
     /* 2286083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2286086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2286089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286101 */   GIM_Try, /*On fail goto*//*Label 30868*/ GIMT_Encode4(2286146), // Rule ID 51044 //
     /* 2286106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286109 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2286112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2286126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286145 */     // GIR_Coverage, 51044,
     /* 2286145 */     GIR_EraseRootFromParent_Done,
     /* 2286146 */   // Label 30868: @2286146
     /* 2286146 */   GIM_Try, /*On fail goto*//*Label 30869*/ GIMT_Encode4(2286191), // Rule ID 51045 //
     /* 2286151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286154 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2286157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2286171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286190 */     // GIR_Coverage, 51045,
     /* 2286190 */     GIR_EraseRootFromParent_Done,
     /* 2286191 */   // Label 30869: @2286191
     /* 2286191 */   GIM_Reject,
     /* 2286192 */ // Label 30867: @2286192
     /* 2286192 */ GIM_Reject,
     /* 2286193 */ // Label 30833: @2286193
     /* 2286193 */ GIM_Try, /*On fail goto*//*Label 30870*/ GIMT_Encode4(2286307),
     /* 2286198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2286201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2286204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286216 */   GIM_Try, /*On fail goto*//*Label 30871*/ GIMT_Encode4(2286261), // Rule ID 51060 //
     /* 2286221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286224 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2286227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2286241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286260 */     // GIR_Coverage, 51060,
     /* 2286260 */     GIR_EraseRootFromParent_Done,
     /* 2286261 */   // Label 30871: @2286261
     /* 2286261 */   GIM_Try, /*On fail goto*//*Label 30872*/ GIMT_Encode4(2286306), // Rule ID 51061 //
     /* 2286266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286269 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2286272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2286286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286305 */     // GIR_Coverage, 51061,
     /* 2286305 */     GIR_EraseRootFromParent_Done,
     /* 2286306 */   // Label 30872: @2286306
     /* 2286306 */   GIM_Reject,
     /* 2286307 */ // Label 30870: @2286307
     /* 2286307 */ GIM_Reject,
     /* 2286308 */ // Label 30834: @2286308
     /* 2286308 */ GIM_Try, /*On fail goto*//*Label 30873*/ GIMT_Encode4(2286422),
     /* 2286313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2286316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2286319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286327 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286331 */   GIM_Try, /*On fail goto*//*Label 30874*/ GIMT_Encode4(2286376), // Rule ID 51120 //
     /* 2286336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2286339 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2286342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2286356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286375 */     // GIR_Coverage, 51120,
     /* 2286375 */     GIR_EraseRootFromParent_Done,
     /* 2286376 */   // Label 30874: @2286376
     /* 2286376 */   GIM_Try, /*On fail goto*//*Label 30875*/ GIMT_Encode4(2286421), // Rule ID 51121 //
     /* 2286381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2286384 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2286387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2286401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286420 */     // GIR_Coverage, 51121,
     /* 2286420 */     GIR_EraseRootFromParent_Done,
     /* 2286421 */   // Label 30875: @2286421
     /* 2286421 */   GIM_Reject,
     /* 2286422 */ // Label 30873: @2286422
     /* 2286422 */ GIM_Reject,
     /* 2286423 */ // Label 30835: @2286423
     /* 2286423 */ GIM_Try, /*On fail goto*//*Label 30876*/ GIMT_Encode4(2286537),
     /* 2286428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2286431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2286434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286446 */   GIM_Try, /*On fail goto*//*Label 30877*/ GIMT_Encode4(2286491), // Rule ID 51036 //
     /* 2286451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286454 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2286457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2286471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286490 */     // GIR_Coverage, 51036,
     /* 2286490 */     GIR_EraseRootFromParent_Done,
     /* 2286491 */   // Label 30877: @2286491
     /* 2286491 */   GIM_Try, /*On fail goto*//*Label 30878*/ GIMT_Encode4(2286536), // Rule ID 51037 //
     /* 2286496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286499 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2286502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2286516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286535 */     // GIR_Coverage, 51037,
     /* 2286535 */     GIR_EraseRootFromParent_Done,
     /* 2286536 */   // Label 30878: @2286536
     /* 2286536 */   GIM_Reject,
     /* 2286537 */ // Label 30876: @2286537
     /* 2286537 */ GIM_Reject,
     /* 2286538 */ // Label 30836: @2286538
     /* 2286538 */ GIM_Try, /*On fail goto*//*Label 30879*/ GIMT_Encode4(2286652),
     /* 2286543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2286546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2286549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286561 */   GIM_Try, /*On fail goto*//*Label 30880*/ GIMT_Encode4(2286606), // Rule ID 51056 //
     /* 2286566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286569 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2286572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2286586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286605 */     // GIR_Coverage, 51056,
     /* 2286605 */     GIR_EraseRootFromParent_Done,
     /* 2286606 */   // Label 30880: @2286606
     /* 2286606 */   GIM_Try, /*On fail goto*//*Label 30881*/ GIMT_Encode4(2286651), // Rule ID 51057 //
     /* 2286611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286614 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2286617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2286631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286650 */     // GIR_Coverage, 51057,
     /* 2286650 */     GIR_EraseRootFromParent_Done,
     /* 2286651 */   // Label 30881: @2286651
     /* 2286651 */   GIM_Reject,
     /* 2286652 */ // Label 30879: @2286652
     /* 2286652 */ GIM_Reject,
     /* 2286653 */ // Label 30837: @2286653
     /* 2286653 */ GIM_Try, /*On fail goto*//*Label 30882*/ GIMT_Encode4(2286767),
     /* 2286658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2286661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2286664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286676 */   GIM_Try, /*On fail goto*//*Label 30883*/ GIMT_Encode4(2286721), // Rule ID 51088 //
     /* 2286681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286684 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2286687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2286701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286720 */     // GIR_Coverage, 51088,
     /* 2286720 */     GIR_EraseRootFromParent_Done,
     /* 2286721 */   // Label 30883: @2286721
     /* 2286721 */   GIM_Try, /*On fail goto*//*Label 30884*/ GIMT_Encode4(2286766), // Rule ID 51089 //
     /* 2286726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286729 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2286732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2286746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286765 */     // GIR_Coverage, 51089,
     /* 2286765 */     GIR_EraseRootFromParent_Done,
     /* 2286766 */   // Label 30884: @2286766
     /* 2286766 */   GIM_Reject,
     /* 2286767 */ // Label 30882: @2286767
     /* 2286767 */ GIM_Reject,
     /* 2286768 */ // Label 30838: @2286768
     /* 2286768 */ GIM_Try, /*On fail goto*//*Label 30885*/ GIMT_Encode4(2286882),
     /* 2286773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2286776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2286779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286791 */   GIM_Try, /*On fail goto*//*Label 30886*/ GIMT_Encode4(2286836), // Rule ID 51124 //
     /* 2286796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2286799 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2286802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2286816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286835 */     // GIR_Coverage, 51124,
     /* 2286835 */     GIR_EraseRootFromParent_Done,
     /* 2286836 */   // Label 30886: @2286836
     /* 2286836 */   GIM_Try, /*On fail goto*//*Label 30887*/ GIMT_Encode4(2286881), // Rule ID 51125 //
     /* 2286841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2286844 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2286847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2286861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286880 */     // GIR_Coverage, 51125,
     /* 2286880 */     GIR_EraseRootFromParent_Done,
     /* 2286881 */   // Label 30887: @2286881
     /* 2286881 */   GIM_Reject,
     /* 2286882 */ // Label 30885: @2286882
     /* 2286882 */ GIM_Reject,
     /* 2286883 */ // Label 30839: @2286883
     /* 2286883 */ GIM_Try, /*On fail goto*//*Label 30888*/ GIMT_Encode4(2286997),
     /* 2286888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2286891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2286894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286906 */   GIM_Try, /*On fail goto*//*Label 30889*/ GIMT_Encode4(2286951), // Rule ID 51052 //
     /* 2286911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286914 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2286917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2286931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286950 */     // GIR_Coverage, 51052,
     /* 2286950 */     GIR_EraseRootFromParent_Done,
     /* 2286951 */   // Label 30889: @2286951
     /* 2286951 */   GIM_Try, /*On fail goto*//*Label 30890*/ GIMT_Encode4(2286996), // Rule ID 51053 //
     /* 2286956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286959 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2286962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2286976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286995 */     // GIR_Coverage, 51053,
     /* 2286995 */     GIR_EraseRootFromParent_Done,
     /* 2286996 */   // Label 30890: @2286996
     /* 2286996 */   GIM_Reject,
     /* 2286997 */ // Label 30888: @2286997
     /* 2286997 */ GIM_Reject,
     /* 2286998 */ // Label 30840: @2286998
     /* 2286998 */ GIM_Try, /*On fail goto*//*Label 30891*/ GIMT_Encode4(2287112),
     /* 2287003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2287006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2287009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287021 */   GIM_Try, /*On fail goto*//*Label 30892*/ GIMT_Encode4(2287066), // Rule ID 51076 //
     /* 2287026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287029 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2287032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2287046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287065 */     // GIR_Coverage, 51076,
     /* 2287065 */     GIR_EraseRootFromParent_Done,
     /* 2287066 */   // Label 30892: @2287066
     /* 2287066 */   GIM_Try, /*On fail goto*//*Label 30893*/ GIMT_Encode4(2287111), // Rule ID 51077 //
     /* 2287071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287074 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2287077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2287091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287110 */     // GIR_Coverage, 51077,
     /* 2287110 */     GIR_EraseRootFromParent_Done,
     /* 2287111 */   // Label 30893: @2287111
     /* 2287111 */   GIM_Reject,
     /* 2287112 */ // Label 30891: @2287112
     /* 2287112 */ GIM_Reject,
     /* 2287113 */ // Label 30841: @2287113
     /* 2287113 */ GIM_Try, /*On fail goto*//*Label 30894*/ GIMT_Encode4(2287227),
     /* 2287118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2287121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2287124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287136 */   GIM_Try, /*On fail goto*//*Label 30895*/ GIMT_Encode4(2287181), // Rule ID 51092 //
     /* 2287141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287144 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2287147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2287161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287180 */     // GIR_Coverage, 51092,
     /* 2287180 */     GIR_EraseRootFromParent_Done,
     /* 2287181 */   // Label 30895: @2287181
     /* 2287181 */   GIM_Try, /*On fail goto*//*Label 30896*/ GIMT_Encode4(2287226), // Rule ID 51093 //
     /* 2287186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287189 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2287192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2287206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287225 */     // GIR_Coverage, 51093,
     /* 2287225 */     GIR_EraseRootFromParent_Done,
     /* 2287226 */   // Label 30896: @2287226
     /* 2287226 */   GIM_Reject,
     /* 2287227 */ // Label 30894: @2287227
     /* 2287227 */ GIM_Reject,
     /* 2287228 */ // Label 30842: @2287228
     /* 2287228 */ GIM_Try, /*On fail goto*//*Label 30897*/ GIMT_Encode4(2287342),
     /* 2287233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2287236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2287239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287251 */   GIM_Try, /*On fail goto*//*Label 30898*/ GIMT_Encode4(2287296), // Rule ID 51128 //
     /* 2287256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2287259 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2287262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287295 */     // GIR_Coverage, 51128,
     /* 2287295 */     GIR_EraseRootFromParent_Done,
     /* 2287296 */   // Label 30898: @2287296
     /* 2287296 */   GIM_Try, /*On fail goto*//*Label 30899*/ GIMT_Encode4(2287341), // Rule ID 51129 //
     /* 2287301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2287304 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2287307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287340 */     // GIR_Coverage, 51129,
     /* 2287340 */     GIR_EraseRootFromParent_Done,
     /* 2287341 */   // Label 30899: @2287341
     /* 2287341 */   GIM_Reject,
     /* 2287342 */ // Label 30897: @2287342
     /* 2287342 */ GIM_Reject,
     /* 2287343 */ // Label 30843: @2287343
     /* 2287343 */ GIM_Try, /*On fail goto*//*Label 30900*/ GIMT_Encode4(2287457),
     /* 2287348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2287351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2287354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287366 */   GIM_Try, /*On fail goto*//*Label 30901*/ GIMT_Encode4(2287411), // Rule ID 51064 //
     /* 2287371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287374 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2287377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2287391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287410 */     // GIR_Coverage, 51064,
     /* 2287410 */     GIR_EraseRootFromParent_Done,
     /* 2287411 */   // Label 30901: @2287411
     /* 2287411 */   GIM_Try, /*On fail goto*//*Label 30902*/ GIMT_Encode4(2287456), // Rule ID 51065 //
     /* 2287416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287419 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2287422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2287436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287455 */     // GIR_Coverage, 51065,
     /* 2287455 */     GIR_EraseRootFromParent_Done,
     /* 2287456 */   // Label 30902: @2287456
     /* 2287456 */   GIM_Reject,
     /* 2287457 */ // Label 30900: @2287457
     /* 2287457 */ GIM_Reject,
     /* 2287458 */ // Label 30844: @2287458
     /* 2287458 */ GIM_Try, /*On fail goto*//*Label 30903*/ GIMT_Encode4(2287572),
     /* 2287463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2287466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2287469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287481 */   GIM_Try, /*On fail goto*//*Label 30904*/ GIMT_Encode4(2287526), // Rule ID 51080 //
     /* 2287486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287489 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2287492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2287506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287525 */     // GIR_Coverage, 51080,
     /* 2287525 */     GIR_EraseRootFromParent_Done,
     /* 2287526 */   // Label 30904: @2287526
     /* 2287526 */   GIM_Try, /*On fail goto*//*Label 30905*/ GIMT_Encode4(2287571), // Rule ID 51081 //
     /* 2287531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287534 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2287537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2287551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287570 */     // GIR_Coverage, 51081,
     /* 2287570 */     GIR_EraseRootFromParent_Done,
     /* 2287571 */   // Label 30905: @2287571
     /* 2287571 */   GIM_Reject,
     /* 2287572 */ // Label 30903: @2287572
     /* 2287572 */ GIM_Reject,
     /* 2287573 */ // Label 30845: @2287573
     /* 2287573 */ GIM_Try, /*On fail goto*//*Label 30906*/ GIMT_Encode4(2287687),
     /* 2287578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2287581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2287584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287596 */   GIM_Try, /*On fail goto*//*Label 30907*/ GIMT_Encode4(2287641), // Rule ID 51096 //
     /* 2287601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287604 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2287607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287640 */     // GIR_Coverage, 51096,
     /* 2287640 */     GIR_EraseRootFromParent_Done,
     /* 2287641 */   // Label 30907: @2287641
     /* 2287641 */   GIM_Try, /*On fail goto*//*Label 30908*/ GIMT_Encode4(2287686), // Rule ID 51097 //
     /* 2287646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287649 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2287652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287685 */     // GIR_Coverage, 51097,
     /* 2287685 */     GIR_EraseRootFromParent_Done,
     /* 2287686 */   // Label 30908: @2287686
     /* 2287686 */   GIM_Reject,
     /* 2287687 */ // Label 30906: @2287687
     /* 2287687 */ GIM_Reject,
     /* 2287688 */ // Label 30846: @2287688
     /* 2287688 */ GIM_Try, /*On fail goto*//*Label 30909*/ GIMT_Encode4(2287802),
     /* 2287693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2287696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2287699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287711 */   GIM_Try, /*On fail goto*//*Label 30910*/ GIMT_Encode4(2287756), // Rule ID 51068 //
     /* 2287716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287719 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2287722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2287736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287755 */     // GIR_Coverage, 51068,
     /* 2287755 */     GIR_EraseRootFromParent_Done,
     /* 2287756 */   // Label 30910: @2287756
     /* 2287756 */   GIM_Try, /*On fail goto*//*Label 30911*/ GIMT_Encode4(2287801), // Rule ID 51069 //
     /* 2287761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287764 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2287767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2287781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287800 */     // GIR_Coverage, 51069,
     /* 2287800 */     GIR_EraseRootFromParent_Done,
     /* 2287801 */   // Label 30911: @2287801
     /* 2287801 */   GIM_Reject,
     /* 2287802 */ // Label 30909: @2287802
     /* 2287802 */ GIM_Reject,
     /* 2287803 */ // Label 30847: @2287803
     /* 2287803 */ GIM_Try, /*On fail goto*//*Label 30912*/ GIMT_Encode4(2287917),
     /* 2287808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2287811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2287814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287826 */   GIM_Try, /*On fail goto*//*Label 30913*/ GIMT_Encode4(2287871), // Rule ID 51084 //
     /* 2287831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287834 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2287837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287870 */     // GIR_Coverage, 51084,
     /* 2287870 */     GIR_EraseRootFromParent_Done,
     /* 2287871 */   // Label 30913: @2287871
     /* 2287871 */   GIM_Try, /*On fail goto*//*Label 30914*/ GIMT_Encode4(2287916), // Rule ID 51085 //
     /* 2287876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287879 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2287882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287915 */     // GIR_Coverage, 51085,
     /* 2287915 */     GIR_EraseRootFromParent_Done,
     /* 2287916 */   // Label 30914: @2287916
     /* 2287916 */   GIM_Reject,
     /* 2287917 */ // Label 30912: @2287917
     /* 2287917 */ GIM_Reject,
     /* 2287918 */ // Label 30848: @2287918
     /* 2287918 */ GIM_Try, /*On fail goto*//*Label 30915*/ GIMT_Encode4(2288032),
     /* 2287923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2287926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2287929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287941 */   GIM_Try, /*On fail goto*//*Label 30916*/ GIMT_Encode4(2287986), // Rule ID 51072 //
     /* 2287946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287949 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2287952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287985 */     // GIR_Coverage, 51072,
     /* 2287985 */     GIR_EraseRootFromParent_Done,
     /* 2287986 */   // Label 30916: @2287986
     /* 2287986 */   GIM_Try, /*On fail goto*//*Label 30917*/ GIMT_Encode4(2288031), // Rule ID 51073 //
     /* 2287991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287994 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2287997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2288011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288030 */     // GIR_Coverage, 51073,
     /* 2288030 */     GIR_EraseRootFromParent_Done,
     /* 2288031 */   // Label 30917: @2288031
     /* 2288031 */   GIM_Reject,
     /* 2288032 */ // Label 30915: @2288032
     /* 2288032 */ GIM_Reject,
     /* 2288033 */ // Label 30849: @2288033
     /* 2288033 */ GIM_Reject,
     /* 2288034 */ // Label 52: @2288034
     /* 2288034 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30942*/ GIMT_Encode4(2290767),
     /* 2288045 */ /*GILLT_s32*//*Label 30918*/ GIMT_Encode4(2288169),
     /* 2288049 */ /*GILLT_s64*//*Label 30919*/ GIMT_Encode4(2288203), GIMT_Encode4(0),
     /* 2288057 */ /*GILLT_nxv1s8*//*Label 30920*/ GIMT_Encode4(2288237),
     /* 2288061 */ /*GILLT_nxv1s16*//*Label 30921*/ GIMT_Encode4(2288352),
     /* 2288065 */ /*GILLT_nxv1s32*//*Label 30922*/ GIMT_Encode4(2288467),
     /* 2288069 */ /*GILLT_nxv1s64*//*Label 30923*/ GIMT_Encode4(2288582), GIMT_Encode4(0),
     /* 2288077 */ /*GILLT_nxv2s8*//*Label 30924*/ GIMT_Encode4(2288697),
     /* 2288081 */ /*GILLT_nxv2s16*//*Label 30925*/ GIMT_Encode4(2288812),
     /* 2288085 */ /*GILLT_nxv2s32*//*Label 30926*/ GIMT_Encode4(2288927),
     /* 2288089 */ /*GILLT_nxv2s64*//*Label 30927*/ GIMT_Encode4(2289042), GIMT_Encode4(0),
     /* 2288097 */ /*GILLT_nxv4s8*//*Label 30928*/ GIMT_Encode4(2289157),
     /* 2288101 */ /*GILLT_nxv4s16*//*Label 30929*/ GIMT_Encode4(2289272),
     /* 2288105 */ /*GILLT_nxv4s32*//*Label 30930*/ GIMT_Encode4(2289387),
     /* 2288109 */ /*GILLT_nxv4s64*//*Label 30931*/ GIMT_Encode4(2289502), GIMT_Encode4(0),
     /* 2288117 */ /*GILLT_nxv8s8*//*Label 30932*/ GIMT_Encode4(2289617),
     /* 2288121 */ /*GILLT_nxv8s16*//*Label 30933*/ GIMT_Encode4(2289732),
     /* 2288125 */ /*GILLT_nxv8s32*//*Label 30934*/ GIMT_Encode4(2289847),
     /* 2288129 */ /*GILLT_nxv8s64*//*Label 30935*/ GIMT_Encode4(2289962), GIMT_Encode4(0),
     /* 2288137 */ /*GILLT_nxv16s8*//*Label 30936*/ GIMT_Encode4(2290077),
     /* 2288141 */ /*GILLT_nxv16s16*//*Label 30937*/ GIMT_Encode4(2290192),
     /* 2288145 */ /*GILLT_nxv16s32*//*Label 30938*/ GIMT_Encode4(2290307), GIMT_Encode4(0),
     /* 2288153 */ /*GILLT_nxv32s8*//*Label 30939*/ GIMT_Encode4(2290422),
     /* 2288157 */ /*GILLT_nxv32s16*//*Label 30940*/ GIMT_Encode4(2290537), GIMT_Encode4(0),
     /* 2288165 */ /*GILLT_nxv64s8*//*Label 30941*/ GIMT_Encode4(2290652),
     /* 2288169 */ // Label 30918: @2288169
     /* 2288169 */ GIM_Try, /*On fail goto*//*Label 30943*/ GIMT_Encode4(2288202), // Rule ID 312 //
     /* 2288174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2288177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2288180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2288183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288195 */   // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2288195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2288200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2288201 */   // GIR_Coverage, 312,
     /* 2288201 */   GIR_Done,
     /* 2288202 */ // Label 30943: @2288202
     /* 2288202 */ GIM_Reject,
     /* 2288203 */ // Label 30919: @2288203
     /* 2288203 */ GIM_Try, /*On fail goto*//*Label 30944*/ GIMT_Encode4(2288236), // Rule ID 311 //
     /* 2288208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2288211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2288214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2288217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288229 */   // (mulhs:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2288229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2288234 */   GIR_RootConstrainSelectedInstOperands,
     /* 2288235 */   // GIR_Coverage, 311,
     /* 2288235 */   GIR_Done,
     /* 2288236 */ // Label 30944: @2288236
     /* 2288236 */ GIM_Reject,
     /* 2288237 */ // Label 30920: @2288237
     /* 2288237 */ GIM_Try, /*On fail goto*//*Label 30945*/ GIMT_Encode4(2288351),
     /* 2288242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2288245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2288248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288260 */   GIM_Try, /*On fail goto*//*Label 30946*/ GIMT_Encode4(2288305), // Rule ID 50956 //
     /* 2288265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288268 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2288271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2288285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288304 */     // GIR_Coverage, 50956,
     /* 2288304 */     GIR_EraseRootFromParent_Done,
     /* 2288305 */   // Label 30946: @2288305
     /* 2288305 */   GIM_Try, /*On fail goto*//*Label 30947*/ GIMT_Encode4(2288350), // Rule ID 50957 //
     /* 2288310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288313 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2288316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2288330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288349 */     // GIR_Coverage, 50957,
     /* 2288349 */     GIR_EraseRootFromParent_Done,
     /* 2288350 */   // Label 30947: @2288350
     /* 2288350 */   GIM_Reject,
     /* 2288351 */ // Label 30945: @2288351
     /* 2288351 */ GIM_Reject,
     /* 2288352 */ // Label 30921: @2288352
     /* 2288352 */ GIM_Try, /*On fail goto*//*Label 30948*/ GIMT_Encode4(2288466),
     /* 2288357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2288360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2288363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288375 */   GIM_Try, /*On fail goto*//*Label 30949*/ GIMT_Encode4(2288420), // Rule ID 50968 //
     /* 2288380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288383 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2288386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2288400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288419 */     // GIR_Coverage, 50968,
     /* 2288419 */     GIR_EraseRootFromParent_Done,
     /* 2288420 */   // Label 30949: @2288420
     /* 2288420 */   GIM_Try, /*On fail goto*//*Label 30950*/ GIMT_Encode4(2288465), // Rule ID 50969 //
     /* 2288425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288428 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2288431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2288445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288464 */     // GIR_Coverage, 50969,
     /* 2288464 */     GIR_EraseRootFromParent_Done,
     /* 2288465 */   // Label 30950: @2288465
     /* 2288465 */   GIM_Reject,
     /* 2288466 */ // Label 30948: @2288466
     /* 2288466 */ GIM_Reject,
     /* 2288467 */ // Label 30922: @2288467
     /* 2288467 */ GIM_Try, /*On fail goto*//*Label 30951*/ GIMT_Encode4(2288581),
     /* 2288472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2288475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2288478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288490 */   GIM_Try, /*On fail goto*//*Label 30952*/ GIMT_Encode4(2288535), // Rule ID 50976 //
     /* 2288495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288498 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2288501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2288515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288534 */     // GIR_Coverage, 50976,
     /* 2288534 */     GIR_EraseRootFromParent_Done,
     /* 2288535 */   // Label 30952: @2288535
     /* 2288535 */   GIM_Try, /*On fail goto*//*Label 30953*/ GIMT_Encode4(2288580), // Rule ID 50977 //
     /* 2288540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288543 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2288546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2288560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288579 */     // GIR_Coverage, 50977,
     /* 2288579 */     GIR_EraseRootFromParent_Done,
     /* 2288580 */   // Label 30953: @2288580
     /* 2288580 */   GIM_Reject,
     /* 2288581 */ // Label 30951: @2288581
     /* 2288581 */ GIM_Reject,
     /* 2288582 */ // Label 30923: @2288582
     /* 2288582 */ GIM_Try, /*On fail goto*//*Label 30954*/ GIMT_Encode4(2288696),
     /* 2288587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2288593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288605 */   GIM_Try, /*On fail goto*//*Label 30955*/ GIMT_Encode4(2288650), // Rule ID 51100 //
     /* 2288610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2288613 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2288616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2288630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288649 */     // GIR_Coverage, 51100,
     /* 2288649 */     GIR_EraseRootFromParent_Done,
     /* 2288650 */   // Label 30955: @2288650
     /* 2288650 */   GIM_Try, /*On fail goto*//*Label 30956*/ GIMT_Encode4(2288695), // Rule ID 51101 //
     /* 2288655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2288658 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2288661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2288675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288694 */     // GIR_Coverage, 51101,
     /* 2288694 */     GIR_EraseRootFromParent_Done,
     /* 2288695 */   // Label 30956: @2288695
     /* 2288695 */   GIM_Reject,
     /* 2288696 */ // Label 30954: @2288696
     /* 2288696 */ GIM_Reject,
     /* 2288697 */ // Label 30924: @2288697
     /* 2288697 */ GIM_Try, /*On fail goto*//*Label 30957*/ GIMT_Encode4(2288811),
     /* 2288702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2288705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2288708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288720 */   GIM_Try, /*On fail goto*//*Label 30958*/ GIMT_Encode4(2288765), // Rule ID 50960 //
     /* 2288725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288728 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2288731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2288745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288764 */     // GIR_Coverage, 50960,
     /* 2288764 */     GIR_EraseRootFromParent_Done,
     /* 2288765 */   // Label 30958: @2288765
     /* 2288765 */   GIM_Try, /*On fail goto*//*Label 30959*/ GIMT_Encode4(2288810), // Rule ID 50961 //
     /* 2288770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288773 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2288776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2288790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288809 */     // GIR_Coverage, 50961,
     /* 2288809 */     GIR_EraseRootFromParent_Done,
     /* 2288810 */   // Label 30959: @2288810
     /* 2288810 */   GIM_Reject,
     /* 2288811 */ // Label 30957: @2288811
     /* 2288811 */ GIM_Reject,
     /* 2288812 */ // Label 30925: @2288812
     /* 2288812 */ GIM_Try, /*On fail goto*//*Label 30960*/ GIMT_Encode4(2288926),
     /* 2288817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2288820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2288823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288835 */   GIM_Try, /*On fail goto*//*Label 30961*/ GIMT_Encode4(2288880), // Rule ID 50972 //
     /* 2288840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288843 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2288846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2288860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288879 */     // GIR_Coverage, 50972,
     /* 2288879 */     GIR_EraseRootFromParent_Done,
     /* 2288880 */   // Label 30961: @2288880
     /* 2288880 */   GIM_Try, /*On fail goto*//*Label 30962*/ GIMT_Encode4(2288925), // Rule ID 50973 //
     /* 2288885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288888 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2288891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2288905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288924 */     // GIR_Coverage, 50973,
     /* 2288924 */     GIR_EraseRootFromParent_Done,
     /* 2288925 */   // Label 30962: @2288925
     /* 2288925 */   GIM_Reject,
     /* 2288926 */ // Label 30960: @2288926
     /* 2288926 */ GIM_Reject,
     /* 2288927 */ // Label 30926: @2288927
     /* 2288927 */ GIM_Try, /*On fail goto*//*Label 30963*/ GIMT_Encode4(2289041),
     /* 2288932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2288935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2288938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288950 */   GIM_Try, /*On fail goto*//*Label 30964*/ GIMT_Encode4(2288995), // Rule ID 50988 //
     /* 2288955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288958 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2288961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2288975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288994 */     // GIR_Coverage, 50988,
     /* 2288994 */     GIR_EraseRootFromParent_Done,
     /* 2288995 */   // Label 30964: @2288995
     /* 2288995 */   GIM_Try, /*On fail goto*//*Label 30965*/ GIMT_Encode4(2289040), // Rule ID 50989 //
     /* 2289000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289003 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2289006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2289020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289039 */     // GIR_Coverage, 50989,
     /* 2289039 */     GIR_EraseRootFromParent_Done,
     /* 2289040 */   // Label 30965: @2289040
     /* 2289040 */   GIM_Reject,
     /* 2289041 */ // Label 30963: @2289041
     /* 2289041 */ GIM_Reject,
     /* 2289042 */ // Label 30927: @2289042
     /* 2289042 */ GIM_Try, /*On fail goto*//*Label 30966*/ GIMT_Encode4(2289156),
     /* 2289047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2289050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2289053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289065 */   GIM_Try, /*On fail goto*//*Label 30967*/ GIMT_Encode4(2289110), // Rule ID 51104 //
     /* 2289070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2289073 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2289076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2289090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289109 */     // GIR_Coverage, 51104,
     /* 2289109 */     GIR_EraseRootFromParent_Done,
     /* 2289110 */   // Label 30967: @2289110
     /* 2289110 */   GIM_Try, /*On fail goto*//*Label 30968*/ GIMT_Encode4(2289155), // Rule ID 51105 //
     /* 2289115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2289118 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2289121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2289135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289154 */     // GIR_Coverage, 51105,
     /* 2289154 */     GIR_EraseRootFromParent_Done,
     /* 2289155 */   // Label 30968: @2289155
     /* 2289155 */   GIM_Reject,
     /* 2289156 */ // Label 30966: @2289156
     /* 2289156 */ GIM_Reject,
     /* 2289157 */ // Label 30928: @2289157
     /* 2289157 */ GIM_Try, /*On fail goto*//*Label 30969*/ GIMT_Encode4(2289271),
     /* 2289162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2289165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2289168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289180 */   GIM_Try, /*On fail goto*//*Label 30970*/ GIMT_Encode4(2289225), // Rule ID 50964 //
     /* 2289185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289188 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2289191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2289205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289224 */     // GIR_Coverage, 50964,
     /* 2289224 */     GIR_EraseRootFromParent_Done,
     /* 2289225 */   // Label 30970: @2289225
     /* 2289225 */   GIM_Try, /*On fail goto*//*Label 30971*/ GIMT_Encode4(2289270), // Rule ID 50965 //
     /* 2289230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289233 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2289236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2289250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289269 */     // GIR_Coverage, 50965,
     /* 2289269 */     GIR_EraseRootFromParent_Done,
     /* 2289270 */   // Label 30971: @2289270
     /* 2289270 */   GIM_Reject,
     /* 2289271 */ // Label 30969: @2289271
     /* 2289271 */ GIM_Reject,
     /* 2289272 */ // Label 30929: @2289272
     /* 2289272 */ GIM_Try, /*On fail goto*//*Label 30972*/ GIMT_Encode4(2289386),
     /* 2289277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2289280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2289283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289295 */   GIM_Try, /*On fail goto*//*Label 30973*/ GIMT_Encode4(2289340), // Rule ID 50984 //
     /* 2289300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289303 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2289306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2289320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289339 */     // GIR_Coverage, 50984,
     /* 2289339 */     GIR_EraseRootFromParent_Done,
     /* 2289340 */   // Label 30973: @2289340
     /* 2289340 */   GIM_Try, /*On fail goto*//*Label 30974*/ GIMT_Encode4(2289385), // Rule ID 50985 //
     /* 2289345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289348 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2289351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2289365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289384 */     // GIR_Coverage, 50985,
     /* 2289384 */     GIR_EraseRootFromParent_Done,
     /* 2289385 */   // Label 30974: @2289385
     /* 2289385 */   GIM_Reject,
     /* 2289386 */ // Label 30972: @2289386
     /* 2289386 */ GIM_Reject,
     /* 2289387 */ // Label 30930: @2289387
     /* 2289387 */ GIM_Try, /*On fail goto*//*Label 30975*/ GIMT_Encode4(2289501),
     /* 2289392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2289395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2289398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289410 */   GIM_Try, /*On fail goto*//*Label 30976*/ GIMT_Encode4(2289455), // Rule ID 51016 //
     /* 2289415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289418 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2289421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2289435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289454 */     // GIR_Coverage, 51016,
     /* 2289454 */     GIR_EraseRootFromParent_Done,
     /* 2289455 */   // Label 30976: @2289455
     /* 2289455 */   GIM_Try, /*On fail goto*//*Label 30977*/ GIMT_Encode4(2289500), // Rule ID 51017 //
     /* 2289460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289463 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2289466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2289480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289499 */     // GIR_Coverage, 51017,
     /* 2289499 */     GIR_EraseRootFromParent_Done,
     /* 2289500 */   // Label 30977: @2289500
     /* 2289500 */   GIM_Reject,
     /* 2289501 */ // Label 30975: @2289501
     /* 2289501 */ GIM_Reject,
     /* 2289502 */ // Label 30931: @2289502
     /* 2289502 */ GIM_Try, /*On fail goto*//*Label 30978*/ GIMT_Encode4(2289616),
     /* 2289507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2289510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2289513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289525 */   GIM_Try, /*On fail goto*//*Label 30979*/ GIMT_Encode4(2289570), // Rule ID 51108 //
     /* 2289530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2289533 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2289536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2289550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289569 */     // GIR_Coverage, 51108,
     /* 2289569 */     GIR_EraseRootFromParent_Done,
     /* 2289570 */   // Label 30979: @2289570
     /* 2289570 */   GIM_Try, /*On fail goto*//*Label 30980*/ GIMT_Encode4(2289615), // Rule ID 51109 //
     /* 2289575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2289578 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2289581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2289595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289614 */     // GIR_Coverage, 51109,
     /* 2289614 */     GIR_EraseRootFromParent_Done,
     /* 2289615 */   // Label 30980: @2289615
     /* 2289615 */   GIM_Reject,
     /* 2289616 */ // Label 30978: @2289616
     /* 2289616 */ GIM_Reject,
     /* 2289617 */ // Label 30932: @2289617
     /* 2289617 */ GIM_Try, /*On fail goto*//*Label 30981*/ GIMT_Encode4(2289731),
     /* 2289622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2289625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2289628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289640 */   GIM_Try, /*On fail goto*//*Label 30982*/ GIMT_Encode4(2289685), // Rule ID 50980 //
     /* 2289645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289648 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2289651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2289665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289684 */     // GIR_Coverage, 50980,
     /* 2289684 */     GIR_EraseRootFromParent_Done,
     /* 2289685 */   // Label 30982: @2289685
     /* 2289685 */   GIM_Try, /*On fail goto*//*Label 30983*/ GIMT_Encode4(2289730), // Rule ID 50981 //
     /* 2289690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289693 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2289696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2289710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289729 */     // GIR_Coverage, 50981,
     /* 2289729 */     GIR_EraseRootFromParent_Done,
     /* 2289730 */   // Label 30983: @2289730
     /* 2289730 */   GIM_Reject,
     /* 2289731 */ // Label 30981: @2289731
     /* 2289731 */ GIM_Reject,
     /* 2289732 */ // Label 30933: @2289732
     /* 2289732 */ GIM_Try, /*On fail goto*//*Label 30984*/ GIMT_Encode4(2289846),
     /* 2289737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2289740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2289743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289755 */   GIM_Try, /*On fail goto*//*Label 30985*/ GIMT_Encode4(2289800), // Rule ID 51004 //
     /* 2289760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289763 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2289766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2289780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289799 */     // GIR_Coverage, 51004,
     /* 2289799 */     GIR_EraseRootFromParent_Done,
     /* 2289800 */   // Label 30985: @2289800
     /* 2289800 */   GIM_Try, /*On fail goto*//*Label 30986*/ GIMT_Encode4(2289845), // Rule ID 51005 //
     /* 2289805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289808 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2289811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2289825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289844 */     // GIR_Coverage, 51005,
     /* 2289844 */     GIR_EraseRootFromParent_Done,
     /* 2289845 */   // Label 30986: @2289845
     /* 2289845 */   GIM_Reject,
     /* 2289846 */ // Label 30984: @2289846
     /* 2289846 */ GIM_Reject,
     /* 2289847 */ // Label 30934: @2289847
     /* 2289847 */ GIM_Try, /*On fail goto*//*Label 30987*/ GIMT_Encode4(2289961),
     /* 2289852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2289855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2289858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289870 */   GIM_Try, /*On fail goto*//*Label 30988*/ GIMT_Encode4(2289915), // Rule ID 51020 //
     /* 2289875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289878 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2289881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2289895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289914 */     // GIR_Coverage, 51020,
     /* 2289914 */     GIR_EraseRootFromParent_Done,
     /* 2289915 */   // Label 30988: @2289915
     /* 2289915 */   GIM_Try, /*On fail goto*//*Label 30989*/ GIMT_Encode4(2289960), // Rule ID 51021 //
     /* 2289920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289923 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2289926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2289940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289959 */     // GIR_Coverage, 51021,
     /* 2289959 */     GIR_EraseRootFromParent_Done,
     /* 2289960 */   // Label 30989: @2289960
     /* 2289960 */   GIM_Reject,
     /* 2289961 */ // Label 30987: @2289961
     /* 2289961 */ GIM_Reject,
     /* 2289962 */ // Label 30935: @2289962
     /* 2289962 */ GIM_Try, /*On fail goto*//*Label 30990*/ GIMT_Encode4(2290076),
     /* 2289967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2289970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2289973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289985 */   GIM_Try, /*On fail goto*//*Label 30991*/ GIMT_Encode4(2290030), // Rule ID 51112 //
     /* 2289990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2289993 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2289996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290029 */     // GIR_Coverage, 51112,
     /* 2290029 */     GIR_EraseRootFromParent_Done,
     /* 2290030 */   // Label 30991: @2290030
     /* 2290030 */   GIM_Try, /*On fail goto*//*Label 30992*/ GIMT_Encode4(2290075), // Rule ID 51113 //
     /* 2290035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2290038 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2290041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290074 */     // GIR_Coverage, 51113,
     /* 2290074 */     GIR_EraseRootFromParent_Done,
     /* 2290075 */   // Label 30992: @2290075
     /* 2290075 */   GIM_Reject,
     /* 2290076 */ // Label 30990: @2290076
     /* 2290076 */ GIM_Reject,
     /* 2290077 */ // Label 30936: @2290077
     /* 2290077 */ GIM_Try, /*On fail goto*//*Label 30993*/ GIMT_Encode4(2290191),
     /* 2290082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2290085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2290088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290100 */   GIM_Try, /*On fail goto*//*Label 30994*/ GIMT_Encode4(2290145), // Rule ID 50992 //
     /* 2290105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290108 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2290111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2290125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290144 */     // GIR_Coverage, 50992,
     /* 2290144 */     GIR_EraseRootFromParent_Done,
     /* 2290145 */   // Label 30994: @2290145
     /* 2290145 */   GIM_Try, /*On fail goto*//*Label 30995*/ GIMT_Encode4(2290190), // Rule ID 50993 //
     /* 2290150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290153 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2290156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2290170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290189 */     // GIR_Coverage, 50993,
     /* 2290189 */     GIR_EraseRootFromParent_Done,
     /* 2290190 */   // Label 30995: @2290190
     /* 2290190 */   GIM_Reject,
     /* 2290191 */ // Label 30993: @2290191
     /* 2290191 */ GIM_Reject,
     /* 2290192 */ // Label 30937: @2290192
     /* 2290192 */ GIM_Try, /*On fail goto*//*Label 30996*/ GIMT_Encode4(2290306),
     /* 2290197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2290200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2290203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290215 */   GIM_Try, /*On fail goto*//*Label 30997*/ GIMT_Encode4(2290260), // Rule ID 51008 //
     /* 2290220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290223 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2290226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2290240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290259 */     // GIR_Coverage, 51008,
     /* 2290259 */     GIR_EraseRootFromParent_Done,
     /* 2290260 */   // Label 30997: @2290260
     /* 2290260 */   GIM_Try, /*On fail goto*//*Label 30998*/ GIMT_Encode4(2290305), // Rule ID 51009 //
     /* 2290265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290268 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2290271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2290285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290304 */     // GIR_Coverage, 51009,
     /* 2290304 */     GIR_EraseRootFromParent_Done,
     /* 2290305 */   // Label 30998: @2290305
     /* 2290305 */   GIM_Reject,
     /* 2290306 */ // Label 30996: @2290306
     /* 2290306 */ GIM_Reject,
     /* 2290307 */ // Label 30938: @2290307
     /* 2290307 */ GIM_Try, /*On fail goto*//*Label 30999*/ GIMT_Encode4(2290421),
     /* 2290312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2290315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2290318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290330 */   GIM_Try, /*On fail goto*//*Label 31000*/ GIMT_Encode4(2290375), // Rule ID 51024 //
     /* 2290335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290338 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2290341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290374 */     // GIR_Coverage, 51024,
     /* 2290374 */     GIR_EraseRootFromParent_Done,
     /* 2290375 */   // Label 31000: @2290375
     /* 2290375 */   GIM_Try, /*On fail goto*//*Label 31001*/ GIMT_Encode4(2290420), // Rule ID 51025 //
     /* 2290380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290383 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2290386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290419 */     // GIR_Coverage, 51025,
     /* 2290419 */     GIR_EraseRootFromParent_Done,
     /* 2290420 */   // Label 31001: @2290420
     /* 2290420 */   GIM_Reject,
     /* 2290421 */ // Label 30999: @2290421
     /* 2290421 */ GIM_Reject,
     /* 2290422 */ // Label 30939: @2290422
     /* 2290422 */ GIM_Try, /*On fail goto*//*Label 31002*/ GIMT_Encode4(2290536),
     /* 2290427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2290430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2290433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290445 */   GIM_Try, /*On fail goto*//*Label 31003*/ GIMT_Encode4(2290490), // Rule ID 50996 //
     /* 2290450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290453 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2290456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2290470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290489 */     // GIR_Coverage, 50996,
     /* 2290489 */     GIR_EraseRootFromParent_Done,
     /* 2290490 */   // Label 31003: @2290490
     /* 2290490 */   GIM_Try, /*On fail goto*//*Label 31004*/ GIMT_Encode4(2290535), // Rule ID 50997 //
     /* 2290495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290498 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2290501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2290515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290534 */     // GIR_Coverage, 50997,
     /* 2290534 */     GIR_EraseRootFromParent_Done,
     /* 2290535 */   // Label 31004: @2290535
     /* 2290535 */   GIM_Reject,
     /* 2290536 */ // Label 31002: @2290536
     /* 2290536 */ GIM_Reject,
     /* 2290537 */ // Label 30940: @2290537
     /* 2290537 */ GIM_Try, /*On fail goto*//*Label 31005*/ GIMT_Encode4(2290651),
     /* 2290542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2290545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2290548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290560 */   GIM_Try, /*On fail goto*//*Label 31006*/ GIMT_Encode4(2290605), // Rule ID 51012 //
     /* 2290565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290568 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2290571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290604 */     // GIR_Coverage, 51012,
     /* 2290604 */     GIR_EraseRootFromParent_Done,
     /* 2290605 */   // Label 31006: @2290605
     /* 2290605 */   GIM_Try, /*On fail goto*//*Label 31007*/ GIMT_Encode4(2290650), // Rule ID 51013 //
     /* 2290610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290613 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2290616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290649 */     // GIR_Coverage, 51013,
     /* 2290649 */     GIR_EraseRootFromParent_Done,
     /* 2290650 */   // Label 31007: @2290650
     /* 2290650 */   GIM_Reject,
     /* 2290651 */ // Label 31005: @2290651
     /* 2290651 */ GIM_Reject,
     /* 2290652 */ // Label 30941: @2290652
     /* 2290652 */ GIM_Try, /*On fail goto*//*Label 31008*/ GIMT_Encode4(2290766),
     /* 2290657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2290660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2290663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290675 */   GIM_Try, /*On fail goto*//*Label 31009*/ GIMT_Encode4(2290720), // Rule ID 51000 //
     /* 2290680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290683 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2290686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290719 */     // GIR_Coverage, 51000,
     /* 2290719 */     GIR_EraseRootFromParent_Done,
     /* 2290720 */   // Label 31009: @2290720
     /* 2290720 */   GIM_Try, /*On fail goto*//*Label 31010*/ GIMT_Encode4(2290765), // Rule ID 51001 //
     /* 2290725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290728 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2290731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290764 */     // GIR_Coverage, 51001,
     /* 2290764 */     GIR_EraseRootFromParent_Done,
     /* 2290765 */   // Label 31010: @2290765
     /* 2290765 */   GIM_Reject,
     /* 2290766 */ // Label 31008: @2290766
     /* 2290766 */ GIM_Reject,
     /* 2290767 */ // Label 30942: @2290767
     /* 2290767 */ GIM_Reject,
     /* 2290768 */ // Label 53: @2290768
     /* 2290768 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31034*/ GIMT_Encode4(2293620),
     /* 2290779 */ /*GILLT_s32*//*Label 31011*/ GIMT_Encode4(2290903), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2290791 */ /*GILLT_nxv1s8*//*Label 31012*/ GIMT_Encode4(2290958),
     /* 2290795 */ /*GILLT_nxv1s16*//*Label 31013*/ GIMT_Encode4(2291079),
     /* 2290799 */ /*GILLT_nxv1s32*//*Label 31014*/ GIMT_Encode4(2291200),
     /* 2290803 */ /*GILLT_nxv1s64*//*Label 31015*/ GIMT_Encode4(2291321), GIMT_Encode4(0),
     /* 2290811 */ /*GILLT_nxv2s8*//*Label 31016*/ GIMT_Encode4(2291442),
     /* 2290815 */ /*GILLT_nxv2s16*//*Label 31017*/ GIMT_Encode4(2291563),
     /* 2290819 */ /*GILLT_nxv2s32*//*Label 31018*/ GIMT_Encode4(2291684),
     /* 2290823 */ /*GILLT_nxv2s64*//*Label 31019*/ GIMT_Encode4(2291805), GIMT_Encode4(0),
     /* 2290831 */ /*GILLT_nxv4s8*//*Label 31020*/ GIMT_Encode4(2291926),
     /* 2290835 */ /*GILLT_nxv4s16*//*Label 31021*/ GIMT_Encode4(2292047),
     /* 2290839 */ /*GILLT_nxv4s32*//*Label 31022*/ GIMT_Encode4(2292168),
     /* 2290843 */ /*GILLT_nxv4s64*//*Label 31023*/ GIMT_Encode4(2292289), GIMT_Encode4(0),
     /* 2290851 */ /*GILLT_nxv8s8*//*Label 31024*/ GIMT_Encode4(2292410),
     /* 2290855 */ /*GILLT_nxv8s16*//*Label 31025*/ GIMT_Encode4(2292531),
     /* 2290859 */ /*GILLT_nxv8s32*//*Label 31026*/ GIMT_Encode4(2292652),
     /* 2290863 */ /*GILLT_nxv8s64*//*Label 31027*/ GIMT_Encode4(2292773), GIMT_Encode4(0),
     /* 2290871 */ /*GILLT_nxv16s8*//*Label 31028*/ GIMT_Encode4(2292894),
     /* 2290875 */ /*GILLT_nxv16s16*//*Label 31029*/ GIMT_Encode4(2293015),
     /* 2290879 */ /*GILLT_nxv16s32*//*Label 31030*/ GIMT_Encode4(2293136), GIMT_Encode4(0),
     /* 2290887 */ /*GILLT_nxv32s8*//*Label 31031*/ GIMT_Encode4(2293257),
     /* 2290891 */ /*GILLT_nxv32s16*//*Label 31032*/ GIMT_Encode4(2293378), GIMT_Encode4(0),
     /* 2290899 */ /*GILLT_nxv64s8*//*Label 31033*/ GIMT_Encode4(2293499),
     /* 2290903 */ // Label 31011: @2290903
     /* 2290903 */ GIM_Try, /*On fail goto*//*Label 31035*/ GIMT_Encode4(2290957),
     /* 2290908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2290914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290922 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290926 */   GIM_Try, /*On fail goto*//*Label 31036*/ GIMT_Encode4(2290941), // Rule ID 64595 //
     /* 2290931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2290934 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2290934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2290939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290940 */     // GIR_Coverage, 64595,
     /* 2290940 */     GIR_Done,
     /* 2290941 */   // Label 31036: @2290941
     /* 2290941 */   GIM_Try, /*On fail goto*//*Label 31037*/ GIMT_Encode4(2290956), // Rule ID 64596 //
     /* 2290946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2290949 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2290949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2290954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290955 */     // GIR_Coverage, 64596,
     /* 2290955 */     GIR_Done,
     /* 2290956 */   // Label 31037: @2290956
     /* 2290956 */   GIM_Reject,
     /* 2290957 */ // Label 31035: @2290957
     /* 2290957 */ GIM_Reject,
     /* 2290958 */ // Label 31012: @2290958
     /* 2290958 */ GIM_Try, /*On fail goto*//*Label 31038*/ GIMT_Encode4(2291078),
     /* 2290963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2290966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2290969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290981 */   GIM_Try, /*On fail goto*//*Label 31039*/ GIMT_Encode4(2291029), // Rule ID 52516 //
     /* 2290986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290989 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2290992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2291006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291028 */     // GIR_Coverage, 52516,
     /* 2291028 */     GIR_EraseRootFromParent_Done,
     /* 2291029 */   // Label 31039: @2291029
     /* 2291029 */   GIM_Try, /*On fail goto*//*Label 31040*/ GIMT_Encode4(2291077), // Rule ID 52517 //
     /* 2291034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291037 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2291040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2291054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291076 */     // GIR_Coverage, 52517,
     /* 2291076 */     GIR_EraseRootFromParent_Done,
     /* 2291077 */   // Label 31040: @2291077
     /* 2291077 */   GIM_Reject,
     /* 2291078 */ // Label 31038: @2291078
     /* 2291078 */ GIM_Reject,
     /* 2291079 */ // Label 31013: @2291079
     /* 2291079 */ GIM_Try, /*On fail goto*//*Label 31041*/ GIMT_Encode4(2291199),
     /* 2291084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2291087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2291090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291102 */   GIM_Try, /*On fail goto*//*Label 31042*/ GIMT_Encode4(2291150), // Rule ID 52528 //
     /* 2291107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291110 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2291113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2291127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291149 */     // GIR_Coverage, 52528,
     /* 2291149 */     GIR_EraseRootFromParent_Done,
     /* 2291150 */   // Label 31042: @2291150
     /* 2291150 */   GIM_Try, /*On fail goto*//*Label 31043*/ GIMT_Encode4(2291198), // Rule ID 52529 //
     /* 2291155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291158 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2291161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2291175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291197 */     // GIR_Coverage, 52529,
     /* 2291197 */     GIR_EraseRootFromParent_Done,
     /* 2291198 */   // Label 31043: @2291198
     /* 2291198 */   GIM_Reject,
     /* 2291199 */ // Label 31041: @2291199
     /* 2291199 */ GIM_Reject,
     /* 2291200 */ // Label 31014: @2291200
     /* 2291200 */ GIM_Try, /*On fail goto*//*Label 31044*/ GIMT_Encode4(2291320),
     /* 2291205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2291208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2291211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291223 */   GIM_Try, /*On fail goto*//*Label 31045*/ GIMT_Encode4(2291271), // Rule ID 52536 //
     /* 2291228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291231 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2291234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2291248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291270 */     // GIR_Coverage, 52536,
     /* 2291270 */     GIR_EraseRootFromParent_Done,
     /* 2291271 */   // Label 31045: @2291271
     /* 2291271 */   GIM_Try, /*On fail goto*//*Label 31046*/ GIMT_Encode4(2291319), // Rule ID 52537 //
     /* 2291276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291279 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2291282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2291296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291318 */     // GIR_Coverage, 52537,
     /* 2291318 */     GIR_EraseRootFromParent_Done,
     /* 2291319 */   // Label 31046: @2291319
     /* 2291319 */   GIM_Reject,
     /* 2291320 */ // Label 31044: @2291320
     /* 2291320 */ GIM_Reject,
     /* 2291321 */ // Label 31015: @2291321
     /* 2291321 */ GIM_Try, /*On fail goto*//*Label 31047*/ GIMT_Encode4(2291441),
     /* 2291326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2291329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2291332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291344 */   GIM_Try, /*On fail goto*//*Label 31048*/ GIMT_Encode4(2291392), // Rule ID 52552 //
     /* 2291349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2291352 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2291355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2291369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291391 */     // GIR_Coverage, 52552,
     /* 2291391 */     GIR_EraseRootFromParent_Done,
     /* 2291392 */   // Label 31048: @2291392
     /* 2291392 */   GIM_Try, /*On fail goto*//*Label 31049*/ GIMT_Encode4(2291440), // Rule ID 52553 //
     /* 2291397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2291400 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2291403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2291417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291439 */     // GIR_Coverage, 52553,
     /* 2291439 */     GIR_EraseRootFromParent_Done,
     /* 2291440 */   // Label 31049: @2291440
     /* 2291440 */   GIM_Reject,
     /* 2291441 */ // Label 31047: @2291441
     /* 2291441 */ GIM_Reject,
     /* 2291442 */ // Label 31016: @2291442
     /* 2291442 */ GIM_Try, /*On fail goto*//*Label 31050*/ GIMT_Encode4(2291562),
     /* 2291447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2291450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2291453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291465 */   GIM_Try, /*On fail goto*//*Label 31051*/ GIMT_Encode4(2291513), // Rule ID 52520 //
     /* 2291470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291473 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2291476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2291490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291512 */     // GIR_Coverage, 52520,
     /* 2291512 */     GIR_EraseRootFromParent_Done,
     /* 2291513 */   // Label 31051: @2291513
     /* 2291513 */   GIM_Try, /*On fail goto*//*Label 31052*/ GIMT_Encode4(2291561), // Rule ID 52521 //
     /* 2291518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291521 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2291524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2291538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291560 */     // GIR_Coverage, 52521,
     /* 2291560 */     GIR_EraseRootFromParent_Done,
     /* 2291561 */   // Label 31052: @2291561
     /* 2291561 */   GIM_Reject,
     /* 2291562 */ // Label 31050: @2291562
     /* 2291562 */ GIM_Reject,
     /* 2291563 */ // Label 31017: @2291563
     /* 2291563 */ GIM_Try, /*On fail goto*//*Label 31053*/ GIMT_Encode4(2291683),
     /* 2291568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2291571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2291574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291586 */   GIM_Try, /*On fail goto*//*Label 31054*/ GIMT_Encode4(2291634), // Rule ID 52532 //
     /* 2291591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291594 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2291597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2291611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291633 */     // GIR_Coverage, 52532,
     /* 2291633 */     GIR_EraseRootFromParent_Done,
     /* 2291634 */   // Label 31054: @2291634
     /* 2291634 */   GIM_Try, /*On fail goto*//*Label 31055*/ GIMT_Encode4(2291682), // Rule ID 52533 //
     /* 2291639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291642 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2291645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2291659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291681 */     // GIR_Coverage, 52533,
     /* 2291681 */     GIR_EraseRootFromParent_Done,
     /* 2291682 */   // Label 31055: @2291682
     /* 2291682 */   GIM_Reject,
     /* 2291683 */ // Label 31053: @2291683
     /* 2291683 */ GIM_Reject,
     /* 2291684 */ // Label 31018: @2291684
     /* 2291684 */ GIM_Try, /*On fail goto*//*Label 31056*/ GIMT_Encode4(2291804),
     /* 2291689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2291692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2291695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291707 */   GIM_Try, /*On fail goto*//*Label 31057*/ GIMT_Encode4(2291755), // Rule ID 52548 //
     /* 2291712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291715 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2291718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2291732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291754 */     // GIR_Coverage, 52548,
     /* 2291754 */     GIR_EraseRootFromParent_Done,
     /* 2291755 */   // Label 31057: @2291755
     /* 2291755 */   GIM_Try, /*On fail goto*//*Label 31058*/ GIMT_Encode4(2291803), // Rule ID 52549 //
     /* 2291760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291763 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2291766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2291780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291802 */     // GIR_Coverage, 52549,
     /* 2291802 */     GIR_EraseRootFromParent_Done,
     /* 2291803 */   // Label 31058: @2291803
     /* 2291803 */   GIM_Reject,
     /* 2291804 */ // Label 31056: @2291804
     /* 2291804 */ GIM_Reject,
     /* 2291805 */ // Label 31019: @2291805
     /* 2291805 */ GIM_Try, /*On fail goto*//*Label 31059*/ GIMT_Encode4(2291925),
     /* 2291810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2291813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2291816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291828 */   GIM_Try, /*On fail goto*//*Label 31060*/ GIMT_Encode4(2291876), // Rule ID 52592 //
     /* 2291833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2291836 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2291839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2291853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291875 */     // GIR_Coverage, 52592,
     /* 2291875 */     GIR_EraseRootFromParent_Done,
     /* 2291876 */   // Label 31060: @2291876
     /* 2291876 */   GIM_Try, /*On fail goto*//*Label 31061*/ GIMT_Encode4(2291924), // Rule ID 52593 //
     /* 2291881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2291884 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2291887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2291901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291923 */     // GIR_Coverage, 52593,
     /* 2291923 */     GIR_EraseRootFromParent_Done,
     /* 2291924 */   // Label 31061: @2291924
     /* 2291924 */   GIM_Reject,
     /* 2291925 */ // Label 31059: @2291925
     /* 2291925 */ GIM_Reject,
     /* 2291926 */ // Label 31020: @2291926
     /* 2291926 */ GIM_Try, /*On fail goto*//*Label 31062*/ GIMT_Encode4(2292046),
     /* 2291931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2291934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2291937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291949 */   GIM_Try, /*On fail goto*//*Label 31063*/ GIMT_Encode4(2291997), // Rule ID 52524 //
     /* 2291954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291957 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2291960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2291974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291996 */     // GIR_Coverage, 52524,
     /* 2291996 */     GIR_EraseRootFromParent_Done,
     /* 2291997 */   // Label 31063: @2291997
     /* 2291997 */   GIM_Try, /*On fail goto*//*Label 31064*/ GIMT_Encode4(2292045), // Rule ID 52525 //
     /* 2292002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292005 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2292008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2292022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292044 */     // GIR_Coverage, 52525,
     /* 2292044 */     GIR_EraseRootFromParent_Done,
     /* 2292045 */   // Label 31064: @2292045
     /* 2292045 */   GIM_Reject,
     /* 2292046 */ // Label 31062: @2292046
     /* 2292046 */ GIM_Reject,
     /* 2292047 */ // Label 31021: @2292047
     /* 2292047 */ GIM_Try, /*On fail goto*//*Label 31065*/ GIMT_Encode4(2292167),
     /* 2292052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2292055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2292058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292070 */   GIM_Try, /*On fail goto*//*Label 31066*/ GIMT_Encode4(2292118), // Rule ID 52544 //
     /* 2292075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292078 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2292081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2292095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292117 */     // GIR_Coverage, 52544,
     /* 2292117 */     GIR_EraseRootFromParent_Done,
     /* 2292118 */   // Label 31066: @2292118
     /* 2292118 */   GIM_Try, /*On fail goto*//*Label 31067*/ GIMT_Encode4(2292166), // Rule ID 52545 //
     /* 2292123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292126 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2292129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2292143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292165 */     // GIR_Coverage, 52545,
     /* 2292165 */     GIR_EraseRootFromParent_Done,
     /* 2292166 */   // Label 31067: @2292166
     /* 2292166 */   GIM_Reject,
     /* 2292167 */ // Label 31065: @2292167
     /* 2292167 */ GIM_Reject,
     /* 2292168 */ // Label 31022: @2292168
     /* 2292168 */ GIM_Try, /*On fail goto*//*Label 31068*/ GIMT_Encode4(2292288),
     /* 2292173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2292179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292191 */   GIM_Try, /*On fail goto*//*Label 31069*/ GIMT_Encode4(2292239), // Rule ID 52580 //
     /* 2292196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292199 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2292202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2292216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292238 */     // GIR_Coverage, 52580,
     /* 2292238 */     GIR_EraseRootFromParent_Done,
     /* 2292239 */   // Label 31069: @2292239
     /* 2292239 */   GIM_Try, /*On fail goto*//*Label 31070*/ GIMT_Encode4(2292287), // Rule ID 52581 //
     /* 2292244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292247 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2292250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2292264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292286 */     // GIR_Coverage, 52581,
     /* 2292286 */     GIR_EraseRootFromParent_Done,
     /* 2292287 */   // Label 31070: @2292287
     /* 2292287 */   GIM_Reject,
     /* 2292288 */ // Label 31068: @2292288
     /* 2292288 */ GIM_Reject,
     /* 2292289 */ // Label 31023: @2292289
     /* 2292289 */ GIM_Try, /*On fail goto*//*Label 31071*/ GIMT_Encode4(2292409),
     /* 2292294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2292297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2292300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292312 */   GIM_Try, /*On fail goto*//*Label 31072*/ GIMT_Encode4(2292360), // Rule ID 52596 //
     /* 2292317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2292320 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2292323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2292337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292359 */     // GIR_Coverage, 52596,
     /* 2292359 */     GIR_EraseRootFromParent_Done,
     /* 2292360 */   // Label 31072: @2292360
     /* 2292360 */   GIM_Try, /*On fail goto*//*Label 31073*/ GIMT_Encode4(2292408), // Rule ID 52597 //
     /* 2292365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2292368 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2292371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2292385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292407 */     // GIR_Coverage, 52597,
     /* 2292407 */     GIR_EraseRootFromParent_Done,
     /* 2292408 */   // Label 31073: @2292408
     /* 2292408 */   GIM_Reject,
     /* 2292409 */ // Label 31071: @2292409
     /* 2292409 */ GIM_Reject,
     /* 2292410 */ // Label 31024: @2292410
     /* 2292410 */ GIM_Try, /*On fail goto*//*Label 31074*/ GIMT_Encode4(2292530),
     /* 2292415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2292418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2292421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292433 */   GIM_Try, /*On fail goto*//*Label 31075*/ GIMT_Encode4(2292481), // Rule ID 52540 //
     /* 2292438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292441 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2292444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2292458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292480 */     // GIR_Coverage, 52540,
     /* 2292480 */     GIR_EraseRootFromParent_Done,
     /* 2292481 */   // Label 31075: @2292481
     /* 2292481 */   GIM_Try, /*On fail goto*//*Label 31076*/ GIMT_Encode4(2292529), // Rule ID 52541 //
     /* 2292486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292489 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2292492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2292506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292528 */     // GIR_Coverage, 52541,
     /* 2292528 */     GIR_EraseRootFromParent_Done,
     /* 2292529 */   // Label 31076: @2292529
     /* 2292529 */   GIM_Reject,
     /* 2292530 */ // Label 31074: @2292530
     /* 2292530 */ GIM_Reject,
     /* 2292531 */ // Label 31025: @2292531
     /* 2292531 */ GIM_Try, /*On fail goto*//*Label 31077*/ GIMT_Encode4(2292651),
     /* 2292536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2292539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2292542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292554 */   GIM_Try, /*On fail goto*//*Label 31078*/ GIMT_Encode4(2292602), // Rule ID 52568 //
     /* 2292559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292562 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2292565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2292579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292601 */     // GIR_Coverage, 52568,
     /* 2292601 */     GIR_EraseRootFromParent_Done,
     /* 2292602 */   // Label 31078: @2292602
     /* 2292602 */   GIM_Try, /*On fail goto*//*Label 31079*/ GIMT_Encode4(2292650), // Rule ID 52569 //
     /* 2292607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292610 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2292613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2292627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292649 */     // GIR_Coverage, 52569,
     /* 2292649 */     GIR_EraseRootFromParent_Done,
     /* 2292650 */   // Label 31079: @2292650
     /* 2292650 */   GIM_Reject,
     /* 2292651 */ // Label 31077: @2292651
     /* 2292651 */ GIM_Reject,
     /* 2292652 */ // Label 31026: @2292652
     /* 2292652 */ GIM_Try, /*On fail goto*//*Label 31080*/ GIMT_Encode4(2292772),
     /* 2292657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2292660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2292663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292675 */   GIM_Try, /*On fail goto*//*Label 31081*/ GIMT_Encode4(2292723), // Rule ID 52584 //
     /* 2292680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292683 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2292686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2292700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292722 */     // GIR_Coverage, 52584,
     /* 2292722 */     GIR_EraseRootFromParent_Done,
     /* 2292723 */   // Label 31081: @2292723
     /* 2292723 */   GIM_Try, /*On fail goto*//*Label 31082*/ GIMT_Encode4(2292771), // Rule ID 52585 //
     /* 2292728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292731 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2292734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2292748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292770 */     // GIR_Coverage, 52585,
     /* 2292770 */     GIR_EraseRootFromParent_Done,
     /* 2292771 */   // Label 31082: @2292771
     /* 2292771 */   GIM_Reject,
     /* 2292772 */ // Label 31080: @2292772
     /* 2292772 */ GIM_Reject,
     /* 2292773 */ // Label 31027: @2292773
     /* 2292773 */ GIM_Try, /*On fail goto*//*Label 31083*/ GIMT_Encode4(2292893),
     /* 2292778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2292781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2292784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292796 */   GIM_Try, /*On fail goto*//*Label 31084*/ GIMT_Encode4(2292844), // Rule ID 52600 //
     /* 2292801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2292804 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2292807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2292821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292843 */     // GIR_Coverage, 52600,
     /* 2292843 */     GIR_EraseRootFromParent_Done,
     /* 2292844 */   // Label 31084: @2292844
     /* 2292844 */   GIM_Try, /*On fail goto*//*Label 31085*/ GIMT_Encode4(2292892), // Rule ID 52601 //
     /* 2292849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2292852 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2292855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2292869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292891 */     // GIR_Coverage, 52601,
     /* 2292891 */     GIR_EraseRootFromParent_Done,
     /* 2292892 */   // Label 31085: @2292892
     /* 2292892 */   GIM_Reject,
     /* 2292893 */ // Label 31083: @2292893
     /* 2292893 */ GIM_Reject,
     /* 2292894 */ // Label 31028: @2292894
     /* 2292894 */ GIM_Try, /*On fail goto*//*Label 31086*/ GIMT_Encode4(2293014),
     /* 2292899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2292902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2292905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292917 */   GIM_Try, /*On fail goto*//*Label 31087*/ GIMT_Encode4(2292965), // Rule ID 52556 //
     /* 2292922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292925 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2292928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2292942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292964 */     // GIR_Coverage, 52556,
     /* 2292964 */     GIR_EraseRootFromParent_Done,
     /* 2292965 */   // Label 31087: @2292965
     /* 2292965 */   GIM_Try, /*On fail goto*//*Label 31088*/ GIMT_Encode4(2293013), // Rule ID 52557 //
     /* 2292970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292973 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2292976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2292990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293012 */     // GIR_Coverage, 52557,
     /* 2293012 */     GIR_EraseRootFromParent_Done,
     /* 2293013 */   // Label 31088: @2293013
     /* 2293013 */   GIM_Reject,
     /* 2293014 */ // Label 31086: @2293014
     /* 2293014 */ GIM_Reject,
     /* 2293015 */ // Label 31029: @2293015
     /* 2293015 */ GIM_Try, /*On fail goto*//*Label 31089*/ GIMT_Encode4(2293135),
     /* 2293020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2293023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2293026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293038 */   GIM_Try, /*On fail goto*//*Label 31090*/ GIMT_Encode4(2293086), // Rule ID 52572 //
     /* 2293043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293046 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2293049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2293063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293085 */     // GIR_Coverage, 52572,
     /* 2293085 */     GIR_EraseRootFromParent_Done,
     /* 2293086 */   // Label 31090: @2293086
     /* 2293086 */   GIM_Try, /*On fail goto*//*Label 31091*/ GIMT_Encode4(2293134), // Rule ID 52573 //
     /* 2293091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293094 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2293097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2293111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293133 */     // GIR_Coverage, 52573,
     /* 2293133 */     GIR_EraseRootFromParent_Done,
     /* 2293134 */   // Label 31091: @2293134
     /* 2293134 */   GIM_Reject,
     /* 2293135 */ // Label 31089: @2293135
     /* 2293135 */ GIM_Reject,
     /* 2293136 */ // Label 31030: @2293136
     /* 2293136 */ GIM_Try, /*On fail goto*//*Label 31092*/ GIMT_Encode4(2293256),
     /* 2293141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2293144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2293147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293159 */   GIM_Try, /*On fail goto*//*Label 31093*/ GIMT_Encode4(2293207), // Rule ID 52588 //
     /* 2293164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293167 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2293170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2293184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293206 */     // GIR_Coverage, 52588,
     /* 2293206 */     GIR_EraseRootFromParent_Done,
     /* 2293207 */   // Label 31093: @2293207
     /* 2293207 */   GIM_Try, /*On fail goto*//*Label 31094*/ GIMT_Encode4(2293255), // Rule ID 52589 //
     /* 2293212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293215 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2293218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2293232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293254 */     // GIR_Coverage, 52589,
     /* 2293254 */     GIR_EraseRootFromParent_Done,
     /* 2293255 */   // Label 31094: @2293255
     /* 2293255 */   GIM_Reject,
     /* 2293256 */ // Label 31092: @2293256
     /* 2293256 */ GIM_Reject,
     /* 2293257 */ // Label 31031: @2293257
     /* 2293257 */ GIM_Try, /*On fail goto*//*Label 31095*/ GIMT_Encode4(2293377),
     /* 2293262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2293265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2293268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293280 */   GIM_Try, /*On fail goto*//*Label 31096*/ GIMT_Encode4(2293328), // Rule ID 52560 //
     /* 2293285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293288 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2293291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2293305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293327 */     // GIR_Coverage, 52560,
     /* 2293327 */     GIR_EraseRootFromParent_Done,
     /* 2293328 */   // Label 31096: @2293328
     /* 2293328 */   GIM_Try, /*On fail goto*//*Label 31097*/ GIMT_Encode4(2293376), // Rule ID 52561 //
     /* 2293333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293336 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2293339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2293353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293375 */     // GIR_Coverage, 52561,
     /* 2293375 */     GIR_EraseRootFromParent_Done,
     /* 2293376 */   // Label 31097: @2293376
     /* 2293376 */   GIM_Reject,
     /* 2293377 */ // Label 31095: @2293377
     /* 2293377 */ GIM_Reject,
     /* 2293378 */ // Label 31032: @2293378
     /* 2293378 */ GIM_Try, /*On fail goto*//*Label 31098*/ GIMT_Encode4(2293498),
     /* 2293383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2293386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2293389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293401 */   GIM_Try, /*On fail goto*//*Label 31099*/ GIMT_Encode4(2293449), // Rule ID 52576 //
     /* 2293406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293409 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2293412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2293426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293448 */     // GIR_Coverage, 52576,
     /* 2293448 */     GIR_EraseRootFromParent_Done,
     /* 2293449 */   // Label 31099: @2293449
     /* 2293449 */   GIM_Try, /*On fail goto*//*Label 31100*/ GIMT_Encode4(2293497), // Rule ID 52577 //
     /* 2293454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293457 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2293460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2293474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293496 */     // GIR_Coverage, 52577,
     /* 2293496 */     GIR_EraseRootFromParent_Done,
     /* 2293497 */   // Label 31100: @2293497
     /* 2293497 */   GIM_Reject,
     /* 2293498 */ // Label 31098: @2293498
     /* 2293498 */ GIM_Reject,
     /* 2293499 */ // Label 31033: @2293499
     /* 2293499 */ GIM_Try, /*On fail goto*//*Label 31101*/ GIMT_Encode4(2293619),
     /* 2293504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2293507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2293510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293522 */   GIM_Try, /*On fail goto*//*Label 31102*/ GIMT_Encode4(2293570), // Rule ID 52564 //
     /* 2293527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293530 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2293533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2293547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293569 */     // GIR_Coverage, 52564,
     /* 2293569 */     GIR_EraseRootFromParent_Done,
     /* 2293570 */   // Label 31102: @2293570
     /* 2293570 */   GIM_Try, /*On fail goto*//*Label 31103*/ GIMT_Encode4(2293618), // Rule ID 52565 //
     /* 2293575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293578 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2293581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2293595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293617 */     // GIR_Coverage, 52565,
     /* 2293617 */     GIR_EraseRootFromParent_Done,
     /* 2293618 */   // Label 31103: @2293618
     /* 2293618 */   GIM_Reject,
     /* 2293619 */ // Label 31101: @2293619
     /* 2293619 */ GIM_Reject,
     /* 2293620 */ // Label 31034: @2293620
     /* 2293620 */ GIM_Reject,
     /* 2293621 */ // Label 54: @2293621
     /* 2293621 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31127*/ GIMT_Encode4(2296473),
     /* 2293632 */ /*GILLT_s32*//*Label 31104*/ GIMT_Encode4(2293756), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2293644 */ /*GILLT_nxv1s8*//*Label 31105*/ GIMT_Encode4(2293811),
     /* 2293648 */ /*GILLT_nxv1s16*//*Label 31106*/ GIMT_Encode4(2293932),
     /* 2293652 */ /*GILLT_nxv1s32*//*Label 31107*/ GIMT_Encode4(2294053),
     /* 2293656 */ /*GILLT_nxv1s64*//*Label 31108*/ GIMT_Encode4(2294174), GIMT_Encode4(0),
     /* 2293664 */ /*GILLT_nxv2s8*//*Label 31109*/ GIMT_Encode4(2294295),
     /* 2293668 */ /*GILLT_nxv2s16*//*Label 31110*/ GIMT_Encode4(2294416),
     /* 2293672 */ /*GILLT_nxv2s32*//*Label 31111*/ GIMT_Encode4(2294537),
     /* 2293676 */ /*GILLT_nxv2s64*//*Label 31112*/ GIMT_Encode4(2294658), GIMT_Encode4(0),
     /* 2293684 */ /*GILLT_nxv4s8*//*Label 31113*/ GIMT_Encode4(2294779),
     /* 2293688 */ /*GILLT_nxv4s16*//*Label 31114*/ GIMT_Encode4(2294900),
     /* 2293692 */ /*GILLT_nxv4s32*//*Label 31115*/ GIMT_Encode4(2295021),
     /* 2293696 */ /*GILLT_nxv4s64*//*Label 31116*/ GIMT_Encode4(2295142), GIMT_Encode4(0),
     /* 2293704 */ /*GILLT_nxv8s8*//*Label 31117*/ GIMT_Encode4(2295263),
     /* 2293708 */ /*GILLT_nxv8s16*//*Label 31118*/ GIMT_Encode4(2295384),
     /* 2293712 */ /*GILLT_nxv8s32*//*Label 31119*/ GIMT_Encode4(2295505),
     /* 2293716 */ /*GILLT_nxv8s64*//*Label 31120*/ GIMT_Encode4(2295626), GIMT_Encode4(0),
     /* 2293724 */ /*GILLT_nxv16s8*//*Label 31121*/ GIMT_Encode4(2295747),
     /* 2293728 */ /*GILLT_nxv16s16*//*Label 31122*/ GIMT_Encode4(2295868),
     /* 2293732 */ /*GILLT_nxv16s32*//*Label 31123*/ GIMT_Encode4(2295989), GIMT_Encode4(0),
     /* 2293740 */ /*GILLT_nxv32s8*//*Label 31124*/ GIMT_Encode4(2296110),
     /* 2293744 */ /*GILLT_nxv32s16*//*Label 31125*/ GIMT_Encode4(2296231), GIMT_Encode4(0),
     /* 2293752 */ /*GILLT_nxv64s8*//*Label 31126*/ GIMT_Encode4(2296352),
     /* 2293756 */ // Label 31104: @2293756
     /* 2293756 */ GIM_Try, /*On fail goto*//*Label 31128*/ GIMT_Encode4(2293810),
     /* 2293761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2293764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2293767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2293771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2293775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2293779 */   GIM_Try, /*On fail goto*//*Label 31129*/ GIMT_Encode4(2293794), // Rule ID 64593 //
     /* 2293784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2293787 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2293787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2293792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293793 */     // GIR_Coverage, 64593,
     /* 2293793 */     GIR_Done,
     /* 2293794 */   // Label 31129: @2293794
     /* 2293794 */   GIM_Try, /*On fail goto*//*Label 31130*/ GIMT_Encode4(2293809), // Rule ID 64594 //
     /* 2293799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2293802 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2293802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2293807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293808 */     // GIR_Coverage, 64594,
     /* 2293808 */     GIR_Done,
     /* 2293809 */   // Label 31130: @2293809
     /* 2293809 */   GIM_Reject,
     /* 2293810 */ // Label 31128: @2293810
     /* 2293810 */ GIM_Reject,
     /* 2293811 */ // Label 31105: @2293811
     /* 2293811 */ GIM_Try, /*On fail goto*//*Label 31131*/ GIMT_Encode4(2293931),
     /* 2293816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2293819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2293822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293834 */   GIM_Try, /*On fail goto*//*Label 31132*/ GIMT_Encode4(2293882), // Rule ID 52384 //
     /* 2293839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293842 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2293845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2293859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293881 */     // GIR_Coverage, 52384,
     /* 2293881 */     GIR_EraseRootFromParent_Done,
     /* 2293882 */   // Label 31132: @2293882
     /* 2293882 */   GIM_Try, /*On fail goto*//*Label 31133*/ GIMT_Encode4(2293930), // Rule ID 52385 //
     /* 2293887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293890 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2293893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2293907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293929 */     // GIR_Coverage, 52385,
     /* 2293929 */     GIR_EraseRootFromParent_Done,
     /* 2293930 */   // Label 31133: @2293930
     /* 2293930 */   GIM_Reject,
     /* 2293931 */ // Label 31131: @2293931
     /* 2293931 */ GIM_Reject,
     /* 2293932 */ // Label 31106: @2293932
     /* 2293932 */ GIM_Try, /*On fail goto*//*Label 31134*/ GIMT_Encode4(2294052),
     /* 2293937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2293943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293955 */   GIM_Try, /*On fail goto*//*Label 31135*/ GIMT_Encode4(2294003), // Rule ID 52396 //
     /* 2293960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293963 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2293966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2293980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294002 */     // GIR_Coverage, 52396,
     /* 2294002 */     GIR_EraseRootFromParent_Done,
     /* 2294003 */   // Label 31135: @2294003
     /* 2294003 */   GIM_Try, /*On fail goto*//*Label 31136*/ GIMT_Encode4(2294051), // Rule ID 52397 //
     /* 2294008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294011 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2294014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2294028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294050 */     // GIR_Coverage, 52397,
     /* 2294050 */     GIR_EraseRootFromParent_Done,
     /* 2294051 */   // Label 31136: @2294051
     /* 2294051 */   GIM_Reject,
     /* 2294052 */ // Label 31134: @2294052
     /* 2294052 */ GIM_Reject,
     /* 2294053 */ // Label 31107: @2294053
     /* 2294053 */ GIM_Try, /*On fail goto*//*Label 31137*/ GIMT_Encode4(2294173),
     /* 2294058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2294061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2294064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294076 */   GIM_Try, /*On fail goto*//*Label 31138*/ GIMT_Encode4(2294124), // Rule ID 52404 //
     /* 2294081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294084 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2294087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2294101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294123 */     // GIR_Coverage, 52404,
     /* 2294123 */     GIR_EraseRootFromParent_Done,
     /* 2294124 */   // Label 31138: @2294124
     /* 2294124 */   GIM_Try, /*On fail goto*//*Label 31139*/ GIMT_Encode4(2294172), // Rule ID 52405 //
     /* 2294129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294132 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2294135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2294149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294171 */     // GIR_Coverage, 52405,
     /* 2294171 */     GIR_EraseRootFromParent_Done,
     /* 2294172 */   // Label 31139: @2294172
     /* 2294172 */   GIM_Reject,
     /* 2294173 */ // Label 31137: @2294173
     /* 2294173 */ GIM_Reject,
     /* 2294174 */ // Label 31108: @2294174
     /* 2294174 */ GIM_Try, /*On fail goto*//*Label 31140*/ GIMT_Encode4(2294294),
     /* 2294179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2294185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294197 */   GIM_Try, /*On fail goto*//*Label 31141*/ GIMT_Encode4(2294245), // Rule ID 52420 //
     /* 2294202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2294205 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2294208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2294222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294244 */     // GIR_Coverage, 52420,
     /* 2294244 */     GIR_EraseRootFromParent_Done,
     /* 2294245 */   // Label 31141: @2294245
     /* 2294245 */   GIM_Try, /*On fail goto*//*Label 31142*/ GIMT_Encode4(2294293), // Rule ID 52421 //
     /* 2294250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2294253 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2294256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2294270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294292 */     // GIR_Coverage, 52421,
     /* 2294292 */     GIR_EraseRootFromParent_Done,
     /* 2294293 */   // Label 31142: @2294293
     /* 2294293 */   GIM_Reject,
     /* 2294294 */ // Label 31140: @2294294
     /* 2294294 */ GIM_Reject,
     /* 2294295 */ // Label 31109: @2294295
     /* 2294295 */ GIM_Try, /*On fail goto*//*Label 31143*/ GIMT_Encode4(2294415),
     /* 2294300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2294303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2294306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294318 */   GIM_Try, /*On fail goto*//*Label 31144*/ GIMT_Encode4(2294366), // Rule ID 52388 //
     /* 2294323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294326 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2294329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2294343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294365 */     // GIR_Coverage, 52388,
     /* 2294365 */     GIR_EraseRootFromParent_Done,
     /* 2294366 */   // Label 31144: @2294366
     /* 2294366 */   GIM_Try, /*On fail goto*//*Label 31145*/ GIMT_Encode4(2294414), // Rule ID 52389 //
     /* 2294371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294374 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2294377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2294391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294413 */     // GIR_Coverage, 52389,
     /* 2294413 */     GIR_EraseRootFromParent_Done,
     /* 2294414 */   // Label 31145: @2294414
     /* 2294414 */   GIM_Reject,
     /* 2294415 */ // Label 31143: @2294415
     /* 2294415 */ GIM_Reject,
     /* 2294416 */ // Label 31110: @2294416
     /* 2294416 */ GIM_Try, /*On fail goto*//*Label 31146*/ GIMT_Encode4(2294536),
     /* 2294421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2294424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2294427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294439 */   GIM_Try, /*On fail goto*//*Label 31147*/ GIMT_Encode4(2294487), // Rule ID 52400 //
     /* 2294444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294447 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2294450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2294464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294486 */     // GIR_Coverage, 52400,
     /* 2294486 */     GIR_EraseRootFromParent_Done,
     /* 2294487 */   // Label 31147: @2294487
     /* 2294487 */   GIM_Try, /*On fail goto*//*Label 31148*/ GIMT_Encode4(2294535), // Rule ID 52401 //
     /* 2294492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294495 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2294498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2294512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294534 */     // GIR_Coverage, 52401,
     /* 2294534 */     GIR_EraseRootFromParent_Done,
     /* 2294535 */   // Label 31148: @2294535
     /* 2294535 */   GIM_Reject,
     /* 2294536 */ // Label 31146: @2294536
     /* 2294536 */ GIM_Reject,
     /* 2294537 */ // Label 31111: @2294537
     /* 2294537 */ GIM_Try, /*On fail goto*//*Label 31149*/ GIMT_Encode4(2294657),
     /* 2294542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2294545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2294548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294560 */   GIM_Try, /*On fail goto*//*Label 31150*/ GIMT_Encode4(2294608), // Rule ID 52416 //
     /* 2294565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294568 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2294571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2294585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294607 */     // GIR_Coverage, 52416,
     /* 2294607 */     GIR_EraseRootFromParent_Done,
     /* 2294608 */   // Label 31150: @2294608
     /* 2294608 */   GIM_Try, /*On fail goto*//*Label 31151*/ GIMT_Encode4(2294656), // Rule ID 52417 //
     /* 2294613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294616 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2294619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2294633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294655 */     // GIR_Coverage, 52417,
     /* 2294655 */     GIR_EraseRootFromParent_Done,
     /* 2294656 */   // Label 31151: @2294656
     /* 2294656 */   GIM_Reject,
     /* 2294657 */ // Label 31149: @2294657
     /* 2294657 */ GIM_Reject,
     /* 2294658 */ // Label 31112: @2294658
     /* 2294658 */ GIM_Try, /*On fail goto*//*Label 31152*/ GIMT_Encode4(2294778),
     /* 2294663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2294666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2294669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294681 */   GIM_Try, /*On fail goto*//*Label 31153*/ GIMT_Encode4(2294729), // Rule ID 52460 //
     /* 2294686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2294689 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2294692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2294706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294728 */     // GIR_Coverage, 52460,
     /* 2294728 */     GIR_EraseRootFromParent_Done,
     /* 2294729 */   // Label 31153: @2294729
     /* 2294729 */   GIM_Try, /*On fail goto*//*Label 31154*/ GIMT_Encode4(2294777), // Rule ID 52461 //
     /* 2294734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2294737 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2294740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2294754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294776 */     // GIR_Coverage, 52461,
     /* 2294776 */     GIR_EraseRootFromParent_Done,
     /* 2294777 */   // Label 31154: @2294777
     /* 2294777 */   GIM_Reject,
     /* 2294778 */ // Label 31152: @2294778
     /* 2294778 */ GIM_Reject,
     /* 2294779 */ // Label 31113: @2294779
     /* 2294779 */ GIM_Try, /*On fail goto*//*Label 31155*/ GIMT_Encode4(2294899),
     /* 2294784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2294787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2294790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294802 */   GIM_Try, /*On fail goto*//*Label 31156*/ GIMT_Encode4(2294850), // Rule ID 52392 //
     /* 2294807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294810 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2294813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2294827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294849 */     // GIR_Coverage, 52392,
     /* 2294849 */     GIR_EraseRootFromParent_Done,
     /* 2294850 */   // Label 31156: @2294850
     /* 2294850 */   GIM_Try, /*On fail goto*//*Label 31157*/ GIMT_Encode4(2294898), // Rule ID 52393 //
     /* 2294855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294858 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2294861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2294875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294897 */     // GIR_Coverage, 52393,
     /* 2294897 */     GIR_EraseRootFromParent_Done,
     /* 2294898 */   // Label 31157: @2294898
     /* 2294898 */   GIM_Reject,
     /* 2294899 */ // Label 31155: @2294899
     /* 2294899 */ GIM_Reject,
     /* 2294900 */ // Label 31114: @2294900
     /* 2294900 */ GIM_Try, /*On fail goto*//*Label 31158*/ GIMT_Encode4(2295020),
     /* 2294905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2294908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2294911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294923 */   GIM_Try, /*On fail goto*//*Label 31159*/ GIMT_Encode4(2294971), // Rule ID 52412 //
     /* 2294928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294931 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2294934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2294948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294966 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294970 */     // GIR_Coverage, 52412,
     /* 2294970 */     GIR_EraseRootFromParent_Done,
     /* 2294971 */   // Label 31159: @2294971
     /* 2294971 */   GIM_Try, /*On fail goto*//*Label 31160*/ GIMT_Encode4(2295019), // Rule ID 52413 //
     /* 2294976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294979 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2294982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2294996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295018 */     // GIR_Coverage, 52413,
     /* 2295018 */     GIR_EraseRootFromParent_Done,
     /* 2295019 */   // Label 31160: @2295019
     /* 2295019 */   GIM_Reject,
     /* 2295020 */ // Label 31158: @2295020
     /* 2295020 */ GIM_Reject,
     /* 2295021 */ // Label 31115: @2295021
     /* 2295021 */ GIM_Try, /*On fail goto*//*Label 31161*/ GIMT_Encode4(2295141),
     /* 2295026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2295029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2295032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295044 */   GIM_Try, /*On fail goto*//*Label 31162*/ GIMT_Encode4(2295092), // Rule ID 52448 //
     /* 2295049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295052 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2295055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2295069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295091 */     // GIR_Coverage, 52448,
     /* 2295091 */     GIR_EraseRootFromParent_Done,
     /* 2295092 */   // Label 31162: @2295092
     /* 2295092 */   GIM_Try, /*On fail goto*//*Label 31163*/ GIMT_Encode4(2295140), // Rule ID 52449 //
     /* 2295097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295100 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2295103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2295117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295139 */     // GIR_Coverage, 52449,
     /* 2295139 */     GIR_EraseRootFromParent_Done,
     /* 2295140 */   // Label 31163: @2295140
     /* 2295140 */   GIM_Reject,
     /* 2295141 */ // Label 31161: @2295141
     /* 2295141 */ GIM_Reject,
     /* 2295142 */ // Label 31116: @2295142
     /* 2295142 */ GIM_Try, /*On fail goto*//*Label 31164*/ GIMT_Encode4(2295262),
     /* 2295147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2295150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2295153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295165 */   GIM_Try, /*On fail goto*//*Label 31165*/ GIMT_Encode4(2295213), // Rule ID 52464 //
     /* 2295170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2295173 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2295176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2295190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295212 */     // GIR_Coverage, 52464,
     /* 2295212 */     GIR_EraseRootFromParent_Done,
     /* 2295213 */   // Label 31165: @2295213
     /* 2295213 */   GIM_Try, /*On fail goto*//*Label 31166*/ GIMT_Encode4(2295261), // Rule ID 52465 //
     /* 2295218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2295221 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2295224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2295238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295260 */     // GIR_Coverage, 52465,
     /* 2295260 */     GIR_EraseRootFromParent_Done,
     /* 2295261 */   // Label 31166: @2295261
     /* 2295261 */   GIM_Reject,
     /* 2295262 */ // Label 31164: @2295262
     /* 2295262 */ GIM_Reject,
     /* 2295263 */ // Label 31117: @2295263
     /* 2295263 */ GIM_Try, /*On fail goto*//*Label 31167*/ GIMT_Encode4(2295383),
     /* 2295268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2295271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2295274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295286 */   GIM_Try, /*On fail goto*//*Label 31168*/ GIMT_Encode4(2295334), // Rule ID 52408 //
     /* 2295291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295294 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2295297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2295311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295333 */     // GIR_Coverage, 52408,
     /* 2295333 */     GIR_EraseRootFromParent_Done,
     /* 2295334 */   // Label 31168: @2295334
     /* 2295334 */   GIM_Try, /*On fail goto*//*Label 31169*/ GIMT_Encode4(2295382), // Rule ID 52409 //
     /* 2295339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295342 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2295345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2295359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295381 */     // GIR_Coverage, 52409,
     /* 2295381 */     GIR_EraseRootFromParent_Done,
     /* 2295382 */   // Label 31169: @2295382
     /* 2295382 */   GIM_Reject,
     /* 2295383 */ // Label 31167: @2295383
     /* 2295383 */ GIM_Reject,
     /* 2295384 */ // Label 31118: @2295384
     /* 2295384 */ GIM_Try, /*On fail goto*//*Label 31170*/ GIMT_Encode4(2295504),
     /* 2295389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2295392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2295395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295407 */   GIM_Try, /*On fail goto*//*Label 31171*/ GIMT_Encode4(2295455), // Rule ID 52436 //
     /* 2295412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295415 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2295418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2295432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295454 */     // GIR_Coverage, 52436,
     /* 2295454 */     GIR_EraseRootFromParent_Done,
     /* 2295455 */   // Label 31171: @2295455
     /* 2295455 */   GIM_Try, /*On fail goto*//*Label 31172*/ GIMT_Encode4(2295503), // Rule ID 52437 //
     /* 2295460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295463 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2295466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2295480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295502 */     // GIR_Coverage, 52437,
     /* 2295502 */     GIR_EraseRootFromParent_Done,
     /* 2295503 */   // Label 31172: @2295503
     /* 2295503 */   GIM_Reject,
     /* 2295504 */ // Label 31170: @2295504
     /* 2295504 */ GIM_Reject,
     /* 2295505 */ // Label 31119: @2295505
     /* 2295505 */ GIM_Try, /*On fail goto*//*Label 31173*/ GIMT_Encode4(2295625),
     /* 2295510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2295513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2295516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295528 */   GIM_Try, /*On fail goto*//*Label 31174*/ GIMT_Encode4(2295576), // Rule ID 52452 //
     /* 2295533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295536 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2295539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2295553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295575 */     // GIR_Coverage, 52452,
     /* 2295575 */     GIR_EraseRootFromParent_Done,
     /* 2295576 */   // Label 31174: @2295576
     /* 2295576 */   GIM_Try, /*On fail goto*//*Label 31175*/ GIMT_Encode4(2295624), // Rule ID 52453 //
     /* 2295581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295584 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2295587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2295601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295623 */     // GIR_Coverage, 52453,
     /* 2295623 */     GIR_EraseRootFromParent_Done,
     /* 2295624 */   // Label 31175: @2295624
     /* 2295624 */   GIM_Reject,
     /* 2295625 */ // Label 31173: @2295625
     /* 2295625 */ GIM_Reject,
     /* 2295626 */ // Label 31120: @2295626
     /* 2295626 */ GIM_Try, /*On fail goto*//*Label 31176*/ GIMT_Encode4(2295746),
     /* 2295631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2295637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295649 */   GIM_Try, /*On fail goto*//*Label 31177*/ GIMT_Encode4(2295697), // Rule ID 52468 //
     /* 2295654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2295657 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2295660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2295674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295696 */     // GIR_Coverage, 52468,
     /* 2295696 */     GIR_EraseRootFromParent_Done,
     /* 2295697 */   // Label 31177: @2295697
     /* 2295697 */   GIM_Try, /*On fail goto*//*Label 31178*/ GIMT_Encode4(2295745), // Rule ID 52469 //
     /* 2295702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2295705 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2295708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2295722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295744 */     // GIR_Coverage, 52469,
     /* 2295744 */     GIR_EraseRootFromParent_Done,
     /* 2295745 */   // Label 31178: @2295745
     /* 2295745 */   GIM_Reject,
     /* 2295746 */ // Label 31176: @2295746
     /* 2295746 */ GIM_Reject,
     /* 2295747 */ // Label 31121: @2295747
     /* 2295747 */ GIM_Try, /*On fail goto*//*Label 31179*/ GIMT_Encode4(2295867),
     /* 2295752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2295755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2295758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295770 */   GIM_Try, /*On fail goto*//*Label 31180*/ GIMT_Encode4(2295818), // Rule ID 52424 //
     /* 2295775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295778 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2295781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2295795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295817 */     // GIR_Coverage, 52424,
     /* 2295817 */     GIR_EraseRootFromParent_Done,
     /* 2295818 */   // Label 31180: @2295818
     /* 2295818 */   GIM_Try, /*On fail goto*//*Label 31181*/ GIMT_Encode4(2295866), // Rule ID 52425 //
     /* 2295823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295826 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2295829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2295843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295865 */     // GIR_Coverage, 52425,
     /* 2295865 */     GIR_EraseRootFromParent_Done,
     /* 2295866 */   // Label 31181: @2295866
     /* 2295866 */   GIM_Reject,
     /* 2295867 */ // Label 31179: @2295867
     /* 2295867 */ GIM_Reject,
     /* 2295868 */ // Label 31122: @2295868
     /* 2295868 */ GIM_Try, /*On fail goto*//*Label 31182*/ GIMT_Encode4(2295988),
     /* 2295873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2295876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2295879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295891 */   GIM_Try, /*On fail goto*//*Label 31183*/ GIMT_Encode4(2295939), // Rule ID 52440 //
     /* 2295896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295899 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2295902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2295916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295938 */     // GIR_Coverage, 52440,
     /* 2295938 */     GIR_EraseRootFromParent_Done,
     /* 2295939 */   // Label 31183: @2295939
     /* 2295939 */   GIM_Try, /*On fail goto*//*Label 31184*/ GIMT_Encode4(2295987), // Rule ID 52441 //
     /* 2295944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295947 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2295950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2295964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295986 */     // GIR_Coverage, 52441,
     /* 2295986 */     GIR_EraseRootFromParent_Done,
     /* 2295987 */   // Label 31184: @2295987
     /* 2295987 */   GIM_Reject,
     /* 2295988 */ // Label 31182: @2295988
     /* 2295988 */ GIM_Reject,
     /* 2295989 */ // Label 31123: @2295989
     /* 2295989 */ GIM_Try, /*On fail goto*//*Label 31185*/ GIMT_Encode4(2296109),
     /* 2295994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2295997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2296000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296012 */   GIM_Try, /*On fail goto*//*Label 31186*/ GIMT_Encode4(2296060), // Rule ID 52456 //
     /* 2296017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296020 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2296023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2296037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296059 */     // GIR_Coverage, 52456,
     /* 2296059 */     GIR_EraseRootFromParent_Done,
     /* 2296060 */   // Label 31186: @2296060
     /* 2296060 */   GIM_Try, /*On fail goto*//*Label 31187*/ GIMT_Encode4(2296108), // Rule ID 52457 //
     /* 2296065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296068 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2296071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2296085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296107 */     // GIR_Coverage, 52457,
     /* 2296107 */     GIR_EraseRootFromParent_Done,
     /* 2296108 */   // Label 31187: @2296108
     /* 2296108 */   GIM_Reject,
     /* 2296109 */ // Label 31185: @2296109
     /* 2296109 */ GIM_Reject,
     /* 2296110 */ // Label 31124: @2296110
     /* 2296110 */ GIM_Try, /*On fail goto*//*Label 31188*/ GIMT_Encode4(2296230),
     /* 2296115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2296118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2296121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296133 */   GIM_Try, /*On fail goto*//*Label 31189*/ GIMT_Encode4(2296181), // Rule ID 52428 //
     /* 2296138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296141 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2296144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2296158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296180 */     // GIR_Coverage, 52428,
     /* 2296180 */     GIR_EraseRootFromParent_Done,
     /* 2296181 */   // Label 31189: @2296181
     /* 2296181 */   GIM_Try, /*On fail goto*//*Label 31190*/ GIMT_Encode4(2296229), // Rule ID 52429 //
     /* 2296186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296189 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2296192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2296206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296228 */     // GIR_Coverage, 52429,
     /* 2296228 */     GIR_EraseRootFromParent_Done,
     /* 2296229 */   // Label 31190: @2296229
     /* 2296229 */   GIM_Reject,
     /* 2296230 */ // Label 31188: @2296230
     /* 2296230 */ GIM_Reject,
     /* 2296231 */ // Label 31125: @2296231
     /* 2296231 */ GIM_Try, /*On fail goto*//*Label 31191*/ GIMT_Encode4(2296351),
     /* 2296236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2296239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2296242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296254 */   GIM_Try, /*On fail goto*//*Label 31192*/ GIMT_Encode4(2296302), // Rule ID 52444 //
     /* 2296259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296262 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2296265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2296279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296301 */     // GIR_Coverage, 52444,
     /* 2296301 */     GIR_EraseRootFromParent_Done,
     /* 2296302 */   // Label 31192: @2296302
     /* 2296302 */   GIM_Try, /*On fail goto*//*Label 31193*/ GIMT_Encode4(2296350), // Rule ID 52445 //
     /* 2296307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296310 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2296313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2296327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296349 */     // GIR_Coverage, 52445,
     /* 2296349 */     GIR_EraseRootFromParent_Done,
     /* 2296350 */   // Label 31193: @2296350
     /* 2296350 */   GIM_Reject,
     /* 2296351 */ // Label 31191: @2296351
     /* 2296351 */ GIM_Reject,
     /* 2296352 */ // Label 31126: @2296352
     /* 2296352 */ GIM_Try, /*On fail goto*//*Label 31194*/ GIMT_Encode4(2296472),
     /* 2296357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2296360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2296363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296375 */   GIM_Try, /*On fail goto*//*Label 31195*/ GIMT_Encode4(2296423), // Rule ID 52432 //
     /* 2296380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296383 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2296386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2296400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296422 */     // GIR_Coverage, 52432,
     /* 2296422 */     GIR_EraseRootFromParent_Done,
     /* 2296423 */   // Label 31195: @2296423
     /* 2296423 */   GIM_Try, /*On fail goto*//*Label 31196*/ GIMT_Encode4(2296471), // Rule ID 52433 //
     /* 2296428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296431 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2296434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2296448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296470 */     // GIR_Coverage, 52433,
     /* 2296470 */     GIR_EraseRootFromParent_Done,
     /* 2296471 */   // Label 31196: @2296471
     /* 2296471 */   GIM_Reject,
     /* 2296472 */ // Label 31194: @2296472
     /* 2296472 */ GIM_Reject,
     /* 2296473 */ // Label 31127: @2296473
     /* 2296473 */ GIM_Reject,
     /* 2296474 */ // Label 55: @2296474
     /* 2296474 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31220*/ GIMT_Encode4(2299326),
     /* 2296485 */ /*GILLT_s32*//*Label 31197*/ GIMT_Encode4(2296609), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296497 */ /*GILLT_nxv1s8*//*Label 31198*/ GIMT_Encode4(2296664),
     /* 2296501 */ /*GILLT_nxv1s16*//*Label 31199*/ GIMT_Encode4(2296785),
     /* 2296505 */ /*GILLT_nxv1s32*//*Label 31200*/ GIMT_Encode4(2296906),
     /* 2296509 */ /*GILLT_nxv1s64*//*Label 31201*/ GIMT_Encode4(2297027), GIMT_Encode4(0),
     /* 2296517 */ /*GILLT_nxv2s8*//*Label 31202*/ GIMT_Encode4(2297148),
     /* 2296521 */ /*GILLT_nxv2s16*//*Label 31203*/ GIMT_Encode4(2297269),
     /* 2296525 */ /*GILLT_nxv2s32*//*Label 31204*/ GIMT_Encode4(2297390),
     /* 2296529 */ /*GILLT_nxv2s64*//*Label 31205*/ GIMT_Encode4(2297511), GIMT_Encode4(0),
     /* 2296537 */ /*GILLT_nxv4s8*//*Label 31206*/ GIMT_Encode4(2297632),
     /* 2296541 */ /*GILLT_nxv4s16*//*Label 31207*/ GIMT_Encode4(2297753),
     /* 2296545 */ /*GILLT_nxv4s32*//*Label 31208*/ GIMT_Encode4(2297874),
     /* 2296549 */ /*GILLT_nxv4s64*//*Label 31209*/ GIMT_Encode4(2297995), GIMT_Encode4(0),
     /* 2296557 */ /*GILLT_nxv8s8*//*Label 31210*/ GIMT_Encode4(2298116),
     /* 2296561 */ /*GILLT_nxv8s16*//*Label 31211*/ GIMT_Encode4(2298237),
     /* 2296565 */ /*GILLT_nxv8s32*//*Label 31212*/ GIMT_Encode4(2298358),
     /* 2296569 */ /*GILLT_nxv8s64*//*Label 31213*/ GIMT_Encode4(2298479), GIMT_Encode4(0),
     /* 2296577 */ /*GILLT_nxv16s8*//*Label 31214*/ GIMT_Encode4(2298600),
     /* 2296581 */ /*GILLT_nxv16s16*//*Label 31215*/ GIMT_Encode4(2298721),
     /* 2296585 */ /*GILLT_nxv16s32*//*Label 31216*/ GIMT_Encode4(2298842), GIMT_Encode4(0),
     /* 2296593 */ /*GILLT_nxv32s8*//*Label 31217*/ GIMT_Encode4(2298963),
     /* 2296597 */ /*GILLT_nxv32s16*//*Label 31218*/ GIMT_Encode4(2299084), GIMT_Encode4(0),
     /* 2296605 */ /*GILLT_nxv64s8*//*Label 31219*/ GIMT_Encode4(2299205),
     /* 2296609 */ // Label 31197: @2296609
     /* 2296609 */ GIM_Try, /*On fail goto*//*Label 31221*/ GIMT_Encode4(2296663),
     /* 2296614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2296617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2296620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296632 */   GIM_Try, /*On fail goto*//*Label 31222*/ GIMT_Encode4(2296647), // Rule ID 64599 //
     /* 2296637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2296640 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2296640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2296645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296646 */     // GIR_Coverage, 64599,
     /* 2296646 */     GIR_Done,
     /* 2296647 */   // Label 31222: @2296647
     /* 2296647 */   GIM_Try, /*On fail goto*//*Label 31223*/ GIMT_Encode4(2296662), // Rule ID 64600 //
     /* 2296652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2296655 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2296655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2296660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296661 */     // GIR_Coverage, 64600,
     /* 2296661 */     GIR_Done,
     /* 2296662 */   // Label 31223: @2296662
     /* 2296662 */   GIM_Reject,
     /* 2296663 */ // Label 31221: @2296663
     /* 2296663 */ GIM_Reject,
     /* 2296664 */ // Label 31198: @2296664
     /* 2296664 */ GIM_Try, /*On fail goto*//*Label 31224*/ GIMT_Encode4(2296784),
     /* 2296669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2296672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2296675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296687 */   GIM_Try, /*On fail goto*//*Label 31225*/ GIMT_Encode4(2296735), // Rule ID 52736 //
     /* 2296692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296695 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2296698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2296712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296734 */     // GIR_Coverage, 52736,
     /* 2296734 */     GIR_EraseRootFromParent_Done,
     /* 2296735 */   // Label 31225: @2296735
     /* 2296735 */   GIM_Try, /*On fail goto*//*Label 31226*/ GIMT_Encode4(2296783), // Rule ID 52737 //
     /* 2296740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296743 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2296746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2296760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296782 */     // GIR_Coverage, 52737,
     /* 2296782 */     GIR_EraseRootFromParent_Done,
     /* 2296783 */   // Label 31226: @2296783
     /* 2296783 */   GIM_Reject,
     /* 2296784 */ // Label 31224: @2296784
     /* 2296784 */ GIM_Reject,
     /* 2296785 */ // Label 31199: @2296785
     /* 2296785 */ GIM_Try, /*On fail goto*//*Label 31227*/ GIMT_Encode4(2296905),
     /* 2296790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2296793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2296796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296808 */   GIM_Try, /*On fail goto*//*Label 31228*/ GIMT_Encode4(2296856), // Rule ID 52748 //
     /* 2296813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296816 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2296819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2296833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296855 */     // GIR_Coverage, 52748,
     /* 2296855 */     GIR_EraseRootFromParent_Done,
     /* 2296856 */   // Label 31228: @2296856
     /* 2296856 */   GIM_Try, /*On fail goto*//*Label 31229*/ GIMT_Encode4(2296904), // Rule ID 52749 //
     /* 2296861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296864 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2296867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2296881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296903 */     // GIR_Coverage, 52749,
     /* 2296903 */     GIR_EraseRootFromParent_Done,
     /* 2296904 */   // Label 31229: @2296904
     /* 2296904 */   GIM_Reject,
     /* 2296905 */ // Label 31227: @2296905
     /* 2296905 */ GIM_Reject,
     /* 2296906 */ // Label 31200: @2296906
     /* 2296906 */ GIM_Try, /*On fail goto*//*Label 31230*/ GIMT_Encode4(2297026),
     /* 2296911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2296914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2296917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296929 */   GIM_Try, /*On fail goto*//*Label 31231*/ GIMT_Encode4(2296977), // Rule ID 52756 //
     /* 2296934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296937 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2296940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2296954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296976 */     // GIR_Coverage, 52756,
     /* 2296976 */     GIR_EraseRootFromParent_Done,
     /* 2296977 */   // Label 31231: @2296977
     /* 2296977 */   GIM_Try, /*On fail goto*//*Label 31232*/ GIMT_Encode4(2297025), // Rule ID 52757 //
     /* 2296982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296985 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2296988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2297002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297024 */     // GIR_Coverage, 52757,
     /* 2297024 */     GIR_EraseRootFromParent_Done,
     /* 2297025 */   // Label 31232: @2297025
     /* 2297025 */   GIM_Reject,
     /* 2297026 */ // Label 31230: @2297026
     /* 2297026 */ GIM_Reject,
     /* 2297027 */ // Label 31201: @2297027
     /* 2297027 */ GIM_Try, /*On fail goto*//*Label 31233*/ GIMT_Encode4(2297147),
     /* 2297032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2297035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2297038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297050 */   GIM_Try, /*On fail goto*//*Label 31234*/ GIMT_Encode4(2297098), // Rule ID 52772 //
     /* 2297055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2297058 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2297061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2297075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297097 */     // GIR_Coverage, 52772,
     /* 2297097 */     GIR_EraseRootFromParent_Done,
     /* 2297098 */   // Label 31234: @2297098
     /* 2297098 */   GIM_Try, /*On fail goto*//*Label 31235*/ GIMT_Encode4(2297146), // Rule ID 52773 //
     /* 2297103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2297106 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2297109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2297123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297145 */     // GIR_Coverage, 52773,
     /* 2297145 */     GIR_EraseRootFromParent_Done,
     /* 2297146 */   // Label 31235: @2297146
     /* 2297146 */   GIM_Reject,
     /* 2297147 */ // Label 31233: @2297147
     /* 2297147 */ GIM_Reject,
     /* 2297148 */ // Label 31202: @2297148
     /* 2297148 */ GIM_Try, /*On fail goto*//*Label 31236*/ GIMT_Encode4(2297268),
     /* 2297153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2297156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2297159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297167 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297171 */   GIM_Try, /*On fail goto*//*Label 31237*/ GIMT_Encode4(2297219), // Rule ID 52740 //
     /* 2297176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297179 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2297182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2297196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297218 */     // GIR_Coverage, 52740,
     /* 2297218 */     GIR_EraseRootFromParent_Done,
     /* 2297219 */   // Label 31237: @2297219
     /* 2297219 */   GIM_Try, /*On fail goto*//*Label 31238*/ GIMT_Encode4(2297267), // Rule ID 52741 //
     /* 2297224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297227 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2297230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2297244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297266 */     // GIR_Coverage, 52741,
     /* 2297266 */     GIR_EraseRootFromParent_Done,
     /* 2297267 */   // Label 31238: @2297267
     /* 2297267 */   GIM_Reject,
     /* 2297268 */ // Label 31236: @2297268
     /* 2297268 */ GIM_Reject,
     /* 2297269 */ // Label 31203: @2297269
     /* 2297269 */ GIM_Try, /*On fail goto*//*Label 31239*/ GIMT_Encode4(2297389),
     /* 2297274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2297277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2297280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297292 */   GIM_Try, /*On fail goto*//*Label 31240*/ GIMT_Encode4(2297340), // Rule ID 52752 //
     /* 2297297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297300 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2297303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2297317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297339 */     // GIR_Coverage, 52752,
     /* 2297339 */     GIR_EraseRootFromParent_Done,
     /* 2297340 */   // Label 31240: @2297340
     /* 2297340 */   GIM_Try, /*On fail goto*//*Label 31241*/ GIMT_Encode4(2297388), // Rule ID 52753 //
     /* 2297345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297348 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2297351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2297365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297387 */     // GIR_Coverage, 52753,
     /* 2297387 */     GIR_EraseRootFromParent_Done,
     /* 2297388 */   // Label 31241: @2297388
     /* 2297388 */   GIM_Reject,
     /* 2297389 */ // Label 31239: @2297389
     /* 2297389 */ GIM_Reject,
     /* 2297390 */ // Label 31204: @2297390
     /* 2297390 */ GIM_Try, /*On fail goto*//*Label 31242*/ GIMT_Encode4(2297510),
     /* 2297395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2297398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2297401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297413 */   GIM_Try, /*On fail goto*//*Label 31243*/ GIMT_Encode4(2297461), // Rule ID 52768 //
     /* 2297418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297421 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2297424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2297438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297460 */     // GIR_Coverage, 52768,
     /* 2297460 */     GIR_EraseRootFromParent_Done,
     /* 2297461 */   // Label 31243: @2297461
     /* 2297461 */   GIM_Try, /*On fail goto*//*Label 31244*/ GIMT_Encode4(2297509), // Rule ID 52769 //
     /* 2297466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297469 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2297472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2297486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297508 */     // GIR_Coverage, 52769,
     /* 2297508 */     GIR_EraseRootFromParent_Done,
     /* 2297509 */   // Label 31244: @2297509
     /* 2297509 */   GIM_Reject,
     /* 2297510 */ // Label 31242: @2297510
     /* 2297510 */ GIM_Reject,
     /* 2297511 */ // Label 31205: @2297511
     /* 2297511 */ GIM_Try, /*On fail goto*//*Label 31245*/ GIMT_Encode4(2297631),
     /* 2297516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2297522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297534 */   GIM_Try, /*On fail goto*//*Label 31246*/ GIMT_Encode4(2297582), // Rule ID 52812 //
     /* 2297539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2297542 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2297545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2297559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297581 */     // GIR_Coverage, 52812,
     /* 2297581 */     GIR_EraseRootFromParent_Done,
     /* 2297582 */   // Label 31246: @2297582
     /* 2297582 */   GIM_Try, /*On fail goto*//*Label 31247*/ GIMT_Encode4(2297630), // Rule ID 52813 //
     /* 2297587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2297590 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2297593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2297607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297629 */     // GIR_Coverage, 52813,
     /* 2297629 */     GIR_EraseRootFromParent_Done,
     /* 2297630 */   // Label 31247: @2297630
     /* 2297630 */   GIM_Reject,
     /* 2297631 */ // Label 31245: @2297631
     /* 2297631 */ GIM_Reject,
     /* 2297632 */ // Label 31206: @2297632
     /* 2297632 */ GIM_Try, /*On fail goto*//*Label 31248*/ GIMT_Encode4(2297752),
     /* 2297637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2297640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2297643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297655 */   GIM_Try, /*On fail goto*//*Label 31249*/ GIMT_Encode4(2297703), // Rule ID 52744 //
     /* 2297660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297663 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2297666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2297680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297702 */     // GIR_Coverage, 52744,
     /* 2297702 */     GIR_EraseRootFromParent_Done,
     /* 2297703 */   // Label 31249: @2297703
     /* 2297703 */   GIM_Try, /*On fail goto*//*Label 31250*/ GIMT_Encode4(2297751), // Rule ID 52745 //
     /* 2297708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297711 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2297714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2297728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297750 */     // GIR_Coverage, 52745,
     /* 2297750 */     GIR_EraseRootFromParent_Done,
     /* 2297751 */   // Label 31250: @2297751
     /* 2297751 */   GIM_Reject,
     /* 2297752 */ // Label 31248: @2297752
     /* 2297752 */ GIM_Reject,
     /* 2297753 */ // Label 31207: @2297753
     /* 2297753 */ GIM_Try, /*On fail goto*//*Label 31251*/ GIMT_Encode4(2297873),
     /* 2297758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2297764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297776 */   GIM_Try, /*On fail goto*//*Label 31252*/ GIMT_Encode4(2297824), // Rule ID 52764 //
     /* 2297781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297784 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2297787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2297801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297823 */     // GIR_Coverage, 52764,
     /* 2297823 */     GIR_EraseRootFromParent_Done,
     /* 2297824 */   // Label 31252: @2297824
     /* 2297824 */   GIM_Try, /*On fail goto*//*Label 31253*/ GIMT_Encode4(2297872), // Rule ID 52765 //
     /* 2297829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297832 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2297835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2297849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297871 */     // GIR_Coverage, 52765,
     /* 2297871 */     GIR_EraseRootFromParent_Done,
     /* 2297872 */   // Label 31253: @2297872
     /* 2297872 */   GIM_Reject,
     /* 2297873 */ // Label 31251: @2297873
     /* 2297873 */ GIM_Reject,
     /* 2297874 */ // Label 31208: @2297874
     /* 2297874 */ GIM_Try, /*On fail goto*//*Label 31254*/ GIMT_Encode4(2297994),
     /* 2297879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2297882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2297885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297897 */   GIM_Try, /*On fail goto*//*Label 31255*/ GIMT_Encode4(2297945), // Rule ID 52800 //
     /* 2297902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297905 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2297908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2297922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297944 */     // GIR_Coverage, 52800,
     /* 2297944 */     GIR_EraseRootFromParent_Done,
     /* 2297945 */   // Label 31255: @2297945
     /* 2297945 */   GIM_Try, /*On fail goto*//*Label 31256*/ GIMT_Encode4(2297993), // Rule ID 52801 //
     /* 2297950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297953 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2297956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2297970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297992 */     // GIR_Coverage, 52801,
     /* 2297992 */     GIR_EraseRootFromParent_Done,
     /* 2297993 */   // Label 31256: @2297993
     /* 2297993 */   GIM_Reject,
     /* 2297994 */ // Label 31254: @2297994
     /* 2297994 */ GIM_Reject,
     /* 2297995 */ // Label 31209: @2297995
     /* 2297995 */ GIM_Try, /*On fail goto*//*Label 31257*/ GIMT_Encode4(2298115),
     /* 2298000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2298003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2298006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298018 */   GIM_Try, /*On fail goto*//*Label 31258*/ GIMT_Encode4(2298066), // Rule ID 52816 //
     /* 2298023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2298026 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2298029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2298043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298065 */     // GIR_Coverage, 52816,
     /* 2298065 */     GIR_EraseRootFromParent_Done,
     /* 2298066 */   // Label 31258: @2298066
     /* 2298066 */   GIM_Try, /*On fail goto*//*Label 31259*/ GIMT_Encode4(2298114), // Rule ID 52817 //
     /* 2298071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2298074 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2298077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2298091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298113 */     // GIR_Coverage, 52817,
     /* 2298113 */     GIR_EraseRootFromParent_Done,
     /* 2298114 */   // Label 31259: @2298114
     /* 2298114 */   GIM_Reject,
     /* 2298115 */ // Label 31257: @2298115
     /* 2298115 */ GIM_Reject,
     /* 2298116 */ // Label 31210: @2298116
     /* 2298116 */ GIM_Try, /*On fail goto*//*Label 31260*/ GIMT_Encode4(2298236),
     /* 2298121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2298124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2298127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298139 */   GIM_Try, /*On fail goto*//*Label 31261*/ GIMT_Encode4(2298187), // Rule ID 52760 //
     /* 2298144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298147 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2298150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2298164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298186 */     // GIR_Coverage, 52760,
     /* 2298186 */     GIR_EraseRootFromParent_Done,
     /* 2298187 */   // Label 31261: @2298187
     /* 2298187 */   GIM_Try, /*On fail goto*//*Label 31262*/ GIMT_Encode4(2298235), // Rule ID 52761 //
     /* 2298192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298195 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2298198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2298212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298234 */     // GIR_Coverage, 52761,
     /* 2298234 */     GIR_EraseRootFromParent_Done,
     /* 2298235 */   // Label 31262: @2298235
     /* 2298235 */   GIM_Reject,
     /* 2298236 */ // Label 31260: @2298236
     /* 2298236 */ GIM_Reject,
     /* 2298237 */ // Label 31211: @2298237
     /* 2298237 */ GIM_Try, /*On fail goto*//*Label 31263*/ GIMT_Encode4(2298357),
     /* 2298242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2298245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2298248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298260 */   GIM_Try, /*On fail goto*//*Label 31264*/ GIMT_Encode4(2298308), // Rule ID 52788 //
     /* 2298265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298268 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2298271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2298285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298307 */     // GIR_Coverage, 52788,
     /* 2298307 */     GIR_EraseRootFromParent_Done,
     /* 2298308 */   // Label 31264: @2298308
     /* 2298308 */   GIM_Try, /*On fail goto*//*Label 31265*/ GIMT_Encode4(2298356), // Rule ID 52789 //
     /* 2298313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298316 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2298319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2298333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298355 */     // GIR_Coverage, 52789,
     /* 2298355 */     GIR_EraseRootFromParent_Done,
     /* 2298356 */   // Label 31265: @2298356
     /* 2298356 */   GIM_Reject,
     /* 2298357 */ // Label 31263: @2298357
     /* 2298357 */ GIM_Reject,
     /* 2298358 */ // Label 31212: @2298358
     /* 2298358 */ GIM_Try, /*On fail goto*//*Label 31266*/ GIMT_Encode4(2298478),
     /* 2298363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2298366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2298369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298381 */   GIM_Try, /*On fail goto*//*Label 31267*/ GIMT_Encode4(2298429), // Rule ID 52804 //
     /* 2298386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298389 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2298392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2298406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298428 */     // GIR_Coverage, 52804,
     /* 2298428 */     GIR_EraseRootFromParent_Done,
     /* 2298429 */   // Label 31267: @2298429
     /* 2298429 */   GIM_Try, /*On fail goto*//*Label 31268*/ GIMT_Encode4(2298477), // Rule ID 52805 //
     /* 2298434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298437 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2298440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2298454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298476 */     // GIR_Coverage, 52805,
     /* 2298476 */     GIR_EraseRootFromParent_Done,
     /* 2298477 */   // Label 31268: @2298477
     /* 2298477 */   GIM_Reject,
     /* 2298478 */ // Label 31266: @2298478
     /* 2298478 */ GIM_Reject,
     /* 2298479 */ // Label 31213: @2298479
     /* 2298479 */ GIM_Try, /*On fail goto*//*Label 31269*/ GIMT_Encode4(2298599),
     /* 2298484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2298487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2298490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298502 */   GIM_Try, /*On fail goto*//*Label 31270*/ GIMT_Encode4(2298550), // Rule ID 52820 //
     /* 2298507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2298510 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2298513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2298527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298549 */     // GIR_Coverage, 52820,
     /* 2298549 */     GIR_EraseRootFromParent_Done,
     /* 2298550 */   // Label 31270: @2298550
     /* 2298550 */   GIM_Try, /*On fail goto*//*Label 31271*/ GIMT_Encode4(2298598), // Rule ID 52821 //
     /* 2298555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2298558 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2298561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2298575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298597 */     // GIR_Coverage, 52821,
     /* 2298597 */     GIR_EraseRootFromParent_Done,
     /* 2298598 */   // Label 31271: @2298598
     /* 2298598 */   GIM_Reject,
     /* 2298599 */ // Label 31269: @2298599
     /* 2298599 */ GIM_Reject,
     /* 2298600 */ // Label 31214: @2298600
     /* 2298600 */ GIM_Try, /*On fail goto*//*Label 31272*/ GIMT_Encode4(2298720),
     /* 2298605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2298608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2298611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298623 */   GIM_Try, /*On fail goto*//*Label 31273*/ GIMT_Encode4(2298671), // Rule ID 52776 //
     /* 2298628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298631 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2298634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2298648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298670 */     // GIR_Coverage, 52776,
     /* 2298670 */     GIR_EraseRootFromParent_Done,
     /* 2298671 */   // Label 31273: @2298671
     /* 2298671 */   GIM_Try, /*On fail goto*//*Label 31274*/ GIMT_Encode4(2298719), // Rule ID 52777 //
     /* 2298676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298679 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2298682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2298696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298718 */     // GIR_Coverage, 52777,
     /* 2298718 */     GIR_EraseRootFromParent_Done,
     /* 2298719 */   // Label 31274: @2298719
     /* 2298719 */   GIM_Reject,
     /* 2298720 */ // Label 31272: @2298720
     /* 2298720 */ GIM_Reject,
     /* 2298721 */ // Label 31215: @2298721
     /* 2298721 */ GIM_Try, /*On fail goto*//*Label 31275*/ GIMT_Encode4(2298841),
     /* 2298726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2298729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2298732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298744 */   GIM_Try, /*On fail goto*//*Label 31276*/ GIMT_Encode4(2298792), // Rule ID 52792 //
     /* 2298749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298752 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2298755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2298769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298791 */     // GIR_Coverage, 52792,
     /* 2298791 */     GIR_EraseRootFromParent_Done,
     /* 2298792 */   // Label 31276: @2298792
     /* 2298792 */   GIM_Try, /*On fail goto*//*Label 31277*/ GIMT_Encode4(2298840), // Rule ID 52793 //
     /* 2298797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298800 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2298803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2298817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298839 */     // GIR_Coverage, 52793,
     /* 2298839 */     GIR_EraseRootFromParent_Done,
     /* 2298840 */   // Label 31277: @2298840
     /* 2298840 */   GIM_Reject,
     /* 2298841 */ // Label 31275: @2298841
     /* 2298841 */ GIM_Reject,
     /* 2298842 */ // Label 31216: @2298842
     /* 2298842 */ GIM_Try, /*On fail goto*//*Label 31278*/ GIMT_Encode4(2298962),
     /* 2298847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2298850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2298853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298865 */   GIM_Try, /*On fail goto*//*Label 31279*/ GIMT_Encode4(2298913), // Rule ID 52808 //
     /* 2298870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298873 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2298876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2298890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298912 */     // GIR_Coverage, 52808,
     /* 2298912 */     GIR_EraseRootFromParent_Done,
     /* 2298913 */   // Label 31279: @2298913
     /* 2298913 */   GIM_Try, /*On fail goto*//*Label 31280*/ GIMT_Encode4(2298961), // Rule ID 52809 //
     /* 2298918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298921 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2298924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2298938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298960 */     // GIR_Coverage, 52809,
     /* 2298960 */     GIR_EraseRootFromParent_Done,
     /* 2298961 */   // Label 31280: @2298961
     /* 2298961 */   GIM_Reject,
     /* 2298962 */ // Label 31278: @2298962
     /* 2298962 */ GIM_Reject,
     /* 2298963 */ // Label 31217: @2298963
     /* 2298963 */ GIM_Try, /*On fail goto*//*Label 31281*/ GIMT_Encode4(2299083),
     /* 2298968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2298971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2298974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298986 */   GIM_Try, /*On fail goto*//*Label 31282*/ GIMT_Encode4(2299034), // Rule ID 52780 //
     /* 2298991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298994 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2298997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2299011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299033 */     // GIR_Coverage, 52780,
     /* 2299033 */     GIR_EraseRootFromParent_Done,
     /* 2299034 */   // Label 31282: @2299034
     /* 2299034 */   GIM_Try, /*On fail goto*//*Label 31283*/ GIMT_Encode4(2299082), // Rule ID 52781 //
     /* 2299039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2299042 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2299045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2299059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299081 */     // GIR_Coverage, 52781,
     /* 2299081 */     GIR_EraseRootFromParent_Done,
     /* 2299082 */   // Label 31283: @2299082
     /* 2299082 */   GIM_Reject,
     /* 2299083 */ // Label 31281: @2299083
     /* 2299083 */ GIM_Reject,
     /* 2299084 */ // Label 31218: @2299084
     /* 2299084 */ GIM_Try, /*On fail goto*//*Label 31284*/ GIMT_Encode4(2299204),
     /* 2299089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2299092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2299095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2299099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2299103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2299107 */   GIM_Try, /*On fail goto*//*Label 31285*/ GIMT_Encode4(2299155), // Rule ID 52796 //
     /* 2299112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2299115 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2299118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2299132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299154 */     // GIR_Coverage, 52796,
     /* 2299154 */     GIR_EraseRootFromParent_Done,
     /* 2299155 */   // Label 31285: @2299155
     /* 2299155 */   GIM_Try, /*On fail goto*//*Label 31286*/ GIMT_Encode4(2299203), // Rule ID 52797 //
     /* 2299160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2299163 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2299166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2299180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299202 */     // GIR_Coverage, 52797,
     /* 2299202 */     GIR_EraseRootFromParent_Done,
     /* 2299203 */   // Label 31286: @2299203
     /* 2299203 */   GIM_Reject,
     /* 2299204 */ // Label 31284: @2299204
     /* 2299204 */ GIM_Reject,
     /* 2299205 */ // Label 31219: @2299205
     /* 2299205 */ GIM_Try, /*On fail goto*//*Label 31287*/ GIMT_Encode4(2299325),
     /* 2299210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2299213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2299216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2299220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2299224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2299228 */   GIM_Try, /*On fail goto*//*Label 31288*/ GIMT_Encode4(2299276), // Rule ID 52784 //
     /* 2299233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2299236 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2299239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2299253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299275 */     // GIR_Coverage, 52784,
     /* 2299275 */     GIR_EraseRootFromParent_Done,
     /* 2299276 */   // Label 31288: @2299276
     /* 2299276 */   GIM_Try, /*On fail goto*//*Label 31289*/ GIMT_Encode4(2299324), // Rule ID 52785 //
     /* 2299281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2299284 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2299287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2299301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299323 */     // GIR_Coverage, 52785,
     /* 2299323 */     GIR_EraseRootFromParent_Done,
     /* 2299324 */   // Label 31289: @2299324
     /* 2299324 */   GIM_Reject,
     /* 2299325 */ // Label 31287: @2299325
     /* 2299325 */ GIM_Reject,
     /* 2299326 */ // Label 31220: @2299326
     /* 2299326 */ GIM_Reject,
     /* 2299327 */ // Label 56: @2299327
     /* 2299327 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31313*/ GIMT_Encode4(2302179),
     /* 2299338 */ /*GILLT_s32*//*Label 31290*/ GIMT_Encode4(2299462), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2299350 */ /*GILLT_nxv1s8*//*Label 31291*/ GIMT_Encode4(2299517),
     /* 2299354 */ /*GILLT_nxv1s16*//*Label 31292*/ GIMT_Encode4(2299638),
     /* 2299358 */ /*GILLT_nxv1s32*//*Label 31293*/ GIMT_Encode4(2299759),
     /* 2299362 */ /*GILLT_nxv1s64*//*Label 31294*/ GIMT_Encode4(2299880), GIMT_Encode4(0),
     /* 2299370 */ /*GILLT_nxv2s8*//*Label 31295*/ GIMT_Encode4(2300001),
     /* 2299374 */ /*GILLT_nxv2s16*//*Label 31296*/ GIMT_Encode4(2300122),
     /* 2299378 */ /*GILLT_nxv2s32*//*Label 31297*/ GIMT_Encode4(2300243),
     /* 2299382 */ /*GILLT_nxv2s64*//*Label 31298*/ GIMT_Encode4(2300364), GIMT_Encode4(0),
     /* 2299390 */ /*GILLT_nxv4s8*//*Label 31299*/ GIMT_Encode4(2300485),
     /* 2299394 */ /*GILLT_nxv4s16*//*Label 31300*/ GIMT_Encode4(2300606),
     /* 2299398 */ /*GILLT_nxv4s32*//*Label 31301*/ GIMT_Encode4(2300727),
     /* 2299402 */ /*GILLT_nxv4s64*//*Label 31302*/ GIMT_Encode4(2300848), GIMT_Encode4(0),
     /* 2299410 */ /*GILLT_nxv8s8*//*Label 31303*/ GIMT_Encode4(2300969),
     /* 2299414 */ /*GILLT_nxv8s16*//*Label 31304*/ GIMT_Encode4(2301090),
     /* 2299418 */ /*GILLT_nxv8s32*//*Label 31305*/ GIMT_Encode4(2301211),
     /* 2299422 */ /*GILLT_nxv8s64*//*Label 31306*/ GIMT_Encode4(2301332), GIMT_Encode4(0),
     /* 2299430 */ /*GILLT_nxv16s8*//*Label 31307*/ GIMT_Encode4(2301453),
     /* 2299434 */ /*GILLT_nxv16s16*//*Label 31308*/ GIMT_Encode4(2301574),
     /* 2299438 */ /*GILLT_nxv16s32*//*Label 31309*/ GIMT_Encode4(2301695), GIMT_Encode4(0),
     /* 2299446 */ /*GILLT_nxv32s8*//*Label 31310*/ GIMT_Encode4(2301816),
     /* 2299450 */ /*GILLT_nxv32s16*//*Label 31311*/ GIMT_Encode4(2301937), GIMT_Encode4(0),
     /* 2299458 */ /*GILLT_nxv64s8*//*Label 31312*/ GIMT_Encode4(2302058),
     /* 2299462 */ // Label 31290: @2299462
     /* 2299462 */ GIM_Try, /*On fail goto*//*Label 31314*/ GIMT_Encode4(2299516),
     /* 2299467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2299470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2299473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2299477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2299481 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2299485 */   GIM_Try, /*On fail goto*//*Label 31315*/ GIMT_Encode4(2299500), // Rule ID 64597 //
     /* 2299490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2299493 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2299493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2299498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299499 */     // GIR_Coverage, 64597,
     /* 2299499 */     GIR_Done,
     /* 2299500 */   // Label 31315: @2299500
     /* 2299500 */   GIM_Try, /*On fail goto*//*Label 31316*/ GIMT_Encode4(2299515), // Rule ID 64598 //
     /* 2299505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2299508 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2299508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2299513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299514 */     // GIR_Coverage, 64598,
     /* 2299514 */     GIR_Done,
     /* 2299515 */   // Label 31316: @2299515
     /* 2299515 */   GIM_Reject,
     /* 2299516 */ // Label 31314: @2299516
     /* 2299516 */ GIM_Reject,
     /* 2299517 */ // Label 31291: @2299517
     /* 2299517 */ GIM_Try, /*On fail goto*//*Label 31317*/ GIMT_Encode4(2299637),
     /* 2299522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2299525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2299528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299540 */   GIM_Try, /*On fail goto*//*Label 31318*/ GIMT_Encode4(2299588), // Rule ID 52648 //
     /* 2299545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2299548 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2299551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2299565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299587 */     // GIR_Coverage, 52648,
     /* 2299587 */     GIR_EraseRootFromParent_Done,
     /* 2299588 */   // Label 31318: @2299588
     /* 2299588 */   GIM_Try, /*On fail goto*//*Label 31319*/ GIMT_Encode4(2299636), // Rule ID 52649 //
     /* 2299593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2299596 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2299599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2299613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299635 */     // GIR_Coverage, 52649,
     /* 2299635 */     GIR_EraseRootFromParent_Done,
     /* 2299636 */   // Label 31319: @2299636
     /* 2299636 */   GIM_Reject,
     /* 2299637 */ // Label 31317: @2299637
     /* 2299637 */ GIM_Reject,
     /* 2299638 */ // Label 31292: @2299638
     /* 2299638 */ GIM_Try, /*On fail goto*//*Label 31320*/ GIMT_Encode4(2299758),
     /* 2299643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2299646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2299649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299661 */   GIM_Try, /*On fail goto*//*Label 31321*/ GIMT_Encode4(2299709), // Rule ID 52660 //
     /* 2299666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2299669 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2299672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2299686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299708 */     // GIR_Coverage, 52660,
     /* 2299708 */     GIR_EraseRootFromParent_Done,
     /* 2299709 */   // Label 31321: @2299709
     /* 2299709 */   GIM_Try, /*On fail goto*//*Label 31322*/ GIMT_Encode4(2299757), // Rule ID 52661 //
     /* 2299714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2299717 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2299720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2299734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299756 */     // GIR_Coverage, 52661,
     /* 2299756 */     GIR_EraseRootFromParent_Done,
     /* 2299757 */   // Label 31322: @2299757
     /* 2299757 */   GIM_Reject,
     /* 2299758 */ // Label 31320: @2299758
     /* 2299758 */ GIM_Reject,
     /* 2299759 */ // Label 31293: @2299759
     /* 2299759 */ GIM_Try, /*On fail goto*//*Label 31323*/ GIMT_Encode4(2299879),
     /* 2299764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2299767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2299770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299778 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299782 */   GIM_Try, /*On fail goto*//*Label 31324*/ GIMT_Encode4(2299830), // Rule ID 52668 //
     /* 2299787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2299790 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2299793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2299807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299829 */     // GIR_Coverage, 52668,
     /* 2299829 */     GIR_EraseRootFromParent_Done,
     /* 2299830 */   // Label 31324: @2299830
     /* 2299830 */   GIM_Try, /*On fail goto*//*Label 31325*/ GIMT_Encode4(2299878), // Rule ID 52669 //
     /* 2299835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2299838 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2299841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2299855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299877 */     // GIR_Coverage, 52669,
     /* 2299877 */     GIR_EraseRootFromParent_Done,
     /* 2299878 */   // Label 31325: @2299878
     /* 2299878 */   GIM_Reject,
     /* 2299879 */ // Label 31323: @2299879
     /* 2299879 */ GIM_Reject,
     /* 2299880 */ // Label 31294: @2299880
     /* 2299880 */ GIM_Try, /*On fail goto*//*Label 31326*/ GIMT_Encode4(2300000),
     /* 2299885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2299891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299903 */   GIM_Try, /*On fail goto*//*Label 31327*/ GIMT_Encode4(2299951), // Rule ID 52684 //
     /* 2299908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2299911 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2299914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2299928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299950 */     // GIR_Coverage, 52684,
     /* 2299950 */     GIR_EraseRootFromParent_Done,
     /* 2299951 */   // Label 31327: @2299951
     /* 2299951 */   GIM_Try, /*On fail goto*//*Label 31328*/ GIMT_Encode4(2299999), // Rule ID 52685 //
     /* 2299956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2299959 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2299962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2299976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299998 */     // GIR_Coverage, 52685,
     /* 2299998 */     GIR_EraseRootFromParent_Done,
     /* 2299999 */   // Label 31328: @2299999
     /* 2299999 */   GIM_Reject,
     /* 2300000 */ // Label 31326: @2300000
     /* 2300000 */ GIM_Reject,
     /* 2300001 */ // Label 31295: @2300001
     /* 2300001 */ GIM_Try, /*On fail goto*//*Label 31329*/ GIMT_Encode4(2300121),
     /* 2300006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2300009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2300012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300024 */   GIM_Try, /*On fail goto*//*Label 31330*/ GIMT_Encode4(2300072), // Rule ID 52652 //
     /* 2300029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300032 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2300035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2300049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300071 */     // GIR_Coverage, 52652,
     /* 2300071 */     GIR_EraseRootFromParent_Done,
     /* 2300072 */   // Label 31330: @2300072
     /* 2300072 */   GIM_Try, /*On fail goto*//*Label 31331*/ GIMT_Encode4(2300120), // Rule ID 52653 //
     /* 2300077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2300080 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2300083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2300097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300119 */     // GIR_Coverage, 52653,
     /* 2300119 */     GIR_EraseRootFromParent_Done,
     /* 2300120 */   // Label 31331: @2300120
     /* 2300120 */   GIM_Reject,
     /* 2300121 */ // Label 31329: @2300121
     /* 2300121 */ GIM_Reject,
     /* 2300122 */ // Label 31296: @2300122
     /* 2300122 */ GIM_Try, /*On fail goto*//*Label 31332*/ GIMT_Encode4(2300242),
     /* 2300127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2300130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2300133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300145 */   GIM_Try, /*On fail goto*//*Label 31333*/ GIMT_Encode4(2300193), // Rule ID 52664 //
     /* 2300150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300153 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2300156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2300170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300192 */     // GIR_Coverage, 52664,
     /* 2300192 */     GIR_EraseRootFromParent_Done,
     /* 2300193 */   // Label 31333: @2300193
     /* 2300193 */   GIM_Try, /*On fail goto*//*Label 31334*/ GIMT_Encode4(2300241), // Rule ID 52665 //
     /* 2300198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2300201 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2300204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2300218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300240 */     // GIR_Coverage, 52665,
     /* 2300240 */     GIR_EraseRootFromParent_Done,
     /* 2300241 */   // Label 31334: @2300241
     /* 2300241 */   GIM_Reject,
     /* 2300242 */ // Label 31332: @2300242
     /* 2300242 */ GIM_Reject,
     /* 2300243 */ // Label 31297: @2300243
     /* 2300243 */ GIM_Try, /*On fail goto*//*Label 31335*/ GIMT_Encode4(2300363),
     /* 2300248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2300254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300266 */   GIM_Try, /*On fail goto*//*Label 31336*/ GIMT_Encode4(2300314), // Rule ID 52680 //
     /* 2300271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300274 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2300277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2300291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300313 */     // GIR_Coverage, 52680,
     /* 2300313 */     GIR_EraseRootFromParent_Done,
     /* 2300314 */   // Label 31336: @2300314
     /* 2300314 */   GIM_Try, /*On fail goto*//*Label 31337*/ GIMT_Encode4(2300362), // Rule ID 52681 //
     /* 2300319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2300322 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2300325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2300339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300361 */     // GIR_Coverage, 52681,
     /* 2300361 */     GIR_EraseRootFromParent_Done,
     /* 2300362 */   // Label 31337: @2300362
     /* 2300362 */   GIM_Reject,
     /* 2300363 */ // Label 31335: @2300363
     /* 2300363 */ GIM_Reject,
     /* 2300364 */ // Label 31298: @2300364
     /* 2300364 */ GIM_Try, /*On fail goto*//*Label 31338*/ GIMT_Encode4(2300484),
     /* 2300369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2300372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2300375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300387 */   GIM_Try, /*On fail goto*//*Label 31339*/ GIMT_Encode4(2300435), // Rule ID 52724 //
     /* 2300392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2300395 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2300398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2300412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300434 */     // GIR_Coverage, 52724,
     /* 2300434 */     GIR_EraseRootFromParent_Done,
     /* 2300435 */   // Label 31339: @2300435
     /* 2300435 */   GIM_Try, /*On fail goto*//*Label 31340*/ GIMT_Encode4(2300483), // Rule ID 52725 //
     /* 2300440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2300443 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2300446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2300460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300482 */     // GIR_Coverage, 52725,
     /* 2300482 */     GIR_EraseRootFromParent_Done,
     /* 2300483 */   // Label 31340: @2300483
     /* 2300483 */   GIM_Reject,
     /* 2300484 */ // Label 31338: @2300484
     /* 2300484 */ GIM_Reject,
     /* 2300485 */ // Label 31299: @2300485
     /* 2300485 */ GIM_Try, /*On fail goto*//*Label 31341*/ GIMT_Encode4(2300605),
     /* 2300490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2300493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2300496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300508 */   GIM_Try, /*On fail goto*//*Label 31342*/ GIMT_Encode4(2300556), // Rule ID 52656 //
     /* 2300513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300516 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2300519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2300533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300555 */     // GIR_Coverage, 52656,
     /* 2300555 */     GIR_EraseRootFromParent_Done,
     /* 2300556 */   // Label 31342: @2300556
     /* 2300556 */   GIM_Try, /*On fail goto*//*Label 31343*/ GIMT_Encode4(2300604), // Rule ID 52657 //
     /* 2300561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2300564 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2300567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2300581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300603 */     // GIR_Coverage, 52657,
     /* 2300603 */     GIR_EraseRootFromParent_Done,
     /* 2300604 */   // Label 31343: @2300604
     /* 2300604 */   GIM_Reject,
     /* 2300605 */ // Label 31341: @2300605
     /* 2300605 */ GIM_Reject,
     /* 2300606 */ // Label 31300: @2300606
     /* 2300606 */ GIM_Try, /*On fail goto*//*Label 31344*/ GIMT_Encode4(2300726),
     /* 2300611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2300614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2300617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300629 */   GIM_Try, /*On fail goto*//*Label 31345*/ GIMT_Encode4(2300677), // Rule ID 52676 //
     /* 2300634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300637 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2300640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2300654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300676 */     // GIR_Coverage, 52676,
     /* 2300676 */     GIR_EraseRootFromParent_Done,
     /* 2300677 */   // Label 31345: @2300677
     /* 2300677 */   GIM_Try, /*On fail goto*//*Label 31346*/ GIMT_Encode4(2300725), // Rule ID 52677 //
     /* 2300682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2300685 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2300688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2300702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300724 */     // GIR_Coverage, 52677,
     /* 2300724 */     GIR_EraseRootFromParent_Done,
     /* 2300725 */   // Label 31346: @2300725
     /* 2300725 */   GIM_Reject,
     /* 2300726 */ // Label 31344: @2300726
     /* 2300726 */ GIM_Reject,
     /* 2300727 */ // Label 31301: @2300727
     /* 2300727 */ GIM_Try, /*On fail goto*//*Label 31347*/ GIMT_Encode4(2300847),
     /* 2300732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2300735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2300738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300750 */   GIM_Try, /*On fail goto*//*Label 31348*/ GIMT_Encode4(2300798), // Rule ID 52712 //
     /* 2300755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300758 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2300761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2300775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300797 */     // GIR_Coverage, 52712,
     /* 2300797 */     GIR_EraseRootFromParent_Done,
     /* 2300798 */   // Label 31348: @2300798
     /* 2300798 */   GIM_Try, /*On fail goto*//*Label 31349*/ GIMT_Encode4(2300846), // Rule ID 52713 //
     /* 2300803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2300806 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2300809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2300823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300845 */     // GIR_Coverage, 52713,
     /* 2300845 */     GIR_EraseRootFromParent_Done,
     /* 2300846 */   // Label 31349: @2300846
     /* 2300846 */   GIM_Reject,
     /* 2300847 */ // Label 31347: @2300847
     /* 2300847 */ GIM_Reject,
     /* 2300848 */ // Label 31302: @2300848
     /* 2300848 */ GIM_Try, /*On fail goto*//*Label 31350*/ GIMT_Encode4(2300968),
     /* 2300853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2300856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2300859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300871 */   GIM_Try, /*On fail goto*//*Label 31351*/ GIMT_Encode4(2300919), // Rule ID 52728 //
     /* 2300876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2300879 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2300882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2300896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300918 */     // GIR_Coverage, 52728,
     /* 2300918 */     GIR_EraseRootFromParent_Done,
     /* 2300919 */   // Label 31351: @2300919
     /* 2300919 */   GIM_Try, /*On fail goto*//*Label 31352*/ GIMT_Encode4(2300967), // Rule ID 52729 //
     /* 2300924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2300927 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2300930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2300944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300966 */     // GIR_Coverage, 52729,
     /* 2300966 */     GIR_EraseRootFromParent_Done,
     /* 2300967 */   // Label 31352: @2300967
     /* 2300967 */   GIM_Reject,
     /* 2300968 */ // Label 31350: @2300968
     /* 2300968 */ GIM_Reject,
     /* 2300969 */ // Label 31303: @2300969
     /* 2300969 */ GIM_Try, /*On fail goto*//*Label 31353*/ GIMT_Encode4(2301089),
     /* 2300974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2300977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2300980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300992 */   GIM_Try, /*On fail goto*//*Label 31354*/ GIMT_Encode4(2301040), // Rule ID 52672 //
     /* 2300997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301000 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2301003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2301017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301039 */     // GIR_Coverage, 52672,
     /* 2301039 */     GIR_EraseRootFromParent_Done,
     /* 2301040 */   // Label 31354: @2301040
     /* 2301040 */   GIM_Try, /*On fail goto*//*Label 31355*/ GIMT_Encode4(2301088), // Rule ID 52673 //
     /* 2301045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301048 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2301051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2301065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301087 */     // GIR_Coverage, 52673,
     /* 2301087 */     GIR_EraseRootFromParent_Done,
     /* 2301088 */   // Label 31355: @2301088
     /* 2301088 */   GIM_Reject,
     /* 2301089 */ // Label 31353: @2301089
     /* 2301089 */ GIM_Reject,
     /* 2301090 */ // Label 31304: @2301090
     /* 2301090 */ GIM_Try, /*On fail goto*//*Label 31356*/ GIMT_Encode4(2301210),
     /* 2301095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2301098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2301101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301113 */   GIM_Try, /*On fail goto*//*Label 31357*/ GIMT_Encode4(2301161), // Rule ID 52700 //
     /* 2301118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301121 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2301124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2301138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301160 */     // GIR_Coverage, 52700,
     /* 2301160 */     GIR_EraseRootFromParent_Done,
     /* 2301161 */   // Label 31357: @2301161
     /* 2301161 */   GIM_Try, /*On fail goto*//*Label 31358*/ GIMT_Encode4(2301209), // Rule ID 52701 //
     /* 2301166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301169 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2301172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2301186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301208 */     // GIR_Coverage, 52701,
     /* 2301208 */     GIR_EraseRootFromParent_Done,
     /* 2301209 */   // Label 31358: @2301209
     /* 2301209 */   GIM_Reject,
     /* 2301210 */ // Label 31356: @2301210
     /* 2301210 */ GIM_Reject,
     /* 2301211 */ // Label 31305: @2301211
     /* 2301211 */ GIM_Try, /*On fail goto*//*Label 31359*/ GIMT_Encode4(2301331),
     /* 2301216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2301219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2301222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301234 */   GIM_Try, /*On fail goto*//*Label 31360*/ GIMT_Encode4(2301282), // Rule ID 52716 //
     /* 2301239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301242 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2301245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2301259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301281 */     // GIR_Coverage, 52716,
     /* 2301281 */     GIR_EraseRootFromParent_Done,
     /* 2301282 */   // Label 31360: @2301282
     /* 2301282 */   GIM_Try, /*On fail goto*//*Label 31361*/ GIMT_Encode4(2301330), // Rule ID 52717 //
     /* 2301287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301290 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2301293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2301307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301329 */     // GIR_Coverage, 52717,
     /* 2301329 */     GIR_EraseRootFromParent_Done,
     /* 2301330 */   // Label 31361: @2301330
     /* 2301330 */   GIM_Reject,
     /* 2301331 */ // Label 31359: @2301331
     /* 2301331 */ GIM_Reject,
     /* 2301332 */ // Label 31306: @2301332
     /* 2301332 */ GIM_Try, /*On fail goto*//*Label 31362*/ GIMT_Encode4(2301452),
     /* 2301337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2301340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2301343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301355 */   GIM_Try, /*On fail goto*//*Label 31363*/ GIMT_Encode4(2301403), // Rule ID 52732 //
     /* 2301360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2301363 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2301366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2301380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301402 */     // GIR_Coverage, 52732,
     /* 2301402 */     GIR_EraseRootFromParent_Done,
     /* 2301403 */   // Label 31363: @2301403
     /* 2301403 */   GIM_Try, /*On fail goto*//*Label 31364*/ GIMT_Encode4(2301451), // Rule ID 52733 //
     /* 2301408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2301411 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2301414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2301428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301450 */     // GIR_Coverage, 52733,
     /* 2301450 */     GIR_EraseRootFromParent_Done,
     /* 2301451 */   // Label 31364: @2301451
     /* 2301451 */   GIM_Reject,
     /* 2301452 */ // Label 31362: @2301452
     /* 2301452 */ GIM_Reject,
     /* 2301453 */ // Label 31307: @2301453
     /* 2301453 */ GIM_Try, /*On fail goto*//*Label 31365*/ GIMT_Encode4(2301573),
     /* 2301458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2301461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2301464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301476 */   GIM_Try, /*On fail goto*//*Label 31366*/ GIMT_Encode4(2301524), // Rule ID 52688 //
     /* 2301481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301484 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2301487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2301501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301523 */     // GIR_Coverage, 52688,
     /* 2301523 */     GIR_EraseRootFromParent_Done,
     /* 2301524 */   // Label 31366: @2301524
     /* 2301524 */   GIM_Try, /*On fail goto*//*Label 31367*/ GIMT_Encode4(2301572), // Rule ID 52689 //
     /* 2301529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301532 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2301535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2301549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301571 */     // GIR_Coverage, 52689,
     /* 2301571 */     GIR_EraseRootFromParent_Done,
     /* 2301572 */   // Label 31367: @2301572
     /* 2301572 */   GIM_Reject,
     /* 2301573 */ // Label 31365: @2301573
     /* 2301573 */ GIM_Reject,
     /* 2301574 */ // Label 31308: @2301574
     /* 2301574 */ GIM_Try, /*On fail goto*//*Label 31368*/ GIMT_Encode4(2301694),
     /* 2301579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2301582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2301585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301597 */   GIM_Try, /*On fail goto*//*Label 31369*/ GIMT_Encode4(2301645), // Rule ID 52704 //
     /* 2301602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301605 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2301608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2301622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301644 */     // GIR_Coverage, 52704,
     /* 2301644 */     GIR_EraseRootFromParent_Done,
     /* 2301645 */   // Label 31369: @2301645
     /* 2301645 */   GIM_Try, /*On fail goto*//*Label 31370*/ GIMT_Encode4(2301693), // Rule ID 52705 //
     /* 2301650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301653 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2301656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2301670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301692 */     // GIR_Coverage, 52705,
     /* 2301692 */     GIR_EraseRootFromParent_Done,
     /* 2301693 */   // Label 31370: @2301693
     /* 2301693 */   GIM_Reject,
     /* 2301694 */ // Label 31368: @2301694
     /* 2301694 */ GIM_Reject,
     /* 2301695 */ // Label 31309: @2301695
     /* 2301695 */ GIM_Try, /*On fail goto*//*Label 31371*/ GIMT_Encode4(2301815),
     /* 2301700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2301703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2301706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301718 */   GIM_Try, /*On fail goto*//*Label 31372*/ GIMT_Encode4(2301766), // Rule ID 52720 //
     /* 2301723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301726 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2301729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2301743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301765 */     // GIR_Coverage, 52720,
     /* 2301765 */     GIR_EraseRootFromParent_Done,
     /* 2301766 */   // Label 31372: @2301766
     /* 2301766 */   GIM_Try, /*On fail goto*//*Label 31373*/ GIMT_Encode4(2301814), // Rule ID 52721 //
     /* 2301771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301774 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2301777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2301791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301813 */     // GIR_Coverage, 52721,
     /* 2301813 */     GIR_EraseRootFromParent_Done,
     /* 2301814 */   // Label 31373: @2301814
     /* 2301814 */   GIM_Reject,
     /* 2301815 */ // Label 31371: @2301815
     /* 2301815 */ GIM_Reject,
     /* 2301816 */ // Label 31310: @2301816
     /* 2301816 */ GIM_Try, /*On fail goto*//*Label 31374*/ GIMT_Encode4(2301936),
     /* 2301821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2301824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2301827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301839 */   GIM_Try, /*On fail goto*//*Label 31375*/ GIMT_Encode4(2301887), // Rule ID 52692 //
     /* 2301844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301847 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2301850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2301864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301886 */     // GIR_Coverage, 52692,
     /* 2301886 */     GIR_EraseRootFromParent_Done,
     /* 2301887 */   // Label 31375: @2301887
     /* 2301887 */   GIM_Try, /*On fail goto*//*Label 31376*/ GIMT_Encode4(2301935), // Rule ID 52693 //
     /* 2301892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301895 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2301898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2301912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301934 */     // GIR_Coverage, 52693,
     /* 2301934 */     GIR_EraseRootFromParent_Done,
     /* 2301935 */   // Label 31376: @2301935
     /* 2301935 */   GIM_Reject,
     /* 2301936 */ // Label 31374: @2301936
     /* 2301936 */ GIM_Reject,
     /* 2301937 */ // Label 31311: @2301937
     /* 2301937 */ GIM_Try, /*On fail goto*//*Label 31377*/ GIMT_Encode4(2302057),
     /* 2301942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2301945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2301948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301960 */   GIM_Try, /*On fail goto*//*Label 31378*/ GIMT_Encode4(2302008), // Rule ID 52708 //
     /* 2301965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301968 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2301971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2301985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2302006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302007 */     // GIR_Coverage, 52708,
     /* 2302007 */     GIR_EraseRootFromParent_Done,
     /* 2302008 */   // Label 31378: @2302008
     /* 2302008 */   GIM_Try, /*On fail goto*//*Label 31379*/ GIMT_Encode4(2302056), // Rule ID 52709 //
     /* 2302013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2302016 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2302019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2302033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2302054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302055 */     // GIR_Coverage, 52709,
     /* 2302055 */     GIR_EraseRootFromParent_Done,
     /* 2302056 */   // Label 31379: @2302056
     /* 2302056 */   GIM_Reject,
     /* 2302057 */ // Label 31377: @2302057
     /* 2302057 */ GIM_Reject,
     /* 2302058 */ // Label 31312: @2302058
     /* 2302058 */ GIM_Try, /*On fail goto*//*Label 31380*/ GIMT_Encode4(2302178),
     /* 2302063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2302066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2302069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302081 */   GIM_Try, /*On fail goto*//*Label 31381*/ GIMT_Encode4(2302129), // Rule ID 52696 //
     /* 2302086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2302089 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2302092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2302106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2302127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302128 */     // GIR_Coverage, 52696,
     /* 2302128 */     GIR_EraseRootFromParent_Done,
     /* 2302129 */   // Label 31381: @2302129
     /* 2302129 */   GIM_Try, /*On fail goto*//*Label 31382*/ GIMT_Encode4(2302177), // Rule ID 52697 //
     /* 2302134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2302137 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2302140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2302154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2302175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302176 */     // GIR_Coverage, 52697,
     /* 2302176 */     GIR_EraseRootFromParent_Done,
     /* 2302177 */   // Label 31382: @2302177
     /* 2302177 */   GIM_Reject,
     /* 2302178 */ // Label 31380: @2302178
     /* 2302178 */ GIM_Reject,
     /* 2302179 */ // Label 31313: @2302179
     /* 2302179 */ GIM_Reject,
     /* 2302180 */ // Label 57: @2302180
     /* 2302180 */ GIM_Try, /*On fail goto*//*Label 31383*/ GIMT_Encode4(2302237),
     /* 2302185 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2302188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2302194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2302198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2302202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2302206 */   GIM_Try, /*On fail goto*//*Label 31384*/ GIMT_Encode4(2302221), // Rule ID 64601 //
     /* 2302211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2302214 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2302214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2302219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302220 */     // GIR_Coverage, 64601,
     /* 2302220 */     GIR_Done,
     /* 2302221 */   // Label 31384: @2302221
     /* 2302221 */   GIM_Try, /*On fail goto*//*Label 31385*/ GIMT_Encode4(2302236), // Rule ID 64602 //
     /* 2302226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2302229 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2302229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2302234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302235 */     // GIR_Coverage, 64602,
     /* 2302235 */     GIR_Done,
     /* 2302236 */   // Label 31385: @2302236
     /* 2302236 */   GIM_Reject,
     /* 2302237 */ // Label 31383: @2302237
     /* 2302237 */ GIM_Reject,
     /* 2302238 */ // Label 58: @2302238
     /* 2302238 */ GIM_Try, /*On fail goto*//*Label 31386*/ GIMT_Encode4(2302295),
     /* 2302243 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2302246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2302252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2302256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2302260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2302264 */   GIM_Try, /*On fail goto*//*Label 31387*/ GIMT_Encode4(2302279), // Rule ID 64603 //
     /* 2302269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2302272 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2302272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2302277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302278 */     // GIR_Coverage, 64603,
     /* 2302278 */     GIR_Done,
     /* 2302279 */   // Label 31387: @2302279
     /* 2302279 */   GIM_Try, /*On fail goto*//*Label 31388*/ GIMT_Encode4(2302294), // Rule ID 64604 //
     /* 2302284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2302287 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2302287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2302292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302293 */     // GIR_Coverage, 64604,
     /* 2302293 */     GIR_Done,
     /* 2302294 */   // Label 31388: @2302294
     /* 2302294 */   GIM_Reject,
     /* 2302295 */ // Label 31386: @2302295
     /* 2302295 */ GIM_Reject,
     /* 2302296 */ // Label 59: @2302296
     /* 2302296 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31407*/ GIMT_Encode4(2304723),
     /* 2302307 */ /*GILLT_s16*//*Label 31389*/ GIMT_Encode4(2302427),
     /* 2302311 */ /*GILLT_s32*//*Label 31390*/ GIMT_Encode4(2302576),
     /* 2302315 */ /*GILLT_s64*//*Label 31391*/ GIMT_Encode4(2302725), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302327 */ /*GILLT_nxv1s16*//*Label 31392*/ GIMT_Encode4(2302908),
     /* 2302331 */ /*GILLT_nxv1s32*//*Label 31393*/ GIMT_Encode4(2303029),
     /* 2302335 */ /*GILLT_nxv1s64*//*Label 31394*/ GIMT_Encode4(2303150), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302347 */ /*GILLT_nxv2s16*//*Label 31395*/ GIMT_Encode4(2303271),
     /* 2302351 */ /*GILLT_nxv2s32*//*Label 31396*/ GIMT_Encode4(2303392),
     /* 2302355 */ /*GILLT_nxv2s64*//*Label 31397*/ GIMT_Encode4(2303513), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302367 */ /*GILLT_nxv4s16*//*Label 31398*/ GIMT_Encode4(2303634),
     /* 2302371 */ /*GILLT_nxv4s32*//*Label 31399*/ GIMT_Encode4(2303755),
     /* 2302375 */ /*GILLT_nxv4s64*//*Label 31400*/ GIMT_Encode4(2303876), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302387 */ /*GILLT_nxv8s16*//*Label 31401*/ GIMT_Encode4(2303997),
     /* 2302391 */ /*GILLT_nxv8s32*//*Label 31402*/ GIMT_Encode4(2304118),
     /* 2302395 */ /*GILLT_nxv8s64*//*Label 31403*/ GIMT_Encode4(2304239), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302407 */ /*GILLT_nxv16s16*//*Label 31404*/ GIMT_Encode4(2304360),
     /* 2302411 */ /*GILLT_nxv16s32*//*Label 31405*/ GIMT_Encode4(2304481), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302423 */ /*GILLT_nxv32s16*//*Label 31406*/ GIMT_Encode4(2304602),
     /* 2302427 */ // Label 31389: @2302427
     /* 2302427 */ GIM_Try, /*On fail goto*//*Label 31408*/ GIMT_Encode4(2302575),
     /* 2302432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2302435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2302438 */   GIM_Try, /*On fail goto*//*Label 31409*/ GIMT_Encode4(2302472), // Rule ID 1966 //
     /* 2302443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2302446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2302450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2302454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2302458 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2302458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2302461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302471 */     // GIR_Coverage, 1966,
     /* 2302471 */     GIR_EraseRootFromParent_Done,
     /* 2302472 */   // Label 31409: @2302472
     /* 2302472 */   GIM_Try, /*On fail goto*//*Label 31410*/ GIMT_Encode4(2302506), // Rule ID 1967 //
     /* 2302477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2302480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2302484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2302488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2302492 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2302492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2302495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302505 */     // GIR_Coverage, 1967,
     /* 2302505 */     GIR_EraseRootFromParent_Done,
     /* 2302506 */   // Label 31410: @2302506
     /* 2302506 */   GIM_Try, /*On fail goto*//*Label 31411*/ GIMT_Encode4(2302540), // Rule ID 1970 //
     /* 2302511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2302514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2302518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2302522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2302526 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2302526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2302529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302539 */     // GIR_Coverage, 1970,
     /* 2302539 */     GIR_EraseRootFromParent_Done,
     /* 2302540 */   // Label 31411: @2302540
     /* 2302540 */   GIM_Try, /*On fail goto*//*Label 31412*/ GIMT_Encode4(2302574), // Rule ID 1971 //
     /* 2302545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2302548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2302552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2302556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2302560 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2302560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2302563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302573 */     // GIR_Coverage, 1971,
     /* 2302573 */     GIR_EraseRootFromParent_Done,
     /* 2302574 */   // Label 31412: @2302574
     /* 2302574 */   GIM_Reject,
     /* 2302575 */ // Label 31408: @2302575
     /* 2302575 */ GIM_Reject,
     /* 2302576 */ // Label 31390: @2302576
     /* 2302576 */ GIM_Try, /*On fail goto*//*Label 31413*/ GIMT_Encode4(2302724),
     /* 2302581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2302587 */   GIM_Try, /*On fail goto*//*Label 31414*/ GIMT_Encode4(2302621), // Rule ID 1257 //
     /* 2302592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2302595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2302599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2302603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2302607 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2302607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2302610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302620 */     // GIR_Coverage, 1257,
     /* 2302620 */     GIR_EraseRootFromParent_Done,
     /* 2302621 */   // Label 31414: @2302621
     /* 2302621 */   GIM_Try, /*On fail goto*//*Label 31415*/ GIMT_Encode4(2302655), // Rule ID 1258 //
     /* 2302626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2302629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2302633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2302637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2302641 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2302641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2302644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302654 */     // GIR_Coverage, 1258,
     /* 2302654 */     GIR_EraseRootFromParent_Done,
     /* 2302655 */   // Label 31415: @2302655
     /* 2302655 */   GIM_Try, /*On fail goto*//*Label 31416*/ GIMT_Encode4(2302689), // Rule ID 1261 //
     /* 2302660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2302663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2302667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2302671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2302675 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2302675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2302678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302688 */     // GIR_Coverage, 1261,
     /* 2302688 */     GIR_EraseRootFromParent_Done,
     /* 2302689 */   // Label 31416: @2302689
     /* 2302689 */   GIM_Try, /*On fail goto*//*Label 31417*/ GIMT_Encode4(2302723), // Rule ID 1262 //
     /* 2302694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2302697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2302701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2302705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2302709 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2302709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2302712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302722 */     // GIR_Coverage, 1262,
     /* 2302722 */     GIR_EraseRootFromParent_Done,
     /* 2302723 */   // Label 31417: @2302723
     /* 2302723 */   GIM_Reject,
     /* 2302724 */ // Label 31413: @2302724
     /* 2302724 */ GIM_Reject,
     /* 2302725 */ // Label 31391: @2302725
     /* 2302725 */ GIM_Try, /*On fail goto*//*Label 31418*/ GIMT_Encode4(2302907),
     /* 2302730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2302733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2302736 */   GIM_Try, /*On fail goto*//*Label 31419*/ GIMT_Encode4(2302770), // Rule ID 1592 //
     /* 2302741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2302744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2302748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2302752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2302756 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2302756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2302759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302769 */     // GIR_Coverage, 1592,
     /* 2302769 */     GIR_EraseRootFromParent_Done,
     /* 2302770 */   // Label 31419: @2302770
     /* 2302770 */   GIM_Try, /*On fail goto*//*Label 31420*/ GIMT_Encode4(2302804), // Rule ID 1593 //
     /* 2302775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2302778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2302782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2302786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2302790 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2302790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2302793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302803 */     // GIR_Coverage, 1593,
     /* 2302803 */     GIR_EraseRootFromParent_Done,
     /* 2302804 */   // Label 31420: @2302804
     /* 2302804 */   GIM_Try, /*On fail goto*//*Label 31421*/ GIMT_Encode4(2302838), // Rule ID 1596 //
     /* 2302809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2302812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2302816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2302820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2302824 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2302824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2302827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302837 */     // GIR_Coverage, 1596,
     /* 2302837 */     GIR_EraseRootFromParent_Done,
     /* 2302838 */   // Label 31421: @2302838
     /* 2302838 */   GIM_Try, /*On fail goto*//*Label 31422*/ GIMT_Encode4(2302872), // Rule ID 1597 //
     /* 2302843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2302846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2302850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2302854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2302858 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2302858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2302861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302871 */     // GIR_Coverage, 1597,
     /* 2302871 */     GIR_EraseRootFromParent_Done,
     /* 2302872 */   // Label 31422: @2302872
     /* 2302872 */   GIM_Try, /*On fail goto*//*Label 31423*/ GIMT_Encode4(2302906), // Rule ID 1599 //
     /* 2302877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2302880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302892 */     // (fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2302892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2302895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302905 */     // GIR_Coverage, 1599,
     /* 2302905 */     GIR_EraseRootFromParent_Done,
     /* 2302906 */   // Label 31423: @2302906
     /* 2302906 */   GIM_Reject,
     /* 2302907 */ // Label 31418: @2302907
     /* 2302907 */ GIM_Reject,
     /* 2302908 */ // Label 31392: @2302908
     /* 2302908 */ GIM_Try, /*On fail goto*//*Label 31424*/ GIMT_Encode4(2303028),
     /* 2302913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2302916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2302919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302931 */   GIM_Try, /*On fail goto*//*Label 31425*/ GIMT_Encode4(2302979), // Rule ID 45772 //
     /* 2302936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302939 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2302942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2302956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302978 */     // GIR_Coverage, 45772,
     /* 2302978 */     GIR_EraseRootFromParent_Done,
     /* 2302979 */   // Label 31425: @2302979
     /* 2302979 */   GIM_Try, /*On fail goto*//*Label 31426*/ GIMT_Encode4(2303027), // Rule ID 45773 //
     /* 2302984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302987 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2302990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2303004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303026 */     // GIR_Coverage, 45773,
     /* 2303026 */     GIR_EraseRootFromParent_Done,
     /* 2303027 */   // Label 31426: @2303027
     /* 2303027 */   GIM_Reject,
     /* 2303028 */ // Label 31424: @2303028
     /* 2303028 */ GIM_Reject,
     /* 2303029 */ // Label 31393: @2303029
     /* 2303029 */ GIM_Try, /*On fail goto*//*Label 31427*/ GIMT_Encode4(2303149),
     /* 2303034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2303037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2303040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303052 */   GIM_Try, /*On fail goto*//*Label 31428*/ GIMT_Encode4(2303100), // Rule ID 53312 //
     /* 2303057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303060 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2303063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2303077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303099 */     // GIR_Coverage, 53312,
     /* 2303099 */     GIR_EraseRootFromParent_Done,
     /* 2303100 */   // Label 31428: @2303100
     /* 2303100 */   GIM_Try, /*On fail goto*//*Label 31429*/ GIMT_Encode4(2303148), // Rule ID 53313 //
     /* 2303105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303108 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2303111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2303125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303147 */     // GIR_Coverage, 53313,
     /* 2303147 */     GIR_EraseRootFromParent_Done,
     /* 2303148 */   // Label 31429: @2303148
     /* 2303148 */   GIM_Reject,
     /* 2303149 */ // Label 31427: @2303149
     /* 2303149 */ GIM_Reject,
     /* 2303150 */ // Label 31394: @2303150
     /* 2303150 */ GIM_Try, /*On fail goto*//*Label 31430*/ GIMT_Encode4(2303270),
     /* 2303155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2303158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2303161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303173 */   GIM_Try, /*On fail goto*//*Label 31431*/ GIMT_Encode4(2303221), // Rule ID 53348 //
     /* 2303178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2303181 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2303184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2303198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303220 */     // GIR_Coverage, 53348,
     /* 2303220 */     GIR_EraseRootFromParent_Done,
     /* 2303221 */   // Label 31431: @2303221
     /* 2303221 */   GIM_Try, /*On fail goto*//*Label 31432*/ GIMT_Encode4(2303269), // Rule ID 53349 //
     /* 2303226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303229 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2303232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2303246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303268 */     // GIR_Coverage, 53349,
     /* 2303268 */     GIR_EraseRootFromParent_Done,
     /* 2303269 */   // Label 31432: @2303269
     /* 2303269 */   GIM_Reject,
     /* 2303270 */ // Label 31430: @2303270
     /* 2303270 */ GIM_Reject,
     /* 2303271 */ // Label 31395: @2303271
     /* 2303271 */ GIM_Try, /*On fail goto*//*Label 31433*/ GIMT_Encode4(2303391),
     /* 2303276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2303279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2303282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303294 */   GIM_Try, /*On fail goto*//*Label 31434*/ GIMT_Encode4(2303342), // Rule ID 53300 //
     /* 2303299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2303302 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2303305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2303319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303341 */     // GIR_Coverage, 53300,
     /* 2303341 */     GIR_EraseRootFromParent_Done,
     /* 2303342 */   // Label 31434: @2303342
     /* 2303342 */   GIM_Try, /*On fail goto*//*Label 31435*/ GIMT_Encode4(2303390), // Rule ID 53301 //
     /* 2303347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303350 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2303353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2303367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303389 */     // GIR_Coverage, 53301,
     /* 2303389 */     GIR_EraseRootFromParent_Done,
     /* 2303390 */   // Label 31435: @2303390
     /* 2303390 */   GIM_Reject,
     /* 2303391 */ // Label 31433: @2303391
     /* 2303391 */ GIM_Reject,
     /* 2303392 */ // Label 31396: @2303392
     /* 2303392 */ GIM_Try, /*On fail goto*//*Label 31436*/ GIMT_Encode4(2303512),
     /* 2303397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2303400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2303403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303415 */   GIM_Try, /*On fail goto*//*Label 31437*/ GIMT_Encode4(2303463), // Rule ID 53336 //
     /* 2303420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303423 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2303426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2303440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303462 */     // GIR_Coverage, 53336,
     /* 2303462 */     GIR_EraseRootFromParent_Done,
     /* 2303463 */   // Label 31437: @2303463
     /* 2303463 */   GIM_Try, /*On fail goto*//*Label 31438*/ GIMT_Encode4(2303511), // Rule ID 53337 //
     /* 2303468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303471 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2303474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2303488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303510 */     // GIR_Coverage, 53337,
     /* 2303510 */     GIR_EraseRootFromParent_Done,
     /* 2303511 */   // Label 31438: @2303511
     /* 2303511 */   GIM_Reject,
     /* 2303512 */ // Label 31436: @2303512
     /* 2303512 */ GIM_Reject,
     /* 2303513 */ // Label 31397: @2303513
     /* 2303513 */ GIM_Try, /*On fail goto*//*Label 31439*/ GIMT_Encode4(2303633),
     /* 2303518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2303521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2303524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303536 */   GIM_Try, /*On fail goto*//*Label 31440*/ GIMT_Encode4(2303584), // Rule ID 53432 //
     /* 2303541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2303544 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2303547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2303561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303583 */     // GIR_Coverage, 53432,
     /* 2303583 */     GIR_EraseRootFromParent_Done,
     /* 2303584 */   // Label 31440: @2303584
     /* 2303584 */   GIM_Try, /*On fail goto*//*Label 31441*/ GIMT_Encode4(2303632), // Rule ID 53433 //
     /* 2303589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303592 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2303595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2303609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303631 */     // GIR_Coverage, 53433,
     /* 2303631 */     GIR_EraseRootFromParent_Done,
     /* 2303632 */   // Label 31441: @2303632
     /* 2303632 */   GIM_Reject,
     /* 2303633 */ // Label 31439: @2303633
     /* 2303633 */ GIM_Reject,
     /* 2303634 */ // Label 31398: @2303634
     /* 2303634 */ GIM_Try, /*On fail goto*//*Label 31442*/ GIMT_Encode4(2303754),
     /* 2303639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2303642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2303645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303657 */   GIM_Try, /*On fail goto*//*Label 31443*/ GIMT_Encode4(2303705), // Rule ID 53324 //
     /* 2303662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2303665 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2303668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2303682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303704 */     // GIR_Coverage, 53324,
     /* 2303704 */     GIR_EraseRootFromParent_Done,
     /* 2303705 */   // Label 31443: @2303705
     /* 2303705 */   GIM_Try, /*On fail goto*//*Label 31444*/ GIMT_Encode4(2303753), // Rule ID 53325 //
     /* 2303710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303713 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2303716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2303730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303752 */     // GIR_Coverage, 53325,
     /* 2303752 */     GIR_EraseRootFromParent_Done,
     /* 2303753 */   // Label 31444: @2303753
     /* 2303753 */   GIM_Reject,
     /* 2303754 */ // Label 31442: @2303754
     /* 2303754 */ GIM_Reject,
     /* 2303755 */ // Label 31399: @2303755
     /* 2303755 */ GIM_Try, /*On fail goto*//*Label 31445*/ GIMT_Encode4(2303875),
     /* 2303760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2303763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2303766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303778 */   GIM_Try, /*On fail goto*//*Label 31446*/ GIMT_Encode4(2303826), // Rule ID 53396 //
     /* 2303783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303786 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2303789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2303803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303825 */     // GIR_Coverage, 53396,
     /* 2303825 */     GIR_EraseRootFromParent_Done,
     /* 2303826 */   // Label 31446: @2303826
     /* 2303826 */   GIM_Try, /*On fail goto*//*Label 31447*/ GIMT_Encode4(2303874), // Rule ID 53397 //
     /* 2303831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303834 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2303837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2303851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303873 */     // GIR_Coverage, 53397,
     /* 2303873 */     GIR_EraseRootFromParent_Done,
     /* 2303874 */   // Label 31447: @2303874
     /* 2303874 */   GIM_Reject,
     /* 2303875 */ // Label 31445: @2303875
     /* 2303875 */ GIM_Reject,
     /* 2303876 */ // Label 31400: @2303876
     /* 2303876 */ GIM_Try, /*On fail goto*//*Label 31448*/ GIMT_Encode4(2303996),
     /* 2303881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2303887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303899 */   GIM_Try, /*On fail goto*//*Label 31449*/ GIMT_Encode4(2303947), // Rule ID 53444 //
     /* 2303904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2303907 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2303910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2303924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303946 */     // GIR_Coverage, 53444,
     /* 2303946 */     GIR_EraseRootFromParent_Done,
     /* 2303947 */   // Label 31449: @2303947
     /* 2303947 */   GIM_Try, /*On fail goto*//*Label 31450*/ GIMT_Encode4(2303995), // Rule ID 53445 //
     /* 2303952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303955 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2303958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2303972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303994 */     // GIR_Coverage, 53445,
     /* 2303994 */     GIR_EraseRootFromParent_Done,
     /* 2303995 */   // Label 31450: @2303995
     /* 2303995 */   GIM_Reject,
     /* 2303996 */ // Label 31448: @2303996
     /* 2303996 */ GIM_Reject,
     /* 2303997 */ // Label 31401: @2303997
     /* 2303997 */ GIM_Try, /*On fail goto*//*Label 31451*/ GIMT_Encode4(2304117),
     /* 2304002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2304008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304020 */   GIM_Try, /*On fail goto*//*Label 31452*/ GIMT_Encode4(2304068), // Rule ID 53360 //
     /* 2304025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304028 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2304031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2304045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304067 */     // GIR_Coverage, 53360,
     /* 2304067 */     GIR_EraseRootFromParent_Done,
     /* 2304068 */   // Label 31452: @2304068
     /* 2304068 */   GIM_Try, /*On fail goto*//*Label 31453*/ GIMT_Encode4(2304116), // Rule ID 53361 //
     /* 2304073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304076 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2304079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2304093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304115 */     // GIR_Coverage, 53361,
     /* 2304115 */     GIR_EraseRootFromParent_Done,
     /* 2304116 */   // Label 31453: @2304116
     /* 2304116 */   GIM_Reject,
     /* 2304117 */ // Label 31451: @2304117
     /* 2304117 */ GIM_Reject,
     /* 2304118 */ // Label 31402: @2304118
     /* 2304118 */ GIM_Try, /*On fail goto*//*Label 31454*/ GIMT_Encode4(2304238),
     /* 2304123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2304126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2304129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304141 */   GIM_Try, /*On fail goto*//*Label 31455*/ GIMT_Encode4(2304189), // Rule ID 53408 //
     /* 2304146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2304149 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2304152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2304166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304188 */     // GIR_Coverage, 53408,
     /* 2304188 */     GIR_EraseRootFromParent_Done,
     /* 2304189 */   // Label 31455: @2304189
     /* 2304189 */   GIM_Try, /*On fail goto*//*Label 31456*/ GIMT_Encode4(2304237), // Rule ID 53409 //
     /* 2304194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2304197 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2304200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2304214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304236 */     // GIR_Coverage, 53409,
     /* 2304236 */     GIR_EraseRootFromParent_Done,
     /* 2304237 */   // Label 31456: @2304237
     /* 2304237 */   GIM_Reject,
     /* 2304238 */ // Label 31454: @2304238
     /* 2304238 */ GIM_Reject,
     /* 2304239 */ // Label 31403: @2304239
     /* 2304239 */ GIM_Try, /*On fail goto*//*Label 31457*/ GIMT_Encode4(2304359),
     /* 2304244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2304247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2304250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304262 */   GIM_Try, /*On fail goto*//*Label 31458*/ GIMT_Encode4(2304310), // Rule ID 53456 //
     /* 2304267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2304270 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2304273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2304287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304309 */     // GIR_Coverage, 53456,
     /* 2304309 */     GIR_EraseRootFromParent_Done,
     /* 2304310 */   // Label 31458: @2304310
     /* 2304310 */   GIM_Try, /*On fail goto*//*Label 31459*/ GIMT_Encode4(2304358), // Rule ID 53457 //
     /* 2304315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2304318 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2304321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2304335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304357 */     // GIR_Coverage, 53457,
     /* 2304357 */     GIR_EraseRootFromParent_Done,
     /* 2304358 */   // Label 31459: @2304358
     /* 2304358 */   GIM_Reject,
     /* 2304359 */ // Label 31457: @2304359
     /* 2304359 */ GIM_Reject,
     /* 2304360 */ // Label 31404: @2304360
     /* 2304360 */ GIM_Try, /*On fail goto*//*Label 31460*/ GIMT_Encode4(2304480),
     /* 2304365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2304368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2304371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304383 */   GIM_Try, /*On fail goto*//*Label 31461*/ GIMT_Encode4(2304431), // Rule ID 53372 //
     /* 2304388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304391 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2304394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2304408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304430 */     // GIR_Coverage, 53372,
     /* 2304430 */     GIR_EraseRootFromParent_Done,
     /* 2304431 */   // Label 31461: @2304431
     /* 2304431 */   GIM_Try, /*On fail goto*//*Label 31462*/ GIMT_Encode4(2304479), // Rule ID 53373 //
     /* 2304436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304439 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2304442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2304456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304478 */     // GIR_Coverage, 53373,
     /* 2304478 */     GIR_EraseRootFromParent_Done,
     /* 2304479 */   // Label 31462: @2304479
     /* 2304479 */   GIM_Reject,
     /* 2304480 */ // Label 31460: @2304480
     /* 2304480 */ GIM_Reject,
     /* 2304481 */ // Label 31405: @2304481
     /* 2304481 */ GIM_Try, /*On fail goto*//*Label 31463*/ GIMT_Encode4(2304601),
     /* 2304486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2304489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2304492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304504 */   GIM_Try, /*On fail goto*//*Label 31464*/ GIMT_Encode4(2304552), // Rule ID 53420 //
     /* 2304509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2304512 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2304515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2304529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304551 */     // GIR_Coverage, 53420,
     /* 2304551 */     GIR_EraseRootFromParent_Done,
     /* 2304552 */   // Label 31464: @2304552
     /* 2304552 */   GIM_Try, /*On fail goto*//*Label 31465*/ GIMT_Encode4(2304600), // Rule ID 53421 //
     /* 2304557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2304560 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2304563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2304577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304599 */     // GIR_Coverage, 53421,
     /* 2304599 */     GIR_EraseRootFromParent_Done,
     /* 2304600 */   // Label 31465: @2304600
     /* 2304600 */   GIM_Reject,
     /* 2304601 */ // Label 31463: @2304601
     /* 2304601 */ GIM_Reject,
     /* 2304602 */ // Label 31406: @2304602
     /* 2304602 */ GIM_Try, /*On fail goto*//*Label 31466*/ GIMT_Encode4(2304722),
     /* 2304607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2304613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304625 */   GIM_Try, /*On fail goto*//*Label 31467*/ GIMT_Encode4(2304673), // Rule ID 53384 //
     /* 2304630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304633 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2304636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2304650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304672 */     // GIR_Coverage, 53384,
     /* 2304672 */     GIR_EraseRootFromParent_Done,
     /* 2304673 */   // Label 31467: @2304673
     /* 2304673 */   GIM_Try, /*On fail goto*//*Label 31468*/ GIMT_Encode4(2304721), // Rule ID 53385 //
     /* 2304678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304681 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2304684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2304698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304720 */     // GIR_Coverage, 53385,
     /* 2304720 */     GIR_EraseRootFromParent_Done,
     /* 2304721 */   // Label 31468: @2304721
     /* 2304721 */   GIM_Reject,
     /* 2304722 */ // Label 31466: @2304722
     /* 2304722 */ GIM_Reject,
     /* 2304723 */ // Label 31407: @2304723
     /* 2304723 */ GIM_Reject,
     /* 2304724 */ // Label 60: @2304724
     /* 2304724 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31487*/ GIMT_Encode4(2307151),
     /* 2304735 */ /*GILLT_s16*//*Label 31469*/ GIMT_Encode4(2304855),
     /* 2304739 */ /*GILLT_s32*//*Label 31470*/ GIMT_Encode4(2305004),
     /* 2304743 */ /*GILLT_s64*//*Label 31471*/ GIMT_Encode4(2305153), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304755 */ /*GILLT_nxv1s16*//*Label 31472*/ GIMT_Encode4(2305336),
     /* 2304759 */ /*GILLT_nxv1s32*//*Label 31473*/ GIMT_Encode4(2305457),
     /* 2304763 */ /*GILLT_nxv1s64*//*Label 31474*/ GIMT_Encode4(2305578), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304775 */ /*GILLT_nxv2s16*//*Label 31475*/ GIMT_Encode4(2305699),
     /* 2304779 */ /*GILLT_nxv2s32*//*Label 31476*/ GIMT_Encode4(2305820),
     /* 2304783 */ /*GILLT_nxv2s64*//*Label 31477*/ GIMT_Encode4(2305941), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304795 */ /*GILLT_nxv4s16*//*Label 31478*/ GIMT_Encode4(2306062),
     /* 2304799 */ /*GILLT_nxv4s32*//*Label 31479*/ GIMT_Encode4(2306183),
     /* 2304803 */ /*GILLT_nxv4s64*//*Label 31480*/ GIMT_Encode4(2306304), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304815 */ /*GILLT_nxv8s16*//*Label 31481*/ GIMT_Encode4(2306425),
     /* 2304819 */ /*GILLT_nxv8s32*//*Label 31482*/ GIMT_Encode4(2306546),
     /* 2304823 */ /*GILLT_nxv8s64*//*Label 31483*/ GIMT_Encode4(2306667), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304835 */ /*GILLT_nxv16s16*//*Label 31484*/ GIMT_Encode4(2306788),
     /* 2304839 */ /*GILLT_nxv16s32*//*Label 31485*/ GIMT_Encode4(2306909), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304851 */ /*GILLT_nxv32s16*//*Label 31486*/ GIMT_Encode4(2307030),
     /* 2304855 */ // Label 31469: @2304855
     /* 2304855 */ GIM_Try, /*On fail goto*//*Label 31488*/ GIMT_Encode4(2305003),
     /* 2304860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2304866 */   GIM_Try, /*On fail goto*//*Label 31489*/ GIMT_Encode4(2304900), // Rule ID 1974 //
     /* 2304871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2304874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304886 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2304886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2304889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304899 */     // GIR_Coverage, 1974,
     /* 2304899 */     GIR_EraseRootFromParent_Done,
     /* 2304900 */   // Label 31489: @2304900
     /* 2304900 */   GIM_Try, /*On fail goto*//*Label 31490*/ GIMT_Encode4(2304934), // Rule ID 1975 //
     /* 2304905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2304908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304920 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2304920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2304923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304933 */     // GIR_Coverage, 1975,
     /* 2304933 */     GIR_EraseRootFromParent_Done,
     /* 2304934 */   // Label 31490: @2304934
     /* 2304934 */   GIM_Try, /*On fail goto*//*Label 31491*/ GIMT_Encode4(2304968), // Rule ID 1978 //
     /* 2304939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2304942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304954 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2304954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2304957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304967 */     // GIR_Coverage, 1978,
     /* 2304967 */     GIR_EraseRootFromParent_Done,
     /* 2304968 */   // Label 31491: @2304968
     /* 2304968 */   GIM_Try, /*On fail goto*//*Label 31492*/ GIMT_Encode4(2305002), // Rule ID 1979 //
     /* 2304973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2304976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304988 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2304988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2304991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305001 */     // GIR_Coverage, 1979,
     /* 2305001 */     GIR_EraseRootFromParent_Done,
     /* 2305002 */   // Label 31492: @2305002
     /* 2305002 */   GIM_Reject,
     /* 2305003 */ // Label 31488: @2305003
     /* 2305003 */ GIM_Reject,
     /* 2305004 */ // Label 31470: @2305004
     /* 2305004 */ GIM_Try, /*On fail goto*//*Label 31493*/ GIMT_Encode4(2305152),
     /* 2305009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2305015 */   GIM_Try, /*On fail goto*//*Label 31494*/ GIMT_Encode4(2305049), // Rule ID 1265 //
     /* 2305020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2305023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305035 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2305035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2305038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305048 */     // GIR_Coverage, 1265,
     /* 2305048 */     GIR_EraseRootFromParent_Done,
     /* 2305049 */   // Label 31494: @2305049
     /* 2305049 */   GIM_Try, /*On fail goto*//*Label 31495*/ GIMT_Encode4(2305083), // Rule ID 1266 //
     /* 2305054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2305057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305069 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2305069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2305072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305082 */     // GIR_Coverage, 1266,
     /* 2305082 */     GIR_EraseRootFromParent_Done,
     /* 2305083 */   // Label 31495: @2305083
     /* 2305083 */   GIM_Try, /*On fail goto*//*Label 31496*/ GIMT_Encode4(2305117), // Rule ID 1269 //
     /* 2305088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2305091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305103 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2305103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2305106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305116 */     // GIR_Coverage, 1269,
     /* 2305116 */     GIR_EraseRootFromParent_Done,
     /* 2305117 */   // Label 31496: @2305117
     /* 2305117 */   GIM_Try, /*On fail goto*//*Label 31497*/ GIMT_Encode4(2305151), // Rule ID 1270 //
     /* 2305122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2305125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305137 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2305137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2305140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305150 */     // GIR_Coverage, 1270,
     /* 2305150 */     GIR_EraseRootFromParent_Done,
     /* 2305151 */   // Label 31497: @2305151
     /* 2305151 */   GIM_Reject,
     /* 2305152 */ // Label 31493: @2305152
     /* 2305152 */ GIM_Reject,
     /* 2305153 */ // Label 31471: @2305153
     /* 2305153 */ GIM_Try, /*On fail goto*//*Label 31498*/ GIMT_Encode4(2305335),
     /* 2305158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2305161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2305164 */   GIM_Try, /*On fail goto*//*Label 31499*/ GIMT_Encode4(2305198), // Rule ID 1602 //
     /* 2305169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2305172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305184 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2305184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2305187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305197 */     // GIR_Coverage, 1602,
     /* 2305197 */     GIR_EraseRootFromParent_Done,
     /* 2305198 */   // Label 31499: @2305198
     /* 2305198 */   GIM_Try, /*On fail goto*//*Label 31500*/ GIMT_Encode4(2305232), // Rule ID 1603 //
     /* 2305203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2305206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305218 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2305218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2305221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305231 */     // GIR_Coverage, 1603,
     /* 2305231 */     GIR_EraseRootFromParent_Done,
     /* 2305232 */   // Label 31500: @2305232
     /* 2305232 */   GIM_Try, /*On fail goto*//*Label 31501*/ GIMT_Encode4(2305266), // Rule ID 1606 //
     /* 2305237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2305240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305252 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2305252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2305255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305265 */     // GIR_Coverage, 1606,
     /* 2305265 */     GIR_EraseRootFromParent_Done,
     /* 2305266 */   // Label 31501: @2305266
     /* 2305266 */   GIM_Try, /*On fail goto*//*Label 31502*/ GIMT_Encode4(2305300), // Rule ID 1607 //
     /* 2305271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2305274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305286 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2305286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2305289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305299 */     // GIR_Coverage, 1607,
     /* 2305299 */     GIR_EraseRootFromParent_Done,
     /* 2305300 */   // Label 31502: @2305300
     /* 2305300 */   GIM_Try, /*On fail goto*//*Label 31503*/ GIMT_Encode4(2305334), // Rule ID 1609 //
     /* 2305305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2305308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2305312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2305316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2305320 */     // (fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2305320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2305323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305333 */     // GIR_Coverage, 1609,
     /* 2305333 */     GIR_EraseRootFromParent_Done,
     /* 2305334 */   // Label 31503: @2305334
     /* 2305334 */   GIM_Reject,
     /* 2305335 */ // Label 31498: @2305335
     /* 2305335 */ GIM_Reject,
     /* 2305336 */ // Label 31472: @2305336
     /* 2305336 */ GIM_Try, /*On fail goto*//*Label 31504*/ GIMT_Encode4(2305456),
     /* 2305341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2305344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2305347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305359 */   GIM_Try, /*On fail goto*//*Label 31505*/ GIMT_Encode4(2305407), // Rule ID 53468 //
     /* 2305364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2305367 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2305370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2305384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305406 */     // GIR_Coverage, 53468,
     /* 2305406 */     GIR_EraseRootFromParent_Done,
     /* 2305407 */   // Label 31505: @2305407
     /* 2305407 */   GIM_Try, /*On fail goto*//*Label 31506*/ GIMT_Encode4(2305455), // Rule ID 53469 //
     /* 2305412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2305415 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2305418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2305432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305454 */     // GIR_Coverage, 53469,
     /* 2305454 */     GIR_EraseRootFromParent_Done,
     /* 2305455 */   // Label 31506: @2305455
     /* 2305455 */   GIM_Reject,
     /* 2305456 */ // Label 31504: @2305456
     /* 2305456 */ GIM_Reject,
     /* 2305457 */ // Label 31473: @2305457
     /* 2305457 */ GIM_Try, /*On fail goto*//*Label 31507*/ GIMT_Encode4(2305577),
     /* 2305462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2305465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2305468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305480 */   GIM_Try, /*On fail goto*//*Label 31508*/ GIMT_Encode4(2305528), // Rule ID 53492 //
     /* 2305485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305488 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2305491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2305505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305527 */     // GIR_Coverage, 53492,
     /* 2305527 */     GIR_EraseRootFromParent_Done,
     /* 2305528 */   // Label 31508: @2305528
     /* 2305528 */   GIM_Try, /*On fail goto*//*Label 31509*/ GIMT_Encode4(2305576), // Rule ID 53493 //
     /* 2305533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305536 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2305539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2305553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305575 */     // GIR_Coverage, 53493,
     /* 2305575 */     GIR_EraseRootFromParent_Done,
     /* 2305576 */   // Label 31509: @2305576
     /* 2305576 */   GIM_Reject,
     /* 2305577 */ // Label 31507: @2305577
     /* 2305577 */ GIM_Reject,
     /* 2305578 */ // Label 31474: @2305578
     /* 2305578 */ GIM_Try, /*On fail goto*//*Label 31510*/ GIMT_Encode4(2305698),
     /* 2305583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2305586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2305589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305597 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305601 */   GIM_Try, /*On fail goto*//*Label 31511*/ GIMT_Encode4(2305649), // Rule ID 53528 //
     /* 2305606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2305609 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2305612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2305626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305648 */     // GIR_Coverage, 53528,
     /* 2305648 */     GIR_EraseRootFromParent_Done,
     /* 2305649 */   // Label 31511: @2305649
     /* 2305649 */   GIM_Try, /*On fail goto*//*Label 31512*/ GIMT_Encode4(2305697), // Rule ID 53529 //
     /* 2305654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2305657 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2305660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2305674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305696 */     // GIR_Coverage, 53529,
     /* 2305696 */     GIR_EraseRootFromParent_Done,
     /* 2305697 */   // Label 31512: @2305697
     /* 2305697 */   GIM_Reject,
     /* 2305698 */ // Label 31510: @2305698
     /* 2305698 */ GIM_Reject,
     /* 2305699 */ // Label 31475: @2305699
     /* 2305699 */ GIM_Try, /*On fail goto*//*Label 31513*/ GIMT_Encode4(2305819),
     /* 2305704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2305707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2305710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305722 */   GIM_Try, /*On fail goto*//*Label 31514*/ GIMT_Encode4(2305770), // Rule ID 53480 //
     /* 2305727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2305730 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2305733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2305747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305769 */     // GIR_Coverage, 53480,
     /* 2305769 */     GIR_EraseRootFromParent_Done,
     /* 2305770 */   // Label 31514: @2305770
     /* 2305770 */   GIM_Try, /*On fail goto*//*Label 31515*/ GIMT_Encode4(2305818), // Rule ID 53481 //
     /* 2305775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2305778 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2305781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2305795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305817 */     // GIR_Coverage, 53481,
     /* 2305817 */     GIR_EraseRootFromParent_Done,
     /* 2305818 */   // Label 31515: @2305818
     /* 2305818 */   GIM_Reject,
     /* 2305819 */ // Label 31513: @2305819
     /* 2305819 */ GIM_Reject,
     /* 2305820 */ // Label 31476: @2305820
     /* 2305820 */ GIM_Try, /*On fail goto*//*Label 31516*/ GIMT_Encode4(2305940),
     /* 2305825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2305828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2305831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305843 */   GIM_Try, /*On fail goto*//*Label 31517*/ GIMT_Encode4(2305891), // Rule ID 53516 //
     /* 2305848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305851 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2305854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2305868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305890 */     // GIR_Coverage, 53516,
     /* 2305890 */     GIR_EraseRootFromParent_Done,
     /* 2305891 */   // Label 31517: @2305891
     /* 2305891 */   GIM_Try, /*On fail goto*//*Label 31518*/ GIMT_Encode4(2305939), // Rule ID 53517 //
     /* 2305896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305899 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2305902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2305916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305938 */     // GIR_Coverage, 53517,
     /* 2305938 */     GIR_EraseRootFromParent_Done,
     /* 2305939 */   // Label 31518: @2305939
     /* 2305939 */   GIM_Reject,
     /* 2305940 */ // Label 31516: @2305940
     /* 2305940 */ GIM_Reject,
     /* 2305941 */ // Label 31477: @2305941
     /* 2305941 */ GIM_Try, /*On fail goto*//*Label 31519*/ GIMT_Encode4(2306061),
     /* 2305946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2305949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2305952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305964 */   GIM_Try, /*On fail goto*//*Label 31520*/ GIMT_Encode4(2306012), // Rule ID 53612 //
     /* 2305969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2305972 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2305975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2305989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306011 */     // GIR_Coverage, 53612,
     /* 2306011 */     GIR_EraseRootFromParent_Done,
     /* 2306012 */   // Label 31520: @2306012
     /* 2306012 */   GIM_Try, /*On fail goto*//*Label 31521*/ GIMT_Encode4(2306060), // Rule ID 53613 //
     /* 2306017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306020 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2306023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2306037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306059 */     // GIR_Coverage, 53613,
     /* 2306059 */     GIR_EraseRootFromParent_Done,
     /* 2306060 */   // Label 31521: @2306060
     /* 2306060 */   GIM_Reject,
     /* 2306061 */ // Label 31519: @2306061
     /* 2306061 */ GIM_Reject,
     /* 2306062 */ // Label 31478: @2306062
     /* 2306062 */ GIM_Try, /*On fail goto*//*Label 31522*/ GIMT_Encode4(2306182),
     /* 2306067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2306070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2306073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306085 */   GIM_Try, /*On fail goto*//*Label 31523*/ GIMT_Encode4(2306133), // Rule ID 53504 //
     /* 2306090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2306093 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2306096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2306110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306132 */     // GIR_Coverage, 53504,
     /* 2306132 */     GIR_EraseRootFromParent_Done,
     /* 2306133 */   // Label 31523: @2306133
     /* 2306133 */   GIM_Try, /*On fail goto*//*Label 31524*/ GIMT_Encode4(2306181), // Rule ID 53505 //
     /* 2306138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2306141 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2306144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2306158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306180 */     // GIR_Coverage, 53505,
     /* 2306180 */     GIR_EraseRootFromParent_Done,
     /* 2306181 */   // Label 31524: @2306181
     /* 2306181 */   GIM_Reject,
     /* 2306182 */ // Label 31522: @2306182
     /* 2306182 */ GIM_Reject,
     /* 2306183 */ // Label 31479: @2306183
     /* 2306183 */ GIM_Try, /*On fail goto*//*Label 31525*/ GIMT_Encode4(2306303),
     /* 2306188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2306191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2306194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306206 */   GIM_Try, /*On fail goto*//*Label 31526*/ GIMT_Encode4(2306254), // Rule ID 53576 //
     /* 2306211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2306214 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2306217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2306231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306253 */     // GIR_Coverage, 53576,
     /* 2306253 */     GIR_EraseRootFromParent_Done,
     /* 2306254 */   // Label 31526: @2306254
     /* 2306254 */   GIM_Try, /*On fail goto*//*Label 31527*/ GIMT_Encode4(2306302), // Rule ID 53577 //
     /* 2306259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2306262 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2306265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2306279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306301 */     // GIR_Coverage, 53577,
     /* 2306301 */     GIR_EraseRootFromParent_Done,
     /* 2306302 */   // Label 31527: @2306302
     /* 2306302 */   GIM_Reject,
     /* 2306303 */ // Label 31525: @2306303
     /* 2306303 */ GIM_Reject,
     /* 2306304 */ // Label 31480: @2306304
     /* 2306304 */ GIM_Try, /*On fail goto*//*Label 31528*/ GIMT_Encode4(2306424),
     /* 2306309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2306312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2306315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306327 */   GIM_Try, /*On fail goto*//*Label 31529*/ GIMT_Encode4(2306375), // Rule ID 53624 //
     /* 2306332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2306335 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2306338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2306352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306374 */     // GIR_Coverage, 53624,
     /* 2306374 */     GIR_EraseRootFromParent_Done,
     /* 2306375 */   // Label 31529: @2306375
     /* 2306375 */   GIM_Try, /*On fail goto*//*Label 31530*/ GIMT_Encode4(2306423), // Rule ID 53625 //
     /* 2306380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306383 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2306386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2306400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306422 */     // GIR_Coverage, 53625,
     /* 2306422 */     GIR_EraseRootFromParent_Done,
     /* 2306423 */   // Label 31530: @2306423
     /* 2306423 */   GIM_Reject,
     /* 2306424 */ // Label 31528: @2306424
     /* 2306424 */ GIM_Reject,
     /* 2306425 */ // Label 31481: @2306425
     /* 2306425 */ GIM_Try, /*On fail goto*//*Label 31531*/ GIMT_Encode4(2306545),
     /* 2306430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2306433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2306436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306448 */   GIM_Try, /*On fail goto*//*Label 31532*/ GIMT_Encode4(2306496), // Rule ID 53540 //
     /* 2306453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2306456 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2306459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2306473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306495 */     // GIR_Coverage, 53540,
     /* 2306495 */     GIR_EraseRootFromParent_Done,
     /* 2306496 */   // Label 31532: @2306496
     /* 2306496 */   GIM_Try, /*On fail goto*//*Label 31533*/ GIMT_Encode4(2306544), // Rule ID 53541 //
     /* 2306501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2306504 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2306507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2306521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306543 */     // GIR_Coverage, 53541,
     /* 2306543 */     GIR_EraseRootFromParent_Done,
     /* 2306544 */   // Label 31533: @2306544
     /* 2306544 */   GIM_Reject,
     /* 2306545 */ // Label 31531: @2306545
     /* 2306545 */ GIM_Reject,
     /* 2306546 */ // Label 31482: @2306546
     /* 2306546 */ GIM_Try, /*On fail goto*//*Label 31534*/ GIMT_Encode4(2306666),
     /* 2306551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2306554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2306557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306569 */   GIM_Try, /*On fail goto*//*Label 31535*/ GIMT_Encode4(2306617), // Rule ID 53588 //
     /* 2306574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2306577 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2306580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2306594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306616 */     // GIR_Coverage, 53588,
     /* 2306616 */     GIR_EraseRootFromParent_Done,
     /* 2306617 */   // Label 31535: @2306617
     /* 2306617 */   GIM_Try, /*On fail goto*//*Label 31536*/ GIMT_Encode4(2306665), // Rule ID 53589 //
     /* 2306622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2306625 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2306628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2306642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306664 */     // GIR_Coverage, 53589,
     /* 2306664 */     GIR_EraseRootFromParent_Done,
     /* 2306665 */   // Label 31536: @2306665
     /* 2306665 */   GIM_Reject,
     /* 2306666 */ // Label 31534: @2306666
     /* 2306666 */ GIM_Reject,
     /* 2306667 */ // Label 31483: @2306667
     /* 2306667 */ GIM_Try, /*On fail goto*//*Label 31537*/ GIMT_Encode4(2306787),
     /* 2306672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2306678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306690 */   GIM_Try, /*On fail goto*//*Label 31538*/ GIMT_Encode4(2306738), // Rule ID 53636 //
     /* 2306695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2306698 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2306701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2306715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306737 */     // GIR_Coverage, 53636,
     /* 2306737 */     GIR_EraseRootFromParent_Done,
     /* 2306738 */   // Label 31538: @2306738
     /* 2306738 */   GIM_Try, /*On fail goto*//*Label 31539*/ GIMT_Encode4(2306786), // Rule ID 53637 //
     /* 2306743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306746 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2306749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2306763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306785 */     // GIR_Coverage, 53637,
     /* 2306785 */     GIR_EraseRootFromParent_Done,
     /* 2306786 */   // Label 31539: @2306786
     /* 2306786 */   GIM_Reject,
     /* 2306787 */ // Label 31537: @2306787
     /* 2306787 */ GIM_Reject,
     /* 2306788 */ // Label 31484: @2306788
     /* 2306788 */ GIM_Try, /*On fail goto*//*Label 31540*/ GIMT_Encode4(2306908),
     /* 2306793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2306796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2306799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306811 */   GIM_Try, /*On fail goto*//*Label 31541*/ GIMT_Encode4(2306859), // Rule ID 53552 //
     /* 2306816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2306819 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2306822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2306836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306858 */     // GIR_Coverage, 53552,
     /* 2306858 */     GIR_EraseRootFromParent_Done,
     /* 2306859 */   // Label 31541: @2306859
     /* 2306859 */   GIM_Try, /*On fail goto*//*Label 31542*/ GIMT_Encode4(2306907), // Rule ID 53553 //
     /* 2306864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2306867 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2306870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2306884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306906 */     // GIR_Coverage, 53553,
     /* 2306906 */     GIR_EraseRootFromParent_Done,
     /* 2306907 */   // Label 31542: @2306907
     /* 2306907 */   GIM_Reject,
     /* 2306908 */ // Label 31540: @2306908
     /* 2306908 */ GIM_Reject,
     /* 2306909 */ // Label 31485: @2306909
     /* 2306909 */ GIM_Try, /*On fail goto*//*Label 31543*/ GIMT_Encode4(2307029),
     /* 2306914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2306917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2306920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306932 */   GIM_Try, /*On fail goto*//*Label 31544*/ GIMT_Encode4(2306980), // Rule ID 53600 //
     /* 2306937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2306940 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2306943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2306957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306979 */     // GIR_Coverage, 53600,
     /* 2306979 */     GIR_EraseRootFromParent_Done,
     /* 2306980 */   // Label 31544: @2306980
     /* 2306980 */   GIM_Try, /*On fail goto*//*Label 31545*/ GIMT_Encode4(2307028), // Rule ID 53601 //
     /* 2306985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2306988 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2306991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2307005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307027 */     // GIR_Coverage, 53601,
     /* 2307027 */     GIR_EraseRootFromParent_Done,
     /* 2307028 */   // Label 31545: @2307028
     /* 2307028 */   GIM_Reject,
     /* 2307029 */ // Label 31543: @2307029
     /* 2307029 */ GIM_Reject,
     /* 2307030 */ // Label 31486: @2307030
     /* 2307030 */ GIM_Try, /*On fail goto*//*Label 31546*/ GIMT_Encode4(2307150),
     /* 2307035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2307038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2307041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307053 */   GIM_Try, /*On fail goto*//*Label 31547*/ GIMT_Encode4(2307101), // Rule ID 53564 //
     /* 2307058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2307061 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2307061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2307064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2307078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307100 */     // GIR_Coverage, 53564,
     /* 2307100 */     GIR_EraseRootFromParent_Done,
     /* 2307101 */   // Label 31547: @2307101
     /* 2307101 */   GIM_Try, /*On fail goto*//*Label 31548*/ GIMT_Encode4(2307149), // Rule ID 53565 //
     /* 2307106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2307109 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2307109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2307112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2307126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307148 */     // GIR_Coverage, 53565,
     /* 2307148 */     GIR_EraseRootFromParent_Done,
     /* 2307149 */   // Label 31548: @2307149
     /* 2307149 */   GIM_Reject,
     /* 2307150 */ // Label 31546: @2307150
     /* 2307150 */ GIM_Reject,
     /* 2307151 */ // Label 31487: @2307151
     /* 2307151 */ GIM_Reject,
     /* 2307152 */ // Label 61: @2307152
     /* 2307152 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31567*/ GIMT_Encode4(2309579),
     /* 2307163 */ /*GILLT_s16*//*Label 31549*/ GIMT_Encode4(2307283),
     /* 2307167 */ /*GILLT_s32*//*Label 31550*/ GIMT_Encode4(2307432),
     /* 2307171 */ /*GILLT_s64*//*Label 31551*/ GIMT_Encode4(2307581), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307183 */ /*GILLT_nxv1s16*//*Label 31552*/ GIMT_Encode4(2307764),
     /* 2307187 */ /*GILLT_nxv1s32*//*Label 31553*/ GIMT_Encode4(2307885),
     /* 2307191 */ /*GILLT_nxv1s64*//*Label 31554*/ GIMT_Encode4(2308006), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307203 */ /*GILLT_nxv2s16*//*Label 31555*/ GIMT_Encode4(2308127),
     /* 2307207 */ /*GILLT_nxv2s32*//*Label 31556*/ GIMT_Encode4(2308248),
     /* 2307211 */ /*GILLT_nxv2s64*//*Label 31557*/ GIMT_Encode4(2308369), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307223 */ /*GILLT_nxv4s16*//*Label 31558*/ GIMT_Encode4(2308490),
     /* 2307227 */ /*GILLT_nxv4s32*//*Label 31559*/ GIMT_Encode4(2308611),
     /* 2307231 */ /*GILLT_nxv4s64*//*Label 31560*/ GIMT_Encode4(2308732), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307243 */ /*GILLT_nxv8s16*//*Label 31561*/ GIMT_Encode4(2308853),
     /* 2307247 */ /*GILLT_nxv8s32*//*Label 31562*/ GIMT_Encode4(2308974),
     /* 2307251 */ /*GILLT_nxv8s64*//*Label 31563*/ GIMT_Encode4(2309095), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307263 */ /*GILLT_nxv16s16*//*Label 31564*/ GIMT_Encode4(2309216),
     /* 2307267 */ /*GILLT_nxv16s32*//*Label 31565*/ GIMT_Encode4(2309337), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307279 */ /*GILLT_nxv32s16*//*Label 31566*/ GIMT_Encode4(2309458),
     /* 2307283 */ // Label 31549: @2307283
     /* 2307283 */ GIM_Try, /*On fail goto*//*Label 31568*/ GIMT_Encode4(2307431),
     /* 2307288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2307291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2307294 */   GIM_Try, /*On fail goto*//*Label 31569*/ GIMT_Encode4(2307328), // Rule ID 1982 //
     /* 2307299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2307302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307314 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2307314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2307317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307327 */     // GIR_Coverage, 1982,
     /* 2307327 */     GIR_EraseRootFromParent_Done,
     /* 2307328 */   // Label 31569: @2307328
     /* 2307328 */   GIM_Try, /*On fail goto*//*Label 31570*/ GIMT_Encode4(2307362), // Rule ID 1983 //
     /* 2307333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2307336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307348 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2307348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2307351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307361 */     // GIR_Coverage, 1983,
     /* 2307361 */     GIR_EraseRootFromParent_Done,
     /* 2307362 */   // Label 31570: @2307362
     /* 2307362 */   GIM_Try, /*On fail goto*//*Label 31571*/ GIMT_Encode4(2307396), // Rule ID 1986 //
     /* 2307367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2307370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307382 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2307382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2307385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307395 */     // GIR_Coverage, 1986,
     /* 2307395 */     GIR_EraseRootFromParent_Done,
     /* 2307396 */   // Label 31571: @2307396
     /* 2307396 */   GIM_Try, /*On fail goto*//*Label 31572*/ GIMT_Encode4(2307430), // Rule ID 1987 //
     /* 2307401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2307404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307416 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2307416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2307419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307429 */     // GIR_Coverage, 1987,
     /* 2307429 */     GIR_EraseRootFromParent_Done,
     /* 2307430 */   // Label 31572: @2307430
     /* 2307430 */   GIM_Reject,
     /* 2307431 */ // Label 31568: @2307431
     /* 2307431 */ GIM_Reject,
     /* 2307432 */ // Label 31550: @2307432
     /* 2307432 */ GIM_Try, /*On fail goto*//*Label 31573*/ GIMT_Encode4(2307580),
     /* 2307437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2307443 */   GIM_Try, /*On fail goto*//*Label 31574*/ GIMT_Encode4(2307477), // Rule ID 1273 //
     /* 2307448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2307451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307463 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2307463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2307466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307476 */     // GIR_Coverage, 1273,
     /* 2307476 */     GIR_EraseRootFromParent_Done,
     /* 2307477 */   // Label 31574: @2307477
     /* 2307477 */   GIM_Try, /*On fail goto*//*Label 31575*/ GIMT_Encode4(2307511), // Rule ID 1274 //
     /* 2307482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2307485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307497 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2307497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2307500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307510 */     // GIR_Coverage, 1274,
     /* 2307510 */     GIR_EraseRootFromParent_Done,
     /* 2307511 */   // Label 31575: @2307511
     /* 2307511 */   GIM_Try, /*On fail goto*//*Label 31576*/ GIMT_Encode4(2307545), // Rule ID 1277 //
     /* 2307516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2307519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307531 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2307531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2307534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307544 */     // GIR_Coverage, 1277,
     /* 2307544 */     GIR_EraseRootFromParent_Done,
     /* 2307545 */   // Label 31576: @2307545
     /* 2307545 */   GIM_Try, /*On fail goto*//*Label 31577*/ GIMT_Encode4(2307579), // Rule ID 1278 //
     /* 2307550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2307553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307565 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2307565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2307568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307578 */     // GIR_Coverage, 1278,
     /* 2307578 */     GIR_EraseRootFromParent_Done,
     /* 2307579 */   // Label 31577: @2307579
     /* 2307579 */   GIM_Reject,
     /* 2307580 */ // Label 31573: @2307580
     /* 2307580 */ GIM_Reject,
     /* 2307581 */ // Label 31551: @2307581
     /* 2307581 */ GIM_Try, /*On fail goto*//*Label 31578*/ GIMT_Encode4(2307763),
     /* 2307586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2307592 */   GIM_Try, /*On fail goto*//*Label 31579*/ GIMT_Encode4(2307626), // Rule ID 1612 //
     /* 2307597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2307600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307612 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2307612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2307615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307625 */     // GIR_Coverage, 1612,
     /* 2307625 */     GIR_EraseRootFromParent_Done,
     /* 2307626 */   // Label 31579: @2307626
     /* 2307626 */   GIM_Try, /*On fail goto*//*Label 31580*/ GIMT_Encode4(2307660), // Rule ID 1613 //
     /* 2307631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2307634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307646 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2307646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2307649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307659 */     // GIR_Coverage, 1613,
     /* 2307659 */     GIR_EraseRootFromParent_Done,
     /* 2307660 */   // Label 31580: @2307660
     /* 2307660 */   GIM_Try, /*On fail goto*//*Label 31581*/ GIMT_Encode4(2307694), // Rule ID 1616 //
     /* 2307665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2307668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307680 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2307680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2307683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307693 */     // GIR_Coverage, 1616,
     /* 2307693 */     GIR_EraseRootFromParent_Done,
     /* 2307694 */   // Label 31581: @2307694
     /* 2307694 */   GIM_Try, /*On fail goto*//*Label 31582*/ GIMT_Encode4(2307728), // Rule ID 1617 //
     /* 2307699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2307702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307714 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2307714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2307717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307727 */     // GIR_Coverage, 1617,
     /* 2307727 */     GIR_EraseRootFromParent_Done,
     /* 2307728 */   // Label 31582: @2307728
     /* 2307728 */   GIM_Try, /*On fail goto*//*Label 31583*/ GIMT_Encode4(2307762), // Rule ID 1619 //
     /* 2307733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2307736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307748 */     // (fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2307748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2307751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307761 */     // GIR_Coverage, 1619,
     /* 2307761 */     GIR_EraseRootFromParent_Done,
     /* 2307762 */   // Label 31583: @2307762
     /* 2307762 */   GIM_Reject,
     /* 2307763 */ // Label 31578: @2307763
     /* 2307763 */ GIM_Reject,
     /* 2307764 */ // Label 31552: @2307764
     /* 2307764 */ GIM_Try, /*On fail goto*//*Label 31584*/ GIMT_Encode4(2307884),
     /* 2307769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2307772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2307775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307787 */   GIM_Try, /*On fail goto*//*Label 31585*/ GIMT_Encode4(2307835), // Rule ID 54236 //
     /* 2307792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2307795 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2307795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2307798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2307812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307834 */     // GIR_Coverage, 54236,
     /* 2307834 */     GIR_EraseRootFromParent_Done,
     /* 2307835 */   // Label 31585: @2307835
     /* 2307835 */   GIM_Try, /*On fail goto*//*Label 31586*/ GIMT_Encode4(2307883), // Rule ID 54237 //
     /* 2307840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2307843 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2307843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2307846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2307860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307882 */     // GIR_Coverage, 54237,
     /* 2307882 */     GIR_EraseRootFromParent_Done,
     /* 2307883 */   // Label 31586: @2307883
     /* 2307883 */   GIM_Reject,
     /* 2307884 */ // Label 31584: @2307884
     /* 2307884 */ GIM_Reject,
     /* 2307885 */ // Label 31553: @2307885
     /* 2307885 */ GIM_Try, /*On fail goto*//*Label 31587*/ GIMT_Encode4(2308005),
     /* 2307890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2307893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2307896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307904 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307908 */   GIM_Try, /*On fail goto*//*Label 31588*/ GIMT_Encode4(2307956), // Rule ID 54260 //
     /* 2307913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2307916 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2307916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2307919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2307933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307955 */     // GIR_Coverage, 54260,
     /* 2307955 */     GIR_EraseRootFromParent_Done,
     /* 2307956 */   // Label 31588: @2307956
     /* 2307956 */   GIM_Try, /*On fail goto*//*Label 31589*/ GIMT_Encode4(2308004), // Rule ID 54261 //
     /* 2307961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2307964 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2307964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2307967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2307981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308003 */     // GIR_Coverage, 54261,
     /* 2308003 */     GIR_EraseRootFromParent_Done,
     /* 2308004 */   // Label 31589: @2308004
     /* 2308004 */   GIM_Reject,
     /* 2308005 */ // Label 31587: @2308005
     /* 2308005 */ GIM_Reject,
     /* 2308006 */ // Label 31554: @2308006
     /* 2308006 */ GIM_Try, /*On fail goto*//*Label 31590*/ GIMT_Encode4(2308126),
     /* 2308011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2308014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2308017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308025 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308029 */   GIM_Try, /*On fail goto*//*Label 31591*/ GIMT_Encode4(2308077), // Rule ID 54296 //
     /* 2308034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2308037 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2308040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2308054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308076 */     // GIR_Coverage, 54296,
     /* 2308076 */     GIR_EraseRootFromParent_Done,
     /* 2308077 */   // Label 31591: @2308077
     /* 2308077 */   GIM_Try, /*On fail goto*//*Label 31592*/ GIMT_Encode4(2308125), // Rule ID 54297 //
     /* 2308082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2308085 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2308088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2308102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308124 */     // GIR_Coverage, 54297,
     /* 2308124 */     GIR_EraseRootFromParent_Done,
     /* 2308125 */   // Label 31592: @2308125
     /* 2308125 */   GIM_Reject,
     /* 2308126 */ // Label 31590: @2308126
     /* 2308126 */ GIM_Reject,
     /* 2308127 */ // Label 31555: @2308127
     /* 2308127 */ GIM_Try, /*On fail goto*//*Label 31593*/ GIMT_Encode4(2308247),
     /* 2308132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2308135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2308138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308150 */   GIM_Try, /*On fail goto*//*Label 31594*/ GIMT_Encode4(2308198), // Rule ID 54248 //
     /* 2308155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308158 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2308161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2308175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308197 */     // GIR_Coverage, 54248,
     /* 2308197 */     GIR_EraseRootFromParent_Done,
     /* 2308198 */   // Label 31594: @2308198
     /* 2308198 */   GIM_Try, /*On fail goto*//*Label 31595*/ GIMT_Encode4(2308246), // Rule ID 54249 //
     /* 2308203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308206 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2308209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2308223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308245 */     // GIR_Coverage, 54249,
     /* 2308245 */     GIR_EraseRootFromParent_Done,
     /* 2308246 */   // Label 31595: @2308246
     /* 2308246 */   GIM_Reject,
     /* 2308247 */ // Label 31593: @2308247
     /* 2308247 */ GIM_Reject,
     /* 2308248 */ // Label 31556: @2308248
     /* 2308248 */ GIM_Try, /*On fail goto*//*Label 31596*/ GIMT_Encode4(2308368),
     /* 2308253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2308256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2308259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308271 */   GIM_Try, /*On fail goto*//*Label 31597*/ GIMT_Encode4(2308319), // Rule ID 54284 //
     /* 2308276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2308279 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2308282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2308296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308318 */     // GIR_Coverage, 54284,
     /* 2308318 */     GIR_EraseRootFromParent_Done,
     /* 2308319 */   // Label 31597: @2308319
     /* 2308319 */   GIM_Try, /*On fail goto*//*Label 31598*/ GIMT_Encode4(2308367), // Rule ID 54285 //
     /* 2308324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2308327 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2308330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2308344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308366 */     // GIR_Coverage, 54285,
     /* 2308366 */     GIR_EraseRootFromParent_Done,
     /* 2308367 */   // Label 31598: @2308367
     /* 2308367 */   GIM_Reject,
     /* 2308368 */ // Label 31596: @2308368
     /* 2308368 */ GIM_Reject,
     /* 2308369 */ // Label 31557: @2308369
     /* 2308369 */ GIM_Try, /*On fail goto*//*Label 31599*/ GIMT_Encode4(2308489),
     /* 2308374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2308377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2308380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308392 */   GIM_Try, /*On fail goto*//*Label 31600*/ GIMT_Encode4(2308440), // Rule ID 54380 //
     /* 2308397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2308400 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2308403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2308417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308439 */     // GIR_Coverage, 54380,
     /* 2308439 */     GIR_EraseRootFromParent_Done,
     /* 2308440 */   // Label 31600: @2308440
     /* 2308440 */   GIM_Try, /*On fail goto*//*Label 31601*/ GIMT_Encode4(2308488), // Rule ID 54381 //
     /* 2308445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2308448 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2308451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2308465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308487 */     // GIR_Coverage, 54381,
     /* 2308487 */     GIR_EraseRootFromParent_Done,
     /* 2308488 */   // Label 31601: @2308488
     /* 2308488 */   GIM_Reject,
     /* 2308489 */ // Label 31599: @2308489
     /* 2308489 */ GIM_Reject,
     /* 2308490 */ // Label 31558: @2308490
     /* 2308490 */ GIM_Try, /*On fail goto*//*Label 31602*/ GIMT_Encode4(2308610),
     /* 2308495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2308498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2308501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308513 */   GIM_Try, /*On fail goto*//*Label 31603*/ GIMT_Encode4(2308561), // Rule ID 54272 //
     /* 2308518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308521 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2308524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2308538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308560 */     // GIR_Coverage, 54272,
     /* 2308560 */     GIR_EraseRootFromParent_Done,
     /* 2308561 */   // Label 31603: @2308561
     /* 2308561 */   GIM_Try, /*On fail goto*//*Label 31604*/ GIMT_Encode4(2308609), // Rule ID 54273 //
     /* 2308566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308569 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2308572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2308586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308608 */     // GIR_Coverage, 54273,
     /* 2308608 */     GIR_EraseRootFromParent_Done,
     /* 2308609 */   // Label 31604: @2308609
     /* 2308609 */   GIM_Reject,
     /* 2308610 */ // Label 31602: @2308610
     /* 2308610 */ GIM_Reject,
     /* 2308611 */ // Label 31559: @2308611
     /* 2308611 */ GIM_Try, /*On fail goto*//*Label 31605*/ GIMT_Encode4(2308731),
     /* 2308616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2308619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2308622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308634 */   GIM_Try, /*On fail goto*//*Label 31606*/ GIMT_Encode4(2308682), // Rule ID 54344 //
     /* 2308639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2308642 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2308645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2308659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308681 */     // GIR_Coverage, 54344,
     /* 2308681 */     GIR_EraseRootFromParent_Done,
     /* 2308682 */   // Label 31606: @2308682
     /* 2308682 */   GIM_Try, /*On fail goto*//*Label 31607*/ GIMT_Encode4(2308730), // Rule ID 54345 //
     /* 2308687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2308690 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2308693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2308707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308729 */     // GIR_Coverage, 54345,
     /* 2308729 */     GIR_EraseRootFromParent_Done,
     /* 2308730 */   // Label 31607: @2308730
     /* 2308730 */   GIM_Reject,
     /* 2308731 */ // Label 31605: @2308731
     /* 2308731 */ GIM_Reject,
     /* 2308732 */ // Label 31560: @2308732
     /* 2308732 */ GIM_Try, /*On fail goto*//*Label 31608*/ GIMT_Encode4(2308852),
     /* 2308737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2308740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2308743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308755 */   GIM_Try, /*On fail goto*//*Label 31609*/ GIMT_Encode4(2308803), // Rule ID 54392 //
     /* 2308760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2308763 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2308766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2308780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308802 */     // GIR_Coverage, 54392,
     /* 2308802 */     GIR_EraseRootFromParent_Done,
     /* 2308803 */   // Label 31609: @2308803
     /* 2308803 */   GIM_Try, /*On fail goto*//*Label 31610*/ GIMT_Encode4(2308851), // Rule ID 54393 //
     /* 2308808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2308811 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2308814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2308828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308850 */     // GIR_Coverage, 54393,
     /* 2308850 */     GIR_EraseRootFromParent_Done,
     /* 2308851 */   // Label 31610: @2308851
     /* 2308851 */   GIM_Reject,
     /* 2308852 */ // Label 31608: @2308852
     /* 2308852 */ GIM_Reject,
     /* 2308853 */ // Label 31561: @2308853
     /* 2308853 */ GIM_Try, /*On fail goto*//*Label 31611*/ GIMT_Encode4(2308973),
     /* 2308858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2308861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2308864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308876 */   GIM_Try, /*On fail goto*//*Label 31612*/ GIMT_Encode4(2308924), // Rule ID 54308 //
     /* 2308881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308884 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2308887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2308901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308923 */     // GIR_Coverage, 54308,
     /* 2308923 */     GIR_EraseRootFromParent_Done,
     /* 2308924 */   // Label 31612: @2308924
     /* 2308924 */   GIM_Try, /*On fail goto*//*Label 31613*/ GIMT_Encode4(2308972), // Rule ID 54309 //
     /* 2308929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308932 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2308935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2308949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308971 */     // GIR_Coverage, 54309,
     /* 2308971 */     GIR_EraseRootFromParent_Done,
     /* 2308972 */   // Label 31613: @2308972
     /* 2308972 */   GIM_Reject,
     /* 2308973 */ // Label 31611: @2308973
     /* 2308973 */ GIM_Reject,
     /* 2308974 */ // Label 31562: @2308974
     /* 2308974 */ GIM_Try, /*On fail goto*//*Label 31614*/ GIMT_Encode4(2309094),
     /* 2308979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2308982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2308985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308997 */   GIM_Try, /*On fail goto*//*Label 31615*/ GIMT_Encode4(2309045), // Rule ID 54356 //
     /* 2309002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309005 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2309008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2309022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309044 */     // GIR_Coverage, 54356,
     /* 2309044 */     GIR_EraseRootFromParent_Done,
     /* 2309045 */   // Label 31615: @2309045
     /* 2309045 */   GIM_Try, /*On fail goto*//*Label 31616*/ GIMT_Encode4(2309093), // Rule ID 54357 //
     /* 2309050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309053 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2309056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2309070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309092 */     // GIR_Coverage, 54357,
     /* 2309092 */     GIR_EraseRootFromParent_Done,
     /* 2309093 */   // Label 31616: @2309093
     /* 2309093 */   GIM_Reject,
     /* 2309094 */ // Label 31614: @2309094
     /* 2309094 */ GIM_Reject,
     /* 2309095 */ // Label 31563: @2309095
     /* 2309095 */ GIM_Try, /*On fail goto*//*Label 31617*/ GIMT_Encode4(2309215),
     /* 2309100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2309103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2309106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309118 */   GIM_Try, /*On fail goto*//*Label 31618*/ GIMT_Encode4(2309166), // Rule ID 54404 //
     /* 2309123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2309126 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2309129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2309143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2309161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309165 */     // GIR_Coverage, 54404,
     /* 2309165 */     GIR_EraseRootFromParent_Done,
     /* 2309166 */   // Label 31618: @2309166
     /* 2309166 */   GIM_Try, /*On fail goto*//*Label 31619*/ GIMT_Encode4(2309214), // Rule ID 54405 //
     /* 2309171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2309174 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2309177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2309191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2309209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309213 */     // GIR_Coverage, 54405,
     /* 2309213 */     GIR_EraseRootFromParent_Done,
     /* 2309214 */   // Label 31619: @2309214
     /* 2309214 */   GIM_Reject,
     /* 2309215 */ // Label 31617: @2309215
     /* 2309215 */ GIM_Reject,
     /* 2309216 */ // Label 31564: @2309216
     /* 2309216 */ GIM_Try, /*On fail goto*//*Label 31620*/ GIMT_Encode4(2309336),
     /* 2309221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2309224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2309227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2309231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2309235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2309239 */   GIM_Try, /*On fail goto*//*Label 31621*/ GIMT_Encode4(2309287), // Rule ID 54320 //
     /* 2309244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2309247 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2309250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2309264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309286 */     // GIR_Coverage, 54320,
     /* 2309286 */     GIR_EraseRootFromParent_Done,
     /* 2309287 */   // Label 31621: @2309287
     /* 2309287 */   GIM_Try, /*On fail goto*//*Label 31622*/ GIMT_Encode4(2309335), // Rule ID 54321 //
     /* 2309292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2309295 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2309298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2309312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309334 */     // GIR_Coverage, 54321,
     /* 2309334 */     GIR_EraseRootFromParent_Done,
     /* 2309335 */   // Label 31622: @2309335
     /* 2309335 */   GIM_Reject,
     /* 2309336 */ // Label 31620: @2309336
     /* 2309336 */ GIM_Reject,
     /* 2309337 */ // Label 31565: @2309337
     /* 2309337 */ GIM_Try, /*On fail goto*//*Label 31623*/ GIMT_Encode4(2309457),
     /* 2309342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2309345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2309348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309360 */   GIM_Try, /*On fail goto*//*Label 31624*/ GIMT_Encode4(2309408), // Rule ID 54368 //
     /* 2309365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309368 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2309371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2309385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309407 */     // GIR_Coverage, 54368,
     /* 2309407 */     GIR_EraseRootFromParent_Done,
     /* 2309408 */   // Label 31624: @2309408
     /* 2309408 */   GIM_Try, /*On fail goto*//*Label 31625*/ GIMT_Encode4(2309456), // Rule ID 54369 //
     /* 2309413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309416 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2309419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2309433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309455 */     // GIR_Coverage, 54369,
     /* 2309455 */     GIR_EraseRootFromParent_Done,
     /* 2309456 */   // Label 31625: @2309456
     /* 2309456 */   GIM_Reject,
     /* 2309457 */ // Label 31623: @2309457
     /* 2309457 */ GIM_Reject,
     /* 2309458 */ // Label 31566: @2309458
     /* 2309458 */ GIM_Try, /*On fail goto*//*Label 31626*/ GIMT_Encode4(2309578),
     /* 2309463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2309466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2309469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309481 */   GIM_Try, /*On fail goto*//*Label 31627*/ GIMT_Encode4(2309529), // Rule ID 54332 //
     /* 2309486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2309489 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2309492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2309506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309528 */     // GIR_Coverage, 54332,
     /* 2309528 */     GIR_EraseRootFromParent_Done,
     /* 2309529 */   // Label 31627: @2309529
     /* 2309529 */   GIM_Try, /*On fail goto*//*Label 31628*/ GIMT_Encode4(2309577), // Rule ID 54333 //
     /* 2309534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2309537 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2309540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2309554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309576 */     // GIR_Coverage, 54333,
     /* 2309576 */     GIR_EraseRootFromParent_Done,
     /* 2309577 */   // Label 31628: @2309577
     /* 2309577 */   GIM_Reject,
     /* 2309578 */ // Label 31626: @2309578
     /* 2309578 */ GIM_Reject,
     /* 2309579 */ // Label 31567: @2309579
     /* 2309579 */ GIM_Reject,
     /* 2309580 */ // Label 62: @2309580
     /* 2309580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31647*/ GIMT_Encode4(2326224),
     /* 2309591 */ /*GILLT_s16*//*Label 31629*/ GIMT_Encode4(2309711),
     /* 2309595 */ /*GILLT_s32*//*Label 31630*/ GIMT_Encode4(2311147),
     /* 2309599 */ /*GILLT_s64*//*Label 31631*/ GIMT_Encode4(2312583), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309611 */ /*GILLT_nxv1s16*//*Label 31632*/ GIMT_Encode4(2314374),
     /* 2309615 */ /*GILLT_nxv1s32*//*Label 31633*/ GIMT_Encode4(2315164),
     /* 2309619 */ /*GILLT_nxv1s64*//*Label 31634*/ GIMT_Encode4(2315954), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309631 */ /*GILLT_nxv2s16*//*Label 31635*/ GIMT_Encode4(2316744),
     /* 2309635 */ /*GILLT_nxv2s32*//*Label 31636*/ GIMT_Encode4(2317534),
     /* 2309639 */ /*GILLT_nxv2s64*//*Label 31637*/ GIMT_Encode4(2318324), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309651 */ /*GILLT_nxv4s16*//*Label 31638*/ GIMT_Encode4(2319114),
     /* 2309655 */ /*GILLT_nxv4s32*//*Label 31639*/ GIMT_Encode4(2319904),
     /* 2309659 */ /*GILLT_nxv4s64*//*Label 31640*/ GIMT_Encode4(2320694), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309671 */ /*GILLT_nxv8s16*//*Label 31641*/ GIMT_Encode4(2321484),
     /* 2309675 */ /*GILLT_nxv8s32*//*Label 31642*/ GIMT_Encode4(2322274),
     /* 2309679 */ /*GILLT_nxv8s64*//*Label 31643*/ GIMT_Encode4(2323064), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309691 */ /*GILLT_nxv16s16*//*Label 31644*/ GIMT_Encode4(2323854),
     /* 2309695 */ /*GILLT_nxv16s32*//*Label 31645*/ GIMT_Encode4(2324644), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309707 */ /*GILLT_nxv32s16*//*Label 31646*/ GIMT_Encode4(2325434),
     /* 2309711 */ // Label 31629: @2309711
     /* 2309711 */ GIM_Try, /*On fail goto*//*Label 31648*/ GIMT_Encode4(2311146),
     /* 2309716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2309722 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2309725 */   GIM_Try, /*On fail goto*//*Label 31649*/ GIMT_Encode4(2309797), // Rule ID 2023 //
     /* 2309730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2309733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309777 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2309777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2309780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309796 */     // GIR_Coverage, 2023,
     /* 2309796 */     GIR_EraseRootFromParent_Done,
     /* 2309797 */   // Label 31649: @2309797
     /* 2309797 */   GIM_Try, /*On fail goto*//*Label 31650*/ GIMT_Encode4(2309869), // Rule ID 2024 //
     /* 2309802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2309805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309849 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2309849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2309852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309868 */     // GIR_Coverage, 2024,
     /* 2309868 */     GIR_EraseRootFromParent_Done,
     /* 2309869 */   // Label 31650: @2309869
     /* 2309869 */   GIM_Try, /*On fail goto*//*Label 31651*/ GIMT_Encode4(2309941), // Rule ID 2056 //
     /* 2309874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2309877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309921 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2309921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2309924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309940 */     // GIR_Coverage, 2056,
     /* 2309940 */     GIR_EraseRootFromParent_Done,
     /* 2309941 */   // Label 31651: @2309941
     /* 2309941 */   GIM_Try, /*On fail goto*//*Label 31652*/ GIMT_Encode4(2310013), // Rule ID 2057 //
     /* 2309946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2309949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309993 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2309993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2309996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2310008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310012 */     // GIR_Coverage, 2057,
     /* 2310012 */     GIR_EraseRootFromParent_Done,
     /* 2310013 */   // Label 31652: @2310013
     /* 2310013 */   GIM_Try, /*On fail goto*//*Label 31653*/ GIMT_Encode4(2310085), // Rule ID 65537 //
     /* 2310018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2310021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310065 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2310068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2310080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310084 */     // GIR_Coverage, 65537,
     /* 2310084 */     GIR_EraseRootFromParent_Done,
     /* 2310085 */   // Label 31653: @2310085
     /* 2310085 */   GIM_Try, /*On fail goto*//*Label 31654*/ GIMT_Encode4(2310157), // Rule ID 65538 //
     /* 2310090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2310093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310137 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2310140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2310152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310156 */     // GIR_Coverage, 65538,
     /* 2310156 */     GIR_EraseRootFromParent_Done,
     /* 2310157 */   // Label 31654: @2310157
     /* 2310157 */   GIM_Try, /*On fail goto*//*Label 31655*/ GIMT_Encode4(2310229), // Rule ID 65545 //
     /* 2310162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2310165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310209 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2310212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2310224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310228 */     // GIR_Coverage, 65545,
     /* 2310228 */     GIR_EraseRootFromParent_Done,
     /* 2310229 */   // Label 31655: @2310229
     /* 2310229 */   GIM_Try, /*On fail goto*//*Label 31656*/ GIMT_Encode4(2310301), // Rule ID 65546 //
     /* 2310234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2310237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310281 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2310284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2310296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310300 */     // GIR_Coverage, 65546,
     /* 2310300 */     GIR_EraseRootFromParent_Done,
     /* 2310301 */   // Label 31656: @2310301
     /* 2310301 */   GIM_Try, /*On fail goto*//*Label 31657*/ GIMT_Encode4(2310358), // Rule ID 2019 //
     /* 2310306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2310309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310340 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2310343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310357 */     // GIR_Coverage, 2019,
     /* 2310357 */     GIR_EraseRootFromParent_Done,
     /* 2310358 */   // Label 31657: @2310358
     /* 2310358 */   GIM_Try, /*On fail goto*//*Label 31658*/ GIMT_Encode4(2310415), // Rule ID 2020 //
     /* 2310363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2310366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310397 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2310400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310414 */     // GIR_Coverage, 2020,
     /* 2310414 */     GIR_EraseRootFromParent_Done,
     /* 2310415 */   // Label 31658: @2310415
     /* 2310415 */   GIM_Try, /*On fail goto*//*Label 31659*/ GIMT_Encode4(2310472), // Rule ID 2052 //
     /* 2310420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2310423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310454 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2310457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310471 */     // GIR_Coverage, 2052,
     /* 2310471 */     GIR_EraseRootFromParent_Done,
     /* 2310472 */   // Label 31659: @2310472
     /* 2310472 */   GIM_Try, /*On fail goto*//*Label 31660*/ GIMT_Encode4(2310529), // Rule ID 2053 //
     /* 2310477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2310480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310511 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2310514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310528 */     // GIR_Coverage, 2053,
     /* 2310528 */     GIR_EraseRootFromParent_Done,
     /* 2310529 */   // Label 31660: @2310529
     /* 2310529 */   GIM_Try, /*On fail goto*//*Label 31661*/ GIMT_Encode4(2310586), // Rule ID 65533 //
     /* 2310534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2310537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310568 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2310571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310585 */     // GIR_Coverage, 65533,
     /* 2310585 */     GIR_EraseRootFromParent_Done,
     /* 2310586 */   // Label 31661: @2310586
     /* 2310586 */   GIM_Try, /*On fail goto*//*Label 31662*/ GIMT_Encode4(2310643), // Rule ID 65534 //
     /* 2310591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2310594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310625 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2310628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310642 */     // GIR_Coverage, 65534,
     /* 2310642 */     GIR_EraseRootFromParent_Done,
     /* 2310643 */   // Label 31662: @2310643
     /* 2310643 */   GIM_Try, /*On fail goto*//*Label 31663*/ GIMT_Encode4(2310700), // Rule ID 65541 //
     /* 2310648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2310651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310682 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2310685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310699 */     // GIR_Coverage, 65541,
     /* 2310699 */     GIR_EraseRootFromParent_Done,
     /* 2310700 */   // Label 31663: @2310700
     /* 2310700 */   GIM_Try, /*On fail goto*//*Label 31664*/ GIMT_Encode4(2310757), // Rule ID 65542 //
     /* 2310705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2310708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310739 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2310742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310756 */     // GIR_Coverage, 65542,
     /* 2310756 */     GIR_EraseRootFromParent_Done,
     /* 2310757 */   // Label 31664: @2310757
     /* 2310757 */   GIM_Try, /*On fail goto*//*Label 31665*/ GIMT_Encode4(2310814), // Rule ID 2015 //
     /* 2310762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2310765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310796 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2310799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310813 */     // GIR_Coverage, 2015,
     /* 2310813 */     GIR_EraseRootFromParent_Done,
     /* 2310814 */   // Label 31665: @2310814
     /* 2310814 */   GIM_Try, /*On fail goto*//*Label 31666*/ GIMT_Encode4(2310871), // Rule ID 2016 //
     /* 2310819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2310822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310853 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2310856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310870 */     // GIR_Coverage, 2016,
     /* 2310870 */     GIR_EraseRootFromParent_Done,
     /* 2310871 */   // Label 31666: @2310871
     /* 2310871 */   GIM_Try, /*On fail goto*//*Label 31667*/ GIMT_Encode4(2310928), // Rule ID 2048 //
     /* 2310876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2310879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310910 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2310913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310927 */     // GIR_Coverage, 2048,
     /* 2310927 */     GIR_EraseRootFromParent_Done,
     /* 2310928 */   // Label 31667: @2310928
     /* 2310928 */   GIM_Try, /*On fail goto*//*Label 31668*/ GIMT_Encode4(2310985), // Rule ID 2049 //
     /* 2310933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2310936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310967 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2310970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310984 */     // GIR_Coverage, 2049,
     /* 2310984 */     GIR_EraseRootFromParent_Done,
     /* 2310985 */   // Label 31668: @2310985
     /* 2310985 */   GIM_Try, /*On fail goto*//*Label 31669*/ GIMT_Encode4(2311025), // Rule ID 2011 //
     /* 2310990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2310993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311009 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2311009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2311012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311024 */     // GIR_Coverage, 2011,
     /* 2311024 */     GIR_EraseRootFromParent_Done,
     /* 2311025 */   // Label 31669: @2311025
     /* 2311025 */   GIM_Try, /*On fail goto*//*Label 31670*/ GIMT_Encode4(2311065), // Rule ID 2012 //
     /* 2311030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2311033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311049 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2311049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2311052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311064 */     // GIR_Coverage, 2012,
     /* 2311064 */     GIR_EraseRootFromParent_Done,
     /* 2311065 */   // Label 31670: @2311065
     /* 2311065 */   GIM_Try, /*On fail goto*//*Label 31671*/ GIMT_Encode4(2311105), // Rule ID 2044 //
     /* 2311070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2311073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311089 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2311089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2311092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311104 */     // GIR_Coverage, 2044,
     /* 2311104 */     GIR_EraseRootFromParent_Done,
     /* 2311105 */   // Label 31671: @2311105
     /* 2311105 */   GIM_Try, /*On fail goto*//*Label 31672*/ GIMT_Encode4(2311145), // Rule ID 2045 //
     /* 2311110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2311113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311129 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2311129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2311132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311144 */     // GIR_Coverage, 2045,
     /* 2311144 */     GIR_EraseRootFromParent_Done,
     /* 2311145 */   // Label 31672: @2311145
     /* 2311145 */   GIM_Reject,
     /* 2311146 */ // Label 31648: @2311146
     /* 2311146 */ GIM_Reject,
     /* 2311147 */ // Label 31630: @2311147
     /* 2311147 */ GIM_Try, /*On fail goto*//*Label 31673*/ GIMT_Encode4(2312582),
     /* 2311152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2311158 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2311161 */   GIM_Try, /*On fail goto*//*Label 31674*/ GIMT_Encode4(2311233), // Rule ID 1322 //
     /* 2311166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2311169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311213 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2311216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311232 */     // GIR_Coverage, 1322,
     /* 2311232 */     GIR_EraseRootFromParent_Done,
     /* 2311233 */   // Label 31674: @2311233
     /* 2311233 */   GIM_Try, /*On fail goto*//*Label 31675*/ GIMT_Encode4(2311305), // Rule ID 1323 //
     /* 2311238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2311241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311285 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2311285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2311288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311304 */     // GIR_Coverage, 1323,
     /* 2311304 */     GIR_EraseRootFromParent_Done,
     /* 2311305 */   // Label 31675: @2311305
     /* 2311305 */   GIM_Try, /*On fail goto*//*Label 31676*/ GIMT_Encode4(2311377), // Rule ID 1343 //
     /* 2311310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2311313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311357 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2311360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311376 */     // GIR_Coverage, 1343,
     /* 2311376 */     GIR_EraseRootFromParent_Done,
     /* 2311377 */   // Label 31676: @2311377
     /* 2311377 */   GIM_Try, /*On fail goto*//*Label 31677*/ GIMT_Encode4(2311449), // Rule ID 1344 //
     /* 2311382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2311385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311429 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2311429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2311432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311448 */     // GIR_Coverage, 1344,
     /* 2311448 */     GIR_EraseRootFromParent_Done,
     /* 2311449 */   // Label 31677: @2311449
     /* 2311449 */   GIM_Try, /*On fail goto*//*Label 31678*/ GIMT_Encode4(2311521), // Rule ID 65501 //
     /* 2311454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2311457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311501 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2311504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2311512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311520 */     // GIR_Coverage, 65501,
     /* 2311520 */     GIR_EraseRootFromParent_Done,
     /* 2311521 */   // Label 31678: @2311521
     /* 2311521 */   GIM_Try, /*On fail goto*//*Label 31679*/ GIMT_Encode4(2311593), // Rule ID 65502 //
     /* 2311526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2311529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311573 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2311573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2311576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2311584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311592 */     // GIR_Coverage, 65502,
     /* 2311592 */     GIR_EraseRootFromParent_Done,
     /* 2311593 */   // Label 31679: @2311593
     /* 2311593 */   GIM_Try, /*On fail goto*//*Label 31680*/ GIMT_Encode4(2311665), // Rule ID 65509 //
     /* 2311598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2311601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311645 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2311648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2311656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311664 */     // GIR_Coverage, 65509,
     /* 2311664 */     GIR_EraseRootFromParent_Done,
     /* 2311665 */   // Label 31680: @2311665
     /* 2311665 */   GIM_Try, /*On fail goto*//*Label 31681*/ GIMT_Encode4(2311737), // Rule ID 65510 //
     /* 2311670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2311673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311717 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2311717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2311720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2311728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311736 */     // GIR_Coverage, 65510,
     /* 2311736 */     GIR_EraseRootFromParent_Done,
     /* 2311737 */   // Label 31681: @2311737
     /* 2311737 */   GIM_Try, /*On fail goto*//*Label 31682*/ GIMT_Encode4(2311794), // Rule ID 1318 //
     /* 2311742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2311745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311776 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2311779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311793 */     // GIR_Coverage, 1318,
     /* 2311793 */     GIR_EraseRootFromParent_Done,
     /* 2311794 */   // Label 31682: @2311794
     /* 2311794 */   GIM_Try, /*On fail goto*//*Label 31683*/ GIMT_Encode4(2311851), // Rule ID 1319 //
     /* 2311799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2311802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311833 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2311833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2311836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311850 */     // GIR_Coverage, 1319,
     /* 2311850 */     GIR_EraseRootFromParent_Done,
     /* 2311851 */   // Label 31683: @2311851
     /* 2311851 */   GIM_Try, /*On fail goto*//*Label 31684*/ GIMT_Encode4(2311908), // Rule ID 1339 //
     /* 2311856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2311859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311890 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2311893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311907 */     // GIR_Coverage, 1339,
     /* 2311907 */     GIR_EraseRootFromParent_Done,
     /* 2311908 */   // Label 31684: @2311908
     /* 2311908 */   GIM_Try, /*On fail goto*//*Label 31685*/ GIMT_Encode4(2311965), // Rule ID 1340 //
     /* 2311913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2311916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311947 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2311947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2311950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311964 */     // GIR_Coverage, 1340,
     /* 2311964 */     GIR_EraseRootFromParent_Done,
     /* 2311965 */   // Label 31685: @2311965
     /* 2311965 */   GIM_Try, /*On fail goto*//*Label 31686*/ GIMT_Encode4(2312022), // Rule ID 65497 //
     /* 2311970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2311973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312004 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2312004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2312007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2312015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312021 */     // GIR_Coverage, 65497,
     /* 2312021 */     GIR_EraseRootFromParent_Done,
     /* 2312022 */   // Label 31686: @2312022
     /* 2312022 */   GIM_Try, /*On fail goto*//*Label 31687*/ GIMT_Encode4(2312079), // Rule ID 65498 //
     /* 2312027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2312030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312061 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2312061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2312064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2312072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312078 */     // GIR_Coverage, 65498,
     /* 2312078 */     GIR_EraseRootFromParent_Done,
     /* 2312079 */   // Label 31687: @2312079
     /* 2312079 */   GIM_Try, /*On fail goto*//*Label 31688*/ GIMT_Encode4(2312136), // Rule ID 65505 //
     /* 2312084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2312087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312118 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2312118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2312121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2312129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312135 */     // GIR_Coverage, 65505,
     /* 2312135 */     GIR_EraseRootFromParent_Done,
     /* 2312136 */   // Label 31688: @2312136
     /* 2312136 */   GIM_Try, /*On fail goto*//*Label 31689*/ GIMT_Encode4(2312193), // Rule ID 65506 //
     /* 2312141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2312144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312175 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2312175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2312178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2312186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312192 */     // GIR_Coverage, 65506,
     /* 2312192 */     GIR_EraseRootFromParent_Done,
     /* 2312193 */   // Label 31689: @2312193
     /* 2312193 */   GIM_Try, /*On fail goto*//*Label 31690*/ GIMT_Encode4(2312250), // Rule ID 1314 //
     /* 2312198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2312201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312232 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2312232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2312235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2312245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312249 */     // GIR_Coverage, 1314,
     /* 2312249 */     GIR_EraseRootFromParent_Done,
     /* 2312250 */   // Label 31690: @2312250
     /* 2312250 */   GIM_Try, /*On fail goto*//*Label 31691*/ GIMT_Encode4(2312307), // Rule ID 1315 //
     /* 2312255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2312258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312289 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2312289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2312292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2312302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312306 */     // GIR_Coverage, 1315,
     /* 2312306 */     GIR_EraseRootFromParent_Done,
     /* 2312307 */   // Label 31691: @2312307
     /* 2312307 */   GIM_Try, /*On fail goto*//*Label 31692*/ GIMT_Encode4(2312364), // Rule ID 1335 //
     /* 2312312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2312315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312346 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2312346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2312349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2312359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312363 */     // GIR_Coverage, 1335,
     /* 2312363 */     GIR_EraseRootFromParent_Done,
     /* 2312364 */   // Label 31692: @2312364
     /* 2312364 */   GIM_Try, /*On fail goto*//*Label 31693*/ GIMT_Encode4(2312421), // Rule ID 1336 //
     /* 2312369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2312372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312403 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2312403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2312406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2312416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312420 */     // GIR_Coverage, 1336,
     /* 2312420 */     GIR_EraseRootFromParent_Done,
     /* 2312421 */   // Label 31693: @2312421
     /* 2312421 */   GIM_Try, /*On fail goto*//*Label 31694*/ GIMT_Encode4(2312461), // Rule ID 1310 //
     /* 2312426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2312429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312445 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2312445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2312448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312460 */     // GIR_Coverage, 1310,
     /* 2312460 */     GIR_EraseRootFromParent_Done,
     /* 2312461 */   // Label 31694: @2312461
     /* 2312461 */   GIM_Try, /*On fail goto*//*Label 31695*/ GIMT_Encode4(2312501), // Rule ID 1311 //
     /* 2312466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2312469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312485 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2312485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2312488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312500 */     // GIR_Coverage, 1311,
     /* 2312500 */     GIR_EraseRootFromParent_Done,
     /* 2312501 */   // Label 31695: @2312501
     /* 2312501 */   GIM_Try, /*On fail goto*//*Label 31696*/ GIMT_Encode4(2312541), // Rule ID 1331 //
     /* 2312506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2312509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312525 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2312525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2312528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312540 */     // GIR_Coverage, 1331,
     /* 2312540 */     GIR_EraseRootFromParent_Done,
     /* 2312541 */   // Label 31696: @2312541
     /* 2312541 */   GIM_Try, /*On fail goto*//*Label 31697*/ GIMT_Encode4(2312581), // Rule ID 1332 //
     /* 2312546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2312549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312565 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2312565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2312568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312580 */     // GIR_Coverage, 1332,
     /* 2312580 */     GIR_EraseRootFromParent_Done,
     /* 2312581 */   // Label 31697: @2312581
     /* 2312581 */   GIM_Reject,
     /* 2312582 */ // Label 31673: @2312582
     /* 2312582 */ GIM_Reject,
     /* 2312583 */ // Label 31631: @2312583
     /* 2312583 */ GIM_Try, /*On fail goto*//*Label 31698*/ GIMT_Encode4(2314373),
     /* 2312588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2312594 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2312597 */   GIM_Try, /*On fail goto*//*Label 31699*/ GIMT_Encode4(2312669), // Rule ID 1659 //
     /* 2312602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2312605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312649 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2312649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2312652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2312664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312668 */     // GIR_Coverage, 1659,
     /* 2312668 */     GIR_EraseRootFromParent_Done,
     /* 2312669 */   // Label 31699: @2312669
     /* 2312669 */   GIM_Try, /*On fail goto*//*Label 31700*/ GIMT_Encode4(2312741), // Rule ID 1660 //
     /* 2312674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2312677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312721 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2312721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2312724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2312736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312740 */     // GIR_Coverage, 1660,
     /* 2312740 */     GIR_EraseRootFromParent_Done,
     /* 2312741 */   // Label 31700: @2312741
     /* 2312741 */   GIM_Try, /*On fail goto*//*Label 31701*/ GIMT_Encode4(2312813), // Rule ID 1682 //
     /* 2312746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2312749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312793 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2312793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2312796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2312808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312812 */     // GIR_Coverage, 1682,
     /* 2312812 */     GIR_EraseRootFromParent_Done,
     /* 2312813 */   // Label 31701: @2312813
     /* 2312813 */   GIM_Try, /*On fail goto*//*Label 31702*/ GIMT_Encode4(2312885), // Rule ID 1714 //
     /* 2312818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2312821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312865 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2312865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2312868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2312880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312884 */     // GIR_Coverage, 1714,
     /* 2312884 */     GIR_EraseRootFromParent_Done,
     /* 2312885 */   // Label 31702: @2312885
     /* 2312885 */   GIM_Try, /*On fail goto*//*Label 31703*/ GIMT_Encode4(2312957), // Rule ID 1715 //
     /* 2312890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2312893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312937 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2312937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2312940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2312952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312956 */     // GIR_Coverage, 1715,
     /* 2312956 */     GIR_EraseRootFromParent_Done,
     /* 2312957 */   // Label 31703: @2312957
     /* 2312957 */   GIM_Try, /*On fail goto*//*Label 31704*/ GIMT_Encode4(2313029), // Rule ID 65517 //
     /* 2312962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2312965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313009 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2313012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2313024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313028 */     // GIR_Coverage, 65517,
     /* 2313028 */     GIR_EraseRootFromParent_Done,
     /* 2313029 */   // Label 31704: @2313029
     /* 2313029 */   GIM_Try, /*On fail goto*//*Label 31705*/ GIMT_Encode4(2313101), // Rule ID 65518 //
     /* 2313034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2313037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313081 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2313084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2313096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313100 */     // GIR_Coverage, 65518,
     /* 2313100 */     GIR_EraseRootFromParent_Done,
     /* 2313101 */   // Label 31705: @2313101
     /* 2313101 */   GIM_Try, /*On fail goto*//*Label 31706*/ GIMT_Encode4(2313173), // Rule ID 65522 //
     /* 2313106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2313109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313153 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2313156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2313168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313172 */     // GIR_Coverage, 65522,
     /* 2313172 */     GIR_EraseRootFromParent_Done,
     /* 2313173 */   // Label 31706: @2313173
     /* 2313173 */   GIM_Try, /*On fail goto*//*Label 31707*/ GIMT_Encode4(2313245), // Rule ID 65529 //
     /* 2313178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2313181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313225 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2313228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2313240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313244 */     // GIR_Coverage, 65529,
     /* 2313244 */     GIR_EraseRootFromParent_Done,
     /* 2313245 */   // Label 31707: @2313245
     /* 2313245 */   GIM_Try, /*On fail goto*//*Label 31708*/ GIMT_Encode4(2313317), // Rule ID 65530 //
     /* 2313250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2313253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313297 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2313300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2313312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313316 */     // GIR_Coverage, 65530,
     /* 2313316 */     GIR_EraseRootFromParent_Done,
     /* 2313317 */   // Label 31708: @2313317
     /* 2313317 */   GIM_Try, /*On fail goto*//*Label 31709*/ GIMT_Encode4(2313374), // Rule ID 1655 //
     /* 2313322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2313325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313356 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2313359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313373 */     // GIR_Coverage, 1655,
     /* 2313373 */     GIR_EraseRootFromParent_Done,
     /* 2313374 */   // Label 31709: @2313374
     /* 2313374 */   GIM_Try, /*On fail goto*//*Label 31710*/ GIMT_Encode4(2313431), // Rule ID 1656 //
     /* 2313379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2313382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313413 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2313416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313430 */     // GIR_Coverage, 1656,
     /* 2313430 */     GIR_EraseRootFromParent_Done,
     /* 2313431 */   // Label 31710: @2313431
     /* 2313431 */   GIM_Try, /*On fail goto*//*Label 31711*/ GIMT_Encode4(2313488), // Rule ID 1680 //
     /* 2313436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2313439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313470 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2313473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313487 */     // GIR_Coverage, 1680,
     /* 2313487 */     GIR_EraseRootFromParent_Done,
     /* 2313488 */   // Label 31711: @2313488
     /* 2313488 */   GIM_Try, /*On fail goto*//*Label 31712*/ GIMT_Encode4(2313545), // Rule ID 1710 //
     /* 2313493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2313496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313527 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2313530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313544 */     // GIR_Coverage, 1710,
     /* 2313544 */     GIR_EraseRootFromParent_Done,
     /* 2313545 */   // Label 31712: @2313545
     /* 2313545 */   GIM_Try, /*On fail goto*//*Label 31713*/ GIMT_Encode4(2313602), // Rule ID 1711 //
     /* 2313550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2313553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313584 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2313587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313601 */     // GIR_Coverage, 1711,
     /* 2313601 */     GIR_EraseRootFromParent_Done,
     /* 2313602 */   // Label 31713: @2313602
     /* 2313602 */   GIM_Try, /*On fail goto*//*Label 31714*/ GIMT_Encode4(2313659), // Rule ID 65513 //
     /* 2313607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2313610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313641 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2313644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313658 */     // GIR_Coverage, 65513,
     /* 2313658 */     GIR_EraseRootFromParent_Done,
     /* 2313659 */   // Label 31714: @2313659
     /* 2313659 */   GIM_Try, /*On fail goto*//*Label 31715*/ GIMT_Encode4(2313716), // Rule ID 65514 //
     /* 2313664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2313667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313698 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2313701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313715 */     // GIR_Coverage, 65514,
     /* 2313715 */     GIR_EraseRootFromParent_Done,
     /* 2313716 */   // Label 31715: @2313716
     /* 2313716 */   GIM_Try, /*On fail goto*//*Label 31716*/ GIMT_Encode4(2313773), // Rule ID 65520 //
     /* 2313721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2313724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313755 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2313758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313772 */     // GIR_Coverage, 65520,
     /* 2313772 */     GIR_EraseRootFromParent_Done,
     /* 2313773 */   // Label 31716: @2313773
     /* 2313773 */   GIM_Try, /*On fail goto*//*Label 31717*/ GIMT_Encode4(2313830), // Rule ID 65525 //
     /* 2313778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2313781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313812 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2313815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313829 */     // GIR_Coverage, 65525,
     /* 2313829 */     GIR_EraseRootFromParent_Done,
     /* 2313830 */   // Label 31717: @2313830
     /* 2313830 */   GIM_Try, /*On fail goto*//*Label 31718*/ GIMT_Encode4(2313887), // Rule ID 65526 //
     /* 2313835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2313838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313869 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2313872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313886 */     // GIR_Coverage, 65526,
     /* 2313886 */     GIR_EraseRootFromParent_Done,
     /* 2313887 */   // Label 31718: @2313887
     /* 2313887 */   GIM_Try, /*On fail goto*//*Label 31719*/ GIMT_Encode4(2313944), // Rule ID 1651 //
     /* 2313892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2313895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313926 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2313929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2313939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313943 */     // GIR_Coverage, 1651,
     /* 2313943 */     GIR_EraseRootFromParent_Done,
     /* 2313944 */   // Label 31719: @2313944
     /* 2313944 */   GIM_Try, /*On fail goto*//*Label 31720*/ GIMT_Encode4(2314001), // Rule ID 1652 //
     /* 2313949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2313952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313983 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2313986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2313996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314000 */     // GIR_Coverage, 1652,
     /* 2314000 */     GIR_EraseRootFromParent_Done,
     /* 2314001 */   // Label 31720: @2314001
     /* 2314001 */   GIM_Try, /*On fail goto*//*Label 31721*/ GIMT_Encode4(2314058), // Rule ID 1678 //
     /* 2314006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2314009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2314033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314040 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2314040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2314043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2314053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314057 */     // GIR_Coverage, 1678,
     /* 2314057 */     GIR_EraseRootFromParent_Done,
     /* 2314058 */   // Label 31721: @2314058
     /* 2314058 */   GIM_Try, /*On fail goto*//*Label 31722*/ GIMT_Encode4(2314115), // Rule ID 1706 //
     /* 2314063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2314066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2314090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314097 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2314097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2314100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2314110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314114 */     // GIR_Coverage, 1706,
     /* 2314114 */     GIR_EraseRootFromParent_Done,
     /* 2314115 */   // Label 31722: @2314115
     /* 2314115 */   GIM_Try, /*On fail goto*//*Label 31723*/ GIMT_Encode4(2314172), // Rule ID 1707 //
     /* 2314120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2314123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2314147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314154 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2314154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2314157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2314167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314171 */     // GIR_Coverage, 1707,
     /* 2314171 */     GIR_EraseRootFromParent_Done,
     /* 2314172 */   // Label 31723: @2314172
     /* 2314172 */   GIM_Try, /*On fail goto*//*Label 31724*/ GIMT_Encode4(2314212), // Rule ID 1647 //
     /* 2314177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2314180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314196 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2314196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2314199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2314207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314211 */     // GIR_Coverage, 1647,
     /* 2314211 */     GIR_EraseRootFromParent_Done,
     /* 2314212 */   // Label 31724: @2314212
     /* 2314212 */   GIM_Try, /*On fail goto*//*Label 31725*/ GIMT_Encode4(2314252), // Rule ID 1648 //
     /* 2314217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2314220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314236 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2314236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2314239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2314247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314251 */     // GIR_Coverage, 1648,
     /* 2314251 */     GIR_EraseRootFromParent_Done,
     /* 2314252 */   // Label 31725: @2314252
     /* 2314252 */   GIM_Try, /*On fail goto*//*Label 31726*/ GIMT_Encode4(2314292), // Rule ID 1676 //
     /* 2314257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2314260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314276 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2314276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2314279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2314287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314291 */     // GIR_Coverage, 1676,
     /* 2314291 */     GIR_EraseRootFromParent_Done,
     /* 2314292 */   // Label 31726: @2314292
     /* 2314292 */   GIM_Try, /*On fail goto*//*Label 31727*/ GIMT_Encode4(2314332), // Rule ID 1702 //
     /* 2314297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2314300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314316 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2314316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2314319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2314327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314331 */     // GIR_Coverage, 1702,
     /* 2314331 */     GIR_EraseRootFromParent_Done,
     /* 2314332 */   // Label 31727: @2314332
     /* 2314332 */   GIM_Try, /*On fail goto*//*Label 31728*/ GIMT_Encode4(2314372), // Rule ID 1703 //
     /* 2314337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2314340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314356 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2314356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2314359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2314367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314371 */     // GIR_Coverage, 1703,
     /* 2314371 */     GIR_EraseRootFromParent_Done,
     /* 2314372 */   // Label 31728: @2314372
     /* 2314372 */   GIM_Reject,
     /* 2314373 */ // Label 31698: @2314373
     /* 2314373 */ GIM_Reject,
     /* 2314374 */ // Label 31632: @2314374
     /* 2314374 */ GIM_Try, /*On fail goto*//*Label 31729*/ GIMT_Encode4(2315163),
     /* 2314379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2314385 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2314388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314392 */   GIM_Try, /*On fail goto*//*Label 31730*/ GIMT_Encode4(2314469), // Rule ID 54850 //
     /* 2314397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2314400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314440 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2314443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314468 */     // GIR_Coverage, 54850,
     /* 2314468 */     GIR_EraseRootFromParent_Done,
     /* 2314469 */   // Label 31730: @2314469
     /* 2314469 */   GIM_Try, /*On fail goto*//*Label 31731*/ GIMT_Encode4(2314546), // Rule ID 54851 //
     /* 2314474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2314477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314517 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2314520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314545 */     // GIR_Coverage, 54851,
     /* 2314545 */     GIR_EraseRootFromParent_Done,
     /* 2314546 */   // Label 31731: @2314546
     /* 2314546 */   GIM_Try, /*On fail goto*//*Label 31732*/ GIMT_Encode4(2314623), // Rule ID 72501 //
     /* 2314551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2314554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314594 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2314597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314622 */     // GIR_Coverage, 72501,
     /* 2314622 */     GIR_EraseRootFromParent_Done,
     /* 2314623 */   // Label 31732: @2314623
     /* 2314623 */   GIM_Try, /*On fail goto*//*Label 31733*/ GIMT_Encode4(2314700), // Rule ID 72502 //
     /* 2314628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2314631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314671 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2314674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314699 */     // GIR_Coverage, 72502,
     /* 2314699 */     GIR_EraseRootFromParent_Done,
     /* 2314700 */   // Label 31733: @2314700
     /* 2314700 */   GIM_Try, /*On fail goto*//*Label 31734*/ GIMT_Encode4(2314762), // Rule ID 54854 //
     /* 2314705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2314708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314735 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2314738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314761 */     // GIR_Coverage, 54854,
     /* 2314761 */     GIR_EraseRootFromParent_Done,
     /* 2314762 */   // Label 31734: @2314762
     /* 2314762 */   GIM_Try, /*On fail goto*//*Label 31735*/ GIMT_Encode4(2314824), // Rule ID 54855 //
     /* 2314767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2314770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314797 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2314800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314823 */     // GIR_Coverage, 54855,
     /* 2314823 */     GIR_EraseRootFromParent_Done,
     /* 2314824 */   // Label 31735: @2314824
     /* 2314824 */   GIM_Try, /*On fail goto*//*Label 31736*/ GIMT_Encode4(2314886), // Rule ID 72505 //
     /* 2314829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2314832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314859 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2314862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314885 */     // GIR_Coverage, 72505,
     /* 2314885 */     GIR_EraseRootFromParent_Done,
     /* 2314886 */   // Label 31736: @2314886
     /* 2314886 */   GIM_Try, /*On fail goto*//*Label 31737*/ GIMT_Encode4(2314948), // Rule ID 72506 //
     /* 2314891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2314894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314921 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2314924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314947 */     // GIR_Coverage, 72506,
     /* 2314947 */     GIR_EraseRootFromParent_Done,
     /* 2314948 */   // Label 31737: @2314948
     /* 2314948 */   GIM_Try, /*On fail goto*//*Label 31738*/ GIMT_Encode4(2315010), // Rule ID 54846 //
     /* 2314953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2314956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314983 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2314986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2314996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315009 */     // GIR_Coverage, 54846,
     /* 2315009 */     GIR_EraseRootFromParent_Done,
     /* 2315010 */   // Label 31738: @2315010
     /* 2315010 */   GIM_Try, /*On fail goto*//*Label 31739*/ GIMT_Encode4(2315072), // Rule ID 54847 //
     /* 2315015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2315038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315045 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2315048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315071 */     // GIR_Coverage, 54847,
     /* 2315071 */     GIR_EraseRootFromParent_Done,
     /* 2315072 */   // Label 31739: @2315072
     /* 2315072 */   GIM_Try, /*On fail goto*//*Label 31740*/ GIMT_Encode4(2315117), // Rule ID 54842 //
     /* 2315077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315092 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2315095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315116 */     // GIR_Coverage, 54842,
     /* 2315116 */     GIR_EraseRootFromParent_Done,
     /* 2315117 */   // Label 31740: @2315117
     /* 2315117 */   GIM_Try, /*On fail goto*//*Label 31741*/ GIMT_Encode4(2315162), // Rule ID 54843 //
     /* 2315122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315137 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2315140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315161 */     // GIR_Coverage, 54843,
     /* 2315161 */     GIR_EraseRootFromParent_Done,
     /* 2315162 */   // Label 31741: @2315162
     /* 2315162 */   GIM_Reject,
     /* 2315163 */ // Label 31729: @2315163
     /* 2315163 */ GIM_Reject,
     /* 2315164 */ // Label 31633: @2315164
     /* 2315164 */ GIM_Try, /*On fail goto*//*Label 31742*/ GIMT_Encode4(2315953),
     /* 2315169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2315175 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2315178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315182 */   GIM_Try, /*On fail goto*//*Label 31743*/ GIMT_Encode4(2315259), // Rule ID 54978 //
     /* 2315187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2315190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315230 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2315233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315258 */     // GIR_Coverage, 54978,
     /* 2315258 */     GIR_EraseRootFromParent_Done,
     /* 2315259 */   // Label 31743: @2315259
     /* 2315259 */   GIM_Try, /*On fail goto*//*Label 31744*/ GIMT_Encode4(2315336), // Rule ID 54979 //
     /* 2315264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2315267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315307 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2315310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315335 */     // GIR_Coverage, 54979,
     /* 2315335 */     GIR_EraseRootFromParent_Done,
     /* 2315336 */   // Label 31744: @2315336
     /* 2315336 */   GIM_Try, /*On fail goto*//*Label 31745*/ GIMT_Encode4(2315413), // Rule ID 72613 //
     /* 2315341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2315344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315384 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2315387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315412 */     // GIR_Coverage, 72613,
     /* 2315412 */     GIR_EraseRootFromParent_Done,
     /* 2315413 */   // Label 31745: @2315413
     /* 2315413 */   GIM_Try, /*On fail goto*//*Label 31746*/ GIMT_Encode4(2315490), // Rule ID 72614 //
     /* 2315418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2315421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315461 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2315464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315489 */     // GIR_Coverage, 72614,
     /* 2315489 */     GIR_EraseRootFromParent_Done,
     /* 2315490 */   // Label 31746: @2315490
     /* 2315490 */   GIM_Try, /*On fail goto*//*Label 31747*/ GIMT_Encode4(2315552), // Rule ID 54982 //
     /* 2315495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2315498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315525 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2315528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315551 */     // GIR_Coverage, 54982,
     /* 2315551 */     GIR_EraseRootFromParent_Done,
     /* 2315552 */   // Label 31747: @2315552
     /* 2315552 */   GIM_Try, /*On fail goto*//*Label 31748*/ GIMT_Encode4(2315614), // Rule ID 54983 //
     /* 2315557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2315560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315587 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2315590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315613 */     // GIR_Coverage, 54983,
     /* 2315613 */     GIR_EraseRootFromParent_Done,
     /* 2315614 */   // Label 31748: @2315614
     /* 2315614 */   GIM_Try, /*On fail goto*//*Label 31749*/ GIMT_Encode4(2315676), // Rule ID 72617 //
     /* 2315619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2315622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315649 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2315652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315675 */     // GIR_Coverage, 72617,
     /* 2315675 */     GIR_EraseRootFromParent_Done,
     /* 2315676 */   // Label 31749: @2315676
     /* 2315676 */   GIM_Try, /*On fail goto*//*Label 31750*/ GIMT_Encode4(2315738), // Rule ID 72618 //
     /* 2315681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2315684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315711 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2315714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315737 */     // GIR_Coverage, 72618,
     /* 2315737 */     GIR_EraseRootFromParent_Done,
     /* 2315738 */   // Label 31750: @2315738
     /* 2315738 */   GIM_Try, /*On fail goto*//*Label 31751*/ GIMT_Encode4(2315800), // Rule ID 54974 //
     /* 2315743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2315746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315773 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2315776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315799 */     // GIR_Coverage, 54974,
     /* 2315799 */     GIR_EraseRootFromParent_Done,
     /* 2315800 */   // Label 31751: @2315800
     /* 2315800 */   GIM_Try, /*On fail goto*//*Label 31752*/ GIMT_Encode4(2315862), // Rule ID 54975 //
     /* 2315805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2315808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315835 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2315838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315861 */     // GIR_Coverage, 54975,
     /* 2315861 */     GIR_EraseRootFromParent_Done,
     /* 2315862 */   // Label 31752: @2315862
     /* 2315862 */   GIM_Try, /*On fail goto*//*Label 31753*/ GIMT_Encode4(2315907), // Rule ID 54970 //
     /* 2315867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2315870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315882 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2315885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315906 */     // GIR_Coverage, 54970,
     /* 2315906 */     GIR_EraseRootFromParent_Done,
     /* 2315907 */   // Label 31753: @2315907
     /* 2315907 */   GIM_Try, /*On fail goto*//*Label 31754*/ GIMT_Encode4(2315952), // Rule ID 54971 //
     /* 2315912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2315915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315927 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2315930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315951 */     // GIR_Coverage, 54971,
     /* 2315951 */     GIR_EraseRootFromParent_Done,
     /* 2315952 */   // Label 31754: @2315952
     /* 2315952 */   GIM_Reject,
     /* 2315953 */ // Label 31742: @2315953
     /* 2315953 */ GIM_Reject,
     /* 2315954 */ // Label 31634: @2315954
     /* 2315954 */ GIM_Try, /*On fail goto*//*Label 31755*/ GIMT_Encode4(2316743),
     /* 2315959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2315962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2315965 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2315968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315972 */   GIM_Try, /*On fail goto*//*Label 31756*/ GIMT_Encode4(2316049), // Rule ID 55170 //
     /* 2315977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2315992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316020 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2316023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316048 */     // GIR_Coverage, 55170,
     /* 2316048 */     GIR_EraseRootFromParent_Done,
     /* 2316049 */   // Label 31756: @2316049
     /* 2316049 */   GIM_Try, /*On fail goto*//*Label 31757*/ GIMT_Encode4(2316126), // Rule ID 55171 //
     /* 2316054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2316057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316097 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2316100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316125 */     // GIR_Coverage, 55171,
     /* 2316125 */     GIR_EraseRootFromParent_Done,
     /* 2316126 */   // Label 31757: @2316126
     /* 2316126 */   GIM_Try, /*On fail goto*//*Label 31758*/ GIMT_Encode4(2316203), // Rule ID 72781 //
     /* 2316131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2316134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316174 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2316177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316202 */     // GIR_Coverage, 72781,
     /* 2316202 */     GIR_EraseRootFromParent_Done,
     /* 2316203 */   // Label 31758: @2316203
     /* 2316203 */   GIM_Try, /*On fail goto*//*Label 31759*/ GIMT_Encode4(2316280), // Rule ID 72782 //
     /* 2316208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2316211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316251 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2316254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316279 */     // GIR_Coverage, 72782,
     /* 2316279 */     GIR_EraseRootFromParent_Done,
     /* 2316280 */   // Label 31759: @2316280
     /* 2316280 */   GIM_Try, /*On fail goto*//*Label 31760*/ GIMT_Encode4(2316342), // Rule ID 55174 //
     /* 2316285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2316288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316315 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2316318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316341 */     // GIR_Coverage, 55174,
     /* 2316341 */     GIR_EraseRootFromParent_Done,
     /* 2316342 */   // Label 31760: @2316342
     /* 2316342 */   GIM_Try, /*On fail goto*//*Label 31761*/ GIMT_Encode4(2316404), // Rule ID 55175 //
     /* 2316347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2316350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316377 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2316380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316403 */     // GIR_Coverage, 55175,
     /* 2316403 */     GIR_EraseRootFromParent_Done,
     /* 2316404 */   // Label 31761: @2316404
     /* 2316404 */   GIM_Try, /*On fail goto*//*Label 31762*/ GIMT_Encode4(2316466), // Rule ID 72785 //
     /* 2316409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2316412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316439 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2316442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316465 */     // GIR_Coverage, 72785,
     /* 2316465 */     GIR_EraseRootFromParent_Done,
     /* 2316466 */   // Label 31762: @2316466
     /* 2316466 */   GIM_Try, /*On fail goto*//*Label 31763*/ GIMT_Encode4(2316528), // Rule ID 72786 //
     /* 2316471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2316474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316501 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2316504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316527 */     // GIR_Coverage, 72786,
     /* 2316527 */     GIR_EraseRootFromParent_Done,
     /* 2316528 */   // Label 31763: @2316528
     /* 2316528 */   GIM_Try, /*On fail goto*//*Label 31764*/ GIMT_Encode4(2316590), // Rule ID 55166 //
     /* 2316533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2316536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316563 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2316566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316589 */     // GIR_Coverage, 55166,
     /* 2316589 */     GIR_EraseRootFromParent_Done,
     /* 2316590 */   // Label 31764: @2316590
     /* 2316590 */   GIM_Try, /*On fail goto*//*Label 31765*/ GIMT_Encode4(2316652), // Rule ID 55167 //
     /* 2316595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2316598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316625 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2316628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316651 */     // GIR_Coverage, 55167,
     /* 2316651 */     GIR_EraseRootFromParent_Done,
     /* 2316652 */   // Label 31765: @2316652
     /* 2316652 */   GIM_Try, /*On fail goto*//*Label 31766*/ GIMT_Encode4(2316697), // Rule ID 55162 //
     /* 2316657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2316660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316672 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2316675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316696 */     // GIR_Coverage, 55162,
     /* 2316696 */     GIR_EraseRootFromParent_Done,
     /* 2316697 */   // Label 31766: @2316697
     /* 2316697 */   GIM_Try, /*On fail goto*//*Label 31767*/ GIMT_Encode4(2316742), // Rule ID 55163 //
     /* 2316702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2316705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316717 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2316720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316741 */     // GIR_Coverage, 55163,
     /* 2316741 */     GIR_EraseRootFromParent_Done,
     /* 2316742 */   // Label 31767: @2316742
     /* 2316742 */   GIM_Reject,
     /* 2316743 */ // Label 31755: @2316743
     /* 2316743 */ GIM_Reject,
     /* 2316744 */ // Label 31635: @2316744
     /* 2316744 */ GIM_Try, /*On fail goto*//*Label 31768*/ GIMT_Encode4(2317533),
     /* 2316749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2316755 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2316758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316762 */   GIM_Try, /*On fail goto*//*Label 31769*/ GIMT_Encode4(2316839), // Rule ID 54914 //
     /* 2316767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2316770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316810 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2316813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316838 */     // GIR_Coverage, 54914,
     /* 2316838 */     GIR_EraseRootFromParent_Done,
     /* 2316839 */   // Label 31769: @2316839
     /* 2316839 */   GIM_Try, /*On fail goto*//*Label 31770*/ GIMT_Encode4(2316916), // Rule ID 54915 //
     /* 2316844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2316847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316887 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2316890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316915 */     // GIR_Coverage, 54915,
     /* 2316915 */     GIR_EraseRootFromParent_Done,
     /* 2316916 */   // Label 31770: @2316916
     /* 2316916 */   GIM_Try, /*On fail goto*//*Label 31771*/ GIMT_Encode4(2316993), // Rule ID 72557 //
     /* 2316921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2316924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316964 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2316967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316992 */     // GIR_Coverage, 72557,
     /* 2316992 */     GIR_EraseRootFromParent_Done,
     /* 2316993 */   // Label 31771: @2316993
     /* 2316993 */   GIM_Try, /*On fail goto*//*Label 31772*/ GIMT_Encode4(2317070), // Rule ID 72558 //
     /* 2316998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2317001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317041 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2317044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317069 */     // GIR_Coverage, 72558,
     /* 2317069 */     GIR_EraseRootFromParent_Done,
     /* 2317070 */   // Label 31772: @2317070
     /* 2317070 */   GIM_Try, /*On fail goto*//*Label 31773*/ GIMT_Encode4(2317132), // Rule ID 54918 //
     /* 2317075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2317078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317105 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2317108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317131 */     // GIR_Coverage, 54918,
     /* 2317131 */     GIR_EraseRootFromParent_Done,
     /* 2317132 */   // Label 31773: @2317132
     /* 2317132 */   GIM_Try, /*On fail goto*//*Label 31774*/ GIMT_Encode4(2317194), // Rule ID 54919 //
     /* 2317137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2317140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317167 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2317170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317193 */     // GIR_Coverage, 54919,
     /* 2317193 */     GIR_EraseRootFromParent_Done,
     /* 2317194 */   // Label 31774: @2317194
     /* 2317194 */   GIM_Try, /*On fail goto*//*Label 31775*/ GIMT_Encode4(2317256), // Rule ID 72561 //
     /* 2317199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2317202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317229 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2317232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317255 */     // GIR_Coverage, 72561,
     /* 2317255 */     GIR_EraseRootFromParent_Done,
     /* 2317256 */   // Label 31775: @2317256
     /* 2317256 */   GIM_Try, /*On fail goto*//*Label 31776*/ GIMT_Encode4(2317318), // Rule ID 72562 //
     /* 2317261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2317264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317291 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2317294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317317 */     // GIR_Coverage, 72562,
     /* 2317317 */     GIR_EraseRootFromParent_Done,
     /* 2317318 */   // Label 31776: @2317318
     /* 2317318 */   GIM_Try, /*On fail goto*//*Label 31777*/ GIMT_Encode4(2317380), // Rule ID 54910 //
     /* 2317323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2317326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317353 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2317356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2317366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317379 */     // GIR_Coverage, 54910,
     /* 2317379 */     GIR_EraseRootFromParent_Done,
     /* 2317380 */   // Label 31777: @2317380
     /* 2317380 */   GIM_Try, /*On fail goto*//*Label 31778*/ GIMT_Encode4(2317442), // Rule ID 54911 //
     /* 2317385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2317388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317415 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2317418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2317428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317441 */     // GIR_Coverage, 54911,
     /* 2317441 */     GIR_EraseRootFromParent_Done,
     /* 2317442 */   // Label 31778: @2317442
     /* 2317442 */   GIM_Try, /*On fail goto*//*Label 31779*/ GIMT_Encode4(2317487), // Rule ID 54906 //
     /* 2317447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2317450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317462 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2317465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317486 */     // GIR_Coverage, 54906,
     /* 2317486 */     GIR_EraseRootFromParent_Done,
     /* 2317487 */   // Label 31779: @2317487
     /* 2317487 */   GIM_Try, /*On fail goto*//*Label 31780*/ GIMT_Encode4(2317532), // Rule ID 54907 //
     /* 2317492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2317495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317507 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2317510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317531 */     // GIR_Coverage, 54907,
     /* 2317531 */     GIR_EraseRootFromParent_Done,
     /* 2317532 */   // Label 31780: @2317532
     /* 2317532 */   GIM_Reject,
     /* 2317533 */ // Label 31768: @2317533
     /* 2317533 */ GIM_Reject,
     /* 2317534 */ // Label 31636: @2317534
     /* 2317534 */ GIM_Try, /*On fail goto*//*Label 31781*/ GIMT_Encode4(2318323),
     /* 2317539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2317545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2317548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317552 */   GIM_Try, /*On fail goto*//*Label 31782*/ GIMT_Encode4(2317629), // Rule ID 55106 //
     /* 2317557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2317560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317600 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2317603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317628 */     // GIR_Coverage, 55106,
     /* 2317628 */     GIR_EraseRootFromParent_Done,
     /* 2317629 */   // Label 31782: @2317629
     /* 2317629 */   GIM_Try, /*On fail goto*//*Label 31783*/ GIMT_Encode4(2317706), // Rule ID 55107 //
     /* 2317634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2317637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317677 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2317680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317705 */     // GIR_Coverage, 55107,
     /* 2317705 */     GIR_EraseRootFromParent_Done,
     /* 2317706 */   // Label 31783: @2317706
     /* 2317706 */   GIM_Try, /*On fail goto*//*Label 31784*/ GIMT_Encode4(2317783), // Rule ID 72725 //
     /* 2317711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2317714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317754 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2317757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317782 */     // GIR_Coverage, 72725,
     /* 2317782 */     GIR_EraseRootFromParent_Done,
     /* 2317783 */   // Label 31784: @2317783
     /* 2317783 */   GIM_Try, /*On fail goto*//*Label 31785*/ GIMT_Encode4(2317860), // Rule ID 72726 //
     /* 2317788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2317791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317831 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2317834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317859 */     // GIR_Coverage, 72726,
     /* 2317859 */     GIR_EraseRootFromParent_Done,
     /* 2317860 */   // Label 31785: @2317860
     /* 2317860 */   GIM_Try, /*On fail goto*//*Label 31786*/ GIMT_Encode4(2317922), // Rule ID 55110 //
     /* 2317865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2317868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317895 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2317898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317921 */     // GIR_Coverage, 55110,
     /* 2317921 */     GIR_EraseRootFromParent_Done,
     /* 2317922 */   // Label 31786: @2317922
     /* 2317922 */   GIM_Try, /*On fail goto*//*Label 31787*/ GIMT_Encode4(2317984), // Rule ID 55111 //
     /* 2317927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2317930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317957 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2317960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317983 */     // GIR_Coverage, 55111,
     /* 2317983 */     GIR_EraseRootFromParent_Done,
     /* 2317984 */   // Label 31787: @2317984
     /* 2317984 */   GIM_Try, /*On fail goto*//*Label 31788*/ GIMT_Encode4(2318046), // Rule ID 72729 //
     /* 2317989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2317992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2318008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318019 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2318022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318045 */     // GIR_Coverage, 72729,
     /* 2318045 */     GIR_EraseRootFromParent_Done,
     /* 2318046 */   // Label 31788: @2318046
     /* 2318046 */   GIM_Try, /*On fail goto*//*Label 31789*/ GIMT_Encode4(2318108), // Rule ID 72730 //
     /* 2318051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2318054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2318070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318081 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2318084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318107 */     // GIR_Coverage, 72730,
     /* 2318107 */     GIR_EraseRootFromParent_Done,
     /* 2318108 */   // Label 31789: @2318108
     /* 2318108 */   GIM_Try, /*On fail goto*//*Label 31790*/ GIMT_Encode4(2318170), // Rule ID 55102 //
     /* 2318113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2318116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2318136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318143 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2318146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318169 */     // GIR_Coverage, 55102,
     /* 2318169 */     GIR_EraseRootFromParent_Done,
     /* 2318170 */   // Label 31790: @2318170
     /* 2318170 */   GIM_Try, /*On fail goto*//*Label 31791*/ GIMT_Encode4(2318232), // Rule ID 55103 //
     /* 2318175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2318178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2318198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318205 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2318208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318231 */     // GIR_Coverage, 55103,
     /* 2318231 */     GIR_EraseRootFromParent_Done,
     /* 2318232 */   // Label 31791: @2318232
     /* 2318232 */   GIM_Try, /*On fail goto*//*Label 31792*/ GIMT_Encode4(2318277), // Rule ID 55098 //
     /* 2318237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2318240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318252 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2318255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318276 */     // GIR_Coverage, 55098,
     /* 2318276 */     GIR_EraseRootFromParent_Done,
     /* 2318277 */   // Label 31792: @2318277
     /* 2318277 */   GIM_Try, /*On fail goto*//*Label 31793*/ GIMT_Encode4(2318322), // Rule ID 55099 //
     /* 2318282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2318285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318297 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2318300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318321 */     // GIR_Coverage, 55099,
     /* 2318321 */     GIR_EraseRootFromParent_Done,
     /* 2318322 */   // Label 31793: @2318322
     /* 2318322 */   GIM_Reject,
     /* 2318323 */ // Label 31781: @2318323
     /* 2318323 */ GIM_Reject,
     /* 2318324 */ // Label 31637: @2318324
     /* 2318324 */ GIM_Try, /*On fail goto*//*Label 31794*/ GIMT_Encode4(2319113),
     /* 2318329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2318335 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2318338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318342 */   GIM_Try, /*On fail goto*//*Label 31795*/ GIMT_Encode4(2318419), // Rule ID 55618 //
     /* 2318347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2318350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318390 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2318393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318418 */     // GIR_Coverage, 55618,
     /* 2318418 */     GIR_EraseRootFromParent_Done,
     /* 2318419 */   // Label 31795: @2318419
     /* 2318419 */   GIM_Try, /*On fail goto*//*Label 31796*/ GIMT_Encode4(2318496), // Rule ID 55619 //
     /* 2318424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2318427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318467 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2318470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318495 */     // GIR_Coverage, 55619,
     /* 2318495 */     GIR_EraseRootFromParent_Done,
     /* 2318496 */   // Label 31796: @2318496
     /* 2318496 */   GIM_Try, /*On fail goto*//*Label 31797*/ GIMT_Encode4(2318573), // Rule ID 73173 //
     /* 2318501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2318504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318544 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2318547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318572 */     // GIR_Coverage, 73173,
     /* 2318572 */     GIR_EraseRootFromParent_Done,
     /* 2318573 */   // Label 31797: @2318573
     /* 2318573 */   GIM_Try, /*On fail goto*//*Label 31798*/ GIMT_Encode4(2318650), // Rule ID 73174 //
     /* 2318578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2318581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318621 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2318624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318649 */     // GIR_Coverage, 73174,
     /* 2318649 */     GIR_EraseRootFromParent_Done,
     /* 2318650 */   // Label 31798: @2318650
     /* 2318650 */   GIM_Try, /*On fail goto*//*Label 31799*/ GIMT_Encode4(2318712), // Rule ID 55622 //
     /* 2318655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2318658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318685 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2318688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318711 */     // GIR_Coverage, 55622,
     /* 2318711 */     GIR_EraseRootFromParent_Done,
     /* 2318712 */   // Label 31799: @2318712
     /* 2318712 */   GIM_Try, /*On fail goto*//*Label 31800*/ GIMT_Encode4(2318774), // Rule ID 55623 //
     /* 2318717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2318720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318747 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2318750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318773 */     // GIR_Coverage, 55623,
     /* 2318773 */     GIR_EraseRootFromParent_Done,
     /* 2318774 */   // Label 31800: @2318774
     /* 2318774 */   GIM_Try, /*On fail goto*//*Label 31801*/ GIMT_Encode4(2318836), // Rule ID 73177 //
     /* 2318779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2318782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318809 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2318812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318835 */     // GIR_Coverage, 73177,
     /* 2318835 */     GIR_EraseRootFromParent_Done,
     /* 2318836 */   // Label 31801: @2318836
     /* 2318836 */   GIM_Try, /*On fail goto*//*Label 31802*/ GIMT_Encode4(2318898), // Rule ID 73178 //
     /* 2318841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2318844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318871 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2318874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318897 */     // GIR_Coverage, 73178,
     /* 2318897 */     GIR_EraseRootFromParent_Done,
     /* 2318898 */   // Label 31802: @2318898
     /* 2318898 */   GIM_Try, /*On fail goto*//*Label 31803*/ GIMT_Encode4(2318960), // Rule ID 55614 //
     /* 2318903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2318906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318933 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2318936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318959 */     // GIR_Coverage, 55614,
     /* 2318959 */     GIR_EraseRootFromParent_Done,
     /* 2318960 */   // Label 31803: @2318960
     /* 2318960 */   GIM_Try, /*On fail goto*//*Label 31804*/ GIMT_Encode4(2319022), // Rule ID 55615 //
     /* 2318965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2318968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318995 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2318998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319021 */     // GIR_Coverage, 55615,
     /* 2319021 */     GIR_EraseRootFromParent_Done,
     /* 2319022 */   // Label 31804: @2319022
     /* 2319022 */   GIM_Try, /*On fail goto*//*Label 31805*/ GIMT_Encode4(2319067), // Rule ID 55610 //
     /* 2319027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2319030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319042 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2319045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319066 */     // GIR_Coverage, 55610,
     /* 2319066 */     GIR_EraseRootFromParent_Done,
     /* 2319067 */   // Label 31805: @2319067
     /* 2319067 */   GIM_Try, /*On fail goto*//*Label 31806*/ GIMT_Encode4(2319112), // Rule ID 55611 //
     /* 2319072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2319075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319087 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2319090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319111 */     // GIR_Coverage, 55611,
     /* 2319111 */     GIR_EraseRootFromParent_Done,
     /* 2319112 */   // Label 31806: @2319112
     /* 2319112 */   GIM_Reject,
     /* 2319113 */ // Label 31794: @2319113
     /* 2319113 */ GIM_Reject,
     /* 2319114 */ // Label 31638: @2319114
     /* 2319114 */ GIM_Try, /*On fail goto*//*Label 31807*/ GIMT_Encode4(2319903),
     /* 2319119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2319125 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2319128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319132 */   GIM_Try, /*On fail goto*//*Label 31808*/ GIMT_Encode4(2319209), // Rule ID 55042 //
     /* 2319137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319180 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2319183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319208 */     // GIR_Coverage, 55042,
     /* 2319208 */     GIR_EraseRootFromParent_Done,
     /* 2319209 */   // Label 31808: @2319209
     /* 2319209 */   GIM_Try, /*On fail goto*//*Label 31809*/ GIMT_Encode4(2319286), // Rule ID 55043 //
     /* 2319214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319257 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2319260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319285 */     // GIR_Coverage, 55043,
     /* 2319285 */     GIR_EraseRootFromParent_Done,
     /* 2319286 */   // Label 31809: @2319286
     /* 2319286 */   GIM_Try, /*On fail goto*//*Label 31810*/ GIMT_Encode4(2319363), // Rule ID 72669 //
     /* 2319291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319327 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319334 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2319337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319362 */     // GIR_Coverage, 72669,
     /* 2319362 */     GIR_EraseRootFromParent_Done,
     /* 2319363 */   // Label 31810: @2319363
     /* 2319363 */   GIM_Try, /*On fail goto*//*Label 31811*/ GIMT_Encode4(2319440), // Rule ID 72670 //
     /* 2319368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319411 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2319414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319439 */     // GIR_Coverage, 72670,
     /* 2319439 */     GIR_EraseRootFromParent_Done,
     /* 2319440 */   // Label 31811: @2319440
     /* 2319440 */   GIM_Try, /*On fail goto*//*Label 31812*/ GIMT_Encode4(2319502), // Rule ID 55046 //
     /* 2319445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319475 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2319478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319501 */     // GIR_Coverage, 55046,
     /* 2319501 */     GIR_EraseRootFromParent_Done,
     /* 2319502 */   // Label 31812: @2319502
     /* 2319502 */   GIM_Try, /*On fail goto*//*Label 31813*/ GIMT_Encode4(2319564), // Rule ID 55047 //
     /* 2319507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319537 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2319540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319563 */     // GIR_Coverage, 55047,
     /* 2319563 */     GIR_EraseRootFromParent_Done,
     /* 2319564 */   // Label 31813: @2319564
     /* 2319564 */   GIM_Try, /*On fail goto*//*Label 31814*/ GIMT_Encode4(2319626), // Rule ID 72673 //
     /* 2319569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319599 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2319602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319625 */     // GIR_Coverage, 72673,
     /* 2319625 */     GIR_EraseRootFromParent_Done,
     /* 2319626 */   // Label 31814: @2319626
     /* 2319626 */   GIM_Try, /*On fail goto*//*Label 31815*/ GIMT_Encode4(2319688), // Rule ID 72674 //
     /* 2319631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319661 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2319664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319687 */     // GIR_Coverage, 72674,
     /* 2319687 */     GIR_EraseRootFromParent_Done,
     /* 2319688 */   // Label 31815: @2319688
     /* 2319688 */   GIM_Try, /*On fail goto*//*Label 31816*/ GIMT_Encode4(2319750), // Rule ID 55038 //
     /* 2319693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319723 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2319726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319749 */     // GIR_Coverage, 55038,
     /* 2319749 */     GIR_EraseRootFromParent_Done,
     /* 2319750 */   // Label 31816: @2319750
     /* 2319750 */   GIM_Try, /*On fail goto*//*Label 31817*/ GIMT_Encode4(2319812), // Rule ID 55039 //
     /* 2319755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319785 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2319788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319811 */     // GIR_Coverage, 55039,
     /* 2319811 */     GIR_EraseRootFromParent_Done,
     /* 2319812 */   // Label 31817: @2319812
     /* 2319812 */   GIM_Try, /*On fail goto*//*Label 31818*/ GIMT_Encode4(2319857), // Rule ID 55034 //
     /* 2319817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319832 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2319835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319856 */     // GIR_Coverage, 55034,
     /* 2319856 */     GIR_EraseRootFromParent_Done,
     /* 2319857 */   // Label 31818: @2319857
     /* 2319857 */   GIM_Try, /*On fail goto*//*Label 31819*/ GIMT_Encode4(2319902), // Rule ID 55035 //
     /* 2319862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319877 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2319880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319901 */     // GIR_Coverage, 55035,
     /* 2319901 */     GIR_EraseRootFromParent_Done,
     /* 2319902 */   // Label 31819: @2319902
     /* 2319902 */   GIM_Reject,
     /* 2319903 */ // Label 31807: @2319903
     /* 2319903 */ GIM_Reject,
     /* 2319904 */ // Label 31639: @2319904
     /* 2319904 */ GIM_Try, /*On fail goto*//*Label 31820*/ GIMT_Encode4(2320693),
     /* 2319909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2319912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2319915 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2319918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319922 */   GIM_Try, /*On fail goto*//*Label 31821*/ GIMT_Encode4(2319999), // Rule ID 55426 //
     /* 2319927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2319930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2319942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2319963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319970 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2319973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319998 */     // GIR_Coverage, 55426,
     /* 2319998 */     GIR_EraseRootFromParent_Done,
     /* 2319999 */   // Label 31821: @2319999
     /* 2319999 */   GIM_Try, /*On fail goto*//*Label 31822*/ GIMT_Encode4(2320076), // Rule ID 55427 //
     /* 2320004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2320007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320047 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2320050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320075 */     // GIR_Coverage, 55427,
     /* 2320075 */     GIR_EraseRootFromParent_Done,
     /* 2320076 */   // Label 31822: @2320076
     /* 2320076 */   GIM_Try, /*On fail goto*//*Label 31823*/ GIMT_Encode4(2320153), // Rule ID 73005 //
     /* 2320081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2320084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320124 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2320127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320152 */     // GIR_Coverage, 73005,
     /* 2320152 */     GIR_EraseRootFromParent_Done,
     /* 2320153 */   // Label 31823: @2320153
     /* 2320153 */   GIM_Try, /*On fail goto*//*Label 31824*/ GIMT_Encode4(2320230), // Rule ID 73006 //
     /* 2320158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2320161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320201 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2320204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320229 */     // GIR_Coverage, 73006,
     /* 2320229 */     GIR_EraseRootFromParent_Done,
     /* 2320230 */   // Label 31824: @2320230
     /* 2320230 */   GIM_Try, /*On fail goto*//*Label 31825*/ GIMT_Encode4(2320292), // Rule ID 55430 //
     /* 2320235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2320238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320265 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2320268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320291 */     // GIR_Coverage, 55430,
     /* 2320291 */     GIR_EraseRootFromParent_Done,
     /* 2320292 */   // Label 31825: @2320292
     /* 2320292 */   GIM_Try, /*On fail goto*//*Label 31826*/ GIMT_Encode4(2320354), // Rule ID 55431 //
     /* 2320297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2320300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320327 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2320330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320353 */     // GIR_Coverage, 55431,
     /* 2320353 */     GIR_EraseRootFromParent_Done,
     /* 2320354 */   // Label 31826: @2320354
     /* 2320354 */   GIM_Try, /*On fail goto*//*Label 31827*/ GIMT_Encode4(2320416), // Rule ID 73009 //
     /* 2320359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2320362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320389 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2320392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320415 */     // GIR_Coverage, 73009,
     /* 2320415 */     GIR_EraseRootFromParent_Done,
     /* 2320416 */   // Label 31827: @2320416
     /* 2320416 */   GIM_Try, /*On fail goto*//*Label 31828*/ GIMT_Encode4(2320478), // Rule ID 73010 //
     /* 2320421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2320424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320451 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2320454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320477 */     // GIR_Coverage, 73010,
     /* 2320477 */     GIR_EraseRootFromParent_Done,
     /* 2320478 */   // Label 31828: @2320478
     /* 2320478 */   GIM_Try, /*On fail goto*//*Label 31829*/ GIMT_Encode4(2320540), // Rule ID 55422 //
     /* 2320483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2320486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320513 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2320516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2320526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320539 */     // GIR_Coverage, 55422,
     /* 2320539 */     GIR_EraseRootFromParent_Done,
     /* 2320540 */   // Label 31829: @2320540
     /* 2320540 */   GIM_Try, /*On fail goto*//*Label 31830*/ GIMT_Encode4(2320602), // Rule ID 55423 //
     /* 2320545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2320548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320575 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2320578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2320588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320601 */     // GIR_Coverage, 55423,
     /* 2320601 */     GIR_EraseRootFromParent_Done,
     /* 2320602 */   // Label 31830: @2320602
     /* 2320602 */   GIM_Try, /*On fail goto*//*Label 31831*/ GIMT_Encode4(2320647), // Rule ID 55418 //
     /* 2320607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2320610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320622 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2320625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320646 */     // GIR_Coverage, 55418,
     /* 2320646 */     GIR_EraseRootFromParent_Done,
     /* 2320647 */   // Label 31831: @2320647
     /* 2320647 */   GIM_Try, /*On fail goto*//*Label 31832*/ GIMT_Encode4(2320692), // Rule ID 55419 //
     /* 2320652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2320655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320667 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2320670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320691 */     // GIR_Coverage, 55419,
     /* 2320691 */     GIR_EraseRootFromParent_Done,
     /* 2320692 */   // Label 31832: @2320692
     /* 2320692 */   GIM_Reject,
     /* 2320693 */ // Label 31820: @2320693
     /* 2320693 */ GIM_Reject,
     /* 2320694 */ // Label 31640: @2320694
     /* 2320694 */ GIM_Try, /*On fail goto*//*Label 31833*/ GIMT_Encode4(2321483),
     /* 2320699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2320705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2320708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320712 */   GIM_Try, /*On fail goto*//*Label 31834*/ GIMT_Encode4(2320789), // Rule ID 55682 //
     /* 2320717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2320720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320760 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2320763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320788 */     // GIR_Coverage, 55682,
     /* 2320788 */     GIR_EraseRootFromParent_Done,
     /* 2320789 */   // Label 31834: @2320789
     /* 2320789 */   GIM_Try, /*On fail goto*//*Label 31835*/ GIMT_Encode4(2320866), // Rule ID 55683 //
     /* 2320794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2320797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320837 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2320840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320865 */     // GIR_Coverage, 55683,
     /* 2320865 */     GIR_EraseRootFromParent_Done,
     /* 2320866 */   // Label 31835: @2320866
     /* 2320866 */   GIM_Try, /*On fail goto*//*Label 31836*/ GIMT_Encode4(2320943), // Rule ID 73229 //
     /* 2320871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2320874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320914 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2320917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320942 */     // GIR_Coverage, 73229,
     /* 2320942 */     GIR_EraseRootFromParent_Done,
     /* 2320943 */   // Label 31836: @2320943
     /* 2320943 */   GIM_Try, /*On fail goto*//*Label 31837*/ GIMT_Encode4(2321020), // Rule ID 73230 //
     /* 2320948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2320951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320991 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2320994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321019 */     // GIR_Coverage, 73230,
     /* 2321019 */     GIR_EraseRootFromParent_Done,
     /* 2321020 */   // Label 31837: @2321020
     /* 2321020 */   GIM_Try, /*On fail goto*//*Label 31838*/ GIMT_Encode4(2321082), // Rule ID 55686 //
     /* 2321025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2321028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321055 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2321058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321081 */     // GIR_Coverage, 55686,
     /* 2321081 */     GIR_EraseRootFromParent_Done,
     /* 2321082 */   // Label 31838: @2321082
     /* 2321082 */   GIM_Try, /*On fail goto*//*Label 31839*/ GIMT_Encode4(2321144), // Rule ID 55687 //
     /* 2321087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321117 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2321120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321143 */     // GIR_Coverage, 55687,
     /* 2321143 */     GIR_EraseRootFromParent_Done,
     /* 2321144 */   // Label 31839: @2321144
     /* 2321144 */   GIM_Try, /*On fail goto*//*Label 31840*/ GIMT_Encode4(2321206), // Rule ID 73233 //
     /* 2321149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2321152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321179 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2321182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321205 */     // GIR_Coverage, 73233,
     /* 2321205 */     GIR_EraseRootFromParent_Done,
     /* 2321206 */   // Label 31840: @2321206
     /* 2321206 */   GIM_Try, /*On fail goto*//*Label 31841*/ GIMT_Encode4(2321268), // Rule ID 73234 //
     /* 2321211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321241 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2321244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321267 */     // GIR_Coverage, 73234,
     /* 2321267 */     GIR_EraseRootFromParent_Done,
     /* 2321268 */   // Label 31841: @2321268
     /* 2321268 */   GIM_Try, /*On fail goto*//*Label 31842*/ GIMT_Encode4(2321330), // Rule ID 55678 //
     /* 2321273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2321276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2321288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321303 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2321306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2321316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321329 */     // GIR_Coverage, 55678,
     /* 2321329 */     GIR_EraseRootFromParent_Done,
     /* 2321330 */   // Label 31842: @2321330
     /* 2321330 */   GIM_Try, /*On fail goto*//*Label 31843*/ GIMT_Encode4(2321392), // Rule ID 55679 //
     /* 2321335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2321350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321365 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2321368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2321378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321391 */     // GIR_Coverage, 55679,
     /* 2321391 */     GIR_EraseRootFromParent_Done,
     /* 2321392 */   // Label 31843: @2321392
     /* 2321392 */   GIM_Try, /*On fail goto*//*Label 31844*/ GIMT_Encode4(2321437), // Rule ID 55674 //
     /* 2321397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2321400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321412 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2321415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321436 */     // GIR_Coverage, 55674,
     /* 2321436 */     GIR_EraseRootFromParent_Done,
     /* 2321437 */   // Label 31844: @2321437
     /* 2321437 */   GIM_Try, /*On fail goto*//*Label 31845*/ GIMT_Encode4(2321482), // Rule ID 55675 //
     /* 2321442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321457 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2321460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321481 */     // GIR_Coverage, 55675,
     /* 2321481 */     GIR_EraseRootFromParent_Done,
     /* 2321482 */   // Label 31845: @2321482
     /* 2321482 */   GIM_Reject,
     /* 2321483 */ // Label 31833: @2321483
     /* 2321483 */ GIM_Reject,
     /* 2321484 */ // Label 31641: @2321484
     /* 2321484 */ GIM_Try, /*On fail goto*//*Label 31846*/ GIMT_Encode4(2322273),
     /* 2321489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2321495 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2321498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321502 */   GIM_Try, /*On fail goto*//*Label 31847*/ GIMT_Encode4(2321579), // Rule ID 55234 //
     /* 2321507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321550 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2321553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321578 */     // GIR_Coverage, 55234,
     /* 2321578 */     GIR_EraseRootFromParent_Done,
     /* 2321579 */   // Label 31847: @2321579
     /* 2321579 */   GIM_Try, /*On fail goto*//*Label 31848*/ GIMT_Encode4(2321656), // Rule ID 55235 //
     /* 2321584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321627 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2321630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321655 */     // GIR_Coverage, 55235,
     /* 2321655 */     GIR_EraseRootFromParent_Done,
     /* 2321656 */   // Label 31848: @2321656
     /* 2321656 */   GIM_Try, /*On fail goto*//*Label 31849*/ GIMT_Encode4(2321733), // Rule ID 72837 //
     /* 2321661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321704 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2321707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321732 */     // GIR_Coverage, 72837,
     /* 2321732 */     GIR_EraseRootFromParent_Done,
     /* 2321733 */   // Label 31849: @2321733
     /* 2321733 */   GIM_Try, /*On fail goto*//*Label 31850*/ GIMT_Encode4(2321810), // Rule ID 72838 //
     /* 2321738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321781 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2321784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321809 */     // GIR_Coverage, 72838,
     /* 2321809 */     GIR_EraseRootFromParent_Done,
     /* 2321810 */   // Label 31850: @2321810
     /* 2321810 */   GIM_Try, /*On fail goto*//*Label 31851*/ GIMT_Encode4(2321872), // Rule ID 55238 //
     /* 2321815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321845 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2321848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321871 */     // GIR_Coverage, 55238,
     /* 2321871 */     GIR_EraseRootFromParent_Done,
     /* 2321872 */   // Label 31851: @2321872
     /* 2321872 */   GIM_Try, /*On fail goto*//*Label 31852*/ GIMT_Encode4(2321934), // Rule ID 55239 //
     /* 2321877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321907 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2321910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321933 */     // GIR_Coverage, 55239,
     /* 2321933 */     GIR_EraseRootFromParent_Done,
     /* 2321934 */   // Label 31852: @2321934
     /* 2321934 */   GIM_Try, /*On fail goto*//*Label 31853*/ GIMT_Encode4(2321996), // Rule ID 72841 //
     /* 2321939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321969 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2321972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321995 */     // GIR_Coverage, 72841,
     /* 2321995 */     GIR_EraseRootFromParent_Done,
     /* 2321996 */   // Label 31853: @2321996
     /* 2321996 */   GIM_Try, /*On fail goto*//*Label 31854*/ GIMT_Encode4(2322058), // Rule ID 72842 //
     /* 2322001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2322020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322031 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2322034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322057 */     // GIR_Coverage, 72842,
     /* 2322057 */     GIR_EraseRootFromParent_Done,
     /* 2322058 */   // Label 31854: @2322058
     /* 2322058 */   GIM_Try, /*On fail goto*//*Label 31855*/ GIMT_Encode4(2322120), // Rule ID 55230 //
     /* 2322063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2322086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322093 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2322096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2322106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322119 */     // GIR_Coverage, 55230,
     /* 2322119 */     GIR_EraseRootFromParent_Done,
     /* 2322120 */   // Label 31855: @2322120
     /* 2322120 */   GIM_Try, /*On fail goto*//*Label 31856*/ GIMT_Encode4(2322182), // Rule ID 55231 //
     /* 2322125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2322148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322155 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2322158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2322168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322181 */     // GIR_Coverage, 55231,
     /* 2322181 */     GIR_EraseRootFromParent_Done,
     /* 2322182 */   // Label 31856: @2322182
     /* 2322182 */   GIM_Try, /*On fail goto*//*Label 31857*/ GIMT_Encode4(2322227), // Rule ID 55226 //
     /* 2322187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322202 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2322205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322226 */     // GIR_Coverage, 55226,
     /* 2322226 */     GIR_EraseRootFromParent_Done,
     /* 2322227 */   // Label 31857: @2322227
     /* 2322227 */   GIM_Try, /*On fail goto*//*Label 31858*/ GIMT_Encode4(2322272), // Rule ID 55227 //
     /* 2322232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322247 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2322250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322271 */     // GIR_Coverage, 55227,
     /* 2322271 */     GIR_EraseRootFromParent_Done,
     /* 2322272 */   // Label 31858: @2322272
     /* 2322272 */   GIM_Reject,
     /* 2322273 */ // Label 31846: @2322273
     /* 2322273 */ GIM_Reject,
     /* 2322274 */ // Label 31642: @2322274
     /* 2322274 */ GIM_Try, /*On fail goto*//*Label 31859*/ GIMT_Encode4(2323063),
     /* 2322279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2322285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2322288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322292 */   GIM_Try, /*On fail goto*//*Label 31860*/ GIMT_Encode4(2322369), // Rule ID 55490 //
     /* 2322297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2322304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2322325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2322340 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2322343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2322355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322368 */     // GIR_Coverage, 55490,
     /* 2322368 */     GIR_EraseRootFromParent_Done,
     /* 2322369 */   // Label 31860: @2322369
     /* 2322369 */   GIM_Try, /*On fail goto*//*Label 31861*/ GIMT_Encode4(2322446), // Rule ID 55491 //
     /* 2322374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2322381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2322402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2322417 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2322420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2322432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322445 */     // GIR_Coverage, 55491,
     /* 2322445 */     GIR_EraseRootFromParent_Done,
     /* 2322446 */   // Label 31861: @2322446
     /* 2322446 */   GIM_Try, /*On fail goto*//*Label 31862*/ GIMT_Encode4(2322523), // Rule ID 73061 //
     /* 2322451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2322479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2322494 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2322497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2322509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322522 */     // GIR_Coverage, 73061,
     /* 2322522 */     GIR_EraseRootFromParent_Done,
     /* 2322523 */   // Label 31862: @2322523
     /* 2322523 */   GIM_Try, /*On fail goto*//*Label 31863*/ GIMT_Encode4(2322600), // Rule ID 73062 //
     /* 2322528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2322556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2322571 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2322574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2322586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322599 */     // GIR_Coverage, 73062,
     /* 2322599 */     GIR_EraseRootFromParent_Done,
     /* 2322600 */   // Label 31863: @2322600
     /* 2322600 */   GIM_Try, /*On fail goto*//*Label 31864*/ GIMT_Encode4(2322662), // Rule ID 55494 //
     /* 2322605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2322612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322635 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2322638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322661 */     // GIR_Coverage, 55494,
     /* 2322661 */     GIR_EraseRootFromParent_Done,
     /* 2322662 */   // Label 31864: @2322662
     /* 2322662 */   GIM_Try, /*On fail goto*//*Label 31865*/ GIMT_Encode4(2322724), // Rule ID 55495 //
     /* 2322667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2322674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322697 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2322700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322723 */     // GIR_Coverage, 55495,
     /* 2322723 */     GIR_EraseRootFromParent_Done,
     /* 2322724 */   // Label 31865: @2322724
     /* 2322724 */   GIM_Try, /*On fail goto*//*Label 31866*/ GIMT_Encode4(2322786), // Rule ID 73065 //
     /* 2322729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322759 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2322762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322785 */     // GIR_Coverage, 73065,
     /* 2322785 */     GIR_EraseRootFromParent_Done,
     /* 2322786 */   // Label 31866: @2322786
     /* 2322786 */   GIM_Try, /*On fail goto*//*Label 31867*/ GIMT_Encode4(2322848), // Rule ID 73066 //
     /* 2322791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322821 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2322824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322847 */     // GIR_Coverage, 73066,
     /* 2322847 */     GIR_EraseRootFromParent_Done,
     /* 2322848 */   // Label 31867: @2322848
     /* 2322848 */   GIM_Try, /*On fail goto*//*Label 31868*/ GIMT_Encode4(2322910), // Rule ID 55486 //
     /* 2322853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322883 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2322886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2322896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322909 */     // GIR_Coverage, 55486,
     /* 2322909 */     GIR_EraseRootFromParent_Done,
     /* 2322910 */   // Label 31868: @2322910
     /* 2322910 */   GIM_Try, /*On fail goto*//*Label 31869*/ GIMT_Encode4(2322972), // Rule ID 55487 //
     /* 2322915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322945 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2322948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2322958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322971 */     // GIR_Coverage, 55487,
     /* 2322971 */     GIR_EraseRootFromParent_Done,
     /* 2322972 */   // Label 31869: @2322972
     /* 2322972 */   GIM_Try, /*On fail goto*//*Label 31870*/ GIMT_Encode4(2323017), // Rule ID 55482 //
     /* 2322977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322992 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2322995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323016 */     // GIR_Coverage, 55482,
     /* 2323016 */     GIR_EraseRootFromParent_Done,
     /* 2323017 */   // Label 31870: @2323017
     /* 2323017 */   GIM_Try, /*On fail goto*//*Label 31871*/ GIMT_Encode4(2323062), // Rule ID 55483 //
     /* 2323022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2323025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323037 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2323040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323061 */     // GIR_Coverage, 55483,
     /* 2323061 */     GIR_EraseRootFromParent_Done,
     /* 2323062 */   // Label 31871: @2323062
     /* 2323062 */   GIM_Reject,
     /* 2323063 */ // Label 31859: @2323063
     /* 2323063 */ GIM_Reject,
     /* 2323064 */ // Label 31643: @2323064
     /* 2323064 */ GIM_Try, /*On fail goto*//*Label 31872*/ GIMT_Encode4(2323853),
     /* 2323069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2323075 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2323078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323082 */   GIM_Try, /*On fail goto*//*Label 31873*/ GIMT_Encode4(2323159), // Rule ID 55746 //
     /* 2323087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2323094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2323115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2323130 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2323133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2323145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323158 */     // GIR_Coverage, 55746,
     /* 2323158 */     GIR_EraseRootFromParent_Done,
     /* 2323159 */   // Label 31873: @2323159
     /* 2323159 */   GIM_Try, /*On fail goto*//*Label 31874*/ GIMT_Encode4(2323236), // Rule ID 55747 //
     /* 2323164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2323171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2323192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2323207 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2323210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2323222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323235 */     // GIR_Coverage, 55747,
     /* 2323235 */     GIR_EraseRootFromParent_Done,
     /* 2323236 */   // Label 31874: @2323236
     /* 2323236 */   GIM_Try, /*On fail goto*//*Label 31875*/ GIMT_Encode4(2323313), // Rule ID 73285 //
     /* 2323241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2323252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2323269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2323284 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2323287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2323299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323312 */     // GIR_Coverage, 73285,
     /* 2323312 */     GIR_EraseRootFromParent_Done,
     /* 2323313 */   // Label 31875: @2323313
     /* 2323313 */   GIM_Try, /*On fail goto*//*Label 31876*/ GIMT_Encode4(2323390), // Rule ID 73286 //
     /* 2323318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2323329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2323346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2323361 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2323364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2323376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323389 */     // GIR_Coverage, 73286,
     /* 2323389 */     GIR_EraseRootFromParent_Done,
     /* 2323390 */   // Label 31876: @2323390
     /* 2323390 */   GIM_Try, /*On fail goto*//*Label 31877*/ GIMT_Encode4(2323452), // Rule ID 55750 //
     /* 2323395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2323402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323425 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2323428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323451 */     // GIR_Coverage, 55750,
     /* 2323451 */     GIR_EraseRootFromParent_Done,
     /* 2323452 */   // Label 31877: @2323452
     /* 2323452 */   GIM_Try, /*On fail goto*//*Label 31878*/ GIMT_Encode4(2323514), // Rule ID 55751 //
     /* 2323457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2323464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323487 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2323490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323513 */     // GIR_Coverage, 55751,
     /* 2323513 */     GIR_EraseRootFromParent_Done,
     /* 2323514 */   // Label 31878: @2323514
     /* 2323514 */   GIM_Try, /*On fail goto*//*Label 31879*/ GIMT_Encode4(2323576), // Rule ID 73289 //
     /* 2323519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2323530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323549 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2323552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323575 */     // GIR_Coverage, 73289,
     /* 2323575 */     GIR_EraseRootFromParent_Done,
     /* 2323576 */   // Label 31879: @2323576
     /* 2323576 */   GIM_Try, /*On fail goto*//*Label 31880*/ GIMT_Encode4(2323638), // Rule ID 73290 //
     /* 2323581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2323592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323611 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2323614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323637 */     // GIR_Coverage, 73290,
     /* 2323637 */     GIR_EraseRootFromParent_Done,
     /* 2323638 */   // Label 31880: @2323638
     /* 2323638 */   GIM_Try, /*On fail goto*//*Label 31881*/ GIMT_Encode4(2323700), // Rule ID 55742 //
     /* 2323643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2323658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323673 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2323676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2323686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323699 */     // GIR_Coverage, 55742,
     /* 2323699 */     GIR_EraseRootFromParent_Done,
     /* 2323700 */   // Label 31881: @2323700
     /* 2323700 */   GIM_Try, /*On fail goto*//*Label 31882*/ GIMT_Encode4(2323762), // Rule ID 55743 //
     /* 2323705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2323720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323735 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2323738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2323748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323761 */     // GIR_Coverage, 55743,
     /* 2323761 */     GIR_EraseRootFromParent_Done,
     /* 2323762 */   // Label 31882: @2323762
     /* 2323762 */   GIM_Try, /*On fail goto*//*Label 31883*/ GIMT_Encode4(2323807), // Rule ID 55738 //
     /* 2323767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323782 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2323785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323806 */     // GIR_Coverage, 55738,
     /* 2323806 */     GIR_EraseRootFromParent_Done,
     /* 2323807 */   // Label 31883: @2323807
     /* 2323807 */   GIM_Try, /*On fail goto*//*Label 31884*/ GIMT_Encode4(2323852), // Rule ID 55739 //
     /* 2323812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323827 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2323830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323851 */     // GIR_Coverage, 55739,
     /* 2323851 */     GIR_EraseRootFromParent_Done,
     /* 2323852 */   // Label 31884: @2323852
     /* 2323852 */   GIM_Reject,
     /* 2323853 */ // Label 31872: @2323853
     /* 2323853 */ GIM_Reject,
     /* 2323854 */ // Label 31644: @2323854
     /* 2323854 */ GIM_Try, /*On fail goto*//*Label 31885*/ GIMT_Encode4(2324643),
     /* 2323859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2323862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2323865 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2323868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323872 */   GIM_Try, /*On fail goto*//*Label 31886*/ GIMT_Encode4(2323949), // Rule ID 55298 //
     /* 2323877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2323880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2323884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2323892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2323905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2323913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2323920 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2323923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2323935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323948 */     // GIR_Coverage, 55298,
     /* 2323948 */     GIR_EraseRootFromParent_Done,
     /* 2323949 */   // Label 31886: @2323949
     /* 2323949 */   GIM_Try, /*On fail goto*//*Label 31887*/ GIMT_Encode4(2324026), // Rule ID 55299 //
     /* 2323954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2323957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2323961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2323969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2323982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2323990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2323997 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2324000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324025 */     // GIR_Coverage, 55299,
     /* 2324025 */     GIR_EraseRootFromParent_Done,
     /* 2324026 */   // Label 31887: @2324026
     /* 2324026 */   GIM_Try, /*On fail goto*//*Label 31888*/ GIMT_Encode4(2324103), // Rule ID 72893 //
     /* 2324031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2324042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2324059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2324074 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2324077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324102 */     // GIR_Coverage, 72893,
     /* 2324102 */     GIR_EraseRootFromParent_Done,
     /* 2324103 */   // Label 31888: @2324103
     /* 2324103 */   GIM_Try, /*On fail goto*//*Label 31889*/ GIMT_Encode4(2324180), // Rule ID 72894 //
     /* 2324108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2324119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2324136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2324151 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2324154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324179 */     // GIR_Coverage, 72894,
     /* 2324179 */     GIR_EraseRootFromParent_Done,
     /* 2324180 */   // Label 31889: @2324180
     /* 2324180 */   GIM_Try, /*On fail goto*//*Label 31890*/ GIMT_Encode4(2324242), // Rule ID 55302 //
     /* 2324185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2324192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324215 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2324218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324241 */     // GIR_Coverage, 55302,
     /* 2324241 */     GIR_EraseRootFromParent_Done,
     /* 2324242 */   // Label 31890: @2324242
     /* 2324242 */   GIM_Try, /*On fail goto*//*Label 31891*/ GIMT_Encode4(2324304), // Rule ID 55303 //
     /* 2324247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2324254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324277 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2324280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324303 */     // GIR_Coverage, 55303,
     /* 2324303 */     GIR_EraseRootFromParent_Done,
     /* 2324304 */   // Label 31891: @2324304
     /* 2324304 */   GIM_Try, /*On fail goto*//*Label 31892*/ GIMT_Encode4(2324366), // Rule ID 72897 //
     /* 2324309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2324320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324339 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2324342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324365 */     // GIR_Coverage, 72897,
     /* 2324365 */     GIR_EraseRootFromParent_Done,
     /* 2324366 */   // Label 31892: @2324366
     /* 2324366 */   GIM_Try, /*On fail goto*//*Label 31893*/ GIMT_Encode4(2324428), // Rule ID 72898 //
     /* 2324371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2324382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324401 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2324404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324427 */     // GIR_Coverage, 72898,
     /* 2324427 */     GIR_EraseRootFromParent_Done,
     /* 2324428 */   // Label 31893: @2324428
     /* 2324428 */   GIM_Try, /*On fail goto*//*Label 31894*/ GIMT_Encode4(2324490), // Rule ID 55294 //
     /* 2324433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2324448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324463 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2324466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2324476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324489 */     // GIR_Coverage, 55294,
     /* 2324489 */     GIR_EraseRootFromParent_Done,
     /* 2324490 */   // Label 31894: @2324490
     /* 2324490 */   GIM_Try, /*On fail goto*//*Label 31895*/ GIMT_Encode4(2324552), // Rule ID 55295 //
     /* 2324495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2324510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324525 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2324528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2324538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324551 */     // GIR_Coverage, 55295,
     /* 2324551 */     GIR_EraseRootFromParent_Done,
     /* 2324552 */   // Label 31895: @2324552
     /* 2324552 */   GIM_Try, /*On fail goto*//*Label 31896*/ GIMT_Encode4(2324597), // Rule ID 55290 //
     /* 2324557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324572 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2324575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324596 */     // GIR_Coverage, 55290,
     /* 2324596 */     GIR_EraseRootFromParent_Done,
     /* 2324597 */   // Label 31896: @2324597
     /* 2324597 */   GIM_Try, /*On fail goto*//*Label 31897*/ GIMT_Encode4(2324642), // Rule ID 55291 //
     /* 2324602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324617 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2324620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324641 */     // GIR_Coverage, 55291,
     /* 2324641 */     GIR_EraseRootFromParent_Done,
     /* 2324642 */   // Label 31897: @2324642
     /* 2324642 */   GIM_Reject,
     /* 2324643 */ // Label 31885: @2324643
     /* 2324643 */ GIM_Reject,
     /* 2324644 */ // Label 31645: @2324644
     /* 2324644 */ GIM_Try, /*On fail goto*//*Label 31898*/ GIMT_Encode4(2325433),
     /* 2324649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2324655 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2324658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324662 */   GIM_Try, /*On fail goto*//*Label 31899*/ GIMT_Encode4(2324739), // Rule ID 55554 //
     /* 2324667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2324674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2324695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2324710 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2324713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324738 */     // GIR_Coverage, 55554,
     /* 2324738 */     GIR_EraseRootFromParent_Done,
     /* 2324739 */   // Label 31899: @2324739
     /* 2324739 */   GIM_Try, /*On fail goto*//*Label 31900*/ GIMT_Encode4(2324816), // Rule ID 55555 //
     /* 2324744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2324747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2324751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2324772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2324787 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2324790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324815 */     // GIR_Coverage, 55555,
     /* 2324815 */     GIR_EraseRootFromParent_Done,
     /* 2324816 */   // Label 31900: @2324816
     /* 2324816 */   GIM_Try, /*On fail goto*//*Label 31901*/ GIMT_Encode4(2324893), // Rule ID 73117 //
     /* 2324821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2324832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2324849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2324864 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2324867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324892 */     // GIR_Coverage, 73117,
     /* 2324892 */     GIR_EraseRootFromParent_Done,
     /* 2324893 */   // Label 31901: @2324893
     /* 2324893 */   GIM_Try, /*On fail goto*//*Label 31902*/ GIMT_Encode4(2324970), // Rule ID 73118 //
     /* 2324898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2324901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2324909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2324926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2324941 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2324944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324969 */     // GIR_Coverage, 73118,
     /* 2324969 */     GIR_EraseRootFromParent_Done,
     /* 2324970 */   // Label 31902: @2324970
     /* 2324970 */   GIM_Try, /*On fail goto*//*Label 31903*/ GIMT_Encode4(2325032), // Rule ID 55558 //
     /* 2324975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2324982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325005 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2325008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325031 */     // GIR_Coverage, 55558,
     /* 2325031 */     GIR_EraseRootFromParent_Done,
     /* 2325032 */   // Label 31903: @2325032
     /* 2325032 */   GIM_Try, /*On fail goto*//*Label 31904*/ GIMT_Encode4(2325094), // Rule ID 55559 //
     /* 2325037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2325040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2325044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325067 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2325070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325093 */     // GIR_Coverage, 55559,
     /* 2325093 */     GIR_EraseRootFromParent_Done,
     /* 2325094 */   // Label 31904: @2325094
     /* 2325094 */   GIM_Try, /*On fail goto*//*Label 31905*/ GIMT_Encode4(2325156), // Rule ID 73121 //
     /* 2325099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2325102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2325110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325129 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2325132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325155 */     // GIR_Coverage, 73121,
     /* 2325155 */     GIR_EraseRootFromParent_Done,
     /* 2325156 */   // Label 31905: @2325156
     /* 2325156 */   GIM_Try, /*On fail goto*//*Label 31906*/ GIMT_Encode4(2325218), // Rule ID 73122 //
     /* 2325161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2325164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2325172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325191 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2325194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325217 */     // GIR_Coverage, 73122,
     /* 2325217 */     GIR_EraseRootFromParent_Done,
     /* 2325218 */   // Label 31906: @2325218
     /* 2325218 */   GIM_Try, /*On fail goto*//*Label 31907*/ GIMT_Encode4(2325280), // Rule ID 55550 //
     /* 2325223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2325226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2325238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325253 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2325256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2325266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325279 */     // GIR_Coverage, 55550,
     /* 2325279 */     GIR_EraseRootFromParent_Done,
     /* 2325280 */   // Label 31907: @2325280
     /* 2325280 */   GIM_Try, /*On fail goto*//*Label 31908*/ GIMT_Encode4(2325342), // Rule ID 55551 //
     /* 2325285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2325288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2325300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325315 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2325318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2325328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325341 */     // GIR_Coverage, 55551,
     /* 2325341 */     GIR_EraseRootFromParent_Done,
     /* 2325342 */   // Label 31908: @2325342
     /* 2325342 */   GIM_Try, /*On fail goto*//*Label 31909*/ GIMT_Encode4(2325387), // Rule ID 55546 //
     /* 2325347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2325350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325362 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2325365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325386 */     // GIR_Coverage, 55546,
     /* 2325386 */     GIR_EraseRootFromParent_Done,
     /* 2325387 */   // Label 31909: @2325387
     /* 2325387 */   GIM_Try, /*On fail goto*//*Label 31910*/ GIMT_Encode4(2325432), // Rule ID 55547 //
     /* 2325392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2325395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325407 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2325410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325431 */     // GIR_Coverage, 55547,
     /* 2325431 */     GIR_EraseRootFromParent_Done,
     /* 2325432 */   // Label 31910: @2325432
     /* 2325432 */   GIM_Reject,
     /* 2325433 */ // Label 31898: @2325433
     /* 2325433 */ GIM_Reject,
     /* 2325434 */ // Label 31646: @2325434
     /* 2325434 */ GIM_Try, /*On fail goto*//*Label 31911*/ GIMT_Encode4(2326223),
     /* 2325439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2325445 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2325448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325452 */   GIM_Try, /*On fail goto*//*Label 31912*/ GIMT_Encode4(2325529), // Rule ID 55362 //
     /* 2325457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2325460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2325464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2325485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2325500 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2325503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2325515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325528 */     // GIR_Coverage, 55362,
     /* 2325528 */     GIR_EraseRootFromParent_Done,
     /* 2325529 */   // Label 31912: @2325529
     /* 2325529 */   GIM_Try, /*On fail goto*//*Label 31913*/ GIMT_Encode4(2325606), // Rule ID 55363 //
     /* 2325534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2325537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2325541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2325562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2325577 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2325580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2325592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325605 */     // GIR_Coverage, 55363,
     /* 2325605 */     GIR_EraseRootFromParent_Done,
     /* 2325606 */   // Label 31913: @2325606
     /* 2325606 */   GIM_Try, /*On fail goto*//*Label 31914*/ GIMT_Encode4(2325683), // Rule ID 72949 //
     /* 2325611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2325614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2325622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2325639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2325654 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2325657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2325669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325682 */     // GIR_Coverage, 72949,
     /* 2325682 */     GIR_EraseRootFromParent_Done,
     /* 2325683 */   // Label 31914: @2325683
     /* 2325683 */   GIM_Try, /*On fail goto*//*Label 31915*/ GIMT_Encode4(2325760), // Rule ID 72950 //
     /* 2325688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2325691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2325699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2325716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2325731 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2325734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2325746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325759 */     // GIR_Coverage, 72950,
     /* 2325759 */     GIR_EraseRootFromParent_Done,
     /* 2325760 */   // Label 31915: @2325760
     /* 2325760 */   GIM_Try, /*On fail goto*//*Label 31916*/ GIMT_Encode4(2325822), // Rule ID 55366 //
     /* 2325765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2325768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2325772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325795 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2325798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325821 */     // GIR_Coverage, 55366,
     /* 2325821 */     GIR_EraseRootFromParent_Done,
     /* 2325822 */   // Label 31916: @2325822
     /* 2325822 */   GIM_Try, /*On fail goto*//*Label 31917*/ GIMT_Encode4(2325884), // Rule ID 55367 //
     /* 2325827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2325830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2325834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325857 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2325860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325883 */     // GIR_Coverage, 55367,
     /* 2325883 */     GIR_EraseRootFromParent_Done,
     /* 2325884 */   // Label 31917: @2325884
     /* 2325884 */   GIM_Try, /*On fail goto*//*Label 31918*/ GIMT_Encode4(2325946), // Rule ID 72953 //
     /* 2325889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2325892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2325900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325919 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2325922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325945 */     // GIR_Coverage, 72953,
     /* 2325945 */     GIR_EraseRootFromParent_Done,
     /* 2325946 */   // Label 31918: @2325946
     /* 2325946 */   GIM_Try, /*On fail goto*//*Label 31919*/ GIMT_Encode4(2326008), // Rule ID 72954 //
     /* 2325951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2325954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2325962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325981 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2325984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326007 */     // GIR_Coverage, 72954,
     /* 2326007 */     GIR_EraseRootFromParent_Done,
     /* 2326008 */   // Label 31919: @2326008
     /* 2326008 */   GIM_Try, /*On fail goto*//*Label 31920*/ GIMT_Encode4(2326070), // Rule ID 55358 //
     /* 2326013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2326016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2326028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2326032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2326036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2326043 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2326043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2326046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2326050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2326056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326069 */     // GIR_Coverage, 55358,
     /* 2326069 */     GIR_EraseRootFromParent_Done,
     /* 2326070 */   // Label 31920: @2326070
     /* 2326070 */   GIM_Try, /*On fail goto*//*Label 31921*/ GIMT_Encode4(2326132), // Rule ID 55359 //
     /* 2326075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2326078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2326090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2326094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2326098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2326105 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2326105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2326108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2326112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2326118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326131 */     // GIR_Coverage, 55359,
     /* 2326131 */     GIR_EraseRootFromParent_Done,
     /* 2326132 */   // Label 31921: @2326132
     /* 2326132 */   GIM_Try, /*On fail goto*//*Label 31922*/ GIMT_Encode4(2326177), // Rule ID 55354 //
     /* 2326137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2326140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326152 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2326152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2326155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2326159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2326163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326176 */     // GIR_Coverage, 55354,
     /* 2326176 */     GIR_EraseRootFromParent_Done,
     /* 2326177 */   // Label 31922: @2326177
     /* 2326177 */   GIM_Try, /*On fail goto*//*Label 31923*/ GIMT_Encode4(2326222), // Rule ID 55355 //
     /* 2326182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2326185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326197 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2326197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2326200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2326204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2326208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326221 */     // GIR_Coverage, 55355,
     /* 2326221 */     GIR_EraseRootFromParent_Done,
     /* 2326222 */   // Label 31923: @2326222
     /* 2326222 */   GIM_Reject,
     /* 2326223 */ // Label 31911: @2326223
     /* 2326223 */ GIM_Reject,
     /* 2326224 */ // Label 31647: @2326224
     /* 2326224 */ GIM_Reject,
     /* 2326225 */ // Label 63: @2326225
     /* 2326225 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31942*/ GIMT_Encode4(2328652),
     /* 2326236 */ /*GILLT_s16*//*Label 31924*/ GIMT_Encode4(2326356),
     /* 2326240 */ /*GILLT_s32*//*Label 31925*/ GIMT_Encode4(2326505),
     /* 2326244 */ /*GILLT_s64*//*Label 31926*/ GIMT_Encode4(2326654), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326256 */ /*GILLT_nxv1s16*//*Label 31927*/ GIMT_Encode4(2326837),
     /* 2326260 */ /*GILLT_nxv1s32*//*Label 31928*/ GIMT_Encode4(2326958),
     /* 2326264 */ /*GILLT_nxv1s64*//*Label 31929*/ GIMT_Encode4(2327079), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326276 */ /*GILLT_nxv2s16*//*Label 31930*/ GIMT_Encode4(2327200),
     /* 2326280 */ /*GILLT_nxv2s32*//*Label 31931*/ GIMT_Encode4(2327321),
     /* 2326284 */ /*GILLT_nxv2s64*//*Label 31932*/ GIMT_Encode4(2327442), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326296 */ /*GILLT_nxv4s16*//*Label 31933*/ GIMT_Encode4(2327563),
     /* 2326300 */ /*GILLT_nxv4s32*//*Label 31934*/ GIMT_Encode4(2327684),
     /* 2326304 */ /*GILLT_nxv4s64*//*Label 31935*/ GIMT_Encode4(2327805), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326316 */ /*GILLT_nxv8s16*//*Label 31936*/ GIMT_Encode4(2327926),
     /* 2326320 */ /*GILLT_nxv8s32*//*Label 31937*/ GIMT_Encode4(2328047),
     /* 2326324 */ /*GILLT_nxv8s64*//*Label 31938*/ GIMT_Encode4(2328168), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326336 */ /*GILLT_nxv16s16*//*Label 31939*/ GIMT_Encode4(2328289),
     /* 2326340 */ /*GILLT_nxv16s32*//*Label 31940*/ GIMT_Encode4(2328410), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326352 */ /*GILLT_nxv32s16*//*Label 31941*/ GIMT_Encode4(2328531),
     /* 2326356 */ // Label 31924: @2326356
     /* 2326356 */ GIM_Try, /*On fail goto*//*Label 31943*/ GIMT_Encode4(2326504),
     /* 2326361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2326364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2326367 */   GIM_Try, /*On fail goto*//*Label 31944*/ GIMT_Encode4(2326401), // Rule ID 1990 //
     /* 2326372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2326375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326387 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2326387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2326390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326400 */     // GIR_Coverage, 1990,
     /* 2326400 */     GIR_EraseRootFromParent_Done,
     /* 2326401 */   // Label 31944: @2326401
     /* 2326401 */   GIM_Try, /*On fail goto*//*Label 31945*/ GIMT_Encode4(2326435), // Rule ID 1991 //
     /* 2326406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2326409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326421 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2326421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2326424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326434 */     // GIR_Coverage, 1991,
     /* 2326434 */     GIR_EraseRootFromParent_Done,
     /* 2326435 */   // Label 31945: @2326435
     /* 2326435 */   GIM_Try, /*On fail goto*//*Label 31946*/ GIMT_Encode4(2326469), // Rule ID 1994 //
     /* 2326440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2326443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326455 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2326455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2326458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326468 */     // GIR_Coverage, 1994,
     /* 2326468 */     GIR_EraseRootFromParent_Done,
     /* 2326469 */   // Label 31946: @2326469
     /* 2326469 */   GIM_Try, /*On fail goto*//*Label 31947*/ GIMT_Encode4(2326503), // Rule ID 1995 //
     /* 2326474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2326477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326489 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2326489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2326492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326502 */     // GIR_Coverage, 1995,
     /* 2326502 */     GIR_EraseRootFromParent_Done,
     /* 2326503 */   // Label 31947: @2326503
     /* 2326503 */   GIM_Reject,
     /* 2326504 */ // Label 31943: @2326504
     /* 2326504 */ GIM_Reject,
     /* 2326505 */ // Label 31925: @2326505
     /* 2326505 */ GIM_Try, /*On fail goto*//*Label 31948*/ GIMT_Encode4(2326653),
     /* 2326510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2326516 */   GIM_Try, /*On fail goto*//*Label 31949*/ GIMT_Encode4(2326550), // Rule ID 1281 //
     /* 2326521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2326524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326536 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2326536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2326539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326549 */     // GIR_Coverage, 1281,
     /* 2326549 */     GIR_EraseRootFromParent_Done,
     /* 2326550 */   // Label 31949: @2326550
     /* 2326550 */   GIM_Try, /*On fail goto*//*Label 31950*/ GIMT_Encode4(2326584), // Rule ID 1282 //
     /* 2326555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2326558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326570 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2326570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2326573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326583 */     // GIR_Coverage, 1282,
     /* 2326583 */     GIR_EraseRootFromParent_Done,
     /* 2326584 */   // Label 31950: @2326584
     /* 2326584 */   GIM_Try, /*On fail goto*//*Label 31951*/ GIMT_Encode4(2326618), // Rule ID 1285 //
     /* 2326589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2326592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326604 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2326604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2326607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326617 */     // GIR_Coverage, 1285,
     /* 2326617 */     GIR_EraseRootFromParent_Done,
     /* 2326618 */   // Label 31951: @2326618
     /* 2326618 */   GIM_Try, /*On fail goto*//*Label 31952*/ GIMT_Encode4(2326652), // Rule ID 1286 //
     /* 2326623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2326626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326638 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2326638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2326641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326651 */     // GIR_Coverage, 1286,
     /* 2326651 */     GIR_EraseRootFromParent_Done,
     /* 2326652 */   // Label 31952: @2326652
     /* 2326652 */   GIM_Reject,
     /* 2326653 */ // Label 31948: @2326653
     /* 2326653 */ GIM_Reject,
     /* 2326654 */ // Label 31926: @2326654
     /* 2326654 */ GIM_Try, /*On fail goto*//*Label 31953*/ GIMT_Encode4(2326836),
     /* 2326659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2326665 */   GIM_Try, /*On fail goto*//*Label 31954*/ GIMT_Encode4(2326699), // Rule ID 1622 //
     /* 2326670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2326673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326685 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2326685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2326688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326698 */     // GIR_Coverage, 1622,
     /* 2326698 */     GIR_EraseRootFromParent_Done,
     /* 2326699 */   // Label 31954: @2326699
     /* 2326699 */   GIM_Try, /*On fail goto*//*Label 31955*/ GIMT_Encode4(2326733), // Rule ID 1623 //
     /* 2326704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2326707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326719 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2326719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2326722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326732 */     // GIR_Coverage, 1623,
     /* 2326732 */     GIR_EraseRootFromParent_Done,
     /* 2326733 */   // Label 31955: @2326733
     /* 2326733 */   GIM_Try, /*On fail goto*//*Label 31956*/ GIMT_Encode4(2326767), // Rule ID 1626 //
     /* 2326738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2326741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326753 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2326753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2326756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326766 */     // GIR_Coverage, 1626,
     /* 2326766 */     GIR_EraseRootFromParent_Done,
     /* 2326767 */   // Label 31956: @2326767
     /* 2326767 */   GIM_Try, /*On fail goto*//*Label 31957*/ GIMT_Encode4(2326801), // Rule ID 1627 //
     /* 2326772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2326775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326787 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2326787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2326790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326800 */     // GIR_Coverage, 1627,
     /* 2326800 */     GIR_EraseRootFromParent_Done,
     /* 2326801 */   // Label 31957: @2326801
     /* 2326801 */   GIM_Try, /*On fail goto*//*Label 31958*/ GIMT_Encode4(2326835), // Rule ID 1629 //
     /* 2326806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2326809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326821 */     // (fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2326821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2326824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326834 */     // GIR_Coverage, 1629,
     /* 2326834 */     GIR_EraseRootFromParent_Done,
     /* 2326835 */   // Label 31958: @2326835
     /* 2326835 */   GIM_Reject,
     /* 2326836 */ // Label 31953: @2326836
     /* 2326836 */ GIM_Reject,
     /* 2326837 */ // Label 31927: @2326837
     /* 2326837 */ GIM_Try, /*On fail goto*//*Label 31959*/ GIMT_Encode4(2326957),
     /* 2326842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2326845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2326848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326860 */   GIM_Try, /*On fail goto*//*Label 31960*/ GIMT_Encode4(2326908), // Rule ID 54416 //
     /* 2326865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2326868 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2326871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2326885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326907 */     // GIR_Coverage, 54416,
     /* 2326907 */     GIR_EraseRootFromParent_Done,
     /* 2326908 */   // Label 31960: @2326908
     /* 2326908 */   GIM_Try, /*On fail goto*//*Label 31961*/ GIMT_Encode4(2326956), // Rule ID 54417 //
     /* 2326913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2326916 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2326919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2326933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326955 */     // GIR_Coverage, 54417,
     /* 2326955 */     GIR_EraseRootFromParent_Done,
     /* 2326956 */   // Label 31961: @2326956
     /* 2326956 */   GIM_Reject,
     /* 2326957 */ // Label 31959: @2326957
     /* 2326957 */ GIM_Reject,
     /* 2326958 */ // Label 31928: @2326958
     /* 2326958 */ GIM_Try, /*On fail goto*//*Label 31962*/ GIMT_Encode4(2327078),
     /* 2326963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2326966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2326969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326981 */   GIM_Try, /*On fail goto*//*Label 31963*/ GIMT_Encode4(2327029), // Rule ID 54440 //
     /* 2326986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2326989 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2326992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2327006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327028 */     // GIR_Coverage, 54440,
     /* 2327028 */     GIR_EraseRootFromParent_Done,
     /* 2327029 */   // Label 31963: @2327029
     /* 2327029 */   GIM_Try, /*On fail goto*//*Label 31964*/ GIMT_Encode4(2327077), // Rule ID 54441 //
     /* 2327034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2327037 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2327054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327076 */     // GIR_Coverage, 54441,
     /* 2327076 */     GIR_EraseRootFromParent_Done,
     /* 2327077 */   // Label 31964: @2327077
     /* 2327077 */   GIM_Reject,
     /* 2327078 */ // Label 31962: @2327078
     /* 2327078 */ GIM_Reject,
     /* 2327079 */ // Label 31929: @2327079
     /* 2327079 */ GIM_Try, /*On fail goto*//*Label 31965*/ GIMT_Encode4(2327199),
     /* 2327084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2327087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2327090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327102 */   GIM_Try, /*On fail goto*//*Label 31966*/ GIMT_Encode4(2327150), // Rule ID 54476 //
     /* 2327107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2327110 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2327113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2327127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327149 */     // GIR_Coverage, 54476,
     /* 2327149 */     GIR_EraseRootFromParent_Done,
     /* 2327150 */   // Label 31966: @2327150
     /* 2327150 */   GIM_Try, /*On fail goto*//*Label 31967*/ GIMT_Encode4(2327198), // Rule ID 54477 //
     /* 2327155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2327158 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2327161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2327175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327197 */     // GIR_Coverage, 54477,
     /* 2327197 */     GIR_EraseRootFromParent_Done,
     /* 2327198 */   // Label 31967: @2327198
     /* 2327198 */   GIM_Reject,
     /* 2327199 */ // Label 31965: @2327199
     /* 2327199 */ GIM_Reject,
     /* 2327200 */ // Label 31930: @2327200
     /* 2327200 */ GIM_Try, /*On fail goto*//*Label 31968*/ GIMT_Encode4(2327320),
     /* 2327205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2327208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2327211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327223 */   GIM_Try, /*On fail goto*//*Label 31969*/ GIMT_Encode4(2327271), // Rule ID 54428 //
     /* 2327228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2327231 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2327234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2327248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327270 */     // GIR_Coverage, 54428,
     /* 2327270 */     GIR_EraseRootFromParent_Done,
     /* 2327271 */   // Label 31969: @2327271
     /* 2327271 */   GIM_Try, /*On fail goto*//*Label 31970*/ GIMT_Encode4(2327319), // Rule ID 54429 //
     /* 2327276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2327279 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2327282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2327296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327318 */     // GIR_Coverage, 54429,
     /* 2327318 */     GIR_EraseRootFromParent_Done,
     /* 2327319 */   // Label 31970: @2327319
     /* 2327319 */   GIM_Reject,
     /* 2327320 */ // Label 31968: @2327320
     /* 2327320 */ GIM_Reject,
     /* 2327321 */ // Label 31931: @2327321
     /* 2327321 */ GIM_Try, /*On fail goto*//*Label 31971*/ GIMT_Encode4(2327441),
     /* 2327326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2327329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2327332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327344 */   GIM_Try, /*On fail goto*//*Label 31972*/ GIMT_Encode4(2327392), // Rule ID 54464 //
     /* 2327349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2327352 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2327355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2327369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327391 */     // GIR_Coverage, 54464,
     /* 2327391 */     GIR_EraseRootFromParent_Done,
     /* 2327392 */   // Label 31972: @2327392
     /* 2327392 */   GIM_Try, /*On fail goto*//*Label 31973*/ GIMT_Encode4(2327440), // Rule ID 54465 //
     /* 2327397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2327400 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2327403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2327417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327439 */     // GIR_Coverage, 54465,
     /* 2327439 */     GIR_EraseRootFromParent_Done,
     /* 2327440 */   // Label 31973: @2327440
     /* 2327440 */   GIM_Reject,
     /* 2327441 */ // Label 31971: @2327441
     /* 2327441 */ GIM_Reject,
     /* 2327442 */ // Label 31932: @2327442
     /* 2327442 */ GIM_Try, /*On fail goto*//*Label 31974*/ GIMT_Encode4(2327562),
     /* 2327447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2327450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2327453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327465 */   GIM_Try, /*On fail goto*//*Label 31975*/ GIMT_Encode4(2327513), // Rule ID 54560 //
     /* 2327470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2327473 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2327476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2327490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327512 */     // GIR_Coverage, 54560,
     /* 2327512 */     GIR_EraseRootFromParent_Done,
     /* 2327513 */   // Label 31975: @2327513
     /* 2327513 */   GIM_Try, /*On fail goto*//*Label 31976*/ GIMT_Encode4(2327561), // Rule ID 54561 //
     /* 2327518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2327521 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2327524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2327538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327560 */     // GIR_Coverage, 54561,
     /* 2327560 */     GIR_EraseRootFromParent_Done,
     /* 2327561 */   // Label 31976: @2327561
     /* 2327561 */   GIM_Reject,
     /* 2327562 */ // Label 31974: @2327562
     /* 2327562 */ GIM_Reject,
     /* 2327563 */ // Label 31933: @2327563
     /* 2327563 */ GIM_Try, /*On fail goto*//*Label 31977*/ GIMT_Encode4(2327683),
     /* 2327568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2327571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2327574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327586 */   GIM_Try, /*On fail goto*//*Label 31978*/ GIMT_Encode4(2327634), // Rule ID 54452 //
     /* 2327591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2327594 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2327597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2327611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327633 */     // GIR_Coverage, 54452,
     /* 2327633 */     GIR_EraseRootFromParent_Done,
     /* 2327634 */   // Label 31978: @2327634
     /* 2327634 */   GIM_Try, /*On fail goto*//*Label 31979*/ GIMT_Encode4(2327682), // Rule ID 54453 //
     /* 2327639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2327642 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2327645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2327659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327681 */     // GIR_Coverage, 54453,
     /* 2327681 */     GIR_EraseRootFromParent_Done,
     /* 2327682 */   // Label 31979: @2327682
     /* 2327682 */   GIM_Reject,
     /* 2327683 */ // Label 31977: @2327683
     /* 2327683 */ GIM_Reject,
     /* 2327684 */ // Label 31934: @2327684
     /* 2327684 */ GIM_Try, /*On fail goto*//*Label 31980*/ GIMT_Encode4(2327804),
     /* 2327689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2327692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2327695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327707 */   GIM_Try, /*On fail goto*//*Label 31981*/ GIMT_Encode4(2327755), // Rule ID 54524 //
     /* 2327712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2327715 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2327718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2327732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327754 */     // GIR_Coverage, 54524,
     /* 2327754 */     GIR_EraseRootFromParent_Done,
     /* 2327755 */   // Label 31981: @2327755
     /* 2327755 */   GIM_Try, /*On fail goto*//*Label 31982*/ GIMT_Encode4(2327803), // Rule ID 54525 //
     /* 2327760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2327763 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2327766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2327780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327802 */     // GIR_Coverage, 54525,
     /* 2327802 */     GIR_EraseRootFromParent_Done,
     /* 2327803 */   // Label 31982: @2327803
     /* 2327803 */   GIM_Reject,
     /* 2327804 */ // Label 31980: @2327804
     /* 2327804 */ GIM_Reject,
     /* 2327805 */ // Label 31935: @2327805
     /* 2327805 */ GIM_Try, /*On fail goto*//*Label 31983*/ GIMT_Encode4(2327925),
     /* 2327810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2327813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2327816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327828 */   GIM_Try, /*On fail goto*//*Label 31984*/ GIMT_Encode4(2327876), // Rule ID 54572 //
     /* 2327833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2327836 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2327839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2327853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327875 */     // GIR_Coverage, 54572,
     /* 2327875 */     GIR_EraseRootFromParent_Done,
     /* 2327876 */   // Label 31984: @2327876
     /* 2327876 */   GIM_Try, /*On fail goto*//*Label 31985*/ GIMT_Encode4(2327924), // Rule ID 54573 //
     /* 2327881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2327884 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2327887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2327901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327923 */     // GIR_Coverage, 54573,
     /* 2327923 */     GIR_EraseRootFromParent_Done,
     /* 2327924 */   // Label 31985: @2327924
     /* 2327924 */   GIM_Reject,
     /* 2327925 */ // Label 31983: @2327925
     /* 2327925 */ GIM_Reject,
     /* 2327926 */ // Label 31936: @2327926
     /* 2327926 */ GIM_Try, /*On fail goto*//*Label 31986*/ GIMT_Encode4(2328046),
     /* 2327931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2327934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2327937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327949 */   GIM_Try, /*On fail goto*//*Label 31987*/ GIMT_Encode4(2327997), // Rule ID 54488 //
     /* 2327954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2327957 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2327960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2327974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327996 */     // GIR_Coverage, 54488,
     /* 2327996 */     GIR_EraseRootFromParent_Done,
     /* 2327997 */   // Label 31987: @2327997
     /* 2327997 */   GIM_Try, /*On fail goto*//*Label 31988*/ GIMT_Encode4(2328045), // Rule ID 54489 //
     /* 2328002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2328005 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2328008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2328022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328044 */     // GIR_Coverage, 54489,
     /* 2328044 */     GIR_EraseRootFromParent_Done,
     /* 2328045 */   // Label 31988: @2328045
     /* 2328045 */   GIM_Reject,
     /* 2328046 */ // Label 31986: @2328046
     /* 2328046 */ GIM_Reject,
     /* 2328047 */ // Label 31937: @2328047
     /* 2328047 */ GIM_Try, /*On fail goto*//*Label 31989*/ GIMT_Encode4(2328167),
     /* 2328052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2328055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2328058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328070 */   GIM_Try, /*On fail goto*//*Label 31990*/ GIMT_Encode4(2328118), // Rule ID 54536 //
     /* 2328075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2328078 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2328081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2328095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328117 */     // GIR_Coverage, 54536,
     /* 2328117 */     GIR_EraseRootFromParent_Done,
     /* 2328118 */   // Label 31990: @2328118
     /* 2328118 */   GIM_Try, /*On fail goto*//*Label 31991*/ GIMT_Encode4(2328166), // Rule ID 54537 //
     /* 2328123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2328126 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2328129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2328143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328165 */     // GIR_Coverage, 54537,
     /* 2328165 */     GIR_EraseRootFromParent_Done,
     /* 2328166 */   // Label 31991: @2328166
     /* 2328166 */   GIM_Reject,
     /* 2328167 */ // Label 31989: @2328167
     /* 2328167 */ GIM_Reject,
     /* 2328168 */ // Label 31938: @2328168
     /* 2328168 */ GIM_Try, /*On fail goto*//*Label 31992*/ GIMT_Encode4(2328288),
     /* 2328173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2328176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2328179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328191 */   GIM_Try, /*On fail goto*//*Label 31993*/ GIMT_Encode4(2328239), // Rule ID 54584 //
     /* 2328196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2328199 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2328202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2328216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328238 */     // GIR_Coverage, 54584,
     /* 2328238 */     GIR_EraseRootFromParent_Done,
     /* 2328239 */   // Label 31993: @2328239
     /* 2328239 */   GIM_Try, /*On fail goto*//*Label 31994*/ GIMT_Encode4(2328287), // Rule ID 54585 //
     /* 2328244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2328247 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2328250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2328264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328286 */     // GIR_Coverage, 54585,
     /* 2328286 */     GIR_EraseRootFromParent_Done,
     /* 2328287 */   // Label 31994: @2328287
     /* 2328287 */   GIM_Reject,
     /* 2328288 */ // Label 31992: @2328288
     /* 2328288 */ GIM_Reject,
     /* 2328289 */ // Label 31939: @2328289
     /* 2328289 */ GIM_Try, /*On fail goto*//*Label 31995*/ GIMT_Encode4(2328409),
     /* 2328294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2328297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2328300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328312 */   GIM_Try, /*On fail goto*//*Label 31996*/ GIMT_Encode4(2328360), // Rule ID 54500 //
     /* 2328317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2328320 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2328323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2328337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328359 */     // GIR_Coverage, 54500,
     /* 2328359 */     GIR_EraseRootFromParent_Done,
     /* 2328360 */   // Label 31996: @2328360
     /* 2328360 */   GIM_Try, /*On fail goto*//*Label 31997*/ GIMT_Encode4(2328408), // Rule ID 54501 //
     /* 2328365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2328368 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2328371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2328385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328407 */     // GIR_Coverage, 54501,
     /* 2328407 */     GIR_EraseRootFromParent_Done,
     /* 2328408 */   // Label 31997: @2328408
     /* 2328408 */   GIM_Reject,
     /* 2328409 */ // Label 31995: @2328409
     /* 2328409 */ GIM_Reject,
     /* 2328410 */ // Label 31940: @2328410
     /* 2328410 */ GIM_Try, /*On fail goto*//*Label 31998*/ GIMT_Encode4(2328530),
     /* 2328415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2328418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2328421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328433 */   GIM_Try, /*On fail goto*//*Label 31999*/ GIMT_Encode4(2328481), // Rule ID 54548 //
     /* 2328438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2328441 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2328444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2328458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328480 */     // GIR_Coverage, 54548,
     /* 2328480 */     GIR_EraseRootFromParent_Done,
     /* 2328481 */   // Label 31999: @2328481
     /* 2328481 */   GIM_Try, /*On fail goto*//*Label 32000*/ GIMT_Encode4(2328529), // Rule ID 54549 //
     /* 2328486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2328489 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2328492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2328506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328528 */     // GIR_Coverage, 54549,
     /* 2328528 */     GIR_EraseRootFromParent_Done,
     /* 2328529 */   // Label 32000: @2328529
     /* 2328529 */   GIM_Reject,
     /* 2328530 */ // Label 31998: @2328530
     /* 2328530 */ GIM_Reject,
     /* 2328531 */ // Label 31941: @2328531
     /* 2328531 */ GIM_Try, /*On fail goto*//*Label 32001*/ GIMT_Encode4(2328651),
     /* 2328536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2328539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2328542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328554 */   GIM_Try, /*On fail goto*//*Label 32002*/ GIMT_Encode4(2328602), // Rule ID 54512 //
     /* 2328559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2328562 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2328565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2328579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328601 */     // GIR_Coverage, 54512,
     /* 2328601 */     GIR_EraseRootFromParent_Done,
     /* 2328602 */   // Label 32002: @2328602
     /* 2328602 */   GIM_Try, /*On fail goto*//*Label 32003*/ GIMT_Encode4(2328650), // Rule ID 54513 //
     /* 2328607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2328610 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2328613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2328627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328649 */     // GIR_Coverage, 54513,
     /* 2328649 */     GIR_EraseRootFromParent_Done,
     /* 2328650 */   // Label 32003: @2328650
     /* 2328650 */   GIM_Reject,
     /* 2328651 */ // Label 32001: @2328651
     /* 2328651 */ GIM_Reject,
     /* 2328652 */ // Label 31942: @2328652
     /* 2328652 */ GIM_Reject,
     /* 2328653 */ // Label 64: @2328653
     /* 2328653 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32022*/ GIMT_Encode4(2330623),
     /* 2328664 */ /*GILLT_s16*//*Label 32004*/ GIMT_Encode4(2328784),
     /* 2328668 */ /*GILLT_s32*//*Label 32005*/ GIMT_Encode4(2328848),
     /* 2328672 */ /*GILLT_s64*//*Label 32006*/ GIMT_Encode4(2328912), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2328684 */ /*GILLT_nxv1s16*//*Label 32007*/ GIMT_Encode4(2329003),
     /* 2328688 */ /*GILLT_nxv1s32*//*Label 32008*/ GIMT_Encode4(2329111),
     /* 2328692 */ /*GILLT_nxv1s64*//*Label 32009*/ GIMT_Encode4(2329219), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2328704 */ /*GILLT_nxv2s16*//*Label 32010*/ GIMT_Encode4(2329327),
     /* 2328708 */ /*GILLT_nxv2s32*//*Label 32011*/ GIMT_Encode4(2329435),
     /* 2328712 */ /*GILLT_nxv2s64*//*Label 32012*/ GIMT_Encode4(2329543), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2328724 */ /*GILLT_nxv4s16*//*Label 32013*/ GIMT_Encode4(2329651),
     /* 2328728 */ /*GILLT_nxv4s32*//*Label 32014*/ GIMT_Encode4(2329759),
     /* 2328732 */ /*GILLT_nxv4s64*//*Label 32015*/ GIMT_Encode4(2329867), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2328744 */ /*GILLT_nxv8s16*//*Label 32016*/ GIMT_Encode4(2329975),
     /* 2328748 */ /*GILLT_nxv8s32*//*Label 32017*/ GIMT_Encode4(2330083),
     /* 2328752 */ /*GILLT_nxv8s64*//*Label 32018*/ GIMT_Encode4(2330191), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2328764 */ /*GILLT_nxv16s16*//*Label 32019*/ GIMT_Encode4(2330299),
     /* 2328768 */ /*GILLT_nxv16s32*//*Label 32020*/ GIMT_Encode4(2330407), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2328780 */ /*GILLT_nxv32s16*//*Label 32021*/ GIMT_Encode4(2330515),
     /* 2328784 */ // Label 32004: @2328784
     /* 2328784 */ GIM_Try, /*On fail goto*//*Label 32023*/ GIMT_Encode4(2328847),
     /* 2328789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2328792 */   GIM_Try, /*On fail goto*//*Label 32024*/ GIMT_Encode4(2328819), // Rule ID 2000 //
     /* 2328797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2328800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2328804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2328808 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2328808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2328811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328818 */     // GIR_Coverage, 2000,
     /* 2328818 */     GIR_EraseRootFromParent_Done,
     /* 2328819 */   // Label 32024: @2328819
     /* 2328819 */   GIM_Try, /*On fail goto*//*Label 32025*/ GIMT_Encode4(2328846), // Rule ID 2033 //
     /* 2328824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2328827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2328831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2328835 */     // (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2328835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2328838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328845 */     // GIR_Coverage, 2033,
     /* 2328845 */     GIR_EraseRootFromParent_Done,
     /* 2328846 */   // Label 32025: @2328846
     /* 2328846 */   GIM_Reject,
     /* 2328847 */ // Label 32023: @2328847
     /* 2328847 */ GIM_Reject,
     /* 2328848 */ // Label 32005: @2328848
     /* 2328848 */ GIM_Try, /*On fail goto*//*Label 32026*/ GIMT_Encode4(2328911),
     /* 2328853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2328856 */   GIM_Try, /*On fail goto*//*Label 32027*/ GIMT_Encode4(2328883), // Rule ID 1291 //
     /* 2328861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2328864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2328868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2328872 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2328872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2328875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328882 */     // GIR_Coverage, 1291,
     /* 2328882 */     GIR_EraseRootFromParent_Done,
     /* 2328883 */   // Label 32027: @2328883
     /* 2328883 */   GIM_Try, /*On fail goto*//*Label 32028*/ GIMT_Encode4(2328910), // Rule ID 1299 //
     /* 2328888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2328891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2328895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2328899 */     // (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2328899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2328902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328909 */     // GIR_Coverage, 1299,
     /* 2328909 */     GIR_EraseRootFromParent_Done,
     /* 2328910 */   // Label 32028: @2328910
     /* 2328910 */   GIM_Reject,
     /* 2328911 */ // Label 32026: @2328911
     /* 2328911 */ GIM_Reject,
     /* 2328912 */ // Label 32006: @2328912
     /* 2328912 */ GIM_Try, /*On fail goto*//*Label 32029*/ GIMT_Encode4(2329002),
     /* 2328917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2328920 */   GIM_Try, /*On fail goto*//*Label 32030*/ GIMT_Encode4(2328947), // Rule ID 1634 //
     /* 2328925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2328928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2328932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2328936 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2328936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2328939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328946 */     // GIR_Coverage, 1634,
     /* 2328946 */     GIR_EraseRootFromParent_Done,
     /* 2328947 */   // Label 32030: @2328947
     /* 2328947 */   GIM_Try, /*On fail goto*//*Label 32031*/ GIMT_Encode4(2328974), // Rule ID 1667 //
     /* 2328952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2328955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2328959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2328963 */     // (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2328963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2328966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328973 */     // GIR_Coverage, 1667,
     /* 2328973 */     GIR_EraseRootFromParent_Done,
     /* 2328974 */   // Label 32031: @2328974
     /* 2328974 */   GIM_Try, /*On fail goto*//*Label 32032*/ GIMT_Encode4(2329001), // Rule ID 1689 //
     /* 2328979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2328982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2328986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2328990 */     // (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2328990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2328993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329000 */     // GIR_Coverage, 1689,
     /* 2329000 */     GIR_EraseRootFromParent_Done,
     /* 2329001 */   // Label 32032: @2329001
     /* 2329001 */   GIM_Reject,
     /* 2329002 */ // Label 32029: @2329002
     /* 2329002 */ GIM_Reject,
     /* 2329003 */ // Label 32007: @2329003
     /* 2329003 */ GIM_Try, /*On fail goto*//*Label 32033*/ GIMT_Encode4(2329110),
     /* 2329008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2329011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329019 */   GIM_Try, /*On fail goto*//*Label 32034*/ GIMT_Encode4(2329064), // Rule ID 56254 //
     /* 2329024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2329027 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2329030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2329044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329063 */     // GIR_Coverage, 56254,
     /* 2329063 */     GIR_EraseRootFromParent_Done,
     /* 2329064 */   // Label 32034: @2329064
     /* 2329064 */   GIM_Try, /*On fail goto*//*Label 32035*/ GIMT_Encode4(2329109), // Rule ID 56255 //
     /* 2329069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2329072 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2329075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2329089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329108 */     // GIR_Coverage, 56255,
     /* 2329108 */     GIR_EraseRootFromParent_Done,
     /* 2329109 */   // Label 32035: @2329109
     /* 2329109 */   GIM_Reject,
     /* 2329110 */ // Label 32033: @2329110
     /* 2329110 */ GIM_Reject,
     /* 2329111 */ // Label 32008: @2329111
     /* 2329111 */ GIM_Try, /*On fail goto*//*Label 32036*/ GIMT_Encode4(2329218),
     /* 2329116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2329119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329127 */   GIM_Try, /*On fail goto*//*Label 32037*/ GIMT_Encode4(2329172), // Rule ID 56294 //
     /* 2329132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2329135 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2329138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2329152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329171 */     // GIR_Coverage, 56294,
     /* 2329171 */     GIR_EraseRootFromParent_Done,
     /* 2329172 */   // Label 32037: @2329172
     /* 2329172 */   GIM_Try, /*On fail goto*//*Label 32038*/ GIMT_Encode4(2329217), // Rule ID 56295 //
     /* 2329177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2329180 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2329183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2329197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329216 */     // GIR_Coverage, 56295,
     /* 2329216 */     GIR_EraseRootFromParent_Done,
     /* 2329217 */   // Label 32038: @2329217
     /* 2329217 */   GIM_Reject,
     /* 2329218 */ // Label 32036: @2329218
     /* 2329218 */ GIM_Reject,
     /* 2329219 */ // Label 32009: @2329219
     /* 2329219 */ GIM_Try, /*On fail goto*//*Label 32039*/ GIMT_Encode4(2329326),
     /* 2329224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2329227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329235 */   GIM_Try, /*On fail goto*//*Label 32040*/ GIMT_Encode4(2329280), // Rule ID 56354 //
     /* 2329240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2329243 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2329246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2329260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329279 */     // GIR_Coverage, 56354,
     /* 2329279 */     GIR_EraseRootFromParent_Done,
     /* 2329280 */   // Label 32040: @2329280
     /* 2329280 */   GIM_Try, /*On fail goto*//*Label 32041*/ GIMT_Encode4(2329325), // Rule ID 56355 //
     /* 2329285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2329288 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2329291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2329305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329324 */     // GIR_Coverage, 56355,
     /* 2329324 */     GIR_EraseRootFromParent_Done,
     /* 2329325 */   // Label 32041: @2329325
     /* 2329325 */   GIM_Reject,
     /* 2329326 */ // Label 32039: @2329326
     /* 2329326 */ GIM_Reject,
     /* 2329327 */ // Label 32010: @2329327
     /* 2329327 */ GIM_Try, /*On fail goto*//*Label 32042*/ GIMT_Encode4(2329434),
     /* 2329332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2329335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329343 */   GIM_Try, /*On fail goto*//*Label 32043*/ GIMT_Encode4(2329388), // Rule ID 56274 //
     /* 2329348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2329351 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2329354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2329368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329387 */     // GIR_Coverage, 56274,
     /* 2329387 */     GIR_EraseRootFromParent_Done,
     /* 2329388 */   // Label 32043: @2329388
     /* 2329388 */   GIM_Try, /*On fail goto*//*Label 32044*/ GIMT_Encode4(2329433), // Rule ID 56275 //
     /* 2329393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2329396 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2329399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2329413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329432 */     // GIR_Coverage, 56275,
     /* 2329432 */     GIR_EraseRootFromParent_Done,
     /* 2329433 */   // Label 32044: @2329433
     /* 2329433 */   GIM_Reject,
     /* 2329434 */ // Label 32042: @2329434
     /* 2329434 */ GIM_Reject,
     /* 2329435 */ // Label 32011: @2329435
     /* 2329435 */ GIM_Try, /*On fail goto*//*Label 32045*/ GIMT_Encode4(2329542),
     /* 2329440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2329443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329451 */   GIM_Try, /*On fail goto*//*Label 32046*/ GIMT_Encode4(2329496), // Rule ID 56334 //
     /* 2329456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2329459 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2329462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2329476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329495 */     // GIR_Coverage, 56334,
     /* 2329495 */     GIR_EraseRootFromParent_Done,
     /* 2329496 */   // Label 32046: @2329496
     /* 2329496 */   GIM_Try, /*On fail goto*//*Label 32047*/ GIMT_Encode4(2329541), // Rule ID 56335 //
     /* 2329501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2329504 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2329507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2329521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329540 */     // GIR_Coverage, 56335,
     /* 2329540 */     GIR_EraseRootFromParent_Done,
     /* 2329541 */   // Label 32047: @2329541
     /* 2329541 */   GIM_Reject,
     /* 2329542 */ // Label 32045: @2329542
     /* 2329542 */ GIM_Reject,
     /* 2329543 */ // Label 32012: @2329543
     /* 2329543 */ GIM_Try, /*On fail goto*//*Label 32048*/ GIMT_Encode4(2329650),
     /* 2329548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2329551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329559 */   GIM_Try, /*On fail goto*//*Label 32049*/ GIMT_Encode4(2329604), // Rule ID 56494 //
     /* 2329564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2329567 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2329570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2329584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329603 */     // GIR_Coverage, 56494,
     /* 2329603 */     GIR_EraseRootFromParent_Done,
     /* 2329604 */   // Label 32049: @2329604
     /* 2329604 */   GIM_Try, /*On fail goto*//*Label 32050*/ GIMT_Encode4(2329649), // Rule ID 56495 //
     /* 2329609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2329612 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2329615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2329629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329648 */     // GIR_Coverage, 56495,
     /* 2329648 */     GIR_EraseRootFromParent_Done,
     /* 2329649 */   // Label 32050: @2329649
     /* 2329649 */   GIM_Reject,
     /* 2329650 */ // Label 32048: @2329650
     /* 2329650 */ GIM_Reject,
     /* 2329651 */ // Label 32013: @2329651
     /* 2329651 */ GIM_Try, /*On fail goto*//*Label 32051*/ GIMT_Encode4(2329758),
     /* 2329656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329667 */   GIM_Try, /*On fail goto*//*Label 32052*/ GIMT_Encode4(2329712), // Rule ID 56314 //
     /* 2329672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2329675 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2329692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329711 */     // GIR_Coverage, 56314,
     /* 2329711 */     GIR_EraseRootFromParent_Done,
     /* 2329712 */   // Label 32052: @2329712
     /* 2329712 */   GIM_Try, /*On fail goto*//*Label 32053*/ GIMT_Encode4(2329757), // Rule ID 56315 //
     /* 2329717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2329720 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2329737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329756 */     // GIR_Coverage, 56315,
     /* 2329756 */     GIR_EraseRootFromParent_Done,
     /* 2329757 */   // Label 32053: @2329757
     /* 2329757 */   GIM_Reject,
     /* 2329758 */ // Label 32051: @2329758
     /* 2329758 */ GIM_Reject,
     /* 2329759 */ // Label 32014: @2329759
     /* 2329759 */ GIM_Try, /*On fail goto*//*Label 32054*/ GIMT_Encode4(2329866),
     /* 2329764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329775 */   GIM_Try, /*On fail goto*//*Label 32055*/ GIMT_Encode4(2329820), // Rule ID 56434 //
     /* 2329780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2329783 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2329800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329819 */     // GIR_Coverage, 56434,
     /* 2329819 */     GIR_EraseRootFromParent_Done,
     /* 2329820 */   // Label 32055: @2329820
     /* 2329820 */   GIM_Try, /*On fail goto*//*Label 32056*/ GIMT_Encode4(2329865), // Rule ID 56435 //
     /* 2329825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2329828 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2329845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329864 */     // GIR_Coverage, 56435,
     /* 2329864 */     GIR_EraseRootFromParent_Done,
     /* 2329865 */   // Label 32056: @2329865
     /* 2329865 */   GIM_Reject,
     /* 2329866 */ // Label 32054: @2329866
     /* 2329866 */ GIM_Reject,
     /* 2329867 */ // Label 32015: @2329867
     /* 2329867 */ GIM_Try, /*On fail goto*//*Label 32057*/ GIMT_Encode4(2329974),
     /* 2329872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329883 */   GIM_Try, /*On fail goto*//*Label 32058*/ GIMT_Encode4(2329928), // Rule ID 56514 //
     /* 2329888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2329891 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2329908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329927 */     // GIR_Coverage, 56514,
     /* 2329927 */     GIR_EraseRootFromParent_Done,
     /* 2329928 */   // Label 32058: @2329928
     /* 2329928 */   GIM_Try, /*On fail goto*//*Label 32059*/ GIMT_Encode4(2329973), // Rule ID 56515 //
     /* 2329933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2329936 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2329953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329972 */     // GIR_Coverage, 56515,
     /* 2329972 */     GIR_EraseRootFromParent_Done,
     /* 2329973 */   // Label 32059: @2329973
     /* 2329973 */   GIM_Reject,
     /* 2329974 */ // Label 32057: @2329974
     /* 2329974 */ GIM_Reject,
     /* 2329975 */ // Label 32016: @2329975
     /* 2329975 */ GIM_Try, /*On fail goto*//*Label 32060*/ GIMT_Encode4(2330082),
     /* 2329980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2329983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329991 */   GIM_Try, /*On fail goto*//*Label 32061*/ GIMT_Encode4(2330036), // Rule ID 56374 //
     /* 2329996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2329999 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2330002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2330016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330035 */     // GIR_Coverage, 56374,
     /* 2330035 */     GIR_EraseRootFromParent_Done,
     /* 2330036 */   // Label 32061: @2330036
     /* 2330036 */   GIM_Try, /*On fail goto*//*Label 32062*/ GIMT_Encode4(2330081), // Rule ID 56375 //
     /* 2330041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2330044 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2330047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2330061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330080 */     // GIR_Coverage, 56375,
     /* 2330080 */     GIR_EraseRootFromParent_Done,
     /* 2330081 */   // Label 32062: @2330081
     /* 2330081 */   GIM_Reject,
     /* 2330082 */ // Label 32060: @2330082
     /* 2330082 */ GIM_Reject,
     /* 2330083 */ // Label 32017: @2330083
     /* 2330083 */ GIM_Try, /*On fail goto*//*Label 32063*/ GIMT_Encode4(2330190),
     /* 2330088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330099 */   GIM_Try, /*On fail goto*//*Label 32064*/ GIMT_Encode4(2330144), // Rule ID 56454 //
     /* 2330104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2330107 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2330124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330143 */     // GIR_Coverage, 56454,
     /* 2330143 */     GIR_EraseRootFromParent_Done,
     /* 2330144 */   // Label 32064: @2330144
     /* 2330144 */   GIM_Try, /*On fail goto*//*Label 32065*/ GIMT_Encode4(2330189), // Rule ID 56455 //
     /* 2330149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2330152 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2330169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330188 */     // GIR_Coverage, 56455,
     /* 2330188 */     GIR_EraseRootFromParent_Done,
     /* 2330189 */   // Label 32065: @2330189
     /* 2330189 */   GIM_Reject,
     /* 2330190 */ // Label 32063: @2330190
     /* 2330190 */ GIM_Reject,
     /* 2330191 */ // Label 32018: @2330191
     /* 2330191 */ GIM_Try, /*On fail goto*//*Label 32066*/ GIMT_Encode4(2330298),
     /* 2330196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330207 */   GIM_Try, /*On fail goto*//*Label 32067*/ GIMT_Encode4(2330252), // Rule ID 56534 //
     /* 2330212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2330215 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2330232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330251 */     // GIR_Coverage, 56534,
     /* 2330251 */     GIR_EraseRootFromParent_Done,
     /* 2330252 */   // Label 32067: @2330252
     /* 2330252 */   GIM_Try, /*On fail goto*//*Label 32068*/ GIMT_Encode4(2330297), // Rule ID 56535 //
     /* 2330257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2330260 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2330277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330296 */     // GIR_Coverage, 56535,
     /* 2330296 */     GIR_EraseRootFromParent_Done,
     /* 2330297 */   // Label 32068: @2330297
     /* 2330297 */   GIM_Reject,
     /* 2330298 */ // Label 32066: @2330298
     /* 2330298 */ GIM_Reject,
     /* 2330299 */ // Label 32019: @2330299
     /* 2330299 */ GIM_Try, /*On fail goto*//*Label 32069*/ GIMT_Encode4(2330406),
     /* 2330304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2330307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330315 */   GIM_Try, /*On fail goto*//*Label 32070*/ GIMT_Encode4(2330360), // Rule ID 56394 //
     /* 2330320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2330323 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2330340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330359 */     // GIR_Coverage, 56394,
     /* 2330359 */     GIR_EraseRootFromParent_Done,
     /* 2330360 */   // Label 32070: @2330360
     /* 2330360 */   GIM_Try, /*On fail goto*//*Label 32071*/ GIMT_Encode4(2330405), // Rule ID 56395 //
     /* 2330365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2330368 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2330385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330404 */     // GIR_Coverage, 56395,
     /* 2330404 */     GIR_EraseRootFromParent_Done,
     /* 2330405 */   // Label 32071: @2330405
     /* 2330405 */   GIM_Reject,
     /* 2330406 */ // Label 32069: @2330406
     /* 2330406 */ GIM_Reject,
     /* 2330407 */ // Label 32020: @2330407
     /* 2330407 */ GIM_Try, /*On fail goto*//*Label 32072*/ GIMT_Encode4(2330514),
     /* 2330412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2330415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330423 */   GIM_Try, /*On fail goto*//*Label 32073*/ GIMT_Encode4(2330468), // Rule ID 56474 //
     /* 2330428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2330431 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2330434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2330448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330467 */     // GIR_Coverage, 56474,
     /* 2330467 */     GIR_EraseRootFromParent_Done,
     /* 2330468 */   // Label 32073: @2330468
     /* 2330468 */   GIM_Try, /*On fail goto*//*Label 32074*/ GIMT_Encode4(2330513), // Rule ID 56475 //
     /* 2330473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2330476 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2330479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2330493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330512 */     // GIR_Coverage, 56475,
     /* 2330512 */     GIR_EraseRootFromParent_Done,
     /* 2330513 */   // Label 32074: @2330513
     /* 2330513 */   GIM_Reject,
     /* 2330514 */ // Label 32072: @2330514
     /* 2330514 */ GIM_Reject,
     /* 2330515 */ // Label 32021: @2330515
     /* 2330515 */ GIM_Try, /*On fail goto*//*Label 32075*/ GIMT_Encode4(2330622),
     /* 2330520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2330523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330531 */   GIM_Try, /*On fail goto*//*Label 32076*/ GIMT_Encode4(2330576), // Rule ID 56414 //
     /* 2330536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2330539 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2330542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2330556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330575 */     // GIR_Coverage, 56414,
     /* 2330575 */     GIR_EraseRootFromParent_Done,
     /* 2330576 */   // Label 32076: @2330576
     /* 2330576 */   GIM_Try, /*On fail goto*//*Label 32077*/ GIMT_Encode4(2330621), // Rule ID 56415 //
     /* 2330581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2330584 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2330587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2330601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330620 */     // GIR_Coverage, 56415,
     /* 2330620 */     GIR_EraseRootFromParent_Done,
     /* 2330621 */   // Label 32077: @2330621
     /* 2330621 */   GIM_Reject,
     /* 2330622 */ // Label 32075: @2330622
     /* 2330622 */ GIM_Reject,
     /* 2330623 */ // Label 32022: @2330623
     /* 2330623 */ GIM_Reject,
     /* 2330624 */ // Label 65: @2330624
     /* 2330624 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 32080*/ GIMT_Encode4(2331076),
     /* 2330635 */ /*GILLT_s32*//*Label 32078*/ GIMT_Encode4(2330643),
     /* 2330639 */ /*GILLT_s64*//*Label 32079*/ GIMT_Encode4(2330765),
     /* 2330643 */ // Label 32078: @2330643
     /* 2330643 */ GIM_Try, /*On fail goto*//*Label 32081*/ GIMT_Encode4(2330764),
     /* 2330648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2330651 */   GIM_Try, /*On fail goto*//*Label 32082*/ GIMT_Encode4(2330679), // Rule ID 2174 //
     /* 2330656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2330659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2330663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2330667 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2330667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2330670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330678 */     // GIR_Coverage, 2174,
     /* 2330678 */     GIR_EraseRootFromParent_Done,
     /* 2330679 */   // Label 32082: @2330679
     /* 2330679 */   GIM_Try, /*On fail goto*//*Label 32083*/ GIMT_Encode4(2330707), // Rule ID 2175 //
     /* 2330684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2330687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2330691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2330695 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2330695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2330698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330706 */     // GIR_Coverage, 2175,
     /* 2330706 */     GIR_EraseRootFromParent_Done,
     /* 2330707 */   // Label 32083: @2330707
     /* 2330707 */   GIM_Try, /*On fail goto*//*Label 32084*/ GIMT_Encode4(2330735), // Rule ID 2190 //
     /* 2330712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2330715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2330719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2330723 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2330723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2330726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330734 */     // GIR_Coverage, 2190,
     /* 2330734 */     GIR_EraseRootFromParent_Done,
     /* 2330735 */   // Label 32084: @2330735
     /* 2330735 */   GIM_Try, /*On fail goto*//*Label 32085*/ GIMT_Encode4(2330763), // Rule ID 2191 //
     /* 2330740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2330743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2330747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2330751 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2330751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2330754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330762 */     // GIR_Coverage, 2191,
     /* 2330762 */     GIR_EraseRootFromParent_Done,
     /* 2330763 */   // Label 32085: @2330763
     /* 2330763 */   GIM_Reject,
     /* 2330764 */ // Label 32081: @2330764
     /* 2330764 */ GIM_Reject,
     /* 2330765 */ // Label 32079: @2330765
     /* 2330765 */ GIM_Try, /*On fail goto*//*Label 32086*/ GIMT_Encode4(2330796), // Rule ID 1576 //
     /* 2330770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2330773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2330780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2330784 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2330784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2330787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330789 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330795 */   // GIR_Coverage, 1576,
     /* 2330795 */   GIR_EraseRootFromParent_Done,
     /* 2330796 */ // Label 32086: @2330796
     /* 2330796 */ GIM_Try, /*On fail goto*//*Label 32087*/ GIMT_Encode4(2330827), // Rule ID 1577 //
     /* 2330801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2330804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2330811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2330815 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2330815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2330818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330820 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330825 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330826 */   // GIR_Coverage, 1577,
     /* 2330826 */   GIR_EraseRootFromParent_Done,
     /* 2330827 */ // Label 32087: @2330827
     /* 2330827 */ GIM_Try, /*On fail goto*//*Label 32088*/ GIMT_Encode4(2330858), // Rule ID 1581 //
     /* 2330832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2330835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2330846 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_INX:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2330846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2330849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330851 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330856 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330857 */   // GIR_Coverage, 1581,
     /* 2330857 */   GIR_EraseRootFromParent_Done,
     /* 2330858 */ // Label 32088: @2330858
     /* 2330858 */ GIM_Try, /*On fail goto*//*Label 32089*/ GIMT_Encode4(2330889), // Rule ID 1588 //
     /* 2330863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2330866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2330873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2330877 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2330877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2330880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330882 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330887 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330888 */   // GIR_Coverage, 1588,
     /* 2330888 */   GIR_EraseRootFromParent_Done,
     /* 2330889 */ // Label 32089: @2330889
     /* 2330889 */ GIM_Try, /*On fail goto*//*Label 32090*/ GIMT_Encode4(2330920), // Rule ID 1589 //
     /* 2330894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2330897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2330904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2330908 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2330908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2330911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330913 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330919 */   // GIR_Coverage, 1589,
     /* 2330919 */   GIR_EraseRootFromParent_Done,
     /* 2330920 */ // Label 32090: @2330920
     /* 2330920 */ GIM_Try, /*On fail goto*//*Label 32091*/ GIMT_Encode4(2330951), // Rule ID 2308 //
     /* 2330925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2330928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2330931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2330935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2330939 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2330939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2330942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330944 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330949 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330950 */   // GIR_Coverage, 2308,
     /* 2330950 */   GIR_EraseRootFromParent_Done,
     /* 2330951 */ // Label 32091: @2330951
     /* 2330951 */ GIM_Try, /*On fail goto*//*Label 32092*/ GIMT_Encode4(2330982), // Rule ID 2309 //
     /* 2330956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2330959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2330962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2330966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2330970 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2330970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2330973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330975 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330980 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330981 */   // GIR_Coverage, 2309,
     /* 2330981 */   GIR_EraseRootFromParent_Done,
     /* 2330982 */ // Label 32092: @2330982
     /* 2330982 */ GIM_Try, /*On fail goto*//*Label 32093*/ GIMT_Encode4(2331013), // Rule ID 2320 //
     /* 2330987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2330990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2330993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2330997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331001 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2331001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2331004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331006 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2331011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331012 */   // GIR_Coverage, 2320,
     /* 2331012 */   GIR_EraseRootFromParent_Done,
     /* 2331013 */ // Label 32093: @2331013
     /* 2331013 */ GIM_Try, /*On fail goto*//*Label 32094*/ GIMT_Encode4(2331044), // Rule ID 2321 //
     /* 2331018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2331021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2331024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331032 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2331032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2331035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331037 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2331042 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331043 */   // GIR_Coverage, 2321,
     /* 2331043 */   GIR_EraseRootFromParent_Done,
     /* 2331044 */ // Label 32094: @2331044
     /* 2331044 */ GIM_Try, /*On fail goto*//*Label 32095*/ GIMT_Encode4(2331075), // Rule ID 2329 //
     /* 2331049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2331052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2331055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331063 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_INX:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2331063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2331066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331068 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2331073 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331074 */   // GIR_Coverage, 2329,
     /* 2331074 */   GIR_EraseRootFromParent_Done,
     /* 2331075 */ // Label 32095: @2331075
     /* 2331075 */ GIM_Reject,
     /* 2331076 */ // Label 32080: @2331076
     /* 2331076 */ GIM_Reject,
     /* 2331077 */ // Label 66: @2331077
     /* 2331077 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(28), /*)*//*default:*//*Label 32107*/ GIMT_Encode4(2332612),
     /* 2331088 */ /*GILLT_s16*//*Label 32096*/ GIMT_Encode4(2331192),
     /* 2331092 */ /*GILLT_s32*//*Label 32097*/ GIMT_Encode4(2331472), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331108 */ /*GILLT_nxv1s16*//*Label 32098*/ GIMT_Encode4(2331622),
     /* 2331112 */ /*GILLT_nxv1s32*//*Label 32099*/ GIMT_Encode4(2331732), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331128 */ /*GILLT_nxv2s16*//*Label 32100*/ GIMT_Encode4(2331842),
     /* 2331132 */ /*GILLT_nxv2s32*//*Label 32101*/ GIMT_Encode4(2331952), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331148 */ /*GILLT_nxv4s16*//*Label 32102*/ GIMT_Encode4(2332062),
     /* 2331152 */ /*GILLT_nxv4s32*//*Label 32103*/ GIMT_Encode4(2332172), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331168 */ /*GILLT_nxv8s16*//*Label 32104*/ GIMT_Encode4(2332282),
     /* 2331172 */ /*GILLT_nxv8s32*//*Label 32105*/ GIMT_Encode4(2332392), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331188 */ /*GILLT_nxv16s16*//*Label 32106*/ GIMT_Encode4(2332502),
     /* 2331192 */ // Label 32096: @2331192
     /* 2331192 */ GIM_Try, /*On fail goto*//*Label 32108*/ GIMT_Encode4(2331223), // Rule ID 2170 //
     /* 2331197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2331200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331211 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2331211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2331214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331216 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331221 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331222 */   // GIR_Coverage, 2170,
     /* 2331222 */   GIR_EraseRootFromParent_Done,
     /* 2331223 */ // Label 32108: @2331223
     /* 2331223 */ GIM_Try, /*On fail goto*//*Label 32109*/ GIMT_Encode4(2331254), // Rule ID 2171 //
     /* 2331228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2331231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331242 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2331242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2331245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331247 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331253 */   // GIR_Coverage, 2171,
     /* 2331253 */   GIR_EraseRootFromParent_Done,
     /* 2331254 */ // Label 32109: @2331254
     /* 2331254 */ GIM_Try, /*On fail goto*//*Label 32110*/ GIMT_Encode4(2331285), // Rule ID 2186 //
     /* 2331259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2331262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331273 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2331273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2331276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331278 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331283 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331284 */   // GIR_Coverage, 2186,
     /* 2331284 */   GIR_EraseRootFromParent_Done,
     /* 2331285 */ // Label 32110: @2331285
     /* 2331285 */ GIM_Try, /*On fail goto*//*Label 32111*/ GIMT_Encode4(2331316), // Rule ID 2187 //
     /* 2331290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2331293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331304 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2331304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2331307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331309 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331314 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331315 */   // GIR_Coverage, 2187,
     /* 2331315 */   GIR_EraseRootFromParent_Done,
     /* 2331316 */ // Label 32111: @2331316
     /* 2331316 */ GIM_Try, /*On fail goto*//*Label 32112*/ GIMT_Encode4(2331347), // Rule ID 2304 //
     /* 2331321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2331324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331335 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2331335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2331338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331340 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331345 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331346 */   // GIR_Coverage, 2304,
     /* 2331346 */   GIR_EraseRootFromParent_Done,
     /* 2331347 */ // Label 32112: @2331347
     /* 2331347 */ GIM_Try, /*On fail goto*//*Label 32113*/ GIMT_Encode4(2331378), // Rule ID 2305 //
     /* 2331352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2331355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331366 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2331366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2331369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331371 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331376 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331377 */   // GIR_Coverage, 2305,
     /* 2331377 */   GIR_EraseRootFromParent_Done,
     /* 2331378 */ // Label 32113: @2331378
     /* 2331378 */ GIM_Try, /*On fail goto*//*Label 32114*/ GIMT_Encode4(2331409), // Rule ID 2316 //
     /* 2331383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2331386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331397 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2331397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2331400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331402 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331407 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331408 */   // GIR_Coverage, 2316,
     /* 2331408 */   GIR_EraseRootFromParent_Done,
     /* 2331409 */ // Label 32114: @2331409
     /* 2331409 */ GIM_Try, /*On fail goto*//*Label 32115*/ GIMT_Encode4(2331440), // Rule ID 2317 //
     /* 2331414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2331417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331428 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2331428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2331431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331433 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331439 */   // GIR_Coverage, 2317,
     /* 2331439 */   GIR_EraseRootFromParent_Done,
     /* 2331440 */ // Label 32115: @2331440
     /* 2331440 */ GIM_Try, /*On fail goto*//*Label 32116*/ GIMT_Encode4(2331471), // Rule ID 2327 //
     /* 2331445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2331448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331459 */   // (fpround:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_INX:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2331459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2331462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331464 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331470 */   // GIR_Coverage, 2327,
     /* 2331470 */   GIR_EraseRootFromParent_Done,
     /* 2331471 */ // Label 32116: @2331471
     /* 2331471 */ GIM_Reject,
     /* 2331472 */ // Label 32097: @2331472
     /* 2331472 */ GIM_Try, /*On fail goto*//*Label 32117*/ GIMT_Encode4(2331621),
     /* 2331477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331480 */   GIM_Try, /*On fail goto*//*Label 32118*/ GIMT_Encode4(2331508), // Rule ID 1572 //
     /* 2331485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2331488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331496 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2331496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2331499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331507 */     // GIR_Coverage, 1572,
     /* 2331507 */     GIR_EraseRootFromParent_Done,
     /* 2331508 */   // Label 32118: @2331508
     /* 2331508 */   GIM_Try, /*On fail goto*//*Label 32119*/ GIMT_Encode4(2331536), // Rule ID 1573 //
     /* 2331513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2331516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331524 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2331524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2331527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331535 */     // GIR_Coverage, 1573,
     /* 2331535 */     GIR_EraseRootFromParent_Done,
     /* 2331536 */   // Label 32119: @2331536
     /* 2331536 */   GIM_Try, /*On fail goto*//*Label 32120*/ GIMT_Encode4(2331564), // Rule ID 1579 //
     /* 2331541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2331544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331552 */     // (fpround:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_INX:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2331552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2331555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331563 */     // GIR_Coverage, 1579,
     /* 2331563 */     GIR_EraseRootFromParent_Done,
     /* 2331564 */   // Label 32120: @2331564
     /* 2331564 */   GIM_Try, /*On fail goto*//*Label 32121*/ GIMT_Encode4(2331592), // Rule ID 1584 //
     /* 2331569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2331572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331580 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2331580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2331583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331591 */     // GIR_Coverage, 1584,
     /* 2331591 */     GIR_EraseRootFromParent_Done,
     /* 2331592 */   // Label 32121: @2331592
     /* 2331592 */   GIM_Try, /*On fail goto*//*Label 32122*/ GIMT_Encode4(2331620), // Rule ID 1585 //
     /* 2331597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2331600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331608 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2331608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2331611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331619 */     // GIR_Coverage, 1585,
     /* 2331619 */     GIR_EraseRootFromParent_Done,
     /* 2331620 */   // Label 32122: @2331620
     /* 2331620 */   GIM_Reject,
     /* 2331621 */ // Label 32117: @2331621
     /* 2331621 */ GIM_Reject,
     /* 2331622 */ // Label 32098: @2331622
     /* 2331622 */ GIM_Try, /*On fail goto*//*Label 32123*/ GIMT_Encode4(2331731),
     /* 2331627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2331630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331638 */   GIM_Try, /*On fail goto*//*Label 32124*/ GIMT_Encode4(2331684), // Rule ID 58902 //
     /* 2331643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2331646 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2331649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2331663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331683 */     // GIR_Coverage, 58902,
     /* 2331683 */     GIR_EraseRootFromParent_Done,
     /* 2331684 */   // Label 32124: @2331684
     /* 2331684 */   GIM_Try, /*On fail goto*//*Label 32125*/ GIMT_Encode4(2331730), // Rule ID 58903 //
     /* 2331689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2331692 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2331695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2331709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331729 */     // GIR_Coverage, 58903,
     /* 2331729 */     GIR_EraseRootFromParent_Done,
     /* 2331730 */   // Label 32125: @2331730
     /* 2331730 */   GIM_Reject,
     /* 2331731 */ // Label 32123: @2331731
     /* 2331731 */ GIM_Reject,
     /* 2331732 */ // Label 32099: @2331732
     /* 2331732 */ GIM_Try, /*On fail goto*//*Label 32126*/ GIMT_Encode4(2331841),
     /* 2331737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2331740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331748 */   GIM_Try, /*On fail goto*//*Label 32127*/ GIMT_Encode4(2331794), // Rule ID 58912 //
     /* 2331753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2331756 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2331759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2331773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331793 */     // GIR_Coverage, 58912,
     /* 2331793 */     GIR_EraseRootFromParent_Done,
     /* 2331794 */   // Label 32127: @2331794
     /* 2331794 */   GIM_Try, /*On fail goto*//*Label 32128*/ GIMT_Encode4(2331840), // Rule ID 58913 //
     /* 2331799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2331802 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2331805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2331819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331839 */     // GIR_Coverage, 58913,
     /* 2331839 */     GIR_EraseRootFromParent_Done,
     /* 2331840 */   // Label 32128: @2331840
     /* 2331840 */   GIM_Reject,
     /* 2331841 */ // Label 32126: @2331841
     /* 2331841 */ GIM_Reject,
     /* 2331842 */ // Label 32100: @2331842
     /* 2331842 */ GIM_Try, /*On fail goto*//*Label 32129*/ GIMT_Encode4(2331951),
     /* 2331847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2331850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331858 */   GIM_Try, /*On fail goto*//*Label 32130*/ GIMT_Encode4(2331904), // Rule ID 58904 //
     /* 2331863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2331866 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2331869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2331883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331903 */     // GIR_Coverage, 58904,
     /* 2331903 */     GIR_EraseRootFromParent_Done,
     /* 2331904 */   // Label 32130: @2331904
     /* 2331904 */   GIM_Try, /*On fail goto*//*Label 32131*/ GIMT_Encode4(2331950), // Rule ID 58905 //
     /* 2331909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2331912 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2331915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2331929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331949 */     // GIR_Coverage, 58905,
     /* 2331949 */     GIR_EraseRootFromParent_Done,
     /* 2331950 */   // Label 32131: @2331950
     /* 2331950 */   GIM_Reject,
     /* 2331951 */ // Label 32129: @2331951
     /* 2331951 */ GIM_Reject,
     /* 2331952 */ // Label 32101: @2331952
     /* 2331952 */ GIM_Try, /*On fail goto*//*Label 32132*/ GIMT_Encode4(2332061),
     /* 2331957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2331960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331968 */   GIM_Try, /*On fail goto*//*Label 32133*/ GIMT_Encode4(2332014), // Rule ID 58914 //
     /* 2331973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2331976 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2331979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2331993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332013 */     // GIR_Coverage, 58914,
     /* 2332013 */     GIR_EraseRootFromParent_Done,
     /* 2332014 */   // Label 32133: @2332014
     /* 2332014 */   GIM_Try, /*On fail goto*//*Label 32134*/ GIMT_Encode4(2332060), // Rule ID 58915 //
     /* 2332019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2332022 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2332025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2332039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332059 */     // GIR_Coverage, 58915,
     /* 2332059 */     GIR_EraseRootFromParent_Done,
     /* 2332060 */   // Label 32134: @2332060
     /* 2332060 */   GIM_Reject,
     /* 2332061 */ // Label 32132: @2332061
     /* 2332061 */ GIM_Reject,
     /* 2332062 */ // Label 32102: @2332062
     /* 2332062 */ GIM_Try, /*On fail goto*//*Label 32135*/ GIMT_Encode4(2332171),
     /* 2332067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2332070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332078 */   GIM_Try, /*On fail goto*//*Label 32136*/ GIMT_Encode4(2332124), // Rule ID 58906 //
     /* 2332083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2332086 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2332089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2332103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332123 */     // GIR_Coverage, 58906,
     /* 2332123 */     GIR_EraseRootFromParent_Done,
     /* 2332124 */   // Label 32136: @2332124
     /* 2332124 */   GIM_Try, /*On fail goto*//*Label 32137*/ GIMT_Encode4(2332170), // Rule ID 58907 //
     /* 2332129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2332132 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2332135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2332149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332169 */     // GIR_Coverage, 58907,
     /* 2332169 */     GIR_EraseRootFromParent_Done,
     /* 2332170 */   // Label 32137: @2332170
     /* 2332170 */   GIM_Reject,
     /* 2332171 */ // Label 32135: @2332171
     /* 2332171 */ GIM_Reject,
     /* 2332172 */ // Label 32103: @2332172
     /* 2332172 */ GIM_Try, /*On fail goto*//*Label 32138*/ GIMT_Encode4(2332281),
     /* 2332177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2332180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332188 */   GIM_Try, /*On fail goto*//*Label 32139*/ GIMT_Encode4(2332234), // Rule ID 58916 //
     /* 2332193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2332196 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2332199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2332213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332233 */     // GIR_Coverage, 58916,
     /* 2332233 */     GIR_EraseRootFromParent_Done,
     /* 2332234 */   // Label 32139: @2332234
     /* 2332234 */   GIM_Try, /*On fail goto*//*Label 32140*/ GIMT_Encode4(2332280), // Rule ID 58917 //
     /* 2332239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2332242 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2332245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2332259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332279 */     // GIR_Coverage, 58917,
     /* 2332279 */     GIR_EraseRootFromParent_Done,
     /* 2332280 */   // Label 32140: @2332280
     /* 2332280 */   GIM_Reject,
     /* 2332281 */ // Label 32138: @2332281
     /* 2332281 */ GIM_Reject,
     /* 2332282 */ // Label 32104: @2332282
     /* 2332282 */ GIM_Try, /*On fail goto*//*Label 32141*/ GIMT_Encode4(2332391),
     /* 2332287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2332290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332298 */   GIM_Try, /*On fail goto*//*Label 32142*/ GIMT_Encode4(2332344), // Rule ID 58908 //
     /* 2332303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2332306 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2332309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2332323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332343 */     // GIR_Coverage, 58908,
     /* 2332343 */     GIR_EraseRootFromParent_Done,
     /* 2332344 */   // Label 32142: @2332344
     /* 2332344 */   GIM_Try, /*On fail goto*//*Label 32143*/ GIMT_Encode4(2332390), // Rule ID 58909 //
     /* 2332349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2332352 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2332355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2332369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332389 */     // GIR_Coverage, 58909,
     /* 2332389 */     GIR_EraseRootFromParent_Done,
     /* 2332390 */   // Label 32143: @2332390
     /* 2332390 */   GIM_Reject,
     /* 2332391 */ // Label 32141: @2332391
     /* 2332391 */ GIM_Reject,
     /* 2332392 */ // Label 32105: @2332392
     /* 2332392 */ GIM_Try, /*On fail goto*//*Label 32144*/ GIMT_Encode4(2332501),
     /* 2332397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2332400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2332408 */   GIM_Try, /*On fail goto*//*Label 32145*/ GIMT_Encode4(2332454), // Rule ID 58918 //
     /* 2332413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2332416 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2332419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2332433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332453 */     // GIR_Coverage, 58918,
     /* 2332453 */     GIR_EraseRootFromParent_Done,
     /* 2332454 */   // Label 32145: @2332454
     /* 2332454 */   GIM_Try, /*On fail goto*//*Label 32146*/ GIMT_Encode4(2332500), // Rule ID 58919 //
     /* 2332459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2332462 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2332465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2332479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332499 */     // GIR_Coverage, 58919,
     /* 2332499 */     GIR_EraseRootFromParent_Done,
     /* 2332500 */   // Label 32146: @2332500
     /* 2332500 */   GIM_Reject,
     /* 2332501 */ // Label 32144: @2332501
     /* 2332501 */ GIM_Reject,
     /* 2332502 */ // Label 32106: @2332502
     /* 2332502 */ GIM_Try, /*On fail goto*//*Label 32147*/ GIMT_Encode4(2332611),
     /* 2332507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2332510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2332518 */   GIM_Try, /*On fail goto*//*Label 32148*/ GIMT_Encode4(2332564), // Rule ID 58910 //
     /* 2332523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2332526 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2332529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2332543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332563 */     // GIR_Coverage, 58910,
     /* 2332563 */     GIR_EraseRootFromParent_Done,
     /* 2332564 */   // Label 32148: @2332564
     /* 2332564 */   GIM_Try, /*On fail goto*//*Label 32149*/ GIMT_Encode4(2332610), // Rule ID 58911 //
     /* 2332569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2332572 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2332575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2332589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332609 */     // GIR_Coverage, 58911,
     /* 2332609 */     GIR_EraseRootFromParent_Done,
     /* 2332610 */   // Label 32149: @2332610
     /* 2332610 */   GIM_Reject,
     /* 2332611 */ // Label 32147: @2332611
     /* 2332611 */ GIM_Reject,
     /* 2332612 */ // Label 32107: @2332612
     /* 2332612 */ GIM_Reject,
     /* 2332613 */ // Label 67: @2332613
     /* 2332613 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 32173*/ GIMT_Encode4(2337498),
     /* 2332624 */ /*GILLT_s32*//*Label 32150*/ GIMT_Encode4(2332740),
     /* 2332628 */ /*GILLT_s64*//*Label 32151*/ GIMT_Encode4(2333113), GIMT_Encode4(0),
     /* 2332636 */ /*GILLT_nxv1s8*//*Label 32152*/ GIMT_Encode4(2333300),
     /* 2332640 */ /*GILLT_nxv1s16*//*Label 32153*/ GIMT_Encode4(2333404),
     /* 2332644 */ /*GILLT_nxv1s32*//*Label 32154*/ GIMT_Encode4(2333621),
     /* 2332648 */ /*GILLT_nxv1s64*//*Label 32155*/ GIMT_Encode4(2333946), GIMT_Encode4(0),
     /* 2332656 */ /*GILLT_nxv2s8*//*Label 32156*/ GIMT_Encode4(2334163),
     /* 2332660 */ /*GILLT_nxv2s16*//*Label 32157*/ GIMT_Encode4(2334267),
     /* 2332664 */ /*GILLT_nxv2s32*//*Label 32158*/ GIMT_Encode4(2334484),
     /* 2332668 */ /*GILLT_nxv2s64*//*Label 32159*/ GIMT_Encode4(2334809), GIMT_Encode4(0),
     /* 2332676 */ /*GILLT_nxv4s8*//*Label 32160*/ GIMT_Encode4(2335026),
     /* 2332680 */ /*GILLT_nxv4s16*//*Label 32161*/ GIMT_Encode4(2335130),
     /* 2332684 */ /*GILLT_nxv4s32*//*Label 32162*/ GIMT_Encode4(2335347),
     /* 2332688 */ /*GILLT_nxv4s64*//*Label 32163*/ GIMT_Encode4(2335672), GIMT_Encode4(0),
     /* 2332696 */ /*GILLT_nxv8s8*//*Label 32164*/ GIMT_Encode4(2335889),
     /* 2332700 */ /*GILLT_nxv8s16*//*Label 32165*/ GIMT_Encode4(2335993),
     /* 2332704 */ /*GILLT_nxv8s32*//*Label 32166*/ GIMT_Encode4(2336210),
     /* 2332708 */ /*GILLT_nxv8s64*//*Label 32167*/ GIMT_Encode4(2336535), GIMT_Encode4(0),
     /* 2332716 */ /*GILLT_nxv16s8*//*Label 32168*/ GIMT_Encode4(2336752),
     /* 2332720 */ /*GILLT_nxv16s16*//*Label 32169*/ GIMT_Encode4(2336856),
     /* 2332724 */ /*GILLT_nxv16s32*//*Label 32170*/ GIMT_Encode4(2337073), GIMT_Encode4(0),
     /* 2332732 */ /*GILLT_nxv32s8*//*Label 32171*/ GIMT_Encode4(2337290),
     /* 2332736 */ /*GILLT_nxv32s16*//*Label 32172*/ GIMT_Encode4(2337394),
     /* 2332740 */ // Label 32150: @2332740
     /* 2332740 */ GIM_Try, /*On fail goto*//*Label 32174*/ GIMT_Encode4(2332771), // Rule ID 1464 //
     /* 2332745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2332748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2332751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2332759 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2332759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2332762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332764 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332770 */   // GIR_Coverage, 1464,
     /* 2332770 */   GIR_EraseRootFromParent_Done,
     /* 2332771 */ // Label 32174: @2332771
     /* 2332771 */ GIM_Try, /*On fail goto*//*Label 32175*/ GIMT_Encode4(2332802), // Rule ID 1465 //
     /* 2332776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2332779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2332782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2332790 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2332790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2332793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332795 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332800 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332801 */   // GIR_Coverage, 1465,
     /* 2332801 */   GIR_EraseRootFromParent_Done,
     /* 2332802 */ // Label 32175: @2332802
     /* 2332802 */ GIM_Try, /*On fail goto*//*Label 32176*/ GIMT_Encode4(2332833), // Rule ID 1490 //
     /* 2332807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2332810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2332813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2332821 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2332821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2332824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332826 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332831 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332832 */   // GIR_Coverage, 1490,
     /* 2332832 */   GIR_EraseRootFromParent_Done,
     /* 2332833 */ // Label 32176: @2332833
     /* 2332833 */ GIM_Try, /*On fail goto*//*Label 32177*/ GIMT_Encode4(2332864), // Rule ID 1491 //
     /* 2332838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2332841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2332844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2332852 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2332852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2332855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332857 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332862 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332863 */   // GIR_Coverage, 1491,
     /* 2332863 */   GIR_EraseRootFromParent_Done,
     /* 2332864 */ // Label 32177: @2332864
     /* 2332864 */ GIM_Try, /*On fail goto*//*Label 32178*/ GIMT_Encode4(2332895), // Rule ID 1858 //
     /* 2332869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2332872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2332883 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2332883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2332886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332888 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332894 */   // GIR_Coverage, 1858,
     /* 2332894 */   GIR_EraseRootFromParent_Done,
     /* 2332895 */ // Label 32178: @2332895
     /* 2332895 */ GIM_Try, /*On fail goto*//*Label 32179*/ GIMT_Encode4(2332926), // Rule ID 1859 //
     /* 2332900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2332903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2332914 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2332914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2332917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332919 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332925 */   // GIR_Coverage, 1859,
     /* 2332925 */   GIR_EraseRootFromParent_Done,
     /* 2332926 */ // Label 32179: @2332926
     /* 2332926 */ GIM_Try, /*On fail goto*//*Label 32180*/ GIMT_Encode4(2332957), // Rule ID 1884 //
     /* 2332931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2332934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2332945 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2332945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2332948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332950 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332955 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332956 */   // GIR_Coverage, 1884,
     /* 2332956 */   GIR_EraseRootFromParent_Done,
     /* 2332957 */ // Label 32180: @2332957
     /* 2332957 */ GIM_Try, /*On fail goto*//*Label 32181*/ GIMT_Encode4(2332988), // Rule ID 1885 //
     /* 2332962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2332965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2332976 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2332976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2332979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332981 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332987 */   // GIR_Coverage, 1885,
     /* 2332987 */   GIR_EraseRootFromParent_Done,
     /* 2332988 */ // Label 32181: @2332988
     /* 2332988 */ GIM_Try, /*On fail goto*//*Label 32182*/ GIMT_Encode4(2333019), // Rule ID 2200 //
     /* 2332993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2332996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2332999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333007 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2333007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2333010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333012 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333017 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333018 */   // GIR_Coverage, 2200,
     /* 2333018 */   GIR_EraseRootFromParent_Done,
     /* 2333019 */ // Label 32182: @2333019
     /* 2333019 */ GIM_Try, /*On fail goto*//*Label 32183*/ GIMT_Encode4(2333050), // Rule ID 2201 //
     /* 2333024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2333027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333038 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2333038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2333041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333043 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333048 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333049 */   // GIR_Coverage, 2201,
     /* 2333049 */   GIR_EraseRootFromParent_Done,
     /* 2333050 */ // Label 32183: @2333050
     /* 2333050 */ GIM_Try, /*On fail goto*//*Label 32184*/ GIMT_Encode4(2333081), // Rule ID 2226 //
     /* 2333055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2333058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333069 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2333069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2333072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333074 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333079 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333080 */   // GIR_Coverage, 2226,
     /* 2333080 */   GIR_EraseRootFromParent_Done,
     /* 2333081 */ // Label 32184: @2333081
     /* 2333081 */ GIM_Try, /*On fail goto*//*Label 32185*/ GIMT_Encode4(2333112), // Rule ID 2227 //
     /* 2333086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2333089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333100 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2333100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2333103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333105 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333111 */   // GIR_Coverage, 2227,
     /* 2333111 */   GIR_EraseRootFromParent_Done,
     /* 2333112 */ // Label 32185: @2333112
     /* 2333112 */ GIM_Reject,
     /* 2333113 */ // Label 32151: @2333113
     /* 2333113 */ GIM_Try, /*On fail goto*//*Label 32186*/ GIMT_Encode4(2333144), // Rule ID 1521 //
     /* 2333118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2333121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2333124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2333132 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2333132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2333135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333137 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333142 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333143 */   // GIR_Coverage, 1521,
     /* 2333143 */   GIR_EraseRootFromParent_Done,
     /* 2333144 */ // Label 32186: @2333144
     /* 2333144 */ GIM_Try, /*On fail goto*//*Label 32187*/ GIMT_Encode4(2333175), // Rule ID 1549 //
     /* 2333149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2333152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2333155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2333163 */   // (fp_to_sint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2333163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2333166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333168 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333174 */   // GIR_Coverage, 1549,
     /* 2333174 */   GIR_EraseRootFromParent_Done,
     /* 2333175 */ // Label 32187: @2333175
     /* 2333175 */ GIM_Try, /*On fail goto*//*Label 32188*/ GIMT_Encode4(2333206), // Rule ID 1921 //
     /* 2333180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2333183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2333186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2333194 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2333194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2333197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333199 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333204 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333205 */   // GIR_Coverage, 1921,
     /* 2333205 */   GIR_EraseRootFromParent_Done,
     /* 2333206 */ // Label 32188: @2333206
     /* 2333206 */ GIM_Try, /*On fail goto*//*Label 32189*/ GIMT_Encode4(2333237), // Rule ID 1949 //
     /* 2333211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2333214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2333217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333225 */   // (fp_to_sint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2333225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2333228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333230 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333236 */   // GIR_Coverage, 1949,
     /* 2333236 */   GIR_EraseRootFromParent_Done,
     /* 2333237 */ // Label 32189: @2333237
     /* 2333237 */ GIM_Try, /*On fail goto*//*Label 32190*/ GIMT_Encode4(2333268), // Rule ID 2255 //
     /* 2333242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2333245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333256 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2333256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2333259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333261 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333266 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333267 */   // GIR_Coverage, 2255,
     /* 2333267 */   GIR_EraseRootFromParent_Done,
     /* 2333268 */ // Label 32190: @2333268
     /* 2333268 */ GIM_Try, /*On fail goto*//*Label 32191*/ GIMT_Encode4(2333299), // Rule ID 2281 //
     /* 2333273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2333276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333287 */   // (fp_to_sint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2333287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2333290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333292 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333297 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333298 */   // GIR_Coverage, 2281,
     /* 2333298 */   GIR_EraseRootFromParent_Done,
     /* 2333299 */ // Label 32191: @2333299
     /* 2333299 */ GIM_Reject,
     /* 2333300 */ // Label 32152: @2333300
     /* 2333300 */ GIM_Try, /*On fail goto*//*Label 32192*/ GIMT_Encode4(2333403),
     /* 2333305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2333308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333316 */   GIM_Try, /*On fail goto*//*Label 32193*/ GIMT_Encode4(2333359), // Rule ID 45832 //
     /* 2333321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333324 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2333327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2333341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333358 */     // GIR_Coverage, 45832,
     /* 2333358 */     GIR_EraseRootFromParent_Done,
     /* 2333359 */   // Label 32193: @2333359
     /* 2333359 */   GIM_Try, /*On fail goto*//*Label 32194*/ GIMT_Encode4(2333402), // Rule ID 45833 //
     /* 2333364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333367 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2333370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2333384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333401 */     // GIR_Coverage, 45833,
     /* 2333401 */     GIR_EraseRootFromParent_Done,
     /* 2333402 */   // Label 32194: @2333402
     /* 2333402 */   GIM_Reject,
     /* 2333403 */ // Label 32192: @2333403
     /* 2333403 */ GIM_Reject,
     /* 2333404 */ // Label 32153: @2333404
     /* 2333404 */ GIM_Try, /*On fail goto*//*Label 32195*/ GIMT_Encode4(2333458), // Rule ID 45816 //
     /* 2333409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2333415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333423 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2333426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2333440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333445 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333456 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333457 */   // GIR_Coverage, 45816,
     /* 2333457 */   GIR_EraseRootFromParent_Done,
     /* 2333458 */ // Label 32195: @2333458
     /* 2333458 */ GIM_Try, /*On fail goto*//*Label 32196*/ GIMT_Encode4(2333512), // Rule ID 45817 //
     /* 2333463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2333469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333477 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2333480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2333494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333499 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333511 */   // GIR_Coverage, 45817,
     /* 2333511 */   GIR_EraseRootFromParent_Done,
     /* 2333512 */ // Label 32196: @2333512
     /* 2333512 */ GIM_Try, /*On fail goto*//*Label 32197*/ GIMT_Encode4(2333566), // Rule ID 58740 //
     /* 2333517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2333523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333531 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2333534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2333548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333553 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333564 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333565 */   // GIR_Coverage, 58740,
     /* 2333565 */   GIR_EraseRootFromParent_Done,
     /* 2333566 */ // Label 32197: @2333566
     /* 2333566 */ GIM_Try, /*On fail goto*//*Label 32198*/ GIMT_Encode4(2333620), // Rule ID 58741 //
     /* 2333571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2333574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2333577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333585 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2333588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2333602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333607 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333619 */   // GIR_Coverage, 58741,
     /* 2333619 */   GIR_EraseRootFromParent_Done,
     /* 2333620 */ // Label 32198: @2333620
     /* 2333620 */ GIM_Reject,
     /* 2333621 */ // Label 32154: @2333621
     /* 2333621 */ GIM_Try, /*On fail goto*//*Label 32199*/ GIMT_Encode4(2333675), // Rule ID 45824 //
     /* 2333626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2333632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333640 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333640 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333643 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333647 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2333657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333659 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333662 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333673 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333674 */   // GIR_Coverage, 45824,
     /* 2333674 */   GIR_EraseRootFromParent_Done,
     /* 2333675 */ // Label 32199: @2333675
     /* 2333675 */ GIM_Try, /*On fail goto*//*Label 32200*/ GIMT_Encode4(2333729), // Rule ID 45825 //
     /* 2333680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2333686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333694 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333694 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333697 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333701 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2333711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333713 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333716 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333727 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333728 */   // GIR_Coverage, 45825,
     /* 2333728 */   GIR_EraseRootFromParent_Done,
     /* 2333729 */ // Label 32200: @2333729
     /* 2333729 */ GIM_Try, /*On fail goto*//*Label 32201*/ GIMT_Encode4(2333783), // Rule ID 58308 //
     /* 2333734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2333740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333748 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333748 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333751 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333755 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2333765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333767 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333770 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333781 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333782 */   // GIR_Coverage, 58308,
     /* 2333782 */   GIR_EraseRootFromParent_Done,
     /* 2333783 */ // Label 32201: @2333783
     /* 2333783 */ GIM_Try, /*On fail goto*//*Label 32202*/ GIMT_Encode4(2333837), // Rule ID 58309 //
     /* 2333788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2333791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2333794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333802 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2333819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333824 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333835 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333836 */   // GIR_Coverage, 58309,
     /* 2333836 */   GIR_EraseRootFromParent_Done,
     /* 2333837 */ // Label 32202: @2333837
     /* 2333837 */ GIM_Try, /*On fail goto*//*Label 32203*/ GIMT_Encode4(2333891), // Rule ID 58760 //
     /* 2333842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2333845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2333848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333856 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333856 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333859 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333863 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2333873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333875 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333878 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333889 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333890 */   // GIR_Coverage, 58760,
     /* 2333890 */   GIR_EraseRootFromParent_Done,
     /* 2333891 */ // Label 32203: @2333891
     /* 2333891 */ GIM_Try, /*On fail goto*//*Label 32204*/ GIMT_Encode4(2333945), // Rule ID 58761 //
     /* 2333896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2333899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2333902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333910 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333910 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333913 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333917 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2333927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333932 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333943 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333944 */   // GIR_Coverage, 58761,
     /* 2333944 */   GIR_EraseRootFromParent_Done,
     /* 2333945 */ // Label 32204: @2333945
     /* 2333945 */ GIM_Reject,
     /* 2333946 */ // Label 32155: @2333946
     /* 2333946 */ GIM_Try, /*On fail goto*//*Label 32205*/ GIMT_Encode4(2334000), // Rule ID 58320 //
     /* 2333951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2333954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2333957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333965 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2333968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333977 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2333982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333984 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333987 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2333995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333999 */   // GIR_Coverage, 58320,
     /* 2333999 */   GIR_EraseRootFromParent_Done,
     /* 2334000 */ // Label 32205: @2334000
     /* 2334000 */ GIM_Try, /*On fail goto*//*Label 32206*/ GIMT_Encode4(2334054), // Rule ID 58321 //
     /* 2334005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2334008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2334011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334019 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2334022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2334036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334041 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334053 */   // GIR_Coverage, 58321,
     /* 2334053 */   GIR_EraseRootFromParent_Done,
     /* 2334054 */ // Label 32206: @2334054
     /* 2334054 */ GIM_Try, /*On fail goto*//*Label 32207*/ GIMT_Encode4(2334108), // Rule ID 58552 //
     /* 2334059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2334062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2334065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334073 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334073 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2334076 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334080 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2334090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334095 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334107 */   // GIR_Coverage, 58552,
     /* 2334107 */   GIR_EraseRootFromParent_Done,
     /* 2334108 */ // Label 32207: @2334108
     /* 2334108 */ GIM_Try, /*On fail goto*//*Label 32208*/ GIMT_Encode4(2334162), // Rule ID 58553 //
     /* 2334113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2334116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2334119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334127 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2334130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2334144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334149 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334161 */   // GIR_Coverage, 58553,
     /* 2334161 */   GIR_EraseRootFromParent_Done,
     /* 2334162 */ // Label 32208: @2334162
     /* 2334162 */ GIM_Reject,
     /* 2334163 */ // Label 32156: @2334163
     /* 2334163 */ GIM_Try, /*On fail goto*//*Label 32209*/ GIMT_Encode4(2334266),
     /* 2334168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2334171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334179 */   GIM_Try, /*On fail goto*//*Label 32210*/ GIMT_Encode4(2334222), // Rule ID 58720 //
     /* 2334184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334187 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2334190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2334204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334221 */     // GIR_Coverage, 58720,
     /* 2334221 */     GIR_EraseRootFromParent_Done,
     /* 2334222 */   // Label 32210: @2334222
     /* 2334222 */   GIM_Try, /*On fail goto*//*Label 32211*/ GIMT_Encode4(2334265), // Rule ID 58721 //
     /* 2334227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334230 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2334233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2334247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334264 */     // GIR_Coverage, 58721,
     /* 2334264 */     GIR_EraseRootFromParent_Done,
     /* 2334265 */   // Label 32211: @2334265
     /* 2334265 */   GIM_Reject,
     /* 2334266 */ // Label 32209: @2334266
     /* 2334266 */ GIM_Reject,
     /* 2334267 */ // Label 32157: @2334267
     /* 2334267 */ GIM_Try, /*On fail goto*//*Label 32212*/ GIMT_Encode4(2334321), // Rule ID 58304 //
     /* 2334272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2334278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334286 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2334289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2334303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334308 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334319 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334320 */   // GIR_Coverage, 58304,
     /* 2334320 */   GIR_EraseRootFromParent_Done,
     /* 2334321 */ // Label 32212: @2334321
     /* 2334321 */ GIM_Try, /*On fail goto*//*Label 32213*/ GIMT_Encode4(2334375), // Rule ID 58305 //
     /* 2334326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2334332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334340 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2334343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2334357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334359 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334362 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334373 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334374 */   // GIR_Coverage, 58305,
     /* 2334374 */   GIR_EraseRootFromParent_Done,
     /* 2334375 */ // Label 32213: @2334375
     /* 2334375 */ GIM_Try, /*On fail goto*//*Label 32214*/ GIMT_Encode4(2334429), // Rule ID 58744 //
     /* 2334380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334394 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2334397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2334411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334413 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334416 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334427 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334428 */   // GIR_Coverage, 58744,
     /* 2334428 */   GIR_EraseRootFromParent_Done,
     /* 2334429 */ // Label 32214: @2334429
     /* 2334429 */ GIM_Try, /*On fail goto*//*Label 32215*/ GIMT_Encode4(2334483), // Rule ID 58745 //
     /* 2334434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334448 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334448 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2334451 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334455 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2334465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334467 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334470 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334481 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334482 */   // GIR_Coverage, 58745,
     /* 2334482 */   GIR_EraseRootFromParent_Done,
     /* 2334483 */ // Label 32215: @2334483
     /* 2334483 */ GIM_Reject,
     /* 2334484 */ // Label 32158: @2334484
     /* 2334484 */ GIM_Try, /*On fail goto*//*Label 32216*/ GIMT_Encode4(2334538), // Rule ID 58316 //
     /* 2334489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334503 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334503 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2334506 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334510 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2334520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334525 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334536 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334537 */   // GIR_Coverage, 58316,
     /* 2334537 */   GIR_EraseRootFromParent_Done,
     /* 2334538 */ // Label 32216: @2334538
     /* 2334538 */ GIM_Try, /*On fail goto*//*Label 32217*/ GIMT_Encode4(2334592), // Rule ID 58317 //
     /* 2334543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334557 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2334560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2334574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334576 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334579 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334591 */   // GIR_Coverage, 58317,
     /* 2334591 */   GIR_EraseRootFromParent_Done,
     /* 2334592 */ // Label 32217: @2334592
     /* 2334592 */ GIM_Try, /*On fail goto*//*Label 32218*/ GIMT_Encode4(2334646), // Rule ID 58536 //
     /* 2334597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2334603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334611 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334611 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2334614 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334618 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2334628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334633 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334645 */   // GIR_Coverage, 58536,
     /* 2334645 */   GIR_EraseRootFromParent_Done,
     /* 2334646 */ // Label 32218: @2334646
     /* 2334646 */ GIM_Try, /*On fail goto*//*Label 32219*/ GIMT_Encode4(2334700), // Rule ID 58537 //
     /* 2334651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2334657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334665 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334665 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2334668 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334672 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2334682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334687 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334698 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334699 */   // GIR_Coverage, 58537,
     /* 2334699 */   GIR_EraseRootFromParent_Done,
     /* 2334700 */ // Label 32219: @2334700
     /* 2334700 */ GIM_Try, /*On fail goto*//*Label 32220*/ GIMT_Encode4(2334754), // Rule ID 58764 //
     /* 2334705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2334708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2334711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334719 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2334722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2334736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334741 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334752 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334753 */   // GIR_Coverage, 58764,
     /* 2334753 */   GIR_EraseRootFromParent_Done,
     /* 2334754 */ // Label 32220: @2334754
     /* 2334754 */ GIM_Try, /*On fail goto*//*Label 32221*/ GIMT_Encode4(2334808), // Rule ID 58765 //
     /* 2334759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2334762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2334765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334773 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334773 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2334776 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334780 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2334790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334792 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334795 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334806 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334807 */   // GIR_Coverage, 58765,
     /* 2334807 */   GIR_EraseRootFromParent_Done,
     /* 2334808 */ // Label 32221: @2334808
     /* 2334808 */ GIM_Reject,
     /* 2334809 */ // Label 32159: @2334809
     /* 2334809 */ GIM_Try, /*On fail goto*//*Label 32222*/ GIMT_Encode4(2334863), // Rule ID 58348 //
     /* 2334814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2334817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2334820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334828 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334828 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2334831 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334835 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2334845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334847 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334850 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334861 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334862 */   // GIR_Coverage, 58348,
     /* 2334862 */   GIR_EraseRootFromParent_Done,
     /* 2334863 */ // Label 32222: @2334863
     /* 2334863 */ GIM_Try, /*On fail goto*//*Label 32223*/ GIMT_Encode4(2334917), // Rule ID 58349 //
     /* 2334868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2334871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2334874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334882 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334882 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2334885 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334889 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2334899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334904 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334915 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334916 */   // GIR_Coverage, 58349,
     /* 2334916 */   GIR_EraseRootFromParent_Done,
     /* 2334917 */ // Label 32223: @2334917
     /* 2334917 */ GIM_Try, /*On fail goto*//*Label 32224*/ GIMT_Encode4(2334971), // Rule ID 58556 //
     /* 2334922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2334925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334936 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2334939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2334953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334958 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334969 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334970 */   // GIR_Coverage, 58556,
     /* 2334970 */   GIR_EraseRootFromParent_Done,
     /* 2334971 */ // Label 32224: @2334971
     /* 2334971 */ GIM_Try, /*On fail goto*//*Label 32225*/ GIMT_Encode4(2335025), // Rule ID 58557 //
     /* 2334976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2334979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334990 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334990 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2334993 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334997 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2335007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335009 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335012 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335023 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335024 */   // GIR_Coverage, 58557,
     /* 2335024 */   GIR_EraseRootFromParent_Done,
     /* 2335025 */ // Label 32225: @2335025
     /* 2335025 */ GIM_Reject,
     /* 2335026 */ // Label 32160: @2335026
     /* 2335026 */ GIM_Try, /*On fail goto*//*Label 32226*/ GIMT_Encode4(2335129),
     /* 2335031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2335034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335042 */   GIM_Try, /*On fail goto*//*Label 32227*/ GIMT_Encode4(2335085), // Rule ID 58724 //
     /* 2335047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335050 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2335053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2335067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335084 */     // GIR_Coverage, 58724,
     /* 2335084 */     GIR_EraseRootFromParent_Done,
     /* 2335085 */   // Label 32227: @2335085
     /* 2335085 */   GIM_Try, /*On fail goto*//*Label 32228*/ GIMT_Encode4(2335128), // Rule ID 58725 //
     /* 2335090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335093 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2335096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2335110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335127 */     // GIR_Coverage, 58725,
     /* 2335127 */     GIR_EraseRootFromParent_Done,
     /* 2335128 */   // Label 32228: @2335128
     /* 2335128 */   GIM_Reject,
     /* 2335129 */ // Label 32226: @2335129
     /* 2335129 */ GIM_Reject,
     /* 2335130 */ // Label 32161: @2335130
     /* 2335130 */ GIM_Try, /*On fail goto*//*Label 32229*/ GIMT_Encode4(2335184), // Rule ID 58312 //
     /* 2335135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2335141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335149 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335149 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2335152 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335156 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2335166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335171 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335182 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335183 */   // GIR_Coverage, 58312,
     /* 2335183 */   GIR_EraseRootFromParent_Done,
     /* 2335184 */ // Label 32229: @2335184
     /* 2335184 */ GIM_Try, /*On fail goto*//*Label 32230*/ GIMT_Encode4(2335238), // Rule ID 58313 //
     /* 2335189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2335195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335203 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2335206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2335220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335222 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335225 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335236 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335237 */   // GIR_Coverage, 58313,
     /* 2335237 */   GIR_EraseRootFromParent_Done,
     /* 2335238 */ // Label 32230: @2335238
     /* 2335238 */ GIM_Try, /*On fail goto*//*Label 32231*/ GIMT_Encode4(2335292), // Rule ID 58748 //
     /* 2335243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2335246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335257 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335257 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2335260 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335264 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2335274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335276 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335279 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335291 */   // GIR_Coverage, 58748,
     /* 2335291 */   GIR_EraseRootFromParent_Done,
     /* 2335292 */ // Label 32231: @2335292
     /* 2335292 */ GIM_Try, /*On fail goto*//*Label 32232*/ GIMT_Encode4(2335346), // Rule ID 58749 //
     /* 2335297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335311 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335311 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2335314 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335318 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335323 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2335328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335330 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335333 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335344 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335345 */   // GIR_Coverage, 58749,
     /* 2335345 */   GIR_EraseRootFromParent_Done,
     /* 2335346 */ // Label 32232: @2335346
     /* 2335346 */ GIM_Reject,
     /* 2335347 */ // Label 32162: @2335347
     /* 2335347 */ GIM_Try, /*On fail goto*//*Label 32233*/ GIMT_Encode4(2335401), // Rule ID 58336 //
     /* 2335352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2335355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335366 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335366 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2335369 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335373 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2335383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335385 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335388 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335399 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335400 */   // GIR_Coverage, 58336,
     /* 2335400 */   GIR_EraseRootFromParent_Done,
     /* 2335401 */ // Label 32233: @2335401
     /* 2335401 */ GIM_Try, /*On fail goto*//*Label 32234*/ GIMT_Encode4(2335455), // Rule ID 58337 //
     /* 2335406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335420 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2335423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2335437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335442 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335454 */   // GIR_Coverage, 58337,
     /* 2335454 */   GIR_EraseRootFromParent_Done,
     /* 2335455 */ // Label 32234: @2335455
     /* 2335455 */ GIM_Try, /*On fail goto*//*Label 32235*/ GIMT_Encode4(2335509), // Rule ID 58540 //
     /* 2335460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2335466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335474 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2335477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2335491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335493 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335496 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335507 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335508 */   // GIR_Coverage, 58540,
     /* 2335508 */   GIR_EraseRootFromParent_Done,
     /* 2335509 */ // Label 32235: @2335509
     /* 2335509 */ GIM_Try, /*On fail goto*//*Label 32236*/ GIMT_Encode4(2335563), // Rule ID 58541 //
     /* 2335514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2335520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335528 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2335531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2335545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335550 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335561 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335562 */   // GIR_Coverage, 58541,
     /* 2335562 */   GIR_EraseRootFromParent_Done,
     /* 2335563 */ // Label 32236: @2335563
     /* 2335563 */ GIM_Try, /*On fail goto*//*Label 32237*/ GIMT_Encode4(2335617), // Rule ID 58768 //
     /* 2335568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2335571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2335574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335582 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2335585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2335599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335604 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335615 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335616 */   // GIR_Coverage, 58768,
     /* 2335616 */   GIR_EraseRootFromParent_Done,
     /* 2335617 */ // Label 32237: @2335617
     /* 2335617 */ GIM_Try, /*On fail goto*//*Label 32238*/ GIMT_Encode4(2335671), // Rule ID 58769 //
     /* 2335622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2335625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2335628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335636 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335636 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2335639 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335643 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2335653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335658 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335670 */   // GIR_Coverage, 58769,
     /* 2335670 */   GIR_EraseRootFromParent_Done,
     /* 2335671 */ // Label 32238: @2335671
     /* 2335671 */ GIM_Reject,
     /* 2335672 */ // Label 32163: @2335672
     /* 2335672 */ GIM_Try, /*On fail goto*//*Label 32239*/ GIMT_Encode4(2335726), // Rule ID 58352 //
     /* 2335677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2335680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2335683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335691 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335691 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2335694 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335698 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2335708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335713 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2335721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335724 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335725 */   // GIR_Coverage, 58352,
     /* 2335725 */   GIR_EraseRootFromParent_Done,
     /* 2335726 */ // Label 32239: @2335726
     /* 2335726 */ GIM_Try, /*On fail goto*//*Label 32240*/ GIMT_Encode4(2335780), // Rule ID 58353 //
     /* 2335731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2335734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2335737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335745 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2335748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2335762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335767 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2335775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335778 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335779 */   // GIR_Coverage, 58353,
     /* 2335779 */   GIR_EraseRootFromParent_Done,
     /* 2335780 */ // Label 32240: @2335780
     /* 2335780 */ GIM_Try, /*On fail goto*//*Label 32241*/ GIMT_Encode4(2335834), // Rule ID 58560 //
     /* 2335785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2335788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335799 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2335802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2335816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335821 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335833 */   // GIR_Coverage, 58560,
     /* 2335833 */   GIR_EraseRootFromParent_Done,
     /* 2335834 */ // Label 32241: @2335834
     /* 2335834 */ GIM_Try, /*On fail goto*//*Label 32242*/ GIMT_Encode4(2335888), // Rule ID 58561 //
     /* 2335839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2335842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335853 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2335856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2335870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335875 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335887 */   // GIR_Coverage, 58561,
     /* 2335887 */   GIR_EraseRootFromParent_Done,
     /* 2335888 */ // Label 32242: @2335888
     /* 2335888 */ GIM_Reject,
     /* 2335889 */ // Label 32164: @2335889
     /* 2335889 */ GIM_Try, /*On fail goto*//*Label 32243*/ GIMT_Encode4(2335992),
     /* 2335894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2335897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335905 */   GIM_Try, /*On fail goto*//*Label 32244*/ GIMT_Encode4(2335948), // Rule ID 58728 //
     /* 2335910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335913 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2335916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2335930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335947 */     // GIR_Coverage, 58728,
     /* 2335947 */     GIR_EraseRootFromParent_Done,
     /* 2335948 */   // Label 32244: @2335948
     /* 2335948 */   GIM_Try, /*On fail goto*//*Label 32245*/ GIMT_Encode4(2335991), // Rule ID 58729 //
     /* 2335953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335956 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2335959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2335973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335990 */     // GIR_Coverage, 58729,
     /* 2335990 */     GIR_EraseRootFromParent_Done,
     /* 2335991 */   // Label 32245: @2335991
     /* 2335991 */   GIM_Reject,
     /* 2335992 */ // Label 32243: @2335992
     /* 2335992 */ GIM_Reject,
     /* 2335993 */ // Label 32165: @2335993
     /* 2335993 */ GIM_Try, /*On fail goto*//*Label 32246*/ GIMT_Encode4(2336047), // Rule ID 58324 //
     /* 2335998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2336004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336012 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2336015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2336029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336034 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336045 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336046 */   // GIR_Coverage, 58324,
     /* 2336046 */   GIR_EraseRootFromParent_Done,
     /* 2336047 */ // Label 32246: @2336047
     /* 2336047 */ GIM_Try, /*On fail goto*//*Label 32247*/ GIMT_Encode4(2336101), // Rule ID 58325 //
     /* 2336052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2336058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336066 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2336069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2336083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336088 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336099 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336100 */   // GIR_Coverage, 58325,
     /* 2336100 */   GIR_EraseRootFromParent_Done,
     /* 2336101 */ // Label 32247: @2336101
     /* 2336101 */ GIM_Try, /*On fail goto*//*Label 32248*/ GIMT_Encode4(2336155), // Rule ID 58752 //
     /* 2336106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2336109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2336112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336120 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2336123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2336137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336142 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336153 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336154 */   // GIR_Coverage, 58752,
     /* 2336154 */   GIR_EraseRootFromParent_Done,
     /* 2336155 */ // Label 32248: @2336155
     /* 2336155 */ GIM_Try, /*On fail goto*//*Label 32249*/ GIMT_Encode4(2336209), // Rule ID 58753 //
     /* 2336160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2336163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2336166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336174 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2336177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2336191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336193 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336196 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336207 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336208 */   // GIR_Coverage, 58753,
     /* 2336208 */   GIR_EraseRootFromParent_Done,
     /* 2336209 */ // Label 32249: @2336209
     /* 2336209 */ GIM_Reject,
     /* 2336210 */ // Label 32166: @2336210
     /* 2336210 */ GIM_Try, /*On fail goto*//*Label 32250*/ GIMT_Encode4(2336264), // Rule ID 58340 //
     /* 2336215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2336218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2336221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336229 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336229 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2336232 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336236 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2336246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336251 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336262 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336263 */   // GIR_Coverage, 58340,
     /* 2336263 */   GIR_EraseRootFromParent_Done,
     /* 2336264 */ // Label 32250: @2336264
     /* 2336264 */ GIM_Try, /*On fail goto*//*Label 32251*/ GIMT_Encode4(2336318), // Rule ID 58341 //
     /* 2336269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2336272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2336275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336283 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336283 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2336286 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336290 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2336300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336305 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336316 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336317 */   // GIR_Coverage, 58341,
     /* 2336317 */   GIR_EraseRootFromParent_Done,
     /* 2336318 */ // Label 32251: @2336318
     /* 2336318 */ GIM_Try, /*On fail goto*//*Label 32252*/ GIMT_Encode4(2336372), // Rule ID 58544 //
     /* 2336323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2336329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336337 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336337 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2336340 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336344 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2336354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336356 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336359 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336370 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336371 */   // GIR_Coverage, 58544,
     /* 2336371 */   GIR_EraseRootFromParent_Done,
     /* 2336372 */ // Label 32252: @2336372
     /* 2336372 */ GIM_Try, /*On fail goto*//*Label 32253*/ GIMT_Encode4(2336426), // Rule ID 58545 //
     /* 2336377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2336383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336391 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2336394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2336408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336413 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336424 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336425 */   // GIR_Coverage, 58545,
     /* 2336425 */   GIR_EraseRootFromParent_Done,
     /* 2336426 */ // Label 32253: @2336426
     /* 2336426 */ GIM_Try, /*On fail goto*//*Label 32254*/ GIMT_Encode4(2336480), // Rule ID 58772 //
     /* 2336431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2336434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2336437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336445 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2336448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2336462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336467 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336479 */   // GIR_Coverage, 58772,
     /* 2336479 */   GIR_EraseRootFromParent_Done,
     /* 2336480 */ // Label 32254: @2336480
     /* 2336480 */ GIM_Try, /*On fail goto*//*Label 32255*/ GIMT_Encode4(2336534), // Rule ID 58773 //
     /* 2336485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2336488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2336491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336499 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2336502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2336516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336521 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336533 */   // GIR_Coverage, 58773,
     /* 2336533 */   GIR_EraseRootFromParent_Done,
     /* 2336534 */ // Label 32255: @2336534
     /* 2336534 */ GIM_Reject,
     /* 2336535 */ // Label 32167: @2336535
     /* 2336535 */ GIM_Try, /*On fail goto*//*Label 32256*/ GIMT_Encode4(2336589), // Rule ID 58356 //
     /* 2336540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2336543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2336546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336554 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336554 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2336557 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336561 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2336571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336576 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336588 */   // GIR_Coverage, 58356,
     /* 2336588 */   GIR_EraseRootFromParent_Done,
     /* 2336589 */ // Label 32256: @2336589
     /* 2336589 */ GIM_Try, /*On fail goto*//*Label 32257*/ GIMT_Encode4(2336643), // Rule ID 58357 //
     /* 2336594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2336597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2336600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336608 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336608 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2336611 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336615 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2336625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336627 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336630 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336641 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336642 */   // GIR_Coverage, 58357,
     /* 2336642 */   GIR_EraseRootFromParent_Done,
     /* 2336643 */ // Label 32257: @2336643
     /* 2336643 */ GIM_Try, /*On fail goto*//*Label 32258*/ GIMT_Encode4(2336697), // Rule ID 58564 //
     /* 2336648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2336651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2336654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336662 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2336665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2336679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336684 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336695 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336696 */   // GIR_Coverage, 58564,
     /* 2336696 */   GIR_EraseRootFromParent_Done,
     /* 2336697 */ // Label 32258: @2336697
     /* 2336697 */ GIM_Try, /*On fail goto*//*Label 32259*/ GIMT_Encode4(2336751), // Rule ID 58565 //
     /* 2336702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2336705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2336708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336716 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336716 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2336719 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336723 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2336733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336735 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336738 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336750 */   // GIR_Coverage, 58565,
     /* 2336750 */   GIR_EraseRootFromParent_Done,
     /* 2336751 */ // Label 32259: @2336751
     /* 2336751 */ GIM_Reject,
     /* 2336752 */ // Label 32168: @2336752
     /* 2336752 */ GIM_Try, /*On fail goto*//*Label 32260*/ GIMT_Encode4(2336855),
     /* 2336757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2336760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336768 */   GIM_Try, /*On fail goto*//*Label 32261*/ GIMT_Encode4(2336811), // Rule ID 58732 //
     /* 2336773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336776 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2336779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2336793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336810 */     // GIR_Coverage, 58732,
     /* 2336810 */     GIR_EraseRootFromParent_Done,
     /* 2336811 */   // Label 32261: @2336811
     /* 2336811 */   GIM_Try, /*On fail goto*//*Label 32262*/ GIMT_Encode4(2336854), // Rule ID 58733 //
     /* 2336816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336819 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2336822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2336836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336853 */     // GIR_Coverage, 58733,
     /* 2336853 */     GIR_EraseRootFromParent_Done,
     /* 2336854 */   // Label 32262: @2336854
     /* 2336854 */   GIM_Reject,
     /* 2336855 */ // Label 32260: @2336855
     /* 2336855 */ GIM_Reject,
     /* 2336856 */ // Label 32169: @2336856
     /* 2336856 */ GIM_Try, /*On fail goto*//*Label 32263*/ GIMT_Encode4(2336910), // Rule ID 58328 //
     /* 2336861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2336867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336875 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2336878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2336892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336897 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336908 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336909 */   // GIR_Coverage, 58328,
     /* 2336909 */   GIR_EraseRootFromParent_Done,
     /* 2336910 */ // Label 32263: @2336910
     /* 2336910 */ GIM_Try, /*On fail goto*//*Label 32264*/ GIMT_Encode4(2336964), // Rule ID 58329 //
     /* 2336915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2336921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336929 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2336932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2336946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336948 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336951 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336962 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336963 */   // GIR_Coverage, 58329,
     /* 2336963 */   GIR_EraseRootFromParent_Done,
     /* 2336964 */ // Label 32264: @2336964
     /* 2336964 */ GIM_Try, /*On fail goto*//*Label 32265*/ GIMT_Encode4(2337018), // Rule ID 58756 //
     /* 2336969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2336972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2336975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336983 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336983 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2336986 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336990 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2337000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337005 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337016 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337017 */   // GIR_Coverage, 58756,
     /* 2337017 */   GIR_EraseRootFromParent_Done,
     /* 2337018 */ // Label 32265: @2337018
     /* 2337018 */ GIM_Try, /*On fail goto*//*Label 32266*/ GIMT_Encode4(2337072), // Rule ID 58757 //
     /* 2337023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2337026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2337029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337037 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337037 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2337040 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337044 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2337054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337059 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337070 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337071 */   // GIR_Coverage, 58757,
     /* 2337071 */   GIR_EraseRootFromParent_Done,
     /* 2337072 */ // Label 32266: @2337072
     /* 2337072 */ GIM_Reject,
     /* 2337073 */ // Label 32170: @2337073
     /* 2337073 */ GIM_Try, /*On fail goto*//*Label 32267*/ GIMT_Encode4(2337127), // Rule ID 58344 //
     /* 2337078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2337081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2337084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337092 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2337095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2337109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337114 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337125 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337126 */   // GIR_Coverage, 58344,
     /* 2337126 */   GIR_EraseRootFromParent_Done,
     /* 2337127 */ // Label 32267: @2337127
     /* 2337127 */ GIM_Try, /*On fail goto*//*Label 32268*/ GIMT_Encode4(2337181), // Rule ID 58345 //
     /* 2337132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2337135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2337138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337146 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2337149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2337163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337165 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337168 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337179 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337180 */   // GIR_Coverage, 58345,
     /* 2337180 */   GIR_EraseRootFromParent_Done,
     /* 2337181 */ // Label 32268: @2337181
     /* 2337181 */ GIM_Try, /*On fail goto*//*Label 32269*/ GIMT_Encode4(2337235), // Rule ID 58548 //
     /* 2337186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2337192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337200 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337200 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2337203 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337207 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2337217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337222 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337233 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337234 */   // GIR_Coverage, 58548,
     /* 2337234 */   GIR_EraseRootFromParent_Done,
     /* 2337235 */ // Label 32269: @2337235
     /* 2337235 */ GIM_Try, /*On fail goto*//*Label 32270*/ GIMT_Encode4(2337289), // Rule ID 58549 //
     /* 2337240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2337246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337254 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337254 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2337257 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337261 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2337271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337276 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337287 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337288 */   // GIR_Coverage, 58549,
     /* 2337288 */   GIR_EraseRootFromParent_Done,
     /* 2337289 */ // Label 32270: @2337289
     /* 2337289 */ GIM_Reject,
     /* 2337290 */ // Label 32171: @2337290
     /* 2337290 */ GIM_Try, /*On fail goto*//*Label 32271*/ GIMT_Encode4(2337393),
     /* 2337295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2337298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337306 */   GIM_Try, /*On fail goto*//*Label 32272*/ GIMT_Encode4(2337349), // Rule ID 58736 //
     /* 2337311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337314 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2337317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2337331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337348 */     // GIR_Coverage, 58736,
     /* 2337348 */     GIR_EraseRootFromParent_Done,
     /* 2337349 */   // Label 32272: @2337349
     /* 2337349 */   GIM_Try, /*On fail goto*//*Label 32273*/ GIMT_Encode4(2337392), // Rule ID 58737 //
     /* 2337354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337357 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2337360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2337374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337391 */     // GIR_Coverage, 58737,
     /* 2337391 */     GIR_EraseRootFromParent_Done,
     /* 2337392 */   // Label 32273: @2337392
     /* 2337392 */   GIM_Reject,
     /* 2337393 */ // Label 32271: @2337393
     /* 2337393 */ GIM_Reject,
     /* 2337394 */ // Label 32172: @2337394
     /* 2337394 */ GIM_Try, /*On fail goto*//*Label 32274*/ GIMT_Encode4(2337497),
     /* 2337399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2337402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337410 */   GIM_Try, /*On fail goto*//*Label 32275*/ GIMT_Encode4(2337453), // Rule ID 58332 //
     /* 2337415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337418 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2337421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2337435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337452 */     // GIR_Coverage, 58332,
     /* 2337452 */     GIR_EraseRootFromParent_Done,
     /* 2337453 */   // Label 32275: @2337453
     /* 2337453 */   GIM_Try, /*On fail goto*//*Label 32276*/ GIMT_Encode4(2337496), // Rule ID 58333 //
     /* 2337458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337461 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2337464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2337478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337495 */     // GIR_Coverage, 58333,
     /* 2337495 */     GIR_EraseRootFromParent_Done,
     /* 2337496 */   // Label 32276: @2337496
     /* 2337496 */   GIM_Reject,
     /* 2337497 */ // Label 32274: @2337497
     /* 2337497 */ GIM_Reject,
     /* 2337498 */ // Label 32173: @2337498
     /* 2337498 */ GIM_Reject,
     /* 2337499 */ // Label 68: @2337499
     /* 2337499 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 32300*/ GIMT_Encode4(2342384),
     /* 2337510 */ /*GILLT_s32*//*Label 32277*/ GIMT_Encode4(2337626),
     /* 2337514 */ /*GILLT_s64*//*Label 32278*/ GIMT_Encode4(2337999), GIMT_Encode4(0),
     /* 2337522 */ /*GILLT_nxv1s8*//*Label 32279*/ GIMT_Encode4(2338186),
     /* 2337526 */ /*GILLT_nxv1s16*//*Label 32280*/ GIMT_Encode4(2338290),
     /* 2337530 */ /*GILLT_nxv1s32*//*Label 32281*/ GIMT_Encode4(2338507),
     /* 2337534 */ /*GILLT_nxv1s64*//*Label 32282*/ GIMT_Encode4(2338832), GIMT_Encode4(0),
     /* 2337542 */ /*GILLT_nxv2s8*//*Label 32283*/ GIMT_Encode4(2339049),
     /* 2337546 */ /*GILLT_nxv2s16*//*Label 32284*/ GIMT_Encode4(2339153),
     /* 2337550 */ /*GILLT_nxv2s32*//*Label 32285*/ GIMT_Encode4(2339370),
     /* 2337554 */ /*GILLT_nxv2s64*//*Label 32286*/ GIMT_Encode4(2339695), GIMT_Encode4(0),
     /* 2337562 */ /*GILLT_nxv4s8*//*Label 32287*/ GIMT_Encode4(2339912),
     /* 2337566 */ /*GILLT_nxv4s16*//*Label 32288*/ GIMT_Encode4(2340016),
     /* 2337570 */ /*GILLT_nxv4s32*//*Label 32289*/ GIMT_Encode4(2340233),
     /* 2337574 */ /*GILLT_nxv4s64*//*Label 32290*/ GIMT_Encode4(2340558), GIMT_Encode4(0),
     /* 2337582 */ /*GILLT_nxv8s8*//*Label 32291*/ GIMT_Encode4(2340775),
     /* 2337586 */ /*GILLT_nxv8s16*//*Label 32292*/ GIMT_Encode4(2340879),
     /* 2337590 */ /*GILLT_nxv8s32*//*Label 32293*/ GIMT_Encode4(2341096),
     /* 2337594 */ /*GILLT_nxv8s64*//*Label 32294*/ GIMT_Encode4(2341421), GIMT_Encode4(0),
     /* 2337602 */ /*GILLT_nxv16s8*//*Label 32295*/ GIMT_Encode4(2341638),
     /* 2337606 */ /*GILLT_nxv16s16*//*Label 32296*/ GIMT_Encode4(2341742),
     /* 2337610 */ /*GILLT_nxv16s32*//*Label 32297*/ GIMT_Encode4(2341959), GIMT_Encode4(0),
     /* 2337618 */ /*GILLT_nxv32s8*//*Label 32298*/ GIMT_Encode4(2342176),
     /* 2337622 */ /*GILLT_nxv32s16*//*Label 32299*/ GIMT_Encode4(2342280),
     /* 2337626 */ // Label 32277: @2337626
     /* 2337626 */ GIM_Try, /*On fail goto*//*Label 32301*/ GIMT_Encode4(2337657), // Rule ID 1468 //
     /* 2337631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2337634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2337645 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2337645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2337648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337650 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337656 */   // GIR_Coverage, 1468,
     /* 2337656 */   GIR_EraseRootFromParent_Done,
     /* 2337657 */ // Label 32301: @2337657
     /* 2337657 */ GIM_Try, /*On fail goto*//*Label 32302*/ GIMT_Encode4(2337688), // Rule ID 1469 //
     /* 2337662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2337665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2337676 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2337676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2337679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337681 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337686 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337687 */   // GIR_Coverage, 1469,
     /* 2337687 */   GIR_EraseRootFromParent_Done,
     /* 2337688 */ // Label 32302: @2337688
     /* 2337688 */ GIM_Try, /*On fail goto*//*Label 32303*/ GIMT_Encode4(2337719), // Rule ID 1494 //
     /* 2337693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2337696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2337707 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2337707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2337710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337712 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337717 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337718 */   // GIR_Coverage, 1494,
     /* 2337718 */   GIR_EraseRootFromParent_Done,
     /* 2337719 */ // Label 32303: @2337719
     /* 2337719 */ GIM_Try, /*On fail goto*//*Label 32304*/ GIMT_Encode4(2337750), // Rule ID 1495 //
     /* 2337724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2337727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2337738 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2337738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2337741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337743 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337748 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337749 */   // GIR_Coverage, 1495,
     /* 2337749 */   GIR_EraseRootFromParent_Done,
     /* 2337750 */ // Label 32304: @2337750
     /* 2337750 */ GIM_Try, /*On fail goto*//*Label 32305*/ GIMT_Encode4(2337781), // Rule ID 1862 //
     /* 2337755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2337758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2337769 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2337769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2337772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337774 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337780 */   // GIR_Coverage, 1862,
     /* 2337780 */   GIR_EraseRootFromParent_Done,
     /* 2337781 */ // Label 32305: @2337781
     /* 2337781 */ GIM_Try, /*On fail goto*//*Label 32306*/ GIMT_Encode4(2337812), // Rule ID 1863 //
     /* 2337786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2337789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2337800 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2337800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2337803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337805 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337811 */   // GIR_Coverage, 1863,
     /* 2337811 */   GIR_EraseRootFromParent_Done,
     /* 2337812 */ // Label 32306: @2337812
     /* 2337812 */ GIM_Try, /*On fail goto*//*Label 32307*/ GIMT_Encode4(2337843), // Rule ID 1888 //
     /* 2337817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2337820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2337831 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2337831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2337834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337836 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337841 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337842 */   // GIR_Coverage, 1888,
     /* 2337842 */   GIR_EraseRootFromParent_Done,
     /* 2337843 */ // Label 32307: @2337843
     /* 2337843 */ GIM_Try, /*On fail goto*//*Label 32308*/ GIMT_Encode4(2337874), // Rule ID 1889 //
     /* 2337848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2337851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2337862 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2337862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2337865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337867 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337872 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337873 */   // GIR_Coverage, 1889,
     /* 2337873 */   GIR_EraseRootFromParent_Done,
     /* 2337874 */ // Label 32308: @2337874
     /* 2337874 */ GIM_Try, /*On fail goto*//*Label 32309*/ GIMT_Encode4(2337905), // Rule ID 2204 //
     /* 2337879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2337882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2337885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2337893 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2337893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2337896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337898 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337903 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337904 */   // GIR_Coverage, 2204,
     /* 2337904 */   GIR_EraseRootFromParent_Done,
     /* 2337905 */ // Label 32309: @2337905
     /* 2337905 */ GIM_Try, /*On fail goto*//*Label 32310*/ GIMT_Encode4(2337936), // Rule ID 2205 //
     /* 2337910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2337913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2337916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2337924 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2337924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2337927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337929 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337935 */   // GIR_Coverage, 2205,
     /* 2337935 */   GIR_EraseRootFromParent_Done,
     /* 2337936 */ // Label 32310: @2337936
     /* 2337936 */ GIM_Try, /*On fail goto*//*Label 32311*/ GIMT_Encode4(2337967), // Rule ID 2230 //
     /* 2337941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2337944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2337947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2337955 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2337955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2337958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337960 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337965 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337966 */   // GIR_Coverage, 2230,
     /* 2337966 */   GIR_EraseRootFromParent_Done,
     /* 2337967 */ // Label 32311: @2337967
     /* 2337967 */ GIM_Try, /*On fail goto*//*Label 32312*/ GIMT_Encode4(2337998), // Rule ID 2231 //
     /* 2337972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2337975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2337978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2337986 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2337986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2337989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337991 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337997 */   // GIR_Coverage, 2231,
     /* 2337997 */   GIR_EraseRootFromParent_Done,
     /* 2337998 */ // Label 32312: @2337998
     /* 2337998 */ GIM_Reject,
     /* 2337999 */ // Label 32278: @2337999
     /* 2337999 */ GIM_Try, /*On fail goto*//*Label 32313*/ GIMT_Encode4(2338030), // Rule ID 1523 //
     /* 2338004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2338007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2338010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338018 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2338018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S),
     /* 2338021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338023 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2338028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338029 */   // GIR_Coverage, 1523,
     /* 2338029 */   GIR_EraseRootFromParent_Done,
     /* 2338030 */ // Label 32313: @2338030
     /* 2338030 */ GIM_Try, /*On fail goto*//*Label 32314*/ GIMT_Encode4(2338061), // Rule ID 1551 //
     /* 2338035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2338038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2338041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338049 */   // (fp_to_uint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2338049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S_INX),
     /* 2338052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338054 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2338059 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338060 */   // GIR_Coverage, 1551,
     /* 2338060 */   GIR_EraseRootFromParent_Done,
     /* 2338061 */ // Label 32314: @2338061
     /* 2338061 */ GIM_Try, /*On fail goto*//*Label 32315*/ GIMT_Encode4(2338092), // Rule ID 1923 //
     /* 2338066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2338069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2338072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2338080 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2338080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D),
     /* 2338083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338085 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2338090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338091 */   // GIR_Coverage, 1923,
     /* 2338091 */   GIR_EraseRootFromParent_Done,
     /* 2338092 */ // Label 32315: @2338092
     /* 2338092 */ GIM_Try, /*On fail goto*//*Label 32316*/ GIMT_Encode4(2338123), // Rule ID 1951 //
     /* 2338097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2338100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2338103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338111 */   // (fp_to_uint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2338111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D_INX),
     /* 2338114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338116 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2338121 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338122 */   // GIR_Coverage, 1951,
     /* 2338122 */   GIR_EraseRootFromParent_Done,
     /* 2338123 */ // Label 32316: @2338123
     /* 2338123 */ GIM_Try, /*On fail goto*//*Label 32317*/ GIMT_Encode4(2338154), // Rule ID 2257 //
     /* 2338128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2338131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2338134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338142 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2338142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H),
     /* 2338145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338147 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2338152 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338153 */   // GIR_Coverage, 2257,
     /* 2338153 */   GIR_EraseRootFromParent_Done,
     /* 2338154 */ // Label 32317: @2338154
     /* 2338154 */ GIM_Try, /*On fail goto*//*Label 32318*/ GIMT_Encode4(2338185), // Rule ID 2283 //
     /* 2338159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2338162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2338165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338173 */   // (fp_to_uint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2338173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H_INX),
     /* 2338176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338178 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2338183 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338184 */   // GIR_Coverage, 2283,
     /* 2338184 */   GIR_EraseRootFromParent_Done,
     /* 2338185 */ // Label 32318: @2338185
     /* 2338185 */ GIM_Reject,
     /* 2338186 */ // Label 32279: @2338186
     /* 2338186 */ GIM_Try, /*On fail goto*//*Label 32319*/ GIMT_Encode4(2338289),
     /* 2338191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2338194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338202 */   GIM_Try, /*On fail goto*//*Label 32320*/ GIMT_Encode4(2338245), // Rule ID 58776 //
     /* 2338207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338210 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2338213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2338227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338244 */     // GIR_Coverage, 58776,
     /* 2338244 */     GIR_EraseRootFromParent_Done,
     /* 2338245 */   // Label 32320: @2338245
     /* 2338245 */   GIM_Try, /*On fail goto*//*Label 32321*/ GIMT_Encode4(2338288), // Rule ID 58777 //
     /* 2338250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338253 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2338256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2338270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338287 */     // GIR_Coverage, 58777,
     /* 2338287 */     GIR_EraseRootFromParent_Done,
     /* 2338288 */   // Label 32321: @2338288
     /* 2338288 */   GIM_Reject,
     /* 2338289 */ // Label 32319: @2338289
     /* 2338289 */ GIM_Reject,
     /* 2338290 */ // Label 32280: @2338290
     /* 2338290 */ GIM_Try, /*On fail goto*//*Label 32322*/ GIMT_Encode4(2338344), // Rule ID 58360 //
     /* 2338295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2338301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338309 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2338312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2338326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338331 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338342 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338343 */   // GIR_Coverage, 58360,
     /* 2338343 */   GIR_EraseRootFromParent_Done,
     /* 2338344 */ // Label 32322: @2338344
     /* 2338344 */ GIM_Try, /*On fail goto*//*Label 32323*/ GIMT_Encode4(2338398), // Rule ID 58361 //
     /* 2338349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2338355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338363 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338363 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2338366 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338370 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2338380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338385 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338397 */   // GIR_Coverage, 58361,
     /* 2338397 */   GIR_EraseRootFromParent_Done,
     /* 2338398 */ // Label 32323: @2338398
     /* 2338398 */ GIM_Try, /*On fail goto*//*Label 32324*/ GIMT_Encode4(2338452), // Rule ID 58800 //
     /* 2338403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2338406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338417 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338417 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2338420 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338424 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2338434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338439 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338450 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338451 */   // GIR_Coverage, 58800,
     /* 2338451 */   GIR_EraseRootFromParent_Done,
     /* 2338452 */ // Label 32324: @2338452
     /* 2338452 */ GIM_Try, /*On fail goto*//*Label 32325*/ GIMT_Encode4(2338506), // Rule ID 58801 //
     /* 2338457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2338460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338471 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2338474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2338488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338490 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338493 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338504 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338505 */   // GIR_Coverage, 58801,
     /* 2338505 */   GIR_EraseRootFromParent_Done,
     /* 2338506 */ // Label 32325: @2338506
     /* 2338506 */ GIM_Reject,
     /* 2338507 */ // Label 32281: @2338507
     /* 2338507 */ GIM_Try, /*On fail goto*//*Label 32326*/ GIMT_Encode4(2338561), // Rule ID 58368 //
     /* 2338512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2338515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338526 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2338543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338548 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338559 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338560 */   // GIR_Coverage, 58368,
     /* 2338560 */   GIR_EraseRootFromParent_Done,
     /* 2338561 */ // Label 32326: @2338561
     /* 2338561 */ GIM_Try, /*On fail goto*//*Label 32327*/ GIMT_Encode4(2338615), // Rule ID 58369 //
     /* 2338566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2338569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338580 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2338597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338602 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338613 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338614 */   // GIR_Coverage, 58369,
     /* 2338614 */   GIR_EraseRootFromParent_Done,
     /* 2338615 */ // Label 32327: @2338615
     /* 2338615 */ GIM_Try, /*On fail goto*//*Label 32328*/ GIMT_Encode4(2338669), // Rule ID 58568 //
     /* 2338620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2338626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338634 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2338651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338653 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338656 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338667 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338668 */   // GIR_Coverage, 58568,
     /* 2338668 */   GIR_EraseRootFromParent_Done,
     /* 2338669 */ // Label 32328: @2338669
     /* 2338669 */ GIM_Try, /*On fail goto*//*Label 32329*/ GIMT_Encode4(2338723), // Rule ID 58569 //
     /* 2338674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2338680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338688 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2338705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338710 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338721 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338722 */   // GIR_Coverage, 58569,
     /* 2338722 */   GIR_EraseRootFromParent_Done,
     /* 2338723 */ // Label 32329: @2338723
     /* 2338723 */ GIM_Try, /*On fail goto*//*Label 32330*/ GIMT_Encode4(2338777), // Rule ID 58820 //
     /* 2338728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2338731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2338734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338742 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2338759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338764 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338775 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338776 */   // GIR_Coverage, 58820,
     /* 2338776 */   GIR_EraseRootFromParent_Done,
     /* 2338777 */ // Label 32330: @2338777
     /* 2338777 */ GIM_Try, /*On fail goto*//*Label 32331*/ GIMT_Encode4(2338831), // Rule ID 58821 //
     /* 2338782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2338785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2338788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338796 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2338813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338818 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338830 */   // GIR_Coverage, 58821,
     /* 2338830 */   GIR_EraseRootFromParent_Done,
     /* 2338831 */ // Label 32331: @2338831
     /* 2338831 */ GIM_Reject,
     /* 2338832 */ // Label 32282: @2338832
     /* 2338832 */ GIM_Try, /*On fail goto*//*Label 32332*/ GIMT_Encode4(2338886), // Rule ID 58380 //
     /* 2338837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2338840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2338843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338851 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2338854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338863 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2338868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338870 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338873 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338884 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338885 */   // GIR_Coverage, 58380,
     /* 2338885 */   GIR_EraseRootFromParent_Done,
     /* 2338886 */ // Label 32332: @2338886
     /* 2338886 */ GIM_Try, /*On fail goto*//*Label 32333*/ GIMT_Encode4(2338940), // Rule ID 58381 //
     /* 2338891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2338894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2338897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338905 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338905 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2338908 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338912 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2338922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338924 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338927 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338938 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338939 */   // GIR_Coverage, 58381,
     /* 2338939 */   GIR_EraseRootFromParent_Done,
     /* 2338940 */ // Label 32333: @2338940
     /* 2338940 */ GIM_Try, /*On fail goto*//*Label 32334*/ GIMT_Encode4(2338994), // Rule ID 58588 //
     /* 2338945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2338948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338959 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2338962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2338976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338978 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338981 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338992 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338993 */   // GIR_Coverage, 58588,
     /* 2338993 */   GIR_EraseRootFromParent_Done,
     /* 2338994 */ // Label 32334: @2338994
     /* 2338994 */ GIM_Try, /*On fail goto*//*Label 32335*/ GIMT_Encode4(2339048), // Rule ID 58589 //
     /* 2338999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2339002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2339005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339013 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339013 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2339016 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339020 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2339030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339032 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339035 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339046 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339047 */   // GIR_Coverage, 58589,
     /* 2339047 */   GIR_EraseRootFromParent_Done,
     /* 2339048 */ // Label 32335: @2339048
     /* 2339048 */ GIM_Reject,
     /* 2339049 */ // Label 32283: @2339049
     /* 2339049 */ GIM_Try, /*On fail goto*//*Label 32336*/ GIMT_Encode4(2339152),
     /* 2339054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2339057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339065 */   GIM_Try, /*On fail goto*//*Label 32337*/ GIMT_Encode4(2339108), // Rule ID 58780 //
     /* 2339070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339073 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2339076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2339090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339107 */     // GIR_Coverage, 58780,
     /* 2339107 */     GIR_EraseRootFromParent_Done,
     /* 2339108 */   // Label 32337: @2339108
     /* 2339108 */   GIM_Try, /*On fail goto*//*Label 32338*/ GIMT_Encode4(2339151), // Rule ID 58781 //
     /* 2339113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339116 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2339119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2339133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339150 */     // GIR_Coverage, 58781,
     /* 2339150 */     GIR_EraseRootFromParent_Done,
     /* 2339151 */   // Label 32338: @2339151
     /* 2339151 */   GIM_Reject,
     /* 2339152 */ // Label 32336: @2339152
     /* 2339152 */ GIM_Reject,
     /* 2339153 */ // Label 32284: @2339153
     /* 2339153 */ GIM_Try, /*On fail goto*//*Label 32339*/ GIMT_Encode4(2339207), // Rule ID 58364 //
     /* 2339158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2339164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339172 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339172 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2339175 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339179 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2339189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339194 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339205 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339206 */   // GIR_Coverage, 58364,
     /* 2339206 */   GIR_EraseRootFromParent_Done,
     /* 2339207 */ // Label 32339: @2339207
     /* 2339207 */ GIM_Try, /*On fail goto*//*Label 32340*/ GIMT_Encode4(2339261), // Rule ID 58365 //
     /* 2339212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2339218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339226 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339226 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2339229 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339233 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2339243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339248 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339260 */   // GIR_Coverage, 58365,
     /* 2339260 */   GIR_EraseRootFromParent_Done,
     /* 2339261 */ // Label 32340: @2339261
     /* 2339261 */ GIM_Try, /*On fail goto*//*Label 32341*/ GIMT_Encode4(2339315), // Rule ID 58804 //
     /* 2339266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2339269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339280 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339280 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2339283 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339287 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2339297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339302 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339313 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339314 */   // GIR_Coverage, 58804,
     /* 2339314 */   GIR_EraseRootFromParent_Done,
     /* 2339315 */ // Label 32341: @2339315
     /* 2339315 */ GIM_Try, /*On fail goto*//*Label 32342*/ GIMT_Encode4(2339369), // Rule ID 58805 //
     /* 2339320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2339323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339334 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2339337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2339351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339353 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339356 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339367 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339368 */   // GIR_Coverage, 58805,
     /* 2339368 */   GIR_EraseRootFromParent_Done,
     /* 2339369 */ // Label 32342: @2339369
     /* 2339369 */ GIM_Reject,
     /* 2339370 */ // Label 32285: @2339370
     /* 2339370 */ GIM_Try, /*On fail goto*//*Label 32343*/ GIMT_Encode4(2339424), // Rule ID 58376 //
     /* 2339375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2339378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339389 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339389 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339392 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339396 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2339406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339411 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339422 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339423 */   // GIR_Coverage, 58376,
     /* 2339423 */   GIR_EraseRootFromParent_Done,
     /* 2339424 */ // Label 32343: @2339424
     /* 2339424 */ GIM_Try, /*On fail goto*//*Label 32344*/ GIMT_Encode4(2339478), // Rule ID 58377 //
     /* 2339429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2339432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339443 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2339460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339465 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339476 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339477 */   // GIR_Coverage, 58377,
     /* 2339477 */   GIR_EraseRootFromParent_Done,
     /* 2339478 */ // Label 32344: @2339478
     /* 2339478 */ GIM_Try, /*On fail goto*//*Label 32345*/ GIMT_Encode4(2339532), // Rule ID 58572 //
     /* 2339483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2339489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339497 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2339514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339519 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339531 */   // GIR_Coverage, 58572,
     /* 2339531 */   GIR_EraseRootFromParent_Done,
     /* 2339532 */ // Label 32345: @2339532
     /* 2339532 */ GIM_Try, /*On fail goto*//*Label 32346*/ GIMT_Encode4(2339586), // Rule ID 58573 //
     /* 2339537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2339543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339551 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2339568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339570 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339573 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339584 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339585 */   // GIR_Coverage, 58573,
     /* 2339585 */   GIR_EraseRootFromParent_Done,
     /* 2339586 */ // Label 32346: @2339586
     /* 2339586 */ GIM_Try, /*On fail goto*//*Label 32347*/ GIMT_Encode4(2339640), // Rule ID 58824 //
     /* 2339591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2339594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2339597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339605 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339605 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339608 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339612 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2339622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339627 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339638 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339639 */   // GIR_Coverage, 58824,
     /* 2339639 */   GIR_EraseRootFromParent_Done,
     /* 2339640 */ // Label 32347: @2339640
     /* 2339640 */ GIM_Try, /*On fail goto*//*Label 32348*/ GIMT_Encode4(2339694), // Rule ID 58825 //
     /* 2339645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2339648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2339651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339659 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2339676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339678 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339681 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339693 */   // GIR_Coverage, 58825,
     /* 2339693 */   GIR_EraseRootFromParent_Done,
     /* 2339694 */ // Label 32348: @2339694
     /* 2339694 */ GIM_Reject,
     /* 2339695 */ // Label 32286: @2339695
     /* 2339695 */ GIM_Try, /*On fail goto*//*Label 32349*/ GIMT_Encode4(2339749), // Rule ID 58408 //
     /* 2339700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2339703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2339706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339714 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2339717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2339731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339736 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2339744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339748 */   // GIR_Coverage, 58408,
     /* 2339748 */   GIR_EraseRootFromParent_Done,
     /* 2339749 */ // Label 32349: @2339749
     /* 2339749 */ GIM_Try, /*On fail goto*//*Label 32350*/ GIMT_Encode4(2339803), // Rule ID 58409 //
     /* 2339754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2339757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2339760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339768 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2339771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2339785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339790 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2339798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339801 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339802 */   // GIR_Coverage, 58409,
     /* 2339802 */   GIR_EraseRootFromParent_Done,
     /* 2339803 */ // Label 32350: @2339803
     /* 2339803 */ GIM_Try, /*On fail goto*//*Label 32351*/ GIMT_Encode4(2339857), // Rule ID 58592 //
     /* 2339808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2339811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339822 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2339825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2339839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339844 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339855 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339856 */   // GIR_Coverage, 58592,
     /* 2339856 */   GIR_EraseRootFromParent_Done,
     /* 2339857 */ // Label 32351: @2339857
     /* 2339857 */ GIM_Try, /*On fail goto*//*Label 32352*/ GIMT_Encode4(2339911), // Rule ID 58593 //
     /* 2339862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2339865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339876 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2339879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2339893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339898 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339909 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339910 */   // GIR_Coverage, 58593,
     /* 2339910 */   GIR_EraseRootFromParent_Done,
     /* 2339911 */ // Label 32352: @2339911
     /* 2339911 */ GIM_Reject,
     /* 2339912 */ // Label 32287: @2339912
     /* 2339912 */ GIM_Try, /*On fail goto*//*Label 32353*/ GIMT_Encode4(2340015),
     /* 2339917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2339920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339928 */   GIM_Try, /*On fail goto*//*Label 32354*/ GIMT_Encode4(2339971), // Rule ID 58784 //
     /* 2339933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339936 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2339939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2339953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339970 */     // GIR_Coverage, 58784,
     /* 2339970 */     GIR_EraseRootFromParent_Done,
     /* 2339971 */   // Label 32354: @2339971
     /* 2339971 */   GIM_Try, /*On fail goto*//*Label 32355*/ GIMT_Encode4(2340014), // Rule ID 58785 //
     /* 2339976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339979 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2339982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2339996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340013 */     // GIR_Coverage, 58785,
     /* 2340013 */     GIR_EraseRootFromParent_Done,
     /* 2340014 */   // Label 32355: @2340014
     /* 2340014 */   GIM_Reject,
     /* 2340015 */ // Label 32353: @2340015
     /* 2340015 */ GIM_Reject,
     /* 2340016 */ // Label 32288: @2340016
     /* 2340016 */ GIM_Try, /*On fail goto*//*Label 32356*/ GIMT_Encode4(2340070), // Rule ID 58372 //
     /* 2340021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2340027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340035 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2340038 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340042 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2340052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340057 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340069 */   // GIR_Coverage, 58372,
     /* 2340069 */   GIR_EraseRootFromParent_Done,
     /* 2340070 */ // Label 32356: @2340070
     /* 2340070 */ GIM_Try, /*On fail goto*//*Label 32357*/ GIMT_Encode4(2340124), // Rule ID 58373 //
     /* 2340075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2340081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340089 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2340092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2340106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340111 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340122 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340123 */   // GIR_Coverage, 58373,
     /* 2340123 */   GIR_EraseRootFromParent_Done,
     /* 2340124 */ // Label 32357: @2340124
     /* 2340124 */ GIM_Try, /*On fail goto*//*Label 32358*/ GIMT_Encode4(2340178), // Rule ID 58808 //
     /* 2340129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340143 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340143 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2340146 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340150 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2340160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340162 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340165 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340176 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340177 */   // GIR_Coverage, 58808,
     /* 2340177 */   GIR_EraseRootFromParent_Done,
     /* 2340178 */ // Label 32358: @2340178
     /* 2340178 */ GIM_Try, /*On fail goto*//*Label 32359*/ GIMT_Encode4(2340232), // Rule ID 58809 //
     /* 2340183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2340186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340197 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340197 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2340200 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340204 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2340214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340219 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340230 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340231 */   // GIR_Coverage, 58809,
     /* 2340231 */   GIR_EraseRootFromParent_Done,
     /* 2340232 */ // Label 32359: @2340232
     /* 2340232 */ GIM_Reject,
     /* 2340233 */ // Label 32289: @2340233
     /* 2340233 */ GIM_Try, /*On fail goto*//*Label 32360*/ GIMT_Encode4(2340287), // Rule ID 58396 //
     /* 2340238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340252 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2340269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340274 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340286 */   // GIR_Coverage, 58396,
     /* 2340286 */   GIR_EraseRootFromParent_Done,
     /* 2340287 */ // Label 32360: @2340287
     /* 2340287 */ GIM_Try, /*On fail goto*//*Label 32361*/ GIMT_Encode4(2340341), // Rule ID 58397 //
     /* 2340292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2340295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340306 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2340323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340328 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340339 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340340 */   // GIR_Coverage, 58397,
     /* 2340340 */   GIR_EraseRootFromParent_Done,
     /* 2340341 */ // Label 32361: @2340341
     /* 2340341 */ GIM_Try, /*On fail goto*//*Label 32362*/ GIMT_Encode4(2340395), // Rule ID 58576 //
     /* 2340346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2340352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340360 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2340377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340382 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340393 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340394 */   // GIR_Coverage, 58576,
     /* 2340394 */   GIR_EraseRootFromParent_Done,
     /* 2340395 */ // Label 32362: @2340395
     /* 2340395 */ GIM_Try, /*On fail goto*//*Label 32363*/ GIMT_Encode4(2340449), // Rule ID 58577 //
     /* 2340400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2340406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340414 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2340431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340436 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340447 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340448 */   // GIR_Coverage, 58577,
     /* 2340448 */   GIR_EraseRootFromParent_Done,
     /* 2340449 */ // Label 32363: @2340449
     /* 2340449 */ GIM_Try, /*On fail goto*//*Label 32364*/ GIMT_Encode4(2340503), // Rule ID 58828 //
     /* 2340454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2340457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2340460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340468 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2340485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340490 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340501 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340502 */   // GIR_Coverage, 58828,
     /* 2340502 */   GIR_EraseRootFromParent_Done,
     /* 2340503 */ // Label 32364: @2340503
     /* 2340503 */ GIM_Try, /*On fail goto*//*Label 32365*/ GIMT_Encode4(2340557), // Rule ID 58829 //
     /* 2340508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2340511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2340514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340522 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340522 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340525 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340529 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2340539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340544 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340555 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340556 */   // GIR_Coverage, 58829,
     /* 2340556 */   GIR_EraseRootFromParent_Done,
     /* 2340557 */ // Label 32365: @2340557
     /* 2340557 */ GIM_Reject,
     /* 2340558 */ // Label 32290: @2340558
     /* 2340558 */ GIM_Try, /*On fail goto*//*Label 32366*/ GIMT_Encode4(2340612), // Rule ID 58412 //
     /* 2340563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2340566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2340569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340577 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2340580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2340594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340599 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340610 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340611 */   // GIR_Coverage, 58412,
     /* 2340611 */   GIR_EraseRootFromParent_Done,
     /* 2340612 */ // Label 32366: @2340612
     /* 2340612 */ GIM_Try, /*On fail goto*//*Label 32367*/ GIMT_Encode4(2340666), // Rule ID 58413 //
     /* 2340617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2340620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2340623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340631 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340631 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2340634 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340638 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2340648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340653 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340664 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340665 */   // GIR_Coverage, 58413,
     /* 2340665 */   GIR_EraseRootFromParent_Done,
     /* 2340666 */ // Label 32367: @2340666
     /* 2340666 */ GIM_Try, /*On fail goto*//*Label 32368*/ GIMT_Encode4(2340720), // Rule ID 58596 //
     /* 2340671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2340674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340685 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2340688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2340702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340704 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340707 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340719 */   // GIR_Coverage, 58596,
     /* 2340719 */   GIR_EraseRootFromParent_Done,
     /* 2340720 */ // Label 32368: @2340720
     /* 2340720 */ GIM_Try, /*On fail goto*//*Label 32369*/ GIMT_Encode4(2340774), // Rule ID 58597 //
     /* 2340725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2340728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340739 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2340742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2340756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340761 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340773 */   // GIR_Coverage, 58597,
     /* 2340773 */   GIR_EraseRootFromParent_Done,
     /* 2340774 */ // Label 32369: @2340774
     /* 2340774 */ GIM_Reject,
     /* 2340775 */ // Label 32291: @2340775
     /* 2340775 */ GIM_Try, /*On fail goto*//*Label 32370*/ GIMT_Encode4(2340878),
     /* 2340780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2340783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340791 */   GIM_Try, /*On fail goto*//*Label 32371*/ GIMT_Encode4(2340834), // Rule ID 58788 //
     /* 2340796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340799 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2340802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2340816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340833 */     // GIR_Coverage, 58788,
     /* 2340833 */     GIR_EraseRootFromParent_Done,
     /* 2340834 */   // Label 32371: @2340834
     /* 2340834 */   GIM_Try, /*On fail goto*//*Label 32372*/ GIMT_Encode4(2340877), // Rule ID 58789 //
     /* 2340839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340842 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2340845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2340859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340876 */     // GIR_Coverage, 58789,
     /* 2340876 */     GIR_EraseRootFromParent_Done,
     /* 2340877 */   // Label 32372: @2340877
     /* 2340877 */   GIM_Reject,
     /* 2340878 */ // Label 32370: @2340878
     /* 2340878 */ GIM_Reject,
     /* 2340879 */ // Label 32292: @2340879
     /* 2340879 */ GIM_Try, /*On fail goto*//*Label 32373*/ GIMT_Encode4(2340933), // Rule ID 58384 //
     /* 2340884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2340890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340898 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2340915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340920 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340932 */   // GIR_Coverage, 58384,
     /* 2340932 */   GIR_EraseRootFromParent_Done,
     /* 2340933 */ // Label 32373: @2340933
     /* 2340933 */ GIM_Try, /*On fail goto*//*Label 32374*/ GIMT_Encode4(2340987), // Rule ID 58385 //
     /* 2340938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2340944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340952 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2340969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340974 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340986 */   // GIR_Coverage, 58385,
     /* 2340986 */   GIR_EraseRootFromParent_Done,
     /* 2340987 */ // Label 32374: @2340987
     /* 2340987 */ GIM_Try, /*On fail goto*//*Label 32375*/ GIMT_Encode4(2341041), // Rule ID 58812 //
     /* 2340992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2340998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341006 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2341009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2341023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341028 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341039 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341040 */   // GIR_Coverage, 58812,
     /* 2341040 */   GIR_EraseRootFromParent_Done,
     /* 2341041 */ // Label 32375: @2341041
     /* 2341041 */ GIM_Try, /*On fail goto*//*Label 32376*/ GIMT_Encode4(2341095), // Rule ID 58813 //
     /* 2341046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341060 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2341063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2341077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341082 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341094 */   // GIR_Coverage, 58813,
     /* 2341094 */   GIR_EraseRootFromParent_Done,
     /* 2341095 */ // Label 32376: @2341095
     /* 2341095 */ GIM_Reject,
     /* 2341096 */ // Label 32293: @2341096
     /* 2341096 */ GIM_Try, /*On fail goto*//*Label 32377*/ GIMT_Encode4(2341150), // Rule ID 58400 //
     /* 2341101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341115 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341115 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341118 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341122 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2341132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341137 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341148 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341149 */   // GIR_Coverage, 58400,
     /* 2341149 */   GIR_EraseRootFromParent_Done,
     /* 2341150 */ // Label 32377: @2341150
     /* 2341150 */ GIM_Try, /*On fail goto*//*Label 32378*/ GIMT_Encode4(2341204), // Rule ID 58401 //
     /* 2341155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341169 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341169 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341172 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341176 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2341186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341191 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341202 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341203 */   // GIR_Coverage, 58401,
     /* 2341203 */   GIR_EraseRootFromParent_Done,
     /* 2341204 */ // Label 32378: @2341204
     /* 2341204 */ GIM_Try, /*On fail goto*//*Label 32379*/ GIMT_Encode4(2341258), // Rule ID 58580 //
     /* 2341209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2341215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341223 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2341240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341245 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341256 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341257 */   // GIR_Coverage, 58580,
     /* 2341257 */   GIR_EraseRootFromParent_Done,
     /* 2341258 */ // Label 32379: @2341258
     /* 2341258 */ GIM_Try, /*On fail goto*//*Label 32380*/ GIMT_Encode4(2341312), // Rule ID 58581 //
     /* 2341263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2341269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341277 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341277 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341284 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2341294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341296 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341299 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341310 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341311 */   // GIR_Coverage, 58581,
     /* 2341311 */   GIR_EraseRootFromParent_Done,
     /* 2341312 */ // Label 32380: @2341312
     /* 2341312 */ GIM_Try, /*On fail goto*//*Label 32381*/ GIMT_Encode4(2341366), // Rule ID 58832 //
     /* 2341317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2341320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2341323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341331 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2341348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341353 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341364 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341365 */   // GIR_Coverage, 58832,
     /* 2341365 */   GIR_EraseRootFromParent_Done,
     /* 2341366 */ // Label 32381: @2341366
     /* 2341366 */ GIM_Try, /*On fail goto*//*Label 32382*/ GIMT_Encode4(2341420), // Rule ID 58833 //
     /* 2341371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2341374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2341377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341385 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2341402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341404 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341407 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341418 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341419 */   // GIR_Coverage, 58833,
     /* 2341419 */   GIR_EraseRootFromParent_Done,
     /* 2341420 */ // Label 32382: @2341420
     /* 2341420 */ GIM_Reject,
     /* 2341421 */ // Label 32294: @2341421
     /* 2341421 */ GIM_Try, /*On fail goto*//*Label 32383*/ GIMT_Encode4(2341475), // Rule ID 58416 //
     /* 2341426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2341429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2341432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341440 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2341457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341459 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341462 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341474 */   // GIR_Coverage, 58416,
     /* 2341474 */   GIR_EraseRootFromParent_Done,
     /* 2341475 */ // Label 32383: @2341475
     /* 2341475 */ GIM_Try, /*On fail goto*//*Label 32384*/ GIMT_Encode4(2341529), // Rule ID 58417 //
     /* 2341480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2341483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2341486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341494 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2341511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341516 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341527 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341528 */   // GIR_Coverage, 58417,
     /* 2341528 */   GIR_EraseRootFromParent_Done,
     /* 2341529 */ // Label 32384: @2341529
     /* 2341529 */ GIM_Try, /*On fail goto*//*Label 32385*/ GIMT_Encode4(2341583), // Rule ID 58600 //
     /* 2341534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2341537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341548 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2341565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341570 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341581 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341582 */   // GIR_Coverage, 58600,
     /* 2341582 */   GIR_EraseRootFromParent_Done,
     /* 2341583 */ // Label 32385: @2341583
     /* 2341583 */ GIM_Try, /*On fail goto*//*Label 32386*/ GIMT_Encode4(2341637), // Rule ID 58601 //
     /* 2341588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2341591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341602 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341602 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341605 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341609 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2341619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341624 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341636 */   // GIR_Coverage, 58601,
     /* 2341636 */   GIR_EraseRootFromParent_Done,
     /* 2341637 */ // Label 32386: @2341637
     /* 2341637 */ GIM_Reject,
     /* 2341638 */ // Label 32295: @2341638
     /* 2341638 */ GIM_Try, /*On fail goto*//*Label 32387*/ GIMT_Encode4(2341741),
     /* 2341643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341654 */   GIM_Try, /*On fail goto*//*Label 32388*/ GIMT_Encode4(2341697), // Rule ID 58792 //
     /* 2341659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341662 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2341665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2341679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341696 */     // GIR_Coverage, 58792,
     /* 2341696 */     GIR_EraseRootFromParent_Done,
     /* 2341697 */   // Label 32388: @2341697
     /* 2341697 */   GIM_Try, /*On fail goto*//*Label 32389*/ GIMT_Encode4(2341740), // Rule ID 58793 //
     /* 2341702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341705 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2341708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2341722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341739 */     // GIR_Coverage, 58793,
     /* 2341739 */     GIR_EraseRootFromParent_Done,
     /* 2341740 */   // Label 32389: @2341740
     /* 2341740 */   GIM_Reject,
     /* 2341741 */ // Label 32387: @2341741
     /* 2341741 */ GIM_Reject,
     /* 2341742 */ // Label 32296: @2341742
     /* 2341742 */ GIM_Try, /*On fail goto*//*Label 32390*/ GIMT_Encode4(2341796), // Rule ID 58388 //
     /* 2341747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341761 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2341778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341783 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341795 */   // GIR_Coverage, 58388,
     /* 2341795 */   GIR_EraseRootFromParent_Done,
     /* 2341796 */ // Label 32390: @2341796
     /* 2341796 */ GIM_Try, /*On fail goto*//*Label 32391*/ GIMT_Encode4(2341850), // Rule ID 58389 //
     /* 2341801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341815 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2341832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341837 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341848 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341849 */   // GIR_Coverage, 58389,
     /* 2341849 */   GIR_EraseRootFromParent_Done,
     /* 2341850 */ // Label 32391: @2341850
     /* 2341850 */ GIM_Try, /*On fail goto*//*Label 32392*/ GIMT_Encode4(2341904), // Rule ID 58816 //
     /* 2341855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341869 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2341886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341891 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341902 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341903 */   // GIR_Coverage, 58816,
     /* 2341903 */   GIR_EraseRootFromParent_Done,
     /* 2341904 */ // Label 32392: @2341904
     /* 2341904 */ GIM_Try, /*On fail goto*//*Label 32393*/ GIMT_Encode4(2341958), // Rule ID 58817 //
     /* 2341909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341923 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341923 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341926 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341930 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2341940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341945 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341956 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341957 */   // GIR_Coverage, 58817,
     /* 2341957 */   GIR_EraseRootFromParent_Done,
     /* 2341958 */ // Label 32393: @2341958
     /* 2341958 */ GIM_Reject,
     /* 2341959 */ // Label 32297: @2341959
     /* 2341959 */ GIM_Try, /*On fail goto*//*Label 32394*/ GIMT_Encode4(2342013), // Rule ID 58404 //
     /* 2341964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341978 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341978 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2341981 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341985 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2341995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342000 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342012 */   // GIR_Coverage, 58404,
     /* 2342012 */   GIR_EraseRootFromParent_Done,
     /* 2342013 */ // Label 32394: @2342013
     /* 2342013 */ GIM_Try, /*On fail goto*//*Label 32395*/ GIMT_Encode4(2342067), // Rule ID 58405 //
     /* 2342018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2342021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2342024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342032 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342032 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2342035 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342039 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2342049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342054 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342065 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342066 */   // GIR_Coverage, 58405,
     /* 2342066 */   GIR_EraseRootFromParent_Done,
     /* 2342067 */ // Label 32395: @2342067
     /* 2342067 */ GIM_Try, /*On fail goto*//*Label 32396*/ GIMT_Encode4(2342121), // Rule ID 58584 //
     /* 2342072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2342078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342086 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2342089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2342103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342108 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342119 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342120 */   // GIR_Coverage, 58584,
     /* 2342120 */   GIR_EraseRootFromParent_Done,
     /* 2342121 */ // Label 32396: @2342121
     /* 2342121 */ GIM_Try, /*On fail goto*//*Label 32397*/ GIMT_Encode4(2342175), // Rule ID 58585 //
     /* 2342126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2342132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342140 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342140 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2342143 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342147 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2342157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342162 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342174 */   // GIR_Coverage, 58585,
     /* 2342174 */   GIR_EraseRootFromParent_Done,
     /* 2342175 */ // Label 32397: @2342175
     /* 2342175 */ GIM_Reject,
     /* 2342176 */ // Label 32298: @2342176
     /* 2342176 */ GIM_Try, /*On fail goto*//*Label 32398*/ GIMT_Encode4(2342279),
     /* 2342181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2342184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342192 */   GIM_Try, /*On fail goto*//*Label 32399*/ GIMT_Encode4(2342235), // Rule ID 58796 //
     /* 2342197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342200 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2342203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2342217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342234 */     // GIR_Coverage, 58796,
     /* 2342234 */     GIR_EraseRootFromParent_Done,
     /* 2342235 */   // Label 32399: @2342235
     /* 2342235 */   GIM_Try, /*On fail goto*//*Label 32400*/ GIMT_Encode4(2342278), // Rule ID 58797 //
     /* 2342240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342243 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2342246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2342260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342277 */     // GIR_Coverage, 58797,
     /* 2342277 */     GIR_EraseRootFromParent_Done,
     /* 2342278 */   // Label 32400: @2342278
     /* 2342278 */   GIM_Reject,
     /* 2342279 */ // Label 32398: @2342279
     /* 2342279 */ GIM_Reject,
     /* 2342280 */ // Label 32299: @2342280
     /* 2342280 */ GIM_Try, /*On fail goto*//*Label 32401*/ GIMT_Encode4(2342383),
     /* 2342285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2342288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342296 */   GIM_Try, /*On fail goto*//*Label 32402*/ GIMT_Encode4(2342339), // Rule ID 58392 //
     /* 2342301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342304 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2342307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2342321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342338 */     // GIR_Coverage, 58392,
     /* 2342338 */     GIR_EraseRootFromParent_Done,
     /* 2342339 */   // Label 32402: @2342339
     /* 2342339 */   GIM_Try, /*On fail goto*//*Label 32403*/ GIMT_Encode4(2342382), // Rule ID 58393 //
     /* 2342344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342347 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2342350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2342364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342381 */     // GIR_Coverage, 58393,
     /* 2342381 */     GIR_EraseRootFromParent_Done,
     /* 2342382 */   // Label 32403: @2342382
     /* 2342382 */   GIM_Reject,
     /* 2342383 */ // Label 32401: @2342383
     /* 2342383 */ GIM_Reject,
     /* 2342384 */ // Label 32300: @2342384
     /* 2342384 */ GIM_Reject,
     /* 2342385 */ // Label 69: @2342385
     /* 2342385 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32422*/ GIMT_Encode4(2347670),
     /* 2342396 */ /*GILLT_s16*//*Label 32404*/ GIMT_Encode4(2342516),
     /* 2342400 */ /*GILLT_s32*//*Label 32405*/ GIMT_Encode4(2342777),
     /* 2342404 */ /*GILLT_s64*//*Label 32406*/ GIMT_Encode4(2343038), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342416 */ /*GILLT_nxv1s16*//*Label 32407*/ GIMT_Encode4(2343299),
     /* 2342420 */ /*GILLT_nxv1s32*//*Label 32408*/ GIMT_Encode4(2343636),
     /* 2342424 */ /*GILLT_nxv1s64*//*Label 32409*/ GIMT_Encode4(2343973), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342436 */ /*GILLT_nxv2s16*//*Label 32410*/ GIMT_Encode4(2344196),
     /* 2342440 */ /*GILLT_nxv2s32*//*Label 32411*/ GIMT_Encode4(2344533),
     /* 2342444 */ /*GILLT_nxv2s64*//*Label 32412*/ GIMT_Encode4(2344870), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342456 */ /*GILLT_nxv4s16*//*Label 32413*/ GIMT_Encode4(2345093),
     /* 2342460 */ /*GILLT_nxv4s32*//*Label 32414*/ GIMT_Encode4(2345430),
     /* 2342464 */ /*GILLT_nxv4s64*//*Label 32415*/ GIMT_Encode4(2345767), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342476 */ /*GILLT_nxv8s16*//*Label 32416*/ GIMT_Encode4(2345990),
     /* 2342480 */ /*GILLT_nxv8s32*//*Label 32417*/ GIMT_Encode4(2346327),
     /* 2342484 */ /*GILLT_nxv8s64*//*Label 32418*/ GIMT_Encode4(2346664), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342496 */ /*GILLT_nxv16s16*//*Label 32419*/ GIMT_Encode4(2346887),
     /* 2342500 */ /*GILLT_nxv16s32*//*Label 32420*/ GIMT_Encode4(2347224), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342512 */ /*GILLT_nxv32s16*//*Label 32421*/ GIMT_Encode4(2347447),
     /* 2342516 */ // Label 32404: @2342516
     /* 2342516 */ GIM_Try, /*On fail goto*//*Label 32423*/ GIMT_Encode4(2342553), // Rule ID 2269 //
     /* 2342521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2342524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2342531 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2342538 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2342541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342551 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342552 */   // GIR_Coverage, 2269,
     /* 2342552 */   GIR_EraseRootFromParent_Done,
     /* 2342553 */ // Label 32423: @2342553
     /* 2342553 */ GIM_Try, /*On fail goto*//*Label 32424*/ GIMT_Encode4(2342590), // Rule ID 2295 //
     /* 2342558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2342561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342568 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2342575 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2342578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342589 */   // GIR_Coverage, 2295,
     /* 2342589 */   GIR_EraseRootFromParent_Done,
     /* 2342590 */ // Label 32424: @2342590
     /* 2342590 */ GIM_Try, /*On fail goto*//*Label 32425*/ GIMT_Encode4(2342621), // Rule ID 2218 //
     /* 2342595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2342598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2342605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342609 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2342612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342614 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342619 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342620 */   // GIR_Coverage, 2218,
     /* 2342620 */   GIR_EraseRootFromParent_Done,
     /* 2342621 */ // Label 32425: @2342621
     /* 2342621 */ GIM_Try, /*On fail goto*//*Label 32426*/ GIMT_Encode4(2342652), // Rule ID 2219 //
     /* 2342626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2342629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2342636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342640 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2342643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342645 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342650 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342651 */   // GIR_Coverage, 2219,
     /* 2342651 */   GIR_EraseRootFromParent_Done,
     /* 2342652 */ // Label 32426: @2342652
     /* 2342652 */ GIM_Try, /*On fail goto*//*Label 32427*/ GIMT_Encode4(2342683), // Rule ID 2244 //
     /* 2342657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2342660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342671 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2342674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342676 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342681 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342682 */   // GIR_Coverage, 2244,
     /* 2342682 */   GIR_EraseRootFromParent_Done,
     /* 2342683 */ // Label 32427: @2342683
     /* 2342683 */ GIM_Try, /*On fail goto*//*Label 32428*/ GIMT_Encode4(2342714), // Rule ID 2245 //
     /* 2342688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2342691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342702 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2342705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342707 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342712 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342713 */   // GIR_Coverage, 2245,
     /* 2342713 */   GIR_EraseRootFromParent_Done,
     /* 2342714 */ // Label 32428: @2342714
     /* 2342714 */ GIM_Try, /*On fail goto*//*Label 32429*/ GIMT_Encode4(2342745), // Rule ID 2273 //
     /* 2342719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2342722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2342729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342733 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L),
     /* 2342736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342738 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342743 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342744 */   // GIR_Coverage, 2273,
     /* 2342744 */   GIR_EraseRootFromParent_Done,
     /* 2342745 */ // Label 32429: @2342745
     /* 2342745 */ GIM_Try, /*On fail goto*//*Label 32430*/ GIMT_Encode4(2342776), // Rule ID 2299 //
     /* 2342750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2342753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342764 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L_INX),
     /* 2342767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342769 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342774 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342775 */   // GIR_Coverage, 2299,
     /* 2342775 */   GIR_EraseRootFromParent_Done,
     /* 2342776 */ // Label 32430: @2342776
     /* 2342776 */ GIM_Reject,
     /* 2342777 */ // Label 32405: @2342777
     /* 2342777 */ GIM_Try, /*On fail goto*//*Label 32431*/ GIMT_Encode4(2342814), // Rule ID 1535 //
     /* 2342782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2342785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342792 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2342799 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2342802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342812 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342813 */   // GIR_Coverage, 1535,
     /* 2342813 */   GIR_EraseRootFromParent_Done,
     /* 2342814 */ // Label 32431: @2342814
     /* 2342814 */ GIM_Try, /*On fail goto*//*Label 32432*/ GIMT_Encode4(2342851), // Rule ID 1563 //
     /* 2342819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2342822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342829 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2342836 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2342839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342849 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342850 */   // GIR_Coverage, 1563,
     /* 2342850 */   GIR_EraseRootFromParent_Done,
     /* 2342851 */ // Label 32432: @2342851
     /* 2342851 */ GIM_Try, /*On fail goto*//*Label 32433*/ GIMT_Encode4(2342882), // Rule ID 1482 //
     /* 2342856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2342859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342870 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2342873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342875 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342880 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342881 */   // GIR_Coverage, 1482,
     /* 2342881 */   GIR_EraseRootFromParent_Done,
     /* 2342882 */ // Label 32433: @2342882
     /* 2342882 */ GIM_Try, /*On fail goto*//*Label 32434*/ GIMT_Encode4(2342913), // Rule ID 1483 //
     /* 2342887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2342890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342901 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2342904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342906 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342912 */   // GIR_Coverage, 1483,
     /* 2342912 */   GIR_EraseRootFromParent_Done,
     /* 2342913 */ // Label 32434: @2342913
     /* 2342913 */ GIM_Try, /*On fail goto*//*Label 32435*/ GIMT_Encode4(2342944), // Rule ID 1508 //
     /* 2342918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2342921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342932 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2342935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342937 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342942 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342943 */   // GIR_Coverage, 1508,
     /* 2342943 */   GIR_EraseRootFromParent_Done,
     /* 2342944 */ // Label 32435: @2342944
     /* 2342944 */ GIM_Try, /*On fail goto*//*Label 32436*/ GIMT_Encode4(2342975), // Rule ID 1509 //
     /* 2342949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2342952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342963 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2342966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342968 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342974 */   // GIR_Coverage, 1509,
     /* 2342974 */   GIR_EraseRootFromParent_Done,
     /* 2342975 */ // Label 32436: @2342975
     /* 2342975 */ GIM_Try, /*On fail goto*//*Label 32437*/ GIMT_Encode4(2343006), // Rule ID 1539 //
     /* 2342980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2342983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342994 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L),
     /* 2342997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342999 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343004 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343005 */   // GIR_Coverage, 1539,
     /* 2343005 */   GIR_EraseRootFromParent_Done,
     /* 2343006 */ // Label 32437: @2343006
     /* 2343006 */ GIM_Try, /*On fail goto*//*Label 32438*/ GIMT_Encode4(2343037), // Rule ID 1567 //
     /* 2343011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2343014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2343017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2343021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343025 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2343025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L_INX),
     /* 2343028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343030 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343035 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343036 */   // GIR_Coverage, 1567,
     /* 2343036 */   GIR_EraseRootFromParent_Done,
     /* 2343037 */ // Label 32438: @2343037
     /* 2343037 */ GIM_Reject,
     /* 2343038 */ // Label 32406: @2343038
     /* 2343038 */ GIM_Try, /*On fail goto*//*Label 32439*/ GIMT_Encode4(2343075), // Rule ID 1915 //
     /* 2343043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2343046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2343049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2343053 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2343060 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2343060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2343063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343065 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2343070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2343073 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343074 */   // GIR_Coverage, 1915,
     /* 2343074 */   GIR_EraseRootFromParent_Done,
     /* 2343075 */ // Label 32439: @2343075
     /* 2343075 */ GIM_Try, /*On fail goto*//*Label 32440*/ GIMT_Encode4(2343112), // Rule ID 1943 //
     /* 2343080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2343083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2343086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343090 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2343097 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2343097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_INX),
     /* 2343100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2343107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2343110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343111 */   // GIR_Coverage, 1943,
     /* 2343111 */   GIR_EraseRootFromParent_Done,
     /* 2343112 */ // Label 32440: @2343112
     /* 2343112 */ GIM_Try, /*On fail goto*//*Label 32441*/ GIMT_Encode4(2343143), // Rule ID 1876 //
     /* 2343117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2343120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2343123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2343127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343131 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2343131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2343134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343136 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2343141 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343142 */   // GIR_Coverage, 1876,
     /* 2343142 */   GIR_EraseRootFromParent_Done,
     /* 2343143 */ // Label 32441: @2343143
     /* 2343143 */ GIM_Try, /*On fail goto*//*Label 32442*/ GIMT_Encode4(2343174), // Rule ID 1877 //
     /* 2343148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2343151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2343154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2343158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343162 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2343162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2343165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343167 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2343172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343173 */   // GIR_Coverage, 1877,
     /* 2343173 */   GIR_EraseRootFromParent_Done,
     /* 2343174 */ // Label 32442: @2343174
     /* 2343174 */ GIM_Try, /*On fail goto*//*Label 32443*/ GIMT_Encode4(2343205), // Rule ID 1902 //
     /* 2343179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2343182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2343185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2343189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343193 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2343193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2343196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343198 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2343203 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343204 */   // GIR_Coverage, 1902,
     /* 2343204 */   GIR_EraseRootFromParent_Done,
     /* 2343205 */ // Label 32443: @2343205
     /* 2343205 */ GIM_Try, /*On fail goto*//*Label 32444*/ GIMT_Encode4(2343236), // Rule ID 1903 //
     /* 2343210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2343213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2343216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2343220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343224 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2343224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2343227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343229 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2343234 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343235 */   // GIR_Coverage, 1903,
     /* 2343235 */   GIR_EraseRootFromParent_Done,
     /* 2343236 */ // Label 32444: @2343236
     /* 2343236 */ GIM_Try, /*On fail goto*//*Label 32445*/ GIMT_Encode4(2343267), // Rule ID 1933 //
     /* 2343241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2343244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2343247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2343251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343255 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2343255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L),
     /* 2343258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343260 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343265 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343266 */   // GIR_Coverage, 1933,
     /* 2343266 */   GIR_EraseRootFromParent_Done,
     /* 2343267 */ // Label 32445: @2343267
     /* 2343267 */ GIM_Try, /*On fail goto*//*Label 32446*/ GIMT_Encode4(2343298), // Rule ID 1961 //
     /* 2343272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2343275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2343278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343286 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2343286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L_INX),
     /* 2343289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343291 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343296 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343297 */   // GIR_Coverage, 1961,
     /* 2343297 */   GIR_EraseRootFromParent_Done,
     /* 2343298 */ // Label 32446: @2343298
     /* 2343298 */ GIM_Reject,
     /* 2343299 */ // Label 32407: @2343299
     /* 2343299 */ GIM_Try, /*On fail goto*//*Label 32447*/ GIMT_Encode4(2343356), // Rule ID 45812 //
     /* 2343304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2343310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343318 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2343335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343340 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343354 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343355 */   // GIR_Coverage, 45812,
     /* 2343355 */   GIR_EraseRootFromParent_Done,
     /* 2343356 */ // Label 32447: @2343356
     /* 2343356 */ GIM_Try, /*On fail goto*//*Label 32448*/ GIMT_Encode4(2343413), // Rule ID 45813 //
     /* 2343361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2343367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343375 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343375 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343378 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343382 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2343392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343394 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343397 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343411 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343412 */   // GIR_Coverage, 45813,
     /* 2343412 */   GIR_EraseRootFromParent_Done,
     /* 2343413 */ // Label 32448: @2343413
     /* 2343413 */ GIM_Try, /*On fail goto*//*Label 32449*/ GIMT_Encode4(2343467), // Rule ID 45820 //
     /* 2343418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2343424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343432 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2343449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343454 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343465 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343466 */   // GIR_Coverage, 45820,
     /* 2343466 */   GIR_EraseRootFromParent_Done,
     /* 2343467 */ // Label 32449: @2343467
     /* 2343467 */ GIM_Try, /*On fail goto*//*Label 32450*/ GIMT_Encode4(2343521), // Rule ID 45821 //
     /* 2343472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2343478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343486 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2343503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343508 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343520 */   // GIR_Coverage, 45821,
     /* 2343520 */   GIR_EraseRootFromParent_Done,
     /* 2343521 */ // Label 32450: @2343521
     /* 2343521 */ GIM_Try, /*On fail goto*//*Label 32451*/ GIMT_Encode4(2343578), // Rule ID 45828 //
     /* 2343526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343540 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2343557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343559 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343562 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343576 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343577 */   // GIR_Coverage, 45828,
     /* 2343577 */   GIR_EraseRootFromParent_Done,
     /* 2343578 */ // Label 32451: @2343578
     /* 2343578 */ GIM_Try, /*On fail goto*//*Label 32452*/ GIMT_Encode4(2343635), // Rule ID 45829 //
     /* 2343583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343597 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2343614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343619 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343633 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343634 */   // GIR_Coverage, 45829,
     /* 2343634 */   GIR_EraseRootFromParent_Done,
     /* 2343635 */ // Label 32452: @2343635
     /* 2343635 */ GIM_Reject,
     /* 2343636 */ // Label 32408: @2343636
     /* 2343636 */ GIM_Try, /*On fail goto*//*Label 32453*/ GIMT_Encode4(2343693), // Rule ID 58424 //
     /* 2343641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2343644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343655 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343655 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343658 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343662 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2343672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343674 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343677 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343691 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343692 */   // GIR_Coverage, 58424,
     /* 2343692 */   GIR_EraseRootFromParent_Done,
     /* 2343693 */ // Label 32453: @2343693
     /* 2343693 */ GIM_Try, /*On fail goto*//*Label 32454*/ GIMT_Encode4(2343750), // Rule ID 58425 //
     /* 2343698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2343701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343712 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2343729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343734 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343748 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343749 */   // GIR_Coverage, 58425,
     /* 2343749 */   GIR_EraseRootFromParent_Done,
     /* 2343750 */ // Label 32454: @2343750
     /* 2343750 */ GIM_Try, /*On fail goto*//*Label 32455*/ GIMT_Encode4(2343804), // Rule ID 58624 //
     /* 2343755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2343758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2343761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343769 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2343786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343791 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343802 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343803 */   // GIR_Coverage, 58624,
     /* 2343803 */   GIR_EraseRootFromParent_Done,
     /* 2343804 */ // Label 32455: @2343804
     /* 2343804 */ GIM_Try, /*On fail goto*//*Label 32456*/ GIMT_Encode4(2343858), // Rule ID 58625 //
     /* 2343809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2343812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2343815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343823 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2343840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343845 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343856 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343857 */   // GIR_Coverage, 58625,
     /* 2343857 */   GIR_EraseRootFromParent_Done,
     /* 2343858 */ // Label 32456: @2343858
     /* 2343858 */ GIM_Try, /*On fail goto*//*Label 32457*/ GIMT_Encode4(2343915), // Rule ID 58852 //
     /* 2343863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2343866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343877 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2343894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343899 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343913 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343914 */   // GIR_Coverage, 58852,
     /* 2343914 */   GIR_EraseRootFromParent_Done,
     /* 2343915 */ // Label 32457: @2343915
     /* 2343915 */ GIM_Try, /*On fail goto*//*Label 32458*/ GIMT_Encode4(2343972), // Rule ID 58853 //
     /* 2343920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2343923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343934 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2343951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343953 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343956 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343970 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343971 */   // GIR_Coverage, 58853,
     /* 2343971 */   GIR_EraseRootFromParent_Done,
     /* 2343972 */ // Label 32458: @2343972
     /* 2343972 */ GIM_Reject,
     /* 2343973 */ // Label 32409: @2343973
     /* 2343973 */ GIM_Try, /*On fail goto*//*Label 32459*/ GIMT_Encode4(2344030), // Rule ID 58436 //
     /* 2343978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2343981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343992 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2343995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2344009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344014 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344029 */   // GIR_Coverage, 58436,
     /* 2344029 */   GIR_EraseRootFromParent_Done,
     /* 2344030 */ // Label 32459: @2344030
     /* 2344030 */ GIM_Try, /*On fail goto*//*Label 32460*/ GIMT_Encode4(2344087), // Rule ID 58437 //
     /* 2344035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2344038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2344041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344049 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2344052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2344066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344071 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344086 */   // GIR_Coverage, 58437,
     /* 2344086 */   GIR_EraseRootFromParent_Done,
     /* 2344087 */ // Label 32460: @2344087
     /* 2344087 */ GIM_Try, /*On fail goto*//*Label 32461*/ GIMT_Encode4(2344141), // Rule ID 58644 //
     /* 2344092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2344095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2344098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344106 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344106 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2344109 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344113 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2344123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344125 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344128 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344139 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344140 */   // GIR_Coverage, 58644,
     /* 2344140 */   GIR_EraseRootFromParent_Done,
     /* 2344141 */ // Label 32461: @2344141
     /* 2344141 */ GIM_Try, /*On fail goto*//*Label 32462*/ GIMT_Encode4(2344195), // Rule ID 58645 //
     /* 2344146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2344149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2344152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344160 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2344163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2344177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344182 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344193 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344194 */   // GIR_Coverage, 58645,
     /* 2344194 */   GIR_EraseRootFromParent_Done,
     /* 2344195 */ // Label 32462: @2344195
     /* 2344195 */ GIM_Reject,
     /* 2344196 */ // Label 32410: @2344196
     /* 2344196 */ GIM_Try, /*On fail goto*//*Label 32463*/ GIMT_Encode4(2344253), // Rule ID 58420 //
     /* 2344201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2344207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344215 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2344232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344234 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344237 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344252 */   // GIR_Coverage, 58420,
     /* 2344252 */   GIR_EraseRootFromParent_Done,
     /* 2344253 */ // Label 32463: @2344253
     /* 2344253 */ GIM_Try, /*On fail goto*//*Label 32464*/ GIMT_Encode4(2344310), // Rule ID 58421 //
     /* 2344258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2344264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344272 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344272 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344275 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344279 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2344289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344294 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344309 */   // GIR_Coverage, 58421,
     /* 2344309 */   GIR_EraseRootFromParent_Done,
     /* 2344310 */ // Label 32464: @2344310
     /* 2344310 */ GIM_Try, /*On fail goto*//*Label 32465*/ GIMT_Encode4(2344364), // Rule ID 58604 //
     /* 2344315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2344321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344329 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2344346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344348 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344351 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344362 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344363 */   // GIR_Coverage, 58604,
     /* 2344363 */   GIR_EraseRootFromParent_Done,
     /* 2344364 */ // Label 32465: @2344364
     /* 2344364 */ GIM_Try, /*On fail goto*//*Label 32466*/ GIMT_Encode4(2344418), // Rule ID 58605 //
     /* 2344369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2344375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344383 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2344400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344405 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344416 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344417 */   // GIR_Coverage, 58605,
     /* 2344417 */   GIR_EraseRootFromParent_Done,
     /* 2344418 */ // Label 32466: @2344418
     /* 2344418 */ GIM_Try, /*On fail goto*//*Label 32467*/ GIMT_Encode4(2344475), // Rule ID 58836 //
     /* 2344423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344437 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2344454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344459 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344474 */   // GIR_Coverage, 58836,
     /* 2344474 */   GIR_EraseRootFromParent_Done,
     /* 2344475 */ // Label 32467: @2344475
     /* 2344475 */ GIM_Try, /*On fail goto*//*Label 32468*/ GIMT_Encode4(2344532), // Rule ID 58837 //
     /* 2344480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344494 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2344511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344516 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344531 */   // GIR_Coverage, 58837,
     /* 2344531 */   GIR_EraseRootFromParent_Done,
     /* 2344532 */ // Label 32468: @2344532
     /* 2344532 */ GIM_Reject,
     /* 2344533 */ // Label 32411: @2344533
     /* 2344533 */ GIM_Try, /*On fail goto*//*Label 32469*/ GIMT_Encode4(2344590), // Rule ID 58432 //
     /* 2344538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2344541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344552 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344552 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344555 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344559 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2344569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344571 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344574 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344589 */   // GIR_Coverage, 58432,
     /* 2344589 */   GIR_EraseRootFromParent_Done,
     /* 2344590 */ // Label 32469: @2344590
     /* 2344590 */ GIM_Try, /*On fail goto*//*Label 32470*/ GIMT_Encode4(2344647), // Rule ID 58433 //
     /* 2344595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2344598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344609 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344609 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344612 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344616 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2344626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344631 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344645 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344646 */   // GIR_Coverage, 58433,
     /* 2344646 */   GIR_EraseRootFromParent_Done,
     /* 2344647 */ // Label 32470: @2344647
     /* 2344647 */ GIM_Try, /*On fail goto*//*Label 32471*/ GIMT_Encode4(2344701), // Rule ID 58628 //
     /* 2344652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2344655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2344658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344666 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344666 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344669 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344673 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2344683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344688 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344699 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344700 */   // GIR_Coverage, 58628,
     /* 2344700 */   GIR_EraseRootFromParent_Done,
     /* 2344701 */ // Label 32471: @2344701
     /* 2344701 */ GIM_Try, /*On fail goto*//*Label 32472*/ GIMT_Encode4(2344755), // Rule ID 58629 //
     /* 2344706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2344709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2344712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344720 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2344737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344742 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344753 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344754 */   // GIR_Coverage, 58629,
     /* 2344754 */   GIR_EraseRootFromParent_Done,
     /* 2344755 */ // Label 32472: @2344755
     /* 2344755 */ GIM_Try, /*On fail goto*//*Label 32473*/ GIMT_Encode4(2344812), // Rule ID 58856 //
     /* 2344760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2344763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344774 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2344791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344796 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344811 */   // GIR_Coverage, 58856,
     /* 2344811 */   GIR_EraseRootFromParent_Done,
     /* 2344812 */ // Label 32473: @2344812
     /* 2344812 */ GIM_Try, /*On fail goto*//*Label 32474*/ GIMT_Encode4(2344869), // Rule ID 58857 //
     /* 2344817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2344820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344831 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2344848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344853 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344867 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344868 */   // GIR_Coverage, 58857,
     /* 2344868 */   GIR_EraseRootFromParent_Done,
     /* 2344869 */ // Label 32474: @2344869
     /* 2344869 */ GIM_Reject,
     /* 2344870 */ // Label 32412: @2344870
     /* 2344870 */ GIM_Try, /*On fail goto*//*Label 32475*/ GIMT_Encode4(2344927), // Rule ID 58464 //
     /* 2344875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2344878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344889 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344889 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344892 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344896 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2344906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344911 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344925 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344926 */   // GIR_Coverage, 58464,
     /* 2344926 */   GIR_EraseRootFromParent_Done,
     /* 2344927 */ // Label 32475: @2344927
     /* 2344927 */ GIM_Try, /*On fail goto*//*Label 32476*/ GIMT_Encode4(2344984), // Rule ID 58465 //
     /* 2344932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2344935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344946 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344946 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344949 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344953 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2344963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344965 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344968 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344983 */   // GIR_Coverage, 58465,
     /* 2344983 */   GIR_EraseRootFromParent_Done,
     /* 2344984 */ // Label 32476: @2344984
     /* 2344984 */ GIM_Try, /*On fail goto*//*Label 32477*/ GIMT_Encode4(2345038), // Rule ID 58648 //
     /* 2344989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2344992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345003 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2345006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2345020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345025 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345036 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345037 */   // GIR_Coverage, 58648,
     /* 2345037 */   GIR_EraseRootFromParent_Done,
     /* 2345038 */ // Label 32477: @2345038
     /* 2345038 */ GIM_Try, /*On fail goto*//*Label 32478*/ GIMT_Encode4(2345092), // Rule ID 58649 //
     /* 2345043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2345046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2345049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345057 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2345060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2345074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345076 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345079 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345091 */   // GIR_Coverage, 58649,
     /* 2345091 */   GIR_EraseRootFromParent_Done,
     /* 2345092 */ // Label 32478: @2345092
     /* 2345092 */ GIM_Reject,
     /* 2345093 */ // Label 32413: @2345093
     /* 2345093 */ GIM_Try, /*On fail goto*//*Label 32479*/ GIMT_Encode4(2345150), // Rule ID 58428 //
     /* 2345098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2345104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345112 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2345129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345131 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345134 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345148 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345149 */   // GIR_Coverage, 58428,
     /* 2345149 */   GIR_EraseRootFromParent_Done,
     /* 2345150 */ // Label 32479: @2345150
     /* 2345150 */ GIM_Try, /*On fail goto*//*Label 32480*/ GIMT_Encode4(2345207), // Rule ID 58429 //
     /* 2345155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2345161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345169 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345169 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345172 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345176 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2345186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345191 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345205 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345206 */   // GIR_Coverage, 58429,
     /* 2345206 */   GIR_EraseRootFromParent_Done,
     /* 2345207 */ // Label 32480: @2345207
     /* 2345207 */ GIM_Try, /*On fail goto*//*Label 32481*/ GIMT_Encode4(2345261), // Rule ID 58608 //
     /* 2345212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2345218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345226 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345226 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345229 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345233 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2345243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345248 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345260 */   // GIR_Coverage, 58608,
     /* 2345260 */   GIR_EraseRootFromParent_Done,
     /* 2345261 */ // Label 32481: @2345261
     /* 2345261 */ GIM_Try, /*On fail goto*//*Label 32482*/ GIMT_Encode4(2345315), // Rule ID 58609 //
     /* 2345266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2345272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345280 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345280 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345283 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345287 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2345297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345302 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345313 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345314 */   // GIR_Coverage, 58609,
     /* 2345314 */   GIR_EraseRootFromParent_Done,
     /* 2345315 */ // Label 32482: @2345315
     /* 2345315 */ GIM_Try, /*On fail goto*//*Label 32483*/ GIMT_Encode4(2345372), // Rule ID 58840 //
     /* 2345320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345334 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2345351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345353 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345356 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345370 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345371 */   // GIR_Coverage, 58840,
     /* 2345371 */   GIR_EraseRootFromParent_Done,
     /* 2345372 */ // Label 32483: @2345372
     /* 2345372 */ GIM_Try, /*On fail goto*//*Label 32484*/ GIMT_Encode4(2345429), // Rule ID 58841 //
     /* 2345377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345391 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2345408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345413 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345427 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345428 */   // GIR_Coverage, 58841,
     /* 2345428 */   GIR_EraseRootFromParent_Done,
     /* 2345429 */ // Label 32484: @2345429
     /* 2345429 */ GIM_Reject,
     /* 2345430 */ // Label 32414: @2345430
     /* 2345430 */ GIM_Try, /*On fail goto*//*Label 32485*/ GIMT_Encode4(2345487), // Rule ID 58452 //
     /* 2345435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2345438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345449 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345449 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345452 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345456 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2345466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345471 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345485 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345486 */   // GIR_Coverage, 58452,
     /* 2345486 */   GIR_EraseRootFromParent_Done,
     /* 2345487 */ // Label 32485: @2345487
     /* 2345487 */ GIM_Try, /*On fail goto*//*Label 32486*/ GIMT_Encode4(2345544), // Rule ID 58453 //
     /* 2345492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2345495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345506 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2345523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345528 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345542 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345543 */   // GIR_Coverage, 58453,
     /* 2345543 */   GIR_EraseRootFromParent_Done,
     /* 2345544 */ // Label 32486: @2345544
     /* 2345544 */ GIM_Try, /*On fail goto*//*Label 32487*/ GIMT_Encode4(2345598), // Rule ID 58632 //
     /* 2345549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2345552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2345555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345563 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345563 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345570 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2345580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345582 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345585 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345597 */   // GIR_Coverage, 58632,
     /* 2345597 */   GIR_EraseRootFromParent_Done,
     /* 2345598 */ // Label 32487: @2345598
     /* 2345598 */ GIM_Try, /*On fail goto*//*Label 32488*/ GIMT_Encode4(2345652), // Rule ID 58633 //
     /* 2345603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2345606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2345609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345617 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2345634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345639 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345650 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345651 */   // GIR_Coverage, 58633,
     /* 2345651 */   GIR_EraseRootFromParent_Done,
     /* 2345652 */ // Label 32488: @2345652
     /* 2345652 */ GIM_Try, /*On fail goto*//*Label 32489*/ GIMT_Encode4(2345709), // Rule ID 58860 //
     /* 2345657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2345660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345671 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345671 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345674 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345678 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2345688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345690 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345693 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345708 */   // GIR_Coverage, 58860,
     /* 2345708 */   GIR_EraseRootFromParent_Done,
     /* 2345709 */ // Label 32489: @2345709
     /* 2345709 */ GIM_Try, /*On fail goto*//*Label 32490*/ GIMT_Encode4(2345766), // Rule ID 58861 //
     /* 2345714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2345717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345728 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2345745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345750 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345765 */   // GIR_Coverage, 58861,
     /* 2345765 */   GIR_EraseRootFromParent_Done,
     /* 2345766 */ // Label 32490: @2345766
     /* 2345766 */ GIM_Reject,
     /* 2345767 */ // Label 32415: @2345767
     /* 2345767 */ GIM_Try, /*On fail goto*//*Label 32491*/ GIMT_Encode4(2345824), // Rule ID 58468 //
     /* 2345772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2345775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345786 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345786 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345789 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345793 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2345803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345805 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345808 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345823 */   // GIR_Coverage, 58468,
     /* 2345823 */   GIR_EraseRootFromParent_Done,
     /* 2345824 */ // Label 32491: @2345824
     /* 2345824 */ GIM_Try, /*On fail goto*//*Label 32492*/ GIMT_Encode4(2345881), // Rule ID 58469 //
     /* 2345829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2345832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345843 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2345860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345865 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345879 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345880 */   // GIR_Coverage, 58469,
     /* 2345880 */   GIR_EraseRootFromParent_Done,
     /* 2345881 */ // Label 32492: @2345881
     /* 2345881 */ GIM_Try, /*On fail goto*//*Label 32493*/ GIMT_Encode4(2345935), // Rule ID 58652 //
     /* 2345886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2345889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345900 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2345917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345919 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345922 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345933 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345934 */   // GIR_Coverage, 58652,
     /* 2345934 */   GIR_EraseRootFromParent_Done,
     /* 2345935 */ // Label 32493: @2345935
     /* 2345935 */ GIM_Try, /*On fail goto*//*Label 32494*/ GIMT_Encode4(2345989), // Rule ID 58653 //
     /* 2345940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2345943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345954 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2345971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345976 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345987 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345988 */   // GIR_Coverage, 58653,
     /* 2345988 */   GIR_EraseRootFromParent_Done,
     /* 2345989 */ // Label 32494: @2345989
     /* 2345989 */ GIM_Reject,
     /* 2345990 */ // Label 32416: @2345990
     /* 2345990 */ GIM_Try, /*On fail goto*//*Label 32495*/ GIMT_Encode4(2346047), // Rule ID 58440 //
     /* 2345995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2346001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346009 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346009 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2346012 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346016 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2346026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346031 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346045 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346046 */   // GIR_Coverage, 58440,
     /* 2346046 */   GIR_EraseRootFromParent_Done,
     /* 2346047 */ // Label 32495: @2346047
     /* 2346047 */ GIM_Try, /*On fail goto*//*Label 32496*/ GIMT_Encode4(2346104), // Rule ID 58441 //
     /* 2346052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2346058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346066 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2346069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2346083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346088 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346102 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346103 */   // GIR_Coverage, 58441,
     /* 2346103 */   GIR_EraseRootFromParent_Done,
     /* 2346104 */ // Label 32496: @2346104
     /* 2346104 */ GIM_Try, /*On fail goto*//*Label 32497*/ GIMT_Encode4(2346158), // Rule ID 58612 //
     /* 2346109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2346115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346123 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346123 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2346126 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346130 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2346140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346145 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346157 */   // GIR_Coverage, 58612,
     /* 2346157 */   GIR_EraseRootFromParent_Done,
     /* 2346158 */ // Label 32497: @2346158
     /* 2346158 */ GIM_Try, /*On fail goto*//*Label 32498*/ GIMT_Encode4(2346212), // Rule ID 58613 //
     /* 2346163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2346169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346177 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2346180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2346194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346199 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346210 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346211 */   // GIR_Coverage, 58613,
     /* 2346211 */   GIR_EraseRootFromParent_Done,
     /* 2346212 */ // Label 32498: @2346212
     /* 2346212 */ GIM_Try, /*On fail goto*//*Label 32499*/ GIMT_Encode4(2346269), // Rule ID 58844 //
     /* 2346217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346231 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346231 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2346234 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346238 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2346248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346250 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346253 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346267 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346268 */   // GIR_Coverage, 58844,
     /* 2346268 */   GIR_EraseRootFromParent_Done,
     /* 2346269 */ // Label 32499: @2346269
     /* 2346269 */ GIM_Try, /*On fail goto*//*Label 32500*/ GIMT_Encode4(2346326), // Rule ID 58845 //
     /* 2346274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346288 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2346291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2346305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346307 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346310 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346324 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346325 */   // GIR_Coverage, 58845,
     /* 2346325 */   GIR_EraseRootFromParent_Done,
     /* 2346326 */ // Label 32500: @2346326
     /* 2346326 */ GIM_Reject,
     /* 2346327 */ // Label 32417: @2346327
     /* 2346327 */ GIM_Try, /*On fail goto*//*Label 32501*/ GIMT_Encode4(2346384), // Rule ID 58456 //
     /* 2346332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2346335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346346 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2346363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346368 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346382 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346383 */   // GIR_Coverage, 58456,
     /* 2346383 */   GIR_EraseRootFromParent_Done,
     /* 2346384 */ // Label 32501: @2346384
     /* 2346384 */ GIM_Try, /*On fail goto*//*Label 32502*/ GIMT_Encode4(2346441), // Rule ID 58457 //
     /* 2346389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2346392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346403 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2346420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346425 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346440 */   // GIR_Coverage, 58457,
     /* 2346440 */   GIR_EraseRootFromParent_Done,
     /* 2346441 */ // Label 32502: @2346441
     /* 2346441 */ GIM_Try, /*On fail goto*//*Label 32503*/ GIMT_Encode4(2346495), // Rule ID 58636 //
     /* 2346446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2346449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2346452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346460 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346460 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346463 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346467 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2346477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346479 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346482 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346493 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346494 */   // GIR_Coverage, 58636,
     /* 2346494 */   GIR_EraseRootFromParent_Done,
     /* 2346495 */ // Label 32503: @2346495
     /* 2346495 */ GIM_Try, /*On fail goto*//*Label 32504*/ GIMT_Encode4(2346549), // Rule ID 58637 //
     /* 2346500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2346503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2346506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346514 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2346531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346536 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346547 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346548 */   // GIR_Coverage, 58637,
     /* 2346548 */   GIR_EraseRootFromParent_Done,
     /* 2346549 */ // Label 32504: @2346549
     /* 2346549 */ GIM_Try, /*On fail goto*//*Label 32505*/ GIMT_Encode4(2346606), // Rule ID 58864 //
     /* 2346554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2346557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2346560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346568 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2346585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346590 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346604 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346605 */   // GIR_Coverage, 58864,
     /* 2346605 */   GIR_EraseRootFromParent_Done,
     /* 2346606 */ // Label 32505: @2346606
     /* 2346606 */ GIM_Try, /*On fail goto*//*Label 32506*/ GIMT_Encode4(2346663), // Rule ID 58865 //
     /* 2346611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2346614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2346617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346625 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346625 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346628 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346632 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2346642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346647 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346662 */   // GIR_Coverage, 58865,
     /* 2346662 */   GIR_EraseRootFromParent_Done,
     /* 2346663 */ // Label 32506: @2346663
     /* 2346663 */ GIM_Reject,
     /* 2346664 */ // Label 32418: @2346664
     /* 2346664 */ GIM_Try, /*On fail goto*//*Label 32507*/ GIMT_Encode4(2346721), // Rule ID 58472 //
     /* 2346669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2346672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2346675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346683 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346683 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2346686 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346690 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2346700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346702 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346705 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2346716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346719 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346720 */   // GIR_Coverage, 58472,
     /* 2346720 */   GIR_EraseRootFromParent_Done,
     /* 2346721 */ // Label 32507: @2346721
     /* 2346721 */ GIM_Try, /*On fail goto*//*Label 32508*/ GIMT_Encode4(2346778), // Rule ID 58473 //
     /* 2346726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2346729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2346732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346740 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2346743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2346757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346762 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2346773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346776 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346777 */   // GIR_Coverage, 58473,
     /* 2346777 */   GIR_EraseRootFromParent_Done,
     /* 2346778 */ // Label 32508: @2346778
     /* 2346778 */ GIM_Try, /*On fail goto*//*Label 32509*/ GIMT_Encode4(2346832), // Rule ID 58656 //
     /* 2346783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2346786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346797 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346797 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2346800 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346804 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2346814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346819 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346830 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346831 */   // GIR_Coverage, 58656,
     /* 2346831 */   GIR_EraseRootFromParent_Done,
     /* 2346832 */ // Label 32509: @2346832
     /* 2346832 */ GIM_Try, /*On fail goto*//*Label 32510*/ GIMT_Encode4(2346886), // Rule ID 58657 //
     /* 2346837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2346840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346851 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2346854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346863 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2346868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346870 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346873 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346884 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346885 */   // GIR_Coverage, 58657,
     /* 2346885 */   GIR_EraseRootFromParent_Done,
     /* 2346886 */ // Label 32510: @2346886
     /* 2346886 */ GIM_Reject,
     /* 2346887 */ // Label 32419: @2346887
     /* 2346887 */ GIM_Try, /*On fail goto*//*Label 32511*/ GIMT_Encode4(2346944), // Rule ID 58444 //
     /* 2346892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2346898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346906 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346906 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346909 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346913 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2346923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346925 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346928 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346942 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346943 */   // GIR_Coverage, 58444,
     /* 2346943 */   GIR_EraseRootFromParent_Done,
     /* 2346944 */ // Label 32511: @2346944
     /* 2346944 */ GIM_Try, /*On fail goto*//*Label 32512*/ GIMT_Encode4(2347001), // Rule ID 58445 //
     /* 2346949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2346955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346963 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346963 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346966 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346970 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2346980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346985 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346999 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347000 */   // GIR_Coverage, 58445,
     /* 2347000 */   GIR_EraseRootFromParent_Done,
     /* 2347001 */ // Label 32512: @2347001
     /* 2347001 */ GIM_Try, /*On fail goto*//*Label 32513*/ GIMT_Encode4(2347055), // Rule ID 58616 //
     /* 2347006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2347012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347020 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2347023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2347037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347042 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347053 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347054 */   // GIR_Coverage, 58616,
     /* 2347054 */   GIR_EraseRootFromParent_Done,
     /* 2347055 */ // Label 32513: @2347055
     /* 2347055 */ GIM_Try, /*On fail goto*//*Label 32514*/ GIMT_Encode4(2347109), // Rule ID 58617 //
     /* 2347060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2347066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347074 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2347077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2347091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347096 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347108 */   // GIR_Coverage, 58617,
     /* 2347108 */   GIR_EraseRootFromParent_Done,
     /* 2347109 */ // Label 32514: @2347109
     /* 2347109 */ GIM_Try, /*On fail goto*//*Label 32515*/ GIMT_Encode4(2347166), // Rule ID 58848 //
     /* 2347114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2347120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347128 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2347131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2347145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347147 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347150 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347165 */   // GIR_Coverage, 58848,
     /* 2347165 */   GIR_EraseRootFromParent_Done,
     /* 2347166 */ // Label 32515: @2347166
     /* 2347166 */ GIM_Try, /*On fail goto*//*Label 32516*/ GIMT_Encode4(2347223), // Rule ID 58849 //
     /* 2347171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2347177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347185 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347185 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2347188 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347192 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2347202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347207 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347221 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347222 */   // GIR_Coverage, 58849,
     /* 2347222 */   GIR_EraseRootFromParent_Done,
     /* 2347223 */ // Label 32516: @2347223
     /* 2347223 */ GIM_Reject,
     /* 2347224 */ // Label 32420: @2347224
     /* 2347224 */ GIM_Try, /*On fail goto*//*Label 32517*/ GIMT_Encode4(2347281), // Rule ID 58460 //
     /* 2347229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2347232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2347235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347243 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347243 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2347246 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347250 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2347260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347265 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347279 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347280 */   // GIR_Coverage, 58460,
     /* 2347280 */   GIR_EraseRootFromParent_Done,
     /* 2347281 */ // Label 32517: @2347281
     /* 2347281 */ GIM_Try, /*On fail goto*//*Label 32518*/ GIMT_Encode4(2347338), // Rule ID 58461 //
     /* 2347286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2347289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2347292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347300 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347300 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2347303 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347307 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2347317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347319 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347322 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347336 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347337 */   // GIR_Coverage, 58461,
     /* 2347337 */   GIR_EraseRootFromParent_Done,
     /* 2347338 */ // Label 32518: @2347338
     /* 2347338 */ GIM_Try, /*On fail goto*//*Label 32519*/ GIMT_Encode4(2347392), // Rule ID 58640 //
     /* 2347343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2347346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2347349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347357 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2347360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2347374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347376 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347379 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347390 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347391 */   // GIR_Coverage, 58640,
     /* 2347391 */   GIR_EraseRootFromParent_Done,
     /* 2347392 */ // Label 32519: @2347392
     /* 2347392 */ GIM_Try, /*On fail goto*//*Label 32520*/ GIMT_Encode4(2347446), // Rule ID 58641 //
     /* 2347397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2347400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2347403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347411 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2347414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2347428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347433 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347445 */   // GIR_Coverage, 58641,
     /* 2347445 */   GIR_EraseRootFromParent_Done,
     /* 2347446 */ // Label 32520: @2347446
     /* 2347446 */ GIM_Reject,
     /* 2347447 */ // Label 32421: @2347447
     /* 2347447 */ GIM_Try, /*On fail goto*//*Label 32521*/ GIMT_Encode4(2347504), // Rule ID 58448 //
     /* 2347452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2347458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347466 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347466 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2347469 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347473 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2347483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347485 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347488 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347503 */   // GIR_Coverage, 58448,
     /* 2347503 */   GIR_EraseRootFromParent_Done,
     /* 2347504 */ // Label 32521: @2347504
     /* 2347504 */ GIM_Try, /*On fail goto*//*Label 32522*/ GIMT_Encode4(2347561), // Rule ID 58449 //
     /* 2347509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2347515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347523 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347523 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2347526 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347530 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2347540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347542 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347545 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347559 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347560 */   // GIR_Coverage, 58449,
     /* 2347560 */   GIR_EraseRootFromParent_Done,
     /* 2347561 */ // Label 32522: @2347561
     /* 2347561 */ GIM_Try, /*On fail goto*//*Label 32523*/ GIMT_Encode4(2347615), // Rule ID 58620 //
     /* 2347566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2347572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347580 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2347583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2347597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347602 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347613 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347614 */   // GIR_Coverage, 58620,
     /* 2347614 */   GIR_EraseRootFromParent_Done,
     /* 2347615 */ // Label 32523: @2347615
     /* 2347615 */ GIM_Try, /*On fail goto*//*Label 32524*/ GIMT_Encode4(2347669), // Rule ID 58621 //
     /* 2347620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2347626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347634 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2347637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2347651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347653 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347656 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347667 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347668 */   // GIR_Coverage, 58621,
     /* 2347668 */   GIR_EraseRootFromParent_Done,
     /* 2347669 */ // Label 32524: @2347669
     /* 2347669 */ GIM_Reject,
     /* 2347670 */ // Label 32422: @2347670
     /* 2347670 */ GIM_Reject,
     /* 2347671 */ // Label 70: @2347671
     /* 2347671 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32543*/ GIMT_Encode4(2352956),
     /* 2347682 */ /*GILLT_s16*//*Label 32525*/ GIMT_Encode4(2347802),
     /* 2347686 */ /*GILLT_s32*//*Label 32526*/ GIMT_Encode4(2348063),
     /* 2347690 */ /*GILLT_s64*//*Label 32527*/ GIMT_Encode4(2348324), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347702 */ /*GILLT_nxv1s16*//*Label 32528*/ GIMT_Encode4(2348585),
     /* 2347706 */ /*GILLT_nxv1s32*//*Label 32529*/ GIMT_Encode4(2348922),
     /* 2347710 */ /*GILLT_nxv1s64*//*Label 32530*/ GIMT_Encode4(2349259), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347722 */ /*GILLT_nxv2s16*//*Label 32531*/ GIMT_Encode4(2349482),
     /* 2347726 */ /*GILLT_nxv2s32*//*Label 32532*/ GIMT_Encode4(2349819),
     /* 2347730 */ /*GILLT_nxv2s64*//*Label 32533*/ GIMT_Encode4(2350156), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347742 */ /*GILLT_nxv4s16*//*Label 32534*/ GIMT_Encode4(2350379),
     /* 2347746 */ /*GILLT_nxv4s32*//*Label 32535*/ GIMT_Encode4(2350716),
     /* 2347750 */ /*GILLT_nxv4s64*//*Label 32536*/ GIMT_Encode4(2351053), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347762 */ /*GILLT_nxv8s16*//*Label 32537*/ GIMT_Encode4(2351276),
     /* 2347766 */ /*GILLT_nxv8s32*//*Label 32538*/ GIMT_Encode4(2351613),
     /* 2347770 */ /*GILLT_nxv8s64*//*Label 32539*/ GIMT_Encode4(2351950), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347782 */ /*GILLT_nxv16s16*//*Label 32540*/ GIMT_Encode4(2352173),
     /* 2347786 */ /*GILLT_nxv16s32*//*Label 32541*/ GIMT_Encode4(2352510), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347798 */ /*GILLT_nxv32s16*//*Label 32542*/ GIMT_Encode4(2352733),
     /* 2347802 */ // Label 32525: @2347802
     /* 2347802 */ GIM_Try, /*On fail goto*//*Label 32544*/ GIMT_Encode4(2347839), // Rule ID 2271 //
     /* 2347807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2347810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2347813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2347817 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2347824 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2347824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2347827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2347834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347837 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347838 */   // GIR_Coverage, 2271,
     /* 2347838 */   GIR_EraseRootFromParent_Done,
     /* 2347839 */ // Label 32544: @2347839
     /* 2347839 */ GIM_Try, /*On fail goto*//*Label 32545*/ GIMT_Encode4(2347876), // Rule ID 2297 //
     /* 2347844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2347847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2347850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2347854 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2347861 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2347861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2347864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2347871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347874 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347875 */   // GIR_Coverage, 2297,
     /* 2347875 */   GIR_EraseRootFromParent_Done,
     /* 2347876 */ // Label 32545: @2347876
     /* 2347876 */ GIM_Try, /*On fail goto*//*Label 32546*/ GIMT_Encode4(2347907), // Rule ID 2222 //
     /* 2347881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2347884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2347887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2347891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2347895 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2347895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2347898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347900 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347905 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347906 */   // GIR_Coverage, 2222,
     /* 2347906 */   GIR_EraseRootFromParent_Done,
     /* 2347907 */ // Label 32546: @2347907
     /* 2347907 */ GIM_Try, /*On fail goto*//*Label 32547*/ GIMT_Encode4(2347938), // Rule ID 2223 //
     /* 2347912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2347915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2347918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2347922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2347926 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2347926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2347929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347931 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347936 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347937 */   // GIR_Coverage, 2223,
     /* 2347937 */   GIR_EraseRootFromParent_Done,
     /* 2347938 */ // Label 32547: @2347938
     /* 2347938 */ GIM_Try, /*On fail goto*//*Label 32548*/ GIMT_Encode4(2347969), // Rule ID 2248 //
     /* 2347943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2347946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2347949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2347953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2347957 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2347957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2347960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347962 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347967 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347968 */   // GIR_Coverage, 2248,
     /* 2347968 */   GIR_EraseRootFromParent_Done,
     /* 2347969 */ // Label 32548: @2347969
     /* 2347969 */ GIM_Try, /*On fail goto*//*Label 32549*/ GIMT_Encode4(2348000), // Rule ID 2249 //
     /* 2347974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2347977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2347980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2347984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2347988 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2347988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2347991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347993 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347999 */   // GIR_Coverage, 2249,
     /* 2347999 */   GIR_EraseRootFromParent_Done,
     /* 2348000 */ // Label 32549: @2348000
     /* 2348000 */ GIM_Try, /*On fail goto*//*Label 32550*/ GIMT_Encode4(2348031), // Rule ID 2275 //
     /* 2348005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2348008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348019 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU),
     /* 2348022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348024 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348030 */   // GIR_Coverage, 2275,
     /* 2348030 */   GIR_EraseRootFromParent_Done,
     /* 2348031 */ // Label 32550: @2348031
     /* 2348031 */ GIM_Try, /*On fail goto*//*Label 32551*/ GIMT_Encode4(2348062), // Rule ID 2301 //
     /* 2348036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2348039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2348046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348050 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU_INX),
     /* 2348053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348055 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348061 */   // GIR_Coverage, 2301,
     /* 2348061 */   GIR_EraseRootFromParent_Done,
     /* 2348062 */ // Label 32551: @2348062
     /* 2348062 */ GIM_Reject,
     /* 2348063 */ // Label 32526: @2348063
     /* 2348063 */ GIM_Try, /*On fail goto*//*Label 32552*/ GIMT_Encode4(2348100), // Rule ID 1537 //
     /* 2348068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2348071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348078 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2348085 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2348088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2348095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348099 */   // GIR_Coverage, 1537,
     /* 2348099 */   GIR_EraseRootFromParent_Done,
     /* 2348100 */ // Label 32552: @2348100
     /* 2348100 */ GIM_Try, /*On fail goto*//*Label 32553*/ GIMT_Encode4(2348137), // Rule ID 1565 //
     /* 2348105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2348108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2348115 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2348122 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2348125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2348132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348135 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348136 */   // GIR_Coverage, 1565,
     /* 2348136 */   GIR_EraseRootFromParent_Done,
     /* 2348137 */ // Label 32553: @2348137
     /* 2348137 */ GIM_Try, /*On fail goto*//*Label 32554*/ GIMT_Encode4(2348168), // Rule ID 1486 //
     /* 2348142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2348145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348156 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2348156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2348159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348161 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348166 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348167 */   // GIR_Coverage, 1486,
     /* 2348167 */   GIR_EraseRootFromParent_Done,
     /* 2348168 */ // Label 32554: @2348168
     /* 2348168 */ GIM_Try, /*On fail goto*//*Label 32555*/ GIMT_Encode4(2348199), // Rule ID 1487 //
     /* 2348173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2348176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348187 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2348187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2348190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348192 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348197 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348198 */   // GIR_Coverage, 1487,
     /* 2348198 */   GIR_EraseRootFromParent_Done,
     /* 2348199 */ // Label 32555: @2348199
     /* 2348199 */ GIM_Try, /*On fail goto*//*Label 32556*/ GIMT_Encode4(2348230), // Rule ID 1512 //
     /* 2348204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2348207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2348214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348218 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2348218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2348221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348223 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348228 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348229 */   // GIR_Coverage, 1512,
     /* 2348229 */   GIR_EraseRootFromParent_Done,
     /* 2348230 */ // Label 32556: @2348230
     /* 2348230 */ GIM_Try, /*On fail goto*//*Label 32557*/ GIMT_Encode4(2348261), // Rule ID 1513 //
     /* 2348235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2348238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2348245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348249 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2348249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2348252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348254 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348260 */   // GIR_Coverage, 1513,
     /* 2348260 */   GIR_EraseRootFromParent_Done,
     /* 2348261 */ // Label 32557: @2348261
     /* 2348261 */ GIM_Try, /*On fail goto*//*Label 32558*/ GIMT_Encode4(2348292), // Rule ID 1541 //
     /* 2348266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2348269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348280 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU),
     /* 2348283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348285 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348291 */   // GIR_Coverage, 1541,
     /* 2348291 */   GIR_EraseRootFromParent_Done,
     /* 2348292 */ // Label 32558: @2348292
     /* 2348292 */ GIM_Try, /*On fail goto*//*Label 32559*/ GIMT_Encode4(2348323), // Rule ID 1569 //
     /* 2348297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2348300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2348307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348311 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU_INX),
     /* 2348314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348316 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348321 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348322 */   // GIR_Coverage, 1569,
     /* 2348322 */   GIR_EraseRootFromParent_Done,
     /* 2348323 */ // Label 32559: @2348323
     /* 2348323 */ GIM_Reject,
     /* 2348324 */ // Label 32527: @2348324
     /* 2348324 */ GIM_Try, /*On fail goto*//*Label 32560*/ GIMT_Encode4(2348361), // Rule ID 1917 //
     /* 2348329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2348332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348339 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2348346 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2348346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2348349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2348356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2348359 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348360 */   // GIR_Coverage, 1917,
     /* 2348360 */   GIR_EraseRootFromParent_Done,
     /* 2348361 */ // Label 32560: @2348361
     /* 2348361 */ GIM_Try, /*On fail goto*//*Label 32561*/ GIMT_Encode4(2348398), // Rule ID 1945 //
     /* 2348366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2348369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348376 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2348383 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2348383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_INX),
     /* 2348386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348388 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2348393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2348396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348397 */   // GIR_Coverage, 1945,
     /* 2348397 */   GIR_EraseRootFromParent_Done,
     /* 2348398 */ // Label 32561: @2348398
     /* 2348398 */ GIM_Try, /*On fail goto*//*Label 32562*/ GIMT_Encode4(2348429), // Rule ID 1880 //
     /* 2348403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2348406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348417 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2348417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2348420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348422 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2348427 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348428 */   // GIR_Coverage, 1880,
     /* 2348428 */   GIR_EraseRootFromParent_Done,
     /* 2348429 */ // Label 32562: @2348429
     /* 2348429 */ GIM_Try, /*On fail goto*//*Label 32563*/ GIMT_Encode4(2348460), // Rule ID 1881 //
     /* 2348434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2348437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348448 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2348448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2348451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348453 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2348458 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348459 */   // GIR_Coverage, 1881,
     /* 2348459 */   GIR_EraseRootFromParent_Done,
     /* 2348460 */ // Label 32563: @2348460
     /* 2348460 */ GIM_Try, /*On fail goto*//*Label 32564*/ GIMT_Encode4(2348491), // Rule ID 1906 //
     /* 2348465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2348468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2348475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348479 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2348479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2348482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348484 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2348489 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348490 */   // GIR_Coverage, 1906,
     /* 2348490 */   GIR_EraseRootFromParent_Done,
     /* 2348491 */ // Label 32564: @2348491
     /* 2348491 */ GIM_Try, /*On fail goto*//*Label 32565*/ GIMT_Encode4(2348522), // Rule ID 1907 //
     /* 2348496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2348499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2348506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348510 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2348510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2348513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348515 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2348520 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348521 */   // GIR_Coverage, 1907,
     /* 2348521 */   GIR_EraseRootFromParent_Done,
     /* 2348522 */ // Label 32565: @2348522
     /* 2348522 */ GIM_Try, /*On fail goto*//*Label 32566*/ GIMT_Encode4(2348553), // Rule ID 1935 //
     /* 2348527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2348530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348541 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU),
     /* 2348544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348546 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348551 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348552 */   // GIR_Coverage, 1935,
     /* 2348552 */   GIR_EraseRootFromParent_Done,
     /* 2348553 */ // Label 32566: @2348553
     /* 2348553 */ GIM_Try, /*On fail goto*//*Label 32567*/ GIMT_Encode4(2348584), // Rule ID 1963 //
     /* 2348558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2348561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348572 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU_INX),
     /* 2348575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348577 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348582 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348583 */   // GIR_Coverage, 1963,
     /* 2348583 */   GIR_EraseRootFromParent_Done,
     /* 2348584 */ // Label 32567: @2348584
     /* 2348584 */ GIM_Reject,
     /* 2348585 */ // Label 32528: @2348585
     /* 2348585 */ GIM_Try, /*On fail goto*//*Label 32568*/ GIMT_Encode4(2348642), // Rule ID 58476 //
     /* 2348590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2348593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2348596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348604 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348604 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348607 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348611 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2348621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348626 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348640 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348641 */   // GIR_Coverage, 58476,
     /* 2348641 */   GIR_EraseRootFromParent_Done,
     /* 2348642 */ // Label 32568: @2348642
     /* 2348642 */ GIM_Try, /*On fail goto*//*Label 32569*/ GIMT_Encode4(2348699), // Rule ID 58477 //
     /* 2348647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2348650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2348653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348661 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2348678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348680 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348683 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348697 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348698 */   // GIR_Coverage, 58477,
     /* 2348698 */   GIR_EraseRootFromParent_Done,
     /* 2348699 */ // Label 32569: @2348699
     /* 2348699 */ GIM_Try, /*On fail goto*//*Label 32570*/ GIMT_Encode4(2348753), // Rule ID 58660 //
     /* 2348704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2348707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2348710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348718 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348718 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348721 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348725 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2348735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348737 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348740 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348751 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348752 */   // GIR_Coverage, 58660,
     /* 2348752 */   GIR_EraseRootFromParent_Done,
     /* 2348753 */ // Label 32570: @2348753
     /* 2348753 */ GIM_Try, /*On fail goto*//*Label 32571*/ GIMT_Encode4(2348807), // Rule ID 58661 //
     /* 2348758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2348761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2348764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348772 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2348789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348794 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348805 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348806 */   // GIR_Coverage, 58661,
     /* 2348806 */   GIR_EraseRootFromParent_Done,
     /* 2348807 */ // Label 32571: @2348807
     /* 2348807 */ GIM_Try, /*On fail goto*//*Label 32572*/ GIMT_Encode4(2348864), // Rule ID 58868 //
     /* 2348812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2348815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2348818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348826 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2348843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348848 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348862 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348863 */   // GIR_Coverage, 58868,
     /* 2348863 */   GIR_EraseRootFromParent_Done,
     /* 2348864 */ // Label 32572: @2348864
     /* 2348864 */ GIM_Try, /*On fail goto*//*Label 32573*/ GIMT_Encode4(2348921), // Rule ID 58869 //
     /* 2348869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2348872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2348875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348883 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348883 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348886 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348890 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2348900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348905 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348919 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348920 */   // GIR_Coverage, 58869,
     /* 2348920 */   GIR_EraseRootFromParent_Done,
     /* 2348921 */ // Label 32573: @2348921
     /* 2348921 */ GIM_Reject,
     /* 2348922 */ // Label 32529: @2348922
     /* 2348922 */ GIM_Try, /*On fail goto*//*Label 32574*/ GIMT_Encode4(2348979), // Rule ID 58484 //
     /* 2348927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2348930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2348933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348941 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2348944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2348958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348960 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348963 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348977 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348978 */   // GIR_Coverage, 58484,
     /* 2348978 */   GIR_EraseRootFromParent_Done,
     /* 2348979 */ // Label 32574: @2348979
     /* 2348979 */ GIM_Try, /*On fail goto*//*Label 32575*/ GIMT_Encode4(2349036), // Rule ID 58485 //
     /* 2348984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2348987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2348990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348998 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2349001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2349015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349020 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349034 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349035 */   // GIR_Coverage, 58485,
     /* 2349035 */   GIR_EraseRootFromParent_Done,
     /* 2349036 */ // Label 32575: @2349036
     /* 2349036 */ GIM_Try, /*On fail goto*//*Label 32576*/ GIMT_Encode4(2349090), // Rule ID 58684 //
     /* 2349041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2349044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2349047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349055 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349055 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2349058 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349062 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2349072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349074 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349077 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349088 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349089 */   // GIR_Coverage, 58684,
     /* 2349089 */   GIR_EraseRootFromParent_Done,
     /* 2349090 */ // Label 32576: @2349090
     /* 2349090 */ GIM_Try, /*On fail goto*//*Label 32577*/ GIMT_Encode4(2349144), // Rule ID 58685 //
     /* 2349095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2349098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2349101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349109 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2349112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2349126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349131 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349142 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349143 */   // GIR_Coverage, 58685,
     /* 2349143 */   GIR_EraseRootFromParent_Done,
     /* 2349144 */ // Label 32577: @2349144
     /* 2349144 */ GIM_Try, /*On fail goto*//*Label 32578*/ GIMT_Encode4(2349201), // Rule ID 58888 //
     /* 2349149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2349152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2349155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349163 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349163 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2349166 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349170 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2349180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349182 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349185 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349200 */   // GIR_Coverage, 58888,
     /* 2349200 */   GIR_EraseRootFromParent_Done,
     /* 2349201 */ // Label 32578: @2349201
     /* 2349201 */ GIM_Try, /*On fail goto*//*Label 32579*/ GIMT_Encode4(2349258), // Rule ID 58889 //
     /* 2349206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2349209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2349212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349220 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349220 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2349223 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349227 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2349237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349242 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349256 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349257 */   // GIR_Coverage, 58889,
     /* 2349257 */   GIR_EraseRootFromParent_Done,
     /* 2349258 */ // Label 32579: @2349258
     /* 2349258 */ GIM_Reject,
     /* 2349259 */ // Label 32530: @2349259
     /* 2349259 */ GIM_Try, /*On fail goto*//*Label 32580*/ GIMT_Encode4(2349316), // Rule ID 58496 //
     /* 2349264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2349267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2349270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349278 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2349295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349297 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349300 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349314 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349315 */   // GIR_Coverage, 58496,
     /* 2349315 */   GIR_EraseRootFromParent_Done,
     /* 2349316 */ // Label 32580: @2349316
     /* 2349316 */ GIM_Try, /*On fail goto*//*Label 32581*/ GIMT_Encode4(2349373), // Rule ID 58497 //
     /* 2349321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2349324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2349327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349335 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349335 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349338 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349342 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2349352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349357 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349371 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349372 */   // GIR_Coverage, 58497,
     /* 2349372 */   GIR_EraseRootFromParent_Done,
     /* 2349373 */ // Label 32581: @2349373
     /* 2349373 */ GIM_Try, /*On fail goto*//*Label 32582*/ GIMT_Encode4(2349427), // Rule ID 58704 //
     /* 2349378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2349381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2349384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349392 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2349409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349414 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349425 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349426 */   // GIR_Coverage, 58704,
     /* 2349426 */   GIR_EraseRootFromParent_Done,
     /* 2349427 */ // Label 32582: @2349427
     /* 2349427 */ GIM_Try, /*On fail goto*//*Label 32583*/ GIMT_Encode4(2349481), // Rule ID 58705 //
     /* 2349432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2349435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2349438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349446 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2349463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349465 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349468 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349479 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349480 */   // GIR_Coverage, 58705,
     /* 2349480 */   GIR_EraseRootFromParent_Done,
     /* 2349481 */ // Label 32583: @2349481
     /* 2349481 */ GIM_Reject,
     /* 2349482 */ // Label 32531: @2349482
     /* 2349482 */ GIM_Try, /*On fail goto*//*Label 32584*/ GIMT_Encode4(2349539), // Rule ID 58480 //
     /* 2349487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2349490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2349493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349501 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2349518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349523 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349537 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349538 */   // GIR_Coverage, 58480,
     /* 2349538 */   GIR_EraseRootFromParent_Done,
     /* 2349539 */ // Label 32584: @2349539
     /* 2349539 */ GIM_Try, /*On fail goto*//*Label 32585*/ GIMT_Encode4(2349596), // Rule ID 58481 //
     /* 2349544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2349547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2349550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349558 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2349575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349577 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349580 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349594 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349595 */   // GIR_Coverage, 58481,
     /* 2349595 */   GIR_EraseRootFromParent_Done,
     /* 2349596 */ // Label 32585: @2349596
     /* 2349596 */ GIM_Try, /*On fail goto*//*Label 32586*/ GIMT_Encode4(2349650), // Rule ID 58664 //
     /* 2349601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2349604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2349607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349615 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349615 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349618 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349622 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2349632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349637 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349648 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349649 */   // GIR_Coverage, 58664,
     /* 2349649 */   GIR_EraseRootFromParent_Done,
     /* 2349650 */ // Label 32586: @2349650
     /* 2349650 */ GIM_Try, /*On fail goto*//*Label 32587*/ GIMT_Encode4(2349704), // Rule ID 58665 //
     /* 2349655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2349658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2349661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349669 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2349686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349691 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349703 */   // GIR_Coverage, 58665,
     /* 2349703 */   GIR_EraseRootFromParent_Done,
     /* 2349704 */ // Label 32587: @2349704
     /* 2349704 */ GIM_Try, /*On fail goto*//*Label 32588*/ GIMT_Encode4(2349761), // Rule ID 58872 //
     /* 2349709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2349712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2349715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349723 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2349740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349745 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349760 */   // GIR_Coverage, 58872,
     /* 2349760 */   GIR_EraseRootFromParent_Done,
     /* 2349761 */ // Label 32588: @2349761
     /* 2349761 */ GIM_Try, /*On fail goto*//*Label 32589*/ GIMT_Encode4(2349818), // Rule ID 58873 //
     /* 2349766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2349769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2349772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349780 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349780 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349783 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349787 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349792 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2349797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349799 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349802 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349816 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349817 */   // GIR_Coverage, 58873,
     /* 2349817 */   GIR_EraseRootFromParent_Done,
     /* 2349818 */ // Label 32589: @2349818
     /* 2349818 */ GIM_Reject,
     /* 2349819 */ // Label 32532: @2349819
     /* 2349819 */ GIM_Try, /*On fail goto*//*Label 32590*/ GIMT_Encode4(2349876), // Rule ID 58492 //
     /* 2349824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2349827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2349830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349838 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2349841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2349855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349860 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349874 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349875 */   // GIR_Coverage, 58492,
     /* 2349875 */   GIR_EraseRootFromParent_Done,
     /* 2349876 */ // Label 32590: @2349876
     /* 2349876 */ GIM_Try, /*On fail goto*//*Label 32591*/ GIMT_Encode4(2349933), // Rule ID 58493 //
     /* 2349881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2349884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2349887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349895 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349895 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2349898 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349902 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2349912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349917 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349932 */   // GIR_Coverage, 58493,
     /* 2349932 */   GIR_EraseRootFromParent_Done,
     /* 2349933 */ // Label 32591: @2349933
     /* 2349933 */ GIM_Try, /*On fail goto*//*Label 32592*/ GIMT_Encode4(2349987), // Rule ID 58688 //
     /* 2349938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2349941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2349944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349952 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2349955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2349969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349974 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349986 */   // GIR_Coverage, 58688,
     /* 2349986 */   GIR_EraseRootFromParent_Done,
     /* 2349987 */ // Label 32592: @2349987
     /* 2349987 */ GIM_Try, /*On fail goto*//*Label 32593*/ GIMT_Encode4(2350041), // Rule ID 58689 //
     /* 2349992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2349995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2349998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350006 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2350009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2350023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350028 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350039 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350040 */   // GIR_Coverage, 58689,
     /* 2350040 */   GIR_EraseRootFromParent_Done,
     /* 2350041 */ // Label 32593: @2350041
     /* 2350041 */ GIM_Try, /*On fail goto*//*Label 32594*/ GIMT_Encode4(2350098), // Rule ID 58892 //
     /* 2350046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2350049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2350052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350060 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2350063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2350077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350082 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350096 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350097 */   // GIR_Coverage, 58892,
     /* 2350097 */   GIR_EraseRootFromParent_Done,
     /* 2350098 */ // Label 32594: @2350098
     /* 2350098 */ GIM_Try, /*On fail goto*//*Label 32595*/ GIMT_Encode4(2350155), // Rule ID 58893 //
     /* 2350103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2350106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2350109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350117 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350117 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2350120 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350124 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2350134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350139 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350153 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350154 */   // GIR_Coverage, 58893,
     /* 2350154 */   GIR_EraseRootFromParent_Done,
     /* 2350155 */ // Label 32595: @2350155
     /* 2350155 */ GIM_Reject,
     /* 2350156 */ // Label 32533: @2350156
     /* 2350156 */ GIM_Try, /*On fail goto*//*Label 32596*/ GIMT_Encode4(2350213), // Rule ID 58524 //
     /* 2350161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2350164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2350167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350175 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350175 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2350178 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350182 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2350192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350197 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350212 */   // GIR_Coverage, 58524,
     /* 2350212 */   GIR_EraseRootFromParent_Done,
     /* 2350213 */ // Label 32596: @2350213
     /* 2350213 */ GIM_Try, /*On fail goto*//*Label 32597*/ GIMT_Encode4(2350270), // Rule ID 58525 //
     /* 2350218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2350221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2350224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350232 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2350235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2350249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350254 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350269 */   // GIR_Coverage, 58525,
     /* 2350269 */   GIR_EraseRootFromParent_Done,
     /* 2350270 */ // Label 32597: @2350270
     /* 2350270 */ GIM_Try, /*On fail goto*//*Label 32598*/ GIMT_Encode4(2350324), // Rule ID 58708 //
     /* 2350275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2350278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2350281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350289 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350289 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2350292 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350296 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2350306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350311 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350322 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350323 */   // GIR_Coverage, 58708,
     /* 2350323 */   GIR_EraseRootFromParent_Done,
     /* 2350324 */ // Label 32598: @2350324
     /* 2350324 */ GIM_Try, /*On fail goto*//*Label 32599*/ GIMT_Encode4(2350378), // Rule ID 58709 //
     /* 2350329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2350332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2350335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350343 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2350346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2350360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350365 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350376 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350377 */   // GIR_Coverage, 58709,
     /* 2350377 */   GIR_EraseRootFromParent_Done,
     /* 2350378 */ // Label 32599: @2350378
     /* 2350378 */ GIM_Reject,
     /* 2350379 */ // Label 32534: @2350379
     /* 2350379 */ GIM_Try, /*On fail goto*//*Label 32600*/ GIMT_Encode4(2350436), // Rule ID 58488 //
     /* 2350384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2350387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2350390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350398 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2350415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350420 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350434 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350435 */   // GIR_Coverage, 58488,
     /* 2350435 */   GIR_EraseRootFromParent_Done,
     /* 2350436 */ // Label 32600: @2350436
     /* 2350436 */ GIM_Try, /*On fail goto*//*Label 32601*/ GIMT_Encode4(2350493), // Rule ID 58489 //
     /* 2350441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2350444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2350447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350455 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2350472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350477 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350491 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350492 */   // GIR_Coverage, 58489,
     /* 2350492 */   GIR_EraseRootFromParent_Done,
     /* 2350493 */ // Label 32601: @2350493
     /* 2350493 */ GIM_Try, /*On fail goto*//*Label 32602*/ GIMT_Encode4(2350547), // Rule ID 58668 //
     /* 2350498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2350501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2350504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350512 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2350529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350531 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350534 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350546 */   // GIR_Coverage, 58668,
     /* 2350546 */   GIR_EraseRootFromParent_Done,
     /* 2350547 */ // Label 32602: @2350547
     /* 2350547 */ GIM_Try, /*On fail goto*//*Label 32603*/ GIMT_Encode4(2350601), // Rule ID 58669 //
     /* 2350552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2350555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2350558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350566 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2350583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350588 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350599 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350600 */   // GIR_Coverage, 58669,
     /* 2350600 */   GIR_EraseRootFromParent_Done,
     /* 2350601 */ // Label 32603: @2350601
     /* 2350601 */ GIM_Try, /*On fail goto*//*Label 32604*/ GIMT_Encode4(2350658), // Rule ID 58876 //
     /* 2350606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2350609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2350612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350620 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2350637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350642 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350656 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350657 */   // GIR_Coverage, 58876,
     /* 2350657 */   GIR_EraseRootFromParent_Done,
     /* 2350658 */ // Label 32604: @2350658
     /* 2350658 */ GIM_Try, /*On fail goto*//*Label 32605*/ GIMT_Encode4(2350715), // Rule ID 58877 //
     /* 2350663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2350666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2350669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350677 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350677 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350680 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350684 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2350694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350699 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350713 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350714 */   // GIR_Coverage, 58877,
     /* 2350714 */   GIR_EraseRootFromParent_Done,
     /* 2350715 */ // Label 32605: @2350715
     /* 2350715 */ GIM_Reject,
     /* 2350716 */ // Label 32535: @2350716
     /* 2350716 */ GIM_Try, /*On fail goto*//*Label 32606*/ GIMT_Encode4(2350773), // Rule ID 58512 //
     /* 2350721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2350724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2350727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350735 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2350738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2350752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350757 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350772 */   // GIR_Coverage, 58512,
     /* 2350772 */   GIR_EraseRootFromParent_Done,
     /* 2350773 */ // Label 32606: @2350773
     /* 2350773 */ GIM_Try, /*On fail goto*//*Label 32607*/ GIMT_Encode4(2350830), // Rule ID 58513 //
     /* 2350778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2350781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2350784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350792 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350792 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2350795 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350799 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2350809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350811 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350814 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350829 */   // GIR_Coverage, 58513,
     /* 2350829 */   GIR_EraseRootFromParent_Done,
     /* 2350830 */ // Label 32607: @2350830
     /* 2350830 */ GIM_Try, /*On fail goto*//*Label 32608*/ GIMT_Encode4(2350884), // Rule ID 58692 //
     /* 2350835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2350838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2350841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350849 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2350852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2350866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350868 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350871 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350882 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350883 */   // GIR_Coverage, 58692,
     /* 2350883 */   GIR_EraseRootFromParent_Done,
     /* 2350884 */ // Label 32608: @2350884
     /* 2350884 */ GIM_Try, /*On fail goto*//*Label 32609*/ GIMT_Encode4(2350938), // Rule ID 58693 //
     /* 2350889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2350892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2350895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350903 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2350906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2350920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350925 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350936 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350937 */   // GIR_Coverage, 58693,
     /* 2350937 */   GIR_EraseRootFromParent_Done,
     /* 2350938 */ // Label 32609: @2350938
     /* 2350938 */ GIM_Try, /*On fail goto*//*Label 32610*/ GIMT_Encode4(2350995), // Rule ID 58896 //
     /* 2350943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2350946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2350949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350957 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2350960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2350974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350979 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350993 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350994 */   // GIR_Coverage, 58896,
     /* 2350994 */   GIR_EraseRootFromParent_Done,
     /* 2350995 */ // Label 32610: @2350995
     /* 2350995 */ GIM_Try, /*On fail goto*//*Label 32611*/ GIMT_Encode4(2351052), // Rule ID 58897 //
     /* 2351000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2351003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2351006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351014 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351014 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2351017 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351021 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2351031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351036 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351050 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351051 */   // GIR_Coverage, 58897,
     /* 2351051 */   GIR_EraseRootFromParent_Done,
     /* 2351052 */ // Label 32611: @2351052
     /* 2351052 */ GIM_Reject,
     /* 2351053 */ // Label 32536: @2351053
     /* 2351053 */ GIM_Try, /*On fail goto*//*Label 32612*/ GIMT_Encode4(2351110), // Rule ID 58528 //
     /* 2351058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2351061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2351064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351072 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2351075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351084 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2351089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351094 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351108 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351109 */   // GIR_Coverage, 58528,
     /* 2351109 */   GIR_EraseRootFromParent_Done,
     /* 2351110 */ // Label 32612: @2351110
     /* 2351110 */ GIM_Try, /*On fail goto*//*Label 32613*/ GIMT_Encode4(2351167), // Rule ID 58529 //
     /* 2351115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2351118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2351121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351129 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351129 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2351132 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351136 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2351146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351151 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351166 */   // GIR_Coverage, 58529,
     /* 2351166 */   GIR_EraseRootFromParent_Done,
     /* 2351167 */ // Label 32613: @2351167
     /* 2351167 */ GIM_Try, /*On fail goto*//*Label 32614*/ GIMT_Encode4(2351221), // Rule ID 58712 //
     /* 2351172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2351175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2351178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351186 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351186 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2351189 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351193 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2351203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351208 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351219 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351220 */   // GIR_Coverage, 58712,
     /* 2351220 */   GIR_EraseRootFromParent_Done,
     /* 2351221 */ // Label 32614: @2351221
     /* 2351221 */ GIM_Try, /*On fail goto*//*Label 32615*/ GIMT_Encode4(2351275), // Rule ID 58713 //
     /* 2351226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2351229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2351232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351240 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351240 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2351243 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351247 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2351257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351259 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351262 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351273 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351274 */   // GIR_Coverage, 58713,
     /* 2351274 */   GIR_EraseRootFromParent_Done,
     /* 2351275 */ // Label 32615: @2351275
     /* 2351275 */ GIM_Reject,
     /* 2351276 */ // Label 32537: @2351276
     /* 2351276 */ GIM_Try, /*On fail goto*//*Label 32616*/ GIMT_Encode4(2351333), // Rule ID 58500 //
     /* 2351281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2351284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2351287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351295 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2351312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351317 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351332 */   // GIR_Coverage, 58500,
     /* 2351332 */   GIR_EraseRootFromParent_Done,
     /* 2351333 */ // Label 32616: @2351333
     /* 2351333 */ GIM_Try, /*On fail goto*//*Label 32617*/ GIMT_Encode4(2351390), // Rule ID 58501 //
     /* 2351338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2351341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2351344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351352 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2351369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351374 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351389 */   // GIR_Coverage, 58501,
     /* 2351389 */   GIR_EraseRootFromParent_Done,
     /* 2351390 */ // Label 32617: @2351390
     /* 2351390 */ GIM_Try, /*On fail goto*//*Label 32618*/ GIMT_Encode4(2351444), // Rule ID 58672 //
     /* 2351395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2351398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2351401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351409 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351409 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351412 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351416 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2351426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351431 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351442 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351443 */   // GIR_Coverage, 58672,
     /* 2351443 */   GIR_EraseRootFromParent_Done,
     /* 2351444 */ // Label 32618: @2351444
     /* 2351444 */ GIM_Try, /*On fail goto*//*Label 32619*/ GIMT_Encode4(2351498), // Rule ID 58673 //
     /* 2351449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2351452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2351455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351463 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351463 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351466 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351470 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2351480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351485 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351496 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351497 */   // GIR_Coverage, 58673,
     /* 2351497 */   GIR_EraseRootFromParent_Done,
     /* 2351498 */ // Label 32619: @2351498
     /* 2351498 */ GIM_Try, /*On fail goto*//*Label 32620*/ GIMT_Encode4(2351555), // Rule ID 58880 //
     /* 2351503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2351506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2351509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351517 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351517 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351520 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351524 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2351534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351536 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351539 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351553 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351554 */   // GIR_Coverage, 58880,
     /* 2351554 */   GIR_EraseRootFromParent_Done,
     /* 2351555 */ // Label 32620: @2351555
     /* 2351555 */ GIM_Try, /*On fail goto*//*Label 32621*/ GIMT_Encode4(2351612), // Rule ID 58881 //
     /* 2351560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2351563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2351566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351574 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2351591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351593 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351596 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351610 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351611 */   // GIR_Coverage, 58881,
     /* 2351611 */   GIR_EraseRootFromParent_Done,
     /* 2351612 */ // Label 32621: @2351612
     /* 2351612 */ GIM_Reject,
     /* 2351613 */ // Label 32538: @2351613
     /* 2351613 */ GIM_Try, /*On fail goto*//*Label 32622*/ GIMT_Encode4(2351670), // Rule ID 58516 //
     /* 2351618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2351621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2351624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351632 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2351635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2351649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351651 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351654 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351668 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351669 */   // GIR_Coverage, 58516,
     /* 2351669 */   GIR_EraseRootFromParent_Done,
     /* 2351670 */ // Label 32622: @2351670
     /* 2351670 */ GIM_Try, /*On fail goto*//*Label 32623*/ GIMT_Encode4(2351727), // Rule ID 58517 //
     /* 2351675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2351678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2351681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351689 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351689 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2351692 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351696 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2351706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351708 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351711 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351725 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351726 */   // GIR_Coverage, 58517,
     /* 2351726 */   GIR_EraseRootFromParent_Done,
     /* 2351727 */ // Label 32623: @2351727
     /* 2351727 */ GIM_Try, /*On fail goto*//*Label 32624*/ GIMT_Encode4(2351781), // Rule ID 58696 //
     /* 2351732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2351735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2351738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351746 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2351749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2351763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351768 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351780 */   // GIR_Coverage, 58696,
     /* 2351780 */   GIR_EraseRootFromParent_Done,
     /* 2351781 */ // Label 32624: @2351781
     /* 2351781 */ GIM_Try, /*On fail goto*//*Label 32625*/ GIMT_Encode4(2351835), // Rule ID 58697 //
     /* 2351786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2351789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2351792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351800 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351800 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2351803 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351807 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2351817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351819 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351822 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351833 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351834 */   // GIR_Coverage, 58697,
     /* 2351834 */   GIR_EraseRootFromParent_Done,
     /* 2351835 */ // Label 32625: @2351835
     /* 2351835 */ GIM_Try, /*On fail goto*//*Label 32626*/ GIMT_Encode4(2351892), // Rule ID 58900 //
     /* 2351840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2351843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2351846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351854 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2351857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2351871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351873 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351876 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351890 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351891 */   // GIR_Coverage, 58900,
     /* 2351891 */   GIR_EraseRootFromParent_Done,
     /* 2351892 */ // Label 32626: @2351892
     /* 2351892 */ GIM_Try, /*On fail goto*//*Label 32627*/ GIMT_Encode4(2351949), // Rule ID 58901 //
     /* 2351897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2351900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2351903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351911 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351911 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2351914 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351918 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2351928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351933 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351947 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351948 */   // GIR_Coverage, 58901,
     /* 2351948 */   GIR_EraseRootFromParent_Done,
     /* 2351949 */ // Label 32627: @2351949
     /* 2351949 */ GIM_Reject,
     /* 2351950 */ // Label 32539: @2351950
     /* 2351950 */ GIM_Try, /*On fail goto*//*Label 32628*/ GIMT_Encode4(2352007), // Rule ID 58532 //
     /* 2351955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2351958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2351961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351969 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2351972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2351986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351988 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351991 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352005 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352006 */   // GIR_Coverage, 58532,
     /* 2352006 */   GIR_EraseRootFromParent_Done,
     /* 2352007 */ // Label 32628: @2352007
     /* 2352007 */ GIM_Try, /*On fail goto*//*Label 32629*/ GIMT_Encode4(2352064), // Rule ID 58533 //
     /* 2352012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2352015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2352018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352026 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2352029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2352043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352048 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352062 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352063 */   // GIR_Coverage, 58533,
     /* 2352063 */   GIR_EraseRootFromParent_Done,
     /* 2352064 */ // Label 32629: @2352064
     /* 2352064 */ GIM_Try, /*On fail goto*//*Label 32630*/ GIMT_Encode4(2352118), // Rule ID 58716 //
     /* 2352069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2352072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2352075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352083 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352083 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2352086 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352090 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2352100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352105 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352117 */   // GIR_Coverage, 58716,
     /* 2352117 */   GIR_EraseRootFromParent_Done,
     /* 2352118 */ // Label 32630: @2352118
     /* 2352118 */ GIM_Try, /*On fail goto*//*Label 32631*/ GIMT_Encode4(2352172), // Rule ID 58717 //
     /* 2352123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2352126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2352129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352137 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352137 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2352140 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352144 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2352154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352156 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352159 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352170 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352171 */   // GIR_Coverage, 58717,
     /* 2352171 */   GIR_EraseRootFromParent_Done,
     /* 2352172 */ // Label 32631: @2352172
     /* 2352172 */ GIM_Reject,
     /* 2352173 */ // Label 32540: @2352173
     /* 2352173 */ GIM_Try, /*On fail goto*//*Label 32632*/ GIMT_Encode4(2352230), // Rule ID 58504 //
     /* 2352178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2352181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2352184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352192 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2352209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352211 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352214 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352228 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352229 */   // GIR_Coverage, 58504,
     /* 2352229 */   GIR_EraseRootFromParent_Done,
     /* 2352230 */ // Label 32632: @2352230
     /* 2352230 */ GIM_Try, /*On fail goto*//*Label 32633*/ GIMT_Encode4(2352287), // Rule ID 58505 //
     /* 2352235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2352238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2352241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352249 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2352266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352268 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352271 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352286 */   // GIR_Coverage, 58505,
     /* 2352286 */   GIR_EraseRootFromParent_Done,
     /* 2352287 */ // Label 32633: @2352287
     /* 2352287 */ GIM_Try, /*On fail goto*//*Label 32634*/ GIMT_Encode4(2352341), // Rule ID 58676 //
     /* 2352292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2352295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2352298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352306 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2352323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352328 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352339 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352340 */   // GIR_Coverage, 58676,
     /* 2352340 */   GIR_EraseRootFromParent_Done,
     /* 2352341 */ // Label 32634: @2352341
     /* 2352341 */ GIM_Try, /*On fail goto*//*Label 32635*/ GIMT_Encode4(2352395), // Rule ID 58677 //
     /* 2352346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2352349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2352352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352360 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2352377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352382 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352393 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352394 */   // GIR_Coverage, 58677,
     /* 2352394 */   GIR_EraseRootFromParent_Done,
     /* 2352395 */ // Label 32635: @2352395
     /* 2352395 */ GIM_Try, /*On fail goto*//*Label 32636*/ GIMT_Encode4(2352452), // Rule ID 58884 //
     /* 2352400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2352403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2352406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352414 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2352431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352436 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352450 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352451 */   // GIR_Coverage, 58884,
     /* 2352451 */   GIR_EraseRootFromParent_Done,
     /* 2352452 */ // Label 32636: @2352452
     /* 2352452 */ GIM_Try, /*On fail goto*//*Label 32637*/ GIMT_Encode4(2352509), // Rule ID 58885 //
     /* 2352457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2352460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2352463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352471 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2352488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352490 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352493 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352507 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352508 */   // GIR_Coverage, 58885,
     /* 2352508 */   GIR_EraseRootFromParent_Done,
     /* 2352509 */ // Label 32637: @2352509
     /* 2352509 */ GIM_Reject,
     /* 2352510 */ // Label 32541: @2352510
     /* 2352510 */ GIM_Try, /*On fail goto*//*Label 32638*/ GIMT_Encode4(2352567), // Rule ID 58520 //
     /* 2352515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2352518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2352521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352529 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352529 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2352532 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352536 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2352546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352548 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352551 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352565 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352566 */   // GIR_Coverage, 58520,
     /* 2352566 */   GIR_EraseRootFromParent_Done,
     /* 2352567 */ // Label 32638: @2352567
     /* 2352567 */ GIM_Try, /*On fail goto*//*Label 32639*/ GIMT_Encode4(2352624), // Rule ID 58521 //
     /* 2352572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2352575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2352578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352586 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352586 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2352589 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352593 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2352603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352608 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352623 */   // GIR_Coverage, 58521,
     /* 2352623 */   GIR_EraseRootFromParent_Done,
     /* 2352624 */ // Label 32639: @2352624
     /* 2352624 */ GIM_Try, /*On fail goto*//*Label 32640*/ GIMT_Encode4(2352678), // Rule ID 58700 //
     /* 2352629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2352632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2352635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352643 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2352646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2352660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352665 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352677 */   // GIR_Coverage, 58700,
     /* 2352677 */   GIR_EraseRootFromParent_Done,
     /* 2352678 */ // Label 32640: @2352678
     /* 2352678 */ GIM_Try, /*On fail goto*//*Label 32641*/ GIMT_Encode4(2352732), // Rule ID 58701 //
     /* 2352683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2352686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2352689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352697 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2352700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2352714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352719 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352730 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352731 */   // GIR_Coverage, 58701,
     /* 2352731 */   GIR_EraseRootFromParent_Done,
     /* 2352732 */ // Label 32641: @2352732
     /* 2352732 */ GIM_Reject,
     /* 2352733 */ // Label 32542: @2352733
     /* 2352733 */ GIM_Try, /*On fail goto*//*Label 32642*/ GIMT_Encode4(2352790), // Rule ID 58508 //
     /* 2352738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2352741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2352744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352752 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352752 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2352755 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352759 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2352769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352774 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352788 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352789 */   // GIR_Coverage, 58508,
     /* 2352789 */   GIR_EraseRootFromParent_Done,
     /* 2352790 */ // Label 32642: @2352790
     /* 2352790 */ GIM_Try, /*On fail goto*//*Label 32643*/ GIMT_Encode4(2352847), // Rule ID 58509 //
     /* 2352795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2352798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2352801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352809 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2352812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2352826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352828 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352831 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352845 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352846 */   // GIR_Coverage, 58509,
     /* 2352846 */   GIR_EraseRootFromParent_Done,
     /* 2352847 */ // Label 32643: @2352847
     /* 2352847 */ GIM_Try, /*On fail goto*//*Label 32644*/ GIMT_Encode4(2352901), // Rule ID 58680 //
     /* 2352852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2352855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2352858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352866 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352866 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2352869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352873 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2352883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352888 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352899 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352900 */   // GIR_Coverage, 58680,
     /* 2352900 */   GIR_EraseRootFromParent_Done,
     /* 2352901 */ // Label 32644: @2352901
     /* 2352901 */ GIM_Try, /*On fail goto*//*Label 32645*/ GIMT_Encode4(2352955), // Rule ID 58681 //
     /* 2352906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2352909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2352912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352920 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2352923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2352937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352939 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352942 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352953 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352954 */   // GIR_Coverage, 58681,
     /* 2352954 */   GIR_EraseRootFromParent_Done,
     /* 2352955 */ // Label 32645: @2352955
     /* 2352955 */ GIM_Reject,
     /* 2352956 */ // Label 32543: @2352956
     /* 2352956 */ GIM_Reject,
     /* 2352957 */ // Label 71: @2352957
     /* 2352957 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32664*/ GIMT_Encode4(2354927),
     /* 2352968 */ /*GILLT_s16*//*Label 32646*/ GIMT_Encode4(2353088),
     /* 2352972 */ /*GILLT_s32*//*Label 32647*/ GIMT_Encode4(2353152),
     /* 2352976 */ /*GILLT_s64*//*Label 32648*/ GIMT_Encode4(2353216), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2352988 */ /*GILLT_nxv1s16*//*Label 32649*/ GIMT_Encode4(2353307),
     /* 2352992 */ /*GILLT_nxv1s32*//*Label 32650*/ GIMT_Encode4(2353415),
     /* 2352996 */ /*GILLT_nxv1s64*//*Label 32651*/ GIMT_Encode4(2353523), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2353008 */ /*GILLT_nxv2s16*//*Label 32652*/ GIMT_Encode4(2353631),
     /* 2353012 */ /*GILLT_nxv2s32*//*Label 32653*/ GIMT_Encode4(2353739),
     /* 2353016 */ /*GILLT_nxv2s64*//*Label 32654*/ GIMT_Encode4(2353847), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2353028 */ /*GILLT_nxv4s16*//*Label 32655*/ GIMT_Encode4(2353955),
     /* 2353032 */ /*GILLT_nxv4s32*//*Label 32656*/ GIMT_Encode4(2354063),
     /* 2353036 */ /*GILLT_nxv4s64*//*Label 32657*/ GIMT_Encode4(2354171), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2353048 */ /*GILLT_nxv8s16*//*Label 32658*/ GIMT_Encode4(2354279),
     /* 2353052 */ /*GILLT_nxv8s32*//*Label 32659*/ GIMT_Encode4(2354387),
     /* 2353056 */ /*GILLT_nxv8s64*//*Label 32660*/ GIMT_Encode4(2354495), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2353068 */ /*GILLT_nxv16s16*//*Label 32661*/ GIMT_Encode4(2354603),
     /* 2353072 */ /*GILLT_nxv16s32*//*Label 32662*/ GIMT_Encode4(2354711), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2353084 */ /*GILLT_nxv32s16*//*Label 32663*/ GIMT_Encode4(2354819),
     /* 2353088 */ // Label 32646: @2353088
     /* 2353088 */ GIM_Try, /*On fail goto*//*Label 32665*/ GIMT_Encode4(2353151),
     /* 2353093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2353096 */   GIM_Try, /*On fail goto*//*Label 32666*/ GIMT_Encode4(2353123), // Rule ID 2001 //
     /* 2353101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2353104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2353108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2353112 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2353112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H),
     /* 2353115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353122 */     // GIR_Coverage, 2001,
     /* 2353122 */     GIR_EraseRootFromParent_Done,
     /* 2353123 */   // Label 32666: @2353123
     /* 2353123 */   GIM_Try, /*On fail goto*//*Label 32667*/ GIMT_Encode4(2353150), // Rule ID 2034 //
     /* 2353128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2353131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2353135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2353139 */     // (fabs:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2353139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H_INX),
     /* 2353142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353149 */     // GIR_Coverage, 2034,
     /* 2353149 */     GIR_EraseRootFromParent_Done,
     /* 2353150 */   // Label 32667: @2353150
     /* 2353150 */   GIM_Reject,
     /* 2353151 */ // Label 32665: @2353151
     /* 2353151 */ GIM_Reject,
     /* 2353152 */ // Label 32647: @2353152
     /* 2353152 */ GIM_Try, /*On fail goto*//*Label 32668*/ GIMT_Encode4(2353215),
     /* 2353157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2353160 */   GIM_Try, /*On fail goto*//*Label 32669*/ GIMT_Encode4(2353187), // Rule ID 1292 //
     /* 2353165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2353168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2353172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2353176 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2353176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S),
     /* 2353179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353186 */     // GIR_Coverage, 1292,
     /* 2353186 */     GIR_EraseRootFromParent_Done,
     /* 2353187 */   // Label 32669: @2353187
     /* 2353187 */   GIM_Try, /*On fail goto*//*Label 32670*/ GIMT_Encode4(2353214), // Rule ID 1300 //
     /* 2353192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2353195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2353199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2353203 */     // (fabs:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2353203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S_INX),
     /* 2353206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353213 */     // GIR_Coverage, 1300,
     /* 2353213 */     GIR_EraseRootFromParent_Done,
     /* 2353214 */   // Label 32670: @2353214
     /* 2353214 */   GIM_Reject,
     /* 2353215 */ // Label 32668: @2353215
     /* 2353215 */ GIM_Reject,
     /* 2353216 */ // Label 32648: @2353216
     /* 2353216 */ GIM_Try, /*On fail goto*//*Label 32671*/ GIMT_Encode4(2353306),
     /* 2353221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2353224 */   GIM_Try, /*On fail goto*//*Label 32672*/ GIMT_Encode4(2353251), // Rule ID 1635 //
     /* 2353229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2353232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2353236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2353240 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2353240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D),
     /* 2353243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353250 */     // GIR_Coverage, 1635,
     /* 2353250 */     GIR_EraseRootFromParent_Done,
     /* 2353251 */   // Label 32672: @2353251
     /* 2353251 */   GIM_Try, /*On fail goto*//*Label 32673*/ GIMT_Encode4(2353278), // Rule ID 1668 //
     /* 2353256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2353259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2353263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2353267 */     // (fabs:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2353267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_INX),
     /* 2353270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353277 */     // GIR_Coverage, 1668,
     /* 2353277 */     GIR_EraseRootFromParent_Done,
     /* 2353278 */   // Label 32673: @2353278
     /* 2353278 */   GIM_Try, /*On fail goto*//*Label 32674*/ GIMT_Encode4(2353305), // Rule ID 1690 //
     /* 2353283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2353286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353294 */     // (fabs:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2353294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_IN32X),
     /* 2353297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353304 */     // GIR_Coverage, 1690,
     /* 2353304 */     GIR_EraseRootFromParent_Done,
     /* 2353305 */   // Label 32674: @2353305
     /* 2353305 */   GIM_Reject,
     /* 2353306 */ // Label 32671: @2353306
     /* 2353306 */ GIM_Reject,
     /* 2353307 */ // Label 32649: @2353307
     /* 2353307 */ GIM_Try, /*On fail goto*//*Label 32675*/ GIMT_Encode4(2353414),
     /* 2353312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2353315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353323 */   GIM_Try, /*On fail goto*//*Label 32676*/ GIMT_Encode4(2353368), // Rule ID 56252 //
     /* 2353328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353331 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2353334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2353348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353367 */     // GIR_Coverage, 56252,
     /* 2353367 */     GIR_EraseRootFromParent_Done,
     /* 2353368 */   // Label 32676: @2353368
     /* 2353368 */   GIM_Try, /*On fail goto*//*Label 32677*/ GIMT_Encode4(2353413), // Rule ID 56253 //
     /* 2353373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2353376 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2353379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2353393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353412 */     // GIR_Coverage, 56253,
     /* 2353412 */     GIR_EraseRootFromParent_Done,
     /* 2353413 */   // Label 32677: @2353413
     /* 2353413 */   GIM_Reject,
     /* 2353414 */ // Label 32675: @2353414
     /* 2353414 */ GIM_Reject,
     /* 2353415 */ // Label 32650: @2353415
     /* 2353415 */ GIM_Try, /*On fail goto*//*Label 32678*/ GIMT_Encode4(2353522),
     /* 2353420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2353423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353431 */   GIM_Try, /*On fail goto*//*Label 32679*/ GIMT_Encode4(2353476), // Rule ID 56292 //
     /* 2353436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2353439 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2353442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2353456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353475 */     // GIR_Coverage, 56292,
     /* 2353475 */     GIR_EraseRootFromParent_Done,
     /* 2353476 */   // Label 32679: @2353476
     /* 2353476 */   GIM_Try, /*On fail goto*//*Label 32680*/ GIMT_Encode4(2353521), // Rule ID 56293 //
     /* 2353481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2353484 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2353487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2353501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353520 */     // GIR_Coverage, 56293,
     /* 2353520 */     GIR_EraseRootFromParent_Done,
     /* 2353521 */   // Label 32680: @2353521
     /* 2353521 */   GIM_Reject,
     /* 2353522 */ // Label 32678: @2353522
     /* 2353522 */ GIM_Reject,
     /* 2353523 */ // Label 32651: @2353523
     /* 2353523 */ GIM_Try, /*On fail goto*//*Label 32681*/ GIMT_Encode4(2353630),
     /* 2353528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2353531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353539 */   GIM_Try, /*On fail goto*//*Label 32682*/ GIMT_Encode4(2353584), // Rule ID 56352 //
     /* 2353544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2353547 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2353550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2353564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353583 */     // GIR_Coverage, 56352,
     /* 2353583 */     GIR_EraseRootFromParent_Done,
     /* 2353584 */   // Label 32682: @2353584
     /* 2353584 */   GIM_Try, /*On fail goto*//*Label 32683*/ GIMT_Encode4(2353629), // Rule ID 56353 //
     /* 2353589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2353592 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2353595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2353609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353628 */     // GIR_Coverage, 56353,
     /* 2353628 */     GIR_EraseRootFromParent_Done,
     /* 2353629 */   // Label 32683: @2353629
     /* 2353629 */   GIM_Reject,
     /* 2353630 */ // Label 32681: @2353630
     /* 2353630 */ GIM_Reject,
     /* 2353631 */ // Label 32652: @2353631
     /* 2353631 */ GIM_Try, /*On fail goto*//*Label 32684*/ GIMT_Encode4(2353738),
     /* 2353636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2353639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353647 */   GIM_Try, /*On fail goto*//*Label 32685*/ GIMT_Encode4(2353692), // Rule ID 56272 //
     /* 2353652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353655 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2353658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2353672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353691 */     // GIR_Coverage, 56272,
     /* 2353691 */     GIR_EraseRootFromParent_Done,
     /* 2353692 */   // Label 32685: @2353692
     /* 2353692 */   GIM_Try, /*On fail goto*//*Label 32686*/ GIMT_Encode4(2353737), // Rule ID 56273 //
     /* 2353697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2353700 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2353703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2353717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353736 */     // GIR_Coverage, 56273,
     /* 2353736 */     GIR_EraseRootFromParent_Done,
     /* 2353737 */   // Label 32686: @2353737
     /* 2353737 */   GIM_Reject,
     /* 2353738 */ // Label 32684: @2353738
     /* 2353738 */ GIM_Reject,
     /* 2353739 */ // Label 32653: @2353739
     /* 2353739 */ GIM_Try, /*On fail goto*//*Label 32687*/ GIMT_Encode4(2353846),
     /* 2353744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2353747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353755 */   GIM_Try, /*On fail goto*//*Label 32688*/ GIMT_Encode4(2353800), // Rule ID 56332 //
     /* 2353760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2353763 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2353766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2353780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353799 */     // GIR_Coverage, 56332,
     /* 2353799 */     GIR_EraseRootFromParent_Done,
     /* 2353800 */   // Label 32688: @2353800
     /* 2353800 */   GIM_Try, /*On fail goto*//*Label 32689*/ GIMT_Encode4(2353845), // Rule ID 56333 //
     /* 2353805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2353808 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2353811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2353825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353844 */     // GIR_Coverage, 56333,
     /* 2353844 */     GIR_EraseRootFromParent_Done,
     /* 2353845 */   // Label 32689: @2353845
     /* 2353845 */   GIM_Reject,
     /* 2353846 */ // Label 32687: @2353846
     /* 2353846 */ GIM_Reject,
     /* 2353847 */ // Label 32654: @2353847
     /* 2353847 */ GIM_Try, /*On fail goto*//*Label 32690*/ GIMT_Encode4(2353954),
     /* 2353852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2353855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353863 */   GIM_Try, /*On fail goto*//*Label 32691*/ GIMT_Encode4(2353908), // Rule ID 56492 //
     /* 2353868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2353871 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2353874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2353888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353907 */     // GIR_Coverage, 56492,
     /* 2353907 */     GIR_EraseRootFromParent_Done,
     /* 2353908 */   // Label 32691: @2353908
     /* 2353908 */   GIM_Try, /*On fail goto*//*Label 32692*/ GIMT_Encode4(2353953), // Rule ID 56493 //
     /* 2353913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2353916 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2353919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2353933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353952 */     // GIR_Coverage, 56493,
     /* 2353952 */     GIR_EraseRootFromParent_Done,
     /* 2353953 */   // Label 32692: @2353953
     /* 2353953 */   GIM_Reject,
     /* 2353954 */ // Label 32690: @2353954
     /* 2353954 */ GIM_Reject,
     /* 2353955 */ // Label 32655: @2353955
     /* 2353955 */ GIM_Try, /*On fail goto*//*Label 32693*/ GIMT_Encode4(2354062),
     /* 2353960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2353963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353971 */   GIM_Try, /*On fail goto*//*Label 32694*/ GIMT_Encode4(2354016), // Rule ID 56312 //
     /* 2353976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353979 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2353982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2353996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354015 */     // GIR_Coverage, 56312,
     /* 2354015 */     GIR_EraseRootFromParent_Done,
     /* 2354016 */   // Label 32694: @2354016
     /* 2354016 */   GIM_Try, /*On fail goto*//*Label 32695*/ GIMT_Encode4(2354061), // Rule ID 56313 //
     /* 2354021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354024 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2354027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2354041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354060 */     // GIR_Coverage, 56313,
     /* 2354060 */     GIR_EraseRootFromParent_Done,
     /* 2354061 */   // Label 32695: @2354061
     /* 2354061 */   GIM_Reject,
     /* 2354062 */ // Label 32693: @2354062
     /* 2354062 */ GIM_Reject,
     /* 2354063 */ // Label 32656: @2354063
     /* 2354063 */ GIM_Try, /*On fail goto*//*Label 32696*/ GIMT_Encode4(2354170),
     /* 2354068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2354071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354079 */   GIM_Try, /*On fail goto*//*Label 32697*/ GIMT_Encode4(2354124), // Rule ID 56432 //
     /* 2354084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354087 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2354090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2354104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354123 */     // GIR_Coverage, 56432,
     /* 2354123 */     GIR_EraseRootFromParent_Done,
     /* 2354124 */   // Label 32697: @2354124
     /* 2354124 */   GIM_Try, /*On fail goto*//*Label 32698*/ GIMT_Encode4(2354169), // Rule ID 56433 //
     /* 2354129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354132 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2354135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2354149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354168 */     // GIR_Coverage, 56433,
     /* 2354168 */     GIR_EraseRootFromParent_Done,
     /* 2354169 */   // Label 32698: @2354169
     /* 2354169 */   GIM_Reject,
     /* 2354170 */ // Label 32696: @2354170
     /* 2354170 */ GIM_Reject,
     /* 2354171 */ // Label 32657: @2354171
     /* 2354171 */ GIM_Try, /*On fail goto*//*Label 32699*/ GIMT_Encode4(2354278),
     /* 2354176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2354179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354187 */   GIM_Try, /*On fail goto*//*Label 32700*/ GIMT_Encode4(2354232), // Rule ID 56512 //
     /* 2354192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2354195 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2354198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2354212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354231 */     // GIR_Coverage, 56512,
     /* 2354231 */     GIR_EraseRootFromParent_Done,
     /* 2354232 */   // Label 32700: @2354232
     /* 2354232 */   GIM_Try, /*On fail goto*//*Label 32701*/ GIMT_Encode4(2354277), // Rule ID 56513 //
     /* 2354237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2354240 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2354243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2354257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354276 */     // GIR_Coverage, 56513,
     /* 2354276 */     GIR_EraseRootFromParent_Done,
     /* 2354277 */   // Label 32701: @2354277
     /* 2354277 */   GIM_Reject,
     /* 2354278 */ // Label 32699: @2354278
     /* 2354278 */ GIM_Reject,
     /* 2354279 */ // Label 32658: @2354279
     /* 2354279 */ GIM_Try, /*On fail goto*//*Label 32702*/ GIMT_Encode4(2354386),
     /* 2354284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2354287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354295 */   GIM_Try, /*On fail goto*//*Label 32703*/ GIMT_Encode4(2354340), // Rule ID 56372 //
     /* 2354300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354303 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2354306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2354320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354339 */     // GIR_Coverage, 56372,
     /* 2354339 */     GIR_EraseRootFromParent_Done,
     /* 2354340 */   // Label 32703: @2354340
     /* 2354340 */   GIM_Try, /*On fail goto*//*Label 32704*/ GIMT_Encode4(2354385), // Rule ID 56373 //
     /* 2354345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354348 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2354351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2354365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354384 */     // GIR_Coverage, 56373,
     /* 2354384 */     GIR_EraseRootFromParent_Done,
     /* 2354385 */   // Label 32704: @2354385
     /* 2354385 */   GIM_Reject,
     /* 2354386 */ // Label 32702: @2354386
     /* 2354386 */ GIM_Reject,
     /* 2354387 */ // Label 32659: @2354387
     /* 2354387 */ GIM_Try, /*On fail goto*//*Label 32705*/ GIMT_Encode4(2354494),
     /* 2354392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2354395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354403 */   GIM_Try, /*On fail goto*//*Label 32706*/ GIMT_Encode4(2354448), // Rule ID 56452 //
     /* 2354408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354411 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2354414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2354428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354447 */     // GIR_Coverage, 56452,
     /* 2354447 */     GIR_EraseRootFromParent_Done,
     /* 2354448 */   // Label 32706: @2354448
     /* 2354448 */   GIM_Try, /*On fail goto*//*Label 32707*/ GIMT_Encode4(2354493), // Rule ID 56453 //
     /* 2354453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354456 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2354459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2354473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354492 */     // GIR_Coverage, 56453,
     /* 2354492 */     GIR_EraseRootFromParent_Done,
     /* 2354493 */   // Label 32707: @2354493
     /* 2354493 */   GIM_Reject,
     /* 2354494 */ // Label 32705: @2354494
     /* 2354494 */ GIM_Reject,
     /* 2354495 */ // Label 32660: @2354495
     /* 2354495 */ GIM_Try, /*On fail goto*//*Label 32708*/ GIMT_Encode4(2354602),
     /* 2354500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2354503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354511 */   GIM_Try, /*On fail goto*//*Label 32709*/ GIMT_Encode4(2354556), // Rule ID 56532 //
     /* 2354516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2354519 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2354522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2354536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354555 */     // GIR_Coverage, 56532,
     /* 2354555 */     GIR_EraseRootFromParent_Done,
     /* 2354556 */   // Label 32709: @2354556
     /* 2354556 */   GIM_Try, /*On fail goto*//*Label 32710*/ GIMT_Encode4(2354601), // Rule ID 56533 //
     /* 2354561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2354564 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2354567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2354581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354600 */     // GIR_Coverage, 56533,
     /* 2354600 */     GIR_EraseRootFromParent_Done,
     /* 2354601 */   // Label 32710: @2354601
     /* 2354601 */   GIM_Reject,
     /* 2354602 */ // Label 32708: @2354602
     /* 2354602 */ GIM_Reject,
     /* 2354603 */ // Label 32661: @2354603
     /* 2354603 */ GIM_Try, /*On fail goto*//*Label 32711*/ GIMT_Encode4(2354710),
     /* 2354608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2354611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354619 */   GIM_Try, /*On fail goto*//*Label 32712*/ GIMT_Encode4(2354664), // Rule ID 56392 //
     /* 2354624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354627 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2354644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354663 */     // GIR_Coverage, 56392,
     /* 2354663 */     GIR_EraseRootFromParent_Done,
     /* 2354664 */   // Label 32712: @2354664
     /* 2354664 */   GIM_Try, /*On fail goto*//*Label 32713*/ GIMT_Encode4(2354709), // Rule ID 56393 //
     /* 2354669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354672 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2354689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354708 */     // GIR_Coverage, 56393,
     /* 2354708 */     GIR_EraseRootFromParent_Done,
     /* 2354709 */   // Label 32713: @2354709
     /* 2354709 */   GIM_Reject,
     /* 2354710 */ // Label 32711: @2354710
     /* 2354710 */ GIM_Reject,
     /* 2354711 */ // Label 32662: @2354711
     /* 2354711 */ GIM_Try, /*On fail goto*//*Label 32714*/ GIMT_Encode4(2354818),
     /* 2354716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2354719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354727 */   GIM_Try, /*On fail goto*//*Label 32715*/ GIMT_Encode4(2354772), // Rule ID 56472 //
     /* 2354732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354735 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2354752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354771 */     // GIR_Coverage, 56472,
     /* 2354771 */     GIR_EraseRootFromParent_Done,
     /* 2354772 */   // Label 32715: @2354772
     /* 2354772 */   GIM_Try, /*On fail goto*//*Label 32716*/ GIMT_Encode4(2354817), // Rule ID 56473 //
     /* 2354777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354780 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2354797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354816 */     // GIR_Coverage, 56473,
     /* 2354816 */     GIR_EraseRootFromParent_Done,
     /* 2354817 */   // Label 32716: @2354817
     /* 2354817 */   GIM_Reject,
     /* 2354818 */ // Label 32714: @2354818
     /* 2354818 */ GIM_Reject,
     /* 2354819 */ // Label 32663: @2354819
     /* 2354819 */ GIM_Try, /*On fail goto*//*Label 32717*/ GIMT_Encode4(2354926),
     /* 2354824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2354827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354835 */   GIM_Try, /*On fail goto*//*Label 32718*/ GIMT_Encode4(2354880), // Rule ID 56412 //
     /* 2354840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354843 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2354846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2354860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354879 */     // GIR_Coverage, 56412,
     /* 2354879 */     GIR_EraseRootFromParent_Done,
     /* 2354880 */   // Label 32718: @2354880
     /* 2354880 */   GIM_Try, /*On fail goto*//*Label 32719*/ GIMT_Encode4(2354925), // Rule ID 56413 //
     /* 2354885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354888 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2354891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2354905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354924 */     // GIR_Coverage, 56413,
     /* 2354924 */     GIR_EraseRootFromParent_Done,
     /* 2354925 */   // Label 32719: @2354925
     /* 2354925 */   GIM_Reject,
     /* 2354926 */ // Label 32717: @2354926
     /* 2354926 */ GIM_Reject,
     /* 2354927 */ // Label 32664: @2354927
     /* 2354927 */ GIM_Reject,
     /* 2354928 */ // Label 72: @2354928
     /* 2354928 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32738*/ GIMT_Encode4(2360989),
     /* 2354939 */ /*GILLT_s16*//*Label 32720*/ GIMT_Encode4(2355059),
     /* 2354943 */ /*GILLT_s32*//*Label 32721*/ GIMT_Encode4(2355735),
     /* 2354947 */ /*GILLT_s64*//*Label 32722*/ GIMT_Encode4(2356411), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2354959 */ /*GILLT_nxv1s16*//*Label 32723*/ GIMT_Encode4(2357224),
     /* 2354963 */ /*GILLT_nxv1s32*//*Label 32724*/ GIMT_Encode4(2357475),
     /* 2354967 */ /*GILLT_nxv1s64*//*Label 32725*/ GIMT_Encode4(2357726), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2354979 */ /*GILLT_nxv2s16*//*Label 32726*/ GIMT_Encode4(2357977),
     /* 2354983 */ /*GILLT_nxv2s32*//*Label 32727*/ GIMT_Encode4(2358228),
     /* 2354987 */ /*GILLT_nxv2s64*//*Label 32728*/ GIMT_Encode4(2358479), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2354999 */ /*GILLT_nxv4s16*//*Label 32729*/ GIMT_Encode4(2358730),
     /* 2355003 */ /*GILLT_nxv4s32*//*Label 32730*/ GIMT_Encode4(2358981),
     /* 2355007 */ /*GILLT_nxv4s64*//*Label 32731*/ GIMT_Encode4(2359232), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355019 */ /*GILLT_nxv8s16*//*Label 32732*/ GIMT_Encode4(2359483),
     /* 2355023 */ /*GILLT_nxv8s32*//*Label 32733*/ GIMT_Encode4(2359734),
     /* 2355027 */ /*GILLT_nxv8s64*//*Label 32734*/ GIMT_Encode4(2359985), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355039 */ /*GILLT_nxv16s16*//*Label 32735*/ GIMT_Encode4(2360236),
     /* 2355043 */ /*GILLT_nxv16s32*//*Label 32736*/ GIMT_Encode4(2360487), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355055 */ /*GILLT_nxv32s16*//*Label 32737*/ GIMT_Encode4(2360738),
     /* 2355059 */ // Label 32720: @2355059
     /* 2355059 */ GIM_Try, /*On fail goto*//*Label 32739*/ GIMT_Encode4(2355734),
     /* 2355064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2355067 */   GIM_Try, /*On fail goto*//*Label 32740*/ GIMT_Encode4(2355118), // Rule ID 2006 //
     /* 2355072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2355075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2355078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2355098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355105 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs2))  =>  (FSGNJN_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)
     /* 2355105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2355108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355117 */     // GIR_Coverage, 2006,
     /* 2355117 */     GIR_EraseRootFromParent_Done,
     /* 2355118 */   // Label 32740: @2355118
     /* 2355118 */   GIM_Try, /*On fail goto*//*Label 32741*/ GIMT_Encode4(2355169), // Rule ID 2039 //
     /* 2355123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2355126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2355129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2355149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355156 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2))  =>  (FSGNJN_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)
     /* 2355156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2355159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355168 */     // GIR_Coverage, 2039,
     /* 2355168 */     GIR_EraseRootFromParent_Done,
     /* 2355169 */   // Label 32741: @2355169
     /* 2355169 */   GIM_Try, /*On fail goto*//*Label 32742*/ GIMT_Encode4(2355199), // Rule ID 2004 //
     /* 2355174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2355177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2355180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355192 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2355192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2355197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355198 */     // GIR_Coverage, 2004,
     /* 2355198 */     GIR_Done,
     /* 2355199 */   // Label 32742: @2355199
     /* 2355199 */   GIM_Try, /*On fail goto*//*Label 32743*/ GIMT_Encode4(2355255), // Rule ID 2007 //
     /* 2355204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2355207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355222 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2355222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2355229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355238 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2355246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355254 */     // GIR_Coverage, 2007,
     /* 2355254 */     GIR_EraseRootFromParent_Done,
     /* 2355255 */   // Label 32743: @2355255
     /* 2355255 */   GIM_Try, /*On fail goto*//*Label 32744*/ GIMT_Encode4(2355311), // Rule ID 2008 //
     /* 2355260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2355263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355278 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2355278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2355285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2355302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355310 */     // GIR_Coverage, 2008,
     /* 2355310 */     GIR_EraseRootFromParent_Done,
     /* 2355311 */   // Label 32744: @2355311
     /* 2355311 */   GIM_Try, /*On fail goto*//*Label 32745*/ GIMT_Encode4(2355341), // Rule ID 2037 //
     /* 2355316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2355319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2355322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355334 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2355334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2355339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355340 */     // GIR_Coverage, 2037,
     /* 2355340 */     GIR_Done,
     /* 2355341 */   // Label 32745: @2355341
     /* 2355341 */   GIM_Try, /*On fail goto*//*Label 32746*/ GIMT_Encode4(2355397), // Rule ID 2040 //
     /* 2355346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2355349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355364 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2355364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2355371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355380 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2355388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355396 */     // GIR_Coverage, 2040,
     /* 2355396 */     GIR_EraseRootFromParent_Done,
     /* 2355397 */   // Label 32746: @2355397
     /* 2355397 */   GIM_Try, /*On fail goto*//*Label 32747*/ GIMT_Encode4(2355453), // Rule ID 2041 //
     /* 2355402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2355405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355420 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2355420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2355427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355432 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355436 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2355444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355452 */     // GIR_Coverage, 2041,
     /* 2355452 */     GIR_EraseRootFromParent_Done,
     /* 2355453 */   // Label 32747: @2355453
     /* 2355453 */   GIM_Try, /*On fail goto*//*Label 32748*/ GIMT_Encode4(2355509), // Rule ID 2310 //
     /* 2355458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2355461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355476 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2355476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2355483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355492 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2355500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355508 */     // GIR_Coverage, 2310,
     /* 2355508 */     GIR_EraseRootFromParent_Done,
     /* 2355509 */   // Label 32748: @2355509
     /* 2355509 */   GIM_Try, /*On fail goto*//*Label 32749*/ GIMT_Encode4(2355565), // Rule ID 2311 //
     /* 2355514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2355517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355532 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2355532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2355539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355548 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2355556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355564 */     // GIR_Coverage, 2311,
     /* 2355564 */     GIR_EraseRootFromParent_Done,
     /* 2355565 */   // Label 32749: @2355565
     /* 2355565 */   GIM_Try, /*On fail goto*//*Label 32750*/ GIMT_Encode4(2355621), // Rule ID 2322 //
     /* 2355570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2355573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2355588 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2355588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2355595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355600 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355604 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2355612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355620 */     // GIR_Coverage, 2322,
     /* 2355620 */     GIR_EraseRootFromParent_Done,
     /* 2355621 */   // Label 32750: @2355621
     /* 2355621 */   GIM_Try, /*On fail goto*//*Label 32751*/ GIMT_Encode4(2355677), // Rule ID 2323 //
     /* 2355626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2355629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2355644 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2355644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2355651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355660 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2355668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355676 */     // GIR_Coverage, 2323,
     /* 2355676 */     GIR_EraseRootFromParent_Done,
     /* 2355677 */   // Label 32751: @2355677
     /* 2355677 */   GIM_Try, /*On fail goto*//*Label 32752*/ GIMT_Encode4(2355733), // Rule ID 2330 //
     /* 2355682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2355685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355700 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_INX:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2355700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2355707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355716 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2355724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355732 */     // GIR_Coverage, 2330,
     /* 2355732 */     GIR_EraseRootFromParent_Done,
     /* 2355733 */   // Label 32752: @2355733
     /* 2355733 */   GIM_Reject,
     /* 2355734 */ // Label 32739: @2355734
     /* 2355734 */ GIM_Reject,
     /* 2355735 */ // Label 32721: @2355735
     /* 2355735 */ GIM_Try, /*On fail goto*//*Label 32753*/ GIMT_Encode4(2356410),
     /* 2355740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2355743 */   GIM_Try, /*On fail goto*//*Label 32754*/ GIMT_Encode4(2355794), // Rule ID 1307 //
     /* 2355748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2355751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2355774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355781 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs2))  =>  (FSGNJN_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)
     /* 2355781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2355784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355793 */     // GIR_Coverage, 1307,
     /* 2355793 */     GIR_EraseRootFromParent_Done,
     /* 2355794 */   // Label 32754: @2355794
     /* 2355794 */   GIM_Try, /*On fail goto*//*Label 32755*/ GIMT_Encode4(2355845), // Rule ID 1328 //
     /* 2355799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2355802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2355825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355832 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2))  =>  (FSGNJN_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)
     /* 2355832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2355835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355844 */     // GIR_Coverage, 1328,
     /* 2355844 */     GIR_EraseRootFromParent_Done,
     /* 2355845 */   // Label 32755: @2355845
     /* 2355845 */   GIM_Try, /*On fail goto*//*Label 32756*/ GIMT_Encode4(2355875), // Rule ID 1303 //
     /* 2355850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2355853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355868 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2355868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2355873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355874 */     // GIR_Coverage, 1303,
     /* 2355874 */     GIR_Done,
     /* 2355875 */   // Label 32756: @2355875
     /* 2355875 */   GIM_Try, /*On fail goto*//*Label 32757*/ GIMT_Encode4(2355905), // Rule ID 1304 //
     /* 2355880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2355883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355898 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2355898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2355903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355904 */     // GIR_Coverage, 1304,
     /* 2355904 */     GIR_Done,
     /* 2355905 */   // Label 32757: @2355905
     /* 2355905 */   GIM_Try, /*On fail goto*//*Label 32758*/ GIMT_Encode4(2355961), // Rule ID 1643 //
     /* 2355910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2355913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355928 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2355928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2355931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2355935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355940 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355944 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2355952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355960 */     // GIR_Coverage, 1643,
     /* 2355960 */     GIR_EraseRootFromParent_Done,
     /* 2355961 */   // Label 32758: @2355961
     /* 2355961 */   GIM_Try, /*On fail goto*//*Label 32759*/ GIMT_Encode4(2356017), // Rule ID 1644 //
     /* 2355966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2355969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355984 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2355984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2355987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2355991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356000 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2356003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2356008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356016 */     // GIR_Coverage, 1644,
     /* 2356016 */     GIR_EraseRootFromParent_Done,
     /* 2356017 */   // Label 32759: @2356017
     /* 2356017 */   GIM_Try, /*On fail goto*//*Label 32760*/ GIMT_Encode4(2356073), // Rule ID 1674 //
     /* 2356022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2356025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356040 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_INX:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2356040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2356047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356052 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356056 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2356059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2356064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356072 */     // GIR_Coverage, 1674,
     /* 2356072 */     GIR_EraseRootFromParent_Done,
     /* 2356073 */   // Label 32760: @2356073
     /* 2356073 */   GIM_Try, /*On fail goto*//*Label 32761*/ GIMT_Encode4(2356129), // Rule ID 1698 //
     /* 2356078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2356081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356096 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2356096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2356103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356108 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356112 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2356115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2356120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356128 */     // GIR_Coverage, 1698,
     /* 2356128 */     GIR_EraseRootFromParent_Done,
     /* 2356129 */   // Label 32761: @2356129
     /* 2356129 */   GIM_Try, /*On fail goto*//*Label 32762*/ GIMT_Encode4(2356185), // Rule ID 1699 //
     /* 2356134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2356137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356152 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2356152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2356159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356164 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356168 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2356171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2356176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356184 */     // GIR_Coverage, 1699,
     /* 2356184 */     GIR_EraseRootFromParent_Done,
     /* 2356185 */   // Label 32762: @2356185
     /* 2356185 */   GIM_Try, /*On fail goto*//*Label 32763*/ GIMT_Encode4(2356241), // Rule ID 2182 //
     /* 2356190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2356193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2356196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2356200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2356204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2356208 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2356208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2356215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356224 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2356232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356240 */     // GIR_Coverage, 2182,
     /* 2356240 */     GIR_EraseRootFromParent_Done,
     /* 2356241 */   // Label 32763: @2356241
     /* 2356241 */   GIM_Try, /*On fail goto*//*Label 32764*/ GIMT_Encode4(2356297), // Rule ID 2183 //
     /* 2356246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2356249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2356252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2356256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2356260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2356264 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2356264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2356271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356280 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2356288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356296 */     // GIR_Coverage, 2183,
     /* 2356296 */     GIR_EraseRootFromParent_Done,
     /* 2356297 */   // Label 32764: @2356297
     /* 2356297 */   GIM_Try, /*On fail goto*//*Label 32765*/ GIMT_Encode4(2356353), // Rule ID 2196 //
     /* 2356302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2356305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2356308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2356320 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2356320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2356327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356336 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2356344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356352 */     // GIR_Coverage, 2196,
     /* 2356352 */     GIR_EraseRootFromParent_Done,
     /* 2356353 */   // Label 32765: @2356353
     /* 2356353 */   GIM_Try, /*On fail goto*//*Label 32766*/ GIMT_Encode4(2356409), // Rule ID 2197 //
     /* 2356358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2356361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2356364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2356376 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2356376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2356383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356392 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2356400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356408 */     // GIR_Coverage, 2197,
     /* 2356408 */     GIR_EraseRootFromParent_Done,
     /* 2356409 */   // Label 32766: @2356409
     /* 2356409 */   GIM_Reject,
     /* 2356410 */ // Label 32753: @2356410
     /* 2356410 */ GIM_Reject,
     /* 2356411 */ // Label 32722: @2356411
     /* 2356411 */ GIM_Try, /*On fail goto*//*Label 32767*/ GIMT_Encode4(2357223),
     /* 2356416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2356419 */   GIM_Try, /*On fail goto*//*Label 32768*/ GIMT_Encode4(2356470), // Rule ID 1640 //
     /* 2356424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2356427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2356450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356457 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs2))  =>  (FSGNJN_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)
     /* 2356457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2356460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356469 */     // GIR_Coverage, 1640,
     /* 2356469 */     GIR_EraseRootFromParent_Done,
     /* 2356470 */   // Label 32768: @2356470
     /* 2356470 */   GIM_Try, /*On fail goto*//*Label 32769*/ GIMT_Encode4(2356521), // Rule ID 1672 //
     /* 2356475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2356478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2356501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356508 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)
     /* 2356508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2356511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356520 */     // GIR_Coverage, 1672,
     /* 2356520 */     GIR_EraseRootFromParent_Done,
     /* 2356521 */   // Label 32769: @2356521
     /* 2356521 */   GIM_Try, /*On fail goto*//*Label 32770*/ GIMT_Encode4(2356572), // Rule ID 1695 //
     /* 2356526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2356529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2356552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356559 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)
     /* 2356559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2356562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356571 */     // GIR_Coverage, 1695,
     /* 2356571 */     GIR_EraseRootFromParent_Done,
     /* 2356572 */   // Label 32770: @2356572
     /* 2356572 */   GIM_Try, /*On fail goto*//*Label 32771*/ GIMT_Encode4(2356602), // Rule ID 1638 //
     /* 2356577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2356580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356595 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2356595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2356600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356601 */     // GIR_Coverage, 1638,
     /* 2356601 */     GIR_Done,
     /* 2356602 */   // Label 32771: @2356602
     /* 2356602 */   GIM_Try, /*On fail goto*//*Label 32772*/ GIMT_Encode4(2356658), // Rule ID 1641 //
     /* 2356607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2356610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2356613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2356625 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2356625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2356628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2356632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356637 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356641 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2356649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356657 */     // GIR_Coverage, 1641,
     /* 2356657 */     GIR_EraseRootFromParent_Done,
     /* 2356658 */   // Label 32772: @2356658
     /* 2356658 */   GIM_Try, /*On fail goto*//*Label 32773*/ GIMT_Encode4(2356714), // Rule ID 1642 //
     /* 2356663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2356666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2356669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2356681 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2356681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2356684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2356688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356697 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2356705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356713 */     // GIR_Coverage, 1642,
     /* 2356713 */     GIR_EraseRootFromParent_Done,
     /* 2356714 */   // Label 32773: @2356714
     /* 2356714 */   GIM_Try, /*On fail goto*//*Label 32774*/ GIMT_Encode4(2356744), // Rule ID 1670 //
     /* 2356719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2356722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356737 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2356737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2356742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356743 */     // GIR_Coverage, 1670,
     /* 2356743 */     GIR_Done,
     /* 2356744 */   // Label 32774: @2356744
     /* 2356744 */   GIM_Try, /*On fail goto*//*Label 32775*/ GIMT_Encode4(2356800), // Rule ID 1673 //
     /* 2356749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2356752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2356755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356767 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_INX:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2356767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2356770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2356774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356783 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2356791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356799 */     // GIR_Coverage, 1673,
     /* 2356799 */     GIR_EraseRootFromParent_Done,
     /* 2356800 */   // Label 32775: @2356800
     /* 2356800 */   GIM_Try, /*On fail goto*//*Label 32776*/ GIMT_Encode4(2356830), // Rule ID 1693 //
     /* 2356805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2356808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356823 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2356823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2356828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356829 */     // GIR_Coverage, 1693,
     /* 2356829 */     GIR_Done,
     /* 2356830 */   // Label 32776: @2356830
     /* 2356830 */   GIM_Try, /*On fail goto*//*Label 32777*/ GIMT_Encode4(2356886), // Rule ID 1696 //
     /* 2356835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2356838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2356841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356853 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2356853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2356856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2356860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356869 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2356877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356885 */     // GIR_Coverage, 1696,
     /* 2356885 */     GIR_EraseRootFromParent_Done,
     /* 2356886 */   // Label 32777: @2356886
     /* 2356886 */   GIM_Try, /*On fail goto*//*Label 32778*/ GIMT_Encode4(2356942), // Rule ID 1697 //
     /* 2356891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2356894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2356897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356909 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2356909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2356912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2356916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356925 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2356933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356941 */     // GIR_Coverage, 1697,
     /* 2356941 */     GIR_EraseRootFromParent_Done,
     /* 2356942 */   // Label 32778: @2356942
     /* 2356942 */   GIM_Try, /*On fail goto*//*Label 32779*/ GIMT_Encode4(2356998), // Rule ID 2312 //
     /* 2356947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2356950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2356953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2356965 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2356965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2356968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2356972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2356989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356997 */     // GIR_Coverage, 2312,
     /* 2356997 */     GIR_EraseRootFromParent_Done,
     /* 2356998 */   // Label 32779: @2356998
     /* 2356998 */   GIM_Try, /*On fail goto*//*Label 32780*/ GIMT_Encode4(2357054), // Rule ID 2313 //
     /* 2357003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2357006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2357009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357021 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2357021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2357024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2357028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357033 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2357037 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2357040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2357045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357053 */     // GIR_Coverage, 2313,
     /* 2357053 */     GIR_EraseRootFromParent_Done,
     /* 2357054 */   // Label 32780: @2357054
     /* 2357054 */   GIM_Try, /*On fail goto*//*Label 32781*/ GIMT_Encode4(2357110), // Rule ID 2324 //
     /* 2357059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2357062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2357065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357077 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2357077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2357080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2357084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357089 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2357093 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2357096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2357101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357109 */     // GIR_Coverage, 2324,
     /* 2357109 */     GIR_EraseRootFromParent_Done,
     /* 2357110 */   // Label 32781: @2357110
     /* 2357110 */   GIM_Try, /*On fail goto*//*Label 32782*/ GIMT_Encode4(2357166), // Rule ID 2325 //
     /* 2357115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2357118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2357121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357133 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2357133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2357136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2357140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2357149 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2357152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2357157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357165 */     // GIR_Coverage, 2325,
     /* 2357165 */     GIR_EraseRootFromParent_Done,
     /* 2357166 */   // Label 32782: @2357166
     /* 2357166 */   GIM_Try, /*On fail goto*//*Label 32783*/ GIMT_Encode4(2357222), // Rule ID 2331 //
     /* 2357171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2357174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2357177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357189 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_INX:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2357189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2357192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2357196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2357205 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2357208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2357213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357221 */     // GIR_Coverage, 2331,
     /* 2357221 */     GIR_EraseRootFromParent_Done,
     /* 2357222 */   // Label 32783: @2357222
     /* 2357222 */   GIM_Reject,
     /* 2357223 */ // Label 32767: @2357223
     /* 2357223 */ GIM_Reject,
     /* 2357224 */ // Label 32723: @2357224
     /* 2357224 */ GIM_Try, /*On fail goto*//*Label 32784*/ GIMT_Encode4(2357474),
     /* 2357229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2357232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2357235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357243 */   GIM_Try, /*On fail goto*//*Label 32785*/ GIMT_Encode4(2357309), // Rule ID 56262 //
     /* 2357248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2357263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357270 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2357287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357308 */     // GIR_Coverage, 56262,
     /* 2357308 */     GIR_EraseRootFromParent_Done,
     /* 2357309 */   // Label 32785: @2357309
     /* 2357309 */   GIM_Try, /*On fail goto*//*Label 32786*/ GIMT_Encode4(2357375), // Rule ID 56263 //
     /* 2357314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2357329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357336 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2357353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357374 */     // GIR_Coverage, 56263,
     /* 2357374 */     GIR_EraseRootFromParent_Done,
     /* 2357375 */   // Label 32786: @2357375
     /* 2357375 */   GIM_Try, /*On fail goto*//*Label 32787*/ GIMT_Encode4(2357424), // Rule ID 56256 //
     /* 2357380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357387 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2357404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357423 */     // GIR_Coverage, 56256,
     /* 2357423 */     GIR_EraseRootFromParent_Done,
     /* 2357424 */   // Label 32787: @2357424
     /* 2357424 */   GIM_Try, /*On fail goto*//*Label 32788*/ GIMT_Encode4(2357473), // Rule ID 56257 //
     /* 2357429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357436 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2357453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357472 */     // GIR_Coverage, 56257,
     /* 2357472 */     GIR_EraseRootFromParent_Done,
     /* 2357473 */   // Label 32788: @2357473
     /* 2357473 */   GIM_Reject,
     /* 2357474 */ // Label 32784: @2357474
     /* 2357474 */ GIM_Reject,
     /* 2357475 */ // Label 32724: @2357475
     /* 2357475 */ GIM_Try, /*On fail goto*//*Label 32789*/ GIMT_Encode4(2357725),
     /* 2357480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2357483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2357486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357494 */   GIM_Try, /*On fail goto*//*Label 32790*/ GIMT_Encode4(2357560), // Rule ID 56302 //
     /* 2357499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2357502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2357514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357521 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2357524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2357538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357559 */     // GIR_Coverage, 56302,
     /* 2357559 */     GIR_EraseRootFromParent_Done,
     /* 2357560 */   // Label 32790: @2357560
     /* 2357560 */   GIM_Try, /*On fail goto*//*Label 32791*/ GIMT_Encode4(2357626), // Rule ID 56303 //
     /* 2357565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2357568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2357580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357587 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2357590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2357604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357625 */     // GIR_Coverage, 56303,
     /* 2357625 */     GIR_EraseRootFromParent_Done,
     /* 2357626 */   // Label 32791: @2357626
     /* 2357626 */   GIM_Try, /*On fail goto*//*Label 32792*/ GIMT_Encode4(2357675), // Rule ID 56296 //
     /* 2357631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2357634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357638 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2357641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2357655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357674 */     // GIR_Coverage, 56296,
     /* 2357674 */     GIR_EraseRootFromParent_Done,
     /* 2357675 */   // Label 32792: @2357675
     /* 2357675 */   GIM_Try, /*On fail goto*//*Label 32793*/ GIMT_Encode4(2357724), // Rule ID 56297 //
     /* 2357680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2357683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357687 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2357690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2357704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357723 */     // GIR_Coverage, 56297,
     /* 2357723 */     GIR_EraseRootFromParent_Done,
     /* 2357724 */   // Label 32793: @2357724
     /* 2357724 */   GIM_Reject,
     /* 2357725 */ // Label 32789: @2357725
     /* 2357725 */ GIM_Reject,
     /* 2357726 */ // Label 32725: @2357726
     /* 2357726 */ GIM_Try, /*On fail goto*//*Label 32794*/ GIMT_Encode4(2357976),
     /* 2357731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2357734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2357737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357745 */   GIM_Try, /*On fail goto*//*Label 32795*/ GIMT_Encode4(2357811), // Rule ID 56362 //
     /* 2357750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2357753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2357765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357772 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2357775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2357789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357810 */     // GIR_Coverage, 56362,
     /* 2357810 */     GIR_EraseRootFromParent_Done,
     /* 2357811 */   // Label 32795: @2357811
     /* 2357811 */   GIM_Try, /*On fail goto*//*Label 32796*/ GIMT_Encode4(2357877), // Rule ID 56363 //
     /* 2357816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2357819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2357831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357838 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2357841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2357855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357876 */     // GIR_Coverage, 56363,
     /* 2357876 */     GIR_EraseRootFromParent_Done,
     /* 2357877 */   // Label 32796: @2357877
     /* 2357877 */   GIM_Try, /*On fail goto*//*Label 32797*/ GIMT_Encode4(2357926), // Rule ID 56356 //
     /* 2357882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2357885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357889 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2357892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2357906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357925 */     // GIR_Coverage, 56356,
     /* 2357925 */     GIR_EraseRootFromParent_Done,
     /* 2357926 */   // Label 32797: @2357926
     /* 2357926 */   GIM_Try, /*On fail goto*//*Label 32798*/ GIMT_Encode4(2357975), // Rule ID 56357 //
     /* 2357931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2357934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357938 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2357941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2357955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357974 */     // GIR_Coverage, 56357,
     /* 2357974 */     GIR_EraseRootFromParent_Done,
     /* 2357975 */   // Label 32798: @2357975
     /* 2357975 */   GIM_Reject,
     /* 2357976 */ // Label 32794: @2357976
     /* 2357976 */ GIM_Reject,
     /* 2357977 */ // Label 32726: @2357977
     /* 2357977 */ GIM_Try, /*On fail goto*//*Label 32799*/ GIMT_Encode4(2358227),
     /* 2357982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2357985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2357988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357996 */   GIM_Try, /*On fail goto*//*Label 32800*/ GIMT_Encode4(2358062), // Rule ID 56282 //
     /* 2358001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2358016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358023 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2358026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2358040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358061 */     // GIR_Coverage, 56282,
     /* 2358061 */     GIR_EraseRootFromParent_Done,
     /* 2358062 */   // Label 32800: @2358062
     /* 2358062 */   GIM_Try, /*On fail goto*//*Label 32801*/ GIMT_Encode4(2358128), // Rule ID 56283 //
     /* 2358067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2358082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358089 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2358092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2358106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358127 */     // GIR_Coverage, 56283,
     /* 2358127 */     GIR_EraseRootFromParent_Done,
     /* 2358128 */   // Label 32801: @2358128
     /* 2358128 */   GIM_Try, /*On fail goto*//*Label 32802*/ GIMT_Encode4(2358177), // Rule ID 56276 //
     /* 2358133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358140 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2358143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2358157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358176 */     // GIR_Coverage, 56276,
     /* 2358176 */     GIR_EraseRootFromParent_Done,
     /* 2358177 */   // Label 32802: @2358177
     /* 2358177 */   GIM_Try, /*On fail goto*//*Label 32803*/ GIMT_Encode4(2358226), // Rule ID 56277 //
     /* 2358182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358189 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2358192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2358206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358225 */     // GIR_Coverage, 56277,
     /* 2358225 */     GIR_EraseRootFromParent_Done,
     /* 2358226 */   // Label 32803: @2358226
     /* 2358226 */   GIM_Reject,
     /* 2358227 */ // Label 32799: @2358227
     /* 2358227 */ GIM_Reject,
     /* 2358228 */ // Label 32727: @2358228
     /* 2358228 */ GIM_Try, /*On fail goto*//*Label 32804*/ GIMT_Encode4(2358478),
     /* 2358233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2358236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2358239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358247 */   GIM_Try, /*On fail goto*//*Label 32805*/ GIMT_Encode4(2358313), // Rule ID 56342 //
     /* 2358252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2358267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358274 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2358291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358312 */     // GIR_Coverage, 56342,
     /* 2358312 */     GIR_EraseRootFromParent_Done,
     /* 2358313 */   // Label 32805: @2358313
     /* 2358313 */   GIM_Try, /*On fail goto*//*Label 32806*/ GIMT_Encode4(2358379), // Rule ID 56343 //
     /* 2358318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2358333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358340 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2358357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358378 */     // GIR_Coverage, 56343,
     /* 2358378 */     GIR_EraseRootFromParent_Done,
     /* 2358379 */   // Label 32806: @2358379
     /* 2358379 */   GIM_Try, /*On fail goto*//*Label 32807*/ GIMT_Encode4(2358428), // Rule ID 56336 //
     /* 2358384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358391 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2358408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358427 */     // GIR_Coverage, 56336,
     /* 2358427 */     GIR_EraseRootFromParent_Done,
     /* 2358428 */   // Label 32807: @2358428
     /* 2358428 */   GIM_Try, /*On fail goto*//*Label 32808*/ GIMT_Encode4(2358477), // Rule ID 56337 //
     /* 2358433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358440 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2358457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358476 */     // GIR_Coverage, 56337,
     /* 2358476 */     GIR_EraseRootFromParent_Done,
     /* 2358477 */   // Label 32808: @2358477
     /* 2358477 */   GIM_Reject,
     /* 2358478 */ // Label 32804: @2358478
     /* 2358478 */ GIM_Reject,
     /* 2358479 */ // Label 32728: @2358479
     /* 2358479 */ GIM_Try, /*On fail goto*//*Label 32809*/ GIMT_Encode4(2358729),
     /* 2358484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2358487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2358490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358498 */   GIM_Try, /*On fail goto*//*Label 32810*/ GIMT_Encode4(2358564), // Rule ID 56502 //
     /* 2358503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2358518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358525 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2358542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358563 */     // GIR_Coverage, 56502,
     /* 2358563 */     GIR_EraseRootFromParent_Done,
     /* 2358564 */   // Label 32810: @2358564
     /* 2358564 */   GIM_Try, /*On fail goto*//*Label 32811*/ GIMT_Encode4(2358630), // Rule ID 56503 //
     /* 2358569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2358584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358591 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2358608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358629 */     // GIR_Coverage, 56503,
     /* 2358629 */     GIR_EraseRootFromParent_Done,
     /* 2358630 */   // Label 32811: @2358630
     /* 2358630 */   GIM_Try, /*On fail goto*//*Label 32812*/ GIMT_Encode4(2358679), // Rule ID 56496 //
     /* 2358635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358642 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2358659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358678 */     // GIR_Coverage, 56496,
     /* 2358678 */     GIR_EraseRootFromParent_Done,
     /* 2358679 */   // Label 32812: @2358679
     /* 2358679 */   GIM_Try, /*On fail goto*//*Label 32813*/ GIMT_Encode4(2358728), // Rule ID 56497 //
     /* 2358684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358691 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2358708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358727 */     // GIR_Coverage, 56497,
     /* 2358727 */     GIR_EraseRootFromParent_Done,
     /* 2358728 */   // Label 32813: @2358728
     /* 2358728 */   GIM_Reject,
     /* 2358729 */ // Label 32809: @2358729
     /* 2358729 */ GIM_Reject,
     /* 2358730 */ // Label 32729: @2358730
     /* 2358730 */ GIM_Try, /*On fail goto*//*Label 32814*/ GIMT_Encode4(2358980),
     /* 2358735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2358738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2358741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358749 */   GIM_Try, /*On fail goto*//*Label 32815*/ GIMT_Encode4(2358815), // Rule ID 56322 //
     /* 2358754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2358769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358776 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2358793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358814 */     // GIR_Coverage, 56322,
     /* 2358814 */     GIR_EraseRootFromParent_Done,
     /* 2358815 */   // Label 32815: @2358815
     /* 2358815 */   GIM_Try, /*On fail goto*//*Label 32816*/ GIMT_Encode4(2358881), // Rule ID 56323 //
     /* 2358820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2358835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358842 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2358859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358880 */     // GIR_Coverage, 56323,
     /* 2358880 */     GIR_EraseRootFromParent_Done,
     /* 2358881 */   // Label 32816: @2358881
     /* 2358881 */   GIM_Try, /*On fail goto*//*Label 32817*/ GIMT_Encode4(2358930), // Rule ID 56316 //
     /* 2358886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358893 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2358910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358929 */     // GIR_Coverage, 56316,
     /* 2358929 */     GIR_EraseRootFromParent_Done,
     /* 2358930 */   // Label 32817: @2358930
     /* 2358930 */   GIM_Try, /*On fail goto*//*Label 32818*/ GIMT_Encode4(2358979), // Rule ID 56317 //
     /* 2358935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358942 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2358959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358978 */     // GIR_Coverage, 56317,
     /* 2358978 */     GIR_EraseRootFromParent_Done,
     /* 2358979 */   // Label 32818: @2358979
     /* 2358979 */   GIM_Reject,
     /* 2358980 */ // Label 32814: @2358980
     /* 2358980 */ GIM_Reject,
     /* 2358981 */ // Label 32730: @2358981
     /* 2358981 */ GIM_Try, /*On fail goto*//*Label 32819*/ GIMT_Encode4(2359231),
     /* 2358986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2358989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2358992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359000 */   GIM_Try, /*On fail goto*//*Label 32820*/ GIMT_Encode4(2359066), // Rule ID 56442 //
     /* 2359005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2359020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359027 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2359030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2359044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359065 */     // GIR_Coverage, 56442,
     /* 2359065 */     GIR_EraseRootFromParent_Done,
     /* 2359066 */   // Label 32820: @2359066
     /* 2359066 */   GIM_Try, /*On fail goto*//*Label 32821*/ GIMT_Encode4(2359132), // Rule ID 56443 //
     /* 2359071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2359086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359093 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2359096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2359110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359131 */     // GIR_Coverage, 56443,
     /* 2359131 */     GIR_EraseRootFromParent_Done,
     /* 2359132 */   // Label 32821: @2359132
     /* 2359132 */   GIM_Try, /*On fail goto*//*Label 32822*/ GIMT_Encode4(2359181), // Rule ID 56436 //
     /* 2359137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359144 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2359147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2359161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359180 */     // GIR_Coverage, 56436,
     /* 2359180 */     GIR_EraseRootFromParent_Done,
     /* 2359181 */   // Label 32822: @2359181
     /* 2359181 */   GIM_Try, /*On fail goto*//*Label 32823*/ GIMT_Encode4(2359230), // Rule ID 56437 //
     /* 2359186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359193 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2359196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2359210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359229 */     // GIR_Coverage, 56437,
     /* 2359229 */     GIR_EraseRootFromParent_Done,
     /* 2359230 */   // Label 32823: @2359230
     /* 2359230 */   GIM_Reject,
     /* 2359231 */ // Label 32819: @2359231
     /* 2359231 */ GIM_Reject,
     /* 2359232 */ // Label 32731: @2359232
     /* 2359232 */ GIM_Try, /*On fail goto*//*Label 32824*/ GIMT_Encode4(2359482),
     /* 2359237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2359240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2359243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359251 */   GIM_Try, /*On fail goto*//*Label 32825*/ GIMT_Encode4(2359317), // Rule ID 56522 //
     /* 2359256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2359259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2359271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359278 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2359281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2359295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359316 */     // GIR_Coverage, 56522,
     /* 2359316 */     GIR_EraseRootFromParent_Done,
     /* 2359317 */   // Label 32825: @2359317
     /* 2359317 */   GIM_Try, /*On fail goto*//*Label 32826*/ GIMT_Encode4(2359383), // Rule ID 56523 //
     /* 2359322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2359325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2359337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359344 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2359347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2359361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359382 */     // GIR_Coverage, 56523,
     /* 2359382 */     GIR_EraseRootFromParent_Done,
     /* 2359383 */   // Label 32826: @2359383
     /* 2359383 */   GIM_Try, /*On fail goto*//*Label 32827*/ GIMT_Encode4(2359432), // Rule ID 56516 //
     /* 2359388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2359391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359395 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2359398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2359412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359431 */     // GIR_Coverage, 56516,
     /* 2359431 */     GIR_EraseRootFromParent_Done,
     /* 2359432 */   // Label 32827: @2359432
     /* 2359432 */   GIM_Try, /*On fail goto*//*Label 32828*/ GIMT_Encode4(2359481), // Rule ID 56517 //
     /* 2359437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2359440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359444 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2359447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2359461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359480 */     // GIR_Coverage, 56517,
     /* 2359480 */     GIR_EraseRootFromParent_Done,
     /* 2359481 */   // Label 32828: @2359481
     /* 2359481 */   GIM_Reject,
     /* 2359482 */ // Label 32824: @2359482
     /* 2359482 */ GIM_Reject,
     /* 2359483 */ // Label 32732: @2359483
     /* 2359483 */ GIM_Try, /*On fail goto*//*Label 32829*/ GIMT_Encode4(2359733),
     /* 2359488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2359491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2359494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359502 */   GIM_Try, /*On fail goto*//*Label 32830*/ GIMT_Encode4(2359568), // Rule ID 56382 //
     /* 2359507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2359510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2359522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359529 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2359532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2359546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359567 */     // GIR_Coverage, 56382,
     /* 2359567 */     GIR_EraseRootFromParent_Done,
     /* 2359568 */   // Label 32830: @2359568
     /* 2359568 */   GIM_Try, /*On fail goto*//*Label 32831*/ GIMT_Encode4(2359634), // Rule ID 56383 //
     /* 2359573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2359576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2359588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359595 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2359598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2359612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359633 */     // GIR_Coverage, 56383,
     /* 2359633 */     GIR_EraseRootFromParent_Done,
     /* 2359634 */   // Label 32831: @2359634
     /* 2359634 */   GIM_Try, /*On fail goto*//*Label 32832*/ GIMT_Encode4(2359683), // Rule ID 56376 //
     /* 2359639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2359642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359646 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2359649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2359663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359682 */     // GIR_Coverage, 56376,
     /* 2359682 */     GIR_EraseRootFromParent_Done,
     /* 2359683 */   // Label 32832: @2359683
     /* 2359683 */   GIM_Try, /*On fail goto*//*Label 32833*/ GIMT_Encode4(2359732), // Rule ID 56377 //
     /* 2359688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2359691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359695 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2359698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2359712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359731 */     // GIR_Coverage, 56377,
     /* 2359731 */     GIR_EraseRootFromParent_Done,
     /* 2359732 */   // Label 32833: @2359732
     /* 2359732 */   GIM_Reject,
     /* 2359733 */ // Label 32829: @2359733
     /* 2359733 */ GIM_Reject,
     /* 2359734 */ // Label 32733: @2359734
     /* 2359734 */ GIM_Try, /*On fail goto*//*Label 32834*/ GIMT_Encode4(2359984),
     /* 2359739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2359742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2359745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359753 */   GIM_Try, /*On fail goto*//*Label 32835*/ GIMT_Encode4(2359819), // Rule ID 56462 //
     /* 2359758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2359773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359780 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2359783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2359797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359818 */     // GIR_Coverage, 56462,
     /* 2359818 */     GIR_EraseRootFromParent_Done,
     /* 2359819 */   // Label 32835: @2359819
     /* 2359819 */   GIM_Try, /*On fail goto*//*Label 32836*/ GIMT_Encode4(2359885), // Rule ID 56463 //
     /* 2359824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2359839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359846 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2359849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2359863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359884 */     // GIR_Coverage, 56463,
     /* 2359884 */     GIR_EraseRootFromParent_Done,
     /* 2359885 */   // Label 32836: @2359885
     /* 2359885 */   GIM_Try, /*On fail goto*//*Label 32837*/ GIMT_Encode4(2359934), // Rule ID 56456 //
     /* 2359890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359897 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2359900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2359914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359933 */     // GIR_Coverage, 56456,
     /* 2359933 */     GIR_EraseRootFromParent_Done,
     /* 2359934 */   // Label 32837: @2359934
     /* 2359934 */   GIM_Try, /*On fail goto*//*Label 32838*/ GIMT_Encode4(2359983), // Rule ID 56457 //
     /* 2359939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359946 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2359949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2359963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359982 */     // GIR_Coverage, 56457,
     /* 2359982 */     GIR_EraseRootFromParent_Done,
     /* 2359983 */   // Label 32838: @2359983
     /* 2359983 */   GIM_Reject,
     /* 2359984 */ // Label 32834: @2359984
     /* 2359984 */ GIM_Reject,
     /* 2359985 */ // Label 32734: @2359985
     /* 2359985 */ GIM_Try, /*On fail goto*//*Label 32839*/ GIMT_Encode4(2360235),
     /* 2359990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2359993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2359996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360004 */   GIM_Try, /*On fail goto*//*Label 32840*/ GIMT_Encode4(2360070), // Rule ID 56542 //
     /* 2360009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2360012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2360024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360031 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2360034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2360048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360069 */     // GIR_Coverage, 56542,
     /* 2360069 */     GIR_EraseRootFromParent_Done,
     /* 2360070 */   // Label 32840: @2360070
     /* 2360070 */   GIM_Try, /*On fail goto*//*Label 32841*/ GIMT_Encode4(2360136), // Rule ID 56543 //
     /* 2360075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2360078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2360090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360097 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2360100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2360114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360135 */     // GIR_Coverage, 56543,
     /* 2360135 */     GIR_EraseRootFromParent_Done,
     /* 2360136 */   // Label 32841: @2360136
     /* 2360136 */   GIM_Try, /*On fail goto*//*Label 32842*/ GIMT_Encode4(2360185), // Rule ID 56536 //
     /* 2360141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2360144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360148 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2360151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2360165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360184 */     // GIR_Coverage, 56536,
     /* 2360184 */     GIR_EraseRootFromParent_Done,
     /* 2360185 */   // Label 32842: @2360185
     /* 2360185 */   GIM_Try, /*On fail goto*//*Label 32843*/ GIMT_Encode4(2360234), // Rule ID 56537 //
     /* 2360190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2360193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360197 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2360200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2360214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360233 */     // GIR_Coverage, 56537,
     /* 2360233 */     GIR_EraseRootFromParent_Done,
     /* 2360234 */   // Label 32843: @2360234
     /* 2360234 */   GIM_Reject,
     /* 2360235 */ // Label 32839: @2360235
     /* 2360235 */ GIM_Reject,
     /* 2360236 */ // Label 32735: @2360236
     /* 2360236 */ GIM_Try, /*On fail goto*//*Label 32844*/ GIMT_Encode4(2360486),
     /* 2360241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2360244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2360247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360255 */   GIM_Try, /*On fail goto*//*Label 32845*/ GIMT_Encode4(2360321), // Rule ID 56402 //
     /* 2360260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2360275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360282 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2360285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2360299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360320 */     // GIR_Coverage, 56402,
     /* 2360320 */     GIR_EraseRootFromParent_Done,
     /* 2360321 */   // Label 32845: @2360321
     /* 2360321 */   GIM_Try, /*On fail goto*//*Label 32846*/ GIMT_Encode4(2360387), // Rule ID 56403 //
     /* 2360326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2360341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360348 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2360351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2360365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360386 */     // GIR_Coverage, 56403,
     /* 2360386 */     GIR_EraseRootFromParent_Done,
     /* 2360387 */   // Label 32846: @2360387
     /* 2360387 */   GIM_Try, /*On fail goto*//*Label 32847*/ GIMT_Encode4(2360436), // Rule ID 56396 //
     /* 2360392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360399 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2360402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2360416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360435 */     // GIR_Coverage, 56396,
     /* 2360435 */     GIR_EraseRootFromParent_Done,
     /* 2360436 */   // Label 32847: @2360436
     /* 2360436 */   GIM_Try, /*On fail goto*//*Label 32848*/ GIMT_Encode4(2360485), // Rule ID 56397 //
     /* 2360441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360448 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2360451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2360465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360484 */     // GIR_Coverage, 56397,
     /* 2360484 */     GIR_EraseRootFromParent_Done,
     /* 2360485 */   // Label 32848: @2360485
     /* 2360485 */   GIM_Reject,
     /* 2360486 */ // Label 32844: @2360486
     /* 2360486 */ GIM_Reject,
     /* 2360487 */ // Label 32736: @2360487
     /* 2360487 */ GIM_Try, /*On fail goto*//*Label 32849*/ GIMT_Encode4(2360737),
     /* 2360492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2360495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2360498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360506 */   GIM_Try, /*On fail goto*//*Label 32850*/ GIMT_Encode4(2360572), // Rule ID 56482 //
     /* 2360511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2360514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2360526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360533 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2360536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2360550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360571 */     // GIR_Coverage, 56482,
     /* 2360571 */     GIR_EraseRootFromParent_Done,
     /* 2360572 */   // Label 32850: @2360572
     /* 2360572 */   GIM_Try, /*On fail goto*//*Label 32851*/ GIMT_Encode4(2360638), // Rule ID 56483 //
     /* 2360577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2360580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2360592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360599 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2360602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2360616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360637 */     // GIR_Coverage, 56483,
     /* 2360637 */     GIR_EraseRootFromParent_Done,
     /* 2360638 */   // Label 32851: @2360638
     /* 2360638 */   GIM_Try, /*On fail goto*//*Label 32852*/ GIMT_Encode4(2360687), // Rule ID 56476 //
     /* 2360643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2360646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360650 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2360653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2360667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360686 */     // GIR_Coverage, 56476,
     /* 2360686 */     GIR_EraseRootFromParent_Done,
     /* 2360687 */   // Label 32852: @2360687
     /* 2360687 */   GIM_Try, /*On fail goto*//*Label 32853*/ GIMT_Encode4(2360736), // Rule ID 56477 //
     /* 2360692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2360695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360699 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2360702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2360716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360735 */     // GIR_Coverage, 56477,
     /* 2360735 */     GIR_EraseRootFromParent_Done,
     /* 2360736 */   // Label 32853: @2360736
     /* 2360736 */   GIM_Reject,
     /* 2360737 */ // Label 32849: @2360737
     /* 2360737 */ GIM_Reject,
     /* 2360738 */ // Label 32737: @2360738
     /* 2360738 */ GIM_Try, /*On fail goto*//*Label 32854*/ GIMT_Encode4(2360988),
     /* 2360743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2360746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2360749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360757 */   GIM_Try, /*On fail goto*//*Label 32855*/ GIMT_Encode4(2360823), // Rule ID 56422 //
     /* 2360762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2360777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360784 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2360787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2360801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360822 */     // GIR_Coverage, 56422,
     /* 2360822 */     GIR_EraseRootFromParent_Done,
     /* 2360823 */   // Label 32855: @2360823
     /* 2360823 */   GIM_Try, /*On fail goto*//*Label 32856*/ GIMT_Encode4(2360889), // Rule ID 56423 //
     /* 2360828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2360843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360850 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2360853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2360867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360888 */     // GIR_Coverage, 56423,
     /* 2360888 */     GIR_EraseRootFromParent_Done,
     /* 2360889 */   // Label 32856: @2360889
     /* 2360889 */   GIM_Try, /*On fail goto*//*Label 32857*/ GIMT_Encode4(2360938), // Rule ID 56416 //
     /* 2360894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360901 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2360904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2360918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360937 */     // GIR_Coverage, 56416,
     /* 2360937 */     GIR_EraseRootFromParent_Done,
     /* 2360938 */   // Label 32857: @2360938
     /* 2360938 */   GIM_Try, /*On fail goto*//*Label 32858*/ GIMT_Encode4(2360987), // Rule ID 56417 //
     /* 2360943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360950 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2360953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2360967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360986 */     // GIR_Coverage, 56417,
     /* 2360986 */     GIR_EraseRootFromParent_Done,
     /* 2360987 */   // Label 32858: @2360987
     /* 2360987 */   GIM_Reject,
     /* 2360988 */ // Label 32854: @2360988
     /* 2360988 */ GIM_Reject,
     /* 2360989 */ // Label 32738: @2360989
     /* 2360989 */ GIM_Reject,
     /* 2360990 */ // Label 73: @2360990
     /* 2360990 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32862*/ GIMT_Encode4(2361179),
     /* 2361001 */ /*GILLT_s16*//*Label 32859*/ GIMT_Encode4(2361013),
     /* 2361005 */ /*GILLT_s32*//*Label 32860*/ GIMT_Encode4(2361063),
     /* 2361009 */ /*GILLT_s64*//*Label 32861*/ GIMT_Encode4(2361113),
     /* 2361013 */ // Label 32859: @2361013
     /* 2361013 */ GIM_Try, /*On fail goto*//*Label 32863*/ GIMT_Encode4(2361062),
     /* 2361018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2361021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361029 */   GIM_Try, /*On fail goto*//*Label 32864*/ GIMT_Encode4(2361045), // Rule ID 2074 //
     /* 2361034 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2361034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2361037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361044 */     // GIR_Coverage, 2074,
     /* 2361044 */     GIR_EraseRootFromParent_Done,
     /* 2361045 */   // Label 32864: @2361045
     /* 2361045 */   GIM_Try, /*On fail goto*//*Label 32865*/ GIMT_Encode4(2361061), // Rule ID 2075 //
     /* 2361050 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2361050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2361053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361060 */     // GIR_Coverage, 2075,
     /* 2361060 */     GIR_EraseRootFromParent_Done,
     /* 2361061 */   // Label 32865: @2361061
     /* 2361061 */   GIM_Reject,
     /* 2361062 */ // Label 32863: @2361062
     /* 2361062 */ GIM_Reject,
     /* 2361063 */ // Label 32860: @2361063
     /* 2361063 */ GIM_Try, /*On fail goto*//*Label 32866*/ GIMT_Encode4(2361112),
     /* 2361068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2361071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361079 */   GIM_Try, /*On fail goto*//*Label 32867*/ GIMT_Encode4(2361095), // Rule ID 1361 //
     /* 2361084 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2361084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2361087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361094 */     // GIR_Coverage, 1361,
     /* 2361094 */     GIR_EraseRootFromParent_Done,
     /* 2361095 */   // Label 32867: @2361095
     /* 2361095 */   GIM_Try, /*On fail goto*//*Label 32868*/ GIMT_Encode4(2361111), // Rule ID 1362 //
     /* 2361100 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2361100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2361103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361110 */     // GIR_Coverage, 1362,
     /* 2361110 */     GIR_EraseRootFromParent_Done,
     /* 2361111 */   // Label 32868: @2361111
     /* 2361111 */   GIM_Reject,
     /* 2361112 */ // Label 32866: @2361112
     /* 2361112 */ GIM_Reject,
     /* 2361113 */ // Label 32861: @2361113
     /* 2361113 */ GIM_Try, /*On fail goto*//*Label 32869*/ GIMT_Encode4(2361178),
     /* 2361118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2361121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361129 */   GIM_Try, /*On fail goto*//*Label 32870*/ GIMT_Encode4(2361145), // Rule ID 1738 //
     /* 2361134 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2361134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2361137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361144 */     // GIR_Coverage, 1738,
     /* 2361144 */     GIR_EraseRootFromParent_Done,
     /* 2361145 */   // Label 32870: @2361145
     /* 2361145 */   GIM_Try, /*On fail goto*//*Label 32871*/ GIMT_Encode4(2361161), // Rule ID 1739 //
     /* 2361150 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2361150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2361153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361160 */     // GIR_Coverage, 1739,
     /* 2361160 */     GIR_EraseRootFromParent_Done,
     /* 2361161 */   // Label 32871: @2361161
     /* 2361161 */   GIM_Try, /*On fail goto*//*Label 32872*/ GIMT_Encode4(2361177), // Rule ID 1740 //
     /* 2361166 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2361166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2361169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361176 */     // GIR_Coverage, 1740,
     /* 2361176 */     GIR_EraseRootFromParent_Done,
     /* 2361177 */   // Label 32872: @2361177
     /* 2361177 */   GIM_Reject,
     /* 2361178 */ // Label 32869: @2361178
     /* 2361178 */ GIM_Reject,
     /* 2361179 */ // Label 32862: @2361179
     /* 2361179 */ GIM_Reject,
     /* 2361180 */ // Label 74: @2361180
     /* 2361180 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32891*/ GIMT_Encode4(2363264),
     /* 2361191 */ /*GILLT_s16*//*Label 32873*/ GIMT_Encode4(2361311),
     /* 2361195 */ /*GILLT_s32*//*Label 32874*/ GIMT_Encode4(2361378),
     /* 2361199 */ /*GILLT_s64*//*Label 32875*/ GIMT_Encode4(2361445), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361211 */ /*GILLT_nxv1s16*//*Label 32876*/ GIMT_Encode4(2361539),
     /* 2361215 */ /*GILLT_nxv1s32*//*Label 32877*/ GIMT_Encode4(2361654),
     /* 2361219 */ /*GILLT_nxv1s64*//*Label 32878*/ GIMT_Encode4(2361769), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361231 */ /*GILLT_nxv2s16*//*Label 32879*/ GIMT_Encode4(2361884),
     /* 2361235 */ /*GILLT_nxv2s32*//*Label 32880*/ GIMT_Encode4(2361999),
     /* 2361239 */ /*GILLT_nxv2s64*//*Label 32881*/ GIMT_Encode4(2362114), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361251 */ /*GILLT_nxv4s16*//*Label 32882*/ GIMT_Encode4(2362229),
     /* 2361255 */ /*GILLT_nxv4s32*//*Label 32883*/ GIMT_Encode4(2362344),
     /* 2361259 */ /*GILLT_nxv4s64*//*Label 32884*/ GIMT_Encode4(2362459), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361271 */ /*GILLT_nxv8s16*//*Label 32885*/ GIMT_Encode4(2362574),
     /* 2361275 */ /*GILLT_nxv8s32*//*Label 32886*/ GIMT_Encode4(2362689),
     /* 2361279 */ /*GILLT_nxv8s64*//*Label 32887*/ GIMT_Encode4(2362804), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361291 */ /*GILLT_nxv16s16*//*Label 32888*/ GIMT_Encode4(2362919),
     /* 2361295 */ /*GILLT_nxv16s32*//*Label 32889*/ GIMT_Encode4(2363034), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361307 */ /*GILLT_nxv32s16*//*Label 32890*/ GIMT_Encode4(2363149),
     /* 2361311 */ // Label 32873: @2361311
     /* 2361311 */ GIM_Try, /*On fail goto*//*Label 32892*/ GIMT_Encode4(2361377),
     /* 2361316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2361319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2361322 */   GIM_Try, /*On fail goto*//*Label 32893*/ GIMT_Encode4(2361349), // Rule ID 2062 //
     /* 2361327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2361330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361342 */     // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2361342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2361347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361348 */     // GIR_Coverage, 2062,
     /* 2361348 */     GIR_Done,
     /* 2361349 */   // Label 32893: @2361349
     /* 2361349 */   GIM_Try, /*On fail goto*//*Label 32894*/ GIMT_Encode4(2361376), // Rule ID 2063 //
     /* 2361354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2361357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2361361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2361365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2361369 */     // (fminnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2361369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2361374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361375 */     // GIR_Coverage, 2063,
     /* 2361375 */     GIR_Done,
     /* 2361376 */   // Label 32894: @2361376
     /* 2361376 */   GIM_Reject,
     /* 2361377 */ // Label 32892: @2361377
     /* 2361377 */ GIM_Reject,
     /* 2361378 */ // Label 32874: @2361378
     /* 2361378 */ GIM_Try, /*On fail goto*//*Label 32895*/ GIMT_Encode4(2361444),
     /* 2361383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2361386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2361389 */   GIM_Try, /*On fail goto*//*Label 32896*/ GIMT_Encode4(2361416), // Rule ID 1349 //
     /* 2361394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2361397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361409 */     // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2361409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2361414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361415 */     // GIR_Coverage, 1349,
     /* 2361415 */     GIR_Done,
     /* 2361416 */   // Label 32896: @2361416
     /* 2361416 */   GIM_Try, /*On fail goto*//*Label 32897*/ GIMT_Encode4(2361443), // Rule ID 1350 //
     /* 2361421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2361424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2361428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2361432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2361436 */     // (fminnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2361436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2361441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361442 */     // GIR_Coverage, 1350,
     /* 2361442 */     GIR_Done,
     /* 2361443 */   // Label 32897: @2361443
     /* 2361443 */   GIM_Reject,
     /* 2361444 */ // Label 32895: @2361444
     /* 2361444 */ GIM_Reject,
     /* 2361445 */ // Label 32875: @2361445
     /* 2361445 */ GIM_Try, /*On fail goto*//*Label 32898*/ GIMT_Encode4(2361538),
     /* 2361450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2361453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2361456 */   GIM_Try, /*On fail goto*//*Label 32899*/ GIMT_Encode4(2361483), // Rule ID 1720 //
     /* 2361461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2361464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361476 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2361476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2361481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361482 */     // GIR_Coverage, 1720,
     /* 2361482 */     GIR_Done,
     /* 2361483 */   // Label 32899: @2361483
     /* 2361483 */   GIM_Try, /*On fail goto*//*Label 32900*/ GIMT_Encode4(2361510), // Rule ID 1721 //
     /* 2361488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2361491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2361495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2361499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2361503 */     // (fminnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2361503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2361508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361509 */     // GIR_Coverage, 1721,
     /* 2361509 */     GIR_Done,
     /* 2361510 */   // Label 32900: @2361510
     /* 2361510 */   GIM_Try, /*On fail goto*//*Label 32901*/ GIMT_Encode4(2361537), // Rule ID 1722 //
     /* 2361515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2361518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361530 */     // (fminnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2361530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2361535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361536 */     // GIR_Coverage, 1722,
     /* 2361536 */     GIR_Done,
     /* 2361537 */   // Label 32901: @2361537
     /* 2361537 */   GIM_Reject,
     /* 2361538 */ // Label 32898: @2361538
     /* 2361538 */ GIM_Reject,
     /* 2361539 */ // Label 32876: @2361539
     /* 2361539 */ GIM_Try, /*On fail goto*//*Label 32902*/ GIMT_Encode4(2361653),
     /* 2361544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2361547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2361550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361562 */   GIM_Try, /*On fail goto*//*Label 32903*/ GIMT_Encode4(2361607), // Rule ID 45764 //
     /* 2361567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361570 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2361573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2361587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361606 */     // GIR_Coverage, 45764,
     /* 2361606 */     GIR_EraseRootFromParent_Done,
     /* 2361607 */   // Label 32903: @2361607
     /* 2361607 */   GIM_Try, /*On fail goto*//*Label 32904*/ GIMT_Encode4(2361652), // Rule ID 45765 //
     /* 2361612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361615 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2361618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2361632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361651 */     // GIR_Coverage, 45765,
     /* 2361651 */     GIR_EraseRootFromParent_Done,
     /* 2361652 */   // Label 32904: @2361652
     /* 2361652 */   GIM_Reject,
     /* 2361653 */ // Label 32902: @2361653
     /* 2361653 */ GIM_Reject,
     /* 2361654 */ // Label 32877: @2361654
     /* 2361654 */ GIM_Try, /*On fail goto*//*Label 32905*/ GIMT_Encode4(2361768),
     /* 2361659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2361662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2361665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361677 */   GIM_Try, /*On fail goto*//*Label 32906*/ GIMT_Encode4(2361722), // Rule ID 56554 //
     /* 2361682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2361685 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2361688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2361702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361721 */     // GIR_Coverage, 56554,
     /* 2361721 */     GIR_EraseRootFromParent_Done,
     /* 2361722 */   // Label 32906: @2361722
     /* 2361722 */   GIM_Try, /*On fail goto*//*Label 32907*/ GIMT_Encode4(2361767), // Rule ID 56555 //
     /* 2361727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2361730 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2361733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2361747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361766 */     // GIR_Coverage, 56555,
     /* 2361766 */     GIR_EraseRootFromParent_Done,
     /* 2361767 */   // Label 32907: @2361767
     /* 2361767 */   GIM_Reject,
     /* 2361768 */ // Label 32905: @2361768
     /* 2361768 */ GIM_Reject,
     /* 2361769 */ // Label 32878: @2361769
     /* 2361769 */ GIM_Try, /*On fail goto*//*Label 32908*/ GIMT_Encode4(2361883),
     /* 2361774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2361777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2361780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361792 */   GIM_Try, /*On fail goto*//*Label 32909*/ GIMT_Encode4(2361837), // Rule ID 56572 //
     /* 2361797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2361800 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2361803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2361817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361836 */     // GIR_Coverage, 56572,
     /* 2361836 */     GIR_EraseRootFromParent_Done,
     /* 2361837 */   // Label 32909: @2361837
     /* 2361837 */   GIM_Try, /*On fail goto*//*Label 32910*/ GIMT_Encode4(2361882), // Rule ID 56573 //
     /* 2361842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2361845 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2361848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2361862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361881 */     // GIR_Coverage, 56573,
     /* 2361881 */     GIR_EraseRootFromParent_Done,
     /* 2361882 */   // Label 32910: @2361882
     /* 2361882 */   GIM_Reject,
     /* 2361883 */ // Label 32908: @2361883
     /* 2361883 */ GIM_Reject,
     /* 2361884 */ // Label 32879: @2361884
     /* 2361884 */ GIM_Try, /*On fail goto*//*Label 32911*/ GIMT_Encode4(2361998),
     /* 2361889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2361892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2361895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361907 */   GIM_Try, /*On fail goto*//*Label 32912*/ GIMT_Encode4(2361952), // Rule ID 56548 //
     /* 2361912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361915 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2361918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2361932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361951 */     // GIR_Coverage, 56548,
     /* 2361951 */     GIR_EraseRootFromParent_Done,
     /* 2361952 */   // Label 32912: @2361952
     /* 2361952 */   GIM_Try, /*On fail goto*//*Label 32913*/ GIMT_Encode4(2361997), // Rule ID 56549 //
     /* 2361957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361960 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2361963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2361977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361996 */     // GIR_Coverage, 56549,
     /* 2361996 */     GIR_EraseRootFromParent_Done,
     /* 2361997 */   // Label 32913: @2361997
     /* 2361997 */   GIM_Reject,
     /* 2361998 */ // Label 32911: @2361998
     /* 2361998 */ GIM_Reject,
     /* 2361999 */ // Label 32880: @2361999
     /* 2361999 */ GIM_Try, /*On fail goto*//*Label 32914*/ GIMT_Encode4(2362113),
     /* 2362004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2362007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2362010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362022 */   GIM_Try, /*On fail goto*//*Label 32915*/ GIMT_Encode4(2362067), // Rule ID 56566 //
     /* 2362027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362030 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2362033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2362047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362066 */     // GIR_Coverage, 56566,
     /* 2362066 */     GIR_EraseRootFromParent_Done,
     /* 2362067 */   // Label 32915: @2362067
     /* 2362067 */   GIM_Try, /*On fail goto*//*Label 32916*/ GIMT_Encode4(2362112), // Rule ID 56567 //
     /* 2362072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362075 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2362078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2362092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362111 */     // GIR_Coverage, 56567,
     /* 2362111 */     GIR_EraseRootFromParent_Done,
     /* 2362112 */   // Label 32916: @2362112
     /* 2362112 */   GIM_Reject,
     /* 2362113 */ // Label 32914: @2362113
     /* 2362113 */ GIM_Reject,
     /* 2362114 */ // Label 32881: @2362114
     /* 2362114 */ GIM_Try, /*On fail goto*//*Label 32917*/ GIMT_Encode4(2362228),
     /* 2362119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2362122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2362125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362137 */   GIM_Try, /*On fail goto*//*Label 32918*/ GIMT_Encode4(2362182), // Rule ID 56614 //
     /* 2362142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362145 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2362148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2362162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362181 */     // GIR_Coverage, 56614,
     /* 2362181 */     GIR_EraseRootFromParent_Done,
     /* 2362182 */   // Label 32918: @2362182
     /* 2362182 */   GIM_Try, /*On fail goto*//*Label 32919*/ GIMT_Encode4(2362227), // Rule ID 56615 //
     /* 2362187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362190 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2362193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2362207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362226 */     // GIR_Coverage, 56615,
     /* 2362226 */     GIR_EraseRootFromParent_Done,
     /* 2362227 */   // Label 32919: @2362227
     /* 2362227 */   GIM_Reject,
     /* 2362228 */ // Label 32917: @2362228
     /* 2362228 */ GIM_Reject,
     /* 2362229 */ // Label 32882: @2362229
     /* 2362229 */ GIM_Try, /*On fail goto*//*Label 32920*/ GIMT_Encode4(2362343),
     /* 2362234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2362237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2362240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362252 */   GIM_Try, /*On fail goto*//*Label 32921*/ GIMT_Encode4(2362297), // Rule ID 56560 //
     /* 2362257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362260 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2362263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2362277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362296 */     // GIR_Coverage, 56560,
     /* 2362296 */     GIR_EraseRootFromParent_Done,
     /* 2362297 */   // Label 32921: @2362297
     /* 2362297 */   GIM_Try, /*On fail goto*//*Label 32922*/ GIMT_Encode4(2362342), // Rule ID 56561 //
     /* 2362302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2362305 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2362308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2362322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362341 */     // GIR_Coverage, 56561,
     /* 2362341 */     GIR_EraseRootFromParent_Done,
     /* 2362342 */   // Label 32922: @2362342
     /* 2362342 */   GIM_Reject,
     /* 2362343 */ // Label 32920: @2362343
     /* 2362343 */ GIM_Reject,
     /* 2362344 */ // Label 32883: @2362344
     /* 2362344 */ GIM_Try, /*On fail goto*//*Label 32923*/ GIMT_Encode4(2362458),
     /* 2362349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2362352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2362355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362367 */   GIM_Try, /*On fail goto*//*Label 32924*/ GIMT_Encode4(2362412), // Rule ID 56596 //
     /* 2362372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362375 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2362378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2362392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362411 */     // GIR_Coverage, 56596,
     /* 2362411 */     GIR_EraseRootFromParent_Done,
     /* 2362412 */   // Label 32924: @2362412
     /* 2362412 */   GIM_Try, /*On fail goto*//*Label 32925*/ GIMT_Encode4(2362457), // Rule ID 56597 //
     /* 2362417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362420 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2362423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2362437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362456 */     // GIR_Coverage, 56597,
     /* 2362456 */     GIR_EraseRootFromParent_Done,
     /* 2362457 */   // Label 32925: @2362457
     /* 2362457 */   GIM_Reject,
     /* 2362458 */ // Label 32923: @2362458
     /* 2362458 */ GIM_Reject,
     /* 2362459 */ // Label 32884: @2362459
     /* 2362459 */ GIM_Try, /*On fail goto*//*Label 32926*/ GIMT_Encode4(2362573),
     /* 2362464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2362467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2362470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362482 */   GIM_Try, /*On fail goto*//*Label 32927*/ GIMT_Encode4(2362527), // Rule ID 56620 //
     /* 2362487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362490 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2362493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2362507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362526 */     // GIR_Coverage, 56620,
     /* 2362526 */     GIR_EraseRootFromParent_Done,
     /* 2362527 */   // Label 32927: @2362527
     /* 2362527 */   GIM_Try, /*On fail goto*//*Label 32928*/ GIMT_Encode4(2362572), // Rule ID 56621 //
     /* 2362532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362535 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2362538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2362552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362571 */     // GIR_Coverage, 56621,
     /* 2362571 */     GIR_EraseRootFromParent_Done,
     /* 2362572 */   // Label 32928: @2362572
     /* 2362572 */   GIM_Reject,
     /* 2362573 */ // Label 32926: @2362573
     /* 2362573 */ GIM_Reject,
     /* 2362574 */ // Label 32885: @2362574
     /* 2362574 */ GIM_Try, /*On fail goto*//*Label 32929*/ GIMT_Encode4(2362688),
     /* 2362579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2362582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2362585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362597 */   GIM_Try, /*On fail goto*//*Label 32930*/ GIMT_Encode4(2362642), // Rule ID 56578 //
     /* 2362602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362605 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2362608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2362622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362641 */     // GIR_Coverage, 56578,
     /* 2362641 */     GIR_EraseRootFromParent_Done,
     /* 2362642 */   // Label 32930: @2362642
     /* 2362642 */   GIM_Try, /*On fail goto*//*Label 32931*/ GIMT_Encode4(2362687), // Rule ID 56579 //
     /* 2362647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2362650 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2362653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2362667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362686 */     // GIR_Coverage, 56579,
     /* 2362686 */     GIR_EraseRootFromParent_Done,
     /* 2362687 */   // Label 32931: @2362687
     /* 2362687 */   GIM_Reject,
     /* 2362688 */ // Label 32929: @2362688
     /* 2362688 */ GIM_Reject,
     /* 2362689 */ // Label 32886: @2362689
     /* 2362689 */ GIM_Try, /*On fail goto*//*Label 32932*/ GIMT_Encode4(2362803),
     /* 2362694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2362697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2362700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362712 */   GIM_Try, /*On fail goto*//*Label 32933*/ GIMT_Encode4(2362757), // Rule ID 56602 //
     /* 2362717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362720 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2362723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2362737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362756 */     // GIR_Coverage, 56602,
     /* 2362756 */     GIR_EraseRootFromParent_Done,
     /* 2362757 */   // Label 32933: @2362757
     /* 2362757 */   GIM_Try, /*On fail goto*//*Label 32934*/ GIMT_Encode4(2362802), // Rule ID 56603 //
     /* 2362762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362765 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2362768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2362782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362801 */     // GIR_Coverage, 56603,
     /* 2362801 */     GIR_EraseRootFromParent_Done,
     /* 2362802 */   // Label 32934: @2362802
     /* 2362802 */   GIM_Reject,
     /* 2362803 */ // Label 32932: @2362803
     /* 2362803 */ GIM_Reject,
     /* 2362804 */ // Label 32887: @2362804
     /* 2362804 */ GIM_Try, /*On fail goto*//*Label 32935*/ GIMT_Encode4(2362918),
     /* 2362809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2362812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2362815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362827 */   GIM_Try, /*On fail goto*//*Label 32936*/ GIMT_Encode4(2362872), // Rule ID 56626 //
     /* 2362832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362835 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2362838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2362852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362871 */     // GIR_Coverage, 56626,
     /* 2362871 */     GIR_EraseRootFromParent_Done,
     /* 2362872 */   // Label 32936: @2362872
     /* 2362872 */   GIM_Try, /*On fail goto*//*Label 32937*/ GIMT_Encode4(2362917), // Rule ID 56627 //
     /* 2362877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362880 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2362883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2362897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362916 */     // GIR_Coverage, 56627,
     /* 2362916 */     GIR_EraseRootFromParent_Done,
     /* 2362917 */   // Label 32937: @2362917
     /* 2362917 */   GIM_Reject,
     /* 2362918 */ // Label 32935: @2362918
     /* 2362918 */ GIM_Reject,
     /* 2362919 */ // Label 32888: @2362919
     /* 2362919 */ GIM_Try, /*On fail goto*//*Label 32938*/ GIMT_Encode4(2363033),
     /* 2362924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2362927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2362930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362942 */   GIM_Try, /*On fail goto*//*Label 32939*/ GIMT_Encode4(2362987), // Rule ID 56584 //
     /* 2362947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362950 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2362953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2362967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362986 */     // GIR_Coverage, 56584,
     /* 2362986 */     GIR_EraseRootFromParent_Done,
     /* 2362987 */   // Label 32939: @2362987
     /* 2362987 */   GIM_Try, /*On fail goto*//*Label 32940*/ GIMT_Encode4(2363032), // Rule ID 56585 //
     /* 2362992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2362995 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2362998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2363012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363031 */     // GIR_Coverage, 56585,
     /* 2363031 */     GIR_EraseRootFromParent_Done,
     /* 2363032 */   // Label 32940: @2363032
     /* 2363032 */   GIM_Reject,
     /* 2363033 */ // Label 32938: @2363033
     /* 2363033 */ GIM_Reject,
     /* 2363034 */ // Label 32889: @2363034
     /* 2363034 */ GIM_Try, /*On fail goto*//*Label 32941*/ GIMT_Encode4(2363148),
     /* 2363039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2363042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2363045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363057 */   GIM_Try, /*On fail goto*//*Label 32942*/ GIMT_Encode4(2363102), // Rule ID 56608 //
     /* 2363062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2363065 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2363068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2363082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363101 */     // GIR_Coverage, 56608,
     /* 2363101 */     GIR_EraseRootFromParent_Done,
     /* 2363102 */   // Label 32942: @2363102
     /* 2363102 */   GIM_Try, /*On fail goto*//*Label 32943*/ GIMT_Encode4(2363147), // Rule ID 56609 //
     /* 2363107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2363110 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2363113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2363127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363146 */     // GIR_Coverage, 56609,
     /* 2363146 */     GIR_EraseRootFromParent_Done,
     /* 2363147 */   // Label 32943: @2363147
     /* 2363147 */   GIM_Reject,
     /* 2363148 */ // Label 32941: @2363148
     /* 2363148 */ GIM_Reject,
     /* 2363149 */ // Label 32890: @2363149
     /* 2363149 */ GIM_Try, /*On fail goto*//*Label 32944*/ GIMT_Encode4(2363263),
     /* 2363154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2363157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2363160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363172 */   GIM_Try, /*On fail goto*//*Label 32945*/ GIMT_Encode4(2363217), // Rule ID 56590 //
     /* 2363177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363180 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2363183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2363197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363216 */     // GIR_Coverage, 56590,
     /* 2363216 */     GIR_EraseRootFromParent_Done,
     /* 2363217 */   // Label 32945: @2363217
     /* 2363217 */   GIM_Try, /*On fail goto*//*Label 32946*/ GIMT_Encode4(2363262), // Rule ID 56591 //
     /* 2363222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363225 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2363228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2363242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363261 */     // GIR_Coverage, 56591,
     /* 2363261 */     GIR_EraseRootFromParent_Done,
     /* 2363262 */   // Label 32946: @2363262
     /* 2363262 */   GIM_Reject,
     /* 2363263 */ // Label 32944: @2363263
     /* 2363263 */ GIM_Reject,
     /* 2363264 */ // Label 32891: @2363264
     /* 2363264 */ GIM_Reject,
     /* 2363265 */ // Label 75: @2363265
     /* 2363265 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32965*/ GIMT_Encode4(2365349),
     /* 2363276 */ /*GILLT_s16*//*Label 32947*/ GIMT_Encode4(2363396),
     /* 2363280 */ /*GILLT_s32*//*Label 32948*/ GIMT_Encode4(2363463),
     /* 2363284 */ /*GILLT_s64*//*Label 32949*/ GIMT_Encode4(2363530), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2363296 */ /*GILLT_nxv1s16*//*Label 32950*/ GIMT_Encode4(2363624),
     /* 2363300 */ /*GILLT_nxv1s32*//*Label 32951*/ GIMT_Encode4(2363739),
     /* 2363304 */ /*GILLT_nxv1s64*//*Label 32952*/ GIMT_Encode4(2363854), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2363316 */ /*GILLT_nxv2s16*//*Label 32953*/ GIMT_Encode4(2363969),
     /* 2363320 */ /*GILLT_nxv2s32*//*Label 32954*/ GIMT_Encode4(2364084),
     /* 2363324 */ /*GILLT_nxv2s64*//*Label 32955*/ GIMT_Encode4(2364199), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2363336 */ /*GILLT_nxv4s16*//*Label 32956*/ GIMT_Encode4(2364314),
     /* 2363340 */ /*GILLT_nxv4s32*//*Label 32957*/ GIMT_Encode4(2364429),
     /* 2363344 */ /*GILLT_nxv4s64*//*Label 32958*/ GIMT_Encode4(2364544), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2363356 */ /*GILLT_nxv8s16*//*Label 32959*/ GIMT_Encode4(2364659),
     /* 2363360 */ /*GILLT_nxv8s32*//*Label 32960*/ GIMT_Encode4(2364774),
     /* 2363364 */ /*GILLT_nxv8s64*//*Label 32961*/ GIMT_Encode4(2364889), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2363376 */ /*GILLT_nxv16s16*//*Label 32962*/ GIMT_Encode4(2365004),
     /* 2363380 */ /*GILLT_nxv16s32*//*Label 32963*/ GIMT_Encode4(2365119), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2363392 */ /*GILLT_nxv32s16*//*Label 32964*/ GIMT_Encode4(2365234),
     /* 2363396 */ // Label 32947: @2363396
     /* 2363396 */ GIM_Try, /*On fail goto*//*Label 32966*/ GIMT_Encode4(2363462),
     /* 2363401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2363404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2363407 */   GIM_Try, /*On fail goto*//*Label 32967*/ GIMT_Encode4(2363434), // Rule ID 2064 //
     /* 2363412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2363415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2363419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2363423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2363427 */     // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2363427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2363432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363433 */     // GIR_Coverage, 2064,
     /* 2363433 */     GIR_Done,
     /* 2363434 */   // Label 32967: @2363434
     /* 2363434 */   GIM_Try, /*On fail goto*//*Label 32968*/ GIMT_Encode4(2363461), // Rule ID 2065 //
     /* 2363439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2363442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2363446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2363450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2363454 */     // (fmaxnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2363454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2363459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363460 */     // GIR_Coverage, 2065,
     /* 2363460 */     GIR_Done,
     /* 2363461 */   // Label 32968: @2363461
     /* 2363461 */   GIM_Reject,
     /* 2363462 */ // Label 32966: @2363462
     /* 2363462 */ GIM_Reject,
     /* 2363463 */ // Label 32948: @2363463
     /* 2363463 */ GIM_Try, /*On fail goto*//*Label 32969*/ GIMT_Encode4(2363529),
     /* 2363468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2363471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2363474 */   GIM_Try, /*On fail goto*//*Label 32970*/ GIMT_Encode4(2363501), // Rule ID 1351 //
     /* 2363479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2363482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2363486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2363490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2363494 */     // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2363494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2363499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363500 */     // GIR_Coverage, 1351,
     /* 2363500 */     GIR_Done,
     /* 2363501 */   // Label 32970: @2363501
     /* 2363501 */   GIM_Try, /*On fail goto*//*Label 32971*/ GIMT_Encode4(2363528), // Rule ID 1352 //
     /* 2363506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2363509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2363513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2363517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2363521 */     // (fmaxnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2363521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2363526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363527 */     // GIR_Coverage, 1352,
     /* 2363527 */     GIR_Done,
     /* 2363528 */   // Label 32971: @2363528
     /* 2363528 */   GIM_Reject,
     /* 2363529 */ // Label 32969: @2363529
     /* 2363529 */ GIM_Reject,
     /* 2363530 */ // Label 32949: @2363530
     /* 2363530 */ GIM_Try, /*On fail goto*//*Label 32972*/ GIMT_Encode4(2363623),
     /* 2363535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2363538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2363541 */   GIM_Try, /*On fail goto*//*Label 32973*/ GIMT_Encode4(2363568), // Rule ID 1723 //
     /* 2363546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2363549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2363553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2363557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2363561 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2363561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2363566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363567 */     // GIR_Coverage, 1723,
     /* 2363567 */     GIR_Done,
     /* 2363568 */   // Label 32973: @2363568
     /* 2363568 */   GIM_Try, /*On fail goto*//*Label 32974*/ GIMT_Encode4(2363595), // Rule ID 1724 //
     /* 2363573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2363576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2363580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2363584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2363588 */     // (fmaxnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2363588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2363593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363594 */     // GIR_Coverage, 1724,
     /* 2363594 */     GIR_Done,
     /* 2363595 */   // Label 32974: @2363595
     /* 2363595 */   GIM_Try, /*On fail goto*//*Label 32975*/ GIMT_Encode4(2363622), // Rule ID 1725 //
     /* 2363600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2363603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363615 */     // (fmaxnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2363615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2363620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363621 */     // GIR_Coverage, 1725,
     /* 2363621 */     GIR_Done,
     /* 2363622 */   // Label 32975: @2363622
     /* 2363622 */   GIM_Reject,
     /* 2363623 */ // Label 32972: @2363623
     /* 2363623 */ GIM_Reject,
     /* 2363624 */ // Label 32950: @2363624
     /* 2363624 */ GIM_Try, /*On fail goto*//*Label 32976*/ GIMT_Encode4(2363738),
     /* 2363629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2363632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2363635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363647 */   GIM_Try, /*On fail goto*//*Label 32977*/ GIMT_Encode4(2363692), // Rule ID 56632 //
     /* 2363652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363655 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2363658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2363672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363691 */     // GIR_Coverage, 56632,
     /* 2363691 */     GIR_EraseRootFromParent_Done,
     /* 2363692 */   // Label 32977: @2363692
     /* 2363692 */   GIM_Try, /*On fail goto*//*Label 32978*/ GIMT_Encode4(2363737), // Rule ID 56633 //
     /* 2363697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363700 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2363703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2363717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363736 */     // GIR_Coverage, 56633,
     /* 2363736 */     GIR_EraseRootFromParent_Done,
     /* 2363737 */   // Label 32978: @2363737
     /* 2363737 */   GIM_Reject,
     /* 2363738 */ // Label 32976: @2363738
     /* 2363738 */ GIM_Reject,
     /* 2363739 */ // Label 32951: @2363739
     /* 2363739 */ GIM_Try, /*On fail goto*//*Label 32979*/ GIMT_Encode4(2363853),
     /* 2363744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2363747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2363750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363762 */   GIM_Try, /*On fail goto*//*Label 32980*/ GIMT_Encode4(2363807), // Rule ID 56644 //
     /* 2363767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2363770 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2363773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2363787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363806 */     // GIR_Coverage, 56644,
     /* 2363806 */     GIR_EraseRootFromParent_Done,
     /* 2363807 */   // Label 32980: @2363807
     /* 2363807 */   GIM_Try, /*On fail goto*//*Label 32981*/ GIMT_Encode4(2363852), // Rule ID 56645 //
     /* 2363812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2363815 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2363818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2363832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363851 */     // GIR_Coverage, 56645,
     /* 2363851 */     GIR_EraseRootFromParent_Done,
     /* 2363852 */   // Label 32981: @2363852
     /* 2363852 */   GIM_Reject,
     /* 2363853 */ // Label 32979: @2363853
     /* 2363853 */ GIM_Reject,
     /* 2363854 */ // Label 32952: @2363854
     /* 2363854 */ GIM_Try, /*On fail goto*//*Label 32982*/ GIMT_Encode4(2363968),
     /* 2363859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2363862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2363865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363877 */   GIM_Try, /*On fail goto*//*Label 32983*/ GIMT_Encode4(2363922), // Rule ID 56662 //
     /* 2363882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2363885 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2363888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2363902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363921 */     // GIR_Coverage, 56662,
     /* 2363921 */     GIR_EraseRootFromParent_Done,
     /* 2363922 */   // Label 32983: @2363922
     /* 2363922 */   GIM_Try, /*On fail goto*//*Label 32984*/ GIMT_Encode4(2363967), // Rule ID 56663 //
     /* 2363927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2363930 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2363933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2363947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363966 */     // GIR_Coverage, 56663,
     /* 2363966 */     GIR_EraseRootFromParent_Done,
     /* 2363967 */   // Label 32984: @2363967
     /* 2363967 */   GIM_Reject,
     /* 2363968 */ // Label 32982: @2363968
     /* 2363968 */ GIM_Reject,
     /* 2363969 */ // Label 32953: @2363969
     /* 2363969 */ GIM_Try, /*On fail goto*//*Label 32985*/ GIMT_Encode4(2364083),
     /* 2363974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2363977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2363980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363992 */   GIM_Try, /*On fail goto*//*Label 32986*/ GIMT_Encode4(2364037), // Rule ID 56638 //
     /* 2363997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2364000 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2364003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2364017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364036 */     // GIR_Coverage, 56638,
     /* 2364036 */     GIR_EraseRootFromParent_Done,
     /* 2364037 */   // Label 32986: @2364037
     /* 2364037 */   GIM_Try, /*On fail goto*//*Label 32987*/ GIMT_Encode4(2364082), // Rule ID 56639 //
     /* 2364042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2364045 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2364048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2364062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364081 */     // GIR_Coverage, 56639,
     /* 2364081 */     GIR_EraseRootFromParent_Done,
     /* 2364082 */   // Label 32987: @2364082
     /* 2364082 */   GIM_Reject,
     /* 2364083 */ // Label 32985: @2364083
     /* 2364083 */ GIM_Reject,
     /* 2364084 */ // Label 32954: @2364084
     /* 2364084 */ GIM_Try, /*On fail goto*//*Label 32988*/ GIMT_Encode4(2364198),
     /* 2364089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2364092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2364095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364107 */   GIM_Try, /*On fail goto*//*Label 32989*/ GIMT_Encode4(2364152), // Rule ID 56656 //
     /* 2364112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2364115 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2364118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2364132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364151 */     // GIR_Coverage, 56656,
     /* 2364151 */     GIR_EraseRootFromParent_Done,
     /* 2364152 */   // Label 32989: @2364152
     /* 2364152 */   GIM_Try, /*On fail goto*//*Label 32990*/ GIMT_Encode4(2364197), // Rule ID 56657 //
     /* 2364157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2364160 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2364163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2364177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364196 */     // GIR_Coverage, 56657,
     /* 2364196 */     GIR_EraseRootFromParent_Done,
     /* 2364197 */   // Label 32990: @2364197
     /* 2364197 */   GIM_Reject,
     /* 2364198 */ // Label 32988: @2364198
     /* 2364198 */ GIM_Reject,
     /* 2364199 */ // Label 32955: @2364199
     /* 2364199 */ GIM_Try, /*On fail goto*//*Label 32991*/ GIMT_Encode4(2364313),
     /* 2364204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2364207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2364210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364222 */   GIM_Try, /*On fail goto*//*Label 32992*/ GIMT_Encode4(2364267), // Rule ID 56704 //
     /* 2364227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2364230 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2364233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2364247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364266 */     // GIR_Coverage, 56704,
     /* 2364266 */     GIR_EraseRootFromParent_Done,
     /* 2364267 */   // Label 32992: @2364267
     /* 2364267 */   GIM_Try, /*On fail goto*//*Label 32993*/ GIMT_Encode4(2364312), // Rule ID 56705 //
     /* 2364272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2364275 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2364278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2364292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364311 */     // GIR_Coverage, 56705,
     /* 2364311 */     GIR_EraseRootFromParent_Done,
     /* 2364312 */   // Label 32993: @2364312
     /* 2364312 */   GIM_Reject,
     /* 2364313 */ // Label 32991: @2364313
     /* 2364313 */ GIM_Reject,
     /* 2364314 */ // Label 32956: @2364314
     /* 2364314 */ GIM_Try, /*On fail goto*//*Label 32994*/ GIMT_Encode4(2364428),
     /* 2364319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2364322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2364325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364337 */   GIM_Try, /*On fail goto*//*Label 32995*/ GIMT_Encode4(2364382), // Rule ID 56650 //
     /* 2364342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2364345 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2364348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2364362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364381 */     // GIR_Coverage, 56650,
     /* 2364381 */     GIR_EraseRootFromParent_Done,
     /* 2364382 */   // Label 32995: @2364382
     /* 2364382 */   GIM_Try, /*On fail goto*//*Label 32996*/ GIMT_Encode4(2364427), // Rule ID 56651 //
     /* 2364387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2364390 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2364393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2364407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364426 */     // GIR_Coverage, 56651,
     /* 2364426 */     GIR_EraseRootFromParent_Done,
     /* 2364427 */   // Label 32996: @2364427
     /* 2364427 */   GIM_Reject,
     /* 2364428 */ // Label 32994: @2364428
     /* 2364428 */ GIM_Reject,
     /* 2364429 */ // Label 32957: @2364429
     /* 2364429 */ GIM_Try, /*On fail goto*//*Label 32997*/ GIMT_Encode4(2364543),
     /* 2364434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2364437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2364440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364452 */   GIM_Try, /*On fail goto*//*Label 32998*/ GIMT_Encode4(2364497), // Rule ID 56686 //
     /* 2364457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2364460 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2364463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2364477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364496 */     // GIR_Coverage, 56686,
     /* 2364496 */     GIR_EraseRootFromParent_Done,
     /* 2364497 */   // Label 32998: @2364497
     /* 2364497 */   GIM_Try, /*On fail goto*//*Label 32999*/ GIMT_Encode4(2364542), // Rule ID 56687 //
     /* 2364502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2364505 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2364508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2364522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364541 */     // GIR_Coverage, 56687,
     /* 2364541 */     GIR_EraseRootFromParent_Done,
     /* 2364542 */   // Label 32999: @2364542
     /* 2364542 */   GIM_Reject,
     /* 2364543 */ // Label 32997: @2364543
     /* 2364543 */ GIM_Reject,
     /* 2364544 */ // Label 32958: @2364544
     /* 2364544 */ GIM_Try, /*On fail goto*//*Label 33000*/ GIMT_Encode4(2364658),
     /* 2364549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2364552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2364555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364567 */   GIM_Try, /*On fail goto*//*Label 33001*/ GIMT_Encode4(2364612), // Rule ID 56710 //
     /* 2364572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2364575 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2364578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2364592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364611 */     // GIR_Coverage, 56710,
     /* 2364611 */     GIR_EraseRootFromParent_Done,
     /* 2364612 */   // Label 33001: @2364612
     /* 2364612 */   GIM_Try, /*On fail goto*//*Label 33002*/ GIMT_Encode4(2364657), // Rule ID 56711 //
     /* 2364617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2364620 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2364623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2364637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364656 */     // GIR_Coverage, 56711,
     /* 2364656 */     GIR_EraseRootFromParent_Done,
     /* 2364657 */   // Label 33002: @2364657
     /* 2364657 */   GIM_Reject,
     /* 2364658 */ // Label 33000: @2364658
     /* 2364658 */ GIM_Reject,
     /* 2364659 */ // Label 32959: @2364659
     /* 2364659 */ GIM_Try, /*On fail goto*//*Label 33003*/ GIMT_Encode4(2364773),
     /* 2364664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2364667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2364670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364682 */   GIM_Try, /*On fail goto*//*Label 33004*/ GIMT_Encode4(2364727), // Rule ID 56668 //
     /* 2364687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2364690 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2364693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2364707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364726 */     // GIR_Coverage, 56668,
     /* 2364726 */     GIR_EraseRootFromParent_Done,
     /* 2364727 */   // Label 33004: @2364727
     /* 2364727 */   GIM_Try, /*On fail goto*//*Label 33005*/ GIMT_Encode4(2364772), // Rule ID 56669 //
     /* 2364732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2364735 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2364738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2364752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364771 */     // GIR_Coverage, 56669,
     /* 2364771 */     GIR_EraseRootFromParent_Done,
     /* 2364772 */   // Label 33005: @2364772
     /* 2364772 */   GIM_Reject,
     /* 2364773 */ // Label 33003: @2364773
     /* 2364773 */ GIM_Reject,
     /* 2364774 */ // Label 32960: @2364774
     /* 2364774 */ GIM_Try, /*On fail goto*//*Label 33006*/ GIMT_Encode4(2364888),
     /* 2364779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2364782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2364785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364797 */   GIM_Try, /*On fail goto*//*Label 33007*/ GIMT_Encode4(2364842), // Rule ID 56692 //
     /* 2364802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2364805 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2364808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2364822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364841 */     // GIR_Coverage, 56692,
     /* 2364841 */     GIR_EraseRootFromParent_Done,
     /* 2364842 */   // Label 33007: @2364842
     /* 2364842 */   GIM_Try, /*On fail goto*//*Label 33008*/ GIMT_Encode4(2364887), // Rule ID 56693 //
     /* 2364847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2364850 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2364853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2364867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364886 */     // GIR_Coverage, 56693,
     /* 2364886 */     GIR_EraseRootFromParent_Done,
     /* 2364887 */   // Label 33008: @2364887
     /* 2364887 */   GIM_Reject,
     /* 2364888 */ // Label 33006: @2364888
     /* 2364888 */ GIM_Reject,
     /* 2364889 */ // Label 32961: @2364889
     /* 2364889 */ GIM_Try, /*On fail goto*//*Label 33009*/ GIMT_Encode4(2365003),
     /* 2364894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2364897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2364900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2364904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2364908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2364912 */   GIM_Try, /*On fail goto*//*Label 33010*/ GIMT_Encode4(2364957), // Rule ID 56716 //
     /* 2364917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2364920 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2364923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2364937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364956 */     // GIR_Coverage, 56716,
     /* 2364956 */     GIR_EraseRootFromParent_Done,
     /* 2364957 */   // Label 33010: @2364957
     /* 2364957 */   GIM_Try, /*On fail goto*//*Label 33011*/ GIMT_Encode4(2365002), // Rule ID 56717 //
     /* 2364962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2364965 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2364968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2364982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365001 */     // GIR_Coverage, 56717,
     /* 2365001 */     GIR_EraseRootFromParent_Done,
     /* 2365002 */   // Label 33011: @2365002
     /* 2365002 */   GIM_Reject,
     /* 2365003 */ // Label 33009: @2365003
     /* 2365003 */ GIM_Reject,
     /* 2365004 */ // Label 32962: @2365004
     /* 2365004 */ GIM_Try, /*On fail goto*//*Label 33012*/ GIMT_Encode4(2365118),
     /* 2365009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2365012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2365015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365027 */   GIM_Try, /*On fail goto*//*Label 33013*/ GIMT_Encode4(2365072), // Rule ID 56674 //
     /* 2365032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2365035 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2365038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2365052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365071 */     // GIR_Coverage, 56674,
     /* 2365071 */     GIR_EraseRootFromParent_Done,
     /* 2365072 */   // Label 33013: @2365072
     /* 2365072 */   GIM_Try, /*On fail goto*//*Label 33014*/ GIMT_Encode4(2365117), // Rule ID 56675 //
     /* 2365077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2365080 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2365083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2365097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365116 */     // GIR_Coverage, 56675,
     /* 2365116 */     GIR_EraseRootFromParent_Done,
     /* 2365117 */   // Label 33014: @2365117
     /* 2365117 */   GIM_Reject,
     /* 2365118 */ // Label 33012: @2365118
     /* 2365118 */ GIM_Reject,
     /* 2365119 */ // Label 32963: @2365119
     /* 2365119 */ GIM_Try, /*On fail goto*//*Label 33015*/ GIMT_Encode4(2365233),
     /* 2365124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2365127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2365130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365142 */   GIM_Try, /*On fail goto*//*Label 33016*/ GIMT_Encode4(2365187), // Rule ID 56698 //
     /* 2365147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2365150 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2365153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2365167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365186 */     // GIR_Coverage, 56698,
     /* 2365186 */     GIR_EraseRootFromParent_Done,
     /* 2365187 */   // Label 33016: @2365187
     /* 2365187 */   GIM_Try, /*On fail goto*//*Label 33017*/ GIMT_Encode4(2365232), // Rule ID 56699 //
     /* 2365192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2365195 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2365198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2365212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365231 */     // GIR_Coverage, 56699,
     /* 2365231 */     GIR_EraseRootFromParent_Done,
     /* 2365232 */   // Label 33017: @2365232
     /* 2365232 */   GIM_Reject,
     /* 2365233 */ // Label 33015: @2365233
     /* 2365233 */ GIM_Reject,
     /* 2365234 */ // Label 32964: @2365234
     /* 2365234 */ GIM_Try, /*On fail goto*//*Label 33018*/ GIMT_Encode4(2365348),
     /* 2365239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2365242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2365245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365257 */   GIM_Try, /*On fail goto*//*Label 33019*/ GIMT_Encode4(2365302), // Rule ID 56680 //
     /* 2365262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2365265 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2365268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2365282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365301 */     // GIR_Coverage, 56680,
     /* 2365301 */     GIR_EraseRootFromParent_Done,
     /* 2365302 */   // Label 33019: @2365302
     /* 2365302 */   GIM_Try, /*On fail goto*//*Label 33020*/ GIMT_Encode4(2365347), // Rule ID 56681 //
     /* 2365307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2365310 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2365313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2365327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365346 */     // GIR_Coverage, 56681,
     /* 2365346 */     GIR_EraseRootFromParent_Done,
     /* 2365347 */   // Label 33020: @2365347
     /* 2365347 */   GIM_Reject,
     /* 2365348 */ // Label 33018: @2365348
     /* 2365348 */ GIM_Reject,
     /* 2365349 */ // Label 32965: @2365349
     /* 2365349 */ GIM_Reject,
     /* 2365350 */ // Label 76: @2365350
     /* 2365350 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33024*/ GIMT_Encode4(2365475),
     /* 2365361 */ /*GILLT_s16*//*Label 33021*/ GIMT_Encode4(2365373),
     /* 2365365 */ /*GILLT_s32*//*Label 33022*/ GIMT_Encode4(2365407),
     /* 2365369 */ /*GILLT_s64*//*Label 33023*/ GIMT_Encode4(2365441),
     /* 2365373 */ // Label 33021: @2365373
     /* 2365373 */ GIM_Try, /*On fail goto*//*Label 33025*/ GIMT_Encode4(2365406), // Rule ID 2416 //
     /* 2365378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2365381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2365384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2365387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365399 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMINM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2365399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_H),
     /* 2365404 */   GIR_RootConstrainSelectedInstOperands,
     /* 2365405 */   // GIR_Coverage, 2416,
     /* 2365405 */   GIR_Done,
     /* 2365406 */ // Label 33025: @2365406
     /* 2365406 */ GIM_Reject,
     /* 2365407 */ // Label 33022: @2365407
     /* 2365407 */ GIM_Try, /*On fail goto*//*Label 33026*/ GIMT_Encode4(2365440), // Rule ID 2334 //
     /* 2365412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2365415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2365418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2365421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365433 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMINM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2365433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_S),
     /* 2365438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2365439 */   // GIR_Coverage, 2334,
     /* 2365439 */   GIR_Done,
     /* 2365440 */ // Label 33026: @2365440
     /* 2365440 */ GIM_Reject,
     /* 2365441 */ // Label 33023: @2365441
     /* 2365441 */ GIM_Try, /*On fail goto*//*Label 33027*/ GIMT_Encode4(2365474), // Rule ID 2374 //
     /* 2365446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2365449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2365452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2365455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365463 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365467 */   // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMINM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2365467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_D),
     /* 2365472 */   GIR_RootConstrainSelectedInstOperands,
     /* 2365473 */   // GIR_Coverage, 2374,
     /* 2365473 */   GIR_Done,
     /* 2365474 */ // Label 33027: @2365474
     /* 2365474 */ GIM_Reject,
     /* 2365475 */ // Label 33024: @2365475
     /* 2365475 */ GIM_Reject,
     /* 2365476 */ // Label 77: @2365476
     /* 2365476 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33031*/ GIMT_Encode4(2365601),
     /* 2365487 */ /*GILLT_s16*//*Label 33028*/ GIMT_Encode4(2365499),
     /* 2365491 */ /*GILLT_s32*//*Label 33029*/ GIMT_Encode4(2365533),
     /* 2365495 */ /*GILLT_s64*//*Label 33030*/ GIMT_Encode4(2365567),
     /* 2365499 */ // Label 33028: @2365499
     /* 2365499 */ GIM_Try, /*On fail goto*//*Label 33032*/ GIMT_Encode4(2365532), // Rule ID 2417 //
     /* 2365504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2365507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2365510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2365513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365525 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAXM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2365525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_H),
     /* 2365530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2365531 */   // GIR_Coverage, 2417,
     /* 2365531 */   GIR_Done,
     /* 2365532 */ // Label 33032: @2365532
     /* 2365532 */ GIM_Reject,
     /* 2365533 */ // Label 33029: @2365533
     /* 2365533 */ GIM_Try, /*On fail goto*//*Label 33033*/ GIMT_Encode4(2365566), // Rule ID 2335 //
     /* 2365538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2365541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2365544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2365547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365559 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAXM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2365559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_S),
     /* 2365564 */   GIR_RootConstrainSelectedInstOperands,
     /* 2365565 */   // GIR_Coverage, 2335,
     /* 2365565 */   GIR_Done,
     /* 2365566 */ // Label 33033: @2365566
     /* 2365566 */ GIM_Reject,
     /* 2365567 */ // Label 33030: @2365567
     /* 2365567 */ GIM_Try, /*On fail goto*//*Label 33034*/ GIMT_Encode4(2365600), // Rule ID 2375 //
     /* 2365572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2365575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2365578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2365581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365593 */   // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAXM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2365593 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_D),
     /* 2365598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2365599 */   // GIR_Coverage, 2375,
     /* 2365599 */   GIR_Done,
     /* 2365600 */ // Label 33034: @2365600
     /* 2365600 */ GIM_Reject,
     /* 2365601 */ // Label 33031: @2365601
     /* 2365601 */ GIM_Reject,
     /* 2365602 */ // Label 78: @2365602
     /* 2365602 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 33053*/ GIMT_Encode4(2367686),
     /* 2365613 */ /*GILLT_s16*//*Label 33035*/ GIMT_Encode4(2365733),
     /* 2365617 */ /*GILLT_s32*//*Label 33036*/ GIMT_Encode4(2365800),
     /* 2365621 */ /*GILLT_s64*//*Label 33037*/ GIMT_Encode4(2365867), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2365633 */ /*GILLT_nxv1s16*//*Label 33038*/ GIMT_Encode4(2365961),
     /* 2365637 */ /*GILLT_nxv1s32*//*Label 33039*/ GIMT_Encode4(2366076),
     /* 2365641 */ /*GILLT_nxv1s64*//*Label 33040*/ GIMT_Encode4(2366191), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2365653 */ /*GILLT_nxv2s16*//*Label 33041*/ GIMT_Encode4(2366306),
     /* 2365657 */ /*GILLT_nxv2s32*//*Label 33042*/ GIMT_Encode4(2366421),
     /* 2365661 */ /*GILLT_nxv2s64*//*Label 33043*/ GIMT_Encode4(2366536), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2365673 */ /*GILLT_nxv4s16*//*Label 33044*/ GIMT_Encode4(2366651),
     /* 2365677 */ /*GILLT_nxv4s32*//*Label 33045*/ GIMT_Encode4(2366766),
     /* 2365681 */ /*GILLT_nxv4s64*//*Label 33046*/ GIMT_Encode4(2366881), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2365693 */ /*GILLT_nxv8s16*//*Label 33047*/ GIMT_Encode4(2366996),
     /* 2365697 */ /*GILLT_nxv8s32*//*Label 33048*/ GIMT_Encode4(2367111),
     /* 2365701 */ /*GILLT_nxv8s64*//*Label 33049*/ GIMT_Encode4(2367226), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2365713 */ /*GILLT_nxv16s16*//*Label 33050*/ GIMT_Encode4(2367341),
     /* 2365717 */ /*GILLT_nxv16s32*//*Label 33051*/ GIMT_Encode4(2367456), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2365729 */ /*GILLT_nxv32s16*//*Label 33052*/ GIMT_Encode4(2367571),
     /* 2365733 */ // Label 33035: @2365733
     /* 2365733 */ GIM_Try, /*On fail goto*//*Label 33054*/ GIMT_Encode4(2365799),
     /* 2365738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2365741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2365744 */   GIM_Try, /*On fail goto*//*Label 33055*/ GIMT_Encode4(2365771), // Rule ID 2066 //
     /* 2365749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2365752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365764 */     // (fminimumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2365764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2365769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365770 */     // GIR_Coverage, 2066,
     /* 2365770 */     GIR_Done,
     /* 2365771 */   // Label 33055: @2365771
     /* 2365771 */   GIM_Try, /*On fail goto*//*Label 33056*/ GIMT_Encode4(2365798), // Rule ID 2067 //
     /* 2365776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2365779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2365783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2365787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2365791 */     // (fminimumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2365791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2365796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365797 */     // GIR_Coverage, 2067,
     /* 2365797 */     GIR_Done,
     /* 2365798 */   // Label 33056: @2365798
     /* 2365798 */   GIM_Reject,
     /* 2365799 */ // Label 33054: @2365799
     /* 2365799 */ GIM_Reject,
     /* 2365800 */ // Label 33036: @2365800
     /* 2365800 */ GIM_Try, /*On fail goto*//*Label 33057*/ GIMT_Encode4(2365866),
     /* 2365805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2365808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2365811 */   GIM_Try, /*On fail goto*//*Label 33058*/ GIMT_Encode4(2365838), // Rule ID 1353 //
     /* 2365816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2365819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365831 */     // (fminimumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2365831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2365836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365837 */     // GIR_Coverage, 1353,
     /* 2365837 */     GIR_Done,
     /* 2365838 */   // Label 33058: @2365838
     /* 2365838 */   GIM_Try, /*On fail goto*//*Label 33059*/ GIMT_Encode4(2365865), // Rule ID 1354 //
     /* 2365843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2365846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2365850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2365854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2365858 */     // (fminimumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2365858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2365863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365864 */     // GIR_Coverage, 1354,
     /* 2365864 */     GIR_Done,
     /* 2365865 */   // Label 33059: @2365865
     /* 2365865 */   GIM_Reject,
     /* 2365866 */ // Label 33057: @2365866
     /* 2365866 */ GIM_Reject,
     /* 2365867 */ // Label 33037: @2365867
     /* 2365867 */ GIM_Try, /*On fail goto*//*Label 33060*/ GIMT_Encode4(2365960),
     /* 2365872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2365875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2365878 */   GIM_Try, /*On fail goto*//*Label 33061*/ GIMT_Encode4(2365905), // Rule ID 1726 //
     /* 2365883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2365886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365898 */     // (fminimumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2365898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2365903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365904 */     // GIR_Coverage, 1726,
     /* 2365904 */     GIR_Done,
     /* 2365905 */   // Label 33061: @2365905
     /* 2365905 */   GIM_Try, /*On fail goto*//*Label 33062*/ GIMT_Encode4(2365932), // Rule ID 1727 //
     /* 2365910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2365913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2365917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2365921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2365925 */     // (fminimumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2365925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2365930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365931 */     // GIR_Coverage, 1727,
     /* 2365931 */     GIR_Done,
     /* 2365932 */   // Label 33062: @2365932
     /* 2365932 */   GIM_Try, /*On fail goto*//*Label 33063*/ GIMT_Encode4(2365959), // Rule ID 1728 //
     /* 2365937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2365940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2365944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2365948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2365952 */     // (fminimumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2365952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2365957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365958 */     // GIR_Coverage, 1728,
     /* 2365958 */     GIR_Done,
     /* 2365959 */   // Label 33063: @2365959
     /* 2365959 */   GIM_Reject,
     /* 2365960 */ // Label 33060: @2365960
     /* 2365960 */ GIM_Reject,
     /* 2365961 */ // Label 33038: @2365961
     /* 2365961 */ GIM_Try, /*On fail goto*//*Label 33064*/ GIMT_Encode4(2366075),
     /* 2365966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2365969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2365972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365984 */   GIM_Try, /*On fail goto*//*Label 33065*/ GIMT_Encode4(2366029), // Rule ID 56722 //
     /* 2365989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2365992 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2365995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2366009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366028 */     // GIR_Coverage, 56722,
     /* 2366028 */     GIR_EraseRootFromParent_Done,
     /* 2366029 */   // Label 33065: @2366029
     /* 2366029 */   GIM_Try, /*On fail goto*//*Label 33066*/ GIMT_Encode4(2366074), // Rule ID 56723 //
     /* 2366034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2366037 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2366040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2366054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366073 */     // GIR_Coverage, 56723,
     /* 2366073 */     GIR_EraseRootFromParent_Done,
     /* 2366074 */   // Label 33066: @2366074
     /* 2366074 */   GIM_Reject,
     /* 2366075 */ // Label 33064: @2366075
     /* 2366075 */ GIM_Reject,
     /* 2366076 */ // Label 33039: @2366076
     /* 2366076 */ GIM_Try, /*On fail goto*//*Label 33067*/ GIMT_Encode4(2366190),
     /* 2366081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2366084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2366087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366099 */   GIM_Try, /*On fail goto*//*Label 33068*/ GIMT_Encode4(2366144), // Rule ID 56734 //
     /* 2366104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2366107 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2366110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2366124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366143 */     // GIR_Coverage, 56734,
     /* 2366143 */     GIR_EraseRootFromParent_Done,
     /* 2366144 */   // Label 33068: @2366144
     /* 2366144 */   GIM_Try, /*On fail goto*//*Label 33069*/ GIMT_Encode4(2366189), // Rule ID 56735 //
     /* 2366149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2366152 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2366155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2366169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366188 */     // GIR_Coverage, 56735,
     /* 2366188 */     GIR_EraseRootFromParent_Done,
     /* 2366189 */   // Label 33069: @2366189
     /* 2366189 */   GIM_Reject,
     /* 2366190 */ // Label 33067: @2366190
     /* 2366190 */ GIM_Reject,
     /* 2366191 */ // Label 33040: @2366191
     /* 2366191 */ GIM_Try, /*On fail goto*//*Label 33070*/ GIMT_Encode4(2366305),
     /* 2366196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2366199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2366202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366214 */   GIM_Try, /*On fail goto*//*Label 33071*/ GIMT_Encode4(2366259), // Rule ID 56752 //
     /* 2366219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2366222 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2366225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2366239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366258 */     // GIR_Coverage, 56752,
     /* 2366258 */     GIR_EraseRootFromParent_Done,
     /* 2366259 */   // Label 33071: @2366259
     /* 2366259 */   GIM_Try, /*On fail goto*//*Label 33072*/ GIMT_Encode4(2366304), // Rule ID 56753 //
     /* 2366264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2366267 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2366270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2366284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366303 */     // GIR_Coverage, 56753,
     /* 2366303 */     GIR_EraseRootFromParent_Done,
     /* 2366304 */   // Label 33072: @2366304
     /* 2366304 */   GIM_Reject,
     /* 2366305 */ // Label 33070: @2366305
     /* 2366305 */ GIM_Reject,
     /* 2366306 */ // Label 33041: @2366306
     /* 2366306 */ GIM_Try, /*On fail goto*//*Label 33073*/ GIMT_Encode4(2366420),
     /* 2366311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2366314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2366317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366329 */   GIM_Try, /*On fail goto*//*Label 33074*/ GIMT_Encode4(2366374), // Rule ID 56728 //
     /* 2366334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2366337 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2366340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2366354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366373 */     // GIR_Coverage, 56728,
     /* 2366373 */     GIR_EraseRootFromParent_Done,
     /* 2366374 */   // Label 33074: @2366374
     /* 2366374 */   GIM_Try, /*On fail goto*//*Label 33075*/ GIMT_Encode4(2366419), // Rule ID 56729 //
     /* 2366379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2366382 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2366385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2366399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366418 */     // GIR_Coverage, 56729,
     /* 2366418 */     GIR_EraseRootFromParent_Done,
     /* 2366419 */   // Label 33075: @2366419
     /* 2366419 */   GIM_Reject,
     /* 2366420 */ // Label 33073: @2366420
     /* 2366420 */ GIM_Reject,
     /* 2366421 */ // Label 33042: @2366421
     /* 2366421 */ GIM_Try, /*On fail goto*//*Label 33076*/ GIMT_Encode4(2366535),
     /* 2366426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2366429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2366432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366444 */   GIM_Try, /*On fail goto*//*Label 33077*/ GIMT_Encode4(2366489), // Rule ID 56746 //
     /* 2366449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2366452 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2366455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2366469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366488 */     // GIR_Coverage, 56746,
     /* 2366488 */     GIR_EraseRootFromParent_Done,
     /* 2366489 */   // Label 33077: @2366489
     /* 2366489 */   GIM_Try, /*On fail goto*//*Label 33078*/ GIMT_Encode4(2366534), // Rule ID 56747 //
     /* 2366494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2366497 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2366500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2366514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366533 */     // GIR_Coverage, 56747,
     /* 2366533 */     GIR_EraseRootFromParent_Done,
     /* 2366534 */   // Label 33078: @2366534
     /* 2366534 */   GIM_Reject,
     /* 2366535 */ // Label 33076: @2366535
     /* 2366535 */ GIM_Reject,
     /* 2366536 */ // Label 33043: @2366536
     /* 2366536 */ GIM_Try, /*On fail goto*//*Label 33079*/ GIMT_Encode4(2366650),
     /* 2366541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2366544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2366547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366559 */   GIM_Try, /*On fail goto*//*Label 33080*/ GIMT_Encode4(2366604), // Rule ID 56794 //
     /* 2366564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2366567 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2366570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2366584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366603 */     // GIR_Coverage, 56794,
     /* 2366603 */     GIR_EraseRootFromParent_Done,
     /* 2366604 */   // Label 33080: @2366604
     /* 2366604 */   GIM_Try, /*On fail goto*//*Label 33081*/ GIMT_Encode4(2366649), // Rule ID 56795 //
     /* 2366609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2366612 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2366615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2366629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366648 */     // GIR_Coverage, 56795,
     /* 2366648 */     GIR_EraseRootFromParent_Done,
     /* 2366649 */   // Label 33081: @2366649
     /* 2366649 */   GIM_Reject,
     /* 2366650 */ // Label 33079: @2366650
     /* 2366650 */ GIM_Reject,
     /* 2366651 */ // Label 33044: @2366651
     /* 2366651 */ GIM_Try, /*On fail goto*//*Label 33082*/ GIMT_Encode4(2366765),
     /* 2366656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2366659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2366662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366674 */   GIM_Try, /*On fail goto*//*Label 33083*/ GIMT_Encode4(2366719), // Rule ID 56740 //
     /* 2366679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2366682 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2366685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2366699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366718 */     // GIR_Coverage, 56740,
     /* 2366718 */     GIR_EraseRootFromParent_Done,
     /* 2366719 */   // Label 33083: @2366719
     /* 2366719 */   GIM_Try, /*On fail goto*//*Label 33084*/ GIMT_Encode4(2366764), // Rule ID 56741 //
     /* 2366724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2366727 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2366730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2366744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366763 */     // GIR_Coverage, 56741,
     /* 2366763 */     GIR_EraseRootFromParent_Done,
     /* 2366764 */   // Label 33084: @2366764
     /* 2366764 */   GIM_Reject,
     /* 2366765 */ // Label 33082: @2366765
     /* 2366765 */ GIM_Reject,
     /* 2366766 */ // Label 33045: @2366766
     /* 2366766 */ GIM_Try, /*On fail goto*//*Label 33085*/ GIMT_Encode4(2366880),
     /* 2366771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2366774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2366777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366789 */   GIM_Try, /*On fail goto*//*Label 33086*/ GIMT_Encode4(2366834), // Rule ID 56776 //
     /* 2366794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2366797 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2366800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2366814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366833 */     // GIR_Coverage, 56776,
     /* 2366833 */     GIR_EraseRootFromParent_Done,
     /* 2366834 */   // Label 33086: @2366834
     /* 2366834 */   GIM_Try, /*On fail goto*//*Label 33087*/ GIMT_Encode4(2366879), // Rule ID 56777 //
     /* 2366839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2366842 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2366845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2366859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366878 */     // GIR_Coverage, 56777,
     /* 2366878 */     GIR_EraseRootFromParent_Done,
     /* 2366879 */   // Label 33087: @2366879
     /* 2366879 */   GIM_Reject,
     /* 2366880 */ // Label 33085: @2366880
     /* 2366880 */ GIM_Reject,
     /* 2366881 */ // Label 33046: @2366881
     /* 2366881 */ GIM_Try, /*On fail goto*//*Label 33088*/ GIMT_Encode4(2366995),
     /* 2366886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2366889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2366892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366904 */   GIM_Try, /*On fail goto*//*Label 33089*/ GIMT_Encode4(2366949), // Rule ID 56800 //
     /* 2366909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2366912 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2366915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2366929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366948 */     // GIR_Coverage, 56800,
     /* 2366948 */     GIR_EraseRootFromParent_Done,
     /* 2366949 */   // Label 33089: @2366949
     /* 2366949 */   GIM_Try, /*On fail goto*//*Label 33090*/ GIMT_Encode4(2366994), // Rule ID 56801 //
     /* 2366954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2366957 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2366960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2366974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366993 */     // GIR_Coverage, 56801,
     /* 2366993 */     GIR_EraseRootFromParent_Done,
     /* 2366994 */   // Label 33090: @2366994
     /* 2366994 */   GIM_Reject,
     /* 2366995 */ // Label 33088: @2366995
     /* 2366995 */ GIM_Reject,
     /* 2366996 */ // Label 33047: @2366996
     /* 2366996 */ GIM_Try, /*On fail goto*//*Label 33091*/ GIMT_Encode4(2367110),
     /* 2367001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2367004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2367007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367019 */   GIM_Try, /*On fail goto*//*Label 33092*/ GIMT_Encode4(2367064), // Rule ID 56758 //
     /* 2367024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2367027 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2367030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2367044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367063 */     // GIR_Coverage, 56758,
     /* 2367063 */     GIR_EraseRootFromParent_Done,
     /* 2367064 */   // Label 33092: @2367064
     /* 2367064 */   GIM_Try, /*On fail goto*//*Label 33093*/ GIMT_Encode4(2367109), // Rule ID 56759 //
     /* 2367069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2367072 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2367075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2367089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367108 */     // GIR_Coverage, 56759,
     /* 2367108 */     GIR_EraseRootFromParent_Done,
     /* 2367109 */   // Label 33093: @2367109
     /* 2367109 */   GIM_Reject,
     /* 2367110 */ // Label 33091: @2367110
     /* 2367110 */ GIM_Reject,
     /* 2367111 */ // Label 33048: @2367111
     /* 2367111 */ GIM_Try, /*On fail goto*//*Label 33094*/ GIMT_Encode4(2367225),
     /* 2367116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2367119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2367122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367134 */   GIM_Try, /*On fail goto*//*Label 33095*/ GIMT_Encode4(2367179), // Rule ID 56782 //
     /* 2367139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2367142 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2367145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2367159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367178 */     // GIR_Coverage, 56782,
     /* 2367178 */     GIR_EraseRootFromParent_Done,
     /* 2367179 */   // Label 33095: @2367179
     /* 2367179 */   GIM_Try, /*On fail goto*//*Label 33096*/ GIMT_Encode4(2367224), // Rule ID 56783 //
     /* 2367184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2367187 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2367190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2367204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367223 */     // GIR_Coverage, 56783,
     /* 2367223 */     GIR_EraseRootFromParent_Done,
     /* 2367224 */   // Label 33096: @2367224
     /* 2367224 */   GIM_Reject,
     /* 2367225 */ // Label 33094: @2367225
     /* 2367225 */ GIM_Reject,
     /* 2367226 */ // Label 33049: @2367226
     /* 2367226 */ GIM_Try, /*On fail goto*//*Label 33097*/ GIMT_Encode4(2367340),
     /* 2367231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2367234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2367237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367249 */   GIM_Try, /*On fail goto*//*Label 33098*/ GIMT_Encode4(2367294), // Rule ID 56806 //
     /* 2367254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2367257 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2367260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2367274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367293 */     // GIR_Coverage, 56806,
     /* 2367293 */     GIR_EraseRootFromParent_Done,
     /* 2367294 */   // Label 33098: @2367294
     /* 2367294 */   GIM_Try, /*On fail goto*//*Label 33099*/ GIMT_Encode4(2367339), // Rule ID 56807 //
     /* 2367299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2367302 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2367305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2367319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367338 */     // GIR_Coverage, 56807,
     /* 2367338 */     GIR_EraseRootFromParent_Done,
     /* 2367339 */   // Label 33099: @2367339
     /* 2367339 */   GIM_Reject,
     /* 2367340 */ // Label 33097: @2367340
     /* 2367340 */ GIM_Reject,
     /* 2367341 */ // Label 33050: @2367341
     /* 2367341 */ GIM_Try, /*On fail goto*//*Label 33100*/ GIMT_Encode4(2367455),
     /* 2367346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2367349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2367352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367360 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367364 */   GIM_Try, /*On fail goto*//*Label 33101*/ GIMT_Encode4(2367409), // Rule ID 56764 //
     /* 2367369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2367372 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2367375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2367389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367408 */     // GIR_Coverage, 56764,
     /* 2367408 */     GIR_EraseRootFromParent_Done,
     /* 2367409 */   // Label 33101: @2367409
     /* 2367409 */   GIM_Try, /*On fail goto*//*Label 33102*/ GIMT_Encode4(2367454), // Rule ID 56765 //
     /* 2367414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2367417 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2367420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2367434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367453 */     // GIR_Coverage, 56765,
     /* 2367453 */     GIR_EraseRootFromParent_Done,
     /* 2367454 */   // Label 33102: @2367454
     /* 2367454 */   GIM_Reject,
     /* 2367455 */ // Label 33100: @2367455
     /* 2367455 */ GIM_Reject,
     /* 2367456 */ // Label 33051: @2367456
     /* 2367456 */ GIM_Try, /*On fail goto*//*Label 33103*/ GIMT_Encode4(2367570),
     /* 2367461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2367464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2367467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367479 */   GIM_Try, /*On fail goto*//*Label 33104*/ GIMT_Encode4(2367524), // Rule ID 56788 //
     /* 2367484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2367487 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2367490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2367504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367523 */     // GIR_Coverage, 56788,
     /* 2367523 */     GIR_EraseRootFromParent_Done,
     /* 2367524 */   // Label 33104: @2367524
     /* 2367524 */   GIM_Try, /*On fail goto*//*Label 33105*/ GIMT_Encode4(2367569), // Rule ID 56789 //
     /* 2367529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2367532 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2367535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2367549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367568 */     // GIR_Coverage, 56789,
     /* 2367568 */     GIR_EraseRootFromParent_Done,
     /* 2367569 */   // Label 33105: @2367569
     /* 2367569 */   GIM_Reject,
     /* 2367570 */ // Label 33103: @2367570
     /* 2367570 */ GIM_Reject,
     /* 2367571 */ // Label 33052: @2367571
     /* 2367571 */ GIM_Try, /*On fail goto*//*Label 33106*/ GIMT_Encode4(2367685),
     /* 2367576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2367579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2367582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367594 */   GIM_Try, /*On fail goto*//*Label 33107*/ GIMT_Encode4(2367639), // Rule ID 56770 //
     /* 2367599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2367602 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2367605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2367619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367638 */     // GIR_Coverage, 56770,
     /* 2367638 */     GIR_EraseRootFromParent_Done,
     /* 2367639 */   // Label 33107: @2367639
     /* 2367639 */   GIM_Try, /*On fail goto*//*Label 33108*/ GIMT_Encode4(2367684), // Rule ID 56771 //
     /* 2367644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2367647 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2367650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2367664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367683 */     // GIR_Coverage, 56771,
     /* 2367683 */     GIR_EraseRootFromParent_Done,
     /* 2367684 */   // Label 33108: @2367684
     /* 2367684 */   GIM_Reject,
     /* 2367685 */ // Label 33106: @2367685
     /* 2367685 */ GIM_Reject,
     /* 2367686 */ // Label 33053: @2367686
     /* 2367686 */ GIM_Reject,
     /* 2367687 */ // Label 79: @2367687
     /* 2367687 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 33127*/ GIMT_Encode4(2369771),
     /* 2367698 */ /*GILLT_s16*//*Label 33109*/ GIMT_Encode4(2367818),
     /* 2367702 */ /*GILLT_s32*//*Label 33110*/ GIMT_Encode4(2367885),
     /* 2367706 */ /*GILLT_s64*//*Label 33111*/ GIMT_Encode4(2367952), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2367718 */ /*GILLT_nxv1s16*//*Label 33112*/ GIMT_Encode4(2368046),
     /* 2367722 */ /*GILLT_nxv1s32*//*Label 33113*/ GIMT_Encode4(2368161),
     /* 2367726 */ /*GILLT_nxv1s64*//*Label 33114*/ GIMT_Encode4(2368276), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2367738 */ /*GILLT_nxv2s16*//*Label 33115*/ GIMT_Encode4(2368391),
     /* 2367742 */ /*GILLT_nxv2s32*//*Label 33116*/ GIMT_Encode4(2368506),
     /* 2367746 */ /*GILLT_nxv2s64*//*Label 33117*/ GIMT_Encode4(2368621), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2367758 */ /*GILLT_nxv4s16*//*Label 33118*/ GIMT_Encode4(2368736),
     /* 2367762 */ /*GILLT_nxv4s32*//*Label 33119*/ GIMT_Encode4(2368851),
     /* 2367766 */ /*GILLT_nxv4s64*//*Label 33120*/ GIMT_Encode4(2368966), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2367778 */ /*GILLT_nxv8s16*//*Label 33121*/ GIMT_Encode4(2369081),
     /* 2367782 */ /*GILLT_nxv8s32*//*Label 33122*/ GIMT_Encode4(2369196),
     /* 2367786 */ /*GILLT_nxv8s64*//*Label 33123*/ GIMT_Encode4(2369311), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2367798 */ /*GILLT_nxv16s16*//*Label 33124*/ GIMT_Encode4(2369426),
     /* 2367802 */ /*GILLT_nxv16s32*//*Label 33125*/ GIMT_Encode4(2369541), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2367814 */ /*GILLT_nxv32s16*//*Label 33126*/ GIMT_Encode4(2369656),
     /* 2367818 */ // Label 33109: @2367818
     /* 2367818 */ GIM_Try, /*On fail goto*//*Label 33128*/ GIMT_Encode4(2367884),
     /* 2367823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2367826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2367829 */   GIM_Try, /*On fail goto*//*Label 33129*/ GIMT_Encode4(2367856), // Rule ID 2068 //
     /* 2367834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2367837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2367841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2367845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2367849 */     // (fmaximumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2367849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2367854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367855 */     // GIR_Coverage, 2068,
     /* 2367855 */     GIR_Done,
     /* 2367856 */   // Label 33129: @2367856
     /* 2367856 */   GIM_Try, /*On fail goto*//*Label 33130*/ GIMT_Encode4(2367883), // Rule ID 2069 //
     /* 2367861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2367864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2367868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2367872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2367876 */     // (fmaximumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2367876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2367881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367882 */     // GIR_Coverage, 2069,
     /* 2367882 */     GIR_Done,
     /* 2367883 */   // Label 33130: @2367883
     /* 2367883 */   GIM_Reject,
     /* 2367884 */ // Label 33128: @2367884
     /* 2367884 */ GIM_Reject,
     /* 2367885 */ // Label 33110: @2367885
     /* 2367885 */ GIM_Try, /*On fail goto*//*Label 33131*/ GIMT_Encode4(2367951),
     /* 2367890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2367893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2367896 */   GIM_Try, /*On fail goto*//*Label 33132*/ GIMT_Encode4(2367923), // Rule ID 1355 //
     /* 2367901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2367904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2367908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2367912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2367916 */     // (fmaximumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2367916 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2367921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367922 */     // GIR_Coverage, 1355,
     /* 2367922 */     GIR_Done,
     /* 2367923 */   // Label 33132: @2367923
     /* 2367923 */   GIM_Try, /*On fail goto*//*Label 33133*/ GIMT_Encode4(2367950), // Rule ID 1356 //
     /* 2367928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2367931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2367935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2367939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2367943 */     // (fmaximumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2367943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2367948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367949 */     // GIR_Coverage, 1356,
     /* 2367949 */     GIR_Done,
     /* 2367950 */   // Label 33133: @2367950
     /* 2367950 */   GIM_Reject,
     /* 2367951 */ // Label 33131: @2367951
     /* 2367951 */ GIM_Reject,
     /* 2367952 */ // Label 33111: @2367952
     /* 2367952 */ GIM_Try, /*On fail goto*//*Label 33134*/ GIMT_Encode4(2368045),
     /* 2367957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2367960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2367963 */   GIM_Try, /*On fail goto*//*Label 33135*/ GIMT_Encode4(2367990), // Rule ID 1729 //
     /* 2367968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2367971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2367975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2367979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2367983 */     // (fmaximumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2367983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2367988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367989 */     // GIR_Coverage, 1729,
     /* 2367989 */     GIR_Done,
     /* 2367990 */   // Label 33135: @2367990
     /* 2367990 */   GIM_Try, /*On fail goto*//*Label 33136*/ GIMT_Encode4(2368017), // Rule ID 1730 //
     /* 2367995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2367998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2368002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2368006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2368010 */     // (fmaximumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2368010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2368015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368016 */     // GIR_Coverage, 1730,
     /* 2368016 */     GIR_Done,
     /* 2368017 */   // Label 33136: @2368017
     /* 2368017 */   GIM_Try, /*On fail goto*//*Label 33137*/ GIMT_Encode4(2368044), // Rule ID 1731 //
     /* 2368022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2368025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2368029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2368033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2368037 */     // (fmaximumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2368037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2368042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368043 */     // GIR_Coverage, 1731,
     /* 2368043 */     GIR_Done,
     /* 2368044 */   // Label 33137: @2368044
     /* 2368044 */   GIM_Reject,
     /* 2368045 */ // Label 33134: @2368045
     /* 2368045 */ GIM_Reject,
     /* 2368046 */ // Label 33112: @2368046
     /* 2368046 */ GIM_Try, /*On fail goto*//*Label 33138*/ GIMT_Encode4(2368160),
     /* 2368051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2368054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2368057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368069 */   GIM_Try, /*On fail goto*//*Label 33139*/ GIMT_Encode4(2368114), // Rule ID 56812 //
     /* 2368074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2368077 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2368080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2368094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368113 */     // GIR_Coverage, 56812,
     /* 2368113 */     GIR_EraseRootFromParent_Done,
     /* 2368114 */   // Label 33139: @2368114
     /* 2368114 */   GIM_Try, /*On fail goto*//*Label 33140*/ GIMT_Encode4(2368159), // Rule ID 56813 //
     /* 2368119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2368122 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2368125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2368139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368158 */     // GIR_Coverage, 56813,
     /* 2368158 */     GIR_EraseRootFromParent_Done,
     /* 2368159 */   // Label 33140: @2368159
     /* 2368159 */   GIM_Reject,
     /* 2368160 */ // Label 33138: @2368160
     /* 2368160 */ GIM_Reject,
     /* 2368161 */ // Label 33113: @2368161
     /* 2368161 */ GIM_Try, /*On fail goto*//*Label 33141*/ GIMT_Encode4(2368275),
     /* 2368166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2368169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2368172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368184 */   GIM_Try, /*On fail goto*//*Label 33142*/ GIMT_Encode4(2368229), // Rule ID 56824 //
     /* 2368189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2368192 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2368195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2368209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368228 */     // GIR_Coverage, 56824,
     /* 2368228 */     GIR_EraseRootFromParent_Done,
     /* 2368229 */   // Label 33142: @2368229
     /* 2368229 */   GIM_Try, /*On fail goto*//*Label 33143*/ GIMT_Encode4(2368274), // Rule ID 56825 //
     /* 2368234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2368237 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2368240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2368254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368273 */     // GIR_Coverage, 56825,
     /* 2368273 */     GIR_EraseRootFromParent_Done,
     /* 2368274 */   // Label 33143: @2368274
     /* 2368274 */   GIM_Reject,
     /* 2368275 */ // Label 33141: @2368275
     /* 2368275 */ GIM_Reject,
     /* 2368276 */ // Label 33114: @2368276
     /* 2368276 */ GIM_Try, /*On fail goto*//*Label 33144*/ GIMT_Encode4(2368390),
     /* 2368281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2368284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2368287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368299 */   GIM_Try, /*On fail goto*//*Label 33145*/ GIMT_Encode4(2368344), // Rule ID 56842 //
     /* 2368304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2368307 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2368310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2368324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368343 */     // GIR_Coverage, 56842,
     /* 2368343 */     GIR_EraseRootFromParent_Done,
     /* 2368344 */   // Label 33145: @2368344
     /* 2368344 */   GIM_Try, /*On fail goto*//*Label 33146*/ GIMT_Encode4(2368389), // Rule ID 56843 //
     /* 2368349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2368352 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2368355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2368369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368388 */     // GIR_Coverage, 56843,
     /* 2368388 */     GIR_EraseRootFromParent_Done,
     /* 2368389 */   // Label 33146: @2368389
     /* 2368389 */   GIM_Reject,
     /* 2368390 */ // Label 33144: @2368390
     /* 2368390 */ GIM_Reject,
     /* 2368391 */ // Label 33115: @2368391
     /* 2368391 */ GIM_Try, /*On fail goto*//*Label 33147*/ GIMT_Encode4(2368505),
     /* 2368396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2368399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2368402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368414 */   GIM_Try, /*On fail goto*//*Label 33148*/ GIMT_Encode4(2368459), // Rule ID 56818 //
     /* 2368419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2368422 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2368425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2368439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368458 */     // GIR_Coverage, 56818,
     /* 2368458 */     GIR_EraseRootFromParent_Done,
     /* 2368459 */   // Label 33148: @2368459
     /* 2368459 */   GIM_Try, /*On fail goto*//*Label 33149*/ GIMT_Encode4(2368504), // Rule ID 56819 //
     /* 2368464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2368467 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2368470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2368484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368503 */     // GIR_Coverage, 56819,
     /* 2368503 */     GIR_EraseRootFromParent_Done,
     /* 2368504 */   // Label 33149: @2368504
     /* 2368504 */   GIM_Reject,
     /* 2368505 */ // Label 33147: @2368505
     /* 2368505 */ GIM_Reject,
     /* 2368506 */ // Label 33116: @2368506
     /* 2368506 */ GIM_Try, /*On fail goto*//*Label 33150*/ GIMT_Encode4(2368620),
     /* 2368511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2368514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2368517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368529 */   GIM_Try, /*On fail goto*//*Label 33151*/ GIMT_Encode4(2368574), // Rule ID 56836 //
     /* 2368534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2368537 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2368540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2368554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368573 */     // GIR_Coverage, 56836,
     /* 2368573 */     GIR_EraseRootFromParent_Done,
     /* 2368574 */   // Label 33151: @2368574
     /* 2368574 */   GIM_Try, /*On fail goto*//*Label 33152*/ GIMT_Encode4(2368619), // Rule ID 56837 //
     /* 2368579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2368582 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2368585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2368599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368618 */     // GIR_Coverage, 56837,
     /* 2368618 */     GIR_EraseRootFromParent_Done,
     /* 2368619 */   // Label 33152: @2368619
     /* 2368619 */   GIM_Reject,
     /* 2368620 */ // Label 33150: @2368620
     /* 2368620 */ GIM_Reject,
     /* 2368621 */ // Label 33117: @2368621
     /* 2368621 */ GIM_Try, /*On fail goto*//*Label 33153*/ GIMT_Encode4(2368735),
     /* 2368626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2368629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2368632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368644 */   GIM_Try, /*On fail goto*//*Label 33154*/ GIMT_Encode4(2368689), // Rule ID 56884 //
     /* 2368649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2368652 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2368655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2368669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368688 */     // GIR_Coverage, 56884,
     /* 2368688 */     GIR_EraseRootFromParent_Done,
     /* 2368689 */   // Label 33154: @2368689
     /* 2368689 */   GIM_Try, /*On fail goto*//*Label 33155*/ GIMT_Encode4(2368734), // Rule ID 56885 //
     /* 2368694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2368697 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2368700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2368714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368733 */     // GIR_Coverage, 56885,
     /* 2368733 */     GIR_EraseRootFromParent_Done,
     /* 2368734 */   // Label 33155: @2368734
     /* 2368734 */   GIM_Reject,
     /* 2368735 */ // Label 33153: @2368735
     /* 2368735 */ GIM_Reject,
     /* 2368736 */ // Label 33118: @2368736
     /* 2368736 */ GIM_Try, /*On fail goto*//*Label 33156*/ GIMT_Encode4(2368850),
     /* 2368741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2368744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2368747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368759 */   GIM_Try, /*On fail goto*//*Label 33157*/ GIMT_Encode4(2368804), // Rule ID 56830 //
     /* 2368764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2368767 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2368770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2368784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368803 */     // GIR_Coverage, 56830,
     /* 2368803 */     GIR_EraseRootFromParent_Done,
     /* 2368804 */   // Label 33157: @2368804
     /* 2368804 */   GIM_Try, /*On fail goto*//*Label 33158*/ GIMT_Encode4(2368849), // Rule ID 56831 //
     /* 2368809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2368812 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2368815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2368829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368848 */     // GIR_Coverage, 56831,
     /* 2368848 */     GIR_EraseRootFromParent_Done,
     /* 2368849 */   // Label 33158: @2368849
     /* 2368849 */   GIM_Reject,
     /* 2368850 */ // Label 33156: @2368850
     /* 2368850 */ GIM_Reject,
     /* 2368851 */ // Label 33119: @2368851
     /* 2368851 */ GIM_Try, /*On fail goto*//*Label 33159*/ GIMT_Encode4(2368965),
     /* 2368856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2368859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2368862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368874 */   GIM_Try, /*On fail goto*//*Label 33160*/ GIMT_Encode4(2368919), // Rule ID 56866 //
     /* 2368879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2368882 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2368885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2368899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368918 */     // GIR_Coverage, 56866,
     /* 2368918 */     GIR_EraseRootFromParent_Done,
     /* 2368919 */   // Label 33160: @2368919
     /* 2368919 */   GIM_Try, /*On fail goto*//*Label 33161*/ GIMT_Encode4(2368964), // Rule ID 56867 //
     /* 2368924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2368927 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2368930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2368944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368963 */     // GIR_Coverage, 56867,
     /* 2368963 */     GIR_EraseRootFromParent_Done,
     /* 2368964 */   // Label 33161: @2368964
     /* 2368964 */   GIM_Reject,
     /* 2368965 */ // Label 33159: @2368965
     /* 2368965 */ GIM_Reject,
     /* 2368966 */ // Label 33120: @2368966
     /* 2368966 */ GIM_Try, /*On fail goto*//*Label 33162*/ GIMT_Encode4(2369080),
     /* 2368971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2368974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2368977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368989 */   GIM_Try, /*On fail goto*//*Label 33163*/ GIMT_Encode4(2369034), // Rule ID 56890 //
     /* 2368994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2368997 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2369000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2369014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369033 */     // GIR_Coverage, 56890,
     /* 2369033 */     GIR_EraseRootFromParent_Done,
     /* 2369034 */   // Label 33163: @2369034
     /* 2369034 */   GIM_Try, /*On fail goto*//*Label 33164*/ GIMT_Encode4(2369079), // Rule ID 56891 //
     /* 2369039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2369042 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2369045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2369059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369078 */     // GIR_Coverage, 56891,
     /* 2369078 */     GIR_EraseRootFromParent_Done,
     /* 2369079 */   // Label 33164: @2369079
     /* 2369079 */   GIM_Reject,
     /* 2369080 */ // Label 33162: @2369080
     /* 2369080 */ GIM_Reject,
     /* 2369081 */ // Label 33121: @2369081
     /* 2369081 */ GIM_Try, /*On fail goto*//*Label 33165*/ GIMT_Encode4(2369195),
     /* 2369086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2369089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2369092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369104 */   GIM_Try, /*On fail goto*//*Label 33166*/ GIMT_Encode4(2369149), // Rule ID 56848 //
     /* 2369109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2369112 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2369115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2369129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369148 */     // GIR_Coverage, 56848,
     /* 2369148 */     GIR_EraseRootFromParent_Done,
     /* 2369149 */   // Label 33166: @2369149
     /* 2369149 */   GIM_Try, /*On fail goto*//*Label 33167*/ GIMT_Encode4(2369194), // Rule ID 56849 //
     /* 2369154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2369157 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2369160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2369174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369193 */     // GIR_Coverage, 56849,
     /* 2369193 */     GIR_EraseRootFromParent_Done,
     /* 2369194 */   // Label 33167: @2369194
     /* 2369194 */   GIM_Reject,
     /* 2369195 */ // Label 33165: @2369195
     /* 2369195 */ GIM_Reject,
     /* 2369196 */ // Label 33122: @2369196
     /* 2369196 */ GIM_Try, /*On fail goto*//*Label 33168*/ GIMT_Encode4(2369310),
     /* 2369201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2369204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2369207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369219 */   GIM_Try, /*On fail goto*//*Label 33169*/ GIMT_Encode4(2369264), // Rule ID 56872 //
     /* 2369224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2369227 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2369230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2369244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369263 */     // GIR_Coverage, 56872,
     /* 2369263 */     GIR_EraseRootFromParent_Done,
     /* 2369264 */   // Label 33169: @2369264
     /* 2369264 */   GIM_Try, /*On fail goto*//*Label 33170*/ GIMT_Encode4(2369309), // Rule ID 56873 //
     /* 2369269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2369272 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2369275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2369289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369308 */     // GIR_Coverage, 56873,
     /* 2369308 */     GIR_EraseRootFromParent_Done,
     /* 2369309 */   // Label 33170: @2369309
     /* 2369309 */   GIM_Reject,
     /* 2369310 */ // Label 33168: @2369310
     /* 2369310 */ GIM_Reject,
     /* 2369311 */ // Label 33123: @2369311
     /* 2369311 */ GIM_Try, /*On fail goto*//*Label 33171*/ GIMT_Encode4(2369425),
     /* 2369316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2369319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2369322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369334 */   GIM_Try, /*On fail goto*//*Label 33172*/ GIMT_Encode4(2369379), // Rule ID 56896 //
     /* 2369339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2369342 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2369345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2369359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369378 */     // GIR_Coverage, 56896,
     /* 2369378 */     GIR_EraseRootFromParent_Done,
     /* 2369379 */   // Label 33172: @2369379
     /* 2369379 */   GIM_Try, /*On fail goto*//*Label 33173*/ GIMT_Encode4(2369424), // Rule ID 56897 //
     /* 2369384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2369387 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2369390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2369404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369423 */     // GIR_Coverage, 56897,
     /* 2369423 */     GIR_EraseRootFromParent_Done,
     /* 2369424 */   // Label 33173: @2369424
     /* 2369424 */   GIM_Reject,
     /* 2369425 */ // Label 33171: @2369425
     /* 2369425 */ GIM_Reject,
     /* 2369426 */ // Label 33124: @2369426
     /* 2369426 */ GIM_Try, /*On fail goto*//*Label 33174*/ GIMT_Encode4(2369540),
     /* 2369431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2369434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2369437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369449 */   GIM_Try, /*On fail goto*//*Label 33175*/ GIMT_Encode4(2369494), // Rule ID 56854 //
     /* 2369454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2369457 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2369460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2369474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369493 */     // GIR_Coverage, 56854,
     /* 2369493 */     GIR_EraseRootFromParent_Done,
     /* 2369494 */   // Label 33175: @2369494
     /* 2369494 */   GIM_Try, /*On fail goto*//*Label 33176*/ GIMT_Encode4(2369539), // Rule ID 56855 //
     /* 2369499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2369502 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2369505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2369519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369538 */     // GIR_Coverage, 56855,
     /* 2369538 */     GIR_EraseRootFromParent_Done,
     /* 2369539 */   // Label 33176: @2369539
     /* 2369539 */   GIM_Reject,
     /* 2369540 */ // Label 33174: @2369540
     /* 2369540 */ GIM_Reject,
     /* 2369541 */ // Label 33125: @2369541
     /* 2369541 */ GIM_Try, /*On fail goto*//*Label 33177*/ GIMT_Encode4(2369655),
     /* 2369546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2369549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2369552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369564 */   GIM_Try, /*On fail goto*//*Label 33178*/ GIMT_Encode4(2369609), // Rule ID 56878 //
     /* 2369569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2369572 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2369575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2369589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369608 */     // GIR_Coverage, 56878,
     /* 2369608 */     GIR_EraseRootFromParent_Done,
     /* 2369609 */   // Label 33178: @2369609
     /* 2369609 */   GIM_Try, /*On fail goto*//*Label 33179*/ GIMT_Encode4(2369654), // Rule ID 56879 //
     /* 2369614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2369617 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2369620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2369634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369653 */     // GIR_Coverage, 56879,
     /* 2369653 */     GIR_EraseRootFromParent_Done,
     /* 2369654 */   // Label 33179: @2369654
     /* 2369654 */   GIM_Reject,
     /* 2369655 */ // Label 33177: @2369655
     /* 2369655 */ GIM_Reject,
     /* 2369656 */ // Label 33126: @2369656
     /* 2369656 */ GIM_Try, /*On fail goto*//*Label 33180*/ GIMT_Encode4(2369770),
     /* 2369661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2369664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2369667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369679 */   GIM_Try, /*On fail goto*//*Label 33181*/ GIMT_Encode4(2369724), // Rule ID 56860 //
     /* 2369684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2369687 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2369690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2369704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369723 */     // GIR_Coverage, 56860,
     /* 2369723 */     GIR_EraseRootFromParent_Done,
     /* 2369724 */   // Label 33181: @2369724
     /* 2369724 */   GIM_Try, /*On fail goto*//*Label 33182*/ GIMT_Encode4(2369769), // Rule ID 56861 //
     /* 2369729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2369732 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2369735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2369749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369768 */     // GIR_Coverage, 56861,
     /* 2369768 */     GIR_EraseRootFromParent_Done,
     /* 2369769 */   // Label 33182: @2369769
     /* 2369769 */   GIM_Reject,
     /* 2369770 */ // Label 33180: @2369770
     /* 2369770 */ GIM_Reject,
     /* 2369771 */ // Label 33127: @2369771
     /* 2369771 */ GIM_Reject,
     /* 2369772 */ // Label 80: @2369772
     /* 2369772 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33207*/ GIMT_Encode4(2372547),
     /* 2369783 */ /*GILLT_s32*//*Label 33183*/ GIMT_Encode4(2369907),
     /* 2369787 */ /*GILLT_s64*//*Label 33184*/ GIMT_Encode4(2369962), GIMT_Encode4(0),
     /* 2369795 */ /*GILLT_nxv1s8*//*Label 33185*/ GIMT_Encode4(2370017),
     /* 2369799 */ /*GILLT_nxv1s16*//*Label 33186*/ GIMT_Encode4(2370132),
     /* 2369803 */ /*GILLT_nxv1s32*//*Label 33187*/ GIMT_Encode4(2370247),
     /* 2369807 */ /*GILLT_nxv1s64*//*Label 33188*/ GIMT_Encode4(2370362), GIMT_Encode4(0),
     /* 2369815 */ /*GILLT_nxv2s8*//*Label 33189*/ GIMT_Encode4(2370477),
     /* 2369819 */ /*GILLT_nxv2s16*//*Label 33190*/ GIMT_Encode4(2370592),
     /* 2369823 */ /*GILLT_nxv2s32*//*Label 33191*/ GIMT_Encode4(2370707),
     /* 2369827 */ /*GILLT_nxv2s64*//*Label 33192*/ GIMT_Encode4(2370822), GIMT_Encode4(0),
     /* 2369835 */ /*GILLT_nxv4s8*//*Label 33193*/ GIMT_Encode4(2370937),
     /* 2369839 */ /*GILLT_nxv4s16*//*Label 33194*/ GIMT_Encode4(2371052),
     /* 2369843 */ /*GILLT_nxv4s32*//*Label 33195*/ GIMT_Encode4(2371167),
     /* 2369847 */ /*GILLT_nxv4s64*//*Label 33196*/ GIMT_Encode4(2371282), GIMT_Encode4(0),
     /* 2369855 */ /*GILLT_nxv8s8*//*Label 33197*/ GIMT_Encode4(2371397),
     /* 2369859 */ /*GILLT_nxv8s16*//*Label 33198*/ GIMT_Encode4(2371512),
     /* 2369863 */ /*GILLT_nxv8s32*//*Label 33199*/ GIMT_Encode4(2371627),
     /* 2369867 */ /*GILLT_nxv8s64*//*Label 33200*/ GIMT_Encode4(2371742), GIMT_Encode4(0),
     /* 2369875 */ /*GILLT_nxv16s8*//*Label 33201*/ GIMT_Encode4(2371857),
     /* 2369879 */ /*GILLT_nxv16s16*//*Label 33202*/ GIMT_Encode4(2371972),
     /* 2369883 */ /*GILLT_nxv16s32*//*Label 33203*/ GIMT_Encode4(2372087), GIMT_Encode4(0),
     /* 2369891 */ /*GILLT_nxv32s8*//*Label 33204*/ GIMT_Encode4(2372202),
     /* 2369895 */ /*GILLT_nxv32s16*//*Label 33205*/ GIMT_Encode4(2372317), GIMT_Encode4(0),
     /* 2369903 */ /*GILLT_nxv64s8*//*Label 33206*/ GIMT_Encode4(2372432),
     /* 2369907 */ // Label 33183: @2369907
     /* 2369907 */ GIM_Try, /*On fail goto*//*Label 33208*/ GIMT_Encode4(2369961),
     /* 2369912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2369915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2369918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369930 */   GIM_Try, /*On fail goto*//*Label 33209*/ GIMT_Encode4(2369945), // Rule ID 64474 //
     /* 2369935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2369938 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2369938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2369943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369944 */     // GIR_Coverage, 64474,
     /* 2369944 */     GIR_Done,
     /* 2369945 */   // Label 33209: @2369945
     /* 2369945 */   GIM_Try, /*On fail goto*//*Label 33210*/ GIMT_Encode4(2369960), // Rule ID 2539 //
     /* 2369950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2369953 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2369953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2369958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369959 */     // GIR_Coverage, 2539,
     /* 2369959 */     GIR_Done,
     /* 2369960 */   // Label 33210: @2369960
     /* 2369960 */   GIM_Reject,
     /* 2369961 */ // Label 33208: @2369961
     /* 2369961 */ GIM_Reject,
     /* 2369962 */ // Label 33184: @2369962
     /* 2369962 */ GIM_Try, /*On fail goto*//*Label 33211*/ GIMT_Encode4(2370016),
     /* 2369967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2369970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2369973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369985 */   GIM_Try, /*On fail goto*//*Label 33212*/ GIMT_Encode4(2370000), // Rule ID 64473 //
     /* 2369990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2369993 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2369993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2369998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369999 */     // GIR_Coverage, 64473,
     /* 2369999 */     GIR_Done,
     /* 2370000 */   // Label 33212: @2370000
     /* 2370000 */   GIM_Try, /*On fail goto*//*Label 33213*/ GIMT_Encode4(2370015), // Rule ID 2538 //
     /* 2370005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2370008 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2370008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2370013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370014 */     // GIR_Coverage, 2538,
     /* 2370014 */     GIR_Done,
     /* 2370015 */   // Label 33213: @2370015
     /* 2370015 */   GIM_Reject,
     /* 2370016 */ // Label 33211: @2370016
     /* 2370016 */ GIM_Reject,
     /* 2370017 */ // Label 33185: @2370017
     /* 2370017 */ GIM_Try, /*On fail goto*//*Label 33214*/ GIMT_Encode4(2370131),
     /* 2370022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2370025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2370028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370040 */   GIM_Try, /*On fail goto*//*Label 33215*/ GIMT_Encode4(2370085), // Rule ID 50604 //
     /* 2370045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370048 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2370051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2370065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370084 */     // GIR_Coverage, 50604,
     /* 2370084 */     GIR_EraseRootFromParent_Done,
     /* 2370085 */   // Label 33215: @2370085
     /* 2370085 */   GIM_Try, /*On fail goto*//*Label 33216*/ GIMT_Encode4(2370130), // Rule ID 50605 //
     /* 2370090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370093 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2370096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2370110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370129 */     // GIR_Coverage, 50605,
     /* 2370129 */     GIR_EraseRootFromParent_Done,
     /* 2370130 */   // Label 33216: @2370130
     /* 2370130 */   GIM_Reject,
     /* 2370131 */ // Label 33214: @2370131
     /* 2370131 */ GIM_Reject,
     /* 2370132 */ // Label 33186: @2370132
     /* 2370132 */ GIM_Try, /*On fail goto*//*Label 33217*/ GIMT_Encode4(2370246),
     /* 2370137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2370140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2370143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370155 */   GIM_Try, /*On fail goto*//*Label 33218*/ GIMT_Encode4(2370200), // Rule ID 50616 //
     /* 2370160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370163 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2370166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2370180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370199 */     // GIR_Coverage, 50616,
     /* 2370199 */     GIR_EraseRootFromParent_Done,
     /* 2370200 */   // Label 33218: @2370200
     /* 2370200 */   GIM_Try, /*On fail goto*//*Label 33219*/ GIMT_Encode4(2370245), // Rule ID 50617 //
     /* 2370205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370208 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2370211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2370225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370244 */     // GIR_Coverage, 50617,
     /* 2370244 */     GIR_EraseRootFromParent_Done,
     /* 2370245 */   // Label 33219: @2370245
     /* 2370245 */   GIM_Reject,
     /* 2370246 */ // Label 33217: @2370246
     /* 2370246 */ GIM_Reject,
     /* 2370247 */ // Label 33187: @2370247
     /* 2370247 */ GIM_Try, /*On fail goto*//*Label 33220*/ GIMT_Encode4(2370361),
     /* 2370252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2370255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2370258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370270 */   GIM_Try, /*On fail goto*//*Label 33221*/ GIMT_Encode4(2370315), // Rule ID 50624 //
     /* 2370275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370278 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2370281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2370295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370314 */     // GIR_Coverage, 50624,
     /* 2370314 */     GIR_EraseRootFromParent_Done,
     /* 2370315 */   // Label 33221: @2370315
     /* 2370315 */   GIM_Try, /*On fail goto*//*Label 33222*/ GIMT_Encode4(2370360), // Rule ID 50625 //
     /* 2370320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370323 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2370326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2370340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370359 */     // GIR_Coverage, 50625,
     /* 2370359 */     GIR_EraseRootFromParent_Done,
     /* 2370360 */   // Label 33222: @2370360
     /* 2370360 */   GIM_Reject,
     /* 2370361 */ // Label 33220: @2370361
     /* 2370361 */ GIM_Reject,
     /* 2370362 */ // Label 33188: @2370362
     /* 2370362 */ GIM_Try, /*On fail goto*//*Label 33223*/ GIMT_Encode4(2370476),
     /* 2370367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2370370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2370373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370385 */   GIM_Try, /*On fail goto*//*Label 33224*/ GIMT_Encode4(2370430), // Rule ID 50640 //
     /* 2370390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2370393 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2370396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2370410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370429 */     // GIR_Coverage, 50640,
     /* 2370429 */     GIR_EraseRootFromParent_Done,
     /* 2370430 */   // Label 33224: @2370430
     /* 2370430 */   GIM_Try, /*On fail goto*//*Label 33225*/ GIMT_Encode4(2370475), // Rule ID 50641 //
     /* 2370435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2370438 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2370441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2370455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370474 */     // GIR_Coverage, 50641,
     /* 2370474 */     GIR_EraseRootFromParent_Done,
     /* 2370475 */   // Label 33225: @2370475
     /* 2370475 */   GIM_Reject,
     /* 2370476 */ // Label 33223: @2370476
     /* 2370476 */ GIM_Reject,
     /* 2370477 */ // Label 33189: @2370477
     /* 2370477 */ GIM_Try, /*On fail goto*//*Label 33226*/ GIMT_Encode4(2370591),
     /* 2370482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2370485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2370488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370500 */   GIM_Try, /*On fail goto*//*Label 33227*/ GIMT_Encode4(2370545), // Rule ID 50608 //
     /* 2370505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370508 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2370511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2370525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370544 */     // GIR_Coverage, 50608,
     /* 2370544 */     GIR_EraseRootFromParent_Done,
     /* 2370545 */   // Label 33227: @2370545
     /* 2370545 */   GIM_Try, /*On fail goto*//*Label 33228*/ GIMT_Encode4(2370590), // Rule ID 50609 //
     /* 2370550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370553 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2370556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2370570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370589 */     // GIR_Coverage, 50609,
     /* 2370589 */     GIR_EraseRootFromParent_Done,
     /* 2370590 */   // Label 33228: @2370590
     /* 2370590 */   GIM_Reject,
     /* 2370591 */ // Label 33226: @2370591
     /* 2370591 */ GIM_Reject,
     /* 2370592 */ // Label 33190: @2370592
     /* 2370592 */ GIM_Try, /*On fail goto*//*Label 33229*/ GIMT_Encode4(2370706),
     /* 2370597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2370600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2370603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370615 */   GIM_Try, /*On fail goto*//*Label 33230*/ GIMT_Encode4(2370660), // Rule ID 50620 //
     /* 2370620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370623 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2370626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2370640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370659 */     // GIR_Coverage, 50620,
     /* 2370659 */     GIR_EraseRootFromParent_Done,
     /* 2370660 */   // Label 33230: @2370660
     /* 2370660 */   GIM_Try, /*On fail goto*//*Label 33231*/ GIMT_Encode4(2370705), // Rule ID 50621 //
     /* 2370665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370668 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2370671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2370685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370704 */     // GIR_Coverage, 50621,
     /* 2370704 */     GIR_EraseRootFromParent_Done,
     /* 2370705 */   // Label 33231: @2370705
     /* 2370705 */   GIM_Reject,
     /* 2370706 */ // Label 33229: @2370706
     /* 2370706 */ GIM_Reject,
     /* 2370707 */ // Label 33191: @2370707
     /* 2370707 */ GIM_Try, /*On fail goto*//*Label 33232*/ GIMT_Encode4(2370821),
     /* 2370712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2370715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2370718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370730 */   GIM_Try, /*On fail goto*//*Label 33233*/ GIMT_Encode4(2370775), // Rule ID 50636 //
     /* 2370735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370738 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2370741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2370755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370774 */     // GIR_Coverage, 50636,
     /* 2370774 */     GIR_EraseRootFromParent_Done,
     /* 2370775 */   // Label 33233: @2370775
     /* 2370775 */   GIM_Try, /*On fail goto*//*Label 33234*/ GIMT_Encode4(2370820), // Rule ID 50637 //
     /* 2370780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370783 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2370786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2370800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370819 */     // GIR_Coverage, 50637,
     /* 2370819 */     GIR_EraseRootFromParent_Done,
     /* 2370820 */   // Label 33234: @2370820
     /* 2370820 */   GIM_Reject,
     /* 2370821 */ // Label 33232: @2370821
     /* 2370821 */ GIM_Reject,
     /* 2370822 */ // Label 33192: @2370822
     /* 2370822 */ GIM_Try, /*On fail goto*//*Label 33235*/ GIMT_Encode4(2370936),
     /* 2370827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2370830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2370833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370845 */   GIM_Try, /*On fail goto*//*Label 33236*/ GIMT_Encode4(2370890), // Rule ID 50680 //
     /* 2370850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2370853 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2370856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2370870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370889 */     // GIR_Coverage, 50680,
     /* 2370889 */     GIR_EraseRootFromParent_Done,
     /* 2370890 */   // Label 33236: @2370890
     /* 2370890 */   GIM_Try, /*On fail goto*//*Label 33237*/ GIMT_Encode4(2370935), // Rule ID 50681 //
     /* 2370895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2370898 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2370901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2370915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370934 */     // GIR_Coverage, 50681,
     /* 2370934 */     GIR_EraseRootFromParent_Done,
     /* 2370935 */   // Label 33237: @2370935
     /* 2370935 */   GIM_Reject,
     /* 2370936 */ // Label 33235: @2370936
     /* 2370936 */ GIM_Reject,
     /* 2370937 */ // Label 33193: @2370937
     /* 2370937 */ GIM_Try, /*On fail goto*//*Label 33238*/ GIMT_Encode4(2371051),
     /* 2370942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2370945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2370948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370960 */   GIM_Try, /*On fail goto*//*Label 33239*/ GIMT_Encode4(2371005), // Rule ID 50612 //
     /* 2370965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370968 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2370971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2370985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371004 */     // GIR_Coverage, 50612,
     /* 2371004 */     GIR_EraseRootFromParent_Done,
     /* 2371005 */   // Label 33239: @2371005
     /* 2371005 */   GIM_Try, /*On fail goto*//*Label 33240*/ GIMT_Encode4(2371050), // Rule ID 50613 //
     /* 2371010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371013 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2371016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2371030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371049 */     // GIR_Coverage, 50613,
     /* 2371049 */     GIR_EraseRootFromParent_Done,
     /* 2371050 */   // Label 33240: @2371050
     /* 2371050 */   GIM_Reject,
     /* 2371051 */ // Label 33238: @2371051
     /* 2371051 */ GIM_Reject,
     /* 2371052 */ // Label 33194: @2371052
     /* 2371052 */ GIM_Try, /*On fail goto*//*Label 33241*/ GIMT_Encode4(2371166),
     /* 2371057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2371060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2371063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371075 */   GIM_Try, /*On fail goto*//*Label 33242*/ GIMT_Encode4(2371120), // Rule ID 50632 //
     /* 2371080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371083 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2371086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2371100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371119 */     // GIR_Coverage, 50632,
     /* 2371119 */     GIR_EraseRootFromParent_Done,
     /* 2371120 */   // Label 33242: @2371120
     /* 2371120 */   GIM_Try, /*On fail goto*//*Label 33243*/ GIMT_Encode4(2371165), // Rule ID 50633 //
     /* 2371125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371128 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2371131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2371145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371164 */     // GIR_Coverage, 50633,
     /* 2371164 */     GIR_EraseRootFromParent_Done,
     /* 2371165 */   // Label 33243: @2371165
     /* 2371165 */   GIM_Reject,
     /* 2371166 */ // Label 33241: @2371166
     /* 2371166 */ GIM_Reject,
     /* 2371167 */ // Label 33195: @2371167
     /* 2371167 */ GIM_Try, /*On fail goto*//*Label 33244*/ GIMT_Encode4(2371281),
     /* 2371172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2371175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2371178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371190 */   GIM_Try, /*On fail goto*//*Label 33245*/ GIMT_Encode4(2371235), // Rule ID 50668 //
     /* 2371195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371198 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2371201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2371215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371234 */     // GIR_Coverage, 50668,
     /* 2371234 */     GIR_EraseRootFromParent_Done,
     /* 2371235 */   // Label 33245: @2371235
     /* 2371235 */   GIM_Try, /*On fail goto*//*Label 33246*/ GIMT_Encode4(2371280), // Rule ID 50669 //
     /* 2371240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371243 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2371246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2371260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371279 */     // GIR_Coverage, 50669,
     /* 2371279 */     GIR_EraseRootFromParent_Done,
     /* 2371280 */   // Label 33246: @2371280
     /* 2371280 */   GIM_Reject,
     /* 2371281 */ // Label 33244: @2371281
     /* 2371281 */ GIM_Reject,
     /* 2371282 */ // Label 33196: @2371282
     /* 2371282 */ GIM_Try, /*On fail goto*//*Label 33247*/ GIMT_Encode4(2371396),
     /* 2371287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2371290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2371293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371305 */   GIM_Try, /*On fail goto*//*Label 33248*/ GIMT_Encode4(2371350), // Rule ID 50684 //
     /* 2371310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2371313 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2371316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2371330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371349 */     // GIR_Coverage, 50684,
     /* 2371349 */     GIR_EraseRootFromParent_Done,
     /* 2371350 */   // Label 33248: @2371350
     /* 2371350 */   GIM_Try, /*On fail goto*//*Label 33249*/ GIMT_Encode4(2371395), // Rule ID 50685 //
     /* 2371355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2371358 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2371361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2371375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371394 */     // GIR_Coverage, 50685,
     /* 2371394 */     GIR_EraseRootFromParent_Done,
     /* 2371395 */   // Label 33249: @2371395
     /* 2371395 */   GIM_Reject,
     /* 2371396 */ // Label 33247: @2371396
     /* 2371396 */ GIM_Reject,
     /* 2371397 */ // Label 33197: @2371397
     /* 2371397 */ GIM_Try, /*On fail goto*//*Label 33250*/ GIMT_Encode4(2371511),
     /* 2371402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2371405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2371408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371420 */   GIM_Try, /*On fail goto*//*Label 33251*/ GIMT_Encode4(2371465), // Rule ID 50628 //
     /* 2371425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371428 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2371431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2371445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371464 */     // GIR_Coverage, 50628,
     /* 2371464 */     GIR_EraseRootFromParent_Done,
     /* 2371465 */   // Label 33251: @2371465
     /* 2371465 */   GIM_Try, /*On fail goto*//*Label 33252*/ GIMT_Encode4(2371510), // Rule ID 50629 //
     /* 2371470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371473 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2371476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2371490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371509 */     // GIR_Coverage, 50629,
     /* 2371509 */     GIR_EraseRootFromParent_Done,
     /* 2371510 */   // Label 33252: @2371510
     /* 2371510 */   GIM_Reject,
     /* 2371511 */ // Label 33250: @2371511
     /* 2371511 */ GIM_Reject,
     /* 2371512 */ // Label 33198: @2371512
     /* 2371512 */ GIM_Try, /*On fail goto*//*Label 33253*/ GIMT_Encode4(2371626),
     /* 2371517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2371520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2371523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371535 */   GIM_Try, /*On fail goto*//*Label 33254*/ GIMT_Encode4(2371580), // Rule ID 50656 //
     /* 2371540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371543 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2371546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2371560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371579 */     // GIR_Coverage, 50656,
     /* 2371579 */     GIR_EraseRootFromParent_Done,
     /* 2371580 */   // Label 33254: @2371580
     /* 2371580 */   GIM_Try, /*On fail goto*//*Label 33255*/ GIMT_Encode4(2371625), // Rule ID 50657 //
     /* 2371585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371588 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2371591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2371605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371624 */     // GIR_Coverage, 50657,
     /* 2371624 */     GIR_EraseRootFromParent_Done,
     /* 2371625 */   // Label 33255: @2371625
     /* 2371625 */   GIM_Reject,
     /* 2371626 */ // Label 33253: @2371626
     /* 2371626 */ GIM_Reject,
     /* 2371627 */ // Label 33199: @2371627
     /* 2371627 */ GIM_Try, /*On fail goto*//*Label 33256*/ GIMT_Encode4(2371741),
     /* 2371632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2371635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2371638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371650 */   GIM_Try, /*On fail goto*//*Label 33257*/ GIMT_Encode4(2371695), // Rule ID 50672 //
     /* 2371655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371658 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2371661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2371675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371694 */     // GIR_Coverage, 50672,
     /* 2371694 */     GIR_EraseRootFromParent_Done,
     /* 2371695 */   // Label 33257: @2371695
     /* 2371695 */   GIM_Try, /*On fail goto*//*Label 33258*/ GIMT_Encode4(2371740), // Rule ID 50673 //
     /* 2371700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371703 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2371706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2371720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371739 */     // GIR_Coverage, 50673,
     /* 2371739 */     GIR_EraseRootFromParent_Done,
     /* 2371740 */   // Label 33258: @2371740
     /* 2371740 */   GIM_Reject,
     /* 2371741 */ // Label 33256: @2371741
     /* 2371741 */ GIM_Reject,
     /* 2371742 */ // Label 33200: @2371742
     /* 2371742 */ GIM_Try, /*On fail goto*//*Label 33259*/ GIMT_Encode4(2371856),
     /* 2371747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2371750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2371753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371765 */   GIM_Try, /*On fail goto*//*Label 33260*/ GIMT_Encode4(2371810), // Rule ID 50688 //
     /* 2371770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2371773 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2371776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2371790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371809 */     // GIR_Coverage, 50688,
     /* 2371809 */     GIR_EraseRootFromParent_Done,
     /* 2371810 */   // Label 33260: @2371810
     /* 2371810 */   GIM_Try, /*On fail goto*//*Label 33261*/ GIMT_Encode4(2371855), // Rule ID 50689 //
     /* 2371815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2371818 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2371821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2371835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371854 */     // GIR_Coverage, 50689,
     /* 2371854 */     GIR_EraseRootFromParent_Done,
     /* 2371855 */   // Label 33261: @2371855
     /* 2371855 */   GIM_Reject,
     /* 2371856 */ // Label 33259: @2371856
     /* 2371856 */ GIM_Reject,
     /* 2371857 */ // Label 33201: @2371857
     /* 2371857 */ GIM_Try, /*On fail goto*//*Label 33262*/ GIMT_Encode4(2371971),
     /* 2371862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2371865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2371868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371880 */   GIM_Try, /*On fail goto*//*Label 33263*/ GIMT_Encode4(2371925), // Rule ID 50644 //
     /* 2371885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371888 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2371891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2371905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371924 */     // GIR_Coverage, 50644,
     /* 2371924 */     GIR_EraseRootFromParent_Done,
     /* 2371925 */   // Label 33263: @2371925
     /* 2371925 */   GIM_Try, /*On fail goto*//*Label 33264*/ GIMT_Encode4(2371970), // Rule ID 50645 //
     /* 2371930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371933 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2371936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2371950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371969 */     // GIR_Coverage, 50645,
     /* 2371969 */     GIR_EraseRootFromParent_Done,
     /* 2371970 */   // Label 33264: @2371970
     /* 2371970 */   GIM_Reject,
     /* 2371971 */ // Label 33262: @2371971
     /* 2371971 */ GIM_Reject,
     /* 2371972 */ // Label 33202: @2371972
     /* 2371972 */ GIM_Try, /*On fail goto*//*Label 33265*/ GIMT_Encode4(2372086),
     /* 2371977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2371980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2371983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371995 */   GIM_Try, /*On fail goto*//*Label 33266*/ GIMT_Encode4(2372040), // Rule ID 50660 //
     /* 2372000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372003 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2372006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2372020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372039 */     // GIR_Coverage, 50660,
     /* 2372039 */     GIR_EraseRootFromParent_Done,
     /* 2372040 */   // Label 33266: @2372040
     /* 2372040 */   GIM_Try, /*On fail goto*//*Label 33267*/ GIMT_Encode4(2372085), // Rule ID 50661 //
     /* 2372045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372048 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2372051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2372065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372084 */     // GIR_Coverage, 50661,
     /* 2372084 */     GIR_EraseRootFromParent_Done,
     /* 2372085 */   // Label 33267: @2372085
     /* 2372085 */   GIM_Reject,
     /* 2372086 */ // Label 33265: @2372086
     /* 2372086 */ GIM_Reject,
     /* 2372087 */ // Label 33203: @2372087
     /* 2372087 */ GIM_Try, /*On fail goto*//*Label 33268*/ GIMT_Encode4(2372201),
     /* 2372092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2372095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2372098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372106 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372110 */   GIM_Try, /*On fail goto*//*Label 33269*/ GIMT_Encode4(2372155), // Rule ID 50676 //
     /* 2372115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372118 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2372121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2372135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372154 */     // GIR_Coverage, 50676,
     /* 2372154 */     GIR_EraseRootFromParent_Done,
     /* 2372155 */   // Label 33269: @2372155
     /* 2372155 */   GIM_Try, /*On fail goto*//*Label 33270*/ GIMT_Encode4(2372200), // Rule ID 50677 //
     /* 2372160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372163 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2372166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2372180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372199 */     // GIR_Coverage, 50677,
     /* 2372199 */     GIR_EraseRootFromParent_Done,
     /* 2372200 */   // Label 33270: @2372200
     /* 2372200 */   GIM_Reject,
     /* 2372201 */ // Label 33268: @2372201
     /* 2372201 */ GIM_Reject,
     /* 2372202 */ // Label 33204: @2372202
     /* 2372202 */ GIM_Try, /*On fail goto*//*Label 33271*/ GIMT_Encode4(2372316),
     /* 2372207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2372210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2372213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372225 */   GIM_Try, /*On fail goto*//*Label 33272*/ GIMT_Encode4(2372270), // Rule ID 50648 //
     /* 2372230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372233 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2372236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2372250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372269 */     // GIR_Coverage, 50648,
     /* 2372269 */     GIR_EraseRootFromParent_Done,
     /* 2372270 */   // Label 33272: @2372270
     /* 2372270 */   GIM_Try, /*On fail goto*//*Label 33273*/ GIMT_Encode4(2372315), // Rule ID 50649 //
     /* 2372275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372278 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2372281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2372295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372314 */     // GIR_Coverage, 50649,
     /* 2372314 */     GIR_EraseRootFromParent_Done,
     /* 2372315 */   // Label 33273: @2372315
     /* 2372315 */   GIM_Reject,
     /* 2372316 */ // Label 33271: @2372316
     /* 2372316 */ GIM_Reject,
     /* 2372317 */ // Label 33205: @2372317
     /* 2372317 */ GIM_Try, /*On fail goto*//*Label 33274*/ GIMT_Encode4(2372431),
     /* 2372322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2372325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2372328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372336 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372340 */   GIM_Try, /*On fail goto*//*Label 33275*/ GIMT_Encode4(2372385), // Rule ID 50664 //
     /* 2372345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372348 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2372351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2372365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372384 */     // GIR_Coverage, 50664,
     /* 2372384 */     GIR_EraseRootFromParent_Done,
     /* 2372385 */   // Label 33275: @2372385
     /* 2372385 */   GIM_Try, /*On fail goto*//*Label 33276*/ GIMT_Encode4(2372430), // Rule ID 50665 //
     /* 2372390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372393 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2372396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2372410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372429 */     // GIR_Coverage, 50665,
     /* 2372429 */     GIR_EraseRootFromParent_Done,
     /* 2372430 */   // Label 33276: @2372430
     /* 2372430 */   GIM_Reject,
     /* 2372431 */ // Label 33274: @2372431
     /* 2372431 */ GIM_Reject,
     /* 2372432 */ // Label 33206: @2372432
     /* 2372432 */ GIM_Try, /*On fail goto*//*Label 33277*/ GIMT_Encode4(2372546),
     /* 2372437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2372440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2372443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372451 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372455 */   GIM_Try, /*On fail goto*//*Label 33278*/ GIMT_Encode4(2372500), // Rule ID 50652 //
     /* 2372460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372463 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2372466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2372480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372499 */     // GIR_Coverage, 50652,
     /* 2372499 */     GIR_EraseRootFromParent_Done,
     /* 2372500 */   // Label 33278: @2372500
     /* 2372500 */   GIM_Try, /*On fail goto*//*Label 33279*/ GIMT_Encode4(2372545), // Rule ID 50653 //
     /* 2372505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372508 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2372511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2372525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372544 */     // GIR_Coverage, 50653,
     /* 2372544 */     GIR_EraseRootFromParent_Done,
     /* 2372545 */   // Label 33279: @2372545
     /* 2372545 */   GIM_Reject,
     /* 2372546 */ // Label 33277: @2372546
     /* 2372546 */ GIM_Reject,
     /* 2372547 */ // Label 33207: @2372547
     /* 2372547 */ GIM_Reject,
     /* 2372548 */ // Label 81: @2372548
     /* 2372548 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33304*/ GIMT_Encode4(2375323),
     /* 2372559 */ /*GILLT_s32*//*Label 33280*/ GIMT_Encode4(2372683),
     /* 2372563 */ /*GILLT_s64*//*Label 33281*/ GIMT_Encode4(2372738), GIMT_Encode4(0),
     /* 2372571 */ /*GILLT_nxv1s8*//*Label 33282*/ GIMT_Encode4(2372793),
     /* 2372575 */ /*GILLT_nxv1s16*//*Label 33283*/ GIMT_Encode4(2372908),
     /* 2372579 */ /*GILLT_nxv1s32*//*Label 33284*/ GIMT_Encode4(2373023),
     /* 2372583 */ /*GILLT_nxv1s64*//*Label 33285*/ GIMT_Encode4(2373138), GIMT_Encode4(0),
     /* 2372591 */ /*GILLT_nxv2s8*//*Label 33286*/ GIMT_Encode4(2373253),
     /* 2372595 */ /*GILLT_nxv2s16*//*Label 33287*/ GIMT_Encode4(2373368),
     /* 2372599 */ /*GILLT_nxv2s32*//*Label 33288*/ GIMT_Encode4(2373483),
     /* 2372603 */ /*GILLT_nxv2s64*//*Label 33289*/ GIMT_Encode4(2373598), GIMT_Encode4(0),
     /* 2372611 */ /*GILLT_nxv4s8*//*Label 33290*/ GIMT_Encode4(2373713),
     /* 2372615 */ /*GILLT_nxv4s16*//*Label 33291*/ GIMT_Encode4(2373828),
     /* 2372619 */ /*GILLT_nxv4s32*//*Label 33292*/ GIMT_Encode4(2373943),
     /* 2372623 */ /*GILLT_nxv4s64*//*Label 33293*/ GIMT_Encode4(2374058), GIMT_Encode4(0),
     /* 2372631 */ /*GILLT_nxv8s8*//*Label 33294*/ GIMT_Encode4(2374173),
     /* 2372635 */ /*GILLT_nxv8s16*//*Label 33295*/ GIMT_Encode4(2374288),
     /* 2372639 */ /*GILLT_nxv8s32*//*Label 33296*/ GIMT_Encode4(2374403),
     /* 2372643 */ /*GILLT_nxv8s64*//*Label 33297*/ GIMT_Encode4(2374518), GIMT_Encode4(0),
     /* 2372651 */ /*GILLT_nxv16s8*//*Label 33298*/ GIMT_Encode4(2374633),
     /* 2372655 */ /*GILLT_nxv16s16*//*Label 33299*/ GIMT_Encode4(2374748),
     /* 2372659 */ /*GILLT_nxv16s32*//*Label 33300*/ GIMT_Encode4(2374863), GIMT_Encode4(0),
     /* 2372667 */ /*GILLT_nxv32s8*//*Label 33301*/ GIMT_Encode4(2374978),
     /* 2372671 */ /*GILLT_nxv32s16*//*Label 33302*/ GIMT_Encode4(2375093), GIMT_Encode4(0),
     /* 2372679 */ /*GILLT_nxv64s8*//*Label 33303*/ GIMT_Encode4(2375208),
     /* 2372683 */ // Label 33280: @2372683
     /* 2372683 */ GIM_Try, /*On fail goto*//*Label 33305*/ GIMT_Encode4(2372737),
     /* 2372688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2372691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2372694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372706 */   GIM_Try, /*On fail goto*//*Label 33306*/ GIMT_Encode4(2372721), // Rule ID 64478 //
     /* 2372711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2372714 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2372714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2372719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372720 */     // GIR_Coverage, 64478,
     /* 2372720 */     GIR_Done,
     /* 2372721 */   // Label 33306: @2372721
     /* 2372721 */   GIM_Try, /*On fail goto*//*Label 33307*/ GIMT_Encode4(2372736), // Rule ID 2541 //
     /* 2372726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2372729 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2372729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2372734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372735 */     // GIR_Coverage, 2541,
     /* 2372735 */     GIR_Done,
     /* 2372736 */   // Label 33307: @2372736
     /* 2372736 */   GIM_Reject,
     /* 2372737 */ // Label 33305: @2372737
     /* 2372737 */ GIM_Reject,
     /* 2372738 */ // Label 33281: @2372738
     /* 2372738 */ GIM_Try, /*On fail goto*//*Label 33308*/ GIMT_Encode4(2372792),
     /* 2372743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2372746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2372749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372761 */   GIM_Try, /*On fail goto*//*Label 33309*/ GIMT_Encode4(2372776), // Rule ID 64477 //
     /* 2372766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2372769 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2372769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2372774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372775 */     // GIR_Coverage, 64477,
     /* 2372775 */     GIR_Done,
     /* 2372776 */   // Label 33309: @2372776
     /* 2372776 */   GIM_Try, /*On fail goto*//*Label 33310*/ GIMT_Encode4(2372791), // Rule ID 2540 //
     /* 2372781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2372784 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2372784 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2372789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372790 */     // GIR_Coverage, 2540,
     /* 2372790 */     GIR_Done,
     /* 2372791 */   // Label 33310: @2372791
     /* 2372791 */   GIM_Reject,
     /* 2372792 */ // Label 33308: @2372792
     /* 2372792 */ GIM_Reject,
     /* 2372793 */ // Label 33282: @2372793
     /* 2372793 */ GIM_Try, /*On fail goto*//*Label 33311*/ GIMT_Encode4(2372907),
     /* 2372798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2372801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2372804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372816 */   GIM_Try, /*On fail goto*//*Label 33312*/ GIMT_Encode4(2372861), // Rule ID 50780 //
     /* 2372821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372824 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2372827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2372841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372860 */     // GIR_Coverage, 50780,
     /* 2372860 */     GIR_EraseRootFromParent_Done,
     /* 2372861 */   // Label 33312: @2372861
     /* 2372861 */   GIM_Try, /*On fail goto*//*Label 33313*/ GIMT_Encode4(2372906), // Rule ID 50781 //
     /* 2372866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372869 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2372872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2372886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372905 */     // GIR_Coverage, 50781,
     /* 2372905 */     GIR_EraseRootFromParent_Done,
     /* 2372906 */   // Label 33313: @2372906
     /* 2372906 */   GIM_Reject,
     /* 2372907 */ // Label 33311: @2372907
     /* 2372907 */ GIM_Reject,
     /* 2372908 */ // Label 33283: @2372908
     /* 2372908 */ GIM_Try, /*On fail goto*//*Label 33314*/ GIMT_Encode4(2373022),
     /* 2372913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2372916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2372919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372931 */   GIM_Try, /*On fail goto*//*Label 33315*/ GIMT_Encode4(2372976), // Rule ID 50792 //
     /* 2372936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372939 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2372942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2372956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372975 */     // GIR_Coverage, 50792,
     /* 2372975 */     GIR_EraseRootFromParent_Done,
     /* 2372976 */   // Label 33315: @2372976
     /* 2372976 */   GIM_Try, /*On fail goto*//*Label 33316*/ GIMT_Encode4(2373021), // Rule ID 50793 //
     /* 2372981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372984 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2372987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2373001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373020 */     // GIR_Coverage, 50793,
     /* 2373020 */     GIR_EraseRootFromParent_Done,
     /* 2373021 */   // Label 33316: @2373021
     /* 2373021 */   GIM_Reject,
     /* 2373022 */ // Label 33314: @2373022
     /* 2373022 */ GIM_Reject,
     /* 2373023 */ // Label 33284: @2373023
     /* 2373023 */ GIM_Try, /*On fail goto*//*Label 33317*/ GIMT_Encode4(2373137),
     /* 2373028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2373031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2373034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373046 */   GIM_Try, /*On fail goto*//*Label 33318*/ GIMT_Encode4(2373091), // Rule ID 50800 //
     /* 2373051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373054 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2373057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2373071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373090 */     // GIR_Coverage, 50800,
     /* 2373090 */     GIR_EraseRootFromParent_Done,
     /* 2373091 */   // Label 33318: @2373091
     /* 2373091 */   GIM_Try, /*On fail goto*//*Label 33319*/ GIMT_Encode4(2373136), // Rule ID 50801 //
     /* 2373096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373099 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2373102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2373116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373135 */     // GIR_Coverage, 50801,
     /* 2373135 */     GIR_EraseRootFromParent_Done,
     /* 2373136 */   // Label 33319: @2373136
     /* 2373136 */   GIM_Reject,
     /* 2373137 */ // Label 33317: @2373137
     /* 2373137 */ GIM_Reject,
     /* 2373138 */ // Label 33285: @2373138
     /* 2373138 */ GIM_Try, /*On fail goto*//*Label 33320*/ GIMT_Encode4(2373252),
     /* 2373143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2373146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2373149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373161 */   GIM_Try, /*On fail goto*//*Label 33321*/ GIMT_Encode4(2373206), // Rule ID 50816 //
     /* 2373166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2373169 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2373172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2373186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373205 */     // GIR_Coverage, 50816,
     /* 2373205 */     GIR_EraseRootFromParent_Done,
     /* 2373206 */   // Label 33321: @2373206
     /* 2373206 */   GIM_Try, /*On fail goto*//*Label 33322*/ GIMT_Encode4(2373251), // Rule ID 50817 //
     /* 2373211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2373214 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2373217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2373231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373250 */     // GIR_Coverage, 50817,
     /* 2373250 */     GIR_EraseRootFromParent_Done,
     /* 2373251 */   // Label 33322: @2373251
     /* 2373251 */   GIM_Reject,
     /* 2373252 */ // Label 33320: @2373252
     /* 2373252 */ GIM_Reject,
     /* 2373253 */ // Label 33286: @2373253
     /* 2373253 */ GIM_Try, /*On fail goto*//*Label 33323*/ GIMT_Encode4(2373367),
     /* 2373258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2373261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2373264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373276 */   GIM_Try, /*On fail goto*//*Label 33324*/ GIMT_Encode4(2373321), // Rule ID 50784 //
     /* 2373281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373284 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2373287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2373301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373320 */     // GIR_Coverage, 50784,
     /* 2373320 */     GIR_EraseRootFromParent_Done,
     /* 2373321 */   // Label 33324: @2373321
     /* 2373321 */   GIM_Try, /*On fail goto*//*Label 33325*/ GIMT_Encode4(2373366), // Rule ID 50785 //
     /* 2373326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373329 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2373332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2373346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373365 */     // GIR_Coverage, 50785,
     /* 2373365 */     GIR_EraseRootFromParent_Done,
     /* 2373366 */   // Label 33325: @2373366
     /* 2373366 */   GIM_Reject,
     /* 2373367 */ // Label 33323: @2373367
     /* 2373367 */ GIM_Reject,
     /* 2373368 */ // Label 33287: @2373368
     /* 2373368 */ GIM_Try, /*On fail goto*//*Label 33326*/ GIMT_Encode4(2373482),
     /* 2373373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2373376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2373379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373391 */   GIM_Try, /*On fail goto*//*Label 33327*/ GIMT_Encode4(2373436), // Rule ID 50796 //
     /* 2373396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373399 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2373402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2373416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373435 */     // GIR_Coverage, 50796,
     /* 2373435 */     GIR_EraseRootFromParent_Done,
     /* 2373436 */   // Label 33327: @2373436
     /* 2373436 */   GIM_Try, /*On fail goto*//*Label 33328*/ GIMT_Encode4(2373481), // Rule ID 50797 //
     /* 2373441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373444 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2373447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2373461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373480 */     // GIR_Coverage, 50797,
     /* 2373480 */     GIR_EraseRootFromParent_Done,
     /* 2373481 */   // Label 33328: @2373481
     /* 2373481 */   GIM_Reject,
     /* 2373482 */ // Label 33326: @2373482
     /* 2373482 */ GIM_Reject,
     /* 2373483 */ // Label 33288: @2373483
     /* 2373483 */ GIM_Try, /*On fail goto*//*Label 33329*/ GIMT_Encode4(2373597),
     /* 2373488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2373491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2373494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373506 */   GIM_Try, /*On fail goto*//*Label 33330*/ GIMT_Encode4(2373551), // Rule ID 50812 //
     /* 2373511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373514 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2373517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2373531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373550 */     // GIR_Coverage, 50812,
     /* 2373550 */     GIR_EraseRootFromParent_Done,
     /* 2373551 */   // Label 33330: @2373551
     /* 2373551 */   GIM_Try, /*On fail goto*//*Label 33331*/ GIMT_Encode4(2373596), // Rule ID 50813 //
     /* 2373556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373559 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2373562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2373576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373595 */     // GIR_Coverage, 50813,
     /* 2373595 */     GIR_EraseRootFromParent_Done,
     /* 2373596 */   // Label 33331: @2373596
     /* 2373596 */   GIM_Reject,
     /* 2373597 */ // Label 33329: @2373597
     /* 2373597 */ GIM_Reject,
     /* 2373598 */ // Label 33289: @2373598
     /* 2373598 */ GIM_Try, /*On fail goto*//*Label 33332*/ GIMT_Encode4(2373712),
     /* 2373603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2373606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2373609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373621 */   GIM_Try, /*On fail goto*//*Label 33333*/ GIMT_Encode4(2373666), // Rule ID 50856 //
     /* 2373626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2373629 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2373632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2373646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373665 */     // GIR_Coverage, 50856,
     /* 2373665 */     GIR_EraseRootFromParent_Done,
     /* 2373666 */   // Label 33333: @2373666
     /* 2373666 */   GIM_Try, /*On fail goto*//*Label 33334*/ GIMT_Encode4(2373711), // Rule ID 50857 //
     /* 2373671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2373674 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2373677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2373691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373710 */     // GIR_Coverage, 50857,
     /* 2373710 */     GIR_EraseRootFromParent_Done,
     /* 2373711 */   // Label 33334: @2373711
     /* 2373711 */   GIM_Reject,
     /* 2373712 */ // Label 33332: @2373712
     /* 2373712 */ GIM_Reject,
     /* 2373713 */ // Label 33290: @2373713
     /* 2373713 */ GIM_Try, /*On fail goto*//*Label 33335*/ GIMT_Encode4(2373827),
     /* 2373718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2373721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2373724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373736 */   GIM_Try, /*On fail goto*//*Label 33336*/ GIMT_Encode4(2373781), // Rule ID 50788 //
     /* 2373741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373744 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2373747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2373761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373780 */     // GIR_Coverage, 50788,
     /* 2373780 */     GIR_EraseRootFromParent_Done,
     /* 2373781 */   // Label 33336: @2373781
     /* 2373781 */   GIM_Try, /*On fail goto*//*Label 33337*/ GIMT_Encode4(2373826), // Rule ID 50789 //
     /* 2373786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373789 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2373792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2373806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373825 */     // GIR_Coverage, 50789,
     /* 2373825 */     GIR_EraseRootFromParent_Done,
     /* 2373826 */   // Label 33337: @2373826
     /* 2373826 */   GIM_Reject,
     /* 2373827 */ // Label 33335: @2373827
     /* 2373827 */ GIM_Reject,
     /* 2373828 */ // Label 33291: @2373828
     /* 2373828 */ GIM_Try, /*On fail goto*//*Label 33338*/ GIMT_Encode4(2373942),
     /* 2373833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2373836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2373839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373851 */   GIM_Try, /*On fail goto*//*Label 33339*/ GIMT_Encode4(2373896), // Rule ID 50808 //
     /* 2373856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373859 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2373862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2373876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373895 */     // GIR_Coverage, 50808,
     /* 2373895 */     GIR_EraseRootFromParent_Done,
     /* 2373896 */   // Label 33339: @2373896
     /* 2373896 */   GIM_Try, /*On fail goto*//*Label 33340*/ GIMT_Encode4(2373941), // Rule ID 50809 //
     /* 2373901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373904 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2373907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2373921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373940 */     // GIR_Coverage, 50809,
     /* 2373940 */     GIR_EraseRootFromParent_Done,
     /* 2373941 */   // Label 33340: @2373941
     /* 2373941 */   GIM_Reject,
     /* 2373942 */ // Label 33338: @2373942
     /* 2373942 */ GIM_Reject,
     /* 2373943 */ // Label 33292: @2373943
     /* 2373943 */ GIM_Try, /*On fail goto*//*Label 33341*/ GIMT_Encode4(2374057),
     /* 2373948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2373951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2373954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373966 */   GIM_Try, /*On fail goto*//*Label 33342*/ GIMT_Encode4(2374011), // Rule ID 50844 //
     /* 2373971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373974 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2373977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2373991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374010 */     // GIR_Coverage, 50844,
     /* 2374010 */     GIR_EraseRootFromParent_Done,
     /* 2374011 */   // Label 33342: @2374011
     /* 2374011 */   GIM_Try, /*On fail goto*//*Label 33343*/ GIMT_Encode4(2374056), // Rule ID 50845 //
     /* 2374016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374019 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2374022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2374036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374055 */     // GIR_Coverage, 50845,
     /* 2374055 */     GIR_EraseRootFromParent_Done,
     /* 2374056 */   // Label 33343: @2374056
     /* 2374056 */   GIM_Reject,
     /* 2374057 */ // Label 33341: @2374057
     /* 2374057 */ GIM_Reject,
     /* 2374058 */ // Label 33293: @2374058
     /* 2374058 */ GIM_Try, /*On fail goto*//*Label 33344*/ GIMT_Encode4(2374172),
     /* 2374063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2374066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2374069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374081 */   GIM_Try, /*On fail goto*//*Label 33345*/ GIMT_Encode4(2374126), // Rule ID 50860 //
     /* 2374086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2374089 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2374092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2374106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374125 */     // GIR_Coverage, 50860,
     /* 2374125 */     GIR_EraseRootFromParent_Done,
     /* 2374126 */   // Label 33345: @2374126
     /* 2374126 */   GIM_Try, /*On fail goto*//*Label 33346*/ GIMT_Encode4(2374171), // Rule ID 50861 //
     /* 2374131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2374134 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2374137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2374151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374170 */     // GIR_Coverage, 50861,
     /* 2374170 */     GIR_EraseRootFromParent_Done,
     /* 2374171 */   // Label 33346: @2374171
     /* 2374171 */   GIM_Reject,
     /* 2374172 */ // Label 33344: @2374172
     /* 2374172 */ GIM_Reject,
     /* 2374173 */ // Label 33294: @2374173
     /* 2374173 */ GIM_Try, /*On fail goto*//*Label 33347*/ GIMT_Encode4(2374287),
     /* 2374178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2374181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2374184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374196 */   GIM_Try, /*On fail goto*//*Label 33348*/ GIMT_Encode4(2374241), // Rule ID 50804 //
     /* 2374201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374204 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2374207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2374221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374240 */     // GIR_Coverage, 50804,
     /* 2374240 */     GIR_EraseRootFromParent_Done,
     /* 2374241 */   // Label 33348: @2374241
     /* 2374241 */   GIM_Try, /*On fail goto*//*Label 33349*/ GIMT_Encode4(2374286), // Rule ID 50805 //
     /* 2374246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374249 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2374252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2374266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374285 */     // GIR_Coverage, 50805,
     /* 2374285 */     GIR_EraseRootFromParent_Done,
     /* 2374286 */   // Label 33349: @2374286
     /* 2374286 */   GIM_Reject,
     /* 2374287 */ // Label 33347: @2374287
     /* 2374287 */ GIM_Reject,
     /* 2374288 */ // Label 33295: @2374288
     /* 2374288 */ GIM_Try, /*On fail goto*//*Label 33350*/ GIMT_Encode4(2374402),
     /* 2374293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2374296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2374299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374311 */   GIM_Try, /*On fail goto*//*Label 33351*/ GIMT_Encode4(2374356), // Rule ID 50832 //
     /* 2374316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374319 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2374322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2374336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374355 */     // GIR_Coverage, 50832,
     /* 2374355 */     GIR_EraseRootFromParent_Done,
     /* 2374356 */   // Label 33351: @2374356
     /* 2374356 */   GIM_Try, /*On fail goto*//*Label 33352*/ GIMT_Encode4(2374401), // Rule ID 50833 //
     /* 2374361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374364 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2374367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2374381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374400 */     // GIR_Coverage, 50833,
     /* 2374400 */     GIR_EraseRootFromParent_Done,
     /* 2374401 */   // Label 33352: @2374401
     /* 2374401 */   GIM_Reject,
     /* 2374402 */ // Label 33350: @2374402
     /* 2374402 */ GIM_Reject,
     /* 2374403 */ // Label 33296: @2374403
     /* 2374403 */ GIM_Try, /*On fail goto*//*Label 33353*/ GIMT_Encode4(2374517),
     /* 2374408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2374411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2374414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374426 */   GIM_Try, /*On fail goto*//*Label 33354*/ GIMT_Encode4(2374471), // Rule ID 50848 //
     /* 2374431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374434 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2374437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2374451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374470 */     // GIR_Coverage, 50848,
     /* 2374470 */     GIR_EraseRootFromParent_Done,
     /* 2374471 */   // Label 33354: @2374471
     /* 2374471 */   GIM_Try, /*On fail goto*//*Label 33355*/ GIMT_Encode4(2374516), // Rule ID 50849 //
     /* 2374476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374479 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2374482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2374496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374515 */     // GIR_Coverage, 50849,
     /* 2374515 */     GIR_EraseRootFromParent_Done,
     /* 2374516 */   // Label 33355: @2374516
     /* 2374516 */   GIM_Reject,
     /* 2374517 */ // Label 33353: @2374517
     /* 2374517 */ GIM_Reject,
     /* 2374518 */ // Label 33297: @2374518
     /* 2374518 */ GIM_Try, /*On fail goto*//*Label 33356*/ GIMT_Encode4(2374632),
     /* 2374523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2374526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2374529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374541 */   GIM_Try, /*On fail goto*//*Label 33357*/ GIMT_Encode4(2374586), // Rule ID 50864 //
     /* 2374546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2374549 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2374552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2374566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374585 */     // GIR_Coverage, 50864,
     /* 2374585 */     GIR_EraseRootFromParent_Done,
     /* 2374586 */   // Label 33357: @2374586
     /* 2374586 */   GIM_Try, /*On fail goto*//*Label 33358*/ GIMT_Encode4(2374631), // Rule ID 50865 //
     /* 2374591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2374594 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2374597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2374611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374630 */     // GIR_Coverage, 50865,
     /* 2374630 */     GIR_EraseRootFromParent_Done,
     /* 2374631 */   // Label 33358: @2374631
     /* 2374631 */   GIM_Reject,
     /* 2374632 */ // Label 33356: @2374632
     /* 2374632 */ GIM_Reject,
     /* 2374633 */ // Label 33298: @2374633
     /* 2374633 */ GIM_Try, /*On fail goto*//*Label 33359*/ GIMT_Encode4(2374747),
     /* 2374638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2374641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2374644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374656 */   GIM_Try, /*On fail goto*//*Label 33360*/ GIMT_Encode4(2374701), // Rule ID 50820 //
     /* 2374661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374664 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2374667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2374681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374700 */     // GIR_Coverage, 50820,
     /* 2374700 */     GIR_EraseRootFromParent_Done,
     /* 2374701 */   // Label 33360: @2374701
     /* 2374701 */   GIM_Try, /*On fail goto*//*Label 33361*/ GIMT_Encode4(2374746), // Rule ID 50821 //
     /* 2374706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374709 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2374712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2374726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374745 */     // GIR_Coverage, 50821,
     /* 2374745 */     GIR_EraseRootFromParent_Done,
     /* 2374746 */   // Label 33361: @2374746
     /* 2374746 */   GIM_Reject,
     /* 2374747 */ // Label 33359: @2374747
     /* 2374747 */ GIM_Reject,
     /* 2374748 */ // Label 33299: @2374748
     /* 2374748 */ GIM_Try, /*On fail goto*//*Label 33362*/ GIMT_Encode4(2374862),
     /* 2374753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2374756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2374759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374771 */   GIM_Try, /*On fail goto*//*Label 33363*/ GIMT_Encode4(2374816), // Rule ID 50836 //
     /* 2374776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374779 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2374782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2374796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374815 */     // GIR_Coverage, 50836,
     /* 2374815 */     GIR_EraseRootFromParent_Done,
     /* 2374816 */   // Label 33363: @2374816
     /* 2374816 */   GIM_Try, /*On fail goto*//*Label 33364*/ GIMT_Encode4(2374861), // Rule ID 50837 //
     /* 2374821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374824 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2374827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2374841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374860 */     // GIR_Coverage, 50837,
     /* 2374860 */     GIR_EraseRootFromParent_Done,
     /* 2374861 */   // Label 33364: @2374861
     /* 2374861 */   GIM_Reject,
     /* 2374862 */ // Label 33362: @2374862
     /* 2374862 */ GIM_Reject,
     /* 2374863 */ // Label 33300: @2374863
     /* 2374863 */ GIM_Try, /*On fail goto*//*Label 33365*/ GIMT_Encode4(2374977),
     /* 2374868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2374871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2374874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374882 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374886 */   GIM_Try, /*On fail goto*//*Label 33366*/ GIMT_Encode4(2374931), // Rule ID 50852 //
     /* 2374891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374894 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2374897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2374911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374930 */     // GIR_Coverage, 50852,
     /* 2374930 */     GIR_EraseRootFromParent_Done,
     /* 2374931 */   // Label 33366: @2374931
     /* 2374931 */   GIM_Try, /*On fail goto*//*Label 33367*/ GIMT_Encode4(2374976), // Rule ID 50853 //
     /* 2374936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374939 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2374942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2374956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374975 */     // GIR_Coverage, 50853,
     /* 2374975 */     GIR_EraseRootFromParent_Done,
     /* 2374976 */   // Label 33367: @2374976
     /* 2374976 */   GIM_Reject,
     /* 2374977 */ // Label 33365: @2374977
     /* 2374977 */ GIM_Reject,
     /* 2374978 */ // Label 33301: @2374978
     /* 2374978 */ GIM_Try, /*On fail goto*//*Label 33368*/ GIMT_Encode4(2375092),
     /* 2374983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2374986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2374989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2375001 */   GIM_Try, /*On fail goto*//*Label 33369*/ GIMT_Encode4(2375046), // Rule ID 50824 //
     /* 2375006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375009 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2375012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2375026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375045 */     // GIR_Coverage, 50824,
     /* 2375045 */     GIR_EraseRootFromParent_Done,
     /* 2375046 */   // Label 33369: @2375046
     /* 2375046 */   GIM_Try, /*On fail goto*//*Label 33370*/ GIMT_Encode4(2375091), // Rule ID 50825 //
     /* 2375051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375054 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2375057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2375071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375090 */     // GIR_Coverage, 50825,
     /* 2375090 */     GIR_EraseRootFromParent_Done,
     /* 2375091 */   // Label 33370: @2375091
     /* 2375091 */   GIM_Reject,
     /* 2375092 */ // Label 33368: @2375092
     /* 2375092 */ GIM_Reject,
     /* 2375093 */ // Label 33302: @2375093
     /* 2375093 */ GIM_Try, /*On fail goto*//*Label 33371*/ GIMT_Encode4(2375207),
     /* 2375098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2375101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2375104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375116 */   GIM_Try, /*On fail goto*//*Label 33372*/ GIMT_Encode4(2375161), // Rule ID 50840 //
     /* 2375121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375124 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2375127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2375141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375160 */     // GIR_Coverage, 50840,
     /* 2375160 */     GIR_EraseRootFromParent_Done,
     /* 2375161 */   // Label 33372: @2375161
     /* 2375161 */   GIM_Try, /*On fail goto*//*Label 33373*/ GIMT_Encode4(2375206), // Rule ID 50841 //
     /* 2375166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375169 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2375172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2375186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375205 */     // GIR_Coverage, 50841,
     /* 2375205 */     GIR_EraseRootFromParent_Done,
     /* 2375206 */   // Label 33373: @2375206
     /* 2375206 */   GIM_Reject,
     /* 2375207 */ // Label 33371: @2375207
     /* 2375207 */ GIM_Reject,
     /* 2375208 */ // Label 33303: @2375208
     /* 2375208 */ GIM_Try, /*On fail goto*//*Label 33374*/ GIMT_Encode4(2375322),
     /* 2375213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2375216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2375219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375231 */   GIM_Try, /*On fail goto*//*Label 33375*/ GIMT_Encode4(2375276), // Rule ID 50828 //
     /* 2375236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375239 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2375242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2375256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375275 */     // GIR_Coverage, 50828,
     /* 2375275 */     GIR_EraseRootFromParent_Done,
     /* 2375276 */   // Label 33375: @2375276
     /* 2375276 */   GIM_Try, /*On fail goto*//*Label 33376*/ GIMT_Encode4(2375321), // Rule ID 50829 //
     /* 2375281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375284 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2375287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2375301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375320 */     // GIR_Coverage, 50829,
     /* 2375320 */     GIR_EraseRootFromParent_Done,
     /* 2375321 */   // Label 33376: @2375321
     /* 2375321 */   GIM_Reject,
     /* 2375322 */ // Label 33374: @2375322
     /* 2375322 */ GIM_Reject,
     /* 2375323 */ // Label 33304: @2375323
     /* 2375323 */ GIM_Reject,
     /* 2375324 */ // Label 82: @2375324
     /* 2375324 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33401*/ GIMT_Encode4(2378099),
     /* 2375335 */ /*GILLT_s32*//*Label 33377*/ GIMT_Encode4(2375459),
     /* 2375339 */ /*GILLT_s64*//*Label 33378*/ GIMT_Encode4(2375514), GIMT_Encode4(0),
     /* 2375347 */ /*GILLT_nxv1s8*//*Label 33379*/ GIMT_Encode4(2375569),
     /* 2375351 */ /*GILLT_nxv1s16*//*Label 33380*/ GIMT_Encode4(2375684),
     /* 2375355 */ /*GILLT_nxv1s32*//*Label 33381*/ GIMT_Encode4(2375799),
     /* 2375359 */ /*GILLT_nxv1s64*//*Label 33382*/ GIMT_Encode4(2375914), GIMT_Encode4(0),
     /* 2375367 */ /*GILLT_nxv2s8*//*Label 33383*/ GIMT_Encode4(2376029),
     /* 2375371 */ /*GILLT_nxv2s16*//*Label 33384*/ GIMT_Encode4(2376144),
     /* 2375375 */ /*GILLT_nxv2s32*//*Label 33385*/ GIMT_Encode4(2376259),
     /* 2375379 */ /*GILLT_nxv2s64*//*Label 33386*/ GIMT_Encode4(2376374), GIMT_Encode4(0),
     /* 2375387 */ /*GILLT_nxv4s8*//*Label 33387*/ GIMT_Encode4(2376489),
     /* 2375391 */ /*GILLT_nxv4s16*//*Label 33388*/ GIMT_Encode4(2376604),
     /* 2375395 */ /*GILLT_nxv4s32*//*Label 33389*/ GIMT_Encode4(2376719),
     /* 2375399 */ /*GILLT_nxv4s64*//*Label 33390*/ GIMT_Encode4(2376834), GIMT_Encode4(0),
     /* 2375407 */ /*GILLT_nxv8s8*//*Label 33391*/ GIMT_Encode4(2376949),
     /* 2375411 */ /*GILLT_nxv8s16*//*Label 33392*/ GIMT_Encode4(2377064),
     /* 2375415 */ /*GILLT_nxv8s32*//*Label 33393*/ GIMT_Encode4(2377179),
     /* 2375419 */ /*GILLT_nxv8s64*//*Label 33394*/ GIMT_Encode4(2377294), GIMT_Encode4(0),
     /* 2375427 */ /*GILLT_nxv16s8*//*Label 33395*/ GIMT_Encode4(2377409),
     /* 2375431 */ /*GILLT_nxv16s16*//*Label 33396*/ GIMT_Encode4(2377524),
     /* 2375435 */ /*GILLT_nxv16s32*//*Label 33397*/ GIMT_Encode4(2377639), GIMT_Encode4(0),
     /* 2375443 */ /*GILLT_nxv32s8*//*Label 33398*/ GIMT_Encode4(2377754),
     /* 2375447 */ /*GILLT_nxv32s16*//*Label 33399*/ GIMT_Encode4(2377869), GIMT_Encode4(0),
     /* 2375455 */ /*GILLT_nxv64s8*//*Label 33400*/ GIMT_Encode4(2377984),
     /* 2375459 */ // Label 33377: @2375459
     /* 2375459 */ GIM_Try, /*On fail goto*//*Label 33402*/ GIMT_Encode4(2375513),
     /* 2375464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2375470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375482 */   GIM_Try, /*On fail goto*//*Label 33403*/ GIMT_Encode4(2375497), // Rule ID 64476 //
     /* 2375487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2375490 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2375490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2375495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375496 */     // GIR_Coverage, 64476,
     /* 2375496 */     GIR_Done,
     /* 2375497 */   // Label 33403: @2375497
     /* 2375497 */   GIM_Try, /*On fail goto*//*Label 33404*/ GIMT_Encode4(2375512), // Rule ID 2543 //
     /* 2375502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2375505 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2375505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2375510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375511 */     // GIR_Coverage, 2543,
     /* 2375511 */     GIR_Done,
     /* 2375512 */   // Label 33404: @2375512
     /* 2375512 */   GIM_Reject,
     /* 2375513 */ // Label 33402: @2375513
     /* 2375513 */ GIM_Reject,
     /* 2375514 */ // Label 33378: @2375514
     /* 2375514 */ GIM_Try, /*On fail goto*//*Label 33405*/ GIMT_Encode4(2375568),
     /* 2375519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2375525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375537 */   GIM_Try, /*On fail goto*//*Label 33406*/ GIMT_Encode4(2375552), // Rule ID 64475 //
     /* 2375542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2375545 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2375545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2375550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375551 */     // GIR_Coverage, 64475,
     /* 2375551 */     GIR_Done,
     /* 2375552 */   // Label 33406: @2375552
     /* 2375552 */   GIM_Try, /*On fail goto*//*Label 33407*/ GIMT_Encode4(2375567), // Rule ID 2542 //
     /* 2375557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2375560 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2375560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2375565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375566 */     // GIR_Coverage, 2542,
     /* 2375566 */     GIR_Done,
     /* 2375567 */   // Label 33407: @2375567
     /* 2375567 */   GIM_Reject,
     /* 2375568 */ // Label 33405: @2375568
     /* 2375568 */ GIM_Reject,
     /* 2375569 */ // Label 33379: @2375569
     /* 2375569 */ GIM_Try, /*On fail goto*//*Label 33408*/ GIMT_Encode4(2375683),
     /* 2375574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2375577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2375580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375592 */   GIM_Try, /*On fail goto*//*Label 33409*/ GIMT_Encode4(2375637), // Rule ID 50516 //
     /* 2375597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375600 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2375603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2375617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375636 */     // GIR_Coverage, 50516,
     /* 2375636 */     GIR_EraseRootFromParent_Done,
     /* 2375637 */   // Label 33409: @2375637
     /* 2375637 */   GIM_Try, /*On fail goto*//*Label 33410*/ GIMT_Encode4(2375682), // Rule ID 50517 //
     /* 2375642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375645 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2375648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2375662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375681 */     // GIR_Coverage, 50517,
     /* 2375681 */     GIR_EraseRootFromParent_Done,
     /* 2375682 */   // Label 33410: @2375682
     /* 2375682 */   GIM_Reject,
     /* 2375683 */ // Label 33408: @2375683
     /* 2375683 */ GIM_Reject,
     /* 2375684 */ // Label 33380: @2375684
     /* 2375684 */ GIM_Try, /*On fail goto*//*Label 33411*/ GIMT_Encode4(2375798),
     /* 2375689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2375692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2375695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375707 */   GIM_Try, /*On fail goto*//*Label 33412*/ GIMT_Encode4(2375752), // Rule ID 50528 //
     /* 2375712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375715 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2375718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2375732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375751 */     // GIR_Coverage, 50528,
     /* 2375751 */     GIR_EraseRootFromParent_Done,
     /* 2375752 */   // Label 33412: @2375752
     /* 2375752 */   GIM_Try, /*On fail goto*//*Label 33413*/ GIMT_Encode4(2375797), // Rule ID 50529 //
     /* 2375757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375760 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2375763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2375777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375796 */     // GIR_Coverage, 50529,
     /* 2375796 */     GIR_EraseRootFromParent_Done,
     /* 2375797 */   // Label 33413: @2375797
     /* 2375797 */   GIM_Reject,
     /* 2375798 */ // Label 33411: @2375798
     /* 2375798 */ GIM_Reject,
     /* 2375799 */ // Label 33381: @2375799
     /* 2375799 */ GIM_Try, /*On fail goto*//*Label 33414*/ GIMT_Encode4(2375913),
     /* 2375804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2375807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2375810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375822 */   GIM_Try, /*On fail goto*//*Label 33415*/ GIMT_Encode4(2375867), // Rule ID 50536 //
     /* 2375827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375830 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2375833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2375847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375866 */     // GIR_Coverage, 50536,
     /* 2375866 */     GIR_EraseRootFromParent_Done,
     /* 2375867 */   // Label 33415: @2375867
     /* 2375867 */   GIM_Try, /*On fail goto*//*Label 33416*/ GIMT_Encode4(2375912), // Rule ID 50537 //
     /* 2375872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375875 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2375878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2375892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375911 */     // GIR_Coverage, 50537,
     /* 2375911 */     GIR_EraseRootFromParent_Done,
     /* 2375912 */   // Label 33416: @2375912
     /* 2375912 */   GIM_Reject,
     /* 2375913 */ // Label 33414: @2375913
     /* 2375913 */ GIM_Reject,
     /* 2375914 */ // Label 33382: @2375914
     /* 2375914 */ GIM_Try, /*On fail goto*//*Label 33417*/ GIMT_Encode4(2376028),
     /* 2375919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2375922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2375925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375937 */   GIM_Try, /*On fail goto*//*Label 33418*/ GIMT_Encode4(2375982), // Rule ID 50552 //
     /* 2375942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2375945 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2375948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2375962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2375977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375981 */     // GIR_Coverage, 50552,
     /* 2375981 */     GIR_EraseRootFromParent_Done,
     /* 2375982 */   // Label 33418: @2375982
     /* 2375982 */   GIM_Try, /*On fail goto*//*Label 33419*/ GIMT_Encode4(2376027), // Rule ID 50553 //
     /* 2375987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2375990 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2375993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2376007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376026 */     // GIR_Coverage, 50553,
     /* 2376026 */     GIR_EraseRootFromParent_Done,
     /* 2376027 */   // Label 33419: @2376027
     /* 2376027 */   GIM_Reject,
     /* 2376028 */ // Label 33417: @2376028
     /* 2376028 */ GIM_Reject,
     /* 2376029 */ // Label 33383: @2376029
     /* 2376029 */ GIM_Try, /*On fail goto*//*Label 33420*/ GIMT_Encode4(2376143),
     /* 2376034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2376037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2376040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376052 */   GIM_Try, /*On fail goto*//*Label 33421*/ GIMT_Encode4(2376097), // Rule ID 50520 //
     /* 2376057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376060 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2376063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2376077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376096 */     // GIR_Coverage, 50520,
     /* 2376096 */     GIR_EraseRootFromParent_Done,
     /* 2376097 */   // Label 33421: @2376097
     /* 2376097 */   GIM_Try, /*On fail goto*//*Label 33422*/ GIMT_Encode4(2376142), // Rule ID 50521 //
     /* 2376102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376105 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2376108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2376122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376141 */     // GIR_Coverage, 50521,
     /* 2376141 */     GIR_EraseRootFromParent_Done,
     /* 2376142 */   // Label 33422: @2376142
     /* 2376142 */   GIM_Reject,
     /* 2376143 */ // Label 33420: @2376143
     /* 2376143 */ GIM_Reject,
     /* 2376144 */ // Label 33384: @2376144
     /* 2376144 */ GIM_Try, /*On fail goto*//*Label 33423*/ GIMT_Encode4(2376258),
     /* 2376149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2376152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2376155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376167 */   GIM_Try, /*On fail goto*//*Label 33424*/ GIMT_Encode4(2376212), // Rule ID 50532 //
     /* 2376172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376175 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2376178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2376192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376211 */     // GIR_Coverage, 50532,
     /* 2376211 */     GIR_EraseRootFromParent_Done,
     /* 2376212 */   // Label 33424: @2376212
     /* 2376212 */   GIM_Try, /*On fail goto*//*Label 33425*/ GIMT_Encode4(2376257), // Rule ID 50533 //
     /* 2376217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376220 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2376223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2376237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376256 */     // GIR_Coverage, 50533,
     /* 2376256 */     GIR_EraseRootFromParent_Done,
     /* 2376257 */   // Label 33425: @2376257
     /* 2376257 */   GIM_Reject,
     /* 2376258 */ // Label 33423: @2376258
     /* 2376258 */ GIM_Reject,
     /* 2376259 */ // Label 33385: @2376259
     /* 2376259 */ GIM_Try, /*On fail goto*//*Label 33426*/ GIMT_Encode4(2376373),
     /* 2376264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2376267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2376270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376282 */   GIM_Try, /*On fail goto*//*Label 33427*/ GIMT_Encode4(2376327), // Rule ID 50548 //
     /* 2376287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376290 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2376293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2376307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376326 */     // GIR_Coverage, 50548,
     /* 2376326 */     GIR_EraseRootFromParent_Done,
     /* 2376327 */   // Label 33427: @2376327
     /* 2376327 */   GIM_Try, /*On fail goto*//*Label 33428*/ GIMT_Encode4(2376372), // Rule ID 50549 //
     /* 2376332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376335 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2376338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2376352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376371 */     // GIR_Coverage, 50549,
     /* 2376371 */     GIR_EraseRootFromParent_Done,
     /* 2376372 */   // Label 33428: @2376372
     /* 2376372 */   GIM_Reject,
     /* 2376373 */ // Label 33426: @2376373
     /* 2376373 */ GIM_Reject,
     /* 2376374 */ // Label 33386: @2376374
     /* 2376374 */ GIM_Try, /*On fail goto*//*Label 33429*/ GIMT_Encode4(2376488),
     /* 2376379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2376382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2376385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376397 */   GIM_Try, /*On fail goto*//*Label 33430*/ GIMT_Encode4(2376442), // Rule ID 50592 //
     /* 2376402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2376405 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2376408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2376422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376441 */     // GIR_Coverage, 50592,
     /* 2376441 */     GIR_EraseRootFromParent_Done,
     /* 2376442 */   // Label 33430: @2376442
     /* 2376442 */   GIM_Try, /*On fail goto*//*Label 33431*/ GIMT_Encode4(2376487), // Rule ID 50593 //
     /* 2376447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2376450 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2376453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2376467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376486 */     // GIR_Coverage, 50593,
     /* 2376486 */     GIR_EraseRootFromParent_Done,
     /* 2376487 */   // Label 33431: @2376487
     /* 2376487 */   GIM_Reject,
     /* 2376488 */ // Label 33429: @2376488
     /* 2376488 */ GIM_Reject,
     /* 2376489 */ // Label 33387: @2376489
     /* 2376489 */ GIM_Try, /*On fail goto*//*Label 33432*/ GIMT_Encode4(2376603),
     /* 2376494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2376497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2376500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376512 */   GIM_Try, /*On fail goto*//*Label 33433*/ GIMT_Encode4(2376557), // Rule ID 50524 //
     /* 2376517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376520 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2376523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2376537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376556 */     // GIR_Coverage, 50524,
     /* 2376556 */     GIR_EraseRootFromParent_Done,
     /* 2376557 */   // Label 33433: @2376557
     /* 2376557 */   GIM_Try, /*On fail goto*//*Label 33434*/ GIMT_Encode4(2376602), // Rule ID 50525 //
     /* 2376562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376565 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2376568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2376582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376601 */     // GIR_Coverage, 50525,
     /* 2376601 */     GIR_EraseRootFromParent_Done,
     /* 2376602 */   // Label 33434: @2376602
     /* 2376602 */   GIM_Reject,
     /* 2376603 */ // Label 33432: @2376603
     /* 2376603 */ GIM_Reject,
     /* 2376604 */ // Label 33388: @2376604
     /* 2376604 */ GIM_Try, /*On fail goto*//*Label 33435*/ GIMT_Encode4(2376718),
     /* 2376609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2376612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2376615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376627 */   GIM_Try, /*On fail goto*//*Label 33436*/ GIMT_Encode4(2376672), // Rule ID 50544 //
     /* 2376632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376635 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2376638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2376652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376671 */     // GIR_Coverage, 50544,
     /* 2376671 */     GIR_EraseRootFromParent_Done,
     /* 2376672 */   // Label 33436: @2376672
     /* 2376672 */   GIM_Try, /*On fail goto*//*Label 33437*/ GIMT_Encode4(2376717), // Rule ID 50545 //
     /* 2376677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376680 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2376683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2376697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376716 */     // GIR_Coverage, 50545,
     /* 2376716 */     GIR_EraseRootFromParent_Done,
     /* 2376717 */   // Label 33437: @2376717
     /* 2376717 */   GIM_Reject,
     /* 2376718 */ // Label 33435: @2376718
     /* 2376718 */ GIM_Reject,
     /* 2376719 */ // Label 33389: @2376719
     /* 2376719 */ GIM_Try, /*On fail goto*//*Label 33438*/ GIMT_Encode4(2376833),
     /* 2376724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2376727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2376730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376738 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376742 */   GIM_Try, /*On fail goto*//*Label 33439*/ GIMT_Encode4(2376787), // Rule ID 50580 //
     /* 2376747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376750 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2376753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2376767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376786 */     // GIR_Coverage, 50580,
     /* 2376786 */     GIR_EraseRootFromParent_Done,
     /* 2376787 */   // Label 33439: @2376787
     /* 2376787 */   GIM_Try, /*On fail goto*//*Label 33440*/ GIMT_Encode4(2376832), // Rule ID 50581 //
     /* 2376792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376795 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2376798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2376812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376831 */     // GIR_Coverage, 50581,
     /* 2376831 */     GIR_EraseRootFromParent_Done,
     /* 2376832 */   // Label 33440: @2376832
     /* 2376832 */   GIM_Reject,
     /* 2376833 */ // Label 33438: @2376833
     /* 2376833 */ GIM_Reject,
     /* 2376834 */ // Label 33390: @2376834
     /* 2376834 */ GIM_Try, /*On fail goto*//*Label 33441*/ GIMT_Encode4(2376948),
     /* 2376839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2376842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2376845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376857 */   GIM_Try, /*On fail goto*//*Label 33442*/ GIMT_Encode4(2376902), // Rule ID 50596 //
     /* 2376862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2376865 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2376868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2376882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376901 */     // GIR_Coverage, 50596,
     /* 2376901 */     GIR_EraseRootFromParent_Done,
     /* 2376902 */   // Label 33442: @2376902
     /* 2376902 */   GIM_Try, /*On fail goto*//*Label 33443*/ GIMT_Encode4(2376947), // Rule ID 50597 //
     /* 2376907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2376910 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2376913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2376927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376946 */     // GIR_Coverage, 50597,
     /* 2376946 */     GIR_EraseRootFromParent_Done,
     /* 2376947 */   // Label 33443: @2376947
     /* 2376947 */   GIM_Reject,
     /* 2376948 */ // Label 33441: @2376948
     /* 2376948 */ GIM_Reject,
     /* 2376949 */ // Label 33391: @2376949
     /* 2376949 */ GIM_Try, /*On fail goto*//*Label 33444*/ GIMT_Encode4(2377063),
     /* 2376954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2376957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2376960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376972 */   GIM_Try, /*On fail goto*//*Label 33445*/ GIMT_Encode4(2377017), // Rule ID 50540 //
     /* 2376977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376980 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2376983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2376997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377016 */     // GIR_Coverage, 50540,
     /* 2377016 */     GIR_EraseRootFromParent_Done,
     /* 2377017 */   // Label 33445: @2377017
     /* 2377017 */   GIM_Try, /*On fail goto*//*Label 33446*/ GIMT_Encode4(2377062), // Rule ID 50541 //
     /* 2377022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377025 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2377028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2377042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377061 */     // GIR_Coverage, 50541,
     /* 2377061 */     GIR_EraseRootFromParent_Done,
     /* 2377062 */   // Label 33446: @2377062
     /* 2377062 */   GIM_Reject,
     /* 2377063 */ // Label 33444: @2377063
     /* 2377063 */ GIM_Reject,
     /* 2377064 */ // Label 33392: @2377064
     /* 2377064 */ GIM_Try, /*On fail goto*//*Label 33447*/ GIMT_Encode4(2377178),
     /* 2377069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2377072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2377075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377087 */   GIM_Try, /*On fail goto*//*Label 33448*/ GIMT_Encode4(2377132), // Rule ID 50568 //
     /* 2377092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377095 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2377098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2377112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377131 */     // GIR_Coverage, 50568,
     /* 2377131 */     GIR_EraseRootFromParent_Done,
     /* 2377132 */   // Label 33448: @2377132
     /* 2377132 */   GIM_Try, /*On fail goto*//*Label 33449*/ GIMT_Encode4(2377177), // Rule ID 50569 //
     /* 2377137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377140 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2377143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2377157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377176 */     // GIR_Coverage, 50569,
     /* 2377176 */     GIR_EraseRootFromParent_Done,
     /* 2377177 */   // Label 33449: @2377177
     /* 2377177 */   GIM_Reject,
     /* 2377178 */ // Label 33447: @2377178
     /* 2377178 */ GIM_Reject,
     /* 2377179 */ // Label 33393: @2377179
     /* 2377179 */ GIM_Try, /*On fail goto*//*Label 33450*/ GIMT_Encode4(2377293),
     /* 2377184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2377187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2377190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377202 */   GIM_Try, /*On fail goto*//*Label 33451*/ GIMT_Encode4(2377247), // Rule ID 50584 //
     /* 2377207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377210 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2377213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2377227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377246 */     // GIR_Coverage, 50584,
     /* 2377246 */     GIR_EraseRootFromParent_Done,
     /* 2377247 */   // Label 33451: @2377247
     /* 2377247 */   GIM_Try, /*On fail goto*//*Label 33452*/ GIMT_Encode4(2377292), // Rule ID 50585 //
     /* 2377252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377255 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2377258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2377272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377291 */     // GIR_Coverage, 50585,
     /* 2377291 */     GIR_EraseRootFromParent_Done,
     /* 2377292 */   // Label 33452: @2377292
     /* 2377292 */   GIM_Reject,
     /* 2377293 */ // Label 33450: @2377293
     /* 2377293 */ GIM_Reject,
     /* 2377294 */ // Label 33394: @2377294
     /* 2377294 */ GIM_Try, /*On fail goto*//*Label 33453*/ GIMT_Encode4(2377408),
     /* 2377299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2377302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2377305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377317 */   GIM_Try, /*On fail goto*//*Label 33454*/ GIMT_Encode4(2377362), // Rule ID 50600 //
     /* 2377322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2377325 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2377328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2377342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377361 */     // GIR_Coverage, 50600,
     /* 2377361 */     GIR_EraseRootFromParent_Done,
     /* 2377362 */   // Label 33454: @2377362
     /* 2377362 */   GIM_Try, /*On fail goto*//*Label 33455*/ GIMT_Encode4(2377407), // Rule ID 50601 //
     /* 2377367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2377370 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2377373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2377387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377406 */     // GIR_Coverage, 50601,
     /* 2377406 */     GIR_EraseRootFromParent_Done,
     /* 2377407 */   // Label 33455: @2377407
     /* 2377407 */   GIM_Reject,
     /* 2377408 */ // Label 33453: @2377408
     /* 2377408 */ GIM_Reject,
     /* 2377409 */ // Label 33395: @2377409
     /* 2377409 */ GIM_Try, /*On fail goto*//*Label 33456*/ GIMT_Encode4(2377523),
     /* 2377414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2377417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2377420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377432 */   GIM_Try, /*On fail goto*//*Label 33457*/ GIMT_Encode4(2377477), // Rule ID 50556 //
     /* 2377437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377440 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2377443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2377457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377476 */     // GIR_Coverage, 50556,
     /* 2377476 */     GIR_EraseRootFromParent_Done,
     /* 2377477 */   // Label 33457: @2377477
     /* 2377477 */   GIM_Try, /*On fail goto*//*Label 33458*/ GIMT_Encode4(2377522), // Rule ID 50557 //
     /* 2377482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377485 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2377488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2377502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377521 */     // GIR_Coverage, 50557,
     /* 2377521 */     GIR_EraseRootFromParent_Done,
     /* 2377522 */   // Label 33458: @2377522
     /* 2377522 */   GIM_Reject,
     /* 2377523 */ // Label 33456: @2377523
     /* 2377523 */ GIM_Reject,
     /* 2377524 */ // Label 33396: @2377524
     /* 2377524 */ GIM_Try, /*On fail goto*//*Label 33459*/ GIMT_Encode4(2377638),
     /* 2377529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2377532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2377535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377547 */   GIM_Try, /*On fail goto*//*Label 33460*/ GIMT_Encode4(2377592), // Rule ID 50572 //
     /* 2377552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377555 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2377558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2377572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377591 */     // GIR_Coverage, 50572,
     /* 2377591 */     GIR_EraseRootFromParent_Done,
     /* 2377592 */   // Label 33460: @2377592
     /* 2377592 */   GIM_Try, /*On fail goto*//*Label 33461*/ GIMT_Encode4(2377637), // Rule ID 50573 //
     /* 2377597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377600 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2377603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2377617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377636 */     // GIR_Coverage, 50573,
     /* 2377636 */     GIR_EraseRootFromParent_Done,
     /* 2377637 */   // Label 33461: @2377637
     /* 2377637 */   GIM_Reject,
     /* 2377638 */ // Label 33459: @2377638
     /* 2377638 */ GIM_Reject,
     /* 2377639 */ // Label 33397: @2377639
     /* 2377639 */ GIM_Try, /*On fail goto*//*Label 33462*/ GIMT_Encode4(2377753),
     /* 2377644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2377647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2377650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377662 */   GIM_Try, /*On fail goto*//*Label 33463*/ GIMT_Encode4(2377707), // Rule ID 50588 //
     /* 2377667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377670 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2377673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2377687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377706 */     // GIR_Coverage, 50588,
     /* 2377706 */     GIR_EraseRootFromParent_Done,
     /* 2377707 */   // Label 33463: @2377707
     /* 2377707 */   GIM_Try, /*On fail goto*//*Label 33464*/ GIMT_Encode4(2377752), // Rule ID 50589 //
     /* 2377712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377715 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2377718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2377732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377751 */     // GIR_Coverage, 50589,
     /* 2377751 */     GIR_EraseRootFromParent_Done,
     /* 2377752 */   // Label 33464: @2377752
     /* 2377752 */   GIM_Reject,
     /* 2377753 */ // Label 33462: @2377753
     /* 2377753 */ GIM_Reject,
     /* 2377754 */ // Label 33398: @2377754
     /* 2377754 */ GIM_Try, /*On fail goto*//*Label 33465*/ GIMT_Encode4(2377868),
     /* 2377759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2377762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2377765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377777 */   GIM_Try, /*On fail goto*//*Label 33466*/ GIMT_Encode4(2377822), // Rule ID 50560 //
     /* 2377782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377785 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2377788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2377802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377821 */     // GIR_Coverage, 50560,
     /* 2377821 */     GIR_EraseRootFromParent_Done,
     /* 2377822 */   // Label 33466: @2377822
     /* 2377822 */   GIM_Try, /*On fail goto*//*Label 33467*/ GIMT_Encode4(2377867), // Rule ID 50561 //
     /* 2377827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377830 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2377833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2377847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377866 */     // GIR_Coverage, 50561,
     /* 2377866 */     GIR_EraseRootFromParent_Done,
     /* 2377867 */   // Label 33467: @2377867
     /* 2377867 */   GIM_Reject,
     /* 2377868 */ // Label 33465: @2377868
     /* 2377868 */ GIM_Reject,
     /* 2377869 */ // Label 33399: @2377869
     /* 2377869 */ GIM_Try, /*On fail goto*//*Label 33468*/ GIMT_Encode4(2377983),
     /* 2377874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2377877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2377880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377892 */   GIM_Try, /*On fail goto*//*Label 33469*/ GIMT_Encode4(2377937), // Rule ID 50576 //
     /* 2377897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377900 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2377903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2377917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377936 */     // GIR_Coverage, 50576,
     /* 2377936 */     GIR_EraseRootFromParent_Done,
     /* 2377937 */   // Label 33469: @2377937
     /* 2377937 */   GIM_Try, /*On fail goto*//*Label 33470*/ GIMT_Encode4(2377982), // Rule ID 50577 //
     /* 2377942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377945 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2377948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2377962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377981 */     // GIR_Coverage, 50577,
     /* 2377981 */     GIR_EraseRootFromParent_Done,
     /* 2377982 */   // Label 33470: @2377982
     /* 2377982 */   GIM_Reject,
     /* 2377983 */ // Label 33468: @2377983
     /* 2377983 */ GIM_Reject,
     /* 2377984 */ // Label 33400: @2377984
     /* 2377984 */ GIM_Try, /*On fail goto*//*Label 33471*/ GIMT_Encode4(2378098),
     /* 2377989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2377992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2377995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378007 */   GIM_Try, /*On fail goto*//*Label 33472*/ GIMT_Encode4(2378052), // Rule ID 50564 //
     /* 2378012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2378015 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2378018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2378032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378051 */     // GIR_Coverage, 50564,
     /* 2378051 */     GIR_EraseRootFromParent_Done,
     /* 2378052 */   // Label 33472: @2378052
     /* 2378052 */   GIM_Try, /*On fail goto*//*Label 33473*/ GIMT_Encode4(2378097), // Rule ID 50565 //
     /* 2378057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2378060 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2378063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2378077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378096 */     // GIR_Coverage, 50565,
     /* 2378096 */     GIR_EraseRootFromParent_Done,
     /* 2378097 */   // Label 33473: @2378097
     /* 2378097 */   GIM_Reject,
     /* 2378098 */ // Label 33471: @2378098
     /* 2378098 */ GIM_Reject,
     /* 2378099 */ // Label 33401: @2378099
     /* 2378099 */ GIM_Reject,
     /* 2378100 */ // Label 83: @2378100
     /* 2378100 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33498*/ GIMT_Encode4(2380875),
     /* 2378111 */ /*GILLT_s32*//*Label 33474*/ GIMT_Encode4(2378235),
     /* 2378115 */ /*GILLT_s64*//*Label 33475*/ GIMT_Encode4(2378290), GIMT_Encode4(0),
     /* 2378123 */ /*GILLT_nxv1s8*//*Label 33476*/ GIMT_Encode4(2378345),
     /* 2378127 */ /*GILLT_nxv1s16*//*Label 33477*/ GIMT_Encode4(2378460),
     /* 2378131 */ /*GILLT_nxv1s32*//*Label 33478*/ GIMT_Encode4(2378575),
     /* 2378135 */ /*GILLT_nxv1s64*//*Label 33479*/ GIMT_Encode4(2378690), GIMT_Encode4(0),
     /* 2378143 */ /*GILLT_nxv2s8*//*Label 33480*/ GIMT_Encode4(2378805),
     /* 2378147 */ /*GILLT_nxv2s16*//*Label 33481*/ GIMT_Encode4(2378920),
     /* 2378151 */ /*GILLT_nxv2s32*//*Label 33482*/ GIMT_Encode4(2379035),
     /* 2378155 */ /*GILLT_nxv2s64*//*Label 33483*/ GIMT_Encode4(2379150), GIMT_Encode4(0),
     /* 2378163 */ /*GILLT_nxv4s8*//*Label 33484*/ GIMT_Encode4(2379265),
     /* 2378167 */ /*GILLT_nxv4s16*//*Label 33485*/ GIMT_Encode4(2379380),
     /* 2378171 */ /*GILLT_nxv4s32*//*Label 33486*/ GIMT_Encode4(2379495),
     /* 2378175 */ /*GILLT_nxv4s64*//*Label 33487*/ GIMT_Encode4(2379610), GIMT_Encode4(0),
     /* 2378183 */ /*GILLT_nxv8s8*//*Label 33488*/ GIMT_Encode4(2379725),
     /* 2378187 */ /*GILLT_nxv8s16*//*Label 33489*/ GIMT_Encode4(2379840),
     /* 2378191 */ /*GILLT_nxv8s32*//*Label 33490*/ GIMT_Encode4(2379955),
     /* 2378195 */ /*GILLT_nxv8s64*//*Label 33491*/ GIMT_Encode4(2380070), GIMT_Encode4(0),
     /* 2378203 */ /*GILLT_nxv16s8*//*Label 33492*/ GIMT_Encode4(2380185),
     /* 2378207 */ /*GILLT_nxv16s16*//*Label 33493*/ GIMT_Encode4(2380300),
     /* 2378211 */ /*GILLT_nxv16s32*//*Label 33494*/ GIMT_Encode4(2380415), GIMT_Encode4(0),
     /* 2378219 */ /*GILLT_nxv32s8*//*Label 33495*/ GIMT_Encode4(2380530),
     /* 2378223 */ /*GILLT_nxv32s16*//*Label 33496*/ GIMT_Encode4(2380645), GIMT_Encode4(0),
     /* 2378231 */ /*GILLT_nxv64s8*//*Label 33497*/ GIMT_Encode4(2380760),
     /* 2378235 */ // Label 33474: @2378235
     /* 2378235 */ GIM_Try, /*On fail goto*//*Label 33499*/ GIMT_Encode4(2378289),
     /* 2378240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2378243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2378246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378258 */   GIM_Try, /*On fail goto*//*Label 33500*/ GIMT_Encode4(2378273), // Rule ID 64480 //
     /* 2378263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2378266 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2378266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2378271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378272 */     // GIR_Coverage, 64480,
     /* 2378272 */     GIR_Done,
     /* 2378273 */   // Label 33500: @2378273
     /* 2378273 */   GIM_Try, /*On fail goto*//*Label 33501*/ GIMT_Encode4(2378288), // Rule ID 2545 //
     /* 2378278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2378281 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2378281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2378286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378287 */     // GIR_Coverage, 2545,
     /* 2378287 */     GIR_Done,
     /* 2378288 */   // Label 33501: @2378288
     /* 2378288 */   GIM_Reject,
     /* 2378289 */ // Label 33499: @2378289
     /* 2378289 */ GIM_Reject,
     /* 2378290 */ // Label 33475: @2378290
     /* 2378290 */ GIM_Try, /*On fail goto*//*Label 33502*/ GIMT_Encode4(2378344),
     /* 2378295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2378298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2378301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378313 */   GIM_Try, /*On fail goto*//*Label 33503*/ GIMT_Encode4(2378328), // Rule ID 64479 //
     /* 2378318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2378321 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2378321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2378326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378327 */     // GIR_Coverage, 64479,
     /* 2378327 */     GIR_Done,
     /* 2378328 */   // Label 33503: @2378328
     /* 2378328 */   GIM_Try, /*On fail goto*//*Label 33504*/ GIMT_Encode4(2378343), // Rule ID 2544 //
     /* 2378333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2378336 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2378336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2378341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378342 */     // GIR_Coverage, 2544,
     /* 2378342 */     GIR_Done,
     /* 2378343 */   // Label 33504: @2378343
     /* 2378343 */   GIM_Reject,
     /* 2378344 */ // Label 33502: @2378344
     /* 2378344 */ GIM_Reject,
     /* 2378345 */ // Label 33476: @2378345
     /* 2378345 */ GIM_Try, /*On fail goto*//*Label 33505*/ GIMT_Encode4(2378459),
     /* 2378350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2378353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2378356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378368 */   GIM_Try, /*On fail goto*//*Label 33506*/ GIMT_Encode4(2378413), // Rule ID 50692 //
     /* 2378373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2378376 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2378379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2378393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378412 */     // GIR_Coverage, 50692,
     /* 2378412 */     GIR_EraseRootFromParent_Done,
     /* 2378413 */   // Label 33506: @2378413
     /* 2378413 */   GIM_Try, /*On fail goto*//*Label 33507*/ GIMT_Encode4(2378458), // Rule ID 50693 //
     /* 2378418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2378421 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2378424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2378438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378457 */     // GIR_Coverage, 50693,
     /* 2378457 */     GIR_EraseRootFromParent_Done,
     /* 2378458 */   // Label 33507: @2378458
     /* 2378458 */   GIM_Reject,
     /* 2378459 */ // Label 33505: @2378459
     /* 2378459 */ GIM_Reject,
     /* 2378460 */ // Label 33477: @2378460
     /* 2378460 */ GIM_Try, /*On fail goto*//*Label 33508*/ GIMT_Encode4(2378574),
     /* 2378465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2378468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2378471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378483 */   GIM_Try, /*On fail goto*//*Label 33509*/ GIMT_Encode4(2378528), // Rule ID 50704 //
     /* 2378488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2378491 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2378494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2378508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378527 */     // GIR_Coverage, 50704,
     /* 2378527 */     GIR_EraseRootFromParent_Done,
     /* 2378528 */   // Label 33509: @2378528
     /* 2378528 */   GIM_Try, /*On fail goto*//*Label 33510*/ GIMT_Encode4(2378573), // Rule ID 50705 //
     /* 2378533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2378536 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2378539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2378553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378572 */     // GIR_Coverage, 50705,
     /* 2378572 */     GIR_EraseRootFromParent_Done,
     /* 2378573 */   // Label 33510: @2378573
     /* 2378573 */   GIM_Reject,
     /* 2378574 */ // Label 33508: @2378574
     /* 2378574 */ GIM_Reject,
     /* 2378575 */ // Label 33478: @2378575
     /* 2378575 */ GIM_Try, /*On fail goto*//*Label 33511*/ GIMT_Encode4(2378689),
     /* 2378580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2378583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2378586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378594 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378598 */   GIM_Try, /*On fail goto*//*Label 33512*/ GIMT_Encode4(2378643), // Rule ID 50712 //
     /* 2378603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2378606 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2378609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2378623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378642 */     // GIR_Coverage, 50712,
     /* 2378642 */     GIR_EraseRootFromParent_Done,
     /* 2378643 */   // Label 33512: @2378643
     /* 2378643 */   GIM_Try, /*On fail goto*//*Label 33513*/ GIMT_Encode4(2378688), // Rule ID 50713 //
     /* 2378648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2378651 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2378654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2378668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378687 */     // GIR_Coverage, 50713,
     /* 2378687 */     GIR_EraseRootFromParent_Done,
     /* 2378688 */   // Label 33513: @2378688
     /* 2378688 */   GIM_Reject,
     /* 2378689 */ // Label 33511: @2378689
     /* 2378689 */ GIM_Reject,
     /* 2378690 */ // Label 33479: @2378690
     /* 2378690 */ GIM_Try, /*On fail goto*//*Label 33514*/ GIMT_Encode4(2378804),
     /* 2378695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2378698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2378701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378713 */   GIM_Try, /*On fail goto*//*Label 33515*/ GIMT_Encode4(2378758), // Rule ID 50728 //
     /* 2378718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2378721 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2378724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2378738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378757 */     // GIR_Coverage, 50728,
     /* 2378757 */     GIR_EraseRootFromParent_Done,
     /* 2378758 */   // Label 33515: @2378758
     /* 2378758 */   GIM_Try, /*On fail goto*//*Label 33516*/ GIMT_Encode4(2378803), // Rule ID 50729 //
     /* 2378763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2378766 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2378769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2378783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378802 */     // GIR_Coverage, 50729,
     /* 2378802 */     GIR_EraseRootFromParent_Done,
     /* 2378803 */   // Label 33516: @2378803
     /* 2378803 */   GIM_Reject,
     /* 2378804 */ // Label 33514: @2378804
     /* 2378804 */ GIM_Reject,
     /* 2378805 */ // Label 33480: @2378805
     /* 2378805 */ GIM_Try, /*On fail goto*//*Label 33517*/ GIMT_Encode4(2378919),
     /* 2378810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2378813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2378816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378828 */   GIM_Try, /*On fail goto*//*Label 33518*/ GIMT_Encode4(2378873), // Rule ID 50696 //
     /* 2378833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2378836 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2378839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2378853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378872 */     // GIR_Coverage, 50696,
     /* 2378872 */     GIR_EraseRootFromParent_Done,
     /* 2378873 */   // Label 33518: @2378873
     /* 2378873 */   GIM_Try, /*On fail goto*//*Label 33519*/ GIMT_Encode4(2378918), // Rule ID 50697 //
     /* 2378878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2378881 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2378884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2378898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378917 */     // GIR_Coverage, 50697,
     /* 2378917 */     GIR_EraseRootFromParent_Done,
     /* 2378918 */   // Label 33519: @2378918
     /* 2378918 */   GIM_Reject,
     /* 2378919 */ // Label 33517: @2378919
     /* 2378919 */ GIM_Reject,
     /* 2378920 */ // Label 33481: @2378920
     /* 2378920 */ GIM_Try, /*On fail goto*//*Label 33520*/ GIMT_Encode4(2379034),
     /* 2378925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2378928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2378931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378943 */   GIM_Try, /*On fail goto*//*Label 33521*/ GIMT_Encode4(2378988), // Rule ID 50708 //
     /* 2378948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2378951 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2378954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2378968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378987 */     // GIR_Coverage, 50708,
     /* 2378987 */     GIR_EraseRootFromParent_Done,
     /* 2378988 */   // Label 33521: @2378988
     /* 2378988 */   GIM_Try, /*On fail goto*//*Label 33522*/ GIMT_Encode4(2379033), // Rule ID 50709 //
     /* 2378993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2378996 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2378999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2379013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379032 */     // GIR_Coverage, 50709,
     /* 2379032 */     GIR_EraseRootFromParent_Done,
     /* 2379033 */   // Label 33522: @2379033
     /* 2379033 */   GIM_Reject,
     /* 2379034 */ // Label 33520: @2379034
     /* 2379034 */ GIM_Reject,
     /* 2379035 */ // Label 33482: @2379035
     /* 2379035 */ GIM_Try, /*On fail goto*//*Label 33523*/ GIMT_Encode4(2379149),
     /* 2379040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2379043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2379046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379058 */   GIM_Try, /*On fail goto*//*Label 33524*/ GIMT_Encode4(2379103), // Rule ID 50724 //
     /* 2379063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379066 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2379069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2379083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379102 */     // GIR_Coverage, 50724,
     /* 2379102 */     GIR_EraseRootFromParent_Done,
     /* 2379103 */   // Label 33524: @2379103
     /* 2379103 */   GIM_Try, /*On fail goto*//*Label 33525*/ GIMT_Encode4(2379148), // Rule ID 50725 //
     /* 2379108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2379111 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2379114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2379128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379147 */     // GIR_Coverage, 50725,
     /* 2379147 */     GIR_EraseRootFromParent_Done,
     /* 2379148 */   // Label 33525: @2379148
     /* 2379148 */   GIM_Reject,
     /* 2379149 */ // Label 33523: @2379149
     /* 2379149 */ GIM_Reject,
     /* 2379150 */ // Label 33483: @2379150
     /* 2379150 */ GIM_Try, /*On fail goto*//*Label 33526*/ GIMT_Encode4(2379264),
     /* 2379155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2379158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2379161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379173 */   GIM_Try, /*On fail goto*//*Label 33527*/ GIMT_Encode4(2379218), // Rule ID 50768 //
     /* 2379178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2379181 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2379184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2379198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379217 */     // GIR_Coverage, 50768,
     /* 2379217 */     GIR_EraseRootFromParent_Done,
     /* 2379218 */   // Label 33527: @2379218
     /* 2379218 */   GIM_Try, /*On fail goto*//*Label 33528*/ GIMT_Encode4(2379263), // Rule ID 50769 //
     /* 2379223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2379226 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2379229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2379243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379262 */     // GIR_Coverage, 50769,
     /* 2379262 */     GIR_EraseRootFromParent_Done,
     /* 2379263 */   // Label 33528: @2379263
     /* 2379263 */   GIM_Reject,
     /* 2379264 */ // Label 33526: @2379264
     /* 2379264 */ GIM_Reject,
     /* 2379265 */ // Label 33484: @2379265
     /* 2379265 */ GIM_Try, /*On fail goto*//*Label 33529*/ GIMT_Encode4(2379379),
     /* 2379270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2379273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2379276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379288 */   GIM_Try, /*On fail goto*//*Label 33530*/ GIMT_Encode4(2379333), // Rule ID 50700 //
     /* 2379293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379296 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2379299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2379313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379332 */     // GIR_Coverage, 50700,
     /* 2379332 */     GIR_EraseRootFromParent_Done,
     /* 2379333 */   // Label 33530: @2379333
     /* 2379333 */   GIM_Try, /*On fail goto*//*Label 33531*/ GIMT_Encode4(2379378), // Rule ID 50701 //
     /* 2379338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2379341 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2379344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2379358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379377 */     // GIR_Coverage, 50701,
     /* 2379377 */     GIR_EraseRootFromParent_Done,
     /* 2379378 */   // Label 33531: @2379378
     /* 2379378 */   GIM_Reject,
     /* 2379379 */ // Label 33529: @2379379
     /* 2379379 */ GIM_Reject,
     /* 2379380 */ // Label 33485: @2379380
     /* 2379380 */ GIM_Try, /*On fail goto*//*Label 33532*/ GIMT_Encode4(2379494),
     /* 2379385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2379388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2379391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379403 */   GIM_Try, /*On fail goto*//*Label 33533*/ GIMT_Encode4(2379448), // Rule ID 50720 //
     /* 2379408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379411 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2379414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2379428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379447 */     // GIR_Coverage, 50720,
     /* 2379447 */     GIR_EraseRootFromParent_Done,
     /* 2379448 */   // Label 33533: @2379448
     /* 2379448 */   GIM_Try, /*On fail goto*//*Label 33534*/ GIMT_Encode4(2379493), // Rule ID 50721 //
     /* 2379453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2379456 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2379459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2379473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379492 */     // GIR_Coverage, 50721,
     /* 2379492 */     GIR_EraseRootFromParent_Done,
     /* 2379493 */   // Label 33534: @2379493
     /* 2379493 */   GIM_Reject,
     /* 2379494 */ // Label 33532: @2379494
     /* 2379494 */ GIM_Reject,
     /* 2379495 */ // Label 33486: @2379495
     /* 2379495 */ GIM_Try, /*On fail goto*//*Label 33535*/ GIMT_Encode4(2379609),
     /* 2379500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2379503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2379506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379518 */   GIM_Try, /*On fail goto*//*Label 33536*/ GIMT_Encode4(2379563), // Rule ID 50756 //
     /* 2379523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379526 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2379529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2379543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379562 */     // GIR_Coverage, 50756,
     /* 2379562 */     GIR_EraseRootFromParent_Done,
     /* 2379563 */   // Label 33536: @2379563
     /* 2379563 */   GIM_Try, /*On fail goto*//*Label 33537*/ GIMT_Encode4(2379608), // Rule ID 50757 //
     /* 2379568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2379571 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2379574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2379588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379607 */     // GIR_Coverage, 50757,
     /* 2379607 */     GIR_EraseRootFromParent_Done,
     /* 2379608 */   // Label 33537: @2379608
     /* 2379608 */   GIM_Reject,
     /* 2379609 */ // Label 33535: @2379609
     /* 2379609 */ GIM_Reject,
     /* 2379610 */ // Label 33487: @2379610
     /* 2379610 */ GIM_Try, /*On fail goto*//*Label 33538*/ GIMT_Encode4(2379724),
     /* 2379615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2379618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2379621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379633 */   GIM_Try, /*On fail goto*//*Label 33539*/ GIMT_Encode4(2379678), // Rule ID 50772 //
     /* 2379638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2379641 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2379644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2379658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379677 */     // GIR_Coverage, 50772,
     /* 2379677 */     GIR_EraseRootFromParent_Done,
     /* 2379678 */   // Label 33539: @2379678
     /* 2379678 */   GIM_Try, /*On fail goto*//*Label 33540*/ GIMT_Encode4(2379723), // Rule ID 50773 //
     /* 2379683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2379686 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2379689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2379703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379722 */     // GIR_Coverage, 50773,
     /* 2379722 */     GIR_EraseRootFromParent_Done,
     /* 2379723 */   // Label 33540: @2379723
     /* 2379723 */   GIM_Reject,
     /* 2379724 */ // Label 33538: @2379724
     /* 2379724 */ GIM_Reject,
     /* 2379725 */ // Label 33488: @2379725
     /* 2379725 */ GIM_Try, /*On fail goto*//*Label 33541*/ GIMT_Encode4(2379839),
     /* 2379730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2379733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2379736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379748 */   GIM_Try, /*On fail goto*//*Label 33542*/ GIMT_Encode4(2379793), // Rule ID 50716 //
     /* 2379753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379756 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2379759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2379773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379792 */     // GIR_Coverage, 50716,
     /* 2379792 */     GIR_EraseRootFromParent_Done,
     /* 2379793 */   // Label 33542: @2379793
     /* 2379793 */   GIM_Try, /*On fail goto*//*Label 33543*/ GIMT_Encode4(2379838), // Rule ID 50717 //
     /* 2379798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2379801 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2379804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2379818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379837 */     // GIR_Coverage, 50717,
     /* 2379837 */     GIR_EraseRootFromParent_Done,
     /* 2379838 */   // Label 33543: @2379838
     /* 2379838 */   GIM_Reject,
     /* 2379839 */ // Label 33541: @2379839
     /* 2379839 */ GIM_Reject,
     /* 2379840 */ // Label 33489: @2379840
     /* 2379840 */ GIM_Try, /*On fail goto*//*Label 33544*/ GIMT_Encode4(2379954),
     /* 2379845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2379848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2379851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379863 */   GIM_Try, /*On fail goto*//*Label 33545*/ GIMT_Encode4(2379908), // Rule ID 50744 //
     /* 2379868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379871 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2379874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2379888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379907 */     // GIR_Coverage, 50744,
     /* 2379907 */     GIR_EraseRootFromParent_Done,
     /* 2379908 */   // Label 33545: @2379908
     /* 2379908 */   GIM_Try, /*On fail goto*//*Label 33546*/ GIMT_Encode4(2379953), // Rule ID 50745 //
     /* 2379913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2379916 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2379919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2379933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379952 */     // GIR_Coverage, 50745,
     /* 2379952 */     GIR_EraseRootFromParent_Done,
     /* 2379953 */   // Label 33546: @2379953
     /* 2379953 */   GIM_Reject,
     /* 2379954 */ // Label 33544: @2379954
     /* 2379954 */ GIM_Reject,
     /* 2379955 */ // Label 33490: @2379955
     /* 2379955 */ GIM_Try, /*On fail goto*//*Label 33547*/ GIMT_Encode4(2380069),
     /* 2379960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2379963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2379966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379978 */   GIM_Try, /*On fail goto*//*Label 33548*/ GIMT_Encode4(2380023), // Rule ID 50760 //
     /* 2379983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379986 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2379989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2380003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380022 */     // GIR_Coverage, 50760,
     /* 2380022 */     GIR_EraseRootFromParent_Done,
     /* 2380023 */   // Label 33548: @2380023
     /* 2380023 */   GIM_Try, /*On fail goto*//*Label 33549*/ GIMT_Encode4(2380068), // Rule ID 50761 //
     /* 2380028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380031 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2380034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2380048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380067 */     // GIR_Coverage, 50761,
     /* 2380067 */     GIR_EraseRootFromParent_Done,
     /* 2380068 */   // Label 33549: @2380068
     /* 2380068 */   GIM_Reject,
     /* 2380069 */ // Label 33547: @2380069
     /* 2380069 */ GIM_Reject,
     /* 2380070 */ // Label 33491: @2380070
     /* 2380070 */ GIM_Try, /*On fail goto*//*Label 33550*/ GIMT_Encode4(2380184),
     /* 2380075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2380078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2380081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380093 */   GIM_Try, /*On fail goto*//*Label 33551*/ GIMT_Encode4(2380138), // Rule ID 50776 //
     /* 2380098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2380101 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2380104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380137 */     // GIR_Coverage, 50776,
     /* 2380137 */     GIR_EraseRootFromParent_Done,
     /* 2380138 */   // Label 33551: @2380138
     /* 2380138 */   GIM_Try, /*On fail goto*//*Label 33552*/ GIMT_Encode4(2380183), // Rule ID 50777 //
     /* 2380143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2380146 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2380149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380182 */     // GIR_Coverage, 50777,
     /* 2380182 */     GIR_EraseRootFromParent_Done,
     /* 2380183 */   // Label 33552: @2380183
     /* 2380183 */   GIM_Reject,
     /* 2380184 */ // Label 33550: @2380184
     /* 2380184 */ GIM_Reject,
     /* 2380185 */ // Label 33492: @2380185
     /* 2380185 */ GIM_Try, /*On fail goto*//*Label 33553*/ GIMT_Encode4(2380299),
     /* 2380190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2380193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2380196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380208 */   GIM_Try, /*On fail goto*//*Label 33554*/ GIMT_Encode4(2380253), // Rule ID 50732 //
     /* 2380213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2380216 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2380219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2380233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380252 */     // GIR_Coverage, 50732,
     /* 2380252 */     GIR_EraseRootFromParent_Done,
     /* 2380253 */   // Label 33554: @2380253
     /* 2380253 */   GIM_Try, /*On fail goto*//*Label 33555*/ GIMT_Encode4(2380298), // Rule ID 50733 //
     /* 2380258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380261 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2380264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2380278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380297 */     // GIR_Coverage, 50733,
     /* 2380297 */     GIR_EraseRootFromParent_Done,
     /* 2380298 */   // Label 33555: @2380298
     /* 2380298 */   GIM_Reject,
     /* 2380299 */ // Label 33553: @2380299
     /* 2380299 */ GIM_Reject,
     /* 2380300 */ // Label 33493: @2380300
     /* 2380300 */ GIM_Try, /*On fail goto*//*Label 33556*/ GIMT_Encode4(2380414),
     /* 2380305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2380308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2380311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380323 */   GIM_Try, /*On fail goto*//*Label 33557*/ GIMT_Encode4(2380368), // Rule ID 50748 //
     /* 2380328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2380331 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2380334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2380348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380367 */     // GIR_Coverage, 50748,
     /* 2380367 */     GIR_EraseRootFromParent_Done,
     /* 2380368 */   // Label 33557: @2380368
     /* 2380368 */   GIM_Try, /*On fail goto*//*Label 33558*/ GIMT_Encode4(2380413), // Rule ID 50749 //
     /* 2380373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380376 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2380379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2380393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380412 */     // GIR_Coverage, 50749,
     /* 2380412 */     GIR_EraseRootFromParent_Done,
     /* 2380413 */   // Label 33558: @2380413
     /* 2380413 */   GIM_Reject,
     /* 2380414 */ // Label 33556: @2380414
     /* 2380414 */ GIM_Reject,
     /* 2380415 */ // Label 33494: @2380415
     /* 2380415 */ GIM_Try, /*On fail goto*//*Label 33559*/ GIMT_Encode4(2380529),
     /* 2380420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2380423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2380426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380438 */   GIM_Try, /*On fail goto*//*Label 33560*/ GIMT_Encode4(2380483), // Rule ID 50764 //
     /* 2380443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2380446 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2380449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380482 */     // GIR_Coverage, 50764,
     /* 2380482 */     GIR_EraseRootFromParent_Done,
     /* 2380483 */   // Label 33560: @2380483
     /* 2380483 */   GIM_Try, /*On fail goto*//*Label 33561*/ GIMT_Encode4(2380528), // Rule ID 50765 //
     /* 2380488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380491 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2380494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380527 */     // GIR_Coverage, 50765,
     /* 2380527 */     GIR_EraseRootFromParent_Done,
     /* 2380528 */   // Label 33561: @2380528
     /* 2380528 */   GIM_Reject,
     /* 2380529 */ // Label 33559: @2380529
     /* 2380529 */ GIM_Reject,
     /* 2380530 */ // Label 33495: @2380530
     /* 2380530 */ GIM_Try, /*On fail goto*//*Label 33562*/ GIMT_Encode4(2380644),
     /* 2380535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2380538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2380541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380553 */   GIM_Try, /*On fail goto*//*Label 33563*/ GIMT_Encode4(2380598), // Rule ID 50736 //
     /* 2380558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2380561 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2380564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2380578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380597 */     // GIR_Coverage, 50736,
     /* 2380597 */     GIR_EraseRootFromParent_Done,
     /* 2380598 */   // Label 33563: @2380598
     /* 2380598 */   GIM_Try, /*On fail goto*//*Label 33564*/ GIMT_Encode4(2380643), // Rule ID 50737 //
     /* 2380603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380606 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2380609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2380623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380642 */     // GIR_Coverage, 50737,
     /* 2380642 */     GIR_EraseRootFromParent_Done,
     /* 2380643 */   // Label 33564: @2380643
     /* 2380643 */   GIM_Reject,
     /* 2380644 */ // Label 33562: @2380644
     /* 2380644 */ GIM_Reject,
     /* 2380645 */ // Label 33496: @2380645
     /* 2380645 */ GIM_Try, /*On fail goto*//*Label 33565*/ GIMT_Encode4(2380759),
     /* 2380650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2380653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2380656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380668 */   GIM_Try, /*On fail goto*//*Label 33566*/ GIMT_Encode4(2380713), // Rule ID 50752 //
     /* 2380673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2380676 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2380679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380712 */     // GIR_Coverage, 50752,
     /* 2380712 */     GIR_EraseRootFromParent_Done,
     /* 2380713 */   // Label 33566: @2380713
     /* 2380713 */   GIM_Try, /*On fail goto*//*Label 33567*/ GIMT_Encode4(2380758), // Rule ID 50753 //
     /* 2380718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380721 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2380724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380757 */     // GIR_Coverage, 50753,
     /* 2380757 */     GIR_EraseRootFromParent_Done,
     /* 2380758 */   // Label 33567: @2380758
     /* 2380758 */   GIM_Reject,
     /* 2380759 */ // Label 33565: @2380759
     /* 2380759 */ GIM_Reject,
     /* 2380760 */ // Label 33497: @2380760
     /* 2380760 */ GIM_Try, /*On fail goto*//*Label 33568*/ GIMT_Encode4(2380874),
     /* 2380765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2380768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2380771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380783 */   GIM_Try, /*On fail goto*//*Label 33569*/ GIMT_Encode4(2380828), // Rule ID 50740 //
     /* 2380788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2380791 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2380794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380827 */     // GIR_Coverage, 50740,
     /* 2380827 */     GIR_EraseRootFromParent_Done,
     /* 2380828 */   // Label 33569: @2380828
     /* 2380828 */   GIM_Try, /*On fail goto*//*Label 33570*/ GIMT_Encode4(2380873), // Rule ID 50741 //
     /* 2380833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380836 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2380839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380872 */     // GIR_Coverage, 50741,
     /* 2380872 */     GIR_EraseRootFromParent_Done,
     /* 2380873 */   // Label 33570: @2380873
     /* 2380873 */   GIM_Reject,
     /* 2380874 */ // Label 33568: @2380874
     /* 2380874 */ GIM_Reject,
     /* 2380875 */ // Label 33498: @2380875
     /* 2380875 */ GIM_Reject,
     /* 2380876 */ // Label 84: @2380876
     /* 2380876 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33573*/ GIMT_Encode4(2381033),
     /* 2380887 */ /*GILLT_s32*//*Label 33571*/ GIMT_Encode4(2380895),
     /* 2380891 */ /*GILLT_s64*//*Label 33572*/ GIMT_Encode4(2380964),
     /* 2380895 */ // Label 33571: @2380895
     /* 2380895 */ GIM_Try, /*On fail goto*//*Label 33574*/ GIMT_Encode4(2380963),
     /* 2380900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2380903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380911 */   GIM_Try, /*On fail goto*//*Label 33575*/ GIMT_Encode4(2380926), // Rule ID 64468 //
     /* 2380916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2380919 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_ABS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2380919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2380924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380925 */     // GIR_Coverage, 64468,
     /* 2380925 */     GIR_Done,
     /* 2380926 */   // Label 33575: @2380926
     /* 2380926 */   GIM_Try, /*On fail goto*//*Label 33576*/ GIMT_Encode4(2380962), // Rule ID 62523 //
     /* 2380931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode1),
     /* 2380934 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (PseudoCCSUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, 2:{ *:[i32] }, GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2380934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2380937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2380939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2380947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2380950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2380958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380961 */     // GIR_Coverage, 62523,
     /* 2380961 */     GIR_EraseRootFromParent_Done,
     /* 2380962 */   // Label 33576: @2380962
     /* 2380962 */   GIM_Reject,
     /* 2380963 */ // Label 33574: @2380963
     /* 2380963 */ GIM_Reject,
     /* 2380964 */ // Label 33572: @2380964
     /* 2380964 */ GIM_Try, /*On fail goto*//*Label 33577*/ GIMT_Encode4(2381032),
     /* 2380969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2380972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380980 */   GIM_Try, /*On fail goto*//*Label 33578*/ GIMT_Encode4(2380995), // Rule ID 64467 //
     /* 2380985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2380988 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_ABS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2380988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2380993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380994 */     // GIR_Coverage, 64467,
     /* 2380994 */     GIR_Done,
     /* 2380995 */   // Label 33578: @2380995
     /* 2380995 */   GIM_Try, /*On fail goto*//*Label 33579*/ GIMT_Encode4(2381031), // Rule ID 62522 //
     /* 2381000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode0),
     /* 2381003 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (PseudoCCSUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, 2:{ *:[i64] }, GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2381003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2381006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2381008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2381016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2381019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2381027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381030 */     // GIR_Coverage, 62522,
     /* 2381030 */     GIR_EraseRootFromParent_Done,
     /* 2381031 */   // Label 33579: @2381031
     /* 2381031 */   GIM_Reject,
     /* 2381032 */ // Label 33577: @2381032
     /* 2381032 */ GIM_Reject,
     /* 2381033 */ // Label 33573: @2381033
     /* 2381033 */ GIM_Reject,
     /* 2381034 */ // Label 85: @2381034
     /* 2381034 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33582*/ GIMT_Encode4(2381613),
     /* 2381045 */ /*GILLT_s32*//*Label 33580*/ GIMT_Encode4(2381053),
     /* 2381049 */ /*GILLT_s64*//*Label 33581*/ GIMT_Encode4(2381426),
     /* 2381053 */ // Label 33580: @2381053
     /* 2381053 */ GIM_Try, /*On fail goto*//*Label 33583*/ GIMT_Encode4(2381084), // Rule ID 1478 //
     /* 2381058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2381061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381072 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2381072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2381075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381077 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381083 */   // GIR_Coverage, 1478,
     /* 2381083 */   GIR_EraseRootFromParent_Done,
     /* 2381084 */ // Label 33583: @2381084
     /* 2381084 */ GIM_Try, /*On fail goto*//*Label 33584*/ GIMT_Encode4(2381115), // Rule ID 1479 //
     /* 2381089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2381092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381103 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2381103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2381106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381108 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381113 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381114 */   // GIR_Coverage, 1479,
     /* 2381114 */   GIR_EraseRootFromParent_Done,
     /* 2381115 */ // Label 33584: @2381115
     /* 2381115 */ GIM_Try, /*On fail goto*//*Label 33585*/ GIMT_Encode4(2381146), // Rule ID 1504 //
     /* 2381120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2381123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381134 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2381134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2381137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381139 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381145 */   // GIR_Coverage, 1504,
     /* 2381145 */   GIR_EraseRootFromParent_Done,
     /* 2381146 */ // Label 33585: @2381146
     /* 2381146 */ GIM_Try, /*On fail goto*//*Label 33586*/ GIMT_Encode4(2381177), // Rule ID 1505 //
     /* 2381151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2381154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381165 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2381165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2381168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381170 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381175 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381176 */   // GIR_Coverage, 1505,
     /* 2381176 */   GIR_EraseRootFromParent_Done,
     /* 2381177 */ // Label 33586: @2381177
     /* 2381177 */ GIM_Try, /*On fail goto*//*Label 33587*/ GIMT_Encode4(2381208), // Rule ID 1872 //
     /* 2381182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2381185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381196 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2381196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2381199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381201 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381207 */   // GIR_Coverage, 1872,
     /* 2381207 */   GIR_EraseRootFromParent_Done,
     /* 2381208 */ // Label 33587: @2381208
     /* 2381208 */ GIM_Try, /*On fail goto*//*Label 33588*/ GIMT_Encode4(2381239), // Rule ID 1873 //
     /* 2381213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2381216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381227 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2381227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2381230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381232 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381238 */   // GIR_Coverage, 1873,
     /* 2381238 */   GIR_EraseRootFromParent_Done,
     /* 2381239 */ // Label 33588: @2381239
     /* 2381239 */ GIM_Try, /*On fail goto*//*Label 33589*/ GIMT_Encode4(2381270), // Rule ID 1898 //
     /* 2381244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2381247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2381258 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2381258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2381261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381263 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381269 */   // GIR_Coverage, 1898,
     /* 2381269 */   GIR_EraseRootFromParent_Done,
     /* 2381270 */ // Label 33589: @2381270
     /* 2381270 */ GIM_Try, /*On fail goto*//*Label 33590*/ GIMT_Encode4(2381301), // Rule ID 1899 //
     /* 2381275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2381278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2381289 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2381289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2381292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381294 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381300 */   // GIR_Coverage, 1899,
     /* 2381300 */   GIR_EraseRootFromParent_Done,
     /* 2381301 */ // Label 33590: @2381301
     /* 2381301 */ GIM_Try, /*On fail goto*//*Label 33591*/ GIMT_Encode4(2381332), // Rule ID 2214 //
     /* 2381306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2381309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381320 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2381320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2381323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381325 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381330 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381331 */   // GIR_Coverage, 2214,
     /* 2381331 */   GIR_EraseRootFromParent_Done,
     /* 2381332 */ // Label 33591: @2381332
     /* 2381332 */ GIM_Try, /*On fail goto*//*Label 33592*/ GIMT_Encode4(2381363), // Rule ID 2215 //
     /* 2381337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2381340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381351 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2381351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2381354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381356 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381362 */   // GIR_Coverage, 2215,
     /* 2381362 */   GIR_EraseRootFromParent_Done,
     /* 2381363 */ // Label 33592: @2381363
     /* 2381363 */ GIM_Try, /*On fail goto*//*Label 33593*/ GIMT_Encode4(2381394), // Rule ID 2240 //
     /* 2381368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2381371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381382 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2381382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2381385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381387 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381392 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381393 */   // GIR_Coverage, 2240,
     /* 2381393 */   GIR_EraseRootFromParent_Done,
     /* 2381394 */ // Label 33593: @2381394
     /* 2381394 */ GIM_Try, /*On fail goto*//*Label 33594*/ GIMT_Encode4(2381425), // Rule ID 2241 //
     /* 2381399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2381402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381413 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2381413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2381416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381418 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381423 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381424 */   // GIR_Coverage, 2241,
     /* 2381424 */   GIR_EraseRootFromParent_Done,
     /* 2381425 */ // Label 33594: @2381425
     /* 2381425 */ GIM_Reject,
     /* 2381426 */ // Label 33581: @2381426
     /* 2381426 */ GIM_Try, /*On fail goto*//*Label 33595*/ GIMT_Encode4(2381457), // Rule ID 1531 //
     /* 2381431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2381434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381445 */   // (lround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2381445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2381448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381450 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381455 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381456 */   // GIR_Coverage, 1531,
     /* 2381456 */   GIR_EraseRootFromParent_Done,
     /* 2381457 */ // Label 33595: @2381457
     /* 2381457 */ GIM_Try, /*On fail goto*//*Label 33596*/ GIMT_Encode4(2381488), // Rule ID 1559 //
     /* 2381462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2381465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381476 */   // (lround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2381476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2381479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381481 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381486 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381487 */   // GIR_Coverage, 1559,
     /* 2381487 */   GIR_EraseRootFromParent_Done,
     /* 2381488 */ // Label 33596: @2381488
     /* 2381488 */ GIM_Try, /*On fail goto*//*Label 33597*/ GIMT_Encode4(2381519), // Rule ID 1929 //
     /* 2381493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2381496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381507 */   // (lround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2381507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2381510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381512 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381518 */   // GIR_Coverage, 1929,
     /* 2381518 */   GIR_EraseRootFromParent_Done,
     /* 2381519 */ // Label 33597: @2381519
     /* 2381519 */ GIM_Try, /*On fail goto*//*Label 33598*/ GIMT_Encode4(2381550), // Rule ID 1957 //
     /* 2381524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2381527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381538 */   // (lround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2381538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2381541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381543 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381548 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381549 */   // GIR_Coverage, 1957,
     /* 2381549 */   GIR_EraseRootFromParent_Done,
     /* 2381550 */ // Label 33598: @2381550
     /* 2381550 */ GIM_Try, /*On fail goto*//*Label 33599*/ GIMT_Encode4(2381581), // Rule ID 2265 //
     /* 2381555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2381558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381569 */   // (lround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2381569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2381572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381574 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381579 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381580 */   // GIR_Coverage, 2265,
     /* 2381580 */   GIR_EraseRootFromParent_Done,
     /* 2381581 */ // Label 33599: @2381581
     /* 2381581 */ GIM_Try, /*On fail goto*//*Label 33600*/ GIMT_Encode4(2381612), // Rule ID 2291 //
     /* 2381586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2381589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381600 */   // (lround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2381600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2381603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381605 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381610 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381611 */   // GIR_Coverage, 2291,
     /* 2381611 */   GIR_EraseRootFromParent_Done,
     /* 2381612 */ // Label 33600: @2381612
     /* 2381612 */ GIM_Reject,
     /* 2381613 */ // Label 33582: @2381613
     /* 2381613 */ GIM_Reject,
     /* 2381614 */ // Label 86: @2381614
     /* 2381614 */ GIM_Try, /*On fail goto*//*Label 33601*/ GIMT_Encode4(2381823),
     /* 2381619 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2381622 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33605*/ GIMT_Encode4(2381822),
     /* 2381633 */   /*GILLT_s16*//*Label 33602*/ GIMT_Encode4(2381645),
     /* 2381637 */   /*GILLT_s32*//*Label 33603*/ GIMT_Encode4(2381704),
     /* 2381641 */   /*GILLT_s64*//*Label 33604*/ GIMT_Encode4(2381763),
     /* 2381645 */   // Label 33602: @2381645
     /* 2381645 */   GIM_Try, /*On fail goto*//*Label 33606*/ GIMT_Encode4(2381703),
     /* 2381650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381654 */     GIM_Try, /*On fail goto*//*Label 33607*/ GIMT_Encode4(2381678), // Rule ID 2267 //
     /* 2381659 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2381662 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381666 */       // (llround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2381666 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2381669 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381671 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381673 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381676 */       GIR_RootConstrainSelectedInstOperands,
     /* 2381677 */       // GIR_Coverage, 2267,
     /* 2381677 */       GIR_EraseRootFromParent_Done,
     /* 2381678 */     // Label 33607: @2381678
     /* 2381678 */     GIM_Try, /*On fail goto*//*Label 33608*/ GIMT_Encode4(2381702), // Rule ID 2293 //
     /* 2381683 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2381686 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381690 */       // (llround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2381690 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2381693 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381695 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381697 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381700 */       GIR_RootConstrainSelectedInstOperands,
     /* 2381701 */       // GIR_Coverage, 2293,
     /* 2381701 */       GIR_EraseRootFromParent_Done,
     /* 2381702 */     // Label 33608: @2381702
     /* 2381702 */     GIM_Reject,
     /* 2381703 */   // Label 33606: @2381703
     /* 2381703 */   GIM_Reject,
     /* 2381704 */   // Label 33603: @2381704
     /* 2381704 */   GIM_Try, /*On fail goto*//*Label 33609*/ GIMT_Encode4(2381762),
     /* 2381709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381713 */     GIM_Try, /*On fail goto*//*Label 33610*/ GIMT_Encode4(2381737), // Rule ID 1533 //
     /* 2381718 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2381721 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381725 */       // (llround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2381725 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2381728 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381730 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381732 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381735 */       GIR_RootConstrainSelectedInstOperands,
     /* 2381736 */       // GIR_Coverage, 1533,
     /* 2381736 */       GIR_EraseRootFromParent_Done,
     /* 2381737 */     // Label 33610: @2381737
     /* 2381737 */     GIM_Try, /*On fail goto*//*Label 33611*/ GIMT_Encode4(2381761), // Rule ID 1561 //
     /* 2381742 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2381745 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381749 */       // (llround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2381749 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2381752 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381754 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381756 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381759 */       GIR_RootConstrainSelectedInstOperands,
     /* 2381760 */       // GIR_Coverage, 1561,
     /* 2381760 */       GIR_EraseRootFromParent_Done,
     /* 2381761 */     // Label 33611: @2381761
     /* 2381761 */     GIM_Reject,
     /* 2381762 */   // Label 33609: @2381762
     /* 2381762 */   GIM_Reject,
     /* 2381763 */   // Label 33604: @2381763
     /* 2381763 */   GIM_Try, /*On fail goto*//*Label 33612*/ GIMT_Encode4(2381821),
     /* 2381768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381772 */     GIM_Try, /*On fail goto*//*Label 33613*/ GIMT_Encode4(2381796), // Rule ID 1931 //
     /* 2381777 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2381780 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381784 */       // (llround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2381784 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2381787 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381789 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381791 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381794 */       GIR_RootConstrainSelectedInstOperands,
     /* 2381795 */       // GIR_Coverage, 1931,
     /* 2381795 */       GIR_EraseRootFromParent_Done,
     /* 2381796 */     // Label 33613: @2381796
     /* 2381796 */     GIM_Try, /*On fail goto*//*Label 33614*/ GIMT_Encode4(2381820), // Rule ID 1959 //
     /* 2381801 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2381804 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381808 */       // (llround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2381808 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2381811 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381813 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381815 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381818 */       GIR_RootConstrainSelectedInstOperands,
     /* 2381819 */       // GIR_Coverage, 1959,
     /* 2381819 */       GIR_EraseRootFromParent_Done,
     /* 2381820 */     // Label 33614: @2381820
     /* 2381820 */     GIM_Reject,
     /* 2381821 */   // Label 33612: @2381821
     /* 2381821 */   GIM_Reject,
     /* 2381822 */   // Label 33605: @2381822
     /* 2381822 */   GIM_Reject,
     /* 2381823 */ // Label 33601: @2381823
     /* 2381823 */ GIM_Reject,
     /* 2381824 */ // Label 87: @2381824
     /* 2381824 */ GIM_Try, /*On fail goto*//*Label 33615*/ GIMT_Encode4(2381839), // Rule ID 4 //
     /* 2381829 */   // MIs[0] imm20
     /* 2381829 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 2381832 */   // (br (bb:{ *:[Other] }):$imm20)  =>  (PseudoBR (bb:{ *:[Other] }):$imm20)
     /* 2381832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoBR),
     /* 2381837 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381838 */   // GIR_Coverage, 4,
     /* 2381838 */   GIR_Done,
     /* 2381839 */ // Label 33615: @2381839
     /* 2381839 */ GIM_Reject,
     /* 2381840 */ // Label 88: @2381840
     /* 2381840 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33640*/ GIMT_Encode4(2384467),
     /* 2381851 */ /*GILLT_s32*//*Label 33616*/ GIMT_Encode4(2381975),
     /* 2381855 */ /*GILLT_s64*//*Label 33617*/ GIMT_Encode4(2382131), GIMT_Encode4(0),
     /* 2381863 */ /*GILLT_nxv1s8*//*Label 33618*/ GIMT_Encode4(2382179),
     /* 2381867 */ /*GILLT_nxv1s16*//*Label 33619*/ GIMT_Encode4(2382283),
     /* 2381871 */ /*GILLT_nxv1s32*//*Label 33620*/ GIMT_Encode4(2382387),
     /* 2381875 */ /*GILLT_nxv1s64*//*Label 33621*/ GIMT_Encode4(2382491), GIMT_Encode4(0),
     /* 2381883 */ /*GILLT_nxv2s8*//*Label 33622*/ GIMT_Encode4(2382595),
     /* 2381887 */ /*GILLT_nxv2s16*//*Label 33623*/ GIMT_Encode4(2382699),
     /* 2381891 */ /*GILLT_nxv2s32*//*Label 33624*/ GIMT_Encode4(2382803),
     /* 2381895 */ /*GILLT_nxv2s64*//*Label 33625*/ GIMT_Encode4(2382907), GIMT_Encode4(0),
     /* 2381903 */ /*GILLT_nxv4s8*//*Label 33626*/ GIMT_Encode4(2383011),
     /* 2381907 */ /*GILLT_nxv4s16*//*Label 33627*/ GIMT_Encode4(2383115),
     /* 2381911 */ /*GILLT_nxv4s32*//*Label 33628*/ GIMT_Encode4(2383219),
     /* 2381915 */ /*GILLT_nxv4s64*//*Label 33629*/ GIMT_Encode4(2383323), GIMT_Encode4(0),
     /* 2381923 */ /*GILLT_nxv8s8*//*Label 33630*/ GIMT_Encode4(2383427),
     /* 2381927 */ /*GILLT_nxv8s16*//*Label 33631*/ GIMT_Encode4(2383531),
     /* 2381931 */ /*GILLT_nxv8s32*//*Label 33632*/ GIMT_Encode4(2383635),
     /* 2381935 */ /*GILLT_nxv8s64*//*Label 33633*/ GIMT_Encode4(2383739), GIMT_Encode4(0),
     /* 2381943 */ /*GILLT_nxv16s8*//*Label 33634*/ GIMT_Encode4(2383843),
     /* 2381947 */ /*GILLT_nxv16s16*//*Label 33635*/ GIMT_Encode4(2383947),
     /* 2381951 */ /*GILLT_nxv16s32*//*Label 33636*/ GIMT_Encode4(2384051), GIMT_Encode4(0),
     /* 2381959 */ /*GILLT_nxv32s8*//*Label 33637*/ GIMT_Encode4(2384155),
     /* 2381963 */ /*GILLT_nxv32s16*//*Label 33638*/ GIMT_Encode4(2384259), GIMT_Encode4(0),
     /* 2381971 */ /*GILLT_nxv64s8*//*Label 33639*/ GIMT_Encode4(2384363),
     /* 2381975 */ // Label 33616: @2381975
     /* 2381975 */ GIM_Try, /*On fail goto*//*Label 33641*/ GIMT_Encode4(2382130),
     /* 2381980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381983 */   GIM_Try, /*On fail goto*//*Label 33642*/ GIMT_Encode4(2382033), // Rule ID 64649 //
     /* 2381988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2381991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2381995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2381999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2382003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2382007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2382011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382016 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2382020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2382022 */     // (cttz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CTO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2382022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CTO),
     /* 2382025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2382031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382032 */     // GIR_Coverage, 64649,
     /* 2382032 */     GIR_EraseRootFromParent_Done,
     /* 2382033 */   // Label 33642: @2382033
     /* 2382033 */   GIM_Try, /*On fail goto*//*Label 33643*/ GIMT_Encode4(2382083), // Rule ID 64650 //
     /* 2382038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2382041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2382045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2382049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2382053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2382057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2382061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382066 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2382070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2382072 */     // (cttz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CTO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2382072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CTO),
     /* 2382075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2382081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382082 */     // GIR_Coverage, 64650,
     /* 2382082 */     GIR_EraseRootFromParent_Done,
     /* 2382083 */   // Label 33643: @2382083
     /* 2382083 */   GIM_Try, /*On fail goto*//*Label 33644*/ GIMT_Encode4(2382106), // Rule ID 2527 //
     /* 2382088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2382091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382099 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CTZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2382099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2382104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382105 */     // GIR_Coverage, 2527,
     /* 2382105 */     GIR_Done,
     /* 2382106 */   // Label 33644: @2382106
     /* 2382106 */   GIM_Try, /*On fail goto*//*Label 33645*/ GIMT_Encode4(2382129), // Rule ID 64451 //
     /* 2382111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2382114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382122 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2382122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2382127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382128 */     // GIR_Coverage, 64451,
     /* 2382128 */     GIR_Done,
     /* 2382129 */   // Label 33645: @2382129
     /* 2382129 */   GIM_Reject,
     /* 2382130 */ // Label 33641: @2382130
     /* 2382130 */ GIM_Reject,
     /* 2382131 */ // Label 33617: @2382131
     /* 2382131 */ GIM_Try, /*On fail goto*//*Label 33646*/ GIMT_Encode4(2382178),
     /* 2382136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2382139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382147 */   GIM_Try, /*On fail goto*//*Label 33647*/ GIMT_Encode4(2382162), // Rule ID 2526 //
     /* 2382152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2382155 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2382155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2382160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382161 */     // GIR_Coverage, 2526,
     /* 2382161 */     GIR_Done,
     /* 2382162 */   // Label 33647: @2382162
     /* 2382162 */   GIM_Try, /*On fail goto*//*Label 33648*/ GIMT_Encode4(2382177), // Rule ID 64450 //
     /* 2382167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2382170 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2382170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2382175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382176 */     // GIR_Coverage, 64450,
     /* 2382176 */     GIR_Done,
     /* 2382177 */   // Label 33648: @2382177
     /* 2382177 */   GIM_Reject,
     /* 2382178 */ // Label 33646: @2382178
     /* 2382178 */ GIM_Reject,
     /* 2382179 */ // Label 33618: @2382179
     /* 2382179 */ GIM_Try, /*On fail goto*//*Label 33649*/ GIMT_Encode4(2382282),
     /* 2382184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2382187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382195 */   GIM_Try, /*On fail goto*//*Label 33650*/ GIMT_Encode4(2382238), // Rule ID 59196 //
     /* 2382200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382203 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2382206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2382220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382237 */     // GIR_Coverage, 59196,
     /* 2382237 */     GIR_EraseRootFromParent_Done,
     /* 2382238 */   // Label 33650: @2382238
     /* 2382238 */   GIM_Try, /*On fail goto*//*Label 33651*/ GIMT_Encode4(2382281), // Rule ID 59197 //
     /* 2382243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382246 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2382249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2382263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382280 */     // GIR_Coverage, 59197,
     /* 2382280 */     GIR_EraseRootFromParent_Done,
     /* 2382281 */   // Label 33651: @2382281
     /* 2382281 */   GIM_Reject,
     /* 2382282 */ // Label 33649: @2382282
     /* 2382282 */ GIM_Reject,
     /* 2382283 */ // Label 33619: @2382283
     /* 2382283 */ GIM_Try, /*On fail goto*//*Label 33652*/ GIMT_Encode4(2382386),
     /* 2382288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2382291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382299 */   GIM_Try, /*On fail goto*//*Label 33653*/ GIMT_Encode4(2382342), // Rule ID 59202 //
     /* 2382304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382307 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2382310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2382324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382341 */     // GIR_Coverage, 59202,
     /* 2382341 */     GIR_EraseRootFromParent_Done,
     /* 2382342 */   // Label 33653: @2382342
     /* 2382342 */   GIM_Try, /*On fail goto*//*Label 33654*/ GIMT_Encode4(2382385), // Rule ID 59203 //
     /* 2382347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382350 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2382353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2382367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382384 */     // GIR_Coverage, 59203,
     /* 2382384 */     GIR_EraseRootFromParent_Done,
     /* 2382385 */   // Label 33654: @2382385
     /* 2382385 */   GIM_Reject,
     /* 2382386 */ // Label 33652: @2382386
     /* 2382386 */ GIM_Reject,
     /* 2382387 */ // Label 33620: @2382387
     /* 2382387 */ GIM_Try, /*On fail goto*//*Label 33655*/ GIMT_Encode4(2382490),
     /* 2382392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2382395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382403 */   GIM_Try, /*On fail goto*//*Label 33656*/ GIMT_Encode4(2382446), // Rule ID 59206 //
     /* 2382408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382411 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2382414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2382428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382445 */     // GIR_Coverage, 59206,
     /* 2382445 */     GIR_EraseRootFromParent_Done,
     /* 2382446 */   // Label 33656: @2382446
     /* 2382446 */   GIM_Try, /*On fail goto*//*Label 33657*/ GIMT_Encode4(2382489), // Rule ID 59207 //
     /* 2382451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382454 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2382457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2382471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382488 */     // GIR_Coverage, 59207,
     /* 2382488 */     GIR_EraseRootFromParent_Done,
     /* 2382489 */   // Label 33657: @2382489
     /* 2382489 */   GIM_Reject,
     /* 2382490 */ // Label 33655: @2382490
     /* 2382490 */ GIM_Reject,
     /* 2382491 */ // Label 33621: @2382491
     /* 2382491 */ GIM_Try, /*On fail goto*//*Label 33658*/ GIMT_Encode4(2382594),
     /* 2382496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2382499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382507 */   GIM_Try, /*On fail goto*//*Label 33659*/ GIMT_Encode4(2382550), // Rule ID 59214 //
     /* 2382512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2382515 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2382518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2382532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382549 */     // GIR_Coverage, 59214,
     /* 2382549 */     GIR_EraseRootFromParent_Done,
     /* 2382550 */   // Label 33659: @2382550
     /* 2382550 */   GIM_Try, /*On fail goto*//*Label 33660*/ GIMT_Encode4(2382593), // Rule ID 59215 //
     /* 2382555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2382558 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2382561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2382575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382592 */     // GIR_Coverage, 59215,
     /* 2382592 */     GIR_EraseRootFromParent_Done,
     /* 2382593 */   // Label 33660: @2382593
     /* 2382593 */   GIM_Reject,
     /* 2382594 */ // Label 33658: @2382594
     /* 2382594 */ GIM_Reject,
     /* 2382595 */ // Label 33622: @2382595
     /* 2382595 */ GIM_Try, /*On fail goto*//*Label 33661*/ GIMT_Encode4(2382698),
     /* 2382600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2382603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382611 */   GIM_Try, /*On fail goto*//*Label 33662*/ GIMT_Encode4(2382654), // Rule ID 59198 //
     /* 2382616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382619 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2382622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2382636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382653 */     // GIR_Coverage, 59198,
     /* 2382653 */     GIR_EraseRootFromParent_Done,
     /* 2382654 */   // Label 33662: @2382654
     /* 2382654 */   GIM_Try, /*On fail goto*//*Label 33663*/ GIMT_Encode4(2382697), // Rule ID 59199 //
     /* 2382659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382662 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2382665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2382679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382696 */     // GIR_Coverage, 59199,
     /* 2382696 */     GIR_EraseRootFromParent_Done,
     /* 2382697 */   // Label 33663: @2382697
     /* 2382697 */   GIM_Reject,
     /* 2382698 */ // Label 33661: @2382698
     /* 2382698 */ GIM_Reject,
     /* 2382699 */ // Label 33623: @2382699
     /* 2382699 */ GIM_Try, /*On fail goto*//*Label 33664*/ GIMT_Encode4(2382802),
     /* 2382704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2382707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382715 */   GIM_Try, /*On fail goto*//*Label 33665*/ GIMT_Encode4(2382758), // Rule ID 59204 //
     /* 2382720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382723 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2382726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2382740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382757 */     // GIR_Coverage, 59204,
     /* 2382757 */     GIR_EraseRootFromParent_Done,
     /* 2382758 */   // Label 33665: @2382758
     /* 2382758 */   GIM_Try, /*On fail goto*//*Label 33666*/ GIMT_Encode4(2382801), // Rule ID 59205 //
     /* 2382763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382766 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2382769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2382783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382800 */     // GIR_Coverage, 59205,
     /* 2382800 */     GIR_EraseRootFromParent_Done,
     /* 2382801 */   // Label 33666: @2382801
     /* 2382801 */   GIM_Reject,
     /* 2382802 */ // Label 33664: @2382802
     /* 2382802 */ GIM_Reject,
     /* 2382803 */ // Label 33624: @2382803
     /* 2382803 */ GIM_Try, /*On fail goto*//*Label 33667*/ GIMT_Encode4(2382906),
     /* 2382808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2382811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382819 */   GIM_Try, /*On fail goto*//*Label 33668*/ GIMT_Encode4(2382862), // Rule ID 59212 //
     /* 2382824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382827 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2382830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2382844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382861 */     // GIR_Coverage, 59212,
     /* 2382861 */     GIR_EraseRootFromParent_Done,
     /* 2382862 */   // Label 33668: @2382862
     /* 2382862 */   GIM_Try, /*On fail goto*//*Label 33669*/ GIMT_Encode4(2382905), // Rule ID 59213 //
     /* 2382867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382870 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2382873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2382887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382904 */     // GIR_Coverage, 59213,
     /* 2382904 */     GIR_EraseRootFromParent_Done,
     /* 2382905 */   // Label 33669: @2382905
     /* 2382905 */   GIM_Reject,
     /* 2382906 */ // Label 33667: @2382906
     /* 2382906 */ GIM_Reject,
     /* 2382907 */ // Label 33625: @2382907
     /* 2382907 */ GIM_Try, /*On fail goto*//*Label 33670*/ GIMT_Encode4(2383010),
     /* 2382912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2382915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382923 */   GIM_Try, /*On fail goto*//*Label 33671*/ GIMT_Encode4(2382966), // Rule ID 59234 //
     /* 2382928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2382931 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2382934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2382948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382965 */     // GIR_Coverage, 59234,
     /* 2382965 */     GIR_EraseRootFromParent_Done,
     /* 2382966 */   // Label 33671: @2382966
     /* 2382966 */   GIM_Try, /*On fail goto*//*Label 33672*/ GIMT_Encode4(2383009), // Rule ID 59235 //
     /* 2382971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2382974 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2382977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2382991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383008 */     // GIR_Coverage, 59235,
     /* 2383008 */     GIR_EraseRootFromParent_Done,
     /* 2383009 */   // Label 33672: @2383009
     /* 2383009 */   GIM_Reject,
     /* 2383010 */ // Label 33670: @2383010
     /* 2383010 */ GIM_Reject,
     /* 2383011 */ // Label 33626: @2383011
     /* 2383011 */ GIM_Try, /*On fail goto*//*Label 33673*/ GIMT_Encode4(2383114),
     /* 2383016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2383019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383027 */   GIM_Try, /*On fail goto*//*Label 33674*/ GIMT_Encode4(2383070), // Rule ID 59200 //
     /* 2383032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383035 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2383038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2383052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383069 */     // GIR_Coverage, 59200,
     /* 2383069 */     GIR_EraseRootFromParent_Done,
     /* 2383070 */   // Label 33674: @2383070
     /* 2383070 */   GIM_Try, /*On fail goto*//*Label 33675*/ GIMT_Encode4(2383113), // Rule ID 59201 //
     /* 2383075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383078 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2383081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2383095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383112 */     // GIR_Coverage, 59201,
     /* 2383112 */     GIR_EraseRootFromParent_Done,
     /* 2383113 */   // Label 33675: @2383113
     /* 2383113 */   GIM_Reject,
     /* 2383114 */ // Label 33673: @2383114
     /* 2383114 */ GIM_Reject,
     /* 2383115 */ // Label 33627: @2383115
     /* 2383115 */ GIM_Try, /*On fail goto*//*Label 33676*/ GIMT_Encode4(2383218),
     /* 2383120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2383123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383131 */   GIM_Try, /*On fail goto*//*Label 33677*/ GIMT_Encode4(2383174), // Rule ID 59210 //
     /* 2383136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383139 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2383142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2383156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383173 */     // GIR_Coverage, 59210,
     /* 2383173 */     GIR_EraseRootFromParent_Done,
     /* 2383174 */   // Label 33677: @2383174
     /* 2383174 */   GIM_Try, /*On fail goto*//*Label 33678*/ GIMT_Encode4(2383217), // Rule ID 59211 //
     /* 2383179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383182 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2383185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2383199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383216 */     // GIR_Coverage, 59211,
     /* 2383216 */     GIR_EraseRootFromParent_Done,
     /* 2383217 */   // Label 33678: @2383217
     /* 2383217 */   GIM_Reject,
     /* 2383218 */ // Label 33676: @2383218
     /* 2383218 */ GIM_Reject,
     /* 2383219 */ // Label 33628: @2383219
     /* 2383219 */ GIM_Try, /*On fail goto*//*Label 33679*/ GIMT_Encode4(2383322),
     /* 2383224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2383227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383235 */   GIM_Try, /*On fail goto*//*Label 33680*/ GIMT_Encode4(2383278), // Rule ID 59228 //
     /* 2383240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383243 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2383246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2383260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383277 */     // GIR_Coverage, 59228,
     /* 2383277 */     GIR_EraseRootFromParent_Done,
     /* 2383278 */   // Label 33680: @2383278
     /* 2383278 */   GIM_Try, /*On fail goto*//*Label 33681*/ GIMT_Encode4(2383321), // Rule ID 59229 //
     /* 2383283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383286 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2383289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2383303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383320 */     // GIR_Coverage, 59229,
     /* 2383320 */     GIR_EraseRootFromParent_Done,
     /* 2383321 */   // Label 33681: @2383321
     /* 2383321 */   GIM_Reject,
     /* 2383322 */ // Label 33679: @2383322
     /* 2383322 */ GIM_Reject,
     /* 2383323 */ // Label 33629: @2383323
     /* 2383323 */ GIM_Try, /*On fail goto*//*Label 33682*/ GIMT_Encode4(2383426),
     /* 2383328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2383331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383339 */   GIM_Try, /*On fail goto*//*Label 33683*/ GIMT_Encode4(2383382), // Rule ID 59236 //
     /* 2383344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2383347 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2383350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2383364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383381 */     // GIR_Coverage, 59236,
     /* 2383381 */     GIR_EraseRootFromParent_Done,
     /* 2383382 */   // Label 33683: @2383382
     /* 2383382 */   GIM_Try, /*On fail goto*//*Label 33684*/ GIMT_Encode4(2383425), // Rule ID 59237 //
     /* 2383387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2383390 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2383393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2383407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383424 */     // GIR_Coverage, 59237,
     /* 2383424 */     GIR_EraseRootFromParent_Done,
     /* 2383425 */   // Label 33684: @2383425
     /* 2383425 */   GIM_Reject,
     /* 2383426 */ // Label 33682: @2383426
     /* 2383426 */ GIM_Reject,
     /* 2383427 */ // Label 33630: @2383427
     /* 2383427 */ GIM_Try, /*On fail goto*//*Label 33685*/ GIMT_Encode4(2383530),
     /* 2383432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2383435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383443 */   GIM_Try, /*On fail goto*//*Label 33686*/ GIMT_Encode4(2383486), // Rule ID 59208 //
     /* 2383448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383451 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2383454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2383468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383485 */     // GIR_Coverage, 59208,
     /* 2383485 */     GIR_EraseRootFromParent_Done,
     /* 2383486 */   // Label 33686: @2383486
     /* 2383486 */   GIM_Try, /*On fail goto*//*Label 33687*/ GIMT_Encode4(2383529), // Rule ID 59209 //
     /* 2383491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383494 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2383497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2383511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383528 */     // GIR_Coverage, 59209,
     /* 2383528 */     GIR_EraseRootFromParent_Done,
     /* 2383529 */   // Label 33687: @2383529
     /* 2383529 */   GIM_Reject,
     /* 2383530 */ // Label 33685: @2383530
     /* 2383530 */ GIM_Reject,
     /* 2383531 */ // Label 33631: @2383531
     /* 2383531 */ GIM_Try, /*On fail goto*//*Label 33688*/ GIMT_Encode4(2383634),
     /* 2383536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2383539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383547 */   GIM_Try, /*On fail goto*//*Label 33689*/ GIMT_Encode4(2383590), // Rule ID 59222 //
     /* 2383552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383555 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2383558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2383572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383589 */     // GIR_Coverage, 59222,
     /* 2383589 */     GIR_EraseRootFromParent_Done,
     /* 2383590 */   // Label 33689: @2383590
     /* 2383590 */   GIM_Try, /*On fail goto*//*Label 33690*/ GIMT_Encode4(2383633), // Rule ID 59223 //
     /* 2383595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383598 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2383601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2383615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383632 */     // GIR_Coverage, 59223,
     /* 2383632 */     GIR_EraseRootFromParent_Done,
     /* 2383633 */   // Label 33690: @2383633
     /* 2383633 */   GIM_Reject,
     /* 2383634 */ // Label 33688: @2383634
     /* 2383634 */ GIM_Reject,
     /* 2383635 */ // Label 33632: @2383635
     /* 2383635 */ GIM_Try, /*On fail goto*//*Label 33691*/ GIMT_Encode4(2383738),
     /* 2383640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2383643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383651 */   GIM_Try, /*On fail goto*//*Label 33692*/ GIMT_Encode4(2383694), // Rule ID 59230 //
     /* 2383656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383659 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2383662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2383676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383693 */     // GIR_Coverage, 59230,
     /* 2383693 */     GIR_EraseRootFromParent_Done,
     /* 2383694 */   // Label 33692: @2383694
     /* 2383694 */   GIM_Try, /*On fail goto*//*Label 33693*/ GIMT_Encode4(2383737), // Rule ID 59231 //
     /* 2383699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383702 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2383705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2383719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383736 */     // GIR_Coverage, 59231,
     /* 2383736 */     GIR_EraseRootFromParent_Done,
     /* 2383737 */   // Label 33693: @2383737
     /* 2383737 */   GIM_Reject,
     /* 2383738 */ // Label 33691: @2383738
     /* 2383738 */ GIM_Reject,
     /* 2383739 */ // Label 33633: @2383739
     /* 2383739 */ GIM_Try, /*On fail goto*//*Label 33694*/ GIMT_Encode4(2383842),
     /* 2383744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2383747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383755 */   GIM_Try, /*On fail goto*//*Label 33695*/ GIMT_Encode4(2383798), // Rule ID 59238 //
     /* 2383760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2383763 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2383766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2383780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383797 */     // GIR_Coverage, 59238,
     /* 2383797 */     GIR_EraseRootFromParent_Done,
     /* 2383798 */   // Label 33695: @2383798
     /* 2383798 */   GIM_Try, /*On fail goto*//*Label 33696*/ GIMT_Encode4(2383841), // Rule ID 59239 //
     /* 2383803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2383806 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2383809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2383823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383840 */     // GIR_Coverage, 59239,
     /* 2383840 */     GIR_EraseRootFromParent_Done,
     /* 2383841 */   // Label 33696: @2383841
     /* 2383841 */   GIM_Reject,
     /* 2383842 */ // Label 33694: @2383842
     /* 2383842 */ GIM_Reject,
     /* 2383843 */ // Label 33634: @2383843
     /* 2383843 */ GIM_Try, /*On fail goto*//*Label 33697*/ GIMT_Encode4(2383946),
     /* 2383848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2383851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383859 */   GIM_Try, /*On fail goto*//*Label 33698*/ GIMT_Encode4(2383902), // Rule ID 59216 //
     /* 2383864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383867 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2383870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2383884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383901 */     // GIR_Coverage, 59216,
     /* 2383901 */     GIR_EraseRootFromParent_Done,
     /* 2383902 */   // Label 33698: @2383902
     /* 2383902 */   GIM_Try, /*On fail goto*//*Label 33699*/ GIMT_Encode4(2383945), // Rule ID 59217 //
     /* 2383907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383910 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2383913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2383927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383944 */     // GIR_Coverage, 59217,
     /* 2383944 */     GIR_EraseRootFromParent_Done,
     /* 2383945 */   // Label 33699: @2383945
     /* 2383945 */   GIM_Reject,
     /* 2383946 */ // Label 33697: @2383946
     /* 2383946 */ GIM_Reject,
     /* 2383947 */ // Label 33635: @2383947
     /* 2383947 */ GIM_Try, /*On fail goto*//*Label 33700*/ GIMT_Encode4(2384050),
     /* 2383952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2383955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383963 */   GIM_Try, /*On fail goto*//*Label 33701*/ GIMT_Encode4(2384006), // Rule ID 59224 //
     /* 2383968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383971 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2383974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2383988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384005 */     // GIR_Coverage, 59224,
     /* 2384005 */     GIR_EraseRootFromParent_Done,
     /* 2384006 */   // Label 33701: @2384006
     /* 2384006 */   GIM_Try, /*On fail goto*//*Label 33702*/ GIMT_Encode4(2384049), // Rule ID 59225 //
     /* 2384011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384014 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2384017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2384031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384048 */     // GIR_Coverage, 59225,
     /* 2384048 */     GIR_EraseRootFromParent_Done,
     /* 2384049 */   // Label 33702: @2384049
     /* 2384049 */   GIM_Reject,
     /* 2384050 */ // Label 33700: @2384050
     /* 2384050 */ GIM_Reject,
     /* 2384051 */ // Label 33636: @2384051
     /* 2384051 */ GIM_Try, /*On fail goto*//*Label 33703*/ GIMT_Encode4(2384154),
     /* 2384056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2384059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384067 */   GIM_Try, /*On fail goto*//*Label 33704*/ GIMT_Encode4(2384110), // Rule ID 59232 //
     /* 2384072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384075 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2384078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2384092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384109 */     // GIR_Coverage, 59232,
     /* 2384109 */     GIR_EraseRootFromParent_Done,
     /* 2384110 */   // Label 33704: @2384110
     /* 2384110 */   GIM_Try, /*On fail goto*//*Label 33705*/ GIMT_Encode4(2384153), // Rule ID 59233 //
     /* 2384115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384118 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2384121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2384135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384152 */     // GIR_Coverage, 59233,
     /* 2384152 */     GIR_EraseRootFromParent_Done,
     /* 2384153 */   // Label 33705: @2384153
     /* 2384153 */   GIM_Reject,
     /* 2384154 */ // Label 33703: @2384154
     /* 2384154 */ GIM_Reject,
     /* 2384155 */ // Label 33637: @2384155
     /* 2384155 */ GIM_Try, /*On fail goto*//*Label 33706*/ GIMT_Encode4(2384258),
     /* 2384160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2384163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384171 */   GIM_Try, /*On fail goto*//*Label 33707*/ GIMT_Encode4(2384214), // Rule ID 59218 //
     /* 2384176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384179 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2384182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2384196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384213 */     // GIR_Coverage, 59218,
     /* 2384213 */     GIR_EraseRootFromParent_Done,
     /* 2384214 */   // Label 33707: @2384214
     /* 2384214 */   GIM_Try, /*On fail goto*//*Label 33708*/ GIMT_Encode4(2384257), // Rule ID 59219 //
     /* 2384219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384222 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2384225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2384239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384256 */     // GIR_Coverage, 59219,
     /* 2384256 */     GIR_EraseRootFromParent_Done,
     /* 2384257 */   // Label 33708: @2384257
     /* 2384257 */   GIM_Reject,
     /* 2384258 */ // Label 33706: @2384258
     /* 2384258 */ GIM_Reject,
     /* 2384259 */ // Label 33638: @2384259
     /* 2384259 */ GIM_Try, /*On fail goto*//*Label 33709*/ GIMT_Encode4(2384362),
     /* 2384264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2384267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384275 */   GIM_Try, /*On fail goto*//*Label 33710*/ GIMT_Encode4(2384318), // Rule ID 59226 //
     /* 2384280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384283 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2384286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2384300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384317 */     // GIR_Coverage, 59226,
     /* 2384317 */     GIR_EraseRootFromParent_Done,
     /* 2384318 */   // Label 33710: @2384318
     /* 2384318 */   GIM_Try, /*On fail goto*//*Label 33711*/ GIMT_Encode4(2384361), // Rule ID 59227 //
     /* 2384323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384326 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2384329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2384343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384360 */     // GIR_Coverage, 59227,
     /* 2384360 */     GIR_EraseRootFromParent_Done,
     /* 2384361 */   // Label 33711: @2384361
     /* 2384361 */   GIM_Reject,
     /* 2384362 */ // Label 33709: @2384362
     /* 2384362 */ GIM_Reject,
     /* 2384363 */ // Label 33639: @2384363
     /* 2384363 */ GIM_Try, /*On fail goto*//*Label 33712*/ GIMT_Encode4(2384466),
     /* 2384368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2384371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384379 */   GIM_Try, /*On fail goto*//*Label 33713*/ GIMT_Encode4(2384422), // Rule ID 59220 //
     /* 2384384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384387 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2384390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2384404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384421 */     // GIR_Coverage, 59220,
     /* 2384421 */     GIR_EraseRootFromParent_Done,
     /* 2384422 */   // Label 33713: @2384422
     /* 2384422 */   GIM_Try, /*On fail goto*//*Label 33714*/ GIMT_Encode4(2384465), // Rule ID 59221 //
     /* 2384427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384430 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2384433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2384447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384464 */     // GIR_Coverage, 59221,
     /* 2384464 */     GIR_EraseRootFromParent_Done,
     /* 2384465 */   // Label 33714: @2384465
     /* 2384465 */   GIM_Reject,
     /* 2384466 */ // Label 33712: @2384466
     /* 2384466 */ GIM_Reject,
     /* 2384467 */ // Label 33640: @2384467
     /* 2384467 */ GIM_Reject,
     /* 2384468 */ // Label 89: @2384468
     /* 2384468 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33739*/ GIMT_Encode4(2387237),
     /* 2384479 */ /*GILLT_s32*//*Label 33715*/ GIMT_Encode4(2384603),
     /* 2384483 */ /*GILLT_s64*//*Label 33716*/ GIMT_Encode4(2384832), GIMT_Encode4(0),
     /* 2384491 */ /*GILLT_nxv1s8*//*Label 33717*/ GIMT_Encode4(2384949),
     /* 2384495 */ /*GILLT_nxv1s16*//*Label 33718*/ GIMT_Encode4(2385053),
     /* 2384499 */ /*GILLT_nxv1s32*//*Label 33719*/ GIMT_Encode4(2385157),
     /* 2384503 */ /*GILLT_nxv1s64*//*Label 33720*/ GIMT_Encode4(2385261), GIMT_Encode4(0),
     /* 2384511 */ /*GILLT_nxv2s8*//*Label 33721*/ GIMT_Encode4(2385365),
     /* 2384515 */ /*GILLT_nxv2s16*//*Label 33722*/ GIMT_Encode4(2385469),
     /* 2384519 */ /*GILLT_nxv2s32*//*Label 33723*/ GIMT_Encode4(2385573),
     /* 2384523 */ /*GILLT_nxv2s64*//*Label 33724*/ GIMT_Encode4(2385677), GIMT_Encode4(0),
     /* 2384531 */ /*GILLT_nxv4s8*//*Label 33725*/ GIMT_Encode4(2385781),
     /* 2384535 */ /*GILLT_nxv4s16*//*Label 33726*/ GIMT_Encode4(2385885),
     /* 2384539 */ /*GILLT_nxv4s32*//*Label 33727*/ GIMT_Encode4(2385989),
     /* 2384543 */ /*GILLT_nxv4s64*//*Label 33728*/ GIMT_Encode4(2386093), GIMT_Encode4(0),
     /* 2384551 */ /*GILLT_nxv8s8*//*Label 33729*/ GIMT_Encode4(2386197),
     /* 2384555 */ /*GILLT_nxv8s16*//*Label 33730*/ GIMT_Encode4(2386301),
     /* 2384559 */ /*GILLT_nxv8s32*//*Label 33731*/ GIMT_Encode4(2386405),
     /* 2384563 */ /*GILLT_nxv8s64*//*Label 33732*/ GIMT_Encode4(2386509), GIMT_Encode4(0),
     /* 2384571 */ /*GILLT_nxv16s8*//*Label 33733*/ GIMT_Encode4(2386613),
     /* 2384575 */ /*GILLT_nxv16s16*//*Label 33734*/ GIMT_Encode4(2386717),
     /* 2384579 */ /*GILLT_nxv16s32*//*Label 33735*/ GIMT_Encode4(2386821), GIMT_Encode4(0),
     /* 2384587 */ /*GILLT_nxv32s8*//*Label 33736*/ GIMT_Encode4(2386925),
     /* 2384591 */ /*GILLT_nxv32s16*//*Label 33737*/ GIMT_Encode4(2387029), GIMT_Encode4(0),
     /* 2384599 */ /*GILLT_nxv64s8*//*Label 33738*/ GIMT_Encode4(2387133),
     /* 2384603 */ // Label 33715: @2384603
     /* 2384603 */ GIM_Try, /*On fail goto*//*Label 33740*/ GIMT_Encode4(2384831),
     /* 2384608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2384611 */   GIM_Try, /*On fail goto*//*Label 33741*/ GIMT_Encode4(2384661), // Rule ID 62576 //
     /* 2384616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2384619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2384627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2384631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2384635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2384639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384644 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2384648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2384650 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (TH_FF0:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2384653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2384659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384660 */     // GIR_Coverage, 62576,
     /* 2384660 */     GIR_EraseRootFromParent_Done,
     /* 2384661 */   // Label 33741: @2384661
     /* 2384661 */   GIM_Try, /*On fail goto*//*Label 33742*/ GIMT_Encode4(2384711), // Rule ID 64651 //
     /* 2384666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2384669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2384673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2384677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2384681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2384685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2384689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384694 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2384698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2384700 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CLO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CLO),
     /* 2384703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2384709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384710 */     // GIR_Coverage, 64651,
     /* 2384710 */     GIR_EraseRootFromParent_Done,
     /* 2384711 */   // Label 33742: @2384711
     /* 2384711 */   GIM_Try, /*On fail goto*//*Label 33743*/ GIMT_Encode4(2384761), // Rule ID 64652 //
     /* 2384716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2384719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2384723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2384727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2384731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2384735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2384739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384744 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2384748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2384750 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CLO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CLO),
     /* 2384753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2384759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384760 */     // GIR_Coverage, 64652,
     /* 2384760 */     GIR_EraseRootFromParent_Done,
     /* 2384761 */   // Label 33743: @2384761
     /* 2384761 */   GIM_Try, /*On fail goto*//*Label 33744*/ GIMT_Encode4(2384784), // Rule ID 2525 //
     /* 2384766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2384769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384777 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2384782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384783 */     // GIR_Coverage, 2525,
     /* 2384783 */     GIR_Done,
     /* 2384784 */   // Label 33744: @2384784
     /* 2384784 */   GIM_Try, /*On fail goto*//*Label 33745*/ GIMT_Encode4(2384807), // Rule ID 62574 //
     /* 2384789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2384792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384800 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2384805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384806 */     // GIR_Coverage, 62574,
     /* 2384806 */     GIR_Done,
     /* 2384807 */   // Label 33745: @2384807
     /* 2384807 */   GIM_Try, /*On fail goto*//*Label 33746*/ GIMT_Encode4(2384830), // Rule ID 64453 //
     /* 2384812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2384815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384823 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FL1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2384828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384829 */     // GIR_Coverage, 64453,
     /* 2384829 */     GIR_Done,
     /* 2384830 */   // Label 33746: @2384830
     /* 2384830 */   GIM_Reject,
     /* 2384831 */ // Label 33740: @2384831
     /* 2384831 */ GIM_Reject,
     /* 2384832 */ // Label 33716: @2384832
     /* 2384832 */ GIM_Try, /*On fail goto*//*Label 33747*/ GIMT_Encode4(2384948),
     /* 2384837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2384840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384844 */   GIM_Try, /*On fail goto*//*Label 33748*/ GIMT_Encode4(2384890), // Rule ID 62575 //
     /* 2384849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2384852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2384856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2384860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2384864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2384868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384873 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2384877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2384879 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }))  =>  (TH_FF0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2384879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2384882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2384888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384889 */     // GIR_Coverage, 62575,
     /* 2384889 */     GIR_EraseRootFromParent_Done,
     /* 2384890 */   // Label 33748: @2384890
     /* 2384890 */   GIM_Try, /*On fail goto*//*Label 33749*/ GIMT_Encode4(2384909), // Rule ID 2524 //
     /* 2384895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2384898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384902 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2384902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2384907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384908 */     // GIR_Coverage, 2524,
     /* 2384908 */     GIR_Done,
     /* 2384909 */   // Label 33749: @2384909
     /* 2384909 */   GIM_Try, /*On fail goto*//*Label 33750*/ GIMT_Encode4(2384928), // Rule ID 62573 //
     /* 2384914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2384917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384921 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2384921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2384926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384927 */     // GIR_Coverage, 62573,
     /* 2384927 */     GIR_Done,
     /* 2384928 */   // Label 33750: @2384928
     /* 2384928 */   GIM_Try, /*On fail goto*//*Label 33751*/ GIMT_Encode4(2384947), // Rule ID 64452 //
     /* 2384933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2384936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384940 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FL1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2384940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2384945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384946 */     // GIR_Coverage, 64452,
     /* 2384946 */     GIR_Done,
     /* 2384947 */   // Label 33751: @2384947
     /* 2384947 */   GIM_Reject,
     /* 2384948 */ // Label 33747: @2384948
     /* 2384948 */ GIM_Reject,
     /* 2384949 */ // Label 33717: @2384949
     /* 2384949 */ GIM_Try, /*On fail goto*//*Label 33752*/ GIMT_Encode4(2385052),
     /* 2384954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2384957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384965 */   GIM_Try, /*On fail goto*//*Label 33753*/ GIMT_Encode4(2385008), // Rule ID 59152 //
     /* 2384970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384973 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2384976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2384990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385007 */     // GIR_Coverage, 59152,
     /* 2385007 */     GIR_EraseRootFromParent_Done,
     /* 2385008 */   // Label 33753: @2385008
     /* 2385008 */   GIM_Try, /*On fail goto*//*Label 33754*/ GIMT_Encode4(2385051), // Rule ID 59153 //
     /* 2385013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385016 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2385019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2385033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385050 */     // GIR_Coverage, 59153,
     /* 2385050 */     GIR_EraseRootFromParent_Done,
     /* 2385051 */   // Label 33754: @2385051
     /* 2385051 */   GIM_Reject,
     /* 2385052 */ // Label 33752: @2385052
     /* 2385052 */ GIM_Reject,
     /* 2385053 */ // Label 33718: @2385053
     /* 2385053 */ GIM_Try, /*On fail goto*//*Label 33755*/ GIMT_Encode4(2385156),
     /* 2385058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2385061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385069 */   GIM_Try, /*On fail goto*//*Label 33756*/ GIMT_Encode4(2385112), // Rule ID 59158 //
     /* 2385074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385077 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2385080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2385094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385111 */     // GIR_Coverage, 59158,
     /* 2385111 */     GIR_EraseRootFromParent_Done,
     /* 2385112 */   // Label 33756: @2385112
     /* 2385112 */   GIM_Try, /*On fail goto*//*Label 33757*/ GIMT_Encode4(2385155), // Rule ID 59159 //
     /* 2385117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385120 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2385123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2385137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385154 */     // GIR_Coverage, 59159,
     /* 2385154 */     GIR_EraseRootFromParent_Done,
     /* 2385155 */   // Label 33757: @2385155
     /* 2385155 */   GIM_Reject,
     /* 2385156 */ // Label 33755: @2385156
     /* 2385156 */ GIM_Reject,
     /* 2385157 */ // Label 33719: @2385157
     /* 2385157 */ GIM_Try, /*On fail goto*//*Label 33758*/ GIMT_Encode4(2385260),
     /* 2385162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2385165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385173 */   GIM_Try, /*On fail goto*//*Label 33759*/ GIMT_Encode4(2385216), // Rule ID 59162 //
     /* 2385178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385181 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2385184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2385198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385215 */     // GIR_Coverage, 59162,
     /* 2385215 */     GIR_EraseRootFromParent_Done,
     /* 2385216 */   // Label 33759: @2385216
     /* 2385216 */   GIM_Try, /*On fail goto*//*Label 33760*/ GIMT_Encode4(2385259), // Rule ID 59163 //
     /* 2385221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385224 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2385227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2385241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385258 */     // GIR_Coverage, 59163,
     /* 2385258 */     GIR_EraseRootFromParent_Done,
     /* 2385259 */   // Label 33760: @2385259
     /* 2385259 */   GIM_Reject,
     /* 2385260 */ // Label 33758: @2385260
     /* 2385260 */ GIM_Reject,
     /* 2385261 */ // Label 33720: @2385261
     /* 2385261 */ GIM_Try, /*On fail goto*//*Label 33761*/ GIMT_Encode4(2385364),
     /* 2385266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2385269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385277 */   GIM_Try, /*On fail goto*//*Label 33762*/ GIMT_Encode4(2385320), // Rule ID 59170 //
     /* 2385282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2385285 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2385288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2385302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385319 */     // GIR_Coverage, 59170,
     /* 2385319 */     GIR_EraseRootFromParent_Done,
     /* 2385320 */   // Label 33762: @2385320
     /* 2385320 */   GIM_Try, /*On fail goto*//*Label 33763*/ GIMT_Encode4(2385363), // Rule ID 59171 //
     /* 2385325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2385328 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2385331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2385345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385362 */     // GIR_Coverage, 59171,
     /* 2385362 */     GIR_EraseRootFromParent_Done,
     /* 2385363 */   // Label 33763: @2385363
     /* 2385363 */   GIM_Reject,
     /* 2385364 */ // Label 33761: @2385364
     /* 2385364 */ GIM_Reject,
     /* 2385365 */ // Label 33721: @2385365
     /* 2385365 */ GIM_Try, /*On fail goto*//*Label 33764*/ GIMT_Encode4(2385468),
     /* 2385370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2385373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385381 */   GIM_Try, /*On fail goto*//*Label 33765*/ GIMT_Encode4(2385424), // Rule ID 59154 //
     /* 2385386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385389 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2385392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2385406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385423 */     // GIR_Coverage, 59154,
     /* 2385423 */     GIR_EraseRootFromParent_Done,
     /* 2385424 */   // Label 33765: @2385424
     /* 2385424 */   GIM_Try, /*On fail goto*//*Label 33766*/ GIMT_Encode4(2385467), // Rule ID 59155 //
     /* 2385429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385432 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2385435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2385449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385466 */     // GIR_Coverage, 59155,
     /* 2385466 */     GIR_EraseRootFromParent_Done,
     /* 2385467 */   // Label 33766: @2385467
     /* 2385467 */   GIM_Reject,
     /* 2385468 */ // Label 33764: @2385468
     /* 2385468 */ GIM_Reject,
     /* 2385469 */ // Label 33722: @2385469
     /* 2385469 */ GIM_Try, /*On fail goto*//*Label 33767*/ GIMT_Encode4(2385572),
     /* 2385474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2385477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385485 */   GIM_Try, /*On fail goto*//*Label 33768*/ GIMT_Encode4(2385528), // Rule ID 59160 //
     /* 2385490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385493 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2385496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2385510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385527 */     // GIR_Coverage, 59160,
     /* 2385527 */     GIR_EraseRootFromParent_Done,
     /* 2385528 */   // Label 33768: @2385528
     /* 2385528 */   GIM_Try, /*On fail goto*//*Label 33769*/ GIMT_Encode4(2385571), // Rule ID 59161 //
     /* 2385533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385536 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2385539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2385553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385570 */     // GIR_Coverage, 59161,
     /* 2385570 */     GIR_EraseRootFromParent_Done,
     /* 2385571 */   // Label 33769: @2385571
     /* 2385571 */   GIM_Reject,
     /* 2385572 */ // Label 33767: @2385572
     /* 2385572 */ GIM_Reject,
     /* 2385573 */ // Label 33723: @2385573
     /* 2385573 */ GIM_Try, /*On fail goto*//*Label 33770*/ GIMT_Encode4(2385676),
     /* 2385578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2385581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385589 */   GIM_Try, /*On fail goto*//*Label 33771*/ GIMT_Encode4(2385632), // Rule ID 59168 //
     /* 2385594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385597 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2385600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2385614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385631 */     // GIR_Coverage, 59168,
     /* 2385631 */     GIR_EraseRootFromParent_Done,
     /* 2385632 */   // Label 33771: @2385632
     /* 2385632 */   GIM_Try, /*On fail goto*//*Label 33772*/ GIMT_Encode4(2385675), // Rule ID 59169 //
     /* 2385637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385640 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2385643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2385657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385674 */     // GIR_Coverage, 59169,
     /* 2385674 */     GIR_EraseRootFromParent_Done,
     /* 2385675 */   // Label 33772: @2385675
     /* 2385675 */   GIM_Reject,
     /* 2385676 */ // Label 33770: @2385676
     /* 2385676 */ GIM_Reject,
     /* 2385677 */ // Label 33724: @2385677
     /* 2385677 */ GIM_Try, /*On fail goto*//*Label 33773*/ GIMT_Encode4(2385780),
     /* 2385682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2385685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385693 */   GIM_Try, /*On fail goto*//*Label 33774*/ GIMT_Encode4(2385736), // Rule ID 59190 //
     /* 2385698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2385701 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2385704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2385718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385735 */     // GIR_Coverage, 59190,
     /* 2385735 */     GIR_EraseRootFromParent_Done,
     /* 2385736 */   // Label 33774: @2385736
     /* 2385736 */   GIM_Try, /*On fail goto*//*Label 33775*/ GIMT_Encode4(2385779), // Rule ID 59191 //
     /* 2385741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2385744 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2385747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2385761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385778 */     // GIR_Coverage, 59191,
     /* 2385778 */     GIR_EraseRootFromParent_Done,
     /* 2385779 */   // Label 33775: @2385779
     /* 2385779 */   GIM_Reject,
     /* 2385780 */ // Label 33773: @2385780
     /* 2385780 */ GIM_Reject,
     /* 2385781 */ // Label 33725: @2385781
     /* 2385781 */ GIM_Try, /*On fail goto*//*Label 33776*/ GIMT_Encode4(2385884),
     /* 2385786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2385789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385797 */   GIM_Try, /*On fail goto*//*Label 33777*/ GIMT_Encode4(2385840), // Rule ID 59156 //
     /* 2385802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385805 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2385808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2385822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385839 */     // GIR_Coverage, 59156,
     /* 2385839 */     GIR_EraseRootFromParent_Done,
     /* 2385840 */   // Label 33777: @2385840
     /* 2385840 */   GIM_Try, /*On fail goto*//*Label 33778*/ GIMT_Encode4(2385883), // Rule ID 59157 //
     /* 2385845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385848 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2385851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2385865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385882 */     // GIR_Coverage, 59157,
     /* 2385882 */     GIR_EraseRootFromParent_Done,
     /* 2385883 */   // Label 33778: @2385883
     /* 2385883 */   GIM_Reject,
     /* 2385884 */ // Label 33776: @2385884
     /* 2385884 */ GIM_Reject,
     /* 2385885 */ // Label 33726: @2385885
     /* 2385885 */ GIM_Try, /*On fail goto*//*Label 33779*/ GIMT_Encode4(2385988),
     /* 2385890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2385893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385901 */   GIM_Try, /*On fail goto*//*Label 33780*/ GIMT_Encode4(2385944), // Rule ID 59166 //
     /* 2385906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385909 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2385912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2385926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385943 */     // GIR_Coverage, 59166,
     /* 2385943 */     GIR_EraseRootFromParent_Done,
     /* 2385944 */   // Label 33780: @2385944
     /* 2385944 */   GIM_Try, /*On fail goto*//*Label 33781*/ GIMT_Encode4(2385987), // Rule ID 59167 //
     /* 2385949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385952 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2385955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2385969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385986 */     // GIR_Coverage, 59167,
     /* 2385986 */     GIR_EraseRootFromParent_Done,
     /* 2385987 */   // Label 33781: @2385987
     /* 2385987 */   GIM_Reject,
     /* 2385988 */ // Label 33779: @2385988
     /* 2385988 */ GIM_Reject,
     /* 2385989 */ // Label 33727: @2385989
     /* 2385989 */ GIM_Try, /*On fail goto*//*Label 33782*/ GIMT_Encode4(2386092),
     /* 2385994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2385997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386005 */   GIM_Try, /*On fail goto*//*Label 33783*/ GIMT_Encode4(2386048), // Rule ID 59184 //
     /* 2386010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386013 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2386016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2386030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386047 */     // GIR_Coverage, 59184,
     /* 2386047 */     GIR_EraseRootFromParent_Done,
     /* 2386048 */   // Label 33783: @2386048
     /* 2386048 */   GIM_Try, /*On fail goto*//*Label 33784*/ GIMT_Encode4(2386091), // Rule ID 59185 //
     /* 2386053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386056 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2386059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2386073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386090 */     // GIR_Coverage, 59185,
     /* 2386090 */     GIR_EraseRootFromParent_Done,
     /* 2386091 */   // Label 33784: @2386091
     /* 2386091 */   GIM_Reject,
     /* 2386092 */ // Label 33782: @2386092
     /* 2386092 */ GIM_Reject,
     /* 2386093 */ // Label 33728: @2386093
     /* 2386093 */ GIM_Try, /*On fail goto*//*Label 33785*/ GIMT_Encode4(2386196),
     /* 2386098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2386101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386109 */   GIM_Try, /*On fail goto*//*Label 33786*/ GIMT_Encode4(2386152), // Rule ID 59192 //
     /* 2386114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2386117 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2386120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386151 */     // GIR_Coverage, 59192,
     /* 2386151 */     GIR_EraseRootFromParent_Done,
     /* 2386152 */   // Label 33786: @2386152
     /* 2386152 */   GIM_Try, /*On fail goto*//*Label 33787*/ GIMT_Encode4(2386195), // Rule ID 59193 //
     /* 2386157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2386160 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2386163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386194 */     // GIR_Coverage, 59193,
     /* 2386194 */     GIR_EraseRootFromParent_Done,
     /* 2386195 */   // Label 33787: @2386195
     /* 2386195 */   GIM_Reject,
     /* 2386196 */ // Label 33785: @2386196
     /* 2386196 */ GIM_Reject,
     /* 2386197 */ // Label 33729: @2386197
     /* 2386197 */ GIM_Try, /*On fail goto*//*Label 33788*/ GIMT_Encode4(2386300),
     /* 2386202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2386205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386213 */   GIM_Try, /*On fail goto*//*Label 33789*/ GIMT_Encode4(2386256), // Rule ID 59164 //
     /* 2386218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386221 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2386224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2386238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386255 */     // GIR_Coverage, 59164,
     /* 2386255 */     GIR_EraseRootFromParent_Done,
     /* 2386256 */   // Label 33789: @2386256
     /* 2386256 */   GIM_Try, /*On fail goto*//*Label 33790*/ GIMT_Encode4(2386299), // Rule ID 59165 //
     /* 2386261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386264 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2386267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2386281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386298 */     // GIR_Coverage, 59165,
     /* 2386298 */     GIR_EraseRootFromParent_Done,
     /* 2386299 */   // Label 33790: @2386299
     /* 2386299 */   GIM_Reject,
     /* 2386300 */ // Label 33788: @2386300
     /* 2386300 */ GIM_Reject,
     /* 2386301 */ // Label 33730: @2386301
     /* 2386301 */ GIM_Try, /*On fail goto*//*Label 33791*/ GIMT_Encode4(2386404),
     /* 2386306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2386309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386317 */   GIM_Try, /*On fail goto*//*Label 33792*/ GIMT_Encode4(2386360), // Rule ID 59178 //
     /* 2386322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386325 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2386328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2386342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386359 */     // GIR_Coverage, 59178,
     /* 2386359 */     GIR_EraseRootFromParent_Done,
     /* 2386360 */   // Label 33792: @2386360
     /* 2386360 */   GIM_Try, /*On fail goto*//*Label 33793*/ GIMT_Encode4(2386403), // Rule ID 59179 //
     /* 2386365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386368 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2386371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2386385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386402 */     // GIR_Coverage, 59179,
     /* 2386402 */     GIR_EraseRootFromParent_Done,
     /* 2386403 */   // Label 33793: @2386403
     /* 2386403 */   GIM_Reject,
     /* 2386404 */ // Label 33791: @2386404
     /* 2386404 */ GIM_Reject,
     /* 2386405 */ // Label 33731: @2386405
     /* 2386405 */ GIM_Try, /*On fail goto*//*Label 33794*/ GIMT_Encode4(2386508),
     /* 2386410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2386413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386421 */   GIM_Try, /*On fail goto*//*Label 33795*/ GIMT_Encode4(2386464), // Rule ID 59186 //
     /* 2386426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386429 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2386432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386463 */     // GIR_Coverage, 59186,
     /* 2386463 */     GIR_EraseRootFromParent_Done,
     /* 2386464 */   // Label 33795: @2386464
     /* 2386464 */   GIM_Try, /*On fail goto*//*Label 33796*/ GIMT_Encode4(2386507), // Rule ID 59187 //
     /* 2386469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386472 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2386475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386506 */     // GIR_Coverage, 59187,
     /* 2386506 */     GIR_EraseRootFromParent_Done,
     /* 2386507 */   // Label 33796: @2386507
     /* 2386507 */   GIM_Reject,
     /* 2386508 */ // Label 33794: @2386508
     /* 2386508 */ GIM_Reject,
     /* 2386509 */ // Label 33732: @2386509
     /* 2386509 */ GIM_Try, /*On fail goto*//*Label 33797*/ GIMT_Encode4(2386612),
     /* 2386514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2386517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386525 */   GIM_Try, /*On fail goto*//*Label 33798*/ GIMT_Encode4(2386568), // Rule ID 59194 //
     /* 2386530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2386533 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2386536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2386550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386567 */     // GIR_Coverage, 59194,
     /* 2386567 */     GIR_EraseRootFromParent_Done,
     /* 2386568 */   // Label 33798: @2386568
     /* 2386568 */   GIM_Try, /*On fail goto*//*Label 33799*/ GIMT_Encode4(2386611), // Rule ID 59195 //
     /* 2386573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2386576 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2386579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2386593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386610 */     // GIR_Coverage, 59195,
     /* 2386610 */     GIR_EraseRootFromParent_Done,
     /* 2386611 */   // Label 33799: @2386611
     /* 2386611 */   GIM_Reject,
     /* 2386612 */ // Label 33797: @2386612
     /* 2386612 */ GIM_Reject,
     /* 2386613 */ // Label 33733: @2386613
     /* 2386613 */ GIM_Try, /*On fail goto*//*Label 33800*/ GIMT_Encode4(2386716),
     /* 2386618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2386621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386629 */   GIM_Try, /*On fail goto*//*Label 33801*/ GIMT_Encode4(2386672), // Rule ID 59172 //
     /* 2386634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386637 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2386640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2386654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386671 */     // GIR_Coverage, 59172,
     /* 2386671 */     GIR_EraseRootFromParent_Done,
     /* 2386672 */   // Label 33801: @2386672
     /* 2386672 */   GIM_Try, /*On fail goto*//*Label 33802*/ GIMT_Encode4(2386715), // Rule ID 59173 //
     /* 2386677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386680 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2386683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2386697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386714 */     // GIR_Coverage, 59173,
     /* 2386714 */     GIR_EraseRootFromParent_Done,
     /* 2386715 */   // Label 33802: @2386715
     /* 2386715 */   GIM_Reject,
     /* 2386716 */ // Label 33800: @2386716
     /* 2386716 */ GIM_Reject,
     /* 2386717 */ // Label 33734: @2386717
     /* 2386717 */ GIM_Try, /*On fail goto*//*Label 33803*/ GIMT_Encode4(2386820),
     /* 2386722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2386725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386733 */   GIM_Try, /*On fail goto*//*Label 33804*/ GIMT_Encode4(2386776), // Rule ID 59180 //
     /* 2386738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386741 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2386744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386775 */     // GIR_Coverage, 59180,
     /* 2386775 */     GIR_EraseRootFromParent_Done,
     /* 2386776 */   // Label 33804: @2386776
     /* 2386776 */   GIM_Try, /*On fail goto*//*Label 33805*/ GIMT_Encode4(2386819), // Rule ID 59181 //
     /* 2386781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386784 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2386787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386818 */     // GIR_Coverage, 59181,
     /* 2386818 */     GIR_EraseRootFromParent_Done,
     /* 2386819 */   // Label 33805: @2386819
     /* 2386819 */   GIM_Reject,
     /* 2386820 */ // Label 33803: @2386820
     /* 2386820 */ GIM_Reject,
     /* 2386821 */ // Label 33735: @2386821
     /* 2386821 */ GIM_Try, /*On fail goto*//*Label 33806*/ GIMT_Encode4(2386924),
     /* 2386826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2386829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386837 */   GIM_Try, /*On fail goto*//*Label 33807*/ GIMT_Encode4(2386880), // Rule ID 59188 //
     /* 2386842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386845 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2386848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2386862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386879 */     // GIR_Coverage, 59188,
     /* 2386879 */     GIR_EraseRootFromParent_Done,
     /* 2386880 */   // Label 33807: @2386880
     /* 2386880 */   GIM_Try, /*On fail goto*//*Label 33808*/ GIMT_Encode4(2386923), // Rule ID 59189 //
     /* 2386885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386888 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2386891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2386905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386922 */     // GIR_Coverage, 59189,
     /* 2386922 */     GIR_EraseRootFromParent_Done,
     /* 2386923 */   // Label 33808: @2386923
     /* 2386923 */   GIM_Reject,
     /* 2386924 */ // Label 33806: @2386924
     /* 2386924 */ GIM_Reject,
     /* 2386925 */ // Label 33736: @2386925
     /* 2386925 */ GIM_Try, /*On fail goto*//*Label 33809*/ GIMT_Encode4(2387028),
     /* 2386930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2386933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386941 */   GIM_Try, /*On fail goto*//*Label 33810*/ GIMT_Encode4(2386984), // Rule ID 59174 //
     /* 2386946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386949 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2386952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386983 */     // GIR_Coverage, 59174,
     /* 2386983 */     GIR_EraseRootFromParent_Done,
     /* 2386984 */   // Label 33810: @2386984
     /* 2386984 */   GIM_Try, /*On fail goto*//*Label 33811*/ GIMT_Encode4(2387027), // Rule ID 59175 //
     /* 2386989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386992 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2386995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2387009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387026 */     // GIR_Coverage, 59175,
     /* 2387026 */     GIR_EraseRootFromParent_Done,
     /* 2387027 */   // Label 33811: @2387027
     /* 2387027 */   GIM_Reject,
     /* 2387028 */ // Label 33809: @2387028
     /* 2387028 */ GIM_Reject,
     /* 2387029 */ // Label 33737: @2387029
     /* 2387029 */ GIM_Try, /*On fail goto*//*Label 33812*/ GIMT_Encode4(2387132),
     /* 2387034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2387037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387045 */   GIM_Try, /*On fail goto*//*Label 33813*/ GIMT_Encode4(2387088), // Rule ID 59182 //
     /* 2387050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387053 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2387056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2387070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387087 */     // GIR_Coverage, 59182,
     /* 2387087 */     GIR_EraseRootFromParent_Done,
     /* 2387088 */   // Label 33813: @2387088
     /* 2387088 */   GIM_Try, /*On fail goto*//*Label 33814*/ GIMT_Encode4(2387131), // Rule ID 59183 //
     /* 2387093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387096 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2387099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2387113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387130 */     // GIR_Coverage, 59183,
     /* 2387130 */     GIR_EraseRootFromParent_Done,
     /* 2387131 */   // Label 33814: @2387131
     /* 2387131 */   GIM_Reject,
     /* 2387132 */ // Label 33812: @2387132
     /* 2387132 */ GIM_Reject,
     /* 2387133 */ // Label 33738: @2387133
     /* 2387133 */ GIM_Try, /*On fail goto*//*Label 33815*/ GIMT_Encode4(2387236),
     /* 2387138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2387141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387149 */   GIM_Try, /*On fail goto*//*Label 33816*/ GIMT_Encode4(2387192), // Rule ID 59176 //
     /* 2387154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387157 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2387160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2387174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387191 */     // GIR_Coverage, 59176,
     /* 2387191 */     GIR_EraseRootFromParent_Done,
     /* 2387192 */   // Label 33816: @2387192
     /* 2387192 */   GIM_Try, /*On fail goto*//*Label 33817*/ GIMT_Encode4(2387235), // Rule ID 59177 //
     /* 2387197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387200 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2387203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2387217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387234 */     // GIR_Coverage, 59177,
     /* 2387234 */     GIR_EraseRootFromParent_Done,
     /* 2387235 */   // Label 33817: @2387235
     /* 2387235 */   GIM_Reject,
     /* 2387236 */ // Label 33815: @2387236
     /* 2387236 */ GIM_Reject,
     /* 2387237 */ // Label 33739: @2387237
     /* 2387237 */ GIM_Reject,
     /* 2387238 */ // Label 90: @2387238
     /* 2387238 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33842*/ GIMT_Encode4(2389788),
     /* 2387249 */ /*GILLT_s32*//*Label 33818*/ GIMT_Encode4(2387373),
     /* 2387253 */ /*GILLT_s64*//*Label 33819*/ GIMT_Encode4(2387421), GIMT_Encode4(0),
     /* 2387261 */ /*GILLT_nxv1s8*//*Label 33820*/ GIMT_Encode4(2387500),
     /* 2387265 */ /*GILLT_nxv1s16*//*Label 33821*/ GIMT_Encode4(2387604),
     /* 2387269 */ /*GILLT_nxv1s32*//*Label 33822*/ GIMT_Encode4(2387708),
     /* 2387273 */ /*GILLT_nxv1s64*//*Label 33823*/ GIMT_Encode4(2387812), GIMT_Encode4(0),
     /* 2387281 */ /*GILLT_nxv2s8*//*Label 33824*/ GIMT_Encode4(2387916),
     /* 2387285 */ /*GILLT_nxv2s16*//*Label 33825*/ GIMT_Encode4(2388020),
     /* 2387289 */ /*GILLT_nxv2s32*//*Label 33826*/ GIMT_Encode4(2388124),
     /* 2387293 */ /*GILLT_nxv2s64*//*Label 33827*/ GIMT_Encode4(2388228), GIMT_Encode4(0),
     /* 2387301 */ /*GILLT_nxv4s8*//*Label 33828*/ GIMT_Encode4(2388332),
     /* 2387305 */ /*GILLT_nxv4s16*//*Label 33829*/ GIMT_Encode4(2388436),
     /* 2387309 */ /*GILLT_nxv4s32*//*Label 33830*/ GIMT_Encode4(2388540),
     /* 2387313 */ /*GILLT_nxv4s64*//*Label 33831*/ GIMT_Encode4(2388644), GIMT_Encode4(0),
     /* 2387321 */ /*GILLT_nxv8s8*//*Label 33832*/ GIMT_Encode4(2388748),
     /* 2387325 */ /*GILLT_nxv8s16*//*Label 33833*/ GIMT_Encode4(2388852),
     /* 2387329 */ /*GILLT_nxv8s32*//*Label 33834*/ GIMT_Encode4(2388956),
     /* 2387333 */ /*GILLT_nxv8s64*//*Label 33835*/ GIMT_Encode4(2389060), GIMT_Encode4(0),
     /* 2387341 */ /*GILLT_nxv16s8*//*Label 33836*/ GIMT_Encode4(2389164),
     /* 2387345 */ /*GILLT_nxv16s16*//*Label 33837*/ GIMT_Encode4(2389268),
     /* 2387349 */ /*GILLT_nxv16s32*//*Label 33838*/ GIMT_Encode4(2389372), GIMT_Encode4(0),
     /* 2387357 */ /*GILLT_nxv32s8*//*Label 33839*/ GIMT_Encode4(2389476),
     /* 2387361 */ /*GILLT_nxv32s16*//*Label 33840*/ GIMT_Encode4(2389580), GIMT_Encode4(0),
     /* 2387369 */ /*GILLT_nxv64s8*//*Label 33841*/ GIMT_Encode4(2389684),
     /* 2387373 */ // Label 33818: @2387373
     /* 2387373 */ GIM_Try, /*On fail goto*//*Label 33843*/ GIMT_Encode4(2387420),
     /* 2387378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2387385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2387389 */   GIM_Try, /*On fail goto*//*Label 33844*/ GIMT_Encode4(2387404), // Rule ID 2529 //
     /* 2387394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2387397 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CPOP:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2387397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2387402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387403 */     // GIR_Coverage, 2529,
     /* 2387403 */     GIR_Done,
     /* 2387404 */   // Label 33844: @2387404
     /* 2387404 */   GIM_Try, /*On fail goto*//*Label 33845*/ GIMT_Encode4(2387419), // Rule ID 64456 //
     /* 2387409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2387412 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_CNT:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2387412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2387417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387418 */     // GIR_Coverage, 64456,
     /* 2387418 */     GIR_Done,
     /* 2387419 */   // Label 33845: @2387419
     /* 2387419 */   GIM_Reject,
     /* 2387420 */ // Label 33843: @2387420
     /* 2387420 */ GIM_Reject,
     /* 2387421 */ // Label 33819: @2387421
     /* 2387421 */ GIM_Try, /*On fail goto*//*Label 33846*/ GIMT_Encode4(2387499),
     /* 2387426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2387429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2387433 */   GIM_Try, /*On fail goto*//*Label 33847*/ GIMT_Encode4(2387460), // Rule ID 2532 //
     /* 2387438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2387441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2387448 */     // (ctpop:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (CPOPW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2387448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CPOPW),
     /* 2387451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2387458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387459 */     // GIR_Coverage, 2532,
     /* 2387459 */     GIR_EraseRootFromParent_Done,
     /* 2387460 */   // Label 33847: @2387460
     /* 2387460 */   GIM_Try, /*On fail goto*//*Label 33848*/ GIMT_Encode4(2387479), // Rule ID 2528 //
     /* 2387465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2387468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2387472 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CPOP:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2387472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2387477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387478 */     // GIR_Coverage, 2528,
     /* 2387478 */     GIR_Done,
     /* 2387479 */   // Label 33848: @2387479
     /* 2387479 */   GIM_Try, /*On fail goto*//*Label 33849*/ GIMT_Encode4(2387498), // Rule ID 64455 //
     /* 2387484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2387487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2387491 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_CNT:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2387491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2387496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387497 */     // GIR_Coverage, 64455,
     /* 2387497 */     GIR_Done,
     /* 2387498 */   // Label 33849: @2387498
     /* 2387498 */   GIM_Reject,
     /* 2387499 */ // Label 33846: @2387499
     /* 2387499 */ GIM_Reject,
     /* 2387500 */ // Label 33820: @2387500
     /* 2387500 */ GIM_Try, /*On fail goto*//*Label 33850*/ GIMT_Encode4(2387603),
     /* 2387505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2387508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387516 */   GIM_Try, /*On fail goto*//*Label 33851*/ GIMT_Encode4(2387559), // Rule ID 59240 //
     /* 2387521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387524 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2387527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2387541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387558 */     // GIR_Coverage, 59240,
     /* 2387558 */     GIR_EraseRootFromParent_Done,
     /* 2387559 */   // Label 33851: @2387559
     /* 2387559 */   GIM_Try, /*On fail goto*//*Label 33852*/ GIMT_Encode4(2387602), // Rule ID 59241 //
     /* 2387564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387567 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2387570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2387584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387601 */     // GIR_Coverage, 59241,
     /* 2387601 */     GIR_EraseRootFromParent_Done,
     /* 2387602 */   // Label 33852: @2387602
     /* 2387602 */   GIM_Reject,
     /* 2387603 */ // Label 33850: @2387603
     /* 2387603 */ GIM_Reject,
     /* 2387604 */ // Label 33821: @2387604
     /* 2387604 */ GIM_Try, /*On fail goto*//*Label 33853*/ GIMT_Encode4(2387707),
     /* 2387609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2387612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387620 */   GIM_Try, /*On fail goto*//*Label 33854*/ GIMT_Encode4(2387663), // Rule ID 59246 //
     /* 2387625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387628 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2387631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2387645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387662 */     // GIR_Coverage, 59246,
     /* 2387662 */     GIR_EraseRootFromParent_Done,
     /* 2387663 */   // Label 33854: @2387663
     /* 2387663 */   GIM_Try, /*On fail goto*//*Label 33855*/ GIMT_Encode4(2387706), // Rule ID 59247 //
     /* 2387668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387671 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2387674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2387688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387705 */     // GIR_Coverage, 59247,
     /* 2387705 */     GIR_EraseRootFromParent_Done,
     /* 2387706 */   // Label 33855: @2387706
     /* 2387706 */   GIM_Reject,
     /* 2387707 */ // Label 33853: @2387707
     /* 2387707 */ GIM_Reject,
     /* 2387708 */ // Label 33822: @2387708
     /* 2387708 */ GIM_Try, /*On fail goto*//*Label 33856*/ GIMT_Encode4(2387811),
     /* 2387713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2387716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387724 */   GIM_Try, /*On fail goto*//*Label 33857*/ GIMT_Encode4(2387767), // Rule ID 59250 //
     /* 2387729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387732 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2387735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2387749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387766 */     // GIR_Coverage, 59250,
     /* 2387766 */     GIR_EraseRootFromParent_Done,
     /* 2387767 */   // Label 33857: @2387767
     /* 2387767 */   GIM_Try, /*On fail goto*//*Label 33858*/ GIMT_Encode4(2387810), // Rule ID 59251 //
     /* 2387772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387775 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2387778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2387792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387809 */     // GIR_Coverage, 59251,
     /* 2387809 */     GIR_EraseRootFromParent_Done,
     /* 2387810 */   // Label 33858: @2387810
     /* 2387810 */   GIM_Reject,
     /* 2387811 */ // Label 33856: @2387811
     /* 2387811 */ GIM_Reject,
     /* 2387812 */ // Label 33823: @2387812
     /* 2387812 */ GIM_Try, /*On fail goto*//*Label 33859*/ GIMT_Encode4(2387915),
     /* 2387817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2387820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387828 */   GIM_Try, /*On fail goto*//*Label 33860*/ GIMT_Encode4(2387871), // Rule ID 59258 //
     /* 2387833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2387836 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2387839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2387853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387870 */     // GIR_Coverage, 59258,
     /* 2387870 */     GIR_EraseRootFromParent_Done,
     /* 2387871 */   // Label 33860: @2387871
     /* 2387871 */   GIM_Try, /*On fail goto*//*Label 33861*/ GIMT_Encode4(2387914), // Rule ID 59259 //
     /* 2387876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2387879 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2387882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2387896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387913 */     // GIR_Coverage, 59259,
     /* 2387913 */     GIR_EraseRootFromParent_Done,
     /* 2387914 */   // Label 33861: @2387914
     /* 2387914 */   GIM_Reject,
     /* 2387915 */ // Label 33859: @2387915
     /* 2387915 */ GIM_Reject,
     /* 2387916 */ // Label 33824: @2387916
     /* 2387916 */ GIM_Try, /*On fail goto*//*Label 33862*/ GIMT_Encode4(2388019),
     /* 2387921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2387924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387932 */   GIM_Try, /*On fail goto*//*Label 33863*/ GIMT_Encode4(2387975), // Rule ID 59242 //
     /* 2387937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387940 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2387943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2387957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387974 */     // GIR_Coverage, 59242,
     /* 2387974 */     GIR_EraseRootFromParent_Done,
     /* 2387975 */   // Label 33863: @2387975
     /* 2387975 */   GIM_Try, /*On fail goto*//*Label 33864*/ GIMT_Encode4(2388018), // Rule ID 59243 //
     /* 2387980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387983 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2387986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2388000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388017 */     // GIR_Coverage, 59243,
     /* 2388017 */     GIR_EraseRootFromParent_Done,
     /* 2388018 */   // Label 33864: @2388018
     /* 2388018 */   GIM_Reject,
     /* 2388019 */ // Label 33862: @2388019
     /* 2388019 */ GIM_Reject,
     /* 2388020 */ // Label 33825: @2388020
     /* 2388020 */ GIM_Try, /*On fail goto*//*Label 33865*/ GIMT_Encode4(2388123),
     /* 2388025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2388028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388036 */   GIM_Try, /*On fail goto*//*Label 33866*/ GIMT_Encode4(2388079), // Rule ID 59248 //
     /* 2388041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388044 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2388047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2388061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388078 */     // GIR_Coverage, 59248,
     /* 2388078 */     GIR_EraseRootFromParent_Done,
     /* 2388079 */   // Label 33866: @2388079
     /* 2388079 */   GIM_Try, /*On fail goto*//*Label 33867*/ GIMT_Encode4(2388122), // Rule ID 59249 //
     /* 2388084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388087 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2388090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2388104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388121 */     // GIR_Coverage, 59249,
     /* 2388121 */     GIR_EraseRootFromParent_Done,
     /* 2388122 */   // Label 33867: @2388122
     /* 2388122 */   GIM_Reject,
     /* 2388123 */ // Label 33865: @2388123
     /* 2388123 */ GIM_Reject,
     /* 2388124 */ // Label 33826: @2388124
     /* 2388124 */ GIM_Try, /*On fail goto*//*Label 33868*/ GIMT_Encode4(2388227),
     /* 2388129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2388132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388140 */   GIM_Try, /*On fail goto*//*Label 33869*/ GIMT_Encode4(2388183), // Rule ID 59256 //
     /* 2388145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388148 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2388151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2388165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388182 */     // GIR_Coverage, 59256,
     /* 2388182 */     GIR_EraseRootFromParent_Done,
     /* 2388183 */   // Label 33869: @2388183
     /* 2388183 */   GIM_Try, /*On fail goto*//*Label 33870*/ GIMT_Encode4(2388226), // Rule ID 59257 //
     /* 2388188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388191 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2388194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2388208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388225 */     // GIR_Coverage, 59257,
     /* 2388225 */     GIR_EraseRootFromParent_Done,
     /* 2388226 */   // Label 33870: @2388226
     /* 2388226 */   GIM_Reject,
     /* 2388227 */ // Label 33868: @2388227
     /* 2388227 */ GIM_Reject,
     /* 2388228 */ // Label 33827: @2388228
     /* 2388228 */ GIM_Try, /*On fail goto*//*Label 33871*/ GIMT_Encode4(2388331),
     /* 2388233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2388236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388244 */   GIM_Try, /*On fail goto*//*Label 33872*/ GIMT_Encode4(2388287), // Rule ID 59278 //
     /* 2388249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2388252 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2388255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2388269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388286 */     // GIR_Coverage, 59278,
     /* 2388286 */     GIR_EraseRootFromParent_Done,
     /* 2388287 */   // Label 33872: @2388287
     /* 2388287 */   GIM_Try, /*On fail goto*//*Label 33873*/ GIMT_Encode4(2388330), // Rule ID 59279 //
     /* 2388292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2388295 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2388298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2388312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388329 */     // GIR_Coverage, 59279,
     /* 2388329 */     GIR_EraseRootFromParent_Done,
     /* 2388330 */   // Label 33873: @2388330
     /* 2388330 */   GIM_Reject,
     /* 2388331 */ // Label 33871: @2388331
     /* 2388331 */ GIM_Reject,
     /* 2388332 */ // Label 33828: @2388332
     /* 2388332 */ GIM_Try, /*On fail goto*//*Label 33874*/ GIMT_Encode4(2388435),
     /* 2388337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2388340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388348 */   GIM_Try, /*On fail goto*//*Label 33875*/ GIMT_Encode4(2388391), // Rule ID 59244 //
     /* 2388353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388356 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2388359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2388373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388390 */     // GIR_Coverage, 59244,
     /* 2388390 */     GIR_EraseRootFromParent_Done,
     /* 2388391 */   // Label 33875: @2388391
     /* 2388391 */   GIM_Try, /*On fail goto*//*Label 33876*/ GIMT_Encode4(2388434), // Rule ID 59245 //
     /* 2388396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388399 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2388402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2388416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388433 */     // GIR_Coverage, 59245,
     /* 2388433 */     GIR_EraseRootFromParent_Done,
     /* 2388434 */   // Label 33876: @2388434
     /* 2388434 */   GIM_Reject,
     /* 2388435 */ // Label 33874: @2388435
     /* 2388435 */ GIM_Reject,
     /* 2388436 */ // Label 33829: @2388436
     /* 2388436 */ GIM_Try, /*On fail goto*//*Label 33877*/ GIMT_Encode4(2388539),
     /* 2388441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2388444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388452 */   GIM_Try, /*On fail goto*//*Label 33878*/ GIMT_Encode4(2388495), // Rule ID 59254 //
     /* 2388457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388460 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2388463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2388477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388494 */     // GIR_Coverage, 59254,
     /* 2388494 */     GIR_EraseRootFromParent_Done,
     /* 2388495 */   // Label 33878: @2388495
     /* 2388495 */   GIM_Try, /*On fail goto*//*Label 33879*/ GIMT_Encode4(2388538), // Rule ID 59255 //
     /* 2388500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388503 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2388506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2388520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388537 */     // GIR_Coverage, 59255,
     /* 2388537 */     GIR_EraseRootFromParent_Done,
     /* 2388538 */   // Label 33879: @2388538
     /* 2388538 */   GIM_Reject,
     /* 2388539 */ // Label 33877: @2388539
     /* 2388539 */ GIM_Reject,
     /* 2388540 */ // Label 33830: @2388540
     /* 2388540 */ GIM_Try, /*On fail goto*//*Label 33880*/ GIMT_Encode4(2388643),
     /* 2388545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2388548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388556 */   GIM_Try, /*On fail goto*//*Label 33881*/ GIMT_Encode4(2388599), // Rule ID 59272 //
     /* 2388561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388564 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2388567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2388581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388598 */     // GIR_Coverage, 59272,
     /* 2388598 */     GIR_EraseRootFromParent_Done,
     /* 2388599 */   // Label 33881: @2388599
     /* 2388599 */   GIM_Try, /*On fail goto*//*Label 33882*/ GIMT_Encode4(2388642), // Rule ID 59273 //
     /* 2388604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388607 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2388610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2388624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388641 */     // GIR_Coverage, 59273,
     /* 2388641 */     GIR_EraseRootFromParent_Done,
     /* 2388642 */   // Label 33882: @2388642
     /* 2388642 */   GIM_Reject,
     /* 2388643 */ // Label 33880: @2388643
     /* 2388643 */ GIM_Reject,
     /* 2388644 */ // Label 33831: @2388644
     /* 2388644 */ GIM_Try, /*On fail goto*//*Label 33883*/ GIMT_Encode4(2388747),
     /* 2388649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2388652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388660 */   GIM_Try, /*On fail goto*//*Label 33884*/ GIMT_Encode4(2388703), // Rule ID 59280 //
     /* 2388665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2388668 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2388671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2388685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388702 */     // GIR_Coverage, 59280,
     /* 2388702 */     GIR_EraseRootFromParent_Done,
     /* 2388703 */   // Label 33884: @2388703
     /* 2388703 */   GIM_Try, /*On fail goto*//*Label 33885*/ GIMT_Encode4(2388746), // Rule ID 59281 //
     /* 2388708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2388711 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2388714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2388728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388745 */     // GIR_Coverage, 59281,
     /* 2388745 */     GIR_EraseRootFromParent_Done,
     /* 2388746 */   // Label 33885: @2388746
     /* 2388746 */   GIM_Reject,
     /* 2388747 */ // Label 33883: @2388747
     /* 2388747 */ GIM_Reject,
     /* 2388748 */ // Label 33832: @2388748
     /* 2388748 */ GIM_Try, /*On fail goto*//*Label 33886*/ GIMT_Encode4(2388851),
     /* 2388753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2388756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388764 */   GIM_Try, /*On fail goto*//*Label 33887*/ GIMT_Encode4(2388807), // Rule ID 59252 //
     /* 2388769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388772 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2388775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2388789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388806 */     // GIR_Coverage, 59252,
     /* 2388806 */     GIR_EraseRootFromParent_Done,
     /* 2388807 */   // Label 33887: @2388807
     /* 2388807 */   GIM_Try, /*On fail goto*//*Label 33888*/ GIMT_Encode4(2388850), // Rule ID 59253 //
     /* 2388812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388815 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2388818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2388832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388849 */     // GIR_Coverage, 59253,
     /* 2388849 */     GIR_EraseRootFromParent_Done,
     /* 2388850 */   // Label 33888: @2388850
     /* 2388850 */   GIM_Reject,
     /* 2388851 */ // Label 33886: @2388851
     /* 2388851 */ GIM_Reject,
     /* 2388852 */ // Label 33833: @2388852
     /* 2388852 */ GIM_Try, /*On fail goto*//*Label 33889*/ GIMT_Encode4(2388955),
     /* 2388857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2388860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388868 */   GIM_Try, /*On fail goto*//*Label 33890*/ GIMT_Encode4(2388911), // Rule ID 59266 //
     /* 2388873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388876 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2388879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2388893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388910 */     // GIR_Coverage, 59266,
     /* 2388910 */     GIR_EraseRootFromParent_Done,
     /* 2388911 */   // Label 33890: @2388911
     /* 2388911 */   GIM_Try, /*On fail goto*//*Label 33891*/ GIMT_Encode4(2388954), // Rule ID 59267 //
     /* 2388916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388919 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2388922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2388936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388953 */     // GIR_Coverage, 59267,
     /* 2388953 */     GIR_EraseRootFromParent_Done,
     /* 2388954 */   // Label 33891: @2388954
     /* 2388954 */   GIM_Reject,
     /* 2388955 */ // Label 33889: @2388955
     /* 2388955 */ GIM_Reject,
     /* 2388956 */ // Label 33834: @2388956
     /* 2388956 */ GIM_Try, /*On fail goto*//*Label 33892*/ GIMT_Encode4(2389059),
     /* 2388961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2388964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388972 */   GIM_Try, /*On fail goto*//*Label 33893*/ GIMT_Encode4(2389015), // Rule ID 59274 //
     /* 2388977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388980 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2388983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2388997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389014 */     // GIR_Coverage, 59274,
     /* 2389014 */     GIR_EraseRootFromParent_Done,
     /* 2389015 */   // Label 33893: @2389015
     /* 2389015 */   GIM_Try, /*On fail goto*//*Label 33894*/ GIMT_Encode4(2389058), // Rule ID 59275 //
     /* 2389020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389023 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2389026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2389040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389057 */     // GIR_Coverage, 59275,
     /* 2389057 */     GIR_EraseRootFromParent_Done,
     /* 2389058 */   // Label 33894: @2389058
     /* 2389058 */   GIM_Reject,
     /* 2389059 */ // Label 33892: @2389059
     /* 2389059 */ GIM_Reject,
     /* 2389060 */ // Label 33835: @2389060
     /* 2389060 */ GIM_Try, /*On fail goto*//*Label 33895*/ GIMT_Encode4(2389163),
     /* 2389065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2389068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389076 */   GIM_Try, /*On fail goto*//*Label 33896*/ GIMT_Encode4(2389119), // Rule ID 59282 //
     /* 2389081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2389084 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2389087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389118 */     // GIR_Coverage, 59282,
     /* 2389118 */     GIR_EraseRootFromParent_Done,
     /* 2389119 */   // Label 33896: @2389119
     /* 2389119 */   GIM_Try, /*On fail goto*//*Label 33897*/ GIMT_Encode4(2389162), // Rule ID 59283 //
     /* 2389124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2389127 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2389130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389161 */     // GIR_Coverage, 59283,
     /* 2389161 */     GIR_EraseRootFromParent_Done,
     /* 2389162 */   // Label 33897: @2389162
     /* 2389162 */   GIM_Reject,
     /* 2389163 */ // Label 33895: @2389163
     /* 2389163 */ GIM_Reject,
     /* 2389164 */ // Label 33836: @2389164
     /* 2389164 */ GIM_Try, /*On fail goto*//*Label 33898*/ GIMT_Encode4(2389267),
     /* 2389169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2389172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389180 */   GIM_Try, /*On fail goto*//*Label 33899*/ GIMT_Encode4(2389223), // Rule ID 59260 //
     /* 2389185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389188 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2389191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2389205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389222 */     // GIR_Coverage, 59260,
     /* 2389222 */     GIR_EraseRootFromParent_Done,
     /* 2389223 */   // Label 33899: @2389223
     /* 2389223 */   GIM_Try, /*On fail goto*//*Label 33900*/ GIMT_Encode4(2389266), // Rule ID 59261 //
     /* 2389228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389231 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2389234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2389248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389265 */     // GIR_Coverage, 59261,
     /* 2389265 */     GIR_EraseRootFromParent_Done,
     /* 2389266 */   // Label 33900: @2389266
     /* 2389266 */   GIM_Reject,
     /* 2389267 */ // Label 33898: @2389267
     /* 2389267 */ GIM_Reject,
     /* 2389268 */ // Label 33837: @2389268
     /* 2389268 */ GIM_Try, /*On fail goto*//*Label 33901*/ GIMT_Encode4(2389371),
     /* 2389273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2389276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389284 */   GIM_Try, /*On fail goto*//*Label 33902*/ GIMT_Encode4(2389327), // Rule ID 59268 //
     /* 2389289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389292 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2389295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2389309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389326 */     // GIR_Coverage, 59268,
     /* 2389326 */     GIR_EraseRootFromParent_Done,
     /* 2389327 */   // Label 33902: @2389327
     /* 2389327 */   GIM_Try, /*On fail goto*//*Label 33903*/ GIMT_Encode4(2389370), // Rule ID 59269 //
     /* 2389332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389335 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2389338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2389352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389369 */     // GIR_Coverage, 59269,
     /* 2389369 */     GIR_EraseRootFromParent_Done,
     /* 2389370 */   // Label 33903: @2389370
     /* 2389370 */   GIM_Reject,
     /* 2389371 */ // Label 33901: @2389371
     /* 2389371 */ GIM_Reject,
     /* 2389372 */ // Label 33838: @2389372
     /* 2389372 */ GIM_Try, /*On fail goto*//*Label 33904*/ GIMT_Encode4(2389475),
     /* 2389377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2389380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389388 */   GIM_Try, /*On fail goto*//*Label 33905*/ GIMT_Encode4(2389431), // Rule ID 59276 //
     /* 2389393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389396 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2389399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389430 */     // GIR_Coverage, 59276,
     /* 2389430 */     GIR_EraseRootFromParent_Done,
     /* 2389431 */   // Label 33905: @2389431
     /* 2389431 */   GIM_Try, /*On fail goto*//*Label 33906*/ GIMT_Encode4(2389474), // Rule ID 59277 //
     /* 2389436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389439 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2389442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389473 */     // GIR_Coverage, 59277,
     /* 2389473 */     GIR_EraseRootFromParent_Done,
     /* 2389474 */   // Label 33906: @2389474
     /* 2389474 */   GIM_Reject,
     /* 2389475 */ // Label 33904: @2389475
     /* 2389475 */ GIM_Reject,
     /* 2389476 */ // Label 33839: @2389476
     /* 2389476 */ GIM_Try, /*On fail goto*//*Label 33907*/ GIMT_Encode4(2389579),
     /* 2389481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2389484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389492 */   GIM_Try, /*On fail goto*//*Label 33908*/ GIMT_Encode4(2389535), // Rule ID 59262 //
     /* 2389497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389500 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2389503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2389517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389534 */     // GIR_Coverage, 59262,
     /* 2389534 */     GIR_EraseRootFromParent_Done,
     /* 2389535 */   // Label 33908: @2389535
     /* 2389535 */   GIM_Try, /*On fail goto*//*Label 33909*/ GIMT_Encode4(2389578), // Rule ID 59263 //
     /* 2389540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389543 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2389546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2389560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389577 */     // GIR_Coverage, 59263,
     /* 2389577 */     GIR_EraseRootFromParent_Done,
     /* 2389578 */   // Label 33909: @2389578
     /* 2389578 */   GIM_Reject,
     /* 2389579 */ // Label 33907: @2389579
     /* 2389579 */ GIM_Reject,
     /* 2389580 */ // Label 33840: @2389580
     /* 2389580 */ GIM_Try, /*On fail goto*//*Label 33910*/ GIMT_Encode4(2389683),
     /* 2389585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2389588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389596 */   GIM_Try, /*On fail goto*//*Label 33911*/ GIMT_Encode4(2389639), // Rule ID 59270 //
     /* 2389601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389604 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2389607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389638 */     // GIR_Coverage, 59270,
     /* 2389638 */     GIR_EraseRootFromParent_Done,
     /* 2389639 */   // Label 33911: @2389639
     /* 2389639 */   GIM_Try, /*On fail goto*//*Label 33912*/ GIMT_Encode4(2389682), // Rule ID 59271 //
     /* 2389644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389647 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2389650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389681 */     // GIR_Coverage, 59271,
     /* 2389681 */     GIR_EraseRootFromParent_Done,
     /* 2389682 */   // Label 33912: @2389682
     /* 2389682 */   GIM_Reject,
     /* 2389683 */ // Label 33910: @2389683
     /* 2389683 */ GIM_Reject,
     /* 2389684 */ // Label 33841: @2389684
     /* 2389684 */ GIM_Try, /*On fail goto*//*Label 33913*/ GIMT_Encode4(2389787),
     /* 2389689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2389692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389700 */   GIM_Try, /*On fail goto*//*Label 33914*/ GIMT_Encode4(2389743), // Rule ID 59264 //
     /* 2389705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389708 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2389711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389742 */     // GIR_Coverage, 59264,
     /* 2389742 */     GIR_EraseRootFromParent_Done,
     /* 2389743 */   // Label 33914: @2389743
     /* 2389743 */   GIM_Try, /*On fail goto*//*Label 33915*/ GIMT_Encode4(2389786), // Rule ID 59265 //
     /* 2389748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389751 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2389754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389785 */     // GIR_Coverage, 59265,
     /* 2389785 */     GIR_EraseRootFromParent_Done,
     /* 2389786 */   // Label 33915: @2389786
     /* 2389786 */   GIM_Reject,
     /* 2389787 */ // Label 33913: @2389787
     /* 2389787 */ GIM_Reject,
     /* 2389788 */ // Label 33842: @2389788
     /* 2389788 */ GIM_Reject,
     /* 2389789 */ // Label 91: @2389789
     /* 2389789 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33940*/ GIMT_Encode4(2392323),
     /* 2389800 */ /*GILLT_s32*//*Label 33916*/ GIMT_Encode4(2389924),
     /* 2389804 */ /*GILLT_s64*//*Label 33917*/ GIMT_Encode4(2389987), GIMT_Encode4(0),
     /* 2389812 */ /*GILLT_nxv1s8*//*Label 33918*/ GIMT_Encode4(2390035),
     /* 2389816 */ /*GILLT_nxv1s16*//*Label 33919*/ GIMT_Encode4(2390139),
     /* 2389820 */ /*GILLT_nxv1s32*//*Label 33920*/ GIMT_Encode4(2390243),
     /* 2389824 */ /*GILLT_nxv1s64*//*Label 33921*/ GIMT_Encode4(2390347), GIMT_Encode4(0),
     /* 2389832 */ /*GILLT_nxv2s8*//*Label 33922*/ GIMT_Encode4(2390451),
     /* 2389836 */ /*GILLT_nxv2s16*//*Label 33923*/ GIMT_Encode4(2390555),
     /* 2389840 */ /*GILLT_nxv2s32*//*Label 33924*/ GIMT_Encode4(2390659),
     /* 2389844 */ /*GILLT_nxv2s64*//*Label 33925*/ GIMT_Encode4(2390763), GIMT_Encode4(0),
     /* 2389852 */ /*GILLT_nxv4s8*//*Label 33926*/ GIMT_Encode4(2390867),
     /* 2389856 */ /*GILLT_nxv4s16*//*Label 33927*/ GIMT_Encode4(2390971),
     /* 2389860 */ /*GILLT_nxv4s32*//*Label 33928*/ GIMT_Encode4(2391075),
     /* 2389864 */ /*GILLT_nxv4s64*//*Label 33929*/ GIMT_Encode4(2391179), GIMT_Encode4(0),
     /* 2389872 */ /*GILLT_nxv8s8*//*Label 33930*/ GIMT_Encode4(2391283),
     /* 2389876 */ /*GILLT_nxv8s16*//*Label 33931*/ GIMT_Encode4(2391387),
     /* 2389880 */ /*GILLT_nxv8s32*//*Label 33932*/ GIMT_Encode4(2391491),
     /* 2389884 */ /*GILLT_nxv8s64*//*Label 33933*/ GIMT_Encode4(2391595), GIMT_Encode4(0),
     /* 2389892 */ /*GILLT_nxv16s8*//*Label 33934*/ GIMT_Encode4(2391699),
     /* 2389896 */ /*GILLT_nxv16s16*//*Label 33935*/ GIMT_Encode4(2391803),
     /* 2389900 */ /*GILLT_nxv16s32*//*Label 33936*/ GIMT_Encode4(2391907), GIMT_Encode4(0),
     /* 2389908 */ /*GILLT_nxv32s8*//*Label 33937*/ GIMT_Encode4(2392011),
     /* 2389912 */ /*GILLT_nxv32s16*//*Label 33938*/ GIMT_Encode4(2392115), GIMT_Encode4(0),
     /* 2389920 */ /*GILLT_nxv64s8*//*Label 33939*/ GIMT_Encode4(2392219),
     /* 2389924 */ // Label 33916: @2389924
     /* 2389924 */ GIM_Try, /*On fail goto*//*Label 33941*/ GIMT_Encode4(2389986),
     /* 2389929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2389932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389940 */   GIM_Try, /*On fail goto*//*Label 33942*/ GIMT_Encode4(2389955), // Rule ID 2546 //
     /* 2389945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0),
     /* 2389948 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2389948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2389953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389954 */     // GIR_Coverage, 2546,
     /* 2389954 */     GIR_Done,
     /* 2389955 */   // Label 33942: @2389955
     /* 2389955 */   GIM_Try, /*On fail goto*//*Label 33943*/ GIMT_Encode4(2389970), // Rule ID 2547 //
     /* 2389960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1),
     /* 2389963 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2389963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2389968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389969 */     // GIR_Coverage, 2547,
     /* 2389969 */     GIR_Done,
     /* 2389970 */   // Label 33943: @2389970
     /* 2389970 */   GIM_Try, /*On fail goto*//*Label 33944*/ GIMT_Encode4(2389985), // Rule ID 62578 //
     /* 2389975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2389978 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_REV:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2389978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2389983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389984 */     // GIR_Coverage, 62578,
     /* 2389984 */     GIR_Done,
     /* 2389985 */   // Label 33944: @2389985
     /* 2389985 */   GIM_Reject,
     /* 2389986 */ // Label 33941: @2389986
     /* 2389986 */ GIM_Reject,
     /* 2389987 */ // Label 33917: @2389987
     /* 2389987 */ GIM_Try, /*On fail goto*//*Label 33945*/ GIMT_Encode4(2390034),
     /* 2389992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2390003 */   GIM_Try, /*On fail goto*//*Label 33946*/ GIMT_Encode4(2390018), // Rule ID 2548 //
     /* 2390008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2390011 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (REV8_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2390011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV64),
     /* 2390016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390017 */     // GIR_Coverage, 2548,
     /* 2390017 */     GIR_Done,
     /* 2390018 */   // Label 33946: @2390018
     /* 2390018 */   GIM_Try, /*On fail goto*//*Label 33947*/ GIMT_Encode4(2390033), // Rule ID 62577 //
     /* 2390023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2390026 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_REV:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2390026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2390031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390032 */     // GIR_Coverage, 62577,
     /* 2390032 */     GIR_Done,
     /* 2390033 */   // Label 33947: @2390033
     /* 2390033 */   GIM_Reject,
     /* 2390034 */ // Label 33945: @2390034
     /* 2390034 */ GIM_Reject,
     /* 2390035 */ // Label 33918: @2390035
     /* 2390035 */ GIM_Try, /*On fail goto*//*Label 33948*/ GIMT_Encode4(2390138),
     /* 2390040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2390043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390051 */   GIM_Try, /*On fail goto*//*Label 33949*/ GIMT_Encode4(2390094), // Rule ID 59108 //
     /* 2390056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390059 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2390062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2390076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390093 */     // GIR_Coverage, 59108,
     /* 2390093 */     GIR_EraseRootFromParent_Done,
     /* 2390094 */   // Label 33949: @2390094
     /* 2390094 */   GIM_Try, /*On fail goto*//*Label 33950*/ GIMT_Encode4(2390137), // Rule ID 59109 //
     /* 2390099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390102 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2390105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2390119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390136 */     // GIR_Coverage, 59109,
     /* 2390136 */     GIR_EraseRootFromParent_Done,
     /* 2390137 */   // Label 33950: @2390137
     /* 2390137 */   GIM_Reject,
     /* 2390138 */ // Label 33948: @2390138
     /* 2390138 */ GIM_Reject,
     /* 2390139 */ // Label 33919: @2390139
     /* 2390139 */ GIM_Try, /*On fail goto*//*Label 33951*/ GIMT_Encode4(2390242),
     /* 2390144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2390147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390155 */   GIM_Try, /*On fail goto*//*Label 33952*/ GIMT_Encode4(2390198), // Rule ID 59114 //
     /* 2390160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390163 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2390166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2390180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390197 */     // GIR_Coverage, 59114,
     /* 2390197 */     GIR_EraseRootFromParent_Done,
     /* 2390198 */   // Label 33952: @2390198
     /* 2390198 */   GIM_Try, /*On fail goto*//*Label 33953*/ GIMT_Encode4(2390241), // Rule ID 59115 //
     /* 2390203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390206 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2390209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2390223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390240 */     // GIR_Coverage, 59115,
     /* 2390240 */     GIR_EraseRootFromParent_Done,
     /* 2390241 */   // Label 33953: @2390241
     /* 2390241 */   GIM_Reject,
     /* 2390242 */ // Label 33951: @2390242
     /* 2390242 */ GIM_Reject,
     /* 2390243 */ // Label 33920: @2390243
     /* 2390243 */ GIM_Try, /*On fail goto*//*Label 33954*/ GIMT_Encode4(2390346),
     /* 2390248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2390251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390259 */   GIM_Try, /*On fail goto*//*Label 33955*/ GIMT_Encode4(2390302), // Rule ID 59118 //
     /* 2390264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390267 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2390270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2390284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390301 */     // GIR_Coverage, 59118,
     /* 2390301 */     GIR_EraseRootFromParent_Done,
     /* 2390302 */   // Label 33955: @2390302
     /* 2390302 */   GIM_Try, /*On fail goto*//*Label 33956*/ GIMT_Encode4(2390345), // Rule ID 59119 //
     /* 2390307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390310 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2390313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2390327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390344 */     // GIR_Coverage, 59119,
     /* 2390344 */     GIR_EraseRootFromParent_Done,
     /* 2390345 */   // Label 33956: @2390345
     /* 2390345 */   GIM_Reject,
     /* 2390346 */ // Label 33954: @2390346
     /* 2390346 */ GIM_Reject,
     /* 2390347 */ // Label 33921: @2390347
     /* 2390347 */ GIM_Try, /*On fail goto*//*Label 33957*/ GIMT_Encode4(2390450),
     /* 2390352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2390355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390363 */   GIM_Try, /*On fail goto*//*Label 33958*/ GIMT_Encode4(2390406), // Rule ID 59126 //
     /* 2390368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2390371 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2390374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2390388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390405 */     // GIR_Coverage, 59126,
     /* 2390405 */     GIR_EraseRootFromParent_Done,
     /* 2390406 */   // Label 33958: @2390406
     /* 2390406 */   GIM_Try, /*On fail goto*//*Label 33959*/ GIMT_Encode4(2390449), // Rule ID 59127 //
     /* 2390411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2390414 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2390417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2390431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390448 */     // GIR_Coverage, 59127,
     /* 2390448 */     GIR_EraseRootFromParent_Done,
     /* 2390449 */   // Label 33959: @2390449
     /* 2390449 */   GIM_Reject,
     /* 2390450 */ // Label 33957: @2390450
     /* 2390450 */ GIM_Reject,
     /* 2390451 */ // Label 33922: @2390451
     /* 2390451 */ GIM_Try, /*On fail goto*//*Label 33960*/ GIMT_Encode4(2390554),
     /* 2390456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2390459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390467 */   GIM_Try, /*On fail goto*//*Label 33961*/ GIMT_Encode4(2390510), // Rule ID 59110 //
     /* 2390472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390475 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2390478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2390492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390509 */     // GIR_Coverage, 59110,
     /* 2390509 */     GIR_EraseRootFromParent_Done,
     /* 2390510 */   // Label 33961: @2390510
     /* 2390510 */   GIM_Try, /*On fail goto*//*Label 33962*/ GIMT_Encode4(2390553), // Rule ID 59111 //
     /* 2390515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390518 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2390521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2390535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390552 */     // GIR_Coverage, 59111,
     /* 2390552 */     GIR_EraseRootFromParent_Done,
     /* 2390553 */   // Label 33962: @2390553
     /* 2390553 */   GIM_Reject,
     /* 2390554 */ // Label 33960: @2390554
     /* 2390554 */ GIM_Reject,
     /* 2390555 */ // Label 33923: @2390555
     /* 2390555 */ GIM_Try, /*On fail goto*//*Label 33963*/ GIMT_Encode4(2390658),
     /* 2390560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2390563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390571 */   GIM_Try, /*On fail goto*//*Label 33964*/ GIMT_Encode4(2390614), // Rule ID 59116 //
     /* 2390576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390579 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2390582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2390596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390613 */     // GIR_Coverage, 59116,
     /* 2390613 */     GIR_EraseRootFromParent_Done,
     /* 2390614 */   // Label 33964: @2390614
     /* 2390614 */   GIM_Try, /*On fail goto*//*Label 33965*/ GIMT_Encode4(2390657), // Rule ID 59117 //
     /* 2390619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390622 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2390625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2390639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390656 */     // GIR_Coverage, 59117,
     /* 2390656 */     GIR_EraseRootFromParent_Done,
     /* 2390657 */   // Label 33965: @2390657
     /* 2390657 */   GIM_Reject,
     /* 2390658 */ // Label 33963: @2390658
     /* 2390658 */ GIM_Reject,
     /* 2390659 */ // Label 33924: @2390659
     /* 2390659 */ GIM_Try, /*On fail goto*//*Label 33966*/ GIMT_Encode4(2390762),
     /* 2390664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2390667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390675 */   GIM_Try, /*On fail goto*//*Label 33967*/ GIMT_Encode4(2390718), // Rule ID 59124 //
     /* 2390680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390683 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2390686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2390700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390717 */     // GIR_Coverage, 59124,
     /* 2390717 */     GIR_EraseRootFromParent_Done,
     /* 2390718 */   // Label 33967: @2390718
     /* 2390718 */   GIM_Try, /*On fail goto*//*Label 33968*/ GIMT_Encode4(2390761), // Rule ID 59125 //
     /* 2390723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390726 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2390729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2390743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390760 */     // GIR_Coverage, 59125,
     /* 2390760 */     GIR_EraseRootFromParent_Done,
     /* 2390761 */   // Label 33968: @2390761
     /* 2390761 */   GIM_Reject,
     /* 2390762 */ // Label 33966: @2390762
     /* 2390762 */ GIM_Reject,
     /* 2390763 */ // Label 33925: @2390763
     /* 2390763 */ GIM_Try, /*On fail goto*//*Label 33969*/ GIMT_Encode4(2390866),
     /* 2390768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2390771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390779 */   GIM_Try, /*On fail goto*//*Label 33970*/ GIMT_Encode4(2390822), // Rule ID 59146 //
     /* 2390784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2390787 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2390790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2390804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390821 */     // GIR_Coverage, 59146,
     /* 2390821 */     GIR_EraseRootFromParent_Done,
     /* 2390822 */   // Label 33970: @2390822
     /* 2390822 */   GIM_Try, /*On fail goto*//*Label 33971*/ GIMT_Encode4(2390865), // Rule ID 59147 //
     /* 2390827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2390830 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2390833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2390847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390864 */     // GIR_Coverage, 59147,
     /* 2390864 */     GIR_EraseRootFromParent_Done,
     /* 2390865 */   // Label 33971: @2390865
     /* 2390865 */   GIM_Reject,
     /* 2390866 */ // Label 33969: @2390866
     /* 2390866 */ GIM_Reject,
     /* 2390867 */ // Label 33926: @2390867
     /* 2390867 */ GIM_Try, /*On fail goto*//*Label 33972*/ GIMT_Encode4(2390970),
     /* 2390872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2390875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390883 */   GIM_Try, /*On fail goto*//*Label 33973*/ GIMT_Encode4(2390926), // Rule ID 59112 //
     /* 2390888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390891 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2390894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2390908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390925 */     // GIR_Coverage, 59112,
     /* 2390925 */     GIR_EraseRootFromParent_Done,
     /* 2390926 */   // Label 33973: @2390926
     /* 2390926 */   GIM_Try, /*On fail goto*//*Label 33974*/ GIMT_Encode4(2390969), // Rule ID 59113 //
     /* 2390931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390934 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2390937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2390951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390968 */     // GIR_Coverage, 59113,
     /* 2390968 */     GIR_EraseRootFromParent_Done,
     /* 2390969 */   // Label 33974: @2390969
     /* 2390969 */   GIM_Reject,
     /* 2390970 */ // Label 33972: @2390970
     /* 2390970 */ GIM_Reject,
     /* 2390971 */ // Label 33927: @2390971
     /* 2390971 */ GIM_Try, /*On fail goto*//*Label 33975*/ GIMT_Encode4(2391074),
     /* 2390976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2390979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390987 */   GIM_Try, /*On fail goto*//*Label 33976*/ GIMT_Encode4(2391030), // Rule ID 59122 //
     /* 2390992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390995 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2390998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2391012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391029 */     // GIR_Coverage, 59122,
     /* 2391029 */     GIR_EraseRootFromParent_Done,
     /* 2391030 */   // Label 33976: @2391030
     /* 2391030 */   GIM_Try, /*On fail goto*//*Label 33977*/ GIMT_Encode4(2391073), // Rule ID 59123 //
     /* 2391035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391038 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2391041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2391055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391072 */     // GIR_Coverage, 59123,
     /* 2391072 */     GIR_EraseRootFromParent_Done,
     /* 2391073 */   // Label 33977: @2391073
     /* 2391073 */   GIM_Reject,
     /* 2391074 */ // Label 33975: @2391074
     /* 2391074 */ GIM_Reject,
     /* 2391075 */ // Label 33928: @2391075
     /* 2391075 */ GIM_Try, /*On fail goto*//*Label 33978*/ GIMT_Encode4(2391178),
     /* 2391080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2391083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2391087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2391091 */   GIM_Try, /*On fail goto*//*Label 33979*/ GIMT_Encode4(2391134), // Rule ID 59140 //
     /* 2391096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391099 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2391102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2391116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391133 */     // GIR_Coverage, 59140,
     /* 2391133 */     GIR_EraseRootFromParent_Done,
     /* 2391134 */   // Label 33979: @2391134
     /* 2391134 */   GIM_Try, /*On fail goto*//*Label 33980*/ GIMT_Encode4(2391177), // Rule ID 59141 //
     /* 2391139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391142 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2391145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2391159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391176 */     // GIR_Coverage, 59141,
     /* 2391176 */     GIR_EraseRootFromParent_Done,
     /* 2391177 */   // Label 33980: @2391177
     /* 2391177 */   GIM_Reject,
     /* 2391178 */ // Label 33978: @2391178
     /* 2391178 */ GIM_Reject,
     /* 2391179 */ // Label 33929: @2391179
     /* 2391179 */ GIM_Try, /*On fail goto*//*Label 33981*/ GIMT_Encode4(2391282),
     /* 2391184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2391187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391195 */   GIM_Try, /*On fail goto*//*Label 33982*/ GIMT_Encode4(2391238), // Rule ID 59148 //
     /* 2391200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2391203 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2391206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2391220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2391233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391237 */     // GIR_Coverage, 59148,
     /* 2391237 */     GIR_EraseRootFromParent_Done,
     /* 2391238 */   // Label 33982: @2391238
     /* 2391238 */   GIM_Try, /*On fail goto*//*Label 33983*/ GIMT_Encode4(2391281), // Rule ID 59149 //
     /* 2391243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2391246 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2391249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2391263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2391276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391280 */     // GIR_Coverage, 59149,
     /* 2391280 */     GIR_EraseRootFromParent_Done,
     /* 2391281 */   // Label 33983: @2391281
     /* 2391281 */   GIM_Reject,
     /* 2391282 */ // Label 33981: @2391282
     /* 2391282 */ GIM_Reject,
     /* 2391283 */ // Label 33930: @2391283
     /* 2391283 */ GIM_Try, /*On fail goto*//*Label 33984*/ GIMT_Encode4(2391386),
     /* 2391288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2391291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391299 */   GIM_Try, /*On fail goto*//*Label 33985*/ GIMT_Encode4(2391342), // Rule ID 59120 //
     /* 2391304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391307 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2391310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2391324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391341 */     // GIR_Coverage, 59120,
     /* 2391341 */     GIR_EraseRootFromParent_Done,
     /* 2391342 */   // Label 33985: @2391342
     /* 2391342 */   GIM_Try, /*On fail goto*//*Label 33986*/ GIMT_Encode4(2391385), // Rule ID 59121 //
     /* 2391347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391350 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2391353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2391367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391384 */     // GIR_Coverage, 59121,
     /* 2391384 */     GIR_EraseRootFromParent_Done,
     /* 2391385 */   // Label 33986: @2391385
     /* 2391385 */   GIM_Reject,
     /* 2391386 */ // Label 33984: @2391386
     /* 2391386 */ GIM_Reject,
     /* 2391387 */ // Label 33931: @2391387
     /* 2391387 */ GIM_Try, /*On fail goto*//*Label 33987*/ GIMT_Encode4(2391490),
     /* 2391392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2391395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2391399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2391403 */   GIM_Try, /*On fail goto*//*Label 33988*/ GIMT_Encode4(2391446), // Rule ID 59134 //
     /* 2391408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391411 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2391414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2391428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391445 */     // GIR_Coverage, 59134,
     /* 2391445 */     GIR_EraseRootFromParent_Done,
     /* 2391446 */   // Label 33988: @2391446
     /* 2391446 */   GIM_Try, /*On fail goto*//*Label 33989*/ GIMT_Encode4(2391489), // Rule ID 59135 //
     /* 2391451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391454 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2391457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2391471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391488 */     // GIR_Coverage, 59135,
     /* 2391488 */     GIR_EraseRootFromParent_Done,
     /* 2391489 */   // Label 33989: @2391489
     /* 2391489 */   GIM_Reject,
     /* 2391490 */ // Label 33987: @2391490
     /* 2391490 */ GIM_Reject,
     /* 2391491 */ // Label 33932: @2391491
     /* 2391491 */ GIM_Try, /*On fail goto*//*Label 33990*/ GIMT_Encode4(2391594),
     /* 2391496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2391499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391507 */   GIM_Try, /*On fail goto*//*Label 33991*/ GIMT_Encode4(2391550), // Rule ID 59142 //
     /* 2391512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391515 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2391518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2391532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391549 */     // GIR_Coverage, 59142,
     /* 2391549 */     GIR_EraseRootFromParent_Done,
     /* 2391550 */   // Label 33991: @2391550
     /* 2391550 */   GIM_Try, /*On fail goto*//*Label 33992*/ GIMT_Encode4(2391593), // Rule ID 59143 //
     /* 2391555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391558 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2391561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2391575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391592 */     // GIR_Coverage, 59143,
     /* 2391592 */     GIR_EraseRootFromParent_Done,
     /* 2391593 */   // Label 33992: @2391593
     /* 2391593 */   GIM_Reject,
     /* 2391594 */ // Label 33990: @2391594
     /* 2391594 */ GIM_Reject,
     /* 2391595 */ // Label 33933: @2391595
     /* 2391595 */ GIM_Try, /*On fail goto*//*Label 33993*/ GIMT_Encode4(2391698),
     /* 2391600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2391603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391611 */   GIM_Try, /*On fail goto*//*Label 33994*/ GIMT_Encode4(2391654), // Rule ID 59150 //
     /* 2391616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2391619 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2391622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2391636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2391649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391653 */     // GIR_Coverage, 59150,
     /* 2391653 */     GIR_EraseRootFromParent_Done,
     /* 2391654 */   // Label 33994: @2391654
     /* 2391654 */   GIM_Try, /*On fail goto*//*Label 33995*/ GIMT_Encode4(2391697), // Rule ID 59151 //
     /* 2391659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2391662 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2391665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2391679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2391692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391696 */     // GIR_Coverage, 59151,
     /* 2391696 */     GIR_EraseRootFromParent_Done,
     /* 2391697 */   // Label 33995: @2391697
     /* 2391697 */   GIM_Reject,
     /* 2391698 */ // Label 33993: @2391698
     /* 2391698 */ GIM_Reject,
     /* 2391699 */ // Label 33934: @2391699
     /* 2391699 */ GIM_Try, /*On fail goto*//*Label 33996*/ GIMT_Encode4(2391802),
     /* 2391704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2391707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2391711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2391715 */   GIM_Try, /*On fail goto*//*Label 33997*/ GIMT_Encode4(2391758), // Rule ID 59128 //
     /* 2391720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391723 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2391726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2391740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391757 */     // GIR_Coverage, 59128,
     /* 2391757 */     GIR_EraseRootFromParent_Done,
     /* 2391758 */   // Label 33997: @2391758
     /* 2391758 */   GIM_Try, /*On fail goto*//*Label 33998*/ GIMT_Encode4(2391801), // Rule ID 59129 //
     /* 2391763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391766 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2391769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2391783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391800 */     // GIR_Coverage, 59129,
     /* 2391800 */     GIR_EraseRootFromParent_Done,
     /* 2391801 */   // Label 33998: @2391801
     /* 2391801 */   GIM_Reject,
     /* 2391802 */ // Label 33996: @2391802
     /* 2391802 */ GIM_Reject,
     /* 2391803 */ // Label 33935: @2391803
     /* 2391803 */ GIM_Try, /*On fail goto*//*Label 33999*/ GIMT_Encode4(2391906),
     /* 2391808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2391811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391819 */   GIM_Try, /*On fail goto*//*Label 34000*/ GIMT_Encode4(2391862), // Rule ID 59136 //
     /* 2391824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391827 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2391830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2391844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391861 */     // GIR_Coverage, 59136,
     /* 2391861 */     GIR_EraseRootFromParent_Done,
     /* 2391862 */   // Label 34000: @2391862
     /* 2391862 */   GIM_Try, /*On fail goto*//*Label 34001*/ GIMT_Encode4(2391905), // Rule ID 59137 //
     /* 2391867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391870 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2391873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2391887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391904 */     // GIR_Coverage, 59137,
     /* 2391904 */     GIR_EraseRootFromParent_Done,
     /* 2391905 */   // Label 34001: @2391905
     /* 2391905 */   GIM_Reject,
     /* 2391906 */ // Label 33999: @2391906
     /* 2391906 */ GIM_Reject,
     /* 2391907 */ // Label 33936: @2391907
     /* 2391907 */ GIM_Try, /*On fail goto*//*Label 34002*/ GIMT_Encode4(2392010),
     /* 2391912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2391915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391923 */   GIM_Try, /*On fail goto*//*Label 34003*/ GIMT_Encode4(2391966), // Rule ID 59144 //
     /* 2391928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391931 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2391934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2391948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391965 */     // GIR_Coverage, 59144,
     /* 2391965 */     GIR_EraseRootFromParent_Done,
     /* 2391966 */   // Label 34003: @2391966
     /* 2391966 */   GIM_Try, /*On fail goto*//*Label 34004*/ GIMT_Encode4(2392009), // Rule ID 59145 //
     /* 2391971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391974 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2391977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2391991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392008 */     // GIR_Coverage, 59145,
     /* 2392008 */     GIR_EraseRootFromParent_Done,
     /* 2392009 */   // Label 34004: @2392009
     /* 2392009 */   GIM_Reject,
     /* 2392010 */ // Label 34002: @2392010
     /* 2392010 */ GIM_Reject,
     /* 2392011 */ // Label 33937: @2392011
     /* 2392011 */ GIM_Try, /*On fail goto*//*Label 34005*/ GIMT_Encode4(2392114),
     /* 2392016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2392019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2392023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2392027 */   GIM_Try, /*On fail goto*//*Label 34006*/ GIMT_Encode4(2392070), // Rule ID 59130 //
     /* 2392032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2392035 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2392038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2392052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392069 */     // GIR_Coverage, 59130,
     /* 2392069 */     GIR_EraseRootFromParent_Done,
     /* 2392070 */   // Label 34006: @2392070
     /* 2392070 */   GIM_Try, /*On fail goto*//*Label 34007*/ GIMT_Encode4(2392113), // Rule ID 59131 //
     /* 2392075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2392078 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2392081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2392095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392112 */     // GIR_Coverage, 59131,
     /* 2392112 */     GIR_EraseRootFromParent_Done,
     /* 2392113 */   // Label 34007: @2392113
     /* 2392113 */   GIM_Reject,
     /* 2392114 */ // Label 34005: @2392114
     /* 2392114 */ GIM_Reject,
     /* 2392115 */ // Label 33938: @2392115
     /* 2392115 */ GIM_Try, /*On fail goto*//*Label 34008*/ GIMT_Encode4(2392218),
     /* 2392120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2392123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2392127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2392131 */   GIM_Try, /*On fail goto*//*Label 34009*/ GIMT_Encode4(2392174), // Rule ID 59138 //
     /* 2392136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2392139 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2392142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2392156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392173 */     // GIR_Coverage, 59138,
     /* 2392173 */     GIR_EraseRootFromParent_Done,
     /* 2392174 */   // Label 34009: @2392174
     /* 2392174 */   GIM_Try, /*On fail goto*//*Label 34010*/ GIMT_Encode4(2392217), // Rule ID 59139 //
     /* 2392179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2392182 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2392185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2392199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392216 */     // GIR_Coverage, 59139,
     /* 2392216 */     GIR_EraseRootFromParent_Done,
     /* 2392217 */   // Label 34010: @2392217
     /* 2392217 */   GIM_Reject,
     /* 2392218 */ // Label 34008: @2392218
     /* 2392218 */ GIM_Reject,
     /* 2392219 */ // Label 33939: @2392219
     /* 2392219 */ GIM_Try, /*On fail goto*//*Label 34011*/ GIMT_Encode4(2392322),
     /* 2392224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2392227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2392231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2392235 */   GIM_Try, /*On fail goto*//*Label 34012*/ GIMT_Encode4(2392278), // Rule ID 59132 //
     /* 2392240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2392243 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2392246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2392260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392277 */     // GIR_Coverage, 59132,
     /* 2392277 */     GIR_EraseRootFromParent_Done,
     /* 2392278 */   // Label 34012: @2392278
     /* 2392278 */   GIM_Try, /*On fail goto*//*Label 34013*/ GIMT_Encode4(2392321), // Rule ID 59133 //
     /* 2392283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2392286 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2392289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2392303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392320 */     // GIR_Coverage, 59133,
     /* 2392320 */     GIR_EraseRootFromParent_Done,
     /* 2392321 */   // Label 34013: @2392321
     /* 2392321 */   GIM_Reject,
     /* 2392322 */ // Label 34011: @2392322
     /* 2392322 */ GIM_Reject,
     /* 2392323 */ // Label 33940: @2392323
     /* 2392323 */ GIM_Reject,
     /* 2392324 */ // Label 92: @2392324
     /* 2392324 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 34038*/ GIMT_Encode4(2394869),
     /* 2392335 */ /*GILLT_s32*//*Label 34014*/ GIMT_Encode4(2392459),
     /* 2392339 */ /*GILLT_s64*//*Label 34015*/ GIMT_Encode4(2392546), GIMT_Encode4(0),
     /* 2392347 */ /*GILLT_nxv1s8*//*Label 34016*/ GIMT_Encode4(2392581),
     /* 2392351 */ /*GILLT_nxv1s16*//*Label 34017*/ GIMT_Encode4(2392685),
     /* 2392355 */ /*GILLT_nxv1s32*//*Label 34018*/ GIMT_Encode4(2392789),
     /* 2392359 */ /*GILLT_nxv1s64*//*Label 34019*/ GIMT_Encode4(2392893), GIMT_Encode4(0),
     /* 2392367 */ /*GILLT_nxv2s8*//*Label 34020*/ GIMT_Encode4(2392997),
     /* 2392371 */ /*GILLT_nxv2s16*//*Label 34021*/ GIMT_Encode4(2393101),
     /* 2392375 */ /*GILLT_nxv2s32*//*Label 34022*/ GIMT_Encode4(2393205),
     /* 2392379 */ /*GILLT_nxv2s64*//*Label 34023*/ GIMT_Encode4(2393309), GIMT_Encode4(0),
     /* 2392387 */ /*GILLT_nxv4s8*//*Label 34024*/ GIMT_Encode4(2393413),
     /* 2392391 */ /*GILLT_nxv4s16*//*Label 34025*/ GIMT_Encode4(2393517),
     /* 2392395 */ /*GILLT_nxv4s32*//*Label 34026*/ GIMT_Encode4(2393621),
     /* 2392399 */ /*GILLT_nxv4s64*//*Label 34027*/ GIMT_Encode4(2393725), GIMT_Encode4(0),
     /* 2392407 */ /*GILLT_nxv8s8*//*Label 34028*/ GIMT_Encode4(2393829),
     /* 2392411 */ /*GILLT_nxv8s16*//*Label 34029*/ GIMT_Encode4(2393933),
     /* 2392415 */ /*GILLT_nxv8s32*//*Label 34030*/ GIMT_Encode4(2394037),
     /* 2392419 */ /*GILLT_nxv8s64*//*Label 34031*/ GIMT_Encode4(2394141), GIMT_Encode4(0),
     /* 2392427 */ /*GILLT_nxv16s8*//*Label 34032*/ GIMT_Encode4(2394245),
     /* 2392431 */ /*GILLT_nxv16s16*//*Label 34033*/ GIMT_Encode4(2394349),
     /* 2392435 */ /*GILLT_nxv16s32*//*Label 34034*/ GIMT_Encode4(2394453), GIMT_Encode4(0),
     /* 2392443 */ /*GILLT_nxv32s8*//*Label 34035*/ GIMT_Encode4(2394557),
     /* 2392447 */ /*GILLT_nxv32s16*//*Label 34036*/ GIMT_Encode4(2394661), GIMT_Encode4(0),
     /* 2392455 */ /*GILLT_nxv64s8*//*Label 34037*/ GIMT_Encode4(2394765),
     /* 2392459 */ // Label 34014: @2392459
     /* 2392459 */ GIM_Try, /*On fail goto*//*Label 34039*/ GIMT_Encode4(2392545),
     /* 2392464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392467 */   GIM_Try, /*On fail goto*//*Label 34040*/ GIMT_Encode4(2392498), // Rule ID 64461 //
     /* 2392472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2392475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392483 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$rs)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2392483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2392486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2392490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2392493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2392496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392497 */     // GIR_Coverage, 64461,
     /* 2392497 */     GIR_EraseRootFromParent_Done,
     /* 2392498 */   // Label 34040: @2392498
     /* 2392498 */   GIM_Try, /*On fail goto*//*Label 34041*/ GIMT_Encode4(2392521), // Rule ID 64643 //
     /* 2392503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2392506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2392510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2392514 */     // (bitreverse:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)  =>  (QC_BREV32:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)
     /* 2392514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_BREV32),
     /* 2392519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392520 */     // GIR_Coverage, 64643,
     /* 2392520 */     GIR_Done,
     /* 2392521 */   // Label 34041: @2392521
     /* 2392521 */   GIM_Try, /*On fail goto*//*Label 34042*/ GIMT_Encode4(2392544), // Rule ID 64644 //
     /* 2392526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2392529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2392533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2392537 */     // (bitreverse:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)  =>  (QC_BREV32:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)
     /* 2392537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_BREV32),
     /* 2392542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392543 */     // GIR_Coverage, 64644,
     /* 2392543 */     GIR_Done,
     /* 2392544 */   // Label 34042: @2392544
     /* 2392544 */   GIM_Reject,
     /* 2392545 */ // Label 34039: @2392545
     /* 2392545 */ GIM_Reject,
     /* 2392546 */ // Label 34015: @2392546
     /* 2392546 */ GIM_Try, /*On fail goto*//*Label 34043*/ GIMT_Encode4(2392580), // Rule ID 64460 //
     /* 2392551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2392554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2392557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392565 */   // (bitreverse:{ *:[i64] } GPR:{ *:[i64] }:$rs)  =>  (CV_BITREV:{ *:[i64] } GPR:{ *:[i64] }:$rs, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2392565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2392568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392570 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2392572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2392575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2392578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2392579 */   // GIR_Coverage, 64460,
     /* 2392579 */   GIR_EraseRootFromParent_Done,
     /* 2392580 */ // Label 34043: @2392580
     /* 2392580 */ GIM_Reject,
     /* 2392581 */ // Label 34016: @2392581
     /* 2392581 */ GIM_Try, /*On fail goto*//*Label 34044*/ GIMT_Encode4(2392684),
     /* 2392586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2392589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392597 */   GIM_Try, /*On fail goto*//*Label 34045*/ GIMT_Encode4(2392640), // Rule ID 58932 //
     /* 2392602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2392605 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2392608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2392622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392639 */     // GIR_Coverage, 58932,
     /* 2392639 */     GIR_EraseRootFromParent_Done,
     /* 2392640 */   // Label 34045: @2392640
     /* 2392640 */   GIM_Try, /*On fail goto*//*Label 34046*/ GIMT_Encode4(2392683), // Rule ID 58933 //
     /* 2392645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2392648 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2392651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2392665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392682 */     // GIR_Coverage, 58933,
     /* 2392682 */     GIR_EraseRootFromParent_Done,
     /* 2392683 */   // Label 34046: @2392683
     /* 2392683 */   GIM_Reject,
     /* 2392684 */ // Label 34044: @2392684
     /* 2392684 */ GIM_Reject,
     /* 2392685 */ // Label 34017: @2392685
     /* 2392685 */ GIM_Try, /*On fail goto*//*Label 34047*/ GIMT_Encode4(2392788),
     /* 2392690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2392693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392701 */   GIM_Try, /*On fail goto*//*Label 34048*/ GIMT_Encode4(2392744), // Rule ID 59070 //
     /* 2392706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2392709 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2392712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2392726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392743 */     // GIR_Coverage, 59070,
     /* 2392743 */     GIR_EraseRootFromParent_Done,
     /* 2392744 */   // Label 34048: @2392744
     /* 2392744 */   GIM_Try, /*On fail goto*//*Label 34049*/ GIMT_Encode4(2392787), // Rule ID 59071 //
     /* 2392749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2392752 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2392755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2392769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392786 */     // GIR_Coverage, 59071,
     /* 2392786 */     GIR_EraseRootFromParent_Done,
     /* 2392787 */   // Label 34049: @2392787
     /* 2392787 */   GIM_Reject,
     /* 2392788 */ // Label 34047: @2392788
     /* 2392788 */ GIM_Reject,
     /* 2392789 */ // Label 34018: @2392789
     /* 2392789 */ GIM_Try, /*On fail goto*//*Label 34050*/ GIMT_Encode4(2392892),
     /* 2392794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2392797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392805 */   GIM_Try, /*On fail goto*//*Label 34051*/ GIMT_Encode4(2392848), // Rule ID 59074 //
     /* 2392810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2392813 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2392816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2392830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392847 */     // GIR_Coverage, 59074,
     /* 2392847 */     GIR_EraseRootFromParent_Done,
     /* 2392848 */   // Label 34051: @2392848
     /* 2392848 */   GIM_Try, /*On fail goto*//*Label 34052*/ GIMT_Encode4(2392891), // Rule ID 59075 //
     /* 2392853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2392856 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2392859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2392873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392890 */     // GIR_Coverage, 59075,
     /* 2392890 */     GIR_EraseRootFromParent_Done,
     /* 2392891 */   // Label 34052: @2392891
     /* 2392891 */   GIM_Reject,
     /* 2392892 */ // Label 34050: @2392892
     /* 2392892 */ GIM_Reject,
     /* 2392893 */ // Label 34019: @2392893
     /* 2392893 */ GIM_Try, /*On fail goto*//*Label 34053*/ GIMT_Encode4(2392996),
     /* 2392898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392909 */   GIM_Try, /*On fail goto*//*Label 34054*/ GIMT_Encode4(2392952), // Rule ID 59082 //
     /* 2392914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2392917 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2392920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2392934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392951 */     // GIR_Coverage, 59082,
     /* 2392951 */     GIR_EraseRootFromParent_Done,
     /* 2392952 */   // Label 34054: @2392952
     /* 2392952 */   GIM_Try, /*On fail goto*//*Label 34055*/ GIMT_Encode4(2392995), // Rule ID 59083 //
     /* 2392957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2392960 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2392963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2392977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392994 */     // GIR_Coverage, 59083,
     /* 2392994 */     GIR_EraseRootFromParent_Done,
     /* 2392995 */   // Label 34055: @2392995
     /* 2392995 */   GIM_Reject,
     /* 2392996 */ // Label 34053: @2392996
     /* 2392996 */ GIM_Reject,
     /* 2392997 */ // Label 34020: @2392997
     /* 2392997 */ GIM_Try, /*On fail goto*//*Label 34056*/ GIMT_Encode4(2393100),
     /* 2393002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2393005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393013 */   GIM_Try, /*On fail goto*//*Label 34057*/ GIMT_Encode4(2393056), // Rule ID 59066 //
     /* 2393018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393021 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2393024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2393038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393055 */     // GIR_Coverage, 59066,
     /* 2393055 */     GIR_EraseRootFromParent_Done,
     /* 2393056 */   // Label 34057: @2393056
     /* 2393056 */   GIM_Try, /*On fail goto*//*Label 34058*/ GIMT_Encode4(2393099), // Rule ID 59067 //
     /* 2393061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393064 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2393067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2393081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393098 */     // GIR_Coverage, 59067,
     /* 2393098 */     GIR_EraseRootFromParent_Done,
     /* 2393099 */   // Label 34058: @2393099
     /* 2393099 */   GIM_Reject,
     /* 2393100 */ // Label 34056: @2393100
     /* 2393100 */ GIM_Reject,
     /* 2393101 */ // Label 34021: @2393101
     /* 2393101 */ GIM_Try, /*On fail goto*//*Label 34059*/ GIMT_Encode4(2393204),
     /* 2393106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393117 */   GIM_Try, /*On fail goto*//*Label 34060*/ GIMT_Encode4(2393160), // Rule ID 59072 //
     /* 2393122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393125 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2393128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2393142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393159 */     // GIR_Coverage, 59072,
     /* 2393159 */     GIR_EraseRootFromParent_Done,
     /* 2393160 */   // Label 34060: @2393160
     /* 2393160 */   GIM_Try, /*On fail goto*//*Label 34061*/ GIMT_Encode4(2393203), // Rule ID 59073 //
     /* 2393165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393168 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2393171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2393185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393202 */     // GIR_Coverage, 59073,
     /* 2393202 */     GIR_EraseRootFromParent_Done,
     /* 2393203 */   // Label 34061: @2393203
     /* 2393203 */   GIM_Reject,
     /* 2393204 */ // Label 34059: @2393204
     /* 2393204 */ GIM_Reject,
     /* 2393205 */ // Label 34022: @2393205
     /* 2393205 */ GIM_Try, /*On fail goto*//*Label 34062*/ GIMT_Encode4(2393308),
     /* 2393210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2393213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393221 */   GIM_Try, /*On fail goto*//*Label 34063*/ GIMT_Encode4(2393264), // Rule ID 59080 //
     /* 2393226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393229 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2393232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2393246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393263 */     // GIR_Coverage, 59080,
     /* 2393263 */     GIR_EraseRootFromParent_Done,
     /* 2393264 */   // Label 34063: @2393264
     /* 2393264 */   GIM_Try, /*On fail goto*//*Label 34064*/ GIMT_Encode4(2393307), // Rule ID 59081 //
     /* 2393269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393272 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2393275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2393289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393306 */     // GIR_Coverage, 59081,
     /* 2393306 */     GIR_EraseRootFromParent_Done,
     /* 2393307 */   // Label 34064: @2393307
     /* 2393307 */   GIM_Reject,
     /* 2393308 */ // Label 34062: @2393308
     /* 2393308 */ GIM_Reject,
     /* 2393309 */ // Label 34023: @2393309
     /* 2393309 */ GIM_Try, /*On fail goto*//*Label 34065*/ GIMT_Encode4(2393412),
     /* 2393314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2393317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393325 */   GIM_Try, /*On fail goto*//*Label 34066*/ GIMT_Encode4(2393368), // Rule ID 59102 //
     /* 2393330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2393333 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2393336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2393350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393367 */     // GIR_Coverage, 59102,
     /* 2393367 */     GIR_EraseRootFromParent_Done,
     /* 2393368 */   // Label 34066: @2393368
     /* 2393368 */   GIM_Try, /*On fail goto*//*Label 34067*/ GIMT_Encode4(2393411), // Rule ID 59103 //
     /* 2393373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2393376 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2393379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2393393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393410 */     // GIR_Coverage, 59103,
     /* 2393410 */     GIR_EraseRootFromParent_Done,
     /* 2393411 */   // Label 34067: @2393411
     /* 2393411 */   GIM_Reject,
     /* 2393412 */ // Label 34065: @2393412
     /* 2393412 */ GIM_Reject,
     /* 2393413 */ // Label 34024: @2393413
     /* 2393413 */ GIM_Try, /*On fail goto*//*Label 34068*/ GIMT_Encode4(2393516),
     /* 2393418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2393421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393429 */   GIM_Try, /*On fail goto*//*Label 34069*/ GIMT_Encode4(2393472), // Rule ID 59068 //
     /* 2393434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393437 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2393440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2393454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393471 */     // GIR_Coverage, 59068,
     /* 2393471 */     GIR_EraseRootFromParent_Done,
     /* 2393472 */   // Label 34069: @2393472
     /* 2393472 */   GIM_Try, /*On fail goto*//*Label 34070*/ GIMT_Encode4(2393515), // Rule ID 59069 //
     /* 2393477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393480 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2393483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2393497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393514 */     // GIR_Coverage, 59069,
     /* 2393514 */     GIR_EraseRootFromParent_Done,
     /* 2393515 */   // Label 34070: @2393515
     /* 2393515 */   GIM_Reject,
     /* 2393516 */ // Label 34068: @2393516
     /* 2393516 */ GIM_Reject,
     /* 2393517 */ // Label 34025: @2393517
     /* 2393517 */ GIM_Try, /*On fail goto*//*Label 34071*/ GIMT_Encode4(2393620),
     /* 2393522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2393525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393533 */   GIM_Try, /*On fail goto*//*Label 34072*/ GIMT_Encode4(2393576), // Rule ID 59078 //
     /* 2393538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393541 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2393544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2393558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393575 */     // GIR_Coverage, 59078,
     /* 2393575 */     GIR_EraseRootFromParent_Done,
     /* 2393576 */   // Label 34072: @2393576
     /* 2393576 */   GIM_Try, /*On fail goto*//*Label 34073*/ GIMT_Encode4(2393619), // Rule ID 59079 //
     /* 2393581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393584 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2393587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2393601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393618 */     // GIR_Coverage, 59079,
     /* 2393618 */     GIR_EraseRootFromParent_Done,
     /* 2393619 */   // Label 34073: @2393619
     /* 2393619 */   GIM_Reject,
     /* 2393620 */ // Label 34071: @2393620
     /* 2393620 */ GIM_Reject,
     /* 2393621 */ // Label 34026: @2393621
     /* 2393621 */ GIM_Try, /*On fail goto*//*Label 34074*/ GIMT_Encode4(2393724),
     /* 2393626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2393629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393637 */   GIM_Try, /*On fail goto*//*Label 34075*/ GIMT_Encode4(2393680), // Rule ID 59096 //
     /* 2393642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393645 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2393648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2393662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393679 */     // GIR_Coverage, 59096,
     /* 2393679 */     GIR_EraseRootFromParent_Done,
     /* 2393680 */   // Label 34075: @2393680
     /* 2393680 */   GIM_Try, /*On fail goto*//*Label 34076*/ GIMT_Encode4(2393723), // Rule ID 59097 //
     /* 2393685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393688 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2393691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2393705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393722 */     // GIR_Coverage, 59097,
     /* 2393722 */     GIR_EraseRootFromParent_Done,
     /* 2393723 */   // Label 34076: @2393723
     /* 2393723 */   GIM_Reject,
     /* 2393724 */ // Label 34074: @2393724
     /* 2393724 */ GIM_Reject,
     /* 2393725 */ // Label 34027: @2393725
     /* 2393725 */ GIM_Try, /*On fail goto*//*Label 34077*/ GIMT_Encode4(2393828),
     /* 2393730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2393733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393741 */   GIM_Try, /*On fail goto*//*Label 34078*/ GIMT_Encode4(2393784), // Rule ID 59104 //
     /* 2393746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2393749 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2393752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2393766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393783 */     // GIR_Coverage, 59104,
     /* 2393783 */     GIR_EraseRootFromParent_Done,
     /* 2393784 */   // Label 34078: @2393784
     /* 2393784 */   GIM_Try, /*On fail goto*//*Label 34079*/ GIMT_Encode4(2393827), // Rule ID 59105 //
     /* 2393789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2393792 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2393795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2393809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393826 */     // GIR_Coverage, 59105,
     /* 2393826 */     GIR_EraseRootFromParent_Done,
     /* 2393827 */   // Label 34079: @2393827
     /* 2393827 */   GIM_Reject,
     /* 2393828 */ // Label 34077: @2393828
     /* 2393828 */ GIM_Reject,
     /* 2393829 */ // Label 34028: @2393829
     /* 2393829 */ GIM_Try, /*On fail goto*//*Label 34080*/ GIMT_Encode4(2393932),
     /* 2393834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2393837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393845 */   GIM_Try, /*On fail goto*//*Label 34081*/ GIMT_Encode4(2393888), // Rule ID 59076 //
     /* 2393850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393853 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2393856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2393870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393887 */     // GIR_Coverage, 59076,
     /* 2393887 */     GIR_EraseRootFromParent_Done,
     /* 2393888 */   // Label 34081: @2393888
     /* 2393888 */   GIM_Try, /*On fail goto*//*Label 34082*/ GIMT_Encode4(2393931), // Rule ID 59077 //
     /* 2393893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393896 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2393899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2393913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393930 */     // GIR_Coverage, 59077,
     /* 2393930 */     GIR_EraseRootFromParent_Done,
     /* 2393931 */   // Label 34082: @2393931
     /* 2393931 */   GIM_Reject,
     /* 2393932 */ // Label 34080: @2393932
     /* 2393932 */ GIM_Reject,
     /* 2393933 */ // Label 34029: @2393933
     /* 2393933 */ GIM_Try, /*On fail goto*//*Label 34083*/ GIMT_Encode4(2394036),
     /* 2393938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2393941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393949 */   GIM_Try, /*On fail goto*//*Label 34084*/ GIMT_Encode4(2393992), // Rule ID 59090 //
     /* 2393954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393957 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2393960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2393974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393991 */     // GIR_Coverage, 59090,
     /* 2393991 */     GIR_EraseRootFromParent_Done,
     /* 2393992 */   // Label 34084: @2393992
     /* 2393992 */   GIM_Try, /*On fail goto*//*Label 34085*/ GIMT_Encode4(2394035), // Rule ID 59091 //
     /* 2393997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394000 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2394003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2394017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394034 */     // GIR_Coverage, 59091,
     /* 2394034 */     GIR_EraseRootFromParent_Done,
     /* 2394035 */   // Label 34085: @2394035
     /* 2394035 */   GIM_Reject,
     /* 2394036 */ // Label 34083: @2394036
     /* 2394036 */ GIM_Reject,
     /* 2394037 */ // Label 34030: @2394037
     /* 2394037 */ GIM_Try, /*On fail goto*//*Label 34086*/ GIMT_Encode4(2394140),
     /* 2394042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2394045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394053 */   GIM_Try, /*On fail goto*//*Label 34087*/ GIMT_Encode4(2394096), // Rule ID 59098 //
     /* 2394058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394061 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2394064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2394078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394095 */     // GIR_Coverage, 59098,
     /* 2394095 */     GIR_EraseRootFromParent_Done,
     /* 2394096 */   // Label 34087: @2394096
     /* 2394096 */   GIM_Try, /*On fail goto*//*Label 34088*/ GIMT_Encode4(2394139), // Rule ID 59099 //
     /* 2394101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394104 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2394107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2394121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394138 */     // GIR_Coverage, 59099,
     /* 2394138 */     GIR_EraseRootFromParent_Done,
     /* 2394139 */   // Label 34088: @2394139
     /* 2394139 */   GIM_Reject,
     /* 2394140 */ // Label 34086: @2394140
     /* 2394140 */ GIM_Reject,
     /* 2394141 */ // Label 34031: @2394141
     /* 2394141 */ GIM_Try, /*On fail goto*//*Label 34089*/ GIMT_Encode4(2394244),
     /* 2394146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2394149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394157 */   GIM_Try, /*On fail goto*//*Label 34090*/ GIMT_Encode4(2394200), // Rule ID 59106 //
     /* 2394162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2394165 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2394168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394199 */     // GIR_Coverage, 59106,
     /* 2394199 */     GIR_EraseRootFromParent_Done,
     /* 2394200 */   // Label 34090: @2394200
     /* 2394200 */   GIM_Try, /*On fail goto*//*Label 34091*/ GIMT_Encode4(2394243), // Rule ID 59107 //
     /* 2394205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2394208 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2394211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394242 */     // GIR_Coverage, 59107,
     /* 2394242 */     GIR_EraseRootFromParent_Done,
     /* 2394243 */   // Label 34091: @2394243
     /* 2394243 */   GIM_Reject,
     /* 2394244 */ // Label 34089: @2394244
     /* 2394244 */ GIM_Reject,
     /* 2394245 */ // Label 34032: @2394245
     /* 2394245 */ GIM_Try, /*On fail goto*//*Label 34092*/ GIMT_Encode4(2394348),
     /* 2394250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2394253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394261 */   GIM_Try, /*On fail goto*//*Label 34093*/ GIMT_Encode4(2394304), // Rule ID 59084 //
     /* 2394266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394269 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2394272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2394286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394303 */     // GIR_Coverage, 59084,
     /* 2394303 */     GIR_EraseRootFromParent_Done,
     /* 2394304 */   // Label 34093: @2394304
     /* 2394304 */   GIM_Try, /*On fail goto*//*Label 34094*/ GIMT_Encode4(2394347), // Rule ID 59085 //
     /* 2394309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394312 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2394315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2394329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394346 */     // GIR_Coverage, 59085,
     /* 2394346 */     GIR_EraseRootFromParent_Done,
     /* 2394347 */   // Label 34094: @2394347
     /* 2394347 */   GIM_Reject,
     /* 2394348 */ // Label 34092: @2394348
     /* 2394348 */ GIM_Reject,
     /* 2394349 */ // Label 34033: @2394349
     /* 2394349 */ GIM_Try, /*On fail goto*//*Label 34095*/ GIMT_Encode4(2394452),
     /* 2394354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2394357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394365 */   GIM_Try, /*On fail goto*//*Label 34096*/ GIMT_Encode4(2394408), // Rule ID 59092 //
     /* 2394370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394373 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2394376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2394390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394407 */     // GIR_Coverage, 59092,
     /* 2394407 */     GIR_EraseRootFromParent_Done,
     /* 2394408 */   // Label 34096: @2394408
     /* 2394408 */   GIM_Try, /*On fail goto*//*Label 34097*/ GIMT_Encode4(2394451), // Rule ID 59093 //
     /* 2394413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394416 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2394419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2394433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394450 */     // GIR_Coverage, 59093,
     /* 2394450 */     GIR_EraseRootFromParent_Done,
     /* 2394451 */   // Label 34097: @2394451
     /* 2394451 */   GIM_Reject,
     /* 2394452 */ // Label 34095: @2394452
     /* 2394452 */ GIM_Reject,
     /* 2394453 */ // Label 34034: @2394453
     /* 2394453 */ GIM_Try, /*On fail goto*//*Label 34098*/ GIMT_Encode4(2394556),
     /* 2394458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2394461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394469 */   GIM_Try, /*On fail goto*//*Label 34099*/ GIMT_Encode4(2394512), // Rule ID 59100 //
     /* 2394474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394477 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2394480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394511 */     // GIR_Coverage, 59100,
     /* 2394511 */     GIR_EraseRootFromParent_Done,
     /* 2394512 */   // Label 34099: @2394512
     /* 2394512 */   GIM_Try, /*On fail goto*//*Label 34100*/ GIMT_Encode4(2394555), // Rule ID 59101 //
     /* 2394517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394520 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2394523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394554 */     // GIR_Coverage, 59101,
     /* 2394554 */     GIR_EraseRootFromParent_Done,
     /* 2394555 */   // Label 34100: @2394555
     /* 2394555 */   GIM_Reject,
     /* 2394556 */ // Label 34098: @2394556
     /* 2394556 */ GIM_Reject,
     /* 2394557 */ // Label 34035: @2394557
     /* 2394557 */ GIM_Try, /*On fail goto*//*Label 34101*/ GIMT_Encode4(2394660),
     /* 2394562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2394565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394573 */   GIM_Try, /*On fail goto*//*Label 34102*/ GIMT_Encode4(2394616), // Rule ID 59086 //
     /* 2394578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394581 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2394584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2394598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394615 */     // GIR_Coverage, 59086,
     /* 2394615 */     GIR_EraseRootFromParent_Done,
     /* 2394616 */   // Label 34102: @2394616
     /* 2394616 */   GIM_Try, /*On fail goto*//*Label 34103*/ GIMT_Encode4(2394659), // Rule ID 59087 //
     /* 2394621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394624 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2394627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2394641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394658 */     // GIR_Coverage, 59087,
     /* 2394658 */     GIR_EraseRootFromParent_Done,
     /* 2394659 */   // Label 34103: @2394659
     /* 2394659 */   GIM_Reject,
     /* 2394660 */ // Label 34101: @2394660
     /* 2394660 */ GIM_Reject,
     /* 2394661 */ // Label 34036: @2394661
     /* 2394661 */ GIM_Try, /*On fail goto*//*Label 34104*/ GIMT_Encode4(2394764),
     /* 2394666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2394669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394677 */   GIM_Try, /*On fail goto*//*Label 34105*/ GIMT_Encode4(2394720), // Rule ID 59094 //
     /* 2394682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394685 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2394688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394719 */     // GIR_Coverage, 59094,
     /* 2394719 */     GIR_EraseRootFromParent_Done,
     /* 2394720 */   // Label 34105: @2394720
     /* 2394720 */   GIM_Try, /*On fail goto*//*Label 34106*/ GIMT_Encode4(2394763), // Rule ID 59095 //
     /* 2394725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394728 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2394731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394762 */     // GIR_Coverage, 59095,
     /* 2394762 */     GIR_EraseRootFromParent_Done,
     /* 2394763 */   // Label 34106: @2394763
     /* 2394763 */   GIM_Reject,
     /* 2394764 */ // Label 34104: @2394764
     /* 2394764 */ GIM_Reject,
     /* 2394765 */ // Label 34037: @2394765
     /* 2394765 */ GIM_Try, /*On fail goto*//*Label 34107*/ GIMT_Encode4(2394868),
     /* 2394770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2394773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394781 */   GIM_Try, /*On fail goto*//*Label 34108*/ GIMT_Encode4(2394824), // Rule ID 59088 //
     /* 2394786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394789 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2394792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394823 */     // GIR_Coverage, 59088,
     /* 2394823 */     GIR_EraseRootFromParent_Done,
     /* 2394824 */   // Label 34108: @2394824
     /* 2394824 */   GIM_Try, /*On fail goto*//*Label 34109*/ GIMT_Encode4(2394867), // Rule ID 59089 //
     /* 2394829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394832 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2394835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394866 */     // GIR_Coverage, 59089,
     /* 2394866 */     GIR_EraseRootFromParent_Done,
     /* 2394867 */   // Label 34109: @2394867
     /* 2394867 */   GIM_Reject,
     /* 2394868 */ // Label 34107: @2394868
     /* 2394868 */ GIM_Reject,
     /* 2394869 */ // Label 34038: @2394869
     /* 2394869 */ GIM_Reject,
     /* 2394870 */ // Label 93: @2394870
     /* 2394870 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34113*/ GIMT_Encode4(2395067),
     /* 2394881 */ /*GILLT_s16*//*Label 34110*/ GIMT_Encode4(2394893),
     /* 2394885 */ /*GILLT_s32*//*Label 34111*/ GIMT_Encode4(2394951),
     /* 2394889 */ /*GILLT_s64*//*Label 34112*/ GIMT_Encode4(2395009),
     /* 2394893 */ // Label 34110: @2394893
     /* 2394893 */ GIM_Try, /*On fail goto*//*Label 34114*/ GIMT_Encode4(2394950),
     /* 2394898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2394901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394909 */   GIM_Try, /*On fail goto*//*Label 34115*/ GIMT_Encode4(2394929), // Rule ID 2440 //
     /* 2394914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2394917 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i64] })
     /* 2394917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2394920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394928 */     // GIR_Coverage, 2440,
     /* 2394928 */     GIR_EraseRootFromParent_Done,
     /* 2394929 */   // Label 34115: @2394929
     /* 2394929 */   GIM_Try, /*On fail goto*//*Label 34116*/ GIMT_Encode4(2394949), // Rule ID 2441 //
     /* 2394934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2394937 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i32] })
     /* 2394937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2394940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394948 */     // GIR_Coverage, 2441,
     /* 2394948 */     GIR_EraseRootFromParent_Done,
     /* 2394949 */   // Label 34116: @2394949
     /* 2394949 */   GIM_Reject,
     /* 2394950 */ // Label 34114: @2394950
     /* 2394950 */ GIM_Reject,
     /* 2394951 */ // Label 34111: @2394951
     /* 2394951 */ GIM_Try, /*On fail goto*//*Label 34117*/ GIMT_Encode4(2395008),
     /* 2394956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2394959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394967 */   GIM_Try, /*On fail goto*//*Label 34118*/ GIMT_Encode4(2394987), // Rule ID 2358 //
     /* 2394972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2394975 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i64] })
     /* 2394975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2394978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394986 */     // GIR_Coverage, 2358,
     /* 2394986 */     GIR_EraseRootFromParent_Done,
     /* 2394987 */   // Label 34118: @2394987
     /* 2394987 */   GIM_Try, /*On fail goto*//*Label 34119*/ GIMT_Encode4(2395007), // Rule ID 2359 //
     /* 2394992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2394995 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i32] })
     /* 2394995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2394998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395006 */     // GIR_Coverage, 2359,
     /* 2395006 */     GIR_EraseRootFromParent_Done,
     /* 2395007 */   // Label 34119: @2395007
     /* 2395007 */   GIM_Reject,
     /* 2395008 */ // Label 34117: @2395008
     /* 2395008 */ GIM_Reject,
     /* 2395009 */ // Label 34112: @2395009
     /* 2395009 */ GIM_Try, /*On fail goto*//*Label 34120*/ GIMT_Encode4(2395066),
     /* 2395014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2395017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395025 */   GIM_Try, /*On fail goto*//*Label 34121*/ GIMT_Encode4(2395045), // Rule ID 2398 //
     /* 2395030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2395033 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i64] })
     /* 2395033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2395036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395044 */     // GIR_Coverage, 2398,
     /* 2395044 */     GIR_EraseRootFromParent_Done,
     /* 2395045 */   // Label 34121: @2395045
     /* 2395045 */   GIM_Try, /*On fail goto*//*Label 34122*/ GIMT_Encode4(2395065), // Rule ID 2399 //
     /* 2395050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2395053 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i32] })
     /* 2395053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2395056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395064 */     // GIR_Coverage, 2399,
     /* 2395064 */     GIR_EraseRootFromParent_Done,
     /* 2395065 */   // Label 34122: @2395065
     /* 2395065 */   GIM_Reject,
     /* 2395066 */ // Label 34120: @2395066
     /* 2395066 */ GIM_Reject,
     /* 2395067 */ // Label 34113: @2395067
     /* 2395067 */ GIM_Reject,
     /* 2395068 */ // Label 94: @2395068
     /* 2395068 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34141*/ GIMT_Encode4(2397243),
     /* 2395079 */ /*GILLT_s16*//*Label 34123*/ GIMT_Encode4(2395199),
     /* 2395083 */ /*GILLT_s32*//*Label 34124*/ GIMT_Encode4(2395321),
     /* 2395087 */ /*GILLT_s64*//*Label 34125*/ GIMT_Encode4(2395443), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2395099 */ /*GILLT_nxv1s16*//*Label 34126*/ GIMT_Encode4(2395593),
     /* 2395103 */ /*GILLT_nxv1s32*//*Label 34127*/ GIMT_Encode4(2395703),
     /* 2395107 */ /*GILLT_nxv1s64*//*Label 34128*/ GIMT_Encode4(2395813), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2395119 */ /*GILLT_nxv2s16*//*Label 34129*/ GIMT_Encode4(2395923),
     /* 2395123 */ /*GILLT_nxv2s32*//*Label 34130*/ GIMT_Encode4(2396033),
     /* 2395127 */ /*GILLT_nxv2s64*//*Label 34131*/ GIMT_Encode4(2396143), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2395139 */ /*GILLT_nxv4s16*//*Label 34132*/ GIMT_Encode4(2396253),
     /* 2395143 */ /*GILLT_nxv4s32*//*Label 34133*/ GIMT_Encode4(2396363),
     /* 2395147 */ /*GILLT_nxv4s64*//*Label 34134*/ GIMT_Encode4(2396473), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2395159 */ /*GILLT_nxv8s16*//*Label 34135*/ GIMT_Encode4(2396583),
     /* 2395163 */ /*GILLT_nxv8s32*//*Label 34136*/ GIMT_Encode4(2396693),
     /* 2395167 */ /*GILLT_nxv8s64*//*Label 34137*/ GIMT_Encode4(2396803), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2395179 */ /*GILLT_nxv16s16*//*Label 34138*/ GIMT_Encode4(2396913),
     /* 2395183 */ /*GILLT_nxv16s32*//*Label 34139*/ GIMT_Encode4(2397023), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2395195 */ /*GILLT_nxv32s16*//*Label 34140*/ GIMT_Encode4(2397133),
     /* 2395199 */ // Label 34123: @2395199
     /* 2395199 */ GIM_Try, /*On fail goto*//*Label 34142*/ GIMT_Encode4(2395320),
     /* 2395204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2395207 */   GIM_Try, /*On fail goto*//*Label 34143*/ GIMT_Encode4(2395235), // Rule ID 1998 //
     /* 2395212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2395215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2395219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2395223 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2395223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2395226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395234 */     // GIR_Coverage, 1998,
     /* 2395234 */     GIR_EraseRootFromParent_Done,
     /* 2395235 */   // Label 34143: @2395235
     /* 2395235 */   GIM_Try, /*On fail goto*//*Label 34144*/ GIMT_Encode4(2395263), // Rule ID 1999 //
     /* 2395240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2395243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2395247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2395251 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2395251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2395254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395262 */     // GIR_Coverage, 1999,
     /* 2395262 */     GIR_EraseRootFromParent_Done,
     /* 2395263 */   // Label 34144: @2395263
     /* 2395263 */   GIM_Try, /*On fail goto*//*Label 34145*/ GIMT_Encode4(2395291), // Rule ID 2031 //
     /* 2395268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2395271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2395275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2395279 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2395279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2395282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395290 */     // GIR_Coverage, 2031,
     /* 2395290 */     GIR_EraseRootFromParent_Done,
     /* 2395291 */   // Label 34145: @2395291
     /* 2395291 */   GIM_Try, /*On fail goto*//*Label 34146*/ GIMT_Encode4(2395319), // Rule ID 2032 //
     /* 2395296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2395299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2395303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2395307 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2395307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2395310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395318 */     // GIR_Coverage, 2032,
     /* 2395318 */     GIR_EraseRootFromParent_Done,
     /* 2395319 */   // Label 34146: @2395319
     /* 2395319 */   GIM_Reject,
     /* 2395320 */ // Label 34142: @2395320
     /* 2395320 */ GIM_Reject,
     /* 2395321 */ // Label 34124: @2395321
     /* 2395321 */ GIM_Try, /*On fail goto*//*Label 34147*/ GIMT_Encode4(2395442),
     /* 2395326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2395329 */   GIM_Try, /*On fail goto*//*Label 34148*/ GIMT_Encode4(2395357), // Rule ID 1289 //
     /* 2395334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2395337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2395341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2395345 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2395345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2395348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395356 */     // GIR_Coverage, 1289,
     /* 2395356 */     GIR_EraseRootFromParent_Done,
     /* 2395357 */   // Label 34148: @2395357
     /* 2395357 */   GIM_Try, /*On fail goto*//*Label 34149*/ GIMT_Encode4(2395385), // Rule ID 1290 //
     /* 2395362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2395365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2395369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2395373 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2395373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2395376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395384 */     // GIR_Coverage, 1290,
     /* 2395384 */     GIR_EraseRootFromParent_Done,
     /* 2395385 */   // Label 34149: @2395385
     /* 2395385 */   GIM_Try, /*On fail goto*//*Label 34150*/ GIMT_Encode4(2395413), // Rule ID 1297 //
     /* 2395390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2395393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2395397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2395401 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2395401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2395404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395412 */     // GIR_Coverage, 1297,
     /* 2395412 */     GIR_EraseRootFromParent_Done,
     /* 2395413 */   // Label 34150: @2395413
     /* 2395413 */   GIM_Try, /*On fail goto*//*Label 34151*/ GIMT_Encode4(2395441), // Rule ID 1298 //
     /* 2395418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2395421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2395425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2395429 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2395429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2395432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395440 */     // GIR_Coverage, 1298,
     /* 2395440 */     GIR_EraseRootFromParent_Done,
     /* 2395441 */   // Label 34151: @2395441
     /* 2395441 */   GIM_Reject,
     /* 2395442 */ // Label 34147: @2395442
     /* 2395442 */ GIM_Reject,
     /* 2395443 */ // Label 34125: @2395443
     /* 2395443 */ GIM_Try, /*On fail goto*//*Label 34152*/ GIMT_Encode4(2395592),
     /* 2395448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2395451 */   GIM_Try, /*On fail goto*//*Label 34153*/ GIMT_Encode4(2395479), // Rule ID 1632 //
     /* 2395456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2395459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395467 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2395467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2395470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395478 */     // GIR_Coverage, 1632,
     /* 2395478 */     GIR_EraseRootFromParent_Done,
     /* 2395479 */   // Label 34153: @2395479
     /* 2395479 */   GIM_Try, /*On fail goto*//*Label 34154*/ GIMT_Encode4(2395507), // Rule ID 1633 //
     /* 2395484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2395487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395495 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2395495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2395498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395506 */     // GIR_Coverage, 1633,
     /* 2395506 */     GIR_EraseRootFromParent_Done,
     /* 2395507 */   // Label 34154: @2395507
     /* 2395507 */   GIM_Try, /*On fail goto*//*Label 34155*/ GIMT_Encode4(2395535), // Rule ID 1666 //
     /* 2395512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2395515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2395519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2395523 */     // (fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2395523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2395526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395534 */     // GIR_Coverage, 1666,
     /* 2395534 */     GIR_EraseRootFromParent_Done,
     /* 2395535 */   // Label 34155: @2395535
     /* 2395535 */   GIM_Try, /*On fail goto*//*Label 34156*/ GIMT_Encode4(2395563), // Rule ID 1687 //
     /* 2395540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2395543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395551 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2395551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2395554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395562 */     // GIR_Coverage, 1687,
     /* 2395562 */     GIR_EraseRootFromParent_Done,
     /* 2395563 */   // Label 34156: @2395563
     /* 2395563 */   GIM_Try, /*On fail goto*//*Label 34157*/ GIMT_Encode4(2395591), // Rule ID 1688 //
     /* 2395568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2395571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395579 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2395579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2395582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395590 */     // GIR_Coverage, 1688,
     /* 2395590 */     GIR_EraseRootFromParent_Done,
     /* 2395591 */   // Label 34157: @2395591
     /* 2395591 */   GIM_Reject,
     /* 2395592 */ // Label 34152: @2395592
     /* 2395592 */ GIM_Reject,
     /* 2395593 */ // Label 34126: @2395593
     /* 2395593 */ GIM_Try, /*On fail goto*//*Label 34158*/ GIMT_Encode4(2395702),
     /* 2395598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395609 */   GIM_Try, /*On fail goto*//*Label 34159*/ GIMT_Encode4(2395655), // Rule ID 56250 //
     /* 2395614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395617 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2395620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2395634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395654 */     // GIR_Coverage, 56250,
     /* 2395654 */     GIR_EraseRootFromParent_Done,
     /* 2395655 */   // Label 34159: @2395655
     /* 2395655 */   GIM_Try, /*On fail goto*//*Label 34160*/ GIMT_Encode4(2395701), // Rule ID 56251 //
     /* 2395660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395663 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2395666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2395680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395700 */     // GIR_Coverage, 56251,
     /* 2395700 */     GIR_EraseRootFromParent_Done,
     /* 2395701 */   // Label 34160: @2395701
     /* 2395701 */   GIM_Reject,
     /* 2395702 */ // Label 34158: @2395702
     /* 2395702 */ GIM_Reject,
     /* 2395703 */ // Label 34127: @2395703
     /* 2395703 */ GIM_Try, /*On fail goto*//*Label 34161*/ GIMT_Encode4(2395812),
     /* 2395708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2395711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395719 */   GIM_Try, /*On fail goto*//*Label 34162*/ GIMT_Encode4(2395765), // Rule ID 56290 //
     /* 2395724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2395727 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2395730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2395744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395764 */     // GIR_Coverage, 56290,
     /* 2395764 */     GIR_EraseRootFromParent_Done,
     /* 2395765 */   // Label 34162: @2395765
     /* 2395765 */   GIM_Try, /*On fail goto*//*Label 34163*/ GIMT_Encode4(2395811), // Rule ID 56291 //
     /* 2395770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2395773 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2395776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2395790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395810 */     // GIR_Coverage, 56291,
     /* 2395810 */     GIR_EraseRootFromParent_Done,
     /* 2395811 */   // Label 34163: @2395811
     /* 2395811 */   GIM_Reject,
     /* 2395812 */ // Label 34161: @2395812
     /* 2395812 */ GIM_Reject,
     /* 2395813 */ // Label 34128: @2395813
     /* 2395813 */ GIM_Try, /*On fail goto*//*Label 34164*/ GIMT_Encode4(2395922),
     /* 2395818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2395821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395829 */   GIM_Try, /*On fail goto*//*Label 34165*/ GIMT_Encode4(2395875), // Rule ID 56350 //
     /* 2395834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2395837 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2395840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2395854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395874 */     // GIR_Coverage, 56350,
     /* 2395874 */     GIR_EraseRootFromParent_Done,
     /* 2395875 */   // Label 34165: @2395875
     /* 2395875 */   GIM_Try, /*On fail goto*//*Label 34166*/ GIMT_Encode4(2395921), // Rule ID 56351 //
     /* 2395880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395883 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2395886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2395900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395920 */     // GIR_Coverage, 56351,
     /* 2395920 */     GIR_EraseRootFromParent_Done,
     /* 2395921 */   // Label 34166: @2395921
     /* 2395921 */   GIM_Reject,
     /* 2395922 */ // Label 34164: @2395922
     /* 2395922 */ GIM_Reject,
     /* 2395923 */ // Label 34129: @2395923
     /* 2395923 */ GIM_Try, /*On fail goto*//*Label 34167*/ GIMT_Encode4(2396032),
     /* 2395928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2395931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395939 */   GIM_Try, /*On fail goto*//*Label 34168*/ GIMT_Encode4(2395985), // Rule ID 56270 //
     /* 2395944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395947 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2395950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2395964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395984 */     // GIR_Coverage, 56270,
     /* 2395984 */     GIR_EraseRootFromParent_Done,
     /* 2395985 */   // Label 34168: @2395985
     /* 2395985 */   GIM_Try, /*On fail goto*//*Label 34169*/ GIMT_Encode4(2396031), // Rule ID 56271 //
     /* 2395990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395993 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2395996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2396010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396030 */     // GIR_Coverage, 56271,
     /* 2396030 */     GIR_EraseRootFromParent_Done,
     /* 2396031 */   // Label 34169: @2396031
     /* 2396031 */   GIM_Reject,
     /* 2396032 */ // Label 34167: @2396032
     /* 2396032 */ GIM_Reject,
     /* 2396033 */ // Label 34130: @2396033
     /* 2396033 */ GIM_Try, /*On fail goto*//*Label 34170*/ GIMT_Encode4(2396142),
     /* 2396038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2396041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396049 */   GIM_Try, /*On fail goto*//*Label 34171*/ GIMT_Encode4(2396095), // Rule ID 56330 //
     /* 2396054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396057 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2396060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2396074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396094 */     // GIR_Coverage, 56330,
     /* 2396094 */     GIR_EraseRootFromParent_Done,
     /* 2396095 */   // Label 34171: @2396095
     /* 2396095 */   GIM_Try, /*On fail goto*//*Label 34172*/ GIMT_Encode4(2396141), // Rule ID 56331 //
     /* 2396100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396103 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2396106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2396120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396140 */     // GIR_Coverage, 56331,
     /* 2396140 */     GIR_EraseRootFromParent_Done,
     /* 2396141 */   // Label 34172: @2396141
     /* 2396141 */   GIM_Reject,
     /* 2396142 */ // Label 34170: @2396142
     /* 2396142 */ GIM_Reject,
     /* 2396143 */ // Label 34131: @2396143
     /* 2396143 */ GIM_Try, /*On fail goto*//*Label 34173*/ GIMT_Encode4(2396252),
     /* 2396148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2396151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396159 */   GIM_Try, /*On fail goto*//*Label 34174*/ GIMT_Encode4(2396205), // Rule ID 56490 //
     /* 2396164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396167 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2396170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2396184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396204 */     // GIR_Coverage, 56490,
     /* 2396204 */     GIR_EraseRootFromParent_Done,
     /* 2396205 */   // Label 34174: @2396205
     /* 2396205 */   GIM_Try, /*On fail goto*//*Label 34175*/ GIMT_Encode4(2396251), // Rule ID 56491 //
     /* 2396210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2396213 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2396216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2396230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396250 */     // GIR_Coverage, 56491,
     /* 2396250 */     GIR_EraseRootFromParent_Done,
     /* 2396251 */   // Label 34175: @2396251
     /* 2396251 */   GIM_Reject,
     /* 2396252 */ // Label 34173: @2396252
     /* 2396252 */ GIM_Reject,
     /* 2396253 */ // Label 34132: @2396253
     /* 2396253 */ GIM_Try, /*On fail goto*//*Label 34176*/ GIMT_Encode4(2396362),
     /* 2396258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2396261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396269 */   GIM_Try, /*On fail goto*//*Label 34177*/ GIMT_Encode4(2396315), // Rule ID 56310 //
     /* 2396274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396277 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2396280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2396294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396314 */     // GIR_Coverage, 56310,
     /* 2396314 */     GIR_EraseRootFromParent_Done,
     /* 2396315 */   // Label 34177: @2396315
     /* 2396315 */   GIM_Try, /*On fail goto*//*Label 34178*/ GIMT_Encode4(2396361), // Rule ID 56311 //
     /* 2396320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396323 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2396326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2396340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396360 */     // GIR_Coverage, 56311,
     /* 2396360 */     GIR_EraseRootFromParent_Done,
     /* 2396361 */   // Label 34178: @2396361
     /* 2396361 */   GIM_Reject,
     /* 2396362 */ // Label 34176: @2396362
     /* 2396362 */ GIM_Reject,
     /* 2396363 */ // Label 34133: @2396363
     /* 2396363 */ GIM_Try, /*On fail goto*//*Label 34179*/ GIMT_Encode4(2396472),
     /* 2396368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396379 */   GIM_Try, /*On fail goto*//*Label 34180*/ GIMT_Encode4(2396425), // Rule ID 56430 //
     /* 2396384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396387 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2396390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2396404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396424 */     // GIR_Coverage, 56430,
     /* 2396424 */     GIR_EraseRootFromParent_Done,
     /* 2396425 */   // Label 34180: @2396425
     /* 2396425 */   GIM_Try, /*On fail goto*//*Label 34181*/ GIMT_Encode4(2396471), // Rule ID 56431 //
     /* 2396430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396433 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2396436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2396450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396470 */     // GIR_Coverage, 56431,
     /* 2396470 */     GIR_EraseRootFromParent_Done,
     /* 2396471 */   // Label 34181: @2396471
     /* 2396471 */   GIM_Reject,
     /* 2396472 */ // Label 34179: @2396472
     /* 2396472 */ GIM_Reject,
     /* 2396473 */ // Label 34134: @2396473
     /* 2396473 */ GIM_Try, /*On fail goto*//*Label 34182*/ GIMT_Encode4(2396582),
     /* 2396478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2396481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396489 */   GIM_Try, /*On fail goto*//*Label 34183*/ GIMT_Encode4(2396535), // Rule ID 56510 //
     /* 2396494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396497 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2396500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2396514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396534 */     // GIR_Coverage, 56510,
     /* 2396534 */     GIR_EraseRootFromParent_Done,
     /* 2396535 */   // Label 34183: @2396535
     /* 2396535 */   GIM_Try, /*On fail goto*//*Label 34184*/ GIMT_Encode4(2396581), // Rule ID 56511 //
     /* 2396540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2396543 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2396546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2396560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396580 */     // GIR_Coverage, 56511,
     /* 2396580 */     GIR_EraseRootFromParent_Done,
     /* 2396581 */   // Label 34184: @2396581
     /* 2396581 */   GIM_Reject,
     /* 2396582 */ // Label 34182: @2396582
     /* 2396582 */ GIM_Reject,
     /* 2396583 */ // Label 34135: @2396583
     /* 2396583 */ GIM_Try, /*On fail goto*//*Label 34185*/ GIMT_Encode4(2396692),
     /* 2396588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2396591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396599 */   GIM_Try, /*On fail goto*//*Label 34186*/ GIMT_Encode4(2396645), // Rule ID 56370 //
     /* 2396604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396607 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2396610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2396624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396644 */     // GIR_Coverage, 56370,
     /* 2396644 */     GIR_EraseRootFromParent_Done,
     /* 2396645 */   // Label 34186: @2396645
     /* 2396645 */   GIM_Try, /*On fail goto*//*Label 34187*/ GIMT_Encode4(2396691), // Rule ID 56371 //
     /* 2396650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396653 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2396656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2396670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396690 */     // GIR_Coverage, 56371,
     /* 2396690 */     GIR_EraseRootFromParent_Done,
     /* 2396691 */   // Label 34187: @2396691
     /* 2396691 */   GIM_Reject,
     /* 2396692 */ // Label 34185: @2396692
     /* 2396692 */ GIM_Reject,
     /* 2396693 */ // Label 34136: @2396693
     /* 2396693 */ GIM_Try, /*On fail goto*//*Label 34188*/ GIMT_Encode4(2396802),
     /* 2396698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2396701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396709 */   GIM_Try, /*On fail goto*//*Label 34189*/ GIMT_Encode4(2396755), // Rule ID 56450 //
     /* 2396714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396717 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2396720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2396734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396754 */     // GIR_Coverage, 56450,
     /* 2396754 */     GIR_EraseRootFromParent_Done,
     /* 2396755 */   // Label 34189: @2396755
     /* 2396755 */   GIM_Try, /*On fail goto*//*Label 34190*/ GIMT_Encode4(2396801), // Rule ID 56451 //
     /* 2396760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396763 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2396766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2396780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396800 */     // GIR_Coverage, 56451,
     /* 2396800 */     GIR_EraseRootFromParent_Done,
     /* 2396801 */   // Label 34190: @2396801
     /* 2396801 */   GIM_Reject,
     /* 2396802 */ // Label 34188: @2396802
     /* 2396802 */ GIM_Reject,
     /* 2396803 */ // Label 34137: @2396803
     /* 2396803 */ GIM_Try, /*On fail goto*//*Label 34191*/ GIMT_Encode4(2396912),
     /* 2396808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2396811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396819 */   GIM_Try, /*On fail goto*//*Label 34192*/ GIMT_Encode4(2396865), // Rule ID 56530 //
     /* 2396824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396827 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2396830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2396844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396864 */     // GIR_Coverage, 56530,
     /* 2396864 */     GIR_EraseRootFromParent_Done,
     /* 2396865 */   // Label 34192: @2396865
     /* 2396865 */   GIM_Try, /*On fail goto*//*Label 34193*/ GIMT_Encode4(2396911), // Rule ID 56531 //
     /* 2396870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2396873 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2396876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2396890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396910 */     // GIR_Coverage, 56531,
     /* 2396910 */     GIR_EraseRootFromParent_Done,
     /* 2396911 */   // Label 34193: @2396911
     /* 2396911 */   GIM_Reject,
     /* 2396912 */ // Label 34191: @2396912
     /* 2396912 */ GIM_Reject,
     /* 2396913 */ // Label 34138: @2396913
     /* 2396913 */ GIM_Try, /*On fail goto*//*Label 34194*/ GIMT_Encode4(2397022),
     /* 2396918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2396921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396929 */   GIM_Try, /*On fail goto*//*Label 34195*/ GIMT_Encode4(2396975), // Rule ID 56390 //
     /* 2396934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396937 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2396940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2396954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396974 */     // GIR_Coverage, 56390,
     /* 2396974 */     GIR_EraseRootFromParent_Done,
     /* 2396975 */   // Label 34195: @2396975
     /* 2396975 */   GIM_Try, /*On fail goto*//*Label 34196*/ GIMT_Encode4(2397021), // Rule ID 56391 //
     /* 2396980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396983 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2396986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2397000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2397007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397020 */     // GIR_Coverage, 56391,
     /* 2397020 */     GIR_EraseRootFromParent_Done,
     /* 2397021 */   // Label 34196: @2397021
     /* 2397021 */   GIM_Reject,
     /* 2397022 */ // Label 34194: @2397022
     /* 2397022 */ GIM_Reject,
     /* 2397023 */ // Label 34139: @2397023
     /* 2397023 */ GIM_Try, /*On fail goto*//*Label 34197*/ GIMT_Encode4(2397132),
     /* 2397028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2397031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2397035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2397039 */   GIM_Try, /*On fail goto*//*Label 34198*/ GIMT_Encode4(2397085), // Rule ID 56470 //
     /* 2397044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2397047 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2397050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2397064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2397071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397084 */     // GIR_Coverage, 56470,
     /* 2397084 */     GIR_EraseRootFromParent_Done,
     /* 2397085 */   // Label 34198: @2397085
     /* 2397085 */   GIM_Try, /*On fail goto*//*Label 34199*/ GIMT_Encode4(2397131), // Rule ID 56471 //
     /* 2397090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2397093 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2397096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2397110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2397117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397130 */     // GIR_Coverage, 56471,
     /* 2397130 */     GIR_EraseRootFromParent_Done,
     /* 2397131 */   // Label 34199: @2397131
     /* 2397131 */   GIM_Reject,
     /* 2397132 */ // Label 34197: @2397132
     /* 2397132 */ GIM_Reject,
     /* 2397133 */ // Label 34140: @2397133
     /* 2397133 */ GIM_Try, /*On fail goto*//*Label 34200*/ GIMT_Encode4(2397242),
     /* 2397138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2397141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2397145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2397149 */   GIM_Try, /*On fail goto*//*Label 34201*/ GIMT_Encode4(2397195), // Rule ID 56410 //
     /* 2397154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397157 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2397160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2397174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2397181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397194 */     // GIR_Coverage, 56410,
     /* 2397194 */     GIR_EraseRootFromParent_Done,
     /* 2397195 */   // Label 34201: @2397195
     /* 2397195 */   GIM_Try, /*On fail goto*//*Label 34202*/ GIMT_Encode4(2397241), // Rule ID 56411 //
     /* 2397200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397203 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2397206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2397220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2397227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397240 */     // GIR_Coverage, 56411,
     /* 2397240 */     GIR_EraseRootFromParent_Done,
     /* 2397241 */   // Label 34202: @2397241
     /* 2397241 */   GIM_Reject,
     /* 2397242 */ // Label 34200: @2397242
     /* 2397242 */ GIM_Reject,
     /* 2397243 */ // Label 34141: @2397243
     /* 2397243 */ GIM_Reject,
     /* 2397244 */ // Label 95: @2397244
     /* 2397244 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34206*/ GIMT_Encode4(2397441),
     /* 2397255 */ /*GILLT_s16*//*Label 34203*/ GIMT_Encode4(2397267),
     /* 2397259 */ /*GILLT_s32*//*Label 34204*/ GIMT_Encode4(2397325),
     /* 2397263 */ /*GILLT_s64*//*Label 34205*/ GIMT_Encode4(2397383),
     /* 2397267 */ // Label 34203: @2397267
     /* 2397267 */ GIM_Try, /*On fail goto*//*Label 34207*/ GIMT_Encode4(2397324),
     /* 2397272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2397275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397283 */   GIM_Try, /*On fail goto*//*Label 34208*/ GIMT_Encode4(2397303), // Rule ID 2436 //
     /* 2397288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2397291 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i64] })
     /* 2397291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2397294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2397301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397302 */     // GIR_Coverage, 2436,
     /* 2397302 */     GIR_EraseRootFromParent_Done,
     /* 2397303 */   // Label 34208: @2397303
     /* 2397303 */   GIM_Try, /*On fail goto*//*Label 34209*/ GIMT_Encode4(2397323), // Rule ID 2437 //
     /* 2397308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2397311 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i32] })
     /* 2397311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2397314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2397321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397322 */     // GIR_Coverage, 2437,
     /* 2397322 */     GIR_EraseRootFromParent_Done,
     /* 2397323 */   // Label 34209: @2397323
     /* 2397323 */   GIM_Reject,
     /* 2397324 */ // Label 34207: @2397324
     /* 2397324 */ GIM_Reject,
     /* 2397325 */ // Label 34204: @2397325
     /* 2397325 */ GIM_Try, /*On fail goto*//*Label 34210*/ GIMT_Encode4(2397382),
     /* 2397330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2397333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397341 */   GIM_Try, /*On fail goto*//*Label 34211*/ GIMT_Encode4(2397361), // Rule ID 2354 //
     /* 2397346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2397349 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i64] })
     /* 2397349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2397352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2397359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397360 */     // GIR_Coverage, 2354,
     /* 2397360 */     GIR_EraseRootFromParent_Done,
     /* 2397361 */   // Label 34211: @2397361
     /* 2397361 */   GIM_Try, /*On fail goto*//*Label 34212*/ GIMT_Encode4(2397381), // Rule ID 2355 //
     /* 2397366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2397369 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i32] })
     /* 2397369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2397372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2397379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397380 */     // GIR_Coverage, 2355,
     /* 2397380 */     GIR_EraseRootFromParent_Done,
     /* 2397381 */   // Label 34212: @2397381
     /* 2397381 */   GIM_Reject,
     /* 2397382 */ // Label 34210: @2397382
     /* 2397382 */ GIM_Reject,
     /* 2397383 */ // Label 34205: @2397383
     /* 2397383 */ GIM_Try, /*On fail goto*//*Label 34213*/ GIMT_Encode4(2397440),
     /* 2397388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2397391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397399 */   GIM_Try, /*On fail goto*//*Label 34214*/ GIMT_Encode4(2397419), // Rule ID 2394 //
     /* 2397404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2397407 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i64] })
     /* 2397407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2397410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2397417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397418 */     // GIR_Coverage, 2394,
     /* 2397418 */     GIR_EraseRootFromParent_Done,
     /* 2397419 */   // Label 34214: @2397419
     /* 2397419 */   GIM_Try, /*On fail goto*//*Label 34215*/ GIMT_Encode4(2397439), // Rule ID 2395 //
     /* 2397424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2397427 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i32] })
     /* 2397427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2397430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2397437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397438 */     // GIR_Coverage, 2395,
     /* 2397438 */     GIR_EraseRootFromParent_Done,
     /* 2397439 */   // Label 34215: @2397439
     /* 2397439 */   GIM_Reject,
     /* 2397440 */ // Label 34213: @2397440
     /* 2397440 */ GIM_Reject,
     /* 2397441 */ // Label 34206: @2397441
     /* 2397441 */ GIM_Reject,
     /* 2397442 */ // Label 96: @2397442
     /* 2397442 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34219*/ GIMT_Encode4(2397639),
     /* 2397453 */ /*GILLT_s16*//*Label 34216*/ GIMT_Encode4(2397465),
     /* 2397457 */ /*GILLT_s32*//*Label 34217*/ GIMT_Encode4(2397523),
     /* 2397461 */ /*GILLT_s64*//*Label 34218*/ GIMT_Encode4(2397581),
     /* 2397465 */ // Label 34216: @2397465
     /* 2397465 */ GIM_Try, /*On fail goto*//*Label 34220*/ GIMT_Encode4(2397522),
     /* 2397470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2397473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397481 */   GIM_Try, /*On fail goto*//*Label 34221*/ GIMT_Encode4(2397501), // Rule ID 2420 //
     /* 2397486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2397489 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2397489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2397492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397500 */     // GIR_Coverage, 2420,
     /* 2397500 */     GIR_EraseRootFromParent_Done,
     /* 2397501 */   // Label 34221: @2397501
     /* 2397501 */   GIM_Try, /*On fail goto*//*Label 34222*/ GIMT_Encode4(2397521), // Rule ID 2421 //
     /* 2397506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2397509 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2397509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2397512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397520 */     // GIR_Coverage, 2421,
     /* 2397520 */     GIR_EraseRootFromParent_Done,
     /* 2397521 */   // Label 34222: @2397521
     /* 2397521 */   GIM_Reject,
     /* 2397522 */ // Label 34220: @2397522
     /* 2397522 */ GIM_Reject,
     /* 2397523 */ // Label 34217: @2397523
     /* 2397523 */ GIM_Try, /*On fail goto*//*Label 34223*/ GIMT_Encode4(2397580),
     /* 2397528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2397531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397539 */   GIM_Try, /*On fail goto*//*Label 34224*/ GIMT_Encode4(2397559), // Rule ID 2338 //
     /* 2397544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2397547 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2397547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2397550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397558 */     // GIR_Coverage, 2338,
     /* 2397558 */     GIR_EraseRootFromParent_Done,
     /* 2397559 */   // Label 34224: @2397559
     /* 2397559 */   GIM_Try, /*On fail goto*//*Label 34225*/ GIMT_Encode4(2397579), // Rule ID 2339 //
     /* 2397564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2397567 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2397567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2397570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397578 */     // GIR_Coverage, 2339,
     /* 2397578 */     GIR_EraseRootFromParent_Done,
     /* 2397579 */   // Label 34225: @2397579
     /* 2397579 */   GIM_Reject,
     /* 2397580 */ // Label 34223: @2397580
     /* 2397580 */ GIM_Reject,
     /* 2397581 */ // Label 34218: @2397581
     /* 2397581 */ GIM_Try, /*On fail goto*//*Label 34226*/ GIMT_Encode4(2397638),
     /* 2397586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2397589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397597 */   GIM_Try, /*On fail goto*//*Label 34227*/ GIMT_Encode4(2397617), // Rule ID 2378 //
     /* 2397602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2397605 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2397605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2397608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397616 */     // GIR_Coverage, 2378,
     /* 2397616 */     GIR_EraseRootFromParent_Done,
     /* 2397617 */   // Label 34227: @2397617
     /* 2397617 */   GIM_Try, /*On fail goto*//*Label 34228*/ GIMT_Encode4(2397637), // Rule ID 2379 //
     /* 2397622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2397625 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2397625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2397628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397636 */     // GIR_Coverage, 2379,
     /* 2397636 */     GIR_EraseRootFromParent_Done,
     /* 2397637 */   // Label 34228: @2397637
     /* 2397637 */   GIM_Reject,
     /* 2397638 */ // Label 34226: @2397638
     /* 2397638 */ GIM_Reject,
     /* 2397639 */ // Label 34219: @2397639
     /* 2397639 */ GIM_Reject,
     /* 2397640 */ // Label 97: @2397640
     /* 2397640 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34232*/ GIMT_Encode4(2397837),
     /* 2397651 */ /*GILLT_s16*//*Label 34229*/ GIMT_Encode4(2397663),
     /* 2397655 */ /*GILLT_s32*//*Label 34230*/ GIMT_Encode4(2397721),
     /* 2397659 */ /*GILLT_s64*//*Label 34231*/ GIMT_Encode4(2397779),
     /* 2397663 */ // Label 34229: @2397663
     /* 2397663 */ GIM_Try, /*On fail goto*//*Label 34233*/ GIMT_Encode4(2397720),
     /* 2397668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2397671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397679 */   GIM_Try, /*On fail goto*//*Label 34234*/ GIMT_Encode4(2397699), // Rule ID 2424 //
     /* 2397684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2397687 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2397687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2397690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397698 */     // GIR_Coverage, 2424,
     /* 2397698 */     GIR_EraseRootFromParent_Done,
     /* 2397699 */   // Label 34234: @2397699
     /* 2397699 */   GIM_Try, /*On fail goto*//*Label 34235*/ GIMT_Encode4(2397719), // Rule ID 2425 //
     /* 2397704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2397707 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2397707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2397710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397718 */     // GIR_Coverage, 2425,
     /* 2397718 */     GIR_EraseRootFromParent_Done,
     /* 2397719 */   // Label 34235: @2397719
     /* 2397719 */   GIM_Reject,
     /* 2397720 */ // Label 34233: @2397720
     /* 2397720 */ GIM_Reject,
     /* 2397721 */ // Label 34230: @2397721
     /* 2397721 */ GIM_Try, /*On fail goto*//*Label 34236*/ GIMT_Encode4(2397778),
     /* 2397726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2397729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397737 */   GIM_Try, /*On fail goto*//*Label 34237*/ GIMT_Encode4(2397757), // Rule ID 2342 //
     /* 2397742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2397745 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2397745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2397748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397756 */     // GIR_Coverage, 2342,
     /* 2397756 */     GIR_EraseRootFromParent_Done,
     /* 2397757 */   // Label 34237: @2397757
     /* 2397757 */   GIM_Try, /*On fail goto*//*Label 34238*/ GIMT_Encode4(2397777), // Rule ID 2343 //
     /* 2397762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2397765 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2397765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2397768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397776 */     // GIR_Coverage, 2343,
     /* 2397776 */     GIR_EraseRootFromParent_Done,
     /* 2397777 */   // Label 34238: @2397777
     /* 2397777 */   GIM_Reject,
     /* 2397778 */ // Label 34236: @2397778
     /* 2397778 */ GIM_Reject,
     /* 2397779 */ // Label 34231: @2397779
     /* 2397779 */ GIM_Try, /*On fail goto*//*Label 34239*/ GIMT_Encode4(2397836),
     /* 2397784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2397787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397795 */   GIM_Try, /*On fail goto*//*Label 34240*/ GIMT_Encode4(2397815), // Rule ID 2382 //
     /* 2397800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2397803 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2397803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2397806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397814 */     // GIR_Coverage, 2382,
     /* 2397814 */     GIR_EraseRootFromParent_Done,
     /* 2397815 */   // Label 34240: @2397815
     /* 2397815 */   GIM_Try, /*On fail goto*//*Label 34241*/ GIMT_Encode4(2397835), // Rule ID 2383 //
     /* 2397820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2397823 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2397823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2397826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397834 */     // GIR_Coverage, 2383,
     /* 2397834 */     GIR_EraseRootFromParent_Done,
     /* 2397835 */   // Label 34241: @2397835
     /* 2397835 */   GIM_Reject,
     /* 2397836 */ // Label 34239: @2397836
     /* 2397836 */ GIM_Reject,
     /* 2397837 */ // Label 34232: @2397837
     /* 2397837 */ GIM_Reject,
     /* 2397838 */ // Label 98: @2397838
     /* 2397838 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34260*/ GIMT_Encode4(2400265),
     /* 2397849 */ /*GILLT_s16*//*Label 34242*/ GIMT_Encode4(2397969),
     /* 2397853 */ /*GILLT_s32*//*Label 34243*/ GIMT_Encode4(2398118),
     /* 2397857 */ /*GILLT_s64*//*Label 34244*/ GIMT_Encode4(2398267), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397869 */ /*GILLT_nxv1s16*//*Label 34245*/ GIMT_Encode4(2398450),
     /* 2397873 */ /*GILLT_nxv1s32*//*Label 34246*/ GIMT_Encode4(2398571),
     /* 2397877 */ /*GILLT_nxv1s64*//*Label 34247*/ GIMT_Encode4(2398692), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397889 */ /*GILLT_nxv2s16*//*Label 34248*/ GIMT_Encode4(2398813),
     /* 2397893 */ /*GILLT_nxv2s32*//*Label 34249*/ GIMT_Encode4(2398934),
     /* 2397897 */ /*GILLT_nxv2s64*//*Label 34250*/ GIMT_Encode4(2399055), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397909 */ /*GILLT_nxv4s16*//*Label 34251*/ GIMT_Encode4(2399176),
     /* 2397913 */ /*GILLT_nxv4s32*//*Label 34252*/ GIMT_Encode4(2399297),
     /* 2397917 */ /*GILLT_nxv4s64*//*Label 34253*/ GIMT_Encode4(2399418), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397929 */ /*GILLT_nxv8s16*//*Label 34254*/ GIMT_Encode4(2399539),
     /* 2397933 */ /*GILLT_nxv8s32*//*Label 34255*/ GIMT_Encode4(2399660),
     /* 2397937 */ /*GILLT_nxv8s64*//*Label 34256*/ GIMT_Encode4(2399781), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397949 */ /*GILLT_nxv16s16*//*Label 34257*/ GIMT_Encode4(2399902),
     /* 2397953 */ /*GILLT_nxv16s32*//*Label 34258*/ GIMT_Encode4(2400023), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397965 */ /*GILLT_nxv32s16*//*Label 34259*/ GIMT_Encode4(2400144),
     /* 2397969 */ // Label 34242: @2397969
     /* 2397969 */ GIM_Try, /*On fail goto*//*Label 34261*/ GIMT_Encode4(2398117),
     /* 2397974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2397977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2397980 */   GIM_Try, /*On fail goto*//*Label 34262*/ GIMT_Encode4(2398014), // Rule ID 1964 //
     /* 2397985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2397988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398000 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2398000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2398003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398013 */     // GIR_Coverage, 1964,
     /* 2398013 */     GIR_EraseRootFromParent_Done,
     /* 2398014 */   // Label 34262: @2398014
     /* 2398014 */   GIM_Try, /*On fail goto*//*Label 34263*/ GIMT_Encode4(2398048), // Rule ID 1965 //
     /* 2398019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2398022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398034 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2398034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2398037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398047 */     // GIR_Coverage, 1965,
     /* 2398047 */     GIR_EraseRootFromParent_Done,
     /* 2398048 */   // Label 34263: @2398048
     /* 2398048 */   GIM_Try, /*On fail goto*//*Label 34264*/ GIMT_Encode4(2398082), // Rule ID 1968 //
     /* 2398053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2398056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2398060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2398064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2398068 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2398068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2398071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398081 */     // GIR_Coverage, 1968,
     /* 2398081 */     GIR_EraseRootFromParent_Done,
     /* 2398082 */   // Label 34264: @2398082
     /* 2398082 */   GIM_Try, /*On fail goto*//*Label 34265*/ GIMT_Encode4(2398116), // Rule ID 1969 //
     /* 2398087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2398090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2398094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2398098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2398102 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2398102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2398105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398115 */     // GIR_Coverage, 1969,
     /* 2398115 */     GIR_EraseRootFromParent_Done,
     /* 2398116 */   // Label 34265: @2398116
     /* 2398116 */   GIM_Reject,
     /* 2398117 */ // Label 34261: @2398117
     /* 2398117 */ GIM_Reject,
     /* 2398118 */ // Label 34243: @2398118
     /* 2398118 */ GIM_Try, /*On fail goto*//*Label 34266*/ GIMT_Encode4(2398266),
     /* 2398123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2398126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2398129 */   GIM_Try, /*On fail goto*//*Label 34267*/ GIMT_Encode4(2398163), // Rule ID 1255 //
     /* 2398134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2398137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2398141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2398145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2398149 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2398149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2398152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398162 */     // GIR_Coverage, 1255,
     /* 2398162 */     GIR_EraseRootFromParent_Done,
     /* 2398163 */   // Label 34267: @2398163
     /* 2398163 */   GIM_Try, /*On fail goto*//*Label 34268*/ GIMT_Encode4(2398197), // Rule ID 1256 //
     /* 2398168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2398171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2398175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2398179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2398183 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2398183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2398186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398196 */     // GIR_Coverage, 1256,
     /* 2398196 */     GIR_EraseRootFromParent_Done,
     /* 2398197 */   // Label 34268: @2398197
     /* 2398197 */   GIM_Try, /*On fail goto*//*Label 34269*/ GIMT_Encode4(2398231), // Rule ID 1259 //
     /* 2398202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2398205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2398209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2398213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2398217 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2398217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2398220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398230 */     // GIR_Coverage, 1259,
     /* 2398230 */     GIR_EraseRootFromParent_Done,
     /* 2398231 */   // Label 34269: @2398231
     /* 2398231 */   GIM_Try, /*On fail goto*//*Label 34270*/ GIMT_Encode4(2398265), // Rule ID 1260 //
     /* 2398236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2398239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2398243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2398247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2398251 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2398251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2398254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398264 */     // GIR_Coverage, 1260,
     /* 2398264 */     GIR_EraseRootFromParent_Done,
     /* 2398265 */   // Label 34270: @2398265
     /* 2398265 */   GIM_Reject,
     /* 2398266 */ // Label 34266: @2398266
     /* 2398266 */ GIM_Reject,
     /* 2398267 */ // Label 34244: @2398267
     /* 2398267 */ GIM_Try, /*On fail goto*//*Label 34271*/ GIMT_Encode4(2398449),
     /* 2398272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2398275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2398278 */   GIM_Try, /*On fail goto*//*Label 34272*/ GIMT_Encode4(2398312), // Rule ID 1590 //
     /* 2398283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2398286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2398290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2398294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2398298 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2398298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2398301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398311 */     // GIR_Coverage, 1590,
     /* 2398311 */     GIR_EraseRootFromParent_Done,
     /* 2398312 */   // Label 34272: @2398312
     /* 2398312 */   GIM_Try, /*On fail goto*//*Label 34273*/ GIMT_Encode4(2398346), // Rule ID 1591 //
     /* 2398317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2398320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2398324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2398328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2398332 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2398332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2398335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398345 */     // GIR_Coverage, 1591,
     /* 2398345 */     GIR_EraseRootFromParent_Done,
     /* 2398346 */   // Label 34273: @2398346
     /* 2398346 */   GIM_Try, /*On fail goto*//*Label 34274*/ GIMT_Encode4(2398380), // Rule ID 1594 //
     /* 2398351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2398354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2398358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2398362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2398366 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2398366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2398369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398379 */     // GIR_Coverage, 1594,
     /* 2398379 */     GIR_EraseRootFromParent_Done,
     /* 2398380 */   // Label 34274: @2398380
     /* 2398380 */   GIM_Try, /*On fail goto*//*Label 34275*/ GIMT_Encode4(2398414), // Rule ID 1595 //
     /* 2398385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2398388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2398392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2398396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2398400 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2398400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2398403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398413 */     // GIR_Coverage, 1595,
     /* 2398413 */     GIR_EraseRootFromParent_Done,
     /* 2398414 */   // Label 34275: @2398414
     /* 2398414 */   GIM_Try, /*On fail goto*//*Label 34276*/ GIMT_Encode4(2398448), // Rule ID 1598 //
     /* 2398419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2398422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2398426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2398430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2398434 */     // (strict_fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2398434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2398437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398447 */     // GIR_Coverage, 1598,
     /* 2398447 */     GIR_EraseRootFromParent_Done,
     /* 2398448 */   // Label 34276: @2398448
     /* 2398448 */   GIM_Reject,
     /* 2398449 */ // Label 34271: @2398449
     /* 2398449 */ GIM_Reject,
     /* 2398450 */ // Label 34245: @2398450
     /* 2398450 */ GIM_Try, /*On fail goto*//*Label 34277*/ GIMT_Encode4(2398570),
     /* 2398455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2398458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2398461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398473 */   GIM_Try, /*On fail goto*//*Label 34278*/ GIMT_Encode4(2398521), // Rule ID 45770 //
     /* 2398478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398481 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2398484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2398498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398520 */     // GIR_Coverage, 45770,
     /* 2398520 */     GIR_EraseRootFromParent_Done,
     /* 2398521 */   // Label 34278: @2398521
     /* 2398521 */   GIM_Try, /*On fail goto*//*Label 34279*/ GIMT_Encode4(2398569), // Rule ID 45771 //
     /* 2398526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398529 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2398532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2398546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398568 */     // GIR_Coverage, 45771,
     /* 2398568 */     GIR_EraseRootFromParent_Done,
     /* 2398569 */   // Label 34279: @2398569
     /* 2398569 */   GIM_Reject,
     /* 2398570 */ // Label 34277: @2398570
     /* 2398570 */ GIM_Reject,
     /* 2398571 */ // Label 34246: @2398571
     /* 2398571 */ GIM_Try, /*On fail goto*//*Label 34280*/ GIMT_Encode4(2398691),
     /* 2398576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2398579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2398582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398594 */   GIM_Try, /*On fail goto*//*Label 34281*/ GIMT_Encode4(2398642), // Rule ID 53310 //
     /* 2398599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398602 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2398605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2398619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398641 */     // GIR_Coverage, 53310,
     /* 2398641 */     GIR_EraseRootFromParent_Done,
     /* 2398642 */   // Label 34281: @2398642
     /* 2398642 */   GIM_Try, /*On fail goto*//*Label 34282*/ GIMT_Encode4(2398690), // Rule ID 53311 //
     /* 2398647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398650 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2398653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2398667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398689 */     // GIR_Coverage, 53311,
     /* 2398689 */     GIR_EraseRootFromParent_Done,
     /* 2398690 */   // Label 34282: @2398690
     /* 2398690 */   GIM_Reject,
     /* 2398691 */ // Label 34280: @2398691
     /* 2398691 */ GIM_Reject,
     /* 2398692 */ // Label 34247: @2398692
     /* 2398692 */ GIM_Try, /*On fail goto*//*Label 34283*/ GIMT_Encode4(2398812),
     /* 2398697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2398700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2398703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398715 */   GIM_Try, /*On fail goto*//*Label 34284*/ GIMT_Encode4(2398763), // Rule ID 53346 //
     /* 2398720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2398723 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2398726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2398740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398762 */     // GIR_Coverage, 53346,
     /* 2398762 */     GIR_EraseRootFromParent_Done,
     /* 2398763 */   // Label 34284: @2398763
     /* 2398763 */   GIM_Try, /*On fail goto*//*Label 34285*/ GIMT_Encode4(2398811), // Rule ID 53347 //
     /* 2398768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2398771 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2398774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2398788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398810 */     // GIR_Coverage, 53347,
     /* 2398810 */     GIR_EraseRootFromParent_Done,
     /* 2398811 */   // Label 34285: @2398811
     /* 2398811 */   GIM_Reject,
     /* 2398812 */ // Label 34283: @2398812
     /* 2398812 */ GIM_Reject,
     /* 2398813 */ // Label 34248: @2398813
     /* 2398813 */ GIM_Try, /*On fail goto*//*Label 34286*/ GIMT_Encode4(2398933),
     /* 2398818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2398821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2398824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398836 */   GIM_Try, /*On fail goto*//*Label 34287*/ GIMT_Encode4(2398884), // Rule ID 53298 //
     /* 2398841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398844 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2398847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2398861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398883 */     // GIR_Coverage, 53298,
     /* 2398883 */     GIR_EraseRootFromParent_Done,
     /* 2398884 */   // Label 34287: @2398884
     /* 2398884 */   GIM_Try, /*On fail goto*//*Label 34288*/ GIMT_Encode4(2398932), // Rule ID 53299 //
     /* 2398889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398892 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2398895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2398909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398931 */     // GIR_Coverage, 53299,
     /* 2398931 */     GIR_EraseRootFromParent_Done,
     /* 2398932 */   // Label 34288: @2398932
     /* 2398932 */   GIM_Reject,
     /* 2398933 */ // Label 34286: @2398933
     /* 2398933 */ GIM_Reject,
     /* 2398934 */ // Label 34249: @2398934
     /* 2398934 */ GIM_Try, /*On fail goto*//*Label 34289*/ GIMT_Encode4(2399054),
     /* 2398939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2398945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398957 */   GIM_Try, /*On fail goto*//*Label 34290*/ GIMT_Encode4(2399005), // Rule ID 53334 //
     /* 2398962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398965 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2398968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2398982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399004 */     // GIR_Coverage, 53334,
     /* 2399004 */     GIR_EraseRootFromParent_Done,
     /* 2399005 */   // Label 34290: @2399005
     /* 2399005 */   GIM_Try, /*On fail goto*//*Label 34291*/ GIMT_Encode4(2399053), // Rule ID 53335 //
     /* 2399010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399013 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2399016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2399030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399052 */     // GIR_Coverage, 53335,
     /* 2399052 */     GIR_EraseRootFromParent_Done,
     /* 2399053 */   // Label 34291: @2399053
     /* 2399053 */   GIM_Reject,
     /* 2399054 */ // Label 34289: @2399054
     /* 2399054 */ GIM_Reject,
     /* 2399055 */ // Label 34250: @2399055
     /* 2399055 */ GIM_Try, /*On fail goto*//*Label 34292*/ GIMT_Encode4(2399175),
     /* 2399060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2399066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399078 */   GIM_Try, /*On fail goto*//*Label 34293*/ GIMT_Encode4(2399126), // Rule ID 53430 //
     /* 2399083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399086 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2399089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2399103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399125 */     // GIR_Coverage, 53430,
     /* 2399125 */     GIR_EraseRootFromParent_Done,
     /* 2399126 */   // Label 34293: @2399126
     /* 2399126 */   GIM_Try, /*On fail goto*//*Label 34294*/ GIMT_Encode4(2399174), // Rule ID 53431 //
     /* 2399131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399134 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2399137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2399151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399173 */     // GIR_Coverage, 53431,
     /* 2399173 */     GIR_EraseRootFromParent_Done,
     /* 2399174 */   // Label 34294: @2399174
     /* 2399174 */   GIM_Reject,
     /* 2399175 */ // Label 34292: @2399175
     /* 2399175 */ GIM_Reject,
     /* 2399176 */ // Label 34251: @2399176
     /* 2399176 */ GIM_Try, /*On fail goto*//*Label 34295*/ GIMT_Encode4(2399296),
     /* 2399181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2399184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2399187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399199 */   GIM_Try, /*On fail goto*//*Label 34296*/ GIMT_Encode4(2399247), // Rule ID 53322 //
     /* 2399204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399207 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2399210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2399224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399246 */     // GIR_Coverage, 53322,
     /* 2399246 */     GIR_EraseRootFromParent_Done,
     /* 2399247 */   // Label 34296: @2399247
     /* 2399247 */   GIM_Try, /*On fail goto*//*Label 34297*/ GIMT_Encode4(2399295), // Rule ID 53323 //
     /* 2399252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399255 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2399258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2399272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399294 */     // GIR_Coverage, 53323,
     /* 2399294 */     GIR_EraseRootFromParent_Done,
     /* 2399295 */   // Label 34297: @2399295
     /* 2399295 */   GIM_Reject,
     /* 2399296 */ // Label 34295: @2399296
     /* 2399296 */ GIM_Reject,
     /* 2399297 */ // Label 34252: @2399297
     /* 2399297 */ GIM_Try, /*On fail goto*//*Label 34298*/ GIMT_Encode4(2399417),
     /* 2399302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2399305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2399308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399320 */   GIM_Try, /*On fail goto*//*Label 34299*/ GIMT_Encode4(2399368), // Rule ID 53394 //
     /* 2399325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2399328 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2399331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2399345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399367 */     // GIR_Coverage, 53394,
     /* 2399367 */     GIR_EraseRootFromParent_Done,
     /* 2399368 */   // Label 34299: @2399368
     /* 2399368 */   GIM_Try, /*On fail goto*//*Label 34300*/ GIMT_Encode4(2399416), // Rule ID 53395 //
     /* 2399373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399376 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2399379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2399393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399415 */     // GIR_Coverage, 53395,
     /* 2399415 */     GIR_EraseRootFromParent_Done,
     /* 2399416 */   // Label 34300: @2399416
     /* 2399416 */   GIM_Reject,
     /* 2399417 */ // Label 34298: @2399417
     /* 2399417 */ GIM_Reject,
     /* 2399418 */ // Label 34253: @2399418
     /* 2399418 */ GIM_Try, /*On fail goto*//*Label 34301*/ GIMT_Encode4(2399538),
     /* 2399423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2399426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2399429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399441 */   GIM_Try, /*On fail goto*//*Label 34302*/ GIMT_Encode4(2399489), // Rule ID 53442 //
     /* 2399446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399449 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2399452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2399466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399488 */     // GIR_Coverage, 53442,
     /* 2399488 */     GIR_EraseRootFromParent_Done,
     /* 2399489 */   // Label 34302: @2399489
     /* 2399489 */   GIM_Try, /*On fail goto*//*Label 34303*/ GIMT_Encode4(2399537), // Rule ID 53443 //
     /* 2399494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399497 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2399500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2399514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399536 */     // GIR_Coverage, 53443,
     /* 2399536 */     GIR_EraseRootFromParent_Done,
     /* 2399537 */   // Label 34303: @2399537
     /* 2399537 */   GIM_Reject,
     /* 2399538 */ // Label 34301: @2399538
     /* 2399538 */ GIM_Reject,
     /* 2399539 */ // Label 34254: @2399539
     /* 2399539 */ GIM_Try, /*On fail goto*//*Label 34304*/ GIMT_Encode4(2399659),
     /* 2399544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2399547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2399550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399562 */   GIM_Try, /*On fail goto*//*Label 34305*/ GIMT_Encode4(2399610), // Rule ID 53358 //
     /* 2399567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399570 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2399573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2399587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399609 */     // GIR_Coverage, 53358,
     /* 2399609 */     GIR_EraseRootFromParent_Done,
     /* 2399610 */   // Label 34305: @2399610
     /* 2399610 */   GIM_Try, /*On fail goto*//*Label 34306*/ GIMT_Encode4(2399658), // Rule ID 53359 //
     /* 2399615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399618 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2399621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2399635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399657 */     // GIR_Coverage, 53359,
     /* 2399657 */     GIR_EraseRootFromParent_Done,
     /* 2399658 */   // Label 34306: @2399658
     /* 2399658 */   GIM_Reject,
     /* 2399659 */ // Label 34304: @2399659
     /* 2399659 */ GIM_Reject,
     /* 2399660 */ // Label 34255: @2399660
     /* 2399660 */ GIM_Try, /*On fail goto*//*Label 34307*/ GIMT_Encode4(2399780),
     /* 2399665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2399668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2399671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399683 */   GIM_Try, /*On fail goto*//*Label 34308*/ GIMT_Encode4(2399731), // Rule ID 53406 //
     /* 2399688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2399691 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2399694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2399708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399730 */     // GIR_Coverage, 53406,
     /* 2399730 */     GIR_EraseRootFromParent_Done,
     /* 2399731 */   // Label 34308: @2399731
     /* 2399731 */   GIM_Try, /*On fail goto*//*Label 34309*/ GIMT_Encode4(2399779), // Rule ID 53407 //
     /* 2399736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399739 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2399742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2399756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399778 */     // GIR_Coverage, 53407,
     /* 2399778 */     GIR_EraseRootFromParent_Done,
     /* 2399779 */   // Label 34309: @2399779
     /* 2399779 */   GIM_Reject,
     /* 2399780 */ // Label 34307: @2399780
     /* 2399780 */ GIM_Reject,
     /* 2399781 */ // Label 34256: @2399781
     /* 2399781 */ GIM_Try, /*On fail goto*//*Label 34310*/ GIMT_Encode4(2399901),
     /* 2399786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2399792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399804 */   GIM_Try, /*On fail goto*//*Label 34311*/ GIMT_Encode4(2399852), // Rule ID 53454 //
     /* 2399809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399812 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2399815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2399829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399851 */     // GIR_Coverage, 53454,
     /* 2399851 */     GIR_EraseRootFromParent_Done,
     /* 2399852 */   // Label 34311: @2399852
     /* 2399852 */   GIM_Try, /*On fail goto*//*Label 34312*/ GIMT_Encode4(2399900), // Rule ID 53455 //
     /* 2399857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399860 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2399863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2399877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399899 */     // GIR_Coverage, 53455,
     /* 2399899 */     GIR_EraseRootFromParent_Done,
     /* 2399900 */   // Label 34312: @2399900
     /* 2399900 */   GIM_Reject,
     /* 2399901 */ // Label 34310: @2399901
     /* 2399901 */ GIM_Reject,
     /* 2399902 */ // Label 34257: @2399902
     /* 2399902 */ GIM_Try, /*On fail goto*//*Label 34313*/ GIMT_Encode4(2400022),
     /* 2399907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2399910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2399913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399925 */   GIM_Try, /*On fail goto*//*Label 34314*/ GIMT_Encode4(2399973), // Rule ID 53370 //
     /* 2399930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399933 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2399936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2399950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399972 */     // GIR_Coverage, 53370,
     /* 2399972 */     GIR_EraseRootFromParent_Done,
     /* 2399973 */   // Label 34314: @2399973
     /* 2399973 */   GIM_Try, /*On fail goto*//*Label 34315*/ GIMT_Encode4(2400021), // Rule ID 53371 //
     /* 2399978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399981 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2399984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2399998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400020 */     // GIR_Coverage, 53371,
     /* 2400020 */     GIR_EraseRootFromParent_Done,
     /* 2400021 */   // Label 34315: @2400021
     /* 2400021 */   GIM_Reject,
     /* 2400022 */ // Label 34313: @2400022
     /* 2400022 */ GIM_Reject,
     /* 2400023 */ // Label 34258: @2400023
     /* 2400023 */ GIM_Try, /*On fail goto*//*Label 34316*/ GIMT_Encode4(2400143),
     /* 2400028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2400031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2400034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400046 */   GIM_Try, /*On fail goto*//*Label 34317*/ GIMT_Encode4(2400094), // Rule ID 53418 //
     /* 2400051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400054 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2400057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2400071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400093 */     // GIR_Coverage, 53418,
     /* 2400093 */     GIR_EraseRootFromParent_Done,
     /* 2400094 */   // Label 34317: @2400094
     /* 2400094 */   GIM_Try, /*On fail goto*//*Label 34318*/ GIMT_Encode4(2400142), // Rule ID 53419 //
     /* 2400099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400102 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2400105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2400119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400141 */     // GIR_Coverage, 53419,
     /* 2400141 */     GIR_EraseRootFromParent_Done,
     /* 2400142 */   // Label 34318: @2400142
     /* 2400142 */   GIM_Reject,
     /* 2400143 */ // Label 34316: @2400143
     /* 2400143 */ GIM_Reject,
     /* 2400144 */ // Label 34259: @2400144
     /* 2400144 */ GIM_Try, /*On fail goto*//*Label 34319*/ GIMT_Encode4(2400264),
     /* 2400149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2400152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2400155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400167 */   GIM_Try, /*On fail goto*//*Label 34320*/ GIMT_Encode4(2400215), // Rule ID 53382 //
     /* 2400172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400175 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2400178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2400192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400214 */     // GIR_Coverage, 53382,
     /* 2400214 */     GIR_EraseRootFromParent_Done,
     /* 2400215 */   // Label 34320: @2400215
     /* 2400215 */   GIM_Try, /*On fail goto*//*Label 34321*/ GIMT_Encode4(2400263), // Rule ID 53383 //
     /* 2400220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400223 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2400226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2400240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400262 */     // GIR_Coverage, 53383,
     /* 2400262 */     GIR_EraseRootFromParent_Done,
     /* 2400263 */   // Label 34321: @2400263
     /* 2400263 */   GIM_Reject,
     /* 2400264 */ // Label 34319: @2400264
     /* 2400264 */ GIM_Reject,
     /* 2400265 */ // Label 34260: @2400265
     /* 2400265 */ GIM_Reject,
     /* 2400266 */ // Label 99: @2400266
     /* 2400266 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34340*/ GIMT_Encode4(2402693),
     /* 2400277 */ /*GILLT_s16*//*Label 34322*/ GIMT_Encode4(2400397),
     /* 2400281 */ /*GILLT_s32*//*Label 34323*/ GIMT_Encode4(2400546),
     /* 2400285 */ /*GILLT_s64*//*Label 34324*/ GIMT_Encode4(2400695), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2400297 */ /*GILLT_nxv1s16*//*Label 34325*/ GIMT_Encode4(2400878),
     /* 2400301 */ /*GILLT_nxv1s32*//*Label 34326*/ GIMT_Encode4(2400999),
     /* 2400305 */ /*GILLT_nxv1s64*//*Label 34327*/ GIMT_Encode4(2401120), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2400317 */ /*GILLT_nxv2s16*//*Label 34328*/ GIMT_Encode4(2401241),
     /* 2400321 */ /*GILLT_nxv2s32*//*Label 34329*/ GIMT_Encode4(2401362),
     /* 2400325 */ /*GILLT_nxv2s64*//*Label 34330*/ GIMT_Encode4(2401483), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2400337 */ /*GILLT_nxv4s16*//*Label 34331*/ GIMT_Encode4(2401604),
     /* 2400341 */ /*GILLT_nxv4s32*//*Label 34332*/ GIMT_Encode4(2401725),
     /* 2400345 */ /*GILLT_nxv4s64*//*Label 34333*/ GIMT_Encode4(2401846), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2400357 */ /*GILLT_nxv8s16*//*Label 34334*/ GIMT_Encode4(2401967),
     /* 2400361 */ /*GILLT_nxv8s32*//*Label 34335*/ GIMT_Encode4(2402088),
     /* 2400365 */ /*GILLT_nxv8s64*//*Label 34336*/ GIMT_Encode4(2402209), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2400377 */ /*GILLT_nxv16s16*//*Label 34337*/ GIMT_Encode4(2402330),
     /* 2400381 */ /*GILLT_nxv16s32*//*Label 34338*/ GIMT_Encode4(2402451), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2400393 */ /*GILLT_nxv32s16*//*Label 34339*/ GIMT_Encode4(2402572),
     /* 2400397 */ // Label 34322: @2400397
     /* 2400397 */ GIM_Try, /*On fail goto*//*Label 34341*/ GIMT_Encode4(2400545),
     /* 2400402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2400405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2400408 */   GIM_Try, /*On fail goto*//*Label 34342*/ GIMT_Encode4(2400442), // Rule ID 1972 //
     /* 2400413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2400416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2400420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2400424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2400428 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2400428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2400431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400441 */     // GIR_Coverage, 1972,
     /* 2400441 */     GIR_EraseRootFromParent_Done,
     /* 2400442 */   // Label 34342: @2400442
     /* 2400442 */   GIM_Try, /*On fail goto*//*Label 34343*/ GIMT_Encode4(2400476), // Rule ID 1973 //
     /* 2400447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2400450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2400454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2400458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2400462 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2400462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2400465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400475 */     // GIR_Coverage, 1973,
     /* 2400475 */     GIR_EraseRootFromParent_Done,
     /* 2400476 */   // Label 34343: @2400476
     /* 2400476 */   GIM_Try, /*On fail goto*//*Label 34344*/ GIMT_Encode4(2400510), // Rule ID 1976 //
     /* 2400481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2400484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2400488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2400492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2400496 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2400496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2400499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400509 */     // GIR_Coverage, 1976,
     /* 2400509 */     GIR_EraseRootFromParent_Done,
     /* 2400510 */   // Label 34344: @2400510
     /* 2400510 */   GIM_Try, /*On fail goto*//*Label 34345*/ GIMT_Encode4(2400544), // Rule ID 1977 //
     /* 2400515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2400518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2400522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2400526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2400530 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2400530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2400533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400543 */     // GIR_Coverage, 1977,
     /* 2400543 */     GIR_EraseRootFromParent_Done,
     /* 2400544 */   // Label 34345: @2400544
     /* 2400544 */   GIM_Reject,
     /* 2400545 */ // Label 34341: @2400545
     /* 2400545 */ GIM_Reject,
     /* 2400546 */ // Label 34323: @2400546
     /* 2400546 */ GIM_Try, /*On fail goto*//*Label 34346*/ GIMT_Encode4(2400694),
     /* 2400551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2400554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2400557 */   GIM_Try, /*On fail goto*//*Label 34347*/ GIMT_Encode4(2400591), // Rule ID 1263 //
     /* 2400562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2400565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2400569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2400573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2400577 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2400577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2400580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400590 */     // GIR_Coverage, 1263,
     /* 2400590 */     GIR_EraseRootFromParent_Done,
     /* 2400591 */   // Label 34347: @2400591
     /* 2400591 */   GIM_Try, /*On fail goto*//*Label 34348*/ GIMT_Encode4(2400625), // Rule ID 1264 //
     /* 2400596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2400599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2400603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2400607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2400611 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2400611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2400614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400624 */     // GIR_Coverage, 1264,
     /* 2400624 */     GIR_EraseRootFromParent_Done,
     /* 2400625 */   // Label 34348: @2400625
     /* 2400625 */   GIM_Try, /*On fail goto*//*Label 34349*/ GIMT_Encode4(2400659), // Rule ID 1267 //
     /* 2400630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2400633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2400637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2400641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2400645 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2400645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2400648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400658 */     // GIR_Coverage, 1267,
     /* 2400658 */     GIR_EraseRootFromParent_Done,
     /* 2400659 */   // Label 34349: @2400659
     /* 2400659 */   GIM_Try, /*On fail goto*//*Label 34350*/ GIMT_Encode4(2400693), // Rule ID 1268 //
     /* 2400664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2400667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2400671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2400675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2400679 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2400679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2400682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400692 */     // GIR_Coverage, 1268,
     /* 2400692 */     GIR_EraseRootFromParent_Done,
     /* 2400693 */   // Label 34350: @2400693
     /* 2400693 */   GIM_Reject,
     /* 2400694 */ // Label 34346: @2400694
     /* 2400694 */ GIM_Reject,
     /* 2400695 */ // Label 34324: @2400695
     /* 2400695 */ GIM_Try, /*On fail goto*//*Label 34351*/ GIMT_Encode4(2400877),
     /* 2400700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2400703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2400706 */   GIM_Try, /*On fail goto*//*Label 34352*/ GIMT_Encode4(2400740), // Rule ID 1600 //
     /* 2400711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2400714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2400718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2400722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2400726 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2400726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2400729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400739 */     // GIR_Coverage, 1600,
     /* 2400739 */     GIR_EraseRootFromParent_Done,
     /* 2400740 */   // Label 34352: @2400740
     /* 2400740 */   GIM_Try, /*On fail goto*//*Label 34353*/ GIMT_Encode4(2400774), // Rule ID 1601 //
     /* 2400745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2400748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2400752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2400756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2400760 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2400760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2400763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400773 */     // GIR_Coverage, 1601,
     /* 2400773 */     GIR_EraseRootFromParent_Done,
     /* 2400774 */   // Label 34353: @2400774
     /* 2400774 */   GIM_Try, /*On fail goto*//*Label 34354*/ GIMT_Encode4(2400808), // Rule ID 1604 //
     /* 2400779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2400782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2400786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2400790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2400794 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2400794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2400797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400807 */     // GIR_Coverage, 1604,
     /* 2400807 */     GIR_EraseRootFromParent_Done,
     /* 2400808 */   // Label 34354: @2400808
     /* 2400808 */   GIM_Try, /*On fail goto*//*Label 34355*/ GIMT_Encode4(2400842), // Rule ID 1605 //
     /* 2400813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2400816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2400820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2400824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2400828 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2400828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2400831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400841 */     // GIR_Coverage, 1605,
     /* 2400841 */     GIR_EraseRootFromParent_Done,
     /* 2400842 */   // Label 34355: @2400842
     /* 2400842 */   GIM_Try, /*On fail goto*//*Label 34356*/ GIMT_Encode4(2400876), // Rule ID 1608 //
     /* 2400847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2400850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2400854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2400858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2400862 */     // (strict_fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2400862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2400865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400875 */     // GIR_Coverage, 1608,
     /* 2400875 */     GIR_EraseRootFromParent_Done,
     /* 2400876 */   // Label 34356: @2400876
     /* 2400876 */   GIM_Reject,
     /* 2400877 */ // Label 34351: @2400877
     /* 2400877 */ GIM_Reject,
     /* 2400878 */ // Label 34325: @2400878
     /* 2400878 */ GIM_Try, /*On fail goto*//*Label 34357*/ GIMT_Encode4(2400998),
     /* 2400883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2400886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2400889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400901 */   GIM_Try, /*On fail goto*//*Label 34358*/ GIMT_Encode4(2400949), // Rule ID 53466 //
     /* 2400906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400909 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2400912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2400926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400948 */     // GIR_Coverage, 53466,
     /* 2400948 */     GIR_EraseRootFromParent_Done,
     /* 2400949 */   // Label 34358: @2400949
     /* 2400949 */   GIM_Try, /*On fail goto*//*Label 34359*/ GIMT_Encode4(2400997), // Rule ID 53467 //
     /* 2400954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400957 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2400960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2400974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400996 */     // GIR_Coverage, 53467,
     /* 2400996 */     GIR_EraseRootFromParent_Done,
     /* 2400997 */   // Label 34359: @2400997
     /* 2400997 */   GIM_Reject,
     /* 2400998 */ // Label 34357: @2400998
     /* 2400998 */ GIM_Reject,
     /* 2400999 */ // Label 34326: @2400999
     /* 2400999 */ GIM_Try, /*On fail goto*//*Label 34360*/ GIMT_Encode4(2401119),
     /* 2401004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2401007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2401010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401022 */   GIM_Try, /*On fail goto*//*Label 34361*/ GIMT_Encode4(2401070), // Rule ID 53490 //
     /* 2401027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401030 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2401033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2401047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401069 */     // GIR_Coverage, 53490,
     /* 2401069 */     GIR_EraseRootFromParent_Done,
     /* 2401070 */   // Label 34361: @2401070
     /* 2401070 */   GIM_Try, /*On fail goto*//*Label 34362*/ GIMT_Encode4(2401118), // Rule ID 53491 //
     /* 2401075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401078 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2401081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2401095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401117 */     // GIR_Coverage, 53491,
     /* 2401117 */     GIR_EraseRootFromParent_Done,
     /* 2401118 */   // Label 34362: @2401118
     /* 2401118 */   GIM_Reject,
     /* 2401119 */ // Label 34360: @2401119
     /* 2401119 */ GIM_Reject,
     /* 2401120 */ // Label 34327: @2401120
     /* 2401120 */ GIM_Try, /*On fail goto*//*Label 34363*/ GIMT_Encode4(2401240),
     /* 2401125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2401128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2401131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401143 */   GIM_Try, /*On fail goto*//*Label 34364*/ GIMT_Encode4(2401191), // Rule ID 53526 //
     /* 2401148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401151 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2401154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2401168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401190 */     // GIR_Coverage, 53526,
     /* 2401190 */     GIR_EraseRootFromParent_Done,
     /* 2401191 */   // Label 34364: @2401191
     /* 2401191 */   GIM_Try, /*On fail goto*//*Label 34365*/ GIMT_Encode4(2401239), // Rule ID 53527 //
     /* 2401196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401199 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2401202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2401216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401238 */     // GIR_Coverage, 53527,
     /* 2401238 */     GIR_EraseRootFromParent_Done,
     /* 2401239 */   // Label 34365: @2401239
     /* 2401239 */   GIM_Reject,
     /* 2401240 */ // Label 34363: @2401240
     /* 2401240 */ GIM_Reject,
     /* 2401241 */ // Label 34328: @2401241
     /* 2401241 */ GIM_Try, /*On fail goto*//*Label 34366*/ GIMT_Encode4(2401361),
     /* 2401246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2401249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2401252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401264 */   GIM_Try, /*On fail goto*//*Label 34367*/ GIMT_Encode4(2401312), // Rule ID 53478 //
     /* 2401269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401272 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2401275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2401289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401311 */     // GIR_Coverage, 53478,
     /* 2401311 */     GIR_EraseRootFromParent_Done,
     /* 2401312 */   // Label 34367: @2401312
     /* 2401312 */   GIM_Try, /*On fail goto*//*Label 34368*/ GIMT_Encode4(2401360), // Rule ID 53479 //
     /* 2401317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401320 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2401323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2401337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401359 */     // GIR_Coverage, 53479,
     /* 2401359 */     GIR_EraseRootFromParent_Done,
     /* 2401360 */   // Label 34368: @2401360
     /* 2401360 */   GIM_Reject,
     /* 2401361 */ // Label 34366: @2401361
     /* 2401361 */ GIM_Reject,
     /* 2401362 */ // Label 34329: @2401362
     /* 2401362 */ GIM_Try, /*On fail goto*//*Label 34369*/ GIMT_Encode4(2401482),
     /* 2401367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2401370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2401373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401385 */   GIM_Try, /*On fail goto*//*Label 34370*/ GIMT_Encode4(2401433), // Rule ID 53514 //
     /* 2401390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401393 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2401396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2401410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401432 */     // GIR_Coverage, 53514,
     /* 2401432 */     GIR_EraseRootFromParent_Done,
     /* 2401433 */   // Label 34370: @2401433
     /* 2401433 */   GIM_Try, /*On fail goto*//*Label 34371*/ GIMT_Encode4(2401481), // Rule ID 53515 //
     /* 2401438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401441 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2401444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2401458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401480 */     // GIR_Coverage, 53515,
     /* 2401480 */     GIR_EraseRootFromParent_Done,
     /* 2401481 */   // Label 34371: @2401481
     /* 2401481 */   GIM_Reject,
     /* 2401482 */ // Label 34369: @2401482
     /* 2401482 */ GIM_Reject,
     /* 2401483 */ // Label 34330: @2401483
     /* 2401483 */ GIM_Try, /*On fail goto*//*Label 34372*/ GIMT_Encode4(2401603),
     /* 2401488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2401491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2401494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401506 */   GIM_Try, /*On fail goto*//*Label 34373*/ GIMT_Encode4(2401554), // Rule ID 53610 //
     /* 2401511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401514 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2401517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2401531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401553 */     // GIR_Coverage, 53610,
     /* 2401553 */     GIR_EraseRootFromParent_Done,
     /* 2401554 */   // Label 34373: @2401554
     /* 2401554 */   GIM_Try, /*On fail goto*//*Label 34374*/ GIMT_Encode4(2401602), // Rule ID 53611 //
     /* 2401559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401562 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2401565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2401579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401601 */     // GIR_Coverage, 53611,
     /* 2401601 */     GIR_EraseRootFromParent_Done,
     /* 2401602 */   // Label 34374: @2401602
     /* 2401602 */   GIM_Reject,
     /* 2401603 */ // Label 34372: @2401603
     /* 2401603 */ GIM_Reject,
     /* 2401604 */ // Label 34331: @2401604
     /* 2401604 */ GIM_Try, /*On fail goto*//*Label 34375*/ GIMT_Encode4(2401724),
     /* 2401609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2401612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2401615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401627 */   GIM_Try, /*On fail goto*//*Label 34376*/ GIMT_Encode4(2401675), // Rule ID 53502 //
     /* 2401632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401635 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2401638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2401652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401674 */     // GIR_Coverage, 53502,
     /* 2401674 */     GIR_EraseRootFromParent_Done,
     /* 2401675 */   // Label 34376: @2401675
     /* 2401675 */   GIM_Try, /*On fail goto*//*Label 34377*/ GIMT_Encode4(2401723), // Rule ID 53503 //
     /* 2401680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401683 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2401686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2401700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401722 */     // GIR_Coverage, 53503,
     /* 2401722 */     GIR_EraseRootFromParent_Done,
     /* 2401723 */   // Label 34377: @2401723
     /* 2401723 */   GIM_Reject,
     /* 2401724 */ // Label 34375: @2401724
     /* 2401724 */ GIM_Reject,
     /* 2401725 */ // Label 34332: @2401725
     /* 2401725 */ GIM_Try, /*On fail goto*//*Label 34378*/ GIMT_Encode4(2401845),
     /* 2401730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2401733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2401736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401748 */   GIM_Try, /*On fail goto*//*Label 34379*/ GIMT_Encode4(2401796), // Rule ID 53574 //
     /* 2401753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401756 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2401759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2401773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401795 */     // GIR_Coverage, 53574,
     /* 2401795 */     GIR_EraseRootFromParent_Done,
     /* 2401796 */   // Label 34379: @2401796
     /* 2401796 */   GIM_Try, /*On fail goto*//*Label 34380*/ GIMT_Encode4(2401844), // Rule ID 53575 //
     /* 2401801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401804 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2401807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2401821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401843 */     // GIR_Coverage, 53575,
     /* 2401843 */     GIR_EraseRootFromParent_Done,
     /* 2401844 */   // Label 34380: @2401844
     /* 2401844 */   GIM_Reject,
     /* 2401845 */ // Label 34378: @2401845
     /* 2401845 */ GIM_Reject,
     /* 2401846 */ // Label 34333: @2401846
     /* 2401846 */ GIM_Try, /*On fail goto*//*Label 34381*/ GIMT_Encode4(2401966),
     /* 2401851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2401857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401869 */   GIM_Try, /*On fail goto*//*Label 34382*/ GIMT_Encode4(2401917), // Rule ID 53622 //
     /* 2401874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401877 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2401880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2401894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401916 */     // GIR_Coverage, 53622,
     /* 2401916 */     GIR_EraseRootFromParent_Done,
     /* 2401917 */   // Label 34382: @2401917
     /* 2401917 */   GIM_Try, /*On fail goto*//*Label 34383*/ GIMT_Encode4(2401965), // Rule ID 53623 //
     /* 2401922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401925 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2401928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2401942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401964 */     // GIR_Coverage, 53623,
     /* 2401964 */     GIR_EraseRootFromParent_Done,
     /* 2401965 */   // Label 34383: @2401965
     /* 2401965 */   GIM_Reject,
     /* 2401966 */ // Label 34381: @2401966
     /* 2401966 */ GIM_Reject,
     /* 2401967 */ // Label 34334: @2401967
     /* 2401967 */ GIM_Try, /*On fail goto*//*Label 34384*/ GIMT_Encode4(2402087),
     /* 2401972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2401975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2401978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401990 */   GIM_Try, /*On fail goto*//*Label 34385*/ GIMT_Encode4(2402038), // Rule ID 53538 //
     /* 2401995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401998 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2402001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2402015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402037 */     // GIR_Coverage, 53538,
     /* 2402037 */     GIR_EraseRootFromParent_Done,
     /* 2402038 */   // Label 34385: @2402038
     /* 2402038 */   GIM_Try, /*On fail goto*//*Label 34386*/ GIMT_Encode4(2402086), // Rule ID 53539 //
     /* 2402043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402046 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2402049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2402063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402085 */     // GIR_Coverage, 53539,
     /* 2402085 */     GIR_EraseRootFromParent_Done,
     /* 2402086 */   // Label 34386: @2402086
     /* 2402086 */   GIM_Reject,
     /* 2402087 */ // Label 34384: @2402087
     /* 2402087 */ GIM_Reject,
     /* 2402088 */ // Label 34335: @2402088
     /* 2402088 */ GIM_Try, /*On fail goto*//*Label 34387*/ GIMT_Encode4(2402208),
     /* 2402093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2402096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2402099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402111 */   GIM_Try, /*On fail goto*//*Label 34388*/ GIMT_Encode4(2402159), // Rule ID 53586 //
     /* 2402116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2402119 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2402122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2402136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402158 */     // GIR_Coverage, 53586,
     /* 2402158 */     GIR_EraseRootFromParent_Done,
     /* 2402159 */   // Label 34388: @2402159
     /* 2402159 */   GIM_Try, /*On fail goto*//*Label 34389*/ GIMT_Encode4(2402207), // Rule ID 53587 //
     /* 2402164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2402167 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2402170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2402184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402206 */     // GIR_Coverage, 53587,
     /* 2402206 */     GIR_EraseRootFromParent_Done,
     /* 2402207 */   // Label 34389: @2402207
     /* 2402207 */   GIM_Reject,
     /* 2402208 */ // Label 34387: @2402208
     /* 2402208 */ GIM_Reject,
     /* 2402209 */ // Label 34336: @2402209
     /* 2402209 */ GIM_Try, /*On fail goto*//*Label 34390*/ GIMT_Encode4(2402329),
     /* 2402214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2402217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2402220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402232 */   GIM_Try, /*On fail goto*//*Label 34391*/ GIMT_Encode4(2402280), // Rule ID 53634 //
     /* 2402237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2402240 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2402243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2402257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2402275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402279 */     // GIR_Coverage, 53634,
     /* 2402279 */     GIR_EraseRootFromParent_Done,
     /* 2402280 */   // Label 34391: @2402280
     /* 2402280 */   GIM_Try, /*On fail goto*//*Label 34392*/ GIMT_Encode4(2402328), // Rule ID 53635 //
     /* 2402285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2402288 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2402291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2402305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2402323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402327 */     // GIR_Coverage, 53635,
     /* 2402327 */     GIR_EraseRootFromParent_Done,
     /* 2402328 */   // Label 34392: @2402328
     /* 2402328 */   GIM_Reject,
     /* 2402329 */ // Label 34390: @2402329
     /* 2402329 */ GIM_Reject,
     /* 2402330 */ // Label 34337: @2402330
     /* 2402330 */ GIM_Try, /*On fail goto*//*Label 34393*/ GIMT_Encode4(2402450),
     /* 2402335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2402338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2402341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402353 */   GIM_Try, /*On fail goto*//*Label 34394*/ GIMT_Encode4(2402401), // Rule ID 53550 //
     /* 2402358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402361 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2402364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2402378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402400 */     // GIR_Coverage, 53550,
     /* 2402400 */     GIR_EraseRootFromParent_Done,
     /* 2402401 */   // Label 34394: @2402401
     /* 2402401 */   GIM_Try, /*On fail goto*//*Label 34395*/ GIMT_Encode4(2402449), // Rule ID 53551 //
     /* 2402406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402409 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2402412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2402426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402448 */     // GIR_Coverage, 53551,
     /* 2402448 */     GIR_EraseRootFromParent_Done,
     /* 2402449 */   // Label 34395: @2402449
     /* 2402449 */   GIM_Reject,
     /* 2402450 */ // Label 34393: @2402450
     /* 2402450 */ GIM_Reject,
     /* 2402451 */ // Label 34338: @2402451
     /* 2402451 */ GIM_Try, /*On fail goto*//*Label 34396*/ GIMT_Encode4(2402571),
     /* 2402456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2402459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2402462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402474 */   GIM_Try, /*On fail goto*//*Label 34397*/ GIMT_Encode4(2402522), // Rule ID 53598 //
     /* 2402479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2402482 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2402485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2402499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402521 */     // GIR_Coverage, 53598,
     /* 2402521 */     GIR_EraseRootFromParent_Done,
     /* 2402522 */   // Label 34397: @2402522
     /* 2402522 */   GIM_Try, /*On fail goto*//*Label 34398*/ GIMT_Encode4(2402570), // Rule ID 53599 //
     /* 2402527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2402530 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2402533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2402547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402569 */     // GIR_Coverage, 53599,
     /* 2402569 */     GIR_EraseRootFromParent_Done,
     /* 2402570 */   // Label 34398: @2402570
     /* 2402570 */   GIM_Reject,
     /* 2402571 */ // Label 34396: @2402571
     /* 2402571 */ GIM_Reject,
     /* 2402572 */ // Label 34339: @2402572
     /* 2402572 */ GIM_Try, /*On fail goto*//*Label 34399*/ GIMT_Encode4(2402692),
     /* 2402577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2402580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2402583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402595 */   GIM_Try, /*On fail goto*//*Label 34400*/ GIMT_Encode4(2402643), // Rule ID 53562 //
     /* 2402600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402603 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2402606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2402620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402642 */     // GIR_Coverage, 53562,
     /* 2402642 */     GIR_EraseRootFromParent_Done,
     /* 2402643 */   // Label 34400: @2402643
     /* 2402643 */   GIM_Try, /*On fail goto*//*Label 34401*/ GIMT_Encode4(2402691), // Rule ID 53563 //
     /* 2402648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402651 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2402654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2402668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402690 */     // GIR_Coverage, 53563,
     /* 2402690 */     GIR_EraseRootFromParent_Done,
     /* 2402691 */   // Label 34401: @2402691
     /* 2402691 */   GIM_Reject,
     /* 2402692 */ // Label 34399: @2402692
     /* 2402692 */ GIM_Reject,
     /* 2402693 */ // Label 34340: @2402693
     /* 2402693 */ GIM_Reject,
     /* 2402694 */ // Label 100: @2402694
     /* 2402694 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34420*/ GIMT_Encode4(2405121),
     /* 2402705 */ /*GILLT_s16*//*Label 34402*/ GIMT_Encode4(2402825),
     /* 2402709 */ /*GILLT_s32*//*Label 34403*/ GIMT_Encode4(2402974),
     /* 2402713 */ /*GILLT_s64*//*Label 34404*/ GIMT_Encode4(2403123), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402725 */ /*GILLT_nxv1s16*//*Label 34405*/ GIMT_Encode4(2403306),
     /* 2402729 */ /*GILLT_nxv1s32*//*Label 34406*/ GIMT_Encode4(2403427),
     /* 2402733 */ /*GILLT_nxv1s64*//*Label 34407*/ GIMT_Encode4(2403548), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402745 */ /*GILLT_nxv2s16*//*Label 34408*/ GIMT_Encode4(2403669),
     /* 2402749 */ /*GILLT_nxv2s32*//*Label 34409*/ GIMT_Encode4(2403790),
     /* 2402753 */ /*GILLT_nxv2s64*//*Label 34410*/ GIMT_Encode4(2403911), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402765 */ /*GILLT_nxv4s16*//*Label 34411*/ GIMT_Encode4(2404032),
     /* 2402769 */ /*GILLT_nxv4s32*//*Label 34412*/ GIMT_Encode4(2404153),
     /* 2402773 */ /*GILLT_nxv4s64*//*Label 34413*/ GIMT_Encode4(2404274), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402785 */ /*GILLT_nxv8s16*//*Label 34414*/ GIMT_Encode4(2404395),
     /* 2402789 */ /*GILLT_nxv8s32*//*Label 34415*/ GIMT_Encode4(2404516),
     /* 2402793 */ /*GILLT_nxv8s64*//*Label 34416*/ GIMT_Encode4(2404637), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402805 */ /*GILLT_nxv16s16*//*Label 34417*/ GIMT_Encode4(2404758),
     /* 2402809 */ /*GILLT_nxv16s32*//*Label 34418*/ GIMT_Encode4(2404879), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402821 */ /*GILLT_nxv32s16*//*Label 34419*/ GIMT_Encode4(2405000),
     /* 2402825 */ // Label 34402: @2402825
     /* 2402825 */ GIM_Try, /*On fail goto*//*Label 34421*/ GIMT_Encode4(2402973),
     /* 2402830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2402836 */   GIM_Try, /*On fail goto*//*Label 34422*/ GIMT_Encode4(2402870), // Rule ID 1980 //
     /* 2402841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2402844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402856 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2402856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2402859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402869 */     // GIR_Coverage, 1980,
     /* 2402869 */     GIR_EraseRootFromParent_Done,
     /* 2402870 */   // Label 34422: @2402870
     /* 2402870 */   GIM_Try, /*On fail goto*//*Label 34423*/ GIMT_Encode4(2402904), // Rule ID 1981 //
     /* 2402875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2402878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402890 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2402890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2402893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402903 */     // GIR_Coverage, 1981,
     /* 2402903 */     GIR_EraseRootFromParent_Done,
     /* 2402904 */   // Label 34423: @2402904
     /* 2402904 */   GIM_Try, /*On fail goto*//*Label 34424*/ GIMT_Encode4(2402938), // Rule ID 1984 //
     /* 2402909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2402912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402924 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2402924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2402927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402937 */     // GIR_Coverage, 1984,
     /* 2402937 */     GIR_EraseRootFromParent_Done,
     /* 2402938 */   // Label 34424: @2402938
     /* 2402938 */   GIM_Try, /*On fail goto*//*Label 34425*/ GIMT_Encode4(2402972), // Rule ID 1985 //
     /* 2402943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2402946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402958 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2402958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2402961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402971 */     // GIR_Coverage, 1985,
     /* 2402971 */     GIR_EraseRootFromParent_Done,
     /* 2402972 */   // Label 34425: @2402972
     /* 2402972 */   GIM_Reject,
     /* 2402973 */ // Label 34421: @2402973
     /* 2402973 */ GIM_Reject,
     /* 2402974 */ // Label 34403: @2402974
     /* 2402974 */ GIM_Try, /*On fail goto*//*Label 34426*/ GIMT_Encode4(2403122),
     /* 2402979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2402982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2402985 */   GIM_Try, /*On fail goto*//*Label 34427*/ GIMT_Encode4(2403019), // Rule ID 1271 //
     /* 2402990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2402993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2402997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403005 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2403005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2403008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403018 */     // GIR_Coverage, 1271,
     /* 2403018 */     GIR_EraseRootFromParent_Done,
     /* 2403019 */   // Label 34427: @2403019
     /* 2403019 */   GIM_Try, /*On fail goto*//*Label 34428*/ GIMT_Encode4(2403053), // Rule ID 1272 //
     /* 2403024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2403027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403039 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2403039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2403042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403052 */     // GIR_Coverage, 1272,
     /* 2403052 */     GIR_EraseRootFromParent_Done,
     /* 2403053 */   // Label 34428: @2403053
     /* 2403053 */   GIM_Try, /*On fail goto*//*Label 34429*/ GIMT_Encode4(2403087), // Rule ID 1275 //
     /* 2403058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2403061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403073 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2403073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2403076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403086 */     // GIR_Coverage, 1275,
     /* 2403086 */     GIR_EraseRootFromParent_Done,
     /* 2403087 */   // Label 34429: @2403087
     /* 2403087 */   GIM_Try, /*On fail goto*//*Label 34430*/ GIMT_Encode4(2403121), // Rule ID 1276 //
     /* 2403092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2403095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403107 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2403107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2403110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403120 */     // GIR_Coverage, 1276,
     /* 2403120 */     GIR_EraseRootFromParent_Done,
     /* 2403121 */   // Label 34430: @2403121
     /* 2403121 */   GIM_Reject,
     /* 2403122 */ // Label 34426: @2403122
     /* 2403122 */ GIM_Reject,
     /* 2403123 */ // Label 34404: @2403123
     /* 2403123 */ GIM_Try, /*On fail goto*//*Label 34431*/ GIMT_Encode4(2403305),
     /* 2403128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2403131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2403134 */   GIM_Try, /*On fail goto*//*Label 34432*/ GIMT_Encode4(2403168), // Rule ID 1610 //
     /* 2403139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2403142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2403146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2403150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2403154 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2403154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2403157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403167 */     // GIR_Coverage, 1610,
     /* 2403167 */     GIR_EraseRootFromParent_Done,
     /* 2403168 */   // Label 34432: @2403168
     /* 2403168 */   GIM_Try, /*On fail goto*//*Label 34433*/ GIMT_Encode4(2403202), // Rule ID 1611 //
     /* 2403173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2403176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2403180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2403184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2403188 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2403188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2403191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403201 */     // GIR_Coverage, 1611,
     /* 2403201 */     GIR_EraseRootFromParent_Done,
     /* 2403202 */   // Label 34433: @2403202
     /* 2403202 */   GIM_Try, /*On fail goto*//*Label 34434*/ GIMT_Encode4(2403236), // Rule ID 1614 //
     /* 2403207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2403210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2403214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2403218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2403222 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2403222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2403225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403235 */     // GIR_Coverage, 1614,
     /* 2403235 */     GIR_EraseRootFromParent_Done,
     /* 2403236 */   // Label 34434: @2403236
     /* 2403236 */   GIM_Try, /*On fail goto*//*Label 34435*/ GIMT_Encode4(2403270), // Rule ID 1615 //
     /* 2403241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2403244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2403248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2403252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2403256 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2403256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2403259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403269 */     // GIR_Coverage, 1615,
     /* 2403269 */     GIR_EraseRootFromParent_Done,
     /* 2403270 */   // Label 34435: @2403270
     /* 2403270 */   GIM_Try, /*On fail goto*//*Label 34436*/ GIMT_Encode4(2403304), // Rule ID 1618 //
     /* 2403275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2403278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2403282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2403286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2403290 */     // (strict_fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2403290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2403293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403303 */     // GIR_Coverage, 1618,
     /* 2403303 */     GIR_EraseRootFromParent_Done,
     /* 2403304 */   // Label 34436: @2403304
     /* 2403304 */   GIM_Reject,
     /* 2403305 */ // Label 34431: @2403305
     /* 2403305 */ GIM_Reject,
     /* 2403306 */ // Label 34405: @2403306
     /* 2403306 */ GIM_Try, /*On fail goto*//*Label 34437*/ GIMT_Encode4(2403426),
     /* 2403311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2403314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2403317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403329 */   GIM_Try, /*On fail goto*//*Label 34438*/ GIMT_Encode4(2403377), // Rule ID 54234 //
     /* 2403334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2403337 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2403340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2403354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403376 */     // GIR_Coverage, 54234,
     /* 2403376 */     GIR_EraseRootFromParent_Done,
     /* 2403377 */   // Label 34438: @2403377
     /* 2403377 */   GIM_Try, /*On fail goto*//*Label 34439*/ GIMT_Encode4(2403425), // Rule ID 54235 //
     /* 2403382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2403385 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2403388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2403402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403424 */     // GIR_Coverage, 54235,
     /* 2403424 */     GIR_EraseRootFromParent_Done,
     /* 2403425 */   // Label 34439: @2403425
     /* 2403425 */   GIM_Reject,
     /* 2403426 */ // Label 34437: @2403426
     /* 2403426 */ GIM_Reject,
     /* 2403427 */ // Label 34406: @2403427
     /* 2403427 */ GIM_Try, /*On fail goto*//*Label 34440*/ GIMT_Encode4(2403547),
     /* 2403432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2403435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2403438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403450 */   GIM_Try, /*On fail goto*//*Label 34441*/ GIMT_Encode4(2403498), // Rule ID 54258 //
     /* 2403455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403458 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2403461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2403475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403497 */     // GIR_Coverage, 54258,
     /* 2403497 */     GIR_EraseRootFromParent_Done,
     /* 2403498 */   // Label 34441: @2403498
     /* 2403498 */   GIM_Try, /*On fail goto*//*Label 34442*/ GIMT_Encode4(2403546), // Rule ID 54259 //
     /* 2403503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403506 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2403509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2403523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403545 */     // GIR_Coverage, 54259,
     /* 2403545 */     GIR_EraseRootFromParent_Done,
     /* 2403546 */   // Label 34442: @2403546
     /* 2403546 */   GIM_Reject,
     /* 2403547 */ // Label 34440: @2403547
     /* 2403547 */ GIM_Reject,
     /* 2403548 */ // Label 34407: @2403548
     /* 2403548 */ GIM_Try, /*On fail goto*//*Label 34443*/ GIMT_Encode4(2403668),
     /* 2403553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2403556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2403559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403571 */   GIM_Try, /*On fail goto*//*Label 34444*/ GIMT_Encode4(2403619), // Rule ID 54294 //
     /* 2403576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2403579 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2403582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2403596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403618 */     // GIR_Coverage, 54294,
     /* 2403618 */     GIR_EraseRootFromParent_Done,
     /* 2403619 */   // Label 34444: @2403619
     /* 2403619 */   GIM_Try, /*On fail goto*//*Label 34445*/ GIMT_Encode4(2403667), // Rule ID 54295 //
     /* 2403624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2403627 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2403630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2403644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403666 */     // GIR_Coverage, 54295,
     /* 2403666 */     GIR_EraseRootFromParent_Done,
     /* 2403667 */   // Label 34445: @2403667
     /* 2403667 */   GIM_Reject,
     /* 2403668 */ // Label 34443: @2403668
     /* 2403668 */ GIM_Reject,
     /* 2403669 */ // Label 34408: @2403669
     /* 2403669 */ GIM_Try, /*On fail goto*//*Label 34446*/ GIMT_Encode4(2403789),
     /* 2403674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2403677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2403680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403692 */   GIM_Try, /*On fail goto*//*Label 34447*/ GIMT_Encode4(2403740), // Rule ID 54246 //
     /* 2403697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2403700 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2403703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2403717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403739 */     // GIR_Coverage, 54246,
     /* 2403739 */     GIR_EraseRootFromParent_Done,
     /* 2403740 */   // Label 34447: @2403740
     /* 2403740 */   GIM_Try, /*On fail goto*//*Label 34448*/ GIMT_Encode4(2403788), // Rule ID 54247 //
     /* 2403745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2403748 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2403751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2403765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403787 */     // GIR_Coverage, 54247,
     /* 2403787 */     GIR_EraseRootFromParent_Done,
     /* 2403788 */   // Label 34448: @2403788
     /* 2403788 */   GIM_Reject,
     /* 2403789 */ // Label 34446: @2403789
     /* 2403789 */ GIM_Reject,
     /* 2403790 */ // Label 34409: @2403790
     /* 2403790 */ GIM_Try, /*On fail goto*//*Label 34449*/ GIMT_Encode4(2403910),
     /* 2403795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2403798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2403801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403813 */   GIM_Try, /*On fail goto*//*Label 34450*/ GIMT_Encode4(2403861), // Rule ID 54282 //
     /* 2403818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403821 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2403824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2403838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403860 */     // GIR_Coverage, 54282,
     /* 2403860 */     GIR_EraseRootFromParent_Done,
     /* 2403861 */   // Label 34450: @2403861
     /* 2403861 */   GIM_Try, /*On fail goto*//*Label 34451*/ GIMT_Encode4(2403909), // Rule ID 54283 //
     /* 2403866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403869 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2403872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2403886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403908 */     // GIR_Coverage, 54283,
     /* 2403908 */     GIR_EraseRootFromParent_Done,
     /* 2403909 */   // Label 34451: @2403909
     /* 2403909 */   GIM_Reject,
     /* 2403910 */ // Label 34449: @2403910
     /* 2403910 */ GIM_Reject,
     /* 2403911 */ // Label 34410: @2403911
     /* 2403911 */ GIM_Try, /*On fail goto*//*Label 34452*/ GIMT_Encode4(2404031),
     /* 2403916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2403919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2403922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2403926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2403930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2403934 */   GIM_Try, /*On fail goto*//*Label 34453*/ GIMT_Encode4(2403982), // Rule ID 54378 //
     /* 2403939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2403942 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2403945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2403959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403981 */     // GIR_Coverage, 54378,
     /* 2403981 */     GIR_EraseRootFromParent_Done,
     /* 2403982 */   // Label 34453: @2403982
     /* 2403982 */   GIM_Try, /*On fail goto*//*Label 34454*/ GIMT_Encode4(2404030), // Rule ID 54379 //
     /* 2403987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2403990 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2403993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2404007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404029 */     // GIR_Coverage, 54379,
     /* 2404029 */     GIR_EraseRootFromParent_Done,
     /* 2404030 */   // Label 34454: @2404030
     /* 2404030 */   GIM_Reject,
     /* 2404031 */ // Label 34452: @2404031
     /* 2404031 */ GIM_Reject,
     /* 2404032 */ // Label 34411: @2404032
     /* 2404032 */ GIM_Try, /*On fail goto*//*Label 34455*/ GIMT_Encode4(2404152),
     /* 2404037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2404040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2404043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2404047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2404051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2404055 */   GIM_Try, /*On fail goto*//*Label 34456*/ GIMT_Encode4(2404103), // Rule ID 54270 //
     /* 2404060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404063 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2404066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2404080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404102 */     // GIR_Coverage, 54270,
     /* 2404102 */     GIR_EraseRootFromParent_Done,
     /* 2404103 */   // Label 34456: @2404103
     /* 2404103 */   GIM_Try, /*On fail goto*//*Label 34457*/ GIMT_Encode4(2404151), // Rule ID 54271 //
     /* 2404108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404111 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2404114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2404128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404150 */     // GIR_Coverage, 54271,
     /* 2404150 */     GIR_EraseRootFromParent_Done,
     /* 2404151 */   // Label 34457: @2404151
     /* 2404151 */   GIM_Reject,
     /* 2404152 */ // Label 34455: @2404152
     /* 2404152 */ GIM_Reject,
     /* 2404153 */ // Label 34412: @2404153
     /* 2404153 */ GIM_Try, /*On fail goto*//*Label 34458*/ GIMT_Encode4(2404273),
     /* 2404158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2404161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2404164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404176 */   GIM_Try, /*On fail goto*//*Label 34459*/ GIMT_Encode4(2404224), // Rule ID 54342 //
     /* 2404181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2404184 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2404187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2404201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404223 */     // GIR_Coverage, 54342,
     /* 2404223 */     GIR_EraseRootFromParent_Done,
     /* 2404224 */   // Label 34459: @2404224
     /* 2404224 */   GIM_Try, /*On fail goto*//*Label 34460*/ GIMT_Encode4(2404272), // Rule ID 54343 //
     /* 2404229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2404232 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2404235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2404249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404271 */     // GIR_Coverage, 54343,
     /* 2404271 */     GIR_EraseRootFromParent_Done,
     /* 2404272 */   // Label 34460: @2404272
     /* 2404272 */   GIM_Reject,
     /* 2404273 */ // Label 34458: @2404273
     /* 2404273 */ GIM_Reject,
     /* 2404274 */ // Label 34413: @2404274
     /* 2404274 */ GIM_Try, /*On fail goto*//*Label 34461*/ GIMT_Encode4(2404394),
     /* 2404279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2404282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2404285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404297 */   GIM_Try, /*On fail goto*//*Label 34462*/ GIMT_Encode4(2404345), // Rule ID 54390 //
     /* 2404302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2404305 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2404308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2404322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404344 */     // GIR_Coverage, 54390,
     /* 2404344 */     GIR_EraseRootFromParent_Done,
     /* 2404345 */   // Label 34462: @2404345
     /* 2404345 */   GIM_Try, /*On fail goto*//*Label 34463*/ GIMT_Encode4(2404393), // Rule ID 54391 //
     /* 2404350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2404353 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2404356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2404370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404392 */     // GIR_Coverage, 54391,
     /* 2404392 */     GIR_EraseRootFromParent_Done,
     /* 2404393 */   // Label 34463: @2404393
     /* 2404393 */   GIM_Reject,
     /* 2404394 */ // Label 34461: @2404394
     /* 2404394 */ GIM_Reject,
     /* 2404395 */ // Label 34414: @2404395
     /* 2404395 */ GIM_Try, /*On fail goto*//*Label 34464*/ GIMT_Encode4(2404515),
     /* 2404400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2404403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2404406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404418 */   GIM_Try, /*On fail goto*//*Label 34465*/ GIMT_Encode4(2404466), // Rule ID 54306 //
     /* 2404423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404426 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2404429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2404443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404465 */     // GIR_Coverage, 54306,
     /* 2404465 */     GIR_EraseRootFromParent_Done,
     /* 2404466 */   // Label 34465: @2404466
     /* 2404466 */   GIM_Try, /*On fail goto*//*Label 34466*/ GIMT_Encode4(2404514), // Rule ID 54307 //
     /* 2404471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404474 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2404477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2404491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404513 */     // GIR_Coverage, 54307,
     /* 2404513 */     GIR_EraseRootFromParent_Done,
     /* 2404514 */   // Label 34466: @2404514
     /* 2404514 */   GIM_Reject,
     /* 2404515 */ // Label 34464: @2404515
     /* 2404515 */ GIM_Reject,
     /* 2404516 */ // Label 34415: @2404516
     /* 2404516 */ GIM_Try, /*On fail goto*//*Label 34467*/ GIMT_Encode4(2404636),
     /* 2404521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2404524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2404527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404539 */   GIM_Try, /*On fail goto*//*Label 34468*/ GIMT_Encode4(2404587), // Rule ID 54354 //
     /* 2404544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2404547 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2404550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2404564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404586 */     // GIR_Coverage, 54354,
     /* 2404586 */     GIR_EraseRootFromParent_Done,
     /* 2404587 */   // Label 34468: @2404587
     /* 2404587 */   GIM_Try, /*On fail goto*//*Label 34469*/ GIMT_Encode4(2404635), // Rule ID 54355 //
     /* 2404592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2404595 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2404598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2404612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404634 */     // GIR_Coverage, 54355,
     /* 2404634 */     GIR_EraseRootFromParent_Done,
     /* 2404635 */   // Label 34469: @2404635
     /* 2404635 */   GIM_Reject,
     /* 2404636 */ // Label 34467: @2404636
     /* 2404636 */ GIM_Reject,
     /* 2404637 */ // Label 34416: @2404637
     /* 2404637 */ GIM_Try, /*On fail goto*//*Label 34470*/ GIMT_Encode4(2404757),
     /* 2404642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2404645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2404648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404660 */   GIM_Try, /*On fail goto*//*Label 34471*/ GIMT_Encode4(2404708), // Rule ID 54402 //
     /* 2404665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2404668 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2404671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2404685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404707 */     // GIR_Coverage, 54402,
     /* 2404707 */     GIR_EraseRootFromParent_Done,
     /* 2404708 */   // Label 34471: @2404708
     /* 2404708 */   GIM_Try, /*On fail goto*//*Label 34472*/ GIMT_Encode4(2404756), // Rule ID 54403 //
     /* 2404713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2404716 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2404719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2404733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404755 */     // GIR_Coverage, 54403,
     /* 2404755 */     GIR_EraseRootFromParent_Done,
     /* 2404756 */   // Label 34472: @2404756
     /* 2404756 */   GIM_Reject,
     /* 2404757 */ // Label 34470: @2404757
     /* 2404757 */ GIM_Reject,
     /* 2404758 */ // Label 34417: @2404758
     /* 2404758 */ GIM_Try, /*On fail goto*//*Label 34473*/ GIMT_Encode4(2404878),
     /* 2404763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2404769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404781 */   GIM_Try, /*On fail goto*//*Label 34474*/ GIMT_Encode4(2404829), // Rule ID 54318 //
     /* 2404786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404789 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2404792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2404806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404828 */     // GIR_Coverage, 54318,
     /* 2404828 */     GIR_EraseRootFromParent_Done,
     /* 2404829 */   // Label 34474: @2404829
     /* 2404829 */   GIM_Try, /*On fail goto*//*Label 34475*/ GIMT_Encode4(2404877), // Rule ID 54319 //
     /* 2404834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404837 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2404840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2404854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404876 */     // GIR_Coverage, 54319,
     /* 2404876 */     GIR_EraseRootFromParent_Done,
     /* 2404877 */   // Label 34475: @2404877
     /* 2404877 */   GIM_Reject,
     /* 2404878 */ // Label 34473: @2404878
     /* 2404878 */ GIM_Reject,
     /* 2404879 */ // Label 34418: @2404879
     /* 2404879 */ GIM_Try, /*On fail goto*//*Label 34476*/ GIMT_Encode4(2404999),
     /* 2404884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2404887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2404890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404902 */   GIM_Try, /*On fail goto*//*Label 34477*/ GIMT_Encode4(2404950), // Rule ID 54366 //
     /* 2404907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2404910 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2404913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2404927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404949 */     // GIR_Coverage, 54366,
     /* 2404949 */     GIR_EraseRootFromParent_Done,
     /* 2404950 */   // Label 34477: @2404950
     /* 2404950 */   GIM_Try, /*On fail goto*//*Label 34478*/ GIMT_Encode4(2404998), // Rule ID 54367 //
     /* 2404955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2404958 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2404961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2404975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404997 */     // GIR_Coverage, 54367,
     /* 2404997 */     GIR_EraseRootFromParent_Done,
     /* 2404998 */   // Label 34478: @2404998
     /* 2404998 */   GIM_Reject,
     /* 2404999 */ // Label 34476: @2404999
     /* 2404999 */ GIM_Reject,
     /* 2405000 */ // Label 34419: @2405000
     /* 2405000 */ GIM_Try, /*On fail goto*//*Label 34479*/ GIMT_Encode4(2405120),
     /* 2405005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2405008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2405011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405023 */   GIM_Try, /*On fail goto*//*Label 34480*/ GIMT_Encode4(2405071), // Rule ID 54330 //
     /* 2405028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2405031 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2405031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2405034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2405038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2405043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2405045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2405048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2405053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2405066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2405069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405070 */     // GIR_Coverage, 54330,
     /* 2405070 */     GIR_EraseRootFromParent_Done,
     /* 2405071 */   // Label 34480: @2405071
     /* 2405071 */   GIM_Try, /*On fail goto*//*Label 34481*/ GIMT_Encode4(2405119), // Rule ID 54331 //
     /* 2405076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2405079 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2405079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2405082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2405086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2405091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2405093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2405096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2405101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2405114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2405117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405118 */     // GIR_Coverage, 54331,
     /* 2405118 */     GIR_EraseRootFromParent_Done,
     /* 2405119 */   // Label 34481: @2405119
     /* 2405119 */   GIM_Reject,
     /* 2405120 */ // Label 34479: @2405120
     /* 2405120 */ GIM_Reject,
     /* 2405121 */ // Label 34420: @2405121
     /* 2405121 */ GIM_Reject,
     /* 2405122 */ // Label 101: @2405122
     /* 2405122 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34500*/ GIMT_Encode4(2407549),
     /* 2405133 */ /*GILLT_s16*//*Label 34482*/ GIMT_Encode4(2405253),
     /* 2405137 */ /*GILLT_s32*//*Label 34483*/ GIMT_Encode4(2405402),
     /* 2405141 */ /*GILLT_s64*//*Label 34484*/ GIMT_Encode4(2405551), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2405153 */ /*GILLT_nxv1s16*//*Label 34485*/ GIMT_Encode4(2405734),
     /* 2405157 */ /*GILLT_nxv1s32*//*Label 34486*/ GIMT_Encode4(2405855),
     /* 2405161 */ /*GILLT_nxv1s64*//*Label 34487*/ GIMT_Encode4(2405976), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2405173 */ /*GILLT_nxv2s16*//*Label 34488*/ GIMT_Encode4(2406097),
     /* 2405177 */ /*GILLT_nxv2s32*//*Label 34489*/ GIMT_Encode4(2406218),
     /* 2405181 */ /*GILLT_nxv2s64*//*Label 34490*/ GIMT_Encode4(2406339), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2405193 */ /*GILLT_nxv4s16*//*Label 34491*/ GIMT_Encode4(2406460),
     /* 2405197 */ /*GILLT_nxv4s32*//*Label 34492*/ GIMT_Encode4(2406581),
     /* 2405201 */ /*GILLT_nxv4s64*//*Label 34493*/ GIMT_Encode4(2406702), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2405213 */ /*GILLT_nxv8s16*//*Label 34494*/ GIMT_Encode4(2406823),
     /* 2405217 */ /*GILLT_nxv8s32*//*Label 34495*/ GIMT_Encode4(2406944),
     /* 2405221 */ /*GILLT_nxv8s64*//*Label 34496*/ GIMT_Encode4(2407065), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2405233 */ /*GILLT_nxv16s16*//*Label 34497*/ GIMT_Encode4(2407186),
     /* 2405237 */ /*GILLT_nxv16s32*//*Label 34498*/ GIMT_Encode4(2407307), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2405249 */ /*GILLT_nxv32s16*//*Label 34499*/ GIMT_Encode4(2407428),
     /* 2405253 */ // Label 34482: @2405253
     /* 2405253 */ GIM_Try, /*On fail goto*//*Label 34501*/ GIMT_Encode4(2405401),
     /* 2405258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2405261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2405264 */   GIM_Try, /*On fail goto*//*Label 34502*/ GIMT_Encode4(2405298), // Rule ID 1988 //
     /* 2405269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2405272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405284 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2405284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2405287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405297 */     // GIR_Coverage, 1988,
     /* 2405297 */     GIR_EraseRootFromParent_Done,
     /* 2405298 */   // Label 34502: @2405298
     /* 2405298 */   GIM_Try, /*On fail goto*//*Label 34503*/ GIMT_Encode4(2405332), // Rule ID 1989 //
     /* 2405303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2405306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405318 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2405318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2405321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405331 */     // GIR_Coverage, 1989,
     /* 2405331 */     GIR_EraseRootFromParent_Done,
     /* 2405332 */   // Label 34503: @2405332
     /* 2405332 */   GIM_Try, /*On fail goto*//*Label 34504*/ GIMT_Encode4(2405366), // Rule ID 1992 //
     /* 2405337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2405340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405352 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2405352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2405355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405365 */     // GIR_Coverage, 1992,
     /* 2405365 */     GIR_EraseRootFromParent_Done,
     /* 2405366 */   // Label 34504: @2405366
     /* 2405366 */   GIM_Try, /*On fail goto*//*Label 34505*/ GIMT_Encode4(2405400), // Rule ID 1993 //
     /* 2405371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2405374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405386 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2405386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2405389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405399 */     // GIR_Coverage, 1993,
     /* 2405399 */     GIR_EraseRootFromParent_Done,
     /* 2405400 */   // Label 34505: @2405400
     /* 2405400 */   GIM_Reject,
     /* 2405401 */ // Label 34501: @2405401
     /* 2405401 */ GIM_Reject,
     /* 2405402 */ // Label 34483: @2405402
     /* 2405402 */ GIM_Try, /*On fail goto*//*Label 34506*/ GIMT_Encode4(2405550),
     /* 2405407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2405413 */   GIM_Try, /*On fail goto*//*Label 34507*/ GIMT_Encode4(2405447), // Rule ID 1279 //
     /* 2405418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2405421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405433 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2405433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2405436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405446 */     // GIR_Coverage, 1279,
     /* 2405446 */     GIR_EraseRootFromParent_Done,
     /* 2405447 */   // Label 34507: @2405447
     /* 2405447 */   GIM_Try, /*On fail goto*//*Label 34508*/ GIMT_Encode4(2405481), // Rule ID 1280 //
     /* 2405452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2405455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405467 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2405467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2405470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405480 */     // GIR_Coverage, 1280,
     /* 2405480 */     GIR_EraseRootFromParent_Done,
     /* 2405481 */   // Label 34508: @2405481
     /* 2405481 */   GIM_Try, /*On fail goto*//*Label 34509*/ GIMT_Encode4(2405515), // Rule ID 1283 //
     /* 2405486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2405489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405501 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2405501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2405504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405514 */     // GIR_Coverage, 1283,
     /* 2405514 */     GIR_EraseRootFromParent_Done,
     /* 2405515 */   // Label 34509: @2405515
     /* 2405515 */   GIM_Try, /*On fail goto*//*Label 34510*/ GIMT_Encode4(2405549), // Rule ID 1284 //
     /* 2405520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2405523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405535 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2405535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2405538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405548 */     // GIR_Coverage, 1284,
     /* 2405548 */     GIR_EraseRootFromParent_Done,
     /* 2405549 */   // Label 34510: @2405549
     /* 2405549 */   GIM_Reject,
     /* 2405550 */ // Label 34506: @2405550
     /* 2405550 */ GIM_Reject,
     /* 2405551 */ // Label 34484: @2405551
     /* 2405551 */ GIM_Try, /*On fail goto*//*Label 34511*/ GIMT_Encode4(2405733),
     /* 2405556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2405562 */   GIM_Try, /*On fail goto*//*Label 34512*/ GIMT_Encode4(2405596), // Rule ID 1620 //
     /* 2405567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2405570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405582 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2405582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2405585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405595 */     // GIR_Coverage, 1620,
     /* 2405595 */     GIR_EraseRootFromParent_Done,
     /* 2405596 */   // Label 34512: @2405596
     /* 2405596 */   GIM_Try, /*On fail goto*//*Label 34513*/ GIMT_Encode4(2405630), // Rule ID 1621 //
     /* 2405601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2405604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405616 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2405616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2405619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405629 */     // GIR_Coverage, 1621,
     /* 2405629 */     GIR_EraseRootFromParent_Done,
     /* 2405630 */   // Label 34513: @2405630
     /* 2405630 */   GIM_Try, /*On fail goto*//*Label 34514*/ GIMT_Encode4(2405664), // Rule ID 1624 //
     /* 2405635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2405638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405650 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2405650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2405653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405663 */     // GIR_Coverage, 1624,
     /* 2405663 */     GIR_EraseRootFromParent_Done,
     /* 2405664 */   // Label 34514: @2405664
     /* 2405664 */   GIM_Try, /*On fail goto*//*Label 34515*/ GIMT_Encode4(2405698), // Rule ID 1625 //
     /* 2405669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2405672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405684 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2405684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2405687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405697 */     // GIR_Coverage, 1625,
     /* 2405697 */     GIR_EraseRootFromParent_Done,
     /* 2405698 */   // Label 34515: @2405698
     /* 2405698 */   GIM_Try, /*On fail goto*//*Label 34516*/ GIMT_Encode4(2405732), // Rule ID 1628 //
     /* 2405703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2405706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405718 */     // (strict_fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2405718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2405721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405731 */     // GIR_Coverage, 1628,
     /* 2405731 */     GIR_EraseRootFromParent_Done,
     /* 2405732 */   // Label 34516: @2405732
     /* 2405732 */   GIM_Reject,
     /* 2405733 */ // Label 34511: @2405733
     /* 2405733 */ GIM_Reject,
     /* 2405734 */ // Label 34485: @2405734
     /* 2405734 */ GIM_Try, /*On fail goto*//*Label 34517*/ GIMT_Encode4(2405854),
     /* 2405739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2405742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2405745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405757 */   GIM_Try, /*On fail goto*//*Label 34518*/ GIMT_Encode4(2405805), // Rule ID 54414 //
     /* 2405762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2405765 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2405765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2405768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2405772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2405777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2405779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2405782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2405787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2405800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2405803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405804 */     // GIR_Coverage, 54414,
     /* 2405804 */     GIR_EraseRootFromParent_Done,
     /* 2405805 */   // Label 34518: @2405805
     /* 2405805 */   GIM_Try, /*On fail goto*//*Label 34519*/ GIMT_Encode4(2405853), // Rule ID 54415 //
     /* 2405810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2405813 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2405813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2405816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2405820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2405825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2405827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2405830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2405835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2405848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2405851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405852 */     // GIR_Coverage, 54415,
     /* 2405852 */     GIR_EraseRootFromParent_Done,
     /* 2405853 */   // Label 34519: @2405853
     /* 2405853 */   GIM_Reject,
     /* 2405854 */ // Label 34517: @2405854
     /* 2405854 */ GIM_Reject,
     /* 2405855 */ // Label 34486: @2405855
     /* 2405855 */ GIM_Try, /*On fail goto*//*Label 34520*/ GIMT_Encode4(2405975),
     /* 2405860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2405863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2405866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405878 */   GIM_Try, /*On fail goto*//*Label 34521*/ GIMT_Encode4(2405926), // Rule ID 54438 //
     /* 2405883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2405886 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2405886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2405889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2405893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2405898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2405900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2405903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2405908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2405924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405925 */     // GIR_Coverage, 54438,
     /* 2405925 */     GIR_EraseRootFromParent_Done,
     /* 2405926 */   // Label 34521: @2405926
     /* 2405926 */   GIM_Try, /*On fail goto*//*Label 34522*/ GIMT_Encode4(2405974), // Rule ID 54439 //
     /* 2405931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2405934 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2405934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2405937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2405941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2405946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2405948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2405951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2405956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2405972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405973 */     // GIR_Coverage, 54439,
     /* 2405973 */     GIR_EraseRootFromParent_Done,
     /* 2405974 */   // Label 34522: @2405974
     /* 2405974 */   GIM_Reject,
     /* 2405975 */ // Label 34520: @2405975
     /* 2405975 */ GIM_Reject,
     /* 2405976 */ // Label 34487: @2405976
     /* 2405976 */ GIM_Try, /*On fail goto*//*Label 34523*/ GIMT_Encode4(2406096),
     /* 2405981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2405984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2405987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405999 */   GIM_Try, /*On fail goto*//*Label 34524*/ GIMT_Encode4(2406047), // Rule ID 54474 //
     /* 2406004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2406007 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2406010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2406024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2406042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406046 */     // GIR_Coverage, 54474,
     /* 2406046 */     GIR_EraseRootFromParent_Done,
     /* 2406047 */   // Label 34524: @2406047
     /* 2406047 */   GIM_Try, /*On fail goto*//*Label 34525*/ GIMT_Encode4(2406095), // Rule ID 54475 //
     /* 2406052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2406055 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2406058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2406072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2406090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406094 */     // GIR_Coverage, 54475,
     /* 2406094 */     GIR_EraseRootFromParent_Done,
     /* 2406095 */   // Label 34525: @2406095
     /* 2406095 */   GIM_Reject,
     /* 2406096 */ // Label 34523: @2406096
     /* 2406096 */ GIM_Reject,
     /* 2406097 */ // Label 34488: @2406097
     /* 2406097 */ GIM_Try, /*On fail goto*//*Label 34526*/ GIMT_Encode4(2406217),
     /* 2406102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2406105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2406108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406120 */   GIM_Try, /*On fail goto*//*Label 34527*/ GIMT_Encode4(2406168), // Rule ID 54426 //
     /* 2406125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406128 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2406131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2406145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406167 */     // GIR_Coverage, 54426,
     /* 2406167 */     GIR_EraseRootFromParent_Done,
     /* 2406168 */   // Label 34527: @2406168
     /* 2406168 */   GIM_Try, /*On fail goto*//*Label 34528*/ GIMT_Encode4(2406216), // Rule ID 54427 //
     /* 2406173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406176 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2406179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2406193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406215 */     // GIR_Coverage, 54427,
     /* 2406215 */     GIR_EraseRootFromParent_Done,
     /* 2406216 */   // Label 34528: @2406216
     /* 2406216 */   GIM_Reject,
     /* 2406217 */ // Label 34526: @2406217
     /* 2406217 */ GIM_Reject,
     /* 2406218 */ // Label 34489: @2406218
     /* 2406218 */ GIM_Try, /*On fail goto*//*Label 34529*/ GIMT_Encode4(2406338),
     /* 2406223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2406226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2406229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406241 */   GIM_Try, /*On fail goto*//*Label 34530*/ GIMT_Encode4(2406289), // Rule ID 54462 //
     /* 2406246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2406249 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2406252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2406266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2406284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406288 */     // GIR_Coverage, 54462,
     /* 2406288 */     GIR_EraseRootFromParent_Done,
     /* 2406289 */   // Label 34530: @2406289
     /* 2406289 */   GIM_Try, /*On fail goto*//*Label 34531*/ GIMT_Encode4(2406337), // Rule ID 54463 //
     /* 2406294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2406297 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2406300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2406314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2406332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406336 */     // GIR_Coverage, 54463,
     /* 2406336 */     GIR_EraseRootFromParent_Done,
     /* 2406337 */   // Label 34531: @2406337
     /* 2406337 */   GIM_Reject,
     /* 2406338 */ // Label 34529: @2406338
     /* 2406338 */ GIM_Reject,
     /* 2406339 */ // Label 34490: @2406339
     /* 2406339 */ GIM_Try, /*On fail goto*//*Label 34532*/ GIMT_Encode4(2406459),
     /* 2406344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2406347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2406350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406362 */   GIM_Try, /*On fail goto*//*Label 34533*/ GIMT_Encode4(2406410), // Rule ID 54558 //
     /* 2406367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2406370 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2406373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2406387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2406405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406409 */     // GIR_Coverage, 54558,
     /* 2406409 */     GIR_EraseRootFromParent_Done,
     /* 2406410 */   // Label 34533: @2406410
     /* 2406410 */   GIM_Try, /*On fail goto*//*Label 34534*/ GIMT_Encode4(2406458), // Rule ID 54559 //
     /* 2406415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2406418 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2406421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2406435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2406453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406457 */     // GIR_Coverage, 54559,
     /* 2406457 */     GIR_EraseRootFromParent_Done,
     /* 2406458 */   // Label 34534: @2406458
     /* 2406458 */   GIM_Reject,
     /* 2406459 */ // Label 34532: @2406459
     /* 2406459 */ GIM_Reject,
     /* 2406460 */ // Label 34491: @2406460
     /* 2406460 */ GIM_Try, /*On fail goto*//*Label 34535*/ GIMT_Encode4(2406580),
     /* 2406465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2406468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2406471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406483 */   GIM_Try, /*On fail goto*//*Label 34536*/ GIMT_Encode4(2406531), // Rule ID 54450 //
     /* 2406488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406491 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2406494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2406508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406530 */     // GIR_Coverage, 54450,
     /* 2406530 */     GIR_EraseRootFromParent_Done,
     /* 2406531 */   // Label 34536: @2406531
     /* 2406531 */   GIM_Try, /*On fail goto*//*Label 34537*/ GIMT_Encode4(2406579), // Rule ID 54451 //
     /* 2406536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406539 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2406542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2406556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406578 */     // GIR_Coverage, 54451,
     /* 2406578 */     GIR_EraseRootFromParent_Done,
     /* 2406579 */   // Label 34537: @2406579
     /* 2406579 */   GIM_Reject,
     /* 2406580 */ // Label 34535: @2406580
     /* 2406580 */ GIM_Reject,
     /* 2406581 */ // Label 34492: @2406581
     /* 2406581 */ GIM_Try, /*On fail goto*//*Label 34538*/ GIMT_Encode4(2406701),
     /* 2406586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2406589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2406592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406604 */   GIM_Try, /*On fail goto*//*Label 34539*/ GIMT_Encode4(2406652), // Rule ID 54522 //
     /* 2406609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2406612 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2406615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2406629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2406647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406651 */     // GIR_Coverage, 54522,
     /* 2406651 */     GIR_EraseRootFromParent_Done,
     /* 2406652 */   // Label 34539: @2406652
     /* 2406652 */   GIM_Try, /*On fail goto*//*Label 34540*/ GIMT_Encode4(2406700), // Rule ID 54523 //
     /* 2406657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2406660 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2406663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2406677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2406695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406699 */     // GIR_Coverage, 54523,
     /* 2406699 */     GIR_EraseRootFromParent_Done,
     /* 2406700 */   // Label 34540: @2406700
     /* 2406700 */   GIM_Reject,
     /* 2406701 */ // Label 34538: @2406701
     /* 2406701 */ GIM_Reject,
     /* 2406702 */ // Label 34493: @2406702
     /* 2406702 */ GIM_Try, /*On fail goto*//*Label 34541*/ GIMT_Encode4(2406822),
     /* 2406707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2406710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2406713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2406717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2406721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2406725 */   GIM_Try, /*On fail goto*//*Label 34542*/ GIMT_Encode4(2406773), // Rule ID 54570 //
     /* 2406730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2406733 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2406736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2406750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2406768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406772 */     // GIR_Coverage, 54570,
     /* 2406772 */     GIR_EraseRootFromParent_Done,
     /* 2406773 */   // Label 34542: @2406773
     /* 2406773 */   GIM_Try, /*On fail goto*//*Label 34543*/ GIMT_Encode4(2406821), // Rule ID 54571 //
     /* 2406778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2406781 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2406784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2406798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2406816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406820 */     // GIR_Coverage, 54571,
     /* 2406820 */     GIR_EraseRootFromParent_Done,
     /* 2406821 */   // Label 34543: @2406821
     /* 2406821 */   GIM_Reject,
     /* 2406822 */ // Label 34541: @2406822
     /* 2406822 */ GIM_Reject,
     /* 2406823 */ // Label 34494: @2406823
     /* 2406823 */ GIM_Try, /*On fail goto*//*Label 34544*/ GIMT_Encode4(2406943),
     /* 2406828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2406831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2406834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406842 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406846 */   GIM_Try, /*On fail goto*//*Label 34545*/ GIMT_Encode4(2406894), // Rule ID 54486 //
     /* 2406851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406854 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2406857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2406871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406893 */     // GIR_Coverage, 54486,
     /* 2406893 */     GIR_EraseRootFromParent_Done,
     /* 2406894 */   // Label 34545: @2406894
     /* 2406894 */   GIM_Try, /*On fail goto*//*Label 34546*/ GIMT_Encode4(2406942), // Rule ID 54487 //
     /* 2406899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406902 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2406905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2406919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406941 */     // GIR_Coverage, 54487,
     /* 2406941 */     GIR_EraseRootFromParent_Done,
     /* 2406942 */   // Label 34546: @2406942
     /* 2406942 */   GIM_Reject,
     /* 2406943 */ // Label 34544: @2406943
     /* 2406943 */ GIM_Reject,
     /* 2406944 */ // Label 34495: @2406944
     /* 2406944 */ GIM_Try, /*On fail goto*//*Label 34547*/ GIMT_Encode4(2407064),
     /* 2406949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2406952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2406955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2406959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2406963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2406967 */   GIM_Try, /*On fail goto*//*Label 34548*/ GIMT_Encode4(2407015), // Rule ID 54534 //
     /* 2406972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2406975 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2406978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2406992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407014 */     // GIR_Coverage, 54534,
     /* 2407014 */     GIR_EraseRootFromParent_Done,
     /* 2407015 */   // Label 34548: @2407015
     /* 2407015 */   GIM_Try, /*On fail goto*//*Label 34549*/ GIMT_Encode4(2407063), // Rule ID 54535 //
     /* 2407020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407023 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2407026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2407040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407062 */     // GIR_Coverage, 54535,
     /* 2407062 */     GIR_EraseRootFromParent_Done,
     /* 2407063 */   // Label 34549: @2407063
     /* 2407063 */   GIM_Reject,
     /* 2407064 */ // Label 34547: @2407064
     /* 2407064 */ GIM_Reject,
     /* 2407065 */ // Label 34496: @2407065
     /* 2407065 */ GIM_Try, /*On fail goto*//*Label 34550*/ GIMT_Encode4(2407185),
     /* 2407070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2407073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2407076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407088 */   GIM_Try, /*On fail goto*//*Label 34551*/ GIMT_Encode4(2407136), // Rule ID 54582 //
     /* 2407093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2407096 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2407099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2407113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2407131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407135 */     // GIR_Coverage, 54582,
     /* 2407135 */     GIR_EraseRootFromParent_Done,
     /* 2407136 */   // Label 34551: @2407136
     /* 2407136 */   GIM_Try, /*On fail goto*//*Label 34552*/ GIMT_Encode4(2407184), // Rule ID 54583 //
     /* 2407141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2407144 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2407147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2407161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2407179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407183 */     // GIR_Coverage, 54583,
     /* 2407183 */     GIR_EraseRootFromParent_Done,
     /* 2407184 */   // Label 34552: @2407184
     /* 2407184 */   GIM_Reject,
     /* 2407185 */ // Label 34550: @2407185
     /* 2407185 */ GIM_Reject,
     /* 2407186 */ // Label 34497: @2407186
     /* 2407186 */ GIM_Try, /*On fail goto*//*Label 34553*/ GIMT_Encode4(2407306),
     /* 2407191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2407194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2407197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2407201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2407205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2407209 */   GIM_Try, /*On fail goto*//*Label 34554*/ GIMT_Encode4(2407257), // Rule ID 54498 //
     /* 2407214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2407217 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2407220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2407234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407256 */     // GIR_Coverage, 54498,
     /* 2407256 */     GIR_EraseRootFromParent_Done,
     /* 2407257 */   // Label 34554: @2407257
     /* 2407257 */   GIM_Try, /*On fail goto*//*Label 34555*/ GIMT_Encode4(2407305), // Rule ID 54499 //
     /* 2407262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2407265 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2407268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2407282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407304 */     // GIR_Coverage, 54499,
     /* 2407304 */     GIR_EraseRootFromParent_Done,
     /* 2407305 */   // Label 34555: @2407305
     /* 2407305 */   GIM_Reject,
     /* 2407306 */ // Label 34553: @2407306
     /* 2407306 */ GIM_Reject,
     /* 2407307 */ // Label 34498: @2407307
     /* 2407307 */ GIM_Try, /*On fail goto*//*Label 34556*/ GIMT_Encode4(2407427),
     /* 2407312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2407315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2407318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407330 */   GIM_Try, /*On fail goto*//*Label 34557*/ GIMT_Encode4(2407378), // Rule ID 54546 //
     /* 2407335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407338 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2407341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2407355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407377 */     // GIR_Coverage, 54546,
     /* 2407377 */     GIR_EraseRootFromParent_Done,
     /* 2407378 */   // Label 34557: @2407378
     /* 2407378 */   GIM_Try, /*On fail goto*//*Label 34558*/ GIMT_Encode4(2407426), // Rule ID 54547 //
     /* 2407383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407386 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2407389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2407403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407425 */     // GIR_Coverage, 54547,
     /* 2407425 */     GIR_EraseRootFromParent_Done,
     /* 2407426 */   // Label 34558: @2407426
     /* 2407426 */   GIM_Reject,
     /* 2407427 */ // Label 34556: @2407427
     /* 2407427 */ GIM_Reject,
     /* 2407428 */ // Label 34499: @2407428
     /* 2407428 */ GIM_Try, /*On fail goto*//*Label 34559*/ GIMT_Encode4(2407548),
     /* 2407433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2407436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2407439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407451 */   GIM_Try, /*On fail goto*//*Label 34560*/ GIMT_Encode4(2407499), // Rule ID 54510 //
     /* 2407456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2407459 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2407462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2407476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407498 */     // GIR_Coverage, 54510,
     /* 2407498 */     GIR_EraseRootFromParent_Done,
     /* 2407499 */   // Label 34560: @2407499
     /* 2407499 */   GIM_Try, /*On fail goto*//*Label 34561*/ GIMT_Encode4(2407547), // Rule ID 54511 //
     /* 2407504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2407507 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2407510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2407524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407546 */     // GIR_Coverage, 54511,
     /* 2407546 */     GIR_EraseRootFromParent_Done,
     /* 2407547 */   // Label 34561: @2407547
     /* 2407547 */   GIM_Reject,
     /* 2407548 */ // Label 34559: @2407548
     /* 2407548 */ GIM_Reject,
     /* 2407549 */ // Label 34500: @2407549
     /* 2407549 */ GIM_Reject,
     /* 2407550 */ // Label 102: @2407550
     /* 2407550 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34580*/ GIMT_Encode4(2424194),
     /* 2407561 */ /*GILLT_s16*//*Label 34562*/ GIMT_Encode4(2407681),
     /* 2407565 */ /*GILLT_s32*//*Label 34563*/ GIMT_Encode4(2409117),
     /* 2407569 */ /*GILLT_s64*//*Label 34564*/ GIMT_Encode4(2410553), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2407581 */ /*GILLT_nxv1s16*//*Label 34565*/ GIMT_Encode4(2412344),
     /* 2407585 */ /*GILLT_nxv1s32*//*Label 34566*/ GIMT_Encode4(2413134),
     /* 2407589 */ /*GILLT_nxv1s64*//*Label 34567*/ GIMT_Encode4(2413924), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2407601 */ /*GILLT_nxv2s16*//*Label 34568*/ GIMT_Encode4(2414714),
     /* 2407605 */ /*GILLT_nxv2s32*//*Label 34569*/ GIMT_Encode4(2415504),
     /* 2407609 */ /*GILLT_nxv2s64*//*Label 34570*/ GIMT_Encode4(2416294), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2407621 */ /*GILLT_nxv4s16*//*Label 34571*/ GIMT_Encode4(2417084),
     /* 2407625 */ /*GILLT_nxv4s32*//*Label 34572*/ GIMT_Encode4(2417874),
     /* 2407629 */ /*GILLT_nxv4s64*//*Label 34573*/ GIMT_Encode4(2418664), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2407641 */ /*GILLT_nxv8s16*//*Label 34574*/ GIMT_Encode4(2419454),
     /* 2407645 */ /*GILLT_nxv8s32*//*Label 34575*/ GIMT_Encode4(2420244),
     /* 2407649 */ /*GILLT_nxv8s64*//*Label 34576*/ GIMT_Encode4(2421034), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2407661 */ /*GILLT_nxv16s16*//*Label 34577*/ GIMT_Encode4(2421824),
     /* 2407665 */ /*GILLT_nxv16s32*//*Label 34578*/ GIMT_Encode4(2422614), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2407677 */ /*GILLT_nxv32s16*//*Label 34579*/ GIMT_Encode4(2423404),
     /* 2407681 */ // Label 34562: @2407681
     /* 2407681 */ GIM_Try, /*On fail goto*//*Label 34581*/ GIMT_Encode4(2409116),
     /* 2407686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2407692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2407695 */   GIM_Try, /*On fail goto*//*Label 34582*/ GIMT_Encode4(2407767), // Rule ID 2021 //
     /* 2407700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2407703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407747 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2407747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2407750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407766 */     // GIR_Coverage, 2021,
     /* 2407766 */     GIR_EraseRootFromParent_Done,
     /* 2407767 */   // Label 34582: @2407767
     /* 2407767 */   GIM_Try, /*On fail goto*//*Label 34583*/ GIMT_Encode4(2407839), // Rule ID 2022 //
     /* 2407772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2407775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407819 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2407819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2407822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407838 */     // GIR_Coverage, 2022,
     /* 2407838 */     GIR_EraseRootFromParent_Done,
     /* 2407839 */   // Label 34583: @2407839
     /* 2407839 */   GIM_Try, /*On fail goto*//*Label 34584*/ GIMT_Encode4(2407911), // Rule ID 2054 //
     /* 2407844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2407847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407891 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2407891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2407894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407910 */     // GIR_Coverage, 2054,
     /* 2407910 */     GIR_EraseRootFromParent_Done,
     /* 2407911 */   // Label 34584: @2407911
     /* 2407911 */   GIM_Try, /*On fail goto*//*Label 34585*/ GIMT_Encode4(2407983), // Rule ID 2055 //
     /* 2407916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2407919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407963 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2407963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2407966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407982 */     // GIR_Coverage, 2055,
     /* 2407982 */     GIR_EraseRootFromParent_Done,
     /* 2407983 */   // Label 34585: @2407983
     /* 2407983 */   GIM_Try, /*On fail goto*//*Label 34586*/ GIMT_Encode4(2408055), // Rule ID 65535 //
     /* 2407988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2407991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408035 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2408038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2408050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408054 */     // GIR_Coverage, 65535,
     /* 2408054 */     GIR_EraseRootFromParent_Done,
     /* 2408055 */   // Label 34586: @2408055
     /* 2408055 */   GIM_Try, /*On fail goto*//*Label 34587*/ GIMT_Encode4(2408127), // Rule ID 65536 //
     /* 2408060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2408063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408107 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2408110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2408122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408126 */     // GIR_Coverage, 65536,
     /* 2408126 */     GIR_EraseRootFromParent_Done,
     /* 2408127 */   // Label 34587: @2408127
     /* 2408127 */   GIM_Try, /*On fail goto*//*Label 34588*/ GIMT_Encode4(2408199), // Rule ID 65543 //
     /* 2408132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2408135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408179 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2408182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2408194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408198 */     // GIR_Coverage, 65543,
     /* 2408198 */     GIR_EraseRootFromParent_Done,
     /* 2408199 */   // Label 34588: @2408199
     /* 2408199 */   GIM_Try, /*On fail goto*//*Label 34589*/ GIMT_Encode4(2408271), // Rule ID 65544 //
     /* 2408204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2408207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408251 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2408254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2408266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408270 */     // GIR_Coverage, 65544,
     /* 2408270 */     GIR_EraseRootFromParent_Done,
     /* 2408271 */   // Label 34589: @2408271
     /* 2408271 */   GIM_Try, /*On fail goto*//*Label 34590*/ GIMT_Encode4(2408328), // Rule ID 2017 //
     /* 2408276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2408279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408310 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2408313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408327 */     // GIR_Coverage, 2017,
     /* 2408327 */     GIR_EraseRootFromParent_Done,
     /* 2408328 */   // Label 34590: @2408328
     /* 2408328 */   GIM_Try, /*On fail goto*//*Label 34591*/ GIMT_Encode4(2408385), // Rule ID 2018 //
     /* 2408333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2408336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408367 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2408370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408384 */     // GIR_Coverage, 2018,
     /* 2408384 */     GIR_EraseRootFromParent_Done,
     /* 2408385 */   // Label 34591: @2408385
     /* 2408385 */   GIM_Try, /*On fail goto*//*Label 34592*/ GIMT_Encode4(2408442), // Rule ID 2050 //
     /* 2408390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2408393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408424 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2408427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408441 */     // GIR_Coverage, 2050,
     /* 2408441 */     GIR_EraseRootFromParent_Done,
     /* 2408442 */   // Label 34592: @2408442
     /* 2408442 */   GIM_Try, /*On fail goto*//*Label 34593*/ GIMT_Encode4(2408499), // Rule ID 2051 //
     /* 2408447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2408450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408481 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2408484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408498 */     // GIR_Coverage, 2051,
     /* 2408498 */     GIR_EraseRootFromParent_Done,
     /* 2408499 */   // Label 34593: @2408499
     /* 2408499 */   GIM_Try, /*On fail goto*//*Label 34594*/ GIMT_Encode4(2408556), // Rule ID 65531 //
     /* 2408504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2408507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408538 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2408541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408555 */     // GIR_Coverage, 65531,
     /* 2408555 */     GIR_EraseRootFromParent_Done,
     /* 2408556 */   // Label 34594: @2408556
     /* 2408556 */   GIM_Try, /*On fail goto*//*Label 34595*/ GIMT_Encode4(2408613), // Rule ID 65532 //
     /* 2408561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2408564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408595 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2408598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408612 */     // GIR_Coverage, 65532,
     /* 2408612 */     GIR_EraseRootFromParent_Done,
     /* 2408613 */   // Label 34595: @2408613
     /* 2408613 */   GIM_Try, /*On fail goto*//*Label 34596*/ GIMT_Encode4(2408670), // Rule ID 65539 //
     /* 2408618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2408621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408652 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2408655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408669 */     // GIR_Coverage, 65539,
     /* 2408669 */     GIR_EraseRootFromParent_Done,
     /* 2408670 */   // Label 34596: @2408670
     /* 2408670 */   GIM_Try, /*On fail goto*//*Label 34597*/ GIMT_Encode4(2408727), // Rule ID 65540 //
     /* 2408675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2408678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408709 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2408712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408726 */     // GIR_Coverage, 65540,
     /* 2408726 */     GIR_EraseRootFromParent_Done,
     /* 2408727 */   // Label 34597: @2408727
     /* 2408727 */   GIM_Try, /*On fail goto*//*Label 34598*/ GIMT_Encode4(2408784), // Rule ID 2013 //
     /* 2408732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2408735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408766 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2408769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408783 */     // GIR_Coverage, 2013,
     /* 2408783 */     GIR_EraseRootFromParent_Done,
     /* 2408784 */   // Label 34598: @2408784
     /* 2408784 */   GIM_Try, /*On fail goto*//*Label 34599*/ GIMT_Encode4(2408841), // Rule ID 2014 //
     /* 2408789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2408792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408823 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2408826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408840 */     // GIR_Coverage, 2014,
     /* 2408840 */     GIR_EraseRootFromParent_Done,
     /* 2408841 */   // Label 34599: @2408841
     /* 2408841 */   GIM_Try, /*On fail goto*//*Label 34600*/ GIMT_Encode4(2408898), // Rule ID 2046 //
     /* 2408846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2408849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408880 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2408883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408897 */     // GIR_Coverage, 2046,
     /* 2408897 */     GIR_EraseRootFromParent_Done,
     /* 2408898 */   // Label 34600: @2408898
     /* 2408898 */   GIM_Try, /*On fail goto*//*Label 34601*/ GIMT_Encode4(2408955), // Rule ID 2047 //
     /* 2408903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2408906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408937 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2408940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408954 */     // GIR_Coverage, 2047,
     /* 2408954 */     GIR_EraseRootFromParent_Done,
     /* 2408955 */   // Label 34601: @2408955
     /* 2408955 */   GIM_Try, /*On fail goto*//*Label 34602*/ GIMT_Encode4(2408995), // Rule ID 2009 //
     /* 2408960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2408963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408979 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2408982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408994 */     // GIR_Coverage, 2009,
     /* 2408994 */     GIR_EraseRootFromParent_Done,
     /* 2408995 */   // Label 34602: @2408995
     /* 2408995 */   GIM_Try, /*On fail goto*//*Label 34603*/ GIMT_Encode4(2409035), // Rule ID 2010 //
     /* 2409000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2409003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2409007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2409011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2409015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2409019 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2409019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2409022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409034 */     // GIR_Coverage, 2010,
     /* 2409034 */     GIR_EraseRootFromParent_Done,
     /* 2409035 */   // Label 34603: @2409035
     /* 2409035 */   GIM_Try, /*On fail goto*//*Label 34604*/ GIMT_Encode4(2409075), // Rule ID 2042 //
     /* 2409040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2409043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409059 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2409059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2409062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409074 */     // GIR_Coverage, 2042,
     /* 2409074 */     GIR_EraseRootFromParent_Done,
     /* 2409075 */   // Label 34604: @2409075
     /* 2409075 */   GIM_Try, /*On fail goto*//*Label 34605*/ GIMT_Encode4(2409115), // Rule ID 2043 //
     /* 2409080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2409083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409099 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2409099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2409102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409114 */     // GIR_Coverage, 2043,
     /* 2409114 */     GIR_EraseRootFromParent_Done,
     /* 2409115 */   // Label 34605: @2409115
     /* 2409115 */   GIM_Reject,
     /* 2409116 */ // Label 34581: @2409116
     /* 2409116 */ GIM_Reject,
     /* 2409117 */ // Label 34563: @2409117
     /* 2409117 */ GIM_Try, /*On fail goto*//*Label 34606*/ GIMT_Encode4(2410552),
     /* 2409122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2409128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2409131 */   GIM_Try, /*On fail goto*//*Label 34607*/ GIMT_Encode4(2409203), // Rule ID 1320 //
     /* 2409136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2409139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409183 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2409186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409202 */     // GIR_Coverage, 1320,
     /* 2409202 */     GIR_EraseRootFromParent_Done,
     /* 2409203 */   // Label 34607: @2409203
     /* 2409203 */   GIM_Try, /*On fail goto*//*Label 34608*/ GIMT_Encode4(2409275), // Rule ID 1321 //
     /* 2409208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2409211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409255 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2409255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2409258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409274 */     // GIR_Coverage, 1321,
     /* 2409274 */     GIR_EraseRootFromParent_Done,
     /* 2409275 */   // Label 34608: @2409275
     /* 2409275 */   GIM_Try, /*On fail goto*//*Label 34609*/ GIMT_Encode4(2409347), // Rule ID 1341 //
     /* 2409280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2409283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409327 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2409330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409346 */     // GIR_Coverage, 1341,
     /* 2409346 */     GIR_EraseRootFromParent_Done,
     /* 2409347 */   // Label 34609: @2409347
     /* 2409347 */   GIM_Try, /*On fail goto*//*Label 34610*/ GIMT_Encode4(2409419), // Rule ID 1342 //
     /* 2409352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2409355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409399 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2409399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2409402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409418 */     // GIR_Coverage, 1342,
     /* 2409418 */     GIR_EraseRootFromParent_Done,
     /* 2409419 */   // Label 34610: @2409419
     /* 2409419 */   GIM_Try, /*On fail goto*//*Label 34611*/ GIMT_Encode4(2409491), // Rule ID 65499 //
     /* 2409424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2409427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409471 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2409474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2409482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409490 */     // GIR_Coverage, 65499,
     /* 2409490 */     GIR_EraseRootFromParent_Done,
     /* 2409491 */   // Label 34611: @2409491
     /* 2409491 */   GIM_Try, /*On fail goto*//*Label 34612*/ GIMT_Encode4(2409563), // Rule ID 65500 //
     /* 2409496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2409499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409543 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2409543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2409546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2409554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409562 */     // GIR_Coverage, 65500,
     /* 2409562 */     GIR_EraseRootFromParent_Done,
     /* 2409563 */   // Label 34612: @2409563
     /* 2409563 */   GIM_Try, /*On fail goto*//*Label 34613*/ GIMT_Encode4(2409635), // Rule ID 65507 //
     /* 2409568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2409571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409615 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2409618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2409626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409634 */     // GIR_Coverage, 65507,
     /* 2409634 */     GIR_EraseRootFromParent_Done,
     /* 2409635 */   // Label 34613: @2409635
     /* 2409635 */   GIM_Try, /*On fail goto*//*Label 34614*/ GIMT_Encode4(2409707), // Rule ID 65508 //
     /* 2409640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2409643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409687 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2409687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2409690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2409698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409706 */     // GIR_Coverage, 65508,
     /* 2409706 */     GIR_EraseRootFromParent_Done,
     /* 2409707 */   // Label 34614: @2409707
     /* 2409707 */   GIM_Try, /*On fail goto*//*Label 34615*/ GIMT_Encode4(2409764), // Rule ID 1316 //
     /* 2409712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2409715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409746 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2409749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409763 */     // GIR_Coverage, 1316,
     /* 2409763 */     GIR_EraseRootFromParent_Done,
     /* 2409764 */   // Label 34615: @2409764
     /* 2409764 */   GIM_Try, /*On fail goto*//*Label 34616*/ GIMT_Encode4(2409821), // Rule ID 1317 //
     /* 2409769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2409772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409803 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2409803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2409806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409820 */     // GIR_Coverage, 1317,
     /* 2409820 */     GIR_EraseRootFromParent_Done,
     /* 2409821 */   // Label 34616: @2409821
     /* 2409821 */   GIM_Try, /*On fail goto*//*Label 34617*/ GIMT_Encode4(2409878), // Rule ID 1337 //
     /* 2409826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2409829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409860 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2409863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409877 */     // GIR_Coverage, 1337,
     /* 2409877 */     GIR_EraseRootFromParent_Done,
     /* 2409878 */   // Label 34617: @2409878
     /* 2409878 */   GIM_Try, /*On fail goto*//*Label 34618*/ GIMT_Encode4(2409935), // Rule ID 1338 //
     /* 2409883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2409886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409917 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2409917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2409920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409934 */     // GIR_Coverage, 1338,
     /* 2409934 */     GIR_EraseRootFromParent_Done,
     /* 2409935 */   // Label 34618: @2409935
     /* 2409935 */   GIM_Try, /*On fail goto*//*Label 34619*/ GIMT_Encode4(2409992), // Rule ID 65495 //
     /* 2409940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2409943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409974 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2409977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2409985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409991 */     // GIR_Coverage, 65495,
     /* 2409991 */     GIR_EraseRootFromParent_Done,
     /* 2409992 */   // Label 34619: @2409992
     /* 2409992 */   GIM_Try, /*On fail goto*//*Label 34620*/ GIMT_Encode4(2410049), // Rule ID 65496 //
     /* 2409997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2410000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410031 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2410031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2410034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2410042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410048 */     // GIR_Coverage, 65496,
     /* 2410048 */     GIR_EraseRootFromParent_Done,
     /* 2410049 */   // Label 34620: @2410049
     /* 2410049 */   GIM_Try, /*On fail goto*//*Label 34621*/ GIMT_Encode4(2410106), // Rule ID 65503 //
     /* 2410054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2410057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410088 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2410088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2410091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2410099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410105 */     // GIR_Coverage, 65503,
     /* 2410105 */     GIR_EraseRootFromParent_Done,
     /* 2410106 */   // Label 34621: @2410106
     /* 2410106 */   GIM_Try, /*On fail goto*//*Label 34622*/ GIMT_Encode4(2410163), // Rule ID 65504 //
     /* 2410111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2410114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410145 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2410145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2410148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2410156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410162 */     // GIR_Coverage, 65504,
     /* 2410162 */     GIR_EraseRootFromParent_Done,
     /* 2410163 */   // Label 34622: @2410163
     /* 2410163 */   GIM_Try, /*On fail goto*//*Label 34623*/ GIMT_Encode4(2410220), // Rule ID 1312 //
     /* 2410168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2410171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410202 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2410202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2410205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2410215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410219 */     // GIR_Coverage, 1312,
     /* 2410219 */     GIR_EraseRootFromParent_Done,
     /* 2410220 */   // Label 34623: @2410220
     /* 2410220 */   GIM_Try, /*On fail goto*//*Label 34624*/ GIMT_Encode4(2410277), // Rule ID 1313 //
     /* 2410225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2410228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410259 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2410259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2410262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2410272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410276 */     // GIR_Coverage, 1313,
     /* 2410276 */     GIR_EraseRootFromParent_Done,
     /* 2410277 */   // Label 34624: @2410277
     /* 2410277 */   GIM_Try, /*On fail goto*//*Label 34625*/ GIMT_Encode4(2410334), // Rule ID 1333 //
     /* 2410282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2410285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410316 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2410316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2410319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2410329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410333 */     // GIR_Coverage, 1333,
     /* 2410333 */     GIR_EraseRootFromParent_Done,
     /* 2410334 */   // Label 34625: @2410334
     /* 2410334 */   GIM_Try, /*On fail goto*//*Label 34626*/ GIMT_Encode4(2410391), // Rule ID 1334 //
     /* 2410339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2410342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410373 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2410373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2410376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2410386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410390 */     // GIR_Coverage, 1334,
     /* 2410390 */     GIR_EraseRootFromParent_Done,
     /* 2410391 */   // Label 34626: @2410391
     /* 2410391 */   GIM_Try, /*On fail goto*//*Label 34627*/ GIMT_Encode4(2410431), // Rule ID 1308 //
     /* 2410396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2410399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410415 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2410415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2410418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410430 */     // GIR_Coverage, 1308,
     /* 2410430 */     GIR_EraseRootFromParent_Done,
     /* 2410431 */   // Label 34627: @2410431
     /* 2410431 */   GIM_Try, /*On fail goto*//*Label 34628*/ GIMT_Encode4(2410471), // Rule ID 1309 //
     /* 2410436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2410439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410455 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2410455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2410458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410470 */     // GIR_Coverage, 1309,
     /* 2410470 */     GIR_EraseRootFromParent_Done,
     /* 2410471 */   // Label 34628: @2410471
     /* 2410471 */   GIM_Try, /*On fail goto*//*Label 34629*/ GIMT_Encode4(2410511), // Rule ID 1329 //
     /* 2410476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2410479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410495 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2410495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2410498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410510 */     // GIR_Coverage, 1329,
     /* 2410510 */     GIR_EraseRootFromParent_Done,
     /* 2410511 */   // Label 34629: @2410511
     /* 2410511 */   GIM_Try, /*On fail goto*//*Label 34630*/ GIMT_Encode4(2410551), // Rule ID 1330 //
     /* 2410516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2410519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410535 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2410535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2410538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410550 */     // GIR_Coverage, 1330,
     /* 2410550 */     GIR_EraseRootFromParent_Done,
     /* 2410551 */   // Label 34630: @2410551
     /* 2410551 */   GIM_Reject,
     /* 2410552 */ // Label 34606: @2410552
     /* 2410552 */ GIM_Reject,
     /* 2410553 */ // Label 34564: @2410553
     /* 2410553 */ GIM_Try, /*On fail goto*//*Label 34631*/ GIMT_Encode4(2412343),
     /* 2410558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2410564 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2410567 */   GIM_Try, /*On fail goto*//*Label 34632*/ GIMT_Encode4(2410639), // Rule ID 1657 //
     /* 2410572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2410575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410619 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2410619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2410622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2410634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410638 */     // GIR_Coverage, 1657,
     /* 2410638 */     GIR_EraseRootFromParent_Done,
     /* 2410639 */   // Label 34632: @2410639
     /* 2410639 */   GIM_Try, /*On fail goto*//*Label 34633*/ GIMT_Encode4(2410711), // Rule ID 1658 //
     /* 2410644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2410647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410691 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2410691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2410694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2410706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410710 */     // GIR_Coverage, 1658,
     /* 2410710 */     GIR_EraseRootFromParent_Done,
     /* 2410711 */   // Label 34633: @2410711
     /* 2410711 */   GIM_Try, /*On fail goto*//*Label 34634*/ GIMT_Encode4(2410783), // Rule ID 1681 //
     /* 2410716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2410719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410763 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2410763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2410766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2410778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410782 */     // GIR_Coverage, 1681,
     /* 2410782 */     GIR_EraseRootFromParent_Done,
     /* 2410783 */   // Label 34634: @2410783
     /* 2410783 */   GIM_Try, /*On fail goto*//*Label 34635*/ GIMT_Encode4(2410855), // Rule ID 1712 //
     /* 2410788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2410791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410835 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2410835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2410838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2410850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410854 */     // GIR_Coverage, 1712,
     /* 2410854 */     GIR_EraseRootFromParent_Done,
     /* 2410855 */   // Label 34635: @2410855
     /* 2410855 */   GIM_Try, /*On fail goto*//*Label 34636*/ GIMT_Encode4(2410927), // Rule ID 1713 //
     /* 2410860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2410863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410907 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2410907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2410910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2410922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410926 */     // GIR_Coverage, 1713,
     /* 2410926 */     GIR_EraseRootFromParent_Done,
     /* 2410927 */   // Label 34636: @2410927
     /* 2410927 */   GIM_Try, /*On fail goto*//*Label 34637*/ GIMT_Encode4(2410999), // Rule ID 65515 //
     /* 2410932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2410935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410979 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2410979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2410982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2410990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2410994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410998 */     // GIR_Coverage, 65515,
     /* 2410998 */     GIR_EraseRootFromParent_Done,
     /* 2410999 */   // Label 34637: @2410999
     /* 2410999 */   GIM_Try, /*On fail goto*//*Label 34638*/ GIMT_Encode4(2411071), // Rule ID 65516 //
     /* 2411004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2411007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411051 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2411054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2411066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411070 */     // GIR_Coverage, 65516,
     /* 2411070 */     GIR_EraseRootFromParent_Done,
     /* 2411071 */   // Label 34638: @2411071
     /* 2411071 */   GIM_Try, /*On fail goto*//*Label 34639*/ GIMT_Encode4(2411143), // Rule ID 65521 //
     /* 2411076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2411079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411123 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2411126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2411138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411142 */     // GIR_Coverage, 65521,
     /* 2411142 */     GIR_EraseRootFromParent_Done,
     /* 2411143 */   // Label 34639: @2411143
     /* 2411143 */   GIM_Try, /*On fail goto*//*Label 34640*/ GIMT_Encode4(2411215), // Rule ID 65527 //
     /* 2411148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2411151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411195 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2411198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2411210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411214 */     // GIR_Coverage, 65527,
     /* 2411214 */     GIR_EraseRootFromParent_Done,
     /* 2411215 */   // Label 34640: @2411215
     /* 2411215 */   GIM_Try, /*On fail goto*//*Label 34641*/ GIMT_Encode4(2411287), // Rule ID 65528 //
     /* 2411220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2411223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411267 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2411270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2411282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411286 */     // GIR_Coverage, 65528,
     /* 2411286 */     GIR_EraseRootFromParent_Done,
     /* 2411287 */   // Label 34641: @2411287
     /* 2411287 */   GIM_Try, /*On fail goto*//*Label 34642*/ GIMT_Encode4(2411344), // Rule ID 1653 //
     /* 2411292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2411295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411326 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2411329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411343 */     // GIR_Coverage, 1653,
     /* 2411343 */     GIR_EraseRootFromParent_Done,
     /* 2411344 */   // Label 34642: @2411344
     /* 2411344 */   GIM_Try, /*On fail goto*//*Label 34643*/ GIMT_Encode4(2411401), // Rule ID 1654 //
     /* 2411349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2411352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411383 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2411386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411400 */     // GIR_Coverage, 1654,
     /* 2411400 */     GIR_EraseRootFromParent_Done,
     /* 2411401 */   // Label 34643: @2411401
     /* 2411401 */   GIM_Try, /*On fail goto*//*Label 34644*/ GIMT_Encode4(2411458), // Rule ID 1679 //
     /* 2411406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2411409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411440 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2411443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411457 */     // GIR_Coverage, 1679,
     /* 2411457 */     GIR_EraseRootFromParent_Done,
     /* 2411458 */   // Label 34644: @2411458
     /* 2411458 */   GIM_Try, /*On fail goto*//*Label 34645*/ GIMT_Encode4(2411515), // Rule ID 1708 //
     /* 2411463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2411466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411497 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2411500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411514 */     // GIR_Coverage, 1708,
     /* 2411514 */     GIR_EraseRootFromParent_Done,
     /* 2411515 */   // Label 34645: @2411515
     /* 2411515 */   GIM_Try, /*On fail goto*//*Label 34646*/ GIMT_Encode4(2411572), // Rule ID 1709 //
     /* 2411520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2411523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411554 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2411557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411571 */     // GIR_Coverage, 1709,
     /* 2411571 */     GIR_EraseRootFromParent_Done,
     /* 2411572 */   // Label 34646: @2411572
     /* 2411572 */   GIM_Try, /*On fail goto*//*Label 34647*/ GIMT_Encode4(2411629), // Rule ID 65511 //
     /* 2411577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2411580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411611 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2411614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411628 */     // GIR_Coverage, 65511,
     /* 2411628 */     GIR_EraseRootFromParent_Done,
     /* 2411629 */   // Label 34647: @2411629
     /* 2411629 */   GIM_Try, /*On fail goto*//*Label 34648*/ GIMT_Encode4(2411686), // Rule ID 65512 //
     /* 2411634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2411637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411668 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2411671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411685 */     // GIR_Coverage, 65512,
     /* 2411685 */     GIR_EraseRootFromParent_Done,
     /* 2411686 */   // Label 34648: @2411686
     /* 2411686 */   GIM_Try, /*On fail goto*//*Label 34649*/ GIMT_Encode4(2411743), // Rule ID 65519 //
     /* 2411691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2411694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411725 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2411728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411742 */     // GIR_Coverage, 65519,
     /* 2411742 */     GIR_EraseRootFromParent_Done,
     /* 2411743 */   // Label 34649: @2411743
     /* 2411743 */   GIM_Try, /*On fail goto*//*Label 34650*/ GIMT_Encode4(2411800), // Rule ID 65523 //
     /* 2411748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2411751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411782 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2411785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411799 */     // GIR_Coverage, 65523,
     /* 2411799 */     GIR_EraseRootFromParent_Done,
     /* 2411800 */   // Label 34650: @2411800
     /* 2411800 */   GIM_Try, /*On fail goto*//*Label 34651*/ GIMT_Encode4(2411857), // Rule ID 65524 //
     /* 2411805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2411808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411839 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2411842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411856 */     // GIR_Coverage, 65524,
     /* 2411856 */     GIR_EraseRootFromParent_Done,
     /* 2411857 */   // Label 34651: @2411857
     /* 2411857 */   GIM_Try, /*On fail goto*//*Label 34652*/ GIMT_Encode4(2411914), // Rule ID 1649 //
     /* 2411862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2411865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411896 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2411899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2411909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411913 */     // GIR_Coverage, 1649,
     /* 2411913 */     GIR_EraseRootFromParent_Done,
     /* 2411914 */   // Label 34652: @2411914
     /* 2411914 */   GIM_Try, /*On fail goto*//*Label 34653*/ GIMT_Encode4(2411971), // Rule ID 1650 //
     /* 2411919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2411922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411953 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2411956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2411966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411970 */     // GIR_Coverage, 1650,
     /* 2411970 */     GIR_EraseRootFromParent_Done,
     /* 2411971 */   // Label 34653: @2411971
     /* 2411971 */   GIM_Try, /*On fail goto*//*Label 34654*/ GIMT_Encode4(2412028), // Rule ID 1677 //
     /* 2411976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2411979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2412003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412010 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2412010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2412013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2412023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412027 */     // GIR_Coverage, 1677,
     /* 2412027 */     GIR_EraseRootFromParent_Done,
     /* 2412028 */   // Label 34654: @2412028
     /* 2412028 */   GIM_Try, /*On fail goto*//*Label 34655*/ GIMT_Encode4(2412085), // Rule ID 1704 //
     /* 2412033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2412036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2412060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412067 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2412067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2412070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2412080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412084 */     // GIR_Coverage, 1704,
     /* 2412084 */     GIR_EraseRootFromParent_Done,
     /* 2412085 */   // Label 34655: @2412085
     /* 2412085 */   GIM_Try, /*On fail goto*//*Label 34656*/ GIMT_Encode4(2412142), // Rule ID 1705 //
     /* 2412090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2412093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2412117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412124 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2412124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2412127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2412137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412141 */     // GIR_Coverage, 1705,
     /* 2412141 */     GIR_EraseRootFromParent_Done,
     /* 2412142 */   // Label 34656: @2412142
     /* 2412142 */   GIM_Try, /*On fail goto*//*Label 34657*/ GIMT_Encode4(2412182), // Rule ID 1645 //
     /* 2412147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2412150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412166 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2412166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2412169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2412177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412181 */     // GIR_Coverage, 1645,
     /* 2412181 */     GIR_EraseRootFromParent_Done,
     /* 2412182 */   // Label 34657: @2412182
     /* 2412182 */   GIM_Try, /*On fail goto*//*Label 34658*/ GIMT_Encode4(2412222), // Rule ID 1646 //
     /* 2412187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2412190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412206 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2412206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2412209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2412217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412221 */     // GIR_Coverage, 1646,
     /* 2412221 */     GIR_EraseRootFromParent_Done,
     /* 2412222 */   // Label 34658: @2412222
     /* 2412222 */   GIM_Try, /*On fail goto*//*Label 34659*/ GIMT_Encode4(2412262), // Rule ID 1675 //
     /* 2412227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2412230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412246 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2412246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2412249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2412257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412261 */     // GIR_Coverage, 1675,
     /* 2412261 */     GIR_EraseRootFromParent_Done,
     /* 2412262 */   // Label 34659: @2412262
     /* 2412262 */   GIM_Try, /*On fail goto*//*Label 34660*/ GIMT_Encode4(2412302), // Rule ID 1700 //
     /* 2412267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2412270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412286 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2412286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2412289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2412297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412301 */     // GIR_Coverage, 1700,
     /* 2412301 */     GIR_EraseRootFromParent_Done,
     /* 2412302 */   // Label 34660: @2412302
     /* 2412302 */   GIM_Try, /*On fail goto*//*Label 34661*/ GIMT_Encode4(2412342), // Rule ID 1701 //
     /* 2412307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2412310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412326 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2412326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2412329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2412337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412341 */     // GIR_Coverage, 1701,
     /* 2412341 */     GIR_EraseRootFromParent_Done,
     /* 2412342 */   // Label 34661: @2412342
     /* 2412342 */   GIM_Reject,
     /* 2412343 */ // Label 34631: @2412343
     /* 2412343 */ GIM_Reject,
     /* 2412344 */ // Label 34565: @2412344
     /* 2412344 */ GIM_Try, /*On fail goto*//*Label 34662*/ GIMT_Encode4(2413133),
     /* 2412349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2412355 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2412358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412362 */   GIM_Try, /*On fail goto*//*Label 34663*/ GIMT_Encode4(2412439), // Rule ID 54848 //
     /* 2412367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2412370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412410 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2412413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412438 */     // GIR_Coverage, 54848,
     /* 2412438 */     GIR_EraseRootFromParent_Done,
     /* 2412439 */   // Label 34663: @2412439
     /* 2412439 */   GIM_Try, /*On fail goto*//*Label 34664*/ GIMT_Encode4(2412516), // Rule ID 54849 //
     /* 2412444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2412447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412487 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2412490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412515 */     // GIR_Coverage, 54849,
     /* 2412515 */     GIR_EraseRootFromParent_Done,
     /* 2412516 */   // Label 34664: @2412516
     /* 2412516 */   GIM_Try, /*On fail goto*//*Label 34665*/ GIMT_Encode4(2412593), // Rule ID 72499 //
     /* 2412521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2412524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412564 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2412567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412592 */     // GIR_Coverage, 72499,
     /* 2412592 */     GIR_EraseRootFromParent_Done,
     /* 2412593 */   // Label 34665: @2412593
     /* 2412593 */   GIM_Try, /*On fail goto*//*Label 34666*/ GIMT_Encode4(2412670), // Rule ID 72500 //
     /* 2412598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2412601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412641 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2412644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412669 */     // GIR_Coverage, 72500,
     /* 2412669 */     GIR_EraseRootFromParent_Done,
     /* 2412670 */   // Label 34666: @2412670
     /* 2412670 */   GIM_Try, /*On fail goto*//*Label 34667*/ GIMT_Encode4(2412732), // Rule ID 54852 //
     /* 2412675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2412678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412705 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2412708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412731 */     // GIR_Coverage, 54852,
     /* 2412731 */     GIR_EraseRootFromParent_Done,
     /* 2412732 */   // Label 34667: @2412732
     /* 2412732 */   GIM_Try, /*On fail goto*//*Label 34668*/ GIMT_Encode4(2412794), // Rule ID 54853 //
     /* 2412737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2412740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412767 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2412770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412793 */     // GIR_Coverage, 54853,
     /* 2412793 */     GIR_EraseRootFromParent_Done,
     /* 2412794 */   // Label 34668: @2412794
     /* 2412794 */   GIM_Try, /*On fail goto*//*Label 34669*/ GIMT_Encode4(2412856), // Rule ID 72503 //
     /* 2412799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2412802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412829 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2412832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412855 */     // GIR_Coverage, 72503,
     /* 2412855 */     GIR_EraseRootFromParent_Done,
     /* 2412856 */   // Label 34669: @2412856
     /* 2412856 */   GIM_Try, /*On fail goto*//*Label 34670*/ GIMT_Encode4(2412918), // Rule ID 72504 //
     /* 2412861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2412864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412891 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2412894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412917 */     // GIR_Coverage, 72504,
     /* 2412917 */     GIR_EraseRootFromParent_Done,
     /* 2412918 */   // Label 34670: @2412918
     /* 2412918 */   GIM_Try, /*On fail goto*//*Label 34671*/ GIMT_Encode4(2412980), // Rule ID 54844 //
     /* 2412923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2412926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412953 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2412956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2412966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412979 */     // GIR_Coverage, 54844,
     /* 2412979 */     GIR_EraseRootFromParent_Done,
     /* 2412980 */   // Label 34671: @2412980
     /* 2412980 */   GIM_Try, /*On fail goto*//*Label 34672*/ GIMT_Encode4(2413042), // Rule ID 54845 //
     /* 2412985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2412988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2413008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413015 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2413018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413041 */     // GIR_Coverage, 54845,
     /* 2413041 */     GIR_EraseRootFromParent_Done,
     /* 2413042 */   // Label 34672: @2413042
     /* 2413042 */   GIM_Try, /*On fail goto*//*Label 34673*/ GIMT_Encode4(2413087), // Rule ID 54840 //
     /* 2413047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413062 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2413065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413086 */     // GIR_Coverage, 54840,
     /* 2413086 */     GIR_EraseRootFromParent_Done,
     /* 2413087 */   // Label 34673: @2413087
     /* 2413087 */   GIM_Try, /*On fail goto*//*Label 34674*/ GIMT_Encode4(2413132), // Rule ID 54841 //
     /* 2413092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413107 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2413110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413131 */     // GIR_Coverage, 54841,
     /* 2413131 */     GIR_EraseRootFromParent_Done,
     /* 2413132 */   // Label 34674: @2413132
     /* 2413132 */   GIM_Reject,
     /* 2413133 */ // Label 34662: @2413133
     /* 2413133 */ GIM_Reject,
     /* 2413134 */ // Label 34566: @2413134
     /* 2413134 */ GIM_Try, /*On fail goto*//*Label 34675*/ GIMT_Encode4(2413923),
     /* 2413139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2413145 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2413148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413152 */   GIM_Try, /*On fail goto*//*Label 34676*/ GIMT_Encode4(2413229), // Rule ID 54976 //
     /* 2413157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413200 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2413203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413228 */     // GIR_Coverage, 54976,
     /* 2413228 */     GIR_EraseRootFromParent_Done,
     /* 2413229 */   // Label 34676: @2413229
     /* 2413229 */   GIM_Try, /*On fail goto*//*Label 34677*/ GIMT_Encode4(2413306), // Rule ID 54977 //
     /* 2413234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2413237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413277 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2413280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413305 */     // GIR_Coverage, 54977,
     /* 2413305 */     GIR_EraseRootFromParent_Done,
     /* 2413306 */   // Label 34677: @2413306
     /* 2413306 */   GIM_Try, /*On fail goto*//*Label 34678*/ GIMT_Encode4(2413383), // Rule ID 72611 //
     /* 2413311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413354 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2413357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413382 */     // GIR_Coverage, 72611,
     /* 2413382 */     GIR_EraseRootFromParent_Done,
     /* 2413383 */   // Label 34678: @2413383
     /* 2413383 */   GIM_Try, /*On fail goto*//*Label 34679*/ GIMT_Encode4(2413460), // Rule ID 72612 //
     /* 2413388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2413391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413431 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2413434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413459 */     // GIR_Coverage, 72612,
     /* 2413459 */     GIR_EraseRootFromParent_Done,
     /* 2413460 */   // Label 34679: @2413460
     /* 2413460 */   GIM_Try, /*On fail goto*//*Label 34680*/ GIMT_Encode4(2413522), // Rule ID 54980 //
     /* 2413465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413495 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2413498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413521 */     // GIR_Coverage, 54980,
     /* 2413521 */     GIR_EraseRootFromParent_Done,
     /* 2413522 */   // Label 34680: @2413522
     /* 2413522 */   GIM_Try, /*On fail goto*//*Label 34681*/ GIMT_Encode4(2413584), // Rule ID 54981 //
     /* 2413527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2413530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413557 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2413560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413583 */     // GIR_Coverage, 54981,
     /* 2413583 */     GIR_EraseRootFromParent_Done,
     /* 2413584 */   // Label 34681: @2413584
     /* 2413584 */   GIM_Try, /*On fail goto*//*Label 34682*/ GIMT_Encode4(2413646), // Rule ID 72615 //
     /* 2413589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413619 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2413622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413645 */     // GIR_Coverage, 72615,
     /* 2413645 */     GIR_EraseRootFromParent_Done,
     /* 2413646 */   // Label 34682: @2413646
     /* 2413646 */   GIM_Try, /*On fail goto*//*Label 34683*/ GIMT_Encode4(2413708), // Rule ID 72616 //
     /* 2413651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2413654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413681 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2413684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413707 */     // GIR_Coverage, 72616,
     /* 2413707 */     GIR_EraseRootFromParent_Done,
     /* 2413708 */   // Label 34683: @2413708
     /* 2413708 */   GIM_Try, /*On fail goto*//*Label 34684*/ GIMT_Encode4(2413770), // Rule ID 54972 //
     /* 2413713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413743 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2413746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413769 */     // GIR_Coverage, 54972,
     /* 2413769 */     GIR_EraseRootFromParent_Done,
     /* 2413770 */   // Label 34684: @2413770
     /* 2413770 */   GIM_Try, /*On fail goto*//*Label 34685*/ GIMT_Encode4(2413832), // Rule ID 54973 //
     /* 2413775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2413778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413805 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2413808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413831 */     // GIR_Coverage, 54973,
     /* 2413831 */     GIR_EraseRootFromParent_Done,
     /* 2413832 */   // Label 34685: @2413832
     /* 2413832 */   GIM_Try, /*On fail goto*//*Label 34686*/ GIMT_Encode4(2413877), // Rule ID 54968 //
     /* 2413837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413852 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2413855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413876 */     // GIR_Coverage, 54968,
     /* 2413876 */     GIR_EraseRootFromParent_Done,
     /* 2413877 */   // Label 34686: @2413877
     /* 2413877 */   GIM_Try, /*On fail goto*//*Label 34687*/ GIMT_Encode4(2413922), // Rule ID 54969 //
     /* 2413882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2413885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413897 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2413900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413921 */     // GIR_Coverage, 54969,
     /* 2413921 */     GIR_EraseRootFromParent_Done,
     /* 2413922 */   // Label 34687: @2413922
     /* 2413922 */   GIM_Reject,
     /* 2413923 */ // Label 34675: @2413923
     /* 2413923 */ GIM_Reject,
     /* 2413924 */ // Label 34567: @2413924
     /* 2413924 */ GIM_Try, /*On fail goto*//*Label 34688*/ GIMT_Encode4(2414713),
     /* 2413929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2413932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2413935 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2413938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413942 */   GIM_Try, /*On fail goto*//*Label 34689*/ GIMT_Encode4(2414019), // Rule ID 55168 //
     /* 2413947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2413950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2413962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2413983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413990 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2413993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414018 */     // GIR_Coverage, 55168,
     /* 2414018 */     GIR_EraseRootFromParent_Done,
     /* 2414019 */   // Label 34689: @2414019
     /* 2414019 */   GIM_Try, /*On fail goto*//*Label 34690*/ GIMT_Encode4(2414096), // Rule ID 55169 //
     /* 2414024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414067 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2414070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414095 */     // GIR_Coverage, 55169,
     /* 2414095 */     GIR_EraseRootFromParent_Done,
     /* 2414096 */   // Label 34690: @2414096
     /* 2414096 */   GIM_Try, /*On fail goto*//*Label 34691*/ GIMT_Encode4(2414173), // Rule ID 72779 //
     /* 2414101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414144 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2414147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414172 */     // GIR_Coverage, 72779,
     /* 2414172 */     GIR_EraseRootFromParent_Done,
     /* 2414173 */   // Label 34691: @2414173
     /* 2414173 */   GIM_Try, /*On fail goto*//*Label 34692*/ GIMT_Encode4(2414250), // Rule ID 72780 //
     /* 2414178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414221 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2414224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414249 */     // GIR_Coverage, 72780,
     /* 2414249 */     GIR_EraseRootFromParent_Done,
     /* 2414250 */   // Label 34692: @2414250
     /* 2414250 */   GIM_Try, /*On fail goto*//*Label 34693*/ GIMT_Encode4(2414312), // Rule ID 55172 //
     /* 2414255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414285 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2414288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414311 */     // GIR_Coverage, 55172,
     /* 2414311 */     GIR_EraseRootFromParent_Done,
     /* 2414312 */   // Label 34693: @2414312
     /* 2414312 */   GIM_Try, /*On fail goto*//*Label 34694*/ GIMT_Encode4(2414374), // Rule ID 55173 //
     /* 2414317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414347 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2414350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414373 */     // GIR_Coverage, 55173,
     /* 2414373 */     GIR_EraseRootFromParent_Done,
     /* 2414374 */   // Label 34694: @2414374
     /* 2414374 */   GIM_Try, /*On fail goto*//*Label 34695*/ GIMT_Encode4(2414436), // Rule ID 72783 //
     /* 2414379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414409 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2414412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414435 */     // GIR_Coverage, 72783,
     /* 2414435 */     GIR_EraseRootFromParent_Done,
     /* 2414436 */   // Label 34695: @2414436
     /* 2414436 */   GIM_Try, /*On fail goto*//*Label 34696*/ GIMT_Encode4(2414498), // Rule ID 72784 //
     /* 2414441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414471 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2414474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414497 */     // GIR_Coverage, 72784,
     /* 2414497 */     GIR_EraseRootFromParent_Done,
     /* 2414498 */   // Label 34696: @2414498
     /* 2414498 */   GIM_Try, /*On fail goto*//*Label 34697*/ GIMT_Encode4(2414560), // Rule ID 55164 //
     /* 2414503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414533 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2414536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2414546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414559 */     // GIR_Coverage, 55164,
     /* 2414559 */     GIR_EraseRootFromParent_Done,
     /* 2414560 */   // Label 34697: @2414560
     /* 2414560 */   GIM_Try, /*On fail goto*//*Label 34698*/ GIMT_Encode4(2414622), // Rule ID 55165 //
     /* 2414565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414595 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2414598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2414608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414621 */     // GIR_Coverage, 55165,
     /* 2414621 */     GIR_EraseRootFromParent_Done,
     /* 2414622 */   // Label 34698: @2414622
     /* 2414622 */   GIM_Try, /*On fail goto*//*Label 34699*/ GIMT_Encode4(2414667), // Rule ID 55160 //
     /* 2414627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414642 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2414645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414666 */     // GIR_Coverage, 55160,
     /* 2414666 */     GIR_EraseRootFromParent_Done,
     /* 2414667 */   // Label 34699: @2414667
     /* 2414667 */   GIM_Try, /*On fail goto*//*Label 34700*/ GIMT_Encode4(2414712), // Rule ID 55161 //
     /* 2414672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414687 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2414690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414711 */     // GIR_Coverage, 55161,
     /* 2414711 */     GIR_EraseRootFromParent_Done,
     /* 2414712 */   // Label 34700: @2414712
     /* 2414712 */   GIM_Reject,
     /* 2414713 */ // Label 34688: @2414713
     /* 2414713 */ GIM_Reject,
     /* 2414714 */ // Label 34568: @2414714
     /* 2414714 */ GIM_Try, /*On fail goto*//*Label 34701*/ GIMT_Encode4(2415503),
     /* 2414719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2414725 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2414728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414732 */   GIM_Try, /*On fail goto*//*Label 34702*/ GIMT_Encode4(2414809), // Rule ID 54912 //
     /* 2414737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2414740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414780 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2414783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414808 */     // GIR_Coverage, 54912,
     /* 2414808 */     GIR_EraseRootFromParent_Done,
     /* 2414809 */   // Label 34702: @2414809
     /* 2414809 */   GIM_Try, /*On fail goto*//*Label 34703*/ GIMT_Encode4(2414886), // Rule ID 54913 //
     /* 2414814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2414817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414857 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2414860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414885 */     // GIR_Coverage, 54913,
     /* 2414885 */     GIR_EraseRootFromParent_Done,
     /* 2414886 */   // Label 34703: @2414886
     /* 2414886 */   GIM_Try, /*On fail goto*//*Label 34704*/ GIMT_Encode4(2414963), // Rule ID 72555 //
     /* 2414891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2414894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414934 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2414937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414962 */     // GIR_Coverage, 72555,
     /* 2414962 */     GIR_EraseRootFromParent_Done,
     /* 2414963 */   // Label 34704: @2414963
     /* 2414963 */   GIM_Try, /*On fail goto*//*Label 34705*/ GIMT_Encode4(2415040), // Rule ID 72556 //
     /* 2414968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2414971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415011 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2415014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415039 */     // GIR_Coverage, 72556,
     /* 2415039 */     GIR_EraseRootFromParent_Done,
     /* 2415040 */   // Label 34705: @2415040
     /* 2415040 */   GIM_Try, /*On fail goto*//*Label 34706*/ GIMT_Encode4(2415102), // Rule ID 54916 //
     /* 2415045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415075 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2415078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415101 */     // GIR_Coverage, 54916,
     /* 2415101 */     GIR_EraseRootFromParent_Done,
     /* 2415102 */   // Label 34706: @2415102
     /* 2415102 */   GIM_Try, /*On fail goto*//*Label 34707*/ GIMT_Encode4(2415164), // Rule ID 54917 //
     /* 2415107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415137 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2415140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415163 */     // GIR_Coverage, 54917,
     /* 2415163 */     GIR_EraseRootFromParent_Done,
     /* 2415164 */   // Label 34707: @2415164
     /* 2415164 */   GIM_Try, /*On fail goto*//*Label 34708*/ GIMT_Encode4(2415226), // Rule ID 72559 //
     /* 2415169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415199 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2415202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415225 */     // GIR_Coverage, 72559,
     /* 2415225 */     GIR_EraseRootFromParent_Done,
     /* 2415226 */   // Label 34708: @2415226
     /* 2415226 */   GIM_Try, /*On fail goto*//*Label 34709*/ GIMT_Encode4(2415288), // Rule ID 72560 //
     /* 2415231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415261 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2415264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415287 */     // GIR_Coverage, 72560,
     /* 2415287 */     GIR_EraseRootFromParent_Done,
     /* 2415288 */   // Label 34709: @2415288
     /* 2415288 */   GIM_Try, /*On fail goto*//*Label 34710*/ GIMT_Encode4(2415350), // Rule ID 54908 //
     /* 2415293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415323 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2415326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2415336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415349 */     // GIR_Coverage, 54908,
     /* 2415349 */     GIR_EraseRootFromParent_Done,
     /* 2415350 */   // Label 34710: @2415350
     /* 2415350 */   GIM_Try, /*On fail goto*//*Label 34711*/ GIMT_Encode4(2415412), // Rule ID 54909 //
     /* 2415355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415385 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2415388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2415398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415411 */     // GIR_Coverage, 54909,
     /* 2415411 */     GIR_EraseRootFromParent_Done,
     /* 2415412 */   // Label 34711: @2415412
     /* 2415412 */   GIM_Try, /*On fail goto*//*Label 34712*/ GIMT_Encode4(2415457), // Rule ID 54904 //
     /* 2415417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415432 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2415435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415456 */     // GIR_Coverage, 54904,
     /* 2415456 */     GIR_EraseRootFromParent_Done,
     /* 2415457 */   // Label 34712: @2415457
     /* 2415457 */   GIM_Try, /*On fail goto*//*Label 34713*/ GIMT_Encode4(2415502), // Rule ID 54905 //
     /* 2415462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415477 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2415480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415501 */     // GIR_Coverage, 54905,
     /* 2415501 */     GIR_EraseRootFromParent_Done,
     /* 2415502 */   // Label 34713: @2415502
     /* 2415502 */   GIM_Reject,
     /* 2415503 */ // Label 34701: @2415503
     /* 2415503 */ GIM_Reject,
     /* 2415504 */ // Label 34569: @2415504
     /* 2415504 */ GIM_Try, /*On fail goto*//*Label 34714*/ GIMT_Encode4(2416293),
     /* 2415509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2415515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2415518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415522 */   GIM_Try, /*On fail goto*//*Label 34715*/ GIMT_Encode4(2415599), // Rule ID 55104 //
     /* 2415527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2415530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415570 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2415573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415598 */     // GIR_Coverage, 55104,
     /* 2415598 */     GIR_EraseRootFromParent_Done,
     /* 2415599 */   // Label 34715: @2415599
     /* 2415599 */   GIM_Try, /*On fail goto*//*Label 34716*/ GIMT_Encode4(2415676), // Rule ID 55105 //
     /* 2415604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2415607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415647 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2415650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415675 */     // GIR_Coverage, 55105,
     /* 2415675 */     GIR_EraseRootFromParent_Done,
     /* 2415676 */   // Label 34716: @2415676
     /* 2415676 */   GIM_Try, /*On fail goto*//*Label 34717*/ GIMT_Encode4(2415753), // Rule ID 72723 //
     /* 2415681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2415684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415724 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2415727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415752 */     // GIR_Coverage, 72723,
     /* 2415752 */     GIR_EraseRootFromParent_Done,
     /* 2415753 */   // Label 34717: @2415753
     /* 2415753 */   GIM_Try, /*On fail goto*//*Label 34718*/ GIMT_Encode4(2415830), // Rule ID 72724 //
     /* 2415758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2415761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415801 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2415804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415829 */     // GIR_Coverage, 72724,
     /* 2415829 */     GIR_EraseRootFromParent_Done,
     /* 2415830 */   // Label 34718: @2415830
     /* 2415830 */   GIM_Try, /*On fail goto*//*Label 34719*/ GIMT_Encode4(2415892), // Rule ID 55108 //
     /* 2415835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2415838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415865 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2415868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415891 */     // GIR_Coverage, 55108,
     /* 2415891 */     GIR_EraseRootFromParent_Done,
     /* 2415892 */   // Label 34719: @2415892
     /* 2415892 */   GIM_Try, /*On fail goto*//*Label 34720*/ GIMT_Encode4(2415954), // Rule ID 55109 //
     /* 2415897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2415900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415927 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2415930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415953 */     // GIR_Coverage, 55109,
     /* 2415953 */     GIR_EraseRootFromParent_Done,
     /* 2415954 */   // Label 34720: @2415954
     /* 2415954 */   GIM_Try, /*On fail goto*//*Label 34721*/ GIMT_Encode4(2416016), // Rule ID 72727 //
     /* 2415959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2415962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415989 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2415992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416015 */     // GIR_Coverage, 72727,
     /* 2416015 */     GIR_EraseRootFromParent_Done,
     /* 2416016 */   // Label 34721: @2416016
     /* 2416016 */   GIM_Try, /*On fail goto*//*Label 34722*/ GIMT_Encode4(2416078), // Rule ID 72728 //
     /* 2416021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2416040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416051 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2416054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416077 */     // GIR_Coverage, 72728,
     /* 2416077 */     GIR_EraseRootFromParent_Done,
     /* 2416078 */   // Label 34722: @2416078
     /* 2416078 */   GIM_Try, /*On fail goto*//*Label 34723*/ GIMT_Encode4(2416140), // Rule ID 55100 //
     /* 2416083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2416106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416113 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2416116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416139 */     // GIR_Coverage, 55100,
     /* 2416139 */     GIR_EraseRootFromParent_Done,
     /* 2416140 */   // Label 34723: @2416140
     /* 2416140 */   GIM_Try, /*On fail goto*//*Label 34724*/ GIMT_Encode4(2416202), // Rule ID 55101 //
     /* 2416145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2416168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416175 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2416178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416201 */     // GIR_Coverage, 55101,
     /* 2416201 */     GIR_EraseRootFromParent_Done,
     /* 2416202 */   // Label 34724: @2416202
     /* 2416202 */   GIM_Try, /*On fail goto*//*Label 34725*/ GIMT_Encode4(2416247), // Rule ID 55096 //
     /* 2416207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416222 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2416225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416246 */     // GIR_Coverage, 55096,
     /* 2416246 */     GIR_EraseRootFromParent_Done,
     /* 2416247 */   // Label 34725: @2416247
     /* 2416247 */   GIM_Try, /*On fail goto*//*Label 34726*/ GIMT_Encode4(2416292), // Rule ID 55097 //
     /* 2416252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416267 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2416270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416291 */     // GIR_Coverage, 55097,
     /* 2416291 */     GIR_EraseRootFromParent_Done,
     /* 2416292 */   // Label 34726: @2416292
     /* 2416292 */   GIM_Reject,
     /* 2416293 */ // Label 34714: @2416293
     /* 2416293 */ GIM_Reject,
     /* 2416294 */ // Label 34570: @2416294
     /* 2416294 */ GIM_Try, /*On fail goto*//*Label 34727*/ GIMT_Encode4(2417083),
     /* 2416299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2416305 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2416308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416312 */   GIM_Try, /*On fail goto*//*Label 34728*/ GIMT_Encode4(2416389), // Rule ID 55616 //
     /* 2416317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2416320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416360 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2416363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416388 */     // GIR_Coverage, 55616,
     /* 2416388 */     GIR_EraseRootFromParent_Done,
     /* 2416389 */   // Label 34728: @2416389
     /* 2416389 */   GIM_Try, /*On fail goto*//*Label 34729*/ GIMT_Encode4(2416466), // Rule ID 55617 //
     /* 2416394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2416397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416437 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2416440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416465 */     // GIR_Coverage, 55617,
     /* 2416465 */     GIR_EraseRootFromParent_Done,
     /* 2416466 */   // Label 34729: @2416466
     /* 2416466 */   GIM_Try, /*On fail goto*//*Label 34730*/ GIMT_Encode4(2416543), // Rule ID 73171 //
     /* 2416471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2416474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416514 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2416517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416542 */     // GIR_Coverage, 73171,
     /* 2416542 */     GIR_EraseRootFromParent_Done,
     /* 2416543 */   // Label 34730: @2416543
     /* 2416543 */   GIM_Try, /*On fail goto*//*Label 34731*/ GIMT_Encode4(2416620), // Rule ID 73172 //
     /* 2416548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2416551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416591 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2416594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416619 */     // GIR_Coverage, 73172,
     /* 2416619 */     GIR_EraseRootFromParent_Done,
     /* 2416620 */   // Label 34731: @2416620
     /* 2416620 */   GIM_Try, /*On fail goto*//*Label 34732*/ GIMT_Encode4(2416682), // Rule ID 55620 //
     /* 2416625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2416628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416655 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2416658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416681 */     // GIR_Coverage, 55620,
     /* 2416681 */     GIR_EraseRootFromParent_Done,
     /* 2416682 */   // Label 34732: @2416682
     /* 2416682 */   GIM_Try, /*On fail goto*//*Label 34733*/ GIMT_Encode4(2416744), // Rule ID 55621 //
     /* 2416687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2416690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416717 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2416720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416743 */     // GIR_Coverage, 55621,
     /* 2416743 */     GIR_EraseRootFromParent_Done,
     /* 2416744 */   // Label 34733: @2416744
     /* 2416744 */   GIM_Try, /*On fail goto*//*Label 34734*/ GIMT_Encode4(2416806), // Rule ID 73175 //
     /* 2416749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2416752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416779 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2416782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416805 */     // GIR_Coverage, 73175,
     /* 2416805 */     GIR_EraseRootFromParent_Done,
     /* 2416806 */   // Label 34734: @2416806
     /* 2416806 */   GIM_Try, /*On fail goto*//*Label 34735*/ GIMT_Encode4(2416868), // Rule ID 73176 //
     /* 2416811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2416814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416841 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2416844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416867 */     // GIR_Coverage, 73176,
     /* 2416867 */     GIR_EraseRootFromParent_Done,
     /* 2416868 */   // Label 34735: @2416868
     /* 2416868 */   GIM_Try, /*On fail goto*//*Label 34736*/ GIMT_Encode4(2416930), // Rule ID 55612 //
     /* 2416873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2416876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416903 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2416906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416929 */     // GIR_Coverage, 55612,
     /* 2416929 */     GIR_EraseRootFromParent_Done,
     /* 2416930 */   // Label 34736: @2416930
     /* 2416930 */   GIM_Try, /*On fail goto*//*Label 34737*/ GIMT_Encode4(2416992), // Rule ID 55613 //
     /* 2416935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2416938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416965 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2416968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416991 */     // GIR_Coverage, 55613,
     /* 2416991 */     GIR_EraseRootFromParent_Done,
     /* 2416992 */   // Label 34737: @2416992
     /* 2416992 */   GIM_Try, /*On fail goto*//*Label 34738*/ GIMT_Encode4(2417037), // Rule ID 55608 //
     /* 2416997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2417000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417012 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2417015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417036 */     // GIR_Coverage, 55608,
     /* 2417036 */     GIR_EraseRootFromParent_Done,
     /* 2417037 */   // Label 34738: @2417037
     /* 2417037 */   GIM_Try, /*On fail goto*//*Label 34739*/ GIMT_Encode4(2417082), // Rule ID 55609 //
     /* 2417042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2417045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417057 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2417060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417081 */     // GIR_Coverage, 55609,
     /* 2417081 */     GIR_EraseRootFromParent_Done,
     /* 2417082 */   // Label 34739: @2417082
     /* 2417082 */   GIM_Reject,
     /* 2417083 */ // Label 34727: @2417083
     /* 2417083 */ GIM_Reject,
     /* 2417084 */ // Label 34571: @2417084
     /* 2417084 */ GIM_Try, /*On fail goto*//*Label 34740*/ GIMT_Encode4(2417873),
     /* 2417089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2417095 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2417098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417102 */   GIM_Try, /*On fail goto*//*Label 34741*/ GIMT_Encode4(2417179), // Rule ID 55040 //
     /* 2417107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417150 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2417153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417178 */     // GIR_Coverage, 55040,
     /* 2417178 */     GIR_EraseRootFromParent_Done,
     /* 2417179 */   // Label 34741: @2417179
     /* 2417179 */   GIM_Try, /*On fail goto*//*Label 34742*/ GIMT_Encode4(2417256), // Rule ID 55041 //
     /* 2417184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417227 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2417230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417255 */     // GIR_Coverage, 55041,
     /* 2417255 */     GIR_EraseRootFromParent_Done,
     /* 2417256 */   // Label 34742: @2417256
     /* 2417256 */   GIM_Try, /*On fail goto*//*Label 34743*/ GIMT_Encode4(2417333), // Rule ID 72667 //
     /* 2417261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417304 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2417307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417332 */     // GIR_Coverage, 72667,
     /* 2417332 */     GIR_EraseRootFromParent_Done,
     /* 2417333 */   // Label 34743: @2417333
     /* 2417333 */   GIM_Try, /*On fail goto*//*Label 34744*/ GIMT_Encode4(2417410), // Rule ID 72668 //
     /* 2417338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417381 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2417384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417409 */     // GIR_Coverage, 72668,
     /* 2417409 */     GIR_EraseRootFromParent_Done,
     /* 2417410 */   // Label 34744: @2417410
     /* 2417410 */   GIM_Try, /*On fail goto*//*Label 34745*/ GIMT_Encode4(2417472), // Rule ID 55044 //
     /* 2417415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417445 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2417448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417471 */     // GIR_Coverage, 55044,
     /* 2417471 */     GIR_EraseRootFromParent_Done,
     /* 2417472 */   // Label 34745: @2417472
     /* 2417472 */   GIM_Try, /*On fail goto*//*Label 34746*/ GIMT_Encode4(2417534), // Rule ID 55045 //
     /* 2417477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417507 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2417510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417533 */     // GIR_Coverage, 55045,
     /* 2417533 */     GIR_EraseRootFromParent_Done,
     /* 2417534 */   // Label 34746: @2417534
     /* 2417534 */   GIM_Try, /*On fail goto*//*Label 34747*/ GIMT_Encode4(2417596), // Rule ID 72671 //
     /* 2417539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417569 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2417572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417595 */     // GIR_Coverage, 72671,
     /* 2417595 */     GIR_EraseRootFromParent_Done,
     /* 2417596 */   // Label 34747: @2417596
     /* 2417596 */   GIM_Try, /*On fail goto*//*Label 34748*/ GIMT_Encode4(2417658), // Rule ID 72672 //
     /* 2417601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417631 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2417634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417657 */     // GIR_Coverage, 72672,
     /* 2417657 */     GIR_EraseRootFromParent_Done,
     /* 2417658 */   // Label 34748: @2417658
     /* 2417658 */   GIM_Try, /*On fail goto*//*Label 34749*/ GIMT_Encode4(2417720), // Rule ID 55036 //
     /* 2417663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417693 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2417696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417719 */     // GIR_Coverage, 55036,
     /* 2417719 */     GIR_EraseRootFromParent_Done,
     /* 2417720 */   // Label 34749: @2417720
     /* 2417720 */   GIM_Try, /*On fail goto*//*Label 34750*/ GIMT_Encode4(2417782), // Rule ID 55037 //
     /* 2417725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417755 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2417758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417781 */     // GIR_Coverage, 55037,
     /* 2417781 */     GIR_EraseRootFromParent_Done,
     /* 2417782 */   // Label 34750: @2417782
     /* 2417782 */   GIM_Try, /*On fail goto*//*Label 34751*/ GIMT_Encode4(2417827), // Rule ID 55032 //
     /* 2417787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417802 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2417805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417826 */     // GIR_Coverage, 55032,
     /* 2417826 */     GIR_EraseRootFromParent_Done,
     /* 2417827 */   // Label 34751: @2417827
     /* 2417827 */   GIM_Try, /*On fail goto*//*Label 34752*/ GIMT_Encode4(2417872), // Rule ID 55033 //
     /* 2417832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417847 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2417850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417871 */     // GIR_Coverage, 55033,
     /* 2417871 */     GIR_EraseRootFromParent_Done,
     /* 2417872 */   // Label 34752: @2417872
     /* 2417872 */   GIM_Reject,
     /* 2417873 */ // Label 34740: @2417873
     /* 2417873 */ GIM_Reject,
     /* 2417874 */ // Label 34572: @2417874
     /* 2417874 */ GIM_Try, /*On fail goto*//*Label 34753*/ GIMT_Encode4(2418663),
     /* 2417879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2417882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2417885 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2417888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417892 */   GIM_Try, /*On fail goto*//*Label 34754*/ GIMT_Encode4(2417969), // Rule ID 55424 //
     /* 2417897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2417900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2417912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2417933 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417940 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2417943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417968 */     // GIR_Coverage, 55424,
     /* 2417968 */     GIR_EraseRootFromParent_Done,
     /* 2417969 */   // Label 34754: @2417969
     /* 2417969 */   GIM_Try, /*On fail goto*//*Label 34755*/ GIMT_Encode4(2418046), // Rule ID 55425 //
     /* 2417974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2417977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2417989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418017 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2418020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418045 */     // GIR_Coverage, 55425,
     /* 2418045 */     GIR_EraseRootFromParent_Done,
     /* 2418046 */   // Label 34755: @2418046
     /* 2418046 */   GIM_Try, /*On fail goto*//*Label 34756*/ GIMT_Encode4(2418123), // Rule ID 73003 //
     /* 2418051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418094 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2418097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418122 */     // GIR_Coverage, 73003,
     /* 2418122 */     GIR_EraseRootFromParent_Done,
     /* 2418123 */   // Label 34756: @2418123
     /* 2418123 */   GIM_Try, /*On fail goto*//*Label 34757*/ GIMT_Encode4(2418200), // Rule ID 73004 //
     /* 2418128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418171 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2418174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418199 */     // GIR_Coverage, 73004,
     /* 2418199 */     GIR_EraseRootFromParent_Done,
     /* 2418200 */   // Label 34757: @2418200
     /* 2418200 */   GIM_Try, /*On fail goto*//*Label 34758*/ GIMT_Encode4(2418262), // Rule ID 55428 //
     /* 2418205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418235 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2418238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418261 */     // GIR_Coverage, 55428,
     /* 2418261 */     GIR_EraseRootFromParent_Done,
     /* 2418262 */   // Label 34758: @2418262
     /* 2418262 */   GIM_Try, /*On fail goto*//*Label 34759*/ GIMT_Encode4(2418324), // Rule ID 55429 //
     /* 2418267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418297 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2418300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418323 */     // GIR_Coverage, 55429,
     /* 2418323 */     GIR_EraseRootFromParent_Done,
     /* 2418324 */   // Label 34759: @2418324
     /* 2418324 */   GIM_Try, /*On fail goto*//*Label 34760*/ GIMT_Encode4(2418386), // Rule ID 73007 //
     /* 2418329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418359 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2418362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418385 */     // GIR_Coverage, 73007,
     /* 2418385 */     GIR_EraseRootFromParent_Done,
     /* 2418386 */   // Label 34760: @2418386
     /* 2418386 */   GIM_Try, /*On fail goto*//*Label 34761*/ GIMT_Encode4(2418448), // Rule ID 73008 //
     /* 2418391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418421 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2418424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418447 */     // GIR_Coverage, 73008,
     /* 2418447 */     GIR_EraseRootFromParent_Done,
     /* 2418448 */   // Label 34761: @2418448
     /* 2418448 */   GIM_Try, /*On fail goto*//*Label 34762*/ GIMT_Encode4(2418510), // Rule ID 55420 //
     /* 2418453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418483 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2418486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2418496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418509 */     // GIR_Coverage, 55420,
     /* 2418509 */     GIR_EraseRootFromParent_Done,
     /* 2418510 */   // Label 34762: @2418510
     /* 2418510 */   GIM_Try, /*On fail goto*//*Label 34763*/ GIMT_Encode4(2418572), // Rule ID 55421 //
     /* 2418515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418545 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2418548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2418558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418571 */     // GIR_Coverage, 55421,
     /* 2418571 */     GIR_EraseRootFromParent_Done,
     /* 2418572 */   // Label 34763: @2418572
     /* 2418572 */   GIM_Try, /*On fail goto*//*Label 34764*/ GIMT_Encode4(2418617), // Rule ID 55416 //
     /* 2418577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418592 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2418595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418616 */     // GIR_Coverage, 55416,
     /* 2418616 */     GIR_EraseRootFromParent_Done,
     /* 2418617 */   // Label 34764: @2418617
     /* 2418617 */   GIM_Try, /*On fail goto*//*Label 34765*/ GIMT_Encode4(2418662), // Rule ID 55417 //
     /* 2418622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418637 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2418640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418661 */     // GIR_Coverage, 55417,
     /* 2418661 */     GIR_EraseRootFromParent_Done,
     /* 2418662 */   // Label 34765: @2418662
     /* 2418662 */   GIM_Reject,
     /* 2418663 */ // Label 34753: @2418663
     /* 2418663 */ GIM_Reject,
     /* 2418664 */ // Label 34573: @2418664
     /* 2418664 */ GIM_Try, /*On fail goto*//*Label 34766*/ GIMT_Encode4(2419453),
     /* 2418669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2418675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2418678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418682 */   GIM_Try, /*On fail goto*//*Label 34767*/ GIMT_Encode4(2418759), // Rule ID 55680 //
     /* 2418687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2418690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418730 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2418733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418758 */     // GIR_Coverage, 55680,
     /* 2418758 */     GIR_EraseRootFromParent_Done,
     /* 2418759 */   // Label 34767: @2418759
     /* 2418759 */   GIM_Try, /*On fail goto*//*Label 34768*/ GIMT_Encode4(2418836), // Rule ID 55681 //
     /* 2418764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2418767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418807 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2418810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418835 */     // GIR_Coverage, 55681,
     /* 2418835 */     GIR_EraseRootFromParent_Done,
     /* 2418836 */   // Label 34768: @2418836
     /* 2418836 */   GIM_Try, /*On fail goto*//*Label 34769*/ GIMT_Encode4(2418913), // Rule ID 73227 //
     /* 2418841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2418844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418884 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2418887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418912 */     // GIR_Coverage, 73227,
     /* 2418912 */     GIR_EraseRootFromParent_Done,
     /* 2418913 */   // Label 34769: @2418913
     /* 2418913 */   GIM_Try, /*On fail goto*//*Label 34770*/ GIMT_Encode4(2418990), // Rule ID 73228 //
     /* 2418918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2418921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418961 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2418964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418989 */     // GIR_Coverage, 73228,
     /* 2418989 */     GIR_EraseRootFromParent_Done,
     /* 2418990 */   // Label 34770: @2418990
     /* 2418990 */   GIM_Try, /*On fail goto*//*Label 34771*/ GIMT_Encode4(2419052), // Rule ID 55684 //
     /* 2418995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2418998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419025 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2419028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419051 */     // GIR_Coverage, 55684,
     /* 2419051 */     GIR_EraseRootFromParent_Done,
     /* 2419052 */   // Label 34771: @2419052
     /* 2419052 */   GIM_Try, /*On fail goto*//*Label 34772*/ GIMT_Encode4(2419114), // Rule ID 55685 //
     /* 2419057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419087 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2419090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419113 */     // GIR_Coverage, 55685,
     /* 2419113 */     GIR_EraseRootFromParent_Done,
     /* 2419114 */   // Label 34772: @2419114
     /* 2419114 */   GIM_Try, /*On fail goto*//*Label 34773*/ GIMT_Encode4(2419176), // Rule ID 73231 //
     /* 2419119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2419122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419149 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2419152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419175 */     // GIR_Coverage, 73231,
     /* 2419175 */     GIR_EraseRootFromParent_Done,
     /* 2419176 */   // Label 34773: @2419176
     /* 2419176 */   GIM_Try, /*On fail goto*//*Label 34774*/ GIMT_Encode4(2419238), // Rule ID 73232 //
     /* 2419181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419211 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2419214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419237 */     // GIR_Coverage, 73232,
     /* 2419237 */     GIR_EraseRootFromParent_Done,
     /* 2419238 */   // Label 34774: @2419238
     /* 2419238 */   GIM_Try, /*On fail goto*//*Label 34775*/ GIMT_Encode4(2419300), // Rule ID 55676 //
     /* 2419243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2419246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419273 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2419276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2419282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2419286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419299 */     // GIR_Coverage, 55676,
     /* 2419299 */     GIR_EraseRootFromParent_Done,
     /* 2419300 */   // Label 34775: @2419300
     /* 2419300 */   GIM_Try, /*On fail goto*//*Label 34776*/ GIMT_Encode4(2419362), // Rule ID 55677 //
     /* 2419305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419335 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2419338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2419344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2419348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419361 */     // GIR_Coverage, 55677,
     /* 2419361 */     GIR_EraseRootFromParent_Done,
     /* 2419362 */   // Label 34776: @2419362
     /* 2419362 */   GIM_Try, /*On fail goto*//*Label 34777*/ GIMT_Encode4(2419407), // Rule ID 55672 //
     /* 2419367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2419370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419382 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2419385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2419391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419406 */     // GIR_Coverage, 55672,
     /* 2419406 */     GIR_EraseRootFromParent_Done,
     /* 2419407 */   // Label 34777: @2419407
     /* 2419407 */   GIM_Try, /*On fail goto*//*Label 34778*/ GIMT_Encode4(2419452), // Rule ID 55673 //
     /* 2419412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419427 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2419430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2419436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419451 */     // GIR_Coverage, 55673,
     /* 2419451 */     GIR_EraseRootFromParent_Done,
     /* 2419452 */   // Label 34778: @2419452
     /* 2419452 */   GIM_Reject,
     /* 2419453 */ // Label 34766: @2419453
     /* 2419453 */ GIM_Reject,
     /* 2419454 */ // Label 34574: @2419454
     /* 2419454 */ GIM_Try, /*On fail goto*//*Label 34779*/ GIMT_Encode4(2420243),
     /* 2419459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2419465 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2419468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419472 */   GIM_Try, /*On fail goto*//*Label 34780*/ GIMT_Encode4(2419549), // Rule ID 55232 //
     /* 2419477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2419505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419520 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2419523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419548 */     // GIR_Coverage, 55232,
     /* 2419548 */     GIR_EraseRootFromParent_Done,
     /* 2419549 */   // Label 34780: @2419549
     /* 2419549 */   GIM_Try, /*On fail goto*//*Label 34781*/ GIMT_Encode4(2419626), // Rule ID 55233 //
     /* 2419554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2419582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419597 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2419600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419625 */     // GIR_Coverage, 55233,
     /* 2419625 */     GIR_EraseRootFromParent_Done,
     /* 2419626 */   // Label 34781: @2419626
     /* 2419626 */   GIM_Try, /*On fail goto*//*Label 34782*/ GIMT_Encode4(2419703), // Rule ID 72835 //
     /* 2419631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2419659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419674 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2419677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419702 */     // GIR_Coverage, 72835,
     /* 2419702 */     GIR_EraseRootFromParent_Done,
     /* 2419703 */   // Label 34782: @2419703
     /* 2419703 */   GIM_Try, /*On fail goto*//*Label 34783*/ GIMT_Encode4(2419780), // Rule ID 72836 //
     /* 2419708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2419736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419751 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2419754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419779 */     // GIR_Coverage, 72836,
     /* 2419779 */     GIR_EraseRootFromParent_Done,
     /* 2419780 */   // Label 34783: @2419780
     /* 2419780 */   GIM_Try, /*On fail goto*//*Label 34784*/ GIMT_Encode4(2419842), // Rule ID 55236 //
     /* 2419785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419815 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2419818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419841 */     // GIR_Coverage, 55236,
     /* 2419841 */     GIR_EraseRootFromParent_Done,
     /* 2419842 */   // Label 34784: @2419842
     /* 2419842 */   GIM_Try, /*On fail goto*//*Label 34785*/ GIMT_Encode4(2419904), // Rule ID 55237 //
     /* 2419847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419877 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2419880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419903 */     // GIR_Coverage, 55237,
     /* 2419903 */     GIR_EraseRootFromParent_Done,
     /* 2419904 */   // Label 34785: @2419904
     /* 2419904 */   GIM_Try, /*On fail goto*//*Label 34786*/ GIMT_Encode4(2419966), // Rule ID 72839 //
     /* 2419909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419939 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2419942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419965 */     // GIR_Coverage, 72839,
     /* 2419965 */     GIR_EraseRootFromParent_Done,
     /* 2419966 */   // Label 34786: @2419966
     /* 2419966 */   GIM_Try, /*On fail goto*//*Label 34787*/ GIMT_Encode4(2420028), // Rule ID 72840 //
     /* 2419971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420001 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2420004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420027 */     // GIR_Coverage, 72840,
     /* 2420027 */     GIR_EraseRootFromParent_Done,
     /* 2420028 */   // Label 34787: @2420028
     /* 2420028 */   GIM_Try, /*On fail goto*//*Label 34788*/ GIMT_Encode4(2420090), // Rule ID 55228 //
     /* 2420033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2420036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2420056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420063 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2420066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2420076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420089 */     // GIR_Coverage, 55228,
     /* 2420089 */     GIR_EraseRootFromParent_Done,
     /* 2420090 */   // Label 34788: @2420090
     /* 2420090 */   GIM_Try, /*On fail goto*//*Label 34789*/ GIMT_Encode4(2420152), // Rule ID 55229 //
     /* 2420095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2420098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2420118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420125 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2420128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2420138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420151 */     // GIR_Coverage, 55229,
     /* 2420151 */     GIR_EraseRootFromParent_Done,
     /* 2420152 */   // Label 34789: @2420152
     /* 2420152 */   GIM_Try, /*On fail goto*//*Label 34790*/ GIMT_Encode4(2420197), // Rule ID 55224 //
     /* 2420157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2420160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420172 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2420175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420196 */     // GIR_Coverage, 55224,
     /* 2420196 */     GIR_EraseRootFromParent_Done,
     /* 2420197 */   // Label 34790: @2420197
     /* 2420197 */   GIM_Try, /*On fail goto*//*Label 34791*/ GIMT_Encode4(2420242), // Rule ID 55225 //
     /* 2420202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2420205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420217 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2420220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420241 */     // GIR_Coverage, 55225,
     /* 2420241 */     GIR_EraseRootFromParent_Done,
     /* 2420242 */   // Label 34791: @2420242
     /* 2420242 */   GIM_Reject,
     /* 2420243 */ // Label 34779: @2420243
     /* 2420243 */ GIM_Reject,
     /* 2420244 */ // Label 34575: @2420244
     /* 2420244 */ GIM_Try, /*On fail goto*//*Label 34792*/ GIMT_Encode4(2421033),
     /* 2420249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2420255 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2420258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420262 */   GIM_Try, /*On fail goto*//*Label 34793*/ GIMT_Encode4(2420339), // Rule ID 55488 //
     /* 2420267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2420274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2420295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2420310 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2420313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2420325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420338 */     // GIR_Coverage, 55488,
     /* 2420338 */     GIR_EraseRootFromParent_Done,
     /* 2420339 */   // Label 34793: @2420339
     /* 2420339 */   GIM_Try, /*On fail goto*//*Label 34794*/ GIMT_Encode4(2420416), // Rule ID 55489 //
     /* 2420344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2420351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2420372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2420387 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2420390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2420402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420415 */     // GIR_Coverage, 55489,
     /* 2420415 */     GIR_EraseRootFromParent_Done,
     /* 2420416 */   // Label 34794: @2420416
     /* 2420416 */   GIM_Try, /*On fail goto*//*Label 34795*/ GIMT_Encode4(2420493), // Rule ID 73059 //
     /* 2420421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2420432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2420449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2420464 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2420467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2420479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420492 */     // GIR_Coverage, 73059,
     /* 2420492 */     GIR_EraseRootFromParent_Done,
     /* 2420493 */   // Label 34795: @2420493
     /* 2420493 */   GIM_Try, /*On fail goto*//*Label 34796*/ GIMT_Encode4(2420570), // Rule ID 73060 //
     /* 2420498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2420509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2420526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2420541 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2420544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2420556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420569 */     // GIR_Coverage, 73060,
     /* 2420569 */     GIR_EraseRootFromParent_Done,
     /* 2420570 */   // Label 34796: @2420570
     /* 2420570 */   GIM_Try, /*On fail goto*//*Label 34797*/ GIMT_Encode4(2420632), // Rule ID 55492 //
     /* 2420575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2420582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420605 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2420608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420631 */     // GIR_Coverage, 55492,
     /* 2420631 */     GIR_EraseRootFromParent_Done,
     /* 2420632 */   // Label 34797: @2420632
     /* 2420632 */   GIM_Try, /*On fail goto*//*Label 34798*/ GIMT_Encode4(2420694), // Rule ID 55493 //
     /* 2420637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2420644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420667 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2420670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420693 */     // GIR_Coverage, 55493,
     /* 2420693 */     GIR_EraseRootFromParent_Done,
     /* 2420694 */   // Label 34798: @2420694
     /* 2420694 */   GIM_Try, /*On fail goto*//*Label 34799*/ GIMT_Encode4(2420756), // Rule ID 73063 //
     /* 2420699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2420710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420729 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2420732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420755 */     // GIR_Coverage, 73063,
     /* 2420755 */     GIR_EraseRootFromParent_Done,
     /* 2420756 */   // Label 34799: @2420756
     /* 2420756 */   GIM_Try, /*On fail goto*//*Label 34800*/ GIMT_Encode4(2420818), // Rule ID 73064 //
     /* 2420761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2420772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420791 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2420794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420817 */     // GIR_Coverage, 73064,
     /* 2420817 */     GIR_EraseRootFromParent_Done,
     /* 2420818 */   // Label 34800: @2420818
     /* 2420818 */   GIM_Try, /*On fail goto*//*Label 34801*/ GIMT_Encode4(2420880), // Rule ID 55484 //
     /* 2420823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420853 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2420856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2420866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420879 */     // GIR_Coverage, 55484,
     /* 2420879 */     GIR_EraseRootFromParent_Done,
     /* 2420880 */   // Label 34801: @2420880
     /* 2420880 */   GIM_Try, /*On fail goto*//*Label 34802*/ GIMT_Encode4(2420942), // Rule ID 55485 //
     /* 2420885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420915 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2420918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2420928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420941 */     // GIR_Coverage, 55485,
     /* 2420941 */     GIR_EraseRootFromParent_Done,
     /* 2420942 */   // Label 34802: @2420942
     /* 2420942 */   GIM_Try, /*On fail goto*//*Label 34803*/ GIMT_Encode4(2420987), // Rule ID 55480 //
     /* 2420947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420962 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2420965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420986 */     // GIR_Coverage, 55480,
     /* 2420986 */     GIR_EraseRootFromParent_Done,
     /* 2420987 */   // Label 34803: @2420987
     /* 2420987 */   GIM_Try, /*On fail goto*//*Label 34804*/ GIMT_Encode4(2421032), // Rule ID 55481 //
     /* 2420992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421007 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2421010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421031 */     // GIR_Coverage, 55481,
     /* 2421031 */     GIR_EraseRootFromParent_Done,
     /* 2421032 */   // Label 34804: @2421032
     /* 2421032 */   GIM_Reject,
     /* 2421033 */ // Label 34792: @2421033
     /* 2421033 */ GIM_Reject,
     /* 2421034 */ // Label 34576: @2421034
     /* 2421034 */ GIM_Try, /*On fail goto*//*Label 34805*/ GIMT_Encode4(2421823),
     /* 2421039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2421045 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2421048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421052 */   GIM_Try, /*On fail goto*//*Label 34806*/ GIMT_Encode4(2421129), // Rule ID 55744 //
     /* 2421057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2421064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2421085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2421100 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2421103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2421115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421128 */     // GIR_Coverage, 55744,
     /* 2421128 */     GIR_EraseRootFromParent_Done,
     /* 2421129 */   // Label 34806: @2421129
     /* 2421129 */   GIM_Try, /*On fail goto*//*Label 34807*/ GIMT_Encode4(2421206), // Rule ID 55745 //
     /* 2421134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2421141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2421162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2421177 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2421180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2421192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421205 */     // GIR_Coverage, 55745,
     /* 2421205 */     GIR_EraseRootFromParent_Done,
     /* 2421206 */   // Label 34807: @2421206
     /* 2421206 */   GIM_Try, /*On fail goto*//*Label 34808*/ GIMT_Encode4(2421283), // Rule ID 73283 //
     /* 2421211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2421239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2421254 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2421257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2421269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421282 */     // GIR_Coverage, 73283,
     /* 2421282 */     GIR_EraseRootFromParent_Done,
     /* 2421283 */   // Label 34808: @2421283
     /* 2421283 */   GIM_Try, /*On fail goto*//*Label 34809*/ GIMT_Encode4(2421360), // Rule ID 73284 //
     /* 2421288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2421316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2421331 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2421334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2421346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421359 */     // GIR_Coverage, 73284,
     /* 2421359 */     GIR_EraseRootFromParent_Done,
     /* 2421360 */   // Label 34809: @2421360
     /* 2421360 */   GIM_Try, /*On fail goto*//*Label 34810*/ GIMT_Encode4(2421422), // Rule ID 55748 //
     /* 2421365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2421372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421395 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2421398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421421 */     // GIR_Coverage, 55748,
     /* 2421421 */     GIR_EraseRootFromParent_Done,
     /* 2421422 */   // Label 34810: @2421422
     /* 2421422 */   GIM_Try, /*On fail goto*//*Label 34811*/ GIMT_Encode4(2421484), // Rule ID 55749 //
     /* 2421427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2421434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421457 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2421460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421483 */     // GIR_Coverage, 55749,
     /* 2421483 */     GIR_EraseRootFromParent_Done,
     /* 2421484 */   // Label 34811: @2421484
     /* 2421484 */   GIM_Try, /*On fail goto*//*Label 34812*/ GIMT_Encode4(2421546), // Rule ID 73287 //
     /* 2421489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421519 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2421522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421545 */     // GIR_Coverage, 73287,
     /* 2421545 */     GIR_EraseRootFromParent_Done,
     /* 2421546 */   // Label 34812: @2421546
     /* 2421546 */   GIM_Try, /*On fail goto*//*Label 34813*/ GIMT_Encode4(2421608), // Rule ID 73288 //
     /* 2421551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421581 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2421584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421607 */     // GIR_Coverage, 73288,
     /* 2421607 */     GIR_EraseRootFromParent_Done,
     /* 2421608 */   // Label 34813: @2421608
     /* 2421608 */   GIM_Try, /*On fail goto*//*Label 34814*/ GIMT_Encode4(2421670), // Rule ID 55740 //
     /* 2421613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421643 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2421646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2421656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421669 */     // GIR_Coverage, 55740,
     /* 2421669 */     GIR_EraseRootFromParent_Done,
     /* 2421670 */   // Label 34814: @2421670
     /* 2421670 */   GIM_Try, /*On fail goto*//*Label 34815*/ GIMT_Encode4(2421732), // Rule ID 55741 //
     /* 2421675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421705 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2421708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2421718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421731 */     // GIR_Coverage, 55741,
     /* 2421731 */     GIR_EraseRootFromParent_Done,
     /* 2421732 */   // Label 34815: @2421732
     /* 2421732 */   GIM_Try, /*On fail goto*//*Label 34816*/ GIMT_Encode4(2421777), // Rule ID 55736 //
     /* 2421737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421752 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2421755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421776 */     // GIR_Coverage, 55736,
     /* 2421776 */     GIR_EraseRootFromParent_Done,
     /* 2421777 */   // Label 34816: @2421777
     /* 2421777 */   GIM_Try, /*On fail goto*//*Label 34817*/ GIMT_Encode4(2421822), // Rule ID 55737 //
     /* 2421782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421797 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2421800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421821 */     // GIR_Coverage, 55737,
     /* 2421821 */     GIR_EraseRootFromParent_Done,
     /* 2421822 */   // Label 34817: @2421822
     /* 2421822 */   GIM_Reject,
     /* 2421823 */ // Label 34805: @2421823
     /* 2421823 */ GIM_Reject,
     /* 2421824 */ // Label 34577: @2421824
     /* 2421824 */ GIM_Try, /*On fail goto*//*Label 34818*/ GIMT_Encode4(2422613),
     /* 2421829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2421832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2421835 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2421838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421842 */   GIM_Try, /*On fail goto*//*Label 34819*/ GIMT_Encode4(2421919), // Rule ID 55296 //
     /* 2421847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2421850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2421854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2421862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2421875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2421883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2421890 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2421893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2421905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421918 */     // GIR_Coverage, 55296,
     /* 2421918 */     GIR_EraseRootFromParent_Done,
     /* 2421919 */   // Label 34819: @2421919
     /* 2421919 */   GIM_Try, /*On fail goto*//*Label 34820*/ GIMT_Encode4(2421996), // Rule ID 55297 //
     /* 2421924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2421927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2421931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2421939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2421952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2421960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2421967 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2421970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2421982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421995 */     // GIR_Coverage, 55297,
     /* 2421995 */     GIR_EraseRootFromParent_Done,
     /* 2421996 */   // Label 34820: @2421996
     /* 2421996 */   GIM_Try, /*On fail goto*//*Label 34821*/ GIMT_Encode4(2422073), // Rule ID 72891 //
     /* 2422001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2422004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2422012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2422029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2422044 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2422047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2422059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422072 */     // GIR_Coverage, 72891,
     /* 2422072 */     GIR_EraseRootFromParent_Done,
     /* 2422073 */   // Label 34821: @2422073
     /* 2422073 */   GIM_Try, /*On fail goto*//*Label 34822*/ GIMT_Encode4(2422150), // Rule ID 72892 //
     /* 2422078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2422081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2422089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2422106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2422121 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2422124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2422136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422149 */     // GIR_Coverage, 72892,
     /* 2422149 */     GIR_EraseRootFromParent_Done,
     /* 2422150 */   // Label 34822: @2422150
     /* 2422150 */   GIM_Try, /*On fail goto*//*Label 34823*/ GIMT_Encode4(2422212), // Rule ID 55300 //
     /* 2422155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2422158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2422162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422185 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2422188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422211 */     // GIR_Coverage, 55300,
     /* 2422211 */     GIR_EraseRootFromParent_Done,
     /* 2422212 */   // Label 34823: @2422212
     /* 2422212 */   GIM_Try, /*On fail goto*//*Label 34824*/ GIMT_Encode4(2422274), // Rule ID 55301 //
     /* 2422217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2422220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2422224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422247 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2422250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422273 */     // GIR_Coverage, 55301,
     /* 2422273 */     GIR_EraseRootFromParent_Done,
     /* 2422274 */   // Label 34824: @2422274
     /* 2422274 */   GIM_Try, /*On fail goto*//*Label 34825*/ GIMT_Encode4(2422336), // Rule ID 72895 //
     /* 2422279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2422282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2422290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422309 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2422312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422335 */     // GIR_Coverage, 72895,
     /* 2422335 */     GIR_EraseRootFromParent_Done,
     /* 2422336 */   // Label 34825: @2422336
     /* 2422336 */   GIM_Try, /*On fail goto*//*Label 34826*/ GIMT_Encode4(2422398), // Rule ID 72896 //
     /* 2422341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2422344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2422352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422371 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2422374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422397 */     // GIR_Coverage, 72896,
     /* 2422397 */     GIR_EraseRootFromParent_Done,
     /* 2422398 */   // Label 34826: @2422398
     /* 2422398 */   GIM_Try, /*On fail goto*//*Label 34827*/ GIMT_Encode4(2422460), // Rule ID 55292 //
     /* 2422403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2422406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422433 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2422436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2422442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2422446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422459 */     // GIR_Coverage, 55292,
     /* 2422459 */     GIR_EraseRootFromParent_Done,
     /* 2422460 */   // Label 34827: @2422460
     /* 2422460 */   GIM_Try, /*On fail goto*//*Label 34828*/ GIMT_Encode4(2422522), // Rule ID 55293 //
     /* 2422465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2422468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422495 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2422498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2422504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2422508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422521 */     // GIR_Coverage, 55293,
     /* 2422521 */     GIR_EraseRootFromParent_Done,
     /* 2422522 */   // Label 34828: @2422522
     /* 2422522 */   GIM_Try, /*On fail goto*//*Label 34829*/ GIMT_Encode4(2422567), // Rule ID 55288 //
     /* 2422527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2422530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422542 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2422545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2422551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422566 */     // GIR_Coverage, 55288,
     /* 2422566 */     GIR_EraseRootFromParent_Done,
     /* 2422567 */   // Label 34829: @2422567
     /* 2422567 */   GIM_Try, /*On fail goto*//*Label 34830*/ GIMT_Encode4(2422612), // Rule ID 55289 //
     /* 2422572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2422575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422587 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2422590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2422596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422611 */     // GIR_Coverage, 55289,
     /* 2422611 */     GIR_EraseRootFromParent_Done,
     /* 2422612 */   // Label 34830: @2422612
     /* 2422612 */   GIM_Reject,
     /* 2422613 */ // Label 34818: @2422613
     /* 2422613 */ GIM_Reject,
     /* 2422614 */ // Label 34578: @2422614
     /* 2422614 */ GIM_Try, /*On fail goto*//*Label 34831*/ GIMT_Encode4(2423403),
     /* 2422619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2422625 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2422628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422632 */   GIM_Try, /*On fail goto*//*Label 34832*/ GIMT_Encode4(2422709), // Rule ID 55552 //
     /* 2422637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2422640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2422644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2422665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422673 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2422680 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2422683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2422695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422708 */     // GIR_Coverage, 55552,
     /* 2422708 */     GIR_EraseRootFromParent_Done,
     /* 2422709 */   // Label 34832: @2422709
     /* 2422709 */   GIM_Try, /*On fail goto*//*Label 34833*/ GIMT_Encode4(2422786), // Rule ID 55553 //
     /* 2422714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2422717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2422721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2422742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2422757 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2422760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2422772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422785 */     // GIR_Coverage, 55553,
     /* 2422785 */     GIR_EraseRootFromParent_Done,
     /* 2422786 */   // Label 34833: @2422786
     /* 2422786 */   GIM_Try, /*On fail goto*//*Label 34834*/ GIMT_Encode4(2422863), // Rule ID 73115 //
     /* 2422791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2422794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2422802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2422819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2422834 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2422837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2422849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422862 */     // GIR_Coverage, 73115,
     /* 2422862 */     GIR_EraseRootFromParent_Done,
     /* 2422863 */   // Label 34834: @2422863
     /* 2422863 */   GIM_Try, /*On fail goto*//*Label 34835*/ GIMT_Encode4(2422940), // Rule ID 73116 //
     /* 2422868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2422871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2422879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2422896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2422911 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2422914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2422926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422939 */     // GIR_Coverage, 73116,
     /* 2422939 */     GIR_EraseRootFromParent_Done,
     /* 2422940 */   // Label 34835: @2422940
     /* 2422940 */   GIM_Try, /*On fail goto*//*Label 34836*/ GIMT_Encode4(2423002), // Rule ID 55556 //
     /* 2422945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2422948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2422952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422975 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2422978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423001 */     // GIR_Coverage, 55556,
     /* 2423001 */     GIR_EraseRootFromParent_Done,
     /* 2423002 */   // Label 34836: @2423002
     /* 2423002 */   GIM_Try, /*On fail goto*//*Label 34837*/ GIMT_Encode4(2423064), // Rule ID 55557 //
     /* 2423007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2423010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2423014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2423022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423037 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2423040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423063 */     // GIR_Coverage, 55557,
     /* 2423063 */     GIR_EraseRootFromParent_Done,
     /* 2423064 */   // Label 34837: @2423064
     /* 2423064 */   GIM_Try, /*On fail goto*//*Label 34838*/ GIMT_Encode4(2423126), // Rule ID 73119 //
     /* 2423069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2423072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2423088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423099 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2423102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423125 */     // GIR_Coverage, 73119,
     /* 2423125 */     GIR_EraseRootFromParent_Done,
     /* 2423126 */   // Label 34838: @2423126
     /* 2423126 */   GIM_Try, /*On fail goto*//*Label 34839*/ GIMT_Encode4(2423188), // Rule ID 73120 //
     /* 2423131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2423134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2423150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423161 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2423164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423187 */     // GIR_Coverage, 73120,
     /* 2423187 */     GIR_EraseRootFromParent_Done,
     /* 2423188 */   // Label 34839: @2423188
     /* 2423188 */   GIM_Try, /*On fail goto*//*Label 34840*/ GIMT_Encode4(2423250), // Rule ID 55548 //
     /* 2423193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2423196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2423216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423223 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2423226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2423236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423249 */     // GIR_Coverage, 55548,
     /* 2423249 */     GIR_EraseRootFromParent_Done,
     /* 2423250 */   // Label 34840: @2423250
     /* 2423250 */   GIM_Try, /*On fail goto*//*Label 34841*/ GIMT_Encode4(2423312), // Rule ID 55549 //
     /* 2423255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2423258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2423278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423285 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2423288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2423298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423311 */     // GIR_Coverage, 55549,
     /* 2423311 */     GIR_EraseRootFromParent_Done,
     /* 2423312 */   // Label 34841: @2423312
     /* 2423312 */   GIM_Try, /*On fail goto*//*Label 34842*/ GIMT_Encode4(2423357), // Rule ID 55544 //
     /* 2423317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2423320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423332 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2423335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423356 */     // GIR_Coverage, 55544,
     /* 2423356 */     GIR_EraseRootFromParent_Done,
     /* 2423357 */   // Label 34842: @2423357
     /* 2423357 */   GIM_Try, /*On fail goto*//*Label 34843*/ GIMT_Encode4(2423402), // Rule ID 55545 //
     /* 2423362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2423365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423377 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2423380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423401 */     // GIR_Coverage, 55545,
     /* 2423401 */     GIR_EraseRootFromParent_Done,
     /* 2423402 */   // Label 34843: @2423402
     /* 2423402 */   GIM_Reject,
     /* 2423403 */ // Label 34831: @2423403
     /* 2423403 */ GIM_Reject,
     /* 2423404 */ // Label 34579: @2423404
     /* 2423404 */ GIM_Try, /*On fail goto*//*Label 34844*/ GIMT_Encode4(2424193),
     /* 2423409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2423415 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2423418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423422 */   GIM_Try, /*On fail goto*//*Label 34845*/ GIMT_Encode4(2423499), // Rule ID 55360 //
     /* 2423427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2423430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2423434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2423455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2423470 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2423473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2423485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423498 */     // GIR_Coverage, 55360,
     /* 2423498 */     GIR_EraseRootFromParent_Done,
     /* 2423499 */   // Label 34845: @2423499
     /* 2423499 */   GIM_Try, /*On fail goto*//*Label 34846*/ GIMT_Encode4(2423576), // Rule ID 55361 //
     /* 2423504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2423507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2423511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2423532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2423547 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2423550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2423562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423575 */     // GIR_Coverage, 55361,
     /* 2423575 */     GIR_EraseRootFromParent_Done,
     /* 2423576 */   // Label 34846: @2423576
     /* 2423576 */   GIM_Try, /*On fail goto*//*Label 34847*/ GIMT_Encode4(2423653), // Rule ID 72947 //
     /* 2423581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2423584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2423609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2423624 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2423627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2423639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423652 */     // GIR_Coverage, 72947,
     /* 2423652 */     GIR_EraseRootFromParent_Done,
     /* 2423653 */   // Label 34847: @2423653
     /* 2423653 */   GIM_Try, /*On fail goto*//*Label 34848*/ GIMT_Encode4(2423730), // Rule ID 72948 //
     /* 2423658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2423661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2423686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423694 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2423701 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2423704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2423716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423729 */     // GIR_Coverage, 72948,
     /* 2423729 */     GIR_EraseRootFromParent_Done,
     /* 2423730 */   // Label 34848: @2423730
     /* 2423730 */   GIM_Try, /*On fail goto*//*Label 34849*/ GIMT_Encode4(2423792), // Rule ID 55364 //
     /* 2423735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2423738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2423742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423765 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2423768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423791 */     // GIR_Coverage, 55364,
     /* 2423791 */     GIR_EraseRootFromParent_Done,
     /* 2423792 */   // Label 34849: @2423792
     /* 2423792 */   GIM_Try, /*On fail goto*//*Label 34850*/ GIMT_Encode4(2423854), // Rule ID 55365 //
     /* 2423797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2423800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2423804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423827 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2423830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423853 */     // GIR_Coverage, 55365,
     /* 2423853 */     GIR_EraseRootFromParent_Done,
     /* 2423854 */   // Label 34850: @2423854
     /* 2423854 */   GIM_Try, /*On fail goto*//*Label 34851*/ GIMT_Encode4(2423916), // Rule ID 72951 //
     /* 2423859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2423862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423889 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2423892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423915 */     // GIR_Coverage, 72951,
     /* 2423915 */     GIR_EraseRootFromParent_Done,
     /* 2423916 */   // Label 34851: @2423916
     /* 2423916 */   GIM_Try, /*On fail goto*//*Label 34852*/ GIMT_Encode4(2423978), // Rule ID 72952 //
     /* 2423921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2423924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423951 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2423954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423977 */     // GIR_Coverage, 72952,
     /* 2423977 */     GIR_EraseRootFromParent_Done,
     /* 2423978 */   // Label 34852: @2423978
     /* 2423978 */   GIM_Try, /*On fail goto*//*Label 34853*/ GIMT_Encode4(2424040), // Rule ID 55356 //
     /* 2423983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2423986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2424002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2424006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424013 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2424013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2424016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2424020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2424026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2424038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424039 */     // GIR_Coverage, 55356,
     /* 2424039 */     GIR_EraseRootFromParent_Done,
     /* 2424040 */   // Label 34853: @2424040
     /* 2424040 */   GIM_Try, /*On fail goto*//*Label 34854*/ GIMT_Encode4(2424102), // Rule ID 55357 //
     /* 2424045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2424048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2424064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2424068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424075 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2424075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2424078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2424082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2424088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2424100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424101 */     // GIR_Coverage, 55357,
     /* 2424101 */     GIR_EraseRootFromParent_Done,
     /* 2424102 */   // Label 34854: @2424102
     /* 2424102 */   GIM_Try, /*On fail goto*//*Label 34855*/ GIMT_Encode4(2424147), // Rule ID 55352 //
     /* 2424107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2424110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424122 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2424122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2424125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2424129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2424145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424146 */     // GIR_Coverage, 55352,
     /* 2424146 */     GIR_EraseRootFromParent_Done,
     /* 2424147 */   // Label 34855: @2424147
     /* 2424147 */   GIM_Try, /*On fail goto*//*Label 34856*/ GIMT_Encode4(2424192), // Rule ID 55353 //
     /* 2424152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2424155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424167 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2424167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2424170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2424174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2424190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424191 */     // GIR_Coverage, 55353,
     /* 2424191 */     GIR_EraseRootFromParent_Done,
     /* 2424192 */   // Label 34856: @2424192
     /* 2424192 */   GIM_Reject,
     /* 2424193 */ // Label 34844: @2424193
     /* 2424193 */ GIM_Reject,
     /* 2424194 */ // Label 34580: @2424194
     /* 2424194 */ GIM_Reject,
     /* 2424195 */ // Label 103: @2424195
     /* 2424195 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34875*/ GIMT_Encode4(2426370),
     /* 2424206 */ /*GILLT_s16*//*Label 34857*/ GIMT_Encode4(2424326),
     /* 2424210 */ /*GILLT_s32*//*Label 34858*/ GIMT_Encode4(2424448),
     /* 2424214 */ /*GILLT_s64*//*Label 34859*/ GIMT_Encode4(2424570), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424226 */ /*GILLT_nxv1s16*//*Label 34860*/ GIMT_Encode4(2424720),
     /* 2424230 */ /*GILLT_nxv1s32*//*Label 34861*/ GIMT_Encode4(2424830),
     /* 2424234 */ /*GILLT_nxv1s64*//*Label 34862*/ GIMT_Encode4(2424940), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424246 */ /*GILLT_nxv2s16*//*Label 34863*/ GIMT_Encode4(2425050),
     /* 2424250 */ /*GILLT_nxv2s32*//*Label 34864*/ GIMT_Encode4(2425160),
     /* 2424254 */ /*GILLT_nxv2s64*//*Label 34865*/ GIMT_Encode4(2425270), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424266 */ /*GILLT_nxv4s16*//*Label 34866*/ GIMT_Encode4(2425380),
     /* 2424270 */ /*GILLT_nxv4s32*//*Label 34867*/ GIMT_Encode4(2425490),
     /* 2424274 */ /*GILLT_nxv4s64*//*Label 34868*/ GIMT_Encode4(2425600), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424286 */ /*GILLT_nxv8s16*//*Label 34869*/ GIMT_Encode4(2425710),
     /* 2424290 */ /*GILLT_nxv8s32*//*Label 34870*/ GIMT_Encode4(2425820),
     /* 2424294 */ /*GILLT_nxv8s64*//*Label 34871*/ GIMT_Encode4(2425930), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424306 */ /*GILLT_nxv16s16*//*Label 34872*/ GIMT_Encode4(2426040),
     /* 2424310 */ /*GILLT_nxv16s32*//*Label 34873*/ GIMT_Encode4(2426150), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424322 */ /*GILLT_nxv32s16*//*Label 34874*/ GIMT_Encode4(2426260),
     /* 2424326 */ // Label 34857: @2424326
     /* 2424326 */ GIM_Try, /*On fail goto*//*Label 34876*/ GIMT_Encode4(2424447),
     /* 2424331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2424334 */   GIM_Try, /*On fail goto*//*Label 34877*/ GIMT_Encode4(2424362), // Rule ID 1996 //
     /* 2424339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2424342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2424346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2424350 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2424350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2424353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424361 */     // GIR_Coverage, 1996,
     /* 2424361 */     GIR_EraseRootFromParent_Done,
     /* 2424362 */   // Label 34877: @2424362
     /* 2424362 */   GIM_Try, /*On fail goto*//*Label 34878*/ GIMT_Encode4(2424390), // Rule ID 1997 //
     /* 2424367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2424370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2424374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2424378 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2424378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2424381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424389 */     // GIR_Coverage, 1997,
     /* 2424389 */     GIR_EraseRootFromParent_Done,
     /* 2424390 */   // Label 34878: @2424390
     /* 2424390 */   GIM_Try, /*On fail goto*//*Label 34879*/ GIMT_Encode4(2424418), // Rule ID 2029 //
     /* 2424395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2424398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2424402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2424406 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2424406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2424409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424417 */     // GIR_Coverage, 2029,
     /* 2424417 */     GIR_EraseRootFromParent_Done,
     /* 2424418 */   // Label 34879: @2424418
     /* 2424418 */   GIM_Try, /*On fail goto*//*Label 34880*/ GIMT_Encode4(2424446), // Rule ID 2030 //
     /* 2424423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2424426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2424430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2424434 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2424434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2424437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424445 */     // GIR_Coverage, 2030,
     /* 2424445 */     GIR_EraseRootFromParent_Done,
     /* 2424446 */   // Label 34880: @2424446
     /* 2424446 */   GIM_Reject,
     /* 2424447 */ // Label 34876: @2424447
     /* 2424447 */ GIM_Reject,
     /* 2424448 */ // Label 34858: @2424448
     /* 2424448 */ GIM_Try, /*On fail goto*//*Label 34881*/ GIMT_Encode4(2424569),
     /* 2424453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424456 */   GIM_Try, /*On fail goto*//*Label 34882*/ GIMT_Encode4(2424484), // Rule ID 1287 //
     /* 2424461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2424464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2424468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2424472 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2424472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2424475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424483 */     // GIR_Coverage, 1287,
     /* 2424483 */     GIR_EraseRootFromParent_Done,
     /* 2424484 */   // Label 34882: @2424484
     /* 2424484 */   GIM_Try, /*On fail goto*//*Label 34883*/ GIMT_Encode4(2424512), // Rule ID 1288 //
     /* 2424489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2424492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2424496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2424500 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2424500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2424503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424511 */     // GIR_Coverage, 1288,
     /* 2424511 */     GIR_EraseRootFromParent_Done,
     /* 2424512 */   // Label 34883: @2424512
     /* 2424512 */   GIM_Try, /*On fail goto*//*Label 34884*/ GIMT_Encode4(2424540), // Rule ID 1295 //
     /* 2424517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2424520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2424524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2424528 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2424528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2424531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424539 */     // GIR_Coverage, 1295,
     /* 2424539 */     GIR_EraseRootFromParent_Done,
     /* 2424540 */   // Label 34884: @2424540
     /* 2424540 */   GIM_Try, /*On fail goto*//*Label 34885*/ GIMT_Encode4(2424568), // Rule ID 1296 //
     /* 2424545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2424548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2424552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2424556 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2424556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2424559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424567 */     // GIR_Coverage, 1296,
     /* 2424567 */     GIR_EraseRootFromParent_Done,
     /* 2424568 */   // Label 34885: @2424568
     /* 2424568 */   GIM_Reject,
     /* 2424569 */ // Label 34881: @2424569
     /* 2424569 */ GIM_Reject,
     /* 2424570 */ // Label 34859: @2424570
     /* 2424570 */ GIM_Try, /*On fail goto*//*Label 34886*/ GIMT_Encode4(2424719),
     /* 2424575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424578 */   GIM_Try, /*On fail goto*//*Label 34887*/ GIMT_Encode4(2424606), // Rule ID 1630 //
     /* 2424583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2424586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2424590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2424594 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2424594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2424597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424605 */     // GIR_Coverage, 1630,
     /* 2424605 */     GIR_EraseRootFromParent_Done,
     /* 2424606 */   // Label 34887: @2424606
     /* 2424606 */   GIM_Try, /*On fail goto*//*Label 34888*/ GIMT_Encode4(2424634), // Rule ID 1631 //
     /* 2424611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2424614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2424618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2424622 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2424622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2424625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424633 */     // GIR_Coverage, 1631,
     /* 2424633 */     GIR_EraseRootFromParent_Done,
     /* 2424634 */   // Label 34888: @2424634
     /* 2424634 */   GIM_Try, /*On fail goto*//*Label 34889*/ GIMT_Encode4(2424662), // Rule ID 1665 //
     /* 2424639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2424642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424650 */     // (strict_fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2424650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2424653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424661 */     // GIR_Coverage, 1665,
     /* 2424661 */     GIR_EraseRootFromParent_Done,
     /* 2424662 */   // Label 34889: @2424662
     /* 2424662 */   GIM_Try, /*On fail goto*//*Label 34890*/ GIMT_Encode4(2424690), // Rule ID 1685 //
     /* 2424667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2424670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2424674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2424678 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2424678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2424681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424689 */     // GIR_Coverage, 1685,
     /* 2424689 */     GIR_EraseRootFromParent_Done,
     /* 2424690 */   // Label 34890: @2424690
     /* 2424690 */   GIM_Try, /*On fail goto*//*Label 34891*/ GIMT_Encode4(2424718), // Rule ID 1686 //
     /* 2424695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2424698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2424702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2424706 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2424706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2424709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424717 */     // GIR_Coverage, 1686,
     /* 2424717 */     GIR_EraseRootFromParent_Done,
     /* 2424718 */   // Label 34891: @2424718
     /* 2424718 */   GIM_Reject,
     /* 2424719 */ // Label 34886: @2424719
     /* 2424719 */ GIM_Reject,
     /* 2424720 */ // Label 34860: @2424720
     /* 2424720 */ GIM_Try, /*On fail goto*//*Label 34892*/ GIMT_Encode4(2424829),
     /* 2424725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2424728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424736 */   GIM_Try, /*On fail goto*//*Label 34893*/ GIMT_Encode4(2424782), // Rule ID 56248 //
     /* 2424741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2424744 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2424744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2424747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2424751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2424756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2424758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2424761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2424766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2424768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424781 */     // GIR_Coverage, 56248,
     /* 2424781 */     GIR_EraseRootFromParent_Done,
     /* 2424782 */   // Label 34893: @2424782
     /* 2424782 */   GIM_Try, /*On fail goto*//*Label 34894*/ GIMT_Encode4(2424828), // Rule ID 56249 //
     /* 2424787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2424790 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2424790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2424793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2424797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2424802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2424804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2424807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2424812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2424814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424827 */     // GIR_Coverage, 56249,
     /* 2424827 */     GIR_EraseRootFromParent_Done,
     /* 2424828 */   // Label 34894: @2424828
     /* 2424828 */   GIM_Reject,
     /* 2424829 */ // Label 34892: @2424829
     /* 2424829 */ GIM_Reject,
     /* 2424830 */ // Label 34861: @2424830
     /* 2424830 */ GIM_Try, /*On fail goto*//*Label 34895*/ GIMT_Encode4(2424939),
     /* 2424835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2424838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424846 */   GIM_Try, /*On fail goto*//*Label 34896*/ GIMT_Encode4(2424892), // Rule ID 56288 //
     /* 2424851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2424854 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2424854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2424857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2424861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2424866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2424868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2424871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2424876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2424878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424891 */     // GIR_Coverage, 56288,
     /* 2424891 */     GIR_EraseRootFromParent_Done,
     /* 2424892 */   // Label 34896: @2424892
     /* 2424892 */   GIM_Try, /*On fail goto*//*Label 34897*/ GIMT_Encode4(2424938), // Rule ID 56289 //
     /* 2424897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2424900 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2424900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2424903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2424907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2424912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2424914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2424917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2424922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2424924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424937 */     // GIR_Coverage, 56289,
     /* 2424937 */     GIR_EraseRootFromParent_Done,
     /* 2424938 */   // Label 34897: @2424938
     /* 2424938 */   GIM_Reject,
     /* 2424939 */ // Label 34895: @2424939
     /* 2424939 */ GIM_Reject,
     /* 2424940 */ // Label 34862: @2424940
     /* 2424940 */ GIM_Try, /*On fail goto*//*Label 34898*/ GIMT_Encode4(2425049),
     /* 2424945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2424948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424956 */   GIM_Try, /*On fail goto*//*Label 34899*/ GIMT_Encode4(2425002), // Rule ID 56348 //
     /* 2424961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2424964 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2424964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2424967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2424971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2424976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2424978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2424981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2424986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2424988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425001 */     // GIR_Coverage, 56348,
     /* 2425001 */     GIR_EraseRootFromParent_Done,
     /* 2425002 */   // Label 34899: @2425002
     /* 2425002 */   GIM_Try, /*On fail goto*//*Label 34900*/ GIMT_Encode4(2425048), // Rule ID 56349 //
     /* 2425007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2425010 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2425013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2425027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425047 */     // GIR_Coverage, 56349,
     /* 2425047 */     GIR_EraseRootFromParent_Done,
     /* 2425048 */   // Label 34900: @2425048
     /* 2425048 */   GIM_Reject,
     /* 2425049 */ // Label 34898: @2425049
     /* 2425049 */ GIM_Reject,
     /* 2425050 */ // Label 34863: @2425050
     /* 2425050 */ GIM_Try, /*On fail goto*//*Label 34901*/ GIMT_Encode4(2425159),
     /* 2425055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2425058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425066 */   GIM_Try, /*On fail goto*//*Label 34902*/ GIMT_Encode4(2425112), // Rule ID 56268 //
     /* 2425071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2425074 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2425077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2425091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425111 */     // GIR_Coverage, 56268,
     /* 2425111 */     GIR_EraseRootFromParent_Done,
     /* 2425112 */   // Label 34902: @2425112
     /* 2425112 */   GIM_Try, /*On fail goto*//*Label 34903*/ GIMT_Encode4(2425158), // Rule ID 56269 //
     /* 2425117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2425120 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2425123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2425137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425157 */     // GIR_Coverage, 56269,
     /* 2425157 */     GIR_EraseRootFromParent_Done,
     /* 2425158 */   // Label 34903: @2425158
     /* 2425158 */   GIM_Reject,
     /* 2425159 */ // Label 34901: @2425159
     /* 2425159 */ GIM_Reject,
     /* 2425160 */ // Label 34864: @2425160
     /* 2425160 */ GIM_Try, /*On fail goto*//*Label 34904*/ GIMT_Encode4(2425269),
     /* 2425165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2425168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425176 */   GIM_Try, /*On fail goto*//*Label 34905*/ GIMT_Encode4(2425222), // Rule ID 56328 //
     /* 2425181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2425184 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2425187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2425201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425221 */     // GIR_Coverage, 56328,
     /* 2425221 */     GIR_EraseRootFromParent_Done,
     /* 2425222 */   // Label 34905: @2425222
     /* 2425222 */   GIM_Try, /*On fail goto*//*Label 34906*/ GIMT_Encode4(2425268), // Rule ID 56329 //
     /* 2425227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2425230 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2425233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2425247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425267 */     // GIR_Coverage, 56329,
     /* 2425267 */     GIR_EraseRootFromParent_Done,
     /* 2425268 */   // Label 34906: @2425268
     /* 2425268 */   GIM_Reject,
     /* 2425269 */ // Label 34904: @2425269
     /* 2425269 */ GIM_Reject,
     /* 2425270 */ // Label 34865: @2425270
     /* 2425270 */ GIM_Try, /*On fail goto*//*Label 34907*/ GIMT_Encode4(2425379),
     /* 2425275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2425278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425286 */   GIM_Try, /*On fail goto*//*Label 34908*/ GIMT_Encode4(2425332), // Rule ID 56488 //
     /* 2425291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2425294 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2425297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2425311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425331 */     // GIR_Coverage, 56488,
     /* 2425331 */     GIR_EraseRootFromParent_Done,
     /* 2425332 */   // Label 34908: @2425332
     /* 2425332 */   GIM_Try, /*On fail goto*//*Label 34909*/ GIMT_Encode4(2425378), // Rule ID 56489 //
     /* 2425337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2425340 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2425343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2425357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425377 */     // GIR_Coverage, 56489,
     /* 2425377 */     GIR_EraseRootFromParent_Done,
     /* 2425378 */   // Label 34909: @2425378
     /* 2425378 */   GIM_Reject,
     /* 2425379 */ // Label 34907: @2425379
     /* 2425379 */ GIM_Reject,
     /* 2425380 */ // Label 34866: @2425380
     /* 2425380 */ GIM_Try, /*On fail goto*//*Label 34910*/ GIMT_Encode4(2425489),
     /* 2425385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2425388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425396 */   GIM_Try, /*On fail goto*//*Label 34911*/ GIMT_Encode4(2425442), // Rule ID 56308 //
     /* 2425401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2425404 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2425407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2425421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425441 */     // GIR_Coverage, 56308,
     /* 2425441 */     GIR_EraseRootFromParent_Done,
     /* 2425442 */   // Label 34911: @2425442
     /* 2425442 */   GIM_Try, /*On fail goto*//*Label 34912*/ GIMT_Encode4(2425488), // Rule ID 56309 //
     /* 2425447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2425450 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2425453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2425467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425487 */     // GIR_Coverage, 56309,
     /* 2425487 */     GIR_EraseRootFromParent_Done,
     /* 2425488 */   // Label 34912: @2425488
     /* 2425488 */   GIM_Reject,
     /* 2425489 */ // Label 34910: @2425489
     /* 2425489 */ GIM_Reject,
     /* 2425490 */ // Label 34867: @2425490
     /* 2425490 */ GIM_Try, /*On fail goto*//*Label 34913*/ GIMT_Encode4(2425599),
     /* 2425495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2425498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425506 */   GIM_Try, /*On fail goto*//*Label 34914*/ GIMT_Encode4(2425552), // Rule ID 56428 //
     /* 2425511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2425514 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2425517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2425531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425551 */     // GIR_Coverage, 56428,
     /* 2425551 */     GIR_EraseRootFromParent_Done,
     /* 2425552 */   // Label 34914: @2425552
     /* 2425552 */   GIM_Try, /*On fail goto*//*Label 34915*/ GIMT_Encode4(2425598), // Rule ID 56429 //
     /* 2425557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2425560 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2425563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2425577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425597 */     // GIR_Coverage, 56429,
     /* 2425597 */     GIR_EraseRootFromParent_Done,
     /* 2425598 */   // Label 34915: @2425598
     /* 2425598 */   GIM_Reject,
     /* 2425599 */ // Label 34913: @2425599
     /* 2425599 */ GIM_Reject,
     /* 2425600 */ // Label 34868: @2425600
     /* 2425600 */ GIM_Try, /*On fail goto*//*Label 34916*/ GIMT_Encode4(2425709),
     /* 2425605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2425608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425616 */   GIM_Try, /*On fail goto*//*Label 34917*/ GIMT_Encode4(2425662), // Rule ID 56508 //
     /* 2425621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2425624 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2425627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2425641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425661 */     // GIR_Coverage, 56508,
     /* 2425661 */     GIR_EraseRootFromParent_Done,
     /* 2425662 */   // Label 34917: @2425662
     /* 2425662 */   GIM_Try, /*On fail goto*//*Label 34918*/ GIMT_Encode4(2425708), // Rule ID 56509 //
     /* 2425667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2425670 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2425673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2425687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425707 */     // GIR_Coverage, 56509,
     /* 2425707 */     GIR_EraseRootFromParent_Done,
     /* 2425708 */   // Label 34918: @2425708
     /* 2425708 */   GIM_Reject,
     /* 2425709 */ // Label 34916: @2425709
     /* 2425709 */ GIM_Reject,
     /* 2425710 */ // Label 34869: @2425710
     /* 2425710 */ GIM_Try, /*On fail goto*//*Label 34919*/ GIMT_Encode4(2425819),
     /* 2425715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2425718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425726 */   GIM_Try, /*On fail goto*//*Label 34920*/ GIMT_Encode4(2425772), // Rule ID 56368 //
     /* 2425731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2425734 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2425737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2425751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425771 */     // GIR_Coverage, 56368,
     /* 2425771 */     GIR_EraseRootFromParent_Done,
     /* 2425772 */   // Label 34920: @2425772
     /* 2425772 */   GIM_Try, /*On fail goto*//*Label 34921*/ GIMT_Encode4(2425818), // Rule ID 56369 //
     /* 2425777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2425780 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2425783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2425797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425817 */     // GIR_Coverage, 56369,
     /* 2425817 */     GIR_EraseRootFromParent_Done,
     /* 2425818 */   // Label 34921: @2425818
     /* 2425818 */   GIM_Reject,
     /* 2425819 */ // Label 34919: @2425819
     /* 2425819 */ GIM_Reject,
     /* 2425820 */ // Label 34870: @2425820
     /* 2425820 */ GIM_Try, /*On fail goto*//*Label 34922*/ GIMT_Encode4(2425929),
     /* 2425825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2425828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425836 */   GIM_Try, /*On fail goto*//*Label 34923*/ GIMT_Encode4(2425882), // Rule ID 56448 //
     /* 2425841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2425844 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2425847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2425861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425881 */     // GIR_Coverage, 56448,
     /* 2425881 */     GIR_EraseRootFromParent_Done,
     /* 2425882 */   // Label 34923: @2425882
     /* 2425882 */   GIM_Try, /*On fail goto*//*Label 34924*/ GIMT_Encode4(2425928), // Rule ID 56449 //
     /* 2425887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2425890 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2425893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2425907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425927 */     // GIR_Coverage, 56449,
     /* 2425927 */     GIR_EraseRootFromParent_Done,
     /* 2425928 */   // Label 34924: @2425928
     /* 2425928 */   GIM_Reject,
     /* 2425929 */ // Label 34922: @2425929
     /* 2425929 */ GIM_Reject,
     /* 2425930 */ // Label 34871: @2425930
     /* 2425930 */ GIM_Try, /*On fail goto*//*Label 34925*/ GIMT_Encode4(2426039),
     /* 2425935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2425938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2425942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2425946 */   GIM_Try, /*On fail goto*//*Label 34926*/ GIMT_Encode4(2425992), // Rule ID 56528 //
     /* 2425951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2425954 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2425957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2425971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425991 */     // GIR_Coverage, 56528,
     /* 2425991 */     GIR_EraseRootFromParent_Done,
     /* 2425992 */   // Label 34926: @2425992
     /* 2425992 */   GIM_Try, /*On fail goto*//*Label 34927*/ GIMT_Encode4(2426038), // Rule ID 56529 //
     /* 2425997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2426000 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2426000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2426003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2426017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426037 */     // GIR_Coverage, 56529,
     /* 2426037 */     GIR_EraseRootFromParent_Done,
     /* 2426038 */   // Label 34927: @2426038
     /* 2426038 */   GIM_Reject,
     /* 2426039 */ // Label 34925: @2426039
     /* 2426039 */ GIM_Reject,
     /* 2426040 */ // Label 34872: @2426040
     /* 2426040 */ GIM_Try, /*On fail goto*//*Label 34928*/ GIMT_Encode4(2426149),
     /* 2426045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2426048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426056 */   GIM_Try, /*On fail goto*//*Label 34929*/ GIMT_Encode4(2426102), // Rule ID 56388 //
     /* 2426061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2426064 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2426064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2426067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2426081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426101 */     // GIR_Coverage, 56388,
     /* 2426101 */     GIR_EraseRootFromParent_Done,
     /* 2426102 */   // Label 34929: @2426102
     /* 2426102 */   GIM_Try, /*On fail goto*//*Label 34930*/ GIMT_Encode4(2426148), // Rule ID 56389 //
     /* 2426107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2426110 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2426110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2426113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2426127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426147 */     // GIR_Coverage, 56389,
     /* 2426147 */     GIR_EraseRootFromParent_Done,
     /* 2426148 */   // Label 34930: @2426148
     /* 2426148 */   GIM_Reject,
     /* 2426149 */ // Label 34928: @2426149
     /* 2426149 */ GIM_Reject,
     /* 2426150 */ // Label 34873: @2426150
     /* 2426150 */ GIM_Try, /*On fail goto*//*Label 34931*/ GIMT_Encode4(2426259),
     /* 2426155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2426158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426166 */   GIM_Try, /*On fail goto*//*Label 34932*/ GIMT_Encode4(2426212), // Rule ID 56468 //
     /* 2426171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2426174 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2426174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2426177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2426191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426211 */     // GIR_Coverage, 56468,
     /* 2426211 */     GIR_EraseRootFromParent_Done,
     /* 2426212 */   // Label 34932: @2426212
     /* 2426212 */   GIM_Try, /*On fail goto*//*Label 34933*/ GIMT_Encode4(2426258), // Rule ID 56469 //
     /* 2426217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2426220 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2426220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2426223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2426237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426257 */     // GIR_Coverage, 56469,
     /* 2426257 */     GIR_EraseRootFromParent_Done,
     /* 2426258 */   // Label 34933: @2426258
     /* 2426258 */   GIM_Reject,
     /* 2426259 */ // Label 34931: @2426259
     /* 2426259 */ GIM_Reject,
     /* 2426260 */ // Label 34874: @2426260
     /* 2426260 */ GIM_Try, /*On fail goto*//*Label 34934*/ GIMT_Encode4(2426369),
     /* 2426265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2426268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426276 */   GIM_Try, /*On fail goto*//*Label 34935*/ GIMT_Encode4(2426322), // Rule ID 56408 //
     /* 2426281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2426284 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2426284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2426287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2426301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426321 */     // GIR_Coverage, 56408,
     /* 2426321 */     GIR_EraseRootFromParent_Done,
     /* 2426322 */   // Label 34935: @2426322
     /* 2426322 */   GIM_Try, /*On fail goto*//*Label 34936*/ GIMT_Encode4(2426368), // Rule ID 56409 //
     /* 2426327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2426330 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2426330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2426333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2426347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426367 */     // GIR_Coverage, 56409,
     /* 2426367 */     GIR_EraseRootFromParent_Done,
     /* 2426368 */   // Label 34936: @2426368
     /* 2426368 */   GIM_Reject,
     /* 2426369 */ // Label 34934: @2426369
     /* 2426369 */ GIM_Reject,
     /* 2426370 */ // Label 34875: @2426370
     /* 2426370 */ GIM_Reject,
     /* 2426371 */ // Label 104: @2426371
     /* 2426371 */ GIM_Try, /*On fail goto*//*Label 34937*/ GIMT_Encode4(2426383), // Rule ID 301 //
     /* 2426376 */   // (trap)  =>  (UNIMP)
     /* 2426376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::UNIMP),
     /* 2426381 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426382 */   // GIR_Coverage, 301,
     /* 2426382 */   GIR_Done,
     /* 2426383 */ // Label 34937: @2426383
     /* 2426383 */ GIM_Reject,
     /* 2426384 */ // Label 105: @2426384
     /* 2426384 */ GIM_Try, /*On fail goto*//*Label 34938*/ GIMT_Encode4(2426396), // Rule ID 302 //
     /* 2426389 */   // (debugtrap)  =>  (EBREAK)
     /* 2426389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::EBREAK),
     /* 2426394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426395 */   // GIR_Coverage, 302,
     /* 2426395 */   GIR_Done,
     /* 2426396 */ // Label 34938: @2426396
     /* 2426396 */ GIM_Reject,
     /* 2426397 */ // Label 106: @2426397
     /* 2426397 */ GIM_Try, /*On fail goto*//*Label 34939*/ GIMT_Encode4(2426491),
     /* 2426402 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2426405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426412 */   GIM_Try, /*On fail goto*//*Label 34940*/ GIMT_Encode4(2426431), // Rule ID 2530 //
     /* 2426417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2426420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426424 */     // (riscv_clzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2426424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZW),
     /* 2426429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426430 */     // GIR_Coverage, 2530,
     /* 2426430 */     GIR_Done,
     /* 2426431 */   // Label 34940: @2426431
     /* 2426431 */   GIM_Try, /*On fail goto*//*Label 34941*/ GIMT_Encode4(2426490), // Rule ID 62583 //
     /* 2426436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2426439 */     // (riscv_clzw:{ *:[i64] } i64:{ *:[i64] }:$rs1)  =>  (TH_FF0:{ *:[i64] } (SLLI:{ *:[i64] } (XORI:{ *:[i64] } i64:{ *:[i64] }:$rs1, -1:{ *:[i64] }), 32:{ *:[i64] }))
     /* 2426439 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 2426442 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2426446 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426451 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /* 2426455 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
     /* 2426458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 2426460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2426463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2426467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426472 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2426475 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2426478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2426483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426489 */     // GIR_Coverage, 62583,
     /* 2426489 */     GIR_EraseRootFromParent_Done,
     /* 2426490 */   // Label 34941: @2426490
     /* 2426490 */   GIM_Reject,
     /* 2426491 */ // Label 34939: @2426491
     /* 2426491 */ GIM_Reject,
     /* 2426492 */ // Label 107: @2426492
     /* 2426492 */ GIM_Try, /*On fail goto*//*Label 34942*/ GIMT_Encode4(2426521), // Rule ID 2531 //
     /* 2426497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2426500 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2426503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426514 */   // (riscv_ctzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2426514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZW),
     /* 2426519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426520 */   // GIR_Coverage, 2531,
     /* 2426520 */   GIR_Done,
     /* 2426521 */ // Label 34942: @2426521
     /* 2426521 */ GIM_Reject,
     /* 2426522 */ // Label 108: @2426522
     /* 2426522 */ GIM_Try, /*On fail goto*//*Label 34943*/ GIMT_Encode4(2426558), // Rule ID 327 //
     /* 2426527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2426530 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2426533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2426539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426551 */   // (riscv_divuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2426551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVUW),
     /* 2426556 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426557 */   // GIR_Coverage, 327,
     /* 2426557 */   GIR_Done,
     /* 2426558 */ // Label 34943: @2426558
     /* 2426558 */ GIM_Reject,
     /* 2426559 */ // Label 109: @2426559
     /* 2426559 */ GIM_Try, /*On fail goto*//*Label 34944*/ GIMT_Encode4(2426595), // Rule ID 326 //
     /* 2426564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2426567 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2426570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2426576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426588 */   // (riscv_divw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2426588 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVW),
     /* 2426593 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426594 */   // GIR_Coverage, 326,
     /* 2426594 */   GIR_Done,
     /* 2426595 */ // Label 34944: @2426595
     /* 2426595 */ GIM_Reject,
     /* 2426596 */ // Label 110: @2426596
     /* 2426596 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34947*/ GIMT_Encode4(2426955),
     /* 2426607 */ /*GILLT_s32*//*Label 34945*/ GIMT_Encode4(2426615),
     /* 2426611 */ /*GILLT_s64*//*Label 34946*/ GIMT_Encode4(2426772),
     /* 2426615 */ // Label 34945: @2426615
     /* 2426615 */ GIM_Try, /*On fail goto*//*Label 34948*/ GIMT_Encode4(2426641), // Rule ID 1294 //
     /* 2426620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2426623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2426626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2426634 */   // (riscv_fclass:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2426634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2426639 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426640 */   // GIR_Coverage, 1294,
     /* 2426640 */   GIR_Done,
     /* 2426641 */ // Label 34948: @2426641
     /* 2426641 */ GIM_Try, /*On fail goto*//*Label 34949*/ GIMT_Encode4(2426667), // Rule ID 1302 //
     /* 2426646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2426649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2426652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2426660 */   // (riscv_fclass:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2426660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2426665 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426666 */   // GIR_Coverage, 1302,
     /* 2426666 */   GIR_Done,
     /* 2426667 */ // Label 34949: @2426667
     /* 2426667 */ GIM_Try, /*On fail goto*//*Label 34950*/ GIMT_Encode4(2426693), // Rule ID 1637 //
     /* 2426672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2426675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2426686 */   // (riscv_fclass:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2426686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2426691 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426692 */   // GIR_Coverage, 1637,
     /* 2426692 */   GIR_Done,
     /* 2426693 */ // Label 34950: @2426693
     /* 2426693 */ GIM_Try, /*On fail goto*//*Label 34951*/ GIMT_Encode4(2426719), // Rule ID 1692 //
     /* 2426698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2426701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2426712 */   // (riscv_fclass:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2426712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2426717 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426718 */   // GIR_Coverage, 1692,
     /* 2426718 */   GIR_Done,
     /* 2426719 */ // Label 34951: @2426719
     /* 2426719 */ GIM_Try, /*On fail goto*//*Label 34952*/ GIMT_Encode4(2426745), // Rule ID 2003 //
     /* 2426724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2426727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2426730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2426738 */   // (riscv_fclass:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2426738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2426743 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426744 */   // GIR_Coverage, 2003,
     /* 2426744 */   GIR_Done,
     /* 2426745 */ // Label 34952: @2426745
     /* 2426745 */ GIM_Try, /*On fail goto*//*Label 34953*/ GIMT_Encode4(2426771), // Rule ID 2036 //
     /* 2426750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2426753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2426756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2426764 */   // (riscv_fclass:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2426764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2426769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426770 */   // GIR_Coverage, 2036,
     /* 2426770 */   GIR_Done,
     /* 2426771 */ // Label 34953: @2426771
     /* 2426771 */ GIM_Reject,
     /* 2426772 */ // Label 34946: @2426772
     /* 2426772 */ GIM_Try, /*On fail goto*//*Label 34954*/ GIMT_Encode4(2426798), // Rule ID 1293 //
     /* 2426777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2426780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2426783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2426791 */   // (riscv_fclass:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2426791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2426796 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426797 */   // GIR_Coverage, 1293,
     /* 2426797 */   GIR_Done,
     /* 2426798 */ // Label 34954: @2426798
     /* 2426798 */ GIM_Try, /*On fail goto*//*Label 34955*/ GIMT_Encode4(2426824), // Rule ID 1301 //
     /* 2426803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2426806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2426809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2426817 */   // (riscv_fclass:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2426817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2426822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426823 */   // GIR_Coverage, 1301,
     /* 2426823 */   GIR_Done,
     /* 2426824 */ // Label 34955: @2426824
     /* 2426824 */ GIM_Try, /*On fail goto*//*Label 34956*/ GIMT_Encode4(2426850), // Rule ID 1636 //
     /* 2426829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2426832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2426843 */   // (riscv_fclass:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2426843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2426848 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426849 */   // GIR_Coverage, 1636,
     /* 2426849 */   GIR_Done,
     /* 2426850 */ // Label 34956: @2426850
     /* 2426850 */ GIM_Try, /*On fail goto*//*Label 34957*/ GIMT_Encode4(2426876), // Rule ID 1669 //
     /* 2426855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2426858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426869 */   // (riscv_fclass:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCLASS_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2426869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_INX),
     /* 2426874 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426875 */   // GIR_Coverage, 1669,
     /* 2426875 */   GIR_Done,
     /* 2426876 */ // Label 34957: @2426876
     /* 2426876 */ GIM_Try, /*On fail goto*//*Label 34958*/ GIMT_Encode4(2426902), // Rule ID 1691 //
     /* 2426881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2426884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2426895 */   // (riscv_fclass:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2426895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2426900 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426901 */   // GIR_Coverage, 1691,
     /* 2426901 */   GIR_Done,
     /* 2426902 */ // Label 34958: @2426902
     /* 2426902 */ GIM_Try, /*On fail goto*//*Label 34959*/ GIMT_Encode4(2426928), // Rule ID 2002 //
     /* 2426907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2426910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2426913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2426921 */   // (riscv_fclass:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2426921 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2426926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426927 */   // GIR_Coverage, 2002,
     /* 2426927 */   GIR_Done,
     /* 2426928 */ // Label 34959: @2426928
     /* 2426928 */ GIM_Try, /*On fail goto*//*Label 34960*/ GIMT_Encode4(2426954), // Rule ID 2035 //
     /* 2426933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2426936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2426939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2426947 */   // (riscv_fclass:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2426947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2426952 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426953 */   // GIR_Coverage, 2035,
     /* 2426953 */   GIR_Done,
     /* 2426954 */ // Label 34960: @2426954
     /* 2426954 */ GIM_Reject,
     /* 2426955 */ // Label 34947: @2426955
     /* 2426955 */ GIM_Reject,
     /* 2426956 */ // Label 111: @2426956
     /* 2426956 */ GIM_Try, /*On fail goto*//*Label 34961*/ GIMT_Encode4(2427153),
     /* 2426961 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2426964 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34965*/ GIMT_Encode4(2427152),
     /* 2426975 */   /*GILLT_s16*//*Label 34962*/ GIMT_Encode4(2426987),
     /* 2426979 */   /*GILLT_s32*//*Label 34963*/ GIMT_Encode4(2427042),
     /* 2426983 */   /*GILLT_s64*//*Label 34964*/ GIMT_Encode4(2427097),
     /* 2426987 */   // Label 34962: @2426987
     /* 2426987 */   GIM_Try, /*On fail goto*//*Label 34966*/ GIMT_Encode4(2427041),
     /* 2426992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426996 */     GIM_Try, /*On fail goto*//*Label 34967*/ GIMT_Encode4(2427018), // Rule ID 2253 //
     /* 2427001 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2427004 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2427008 */       // MIs[0] frm
     /* 2427008 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427011 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427011 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2427016 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427017 */       // GIR_Coverage, 2253,
     /* 2427017 */       GIR_Done,
     /* 2427018 */     // Label 34967: @2427018
     /* 2427018 */     GIM_Try, /*On fail goto*//*Label 34968*/ GIMT_Encode4(2427040), // Rule ID 2279 //
     /* 2427023 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2427026 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2427030 */       // MIs[0] frm
     /* 2427030 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427033 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427033 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2427038 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427039 */       // GIR_Coverage, 2279,
     /* 2427039 */       GIR_Done,
     /* 2427040 */     // Label 34968: @2427040
     /* 2427040 */     GIM_Reject,
     /* 2427041 */   // Label 34966: @2427041
     /* 2427041 */   GIM_Reject,
     /* 2427042 */   // Label 34963: @2427042
     /* 2427042 */   GIM_Try, /*On fail goto*//*Label 34969*/ GIMT_Encode4(2427096),
     /* 2427047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427051 */     GIM_Try, /*On fail goto*//*Label 34970*/ GIMT_Encode4(2427073), // Rule ID 1519 //
     /* 2427056 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2427059 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2427063 */       // MIs[0] frm
     /* 2427063 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427066 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427066 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2427071 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427072 */       // GIR_Coverage, 1519,
     /* 2427072 */       GIR_Done,
     /* 2427073 */     // Label 34970: @2427073
     /* 2427073 */     GIM_Try, /*On fail goto*//*Label 34971*/ GIMT_Encode4(2427095), // Rule ID 1547 //
     /* 2427078 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2427081 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2427085 */       // MIs[0] frm
     /* 2427085 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427088 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427088 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2427093 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427094 */       // GIR_Coverage, 1547,
     /* 2427094 */       GIR_Done,
     /* 2427095 */     // Label 34971: @2427095
     /* 2427095 */     GIM_Reject,
     /* 2427096 */   // Label 34969: @2427096
     /* 2427096 */   GIM_Reject,
     /* 2427097 */   // Label 34964: @2427097
     /* 2427097 */   GIM_Try, /*On fail goto*//*Label 34972*/ GIMT_Encode4(2427151),
     /* 2427102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427106 */     GIM_Try, /*On fail goto*//*Label 34973*/ GIMT_Encode4(2427128), // Rule ID 1913 //
     /* 2427111 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2427114 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2427118 */       // MIs[0] frm
     /* 2427118 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427121 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427121 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2427126 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427127 */       // GIR_Coverage, 1913,
     /* 2427127 */       GIR_Done,
     /* 2427128 */     // Label 34973: @2427128
     /* 2427128 */     GIM_Try, /*On fail goto*//*Label 34974*/ GIMT_Encode4(2427150), // Rule ID 1941 //
     /* 2427133 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2427136 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427140 */       // MIs[0] frm
     /* 2427140 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427143 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427143 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_INX),
     /* 2427148 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427149 */       // GIR_Coverage, 1941,
     /* 2427149 */       GIR_Done,
     /* 2427150 */     // Label 34974: @2427150
     /* 2427150 */     GIM_Reject,
     /* 2427151 */   // Label 34972: @2427151
     /* 2427151 */   GIM_Reject,
     /* 2427152 */   // Label 34965: @2427152
     /* 2427152 */   GIM_Reject,
     /* 2427153 */ // Label 34961: @2427153
     /* 2427153 */ GIM_Reject,
     /* 2427154 */ // Label 112: @2427154
     /* 2427154 */ GIM_Try, /*On fail goto*//*Label 34975*/ GIMT_Encode4(2427351),
     /* 2427159 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427162 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34979*/ GIMT_Encode4(2427350),
     /* 2427173 */   /*GILLT_s16*//*Label 34976*/ GIMT_Encode4(2427185),
     /* 2427177 */   /*GILLT_s32*//*Label 34977*/ GIMT_Encode4(2427240),
     /* 2427181 */   /*GILLT_s64*//*Label 34978*/ GIMT_Encode4(2427295),
     /* 2427185 */   // Label 34976: @2427185
     /* 2427185 */   GIM_Try, /*On fail goto*//*Label 34980*/ GIMT_Encode4(2427239),
     /* 2427190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427194 */     GIM_Try, /*On fail goto*//*Label 34981*/ GIMT_Encode4(2427216), // Rule ID 2251 //
     /* 2427199 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2427202 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2427206 */       // MIs[0] frm
     /* 2427206 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427209 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427209 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2427214 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427215 */       // GIR_Coverage, 2251,
     /* 2427215 */       GIR_Done,
     /* 2427216 */     // Label 34981: @2427216
     /* 2427216 */     GIM_Try, /*On fail goto*//*Label 34982*/ GIMT_Encode4(2427238), // Rule ID 2277 //
     /* 2427221 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2427224 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2427228 */       // MIs[0] frm
     /* 2427228 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427231 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427231 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2427236 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427237 */       // GIR_Coverage, 2277,
     /* 2427237 */       GIR_Done,
     /* 2427238 */     // Label 34982: @2427238
     /* 2427238 */     GIM_Reject,
     /* 2427239 */   // Label 34980: @2427239
     /* 2427239 */   GIM_Reject,
     /* 2427240 */   // Label 34977: @2427240
     /* 2427240 */   GIM_Try, /*On fail goto*//*Label 34983*/ GIMT_Encode4(2427294),
     /* 2427245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427249 */     GIM_Try, /*On fail goto*//*Label 34984*/ GIMT_Encode4(2427271), // Rule ID 1517 //
     /* 2427254 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2427257 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2427261 */       // MIs[0] frm
     /* 2427261 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427264 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427264 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2427269 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427270 */       // GIR_Coverage, 1517,
     /* 2427270 */       GIR_Done,
     /* 2427271 */     // Label 34984: @2427271
     /* 2427271 */     GIM_Try, /*On fail goto*//*Label 34985*/ GIMT_Encode4(2427293), // Rule ID 1545 //
     /* 2427276 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2427279 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2427283 */       // MIs[0] frm
     /* 2427283 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427286 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427286 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2427291 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427292 */       // GIR_Coverage, 1545,
     /* 2427292 */       GIR_Done,
     /* 2427293 */     // Label 34985: @2427293
     /* 2427293 */     GIM_Reject,
     /* 2427294 */   // Label 34983: @2427294
     /* 2427294 */   GIM_Reject,
     /* 2427295 */   // Label 34978: @2427295
     /* 2427295 */   GIM_Try, /*On fail goto*//*Label 34986*/ GIMT_Encode4(2427349),
     /* 2427300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427304 */     GIM_Try, /*On fail goto*//*Label 34987*/ GIMT_Encode4(2427326), // Rule ID 1911 //
     /* 2427309 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2427312 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2427316 */       // MIs[0] frm
     /* 2427316 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427319 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427319 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2427324 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427325 */       // GIR_Coverage, 1911,
     /* 2427325 */       GIR_Done,
     /* 2427326 */     // Label 34987: @2427326
     /* 2427326 */     GIM_Try, /*On fail goto*//*Label 34988*/ GIMT_Encode4(2427348), // Rule ID 1939 //
     /* 2427331 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2427334 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427338 */       // MIs[0] frm
     /* 2427338 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427341 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427341 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_INX),
     /* 2427346 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427347 */       // GIR_Coverage, 1939,
     /* 2427347 */       GIR_Done,
     /* 2427348 */     // Label 34988: @2427348
     /* 2427348 */     GIM_Reject,
     /* 2427349 */   // Label 34986: @2427349
     /* 2427349 */   GIM_Reject,
     /* 2427350 */   // Label 34979: @2427350
     /* 2427350 */   GIM_Reject,
     /* 2427351 */ // Label 34975: @2427351
     /* 2427351 */ GIM_Reject,
     /* 2427352 */ // Label 113: @2427352
     /* 2427352 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34991*/ GIMT_Encode4(2427411),
     /* 2427363 */ /*GILLT_s32*//*Label 34989*/ GIMT_Encode4(2427371),
     /* 2427367 */ /*GILLT_s64*//*Label 34990*/ GIMT_Encode4(2427391),
     /* 2427371 */ // Label 34989: @2427371
     /* 2427371 */ GIM_Try, /*On fail goto*//*Label 34992*/ GIMT_Encode4(2427390), // Rule ID 81 //
     /* 2427376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427383 */   // (riscv_read_vlenb:{ *:[i32] })  =>  (PseudoReadVLENB:{ *:[i32] })
     /* 2427383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2427388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427389 */   // GIR_Coverage, 81,
     /* 2427389 */   GIR_Done,
     /* 2427390 */ // Label 34992: @2427390
     /* 2427390 */ GIM_Reject,
     /* 2427391 */ // Label 34990: @2427391
     /* 2427391 */ GIM_Try, /*On fail goto*//*Label 34993*/ GIMT_Encode4(2427410), // Rule ID 80 //
     /* 2427396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427403 */   // (riscv_read_vlenb:{ *:[i64] })  =>  (PseudoReadVLENB:{ *:[i64] })
     /* 2427403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2427408 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427409 */   // GIR_Coverage, 80,
     /* 2427409 */   GIR_Done,
     /* 2427410 */ // Label 34993: @2427410
     /* 2427410 */ GIM_Reject,
     /* 2427411 */ // Label 34991: @2427411
     /* 2427411 */ GIM_Reject,
     /* 2427412 */ // Label 114: @2427412
     /* 2427412 */ GIM_Try, /*On fail goto*//*Label 34994*/ GIMT_Encode4(2427448), // Rule ID 328 //
     /* 2427417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2427420 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2427429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427441 */   // (riscv_remuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2427441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMUW),
     /* 2427446 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427447 */   // GIR_Coverage, 328,
     /* 2427447 */   GIR_Done,
     /* 2427448 */ // Label 34994: @2427448
     /* 2427448 */ GIM_Reject,
     /* 2427449 */ // Label 115: @2427449
     /* 2427449 */ GIM_Try, /*On fail goto*//*Label 34995*/ GIMT_Encode4(2427573),
     /* 2427454 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2427463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427471 */   GIM_Try, /*On fail goto*//*Label 34996*/ GIMT_Encode4(2427507), // Rule ID 2479 //
     /* 2427476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2427479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2427483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427491 */     // MIs[1] Operand 1
     /* 2427491 */     // No operand predicates
     /* 2427491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427493 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2427493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2427496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427500 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2427505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427506 */     // GIR_Coverage, 2479,
     /* 2427506 */     GIR_EraseRootFromParent_Done,
     /* 2427507 */   // Label 34996: @2427507
     /* 2427507 */   GIM_Try, /*On fail goto*//*Label 34997*/ GIMT_Encode4(2427543), // Rule ID 62580 //
     /* 2427512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2427515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2427519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427527 */     // MIs[1] Operand 1
     /* 2427527 */     // No operand predicates
     /* 2427527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427529 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2427529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2427532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427536 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2427541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427542 */     // GIR_Coverage, 62580,
     /* 2427542 */     GIR_EraseRootFromParent_Done,
     /* 2427543 */   // Label 34997: @2427543
     /* 2427543 */   GIM_Try, /*On fail goto*//*Label 34998*/ GIMT_Encode4(2427572), // Rule ID 2476 //
     /* 2427548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2427551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2427558 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2427558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROLW),
     /* 2427561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2427570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427571 */     // GIR_Coverage, 2476,
     /* 2427571 */     GIR_EraseRootFromParent_Done,
     /* 2427572 */   // Label 34998: @2427572
     /* 2427572 */   GIM_Reject,
     /* 2427573 */ // Label 34995: @2427573
     /* 2427573 */ GIM_Reject,
     /* 2427574 */ // Label 116: @2427574
     /* 2427574 */ GIM_Try, /*On fail goto*//*Label 34999*/ GIMT_Encode4(2427694),
     /* 2427579 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2427588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427596 */   GIM_Try, /*On fail goto*//*Label 35000*/ GIMT_Encode4(2427630), // Rule ID 2478 //
     /* 2427601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2427604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2427608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427616 */     // MIs[1] Operand 1
     /* 2427616 */     // No operand predicates
     /* 2427616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427618 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2427618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2427621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2427628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427629 */     // GIR_Coverage, 2478,
     /* 2427629 */     GIR_EraseRootFromParent_Done,
     /* 2427630 */   // Label 35000: @2427630
     /* 2427630 */   GIM_Try, /*On fail goto*//*Label 35001*/ GIMT_Encode4(2427664), // Rule ID 62579 //
     /* 2427635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2427638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2427642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427650 */     // MIs[1] Operand 1
     /* 2427650 */     // No operand predicates
     /* 2427650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427652 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2427652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2427655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2427662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427663 */     // GIR_Coverage, 62579,
     /* 2427663 */     GIR_EraseRootFromParent_Done,
     /* 2427664 */   // Label 35001: @2427664
     /* 2427664 */   GIM_Try, /*On fail goto*//*Label 35002*/ GIMT_Encode4(2427693), // Rule ID 2477 //
     /* 2427669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2427672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2427679 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (RORW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2427679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORW),
     /* 2427682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2427691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427692 */     // GIR_Coverage, 2477,
     /* 2427692 */     GIR_EraseRootFromParent_Done,
     /* 2427693 */   // Label 35002: @2427693
     /* 2427693 */   GIM_Reject,
     /* 2427694 */ // Label 34999: @2427694
     /* 2427694 */ GIM_Reject,
     /* 2427695 */ // Label 117: @2427695
     /* 2427695 */ GIM_Try, /*On fail goto*//*Label 35003*/ GIMT_Encode4(2427741), // Rule ID 279 //
     /* 2427700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2427703 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2427712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427720 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2427727 */   // (riscv_sllw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2427727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLW),
     /* 2427730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427732 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2427739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427740 */   // GIR_Coverage, 279,
     /* 2427740 */   GIR_EraseRootFromParent_Done,
     /* 2427741 */ // Label 35003: @2427741
     /* 2427741 */ GIM_Reject,
     /* 2427742 */ // Label 118: @2427742
     /* 2427742 */ GIM_Try, /*On fail goto*//*Label 35004*/ GIMT_Encode4(2427788), // Rule ID 281 //
     /* 2427747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2427750 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2427759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427767 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2427774 */   // (riscv_sraw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRAW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2427774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAW),
     /* 2427777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427779 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2427786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427787 */   // GIR_Coverage, 281,
     /* 2427787 */   GIR_EraseRootFromParent_Done,
     /* 2427788 */ // Label 35004: @2427788
     /* 2427788 */ GIM_Reject,
     /* 2427789 */ // Label 119: @2427789
     /* 2427789 */ GIM_Try, /*On fail goto*//*Label 35005*/ GIMT_Encode4(2427835), // Rule ID 280 //
     /* 2427794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2427797 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2427806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427814 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2427821 */   // (riscv_srlw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2427821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLW),
     /* 2427824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427826 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2427833 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427834 */   // GIR_Coverage, 280,
     /* 2427834 */   GIR_EraseRootFromParent_Done,
     /* 2427835 */ // Label 35005: @2427835
     /* 2427835 */ GIM_Reject,
     /* 2427836 */ // Label 120: @2427836
     /* 2427836 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 35013*/ GIMT_Encode4(2428484),
     /* 2427847 */ /*GILLT_nxv1s1*//*Label 35006*/ GIMT_Encode4(2427959), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2427867 */ /*GILLT_nxv2s1*//*Label 35007*/ GIMT_Encode4(2428034), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2427887 */ /*GILLT_nxv4s1*//*Label 35008*/ GIMT_Encode4(2428109), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2427907 */ /*GILLT_nxv8s1*//*Label 35009*/ GIMT_Encode4(2428184), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2427927 */ /*GILLT_nxv16s1*//*Label 35010*/ GIMT_Encode4(2428259), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2427943 */ /*GILLT_nxv32s1*//*Label 35011*/ GIMT_Encode4(2428334), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2427955 */ /*GILLT_nxv64s1*//*Label 35012*/ GIMT_Encode4(2428409),
     /* 2427959 */ // Label 35006: @2427959
     /* 2427959 */ GIM_Try, /*On fail goto*//*Label 35014*/ GIMT_Encode4(2427996), // Rule ID 44726 //
     /* 2427964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427974 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427981 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2427981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2427984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427994 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427995 */   // GIR_Coverage, 44726,
     /* 2427995 */   GIR_EraseRootFromParent_Done,
     /* 2427996 */ // Label 35014: @2427996
     /* 2427996 */ GIM_Try, /*On fail goto*//*Label 35015*/ GIMT_Encode4(2428033), // Rule ID 44727 //
     /* 2428001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428011 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428018 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2428021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428032 */   // GIR_Coverage, 44727,
     /* 2428032 */   GIR_EraseRootFromParent_Done,
     /* 2428033 */ // Label 35015: @2428033
     /* 2428033 */ GIM_Reject,
     /* 2428034 */ // Label 35007: @2428034
     /* 2428034 */ GIM_Try, /*On fail goto*//*Label 35016*/ GIMT_Encode4(2428071), // Rule ID 44754 //
     /* 2428039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428049 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428056 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2428059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428069 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428070 */   // GIR_Coverage, 44754,
     /* 2428070 */   GIR_EraseRootFromParent_Done,
     /* 2428071 */ // Label 35016: @2428071
     /* 2428071 */ GIM_Try, /*On fail goto*//*Label 35017*/ GIMT_Encode4(2428108), // Rule ID 44755 //
     /* 2428076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428086 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428093 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2428096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428107 */   // GIR_Coverage, 44755,
     /* 2428107 */   GIR_EraseRootFromParent_Done,
     /* 2428108 */ // Label 35017: @2428108
     /* 2428108 */ GIM_Reject,
     /* 2428109 */ // Label 35008: @2428109
     /* 2428109 */ GIM_Try, /*On fail goto*//*Label 35018*/ GIMT_Encode4(2428146), // Rule ID 44782 //
     /* 2428114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428124 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428131 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2428134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428145 */   // GIR_Coverage, 44782,
     /* 2428145 */   GIR_EraseRootFromParent_Done,
     /* 2428146 */ // Label 35018: @2428146
     /* 2428146 */ GIM_Try, /*On fail goto*//*Label 35019*/ GIMT_Encode4(2428183), // Rule ID 44783 //
     /* 2428151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428168 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2428171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428182 */   // GIR_Coverage, 44783,
     /* 2428182 */   GIR_EraseRootFromParent_Done,
     /* 2428183 */ // Label 35019: @2428183
     /* 2428183 */ GIM_Reject,
     /* 2428184 */ // Label 35009: @2428184
     /* 2428184 */ GIM_Try, /*On fail goto*//*Label 35020*/ GIMT_Encode4(2428221), // Rule ID 44810 //
     /* 2428189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428199 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428206 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2428209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428219 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428220 */   // GIR_Coverage, 44810,
     /* 2428220 */   GIR_EraseRootFromParent_Done,
     /* 2428221 */ // Label 35020: @2428221
     /* 2428221 */ GIM_Try, /*On fail goto*//*Label 35021*/ GIMT_Encode4(2428258), // Rule ID 44811 //
     /* 2428226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428236 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428243 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2428246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428256 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428257 */   // GIR_Coverage, 44811,
     /* 2428257 */   GIR_EraseRootFromParent_Done,
     /* 2428258 */ // Label 35021: @2428258
     /* 2428258 */ GIM_Reject,
     /* 2428259 */ // Label 35010: @2428259
     /* 2428259 */ GIM_Try, /*On fail goto*//*Label 35022*/ GIMT_Encode4(2428296), // Rule ID 44838 //
     /* 2428264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428274 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428281 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2428284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428286 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428294 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428295 */   // GIR_Coverage, 44838,
     /* 2428295 */   GIR_EraseRootFromParent_Done,
     /* 2428296 */ // Label 35022: @2428296
     /* 2428296 */ GIM_Try, /*On fail goto*//*Label 35023*/ GIMT_Encode4(2428333), // Rule ID 44839 //
     /* 2428301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428311 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428318 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2428321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428332 */   // GIR_Coverage, 44839,
     /* 2428332 */   GIR_EraseRootFromParent_Done,
     /* 2428333 */ // Label 35023: @2428333
     /* 2428333 */ GIM_Reject,
     /* 2428334 */ // Label 35011: @2428334
     /* 2428334 */ GIM_Try, /*On fail goto*//*Label 35024*/ GIMT_Encode4(2428371), // Rule ID 44866 //
     /* 2428339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428349 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428356 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2428359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428369 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428370 */   // GIR_Coverage, 44866,
     /* 2428370 */   GIR_EraseRootFromParent_Done,
     /* 2428371 */ // Label 35024: @2428371
     /* 2428371 */ GIM_Try, /*On fail goto*//*Label 35025*/ GIMT_Encode4(2428408), // Rule ID 44867 //
     /* 2428376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428386 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428393 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2428396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428406 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428407 */   // GIR_Coverage, 44867,
     /* 2428407 */   GIR_EraseRootFromParent_Done,
     /* 2428408 */ // Label 35025: @2428408
     /* 2428408 */ GIM_Reject,
     /* 2428409 */ // Label 35012: @2428409
     /* 2428409 */ GIM_Try, /*On fail goto*//*Label 35026*/ GIMT_Encode4(2428446), // Rule ID 44894 //
     /* 2428414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428424 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428431 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2428434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428445 */   // GIR_Coverage, 44894,
     /* 2428445 */   GIR_EraseRootFromParent_Done,
     /* 2428446 */ // Label 35026: @2428446
     /* 2428446 */ GIM_Try, /*On fail goto*//*Label 35027*/ GIMT_Encode4(2428483), // Rule ID 44895 //
     /* 2428451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428461 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428468 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2428471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428481 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428482 */   // GIR_Coverage, 44895,
     /* 2428482 */   GIR_EraseRootFromParent_Done,
     /* 2428483 */ // Label 35027: @2428483
     /* 2428483 */ GIM_Reject,
     /* 2428484 */ // Label 35013: @2428484
     /* 2428484 */ GIM_Reject,
     /* 2428485 */ // Label 121: @2428485
     /* 2428485 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 35035*/ GIMT_Encode4(2429133),
     /* 2428496 */ /*GILLT_nxv1s1*//*Label 35028*/ GIMT_Encode4(2428608), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2428516 */ /*GILLT_nxv2s1*//*Label 35029*/ GIMT_Encode4(2428683), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2428536 */ /*GILLT_nxv4s1*//*Label 35030*/ GIMT_Encode4(2428758), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2428556 */ /*GILLT_nxv8s1*//*Label 35031*/ GIMT_Encode4(2428833), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2428576 */ /*GILLT_nxv16s1*//*Label 35032*/ GIMT_Encode4(2428908), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2428592 */ /*GILLT_nxv32s1*//*Label 35033*/ GIMT_Encode4(2428983), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2428604 */ /*GILLT_nxv64s1*//*Label 35034*/ GIMT_Encode4(2429058),
     /* 2428608 */ // Label 35028: @2428608
     /* 2428608 */ GIM_Try, /*On fail goto*//*Label 35036*/ GIMT_Encode4(2428645), // Rule ID 44724 //
     /* 2428613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428623 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428630 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2428633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428644 */   // GIR_Coverage, 44724,
     /* 2428644 */   GIR_EraseRootFromParent_Done,
     /* 2428645 */ // Label 35036: @2428645
     /* 2428645 */ GIM_Try, /*On fail goto*//*Label 35037*/ GIMT_Encode4(2428682), // Rule ID 44725 //
     /* 2428650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428660 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428667 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2428670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428680 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428681 */   // GIR_Coverage, 44725,
     /* 2428681 */   GIR_EraseRootFromParent_Done,
     /* 2428682 */ // Label 35037: @2428682
     /* 2428682 */ GIM_Reject,
     /* 2428683 */ // Label 35029: @2428683
     /* 2428683 */ GIM_Try, /*On fail goto*//*Label 35038*/ GIMT_Encode4(2428720), // Rule ID 44752 //
     /* 2428688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428698 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428705 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2428708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428719 */   // GIR_Coverage, 44752,
     /* 2428719 */   GIR_EraseRootFromParent_Done,
     /* 2428720 */ // Label 35038: @2428720
     /* 2428720 */ GIM_Try, /*On fail goto*//*Label 35039*/ GIMT_Encode4(2428757), // Rule ID 44753 //
     /* 2428725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428742 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2428745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428755 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428756 */   // GIR_Coverage, 44753,
     /* 2428756 */   GIR_EraseRootFromParent_Done,
     /* 2428757 */ // Label 35039: @2428757
     /* 2428757 */ GIM_Reject,
     /* 2428758 */ // Label 35030: @2428758
     /* 2428758 */ GIM_Try, /*On fail goto*//*Label 35040*/ GIMT_Encode4(2428795), // Rule ID 44780 //
     /* 2428763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428773 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428780 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2428783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428794 */   // GIR_Coverage, 44780,
     /* 2428794 */   GIR_EraseRootFromParent_Done,
     /* 2428795 */ // Label 35040: @2428795
     /* 2428795 */ GIM_Try, /*On fail goto*//*Label 35041*/ GIMT_Encode4(2428832), // Rule ID 44781 //
     /* 2428800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428810 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428817 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2428820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428830 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428831 */   // GIR_Coverage, 44781,
     /* 2428831 */   GIR_EraseRootFromParent_Done,
     /* 2428832 */ // Label 35041: @2428832
     /* 2428832 */ GIM_Reject,
     /* 2428833 */ // Label 35031: @2428833
     /* 2428833 */ GIM_Try, /*On fail goto*//*Label 35042*/ GIMT_Encode4(2428870), // Rule ID 44808 //
     /* 2428838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428848 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428855 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2428858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428868 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428869 */   // GIR_Coverage, 44808,
     /* 2428869 */   GIR_EraseRootFromParent_Done,
     /* 2428870 */ // Label 35042: @2428870
     /* 2428870 */ GIM_Try, /*On fail goto*//*Label 35043*/ GIMT_Encode4(2428907), // Rule ID 44809 //
     /* 2428875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428885 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428892 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2428895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428905 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428906 */   // GIR_Coverage, 44809,
     /* 2428906 */   GIR_EraseRootFromParent_Done,
     /* 2428907 */ // Label 35043: @2428907
     /* 2428907 */ GIM_Reject,
     /* 2428908 */ // Label 35032: @2428908
     /* 2428908 */ GIM_Try, /*On fail goto*//*Label 35044*/ GIMT_Encode4(2428945), // Rule ID 44836 //
     /* 2428913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428923 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428930 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2428933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428943 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428944 */   // GIR_Coverage, 44836,
     /* 2428944 */   GIR_EraseRootFromParent_Done,
     /* 2428945 */ // Label 35044: @2428945
     /* 2428945 */ GIM_Try, /*On fail goto*//*Label 35045*/ GIMT_Encode4(2428982), // Rule ID 44837 //
     /* 2428950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428960 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428967 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2428970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428980 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428981 */   // GIR_Coverage, 44837,
     /* 2428981 */   GIR_EraseRootFromParent_Done,
     /* 2428982 */ // Label 35045: @2428982
     /* 2428982 */ GIM_Reject,
     /* 2428983 */ // Label 35033: @2428983
     /* 2428983 */ GIM_Try, /*On fail goto*//*Label 35046*/ GIMT_Encode4(2429020), // Rule ID 44864 //
     /* 2428988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429005 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2429005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2429008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429018 */   GIR_RootConstrainSelectedInstOperands,
     /* 2429019 */   // GIR_Coverage, 44864,
     /* 2429019 */   GIR_EraseRootFromParent_Done,
     /* 2429020 */ // Label 35046: @2429020
     /* 2429020 */ GIM_Try, /*On fail goto*//*Label 35047*/ GIMT_Encode4(2429057), // Rule ID 44865 //
     /* 2429025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2429031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429035 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429042 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2429042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2429045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429055 */   GIR_RootConstrainSelectedInstOperands,
     /* 2429056 */   // GIR_Coverage, 44865,
     /* 2429056 */   GIR_EraseRootFromParent_Done,
     /* 2429057 */ // Label 35047: @2429057
     /* 2429057 */ GIM_Reject,
     /* 2429058 */ // Label 35034: @2429058
     /* 2429058 */ GIM_Try, /*On fail goto*//*Label 35048*/ GIMT_Encode4(2429095), // Rule ID 44892 //
     /* 2429063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2429069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429080 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2429080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2429083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2429094 */   // GIR_Coverage, 44892,
     /* 2429094 */   GIR_EraseRootFromParent_Done,
     /* 2429095 */ // Label 35048: @2429095
     /* 2429095 */ GIM_Try, /*On fail goto*//*Label 35049*/ GIMT_Encode4(2429132), // Rule ID 44893 //
     /* 2429100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2429106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429110 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429117 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2429117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2429120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429130 */   GIR_RootConstrainSelectedInstOperands,
     /* 2429131 */   // GIR_Coverage, 44893,
     /* 2429131 */   GIR_EraseRootFromParent_Done,
     /* 2429132 */ // Label 35049: @2429132
     /* 2429132 */ GIM_Reject,
     /* 2429133 */ // Label 35035: @2429133
     /* 2429133 */ GIM_Reject,
     /* 2429134 */ // Label 122: @2429134
     /* 2429134 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35072*/ GIMT_Encode4(2433391),
     /* 2429145 */ /*GILLT_nxv1s8*//*Label 35050*/ GIMT_Encode4(2429257),
     /* 2429149 */ /*GILLT_nxv1s16*//*Label 35051*/ GIMT_Encode4(2429374),
     /* 2429153 */ /*GILLT_nxv1s32*//*Label 35052*/ GIMT_Encode4(2429595),
     /* 2429157 */ /*GILLT_nxv1s64*//*Label 35053*/ GIMT_Encode4(2429816), GIMT_Encode4(0),
     /* 2429165 */ /*GILLT_nxv2s8*//*Label 35054*/ GIMT_Encode4(2430037),
     /* 2429169 */ /*GILLT_nxv2s16*//*Label 35055*/ GIMT_Encode4(2430154),
     /* 2429173 */ /*GILLT_nxv2s32*//*Label 35056*/ GIMT_Encode4(2430375),
     /* 2429177 */ /*GILLT_nxv2s64*//*Label 35057*/ GIMT_Encode4(2430596), GIMT_Encode4(0),
     /* 2429185 */ /*GILLT_nxv4s8*//*Label 35058*/ GIMT_Encode4(2430817),
     /* 2429189 */ /*GILLT_nxv4s16*//*Label 35059*/ GIMT_Encode4(2430934),
     /* 2429193 */ /*GILLT_nxv4s32*//*Label 35060*/ GIMT_Encode4(2431155),
     /* 2429197 */ /*GILLT_nxv4s64*//*Label 35061*/ GIMT_Encode4(2431376), GIMT_Encode4(0),
     /* 2429205 */ /*GILLT_nxv8s8*//*Label 35062*/ GIMT_Encode4(2431597),
     /* 2429209 */ /*GILLT_nxv8s16*//*Label 35063*/ GIMT_Encode4(2431714),
     /* 2429213 */ /*GILLT_nxv8s32*//*Label 35064*/ GIMT_Encode4(2431935),
     /* 2429217 */ /*GILLT_nxv8s64*//*Label 35065*/ GIMT_Encode4(2432156), GIMT_Encode4(0),
     /* 2429225 */ /*GILLT_nxv16s8*//*Label 35066*/ GIMT_Encode4(2432377),
     /* 2429229 */ /*GILLT_nxv16s16*//*Label 35067*/ GIMT_Encode4(2432494),
     /* 2429233 */ /*GILLT_nxv16s32*//*Label 35068*/ GIMT_Encode4(2432715), GIMT_Encode4(0),
     /* 2429241 */ /*GILLT_nxv32s8*//*Label 35069*/ GIMT_Encode4(2432936),
     /* 2429245 */ /*GILLT_nxv32s16*//*Label 35070*/ GIMT_Encode4(2433053), GIMT_Encode4(0),
     /* 2429253 */ /*GILLT_nxv64s8*//*Label 35071*/ GIMT_Encode4(2433274),
     /* 2429257 */ // Label 35050: @2429257
     /* 2429257 */ GIM_Try, /*On fail goto*//*Label 35073*/ GIMT_Encode4(2429373),
     /* 2429262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2429265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2429268 */   GIM_Try, /*On fail goto*//*Label 35074*/ GIMT_Encode4(2429320), // Rule ID 32314 //
     /* 2429273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429298 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2429301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429303 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429319 */     // GIR_Coverage, 32314,
     /* 2429319 */     GIR_EraseRootFromParent_Done,
     /* 2429320 */   // Label 35074: @2429320
     /* 2429320 */   GIM_Try, /*On fail goto*//*Label 35075*/ GIMT_Encode4(2429372), // Rule ID 32315 //
     /* 2429325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429350 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2429353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429355 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429371 */     // GIR_Coverage, 32315,
     /* 2429371 */     GIR_EraseRootFromParent_Done,
     /* 2429372 */   // Label 35075: @2429372
     /* 2429372 */   GIM_Reject,
     /* 2429373 */ // Label 35073: @2429373
     /* 2429373 */ GIM_Reject,
     /* 2429374 */ // Label 35051: @2429374
     /* 2429374 */ GIM_Try, /*On fail goto*//*Label 35076*/ GIMT_Encode4(2429594),
     /* 2429379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2429382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2429385 */   GIM_Try, /*On fail goto*//*Label 35077*/ GIMT_Encode4(2429437), // Rule ID 32584 //
     /* 2429390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429415 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2429418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429420 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429436 */     // GIR_Coverage, 32584,
     /* 2429436 */     GIR_EraseRootFromParent_Done,
     /* 2429437 */   // Label 35077: @2429437
     /* 2429437 */   GIM_Try, /*On fail goto*//*Label 35078*/ GIMT_Encode4(2429489), // Rule ID 32585 //
     /* 2429442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429467 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2429470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429472 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429488 */     // GIR_Coverage, 32585,
     /* 2429488 */     GIR_EraseRootFromParent_Done,
     /* 2429489 */   // Label 35078: @2429489
     /* 2429489 */   GIM_Try, /*On fail goto*//*Label 35079*/ GIMT_Encode4(2429541), // Rule ID 34294 //
     /* 2429494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429519 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2429522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429524 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429540 */     // GIR_Coverage, 34294,
     /* 2429540 */     GIR_EraseRootFromParent_Done,
     /* 2429541 */   // Label 35079: @2429541
     /* 2429541 */   GIM_Try, /*On fail goto*//*Label 35080*/ GIMT_Encode4(2429593), // Rule ID 34295 //
     /* 2429546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429571 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2429574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429576 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429592 */     // GIR_Coverage, 34295,
     /* 2429592 */     GIR_EraseRootFromParent_Done,
     /* 2429593 */   // Label 35080: @2429593
     /* 2429593 */   GIM_Reject,
     /* 2429594 */ // Label 35076: @2429594
     /* 2429594 */ GIM_Reject,
     /* 2429595 */ // Label 35052: @2429595
     /* 2429595 */ GIM_Try, /*On fail goto*//*Label 35081*/ GIMT_Encode4(2429815),
     /* 2429600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2429603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2429606 */   GIM_Try, /*On fail goto*//*Label 35082*/ GIMT_Encode4(2429658), // Rule ID 32764 //
     /* 2429611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429636 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2429639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429641 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429657 */     // GIR_Coverage, 32764,
     /* 2429657 */     GIR_EraseRootFromParent_Done,
     /* 2429658 */   // Label 35082: @2429658
     /* 2429658 */   GIM_Try, /*On fail goto*//*Label 35083*/ GIMT_Encode4(2429710), // Rule ID 32765 //
     /* 2429663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429688 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2429691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429693 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429709 */     // GIR_Coverage, 32765,
     /* 2429709 */     GIR_EraseRootFromParent_Done,
     /* 2429710 */   // Label 35083: @2429710
     /* 2429710 */   GIM_Try, /*On fail goto*//*Label 35084*/ GIMT_Encode4(2429762), // Rule ID 34474 //
     /* 2429715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429740 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2429743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429745 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429761 */     // GIR_Coverage, 34474,
     /* 2429761 */     GIR_EraseRootFromParent_Done,
     /* 2429762 */   // Label 35084: @2429762
     /* 2429762 */   GIM_Try, /*On fail goto*//*Label 35085*/ GIMT_Encode4(2429814), // Rule ID 34475 //
     /* 2429767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429792 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2429795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429797 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429813 */     // GIR_Coverage, 34475,
     /* 2429813 */     GIR_EraseRootFromParent_Done,
     /* 2429814 */   // Label 35085: @2429814
     /* 2429814 */   GIM_Reject,
     /* 2429815 */ // Label 35081: @2429815
     /* 2429815 */ GIM_Reject,
     /* 2429816 */ // Label 35053: @2429816
     /* 2429816 */ GIM_Try, /*On fail goto*//*Label 35086*/ GIMT_Encode4(2430036),
     /* 2429821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2429824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2429827 */   GIM_Try, /*On fail goto*//*Label 35087*/ GIMT_Encode4(2429879), // Rule ID 33124 //
     /* 2429832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429857 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2429860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429862 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429878 */     // GIR_Coverage, 33124,
     /* 2429878 */     GIR_EraseRootFromParent_Done,
     /* 2429879 */   // Label 35087: @2429879
     /* 2429879 */   GIM_Try, /*On fail goto*//*Label 35088*/ GIMT_Encode4(2429931), // Rule ID 33125 //
     /* 2429884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429909 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2429912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429914 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429930 */     // GIR_Coverage, 33125,
     /* 2429930 */     GIR_EraseRootFromParent_Done,
     /* 2429931 */   // Label 35088: @2429931
     /* 2429931 */   GIM_Try, /*On fail goto*//*Label 35089*/ GIMT_Encode4(2429983), // Rule ID 34920 //
     /* 2429936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429961 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2429964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429966 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429982 */     // GIR_Coverage, 34920,
     /* 2429982 */     GIR_EraseRootFromParent_Done,
     /* 2429983 */   // Label 35089: @2429983
     /* 2429983 */   GIM_Try, /*On fail goto*//*Label 35090*/ GIMT_Encode4(2430035), // Rule ID 34921 //
     /* 2429988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430013 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2430016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430018 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430034 */     // GIR_Coverage, 34921,
     /* 2430034 */     GIR_EraseRootFromParent_Done,
     /* 2430035 */   // Label 35090: @2430035
     /* 2430035 */   GIM_Reject,
     /* 2430036 */ // Label 35086: @2430036
     /* 2430036 */ GIM_Reject,
     /* 2430037 */ // Label 35054: @2430037
     /* 2430037 */ GIM_Try, /*On fail goto*//*Label 35091*/ GIMT_Encode4(2430153),
     /* 2430042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2430045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2430048 */   GIM_Try, /*On fail goto*//*Label 35092*/ GIMT_Encode4(2430100), // Rule ID 32404 //
     /* 2430053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430078 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2430081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430083 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430099 */     // GIR_Coverage, 32404,
     /* 2430099 */     GIR_EraseRootFromParent_Done,
     /* 2430100 */   // Label 35092: @2430100
     /* 2430100 */   GIM_Try, /*On fail goto*//*Label 35093*/ GIMT_Encode4(2430152), // Rule ID 32405 //
     /* 2430105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430130 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2430133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430135 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430151 */     // GIR_Coverage, 32405,
     /* 2430151 */     GIR_EraseRootFromParent_Done,
     /* 2430152 */   // Label 35093: @2430152
     /* 2430152 */   GIM_Reject,
     /* 2430153 */ // Label 35091: @2430153
     /* 2430153 */ GIM_Reject,
     /* 2430154 */ // Label 35055: @2430154
     /* 2430154 */ GIM_Try, /*On fail goto*//*Label 35094*/ GIMT_Encode4(2430374),
     /* 2430159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2430162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2430165 */   GIM_Try, /*On fail goto*//*Label 35095*/ GIMT_Encode4(2430217), // Rule ID 32674 //
     /* 2430170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430195 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2430198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430200 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430216 */     // GIR_Coverage, 32674,
     /* 2430216 */     GIR_EraseRootFromParent_Done,
     /* 2430217 */   // Label 35095: @2430217
     /* 2430217 */   GIM_Try, /*On fail goto*//*Label 35096*/ GIMT_Encode4(2430269), // Rule ID 32675 //
     /* 2430222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430247 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2430250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430252 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430268 */     // GIR_Coverage, 32675,
     /* 2430268 */     GIR_EraseRootFromParent_Done,
     /* 2430269 */   // Label 35096: @2430269
     /* 2430269 */   GIM_Try, /*On fail goto*//*Label 35097*/ GIMT_Encode4(2430321), // Rule ID 34384 //
     /* 2430274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430299 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2430302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430304 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430320 */     // GIR_Coverage, 34384,
     /* 2430320 */     GIR_EraseRootFromParent_Done,
     /* 2430321 */   // Label 35097: @2430321
     /* 2430321 */   GIM_Try, /*On fail goto*//*Label 35098*/ GIMT_Encode4(2430373), // Rule ID 34385 //
     /* 2430326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430351 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2430354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430356 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430372 */     // GIR_Coverage, 34385,
     /* 2430372 */     GIR_EraseRootFromParent_Done,
     /* 2430373 */   // Label 35098: @2430373
     /* 2430373 */   GIM_Reject,
     /* 2430374 */ // Label 35094: @2430374
     /* 2430374 */ GIM_Reject,
     /* 2430375 */ // Label 35056: @2430375
     /* 2430375 */ GIM_Try, /*On fail goto*//*Label 35099*/ GIMT_Encode4(2430595),
     /* 2430380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2430383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2430386 */   GIM_Try, /*On fail goto*//*Label 35100*/ GIMT_Encode4(2430438), // Rule ID 33034 //
     /* 2430391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430416 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2430419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430421 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430437 */     // GIR_Coverage, 33034,
     /* 2430437 */     GIR_EraseRootFromParent_Done,
     /* 2430438 */   // Label 35100: @2430438
     /* 2430438 */   GIM_Try, /*On fail goto*//*Label 35101*/ GIMT_Encode4(2430490), // Rule ID 33035 //
     /* 2430443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430468 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2430471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430473 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430489 */     // GIR_Coverage, 33035,
     /* 2430489 */     GIR_EraseRootFromParent_Done,
     /* 2430490 */   // Label 35101: @2430490
     /* 2430490 */   GIM_Try, /*On fail goto*//*Label 35102*/ GIMT_Encode4(2430542), // Rule ID 34830 //
     /* 2430495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430520 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2430523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430525 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430541 */     // GIR_Coverage, 34830,
     /* 2430541 */     GIR_EraseRootFromParent_Done,
     /* 2430542 */   // Label 35102: @2430542
     /* 2430542 */   GIM_Try, /*On fail goto*//*Label 35103*/ GIMT_Encode4(2430594), // Rule ID 34831 //
     /* 2430547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430572 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2430575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430577 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430593 */     // GIR_Coverage, 34831,
     /* 2430593 */     GIR_EraseRootFromParent_Done,
     /* 2430594 */   // Label 35103: @2430594
     /* 2430594 */   GIM_Reject,
     /* 2430595 */ // Label 35099: @2430595
     /* 2430595 */ GIM_Reject,
     /* 2430596 */ // Label 35057: @2430596
     /* 2430596 */ GIM_Try, /*On fail goto*//*Label 35104*/ GIMT_Encode4(2430816),
     /* 2430601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2430604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2430607 */   GIM_Try, /*On fail goto*//*Label 35105*/ GIMT_Encode4(2430659), // Rule ID 34024 //
     /* 2430612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2430615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430637 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2430640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430642 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430658 */     // GIR_Coverage, 34024,
     /* 2430658 */     GIR_EraseRootFromParent_Done,
     /* 2430659 */   // Label 35105: @2430659
     /* 2430659 */   GIM_Try, /*On fail goto*//*Label 35106*/ GIMT_Encode4(2430711), // Rule ID 34025 //
     /* 2430664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2430667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430689 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2430692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430694 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430710 */     // GIR_Coverage, 34025,
     /* 2430710 */     GIR_EraseRootFromParent_Done,
     /* 2430711 */   // Label 35106: @2430711
     /* 2430711 */   GIM_Try, /*On fail goto*//*Label 35107*/ GIMT_Encode4(2430763), // Rule ID 35638 //
     /* 2430716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2430719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430741 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2430744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430746 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430762 */     // GIR_Coverage, 35638,
     /* 2430762 */     GIR_EraseRootFromParent_Done,
     /* 2430763 */   // Label 35107: @2430763
     /* 2430763 */   GIM_Try, /*On fail goto*//*Label 35108*/ GIMT_Encode4(2430815), // Rule ID 35639 //
     /* 2430768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2430771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430793 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2430796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430798 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430814 */     // GIR_Coverage, 35639,
     /* 2430814 */     GIR_EraseRootFromParent_Done,
     /* 2430815 */   // Label 35108: @2430815
     /* 2430815 */   GIM_Reject,
     /* 2430816 */ // Label 35104: @2430816
     /* 2430816 */ GIM_Reject,
     /* 2430817 */ // Label 35058: @2430817
     /* 2430817 */ GIM_Try, /*On fail goto*//*Label 35109*/ GIMT_Encode4(2430933),
     /* 2430822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2430825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2430828 */   GIM_Try, /*On fail goto*//*Label 35110*/ GIMT_Encode4(2430880), // Rule ID 32494 //
     /* 2430833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430858 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2430861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430863 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430879 */     // GIR_Coverage, 32494,
     /* 2430879 */     GIR_EraseRootFromParent_Done,
     /* 2430880 */   // Label 35110: @2430880
     /* 2430880 */   GIM_Try, /*On fail goto*//*Label 35111*/ GIMT_Encode4(2430932), // Rule ID 32495 //
     /* 2430885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430910 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2430913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430915 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430931 */     // GIR_Coverage, 32495,
     /* 2430931 */     GIR_EraseRootFromParent_Done,
     /* 2430932 */   // Label 35111: @2430932
     /* 2430932 */   GIM_Reject,
     /* 2430933 */ // Label 35109: @2430933
     /* 2430933 */ GIM_Reject,
     /* 2430934 */ // Label 35059: @2430934
     /* 2430934 */ GIM_Try, /*On fail goto*//*Label 35112*/ GIMT_Encode4(2431154),
     /* 2430939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2430942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2430945 */   GIM_Try, /*On fail goto*//*Label 35113*/ GIMT_Encode4(2430997), // Rule ID 32944 //
     /* 2430950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430975 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2430978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430980 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430996 */     // GIR_Coverage, 32944,
     /* 2430996 */     GIR_EraseRootFromParent_Done,
     /* 2430997 */   // Label 35113: @2430997
     /* 2430997 */   GIM_Try, /*On fail goto*//*Label 35114*/ GIMT_Encode4(2431049), // Rule ID 32945 //
     /* 2431002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431027 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2431030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431032 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431048 */     // GIR_Coverage, 32945,
     /* 2431048 */     GIR_EraseRootFromParent_Done,
     /* 2431049 */   // Label 35114: @2431049
     /* 2431049 */   GIM_Try, /*On fail goto*//*Label 35115*/ GIMT_Encode4(2431101), // Rule ID 34740 //
     /* 2431054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431079 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2431082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431084 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431100 */     // GIR_Coverage, 34740,
     /* 2431100 */     GIR_EraseRootFromParent_Done,
     /* 2431101 */   // Label 35115: @2431101
     /* 2431101 */   GIM_Try, /*On fail goto*//*Label 35116*/ GIMT_Encode4(2431153), // Rule ID 34741 //
     /* 2431106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431131 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2431134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431136 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431152 */     // GIR_Coverage, 34741,
     /* 2431152 */     GIR_EraseRootFromParent_Done,
     /* 2431153 */   // Label 35116: @2431153
     /* 2431153 */   GIM_Reject,
     /* 2431154 */ // Label 35112: @2431154
     /* 2431154 */ GIM_Reject,
     /* 2431155 */ // Label 35060: @2431155
     /* 2431155 */ GIM_Try, /*On fail goto*//*Label 35117*/ GIMT_Encode4(2431375),
     /* 2431160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2431163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2431166 */   GIM_Try, /*On fail goto*//*Label 35118*/ GIMT_Encode4(2431218), // Rule ID 33754 //
     /* 2431171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431196 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431201 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431217 */     // GIR_Coverage, 33754,
     /* 2431217 */     GIR_EraseRootFromParent_Done,
     /* 2431218 */   // Label 35118: @2431218
     /* 2431218 */   GIM_Try, /*On fail goto*//*Label 35119*/ GIMT_Encode4(2431270), // Rule ID 33755 //
     /* 2431223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431248 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431253 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431269 */     // GIR_Coverage, 33755,
     /* 2431269 */     GIR_EraseRootFromParent_Done,
     /* 2431270 */   // Label 35119: @2431270
     /* 2431270 */   GIM_Try, /*On fail goto*//*Label 35120*/ GIMT_Encode4(2431322), // Rule ID 35368 //
     /* 2431275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431300 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431305 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431321 */     // GIR_Coverage, 35368,
     /* 2431321 */     GIR_EraseRootFromParent_Done,
     /* 2431322 */   // Label 35120: @2431322
     /* 2431322 */   GIM_Try, /*On fail goto*//*Label 35121*/ GIMT_Encode4(2431374), // Rule ID 35369 //
     /* 2431327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431352 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431357 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431373 */     // GIR_Coverage, 35369,
     /* 2431373 */     GIR_EraseRootFromParent_Done,
     /* 2431374 */   // Label 35121: @2431374
     /* 2431374 */   GIM_Reject,
     /* 2431375 */ // Label 35117: @2431375
     /* 2431375 */ GIM_Reject,
     /* 2431376 */ // Label 35061: @2431376
     /* 2431376 */ GIM_Try, /*On fail goto*//*Label 35122*/ GIMT_Encode4(2431596),
     /* 2431381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2431384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2431387 */   GIM_Try, /*On fail goto*//*Label 35123*/ GIMT_Encode4(2431439), // Rule ID 34114 //
     /* 2431392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431417 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2431420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431422 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431438 */     // GIR_Coverage, 34114,
     /* 2431438 */     GIR_EraseRootFromParent_Done,
     /* 2431439 */   // Label 35123: @2431439
     /* 2431439 */   GIM_Try, /*On fail goto*//*Label 35124*/ GIMT_Encode4(2431491), // Rule ID 34115 //
     /* 2431444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431469 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2431472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431474 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431490 */     // GIR_Coverage, 34115,
     /* 2431490 */     GIR_EraseRootFromParent_Done,
     /* 2431491 */   // Label 35124: @2431491
     /* 2431491 */   GIM_Try, /*On fail goto*//*Label 35125*/ GIMT_Encode4(2431543), // Rule ID 35728 //
     /* 2431496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431521 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2431524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431526 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431542 */     // GIR_Coverage, 35728,
     /* 2431542 */     GIR_EraseRootFromParent_Done,
     /* 2431543 */   // Label 35125: @2431543
     /* 2431543 */   GIM_Try, /*On fail goto*//*Label 35126*/ GIMT_Encode4(2431595), // Rule ID 35729 //
     /* 2431548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431573 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2431576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431578 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431594 */     // GIR_Coverage, 35729,
     /* 2431594 */     GIR_EraseRootFromParent_Done,
     /* 2431595 */   // Label 35126: @2431595
     /* 2431595 */   GIM_Reject,
     /* 2431596 */ // Label 35122: @2431596
     /* 2431596 */ GIM_Reject,
     /* 2431597 */ // Label 35062: @2431597
     /* 2431597 */ GIM_Try, /*On fail goto*//*Label 35127*/ GIMT_Encode4(2431713),
     /* 2431602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2431605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2431608 */   GIM_Try, /*On fail goto*//*Label 35128*/ GIMT_Encode4(2431660), // Rule ID 32854 //
     /* 2431613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431638 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2431641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431643 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2431655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431659 */     // GIR_Coverage, 32854,
     /* 2431659 */     GIR_EraseRootFromParent_Done,
     /* 2431660 */   // Label 35128: @2431660
     /* 2431660 */   GIM_Try, /*On fail goto*//*Label 35129*/ GIMT_Encode4(2431712), // Rule ID 32855 //
     /* 2431665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431690 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2431693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431695 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2431707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431711 */     // GIR_Coverage, 32855,
     /* 2431711 */     GIR_EraseRootFromParent_Done,
     /* 2431712 */   // Label 35129: @2431712
     /* 2431712 */   GIM_Reject,
     /* 2431713 */ // Label 35127: @2431713
     /* 2431713 */ GIM_Reject,
     /* 2431714 */ // Label 35063: @2431714
     /* 2431714 */ GIM_Try, /*On fail goto*//*Label 35130*/ GIMT_Encode4(2431934),
     /* 2431719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2431722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2431725 */   GIM_Try, /*On fail goto*//*Label 35131*/ GIMT_Encode4(2431777), // Rule ID 33484 //
     /* 2431730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431755 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431760 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431776 */     // GIR_Coverage, 33484,
     /* 2431776 */     GIR_EraseRootFromParent_Done,
     /* 2431777 */   // Label 35131: @2431777
     /* 2431777 */   GIM_Try, /*On fail goto*//*Label 35132*/ GIMT_Encode4(2431829), // Rule ID 33485 //
     /* 2431782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431807 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431812 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431828 */     // GIR_Coverage, 33485,
     /* 2431828 */     GIR_EraseRootFromParent_Done,
     /* 2431829 */   // Label 35132: @2431829
     /* 2431829 */   GIM_Try, /*On fail goto*//*Label 35133*/ GIMT_Encode4(2431881), // Rule ID 35098 //
     /* 2431834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431859 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431864 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431880 */     // GIR_Coverage, 35098,
     /* 2431880 */     GIR_EraseRootFromParent_Done,
     /* 2431881 */   // Label 35133: @2431881
     /* 2431881 */   GIM_Try, /*On fail goto*//*Label 35134*/ GIMT_Encode4(2431933), // Rule ID 35099 //
     /* 2431886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431911 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431916 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431932 */     // GIR_Coverage, 35099,
     /* 2431932 */     GIR_EraseRootFromParent_Done,
     /* 2431933 */   // Label 35134: @2431933
     /* 2431933 */   GIM_Reject,
     /* 2431934 */ // Label 35130: @2431934
     /* 2431934 */ GIM_Reject,
     /* 2431935 */ // Label 35064: @2431935
     /* 2431935 */ GIM_Try, /*On fail goto*//*Label 35135*/ GIMT_Encode4(2432155),
     /* 2431940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2431943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2431946 */   GIM_Try, /*On fail goto*//*Label 35136*/ GIMT_Encode4(2431998), // Rule ID 33844 //
     /* 2431951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431976 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2431979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431981 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431997 */     // GIR_Coverage, 33844,
     /* 2431997 */     GIR_EraseRootFromParent_Done,
     /* 2431998 */   // Label 35136: @2431998
     /* 2431998 */   GIM_Try, /*On fail goto*//*Label 35137*/ GIMT_Encode4(2432050), // Rule ID 33845 //
     /* 2432003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432028 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432033 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432049 */     // GIR_Coverage, 33845,
     /* 2432049 */     GIR_EraseRootFromParent_Done,
     /* 2432050 */   // Label 35137: @2432050
     /* 2432050 */   GIM_Try, /*On fail goto*//*Label 35138*/ GIMT_Encode4(2432102), // Rule ID 35458 //
     /* 2432055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432080 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432085 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432101 */     // GIR_Coverage, 35458,
     /* 2432101 */     GIR_EraseRootFromParent_Done,
     /* 2432102 */   // Label 35138: @2432102
     /* 2432102 */   GIM_Try, /*On fail goto*//*Label 35139*/ GIMT_Encode4(2432154), // Rule ID 35459 //
     /* 2432107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432132 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432137 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432153 */     // GIR_Coverage, 35459,
     /* 2432153 */     GIR_EraseRootFromParent_Done,
     /* 2432154 */   // Label 35139: @2432154
     /* 2432154 */   GIM_Reject,
     /* 2432155 */ // Label 35135: @2432155
     /* 2432155 */ GIM_Reject,
     /* 2432156 */ // Label 35065: @2432156
     /* 2432156 */ GIM_Try, /*On fail goto*//*Label 35140*/ GIMT_Encode4(2432376),
     /* 2432161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2432164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2432167 */   GIM_Try, /*On fail goto*//*Label 35141*/ GIMT_Encode4(2432219), // Rule ID 34204 //
     /* 2432172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2432175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432197 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432202 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432218 */     // GIR_Coverage, 34204,
     /* 2432218 */     GIR_EraseRootFromParent_Done,
     /* 2432219 */   // Label 35141: @2432219
     /* 2432219 */   GIM_Try, /*On fail goto*//*Label 35142*/ GIMT_Encode4(2432271), // Rule ID 34205 //
     /* 2432224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432249 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432254 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432270 */     // GIR_Coverage, 34205,
     /* 2432270 */     GIR_EraseRootFromParent_Done,
     /* 2432271 */   // Label 35142: @2432271
     /* 2432271 */   GIM_Try, /*On fail goto*//*Label 35143*/ GIMT_Encode4(2432323), // Rule ID 35818 //
     /* 2432276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2432279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432301 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432306 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432322 */     // GIR_Coverage, 35818,
     /* 2432322 */     GIR_EraseRootFromParent_Done,
     /* 2432323 */   // Label 35143: @2432323
     /* 2432323 */   GIM_Try, /*On fail goto*//*Label 35144*/ GIMT_Encode4(2432375), // Rule ID 35819 //
     /* 2432328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432353 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432358 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432374 */     // GIR_Coverage, 35819,
     /* 2432374 */     GIR_EraseRootFromParent_Done,
     /* 2432375 */   // Label 35144: @2432375
     /* 2432375 */   GIM_Reject,
     /* 2432376 */ // Label 35140: @2432376
     /* 2432376 */ GIM_Reject,
     /* 2432377 */ // Label 35066: @2432377
     /* 2432377 */ GIM_Try, /*On fail goto*//*Label 35145*/ GIMT_Encode4(2432493),
     /* 2432382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2432385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2432388 */   GIM_Try, /*On fail goto*//*Label 35146*/ GIMT_Encode4(2432440), // Rule ID 33214 //
     /* 2432393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432418 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2432421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432423 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432439 */     // GIR_Coverage, 33214,
     /* 2432439 */     GIR_EraseRootFromParent_Done,
     /* 2432440 */   // Label 35146: @2432440
     /* 2432440 */   GIM_Try, /*On fail goto*//*Label 35147*/ GIMT_Encode4(2432492), // Rule ID 33215 //
     /* 2432445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432470 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2432473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432475 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432491 */     // GIR_Coverage, 33215,
     /* 2432491 */     GIR_EraseRootFromParent_Done,
     /* 2432492 */   // Label 35147: @2432492
     /* 2432492 */   GIM_Reject,
     /* 2432493 */ // Label 35145: @2432493
     /* 2432493 */ GIM_Reject,
     /* 2432494 */ // Label 35067: @2432494
     /* 2432494 */ GIM_Try, /*On fail goto*//*Label 35148*/ GIMT_Encode4(2432714),
     /* 2432499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2432502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2432505 */   GIM_Try, /*On fail goto*//*Label 35149*/ GIMT_Encode4(2432557), // Rule ID 33574 //
     /* 2432510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432535 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432540 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432556 */     // GIR_Coverage, 33574,
     /* 2432556 */     GIR_EraseRootFromParent_Done,
     /* 2432557 */   // Label 35149: @2432557
     /* 2432557 */   GIM_Try, /*On fail goto*//*Label 35150*/ GIMT_Encode4(2432609), // Rule ID 33575 //
     /* 2432562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432587 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432592 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432608 */     // GIR_Coverage, 33575,
     /* 2432608 */     GIR_EraseRootFromParent_Done,
     /* 2432609 */   // Label 35150: @2432609
     /* 2432609 */   GIM_Try, /*On fail goto*//*Label 35151*/ GIMT_Encode4(2432661), // Rule ID 35188 //
     /* 2432614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432639 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432644 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432660 */     // GIR_Coverage, 35188,
     /* 2432660 */     GIR_EraseRootFromParent_Done,
     /* 2432661 */   // Label 35151: @2432661
     /* 2432661 */   GIM_Try, /*On fail goto*//*Label 35152*/ GIMT_Encode4(2432713), // Rule ID 35189 //
     /* 2432666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432691 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432696 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432712 */     // GIR_Coverage, 35189,
     /* 2432712 */     GIR_EraseRootFromParent_Done,
     /* 2432713 */   // Label 35152: @2432713
     /* 2432713 */   GIM_Reject,
     /* 2432714 */ // Label 35148: @2432714
     /* 2432714 */ GIM_Reject,
     /* 2432715 */ // Label 35068: @2432715
     /* 2432715 */ GIM_Try, /*On fail goto*//*Label 35153*/ GIMT_Encode4(2432935),
     /* 2432720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2432723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2432726 */   GIM_Try, /*On fail goto*//*Label 35154*/ GIMT_Encode4(2432778), // Rule ID 33934 //
     /* 2432731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432756 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432761 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432777 */     // GIR_Coverage, 33934,
     /* 2432777 */     GIR_EraseRootFromParent_Done,
     /* 2432778 */   // Label 35154: @2432778
     /* 2432778 */   GIM_Try, /*On fail goto*//*Label 35155*/ GIMT_Encode4(2432830), // Rule ID 33935 //
     /* 2432783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432808 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432813 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432829 */     // GIR_Coverage, 33935,
     /* 2432829 */     GIR_EraseRootFromParent_Done,
     /* 2432830 */   // Label 35155: @2432830
     /* 2432830 */   GIM_Try, /*On fail goto*//*Label 35156*/ GIMT_Encode4(2432882), // Rule ID 35548 //
     /* 2432835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432860 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432865 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432881 */     // GIR_Coverage, 35548,
     /* 2432881 */     GIR_EraseRootFromParent_Done,
     /* 2432882 */   // Label 35156: @2432882
     /* 2432882 */   GIM_Try, /*On fail goto*//*Label 35157*/ GIMT_Encode4(2432934), // Rule ID 35549 //
     /* 2432887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432912 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432917 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432933 */     // GIR_Coverage, 35549,
     /* 2432933 */     GIR_EraseRootFromParent_Done,
     /* 2432934 */   // Label 35157: @2432934
     /* 2432934 */   GIM_Reject,
     /* 2432935 */ // Label 35153: @2432935
     /* 2432935 */ GIM_Reject,
     /* 2432936 */ // Label 35069: @2432936
     /* 2432936 */ GIM_Try, /*On fail goto*//*Label 35158*/ GIMT_Encode4(2433052),
     /* 2432941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2432944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2432947 */   GIM_Try, /*On fail goto*//*Label 35159*/ GIMT_Encode4(2432999), // Rule ID 33304 //
     /* 2432952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432977 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432982 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432998 */     // GIR_Coverage, 33304,
     /* 2432998 */     GIR_EraseRootFromParent_Done,
     /* 2432999 */   // Label 35159: @2432999
     /* 2432999 */   GIM_Try, /*On fail goto*//*Label 35160*/ GIMT_Encode4(2433051), // Rule ID 33305 //
     /* 2433004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433029 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2433029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2433032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433034 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433050 */     // GIR_Coverage, 33305,
     /* 2433050 */     GIR_EraseRootFromParent_Done,
     /* 2433051 */   // Label 35160: @2433051
     /* 2433051 */   GIM_Reject,
     /* 2433052 */ // Label 35158: @2433052
     /* 2433052 */ GIM_Reject,
     /* 2433053 */ // Label 35070: @2433053
     /* 2433053 */ GIM_Try, /*On fail goto*//*Label 35161*/ GIMT_Encode4(2433273),
     /* 2433058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2433061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2433064 */   GIM_Try, /*On fail goto*//*Label 35162*/ GIMT_Encode4(2433116), // Rule ID 33664 //
     /* 2433069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433094 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2433094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2433097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433099 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433115 */     // GIR_Coverage, 33664,
     /* 2433115 */     GIR_EraseRootFromParent_Done,
     /* 2433116 */   // Label 35162: @2433116
     /* 2433116 */   GIM_Try, /*On fail goto*//*Label 35163*/ GIMT_Encode4(2433168), // Rule ID 33665 //
     /* 2433121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433146 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2433146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2433149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433151 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433167 */     // GIR_Coverage, 33665,
     /* 2433167 */     GIR_EraseRootFromParent_Done,
     /* 2433168 */   // Label 35163: @2433168
     /* 2433168 */   GIM_Try, /*On fail goto*//*Label 35164*/ GIMT_Encode4(2433220), // Rule ID 35278 //
     /* 2433173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433198 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2433198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2433201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433203 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433219 */     // GIR_Coverage, 35278,
     /* 2433219 */     GIR_EraseRootFromParent_Done,
     /* 2433220 */   // Label 35164: @2433220
     /* 2433220 */   GIM_Try, /*On fail goto*//*Label 35165*/ GIMT_Encode4(2433272), // Rule ID 35279 //
     /* 2433225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433250 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2433250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2433253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433255 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433271 */     // GIR_Coverage, 35279,
     /* 2433271 */     GIR_EraseRootFromParent_Done,
     /* 2433272 */   // Label 35165: @2433272
     /* 2433272 */   GIM_Reject,
     /* 2433273 */ // Label 35161: @2433273
     /* 2433273 */ GIM_Reject,
     /* 2433274 */ // Label 35071: @2433274
     /* 2433274 */ GIM_Try, /*On fail goto*//*Label 35166*/ GIMT_Encode4(2433390),
     /* 2433279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2433282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2433285 */   GIM_Try, /*On fail goto*//*Label 35167*/ GIMT_Encode4(2433337), // Rule ID 33394 //
     /* 2433290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433315 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2433315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2433318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433320 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433336 */     // GIR_Coverage, 33394,
     /* 2433336 */     GIR_EraseRootFromParent_Done,
     /* 2433337 */   // Label 35167: @2433337
     /* 2433337 */   GIM_Try, /*On fail goto*//*Label 35168*/ GIMT_Encode4(2433389), // Rule ID 33395 //
     /* 2433342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433367 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2433367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2433370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433372 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433388 */     // GIR_Coverage, 33395,
     /* 2433388 */     GIR_EraseRootFromParent_Done,
     /* 2433389 */   // Label 35168: @2433389
     /* 2433389 */   GIM_Reject,
     /* 2433390 */ // Label 35166: @2433390
     /* 2433390 */ GIM_Reject,
     /* 2433391 */ // Label 35072: @2433391
     /* 2433391 */ GIM_Reject,
     /* 2433392 */ // Label 123: @2433392
     /* 2433392 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35191*/ GIMT_Encode4(2445271),
     /* 2433403 */ /*GILLT_nxv1s8*//*Label 35169*/ GIMT_Encode4(2433515),
     /* 2433407 */ /*GILLT_nxv1s16*//*Label 35170*/ GIMT_Encode4(2433838),
     /* 2433411 */ /*GILLT_nxv1s32*//*Label 35171*/ GIMT_Encode4(2434471),
     /* 2433415 */ /*GILLT_nxv1s64*//*Label 35172*/ GIMT_Encode4(2435104), GIMT_Encode4(0),
     /* 2433423 */ /*GILLT_nxv2s8*//*Label 35173*/ GIMT_Encode4(2435737),
     /* 2433427 */ /*GILLT_nxv2s16*//*Label 35174*/ GIMT_Encode4(2436060),
     /* 2433431 */ /*GILLT_nxv2s32*//*Label 35175*/ GIMT_Encode4(2436693),
     /* 2433435 */ /*GILLT_nxv2s64*//*Label 35176*/ GIMT_Encode4(2437326), GIMT_Encode4(0),
     /* 2433443 */ /*GILLT_nxv4s8*//*Label 35177*/ GIMT_Encode4(2437959),
     /* 2433447 */ /*GILLT_nxv4s16*//*Label 35178*/ GIMT_Encode4(2438282),
     /* 2433451 */ /*GILLT_nxv4s32*//*Label 35179*/ GIMT_Encode4(2438915),
     /* 2433455 */ /*GILLT_nxv4s64*//*Label 35180*/ GIMT_Encode4(2439548), GIMT_Encode4(0),
     /* 2433463 */ /*GILLT_nxv8s8*//*Label 35181*/ GIMT_Encode4(2440181),
     /* 2433467 */ /*GILLT_nxv8s16*//*Label 35182*/ GIMT_Encode4(2440504),
     /* 2433471 */ /*GILLT_nxv8s32*//*Label 35183*/ GIMT_Encode4(2441137),
     /* 2433475 */ /*GILLT_nxv8s64*//*Label 35184*/ GIMT_Encode4(2441770), GIMT_Encode4(0),
     /* 2433483 */ /*GILLT_nxv16s8*//*Label 35185*/ GIMT_Encode4(2442403),
     /* 2433487 */ /*GILLT_nxv16s16*//*Label 35186*/ GIMT_Encode4(2442726),
     /* 2433491 */ /*GILLT_nxv16s32*//*Label 35187*/ GIMT_Encode4(2443359), GIMT_Encode4(0),
     /* 2433499 */ /*GILLT_nxv32s8*//*Label 35188*/ GIMT_Encode4(2443992),
     /* 2433503 */ /*GILLT_nxv32s16*//*Label 35189*/ GIMT_Encode4(2444315), GIMT_Encode4(0),
     /* 2433511 */ /*GILLT_nxv64s8*//*Label 35190*/ GIMT_Encode4(2444948),
     /* 2433515 */ // Label 35169: @2433515
     /* 2433515 */ GIM_Try, /*On fail goto*//*Label 35192*/ GIMT_Encode4(2433837),
     /* 2433520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2433523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2433526 */   GIM_Try, /*On fail goto*//*Label 35193*/ GIMT_Encode4(2433609), // Rule ID 45458 //
     /* 2433531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2433540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433567 */     // MIs[1] Operand 1
     /* 2433567 */     // No operand predicates
     /* 2433567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433571 */     // MIs[0] policy
     /* 2433571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433583 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2433586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433605 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433608 */     // GIR_Coverage, 45458,
     /* 2433608 */     GIR_EraseRootFromParent_Done,
     /* 2433609 */   // Label 35193: @2433609
     /* 2433609 */   GIM_Try, /*On fail goto*//*Label 35194*/ GIMT_Encode4(2433692), // Rule ID 45459 //
     /* 2433614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2433623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433650 */     // MIs[1] Operand 1
     /* 2433650 */     // No operand predicates
     /* 2433650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433654 */     // MIs[0] policy
     /* 2433654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433666 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2433669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433678 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433691 */     // GIR_Coverage, 45459,
     /* 2433691 */     GIR_EraseRootFromParent_Done,
     /* 2433692 */   // Label 35194: @2433692
     /* 2433692 */   GIM_Try, /*On fail goto*//*Label 35195*/ GIMT_Encode4(2433764), // Rule ID 45460 //
     /* 2433697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2433706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433729 */     // MIs[0] policy
     /* 2433729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433739 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2433742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433750 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433763 */     // GIR_Coverage, 45460,
     /* 2433763 */     GIR_EraseRootFromParent_Done,
     /* 2433764 */   // Label 35195: @2433764
     /* 2433764 */   GIM_Try, /*On fail goto*//*Label 35196*/ GIMT_Encode4(2433836), // Rule ID 45461 //
     /* 2433769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2433778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433801 */     // MIs[0] policy
     /* 2433801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433811 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2433814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433822 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433835 */     // GIR_Coverage, 45461,
     /* 2433835 */     GIR_EraseRootFromParent_Done,
     /* 2433836 */   // Label 35196: @2433836
     /* 2433836 */   GIM_Reject,
     /* 2433837 */ // Label 35192: @2433837
     /* 2433837 */ GIM_Reject,
     /* 2433838 */ // Label 35170: @2433838
     /* 2433838 */ GIM_Try, /*On fail goto*//*Label 35197*/ GIMT_Encode4(2434470),
     /* 2433843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2433846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2433849 */   GIM_Try, /*On fail goto*//*Label 35198*/ GIMT_Encode4(2433932), // Rule ID 45470 //
     /* 2433854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2433863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433890 */     // MIs[1] Operand 1
     /* 2433890 */     // No operand predicates
     /* 2433890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433894 */     // MIs[0] policy
     /* 2433894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433906 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2433909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433918 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433931 */     // GIR_Coverage, 45470,
     /* 2433931 */     GIR_EraseRootFromParent_Done,
     /* 2433932 */   // Label 35198: @2433932
     /* 2433932 */   GIM_Try, /*On fail goto*//*Label 35199*/ GIMT_Encode4(2434015), // Rule ID 45471 //
     /* 2433937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2433946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433973 */     // MIs[1] Operand 1
     /* 2433973 */     // No operand predicates
     /* 2433973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433977 */     // MIs[0] policy
     /* 2433977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433989 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2433992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434014 */     // GIR_Coverage, 45471,
     /* 2434014 */     GIR_EraseRootFromParent_Done,
     /* 2434015 */   // Label 35199: @2434015
     /* 2434015 */   GIM_Try, /*On fail goto*//*Label 35200*/ GIMT_Encode4(2434098), // Rule ID 45546 //
     /* 2434020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434056 */     // MIs[1] Operand 1
     /* 2434056 */     // No operand predicates
     /* 2434056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434060 */     // MIs[0] policy
     /* 2434060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434072 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2434075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434097 */     // GIR_Coverage, 45546,
     /* 2434097 */     GIR_EraseRootFromParent_Done,
     /* 2434098 */   // Label 35200: @2434098
     /* 2434098 */   GIM_Try, /*On fail goto*//*Label 35201*/ GIMT_Encode4(2434181), // Rule ID 45547 //
     /* 2434103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434139 */     // MIs[1] Operand 1
     /* 2434139 */     // No operand predicates
     /* 2434139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434143 */     // MIs[0] policy
     /* 2434143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434155 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2434158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434180 */     // GIR_Coverage, 45547,
     /* 2434180 */     GIR_EraseRootFromParent_Done,
     /* 2434181 */   // Label 35201: @2434181
     /* 2434181 */   GIM_Try, /*On fail goto*//*Label 35202*/ GIMT_Encode4(2434253), // Rule ID 45472 //
     /* 2434186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434218 */     // MIs[0] policy
     /* 2434218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434228 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2434231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434252 */     // GIR_Coverage, 45472,
     /* 2434252 */     GIR_EraseRootFromParent_Done,
     /* 2434253 */   // Label 35202: @2434253
     /* 2434253 */   GIM_Try, /*On fail goto*//*Label 35203*/ GIMT_Encode4(2434325), // Rule ID 45473 //
     /* 2434258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434290 */     // MIs[0] policy
     /* 2434290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434300 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2434303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434324 */     // GIR_Coverage, 45473,
     /* 2434324 */     GIR_EraseRootFromParent_Done,
     /* 2434325 */   // Label 35203: @2434325
     /* 2434325 */   GIM_Try, /*On fail goto*//*Label 35204*/ GIMT_Encode4(2434397), // Rule ID 45548 //
     /* 2434330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434362 */     // MIs[0] policy
     /* 2434362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434372 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2434375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434396 */     // GIR_Coverage, 45548,
     /* 2434396 */     GIR_EraseRootFromParent_Done,
     /* 2434397 */   // Label 35204: @2434397
     /* 2434397 */   GIM_Try, /*On fail goto*//*Label 35205*/ GIMT_Encode4(2434469), // Rule ID 45549 //
     /* 2434402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434434 */     // MIs[0] policy
     /* 2434434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434444 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2434447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434468 */     // GIR_Coverage, 45549,
     /* 2434468 */     GIR_EraseRootFromParent_Done,
     /* 2434469 */   // Label 35205: @2434469
     /* 2434469 */   GIM_Reject,
     /* 2434470 */ // Label 35197: @2434470
     /* 2434470 */ GIM_Reject,
     /* 2434471 */ // Label 35171: @2434471
     /* 2434471 */ GIM_Try, /*On fail goto*//*Label 35206*/ GIMT_Encode4(2435103),
     /* 2434476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2434479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2434482 */   GIM_Try, /*On fail goto*//*Label 35207*/ GIMT_Encode4(2434565), // Rule ID 45478 //
     /* 2434487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434523 */     // MIs[1] Operand 1
     /* 2434523 */     // No operand predicates
     /* 2434523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434527 */     // MIs[0] policy
     /* 2434527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434539 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2434542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434564 */     // GIR_Coverage, 45478,
     /* 2434564 */     GIR_EraseRootFromParent_Done,
     /* 2434565 */   // Label 35207: @2434565
     /* 2434565 */   GIM_Try, /*On fail goto*//*Label 35208*/ GIMT_Encode4(2434648), // Rule ID 45479 //
     /* 2434570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434606 */     // MIs[1] Operand 1
     /* 2434606 */     // No operand predicates
     /* 2434606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434610 */     // MIs[0] policy
     /* 2434610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434622 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2434625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434634 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434647 */     // GIR_Coverage, 45479,
     /* 2434647 */     GIR_EraseRootFromParent_Done,
     /* 2434648 */   // Label 35208: @2434648
     /* 2434648 */   GIM_Try, /*On fail goto*//*Label 35209*/ GIMT_Encode4(2434731), // Rule ID 45554 //
     /* 2434653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434689 */     // MIs[1] Operand 1
     /* 2434689 */     // No operand predicates
     /* 2434689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434693 */     // MIs[0] policy
     /* 2434693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434705 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2434708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434730 */     // GIR_Coverage, 45554,
     /* 2434730 */     GIR_EraseRootFromParent_Done,
     /* 2434731 */   // Label 35209: @2434731
     /* 2434731 */   GIM_Try, /*On fail goto*//*Label 35210*/ GIMT_Encode4(2434814), // Rule ID 45555 //
     /* 2434736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434772 */     // MIs[1] Operand 1
     /* 2434772 */     // No operand predicates
     /* 2434772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434776 */     // MIs[0] policy
     /* 2434776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434788 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2434791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434800 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434813 */     // GIR_Coverage, 45555,
     /* 2434813 */     GIR_EraseRootFromParent_Done,
     /* 2434814 */   // Label 35210: @2434814
     /* 2434814 */   GIM_Try, /*On fail goto*//*Label 35211*/ GIMT_Encode4(2434886), // Rule ID 45480 //
     /* 2434819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434851 */     // MIs[0] policy
     /* 2434851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434861 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2434864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434872 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434885 */     // GIR_Coverage, 45480,
     /* 2434885 */     GIR_EraseRootFromParent_Done,
     /* 2434886 */   // Label 35211: @2434886
     /* 2434886 */   GIM_Try, /*On fail goto*//*Label 35212*/ GIMT_Encode4(2434958), // Rule ID 45481 //
     /* 2434891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434923 */     // MIs[0] policy
     /* 2434923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434933 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2434936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434944 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434957 */     // GIR_Coverage, 45481,
     /* 2434957 */     GIR_EraseRootFromParent_Done,
     /* 2434958 */   // Label 35212: @2434958
     /* 2434958 */   GIM_Try, /*On fail goto*//*Label 35213*/ GIMT_Encode4(2435030), // Rule ID 45556 //
     /* 2434963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434995 */     // MIs[0] policy
     /* 2434995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435005 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2435008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435016 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435029 */     // GIR_Coverage, 45556,
     /* 2435029 */     GIR_EraseRootFromParent_Done,
     /* 2435030 */   // Label 35213: @2435030
     /* 2435030 */   GIM_Try, /*On fail goto*//*Label 35214*/ GIMT_Encode4(2435102), // Rule ID 45557 //
     /* 2435035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435067 */     // MIs[0] policy
     /* 2435067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435077 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2435080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435088 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435101 */     // GIR_Coverage, 45557,
     /* 2435101 */     GIR_EraseRootFromParent_Done,
     /* 2435102 */   // Label 35214: @2435102
     /* 2435102 */   GIM_Reject,
     /* 2435103 */ // Label 35206: @2435103
     /* 2435103 */ GIM_Reject,
     /* 2435104 */ // Label 35172: @2435104
     /* 2435104 */ GIM_Try, /*On fail goto*//*Label 35215*/ GIMT_Encode4(2435736),
     /* 2435109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2435112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2435115 */   GIM_Try, /*On fail goto*//*Label 35216*/ GIMT_Encode4(2435198), // Rule ID 45494 //
     /* 2435120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435156 */     // MIs[1] Operand 1
     /* 2435156 */     // No operand predicates
     /* 2435156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435160 */     // MIs[0] policy
     /* 2435160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435172 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2435175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435184 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435197 */     // GIR_Coverage, 45494,
     /* 2435197 */     GIR_EraseRootFromParent_Done,
     /* 2435198 */   // Label 35216: @2435198
     /* 2435198 */   GIM_Try, /*On fail goto*//*Label 35217*/ GIMT_Encode4(2435281), // Rule ID 45495 //
     /* 2435203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2435206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435239 */     // MIs[1] Operand 1
     /* 2435239 */     // No operand predicates
     /* 2435239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435243 */     // MIs[0] policy
     /* 2435243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435255 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2435258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435280 */     // GIR_Coverage, 45495,
     /* 2435280 */     GIR_EraseRootFromParent_Done,
     /* 2435281 */   // Label 35217: @2435281
     /* 2435281 */   GIM_Try, /*On fail goto*//*Label 35218*/ GIMT_Encode4(2435364), // Rule ID 45566 //
     /* 2435286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435322 */     // MIs[1] Operand 1
     /* 2435322 */     // No operand predicates
     /* 2435322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435326 */     // MIs[0] policy
     /* 2435326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435338 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2435341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435350 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435363 */     // GIR_Coverage, 45566,
     /* 2435363 */     GIR_EraseRootFromParent_Done,
     /* 2435364 */   // Label 35218: @2435364
     /* 2435364 */   GIM_Try, /*On fail goto*//*Label 35219*/ GIMT_Encode4(2435447), // Rule ID 45567 //
     /* 2435369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2435372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435405 */     // MIs[1] Operand 1
     /* 2435405 */     // No operand predicates
     /* 2435405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435409 */     // MIs[0] policy
     /* 2435409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435421 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2435424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435446 */     // GIR_Coverage, 45567,
     /* 2435446 */     GIR_EraseRootFromParent_Done,
     /* 2435447 */   // Label 35219: @2435447
     /* 2435447 */   GIM_Try, /*On fail goto*//*Label 35220*/ GIMT_Encode4(2435519), // Rule ID 45496 //
     /* 2435452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435484 */     // MIs[0] policy
     /* 2435484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435494 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2435497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435518 */     // GIR_Coverage, 45496,
     /* 2435518 */     GIR_EraseRootFromParent_Done,
     /* 2435519 */   // Label 35220: @2435519
     /* 2435519 */   GIM_Try, /*On fail goto*//*Label 35221*/ GIMT_Encode4(2435591), // Rule ID 45497 //
     /* 2435524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2435527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435556 */     // MIs[0] policy
     /* 2435556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435566 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2435569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435590 */     // GIR_Coverage, 45497,
     /* 2435590 */     GIR_EraseRootFromParent_Done,
     /* 2435591 */   // Label 35221: @2435591
     /* 2435591 */   GIM_Try, /*On fail goto*//*Label 35222*/ GIMT_Encode4(2435663), // Rule ID 45568 //
     /* 2435596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435628 */     // MIs[0] policy
     /* 2435628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435638 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2435641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435662 */     // GIR_Coverage, 45568,
     /* 2435662 */     GIR_EraseRootFromParent_Done,
     /* 2435663 */   // Label 35222: @2435663
     /* 2435663 */   GIM_Try, /*On fail goto*//*Label 35223*/ GIMT_Encode4(2435735), // Rule ID 45569 //
     /* 2435668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2435671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435700 */     // MIs[0] policy
     /* 2435700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435710 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2435713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435734 */     // GIR_Coverage, 45569,
     /* 2435734 */     GIR_EraseRootFromParent_Done,
     /* 2435735 */   // Label 35223: @2435735
     /* 2435735 */   GIM_Reject,
     /* 2435736 */ // Label 35215: @2435736
     /* 2435736 */ GIM_Reject,
     /* 2435737 */ // Label 35173: @2435737
     /* 2435737 */ GIM_Try, /*On fail goto*//*Label 35224*/ GIMT_Encode4(2436059),
     /* 2435742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2435745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2435748 */   GIM_Try, /*On fail goto*//*Label 35225*/ GIMT_Encode4(2435831), // Rule ID 45462 //
     /* 2435753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2435762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435789 */     // MIs[1] Operand 1
     /* 2435789 */     // No operand predicates
     /* 2435789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435793 */     // MIs[0] policy
     /* 2435793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435805 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2435808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2435827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435830 */     // GIR_Coverage, 45462,
     /* 2435830 */     GIR_EraseRootFromParent_Done,
     /* 2435831 */   // Label 35225: @2435831
     /* 2435831 */   GIM_Try, /*On fail goto*//*Label 35226*/ GIMT_Encode4(2435914), // Rule ID 45463 //
     /* 2435836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2435845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435872 */     // MIs[1] Operand 1
     /* 2435872 */     // No operand predicates
     /* 2435872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435876 */     // MIs[0] policy
     /* 2435876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435888 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2435891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435900 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2435910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435913 */     // GIR_Coverage, 45463,
     /* 2435913 */     GIR_EraseRootFromParent_Done,
     /* 2435914 */   // Label 35226: @2435914
     /* 2435914 */   GIM_Try, /*On fail goto*//*Label 35227*/ GIMT_Encode4(2435986), // Rule ID 45464 //
     /* 2435919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2435928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435951 */     // MIs[0] policy
     /* 2435951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435961 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2435964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2435982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435985 */     // GIR_Coverage, 45464,
     /* 2435985 */     GIR_EraseRootFromParent_Done,
     /* 2435986 */   // Label 35227: @2435986
     /* 2435986 */   GIM_Try, /*On fail goto*//*Label 35228*/ GIMT_Encode4(2436058), // Rule ID 45465 //
     /* 2435991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436023 */     // MIs[0] policy
     /* 2436023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436033 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2436036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436044 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436057 */     // GIR_Coverage, 45465,
     /* 2436057 */     GIR_EraseRootFromParent_Done,
     /* 2436058 */   // Label 35228: @2436058
     /* 2436058 */   GIM_Reject,
     /* 2436059 */ // Label 35224: @2436059
     /* 2436059 */ GIM_Reject,
     /* 2436060 */ // Label 35174: @2436060
     /* 2436060 */ GIM_Try, /*On fail goto*//*Label 35229*/ GIMT_Encode4(2436692),
     /* 2436065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2436068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2436071 */   GIM_Try, /*On fail goto*//*Label 35230*/ GIMT_Encode4(2436154), // Rule ID 45474 //
     /* 2436076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436112 */     // MIs[1] Operand 1
     /* 2436112 */     // No operand predicates
     /* 2436112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436116 */     // MIs[0] policy
     /* 2436116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436128 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2436131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436153 */     // GIR_Coverage, 45474,
     /* 2436153 */     GIR_EraseRootFromParent_Done,
     /* 2436154 */   // Label 35230: @2436154
     /* 2436154 */   GIM_Try, /*On fail goto*//*Label 35231*/ GIMT_Encode4(2436237), // Rule ID 45475 //
     /* 2436159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436195 */     // MIs[1] Operand 1
     /* 2436195 */     // No operand predicates
     /* 2436195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436199 */     // MIs[0] policy
     /* 2436199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436211 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2436214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436236 */     // GIR_Coverage, 45475,
     /* 2436236 */     GIR_EraseRootFromParent_Done,
     /* 2436237 */   // Label 35231: @2436237
     /* 2436237 */   GIM_Try, /*On fail goto*//*Label 35232*/ GIMT_Encode4(2436320), // Rule ID 45550 //
     /* 2436242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436278 */     // MIs[1] Operand 1
     /* 2436278 */     // No operand predicates
     /* 2436278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436282 */     // MIs[0] policy
     /* 2436282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436294 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2436297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436306 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436319 */     // GIR_Coverage, 45550,
     /* 2436319 */     GIR_EraseRootFromParent_Done,
     /* 2436320 */   // Label 35232: @2436320
     /* 2436320 */   GIM_Try, /*On fail goto*//*Label 35233*/ GIMT_Encode4(2436403), // Rule ID 45551 //
     /* 2436325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436361 */     // MIs[1] Operand 1
     /* 2436361 */     // No operand predicates
     /* 2436361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436365 */     // MIs[0] policy
     /* 2436365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436377 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2436380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436402 */     // GIR_Coverage, 45551,
     /* 2436402 */     GIR_EraseRootFromParent_Done,
     /* 2436403 */   // Label 35233: @2436403
     /* 2436403 */   GIM_Try, /*On fail goto*//*Label 35234*/ GIMT_Encode4(2436475), // Rule ID 45476 //
     /* 2436408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436440 */     // MIs[0] policy
     /* 2436440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436450 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2436453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436474 */     // GIR_Coverage, 45476,
     /* 2436474 */     GIR_EraseRootFromParent_Done,
     /* 2436475 */   // Label 35234: @2436475
     /* 2436475 */   GIM_Try, /*On fail goto*//*Label 35235*/ GIMT_Encode4(2436547), // Rule ID 45477 //
     /* 2436480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436512 */     // MIs[0] policy
     /* 2436512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436522 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2436525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436546 */     // GIR_Coverage, 45477,
     /* 2436546 */     GIR_EraseRootFromParent_Done,
     /* 2436547 */   // Label 35235: @2436547
     /* 2436547 */   GIM_Try, /*On fail goto*//*Label 35236*/ GIMT_Encode4(2436619), // Rule ID 45552 //
     /* 2436552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436584 */     // MIs[0] policy
     /* 2436584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436594 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2436597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436618 */     // GIR_Coverage, 45552,
     /* 2436618 */     GIR_EraseRootFromParent_Done,
     /* 2436619 */   // Label 35236: @2436619
     /* 2436619 */   GIM_Try, /*On fail goto*//*Label 35237*/ GIMT_Encode4(2436691), // Rule ID 45553 //
     /* 2436624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436656 */     // MIs[0] policy
     /* 2436656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436666 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2436669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436690 */     // GIR_Coverage, 45553,
     /* 2436690 */     GIR_EraseRootFromParent_Done,
     /* 2436691 */   // Label 35237: @2436691
     /* 2436691 */   GIM_Reject,
     /* 2436692 */ // Label 35229: @2436692
     /* 2436692 */ GIM_Reject,
     /* 2436693 */ // Label 35175: @2436693
     /* 2436693 */ GIM_Try, /*On fail goto*//*Label 35238*/ GIMT_Encode4(2437325),
     /* 2436698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2436701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2436704 */   GIM_Try, /*On fail goto*//*Label 35239*/ GIMT_Encode4(2436787), // Rule ID 45490 //
     /* 2436709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436745 */     // MIs[1] Operand 1
     /* 2436745 */     // No operand predicates
     /* 2436745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436749 */     // MIs[0] policy
     /* 2436749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436761 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2436764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2436783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436786 */     // GIR_Coverage, 45490,
     /* 2436786 */     GIR_EraseRootFromParent_Done,
     /* 2436787 */   // Label 35239: @2436787
     /* 2436787 */   GIM_Try, /*On fail goto*//*Label 35240*/ GIMT_Encode4(2436870), // Rule ID 45491 //
     /* 2436792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436828 */     // MIs[1] Operand 1
     /* 2436828 */     // No operand predicates
     /* 2436828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436832 */     // MIs[0] policy
     /* 2436832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436844 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2436847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436856 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2436866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436869 */     // GIR_Coverage, 45491,
     /* 2436869 */     GIR_EraseRootFromParent_Done,
     /* 2436870 */   // Label 35240: @2436870
     /* 2436870 */   GIM_Try, /*On fail goto*//*Label 35241*/ GIMT_Encode4(2436953), // Rule ID 45562 //
     /* 2436875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436911 */     // MIs[1] Operand 1
     /* 2436911 */     // No operand predicates
     /* 2436911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436915 */     // MIs[0] policy
     /* 2436915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436927 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2436930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2436949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436952 */     // GIR_Coverage, 45562,
     /* 2436952 */     GIR_EraseRootFromParent_Done,
     /* 2436953 */   // Label 35241: @2436953
     /* 2436953 */   GIM_Try, /*On fail goto*//*Label 35242*/ GIMT_Encode4(2437036), // Rule ID 45563 //
     /* 2436958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436994 */     // MIs[1] Operand 1
     /* 2436994 */     // No operand predicates
     /* 2436994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436998 */     // MIs[0] policy
     /* 2436998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437010 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2437013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437022 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437035 */     // GIR_Coverage, 45563,
     /* 2437035 */     GIR_EraseRootFromParent_Done,
     /* 2437036 */   // Label 35242: @2437036
     /* 2437036 */   GIM_Try, /*On fail goto*//*Label 35243*/ GIMT_Encode4(2437108), // Rule ID 45492 //
     /* 2437041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2437057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437073 */     // MIs[0] policy
     /* 2437073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437083 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2437086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437094 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437107 */     // GIR_Coverage, 45492,
     /* 2437107 */     GIR_EraseRootFromParent_Done,
     /* 2437108 */   // Label 35243: @2437108
     /* 2437108 */   GIM_Try, /*On fail goto*//*Label 35244*/ GIMT_Encode4(2437180), // Rule ID 45493 //
     /* 2437113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2437129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437145 */     // MIs[0] policy
     /* 2437145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437155 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2437158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437179 */     // GIR_Coverage, 45493,
     /* 2437179 */     GIR_EraseRootFromParent_Done,
     /* 2437180 */   // Label 35244: @2437180
     /* 2437180 */   GIM_Try, /*On fail goto*//*Label 35245*/ GIMT_Encode4(2437252), // Rule ID 45564 //
     /* 2437185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2437201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437217 */     // MIs[0] policy
     /* 2437217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437227 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2437230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437238 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437251 */     // GIR_Coverage, 45564,
     /* 2437251 */     GIR_EraseRootFromParent_Done,
     /* 2437252 */   // Label 35245: @2437252
     /* 2437252 */   GIM_Try, /*On fail goto*//*Label 35246*/ GIMT_Encode4(2437324), // Rule ID 45565 //
     /* 2437257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2437273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437289 */     // MIs[0] policy
     /* 2437289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437299 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2437302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437310 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437323 */     // GIR_Coverage, 45565,
     /* 2437323 */     GIR_EraseRootFromParent_Done,
     /* 2437324 */   // Label 35246: @2437324
     /* 2437324 */   GIM_Reject,
     /* 2437325 */ // Label 35238: @2437325
     /* 2437325 */ GIM_Reject,
     /* 2437326 */ // Label 35176: @2437326
     /* 2437326 */ GIM_Try, /*On fail goto*//*Label 35247*/ GIMT_Encode4(2437958),
     /* 2437331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2437334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2437337 */   GIM_Try, /*On fail goto*//*Label 35248*/ GIMT_Encode4(2437420), // Rule ID 45534 //
     /* 2437342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2437345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437378 */     // MIs[1] Operand 1
     /* 2437378 */     // No operand predicates
     /* 2437378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437382 */     // MIs[0] policy
     /* 2437382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437394 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2437397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437406 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437419 */     // GIR_Coverage, 45534,
     /* 2437419 */     GIR_EraseRootFromParent_Done,
     /* 2437420 */   // Label 35248: @2437420
     /* 2437420 */   GIM_Try, /*On fail goto*//*Label 35249*/ GIMT_Encode4(2437503), // Rule ID 45535 //
     /* 2437425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2437428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437461 */     // MIs[1] Operand 1
     /* 2437461 */     // No operand predicates
     /* 2437461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437465 */     // MIs[0] policy
     /* 2437465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437477 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2437480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437502 */     // GIR_Coverage, 45535,
     /* 2437502 */     GIR_EraseRootFromParent_Done,
     /* 2437503 */   // Label 35249: @2437503
     /* 2437503 */   GIM_Try, /*On fail goto*//*Label 35250*/ GIMT_Encode4(2437586), // Rule ID 45594 //
     /* 2437508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2437511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437544 */     // MIs[1] Operand 1
     /* 2437544 */     // No operand predicates
     /* 2437544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437548 */     // MIs[0] policy
     /* 2437548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437560 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2437563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437572 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437585 */     // GIR_Coverage, 45594,
     /* 2437585 */     GIR_EraseRootFromParent_Done,
     /* 2437586 */   // Label 35250: @2437586
     /* 2437586 */   GIM_Try, /*On fail goto*//*Label 35251*/ GIMT_Encode4(2437669), // Rule ID 45595 //
     /* 2437591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2437594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437627 */     // MIs[1] Operand 1
     /* 2437627 */     // No operand predicates
     /* 2437627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437631 */     // MIs[0] policy
     /* 2437631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437643 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2437646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437668 */     // GIR_Coverage, 45595,
     /* 2437668 */     GIR_EraseRootFromParent_Done,
     /* 2437669 */   // Label 35251: @2437669
     /* 2437669 */   GIM_Try, /*On fail goto*//*Label 35252*/ GIMT_Encode4(2437741), // Rule ID 45536 //
     /* 2437674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2437677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437706 */     // MIs[0] policy
     /* 2437706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437716 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2437719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437740 */     // GIR_Coverage, 45536,
     /* 2437740 */     GIR_EraseRootFromParent_Done,
     /* 2437741 */   // Label 35252: @2437741
     /* 2437741 */   GIM_Try, /*On fail goto*//*Label 35253*/ GIMT_Encode4(2437813), // Rule ID 45537 //
     /* 2437746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2437749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437778 */     // MIs[0] policy
     /* 2437778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437788 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2437791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437812 */     // GIR_Coverage, 45537,
     /* 2437812 */     GIR_EraseRootFromParent_Done,
     /* 2437813 */   // Label 35253: @2437813
     /* 2437813 */   GIM_Try, /*On fail goto*//*Label 35254*/ GIMT_Encode4(2437885), // Rule ID 45596 //
     /* 2437818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2437821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437850 */     // MIs[0] policy
     /* 2437850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437860 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2437863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437884 */     // GIR_Coverage, 45596,
     /* 2437884 */     GIR_EraseRootFromParent_Done,
     /* 2437885 */   // Label 35254: @2437885
     /* 2437885 */   GIM_Try, /*On fail goto*//*Label 35255*/ GIMT_Encode4(2437957), // Rule ID 45597 //
     /* 2437890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2437893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437922 */     // MIs[0] policy
     /* 2437922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437932 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2437935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437956 */     // GIR_Coverage, 45597,
     /* 2437956 */     GIR_EraseRootFromParent_Done,
     /* 2437957 */   // Label 35255: @2437957
     /* 2437957 */   GIM_Reject,
     /* 2437958 */ // Label 35247: @2437958
     /* 2437958 */ GIM_Reject,
     /* 2437959 */ // Label 35177: @2437959
     /* 2437959 */ GIM_Try, /*On fail goto*//*Label 35256*/ GIMT_Encode4(2438281),
     /* 2437964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2437967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2437970 */   GIM_Try, /*On fail goto*//*Label 35257*/ GIMT_Encode4(2438053), // Rule ID 45466 //
     /* 2437975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2437984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2437991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438011 */     // MIs[1] Operand 1
     /* 2438011 */     // No operand predicates
     /* 2438011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438015 */     // MIs[0] policy
     /* 2438015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438027 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2438030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438052 */     // GIR_Coverage, 45466,
     /* 2438052 */     GIR_EraseRootFromParent_Done,
     /* 2438053 */   // Label 35257: @2438053
     /* 2438053 */   GIM_Try, /*On fail goto*//*Label 35258*/ GIMT_Encode4(2438136), // Rule ID 45467 //
     /* 2438058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438094 */     // MIs[1] Operand 1
     /* 2438094 */     // No operand predicates
     /* 2438094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438098 */     // MIs[0] policy
     /* 2438098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438110 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2438113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438122 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438135 */     // GIR_Coverage, 45467,
     /* 2438135 */     GIR_EraseRootFromParent_Done,
     /* 2438136 */   // Label 35258: @2438136
     /* 2438136 */   GIM_Try, /*On fail goto*//*Label 35259*/ GIMT_Encode4(2438208), // Rule ID 45468 //
     /* 2438141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438173 */     // MIs[0] policy
     /* 2438173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438183 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2438186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438194 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438207 */     // GIR_Coverage, 45468,
     /* 2438207 */     GIR_EraseRootFromParent_Done,
     /* 2438208 */   // Label 35259: @2438208
     /* 2438208 */   GIM_Try, /*On fail goto*//*Label 35260*/ GIMT_Encode4(2438280), // Rule ID 45469 //
     /* 2438213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438245 */     // MIs[0] policy
     /* 2438245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438255 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2438258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438266 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438279 */     // GIR_Coverage, 45469,
     /* 2438279 */     GIR_EraseRootFromParent_Done,
     /* 2438280 */   // Label 35260: @2438280
     /* 2438280 */   GIM_Reject,
     /* 2438281 */ // Label 35256: @2438281
     /* 2438281 */ GIM_Reject,
     /* 2438282 */ // Label 35178: @2438282
     /* 2438282 */ GIM_Try, /*On fail goto*//*Label 35261*/ GIMT_Encode4(2438914),
     /* 2438287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2438290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2438293 */   GIM_Try, /*On fail goto*//*Label 35262*/ GIMT_Encode4(2438376), // Rule ID 45486 //
     /* 2438298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438334 */     // MIs[1] Operand 1
     /* 2438334 */     // No operand predicates
     /* 2438334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438338 */     // MIs[0] policy
     /* 2438338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438350 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2438353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438375 */     // GIR_Coverage, 45486,
     /* 2438375 */     GIR_EraseRootFromParent_Done,
     /* 2438376 */   // Label 35262: @2438376
     /* 2438376 */   GIM_Try, /*On fail goto*//*Label 35263*/ GIMT_Encode4(2438459), // Rule ID 45487 //
     /* 2438381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438417 */     // MIs[1] Operand 1
     /* 2438417 */     // No operand predicates
     /* 2438417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438421 */     // MIs[0] policy
     /* 2438421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438433 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2438436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438455 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438458 */     // GIR_Coverage, 45487,
     /* 2438458 */     GIR_EraseRootFromParent_Done,
     /* 2438459 */   // Label 35263: @2438459
     /* 2438459 */   GIM_Try, /*On fail goto*//*Label 35264*/ GIMT_Encode4(2438542), // Rule ID 45558 //
     /* 2438464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438500 */     // MIs[1] Operand 1
     /* 2438500 */     // No operand predicates
     /* 2438500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438504 */     // MIs[0] policy
     /* 2438504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438516 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2438519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438541 */     // GIR_Coverage, 45558,
     /* 2438541 */     GIR_EraseRootFromParent_Done,
     /* 2438542 */   // Label 35264: @2438542
     /* 2438542 */   GIM_Try, /*On fail goto*//*Label 35265*/ GIMT_Encode4(2438625), // Rule ID 45559 //
     /* 2438547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438583 */     // MIs[1] Operand 1
     /* 2438583 */     // No operand predicates
     /* 2438583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438587 */     // MIs[0] policy
     /* 2438587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438599 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2438602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438624 */     // GIR_Coverage, 45559,
     /* 2438624 */     GIR_EraseRootFromParent_Done,
     /* 2438625 */   // Label 35265: @2438625
     /* 2438625 */   GIM_Try, /*On fail goto*//*Label 35266*/ GIMT_Encode4(2438697), // Rule ID 45488 //
     /* 2438630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438662 */     // MIs[0] policy
     /* 2438662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438672 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2438675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438696 */     // GIR_Coverage, 45488,
     /* 2438696 */     GIR_EraseRootFromParent_Done,
     /* 2438697 */   // Label 35266: @2438697
     /* 2438697 */   GIM_Try, /*On fail goto*//*Label 35267*/ GIMT_Encode4(2438769), // Rule ID 45489 //
     /* 2438702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438734 */     // MIs[0] policy
     /* 2438734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438744 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2438747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438768 */     // GIR_Coverage, 45489,
     /* 2438768 */     GIR_EraseRootFromParent_Done,
     /* 2438769 */   // Label 35267: @2438769
     /* 2438769 */   GIM_Try, /*On fail goto*//*Label 35268*/ GIMT_Encode4(2438841), // Rule ID 45560 //
     /* 2438774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438806 */     // MIs[0] policy
     /* 2438806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438816 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2438819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438840 */     // GIR_Coverage, 45560,
     /* 2438840 */     GIR_EraseRootFromParent_Done,
     /* 2438841 */   // Label 35268: @2438841
     /* 2438841 */   GIM_Try, /*On fail goto*//*Label 35269*/ GIMT_Encode4(2438913), // Rule ID 45561 //
     /* 2438846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438878 */     // MIs[0] policy
     /* 2438878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438888 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2438891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438909 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438912 */     // GIR_Coverage, 45561,
     /* 2438912 */     GIR_EraseRootFromParent_Done,
     /* 2438913 */   // Label 35269: @2438913
     /* 2438913 */   GIM_Reject,
     /* 2438914 */ // Label 35261: @2438914
     /* 2438914 */ GIM_Reject,
     /* 2438915 */ // Label 35179: @2438915
     /* 2438915 */ GIM_Try, /*On fail goto*//*Label 35270*/ GIMT_Encode4(2439547),
     /* 2438920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2438923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2438926 */   GIM_Try, /*On fail goto*//*Label 35271*/ GIMT_Encode4(2439009), // Rule ID 45522 //
     /* 2438931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2438947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2438951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2438955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438967 */     // MIs[1] Operand 1
     /* 2438967 */     // No operand predicates
     /* 2438967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438971 */     // MIs[0] policy
     /* 2438971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438983 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2438986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439008 */     // GIR_Coverage, 45522,
     /* 2439008 */     GIR_EraseRootFromParent_Done,
     /* 2439009 */   // Label 35271: @2439009
     /* 2439009 */   GIM_Try, /*On fail goto*//*Label 35272*/ GIMT_Encode4(2439092), // Rule ID 45523 //
     /* 2439014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439050 */     // MIs[1] Operand 1
     /* 2439050 */     // No operand predicates
     /* 2439050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439054 */     // MIs[0] policy
     /* 2439054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439066 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2439069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439078 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439091 */     // GIR_Coverage, 45523,
     /* 2439091 */     GIR_EraseRootFromParent_Done,
     /* 2439092 */   // Label 35272: @2439092
     /* 2439092 */   GIM_Try, /*On fail goto*//*Label 35273*/ GIMT_Encode4(2439175), // Rule ID 45582 //
     /* 2439097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439133 */     // MIs[1] Operand 1
     /* 2439133 */     // No operand predicates
     /* 2439133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439137 */     // MIs[0] policy
     /* 2439137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439149 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2439152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439174 */     // GIR_Coverage, 45582,
     /* 2439174 */     GIR_EraseRootFromParent_Done,
     /* 2439175 */   // Label 35273: @2439175
     /* 2439175 */   GIM_Try, /*On fail goto*//*Label 35274*/ GIMT_Encode4(2439258), // Rule ID 45583 //
     /* 2439180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439216 */     // MIs[1] Operand 1
     /* 2439216 */     // No operand predicates
     /* 2439216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439220 */     // MIs[0] policy
     /* 2439220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439232 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2439235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439257 */     // GIR_Coverage, 45583,
     /* 2439257 */     GIR_EraseRootFromParent_Done,
     /* 2439258 */   // Label 35274: @2439258
     /* 2439258 */   GIM_Try, /*On fail goto*//*Label 35275*/ GIMT_Encode4(2439330), // Rule ID 45524 //
     /* 2439263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439295 */     // MIs[0] policy
     /* 2439295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439305 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2439308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439329 */     // GIR_Coverage, 45524,
     /* 2439329 */     GIR_EraseRootFromParent_Done,
     /* 2439330 */   // Label 35275: @2439330
     /* 2439330 */   GIM_Try, /*On fail goto*//*Label 35276*/ GIMT_Encode4(2439402), // Rule ID 45525 //
     /* 2439335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439367 */     // MIs[0] policy
     /* 2439367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439377 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2439380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439388 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439401 */     // GIR_Coverage, 45525,
     /* 2439401 */     GIR_EraseRootFromParent_Done,
     /* 2439402 */   // Label 35276: @2439402
     /* 2439402 */   GIM_Try, /*On fail goto*//*Label 35277*/ GIMT_Encode4(2439474), // Rule ID 45584 //
     /* 2439407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439439 */     // MIs[0] policy
     /* 2439439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439449 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2439452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439473 */     // GIR_Coverage, 45584,
     /* 2439473 */     GIR_EraseRootFromParent_Done,
     /* 2439474 */   // Label 35277: @2439474
     /* 2439474 */   GIM_Try, /*On fail goto*//*Label 35278*/ GIMT_Encode4(2439546), // Rule ID 45585 //
     /* 2439479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439511 */     // MIs[0] policy
     /* 2439511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439521 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2439524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439545 */     // GIR_Coverage, 45585,
     /* 2439545 */     GIR_EraseRootFromParent_Done,
     /* 2439546 */   // Label 35278: @2439546
     /* 2439546 */   GIM_Reject,
     /* 2439547 */ // Label 35270: @2439547
     /* 2439547 */ GIM_Reject,
     /* 2439548 */ // Label 35180: @2439548
     /* 2439548 */ GIM_Try, /*On fail goto*//*Label 35279*/ GIMT_Encode4(2440180),
     /* 2439553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2439556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2439559 */   GIM_Try, /*On fail goto*//*Label 35280*/ GIMT_Encode4(2439642), // Rule ID 45538 //
     /* 2439564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2439567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439600 */     // MIs[1] Operand 1
     /* 2439600 */     // No operand predicates
     /* 2439600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439604 */     // MIs[0] policy
     /* 2439604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439616 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2439619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2439638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439641 */     // GIR_Coverage, 45538,
     /* 2439641 */     GIR_EraseRootFromParent_Done,
     /* 2439642 */   // Label 35280: @2439642
     /* 2439642 */   GIM_Try, /*On fail goto*//*Label 35281*/ GIMT_Encode4(2439725), // Rule ID 45539 //
     /* 2439647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2439650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439683 */     // MIs[1] Operand 1
     /* 2439683 */     // No operand predicates
     /* 2439683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439687 */     // MIs[0] policy
     /* 2439687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439699 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2439702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2439721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439724 */     // GIR_Coverage, 45539,
     /* 2439724 */     GIR_EraseRootFromParent_Done,
     /* 2439725 */   // Label 35281: @2439725
     /* 2439725 */   GIM_Try, /*On fail goto*//*Label 35282*/ GIMT_Encode4(2439808), // Rule ID 45598 //
     /* 2439730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2439733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439766 */     // MIs[1] Operand 1
     /* 2439766 */     // No operand predicates
     /* 2439766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439770 */     // MIs[0] policy
     /* 2439770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439782 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2439785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439794 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2439804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439807 */     // GIR_Coverage, 45598,
     /* 2439807 */     GIR_EraseRootFromParent_Done,
     /* 2439808 */   // Label 35282: @2439808
     /* 2439808 */   GIM_Try, /*On fail goto*//*Label 35283*/ GIMT_Encode4(2439891), // Rule ID 45599 //
     /* 2439813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2439816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439849 */     // MIs[1] Operand 1
     /* 2439849 */     // No operand predicates
     /* 2439849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439853 */     // MIs[0] policy
     /* 2439853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439865 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2439868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2439887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439890 */     // GIR_Coverage, 45599,
     /* 2439890 */     GIR_EraseRootFromParent_Done,
     /* 2439891 */   // Label 35283: @2439891
     /* 2439891 */   GIM_Try, /*On fail goto*//*Label 35284*/ GIMT_Encode4(2439963), // Rule ID 45540 //
     /* 2439896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2439899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439928 */     // MIs[0] policy
     /* 2439928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439938 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2439941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2439959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439962 */     // GIR_Coverage, 45540,
     /* 2439962 */     GIR_EraseRootFromParent_Done,
     /* 2439963 */   // Label 35284: @2439963
     /* 2439963 */   GIM_Try, /*On fail goto*//*Label 35285*/ GIMT_Encode4(2440035), // Rule ID 45541 //
     /* 2439968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2439971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440000 */     // MIs[0] policy
     /* 2440000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440010 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2440013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2440031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440034 */     // GIR_Coverage, 45541,
     /* 2440034 */     GIR_EraseRootFromParent_Done,
     /* 2440035 */   // Label 35285: @2440035
     /* 2440035 */   GIM_Try, /*On fail goto*//*Label 35286*/ GIMT_Encode4(2440107), // Rule ID 45600 //
     /* 2440040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2440043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2440049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2440056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440072 */     // MIs[0] policy
     /* 2440072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440082 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2440085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2440103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440106 */     // GIR_Coverage, 45600,
     /* 2440106 */     GIR_EraseRootFromParent_Done,
     /* 2440107 */   // Label 35286: @2440107
     /* 2440107 */   GIM_Try, /*On fail goto*//*Label 35287*/ GIMT_Encode4(2440179), // Rule ID 45601 //
     /* 2440112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2440115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2440121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2440128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440144 */     // MIs[0] policy
     /* 2440144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440154 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2440157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2440175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440178 */     // GIR_Coverage, 45601,
     /* 2440178 */     GIR_EraseRootFromParent_Done,
     /* 2440179 */   // Label 35287: @2440179
     /* 2440179 */   GIM_Reject,
     /* 2440180 */ // Label 35279: @2440180
     /* 2440180 */ GIM_Reject,
     /* 2440181 */ // Label 35181: @2440181
     /* 2440181 */ GIM_Try, /*On fail goto*//*Label 35288*/ GIMT_Encode4(2440503),
     /* 2440186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2440189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2440192 */   GIM_Try, /*On fail goto*//*Label 35289*/ GIMT_Encode4(2440275), // Rule ID 45482 //
     /* 2440197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440233 */     // MIs[1] Operand 1
     /* 2440233 */     // No operand predicates
     /* 2440233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440237 */     // MIs[0] policy
     /* 2440237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440249 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2440252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2440271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440274 */     // GIR_Coverage, 45482,
     /* 2440274 */     GIR_EraseRootFromParent_Done,
     /* 2440275 */   // Label 35289: @2440275
     /* 2440275 */   GIM_Try, /*On fail goto*//*Label 35290*/ GIMT_Encode4(2440358), // Rule ID 45483 //
     /* 2440280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440316 */     // MIs[1] Operand 1
     /* 2440316 */     // No operand predicates
     /* 2440316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440320 */     // MIs[0] policy
     /* 2440320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440332 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2440335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440344 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2440354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440357 */     // GIR_Coverage, 45483,
     /* 2440357 */     GIR_EraseRootFromParent_Done,
     /* 2440358 */   // Label 35290: @2440358
     /* 2440358 */   GIM_Try, /*On fail goto*//*Label 35291*/ GIMT_Encode4(2440430), // Rule ID 45484 //
     /* 2440363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440395 */     // MIs[0] policy
     /* 2440395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440405 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2440408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440416 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2440426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440429 */     // GIR_Coverage, 45484,
     /* 2440429 */     GIR_EraseRootFromParent_Done,
     /* 2440430 */   // Label 35291: @2440430
     /* 2440430 */   GIM_Try, /*On fail goto*//*Label 35292*/ GIMT_Encode4(2440502), // Rule ID 45485 //
     /* 2440435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440467 */     // MIs[0] policy
     /* 2440467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440477 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2440480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440488 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2440498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440501 */     // GIR_Coverage, 45485,
     /* 2440501 */     GIR_EraseRootFromParent_Done,
     /* 2440502 */   // Label 35292: @2440502
     /* 2440502 */   GIM_Reject,
     /* 2440503 */ // Label 35288: @2440503
     /* 2440503 */ GIM_Reject,
     /* 2440504 */ // Label 35182: @2440504
     /* 2440504 */ GIM_Try, /*On fail goto*//*Label 35293*/ GIMT_Encode4(2441136),
     /* 2440509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2440512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2440515 */   GIM_Try, /*On fail goto*//*Label 35294*/ GIMT_Encode4(2440598), // Rule ID 45510 //
     /* 2440520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2440536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440556 */     // MIs[1] Operand 1
     /* 2440556 */     // No operand predicates
     /* 2440556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440560 */     // MIs[0] policy
     /* 2440560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440572 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2440575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440584 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440597 */     // GIR_Coverage, 45510,
     /* 2440597 */     GIR_EraseRootFromParent_Done,
     /* 2440598 */   // Label 35294: @2440598
     /* 2440598 */   GIM_Try, /*On fail goto*//*Label 35295*/ GIMT_Encode4(2440681), // Rule ID 45511 //
     /* 2440603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2440619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440639 */     // MIs[1] Operand 1
     /* 2440639 */     // No operand predicates
     /* 2440639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440643 */     // MIs[0] policy
     /* 2440643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440655 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2440658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440680 */     // GIR_Coverage, 45511,
     /* 2440680 */     GIR_EraseRootFromParent_Done,
     /* 2440681 */   // Label 35295: @2440681
     /* 2440681 */   GIM_Try, /*On fail goto*//*Label 35296*/ GIMT_Encode4(2440764), // Rule ID 45570 //
     /* 2440686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2440702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440722 */     // MIs[1] Operand 1
     /* 2440722 */     // No operand predicates
     /* 2440722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440726 */     // MIs[0] policy
     /* 2440726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440738 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2440741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440750 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440763 */     // GIR_Coverage, 45570,
     /* 2440763 */     GIR_EraseRootFromParent_Done,
     /* 2440764 */   // Label 35296: @2440764
     /* 2440764 */   GIM_Try, /*On fail goto*//*Label 35297*/ GIMT_Encode4(2440847), // Rule ID 45571 //
     /* 2440769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2440785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440805 */     // MIs[1] Operand 1
     /* 2440805 */     // No operand predicates
     /* 2440805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440809 */     // MIs[0] policy
     /* 2440809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440821 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2440824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440846 */     // GIR_Coverage, 45571,
     /* 2440846 */     GIR_EraseRootFromParent_Done,
     /* 2440847 */   // Label 35297: @2440847
     /* 2440847 */   GIM_Try, /*On fail goto*//*Label 35298*/ GIMT_Encode4(2440919), // Rule ID 45512 //
     /* 2440852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2440868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440884 */     // MIs[0] policy
     /* 2440884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440894 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2440897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440918 */     // GIR_Coverage, 45512,
     /* 2440918 */     GIR_EraseRootFromParent_Done,
     /* 2440919 */   // Label 35298: @2440919
     /* 2440919 */   GIM_Try, /*On fail goto*//*Label 35299*/ GIMT_Encode4(2440991), // Rule ID 45513 //
     /* 2440924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2440940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440956 */     // MIs[0] policy
     /* 2440956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440966 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2440969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440990 */     // GIR_Coverage, 45513,
     /* 2440990 */     GIR_EraseRootFromParent_Done,
     /* 2440991 */   // Label 35299: @2440991
     /* 2440991 */   GIM_Try, /*On fail goto*//*Label 35300*/ GIMT_Encode4(2441063), // Rule ID 45572 //
     /* 2440996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2441012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2441016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2441020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441028 */     // MIs[0] policy
     /* 2441028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441038 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2441041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2441059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441062 */     // GIR_Coverage, 45572,
     /* 2441062 */     GIR_EraseRootFromParent_Done,
     /* 2441063 */   // Label 35300: @2441063
     /* 2441063 */   GIM_Try, /*On fail goto*//*Label 35301*/ GIMT_Encode4(2441135), // Rule ID 45573 //
     /* 2441068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2441084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2441088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2441092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441100 */     // MIs[0] policy
     /* 2441100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441110 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2441113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2441131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441134 */     // GIR_Coverage, 45573,
     /* 2441134 */     GIR_EraseRootFromParent_Done,
     /* 2441135 */   // Label 35301: @2441135
     /* 2441135 */   GIM_Reject,
     /* 2441136 */ // Label 35293: @2441136
     /* 2441136 */ GIM_Reject,
     /* 2441137 */ // Label 35183: @2441137
     /* 2441137 */ GIM_Try, /*On fail goto*//*Label 35302*/ GIMT_Encode4(2441769),
     /* 2441142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2441145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2441148 */   GIM_Try, /*On fail goto*//*Label 35303*/ GIMT_Encode4(2441231), // Rule ID 45526 //
     /* 2441153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441189 */     // MIs[1] Operand 1
     /* 2441189 */     // No operand predicates
     /* 2441189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441193 */     // MIs[0] policy
     /* 2441193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441205 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2441208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441230 */     // GIR_Coverage, 45526,
     /* 2441230 */     GIR_EraseRootFromParent_Done,
     /* 2441231 */   // Label 35303: @2441231
     /* 2441231 */   GIM_Try, /*On fail goto*//*Label 35304*/ GIMT_Encode4(2441314), // Rule ID 45527 //
     /* 2441236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441272 */     // MIs[1] Operand 1
     /* 2441272 */     // No operand predicates
     /* 2441272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441276 */     // MIs[0] policy
     /* 2441276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441288 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2441291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441313 */     // GIR_Coverage, 45527,
     /* 2441313 */     GIR_EraseRootFromParent_Done,
     /* 2441314 */   // Label 35304: @2441314
     /* 2441314 */   GIM_Try, /*On fail goto*//*Label 35305*/ GIMT_Encode4(2441397), // Rule ID 45586 //
     /* 2441319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441355 */     // MIs[1] Operand 1
     /* 2441355 */     // No operand predicates
     /* 2441355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441359 */     // MIs[0] policy
     /* 2441359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441371 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2441374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441396 */     // GIR_Coverage, 45586,
     /* 2441396 */     GIR_EraseRootFromParent_Done,
     /* 2441397 */   // Label 35305: @2441397
     /* 2441397 */   GIM_Try, /*On fail goto*//*Label 35306*/ GIMT_Encode4(2441480), // Rule ID 45587 //
     /* 2441402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441438 */     // MIs[1] Operand 1
     /* 2441438 */     // No operand predicates
     /* 2441438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441442 */     // MIs[0] policy
     /* 2441442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441454 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2441457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441479 */     // GIR_Coverage, 45587,
     /* 2441479 */     GIR_EraseRootFromParent_Done,
     /* 2441480 */   // Label 35306: @2441480
     /* 2441480 */   GIM_Try, /*On fail goto*//*Label 35307*/ GIMT_Encode4(2441552), // Rule ID 45528 //
     /* 2441485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441517 */     // MIs[0] policy
     /* 2441517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441527 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2441530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441538 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441551 */     // GIR_Coverage, 45528,
     /* 2441551 */     GIR_EraseRootFromParent_Done,
     /* 2441552 */   // Label 35307: @2441552
     /* 2441552 */   GIM_Try, /*On fail goto*//*Label 35308*/ GIMT_Encode4(2441624), // Rule ID 45529 //
     /* 2441557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441589 */     // MIs[0] policy
     /* 2441589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441599 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2441602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441610 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441623 */     // GIR_Coverage, 45529,
     /* 2441623 */     GIR_EraseRootFromParent_Done,
     /* 2441624 */   // Label 35308: @2441624
     /* 2441624 */   GIM_Try, /*On fail goto*//*Label 35309*/ GIMT_Encode4(2441696), // Rule ID 45588 //
     /* 2441629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441661 */     // MIs[0] policy
     /* 2441661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441671 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2441674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441695 */     // GIR_Coverage, 45588,
     /* 2441695 */     GIR_EraseRootFromParent_Done,
     /* 2441696 */   // Label 35309: @2441696
     /* 2441696 */   GIM_Try, /*On fail goto*//*Label 35310*/ GIMT_Encode4(2441768), // Rule ID 45589 //
     /* 2441701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441733 */     // MIs[0] policy
     /* 2441733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441743 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2441746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441754 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441764 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441767 */     // GIR_Coverage, 45589,
     /* 2441767 */     GIR_EraseRootFromParent_Done,
     /* 2441768 */   // Label 35310: @2441768
     /* 2441768 */   GIM_Reject,
     /* 2441769 */ // Label 35302: @2441769
     /* 2441769 */ GIM_Reject,
     /* 2441770 */ // Label 35184: @2441770
     /* 2441770 */ GIM_Try, /*On fail goto*//*Label 35311*/ GIMT_Encode4(2442402),
     /* 2441775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2441778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2441781 */   GIM_Try, /*On fail goto*//*Label 35312*/ GIMT_Encode4(2441864), // Rule ID 45542 //
     /* 2441786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2441789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2441802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441822 */     // MIs[1] Operand 1
     /* 2441822 */     // No operand predicates
     /* 2441822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441826 */     // MIs[0] policy
     /* 2441826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441838 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2441841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441850 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441863 */     // GIR_Coverage, 45542,
     /* 2441863 */     GIR_EraseRootFromParent_Done,
     /* 2441864 */   // Label 35312: @2441864
     /* 2441864 */   GIM_Try, /*On fail goto*//*Label 35313*/ GIMT_Encode4(2441947), // Rule ID 45543 //
     /* 2441869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2441872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2441885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441905 */     // MIs[1] Operand 1
     /* 2441905 */     // No operand predicates
     /* 2441905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441909 */     // MIs[0] policy
     /* 2441909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441921 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2441924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441946 */     // GIR_Coverage, 45543,
     /* 2441946 */     GIR_EraseRootFromParent_Done,
     /* 2441947 */   // Label 35313: @2441947
     /* 2441947 */   GIM_Try, /*On fail goto*//*Label 35314*/ GIMT_Encode4(2442030), // Rule ID 45602 //
     /* 2441952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2441955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2441968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441988 */     // MIs[1] Operand 1
     /* 2441988 */     // No operand predicates
     /* 2441988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441992 */     // MIs[0] policy
     /* 2441992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442004 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2442007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442016 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2442026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442029 */     // GIR_Coverage, 45602,
     /* 2442029 */     GIR_EraseRootFromParent_Done,
     /* 2442030 */   // Label 35314: @2442030
     /* 2442030 */   GIM_Try, /*On fail goto*//*Label 35315*/ GIMT_Encode4(2442113), // Rule ID 45603 //
     /* 2442035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2442038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2442044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2442051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442071 */     // MIs[1] Operand 1
     /* 2442071 */     // No operand predicates
     /* 2442071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442075 */     // MIs[0] policy
     /* 2442075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442087 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2442090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2442109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442112 */     // GIR_Coverage, 45603,
     /* 2442112 */     GIR_EraseRootFromParent_Done,
     /* 2442113 */   // Label 35315: @2442113
     /* 2442113 */   GIM_Try, /*On fail goto*//*Label 35316*/ GIMT_Encode4(2442185), // Rule ID 45544 //
     /* 2442118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2442121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2442127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2442134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442150 */     // MIs[0] policy
     /* 2442150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442160 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2442163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2442181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442184 */     // GIR_Coverage, 45544,
     /* 2442184 */     GIR_EraseRootFromParent_Done,
     /* 2442185 */   // Label 35316: @2442185
     /* 2442185 */   GIM_Try, /*On fail goto*//*Label 35317*/ GIMT_Encode4(2442257), // Rule ID 45545 //
     /* 2442190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2442193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2442199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2442206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442222 */     // MIs[0] policy
     /* 2442222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442232 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2442235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2442253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442256 */     // GIR_Coverage, 45545,
     /* 2442256 */     GIR_EraseRootFromParent_Done,
     /* 2442257 */   // Label 35317: @2442257
     /* 2442257 */   GIM_Try, /*On fail goto*//*Label 35318*/ GIMT_Encode4(2442329), // Rule ID 45604 //
     /* 2442262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2442265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2442271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2442278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442294 */     // MIs[0] policy
     /* 2442294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442304 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2442307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2442325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442328 */     // GIR_Coverage, 45604,
     /* 2442328 */     GIR_EraseRootFromParent_Done,
     /* 2442329 */   // Label 35318: @2442329
     /* 2442329 */   GIM_Try, /*On fail goto*//*Label 35319*/ GIMT_Encode4(2442401), // Rule ID 45605 //
     /* 2442334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2442337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2442343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2442350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442366 */     // MIs[0] policy
     /* 2442366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442376 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2442379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2442397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442400 */     // GIR_Coverage, 45605,
     /* 2442400 */     GIR_EraseRootFromParent_Done,
     /* 2442401 */   // Label 35319: @2442401
     /* 2442401 */   GIM_Reject,
     /* 2442402 */ // Label 35311: @2442402
     /* 2442402 */ GIM_Reject,
     /* 2442403 */ // Label 35185: @2442403
     /* 2442403 */ GIM_Try, /*On fail goto*//*Label 35320*/ GIMT_Encode4(2442725),
     /* 2442408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2442411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2442414 */   GIM_Try, /*On fail goto*//*Label 35321*/ GIMT_Encode4(2442497), // Rule ID 45498 //
     /* 2442419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2442435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442455 */     // MIs[1] Operand 1
     /* 2442455 */     // No operand predicates
     /* 2442455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442459 */     // MIs[0] policy
     /* 2442459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442471 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2442474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2442493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442496 */     // GIR_Coverage, 45498,
     /* 2442496 */     GIR_EraseRootFromParent_Done,
     /* 2442497 */   // Label 35321: @2442497
     /* 2442497 */   GIM_Try, /*On fail goto*//*Label 35322*/ GIMT_Encode4(2442580), // Rule ID 45499 //
     /* 2442502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2442518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442538 */     // MIs[1] Operand 1
     /* 2442538 */     // No operand predicates
     /* 2442538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442542 */     // MIs[0] policy
     /* 2442542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442554 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2442557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442566 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2442576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442579 */     // GIR_Coverage, 45499,
     /* 2442579 */     GIR_EraseRootFromParent_Done,
     /* 2442580 */   // Label 35322: @2442580
     /* 2442580 */   GIM_Try, /*On fail goto*//*Label 35323*/ GIMT_Encode4(2442652), // Rule ID 45500 //
     /* 2442585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2442601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442617 */     // MIs[0] policy
     /* 2442617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442627 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2442630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442638 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2442648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442651 */     // GIR_Coverage, 45500,
     /* 2442651 */     GIR_EraseRootFromParent_Done,
     /* 2442652 */   // Label 35323: @2442652
     /* 2442652 */   GIM_Try, /*On fail goto*//*Label 35324*/ GIMT_Encode4(2442724), // Rule ID 45501 //
     /* 2442657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2442673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442689 */     // MIs[0] policy
     /* 2442689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442699 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2442702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442710 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2442720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442723 */     // GIR_Coverage, 45501,
     /* 2442723 */     GIR_EraseRootFromParent_Done,
     /* 2442724 */   // Label 35324: @2442724
     /* 2442724 */   GIM_Reject,
     /* 2442725 */ // Label 35320: @2442725
     /* 2442725 */ GIM_Reject,
     /* 2442726 */ // Label 35186: @2442726
     /* 2442726 */ GIM_Try, /*On fail goto*//*Label 35325*/ GIMT_Encode4(2443358),
     /* 2442731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2442734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2442737 */   GIM_Try, /*On fail goto*//*Label 35326*/ GIMT_Encode4(2442820), // Rule ID 45514 //
     /* 2442742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2442758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2442762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2442766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442778 */     // MIs[1] Operand 1
     /* 2442778 */     // No operand predicates
     /* 2442778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442782 */     // MIs[0] policy
     /* 2442782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442794 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2442797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442806 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442819 */     // GIR_Coverage, 45514,
     /* 2442819 */     GIR_EraseRootFromParent_Done,
     /* 2442820 */   // Label 35326: @2442820
     /* 2442820 */   GIM_Try, /*On fail goto*//*Label 35327*/ GIMT_Encode4(2442903), // Rule ID 45515 //
     /* 2442825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2442841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2442845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2442849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442861 */     // MIs[1] Operand 1
     /* 2442861 */     // No operand predicates
     /* 2442861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442865 */     // MIs[0] policy
     /* 2442865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442877 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2442880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442902 */     // GIR_Coverage, 45515,
     /* 2442902 */     GIR_EraseRootFromParent_Done,
     /* 2442903 */   // Label 35327: @2442903
     /* 2442903 */   GIM_Try, /*On fail goto*//*Label 35328*/ GIMT_Encode4(2442986), // Rule ID 45574 //
     /* 2442908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2442924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2442928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2442932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442944 */     // MIs[1] Operand 1
     /* 2442944 */     // No operand predicates
     /* 2442944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442948 */     // MIs[0] policy
     /* 2442948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442960 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2442963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442985 */     // GIR_Coverage, 45574,
     /* 2442985 */     GIR_EraseRootFromParent_Done,
     /* 2442986 */   // Label 35328: @2442986
     /* 2442986 */   GIM_Try, /*On fail goto*//*Label 35329*/ GIMT_Encode4(2443069), // Rule ID 45575 //
     /* 2442991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2443007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443027 */     // MIs[1] Operand 1
     /* 2443027 */     // No operand predicates
     /* 2443027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443031 */     // MIs[0] policy
     /* 2443031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443043 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2443046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2443065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443068 */     // GIR_Coverage, 45575,
     /* 2443068 */     GIR_EraseRootFromParent_Done,
     /* 2443069 */   // Label 35329: @2443069
     /* 2443069 */   GIM_Try, /*On fail goto*//*Label 35330*/ GIMT_Encode4(2443141), // Rule ID 45516 //
     /* 2443074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2443090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443106 */     // MIs[0] policy
     /* 2443106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443116 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2443119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2443137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443140 */     // GIR_Coverage, 45516,
     /* 2443140 */     GIR_EraseRootFromParent_Done,
     /* 2443141 */   // Label 35330: @2443141
     /* 2443141 */   GIM_Try, /*On fail goto*//*Label 35331*/ GIMT_Encode4(2443213), // Rule ID 45517 //
     /* 2443146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2443162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443178 */     // MIs[0] policy
     /* 2443178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443188 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2443191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2443209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443212 */     // GIR_Coverage, 45517,
     /* 2443212 */     GIR_EraseRootFromParent_Done,
     /* 2443213 */   // Label 35331: @2443213
     /* 2443213 */   GIM_Try, /*On fail goto*//*Label 35332*/ GIMT_Encode4(2443285), // Rule ID 45576 //
     /* 2443218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2443234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443250 */     // MIs[0] policy
     /* 2443250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443260 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2443263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2443281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443284 */     // GIR_Coverage, 45576,
     /* 2443284 */     GIR_EraseRootFromParent_Done,
     /* 2443285 */   // Label 35332: @2443285
     /* 2443285 */   GIM_Try, /*On fail goto*//*Label 35333*/ GIMT_Encode4(2443357), // Rule ID 45577 //
     /* 2443290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2443306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443322 */     // MIs[0] policy
     /* 2443322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443332 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2443335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443343 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2443353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443356 */     // GIR_Coverage, 45577,
     /* 2443356 */     GIR_EraseRootFromParent_Done,
     /* 2443357 */   // Label 35333: @2443357
     /* 2443357 */   GIM_Reject,
     /* 2443358 */ // Label 35325: @2443358
     /* 2443358 */ GIM_Reject,
     /* 2443359 */ // Label 35187: @2443359
     /* 2443359 */ GIM_Try, /*On fail goto*//*Label 35334*/ GIMT_Encode4(2443991),
     /* 2443364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2443367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2443370 */   GIM_Try, /*On fail goto*//*Label 35335*/ GIMT_Encode4(2443453), // Rule ID 45530 //
     /* 2443375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443411 */     // MIs[1] Operand 1
     /* 2443411 */     // No operand predicates
     /* 2443411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443415 */     // MIs[0] policy
     /* 2443415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443427 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2443430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443452 */     // GIR_Coverage, 45530,
     /* 2443452 */     GIR_EraseRootFromParent_Done,
     /* 2443453 */   // Label 35335: @2443453
     /* 2443453 */   GIM_Try, /*On fail goto*//*Label 35336*/ GIMT_Encode4(2443536), // Rule ID 45531 //
     /* 2443458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443494 */     // MIs[1] Operand 1
     /* 2443494 */     // No operand predicates
     /* 2443494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443498 */     // MIs[0] policy
     /* 2443498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443510 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2443513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443522 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443535 */     // GIR_Coverage, 45531,
     /* 2443535 */     GIR_EraseRootFromParent_Done,
     /* 2443536 */   // Label 35336: @2443536
     /* 2443536 */   GIM_Try, /*On fail goto*//*Label 35337*/ GIMT_Encode4(2443619), // Rule ID 45590 //
     /* 2443541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443577 */     // MIs[1] Operand 1
     /* 2443577 */     // No operand predicates
     /* 2443577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443581 */     // MIs[0] policy
     /* 2443581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443593 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2443596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443618 */     // GIR_Coverage, 45590,
     /* 2443618 */     GIR_EraseRootFromParent_Done,
     /* 2443619 */   // Label 35337: @2443619
     /* 2443619 */   GIM_Try, /*On fail goto*//*Label 35338*/ GIMT_Encode4(2443702), // Rule ID 45591 //
     /* 2443624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443660 */     // MIs[1] Operand 1
     /* 2443660 */     // No operand predicates
     /* 2443660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443664 */     // MIs[0] policy
     /* 2443664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443676 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2443679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443688 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443701 */     // GIR_Coverage, 45591,
     /* 2443701 */     GIR_EraseRootFromParent_Done,
     /* 2443702 */   // Label 35338: @2443702
     /* 2443702 */   GIM_Try, /*On fail goto*//*Label 35339*/ GIMT_Encode4(2443774), // Rule ID 45532 //
     /* 2443707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443739 */     // MIs[0] policy
     /* 2443739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443749 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2443752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443760 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443773 */     // GIR_Coverage, 45532,
     /* 2443773 */     GIR_EraseRootFromParent_Done,
     /* 2443774 */   // Label 35339: @2443774
     /* 2443774 */   GIM_Try, /*On fail goto*//*Label 35340*/ GIMT_Encode4(2443846), // Rule ID 45533 //
     /* 2443779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443811 */     // MIs[0] policy
     /* 2443811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443821 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2443824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443832 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443842 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443845 */     // GIR_Coverage, 45533,
     /* 2443845 */     GIR_EraseRootFromParent_Done,
     /* 2443846 */   // Label 35340: @2443846
     /* 2443846 */   GIM_Try, /*On fail goto*//*Label 35341*/ GIMT_Encode4(2443918), // Rule ID 45592 //
     /* 2443851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443883 */     // MIs[0] policy
     /* 2443883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443893 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2443896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443904 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443917 */     // GIR_Coverage, 45592,
     /* 2443917 */     GIR_EraseRootFromParent_Done,
     /* 2443918 */   // Label 35341: @2443918
     /* 2443918 */   GIM_Try, /*On fail goto*//*Label 35342*/ GIMT_Encode4(2443990), // Rule ID 45593 //
     /* 2443923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443955 */     // MIs[0] policy
     /* 2443955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443965 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2443968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443976 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443986 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443989 */     // GIR_Coverage, 45593,
     /* 2443989 */     GIR_EraseRootFromParent_Done,
     /* 2443990 */   // Label 35342: @2443990
     /* 2443990 */   GIM_Reject,
     /* 2443991 */ // Label 35334: @2443991
     /* 2443991 */ GIM_Reject,
     /* 2443992 */ // Label 35188: @2443992
     /* 2443992 */ GIM_Try, /*On fail goto*//*Label 35343*/ GIMT_Encode4(2444314),
     /* 2443997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2444000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2444003 */   GIM_Try, /*On fail goto*//*Label 35344*/ GIMT_Encode4(2444086), // Rule ID 45502 //
     /* 2444008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2444024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444044 */     // MIs[1] Operand 1
     /* 2444044 */     // No operand predicates
     /* 2444044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444048 */     // MIs[0] policy
     /* 2444048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444060 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2444063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444072 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444085 */     // GIR_Coverage, 45502,
     /* 2444085 */     GIR_EraseRootFromParent_Done,
     /* 2444086 */   // Label 35344: @2444086
     /* 2444086 */   GIM_Try, /*On fail goto*//*Label 35345*/ GIMT_Encode4(2444169), // Rule ID 45503 //
     /* 2444091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2444107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444127 */     // MIs[1] Operand 1
     /* 2444127 */     // No operand predicates
     /* 2444127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444131 */     // MIs[0] policy
     /* 2444131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444143 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2444146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444155 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444168 */     // GIR_Coverage, 45503,
     /* 2444168 */     GIR_EraseRootFromParent_Done,
     /* 2444169 */   // Label 35345: @2444169
     /* 2444169 */   GIM_Try, /*On fail goto*//*Label 35346*/ GIMT_Encode4(2444241), // Rule ID 45504 //
     /* 2444174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2444190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444206 */     // MIs[0] policy
     /* 2444206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444216 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2444219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444240 */     // GIR_Coverage, 45504,
     /* 2444240 */     GIR_EraseRootFromParent_Done,
     /* 2444241 */   // Label 35346: @2444241
     /* 2444241 */   GIM_Try, /*On fail goto*//*Label 35347*/ GIMT_Encode4(2444313), // Rule ID 45505 //
     /* 2444246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2444262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444278 */     // MIs[0] policy
     /* 2444278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444288 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2444291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444312 */     // GIR_Coverage, 45505,
     /* 2444312 */     GIR_EraseRootFromParent_Done,
     /* 2444313 */   // Label 35347: @2444313
     /* 2444313 */   GIM_Reject,
     /* 2444314 */ // Label 35343: @2444314
     /* 2444314 */ GIM_Reject,
     /* 2444315 */ // Label 35189: @2444315
     /* 2444315 */ GIM_Try, /*On fail goto*//*Label 35348*/ GIMT_Encode4(2444947),
     /* 2444320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2444323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2444326 */   GIM_Try, /*On fail goto*//*Label 35349*/ GIMT_Encode4(2444409), // Rule ID 45518 //
     /* 2444331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444367 */     // MIs[1] Operand 1
     /* 2444367 */     // No operand predicates
     /* 2444367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444371 */     // MIs[0] policy
     /* 2444371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444383 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2444386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444408 */     // GIR_Coverage, 45518,
     /* 2444408 */     GIR_EraseRootFromParent_Done,
     /* 2444409 */   // Label 35349: @2444409
     /* 2444409 */   GIM_Try, /*On fail goto*//*Label 35350*/ GIMT_Encode4(2444492), // Rule ID 45519 //
     /* 2444414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444450 */     // MIs[1] Operand 1
     /* 2444450 */     // No operand predicates
     /* 2444450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444454 */     // MIs[0] policy
     /* 2444454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444466 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2444469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444478 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444491 */     // GIR_Coverage, 45519,
     /* 2444491 */     GIR_EraseRootFromParent_Done,
     /* 2444492 */   // Label 35350: @2444492
     /* 2444492 */   GIM_Try, /*On fail goto*//*Label 35351*/ GIMT_Encode4(2444575), // Rule ID 45578 //
     /* 2444497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444533 */     // MIs[1] Operand 1
     /* 2444533 */     // No operand predicates
     /* 2444533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444537 */     // MIs[0] policy
     /* 2444537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444549 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2444552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444574 */     // GIR_Coverage, 45578,
     /* 2444574 */     GIR_EraseRootFromParent_Done,
     /* 2444575 */   // Label 35351: @2444575
     /* 2444575 */   GIM_Try, /*On fail goto*//*Label 35352*/ GIMT_Encode4(2444658), // Rule ID 45579 //
     /* 2444580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444616 */     // MIs[1] Operand 1
     /* 2444616 */     // No operand predicates
     /* 2444616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444620 */     // MIs[0] policy
     /* 2444620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444632 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2444635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444644 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444657 */     // GIR_Coverage, 45579,
     /* 2444657 */     GIR_EraseRootFromParent_Done,
     /* 2444658 */   // Label 35352: @2444658
     /* 2444658 */   GIM_Try, /*On fail goto*//*Label 35353*/ GIMT_Encode4(2444730), // Rule ID 45520 //
     /* 2444663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444695 */     // MIs[0] policy
     /* 2444695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444705 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2444708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444729 */     // GIR_Coverage, 45520,
     /* 2444729 */     GIR_EraseRootFromParent_Done,
     /* 2444730 */   // Label 35353: @2444730
     /* 2444730 */   GIM_Try, /*On fail goto*//*Label 35354*/ GIMT_Encode4(2444802), // Rule ID 45521 //
     /* 2444735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444767 */     // MIs[0] policy
     /* 2444767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444777 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2444780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444801 */     // GIR_Coverage, 45521,
     /* 2444801 */     GIR_EraseRootFromParent_Done,
     /* 2444802 */   // Label 35354: @2444802
     /* 2444802 */   GIM_Try, /*On fail goto*//*Label 35355*/ GIMT_Encode4(2444874), // Rule ID 45580 //
     /* 2444807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444839 */     // MIs[0] policy
     /* 2444839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444849 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2444852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444873 */     // GIR_Coverage, 45580,
     /* 2444873 */     GIR_EraseRootFromParent_Done,
     /* 2444874 */   // Label 35355: @2444874
     /* 2444874 */   GIM_Try, /*On fail goto*//*Label 35356*/ GIMT_Encode4(2444946), // Rule ID 45581 //
     /* 2444879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444911 */     // MIs[0] policy
     /* 2444911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444921 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2444924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444932 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444945 */     // GIR_Coverage, 45581,
     /* 2444945 */     GIR_EraseRootFromParent_Done,
     /* 2444946 */   // Label 35356: @2444946
     /* 2444946 */   GIM_Reject,
     /* 2444947 */ // Label 35348: @2444947
     /* 2444947 */ GIM_Reject,
     /* 2444948 */ // Label 35190: @2444948
     /* 2444948 */ GIM_Try, /*On fail goto*//*Label 35357*/ GIMT_Encode4(2445270),
     /* 2444953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2444956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2444959 */   GIM_Try, /*On fail goto*//*Label 35358*/ GIMT_Encode4(2445042), // Rule ID 45506 //
     /* 2444964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2444973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445000 */     // MIs[1] Operand 1
     /* 2445000 */     // No operand predicates
     /* 2445000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445004 */     // MIs[0] policy
     /* 2445004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445016 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2445019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445028 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445041 */     // GIR_Coverage, 45506,
     /* 2445041 */     GIR_EraseRootFromParent_Done,
     /* 2445042 */   // Label 35358: @2445042
     /* 2445042 */   GIM_Try, /*On fail goto*//*Label 35359*/ GIMT_Encode4(2445125), // Rule ID 45507 //
     /* 2445047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2445056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2445063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2445067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2445071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445083 */     // MIs[1] Operand 1
     /* 2445083 */     // No operand predicates
     /* 2445083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445087 */     // MIs[0] policy
     /* 2445087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445099 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2445102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445124 */     // GIR_Coverage, 45507,
     /* 2445124 */     GIR_EraseRootFromParent_Done,
     /* 2445125 */   // Label 35359: @2445125
     /* 2445125 */   GIM_Try, /*On fail goto*//*Label 35360*/ GIMT_Encode4(2445197), // Rule ID 45508 //
     /* 2445130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2445139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2445146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2445150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2445154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445162 */     // MIs[0] policy
     /* 2445162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445172 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2445175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445196 */     // GIR_Coverage, 45508,
     /* 2445196 */     GIR_EraseRootFromParent_Done,
     /* 2445197 */   // Label 35360: @2445197
     /* 2445197 */   GIM_Try, /*On fail goto*//*Label 35361*/ GIMT_Encode4(2445269), // Rule ID 45509 //
     /* 2445202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2445211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2445218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2445222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2445226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445234 */     // MIs[0] policy
     /* 2445234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445244 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2445247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445268 */     // GIR_Coverage, 45509,
     /* 2445268 */     GIR_EraseRootFromParent_Done,
     /* 2445269 */   // Label 35361: @2445269
     /* 2445269 */   GIM_Reject,
     /* 2445270 */ // Label 35357: @2445270
     /* 2445270 */ GIM_Reject,
     /* 2445271 */ // Label 35191: @2445271
     /* 2445271 */ GIM_Reject,
     /* 2445272 */ // Label 124: @2445272
     /* 2445272 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35384*/ GIMT_Encode4(2457151),
     /* 2445283 */ /*GILLT_nxv1s8*//*Label 35362*/ GIMT_Encode4(2445395),
     /* 2445287 */ /*GILLT_nxv1s16*//*Label 35363*/ GIMT_Encode4(2445718),
     /* 2445291 */ /*GILLT_nxv1s32*//*Label 35364*/ GIMT_Encode4(2446351),
     /* 2445295 */ /*GILLT_nxv1s64*//*Label 35365*/ GIMT_Encode4(2446984), GIMT_Encode4(0),
     /* 2445303 */ /*GILLT_nxv2s8*//*Label 35366*/ GIMT_Encode4(2447617),
     /* 2445307 */ /*GILLT_nxv2s16*//*Label 35367*/ GIMT_Encode4(2447940),
     /* 2445311 */ /*GILLT_nxv2s32*//*Label 35368*/ GIMT_Encode4(2448573),
     /* 2445315 */ /*GILLT_nxv2s64*//*Label 35369*/ GIMT_Encode4(2449206), GIMT_Encode4(0),
     /* 2445323 */ /*GILLT_nxv4s8*//*Label 35370*/ GIMT_Encode4(2449839),
     /* 2445327 */ /*GILLT_nxv4s16*//*Label 35371*/ GIMT_Encode4(2450162),
     /* 2445331 */ /*GILLT_nxv4s32*//*Label 35372*/ GIMT_Encode4(2450795),
     /* 2445335 */ /*GILLT_nxv4s64*//*Label 35373*/ GIMT_Encode4(2451428), GIMT_Encode4(0),
     /* 2445343 */ /*GILLT_nxv8s8*//*Label 35374*/ GIMT_Encode4(2452061),
     /* 2445347 */ /*GILLT_nxv8s16*//*Label 35375*/ GIMT_Encode4(2452384),
     /* 2445351 */ /*GILLT_nxv8s32*//*Label 35376*/ GIMT_Encode4(2453017),
     /* 2445355 */ /*GILLT_nxv8s64*//*Label 35377*/ GIMT_Encode4(2453650), GIMT_Encode4(0),
     /* 2445363 */ /*GILLT_nxv16s8*//*Label 35378*/ GIMT_Encode4(2454283),
     /* 2445367 */ /*GILLT_nxv16s16*//*Label 35379*/ GIMT_Encode4(2454606),
     /* 2445371 */ /*GILLT_nxv16s32*//*Label 35380*/ GIMT_Encode4(2455239), GIMT_Encode4(0),
     /* 2445379 */ /*GILLT_nxv32s8*//*Label 35381*/ GIMT_Encode4(2455872),
     /* 2445383 */ /*GILLT_nxv32s16*//*Label 35382*/ GIMT_Encode4(2456195), GIMT_Encode4(0),
     /* 2445391 */ /*GILLT_nxv64s8*//*Label 35383*/ GIMT_Encode4(2456828),
     /* 2445395 */ // Label 35362: @2445395
     /* 2445395 */ GIM_Try, /*On fail goto*//*Label 35385*/ GIMT_Encode4(2445717),
     /* 2445400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2445403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2445406 */   GIM_Try, /*On fail goto*//*Label 35386*/ GIMT_Encode4(2445489), // Rule ID 25372 //
     /* 2445411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445447 */     // MIs[1] Operand 1
     /* 2445447 */     // No operand predicates
     /* 2445447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445451 */     // MIs[0] policy
     /* 2445451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445463 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2445466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445488 */     // GIR_Coverage, 25372,
     /* 2445488 */     GIR_EraseRootFromParent_Done,
     /* 2445489 */   // Label 35386: @2445489
     /* 2445489 */   GIM_Try, /*On fail goto*//*Label 35387*/ GIMT_Encode4(2445572), // Rule ID 25373 //
     /* 2445494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445530 */     // MIs[1] Operand 1
     /* 2445530 */     // No operand predicates
     /* 2445530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445534 */     // MIs[0] policy
     /* 2445534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445546 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2445549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445571 */     // GIR_Coverage, 25373,
     /* 2445571 */     GIR_EraseRootFromParent_Done,
     /* 2445572 */   // Label 35387: @2445572
     /* 2445572 */   GIM_Try, /*On fail goto*//*Label 35388*/ GIMT_Encode4(2445644), // Rule ID 25374 //
     /* 2445577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445609 */     // MIs[0] policy
     /* 2445609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445619 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2445622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445630 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445643 */     // GIR_Coverage, 25374,
     /* 2445643 */     GIR_EraseRootFromParent_Done,
     /* 2445644 */   // Label 35388: @2445644
     /* 2445644 */   GIM_Try, /*On fail goto*//*Label 35389*/ GIMT_Encode4(2445716), // Rule ID 25375 //
     /* 2445649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445681 */     // MIs[0] policy
     /* 2445681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445691 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2445694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445715 */     // GIR_Coverage, 25375,
     /* 2445715 */     GIR_EraseRootFromParent_Done,
     /* 2445716 */   // Label 35389: @2445716
     /* 2445716 */   GIM_Reject,
     /* 2445717 */ // Label 35385: @2445717
     /* 2445717 */ GIM_Reject,
     /* 2445718 */ // Label 35363: @2445718
     /* 2445718 */ GIM_Try, /*On fail goto*//*Label 35390*/ GIMT_Encode4(2446350),
     /* 2445723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2445726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2445729 */   GIM_Try, /*On fail goto*//*Label 35391*/ GIMT_Encode4(2445812), // Rule ID 45322 //
     /* 2445734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445770 */     // MIs[1] Operand 1
     /* 2445770 */     // No operand predicates
     /* 2445770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445774 */     // MIs[0] policy
     /* 2445774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445786 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2445789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445798 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2445808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445811 */     // GIR_Coverage, 45322,
     /* 2445811 */     GIR_EraseRootFromParent_Done,
     /* 2445812 */   // Label 35391: @2445812
     /* 2445812 */   GIM_Try, /*On fail goto*//*Label 35392*/ GIMT_Encode4(2445895), // Rule ID 45323 //
     /* 2445817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445853 */     // MIs[1] Operand 1
     /* 2445853 */     // No operand predicates
     /* 2445853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445857 */     // MIs[0] policy
     /* 2445857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445869 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2445872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2445891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445894 */     // GIR_Coverage, 45323,
     /* 2445894 */     GIR_EraseRootFromParent_Done,
     /* 2445895 */   // Label 35392: @2445895
     /* 2445895 */   GIM_Try, /*On fail goto*//*Label 35393*/ GIMT_Encode4(2445978), // Rule ID 45398 //
     /* 2445900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445936 */     // MIs[1] Operand 1
     /* 2445936 */     // No operand predicates
     /* 2445936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445940 */     // MIs[0] policy
     /* 2445940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445952 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2445955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445964 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2445974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445977 */     // GIR_Coverage, 45398,
     /* 2445977 */     GIR_EraseRootFromParent_Done,
     /* 2445978 */   // Label 35393: @2445978
     /* 2445978 */   GIM_Try, /*On fail goto*//*Label 35394*/ GIMT_Encode4(2446061), // Rule ID 45399 //
     /* 2445983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446019 */     // MIs[1] Operand 1
     /* 2446019 */     // No operand predicates
     /* 2446019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446023 */     // MIs[0] policy
     /* 2446023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446035 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2446038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446060 */     // GIR_Coverage, 45399,
     /* 2446060 */     GIR_EraseRootFromParent_Done,
     /* 2446061 */   // Label 35394: @2446061
     /* 2446061 */   GIM_Try, /*On fail goto*//*Label 35395*/ GIMT_Encode4(2446133), // Rule ID 45324 //
     /* 2446066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446098 */     // MIs[0] policy
     /* 2446098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446108 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2446111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446132 */     // GIR_Coverage, 45324,
     /* 2446132 */     GIR_EraseRootFromParent_Done,
     /* 2446133 */   // Label 35395: @2446133
     /* 2446133 */   GIM_Try, /*On fail goto*//*Label 35396*/ GIMT_Encode4(2446205), // Rule ID 45325 //
     /* 2446138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446170 */     // MIs[0] policy
     /* 2446170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446180 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2446183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446204 */     // GIR_Coverage, 45325,
     /* 2446204 */     GIR_EraseRootFromParent_Done,
     /* 2446205 */   // Label 35396: @2446205
     /* 2446205 */   GIM_Try, /*On fail goto*//*Label 35397*/ GIMT_Encode4(2446277), // Rule ID 45400 //
     /* 2446210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446242 */     // MIs[0] policy
     /* 2446242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446252 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2446255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446276 */     // GIR_Coverage, 45400,
     /* 2446276 */     GIR_EraseRootFromParent_Done,
     /* 2446277 */   // Label 35397: @2446277
     /* 2446277 */   GIM_Try, /*On fail goto*//*Label 35398*/ GIMT_Encode4(2446349), // Rule ID 45401 //
     /* 2446282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446314 */     // MIs[0] policy
     /* 2446314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446324 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2446327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446348 */     // GIR_Coverage, 45401,
     /* 2446348 */     GIR_EraseRootFromParent_Done,
     /* 2446349 */   // Label 35398: @2446349
     /* 2446349 */   GIM_Reject,
     /* 2446350 */ // Label 35390: @2446350
     /* 2446350 */ GIM_Reject,
     /* 2446351 */ // Label 35364: @2446351
     /* 2446351 */ GIM_Try, /*On fail goto*//*Label 35399*/ GIMT_Encode4(2446983),
     /* 2446356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2446359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2446362 */   GIM_Try, /*On fail goto*//*Label 35400*/ GIMT_Encode4(2446445), // Rule ID 45330 //
     /* 2446367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446403 */     // MIs[1] Operand 1
     /* 2446403 */     // No operand predicates
     /* 2446403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446407 */     // MIs[0] policy
     /* 2446407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446419 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2446422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446444 */     // GIR_Coverage, 45330,
     /* 2446444 */     GIR_EraseRootFromParent_Done,
     /* 2446445 */   // Label 35400: @2446445
     /* 2446445 */   GIM_Try, /*On fail goto*//*Label 35401*/ GIMT_Encode4(2446528), // Rule ID 45331 //
     /* 2446450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446486 */     // MIs[1] Operand 1
     /* 2446486 */     // No operand predicates
     /* 2446486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446490 */     // MIs[0] policy
     /* 2446490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446502 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2446505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446514 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446527 */     // GIR_Coverage, 45331,
     /* 2446527 */     GIR_EraseRootFromParent_Done,
     /* 2446528 */   // Label 35401: @2446528
     /* 2446528 */   GIM_Try, /*On fail goto*//*Label 35402*/ GIMT_Encode4(2446611), // Rule ID 45406 //
     /* 2446533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446569 */     // MIs[1] Operand 1
     /* 2446569 */     // No operand predicates
     /* 2446569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446573 */     // MIs[0] policy
     /* 2446573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446585 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2446588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446610 */     // GIR_Coverage, 45406,
     /* 2446610 */     GIR_EraseRootFromParent_Done,
     /* 2446611 */   // Label 35402: @2446611
     /* 2446611 */   GIM_Try, /*On fail goto*//*Label 35403*/ GIMT_Encode4(2446694), // Rule ID 45407 //
     /* 2446616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446652 */     // MIs[1] Operand 1
     /* 2446652 */     // No operand predicates
     /* 2446652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446656 */     // MIs[0] policy
     /* 2446656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446668 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2446671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446680 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446693 */     // GIR_Coverage, 45407,
     /* 2446693 */     GIR_EraseRootFromParent_Done,
     /* 2446694 */   // Label 35403: @2446694
     /* 2446694 */   GIM_Try, /*On fail goto*//*Label 35404*/ GIMT_Encode4(2446766), // Rule ID 45332 //
     /* 2446699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446731 */     // MIs[0] policy
     /* 2446731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446741 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2446744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446752 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446765 */     // GIR_Coverage, 45332,
     /* 2446765 */     GIR_EraseRootFromParent_Done,
     /* 2446766 */   // Label 35404: @2446766
     /* 2446766 */   GIM_Try, /*On fail goto*//*Label 35405*/ GIMT_Encode4(2446838), // Rule ID 45333 //
     /* 2446771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446803 */     // MIs[0] policy
     /* 2446803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446813 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2446816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446824 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446837 */     // GIR_Coverage, 45333,
     /* 2446837 */     GIR_EraseRootFromParent_Done,
     /* 2446838 */   // Label 35405: @2446838
     /* 2446838 */   GIM_Try, /*On fail goto*//*Label 35406*/ GIMT_Encode4(2446910), // Rule ID 45408 //
     /* 2446843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446875 */     // MIs[0] policy
     /* 2446875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446885 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2446888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446909 */     // GIR_Coverage, 45408,
     /* 2446909 */     GIR_EraseRootFromParent_Done,
     /* 2446910 */   // Label 35406: @2446910
     /* 2446910 */   GIM_Try, /*On fail goto*//*Label 35407*/ GIMT_Encode4(2446982), // Rule ID 45409 //
     /* 2446915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446947 */     // MIs[0] policy
     /* 2446947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446957 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2446960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446968 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446981 */     // GIR_Coverage, 45409,
     /* 2446981 */     GIR_EraseRootFromParent_Done,
     /* 2446982 */   // Label 35407: @2446982
     /* 2446982 */   GIM_Reject,
     /* 2446983 */ // Label 35399: @2446983
     /* 2446983 */ GIM_Reject,
     /* 2446984 */ // Label 35365: @2446984
     /* 2446984 */ GIM_Try, /*On fail goto*//*Label 35408*/ GIMT_Encode4(2447616),
     /* 2446989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2446992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2446995 */   GIM_Try, /*On fail goto*//*Label 35409*/ GIMT_Encode4(2447078), // Rule ID 45346 //
     /* 2447000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447036 */     // MIs[1] Operand 1
     /* 2447036 */     // No operand predicates
     /* 2447036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447040 */     // MIs[0] policy
     /* 2447040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447052 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2447055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447064 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447077 */     // GIR_Coverage, 45346,
     /* 2447077 */     GIR_EraseRootFromParent_Done,
     /* 2447078 */   // Label 35409: @2447078
     /* 2447078 */   GIM_Try, /*On fail goto*//*Label 35410*/ GIMT_Encode4(2447161), // Rule ID 45347 //
     /* 2447083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447119 */     // MIs[1] Operand 1
     /* 2447119 */     // No operand predicates
     /* 2447119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447123 */     // MIs[0] policy
     /* 2447123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447135 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2447138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447160 */     // GIR_Coverage, 45347,
     /* 2447160 */     GIR_EraseRootFromParent_Done,
     /* 2447161 */   // Label 35410: @2447161
     /* 2447161 */   GIM_Try, /*On fail goto*//*Label 35411*/ GIMT_Encode4(2447244), // Rule ID 45418 //
     /* 2447166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447202 */     // MIs[1] Operand 1
     /* 2447202 */     // No operand predicates
     /* 2447202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447206 */     // MIs[0] policy
     /* 2447206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447218 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2447221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447230 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447243 */     // GIR_Coverage, 45418,
     /* 2447243 */     GIR_EraseRootFromParent_Done,
     /* 2447244 */   // Label 35411: @2447244
     /* 2447244 */   GIM_Try, /*On fail goto*//*Label 35412*/ GIMT_Encode4(2447327), // Rule ID 45419 //
     /* 2447249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447285 */     // MIs[1] Operand 1
     /* 2447285 */     // No operand predicates
     /* 2447285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447289 */     // MIs[0] policy
     /* 2447289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447301 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2447304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447326 */     // GIR_Coverage, 45419,
     /* 2447326 */     GIR_EraseRootFromParent_Done,
     /* 2447327 */   // Label 35412: @2447327
     /* 2447327 */   GIM_Try, /*On fail goto*//*Label 35413*/ GIMT_Encode4(2447399), // Rule ID 45348 //
     /* 2447332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447364 */     // MIs[0] policy
     /* 2447364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447374 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2447377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447398 */     // GIR_Coverage, 45348,
     /* 2447398 */     GIR_EraseRootFromParent_Done,
     /* 2447399 */   // Label 35413: @2447399
     /* 2447399 */   GIM_Try, /*On fail goto*//*Label 35414*/ GIMT_Encode4(2447471), // Rule ID 45349 //
     /* 2447404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447436 */     // MIs[0] policy
     /* 2447436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447446 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2447449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447470 */     // GIR_Coverage, 45349,
     /* 2447470 */     GIR_EraseRootFromParent_Done,
     /* 2447471 */   // Label 35414: @2447471
     /* 2447471 */   GIM_Try, /*On fail goto*//*Label 35415*/ GIMT_Encode4(2447543), // Rule ID 45420 //
     /* 2447476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447508 */     // MIs[0] policy
     /* 2447508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447518 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2447521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447542 */     // GIR_Coverage, 45420,
     /* 2447542 */     GIR_EraseRootFromParent_Done,
     /* 2447543 */   // Label 35415: @2447543
     /* 2447543 */   GIM_Try, /*On fail goto*//*Label 35416*/ GIMT_Encode4(2447615), // Rule ID 45421 //
     /* 2447548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447580 */     // MIs[0] policy
     /* 2447580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447590 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2447593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447614 */     // GIR_Coverage, 45421,
     /* 2447614 */     GIR_EraseRootFromParent_Done,
     /* 2447615 */   // Label 35416: @2447615
     /* 2447615 */   GIM_Reject,
     /* 2447616 */ // Label 35408: @2447616
     /* 2447616 */ GIM_Reject,
     /* 2447617 */ // Label 35366: @2447617
     /* 2447617 */ GIM_Try, /*On fail goto*//*Label 35417*/ GIMT_Encode4(2447939),
     /* 2447622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2447625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2447628 */   GIM_Try, /*On fail goto*//*Label 35418*/ GIMT_Encode4(2447711), // Rule ID 45314 //
     /* 2447633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2447642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447669 */     // MIs[1] Operand 1
     /* 2447669 */     // No operand predicates
     /* 2447669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447673 */     // MIs[0] policy
     /* 2447673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447685 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2447688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2447707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447710 */     // GIR_Coverage, 45314,
     /* 2447710 */     GIR_EraseRootFromParent_Done,
     /* 2447711 */   // Label 35418: @2447711
     /* 2447711 */   GIM_Try, /*On fail goto*//*Label 35419*/ GIMT_Encode4(2447794), // Rule ID 45315 //
     /* 2447716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2447725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447752 */     // MIs[1] Operand 1
     /* 2447752 */     // No operand predicates
     /* 2447752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447756 */     // MIs[0] policy
     /* 2447756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447768 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2447771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2447790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447793 */     // GIR_Coverage, 45315,
     /* 2447793 */     GIR_EraseRootFromParent_Done,
     /* 2447794 */   // Label 35419: @2447794
     /* 2447794 */   GIM_Try, /*On fail goto*//*Label 35420*/ GIMT_Encode4(2447866), // Rule ID 45316 //
     /* 2447799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2447808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447831 */     // MIs[0] policy
     /* 2447831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447841 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2447844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2447862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447865 */     // GIR_Coverage, 45316,
     /* 2447865 */     GIR_EraseRootFromParent_Done,
     /* 2447866 */   // Label 35420: @2447866
     /* 2447866 */   GIM_Try, /*On fail goto*//*Label 35421*/ GIMT_Encode4(2447938), // Rule ID 45317 //
     /* 2447871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2447880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447903 */     // MIs[0] policy
     /* 2447903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447913 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2447916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2447934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447937 */     // GIR_Coverage, 45317,
     /* 2447937 */     GIR_EraseRootFromParent_Done,
     /* 2447938 */   // Label 35421: @2447938
     /* 2447938 */   GIM_Reject,
     /* 2447939 */ // Label 35417: @2447939
     /* 2447939 */ GIM_Reject,
     /* 2447940 */ // Label 35367: @2447940
     /* 2447940 */ GIM_Try, /*On fail goto*//*Label 35422*/ GIMT_Encode4(2448572),
     /* 2447945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2447948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2447951 */   GIM_Try, /*On fail goto*//*Label 35423*/ GIMT_Encode4(2448034), // Rule ID 45326 //
     /* 2447956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2447965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447992 */     // MIs[1] Operand 1
     /* 2447992 */     // No operand predicates
     /* 2447992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447996 */     // MIs[0] policy
     /* 2447996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448008 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2448011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448033 */     // GIR_Coverage, 45326,
     /* 2448033 */     GIR_EraseRootFromParent_Done,
     /* 2448034 */   // Label 35423: @2448034
     /* 2448034 */   GIM_Try, /*On fail goto*//*Label 35424*/ GIMT_Encode4(2448117), // Rule ID 45327 //
     /* 2448039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448075 */     // MIs[1] Operand 1
     /* 2448075 */     // No operand predicates
     /* 2448075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448079 */     // MIs[0] policy
     /* 2448079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448091 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2448094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448116 */     // GIR_Coverage, 45327,
     /* 2448116 */     GIR_EraseRootFromParent_Done,
     /* 2448117 */   // Label 35424: @2448117
     /* 2448117 */   GIM_Try, /*On fail goto*//*Label 35425*/ GIMT_Encode4(2448200), // Rule ID 45402 //
     /* 2448122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448158 */     // MIs[1] Operand 1
     /* 2448158 */     // No operand predicates
     /* 2448158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448162 */     // MIs[0] policy
     /* 2448162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448174 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2448177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448186 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448199 */     // GIR_Coverage, 45402,
     /* 2448199 */     GIR_EraseRootFromParent_Done,
     /* 2448200 */   // Label 35425: @2448200
     /* 2448200 */   GIM_Try, /*On fail goto*//*Label 35426*/ GIMT_Encode4(2448283), // Rule ID 45403 //
     /* 2448205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448241 */     // MIs[1] Operand 1
     /* 2448241 */     // No operand predicates
     /* 2448241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448245 */     // MIs[0] policy
     /* 2448245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448257 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2448260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448282 */     // GIR_Coverage, 45403,
     /* 2448282 */     GIR_EraseRootFromParent_Done,
     /* 2448283 */   // Label 35426: @2448283
     /* 2448283 */   GIM_Try, /*On fail goto*//*Label 35427*/ GIMT_Encode4(2448355), // Rule ID 45328 //
     /* 2448288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448320 */     // MIs[0] policy
     /* 2448320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448330 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2448333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448354 */     // GIR_Coverage, 45328,
     /* 2448354 */     GIR_EraseRootFromParent_Done,
     /* 2448355 */   // Label 35427: @2448355
     /* 2448355 */   GIM_Try, /*On fail goto*//*Label 35428*/ GIMT_Encode4(2448427), // Rule ID 45329 //
     /* 2448360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448392 */     // MIs[0] policy
     /* 2448392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448402 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2448405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448426 */     // GIR_Coverage, 45329,
     /* 2448426 */     GIR_EraseRootFromParent_Done,
     /* 2448427 */   // Label 35428: @2448427
     /* 2448427 */   GIM_Try, /*On fail goto*//*Label 35429*/ GIMT_Encode4(2448499), // Rule ID 45404 //
     /* 2448432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448464 */     // MIs[0] policy
     /* 2448464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448474 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2448477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448498 */     // GIR_Coverage, 45404,
     /* 2448498 */     GIR_EraseRootFromParent_Done,
     /* 2448499 */   // Label 35429: @2448499
     /* 2448499 */   GIM_Try, /*On fail goto*//*Label 35430*/ GIMT_Encode4(2448571), // Rule ID 45405 //
     /* 2448504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448536 */     // MIs[0] policy
     /* 2448536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448546 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2448549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448570 */     // GIR_Coverage, 45405,
     /* 2448570 */     GIR_EraseRootFromParent_Done,
     /* 2448571 */   // Label 35430: @2448571
     /* 2448571 */   GIM_Reject,
     /* 2448572 */ // Label 35422: @2448572
     /* 2448572 */ GIM_Reject,
     /* 2448573 */ // Label 35368: @2448573
     /* 2448573 */ GIM_Try, /*On fail goto*//*Label 35431*/ GIMT_Encode4(2449205),
     /* 2448578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2448581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2448584 */   GIM_Try, /*On fail goto*//*Label 35432*/ GIMT_Encode4(2448667), // Rule ID 45342 //
     /* 2448589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448625 */     // MIs[1] Operand 1
     /* 2448625 */     // No operand predicates
     /* 2448625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448629 */     // MIs[0] policy
     /* 2448629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448641 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2448644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2448663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448666 */     // GIR_Coverage, 45342,
     /* 2448666 */     GIR_EraseRootFromParent_Done,
     /* 2448667 */   // Label 35432: @2448667
     /* 2448667 */   GIM_Try, /*On fail goto*//*Label 35433*/ GIMT_Encode4(2448750), // Rule ID 45343 //
     /* 2448672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448708 */     // MIs[1] Operand 1
     /* 2448708 */     // No operand predicates
     /* 2448708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448712 */     // MIs[0] policy
     /* 2448712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448724 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2448727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448736 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2448746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448749 */     // GIR_Coverage, 45343,
     /* 2448749 */     GIR_EraseRootFromParent_Done,
     /* 2448750 */   // Label 35433: @2448750
     /* 2448750 */   GIM_Try, /*On fail goto*//*Label 35434*/ GIMT_Encode4(2448833), // Rule ID 45414 //
     /* 2448755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448791 */     // MIs[1] Operand 1
     /* 2448791 */     // No operand predicates
     /* 2448791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448795 */     // MIs[0] policy
     /* 2448795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448807 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2448810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2448829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448832 */     // GIR_Coverage, 45414,
     /* 2448832 */     GIR_EraseRootFromParent_Done,
     /* 2448833 */   // Label 35434: @2448833
     /* 2448833 */   GIM_Try, /*On fail goto*//*Label 35435*/ GIMT_Encode4(2448916), // Rule ID 45415 //
     /* 2448838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448874 */     // MIs[1] Operand 1
     /* 2448874 */     // No operand predicates
     /* 2448874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448878 */     // MIs[0] policy
     /* 2448878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448890 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2448893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448902 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2448912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448915 */     // GIR_Coverage, 45415,
     /* 2448915 */     GIR_EraseRootFromParent_Done,
     /* 2448916 */   // Label 35435: @2448916
     /* 2448916 */   GIM_Try, /*On fail goto*//*Label 35436*/ GIMT_Encode4(2448988), // Rule ID 45344 //
     /* 2448921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448953 */     // MIs[0] policy
     /* 2448953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448963 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2448966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448974 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2448984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448987 */     // GIR_Coverage, 45344,
     /* 2448987 */     GIR_EraseRootFromParent_Done,
     /* 2448988 */   // Label 35436: @2448988
     /* 2448988 */   GIM_Try, /*On fail goto*//*Label 35437*/ GIMT_Encode4(2449060), // Rule ID 45345 //
     /* 2448993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2449009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449025 */     // MIs[0] policy
     /* 2449025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449035 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2449038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449046 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449059 */     // GIR_Coverage, 45345,
     /* 2449059 */     GIR_EraseRootFromParent_Done,
     /* 2449060 */   // Label 35437: @2449060
     /* 2449060 */   GIM_Try, /*On fail goto*//*Label 35438*/ GIMT_Encode4(2449132), // Rule ID 45416 //
     /* 2449065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2449081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449097 */     // MIs[0] policy
     /* 2449097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449107 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2449110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449118 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449131 */     // GIR_Coverage, 45416,
     /* 2449131 */     GIR_EraseRootFromParent_Done,
     /* 2449132 */   // Label 35438: @2449132
     /* 2449132 */   GIM_Try, /*On fail goto*//*Label 35439*/ GIMT_Encode4(2449204), // Rule ID 45417 //
     /* 2449137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2449153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449169 */     // MIs[0] policy
     /* 2449169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449179 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2449182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449190 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449203 */     // GIR_Coverage, 45417,
     /* 2449203 */     GIR_EraseRootFromParent_Done,
     /* 2449204 */   // Label 35439: @2449204
     /* 2449204 */   GIM_Reject,
     /* 2449205 */ // Label 35431: @2449205
     /* 2449205 */ GIM_Reject,
     /* 2449206 */ // Label 35369: @2449206
     /* 2449206 */ GIM_Try, /*On fail goto*//*Label 35440*/ GIMT_Encode4(2449838),
     /* 2449211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2449214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2449217 */   GIM_Try, /*On fail goto*//*Label 35441*/ GIMT_Encode4(2449300), // Rule ID 45386 //
     /* 2449222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2449225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449258 */     // MIs[1] Operand 1
     /* 2449258 */     // No operand predicates
     /* 2449258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449262 */     // MIs[0] policy
     /* 2449262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449274 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2449277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449286 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449299 */     // GIR_Coverage, 45386,
     /* 2449299 */     GIR_EraseRootFromParent_Done,
     /* 2449300 */   // Label 35441: @2449300
     /* 2449300 */   GIM_Try, /*On fail goto*//*Label 35442*/ GIMT_Encode4(2449383), // Rule ID 45387 //
     /* 2449305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2449308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449341 */     // MIs[1] Operand 1
     /* 2449341 */     // No operand predicates
     /* 2449341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449345 */     // MIs[0] policy
     /* 2449345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449357 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2449360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449382 */     // GIR_Coverage, 45387,
     /* 2449382 */     GIR_EraseRootFromParent_Done,
     /* 2449383 */   // Label 35442: @2449383
     /* 2449383 */   GIM_Try, /*On fail goto*//*Label 35443*/ GIMT_Encode4(2449466), // Rule ID 45446 //
     /* 2449388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2449391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449424 */     // MIs[1] Operand 1
     /* 2449424 */     // No operand predicates
     /* 2449424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449428 */     // MIs[0] policy
     /* 2449428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449440 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2449443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449465 */     // GIR_Coverage, 45446,
     /* 2449465 */     GIR_EraseRootFromParent_Done,
     /* 2449466 */   // Label 35443: @2449466
     /* 2449466 */   GIM_Try, /*On fail goto*//*Label 35444*/ GIMT_Encode4(2449549), // Rule ID 45447 //
     /* 2449471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2449474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449507 */     // MIs[1] Operand 1
     /* 2449507 */     // No operand predicates
     /* 2449507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449511 */     // MIs[0] policy
     /* 2449511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449523 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2449526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449548 */     // GIR_Coverage, 45447,
     /* 2449548 */     GIR_EraseRootFromParent_Done,
     /* 2449549 */   // Label 35444: @2449549
     /* 2449549 */   GIM_Try, /*On fail goto*//*Label 35445*/ GIMT_Encode4(2449621), // Rule ID 45388 //
     /* 2449554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2449557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449586 */     // MIs[0] policy
     /* 2449586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449596 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2449599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449620 */     // GIR_Coverage, 45388,
     /* 2449620 */     GIR_EraseRootFromParent_Done,
     /* 2449621 */   // Label 35445: @2449621
     /* 2449621 */   GIM_Try, /*On fail goto*//*Label 35446*/ GIMT_Encode4(2449693), // Rule ID 45389 //
     /* 2449626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2449629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449658 */     // MIs[0] policy
     /* 2449658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449668 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2449671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449692 */     // GIR_Coverage, 45389,
     /* 2449692 */     GIR_EraseRootFromParent_Done,
     /* 2449693 */   // Label 35446: @2449693
     /* 2449693 */   GIM_Try, /*On fail goto*//*Label 35447*/ GIMT_Encode4(2449765), // Rule ID 45448 //
     /* 2449698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2449701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449730 */     // MIs[0] policy
     /* 2449730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449740 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2449743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449764 */     // GIR_Coverage, 45448,
     /* 2449764 */     GIR_EraseRootFromParent_Done,
     /* 2449765 */   // Label 35447: @2449765
     /* 2449765 */   GIM_Try, /*On fail goto*//*Label 35448*/ GIMT_Encode4(2449837), // Rule ID 45449 //
     /* 2449770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2449773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449802 */     // MIs[0] policy
     /* 2449802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449812 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2449815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449836 */     // GIR_Coverage, 45449,
     /* 2449836 */     GIR_EraseRootFromParent_Done,
     /* 2449837 */   // Label 35448: @2449837
     /* 2449837 */   GIM_Reject,
     /* 2449838 */ // Label 35440: @2449838
     /* 2449838 */ GIM_Reject,
     /* 2449839 */ // Label 35370: @2449839
     /* 2449839 */ GIM_Try, /*On fail goto*//*Label 35449*/ GIMT_Encode4(2450161),
     /* 2449844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2449847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2449850 */   GIM_Try, /*On fail goto*//*Label 35450*/ GIMT_Encode4(2449933), // Rule ID 45318 //
     /* 2449855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2449864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2449871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449891 */     // MIs[1] Operand 1
     /* 2449891 */     // No operand predicates
     /* 2449891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449895 */     // MIs[0] policy
     /* 2449895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449907 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2449910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2449929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449932 */     // GIR_Coverage, 45318,
     /* 2449932 */     GIR_EraseRootFromParent_Done,
     /* 2449933 */   // Label 35450: @2449933
     /* 2449933 */   GIM_Try, /*On fail goto*//*Label 35451*/ GIMT_Encode4(2450016), // Rule ID 45319 //
     /* 2449938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2449947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2449954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449974 */     // MIs[1] Operand 1
     /* 2449974 */     // No operand predicates
     /* 2449974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449978 */     // MIs[0] policy
     /* 2449978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449990 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2449993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450002 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450015 */     // GIR_Coverage, 45319,
     /* 2450015 */     GIR_EraseRootFromParent_Done,
     /* 2450016 */   // Label 35451: @2450016
     /* 2450016 */   GIM_Try, /*On fail goto*//*Label 35452*/ GIMT_Encode4(2450088), // Rule ID 45320 //
     /* 2450021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450053 */     // MIs[0] policy
     /* 2450053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450063 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2450066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450087 */     // GIR_Coverage, 45320,
     /* 2450087 */     GIR_EraseRootFromParent_Done,
     /* 2450088 */   // Label 35452: @2450088
     /* 2450088 */   GIM_Try, /*On fail goto*//*Label 35453*/ GIMT_Encode4(2450160), // Rule ID 45321 //
     /* 2450093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450125 */     // MIs[0] policy
     /* 2450125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450135 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2450138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450146 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450159 */     // GIR_Coverage, 45321,
     /* 2450159 */     GIR_EraseRootFromParent_Done,
     /* 2450160 */   // Label 35453: @2450160
     /* 2450160 */   GIM_Reject,
     /* 2450161 */ // Label 35449: @2450161
     /* 2450161 */ GIM_Reject,
     /* 2450162 */ // Label 35371: @2450162
     /* 2450162 */ GIM_Try, /*On fail goto*//*Label 35454*/ GIMT_Encode4(2450794),
     /* 2450167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2450170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2450173 */   GIM_Try, /*On fail goto*//*Label 35455*/ GIMT_Encode4(2450256), // Rule ID 45338 //
     /* 2450178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450214 */     // MIs[1] Operand 1
     /* 2450214 */     // No operand predicates
     /* 2450214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450218 */     // MIs[0] policy
     /* 2450218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450230 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2450233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450242 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450255 */     // GIR_Coverage, 45338,
     /* 2450255 */     GIR_EraseRootFromParent_Done,
     /* 2450256 */   // Label 35455: @2450256
     /* 2450256 */   GIM_Try, /*On fail goto*//*Label 35456*/ GIMT_Encode4(2450339), // Rule ID 45339 //
     /* 2450261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450297 */     // MIs[1] Operand 1
     /* 2450297 */     // No operand predicates
     /* 2450297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450301 */     // MIs[0] policy
     /* 2450301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450313 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2450316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450338 */     // GIR_Coverage, 45339,
     /* 2450338 */     GIR_EraseRootFromParent_Done,
     /* 2450339 */   // Label 35456: @2450339
     /* 2450339 */   GIM_Try, /*On fail goto*//*Label 35457*/ GIMT_Encode4(2450422), // Rule ID 45410 //
     /* 2450344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450380 */     // MIs[1] Operand 1
     /* 2450380 */     // No operand predicates
     /* 2450380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450384 */     // MIs[0] policy
     /* 2450384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450396 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2450399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450421 */     // GIR_Coverage, 45410,
     /* 2450421 */     GIR_EraseRootFromParent_Done,
     /* 2450422 */   // Label 35457: @2450422
     /* 2450422 */   GIM_Try, /*On fail goto*//*Label 35458*/ GIMT_Encode4(2450505), // Rule ID 45411 //
     /* 2450427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450463 */     // MIs[1] Operand 1
     /* 2450463 */     // No operand predicates
     /* 2450463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450467 */     // MIs[0] policy
     /* 2450467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450479 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2450482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450504 */     // GIR_Coverage, 45411,
     /* 2450504 */     GIR_EraseRootFromParent_Done,
     /* 2450505 */   // Label 35458: @2450505
     /* 2450505 */   GIM_Try, /*On fail goto*//*Label 35459*/ GIMT_Encode4(2450577), // Rule ID 45340 //
     /* 2450510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450542 */     // MIs[0] policy
     /* 2450542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450552 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2450555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450576 */     // GIR_Coverage, 45340,
     /* 2450576 */     GIR_EraseRootFromParent_Done,
     /* 2450577 */   // Label 35459: @2450577
     /* 2450577 */   GIM_Try, /*On fail goto*//*Label 35460*/ GIMT_Encode4(2450649), // Rule ID 45341 //
     /* 2450582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450614 */     // MIs[0] policy
     /* 2450614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450624 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2450627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450648 */     // GIR_Coverage, 45341,
     /* 2450648 */     GIR_EraseRootFromParent_Done,
     /* 2450649 */   // Label 35460: @2450649
     /* 2450649 */   GIM_Try, /*On fail goto*//*Label 35461*/ GIMT_Encode4(2450721), // Rule ID 45412 //
     /* 2450654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450686 */     // MIs[0] policy
     /* 2450686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450696 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2450699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450720 */     // GIR_Coverage, 45412,
     /* 2450720 */     GIR_EraseRootFromParent_Done,
     /* 2450721 */   // Label 35461: @2450721
     /* 2450721 */   GIM_Try, /*On fail goto*//*Label 35462*/ GIMT_Encode4(2450793), // Rule ID 45413 //
     /* 2450726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450758 */     // MIs[0] policy
     /* 2450758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450768 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2450771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450792 */     // GIR_Coverage, 45413,
     /* 2450792 */     GIR_EraseRootFromParent_Done,
     /* 2450793 */   // Label 35462: @2450793
     /* 2450793 */   GIM_Reject,
     /* 2450794 */ // Label 35454: @2450794
     /* 2450794 */ GIM_Reject,
     /* 2450795 */ // Label 35372: @2450795
     /* 2450795 */ GIM_Try, /*On fail goto*//*Label 35463*/ GIMT_Encode4(2451427),
     /* 2450800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2450803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2450806 */   GIM_Try, /*On fail goto*//*Label 35464*/ GIMT_Encode4(2450889), // Rule ID 45374 //
     /* 2450811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2450827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450847 */     // MIs[1] Operand 1
     /* 2450847 */     // No operand predicates
     /* 2450847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450851 */     // MIs[0] policy
     /* 2450851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450863 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2450866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450875 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2450885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450888 */     // GIR_Coverage, 45374,
     /* 2450888 */     GIR_EraseRootFromParent_Done,
     /* 2450889 */   // Label 35464: @2450889
     /* 2450889 */   GIM_Try, /*On fail goto*//*Label 35465*/ GIMT_Encode4(2450972), // Rule ID 45375 //
     /* 2450894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2450910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450930 */     // MIs[1] Operand 1
     /* 2450930 */     // No operand predicates
     /* 2450930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450934 */     // MIs[0] policy
     /* 2450934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450946 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2450949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450958 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2450968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450971 */     // GIR_Coverage, 45375,
     /* 2450971 */     GIR_EraseRootFromParent_Done,
     /* 2450972 */   // Label 35465: @2450972
     /* 2450972 */   GIM_Try, /*On fail goto*//*Label 35466*/ GIMT_Encode4(2451055), // Rule ID 45434 //
     /* 2450977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2450993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451013 */     // MIs[1] Operand 1
     /* 2451013 */     // No operand predicates
     /* 2451013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451017 */     // MIs[0] policy
     /* 2451017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451029 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2451032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451054 */     // GIR_Coverage, 45434,
     /* 2451054 */     GIR_EraseRootFromParent_Done,
     /* 2451055 */   // Label 35466: @2451055
     /* 2451055 */   GIM_Try, /*On fail goto*//*Label 35467*/ GIMT_Encode4(2451138), // Rule ID 45435 //
     /* 2451060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2451076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451096 */     // MIs[1] Operand 1
     /* 2451096 */     // No operand predicates
     /* 2451096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451100 */     // MIs[0] policy
     /* 2451100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451112 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2451115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451124 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451137 */     // GIR_Coverage, 45435,
     /* 2451137 */     GIR_EraseRootFromParent_Done,
     /* 2451138 */   // Label 35467: @2451138
     /* 2451138 */   GIM_Try, /*On fail goto*//*Label 35468*/ GIMT_Encode4(2451210), // Rule ID 45376 //
     /* 2451143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2451159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451175 */     // MIs[0] policy
     /* 2451175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451185 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2451188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451196 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451209 */     // GIR_Coverage, 45376,
     /* 2451209 */     GIR_EraseRootFromParent_Done,
     /* 2451210 */   // Label 35468: @2451210
     /* 2451210 */   GIM_Try, /*On fail goto*//*Label 35469*/ GIMT_Encode4(2451282), // Rule ID 45377 //
     /* 2451215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2451231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451247 */     // MIs[0] policy
     /* 2451247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451257 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2451260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451268 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451281 */     // GIR_Coverage, 45377,
     /* 2451281 */     GIR_EraseRootFromParent_Done,
     /* 2451282 */   // Label 35469: @2451282
     /* 2451282 */   GIM_Try, /*On fail goto*//*Label 35470*/ GIMT_Encode4(2451354), // Rule ID 45436 //
     /* 2451287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2451303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451319 */     // MIs[0] policy
     /* 2451319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451329 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2451332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451340 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451353 */     // GIR_Coverage, 45436,
     /* 2451353 */     GIR_EraseRootFromParent_Done,
     /* 2451354 */   // Label 35470: @2451354
     /* 2451354 */   GIM_Try, /*On fail goto*//*Label 35471*/ GIMT_Encode4(2451426), // Rule ID 45437 //
     /* 2451359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2451375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451391 */     // MIs[0] policy
     /* 2451391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451401 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2451404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451412 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451425 */     // GIR_Coverage, 45437,
     /* 2451425 */     GIR_EraseRootFromParent_Done,
     /* 2451426 */   // Label 35471: @2451426
     /* 2451426 */   GIM_Reject,
     /* 2451427 */ // Label 35463: @2451427
     /* 2451427 */ GIM_Reject,
     /* 2451428 */ // Label 35373: @2451428
     /* 2451428 */ GIM_Try, /*On fail goto*//*Label 35472*/ GIMT_Encode4(2452060),
     /* 2451433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2451436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2451439 */   GIM_Try, /*On fail goto*//*Label 35473*/ GIMT_Encode4(2451522), // Rule ID 45390 //
     /* 2451444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2451447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451480 */     // MIs[1] Operand 1
     /* 2451480 */     // No operand predicates
     /* 2451480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451484 */     // MIs[0] policy
     /* 2451484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451496 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2451499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451508 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451521 */     // GIR_Coverage, 45390,
     /* 2451521 */     GIR_EraseRootFromParent_Done,
     /* 2451522 */   // Label 35473: @2451522
     /* 2451522 */   GIM_Try, /*On fail goto*//*Label 35474*/ GIMT_Encode4(2451605), // Rule ID 45391 //
     /* 2451527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2451530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451563 */     // MIs[1] Operand 1
     /* 2451563 */     // No operand predicates
     /* 2451563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451567 */     // MIs[0] policy
     /* 2451567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451579 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2451582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451601 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451604 */     // GIR_Coverage, 45391,
     /* 2451604 */     GIR_EraseRootFromParent_Done,
     /* 2451605 */   // Label 35474: @2451605
     /* 2451605 */   GIM_Try, /*On fail goto*//*Label 35475*/ GIMT_Encode4(2451688), // Rule ID 45450 //
     /* 2451610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2451613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451646 */     // MIs[1] Operand 1
     /* 2451646 */     // No operand predicates
     /* 2451646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451650 */     // MIs[0] policy
     /* 2451650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451662 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2451665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451687 */     // GIR_Coverage, 45450,
     /* 2451687 */     GIR_EraseRootFromParent_Done,
     /* 2451688 */   // Label 35475: @2451688
     /* 2451688 */   GIM_Try, /*On fail goto*//*Label 35476*/ GIMT_Encode4(2451771), // Rule ID 45451 //
     /* 2451693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2451696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451729 */     // MIs[1] Operand 1
     /* 2451729 */     // No operand predicates
     /* 2451729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451733 */     // MIs[0] policy
     /* 2451733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451745 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2451748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451767 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451770 */     // GIR_Coverage, 45451,
     /* 2451770 */     GIR_EraseRootFromParent_Done,
     /* 2451771 */   // Label 35476: @2451771
     /* 2451771 */   GIM_Try, /*On fail goto*//*Label 35477*/ GIMT_Encode4(2451843), // Rule ID 45392 //
     /* 2451776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2451779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451808 */     // MIs[0] policy
     /* 2451808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451818 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2451821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451839 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451842 */     // GIR_Coverage, 45392,
     /* 2451842 */     GIR_EraseRootFromParent_Done,
     /* 2451843 */   // Label 35477: @2451843
     /* 2451843 */   GIM_Try, /*On fail goto*//*Label 35478*/ GIMT_Encode4(2451915), // Rule ID 45393 //
     /* 2451848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2451851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451880 */     // MIs[0] policy
     /* 2451880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451890 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2451893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451914 */     // GIR_Coverage, 45393,
     /* 2451914 */     GIR_EraseRootFromParent_Done,
     /* 2451915 */   // Label 35478: @2451915
     /* 2451915 */   GIM_Try, /*On fail goto*//*Label 35479*/ GIMT_Encode4(2451987), // Rule ID 45452 //
     /* 2451920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2451923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451952 */     // MIs[0] policy
     /* 2451952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451962 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2451965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451986 */     // GIR_Coverage, 45452,
     /* 2451986 */     GIR_EraseRootFromParent_Done,
     /* 2451987 */   // Label 35479: @2451987
     /* 2451987 */   GIM_Try, /*On fail goto*//*Label 35480*/ GIMT_Encode4(2452059), // Rule ID 45453 //
     /* 2451992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2451995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2452001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2452008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2452012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2452016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452024 */     // MIs[0] policy
     /* 2452024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452034 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2452037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2452055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452058 */     // GIR_Coverage, 45453,
     /* 2452058 */     GIR_EraseRootFromParent_Done,
     /* 2452059 */   // Label 35480: @2452059
     /* 2452059 */   GIM_Reject,
     /* 2452060 */ // Label 35472: @2452060
     /* 2452060 */ GIM_Reject,
     /* 2452061 */ // Label 35374: @2452061
     /* 2452061 */ GIM_Try, /*On fail goto*//*Label 35481*/ GIMT_Encode4(2452383),
     /* 2452066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2452069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2452072 */   GIM_Try, /*On fail goto*//*Label 35482*/ GIMT_Encode4(2452155), // Rule ID 45334 //
     /* 2452077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2452093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452113 */     // MIs[1] Operand 1
     /* 2452113 */     // No operand predicates
     /* 2452113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452117 */     // MIs[0] policy
     /* 2452117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452129 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2452132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2452151 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452154 */     // GIR_Coverage, 45334,
     /* 2452154 */     GIR_EraseRootFromParent_Done,
     /* 2452155 */   // Label 35482: @2452155
     /* 2452155 */   GIM_Try, /*On fail goto*//*Label 35483*/ GIMT_Encode4(2452238), // Rule ID 45335 //
     /* 2452160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2452176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452196 */     // MIs[1] Operand 1
     /* 2452196 */     // No operand predicates
     /* 2452196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452200 */     // MIs[0] policy
     /* 2452200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452212 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2452215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452224 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2452234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452237 */     // GIR_Coverage, 45335,
     /* 2452237 */     GIR_EraseRootFromParent_Done,
     /* 2452238 */   // Label 35483: @2452238
     /* 2452238 */   GIM_Try, /*On fail goto*//*Label 35484*/ GIMT_Encode4(2452310), // Rule ID 45336 //
     /* 2452243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2452259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452275 */     // MIs[0] policy
     /* 2452275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452285 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2452288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452296 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2452306 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452309 */     // GIR_Coverage, 45336,
     /* 2452309 */     GIR_EraseRootFromParent_Done,
     /* 2452310 */   // Label 35484: @2452310
     /* 2452310 */   GIM_Try, /*On fail goto*//*Label 35485*/ GIMT_Encode4(2452382), // Rule ID 45337 //
     /* 2452315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2452331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452347 */     // MIs[0] policy
     /* 2452347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452357 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2452360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452368 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2452378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452381 */     // GIR_Coverage, 45337,
     /* 2452381 */     GIR_EraseRootFromParent_Done,
     /* 2452382 */   // Label 35485: @2452382
     /* 2452382 */   GIM_Reject,
     /* 2452383 */ // Label 35481: @2452383
     /* 2452383 */ GIM_Reject,
     /* 2452384 */ // Label 35375: @2452384
     /* 2452384 */ GIM_Try, /*On fail goto*//*Label 35486*/ GIMT_Encode4(2453016),
     /* 2452389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2452392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2452395 */   GIM_Try, /*On fail goto*//*Label 35487*/ GIMT_Encode4(2452478), // Rule ID 45362 //
     /* 2452400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452436 */     // MIs[1] Operand 1
     /* 2452436 */     // No operand predicates
     /* 2452436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452440 */     // MIs[0] policy
     /* 2452440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452452 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2452455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452464 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452477 */     // GIR_Coverage, 45362,
     /* 2452477 */     GIR_EraseRootFromParent_Done,
     /* 2452478 */   // Label 35487: @2452478
     /* 2452478 */   GIM_Try, /*On fail goto*//*Label 35488*/ GIMT_Encode4(2452561), // Rule ID 45363 //
     /* 2452483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452519 */     // MIs[1] Operand 1
     /* 2452519 */     // No operand predicates
     /* 2452519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452523 */     // MIs[0] policy
     /* 2452523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452535 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2452538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452560 */     // GIR_Coverage, 45363,
     /* 2452560 */     GIR_EraseRootFromParent_Done,
     /* 2452561 */   // Label 35488: @2452561
     /* 2452561 */   GIM_Try, /*On fail goto*//*Label 35489*/ GIMT_Encode4(2452644), // Rule ID 45422 //
     /* 2452566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452602 */     // MIs[1] Operand 1
     /* 2452602 */     // No operand predicates
     /* 2452602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452606 */     // MIs[0] policy
     /* 2452606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452618 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2452621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452630 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452643 */     // GIR_Coverage, 45422,
     /* 2452643 */     GIR_EraseRootFromParent_Done,
     /* 2452644 */   // Label 35489: @2452644
     /* 2452644 */   GIM_Try, /*On fail goto*//*Label 35490*/ GIMT_Encode4(2452727), // Rule ID 45423 //
     /* 2452649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452685 */     // MIs[1] Operand 1
     /* 2452685 */     // No operand predicates
     /* 2452685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452689 */     // MIs[0] policy
     /* 2452689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452701 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2452704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452726 */     // GIR_Coverage, 45423,
     /* 2452726 */     GIR_EraseRootFromParent_Done,
     /* 2452727 */   // Label 35490: @2452727
     /* 2452727 */   GIM_Try, /*On fail goto*//*Label 35491*/ GIMT_Encode4(2452799), // Rule ID 45364 //
     /* 2452732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452764 */     // MIs[0] policy
     /* 2452764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452774 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2452777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452798 */     // GIR_Coverage, 45364,
     /* 2452798 */     GIR_EraseRootFromParent_Done,
     /* 2452799 */   // Label 35491: @2452799
     /* 2452799 */   GIM_Try, /*On fail goto*//*Label 35492*/ GIMT_Encode4(2452871), // Rule ID 45365 //
     /* 2452804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452836 */     // MIs[0] policy
     /* 2452836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452846 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2452849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452870 */     // GIR_Coverage, 45365,
     /* 2452870 */     GIR_EraseRootFromParent_Done,
     /* 2452871 */   // Label 35492: @2452871
     /* 2452871 */   GIM_Try, /*On fail goto*//*Label 35493*/ GIMT_Encode4(2452943), // Rule ID 45424 //
     /* 2452876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452908 */     // MIs[0] policy
     /* 2452908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452918 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2452921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452942 */     // GIR_Coverage, 45424,
     /* 2452942 */     GIR_EraseRootFromParent_Done,
     /* 2452943 */   // Label 35493: @2452943
     /* 2452943 */   GIM_Try, /*On fail goto*//*Label 35494*/ GIMT_Encode4(2453015), // Rule ID 45425 //
     /* 2452948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452980 */     // MIs[0] policy
     /* 2452980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452990 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2452993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2453001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2453011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453014 */     // GIR_Coverage, 45425,
     /* 2453014 */     GIR_EraseRootFromParent_Done,
     /* 2453015 */   // Label 35494: @2453015
     /* 2453015 */   GIM_Reject,
     /* 2453016 */ // Label 35486: @2453016
     /* 2453016 */ GIM_Reject,
     /* 2453017 */ // Label 35376: @2453017
     /* 2453017 */ GIM_Try, /*On fail goto*//*Label 35495*/ GIMT_Encode4(2453649),
     /* 2453022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2453025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2453028 */   GIM_Try, /*On fail goto*//*Label 35496*/ GIMT_Encode4(2453111), // Rule ID 45378 //
     /* 2453033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2453036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453069 */     // MIs[1] Operand 1
     /* 2453069 */     // No operand predicates
     /* 2453069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453073 */     // MIs[0] policy
     /* 2453073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453085 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2453088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453110 */     // GIR_Coverage, 45378,
     /* 2453110 */     GIR_EraseRootFromParent_Done,
     /* 2453111 */   // Label 35496: @2453111
     /* 2453111 */   GIM_Try, /*On fail goto*//*Label 35497*/ GIMT_Encode4(2453194), // Rule ID 45379 //
     /* 2453116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2453119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453152 */     // MIs[1] Operand 1
     /* 2453152 */     // No operand predicates
     /* 2453152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453156 */     // MIs[0] policy
     /* 2453156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453168 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2453171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453180 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453193 */     // GIR_Coverage, 45379,
     /* 2453193 */     GIR_EraseRootFromParent_Done,
     /* 2453194 */   // Label 35497: @2453194
     /* 2453194 */   GIM_Try, /*On fail goto*//*Label 35498*/ GIMT_Encode4(2453277), // Rule ID 45438 //
     /* 2453199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2453202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453235 */     // MIs[1] Operand 1
     /* 2453235 */     // No operand predicates
     /* 2453235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453239 */     // MIs[0] policy
     /* 2453239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453251 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2453254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453276 */     // GIR_Coverage, 45438,
     /* 2453276 */     GIR_EraseRootFromParent_Done,
     /* 2453277 */   // Label 35498: @2453277
     /* 2453277 */   GIM_Try, /*On fail goto*//*Label 35499*/ GIMT_Encode4(2453360), // Rule ID 45439 //
     /* 2453282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2453285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453318 */     // MIs[1] Operand 1
     /* 2453318 */     // No operand predicates
     /* 2453318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453322 */     // MIs[0] policy
     /* 2453322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453334 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2453337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453346 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453359 */     // GIR_Coverage, 45439,
     /* 2453359 */     GIR_EraseRootFromParent_Done,
     /* 2453360 */   // Label 35499: @2453360
     /* 2453360 */   GIM_Try, /*On fail goto*//*Label 35500*/ GIMT_Encode4(2453432), // Rule ID 45380 //
     /* 2453365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2453368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2453393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453397 */     // MIs[0] policy
     /* 2453397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453407 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2453410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2453418 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453431 */     // GIR_Coverage, 45380,
     /* 2453431 */     GIR_EraseRootFromParent_Done,
     /* 2453432 */   // Label 35500: @2453432
     /* 2453432 */   GIM_Try, /*On fail goto*//*Label 35501*/ GIMT_Encode4(2453504), // Rule ID 45381 //
     /* 2453437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2453440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2453465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453469 */     // MIs[0] policy
     /* 2453469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453479 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2453482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2453490 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453503 */     // GIR_Coverage, 45381,
     /* 2453503 */     GIR_EraseRootFromParent_Done,
     /* 2453504 */   // Label 35501: @2453504
     /* 2453504 */   GIM_Try, /*On fail goto*//*Label 35502*/ GIMT_Encode4(2453576), // Rule ID 45440 //
     /* 2453509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2453512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2453537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453541 */     // MIs[0] policy
     /* 2453541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453551 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2453554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2453562 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453575 */     // GIR_Coverage, 45440,
     /* 2453575 */     GIR_EraseRootFromParent_Done,
     /* 2453576 */   // Label 35502: @2453576
     /* 2453576 */   GIM_Try, /*On fail goto*//*Label 35503*/ GIMT_Encode4(2453648), // Rule ID 45441 //
     /* 2453581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2453584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2453609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453613 */     // MIs[0] policy
     /* 2453613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453623 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2453626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2453634 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453647 */     // GIR_Coverage, 45441,
     /* 2453647 */     GIR_EraseRootFromParent_Done,
     /* 2453648 */   // Label 35503: @2453648
     /* 2453648 */   GIM_Reject,
     /* 2453649 */ // Label 35495: @2453649
     /* 2453649 */ GIM_Reject,
     /* 2453650 */ // Label 35377: @2453650
     /* 2453650 */ GIM_Try, /*On fail goto*//*Label 35504*/ GIMT_Encode4(2454282),
     /* 2453655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2453658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2453661 */   GIM_Try, /*On fail goto*//*Label 35505*/ GIMT_Encode4(2453744), // Rule ID 45394 //
     /* 2453666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2453669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2453682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453702 */     // MIs[1] Operand 1
     /* 2453702 */     // No operand predicates
     /* 2453702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453706 */     // MIs[0] policy
     /* 2453706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453718 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2453721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453730 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2453740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453743 */     // GIR_Coverage, 45394,
     /* 2453743 */     GIR_EraseRootFromParent_Done,
     /* 2453744 */   // Label 35505: @2453744
     /* 2453744 */   GIM_Try, /*On fail goto*//*Label 35506*/ GIMT_Encode4(2453827), // Rule ID 45395 //
     /* 2453749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2453752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2453765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453785 */     // MIs[1] Operand 1
     /* 2453785 */     // No operand predicates
     /* 2453785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453789 */     // MIs[0] policy
     /* 2453789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453801 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2453804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2453823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453826 */     // GIR_Coverage, 45395,
     /* 2453826 */     GIR_EraseRootFromParent_Done,
     /* 2453827 */   // Label 35506: @2453827
     /* 2453827 */   GIM_Try, /*On fail goto*//*Label 35507*/ GIMT_Encode4(2453910), // Rule ID 45454 //
     /* 2453832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2453835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2453848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453868 */     // MIs[1] Operand 1
     /* 2453868 */     // No operand predicates
     /* 2453868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453872 */     // MIs[0] policy
     /* 2453872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453884 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2453887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2453906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453909 */     // GIR_Coverage, 45454,
     /* 2453909 */     GIR_EraseRootFromParent_Done,
     /* 2453910 */   // Label 35507: @2453910
     /* 2453910 */   GIM_Try, /*On fail goto*//*Label 35508*/ GIMT_Encode4(2453993), // Rule ID 45455 //
     /* 2453915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2453918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2453931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453951 */     // MIs[1] Operand 1
     /* 2453951 */     // No operand predicates
     /* 2453951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453955 */     // MIs[0] policy
     /* 2453955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453967 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2453970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2453989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453992 */     // GIR_Coverage, 45455,
     /* 2453992 */     GIR_EraseRootFromParent_Done,
     /* 2453993 */   // Label 35508: @2453993
     /* 2453993 */   GIM_Try, /*On fail goto*//*Label 35509*/ GIMT_Encode4(2454065), // Rule ID 45396 //
     /* 2453998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2454001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2454007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2454014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454030 */     // MIs[0] policy
     /* 2454030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454040 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2454043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2454061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454064 */     // GIR_Coverage, 45396,
     /* 2454064 */     GIR_EraseRootFromParent_Done,
     /* 2454065 */   // Label 35509: @2454065
     /* 2454065 */   GIM_Try, /*On fail goto*//*Label 35510*/ GIMT_Encode4(2454137), // Rule ID 45397 //
     /* 2454070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2454073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2454076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2454079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2454082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2454086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454102 */     // MIs[0] policy
     /* 2454102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454112 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2454112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2454115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2454133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454136 */     // GIR_Coverage, 45397,
     /* 2454136 */     GIR_EraseRootFromParent_Done,
     /* 2454137 */   // Label 35510: @2454137
     /* 2454137 */   GIM_Try, /*On fail goto*//*Label 35511*/ GIMT_Encode4(2454209), // Rule ID 45456 //
     /* 2454142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2454145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2454151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2454158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454174 */     // MIs[0] policy
     /* 2454174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454184 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2454187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454195 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2454205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454208 */     // GIR_Coverage, 45456,
     /* 2454208 */     GIR_EraseRootFromParent_Done,
     /* 2454209 */   // Label 35511: @2454209
     /* 2454209 */   GIM_Try, /*On fail goto*//*Label 35512*/ GIMT_Encode4(2454281), // Rule ID 45457 //
     /* 2454214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2454217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2454220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2454223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2454226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2454230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454246 */     // MIs[0] policy
     /* 2454246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454256 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2454256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2454259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2454277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454280 */     // GIR_Coverage, 45457,
     /* 2454280 */     GIR_EraseRootFromParent_Done,
     /* 2454281 */   // Label 35512: @2454281
     /* 2454281 */   GIM_Reject,
     /* 2454282 */ // Label 35504: @2454282
     /* 2454282 */ GIM_Reject,
     /* 2454283 */ // Label 35378: @2454283
     /* 2454283 */ GIM_Try, /*On fail goto*//*Label 35513*/ GIMT_Encode4(2454605),
     /* 2454288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2454291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2454294 */   GIM_Try, /*On fail goto*//*Label 35514*/ GIMT_Encode4(2454377), // Rule ID 45350 //
     /* 2454299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2454302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2454315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2454327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2454331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2454335 */     // MIs[1] Operand 1
     /* 2454335 */     // No operand predicates
     /* 2454335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454339 */     // MIs[0] policy
     /* 2454339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2454344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454351 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2454354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2454363 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2454373 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454376 */     // GIR_Coverage, 45350,
     /* 2454376 */     GIR_EraseRootFromParent_Done,
     /* 2454377 */   // Label 35514: @2454377
     /* 2454377 */   GIM_Try, /*On fail goto*//*Label 35515*/ GIMT_Encode4(2454460), // Rule ID 45351 //
     /* 2454382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2454385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2454388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2454394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2454398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2454410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2454414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2454418 */     // MIs[1] Operand 1
     /* 2454418 */     // No operand predicates
     /* 2454418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454422 */     // MIs[0] policy
     /* 2454422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2454427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454434 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2454434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2454437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2454446 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2454456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454459 */     // GIR_Coverage, 45351,
     /* 2454459 */     GIR_EraseRootFromParent_Done,
     /* 2454460 */   // Label 35515: @2454460
     /* 2454460 */   GIM_Try, /*On fail goto*//*Label 35516*/ GIMT_Encode4(2454532), // Rule ID 45352 //
     /* 2454465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2454468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2454481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454497 */     // MIs[0] policy
     /* 2454497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454507 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2454510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454518 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2454528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454531 */     // GIR_Coverage, 45352,
     /* 2454531 */     GIR_EraseRootFromParent_Done,
     /* 2454532 */   // Label 35516: @2454532
     /* 2454532 */   GIM_Try, /*On fail goto*//*Label 35517*/ GIMT_Encode4(2454604), // Rule ID 45353 //
     /* 2454537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2454540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2454543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2454549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2454553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454569 */     // MIs[0] policy
     /* 2454569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454579 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2454579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2454582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454590 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2454600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454603 */     // GIR_Coverage, 45353,
     /* 2454603 */     GIR_EraseRootFromParent_Done,
     /* 2454604 */   // Label 35517: @2454604
     /* 2454604 */   GIM_Reject,
     /* 2454605 */ // Label 35513: @2454605
     /* 2454605 */ GIM_Reject,
     /* 2454606 */ // Label 35379: @2454606
     /* 2454606 */ GIM_Try, /*On fail goto*//*Label 35518*/ GIMT_Encode4(2455238),
     /* 2454611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2454614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2454617 */   GIM_Try, /*On fail goto*//*Label 35519*/ GIMT_Encode4(2454700), // Rule ID 45366 //
     /* 2454622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2454625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2454638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2454650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2454654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2454658 */     // MIs[1] Operand 1
     /* 2454658 */     // No operand predicates
     /* 2454658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454662 */     // MIs[0] policy
     /* 2454662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2454667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454674 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2454677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2454686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2454696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454699 */     // GIR_Coverage, 45366,
     /* 2454699 */     GIR_EraseRootFromParent_Done,
     /* 2454700 */   // Label 35519: @2454700
     /* 2454700 */   GIM_Try, /*On fail goto*//*Label 35520*/ GIMT_Encode4(2454783), // Rule ID 45367 //
     /* 2454705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2454708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2454711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2454717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2454721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2454733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2454737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2454741 */     // MIs[1] Operand 1
     /* 2454741 */     // No operand predicates
     /* 2454741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454745 */     // MIs[0] policy
     /* 2454745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2454750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454757 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2454757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2454760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2454769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2454779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454782 */     // GIR_Coverage, 45367,
     /* 2454782 */     GIR_EraseRootFromParent_Done,
     /* 2454783 */   // Label 35520: @2454783
     /* 2454783 */   GIM_Try, /*On fail goto*//*Label 35521*/ GIMT_Encode4(2454866), // Rule ID 45426 //
     /* 2454788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2454791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2454804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2454816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2454820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2454824 */     // MIs[1] Operand 1
     /* 2454824 */     // No operand predicates
     /* 2454824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454828 */     // MIs[0] policy
     /* 2454828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2454833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454840 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2454843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2454852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2454862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454865 */     // GIR_Coverage, 45426,
     /* 2454865 */     GIR_EraseRootFromParent_Done,
     /* 2454866 */   // Label 35521: @2454866
     /* 2454866 */   GIM_Try, /*On fail goto*//*Label 35522*/ GIMT_Encode4(2454949), // Rule ID 45427 //
     /* 2454871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2454874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2454877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2454883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2454887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2454899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2454903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2454907 */     // MIs[1] Operand 1
     /* 2454907 */     // No operand predicates
     /* 2454907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454911 */     // MIs[0] policy
     /* 2454911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2454916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454923 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2454923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2454926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2454935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2454945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454948 */     // GIR_Coverage, 45427,
     /* 2454948 */     GIR_EraseRootFromParent_Done,
     /* 2454949 */   // Label 35522: @2454949
     /* 2454949 */   GIM_Try, /*On fail goto*//*Label 35523*/ GIMT_Encode4(2455021), // Rule ID 45368 //
     /* 2454954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2454957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2454970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454986 */     // MIs[0] policy
     /* 2454986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454996 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2454999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2455017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455020 */     // GIR_Coverage, 45368,
     /* 2455020 */     GIR_EraseRootFromParent_Done,
     /* 2455021 */   // Label 35523: @2455021
     /* 2455021 */   GIM_Try, /*On fail goto*//*Label 35524*/ GIMT_Encode4(2455093), // Rule ID 45369 //
     /* 2455026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2455042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455058 */     // MIs[0] policy
     /* 2455058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455068 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2455068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2455071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2455089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455092 */     // GIR_Coverage, 45369,
     /* 2455092 */     GIR_EraseRootFromParent_Done,
     /* 2455093 */   // Label 35524: @2455093
     /* 2455093 */   GIM_Try, /*On fail goto*//*Label 35525*/ GIMT_Encode4(2455165), // Rule ID 45428 //
     /* 2455098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2455101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2455104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2455110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2455114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455130 */     // MIs[0] policy
     /* 2455130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455140 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2455140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2455143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2455161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455164 */     // GIR_Coverage, 45428,
     /* 2455164 */     GIR_EraseRootFromParent_Done,
     /* 2455165 */   // Label 35525: @2455165
     /* 2455165 */   GIM_Try, /*On fail goto*//*Label 35526*/ GIMT_Encode4(2455237), // Rule ID 45429 //
     /* 2455170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2455186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455202 */     // MIs[0] policy
     /* 2455202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455212 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2455212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2455215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2455233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455236 */     // GIR_Coverage, 45429,
     /* 2455236 */     GIR_EraseRootFromParent_Done,
     /* 2455237 */   // Label 35526: @2455237
     /* 2455237 */   GIM_Reject,
     /* 2455238 */ // Label 35518: @2455238
     /* 2455238 */ GIM_Reject,
     /* 2455239 */ // Label 35380: @2455239
     /* 2455239 */ GIM_Try, /*On fail goto*//*Label 35527*/ GIMT_Encode4(2455871),
     /* 2455244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2455247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2455250 */   GIM_Try, /*On fail goto*//*Label 35528*/ GIMT_Encode4(2455333), // Rule ID 45382 //
     /* 2455255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2455258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2455261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2455267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2455283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2455287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2455291 */     // MIs[1] Operand 1
     /* 2455291 */     // No operand predicates
     /* 2455291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455295 */     // MIs[0] policy
     /* 2455295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2455300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455307 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2455307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2455310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2455319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455332 */     // GIR_Coverage, 45382,
     /* 2455332 */     GIR_EraseRootFromParent_Done,
     /* 2455333 */   // Label 35528: @2455333
     /* 2455333 */   GIM_Try, /*On fail goto*//*Label 35529*/ GIMT_Encode4(2455416), // Rule ID 45383 //
     /* 2455338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2455366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2455370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2455374 */     // MIs[1] Operand 1
     /* 2455374 */     // No operand predicates
     /* 2455374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455378 */     // MIs[0] policy
     /* 2455378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2455383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455390 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2455390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2455393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2455402 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455415 */     // GIR_Coverage, 45383,
     /* 2455415 */     GIR_EraseRootFromParent_Done,
     /* 2455416 */   // Label 35529: @2455416
     /* 2455416 */   GIM_Try, /*On fail goto*//*Label 35530*/ GIMT_Encode4(2455499), // Rule ID 45442 //
     /* 2455421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2455424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2455427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2455433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2455449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2455453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2455457 */     // MIs[1] Operand 1
     /* 2455457 */     // No operand predicates
     /* 2455457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455461 */     // MIs[0] policy
     /* 2455461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2455466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455473 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2455473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2455476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2455485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455498 */     // GIR_Coverage, 45442,
     /* 2455498 */     GIR_EraseRootFromParent_Done,
     /* 2455499 */   // Label 35530: @2455499
     /* 2455499 */   GIM_Try, /*On fail goto*//*Label 35531*/ GIMT_Encode4(2455582), // Rule ID 45443 //
     /* 2455504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2455532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2455536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2455540 */     // MIs[1] Operand 1
     /* 2455540 */     // No operand predicates
     /* 2455540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455544 */     // MIs[0] policy
     /* 2455544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2455549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455556 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2455556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2455559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2455568 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455581 */     // GIR_Coverage, 45443,
     /* 2455581 */     GIR_EraseRootFromParent_Done,
     /* 2455582 */   // Label 35531: @2455582
     /* 2455582 */   GIM_Try, /*On fail goto*//*Label 35532*/ GIMT_Encode4(2455654), // Rule ID 45384 //
     /* 2455587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2455590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2455593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2455599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455619 */     // MIs[0] policy
     /* 2455619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455629 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2455629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2455632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455640 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455653 */     // GIR_Coverage, 45384,
     /* 2455653 */     GIR_EraseRootFromParent_Done,
     /* 2455654 */   // Label 35532: @2455654
     /* 2455654 */   GIM_Try, /*On fail goto*//*Label 35533*/ GIMT_Encode4(2455726), // Rule ID 45385 //
     /* 2455659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455691 */     // MIs[0] policy
     /* 2455691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455701 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2455701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2455704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455712 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455725 */     // GIR_Coverage, 45385,
     /* 2455725 */     GIR_EraseRootFromParent_Done,
     /* 2455726 */   // Label 35533: @2455726
     /* 2455726 */   GIM_Try, /*On fail goto*//*Label 35534*/ GIMT_Encode4(2455798), // Rule ID 45444 //
     /* 2455731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2455734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2455737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2455743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455763 */     // MIs[0] policy
     /* 2455763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455773 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2455773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2455776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455784 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455797 */     // GIR_Coverage, 45444,
     /* 2455797 */     GIR_EraseRootFromParent_Done,
     /* 2455798 */   // Label 35534: @2455798
     /* 2455798 */   GIM_Try, /*On fail goto*//*Label 35535*/ GIMT_Encode4(2455870), // Rule ID 45445 //
     /* 2455803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455835 */     // MIs[0] policy
     /* 2455835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455845 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2455845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2455848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455856 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455869 */     // GIR_Coverage, 45445,
     /* 2455869 */     GIR_EraseRootFromParent_Done,
     /* 2455870 */   // Label 35535: @2455870
     /* 2455870 */   GIM_Reject,
     /* 2455871 */ // Label 35527: @2455871
     /* 2455871 */ GIM_Reject,
     /* 2455872 */ // Label 35381: @2455872
     /* 2455872 */ GIM_Try, /*On fail goto*//*Label 35536*/ GIMT_Encode4(2456194),
     /* 2455877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2455880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2455883 */   GIM_Try, /*On fail goto*//*Label 35537*/ GIMT_Encode4(2455966), // Rule ID 45354 //
     /* 2455888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2455891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2455894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2455897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2455900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2455904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2455916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2455920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2455924 */     // MIs[1] Operand 1
     /* 2455924 */     // No operand predicates
     /* 2455924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455928 */     // MIs[0] policy
     /* 2455928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2455933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455940 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2455940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2455943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2455952 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2455962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455965 */     // GIR_Coverage, 45354,
     /* 2455965 */     GIR_EraseRootFromParent_Done,
     /* 2455966 */   // Label 35537: @2455966
     /* 2455966 */   GIM_Try, /*On fail goto*//*Label 35538*/ GIMT_Encode4(2456049), // Rule ID 45355 //
     /* 2455971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2455980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2455987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2455999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456007 */     // MIs[1] Operand 1
     /* 2456007 */     // No operand predicates
     /* 2456007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456011 */     // MIs[0] policy
     /* 2456011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456023 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2456026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456035 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2456045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456048 */     // GIR_Coverage, 45355,
     /* 2456048 */     GIR_EraseRootFromParent_Done,
     /* 2456049 */   // Label 35538: @2456049
     /* 2456049 */   GIM_Try, /*On fail goto*//*Label 35539*/ GIMT_Encode4(2456121), // Rule ID 45356 //
     /* 2456054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2456057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2456060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2456066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2456070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2456074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2456078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2456082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456086 */     // MIs[0] policy
     /* 2456086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456096 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2456096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2456099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2456107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2456117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456120 */     // GIR_Coverage, 45356,
     /* 2456120 */     GIR_EraseRootFromParent_Done,
     /* 2456121 */   // Label 35539: @2456121
     /* 2456121 */   GIM_Try, /*On fail goto*//*Label 35540*/ GIMT_Encode4(2456193), // Rule ID 45357 //
     /* 2456126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2456129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2456132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2456138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2456142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2456146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2456150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2456154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456158 */     // MIs[0] policy
     /* 2456158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456168 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2456171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2456179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2456189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456192 */     // GIR_Coverage, 45357,
     /* 2456192 */     GIR_EraseRootFromParent_Done,
     /* 2456193 */   // Label 35540: @2456193
     /* 2456193 */   GIM_Reject,
     /* 2456194 */ // Label 35536: @2456194
     /* 2456194 */ GIM_Reject,
     /* 2456195 */ // Label 35382: @2456195
     /* 2456195 */ GIM_Try, /*On fail goto*//*Label 35541*/ GIMT_Encode4(2456827),
     /* 2456200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2456203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2456206 */   GIM_Try, /*On fail goto*//*Label 35542*/ GIMT_Encode4(2456289), // Rule ID 45370 //
     /* 2456211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2456214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2456217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2456223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2456239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456247 */     // MIs[1] Operand 1
     /* 2456247 */     // No operand predicates
     /* 2456247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456251 */     // MIs[0] policy
     /* 2456251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456263 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2456263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2456266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456288 */     // GIR_Coverage, 45370,
     /* 2456288 */     GIR_EraseRootFromParent_Done,
     /* 2456289 */   // Label 35542: @2456289
     /* 2456289 */   GIM_Try, /*On fail goto*//*Label 35543*/ GIMT_Encode4(2456372), // Rule ID 45371 //
     /* 2456294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2456297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2456300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2456306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2456322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456330 */     // MIs[1] Operand 1
     /* 2456330 */     // No operand predicates
     /* 2456330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456334 */     // MIs[0] policy
     /* 2456334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456346 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2456349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456358 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456371 */     // GIR_Coverage, 45371,
     /* 2456371 */     GIR_EraseRootFromParent_Done,
     /* 2456372 */   // Label 35543: @2456372
     /* 2456372 */   GIM_Try, /*On fail goto*//*Label 35544*/ GIMT_Encode4(2456455), // Rule ID 45430 //
     /* 2456377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2456380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2456383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2456389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2456405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456413 */     // MIs[1] Operand 1
     /* 2456413 */     // No operand predicates
     /* 2456413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456417 */     // MIs[0] policy
     /* 2456417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456429 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2456429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2456432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456454 */     // GIR_Coverage, 45430,
     /* 2456454 */     GIR_EraseRootFromParent_Done,
     /* 2456455 */   // Label 35544: @2456455
     /* 2456455 */   GIM_Try, /*On fail goto*//*Label 35545*/ GIMT_Encode4(2456538), // Rule ID 45431 //
     /* 2456460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2456463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2456466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2456472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2456488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456496 */     // MIs[1] Operand 1
     /* 2456496 */     // No operand predicates
     /* 2456496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456500 */     // MIs[0] policy
     /* 2456500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456512 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2456515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456537 */     // GIR_Coverage, 45431,
     /* 2456537 */     GIR_EraseRootFromParent_Done,
     /* 2456538 */   // Label 35545: @2456538
     /* 2456538 */   GIM_Try, /*On fail goto*//*Label 35546*/ GIMT_Encode4(2456610), // Rule ID 45372 //
     /* 2456543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2456546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2456549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2456555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2456571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456575 */     // MIs[0] policy
     /* 2456575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456585 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2456585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2456588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2456596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456609 */     // GIR_Coverage, 45372,
     /* 2456609 */     GIR_EraseRootFromParent_Done,
     /* 2456610 */   // Label 35546: @2456610
     /* 2456610 */   GIM_Try, /*On fail goto*//*Label 35547*/ GIMT_Encode4(2456682), // Rule ID 45373 //
     /* 2456615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2456618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2456621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2456627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2456643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456647 */     // MIs[0] policy
     /* 2456647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456657 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2456660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2456668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456681 */     // GIR_Coverage, 45373,
     /* 2456681 */     GIR_EraseRootFromParent_Done,
     /* 2456682 */   // Label 35547: @2456682
     /* 2456682 */   GIM_Try, /*On fail goto*//*Label 35548*/ GIMT_Encode4(2456754), // Rule ID 45432 //
     /* 2456687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2456690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2456693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2456699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2456715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456719 */     // MIs[0] policy
     /* 2456719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456729 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2456729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2456732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2456740 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456753 */     // GIR_Coverage, 45432,
     /* 2456753 */     GIR_EraseRootFromParent_Done,
     /* 2456754 */   // Label 35548: @2456754
     /* 2456754 */   GIM_Try, /*On fail goto*//*Label 35549*/ GIMT_Encode4(2456826), // Rule ID 45433 //
     /* 2456759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2456762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2456765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2456771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2456787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456791 */     // MIs[0] policy
     /* 2456791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456801 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2456804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2456812 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456825 */     // GIR_Coverage, 45433,
     /* 2456825 */     GIR_EraseRootFromParent_Done,
     /* 2456826 */   // Label 35549: @2456826
     /* 2456826 */   GIM_Reject,
     /* 2456827 */ // Label 35541: @2456827
     /* 2456827 */ GIM_Reject,
     /* 2456828 */ // Label 35383: @2456828
     /* 2456828 */ GIM_Try, /*On fail goto*//*Label 35550*/ GIMT_Encode4(2457150),
     /* 2456833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2456836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2456839 */   GIM_Try, /*On fail goto*//*Label 35551*/ GIMT_Encode4(2456922), // Rule ID 45358 //
     /* 2456844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2456847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2456850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2456853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2456856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2456872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456880 */     // MIs[1] Operand 1
     /* 2456880 */     // No operand predicates
     /* 2456880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456884 */     // MIs[0] policy
     /* 2456884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456896 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2456896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2456899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2456918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456921 */     // GIR_Coverage, 45358,
     /* 2456921 */     GIR_EraseRootFromParent_Done,
     /* 2456922 */   // Label 35551: @2456922
     /* 2456922 */   GIM_Try, /*On fail goto*//*Label 35552*/ GIMT_Encode4(2457005), // Rule ID 45359 //
     /* 2456927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2456930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2456933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2456936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2456939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2456955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456963 */     // MIs[1] Operand 1
     /* 2456963 */     // No operand predicates
     /* 2456963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456967 */     // MIs[0] policy
     /* 2456967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456979 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2456982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2457001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2457003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2457004 */     // GIR_Coverage, 45359,
     /* 2457004 */     GIR_EraseRootFromParent_Done,
     /* 2457005 */   // Label 35552: @2457005
     /* 2457005 */   GIM_Try, /*On fail goto*//*Label 35553*/ GIMT_Encode4(2457077), // Rule ID 45360 //
     /* 2457010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2457013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2457016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2457019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2457022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2457026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2457030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2457034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2457038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2457042 */     // MIs[0] policy
     /* 2457042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2457045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2457052 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2457052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2457055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2457057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2457059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2457061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2457063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2457065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2457070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2457073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2457075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2457076 */     // GIR_Coverage, 45360,
     /* 2457076 */     GIR_EraseRootFromParent_Done,
     /* 2457077 */   // Label 35553: @2457077
     /* 2457077 */   GIM_Try, /*On fail goto*//*Label 35554*/ GIMT_Encode4(2457149), // Rule ID 45361 //
     /* 2457082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2457085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2457088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2457091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2457094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2457098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2457102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2457106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2457110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2457114 */     // MIs[0] policy
     /* 2457114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2457117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2457124 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2457124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2457127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2457129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2457131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2457133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2457135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2457137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2457142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2457145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2457147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2457148 */     // GIR_Coverage, 45361,
     /* 2457148 */     GIR_EraseRootFromParent_Done,
     /* 2457149 */   // Label 35554: @2457149
     /* 2457149 */   GIM_Reject,
     /* 2457150 */ // Label 35550: @2457150
     /* 2457150 */ GIM_Reject,
     /* 2457151 */ // Label 35384: @2457151
     /* 2457151 */ GIM_Reject,
     /* 2457152 */ // Label 125: @2457152
     /* 2457152 */ GIM_Reject,
     /* 2457153 */ }; // Size: 2457153 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
